# !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
# This file is machine-generated by lib/unicore/mktables from the Unicode
# database, Version 13.0.0.  Any changes made here will be lost!

sub TODO_FAILING_BREAKS { 0 }

use strict;
use warnings;

use feature 'signatures';

no warnings 'experimental::signatures';
no warnings 'experimental::uniprop_wildcards';

# Test qr/\X/ and the \p{} regular expression constructs.  This file is
# constructed by mktables from the tables it generates, so if mktables is
# buggy, this won't necessarily catch those bugs.  Tests are generated for all
# feasible properties; a few aren't currently feasible; see
# is_code_point_usable() in mktables for details.

# Standard test packages are not used because this manipulates SIG_WARN.  It
# exits 0 if every non-skipped test succeeded; -1 if any failed.

my $Tests = 0;
my $Fails = 0;

# loc_tools.pl requires this function to be defined
sub ok($pass, @msg) {
    print "not " unless $pass;
    print "ok ";
    print ++$Tests;
    print " - ", join "", @msg if @msg;
    print "\n";
}

sub Expect($expected, $ord, $regex, $warning_type='') {
    my $line   = (caller)[2];

    # Convert the code point to hex form
    my $string = sprintf "\"\\x{%04X}\"", $ord;

    my @tests = "";

    # The first time through, use all warnings.  If the input should generate
    # a warning, add another time through with them turned off
    push @tests, "no warnings '$warning_type';" if $warning_type;

    foreach my $no_warnings (@tests) {

        # Store any warning messages instead of outputting them
        local $SIG{__WARN__} = $SIG{__WARN__};
        my $warning_message;
        $SIG{__WARN__} = sub { $warning_message = $_[0] };

        $Tests++;

        # A string eval is needed because of the 'no warnings'.
        # Assumes no parentheses in the regular expression
        my $result = eval "$no_warnings
                            my \$RegObj = qr($regex);
                            $string =~ \$RegObj ? 1 : 0";
        if (not defined $result) {
            print "not ok $Tests - couldn't compile /$regex/; line $line: $@\n";
            $Fails++;
        }
        elsif ($result ^ $expected) {
            print "not ok $Tests - expected $expected but got $result for $string =~ qr/$regex/; line $line\n";
            $Fails++;
        }
        elsif ($warning_message) {
            if (! $warning_type || ($warning_type && $no_warnings)) {
                print "not ok $Tests - for qr/$regex/ did not expect warning message '$warning_message'; line $line\n";
                $Fails++;
            }
            else {
                print "ok $Tests - expected and got a warning message for qr/$regex/; line $line\n";
            }
        }
        elsif ($warning_type && ! $no_warnings) {
            print "not ok $Tests - for qr/$regex/ expected a $warning_type warning message, but got none; line $line\n";
            $Fails++;
        }
        else {
            print "ok $Tests - got $result for $string =~ qr/$regex/; line $line\n";
        }
    }
    return;
}

sub Error($regex) {
    $Tests++;
    if (eval { 'x' =~ qr/$regex/; 1 }) {
        $Fails++;
        my $line = (caller)[2];
        print "not ok $Tests - re compiled ok, but expected error for qr/$regex/; line $line: $@\n";
    }
    else {
        my $line = (caller)[2];
        print "ok $Tests - got and expected error for qr/$regex/; line $line\n";
    }
    return;
}

# Break test files (e.g. GCBTest.txt) character that break allowed here
my $breakable_utf8 = my $breakable = chr(utf8::unicode_to_native(0xF7));
utf8::upgrade($breakable_utf8);

# Break test files (e.g. GCBTest.txt) character that indicates can't break
# here
my $nobreak_utf8 = my $nobreak = chr(utf8::unicode_to_native(0xD7));
utf8::upgrade($nobreak_utf8);

my $are_ctype_locales_available;
my $utf8_locale;
chdir 't' if -d 't';
eval { require "./loc_tools.pl" };
if (defined &locales_enabled) {
    $are_ctype_locales_available = locales_enabled('LC_CTYPE');
    if ($are_ctype_locales_available) {
        $utf8_locale = &find_utf8_ctype_locale;
    }
}

# Eval'd so can run on versions earlier than the property is available in
my $WB_Extend_or_Format_re = eval 'qr/[\p{WB=Extend}\p{WB=Format}\p{WB=ZWJ}]/';
if (! defined $WB_Extend_or_Format_re) {
    $WB_Extend_or_Format_re = eval 'qr/[\p{WB=Extend}\p{WB=Format}]/';
}

sub _test_break($template, $break_type) {
    # Test various break property matches.  The 2nd parameter gives the
    # property name.  The input is a line from auxiliary/*Test.txt for the
    # given property.  Each such line is a sequence of Unicode (not native)
    # code points given by their hex numbers, separated by the two characters
    # defined just before this subroutine that indicate that either there can
    # or cannot be a break between the adjacent code points.  All these are
    # tested.
    #
    # For the gcb property extra tests are made.  if there isn't a break, that
    # means the sequence forms an extended grapheme cluster, which means that
    # \X should match the whole thing.  If there is a break, \X should stop
    # there.  This is all converted by this routine into a match: $string =~
    # /(\X)/, Each \X should match the next cluster; and that is what is
    # checked.

    my $line   = (caller 1)[2];   # Line number
    my $comment = "";

    if ($template =~ / ( .*? ) \s* \# (.*) /x) {
        $template = $1;
        $comment = $2;

        # Replace leading spaces with a single one.
        $comment =~ s/ ^ \s* / # /x;
    }

    # The line contains characters above the ASCII range, but in Latin1.  It
    # may or may not be in utf8, and if it is, it may or may not know it.  So,
    # convert these characters to 8 bits.  If knows is in utf8, simply
    # downgrade.
    if (utf8::is_utf8($template)) {
        utf8::downgrade($template);
    } else {

        # Otherwise, if it is in utf8, but doesn't know it, the next lines
        # convert the two problematic characters to their 8-bit equivalents.
        # If it isn't in utf8, they don't harm anything.
        use bytes;
        $template =~ s/$nobreak_utf8/$nobreak/g;
        $template =~ s/$breakable_utf8/$breakable/g;
    }

    # Perl customizes wb.  So change the official tests accordingly
    if ($break_type eq 'wb' && $WB_Extend_or_Format_re) {

        # Split into elements that alternate between code point and
        # break/no-break
        my @line = split / +/, $template;

        # Look at each code point and its following one
        for (my $i = 1; $i <  @line - 1 - 1; $i+=2) {

            # The customization only involves changing some breaks to
            # non-breaks.
            next if $line[$i+1] =~ /$nobreak/;

            my $lhs = chr utf8::unicode_to_native(hex $line[$i]);
            my $rhs = chr utf8::unicode_to_native(hex $line[$i+2]);

            # And it only affects adjacent space characters.
            next if $lhs !~ /\s/u;

            # But, we want to make sure to test spaces followed by a Extend
            # or Format.
            next if $rhs !~ /\s|$WB_Extend_or_Format_re/;

            # To test the customization, add some white-space before this to
            # create a span.  The $lhs white space may or may not be bound to
            # that span, and also with the $rhs.  If the $rhs is a binding
            # character, the $lhs is bound to it and not to the span, unless
            # $lhs is vertical space.  In all other cases, the $lhs is bound
            # to the span.  If the $rhs is white space, it is bound to the
            # $lhs
            my $bound;
            my $span;
            if ($rhs =~ /$WB_Extend_or_Format_re/) {
                if ($lhs =~ /\v/) {
                    $bound = $breakable;
                    $span = $nobreak;
                }
                else {
                    $bound = $nobreak;
                    $span = $breakable;
                }
            }
            else {
                $span = $nobreak;
                $bound = $nobreak;
            }

            splice @line, $i, 0, ( '0020', $nobreak, '0020', $span);
            $i += 4;
            $line[$i+1] = $bound;
        }
        $template = join " ", @line;
    }

    # The input is just the break/no-break symbols and sequences of Unicode
    # code points as hex digits separated by spaces for legibility. e.g.:
    # ÷ 0020 × 0308 ÷ 0020 ÷
    # Convert to native \x format
    $template =~ s/ \s* ( [[:xdigit:]]+ ) \s* /sprintf("\\x{%02X}", utf8::unicode_to_native(hex $1))/gex;
    $template =~ s/ \s* //gx;   # Probably the line above removed all spaces;
                                # but be sure

    # Make a copy of the input with the symbols replaced by \b{} and \B{} as
    # appropriate
    my $break_pattern = $template =~ s/ $breakable /\\b{$break_type}/grx;
    $break_pattern =~ s/ $nobreak /\\B{$break_type}/gx;

    my $display_string = $template =~ s/[$breakable$nobreak]//gr;
    my $string = eval "\"$display_string\"";

    # The remaining massaging of the input is for the \X tests.  Get rid of
    # the leading and trailing breakables
    $template =~ s/^ \s* $breakable \s* //x;
    $template =~ s/ \s* $breakable \s* $ //x;

    # Delete no-breaks
    $template =~ s/ \s* $nobreak \s* //xg;

    # Split the input into segments that are breakable between them.
    my @should_display = split /\s*$breakable\s*/, $template;
    my @should_match = map { eval "\"$_\"" } @should_display;

    # If a string can be represented in both non-ut8 and utf8, test both cases
    my $display_upgrade = "";
    UPGRADE:
    for my $to_upgrade (0 .. 1) {

        if ($to_upgrade) {

            # If already in utf8, would just be a repeat
            next UPGRADE if utf8::is_utf8($string);

            utf8::upgrade($string);
            $display_upgrade = " (utf8-upgraded)";
        }

        my @modifiers = qw(a aa d u i);
        if ($are_ctype_locales_available) {
            push @modifiers, "l$utf8_locale" if defined $utf8_locale;

            # The /l modifier has C after it to indicate the locale to try
            push @modifiers, "lC";
        }

        # Test for each of the regex modifiers.
        for my $modifier (@modifiers) {
            my $display_locale = "";

            # For /l, set the locale to what it says to.
            if ($modifier =~ / ^ l (.*) /x) {
                my $locale = $1;
                $display_locale = "(locale = $locale)";
                POSIX::setlocale(&POSIX::LC_CTYPE, $locale);
                $modifier = 'l';
            }

            no warnings qw(locale regexp surrogate);
            my $pattern = "(?$modifier:$break_pattern)";

            # Actually do the test
            my $matched_text;
            my $matched = $string =~ qr/$pattern/;
            if ($matched) {
                $matched_text = "matched";
            }
            else {
                $matched_text = "failed to match";
                print "not ";

                if (TODO_FAILING_BREAKS) {
                    $comment = " # $comment" unless $comment =~ / ^ \s* \# /x;
                    $comment =~ s/#/# TODO/;
                }
            }
            print "ok ", ++$Tests, " - \"$display_string\" $matched_text /$pattern/$display_upgrade; line $line $display_locale$comment\n";

            # Only print the comment on the first use of this line
            $comment = "";

            # Repeat with the first \B{} in the pattern.  This makes sure the
            # code in regexec.c:find_byclass() for \B gets executed
            if ($pattern =~ / ( .*? : ) .* ( \\B\{ .* ) /x) {
                my $B_pattern = "$1$2";
                $matched = $string =~ qr/$B_pattern/;
                print "not " unless $matched;
                $matched_text = ($matched) ? "matched" : "failed to match";
                print "ok ", ++$Tests, " - \"$display_string\" $matched_text /$B_pattern/$display_upgrade; line $line $display_locale";
                print " # TODO" if TODO_FAILING_BREAKS && ! $matched;
                print "\n";
            }
        }

        next if $break_type ne 'gcb';

        # Finally, do the \X match.
        my @matches = $string =~ /(\X)/g;

        # Look through each matched cluster to verify that it matches what we
        # expect.
        my $min = (@matches < @should_match) ? @matches : @should_match;
        for my $i (0 .. $min - 1) {
            $Tests++;
            if ($matches[$i] eq $should_match[$i]) {
                print "ok $Tests - ";
                if ($i == 0) {
                    print "In \"$display_string\" =~ /(\\X)/g, \\X #1";
                } else {
                    print "And \\X #", $i + 1,
                }
                print " correctly matched $should_display[$i]; line $line\n";
            } else {
                $matches[$i] = join("", map { sprintf "\\x{%04X}", ord $_ }
                                                    split "", $matches[$i]);
                print "not ok $Tests -";
                print " # TODO" if TODO_FAILING_BREAKS;
                print " In \"$display_string\" =~ /(\\X)/g, \\X #",
                    $i + 1,
                    " should have matched $should_display[$i]",
                    " but instead matched $matches[$i]",
                    ".  Abandoning rest of line $line\n";
                next UPGRADE;
            }
        }

        # And the number of matches should equal the number of expected matches.
        $Tests++;
        if (@matches == @should_match) {
            print "ok $Tests - Nothing was left over; line $line\n";
        } else {
            print "not ok $Tests - There were ", scalar @should_match, " \\X matches expected, but got ", scalar @matches, " instead; line $line";
            print " # TODO" if TODO_FAILING_BREAKS;
            print "\n";
        }
    }

    return;
}

sub Test_GCB($t) {
    _test_break($t, 'gcb');
}

sub Test_LB($t) {
    _test_break($t, 'lb');
}

sub Test_SB($t) {
    _test_break($t, 'sb');
}

sub Test_WB($t) {
    _test_break($t, 'wb');
}

sub Finished() {
    print "1..$Tests\n";
    exit($Fails ? -1 : 0);
}

if (!$::TESTCHUNK or $::TESTCHUNK == 1) {
    Error('\p{Script=InGreek}');    # Bug #69018
    Test_GCB("1100 $nobreak 1161");  # Bug #70940
    Expect(0, 0x2028, '\p{Print}', ""); # Bug # 71722
    Expect(0, 0x2029, '\p{Print}', ""); # Bug # 71722
    Expect(1, 0xFF10, '\p{XDigit}', ""); # Bug # 71726
    Error('\p{InKana}');    # 'Kana' is not a block so InKana shouldn't compile
    
    # Make sure this gets tested; it was not part of the official test suite at
    # the time this was added.  Note that this is as it would appear in the
    # official suite, and gets modified to check for the perl tailoring by
    # Test_WB()
    Test_WB("$breakable 0020 $breakable 0020 $breakable 0308 $breakable");
    Test_LB("$nobreak 200B $nobreak 0020 $nobreak 0020 $breakable 2060 $breakable");
    Expect(1, ord(" "), '\p{gc=:(?aa)s:}', "");     # /aa is valid
    Expect(1, ord(" "), '\p{gc=:(?-s)s:}', "");     # /-s is valid
    ;
    Error('\p{_perllb}');
    Error('\P{_perllb}');
    Error('\p{_perlscx}');
    Error('\P{_perlscx}');
    Error('\p{age}');
    Error('\P{age}');
    Error('\p{Age=_V1_1/a/}');
    Error('\P{Age=_V1_1/a/}');
    Expect(1, 65533, '\p{Age=:\AV1_1\z:}', "");;
    Expect(0, 65536, '\p{Age=:\AV1_1\z:}', "");;
    Expect(1, 65533, '\p{Age=v11}', "");
    Expect(0, 65533, '\p{^Age=v11}', "");
    Expect(0, 65533, '\P{Age=v11}', "");
    Expect(1, 65533, '\P{^Age=v11}', "");
    Expect(0, 65536, '\p{Age=v11}', "");
    Expect(1, 65536, '\p{^Age=v11}', "");
    Expect(1, 65536, '\P{Age=v11}', "");
    Expect(0, 65536, '\P{^Age=v11}', "");
    Expect(1, 65533, '\p{Age=:\Av11\z:}', "");;
    Expect(0, 65536, '\p{Age=:\Av11\z:}', "");;
    Expect(1, 65533, '\p{Age=	v1_1}', "");
    Expect(0, 65533, '\p{^Age=	v1_1}', "");
    Expect(0, 65533, '\P{Age=	v1_1}', "");
    Expect(1, 65533, '\P{^Age=	v1_1}', "");
    Expect(0, 65536, '\p{Age=	v1_1}', "");
    Expect(1, 65536, '\p{^Age=	v1_1}', "");
    Expect(1, 65536, '\P{Age=	v1_1}', "");
    Expect(0, 65536, '\P{^Age=	v1_1}', "");
    Error('\p{Is_Age=:=	 000000001.1}');
    Error('\P{Is_Age=:=	 000000001.1}');
    Expect(1, 65533, '\p{Is_Age=+0_1.1}', "");
    Expect(0, 65533, '\p{^Is_Age=+0_1.1}', "");
    Expect(0, 65533, '\P{Is_Age=+0_1.1}', "");
    Expect(1, 65533, '\P{^Is_Age=+0_1.1}', "");
    Expect(0, 65536, '\p{Is_Age=+0_1.1}', "");
    Expect(1, 65536, '\p{^Is_Age=+0_1.1}', "");
    Expect(1, 65536, '\P{Is_Age=+0_1.1}', "");
    Expect(0, 65536, '\P{^Is_Age=+0_1.1}', "");
    Error('\p{Age=		v10_0:=}');
    Error('\P{Age=		v10_0:=}');
    Expect(1, 191456, '\p{Age=:\AV10_0\z:}', "");;
    Expect(0, 191457, '\p{Age=:\AV10_0\z:}', "");;
    Expect(1, 191456, '\p{Age=v100}', "");
    Expect(0, 191456, '\p{^Age=v100}', "");
    Expect(0, 191456, '\P{Age=v100}', "");
    Expect(1, 191456, '\P{^Age=v100}', "");
    Expect(0, 191457, '\p{Age=v100}', "");
    Expect(1, 191457, '\p{^Age=v100}', "");
    Expect(1, 191457, '\P{Age=v100}', "");
    Expect(0, 191457, '\P{^Age=v100}', "");
    Expect(1, 191456, '\p{Age=:\Av100\z:}', "");;
    Expect(0, 191457, '\p{Age=:\Av100\z:}', "");;
    Expect(1, 191456, '\p{Age=	-V10_0}', "");
    Expect(0, 191456, '\p{^Age=	-V10_0}', "");
    Expect(0, 191456, '\P{Age=	-V10_0}', "");
    Expect(1, 191456, '\P{^Age=	-V10_0}', "");
    Expect(0, 191457, '\p{Age=	-V10_0}', "");
    Expect(1, 191457, '\p{^Age=	-V10_0}', "");
    Expect(1, 191457, '\P{Age=	-V10_0}', "");
    Expect(0, 191457, '\P{^Age=	-V10_0}', "");
    Error('\p{Is_Age:   __0_0_0_0_0_0_0010.0/a/}');
    Error('\P{Is_Age:   __0_0_0_0_0_0_0010.0/a/}');
    Expect(1, 191456, '\p{Is_Age=0000010.0}', "");
    Expect(0, 191456, '\p{^Is_Age=0000010.0}', "");
    Expect(0, 191456, '\P{Is_Age=0000010.0}', "");
    Expect(1, 191456, '\P{^Is_Age=0000010.0}', "");
    Expect(0, 191457, '\p{Is_Age=0000010.0}', "");
    Expect(1, 191457, '\p{^Is_Age=0000010.0}', "");
    Expect(1, 191457, '\P{Is_Age=0000010.0}', "");
    Expect(0, 191457, '\P{^Is_Age=0000010.0}', "");
    Error('\p{Age=/a/V11_0}');
    Error('\P{Age=/a/V11_0}');
    Expect(1, 129645, '\p{Age=:\AV11_0\z:}', "");;
    Expect(0, 129646, '\p{Age=:\AV11_0\z:}', "");;
    Expect(1, 129645, '\p{Age=v110}', "");
    Expect(0, 129645, '\p{^Age=v110}', "");
    Expect(0, 129645, '\P{Age=v110}', "");
    Expect(1, 129645, '\P{^Age=v110}', "");
    Expect(0, 129646, '\p{Age=v110}', "");
    Expect(1, 129646, '\p{^Age=v110}', "");
    Expect(1, 129646, '\P{Age=v110}', "");
    Expect(0, 129646, '\P{^Age=v110}', "");
    Expect(1, 129645, '\p{Age=:\Av110\z:}', "");;
    Expect(0, 129646, '\p{Age=:\Av110\z:}', "");;
    Expect(1, 129645, '\p{Age= _V11_0}', "");
    Expect(0, 129645, '\p{^Age= _V11_0}', "");
    Expect(0, 129645, '\P{Age= _V11_0}', "");
    Expect(1, 129645, '\P{^Age= _V11_0}', "");
    Expect(0, 129646, '\p{Age= _V11_0}', "");
    Expect(1, 129646, '\p{^Age= _V11_0}', "");
    Expect(1, 129646, '\P{Age= _V11_0}', "");
    Expect(0, 129646, '\P{^Age= _V11_0}', "");
    Error('\p{Is_Age=_ +0000011.0:=}');
    Error('\P{Is_Age=_ +0000011.0:=}');
    Expect(1, 129645, '\p{Is_Age=1_1.0}', "");
    Expect(0, 129645, '\p{^Is_Age=1_1.0}', "");
    Expect(0, 129645, '\P{Is_Age=1_1.0}', "");
    Expect(1, 129645, '\P{^Is_Age=1_1.0}', "");
    Expect(0, 129646, '\p{Is_Age=1_1.0}', "");
    Expect(1, 129646, '\p{^Is_Age=1_1.0}', "");
    Expect(1, 129646, '\P{Is_Age=1_1.0}', "");
    Expect(0, 129646, '\P{^Is_Age=1_1.0}', "");
    Error('\p{Age= V12_0:=}');
    Error('\P{Age= V12_0:=}');
    Expect(1, 129685, '\p{Age=:\AV12_0\z:}', "");;
    Expect(0, 129686, '\p{Age=:\AV12_0\z:}', "");;
    Expect(1, 129685, '\p{Age=v120}', "");
    Expect(0, 129685, '\p{^Age=v120}', "");
    Expect(0, 129685, '\P{Age=v120}', "");
    Expect(1, 129685, '\P{^Age=v120}', "");
    Expect(0, 129686, '\p{Age=v120}', "");
    Expect(1, 129686, '\p{^Age=v120}', "");
    Expect(1, 129686, '\P{Age=v120}', "");
    Expect(0, 129686, '\P{^Age=v120}', "");
    Expect(1, 129685, '\p{Age=:\Av120\z:}', "");;
    Expect(0, 129686, '\p{Age=:\Av120\z:}', "");;
    Expect(1, 129685, '\p{Age= _V12_0}', "");
    Expect(0, 129685, '\p{^Age= _V12_0}', "");
    Expect(0, 129685, '\P{Age= _V12_0}', "");
    Expect(1, 129685, '\P{^Age= _V12_0}', "");
    Expect(0, 129686, '\p{Age= _V12_0}', "");
    Expect(1, 129686, '\p{^Age= _V12_0}', "");
    Expect(1, 129686, '\P{Age= _V12_0}', "");
    Expect(0, 129686, '\P{^Age= _V12_0}', "");
    Error('\p{Is_Age=/a/		0000000012.0}');
    Error('\P{Is_Age=/a/		0000000012.0}');
    Expect(1, 129685, '\p{Is_Age=00_00_01_2.0}', "");
    Expect(0, 129685, '\p{^Is_Age=00_00_01_2.0}', "");
    Expect(0, 129685, '\P{Is_Age=00_00_01_2.0}', "");
    Expect(1, 129685, '\P{^Is_Age=00_00_01_2.0}', "");
    Expect(0, 129686, '\p{Is_Age=00_00_01_2.0}', "");
    Expect(1, 129686, '\p{^Is_Age=00_00_01_2.0}', "");
    Expect(1, 129686, '\P{Is_Age=00_00_01_2.0}', "");
    Expect(0, 129686, '\P{^Is_Age=00_00_01_2.0}', "");
    Error('\p{Age=_V12_1/a/}');
    Error('\P{Age=_V12_1/a/}');
    Expect(1, 13055, '\p{Age=:\AV12_1\z:}', "");;
    Expect(0, 13056, '\p{Age=:\AV12_1\z:}', "");;
    Expect(1, 13055, '\p{Age=v121}', "");
    Expect(0, 13055, '\p{^Age=v121}', "");
    Expect(0, 13055, '\P{Age=v121}', "");
    Expect(1, 13055, '\P{^Age=v121}', "");
    Expect(0, 13056, '\p{Age=v121}', "");
    Expect(1, 13056, '\p{^Age=v121}', "");
    Expect(1, 13056, '\P{Age=v121}', "");
    Expect(0, 13056, '\P{^Age=v121}', "");
    Expect(1, 13055, '\p{Age=:\Av121\z:}', "");;
    Expect(0, 13056, '\p{Age=:\Av121\z:}', "");;
    Expect(1, 13055, '\p{Age= 	V12_1}', "");
    Expect(0, 13055, '\p{^Age= 	V12_1}', "");
    Expect(0, 13055, '\P{Age= 	V12_1}', "");
    Expect(1, 13055, '\P{^Age= 	V12_1}', "");
    Expect(0, 13056, '\p{Age= 	V12_1}', "");
    Expect(1, 13056, '\p{^Age= 	V12_1}', "");
    Expect(1, 13056, '\P{Age= 	V12_1}', "");
    Expect(0, 13056, '\P{^Age= 	V12_1}', "");
    Error('\p{Is_Age=:=-+012.1}');
    Error('\P{Is_Age=:=-+012.1}');
    Expect(1, 13055, '\p{Is_Age=000000012.1}', "");
    Expect(0, 13055, '\p{^Is_Age=000000012.1}', "");
    Expect(0, 13055, '\P{Is_Age=000000012.1}', "");
    Expect(1, 13055, '\P{^Is_Age=000000012.1}', "");
    Expect(0, 13056, '\p{Is_Age=000000012.1}', "");
    Expect(1, 13056, '\p{^Is_Age=000000012.1}', "");
    Expect(1, 13056, '\P{Is_Age=000000012.1}', "");
    Expect(0, 13056, '\P{^Is_Age=000000012.1}', "");
    Error('\p{Age=--V13_0/a/}');
    Error('\P{Age=--V13_0/a/}');
    Expect(1, 201546, '\p{Age=:\AV13_0\z:}', "");;
    Expect(0, 201547, '\p{Age=:\AV13_0\z:}', "");;
    Expect(1, 201546, '\p{Age=v130}', "");
    Expect(0, 201546, '\p{^Age=v130}', "");
    Expect(0, 201546, '\P{Age=v130}', "");
    Expect(1, 201546, '\P{^Age=v130}', "");
    Expect(0, 201547, '\p{Age=v130}', "");
    Expect(1, 201547, '\p{^Age=v130}', "");
    Expect(1, 201547, '\P{Age=v130}', "");
    Expect(0, 201547, '\P{^Age=v130}', "");
    Expect(1, 201546, '\p{Age=:\Av130\z:}', "");;
    Expect(0, 201547, '\p{Age=:\Av130\z:}', "");;
    Expect(1, 201546, '\p{Age= V13_0}', "");
    Expect(0, 201546, '\p{^Age= V13_0}', "");
    Expect(0, 201546, '\P{Age= V13_0}', "");
    Expect(1, 201546, '\P{^Age= V13_0}', "");
    Expect(0, 201547, '\p{Age= V13_0}', "");
    Expect(1, 201547, '\p{^Age= V13_0}', "");
    Expect(1, 201547, '\P{Age= V13_0}', "");
    Expect(0, 201547, '\P{^Age= V13_0}', "");
    Error('\p{Is_Age=	01_3.0/a/}');
    Error('\P{Is_Age=	01_3.0/a/}');
    Expect(1, 201546, '\p{Is_Age=+00000013.0}', "");
    Expect(0, 201546, '\p{^Is_Age=+00000013.0}', "");
    Expect(0, 201546, '\P{Is_Age=+00000013.0}', "");
    Expect(1, 201546, '\P{^Is_Age=+00000013.0}', "");
    Expect(0, 201547, '\p{Is_Age=+00000013.0}', "");
    Expect(1, 201547, '\p{^Is_Age=+00000013.0}', "");
    Expect(1, 201547, '\P{Is_Age=+00000013.0}', "");
    Expect(0, 201547, '\P{^Is_Age=+00000013.0}', "");
    Error('\p{Age=	V2_0/a/}');
    Error('\P{Age=	V2_0/a/}');
    Expect(1, 983040, '\p{Age=:\AV2_0\z:}', "");;
    Expect(0, 983037, '\p{Age=:\AV2_0\z:}', "");;
    Expect(1, 983040, '\p{Age=v20}', "");
    Expect(0, 983040, '\p{^Age=v20}', "");
    Expect(0, 983040, '\P{Age=v20}', "");
    Expect(1, 983040, '\P{^Age=v20}', "");
    Expect(0, 983037, '\p{Age=v20}', "");
    Expect(1, 983037, '\p{^Age=v20}', "");
    Expect(1, 983037, '\P{Age=v20}', "");
    Expect(0, 983037, '\P{^Age=v20}', "");
    Expect(1, 983040, '\p{Age=:\Av20\z:}', "");;
    Expect(0, 983037, '\p{Age=:\Av20\z:}', "");;
    Expect(1, 983040, '\p{Age=  V2_0}', "");
    Expect(0, 983040, '\p{^Age=  V2_0}', "");
    Expect(0, 983040, '\P{Age=  V2_0}', "");
    Expect(1, 983040, '\P{^Age=  V2_0}', "");
    Expect(0, 983037, '\p{Age=  V2_0}', "");
    Expect(1, 983037, '\p{^Age=  V2_0}', "");
    Expect(1, 983037, '\P{Age=  V2_0}', "");
    Expect(0, 983037, '\P{^Age=  V2_0}', "");
    Error('\p{Is_Age=:=	-+0000002.0}');
    Error('\P{Is_Age=:=	-+0000002.0}');
    Expect(1, 983040, '\p{Is_Age=00_00_00_2.0}', "");
    Expect(0, 983040, '\p{^Is_Age=00_00_00_2.0}', "");
    Expect(0, 983040, '\P{Is_Age=00_00_00_2.0}', "");
    Expect(1, 983040, '\P{^Is_Age=00_00_00_2.0}', "");
    Expect(0, 983037, '\p{Is_Age=00_00_00_2.0}', "");
    Expect(1, 983037, '\p{^Is_Age=00_00_00_2.0}', "");
    Expect(1, 983037, '\P{Is_Age=00_00_00_2.0}', "");
    Expect(0, 983037, '\P{^Is_Age=00_00_00_2.0}', "");
    Error('\p{Age= :=V2_1}');
    Error('\P{Age= :=V2_1}');
    Expect(1, 65532, '\p{Age=:\AV2_1\z:}', "");;
    Expect(0, 65533, '\p{Age=:\AV2_1\z:}', "");;
    Expect(1, 65532, '\p{Age=v21}', "");
    Expect(0, 65532, '\p{^Age=v21}', "");
    Expect(0, 65532, '\P{Age=v21}', "");
    Expect(1, 65532, '\P{^Age=v21}', "");
    Expect(0, 65533, '\p{Age=v21}', "");
    Expect(1, 65533, '\p{^Age=v21}', "");
    Expect(1, 65533, '\P{Age=v21}', "");
    Expect(0, 65533, '\P{^Age=v21}', "");
    Expect(1, 65532, '\p{Age=:\Av21\z:}', "");;
    Expect(0, 65533, '\p{Age=:\Av21\z:}', "");;
    Expect(1, 65532, '\p{Age=V2_1}', "");
    Expect(0, 65532, '\p{^Age=V2_1}', "");
    Expect(0, 65532, '\P{Age=V2_1}', "");
    Expect(1, 65532, '\P{^Age=V2_1}', "");
    Expect(0, 65533, '\p{Age=V2_1}', "");
    Expect(1, 65533, '\p{^Age=V2_1}', "");
    Expect(1, 65533, '\P{Age=V2_1}', "");
    Expect(0, 65533, '\P{^Age=V2_1}', "");
    Error('\p{Is_Age=/a/ -+0000002.1}');
    Error('\P{Is_Age=/a/ -+0000002.1}');
    Expect(1, 65532, '\p{Is_Age=2.1}', "");
    Expect(0, 65532, '\p{^Is_Age=2.1}', "");
    Expect(0, 65532, '\P{Is_Age=2.1}', "");
    Expect(1, 65532, '\P{^Is_Age=2.1}', "");
    Expect(0, 65533, '\p{Is_Age=2.1}', "");
    Expect(1, 65533, '\p{^Is_Age=2.1}', "");
    Expect(1, 65533, '\P{Is_Age=2.1}', "");
    Expect(0, 65533, '\P{^Is_Age=2.1}', "");
    Error('\p{Age: := _V3_0}');
    Error('\P{Age: := _V3_0}');
    Expect(1, 65531, '\p{Age=:\AV3_0\z:}', "");;
    Expect(0, 65532, '\p{Age=:\AV3_0\z:}', "");;
    Expect(1, 65531, '\p{Age=v30}', "");
    Expect(0, 65531, '\p{^Age=v30}', "");
    Expect(0, 65531, '\P{Age=v30}', "");
    Expect(1, 65531, '\P{^Age=v30}', "");
    Expect(0, 65532, '\p{Age=v30}', "");
    Expect(1, 65532, '\p{^Age=v30}', "");
    Expect(1, 65532, '\P{Age=v30}', "");
    Expect(0, 65532, '\P{^Age=v30}', "");
    Expect(1, 65531, '\p{Age=:\Av30\z:}', "");;
    Expect(0, 65532, '\p{Age=:\Av30\z:}', "");;
    Expect(1, 65531, '\p{Age=	_V3_0}', "");
    Expect(0, 65531, '\p{^Age=	_V3_0}', "");
    Expect(0, 65531, '\P{Age=	_V3_0}', "");
    Expect(1, 65531, '\P{^Age=	_V3_0}', "");
    Expect(0, 65532, '\p{Age=	_V3_0}', "");
    Expect(1, 65532, '\p{^Age=	_V3_0}', "");
    Expect(1, 65532, '\P{Age=	_V3_0}', "");
    Expect(0, 65532, '\P{^Age=	_V3_0}', "");
    Error('\p{Is_Age=:=  003.0}');
    Error('\P{Is_Age=:=  003.0}');
    Expect(1, 65531, '\p{Is_Age=+003.0}', "");
    Expect(0, 65531, '\p{^Is_Age=+003.0}', "");
    Expect(0, 65531, '\P{Is_Age=+003.0}', "");
    Expect(1, 65531, '\P{^Is_Age=+003.0}', "");
    Expect(0, 65532, '\p{Is_Age=+003.0}', "");
    Expect(1, 65532, '\p{^Is_Age=+003.0}', "");
    Expect(1, 65532, '\P{Is_Age=+003.0}', "");
    Expect(0, 65532, '\P{^Is_Age=+003.0}', "");
    Error('\p{Age=-/a/v3_1}');
    Error('\P{Age=-/a/v3_1}');
    Expect(1, 917631, '\p{Age=:\AV3_1\z:}', "");;
    Expect(0, 917632, '\p{Age=:\AV3_1\z:}', "");;
    Expect(1, 917631, '\p{Age=v31}', "");
    Expect(0, 917631, '\p{^Age=v31}', "");
    Expect(0, 917631, '\P{Age=v31}', "");
    Expect(1, 917631, '\P{^Age=v31}', "");
    Expect(0, 917632, '\p{Age=v31}', "");
    Expect(1, 917632, '\p{^Age=v31}', "");
    Expect(1, 917632, '\P{Age=v31}', "");
    Expect(0, 917632, '\P{^Age=v31}', "");
    Expect(1, 917631, '\p{Age=:\Av31\z:}', "");;
    Expect(0, 917632, '\p{Age=:\Av31\z:}', "");;
    Expect(1, 917631, '\p{Age=	V3_1}', "");
    Expect(0, 917631, '\p{^Age=	V3_1}', "");
    Expect(0, 917631, '\P{Age=	V3_1}', "");
    Expect(1, 917631, '\P{^Age=	V3_1}', "");
    Expect(0, 917632, '\p{Age=	V3_1}', "");
    Expect(1, 917632, '\p{^Age=	V3_1}', "");
    Expect(1, 917632, '\P{Age=	V3_1}', "");
    Expect(0, 917632, '\P{^Age=	V3_1}', "");
    Error('\p{Is_Age=:= 3.1}');
    Error('\P{Is_Age=:= 3.1}');
    Expect(1, 917631, '\p{Is_Age=3.1}', "");
    Expect(0, 917631, '\p{^Is_Age=3.1}', "");
    Expect(0, 917631, '\P{Is_Age=3.1}', "");
    Expect(1, 917631, '\P{^Is_Age=3.1}', "");
    Expect(0, 917632, '\p{Is_Age=3.1}', "");
    Expect(1, 917632, '\p{^Is_Age=3.1}', "");
    Expect(1, 917632, '\P{Is_Age=3.1}', "");
    Expect(0, 917632, '\P{^Is_Age=3.1}', "");
    Error('\p{Age=-/a/V3_2}');
    Error('\P{Age=-/a/V3_2}');
    Expect(1, 65376, '\p{Age=:\AV3_2\z:}', "");;
    Expect(0, 65377, '\p{Age=:\AV3_2\z:}', "");;
    Expect(1, 65376, '\p{Age=v32}', "");
    Expect(0, 65376, '\p{^Age=v32}', "");
    Expect(0, 65376, '\P{Age=v32}', "");
    Expect(1, 65376, '\P{^Age=v32}', "");
    Expect(0, 65377, '\p{Age=v32}', "");
    Expect(1, 65377, '\p{^Age=v32}', "");
    Expect(1, 65377, '\P{Age=v32}', "");
    Expect(0, 65377, '\P{^Age=v32}', "");
    Expect(1, 65376, '\p{Age=:\Av32\z:}', "");;
    Expect(0, 65377, '\p{Age=:\Av32\z:}', "");;
    Expect(1, 65376, '\p{Age=		V3_2}', "");
    Expect(0, 65376, '\p{^Age=		V3_2}', "");
    Expect(0, 65376, '\P{Age=		V3_2}', "");
    Expect(1, 65376, '\P{^Age=		V3_2}', "");
    Expect(0, 65377, '\p{Age=		V3_2}', "");
    Expect(1, 65377, '\p{^Age=		V3_2}', "");
    Expect(1, 65377, '\P{Age=		V3_2}', "");
    Expect(0, 65377, '\P{^Age=		V3_2}', "");
    Error('\p{Is_Age=:=- 0003.2}');
    Error('\P{Is_Age=:=- 0003.2}');
    Expect(1, 65376, '\p{Is_Age=+000003.2}', "");
    Expect(0, 65376, '\p{^Is_Age=+000003.2}', "");
    Expect(0, 65376, '\P{Is_Age=+000003.2}', "");
    Expect(1, 65376, '\P{^Is_Age=+000003.2}', "");
    Expect(0, 65377, '\p{Is_Age=+000003.2}', "");
    Expect(1, 65377, '\p{^Is_Age=+000003.2}', "");
    Expect(1, 65377, '\P{Is_Age=+000003.2}', "");
    Expect(0, 65377, '\P{^Is_Age=+000003.2}', "");
    Error('\p{Age=/a/__V4_0}');
    Error('\P{Age=/a/__V4_0}');
    Expect(1, 917999, '\p{Age=:\AV4_0\z:}', "");;
    Expect(0, 918000, '\p{Age=:\AV4_0\z:}', "");;
    Expect(1, 917999, '\p{Age=v40}', "");
    Expect(0, 917999, '\p{^Age=v40}', "");
    Expect(0, 917999, '\P{Age=v40}', "");
    Expect(1, 917999, '\P{^Age=v40}', "");
    Expect(0, 918000, '\p{Age=v40}', "");
    Expect(1, 918000, '\p{^Age=v40}', "");
    Expect(1, 918000, '\P{Age=v40}', "");
    Expect(0, 918000, '\P{^Age=v40}', "");
    Expect(1, 917999, '\p{Age=:\Av40\z:}', "");;
    Expect(0, 918000, '\p{Age=:\Av40\z:}', "");;
    Expect(1, 917999, '\p{Age=_	v4_0}', "");
    Expect(0, 917999, '\p{^Age=_	v4_0}', "");
    Expect(0, 917999, '\P{Age=_	v4_0}', "");
    Expect(1, 917999, '\P{^Age=_	v4_0}', "");
    Expect(0, 918000, '\p{Age=_	v4_0}', "");
    Expect(1, 918000, '\p{^Age=_	v4_0}', "");
    Expect(1, 918000, '\P{Age=_	v4_0}', "");
    Expect(0, 918000, '\P{^Age=_	v4_0}', "");
    Error('\p{Is_Age=:=-	0_0_04.0}');
    Error('\P{Is_Age=:=-	0_0_04.0}');
    Expect(1, 917999, '\p{Is_Age=+0000_4.0}', "");
    Expect(0, 917999, '\p{^Is_Age=+0000_4.0}', "");
    Expect(0, 917999, '\P{Is_Age=+0000_4.0}', "");
    Expect(1, 917999, '\P{^Is_Age=+0000_4.0}', "");
    Expect(0, 918000, '\p{Is_Age=+0000_4.0}', "");
    Expect(1, 918000, '\p{^Is_Age=+0000_4.0}', "");
    Expect(1, 918000, '\P{Is_Age=+0000_4.0}', "");
    Expect(0, 918000, '\P{^Is_Age=+0000_4.0}', "");
    Error('\p{Age=:=V4_1}');
    Error('\P{Age=:=V4_1}');
    Expect(1, 120485, '\p{Age=:\AV4_1\z:}', "");;
    Expect(0, 120486, '\p{Age=:\AV4_1\z:}', "");;
    Expect(1, 120485, '\p{Age:	v41}', "");
    Expect(0, 120485, '\p{^Age:	v41}', "");
    Expect(0, 120485, '\P{Age:	v41}', "");
    Expect(1, 120485, '\P{^Age:	v41}', "");
    Expect(0, 120486, '\p{Age:	v41}', "");
    Expect(1, 120486, '\p{^Age:	v41}', "");
    Expect(1, 120486, '\P{Age:	v41}', "");
    Expect(0, 120486, '\P{^Age:	v41}', "");
    Expect(1, 120485, '\p{Age=:\Av41\z:}', "");;
    Expect(0, 120486, '\p{Age=:\Av41\z:}', "");;
    Expect(1, 120485, '\p{Age= -v4_1}', "");
    Expect(0, 120485, '\p{^Age= -v4_1}', "");
    Expect(0, 120485, '\P{Age= -v4_1}', "");
    Expect(1, 120485, '\P{^Age= -v4_1}', "");
    Expect(0, 120486, '\p{Age= -v4_1}', "");
    Expect(1, 120486, '\p{^Age= -v4_1}', "");
    Expect(1, 120486, '\P{Age= -v4_1}', "");
    Expect(0, 120486, '\P{^Age= -v4_1}', "");
    Error('\p{Is_Age=_0_4.1:=}');
    Error('\P{Is_Age=_0_4.1:=}');
    Expect(1, 120485, '\p{Is_Age=+00004.1}', "");
    Expect(0, 120485, '\p{^Is_Age=+00004.1}', "");
    Expect(0, 120485, '\P{Is_Age=+00004.1}', "");
    Expect(1, 120485, '\P{^Is_Age=+00004.1}', "");
    Expect(0, 120486, '\p{Is_Age=+00004.1}', "");
    Expect(1, 120486, '\p{^Is_Age=+00004.1}', "");
    Expect(1, 120486, '\P{Is_Age=+00004.1}', "");
    Expect(0, 120486, '\P{^Is_Age=+00004.1}', "");
    Error('\p{Age=:=_V5_0}');
    Error('\P{Age=:=_V5_0}');
    Expect(1, 120779, '\p{Age=:\AV5_0\z:}', "");;
    Expect(0, 120780, '\p{Age=:\AV5_0\z:}', "");;
    Expect(1, 120779, '\p{Age:	v50}', "");
    Expect(0, 120779, '\p{^Age:	v50}', "");
    Expect(0, 120779, '\P{Age:	v50}', "");
    Expect(1, 120779, '\P{^Age:	v50}', "");
    Expect(0, 120780, '\p{Age:	v50}', "");
    Expect(1, 120780, '\p{^Age:	v50}', "");
    Expect(1, 120780, '\P{Age:	v50}', "");
    Expect(0, 120780, '\P{^Age:	v50}', "");
    Expect(1, 120779, '\p{Age=:\Av50\z:}', "");;
    Expect(0, 120780, '\p{Age=:\Av50\z:}', "");;
    Expect(1, 120779, '\p{Age=		v5_0}', "");
    Expect(0, 120779, '\p{^Age=		v5_0}', "");
    Expect(0, 120779, '\P{Age=		v5_0}', "");
    Expect(1, 120779, '\P{^Age=		v5_0}', "");
    Expect(0, 120780, '\p{Age=		v5_0}', "");
    Expect(1, 120780, '\p{^Age=		v5_0}', "");
    Expect(1, 120780, '\P{Age=		v5_0}', "");
    Expect(0, 120780, '\P{^Age=		v5_0}', "");
    Error('\p{Is_Age=:=00_5.0}');
    Error('\P{Is_Age=:=00_5.0}');
    Expect(1, 120779, '\p{Is_Age=00_00_5.0}', "");
    Expect(0, 120779, '\p{^Is_Age=00_00_5.0}', "");
    Expect(0, 120779, '\P{Is_Age=00_00_5.0}', "");
    Expect(1, 120779, '\P{^Is_Age=00_00_5.0}', "");
    Expect(0, 120780, '\p{Is_Age=00_00_5.0}', "");
    Expect(1, 120780, '\p{^Is_Age=00_00_5.0}', "");
    Expect(1, 120780, '\P{Is_Age=00_00_5.0}', "");
    Expect(0, 120780, '\P{^Is_Age=00_00_5.0}', "");
    Error('\p{Age:/a/_V5_1}');
    Error('\P{Age:/a/_V5_1}');
    Expect(1, 127123, '\p{Age=:\AV5_1\z:}', "");;
    Expect(0, 127124, '\p{Age=:\AV5_1\z:}', "");;
    Expect(1, 127123, '\p{Age=v51}', "");
    Expect(0, 127123, '\p{^Age=v51}', "");
    Expect(0, 127123, '\P{Age=v51}', "");
    Expect(1, 127123, '\P{^Age=v51}', "");
    Expect(0, 127124, '\p{Age=v51}', "");
    Expect(1, 127124, '\p{^Age=v51}', "");
    Expect(1, 127124, '\P{Age=v51}', "");
    Expect(0, 127124, '\P{^Age=v51}', "");
    Expect(1, 127123, '\p{Age=:\Av51\z:}', "");;
    Expect(0, 127124, '\p{Age=:\Av51\z:}', "");;
    Expect(1, 127123, '\p{Age=	-V5_1}', "");
    Expect(0, 127123, '\p{^Age=	-V5_1}', "");
    Expect(0, 127123, '\P{Age=	-V5_1}', "");
    Expect(1, 127123, '\P{^Age=	-V5_1}', "");
    Expect(0, 127124, '\p{Age=	-V5_1}', "");
    Expect(1, 127124, '\p{^Age=	-V5_1}', "");
    Expect(1, 127124, '\P{Age=	-V5_1}', "");
    Expect(0, 127124, '\P{^Age=	-V5_1}', "");
    Error('\p{Is_Age=/a/-_+0_5.1}');
    Error('\P{Is_Age=/a/-_+0_5.1}');
    Expect(1, 127123, '\p{Is_Age=+00_00_00_005.1}', "");
    Expect(0, 127123, '\p{^Is_Age=+00_00_00_005.1}', "");
    Expect(0, 127123, '\P{Is_Age=+00_00_00_005.1}', "");
    Expect(1, 127123, '\P{^Is_Age=+00_00_00_005.1}', "");
    Expect(0, 127124, '\p{Is_Age=+00_00_00_005.1}', "");
    Expect(1, 127124, '\p{^Is_Age=+00_00_00_005.1}', "");
    Expect(1, 127124, '\P{Is_Age=+00_00_00_005.1}', "");
    Expect(0, 127124, '\P{^Is_Age=+00_00_00_005.1}', "");
    Error('\p{Age=V5_2:=}');
    Error('\P{Age=V5_2:=}');
    Expect(1, 177972, '\p{Age=:\AV5_2\z:}', "");;
    Expect(0, 177973, '\p{Age=:\AV5_2\z:}', "");;
    Expect(1, 177972, '\p{Age=v52}', "");
    Expect(0, 177972, '\p{^Age=v52}', "");
    Expect(0, 177972, '\P{Age=v52}', "");
    Expect(1, 177972, '\P{^Age=v52}', "");
    Expect(0, 177973, '\p{Age=v52}', "");
    Expect(1, 177973, '\p{^Age=v52}', "");
    Expect(1, 177973, '\P{Age=v52}', "");
    Expect(0, 177973, '\P{^Age=v52}', "");
    Expect(1, 177972, '\p{Age=:\Av52\z:}', "");;
    Expect(0, 177973, '\p{Age=:\Av52\z:}', "");;
    Expect(1, 177972, '\p{Age=	V5_2}', "");
    Expect(0, 177972, '\p{^Age=	V5_2}', "");
    Expect(0, 177972, '\P{Age=	V5_2}', "");
    Expect(1, 177972, '\P{^Age=	V5_2}', "");
    Expect(0, 177973, '\p{Age=	V5_2}', "");
    Expect(1, 177973, '\p{^Age=	V5_2}', "");
    Expect(1, 177973, '\P{Age=	V5_2}', "");
    Expect(0, 177973, '\P{^Age=	V5_2}', "");
    Error('\p{Is_Age=/a/		5.2}');
    Error('\P{Is_Age=/a/		5.2}');
    Expect(1, 177972, '\p{Is_Age=0_0_0_05.2}', "");
    Expect(0, 177972, '\p{^Is_Age=0_0_0_05.2}', "");
    Expect(0, 177972, '\P{Is_Age=0_0_0_05.2}', "");
    Expect(1, 177972, '\P{^Is_Age=0_0_0_05.2}', "");
    Expect(0, 177973, '\p{Is_Age=0_0_0_05.2}', "");
    Expect(1, 177973, '\p{^Is_Age=0_0_0_05.2}', "");
    Expect(1, 177973, '\P{Is_Age=0_0_0_05.2}', "");
    Expect(0, 177973, '\P{^Is_Age=0_0_0_05.2}', "");
    Error('\p{Age=	:=V6_0}');
    Error('\P{Age=	:=V6_0}');
    Expect(1, 178205, '\p{Age=:\AV6_0\z:}', "");;
    Expect(0, 178206, '\p{Age=:\AV6_0\z:}', "");;
    Expect(1, 178205, '\p{Age: v60}', "");
    Expect(0, 178205, '\p{^Age: v60}', "");
    Expect(0, 178205, '\P{Age: v60}', "");
    Expect(1, 178205, '\P{^Age: v60}', "");
    Expect(0, 178206, '\p{Age: v60}', "");
    Expect(1, 178206, '\p{^Age: v60}', "");
    Expect(1, 178206, '\P{Age: v60}', "");
    Expect(0, 178206, '\P{^Age: v60}', "");
    Expect(1, 178205, '\p{Age=:\Av60\z:}', "");;
    Expect(0, 178206, '\p{Age=:\Av60\z:}', "");;
    Expect(1, 178205, '\p{Age= _V6_0}', "");
    Expect(0, 178205, '\p{^Age= _V6_0}', "");
    Expect(0, 178205, '\P{Age= _V6_0}', "");
    Expect(1, 178205, '\P{^Age= _V6_0}', "");
    Expect(0, 178206, '\p{Age= _V6_0}', "");
    Expect(1, 178206, '\p{^Age= _V6_0}', "");
    Expect(1, 178206, '\P{Age= _V6_0}', "");
    Expect(0, 178206, '\P{^Age= _V6_0}', "");
    Error('\p{Is_Age=_+000006.0:=}');
    Error('\P{Is_Age=_+000006.0:=}');
    Expect(1, 178205, '\p{Is_Age=+0000000006.0}', "");
    Expect(0, 178205, '\p{^Is_Age=+0000000006.0}', "");
    Expect(0, 178205, '\P{Is_Age=+0000000006.0}', "");
    Expect(1, 178205, '\P{^Is_Age=+0000000006.0}', "");
    Expect(0, 178206, '\p{Is_Age=+0000000006.0}', "");
    Expect(1, 178206, '\p{^Is_Age=+0000000006.0}', "");
    Expect(1, 178206, '\P{Is_Age=+0000000006.0}', "");
    Expect(0, 178206, '\P{^Is_Age=+0000000006.0}', "");
    Error('\p{Age:		/a/V6_1}');
    Error('\P{Age:		/a/V6_1}');
    Expect(1, 128564, '\p{Age=:\AV6_1\z:}', "");;
    Expect(0, 128565, '\p{Age=:\AV6_1\z:}', "");;
    Expect(1, 128564, '\p{Age=v61}', "");
    Expect(0, 128564, '\p{^Age=v61}', "");
    Expect(0, 128564, '\P{Age=v61}', "");
    Expect(1, 128564, '\P{^Age=v61}', "");
    Expect(0, 128565, '\p{Age=v61}', "");
    Expect(1, 128565, '\p{^Age=v61}', "");
    Expect(1, 128565, '\P{Age=v61}', "");
    Expect(0, 128565, '\P{^Age=v61}', "");
    Expect(1, 128564, '\p{Age=:\Av61\z:}', "");;
    Expect(0, 128565, '\p{Age=:\Av61\z:}', "");;
    Expect(1, 128564, '\p{Age=_ v6_1}', "");
    Expect(0, 128564, '\p{^Age=_ v6_1}', "");
    Expect(0, 128564, '\P{Age=_ v6_1}', "");
    Expect(1, 128564, '\P{^Age=_ v6_1}', "");
    Expect(0, 128565, '\p{Age=_ v6_1}', "");
    Expect(1, 128565, '\p{^Age=_ v6_1}', "");
    Expect(1, 128565, '\P{Age=_ v6_1}', "");
    Expect(0, 128565, '\P{^Age=_ v6_1}', "");
    Error('\p{Is_Age=- +00_6.1:=}');
    Error('\P{Is_Age=- +00_6.1:=}');
    Expect(1, 128564, '\p{Is_Age:	0_6.1}', "");
    Expect(0, 128564, '\p{^Is_Age:	0_6.1}', "");
    Expect(0, 128564, '\P{Is_Age:	0_6.1}', "");
    Expect(1, 128564, '\P{^Is_Age:	0_6.1}', "");
    Expect(0, 128565, '\p{Is_Age:	0_6.1}', "");
    Expect(1, 128565, '\p{^Is_Age:	0_6.1}', "");
    Expect(1, 128565, '\P{Is_Age:	0_6.1}', "");
    Expect(0, 128565, '\P{^Is_Age:	0_6.1}', "");
    Error('\p{Age=/a/V6_2}');
    Error('\P{Age=/a/V6_2}');
    Expect(1, 8378, '\p{Age=:\AV6_2\z:}', "");;
    Expect(0, 8379, '\p{Age=:\AV6_2\z:}', "");;
    Expect(1, 8378, '\p{Age=v62}', "");
    Expect(0, 8378, '\p{^Age=v62}', "");
    Expect(0, 8378, '\P{Age=v62}', "");
    Expect(1, 8378, '\P{^Age=v62}', "");
    Expect(0, 8379, '\p{Age=v62}', "");
    Expect(1, 8379, '\p{^Age=v62}', "");
    Expect(1, 8379, '\P{Age=v62}', "");
    Expect(0, 8379, '\P{^Age=v62}', "");
    Expect(1, 8378, '\p{Age=:\Av62\z:}', "");;
    Expect(0, 8379, '\p{Age=:\Av62\z:}', "");;
    Expect(1, 8378, '\p{Age=_V6_2}', "");
    Expect(0, 8378, '\p{^Age=_V6_2}', "");
    Expect(0, 8378, '\P{Age=_V6_2}', "");
    Expect(1, 8378, '\P{^Age=_V6_2}', "");
    Expect(0, 8379, '\p{Age=_V6_2}', "");
    Expect(1, 8379, '\p{^Age=_V6_2}', "");
    Expect(1, 8379, '\P{Age=_V6_2}', "");
    Expect(0, 8379, '\P{^Age=_V6_2}', "");
    Error('\p{Is_Age= 00000000_6.2:=}');
    Error('\P{Is_Age= 00000000_6.2:=}');
    Expect(1, 8378, '\p{Is_Age=+0_6.2}', "");
    Expect(0, 8378, '\p{^Is_Age=+0_6.2}', "");
    Expect(0, 8378, '\P{Is_Age=+0_6.2}', "");
    Expect(1, 8378, '\P{^Is_Age=+0_6.2}', "");
    Expect(0, 8379, '\p{Is_Age=+0_6.2}', "");
    Expect(1, 8379, '\p{^Is_Age=+0_6.2}', "");
    Expect(1, 8379, '\P{Is_Age=+0_6.2}', "");
    Expect(0, 8379, '\P{^Is_Age=+0_6.2}', "");
    Error('\p{Age=:=_v6_3}');
    Error('\P{Age=:=_v6_3}');
    Expect(1, 8297, '\p{Age=:\AV6_3\z:}', "");;
    Expect(0, 8298, '\p{Age=:\AV6_3\z:}', "");;
    Expect(1, 8297, '\p{Age=v63}', "");
    Expect(0, 8297, '\p{^Age=v63}', "");
    Expect(0, 8297, '\P{Age=v63}', "");
    Expect(1, 8297, '\P{^Age=v63}', "");
    Expect(0, 8298, '\p{Age=v63}', "");
    Expect(1, 8298, '\p{^Age=v63}', "");
    Expect(1, 8298, '\P{Age=v63}', "");
    Expect(0, 8298, '\P{^Age=v63}', "");
    Expect(1, 8297, '\p{Age=:\Av63\z:}', "");;
    Expect(0, 8298, '\p{Age=:\Av63\z:}', "");;
    Expect(1, 8297, '\p{Age=-V6_3}', "");
    Expect(0, 8297, '\p{^Age=-V6_3}', "");
    Expect(0, 8297, '\P{Age=-V6_3}', "");
    Expect(1, 8297, '\P{^Age=-V6_3}', "");
    Expect(0, 8298, '\p{Age=-V6_3}', "");
    Expect(1, 8298, '\p{^Age=-V6_3}', "");
    Expect(1, 8298, '\P{Age=-V6_3}', "");
    Expect(0, 8298, '\P{^Age=-V6_3}', "");
    Error('\p{Is_Age=_	0_6.3/a/}');
    Error('\P{Is_Age=_	0_6.3/a/}');
    Expect(1, 8297, '\p{Is_Age=00_00_00_00_6.3}', "");
    Expect(0, 8297, '\p{^Is_Age=00_00_00_00_6.3}', "");
    Expect(0, 8297, '\P{Is_Age=00_00_00_00_6.3}', "");
    Expect(1, 8297, '\P{^Is_Age=00_00_00_00_6.3}', "");
    Expect(0, 8298, '\p{Is_Age=00_00_00_00_6.3}', "");
    Expect(1, 8298, '\p{^Is_Age=00_00_00_00_6.3}', "");
    Expect(1, 8298, '\P{Is_Age=00_00_00_00_6.3}', "");
    Expect(0, 8298, '\P{^Is_Age=00_00_00_00_6.3}', "");
    Error('\p{Age=-	v7_0/a/}');
    Error('\P{Age=-	v7_0/a/}');
    Expect(1, 129197, '\p{Age=:\AV7_0\z:}', "");;
    Expect(0, 129198, '\p{Age=:\AV7_0\z:}', "");;
    Expect(1, 129197, '\p{Age=v70}', "");
    Expect(0, 129197, '\p{^Age=v70}', "");
    Expect(0, 129197, '\P{Age=v70}', "");
    Expect(1, 129197, '\P{^Age=v70}', "");
    Expect(0, 129198, '\p{Age=v70}', "");
    Expect(1, 129198, '\p{^Age=v70}', "");
    Expect(1, 129198, '\P{Age=v70}', "");
    Expect(0, 129198, '\P{^Age=v70}', "");
    Expect(1, 129197, '\p{Age=:\Av70\z:}', "");;
    Expect(0, 129198, '\p{Age=:\Av70\z:}', "");;
    Expect(1, 129197, '\p{Age=  V7_0}', "");
    Expect(0, 129197, '\p{^Age=  V7_0}', "");
    Expect(0, 129197, '\P{Age=  V7_0}', "");
    Expect(1, 129197, '\P{^Age=  V7_0}', "");
    Expect(0, 129198, '\p{Age=  V7_0}', "");
    Expect(1, 129198, '\p{^Age=  V7_0}', "");
    Expect(1, 129198, '\P{Age=  V7_0}', "");
    Expect(0, 129198, '\P{^Age=  V7_0}', "");
    Error('\p{Is_Age=_/a/007.0}');
    Error('\P{Is_Age=_/a/007.0}');
    Expect(1, 129197, '\p{Is_Age=00000000_7.0}', "");
    Expect(0, 129197, '\p{^Is_Age=00000000_7.0}', "");
    Expect(0, 129197, '\P{Is_Age=00000000_7.0}', "");
    Expect(1, 129197, '\P{^Is_Age=00000000_7.0}', "");
    Expect(0, 129198, '\p{Is_Age=00000000_7.0}', "");
    Expect(1, 129198, '\p{^Is_Age=00000000_7.0}', "");
    Expect(1, 129198, '\P{Is_Age=00000000_7.0}', "");
    Expect(0, 129198, '\P{^Is_Age=00000000_7.0}', "");
    Error('\p{Age=/a/- V8_0}');
    Error('\P{Age=/a/- V8_0}');
    Expect(1, 183969, '\p{Age=:\AV8_0\z:}', "");;
    Expect(0, 183970, '\p{Age=:\AV8_0\z:}', "");;
    Expect(1, 183969, '\p{Age=v80}', "");
    Expect(0, 183969, '\p{^Age=v80}', "");
    Expect(0, 183969, '\P{Age=v80}', "");
    Expect(1, 183969, '\P{^Age=v80}', "");
    Expect(0, 183970, '\p{Age=v80}', "");
    Expect(1, 183970, '\p{^Age=v80}', "");
    Expect(1, 183970, '\P{Age=v80}', "");
    Expect(0, 183970, '\P{^Age=v80}', "");
    Expect(1, 183969, '\p{Age=:\Av80\z:}', "");;
    Expect(0, 183970, '\p{Age=:\Av80\z:}', "");;
    Expect(1, 183969, '\p{Age=_	v8_0}', "");
    Expect(0, 183969, '\p{^Age=_	v8_0}', "");
    Expect(0, 183969, '\P{Age=_	v8_0}', "");
    Expect(1, 183969, '\P{^Age=_	v8_0}', "");
    Expect(0, 183970, '\p{Age=_	v8_0}', "");
    Expect(1, 183970, '\p{^Age=_	v8_0}', "");
    Expect(1, 183970, '\P{Age=_	v8_0}', "");
    Expect(0, 183970, '\P{^Age=_	v8_0}', "");
    Error('\p{Is_Age=:= _0000008.0}');
    Error('\P{Is_Age=:= _0000008.0}');
    Expect(1, 183969, '\p{Is_Age=+0000_0000_08.0}', "");
    Expect(0, 183969, '\p{^Is_Age=+0000_0000_08.0}', "");
    Expect(0, 183969, '\P{Is_Age=+0000_0000_08.0}', "");
    Expect(1, 183969, '\P{^Is_Age=+0000_0000_08.0}', "");
    Expect(0, 183970, '\p{Is_Age=+0000_0000_08.0}', "");
    Expect(1, 183970, '\p{^Is_Age=+0000_0000_08.0}', "");
    Expect(1, 183970, '\P{Is_Age=+0000_0000_08.0}', "");
    Expect(0, 183970, '\P{^Is_Age=+0000_0000_08.0}', "");
    Error('\p{Age= /a/v9_0}');
    Error('\P{Age= /a/v9_0}');
    Expect(1, 129425, '\p{Age=:\AV9_0\z:}', "");;
    Expect(0, 129426, '\p{Age=:\AV9_0\z:}', "");;
    Expect(1, 129425, '\p{Age=v90}', "");
    Expect(0, 129425, '\p{^Age=v90}', "");
    Expect(0, 129425, '\P{Age=v90}', "");
    Expect(1, 129425, '\P{^Age=v90}', "");
    Expect(0, 129426, '\p{Age=v90}', "");
    Expect(1, 129426, '\p{^Age=v90}', "");
    Expect(1, 129426, '\P{Age=v90}', "");
    Expect(0, 129426, '\P{^Age=v90}', "");
    Expect(1, 129425, '\p{Age=:\Av90\z:}', "");;
    Expect(0, 129426, '\p{Age=:\Av90\z:}', "");;
    Expect(1, 129425, '\p{Age=	 V9_0}', "");
    Expect(0, 129425, '\p{^Age=	 V9_0}', "");
    Expect(0, 129425, '\P{Age=	 V9_0}', "");
    Expect(1, 129425, '\P{^Age=	 V9_0}', "");
    Expect(0, 129426, '\p{Age=	 V9_0}', "");
    Expect(1, 129426, '\p{^Age=	 V9_0}', "");
    Expect(1, 129426, '\P{Age=	 V9_0}', "");
    Expect(0, 129426, '\P{^Age=	 V9_0}', "");
    Error('\p{Is_Age= :=0009.0}');
    Error('\P{Is_Age= :=0009.0}');
    Expect(1, 129425, '\p{Is_Age=00000009.0}', "");
    Expect(0, 129425, '\p{^Is_Age=00000009.0}', "");
    Expect(0, 129425, '\P{Is_Age=00000009.0}', "");
    Expect(1, 129425, '\P{^Is_Age=00000009.0}', "");
    Expect(0, 129426, '\p{Is_Age=00000009.0}', "");
    Expect(1, 129426, '\p{^Is_Age=00000009.0}', "");
    Expect(1, 129426, '\P{Is_Age=00000009.0}', "");
    Expect(0, 129426, '\P{^Is_Age=00000009.0}', "");
    Error('\p{Age=/a/ 	UNASSIGNED}');
    Error('\P{Age=/a/ 	UNASSIGNED}');
    Expect(1, 983037, '\p{Age=:\AUnassigned\z:}', "");;
    Expect(0, 983040, '\p{Age=:\AUnassigned\z:}', "");;
    Expect(1, 983037, '\p{Age=unassigned}', "");
    Expect(0, 983037, '\p{^Age=unassigned}', "");
    Expect(0, 983037, '\P{Age=unassigned}', "");
    Expect(1, 983037, '\P{^Age=unassigned}', "");
    Expect(0, 983040, '\p{Age=unassigned}', "");
    Expect(1, 983040, '\p{^Age=unassigned}', "");
    Expect(1, 983040, '\P{Age=unassigned}', "");
    Expect(0, 983040, '\P{^Age=unassigned}', "");
    Expect(1, 983037, '\p{Age=:\Aunassigned\z:}', "");;
    Expect(0, 983040, '\p{Age=:\Aunassigned\z:}', "");;
    Expect(1, 983037, '\p{Age=		unassigned}', "");
    Expect(0, 983037, '\p{^Age=		unassigned}', "");
    Expect(0, 983037, '\P{Age=		unassigned}', "");
    Expect(1, 983037, '\P{^Age=		unassigned}', "");
    Expect(0, 983040, '\p{Age=		unassigned}', "");
    Expect(1, 983040, '\p{^Age=		unassigned}', "");
    Expect(1, 983040, '\P{Age=		unassigned}', "");
    Expect(0, 983040, '\P{^Age=		unassigned}', "");
    Error('\p{Is_Age:	/a/NA}');
    Error('\P{Is_Age:	/a/NA}');
    Expect(1, 983037, '\p{Is_Age=na}', "");
    Expect(0, 983037, '\p{^Is_Age=na}', "");
    Expect(0, 983037, '\P{Is_Age=na}', "");
    Expect(1, 983037, '\P{^Is_Age=na}', "");
    Expect(0, 983040, '\p{Is_Age=na}', "");
    Expect(1, 983040, '\p{^Is_Age=na}', "");
    Expect(1, 983040, '\P{Is_Age=na}', "");
    Expect(0, 983040, '\P{^Is_Age=na}', "");
    Expect(1, 983037, '\p{Is_Age= NA}', "");
    Expect(0, 983037, '\p{^Is_Age= NA}', "");
    Expect(0, 983037, '\P{Is_Age= NA}', "");
    Expect(1, 983037, '\P{^Is_Age= NA}', "");
    Expect(0, 983040, '\p{Is_Age= NA}', "");
    Expect(1, 983040, '\p{^Is_Age= NA}', "");
    Expect(1, 983040, '\P{Is_Age= NA}', "");
    Expect(0, 983040, '\P{^Is_Age= NA}', "");
    Error('\p{ASCII_Hex_Digit=:=-No}');
    Error('\P{ASCII_Hex_Digit=:=-No}');
    Expect(1, 103, '\p{ASCII_Hex_Digit=:\ANo\z:}', "");;
    Expect(0, 102, '\p{ASCII_Hex_Digit=:\ANo\z:}', "");;
    Expect(1, 103, '\p{ASCII_Hex_Digit=no}', "");
    Expect(0, 103, '\p{^ASCII_Hex_Digit=no}', "");
    Expect(0, 103, '\P{ASCII_Hex_Digit=no}', "");
    Expect(1, 103, '\P{^ASCII_Hex_Digit=no}', "");
    Expect(0, 102, '\p{ASCII_Hex_Digit=no}', "");
    Expect(1, 102, '\p{^ASCII_Hex_Digit=no}', "");
    Expect(1, 102, '\P{ASCII_Hex_Digit=no}', "");
    Expect(0, 102, '\P{^ASCII_Hex_Digit=no}', "");
    Expect(1, 103, '\p{ASCII_Hex_Digit=:\Ano\z:}', "");;
    Expect(0, 102, '\p{ASCII_Hex_Digit=:\Ano\z:}', "");;
    Expect(1, 103, '\p{ASCII_Hex_Digit= -NO}', "");
    Expect(0, 103, '\p{^ASCII_Hex_Digit= -NO}', "");
    Expect(0, 103, '\P{ASCII_Hex_Digit= -NO}', "");
    Expect(1, 103, '\P{^ASCII_Hex_Digit= -NO}', "");
    Expect(0, 102, '\p{ASCII_Hex_Digit= -NO}', "");
    Expect(1, 102, '\p{^ASCII_Hex_Digit= -NO}', "");
    Expect(1, 102, '\P{ASCII_Hex_Digit= -NO}', "");
    Expect(0, 102, '\P{^ASCII_Hex_Digit= -NO}', "");
    Error('\p{AHex: /a/N}');
    Error('\P{AHex: /a/N}');
    Expect(1, 103, '\p{AHex=:\AN\z:}', "");;
    Expect(0, 102, '\p{AHex=:\AN\z:}', "");;
    Expect(1, 103, '\p{AHex=n}', "");
    Expect(0, 103, '\p{^AHex=n}', "");
    Expect(0, 103, '\P{AHex=n}', "");
    Expect(1, 103, '\P{^AHex=n}', "");
    Expect(0, 102, '\p{AHex=n}', "");
    Expect(1, 102, '\p{^AHex=n}', "");
    Expect(1, 102, '\P{AHex=n}', "");
    Expect(0, 102, '\P{^AHex=n}', "");
    Expect(1, 103, '\p{AHex=:\An\z:}', "");;
    Expect(0, 102, '\p{AHex=:\An\z:}', "");;
    Expect(1, 103, '\p{AHex=-n}', "");
    Expect(0, 103, '\p{^AHex=-n}', "");
    Expect(0, 103, '\P{AHex=-n}', "");
    Expect(1, 103, '\P{^AHex=-n}', "");
    Expect(0, 102, '\p{AHex=-n}', "");
    Expect(1, 102, '\p{^AHex=-n}', "");
    Expect(1, 102, '\P{AHex=-n}', "");
    Expect(0, 102, '\P{^AHex=-n}', "");
    Error('\p{Is_ASCII_Hex_Digit=:= F}');
    Error('\P{Is_ASCII_Hex_Digit=:= F}');
    Expect(1, 103, '\p{Is_ASCII_Hex_Digit=f}', "");
    Expect(0, 103, '\p{^Is_ASCII_Hex_Digit=f}', "");
    Expect(0, 103, '\P{Is_ASCII_Hex_Digit=f}', "");
    Expect(1, 103, '\P{^Is_ASCII_Hex_Digit=f}', "");
    Expect(0, 102, '\p{Is_ASCII_Hex_Digit=f}', "");
    Expect(1, 102, '\p{^Is_ASCII_Hex_Digit=f}', "");
    Expect(1, 102, '\P{Is_ASCII_Hex_Digit=f}', "");
    Expect(0, 102, '\P{^Is_ASCII_Hex_Digit=f}', "");
    Expect(1, 103, '\p{Is_ASCII_Hex_Digit=-f}', "");
    Expect(0, 103, '\p{^Is_ASCII_Hex_Digit=-f}', "");
    Expect(0, 103, '\P{Is_ASCII_Hex_Digit=-f}', "");
    Expect(1, 103, '\P{^Is_ASCII_Hex_Digit=-f}', "");
    Expect(0, 102, '\p{Is_ASCII_Hex_Digit=-f}', "");
    Expect(1, 102, '\p{^Is_ASCII_Hex_Digit=-f}', "");
    Expect(1, 102, '\P{Is_ASCII_Hex_Digit=-f}', "");
    Expect(0, 102, '\P{^Is_ASCII_Hex_Digit=-f}', "");
    Error('\p{Is_AHex=-/a/FALSE}');
    Error('\P{Is_AHex=-/a/FALSE}');
    Expect(1, 103, '\p{Is_AHex=false}', "");
    Expect(0, 103, '\p{^Is_AHex=false}', "");
    Expect(0, 103, '\P{Is_AHex=false}', "");
    Expect(1, 103, '\P{^Is_AHex=false}', "");
    Expect(0, 102, '\p{Is_AHex=false}', "");
    Expect(1, 102, '\p{^Is_AHex=false}', "");
    Expect(1, 102, '\P{Is_AHex=false}', "");
    Expect(0, 102, '\P{^Is_AHex=false}', "");
    Expect(1, 103, '\p{Is_AHex=- False}', "");
    Expect(0, 103, '\p{^Is_AHex=- False}', "");
    Expect(0, 103, '\P{Is_AHex=- False}', "");
    Expect(1, 103, '\P{^Is_AHex=- False}', "");
    Expect(0, 102, '\p{Is_AHex=- False}', "");
    Expect(1, 102, '\p{^Is_AHex=- False}', "");
    Expect(1, 102, '\P{Is_AHex=- False}', "");
    Expect(0, 102, '\P{^Is_AHex=- False}', "");
    Error('\p{ASCII_Hex_Digit=:=_yes}');
    Error('\P{ASCII_Hex_Digit=:=_yes}');
    Expect(1, 102, '\p{ASCII_Hex_Digit=:\AYes\z:}', "");;
    Expect(0, 103, '\p{ASCII_Hex_Digit=:\AYes\z:}', "");;
    Expect(1, 102, '\p{ASCII_Hex_Digit=yes}', "");
    Expect(0, 102, '\p{^ASCII_Hex_Digit=yes}', "");
    Expect(0, 102, '\P{ASCII_Hex_Digit=yes}', "");
    Expect(1, 102, '\P{^ASCII_Hex_Digit=yes}', "");
    Expect(0, 103, '\p{ASCII_Hex_Digit=yes}', "");
    Expect(1, 103, '\p{^ASCII_Hex_Digit=yes}', "");
    Expect(1, 103, '\P{ASCII_Hex_Digit=yes}', "");
    Expect(0, 103, '\P{^ASCII_Hex_Digit=yes}', "");
    Expect(1, 102, '\p{ASCII_Hex_Digit=:\Ayes\z:}', "");;
    Expect(0, 103, '\p{ASCII_Hex_Digit=:\Ayes\z:}', "");;
    Expect(1, 102, '\p{ASCII_Hex_Digit=-_yes}', "");
    Expect(0, 102, '\p{^ASCII_Hex_Digit=-_yes}', "");
    Expect(0, 102, '\P{ASCII_Hex_Digit=-_yes}', "");
    Expect(1, 102, '\P{^ASCII_Hex_Digit=-_yes}', "");
    Expect(0, 103, '\p{ASCII_Hex_Digit=-_yes}', "");
    Expect(1, 103, '\p{^ASCII_Hex_Digit=-_yes}', "");
    Expect(1, 103, '\P{ASCII_Hex_Digit=-_yes}', "");
    Expect(0, 103, '\P{^ASCII_Hex_Digit=-_yes}', "");
    Error('\p{AHex=/a/	Y}');
    Error('\P{AHex=/a/	Y}');
    Expect(1, 102, '\p{AHex=:\AY\z:}', "");;
    Expect(0, 103, '\p{AHex=:\AY\z:}', "");;
    Expect(1, 102, '\p{AHex=y}', "");
    Expect(0, 102, '\p{^AHex=y}', "");
    Expect(0, 102, '\P{AHex=y}', "");
    Expect(1, 102, '\P{^AHex=y}', "");
    Expect(0, 103, '\p{AHex=y}', "");
    Expect(1, 103, '\p{^AHex=y}', "");
    Expect(1, 103, '\P{AHex=y}', "");
    Expect(0, 103, '\P{^AHex=y}', "");
    Expect(1, 102, '\p{AHex=:\Ay\z:}', "");;
    Expect(0, 103, '\p{AHex=:\Ay\z:}', "");;
    Expect(1, 102, '\p{AHex: 		y}', "");
    Expect(0, 102, '\p{^AHex: 		y}', "");
    Expect(0, 102, '\P{AHex: 		y}', "");
    Expect(1, 102, '\P{^AHex: 		y}', "");
    Expect(0, 103, '\p{AHex: 		y}', "");
    Expect(1, 103, '\p{^AHex: 		y}', "");
    Expect(1, 103, '\P{AHex: 		y}', "");
    Expect(0, 103, '\P{^AHex: 		y}', "");
    Error('\p{Is_ASCII_Hex_Digit=__T:=}');
    Error('\P{Is_ASCII_Hex_Digit=__T:=}');
    Expect(1, 102, '\p{Is_ASCII_Hex_Digit=t}', "");
    Expect(0, 102, '\p{^Is_ASCII_Hex_Digit=t}', "");
    Expect(0, 102, '\P{Is_ASCII_Hex_Digit=t}', "");
    Expect(1, 102, '\P{^Is_ASCII_Hex_Digit=t}', "");
    Expect(0, 103, '\p{Is_ASCII_Hex_Digit=t}', "");
    Expect(1, 103, '\p{^Is_ASCII_Hex_Digit=t}', "");
    Expect(1, 103, '\P{Is_ASCII_Hex_Digit=t}', "");
    Expect(0, 103, '\P{^Is_ASCII_Hex_Digit=t}', "");
    Expect(1, 102, '\p{Is_ASCII_Hex_Digit=_-T}', "");
    Expect(0, 102, '\p{^Is_ASCII_Hex_Digit=_-T}', "");
    Expect(0, 102, '\P{Is_ASCII_Hex_Digit=_-T}', "");
    Expect(1, 102, '\P{^Is_ASCII_Hex_Digit=_-T}', "");
    Expect(0, 103, '\p{Is_ASCII_Hex_Digit=_-T}', "");
    Expect(1, 103, '\p{^Is_ASCII_Hex_Digit=_-T}', "");
    Expect(1, 103, '\P{Is_ASCII_Hex_Digit=_-T}', "");
    Expect(0, 103, '\P{^Is_ASCII_Hex_Digit=_-T}', "");
    Error('\p{Is_AHex=-/a/True}');
    Error('\P{Is_AHex=-/a/True}');
    Expect(1, 102, '\p{Is_AHex=true}', "");
    Expect(0, 102, '\p{^Is_AHex=true}', "");
    Expect(0, 102, '\P{Is_AHex=true}', "");
    Expect(1, 102, '\P{^Is_AHex=true}', "");
    Expect(0, 103, '\p{Is_AHex=true}', "");
    Expect(1, 103, '\p{^Is_AHex=true}', "");
    Expect(1, 103, '\P{Is_AHex=true}', "");
    Expect(0, 103, '\P{^Is_AHex=true}', "");
    Expect(1, 102, '\p{Is_AHex= _true}', "");
    Expect(0, 102, '\p{^Is_AHex= _true}', "");
    Expect(0, 102, '\P{Is_AHex= _true}', "");
    Expect(1, 102, '\P{^Is_AHex= _true}', "");
    Expect(0, 103, '\p{Is_AHex= _true}', "");
    Expect(1, 103, '\p{^Is_AHex= _true}', "");
    Expect(1, 103, '\P{Is_AHex= _true}', "");
    Expect(0, 103, '\P{^Is_AHex= _true}', "");
    Error('\p{Alphabetic=-No:=}');
    Error('\P{Alphabetic=-No:=}');
    Expect(1, 201547, '\p{Alphabetic=:\ANo\z:}', "");;
    Expect(0, 201546, '\p{Alphabetic=:\ANo\z:}', "");;
    Expect(1, 201547, '\p{Alphabetic=no}', "");
    Expect(0, 201547, '\p{^Alphabetic=no}', "");
    Expect(0, 201547, '\P{Alphabetic=no}', "");
    Expect(1, 201547, '\P{^Alphabetic=no}', "");
    Expect(0, 201546, '\p{Alphabetic=no}', "");
    Expect(1, 201546, '\p{^Alphabetic=no}', "");
    Expect(1, 201546, '\P{Alphabetic=no}', "");
    Expect(0, 201546, '\P{^Alphabetic=no}', "");
    Expect(1, 201547, '\p{Alphabetic=:\Ano\z:}', "");;
    Expect(0, 201546, '\p{Alphabetic=:\Ano\z:}', "");;
    Expect(1, 201547, '\p{Alphabetic=	 No}', "");
    Expect(0, 201547, '\p{^Alphabetic=	 No}', "");
    Expect(0, 201547, '\P{Alphabetic=	 No}', "");
    Expect(1, 201547, '\P{^Alphabetic=	 No}', "");
    Expect(0, 201546, '\p{Alphabetic=	 No}', "");
    Expect(1, 201546, '\p{^Alphabetic=	 No}', "");
    Expect(1, 201546, '\P{Alphabetic=	 No}', "");
    Expect(0, 201546, '\P{^Alphabetic=	 No}', "");
    Error('\p{Alpha=		N:=}');
    Error('\P{Alpha=		N:=}');
    Expect(1, 201547, '\p{Alpha=:\AN\z:}', "");;
    Expect(0, 201546, '\p{Alpha=:\AN\z:}', "");;
    Expect(1, 201547, '\p{Alpha=n}', "");
    Expect(0, 201547, '\p{^Alpha=n}', "");
    Expect(0, 201547, '\P{Alpha=n}', "");
    Expect(1, 201547, '\P{^Alpha=n}', "");
    Expect(0, 201546, '\p{Alpha=n}', "");
    Expect(1, 201546, '\p{^Alpha=n}', "");
    Expect(1, 201546, '\P{Alpha=n}', "");
    Expect(0, 201546, '\P{^Alpha=n}', "");
    Expect(1, 201547, '\p{Alpha=:\An\z:}', "");;
    Expect(0, 201546, '\p{Alpha=:\An\z:}', "");;
    Expect(1, 201547, '\p{Alpha=	-N}', "");
    Expect(0, 201547, '\p{^Alpha=	-N}', "");
    Expect(0, 201547, '\P{Alpha=	-N}', "");
    Expect(1, 201547, '\P{^Alpha=	-N}', "");
    Expect(0, 201546, '\p{Alpha=	-N}', "");
    Expect(1, 201546, '\p{^Alpha=	-N}', "");
    Expect(1, 201546, '\P{Alpha=	-N}', "");
    Expect(0, 201546, '\P{^Alpha=	-N}', "");
    Error('\p{Is_Alphabetic=/a/	_f}');
    Error('\P{Is_Alphabetic=/a/	_f}');
    Expect(1, 201547, '\p{Is_Alphabetic=f}', "");
    Expect(0, 201547, '\p{^Is_Alphabetic=f}', "");
    Expect(0, 201547, '\P{Is_Alphabetic=f}', "");
    Expect(1, 201547, '\P{^Is_Alphabetic=f}', "");
    Expect(0, 201546, '\p{Is_Alphabetic=f}', "");
    Expect(1, 201546, '\p{^Is_Alphabetic=f}', "");
    Expect(1, 201546, '\P{Is_Alphabetic=f}', "");
    Expect(0, 201546, '\P{^Is_Alphabetic=f}', "");
    Expect(1, 201547, '\p{Is_Alphabetic=_F}', "");
    Expect(0, 201547, '\p{^Is_Alphabetic=_F}', "");
    Expect(0, 201547, '\P{Is_Alphabetic=_F}', "");
    Expect(1, 201547, '\P{^Is_Alphabetic=_F}', "");
    Expect(0, 201546, '\p{Is_Alphabetic=_F}', "");
    Expect(1, 201546, '\p{^Is_Alphabetic=_F}', "");
    Expect(1, 201546, '\P{Is_Alphabetic=_F}', "");
    Expect(0, 201546, '\P{^Is_Alphabetic=_F}', "");
    Error('\p{Is_Alpha=/a/--false}');
    Error('\P{Is_Alpha=/a/--false}');
    Expect(1, 201547, '\p{Is_Alpha=false}', "");
    Expect(0, 201547, '\p{^Is_Alpha=false}', "");
    Expect(0, 201547, '\P{Is_Alpha=false}', "");
    Expect(1, 201547, '\P{^Is_Alpha=false}', "");
    Expect(0, 201546, '\p{Is_Alpha=false}', "");
    Expect(1, 201546, '\p{^Is_Alpha=false}', "");
    Expect(1, 201546, '\P{Is_Alpha=false}', "");
    Expect(0, 201546, '\P{^Is_Alpha=false}', "");
    Expect(1, 201547, '\p{Is_Alpha=-False}', "");
    Expect(0, 201547, '\p{^Is_Alpha=-False}', "");
    Expect(0, 201547, '\P{Is_Alpha=-False}', "");
    Expect(1, 201547, '\P{^Is_Alpha=-False}', "");
    Expect(0, 201546, '\p{Is_Alpha=-False}', "");
    Expect(1, 201546, '\p{^Is_Alpha=-False}', "");
    Expect(1, 201546, '\P{Is_Alpha=-False}', "");
    Expect(0, 201546, '\P{^Is_Alpha=-False}', "");
    Error('\p{Alphabetic=	Yes/a/}');
    Error('\P{Alphabetic=	Yes/a/}');
    Expect(1, 201546, '\p{Alphabetic=:\AYes\z:}', "");;
    Expect(0, 201547, '\p{Alphabetic=:\AYes\z:}', "");;
    Expect(1, 201546, '\p{Alphabetic=yes}', "");
    Expect(0, 201546, '\p{^Alphabetic=yes}', "");
    Expect(0, 201546, '\P{Alphabetic=yes}', "");
    Expect(1, 201546, '\P{^Alphabetic=yes}', "");
    Expect(0, 201547, '\p{Alphabetic=yes}', "");
    Expect(1, 201547, '\p{^Alphabetic=yes}', "");
    Expect(1, 201547, '\P{Alphabetic=yes}', "");
    Expect(0, 201547, '\P{^Alphabetic=yes}', "");
    Expect(1, 201546, '\p{Alphabetic=:\Ayes\z:}', "");;
    Expect(0, 201547, '\p{Alphabetic=:\Ayes\z:}', "");;
    Expect(1, 201546, '\p{Alphabetic: YES}', "");
    Expect(0, 201546, '\p{^Alphabetic: YES}', "");
    Expect(0, 201546, '\P{Alphabetic: YES}', "");
    Expect(1, 201546, '\P{^Alphabetic: YES}', "");
    Expect(0, 201547, '\p{Alphabetic: YES}', "");
    Expect(1, 201547, '\p{^Alphabetic: YES}', "");
    Expect(1, 201547, '\P{Alphabetic: YES}', "");
    Expect(0, 201547, '\P{^Alphabetic: YES}', "");
    Error('\p{Alpha=	_Y:=}');
    Error('\P{Alpha=	_Y:=}');
    Expect(1, 201546, '\p{Alpha=:\AY\z:}', "");;
    Expect(0, 201547, '\p{Alpha=:\AY\z:}', "");;
    Expect(1, 201546, '\p{Alpha:	y}', "");
    Expect(0, 201546, '\p{^Alpha:	y}', "");
    Expect(0, 201546, '\P{Alpha:	y}', "");
    Expect(1, 201546, '\P{^Alpha:	y}', "");
    Expect(0, 201547, '\p{Alpha:	y}', "");
    Expect(1, 201547, '\p{^Alpha:	y}', "");
    Expect(1, 201547, '\P{Alpha:	y}', "");
    Expect(0, 201547, '\P{^Alpha:	y}', "");
    Expect(1, 201546, '\p{Alpha=:\Ay\z:}', "");;
    Expect(0, 201547, '\p{Alpha=:\Ay\z:}', "");;
    Expect(1, 201546, '\p{Alpha=	_Y}', "");
    Expect(0, 201546, '\p{^Alpha=	_Y}', "");
    Expect(0, 201546, '\P{Alpha=	_Y}', "");
    Expect(1, 201546, '\P{^Alpha=	_Y}', "");
    Expect(0, 201547, '\p{Alpha=	_Y}', "");
    Expect(1, 201547, '\p{^Alpha=	_Y}', "");
    Expect(1, 201547, '\P{Alpha=	_Y}', "");
    Expect(0, 201547, '\P{^Alpha=	_Y}', "");
    Error('\p{Is_Alphabetic=/a/_T}');
    Error('\P{Is_Alphabetic=/a/_T}');
    Expect(1, 201546, '\p{Is_Alphabetic=t}', "");
    Expect(0, 201546, '\p{^Is_Alphabetic=t}', "");
    Expect(0, 201546, '\P{Is_Alphabetic=t}', "");
    Expect(1, 201546, '\P{^Is_Alphabetic=t}', "");
    Expect(0, 201547, '\p{Is_Alphabetic=t}', "");
    Expect(1, 201547, '\p{^Is_Alphabetic=t}', "");
    Expect(1, 201547, '\P{Is_Alphabetic=t}', "");
    Expect(0, 201547, '\P{^Is_Alphabetic=t}', "");
    Expect(1, 201546, '\p{Is_Alphabetic=	_T}', "");
    Expect(0, 201546, '\p{^Is_Alphabetic=	_T}', "");
    Expect(0, 201546, '\P{Is_Alphabetic=	_T}', "");
    Expect(1, 201546, '\P{^Is_Alphabetic=	_T}', "");
    Expect(0, 201547, '\p{Is_Alphabetic=	_T}', "");
    Expect(1, 201547, '\p{^Is_Alphabetic=	_T}', "");
    Expect(1, 201547, '\P{Is_Alphabetic=	_T}', "");
    Expect(0, 201547, '\P{^Is_Alphabetic=	_T}', "");
    Error('\p{Is_Alpha=:=--TRUE}');
    Error('\P{Is_Alpha=:=--TRUE}');
    Expect(1, 201546, '\p{Is_Alpha=true}', "");
    Expect(0, 201546, '\p{^Is_Alpha=true}', "");
    Expect(0, 201546, '\P{Is_Alpha=true}', "");
    Expect(1, 201546, '\P{^Is_Alpha=true}', "");
    Expect(0, 201547, '\p{Is_Alpha=true}', "");
    Expect(1, 201547, '\p{^Is_Alpha=true}', "");
    Expect(1, 201547, '\P{Is_Alpha=true}', "");
    Expect(0, 201547, '\P{^Is_Alpha=true}', "");
    Expect(1, 201546, '\p{Is_Alpha:    -True}', "");
    Expect(0, 201546, '\p{^Is_Alpha:    -True}', "");
    Expect(0, 201546, '\P{Is_Alpha:    -True}', "");
    Expect(1, 201546, '\P{^Is_Alpha:    -True}', "");
    Expect(0, 201547, '\p{Is_Alpha:    -True}', "");
    Expect(1, 201547, '\p{^Is_Alpha:    -True}', "");
    Expect(1, 201547, '\P{Is_Alpha:    -True}', "");
    Expect(0, 201547, '\P{^Is_Alpha:    -True}', "");
    Error('\p{bidiclass}');
    Error('\P{bidiclass}');
    Error('\p{bc}');
    Error('\P{bc}');
    Error('\p{Bidi_Class=	:=ARABIC_Letter}');
    Error('\P{Bidi_Class=	:=ARABIC_Letter}');
    Expect(1, 126719, '\p{Bidi_Class=:\AArabic_Letter\z:}', "");;
    Expect(0, 126720, '\p{Bidi_Class=:\AArabic_Letter\z:}', "");;
    Expect(1, 126719, '\p{Bidi_Class=arabicletter}', "");
    Expect(0, 126719, '\p{^Bidi_Class=arabicletter}', "");
    Expect(0, 126719, '\P{Bidi_Class=arabicletter}', "");
    Expect(1, 126719, '\P{^Bidi_Class=arabicletter}', "");
    Expect(0, 126720, '\p{Bidi_Class=arabicletter}', "");
    Expect(1, 126720, '\p{^Bidi_Class=arabicletter}', "");
    Expect(1, 126720, '\P{Bidi_Class=arabicletter}', "");
    Expect(0, 126720, '\P{^Bidi_Class=arabicletter}', "");
    Expect(1, 126719, '\p{Bidi_Class=:\Aarabicletter\z:}', "");;
    Expect(0, 126720, '\p{Bidi_Class=:\Aarabicletter\z:}', "");;
    Expect(1, 126719, '\p{Bidi_Class= -arabic_letter}', "");
    Expect(0, 126719, '\p{^Bidi_Class= -arabic_letter}', "");
    Expect(0, 126719, '\P{Bidi_Class= -arabic_letter}', "");
    Expect(1, 126719, '\P{^Bidi_Class= -arabic_letter}', "");
    Expect(0, 126720, '\p{Bidi_Class= -arabic_letter}', "");
    Expect(1, 126720, '\p{^Bidi_Class= -arabic_letter}', "");
    Expect(1, 126720, '\P{Bidi_Class= -arabic_letter}', "");
    Expect(0, 126720, '\P{^Bidi_Class= -arabic_letter}', "");
    Error('\p{Bc= AL/a/}');
    Error('\P{Bc= AL/a/}');
    Expect(1, 126719, '\p{Bc=:\AAL\z:}', "");;
    Expect(0, 126720, '\p{Bc=:\AAL\z:}', "");;
    Expect(1, 126719, '\p{Bc=al}', "");
    Expect(0, 126719, '\p{^Bc=al}', "");
    Expect(0, 126719, '\P{Bc=al}', "");
    Expect(1, 126719, '\P{^Bc=al}', "");
    Expect(0, 126720, '\p{Bc=al}', "");
    Expect(1, 126720, '\p{^Bc=al}', "");
    Expect(1, 126720, '\P{Bc=al}', "");
    Expect(0, 126720, '\P{^Bc=al}', "");
    Expect(1, 126719, '\p{Bc=:\Aal\z:}', "");;
    Expect(0, 126720, '\p{Bc=:\Aal\z:}', "");;
    Expect(1, 126719, '\p{Bc=- al}', "");
    Expect(0, 126719, '\p{^Bc=- al}', "");
    Expect(0, 126719, '\P{Bc=- al}', "");
    Expect(1, 126719, '\P{^Bc=- al}', "");
    Expect(0, 126720, '\p{Bc=- al}', "");
    Expect(1, 126720, '\p{^Bc=- al}', "");
    Expect(1, 126720, '\P{Bc=- al}', "");
    Expect(0, 126720, '\P{^Bc=- al}', "");
    Error('\p{Is_Bidi_Class=:=	 ARABIC_letter}');
    Error('\P{Is_Bidi_Class=:=	 ARABIC_letter}');
    Expect(1, 126719, '\p{Is_Bidi_Class=arabicletter}', "");
    Expect(0, 126719, '\p{^Is_Bidi_Class=arabicletter}', "");
    Expect(0, 126719, '\P{Is_Bidi_Class=arabicletter}', "");
    Expect(1, 126719, '\P{^Is_Bidi_Class=arabicletter}', "");
    Expect(0, 126720, '\p{Is_Bidi_Class=arabicletter}', "");
    Expect(1, 126720, '\p{^Is_Bidi_Class=arabicletter}', "");
    Expect(1, 126720, '\P{Is_Bidi_Class=arabicletter}', "");
    Expect(0, 126720, '\P{^Is_Bidi_Class=arabicletter}', "");
    Expect(1, 126719, '\p{Is_Bidi_Class= 	ARABIC_Letter}', "");
    Expect(0, 126719, '\p{^Is_Bidi_Class= 	ARABIC_Letter}', "");
    Expect(0, 126719, '\P{Is_Bidi_Class= 	ARABIC_Letter}', "");
    Expect(1, 126719, '\P{^Is_Bidi_Class= 	ARABIC_Letter}', "");
    Expect(0, 126720, '\p{Is_Bidi_Class= 	ARABIC_Letter}', "");
    Expect(1, 126720, '\p{^Is_Bidi_Class= 	ARABIC_Letter}', "");
    Expect(1, 126720, '\P{Is_Bidi_Class= 	ARABIC_Letter}', "");
    Expect(0, 126720, '\P{^Is_Bidi_Class= 	ARABIC_Letter}', "");
    Error('\p{Is_Bc=:=-AL}');
    Error('\P{Is_Bc=:=-AL}');
    Expect(1, 126719, '\p{Is_Bc=al}', "");
    Expect(0, 126719, '\p{^Is_Bc=al}', "");
    Expect(0, 126719, '\P{Is_Bc=al}', "");
    Expect(1, 126719, '\P{^Is_Bc=al}', "");
    Expect(0, 126720, '\p{Is_Bc=al}', "");
    Expect(1, 126720, '\p{^Is_Bc=al}', "");
    Expect(1, 126720, '\P{Is_Bc=al}', "");
    Expect(0, 126720, '\P{^Is_Bc=al}', "");
    Expect(1, 126719, '\p{Is_Bc:  	al}', "");
    Expect(0, 126719, '\p{^Is_Bc:  	al}', "");
    Expect(0, 126719, '\P{Is_Bc:  	al}', "");
    Expect(1, 126719, '\P{^Is_Bc:  	al}', "");
    Expect(0, 126720, '\p{Is_Bc:  	al}', "");
    Expect(1, 126720, '\p{^Is_Bc:  	al}', "");
    Expect(1, 126720, '\P{Is_Bc:  	al}', "");
    Expect(0, 126720, '\P{^Is_Bc:  	al}', "");
    Error('\p{Bidi_Class=_ arabic_NUMBER/a/}');
    Error('\P{Bidi_Class=_ arabic_NUMBER/a/}');
    Expect(1, 69246, '\p{Bidi_Class=:\AArabic_Number\z:}', "");;
    Expect(0, 69247, '\p{Bidi_Class=:\AArabic_Number\z:}', "");;
    Expect(1, 69246, '\p{Bidi_Class=arabicnumber}', "");
    Expect(0, 69246, '\p{^Bidi_Class=arabicnumber}', "");
    Expect(0, 69246, '\P{Bidi_Class=arabicnumber}', "");
    Expect(1, 69246, '\P{^Bidi_Class=arabicnumber}', "");
    Expect(0, 69247, '\p{Bidi_Class=arabicnumber}', "");
    Expect(1, 69247, '\p{^Bidi_Class=arabicnumber}', "");
    Expect(1, 69247, '\P{Bidi_Class=arabicnumber}', "");
    Expect(0, 69247, '\P{^Bidi_Class=arabicnumber}', "");
    Expect(1, 69246, '\p{Bidi_Class=:\Aarabicnumber\z:}', "");;
    Expect(0, 69247, '\p{Bidi_Class=:\Aarabicnumber\z:}', "");;
    Expect(1, 69246, '\p{Bidi_Class=arabic_Number}', "");
    Expect(0, 69246, '\p{^Bidi_Class=arabic_Number}', "");
    Expect(0, 69246, '\P{Bidi_Class=arabic_Number}', "");
    Expect(1, 69246, '\P{^Bidi_Class=arabic_Number}', "");
    Expect(0, 69247, '\p{Bidi_Class=arabic_Number}', "");
    Expect(1, 69247, '\p{^Bidi_Class=arabic_Number}', "");
    Expect(1, 69247, '\P{Bidi_Class=arabic_Number}', "");
    Expect(0, 69247, '\P{^Bidi_Class=arabic_Number}', "");
    Error('\p{Bc=-	AN/a/}');
    Error('\P{Bc=-	AN/a/}');
    Expect(1, 69246, '\p{Bc=:\AAN\z:}', "");;
    Expect(0, 69247, '\p{Bc=:\AAN\z:}', "");;
    Expect(1, 69246, '\p{Bc=an}', "");
    Expect(0, 69246, '\p{^Bc=an}', "");
    Expect(0, 69246, '\P{Bc=an}', "");
    Expect(1, 69246, '\P{^Bc=an}', "");
    Expect(0, 69247, '\p{Bc=an}', "");
    Expect(1, 69247, '\p{^Bc=an}', "");
    Expect(1, 69247, '\P{Bc=an}', "");
    Expect(0, 69247, '\P{^Bc=an}', "");
    Expect(1, 69246, '\p{Bc=:\Aan\z:}', "");;
    Expect(0, 69247, '\p{Bc=:\Aan\z:}', "");;
    Expect(1, 69246, '\p{Bc:   __an}', "");
    Expect(0, 69246, '\p{^Bc:   __an}', "");
    Expect(0, 69246, '\P{Bc:   __an}', "");
    Expect(1, 69246, '\P{^Bc:   __an}', "");
    Expect(0, 69247, '\p{Bc:   __an}', "");
    Expect(1, 69247, '\p{^Bc:   __an}', "");
    Expect(1, 69247, '\P{Bc:   __an}', "");
    Expect(0, 69247, '\P{^Bc:   __an}', "");
    Error('\p{Is_Bidi_Class=/a/_ arabic_Number}');
    Error('\P{Is_Bidi_Class=/a/_ arabic_Number}');
    Expect(1, 69246, '\p{Is_Bidi_Class=arabicnumber}', "");
    Expect(0, 69246, '\p{^Is_Bidi_Class=arabicnumber}', "");
    Expect(0, 69246, '\P{Is_Bidi_Class=arabicnumber}', "");
    Expect(1, 69246, '\P{^Is_Bidi_Class=arabicnumber}', "");
    Expect(0, 69247, '\p{Is_Bidi_Class=arabicnumber}', "");
    Expect(1, 69247, '\p{^Is_Bidi_Class=arabicnumber}', "");
    Expect(1, 69247, '\P{Is_Bidi_Class=arabicnumber}', "");
    Expect(0, 69247, '\P{^Is_Bidi_Class=arabicnumber}', "");
    Expect(1, 69246, '\p{Is_Bidi_Class:   -arabic_Number}', "");
    Expect(0, 69246, '\p{^Is_Bidi_Class:   -arabic_Number}', "");
    Expect(0, 69246, '\P{Is_Bidi_Class:   -arabic_Number}', "");
    Expect(1, 69246, '\P{^Is_Bidi_Class:   -arabic_Number}', "");
    Expect(0, 69247, '\p{Is_Bidi_Class:   -arabic_Number}', "");
    Expect(1, 69247, '\p{^Is_Bidi_Class:   -arabic_Number}', "");
    Expect(1, 69247, '\P{Is_Bidi_Class:   -arabic_Number}', "");
    Expect(0, 69247, '\P{^Is_Bidi_Class:   -arabic_Number}', "");
    Error('\p{Is_Bc=	/a/an}');
    Error('\P{Is_Bc=	/a/an}');
    Expect(1, 69246, '\p{Is_Bc=an}', "");
    Expect(0, 69246, '\p{^Is_Bc=an}', "");
    Expect(0, 69246, '\P{Is_Bc=an}', "");
    Expect(1, 69246, '\P{^Is_Bc=an}', "");
    Expect(0, 69247, '\p{Is_Bc=an}', "");
    Expect(1, 69247, '\p{^Is_Bc=an}', "");
    Expect(1, 69247, '\P{Is_Bc=an}', "");
    Expect(0, 69247, '\P{^Is_Bc=an}', "");
    Expect(1, 69246, '\p{Is_Bc=_AN}', "");
    Expect(0, 69246, '\p{^Is_Bc=_AN}', "");
    Expect(0, 69246, '\P{Is_Bc=_AN}', "");
    Expect(1, 69246, '\P{^Is_Bc=_AN}', "");
    Expect(0, 69247, '\p{Is_Bc=_AN}', "");
    Expect(1, 69247, '\p{^Is_Bc=_AN}', "");
    Expect(1, 69247, '\P{Is_Bc=_AN}', "");
    Expect(0, 69247, '\P{^Is_Bc=_AN}', "");
    Error('\p{Bidi_Class=/a/  Paragraph_Separator}');
    Error('\P{Bidi_Class=/a/  Paragraph_Separator}');
    Expect(1, 8233, '\p{Bidi_Class=:\AParagraph_Separator\z:}', "");;
    Expect(0, 8234, '\p{Bidi_Class=:\AParagraph_Separator\z:}', "");;
    Expect(1, 8233, '\p{Bidi_Class=paragraphseparator}', "");
    Expect(0, 8233, '\p{^Bidi_Class=paragraphseparator}', "");
    Expect(0, 8233, '\P{Bidi_Class=paragraphseparator}', "");
    Expect(1, 8233, '\P{^Bidi_Class=paragraphseparator}', "");
    Expect(0, 8234, '\p{Bidi_Class=paragraphseparator}', "");
    Expect(1, 8234, '\p{^Bidi_Class=paragraphseparator}', "");
    Expect(1, 8234, '\P{Bidi_Class=paragraphseparator}', "");
    Expect(0, 8234, '\P{^Bidi_Class=paragraphseparator}', "");
    Expect(1, 8233, '\p{Bidi_Class=:\Aparagraphseparator\z:}', "");;
    Expect(0, 8234, '\p{Bidi_Class=:\Aparagraphseparator\z:}', "");;
    Expect(1, 8233, '\p{Bidi_Class:   		Paragraph_separator}', "");
    Expect(0, 8233, '\p{^Bidi_Class:   		Paragraph_separator}', "");
    Expect(0, 8233, '\P{Bidi_Class:   		Paragraph_separator}', "");
    Expect(1, 8233, '\P{^Bidi_Class:   		Paragraph_separator}', "");
    Expect(0, 8234, '\p{Bidi_Class:   		Paragraph_separator}', "");
    Expect(1, 8234, '\p{^Bidi_Class:   		Paragraph_separator}', "");
    Expect(1, 8234, '\P{Bidi_Class:   		Paragraph_separator}', "");
    Expect(0, 8234, '\P{^Bidi_Class:   		Paragraph_separator}', "");
    Error('\p{Bc=/a/B}');
    Error('\P{Bc=/a/B}');
    Expect(1, 8233, '\p{Bc=:\AB\z:}', "");;
    Expect(0, 8234, '\p{Bc=:\AB\z:}', "");;
    Expect(1, 8233, '\p{Bc=b}', "");
    Expect(0, 8233, '\p{^Bc=b}', "");
    Expect(0, 8233, '\P{Bc=b}', "");
    Expect(1, 8233, '\P{^Bc=b}', "");
    Expect(0, 8234, '\p{Bc=b}', "");
    Expect(1, 8234, '\p{^Bc=b}', "");
    Expect(1, 8234, '\P{Bc=b}', "");
    Expect(0, 8234, '\P{^Bc=b}', "");
    Expect(1, 8233, '\p{Bc=:\Ab\z:}', "");;
    Expect(0, 8234, '\p{Bc=:\Ab\z:}', "");;
    Expect(1, 8233, '\p{Bc=	B}', "");
    Expect(0, 8233, '\p{^Bc=	B}', "");
    Expect(0, 8233, '\P{Bc=	B}', "");
    Expect(1, 8233, '\P{^Bc=	B}', "");
    Expect(0, 8234, '\p{Bc=	B}', "");
    Expect(1, 8234, '\p{^Bc=	B}', "");
    Expect(1, 8234, '\P{Bc=	B}', "");
    Expect(0, 8234, '\P{^Bc=	B}', "");
    Error('\p{Is_Bidi_Class=_Paragraph_SEPARATOR/a/}');
    Error('\P{Is_Bidi_Class=_Paragraph_SEPARATOR/a/}');
    Expect(1, 8233, '\p{Is_Bidi_Class: paragraphseparator}', "");
    Expect(0, 8233, '\p{^Is_Bidi_Class: paragraphseparator}', "");
    Expect(0, 8233, '\P{Is_Bidi_Class: paragraphseparator}', "");
    Expect(1, 8233, '\P{^Is_Bidi_Class: paragraphseparator}', "");
    Expect(0, 8234, '\p{Is_Bidi_Class: paragraphseparator}', "");
    Expect(1, 8234, '\p{^Is_Bidi_Class: paragraphseparator}', "");
    Expect(1, 8234, '\P{Is_Bidi_Class: paragraphseparator}', "");
    Expect(0, 8234, '\P{^Is_Bidi_Class: paragraphseparator}', "");
    Expect(1, 8233, '\p{Is_Bidi_Class=PARAGRAPH_separator}', "");
    Expect(0, 8233, '\p{^Is_Bidi_Class=PARAGRAPH_separator}', "");
    Expect(0, 8233, '\P{Is_Bidi_Class=PARAGRAPH_separator}', "");
    Expect(1, 8233, '\P{^Is_Bidi_Class=PARAGRAPH_separator}', "");
    Expect(0, 8234, '\p{Is_Bidi_Class=PARAGRAPH_separator}', "");
    Expect(1, 8234, '\p{^Is_Bidi_Class=PARAGRAPH_separator}', "");
    Expect(1, 8234, '\P{Is_Bidi_Class=PARAGRAPH_separator}', "");
    Expect(0, 8234, '\P{^Is_Bidi_Class=PARAGRAPH_separator}', "");
    Error('\p{Is_Bc=:=  B}');
    Error('\P{Is_Bc=:=  B}');
    Expect(1, 8233, '\p{Is_Bc=b}', "");
    Expect(0, 8233, '\p{^Is_Bc=b}', "");
    Expect(0, 8233, '\P{Is_Bc=b}', "");
    Expect(1, 8233, '\P{^Is_Bc=b}', "");
    Expect(0, 8234, '\p{Is_Bc=b}', "");
    Expect(1, 8234, '\p{^Is_Bc=b}', "");
    Expect(1, 8234, '\P{Is_Bc=b}', "");
    Expect(0, 8234, '\P{^Is_Bc=b}', "");
    Expect(1, 8233, '\p{Is_Bc=_B}', "");
    Expect(0, 8233, '\p{^Is_Bc=_B}', "");
    Expect(0, 8233, '\P{Is_Bc=_B}', "");
    Expect(1, 8233, '\P{^Is_Bc=_B}', "");
    Expect(0, 8234, '\p{Is_Bc=_B}', "");
    Expect(1, 8234, '\p{^Is_Bc=_B}', "");
    Expect(1, 8234, '\P{Is_Bc=_B}', "");
    Expect(0, 8234, '\P{^Is_Bc=_B}', "");
    Error('\p{Bidi_Class=:=__boundary_NEUTRAL}');
    Error('\P{Bidi_Class=:=__boundary_NEUTRAL}');
    Expect(1, 921599, '\p{Bidi_Class=:\ABoundary_Neutral\z:}', "");;
    Expect(0, 1114109, '\p{Bidi_Class=:\ABoundary_Neutral\z:}', "");;
    Expect(1, 921599, '\p{Bidi_Class=boundaryneutral}', "");
    Expect(0, 921599, '\p{^Bidi_Class=boundaryneutral}', "");
    Expect(0, 921599, '\P{Bidi_Class=boundaryneutral}', "");
    Expect(1, 921599, '\P{^Bidi_Class=boundaryneutral}', "");
    Expect(0, 1114109, '\p{Bidi_Class=boundaryneutral}', "");
    Expect(1, 1114109, '\p{^Bidi_Class=boundaryneutral}', "");
    Expect(1, 1114109, '\P{Bidi_Class=boundaryneutral}', "");
    Expect(0, 1114109, '\P{^Bidi_Class=boundaryneutral}', "");
    Expect(1, 921599, '\p{Bidi_Class=:\Aboundaryneutral\z:}', "");;
    Expect(0, 1114109, '\p{Bidi_Class=:\Aboundaryneutral\z:}', "");;
    Expect(1, 921599, '\p{Bidi_Class=	 BOUNDARY_Neutral}', "");
    Expect(0, 921599, '\p{^Bidi_Class=	 BOUNDARY_Neutral}', "");
    Expect(0, 921599, '\P{Bidi_Class=	 BOUNDARY_Neutral}', "");
    Expect(1, 921599, '\P{^Bidi_Class=	 BOUNDARY_Neutral}', "");
    Expect(0, 1114109, '\p{Bidi_Class=	 BOUNDARY_Neutral}', "");
    Expect(1, 1114109, '\p{^Bidi_Class=	 BOUNDARY_Neutral}', "");
    Expect(1, 1114109, '\P{Bidi_Class=	 BOUNDARY_Neutral}', "");
    Expect(0, 1114109, '\P{^Bidi_Class=	 BOUNDARY_Neutral}', "");
    Error('\p{Bc= /a/BN}');
    Error('\P{Bc= /a/BN}');
    Expect(1, 921599, '\p{Bc=:\ABN\z:}', "");;
    Expect(0, 1114109, '\p{Bc=:\ABN\z:}', "");;
    Expect(1, 921599, '\p{Bc=bn}', "");
    Expect(0, 921599, '\p{^Bc=bn}', "");
    Expect(0, 921599, '\P{Bc=bn}', "");
    Expect(1, 921599, '\P{^Bc=bn}', "");
    Expect(0, 1114109, '\p{Bc=bn}', "");
    Expect(1, 1114109, '\p{^Bc=bn}', "");
    Expect(1, 1114109, '\P{Bc=bn}', "");
    Expect(0, 1114109, '\P{^Bc=bn}', "");
    Expect(1, 921599, '\p{Bc=:\Abn\z:}', "");;
    Expect(0, 1114109, '\p{Bc=:\Abn\z:}', "");;
    Expect(1, 921599, '\p{Bc=-BN}', "");
    Expect(0, 921599, '\p{^Bc=-BN}', "");
    Expect(0, 921599, '\P{Bc=-BN}', "");
    Expect(1, 921599, '\P{^Bc=-BN}', "");
    Expect(0, 1114109, '\p{Bc=-BN}', "");
    Expect(1, 1114109, '\p{^Bc=-BN}', "");
    Expect(1, 1114109, '\P{Bc=-BN}', "");
    Expect(0, 1114109, '\P{^Bc=-BN}', "");
    Error('\p{Is_Bidi_Class= Boundary_Neutral:=}');
    Error('\P{Is_Bidi_Class= Boundary_Neutral:=}');
    Expect(1, 921599, '\p{Is_Bidi_Class=boundaryneutral}', "");
    Expect(0, 921599, '\p{^Is_Bidi_Class=boundaryneutral}', "");
    Expect(0, 921599, '\P{Is_Bidi_Class=boundaryneutral}', "");
    Expect(1, 921599, '\P{^Is_Bidi_Class=boundaryneutral}', "");
    Expect(0, 1114109, '\p{Is_Bidi_Class=boundaryneutral}', "");
    Expect(1, 1114109, '\p{^Is_Bidi_Class=boundaryneutral}', "");
    Expect(1, 1114109, '\P{Is_Bidi_Class=boundaryneutral}', "");
    Expect(0, 1114109, '\P{^Is_Bidi_Class=boundaryneutral}', "");
    Expect(1, 921599, '\p{Is_Bidi_Class=	boundary_Neutral}', "");
    Expect(0, 921599, '\p{^Is_Bidi_Class=	boundary_Neutral}', "");
    Expect(0, 921599, '\P{Is_Bidi_Class=	boundary_Neutral}', "");
    Expect(1, 921599, '\P{^Is_Bidi_Class=	boundary_Neutral}', "");
    Expect(0, 1114109, '\p{Is_Bidi_Class=	boundary_Neutral}', "");
    Expect(1, 1114109, '\p{^Is_Bidi_Class=	boundary_Neutral}', "");
    Expect(1, 1114109, '\P{Is_Bidi_Class=	boundary_Neutral}', "");
    Expect(0, 1114109, '\P{^Is_Bidi_Class=	boundary_Neutral}', "");
    Error('\p{Is_Bc=-:=BN}');
    Error('\P{Is_Bc=-:=BN}');
    Expect(1, 921599, '\p{Is_Bc=bn}', "");
    Expect(0, 921599, '\p{^Is_Bc=bn}', "");
    Expect(0, 921599, '\P{Is_Bc=bn}', "");
    Expect(1, 921599, '\P{^Is_Bc=bn}', "");
    Expect(0, 1114109, '\p{Is_Bc=bn}', "");
    Expect(1, 1114109, '\p{^Is_Bc=bn}', "");
    Expect(1, 1114109, '\P{Is_Bc=bn}', "");
    Expect(0, 1114109, '\P{^Is_Bc=bn}', "");
    Expect(1, 921599, '\p{Is_Bc= -BN}', "");
    Expect(0, 921599, '\p{^Is_Bc= -BN}', "");
    Expect(0, 921599, '\P{Is_Bc= -BN}', "");
    Expect(1, 921599, '\P{^Is_Bc= -BN}', "");
    Expect(0, 1114109, '\p{Is_Bc= -BN}', "");
    Expect(1, 1114109, '\p{^Is_Bc= -BN}', "");
    Expect(1, 1114109, '\P{Is_Bc= -BN}', "");
    Expect(0, 1114109, '\P{^Is_Bc= -BN}', "");
    Error('\p{Bidi_Class=-:=Common_Separator}');
    Error('\P{Bidi_Class=-:=Common_Separator}');
    Expect(1, 65306, '\p{Bidi_Class=:\ACommon_Separator\z:}', "");;
    Expect(0, 65307, '\p{Bidi_Class=:\ACommon_Separator\z:}', "");;
    Expect(1, 65306, '\p{Bidi_Class=commonseparator}', "");
    Expect(0, 65306, '\p{^Bidi_Class=commonseparator}', "");
    Expect(0, 65306, '\P{Bidi_Class=commonseparator}', "");
    Expect(1, 65306, '\P{^Bidi_Class=commonseparator}', "");
    Expect(0, 65307, '\p{Bidi_Class=commonseparator}', "");
    Expect(1, 65307, '\p{^Bidi_Class=commonseparator}', "");
    Expect(1, 65307, '\P{Bidi_Class=commonseparator}', "");
    Expect(0, 65307, '\P{^Bidi_Class=commonseparator}', "");
    Expect(1, 65306, '\p{Bidi_Class=:\Acommonseparator\z:}', "");;
    Expect(0, 65307, '\p{Bidi_Class=:\Acommonseparator\z:}', "");;
    Expect(1, 65306, '\p{Bidi_Class:   --Common_Separator}', "");
    Expect(0, 65306, '\p{^Bidi_Class:   --Common_Separator}', "");
    Expect(0, 65306, '\P{Bidi_Class:   --Common_Separator}', "");
    Expect(1, 65306, '\P{^Bidi_Class:   --Common_Separator}', "");
    Expect(0, 65307, '\p{Bidi_Class:   --Common_Separator}', "");
    Expect(1, 65307, '\p{^Bidi_Class:   --Common_Separator}', "");
    Expect(1, 65307, '\P{Bidi_Class:   --Common_Separator}', "");
    Expect(0, 65307, '\P{^Bidi_Class:   --Common_Separator}', "");
    Error('\p{Bc=	CS:=}');
    Error('\P{Bc=	CS:=}');
    Expect(1, 65306, '\p{Bc=:\ACS\z:}', "");;
    Expect(0, 65307, '\p{Bc=:\ACS\z:}', "");;
    Expect(1, 65306, '\p{Bc:cs}', "");
    Expect(0, 65306, '\p{^Bc:cs}', "");
    Expect(0, 65306, '\P{Bc:cs}', "");
    Expect(1, 65306, '\P{^Bc:cs}', "");
    Expect(0, 65307, '\p{Bc:cs}', "");
    Expect(1, 65307, '\p{^Bc:cs}', "");
    Expect(1, 65307, '\P{Bc:cs}', "");
    Expect(0, 65307, '\P{^Bc:cs}', "");
    Expect(1, 65306, '\p{Bc=:\Acs\z:}', "");;
    Expect(0, 65307, '\p{Bc=:\Acs\z:}', "");;
    Error('\p{Is_Bidi_Class=/a/ _Common_separator}');
    Error('\P{Is_Bidi_Class=/a/ _Common_separator}');
    Expect(1, 65306, '\p{Is_Bidi_Class=commonseparator}', "");
    Expect(0, 65306, '\p{^Is_Bidi_Class=commonseparator}', "");
    Expect(0, 65306, '\P{Is_Bidi_Class=commonseparator}', "");
    Expect(1, 65306, '\P{^Is_Bidi_Class=commonseparator}', "");
    Expect(0, 65307, '\p{Is_Bidi_Class=commonseparator}', "");
    Expect(1, 65307, '\p{^Is_Bidi_Class=commonseparator}', "");
    Expect(1, 65307, '\P{Is_Bidi_Class=commonseparator}', "");
    Expect(0, 65307, '\P{^Is_Bidi_Class=commonseparator}', "");
    Expect(1, 65306, '\p{Is_Bidi_Class=- Common_separator}', "");
    Expect(0, 65306, '\p{^Is_Bidi_Class=- Common_separator}', "");
    Expect(0, 65306, '\P{Is_Bidi_Class=- Common_separator}', "");
    Expect(1, 65306, '\P{^Is_Bidi_Class=- Common_separator}', "");
    Expect(0, 65307, '\p{Is_Bidi_Class=- Common_separator}', "");
    Expect(1, 65307, '\p{^Is_Bidi_Class=- Common_separator}', "");
    Expect(1, 65307, '\P{Is_Bidi_Class=- Common_separator}', "");
    Expect(0, 65307, '\P{^Is_Bidi_Class=- Common_separator}', "");
    Error('\p{Is_Bc=_CS:=}');
    Error('\P{Is_Bc=_CS:=}');
    Expect(1, 65306, '\p{Is_Bc=cs}', "");
    Expect(0, 65306, '\p{^Is_Bc=cs}', "");
    Expect(0, 65306, '\P{Is_Bc=cs}', "");
    Expect(1, 65306, '\P{^Is_Bc=cs}', "");
    Expect(0, 65307, '\p{Is_Bc=cs}', "");
    Expect(1, 65307, '\p{^Is_Bc=cs}', "");
    Expect(1, 65307, '\P{Is_Bc=cs}', "");
    Expect(0, 65307, '\P{^Is_Bc=cs}', "");
    Expect(1, 65306, '\p{Is_Bc=_cs}', "");
    Expect(0, 65306, '\p{^Is_Bc=_cs}', "");
    Expect(0, 65306, '\P{Is_Bc=_cs}', "");
    Expect(1, 65306, '\P{^Is_Bc=_cs}', "");
    Expect(0, 65307, '\p{Is_Bc=_cs}', "");
    Expect(1, 65307, '\p{^Is_Bc=_cs}', "");
    Expect(1, 65307, '\P{Is_Bc=_cs}', "");
    Expect(0, 65307, '\P{^Is_Bc=_cs}', "");
    Error('\p{Bidi_Class=-/a/European_NUMBER}');
    Error('\P{Bidi_Class=-/a/European_NUMBER}');
    Expect(1, 130041, '\p{Bidi_Class=:\AEuropean_Number\z:}', "");;
    Expect(0, 130042, '\p{Bidi_Class=:\AEuropean_Number\z:}', "");;
    Expect(1, 130041, '\p{Bidi_Class=europeannumber}', "");
    Expect(0, 130041, '\p{^Bidi_Class=europeannumber}', "");
    Expect(0, 130041, '\P{Bidi_Class=europeannumber}', "");
    Expect(1, 130041, '\P{^Bidi_Class=europeannumber}', "");
    Expect(0, 130042, '\p{Bidi_Class=europeannumber}', "");
    Expect(1, 130042, '\p{^Bidi_Class=europeannumber}', "");
    Expect(1, 130042, '\P{Bidi_Class=europeannumber}', "");
    Expect(0, 130042, '\P{^Bidi_Class=europeannumber}', "");
    Expect(1, 130041, '\p{Bidi_Class=:\Aeuropeannumber\z:}', "");;
    Expect(0, 130042, '\p{Bidi_Class=:\Aeuropeannumber\z:}', "");;
    Expect(1, 130041, '\p{Bidi_Class=_-EUROPEAN_Number}', "");
    Expect(0, 130041, '\p{^Bidi_Class=_-EUROPEAN_Number}', "");
    Expect(0, 130041, '\P{Bidi_Class=_-EUROPEAN_Number}', "");
    Expect(1, 130041, '\P{^Bidi_Class=_-EUROPEAN_Number}', "");
    Expect(0, 130042, '\p{Bidi_Class=_-EUROPEAN_Number}', "");
    Expect(1, 130042, '\p{^Bidi_Class=_-EUROPEAN_Number}', "");
    Expect(1, 130042, '\P{Bidi_Class=_-EUROPEAN_Number}', "");
    Expect(0, 130042, '\P{^Bidi_Class=_-EUROPEAN_Number}', "");
    Error('\p{Bc=--en/a/}');
    Error('\P{Bc=--en/a/}');
    Expect(1, 130041, '\p{Bc=:\AEN\z:}', "");;
    Expect(0, 130042, '\p{Bc=:\AEN\z:}', "");;
    Expect(1, 130041, '\p{Bc=en}', "");
    Expect(0, 130041, '\p{^Bc=en}', "");
    Expect(0, 130041, '\P{Bc=en}', "");
    Expect(1, 130041, '\P{^Bc=en}', "");
    Expect(0, 130042, '\p{Bc=en}', "");
    Expect(1, 130042, '\p{^Bc=en}', "");
    Expect(1, 130042, '\P{Bc=en}', "");
    Expect(0, 130042, '\P{^Bc=en}', "");
    Expect(1, 130041, '\p{Bc=:\Aen\z:}', "");;
    Expect(0, 130042, '\p{Bc=:\Aen\z:}', "");;
    Expect(1, 130041, '\p{Bc=	EN}', "");
    Expect(0, 130041, '\p{^Bc=	EN}', "");
    Expect(0, 130041, '\P{Bc=	EN}', "");
    Expect(1, 130041, '\P{^Bc=	EN}', "");
    Expect(0, 130042, '\p{Bc=	EN}', "");
    Expect(1, 130042, '\p{^Bc=	EN}', "");
    Expect(1, 130042, '\P{Bc=	EN}', "");
    Expect(0, 130042, '\P{^Bc=	EN}', "");
    Error('\p{Is_Bidi_Class=	-European_number:=}');
    Error('\P{Is_Bidi_Class=	-European_number:=}');
    Expect(1, 130041, '\p{Is_Bidi_Class:europeannumber}', "");
    Expect(0, 130041, '\p{^Is_Bidi_Class:europeannumber}', "");
    Expect(0, 130041, '\P{Is_Bidi_Class:europeannumber}', "");
    Expect(1, 130041, '\P{^Is_Bidi_Class:europeannumber}', "");
    Expect(0, 130042, '\p{Is_Bidi_Class:europeannumber}', "");
    Expect(1, 130042, '\p{^Is_Bidi_Class:europeannumber}', "");
    Expect(1, 130042, '\P{Is_Bidi_Class:europeannumber}', "");
    Expect(0, 130042, '\P{^Is_Bidi_Class:europeannumber}', "");
    Expect(1, 130041, '\p{Is_Bidi_Class=- European_Number}', "");
    Expect(0, 130041, '\p{^Is_Bidi_Class=- European_Number}', "");
    Expect(0, 130041, '\P{Is_Bidi_Class=- European_Number}', "");
    Expect(1, 130041, '\P{^Is_Bidi_Class=- European_Number}', "");
    Expect(0, 130042, '\p{Is_Bidi_Class=- European_Number}', "");
    Expect(1, 130042, '\p{^Is_Bidi_Class=- European_Number}', "");
    Expect(1, 130042, '\P{Is_Bidi_Class=- European_Number}', "");
    Expect(0, 130042, '\P{^Is_Bidi_Class=- European_Number}', "");
    Error('\p{Is_Bc=	/a/EN}');
    Error('\P{Is_Bc=	/a/EN}');
    Expect(1, 130041, '\p{Is_Bc=en}', "");
    Expect(0, 130041, '\p{^Is_Bc=en}', "");
    Expect(0, 130041, '\P{Is_Bc=en}', "");
    Expect(1, 130041, '\P{^Is_Bc=en}', "");
    Expect(0, 130042, '\p{Is_Bc=en}', "");
    Expect(1, 130042, '\p{^Is_Bc=en}', "");
    Expect(1, 130042, '\P{Is_Bc=en}', "");
    Expect(0, 130042, '\P{^Is_Bc=en}', "");
    Expect(1, 130041, '\p{Is_Bc=_-EN}', "");
    Expect(0, 130041, '\p{^Is_Bc=_-EN}', "");
    Expect(0, 130041, '\P{Is_Bc=_-EN}', "");
    Expect(1, 130041, '\P{^Is_Bc=_-EN}', "");
    Expect(0, 130042, '\p{Is_Bc=_-EN}', "");
    Expect(1, 130042, '\p{^Is_Bc=_-EN}', "");
    Expect(1, 130042, '\P{Is_Bc=_-EN}', "");
    Expect(0, 130042, '\P{^Is_Bc=_-EN}', "");
    Error('\p{Bidi_Class=/a/_-European_Separator}');
    Error('\P{Bidi_Class=/a/_-European_Separator}');
    Expect(1, 65293, '\p{Bidi_Class=:\AEuropean_Separator\z:}', "");;
    Expect(0, 65294, '\p{Bidi_Class=:\AEuropean_Separator\z:}', "");;
    Expect(1, 65293, '\p{Bidi_Class=europeanseparator}', "");
    Expect(0, 65293, '\p{^Bidi_Class=europeanseparator}', "");
    Expect(0, 65293, '\P{Bidi_Class=europeanseparator}', "");
    Expect(1, 65293, '\P{^Bidi_Class=europeanseparator}', "");
    Expect(0, 65294, '\p{Bidi_Class=europeanseparator}', "");
    Expect(1, 65294, '\p{^Bidi_Class=europeanseparator}', "");
    Expect(1, 65294, '\P{Bidi_Class=europeanseparator}', "");
    Expect(0, 65294, '\P{^Bidi_Class=europeanseparator}', "");
    Expect(1, 65293, '\p{Bidi_Class=:\Aeuropeanseparator\z:}', "");;
    Expect(0, 65294, '\p{Bidi_Class=:\Aeuropeanseparator\z:}', "");;
    Expect(1, 65293, '\p{Bidi_Class=	-european_separator}', "");
    Expect(0, 65293, '\p{^Bidi_Class=	-european_separator}', "");
    Expect(0, 65293, '\P{Bidi_Class=	-european_separator}', "");
    Expect(1, 65293, '\P{^Bidi_Class=	-european_separator}', "");
    Expect(0, 65294, '\p{Bidi_Class=	-european_separator}', "");
    Expect(1, 65294, '\p{^Bidi_Class=	-european_separator}', "");
    Expect(1, 65294, '\P{Bidi_Class=	-european_separator}', "");
    Expect(0, 65294, '\P{^Bidi_Class=	-european_separator}', "");
    Error('\p{Bc:-:=ES}');
    Error('\P{Bc:-:=ES}');
    Expect(1, 65293, '\p{Bc=:\AES\z:}', "");;
    Expect(0, 65294, '\p{Bc=:\AES\z:}', "");;
    Expect(1, 65293, '\p{Bc=es}', "");
    Expect(0, 65293, '\p{^Bc=es}', "");
    Expect(0, 65293, '\P{Bc=es}', "");
    Expect(1, 65293, '\P{^Bc=es}', "");
    Expect(0, 65294, '\p{Bc=es}', "");
    Expect(1, 65294, '\p{^Bc=es}', "");
    Expect(1, 65294, '\P{Bc=es}', "");
    Expect(0, 65294, '\P{^Bc=es}', "");
    Expect(1, 65293, '\p{Bc=:\Aes\z:}', "");;
    Expect(0, 65294, '\p{Bc=:\Aes\z:}', "");;
    Expect(1, 65293, '\p{Bc=	_ES}', "");
    Expect(0, 65293, '\p{^Bc=	_ES}', "");
    Expect(0, 65293, '\P{Bc=	_ES}', "");
    Expect(1, 65293, '\P{^Bc=	_ES}', "");
    Expect(0, 65294, '\p{Bc=	_ES}', "");
    Expect(1, 65294, '\p{^Bc=	_ES}', "");
    Expect(1, 65294, '\P{Bc=	_ES}', "");
    Expect(0, 65294, '\P{^Bc=	_ES}', "");
    Error('\p{Is_Bidi_Class=/a/__EUROPEAN_separator}');
    Error('\P{Is_Bidi_Class=/a/__EUROPEAN_separator}');
    Expect(1, 65293, '\p{Is_Bidi_Class=europeanseparator}', "");
    Expect(0, 65293, '\p{^Is_Bidi_Class=europeanseparator}', "");
    Expect(0, 65293, '\P{Is_Bidi_Class=europeanseparator}', "");
    Expect(1, 65293, '\P{^Is_Bidi_Class=europeanseparator}', "");
    Expect(0, 65294, '\p{Is_Bidi_Class=europeanseparator}', "");
    Expect(1, 65294, '\p{^Is_Bidi_Class=europeanseparator}', "");
    Expect(1, 65294, '\P{Is_Bidi_Class=europeanseparator}', "");
    Expect(0, 65294, '\P{^Is_Bidi_Class=europeanseparator}', "");
    Expect(1, 65293, '\p{Is_Bidi_Class=	 european_separator}', "");
    Expect(0, 65293, '\p{^Is_Bidi_Class=	 european_separator}', "");
    Expect(0, 65293, '\P{Is_Bidi_Class=	 european_separator}', "");
    Expect(1, 65293, '\P{^Is_Bidi_Class=	 european_separator}', "");
    Expect(0, 65294, '\p{Is_Bidi_Class=	 european_separator}', "");
    Expect(1, 65294, '\p{^Is_Bidi_Class=	 european_separator}', "");
    Expect(1, 65294, '\P{Is_Bidi_Class=	 european_separator}', "");
    Expect(0, 65294, '\P{^Is_Bidi_Class=	 european_separator}', "");
    Error('\p{Is_Bc=_:=ES}');
    Error('\P{Is_Bc=_:=ES}');
    Expect(1, 65293, '\p{Is_Bc:   es}', "");
    Expect(0, 65293, '\p{^Is_Bc:   es}', "");
    Expect(0, 65293, '\P{Is_Bc:   es}', "");
    Expect(1, 65293, '\P{^Is_Bc:   es}', "");
    Expect(0, 65294, '\p{Is_Bc:   es}', "");
    Expect(1, 65294, '\p{^Is_Bc:   es}', "");
    Expect(1, 65294, '\P{Is_Bc:   es}', "");
    Expect(0, 65294, '\P{^Is_Bc:   es}', "");
    Expect(1, 65293, '\p{Is_Bc= _ES}', "");
    Expect(0, 65293, '\p{^Is_Bc= _ES}', "");
    Expect(0, 65293, '\P{Is_Bc= _ES}', "");
    Expect(1, 65293, '\P{^Is_Bc= _ES}', "");
    Expect(0, 65294, '\p{Is_Bc= _ES}', "");
    Expect(1, 65294, '\p{^Is_Bc= _ES}', "");
    Expect(1, 65294, '\P{Is_Bc= _ES}', "");
    Expect(0, 65294, '\P{^Is_Bc= _ES}', "");
    Error('\p{Bidi_Class= :=European_terminator}');
    Error('\P{Bidi_Class= :=European_terminator}');
    Expect(1, 123647, '\p{Bidi_Class=:\AEuropean_Terminator\z:}', "");;
    Expect(0, 123648, '\p{Bidi_Class=:\AEuropean_Terminator\z:}', "");;
    Expect(1, 123647, '\p{Bidi_Class=europeanterminator}', "");
    Expect(0, 123647, '\p{^Bidi_Class=europeanterminator}', "");
    Expect(0, 123647, '\P{Bidi_Class=europeanterminator}', "");
    Expect(1, 123647, '\P{^Bidi_Class=europeanterminator}', "");
    Expect(0, 123648, '\p{Bidi_Class=europeanterminator}', "");
    Expect(1, 123648, '\p{^Bidi_Class=europeanterminator}', "");
    Expect(1, 123648, '\P{Bidi_Class=europeanterminator}', "");
    Expect(0, 123648, '\P{^Bidi_Class=europeanterminator}', "");
    Expect(1, 123647, '\p{Bidi_Class=:\Aeuropeanterminator\z:}', "");;
    Expect(0, 123648, '\p{Bidi_Class=:\Aeuropeanterminator\z:}', "");;
    Expect(1, 123647, '\p{Bidi_Class=-	European_Terminator}', "");
    Expect(0, 123647, '\p{^Bidi_Class=-	European_Terminator}', "");
    Expect(0, 123647, '\P{Bidi_Class=-	European_Terminator}', "");
    Expect(1, 123647, '\P{^Bidi_Class=-	European_Terminator}', "");
    Expect(0, 123648, '\p{Bidi_Class=-	European_Terminator}', "");
    Expect(1, 123648, '\p{^Bidi_Class=-	European_Terminator}', "");
    Expect(1, 123648, '\P{Bidi_Class=-	European_Terminator}', "");
    Expect(0, 123648, '\P{^Bidi_Class=-	European_Terminator}', "");
    Error('\p{Bc=	ET/a/}');
    Error('\P{Bc=	ET/a/}');
    Expect(1, 123647, '\p{Bc=:\AET\z:}', "");;
    Expect(0, 123648, '\p{Bc=:\AET\z:}', "");;
    Expect(1, 123647, '\p{Bc=et}', "");
    Expect(0, 123647, '\p{^Bc=et}', "");
    Expect(0, 123647, '\P{Bc=et}', "");
    Expect(1, 123647, '\P{^Bc=et}', "");
    Expect(0, 123648, '\p{Bc=et}', "");
    Expect(1, 123648, '\p{^Bc=et}', "");
    Expect(1, 123648, '\P{Bc=et}', "");
    Expect(0, 123648, '\P{^Bc=et}', "");
    Expect(1, 123647, '\p{Bc=:\Aet\z:}', "");;
    Expect(0, 123648, '\p{Bc=:\Aet\z:}', "");;
    Expect(1, 123647, '\p{Bc=  et}', "");
    Expect(0, 123647, '\p{^Bc=  et}', "");
    Expect(0, 123647, '\P{Bc=  et}', "");
    Expect(1, 123647, '\P{^Bc=  et}', "");
    Expect(0, 123648, '\p{Bc=  et}', "");
    Expect(1, 123648, '\p{^Bc=  et}', "");
    Expect(1, 123648, '\P{Bc=  et}', "");
    Expect(0, 123648, '\P{^Bc=  et}', "");
    Error('\p{Is_Bidi_Class=:=	european_Terminator}');
    Error('\P{Is_Bidi_Class=:=	european_Terminator}');
    Expect(1, 123647, '\p{Is_Bidi_Class=europeanterminator}', "");
    Expect(0, 123647, '\p{^Is_Bidi_Class=europeanterminator}', "");
    Expect(0, 123647, '\P{Is_Bidi_Class=europeanterminator}', "");
    Expect(1, 123647, '\P{^Is_Bidi_Class=europeanterminator}', "");
    Expect(0, 123648, '\p{Is_Bidi_Class=europeanterminator}', "");
    Expect(1, 123648, '\p{^Is_Bidi_Class=europeanterminator}', "");
    Expect(1, 123648, '\P{Is_Bidi_Class=europeanterminator}', "");
    Expect(0, 123648, '\P{^Is_Bidi_Class=europeanterminator}', "");
    Expect(1, 123647, '\p{Is_Bidi_Class=-European_Terminator}', "");
    Expect(0, 123647, '\p{^Is_Bidi_Class=-European_Terminator}', "");
    Expect(0, 123647, '\P{Is_Bidi_Class=-European_Terminator}', "");
    Expect(1, 123647, '\P{^Is_Bidi_Class=-European_Terminator}', "");
    Expect(0, 123648, '\p{Is_Bidi_Class=-European_Terminator}', "");
    Expect(1, 123648, '\p{^Is_Bidi_Class=-European_Terminator}', "");
    Expect(1, 123648, '\P{Is_Bidi_Class=-European_Terminator}', "");
    Expect(0, 123648, '\P{^Is_Bidi_Class=-European_Terminator}', "");
    Error('\p{Is_Bc=/a/	ET}');
    Error('\P{Is_Bc=/a/	ET}');
    Expect(1, 123647, '\p{Is_Bc=et}', "");
    Expect(0, 123647, '\p{^Is_Bc=et}', "");
    Expect(0, 123647, '\P{Is_Bc=et}', "");
    Expect(1, 123647, '\P{^Is_Bc=et}', "");
    Expect(0, 123648, '\p{Is_Bc=et}', "");
    Expect(1, 123648, '\p{^Is_Bc=et}', "");
    Expect(1, 123648, '\P{Is_Bc=et}', "");
    Expect(0, 123648, '\P{^Is_Bc=et}', "");
    Expect(1, 123647, '\p{Is_Bc=- ET}', "");
    Expect(0, 123647, '\p{^Is_Bc=- ET}', "");
    Expect(0, 123647, '\P{Is_Bc=- ET}', "");
    Expect(1, 123647, '\P{^Is_Bc=- ET}', "");
    Expect(0, 123648, '\p{Is_Bc=- ET}', "");
    Expect(1, 123648, '\p{^Is_Bc=- ET}', "");
    Expect(1, 123648, '\P{Is_Bc=- ET}', "");
    Expect(0, 123648, '\P{^Is_Bc=- ET}', "");
    Error('\p{Bidi_Class=-First_STRONG_Isolate:=}');
    Error('\P{Bidi_Class=-First_STRONG_Isolate:=}');
    Expect(1, 8296, '\p{Bidi_Class=:\AFirst_Strong_Isolate\z:}', "");;
    Expect(0, 8297, '\p{Bidi_Class=:\AFirst_Strong_Isolate\z:}', "");;
    Expect(1, 8296, '\p{Bidi_Class=firststrongisolate}', "");
    Expect(0, 8296, '\p{^Bidi_Class=firststrongisolate}', "");
    Expect(0, 8296, '\P{Bidi_Class=firststrongisolate}', "");
    Expect(1, 8296, '\P{^Bidi_Class=firststrongisolate}', "");
    Expect(0, 8297, '\p{Bidi_Class=firststrongisolate}', "");
    Expect(1, 8297, '\p{^Bidi_Class=firststrongisolate}', "");
    Expect(1, 8297, '\P{Bidi_Class=firststrongisolate}', "");
    Expect(0, 8297, '\P{^Bidi_Class=firststrongisolate}', "");
    Expect(1, 8296, '\p{Bidi_Class=:\Afirststrongisolate\z:}', "");;
    Expect(0, 8297, '\p{Bidi_Class=:\Afirststrongisolate\z:}', "");;
    Expect(1, 8296, '\p{Bidi_Class=_first_Strong_Isolate}', "");
    Expect(0, 8296, '\p{^Bidi_Class=_first_Strong_Isolate}', "");
    Expect(0, 8296, '\P{Bidi_Class=_first_Strong_Isolate}', "");
    Expect(1, 8296, '\P{^Bidi_Class=_first_Strong_Isolate}', "");
    Expect(0, 8297, '\p{Bidi_Class=_first_Strong_Isolate}', "");
    Expect(1, 8297, '\p{^Bidi_Class=_first_Strong_Isolate}', "");
    Expect(1, 8297, '\P{Bidi_Class=_first_Strong_Isolate}', "");
    Expect(0, 8297, '\P{^Bidi_Class=_first_Strong_Isolate}', "");
    Error('\p{Bc=	:=FSI}');
    Error('\P{Bc=	:=FSI}');
    Expect(1, 8296, '\p{Bc=:\AFSI\z:}', "");;
    Expect(0, 8297, '\p{Bc=:\AFSI\z:}', "");;
    Expect(1, 8296, '\p{Bc=fsi}', "");
    Expect(0, 8296, '\p{^Bc=fsi}', "");
    Expect(0, 8296, '\P{Bc=fsi}', "");
    Expect(1, 8296, '\P{^Bc=fsi}', "");
    Expect(0, 8297, '\p{Bc=fsi}', "");
    Expect(1, 8297, '\p{^Bc=fsi}', "");
    Expect(1, 8297, '\P{Bc=fsi}', "");
    Expect(0, 8297, '\P{^Bc=fsi}', "");
    Expect(1, 8296, '\p{Bc=:\Afsi\z:}', "");;
    Expect(0, 8297, '\p{Bc=:\Afsi\z:}', "");;
    Expect(1, 8296, '\p{Bc=_-FSI}', "");
    Expect(0, 8296, '\p{^Bc=_-FSI}', "");
    Expect(0, 8296, '\P{Bc=_-FSI}', "");
    Expect(1, 8296, '\P{^Bc=_-FSI}', "");
    Expect(0, 8297, '\p{Bc=_-FSI}', "");
    Expect(1, 8297, '\p{^Bc=_-FSI}', "");
    Expect(1, 8297, '\P{Bc=_-FSI}', "");
    Expect(0, 8297, '\P{^Bc=_-FSI}', "");
    Error('\p{Is_Bidi_Class= 	FIRST_Strong_Isolate/a/}');
    Error('\P{Is_Bidi_Class= 	FIRST_Strong_Isolate/a/}');
    Expect(1, 8296, '\p{Is_Bidi_Class=firststrongisolate}', "");
    Expect(0, 8296, '\p{^Is_Bidi_Class=firststrongisolate}', "");
    Expect(0, 8296, '\P{Is_Bidi_Class=firststrongisolate}', "");
    Expect(1, 8296, '\P{^Is_Bidi_Class=firststrongisolate}', "");
    Expect(0, 8297, '\p{Is_Bidi_Class=firststrongisolate}', "");
    Expect(1, 8297, '\p{^Is_Bidi_Class=firststrongisolate}', "");
    Expect(1, 8297, '\P{Is_Bidi_Class=firststrongisolate}', "");
    Expect(0, 8297, '\P{^Is_Bidi_Class=firststrongisolate}', "");
    Expect(1, 8296, '\p{Is_Bidi_Class=- First_Strong_Isolate}', "");
    Expect(0, 8296, '\p{^Is_Bidi_Class=- First_Strong_Isolate}', "");
    Expect(0, 8296, '\P{Is_Bidi_Class=- First_Strong_Isolate}', "");
    Expect(1, 8296, '\P{^Is_Bidi_Class=- First_Strong_Isolate}', "");
    Expect(0, 8297, '\p{Is_Bidi_Class=- First_Strong_Isolate}', "");
    Expect(1, 8297, '\p{^Is_Bidi_Class=- First_Strong_Isolate}', "");
    Expect(1, 8297, '\P{Is_Bidi_Class=- First_Strong_Isolate}', "");
    Expect(0, 8297, '\P{^Is_Bidi_Class=- First_Strong_Isolate}', "");
    Error('\p{Is_Bc=_ FSI:=}');
    Error('\P{Is_Bc=_ FSI:=}');
    Expect(1, 8296, '\p{Is_Bc=fsi}', "");
    Expect(0, 8296, '\p{^Is_Bc=fsi}', "");
    Expect(0, 8296, '\P{Is_Bc=fsi}', "");
    Expect(1, 8296, '\P{^Is_Bc=fsi}', "");
    Expect(0, 8297, '\p{Is_Bc=fsi}', "");
    Expect(1, 8297, '\p{^Is_Bc=fsi}', "");
    Expect(1, 8297, '\P{Is_Bc=fsi}', "");
    Expect(0, 8297, '\P{^Is_Bc=fsi}', "");
    Expect(1, 8296, '\p{Is_Bc=	 FSI}', "");
    Expect(0, 8296, '\p{^Is_Bc=	 FSI}', "");
    Expect(0, 8296, '\P{Is_Bc=	 FSI}', "");
    Expect(1, 8296, '\P{^Is_Bc=	 FSI}', "");
    Expect(0, 8297, '\p{Is_Bc=	 FSI}', "");
    Expect(1, 8297, '\p{^Is_Bc=	 FSI}', "");
    Expect(1, 8297, '\P{Is_Bc=	 FSI}', "");
    Expect(0, 8297, '\P{^Is_Bc=	 FSI}', "");
    Error('\p{Bidi_Class=/a/-_Left_to_Right}');
    Error('\P{Bidi_Class=/a/-_Left_to_Right}');
    Expect(1, 1114109, '\p{Bidi_Class=:\ALeft_To_Right\z:}', "");;
    Expect(0, 921599, '\p{Bidi_Class=:\ALeft_To_Right\z:}', "");;
    Expect(1, 1114109, '\p{Bidi_Class=lefttoright}', "");
    Expect(0, 1114109, '\p{^Bidi_Class=lefttoright}', "");
    Expect(0, 1114109, '\P{Bidi_Class=lefttoright}', "");
    Expect(1, 1114109, '\P{^Bidi_Class=lefttoright}', "");
    Expect(0, 921599, '\p{Bidi_Class=lefttoright}', "");
    Expect(1, 921599, '\p{^Bidi_Class=lefttoright}', "");
    Expect(1, 921599, '\P{Bidi_Class=lefttoright}', "");
    Expect(0, 921599, '\P{^Bidi_Class=lefttoright}', "");
    Expect(1, 1114109, '\p{Bidi_Class=:\Alefttoright\z:}', "");;
    Expect(0, 921599, '\p{Bidi_Class=:\Alefttoright\z:}', "");;
    Expect(1, 1114109, '\p{Bidi_Class: _-LEFT_To_right}', "");
    Expect(0, 1114109, '\p{^Bidi_Class: _-LEFT_To_right}', "");
    Expect(0, 1114109, '\P{Bidi_Class: _-LEFT_To_right}', "");
    Expect(1, 1114109, '\P{^Bidi_Class: _-LEFT_To_right}', "");
    Expect(0, 921599, '\p{Bidi_Class: _-LEFT_To_right}', "");
    Expect(1, 921599, '\p{^Bidi_Class: _-LEFT_To_right}', "");
    Expect(1, 921599, '\P{Bidi_Class: _-LEFT_To_right}', "");
    Expect(0, 921599, '\P{^Bidi_Class: _-LEFT_To_right}', "");
    Error('\p{Bc:_/a/l}');
    Error('\P{Bc:_/a/l}');
    Expect(1, 1114109, '\p{Bc=:\AL\z:}', "");;
    Expect(0, 921599, '\p{Bc=:\AL\z:}', "");;
    Expect(1, 1114109, '\p{Bc=l}', "");
    Expect(0, 1114109, '\p{^Bc=l}', "");
    Expect(0, 1114109, '\P{Bc=l}', "");
    Expect(1, 1114109, '\P{^Bc=l}', "");
    Expect(0, 921599, '\p{Bc=l}', "");
    Expect(1, 921599, '\p{^Bc=l}', "");
    Expect(1, 921599, '\P{Bc=l}', "");
    Expect(0, 921599, '\P{^Bc=l}', "");
    Expect(1, 1114109, '\p{Bc=:\Al\z:}', "");;
    Expect(0, 921599, '\p{Bc=:\Al\z:}', "");;
    Expect(1, 1114109, '\p{Bc= _L}', "");
    Expect(0, 1114109, '\p{^Bc= _L}', "");
    Expect(0, 1114109, '\P{Bc= _L}', "");
    Expect(1, 1114109, '\P{^Bc= _L}', "");
    Expect(0, 921599, '\p{Bc= _L}', "");
    Expect(1, 921599, '\p{^Bc= _L}', "");
    Expect(1, 921599, '\P{Bc= _L}', "");
    Expect(0, 921599, '\P{^Bc= _L}', "");
    Error('\p{Is_Bidi_Class= /a/left_to_right}');
    Error('\P{Is_Bidi_Class= /a/left_to_right}');
    Expect(1, 1114109, '\p{Is_Bidi_Class:lefttoright}', "");
    Expect(0, 1114109, '\p{^Is_Bidi_Class:lefttoright}', "");
    Expect(0, 1114109, '\P{Is_Bidi_Class:lefttoright}', "");
    Expect(1, 1114109, '\P{^Is_Bidi_Class:lefttoright}', "");
    Expect(0, 921599, '\p{Is_Bidi_Class:lefttoright}', "");
    Expect(1, 921599, '\p{^Is_Bidi_Class:lefttoright}', "");
    Expect(1, 921599, '\P{Is_Bidi_Class:lefttoright}', "");
    Expect(0, 921599, '\P{^Is_Bidi_Class:lefttoright}', "");
    Expect(1, 1114109, '\p{Is_Bidi_Class:   LEFT_to_RIGHT}', "");
    Expect(0, 1114109, '\p{^Is_Bidi_Class:   LEFT_to_RIGHT}', "");
    Expect(0, 1114109, '\P{Is_Bidi_Class:   LEFT_to_RIGHT}', "");
    Expect(1, 1114109, '\P{^Is_Bidi_Class:   LEFT_to_RIGHT}', "");
    Expect(0, 921599, '\p{Is_Bidi_Class:   LEFT_to_RIGHT}', "");
    Expect(1, 921599, '\p{^Is_Bidi_Class:   LEFT_to_RIGHT}', "");
    Expect(1, 921599, '\P{Is_Bidi_Class:   LEFT_to_RIGHT}', "");
    Expect(0, 921599, '\P{^Is_Bidi_Class:   LEFT_to_RIGHT}', "");
    Error('\p{Is_Bc=-:=l}');
    Error('\P{Is_Bc=-:=l}');
    Expect(1, 1114109, '\p{Is_Bc: l}', "");
    Expect(0, 1114109, '\p{^Is_Bc: l}', "");
    Expect(0, 1114109, '\P{Is_Bc: l}', "");
    Expect(1, 1114109, '\P{^Is_Bc: l}', "");
    Expect(0, 921599, '\p{Is_Bc: l}', "");
    Expect(1, 921599, '\p{^Is_Bc: l}', "");
    Expect(1, 921599, '\P{Is_Bc: l}', "");
    Expect(0, 921599, '\P{^Is_Bc: l}', "");
    Expect(1, 1114109, '\p{Is_Bc=-l}', "");
    Expect(0, 1114109, '\p{^Is_Bc=-l}', "");
    Expect(0, 1114109, '\P{Is_Bc=-l}', "");
    Expect(1, 1114109, '\P{^Is_Bc=-l}', "");
    Expect(0, 921599, '\p{Is_Bc=-l}', "");
    Expect(1, 921599, '\p{^Is_Bc=-l}', "");
    Expect(1, 921599, '\P{Is_Bc=-l}', "");
    Expect(0, 921599, '\P{^Is_Bc=-l}', "");
    Error('\p{Bidi_Class: -left_TO_right_embedding:=}');
    Error('\P{Bidi_Class: -left_TO_right_embedding:=}');
    Expect(1, 8234, '\p{Bidi_Class=:\ALeft_To_Right_Embedding\z:}', "");;
    Expect(0, 8235, '\p{Bidi_Class=:\ALeft_To_Right_Embedding\z:}', "");;
    Expect(1, 8234, '\p{Bidi_Class: lefttorightembedding}', "");
    Expect(0, 8234, '\p{^Bidi_Class: lefttorightembedding}', "");
    Expect(0, 8234, '\P{Bidi_Class: lefttorightembedding}', "");
    Expect(1, 8234, '\P{^Bidi_Class: lefttorightembedding}', "");
    Expect(0, 8235, '\p{Bidi_Class: lefttorightembedding}', "");
    Expect(1, 8235, '\p{^Bidi_Class: lefttorightembedding}', "");
    Expect(1, 8235, '\P{Bidi_Class: lefttorightembedding}', "");
    Expect(0, 8235, '\P{^Bidi_Class: lefttorightembedding}', "");
    Expect(1, 8234, '\p{Bidi_Class=:\Alefttorightembedding\z:}', "");;
    Expect(0, 8235, '\p{Bidi_Class=:\Alefttorightembedding\z:}', "");;
    Expect(1, 8234, '\p{Bidi_Class=--Left_To_right_embedding}', "");
    Expect(0, 8234, '\p{^Bidi_Class=--Left_To_right_embedding}', "");
    Expect(0, 8234, '\P{Bidi_Class=--Left_To_right_embedding}', "");
    Expect(1, 8234, '\P{^Bidi_Class=--Left_To_right_embedding}', "");
    Expect(0, 8235, '\p{Bidi_Class=--Left_To_right_embedding}', "");
    Expect(1, 8235, '\p{^Bidi_Class=--Left_To_right_embedding}', "");
    Expect(1, 8235, '\P{Bidi_Class=--Left_To_right_embedding}', "");
    Expect(0, 8235, '\P{^Bidi_Class=--Left_To_right_embedding}', "");
    Error('\p{Bc=-/a/LRE}');
    Error('\P{Bc=-/a/LRE}');
    Expect(1, 8234, '\p{Bc=:\ALRE\z:}', "");;
    Expect(0, 8235, '\p{Bc=:\ALRE\z:}', "");;
    Expect(1, 8234, '\p{Bc=lre}', "");
    Expect(0, 8234, '\p{^Bc=lre}', "");
    Expect(0, 8234, '\P{Bc=lre}', "");
    Expect(1, 8234, '\P{^Bc=lre}', "");
    Expect(0, 8235, '\p{Bc=lre}', "");
    Expect(1, 8235, '\p{^Bc=lre}', "");
    Expect(1, 8235, '\P{Bc=lre}', "");
    Expect(0, 8235, '\P{^Bc=lre}', "");
    Expect(1, 8234, '\p{Bc=:\Alre\z:}', "");;
    Expect(0, 8235, '\p{Bc=:\Alre\z:}', "");;
    Expect(1, 8234, '\p{Bc=-	lre}', "");
    Expect(0, 8234, '\p{^Bc=-	lre}', "");
    Expect(0, 8234, '\P{Bc=-	lre}', "");
    Expect(1, 8234, '\P{^Bc=-	lre}', "");
    Expect(0, 8235, '\p{Bc=-	lre}', "");
    Expect(1, 8235, '\p{^Bc=-	lre}', "");
    Expect(1, 8235, '\P{Bc=-	lre}', "");
    Expect(0, 8235, '\P{^Bc=-	lre}', "");
    Error('\p{Is_Bidi_Class=LEFT_to_RIGHT_EMBEDDING:=}');
    Error('\P{Is_Bidi_Class=LEFT_to_RIGHT_EMBEDDING:=}');
    Expect(1, 8234, '\p{Is_Bidi_Class=lefttorightembedding}', "");
    Expect(0, 8234, '\p{^Is_Bidi_Class=lefttorightembedding}', "");
    Expect(0, 8234, '\P{Is_Bidi_Class=lefttorightembedding}', "");
    Expect(1, 8234, '\P{^Is_Bidi_Class=lefttorightembedding}', "");
    Expect(0, 8235, '\p{Is_Bidi_Class=lefttorightembedding}', "");
    Expect(1, 8235, '\p{^Is_Bidi_Class=lefttorightembedding}', "");
    Expect(1, 8235, '\P{Is_Bidi_Class=lefttorightembedding}', "");
    Expect(0, 8235, '\P{^Is_Bidi_Class=lefttorightembedding}', "");
    Expect(1, 8234, '\p{Is_Bidi_Class=  Left_To_RIGHT_EMBEDDING}', "");
    Expect(0, 8234, '\p{^Is_Bidi_Class=  Left_To_RIGHT_EMBEDDING}', "");
    Expect(0, 8234, '\P{Is_Bidi_Class=  Left_To_RIGHT_EMBEDDING}', "");
    Expect(1, 8234, '\P{^Is_Bidi_Class=  Left_To_RIGHT_EMBEDDING}', "");
    Expect(0, 8235, '\p{Is_Bidi_Class=  Left_To_RIGHT_EMBEDDING}', "");
    Expect(1, 8235, '\p{^Is_Bidi_Class=  Left_To_RIGHT_EMBEDDING}', "");
    Expect(1, 8235, '\P{Is_Bidi_Class=  Left_To_RIGHT_EMBEDDING}', "");
    Expect(0, 8235, '\P{^Is_Bidi_Class=  Left_To_RIGHT_EMBEDDING}', "");
    Error('\p{Is_Bc=-LRE/a/}');
    Error('\P{Is_Bc=-LRE/a/}');
    Expect(1, 8234, '\p{Is_Bc=lre}', "");
    Expect(0, 8234, '\p{^Is_Bc=lre}', "");
    Expect(0, 8234, '\P{Is_Bc=lre}', "");
    Expect(1, 8234, '\P{^Is_Bc=lre}', "");
    Expect(0, 8235, '\p{Is_Bc=lre}', "");
    Expect(1, 8235, '\p{^Is_Bc=lre}', "");
    Expect(1, 8235, '\P{Is_Bc=lre}', "");
    Expect(0, 8235, '\P{^Is_Bc=lre}', "");
    Expect(1, 8234, '\p{Is_Bc=-	LRE}', "");
    Expect(0, 8234, '\p{^Is_Bc=-	LRE}', "");
    Expect(0, 8234, '\P{Is_Bc=-	LRE}', "");
    Expect(1, 8234, '\P{^Is_Bc=-	LRE}', "");
    Expect(0, 8235, '\p{Is_Bc=-	LRE}', "");
    Expect(1, 8235, '\p{^Is_Bc=-	LRE}', "");
    Expect(1, 8235, '\P{Is_Bc=-	LRE}', "");
    Expect(0, 8235, '\P{^Is_Bc=-	LRE}', "");
    Error('\p{Bidi_Class=/a/ -left_To_RIGHT_ISOLATE}');
    Error('\P{Bidi_Class=/a/ -left_To_RIGHT_ISOLATE}');
    Expect(1, 8294, '\p{Bidi_Class=:\ALeft_To_Right_Isolate\z:}', "");;
    Expect(0, 8295, '\p{Bidi_Class=:\ALeft_To_Right_Isolate\z:}', "");;
    Expect(1, 8294, '\p{Bidi_Class=lefttorightisolate}', "");
    Expect(0, 8294, '\p{^Bidi_Class=lefttorightisolate}', "");
    Expect(0, 8294, '\P{Bidi_Class=lefttorightisolate}', "");
    Expect(1, 8294, '\P{^Bidi_Class=lefttorightisolate}', "");
    Expect(0, 8295, '\p{Bidi_Class=lefttorightisolate}', "");
    Expect(1, 8295, '\p{^Bidi_Class=lefttorightisolate}', "");
    Expect(1, 8295, '\P{Bidi_Class=lefttorightisolate}', "");
    Expect(0, 8295, '\P{^Bidi_Class=lefttorightisolate}', "");
    Expect(1, 8294, '\p{Bidi_Class=:\Alefttorightisolate\z:}', "");;
    Expect(0, 8295, '\p{Bidi_Class=:\Alefttorightisolate\z:}', "");;
    Expect(1, 8294, '\p{Bidi_Class:  _Left_TO_Right_isolate}', "");
    Expect(0, 8294, '\p{^Bidi_Class:  _Left_TO_Right_isolate}', "");
    Expect(0, 8294, '\P{Bidi_Class:  _Left_TO_Right_isolate}', "");
    Expect(1, 8294, '\P{^Bidi_Class:  _Left_TO_Right_isolate}', "");
    Expect(0, 8295, '\p{Bidi_Class:  _Left_TO_Right_isolate}', "");
    Expect(1, 8295, '\p{^Bidi_Class:  _Left_TO_Right_isolate}', "");
    Expect(1, 8295, '\P{Bidi_Class:  _Left_TO_Right_isolate}', "");
    Expect(0, 8295, '\P{^Bidi_Class:  _Left_TO_Right_isolate}', "");
    Error('\p{Bc= :=LRI}');
    Error('\P{Bc= :=LRI}');
    Expect(1, 8294, '\p{Bc=:\ALRI\z:}', "");;
    Expect(0, 8295, '\p{Bc=:\ALRI\z:}', "");;
    Expect(1, 8294, '\p{Bc=lri}', "");
    Expect(0, 8294, '\p{^Bc=lri}', "");
    Expect(0, 8294, '\P{Bc=lri}', "");
    Expect(1, 8294, '\P{^Bc=lri}', "");
    Expect(0, 8295, '\p{Bc=lri}', "");
    Expect(1, 8295, '\p{^Bc=lri}', "");
    Expect(1, 8295, '\P{Bc=lri}', "");
    Expect(0, 8295, '\P{^Bc=lri}', "");
    Expect(1, 8294, '\p{Bc=:\Alri\z:}', "");;
    Expect(0, 8295, '\p{Bc=:\Alri\z:}', "");;
    Expect(1, 8294, '\p{Bc=-lri}', "");
    Expect(0, 8294, '\p{^Bc=-lri}', "");
    Expect(0, 8294, '\P{Bc=-lri}', "");
    Expect(1, 8294, '\P{^Bc=-lri}', "");
    Expect(0, 8295, '\p{Bc=-lri}', "");
    Expect(1, 8295, '\p{^Bc=-lri}', "");
    Expect(1, 8295, '\P{Bc=-lri}', "");
    Expect(0, 8295, '\P{^Bc=-lri}', "");
    Error('\p{Is_Bidi_Class:	/a/_Left_To_Right_Isolate}');
    Error('\P{Is_Bidi_Class:	/a/_Left_To_Right_Isolate}');
    Expect(1, 8294, '\p{Is_Bidi_Class=lefttorightisolate}', "");
    Expect(0, 8294, '\p{^Is_Bidi_Class=lefttorightisolate}', "");
    Expect(0, 8294, '\P{Is_Bidi_Class=lefttorightisolate}', "");
    Expect(1, 8294, '\P{^Is_Bidi_Class=lefttorightisolate}', "");
    Expect(0, 8295, '\p{Is_Bidi_Class=lefttorightisolate}', "");
    Expect(1, 8295, '\p{^Is_Bidi_Class=lefttorightisolate}', "");
    Expect(1, 8295, '\P{Is_Bidi_Class=lefttorightisolate}', "");
    Expect(0, 8295, '\P{^Is_Bidi_Class=lefttorightisolate}', "");
    Expect(1, 8294, '\p{Is_Bidi_Class=_	left_TO_right_ISOLATE}', "");
    Expect(0, 8294, '\p{^Is_Bidi_Class=_	left_TO_right_ISOLATE}', "");
    Expect(0, 8294, '\P{Is_Bidi_Class=_	left_TO_right_ISOLATE}', "");
    Expect(1, 8294, '\P{^Is_Bidi_Class=_	left_TO_right_ISOLATE}', "");
    Expect(0, 8295, '\p{Is_Bidi_Class=_	left_TO_right_ISOLATE}', "");
    Expect(1, 8295, '\p{^Is_Bidi_Class=_	left_TO_right_ISOLATE}', "");
    Expect(1, 8295, '\P{Is_Bidi_Class=_	left_TO_right_ISOLATE}', "");
    Expect(0, 8295, '\P{^Is_Bidi_Class=_	left_TO_right_ISOLATE}', "");
    Error('\p{Is_Bc=_/a/lri}');
    Error('\P{Is_Bc=_/a/lri}');
    Expect(1, 8294, '\p{Is_Bc=lri}', "");
    Expect(0, 8294, '\p{^Is_Bc=lri}', "");
    Expect(0, 8294, '\P{Is_Bc=lri}', "");
    Expect(1, 8294, '\P{^Is_Bc=lri}', "");
    Expect(0, 8295, '\p{Is_Bc=lri}', "");
    Expect(1, 8295, '\p{^Is_Bc=lri}', "");
    Expect(1, 8295, '\P{Is_Bc=lri}', "");
    Expect(0, 8295, '\P{^Is_Bc=lri}', "");
    Expect(1, 8294, '\p{Is_Bc=		lri}', "");
    Expect(0, 8294, '\p{^Is_Bc=		lri}', "");
    Expect(0, 8294, '\P{Is_Bc=		lri}', "");
    Expect(1, 8294, '\P{^Is_Bc=		lri}', "");
    Expect(0, 8295, '\p{Is_Bc=		lri}', "");
    Expect(1, 8295, '\p{^Is_Bc=		lri}', "");
    Expect(1, 8295, '\P{Is_Bc=		lri}', "");
    Expect(0, 8295, '\P{^Is_Bc=		lri}', "");
    Error('\p{Bidi_Class=_-LEFT_TO_right_OVERRIDE:=}');
    Error('\P{Bidi_Class=_-LEFT_TO_right_OVERRIDE:=}');
    Expect(1, 8237, '\p{Bidi_Class=:\ALeft_To_Right_Override\z:}', "");;
    Expect(0, 8238, '\p{Bidi_Class=:\ALeft_To_Right_Override\z:}', "");;
    Expect(1, 8237, '\p{Bidi_Class=lefttorightoverride}', "");
    Expect(0, 8237, '\p{^Bidi_Class=lefttorightoverride}', "");
    Expect(0, 8237, '\P{Bidi_Class=lefttorightoverride}', "");
    Expect(1, 8237, '\P{^Bidi_Class=lefttorightoverride}', "");
    Expect(0, 8238, '\p{Bidi_Class=lefttorightoverride}', "");
    Expect(1, 8238, '\p{^Bidi_Class=lefttorightoverride}', "");
    Expect(1, 8238, '\P{Bidi_Class=lefttorightoverride}', "");
    Expect(0, 8238, '\P{^Bidi_Class=lefttorightoverride}', "");
    Expect(1, 8237, '\p{Bidi_Class=:\Alefttorightoverride\z:}', "");;
    Expect(0, 8238, '\p{Bidi_Class=:\Alefttorightoverride\z:}', "");;
    Expect(1, 8237, '\p{Bidi_Class=_	LEFT_TO_RIGHT_OVERRIDE}', "");
    Expect(0, 8237, '\p{^Bidi_Class=_	LEFT_TO_RIGHT_OVERRIDE}', "");
    Expect(0, 8237, '\P{Bidi_Class=_	LEFT_TO_RIGHT_OVERRIDE}', "");
    Expect(1, 8237, '\P{^Bidi_Class=_	LEFT_TO_RIGHT_OVERRIDE}', "");
    Expect(0, 8238, '\p{Bidi_Class=_	LEFT_TO_RIGHT_OVERRIDE}', "");
    Expect(1, 8238, '\p{^Bidi_Class=_	LEFT_TO_RIGHT_OVERRIDE}', "");
    Expect(1, 8238, '\P{Bidi_Class=_	LEFT_TO_RIGHT_OVERRIDE}', "");
    Expect(0, 8238, '\P{^Bidi_Class=_	LEFT_TO_RIGHT_OVERRIDE}', "");
    Error('\p{Bc= /a/LRO}');
    Error('\P{Bc= /a/LRO}');
    Expect(1, 8237, '\p{Bc=:\ALRO\z:}', "");;
    Expect(0, 8238, '\p{Bc=:\ALRO\z:}', "");;
    Expect(1, 8237, '\p{Bc=lro}', "");
    Expect(0, 8237, '\p{^Bc=lro}', "");
    Expect(0, 8237, '\P{Bc=lro}', "");
    Expect(1, 8237, '\P{^Bc=lro}', "");
    Expect(0, 8238, '\p{Bc=lro}', "");
    Expect(1, 8238, '\p{^Bc=lro}', "");
    Expect(1, 8238, '\P{Bc=lro}', "");
    Expect(0, 8238, '\P{^Bc=lro}', "");
    Expect(1, 8237, '\p{Bc=:\Alro\z:}', "");;
    Expect(0, 8238, '\p{Bc=:\Alro\z:}', "");;
    Expect(1, 8237, '\p{Bc=-_LRO}', "");
    Expect(0, 8237, '\p{^Bc=-_LRO}', "");
    Expect(0, 8237, '\P{Bc=-_LRO}', "");
    Expect(1, 8237, '\P{^Bc=-_LRO}', "");
    Expect(0, 8238, '\p{Bc=-_LRO}', "");
    Expect(1, 8238, '\p{^Bc=-_LRO}', "");
    Expect(1, 8238, '\P{Bc=-_LRO}', "");
    Expect(0, 8238, '\P{^Bc=-_LRO}', "");
    Error('\p{Is_Bidi_Class=-:=Left_To_Right_override}');
    Error('\P{Is_Bidi_Class=-:=Left_To_Right_override}');
    Expect(1, 8237, '\p{Is_Bidi_Class: lefttorightoverride}', "");
    Expect(0, 8237, '\p{^Is_Bidi_Class: lefttorightoverride}', "");
    Expect(0, 8237, '\P{Is_Bidi_Class: lefttorightoverride}', "");
    Expect(1, 8237, '\P{^Is_Bidi_Class: lefttorightoverride}', "");
    Expect(0, 8238, '\p{Is_Bidi_Class: lefttorightoverride}', "");
    Expect(1, 8238, '\p{^Is_Bidi_Class: lefttorightoverride}', "");
    Expect(1, 8238, '\P{Is_Bidi_Class: lefttorightoverride}', "");
    Expect(0, 8238, '\P{^Is_Bidi_Class: lefttorightoverride}', "");
    Expect(1, 8237, '\p{Is_Bidi_Class=	-LEFT_to_Right_OVERRIDE}', "");
    Expect(0, 8237, '\p{^Is_Bidi_Class=	-LEFT_to_Right_OVERRIDE}', "");
    Expect(0, 8237, '\P{Is_Bidi_Class=	-LEFT_to_Right_OVERRIDE}', "");
    Expect(1, 8237, '\P{^Is_Bidi_Class=	-LEFT_to_Right_OVERRIDE}', "");
    Expect(0, 8238, '\p{Is_Bidi_Class=	-LEFT_to_Right_OVERRIDE}', "");
    Expect(1, 8238, '\p{^Is_Bidi_Class=	-LEFT_to_Right_OVERRIDE}', "");
    Expect(1, 8238, '\P{Is_Bidi_Class=	-LEFT_to_Right_OVERRIDE}', "");
    Expect(0, 8238, '\P{^Is_Bidi_Class=	-LEFT_to_Right_OVERRIDE}', "");
    Error('\p{Is_Bc= -lro:=}');
    Error('\P{Is_Bc= -lro:=}');
    Expect(1, 8237, '\p{Is_Bc=lro}', "");
    Expect(0, 8237, '\p{^Is_Bc=lro}', "");
    Expect(0, 8237, '\P{Is_Bc=lro}', "");
    Expect(1, 8237, '\P{^Is_Bc=lro}', "");
    Expect(0, 8238, '\p{Is_Bc=lro}', "");
    Expect(1, 8238, '\p{^Is_Bc=lro}', "");
    Expect(1, 8238, '\P{Is_Bc=lro}', "");
    Expect(0, 8238, '\P{^Is_Bc=lro}', "");
    Expect(1, 8237, '\p{Is_Bc:	 	lro}', "");
    Expect(0, 8237, '\p{^Is_Bc:	 	lro}', "");
    Expect(0, 8237, '\P{Is_Bc:	 	lro}', "");
    Expect(1, 8237, '\P{^Is_Bc:	 	lro}', "");
    Expect(0, 8238, '\p{Is_Bc:	 	lro}', "");
    Expect(1, 8238, '\p{^Is_Bc:	 	lro}', "");
    Expect(1, 8238, '\P{Is_Bc:	 	lro}', "");
    Expect(0, 8238, '\P{^Is_Bc:	 	lro}', "");
    Error('\p{Bidi_Class=	_Nonspacing_mark:=}');
    Error('\P{Bidi_Class=	_Nonspacing_mark:=}');
    Expect(1, 917999, '\p{Bidi_Class=:\ANonspacing_Mark\z:}', "");;
    Expect(0, 918000, '\p{Bidi_Class=:\ANonspacing_Mark\z:}', "");;
    Expect(1, 917999, '\p{Bidi_Class=nonspacingmark}', "");
    Expect(0, 917999, '\p{^Bidi_Class=nonspacingmark}', "");
    Expect(0, 917999, '\P{Bidi_Class=nonspacingmark}', "");
    Expect(1, 917999, '\P{^Bidi_Class=nonspacingmark}', "");
    Expect(0, 918000, '\p{Bidi_Class=nonspacingmark}', "");
    Expect(1, 918000, '\p{^Bidi_Class=nonspacingmark}', "");
    Expect(1, 918000, '\P{Bidi_Class=nonspacingmark}', "");
    Expect(0, 918000, '\P{^Bidi_Class=nonspacingmark}', "");
    Expect(1, 917999, '\p{Bidi_Class=:\Anonspacingmark\z:}', "");;
    Expect(0, 918000, '\p{Bidi_Class=:\Anonspacingmark\z:}', "");;
    Expect(1, 917999, '\p{Bidi_Class=	Nonspacing_MARK}', "");
    Expect(0, 917999, '\p{^Bidi_Class=	Nonspacing_MARK}', "");
    Expect(0, 917999, '\P{Bidi_Class=	Nonspacing_MARK}', "");
    Expect(1, 917999, '\P{^Bidi_Class=	Nonspacing_MARK}', "");
    Expect(0, 918000, '\p{Bidi_Class=	Nonspacing_MARK}', "");
    Expect(1, 918000, '\p{^Bidi_Class=	Nonspacing_MARK}', "");
    Expect(1, 918000, '\P{Bidi_Class=	Nonspacing_MARK}', "");
    Expect(0, 918000, '\P{^Bidi_Class=	Nonspacing_MARK}', "");
    Error('\p{Bc:/a/_NSM}');
    Error('\P{Bc:/a/_NSM}');
    Expect(1, 917999, '\p{Bc=:\ANSM\z:}', "");;
    Expect(0, 918000, '\p{Bc=:\ANSM\z:}', "");;
    Expect(1, 917999, '\p{Bc=nsm}', "");
    Expect(0, 917999, '\p{^Bc=nsm}', "");
    Expect(0, 917999, '\P{Bc=nsm}', "");
    Expect(1, 917999, '\P{^Bc=nsm}', "");
    Expect(0, 918000, '\p{Bc=nsm}', "");
    Expect(1, 918000, '\p{^Bc=nsm}', "");
    Expect(1, 918000, '\P{Bc=nsm}', "");
    Expect(0, 918000, '\P{^Bc=nsm}', "");
    Expect(1, 917999, '\p{Bc=:\Ansm\z:}', "");;
    Expect(0, 918000, '\p{Bc=:\Ansm\z:}', "");;
    Expect(1, 917999, '\p{Bc=_	NSM}', "");
    Expect(0, 917999, '\p{^Bc=_	NSM}', "");
    Expect(0, 917999, '\P{Bc=_	NSM}', "");
    Expect(1, 917999, '\P{^Bc=_	NSM}', "");
    Expect(0, 918000, '\p{Bc=_	NSM}', "");
    Expect(1, 918000, '\p{^Bc=_	NSM}', "");
    Expect(1, 918000, '\P{Bc=_	NSM}', "");
    Expect(0, 918000, '\P{^Bc=_	NSM}', "");
    Error('\p{Is_Bidi_Class=:=NONSPACING_mark}');
    Error('\P{Is_Bidi_Class=:=NONSPACING_mark}');
    Expect(1, 917999, '\p{Is_Bidi_Class:   nonspacingmark}', "");
    Expect(0, 917999, '\p{^Is_Bidi_Class:   nonspacingmark}', "");
    Expect(0, 917999, '\P{Is_Bidi_Class:   nonspacingmark}', "");
    Expect(1, 917999, '\P{^Is_Bidi_Class:   nonspacingmark}', "");
    Expect(0, 918000, '\p{Is_Bidi_Class:   nonspacingmark}', "");
    Expect(1, 918000, '\p{^Is_Bidi_Class:   nonspacingmark}', "");
    Expect(1, 918000, '\P{Is_Bidi_Class:   nonspacingmark}', "");
    Expect(0, 918000, '\P{^Is_Bidi_Class:   nonspacingmark}', "");
    Expect(1, 917999, '\p{Is_Bidi_Class=  NONSPACING_mark}', "");
    Expect(0, 917999, '\p{^Is_Bidi_Class=  NONSPACING_mark}', "");
    Expect(0, 917999, '\P{Is_Bidi_Class=  NONSPACING_mark}', "");
    Expect(1, 917999, '\P{^Is_Bidi_Class=  NONSPACING_mark}', "");
    Expect(0, 918000, '\p{Is_Bidi_Class=  NONSPACING_mark}', "");
    Expect(1, 918000, '\p{^Is_Bidi_Class=  NONSPACING_mark}', "");
    Expect(1, 918000, '\P{Is_Bidi_Class=  NONSPACING_mark}', "");
    Expect(0, 918000, '\P{^Is_Bidi_Class=  NONSPACING_mark}', "");
    Error('\p{Is_Bc=	NSM/a/}');
    Error('\P{Is_Bc=	NSM/a/}');
    Expect(1, 917999, '\p{Is_Bc=nsm}', "");
    Expect(0, 917999, '\p{^Is_Bc=nsm}', "");
    Expect(0, 917999, '\P{Is_Bc=nsm}', "");
    Expect(1, 917999, '\P{^Is_Bc=nsm}', "");
    Expect(0, 918000, '\p{Is_Bc=nsm}', "");
    Expect(1, 918000, '\p{^Is_Bc=nsm}', "");
    Expect(1, 918000, '\P{Is_Bc=nsm}', "");
    Expect(0, 918000, '\P{^Is_Bc=nsm}', "");
    Expect(1, 917999, '\p{Is_Bc=-NSM}', "");
    Expect(0, 917999, '\p{^Is_Bc=-NSM}', "");
    Expect(0, 917999, '\P{Is_Bc=-NSM}', "");
    Expect(1, 917999, '\P{^Is_Bc=-NSM}', "");
    Expect(0, 918000, '\p{Is_Bc=-NSM}', "");
    Expect(1, 918000, '\p{^Is_Bc=-NSM}', "");
    Expect(1, 918000, '\P{Is_Bc=-NSM}', "");
    Expect(0, 918000, '\P{^Is_Bc=-NSM}', "");
    Error('\p{Bidi_Class=-	OTHER_Neutral/a/}');
    Error('\P{Bidi_Class=-	OTHER_Neutral/a/}');
    Expect(1, 129994, '\p{Bidi_Class=:\AOther_Neutral\z:}', "");;
    Expect(0, 129995, '\p{Bidi_Class=:\AOther_Neutral\z:}', "");;
    Expect(1, 129994, '\p{Bidi_Class=otherneutral}', "");
    Expect(0, 129994, '\p{^Bidi_Class=otherneutral}', "");
    Expect(0, 129994, '\P{Bidi_Class=otherneutral}', "");
    Expect(1, 129994, '\P{^Bidi_Class=otherneutral}', "");
    Expect(0, 129995, '\p{Bidi_Class=otherneutral}', "");
    Expect(1, 129995, '\p{^Bidi_Class=otherneutral}', "");
    Expect(1, 129995, '\P{Bidi_Class=otherneutral}', "");
    Expect(0, 129995, '\P{^Bidi_Class=otherneutral}', "");
    Expect(1, 129994, '\p{Bidi_Class=:\Aotherneutral\z:}', "");;
    Expect(0, 129995, '\p{Bidi_Class=:\Aotherneutral\z:}', "");;
    Expect(1, 129994, '\p{Bidi_Class=	 Other_neutral}', "");
    Expect(0, 129994, '\p{^Bidi_Class=	 Other_neutral}', "");
    Expect(0, 129994, '\P{Bidi_Class=	 Other_neutral}', "");
    Expect(1, 129994, '\P{^Bidi_Class=	 Other_neutral}', "");
    Expect(0, 129995, '\p{Bidi_Class=	 Other_neutral}', "");
    Expect(1, 129995, '\p{^Bidi_Class=	 Other_neutral}', "");
    Expect(1, 129995, '\P{Bidi_Class=	 Other_neutral}', "");
    Expect(0, 129995, '\P{^Bidi_Class=	 Other_neutral}', "");
    Error('\p{Bc=/a/ -ON}');
    Error('\P{Bc=/a/ -ON}');
    Expect(1, 129994, '\p{Bc=:\AON\z:}', "");;
    Expect(0, 129995, '\p{Bc=:\AON\z:}', "");;
    Expect(1, 129994, '\p{Bc=on}', "");
    Expect(0, 129994, '\p{^Bc=on}', "");
    Expect(0, 129994, '\P{Bc=on}', "");
    Expect(1, 129994, '\P{^Bc=on}', "");
    Expect(0, 129995, '\p{Bc=on}', "");
    Expect(1, 129995, '\p{^Bc=on}', "");
    Expect(1, 129995, '\P{Bc=on}', "");
    Expect(0, 129995, '\P{^Bc=on}', "");
    Expect(1, 129994, '\p{Bc=:\Aon\z:}', "");;
    Expect(0, 129995, '\p{Bc=:\Aon\z:}', "");;
    Expect(1, 129994, '\p{Bc=	ON}', "");
    Expect(0, 129994, '\p{^Bc=	ON}', "");
    Expect(0, 129994, '\P{Bc=	ON}', "");
    Expect(1, 129994, '\P{^Bc=	ON}', "");
    Expect(0, 129995, '\p{Bc=	ON}', "");
    Expect(1, 129995, '\p{^Bc=	ON}', "");
    Expect(1, 129995, '\P{Bc=	ON}', "");
    Expect(0, 129995, '\P{^Bc=	ON}', "");
    Error('\p{Is_Bidi_Class=	-OTHER_Neutral/a/}');
    Error('\P{Is_Bidi_Class=	-OTHER_Neutral/a/}');
    Expect(1, 129994, '\p{Is_Bidi_Class:   otherneutral}', "");
    Expect(0, 129994, '\p{^Is_Bidi_Class:   otherneutral}', "");
    Expect(0, 129994, '\P{Is_Bidi_Class:   otherneutral}', "");
    Expect(1, 129994, '\P{^Is_Bidi_Class:   otherneutral}', "");
    Expect(0, 129995, '\p{Is_Bidi_Class:   otherneutral}', "");
    Expect(1, 129995, '\p{^Is_Bidi_Class:   otherneutral}', "");
    Expect(1, 129995, '\P{Is_Bidi_Class:   otherneutral}', "");
    Expect(0, 129995, '\P{^Is_Bidi_Class:   otherneutral}', "");
    Expect(1, 129994, '\p{Is_Bidi_Class=other_NEUTRAL}', "");
    Expect(0, 129994, '\p{^Is_Bidi_Class=other_NEUTRAL}', "");
    Expect(0, 129994, '\P{Is_Bidi_Class=other_NEUTRAL}', "");
    Expect(1, 129994, '\P{^Is_Bidi_Class=other_NEUTRAL}', "");
    Expect(0, 129995, '\p{Is_Bidi_Class=other_NEUTRAL}', "");
    Expect(1, 129995, '\p{^Is_Bidi_Class=other_NEUTRAL}', "");
    Expect(1, 129995, '\P{Is_Bidi_Class=other_NEUTRAL}', "");
    Expect(0, 129995, '\P{^Is_Bidi_Class=other_NEUTRAL}', "");
    Error('\p{Is_Bc= 	ON:=}');
    Error('\P{Is_Bc= 	ON:=}');
    Expect(1, 129994, '\p{Is_Bc:on}', "");
    Expect(0, 129994, '\p{^Is_Bc:on}', "");
    Expect(0, 129994, '\P{Is_Bc:on}', "");
    Expect(1, 129994, '\P{^Is_Bc:on}', "");
    Expect(0, 129995, '\p{Is_Bc:on}', "");
    Expect(1, 129995, '\p{^Is_Bc:on}', "");
    Expect(1, 129995, '\P{Is_Bc:on}', "");
    Expect(0, 129995, '\P{^Is_Bc:on}', "");
    Expect(1, 129994, '\p{Is_Bc:   _ON}', "");
    Expect(0, 129994, '\p{^Is_Bc:   _ON}', "");
    Expect(0, 129994, '\P{Is_Bc:   _ON}', "");
    Expect(1, 129994, '\P{^Is_Bc:   _ON}', "");
    Expect(0, 129995, '\p{Is_Bc:   _ON}', "");
    Expect(1, 129995, '\p{^Is_Bc:   _ON}', "");
    Expect(1, 129995, '\P{Is_Bc:   _ON}', "");
    Expect(0, 129995, '\P{^Is_Bc:   _ON}', "");
    Error('\p{Bidi_Class=_/a/Pop_Directional_FORMAT}');
    Error('\P{Bidi_Class=_/a/Pop_Directional_FORMAT}');
    Expect(1, 8236, '\p{Bidi_Class=:\APop_Directional_Format\z:}', "");;
    Expect(0, 8237, '\p{Bidi_Class=:\APop_Directional_Format\z:}', "");;
    Expect(1, 8236, '\p{Bidi_Class=popdirectionalformat}', "");
    Expect(0, 8236, '\p{^Bidi_Class=popdirectionalformat}', "");
    Expect(0, 8236, '\P{Bidi_Class=popdirectionalformat}', "");
    Expect(1, 8236, '\P{^Bidi_Class=popdirectionalformat}', "");
    Expect(0, 8237, '\p{Bidi_Class=popdirectionalformat}', "");
    Expect(1, 8237, '\p{^Bidi_Class=popdirectionalformat}', "");
    Expect(1, 8237, '\P{Bidi_Class=popdirectionalformat}', "");
    Expect(0, 8237, '\P{^Bidi_Class=popdirectionalformat}', "");
    Expect(1, 8236, '\p{Bidi_Class=:\Apopdirectionalformat\z:}', "");;
    Expect(0, 8237, '\p{Bidi_Class=:\Apopdirectionalformat\z:}', "");;
    Expect(1, 8236, '\p{Bidi_Class:  	pop_Directional_FORMAT}', "");
    Expect(0, 8236, '\p{^Bidi_Class:  	pop_Directional_FORMAT}', "");
    Expect(0, 8236, '\P{Bidi_Class:  	pop_Directional_FORMAT}', "");
    Expect(1, 8236, '\P{^Bidi_Class:  	pop_Directional_FORMAT}', "");
    Expect(0, 8237, '\p{Bidi_Class:  	pop_Directional_FORMAT}', "");
    Expect(1, 8237, '\p{^Bidi_Class:  	pop_Directional_FORMAT}', "");
    Expect(1, 8237, '\P{Bidi_Class:  	pop_Directional_FORMAT}', "");
    Expect(0, 8237, '\P{^Bidi_Class:  	pop_Directional_FORMAT}', "");
    Error('\p{Bc=	/a/PDF}');
    Error('\P{Bc=	/a/PDF}');
    Expect(1, 8236, '\p{Bc=:\APDF\z:}', "");;
    Expect(0, 8237, '\p{Bc=:\APDF\z:}', "");;
    Expect(1, 8236, '\p{Bc:	pdf}', "");
    Expect(0, 8236, '\p{^Bc:	pdf}', "");
    Expect(0, 8236, '\P{Bc:	pdf}', "");
    Expect(1, 8236, '\P{^Bc:	pdf}', "");
    Expect(0, 8237, '\p{Bc:	pdf}', "");
    Expect(1, 8237, '\p{^Bc:	pdf}', "");
    Expect(1, 8237, '\P{Bc:	pdf}', "");
    Expect(0, 8237, '\P{^Bc:	pdf}', "");
    Expect(1, 8236, '\p{Bc=:\Apdf\z:}', "");;
    Expect(0, 8237, '\p{Bc=:\Apdf\z:}', "");;
    Expect(1, 8236, '\p{Bc=		pdf}', "");
    Expect(0, 8236, '\p{^Bc=		pdf}', "");
    Expect(0, 8236, '\P{Bc=		pdf}', "");
    Expect(1, 8236, '\P{^Bc=		pdf}', "");
    Expect(0, 8237, '\p{Bc=		pdf}', "");
    Expect(1, 8237, '\p{^Bc=		pdf}', "");
    Expect(1, 8237, '\P{Bc=		pdf}', "");
    Expect(0, 8237, '\P{^Bc=		pdf}', "");
    Error('\p{Is_Bidi_Class=-_Pop_directional_format/a/}');
    Error('\P{Is_Bidi_Class=-_Pop_directional_format/a/}');
    Expect(1, 8236, '\p{Is_Bidi_Class=popdirectionalformat}', "");
    Expect(0, 8236, '\p{^Is_Bidi_Class=popdirectionalformat}', "");
    Expect(0, 8236, '\P{Is_Bidi_Class=popdirectionalformat}', "");
    Expect(1, 8236, '\P{^Is_Bidi_Class=popdirectionalformat}', "");
    Expect(0, 8237, '\p{Is_Bidi_Class=popdirectionalformat}', "");
    Expect(1, 8237, '\p{^Is_Bidi_Class=popdirectionalformat}', "");
    Expect(1, 8237, '\P{Is_Bidi_Class=popdirectionalformat}', "");
    Expect(0, 8237, '\P{^Is_Bidi_Class=popdirectionalformat}', "");
    Expect(1, 8236, '\p{Is_Bidi_Class=_POP_Directional_FORMAT}', "");
    Expect(0, 8236, '\p{^Is_Bidi_Class=_POP_Directional_FORMAT}', "");
    Expect(0, 8236, '\P{Is_Bidi_Class=_POP_Directional_FORMAT}', "");
    Expect(1, 8236, '\P{^Is_Bidi_Class=_POP_Directional_FORMAT}', "");
    Expect(0, 8237, '\p{Is_Bidi_Class=_POP_Directional_FORMAT}', "");
    Expect(1, 8237, '\p{^Is_Bidi_Class=_POP_Directional_FORMAT}', "");
    Expect(1, 8237, '\P{Is_Bidi_Class=_POP_Directional_FORMAT}', "");
    Expect(0, 8237, '\P{^Is_Bidi_Class=_POP_Directional_FORMAT}', "");
    Error('\p{Is_Bc:   		pdf:=}');
    Error('\P{Is_Bc:   		pdf:=}');
    Expect(1, 8236, '\p{Is_Bc=pdf}', "");
    Expect(0, 8236, '\p{^Is_Bc=pdf}', "");
    Expect(0, 8236, '\P{Is_Bc=pdf}', "");
    Expect(1, 8236, '\P{^Is_Bc=pdf}', "");
    Expect(0, 8237, '\p{Is_Bc=pdf}', "");
    Expect(1, 8237, '\p{^Is_Bc=pdf}', "");
    Expect(1, 8237, '\P{Is_Bc=pdf}', "");
    Expect(0, 8237, '\P{^Is_Bc=pdf}', "");
    Expect(1, 8236, '\p{Is_Bc=  pdf}', "");
    Expect(0, 8236, '\p{^Is_Bc=  pdf}', "");
    Expect(0, 8236, '\P{Is_Bc=  pdf}', "");
    Expect(1, 8236, '\P{^Is_Bc=  pdf}', "");
    Expect(0, 8237, '\p{Is_Bc=  pdf}', "");
    Expect(1, 8237, '\p{^Is_Bc=  pdf}', "");
    Expect(1, 8237, '\P{Is_Bc=  pdf}', "");
    Expect(0, 8237, '\P{^Is_Bc=  pdf}', "");
    Error('\p{Bidi_Class=/a/Pop_Directional_Isolate}');
    Error('\P{Bidi_Class=/a/Pop_Directional_Isolate}');
    Expect(1, 8297, '\p{Bidi_Class=:\APop_Directional_Isolate\z:}', "");;
    Expect(0, 8298, '\p{Bidi_Class=:\APop_Directional_Isolate\z:}', "");;
    Expect(1, 8297, '\p{Bidi_Class=popdirectionalisolate}', "");
    Expect(0, 8297, '\p{^Bidi_Class=popdirectionalisolate}', "");
    Expect(0, 8297, '\P{Bidi_Class=popdirectionalisolate}', "");
    Expect(1, 8297, '\P{^Bidi_Class=popdirectionalisolate}', "");
    Expect(0, 8298, '\p{Bidi_Class=popdirectionalisolate}', "");
    Expect(1, 8298, '\p{^Bidi_Class=popdirectionalisolate}', "");
    Expect(1, 8298, '\P{Bidi_Class=popdirectionalisolate}', "");
    Expect(0, 8298, '\P{^Bidi_Class=popdirectionalisolate}', "");
    Expect(1, 8297, '\p{Bidi_Class=:\Apopdirectionalisolate\z:}', "");;
    Expect(0, 8298, '\p{Bidi_Class=:\Apopdirectionalisolate\z:}', "");;
    Expect(1, 8297, '\p{Bidi_Class=	pop_Directional_isolate}', "");
    Expect(0, 8297, '\p{^Bidi_Class=	pop_Directional_isolate}', "");
    Expect(0, 8297, '\P{Bidi_Class=	pop_Directional_isolate}', "");
    Expect(1, 8297, '\P{^Bidi_Class=	pop_Directional_isolate}', "");
    Expect(0, 8298, '\p{Bidi_Class=	pop_Directional_isolate}', "");
    Expect(1, 8298, '\p{^Bidi_Class=	pop_Directional_isolate}', "");
    Expect(1, 8298, '\P{Bidi_Class=	pop_Directional_isolate}', "");
    Expect(0, 8298, '\P{^Bidi_Class=	pop_Directional_isolate}', "");
    Error('\p{Bc=/a/ _PDI}');
    Error('\P{Bc=/a/ _PDI}');
    Expect(1, 8297, '\p{Bc=:\APDI\z:}', "");;
    Expect(0, 8298, '\p{Bc=:\APDI\z:}', "");;
    Expect(1, 8297, '\p{Bc=pdi}', "");
    Expect(0, 8297, '\p{^Bc=pdi}', "");
    Expect(0, 8297, '\P{Bc=pdi}', "");
    Expect(1, 8297, '\P{^Bc=pdi}', "");
    Expect(0, 8298, '\p{Bc=pdi}', "");
    Expect(1, 8298, '\p{^Bc=pdi}', "");
    Expect(1, 8298, '\P{Bc=pdi}', "");
    Expect(0, 8298, '\P{^Bc=pdi}', "");
    Expect(1, 8297, '\p{Bc=:\Apdi\z:}', "");;
    Expect(0, 8298, '\p{Bc=:\Apdi\z:}', "");;
    Expect(1, 8297, '\p{Bc= PDI}', "");
    Expect(0, 8297, '\p{^Bc= PDI}', "");
    Expect(0, 8297, '\P{Bc= PDI}', "");
    Expect(1, 8297, '\P{^Bc= PDI}', "");
    Expect(0, 8298, '\p{Bc= PDI}', "");
    Expect(1, 8298, '\p{^Bc= PDI}', "");
    Expect(1, 8298, '\P{Bc= PDI}', "");
    Expect(0, 8298, '\P{^Bc= PDI}', "");
    Error('\p{Is_Bidi_Class=:=_POP_directional_ISOLATE}');
    Error('\P{Is_Bidi_Class=:=_POP_directional_ISOLATE}');
    Expect(1, 8297, '\p{Is_Bidi_Class:	popdirectionalisolate}', "");
    Expect(0, 8297, '\p{^Is_Bidi_Class:	popdirectionalisolate}', "");
    Expect(0, 8297, '\P{Is_Bidi_Class:	popdirectionalisolate}', "");
    Expect(1, 8297, '\P{^Is_Bidi_Class:	popdirectionalisolate}', "");
    Expect(0, 8298, '\p{Is_Bidi_Class:	popdirectionalisolate}', "");
    Expect(1, 8298, '\p{^Is_Bidi_Class:	popdirectionalisolate}', "");
    Expect(1, 8298, '\P{Is_Bidi_Class:	popdirectionalisolate}', "");
    Expect(0, 8298, '\P{^Is_Bidi_Class:	popdirectionalisolate}', "");
    Expect(1, 8297, '\p{Is_Bidi_Class=		pop_Directional_Isolate}', "");
    Expect(0, 8297, '\p{^Is_Bidi_Class=		pop_Directional_Isolate}', "");
    Expect(0, 8297, '\P{Is_Bidi_Class=		pop_Directional_Isolate}', "");
    Expect(1, 8297, '\P{^Is_Bidi_Class=		pop_Directional_Isolate}', "");
    Expect(0, 8298, '\p{Is_Bidi_Class=		pop_Directional_Isolate}', "");
    Expect(1, 8298, '\p{^Is_Bidi_Class=		pop_Directional_Isolate}', "");
    Expect(1, 8298, '\P{Is_Bidi_Class=		pop_Directional_Isolate}', "");
    Expect(0, 8298, '\P{^Is_Bidi_Class=		pop_Directional_Isolate}', "");
    Error('\p{Is_Bc:		:=PDI}');
    Error('\P{Is_Bc:		:=PDI}');
    Expect(1, 8297, '\p{Is_Bc=pdi}', "");
    Expect(0, 8297, '\p{^Is_Bc=pdi}', "");
    Expect(0, 8297, '\P{Is_Bc=pdi}', "");
    Expect(1, 8297, '\P{^Is_Bc=pdi}', "");
    Expect(0, 8298, '\p{Is_Bc=pdi}', "");
    Expect(1, 8298, '\p{^Is_Bc=pdi}', "");
    Expect(1, 8298, '\P{Is_Bc=pdi}', "");
    Expect(0, 8298, '\P{^Is_Bc=pdi}', "");
    Expect(1, 8297, '\p{Is_Bc= PDI}', "");
    Expect(0, 8297, '\p{^Is_Bc= PDI}', "");
    Expect(0, 8297, '\P{Is_Bc= PDI}', "");
    Expect(1, 8297, '\P{^Is_Bc= PDI}', "");
    Expect(0, 8298, '\p{Is_Bc= PDI}', "");
    Expect(1, 8298, '\p{^Is_Bc= PDI}', "");
    Expect(1, 8298, '\P{Is_Bc= PDI}', "");
    Expect(0, 8298, '\P{^Is_Bc= PDI}', "");
    Error('\p{Bidi_Class=	:=Right_To_LEFT}');
    Error('\P{Bidi_Class=	:=Right_To_LEFT}');
    Expect(1, 126975, '\p{Bidi_Class=:\ARight_To_Left\z:}', "");;
    Expect(0, 126976, '\p{Bidi_Class=:\ARight_To_Left\z:}', "");;
    Expect(1, 126975, '\p{Bidi_Class=righttoleft}', "");
    Expect(0, 126975, '\p{^Bidi_Class=righttoleft}', "");
    Expect(0, 126975, '\P{Bidi_Class=righttoleft}', "");
    Expect(1, 126975, '\P{^Bidi_Class=righttoleft}', "");
    Expect(0, 126976, '\p{Bidi_Class=righttoleft}', "");
    Expect(1, 126976, '\p{^Bidi_Class=righttoleft}', "");
    Expect(1, 126976, '\P{Bidi_Class=righttoleft}', "");
    Expect(0, 126976, '\P{^Bidi_Class=righttoleft}', "");
    Expect(1, 126975, '\p{Bidi_Class=:\Arighttoleft\z:}', "");;
    Expect(0, 126976, '\p{Bidi_Class=:\Arighttoleft\z:}', "");;
    Expect(1, 126975, '\p{Bidi_Class:			RIGHT_To_Left}', "");
    Expect(0, 126975, '\p{^Bidi_Class:			RIGHT_To_Left}', "");
    Expect(0, 126975, '\P{Bidi_Class:			RIGHT_To_Left}', "");
    Expect(1, 126975, '\P{^Bidi_Class:			RIGHT_To_Left}', "");
    Expect(0, 126976, '\p{Bidi_Class:			RIGHT_To_Left}', "");
    Expect(1, 126976, '\p{^Bidi_Class:			RIGHT_To_Left}', "");
    Expect(1, 126976, '\P{Bidi_Class:			RIGHT_To_Left}', "");
    Expect(0, 126976, '\P{^Bidi_Class:			RIGHT_To_Left}', "");
    Error('\p{Bc=	:=R}');
    Error('\P{Bc=	:=R}');
    Expect(1, 126975, '\p{Bc=:\AR\z:}', "");;
    Expect(0, 126976, '\p{Bc=:\AR\z:}', "");;
    Expect(1, 126975, '\p{Bc=r}', "");
    Expect(0, 126975, '\p{^Bc=r}', "");
    Expect(0, 126975, '\P{Bc=r}', "");
    Expect(1, 126975, '\P{^Bc=r}', "");
    Expect(0, 126976, '\p{Bc=r}', "");
    Expect(1, 126976, '\p{^Bc=r}', "");
    Expect(1, 126976, '\P{Bc=r}', "");
    Expect(0, 126976, '\P{^Bc=r}', "");
    Expect(1, 126975, '\p{Bc=:\Ar\z:}', "");;
    Expect(0, 126976, '\p{Bc=:\Ar\z:}', "");;
    Expect(1, 126975, '\p{Bc= R}', "");
    Expect(0, 126975, '\p{^Bc= R}', "");
    Expect(0, 126975, '\P{Bc= R}', "");
    Expect(1, 126975, '\P{^Bc= R}', "");
    Expect(0, 126976, '\p{Bc= R}', "");
    Expect(1, 126976, '\p{^Bc= R}', "");
    Expect(1, 126976, '\P{Bc= R}', "");
    Expect(0, 126976, '\P{^Bc= R}', "");
    Error('\p{Is_Bidi_Class=:=_right_TO_Left}');
    Error('\P{Is_Bidi_Class=:=_right_TO_Left}');
    Expect(1, 126975, '\p{Is_Bidi_Class=righttoleft}', "");
    Expect(0, 126975, '\p{^Is_Bidi_Class=righttoleft}', "");
    Expect(0, 126975, '\P{Is_Bidi_Class=righttoleft}', "");
    Expect(1, 126975, '\P{^Is_Bidi_Class=righttoleft}', "");
    Expect(0, 126976, '\p{Is_Bidi_Class=righttoleft}', "");
    Expect(1, 126976, '\p{^Is_Bidi_Class=righttoleft}', "");
    Expect(1, 126976, '\P{Is_Bidi_Class=righttoleft}', "");
    Expect(0, 126976, '\P{^Is_Bidi_Class=righttoleft}', "");
    Expect(1, 126975, '\p{Is_Bidi_Class=	 Right_To_LEFT}', "");
    Expect(0, 126975, '\p{^Is_Bidi_Class=	 Right_To_LEFT}', "");
    Expect(0, 126975, '\P{Is_Bidi_Class=	 Right_To_LEFT}', "");
    Expect(1, 126975, '\P{^Is_Bidi_Class=	 Right_To_LEFT}', "");
    Expect(0, 126976, '\p{Is_Bidi_Class=	 Right_To_LEFT}', "");
    Expect(1, 126976, '\p{^Is_Bidi_Class=	 Right_To_LEFT}', "");
    Expect(1, 126976, '\P{Is_Bidi_Class=	 Right_To_LEFT}', "");
    Expect(0, 126976, '\P{^Is_Bidi_Class=	 Right_To_LEFT}', "");
    Error('\p{Is_Bc=:= 	R}');
    Error('\P{Is_Bc=:= 	R}');
    Expect(1, 126975, '\p{Is_Bc=r}', "");
    Expect(0, 126975, '\p{^Is_Bc=r}', "");
    Expect(0, 126975, '\P{Is_Bc=r}', "");
    Expect(1, 126975, '\P{^Is_Bc=r}', "");
    Expect(0, 126976, '\p{Is_Bc=r}', "");
    Expect(1, 126976, '\p{^Is_Bc=r}', "");
    Expect(1, 126976, '\P{Is_Bc=r}', "");
    Expect(0, 126976, '\P{^Is_Bc=r}', "");
    Expect(1, 126975, '\p{Is_Bc=- R}', "");
    Expect(0, 126975, '\p{^Is_Bc=- R}', "");
    Expect(0, 126975, '\P{Is_Bc=- R}', "");
    Expect(1, 126975, '\P{^Is_Bc=- R}', "");
    Expect(0, 126976, '\p{Is_Bc=- R}', "");
    Expect(1, 126976, '\p{^Is_Bc=- R}', "");
    Expect(1, 126976, '\P{Is_Bc=- R}', "");
    Expect(0, 126976, '\P{^Is_Bc=- R}', "");
    Error('\p{Bidi_Class= :=right_To_Left_EMBEDDING}');
    Error('\P{Bidi_Class= :=right_To_Left_EMBEDDING}');
    Expect(1, 8235, '\p{Bidi_Class=:\ARight_To_Left_Embedding\z:}', "");;
    Expect(0, 8236, '\p{Bidi_Class=:\ARight_To_Left_Embedding\z:}', "");;
    Expect(1, 8235, '\p{Bidi_Class=righttoleftembedding}', "");
    Expect(0, 8235, '\p{^Bidi_Class=righttoleftembedding}', "");
    Expect(0, 8235, '\P{Bidi_Class=righttoleftembedding}', "");
    Expect(1, 8235, '\P{^Bidi_Class=righttoleftembedding}', "");
    Expect(0, 8236, '\p{Bidi_Class=righttoleftembedding}', "");
    Expect(1, 8236, '\p{^Bidi_Class=righttoleftembedding}', "");
    Expect(1, 8236, '\P{Bidi_Class=righttoleftembedding}', "");
    Expect(0, 8236, '\P{^Bidi_Class=righttoleftembedding}', "");
    Expect(1, 8235, '\p{Bidi_Class=:\Arighttoleftembedding\z:}', "");;
    Expect(0, 8236, '\p{Bidi_Class=:\Arighttoleftembedding\z:}', "");;
    Expect(1, 8235, '\p{Bidi_Class=	 RIGHT_to_left_EMBEDDING}', "");
    Expect(0, 8235, '\p{^Bidi_Class=	 RIGHT_to_left_EMBEDDING}', "");
    Expect(0, 8235, '\P{Bidi_Class=	 RIGHT_to_left_EMBEDDING}', "");
    Expect(1, 8235, '\P{^Bidi_Class=	 RIGHT_to_left_EMBEDDING}', "");
    Expect(0, 8236, '\p{Bidi_Class=	 RIGHT_to_left_EMBEDDING}', "");
    Expect(1, 8236, '\p{^Bidi_Class=	 RIGHT_to_left_EMBEDDING}', "");
    Expect(1, 8236, '\P{Bidi_Class=	 RIGHT_to_left_EMBEDDING}', "");
    Expect(0, 8236, '\P{^Bidi_Class=	 RIGHT_to_left_EMBEDDING}', "");
    Error('\p{Bc=/a/-RLE}');
    Error('\P{Bc=/a/-RLE}');
    Expect(1, 8235, '\p{Bc=:\ARLE\z:}', "");;
    Expect(0, 8236, '\p{Bc=:\ARLE\z:}', "");;
    Expect(1, 8235, '\p{Bc=rle}', "");
    Expect(0, 8235, '\p{^Bc=rle}', "");
    Expect(0, 8235, '\P{Bc=rle}', "");
    Expect(1, 8235, '\P{^Bc=rle}', "");
    Expect(0, 8236, '\p{Bc=rle}', "");
    Expect(1, 8236, '\p{^Bc=rle}', "");
    Expect(1, 8236, '\P{Bc=rle}', "");
    Expect(0, 8236, '\P{^Bc=rle}', "");
    Expect(1, 8235, '\p{Bc=:\Arle\z:}', "");;
    Expect(0, 8236, '\p{Bc=:\Arle\z:}', "");;
    Expect(1, 8235, '\p{Bc=	 RLE}', "");
    Expect(0, 8235, '\p{^Bc=	 RLE}', "");
    Expect(0, 8235, '\P{Bc=	 RLE}', "");
    Expect(1, 8235, '\P{^Bc=	 RLE}', "");
    Expect(0, 8236, '\p{Bc=	 RLE}', "");
    Expect(1, 8236, '\p{^Bc=	 RLE}', "");
    Expect(1, 8236, '\P{Bc=	 RLE}', "");
    Expect(0, 8236, '\P{^Bc=	 RLE}', "");
    Error('\p{Is_Bidi_Class: _	Right_To_left_EMBEDDING:=}');
    Error('\P{Is_Bidi_Class: _	Right_To_left_EMBEDDING:=}');
    Expect(1, 8235, '\p{Is_Bidi_Class=righttoleftembedding}', "");
    Expect(0, 8235, '\p{^Is_Bidi_Class=righttoleftembedding}', "");
    Expect(0, 8235, '\P{Is_Bidi_Class=righttoleftembedding}', "");
    Expect(1, 8235, '\P{^Is_Bidi_Class=righttoleftembedding}', "");
    Expect(0, 8236, '\p{Is_Bidi_Class=righttoleftembedding}', "");
    Expect(1, 8236, '\p{^Is_Bidi_Class=righttoleftembedding}', "");
    Expect(1, 8236, '\P{Is_Bidi_Class=righttoleftembedding}', "");
    Expect(0, 8236, '\P{^Is_Bidi_Class=righttoleftembedding}', "");
    Expect(1, 8235, '\p{Is_Bidi_Class=--right_To_Left_embedding}', "");
    Expect(0, 8235, '\p{^Is_Bidi_Class=--right_To_Left_embedding}', "");
    Expect(0, 8235, '\P{Is_Bidi_Class=--right_To_Left_embedding}', "");
    Expect(1, 8235, '\P{^Is_Bidi_Class=--right_To_Left_embedding}', "");
    Expect(0, 8236, '\p{Is_Bidi_Class=--right_To_Left_embedding}', "");
    Expect(1, 8236, '\p{^Is_Bidi_Class=--right_To_Left_embedding}', "");
    Expect(1, 8236, '\P{Is_Bidi_Class=--right_To_Left_embedding}', "");
    Expect(0, 8236, '\P{^Is_Bidi_Class=--right_To_Left_embedding}', "");
    Error('\p{Is_Bc=-RLE:=}');
    Error('\P{Is_Bc=-RLE:=}');
    Expect(1, 8235, '\p{Is_Bc=rle}', "");
    Expect(0, 8235, '\p{^Is_Bc=rle}', "");
    Expect(0, 8235, '\P{Is_Bc=rle}', "");
    Expect(1, 8235, '\P{^Is_Bc=rle}', "");
    Expect(0, 8236, '\p{Is_Bc=rle}', "");
    Expect(1, 8236, '\p{^Is_Bc=rle}', "");
    Expect(1, 8236, '\P{Is_Bc=rle}', "");
    Expect(0, 8236, '\P{^Is_Bc=rle}', "");
    Expect(1, 8235, '\p{Is_Bc=_-RLE}', "");
    Expect(0, 8235, '\p{^Is_Bc=_-RLE}', "");
    Expect(0, 8235, '\P{Is_Bc=_-RLE}', "");
    Expect(1, 8235, '\P{^Is_Bc=_-RLE}', "");
    Expect(0, 8236, '\p{Is_Bc=_-RLE}', "");
    Expect(1, 8236, '\p{^Is_Bc=_-RLE}', "");
    Expect(1, 8236, '\P{Is_Bc=_-RLE}', "");
    Expect(0, 8236, '\P{^Is_Bc=_-RLE}', "");
    Error('\p{Bidi_Class::=--RIGHT_To_left_Isolate}');
    Error('\P{Bidi_Class::=--RIGHT_To_left_Isolate}');
    Expect(1, 8295, '\p{Bidi_Class=:\ARight_To_Left_Isolate\z:}', "");;
    Expect(0, 8296, '\p{Bidi_Class=:\ARight_To_Left_Isolate\z:}', "");;
    Expect(1, 8295, '\p{Bidi_Class=righttoleftisolate}', "");
    Expect(0, 8295, '\p{^Bidi_Class=righttoleftisolate}', "");
    Expect(0, 8295, '\P{Bidi_Class=righttoleftisolate}', "");
    Expect(1, 8295, '\P{^Bidi_Class=righttoleftisolate}', "");
    Expect(0, 8296, '\p{Bidi_Class=righttoleftisolate}', "");
    Expect(1, 8296, '\p{^Bidi_Class=righttoleftisolate}', "");
    Expect(1, 8296, '\P{Bidi_Class=righttoleftisolate}', "");
    Expect(0, 8296, '\P{^Bidi_Class=righttoleftisolate}', "");
    Expect(1, 8295, '\p{Bidi_Class=:\Arighttoleftisolate\z:}', "");;
    Expect(0, 8296, '\p{Bidi_Class=:\Arighttoleftisolate\z:}', "");;
    Expect(1, 8295, '\p{Bidi_Class=	_right_to_left_Isolate}', "");
    Expect(0, 8295, '\p{^Bidi_Class=	_right_to_left_Isolate}', "");
    Expect(0, 8295, '\P{Bidi_Class=	_right_to_left_Isolate}', "");
    Expect(1, 8295, '\P{^Bidi_Class=	_right_to_left_Isolate}', "");
    Expect(0, 8296, '\p{Bidi_Class=	_right_to_left_Isolate}', "");
    Expect(1, 8296, '\p{^Bidi_Class=	_right_to_left_Isolate}', "");
    Expect(1, 8296, '\P{Bidi_Class=	_right_to_left_Isolate}', "");
    Expect(0, 8296, '\P{^Bidi_Class=	_right_to_left_Isolate}', "");
    Error('\p{Bc::=	rli}');
    Error('\P{Bc::=	rli}');
    Expect(1, 8295, '\p{Bc=:\ARLI\z:}', "");;
    Expect(0, 8296, '\p{Bc=:\ARLI\z:}', "");;
    Expect(1, 8295, '\p{Bc: rli}', "");
    Expect(0, 8295, '\p{^Bc: rli}', "");
    Expect(0, 8295, '\P{Bc: rli}', "");
    Expect(1, 8295, '\P{^Bc: rli}', "");
    Expect(0, 8296, '\p{Bc: rli}', "");
    Expect(1, 8296, '\p{^Bc: rli}', "");
    Expect(1, 8296, '\P{Bc: rli}', "");
    Expect(0, 8296, '\P{^Bc: rli}', "");
    Expect(1, 8295, '\p{Bc=:\Arli\z:}', "");;
    Expect(0, 8296, '\p{Bc=:\Arli\z:}', "");;
    Expect(1, 8295, '\p{Bc= RLI}', "");
    Expect(0, 8295, '\p{^Bc= RLI}', "");
    Expect(0, 8295, '\P{Bc= RLI}', "");
    Expect(1, 8295, '\P{^Bc= RLI}', "");
    Expect(0, 8296, '\p{Bc= RLI}', "");
    Expect(1, 8296, '\p{^Bc= RLI}', "");
    Expect(1, 8296, '\P{Bc= RLI}', "");
    Expect(0, 8296, '\P{^Bc= RLI}', "");
    Error('\p{Is_Bidi_Class=-:=right_To_Left_Isolate}');
    Error('\P{Is_Bidi_Class=-:=right_To_Left_Isolate}');
    Expect(1, 8295, '\p{Is_Bidi_Class=righttoleftisolate}', "");
    Expect(0, 8295, '\p{^Is_Bidi_Class=righttoleftisolate}', "");
    Expect(0, 8295, '\P{Is_Bidi_Class=righttoleftisolate}', "");
    Expect(1, 8295, '\P{^Is_Bidi_Class=righttoleftisolate}', "");
    Expect(0, 8296, '\p{Is_Bidi_Class=righttoleftisolate}', "");
    Expect(1, 8296, '\p{^Is_Bidi_Class=righttoleftisolate}', "");
    Expect(1, 8296, '\P{Is_Bidi_Class=righttoleftisolate}', "");
    Expect(0, 8296, '\P{^Is_Bidi_Class=righttoleftisolate}', "");
    Expect(1, 8295, '\p{Is_Bidi_Class=_Right_To_Left_isolate}', "");
    Expect(0, 8295, '\p{^Is_Bidi_Class=_Right_To_Left_isolate}', "");
    Expect(0, 8295, '\P{Is_Bidi_Class=_Right_To_Left_isolate}', "");
    Expect(1, 8295, '\P{^Is_Bidi_Class=_Right_To_Left_isolate}', "");
    Expect(0, 8296, '\p{Is_Bidi_Class=_Right_To_Left_isolate}', "");
    Expect(1, 8296, '\p{^Is_Bidi_Class=_Right_To_Left_isolate}', "");
    Expect(1, 8296, '\P{Is_Bidi_Class=_Right_To_Left_isolate}', "");
    Expect(0, 8296, '\P{^Is_Bidi_Class=_Right_To_Left_isolate}', "");
    Error('\p{Is_Bc= /a/RLI}');
    Error('\P{Is_Bc= /a/RLI}');
    Expect(1, 8295, '\p{Is_Bc=rli}', "");
    Expect(0, 8295, '\p{^Is_Bc=rli}', "");
    Expect(0, 8295, '\P{Is_Bc=rli}', "");
    Expect(1, 8295, '\P{^Is_Bc=rli}', "");
    Expect(0, 8296, '\p{Is_Bc=rli}', "");
    Expect(1, 8296, '\p{^Is_Bc=rli}', "");
    Expect(1, 8296, '\P{Is_Bc=rli}', "");
    Expect(0, 8296, '\P{^Is_Bc=rli}', "");
    Expect(1, 8295, '\p{Is_Bc=_-RLI}', "");
    Expect(0, 8295, '\p{^Is_Bc=_-RLI}', "");
    Expect(0, 8295, '\P{Is_Bc=_-RLI}', "");
    Expect(1, 8295, '\P{^Is_Bc=_-RLI}', "");
    Expect(0, 8296, '\p{Is_Bc=_-RLI}', "");
    Expect(1, 8296, '\p{^Is_Bc=_-RLI}', "");
    Expect(1, 8296, '\P{Is_Bc=_-RLI}', "");
    Expect(0, 8296, '\P{^Is_Bc=_-RLI}', "");
    Error('\p{Bidi_Class=	/a/right_to_Left_Override}');
    Error('\P{Bidi_Class=	/a/right_to_Left_Override}');
    Expect(1, 8238, '\p{Bidi_Class=:\ARight_To_Left_Override\z:}', "");;
    Expect(0, 8239, '\p{Bidi_Class=:\ARight_To_Left_Override\z:}', "");;
    Expect(1, 8238, '\p{Bidi_Class=righttoleftoverride}', "");
    Expect(0, 8238, '\p{^Bidi_Class=righttoleftoverride}', "");
    Expect(0, 8238, '\P{Bidi_Class=righttoleftoverride}', "");
    Expect(1, 8238, '\P{^Bidi_Class=righttoleftoverride}', "");
    Expect(0, 8239, '\p{Bidi_Class=righttoleftoverride}', "");
    Expect(1, 8239, '\p{^Bidi_Class=righttoleftoverride}', "");
    Expect(1, 8239, '\P{Bidi_Class=righttoleftoverride}', "");
    Expect(0, 8239, '\P{^Bidi_Class=righttoleftoverride}', "");
    Expect(1, 8238, '\p{Bidi_Class=:\Arighttoleftoverride\z:}', "");;
    Expect(0, 8239, '\p{Bidi_Class=:\Arighttoleftoverride\z:}', "");;
    Expect(1, 8238, '\p{Bidi_Class=	_Right_To_left_override}', "");
    Expect(0, 8238, '\p{^Bidi_Class=	_Right_To_left_override}', "");
    Expect(0, 8238, '\P{Bidi_Class=	_Right_To_left_override}', "");
    Expect(1, 8238, '\P{^Bidi_Class=	_Right_To_left_override}', "");
    Expect(0, 8239, '\p{Bidi_Class=	_Right_To_left_override}', "");
    Expect(1, 8239, '\p{^Bidi_Class=	_Right_To_left_override}', "");
    Expect(1, 8239, '\P{Bidi_Class=	_Right_To_left_override}', "");
    Expect(0, 8239, '\P{^Bidi_Class=	_Right_To_left_override}', "");
    Error('\p{Bc=__rlo/a/}');
    Error('\P{Bc=__rlo/a/}');
    Expect(1, 8238, '\p{Bc=:\ARLO\z:}', "");;
    Expect(0, 8239, '\p{Bc=:\ARLO\z:}', "");;
    Expect(1, 8238, '\p{Bc=rlo}', "");
    Expect(0, 8238, '\p{^Bc=rlo}', "");
    Expect(0, 8238, '\P{Bc=rlo}', "");
    Expect(1, 8238, '\P{^Bc=rlo}', "");
    Expect(0, 8239, '\p{Bc=rlo}', "");
    Expect(1, 8239, '\p{^Bc=rlo}', "");
    Expect(1, 8239, '\P{Bc=rlo}', "");
    Expect(0, 8239, '\P{^Bc=rlo}', "");
    Expect(1, 8238, '\p{Bc=:\Arlo\z:}', "");;
    Expect(0, 8239, '\p{Bc=:\Arlo\z:}', "");;
    Expect(1, 8238, '\p{Bc=	 rlo}', "");
    Expect(0, 8238, '\p{^Bc=	 rlo}', "");
    Expect(0, 8238, '\P{Bc=	 rlo}', "");
    Expect(1, 8238, '\P{^Bc=	 rlo}', "");
    Expect(0, 8239, '\p{Bc=	 rlo}', "");
    Expect(1, 8239, '\p{^Bc=	 rlo}', "");
    Expect(1, 8239, '\P{Bc=	 rlo}', "");
    Expect(0, 8239, '\P{^Bc=	 rlo}', "");
    Error('\p{Is_Bidi_Class=	 Right_To_Left_OVERRIDE/a/}');
    Error('\P{Is_Bidi_Class=	 Right_To_Left_OVERRIDE/a/}');
    Expect(1, 8238, '\p{Is_Bidi_Class=righttoleftoverride}', "");
    Expect(0, 8238, '\p{^Is_Bidi_Class=righttoleftoverride}', "");
    Expect(0, 8238, '\P{Is_Bidi_Class=righttoleftoverride}', "");
    Expect(1, 8238, '\P{^Is_Bidi_Class=righttoleftoverride}', "");
    Expect(0, 8239, '\p{Is_Bidi_Class=righttoleftoverride}', "");
    Expect(1, 8239, '\p{^Is_Bidi_Class=righttoleftoverride}', "");
    Expect(1, 8239, '\P{Is_Bidi_Class=righttoleftoverride}', "");
    Expect(0, 8239, '\P{^Is_Bidi_Class=righttoleftoverride}', "");
    Expect(1, 8238, '\p{Is_Bidi_Class: -right_to_left_override}', "");
    Expect(0, 8238, '\p{^Is_Bidi_Class: -right_to_left_override}', "");
    Expect(0, 8238, '\P{Is_Bidi_Class: -right_to_left_override}', "");
    Expect(1, 8238, '\P{^Is_Bidi_Class: -right_to_left_override}', "");
    Expect(0, 8239, '\p{Is_Bidi_Class: -right_to_left_override}', "");
    Expect(1, 8239, '\p{^Is_Bidi_Class: -right_to_left_override}', "");
    Expect(1, 8239, '\P{Is_Bidi_Class: -right_to_left_override}', "");
    Expect(0, 8239, '\P{^Is_Bidi_Class: -right_to_left_override}', "");
    Error('\p{Is_Bc=:=_	RLO}');
    Error('\P{Is_Bc=:=_	RLO}');
    Expect(1, 8238, '\p{Is_Bc=rlo}', "");
    Expect(0, 8238, '\p{^Is_Bc=rlo}', "");
    Expect(0, 8238, '\P{Is_Bc=rlo}', "");
    Expect(1, 8238, '\P{^Is_Bc=rlo}', "");
    Expect(0, 8239, '\p{Is_Bc=rlo}', "");
    Expect(1, 8239, '\p{^Is_Bc=rlo}', "");
    Expect(1, 8239, '\P{Is_Bc=rlo}', "");
    Expect(0, 8239, '\P{^Is_Bc=rlo}', "");
    Expect(1, 8238, '\p{Is_Bc=-RLO}', "");
    Expect(0, 8238, '\p{^Is_Bc=-RLO}', "");
    Expect(0, 8238, '\P{Is_Bc=-RLO}', "");
    Expect(1, 8238, '\P{^Is_Bc=-RLO}', "");
    Expect(0, 8239, '\p{Is_Bc=-RLO}', "");
    Expect(1, 8239, '\p{^Is_Bc=-RLO}', "");
    Expect(1, 8239, '\P{Is_Bc=-RLO}', "");
    Expect(0, 8239, '\P{^Is_Bc=-RLO}', "");
    Error('\p{Bidi_Class=__Segment_Separator/a/}');
    Error('\P{Bidi_Class=__Segment_Separator/a/}');
    Expect(1, 31, '\p{Bidi_Class=:\ASegment_Separator\z:}', "");;
    Expect(0, 32, '\p{Bidi_Class=:\ASegment_Separator\z:}', "");;
    Expect(1, 31, '\p{Bidi_Class:   segmentseparator}', "");
    Expect(0, 31, '\p{^Bidi_Class:   segmentseparator}', "");
    Expect(0, 31, '\P{Bidi_Class:   segmentseparator}', "");
    Expect(1, 31, '\P{^Bidi_Class:   segmentseparator}', "");
    Expect(0, 32, '\p{Bidi_Class:   segmentseparator}', "");
    Expect(1, 32, '\p{^Bidi_Class:   segmentseparator}', "");
    Expect(1, 32, '\P{Bidi_Class:   segmentseparator}', "");
    Expect(0, 32, '\P{^Bidi_Class:   segmentseparator}', "");
    Expect(1, 31, '\p{Bidi_Class=:\Asegmentseparator\z:}', "");;
    Expect(0, 32, '\p{Bidi_Class=:\Asegmentseparator\z:}', "");;
    Expect(1, 31, '\p{Bidi_Class= 	SEGMENT_SEPARATOR}', "");
    Expect(0, 31, '\p{^Bidi_Class= 	SEGMENT_SEPARATOR}', "");
    Expect(0, 31, '\P{Bidi_Class= 	SEGMENT_SEPARATOR}', "");
    Expect(1, 31, '\P{^Bidi_Class= 	SEGMENT_SEPARATOR}', "");
    Expect(0, 32, '\p{Bidi_Class= 	SEGMENT_SEPARATOR}', "");
    Expect(1, 32, '\p{^Bidi_Class= 	SEGMENT_SEPARATOR}', "");
    Expect(1, 32, '\P{Bidi_Class= 	SEGMENT_SEPARATOR}', "");
    Expect(0, 32, '\P{^Bidi_Class= 	SEGMENT_SEPARATOR}', "");
    Error('\p{Bc:- S/a/}');
    Error('\P{Bc:- S/a/}');
    Expect(1, 31, '\p{Bc=:\AS\z:}', "");;
    Expect(0, 32, '\p{Bc=:\AS\z:}', "");;
    Expect(1, 31, '\p{Bc=s}', "");
    Expect(0, 31, '\p{^Bc=s}', "");
    Expect(0, 31, '\P{Bc=s}', "");
    Expect(1, 31, '\P{^Bc=s}', "");
    Expect(0, 32, '\p{Bc=s}', "");
    Expect(1, 32, '\p{^Bc=s}', "");
    Expect(1, 32, '\P{Bc=s}', "");
    Expect(0, 32, '\P{^Bc=s}', "");
    Expect(1, 31, '\p{Bc=:\As\z:}', "");;
    Expect(0, 32, '\p{Bc=:\As\z:}', "");;
    Expect(1, 31, '\p{Bc=_S}', "");
    Expect(0, 31, '\p{^Bc=_S}', "");
    Expect(0, 31, '\P{Bc=_S}', "");
    Expect(1, 31, '\P{^Bc=_S}', "");
    Expect(0, 32, '\p{Bc=_S}', "");
    Expect(1, 32, '\p{^Bc=_S}', "");
    Expect(1, 32, '\P{Bc=_S}', "");
    Expect(0, 32, '\P{^Bc=_S}', "");
    Error('\p{Is_Bidi_Class=_	segment_Separator/a/}');
    Error('\P{Is_Bidi_Class=_	segment_Separator/a/}');
    Expect(1, 31, '\p{Is_Bidi_Class=segmentseparator}', "");
    Expect(0, 31, '\p{^Is_Bidi_Class=segmentseparator}', "");
    Expect(0, 31, '\P{Is_Bidi_Class=segmentseparator}', "");
    Expect(1, 31, '\P{^Is_Bidi_Class=segmentseparator}', "");
    Expect(0, 32, '\p{Is_Bidi_Class=segmentseparator}', "");
    Expect(1, 32, '\p{^Is_Bidi_Class=segmentseparator}', "");
    Expect(1, 32, '\P{Is_Bidi_Class=segmentseparator}', "");
    Expect(0, 32, '\P{^Is_Bidi_Class=segmentseparator}', "");
    Expect(1, 31, '\p{Is_Bidi_Class= _Segment_SEPARATOR}', "");
    Expect(0, 31, '\p{^Is_Bidi_Class= _Segment_SEPARATOR}', "");
    Expect(0, 31, '\P{Is_Bidi_Class= _Segment_SEPARATOR}', "");
    Expect(1, 31, '\P{^Is_Bidi_Class= _Segment_SEPARATOR}', "");
    Expect(0, 32, '\p{Is_Bidi_Class= _Segment_SEPARATOR}', "");
    Expect(1, 32, '\p{^Is_Bidi_Class= _Segment_SEPARATOR}', "");
    Expect(1, 32, '\P{Is_Bidi_Class= _Segment_SEPARATOR}', "");
    Expect(0, 32, '\P{^Is_Bidi_Class= _Segment_SEPARATOR}', "");
    Error('\p{Is_Bc=:=- S}');
    Error('\P{Is_Bc=:=- S}');
    Expect(1, 31, '\p{Is_Bc=s}', "");
    Expect(0, 31, '\p{^Is_Bc=s}', "");
    Expect(0, 31, '\P{Is_Bc=s}', "");
    Expect(1, 31, '\P{^Is_Bc=s}', "");
    Expect(0, 32, '\p{Is_Bc=s}', "");
    Expect(1, 32, '\p{^Is_Bc=s}', "");
    Expect(1, 32, '\P{Is_Bc=s}', "");
    Expect(0, 32, '\P{^Is_Bc=s}', "");
    Expect(1, 31, '\p{Is_Bc=__S}', "");
    Expect(0, 31, '\p{^Is_Bc=__S}', "");
    Expect(0, 31, '\P{Is_Bc=__S}', "");
    Expect(1, 31, '\P{^Is_Bc=__S}', "");
    Expect(0, 32, '\p{Is_Bc=__S}', "");
    Expect(1, 32, '\p{^Is_Bc=__S}', "");
    Expect(1, 32, '\P{Is_Bc=__S}', "");
    Expect(0, 32, '\P{^Is_Bc=__S}', "");
    Error('\p{Bidi_Class: :=-white_SPACE}');
    Error('\P{Bidi_Class: :=-white_SPACE}');
    Expect(1, 12288, '\p{Bidi_Class=:\AWhite_Space\z:}', "");;
    Expect(0, 12289, '\p{Bidi_Class=:\AWhite_Space\z:}', "");;
    Expect(1, 12288, '\p{Bidi_Class=whitespace}', "");
    Expect(0, 12288, '\p{^Bidi_Class=whitespace}', "");
    Expect(0, 12288, '\P{Bidi_Class=whitespace}', "");
    Expect(1, 12288, '\P{^Bidi_Class=whitespace}', "");
    Expect(0, 12289, '\p{Bidi_Class=whitespace}', "");
    Expect(1, 12289, '\p{^Bidi_Class=whitespace}', "");
    Expect(1, 12289, '\P{Bidi_Class=whitespace}', "");
    Expect(0, 12289, '\P{^Bidi_Class=whitespace}', "");
    Expect(1, 12288, '\p{Bidi_Class=:\Awhitespace\z:}', "");;
    Expect(0, 12289, '\p{Bidi_Class=:\Awhitespace\z:}', "");;
    Expect(1, 12288, '\p{Bidi_Class=	white_Space}', "");
    Expect(0, 12288, '\p{^Bidi_Class=	white_Space}', "");
    Expect(0, 12288, '\P{Bidi_Class=	white_Space}', "");
    Expect(1, 12288, '\P{^Bidi_Class=	white_Space}', "");
    Expect(0, 12289, '\p{Bidi_Class=	white_Space}', "");
    Expect(1, 12289, '\p{^Bidi_Class=	white_Space}', "");
    Expect(1, 12289, '\P{Bidi_Class=	white_Space}', "");
    Expect(0, 12289, '\P{^Bidi_Class=	white_Space}', "");
    Error('\p{Bc=	 WS/a/}');
    Error('\P{Bc=	 WS/a/}');
    Expect(1, 12288, '\p{Bc=:\AWS\z:}', "");;
    Expect(0, 12289, '\p{Bc=:\AWS\z:}', "");;
    Expect(1, 12288, '\p{Bc=ws}', "");
    Expect(0, 12288, '\p{^Bc=ws}', "");
    Expect(0, 12288, '\P{Bc=ws}', "");
    Expect(1, 12288, '\P{^Bc=ws}', "");
    Expect(0, 12289, '\p{Bc=ws}', "");
    Expect(1, 12289, '\p{^Bc=ws}', "");
    Expect(1, 12289, '\P{Bc=ws}', "");
    Expect(0, 12289, '\P{^Bc=ws}', "");
    Expect(1, 12288, '\p{Bc=:\Aws\z:}', "");;
    Expect(0, 12289, '\p{Bc=:\Aws\z:}', "");;
    Expect(1, 12288, '\p{Bc=WS}', "");
    Expect(0, 12288, '\p{^Bc=WS}', "");
    Expect(0, 12288, '\P{Bc=WS}', "");
    Expect(1, 12288, '\P{^Bc=WS}', "");
    Expect(0, 12289, '\p{Bc=WS}', "");
    Expect(1, 12289, '\p{^Bc=WS}', "");
    Expect(1, 12289, '\P{Bc=WS}', "");
    Expect(0, 12289, '\P{^Bc=WS}', "");
    Error('\p{Is_Bidi_Class=	White_Space:=}');
    Error('\P{Is_Bidi_Class=	White_Space:=}');
    Expect(1, 12288, '\p{Is_Bidi_Class:   whitespace}', "");
    Expect(0, 12288, '\p{^Is_Bidi_Class:   whitespace}', "");
    Expect(0, 12288, '\P{Is_Bidi_Class:   whitespace}', "");
    Expect(1, 12288, '\P{^Is_Bidi_Class:   whitespace}', "");
    Expect(0, 12289, '\p{Is_Bidi_Class:   whitespace}', "");
    Expect(1, 12289, '\p{^Is_Bidi_Class:   whitespace}', "");
    Expect(1, 12289, '\P{Is_Bidi_Class:   whitespace}', "");
    Expect(0, 12289, '\P{^Is_Bidi_Class:   whitespace}', "");
    Expect(1, 12288, '\p{Is_Bidi_Class=-white_Space}', "");
    Expect(0, 12288, '\p{^Is_Bidi_Class=-white_Space}', "");
    Expect(0, 12288, '\P{Is_Bidi_Class=-white_Space}', "");
    Expect(1, 12288, '\P{^Is_Bidi_Class=-white_Space}', "");
    Expect(0, 12289, '\p{Is_Bidi_Class=-white_Space}', "");
    Expect(1, 12289, '\p{^Is_Bidi_Class=-white_Space}', "");
    Expect(1, 12289, '\P{Is_Bidi_Class=-white_Space}', "");
    Expect(0, 12289, '\P{^Is_Bidi_Class=-white_Space}', "");
    Error('\p{Is_Bc:	 WS/a/}');
    Error('\P{Is_Bc:	 WS/a/}');
    Expect(1, 12288, '\p{Is_Bc=ws}', "");
    Expect(0, 12288, '\p{^Is_Bc=ws}', "");
    Expect(0, 12288, '\P{Is_Bc=ws}', "");
    Expect(1, 12288, '\P{^Is_Bc=ws}', "");
    Expect(0, 12289, '\p{Is_Bc=ws}', "");
    Expect(1, 12289, '\p{^Is_Bc=ws}', "");
    Expect(1, 12289, '\P{Is_Bc=ws}', "");
    Expect(0, 12289, '\P{^Is_Bc=ws}', "");
    Expect(1, 12288, '\p{Is_Bc=_-WS}', "");
    Expect(0, 12288, '\p{^Is_Bc=_-WS}', "");
    Expect(0, 12288, '\P{Is_Bc=_-WS}', "");
    Expect(1, 12288, '\P{^Is_Bc=_-WS}', "");
    Expect(0, 12289, '\p{Is_Bc=_-WS}', "");
    Expect(1, 12289, '\p{^Is_Bc=_-WS}', "");
    Expect(1, 12289, '\P{Is_Bc=_-WS}', "");
    Expect(0, 12289, '\P{^Is_Bc=_-WS}', "");
    Error('\p{Bidi_Control=:=  No}');
    Error('\P{Bidi_Control=:=  No}');
    Expect(1, 8298, '\p{Bidi_Control=:\ANo\z:}', "");;
    Expect(0, 8297, '\p{Bidi_Control=:\ANo\z:}', "");;
    Expect(1, 8298, '\p{Bidi_Control=no}', "");
    Expect(0, 8298, '\p{^Bidi_Control=no}', "");
    Expect(0, 8298, '\P{Bidi_Control=no}', "");
    Expect(1, 8298, '\P{^Bidi_Control=no}', "");
    Expect(0, 8297, '\p{Bidi_Control=no}', "");
    Expect(1, 8297, '\p{^Bidi_Control=no}', "");
    Expect(1, 8297, '\P{Bidi_Control=no}', "");
    Expect(0, 8297, '\P{^Bidi_Control=no}', "");
    Expect(1, 8298, '\p{Bidi_Control=:\Ano\z:}', "");;
    Expect(0, 8297, '\p{Bidi_Control=:\Ano\z:}', "");;
    Expect(1, 8298, '\p{Bidi_Control=--No}', "");
    Expect(0, 8298, '\p{^Bidi_Control=--No}', "");
    Expect(0, 8298, '\P{Bidi_Control=--No}', "");
    Expect(1, 8298, '\P{^Bidi_Control=--No}', "");
    Expect(0, 8297, '\p{Bidi_Control=--No}', "");
    Expect(1, 8297, '\p{^Bidi_Control=--No}', "");
    Expect(1, 8297, '\P{Bidi_Control=--No}', "");
    Expect(0, 8297, '\P{^Bidi_Control=--No}', "");
    Error('\p{Bidi_C=:= -N}');
    Error('\P{Bidi_C=:= -N}');
    Expect(1, 8298, '\p{Bidi_C=:\AN\z:}', "");;
    Expect(0, 8297, '\p{Bidi_C=:\AN\z:}', "");;
    Expect(1, 8298, '\p{Bidi_C=n}', "");
    Expect(0, 8298, '\p{^Bidi_C=n}', "");
    Expect(0, 8298, '\P{Bidi_C=n}', "");
    Expect(1, 8298, '\P{^Bidi_C=n}', "");
    Expect(0, 8297, '\p{Bidi_C=n}', "");
    Expect(1, 8297, '\p{^Bidi_C=n}', "");
    Expect(1, 8297, '\P{Bidi_C=n}', "");
    Expect(0, 8297, '\P{^Bidi_C=n}', "");
    Expect(1, 8298, '\p{Bidi_C=:\An\z:}', "");;
    Expect(0, 8297, '\p{Bidi_C=:\An\z:}', "");;
    Expect(1, 8298, '\p{Bidi_C=N}', "");
    Expect(0, 8298, '\p{^Bidi_C=N}', "");
    Expect(0, 8298, '\P{Bidi_C=N}', "");
    Expect(1, 8298, '\P{^Bidi_C=N}', "");
    Expect(0, 8297, '\p{Bidi_C=N}', "");
    Expect(1, 8297, '\p{^Bidi_C=N}', "");
    Expect(1, 8297, '\P{Bidi_C=N}', "");
    Expect(0, 8297, '\P{^Bidi_C=N}', "");
    Error('\p{Is_Bidi_Control= /a/F}');
    Error('\P{Is_Bidi_Control= /a/F}');
    Expect(1, 8298, '\p{Is_Bidi_Control=f}', "");
    Expect(0, 8298, '\p{^Is_Bidi_Control=f}', "");
    Expect(0, 8298, '\P{Is_Bidi_Control=f}', "");
    Expect(1, 8298, '\P{^Is_Bidi_Control=f}', "");
    Expect(0, 8297, '\p{Is_Bidi_Control=f}', "");
    Expect(1, 8297, '\p{^Is_Bidi_Control=f}', "");
    Expect(1, 8297, '\P{Is_Bidi_Control=f}', "");
    Expect(0, 8297, '\P{^Is_Bidi_Control=f}', "");
    Expect(1, 8298, '\p{Is_Bidi_Control=_F}', "");
    Expect(0, 8298, '\p{^Is_Bidi_Control=_F}', "");
    Expect(0, 8298, '\P{Is_Bidi_Control=_F}', "");
    Expect(1, 8298, '\P{^Is_Bidi_Control=_F}', "");
    Expect(0, 8297, '\p{Is_Bidi_Control=_F}', "");
    Expect(1, 8297, '\p{^Is_Bidi_Control=_F}', "");
    Expect(1, 8297, '\P{Is_Bidi_Control=_F}', "");
    Expect(0, 8297, '\P{^Is_Bidi_Control=_F}', "");
    Error('\p{Is_Bidi_C=-_False:=}');
    Error('\P{Is_Bidi_C=-_False:=}');
    Expect(1, 8298, '\p{Is_Bidi_C=false}', "");
    Expect(0, 8298, '\p{^Is_Bidi_C=false}', "");
    Expect(0, 8298, '\P{Is_Bidi_C=false}', "");
    Expect(1, 8298, '\P{^Is_Bidi_C=false}', "");
    Expect(0, 8297, '\p{Is_Bidi_C=false}', "");
    Expect(1, 8297, '\p{^Is_Bidi_C=false}', "");
    Expect(1, 8297, '\P{Is_Bidi_C=false}', "");
    Expect(0, 8297, '\P{^Is_Bidi_C=false}', "");
    Expect(1, 8298, '\p{Is_Bidi_C= FALSE}', "");
    Expect(0, 8298, '\p{^Is_Bidi_C= FALSE}', "");
    Expect(0, 8298, '\P{Is_Bidi_C= FALSE}', "");
    Expect(1, 8298, '\P{^Is_Bidi_C= FALSE}', "");
    Expect(0, 8297, '\p{Is_Bidi_C= FALSE}', "");
    Expect(1, 8297, '\p{^Is_Bidi_C= FALSE}', "");
    Expect(1, 8297, '\P{Is_Bidi_C= FALSE}', "");
    Expect(0, 8297, '\P{^Is_Bidi_C= FALSE}', "");
    Error('\p{Bidi_Control=:= _YES}');
    Error('\P{Bidi_Control=:= _YES}');
    Expect(1, 8297, '\p{Bidi_Control=:\AYes\z:}', "");;
    Expect(0, 8298, '\p{Bidi_Control=:\AYes\z:}', "");;
    Expect(1, 8297, '\p{Bidi_Control:   yes}', "");
    Expect(0, 8297, '\p{^Bidi_Control:   yes}', "");
    Expect(0, 8297, '\P{Bidi_Control:   yes}', "");
    Expect(1, 8297, '\P{^Bidi_Control:   yes}', "");
    Expect(0, 8298, '\p{Bidi_Control:   yes}', "");
    Expect(1, 8298, '\p{^Bidi_Control:   yes}', "");
    Expect(1, 8298, '\P{Bidi_Control:   yes}', "");
    Expect(0, 8298, '\P{^Bidi_Control:   yes}', "");
    Expect(1, 8297, '\p{Bidi_Control=:\Ayes\z:}', "");;
    Expect(0, 8298, '\p{Bidi_Control=:\Ayes\z:}', "");;
    Expect(1, 8297, '\p{Bidi_Control=	-Yes}', "");
    Expect(0, 8297, '\p{^Bidi_Control=	-Yes}', "");
    Expect(0, 8297, '\P{Bidi_Control=	-Yes}', "");
    Expect(1, 8297, '\P{^Bidi_Control=	-Yes}', "");
    Expect(0, 8298, '\p{Bidi_Control=	-Yes}', "");
    Expect(1, 8298, '\p{^Bidi_Control=	-Yes}', "");
    Expect(1, 8298, '\P{Bidi_Control=	-Yes}', "");
    Expect(0, 8298, '\P{^Bidi_Control=	-Yes}', "");
    Error('\p{Bidi_C=:=y}');
    Error('\P{Bidi_C=:=y}');
    Expect(1, 8297, '\p{Bidi_C=:\AY\z:}', "");;
    Expect(0, 8298, '\p{Bidi_C=:\AY\z:}', "");;
    Expect(1, 8297, '\p{Bidi_C=y}', "");
    Expect(0, 8297, '\p{^Bidi_C=y}', "");
    Expect(0, 8297, '\P{Bidi_C=y}', "");
    Expect(1, 8297, '\P{^Bidi_C=y}', "");
    Expect(0, 8298, '\p{Bidi_C=y}', "");
    Expect(1, 8298, '\p{^Bidi_C=y}', "");
    Expect(1, 8298, '\P{Bidi_C=y}', "");
    Expect(0, 8298, '\P{^Bidi_C=y}', "");
    Expect(1, 8297, '\p{Bidi_C=:\Ay\z:}', "");;
    Expect(0, 8298, '\p{Bidi_C=:\Ay\z:}', "");;
    Expect(1, 8297, '\p{Bidi_C= Y}', "");
    Expect(0, 8297, '\p{^Bidi_C= Y}', "");
    Expect(0, 8297, '\P{Bidi_C= Y}', "");
    Expect(1, 8297, '\P{^Bidi_C= Y}', "");
    Expect(0, 8298, '\p{Bidi_C= Y}', "");
    Expect(1, 8298, '\p{^Bidi_C= Y}', "");
    Expect(1, 8298, '\P{Bidi_C= Y}', "");
    Expect(0, 8298, '\P{^Bidi_C= Y}', "");
    Error('\p{Is_Bidi_Control=	_T:=}');
    Error('\P{Is_Bidi_Control=	_T:=}');
    Expect(1, 8297, '\p{Is_Bidi_Control=t}', "");
    Expect(0, 8297, '\p{^Is_Bidi_Control=t}', "");
    Expect(0, 8297, '\P{Is_Bidi_Control=t}', "");
    Expect(1, 8297, '\P{^Is_Bidi_Control=t}', "");
    Expect(0, 8298, '\p{Is_Bidi_Control=t}', "");
    Expect(1, 8298, '\p{^Is_Bidi_Control=t}', "");
    Expect(1, 8298, '\P{Is_Bidi_Control=t}', "");
    Expect(0, 8298, '\P{^Is_Bidi_Control=t}', "");
    Expect(1, 8297, '\p{Is_Bidi_Control= -T}', "");
    Expect(0, 8297, '\p{^Is_Bidi_Control= -T}', "");
    Expect(0, 8297, '\P{Is_Bidi_Control= -T}', "");
    Expect(1, 8297, '\P{^Is_Bidi_Control= -T}', "");
    Expect(0, 8298, '\p{Is_Bidi_Control= -T}', "");
    Expect(1, 8298, '\p{^Is_Bidi_Control= -T}', "");
    Expect(1, 8298, '\P{Is_Bidi_Control= -T}', "");
    Expect(0, 8298, '\P{^Is_Bidi_Control= -T}', "");
    Error('\p{Is_Bidi_C=/a/--True}');
    Error('\P{Is_Bidi_C=/a/--True}');
    Expect(1, 8297, '\p{Is_Bidi_C=true}', "");
    Expect(0, 8297, '\p{^Is_Bidi_C=true}', "");
    Expect(0, 8297, '\P{Is_Bidi_C=true}', "");
    Expect(1, 8297, '\P{^Is_Bidi_C=true}', "");
    Expect(0, 8298, '\p{Is_Bidi_C=true}', "");
    Expect(1, 8298, '\p{^Is_Bidi_C=true}', "");
    Expect(1, 8298, '\P{Is_Bidi_C=true}', "");
    Expect(0, 8298, '\P{^Is_Bidi_C=true}', "");
    Expect(1, 8297, '\p{Is_Bidi_C=	_True}', "");
    Expect(0, 8297, '\p{^Is_Bidi_C=	_True}', "");
    Expect(0, 8297, '\P{Is_Bidi_C=	_True}', "");
    Expect(1, 8297, '\P{^Is_Bidi_C=	_True}', "");
    Expect(0, 8298, '\p{Is_Bidi_C=	_True}', "");
    Expect(1, 8298, '\p{^Is_Bidi_C=	_True}', "");
    Expect(1, 8298, '\P{Is_Bidi_C=	_True}', "");
    Expect(0, 8298, '\P{^Is_Bidi_C=	_True}', "");
    Error('\p{Bidi_Mirrored=:=No}');
    Error('\P{Bidi_Mirrored=:=No}');
    Expect(1, 120772, '\p{Bidi_Mirrored=:\ANo\z:}', "");;
    Expect(0, 120771, '\p{Bidi_Mirrored=:\ANo\z:}', "");;
    Expect(1, 120772, '\p{Bidi_Mirrored=no}', "");
    Expect(0, 120772, '\p{^Bidi_Mirrored=no}', "");
    Expect(0, 120772, '\P{Bidi_Mirrored=no}', "");
    Expect(1, 120772, '\P{^Bidi_Mirrored=no}', "");
    Expect(0, 120771, '\p{Bidi_Mirrored=no}', "");
    Expect(1, 120771, '\p{^Bidi_Mirrored=no}', "");
    Expect(1, 120771, '\P{Bidi_Mirrored=no}', "");
    Expect(0, 120771, '\P{^Bidi_Mirrored=no}', "");
    Expect(1, 120772, '\p{Bidi_Mirrored=:\Ano\z:}', "");;
    Expect(0, 120771, '\p{Bidi_Mirrored=:\Ano\z:}', "");;
    Expect(1, 120772, '\p{Bidi_Mirrored=_NO}', "");
    Expect(0, 120772, '\p{^Bidi_Mirrored=_NO}', "");
    Expect(0, 120772, '\P{Bidi_Mirrored=_NO}', "");
    Expect(1, 120772, '\P{^Bidi_Mirrored=_NO}', "");
    Expect(0, 120771, '\p{Bidi_Mirrored=_NO}', "");
    Expect(1, 120771, '\p{^Bidi_Mirrored=_NO}', "");
    Expect(1, 120771, '\P{Bidi_Mirrored=_NO}', "");
    Expect(0, 120771, '\P{^Bidi_Mirrored=_NO}', "");
    Error('\p{Bidi_M=/a/_ N}');
    Error('\P{Bidi_M=/a/_ N}');
    Expect(1, 120772, '\p{Bidi_M=:\AN\z:}', "");;
    Expect(0, 120771, '\p{Bidi_M=:\AN\z:}', "");;
    Expect(1, 120772, '\p{Bidi_M=n}', "");
    Expect(0, 120772, '\p{^Bidi_M=n}', "");
    Expect(0, 120772, '\P{Bidi_M=n}', "");
    Expect(1, 120772, '\P{^Bidi_M=n}', "");
    Expect(0, 120771, '\p{Bidi_M=n}', "");
    Expect(1, 120771, '\p{^Bidi_M=n}', "");
    Expect(1, 120771, '\P{Bidi_M=n}', "");
    Expect(0, 120771, '\P{^Bidi_M=n}', "");
    Expect(1, 120772, '\p{Bidi_M=:\An\z:}', "");;
    Expect(0, 120771, '\p{Bidi_M=:\An\z:}', "");;
    Expect(1, 120772, '\p{Bidi_M=--N}', "");
    Expect(0, 120772, '\p{^Bidi_M=--N}', "");
    Expect(0, 120772, '\P{Bidi_M=--N}', "");
    Expect(1, 120772, '\P{^Bidi_M=--N}', "");
    Expect(0, 120771, '\p{Bidi_M=--N}', "");
    Expect(1, 120771, '\p{^Bidi_M=--N}', "");
    Expect(1, 120771, '\P{Bidi_M=--N}', "");
    Expect(0, 120771, '\P{^Bidi_M=--N}', "");
    Error('\p{Is_Bidi_Mirrored=:=-	F}');
    Error('\P{Is_Bidi_Mirrored=:=-	F}');
    Expect(1, 120772, '\p{Is_Bidi_Mirrored=f}', "");
    Expect(0, 120772, '\p{^Is_Bidi_Mirrored=f}', "");
    Expect(0, 120772, '\P{Is_Bidi_Mirrored=f}', "");
    Expect(1, 120772, '\P{^Is_Bidi_Mirrored=f}', "");
    Expect(0, 120771, '\p{Is_Bidi_Mirrored=f}', "");
    Expect(1, 120771, '\p{^Is_Bidi_Mirrored=f}', "");
    Expect(1, 120771, '\P{Is_Bidi_Mirrored=f}', "");
    Expect(0, 120771, '\P{^Is_Bidi_Mirrored=f}', "");
    Expect(1, 120772, '\p{Is_Bidi_Mirrored=- F}', "");
    Expect(0, 120772, '\p{^Is_Bidi_Mirrored=- F}', "");
    Expect(0, 120772, '\P{Is_Bidi_Mirrored=- F}', "");
    Expect(1, 120772, '\P{^Is_Bidi_Mirrored=- F}', "");
    Expect(0, 120771, '\p{Is_Bidi_Mirrored=- F}', "");
    Expect(1, 120771, '\p{^Is_Bidi_Mirrored=- F}', "");
    Expect(1, 120771, '\P{Is_Bidi_Mirrored=- F}', "");
    Expect(0, 120771, '\P{^Is_Bidi_Mirrored=- F}', "");
    Error('\p{Is_Bidi_M=_/a/FALSE}');
    Error('\P{Is_Bidi_M=_/a/FALSE}');
    Expect(1, 120772, '\p{Is_Bidi_M=false}', "");
    Expect(0, 120772, '\p{^Is_Bidi_M=false}', "");
    Expect(0, 120772, '\P{Is_Bidi_M=false}', "");
    Expect(1, 120772, '\P{^Is_Bidi_M=false}', "");
    Expect(0, 120771, '\p{Is_Bidi_M=false}', "");
    Expect(1, 120771, '\p{^Is_Bidi_M=false}', "");
    Expect(1, 120771, '\P{Is_Bidi_M=false}', "");
    Expect(0, 120771, '\P{^Is_Bidi_M=false}', "");
    Expect(1, 120772, '\p{Is_Bidi_M=	-False}', "");
    Expect(0, 120772, '\p{^Is_Bidi_M=	-False}', "");
    Expect(0, 120772, '\P{Is_Bidi_M=	-False}', "");
    Expect(1, 120772, '\P{^Is_Bidi_M=	-False}', "");
    Expect(0, 120771, '\p{Is_Bidi_M=	-False}', "");
    Expect(1, 120771, '\p{^Is_Bidi_M=	-False}', "");
    Expect(1, 120771, '\P{Is_Bidi_M=	-False}', "");
    Expect(0, 120771, '\P{^Is_Bidi_M=	-False}', "");
    Error('\p{Bidi_Mirrored=	 Yes/a/}');
    Error('\P{Bidi_Mirrored=	 Yes/a/}');
    Expect(1, 120771, '\p{Bidi_Mirrored=:\AYes\z:}', "");;
    Expect(0, 120772, '\p{Bidi_Mirrored=:\AYes\z:}', "");;
    Expect(1, 120771, '\p{Bidi_Mirrored=yes}', "");
    Expect(0, 120771, '\p{^Bidi_Mirrored=yes}', "");
    Expect(0, 120771, '\P{Bidi_Mirrored=yes}', "");
    Expect(1, 120771, '\P{^Bidi_Mirrored=yes}', "");
    Expect(0, 120772, '\p{Bidi_Mirrored=yes}', "");
    Expect(1, 120772, '\p{^Bidi_Mirrored=yes}', "");
    Expect(1, 120772, '\P{Bidi_Mirrored=yes}', "");
    Expect(0, 120772, '\P{^Bidi_Mirrored=yes}', "");
    Expect(1, 120771, '\p{Bidi_Mirrored=:\Ayes\z:}', "");;
    Expect(0, 120772, '\p{Bidi_Mirrored=:\Ayes\z:}', "");;
    Expect(1, 120771, '\p{Bidi_Mirrored=	_Yes}', "");
    Expect(0, 120771, '\p{^Bidi_Mirrored=	_Yes}', "");
    Expect(0, 120771, '\P{Bidi_Mirrored=	_Yes}', "");
    Expect(1, 120771, '\P{^Bidi_Mirrored=	_Yes}', "");
    Expect(0, 120772, '\p{Bidi_Mirrored=	_Yes}', "");
    Expect(1, 120772, '\p{^Bidi_Mirrored=	_Yes}', "");
    Expect(1, 120772, '\P{Bidi_Mirrored=	_Yes}', "");
    Expect(0, 120772, '\P{^Bidi_Mirrored=	_Yes}', "");
    Error('\p{Bidi_M=/a/ _Y}');
    Error('\P{Bidi_M=/a/ _Y}');
    Expect(1, 120771, '\p{Bidi_M=:\AY\z:}', "");;
    Expect(0, 120772, '\p{Bidi_M=:\AY\z:}', "");;
    Expect(1, 120771, '\p{Bidi_M=y}', "");
    Expect(0, 120771, '\p{^Bidi_M=y}', "");
    Expect(0, 120771, '\P{Bidi_M=y}', "");
    Expect(1, 120771, '\P{^Bidi_M=y}', "");
    Expect(0, 120772, '\p{Bidi_M=y}', "");
    Expect(1, 120772, '\p{^Bidi_M=y}', "");
    Expect(1, 120772, '\P{Bidi_M=y}', "");
    Expect(0, 120772, '\P{^Bidi_M=y}', "");
    Expect(1, 120771, '\p{Bidi_M=:\Ay\z:}', "");;
    Expect(0, 120772, '\p{Bidi_M=:\Ay\z:}', "");;
    Expect(1, 120771, '\p{Bidi_M=- Y}', "");
    Expect(0, 120771, '\p{^Bidi_M=- Y}', "");
    Expect(0, 120771, '\P{Bidi_M=- Y}', "");
    Expect(1, 120771, '\P{^Bidi_M=- Y}', "");
    Expect(0, 120772, '\p{Bidi_M=- Y}', "");
    Expect(1, 120772, '\p{^Bidi_M=- Y}', "");
    Expect(1, 120772, '\P{Bidi_M=- Y}', "");
    Expect(0, 120772, '\P{^Bidi_M=- Y}', "");
    Error('\p{Is_Bidi_Mirrored=:=T}');
    Error('\P{Is_Bidi_Mirrored=:=T}');
    Expect(1, 120771, '\p{Is_Bidi_Mirrored=t}', "");
    Expect(0, 120771, '\p{^Is_Bidi_Mirrored=t}', "");
    Expect(0, 120771, '\P{Is_Bidi_Mirrored=t}', "");
    Expect(1, 120771, '\P{^Is_Bidi_Mirrored=t}', "");
    Expect(0, 120772, '\p{Is_Bidi_Mirrored=t}', "");
    Expect(1, 120772, '\p{^Is_Bidi_Mirrored=t}', "");
    Expect(1, 120772, '\P{Is_Bidi_Mirrored=t}', "");
    Expect(0, 120772, '\P{^Is_Bidi_Mirrored=t}', "");
    Expect(1, 120771, '\p{Is_Bidi_Mirrored=	-t}', "");
    Expect(0, 120771, '\p{^Is_Bidi_Mirrored=	-t}', "");
    Expect(0, 120771, '\P{Is_Bidi_Mirrored=	-t}', "");
    Expect(1, 120771, '\P{^Is_Bidi_Mirrored=	-t}', "");
    Expect(0, 120772, '\p{Is_Bidi_Mirrored=	-t}', "");
    Expect(1, 120772, '\p{^Is_Bidi_Mirrored=	-t}', "");
    Expect(1, 120772, '\P{Is_Bidi_Mirrored=	-t}', "");
    Expect(0, 120772, '\P{^Is_Bidi_Mirrored=	-t}', "");
    Error('\p{Is_Bidi_M=		True:=}');
    Error('\P{Is_Bidi_M=		True:=}');
    Expect(1, 120771, '\p{Is_Bidi_M:   true}', "");
    Expect(0, 120771, '\p{^Is_Bidi_M:   true}', "");
    Expect(0, 120771, '\P{Is_Bidi_M:   true}', "");
    Expect(1, 120771, '\P{^Is_Bidi_M:   true}', "");
    Expect(0, 120772, '\p{Is_Bidi_M:   true}', "");
    Expect(1, 120772, '\p{^Is_Bidi_M:   true}', "");
    Expect(1, 120772, '\P{Is_Bidi_M:   true}', "");
    Expect(0, 120772, '\P{^Is_Bidi_M:   true}', "");
    Expect(1, 120771, '\p{Is_Bidi_M=		True}', "");
    Expect(0, 120771, '\p{^Is_Bidi_M=		True}', "");
    Expect(0, 120771, '\P{Is_Bidi_M=		True}', "");
    Expect(1, 120771, '\P{^Is_Bidi_M=		True}', "");
    Expect(0, 120772, '\p{Is_Bidi_M=		True}', "");
    Expect(1, 120772, '\p{^Is_Bidi_M=		True}', "");
    Expect(1, 120772, '\P{Is_Bidi_M=		True}', "");
    Expect(0, 120772, '\P{^Is_Bidi_M=		True}', "");
    Error('\p{block}');
    Error('\P{block}');
    Error('\p{blk}');
    Error('\P{blk}');
    Error('\p{Block=	/a/adlam}');
    Error('\P{Block=	/a/adlam}');
    Expect(1, 125279, '\p{Block=:\AAdlam\z:}', "");;
    Expect(0, 125280, '\p{Block=:\AAdlam\z:}', "");;
    Expect(1, 125279, '\p{Block:adlam}', "");
    Expect(0, 125279, '\p{^Block:adlam}', "");
    Expect(0, 125279, '\P{Block:adlam}', "");
    Expect(1, 125279, '\P{^Block:adlam}', "");
    Expect(0, 125280, '\p{Block:adlam}', "");
    Expect(1, 125280, '\p{^Block:adlam}', "");
    Expect(1, 125280, '\P{Block:adlam}', "");
    Expect(0, 125280, '\P{^Block:adlam}', "");
    Expect(1, 125279, '\p{Block=:\Aadlam\z:}', "");;
    Expect(0, 125280, '\p{Block=:\Aadlam\z:}', "");;
    Expect(1, 125279, '\p{Block=__Adlam}', "");
    Expect(0, 125279, '\p{^Block=__Adlam}', "");
    Expect(0, 125279, '\P{Block=__Adlam}', "");
    Expect(1, 125279, '\P{^Block=__Adlam}', "");
    Expect(0, 125280, '\p{Block=__Adlam}', "");
    Expect(1, 125280, '\p{^Block=__Adlam}', "");
    Expect(1, 125280, '\P{Block=__Adlam}', "");
    Expect(0, 125280, '\P{^Block=__Adlam}', "");
    Error('\p{Blk=:=_ adlam}');
    Error('\P{Blk=:=_ adlam}');
    Expect(1, 125279, '\p{Blk=:\AAdlam\z:}', "");;
    Expect(0, 125280, '\p{Blk=:\AAdlam\z:}', "");;
    Expect(1, 125279, '\p{Blk=adlam}', "");
    Expect(0, 125279, '\p{^Blk=adlam}', "");
    Expect(0, 125279, '\P{Blk=adlam}', "");
    Expect(1, 125279, '\P{^Blk=adlam}', "");
    Expect(0, 125280, '\p{Blk=adlam}', "");
    Expect(1, 125280, '\p{^Blk=adlam}', "");
    Expect(1, 125280, '\P{Blk=adlam}', "");
    Expect(0, 125280, '\P{^Blk=adlam}', "");
    Expect(1, 125279, '\p{Blk=:\Aadlam\z:}', "");;
    Expect(0, 125280, '\p{Blk=:\Aadlam\z:}', "");;
    Expect(1, 125279, '\p{Blk=	_ADLAM}', "");
    Expect(0, 125279, '\p{^Blk=	_ADLAM}', "");
    Expect(0, 125279, '\P{Blk=	_ADLAM}', "");
    Expect(1, 125279, '\P{^Blk=	_ADLAM}', "");
    Expect(0, 125280, '\p{Blk=	_ADLAM}', "");
    Expect(1, 125280, '\p{^Blk=	_ADLAM}', "");
    Expect(1, 125280, '\P{Blk=	_ADLAM}', "");
    Expect(0, 125280, '\P{^Blk=	_ADLAM}', "");
    Error('\p{Is_Block:   -	adlam/a/}');
    Error('\P{Is_Block:   -	adlam/a/}');
    Expect(1, 125279, '\p{Is_Block=adlam}', "");
    Expect(0, 125279, '\p{^Is_Block=adlam}', "");
    Expect(0, 125279, '\P{Is_Block=adlam}', "");
    Expect(1, 125279, '\P{^Is_Block=adlam}', "");
    Expect(0, 125280, '\p{Is_Block=adlam}', "");
    Expect(1, 125280, '\p{^Is_Block=adlam}', "");
    Expect(1, 125280, '\P{Is_Block=adlam}', "");
    Expect(0, 125280, '\P{^Is_Block=adlam}', "");
    Expect(1, 125279, '\p{Is_Block=	adlam}', "");
    Expect(0, 125279, '\p{^Is_Block=	adlam}', "");
    Expect(0, 125279, '\P{Is_Block=	adlam}', "");
    Expect(1, 125279, '\P{^Is_Block=	adlam}', "");
    Expect(0, 125280, '\p{Is_Block=	adlam}', "");
    Expect(1, 125280, '\p{^Is_Block=	adlam}', "");
    Expect(1, 125280, '\P{Is_Block=	adlam}', "");
    Expect(0, 125280, '\P{^Is_Block=	adlam}', "");
    Error('\p{Is_Blk= _Adlam:=}');
    Error('\P{Is_Blk= _Adlam:=}');
    Expect(1, 125279, '\p{Is_Blk=adlam}', "");
    Expect(0, 125279, '\p{^Is_Blk=adlam}', "");
    Expect(0, 125279, '\P{Is_Blk=adlam}', "");
    Expect(1, 125279, '\P{^Is_Blk=adlam}', "");
    Expect(0, 125280, '\p{Is_Blk=adlam}', "");
    Expect(1, 125280, '\p{^Is_Blk=adlam}', "");
    Expect(1, 125280, '\P{Is_Blk=adlam}', "");
    Expect(0, 125280, '\P{^Is_Blk=adlam}', "");
    Expect(1, 125279, '\p{Is_Blk=_-Adlam}', "");
    Expect(0, 125279, '\p{^Is_Blk=_-Adlam}', "");
    Expect(0, 125279, '\P{Is_Blk=_-Adlam}', "");
    Expect(1, 125279, '\P{^Is_Blk=_-Adlam}', "");
    Expect(0, 125280, '\p{Is_Blk=_-Adlam}', "");
    Expect(1, 125280, '\p{^Is_Blk=_-Adlam}', "");
    Expect(1, 125280, '\P{Is_Blk=_-Adlam}', "");
    Expect(0, 125280, '\P{^Is_Blk=_-Adlam}', "");
    Error('\p{Block=/a/ -AEGEAN_numbers}');
    Error('\P{Block=/a/ -AEGEAN_numbers}');
    Expect(1, 65855, '\p{Block=:\AAegean_Numbers\z:}', "");;
    Expect(0, 65856, '\p{Block=:\AAegean_Numbers\z:}', "");;
    Expect(1, 65855, '\p{Block=aegeannumbers}', "");
    Expect(0, 65855, '\p{^Block=aegeannumbers}', "");
    Expect(0, 65855, '\P{Block=aegeannumbers}', "");
    Expect(1, 65855, '\P{^Block=aegeannumbers}', "");
    Expect(0, 65856, '\p{Block=aegeannumbers}', "");
    Expect(1, 65856, '\p{^Block=aegeannumbers}', "");
    Expect(1, 65856, '\P{Block=aegeannumbers}', "");
    Expect(0, 65856, '\P{^Block=aegeannumbers}', "");
    Expect(1, 65855, '\p{Block=:\Aaegeannumbers\z:}', "");;
    Expect(0, 65856, '\p{Block=:\Aaegeannumbers\z:}', "");;
    Expect(1, 65855, '\p{Block=		aegean_Numbers}', "");
    Expect(0, 65855, '\p{^Block=		aegean_Numbers}', "");
    Expect(0, 65855, '\P{Block=		aegean_Numbers}', "");
    Expect(1, 65855, '\P{^Block=		aegean_Numbers}', "");
    Expect(0, 65856, '\p{Block=		aegean_Numbers}', "");
    Expect(1, 65856, '\p{^Block=		aegean_Numbers}', "");
    Expect(1, 65856, '\P{Block=		aegean_Numbers}', "");
    Expect(0, 65856, '\P{^Block=		aegean_Numbers}', "");
    Error('\p{Blk=_:=aegean_Numbers}');
    Error('\P{Blk=_:=aegean_Numbers}');
    Expect(1, 65855, '\p{Blk=:\AAegean_Numbers\z:}', "");;
    Expect(0, 65856, '\p{Blk=:\AAegean_Numbers\z:}', "");;
    Expect(1, 65855, '\p{Blk=aegeannumbers}', "");
    Expect(0, 65855, '\p{^Blk=aegeannumbers}', "");
    Expect(0, 65855, '\P{Blk=aegeannumbers}', "");
    Expect(1, 65855, '\P{^Blk=aegeannumbers}', "");
    Expect(0, 65856, '\p{Blk=aegeannumbers}', "");
    Expect(1, 65856, '\p{^Blk=aegeannumbers}', "");
    Expect(1, 65856, '\P{Blk=aegeannumbers}', "");
    Expect(0, 65856, '\P{^Blk=aegeannumbers}', "");
    Expect(1, 65855, '\p{Blk=:\Aaegeannumbers\z:}', "");;
    Expect(0, 65856, '\p{Blk=:\Aaegeannumbers\z:}', "");;
    Expect(1, 65855, '\p{Blk:	 Aegean_NUMBERS}', "");
    Expect(0, 65855, '\p{^Blk:	 Aegean_NUMBERS}', "");
    Expect(0, 65855, '\P{Blk:	 Aegean_NUMBERS}', "");
    Expect(1, 65855, '\P{^Blk:	 Aegean_NUMBERS}', "");
    Expect(0, 65856, '\p{Blk:	 Aegean_NUMBERS}', "");
    Expect(1, 65856, '\p{^Blk:	 Aegean_NUMBERS}', "");
    Expect(1, 65856, '\P{Blk:	 Aegean_NUMBERS}', "");
    Expect(0, 65856, '\P{^Blk:	 Aegean_NUMBERS}', "");
    Error('\p{Is_Block=_-Aegean_NUMBERS/a/}');
    Error('\P{Is_Block=_-Aegean_NUMBERS/a/}');
    Expect(1, 65855, '\p{Is_Block=aegeannumbers}', "");
    Expect(0, 65855, '\p{^Is_Block=aegeannumbers}', "");
    Expect(0, 65855, '\P{Is_Block=aegeannumbers}', "");
    Expect(1, 65855, '\P{^Is_Block=aegeannumbers}', "");
    Expect(0, 65856, '\p{Is_Block=aegeannumbers}', "");
    Expect(1, 65856, '\p{^Is_Block=aegeannumbers}', "");
    Expect(1, 65856, '\P{Is_Block=aegeannumbers}', "");
    Expect(0, 65856, '\P{^Is_Block=aegeannumbers}', "");
    Expect(1, 65855, '\p{Is_Block= Aegean_Numbers}', "");
    Expect(0, 65855, '\p{^Is_Block= Aegean_Numbers}', "");
    Expect(0, 65855, '\P{Is_Block= Aegean_Numbers}', "");
    Expect(1, 65855, '\P{^Is_Block= Aegean_Numbers}', "");
    Expect(0, 65856, '\p{Is_Block= Aegean_Numbers}', "");
    Expect(1, 65856, '\p{^Is_Block= Aegean_Numbers}', "");
    Expect(1, 65856, '\P{Is_Block= Aegean_Numbers}', "");
    Expect(0, 65856, '\P{^Is_Block= Aegean_Numbers}', "");
    Error('\p{Is_Blk=-_aegean_Numbers/a/}');
    Error('\P{Is_Blk=-_aegean_Numbers/a/}');
    Expect(1, 65855, '\p{Is_Blk=aegeannumbers}', "");
    Expect(0, 65855, '\p{^Is_Blk=aegeannumbers}', "");
    Expect(0, 65855, '\P{Is_Blk=aegeannumbers}', "");
    Expect(1, 65855, '\P{^Is_Blk=aegeannumbers}', "");
    Expect(0, 65856, '\p{Is_Blk=aegeannumbers}', "");
    Expect(1, 65856, '\p{^Is_Blk=aegeannumbers}', "");
    Expect(1, 65856, '\P{Is_Blk=aegeannumbers}', "");
    Expect(0, 65856, '\P{^Is_Blk=aegeannumbers}', "");
    Expect(1, 65855, '\p{Is_Blk=_	Aegean_NUMBERS}', "");
    Expect(0, 65855, '\p{^Is_Blk=_	Aegean_NUMBERS}', "");
    Expect(0, 65855, '\P{Is_Blk=_	Aegean_NUMBERS}', "");
    Expect(1, 65855, '\P{^Is_Blk=_	Aegean_NUMBERS}', "");
    Expect(0, 65856, '\p{Is_Blk=_	Aegean_NUMBERS}', "");
    Expect(1, 65856, '\p{^Is_Blk=_	Aegean_NUMBERS}', "");
    Expect(1, 65856, '\P{Is_Blk=_	Aegean_NUMBERS}', "");
    Expect(0, 65856, '\P{^Is_Blk=_	Aegean_NUMBERS}', "");
    Error('\p{Block=-_AHOM:=}');
    Error('\P{Block=-_AHOM:=}');
    Expect(1, 71487, '\p{Block=:\AAhom\z:}', "");;
    Expect(0, 71488, '\p{Block=:\AAhom\z:}', "");;
    Expect(1, 71487, '\p{Block=ahom}', "");
    Expect(0, 71487, '\p{^Block=ahom}', "");
    Expect(0, 71487, '\P{Block=ahom}', "");
    Expect(1, 71487, '\P{^Block=ahom}', "");
    Expect(0, 71488, '\p{Block=ahom}', "");
    Expect(1, 71488, '\p{^Block=ahom}', "");
    Expect(1, 71488, '\P{Block=ahom}', "");
    Expect(0, 71488, '\P{^Block=ahom}', "");
    Expect(1, 71487, '\p{Block=:\Aahom\z:}', "");;
    Expect(0, 71488, '\p{Block=:\Aahom\z:}', "");;
    Expect(1, 71487, '\p{Block=	Ahom}', "");
    Expect(0, 71487, '\p{^Block=	Ahom}', "");
    Expect(0, 71487, '\P{Block=	Ahom}', "");
    Expect(1, 71487, '\P{^Block=	Ahom}', "");
    Expect(0, 71488, '\p{Block=	Ahom}', "");
    Expect(1, 71488, '\p{^Block=	Ahom}', "");
    Expect(1, 71488, '\P{Block=	Ahom}', "");
    Expect(0, 71488, '\P{^Block=	Ahom}', "");
    Error('\p{Blk::=-ahom}');
    Error('\P{Blk::=-ahom}');
    Expect(1, 71487, '\p{Blk=:\AAhom\z:}', "");;
    Expect(0, 71488, '\p{Blk=:\AAhom\z:}', "");;
    Expect(1, 71487, '\p{Blk=ahom}', "");
    Expect(0, 71487, '\p{^Blk=ahom}', "");
    Expect(0, 71487, '\P{Blk=ahom}', "");
    Expect(1, 71487, '\P{^Blk=ahom}', "");
    Expect(0, 71488, '\p{Blk=ahom}', "");
    Expect(1, 71488, '\p{^Blk=ahom}', "");
    Expect(1, 71488, '\P{Blk=ahom}', "");
    Expect(0, 71488, '\P{^Blk=ahom}', "");
    Expect(1, 71487, '\p{Blk=:\Aahom\z:}', "");;
    Expect(0, 71488, '\p{Blk=:\Aahom\z:}', "");;
    Expect(1, 71487, '\p{Blk=-	ahom}', "");
    Expect(0, 71487, '\p{^Blk=-	ahom}', "");
    Expect(0, 71487, '\P{Blk=-	ahom}', "");
    Expect(1, 71487, '\P{^Blk=-	ahom}', "");
    Expect(0, 71488, '\p{Blk=-	ahom}', "");
    Expect(1, 71488, '\p{^Blk=-	ahom}', "");
    Expect(1, 71488, '\P{Blk=-	ahom}', "");
    Expect(0, 71488, '\P{^Blk=-	ahom}', "");
    Error('\p{Is_Block=	ahom/a/}');
    Error('\P{Is_Block=	ahom/a/}');
    Expect(1, 71487, '\p{Is_Block=ahom}', "");
    Expect(0, 71487, '\p{^Is_Block=ahom}', "");
    Expect(0, 71487, '\P{Is_Block=ahom}', "");
    Expect(1, 71487, '\P{^Is_Block=ahom}', "");
    Expect(0, 71488, '\p{Is_Block=ahom}', "");
    Expect(1, 71488, '\p{^Is_Block=ahom}', "");
    Expect(1, 71488, '\P{Is_Block=ahom}', "");
    Expect(0, 71488, '\P{^Is_Block=ahom}', "");
    Expect(1, 71487, '\p{Is_Block=	Ahom}', "");
    Expect(0, 71487, '\p{^Is_Block=	Ahom}', "");
    Expect(0, 71487, '\P{Is_Block=	Ahom}', "");
    Expect(1, 71487, '\P{^Is_Block=	Ahom}', "");
    Expect(0, 71488, '\p{Is_Block=	Ahom}', "");
    Expect(1, 71488, '\p{^Is_Block=	Ahom}', "");
    Expect(1, 71488, '\P{Is_Block=	Ahom}', "");
    Expect(0, 71488, '\P{^Is_Block=	Ahom}', "");
    Error('\p{Is_Blk=_:=AHOM}');
    Error('\P{Is_Blk=_:=AHOM}');
    Expect(1, 71487, '\p{Is_Blk=ahom}', "");
    Expect(0, 71487, '\p{^Is_Blk=ahom}', "");
    Expect(0, 71487, '\P{Is_Blk=ahom}', "");
    Expect(1, 71487, '\P{^Is_Blk=ahom}', "");
    Expect(0, 71488, '\p{Is_Blk=ahom}', "");
    Expect(1, 71488, '\p{^Is_Blk=ahom}', "");
    Expect(1, 71488, '\P{Is_Blk=ahom}', "");
    Expect(0, 71488, '\P{^Is_Blk=ahom}', "");
    Error('\p{Block=		alchemical_Symbols/a/}');
    Error('\P{Block=		alchemical_Symbols/a/}');
    Expect(1, 128895, '\p{Block=:\AAlchemical_Symbols\z:}', "");;
    Expect(0, 128896, '\p{Block=:\AAlchemical_Symbols\z:}', "");;
    Expect(1, 128895, '\p{Block=alchemicalsymbols}', "");
    Expect(0, 128895, '\p{^Block=alchemicalsymbols}', "");
    Expect(0, 128895, '\P{Block=alchemicalsymbols}', "");
    Expect(1, 128895, '\P{^Block=alchemicalsymbols}', "");
    Expect(0, 128896, '\p{Block=alchemicalsymbols}', "");
    Expect(1, 128896, '\p{^Block=alchemicalsymbols}', "");
    Expect(1, 128896, '\P{Block=alchemicalsymbols}', "");
    Expect(0, 128896, '\P{^Block=alchemicalsymbols}', "");
    Expect(1, 128895, '\p{Block=:\Aalchemicalsymbols\z:}', "");;
    Expect(0, 128896, '\p{Block=:\Aalchemicalsymbols\z:}', "");;
    Expect(1, 128895, '\p{Block=_ ALCHEMICAL_symbols}', "");
    Expect(0, 128895, '\p{^Block=_ ALCHEMICAL_symbols}', "");
    Expect(0, 128895, '\P{Block=_ ALCHEMICAL_symbols}', "");
    Expect(1, 128895, '\P{^Block=_ ALCHEMICAL_symbols}', "");
    Expect(0, 128896, '\p{Block=_ ALCHEMICAL_symbols}', "");
    Expect(1, 128896, '\p{^Block=_ ALCHEMICAL_symbols}', "");
    Expect(1, 128896, '\P{Block=_ ALCHEMICAL_symbols}', "");
    Expect(0, 128896, '\P{^Block=_ ALCHEMICAL_symbols}', "");
    Error('\p{Blk=:=-Alchemical}');
    Error('\P{Blk=:=-Alchemical}');
    Expect(1, 128895, '\p{Blk=:\AAlchemical\z:}', "");;
    Expect(0, 128896, '\p{Blk=:\AAlchemical\z:}', "");;
    Expect(1, 128895, '\p{Blk=alchemical}', "");
    Expect(0, 128895, '\p{^Blk=alchemical}', "");
    Expect(0, 128895, '\P{Blk=alchemical}', "");
    Expect(1, 128895, '\P{^Blk=alchemical}', "");
    Expect(0, 128896, '\p{Blk=alchemical}', "");
    Expect(1, 128896, '\p{^Blk=alchemical}', "");
    Expect(1, 128896, '\P{Blk=alchemical}', "");
    Expect(0, 128896, '\P{^Blk=alchemical}', "");
    Expect(1, 128895, '\p{Blk=:\Aalchemical\z:}', "");;
    Expect(0, 128896, '\p{Blk=:\Aalchemical\z:}', "");;
    Expect(1, 128895, '\p{Blk=  ALCHEMICAL}', "");
    Expect(0, 128895, '\p{^Blk=  ALCHEMICAL}', "");
    Expect(0, 128895, '\P{Blk=  ALCHEMICAL}', "");
    Expect(1, 128895, '\P{^Blk=  ALCHEMICAL}', "");
    Expect(0, 128896, '\p{Blk=  ALCHEMICAL}', "");
    Expect(1, 128896, '\p{^Blk=  ALCHEMICAL}', "");
    Expect(1, 128896, '\P{Blk=  ALCHEMICAL}', "");
    Expect(0, 128896, '\P{^Blk=  ALCHEMICAL}', "");
    Error('\p{Is_Block: /a/_-ALCHEMICAL_symbols}');
    Error('\P{Is_Block: /a/_-ALCHEMICAL_symbols}');
    Expect(1, 128895, '\p{Is_Block=alchemicalsymbols}', "");
    Expect(0, 128895, '\p{^Is_Block=alchemicalsymbols}', "");
    Expect(0, 128895, '\P{Is_Block=alchemicalsymbols}', "");
    Expect(1, 128895, '\P{^Is_Block=alchemicalsymbols}', "");
    Expect(0, 128896, '\p{Is_Block=alchemicalsymbols}', "");
    Expect(1, 128896, '\p{^Is_Block=alchemicalsymbols}', "");
    Expect(1, 128896, '\P{Is_Block=alchemicalsymbols}', "");
    Expect(0, 128896, '\P{^Is_Block=alchemicalsymbols}', "");
    Expect(1, 128895, '\p{Is_Block=- Alchemical_Symbols}', "");
    Expect(0, 128895, '\p{^Is_Block=- Alchemical_Symbols}', "");
    Expect(0, 128895, '\P{Is_Block=- Alchemical_Symbols}', "");
    Expect(1, 128895, '\P{^Is_Block=- Alchemical_Symbols}', "");
    Expect(0, 128896, '\p{Is_Block=- Alchemical_Symbols}', "");
    Expect(1, 128896, '\p{^Is_Block=- Alchemical_Symbols}', "");
    Expect(1, 128896, '\P{Is_Block=- Alchemical_Symbols}', "");
    Expect(0, 128896, '\P{^Is_Block=- Alchemical_Symbols}', "");
    Error('\p{Is_Blk:/a/ -Alchemical}');
    Error('\P{Is_Blk:/a/ -Alchemical}');
    Expect(1, 128895, '\p{Is_Blk=alchemical}', "");
    Expect(0, 128895, '\p{^Is_Blk=alchemical}', "");
    Expect(0, 128895, '\P{Is_Blk=alchemical}', "");
    Expect(1, 128895, '\P{^Is_Blk=alchemical}', "");
    Expect(0, 128896, '\p{Is_Blk=alchemical}', "");
    Expect(1, 128896, '\p{^Is_Blk=alchemical}', "");
    Expect(1, 128896, '\P{Is_Blk=alchemical}', "");
    Expect(0, 128896, '\P{^Is_Blk=alchemical}', "");
    Expect(1, 128895, '\p{Is_Blk= _Alchemical}', "");
    Expect(0, 128895, '\p{^Is_Blk= _Alchemical}', "");
    Expect(0, 128895, '\P{Is_Blk= _Alchemical}', "");
    Expect(1, 128895, '\P{^Is_Blk= _Alchemical}', "");
    Expect(0, 128896, '\p{Is_Blk= _Alchemical}', "");
    Expect(1, 128896, '\p{^Is_Blk= _Alchemical}', "");
    Expect(1, 128896, '\P{Is_Blk= _Alchemical}', "");
    Expect(0, 128896, '\P{^Is_Blk= _Alchemical}', "");
    Error('\p{Block=/a/- Alphabetic_presentation_Forms}');
    Error('\P{Block=/a/- Alphabetic_presentation_Forms}');
    Expect(1, 64335, '\p{Block=:\AAlphabetic_Presentation_Forms\z:}', "");;
    Expect(0, 64336, '\p{Block=:\AAlphabetic_Presentation_Forms\z:}', "");;
    Expect(1, 64335, '\p{Block=alphabeticpresentationforms}', "");
    Expect(0, 64335, '\p{^Block=alphabeticpresentationforms}', "");
    Expect(0, 64335, '\P{Block=alphabeticpresentationforms}', "");
    Expect(1, 64335, '\P{^Block=alphabeticpresentationforms}', "");
    Expect(0, 64336, '\p{Block=alphabeticpresentationforms}', "");
    Expect(1, 64336, '\p{^Block=alphabeticpresentationforms}', "");
    Expect(1, 64336, '\P{Block=alphabeticpresentationforms}', "");
    Expect(0, 64336, '\P{^Block=alphabeticpresentationforms}', "");
    Expect(1, 64335, '\p{Block=:\Aalphabeticpresentationforms\z:}', "");;
    Expect(0, 64336, '\p{Block=:\Aalphabeticpresentationforms\z:}', "");;
    Expect(1, 64335, '\p{Block=	-Alphabetic_presentation_Forms}', "");
    Expect(0, 64335, '\p{^Block=	-Alphabetic_presentation_Forms}', "");
    Expect(0, 64335, '\P{Block=	-Alphabetic_presentation_Forms}', "");
    Expect(1, 64335, '\P{^Block=	-Alphabetic_presentation_Forms}', "");
    Expect(0, 64336, '\p{Block=	-Alphabetic_presentation_Forms}', "");
    Expect(1, 64336, '\p{^Block=	-Alphabetic_presentation_Forms}', "");
    Expect(1, 64336, '\P{Block=	-Alphabetic_presentation_Forms}', "");
    Expect(0, 64336, '\P{^Block=	-Alphabetic_presentation_Forms}', "");
    Error('\p{Blk: - Alphabetic_pf:=}');
    Error('\P{Blk: - Alphabetic_pf:=}');
    Expect(1, 64335, '\p{Blk=:\AAlphabetic_PF\z:}', "");;
    Expect(0, 64336, '\p{Blk=:\AAlphabetic_PF\z:}', "");;
    Expect(1, 64335, '\p{Blk=alphabeticpf}', "");
    Expect(0, 64335, '\p{^Blk=alphabeticpf}', "");
    Expect(0, 64335, '\P{Blk=alphabeticpf}', "");
    Expect(1, 64335, '\P{^Blk=alphabeticpf}', "");
    Expect(0, 64336, '\p{Blk=alphabeticpf}', "");
    Expect(1, 64336, '\p{^Blk=alphabeticpf}', "");
    Expect(1, 64336, '\P{Blk=alphabeticpf}', "");
    Expect(0, 64336, '\P{^Blk=alphabeticpf}', "");
    Expect(1, 64335, '\p{Blk=:\Aalphabeticpf\z:}', "");;
    Expect(0, 64336, '\p{Blk=:\Aalphabeticpf\z:}', "");;
    Expect(1, 64335, '\p{Blk=		Alphabetic_pf}', "");
    Expect(0, 64335, '\p{^Blk=		Alphabetic_pf}', "");
    Expect(0, 64335, '\P{Blk=		Alphabetic_pf}', "");
    Expect(1, 64335, '\P{^Blk=		Alphabetic_pf}', "");
    Expect(0, 64336, '\p{Blk=		Alphabetic_pf}', "");
    Expect(1, 64336, '\p{^Blk=		Alphabetic_pf}', "");
    Expect(1, 64336, '\P{Blk=		Alphabetic_pf}', "");
    Expect(0, 64336, '\P{^Blk=		Alphabetic_pf}', "");
    Error('\p{Is_Block=:=		Alphabetic_Presentation_FORMS}');
    Error('\P{Is_Block=:=		Alphabetic_Presentation_FORMS}');
    Expect(1, 64335, '\p{Is_Block=alphabeticpresentationforms}', "");
    Expect(0, 64335, '\p{^Is_Block=alphabeticpresentationforms}', "");
    Expect(0, 64335, '\P{Is_Block=alphabeticpresentationforms}', "");
    Expect(1, 64335, '\P{^Is_Block=alphabeticpresentationforms}', "");
    Expect(0, 64336, '\p{Is_Block=alphabeticpresentationforms}', "");
    Expect(1, 64336, '\p{^Is_Block=alphabeticpresentationforms}', "");
    Expect(1, 64336, '\P{Is_Block=alphabeticpresentationforms}', "");
    Expect(0, 64336, '\P{^Is_Block=alphabeticpresentationforms}', "");
    Expect(1, 64335, '\p{Is_Block:    	Alphabetic_PRESENTATION_Forms}', "");
    Expect(0, 64335, '\p{^Is_Block:    	Alphabetic_PRESENTATION_Forms}', "");
    Expect(0, 64335, '\P{Is_Block:    	Alphabetic_PRESENTATION_Forms}', "");
    Expect(1, 64335, '\P{^Is_Block:    	Alphabetic_PRESENTATION_Forms}', "");
    Expect(0, 64336, '\p{Is_Block:    	Alphabetic_PRESENTATION_Forms}', "");
    Expect(1, 64336, '\p{^Is_Block:    	Alphabetic_PRESENTATION_Forms}', "");
    Expect(1, 64336, '\P{Is_Block:    	Alphabetic_PRESENTATION_Forms}', "");
    Expect(0, 64336, '\P{^Is_Block:    	Alphabetic_PRESENTATION_Forms}', "");
    Error('\p{Is_Blk=- Alphabetic_PF:=}');
    Error('\P{Is_Blk=- Alphabetic_PF:=}');
    Expect(1, 64335, '\p{Is_Blk=alphabeticpf}', "");
    Expect(0, 64335, '\p{^Is_Blk=alphabeticpf}', "");
    Expect(0, 64335, '\P{Is_Blk=alphabeticpf}', "");
    Expect(1, 64335, '\P{^Is_Blk=alphabeticpf}', "");
    Expect(0, 64336, '\p{Is_Blk=alphabeticpf}', "");
    Expect(1, 64336, '\p{^Is_Blk=alphabeticpf}', "");
    Expect(1, 64336, '\P{Is_Blk=alphabeticpf}', "");
    Expect(0, 64336, '\P{^Is_Blk=alphabeticpf}', "");
    Expect(1, 64335, '\p{Is_Blk=		Alphabetic_PF}', "");
    Expect(0, 64335, '\p{^Is_Blk=		Alphabetic_PF}', "");
    Expect(0, 64335, '\P{Is_Blk=		Alphabetic_PF}', "");
    Expect(1, 64335, '\P{^Is_Blk=		Alphabetic_PF}', "");
    Expect(0, 64336, '\p{Is_Blk=		Alphabetic_PF}', "");
    Expect(1, 64336, '\p{^Is_Blk=		Alphabetic_PF}', "");
    Expect(1, 64336, '\P{Is_Blk=		Alphabetic_PF}', "");
    Expect(0, 64336, '\P{^Is_Blk=		Alphabetic_PF}', "");
    Error('\p{Block= :=Anatolian_Hieroglyphs}');
    Error('\P{Block= :=Anatolian_Hieroglyphs}');
    Expect(1, 83583, '\p{Block=:\AAnatolian_Hieroglyphs\z:}', "");;
    Expect(0, 83584, '\p{Block=:\AAnatolian_Hieroglyphs\z:}', "");;
    Expect(1, 83583, '\p{Block=anatolianhieroglyphs}', "");
    Expect(0, 83583, '\p{^Block=anatolianhieroglyphs}', "");
    Expect(0, 83583, '\P{Block=anatolianhieroglyphs}', "");
    Expect(1, 83583, '\P{^Block=anatolianhieroglyphs}', "");
    Expect(0, 83584, '\p{Block=anatolianhieroglyphs}', "");
    Expect(1, 83584, '\p{^Block=anatolianhieroglyphs}', "");
    Expect(1, 83584, '\P{Block=anatolianhieroglyphs}', "");
    Expect(0, 83584, '\P{^Block=anatolianhieroglyphs}', "");
    Expect(1, 83583, '\p{Block=:\Aanatolianhieroglyphs\z:}', "");;
    Expect(0, 83584, '\p{Block=:\Aanatolianhieroglyphs\z:}', "");;
    Expect(1, 83583, '\p{Block= -ANATOLIAN_HIEROGLYPHS}', "");
    Expect(0, 83583, '\p{^Block= -ANATOLIAN_HIEROGLYPHS}', "");
    Expect(0, 83583, '\P{Block= -ANATOLIAN_HIEROGLYPHS}', "");
    Expect(1, 83583, '\P{^Block= -ANATOLIAN_HIEROGLYPHS}', "");
    Expect(0, 83584, '\p{Block= -ANATOLIAN_HIEROGLYPHS}', "");
    Expect(1, 83584, '\p{^Block= -ANATOLIAN_HIEROGLYPHS}', "");
    Expect(1, 83584, '\P{Block= -ANATOLIAN_HIEROGLYPHS}', "");
    Expect(0, 83584, '\P{^Block= -ANATOLIAN_HIEROGLYPHS}', "");
    Error('\p{Blk=:= _anatolian_HIEROGLYPHS}');
    Error('\P{Blk=:= _anatolian_HIEROGLYPHS}');
    Expect(1, 83583, '\p{Blk=:\AAnatolian_Hieroglyphs\z:}', "");;
    Expect(0, 83584, '\p{Blk=:\AAnatolian_Hieroglyphs\z:}', "");;
    Expect(1, 83583, '\p{Blk=anatolianhieroglyphs}', "");
    Expect(0, 83583, '\p{^Blk=anatolianhieroglyphs}', "");
    Expect(0, 83583, '\P{Blk=anatolianhieroglyphs}', "");
    Expect(1, 83583, '\P{^Blk=anatolianhieroglyphs}', "");
    Expect(0, 83584, '\p{Blk=anatolianhieroglyphs}', "");
    Expect(1, 83584, '\p{^Blk=anatolianhieroglyphs}', "");
    Expect(1, 83584, '\P{Blk=anatolianhieroglyphs}', "");
    Expect(0, 83584, '\P{^Blk=anatolianhieroglyphs}', "");
    Expect(1, 83583, '\p{Blk=:\Aanatolianhieroglyphs\z:}', "");;
    Expect(0, 83584, '\p{Blk=:\Aanatolianhieroglyphs\z:}', "");;
    Expect(1, 83583, '\p{Blk=_	Anatolian_HIEROGLYPHS}', "");
    Expect(0, 83583, '\p{^Blk=_	Anatolian_HIEROGLYPHS}', "");
    Expect(0, 83583, '\P{Blk=_	Anatolian_HIEROGLYPHS}', "");
    Expect(1, 83583, '\P{^Blk=_	Anatolian_HIEROGLYPHS}', "");
    Expect(0, 83584, '\p{Blk=_	Anatolian_HIEROGLYPHS}', "");
    Expect(1, 83584, '\p{^Blk=_	Anatolian_HIEROGLYPHS}', "");
    Expect(1, 83584, '\P{Blk=_	Anatolian_HIEROGLYPHS}', "");
    Expect(0, 83584, '\P{^Blk=_	Anatolian_HIEROGLYPHS}', "");
    Error('\p{Is_Block:/a/ -Anatolian_Hieroglyphs}');
    Error('\P{Is_Block:/a/ -Anatolian_Hieroglyphs}');
    Expect(1, 83583, '\p{Is_Block=anatolianhieroglyphs}', "");
    Expect(0, 83583, '\p{^Is_Block=anatolianhieroglyphs}', "");
    Expect(0, 83583, '\P{Is_Block=anatolianhieroglyphs}', "");
    Expect(1, 83583, '\P{^Is_Block=anatolianhieroglyphs}', "");
    Expect(0, 83584, '\p{Is_Block=anatolianhieroglyphs}', "");
    Expect(1, 83584, '\p{^Is_Block=anatolianhieroglyphs}', "");
    Expect(1, 83584, '\P{Is_Block=anatolianhieroglyphs}', "");
    Expect(0, 83584, '\P{^Is_Block=anatolianhieroglyphs}', "");
    Expect(1, 83583, '\p{Is_Block=_Anatolian_hieroglyphs}', "");
    Expect(0, 83583, '\p{^Is_Block=_Anatolian_hieroglyphs}', "");
    Expect(0, 83583, '\P{Is_Block=_Anatolian_hieroglyphs}', "");
    Expect(1, 83583, '\P{^Is_Block=_Anatolian_hieroglyphs}', "");
    Expect(0, 83584, '\p{Is_Block=_Anatolian_hieroglyphs}', "");
    Expect(1, 83584, '\p{^Is_Block=_Anatolian_hieroglyphs}', "");
    Expect(1, 83584, '\P{Is_Block=_Anatolian_hieroglyphs}', "");
    Expect(0, 83584, '\P{^Is_Block=_Anatolian_hieroglyphs}', "");
    Error('\p{Is_Blk:		/a/anatolian_Hieroglyphs}');
    Error('\P{Is_Blk:		/a/anatolian_Hieroglyphs}');
    Expect(1, 83583, '\p{Is_Blk=anatolianhieroglyphs}', "");
    Expect(0, 83583, '\p{^Is_Blk=anatolianhieroglyphs}', "");
    Expect(0, 83583, '\P{Is_Blk=anatolianhieroglyphs}', "");
    Expect(1, 83583, '\P{^Is_Blk=anatolianhieroglyphs}', "");
    Expect(0, 83584, '\p{Is_Blk=anatolianhieroglyphs}', "");
    Expect(1, 83584, '\p{^Is_Blk=anatolianhieroglyphs}', "");
    Expect(1, 83584, '\P{Is_Blk=anatolianhieroglyphs}', "");
    Expect(0, 83584, '\P{^Is_Blk=anatolianhieroglyphs}', "");
    Expect(1, 83583, '\p{Is_Blk=	_Anatolian_Hieroglyphs}', "");
    Expect(0, 83583, '\p{^Is_Blk=	_Anatolian_Hieroglyphs}', "");
    Expect(0, 83583, '\P{Is_Blk=	_Anatolian_Hieroglyphs}', "");
    Expect(1, 83583, '\P{^Is_Blk=	_Anatolian_Hieroglyphs}', "");
    Expect(0, 83584, '\p{Is_Blk=	_Anatolian_Hieroglyphs}', "");
    Expect(1, 83584, '\p{^Is_Blk=	_Anatolian_Hieroglyphs}', "");
    Expect(1, 83584, '\P{Is_Blk=	_Anatolian_Hieroglyphs}', "");
    Expect(0, 83584, '\P{^Is_Blk=	_Anatolian_Hieroglyphs}', "");
    Error('\p{Block=:=_ Ancient_Greek_MUSICAL_Notation}');
    Error('\P{Block=:=_ Ancient_Greek_MUSICAL_Notation}');
    Expect(1, 119375, '\p{Block=:\AAncient_Greek_Musical_Notation\z:}', "");;
    Expect(0, 119376, '\p{Block=:\AAncient_Greek_Musical_Notation\z:}', "");;
    Expect(1, 119375, '\p{Block=ancientgreekmusicalnotation}', "");
    Expect(0, 119375, '\p{^Block=ancientgreekmusicalnotation}', "");
    Expect(0, 119375, '\P{Block=ancientgreekmusicalnotation}', "");
    Expect(1, 119375, '\P{^Block=ancientgreekmusicalnotation}', "");
    Expect(0, 119376, '\p{Block=ancientgreekmusicalnotation}', "");
    Expect(1, 119376, '\p{^Block=ancientgreekmusicalnotation}', "");
    Expect(1, 119376, '\P{Block=ancientgreekmusicalnotation}', "");
    Expect(0, 119376, '\P{^Block=ancientgreekmusicalnotation}', "");
    Expect(1, 119375, '\p{Block=:\Aancientgreekmusicalnotation\z:}', "");;
    Expect(0, 119376, '\p{Block=:\Aancientgreekmusicalnotation\z:}', "");;
    Expect(1, 119375, '\p{Block:  Ancient_Greek_musical_notation}', "");
    Expect(0, 119375, '\p{^Block:  Ancient_Greek_musical_notation}', "");
    Expect(0, 119375, '\P{Block:  Ancient_Greek_musical_notation}', "");
    Expect(1, 119375, '\P{^Block:  Ancient_Greek_musical_notation}', "");
    Expect(0, 119376, '\p{Block:  Ancient_Greek_musical_notation}', "");
    Expect(1, 119376, '\p{^Block:  Ancient_Greek_musical_notation}', "");
    Expect(1, 119376, '\P{Block:  Ancient_Greek_musical_notation}', "");
    Expect(0, 119376, '\P{^Block:  Ancient_Greek_musical_notation}', "");
    Error('\p{Blk=/a/	ancient_greek_music}');
    Error('\P{Blk=/a/	ancient_greek_music}');
    Expect(1, 119375, '\p{Blk=:\AAncient_Greek_Music\z:}', "");;
    Expect(0, 119376, '\p{Blk=:\AAncient_Greek_Music\z:}', "");;
    Expect(1, 119375, '\p{Blk=ancientgreekmusic}', "");
    Expect(0, 119375, '\p{^Blk=ancientgreekmusic}', "");
    Expect(0, 119375, '\P{Blk=ancientgreekmusic}', "");
    Expect(1, 119375, '\P{^Blk=ancientgreekmusic}', "");
    Expect(0, 119376, '\p{Blk=ancientgreekmusic}', "");
    Expect(1, 119376, '\p{^Blk=ancientgreekmusic}', "");
    Expect(1, 119376, '\P{Blk=ancientgreekmusic}', "");
    Expect(0, 119376, '\P{^Blk=ancientgreekmusic}', "");
    Expect(1, 119375, '\p{Blk=:\Aancientgreekmusic\z:}', "");;
    Expect(0, 119376, '\p{Blk=:\Aancientgreekmusic\z:}', "");;
    Expect(1, 119375, '\p{Blk=	-ANCIENT_Greek_MUSIC}', "");
    Expect(0, 119375, '\p{^Blk=	-ANCIENT_Greek_MUSIC}', "");
    Expect(0, 119375, '\P{Blk=	-ANCIENT_Greek_MUSIC}', "");
    Expect(1, 119375, '\P{^Blk=	-ANCIENT_Greek_MUSIC}', "");
    Expect(0, 119376, '\p{Blk=	-ANCIENT_Greek_MUSIC}', "");
    Expect(1, 119376, '\p{^Blk=	-ANCIENT_Greek_MUSIC}', "");
    Expect(1, 119376, '\P{Blk=	-ANCIENT_Greek_MUSIC}', "");
    Expect(0, 119376, '\P{^Blk=	-ANCIENT_Greek_MUSIC}', "");
    Error('\p{Is_Block=/a/_	Ancient_Greek_MUSICAL_Notation}');
    Error('\P{Is_Block=/a/_	Ancient_Greek_MUSICAL_Notation}');
    Expect(1, 119375, '\p{Is_Block=ancientgreekmusicalnotation}', "");
    Expect(0, 119375, '\p{^Is_Block=ancientgreekmusicalnotation}', "");
    Expect(0, 119375, '\P{Is_Block=ancientgreekmusicalnotation}', "");
    Expect(1, 119375, '\P{^Is_Block=ancientgreekmusicalnotation}', "");
    Expect(0, 119376, '\p{Is_Block=ancientgreekmusicalnotation}', "");
    Expect(1, 119376, '\p{^Is_Block=ancientgreekmusicalnotation}', "");
    Expect(1, 119376, '\P{Is_Block=ancientgreekmusicalnotation}', "");
    Expect(0, 119376, '\P{^Is_Block=ancientgreekmusicalnotation}', "");
    Expect(1, 119375, '\p{Is_Block= -Ancient_Greek_Musical_NOTATION}', "");
    Expect(0, 119375, '\p{^Is_Block= -Ancient_Greek_Musical_NOTATION}', "");
    Expect(0, 119375, '\P{Is_Block= -Ancient_Greek_Musical_NOTATION}', "");
    Expect(1, 119375, '\P{^Is_Block= -Ancient_Greek_Musical_NOTATION}', "");
    Expect(0, 119376, '\p{Is_Block= -Ancient_Greek_Musical_NOTATION}', "");
    Expect(1, 119376, '\p{^Is_Block= -Ancient_Greek_Musical_NOTATION}', "");
    Expect(1, 119376, '\P{Is_Block= -Ancient_Greek_Musical_NOTATION}', "");
    Expect(0, 119376, '\P{^Is_Block= -Ancient_Greek_Musical_NOTATION}', "");
    Error('\p{Is_Blk=		Ancient_greek_MUSIC/a/}');
    Error('\P{Is_Blk=		Ancient_greek_MUSIC/a/}');
    Expect(1, 119375, '\p{Is_Blk=ancientgreekmusic}', "");
    Expect(0, 119375, '\p{^Is_Blk=ancientgreekmusic}', "");
    Expect(0, 119375, '\P{Is_Blk=ancientgreekmusic}', "");
    Expect(1, 119375, '\P{^Is_Blk=ancientgreekmusic}', "");
    Expect(0, 119376, '\p{Is_Blk=ancientgreekmusic}', "");
    Expect(1, 119376, '\p{^Is_Blk=ancientgreekmusic}', "");
    Expect(1, 119376, '\P{Is_Blk=ancientgreekmusic}', "");
    Expect(0, 119376, '\P{^Is_Blk=ancientgreekmusic}', "");
    Expect(1, 119375, '\p{Is_Blk=	Ancient_greek_music}', "");
    Expect(0, 119375, '\p{^Is_Blk=	Ancient_greek_music}', "");
    Expect(0, 119375, '\P{Is_Blk=	Ancient_greek_music}', "");
    Expect(1, 119375, '\P{^Is_Blk=	Ancient_greek_music}', "");
    Expect(0, 119376, '\p{Is_Blk=	Ancient_greek_music}', "");
    Expect(1, 119376, '\p{^Is_Blk=	Ancient_greek_music}', "");
    Expect(1, 119376, '\P{Is_Blk=	Ancient_greek_music}', "");
    Expect(0, 119376, '\P{^Is_Blk=	Ancient_greek_music}', "");
    Error('\p{Block=:= _ANCIENT_Greek_Numbers}');
    Error('\P{Block=:= _ANCIENT_Greek_Numbers}');
    Expect(1, 65935, '\p{Block=:\AAncient_Greek_Numbers\z:}', "");;
    Expect(0, 65936, '\p{Block=:\AAncient_Greek_Numbers\z:}', "");;
    Expect(1, 65935, '\p{Block: ancientgreeknumbers}', "");
    Expect(0, 65935, '\p{^Block: ancientgreeknumbers}', "");
    Expect(0, 65935, '\P{Block: ancientgreeknumbers}', "");
    Expect(1, 65935, '\P{^Block: ancientgreeknumbers}', "");
    Expect(0, 65936, '\p{Block: ancientgreeknumbers}', "");
    Expect(1, 65936, '\p{^Block: ancientgreeknumbers}', "");
    Expect(1, 65936, '\P{Block: ancientgreeknumbers}', "");
    Expect(0, 65936, '\P{^Block: ancientgreeknumbers}', "");
    Expect(1, 65935, '\p{Block=:\Aancientgreeknumbers\z:}', "");;
    Expect(0, 65936, '\p{Block=:\Aancientgreeknumbers\z:}', "");;
    Expect(1, 65935, '\p{Block= _Ancient_greek_Numbers}', "");
    Expect(0, 65935, '\p{^Block= _Ancient_greek_Numbers}', "");
    Expect(0, 65935, '\P{Block= _Ancient_greek_Numbers}', "");
    Expect(1, 65935, '\P{^Block= _Ancient_greek_Numbers}', "");
    Expect(0, 65936, '\p{Block= _Ancient_greek_Numbers}', "");
    Expect(1, 65936, '\p{^Block= _Ancient_greek_Numbers}', "");
    Expect(1, 65936, '\P{Block= _Ancient_greek_Numbers}', "");
    Expect(0, 65936, '\P{^Block= _Ancient_greek_Numbers}', "");
    Error('\p{Blk=/a/	 ANCIENT_greek_Numbers}');
    Error('\P{Blk=/a/	 ANCIENT_greek_Numbers}');
    Expect(1, 65935, '\p{Blk=:\AAncient_Greek_Numbers\z:}', "");;
    Expect(0, 65936, '\p{Blk=:\AAncient_Greek_Numbers\z:}', "");;
    Expect(1, 65935, '\p{Blk=ancientgreeknumbers}', "");
    Expect(0, 65935, '\p{^Blk=ancientgreeknumbers}', "");
    Expect(0, 65935, '\P{Blk=ancientgreeknumbers}', "");
    Expect(1, 65935, '\P{^Blk=ancientgreeknumbers}', "");
    Expect(0, 65936, '\p{Blk=ancientgreeknumbers}', "");
    Expect(1, 65936, '\p{^Blk=ancientgreeknumbers}', "");
    Expect(1, 65936, '\P{Blk=ancientgreeknumbers}', "");
    Expect(0, 65936, '\P{^Blk=ancientgreeknumbers}', "");
    Expect(1, 65935, '\p{Blk=:\Aancientgreeknumbers\z:}', "");;
    Expect(0, 65936, '\p{Blk=:\Aancientgreeknumbers\z:}', "");;
    Expect(1, 65935, '\p{Blk=__Ancient_Greek_NUMBERS}', "");
    Expect(0, 65935, '\p{^Blk=__Ancient_Greek_NUMBERS}', "");
    Expect(0, 65935, '\P{Blk=__Ancient_Greek_NUMBERS}', "");
    Expect(1, 65935, '\P{^Blk=__Ancient_Greek_NUMBERS}', "");
    Expect(0, 65936, '\p{Blk=__Ancient_Greek_NUMBERS}', "");
    Expect(1, 65936, '\p{^Blk=__Ancient_Greek_NUMBERS}', "");
    Expect(1, 65936, '\P{Blk=__Ancient_Greek_NUMBERS}', "");
    Expect(0, 65936, '\P{^Blk=__Ancient_Greek_NUMBERS}', "");
    Error('\p{Is_Block=:=	ANCIENT_GREEK_Numbers}');
    Error('\P{Is_Block=:=	ANCIENT_GREEK_Numbers}');
    Expect(1, 65935, '\p{Is_Block=ancientgreeknumbers}', "");
    Expect(0, 65935, '\p{^Is_Block=ancientgreeknumbers}', "");
    Expect(0, 65935, '\P{Is_Block=ancientgreeknumbers}', "");
    Expect(1, 65935, '\P{^Is_Block=ancientgreeknumbers}', "");
    Expect(0, 65936, '\p{Is_Block=ancientgreeknumbers}', "");
    Expect(1, 65936, '\p{^Is_Block=ancientgreeknumbers}', "");
    Expect(1, 65936, '\P{Is_Block=ancientgreeknumbers}', "");
    Expect(0, 65936, '\P{^Is_Block=ancientgreeknumbers}', "");
    Expect(1, 65935, '\p{Is_Block= ancient_Greek_Numbers}', "");
    Expect(0, 65935, '\p{^Is_Block= ancient_Greek_Numbers}', "");
    Expect(0, 65935, '\P{Is_Block= ancient_Greek_Numbers}', "");
    Expect(1, 65935, '\P{^Is_Block= ancient_Greek_Numbers}', "");
    Expect(0, 65936, '\p{Is_Block= ancient_Greek_Numbers}', "");
    Expect(1, 65936, '\p{^Is_Block= ancient_Greek_Numbers}', "");
    Expect(1, 65936, '\P{Is_Block= ancient_Greek_Numbers}', "");
    Expect(0, 65936, '\P{^Is_Block= ancient_Greek_Numbers}', "");
    Error('\p{Is_Blk=	:=Ancient_Greek_Numbers}');
    Error('\P{Is_Blk=	:=Ancient_Greek_Numbers}');
    Expect(1, 65935, '\p{Is_Blk=ancientgreeknumbers}', "");
    Expect(0, 65935, '\p{^Is_Blk=ancientgreeknumbers}', "");
    Expect(0, 65935, '\P{Is_Blk=ancientgreeknumbers}', "");
    Expect(1, 65935, '\P{^Is_Blk=ancientgreeknumbers}', "");
    Expect(0, 65936, '\p{Is_Blk=ancientgreeknumbers}', "");
    Expect(1, 65936, '\p{^Is_Blk=ancientgreeknumbers}', "");
    Expect(1, 65936, '\P{Is_Blk=ancientgreeknumbers}', "");
    Expect(0, 65936, '\P{^Is_Blk=ancientgreeknumbers}', "");
    Expect(1, 65935, '\p{Is_Blk=Ancient_Greek_numbers}', "");
    Expect(0, 65935, '\p{^Is_Blk=Ancient_Greek_numbers}', "");
    Expect(0, 65935, '\P{Is_Blk=Ancient_Greek_numbers}', "");
    Expect(1, 65935, '\P{^Is_Blk=Ancient_Greek_numbers}', "");
    Expect(0, 65936, '\p{Is_Blk=Ancient_Greek_numbers}', "");
    Expect(1, 65936, '\p{^Is_Blk=Ancient_Greek_numbers}', "");
    Expect(1, 65936, '\P{Is_Blk=Ancient_Greek_numbers}', "");
    Expect(0, 65936, '\P{^Is_Blk=Ancient_Greek_numbers}', "");
    Error('\p{Block=:= 	Ancient_Symbols}');
    Error('\P{Block=:= 	Ancient_Symbols}');
    Expect(1, 65999, '\p{Block=:\AAncient_Symbols\z:}', "");;
    Expect(0, 66000, '\p{Block=:\AAncient_Symbols\z:}', "");;
    Expect(1, 65999, '\p{Block=ancientsymbols}', "");
    Expect(0, 65999, '\p{^Block=ancientsymbols}', "");
    Expect(0, 65999, '\P{Block=ancientsymbols}', "");
    Expect(1, 65999, '\P{^Block=ancientsymbols}', "");
    Expect(0, 66000, '\p{Block=ancientsymbols}', "");
    Expect(1, 66000, '\p{^Block=ancientsymbols}', "");
    Expect(1, 66000, '\P{Block=ancientsymbols}', "");
    Expect(0, 66000, '\P{^Block=ancientsymbols}', "");
    Expect(1, 65999, '\p{Block=:\Aancientsymbols\z:}', "");;
    Expect(0, 66000, '\p{Block=:\Aancientsymbols\z:}', "");;
    Expect(1, 65999, '\p{Block=__ancient_Symbols}', "");
    Expect(0, 65999, '\p{^Block=__ancient_Symbols}', "");
    Expect(0, 65999, '\P{Block=__ancient_Symbols}', "");
    Expect(1, 65999, '\P{^Block=__ancient_Symbols}', "");
    Expect(0, 66000, '\p{Block=__ancient_Symbols}', "");
    Expect(1, 66000, '\p{^Block=__ancient_Symbols}', "");
    Expect(1, 66000, '\P{Block=__ancient_Symbols}', "");
    Expect(0, 66000, '\P{^Block=__ancient_Symbols}', "");
    Error('\p{Blk=-/a/ANCIENT_Symbols}');
    Error('\P{Blk=-/a/ANCIENT_Symbols}');
    Expect(1, 65999, '\p{Blk=:\AAncient_Symbols\z:}', "");;
    Expect(0, 66000, '\p{Blk=:\AAncient_Symbols\z:}', "");;
    Expect(1, 65999, '\p{Blk:   ancientsymbols}', "");
    Expect(0, 65999, '\p{^Blk:   ancientsymbols}', "");
    Expect(0, 65999, '\P{Blk:   ancientsymbols}', "");
    Expect(1, 65999, '\P{^Blk:   ancientsymbols}', "");
    Expect(0, 66000, '\p{Blk:   ancientsymbols}', "");
    Expect(1, 66000, '\p{^Blk:   ancientsymbols}', "");
    Expect(1, 66000, '\P{Blk:   ancientsymbols}', "");
    Expect(0, 66000, '\P{^Blk:   ancientsymbols}', "");
    Expect(1, 65999, '\p{Blk=:\Aancientsymbols\z:}', "");;
    Expect(0, 66000, '\p{Blk=:\Aancientsymbols\z:}', "");;
    Expect(1, 65999, '\p{Blk=-Ancient_Symbols}', "");
    Expect(0, 65999, '\p{^Blk=-Ancient_Symbols}', "");
    Expect(0, 65999, '\P{Blk=-Ancient_Symbols}', "");
    Expect(1, 65999, '\P{^Blk=-Ancient_Symbols}', "");
    Expect(0, 66000, '\p{Blk=-Ancient_Symbols}', "");
    Expect(1, 66000, '\p{^Blk=-Ancient_Symbols}', "");
    Expect(1, 66000, '\P{Blk=-Ancient_Symbols}', "");
    Expect(0, 66000, '\P{^Blk=-Ancient_Symbols}', "");
    Error('\p{Is_Block=_:=Ancient_SYMBOLS}');
    Error('\P{Is_Block=_:=Ancient_SYMBOLS}');
    Expect(1, 65999, '\p{Is_Block=ancientsymbols}', "");
    Expect(0, 65999, '\p{^Is_Block=ancientsymbols}', "");
    Expect(0, 65999, '\P{Is_Block=ancientsymbols}', "");
    Expect(1, 65999, '\P{^Is_Block=ancientsymbols}', "");
    Expect(0, 66000, '\p{Is_Block=ancientsymbols}', "");
    Expect(1, 66000, '\p{^Is_Block=ancientsymbols}', "");
    Expect(1, 66000, '\P{Is_Block=ancientsymbols}', "");
    Expect(0, 66000, '\P{^Is_Block=ancientsymbols}', "");
    Expect(1, 65999, '\p{Is_Block=_Ancient_Symbols}', "");
    Expect(0, 65999, '\p{^Is_Block=_Ancient_Symbols}', "");
    Expect(0, 65999, '\P{Is_Block=_Ancient_Symbols}', "");
    Expect(1, 65999, '\P{^Is_Block=_Ancient_Symbols}', "");
    Expect(0, 66000, '\p{Is_Block=_Ancient_Symbols}', "");
    Expect(1, 66000, '\p{^Is_Block=_Ancient_Symbols}', "");
    Expect(1, 66000, '\P{Is_Block=_Ancient_Symbols}', "");
    Expect(0, 66000, '\P{^Is_Block=_Ancient_Symbols}', "");
    Error('\p{Is_Blk=_-Ancient_SYMBOLS:=}');
    Error('\P{Is_Blk=_-Ancient_SYMBOLS:=}');
    Expect(1, 65999, '\p{Is_Blk=ancientsymbols}', "");
    Expect(0, 65999, '\p{^Is_Blk=ancientsymbols}', "");
    Expect(0, 65999, '\P{Is_Blk=ancientsymbols}', "");
    Expect(1, 65999, '\P{^Is_Blk=ancientsymbols}', "");
    Expect(0, 66000, '\p{Is_Blk=ancientsymbols}', "");
    Expect(1, 66000, '\p{^Is_Blk=ancientsymbols}', "");
    Expect(1, 66000, '\P{Is_Blk=ancientsymbols}', "");
    Expect(0, 66000, '\P{^Is_Blk=ancientsymbols}', "");
    Expect(1, 65999, '\p{Is_Blk:_ Ancient_symbols}', "");
    Expect(0, 65999, '\p{^Is_Blk:_ Ancient_symbols}', "");
    Expect(0, 65999, '\P{Is_Blk:_ Ancient_symbols}', "");
    Expect(1, 65999, '\P{^Is_Blk:_ Ancient_symbols}', "");
    Expect(0, 66000, '\p{Is_Blk:_ Ancient_symbols}', "");
    Expect(1, 66000, '\p{^Is_Blk:_ Ancient_symbols}', "");
    Expect(1, 66000, '\P{Is_Blk:_ Ancient_symbols}', "");
    Expect(0, 66000, '\P{^Is_Blk:_ Ancient_symbols}', "");
    Error('\p{Block=  arabic/a/}');
    Error('\P{Block=  arabic/a/}');
    Expect(1, 1791, '\p{Block=:\AArabic\z:}', "");;
    Expect(0, 1792, '\p{Block=:\AArabic\z:}', "");;
    Expect(1, 1791, '\p{Block=arabic}', "");
    Expect(0, 1791, '\p{^Block=arabic}', "");
    Expect(0, 1791, '\P{Block=arabic}', "");
    Expect(1, 1791, '\P{^Block=arabic}', "");
    Expect(0, 1792, '\p{Block=arabic}', "");
    Expect(1, 1792, '\p{^Block=arabic}', "");
    Expect(1, 1792, '\P{Block=arabic}', "");
    Expect(0, 1792, '\P{^Block=arabic}', "");
    Expect(1, 1791, '\p{Block=:\Aarabic\z:}', "");;
    Expect(0, 1792, '\p{Block=:\Aarabic\z:}', "");;
    Expect(1, 1791, '\p{Block:_Arabic}', "");
    Expect(0, 1791, '\p{^Block:_Arabic}', "");
    Expect(0, 1791, '\P{Block:_Arabic}', "");
    Expect(1, 1791, '\P{^Block:_Arabic}', "");
    Expect(0, 1792, '\p{Block:_Arabic}', "");
    Expect(1, 1792, '\p{^Block:_Arabic}', "");
    Expect(1, 1792, '\P{Block:_Arabic}', "");
    Expect(0, 1792, '\P{^Block:_Arabic}', "");
    Error('\p{Blk=/a/	Arabic}');
    Error('\P{Blk=/a/	Arabic}');
    Expect(1, 1791, '\p{Blk=:\AArabic\z:}', "");;
    Expect(0, 1792, '\p{Blk=:\AArabic\z:}', "");;
    Expect(1, 1791, '\p{Blk=arabic}', "");
    Expect(0, 1791, '\p{^Blk=arabic}', "");
    Expect(0, 1791, '\P{Blk=arabic}', "");
    Expect(1, 1791, '\P{^Blk=arabic}', "");
    Expect(0, 1792, '\p{Blk=arabic}', "");
    Expect(1, 1792, '\p{^Blk=arabic}', "");
    Expect(1, 1792, '\P{Blk=arabic}', "");
    Expect(0, 1792, '\P{^Blk=arabic}', "");
    Expect(1, 1791, '\p{Blk=:\Aarabic\z:}', "");;
    Expect(0, 1792, '\p{Blk=:\Aarabic\z:}', "");;
    Expect(1, 1791, '\p{Blk=-Arabic}', "");
    Expect(0, 1791, '\p{^Blk=-Arabic}', "");
    Expect(0, 1791, '\P{Blk=-Arabic}', "");
    Expect(1, 1791, '\P{^Blk=-Arabic}', "");
    Expect(0, 1792, '\p{Blk=-Arabic}', "");
    Expect(1, 1792, '\p{^Blk=-Arabic}', "");
    Expect(1, 1792, '\P{Blk=-Arabic}', "");
    Expect(0, 1792, '\P{^Blk=-Arabic}', "");
    Error('\p{Is_Block=/a/-	Arabic}');
    Error('\P{Is_Block=/a/-	Arabic}');
    Expect(1, 1791, '\p{Is_Block:arabic}', "");
    Expect(0, 1791, '\p{^Is_Block:arabic}', "");
    Expect(0, 1791, '\P{Is_Block:arabic}', "");
    Expect(1, 1791, '\P{^Is_Block:arabic}', "");
    Expect(0, 1792, '\p{Is_Block:arabic}', "");
    Expect(1, 1792, '\p{^Is_Block:arabic}', "");
    Expect(1, 1792, '\P{Is_Block:arabic}', "");
    Expect(0, 1792, '\P{^Is_Block:arabic}', "");
    Expect(1, 1791, '\p{Is_Block=_Arabic}', "");
    Expect(0, 1791, '\p{^Is_Block=_Arabic}', "");
    Expect(0, 1791, '\P{Is_Block=_Arabic}', "");
    Expect(1, 1791, '\P{^Is_Block=_Arabic}', "");
    Expect(0, 1792, '\p{Is_Block=_Arabic}', "");
    Expect(1, 1792, '\p{^Is_Block=_Arabic}', "");
    Expect(1, 1792, '\P{Is_Block=_Arabic}', "");
    Expect(0, 1792, '\P{^Is_Block=_Arabic}', "");
    Error('\p{Is_Blk=_Arabic:=}');
    Error('\P{Is_Blk=_Arabic:=}');
    Expect(1, 1791, '\p{Is_Blk=arabic}', "");
    Expect(0, 1791, '\p{^Is_Blk=arabic}', "");
    Expect(0, 1791, '\P{Is_Blk=arabic}', "");
    Expect(1, 1791, '\P{^Is_Blk=arabic}', "");
    Expect(0, 1792, '\p{Is_Blk=arabic}', "");
    Expect(1, 1792, '\p{^Is_Blk=arabic}', "");
    Expect(1, 1792, '\P{Is_Blk=arabic}', "");
    Expect(0, 1792, '\P{^Is_Blk=arabic}', "");
    Expect(1, 1791, '\p{Is_Blk=Arabic}', "");
    Expect(0, 1791, '\p{^Is_Blk=Arabic}', "");
    Expect(0, 1791, '\P{Is_Blk=Arabic}', "");
    Expect(1, 1791, '\P{^Is_Blk=Arabic}', "");
    Expect(0, 1792, '\p{Is_Blk=Arabic}', "");
    Expect(1, 1792, '\p{^Is_Blk=Arabic}', "");
    Expect(1, 1792, '\P{Is_Blk=Arabic}', "");
    Expect(0, 1792, '\P{^Is_Blk=Arabic}', "");
    Error('\p{Block=_Arabic_Extended_A/a/}');
    Error('\P{Block=_Arabic_Extended_A/a/}');
    Expect(1, 2303, '\p{Block=:\AArabic_Extended_A\z:}', "");;
    Expect(0, 2304, '\p{Block=:\AArabic_Extended_A\z:}', "");;
    Expect(1, 2303, '\p{Block: arabicextendeda}', "");
    Expect(0, 2303, '\p{^Block: arabicextendeda}', "");
    Expect(0, 2303, '\P{Block: arabicextendeda}', "");
    Expect(1, 2303, '\P{^Block: arabicextendeda}', "");
    Expect(0, 2304, '\p{Block: arabicextendeda}', "");
    Expect(1, 2304, '\p{^Block: arabicextendeda}', "");
    Expect(1, 2304, '\P{Block: arabicextendeda}', "");
    Expect(0, 2304, '\P{^Block: arabicextendeda}', "");
    Expect(1, 2303, '\p{Block=:\Aarabicextendeda\z:}', "");;
    Expect(0, 2304, '\p{Block=:\Aarabicextendeda\z:}', "");;
    Expect(1, 2303, '\p{Block=	_Arabic_extended_A}', "");
    Expect(0, 2303, '\p{^Block=	_Arabic_extended_A}', "");
    Expect(0, 2303, '\P{Block=	_Arabic_extended_A}', "");
    Expect(1, 2303, '\P{^Block=	_Arabic_extended_A}', "");
    Expect(0, 2304, '\p{Block=	_Arabic_extended_A}', "");
    Expect(1, 2304, '\p{^Block=	_Arabic_extended_A}', "");
    Expect(1, 2304, '\P{Block=	_Arabic_extended_A}', "");
    Expect(0, 2304, '\P{^Block=	_Arabic_extended_A}', "");
    Error('\p{Blk=:=	_ARABIC_ext_A}');
    Error('\P{Blk=:=	_ARABIC_ext_A}');
    Expect(1, 2303, '\p{Blk=:\AArabic_Ext_A\z:}', "");;
    Expect(0, 2304, '\p{Blk=:\AArabic_Ext_A\z:}', "");;
    Expect(1, 2303, '\p{Blk=arabicexta}', "");
    Expect(0, 2303, '\p{^Blk=arabicexta}', "");
    Expect(0, 2303, '\P{Blk=arabicexta}', "");
    Expect(1, 2303, '\P{^Blk=arabicexta}', "");
    Expect(0, 2304, '\p{Blk=arabicexta}', "");
    Expect(1, 2304, '\p{^Blk=arabicexta}', "");
    Expect(1, 2304, '\P{Blk=arabicexta}', "");
    Expect(0, 2304, '\P{^Blk=arabicexta}', "");
    Expect(1, 2303, '\p{Blk=:\Aarabicexta\z:}', "");;
    Expect(0, 2304, '\p{Blk=:\Aarabicexta\z:}', "");;
    Expect(1, 2303, '\p{Blk=_	Arabic_Ext_A}', "");
    Expect(0, 2303, '\p{^Blk=_	Arabic_Ext_A}', "");
    Expect(0, 2303, '\P{Blk=_	Arabic_Ext_A}', "");
    Expect(1, 2303, '\P{^Blk=_	Arabic_Ext_A}', "");
    Expect(0, 2304, '\p{Blk=_	Arabic_Ext_A}', "");
    Expect(1, 2304, '\p{^Blk=_	Arabic_Ext_A}', "");
    Expect(1, 2304, '\P{Blk=_	Arabic_Ext_A}', "");
    Expect(0, 2304, '\P{^Blk=_	Arabic_Ext_A}', "");
    Error('\p{Is_Block:    :=Arabic_Extended_A}');
    Error('\P{Is_Block:    :=Arabic_Extended_A}');
    Expect(1, 2303, '\p{Is_Block=arabicextendeda}', "");
    Expect(0, 2303, '\p{^Is_Block=arabicextendeda}', "");
    Expect(0, 2303, '\P{Is_Block=arabicextendeda}', "");
    Expect(1, 2303, '\P{^Is_Block=arabicextendeda}', "");
    Expect(0, 2304, '\p{Is_Block=arabicextendeda}', "");
    Expect(1, 2304, '\p{^Is_Block=arabicextendeda}', "");
    Expect(1, 2304, '\P{Is_Block=arabicextendeda}', "");
    Expect(0, 2304, '\P{^Is_Block=arabicextendeda}', "");
    Expect(1, 2303, '\p{Is_Block= Arabic_extended_A}', "");
    Expect(0, 2303, '\p{^Is_Block= Arabic_extended_A}', "");
    Expect(0, 2303, '\P{Is_Block= Arabic_extended_A}', "");
    Expect(1, 2303, '\P{^Is_Block= Arabic_extended_A}', "");
    Expect(0, 2304, '\p{Is_Block= Arabic_extended_A}', "");
    Expect(1, 2304, '\p{^Is_Block= Arabic_extended_A}', "");
    Expect(1, 2304, '\P{Is_Block= Arabic_extended_A}', "");
    Expect(0, 2304, '\P{^Is_Block= Arabic_extended_A}', "");
    Error('\p{Is_Blk=:=-Arabic_ext_A}');
    Error('\P{Is_Blk=:=-Arabic_ext_A}');
    Expect(1, 2303, '\p{Is_Blk=arabicexta}', "");
    Expect(0, 2303, '\p{^Is_Blk=arabicexta}', "");
    Expect(0, 2303, '\P{Is_Blk=arabicexta}', "");
    Expect(1, 2303, '\P{^Is_Blk=arabicexta}', "");
    Expect(0, 2304, '\p{Is_Blk=arabicexta}', "");
    Expect(1, 2304, '\p{^Is_Blk=arabicexta}', "");
    Expect(1, 2304, '\P{Is_Blk=arabicexta}', "");
    Expect(0, 2304, '\P{^Is_Blk=arabicexta}', "");
    Expect(1, 2303, '\p{Is_Blk=_ Arabic_Ext_A}', "");
    Expect(0, 2303, '\p{^Is_Blk=_ Arabic_Ext_A}', "");
    Expect(0, 2303, '\P{Is_Blk=_ Arabic_Ext_A}', "");
    Expect(1, 2303, '\P{^Is_Blk=_ Arabic_Ext_A}', "");
    Expect(0, 2304, '\p{Is_Blk=_ Arabic_Ext_A}', "");
    Expect(1, 2304, '\p{^Is_Blk=_ Arabic_Ext_A}', "");
    Expect(1, 2304, '\P{Is_Blk=_ Arabic_Ext_A}', "");
    Expect(0, 2304, '\P{^Is_Blk=_ Arabic_Ext_A}', "");
    Error('\p{Block=- Arabic_mathematical_Alphabetic_SYMBOLS:=}');
    Error('\P{Block=- Arabic_mathematical_Alphabetic_SYMBOLS:=}');
    Expect(1, 126719, '\p{Block=:\AArabic_Mathematical_Alphabetic_Symbols\z:}', "");;
    Expect(0, 126720, '\p{Block=:\AArabic_Mathematical_Alphabetic_Symbols\z:}', "");;
    Expect(1, 126719, '\p{Block=arabicmathematicalalphabeticsymbols}', "");
    Expect(0, 126719, '\p{^Block=arabicmathematicalalphabeticsymbols}', "");
    Expect(0, 126719, '\P{Block=arabicmathematicalalphabeticsymbols}', "");
    Expect(1, 126719, '\P{^Block=arabicmathematicalalphabeticsymbols}', "");
    Expect(0, 126720, '\p{Block=arabicmathematicalalphabeticsymbols}', "");
    Expect(1, 126720, '\p{^Block=arabicmathematicalalphabeticsymbols}', "");
    Expect(1, 126720, '\P{Block=arabicmathematicalalphabeticsymbols}', "");
    Expect(0, 126720, '\P{^Block=arabicmathematicalalphabeticsymbols}', "");
    Expect(1, 126719, '\p{Block=:\Aarabicmathematicalalphabeticsymbols\z:}', "");;
    Expect(0, 126720, '\p{Block=:\Aarabicmathematicalalphabeticsymbols\z:}', "");;
    Expect(1, 126719, '\p{Block=-arabic_Mathematical_Alphabetic_symbols}', "");
    Expect(0, 126719, '\p{^Block=-arabic_Mathematical_Alphabetic_symbols}', "");
    Expect(0, 126719, '\P{Block=-arabic_Mathematical_Alphabetic_symbols}', "");
    Expect(1, 126719, '\P{^Block=-arabic_Mathematical_Alphabetic_symbols}', "");
    Expect(0, 126720, '\p{Block=-arabic_Mathematical_Alphabetic_symbols}', "");
    Expect(1, 126720, '\p{^Block=-arabic_Mathematical_Alphabetic_symbols}', "");
    Expect(1, 126720, '\P{Block=-arabic_Mathematical_Alphabetic_symbols}', "");
    Expect(0, 126720, '\P{^Block=-arabic_Mathematical_Alphabetic_symbols}', "");
    Error('\p{Blk=-:=ARABIC_math}');
    Error('\P{Blk=-:=ARABIC_math}');
    Expect(1, 126719, '\p{Blk=:\AArabic_Math\z:}', "");;
    Expect(0, 126720, '\p{Blk=:\AArabic_Math\z:}', "");;
    Expect(1, 126719, '\p{Blk=arabicmath}', "");
    Expect(0, 126719, '\p{^Blk=arabicmath}', "");
    Expect(0, 126719, '\P{Blk=arabicmath}', "");
    Expect(1, 126719, '\P{^Blk=arabicmath}', "");
    Expect(0, 126720, '\p{Blk=arabicmath}', "");
    Expect(1, 126720, '\p{^Blk=arabicmath}', "");
    Expect(1, 126720, '\P{Blk=arabicmath}', "");
    Expect(0, 126720, '\P{^Blk=arabicmath}', "");
    Expect(1, 126719, '\p{Blk=:\Aarabicmath\z:}', "");;
    Expect(0, 126720, '\p{Blk=:\Aarabicmath\z:}', "");;
    Expect(1, 126719, '\p{Blk=__Arabic_math}', "");
    Expect(0, 126719, '\p{^Blk=__Arabic_math}', "");
    Expect(0, 126719, '\P{Blk=__Arabic_math}', "");
    Expect(1, 126719, '\P{^Blk=__Arabic_math}', "");
    Expect(0, 126720, '\p{Blk=__Arabic_math}', "");
    Expect(1, 126720, '\p{^Blk=__Arabic_math}', "");
    Expect(1, 126720, '\P{Blk=__Arabic_math}', "");
    Expect(0, 126720, '\P{^Blk=__Arabic_math}', "");
    Error('\p{Is_Block=/a/	 Arabic_Mathematical_Alphabetic_Symbols}');
    Error('\P{Is_Block=/a/	 Arabic_Mathematical_Alphabetic_Symbols}');
    Expect(1, 126719, '\p{Is_Block=arabicmathematicalalphabeticsymbols}', "");
    Expect(0, 126719, '\p{^Is_Block=arabicmathematicalalphabeticsymbols}', "");
    Expect(0, 126719, '\P{Is_Block=arabicmathematicalalphabeticsymbols}', "");
    Expect(1, 126719, '\P{^Is_Block=arabicmathematicalalphabeticsymbols}', "");
    Expect(0, 126720, '\p{Is_Block=arabicmathematicalalphabeticsymbols}', "");
    Expect(1, 126720, '\p{^Is_Block=arabicmathematicalalphabeticsymbols}', "");
    Expect(1, 126720, '\P{Is_Block=arabicmathematicalalphabeticsymbols}', "");
    Expect(0, 126720, '\P{^Is_Block=arabicmathematicalalphabeticsymbols}', "");
    Expect(1, 126719, '\p{Is_Block=-_Arabic_Mathematical_ALPHABETIC_symbols}', "");
    Expect(0, 126719, '\p{^Is_Block=-_Arabic_Mathematical_ALPHABETIC_symbols}', "");
    Expect(0, 126719, '\P{Is_Block=-_Arabic_Mathematical_ALPHABETIC_symbols}', "");
    Expect(1, 126719, '\P{^Is_Block=-_Arabic_Mathematical_ALPHABETIC_symbols}', "");
    Expect(0, 126720, '\p{Is_Block=-_Arabic_Mathematical_ALPHABETIC_symbols}', "");
    Expect(1, 126720, '\p{^Is_Block=-_Arabic_Mathematical_ALPHABETIC_symbols}', "");
    Expect(1, 126720, '\P{Is_Block=-_Arabic_Mathematical_ALPHABETIC_symbols}', "");
    Expect(0, 126720, '\P{^Is_Block=-_Arabic_Mathematical_ALPHABETIC_symbols}', "");
    Error('\p{Is_Blk=/a/	ARABIC_Math}');
    Error('\P{Is_Blk=/a/	ARABIC_Math}');
    Expect(1, 126719, '\p{Is_Blk=arabicmath}', "");
    Expect(0, 126719, '\p{^Is_Blk=arabicmath}', "");
    Expect(0, 126719, '\P{Is_Blk=arabicmath}', "");
    Expect(1, 126719, '\P{^Is_Blk=arabicmath}', "");
    Expect(0, 126720, '\p{Is_Blk=arabicmath}', "");
    Expect(1, 126720, '\p{^Is_Blk=arabicmath}', "");
    Expect(1, 126720, '\P{Is_Blk=arabicmath}', "");
    Expect(0, 126720, '\P{^Is_Blk=arabicmath}', "");
    Expect(1, 126719, '\p{Is_Blk:_	arabic_MATH}', "");
    Expect(0, 126719, '\p{^Is_Blk:_	arabic_MATH}', "");
    Expect(0, 126719, '\P{Is_Blk:_	arabic_MATH}', "");
    Expect(1, 126719, '\P{^Is_Blk:_	arabic_MATH}', "");
    Expect(0, 126720, '\p{Is_Blk:_	arabic_MATH}', "");
    Expect(1, 126720, '\p{^Is_Blk:_	arabic_MATH}', "");
    Expect(1, 126720, '\P{Is_Blk:_	arabic_MATH}', "");
    Expect(0, 126720, '\P{^Is_Blk:_	arabic_MATH}', "");
    Error('\p{Block=_/a/Arabic_PRESENTATION_FORMS_A}');
    Error('\P{Block=_/a/Arabic_PRESENTATION_FORMS_A}');
    Expect(1, 65023, '\p{Block=:\AArabic_Presentation_Forms_A\z:}', "");;
    Expect(0, 65024, '\p{Block=:\AArabic_Presentation_Forms_A\z:}', "");;
    Expect(1, 65023, '\p{Block=arabicpresentationformsa}', "");
    Expect(0, 65023, '\p{^Block=arabicpresentationformsa}', "");
    Expect(0, 65023, '\P{Block=arabicpresentationformsa}', "");
    Expect(1, 65023, '\P{^Block=arabicpresentationformsa}', "");
    Expect(0, 65024, '\p{Block=arabicpresentationformsa}', "");
    Expect(1, 65024, '\p{^Block=arabicpresentationformsa}', "");
    Expect(1, 65024, '\P{Block=arabicpresentationformsa}', "");
    Expect(0, 65024, '\P{^Block=arabicpresentationformsa}', "");
    Expect(1, 65023, '\p{Block=:\Aarabicpresentationformsa\z:}', "");;
    Expect(0, 65024, '\p{Block=:\Aarabicpresentationformsa\z:}', "");;
    Expect(1, 65023, '\p{Block=	 Arabic_Presentation_forms_A}', "");
    Expect(0, 65023, '\p{^Block=	 Arabic_Presentation_forms_A}', "");
    Expect(0, 65023, '\P{Block=	 Arabic_Presentation_forms_A}', "");
    Expect(1, 65023, '\P{^Block=	 Arabic_Presentation_forms_A}', "");
    Expect(0, 65024, '\p{Block=	 Arabic_Presentation_forms_A}', "");
    Expect(1, 65024, '\p{^Block=	 Arabic_Presentation_forms_A}', "");
    Expect(1, 65024, '\P{Block=	 Arabic_Presentation_forms_A}', "");
    Expect(0, 65024, '\P{^Block=	 Arabic_Presentation_forms_A}', "");
    Error('\p{Blk=_/a/ARABIC_PF_A}');
    Error('\P{Blk=_/a/ARABIC_PF_A}');
    Expect(1, 65023, '\p{Blk=:\AArabic_PF_A\z:}', "");;
    Expect(0, 65024, '\p{Blk=:\AArabic_PF_A\z:}', "");;
    Expect(1, 65023, '\p{Blk: arabicpfa}', "");
    Expect(0, 65023, '\p{^Blk: arabicpfa}', "");
    Expect(0, 65023, '\P{Blk: arabicpfa}', "");
    Expect(1, 65023, '\P{^Blk: arabicpfa}', "");
    Expect(0, 65024, '\p{Blk: arabicpfa}', "");
    Expect(1, 65024, '\p{^Blk: arabicpfa}', "");
    Expect(1, 65024, '\P{Blk: arabicpfa}', "");
    Expect(0, 65024, '\P{^Blk: arabicpfa}', "");
    Expect(1, 65023, '\p{Blk=:\Aarabicpfa\z:}', "");;
    Expect(0, 65024, '\p{Blk=:\Aarabicpfa\z:}', "");;
    Expect(1, 65023, '\p{Blk=__Arabic_PF_a}', "");
    Expect(0, 65023, '\p{^Blk=__Arabic_PF_a}', "");
    Expect(0, 65023, '\P{Blk=__Arabic_PF_a}', "");
    Expect(1, 65023, '\P{^Blk=__Arabic_PF_a}', "");
    Expect(0, 65024, '\p{Blk=__Arabic_PF_a}', "");
    Expect(1, 65024, '\p{^Blk=__Arabic_PF_a}', "");
    Expect(1, 65024, '\P{Blk=__Arabic_PF_a}', "");
    Expect(0, 65024, '\P{^Blk=__Arabic_PF_a}', "");
    Error('\p{Is_Block=- ARABIC_presentation_FORMS_A/a/}');
    Error('\P{Is_Block=- ARABIC_presentation_FORMS_A/a/}');
    Expect(1, 65023, '\p{Is_Block=arabicpresentationformsa}', "");
    Expect(0, 65023, '\p{^Is_Block=arabicpresentationformsa}', "");
    Expect(0, 65023, '\P{Is_Block=arabicpresentationformsa}', "");
    Expect(1, 65023, '\P{^Is_Block=arabicpresentationformsa}', "");
    Expect(0, 65024, '\p{Is_Block=arabicpresentationformsa}', "");
    Expect(1, 65024, '\p{^Is_Block=arabicpresentationformsa}', "");
    Expect(1, 65024, '\P{Is_Block=arabicpresentationformsa}', "");
    Expect(0, 65024, '\P{^Is_Block=arabicpresentationformsa}', "");
    Expect(1, 65023, '\p{Is_Block= _Arabic_presentation_Forms_A}', "");
    Expect(0, 65023, '\p{^Is_Block= _Arabic_presentation_Forms_A}', "");
    Expect(0, 65023, '\P{Is_Block= _Arabic_presentation_Forms_A}', "");
    Expect(1, 65023, '\P{^Is_Block= _Arabic_presentation_Forms_A}', "");
    Expect(0, 65024, '\p{Is_Block= _Arabic_presentation_Forms_A}', "");
    Expect(1, 65024, '\p{^Is_Block= _Arabic_presentation_Forms_A}', "");
    Expect(1, 65024, '\P{Is_Block= _Arabic_presentation_Forms_A}', "");
    Expect(0, 65024, '\P{^Is_Block= _Arabic_presentation_Forms_A}', "");
    Error('\p{Is_Blk=-arabic_PF_A/a/}');
    Error('\P{Is_Blk=-arabic_PF_A/a/}');
    Expect(1, 65023, '\p{Is_Blk=arabicpfa}', "");
    Expect(0, 65023, '\p{^Is_Blk=arabicpfa}', "");
    Expect(0, 65023, '\P{Is_Blk=arabicpfa}', "");
    Expect(1, 65023, '\P{^Is_Blk=arabicpfa}', "");
    Expect(0, 65024, '\p{Is_Blk=arabicpfa}', "");
    Expect(1, 65024, '\p{^Is_Blk=arabicpfa}', "");
    Expect(1, 65024, '\P{Is_Blk=arabicpfa}', "");
    Expect(0, 65024, '\P{^Is_Blk=arabicpfa}', "");
    Expect(1, 65023, '\p{Is_Blk=_ Arabic_pf_A}', "");
    Expect(0, 65023, '\p{^Is_Blk=_ Arabic_pf_A}', "");
    Expect(0, 65023, '\P{Is_Blk=_ Arabic_pf_A}', "");
    Expect(1, 65023, '\P{^Is_Blk=_ Arabic_pf_A}', "");
    Expect(0, 65024, '\p{Is_Blk=_ Arabic_pf_A}', "");
    Expect(1, 65024, '\p{^Is_Blk=_ Arabic_pf_A}', "");
    Expect(1, 65024, '\P{Is_Blk=_ Arabic_pf_A}', "");
    Expect(0, 65024, '\P{^Is_Blk=_ Arabic_pf_A}', "");
    Error('\p{Block=_	arabic_Presentation_Forms_B/a/}');
    Error('\P{Block=_	arabic_Presentation_Forms_B/a/}');
    Expect(1, 65279, '\p{Block=:\AArabic_Presentation_Forms_B\z:}', "");;
    Expect(0, 65280, '\p{Block=:\AArabic_Presentation_Forms_B\z:}', "");;
    Expect(1, 65279, '\p{Block=arabicpresentationformsb}', "");
    Expect(0, 65279, '\p{^Block=arabicpresentationformsb}', "");
    Expect(0, 65279, '\P{Block=arabicpresentationformsb}', "");
    Expect(1, 65279, '\P{^Block=arabicpresentationformsb}', "");
    Expect(0, 65280, '\p{Block=arabicpresentationformsb}', "");
    Expect(1, 65280, '\p{^Block=arabicpresentationformsb}', "");
    Expect(1, 65280, '\P{Block=arabicpresentationformsb}', "");
    Expect(0, 65280, '\P{^Block=arabicpresentationformsb}', "");
    Expect(1, 65279, '\p{Block=:\Aarabicpresentationformsb\z:}', "");;
    Expect(0, 65280, '\p{Block=:\Aarabicpresentationformsb\z:}', "");;
    Expect(1, 65279, '\p{Block:   _Arabic_presentation_Forms_B}', "");
    Expect(0, 65279, '\p{^Block:   _Arabic_presentation_Forms_B}', "");
    Expect(0, 65279, '\P{Block:   _Arabic_presentation_Forms_B}', "");
    Expect(1, 65279, '\P{^Block:   _Arabic_presentation_Forms_B}', "");
    Expect(0, 65280, '\p{Block:   _Arabic_presentation_Forms_B}', "");
    Expect(1, 65280, '\p{^Block:   _Arabic_presentation_Forms_B}', "");
    Expect(1, 65280, '\P{Block:   _Arabic_presentation_Forms_B}', "");
    Expect(0, 65280, '\P{^Block:   _Arabic_presentation_Forms_B}', "");
    Error('\p{Blk=/a/Arabic_PF_B}');
    Error('\P{Blk=/a/Arabic_PF_B}');
    Expect(1, 65279, '\p{Blk=:\AArabic_PF_B\z:}', "");;
    Expect(0, 65280, '\p{Blk=:\AArabic_PF_B\z:}', "");;
    Expect(1, 65279, '\p{Blk=arabicpfb}', "");
    Expect(0, 65279, '\p{^Blk=arabicpfb}', "");
    Expect(0, 65279, '\P{Blk=arabicpfb}', "");
    Expect(1, 65279, '\P{^Blk=arabicpfb}', "");
    Expect(0, 65280, '\p{Blk=arabicpfb}', "");
    Expect(1, 65280, '\p{^Blk=arabicpfb}', "");
    Expect(1, 65280, '\P{Blk=arabicpfb}', "");
    Expect(0, 65280, '\P{^Blk=arabicpfb}', "");
    Expect(1, 65279, '\p{Blk=:\Aarabicpfb\z:}', "");;
    Expect(0, 65280, '\p{Blk=:\Aarabicpfb\z:}', "");;
    Expect(1, 65279, '\p{Blk=--ARABIC_pf_B}', "");
    Expect(0, 65279, '\p{^Blk=--ARABIC_pf_B}', "");
    Expect(0, 65279, '\P{Blk=--ARABIC_pf_B}', "");
    Expect(1, 65279, '\P{^Blk=--ARABIC_pf_B}', "");
    Expect(0, 65280, '\p{Blk=--ARABIC_pf_B}', "");
    Expect(1, 65280, '\p{^Blk=--ARABIC_pf_B}', "");
    Expect(1, 65280, '\P{Blk=--ARABIC_pf_B}', "");
    Expect(0, 65280, '\P{^Blk=--ARABIC_pf_B}', "");
    Error('\p{Is_Block=-Arabic_Presentation_Forms_B:=}');
    Error('\P{Is_Block=-Arabic_Presentation_Forms_B:=}');
    Expect(1, 65279, '\p{Is_Block=arabicpresentationformsb}', "");
    Expect(0, 65279, '\p{^Is_Block=arabicpresentationformsb}', "");
    Expect(0, 65279, '\P{Is_Block=arabicpresentationformsb}', "");
    Expect(1, 65279, '\P{^Is_Block=arabicpresentationformsb}', "");
    Expect(0, 65280, '\p{Is_Block=arabicpresentationformsb}', "");
    Expect(1, 65280, '\p{^Is_Block=arabicpresentationformsb}', "");
    Expect(1, 65280, '\P{Is_Block=arabicpresentationformsb}', "");
    Expect(0, 65280, '\P{^Is_Block=arabicpresentationformsb}', "");
    Expect(1, 65279, '\p{Is_Block=--Arabic_PRESENTATION_FORMS_b}', "");
    Expect(0, 65279, '\p{^Is_Block=--Arabic_PRESENTATION_FORMS_b}', "");
    Expect(0, 65279, '\P{Is_Block=--Arabic_PRESENTATION_FORMS_b}', "");
    Expect(1, 65279, '\P{^Is_Block=--Arabic_PRESENTATION_FORMS_b}', "");
    Expect(0, 65280, '\p{Is_Block=--Arabic_PRESENTATION_FORMS_b}', "");
    Expect(1, 65280, '\p{^Is_Block=--Arabic_PRESENTATION_FORMS_b}', "");
    Expect(1, 65280, '\P{Is_Block=--Arabic_PRESENTATION_FORMS_b}', "");
    Expect(0, 65280, '\P{^Is_Block=--Arabic_PRESENTATION_FORMS_b}', "");
    Error('\p{Is_Blk=/a/-arabic_pf_b}');
    Error('\P{Is_Blk=/a/-arabic_pf_b}');
    Expect(1, 65279, '\p{Is_Blk=arabicpfb}', "");
    Expect(0, 65279, '\p{^Is_Blk=arabicpfb}', "");
    Expect(0, 65279, '\P{Is_Blk=arabicpfb}', "");
    Expect(1, 65279, '\P{^Is_Blk=arabicpfb}', "");
    Expect(0, 65280, '\p{Is_Blk=arabicpfb}', "");
    Expect(1, 65280, '\p{^Is_Blk=arabicpfb}', "");
    Expect(1, 65280, '\P{Is_Blk=arabicpfb}', "");
    Expect(0, 65280, '\P{^Is_Blk=arabicpfb}', "");
    Expect(1, 65279, '\p{Is_Blk=-_arabic_PF_B}', "");
    Expect(0, 65279, '\p{^Is_Blk=-_arabic_PF_B}', "");
    Expect(0, 65279, '\P{Is_Blk=-_arabic_PF_B}', "");
    Expect(1, 65279, '\P{^Is_Blk=-_arabic_PF_B}', "");
    Expect(0, 65280, '\p{Is_Blk=-_arabic_PF_B}', "");
    Expect(1, 65280, '\p{^Is_Blk=-_arabic_PF_B}', "");
    Expect(1, 65280, '\P{Is_Blk=-_arabic_PF_B}', "");
    Expect(0, 65280, '\P{^Is_Blk=-_arabic_PF_B}', "");
    Error('\p{Block=	:=arabic_Supplement}');
    Error('\P{Block=	:=arabic_Supplement}');
    Expect(1, 1919, '\p{Block=:\AArabic_Supplement\z:}', "");;
    Expect(0, 1920, '\p{Block=:\AArabic_Supplement\z:}', "");;
    Expect(1, 1919, '\p{Block=arabicsupplement}', "");
    Expect(0, 1919, '\p{^Block=arabicsupplement}', "");
    Expect(0, 1919, '\P{Block=arabicsupplement}', "");
    Expect(1, 1919, '\P{^Block=arabicsupplement}', "");
    Expect(0, 1920, '\p{Block=arabicsupplement}', "");
    Expect(1, 1920, '\p{^Block=arabicsupplement}', "");
    Expect(1, 1920, '\P{Block=arabicsupplement}', "");
    Expect(0, 1920, '\P{^Block=arabicsupplement}', "");
    Expect(1, 1919, '\p{Block=:\Aarabicsupplement\z:}', "");;
    Expect(0, 1920, '\p{Block=:\Aarabicsupplement\z:}', "");;
    Expect(1, 1919, '\p{Block=_	arabic_supplement}', "");
    Expect(0, 1919, '\p{^Block=_	arabic_supplement}', "");
    Expect(0, 1919, '\P{Block=_	arabic_supplement}', "");
    Expect(1, 1919, '\P{^Block=_	arabic_supplement}', "");
    Expect(0, 1920, '\p{Block=_	arabic_supplement}', "");
    Expect(1, 1920, '\p{^Block=_	arabic_supplement}', "");
    Expect(1, 1920, '\P{Block=_	arabic_supplement}', "");
    Expect(0, 1920, '\P{^Block=_	arabic_supplement}', "");
    Error('\p{Blk=:=_Arabic_Sup}');
    Error('\P{Blk=:=_Arabic_Sup}');
    Expect(1, 1919, '\p{Blk=:\AArabic_Sup\z:}', "");;
    Expect(0, 1920, '\p{Blk=:\AArabic_Sup\z:}', "");;
    Expect(1, 1919, '\p{Blk=arabicsup}', "");
    Expect(0, 1919, '\p{^Blk=arabicsup}', "");
    Expect(0, 1919, '\P{Blk=arabicsup}', "");
    Expect(1, 1919, '\P{^Blk=arabicsup}', "");
    Expect(0, 1920, '\p{Blk=arabicsup}', "");
    Expect(1, 1920, '\p{^Blk=arabicsup}', "");
    Expect(1, 1920, '\P{Blk=arabicsup}', "");
    Expect(0, 1920, '\P{^Blk=arabicsup}', "");
    Expect(1, 1919, '\p{Blk=:\Aarabicsup\z:}', "");;
    Expect(0, 1920, '\p{Blk=:\Aarabicsup\z:}', "");;
    Expect(1, 1919, '\p{Blk=	-Arabic_sup}', "");
    Expect(0, 1919, '\p{^Blk=	-Arabic_sup}', "");
    Expect(0, 1919, '\P{Blk=	-Arabic_sup}', "");
    Expect(1, 1919, '\P{^Blk=	-Arabic_sup}', "");
    Expect(0, 1920, '\p{Blk=	-Arabic_sup}', "");
    Expect(1, 1920, '\p{^Blk=	-Arabic_sup}', "");
    Expect(1, 1920, '\P{Blk=	-Arabic_sup}', "");
    Expect(0, 1920, '\P{^Blk=	-Arabic_sup}', "");
    Error('\p{Is_Block=-:=Arabic_SUPPLEMENT}');
    Error('\P{Is_Block=-:=Arabic_SUPPLEMENT}');
    Expect(1, 1919, '\p{Is_Block=arabicsupplement}', "");
    Expect(0, 1919, '\p{^Is_Block=arabicsupplement}', "");
    Expect(0, 1919, '\P{Is_Block=arabicsupplement}', "");
    Expect(1, 1919, '\P{^Is_Block=arabicsupplement}', "");
    Expect(0, 1920, '\p{Is_Block=arabicsupplement}', "");
    Expect(1, 1920, '\p{^Is_Block=arabicsupplement}', "");
    Expect(1, 1920, '\P{Is_Block=arabicsupplement}', "");
    Expect(0, 1920, '\P{^Is_Block=arabicsupplement}', "");
    Expect(1, 1919, '\p{Is_Block=_ ARABIC_SUPPLEMENT}', "");
    Expect(0, 1919, '\p{^Is_Block=_ ARABIC_SUPPLEMENT}', "");
    Expect(0, 1919, '\P{Is_Block=_ ARABIC_SUPPLEMENT}', "");
    Expect(1, 1919, '\P{^Is_Block=_ ARABIC_SUPPLEMENT}', "");
    Expect(0, 1920, '\p{Is_Block=_ ARABIC_SUPPLEMENT}', "");
    Expect(1, 1920, '\p{^Is_Block=_ ARABIC_SUPPLEMENT}', "");
    Expect(1, 1920, '\P{Is_Block=_ ARABIC_SUPPLEMENT}', "");
    Expect(0, 1920, '\P{^Is_Block=_ ARABIC_SUPPLEMENT}', "");
    Error('\p{Is_Blk=:=	 arabic_SUP}');
    Error('\P{Is_Blk=:=	 arabic_SUP}');
    Expect(1, 1919, '\p{Is_Blk=arabicsup}', "");
    Expect(0, 1919, '\p{^Is_Blk=arabicsup}', "");
    Expect(0, 1919, '\P{Is_Blk=arabicsup}', "");
    Expect(1, 1919, '\P{^Is_Blk=arabicsup}', "");
    Expect(0, 1920, '\p{Is_Blk=arabicsup}', "");
    Expect(1, 1920, '\p{^Is_Blk=arabicsup}', "");
    Expect(1, 1920, '\P{Is_Blk=arabicsup}', "");
    Expect(0, 1920, '\P{^Is_Blk=arabicsup}', "");
    Expect(1, 1919, '\p{Is_Blk=		Arabic_sup}', "");
    Expect(0, 1919, '\p{^Is_Blk=		Arabic_sup}', "");
    Expect(0, 1919, '\P{Is_Blk=		Arabic_sup}', "");
    Expect(1, 1919, '\P{^Is_Blk=		Arabic_sup}', "");
    Expect(0, 1920, '\p{Is_Blk=		Arabic_sup}', "");
    Expect(1, 1920, '\p{^Is_Blk=		Arabic_sup}', "");
    Expect(1, 1920, '\P{Is_Blk=		Arabic_sup}', "");
    Expect(0, 1920, '\P{^Is_Blk=		Arabic_sup}', "");
    Error('\p{Block= ARMENIAN:=}');
    Error('\P{Block= ARMENIAN:=}');
    Expect(1, 1423, '\p{Block=:\AArmenian\z:}', "");;
    Expect(0, 1424, '\p{Block=:\AArmenian\z:}', "");;
    Expect(1, 1423, '\p{Block=armenian}', "");
    Expect(0, 1423, '\p{^Block=armenian}', "");
    Expect(0, 1423, '\P{Block=armenian}', "");
    Expect(1, 1423, '\P{^Block=armenian}', "");
    Expect(0, 1424, '\p{Block=armenian}', "");
    Expect(1, 1424, '\p{^Block=armenian}', "");
    Expect(1, 1424, '\P{Block=armenian}', "");
    Expect(0, 1424, '\P{^Block=armenian}', "");
    Expect(1, 1423, '\p{Block=:\Aarmenian\z:}', "");;
    Expect(0, 1424, '\p{Block=:\Aarmenian\z:}', "");;
    Expect(1, 1423, '\p{Block=		Armenian}', "");
    Expect(0, 1423, '\p{^Block=		Armenian}', "");
    Expect(0, 1423, '\P{Block=		Armenian}', "");
    Expect(1, 1423, '\P{^Block=		Armenian}', "");
    Expect(0, 1424, '\p{Block=		Armenian}', "");
    Expect(1, 1424, '\p{^Block=		Armenian}', "");
    Expect(1, 1424, '\P{Block=		Armenian}', "");
    Expect(0, 1424, '\P{^Block=		Armenian}', "");
    Error('\p{Blk=/a/ ARMENIAN}');
    Error('\P{Blk=/a/ ARMENIAN}');
    Expect(1, 1423, '\p{Blk=:\AArmenian\z:}', "");;
    Expect(0, 1424, '\p{Blk=:\AArmenian\z:}', "");;
    Expect(1, 1423, '\p{Blk=armenian}', "");
    Expect(0, 1423, '\p{^Blk=armenian}', "");
    Expect(0, 1423, '\P{Blk=armenian}', "");
    Expect(1, 1423, '\P{^Blk=armenian}', "");
    Expect(0, 1424, '\p{Blk=armenian}', "");
    Expect(1, 1424, '\p{^Blk=armenian}', "");
    Expect(1, 1424, '\P{Blk=armenian}', "");
    Expect(0, 1424, '\P{^Blk=armenian}', "");
    Expect(1, 1423, '\p{Blk=:\Aarmenian\z:}', "");;
    Expect(0, 1424, '\p{Blk=:\Aarmenian\z:}', "");;
    Expect(1, 1423, '\p{Blk=- Armenian}', "");
    Expect(0, 1423, '\p{^Blk=- Armenian}', "");
    Expect(0, 1423, '\P{Blk=- Armenian}', "");
    Expect(1, 1423, '\P{^Blk=- Armenian}', "");
    Expect(0, 1424, '\p{Blk=- Armenian}', "");
    Expect(1, 1424, '\p{^Blk=- Armenian}', "");
    Expect(1, 1424, '\P{Blk=- Armenian}', "");
    Expect(0, 1424, '\P{^Blk=- Armenian}', "");
    Error('\p{Is_Block=/a/- Armenian}');
    Error('\P{Is_Block=/a/- Armenian}');
    Expect(1, 1423, '\p{Is_Block=armenian}', "");
    Expect(0, 1423, '\p{^Is_Block=armenian}', "");
    Expect(0, 1423, '\P{Is_Block=armenian}', "");
    Expect(1, 1423, '\P{^Is_Block=armenian}', "");
    Expect(0, 1424, '\p{Is_Block=armenian}', "");
    Expect(1, 1424, '\p{^Is_Block=armenian}', "");
    Expect(1, 1424, '\P{Is_Block=armenian}', "");
    Expect(0, 1424, '\P{^Is_Block=armenian}', "");
    Expect(1, 1423, '\p{Is_Block=_ARMENIAN}', "");
    Expect(0, 1423, '\p{^Is_Block=_ARMENIAN}', "");
    Expect(0, 1423, '\P{Is_Block=_ARMENIAN}', "");
    Expect(1, 1423, '\P{^Is_Block=_ARMENIAN}', "");
    Expect(0, 1424, '\p{Is_Block=_ARMENIAN}', "");
    Expect(1, 1424, '\p{^Is_Block=_ARMENIAN}', "");
    Expect(1, 1424, '\P{Is_Block=_ARMENIAN}', "");
    Expect(0, 1424, '\P{^Is_Block=_ARMENIAN}', "");
    Error('\p{Is_Blk=:=	 Armenian}');
    Error('\P{Is_Blk=:=	 Armenian}');
    Expect(1, 1423, '\p{Is_Blk=armenian}', "");
    Expect(0, 1423, '\p{^Is_Blk=armenian}', "");
    Expect(0, 1423, '\P{Is_Blk=armenian}', "");
    Expect(1, 1423, '\P{^Is_Blk=armenian}', "");
    Expect(0, 1424, '\p{Is_Blk=armenian}', "");
    Expect(1, 1424, '\p{^Is_Blk=armenian}', "");
    Expect(1, 1424, '\P{Is_Blk=armenian}', "");
    Expect(0, 1424, '\P{^Is_Blk=armenian}', "");
    Expect(1, 1423, '\p{Is_Blk= -Armenian}', "");
    Expect(0, 1423, '\p{^Is_Blk= -Armenian}', "");
    Expect(0, 1423, '\P{Is_Blk= -Armenian}', "");
    Expect(1, 1423, '\P{^Is_Blk= -Armenian}', "");
    Expect(0, 1424, '\p{Is_Blk= -Armenian}', "");
    Expect(1, 1424, '\p{^Is_Blk= -Armenian}', "");
    Expect(1, 1424, '\P{Is_Blk= -Armenian}', "");
    Expect(0, 1424, '\P{^Is_Blk= -Armenian}', "");
    Error('\p{Block= -arrows:=}');
    Error('\P{Block= -arrows:=}');
    Expect(1, 8703, '\p{Block=:\AArrows\z:}', "");;
    Expect(0, 8704, '\p{Block=:\AArrows\z:}', "");;
    Expect(1, 8703, '\p{Block=arrows}', "");
    Expect(0, 8703, '\p{^Block=arrows}', "");
    Expect(0, 8703, '\P{Block=arrows}', "");
    Expect(1, 8703, '\P{^Block=arrows}', "");
    Expect(0, 8704, '\p{Block=arrows}', "");
    Expect(1, 8704, '\p{^Block=arrows}', "");
    Expect(1, 8704, '\P{Block=arrows}', "");
    Expect(0, 8704, '\P{^Block=arrows}', "");
    Expect(1, 8703, '\p{Block=:\Aarrows\z:}', "");;
    Expect(0, 8704, '\p{Block=:\Aarrows\z:}', "");;
    Expect(1, 8703, '\p{Block=_Arrows}', "");
    Expect(0, 8703, '\p{^Block=_Arrows}', "");
    Expect(0, 8703, '\P{Block=_Arrows}', "");
    Expect(1, 8703, '\P{^Block=_Arrows}', "");
    Expect(0, 8704, '\p{Block=_Arrows}', "");
    Expect(1, 8704, '\p{^Block=_Arrows}', "");
    Expect(1, 8704, '\P{Block=_Arrows}', "");
    Expect(0, 8704, '\P{^Block=_Arrows}', "");
    Error('\p{Blk=/a/	Arrows}');
    Error('\P{Blk=/a/	Arrows}');
    Expect(1, 8703, '\p{Blk=:\AArrows\z:}', "");;
    Expect(0, 8704, '\p{Blk=:\AArrows\z:}', "");;
    Expect(1, 8703, '\p{Blk=arrows}', "");
    Expect(0, 8703, '\p{^Blk=arrows}', "");
    Expect(0, 8703, '\P{Blk=arrows}', "");
    Expect(1, 8703, '\P{^Blk=arrows}', "");
    Expect(0, 8704, '\p{Blk=arrows}', "");
    Expect(1, 8704, '\p{^Blk=arrows}', "");
    Expect(1, 8704, '\P{Blk=arrows}', "");
    Expect(0, 8704, '\P{^Blk=arrows}', "");
    Expect(1, 8703, '\p{Blk=:\Aarrows\z:}', "");;
    Expect(0, 8704, '\p{Blk=:\Aarrows\z:}', "");;
    Expect(1, 8703, '\p{Blk=		Arrows}', "");
    Expect(0, 8703, '\p{^Blk=		Arrows}', "");
    Expect(0, 8703, '\P{Blk=		Arrows}', "");
    Expect(1, 8703, '\P{^Blk=		Arrows}', "");
    Expect(0, 8704, '\p{Blk=		Arrows}', "");
    Expect(1, 8704, '\p{^Blk=		Arrows}', "");
    Expect(1, 8704, '\P{Blk=		Arrows}', "");
    Expect(0, 8704, '\P{^Blk=		Arrows}', "");
    Error('\p{Is_Block=	ARROWS:=}');
    Error('\P{Is_Block=	ARROWS:=}');
    Expect(1, 8703, '\p{Is_Block=arrows}', "");
    Expect(0, 8703, '\p{^Is_Block=arrows}', "");
    Expect(0, 8703, '\P{Is_Block=arrows}', "");
    Expect(1, 8703, '\P{^Is_Block=arrows}', "");
    Expect(0, 8704, '\p{Is_Block=arrows}', "");
    Expect(1, 8704, '\p{^Is_Block=arrows}', "");
    Expect(1, 8704, '\P{Is_Block=arrows}', "");
    Expect(0, 8704, '\P{^Is_Block=arrows}', "");
    Expect(1, 8703, '\p{Is_Block= -Arrows}', "");
    Expect(0, 8703, '\p{^Is_Block= -Arrows}', "");
    Expect(0, 8703, '\P{Is_Block= -Arrows}', "");
    Expect(1, 8703, '\P{^Is_Block= -Arrows}', "");
    Expect(0, 8704, '\p{Is_Block= -Arrows}', "");
    Expect(1, 8704, '\p{^Is_Block= -Arrows}', "");
    Expect(1, 8704, '\P{Is_Block= -Arrows}', "");
    Expect(0, 8704, '\P{^Is_Block= -Arrows}', "");
    Error('\p{Is_Blk=:=_ Arrows}');
    Error('\P{Is_Blk=:=_ Arrows}');
    Expect(1, 8703, '\p{Is_Blk=arrows}', "");
    Expect(0, 8703, '\p{^Is_Blk=arrows}', "");
    Expect(0, 8703, '\P{Is_Blk=arrows}', "");
    Expect(1, 8703, '\P{^Is_Blk=arrows}', "");
    Expect(0, 8704, '\p{Is_Blk=arrows}', "");
    Expect(1, 8704, '\p{^Is_Blk=arrows}', "");
    Expect(1, 8704, '\P{Is_Blk=arrows}', "");
    Expect(0, 8704, '\P{^Is_Blk=arrows}', "");
    Expect(1, 8703, '\p{Is_Blk=-Arrows}', "");
    Expect(0, 8703, '\p{^Is_Blk=-Arrows}', "");
    Expect(0, 8703, '\P{Is_Blk=-Arrows}', "");
    Expect(1, 8703, '\P{^Is_Blk=-Arrows}', "");
    Expect(0, 8704, '\p{Is_Blk=-Arrows}', "");
    Expect(1, 8704, '\p{^Is_Blk=-Arrows}', "");
    Expect(1, 8704, '\P{Is_Blk=-Arrows}', "");
    Expect(0, 8704, '\P{^Is_Blk=-Arrows}', "");
    Error('\p{Block:	__BASIC_LATIN:=}');
    Error('\P{Block:	__BASIC_LATIN:=}');
    Expect(1, 127, '\p{Block=:\ABasic_Latin\z:}', "");;
    Expect(0, 128, '\p{Block=:\ABasic_Latin\z:}', "");;
    Expect(1, 127, '\p{Block=basiclatin}', "");
    Expect(0, 127, '\p{^Block=basiclatin}', "");
    Expect(0, 127, '\P{Block=basiclatin}', "");
    Expect(1, 127, '\P{^Block=basiclatin}', "");
    Expect(0, 128, '\p{Block=basiclatin}', "");
    Expect(1, 128, '\p{^Block=basiclatin}', "");
    Expect(1, 128, '\P{Block=basiclatin}', "");
    Expect(0, 128, '\P{^Block=basiclatin}', "");
    Expect(1, 127, '\p{Block=:\Abasiclatin\z:}', "");;
    Expect(0, 128, '\p{Block=:\Abasiclatin\z:}', "");;
    Expect(1, 127, '\p{Block:   __Basic_Latin}', "");
    Expect(0, 127, '\p{^Block:   __Basic_Latin}', "");
    Expect(0, 127, '\P{Block:   __Basic_Latin}', "");
    Expect(1, 127, '\P{^Block:   __Basic_Latin}', "");
    Expect(0, 128, '\p{Block:   __Basic_Latin}', "");
    Expect(1, 128, '\p{^Block:   __Basic_Latin}', "");
    Expect(1, 128, '\P{Block:   __Basic_Latin}', "");
    Expect(0, 128, '\P{^Block:   __Basic_Latin}', "");
    Error('\p{Blk= /a/ascii}');
    Error('\P{Blk= /a/ascii}');
    Expect(1, 127, '\p{Blk=:\AASCII\z:}', "");;
    Expect(0, 128, '\p{Blk=:\AASCII\z:}', "");;
    Expect(1, 127, '\p{Blk=ascii}', "");
    Expect(0, 127, '\p{^Blk=ascii}', "");
    Expect(0, 127, '\P{Blk=ascii}', "");
    Expect(1, 127, '\P{^Blk=ascii}', "");
    Expect(0, 128, '\p{Blk=ascii}', "");
    Expect(1, 128, '\p{^Blk=ascii}', "");
    Expect(1, 128, '\P{Blk=ascii}', "");
    Expect(0, 128, '\P{^Blk=ascii}', "");
    Expect(1, 127, '\p{Blk=:\Aascii\z:}', "");;
    Expect(0, 128, '\p{Blk=:\Aascii\z:}', "");;
    Expect(1, 127, '\p{Blk=	 ascii}', "");
    Expect(0, 127, '\p{^Blk=	 ascii}', "");
    Expect(0, 127, '\P{Blk=	 ascii}', "");
    Expect(1, 127, '\P{^Blk=	 ascii}', "");
    Expect(0, 128, '\p{Blk=	 ascii}', "");
    Expect(1, 128, '\p{^Blk=	 ascii}', "");
    Expect(1, 128, '\P{Blk=	 ascii}', "");
    Expect(0, 128, '\P{^Blk=	 ascii}', "");
    Error('\p{Is_Block=/a/-Basic_Latin}');
    Error('\P{Is_Block=/a/-Basic_Latin}');
    Expect(1, 127, '\p{Is_Block=basiclatin}', "");
    Expect(0, 127, '\p{^Is_Block=basiclatin}', "");
    Expect(0, 127, '\P{Is_Block=basiclatin}', "");
    Expect(1, 127, '\P{^Is_Block=basiclatin}', "");
    Expect(0, 128, '\p{Is_Block=basiclatin}', "");
    Expect(1, 128, '\p{^Is_Block=basiclatin}', "");
    Expect(1, 128, '\P{Is_Block=basiclatin}', "");
    Expect(0, 128, '\P{^Is_Block=basiclatin}', "");
    Expect(1, 127, '\p{Is_Block=-	Basic_LATIN}', "");
    Expect(0, 127, '\p{^Is_Block=-	Basic_LATIN}', "");
    Expect(0, 127, '\P{Is_Block=-	Basic_LATIN}', "");
    Expect(1, 127, '\P{^Is_Block=-	Basic_LATIN}', "");
    Expect(0, 128, '\p{Is_Block=-	Basic_LATIN}', "");
    Expect(1, 128, '\p{^Is_Block=-	Basic_LATIN}', "");
    Expect(1, 128, '\P{Is_Block=-	Basic_LATIN}', "");
    Expect(0, 128, '\P{^Is_Block=-	Basic_LATIN}', "");
    Error('\p{Is_Blk=/a/_	ASCII}');
    Error('\P{Is_Blk=/a/_	ASCII}');
    Expect(1, 127, '\p{Is_Blk=ascii}', "");
    Expect(0, 127, '\p{^Is_Blk=ascii}', "");
    Expect(0, 127, '\P{Is_Blk=ascii}', "");
    Expect(1, 127, '\P{^Is_Blk=ascii}', "");
    Expect(0, 128, '\p{Is_Blk=ascii}', "");
    Expect(1, 128, '\p{^Is_Blk=ascii}', "");
    Expect(1, 128, '\P{Is_Blk=ascii}', "");
    Expect(0, 128, '\P{^Is_Blk=ascii}', "");
    Expect(1, 127, '\p{Is_Blk= -ASCII}', "");
    Expect(0, 127, '\p{^Is_Blk= -ASCII}', "");
    Expect(0, 127, '\P{Is_Blk= -ASCII}', "");
    Expect(1, 127, '\P{^Is_Blk= -ASCII}', "");
    Expect(0, 128, '\p{Is_Blk= -ASCII}', "");
    Expect(1, 128, '\p{^Is_Blk= -ASCII}', "");
    Expect(1, 128, '\P{Is_Blk= -ASCII}', "");
    Expect(0, 128, '\P{^Is_Blk= -ASCII}', "");
    Error('\p{Block=:=__Avestan}');
    Error('\P{Block=:=__Avestan}');
    Expect(1, 68415, '\p{Block=:\AAvestan\z:}', "");;
    Expect(0, 68416, '\p{Block=:\AAvestan\z:}', "");;
    Expect(1, 68415, '\p{Block=avestan}', "");
    Expect(0, 68415, '\p{^Block=avestan}', "");
    Expect(0, 68415, '\P{Block=avestan}', "");
    Expect(1, 68415, '\P{^Block=avestan}', "");
    Expect(0, 68416, '\p{Block=avestan}', "");
    Expect(1, 68416, '\p{^Block=avestan}', "");
    Expect(1, 68416, '\P{Block=avestan}', "");
    Expect(0, 68416, '\P{^Block=avestan}', "");
    Expect(1, 68415, '\p{Block=:\Aavestan\z:}', "");;
    Expect(0, 68416, '\p{Block=:\Aavestan\z:}', "");;
    Expect(1, 68415, '\p{Block=	_Avestan}', "");
    Expect(0, 68415, '\p{^Block=	_Avestan}', "");
    Expect(0, 68415, '\P{Block=	_Avestan}', "");
    Expect(1, 68415, '\P{^Block=	_Avestan}', "");
    Expect(0, 68416, '\p{Block=	_Avestan}', "");
    Expect(1, 68416, '\p{^Block=	_Avestan}', "");
    Expect(1, 68416, '\P{Block=	_Avestan}', "");
    Expect(0, 68416, '\P{^Block=	_Avestan}', "");
    Error('\p{Blk=	_Avestan/a/}');
    Error('\P{Blk=	_Avestan/a/}');
    Expect(1, 68415, '\p{Blk=:\AAvestan\z:}', "");;
    Expect(0, 68416, '\p{Blk=:\AAvestan\z:}', "");;
    Expect(1, 68415, '\p{Blk=avestan}', "");
    Expect(0, 68415, '\p{^Blk=avestan}', "");
    Expect(0, 68415, '\P{Blk=avestan}', "");
    Expect(1, 68415, '\P{^Blk=avestan}', "");
    Expect(0, 68416, '\p{Blk=avestan}', "");
    Expect(1, 68416, '\p{^Blk=avestan}', "");
    Expect(1, 68416, '\P{Blk=avestan}', "");
    Expect(0, 68416, '\P{^Blk=avestan}', "");
    Expect(1, 68415, '\p{Blk=:\Aavestan\z:}', "");;
    Expect(0, 68416, '\p{Blk=:\Aavestan\z:}', "");;
    Expect(1, 68415, '\p{Blk= Avestan}', "");
    Expect(0, 68415, '\p{^Blk= Avestan}', "");
    Expect(0, 68415, '\P{Blk= Avestan}', "");
    Expect(1, 68415, '\P{^Blk= Avestan}', "");
    Expect(0, 68416, '\p{Blk= Avestan}', "");
    Expect(1, 68416, '\p{^Blk= Avestan}', "");
    Expect(1, 68416, '\P{Blk= Avestan}', "");
    Expect(0, 68416, '\P{^Blk= Avestan}', "");
    Error('\p{Is_Block=-/a/Avestan}');
    Error('\P{Is_Block=-/a/Avestan}');
    Expect(1, 68415, '\p{Is_Block=avestan}', "");
    Expect(0, 68415, '\p{^Is_Block=avestan}', "");
    Expect(0, 68415, '\P{Is_Block=avestan}', "");
    Expect(1, 68415, '\P{^Is_Block=avestan}', "");
    Expect(0, 68416, '\p{Is_Block=avestan}', "");
    Expect(1, 68416, '\p{^Is_Block=avestan}', "");
    Expect(1, 68416, '\P{Is_Block=avestan}', "");
    Expect(0, 68416, '\P{^Is_Block=avestan}', "");
    Expect(1, 68415, '\p{Is_Block=-Avestan}', "");
    Expect(0, 68415, '\p{^Is_Block=-Avestan}', "");
    Expect(0, 68415, '\P{Is_Block=-Avestan}', "");
    Expect(1, 68415, '\P{^Is_Block=-Avestan}', "");
    Expect(0, 68416, '\p{Is_Block=-Avestan}', "");
    Expect(1, 68416, '\p{^Is_Block=-Avestan}', "");
    Expect(1, 68416, '\P{Is_Block=-Avestan}', "");
    Expect(0, 68416, '\P{^Is_Block=-Avestan}', "");
    Error('\p{Is_Blk:  :=Avestan}');
    Error('\P{Is_Blk:  :=Avestan}');
    Expect(1, 68415, '\p{Is_Blk=avestan}', "");
    Expect(0, 68415, '\p{^Is_Blk=avestan}', "");
    Expect(0, 68415, '\P{Is_Blk=avestan}', "");
    Expect(1, 68415, '\P{^Is_Blk=avestan}', "");
    Expect(0, 68416, '\p{Is_Blk=avestan}', "");
    Expect(1, 68416, '\p{^Is_Blk=avestan}', "");
    Expect(1, 68416, '\P{Is_Blk=avestan}', "");
    Expect(0, 68416, '\P{^Is_Blk=avestan}', "");
    Expect(1, 68415, '\p{Is_Blk=_Avestan}', "");
    Expect(0, 68415, '\p{^Is_Blk=_Avestan}', "");
    Expect(0, 68415, '\P{Is_Blk=_Avestan}', "");
    Expect(1, 68415, '\P{^Is_Blk=_Avestan}', "");
    Expect(0, 68416, '\p{Is_Blk=_Avestan}', "");
    Expect(1, 68416, '\p{^Is_Blk=_Avestan}', "");
    Expect(1, 68416, '\P{Is_Blk=_Avestan}', "");
    Expect(0, 68416, '\P{^Is_Blk=_Avestan}', "");
    Error('\p{Block=:=	balinese}');
    Error('\P{Block=:=	balinese}');
    Expect(1, 7039, '\p{Block=:\ABalinese\z:}', "");;
    Expect(0, 7040, '\p{Block=:\ABalinese\z:}', "");;
    Expect(1, 7039, '\p{Block:balinese}', "");
    Expect(0, 7039, '\p{^Block:balinese}', "");
    Expect(0, 7039, '\P{Block:balinese}', "");
    Expect(1, 7039, '\P{^Block:balinese}', "");
    Expect(0, 7040, '\p{Block:balinese}', "");
    Expect(1, 7040, '\p{^Block:balinese}', "");
    Expect(1, 7040, '\P{Block:balinese}', "");
    Expect(0, 7040, '\P{^Block:balinese}', "");
    Expect(1, 7039, '\p{Block=:\Abalinese\z:}', "");;
    Expect(0, 7040, '\p{Block=:\Abalinese\z:}', "");;
    Expect(1, 7039, '\p{Block=-	Balinese}', "");
    Expect(0, 7039, '\p{^Block=-	Balinese}', "");
    Expect(0, 7039, '\P{Block=-	Balinese}', "");
    Expect(1, 7039, '\P{^Block=-	Balinese}', "");
    Expect(0, 7040, '\p{Block=-	Balinese}', "");
    Expect(1, 7040, '\p{^Block=-	Balinese}', "");
    Expect(1, 7040, '\P{Block=-	Balinese}', "");
    Expect(0, 7040, '\P{^Block=-	Balinese}', "");
    Error('\p{Blk=-:=Balinese}');
    Error('\P{Blk=-:=Balinese}');
    Expect(1, 7039, '\p{Blk=:\ABalinese\z:}', "");;
    Expect(0, 7040, '\p{Blk=:\ABalinese\z:}', "");;
    Expect(1, 7039, '\p{Blk=balinese}', "");
    Expect(0, 7039, '\p{^Blk=balinese}', "");
    Expect(0, 7039, '\P{Blk=balinese}', "");
    Expect(1, 7039, '\P{^Blk=balinese}', "");
    Expect(0, 7040, '\p{Blk=balinese}', "");
    Expect(1, 7040, '\p{^Blk=balinese}', "");
    Expect(1, 7040, '\P{Blk=balinese}', "");
    Expect(0, 7040, '\P{^Blk=balinese}', "");
    Expect(1, 7039, '\p{Blk=:\Abalinese\z:}', "");;
    Expect(0, 7040, '\p{Blk=:\Abalinese\z:}', "");;
    Expect(1, 7039, '\p{Blk=-	BALINESE}', "");
    Expect(0, 7039, '\p{^Blk=-	BALINESE}', "");
    Expect(0, 7039, '\P{Blk=-	BALINESE}', "");
    Expect(1, 7039, '\P{^Blk=-	BALINESE}', "");
    Expect(0, 7040, '\p{Blk=-	BALINESE}', "");
    Expect(1, 7040, '\p{^Blk=-	BALINESE}', "");
    Expect(1, 7040, '\P{Blk=-	BALINESE}', "");
    Expect(0, 7040, '\P{^Blk=-	BALINESE}', "");
    Error('\p{Is_Block: -:=BALINESE}');
    Error('\P{Is_Block: -:=BALINESE}');
    Expect(1, 7039, '\p{Is_Block=balinese}', "");
    Expect(0, 7039, '\p{^Is_Block=balinese}', "");
    Expect(0, 7039, '\P{Is_Block=balinese}', "");
    Expect(1, 7039, '\P{^Is_Block=balinese}', "");
    Expect(0, 7040, '\p{Is_Block=balinese}', "");
    Expect(1, 7040, '\p{^Is_Block=balinese}', "");
    Expect(1, 7040, '\P{Is_Block=balinese}', "");
    Expect(0, 7040, '\P{^Is_Block=balinese}', "");
    Expect(1, 7039, '\p{Is_Block=_BALINESE}', "");
    Expect(0, 7039, '\p{^Is_Block=_BALINESE}', "");
    Expect(0, 7039, '\P{Is_Block=_BALINESE}', "");
    Expect(1, 7039, '\P{^Is_Block=_BALINESE}', "");
    Expect(0, 7040, '\p{Is_Block=_BALINESE}', "");
    Expect(1, 7040, '\p{^Is_Block=_BALINESE}', "");
    Expect(1, 7040, '\P{Is_Block=_BALINESE}', "");
    Expect(0, 7040, '\P{^Is_Block=_BALINESE}', "");
    Error('\p{Is_Blk=		Balinese:=}');
    Error('\P{Is_Blk=		Balinese:=}');
    Expect(1, 7039, '\p{Is_Blk=balinese}', "");
    Expect(0, 7039, '\p{^Is_Blk=balinese}', "");
    Expect(0, 7039, '\P{Is_Blk=balinese}', "");
    Expect(1, 7039, '\P{^Is_Blk=balinese}', "");
    Expect(0, 7040, '\p{Is_Blk=balinese}', "");
    Expect(1, 7040, '\p{^Is_Blk=balinese}', "");
    Expect(1, 7040, '\P{Is_Blk=balinese}', "");
    Expect(0, 7040, '\P{^Is_Blk=balinese}', "");
    Expect(1, 7039, '\p{Is_Blk=_	BALINESE}', "");
    Expect(0, 7039, '\p{^Is_Blk=_	BALINESE}', "");
    Expect(0, 7039, '\P{Is_Blk=_	BALINESE}', "");
    Expect(1, 7039, '\P{^Is_Blk=_	BALINESE}', "");
    Expect(0, 7040, '\p{Is_Blk=_	BALINESE}', "");
    Expect(1, 7040, '\p{^Is_Blk=_	BALINESE}', "");
    Expect(1, 7040, '\P{Is_Blk=_	BALINESE}', "");
    Expect(0, 7040, '\P{^Is_Blk=_	BALINESE}', "");
    Error('\p{Block=-BAMUM:=}');
    Error('\P{Block=-BAMUM:=}');
    Expect(1, 42751, '\p{Block=:\ABamum\z:}', "");;
    Expect(0, 42752, '\p{Block=:\ABamum\z:}', "");;
    Expect(1, 42751, '\p{Block=bamum}', "");
    Expect(0, 42751, '\p{^Block=bamum}', "");
    Expect(0, 42751, '\P{Block=bamum}', "");
    Expect(1, 42751, '\P{^Block=bamum}', "");
    Expect(0, 42752, '\p{Block=bamum}', "");
    Expect(1, 42752, '\p{^Block=bamum}', "");
    Expect(1, 42752, '\P{Block=bamum}', "");
    Expect(0, 42752, '\P{^Block=bamum}', "");
    Expect(1, 42751, '\p{Block=:\Abamum\z:}', "");;
    Expect(0, 42752, '\p{Block=:\Abamum\z:}', "");;
    Expect(1, 42751, '\p{Block=	Bamum}', "");
    Expect(0, 42751, '\p{^Block=	Bamum}', "");
    Expect(0, 42751, '\P{Block=	Bamum}', "");
    Expect(1, 42751, '\P{^Block=	Bamum}', "");
    Expect(0, 42752, '\p{Block=	Bamum}', "");
    Expect(1, 42752, '\p{^Block=	Bamum}', "");
    Expect(1, 42752, '\P{Block=	Bamum}', "");
    Expect(0, 42752, '\P{^Block=	Bamum}', "");
    Error('\p{Blk=/a/_bamum}');
    Error('\P{Blk=/a/_bamum}');
    Expect(1, 42751, '\p{Blk=:\ABamum\z:}', "");;
    Expect(0, 42752, '\p{Blk=:\ABamum\z:}', "");;
    Expect(1, 42751, '\p{Blk=bamum}', "");
    Expect(0, 42751, '\p{^Blk=bamum}', "");
    Expect(0, 42751, '\P{Blk=bamum}', "");
    Expect(1, 42751, '\P{^Blk=bamum}', "");
    Expect(0, 42752, '\p{Blk=bamum}', "");
    Expect(1, 42752, '\p{^Blk=bamum}', "");
    Expect(1, 42752, '\P{Blk=bamum}', "");
    Expect(0, 42752, '\P{^Blk=bamum}', "");
    Expect(1, 42751, '\p{Blk=:\Abamum\z:}', "");;
    Expect(0, 42752, '\p{Blk=:\Abamum\z:}', "");;
    Expect(1, 42751, '\p{Blk:	-BAMUM}', "");
    Expect(0, 42751, '\p{^Blk:	-BAMUM}', "");
    Expect(0, 42751, '\P{Blk:	-BAMUM}', "");
    Expect(1, 42751, '\P{^Blk:	-BAMUM}', "");
    Expect(0, 42752, '\p{Blk:	-BAMUM}', "");
    Expect(1, 42752, '\p{^Blk:	-BAMUM}', "");
    Expect(1, 42752, '\P{Blk:	-BAMUM}', "");
    Expect(0, 42752, '\P{^Blk:	-BAMUM}', "");
    Error('\p{Is_Block=:=_Bamum}');
    Error('\P{Is_Block=:=_Bamum}');
    Expect(1, 42751, '\p{Is_Block=bamum}', "");
    Expect(0, 42751, '\p{^Is_Block=bamum}', "");
    Expect(0, 42751, '\P{Is_Block=bamum}', "");
    Expect(1, 42751, '\P{^Is_Block=bamum}', "");
    Expect(0, 42752, '\p{Is_Block=bamum}', "");
    Expect(1, 42752, '\p{^Is_Block=bamum}', "");
    Expect(1, 42752, '\P{Is_Block=bamum}', "");
    Expect(0, 42752, '\P{^Is_Block=bamum}', "");
    Expect(1, 42751, '\p{Is_Block:- bamum}', "");
    Expect(0, 42751, '\p{^Is_Block:- bamum}', "");
    Expect(0, 42751, '\P{Is_Block:- bamum}', "");
    Expect(1, 42751, '\P{^Is_Block:- bamum}', "");
    Expect(0, 42752, '\p{Is_Block:- bamum}', "");
    Expect(1, 42752, '\p{^Is_Block:- bamum}', "");
    Expect(1, 42752, '\P{Is_Block:- bamum}', "");
    Expect(0, 42752, '\P{^Is_Block:- bamum}', "");
    Error('\p{Is_Blk= _BAMUM/a/}');
    Error('\P{Is_Blk= _BAMUM/a/}');
    Expect(1, 42751, '\p{Is_Blk=bamum}', "");
    Expect(0, 42751, '\p{^Is_Blk=bamum}', "");
    Expect(0, 42751, '\P{Is_Blk=bamum}', "");
    Expect(1, 42751, '\P{^Is_Blk=bamum}', "");
    Expect(0, 42752, '\p{Is_Blk=bamum}', "");
    Expect(1, 42752, '\p{^Is_Blk=bamum}', "");
    Expect(1, 42752, '\P{Is_Blk=bamum}', "");
    Expect(0, 42752, '\P{^Is_Blk=bamum}', "");
    Expect(1, 42751, '\p{Is_Blk=	-Bamum}', "");
    Expect(0, 42751, '\p{^Is_Blk=	-Bamum}', "");
    Expect(0, 42751, '\P{Is_Blk=	-Bamum}', "");
    Expect(1, 42751, '\P{^Is_Blk=	-Bamum}', "");
    Expect(0, 42752, '\p{Is_Blk=	-Bamum}', "");
    Expect(1, 42752, '\p{^Is_Blk=	-Bamum}', "");
    Expect(1, 42752, '\P{Is_Blk=	-Bamum}', "");
    Expect(0, 42752, '\P{^Is_Blk=	-Bamum}', "");
    Error('\p{Block=_ Bamum_Supplement/a/}');
    Error('\P{Block=_ Bamum_Supplement/a/}');
    Expect(1, 92735, '\p{Block=:\ABamum_Supplement\z:}', "");;
    Expect(0, 92736, '\p{Block=:\ABamum_Supplement\z:}', "");;
    Expect(1, 92735, '\p{Block=bamumsupplement}', "");
    Expect(0, 92735, '\p{^Block=bamumsupplement}', "");
    Expect(0, 92735, '\P{Block=bamumsupplement}', "");
    Expect(1, 92735, '\P{^Block=bamumsupplement}', "");
    Expect(0, 92736, '\p{Block=bamumsupplement}', "");
    Expect(1, 92736, '\p{^Block=bamumsupplement}', "");
    Expect(1, 92736, '\P{Block=bamumsupplement}', "");
    Expect(0, 92736, '\P{^Block=bamumsupplement}', "");
    Expect(1, 92735, '\p{Block=:\Abamumsupplement\z:}', "");;
    Expect(0, 92736, '\p{Block=:\Abamumsupplement\z:}', "");;
    Expect(1, 92735, '\p{Block=-	Bamum_Supplement}', "");
    Expect(0, 92735, '\p{^Block=-	Bamum_Supplement}', "");
    Expect(0, 92735, '\P{Block=-	Bamum_Supplement}', "");
    Expect(1, 92735, '\P{^Block=-	Bamum_Supplement}', "");
    Expect(0, 92736, '\p{Block=-	Bamum_Supplement}', "");
    Expect(1, 92736, '\p{^Block=-	Bamum_Supplement}', "");
    Expect(1, 92736, '\P{Block=-	Bamum_Supplement}', "");
    Expect(0, 92736, '\P{^Block=-	Bamum_Supplement}', "");
    Error('\p{Blk=/a/BAMUM_SUP}');
    Error('\P{Blk=/a/BAMUM_SUP}');
    Expect(1, 92735, '\p{Blk=:\ABamum_Sup\z:}', "");;
    Expect(0, 92736, '\p{Blk=:\ABamum_Sup\z:}', "");;
    Expect(1, 92735, '\p{Blk=bamumsup}', "");
    Expect(0, 92735, '\p{^Blk=bamumsup}', "");
    Expect(0, 92735, '\P{Blk=bamumsup}', "");
    Expect(1, 92735, '\P{^Blk=bamumsup}', "");
    Expect(0, 92736, '\p{Blk=bamumsup}', "");
    Expect(1, 92736, '\p{^Blk=bamumsup}', "");
    Expect(1, 92736, '\P{Blk=bamumsup}', "");
    Expect(0, 92736, '\P{^Blk=bamumsup}', "");
    Expect(1, 92735, '\p{Blk=:\Abamumsup\z:}', "");;
    Expect(0, 92736, '\p{Blk=:\Abamumsup\z:}', "");;
    Expect(1, 92735, '\p{Blk=_ Bamum_Sup}', "");
    Expect(0, 92735, '\p{^Blk=_ Bamum_Sup}', "");
    Expect(0, 92735, '\P{Blk=_ Bamum_Sup}', "");
    Expect(1, 92735, '\P{^Blk=_ Bamum_Sup}', "");
    Expect(0, 92736, '\p{Blk=_ Bamum_Sup}', "");
    Expect(1, 92736, '\p{^Blk=_ Bamum_Sup}', "");
    Expect(1, 92736, '\P{Blk=_ Bamum_Sup}', "");
    Expect(0, 92736, '\P{^Blk=_ Bamum_Sup}', "");
    Error('\p{Is_Block=/a/ bamum_Supplement}');
    Error('\P{Is_Block=/a/ bamum_Supplement}');
    Expect(1, 92735, '\p{Is_Block=bamumsupplement}', "");
    Expect(0, 92735, '\p{^Is_Block=bamumsupplement}', "");
    Expect(0, 92735, '\P{Is_Block=bamumsupplement}', "");
    Expect(1, 92735, '\P{^Is_Block=bamumsupplement}', "");
    Expect(0, 92736, '\p{Is_Block=bamumsupplement}', "");
    Expect(1, 92736, '\p{^Is_Block=bamumsupplement}', "");
    Expect(1, 92736, '\P{Is_Block=bamumsupplement}', "");
    Expect(0, 92736, '\P{^Is_Block=bamumsupplement}', "");
    Expect(1, 92735, '\p{Is_Block: _ BAMUM_SUPPLEMENT}', "");
    Expect(0, 92735, '\p{^Is_Block: _ BAMUM_SUPPLEMENT}', "");
    Expect(0, 92735, '\P{Is_Block: _ BAMUM_SUPPLEMENT}', "");
    Expect(1, 92735, '\P{^Is_Block: _ BAMUM_SUPPLEMENT}', "");
    Expect(0, 92736, '\p{Is_Block: _ BAMUM_SUPPLEMENT}', "");
    Expect(1, 92736, '\p{^Is_Block: _ BAMUM_SUPPLEMENT}', "");
    Expect(1, 92736, '\P{Is_Block: _ BAMUM_SUPPLEMENT}', "");
    Expect(0, 92736, '\P{^Is_Block: _ BAMUM_SUPPLEMENT}', "");
    Error('\p{Is_Blk=-:=Bamum_sup}');
    Error('\P{Is_Blk=-:=Bamum_sup}');
    Expect(1, 92735, '\p{Is_Blk=bamumsup}', "");
    Expect(0, 92735, '\p{^Is_Blk=bamumsup}', "");
    Expect(0, 92735, '\P{Is_Blk=bamumsup}', "");
    Expect(1, 92735, '\P{^Is_Blk=bamumsup}', "");
    Expect(0, 92736, '\p{Is_Blk=bamumsup}', "");
    Expect(1, 92736, '\p{^Is_Blk=bamumsup}', "");
    Expect(1, 92736, '\P{Is_Blk=bamumsup}', "");
    Expect(0, 92736, '\P{^Is_Blk=bamumsup}', "");
    Expect(1, 92735, '\p{Is_Blk=-Bamum_Sup}', "");
    Expect(0, 92735, '\p{^Is_Blk=-Bamum_Sup}', "");
    Expect(0, 92735, '\P{Is_Blk=-Bamum_Sup}', "");
    Expect(1, 92735, '\P{^Is_Blk=-Bamum_Sup}', "");
    Expect(0, 92736, '\p{Is_Blk=-Bamum_Sup}', "");
    Expect(1, 92736, '\p{^Is_Blk=-Bamum_Sup}', "");
    Expect(1, 92736, '\P{Is_Blk=-Bamum_Sup}', "");
    Expect(0, 92736, '\P{^Is_Blk=-Bamum_Sup}', "");
    Error('\p{Block=/a/Bassa_Vah}');
    Error('\P{Block=/a/Bassa_Vah}');
    Expect(1, 92927, '\p{Block=:\ABassa_Vah\z:}', "");;
    Expect(0, 92928, '\p{Block=:\ABassa_Vah\z:}', "");;
    Expect(1, 92927, '\p{Block:   bassavah}', "");
    Expect(0, 92927, '\p{^Block:   bassavah}', "");
    Expect(0, 92927, '\P{Block:   bassavah}', "");
    Expect(1, 92927, '\P{^Block:   bassavah}', "");
    Expect(0, 92928, '\p{Block:   bassavah}', "");
    Expect(1, 92928, '\p{^Block:   bassavah}', "");
    Expect(1, 92928, '\P{Block:   bassavah}', "");
    Expect(0, 92928, '\P{^Block:   bassavah}', "");
    Expect(1, 92927, '\p{Block=:\Abassavah\z:}', "");;
    Expect(0, 92928, '\p{Block=:\Abassavah\z:}', "");;
    Expect(1, 92927, '\p{Block:   -	Bassa_Vah}', "");
    Expect(0, 92927, '\p{^Block:   -	Bassa_Vah}', "");
    Expect(0, 92927, '\P{Block:   -	Bassa_Vah}', "");
    Expect(1, 92927, '\P{^Block:   -	Bassa_Vah}', "");
    Expect(0, 92928, '\p{Block:   -	Bassa_Vah}', "");
    Expect(1, 92928, '\p{^Block:   -	Bassa_Vah}', "");
    Expect(1, 92928, '\P{Block:   -	Bassa_Vah}', "");
    Expect(0, 92928, '\P{^Block:   -	Bassa_Vah}', "");
    Error('\p{Blk= 	BASSA_VAH/a/}');
    Error('\P{Blk= 	BASSA_VAH/a/}');
    Expect(1, 92927, '\p{Blk=:\ABassa_Vah\z:}', "");;
    Expect(0, 92928, '\p{Blk=:\ABassa_Vah\z:}', "");;
    Expect(1, 92927, '\p{Blk: bassavah}', "");
    Expect(0, 92927, '\p{^Blk: bassavah}', "");
    Expect(0, 92927, '\P{Blk: bassavah}', "");
    Expect(1, 92927, '\P{^Blk: bassavah}', "");
    Expect(0, 92928, '\p{Blk: bassavah}', "");
    Expect(1, 92928, '\p{^Blk: bassavah}', "");
    Expect(1, 92928, '\P{Blk: bassavah}', "");
    Expect(0, 92928, '\P{^Blk: bassavah}', "");
    Expect(1, 92927, '\p{Blk=:\Abassavah\z:}', "");;
    Expect(0, 92928, '\p{Blk=:\Abassavah\z:}', "");;
    Expect(1, 92927, '\p{Blk:__bassa_VAH}', "");
    Expect(0, 92927, '\p{^Blk:__bassa_VAH}', "");
    Expect(0, 92927, '\P{Blk:__bassa_VAH}', "");
    Expect(1, 92927, '\P{^Blk:__bassa_VAH}', "");
    Expect(0, 92928, '\p{Blk:__bassa_VAH}', "");
    Expect(1, 92928, '\p{^Blk:__bassa_VAH}', "");
    Expect(1, 92928, '\P{Blk:__bassa_VAH}', "");
    Expect(0, 92928, '\P{^Blk:__bassa_VAH}', "");
    Error('\p{Is_Block=/a/ BASSA_Vah}');
    Error('\P{Is_Block=/a/ BASSA_Vah}');
    Expect(1, 92927, '\p{Is_Block=bassavah}', "");
    Expect(0, 92927, '\p{^Is_Block=bassavah}', "");
    Expect(0, 92927, '\P{Is_Block=bassavah}', "");
    Expect(1, 92927, '\P{^Is_Block=bassavah}', "");
    Expect(0, 92928, '\p{Is_Block=bassavah}', "");
    Expect(1, 92928, '\p{^Is_Block=bassavah}', "");
    Expect(1, 92928, '\P{Is_Block=bassavah}', "");
    Expect(0, 92928, '\P{^Is_Block=bassavah}', "");
    Expect(1, 92927, '\p{Is_Block= Bassa_Vah}', "");
    Expect(0, 92927, '\p{^Is_Block= Bassa_Vah}', "");
    Expect(0, 92927, '\P{Is_Block= Bassa_Vah}', "");
    Expect(1, 92927, '\P{^Is_Block= Bassa_Vah}', "");
    Expect(0, 92928, '\p{Is_Block= Bassa_Vah}', "");
    Expect(1, 92928, '\p{^Is_Block= Bassa_Vah}', "");
    Expect(1, 92928, '\P{Is_Block= Bassa_Vah}', "");
    Expect(0, 92928, '\P{^Is_Block= Bassa_Vah}', "");
    Error('\p{Is_Blk=  Bassa_Vah/a/}');
    Error('\P{Is_Blk=  Bassa_Vah/a/}');
    Expect(1, 92927, '\p{Is_Blk=bassavah}', "");
    Expect(0, 92927, '\p{^Is_Blk=bassavah}', "");
    Expect(0, 92927, '\P{Is_Blk=bassavah}', "");
    Expect(1, 92927, '\P{^Is_Blk=bassavah}', "");
    Expect(0, 92928, '\p{Is_Blk=bassavah}', "");
    Expect(1, 92928, '\p{^Is_Blk=bassavah}', "");
    Expect(1, 92928, '\P{Is_Blk=bassavah}', "");
    Expect(0, 92928, '\P{^Is_Blk=bassavah}', "");
    Expect(1, 92927, '\p{Is_Blk= bassa_vah}', "");
    Expect(0, 92927, '\p{^Is_Blk= bassa_vah}', "");
    Expect(0, 92927, '\P{Is_Blk= bassa_vah}', "");
    Expect(1, 92927, '\P{^Is_Blk= bassa_vah}', "");
    Expect(0, 92928, '\p{Is_Blk= bassa_vah}', "");
    Expect(1, 92928, '\p{^Is_Blk= bassa_vah}', "");
    Expect(1, 92928, '\P{Is_Blk= bassa_vah}', "");
    Expect(0, 92928, '\P{^Is_Blk= bassa_vah}', "");
    Error('\p{Block=:=		batak}');
    Error('\P{Block=:=		batak}');
    Expect(1, 7167, '\p{Block=:\ABatak\z:}', "");;
    Expect(0, 7168, '\p{Block=:\ABatak\z:}', "");;
    Expect(1, 7167, '\p{Block=batak}', "");
    Expect(0, 7167, '\p{^Block=batak}', "");
    Expect(0, 7167, '\P{Block=batak}', "");
    Expect(1, 7167, '\P{^Block=batak}', "");
    Expect(0, 7168, '\p{Block=batak}', "");
    Expect(1, 7168, '\p{^Block=batak}', "");
    Expect(1, 7168, '\P{Block=batak}', "");
    Expect(0, 7168, '\P{^Block=batak}', "");
    Expect(1, 7167, '\p{Block=:\Abatak\z:}', "");;
    Expect(0, 7168, '\p{Block=:\Abatak\z:}', "");;
    Expect(1, 7167, '\p{Block= Batak}', "");
    Expect(0, 7167, '\p{^Block= Batak}', "");
    Expect(0, 7167, '\P{Block= Batak}', "");
    Expect(1, 7167, '\P{^Block= Batak}', "");
    Expect(0, 7168, '\p{Block= Batak}', "");
    Expect(1, 7168, '\p{^Block= Batak}', "");
    Expect(1, 7168, '\P{Block= Batak}', "");
    Expect(0, 7168, '\P{^Block= Batak}', "");
    Error('\p{Blk= /a/batak}');
    Error('\P{Blk= /a/batak}');
    Expect(1, 7167, '\p{Blk=:\ABatak\z:}', "");;
    Expect(0, 7168, '\p{Blk=:\ABatak\z:}', "");;
    Expect(1, 7167, '\p{Blk=batak}', "");
    Expect(0, 7167, '\p{^Blk=batak}', "");
    Expect(0, 7167, '\P{Blk=batak}', "");
    Expect(1, 7167, '\P{^Blk=batak}', "");
    Expect(0, 7168, '\p{Blk=batak}', "");
    Expect(1, 7168, '\p{^Blk=batak}', "");
    Expect(1, 7168, '\P{Blk=batak}', "");
    Expect(0, 7168, '\P{^Blk=batak}', "");
    Expect(1, 7167, '\p{Blk=:\Abatak\z:}', "");;
    Expect(0, 7168, '\p{Blk=:\Abatak\z:}', "");;
    Expect(1, 7167, '\p{Blk= BATAK}', "");
    Expect(0, 7167, '\p{^Blk= BATAK}', "");
    Expect(0, 7167, '\P{Blk= BATAK}', "");
    Expect(1, 7167, '\P{^Blk= BATAK}', "");
    Expect(0, 7168, '\p{Blk= BATAK}', "");
    Expect(1, 7168, '\p{^Blk= BATAK}', "");
    Expect(1, 7168, '\P{Blk= BATAK}', "");
    Expect(0, 7168, '\P{^Blk= BATAK}', "");
    Error('\p{Is_Block=:= 	Batak}');
    Error('\P{Is_Block=:= 	Batak}');
    Expect(1, 7167, '\p{Is_Block=batak}', "");
    Expect(0, 7167, '\p{^Is_Block=batak}', "");
    Expect(0, 7167, '\P{Is_Block=batak}', "");
    Expect(1, 7167, '\P{^Is_Block=batak}', "");
    Expect(0, 7168, '\p{Is_Block=batak}', "");
    Expect(1, 7168, '\p{^Is_Block=batak}', "");
    Expect(1, 7168, '\P{Is_Block=batak}', "");
    Expect(0, 7168, '\P{^Is_Block=batak}', "");
    Expect(1, 7167, '\p{Is_Block=_-BATAK}', "");
    Expect(0, 7167, '\p{^Is_Block=_-BATAK}', "");
    Expect(0, 7167, '\P{Is_Block=_-BATAK}', "");
    Expect(1, 7167, '\P{^Is_Block=_-BATAK}', "");
    Expect(0, 7168, '\p{Is_Block=_-BATAK}', "");
    Expect(1, 7168, '\p{^Is_Block=_-BATAK}', "");
    Expect(1, 7168, '\P{Is_Block=_-BATAK}', "");
    Expect(0, 7168, '\P{^Is_Block=_-BATAK}', "");
    Error('\p{Is_Blk:  	Batak/a/}');
    Error('\P{Is_Blk:  	Batak/a/}');
    Expect(1, 7167, '\p{Is_Blk=batak}', "");
    Expect(0, 7167, '\p{^Is_Blk=batak}', "");
    Expect(0, 7167, '\P{Is_Blk=batak}', "");
    Expect(1, 7167, '\P{^Is_Blk=batak}', "");
    Expect(0, 7168, '\p{Is_Blk=batak}', "");
    Expect(1, 7168, '\p{^Is_Blk=batak}', "");
    Expect(1, 7168, '\P{Is_Blk=batak}', "");
    Expect(0, 7168, '\P{^Is_Blk=batak}', "");
    Expect(1, 7167, '\p{Is_Blk= 	BATAK}', "");
    Expect(0, 7167, '\p{^Is_Blk= 	BATAK}', "");
    Expect(0, 7167, '\P{Is_Blk= 	BATAK}', "");
    Expect(1, 7167, '\P{^Is_Blk= 	BATAK}', "");
    Expect(0, 7168, '\p{Is_Blk= 	BATAK}', "");
    Expect(1, 7168, '\p{^Is_Blk= 	BATAK}', "");
    Expect(1, 7168, '\P{Is_Blk= 	BATAK}', "");
    Expect(0, 7168, '\P{^Is_Blk= 	BATAK}', "");
    Error('\p{Block=-bengali/a/}');
    Error('\P{Block=-bengali/a/}');
    Expect(1, 2559, '\p{Block=:\ABengali\z:}', "");;
    Expect(0, 2560, '\p{Block=:\ABengali\z:}', "");;
    Expect(1, 2559, '\p{Block=bengali}', "");
    Expect(0, 2559, '\p{^Block=bengali}', "");
    Expect(0, 2559, '\P{Block=bengali}', "");
    Expect(1, 2559, '\P{^Block=bengali}', "");
    Expect(0, 2560, '\p{Block=bengali}', "");
    Expect(1, 2560, '\p{^Block=bengali}', "");
    Expect(1, 2560, '\P{Block=bengali}', "");
    Expect(0, 2560, '\P{^Block=bengali}', "");
    Expect(1, 2559, '\p{Block=:\Abengali\z:}', "");;
    Expect(0, 2560, '\p{Block=:\Abengali\z:}', "");;
    Expect(1, 2559, '\p{Block=__Bengali}', "");
    Expect(0, 2559, '\p{^Block=__Bengali}', "");
    Expect(0, 2559, '\P{Block=__Bengali}', "");
    Expect(1, 2559, '\P{^Block=__Bengali}', "");
    Expect(0, 2560, '\p{Block=__Bengali}', "");
    Expect(1, 2560, '\p{^Block=__Bengali}', "");
    Expect(1, 2560, '\P{Block=__Bengali}', "");
    Expect(0, 2560, '\P{^Block=__Bengali}', "");
    Error('\p{Blk=-:=Bengali}');
    Error('\P{Blk=-:=Bengali}');
    Expect(1, 2559, '\p{Blk=:\ABengali\z:}', "");;
    Expect(0, 2560, '\p{Blk=:\ABengali\z:}', "");;
    Expect(1, 2559, '\p{Blk=bengali}', "");
    Expect(0, 2559, '\p{^Blk=bengali}', "");
    Expect(0, 2559, '\P{Blk=bengali}', "");
    Expect(1, 2559, '\P{^Blk=bengali}', "");
    Expect(0, 2560, '\p{Blk=bengali}', "");
    Expect(1, 2560, '\p{^Blk=bengali}', "");
    Expect(1, 2560, '\P{Blk=bengali}', "");
    Expect(0, 2560, '\P{^Blk=bengali}', "");
    Expect(1, 2559, '\p{Blk=:\Abengali\z:}', "");;
    Expect(0, 2560, '\p{Blk=:\Abengali\z:}', "");;
    Expect(1, 2559, '\p{Blk: - Bengali}', "");
    Expect(0, 2559, '\p{^Blk: - Bengali}', "");
    Expect(0, 2559, '\P{Blk: - Bengali}', "");
    Expect(1, 2559, '\P{^Blk: - Bengali}', "");
    Expect(0, 2560, '\p{Blk: - Bengali}', "");
    Expect(1, 2560, '\p{^Blk: - Bengali}', "");
    Expect(1, 2560, '\P{Blk: - Bengali}', "");
    Expect(0, 2560, '\P{^Blk: - Bengali}', "");
    Error('\p{Is_Block=-_bengali/a/}');
    Error('\P{Is_Block=-_bengali/a/}');
    Expect(1, 2559, '\p{Is_Block:   bengali}', "");
    Expect(0, 2559, '\p{^Is_Block:   bengali}', "");
    Expect(0, 2559, '\P{Is_Block:   bengali}', "");
    Expect(1, 2559, '\P{^Is_Block:   bengali}', "");
    Expect(0, 2560, '\p{Is_Block:   bengali}', "");
    Expect(1, 2560, '\p{^Is_Block:   bengali}', "");
    Expect(1, 2560, '\P{Is_Block:   bengali}', "");
    Expect(0, 2560, '\P{^Is_Block:   bengali}', "");
    Expect(1, 2559, '\p{Is_Block=Bengali}', "");
    Expect(0, 2559, '\p{^Is_Block=Bengali}', "");
    Expect(0, 2559, '\P{Is_Block=Bengali}', "");
    Expect(1, 2559, '\P{^Is_Block=Bengali}', "");
    Expect(0, 2560, '\p{Is_Block=Bengali}', "");
    Expect(1, 2560, '\p{^Is_Block=Bengali}', "");
    Expect(1, 2560, '\P{Is_Block=Bengali}', "");
    Expect(0, 2560, '\P{^Is_Block=Bengali}', "");
    Error('\p{Is_Blk=_/a/Bengali}');
    Error('\P{Is_Blk=_/a/Bengali}');
    Expect(1, 2559, '\p{Is_Blk=bengali}', "");
    Expect(0, 2559, '\p{^Is_Blk=bengali}', "");
    Expect(0, 2559, '\P{Is_Blk=bengali}', "");
    Expect(1, 2559, '\P{^Is_Blk=bengali}', "");
    Expect(0, 2560, '\p{Is_Blk=bengali}', "");
    Expect(1, 2560, '\p{^Is_Blk=bengali}', "");
    Expect(1, 2560, '\P{Is_Blk=bengali}', "");
    Expect(0, 2560, '\P{^Is_Blk=bengali}', "");
    Expect(1, 2559, '\p{Is_Blk=	_Bengali}', "");
    Expect(0, 2559, '\p{^Is_Blk=	_Bengali}', "");
    Expect(0, 2559, '\P{Is_Blk=	_Bengali}', "");
    Expect(1, 2559, '\P{^Is_Blk=	_Bengali}', "");
    Expect(0, 2560, '\p{Is_Blk=	_Bengali}', "");
    Expect(1, 2560, '\p{^Is_Blk=	_Bengali}', "");
    Expect(1, 2560, '\P{Is_Blk=	_Bengali}', "");
    Expect(0, 2560, '\P{^Is_Blk=	_Bengali}', "");
    Error('\p{Block=-/a/BHAIKSUKI}');
    Error('\P{Block=-/a/BHAIKSUKI}');
    Expect(1, 72815, '\p{Block=:\ABhaiksuki\z:}', "");;
    Expect(0, 72816, '\p{Block=:\ABhaiksuki\z:}', "");;
    Expect(1, 72815, '\p{Block=bhaiksuki}', "");
    Expect(0, 72815, '\p{^Block=bhaiksuki}', "");
    Expect(0, 72815, '\P{Block=bhaiksuki}', "");
    Expect(1, 72815, '\P{^Block=bhaiksuki}', "");
    Expect(0, 72816, '\p{Block=bhaiksuki}', "");
    Expect(1, 72816, '\p{^Block=bhaiksuki}', "");
    Expect(1, 72816, '\P{Block=bhaiksuki}', "");
    Expect(0, 72816, '\P{^Block=bhaiksuki}', "");
    Expect(1, 72815, '\p{Block=:\Abhaiksuki\z:}', "");;
    Expect(0, 72816, '\p{Block=:\Abhaiksuki\z:}', "");;
    Expect(1, 72815, '\p{Block=	Bhaiksuki}', "");
    Expect(0, 72815, '\p{^Block=	Bhaiksuki}', "");
    Expect(0, 72815, '\P{Block=	Bhaiksuki}', "");
    Expect(1, 72815, '\P{^Block=	Bhaiksuki}', "");
    Expect(0, 72816, '\p{Block=	Bhaiksuki}', "");
    Expect(1, 72816, '\p{^Block=	Bhaiksuki}', "");
    Expect(1, 72816, '\P{Block=	Bhaiksuki}', "");
    Expect(0, 72816, '\P{^Block=	Bhaiksuki}', "");
    Error('\p{Blk:	:=-bhaiksuki}');
    Error('\P{Blk:	:=-bhaiksuki}');
    Expect(1, 72815, '\p{Blk=:\ABhaiksuki\z:}', "");;
    Expect(0, 72816, '\p{Blk=:\ABhaiksuki\z:}', "");;
    Expect(1, 72815, '\p{Blk=bhaiksuki}', "");
    Expect(0, 72815, '\p{^Blk=bhaiksuki}', "");
    Expect(0, 72815, '\P{Blk=bhaiksuki}', "");
    Expect(1, 72815, '\P{^Blk=bhaiksuki}', "");
    Expect(0, 72816, '\p{Blk=bhaiksuki}', "");
    Expect(1, 72816, '\p{^Blk=bhaiksuki}', "");
    Expect(1, 72816, '\P{Blk=bhaiksuki}', "");
    Expect(0, 72816, '\P{^Blk=bhaiksuki}', "");
    Expect(1, 72815, '\p{Blk=:\Abhaiksuki\z:}', "");;
    Expect(0, 72816, '\p{Blk=:\Abhaiksuki\z:}', "");;
    Expect(1, 72815, '\p{Blk=-	BHAIKSUKI}', "");
    Expect(0, 72815, '\p{^Blk=-	BHAIKSUKI}', "");
    Expect(0, 72815, '\P{Blk=-	BHAIKSUKI}', "");
    Expect(1, 72815, '\P{^Blk=-	BHAIKSUKI}', "");
    Expect(0, 72816, '\p{Blk=-	BHAIKSUKI}', "");
    Expect(1, 72816, '\p{^Blk=-	BHAIKSUKI}', "");
    Expect(1, 72816, '\P{Blk=-	BHAIKSUKI}', "");
    Expect(0, 72816, '\P{^Blk=-	BHAIKSUKI}', "");
    Error('\p{Is_Block=/a/_	bhaiksuki}');
    Error('\P{Is_Block=/a/_	bhaiksuki}');
    Expect(1, 72815, '\p{Is_Block=bhaiksuki}', "");
    Expect(0, 72815, '\p{^Is_Block=bhaiksuki}', "");
    Expect(0, 72815, '\P{Is_Block=bhaiksuki}', "");
    Expect(1, 72815, '\P{^Is_Block=bhaiksuki}', "");
    Expect(0, 72816, '\p{Is_Block=bhaiksuki}', "");
    Expect(1, 72816, '\p{^Is_Block=bhaiksuki}', "");
    Expect(1, 72816, '\P{Is_Block=bhaiksuki}', "");
    Expect(0, 72816, '\P{^Is_Block=bhaiksuki}', "");
    Expect(1, 72815, '\p{Is_Block=- Bhaiksuki}', "");
    Expect(0, 72815, '\p{^Is_Block=- Bhaiksuki}', "");
    Expect(0, 72815, '\P{Is_Block=- Bhaiksuki}', "");
    Expect(1, 72815, '\P{^Is_Block=- Bhaiksuki}', "");
    Expect(0, 72816, '\p{Is_Block=- Bhaiksuki}', "");
    Expect(1, 72816, '\p{^Is_Block=- Bhaiksuki}', "");
    Expect(1, 72816, '\P{Is_Block=- Bhaiksuki}', "");
    Expect(0, 72816, '\P{^Is_Block=- Bhaiksuki}', "");
    Error('\p{Is_Blk=/a/_ Bhaiksuki}');
    Error('\P{Is_Blk=/a/_ Bhaiksuki}');
    Expect(1, 72815, '\p{Is_Blk=bhaiksuki}', "");
    Expect(0, 72815, '\p{^Is_Blk=bhaiksuki}', "");
    Expect(0, 72815, '\P{Is_Blk=bhaiksuki}', "");
    Expect(1, 72815, '\P{^Is_Blk=bhaiksuki}', "");
    Expect(0, 72816, '\p{Is_Blk=bhaiksuki}', "");
    Expect(1, 72816, '\p{^Is_Blk=bhaiksuki}', "");
    Expect(1, 72816, '\P{Is_Blk=bhaiksuki}', "");
    Expect(0, 72816, '\P{^Is_Blk=bhaiksuki}', "");
    Expect(1, 72815, '\p{Is_Blk= -Bhaiksuki}', "");
    Expect(0, 72815, '\p{^Is_Blk= -Bhaiksuki}', "");
    Expect(0, 72815, '\P{Is_Blk= -Bhaiksuki}', "");
    Expect(1, 72815, '\P{^Is_Blk= -Bhaiksuki}', "");
    Expect(0, 72816, '\p{Is_Blk= -Bhaiksuki}', "");
    Expect(1, 72816, '\p{^Is_Blk= -Bhaiksuki}', "");
    Expect(1, 72816, '\P{Is_Blk= -Bhaiksuki}', "");
    Expect(0, 72816, '\P{^Is_Blk= -Bhaiksuki}', "");
    Error('\p{Block=__Block_Elements/a/}');
    Error('\P{Block=__Block_Elements/a/}');
    Expect(1, 9631, '\p{Block=:\ABlock_Elements\z:}', "");;
    Expect(0, 9632, '\p{Block=:\ABlock_Elements\z:}', "");;
    Expect(1, 9631, '\p{Block=blockelements}', "");
    Expect(0, 9631, '\p{^Block=blockelements}', "");
    Expect(0, 9631, '\P{Block=blockelements}', "");
    Expect(1, 9631, '\P{^Block=blockelements}', "");
    Expect(0, 9632, '\p{Block=blockelements}', "");
    Expect(1, 9632, '\p{^Block=blockelements}', "");
    Expect(1, 9632, '\P{Block=blockelements}', "");
    Expect(0, 9632, '\P{^Block=blockelements}', "");
    Expect(1, 9631, '\p{Block=:\Ablockelements\z:}', "");;
    Expect(0, 9632, '\p{Block=:\Ablockelements\z:}', "");;
    Expect(1, 9631, '\p{Block: -Block_ELEMENTS}', "");
    Expect(0, 9631, '\p{^Block: -Block_ELEMENTS}', "");
    Expect(0, 9631, '\P{Block: -Block_ELEMENTS}', "");
    Expect(1, 9631, '\P{^Block: -Block_ELEMENTS}', "");
    Expect(0, 9632, '\p{Block: -Block_ELEMENTS}', "");
    Expect(1, 9632, '\p{^Block: -Block_ELEMENTS}', "");
    Expect(1, 9632, '\P{Block: -Block_ELEMENTS}', "");
    Expect(0, 9632, '\P{^Block: -Block_ELEMENTS}', "");
    Error('\p{Blk=:=__block_Elements}');
    Error('\P{Blk=:=__block_Elements}');
    Expect(1, 9631, '\p{Blk=:\ABlock_Elements\z:}', "");;
    Expect(0, 9632, '\p{Blk=:\ABlock_Elements\z:}', "");;
    Expect(1, 9631, '\p{Blk=blockelements}', "");
    Expect(0, 9631, '\p{^Blk=blockelements}', "");
    Expect(0, 9631, '\P{Blk=blockelements}', "");
    Expect(1, 9631, '\P{^Blk=blockelements}', "");
    Expect(0, 9632, '\p{Blk=blockelements}', "");
    Expect(1, 9632, '\p{^Blk=blockelements}', "");
    Expect(1, 9632, '\P{Blk=blockelements}', "");
    Expect(0, 9632, '\P{^Blk=blockelements}', "");
    Expect(1, 9631, '\p{Blk=:\Ablockelements\z:}', "");;
    Expect(0, 9632, '\p{Blk=:\Ablockelements\z:}', "");;
    Expect(1, 9631, '\p{Blk= block_Elements}', "");
    Expect(0, 9631, '\p{^Blk= block_Elements}', "");
    Expect(0, 9631, '\P{Blk= block_Elements}', "");
    Expect(1, 9631, '\P{^Blk= block_Elements}', "");
    Expect(0, 9632, '\p{Blk= block_Elements}', "");
    Expect(1, 9632, '\p{^Blk= block_Elements}', "");
    Expect(1, 9632, '\P{Blk= block_Elements}', "");
    Expect(0, 9632, '\P{^Blk= block_Elements}', "");
    Error('\p{Is_Block=/a/--BLOCK_Elements}');
    Error('\P{Is_Block=/a/--BLOCK_Elements}');
    Expect(1, 9631, '\p{Is_Block=blockelements}', "");
    Expect(0, 9631, '\p{^Is_Block=blockelements}', "");
    Expect(0, 9631, '\P{Is_Block=blockelements}', "");
    Expect(1, 9631, '\P{^Is_Block=blockelements}', "");
    Expect(0, 9632, '\p{Is_Block=blockelements}', "");
    Expect(1, 9632, '\p{^Is_Block=blockelements}', "");
    Expect(1, 9632, '\P{Is_Block=blockelements}', "");
    Expect(0, 9632, '\P{^Is_Block=blockelements}', "");
    Expect(1, 9631, '\p{Is_Block=_Block_Elements}', "");
    Expect(0, 9631, '\p{^Is_Block=_Block_Elements}', "");
    Expect(0, 9631, '\P{Is_Block=_Block_Elements}', "");
    Expect(1, 9631, '\P{^Is_Block=_Block_Elements}', "");
    Expect(0, 9632, '\p{Is_Block=_Block_Elements}', "");
    Expect(1, 9632, '\p{^Is_Block=_Block_Elements}', "");
    Expect(1, 9632, '\P{Is_Block=_Block_Elements}', "");
    Expect(0, 9632, '\P{^Is_Block=_Block_Elements}', "");
    Error('\p{Is_Blk= :=block_Elements}');
    Error('\P{Is_Blk= :=block_Elements}');
    Expect(1, 9631, '\p{Is_Blk=blockelements}', "");
    Expect(0, 9631, '\p{^Is_Blk=blockelements}', "");
    Expect(0, 9631, '\P{Is_Blk=blockelements}', "");
    Expect(1, 9631, '\P{^Is_Blk=blockelements}', "");
    Expect(0, 9632, '\p{Is_Blk=blockelements}', "");
    Expect(1, 9632, '\p{^Is_Blk=blockelements}', "");
    Expect(1, 9632, '\P{Is_Blk=blockelements}', "");
    Expect(0, 9632, '\P{^Is_Blk=blockelements}', "");
    Expect(1, 9631, '\p{Is_Blk=Block_ELEMENTS}', "");
    Expect(0, 9631, '\p{^Is_Blk=Block_ELEMENTS}', "");
    Expect(0, 9631, '\P{Is_Blk=Block_ELEMENTS}', "");
    Expect(1, 9631, '\P{^Is_Blk=Block_ELEMENTS}', "");
    Expect(0, 9632, '\p{Is_Blk=Block_ELEMENTS}', "");
    Expect(1, 9632, '\p{^Is_Blk=Block_ELEMENTS}', "");
    Expect(1, 9632, '\P{Is_Blk=Block_ELEMENTS}', "");
    Expect(0, 9632, '\P{^Is_Blk=Block_ELEMENTS}', "");
    Error('\p{Block=:=	Bopomofo}');
    Error('\P{Block=:=	Bopomofo}');
    Expect(1, 12591, '\p{Block=:\ABopomofo\z:}', "");;
    Expect(0, 12592, '\p{Block=:\ABopomofo\z:}', "");;
    Expect(1, 12591, '\p{Block=bopomofo}', "");
    Expect(0, 12591, '\p{^Block=bopomofo}', "");
    Expect(0, 12591, '\P{Block=bopomofo}', "");
    Expect(1, 12591, '\P{^Block=bopomofo}', "");
    Expect(0, 12592, '\p{Block=bopomofo}', "");
    Expect(1, 12592, '\p{^Block=bopomofo}', "");
    Expect(1, 12592, '\P{Block=bopomofo}', "");
    Expect(0, 12592, '\P{^Block=bopomofo}', "");
    Expect(1, 12591, '\p{Block=:\Abopomofo\z:}', "");;
    Expect(0, 12592, '\p{Block=:\Abopomofo\z:}', "");;
    Expect(1, 12591, '\p{Block:	__BOPOMOFO}', "");
    Expect(0, 12591, '\p{^Block:	__BOPOMOFO}', "");
    Expect(0, 12591, '\P{Block:	__BOPOMOFO}', "");
    Expect(1, 12591, '\P{^Block:	__BOPOMOFO}', "");
    Expect(0, 12592, '\p{Block:	__BOPOMOFO}', "");
    Expect(1, 12592, '\p{^Block:	__BOPOMOFO}', "");
    Expect(1, 12592, '\P{Block:	__BOPOMOFO}', "");
    Expect(0, 12592, '\P{^Block:	__BOPOMOFO}', "");
    Error('\p{Blk=_	Bopomofo/a/}');
    Error('\P{Blk=_	Bopomofo/a/}');
    Expect(1, 12591, '\p{Blk=:\ABopomofo\z:}', "");;
    Expect(0, 12592, '\p{Blk=:\ABopomofo\z:}', "");;
    Expect(1, 12591, '\p{Blk=bopomofo}', "");
    Expect(0, 12591, '\p{^Blk=bopomofo}', "");
    Expect(0, 12591, '\P{Blk=bopomofo}', "");
    Expect(1, 12591, '\P{^Blk=bopomofo}', "");
    Expect(0, 12592, '\p{Blk=bopomofo}', "");
    Expect(1, 12592, '\p{^Blk=bopomofo}', "");
    Expect(1, 12592, '\P{Blk=bopomofo}', "");
    Expect(0, 12592, '\P{^Blk=bopomofo}', "");
    Expect(1, 12591, '\p{Blk=:\Abopomofo\z:}', "");;
    Expect(0, 12592, '\p{Blk=:\Abopomofo\z:}', "");;
    Expect(1, 12591, '\p{Blk:-_Bopomofo}', "");
    Expect(0, 12591, '\p{^Blk:-_Bopomofo}', "");
    Expect(0, 12591, '\P{Blk:-_Bopomofo}', "");
    Expect(1, 12591, '\P{^Blk:-_Bopomofo}', "");
    Expect(0, 12592, '\p{Blk:-_Bopomofo}', "");
    Expect(1, 12592, '\p{^Blk:-_Bopomofo}', "");
    Expect(1, 12592, '\P{Blk:-_Bopomofo}', "");
    Expect(0, 12592, '\P{^Blk:-_Bopomofo}', "");
    Error('\p{Is_Block=_ bopomofo:=}');
    Error('\P{Is_Block=_ bopomofo:=}');
    Expect(1, 12591, '\p{Is_Block=bopomofo}', "");
    Expect(0, 12591, '\p{^Is_Block=bopomofo}', "");
    Expect(0, 12591, '\P{Is_Block=bopomofo}', "");
    Expect(1, 12591, '\P{^Is_Block=bopomofo}', "");
    Expect(0, 12592, '\p{Is_Block=bopomofo}', "");
    Expect(1, 12592, '\p{^Is_Block=bopomofo}', "");
    Expect(1, 12592, '\P{Is_Block=bopomofo}', "");
    Expect(0, 12592, '\P{^Is_Block=bopomofo}', "");
    Expect(1, 12591, '\p{Is_Block=  Bopomofo}', "");
    Expect(0, 12591, '\p{^Is_Block=  Bopomofo}', "");
    Expect(0, 12591, '\P{Is_Block=  Bopomofo}', "");
    Expect(1, 12591, '\P{^Is_Block=  Bopomofo}', "");
    Expect(0, 12592, '\p{Is_Block=  Bopomofo}', "");
    Expect(1, 12592, '\p{^Is_Block=  Bopomofo}', "");
    Expect(1, 12592, '\P{Is_Block=  Bopomofo}', "");
    Expect(0, 12592, '\P{^Is_Block=  Bopomofo}', "");
    Error('\p{Is_Blk=__Bopomofo:=}');
    Error('\P{Is_Blk=__Bopomofo:=}');
    Expect(1, 12591, '\p{Is_Blk=bopomofo}', "");
    Expect(0, 12591, '\p{^Is_Blk=bopomofo}', "");
    Expect(0, 12591, '\P{Is_Blk=bopomofo}', "");
    Expect(1, 12591, '\P{^Is_Blk=bopomofo}', "");
    Expect(0, 12592, '\p{Is_Blk=bopomofo}', "");
    Expect(1, 12592, '\p{^Is_Blk=bopomofo}', "");
    Expect(1, 12592, '\P{Is_Blk=bopomofo}', "");
    Expect(0, 12592, '\P{^Is_Blk=bopomofo}', "");
    Expect(1, 12591, '\p{Is_Blk=-bopomofo}', "");
    Expect(0, 12591, '\p{^Is_Blk=-bopomofo}', "");
    Expect(0, 12591, '\P{Is_Blk=-bopomofo}', "");
    Expect(1, 12591, '\P{^Is_Blk=-bopomofo}', "");
    Expect(0, 12592, '\p{Is_Blk=-bopomofo}', "");
    Expect(1, 12592, '\p{^Is_Blk=-bopomofo}', "");
    Expect(1, 12592, '\P{Is_Blk=-bopomofo}', "");
    Expect(0, 12592, '\P{^Is_Blk=-bopomofo}', "");
    Error('\p{Block=-/a/bopomofo_extended}');
    Error('\P{Block=-/a/bopomofo_extended}');
    Expect(1, 12735, '\p{Block=:\ABopomofo_Extended\z:}', "");;
    Expect(0, 12736, '\p{Block=:\ABopomofo_Extended\z:}', "");;
    Expect(1, 12735, '\p{Block=bopomofoextended}', "");
    Expect(0, 12735, '\p{^Block=bopomofoextended}', "");
    Expect(0, 12735, '\P{Block=bopomofoextended}', "");
    Expect(1, 12735, '\P{^Block=bopomofoextended}', "");
    Expect(0, 12736, '\p{Block=bopomofoextended}', "");
    Expect(1, 12736, '\p{^Block=bopomofoextended}', "");
    Expect(1, 12736, '\P{Block=bopomofoextended}', "");
    Expect(0, 12736, '\P{^Block=bopomofoextended}', "");
    Expect(1, 12735, '\p{Block=:\Abopomofoextended\z:}', "");;
    Expect(0, 12736, '\p{Block=:\Abopomofoextended\z:}', "");;
    Expect(1, 12735, '\p{Block=--bopomofo_Extended}', "");
    Expect(0, 12735, '\p{^Block=--bopomofo_Extended}', "");
    Expect(0, 12735, '\P{Block=--bopomofo_Extended}', "");
    Expect(1, 12735, '\P{^Block=--bopomofo_Extended}', "");
    Expect(0, 12736, '\p{Block=--bopomofo_Extended}', "");
    Expect(1, 12736, '\p{^Block=--bopomofo_Extended}', "");
    Expect(1, 12736, '\P{Block=--bopomofo_Extended}', "");
    Expect(0, 12736, '\P{^Block=--bopomofo_Extended}', "");
    Error('\p{Blk= bopomofo_Ext:=}');
    Error('\P{Blk= bopomofo_Ext:=}');
    Expect(1, 12735, '\p{Blk=:\ABopomofo_Ext\z:}', "");;
    Expect(0, 12736, '\p{Blk=:\ABopomofo_Ext\z:}', "");;
    Expect(1, 12735, '\p{Blk=bopomofoext}', "");
    Expect(0, 12735, '\p{^Blk=bopomofoext}', "");
    Expect(0, 12735, '\P{Blk=bopomofoext}', "");
    Expect(1, 12735, '\P{^Blk=bopomofoext}', "");
    Expect(0, 12736, '\p{Blk=bopomofoext}', "");
    Expect(1, 12736, '\p{^Blk=bopomofoext}', "");
    Expect(1, 12736, '\P{Blk=bopomofoext}', "");
    Expect(0, 12736, '\P{^Blk=bopomofoext}', "");
    Expect(1, 12735, '\p{Blk=:\Abopomofoext\z:}', "");;
    Expect(0, 12736, '\p{Blk=:\Abopomofoext\z:}', "");;
    Expect(1, 12735, '\p{Blk=	BOPOMOFO_EXT}', "");
    Expect(0, 12735, '\p{^Blk=	BOPOMOFO_EXT}', "");
    Expect(0, 12735, '\P{Blk=	BOPOMOFO_EXT}', "");
    Expect(1, 12735, '\P{^Blk=	BOPOMOFO_EXT}', "");
    Expect(0, 12736, '\p{Blk=	BOPOMOFO_EXT}', "");
    Expect(1, 12736, '\p{^Blk=	BOPOMOFO_EXT}', "");
    Expect(1, 12736, '\P{Blk=	BOPOMOFO_EXT}', "");
    Expect(0, 12736, '\P{^Blk=	BOPOMOFO_EXT}', "");
    Error('\p{Is_Block=/a/ Bopomofo_extended}');
    Error('\P{Is_Block=/a/ Bopomofo_extended}');
    Expect(1, 12735, '\p{Is_Block:   bopomofoextended}', "");
    Expect(0, 12735, '\p{^Is_Block:   bopomofoextended}', "");
    Expect(0, 12735, '\P{Is_Block:   bopomofoextended}', "");
    Expect(1, 12735, '\P{^Is_Block:   bopomofoextended}', "");
    Expect(0, 12736, '\p{Is_Block:   bopomofoextended}', "");
    Expect(1, 12736, '\p{^Is_Block:   bopomofoextended}', "");
    Expect(1, 12736, '\P{Is_Block:   bopomofoextended}', "");
    Expect(0, 12736, '\P{^Is_Block:   bopomofoextended}', "");
    Expect(1, 12735, '\p{Is_Block=	 Bopomofo_Extended}', "");
    Expect(0, 12735, '\p{^Is_Block=	 Bopomofo_Extended}', "");
    Expect(0, 12735, '\P{Is_Block=	 Bopomofo_Extended}', "");
    Expect(1, 12735, '\P{^Is_Block=	 Bopomofo_Extended}', "");
    Expect(0, 12736, '\p{Is_Block=	 Bopomofo_Extended}', "");
    Expect(1, 12736, '\p{^Is_Block=	 Bopomofo_Extended}', "");
    Expect(1, 12736, '\P{Is_Block=	 Bopomofo_Extended}', "");
    Expect(0, 12736, '\P{^Is_Block=	 Bopomofo_Extended}', "");
    Error('\p{Is_Blk=/a/ _Bopomofo_Ext}');
    Error('\P{Is_Blk=/a/ _Bopomofo_Ext}');
    Expect(1, 12735, '\p{Is_Blk=bopomofoext}', "");
    Expect(0, 12735, '\p{^Is_Blk=bopomofoext}', "");
    Expect(0, 12735, '\P{Is_Blk=bopomofoext}', "");
    Expect(1, 12735, '\P{^Is_Blk=bopomofoext}', "");
    Expect(0, 12736, '\p{Is_Blk=bopomofoext}', "");
    Expect(1, 12736, '\p{^Is_Blk=bopomofoext}', "");
    Expect(1, 12736, '\P{Is_Blk=bopomofoext}', "");
    Expect(0, 12736, '\P{^Is_Blk=bopomofoext}', "");
    Expect(1, 12735, '\p{Is_Blk=	bopomofo_ext}', "");
    Expect(0, 12735, '\p{^Is_Blk=	bopomofo_ext}', "");
    Expect(0, 12735, '\P{Is_Blk=	bopomofo_ext}', "");
    Expect(1, 12735, '\P{^Is_Blk=	bopomofo_ext}', "");
    Expect(0, 12736, '\p{Is_Blk=	bopomofo_ext}', "");
    Expect(1, 12736, '\p{^Is_Blk=	bopomofo_ext}', "");
    Expect(1, 12736, '\P{Is_Blk=	bopomofo_ext}', "");
    Expect(0, 12736, '\P{^Is_Blk=	bopomofo_ext}', "");
    Error('\p{Block=_BOX_Drawing/a/}');
    Error('\P{Block=_BOX_Drawing/a/}');
    Expect(1, 9599, '\p{Block=:\ABox_Drawing\z:}', "");;
    Expect(0, 9600, '\p{Block=:\ABox_Drawing\z:}', "");;
    Expect(1, 9599, '\p{Block:boxdrawing}', "");
    Expect(0, 9599, '\p{^Block:boxdrawing}', "");
    Expect(0, 9599, '\P{Block:boxdrawing}', "");
    Expect(1, 9599, '\P{^Block:boxdrawing}', "");
    Expect(0, 9600, '\p{Block:boxdrawing}', "");
    Expect(1, 9600, '\p{^Block:boxdrawing}', "");
    Expect(1, 9600, '\P{Block:boxdrawing}', "");
    Expect(0, 9600, '\P{^Block:boxdrawing}', "");
    Expect(1, 9599, '\p{Block=:\Aboxdrawing\z:}', "");;
    Expect(0, 9600, '\p{Block=:\Aboxdrawing\z:}', "");;
    Expect(1, 9599, '\p{Block= 	Box_Drawing}', "");
    Expect(0, 9599, '\p{^Block= 	Box_Drawing}', "");
    Expect(0, 9599, '\P{Block= 	Box_Drawing}', "");
    Expect(1, 9599, '\P{^Block= 	Box_Drawing}', "");
    Expect(0, 9600, '\p{Block= 	Box_Drawing}', "");
    Expect(1, 9600, '\p{^Block= 	Box_Drawing}', "");
    Expect(1, 9600, '\P{Block= 	Box_Drawing}', "");
    Expect(0, 9600, '\P{^Block= 	Box_Drawing}', "");
    Error('\p{Blk=  box_drawing:=}');
    Error('\P{Blk=  box_drawing:=}');
    Expect(1, 9599, '\p{Blk=:\ABox_Drawing\z:}', "");;
    Expect(0, 9600, '\p{Blk=:\ABox_Drawing\z:}', "");;
    Expect(1, 9599, '\p{Blk=boxdrawing}', "");
    Expect(0, 9599, '\p{^Blk=boxdrawing}', "");
    Expect(0, 9599, '\P{Blk=boxdrawing}', "");
    Expect(1, 9599, '\P{^Blk=boxdrawing}', "");
    Expect(0, 9600, '\p{Blk=boxdrawing}', "");
    Expect(1, 9600, '\p{^Blk=boxdrawing}', "");
    Expect(1, 9600, '\P{Blk=boxdrawing}', "");
    Expect(0, 9600, '\P{^Blk=boxdrawing}', "");
    Expect(1, 9599, '\p{Blk=:\Aboxdrawing\z:}', "");;
    Expect(0, 9600, '\p{Blk=:\Aboxdrawing\z:}', "");;
    Expect(1, 9599, '\p{Blk=_ Box_DRAWING}', "");
    Expect(0, 9599, '\p{^Blk=_ Box_DRAWING}', "");
    Expect(0, 9599, '\P{Blk=_ Box_DRAWING}', "");
    Expect(1, 9599, '\P{^Blk=_ Box_DRAWING}', "");
    Expect(0, 9600, '\p{Blk=_ Box_DRAWING}', "");
    Expect(1, 9600, '\p{^Blk=_ Box_DRAWING}', "");
    Expect(1, 9600, '\P{Blk=_ Box_DRAWING}', "");
    Expect(0, 9600, '\P{^Blk=_ Box_DRAWING}', "");
    Error('\p{Is_Block=-BOX_drawing/a/}');
    Error('\P{Is_Block=-BOX_drawing/a/}');
    Expect(1, 9599, '\p{Is_Block=boxdrawing}', "");
    Expect(0, 9599, '\p{^Is_Block=boxdrawing}', "");
    Expect(0, 9599, '\P{Is_Block=boxdrawing}', "");
    Expect(1, 9599, '\P{^Is_Block=boxdrawing}', "");
    Expect(0, 9600, '\p{Is_Block=boxdrawing}', "");
    Expect(1, 9600, '\p{^Is_Block=boxdrawing}', "");
    Expect(1, 9600, '\P{Is_Block=boxdrawing}', "");
    Expect(0, 9600, '\P{^Is_Block=boxdrawing}', "");
    Expect(1, 9599, '\p{Is_Block=_BOX_DRAWING}', "");
    Expect(0, 9599, '\p{^Is_Block=_BOX_DRAWING}', "");
    Expect(0, 9599, '\P{Is_Block=_BOX_DRAWING}', "");
    Expect(1, 9599, '\P{^Is_Block=_BOX_DRAWING}', "");
    Expect(0, 9600, '\p{Is_Block=_BOX_DRAWING}', "");
    Expect(1, 9600, '\p{^Is_Block=_BOX_DRAWING}', "");
    Expect(1, 9600, '\P{Is_Block=_BOX_DRAWING}', "");
    Expect(0, 9600, '\P{^Is_Block=_BOX_DRAWING}', "");
    Error('\p{Is_Blk=-/a/box_DRAWING}');
    Error('\P{Is_Blk=-/a/box_DRAWING}');
    Expect(1, 9599, '\p{Is_Blk=boxdrawing}', "");
    Expect(0, 9599, '\p{^Is_Blk=boxdrawing}', "");
    Expect(0, 9599, '\P{Is_Blk=boxdrawing}', "");
    Expect(1, 9599, '\P{^Is_Blk=boxdrawing}', "");
    Expect(0, 9600, '\p{Is_Blk=boxdrawing}', "");
    Expect(1, 9600, '\p{^Is_Blk=boxdrawing}', "");
    Expect(1, 9600, '\P{Is_Blk=boxdrawing}', "");
    Expect(0, 9600, '\P{^Is_Blk=boxdrawing}', "");
    Expect(1, 9599, '\p{Is_Blk=	-Box_Drawing}', "");
    Expect(0, 9599, '\p{^Is_Blk=	-Box_Drawing}', "");
    Expect(0, 9599, '\P{Is_Blk=	-Box_Drawing}', "");
    Expect(1, 9599, '\P{^Is_Blk=	-Box_Drawing}', "");
    Expect(0, 9600, '\p{Is_Blk=	-Box_Drawing}', "");
    Expect(1, 9600, '\p{^Is_Blk=	-Box_Drawing}', "");
    Expect(1, 9600, '\P{Is_Blk=	-Box_Drawing}', "");
    Expect(0, 9600, '\P{^Is_Blk=	-Box_Drawing}', "");
    Error('\p{Block=_/a/Brahmi}');
    Error('\P{Block=_/a/Brahmi}');
    Expect(1, 69759, '\p{Block=:\ABrahmi\z:}', "");;
    Expect(0, 69760, '\p{Block=:\ABrahmi\z:}', "");;
    Expect(1, 69759, '\p{Block=brahmi}', "");
    Expect(0, 69759, '\p{^Block=brahmi}', "");
    Expect(0, 69759, '\P{Block=brahmi}', "");
    Expect(1, 69759, '\P{^Block=brahmi}', "");
    Expect(0, 69760, '\p{Block=brahmi}', "");
    Expect(1, 69760, '\p{^Block=brahmi}', "");
    Expect(1, 69760, '\P{Block=brahmi}', "");
    Expect(0, 69760, '\P{^Block=brahmi}', "");
    Expect(1, 69759, '\p{Block=:\Abrahmi\z:}', "");;
    Expect(0, 69760, '\p{Block=:\Abrahmi\z:}', "");;
    Expect(1, 69759, '\p{Block=	_Brahmi}', "");
    Expect(0, 69759, '\p{^Block=	_Brahmi}', "");
    Expect(0, 69759, '\P{Block=	_Brahmi}', "");
    Expect(1, 69759, '\P{^Block=	_Brahmi}', "");
    Expect(0, 69760, '\p{Block=	_Brahmi}', "");
    Expect(1, 69760, '\p{^Block=	_Brahmi}', "");
    Expect(1, 69760, '\P{Block=	_Brahmi}', "");
    Expect(0, 69760, '\P{^Block=	_Brahmi}', "");
    Error('\p{Blk=/a/-Brahmi}');
    Error('\P{Blk=/a/-Brahmi}');
    Expect(1, 69759, '\p{Blk=:\ABrahmi\z:}', "");;
    Expect(0, 69760, '\p{Blk=:\ABrahmi\z:}', "");;
    Expect(1, 69759, '\p{Blk=brahmi}', "");
    Expect(0, 69759, '\p{^Blk=brahmi}', "");
    Expect(0, 69759, '\P{Blk=brahmi}', "");
    Expect(1, 69759, '\P{^Blk=brahmi}', "");
    Expect(0, 69760, '\p{Blk=brahmi}', "");
    Expect(1, 69760, '\p{^Blk=brahmi}', "");
    Expect(1, 69760, '\P{Blk=brahmi}', "");
    Expect(0, 69760, '\P{^Blk=brahmi}', "");
    Expect(1, 69759, '\p{Blk=:\Abrahmi\z:}', "");;
    Expect(0, 69760, '\p{Blk=:\Abrahmi\z:}', "");;
    Expect(1, 69759, '\p{Blk=	brahmi}', "");
    Expect(0, 69759, '\p{^Blk=	brahmi}', "");
    Expect(0, 69759, '\P{Blk=	brahmi}', "");
    Expect(1, 69759, '\P{^Blk=	brahmi}', "");
    Expect(0, 69760, '\p{Blk=	brahmi}', "");
    Expect(1, 69760, '\p{^Blk=	brahmi}', "");
    Expect(1, 69760, '\P{Blk=	brahmi}', "");
    Expect(0, 69760, '\P{^Blk=	brahmi}', "");
    Error('\p{Is_Block=_:=Brahmi}');
    Error('\P{Is_Block=_:=Brahmi}');
    Expect(1, 69759, '\p{Is_Block=brahmi}', "");
    Expect(0, 69759, '\p{^Is_Block=brahmi}', "");
    Expect(0, 69759, '\P{Is_Block=brahmi}', "");
    Expect(1, 69759, '\P{^Is_Block=brahmi}', "");
    Expect(0, 69760, '\p{Is_Block=brahmi}', "");
    Expect(1, 69760, '\p{^Is_Block=brahmi}', "");
    Expect(1, 69760, '\P{Is_Block=brahmi}', "");
    Expect(0, 69760, '\P{^Is_Block=brahmi}', "");
    Expect(1, 69759, '\p{Is_Block: _ Brahmi}', "");
    Expect(0, 69759, '\p{^Is_Block: _ Brahmi}', "");
    Expect(0, 69759, '\P{Is_Block: _ Brahmi}', "");
    Expect(1, 69759, '\P{^Is_Block: _ Brahmi}', "");
    Expect(0, 69760, '\p{Is_Block: _ Brahmi}', "");
    Expect(1, 69760, '\p{^Is_Block: _ Brahmi}', "");
    Expect(1, 69760, '\P{Is_Block: _ Brahmi}', "");
    Expect(0, 69760, '\P{^Is_Block: _ Brahmi}', "");
    Error('\p{Is_Blk=:=_-Brahmi}');
    Error('\P{Is_Blk=:=_-Brahmi}');
    Expect(1, 69759, '\p{Is_Blk=brahmi}', "");
    Expect(0, 69759, '\p{^Is_Blk=brahmi}', "");
    Expect(0, 69759, '\P{Is_Blk=brahmi}', "");
    Expect(1, 69759, '\P{^Is_Blk=brahmi}', "");
    Expect(0, 69760, '\p{Is_Blk=brahmi}', "");
    Expect(1, 69760, '\p{^Is_Blk=brahmi}', "");
    Expect(1, 69760, '\P{Is_Blk=brahmi}', "");
    Expect(0, 69760, '\P{^Is_Blk=brahmi}', "");
    Expect(1, 69759, '\p{Is_Blk=- Brahmi}', "");
    Expect(0, 69759, '\p{^Is_Blk=- Brahmi}', "");
    Expect(0, 69759, '\P{Is_Blk=- Brahmi}', "");
    Expect(1, 69759, '\P{^Is_Blk=- Brahmi}', "");
    Expect(0, 69760, '\p{Is_Blk=- Brahmi}', "");
    Expect(1, 69760, '\p{^Is_Blk=- Brahmi}', "");
    Expect(1, 69760, '\P{Is_Blk=- Brahmi}', "");
    Expect(0, 69760, '\P{^Is_Blk=- Brahmi}', "");
    Error('\p{Block:  -braille_patterns/a/}');
    Error('\P{Block:  -braille_patterns/a/}');
    Expect(1, 10495, '\p{Block=:\ABraille_Patterns\z:}', "");;
    Expect(0, 10496, '\p{Block=:\ABraille_Patterns\z:}', "");;
    Expect(1, 10495, '\p{Block=braillepatterns}', "");
    Expect(0, 10495, '\p{^Block=braillepatterns}', "");
    Expect(0, 10495, '\P{Block=braillepatterns}', "");
    Expect(1, 10495, '\P{^Block=braillepatterns}', "");
    Expect(0, 10496, '\p{Block=braillepatterns}', "");
    Expect(1, 10496, '\p{^Block=braillepatterns}', "");
    Expect(1, 10496, '\P{Block=braillepatterns}', "");
    Expect(0, 10496, '\P{^Block=braillepatterns}', "");
    Expect(1, 10495, '\p{Block=:\Abraillepatterns\z:}', "");;
    Expect(0, 10496, '\p{Block=:\Abraillepatterns\z:}', "");;
    Expect(1, 10495, '\p{Block=--braille_Patterns}', "");
    Expect(0, 10495, '\p{^Block=--braille_Patterns}', "");
    Expect(0, 10495, '\P{Block=--braille_Patterns}', "");
    Expect(1, 10495, '\P{^Block=--braille_Patterns}', "");
    Expect(0, 10496, '\p{Block=--braille_Patterns}', "");
    Expect(1, 10496, '\p{^Block=--braille_Patterns}', "");
    Expect(1, 10496, '\P{Block=--braille_Patterns}', "");
    Expect(0, 10496, '\P{^Block=--braille_Patterns}', "");
    Error('\p{Blk=  Braille/a/}');
    Error('\P{Blk=  Braille/a/}');
    Expect(1, 10495, '\p{Blk=:\ABraille\z:}', "");;
    Expect(0, 10496, '\p{Blk=:\ABraille\z:}', "");;
    Expect(1, 10495, '\p{Blk=braille}', "");
    Expect(0, 10495, '\p{^Blk=braille}', "");
    Expect(0, 10495, '\P{Blk=braille}', "");
    Expect(1, 10495, '\P{^Blk=braille}', "");
    Expect(0, 10496, '\p{Blk=braille}', "");
    Expect(1, 10496, '\p{^Blk=braille}', "");
    Expect(1, 10496, '\P{Blk=braille}', "");
    Expect(0, 10496, '\P{^Blk=braille}', "");
    Expect(1, 10495, '\p{Blk=:\Abraille\z:}', "");;
    Expect(0, 10496, '\p{Blk=:\Abraille\z:}', "");;
    Expect(1, 10495, '\p{Blk= BRAILLE}', "");
    Expect(0, 10495, '\p{^Blk= BRAILLE}', "");
    Expect(0, 10495, '\P{Blk= BRAILLE}', "");
    Expect(1, 10495, '\P{^Blk= BRAILLE}', "");
    Expect(0, 10496, '\p{Blk= BRAILLE}', "");
    Expect(1, 10496, '\p{^Blk= BRAILLE}', "");
    Expect(1, 10496, '\P{Blk= BRAILLE}', "");
    Expect(0, 10496, '\P{^Blk= BRAILLE}', "");
    Error('\p{Is_Block=:=	 Braille_patterns}');
    Error('\P{Is_Block=:=	 Braille_patterns}');
    Expect(1, 10495, '\p{Is_Block=braillepatterns}', "");
    Expect(0, 10495, '\p{^Is_Block=braillepatterns}', "");
    Expect(0, 10495, '\P{Is_Block=braillepatterns}', "");
    Expect(1, 10495, '\P{^Is_Block=braillepatterns}', "");
    Expect(0, 10496, '\p{Is_Block=braillepatterns}', "");
    Expect(1, 10496, '\p{^Is_Block=braillepatterns}', "");
    Expect(1, 10496, '\P{Is_Block=braillepatterns}', "");
    Expect(0, 10496, '\P{^Is_Block=braillepatterns}', "");
    Expect(1, 10495, '\p{Is_Block= _braille_PATTERNS}', "");
    Expect(0, 10495, '\p{^Is_Block= _braille_PATTERNS}', "");
    Expect(0, 10495, '\P{Is_Block= _braille_PATTERNS}', "");
    Expect(1, 10495, '\P{^Is_Block= _braille_PATTERNS}', "");
    Expect(0, 10496, '\p{Is_Block= _braille_PATTERNS}', "");
    Expect(1, 10496, '\p{^Is_Block= _braille_PATTERNS}', "");
    Expect(1, 10496, '\P{Is_Block= _braille_PATTERNS}', "");
    Expect(0, 10496, '\P{^Is_Block= _braille_PATTERNS}', "");
    Error('\p{Is_Blk=:=-braille}');
    Error('\P{Is_Blk=:=-braille}');
    Expect(1, 10495, '\p{Is_Blk=braille}', "");
    Expect(0, 10495, '\p{^Is_Blk=braille}', "");
    Expect(0, 10495, '\P{Is_Blk=braille}', "");
    Expect(1, 10495, '\P{^Is_Blk=braille}', "");
    Expect(0, 10496, '\p{Is_Blk=braille}', "");
    Expect(1, 10496, '\p{^Is_Blk=braille}', "");
    Expect(1, 10496, '\P{Is_Blk=braille}', "");
    Expect(0, 10496, '\P{^Is_Blk=braille}', "");
    Expect(1, 10495, '\p{Is_Blk= braille}', "");
    Expect(0, 10495, '\p{^Is_Blk= braille}', "");
    Expect(0, 10495, '\P{Is_Blk= braille}', "");
    Expect(1, 10495, '\P{^Is_Blk= braille}', "");
    Expect(0, 10496, '\p{Is_Blk= braille}', "");
    Expect(1, 10496, '\p{^Is_Blk= braille}', "");
    Expect(1, 10496, '\P{Is_Blk= braille}', "");
    Expect(0, 10496, '\P{^Is_Blk= braille}', "");
    Error('\p{Block: :=	BUGINESE}');
    Error('\P{Block: :=	BUGINESE}');
    Expect(1, 6687, '\p{Block=:\ABuginese\z:}', "");;
    Expect(0, 6688, '\p{Block=:\ABuginese\z:}', "");;
    Expect(1, 6687, '\p{Block=buginese}', "");
    Expect(0, 6687, '\p{^Block=buginese}', "");
    Expect(0, 6687, '\P{Block=buginese}', "");
    Expect(1, 6687, '\P{^Block=buginese}', "");
    Expect(0, 6688, '\p{Block=buginese}', "");
    Expect(1, 6688, '\p{^Block=buginese}', "");
    Expect(1, 6688, '\P{Block=buginese}', "");
    Expect(0, 6688, '\P{^Block=buginese}', "");
    Expect(1, 6687, '\p{Block=:\Abuginese\z:}', "");;
    Expect(0, 6688, '\p{Block=:\Abuginese\z:}', "");;
    Expect(1, 6687, '\p{Block=- buginese}', "");
    Expect(0, 6687, '\p{^Block=- buginese}', "");
    Expect(0, 6687, '\P{Block=- buginese}', "");
    Expect(1, 6687, '\P{^Block=- buginese}', "");
    Expect(0, 6688, '\p{Block=- buginese}', "");
    Expect(1, 6688, '\p{^Block=- buginese}', "");
    Expect(1, 6688, '\P{Block=- buginese}', "");
    Expect(0, 6688, '\P{^Block=- buginese}', "");
    Error('\p{Blk= Buginese/a/}');
    Error('\P{Blk= Buginese/a/}');
    Expect(1, 6687, '\p{Blk=:\ABuginese\z:}', "");;
    Expect(0, 6688, '\p{Blk=:\ABuginese\z:}', "");;
    Expect(1, 6687, '\p{Blk=buginese}', "");
    Expect(0, 6687, '\p{^Blk=buginese}', "");
    Expect(0, 6687, '\P{Blk=buginese}', "");
    Expect(1, 6687, '\P{^Blk=buginese}', "");
    Expect(0, 6688, '\p{Blk=buginese}', "");
    Expect(1, 6688, '\p{^Blk=buginese}', "");
    Expect(1, 6688, '\P{Blk=buginese}', "");
    Expect(0, 6688, '\P{^Blk=buginese}', "");
    Expect(1, 6687, '\p{Blk=:\Abuginese\z:}', "");;
    Expect(0, 6688, '\p{Blk=:\Abuginese\z:}', "");;
    Expect(1, 6687, '\p{Blk=--Buginese}', "");
    Expect(0, 6687, '\p{^Blk=--Buginese}', "");
    Expect(0, 6687, '\P{Blk=--Buginese}', "");
    Expect(1, 6687, '\P{^Blk=--Buginese}', "");
    Expect(0, 6688, '\p{Blk=--Buginese}', "");
    Expect(1, 6688, '\p{^Blk=--Buginese}', "");
    Expect(1, 6688, '\P{Blk=--Buginese}', "");
    Expect(0, 6688, '\P{^Blk=--Buginese}', "");
    Error('\p{Is_Block=:=-	Buginese}');
    Error('\P{Is_Block=:=-	Buginese}');
    Expect(1, 6687, '\p{Is_Block=buginese}', "");
    Expect(0, 6687, '\p{^Is_Block=buginese}', "");
    Expect(0, 6687, '\P{Is_Block=buginese}', "");
    Expect(1, 6687, '\P{^Is_Block=buginese}', "");
    Expect(0, 6688, '\p{Is_Block=buginese}', "");
    Expect(1, 6688, '\p{^Is_Block=buginese}', "");
    Expect(1, 6688, '\P{Is_Block=buginese}', "");
    Expect(0, 6688, '\P{^Is_Block=buginese}', "");
    Expect(1, 6687, '\p{Is_Block=-Buginese}', "");
    Expect(0, 6687, '\p{^Is_Block=-Buginese}', "");
    Expect(0, 6687, '\P{Is_Block=-Buginese}', "");
    Expect(1, 6687, '\P{^Is_Block=-Buginese}', "");
    Expect(0, 6688, '\p{Is_Block=-Buginese}', "");
    Expect(1, 6688, '\p{^Is_Block=-Buginese}', "");
    Expect(1, 6688, '\P{Is_Block=-Buginese}', "");
    Expect(0, 6688, '\P{^Is_Block=-Buginese}', "");
    Error('\p{Is_Blk=_buginese/a/}');
    Error('\P{Is_Blk=_buginese/a/}');
    Expect(1, 6687, '\p{Is_Blk=buginese}', "");
    Expect(0, 6687, '\p{^Is_Blk=buginese}', "");
    Expect(0, 6687, '\P{Is_Blk=buginese}', "");
    Expect(1, 6687, '\P{^Is_Blk=buginese}', "");
    Expect(0, 6688, '\p{Is_Blk=buginese}', "");
    Expect(1, 6688, '\p{^Is_Blk=buginese}', "");
    Expect(1, 6688, '\P{Is_Blk=buginese}', "");
    Expect(0, 6688, '\P{^Is_Blk=buginese}', "");
    Expect(1, 6687, '\p{Is_Blk: _Buginese}', "");
    Expect(0, 6687, '\p{^Is_Blk: _Buginese}', "");
    Expect(0, 6687, '\P{Is_Blk: _Buginese}', "");
    Expect(1, 6687, '\P{^Is_Blk: _Buginese}', "");
    Expect(0, 6688, '\p{Is_Blk: _Buginese}', "");
    Expect(1, 6688, '\p{^Is_Blk: _Buginese}', "");
    Expect(1, 6688, '\P{Is_Blk: _Buginese}', "");
    Expect(0, 6688, '\P{^Is_Blk: _Buginese}', "");
    Error('\p{Block=/a/ 	Buhid}');
    Error('\P{Block=/a/ 	Buhid}');
    Expect(1, 5983, '\p{Block=:\ABuhid\z:}', "");;
    Expect(0, 5984, '\p{Block=:\ABuhid\z:}', "");;
    Expect(1, 5983, '\p{Block=buhid}', "");
    Expect(0, 5983, '\p{^Block=buhid}', "");
    Expect(0, 5983, '\P{Block=buhid}', "");
    Expect(1, 5983, '\P{^Block=buhid}', "");
    Expect(0, 5984, '\p{Block=buhid}', "");
    Expect(1, 5984, '\p{^Block=buhid}', "");
    Expect(1, 5984, '\P{Block=buhid}', "");
    Expect(0, 5984, '\P{^Block=buhid}', "");
    Expect(1, 5983, '\p{Block=:\Abuhid\z:}', "");;
    Expect(0, 5984, '\p{Block=:\Abuhid\z:}', "");;
    Expect(1, 5983, '\p{Block=BUHID}', "");
    Expect(0, 5983, '\p{^Block=BUHID}', "");
    Expect(0, 5983, '\P{Block=BUHID}', "");
    Expect(1, 5983, '\P{^Block=BUHID}', "");
    Expect(0, 5984, '\p{Block=BUHID}', "");
    Expect(1, 5984, '\p{^Block=BUHID}', "");
    Expect(1, 5984, '\P{Block=BUHID}', "");
    Expect(0, 5984, '\P{^Block=BUHID}', "");
    Error('\p{Blk=/a/	 buhid}');
    Error('\P{Blk=/a/	 buhid}');
    Expect(1, 5983, '\p{Blk=:\ABuhid\z:}', "");;
    Expect(0, 5984, '\p{Blk=:\ABuhid\z:}', "");;
    Expect(1, 5983, '\p{Blk=buhid}', "");
    Expect(0, 5983, '\p{^Blk=buhid}', "");
    Expect(0, 5983, '\P{Blk=buhid}', "");
    Expect(1, 5983, '\P{^Blk=buhid}', "");
    Expect(0, 5984, '\p{Blk=buhid}', "");
    Expect(1, 5984, '\p{^Blk=buhid}', "");
    Expect(1, 5984, '\P{Blk=buhid}', "");
    Expect(0, 5984, '\P{^Blk=buhid}', "");
    Expect(1, 5983, '\p{Blk=:\Abuhid\z:}', "");;
    Expect(0, 5984, '\p{Blk=:\Abuhid\z:}', "");;
    Expect(1, 5983, '\p{Blk= Buhid}', "");
    Expect(0, 5983, '\p{^Blk= Buhid}', "");
    Expect(0, 5983, '\P{Blk= Buhid}', "");
    Expect(1, 5983, '\P{^Blk= Buhid}', "");
    Expect(0, 5984, '\p{Blk= Buhid}', "");
    Expect(1, 5984, '\p{^Blk= Buhid}', "");
    Expect(1, 5984, '\P{Blk= Buhid}', "");
    Expect(0, 5984, '\P{^Blk= Buhid}', "");
    Error('\p{Is_Block=/a/-	BUHID}');
    Error('\P{Is_Block=/a/-	BUHID}');
    Expect(1, 5983, '\p{Is_Block=buhid}', "");
    Expect(0, 5983, '\p{^Is_Block=buhid}', "");
    Expect(0, 5983, '\P{Is_Block=buhid}', "");
    Expect(1, 5983, '\P{^Is_Block=buhid}', "");
    Expect(0, 5984, '\p{Is_Block=buhid}', "");
    Expect(1, 5984, '\p{^Is_Block=buhid}', "");
    Expect(1, 5984, '\P{Is_Block=buhid}', "");
    Expect(0, 5984, '\P{^Is_Block=buhid}', "");
    Expect(1, 5983, '\p{Is_Block=_-BUHID}', "");
    Expect(0, 5983, '\p{^Is_Block=_-BUHID}', "");
    Expect(0, 5983, '\P{Is_Block=_-BUHID}', "");
    Expect(1, 5983, '\P{^Is_Block=_-BUHID}', "");
    Expect(0, 5984, '\p{Is_Block=_-BUHID}', "");
    Expect(1, 5984, '\p{^Is_Block=_-BUHID}', "");
    Expect(1, 5984, '\P{Is_Block=_-BUHID}', "");
    Expect(0, 5984, '\P{^Is_Block=_-BUHID}', "");
    Error('\p{Is_Blk= Buhid/a/}');
    Error('\P{Is_Blk= Buhid/a/}');
    Expect(1, 5983, '\p{Is_Blk=buhid}', "");
    Expect(0, 5983, '\p{^Is_Blk=buhid}', "");
    Expect(0, 5983, '\P{Is_Blk=buhid}', "");
    Expect(1, 5983, '\P{^Is_Blk=buhid}', "");
    Expect(0, 5984, '\p{Is_Blk=buhid}', "");
    Expect(1, 5984, '\p{^Is_Blk=buhid}', "");
    Expect(1, 5984, '\P{Is_Blk=buhid}', "");
    Expect(0, 5984, '\P{^Is_Blk=buhid}', "");
    Expect(1, 5983, '\p{Is_Blk:	 BUHID}', "");
    Expect(0, 5983, '\p{^Is_Blk:	 BUHID}', "");
    Expect(0, 5983, '\P{Is_Blk:	 BUHID}', "");
    Expect(1, 5983, '\P{^Is_Blk:	 BUHID}', "");
    Expect(0, 5984, '\p{Is_Blk:	 BUHID}', "");
    Expect(1, 5984, '\p{^Is_Blk:	 BUHID}', "");
    Expect(1, 5984, '\P{Is_Blk:	 BUHID}', "");
    Expect(0, 5984, '\P{^Is_Blk:	 BUHID}', "");
    Error('\p{Block=  Byzantine_Musical_symbols/a/}');
    Error('\P{Block=  Byzantine_Musical_symbols/a/}');
    Expect(1, 119039, '\p{Block=:\AByzantine_Musical_Symbols\z:}', "");;
    Expect(0, 119040, '\p{Block=:\AByzantine_Musical_Symbols\z:}', "");;
    Expect(1, 119039, '\p{Block:byzantinemusicalsymbols}', "");
    Expect(0, 119039, '\p{^Block:byzantinemusicalsymbols}', "");
    Expect(0, 119039, '\P{Block:byzantinemusicalsymbols}', "");
    Expect(1, 119039, '\P{^Block:byzantinemusicalsymbols}', "");
    Expect(0, 119040, '\p{Block:byzantinemusicalsymbols}', "");
    Expect(1, 119040, '\p{^Block:byzantinemusicalsymbols}', "");
    Expect(1, 119040, '\P{Block:byzantinemusicalsymbols}', "");
    Expect(0, 119040, '\P{^Block:byzantinemusicalsymbols}', "");
    Expect(1, 119039, '\p{Block=:\Abyzantinemusicalsymbols\z:}', "");;
    Expect(0, 119040, '\p{Block=:\Abyzantinemusicalsymbols\z:}', "");;
    Expect(1, 119039, '\p{Block:		Byzantine_Musical_Symbols}', "");
    Expect(0, 119039, '\p{^Block:		Byzantine_Musical_Symbols}', "");
    Expect(0, 119039, '\P{Block:		Byzantine_Musical_Symbols}', "");
    Expect(1, 119039, '\P{^Block:		Byzantine_Musical_Symbols}', "");
    Expect(0, 119040, '\p{Block:		Byzantine_Musical_Symbols}', "");
    Expect(1, 119040, '\p{^Block:		Byzantine_Musical_Symbols}', "");
    Expect(1, 119040, '\P{Block:		Byzantine_Musical_Symbols}', "");
    Expect(0, 119040, '\P{^Block:		Byzantine_Musical_Symbols}', "");
    Error('\p{Blk=_Byzantine_music/a/}');
    Error('\P{Blk=_Byzantine_music/a/}');
    Expect(1, 119039, '\p{Blk=:\AByzantine_Music\z:}', "");;
    Expect(0, 119040, '\p{Blk=:\AByzantine_Music\z:}', "");;
    Expect(1, 119039, '\p{Blk=byzantinemusic}', "");
    Expect(0, 119039, '\p{^Blk=byzantinemusic}', "");
    Expect(0, 119039, '\P{Blk=byzantinemusic}', "");
    Expect(1, 119039, '\P{^Blk=byzantinemusic}', "");
    Expect(0, 119040, '\p{Blk=byzantinemusic}', "");
    Expect(1, 119040, '\p{^Blk=byzantinemusic}', "");
    Expect(1, 119040, '\P{Blk=byzantinemusic}', "");
    Expect(0, 119040, '\P{^Blk=byzantinemusic}', "");
    Expect(1, 119039, '\p{Blk=:\Abyzantinemusic\z:}', "");;
    Expect(0, 119040, '\p{Blk=:\Abyzantinemusic\z:}', "");;
    Expect(1, 119039, '\p{Blk= byzantine_music}', "");
    Expect(0, 119039, '\p{^Blk= byzantine_music}', "");
    Expect(0, 119039, '\P{Blk= byzantine_music}', "");
    Expect(1, 119039, '\P{^Blk= byzantine_music}', "");
    Expect(0, 119040, '\p{Blk= byzantine_music}', "");
    Expect(1, 119040, '\p{^Blk= byzantine_music}', "");
    Expect(1, 119040, '\P{Blk= byzantine_music}', "");
    Expect(0, 119040, '\P{^Blk= byzantine_music}', "");
    Error('\p{Is_Block=/a/	-Byzantine_Musical_Symbols}');
    Error('\P{Is_Block=/a/	-Byzantine_Musical_Symbols}');
    Expect(1, 119039, '\p{Is_Block=byzantinemusicalsymbols}', "");
    Expect(0, 119039, '\p{^Is_Block=byzantinemusicalsymbols}', "");
    Expect(0, 119039, '\P{Is_Block=byzantinemusicalsymbols}', "");
    Expect(1, 119039, '\P{^Is_Block=byzantinemusicalsymbols}', "");
    Expect(0, 119040, '\p{Is_Block=byzantinemusicalsymbols}', "");
    Expect(1, 119040, '\p{^Is_Block=byzantinemusicalsymbols}', "");
    Expect(1, 119040, '\P{Is_Block=byzantinemusicalsymbols}', "");
    Expect(0, 119040, '\P{^Is_Block=byzantinemusicalsymbols}', "");
    Expect(1, 119039, '\p{Is_Block=		Byzantine_Musical_SYMBOLS}', "");
    Expect(0, 119039, '\p{^Is_Block=		Byzantine_Musical_SYMBOLS}', "");
    Expect(0, 119039, '\P{Is_Block=		Byzantine_Musical_SYMBOLS}', "");
    Expect(1, 119039, '\P{^Is_Block=		Byzantine_Musical_SYMBOLS}', "");
    Expect(0, 119040, '\p{Is_Block=		Byzantine_Musical_SYMBOLS}', "");
    Expect(1, 119040, '\p{^Is_Block=		Byzantine_Musical_SYMBOLS}', "");
    Expect(1, 119040, '\P{Is_Block=		Byzantine_Musical_SYMBOLS}', "");
    Expect(0, 119040, '\P{^Is_Block=		Byzantine_Musical_SYMBOLS}', "");
    Error('\p{Is_Blk=_	byzantine_Music:=}');
    Error('\P{Is_Blk=_	byzantine_Music:=}');
    Expect(1, 119039, '\p{Is_Blk=byzantinemusic}', "");
    Expect(0, 119039, '\p{^Is_Blk=byzantinemusic}', "");
    Expect(0, 119039, '\P{Is_Blk=byzantinemusic}', "");
    Expect(1, 119039, '\P{^Is_Blk=byzantinemusic}', "");
    Expect(0, 119040, '\p{Is_Blk=byzantinemusic}', "");
    Expect(1, 119040, '\p{^Is_Blk=byzantinemusic}', "");
    Expect(1, 119040, '\P{Is_Blk=byzantinemusic}', "");
    Expect(0, 119040, '\P{^Is_Blk=byzantinemusic}', "");
    Expect(1, 119039, '\p{Is_Blk=byzantine_MUSIC}', "");
    Expect(0, 119039, '\p{^Is_Blk=byzantine_MUSIC}', "");
    Expect(0, 119039, '\P{Is_Blk=byzantine_MUSIC}', "");
    Expect(1, 119039, '\P{^Is_Blk=byzantine_MUSIC}', "");
    Expect(0, 119040, '\p{Is_Blk=byzantine_MUSIC}', "");
    Expect(1, 119040, '\p{^Is_Blk=byzantine_MUSIC}', "");
    Expect(1, 119040, '\P{Is_Blk=byzantine_MUSIC}', "");
    Expect(0, 119040, '\P{^Is_Blk=byzantine_MUSIC}', "");
    Error('\p{Block=_/a/Carian}');
    Error('\P{Block=_/a/Carian}');
    Expect(1, 66271, '\p{Block=:\ACarian\z:}', "");;
    Expect(0, 66272, '\p{Block=:\ACarian\z:}', "");;
    Expect(1, 66271, '\p{Block=carian}', "");
    Expect(0, 66271, '\p{^Block=carian}', "");
    Expect(0, 66271, '\P{Block=carian}', "");
    Expect(1, 66271, '\P{^Block=carian}', "");
    Expect(0, 66272, '\p{Block=carian}', "");
    Expect(1, 66272, '\p{^Block=carian}', "");
    Expect(1, 66272, '\P{Block=carian}', "");
    Expect(0, 66272, '\P{^Block=carian}', "");
    Expect(1, 66271, '\p{Block=:\Acarian\z:}', "");;
    Expect(0, 66272, '\p{Block=:\Acarian\z:}', "");;
    Expect(1, 66271, '\p{Block=_-CARIAN}', "");
    Expect(0, 66271, '\p{^Block=_-CARIAN}', "");
    Expect(0, 66271, '\P{Block=_-CARIAN}', "");
    Expect(1, 66271, '\P{^Block=_-CARIAN}', "");
    Expect(0, 66272, '\p{Block=_-CARIAN}', "");
    Expect(1, 66272, '\p{^Block=_-CARIAN}', "");
    Expect(1, 66272, '\P{Block=_-CARIAN}', "");
    Expect(0, 66272, '\P{^Block=_-CARIAN}', "");
    Error('\p{Blk=_:=CARIAN}');
    Error('\P{Blk=_:=CARIAN}');
    Expect(1, 66271, '\p{Blk=:\ACarian\z:}', "");;
    Expect(0, 66272, '\p{Blk=:\ACarian\z:}', "");;
    Expect(1, 66271, '\p{Blk=carian}', "");
    Expect(0, 66271, '\p{^Blk=carian}', "");
    Expect(0, 66271, '\P{Blk=carian}', "");
    Expect(1, 66271, '\P{^Blk=carian}', "");
    Expect(0, 66272, '\p{Blk=carian}', "");
    Expect(1, 66272, '\p{^Blk=carian}', "");
    Expect(1, 66272, '\P{Blk=carian}', "");
    Expect(0, 66272, '\P{^Blk=carian}', "");
    Expect(1, 66271, '\p{Blk=:\Acarian\z:}', "");;
    Expect(0, 66272, '\p{Blk=:\Acarian\z:}', "");;
    Expect(1, 66271, '\p{Blk: _	Carian}', "");
    Expect(0, 66271, '\p{^Blk: _	Carian}', "");
    Expect(0, 66271, '\P{Blk: _	Carian}', "");
    Expect(1, 66271, '\P{^Blk: _	Carian}', "");
    Expect(0, 66272, '\p{Blk: _	Carian}', "");
    Expect(1, 66272, '\p{^Blk: _	Carian}', "");
    Expect(1, 66272, '\P{Blk: _	Carian}', "");
    Expect(0, 66272, '\P{^Blk: _	Carian}', "");
    Error('\p{Is_Block=-/a/CARIAN}');
    Error('\P{Is_Block=-/a/CARIAN}');
    Expect(1, 66271, '\p{Is_Block=carian}', "");
    Expect(0, 66271, '\p{^Is_Block=carian}', "");
    Expect(0, 66271, '\P{Is_Block=carian}', "");
    Expect(1, 66271, '\P{^Is_Block=carian}', "");
    Expect(0, 66272, '\p{Is_Block=carian}', "");
    Expect(1, 66272, '\p{^Is_Block=carian}', "");
    Expect(1, 66272, '\P{Is_Block=carian}', "");
    Expect(0, 66272, '\P{^Is_Block=carian}', "");
    Expect(1, 66271, '\p{Is_Block:CARIAN}', "");
    Expect(0, 66271, '\p{^Is_Block:CARIAN}', "");
    Expect(0, 66271, '\P{Is_Block:CARIAN}', "");
    Expect(1, 66271, '\P{^Is_Block:CARIAN}', "");
    Expect(0, 66272, '\p{Is_Block:CARIAN}', "");
    Expect(1, 66272, '\p{^Is_Block:CARIAN}', "");
    Expect(1, 66272, '\P{Is_Block:CARIAN}', "");
    Expect(0, 66272, '\P{^Is_Block:CARIAN}', "");
    Error('\p{Is_Blk: Carian:=}');
    Error('\P{Is_Blk: Carian:=}');
    Expect(1, 66271, '\p{Is_Blk=carian}', "");
    Expect(0, 66271, '\p{^Is_Blk=carian}', "");
    Expect(0, 66271, '\P{Is_Blk=carian}', "");
    Expect(1, 66271, '\P{^Is_Blk=carian}', "");
    Expect(0, 66272, '\p{Is_Blk=carian}', "");
    Expect(1, 66272, '\p{^Is_Blk=carian}', "");
    Expect(1, 66272, '\P{Is_Blk=carian}', "");
    Expect(0, 66272, '\P{^Is_Blk=carian}', "");
    Expect(1, 66271, '\p{Is_Blk=_-CARIAN}', "");
    Expect(0, 66271, '\p{^Is_Blk=_-CARIAN}', "");
    Expect(0, 66271, '\P{Is_Blk=_-CARIAN}', "");
    Expect(1, 66271, '\P{^Is_Blk=_-CARIAN}', "");
    Expect(0, 66272, '\p{Is_Blk=_-CARIAN}', "");
    Expect(1, 66272, '\p{^Is_Blk=_-CARIAN}', "");
    Expect(1, 66272, '\P{Is_Blk=_-CARIAN}', "");
    Expect(0, 66272, '\P{^Is_Blk=_-CARIAN}', "");
    Error('\p{Block: :=	 Caucasian_Albanian}');
    Error('\P{Block: :=	 Caucasian_Albanian}');
    Expect(1, 66927, '\p{Block=:\ACaucasian_Albanian\z:}', "");;
    Expect(0, 66928, '\p{Block=:\ACaucasian_Albanian\z:}', "");;
    Expect(1, 66927, '\p{Block=caucasianalbanian}', "");
    Expect(0, 66927, '\p{^Block=caucasianalbanian}', "");
    Expect(0, 66927, '\P{Block=caucasianalbanian}', "");
    Expect(1, 66927, '\P{^Block=caucasianalbanian}', "");
    Expect(0, 66928, '\p{Block=caucasianalbanian}', "");
    Expect(1, 66928, '\p{^Block=caucasianalbanian}', "");
    Expect(1, 66928, '\P{Block=caucasianalbanian}', "");
    Expect(0, 66928, '\P{^Block=caucasianalbanian}', "");
    Expect(1, 66927, '\p{Block=:\Acaucasianalbanian\z:}', "");;
    Expect(0, 66928, '\p{Block=:\Acaucasianalbanian\z:}', "");;
    Expect(1, 66927, '\p{Block=_-caucasian_Albanian}', "");
    Expect(0, 66927, '\p{^Block=_-caucasian_Albanian}', "");
    Expect(0, 66927, '\P{Block=_-caucasian_Albanian}', "");
    Expect(1, 66927, '\P{^Block=_-caucasian_Albanian}', "");
    Expect(0, 66928, '\p{Block=_-caucasian_Albanian}', "");
    Expect(1, 66928, '\p{^Block=_-caucasian_Albanian}', "");
    Expect(1, 66928, '\P{Block=_-caucasian_Albanian}', "");
    Expect(0, 66928, '\P{^Block=_-caucasian_Albanian}', "");
    Error('\p{Blk:		 Caucasian_Albanian:=}');
    Error('\P{Blk:		 Caucasian_Albanian:=}');
    Expect(1, 66927, '\p{Blk=:\ACaucasian_Albanian\z:}', "");;
    Expect(0, 66928, '\p{Blk=:\ACaucasian_Albanian\z:}', "");;
    Expect(1, 66927, '\p{Blk=caucasianalbanian}', "");
    Expect(0, 66927, '\p{^Blk=caucasianalbanian}', "");
    Expect(0, 66927, '\P{Blk=caucasianalbanian}', "");
    Expect(1, 66927, '\P{^Blk=caucasianalbanian}', "");
    Expect(0, 66928, '\p{Blk=caucasianalbanian}', "");
    Expect(1, 66928, '\p{^Blk=caucasianalbanian}', "");
    Expect(1, 66928, '\P{Blk=caucasianalbanian}', "");
    Expect(0, 66928, '\P{^Blk=caucasianalbanian}', "");
    Expect(1, 66927, '\p{Blk=:\Acaucasianalbanian\z:}', "");;
    Expect(0, 66928, '\p{Blk=:\Acaucasianalbanian\z:}', "");;
    Expect(1, 66927, '\p{Blk:	- Caucasian_albanian}', "");
    Expect(0, 66927, '\p{^Blk:	- Caucasian_albanian}', "");
    Expect(0, 66927, '\P{Blk:	- Caucasian_albanian}', "");
    Expect(1, 66927, '\P{^Blk:	- Caucasian_albanian}', "");
    Expect(0, 66928, '\p{Blk:	- Caucasian_albanian}', "");
    Expect(1, 66928, '\p{^Blk:	- Caucasian_albanian}', "");
    Expect(1, 66928, '\P{Blk:	- Caucasian_albanian}', "");
    Expect(0, 66928, '\P{^Blk:	- Caucasian_albanian}', "");
    Error('\p{Is_Block=:= -CAUCASIAN_ALBANIAN}');
    Error('\P{Is_Block=:= -CAUCASIAN_ALBANIAN}');
    Expect(1, 66927, '\p{Is_Block=caucasianalbanian}', "");
    Expect(0, 66927, '\p{^Is_Block=caucasianalbanian}', "");
    Expect(0, 66927, '\P{Is_Block=caucasianalbanian}', "");
    Expect(1, 66927, '\P{^Is_Block=caucasianalbanian}', "");
    Expect(0, 66928, '\p{Is_Block=caucasianalbanian}', "");
    Expect(1, 66928, '\p{^Is_Block=caucasianalbanian}', "");
    Expect(1, 66928, '\P{Is_Block=caucasianalbanian}', "");
    Expect(0, 66928, '\P{^Is_Block=caucasianalbanian}', "");
    Expect(1, 66927, '\p{Is_Block:    caucasian_Albanian}', "");
    Expect(0, 66927, '\p{^Is_Block:    caucasian_Albanian}', "");
    Expect(0, 66927, '\P{Is_Block:    caucasian_Albanian}', "");
    Expect(1, 66927, '\P{^Is_Block:    caucasian_Albanian}', "");
    Expect(0, 66928, '\p{Is_Block:    caucasian_Albanian}', "");
    Expect(1, 66928, '\p{^Is_Block:    caucasian_Albanian}', "");
    Expect(1, 66928, '\P{Is_Block:    caucasian_Albanian}', "");
    Expect(0, 66928, '\P{^Is_Block:    caucasian_Albanian}', "");
    Error('\p{Is_Blk= :=caucasian_albanian}');
    Error('\P{Is_Blk= :=caucasian_albanian}');
    Expect(1, 66927, '\p{Is_Blk=caucasianalbanian}', "");
    Expect(0, 66927, '\p{^Is_Blk=caucasianalbanian}', "");
    Expect(0, 66927, '\P{Is_Blk=caucasianalbanian}', "");
    Expect(1, 66927, '\P{^Is_Blk=caucasianalbanian}', "");
    Expect(0, 66928, '\p{Is_Blk=caucasianalbanian}', "");
    Expect(1, 66928, '\p{^Is_Blk=caucasianalbanian}', "");
    Expect(1, 66928, '\P{Is_Blk=caucasianalbanian}', "");
    Expect(0, 66928, '\P{^Is_Blk=caucasianalbanian}', "");
    Expect(1, 66927, '\p{Is_Blk= -CAUCASIAN_Albanian}', "");
    Expect(0, 66927, '\p{^Is_Blk= -CAUCASIAN_Albanian}', "");
    Expect(0, 66927, '\P{Is_Blk= -CAUCASIAN_Albanian}', "");
    Expect(1, 66927, '\P{^Is_Blk= -CAUCASIAN_Albanian}', "");
    Expect(0, 66928, '\p{Is_Blk= -CAUCASIAN_Albanian}', "");
    Expect(1, 66928, '\p{^Is_Blk= -CAUCASIAN_Albanian}', "");
    Expect(1, 66928, '\P{Is_Blk= -CAUCASIAN_Albanian}', "");
    Expect(0, 66928, '\P{^Is_Blk= -CAUCASIAN_Albanian}', "");
    Error('\p{Block: _/a/chakma}');
    Error('\P{Block: _/a/chakma}');
    Expect(1, 69967, '\p{Block=:\AChakma\z:}', "");;
    Expect(0, 69968, '\p{Block=:\AChakma\z:}', "");;
    Expect(1, 69967, '\p{Block=chakma}', "");
    Expect(0, 69967, '\p{^Block=chakma}', "");
    Expect(0, 69967, '\P{Block=chakma}', "");
    Expect(1, 69967, '\P{^Block=chakma}', "");
    Expect(0, 69968, '\p{Block=chakma}', "");
    Expect(1, 69968, '\p{^Block=chakma}', "");
    Expect(1, 69968, '\P{Block=chakma}', "");
    Expect(0, 69968, '\P{^Block=chakma}', "");
    Expect(1, 69967, '\p{Block=:\Achakma\z:}', "");;
    Expect(0, 69968, '\p{Block=:\Achakma\z:}', "");;
    Expect(1, 69967, '\p{Block=- Chakma}', "");
    Expect(0, 69967, '\p{^Block=- Chakma}', "");
    Expect(0, 69967, '\P{Block=- Chakma}', "");
    Expect(1, 69967, '\P{^Block=- Chakma}', "");
    Expect(0, 69968, '\p{Block=- Chakma}', "");
    Expect(1, 69968, '\p{^Block=- Chakma}', "");
    Expect(1, 69968, '\P{Block=- Chakma}', "");
    Expect(0, 69968, '\P{^Block=- Chakma}', "");
    Error('\p{Blk=CHAKMA/a/}');
    Error('\P{Blk=CHAKMA/a/}');
    Expect(1, 69967, '\p{Blk=:\AChakma\z:}', "");;
    Expect(0, 69968, '\p{Blk=:\AChakma\z:}', "");;
    Expect(1, 69967, '\p{Blk=chakma}', "");
    Expect(0, 69967, '\p{^Blk=chakma}', "");
    Expect(0, 69967, '\P{Blk=chakma}', "");
    Expect(1, 69967, '\P{^Blk=chakma}', "");
    Expect(0, 69968, '\p{Blk=chakma}', "");
    Expect(1, 69968, '\p{^Blk=chakma}', "");
    Expect(1, 69968, '\P{Blk=chakma}', "");
    Expect(0, 69968, '\P{^Blk=chakma}', "");
    Expect(1, 69967, '\p{Blk=:\Achakma\z:}', "");;
    Expect(0, 69968, '\p{Blk=:\Achakma\z:}', "");;
    Expect(1, 69967, '\p{Blk=	 CHAKMA}', "");
    Expect(0, 69967, '\p{^Blk=	 CHAKMA}', "");
    Expect(0, 69967, '\P{Blk=	 CHAKMA}', "");
    Expect(1, 69967, '\P{^Blk=	 CHAKMA}', "");
    Expect(0, 69968, '\p{Blk=	 CHAKMA}', "");
    Expect(1, 69968, '\p{^Blk=	 CHAKMA}', "");
    Expect(1, 69968, '\P{Blk=	 CHAKMA}', "");
    Expect(0, 69968, '\P{^Blk=	 CHAKMA}', "");
    Error('\p{Is_Block=_chakma/a/}');
    Error('\P{Is_Block=_chakma/a/}');
    Expect(1, 69967, '\p{Is_Block=chakma}', "");
    Expect(0, 69967, '\p{^Is_Block=chakma}', "");
    Expect(0, 69967, '\P{Is_Block=chakma}', "");
    Expect(1, 69967, '\P{^Is_Block=chakma}', "");
    Expect(0, 69968, '\p{Is_Block=chakma}', "");
    Expect(1, 69968, '\p{^Is_Block=chakma}', "");
    Expect(1, 69968, '\P{Is_Block=chakma}', "");
    Expect(0, 69968, '\P{^Is_Block=chakma}', "");
    Expect(1, 69967, '\p{Is_Block:   CHAKMA}', "");
    Expect(0, 69967, '\p{^Is_Block:   CHAKMA}', "");
    Expect(0, 69967, '\P{Is_Block:   CHAKMA}', "");
    Expect(1, 69967, '\P{^Is_Block:   CHAKMA}', "");
    Expect(0, 69968, '\p{Is_Block:   CHAKMA}', "");
    Expect(1, 69968, '\p{^Is_Block:   CHAKMA}', "");
    Expect(1, 69968, '\P{Is_Block:   CHAKMA}', "");
    Expect(0, 69968, '\P{^Is_Block:   CHAKMA}', "");
    Error('\p{Is_Blk=/a/	chakma}');
    Error('\P{Is_Blk=/a/	chakma}');
    Expect(1, 69967, '\p{Is_Blk=chakma}', "");
    Expect(0, 69967, '\p{^Is_Blk=chakma}', "");
    Expect(0, 69967, '\P{Is_Blk=chakma}', "");
    Expect(1, 69967, '\P{^Is_Blk=chakma}', "");
    Expect(0, 69968, '\p{Is_Blk=chakma}', "");
    Expect(1, 69968, '\p{^Is_Blk=chakma}', "");
    Expect(1, 69968, '\P{Is_Blk=chakma}', "");
    Expect(0, 69968, '\P{^Is_Blk=chakma}', "");
    Expect(1, 69967, '\p{Is_Blk= _CHAKMA}', "");
    Expect(0, 69967, '\p{^Is_Blk= _CHAKMA}', "");
    Expect(0, 69967, '\P{Is_Blk= _CHAKMA}', "");
    Expect(1, 69967, '\P{^Is_Blk= _CHAKMA}', "");
    Expect(0, 69968, '\p{Is_Blk= _CHAKMA}', "");
    Expect(1, 69968, '\p{^Is_Blk= _CHAKMA}', "");
    Expect(1, 69968, '\P{Is_Blk= _CHAKMA}', "");
    Expect(0, 69968, '\P{^Is_Blk= _CHAKMA}', "");
    Error('\p{Block=		cham:=}');
    Error('\P{Block=		cham:=}');
    Expect(1, 43615, '\p{Block=:\ACham\z:}', "");;
    Expect(0, 43616, '\p{Block=:\ACham\z:}', "");;
    Expect(1, 43615, '\p{Block=cham}', "");
    Expect(0, 43615, '\p{^Block=cham}', "");
    Expect(0, 43615, '\P{Block=cham}', "");
    Expect(1, 43615, '\P{^Block=cham}', "");
    Expect(0, 43616, '\p{Block=cham}', "");
    Expect(1, 43616, '\p{^Block=cham}', "");
    Expect(1, 43616, '\P{Block=cham}', "");
    Expect(0, 43616, '\P{^Block=cham}', "");
    Expect(1, 43615, '\p{Block=:\Acham\z:}', "");;
    Expect(0, 43616, '\p{Block=:\Acham\z:}', "");;
    Expect(1, 43615, '\p{Block= _CHAM}', "");
    Expect(0, 43615, '\p{^Block= _CHAM}', "");
    Expect(0, 43615, '\P{Block= _CHAM}', "");
    Expect(1, 43615, '\P{^Block= _CHAM}', "");
    Expect(0, 43616, '\p{Block= _CHAM}', "");
    Expect(1, 43616, '\p{^Block= _CHAM}', "");
    Expect(1, 43616, '\P{Block= _CHAM}', "");
    Expect(0, 43616, '\P{^Block= _CHAM}', "");
    Error('\p{Blk:   :=-	Cham}');
    Error('\P{Blk:   :=-	Cham}');
    Expect(1, 43615, '\p{Blk=:\ACham\z:}', "");;
    Expect(0, 43616, '\p{Blk=:\ACham\z:}', "");;
    Expect(1, 43615, '\p{Blk=cham}', "");
    Expect(0, 43615, '\p{^Blk=cham}', "");
    Expect(0, 43615, '\P{Blk=cham}', "");
    Expect(1, 43615, '\P{^Blk=cham}', "");
    Expect(0, 43616, '\p{Blk=cham}', "");
    Expect(1, 43616, '\p{^Blk=cham}', "");
    Expect(1, 43616, '\P{Blk=cham}', "");
    Expect(0, 43616, '\P{^Blk=cham}', "");
    Expect(1, 43615, '\p{Blk=:\Acham\z:}', "");;
    Expect(0, 43616, '\p{Blk=:\Acham\z:}', "");;
    Expect(1, 43615, '\p{Blk=-CHAM}', "");
    Expect(0, 43615, '\p{^Blk=-CHAM}', "");
    Expect(0, 43615, '\P{Blk=-CHAM}', "");
    Expect(1, 43615, '\P{^Blk=-CHAM}', "");
    Expect(0, 43616, '\p{Blk=-CHAM}', "");
    Expect(1, 43616, '\p{^Blk=-CHAM}', "");
    Expect(1, 43616, '\P{Blk=-CHAM}', "");
    Expect(0, 43616, '\P{^Blk=-CHAM}', "");
    Error('\p{Is_Block:/a/-CHAM}');
    Error('\P{Is_Block:/a/-CHAM}');
    Expect(1, 43615, '\p{Is_Block=cham}', "");
    Expect(0, 43615, '\p{^Is_Block=cham}', "");
    Expect(0, 43615, '\P{Is_Block=cham}', "");
    Expect(1, 43615, '\P{^Is_Block=cham}', "");
    Expect(0, 43616, '\p{Is_Block=cham}', "");
    Expect(1, 43616, '\p{^Is_Block=cham}', "");
    Expect(1, 43616, '\P{Is_Block=cham}', "");
    Expect(0, 43616, '\P{^Is_Block=cham}', "");
    Expect(1, 43615, '\p{Is_Block=-	Cham}', "");
    Expect(0, 43615, '\p{^Is_Block=-	Cham}', "");
    Expect(0, 43615, '\P{Is_Block=-	Cham}', "");
    Expect(1, 43615, '\P{^Is_Block=-	Cham}', "");
    Expect(0, 43616, '\p{Is_Block=-	Cham}', "");
    Expect(1, 43616, '\p{^Is_Block=-	Cham}', "");
    Expect(1, 43616, '\P{Is_Block=-	Cham}', "");
    Expect(0, 43616, '\P{^Is_Block=-	Cham}', "");
    Error('\p{Is_Blk= -cham/a/}');
    Error('\P{Is_Blk= -cham/a/}');
    Expect(1, 43615, '\p{Is_Blk=cham}', "");
    Expect(0, 43615, '\p{^Is_Blk=cham}', "");
    Expect(0, 43615, '\P{Is_Blk=cham}', "");
    Expect(1, 43615, '\P{^Is_Blk=cham}', "");
    Expect(0, 43616, '\p{Is_Blk=cham}', "");
    Expect(1, 43616, '\p{^Is_Blk=cham}', "");
    Expect(1, 43616, '\P{Is_Blk=cham}', "");
    Expect(0, 43616, '\P{^Is_Blk=cham}', "");
    Expect(1, 43615, '\p{Is_Blk=-Cham}', "");
    Expect(0, 43615, '\p{^Is_Blk=-Cham}', "");
    Expect(0, 43615, '\P{Is_Blk=-Cham}', "");
    Expect(1, 43615, '\P{^Is_Blk=-Cham}', "");
    Expect(0, 43616, '\p{Is_Blk=-Cham}', "");
    Expect(1, 43616, '\p{^Is_Blk=-Cham}', "");
    Expect(1, 43616, '\P{Is_Blk=-Cham}', "");
    Expect(0, 43616, '\P{^Is_Blk=-Cham}', "");
    Error('\p{Block=- Cherokee:=}');
    Error('\P{Block=- Cherokee:=}');
    Expect(1, 5119, '\p{Block=:\ACherokee\z:}', "");;
    Expect(0, 5120, '\p{Block=:\ACherokee\z:}', "");;
    Expect(1, 5119, '\p{Block=cherokee}', "");
    Expect(0, 5119, '\p{^Block=cherokee}', "");
    Expect(0, 5119, '\P{Block=cherokee}', "");
    Expect(1, 5119, '\P{^Block=cherokee}', "");
    Expect(0, 5120, '\p{Block=cherokee}', "");
    Expect(1, 5120, '\p{^Block=cherokee}', "");
    Expect(1, 5120, '\P{Block=cherokee}', "");
    Expect(0, 5120, '\P{^Block=cherokee}', "");
    Expect(1, 5119, '\p{Block=:\Acherokee\z:}', "");;
    Expect(0, 5120, '\p{Block=:\Acherokee\z:}', "");;
    Expect(1, 5119, '\p{Block=-	Cherokee}', "");
    Expect(0, 5119, '\p{^Block=-	Cherokee}', "");
    Expect(0, 5119, '\P{Block=-	Cherokee}', "");
    Expect(1, 5119, '\P{^Block=-	Cherokee}', "");
    Expect(0, 5120, '\p{Block=-	Cherokee}', "");
    Expect(1, 5120, '\p{^Block=-	Cherokee}', "");
    Expect(1, 5120, '\P{Block=-	Cherokee}', "");
    Expect(0, 5120, '\P{^Block=-	Cherokee}', "");
    Error('\p{Blk=:=CHEROKEE}');
    Error('\P{Blk=:=CHEROKEE}');
    Expect(1, 5119, '\p{Blk=:\ACherokee\z:}', "");;
    Expect(0, 5120, '\p{Blk=:\ACherokee\z:}', "");;
    Expect(1, 5119, '\p{Blk=cherokee}', "");
    Expect(0, 5119, '\p{^Blk=cherokee}', "");
    Expect(0, 5119, '\P{Blk=cherokee}', "");
    Expect(1, 5119, '\P{^Blk=cherokee}', "");
    Expect(0, 5120, '\p{Blk=cherokee}', "");
    Expect(1, 5120, '\p{^Blk=cherokee}', "");
    Expect(1, 5120, '\P{Blk=cherokee}', "");
    Expect(0, 5120, '\P{^Blk=cherokee}', "");
    Expect(1, 5119, '\p{Blk=:\Acherokee\z:}', "");;
    Expect(0, 5120, '\p{Blk=:\Acherokee\z:}', "");;
    Expect(1, 5119, '\p{Blk=_Cherokee}', "");
    Expect(0, 5119, '\p{^Blk=_Cherokee}', "");
    Expect(0, 5119, '\P{Blk=_Cherokee}', "");
    Expect(1, 5119, '\P{^Blk=_Cherokee}', "");
    Expect(0, 5120, '\p{Blk=_Cherokee}', "");
    Expect(1, 5120, '\p{^Blk=_Cherokee}', "");
    Expect(1, 5120, '\P{Blk=_Cherokee}', "");
    Expect(0, 5120, '\P{^Blk=_Cherokee}', "");
    Error('\p{Is_Block=/a/--cherokee}');
    Error('\P{Is_Block=/a/--cherokee}');
    Expect(1, 5119, '\p{Is_Block=cherokee}', "");
    Expect(0, 5119, '\p{^Is_Block=cherokee}', "");
    Expect(0, 5119, '\P{Is_Block=cherokee}', "");
    Expect(1, 5119, '\P{^Is_Block=cherokee}', "");
    Expect(0, 5120, '\p{Is_Block=cherokee}', "");
    Expect(1, 5120, '\p{^Is_Block=cherokee}', "");
    Expect(1, 5120, '\P{Is_Block=cherokee}', "");
    Expect(0, 5120, '\P{^Is_Block=cherokee}', "");
    Expect(1, 5119, '\p{Is_Block= _Cherokee}', "");
    Expect(0, 5119, '\p{^Is_Block= _Cherokee}', "");
    Expect(0, 5119, '\P{Is_Block= _Cherokee}', "");
    Expect(1, 5119, '\P{^Is_Block= _Cherokee}', "");
    Expect(0, 5120, '\p{Is_Block= _Cherokee}', "");
    Expect(1, 5120, '\p{^Is_Block= _Cherokee}', "");
    Expect(1, 5120, '\P{Is_Block= _Cherokee}', "");
    Expect(0, 5120, '\P{^Is_Block= _Cherokee}', "");
    Error('\p{Is_Blk: -Cherokee/a/}');
    Error('\P{Is_Blk: -Cherokee/a/}');
    Expect(1, 5119, '\p{Is_Blk=cherokee}', "");
    Expect(0, 5119, '\p{^Is_Blk=cherokee}', "");
    Expect(0, 5119, '\P{Is_Blk=cherokee}', "");
    Expect(1, 5119, '\P{^Is_Blk=cherokee}', "");
    Expect(0, 5120, '\p{Is_Blk=cherokee}', "");
    Expect(1, 5120, '\p{^Is_Blk=cherokee}', "");
    Expect(1, 5120, '\P{Is_Blk=cherokee}', "");
    Expect(0, 5120, '\P{^Is_Blk=cherokee}', "");
    Expect(1, 5119, '\p{Is_Blk:  -Cherokee}', "");
    Expect(0, 5119, '\p{^Is_Blk:  -Cherokee}', "");
    Expect(0, 5119, '\P{Is_Blk:  -Cherokee}', "");
    Expect(1, 5119, '\P{^Is_Blk:  -Cherokee}', "");
    Expect(0, 5120, '\p{Is_Blk:  -Cherokee}', "");
    Expect(1, 5120, '\p{^Is_Blk:  -Cherokee}', "");
    Expect(1, 5120, '\P{Is_Blk:  -Cherokee}', "");
    Expect(0, 5120, '\P{^Is_Blk:  -Cherokee}', "");
    Error('\p{Block=__cherokee_supplement/a/}');
    Error('\P{Block=__cherokee_supplement/a/}');
    Expect(1, 43967, '\p{Block=:\ACherokee_Supplement\z:}', "");;
    Expect(0, 43968, '\p{Block=:\ACherokee_Supplement\z:}', "");;
    Expect(1, 43967, '\p{Block=cherokeesupplement}', "");
    Expect(0, 43967, '\p{^Block=cherokeesupplement}', "");
    Expect(0, 43967, '\P{Block=cherokeesupplement}', "");
    Expect(1, 43967, '\P{^Block=cherokeesupplement}', "");
    Expect(0, 43968, '\p{Block=cherokeesupplement}', "");
    Expect(1, 43968, '\p{^Block=cherokeesupplement}', "");
    Expect(1, 43968, '\P{Block=cherokeesupplement}', "");
    Expect(0, 43968, '\P{^Block=cherokeesupplement}', "");
    Expect(1, 43967, '\p{Block=:\Acherokeesupplement\z:}', "");;
    Expect(0, 43968, '\p{Block=:\Acherokeesupplement\z:}', "");;
    Expect(1, 43967, '\p{Block=CHEROKEE_supplement}', "");
    Expect(0, 43967, '\p{^Block=CHEROKEE_supplement}', "");
    Expect(0, 43967, '\P{Block=CHEROKEE_supplement}', "");
    Expect(1, 43967, '\P{^Block=CHEROKEE_supplement}', "");
    Expect(0, 43968, '\p{Block=CHEROKEE_supplement}', "");
    Expect(1, 43968, '\p{^Block=CHEROKEE_supplement}', "");
    Expect(1, 43968, '\P{Block=CHEROKEE_supplement}', "");
    Expect(0, 43968, '\P{^Block=CHEROKEE_supplement}', "");
    Error('\p{Blk=	/a/CHEROKEE_sup}');
    Error('\P{Blk=	/a/CHEROKEE_sup}');
    Expect(1, 43967, '\p{Blk=:\ACherokee_Sup\z:}', "");;
    Expect(0, 43968, '\p{Blk=:\ACherokee_Sup\z:}', "");;
    Expect(1, 43967, '\p{Blk=cherokeesup}', "");
    Expect(0, 43967, '\p{^Blk=cherokeesup}', "");
    Expect(0, 43967, '\P{Blk=cherokeesup}', "");
    Expect(1, 43967, '\P{^Blk=cherokeesup}', "");
    Expect(0, 43968, '\p{Blk=cherokeesup}', "");
    Expect(1, 43968, '\p{^Blk=cherokeesup}', "");
    Expect(1, 43968, '\P{Blk=cherokeesup}', "");
    Expect(0, 43968, '\P{^Blk=cherokeesup}', "");
    Expect(1, 43967, '\p{Blk=:\Acherokeesup\z:}', "");;
    Expect(0, 43968, '\p{Blk=:\Acherokeesup\z:}', "");;
    Expect(1, 43967, '\p{Blk=_	Cherokee_SUP}', "");
    Expect(0, 43967, '\p{^Blk=_	Cherokee_SUP}', "");
    Expect(0, 43967, '\P{Blk=_	Cherokee_SUP}', "");
    Expect(1, 43967, '\P{^Blk=_	Cherokee_SUP}', "");
    Expect(0, 43968, '\p{Blk=_	Cherokee_SUP}', "");
    Expect(1, 43968, '\p{^Blk=_	Cherokee_SUP}', "");
    Expect(1, 43968, '\P{Blk=_	Cherokee_SUP}', "");
    Expect(0, 43968, '\P{^Blk=_	Cherokee_SUP}', "");
    Error('\p{Is_Block=- CHEROKEE_SUPPLEMENT/a/}');
    Error('\P{Is_Block=- CHEROKEE_SUPPLEMENT/a/}');
    Expect(1, 43967, '\p{Is_Block=cherokeesupplement}', "");
    Expect(0, 43967, '\p{^Is_Block=cherokeesupplement}', "");
    Expect(0, 43967, '\P{Is_Block=cherokeesupplement}', "");
    Expect(1, 43967, '\P{^Is_Block=cherokeesupplement}', "");
    Expect(0, 43968, '\p{Is_Block=cherokeesupplement}', "");
    Expect(1, 43968, '\p{^Is_Block=cherokeesupplement}', "");
    Expect(1, 43968, '\P{Is_Block=cherokeesupplement}', "");
    Expect(0, 43968, '\P{^Is_Block=cherokeesupplement}', "");
    Expect(1, 43967, '\p{Is_Block=CHEROKEE_Supplement}', "");
    Expect(0, 43967, '\p{^Is_Block=CHEROKEE_Supplement}', "");
    Expect(0, 43967, '\P{Is_Block=CHEROKEE_Supplement}', "");
    Expect(1, 43967, '\P{^Is_Block=CHEROKEE_Supplement}', "");
    Expect(0, 43968, '\p{Is_Block=CHEROKEE_Supplement}', "");
    Expect(1, 43968, '\p{^Is_Block=CHEROKEE_Supplement}', "");
    Expect(1, 43968, '\P{Is_Block=CHEROKEE_Supplement}', "");
    Expect(0, 43968, '\P{^Is_Block=CHEROKEE_Supplement}', "");
    Error('\p{Is_Blk=	/a/Cherokee_Sup}');
    Error('\P{Is_Blk=	/a/Cherokee_Sup}');
    Expect(1, 43967, '\p{Is_Blk:cherokeesup}', "");
    Expect(0, 43967, '\p{^Is_Blk:cherokeesup}', "");
    Expect(0, 43967, '\P{Is_Blk:cherokeesup}', "");
    Expect(1, 43967, '\P{^Is_Blk:cherokeesup}', "");
    Expect(0, 43968, '\p{Is_Blk:cherokeesup}', "");
    Expect(1, 43968, '\p{^Is_Blk:cherokeesup}', "");
    Expect(1, 43968, '\P{Is_Blk:cherokeesup}', "");
    Expect(0, 43968, '\P{^Is_Blk:cherokeesup}', "");
    Expect(1, 43967, '\p{Is_Blk=	Cherokee_SUP}', "");
    Expect(0, 43967, '\p{^Is_Blk=	Cherokee_SUP}', "");
    Expect(0, 43967, '\P{Is_Blk=	Cherokee_SUP}', "");
    Expect(1, 43967, '\P{^Is_Blk=	Cherokee_SUP}', "");
    Expect(0, 43968, '\p{Is_Blk=	Cherokee_SUP}', "");
    Expect(1, 43968, '\p{^Is_Blk=	Cherokee_SUP}', "");
    Expect(1, 43968, '\P{Is_Blk=	Cherokee_SUP}', "");
    Expect(0, 43968, '\P{^Is_Blk=	Cherokee_SUP}', "");
    Error('\p{Block=	:=chess_SYMBOLS}');
    Error('\P{Block=	:=chess_SYMBOLS}');
    Expect(1, 129647, '\p{Block=:\AChess_Symbols\z:}', "");;
    Expect(0, 129648, '\p{Block=:\AChess_Symbols\z:}', "");;
    Expect(1, 129647, '\p{Block=chesssymbols}', "");
    Expect(0, 129647, '\p{^Block=chesssymbols}', "");
    Expect(0, 129647, '\P{Block=chesssymbols}', "");
    Expect(1, 129647, '\P{^Block=chesssymbols}', "");
    Expect(0, 129648, '\p{Block=chesssymbols}', "");
    Expect(1, 129648, '\p{^Block=chesssymbols}', "");
    Expect(1, 129648, '\P{Block=chesssymbols}', "");
    Expect(0, 129648, '\P{^Block=chesssymbols}', "");
    Expect(1, 129647, '\p{Block=:\Achesssymbols\z:}', "");;
    Expect(0, 129648, '\p{Block=:\Achesssymbols\z:}', "");;
    Expect(1, 129647, '\p{Block= _CHESS_Symbols}', "");
    Expect(0, 129647, '\p{^Block= _CHESS_Symbols}', "");
    Expect(0, 129647, '\P{Block= _CHESS_Symbols}', "");
    Expect(1, 129647, '\P{^Block= _CHESS_Symbols}', "");
    Expect(0, 129648, '\p{Block= _CHESS_Symbols}', "");
    Expect(1, 129648, '\p{^Block= _CHESS_Symbols}', "");
    Expect(1, 129648, '\P{Block= _CHESS_Symbols}', "");
    Expect(0, 129648, '\P{^Block= _CHESS_Symbols}', "");
    Error('\p{Blk=-:=Chess_Symbols}');
    Error('\P{Blk=-:=Chess_Symbols}');
    Expect(1, 129647, '\p{Blk=:\AChess_Symbols\z:}', "");;
    Expect(0, 129648, '\p{Blk=:\AChess_Symbols\z:}', "");;
    Expect(1, 129647, '\p{Blk=chesssymbols}', "");
    Expect(0, 129647, '\p{^Blk=chesssymbols}', "");
    Expect(0, 129647, '\P{Blk=chesssymbols}', "");
    Expect(1, 129647, '\P{^Blk=chesssymbols}', "");
    Expect(0, 129648, '\p{Blk=chesssymbols}', "");
    Expect(1, 129648, '\p{^Blk=chesssymbols}', "");
    Expect(1, 129648, '\P{Blk=chesssymbols}', "");
    Expect(0, 129648, '\P{^Blk=chesssymbols}', "");
    Expect(1, 129647, '\p{Blk=:\Achesssymbols\z:}', "");;
    Expect(0, 129648, '\p{Blk=:\Achesssymbols\z:}', "");;
    Expect(1, 129647, '\p{Blk=__Chess_Symbols}', "");
    Expect(0, 129647, '\p{^Blk=__Chess_Symbols}', "");
    Expect(0, 129647, '\P{Blk=__Chess_Symbols}', "");
    Expect(1, 129647, '\P{^Blk=__Chess_Symbols}', "");
    Expect(0, 129648, '\p{Blk=__Chess_Symbols}', "");
    Expect(1, 129648, '\p{^Blk=__Chess_Symbols}', "");
    Expect(1, 129648, '\P{Blk=__Chess_Symbols}', "");
    Expect(0, 129648, '\P{^Blk=__Chess_Symbols}', "");
    Error('\p{Is_Block=_:=Chess_symbols}');
    Error('\P{Is_Block=_:=Chess_symbols}');
    Expect(1, 129647, '\p{Is_Block=chesssymbols}', "");
    Expect(0, 129647, '\p{^Is_Block=chesssymbols}', "");
    Expect(0, 129647, '\P{Is_Block=chesssymbols}', "");
    Expect(1, 129647, '\P{^Is_Block=chesssymbols}', "");
    Expect(0, 129648, '\p{Is_Block=chesssymbols}', "");
    Expect(1, 129648, '\p{^Is_Block=chesssymbols}', "");
    Expect(1, 129648, '\P{Is_Block=chesssymbols}', "");
    Expect(0, 129648, '\P{^Is_Block=chesssymbols}', "");
    Expect(1, 129647, '\p{Is_Block= 	Chess_symbols}', "");
    Expect(0, 129647, '\p{^Is_Block= 	Chess_symbols}', "");
    Expect(0, 129647, '\P{Is_Block= 	Chess_symbols}', "");
    Expect(1, 129647, '\P{^Is_Block= 	Chess_symbols}', "");
    Expect(0, 129648, '\p{Is_Block= 	Chess_symbols}', "");
    Expect(1, 129648, '\p{^Is_Block= 	Chess_symbols}', "");
    Expect(1, 129648, '\P{Is_Block= 	Chess_symbols}', "");
    Expect(0, 129648, '\P{^Is_Block= 	Chess_symbols}', "");
    Error('\p{Is_Blk=/a/_	CHESS_Symbols}');
    Error('\P{Is_Blk=/a/_	CHESS_Symbols}');
    Expect(1, 129647, '\p{Is_Blk=chesssymbols}', "");
    Expect(0, 129647, '\p{^Is_Blk=chesssymbols}', "");
    Expect(0, 129647, '\P{Is_Blk=chesssymbols}', "");
    Expect(1, 129647, '\P{^Is_Blk=chesssymbols}', "");
    Expect(0, 129648, '\p{Is_Blk=chesssymbols}', "");
    Expect(1, 129648, '\p{^Is_Blk=chesssymbols}', "");
    Expect(1, 129648, '\P{Is_Blk=chesssymbols}', "");
    Expect(0, 129648, '\P{^Is_Blk=chesssymbols}', "");
    Expect(1, 129647, '\p{Is_Blk=_	Chess_symbols}', "");
    Expect(0, 129647, '\p{^Is_Blk=_	Chess_symbols}', "");
    Expect(0, 129647, '\P{Is_Blk=_	Chess_symbols}', "");
    Expect(1, 129647, '\P{^Is_Blk=_	Chess_symbols}', "");
    Expect(0, 129648, '\p{Is_Blk=_	Chess_symbols}', "");
    Expect(1, 129648, '\p{^Is_Blk=_	Chess_symbols}', "");
    Expect(1, 129648, '\P{Is_Blk=_	Chess_symbols}', "");
    Expect(0, 129648, '\P{^Is_Blk=_	Chess_symbols}', "");
    Error('\p{Block=/a/- Chorasmian}');
    Error('\P{Block=/a/- Chorasmian}');
    Expect(1, 69599, '\p{Block=:\AChorasmian\z:}', "");;
    Expect(0, 69600, '\p{Block=:\AChorasmian\z:}', "");;
    Expect(1, 69599, '\p{Block=chorasmian}', "");
    Expect(0, 69599, '\p{^Block=chorasmian}', "");
    Expect(0, 69599, '\P{Block=chorasmian}', "");
    Expect(1, 69599, '\P{^Block=chorasmian}', "");
    Expect(0, 69600, '\p{Block=chorasmian}', "");
    Expect(1, 69600, '\p{^Block=chorasmian}', "");
    Expect(1, 69600, '\P{Block=chorasmian}', "");
    Expect(0, 69600, '\P{^Block=chorasmian}', "");
    Expect(1, 69599, '\p{Block=:\Achorasmian\z:}', "");;
    Expect(0, 69600, '\p{Block=:\Achorasmian\z:}', "");;
    Expect(1, 69599, '\p{Block: _	Chorasmian}', "");
    Expect(0, 69599, '\p{^Block: _	Chorasmian}', "");
    Expect(0, 69599, '\P{Block: _	Chorasmian}', "");
    Expect(1, 69599, '\P{^Block: _	Chorasmian}', "");
    Expect(0, 69600, '\p{Block: _	Chorasmian}', "");
    Expect(1, 69600, '\p{^Block: _	Chorasmian}', "");
    Expect(1, 69600, '\P{Block: _	Chorasmian}', "");
    Expect(0, 69600, '\P{^Block: _	Chorasmian}', "");
    Error('\p{Blk=:=	_Chorasmian}');
    Error('\P{Blk=:=	_Chorasmian}');
    Expect(1, 69599, '\p{Blk=:\AChorasmian\z:}', "");;
    Expect(0, 69600, '\p{Blk=:\AChorasmian\z:}', "");;
    Expect(1, 69599, '\p{Blk=chorasmian}', "");
    Expect(0, 69599, '\p{^Blk=chorasmian}', "");
    Expect(0, 69599, '\P{Blk=chorasmian}', "");
    Expect(1, 69599, '\P{^Blk=chorasmian}', "");
    Expect(0, 69600, '\p{Blk=chorasmian}', "");
    Expect(1, 69600, '\p{^Blk=chorasmian}', "");
    Expect(1, 69600, '\P{Blk=chorasmian}', "");
    Expect(0, 69600, '\P{^Blk=chorasmian}', "");
    Expect(1, 69599, '\p{Blk=:\Achorasmian\z:}', "");;
    Expect(0, 69600, '\p{Blk=:\Achorasmian\z:}', "");;
    Expect(1, 69599, '\p{Blk=_	chorasmian}', "");
    Expect(0, 69599, '\p{^Blk=_	chorasmian}', "");
    Expect(0, 69599, '\P{Blk=_	chorasmian}', "");
    Expect(1, 69599, '\P{^Blk=_	chorasmian}', "");
    Expect(0, 69600, '\p{Blk=_	chorasmian}', "");
    Expect(1, 69600, '\p{^Blk=_	chorasmian}', "");
    Expect(1, 69600, '\P{Blk=_	chorasmian}', "");
    Expect(0, 69600, '\P{^Blk=_	chorasmian}', "");
    Error('\p{Is_Block=_:=chorasmian}');
    Error('\P{Is_Block=_:=chorasmian}');
    Expect(1, 69599, '\p{Is_Block=chorasmian}', "");
    Expect(0, 69599, '\p{^Is_Block=chorasmian}', "");
    Expect(0, 69599, '\P{Is_Block=chorasmian}', "");
    Expect(1, 69599, '\P{^Is_Block=chorasmian}', "");
    Expect(0, 69600, '\p{Is_Block=chorasmian}', "");
    Expect(1, 69600, '\p{^Is_Block=chorasmian}', "");
    Expect(1, 69600, '\P{Is_Block=chorasmian}', "");
    Expect(0, 69600, '\P{^Is_Block=chorasmian}', "");
    Expect(1, 69599, '\p{Is_Block=		chorasmian}', "");
    Expect(0, 69599, '\p{^Is_Block=		chorasmian}', "");
    Expect(0, 69599, '\P{Is_Block=		chorasmian}', "");
    Expect(1, 69599, '\P{^Is_Block=		chorasmian}', "");
    Expect(0, 69600, '\p{Is_Block=		chorasmian}', "");
    Expect(1, 69600, '\p{^Is_Block=		chorasmian}', "");
    Expect(1, 69600, '\P{Is_Block=		chorasmian}', "");
    Expect(0, 69600, '\P{^Is_Block=		chorasmian}', "");
    Error('\p{Is_Blk=/a/CHORASMIAN}');
    Error('\P{Is_Blk=/a/CHORASMIAN}');
    Expect(1, 69599, '\p{Is_Blk=chorasmian}', "");
    Expect(0, 69599, '\p{^Is_Blk=chorasmian}', "");
    Expect(0, 69599, '\P{Is_Blk=chorasmian}', "");
    Expect(1, 69599, '\P{^Is_Blk=chorasmian}', "");
    Expect(0, 69600, '\p{Is_Blk=chorasmian}', "");
    Expect(1, 69600, '\p{^Is_Blk=chorasmian}', "");
    Expect(1, 69600, '\P{Is_Blk=chorasmian}', "");
    Expect(0, 69600, '\P{^Is_Blk=chorasmian}', "");
    Expect(1, 69599, '\p{Is_Blk=_Chorasmian}', "");
    Expect(0, 69599, '\p{^Is_Blk=_Chorasmian}', "");
    Expect(0, 69599, '\P{Is_Blk=_Chorasmian}', "");
    Expect(1, 69599, '\P{^Is_Blk=_Chorasmian}', "");
    Expect(0, 69600, '\p{Is_Blk=_Chorasmian}', "");
    Expect(1, 69600, '\p{^Is_Blk=_Chorasmian}', "");
    Expect(1, 69600, '\P{Is_Blk=_Chorasmian}', "");
    Expect(0, 69600, '\P{^Is_Blk=_Chorasmian}', "");
    Error('\p{Block=-cjk_UNIFIED_Ideographs:=}');
    Error('\P{Block=-cjk_UNIFIED_Ideographs:=}');
    Expect(1, 40959, '\p{Block=:\ACJK_Unified_Ideographs\z:}', "");;
    Expect(0, 40960, '\p{Block=:\ACJK_Unified_Ideographs\z:}', "");;
    Expect(1, 40959, '\p{Block=cjkunifiedideographs}', "");
    Expect(0, 40959, '\p{^Block=cjkunifiedideographs}', "");
    Expect(0, 40959, '\P{Block=cjkunifiedideographs}', "");
    Expect(1, 40959, '\P{^Block=cjkunifiedideographs}', "");
    Expect(0, 40960, '\p{Block=cjkunifiedideographs}', "");
    Expect(1, 40960, '\p{^Block=cjkunifiedideographs}', "");
    Expect(1, 40960, '\P{Block=cjkunifiedideographs}', "");
    Expect(0, 40960, '\P{^Block=cjkunifiedideographs}', "");
    Expect(1, 40959, '\p{Block=:\Acjkunifiedideographs\z:}', "");;
    Expect(0, 40960, '\p{Block=:\Acjkunifiedideographs\z:}', "");;
    Expect(1, 40959, '\p{Block=--CJK_unified_Ideographs}', "");
    Expect(0, 40959, '\p{^Block=--CJK_unified_Ideographs}', "");
    Expect(0, 40959, '\P{Block=--CJK_unified_Ideographs}', "");
    Expect(1, 40959, '\P{^Block=--CJK_unified_Ideographs}', "");
    Expect(0, 40960, '\p{Block=--CJK_unified_Ideographs}', "");
    Expect(1, 40960, '\p{^Block=--CJK_unified_Ideographs}', "");
    Expect(1, 40960, '\P{Block=--CJK_unified_Ideographs}', "");
    Expect(0, 40960, '\P{^Block=--CJK_unified_Ideographs}', "");
    Error('\p{Blk=_:=CJK}');
    Error('\P{Blk=_:=CJK}');
    Expect(1, 40959, '\p{Blk=:\ACJK\z:}', "");;
    Expect(0, 40960, '\p{Blk=:\ACJK\z:}', "");;
    Expect(1, 40959, '\p{Blk=cjk}', "");
    Expect(0, 40959, '\p{^Blk=cjk}', "");
    Expect(0, 40959, '\P{Blk=cjk}', "");
    Expect(1, 40959, '\P{^Blk=cjk}', "");
    Expect(0, 40960, '\p{Blk=cjk}', "");
    Expect(1, 40960, '\p{^Blk=cjk}', "");
    Expect(1, 40960, '\P{Blk=cjk}', "");
    Expect(0, 40960, '\P{^Blk=cjk}', "");
    Expect(1, 40959, '\p{Blk=:\Acjk\z:}', "");;
    Expect(0, 40960, '\p{Blk=:\Acjk\z:}', "");;
    Expect(1, 40959, '\p{Blk=_-CJK}', "");
    Expect(0, 40959, '\p{^Blk=_-CJK}', "");
    Expect(0, 40959, '\P{Blk=_-CJK}', "");
    Expect(1, 40959, '\P{^Blk=_-CJK}', "");
    Expect(0, 40960, '\p{Blk=_-CJK}', "");
    Expect(1, 40960, '\p{^Blk=_-CJK}', "");
    Expect(1, 40960, '\P{Blk=_-CJK}', "");
    Expect(0, 40960, '\P{^Blk=_-CJK}', "");
    Error('\p{Is_Block=/a/	CJK_Unified_IDEOGRAPHS}');
    Error('\P{Is_Block=/a/	CJK_Unified_IDEOGRAPHS}');
    Expect(1, 40959, '\p{Is_Block=cjkunifiedideographs}', "");
    Expect(0, 40959, '\p{^Is_Block=cjkunifiedideographs}', "");
    Expect(0, 40959, '\P{Is_Block=cjkunifiedideographs}', "");
    Expect(1, 40959, '\P{^Is_Block=cjkunifiedideographs}', "");
    Expect(0, 40960, '\p{Is_Block=cjkunifiedideographs}', "");
    Expect(1, 40960, '\p{^Is_Block=cjkunifiedideographs}', "");
    Expect(1, 40960, '\P{Is_Block=cjkunifiedideographs}', "");
    Expect(0, 40960, '\P{^Is_Block=cjkunifiedideographs}', "");
    Expect(1, 40959, '\p{Is_Block=  cjk_UNIFIED_Ideographs}', "");
    Expect(0, 40959, '\p{^Is_Block=  cjk_UNIFIED_Ideographs}', "");
    Expect(0, 40959, '\P{Is_Block=  cjk_UNIFIED_Ideographs}', "");
    Expect(1, 40959, '\P{^Is_Block=  cjk_UNIFIED_Ideographs}', "");
    Expect(0, 40960, '\p{Is_Block=  cjk_UNIFIED_Ideographs}', "");
    Expect(1, 40960, '\p{^Is_Block=  cjk_UNIFIED_Ideographs}', "");
    Expect(1, 40960, '\P{Is_Block=  cjk_UNIFIED_Ideographs}', "");
    Expect(0, 40960, '\P{^Is_Block=  cjk_UNIFIED_Ideographs}', "");
    Error('\p{Is_Blk=-CJK/a/}');
    Error('\P{Is_Blk=-CJK/a/}');
    Expect(1, 40959, '\p{Is_Blk=cjk}', "");
    Expect(0, 40959, '\p{^Is_Blk=cjk}', "");
    Expect(0, 40959, '\P{Is_Blk=cjk}', "");
    Expect(1, 40959, '\P{^Is_Blk=cjk}', "");
    Expect(0, 40960, '\p{Is_Blk=cjk}', "");
    Expect(1, 40960, '\p{^Is_Blk=cjk}', "");
    Expect(1, 40960, '\P{Is_Blk=cjk}', "");
    Expect(0, 40960, '\P{^Is_Blk=cjk}', "");
    Expect(1, 40959, '\p{Is_Blk=-CJK}', "");
    Expect(0, 40959, '\p{^Is_Blk=-CJK}', "");
    Expect(0, 40959, '\P{Is_Blk=-CJK}', "");
    Expect(1, 40959, '\P{^Is_Blk=-CJK}', "");
    Expect(0, 40960, '\p{Is_Blk=-CJK}', "");
    Expect(1, 40960, '\p{^Is_Blk=-CJK}', "");
    Expect(1, 40960, '\P{Is_Blk=-CJK}', "");
    Expect(0, 40960, '\P{^Is_Blk=-CJK}', "");
    Error('\p{Block=/a/ -CJK_COMPATIBILITY}');
    Error('\P{Block=/a/ -CJK_COMPATIBILITY}');
    Expect(1, 13311, '\p{Block=:\ACJK_Compatibility\z:}', "");;
    Expect(0, 13312, '\p{Block=:\ACJK_Compatibility\z:}', "");;
    Expect(1, 13311, '\p{Block=cjkcompatibility}', "");
    Expect(0, 13311, '\p{^Block=cjkcompatibility}', "");
    Expect(0, 13311, '\P{Block=cjkcompatibility}', "");
    Expect(1, 13311, '\P{^Block=cjkcompatibility}', "");
    Expect(0, 13312, '\p{Block=cjkcompatibility}', "");
    Expect(1, 13312, '\p{^Block=cjkcompatibility}', "");
    Expect(1, 13312, '\P{Block=cjkcompatibility}', "");
    Expect(0, 13312, '\P{^Block=cjkcompatibility}', "");
    Expect(1, 13311, '\p{Block=:\Acjkcompatibility\z:}', "");;
    Expect(0, 13312, '\p{Block=:\Acjkcompatibility\z:}', "");;
    Expect(1, 13311, '\p{Block:    	cjk_Compatibility}', "");
    Expect(0, 13311, '\p{^Block:    	cjk_Compatibility}', "");
    Expect(0, 13311, '\P{Block:    	cjk_Compatibility}', "");
    Expect(1, 13311, '\P{^Block:    	cjk_Compatibility}', "");
    Expect(0, 13312, '\p{Block:    	cjk_Compatibility}', "");
    Expect(1, 13312, '\p{^Block:    	cjk_Compatibility}', "");
    Expect(1, 13312, '\P{Block:    	cjk_Compatibility}', "");
    Expect(0, 13312, '\P{^Block:    	cjk_Compatibility}', "");
    Error('\p{Blk: /a/CJK_compat}');
    Error('\P{Blk: /a/CJK_compat}');
    Expect(1, 13311, '\p{Blk=:\ACJK_Compat\z:}', "");;
    Expect(0, 13312, '\p{Blk=:\ACJK_Compat\z:}', "");;
    Expect(1, 13311, '\p{Blk=cjkcompat}', "");
    Expect(0, 13311, '\p{^Blk=cjkcompat}', "");
    Expect(0, 13311, '\P{Blk=cjkcompat}', "");
    Expect(1, 13311, '\P{^Blk=cjkcompat}', "");
    Expect(0, 13312, '\p{Blk=cjkcompat}', "");
    Expect(1, 13312, '\p{^Blk=cjkcompat}', "");
    Expect(1, 13312, '\P{Blk=cjkcompat}', "");
    Expect(0, 13312, '\P{^Blk=cjkcompat}', "");
    Expect(1, 13311, '\p{Blk=:\Acjkcompat\z:}', "");;
    Expect(0, 13312, '\p{Blk=:\Acjkcompat\z:}', "");;
    Expect(1, 13311, '\p{Blk= CJK_Compat}', "");
    Expect(0, 13311, '\p{^Blk= CJK_Compat}', "");
    Expect(0, 13311, '\P{Blk= CJK_Compat}', "");
    Expect(1, 13311, '\P{^Blk= CJK_Compat}', "");
    Expect(0, 13312, '\p{Blk= CJK_Compat}', "");
    Expect(1, 13312, '\p{^Blk= CJK_Compat}', "");
    Expect(1, 13312, '\P{Blk= CJK_Compat}', "");
    Expect(0, 13312, '\P{^Blk= CJK_Compat}', "");
    Error('\p{Is_Block=:= cjk_Compatibility}');
    Error('\P{Is_Block=:= cjk_Compatibility}');
    Expect(1, 13311, '\p{Is_Block=cjkcompatibility}', "");
    Expect(0, 13311, '\p{^Is_Block=cjkcompatibility}', "");
    Expect(0, 13311, '\P{Is_Block=cjkcompatibility}', "");
    Expect(1, 13311, '\P{^Is_Block=cjkcompatibility}', "");
    Expect(0, 13312, '\p{Is_Block=cjkcompatibility}', "");
    Expect(1, 13312, '\p{^Is_Block=cjkcompatibility}', "");
    Expect(1, 13312, '\P{Is_Block=cjkcompatibility}', "");
    Expect(0, 13312, '\P{^Is_Block=cjkcompatibility}', "");
    Expect(1, 13311, '\p{Is_Block=	 CJK_Compatibility}', "");
    Expect(0, 13311, '\p{^Is_Block=	 CJK_Compatibility}', "");
    Expect(0, 13311, '\P{Is_Block=	 CJK_Compatibility}', "");
    Expect(1, 13311, '\P{^Is_Block=	 CJK_Compatibility}', "");
    Expect(0, 13312, '\p{Is_Block=	 CJK_Compatibility}', "");
    Expect(1, 13312, '\p{^Is_Block=	 CJK_Compatibility}', "");
    Expect(1, 13312, '\P{Is_Block=	 CJK_Compatibility}', "");
    Expect(0, 13312, '\P{^Is_Block=	 CJK_Compatibility}', "");
    Error('\p{Is_Blk=/a/--CJK_COMPAT}');
    Error('\P{Is_Blk=/a/--CJK_COMPAT}');
    Expect(1, 13311, '\p{Is_Blk=cjkcompat}', "");
    Expect(0, 13311, '\p{^Is_Blk=cjkcompat}', "");
    Expect(0, 13311, '\P{Is_Blk=cjkcompat}', "");
    Expect(1, 13311, '\P{^Is_Blk=cjkcompat}', "");
    Expect(0, 13312, '\p{Is_Blk=cjkcompat}', "");
    Expect(1, 13312, '\p{^Is_Blk=cjkcompat}', "");
    Expect(1, 13312, '\P{Is_Blk=cjkcompat}', "");
    Expect(0, 13312, '\P{^Is_Blk=cjkcompat}', "");
    Expect(1, 13311, '\p{Is_Blk=_cjk_compat}', "");
    Expect(0, 13311, '\p{^Is_Blk=_cjk_compat}', "");
    Expect(0, 13311, '\P{Is_Blk=_cjk_compat}', "");
    Expect(1, 13311, '\P{^Is_Blk=_cjk_compat}', "");
    Expect(0, 13312, '\p{Is_Blk=_cjk_compat}', "");
    Expect(1, 13312, '\p{^Is_Blk=_cjk_compat}', "");
    Expect(1, 13312, '\P{Is_Blk=_cjk_compat}', "");
    Expect(0, 13312, '\P{^Is_Blk=_cjk_compat}', "");
    Error('\p{Block=		CJK_compatibility_FORMS/a/}');
    Error('\P{Block=		CJK_compatibility_FORMS/a/}');
    Expect(1, 65103, '\p{Block=:\ACJK_Compatibility_Forms\z:}', "");;
    Expect(0, 65104, '\p{Block=:\ACJK_Compatibility_Forms\z:}', "");;
    Expect(1, 65103, '\p{Block=cjkcompatibilityforms}', "");
    Expect(0, 65103, '\p{^Block=cjkcompatibilityforms}', "");
    Expect(0, 65103, '\P{Block=cjkcompatibilityforms}', "");
    Expect(1, 65103, '\P{^Block=cjkcompatibilityforms}', "");
    Expect(0, 65104, '\p{Block=cjkcompatibilityforms}', "");
    Expect(1, 65104, '\p{^Block=cjkcompatibilityforms}', "");
    Expect(1, 65104, '\P{Block=cjkcompatibilityforms}', "");
    Expect(0, 65104, '\P{^Block=cjkcompatibilityforms}', "");
    Expect(1, 65103, '\p{Block=:\Acjkcompatibilityforms\z:}', "");;
    Expect(0, 65104, '\p{Block=:\Acjkcompatibilityforms\z:}', "");;
    Expect(1, 65103, '\p{Block= 	CJK_Compatibility_forms}', "");
    Expect(0, 65103, '\p{^Block= 	CJK_Compatibility_forms}', "");
    Expect(0, 65103, '\P{Block= 	CJK_Compatibility_forms}', "");
    Expect(1, 65103, '\P{^Block= 	CJK_Compatibility_forms}', "");
    Expect(0, 65104, '\p{Block= 	CJK_Compatibility_forms}', "");
    Expect(1, 65104, '\p{^Block= 	CJK_Compatibility_forms}', "");
    Expect(1, 65104, '\P{Block= 	CJK_Compatibility_forms}', "");
    Expect(0, 65104, '\P{^Block= 	CJK_Compatibility_forms}', "");
    Error('\p{Blk=:= cjk_Compat_Forms}');
    Error('\P{Blk=:= cjk_Compat_Forms}');
    Expect(1, 65103, '\p{Blk=:\ACJK_Compat_Forms\z:}', "");;
    Expect(0, 65104, '\p{Blk=:\ACJK_Compat_Forms\z:}', "");;
    Expect(1, 65103, '\p{Blk=cjkcompatforms}', "");
    Expect(0, 65103, '\p{^Blk=cjkcompatforms}', "");
    Expect(0, 65103, '\P{Blk=cjkcompatforms}', "");
    Expect(1, 65103, '\P{^Blk=cjkcompatforms}', "");
    Expect(0, 65104, '\p{Blk=cjkcompatforms}', "");
    Expect(1, 65104, '\p{^Blk=cjkcompatforms}', "");
    Expect(1, 65104, '\P{Blk=cjkcompatforms}', "");
    Expect(0, 65104, '\P{^Blk=cjkcompatforms}', "");
    Expect(1, 65103, '\p{Blk=:\Acjkcompatforms\z:}', "");;
    Expect(0, 65104, '\p{Blk=:\Acjkcompatforms\z:}', "");;
    Expect(1, 65103, '\p{Blk:    CJK_compat_FORMS}', "");
    Expect(0, 65103, '\p{^Blk:    CJK_compat_FORMS}', "");
    Expect(0, 65103, '\P{Blk:    CJK_compat_FORMS}', "");
    Expect(1, 65103, '\P{^Blk:    CJK_compat_FORMS}', "");
    Expect(0, 65104, '\p{Blk:    CJK_compat_FORMS}', "");
    Expect(1, 65104, '\p{^Blk:    CJK_compat_FORMS}', "");
    Expect(1, 65104, '\P{Blk:    CJK_compat_FORMS}', "");
    Expect(0, 65104, '\P{^Blk:    CJK_compat_FORMS}', "");
    Error('\p{Is_Block=	 CJK_Compatibility_Forms/a/}');
    Error('\P{Is_Block=	 CJK_Compatibility_Forms/a/}');
    Expect(1, 65103, '\p{Is_Block=cjkcompatibilityforms}', "");
    Expect(0, 65103, '\p{^Is_Block=cjkcompatibilityforms}', "");
    Expect(0, 65103, '\P{Is_Block=cjkcompatibilityforms}', "");
    Expect(1, 65103, '\P{^Is_Block=cjkcompatibilityforms}', "");
    Expect(0, 65104, '\p{Is_Block=cjkcompatibilityforms}', "");
    Expect(1, 65104, '\p{^Is_Block=cjkcompatibilityforms}', "");
    Expect(1, 65104, '\P{Is_Block=cjkcompatibilityforms}', "");
    Expect(0, 65104, '\P{^Is_Block=cjkcompatibilityforms}', "");
    Expect(1, 65103, '\p{Is_Block=		CJK_compatibility_forms}', "");
    Expect(0, 65103, '\p{^Is_Block=		CJK_compatibility_forms}', "");
    Expect(0, 65103, '\P{Is_Block=		CJK_compatibility_forms}', "");
    Expect(1, 65103, '\P{^Is_Block=		CJK_compatibility_forms}', "");
    Expect(0, 65104, '\p{Is_Block=		CJK_compatibility_forms}', "");
    Expect(1, 65104, '\p{^Is_Block=		CJK_compatibility_forms}', "");
    Expect(1, 65104, '\P{Is_Block=		CJK_compatibility_forms}', "");
    Expect(0, 65104, '\P{^Is_Block=		CJK_compatibility_forms}', "");
    Error('\p{Is_Blk=/a/ -CJK_Compat_forms}');
    Error('\P{Is_Blk=/a/ -CJK_Compat_forms}');
    Expect(1, 65103, '\p{Is_Blk=cjkcompatforms}', "");
    Expect(0, 65103, '\p{^Is_Blk=cjkcompatforms}', "");
    Expect(0, 65103, '\P{Is_Blk=cjkcompatforms}', "");
    Expect(1, 65103, '\P{^Is_Blk=cjkcompatforms}', "");
    Expect(0, 65104, '\p{Is_Blk=cjkcompatforms}', "");
    Expect(1, 65104, '\p{^Is_Blk=cjkcompatforms}', "");
    Expect(1, 65104, '\P{Is_Blk=cjkcompatforms}', "");
    Expect(0, 65104, '\P{^Is_Blk=cjkcompatforms}', "");
    Expect(1, 65103, '\p{Is_Blk=--CJK_Compat_Forms}', "");
    Expect(0, 65103, '\p{^Is_Blk=--CJK_Compat_Forms}', "");
    Expect(0, 65103, '\P{Is_Blk=--CJK_Compat_Forms}', "");
    Expect(1, 65103, '\P{^Is_Blk=--CJK_Compat_Forms}', "");
    Expect(0, 65104, '\p{Is_Blk=--CJK_Compat_Forms}', "");
    Expect(1, 65104, '\p{^Is_Blk=--CJK_Compat_Forms}', "");
    Expect(1, 65104, '\P{Is_Blk=--CJK_Compat_Forms}', "");
    Expect(0, 65104, '\P{^Is_Blk=--CJK_Compat_Forms}', "");
    Error('\p{Block=/a/	CJK_Compatibility_ideographs}');
    Error('\P{Block=/a/	CJK_Compatibility_ideographs}');
    Expect(1, 64255, '\p{Block=:\ACJK_Compatibility_Ideographs\z:}', "");;
    Expect(0, 64256, '\p{Block=:\ACJK_Compatibility_Ideographs\z:}', "");;
    Expect(1, 64255, '\p{Block=cjkcompatibilityideographs}', "");
    Expect(0, 64255, '\p{^Block=cjkcompatibilityideographs}', "");
    Expect(0, 64255, '\P{Block=cjkcompatibilityideographs}', "");
    Expect(1, 64255, '\P{^Block=cjkcompatibilityideographs}', "");
    Expect(0, 64256, '\p{Block=cjkcompatibilityideographs}', "");
    Expect(1, 64256, '\p{^Block=cjkcompatibilityideographs}', "");
    Expect(1, 64256, '\P{Block=cjkcompatibilityideographs}', "");
    Expect(0, 64256, '\P{^Block=cjkcompatibilityideographs}', "");
    Expect(1, 64255, '\p{Block=:\Acjkcompatibilityideographs\z:}', "");;
    Expect(0, 64256, '\p{Block=:\Acjkcompatibilityideographs\z:}', "");;
    Expect(1, 64255, '\p{Block=--CJK_Compatibility_ideographs}', "");
    Expect(0, 64255, '\p{^Block=--CJK_Compatibility_ideographs}', "");
    Expect(0, 64255, '\P{Block=--CJK_Compatibility_ideographs}', "");
    Expect(1, 64255, '\P{^Block=--CJK_Compatibility_ideographs}', "");
    Expect(0, 64256, '\p{Block=--CJK_Compatibility_ideographs}', "");
    Expect(1, 64256, '\p{^Block=--CJK_Compatibility_ideographs}', "");
    Expect(1, 64256, '\P{Block=--CJK_Compatibility_ideographs}', "");
    Expect(0, 64256, '\P{^Block=--CJK_Compatibility_ideographs}', "");
    Error('\p{Blk: :=-	cjk_Compat_Ideographs}');
    Error('\P{Blk: :=-	cjk_Compat_Ideographs}');
    Expect(1, 64255, '\p{Blk=:\ACJK_Compat_Ideographs\z:}', "");;
    Expect(0, 64256, '\p{Blk=:\ACJK_Compat_Ideographs\z:}', "");;
    Expect(1, 64255, '\p{Blk=cjkcompatideographs}', "");
    Expect(0, 64255, '\p{^Blk=cjkcompatideographs}', "");
    Expect(0, 64255, '\P{Blk=cjkcompatideographs}', "");
    Expect(1, 64255, '\P{^Blk=cjkcompatideographs}', "");
    Expect(0, 64256, '\p{Blk=cjkcompatideographs}', "");
    Expect(1, 64256, '\p{^Blk=cjkcompatideographs}', "");
    Expect(1, 64256, '\P{Blk=cjkcompatideographs}', "");
    Expect(0, 64256, '\P{^Blk=cjkcompatideographs}', "");
    Expect(1, 64255, '\p{Blk=:\Acjkcompatideographs\z:}', "");;
    Expect(0, 64256, '\p{Blk=:\Acjkcompatideographs\z:}', "");;
    Expect(1, 64255, '\p{Blk=- cjk_compat_ideographs}', "");
    Expect(0, 64255, '\p{^Blk=- cjk_compat_ideographs}', "");
    Expect(0, 64255, '\P{Blk=- cjk_compat_ideographs}', "");
    Expect(1, 64255, '\P{^Blk=- cjk_compat_ideographs}', "");
    Expect(0, 64256, '\p{Blk=- cjk_compat_ideographs}', "");
    Expect(1, 64256, '\p{^Blk=- cjk_compat_ideographs}', "");
    Expect(1, 64256, '\P{Blk=- cjk_compat_ideographs}', "");
    Expect(0, 64256, '\P{^Blk=- cjk_compat_ideographs}', "");
    Error('\p{Is_Block= CJK_COMPATIBILITY_ideographs:=}');
    Error('\P{Is_Block= CJK_COMPATIBILITY_ideographs:=}');
    Expect(1, 64255, '\p{Is_Block=cjkcompatibilityideographs}', "");
    Expect(0, 64255, '\p{^Is_Block=cjkcompatibilityideographs}', "");
    Expect(0, 64255, '\P{Is_Block=cjkcompatibilityideographs}', "");
    Expect(1, 64255, '\P{^Is_Block=cjkcompatibilityideographs}', "");
    Expect(0, 64256, '\p{Is_Block=cjkcompatibilityideographs}', "");
    Expect(1, 64256, '\p{^Is_Block=cjkcompatibilityideographs}', "");
    Expect(1, 64256, '\P{Is_Block=cjkcompatibilityideographs}', "");
    Expect(0, 64256, '\P{^Is_Block=cjkcompatibilityideographs}', "");
    Expect(1, 64255, '\p{Is_Block= 	CJK_compatibility_Ideographs}', "");
    Expect(0, 64255, '\p{^Is_Block= 	CJK_compatibility_Ideographs}', "");
    Expect(0, 64255, '\P{Is_Block= 	CJK_compatibility_Ideographs}', "");
    Expect(1, 64255, '\P{^Is_Block= 	CJK_compatibility_Ideographs}', "");
    Expect(0, 64256, '\p{Is_Block= 	CJK_compatibility_Ideographs}', "");
    Expect(1, 64256, '\p{^Is_Block= 	CJK_compatibility_Ideographs}', "");
    Expect(1, 64256, '\P{Is_Block= 	CJK_compatibility_Ideographs}', "");
    Expect(0, 64256, '\P{^Is_Block= 	CJK_compatibility_Ideographs}', "");
    Error('\p{Is_Blk=/a/-	CJK_Compat_ideographs}');
    Error('\P{Is_Blk=/a/-	CJK_Compat_ideographs}');
    Expect(1, 64255, '\p{Is_Blk=cjkcompatideographs}', "");
    Expect(0, 64255, '\p{^Is_Blk=cjkcompatideographs}', "");
    Expect(0, 64255, '\P{Is_Blk=cjkcompatideographs}', "");
    Expect(1, 64255, '\P{^Is_Blk=cjkcompatideographs}', "");
    Expect(0, 64256, '\p{Is_Blk=cjkcompatideographs}', "");
    Expect(1, 64256, '\p{^Is_Blk=cjkcompatideographs}', "");
    Expect(1, 64256, '\P{Is_Blk=cjkcompatideographs}', "");
    Expect(0, 64256, '\P{^Is_Blk=cjkcompatideographs}', "");
    Expect(1, 64255, '\p{Is_Blk=-CJK_Compat_Ideographs}', "");
    Expect(0, 64255, '\p{^Is_Blk=-CJK_Compat_Ideographs}', "");
    Expect(0, 64255, '\P{Is_Blk=-CJK_Compat_Ideographs}', "");
    Expect(1, 64255, '\P{^Is_Blk=-CJK_Compat_Ideographs}', "");
    Expect(0, 64256, '\p{Is_Blk=-CJK_Compat_Ideographs}', "");
    Expect(1, 64256, '\p{^Is_Blk=-CJK_Compat_Ideographs}', "");
    Expect(1, 64256, '\P{Is_Blk=-CJK_Compat_Ideographs}', "");
    Expect(0, 64256, '\P{^Is_Blk=-CJK_Compat_Ideographs}', "");
    Error('\p{Block=	CJK_Compatibility_IDEOGRAPHS_SUPPLEMENT:=}');
    Error('\P{Block=	CJK_Compatibility_IDEOGRAPHS_SUPPLEMENT:=}');
    Expect(1, 195103, '\p{Block=:\ACJK_Compatibility_Ideographs_Supplement\z:}', "");;
    Expect(0, 195104, '\p{Block=:\ACJK_Compatibility_Ideographs_Supplement\z:}', "");;
    Expect(1, 195103, '\p{Block=cjkcompatibilityideographssupplement}', "");
    Expect(0, 195103, '\p{^Block=cjkcompatibilityideographssupplement}', "");
    Expect(0, 195103, '\P{Block=cjkcompatibilityideographssupplement}', "");
    Expect(1, 195103, '\P{^Block=cjkcompatibilityideographssupplement}', "");
    Expect(0, 195104, '\p{Block=cjkcompatibilityideographssupplement}', "");
    Expect(1, 195104, '\p{^Block=cjkcompatibilityideographssupplement}', "");
    Expect(1, 195104, '\P{Block=cjkcompatibilityideographssupplement}', "");
    Expect(0, 195104, '\P{^Block=cjkcompatibilityideographssupplement}', "");
    Expect(1, 195103, '\p{Block=:\Acjkcompatibilityideographssupplement\z:}', "");;
    Expect(0, 195104, '\p{Block=:\Acjkcompatibilityideographssupplement\z:}', "");;
    Expect(1, 195103, '\p{Block=CJK_COMPATIBILITY_ideographs_Supplement}', "");
    Expect(0, 195103, '\p{^Block=CJK_COMPATIBILITY_ideographs_Supplement}', "");
    Expect(0, 195103, '\P{Block=CJK_COMPATIBILITY_ideographs_Supplement}', "");
    Expect(1, 195103, '\P{^Block=CJK_COMPATIBILITY_ideographs_Supplement}', "");
    Expect(0, 195104, '\p{Block=CJK_COMPATIBILITY_ideographs_Supplement}', "");
    Expect(1, 195104, '\p{^Block=CJK_COMPATIBILITY_ideographs_Supplement}', "");
    Expect(1, 195104, '\P{Block=CJK_COMPATIBILITY_ideographs_Supplement}', "");
    Expect(0, 195104, '\P{^Block=CJK_COMPATIBILITY_ideographs_Supplement}', "");
    Error('\p{Blk=__CJK_compat_Ideographs_sup/a/}');
    Error('\P{Blk=__CJK_compat_Ideographs_sup/a/}');
    Expect(1, 195103, '\p{Blk=:\ACJK_Compat_Ideographs_Sup\z:}', "");;
    Expect(0, 195104, '\p{Blk=:\ACJK_Compat_Ideographs_Sup\z:}', "");;
    Expect(1, 195103, '\p{Blk:cjkcompatideographssup}', "");
    Expect(0, 195103, '\p{^Blk:cjkcompatideographssup}', "");
    Expect(0, 195103, '\P{Blk:cjkcompatideographssup}', "");
    Expect(1, 195103, '\P{^Blk:cjkcompatideographssup}', "");
    Expect(0, 195104, '\p{Blk:cjkcompatideographssup}', "");
    Expect(1, 195104, '\p{^Blk:cjkcompatideographssup}', "");
    Expect(1, 195104, '\P{Blk:cjkcompatideographssup}', "");
    Expect(0, 195104, '\P{^Blk:cjkcompatideographssup}', "");
    Expect(1, 195103, '\p{Blk=:\Acjkcompatideographssup\z:}', "");;
    Expect(0, 195104, '\p{Blk=:\Acjkcompatideographssup\z:}', "");;
    Expect(1, 195103, '\p{Blk=__cjk_compat_Ideographs_Sup}', "");
    Expect(0, 195103, '\p{^Blk=__cjk_compat_Ideographs_Sup}', "");
    Expect(0, 195103, '\P{Blk=__cjk_compat_Ideographs_Sup}', "");
    Expect(1, 195103, '\P{^Blk=__cjk_compat_Ideographs_Sup}', "");
    Expect(0, 195104, '\p{Blk=__cjk_compat_Ideographs_Sup}', "");
    Expect(1, 195104, '\p{^Blk=__cjk_compat_Ideographs_Sup}', "");
    Expect(1, 195104, '\P{Blk=__cjk_compat_Ideographs_Sup}', "");
    Expect(0, 195104, '\P{^Blk=__cjk_compat_Ideographs_Sup}', "");
    Error('\p{Is_Block=_:=cjk_compatibility_IDEOGRAPHS_supplement}');
    Error('\P{Is_Block=_:=cjk_compatibility_IDEOGRAPHS_supplement}');
    Expect(1, 195103, '\p{Is_Block=cjkcompatibilityideographssupplement}', "");
    Expect(0, 195103, '\p{^Is_Block=cjkcompatibilityideographssupplement}', "");
    Expect(0, 195103, '\P{Is_Block=cjkcompatibilityideographssupplement}', "");
    Expect(1, 195103, '\P{^Is_Block=cjkcompatibilityideographssupplement}', "");
    Expect(0, 195104, '\p{Is_Block=cjkcompatibilityideographssupplement}', "");
    Expect(1, 195104, '\p{^Is_Block=cjkcompatibilityideographssupplement}', "");
    Expect(1, 195104, '\P{Is_Block=cjkcompatibilityideographssupplement}', "");
    Expect(0, 195104, '\P{^Is_Block=cjkcompatibilityideographssupplement}', "");
    Expect(1, 195103, '\p{Is_Block:	 -CJK_compatibility_IDEOGRAPHS_SUPPLEMENT}', "");
    Expect(0, 195103, '\p{^Is_Block:	 -CJK_compatibility_IDEOGRAPHS_SUPPLEMENT}', "");
    Expect(0, 195103, '\P{Is_Block:	 -CJK_compatibility_IDEOGRAPHS_SUPPLEMENT}', "");
    Expect(1, 195103, '\P{^Is_Block:	 -CJK_compatibility_IDEOGRAPHS_SUPPLEMENT}', "");
    Expect(0, 195104, '\p{Is_Block:	 -CJK_compatibility_IDEOGRAPHS_SUPPLEMENT}', "");
    Expect(1, 195104, '\p{^Is_Block:	 -CJK_compatibility_IDEOGRAPHS_SUPPLEMENT}', "");
    Expect(1, 195104, '\P{Is_Block:	 -CJK_compatibility_IDEOGRAPHS_SUPPLEMENT}', "");
    Expect(0, 195104, '\P{^Is_Block:	 -CJK_compatibility_IDEOGRAPHS_SUPPLEMENT}', "");
    Error('\p{Is_Blk=/a/ 	CJK_Compat_ideographs_Sup}');
    Error('\P{Is_Blk=/a/ 	CJK_Compat_ideographs_Sup}');
    Expect(1, 195103, '\p{Is_Blk=cjkcompatideographssup}', "");
    Expect(0, 195103, '\p{^Is_Blk=cjkcompatideographssup}', "");
    Expect(0, 195103, '\P{Is_Blk=cjkcompatideographssup}', "");
    Expect(1, 195103, '\P{^Is_Blk=cjkcompatideographssup}', "");
    Expect(0, 195104, '\p{Is_Blk=cjkcompatideographssup}', "");
    Expect(1, 195104, '\p{^Is_Blk=cjkcompatideographssup}', "");
    Expect(1, 195104, '\P{Is_Blk=cjkcompatideographssup}', "");
    Expect(0, 195104, '\P{^Is_Blk=cjkcompatideographssup}', "");
    Expect(1, 195103, '\p{Is_Blk= CJK_COMPAT_Ideographs_Sup}', "");
    Expect(0, 195103, '\p{^Is_Blk= CJK_COMPAT_Ideographs_Sup}', "");
    Expect(0, 195103, '\P{Is_Blk= CJK_COMPAT_Ideographs_Sup}', "");
    Expect(1, 195103, '\P{^Is_Blk= CJK_COMPAT_Ideographs_Sup}', "");
    Expect(0, 195104, '\p{Is_Blk= CJK_COMPAT_Ideographs_Sup}', "");
    Expect(1, 195104, '\p{^Is_Blk= CJK_COMPAT_Ideographs_Sup}', "");
    Expect(1, 195104, '\P{Is_Blk= CJK_COMPAT_Ideographs_Sup}', "");
    Expect(0, 195104, '\P{^Is_Blk= CJK_COMPAT_Ideographs_Sup}', "");
    Error('\p{Block=	/a/cjk_Unified_ideographs_EXTENSION_A}');
    Error('\P{Block=	/a/cjk_Unified_ideographs_EXTENSION_A}');
    Expect(1, 19903, '\p{Block=:\ACJK_Unified_Ideographs_Extension_A\z:}', "");;
    Expect(0, 19904, '\p{Block=:\ACJK_Unified_Ideographs_Extension_A\z:}', "");;
    Expect(1, 19903, '\p{Block=cjkunifiedideographsextensiona}', "");
    Expect(0, 19903, '\p{^Block=cjkunifiedideographsextensiona}', "");
    Expect(0, 19903, '\P{Block=cjkunifiedideographsextensiona}', "");
    Expect(1, 19903, '\P{^Block=cjkunifiedideographsextensiona}', "");
    Expect(0, 19904, '\p{Block=cjkunifiedideographsextensiona}', "");
    Expect(1, 19904, '\p{^Block=cjkunifiedideographsextensiona}', "");
    Expect(1, 19904, '\P{Block=cjkunifiedideographsextensiona}', "");
    Expect(0, 19904, '\P{^Block=cjkunifiedideographsextensiona}', "");
    Expect(1, 19903, '\p{Block=:\Acjkunifiedideographsextensiona\z:}', "");;
    Expect(0, 19904, '\p{Block=:\Acjkunifiedideographsextensiona\z:}', "");;
    Expect(1, 19903, '\p{Block=	-CJK_unified_Ideographs_Extension_A}', "");
    Expect(0, 19903, '\p{^Block=	-CJK_unified_Ideographs_Extension_A}', "");
    Expect(0, 19903, '\P{Block=	-CJK_unified_Ideographs_Extension_A}', "");
    Expect(1, 19903, '\P{^Block=	-CJK_unified_Ideographs_Extension_A}', "");
    Expect(0, 19904, '\p{Block=	-CJK_unified_Ideographs_Extension_A}', "");
    Expect(1, 19904, '\p{^Block=	-CJK_unified_Ideographs_Extension_A}', "");
    Expect(1, 19904, '\P{Block=	-CJK_unified_Ideographs_Extension_A}', "");
    Expect(0, 19904, '\P{^Block=	-CJK_unified_Ideographs_Extension_A}', "");
    Error('\p{Blk=/a/_	CJK_ext_A}');
    Error('\P{Blk=/a/_	CJK_ext_A}');
    Expect(1, 19903, '\p{Blk=:\ACJK_Ext_A\z:}', "");;
    Expect(0, 19904, '\p{Blk=:\ACJK_Ext_A\z:}', "");;
    Expect(1, 19903, '\p{Blk=cjkexta}', "");
    Expect(0, 19903, '\p{^Blk=cjkexta}', "");
    Expect(0, 19903, '\P{Blk=cjkexta}', "");
    Expect(1, 19903, '\P{^Blk=cjkexta}', "");
    Expect(0, 19904, '\p{Blk=cjkexta}', "");
    Expect(1, 19904, '\p{^Blk=cjkexta}', "");
    Expect(1, 19904, '\P{Blk=cjkexta}', "");
    Expect(0, 19904, '\P{^Blk=cjkexta}', "");
    Expect(1, 19903, '\p{Blk=:\Acjkexta\z:}', "");;
    Expect(0, 19904, '\p{Blk=:\Acjkexta\z:}', "");;
    Expect(1, 19903, '\p{Blk=- CJK_Ext_a}', "");
    Expect(0, 19903, '\p{^Blk=- CJK_Ext_a}', "");
    Expect(0, 19903, '\P{Blk=- CJK_Ext_a}', "");
    Expect(1, 19903, '\P{^Blk=- CJK_Ext_a}', "");
    Expect(0, 19904, '\p{Blk=- CJK_Ext_a}', "");
    Expect(1, 19904, '\p{^Blk=- CJK_Ext_a}', "");
    Expect(1, 19904, '\P{Blk=- CJK_Ext_a}', "");
    Expect(0, 19904, '\P{^Blk=- CJK_Ext_a}', "");
    Error('\p{Is_Block=-:=CJK_Unified_Ideographs_Extension_a}');
    Error('\P{Is_Block=-:=CJK_Unified_Ideographs_Extension_a}');
    Expect(1, 19903, '\p{Is_Block=cjkunifiedideographsextensiona}', "");
    Expect(0, 19903, '\p{^Is_Block=cjkunifiedideographsextensiona}', "");
    Expect(0, 19903, '\P{Is_Block=cjkunifiedideographsextensiona}', "");
    Expect(1, 19903, '\P{^Is_Block=cjkunifiedideographsextensiona}', "");
    Expect(0, 19904, '\p{Is_Block=cjkunifiedideographsextensiona}', "");
    Expect(1, 19904, '\p{^Is_Block=cjkunifiedideographsextensiona}', "");
    Expect(1, 19904, '\P{Is_Block=cjkunifiedideographsextensiona}', "");
    Expect(0, 19904, '\P{^Is_Block=cjkunifiedideographsextensiona}', "");
    Expect(1, 19903, '\p{Is_Block= -CJK_unified_IDEOGRAPHS_Extension_a}', "");
    Expect(0, 19903, '\p{^Is_Block= -CJK_unified_IDEOGRAPHS_Extension_a}', "");
    Expect(0, 19903, '\P{Is_Block= -CJK_unified_IDEOGRAPHS_Extension_a}', "");
    Expect(1, 19903, '\P{^Is_Block= -CJK_unified_IDEOGRAPHS_Extension_a}', "");
    Expect(0, 19904, '\p{Is_Block= -CJK_unified_IDEOGRAPHS_Extension_a}', "");
    Expect(1, 19904, '\p{^Is_Block= -CJK_unified_IDEOGRAPHS_Extension_a}', "");
    Expect(1, 19904, '\P{Is_Block= -CJK_unified_IDEOGRAPHS_Extension_a}', "");
    Expect(0, 19904, '\P{^Is_Block= -CJK_unified_IDEOGRAPHS_Extension_a}', "");
    Error('\p{Is_Blk=/a/_CJK_EXT_A}');
    Error('\P{Is_Blk=/a/_CJK_EXT_A}');
    Expect(1, 19903, '\p{Is_Blk=cjkexta}', "");
    Expect(0, 19903, '\p{^Is_Blk=cjkexta}', "");
    Expect(0, 19903, '\P{Is_Blk=cjkexta}', "");
    Expect(1, 19903, '\P{^Is_Blk=cjkexta}', "");
    Expect(0, 19904, '\p{Is_Blk=cjkexta}', "");
    Expect(1, 19904, '\p{^Is_Blk=cjkexta}', "");
    Expect(1, 19904, '\P{Is_Blk=cjkexta}', "");
    Expect(0, 19904, '\P{^Is_Blk=cjkexta}', "");
    Expect(1, 19903, '\p{Is_Blk:--CJK_EXT_A}', "");
    Expect(0, 19903, '\p{^Is_Blk:--CJK_EXT_A}', "");
    Expect(0, 19903, '\P{Is_Blk:--CJK_EXT_A}', "");
    Expect(1, 19903, '\P{^Is_Blk:--CJK_EXT_A}', "");
    Expect(0, 19904, '\p{Is_Blk:--CJK_EXT_A}', "");
    Expect(1, 19904, '\p{^Is_Blk:--CJK_EXT_A}', "");
    Expect(1, 19904, '\P{Is_Blk:--CJK_EXT_A}', "");
    Expect(0, 19904, '\P{^Is_Blk:--CJK_EXT_A}', "");
    Error('\p{Block=_CJK_UNIFIED_ideographs_extension_B/a/}');
    Error('\P{Block=_CJK_UNIFIED_ideographs_extension_B/a/}');
    Expect(1, 173791, '\p{Block=:\ACJK_Unified_Ideographs_Extension_B\z:}', "");;
    Expect(0, 173792, '\p{Block=:\ACJK_Unified_Ideographs_Extension_B\z:}', "");;
    Expect(1, 173791, '\p{Block=cjkunifiedideographsextensionb}', "");
    Expect(0, 173791, '\p{^Block=cjkunifiedideographsextensionb}', "");
    Expect(0, 173791, '\P{Block=cjkunifiedideographsextensionb}', "");
    Expect(1, 173791, '\P{^Block=cjkunifiedideographsextensionb}', "");
    Expect(0, 173792, '\p{Block=cjkunifiedideographsextensionb}', "");
    Expect(1, 173792, '\p{^Block=cjkunifiedideographsextensionb}', "");
    Expect(1, 173792, '\P{Block=cjkunifiedideographsextensionb}', "");
    Expect(0, 173792, '\P{^Block=cjkunifiedideographsextensionb}', "");
    Expect(1, 173791, '\p{Block=:\Acjkunifiedideographsextensionb\z:}', "");;
    Expect(0, 173792, '\p{Block=:\Acjkunifiedideographsextensionb\z:}', "");;
    Expect(1, 173791, '\p{Block=--CJK_Unified_Ideographs_Extension_B}', "");
    Expect(0, 173791, '\p{^Block=--CJK_Unified_Ideographs_Extension_B}', "");
    Expect(0, 173791, '\P{Block=--CJK_Unified_Ideographs_Extension_B}', "");
    Expect(1, 173791, '\P{^Block=--CJK_Unified_Ideographs_Extension_B}', "");
    Expect(0, 173792, '\p{Block=--CJK_Unified_Ideographs_Extension_B}', "");
    Expect(1, 173792, '\p{^Block=--CJK_Unified_Ideographs_Extension_B}', "");
    Expect(1, 173792, '\P{Block=--CJK_Unified_Ideographs_Extension_B}', "");
    Expect(0, 173792, '\P{^Block=--CJK_Unified_Ideographs_Extension_B}', "");
    Error('\p{Blk=_CJK_Ext_B/a/}');
    Error('\P{Blk=_CJK_Ext_B/a/}');
    Expect(1, 173791, '\p{Blk=:\ACJK_Ext_B\z:}', "");;
    Expect(0, 173792, '\p{Blk=:\ACJK_Ext_B\z:}', "");;
    Expect(1, 173791, '\p{Blk:cjkextb}', "");
    Expect(0, 173791, '\p{^Blk:cjkextb}', "");
    Expect(0, 173791, '\P{Blk:cjkextb}', "");
    Expect(1, 173791, '\P{^Blk:cjkextb}', "");
    Expect(0, 173792, '\p{Blk:cjkextb}', "");
    Expect(1, 173792, '\p{^Blk:cjkextb}', "");
    Expect(1, 173792, '\P{Blk:cjkextb}', "");
    Expect(0, 173792, '\P{^Blk:cjkextb}', "");
    Expect(1, 173791, '\p{Blk=:\Acjkextb\z:}', "");;
    Expect(0, 173792, '\p{Blk=:\Acjkextb\z:}', "");;
    Expect(1, 173791, '\p{Blk:	-CJK_ext_B}', "");
    Expect(0, 173791, '\p{^Blk:	-CJK_ext_B}', "");
    Expect(0, 173791, '\P{Blk:	-CJK_ext_B}', "");
    Expect(1, 173791, '\P{^Blk:	-CJK_ext_B}', "");
    Expect(0, 173792, '\p{Blk:	-CJK_ext_B}', "");
    Expect(1, 173792, '\p{^Blk:	-CJK_ext_B}', "");
    Expect(1, 173792, '\P{Blk:	-CJK_ext_B}', "");
    Expect(0, 173792, '\P{^Blk:	-CJK_ext_B}', "");
    Error('\p{Is_Block: -cjk_unified_IDEOGRAPHS_Extension_B:=}');
    Error('\P{Is_Block: -cjk_unified_IDEOGRAPHS_Extension_B:=}');
    Expect(1, 173791, '\p{Is_Block:	cjkunifiedideographsextensionb}', "");
    Expect(0, 173791, '\p{^Is_Block:	cjkunifiedideographsextensionb}', "");
    Expect(0, 173791, '\P{Is_Block:	cjkunifiedideographsextensionb}', "");
    Expect(1, 173791, '\P{^Is_Block:	cjkunifiedideographsextensionb}', "");
    Expect(0, 173792, '\p{Is_Block:	cjkunifiedideographsextensionb}', "");
    Expect(1, 173792, '\p{^Is_Block:	cjkunifiedideographsextensionb}', "");
    Expect(1, 173792, '\P{Is_Block:	cjkunifiedideographsextensionb}', "");
    Expect(0, 173792, '\P{^Is_Block:	cjkunifiedideographsextensionb}', "");
    Expect(1, 173791, '\p{Is_Block=-cjk_UNIFIED_Ideographs_extension_b}', "");
    Expect(0, 173791, '\p{^Is_Block=-cjk_UNIFIED_Ideographs_extension_b}', "");
    Expect(0, 173791, '\P{Is_Block=-cjk_UNIFIED_Ideographs_extension_b}', "");
    Expect(1, 173791, '\P{^Is_Block=-cjk_UNIFIED_Ideographs_extension_b}', "");
    Expect(0, 173792, '\p{Is_Block=-cjk_UNIFIED_Ideographs_extension_b}', "");
    Expect(1, 173792, '\p{^Is_Block=-cjk_UNIFIED_Ideographs_extension_b}', "");
    Expect(1, 173792, '\P{Is_Block=-cjk_UNIFIED_Ideographs_extension_b}', "");
    Expect(0, 173792, '\P{^Is_Block=-cjk_UNIFIED_Ideographs_extension_b}', "");
    Error('\p{Is_Blk=:=--CJK_EXT_B}');
    Error('\P{Is_Blk=:=--CJK_EXT_B}');
    Expect(1, 173791, '\p{Is_Blk=cjkextb}', "");
    Expect(0, 173791, '\p{^Is_Blk=cjkextb}', "");
    Expect(0, 173791, '\P{Is_Blk=cjkextb}', "");
    Expect(1, 173791, '\P{^Is_Blk=cjkextb}', "");
    Expect(0, 173792, '\p{Is_Blk=cjkextb}', "");
    Expect(1, 173792, '\p{^Is_Blk=cjkextb}', "");
    Expect(1, 173792, '\P{Is_Blk=cjkextb}', "");
    Expect(0, 173792, '\P{^Is_Blk=cjkextb}', "");
    Expect(1, 173791, '\p{Is_Blk= _CJK_ext_B}', "");
    Expect(0, 173791, '\p{^Is_Blk= _CJK_ext_B}', "");
    Expect(0, 173791, '\P{Is_Blk= _CJK_ext_B}', "");
    Expect(1, 173791, '\P{^Is_Blk= _CJK_ext_B}', "");
    Expect(0, 173792, '\p{Is_Blk= _CJK_ext_B}', "");
    Expect(1, 173792, '\p{^Is_Blk= _CJK_ext_B}', "");
    Expect(1, 173792, '\P{Is_Blk= _CJK_ext_B}', "");
    Expect(0, 173792, '\P{^Is_Blk= _CJK_ext_B}', "");
    Error('\p{Block=	-CJK_unified_IDEOGRAPHS_EXTENSION_c:=}');
    Error('\P{Block=	-CJK_unified_IDEOGRAPHS_EXTENSION_c:=}');
    Expect(1, 177983, '\p{Block=:\ACJK_Unified_Ideographs_Extension_C\z:}', "");;
    Expect(0, 177984, '\p{Block=:\ACJK_Unified_Ideographs_Extension_C\z:}', "");;
    Expect(1, 177983, '\p{Block=cjkunifiedideographsextensionc}', "");
    Expect(0, 177983, '\p{^Block=cjkunifiedideographsextensionc}', "");
    Expect(0, 177983, '\P{Block=cjkunifiedideographsextensionc}', "");
    Expect(1, 177983, '\P{^Block=cjkunifiedideographsextensionc}', "");
    Expect(0, 177984, '\p{Block=cjkunifiedideographsextensionc}', "");
    Expect(1, 177984, '\p{^Block=cjkunifiedideographsextensionc}', "");
    Expect(1, 177984, '\P{Block=cjkunifiedideographsextensionc}', "");
    Expect(0, 177984, '\P{^Block=cjkunifiedideographsextensionc}', "");
    Expect(1, 177983, '\p{Block=:\Acjkunifiedideographsextensionc\z:}', "");;
    Expect(0, 177984, '\p{Block=:\Acjkunifiedideographsextensionc\z:}', "");;
    Expect(1, 177983, '\p{Block=_-CJK_Unified_Ideographs_extension_c}', "");
    Expect(0, 177983, '\p{^Block=_-CJK_Unified_Ideographs_extension_c}', "");
    Expect(0, 177983, '\P{Block=_-CJK_Unified_Ideographs_extension_c}', "");
    Expect(1, 177983, '\P{^Block=_-CJK_Unified_Ideographs_extension_c}', "");
    Expect(0, 177984, '\p{Block=_-CJK_Unified_Ideographs_extension_c}', "");
    Expect(1, 177984, '\p{^Block=_-CJK_Unified_Ideographs_extension_c}', "");
    Expect(1, 177984, '\P{Block=_-CJK_Unified_Ideographs_extension_c}', "");
    Expect(0, 177984, '\P{^Block=_-CJK_Unified_Ideographs_extension_c}', "");
    Error('\p{Blk=_:=CJK_Ext_c}');
    Error('\P{Blk=_:=CJK_Ext_c}');
    Expect(1, 177983, '\p{Blk=:\ACJK_Ext_C\z:}', "");;
    Expect(0, 177984, '\p{Blk=:\ACJK_Ext_C\z:}', "");;
    Expect(1, 177983, '\p{Blk:cjkextc}', "");
    Expect(0, 177983, '\p{^Blk:cjkextc}', "");
    Expect(0, 177983, '\P{Blk:cjkextc}', "");
    Expect(1, 177983, '\P{^Blk:cjkextc}', "");
    Expect(0, 177984, '\p{Blk:cjkextc}', "");
    Expect(1, 177984, '\p{^Blk:cjkextc}', "");
    Expect(1, 177984, '\P{Blk:cjkextc}', "");
    Expect(0, 177984, '\P{^Blk:cjkextc}', "");
    Expect(1, 177983, '\p{Blk=:\Acjkextc\z:}', "");;
    Expect(0, 177984, '\p{Blk=:\Acjkextc\z:}', "");;
    Expect(1, 177983, '\p{Blk=_cjk_ext_c}', "");
    Expect(0, 177983, '\p{^Blk=_cjk_ext_c}', "");
    Expect(0, 177983, '\P{Blk=_cjk_ext_c}', "");
    Expect(1, 177983, '\P{^Blk=_cjk_ext_c}', "");
    Expect(0, 177984, '\p{Blk=_cjk_ext_c}', "");
    Expect(1, 177984, '\p{^Blk=_cjk_ext_c}', "");
    Expect(1, 177984, '\P{Blk=_cjk_ext_c}', "");
    Expect(0, 177984, '\P{^Blk=_cjk_ext_c}', "");
    Error('\p{Is_Block=/a/ 	CJK_UNIFIED_Ideographs_Extension_C}');
    Error('\P{Is_Block=/a/ 	CJK_UNIFIED_Ideographs_Extension_C}');
    Expect(1, 177983, '\p{Is_Block=cjkunifiedideographsextensionc}', "");
    Expect(0, 177983, '\p{^Is_Block=cjkunifiedideographsextensionc}', "");
    Expect(0, 177983, '\P{Is_Block=cjkunifiedideographsextensionc}', "");
    Expect(1, 177983, '\P{^Is_Block=cjkunifiedideographsextensionc}', "");
    Expect(0, 177984, '\p{Is_Block=cjkunifiedideographsextensionc}', "");
    Expect(1, 177984, '\p{^Is_Block=cjkunifiedideographsextensionc}', "");
    Expect(1, 177984, '\P{Is_Block=cjkunifiedideographsextensionc}', "");
    Expect(0, 177984, '\P{^Is_Block=cjkunifiedideographsextensionc}', "");
    Expect(1, 177983, '\p{Is_Block:    _cjk_unified_Ideographs_Extension_c}', "");
    Expect(0, 177983, '\p{^Is_Block:    _cjk_unified_Ideographs_Extension_c}', "");
    Expect(0, 177983, '\P{Is_Block:    _cjk_unified_Ideographs_Extension_c}', "");
    Expect(1, 177983, '\P{^Is_Block:    _cjk_unified_Ideographs_Extension_c}', "");
    Expect(0, 177984, '\p{Is_Block:    _cjk_unified_Ideographs_Extension_c}', "");
    Expect(1, 177984, '\p{^Is_Block:    _cjk_unified_Ideographs_Extension_c}', "");
    Expect(1, 177984, '\P{Is_Block:    _cjk_unified_Ideographs_Extension_c}', "");
    Expect(0, 177984, '\P{^Is_Block:    _cjk_unified_Ideographs_Extension_c}', "");
    Error('\p{Is_Blk= 	CJK_Ext_C:=}');
    Error('\P{Is_Blk= 	CJK_Ext_C:=}');
    Expect(1, 177983, '\p{Is_Blk=cjkextc}', "");
    Expect(0, 177983, '\p{^Is_Blk=cjkextc}', "");
    Expect(0, 177983, '\P{Is_Blk=cjkextc}', "");
    Expect(1, 177983, '\P{^Is_Blk=cjkextc}', "");
    Expect(0, 177984, '\p{Is_Blk=cjkextc}', "");
    Expect(1, 177984, '\p{^Is_Blk=cjkextc}', "");
    Expect(1, 177984, '\P{Is_Blk=cjkextc}', "");
    Expect(0, 177984, '\P{^Is_Blk=cjkextc}', "");
    Expect(1, 177983, '\p{Is_Blk=	CJK_ext_c}', "");
    Expect(0, 177983, '\p{^Is_Blk=	CJK_ext_c}', "");
    Expect(0, 177983, '\P{Is_Blk=	CJK_ext_c}', "");
    Expect(1, 177983, '\P{^Is_Blk=	CJK_ext_c}', "");
    Expect(0, 177984, '\p{Is_Blk=	CJK_ext_c}', "");
    Expect(1, 177984, '\p{^Is_Blk=	CJK_ext_c}', "");
    Expect(1, 177984, '\P{Is_Blk=	CJK_ext_c}', "");
    Expect(0, 177984, '\P{^Is_Blk=	CJK_ext_c}', "");
    Error('\p{Block=/a/- CJK_Unified_Ideographs_EXTENSION_d}');
    Error('\P{Block=/a/- CJK_Unified_Ideographs_EXTENSION_d}');
    Expect(1, 178207, '\p{Block=:\ACJK_Unified_Ideographs_Extension_D\z:}', "");;
    Expect(0, 178208, '\p{Block=:\ACJK_Unified_Ideographs_Extension_D\z:}', "");;
    Expect(1, 178207, '\p{Block=cjkunifiedideographsextensiond}', "");
    Expect(0, 178207, '\p{^Block=cjkunifiedideographsextensiond}', "");
    Expect(0, 178207, '\P{Block=cjkunifiedideographsextensiond}', "");
    Expect(1, 178207, '\P{^Block=cjkunifiedideographsextensiond}', "");
    Expect(0, 178208, '\p{Block=cjkunifiedideographsextensiond}', "");
    Expect(1, 178208, '\p{^Block=cjkunifiedideographsextensiond}', "");
    Expect(1, 178208, '\P{Block=cjkunifiedideographsextensiond}', "");
    Expect(0, 178208, '\P{^Block=cjkunifiedideographsextensiond}', "");
    Expect(1, 178207, '\p{Block=:\Acjkunifiedideographsextensiond\z:}', "");;
    Expect(0, 178208, '\p{Block=:\Acjkunifiedideographsextensiond\z:}', "");;
    Expect(1, 178207, '\p{Block=CJK_unified_ideographs_extension_D}', "");
    Expect(0, 178207, '\p{^Block=CJK_unified_ideographs_extension_D}', "");
    Expect(0, 178207, '\P{Block=CJK_unified_ideographs_extension_D}', "");
    Expect(1, 178207, '\P{^Block=CJK_unified_ideographs_extension_D}', "");
    Expect(0, 178208, '\p{Block=CJK_unified_ideographs_extension_D}', "");
    Expect(1, 178208, '\p{^Block=CJK_unified_ideographs_extension_D}', "");
    Expect(1, 178208, '\P{Block=CJK_unified_ideographs_extension_D}', "");
    Expect(0, 178208, '\P{^Block=CJK_unified_ideographs_extension_D}', "");
    Error('\p{Blk=		CJK_ext_D:=}');
    Error('\P{Blk=		CJK_ext_D:=}');
    Expect(1, 178207, '\p{Blk=:\ACJK_Ext_D\z:}', "");;
    Expect(0, 178208, '\p{Blk=:\ACJK_Ext_D\z:}', "");;
    Expect(1, 178207, '\p{Blk=cjkextd}', "");
    Expect(0, 178207, '\p{^Blk=cjkextd}', "");
    Expect(0, 178207, '\P{Blk=cjkextd}', "");
    Expect(1, 178207, '\P{^Blk=cjkextd}', "");
    Expect(0, 178208, '\p{Blk=cjkextd}', "");
    Expect(1, 178208, '\p{^Blk=cjkextd}', "");
    Expect(1, 178208, '\P{Blk=cjkextd}', "");
    Expect(0, 178208, '\P{^Blk=cjkextd}', "");
    Expect(1, 178207, '\p{Blk=:\Acjkextd\z:}', "");;
    Expect(0, 178208, '\p{Blk=:\Acjkextd\z:}', "");;
    Expect(1, 178207, '\p{Blk=--CJK_Ext_D}', "");
    Expect(0, 178207, '\p{^Blk=--CJK_Ext_D}', "");
    Expect(0, 178207, '\P{Blk=--CJK_Ext_D}', "");
    Expect(1, 178207, '\P{^Blk=--CJK_Ext_D}', "");
    Expect(0, 178208, '\p{Blk=--CJK_Ext_D}', "");
    Expect(1, 178208, '\p{^Blk=--CJK_Ext_D}', "");
    Expect(1, 178208, '\P{Blk=--CJK_Ext_D}', "");
    Expect(0, 178208, '\P{^Blk=--CJK_Ext_D}', "");
    Error('\p{Is_Block=		CJK_unified_IDEOGRAPHS_extension_D:=}');
    Error('\P{Is_Block=		CJK_unified_IDEOGRAPHS_extension_D:=}');
    Expect(1, 178207, '\p{Is_Block=cjkunifiedideographsextensiond}', "");
    Expect(0, 178207, '\p{^Is_Block=cjkunifiedideographsextensiond}', "");
    Expect(0, 178207, '\P{Is_Block=cjkunifiedideographsextensiond}', "");
    Expect(1, 178207, '\P{^Is_Block=cjkunifiedideographsextensiond}', "");
    Expect(0, 178208, '\p{Is_Block=cjkunifiedideographsextensiond}', "");
    Expect(1, 178208, '\p{^Is_Block=cjkunifiedideographsextensiond}', "");
    Expect(1, 178208, '\P{Is_Block=cjkunifiedideographsextensiond}', "");
    Expect(0, 178208, '\P{^Is_Block=cjkunifiedideographsextensiond}', "");
    Expect(1, 178207, '\p{Is_Block=		CJK_unified_ideographs_EXTENSION_D}', "");
    Expect(0, 178207, '\p{^Is_Block=		CJK_unified_ideographs_EXTENSION_D}', "");
    Expect(0, 178207, '\P{Is_Block=		CJK_unified_ideographs_EXTENSION_D}', "");
    Expect(1, 178207, '\P{^Is_Block=		CJK_unified_ideographs_EXTENSION_D}', "");
    Expect(0, 178208, '\p{Is_Block=		CJK_unified_ideographs_EXTENSION_D}', "");
    Expect(1, 178208, '\p{^Is_Block=		CJK_unified_ideographs_EXTENSION_D}', "");
    Expect(1, 178208, '\P{Is_Block=		CJK_unified_ideographs_EXTENSION_D}', "");
    Expect(0, 178208, '\P{^Is_Block=		CJK_unified_ideographs_EXTENSION_D}', "");
    Error('\p{Is_Blk=/a/CJK_EXT_D}');
    Error('\P{Is_Blk=/a/CJK_EXT_D}');
    Expect(1, 178207, '\p{Is_Blk=cjkextd}', "");
    Expect(0, 178207, '\p{^Is_Blk=cjkextd}', "");
    Expect(0, 178207, '\P{Is_Blk=cjkextd}', "");
    Expect(1, 178207, '\P{^Is_Blk=cjkextd}', "");
    Expect(0, 178208, '\p{Is_Blk=cjkextd}', "");
    Expect(1, 178208, '\p{^Is_Blk=cjkextd}', "");
    Expect(1, 178208, '\P{Is_Blk=cjkextd}', "");
    Expect(0, 178208, '\P{^Is_Blk=cjkextd}', "");
    Expect(1, 178207, '\p{Is_Blk= 	CJK_EXT_d}', "");
    Expect(0, 178207, '\p{^Is_Blk= 	CJK_EXT_d}', "");
    Expect(0, 178207, '\P{Is_Blk= 	CJK_EXT_d}', "");
    Expect(1, 178207, '\P{^Is_Blk= 	CJK_EXT_d}', "");
    Expect(0, 178208, '\p{Is_Blk= 	CJK_EXT_d}', "");
    Expect(1, 178208, '\p{^Is_Blk= 	CJK_EXT_d}', "");
    Expect(1, 178208, '\P{Is_Blk= 	CJK_EXT_d}', "");
    Expect(0, 178208, '\P{^Is_Blk= 	CJK_EXT_d}', "");
    Error('\p{Block=_:=CJK_Unified_Ideographs_Extension_E}');
    Error('\P{Block=_:=CJK_Unified_Ideographs_Extension_E}');
    Expect(1, 183983, '\p{Block=:\ACJK_Unified_Ideographs_Extension_E\z:}', "");;
    Expect(0, 183984, '\p{Block=:\ACJK_Unified_Ideographs_Extension_E\z:}', "");;
    Expect(1, 183983, '\p{Block: cjkunifiedideographsextensione}', "");
    Expect(0, 183983, '\p{^Block: cjkunifiedideographsextensione}', "");
    Expect(0, 183983, '\P{Block: cjkunifiedideographsextensione}', "");
    Expect(1, 183983, '\P{^Block: cjkunifiedideographsextensione}', "");
    Expect(0, 183984, '\p{Block: cjkunifiedideographsextensione}', "");
    Expect(1, 183984, '\p{^Block: cjkunifiedideographsextensione}', "");
    Expect(1, 183984, '\P{Block: cjkunifiedideographsextensione}', "");
    Expect(0, 183984, '\P{^Block: cjkunifiedideographsextensione}', "");
    Expect(1, 183983, '\p{Block=:\Acjkunifiedideographsextensione\z:}', "");;
    Expect(0, 183984, '\p{Block=:\Acjkunifiedideographsextensione\z:}', "");;
    Expect(1, 183983, '\p{Block:- CJK_UNIFIED_IDEOGRAPHS_EXTENSION_e}', "");
    Expect(0, 183983, '\p{^Block:- CJK_UNIFIED_IDEOGRAPHS_EXTENSION_e}', "");
    Expect(0, 183983, '\P{Block:- CJK_UNIFIED_IDEOGRAPHS_EXTENSION_e}', "");
    Expect(1, 183983, '\P{^Block:- CJK_UNIFIED_IDEOGRAPHS_EXTENSION_e}', "");
    Expect(0, 183984, '\p{Block:- CJK_UNIFIED_IDEOGRAPHS_EXTENSION_e}', "");
    Expect(1, 183984, '\p{^Block:- CJK_UNIFIED_IDEOGRAPHS_EXTENSION_e}', "");
    Expect(1, 183984, '\P{Block:- CJK_UNIFIED_IDEOGRAPHS_EXTENSION_e}', "");
    Expect(0, 183984, '\P{^Block:- CJK_UNIFIED_IDEOGRAPHS_EXTENSION_e}', "");
    Error('\p{Blk=:=--CJK_Ext_e}');
    Error('\P{Blk=:=--CJK_Ext_e}');
    Expect(1, 183983, '\p{Blk=:\ACJK_Ext_E\z:}', "");;
    Expect(0, 183984, '\p{Blk=:\ACJK_Ext_E\z:}', "");;
    Expect(1, 183983, '\p{Blk=cjkexte}', "");
    Expect(0, 183983, '\p{^Blk=cjkexte}', "");
    Expect(0, 183983, '\P{Blk=cjkexte}', "");
    Expect(1, 183983, '\P{^Blk=cjkexte}', "");
    Expect(0, 183984, '\p{Blk=cjkexte}', "");
    Expect(1, 183984, '\p{^Blk=cjkexte}', "");
    Expect(1, 183984, '\P{Blk=cjkexte}', "");
    Expect(0, 183984, '\P{^Blk=cjkexte}', "");
    Expect(1, 183983, '\p{Blk=:\Acjkexte\z:}', "");;
    Expect(0, 183984, '\p{Blk=:\Acjkexte\z:}', "");;
    Expect(1, 183983, '\p{Blk=-CJK_Ext_E}', "");
    Expect(0, 183983, '\p{^Blk=-CJK_Ext_E}', "");
    Expect(0, 183983, '\P{Blk=-CJK_Ext_E}', "");
    Expect(1, 183983, '\P{^Blk=-CJK_Ext_E}', "");
    Expect(0, 183984, '\p{Blk=-CJK_Ext_E}', "");
    Expect(1, 183984, '\p{^Blk=-CJK_Ext_E}', "");
    Expect(1, 183984, '\P{Blk=-CJK_Ext_E}', "");
    Expect(0, 183984, '\P{^Blk=-CJK_Ext_E}', "");
    Error('\p{Is_Block=:=__CJK_Unified_Ideographs_EXTENSION_E}');
    Error('\P{Is_Block=:=__CJK_Unified_Ideographs_EXTENSION_E}');
    Expect(1, 183983, '\p{Is_Block=cjkunifiedideographsextensione}', "");
    Expect(0, 183983, '\p{^Is_Block=cjkunifiedideographsextensione}', "");
    Expect(0, 183983, '\P{Is_Block=cjkunifiedideographsextensione}', "");
    Expect(1, 183983, '\P{^Is_Block=cjkunifiedideographsextensione}', "");
    Expect(0, 183984, '\p{Is_Block=cjkunifiedideographsextensione}', "");
    Expect(1, 183984, '\p{^Is_Block=cjkunifiedideographsextensione}', "");
    Expect(1, 183984, '\P{Is_Block=cjkunifiedideographsextensione}', "");
    Expect(0, 183984, '\P{^Is_Block=cjkunifiedideographsextensione}', "");
    Expect(1, 183983, '\p{Is_Block=--CJK_UNIFIED_ideographs_EXTENSION_E}', "");
    Expect(0, 183983, '\p{^Is_Block=--CJK_UNIFIED_ideographs_EXTENSION_E}', "");
    Expect(0, 183983, '\P{Is_Block=--CJK_UNIFIED_ideographs_EXTENSION_E}', "");
    Expect(1, 183983, '\P{^Is_Block=--CJK_UNIFIED_ideographs_EXTENSION_E}', "");
    Expect(0, 183984, '\p{Is_Block=--CJK_UNIFIED_ideographs_EXTENSION_E}', "");
    Expect(1, 183984, '\p{^Is_Block=--CJK_UNIFIED_ideographs_EXTENSION_E}', "");
    Expect(1, 183984, '\P{Is_Block=--CJK_UNIFIED_ideographs_EXTENSION_E}', "");
    Expect(0, 183984, '\P{^Is_Block=--CJK_UNIFIED_ideographs_EXTENSION_E}', "");
    Error('\p{Is_Blk= :=CJK_EXT_E}');
    Error('\P{Is_Blk= :=CJK_EXT_E}');
    Expect(1, 183983, '\p{Is_Blk=cjkexte}', "");
    Expect(0, 183983, '\p{^Is_Blk=cjkexte}', "");
    Expect(0, 183983, '\P{Is_Blk=cjkexte}', "");
    Expect(1, 183983, '\P{^Is_Blk=cjkexte}', "");
    Expect(0, 183984, '\p{Is_Blk=cjkexte}', "");
    Expect(1, 183984, '\p{^Is_Blk=cjkexte}', "");
    Expect(1, 183984, '\P{Is_Blk=cjkexte}', "");
    Expect(0, 183984, '\P{^Is_Blk=cjkexte}', "");
    Expect(1, 183983, '\p{Is_Blk=-	CJK_EXT_E}', "");
    Expect(0, 183983, '\p{^Is_Blk=-	CJK_EXT_E}', "");
    Expect(0, 183983, '\P{Is_Blk=-	CJK_EXT_E}', "");
    Expect(1, 183983, '\P{^Is_Blk=-	CJK_EXT_E}', "");
    Expect(0, 183984, '\p{Is_Blk=-	CJK_EXT_E}', "");
    Expect(1, 183984, '\p{^Is_Blk=-	CJK_EXT_E}', "");
    Expect(1, 183984, '\P{Is_Blk=-	CJK_EXT_E}', "");
    Expect(0, 183984, '\P{^Is_Blk=-	CJK_EXT_E}', "");
    Error('\p{Block=	/a/CJK_UNIFIED_Ideographs_Extension_F}');
    Error('\P{Block=	/a/CJK_UNIFIED_Ideographs_Extension_F}');
    Expect(1, 191471, '\p{Block=:\ACJK_Unified_Ideographs_Extension_F\z:}', "");;
    Expect(0, 191472, '\p{Block=:\ACJK_Unified_Ideographs_Extension_F\z:}', "");;
    Expect(1, 191471, '\p{Block=cjkunifiedideographsextensionf}', "");
    Expect(0, 191471, '\p{^Block=cjkunifiedideographsextensionf}', "");
    Expect(0, 191471, '\P{Block=cjkunifiedideographsextensionf}', "");
    Expect(1, 191471, '\P{^Block=cjkunifiedideographsextensionf}', "");
    Expect(0, 191472, '\p{Block=cjkunifiedideographsextensionf}', "");
    Expect(1, 191472, '\p{^Block=cjkunifiedideographsextensionf}', "");
    Expect(1, 191472, '\P{Block=cjkunifiedideographsextensionf}', "");
    Expect(0, 191472, '\P{^Block=cjkunifiedideographsextensionf}', "");
    Expect(1, 191471, '\p{Block=:\Acjkunifiedideographsextensionf\z:}', "");;
    Expect(0, 191472, '\p{Block=:\Acjkunifiedideographsextensionf\z:}', "");;
    Expect(1, 191471, '\p{Block:   -_CJK_UNIFIED_Ideographs_Extension_F}', "");
    Expect(0, 191471, '\p{^Block:   -_CJK_UNIFIED_Ideographs_Extension_F}', "");
    Expect(0, 191471, '\P{Block:   -_CJK_UNIFIED_Ideographs_Extension_F}', "");
    Expect(1, 191471, '\P{^Block:   -_CJK_UNIFIED_Ideographs_Extension_F}', "");
    Expect(0, 191472, '\p{Block:   -_CJK_UNIFIED_Ideographs_Extension_F}', "");
    Expect(1, 191472, '\p{^Block:   -_CJK_UNIFIED_Ideographs_Extension_F}', "");
    Expect(1, 191472, '\P{Block:   -_CJK_UNIFIED_Ideographs_Extension_F}', "");
    Expect(0, 191472, '\P{^Block:   -_CJK_UNIFIED_Ideographs_Extension_F}', "");
    Error('\p{Blk: _	CJK_Ext_f/a/}');
    Error('\P{Blk: _	CJK_Ext_f/a/}');
    Expect(1, 191471, '\p{Blk=:\ACJK_Ext_F\z:}', "");;
    Expect(0, 191472, '\p{Blk=:\ACJK_Ext_F\z:}', "");;
    Expect(1, 191471, '\p{Blk=cjkextf}', "");
    Expect(0, 191471, '\p{^Blk=cjkextf}', "");
    Expect(0, 191471, '\P{Blk=cjkextf}', "");
    Expect(1, 191471, '\P{^Blk=cjkextf}', "");
    Expect(0, 191472, '\p{Blk=cjkextf}', "");
    Expect(1, 191472, '\p{^Blk=cjkextf}', "");
    Expect(1, 191472, '\P{Blk=cjkextf}', "");
    Expect(0, 191472, '\P{^Blk=cjkextf}', "");
    Expect(1, 191471, '\p{Blk=:\Acjkextf\z:}', "");;
    Expect(0, 191472, '\p{Blk=:\Acjkextf\z:}', "");;
    Expect(1, 191471, '\p{Blk=	cjk_Ext_F}', "");
    Expect(0, 191471, '\p{^Blk=	cjk_Ext_F}', "");
    Expect(0, 191471, '\P{Blk=	cjk_Ext_F}', "");
    Expect(1, 191471, '\P{^Blk=	cjk_Ext_F}', "");
    Expect(0, 191472, '\p{Blk=	cjk_Ext_F}', "");
    Expect(1, 191472, '\p{^Blk=	cjk_Ext_F}', "");
    Expect(1, 191472, '\P{Blk=	cjk_Ext_F}', "");
    Expect(0, 191472, '\P{^Blk=	cjk_Ext_F}', "");
    Error('\p{Is_Block=cjk_unified_IDEOGRAPHS_extension_f:=}');
    Error('\P{Is_Block=cjk_unified_IDEOGRAPHS_extension_f:=}');
    Expect(1, 191471, '\p{Is_Block:   cjkunifiedideographsextensionf}', "");
    Expect(0, 191471, '\p{^Is_Block:   cjkunifiedideographsextensionf}', "");
    Expect(0, 191471, '\P{Is_Block:   cjkunifiedideographsextensionf}', "");
    Expect(1, 191471, '\P{^Is_Block:   cjkunifiedideographsextensionf}', "");
    Expect(0, 191472, '\p{Is_Block:   cjkunifiedideographsextensionf}', "");
    Expect(1, 191472, '\p{^Is_Block:   cjkunifiedideographsextensionf}', "");
    Expect(1, 191472, '\P{Is_Block:   cjkunifiedideographsextensionf}', "");
    Expect(0, 191472, '\P{^Is_Block:   cjkunifiedideographsextensionf}', "");
    Expect(1, 191471, '\p{Is_Block:	_CJK_Unified_Ideographs_extension_F}', "");
    Expect(0, 191471, '\p{^Is_Block:	_CJK_Unified_Ideographs_extension_F}', "");
    Expect(0, 191471, '\P{Is_Block:	_CJK_Unified_Ideographs_extension_F}', "");
    Expect(1, 191471, '\P{^Is_Block:	_CJK_Unified_Ideographs_extension_F}', "");
    Expect(0, 191472, '\p{Is_Block:	_CJK_Unified_Ideographs_extension_F}', "");
    Expect(1, 191472, '\p{^Is_Block:	_CJK_Unified_Ideographs_extension_F}', "");
    Expect(1, 191472, '\P{Is_Block:	_CJK_Unified_Ideographs_extension_F}', "");
    Expect(0, 191472, '\P{^Is_Block:	_CJK_Unified_Ideographs_extension_F}', "");
    Error('\p{Is_Blk=/a/CJK_EXT_F}');
    Error('\P{Is_Blk=/a/CJK_EXT_F}');
    Expect(1, 191471, '\p{Is_Blk=cjkextf}', "");
    Expect(0, 191471, '\p{^Is_Blk=cjkextf}', "");
    Expect(0, 191471, '\P{Is_Blk=cjkextf}', "");
    Expect(1, 191471, '\P{^Is_Blk=cjkextf}', "");
    Expect(0, 191472, '\p{Is_Blk=cjkextf}', "");
    Expect(1, 191472, '\p{^Is_Blk=cjkextf}', "");
    Expect(1, 191472, '\P{Is_Blk=cjkextf}', "");
    Expect(0, 191472, '\P{^Is_Blk=cjkextf}', "");
    Expect(1, 191471, '\p{Is_Blk=-_CJK_Ext_f}', "");
    Expect(0, 191471, '\p{^Is_Blk=-_CJK_Ext_f}', "");
    Expect(0, 191471, '\P{Is_Blk=-_CJK_Ext_f}', "");
    Expect(1, 191471, '\P{^Is_Blk=-_CJK_Ext_f}', "");
    Expect(0, 191472, '\p{Is_Blk=-_CJK_Ext_f}', "");
    Expect(1, 191472, '\p{^Is_Blk=-_CJK_Ext_f}', "");
    Expect(1, 191472, '\P{Is_Blk=-_CJK_Ext_f}', "");
    Expect(0, 191472, '\P{^Is_Blk=-_CJK_Ext_f}', "");
    Error('\p{Block=:=_CJK_UNIFIED_IDEOGRAPHS_EXTENSION_g}');
    Error('\P{Block=:=_CJK_UNIFIED_IDEOGRAPHS_EXTENSION_g}');
    Expect(1, 201551, '\p{Block=:\ACJK_Unified_Ideographs_Extension_G\z:}', "");;
    Expect(0, 201552, '\p{Block=:\ACJK_Unified_Ideographs_Extension_G\z:}', "");;
    Expect(1, 201551, '\p{Block=cjkunifiedideographsextensiong}', "");
    Expect(0, 201551, '\p{^Block=cjkunifiedideographsextensiong}', "");
    Expect(0, 201551, '\P{Block=cjkunifiedideographsextensiong}', "");
    Expect(1, 201551, '\P{^Block=cjkunifiedideographsextensiong}', "");
    Expect(0, 201552, '\p{Block=cjkunifiedideographsextensiong}', "");
    Expect(1, 201552, '\p{^Block=cjkunifiedideographsextensiong}', "");
    Expect(1, 201552, '\P{Block=cjkunifiedideographsextensiong}', "");
    Expect(0, 201552, '\P{^Block=cjkunifiedideographsextensiong}', "");
    Expect(1, 201551, '\p{Block=:\Acjkunifiedideographsextensiong\z:}', "");;
    Expect(0, 201552, '\p{Block=:\Acjkunifiedideographsextensiong\z:}', "");;
    Expect(1, 201551, '\p{Block=CJK_Unified_IDEOGRAPHS_extension_G}', "");
    Expect(0, 201551, '\p{^Block=CJK_Unified_IDEOGRAPHS_extension_G}', "");
    Expect(0, 201551, '\P{Block=CJK_Unified_IDEOGRAPHS_extension_G}', "");
    Expect(1, 201551, '\P{^Block=CJK_Unified_IDEOGRAPHS_extension_G}', "");
    Expect(0, 201552, '\p{Block=CJK_Unified_IDEOGRAPHS_extension_G}', "");
    Expect(1, 201552, '\p{^Block=CJK_Unified_IDEOGRAPHS_extension_G}', "");
    Expect(1, 201552, '\P{Block=CJK_Unified_IDEOGRAPHS_extension_G}', "");
    Expect(0, 201552, '\P{^Block=CJK_Unified_IDEOGRAPHS_extension_G}', "");
    Error('\p{Blk=/a/ -CJK_EXT_G}');
    Error('\P{Blk=/a/ -CJK_EXT_G}');
    Expect(1, 201551, '\p{Blk=:\ACJK_Ext_G\z:}', "");;
    Expect(0, 201552, '\p{Blk=:\ACJK_Ext_G\z:}', "");;
    Expect(1, 201551, '\p{Blk=cjkextg}', "");
    Expect(0, 201551, '\p{^Blk=cjkextg}', "");
    Expect(0, 201551, '\P{Blk=cjkextg}', "");
    Expect(1, 201551, '\P{^Blk=cjkextg}', "");
    Expect(0, 201552, '\p{Blk=cjkextg}', "");
    Expect(1, 201552, '\p{^Blk=cjkextg}', "");
    Expect(1, 201552, '\P{Blk=cjkextg}', "");
    Expect(0, 201552, '\P{^Blk=cjkextg}', "");
    Expect(1, 201551, '\p{Blk=:\Acjkextg\z:}', "");;
    Expect(0, 201552, '\p{Blk=:\Acjkextg\z:}', "");;
    Expect(1, 201551, '\p{Blk= CJK_ext_G}', "");
    Expect(0, 201551, '\p{^Blk= CJK_ext_G}', "");
    Expect(0, 201551, '\P{Blk= CJK_ext_G}', "");
    Expect(1, 201551, '\P{^Blk= CJK_ext_G}', "");
    Expect(0, 201552, '\p{Blk= CJK_ext_G}', "");
    Expect(1, 201552, '\p{^Blk= CJK_ext_G}', "");
    Expect(1, 201552, '\P{Blk= CJK_ext_G}', "");
    Expect(0, 201552, '\P{^Blk= CJK_ext_G}', "");
    Error('\p{Is_Block=:=	_CJK_Unified_Ideographs_Extension_G}');
    Error('\P{Is_Block=:=	_CJK_Unified_Ideographs_Extension_G}');
    Expect(1, 201551, '\p{Is_Block=cjkunifiedideographsextensiong}', "");
    Expect(0, 201551, '\p{^Is_Block=cjkunifiedideographsextensiong}', "");
    Expect(0, 201551, '\P{Is_Block=cjkunifiedideographsextensiong}', "");
    Expect(1, 201551, '\P{^Is_Block=cjkunifiedideographsextensiong}', "");
    Expect(0, 201552, '\p{Is_Block=cjkunifiedideographsextensiong}', "");
    Expect(1, 201552, '\p{^Is_Block=cjkunifiedideographsextensiong}', "");
    Expect(1, 201552, '\P{Is_Block=cjkunifiedideographsextensiong}', "");
    Expect(0, 201552, '\P{^Is_Block=cjkunifiedideographsextensiong}', "");
    Expect(1, 201551, '\p{Is_Block=	-CJK_Unified_Ideographs_Extension_G}', "");
    Expect(0, 201551, '\p{^Is_Block=	-CJK_Unified_Ideographs_Extension_G}', "");
    Expect(0, 201551, '\P{Is_Block=	-CJK_Unified_Ideographs_Extension_G}', "");
    Expect(1, 201551, '\P{^Is_Block=	-CJK_Unified_Ideographs_Extension_G}', "");
    Expect(0, 201552, '\p{Is_Block=	-CJK_Unified_Ideographs_Extension_G}', "");
    Expect(1, 201552, '\p{^Is_Block=	-CJK_Unified_Ideographs_Extension_G}', "");
    Expect(1, 201552, '\P{Is_Block=	-CJK_Unified_Ideographs_Extension_G}', "");
    Expect(0, 201552, '\P{^Is_Block=	-CJK_Unified_Ideographs_Extension_G}', "");
    Error('\p{Is_Blk= -CJK_Ext_G:=}');
    Error('\P{Is_Blk= -CJK_Ext_G:=}');
    Expect(1, 201551, '\p{Is_Blk=cjkextg}', "");
    Expect(0, 201551, '\p{^Is_Blk=cjkextg}', "");
    Expect(0, 201551, '\P{Is_Blk=cjkextg}', "");
    Expect(1, 201551, '\P{^Is_Blk=cjkextg}', "");
    Expect(0, 201552, '\p{Is_Blk=cjkextg}', "");
    Expect(1, 201552, '\p{^Is_Blk=cjkextg}', "");
    Expect(1, 201552, '\P{Is_Blk=cjkextg}', "");
    Expect(0, 201552, '\P{^Is_Blk=cjkextg}', "");
    Expect(1, 201551, '\p{Is_Blk= -CJK_EXT_G}', "");
    Expect(0, 201551, '\p{^Is_Blk= -CJK_EXT_G}', "");
    Expect(0, 201551, '\P{Is_Blk= -CJK_EXT_G}', "");
    Expect(1, 201551, '\P{^Is_Blk= -CJK_EXT_G}', "");
    Expect(0, 201552, '\p{Is_Blk= -CJK_EXT_G}', "");
    Expect(1, 201552, '\p{^Is_Blk= -CJK_EXT_G}', "");
    Expect(1, 201552, '\P{Is_Blk= -CJK_EXT_G}', "");
    Expect(0, 201552, '\P{^Is_Blk= -CJK_EXT_G}', "");
    Error('\p{Block=_-CJK_radicals_supplement:=}');
    Error('\P{Block=_-CJK_radicals_supplement:=}');
    Expect(1, 12031, '\p{Block=:\ACJK_Radicals_Supplement\z:}', "");;
    Expect(0, 12032, '\p{Block=:\ACJK_Radicals_Supplement\z:}', "");;
    Expect(1, 12031, '\p{Block=cjkradicalssupplement}', "");
    Expect(0, 12031, '\p{^Block=cjkradicalssupplement}', "");
    Expect(0, 12031, '\P{Block=cjkradicalssupplement}', "");
    Expect(1, 12031, '\P{^Block=cjkradicalssupplement}', "");
    Expect(0, 12032, '\p{Block=cjkradicalssupplement}', "");
    Expect(1, 12032, '\p{^Block=cjkradicalssupplement}', "");
    Expect(1, 12032, '\P{Block=cjkradicalssupplement}', "");
    Expect(0, 12032, '\P{^Block=cjkradicalssupplement}', "");
    Expect(1, 12031, '\p{Block=:\Acjkradicalssupplement\z:}', "");;
    Expect(0, 12032, '\p{Block=:\Acjkradicalssupplement\z:}', "");;
    Expect(1, 12031, '\p{Block:-CJK_Radicals_Supplement}', "");
    Expect(0, 12031, '\p{^Block:-CJK_Radicals_Supplement}', "");
    Expect(0, 12031, '\P{Block:-CJK_Radicals_Supplement}', "");
    Expect(1, 12031, '\P{^Block:-CJK_Radicals_Supplement}', "");
    Expect(0, 12032, '\p{Block:-CJK_Radicals_Supplement}', "");
    Expect(1, 12032, '\p{^Block:-CJK_Radicals_Supplement}', "");
    Expect(1, 12032, '\P{Block:-CJK_Radicals_Supplement}', "");
    Expect(0, 12032, '\P{^Block:-CJK_Radicals_Supplement}', "");
    Error('\p{Blk:__cjk_radicals_sup/a/}');
    Error('\P{Blk:__cjk_radicals_sup/a/}');
    Expect(1, 12031, '\p{Blk=:\ACJK_Radicals_Sup\z:}', "");;
    Expect(0, 12032, '\p{Blk=:\ACJK_Radicals_Sup\z:}', "");;
    Expect(1, 12031, '\p{Blk=cjkradicalssup}', "");
    Expect(0, 12031, '\p{^Blk=cjkradicalssup}', "");
    Expect(0, 12031, '\P{Blk=cjkradicalssup}', "");
    Expect(1, 12031, '\P{^Blk=cjkradicalssup}', "");
    Expect(0, 12032, '\p{Blk=cjkradicalssup}', "");
    Expect(1, 12032, '\p{^Blk=cjkradicalssup}', "");
    Expect(1, 12032, '\P{Blk=cjkradicalssup}', "");
    Expect(0, 12032, '\P{^Blk=cjkradicalssup}', "");
    Expect(1, 12031, '\p{Blk=:\Acjkradicalssup\z:}', "");;
    Expect(0, 12032, '\p{Blk=:\Acjkradicalssup\z:}', "");;
    Expect(1, 12031, '\p{Blk:  CJK_radicals_Sup}', "");
    Expect(0, 12031, '\p{^Blk:  CJK_radicals_Sup}', "");
    Expect(0, 12031, '\P{Blk:  CJK_radicals_Sup}', "");
    Expect(1, 12031, '\P{^Blk:  CJK_radicals_Sup}', "");
    Expect(0, 12032, '\p{Blk:  CJK_radicals_Sup}', "");
    Expect(1, 12032, '\p{^Blk:  CJK_radicals_Sup}', "");
    Expect(1, 12032, '\P{Blk:  CJK_radicals_Sup}', "");
    Expect(0, 12032, '\P{^Blk:  CJK_radicals_Sup}', "");
    Error('\p{Is_Block=	 cjk_Radicals_SUPPLEMENT:=}');
    Error('\P{Is_Block=	 cjk_Radicals_SUPPLEMENT:=}');
    Expect(1, 12031, '\p{Is_Block=cjkradicalssupplement}', "");
    Expect(0, 12031, '\p{^Is_Block=cjkradicalssupplement}', "");
    Expect(0, 12031, '\P{Is_Block=cjkradicalssupplement}', "");
    Expect(1, 12031, '\P{^Is_Block=cjkradicalssupplement}', "");
    Expect(0, 12032, '\p{Is_Block=cjkradicalssupplement}', "");
    Expect(1, 12032, '\p{^Is_Block=cjkradicalssupplement}', "");
    Expect(1, 12032, '\P{Is_Block=cjkradicalssupplement}', "");
    Expect(0, 12032, '\P{^Is_Block=cjkradicalssupplement}', "");
    Expect(1, 12031, '\p{Is_Block=-	cjk_Radicals_SUPPLEMENT}', "");
    Expect(0, 12031, '\p{^Is_Block=-	cjk_Radicals_SUPPLEMENT}', "");
    Expect(0, 12031, '\P{Is_Block=-	cjk_Radicals_SUPPLEMENT}', "");
    Expect(1, 12031, '\P{^Is_Block=-	cjk_Radicals_SUPPLEMENT}', "");
    Expect(0, 12032, '\p{Is_Block=-	cjk_Radicals_SUPPLEMENT}', "");
    Expect(1, 12032, '\p{^Is_Block=-	cjk_Radicals_SUPPLEMENT}', "");
    Expect(1, 12032, '\P{Is_Block=-	cjk_Radicals_SUPPLEMENT}', "");
    Expect(0, 12032, '\P{^Is_Block=-	cjk_Radicals_SUPPLEMENT}', "");
    Error('\p{Is_Blk=:=-_cjk_radicals_sup}');
    Error('\P{Is_Blk=:=-_cjk_radicals_sup}');
    Expect(1, 12031, '\p{Is_Blk:   cjkradicalssup}', "");
    Expect(0, 12031, '\p{^Is_Blk:   cjkradicalssup}', "");
    Expect(0, 12031, '\P{Is_Blk:   cjkradicalssup}', "");
    Expect(1, 12031, '\P{^Is_Blk:   cjkradicalssup}', "");
    Expect(0, 12032, '\p{Is_Blk:   cjkradicalssup}', "");
    Expect(1, 12032, '\p{^Is_Blk:   cjkradicalssup}', "");
    Expect(1, 12032, '\P{Is_Blk:   cjkradicalssup}', "");
    Expect(0, 12032, '\P{^Is_Blk:   cjkradicalssup}', "");
    Expect(1, 12031, '\p{Is_Blk= cjk_Radicals_Sup}', "");
    Expect(0, 12031, '\p{^Is_Blk= cjk_Radicals_Sup}', "");
    Expect(0, 12031, '\P{Is_Blk= cjk_Radicals_Sup}', "");
    Expect(1, 12031, '\P{^Is_Blk= cjk_Radicals_Sup}', "");
    Expect(0, 12032, '\p{Is_Blk= cjk_Radicals_Sup}', "");
    Expect(1, 12032, '\p{^Is_Blk= cjk_Radicals_Sup}', "");
    Expect(1, 12032, '\P{Is_Blk= cjk_Radicals_Sup}', "");
    Expect(0, 12032, '\P{^Is_Blk= cjk_Radicals_Sup}', "");
    Error('\p{Block=- CJK_Strokes:=}');
    Error('\P{Block=- CJK_Strokes:=}');
    Expect(1, 12783, '\p{Block=:\ACJK_Strokes\z:}', "");;
    Expect(0, 12784, '\p{Block=:\ACJK_Strokes\z:}', "");;
    Expect(1, 12783, '\p{Block=cjkstrokes}', "");
    Expect(0, 12783, '\p{^Block=cjkstrokes}', "");
    Expect(0, 12783, '\P{Block=cjkstrokes}', "");
    Expect(1, 12783, '\P{^Block=cjkstrokes}', "");
    Expect(0, 12784, '\p{Block=cjkstrokes}', "");
    Expect(1, 12784, '\p{^Block=cjkstrokes}', "");
    Expect(1, 12784, '\P{Block=cjkstrokes}', "");
    Expect(0, 12784, '\P{^Block=cjkstrokes}', "");
    Expect(1, 12783, '\p{Block=:\Acjkstrokes\z:}', "");;
    Expect(0, 12784, '\p{Block=:\Acjkstrokes\z:}', "");;
    Expect(1, 12783, '\p{Block=-_CJK_Strokes}', "");
    Expect(0, 12783, '\p{^Block=-_CJK_Strokes}', "");
    Expect(0, 12783, '\P{Block=-_CJK_Strokes}', "");
    Expect(1, 12783, '\P{^Block=-_CJK_Strokes}', "");
    Expect(0, 12784, '\p{Block=-_CJK_Strokes}', "");
    Expect(1, 12784, '\p{^Block=-_CJK_Strokes}', "");
    Expect(1, 12784, '\P{Block=-_CJK_Strokes}', "");
    Expect(0, 12784, '\P{^Block=-_CJK_Strokes}', "");
    Error('\p{Blk=_:=CJK_STROKES}');
    Error('\P{Blk=_:=CJK_STROKES}');
    Expect(1, 12783, '\p{Blk=:\ACJK_Strokes\z:}', "");;
    Expect(0, 12784, '\p{Blk=:\ACJK_Strokes\z:}', "");;
    Expect(1, 12783, '\p{Blk=cjkstrokes}', "");
    Expect(0, 12783, '\p{^Blk=cjkstrokes}', "");
    Expect(0, 12783, '\P{Blk=cjkstrokes}', "");
    Expect(1, 12783, '\P{^Blk=cjkstrokes}', "");
    Expect(0, 12784, '\p{Blk=cjkstrokes}', "");
    Expect(1, 12784, '\p{^Blk=cjkstrokes}', "");
    Expect(1, 12784, '\P{Blk=cjkstrokes}', "");
    Expect(0, 12784, '\P{^Blk=cjkstrokes}', "");
    Expect(1, 12783, '\p{Blk=:\Acjkstrokes\z:}', "");;
    Expect(0, 12784, '\p{Blk=:\Acjkstrokes\z:}', "");;
    Expect(1, 12783, '\p{Blk= CJK_Strokes}', "");
    Expect(0, 12783, '\p{^Blk= CJK_Strokes}', "");
    Expect(0, 12783, '\P{Blk= CJK_Strokes}', "");
    Expect(1, 12783, '\P{^Blk= CJK_Strokes}', "");
    Expect(0, 12784, '\p{Blk= CJK_Strokes}', "");
    Expect(1, 12784, '\p{^Blk= CJK_Strokes}', "");
    Expect(1, 12784, '\P{Blk= CJK_Strokes}', "");
    Expect(0, 12784, '\P{^Blk= CJK_Strokes}', "");
    Error('\p{Is_Block=  cjk_STROKES:=}');
    Error('\P{Is_Block=  cjk_STROKES:=}');
    Expect(1, 12783, '\p{Is_Block=cjkstrokes}', "");
    Expect(0, 12783, '\p{^Is_Block=cjkstrokes}', "");
    Expect(0, 12783, '\P{Is_Block=cjkstrokes}', "");
    Expect(1, 12783, '\P{^Is_Block=cjkstrokes}', "");
    Expect(0, 12784, '\p{Is_Block=cjkstrokes}', "");
    Expect(1, 12784, '\p{^Is_Block=cjkstrokes}', "");
    Expect(1, 12784, '\P{Is_Block=cjkstrokes}', "");
    Expect(0, 12784, '\P{^Is_Block=cjkstrokes}', "");
    Expect(1, 12783, '\p{Is_Block=	CJK_strokes}', "");
    Expect(0, 12783, '\p{^Is_Block=	CJK_strokes}', "");
    Expect(0, 12783, '\P{Is_Block=	CJK_strokes}', "");
    Expect(1, 12783, '\P{^Is_Block=	CJK_strokes}', "");
    Expect(0, 12784, '\p{Is_Block=	CJK_strokes}', "");
    Expect(1, 12784, '\p{^Is_Block=	CJK_strokes}', "");
    Expect(1, 12784, '\P{Is_Block=	CJK_strokes}', "");
    Expect(0, 12784, '\P{^Is_Block=	CJK_strokes}', "");
    Error('\p{Is_Blk=  CJK_STROKES:=}');
    Error('\P{Is_Blk=  CJK_STROKES:=}');
    Expect(1, 12783, '\p{Is_Blk=cjkstrokes}', "");
    Expect(0, 12783, '\p{^Is_Blk=cjkstrokes}', "");
    Expect(0, 12783, '\P{Is_Blk=cjkstrokes}', "");
    Expect(1, 12783, '\P{^Is_Blk=cjkstrokes}', "");
    Expect(0, 12784, '\p{Is_Blk=cjkstrokes}', "");
    Expect(1, 12784, '\p{^Is_Blk=cjkstrokes}', "");
    Expect(1, 12784, '\P{Is_Blk=cjkstrokes}', "");
    Expect(0, 12784, '\P{^Is_Blk=cjkstrokes}', "");
    Expect(1, 12783, '\p{Is_Blk=__cjk_strokes}', "");
    Expect(0, 12783, '\p{^Is_Blk=__cjk_strokes}', "");
    Expect(0, 12783, '\P{Is_Blk=__cjk_strokes}', "");
    Expect(1, 12783, '\P{^Is_Blk=__cjk_strokes}', "");
    Expect(0, 12784, '\p{Is_Blk=__cjk_strokes}', "");
    Expect(1, 12784, '\p{^Is_Blk=__cjk_strokes}', "");
    Expect(1, 12784, '\P{Is_Blk=__cjk_strokes}', "");
    Expect(0, 12784, '\P{^Is_Blk=__cjk_strokes}', "");
    Error('\p{Block=-CJK_Symbols_And_PUNCTUATION/a/}');
    Error('\P{Block=-CJK_Symbols_And_PUNCTUATION/a/}');
    Expect(1, 12351, '\p{Block=:\ACJK_Symbols_And_Punctuation\z:}', "");;
    Expect(0, 12352, '\p{Block=:\ACJK_Symbols_And_Punctuation\z:}', "");;
    Expect(1, 12351, '\p{Block=cjksymbolsandpunctuation}', "");
    Expect(0, 12351, '\p{^Block=cjksymbolsandpunctuation}', "");
    Expect(0, 12351, '\P{Block=cjksymbolsandpunctuation}', "");
    Expect(1, 12351, '\P{^Block=cjksymbolsandpunctuation}', "");
    Expect(0, 12352, '\p{Block=cjksymbolsandpunctuation}', "");
    Expect(1, 12352, '\p{^Block=cjksymbolsandpunctuation}', "");
    Expect(1, 12352, '\P{Block=cjksymbolsandpunctuation}', "");
    Expect(0, 12352, '\P{^Block=cjksymbolsandpunctuation}', "");
    Expect(1, 12351, '\p{Block=:\Acjksymbolsandpunctuation\z:}', "");;
    Expect(0, 12352, '\p{Block=:\Acjksymbolsandpunctuation\z:}', "");;
    Expect(1, 12351, '\p{Block=  CJK_symbols_And_Punctuation}', "");
    Expect(0, 12351, '\p{^Block=  CJK_symbols_And_Punctuation}', "");
    Expect(0, 12351, '\P{Block=  CJK_symbols_And_Punctuation}', "");
    Expect(1, 12351, '\P{^Block=  CJK_symbols_And_Punctuation}', "");
    Expect(0, 12352, '\p{Block=  CJK_symbols_And_Punctuation}', "");
    Expect(1, 12352, '\p{^Block=  CJK_symbols_And_Punctuation}', "");
    Expect(1, 12352, '\P{Block=  CJK_symbols_And_Punctuation}', "");
    Expect(0, 12352, '\P{^Block=  CJK_symbols_And_Punctuation}', "");
    Error('\p{Blk=/a/		CJK_SYMBOLS}');
    Error('\P{Blk=/a/		CJK_SYMBOLS}');
    Expect(1, 12351, '\p{Blk=:\ACJK_Symbols\z:}', "");;
    Expect(0, 12352, '\p{Blk=:\ACJK_Symbols\z:}', "");;
    Expect(1, 12351, '\p{Blk=cjksymbols}', "");
    Expect(0, 12351, '\p{^Blk=cjksymbols}', "");
    Expect(0, 12351, '\P{Blk=cjksymbols}', "");
    Expect(1, 12351, '\P{^Blk=cjksymbols}', "");
    Expect(0, 12352, '\p{Blk=cjksymbols}', "");
    Expect(1, 12352, '\p{^Blk=cjksymbols}', "");
    Expect(1, 12352, '\P{Blk=cjksymbols}', "");
    Expect(0, 12352, '\P{^Blk=cjksymbols}', "");
    Expect(1, 12351, '\p{Blk=:\Acjksymbols\z:}', "");;
    Expect(0, 12352, '\p{Blk=:\Acjksymbols\z:}', "");;
    Expect(1, 12351, '\p{Blk:		 cjk_Symbols}', "");
    Expect(0, 12351, '\p{^Blk:		 cjk_Symbols}', "");
    Expect(0, 12351, '\P{Blk:		 cjk_Symbols}', "");
    Expect(1, 12351, '\P{^Blk:		 cjk_Symbols}', "");
    Expect(0, 12352, '\p{Blk:		 cjk_Symbols}', "");
    Expect(1, 12352, '\p{^Blk:		 cjk_Symbols}', "");
    Expect(1, 12352, '\P{Blk:		 cjk_Symbols}', "");
    Expect(0, 12352, '\P{^Blk:		 cjk_Symbols}', "");
    Error('\p{Is_Block=-/a/CJK_Symbols_and_Punctuation}');
    Error('\P{Is_Block=-/a/CJK_Symbols_and_Punctuation}');
    Expect(1, 12351, '\p{Is_Block=cjksymbolsandpunctuation}', "");
    Expect(0, 12351, '\p{^Is_Block=cjksymbolsandpunctuation}', "");
    Expect(0, 12351, '\P{Is_Block=cjksymbolsandpunctuation}', "");
    Expect(1, 12351, '\P{^Is_Block=cjksymbolsandpunctuation}', "");
    Expect(0, 12352, '\p{Is_Block=cjksymbolsandpunctuation}', "");
    Expect(1, 12352, '\p{^Is_Block=cjksymbolsandpunctuation}', "");
    Expect(1, 12352, '\P{Is_Block=cjksymbolsandpunctuation}', "");
    Expect(0, 12352, '\P{^Is_Block=cjksymbolsandpunctuation}', "");
    Expect(1, 12351, '\p{Is_Block=	CJK_Symbols_and_Punctuation}', "");
    Expect(0, 12351, '\p{^Is_Block=	CJK_Symbols_and_Punctuation}', "");
    Expect(0, 12351, '\P{Is_Block=	CJK_Symbols_and_Punctuation}', "");
    Expect(1, 12351, '\P{^Is_Block=	CJK_Symbols_and_Punctuation}', "");
    Expect(0, 12352, '\p{Is_Block=	CJK_Symbols_and_Punctuation}', "");
    Expect(1, 12352, '\p{^Is_Block=	CJK_Symbols_and_Punctuation}', "");
    Expect(1, 12352, '\P{Is_Block=	CJK_Symbols_and_Punctuation}', "");
    Expect(0, 12352, '\P{^Is_Block=	CJK_Symbols_and_Punctuation}', "");
    Error('\p{Is_Blk:	:=_-cjk_symbols}');
    Error('\P{Is_Blk:	:=_-cjk_symbols}');
    Expect(1, 12351, '\p{Is_Blk=cjksymbols}', "");
    Expect(0, 12351, '\p{^Is_Blk=cjksymbols}', "");
    Expect(0, 12351, '\P{Is_Blk=cjksymbols}', "");
    Expect(1, 12351, '\P{^Is_Blk=cjksymbols}', "");
    Expect(0, 12352, '\p{Is_Blk=cjksymbols}', "");
    Expect(1, 12352, '\p{^Is_Blk=cjksymbols}', "");
    Expect(1, 12352, '\P{Is_Blk=cjksymbols}', "");
    Expect(0, 12352, '\P{^Is_Blk=cjksymbols}', "");
    Expect(1, 12351, '\p{Is_Blk=	_CJK_SYMBOLS}', "");
    Expect(0, 12351, '\p{^Is_Blk=	_CJK_SYMBOLS}', "");
    Expect(0, 12351, '\P{Is_Blk=	_CJK_SYMBOLS}', "");
    Expect(1, 12351, '\P{^Is_Blk=	_CJK_SYMBOLS}', "");
    Expect(0, 12352, '\p{Is_Blk=	_CJK_SYMBOLS}', "");
    Expect(1, 12352, '\p{^Is_Blk=	_CJK_SYMBOLS}', "");
    Expect(1, 12352, '\P{Is_Blk=	_CJK_SYMBOLS}', "");
    Expect(0, 12352, '\P{^Is_Blk=	_CJK_SYMBOLS}', "");
    Error('\p{Block=_hangul_Compatibility_Jamo:=}');
    Error('\P{Block=_hangul_Compatibility_Jamo:=}');
    Expect(1, 12687, '\p{Block=:\AHangul_Compatibility_Jamo\z:}', "");;
    Expect(0, 12688, '\p{Block=:\AHangul_Compatibility_Jamo\z:}', "");;
    Expect(1, 12687, '\p{Block=hangulcompatibilityjamo}', "");
    Expect(0, 12687, '\p{^Block=hangulcompatibilityjamo}', "");
    Expect(0, 12687, '\P{Block=hangulcompatibilityjamo}', "");
    Expect(1, 12687, '\P{^Block=hangulcompatibilityjamo}', "");
    Expect(0, 12688, '\p{Block=hangulcompatibilityjamo}', "");
    Expect(1, 12688, '\p{^Block=hangulcompatibilityjamo}', "");
    Expect(1, 12688, '\P{Block=hangulcompatibilityjamo}', "");
    Expect(0, 12688, '\P{^Block=hangulcompatibilityjamo}', "");
    Expect(1, 12687, '\p{Block=:\Ahangulcompatibilityjamo\z:}', "");;
    Expect(0, 12688, '\p{Block=:\Ahangulcompatibilityjamo\z:}', "");;
    Expect(1, 12687, '\p{Block=-hangul_COMPATIBILITY_Jamo}', "");
    Expect(0, 12687, '\p{^Block=-hangul_COMPATIBILITY_Jamo}', "");
    Expect(0, 12687, '\P{Block=-hangul_COMPATIBILITY_Jamo}', "");
    Expect(1, 12687, '\P{^Block=-hangul_COMPATIBILITY_Jamo}', "");
    Expect(0, 12688, '\p{Block=-hangul_COMPATIBILITY_Jamo}', "");
    Expect(1, 12688, '\p{^Block=-hangul_COMPATIBILITY_Jamo}', "");
    Expect(1, 12688, '\P{Block=-hangul_COMPATIBILITY_Jamo}', "");
    Expect(0, 12688, '\P{^Block=-hangul_COMPATIBILITY_Jamo}', "");
    Error('\p{Blk=:=COMPAT_JAMO}');
    Error('\P{Blk=:=COMPAT_JAMO}');
    Expect(1, 12687, '\p{Blk=:\ACompat_Jamo\z:}', "");;
    Expect(0, 12688, '\p{Blk=:\ACompat_Jamo\z:}', "");;
    Expect(1, 12687, '\p{Blk=compatjamo}', "");
    Expect(0, 12687, '\p{^Blk=compatjamo}', "");
    Expect(0, 12687, '\P{Blk=compatjamo}', "");
    Expect(1, 12687, '\P{^Blk=compatjamo}', "");
    Expect(0, 12688, '\p{Blk=compatjamo}', "");
    Expect(1, 12688, '\p{^Blk=compatjamo}', "");
    Expect(1, 12688, '\P{Blk=compatjamo}', "");
    Expect(0, 12688, '\P{^Blk=compatjamo}', "");
    Expect(1, 12687, '\p{Blk=:\Acompatjamo\z:}', "");;
    Expect(0, 12688, '\p{Blk=:\Acompatjamo\z:}', "");;
    Expect(1, 12687, '\p{Blk=-COMPAT_JAMO}', "");
    Expect(0, 12687, '\p{^Blk=-COMPAT_JAMO}', "");
    Expect(0, 12687, '\P{Blk=-COMPAT_JAMO}', "");
    Expect(1, 12687, '\P{^Blk=-COMPAT_JAMO}', "");
    Expect(0, 12688, '\p{Blk=-COMPAT_JAMO}', "");
    Expect(1, 12688, '\p{^Blk=-COMPAT_JAMO}', "");
    Expect(1, 12688, '\P{Blk=-COMPAT_JAMO}', "");
    Expect(0, 12688, '\P{^Blk=-COMPAT_JAMO}', "");
    Error('\p{Is_Block=-HANGUL_Compatibility_jamo:=}');
    Error('\P{Is_Block=-HANGUL_Compatibility_jamo:=}');
    Expect(1, 12687, '\p{Is_Block=hangulcompatibilityjamo}', "");
    Expect(0, 12687, '\p{^Is_Block=hangulcompatibilityjamo}', "");
    Expect(0, 12687, '\P{Is_Block=hangulcompatibilityjamo}', "");
    Expect(1, 12687, '\P{^Is_Block=hangulcompatibilityjamo}', "");
    Expect(0, 12688, '\p{Is_Block=hangulcompatibilityjamo}', "");
    Expect(1, 12688, '\p{^Is_Block=hangulcompatibilityjamo}', "");
    Expect(1, 12688, '\P{Is_Block=hangulcompatibilityjamo}', "");
    Expect(0, 12688, '\P{^Is_Block=hangulcompatibilityjamo}', "");
    Expect(1, 12687, '\p{Is_Block:-hangul_COMPATIBILITY_Jamo}', "");
    Expect(0, 12687, '\p{^Is_Block:-hangul_COMPATIBILITY_Jamo}', "");
    Expect(0, 12687, '\P{Is_Block:-hangul_COMPATIBILITY_Jamo}', "");
    Expect(1, 12687, '\P{^Is_Block:-hangul_COMPATIBILITY_Jamo}', "");
    Expect(0, 12688, '\p{Is_Block:-hangul_COMPATIBILITY_Jamo}', "");
    Expect(1, 12688, '\p{^Is_Block:-hangul_COMPATIBILITY_Jamo}', "");
    Expect(1, 12688, '\P{Is_Block:-hangul_COMPATIBILITY_Jamo}', "");
    Expect(0, 12688, '\P{^Is_Block:-hangul_COMPATIBILITY_Jamo}', "");
    Error('\p{Is_Blk=/a/		Compat_jamo}');
    Error('\P{Is_Blk=/a/		Compat_jamo}');
    Expect(1, 12687, '\p{Is_Blk:   compatjamo}', "");
    Expect(0, 12687, '\p{^Is_Blk:   compatjamo}', "");
    Expect(0, 12687, '\P{Is_Blk:   compatjamo}', "");
    Expect(1, 12687, '\P{^Is_Blk:   compatjamo}', "");
    Expect(0, 12688, '\p{Is_Blk:   compatjamo}', "");
    Expect(1, 12688, '\p{^Is_Blk:   compatjamo}', "");
    Expect(1, 12688, '\P{Is_Blk:   compatjamo}', "");
    Expect(0, 12688, '\P{^Is_Blk:   compatjamo}', "");
    Expect(1, 12687, '\p{Is_Blk=Compat_Jamo}', "");
    Expect(0, 12687, '\p{^Is_Blk=Compat_Jamo}', "");
    Expect(0, 12687, '\P{Is_Blk=Compat_Jamo}', "");
    Expect(1, 12687, '\P{^Is_Blk=Compat_Jamo}', "");
    Expect(0, 12688, '\p{Is_Blk=Compat_Jamo}', "");
    Expect(1, 12688, '\p{^Is_Blk=Compat_Jamo}', "");
    Expect(1, 12688, '\P{Is_Blk=Compat_Jamo}', "");
    Expect(0, 12688, '\P{^Is_Blk=Compat_Jamo}', "");
    Error('\p{Block=:=_ Control_pictures}');
    Error('\P{Block=:=_ Control_pictures}');
    Expect(1, 9279, '\p{Block=:\AControl_Pictures\z:}', "");;
    Expect(0, 9280, '\p{Block=:\AControl_Pictures\z:}', "");;
    Expect(1, 9279, '\p{Block=controlpictures}', "");
    Expect(0, 9279, '\p{^Block=controlpictures}', "");
    Expect(0, 9279, '\P{Block=controlpictures}', "");
    Expect(1, 9279, '\P{^Block=controlpictures}', "");
    Expect(0, 9280, '\p{Block=controlpictures}', "");
    Expect(1, 9280, '\p{^Block=controlpictures}', "");
    Expect(1, 9280, '\P{Block=controlpictures}', "");
    Expect(0, 9280, '\P{^Block=controlpictures}', "");
    Expect(1, 9279, '\p{Block=:\Acontrolpictures\z:}', "");;
    Expect(0, 9280, '\p{Block=:\Acontrolpictures\z:}', "");;
    Expect(1, 9279, '\p{Block=_Control_Pictures}', "");
    Expect(0, 9279, '\p{^Block=_Control_Pictures}', "");
    Expect(0, 9279, '\P{Block=_Control_Pictures}', "");
    Expect(1, 9279, '\P{^Block=_Control_Pictures}', "");
    Expect(0, 9280, '\p{Block=_Control_Pictures}', "");
    Expect(1, 9280, '\p{^Block=_Control_Pictures}', "");
    Expect(1, 9280, '\P{Block=_Control_Pictures}', "");
    Expect(0, 9280, '\P{^Block=_Control_Pictures}', "");
    Error('\p{Blk=_-Control_PICTURES/a/}');
    Error('\P{Blk=_-Control_PICTURES/a/}');
    Expect(1, 9279, '\p{Blk=:\AControl_Pictures\z:}', "");;
    Expect(0, 9280, '\p{Blk=:\AControl_Pictures\z:}', "");;
    Expect(1, 9279, '\p{Blk:controlpictures}', "");
    Expect(0, 9279, '\p{^Blk:controlpictures}', "");
    Expect(0, 9279, '\P{Blk:controlpictures}', "");
    Expect(1, 9279, '\P{^Blk:controlpictures}', "");
    Expect(0, 9280, '\p{Blk:controlpictures}', "");
    Expect(1, 9280, '\p{^Blk:controlpictures}', "");
    Expect(1, 9280, '\P{Blk:controlpictures}', "");
    Expect(0, 9280, '\P{^Blk:controlpictures}', "");
    Expect(1, 9279, '\p{Blk=:\Acontrolpictures\z:}', "");;
    Expect(0, 9280, '\p{Blk=:\Acontrolpictures\z:}', "");;
    Expect(1, 9279, '\p{Blk=	Control_Pictures}', "");
    Expect(0, 9279, '\p{^Blk=	Control_Pictures}', "");
    Expect(0, 9279, '\P{Blk=	Control_Pictures}', "");
    Expect(1, 9279, '\P{^Blk=	Control_Pictures}', "");
    Expect(0, 9280, '\p{Blk=	Control_Pictures}', "");
    Expect(1, 9280, '\p{^Blk=	Control_Pictures}', "");
    Expect(1, 9280, '\P{Blk=	Control_Pictures}', "");
    Expect(0, 9280, '\P{^Blk=	Control_Pictures}', "");
    Error('\p{Is_Block=-Control_Pictures:=}');
    Error('\P{Is_Block=-Control_Pictures:=}');
    Expect(1, 9279, '\p{Is_Block=controlpictures}', "");
    Expect(0, 9279, '\p{^Is_Block=controlpictures}', "");
    Expect(0, 9279, '\P{Is_Block=controlpictures}', "");
    Expect(1, 9279, '\P{^Is_Block=controlpictures}', "");
    Expect(0, 9280, '\p{Is_Block=controlpictures}', "");
    Expect(1, 9280, '\p{^Is_Block=controlpictures}', "");
    Expect(1, 9280, '\P{Is_Block=controlpictures}', "");
    Expect(0, 9280, '\P{^Is_Block=controlpictures}', "");
    Expect(1, 9279, '\p{Is_Block=	_Control_Pictures}', "");
    Expect(0, 9279, '\p{^Is_Block=	_Control_Pictures}', "");
    Expect(0, 9279, '\P{Is_Block=	_Control_Pictures}', "");
    Expect(1, 9279, '\P{^Is_Block=	_Control_Pictures}', "");
    Expect(0, 9280, '\p{Is_Block=	_Control_Pictures}', "");
    Expect(1, 9280, '\p{^Is_Block=	_Control_Pictures}', "");
    Expect(1, 9280, '\P{Is_Block=	_Control_Pictures}', "");
    Expect(0, 9280, '\P{^Is_Block=	_Control_Pictures}', "");
    Error('\p{Is_Blk=	-CONTROL_PICTURES:=}');
    Error('\P{Is_Blk=	-CONTROL_PICTURES:=}');
    Expect(1, 9279, '\p{Is_Blk=controlpictures}', "");
    Expect(0, 9279, '\p{^Is_Blk=controlpictures}', "");
    Expect(0, 9279, '\P{Is_Blk=controlpictures}', "");
    Expect(1, 9279, '\P{^Is_Blk=controlpictures}', "");
    Expect(0, 9280, '\p{Is_Blk=controlpictures}', "");
    Expect(1, 9280, '\p{^Is_Blk=controlpictures}', "");
    Expect(1, 9280, '\P{Is_Blk=controlpictures}', "");
    Expect(0, 9280, '\P{^Is_Blk=controlpictures}', "");
    Expect(1, 9279, '\p{Is_Blk= Control_Pictures}', "");
    Expect(0, 9279, '\p{^Is_Blk= Control_Pictures}', "");
    Expect(0, 9279, '\P{Is_Blk= Control_Pictures}', "");
    Expect(1, 9279, '\P{^Is_Blk= Control_Pictures}', "");
    Expect(0, 9280, '\p{Is_Blk= Control_Pictures}', "");
    Expect(1, 9280, '\p{^Is_Blk= Control_Pictures}', "");
    Expect(1, 9280, '\P{Is_Blk= Control_Pictures}', "");
    Expect(0, 9280, '\P{^Is_Blk= Control_Pictures}', "");
    Error('\p{Block=_/a/coptic}');
    Error('\P{Block=_/a/coptic}');
    Expect(1, 11519, '\p{Block=:\ACoptic\z:}', "");;
    Expect(0, 11520, '\p{Block=:\ACoptic\z:}', "");;
    Expect(1, 11519, '\p{Block=coptic}', "");
    Expect(0, 11519, '\p{^Block=coptic}', "");
    Expect(0, 11519, '\P{Block=coptic}', "");
    Expect(1, 11519, '\P{^Block=coptic}', "");
    Expect(0, 11520, '\p{Block=coptic}', "");
    Expect(1, 11520, '\p{^Block=coptic}', "");
    Expect(1, 11520, '\P{Block=coptic}', "");
    Expect(0, 11520, '\P{^Block=coptic}', "");
    Expect(1, 11519, '\p{Block=:\Acoptic\z:}', "");;
    Expect(0, 11520, '\p{Block=:\Acoptic\z:}', "");;
    Expect(1, 11519, '\p{Block=-Coptic}', "");
    Expect(0, 11519, '\p{^Block=-Coptic}', "");
    Expect(0, 11519, '\P{Block=-Coptic}', "");
    Expect(1, 11519, '\P{^Block=-Coptic}', "");
    Expect(0, 11520, '\p{Block=-Coptic}', "");
    Expect(1, 11520, '\p{^Block=-Coptic}', "");
    Expect(1, 11520, '\P{Block=-Coptic}', "");
    Expect(0, 11520, '\P{^Block=-Coptic}', "");
    Error('\p{Blk=:=	Coptic}');
    Error('\P{Blk=:=	Coptic}');
    Expect(1, 11519, '\p{Blk=:\ACoptic\z:}', "");;
    Expect(0, 11520, '\p{Blk=:\ACoptic\z:}', "");;
    Expect(1, 11519, '\p{Blk=coptic}', "");
    Expect(0, 11519, '\p{^Blk=coptic}', "");
    Expect(0, 11519, '\P{Blk=coptic}', "");
    Expect(1, 11519, '\P{^Blk=coptic}', "");
    Expect(0, 11520, '\p{Blk=coptic}', "");
    Expect(1, 11520, '\p{^Blk=coptic}', "");
    Expect(1, 11520, '\P{Blk=coptic}', "");
    Expect(0, 11520, '\P{^Blk=coptic}', "");
    Expect(1, 11519, '\p{Blk=:\Acoptic\z:}', "");;
    Expect(0, 11520, '\p{Blk=:\Acoptic\z:}', "");;
    Expect(1, 11519, '\p{Blk=	 Coptic}', "");
    Expect(0, 11519, '\p{^Blk=	 Coptic}', "");
    Expect(0, 11519, '\P{Blk=	 Coptic}', "");
    Expect(1, 11519, '\P{^Blk=	 Coptic}', "");
    Expect(0, 11520, '\p{Blk=	 Coptic}', "");
    Expect(1, 11520, '\p{^Blk=	 Coptic}', "");
    Expect(1, 11520, '\P{Blk=	 Coptic}', "");
    Expect(0, 11520, '\P{^Blk=	 Coptic}', "");
    Error('\p{Is_Block=:=  Coptic}');
    Error('\P{Is_Block=:=  Coptic}');
    Expect(1, 11519, '\p{Is_Block=coptic}', "");
    Expect(0, 11519, '\p{^Is_Block=coptic}', "");
    Expect(0, 11519, '\P{Is_Block=coptic}', "");
    Expect(1, 11519, '\P{^Is_Block=coptic}', "");
    Expect(0, 11520, '\p{Is_Block=coptic}', "");
    Expect(1, 11520, '\p{^Is_Block=coptic}', "");
    Expect(1, 11520, '\P{Is_Block=coptic}', "");
    Expect(0, 11520, '\P{^Is_Block=coptic}', "");
    Expect(1, 11519, '\p{Is_Block= _Coptic}', "");
    Expect(0, 11519, '\p{^Is_Block= _Coptic}', "");
    Expect(0, 11519, '\P{Is_Block= _Coptic}', "");
    Expect(1, 11519, '\P{^Is_Block= _Coptic}', "");
    Expect(0, 11520, '\p{Is_Block= _Coptic}', "");
    Expect(1, 11520, '\p{^Is_Block= _Coptic}', "");
    Expect(1, 11520, '\P{Is_Block= _Coptic}', "");
    Expect(0, 11520, '\P{^Is_Block= _Coptic}', "");
    Error('\p{Is_Blk=/a/coptic}');
    Error('\P{Is_Blk=/a/coptic}');
    Expect(1, 11519, '\p{Is_Blk=coptic}', "");
    Expect(0, 11519, '\p{^Is_Blk=coptic}', "");
    Expect(0, 11519, '\P{Is_Blk=coptic}', "");
    Expect(1, 11519, '\P{^Is_Blk=coptic}', "");
    Expect(0, 11520, '\p{Is_Blk=coptic}', "");
    Expect(1, 11520, '\p{^Is_Blk=coptic}', "");
    Expect(1, 11520, '\P{Is_Blk=coptic}', "");
    Expect(0, 11520, '\P{^Is_Blk=coptic}', "");
    Expect(1, 11519, '\p{Is_Blk=_Coptic}', "");
    Expect(0, 11519, '\p{^Is_Blk=_Coptic}', "");
    Expect(0, 11519, '\P{Is_Blk=_Coptic}', "");
    Expect(1, 11519, '\P{^Is_Blk=_Coptic}', "");
    Expect(0, 11520, '\p{Is_Blk=_Coptic}', "");
    Expect(1, 11520, '\p{^Is_Blk=_Coptic}', "");
    Expect(1, 11520, '\P{Is_Blk=_Coptic}', "");
    Expect(0, 11520, '\P{^Is_Blk=_Coptic}', "");
    Error('\p{Block=:=-	COPTIC_Epact_NUMBERS}');
    Error('\P{Block=:=-	COPTIC_Epact_NUMBERS}');
    Expect(1, 66303, '\p{Block=:\ACoptic_Epact_Numbers\z:}', "");;
    Expect(0, 66304, '\p{Block=:\ACoptic_Epact_Numbers\z:}', "");;
    Expect(1, 66303, '\p{Block=copticepactnumbers}', "");
    Expect(0, 66303, '\p{^Block=copticepactnumbers}', "");
    Expect(0, 66303, '\P{Block=copticepactnumbers}', "");
    Expect(1, 66303, '\P{^Block=copticepactnumbers}', "");
    Expect(0, 66304, '\p{Block=copticepactnumbers}', "");
    Expect(1, 66304, '\p{^Block=copticepactnumbers}', "");
    Expect(1, 66304, '\P{Block=copticepactnumbers}', "");
    Expect(0, 66304, '\P{^Block=copticepactnumbers}', "");
    Expect(1, 66303, '\p{Block=:\Acopticepactnumbers\z:}', "");;
    Expect(0, 66304, '\p{Block=:\Acopticepactnumbers\z:}', "");;
    Expect(1, 66303, '\p{Block=__Coptic_Epact_Numbers}', "");
    Expect(0, 66303, '\p{^Block=__Coptic_Epact_Numbers}', "");
    Expect(0, 66303, '\P{Block=__Coptic_Epact_Numbers}', "");
    Expect(1, 66303, '\P{^Block=__Coptic_Epact_Numbers}', "");
    Expect(0, 66304, '\p{Block=__Coptic_Epact_Numbers}', "");
    Expect(1, 66304, '\p{^Block=__Coptic_Epact_Numbers}', "");
    Expect(1, 66304, '\P{Block=__Coptic_Epact_Numbers}', "");
    Expect(0, 66304, '\P{^Block=__Coptic_Epact_Numbers}', "");
    Error('\p{Blk=-/a/Coptic_Epact_NUMBERS}');
    Error('\P{Blk=-/a/Coptic_Epact_NUMBERS}');
    Expect(1, 66303, '\p{Blk=:\ACoptic_Epact_Numbers\z:}', "");;
    Expect(0, 66304, '\p{Blk=:\ACoptic_Epact_Numbers\z:}', "");;
    Expect(1, 66303, '\p{Blk=copticepactnumbers}', "");
    Expect(0, 66303, '\p{^Blk=copticepactnumbers}', "");
    Expect(0, 66303, '\P{Blk=copticepactnumbers}', "");
    Expect(1, 66303, '\P{^Blk=copticepactnumbers}', "");
    Expect(0, 66304, '\p{Blk=copticepactnumbers}', "");
    Expect(1, 66304, '\p{^Blk=copticepactnumbers}', "");
    Expect(1, 66304, '\P{Blk=copticepactnumbers}', "");
    Expect(0, 66304, '\P{^Blk=copticepactnumbers}', "");
    Expect(1, 66303, '\p{Blk=:\Acopticepactnumbers\z:}', "");;
    Expect(0, 66304, '\p{Blk=:\Acopticepactnumbers\z:}', "");;
    Expect(1, 66303, '\p{Blk=--COPTIC_Epact_Numbers}', "");
    Expect(0, 66303, '\p{^Blk=--COPTIC_Epact_Numbers}', "");
    Expect(0, 66303, '\P{Blk=--COPTIC_Epact_Numbers}', "");
    Expect(1, 66303, '\P{^Blk=--COPTIC_Epact_Numbers}', "");
    Expect(0, 66304, '\p{Blk=--COPTIC_Epact_Numbers}', "");
    Expect(1, 66304, '\p{^Blk=--COPTIC_Epact_Numbers}', "");
    Expect(1, 66304, '\P{Blk=--COPTIC_Epact_Numbers}', "");
    Expect(0, 66304, '\P{^Blk=--COPTIC_Epact_Numbers}', "");
    Error('\p{Is_Block=_-coptic_Epact_Numbers:=}');
    Error('\P{Is_Block=_-coptic_Epact_Numbers:=}');
    Expect(1, 66303, '\p{Is_Block=copticepactnumbers}', "");
    Expect(0, 66303, '\p{^Is_Block=copticepactnumbers}', "");
    Expect(0, 66303, '\P{Is_Block=copticepactnumbers}', "");
    Expect(1, 66303, '\P{^Is_Block=copticepactnumbers}', "");
    Expect(0, 66304, '\p{Is_Block=copticepactnumbers}', "");
    Expect(1, 66304, '\p{^Is_Block=copticepactnumbers}', "");
    Expect(1, 66304, '\P{Is_Block=copticepactnumbers}', "");
    Expect(0, 66304, '\P{^Is_Block=copticepactnumbers}', "");
    Expect(1, 66303, '\p{Is_Block=- Coptic_Epact_NUMBERS}', "");
    Expect(0, 66303, '\p{^Is_Block=- Coptic_Epact_NUMBERS}', "");
    Expect(0, 66303, '\P{Is_Block=- Coptic_Epact_NUMBERS}', "");
    Expect(1, 66303, '\P{^Is_Block=- Coptic_Epact_NUMBERS}', "");
    Expect(0, 66304, '\p{Is_Block=- Coptic_Epact_NUMBERS}', "");
    Expect(1, 66304, '\p{^Is_Block=- Coptic_Epact_NUMBERS}', "");
    Expect(1, 66304, '\P{Is_Block=- Coptic_Epact_NUMBERS}', "");
    Expect(0, 66304, '\P{^Is_Block=- Coptic_Epact_NUMBERS}', "");
    Error('\p{Is_Blk=/a/	coptic_Epact_Numbers}');
    Error('\P{Is_Blk=/a/	coptic_Epact_Numbers}');
    Expect(1, 66303, '\p{Is_Blk=copticepactnumbers}', "");
    Expect(0, 66303, '\p{^Is_Blk=copticepactnumbers}', "");
    Expect(0, 66303, '\P{Is_Blk=copticepactnumbers}', "");
    Expect(1, 66303, '\P{^Is_Blk=copticepactnumbers}', "");
    Expect(0, 66304, '\p{Is_Blk=copticepactnumbers}', "");
    Expect(1, 66304, '\p{^Is_Blk=copticepactnumbers}', "");
    Expect(1, 66304, '\P{Is_Blk=copticepactnumbers}', "");
    Expect(0, 66304, '\P{^Is_Blk=copticepactnumbers}', "");
    Expect(1, 66303, '\p{Is_Blk=	COPTIC_EPACT_numbers}', "");
    Expect(0, 66303, '\p{^Is_Blk=	COPTIC_EPACT_numbers}', "");
    Expect(0, 66303, '\P{Is_Blk=	COPTIC_EPACT_numbers}', "");
    Expect(1, 66303, '\P{^Is_Blk=	COPTIC_EPACT_numbers}', "");
    Expect(0, 66304, '\p{Is_Blk=	COPTIC_EPACT_numbers}', "");
    Expect(1, 66304, '\p{^Is_Blk=	COPTIC_EPACT_numbers}', "");
    Expect(1, 66304, '\P{Is_Blk=	COPTIC_EPACT_numbers}', "");
    Expect(0, 66304, '\P{^Is_Blk=	COPTIC_EPACT_numbers}', "");
    Error('\p{Block=:=counting_Rod_NUMERALS}');
    Error('\P{Block=:=counting_Rod_NUMERALS}');
    Expect(1, 119679, '\p{Block=:\ACounting_Rod_Numerals\z:}', "");;
    Expect(0, 119680, '\p{Block=:\ACounting_Rod_Numerals\z:}', "");;
    Expect(1, 119679, '\p{Block=countingrodnumerals}', "");
    Expect(0, 119679, '\p{^Block=countingrodnumerals}', "");
    Expect(0, 119679, '\P{Block=countingrodnumerals}', "");
    Expect(1, 119679, '\P{^Block=countingrodnumerals}', "");
    Expect(0, 119680, '\p{Block=countingrodnumerals}', "");
    Expect(1, 119680, '\p{^Block=countingrodnumerals}', "");
    Expect(1, 119680, '\P{Block=countingrodnumerals}', "");
    Expect(0, 119680, '\P{^Block=countingrodnumerals}', "");
    Expect(1, 119679, '\p{Block=:\Acountingrodnumerals\z:}', "");;
    Expect(0, 119680, '\p{Block=:\Acountingrodnumerals\z:}', "");;
    Expect(1, 119679, '\p{Block=--Counting_ROD_numerals}', "");
    Expect(0, 119679, '\p{^Block=--Counting_ROD_numerals}', "");
    Expect(0, 119679, '\P{Block=--Counting_ROD_numerals}', "");
    Expect(1, 119679, '\P{^Block=--Counting_ROD_numerals}', "");
    Expect(0, 119680, '\p{Block=--Counting_ROD_numerals}', "");
    Expect(1, 119680, '\p{^Block=--Counting_ROD_numerals}', "");
    Expect(1, 119680, '\P{Block=--Counting_ROD_numerals}', "");
    Expect(0, 119680, '\P{^Block=--Counting_ROD_numerals}', "");
    Error('\p{Blk= /a/counting_rod}');
    Error('\P{Blk= /a/counting_rod}');
    Expect(1, 119679, '\p{Blk=:\ACounting_Rod\z:}', "");;
    Expect(0, 119680, '\p{Blk=:\ACounting_Rod\z:}', "");;
    Expect(1, 119679, '\p{Blk=countingrod}', "");
    Expect(0, 119679, '\p{^Blk=countingrod}', "");
    Expect(0, 119679, '\P{Blk=countingrod}', "");
    Expect(1, 119679, '\P{^Blk=countingrod}', "");
    Expect(0, 119680, '\p{Blk=countingrod}', "");
    Expect(1, 119680, '\p{^Blk=countingrod}', "");
    Expect(1, 119680, '\P{Blk=countingrod}', "");
    Expect(0, 119680, '\P{^Blk=countingrod}', "");
    Expect(1, 119679, '\p{Blk=:\Acountingrod\z:}', "");;
    Expect(0, 119680, '\p{Blk=:\Acountingrod\z:}', "");;
    Expect(1, 119679, '\p{Blk=	Counting_Rod}', "");
    Expect(0, 119679, '\p{^Blk=	Counting_Rod}', "");
    Expect(0, 119679, '\P{Blk=	Counting_Rod}', "");
    Expect(1, 119679, '\P{^Blk=	Counting_Rod}', "");
    Expect(0, 119680, '\p{Blk=	Counting_Rod}', "");
    Expect(1, 119680, '\p{^Blk=	Counting_Rod}', "");
    Expect(1, 119680, '\P{Blk=	Counting_Rod}', "");
    Expect(0, 119680, '\P{^Blk=	Counting_Rod}', "");
    Error('\p{Is_Block=--counting_ROD_Numerals:=}');
    Error('\P{Is_Block=--counting_ROD_Numerals:=}');
    Expect(1, 119679, '\p{Is_Block=countingrodnumerals}', "");
    Expect(0, 119679, '\p{^Is_Block=countingrodnumerals}', "");
    Expect(0, 119679, '\P{Is_Block=countingrodnumerals}', "");
    Expect(1, 119679, '\P{^Is_Block=countingrodnumerals}', "");
    Expect(0, 119680, '\p{Is_Block=countingrodnumerals}', "");
    Expect(1, 119680, '\p{^Is_Block=countingrodnumerals}', "");
    Expect(1, 119680, '\P{Is_Block=countingrodnumerals}', "");
    Expect(0, 119680, '\P{^Is_Block=countingrodnumerals}', "");
    Expect(1, 119679, '\p{Is_Block=	_COUNTING_rod_Numerals}', "");
    Expect(0, 119679, '\p{^Is_Block=	_COUNTING_rod_Numerals}', "");
    Expect(0, 119679, '\P{Is_Block=	_COUNTING_rod_Numerals}', "");
    Expect(1, 119679, '\P{^Is_Block=	_COUNTING_rod_Numerals}', "");
    Expect(0, 119680, '\p{Is_Block=	_COUNTING_rod_Numerals}', "");
    Expect(1, 119680, '\p{^Is_Block=	_COUNTING_rod_Numerals}', "");
    Expect(1, 119680, '\P{Is_Block=	_COUNTING_rod_Numerals}', "");
    Expect(0, 119680, '\P{^Is_Block=	_COUNTING_rod_Numerals}', "");
    Error('\p{Is_Blk=_/a/counting_Rod}');
    Error('\P{Is_Blk=_/a/counting_Rod}');
    Expect(1, 119679, '\p{Is_Blk=countingrod}', "");
    Expect(0, 119679, '\p{^Is_Blk=countingrod}', "");
    Expect(0, 119679, '\P{Is_Blk=countingrod}', "");
    Expect(1, 119679, '\P{^Is_Blk=countingrod}', "");
    Expect(0, 119680, '\p{Is_Blk=countingrod}', "");
    Expect(1, 119680, '\p{^Is_Blk=countingrod}', "");
    Expect(1, 119680, '\P{Is_Blk=countingrod}', "");
    Expect(0, 119680, '\P{^Is_Blk=countingrod}', "");
    Expect(1, 119679, '\p{Is_Blk=	COUNTING_Rod}', "");
    Expect(0, 119679, '\p{^Is_Blk=	COUNTING_Rod}', "");
    Expect(0, 119679, '\P{Is_Blk=	COUNTING_Rod}', "");
    Expect(1, 119679, '\P{^Is_Blk=	COUNTING_Rod}', "");
    Expect(0, 119680, '\p{Is_Blk=	COUNTING_Rod}', "");
    Expect(1, 119680, '\p{^Is_Blk=	COUNTING_Rod}', "");
    Expect(1, 119680, '\P{Is_Blk=	COUNTING_Rod}', "");
    Expect(0, 119680, '\P{^Is_Blk=	COUNTING_Rod}', "");
    Error('\p{Block: :=		CUNEIFORM}');
    Error('\P{Block: :=		CUNEIFORM}');
    Expect(1, 74751, '\p{Block=:\ACuneiform\z:}', "");;
    Expect(0, 74752, '\p{Block=:\ACuneiform\z:}', "");;
    Expect(1, 74751, '\p{Block=cuneiform}', "");
    Expect(0, 74751, '\p{^Block=cuneiform}', "");
    Expect(0, 74751, '\P{Block=cuneiform}', "");
    Expect(1, 74751, '\P{^Block=cuneiform}', "");
    Expect(0, 74752, '\p{Block=cuneiform}', "");
    Expect(1, 74752, '\p{^Block=cuneiform}', "");
    Expect(1, 74752, '\P{Block=cuneiform}', "");
    Expect(0, 74752, '\P{^Block=cuneiform}', "");
    Expect(1, 74751, '\p{Block=:\Acuneiform\z:}', "");;
    Expect(0, 74752, '\p{Block=:\Acuneiform\z:}', "");;
    Expect(1, 74751, '\p{Block= Cuneiform}', "");
    Expect(0, 74751, '\p{^Block= Cuneiform}', "");
    Expect(0, 74751, '\P{Block= Cuneiform}', "");
    Expect(1, 74751, '\P{^Block= Cuneiform}', "");
    Expect(0, 74752, '\p{Block= Cuneiform}', "");
    Expect(1, 74752, '\p{^Block= Cuneiform}', "");
    Expect(1, 74752, '\P{Block= Cuneiform}', "");
    Expect(0, 74752, '\P{^Block= Cuneiform}', "");
    Error('\p{Blk:   /a/Cuneiform}');
    Error('\P{Blk:   /a/Cuneiform}');
    Expect(1, 74751, '\p{Blk=:\ACuneiform\z:}', "");;
    Expect(0, 74752, '\p{Blk=:\ACuneiform\z:}', "");;
    Expect(1, 74751, '\p{Blk: cuneiform}', "");
    Expect(0, 74751, '\p{^Blk: cuneiform}', "");
    Expect(0, 74751, '\P{Blk: cuneiform}', "");
    Expect(1, 74751, '\P{^Blk: cuneiform}', "");
    Expect(0, 74752, '\p{Blk: cuneiform}', "");
    Expect(1, 74752, '\p{^Blk: cuneiform}', "");
    Expect(1, 74752, '\P{Blk: cuneiform}', "");
    Expect(0, 74752, '\P{^Blk: cuneiform}', "");
    Expect(1, 74751, '\p{Blk=:\Acuneiform\z:}', "");;
    Expect(0, 74752, '\p{Blk=:\Acuneiform\z:}', "");;
    Expect(1, 74751, '\p{Blk=  Cuneiform}', "");
    Expect(0, 74751, '\p{^Blk=  Cuneiform}', "");
    Expect(0, 74751, '\P{Blk=  Cuneiform}', "");
    Expect(1, 74751, '\P{^Blk=  Cuneiform}', "");
    Expect(0, 74752, '\p{Blk=  Cuneiform}', "");
    Expect(1, 74752, '\p{^Blk=  Cuneiform}', "");
    Expect(1, 74752, '\P{Blk=  Cuneiform}', "");
    Expect(0, 74752, '\P{^Blk=  Cuneiform}', "");
    Error('\p{Is_Block: := CUNEIFORM}');
    Error('\P{Is_Block: := CUNEIFORM}');
    Expect(1, 74751, '\p{Is_Block=cuneiform}', "");
    Expect(0, 74751, '\p{^Is_Block=cuneiform}', "");
    Expect(0, 74751, '\P{Is_Block=cuneiform}', "");
    Expect(1, 74751, '\P{^Is_Block=cuneiform}', "");
    Expect(0, 74752, '\p{Is_Block=cuneiform}', "");
    Expect(1, 74752, '\p{^Is_Block=cuneiform}', "");
    Expect(1, 74752, '\P{Is_Block=cuneiform}', "");
    Expect(0, 74752, '\P{^Is_Block=cuneiform}', "");
    Expect(1, 74751, '\p{Is_Block= 	Cuneiform}', "");
    Expect(0, 74751, '\p{^Is_Block= 	Cuneiform}', "");
    Expect(0, 74751, '\P{Is_Block= 	Cuneiform}', "");
    Expect(1, 74751, '\P{^Is_Block= 	Cuneiform}', "");
    Expect(0, 74752, '\p{Is_Block= 	Cuneiform}', "");
    Expect(1, 74752, '\p{^Is_Block= 	Cuneiform}', "");
    Expect(1, 74752, '\P{Is_Block= 	Cuneiform}', "");
    Expect(0, 74752, '\P{^Is_Block= 	Cuneiform}', "");
    Error('\p{Is_Blk=/a/-	Cuneiform}');
    Error('\P{Is_Blk=/a/-	Cuneiform}');
    Expect(1, 74751, '\p{Is_Blk=cuneiform}', "");
    Expect(0, 74751, '\p{^Is_Blk=cuneiform}', "");
    Expect(0, 74751, '\P{Is_Blk=cuneiform}', "");
    Expect(1, 74751, '\P{^Is_Blk=cuneiform}', "");
    Expect(0, 74752, '\p{Is_Blk=cuneiform}', "");
    Expect(1, 74752, '\p{^Is_Blk=cuneiform}', "");
    Expect(1, 74752, '\P{Is_Blk=cuneiform}', "");
    Expect(0, 74752, '\P{^Is_Blk=cuneiform}', "");
    Expect(1, 74751, '\p{Is_Blk:   _cuneiform}', "");
    Expect(0, 74751, '\p{^Is_Blk:   _cuneiform}', "");
    Expect(0, 74751, '\P{Is_Blk:   _cuneiform}', "");
    Expect(1, 74751, '\P{^Is_Blk:   _cuneiform}', "");
    Expect(0, 74752, '\p{Is_Blk:   _cuneiform}', "");
    Expect(1, 74752, '\p{^Is_Blk:   _cuneiform}', "");
    Expect(1, 74752, '\P{Is_Blk:   _cuneiform}', "");
    Expect(0, 74752, '\P{^Is_Blk:   _cuneiform}', "");
    Error('\p{Block=:=--Cuneiform_Numbers_And_Punctuation}');
    Error('\P{Block=:=--Cuneiform_Numbers_And_Punctuation}');
    Expect(1, 74879, '\p{Block=:\ACuneiform_Numbers_And_Punctuation\z:}', "");;
    Expect(0, 74880, '\p{Block=:\ACuneiform_Numbers_And_Punctuation\z:}', "");;
    Expect(1, 74879, '\p{Block=cuneiformnumbersandpunctuation}', "");
    Expect(0, 74879, '\p{^Block=cuneiformnumbersandpunctuation}', "");
    Expect(0, 74879, '\P{Block=cuneiformnumbersandpunctuation}', "");
    Expect(1, 74879, '\P{^Block=cuneiformnumbersandpunctuation}', "");
    Expect(0, 74880, '\p{Block=cuneiformnumbersandpunctuation}', "");
    Expect(1, 74880, '\p{^Block=cuneiformnumbersandpunctuation}', "");
    Expect(1, 74880, '\P{Block=cuneiformnumbersandpunctuation}', "");
    Expect(0, 74880, '\P{^Block=cuneiformnumbersandpunctuation}', "");
    Expect(1, 74879, '\p{Block=:\Acuneiformnumbersandpunctuation\z:}', "");;
    Expect(0, 74880, '\p{Block=:\Acuneiformnumbersandpunctuation\z:}', "");;
    Expect(1, 74879, '\p{Block=-CUNEIFORM_Numbers_and_Punctuation}', "");
    Expect(0, 74879, '\p{^Block=-CUNEIFORM_Numbers_and_Punctuation}', "");
    Expect(0, 74879, '\P{Block=-CUNEIFORM_Numbers_and_Punctuation}', "");
    Expect(1, 74879, '\P{^Block=-CUNEIFORM_Numbers_and_Punctuation}', "");
    Expect(0, 74880, '\p{Block=-CUNEIFORM_Numbers_and_Punctuation}', "");
    Expect(1, 74880, '\p{^Block=-CUNEIFORM_Numbers_and_Punctuation}', "");
    Expect(1, 74880, '\P{Block=-CUNEIFORM_Numbers_and_Punctuation}', "");
    Expect(0, 74880, '\P{^Block=-CUNEIFORM_Numbers_and_Punctuation}', "");
    Error('\p{Blk=_:=Cuneiform_NUMBERS}');
    Error('\P{Blk=_:=Cuneiform_NUMBERS}');
    Expect(1, 74879, '\p{Blk=:\ACuneiform_Numbers\z:}', "");;
    Expect(0, 74880, '\p{Blk=:\ACuneiform_Numbers\z:}', "");;
    Expect(1, 74879, '\p{Blk=cuneiformnumbers}', "");
    Expect(0, 74879, '\p{^Blk=cuneiformnumbers}', "");
    Expect(0, 74879, '\P{Blk=cuneiformnumbers}', "");
    Expect(1, 74879, '\P{^Blk=cuneiformnumbers}', "");
    Expect(0, 74880, '\p{Blk=cuneiformnumbers}', "");
    Expect(1, 74880, '\p{^Blk=cuneiformnumbers}', "");
    Expect(1, 74880, '\P{Blk=cuneiformnumbers}', "");
    Expect(0, 74880, '\P{^Blk=cuneiformnumbers}', "");
    Expect(1, 74879, '\p{Blk=:\Acuneiformnumbers\z:}', "");;
    Expect(0, 74880, '\p{Blk=:\Acuneiformnumbers\z:}', "");;
    Expect(1, 74879, '\p{Blk=-CUNEIFORM_Numbers}', "");
    Expect(0, 74879, '\p{^Blk=-CUNEIFORM_Numbers}', "");
    Expect(0, 74879, '\P{Blk=-CUNEIFORM_Numbers}', "");
    Expect(1, 74879, '\P{^Blk=-CUNEIFORM_Numbers}', "");
    Expect(0, 74880, '\p{Blk=-CUNEIFORM_Numbers}', "");
    Expect(1, 74880, '\p{^Blk=-CUNEIFORM_Numbers}', "");
    Expect(1, 74880, '\P{Blk=-CUNEIFORM_Numbers}', "");
    Expect(0, 74880, '\P{^Blk=-CUNEIFORM_Numbers}', "");
    Error('\p{Is_Block:	/a/		CUNEIFORM_Numbers_AND_Punctuation}');
    Error('\P{Is_Block:	/a/		CUNEIFORM_Numbers_AND_Punctuation}');
    Expect(1, 74879, '\p{Is_Block=cuneiformnumbersandpunctuation}', "");
    Expect(0, 74879, '\p{^Is_Block=cuneiformnumbersandpunctuation}', "");
    Expect(0, 74879, '\P{Is_Block=cuneiformnumbersandpunctuation}', "");
    Expect(1, 74879, '\P{^Is_Block=cuneiformnumbersandpunctuation}', "");
    Expect(0, 74880, '\p{Is_Block=cuneiformnumbersandpunctuation}', "");
    Expect(1, 74880, '\p{^Is_Block=cuneiformnumbersandpunctuation}', "");
    Expect(1, 74880, '\P{Is_Block=cuneiformnumbersandpunctuation}', "");
    Expect(0, 74880, '\P{^Is_Block=cuneiformnumbersandpunctuation}', "");
    Expect(1, 74879, '\p{Is_Block=_-Cuneiform_NUMBERS_and_punctuation}', "");
    Expect(0, 74879, '\p{^Is_Block=_-Cuneiform_NUMBERS_and_punctuation}', "");
    Expect(0, 74879, '\P{Is_Block=_-Cuneiform_NUMBERS_and_punctuation}', "");
    Expect(1, 74879, '\P{^Is_Block=_-Cuneiform_NUMBERS_and_punctuation}', "");
    Expect(0, 74880, '\p{Is_Block=_-Cuneiform_NUMBERS_and_punctuation}', "");
    Expect(1, 74880, '\p{^Is_Block=_-Cuneiform_NUMBERS_and_punctuation}', "");
    Expect(1, 74880, '\P{Is_Block=_-Cuneiform_NUMBERS_and_punctuation}', "");
    Expect(0, 74880, '\P{^Is_Block=_-Cuneiform_NUMBERS_and_punctuation}', "");
    Error('\p{Is_Blk=/a/-CUNEIFORM_NUMBERS}');
    Error('\P{Is_Blk=/a/-CUNEIFORM_NUMBERS}');
    Expect(1, 74879, '\p{Is_Blk=cuneiformnumbers}', "");
    Expect(0, 74879, '\p{^Is_Blk=cuneiformnumbers}', "");
    Expect(0, 74879, '\P{Is_Blk=cuneiformnumbers}', "");
    Expect(1, 74879, '\P{^Is_Blk=cuneiformnumbers}', "");
    Expect(0, 74880, '\p{Is_Blk=cuneiformnumbers}', "");
    Expect(1, 74880, '\p{^Is_Blk=cuneiformnumbers}', "");
    Expect(1, 74880, '\P{Is_Blk=cuneiformnumbers}', "");
    Expect(0, 74880, '\P{^Is_Blk=cuneiformnumbers}', "");
    Expect(1, 74879, '\p{Is_Blk=_CUNEIFORM_Numbers}', "");
    Expect(0, 74879, '\p{^Is_Blk=_CUNEIFORM_Numbers}', "");
    Expect(0, 74879, '\P{Is_Blk=_CUNEIFORM_Numbers}', "");
    Expect(1, 74879, '\P{^Is_Blk=_CUNEIFORM_Numbers}', "");
    Expect(0, 74880, '\p{Is_Blk=_CUNEIFORM_Numbers}', "");
    Expect(1, 74880, '\p{^Is_Blk=_CUNEIFORM_Numbers}', "");
    Expect(1, 74880, '\P{Is_Blk=_CUNEIFORM_Numbers}', "");
    Expect(0, 74880, '\P{^Is_Blk=_CUNEIFORM_Numbers}', "");
    Error('\p{Block=:=_-CURRENCY_SYMBOLS}');
    Error('\P{Block=:=_-CURRENCY_SYMBOLS}');
    Expect(1, 8399, '\p{Block=:\ACurrency_Symbols\z:}', "");;
    Expect(0, 8400, '\p{Block=:\ACurrency_Symbols\z:}', "");;
    Expect(1, 8399, '\p{Block:currencysymbols}', "");
    Expect(0, 8399, '\p{^Block:currencysymbols}', "");
    Expect(0, 8399, '\P{Block:currencysymbols}', "");
    Expect(1, 8399, '\P{^Block:currencysymbols}', "");
    Expect(0, 8400, '\p{Block:currencysymbols}', "");
    Expect(1, 8400, '\p{^Block:currencysymbols}', "");
    Expect(1, 8400, '\P{Block:currencysymbols}', "");
    Expect(0, 8400, '\P{^Block:currencysymbols}', "");
    Expect(1, 8399, '\p{Block=:\Acurrencysymbols\z:}', "");;
    Expect(0, 8400, '\p{Block=:\Acurrencysymbols\z:}', "");;
    Expect(1, 8399, '\p{Block=--currency_SYMBOLS}', "");
    Expect(0, 8399, '\p{^Block=--currency_SYMBOLS}', "");
    Expect(0, 8399, '\P{Block=--currency_SYMBOLS}', "");
    Expect(1, 8399, '\P{^Block=--currency_SYMBOLS}', "");
    Expect(0, 8400, '\p{Block=--currency_SYMBOLS}', "");
    Expect(1, 8400, '\p{^Block=--currency_SYMBOLS}', "");
    Expect(1, 8400, '\P{Block=--currency_SYMBOLS}', "");
    Expect(0, 8400, '\P{^Block=--currency_SYMBOLS}', "");
    Error('\p{Blk=	:=CURRENCY_Symbols}');
    Error('\P{Blk=	:=CURRENCY_Symbols}');
    Expect(1, 8399, '\p{Blk=:\ACurrency_Symbols\z:}', "");;
    Expect(0, 8400, '\p{Blk=:\ACurrency_Symbols\z:}', "");;
    Expect(1, 8399, '\p{Blk=currencysymbols}', "");
    Expect(0, 8399, '\p{^Blk=currencysymbols}', "");
    Expect(0, 8399, '\P{Blk=currencysymbols}', "");
    Expect(1, 8399, '\P{^Blk=currencysymbols}', "");
    Expect(0, 8400, '\p{Blk=currencysymbols}', "");
    Expect(1, 8400, '\p{^Blk=currencysymbols}', "");
    Expect(1, 8400, '\P{Blk=currencysymbols}', "");
    Expect(0, 8400, '\P{^Blk=currencysymbols}', "");
    Expect(1, 8399, '\p{Blk=:\Acurrencysymbols\z:}', "");;
    Expect(0, 8400, '\p{Blk=:\Acurrencysymbols\z:}', "");;
    Expect(1, 8399, '\p{Blk=		CURRENCY_symbols}', "");
    Expect(0, 8399, '\p{^Blk=		CURRENCY_symbols}', "");
    Expect(0, 8399, '\P{Blk=		CURRENCY_symbols}', "");
    Expect(1, 8399, '\P{^Blk=		CURRENCY_symbols}', "");
    Expect(0, 8400, '\p{Blk=		CURRENCY_symbols}', "");
    Expect(1, 8400, '\p{^Blk=		CURRENCY_symbols}', "");
    Expect(1, 8400, '\P{Blk=		CURRENCY_symbols}', "");
    Expect(0, 8400, '\P{^Blk=		CURRENCY_symbols}', "");
    Error('\p{Is_Block=	 CURRENCY_Symbols:=}');
    Error('\P{Is_Block=	 CURRENCY_Symbols:=}');
    Expect(1, 8399, '\p{Is_Block=currencysymbols}', "");
    Expect(0, 8399, '\p{^Is_Block=currencysymbols}', "");
    Expect(0, 8399, '\P{Is_Block=currencysymbols}', "");
    Expect(1, 8399, '\P{^Is_Block=currencysymbols}', "");
    Expect(0, 8400, '\p{Is_Block=currencysymbols}', "");
    Expect(1, 8400, '\p{^Is_Block=currencysymbols}', "");
    Expect(1, 8400, '\P{Is_Block=currencysymbols}', "");
    Expect(0, 8400, '\P{^Is_Block=currencysymbols}', "");
    Expect(1, 8399, '\p{Is_Block= currency_symbols}', "");
    Expect(0, 8399, '\p{^Is_Block= currency_symbols}', "");
    Expect(0, 8399, '\P{Is_Block= currency_symbols}', "");
    Expect(1, 8399, '\P{^Is_Block= currency_symbols}', "");
    Expect(0, 8400, '\p{Is_Block= currency_symbols}', "");
    Expect(1, 8400, '\p{^Is_Block= currency_symbols}', "");
    Expect(1, 8400, '\P{Is_Block= currency_symbols}', "");
    Expect(0, 8400, '\P{^Is_Block= currency_symbols}', "");
    Error('\p{Is_Blk=:=--currency_symbols}');
    Error('\P{Is_Blk=:=--currency_symbols}');
    Expect(1, 8399, '\p{Is_Blk=currencysymbols}', "");
    Expect(0, 8399, '\p{^Is_Blk=currencysymbols}', "");
    Expect(0, 8399, '\P{Is_Blk=currencysymbols}', "");
    Expect(1, 8399, '\P{^Is_Blk=currencysymbols}', "");
    Expect(0, 8400, '\p{Is_Blk=currencysymbols}', "");
    Expect(1, 8400, '\p{^Is_Blk=currencysymbols}', "");
    Expect(1, 8400, '\P{Is_Blk=currencysymbols}', "");
    Expect(0, 8400, '\P{^Is_Blk=currencysymbols}', "");
    Expect(1, 8399, '\p{Is_Blk=	_Currency_SYMBOLS}', "");
    Expect(0, 8399, '\p{^Is_Blk=	_Currency_SYMBOLS}', "");
    Expect(0, 8399, '\P{Is_Blk=	_Currency_SYMBOLS}', "");
    Expect(1, 8399, '\P{^Is_Blk=	_Currency_SYMBOLS}', "");
    Expect(0, 8400, '\p{Is_Blk=	_Currency_SYMBOLS}', "");
    Expect(1, 8400, '\p{^Is_Blk=	_Currency_SYMBOLS}', "");
    Expect(1, 8400, '\P{Is_Blk=	_Currency_SYMBOLS}', "");
    Expect(0, 8400, '\P{^Is_Blk=	_Currency_SYMBOLS}', "");
    Error('\p{Block=_	Cypriot_Syllabary/a/}');
    Error('\P{Block=_	Cypriot_Syllabary/a/}');
    Expect(1, 67647, '\p{Block=:\ACypriot_Syllabary\z:}', "");;
    Expect(0, 67648, '\p{Block=:\ACypriot_Syllabary\z:}', "");;
    Expect(1, 67647, '\p{Block=cypriotsyllabary}', "");
    Expect(0, 67647, '\p{^Block=cypriotsyllabary}', "");
    Expect(0, 67647, '\P{Block=cypriotsyllabary}', "");
    Expect(1, 67647, '\P{^Block=cypriotsyllabary}', "");
    Expect(0, 67648, '\p{Block=cypriotsyllabary}', "");
    Expect(1, 67648, '\p{^Block=cypriotsyllabary}', "");
    Expect(1, 67648, '\P{Block=cypriotsyllabary}', "");
    Expect(0, 67648, '\P{^Block=cypriotsyllabary}', "");
    Expect(1, 67647, '\p{Block=:\Acypriotsyllabary\z:}', "");;
    Expect(0, 67648, '\p{Block=:\Acypriotsyllabary\z:}', "");;
    Expect(1, 67647, '\p{Block=--CYPRIOT_syllabary}', "");
    Expect(0, 67647, '\p{^Block=--CYPRIOT_syllabary}', "");
    Expect(0, 67647, '\P{Block=--CYPRIOT_syllabary}', "");
    Expect(1, 67647, '\P{^Block=--CYPRIOT_syllabary}', "");
    Expect(0, 67648, '\p{Block=--CYPRIOT_syllabary}', "");
    Expect(1, 67648, '\p{^Block=--CYPRIOT_syllabary}', "");
    Expect(1, 67648, '\P{Block=--CYPRIOT_syllabary}', "");
    Expect(0, 67648, '\P{^Block=--CYPRIOT_syllabary}', "");
    Error('\p{Blk=	_Cypriot_SYLLABARY/a/}');
    Error('\P{Blk=	_Cypriot_SYLLABARY/a/}');
    Expect(1, 67647, '\p{Blk=:\ACypriot_Syllabary\z:}', "");;
    Expect(0, 67648, '\p{Blk=:\ACypriot_Syllabary\z:}', "");;
    Expect(1, 67647, '\p{Blk=cypriotsyllabary}', "");
    Expect(0, 67647, '\p{^Blk=cypriotsyllabary}', "");
    Expect(0, 67647, '\P{Blk=cypriotsyllabary}', "");
    Expect(1, 67647, '\P{^Blk=cypriotsyllabary}', "");
    Expect(0, 67648, '\p{Blk=cypriotsyllabary}', "");
    Expect(1, 67648, '\p{^Blk=cypriotsyllabary}', "");
    Expect(1, 67648, '\P{Blk=cypriotsyllabary}', "");
    Expect(0, 67648, '\P{^Blk=cypriotsyllabary}', "");
    Expect(1, 67647, '\p{Blk=:\Acypriotsyllabary\z:}', "");;
    Expect(0, 67648, '\p{Blk=:\Acypriotsyllabary\z:}', "");;
    Expect(1, 67647, '\p{Blk:	- CYPRIOT_Syllabary}', "");
    Expect(0, 67647, '\p{^Blk:	- CYPRIOT_Syllabary}', "");
    Expect(0, 67647, '\P{Blk:	- CYPRIOT_Syllabary}', "");
    Expect(1, 67647, '\P{^Blk:	- CYPRIOT_Syllabary}', "");
    Expect(0, 67648, '\p{Blk:	- CYPRIOT_Syllabary}', "");
    Expect(1, 67648, '\p{^Blk:	- CYPRIOT_Syllabary}', "");
    Expect(1, 67648, '\P{Blk:	- CYPRIOT_Syllabary}', "");
    Expect(0, 67648, '\P{^Blk:	- CYPRIOT_Syllabary}', "");
    Error('\p{Is_Block=-:=cypriot_syllabary}');
    Error('\P{Is_Block=-:=cypriot_syllabary}');
    Expect(1, 67647, '\p{Is_Block=cypriotsyllabary}', "");
    Expect(0, 67647, '\p{^Is_Block=cypriotsyllabary}', "");
    Expect(0, 67647, '\P{Is_Block=cypriotsyllabary}', "");
    Expect(1, 67647, '\P{^Is_Block=cypriotsyllabary}', "");
    Expect(0, 67648, '\p{Is_Block=cypriotsyllabary}', "");
    Expect(1, 67648, '\p{^Is_Block=cypriotsyllabary}', "");
    Expect(1, 67648, '\P{Is_Block=cypriotsyllabary}', "");
    Expect(0, 67648, '\P{^Is_Block=cypriotsyllabary}', "");
    Expect(1, 67647, '\p{Is_Block=__CYPRIOT_SYLLABARY}', "");
    Expect(0, 67647, '\p{^Is_Block=__CYPRIOT_SYLLABARY}', "");
    Expect(0, 67647, '\P{Is_Block=__CYPRIOT_SYLLABARY}', "");
    Expect(1, 67647, '\P{^Is_Block=__CYPRIOT_SYLLABARY}', "");
    Expect(0, 67648, '\p{Is_Block=__CYPRIOT_SYLLABARY}', "");
    Expect(1, 67648, '\p{^Is_Block=__CYPRIOT_SYLLABARY}', "");
    Expect(1, 67648, '\P{Is_Block=__CYPRIOT_SYLLABARY}', "");
    Expect(0, 67648, '\P{^Is_Block=__CYPRIOT_SYLLABARY}', "");
    Error('\p{Is_Blk=_/a/Cypriot_syllabary}');
    Error('\P{Is_Blk=_/a/Cypriot_syllabary}');
    Expect(1, 67647, '\p{Is_Blk=cypriotsyllabary}', "");
    Expect(0, 67647, '\p{^Is_Blk=cypriotsyllabary}', "");
    Expect(0, 67647, '\P{Is_Blk=cypriotsyllabary}', "");
    Expect(1, 67647, '\P{^Is_Blk=cypriotsyllabary}', "");
    Expect(0, 67648, '\p{Is_Blk=cypriotsyllabary}', "");
    Expect(1, 67648, '\p{^Is_Blk=cypriotsyllabary}', "");
    Expect(1, 67648, '\P{Is_Blk=cypriotsyllabary}', "");
    Expect(0, 67648, '\P{^Is_Blk=cypriotsyllabary}', "");
    Expect(1, 67647, '\p{Is_Blk=	 CYPRIOT_SYLLABARY}', "");
    Expect(0, 67647, '\p{^Is_Blk=	 CYPRIOT_SYLLABARY}', "");
    Expect(0, 67647, '\P{Is_Blk=	 CYPRIOT_SYLLABARY}', "");
    Expect(1, 67647, '\P{^Is_Blk=	 CYPRIOT_SYLLABARY}', "");
    Expect(0, 67648, '\p{Is_Blk=	 CYPRIOT_SYLLABARY}', "");
    Expect(1, 67648, '\p{^Is_Blk=	 CYPRIOT_SYLLABARY}', "");
    Expect(1, 67648, '\P{Is_Blk=	 CYPRIOT_SYLLABARY}', "");
    Expect(0, 67648, '\P{^Is_Blk=	 CYPRIOT_SYLLABARY}', "");
    Error('\p{Block=_cyrillic:=}');
    Error('\P{Block=_cyrillic:=}');
    Expect(1, 1279, '\p{Block=:\ACyrillic\z:}', "");;
    Expect(0, 1280, '\p{Block=:\ACyrillic\z:}', "");;
    Expect(1, 1279, '\p{Block=cyrillic}', "");
    Expect(0, 1279, '\p{^Block=cyrillic}', "");
    Expect(0, 1279, '\P{Block=cyrillic}', "");
    Expect(1, 1279, '\P{^Block=cyrillic}', "");
    Expect(0, 1280, '\p{Block=cyrillic}', "");
    Expect(1, 1280, '\p{^Block=cyrillic}', "");
    Expect(1, 1280, '\P{Block=cyrillic}', "");
    Expect(0, 1280, '\P{^Block=cyrillic}', "");
    Expect(1, 1279, '\p{Block=:\Acyrillic\z:}', "");;
    Expect(0, 1280, '\p{Block=:\Acyrillic\z:}', "");;
    Expect(1, 1279, '\p{Block=_CYRILLIC}', "");
    Expect(0, 1279, '\p{^Block=_CYRILLIC}', "");
    Expect(0, 1279, '\P{Block=_CYRILLIC}', "");
    Expect(1, 1279, '\P{^Block=_CYRILLIC}', "");
    Expect(0, 1280, '\p{Block=_CYRILLIC}', "");
    Expect(1, 1280, '\p{^Block=_CYRILLIC}', "");
    Expect(1, 1280, '\P{Block=_CYRILLIC}', "");
    Expect(0, 1280, '\P{^Block=_CYRILLIC}', "");
    Error('\p{Blk=:= Cyrillic}');
    Error('\P{Blk=:= Cyrillic}');
    Expect(1, 1279, '\p{Blk=:\ACyrillic\z:}', "");;
    Expect(0, 1280, '\p{Blk=:\ACyrillic\z:}', "");;
    Expect(1, 1279, '\p{Blk:   cyrillic}', "");
    Expect(0, 1279, '\p{^Blk:   cyrillic}', "");
    Expect(0, 1279, '\P{Blk:   cyrillic}', "");
    Expect(1, 1279, '\P{^Blk:   cyrillic}', "");
    Expect(0, 1280, '\p{Blk:   cyrillic}', "");
    Expect(1, 1280, '\p{^Blk:   cyrillic}', "");
    Expect(1, 1280, '\P{Blk:   cyrillic}', "");
    Expect(0, 1280, '\P{^Blk:   cyrillic}', "");
    Expect(1, 1279, '\p{Blk=:\Acyrillic\z:}', "");;
    Expect(0, 1280, '\p{Blk=:\Acyrillic\z:}', "");;
    Expect(1, 1279, '\p{Blk=--cyrillic}', "");
    Expect(0, 1279, '\p{^Blk=--cyrillic}', "");
    Expect(0, 1279, '\P{Blk=--cyrillic}', "");
    Expect(1, 1279, '\P{^Blk=--cyrillic}', "");
    Expect(0, 1280, '\p{Blk=--cyrillic}', "");
    Expect(1, 1280, '\p{^Blk=--cyrillic}', "");
    Expect(1, 1280, '\P{Blk=--cyrillic}', "");
    Expect(0, 1280, '\P{^Blk=--cyrillic}', "");
    Error('\p{Is_Block=-	Cyrillic/a/}');
    Error('\P{Is_Block=-	Cyrillic/a/}');
    Expect(1, 1279, '\p{Is_Block=cyrillic}', "");
    Expect(0, 1279, '\p{^Is_Block=cyrillic}', "");
    Expect(0, 1279, '\P{Is_Block=cyrillic}', "");
    Expect(1, 1279, '\P{^Is_Block=cyrillic}', "");
    Expect(0, 1280, '\p{Is_Block=cyrillic}', "");
    Expect(1, 1280, '\p{^Is_Block=cyrillic}', "");
    Expect(1, 1280, '\P{Is_Block=cyrillic}', "");
    Expect(0, 1280, '\P{^Is_Block=cyrillic}', "");
    Expect(1, 1279, '\p{Is_Block=	_Cyrillic}', "");
    Expect(0, 1279, '\p{^Is_Block=	_Cyrillic}', "");
    Expect(0, 1279, '\P{Is_Block=	_Cyrillic}', "");
    Expect(1, 1279, '\P{^Is_Block=	_Cyrillic}', "");
    Expect(0, 1280, '\p{Is_Block=	_Cyrillic}', "");
    Expect(1, 1280, '\p{^Is_Block=	_Cyrillic}', "");
    Expect(1, 1280, '\P{Is_Block=	_Cyrillic}', "");
    Expect(0, 1280, '\P{^Is_Block=	_Cyrillic}', "");
    Error('\p{Is_Blk=:= _CYRILLIC}');
    Error('\P{Is_Blk=:= _CYRILLIC}');
    Expect(1, 1279, '\p{Is_Blk=cyrillic}', "");
    Expect(0, 1279, '\p{^Is_Blk=cyrillic}', "");
    Expect(0, 1279, '\P{Is_Blk=cyrillic}', "");
    Expect(1, 1279, '\P{^Is_Blk=cyrillic}', "");
    Expect(0, 1280, '\p{Is_Blk=cyrillic}', "");
    Expect(1, 1280, '\p{^Is_Blk=cyrillic}', "");
    Expect(1, 1280, '\P{Is_Blk=cyrillic}', "");
    Expect(0, 1280, '\P{^Is_Blk=cyrillic}', "");
    Expect(1, 1279, '\p{Is_Blk:    	CYRILLIC}', "");
    Expect(0, 1279, '\p{^Is_Blk:    	CYRILLIC}', "");
    Expect(0, 1279, '\P{Is_Blk:    	CYRILLIC}', "");
    Expect(1, 1279, '\P{^Is_Blk:    	CYRILLIC}', "");
    Expect(0, 1280, '\p{Is_Blk:    	CYRILLIC}', "");
    Expect(1, 1280, '\p{^Is_Blk:    	CYRILLIC}', "");
    Expect(1, 1280, '\P{Is_Blk:    	CYRILLIC}', "");
    Expect(0, 1280, '\P{^Is_Blk:    	CYRILLIC}', "");
    Error('\p{Block:   :=		Cyrillic_EXTENDED_A}');
    Error('\P{Block:   :=		Cyrillic_EXTENDED_A}');
    Expect(1, 11775, '\p{Block=:\ACyrillic_Extended_A\z:}', "");;
    Expect(0, 11776, '\p{Block=:\ACyrillic_Extended_A\z:}', "");;
    Expect(1, 11775, '\p{Block=cyrillicextendeda}', "");
    Expect(0, 11775, '\p{^Block=cyrillicextendeda}', "");
    Expect(0, 11775, '\P{Block=cyrillicextendeda}', "");
    Expect(1, 11775, '\P{^Block=cyrillicextendeda}', "");
    Expect(0, 11776, '\p{Block=cyrillicextendeda}', "");
    Expect(1, 11776, '\p{^Block=cyrillicextendeda}', "");
    Expect(1, 11776, '\P{Block=cyrillicextendeda}', "");
    Expect(0, 11776, '\P{^Block=cyrillicextendeda}', "");
    Expect(1, 11775, '\p{Block=:\Acyrillicextendeda\z:}', "");;
    Expect(0, 11776, '\p{Block=:\Acyrillicextendeda\z:}', "");;
    Expect(1, 11775, '\p{Block=_cyrillic_EXTENDED_A}', "");
    Expect(0, 11775, '\p{^Block=_cyrillic_EXTENDED_A}', "");
    Expect(0, 11775, '\P{Block=_cyrillic_EXTENDED_A}', "");
    Expect(1, 11775, '\P{^Block=_cyrillic_EXTENDED_A}', "");
    Expect(0, 11776, '\p{Block=_cyrillic_EXTENDED_A}', "");
    Expect(1, 11776, '\p{^Block=_cyrillic_EXTENDED_A}', "");
    Expect(1, 11776, '\P{Block=_cyrillic_EXTENDED_A}', "");
    Expect(0, 11776, '\P{^Block=_cyrillic_EXTENDED_A}', "");
    Error('\p{Blk=_Cyrillic_Ext_A/a/}');
    Error('\P{Blk=_Cyrillic_Ext_A/a/}');
    Expect(1, 11775, '\p{Blk=:\ACyrillic_Ext_A\z:}', "");;
    Expect(0, 11776, '\p{Blk=:\ACyrillic_Ext_A\z:}', "");;
    Expect(1, 11775, '\p{Blk=cyrillicexta}', "");
    Expect(0, 11775, '\p{^Blk=cyrillicexta}', "");
    Expect(0, 11775, '\P{Blk=cyrillicexta}', "");
    Expect(1, 11775, '\P{^Blk=cyrillicexta}', "");
    Expect(0, 11776, '\p{Blk=cyrillicexta}', "");
    Expect(1, 11776, '\p{^Blk=cyrillicexta}', "");
    Expect(1, 11776, '\P{Blk=cyrillicexta}', "");
    Expect(0, 11776, '\P{^Blk=cyrillicexta}', "");
    Expect(1, 11775, '\p{Blk=:\Acyrillicexta\z:}', "");;
    Expect(0, 11776, '\p{Blk=:\Acyrillicexta\z:}', "");;
    Expect(1, 11775, '\p{Blk= 	cyrillic_EXT_a}', "");
    Expect(0, 11775, '\p{^Blk= 	cyrillic_EXT_a}', "");
    Expect(0, 11775, '\P{Blk= 	cyrillic_EXT_a}', "");
    Expect(1, 11775, '\P{^Blk= 	cyrillic_EXT_a}', "");
    Expect(0, 11776, '\p{Blk= 	cyrillic_EXT_a}', "");
    Expect(1, 11776, '\p{^Blk= 	cyrillic_EXT_a}', "");
    Expect(1, 11776, '\P{Blk= 	cyrillic_EXT_a}', "");
    Expect(0, 11776, '\P{^Blk= 	cyrillic_EXT_a}', "");
    Error('\p{Is_Block=:=	 cyrillic_Extended_a}');
    Error('\P{Is_Block=:=	 cyrillic_Extended_a}');
    Expect(1, 11775, '\p{Is_Block=cyrillicextendeda}', "");
    Expect(0, 11775, '\p{^Is_Block=cyrillicextendeda}', "");
    Expect(0, 11775, '\P{Is_Block=cyrillicextendeda}', "");
    Expect(1, 11775, '\P{^Is_Block=cyrillicextendeda}', "");
    Expect(0, 11776, '\p{Is_Block=cyrillicextendeda}', "");
    Expect(1, 11776, '\p{^Is_Block=cyrillicextendeda}', "");
    Expect(1, 11776, '\P{Is_Block=cyrillicextendeda}', "");
    Expect(0, 11776, '\P{^Is_Block=cyrillicextendeda}', "");
    Expect(1, 11775, '\p{Is_Block= -cyrillic_Extended_A}', "");
    Expect(0, 11775, '\p{^Is_Block= -cyrillic_Extended_A}', "");
    Expect(0, 11775, '\P{Is_Block= -cyrillic_Extended_A}', "");
    Expect(1, 11775, '\P{^Is_Block= -cyrillic_Extended_A}', "");
    Expect(0, 11776, '\p{Is_Block= -cyrillic_Extended_A}', "");
    Expect(1, 11776, '\p{^Is_Block= -cyrillic_Extended_A}', "");
    Expect(1, 11776, '\P{Is_Block= -cyrillic_Extended_A}', "");
    Expect(0, 11776, '\P{^Is_Block= -cyrillic_Extended_A}', "");
    Error('\p{Is_Blk= CYRILLIC_Ext_A:=}');
    Error('\P{Is_Blk= CYRILLIC_Ext_A:=}');
    Expect(1, 11775, '\p{Is_Blk=cyrillicexta}', "");
    Expect(0, 11775, '\p{^Is_Blk=cyrillicexta}', "");
    Expect(0, 11775, '\P{Is_Blk=cyrillicexta}', "");
    Expect(1, 11775, '\P{^Is_Blk=cyrillicexta}', "");
    Expect(0, 11776, '\p{Is_Blk=cyrillicexta}', "");
    Expect(1, 11776, '\p{^Is_Blk=cyrillicexta}', "");
    Expect(1, 11776, '\P{Is_Blk=cyrillicexta}', "");
    Expect(0, 11776, '\P{^Is_Blk=cyrillicexta}', "");
    Expect(1, 11775, '\p{Is_Blk=_Cyrillic_Ext_A}', "");
    Expect(0, 11775, '\p{^Is_Blk=_Cyrillic_Ext_A}', "");
    Expect(0, 11775, '\P{Is_Blk=_Cyrillic_Ext_A}', "");
    Expect(1, 11775, '\P{^Is_Blk=_Cyrillic_Ext_A}', "");
    Expect(0, 11776, '\p{Is_Blk=_Cyrillic_Ext_A}', "");
    Expect(1, 11776, '\p{^Is_Blk=_Cyrillic_Ext_A}', "");
    Expect(1, 11776, '\P{Is_Blk=_Cyrillic_Ext_A}', "");
    Expect(0, 11776, '\P{^Is_Blk=_Cyrillic_Ext_A}', "");
    Error('\p{Block=/a/	 CYRILLIC_Extended_B}');
    Error('\P{Block=/a/	 CYRILLIC_Extended_B}');
    Expect(1, 42655, '\p{Block=:\ACyrillic_Extended_B\z:}', "");;
    Expect(0, 42656, '\p{Block=:\ACyrillic_Extended_B\z:}', "");;
    Expect(1, 42655, '\p{Block: cyrillicextendedb}', "");
    Expect(0, 42655, '\p{^Block: cyrillicextendedb}', "");
    Expect(0, 42655, '\P{Block: cyrillicextendedb}', "");
    Expect(1, 42655, '\P{^Block: cyrillicextendedb}', "");
    Expect(0, 42656, '\p{Block: cyrillicextendedb}', "");
    Expect(1, 42656, '\p{^Block: cyrillicextendedb}', "");
    Expect(1, 42656, '\P{Block: cyrillicextendedb}', "");
    Expect(0, 42656, '\P{^Block: cyrillicextendedb}', "");
    Expect(1, 42655, '\p{Block=:\Acyrillicextendedb\z:}', "");;
    Expect(0, 42656, '\p{Block=:\Acyrillicextendedb\z:}', "");;
    Expect(1, 42655, '\p{Block= cyrillic_Extended_B}', "");
    Expect(0, 42655, '\p{^Block= cyrillic_Extended_B}', "");
    Expect(0, 42655, '\P{Block= cyrillic_Extended_B}', "");
    Expect(1, 42655, '\P{^Block= cyrillic_Extended_B}', "");
    Expect(0, 42656, '\p{Block= cyrillic_Extended_B}', "");
    Expect(1, 42656, '\p{^Block= cyrillic_Extended_B}', "");
    Expect(1, 42656, '\P{Block= cyrillic_Extended_B}', "");
    Expect(0, 42656, '\P{^Block= cyrillic_Extended_B}', "");
    Error('\p{Blk=:=Cyrillic_EXT_B}');
    Error('\P{Blk=:=Cyrillic_EXT_B}');
    Expect(1, 42655, '\p{Blk=:\ACyrillic_Ext_B\z:}', "");;
    Expect(0, 42656, '\p{Blk=:\ACyrillic_Ext_B\z:}', "");;
    Expect(1, 42655, '\p{Blk=cyrillicextb}', "");
    Expect(0, 42655, '\p{^Blk=cyrillicextb}', "");
    Expect(0, 42655, '\P{Blk=cyrillicextb}', "");
    Expect(1, 42655, '\P{^Blk=cyrillicextb}', "");
    Expect(0, 42656, '\p{Blk=cyrillicextb}', "");
    Expect(1, 42656, '\p{^Blk=cyrillicextb}', "");
    Expect(1, 42656, '\P{Blk=cyrillicextb}', "");
    Expect(0, 42656, '\P{^Blk=cyrillicextb}', "");
    Expect(1, 42655, '\p{Blk=:\Acyrillicextb\z:}', "");;
    Expect(0, 42656, '\p{Blk=:\Acyrillicextb\z:}', "");;
    Expect(1, 42655, '\p{Blk=	-CYRILLIC_ext_b}', "");
    Expect(0, 42655, '\p{^Blk=	-CYRILLIC_ext_b}', "");
    Expect(0, 42655, '\P{Blk=	-CYRILLIC_ext_b}', "");
    Expect(1, 42655, '\P{^Blk=	-CYRILLIC_ext_b}', "");
    Expect(0, 42656, '\p{Blk=	-CYRILLIC_ext_b}', "");
    Expect(1, 42656, '\p{^Blk=	-CYRILLIC_ext_b}', "");
    Expect(1, 42656, '\P{Blk=	-CYRILLIC_ext_b}', "");
    Expect(0, 42656, '\P{^Blk=	-CYRILLIC_ext_b}', "");
    Error('\p{Is_Block=_/a/cyrillic_Extended_B}');
    Error('\P{Is_Block=_/a/cyrillic_Extended_B}');
    Expect(1, 42655, '\p{Is_Block:	cyrillicextendedb}', "");
    Expect(0, 42655, '\p{^Is_Block:	cyrillicextendedb}', "");
    Expect(0, 42655, '\P{Is_Block:	cyrillicextendedb}', "");
    Expect(1, 42655, '\P{^Is_Block:	cyrillicextendedb}', "");
    Expect(0, 42656, '\p{Is_Block:	cyrillicextendedb}', "");
    Expect(1, 42656, '\p{^Is_Block:	cyrillicextendedb}', "");
    Expect(1, 42656, '\P{Is_Block:	cyrillicextendedb}', "");
    Expect(0, 42656, '\P{^Is_Block:	cyrillicextendedb}', "");
    Expect(1, 42655, '\p{Is_Block=-	Cyrillic_Extended_b}', "");
    Expect(0, 42655, '\p{^Is_Block=-	Cyrillic_Extended_b}', "");
    Expect(0, 42655, '\P{Is_Block=-	Cyrillic_Extended_b}', "");
    Expect(1, 42655, '\P{^Is_Block=-	Cyrillic_Extended_b}', "");
    Expect(0, 42656, '\p{Is_Block=-	Cyrillic_Extended_b}', "");
    Expect(1, 42656, '\p{^Is_Block=-	Cyrillic_Extended_b}', "");
    Expect(1, 42656, '\P{Is_Block=-	Cyrillic_Extended_b}', "");
    Expect(0, 42656, '\P{^Is_Block=-	Cyrillic_Extended_b}', "");
    Error('\p{Is_Blk=	_Cyrillic_EXT_B:=}');
    Error('\P{Is_Blk=	_Cyrillic_EXT_B:=}');
    Expect(1, 42655, '\p{Is_Blk=cyrillicextb}', "");
    Expect(0, 42655, '\p{^Is_Blk=cyrillicextb}', "");
    Expect(0, 42655, '\P{Is_Blk=cyrillicextb}', "");
    Expect(1, 42655, '\P{^Is_Blk=cyrillicextb}', "");
    Expect(0, 42656, '\p{Is_Blk=cyrillicextb}', "");
    Expect(1, 42656, '\p{^Is_Blk=cyrillicextb}', "");
    Expect(1, 42656, '\P{Is_Blk=cyrillicextb}', "");
    Expect(0, 42656, '\P{^Is_Blk=cyrillicextb}', "");
    Expect(1, 42655, '\p{Is_Blk= Cyrillic_Ext_B}', "");
    Expect(0, 42655, '\p{^Is_Blk= Cyrillic_Ext_B}', "");
    Expect(0, 42655, '\P{Is_Blk= Cyrillic_Ext_B}', "");
    Expect(1, 42655, '\P{^Is_Blk= Cyrillic_Ext_B}', "");
    Expect(0, 42656, '\p{Is_Blk= Cyrillic_Ext_B}', "");
    Expect(1, 42656, '\p{^Is_Blk= Cyrillic_Ext_B}', "");
    Expect(1, 42656, '\P{Is_Blk= Cyrillic_Ext_B}', "");
    Expect(0, 42656, '\P{^Is_Blk= Cyrillic_Ext_B}', "");
    Error('\p{Block=:=cyrillic_Extended_C}');
    Error('\P{Block=:=cyrillic_Extended_C}');
    Expect(1, 7311, '\p{Block=:\ACyrillic_Extended_C\z:}', "");;
    Expect(0, 7312, '\p{Block=:\ACyrillic_Extended_C\z:}', "");;
    Expect(1, 7311, '\p{Block=cyrillicextendedc}', "");
    Expect(0, 7311, '\p{^Block=cyrillicextendedc}', "");
    Expect(0, 7311, '\P{Block=cyrillicextendedc}', "");
    Expect(1, 7311, '\P{^Block=cyrillicextendedc}', "");
    Expect(0, 7312, '\p{Block=cyrillicextendedc}', "");
    Expect(1, 7312, '\p{^Block=cyrillicextendedc}', "");
    Expect(1, 7312, '\P{Block=cyrillicextendedc}', "");
    Expect(0, 7312, '\P{^Block=cyrillicextendedc}', "");
    Expect(1, 7311, '\p{Block=:\Acyrillicextendedc\z:}', "");;
    Expect(0, 7312, '\p{Block=:\Acyrillicextendedc\z:}', "");;
    Expect(1, 7311, '\p{Block=	_CYRILLIC_EXTENDED_c}', "");
    Expect(0, 7311, '\p{^Block=	_CYRILLIC_EXTENDED_c}', "");
    Expect(0, 7311, '\P{Block=	_CYRILLIC_EXTENDED_c}', "");
    Expect(1, 7311, '\P{^Block=	_CYRILLIC_EXTENDED_c}', "");
    Expect(0, 7312, '\p{Block=	_CYRILLIC_EXTENDED_c}', "");
    Expect(1, 7312, '\p{^Block=	_CYRILLIC_EXTENDED_c}', "");
    Expect(1, 7312, '\P{Block=	_CYRILLIC_EXTENDED_c}', "");
    Expect(0, 7312, '\P{^Block=	_CYRILLIC_EXTENDED_c}', "");
    Error('\p{Blk=:= -Cyrillic_Ext_C}');
    Error('\P{Blk=:= -Cyrillic_Ext_C}');
    Expect(1, 7311, '\p{Blk=:\ACyrillic_Ext_C\z:}', "");;
    Expect(0, 7312, '\p{Blk=:\ACyrillic_Ext_C\z:}', "");;
    Expect(1, 7311, '\p{Blk:   cyrillicextc}', "");
    Expect(0, 7311, '\p{^Blk:   cyrillicextc}', "");
    Expect(0, 7311, '\P{Blk:   cyrillicextc}', "");
    Expect(1, 7311, '\P{^Blk:   cyrillicextc}', "");
    Expect(0, 7312, '\p{Blk:   cyrillicextc}', "");
    Expect(1, 7312, '\p{^Blk:   cyrillicextc}', "");
    Expect(1, 7312, '\P{Blk:   cyrillicextc}', "");
    Expect(0, 7312, '\P{^Blk:   cyrillicextc}', "");
    Expect(1, 7311, '\p{Blk=:\Acyrillicextc\z:}', "");;
    Expect(0, 7312, '\p{Blk=:\Acyrillicextc\z:}', "");;
    Expect(1, 7311, '\p{Blk=		Cyrillic_EXT_c}', "");
    Expect(0, 7311, '\p{^Blk=		Cyrillic_EXT_c}', "");
    Expect(0, 7311, '\P{Blk=		Cyrillic_EXT_c}', "");
    Expect(1, 7311, '\P{^Blk=		Cyrillic_EXT_c}', "");
    Expect(0, 7312, '\p{Blk=		Cyrillic_EXT_c}', "");
    Expect(1, 7312, '\p{^Blk=		Cyrillic_EXT_c}', "");
    Expect(1, 7312, '\P{Blk=		Cyrillic_EXT_c}', "");
    Expect(0, 7312, '\P{^Blk=		Cyrillic_EXT_c}', "");
    Error('\p{Is_Block=-:=Cyrillic_Extended_C}');
    Error('\P{Is_Block=-:=Cyrillic_Extended_C}');
    Expect(1, 7311, '\p{Is_Block=cyrillicextendedc}', "");
    Expect(0, 7311, '\p{^Is_Block=cyrillicextendedc}', "");
    Expect(0, 7311, '\P{Is_Block=cyrillicextendedc}', "");
    Expect(1, 7311, '\P{^Is_Block=cyrillicextendedc}', "");
    Expect(0, 7312, '\p{Is_Block=cyrillicextendedc}', "");
    Expect(1, 7312, '\p{^Is_Block=cyrillicextendedc}', "");
    Expect(1, 7312, '\P{Is_Block=cyrillicextendedc}', "");
    Expect(0, 7312, '\P{^Is_Block=cyrillicextendedc}', "");
    Expect(1, 7311, '\p{Is_Block=- Cyrillic_Extended_c}', "");
    Expect(0, 7311, '\p{^Is_Block=- Cyrillic_Extended_c}', "");
    Expect(0, 7311, '\P{Is_Block=- Cyrillic_Extended_c}', "");
    Expect(1, 7311, '\P{^Is_Block=- Cyrillic_Extended_c}', "");
    Expect(0, 7312, '\p{Is_Block=- Cyrillic_Extended_c}', "");
    Expect(1, 7312, '\p{^Is_Block=- Cyrillic_Extended_c}', "");
    Expect(1, 7312, '\P{Is_Block=- Cyrillic_Extended_c}', "");
    Expect(0, 7312, '\P{^Is_Block=- Cyrillic_Extended_c}', "");
    Error('\p{Is_Blk=/a/ -CYRILLIC_Ext_C}');
    Error('\P{Is_Blk=/a/ -CYRILLIC_Ext_C}');
    Expect(1, 7311, '\p{Is_Blk=cyrillicextc}', "");
    Expect(0, 7311, '\p{^Is_Blk=cyrillicextc}', "");
    Expect(0, 7311, '\P{Is_Blk=cyrillicextc}', "");
    Expect(1, 7311, '\P{^Is_Blk=cyrillicextc}', "");
    Expect(0, 7312, '\p{Is_Blk=cyrillicextc}', "");
    Expect(1, 7312, '\p{^Is_Blk=cyrillicextc}', "");
    Expect(1, 7312, '\P{Is_Blk=cyrillicextc}', "");
    Expect(0, 7312, '\P{^Is_Blk=cyrillicextc}', "");
    Expect(1, 7311, '\p{Is_Blk=_-CYRILLIC_Ext_C}', "");
    Expect(0, 7311, '\p{^Is_Blk=_-CYRILLIC_Ext_C}', "");
    Expect(0, 7311, '\P{Is_Blk=_-CYRILLIC_Ext_C}', "");
    Expect(1, 7311, '\P{^Is_Blk=_-CYRILLIC_Ext_C}', "");
    Expect(0, 7312, '\p{Is_Blk=_-CYRILLIC_Ext_C}', "");
    Expect(1, 7312, '\p{^Is_Blk=_-CYRILLIC_Ext_C}', "");
    Expect(1, 7312, '\P{Is_Blk=_-CYRILLIC_Ext_C}', "");
    Expect(0, 7312, '\P{^Is_Blk=_-CYRILLIC_Ext_C}', "");
    Error('\p{Block=:=	Cyrillic_supplement}');
    Error('\P{Block=:=	Cyrillic_supplement}');
    Expect(1, 1327, '\p{Block=:\ACyrillic_Supplement\z:}', "");;
    Expect(0, 1328, '\p{Block=:\ACyrillic_Supplement\z:}', "");;
    Expect(1, 1327, '\p{Block=cyrillicsupplement}', "");
    Expect(0, 1327, '\p{^Block=cyrillicsupplement}', "");
    Expect(0, 1327, '\P{Block=cyrillicsupplement}', "");
    Expect(1, 1327, '\P{^Block=cyrillicsupplement}', "");
    Expect(0, 1328, '\p{Block=cyrillicsupplement}', "");
    Expect(1, 1328, '\p{^Block=cyrillicsupplement}', "");
    Expect(1, 1328, '\P{Block=cyrillicsupplement}', "");
    Expect(0, 1328, '\P{^Block=cyrillicsupplement}', "");
    Expect(1, 1327, '\p{Block=:\Acyrillicsupplement\z:}', "");;
    Expect(0, 1328, '\p{Block=:\Acyrillicsupplement\z:}', "");;
    Expect(1, 1327, '\p{Block: - CYRILLIC_Supplement}', "");
    Expect(0, 1327, '\p{^Block: - CYRILLIC_Supplement}', "");
    Expect(0, 1327, '\P{Block: - CYRILLIC_Supplement}', "");
    Expect(1, 1327, '\P{^Block: - CYRILLIC_Supplement}', "");
    Expect(0, 1328, '\p{Block: - CYRILLIC_Supplement}', "");
    Expect(1, 1328, '\p{^Block: - CYRILLIC_Supplement}', "");
    Expect(1, 1328, '\P{Block: - CYRILLIC_Supplement}', "");
    Expect(0, 1328, '\P{^Block: - CYRILLIC_Supplement}', "");
    Error('\p{Blk=/a/Cyrillic_sup}');
    Error('\P{Blk=/a/Cyrillic_sup}');
    Expect(1, 1327, '\p{Blk=:\ACyrillic_Sup\z:}', "");;
    Expect(0, 1328, '\p{Blk=:\ACyrillic_Sup\z:}', "");;
    Expect(1, 1327, '\p{Blk=cyrillicsup}', "");
    Expect(0, 1327, '\p{^Blk=cyrillicsup}', "");
    Expect(0, 1327, '\P{Blk=cyrillicsup}', "");
    Expect(1, 1327, '\P{^Blk=cyrillicsup}', "");
    Expect(0, 1328, '\p{Blk=cyrillicsup}', "");
    Expect(1, 1328, '\p{^Blk=cyrillicsup}', "");
    Expect(1, 1328, '\P{Blk=cyrillicsup}', "");
    Expect(0, 1328, '\P{^Blk=cyrillicsup}', "");
    Expect(1, 1327, '\p{Blk=:\Acyrillicsup\z:}', "");;
    Expect(0, 1328, '\p{Blk=:\Acyrillicsup\z:}', "");;
    Expect(1, 1327, '\p{Blk= _Cyrillic_Sup}', "");
    Expect(0, 1327, '\p{^Blk= _Cyrillic_Sup}', "");
    Expect(0, 1327, '\P{Blk= _Cyrillic_Sup}', "");
    Expect(1, 1327, '\P{^Blk= _Cyrillic_Sup}', "");
    Expect(0, 1328, '\p{Blk= _Cyrillic_Sup}', "");
    Expect(1, 1328, '\p{^Blk= _Cyrillic_Sup}', "");
    Expect(1, 1328, '\P{Blk= _Cyrillic_Sup}', "");
    Expect(0, 1328, '\P{^Blk= _Cyrillic_Sup}', "");
    Error('\p{Is_Block=	/a/cyrillic_Supplementary}');
    Error('\P{Is_Block=	/a/cyrillic_Supplementary}');
    Expect(1, 1327, '\p{Is_Block=cyrillicsupplementary}', "");
    Expect(0, 1327, '\p{^Is_Block=cyrillicsupplementary}', "");
    Expect(0, 1327, '\P{Is_Block=cyrillicsupplementary}', "");
    Expect(1, 1327, '\P{^Is_Block=cyrillicsupplementary}', "");
    Expect(0, 1328, '\p{Is_Block=cyrillicsupplementary}', "");
    Expect(1, 1328, '\p{^Is_Block=cyrillicsupplementary}', "");
    Expect(1, 1328, '\P{Is_Block=cyrillicsupplementary}', "");
    Expect(0, 1328, '\P{^Is_Block=cyrillicsupplementary}', "");
    Expect(1, 1327, '\p{Is_Block=__cyrillic_supplementary}', "");
    Expect(0, 1327, '\p{^Is_Block=__cyrillic_supplementary}', "");
    Expect(0, 1327, '\P{Is_Block=__cyrillic_supplementary}', "");
    Expect(1, 1327, '\P{^Is_Block=__cyrillic_supplementary}', "");
    Expect(0, 1328, '\p{Is_Block=__cyrillic_supplementary}', "");
    Expect(1, 1328, '\p{^Is_Block=__cyrillic_supplementary}', "");
    Expect(1, 1328, '\P{Is_Block=__cyrillic_supplementary}', "");
    Expect(0, 1328, '\P{^Is_Block=__cyrillic_supplementary}', "");
    Error('\p{Is_Blk=/a/CYRILLIC_SUPPLEMENT}');
    Error('\P{Is_Blk=/a/CYRILLIC_SUPPLEMENT}');
    Expect(1, 1327, '\p{Is_Blk=cyrillicsupplement}', "");
    Expect(0, 1327, '\p{^Is_Blk=cyrillicsupplement}', "");
    Expect(0, 1327, '\P{Is_Blk=cyrillicsupplement}', "");
    Expect(1, 1327, '\P{^Is_Blk=cyrillicsupplement}', "");
    Expect(0, 1328, '\p{Is_Blk=cyrillicsupplement}', "");
    Expect(1, 1328, '\p{^Is_Blk=cyrillicsupplement}', "");
    Expect(1, 1328, '\P{Is_Blk=cyrillicsupplement}', "");
    Expect(0, 1328, '\P{^Is_Blk=cyrillicsupplement}', "");
    Expect(1, 1327, '\p{Is_Blk=-	Cyrillic_Supplement}', "");
    Expect(0, 1327, '\p{^Is_Blk=-	Cyrillic_Supplement}', "");
    Expect(0, 1327, '\P{Is_Blk=-	Cyrillic_Supplement}', "");
    Expect(1, 1327, '\P{^Is_Blk=-	Cyrillic_Supplement}', "");
    Expect(0, 1328, '\p{Is_Blk=-	Cyrillic_Supplement}', "");
    Expect(1, 1328, '\p{^Is_Blk=-	Cyrillic_Supplement}', "");
    Expect(1, 1328, '\P{Is_Blk=-	Cyrillic_Supplement}', "");
    Expect(0, 1328, '\P{^Is_Blk=-	Cyrillic_Supplement}', "");
    Error('\p{Block=-	Deseret/a/}');
    Error('\P{Block=-	Deseret/a/}');
    Expect(1, 66639, '\p{Block=:\ADeseret\z:}', "");;
    Expect(0, 66640, '\p{Block=:\ADeseret\z:}', "");;
    Expect(1, 66639, '\p{Block=deseret}', "");
    Expect(0, 66639, '\p{^Block=deseret}', "");
    Expect(0, 66639, '\P{Block=deseret}', "");
    Expect(1, 66639, '\P{^Block=deseret}', "");
    Expect(0, 66640, '\p{Block=deseret}', "");
    Expect(1, 66640, '\p{^Block=deseret}', "");
    Expect(1, 66640, '\P{Block=deseret}', "");
    Expect(0, 66640, '\P{^Block=deseret}', "");
    Expect(1, 66639, '\p{Block=:\Adeseret\z:}', "");;
    Expect(0, 66640, '\p{Block=:\Adeseret\z:}', "");;
    Expect(1, 66639, '\p{Block=	-deseret}', "");
    Expect(0, 66639, '\p{^Block=	-deseret}', "");
    Expect(0, 66639, '\P{Block=	-deseret}', "");
    Expect(1, 66639, '\P{^Block=	-deseret}', "");
    Expect(0, 66640, '\p{Block=	-deseret}', "");
    Expect(1, 66640, '\p{^Block=	-deseret}', "");
    Expect(1, 66640, '\P{Block=	-deseret}', "");
    Expect(0, 66640, '\P{^Block=	-deseret}', "");
    Error('\p{Blk=:=_ deseret}');
    Error('\P{Blk=:=_ deseret}');
    Expect(1, 66639, '\p{Blk=:\ADeseret\z:}', "");;
    Expect(0, 66640, '\p{Blk=:\ADeseret\z:}', "");;
    Expect(1, 66639, '\p{Blk=deseret}', "");
    Expect(0, 66639, '\p{^Blk=deseret}', "");
    Expect(0, 66639, '\P{Blk=deseret}', "");
    Expect(1, 66639, '\P{^Blk=deseret}', "");
    Expect(0, 66640, '\p{Blk=deseret}', "");
    Expect(1, 66640, '\p{^Blk=deseret}', "");
    Expect(1, 66640, '\P{Blk=deseret}', "");
    Expect(0, 66640, '\P{^Blk=deseret}', "");
    Expect(1, 66639, '\p{Blk=:\Adeseret\z:}', "");;
    Expect(0, 66640, '\p{Blk=:\Adeseret\z:}', "");;
    Expect(1, 66639, '\p{Blk= Deseret}', "");
    Expect(0, 66639, '\p{^Blk= Deseret}', "");
    Expect(0, 66639, '\P{Blk= Deseret}', "");
    Expect(1, 66639, '\P{^Blk= Deseret}', "");
    Expect(0, 66640, '\p{Blk= Deseret}', "");
    Expect(1, 66640, '\p{^Blk= Deseret}', "");
    Expect(1, 66640, '\P{Blk= Deseret}', "");
    Expect(0, 66640, '\P{^Blk= Deseret}', "");
    Error('\p{Is_Block=	/a/deseret}');
    Error('\P{Is_Block=	/a/deseret}');
    Expect(1, 66639, '\p{Is_Block=deseret}', "");
    Expect(0, 66639, '\p{^Is_Block=deseret}', "");
    Expect(0, 66639, '\P{Is_Block=deseret}', "");
    Expect(1, 66639, '\P{^Is_Block=deseret}', "");
    Expect(0, 66640, '\p{Is_Block=deseret}', "");
    Expect(1, 66640, '\p{^Is_Block=deseret}', "");
    Expect(1, 66640, '\P{Is_Block=deseret}', "");
    Expect(0, 66640, '\P{^Is_Block=deseret}', "");
    Expect(1, 66639, '\p{Is_Block=	 deseret}', "");
    Expect(0, 66639, '\p{^Is_Block=	 deseret}', "");
    Expect(0, 66639, '\P{Is_Block=	 deseret}', "");
    Expect(1, 66639, '\P{^Is_Block=	 deseret}', "");
    Expect(0, 66640, '\p{Is_Block=	 deseret}', "");
    Expect(1, 66640, '\p{^Is_Block=	 deseret}', "");
    Expect(1, 66640, '\P{Is_Block=	 deseret}', "");
    Expect(0, 66640, '\P{^Is_Block=	 deseret}', "");
    Error('\p{Is_Blk=:=-	Deseret}');
    Error('\P{Is_Blk=:=-	Deseret}');
    Expect(1, 66639, '\p{Is_Blk: deseret}', "");
    Expect(0, 66639, '\p{^Is_Blk: deseret}', "");
    Expect(0, 66639, '\P{Is_Blk: deseret}', "");
    Expect(1, 66639, '\P{^Is_Blk: deseret}', "");
    Expect(0, 66640, '\p{Is_Blk: deseret}', "");
    Expect(1, 66640, '\p{^Is_Blk: deseret}', "");
    Expect(1, 66640, '\P{Is_Blk: deseret}', "");
    Expect(0, 66640, '\P{^Is_Blk: deseret}', "");
    Expect(1, 66639, '\p{Is_Blk=_	Deseret}', "");
    Expect(0, 66639, '\p{^Is_Blk=_	Deseret}', "");
    Expect(0, 66639, '\P{Is_Blk=_	Deseret}', "");
    Expect(1, 66639, '\P{^Is_Blk=_	Deseret}', "");
    Expect(0, 66640, '\p{Is_Blk=_	Deseret}', "");
    Expect(1, 66640, '\p{^Is_Blk=_	Deseret}', "");
    Expect(1, 66640, '\P{Is_Blk=_	Deseret}', "");
    Expect(0, 66640, '\P{^Is_Blk=_	Deseret}', "");
    Error('\p{Block= /a/Devanagari}');
    Error('\P{Block= /a/Devanagari}');
    Expect(1, 2431, '\p{Block=:\ADevanagari\z:}', "");;
    Expect(0, 2432, '\p{Block=:\ADevanagari\z:}', "");;
    Expect(1, 2431, '\p{Block:	devanagari}', "");
    Expect(0, 2431, '\p{^Block:	devanagari}', "");
    Expect(0, 2431, '\P{Block:	devanagari}', "");
    Expect(1, 2431, '\P{^Block:	devanagari}', "");
    Expect(0, 2432, '\p{Block:	devanagari}', "");
    Expect(1, 2432, '\p{^Block:	devanagari}', "");
    Expect(1, 2432, '\P{Block:	devanagari}', "");
    Expect(0, 2432, '\P{^Block:	devanagari}', "");
    Expect(1, 2431, '\p{Block=:\Adevanagari\z:}', "");;
    Expect(0, 2432, '\p{Block=:\Adevanagari\z:}', "");;
    Expect(1, 2431, '\p{Block=__Devanagari}', "");
    Expect(0, 2431, '\p{^Block=__Devanagari}', "");
    Expect(0, 2431, '\P{Block=__Devanagari}', "");
    Expect(1, 2431, '\P{^Block=__Devanagari}', "");
    Expect(0, 2432, '\p{Block=__Devanagari}', "");
    Expect(1, 2432, '\p{^Block=__Devanagari}', "");
    Expect(1, 2432, '\P{Block=__Devanagari}', "");
    Expect(0, 2432, '\P{^Block=__Devanagari}', "");
    Error('\p{Blk=:=Devanagari}');
    Error('\P{Blk=:=Devanagari}');
    Expect(1, 2431, '\p{Blk=:\ADevanagari\z:}', "");;
    Expect(0, 2432, '\p{Blk=:\ADevanagari\z:}', "");;
    Expect(1, 2431, '\p{Blk=devanagari}', "");
    Expect(0, 2431, '\p{^Blk=devanagari}', "");
    Expect(0, 2431, '\P{Blk=devanagari}', "");
    Expect(1, 2431, '\P{^Blk=devanagari}', "");
    Expect(0, 2432, '\p{Blk=devanagari}', "");
    Expect(1, 2432, '\p{^Blk=devanagari}', "");
    Expect(1, 2432, '\P{Blk=devanagari}', "");
    Expect(0, 2432, '\P{^Blk=devanagari}', "");
    Expect(1, 2431, '\p{Blk=:\Adevanagari\z:}', "");;
    Expect(0, 2432, '\p{Blk=:\Adevanagari\z:}', "");;
    Expect(1, 2431, '\p{Blk= -Devanagari}', "");
    Expect(0, 2431, '\p{^Blk= -Devanagari}', "");
    Expect(0, 2431, '\P{Blk= -Devanagari}', "");
    Expect(1, 2431, '\P{^Blk= -Devanagari}', "");
    Expect(0, 2432, '\p{Blk= -Devanagari}', "");
    Expect(1, 2432, '\p{^Blk= -Devanagari}', "");
    Expect(1, 2432, '\P{Blk= -Devanagari}', "");
    Expect(0, 2432, '\P{^Blk= -Devanagari}', "");
    Error('\p{Is_Block=/a/ _Devanagari}');
    Error('\P{Is_Block=/a/ _Devanagari}');
    Expect(1, 2431, '\p{Is_Block=devanagari}', "");
    Expect(0, 2431, '\p{^Is_Block=devanagari}', "");
    Expect(0, 2431, '\P{Is_Block=devanagari}', "");
    Expect(1, 2431, '\P{^Is_Block=devanagari}', "");
    Expect(0, 2432, '\p{Is_Block=devanagari}', "");
    Expect(1, 2432, '\p{^Is_Block=devanagari}', "");
    Expect(1, 2432, '\P{Is_Block=devanagari}', "");
    Expect(0, 2432, '\P{^Is_Block=devanagari}', "");
    Expect(1, 2431, '\p{Is_Block=-_Devanagari}', "");
    Expect(0, 2431, '\p{^Is_Block=-_Devanagari}', "");
    Expect(0, 2431, '\P{Is_Block=-_Devanagari}', "");
    Expect(1, 2431, '\P{^Is_Block=-_Devanagari}', "");
    Expect(0, 2432, '\p{Is_Block=-_Devanagari}', "");
    Expect(1, 2432, '\p{^Is_Block=-_Devanagari}', "");
    Expect(1, 2432, '\P{Is_Block=-_Devanagari}', "");
    Expect(0, 2432, '\P{^Is_Block=-_Devanagari}', "");
    Error('\p{Is_Blk:   _Devanagari:=}');
    Error('\P{Is_Blk:   _Devanagari:=}');
    Expect(1, 2431, '\p{Is_Blk=devanagari}', "");
    Expect(0, 2431, '\p{^Is_Blk=devanagari}', "");
    Expect(0, 2431, '\P{Is_Blk=devanagari}', "");
    Expect(1, 2431, '\P{^Is_Blk=devanagari}', "");
    Expect(0, 2432, '\p{Is_Blk=devanagari}', "");
    Expect(1, 2432, '\p{^Is_Blk=devanagari}', "");
    Expect(1, 2432, '\P{Is_Blk=devanagari}', "");
    Expect(0, 2432, '\P{^Is_Blk=devanagari}', "");
    Expect(1, 2431, '\p{Is_Blk=  Devanagari}', "");
    Expect(0, 2431, '\p{^Is_Blk=  Devanagari}', "");
    Expect(0, 2431, '\P{Is_Blk=  Devanagari}', "");
    Expect(1, 2431, '\P{^Is_Blk=  Devanagari}', "");
    Expect(0, 2432, '\p{Is_Blk=  Devanagari}', "");
    Expect(1, 2432, '\p{^Is_Blk=  Devanagari}', "");
    Expect(1, 2432, '\P{Is_Blk=  Devanagari}', "");
    Expect(0, 2432, '\P{^Is_Blk=  Devanagari}', "");
    Error('\p{Block=:=_	devanagari_Extended}');
    Error('\P{Block=:=_	devanagari_Extended}');
    Expect(1, 43263, '\p{Block=:\ADevanagari_Extended\z:}', "");;
    Expect(0, 43264, '\p{Block=:\ADevanagari_Extended\z:}', "");;
    Expect(1, 43263, '\p{Block=devanagariextended}', "");
    Expect(0, 43263, '\p{^Block=devanagariextended}', "");
    Expect(0, 43263, '\P{Block=devanagariextended}', "");
    Expect(1, 43263, '\P{^Block=devanagariextended}', "");
    Expect(0, 43264, '\p{Block=devanagariextended}', "");
    Expect(1, 43264, '\p{^Block=devanagariextended}', "");
    Expect(1, 43264, '\P{Block=devanagariextended}', "");
    Expect(0, 43264, '\P{^Block=devanagariextended}', "");
    Expect(1, 43263, '\p{Block=:\Adevanagariextended\z:}', "");;
    Expect(0, 43264, '\p{Block=:\Adevanagariextended\z:}', "");;
    Expect(1, 43263, '\p{Block=		devanagari_EXTENDED}', "");
    Expect(0, 43263, '\p{^Block=		devanagari_EXTENDED}', "");
    Expect(0, 43263, '\P{Block=		devanagari_EXTENDED}', "");
    Expect(1, 43263, '\P{^Block=		devanagari_EXTENDED}', "");
    Expect(0, 43264, '\p{Block=		devanagari_EXTENDED}', "");
    Expect(1, 43264, '\p{^Block=		devanagari_EXTENDED}', "");
    Expect(1, 43264, '\P{Block=		devanagari_EXTENDED}', "");
    Expect(0, 43264, '\P{^Block=		devanagari_EXTENDED}', "");
    Error('\p{Blk: -:=DEVANAGARI_Ext}');
    Error('\P{Blk: -:=DEVANAGARI_Ext}');
    Expect(1, 43263, '\p{Blk=:\ADevanagari_Ext\z:}', "");;
    Expect(0, 43264, '\p{Blk=:\ADevanagari_Ext\z:}', "");;
    Expect(1, 43263, '\p{Blk=devanagariext}', "");
    Expect(0, 43263, '\p{^Blk=devanagariext}', "");
    Expect(0, 43263, '\P{Blk=devanagariext}', "");
    Expect(1, 43263, '\P{^Blk=devanagariext}', "");
    Expect(0, 43264, '\p{Blk=devanagariext}', "");
    Expect(1, 43264, '\p{^Blk=devanagariext}', "");
    Expect(1, 43264, '\P{Blk=devanagariext}', "");
    Expect(0, 43264, '\P{^Blk=devanagariext}', "");
    Expect(1, 43263, '\p{Blk=:\Adevanagariext\z:}', "");;
    Expect(0, 43264, '\p{Blk=:\Adevanagariext\z:}', "");;
    Expect(1, 43263, '\p{Blk=  Devanagari_Ext}', "");
    Expect(0, 43263, '\p{^Blk=  Devanagari_Ext}', "");
    Expect(0, 43263, '\P{Blk=  Devanagari_Ext}', "");
    Expect(1, 43263, '\P{^Blk=  Devanagari_Ext}', "");
    Expect(0, 43264, '\p{Blk=  Devanagari_Ext}', "");
    Expect(1, 43264, '\p{^Blk=  Devanagari_Ext}', "");
    Expect(1, 43264, '\P{Blk=  Devanagari_Ext}', "");
    Expect(0, 43264, '\P{^Blk=  Devanagari_Ext}', "");
    Error('\p{Is_Block:_/a/Devanagari_extended}');
    Error('\P{Is_Block:_/a/Devanagari_extended}');
    Expect(1, 43263, '\p{Is_Block=devanagariextended}', "");
    Expect(0, 43263, '\p{^Is_Block=devanagariextended}', "");
    Expect(0, 43263, '\P{Is_Block=devanagariextended}', "");
    Expect(1, 43263, '\P{^Is_Block=devanagariextended}', "");
    Expect(0, 43264, '\p{Is_Block=devanagariextended}', "");
    Expect(1, 43264, '\p{^Is_Block=devanagariextended}', "");
    Expect(1, 43264, '\P{Is_Block=devanagariextended}', "");
    Expect(0, 43264, '\P{^Is_Block=devanagariextended}', "");
    Expect(1, 43263, '\p{Is_Block=_ Devanagari_Extended}', "");
    Expect(0, 43263, '\p{^Is_Block=_ Devanagari_Extended}', "");
    Expect(0, 43263, '\P{Is_Block=_ Devanagari_Extended}', "");
    Expect(1, 43263, '\P{^Is_Block=_ Devanagari_Extended}', "");
    Expect(0, 43264, '\p{Is_Block=_ Devanagari_Extended}', "");
    Expect(1, 43264, '\p{^Is_Block=_ Devanagari_Extended}', "");
    Expect(1, 43264, '\P{Is_Block=_ Devanagari_Extended}', "");
    Expect(0, 43264, '\P{^Is_Block=_ Devanagari_Extended}', "");
    Error('\p{Is_Blk=-:=devanagari_Ext}');
    Error('\P{Is_Blk=-:=devanagari_Ext}');
    Expect(1, 43263, '\p{Is_Blk=devanagariext}', "");
    Expect(0, 43263, '\p{^Is_Blk=devanagariext}', "");
    Expect(0, 43263, '\P{Is_Blk=devanagariext}', "");
    Expect(1, 43263, '\P{^Is_Blk=devanagariext}', "");
    Expect(0, 43264, '\p{Is_Blk=devanagariext}', "");
    Expect(1, 43264, '\p{^Is_Blk=devanagariext}', "");
    Expect(1, 43264, '\P{Is_Blk=devanagariext}', "");
    Expect(0, 43264, '\P{^Is_Blk=devanagariext}', "");
    Expect(1, 43263, '\p{Is_Blk= 	Devanagari_Ext}', "");
    Expect(0, 43263, '\p{^Is_Blk= 	Devanagari_Ext}', "");
    Expect(0, 43263, '\P{Is_Blk= 	Devanagari_Ext}', "");
    Expect(1, 43263, '\P{^Is_Blk= 	Devanagari_Ext}', "");
    Expect(0, 43264, '\p{Is_Blk= 	Devanagari_Ext}', "");
    Expect(1, 43264, '\p{^Is_Blk= 	Devanagari_Ext}', "");
    Expect(1, 43264, '\P{Is_Blk= 	Devanagari_Ext}', "");
    Expect(0, 43264, '\P{^Is_Blk= 	Devanagari_Ext}', "");
    Error('\p{Block=combining_diacritical_MARKS/a/}');
    Error('\P{Block=combining_diacritical_MARKS/a/}');
    Expect(1, 879, '\p{Block=:\ACombining_Diacritical_Marks\z:}', "");;
    Expect(0, 880, '\p{Block=:\ACombining_Diacritical_Marks\z:}', "");;
    Expect(1, 879, '\p{Block=combiningdiacriticalmarks}', "");
    Expect(0, 879, '\p{^Block=combiningdiacriticalmarks}', "");
    Expect(0, 879, '\P{Block=combiningdiacriticalmarks}', "");
    Expect(1, 879, '\P{^Block=combiningdiacriticalmarks}', "");
    Expect(0, 880, '\p{Block=combiningdiacriticalmarks}', "");
    Expect(1, 880, '\p{^Block=combiningdiacriticalmarks}', "");
    Expect(1, 880, '\P{Block=combiningdiacriticalmarks}', "");
    Expect(0, 880, '\P{^Block=combiningdiacriticalmarks}', "");
    Expect(1, 879, '\p{Block=:\Acombiningdiacriticalmarks\z:}', "");;
    Expect(0, 880, '\p{Block=:\Acombiningdiacriticalmarks\z:}', "");;
    Expect(1, 879, '\p{Block=	_COMBINING_diacritical_marks}', "");
    Expect(0, 879, '\p{^Block=	_COMBINING_diacritical_marks}', "");
    Expect(0, 879, '\P{Block=	_COMBINING_diacritical_marks}', "");
    Expect(1, 879, '\P{^Block=	_COMBINING_diacritical_marks}', "");
    Expect(0, 880, '\p{Block=	_COMBINING_diacritical_marks}', "");
    Expect(1, 880, '\p{^Block=	_COMBINING_diacritical_marks}', "");
    Expect(1, 880, '\P{Block=	_COMBINING_diacritical_marks}', "");
    Expect(0, 880, '\P{^Block=	_COMBINING_diacritical_marks}', "");
    Error('\p{Blk=	 Diacriticals/a/}');
    Error('\P{Blk=	 Diacriticals/a/}');
    Expect(1, 879, '\p{Blk=:\ADiacriticals\z:}', "");;
    Expect(0, 880, '\p{Blk=:\ADiacriticals\z:}', "");;
    Expect(1, 879, '\p{Blk:	diacriticals}', "");
    Expect(0, 879, '\p{^Blk:	diacriticals}', "");
    Expect(0, 879, '\P{Blk:	diacriticals}', "");
    Expect(1, 879, '\P{^Blk:	diacriticals}', "");
    Expect(0, 880, '\p{Blk:	diacriticals}', "");
    Expect(1, 880, '\p{^Blk:	diacriticals}', "");
    Expect(1, 880, '\P{Blk:	diacriticals}', "");
    Expect(0, 880, '\P{^Blk:	diacriticals}', "");
    Expect(1, 879, '\p{Blk=:\Adiacriticals\z:}', "");;
    Expect(0, 880, '\p{Blk=:\Adiacriticals\z:}', "");;
    Expect(1, 879, '\p{Blk=	-diacriticals}', "");
    Expect(0, 879, '\p{^Blk=	-diacriticals}', "");
    Expect(0, 879, '\P{Blk=	-diacriticals}', "");
    Expect(1, 879, '\P{^Blk=	-diacriticals}', "");
    Expect(0, 880, '\p{Blk=	-diacriticals}', "");
    Expect(1, 880, '\p{^Blk=	-diacriticals}', "");
    Expect(1, 880, '\P{Blk=	-diacriticals}', "");
    Expect(0, 880, '\P{^Blk=	-diacriticals}', "");
    Error('\p{Is_Block=- Combining_diacritical_Marks:=}');
    Error('\P{Is_Block=- Combining_diacritical_Marks:=}');
    Expect(1, 879, '\p{Is_Block=combiningdiacriticalmarks}', "");
    Expect(0, 879, '\p{^Is_Block=combiningdiacriticalmarks}', "");
    Expect(0, 879, '\P{Is_Block=combiningdiacriticalmarks}', "");
    Expect(1, 879, '\P{^Is_Block=combiningdiacriticalmarks}', "");
    Expect(0, 880, '\p{Is_Block=combiningdiacriticalmarks}', "");
    Expect(1, 880, '\p{^Is_Block=combiningdiacriticalmarks}', "");
    Expect(1, 880, '\P{Is_Block=combiningdiacriticalmarks}', "");
    Expect(0, 880, '\P{^Is_Block=combiningdiacriticalmarks}', "");
    Expect(1, 879, '\p{Is_Block=	Combining_Diacritical_Marks}', "");
    Expect(0, 879, '\p{^Is_Block=	Combining_Diacritical_Marks}', "");
    Expect(0, 879, '\P{Is_Block=	Combining_Diacritical_Marks}', "");
    Expect(1, 879, '\P{^Is_Block=	Combining_Diacritical_Marks}', "");
    Expect(0, 880, '\p{Is_Block=	Combining_Diacritical_Marks}', "");
    Expect(1, 880, '\p{^Is_Block=	Combining_Diacritical_Marks}', "");
    Expect(1, 880, '\P{Is_Block=	Combining_Diacritical_Marks}', "");
    Expect(0, 880, '\P{^Is_Block=	Combining_Diacritical_Marks}', "");
    Error('\p{Is_Blk=- DIACRITICALS:=}');
    Error('\P{Is_Blk=- DIACRITICALS:=}');
    Expect(1, 879, '\p{Is_Blk=diacriticals}', "");
    Expect(0, 879, '\p{^Is_Blk=diacriticals}', "");
    Expect(0, 879, '\P{Is_Blk=diacriticals}', "");
    Expect(1, 879, '\P{^Is_Blk=diacriticals}', "");
    Expect(0, 880, '\p{Is_Blk=diacriticals}', "");
    Expect(1, 880, '\p{^Is_Blk=diacriticals}', "");
    Expect(1, 880, '\P{Is_Blk=diacriticals}', "");
    Expect(0, 880, '\P{^Is_Blk=diacriticals}', "");
    Expect(1, 879, '\p{Is_Blk=Diacriticals}', "");
    Expect(0, 879, '\p{^Is_Blk=Diacriticals}', "");
    Expect(0, 879, '\P{Is_Blk=Diacriticals}', "");
    Expect(1, 879, '\P{^Is_Blk=Diacriticals}', "");
    Expect(0, 880, '\p{Is_Blk=Diacriticals}', "");
    Expect(1, 880, '\p{^Is_Blk=Diacriticals}', "");
    Expect(1, 880, '\P{Is_Blk=Diacriticals}', "");
    Expect(0, 880, '\P{^Is_Blk=Diacriticals}', "");
    Error('\p{Block=:= 	Combining_diacritical_Marks_EXTENDED}');
    Error('\P{Block=:= 	Combining_diacritical_Marks_EXTENDED}');
    Expect(1, 6911, '\p{Block=:\ACombining_Diacritical_Marks_Extended\z:}', "");;
    Expect(0, 6912, '\p{Block=:\ACombining_Diacritical_Marks_Extended\z:}', "");;
    Expect(1, 6911, '\p{Block=combiningdiacriticalmarksextended}', "");
    Expect(0, 6911, '\p{^Block=combiningdiacriticalmarksextended}', "");
    Expect(0, 6911, '\P{Block=combiningdiacriticalmarksextended}', "");
    Expect(1, 6911, '\P{^Block=combiningdiacriticalmarksextended}', "");
    Expect(0, 6912, '\p{Block=combiningdiacriticalmarksextended}', "");
    Expect(1, 6912, '\p{^Block=combiningdiacriticalmarksextended}', "");
    Expect(1, 6912, '\P{Block=combiningdiacriticalmarksextended}', "");
    Expect(0, 6912, '\P{^Block=combiningdiacriticalmarksextended}', "");
    Expect(1, 6911, '\p{Block=:\Acombiningdiacriticalmarksextended\z:}', "");;
    Expect(0, 6912, '\p{Block=:\Acombiningdiacriticalmarksextended\z:}', "");;
    Expect(1, 6911, '\p{Block= 	COMBINING_Diacritical_marks_Extended}', "");
    Expect(0, 6911, '\p{^Block= 	COMBINING_Diacritical_marks_Extended}', "");
    Expect(0, 6911, '\P{Block= 	COMBINING_Diacritical_marks_Extended}', "");
    Expect(1, 6911, '\P{^Block= 	COMBINING_Diacritical_marks_Extended}', "");
    Expect(0, 6912, '\p{Block= 	COMBINING_Diacritical_marks_Extended}', "");
    Expect(1, 6912, '\p{^Block= 	COMBINING_Diacritical_marks_Extended}', "");
    Expect(1, 6912, '\P{Block= 	COMBINING_Diacritical_marks_Extended}', "");
    Expect(0, 6912, '\P{^Block= 	COMBINING_Diacritical_marks_Extended}', "");
    Error('\p{Blk=/a/_-DIACRITICALS_ext}');
    Error('\P{Blk=/a/_-DIACRITICALS_ext}');
    Expect(1, 6911, '\p{Blk=:\ADiacriticals_Ext\z:}', "");;
    Expect(0, 6912, '\p{Blk=:\ADiacriticals_Ext\z:}', "");;
    Expect(1, 6911, '\p{Blk=diacriticalsext}', "");
    Expect(0, 6911, '\p{^Blk=diacriticalsext}', "");
    Expect(0, 6911, '\P{Blk=diacriticalsext}', "");
    Expect(1, 6911, '\P{^Blk=diacriticalsext}', "");
    Expect(0, 6912, '\p{Blk=diacriticalsext}', "");
    Expect(1, 6912, '\p{^Blk=diacriticalsext}', "");
    Expect(1, 6912, '\P{Blk=diacriticalsext}', "");
    Expect(0, 6912, '\P{^Blk=diacriticalsext}', "");
    Expect(1, 6911, '\p{Blk=:\Adiacriticalsext\z:}', "");;
    Expect(0, 6912, '\p{Blk=:\Adiacriticalsext\z:}', "");;
    Expect(1, 6911, '\p{Blk=  diacriticals_ext}', "");
    Expect(0, 6911, '\p{^Blk=  diacriticals_ext}', "");
    Expect(0, 6911, '\P{Blk=  diacriticals_ext}', "");
    Expect(1, 6911, '\P{^Blk=  diacriticals_ext}', "");
    Expect(0, 6912, '\p{Blk=  diacriticals_ext}', "");
    Expect(1, 6912, '\p{^Blk=  diacriticals_ext}', "");
    Expect(1, 6912, '\P{Blk=  diacriticals_ext}', "");
    Expect(0, 6912, '\P{^Blk=  diacriticals_ext}', "");
    Error('\p{Is_Block=:=	COMBINING_DIACRITICAL_Marks_EXTENDED}');
    Error('\P{Is_Block=:=	COMBINING_DIACRITICAL_Marks_EXTENDED}');
    Expect(1, 6911, '\p{Is_Block=combiningdiacriticalmarksextended}', "");
    Expect(0, 6911, '\p{^Is_Block=combiningdiacriticalmarksextended}', "");
    Expect(0, 6911, '\P{Is_Block=combiningdiacriticalmarksextended}', "");
    Expect(1, 6911, '\P{^Is_Block=combiningdiacriticalmarksextended}', "");
    Expect(0, 6912, '\p{Is_Block=combiningdiacriticalmarksextended}', "");
    Expect(1, 6912, '\p{^Is_Block=combiningdiacriticalmarksextended}', "");
    Expect(1, 6912, '\P{Is_Block=combiningdiacriticalmarksextended}', "");
    Expect(0, 6912, '\P{^Is_Block=combiningdiacriticalmarksextended}', "");
    Expect(1, 6911, '\p{Is_Block=-combining_Diacritical_Marks_Extended}', "");
    Expect(0, 6911, '\p{^Is_Block=-combining_Diacritical_Marks_Extended}', "");
    Expect(0, 6911, '\P{Is_Block=-combining_Diacritical_Marks_Extended}', "");
    Expect(1, 6911, '\P{^Is_Block=-combining_Diacritical_Marks_Extended}', "");
    Expect(0, 6912, '\p{Is_Block=-combining_Diacritical_Marks_Extended}', "");
    Expect(1, 6912, '\p{^Is_Block=-combining_Diacritical_Marks_Extended}', "");
    Expect(1, 6912, '\P{Is_Block=-combining_Diacritical_Marks_Extended}', "");
    Expect(0, 6912, '\P{^Is_Block=-combining_Diacritical_Marks_Extended}', "");
    Error('\p{Is_Blk=:=-DIACRITICALS_ext}');
    Error('\P{Is_Blk=:=-DIACRITICALS_ext}');
    Expect(1, 6911, '\p{Is_Blk=diacriticalsext}', "");
    Expect(0, 6911, '\p{^Is_Blk=diacriticalsext}', "");
    Expect(0, 6911, '\P{Is_Blk=diacriticalsext}', "");
    Expect(1, 6911, '\P{^Is_Blk=diacriticalsext}', "");
    Expect(0, 6912, '\p{Is_Blk=diacriticalsext}', "");
    Expect(1, 6912, '\p{^Is_Blk=diacriticalsext}', "");
    Expect(1, 6912, '\P{Is_Blk=diacriticalsext}', "");
    Expect(0, 6912, '\P{^Is_Blk=diacriticalsext}', "");
    Expect(1, 6911, '\p{Is_Blk:_ DIACRITICALS_EXT}', "");
    Expect(0, 6911, '\p{^Is_Blk:_ DIACRITICALS_EXT}', "");
    Expect(0, 6911, '\P{Is_Blk:_ DIACRITICALS_EXT}', "");
    Expect(1, 6911, '\P{^Is_Blk:_ DIACRITICALS_EXT}', "");
    Expect(0, 6912, '\p{Is_Blk:_ DIACRITICALS_EXT}', "");
    Expect(1, 6912, '\p{^Is_Blk:_ DIACRITICALS_EXT}', "");
    Expect(1, 6912, '\P{Is_Blk:_ DIACRITICALS_EXT}', "");
    Expect(0, 6912, '\P{^Is_Blk:_ DIACRITICALS_EXT}', "");
    Error('\p{Block=	COMBINING_Diacritical_Marks_For_SYMBOLS/a/}');
    Error('\P{Block=	COMBINING_Diacritical_Marks_For_SYMBOLS/a/}');
    Expect(1, 8447, '\p{Block=:\ACombining_Diacritical_Marks_For_Symbols\z:}', "");;
    Expect(0, 8448, '\p{Block=:\ACombining_Diacritical_Marks_For_Symbols\z:}', "");;
    Expect(1, 8447, '\p{Block:combiningdiacriticalmarksforsymbols}', "");
    Expect(0, 8447, '\p{^Block:combiningdiacriticalmarksforsymbols}', "");
    Expect(0, 8447, '\P{Block:combiningdiacriticalmarksforsymbols}', "");
    Expect(1, 8447, '\P{^Block:combiningdiacriticalmarksforsymbols}', "");
    Expect(0, 8448, '\p{Block:combiningdiacriticalmarksforsymbols}', "");
    Expect(1, 8448, '\p{^Block:combiningdiacriticalmarksforsymbols}', "");
    Expect(1, 8448, '\P{Block:combiningdiacriticalmarksforsymbols}', "");
    Expect(0, 8448, '\P{^Block:combiningdiacriticalmarksforsymbols}', "");
    Expect(1, 8447, '\p{Block=:\Acombiningdiacriticalmarksforsymbols\z:}', "");;
    Expect(0, 8448, '\p{Block=:\Acombiningdiacriticalmarksforsymbols\z:}', "");;
    Expect(1, 8447, '\p{Block=  COMBINING_DIACRITICAL_MARKS_For_SYMBOLS}', "");
    Expect(0, 8447, '\p{^Block=  COMBINING_DIACRITICAL_MARKS_For_SYMBOLS}', "");
    Expect(0, 8447, '\P{Block=  COMBINING_DIACRITICAL_MARKS_For_SYMBOLS}', "");
    Expect(1, 8447, '\P{^Block=  COMBINING_DIACRITICAL_MARKS_For_SYMBOLS}', "");
    Expect(0, 8448, '\p{Block=  COMBINING_DIACRITICAL_MARKS_For_SYMBOLS}', "");
    Expect(1, 8448, '\p{^Block=  COMBINING_DIACRITICAL_MARKS_For_SYMBOLS}', "");
    Expect(1, 8448, '\P{Block=  COMBINING_DIACRITICAL_MARKS_For_SYMBOLS}', "");
    Expect(0, 8448, '\P{^Block=  COMBINING_DIACRITICAL_MARKS_For_SYMBOLS}', "");
    Error('\p{Blk: -DIACRITICALS_FOR_Symbols:=}');
    Error('\P{Blk: -DIACRITICALS_FOR_Symbols:=}');
    Expect(1, 8447, '\p{Blk=:\ADiacriticals_For_Symbols\z:}', "");;
    Expect(0, 8448, '\p{Blk=:\ADiacriticals_For_Symbols\z:}', "");;
    Expect(1, 8447, '\p{Blk=diacriticalsforsymbols}', "");
    Expect(0, 8447, '\p{^Blk=diacriticalsforsymbols}', "");
    Expect(0, 8447, '\P{Blk=diacriticalsforsymbols}', "");
    Expect(1, 8447, '\P{^Blk=diacriticalsforsymbols}', "");
    Expect(0, 8448, '\p{Blk=diacriticalsforsymbols}', "");
    Expect(1, 8448, '\p{^Blk=diacriticalsforsymbols}', "");
    Expect(1, 8448, '\P{Blk=diacriticalsforsymbols}', "");
    Expect(0, 8448, '\P{^Blk=diacriticalsforsymbols}', "");
    Expect(1, 8447, '\p{Blk=:\Adiacriticalsforsymbols\z:}', "");;
    Expect(0, 8448, '\p{Blk=:\Adiacriticalsforsymbols\z:}', "");;
    Expect(1, 8447, '\p{Blk=__Diacriticals_for_Symbols}', "");
    Expect(0, 8447, '\p{^Blk=__Diacriticals_for_Symbols}', "");
    Expect(0, 8447, '\P{Blk=__Diacriticals_for_Symbols}', "");
    Expect(1, 8447, '\P{^Blk=__Diacriticals_for_Symbols}', "");
    Expect(0, 8448, '\p{Blk=__Diacriticals_for_Symbols}', "");
    Expect(1, 8448, '\p{^Blk=__Diacriticals_for_Symbols}', "");
    Expect(1, 8448, '\P{Blk=__Diacriticals_for_Symbols}', "");
    Expect(0, 8448, '\P{^Blk=__Diacriticals_for_Symbols}', "");
    Error('\p{Is_Block=:= combining_Marks_For_SYMBOLS}');
    Error('\P{Is_Block=:= combining_Marks_For_SYMBOLS}');
    Expect(1, 8447, '\p{Is_Block=combiningmarksforsymbols}', "");
    Expect(0, 8447, '\p{^Is_Block=combiningmarksforsymbols}', "");
    Expect(0, 8447, '\P{Is_Block=combiningmarksforsymbols}', "");
    Expect(1, 8447, '\P{^Is_Block=combiningmarksforsymbols}', "");
    Expect(0, 8448, '\p{Is_Block=combiningmarksforsymbols}', "");
    Expect(1, 8448, '\p{^Is_Block=combiningmarksforsymbols}', "");
    Expect(1, 8448, '\P{Is_Block=combiningmarksforsymbols}', "");
    Expect(0, 8448, '\P{^Is_Block=combiningmarksforsymbols}', "");
    Expect(1, 8447, '\p{Is_Block=-	COMBINING_MARKS_For_symbols}', "");
    Expect(0, 8447, '\p{^Is_Block=-	COMBINING_MARKS_For_symbols}', "");
    Expect(0, 8447, '\P{Is_Block=-	COMBINING_MARKS_For_symbols}', "");
    Expect(1, 8447, '\P{^Is_Block=-	COMBINING_MARKS_For_symbols}', "");
    Expect(0, 8448, '\p{Is_Block=-	COMBINING_MARKS_For_symbols}', "");
    Expect(1, 8448, '\p{^Is_Block=-	COMBINING_MARKS_For_symbols}', "");
    Expect(1, 8448, '\P{Is_Block=-	COMBINING_MARKS_For_symbols}', "");
    Expect(0, 8448, '\P{^Is_Block=-	COMBINING_MARKS_For_symbols}', "");
    Error('\p{Is_Blk=:= _Combining_Diacritical_Marks_FOR_symbols}');
    Error('\P{Is_Blk=:= _Combining_Diacritical_Marks_FOR_symbols}');
    Expect(1, 8447, '\p{Is_Blk=combiningdiacriticalmarksforsymbols}', "");
    Expect(0, 8447, '\p{^Is_Blk=combiningdiacriticalmarksforsymbols}', "");
    Expect(0, 8447, '\P{Is_Blk=combiningdiacriticalmarksforsymbols}', "");
    Expect(1, 8447, '\P{^Is_Blk=combiningdiacriticalmarksforsymbols}', "");
    Expect(0, 8448, '\p{Is_Blk=combiningdiacriticalmarksforsymbols}', "");
    Expect(1, 8448, '\p{^Is_Blk=combiningdiacriticalmarksforsymbols}', "");
    Expect(1, 8448, '\P{Is_Blk=combiningdiacriticalmarksforsymbols}', "");
    Expect(0, 8448, '\P{^Is_Blk=combiningdiacriticalmarksforsymbols}', "");
    Expect(1, 8447, '\p{Is_Blk=	 Combining_Diacritical_Marks_for_Symbols}', "");
    Expect(0, 8447, '\p{^Is_Blk=	 Combining_Diacritical_Marks_for_Symbols}', "");
    Expect(0, 8447, '\P{Is_Blk=	 Combining_Diacritical_Marks_for_Symbols}', "");
    Expect(1, 8447, '\P{^Is_Blk=	 Combining_Diacritical_Marks_for_Symbols}', "");
    Expect(0, 8448, '\p{Is_Blk=	 Combining_Diacritical_Marks_for_Symbols}', "");
    Expect(1, 8448, '\p{^Is_Blk=	 Combining_Diacritical_Marks_for_Symbols}', "");
    Expect(1, 8448, '\P{Is_Blk=	 Combining_Diacritical_Marks_for_Symbols}', "");
    Expect(0, 8448, '\P{^Is_Blk=	 Combining_Diacritical_Marks_for_Symbols}', "");
    Error('\p{Block:		:=COMBINING_diacritical_marks_Supplement}');
    Error('\P{Block:		:=COMBINING_diacritical_marks_Supplement}');
    Expect(1, 7679, '\p{Block=:\ACombining_Diacritical_Marks_Supplement\z:}', "");;
    Expect(0, 7680, '\p{Block=:\ACombining_Diacritical_Marks_Supplement\z:}', "");;
    Expect(1, 7679, '\p{Block=combiningdiacriticalmarkssupplement}', "");
    Expect(0, 7679, '\p{^Block=combiningdiacriticalmarkssupplement}', "");
    Expect(0, 7679, '\P{Block=combiningdiacriticalmarkssupplement}', "");
    Expect(1, 7679, '\P{^Block=combiningdiacriticalmarkssupplement}', "");
    Expect(0, 7680, '\p{Block=combiningdiacriticalmarkssupplement}', "");
    Expect(1, 7680, '\p{^Block=combiningdiacriticalmarkssupplement}', "");
    Expect(1, 7680, '\P{Block=combiningdiacriticalmarkssupplement}', "");
    Expect(0, 7680, '\P{^Block=combiningdiacriticalmarkssupplement}', "");
    Expect(1, 7679, '\p{Block=:\Acombiningdiacriticalmarkssupplement\z:}', "");;
    Expect(0, 7680, '\p{Block=:\Acombiningdiacriticalmarkssupplement\z:}', "");;
    Expect(1, 7679, '\p{Block:   COMBINING_Diacritical_Marks_SUPPLEMENT}', "");
    Expect(0, 7679, '\p{^Block:   COMBINING_Diacritical_Marks_SUPPLEMENT}', "");
    Expect(0, 7679, '\P{Block:   COMBINING_Diacritical_Marks_SUPPLEMENT}', "");
    Expect(1, 7679, '\P{^Block:   COMBINING_Diacritical_Marks_SUPPLEMENT}', "");
    Expect(0, 7680, '\p{Block:   COMBINING_Diacritical_Marks_SUPPLEMENT}', "");
    Expect(1, 7680, '\p{^Block:   COMBINING_Diacritical_Marks_SUPPLEMENT}', "");
    Expect(1, 7680, '\P{Block:   COMBINING_Diacritical_Marks_SUPPLEMENT}', "");
    Expect(0, 7680, '\P{^Block:   COMBINING_Diacritical_Marks_SUPPLEMENT}', "");
    Error('\p{Blk=_DIACRITICALS_Sup:=}');
    Error('\P{Blk=_DIACRITICALS_Sup:=}');
    Expect(1, 7679, '\p{Blk=:\ADiacriticals_Sup\z:}', "");;
    Expect(0, 7680, '\p{Blk=:\ADiacriticals_Sup\z:}', "");;
    Expect(1, 7679, '\p{Blk=diacriticalssup}', "");
    Expect(0, 7679, '\p{^Blk=diacriticalssup}', "");
    Expect(0, 7679, '\P{Blk=diacriticalssup}', "");
    Expect(1, 7679, '\P{^Blk=diacriticalssup}', "");
    Expect(0, 7680, '\p{Blk=diacriticalssup}', "");
    Expect(1, 7680, '\p{^Blk=diacriticalssup}', "");
    Expect(1, 7680, '\P{Blk=diacriticalssup}', "");
    Expect(0, 7680, '\P{^Blk=diacriticalssup}', "");
    Expect(1, 7679, '\p{Blk=:\Adiacriticalssup\z:}', "");;
    Expect(0, 7680, '\p{Blk=:\Adiacriticalssup\z:}', "");;
    Expect(1, 7679, '\p{Blk=	-Diacriticals_Sup}', "");
    Expect(0, 7679, '\p{^Blk=	-Diacriticals_Sup}', "");
    Expect(0, 7679, '\P{Blk=	-Diacriticals_Sup}', "");
    Expect(1, 7679, '\P{^Blk=	-Diacriticals_Sup}', "");
    Expect(0, 7680, '\p{Blk=	-Diacriticals_Sup}', "");
    Expect(1, 7680, '\p{^Blk=	-Diacriticals_Sup}', "");
    Expect(1, 7680, '\P{Blk=	-Diacriticals_Sup}', "");
    Expect(0, 7680, '\P{^Blk=	-Diacriticals_Sup}', "");
    Error('\p{Is_Block=-_COMBINING_diacritical_marks_Supplement:=}');
    Error('\P{Is_Block=-_COMBINING_diacritical_marks_Supplement:=}');
    Expect(1, 7679, '\p{Is_Block=combiningdiacriticalmarkssupplement}', "");
    Expect(0, 7679, '\p{^Is_Block=combiningdiacriticalmarkssupplement}', "");
    Expect(0, 7679, '\P{Is_Block=combiningdiacriticalmarkssupplement}', "");
    Expect(1, 7679, '\P{^Is_Block=combiningdiacriticalmarkssupplement}', "");
    Expect(0, 7680, '\p{Is_Block=combiningdiacriticalmarkssupplement}', "");
    Expect(1, 7680, '\p{^Is_Block=combiningdiacriticalmarkssupplement}', "");
    Expect(1, 7680, '\P{Is_Block=combiningdiacriticalmarkssupplement}', "");
    Expect(0, 7680, '\P{^Is_Block=combiningdiacriticalmarkssupplement}', "");
    Expect(1, 7679, '\p{Is_Block=	Combining_diacritical_Marks_Supplement}', "");
    Expect(0, 7679, '\p{^Is_Block=	Combining_diacritical_Marks_Supplement}', "");
    Expect(0, 7679, '\P{Is_Block=	Combining_diacritical_Marks_Supplement}', "");
    Expect(1, 7679, '\P{^Is_Block=	Combining_diacritical_Marks_Supplement}', "");
    Expect(0, 7680, '\p{Is_Block=	Combining_diacritical_Marks_Supplement}', "");
    Expect(1, 7680, '\p{^Is_Block=	Combining_diacritical_Marks_Supplement}', "");
    Expect(1, 7680, '\P{Is_Block=	Combining_diacritical_Marks_Supplement}', "");
    Expect(0, 7680, '\P{^Is_Block=	Combining_diacritical_Marks_Supplement}', "");
    Error('\p{Is_Blk:   /a/diacriticals_sup}');
    Error('\P{Is_Blk:   /a/diacriticals_sup}');
    Expect(1, 7679, '\p{Is_Blk=diacriticalssup}', "");
    Expect(0, 7679, '\p{^Is_Blk=diacriticalssup}', "");
    Expect(0, 7679, '\P{Is_Blk=diacriticalssup}', "");
    Expect(1, 7679, '\P{^Is_Blk=diacriticalssup}', "");
    Expect(0, 7680, '\p{Is_Blk=diacriticalssup}', "");
    Expect(1, 7680, '\p{^Is_Blk=diacriticalssup}', "");
    Expect(1, 7680, '\P{Is_Blk=diacriticalssup}', "");
    Expect(0, 7680, '\P{^Is_Blk=diacriticalssup}', "");
    Expect(1, 7679, '\p{Is_Blk=_ DIACRITICALS_sup}', "");
    Expect(0, 7679, '\p{^Is_Blk=_ DIACRITICALS_sup}', "");
    Expect(0, 7679, '\P{Is_Blk=_ DIACRITICALS_sup}', "");
    Expect(1, 7679, '\P{^Is_Blk=_ DIACRITICALS_sup}', "");
    Expect(0, 7680, '\p{Is_Blk=_ DIACRITICALS_sup}', "");
    Expect(1, 7680, '\p{^Is_Blk=_ DIACRITICALS_sup}', "");
    Expect(1, 7680, '\P{Is_Blk=_ DIACRITICALS_sup}', "");
    Expect(0, 7680, '\P{^Is_Blk=_ DIACRITICALS_sup}', "");
    Error('\p{Block=--DINGBATS/a/}');
    Error('\P{Block=--DINGBATS/a/}');
    Expect(1, 10175, '\p{Block=:\ADingbats\z:}', "");;
    Expect(0, 10176, '\p{Block=:\ADingbats\z:}', "");;
    Expect(1, 10175, '\p{Block=dingbats}', "");
    Expect(0, 10175, '\p{^Block=dingbats}', "");
    Expect(0, 10175, '\P{Block=dingbats}', "");
    Expect(1, 10175, '\P{^Block=dingbats}', "");
    Expect(0, 10176, '\p{Block=dingbats}', "");
    Expect(1, 10176, '\p{^Block=dingbats}', "");
    Expect(1, 10176, '\P{Block=dingbats}', "");
    Expect(0, 10176, '\P{^Block=dingbats}', "");
    Expect(1, 10175, '\p{Block=:\Adingbats\z:}', "");;
    Expect(0, 10176, '\p{Block=:\Adingbats\z:}', "");;
    Expect(1, 10175, '\p{Block=	Dingbats}', "");
    Expect(0, 10175, '\p{^Block=	Dingbats}', "");
    Expect(0, 10175, '\P{Block=	Dingbats}', "");
    Expect(1, 10175, '\P{^Block=	Dingbats}', "");
    Expect(0, 10176, '\p{Block=	Dingbats}', "");
    Expect(1, 10176, '\p{^Block=	Dingbats}', "");
    Expect(1, 10176, '\P{Block=	Dingbats}', "");
    Expect(0, 10176, '\P{^Block=	Dingbats}', "");
    Error('\p{Blk= :=Dingbats}');
    Error('\P{Blk= :=Dingbats}');
    Expect(1, 10175, '\p{Blk=:\ADingbats\z:}', "");;
    Expect(0, 10176, '\p{Blk=:\ADingbats\z:}', "");;
    Expect(1, 10175, '\p{Blk=dingbats}', "");
    Expect(0, 10175, '\p{^Blk=dingbats}', "");
    Expect(0, 10175, '\P{Blk=dingbats}', "");
    Expect(1, 10175, '\P{^Blk=dingbats}', "");
    Expect(0, 10176, '\p{Blk=dingbats}', "");
    Expect(1, 10176, '\p{^Blk=dingbats}', "");
    Expect(1, 10176, '\P{Blk=dingbats}', "");
    Expect(0, 10176, '\P{^Blk=dingbats}', "");
    Expect(1, 10175, '\p{Blk=:\Adingbats\z:}', "");;
    Expect(0, 10176, '\p{Blk=:\Adingbats\z:}', "");;
    Expect(1, 10175, '\p{Blk=- DINGBATS}', "");
    Expect(0, 10175, '\p{^Blk=- DINGBATS}', "");
    Expect(0, 10175, '\P{Blk=- DINGBATS}', "");
    Expect(1, 10175, '\P{^Blk=- DINGBATS}', "");
    Expect(0, 10176, '\p{Blk=- DINGBATS}', "");
    Expect(1, 10176, '\p{^Blk=- DINGBATS}', "");
    Expect(1, 10176, '\P{Blk=- DINGBATS}', "");
    Expect(0, 10176, '\P{^Blk=- DINGBATS}', "");
    Error('\p{Is_Block=	Dingbats:=}');
    Error('\P{Is_Block=	Dingbats:=}');
    Expect(1, 10175, '\p{Is_Block=dingbats}', "");
    Expect(0, 10175, '\p{^Is_Block=dingbats}', "");
    Expect(0, 10175, '\P{Is_Block=dingbats}', "");
    Expect(1, 10175, '\P{^Is_Block=dingbats}', "");
    Expect(0, 10176, '\p{Is_Block=dingbats}', "");
    Expect(1, 10176, '\p{^Is_Block=dingbats}', "");
    Expect(1, 10176, '\P{Is_Block=dingbats}', "");
    Expect(0, 10176, '\P{^Is_Block=dingbats}', "");
    Expect(1, 10175, '\p{Is_Block=-_Dingbats}', "");
    Expect(0, 10175, '\p{^Is_Block=-_Dingbats}', "");
    Expect(0, 10175, '\P{Is_Block=-_Dingbats}', "");
    Expect(1, 10175, '\P{^Is_Block=-_Dingbats}', "");
    Expect(0, 10176, '\p{Is_Block=-_Dingbats}', "");
    Expect(1, 10176, '\p{^Is_Block=-_Dingbats}', "");
    Expect(1, 10176, '\P{Is_Block=-_Dingbats}', "");
    Expect(0, 10176, '\P{^Is_Block=-_Dingbats}', "");
    Error('\p{Is_Blk=/a/	dingbats}');
    Error('\P{Is_Blk=/a/	dingbats}');
    Expect(1, 10175, '\p{Is_Blk:dingbats}', "");
    Expect(0, 10175, '\p{^Is_Blk:dingbats}', "");
    Expect(0, 10175, '\P{Is_Blk:dingbats}', "");
    Expect(1, 10175, '\P{^Is_Blk:dingbats}', "");
    Expect(0, 10176, '\p{Is_Blk:dingbats}', "");
    Expect(1, 10176, '\p{^Is_Blk:dingbats}', "");
    Expect(1, 10176, '\P{Is_Blk:dingbats}', "");
    Expect(0, 10176, '\P{^Is_Blk:dingbats}', "");
    Expect(1, 10175, '\p{Is_Blk=Dingbats}', "");
    Expect(0, 10175, '\p{^Is_Blk=Dingbats}', "");
    Expect(0, 10175, '\P{Is_Blk=Dingbats}', "");
    Expect(1, 10175, '\P{^Is_Blk=Dingbats}', "");
    Expect(0, 10176, '\p{Is_Blk=Dingbats}', "");
    Expect(1, 10176, '\p{^Is_Blk=Dingbats}', "");
    Expect(1, 10176, '\P{Is_Blk=Dingbats}', "");
    Expect(0, 10176, '\P{^Is_Blk=Dingbats}', "");
    Error('\p{Block=:= _Dives_Akuru}');
    Error('\P{Block=:= _Dives_Akuru}');
    Expect(1, 72031, '\p{Block=:\ADives_Akuru\z:}', "");;
    Expect(0, 72032, '\p{Block=:\ADives_Akuru\z:}', "");;
    Expect(1, 72031, '\p{Block=divesakuru}', "");
    Expect(0, 72031, '\p{^Block=divesakuru}', "");
    Expect(0, 72031, '\P{Block=divesakuru}', "");
    Expect(1, 72031, '\P{^Block=divesakuru}', "");
    Expect(0, 72032, '\p{Block=divesakuru}', "");
    Expect(1, 72032, '\p{^Block=divesakuru}', "");
    Expect(1, 72032, '\P{Block=divesakuru}', "");
    Expect(0, 72032, '\P{^Block=divesakuru}', "");
    Expect(1, 72031, '\p{Block=:\Adivesakuru\z:}', "");;
    Expect(0, 72032, '\p{Block=:\Adivesakuru\z:}', "");;
    Expect(1, 72031, '\p{Block=--dives_Akuru}', "");
    Expect(0, 72031, '\p{^Block=--dives_Akuru}', "");
    Expect(0, 72031, '\P{Block=--dives_Akuru}', "");
    Expect(1, 72031, '\P{^Block=--dives_Akuru}', "");
    Expect(0, 72032, '\p{Block=--dives_Akuru}', "");
    Expect(1, 72032, '\p{^Block=--dives_Akuru}', "");
    Expect(1, 72032, '\P{Block=--dives_Akuru}', "");
    Expect(0, 72032, '\P{^Block=--dives_Akuru}', "");
    Error('\p{Blk=/a/ -Dives_Akuru}');
    Error('\P{Blk=/a/ -Dives_Akuru}');
    Expect(1, 72031, '\p{Blk=:\ADives_Akuru\z:}', "");;
    Expect(0, 72032, '\p{Blk=:\ADives_Akuru\z:}', "");;
    Expect(1, 72031, '\p{Blk=divesakuru}', "");
    Expect(0, 72031, '\p{^Blk=divesakuru}', "");
    Expect(0, 72031, '\P{Blk=divesakuru}', "");
    Expect(1, 72031, '\P{^Blk=divesakuru}', "");
    Expect(0, 72032, '\p{Blk=divesakuru}', "");
    Expect(1, 72032, '\p{^Blk=divesakuru}', "");
    Expect(1, 72032, '\P{Blk=divesakuru}', "");
    Expect(0, 72032, '\P{^Blk=divesakuru}', "");
    Expect(1, 72031, '\p{Blk=:\Adivesakuru\z:}', "");;
    Expect(0, 72032, '\p{Blk=:\Adivesakuru\z:}', "");;
    Expect(1, 72031, '\p{Blk=Dives_AKURU}', "");
    Expect(0, 72031, '\p{^Blk=Dives_AKURU}', "");
    Expect(0, 72031, '\P{Blk=Dives_AKURU}', "");
    Expect(1, 72031, '\P{^Blk=Dives_AKURU}', "");
    Expect(0, 72032, '\p{Blk=Dives_AKURU}', "");
    Expect(1, 72032, '\p{^Blk=Dives_AKURU}', "");
    Expect(1, 72032, '\P{Blk=Dives_AKURU}', "");
    Expect(0, 72032, '\P{^Blk=Dives_AKURU}', "");
    Error('\p{Is_Block=-DIVES_Akuru/a/}');
    Error('\P{Is_Block=-DIVES_Akuru/a/}');
    Expect(1, 72031, '\p{Is_Block=divesakuru}', "");
    Expect(0, 72031, '\p{^Is_Block=divesakuru}', "");
    Expect(0, 72031, '\P{Is_Block=divesakuru}', "");
    Expect(1, 72031, '\P{^Is_Block=divesakuru}', "");
    Expect(0, 72032, '\p{Is_Block=divesakuru}', "");
    Expect(1, 72032, '\p{^Is_Block=divesakuru}', "");
    Expect(1, 72032, '\P{Is_Block=divesakuru}', "");
    Expect(0, 72032, '\P{^Is_Block=divesakuru}', "");
    Expect(1, 72031, '\p{Is_Block= _Dives_Akuru}', "");
    Expect(0, 72031, '\p{^Is_Block= _Dives_Akuru}', "");
    Expect(0, 72031, '\P{Is_Block= _Dives_Akuru}', "");
    Expect(1, 72031, '\P{^Is_Block= _Dives_Akuru}', "");
    Expect(0, 72032, '\p{Is_Block= _Dives_Akuru}', "");
    Expect(1, 72032, '\p{^Is_Block= _Dives_Akuru}', "");
    Expect(1, 72032, '\P{Is_Block= _Dives_Akuru}', "");
    Expect(0, 72032, '\P{^Is_Block= _Dives_Akuru}', "");
    Error('\p{Is_Blk=:=	Dives_akuru}');
    Error('\P{Is_Blk=:=	Dives_akuru}');
    Expect(1, 72031, '\p{Is_Blk=divesakuru}', "");
    Expect(0, 72031, '\p{^Is_Blk=divesakuru}', "");
    Expect(0, 72031, '\P{Is_Blk=divesakuru}', "");
    Expect(1, 72031, '\P{^Is_Blk=divesakuru}', "");
    Expect(0, 72032, '\p{Is_Blk=divesakuru}', "");
    Expect(1, 72032, '\p{^Is_Blk=divesakuru}', "");
    Expect(1, 72032, '\P{Is_Blk=divesakuru}', "");
    Expect(0, 72032, '\P{^Is_Blk=divesakuru}', "");
    Expect(1, 72031, '\p{Is_Blk= _dives_AKURU}', "");
    Expect(0, 72031, '\p{^Is_Blk= _dives_AKURU}', "");
    Expect(0, 72031, '\P{Is_Blk= _dives_AKURU}', "");
    Expect(1, 72031, '\P{^Is_Blk= _dives_AKURU}', "");
    Expect(0, 72032, '\p{Is_Blk= _dives_AKURU}', "");
    Expect(1, 72032, '\p{^Is_Blk= _dives_AKURU}', "");
    Expect(1, 72032, '\P{Is_Blk= _dives_AKURU}', "");
    Expect(0, 72032, '\P{^Is_Blk= _dives_AKURU}', "");
    Error('\p{Block=:=_ dogra}');
    Error('\P{Block=:=_ dogra}');
    Expect(1, 71759, '\p{Block=:\ADogra\z:}', "");;
    Expect(0, 71760, '\p{Block=:\ADogra\z:}', "");;
    Expect(1, 71759, '\p{Block=dogra}', "");
    Expect(0, 71759, '\p{^Block=dogra}', "");
    Expect(0, 71759, '\P{Block=dogra}', "");
    Expect(1, 71759, '\P{^Block=dogra}', "");
    Expect(0, 71760, '\p{Block=dogra}', "");
    Expect(1, 71760, '\p{^Block=dogra}', "");
    Expect(1, 71760, '\P{Block=dogra}', "");
    Expect(0, 71760, '\P{^Block=dogra}', "");
    Expect(1, 71759, '\p{Block=:\Adogra\z:}', "");;
    Expect(0, 71760, '\p{Block=:\Adogra\z:}', "");;
    Expect(1, 71759, '\p{Block=- dogra}', "");
    Expect(0, 71759, '\p{^Block=- dogra}', "");
    Expect(0, 71759, '\P{Block=- dogra}', "");
    Expect(1, 71759, '\P{^Block=- dogra}', "");
    Expect(0, 71760, '\p{Block=- dogra}', "");
    Expect(1, 71760, '\p{^Block=- dogra}', "");
    Expect(1, 71760, '\P{Block=- dogra}', "");
    Expect(0, 71760, '\P{^Block=- dogra}', "");
    Error('\p{Blk=-:=Dogra}');
    Error('\P{Blk=-:=Dogra}');
    Expect(1, 71759, '\p{Blk=:\ADogra\z:}', "");;
    Expect(0, 71760, '\p{Blk=:\ADogra\z:}', "");;
    Expect(1, 71759, '\p{Blk=dogra}', "");
    Expect(0, 71759, '\p{^Blk=dogra}', "");
    Expect(0, 71759, '\P{Blk=dogra}', "");
    Expect(1, 71759, '\P{^Blk=dogra}', "");
    Expect(0, 71760, '\p{Blk=dogra}', "");
    Expect(1, 71760, '\p{^Blk=dogra}', "");
    Expect(1, 71760, '\P{Blk=dogra}', "");
    Expect(0, 71760, '\P{^Blk=dogra}', "");
    Expect(1, 71759, '\p{Blk=:\Adogra\z:}', "");;
    Expect(0, 71760, '\p{Blk=:\Adogra\z:}', "");;
    Expect(1, 71759, '\p{Blk=__Dogra}', "");
    Expect(0, 71759, '\p{^Blk=__Dogra}', "");
    Expect(0, 71759, '\P{Blk=__Dogra}', "");
    Expect(1, 71759, '\P{^Blk=__Dogra}', "");
    Expect(0, 71760, '\p{Blk=__Dogra}', "");
    Expect(1, 71760, '\p{^Blk=__Dogra}', "");
    Expect(1, 71760, '\P{Blk=__Dogra}', "");
    Expect(0, 71760, '\P{^Blk=__Dogra}', "");
    Error('\p{Is_Block=	/a/dogra}');
    Error('\P{Is_Block=	/a/dogra}');
    Expect(1, 71759, '\p{Is_Block:   dogra}', "");
    Expect(0, 71759, '\p{^Is_Block:   dogra}', "");
    Expect(0, 71759, '\P{Is_Block:   dogra}', "");
    Expect(1, 71759, '\P{^Is_Block:   dogra}', "");
    Expect(0, 71760, '\p{Is_Block:   dogra}', "");
    Expect(1, 71760, '\p{^Is_Block:   dogra}', "");
    Expect(1, 71760, '\P{Is_Block:   dogra}', "");
    Expect(0, 71760, '\P{^Is_Block:   dogra}', "");
    Expect(1, 71759, '\p{Is_Block=_	Dogra}', "");
    Expect(0, 71759, '\p{^Is_Block=_	Dogra}', "");
    Expect(0, 71759, '\P{Is_Block=_	Dogra}', "");
    Expect(1, 71759, '\P{^Is_Block=_	Dogra}', "");
    Expect(0, 71760, '\p{Is_Block=_	Dogra}', "");
    Expect(1, 71760, '\p{^Is_Block=_	Dogra}', "");
    Expect(1, 71760, '\P{Is_Block=_	Dogra}', "");
    Expect(0, 71760, '\P{^Is_Block=_	Dogra}', "");
    Error('\p{Is_Blk=/a/-_Dogra}');
    Error('\P{Is_Blk=/a/-_Dogra}');
    Expect(1, 71759, '\p{Is_Blk: dogra}', "");
    Expect(0, 71759, '\p{^Is_Blk: dogra}', "");
    Expect(0, 71759, '\P{Is_Blk: dogra}', "");
    Expect(1, 71759, '\P{^Is_Blk: dogra}', "");
    Expect(0, 71760, '\p{Is_Blk: dogra}', "");
    Expect(1, 71760, '\p{^Is_Blk: dogra}', "");
    Expect(1, 71760, '\P{Is_Blk: dogra}', "");
    Expect(0, 71760, '\P{^Is_Blk: dogra}', "");
    Expect(1, 71759, '\p{Is_Blk=_Dogra}', "");
    Expect(0, 71759, '\p{^Is_Blk=_Dogra}', "");
    Expect(0, 71759, '\P{Is_Blk=_Dogra}', "");
    Expect(1, 71759, '\P{^Is_Blk=_Dogra}', "");
    Expect(0, 71760, '\p{Is_Blk=_Dogra}', "");
    Expect(1, 71760, '\p{^Is_Blk=_Dogra}', "");
    Expect(1, 71760, '\P{Is_Blk=_Dogra}', "");
    Expect(0, 71760, '\P{^Is_Blk=_Dogra}', "");
    Error('\p{Block= :=Domino_Tiles}');
    Error('\P{Block= :=Domino_Tiles}');
    Expect(1, 127135, '\p{Block=:\ADomino_Tiles\z:}', "");;
    Expect(0, 127136, '\p{Block=:\ADomino_Tiles\z:}', "");;
    Expect(1, 127135, '\p{Block=dominotiles}', "");
    Expect(0, 127135, '\p{^Block=dominotiles}', "");
    Expect(0, 127135, '\P{Block=dominotiles}', "");
    Expect(1, 127135, '\P{^Block=dominotiles}', "");
    Expect(0, 127136, '\p{Block=dominotiles}', "");
    Expect(1, 127136, '\p{^Block=dominotiles}', "");
    Expect(1, 127136, '\P{Block=dominotiles}', "");
    Expect(0, 127136, '\P{^Block=dominotiles}', "");
    Expect(1, 127135, '\p{Block=:\Adominotiles\z:}', "");;
    Expect(0, 127136, '\p{Block=:\Adominotiles\z:}', "");;
    Expect(1, 127135, '\p{Block=	-domino_TILES}', "");
    Expect(0, 127135, '\p{^Block=	-domino_TILES}', "");
    Expect(0, 127135, '\P{Block=	-domino_TILES}', "");
    Expect(1, 127135, '\P{^Block=	-domino_TILES}', "");
    Expect(0, 127136, '\p{Block=	-domino_TILES}', "");
    Expect(1, 127136, '\p{^Block=	-domino_TILES}', "");
    Expect(1, 127136, '\P{Block=	-domino_TILES}', "");
    Expect(0, 127136, '\P{^Block=	-domino_TILES}', "");
    Error('\p{Blk=:=	Domino}');
    Error('\P{Blk=:=	Domino}');
    Expect(1, 127135, '\p{Blk=:\ADomino\z:}', "");;
    Expect(0, 127136, '\p{Blk=:\ADomino\z:}', "");;
    Expect(1, 127135, '\p{Blk=domino}', "");
    Expect(0, 127135, '\p{^Blk=domino}', "");
    Expect(0, 127135, '\P{Blk=domino}', "");
    Expect(1, 127135, '\P{^Blk=domino}', "");
    Expect(0, 127136, '\p{Blk=domino}', "");
    Expect(1, 127136, '\p{^Blk=domino}', "");
    Expect(1, 127136, '\P{Blk=domino}', "");
    Expect(0, 127136, '\P{^Blk=domino}', "");
    Expect(1, 127135, '\p{Blk=:\Adomino\z:}', "");;
    Expect(0, 127136, '\p{Blk=:\Adomino\z:}', "");;
    Expect(1, 127135, '\p{Blk=	Domino}', "");
    Expect(0, 127135, '\p{^Blk=	Domino}', "");
    Expect(0, 127135, '\P{Blk=	Domino}', "");
    Expect(1, 127135, '\P{^Blk=	Domino}', "");
    Expect(0, 127136, '\p{Blk=	Domino}', "");
    Expect(1, 127136, '\p{^Blk=	Domino}', "");
    Expect(1, 127136, '\P{Blk=	Domino}', "");
    Expect(0, 127136, '\P{^Blk=	Domino}', "");
    Error('\p{Is_Block=:=	 DOMINO_TILES}');
    Error('\P{Is_Block=:=	 DOMINO_TILES}');
    Expect(1, 127135, '\p{Is_Block=dominotiles}', "");
    Expect(0, 127135, '\p{^Is_Block=dominotiles}', "");
    Expect(0, 127135, '\P{Is_Block=dominotiles}', "");
    Expect(1, 127135, '\P{^Is_Block=dominotiles}', "");
    Expect(0, 127136, '\p{Is_Block=dominotiles}', "");
    Expect(1, 127136, '\p{^Is_Block=dominotiles}', "");
    Expect(1, 127136, '\P{Is_Block=dominotiles}', "");
    Expect(0, 127136, '\P{^Is_Block=dominotiles}', "");
    Expect(1, 127135, '\p{Is_Block=-DOMINO_TILES}', "");
    Expect(0, 127135, '\p{^Is_Block=-DOMINO_TILES}', "");
    Expect(0, 127135, '\P{Is_Block=-DOMINO_TILES}', "");
    Expect(1, 127135, '\P{^Is_Block=-DOMINO_TILES}', "");
    Expect(0, 127136, '\p{Is_Block=-DOMINO_TILES}', "");
    Expect(1, 127136, '\p{^Is_Block=-DOMINO_TILES}', "");
    Expect(1, 127136, '\P{Is_Block=-DOMINO_TILES}', "");
    Expect(0, 127136, '\P{^Is_Block=-DOMINO_TILES}', "");
    Error('\p{Is_Blk=:=domino}');
    Error('\P{Is_Blk=:=domino}');
    Expect(1, 127135, '\p{Is_Blk=domino}', "");
    Expect(0, 127135, '\p{^Is_Blk=domino}', "");
    Expect(0, 127135, '\P{Is_Blk=domino}', "");
    Expect(1, 127135, '\P{^Is_Blk=domino}', "");
    Expect(0, 127136, '\p{Is_Blk=domino}', "");
    Expect(1, 127136, '\p{^Is_Blk=domino}', "");
    Expect(1, 127136, '\P{Is_Blk=domino}', "");
    Expect(0, 127136, '\P{^Is_Blk=domino}', "");
    Expect(1, 127135, '\p{Is_Blk=_-Domino}', "");
    Expect(0, 127135, '\p{^Is_Blk=_-Domino}', "");
    Expect(0, 127135, '\P{Is_Blk=_-Domino}', "");
    Expect(1, 127135, '\P{^Is_Blk=_-Domino}', "");
    Expect(0, 127136, '\p{Is_Blk=_-Domino}', "");
    Expect(1, 127136, '\p{^Is_Blk=_-Domino}', "");
    Expect(1, 127136, '\P{Is_Blk=_-Domino}', "");
    Expect(0, 127136, '\P{^Is_Blk=_-Domino}', "");
    Error('\p{Block= Duployan:=}');
    Error('\P{Block= Duployan:=}');
    Expect(1, 113823, '\p{Block=:\ADuployan\z:}', "");;
    Expect(0, 113824, '\p{Block=:\ADuployan\z:}', "");;
    Expect(1, 113823, '\p{Block=duployan}', "");
    Expect(0, 113823, '\p{^Block=duployan}', "");
    Expect(0, 113823, '\P{Block=duployan}', "");
    Expect(1, 113823, '\P{^Block=duployan}', "");
    Expect(0, 113824, '\p{Block=duployan}', "");
    Expect(1, 113824, '\p{^Block=duployan}', "");
    Expect(1, 113824, '\P{Block=duployan}', "");
    Expect(0, 113824, '\P{^Block=duployan}', "");
    Expect(1, 113823, '\p{Block=:\Aduployan\z:}', "");;
    Expect(0, 113824, '\p{Block=:\Aduployan\z:}', "");;
    Expect(1, 113823, '\p{Block= Duployan}', "");
    Expect(0, 113823, '\p{^Block= Duployan}', "");
    Expect(0, 113823, '\P{Block= Duployan}', "");
    Expect(1, 113823, '\P{^Block= Duployan}', "");
    Expect(0, 113824, '\p{Block= Duployan}', "");
    Expect(1, 113824, '\p{^Block= Duployan}', "");
    Expect(1, 113824, '\P{Block= Duployan}', "");
    Expect(0, 113824, '\P{^Block= Duployan}', "");
    Error('\p{Blk: --duployan:=}');
    Error('\P{Blk: --duployan:=}');
    Expect(1, 113823, '\p{Blk=:\ADuployan\z:}', "");;
    Expect(0, 113824, '\p{Blk=:\ADuployan\z:}', "");;
    Expect(1, 113823, '\p{Blk=duployan}', "");
    Expect(0, 113823, '\p{^Blk=duployan}', "");
    Expect(0, 113823, '\P{Blk=duployan}', "");
    Expect(1, 113823, '\P{^Blk=duployan}', "");
    Expect(0, 113824, '\p{Blk=duployan}', "");
    Expect(1, 113824, '\p{^Blk=duployan}', "");
    Expect(1, 113824, '\P{Blk=duployan}', "");
    Expect(0, 113824, '\P{^Blk=duployan}', "");
    Expect(1, 113823, '\p{Blk=:\Aduployan\z:}', "");;
    Expect(0, 113824, '\p{Blk=:\Aduployan\z:}', "");;
    Expect(1, 113823, '\p{Blk=	 duployan}', "");
    Expect(0, 113823, '\p{^Blk=	 duployan}', "");
    Expect(0, 113823, '\P{Blk=	 duployan}', "");
    Expect(1, 113823, '\P{^Blk=	 duployan}', "");
    Expect(0, 113824, '\p{Blk=	 duployan}', "");
    Expect(1, 113824, '\p{^Blk=	 duployan}', "");
    Expect(1, 113824, '\P{Blk=	 duployan}', "");
    Expect(0, 113824, '\P{^Blk=	 duployan}', "");
    Error('\p{Is_Block=/a/--Duployan}');
    Error('\P{Is_Block=/a/--Duployan}');
    Expect(1, 113823, '\p{Is_Block:	duployan}', "");
    Expect(0, 113823, '\p{^Is_Block:	duployan}', "");
    Expect(0, 113823, '\P{Is_Block:	duployan}', "");
    Expect(1, 113823, '\P{^Is_Block:	duployan}', "");
    Expect(0, 113824, '\p{Is_Block:	duployan}', "");
    Expect(1, 113824, '\p{^Is_Block:	duployan}', "");
    Expect(1, 113824, '\P{Is_Block:	duployan}', "");
    Expect(0, 113824, '\P{^Is_Block:	duployan}', "");
    Expect(1, 113823, '\p{Is_Block=-DUPLOYAN}', "");
    Expect(0, 113823, '\p{^Is_Block=-DUPLOYAN}', "");
    Expect(0, 113823, '\P{Is_Block=-DUPLOYAN}', "");
    Expect(1, 113823, '\P{^Is_Block=-DUPLOYAN}', "");
    Expect(0, 113824, '\p{Is_Block=-DUPLOYAN}', "");
    Expect(1, 113824, '\p{^Is_Block=-DUPLOYAN}', "");
    Expect(1, 113824, '\P{Is_Block=-DUPLOYAN}', "");
    Expect(0, 113824, '\P{^Is_Block=-DUPLOYAN}', "");
    Error('\p{Is_Blk=	/a/DUPLOYAN}');
    Error('\P{Is_Blk=	/a/DUPLOYAN}');
    Expect(1, 113823, '\p{Is_Blk=duployan}', "");
    Expect(0, 113823, '\p{^Is_Blk=duployan}', "");
    Expect(0, 113823, '\P{Is_Blk=duployan}', "");
    Expect(1, 113823, '\P{^Is_Blk=duployan}', "");
    Expect(0, 113824, '\p{Is_Blk=duployan}', "");
    Expect(1, 113824, '\p{^Is_Blk=duployan}', "");
    Expect(1, 113824, '\P{Is_Blk=duployan}', "");
    Expect(0, 113824, '\P{^Is_Blk=duployan}', "");
    Expect(1, 113823, '\p{Is_Blk= _Duployan}', "");
    Expect(0, 113823, '\p{^Is_Blk= _Duployan}', "");
    Expect(0, 113823, '\P{Is_Blk= _Duployan}', "");
    Expect(1, 113823, '\P{^Is_Blk= _Duployan}', "");
    Expect(0, 113824, '\p{Is_Blk= _Duployan}', "");
    Expect(1, 113824, '\p{^Is_Blk= _Duployan}', "");
    Expect(1, 113824, '\P{Is_Blk= _Duployan}', "");
    Expect(0, 113824, '\P{^Is_Blk= _Duployan}', "");
    Error('\p{Block=-	early_Dynastic_Cuneiform/a/}');
    Error('\P{Block=-	early_Dynastic_Cuneiform/a/}');
    Expect(1, 75087, '\p{Block=:\AEarly_Dynastic_Cuneiform\z:}', "");;
    Expect(0, 75088, '\p{Block=:\AEarly_Dynastic_Cuneiform\z:}', "");;
    Expect(1, 75087, '\p{Block=earlydynasticcuneiform}', "");
    Expect(0, 75087, '\p{^Block=earlydynasticcuneiform}', "");
    Expect(0, 75087, '\P{Block=earlydynasticcuneiform}', "");
    Expect(1, 75087, '\P{^Block=earlydynasticcuneiform}', "");
    Expect(0, 75088, '\p{Block=earlydynasticcuneiform}', "");
    Expect(1, 75088, '\p{^Block=earlydynasticcuneiform}', "");
    Expect(1, 75088, '\P{Block=earlydynasticcuneiform}', "");
    Expect(0, 75088, '\P{^Block=earlydynasticcuneiform}', "");
    Expect(1, 75087, '\p{Block=:\Aearlydynasticcuneiform\z:}', "");;
    Expect(0, 75088, '\p{Block=:\Aearlydynasticcuneiform\z:}', "");;
    Expect(1, 75087, '\p{Block=  early_Dynastic_Cuneiform}', "");
    Expect(0, 75087, '\p{^Block=  early_Dynastic_Cuneiform}', "");
    Expect(0, 75087, '\P{Block=  early_Dynastic_Cuneiform}', "");
    Expect(1, 75087, '\P{^Block=  early_Dynastic_Cuneiform}', "");
    Expect(0, 75088, '\p{Block=  early_Dynastic_Cuneiform}', "");
    Expect(1, 75088, '\p{^Block=  early_Dynastic_Cuneiform}', "");
    Expect(1, 75088, '\P{Block=  early_Dynastic_Cuneiform}', "");
    Expect(0, 75088, '\P{^Block=  early_Dynastic_Cuneiform}', "");
    Error('\p{Blk=/a/- EARLY_dynastic_Cuneiform}');
    Error('\P{Blk=/a/- EARLY_dynastic_Cuneiform}');
    Expect(1, 75087, '\p{Blk=:\AEarly_Dynastic_Cuneiform\z:}', "");;
    Expect(0, 75088, '\p{Blk=:\AEarly_Dynastic_Cuneiform\z:}', "");;
    Expect(1, 75087, '\p{Blk=earlydynasticcuneiform}', "");
    Expect(0, 75087, '\p{^Blk=earlydynasticcuneiform}', "");
    Expect(0, 75087, '\P{Blk=earlydynasticcuneiform}', "");
    Expect(1, 75087, '\P{^Blk=earlydynasticcuneiform}', "");
    Expect(0, 75088, '\p{Blk=earlydynasticcuneiform}', "");
    Expect(1, 75088, '\p{^Blk=earlydynasticcuneiform}', "");
    Expect(1, 75088, '\P{Blk=earlydynasticcuneiform}', "");
    Expect(0, 75088, '\P{^Blk=earlydynasticcuneiform}', "");
    Expect(1, 75087, '\p{Blk=:\Aearlydynasticcuneiform\z:}', "");;
    Expect(0, 75088, '\p{Blk=:\Aearlydynasticcuneiform\z:}', "");;
    Expect(1, 75087, '\p{Blk=_ early_dynastic_Cuneiform}', "");
    Expect(0, 75087, '\p{^Blk=_ early_dynastic_Cuneiform}', "");
    Expect(0, 75087, '\P{Blk=_ early_dynastic_Cuneiform}', "");
    Expect(1, 75087, '\P{^Blk=_ early_dynastic_Cuneiform}', "");
    Expect(0, 75088, '\p{Blk=_ early_dynastic_Cuneiform}', "");
    Expect(1, 75088, '\p{^Blk=_ early_dynastic_Cuneiform}', "");
    Expect(1, 75088, '\P{Blk=_ early_dynastic_Cuneiform}', "");
    Expect(0, 75088, '\P{^Blk=_ early_dynastic_Cuneiform}', "");
    Error('\p{Is_Block=		Early_Dynastic_CUNEIFORM:=}');
    Error('\P{Is_Block=		Early_Dynastic_CUNEIFORM:=}');
    Expect(1, 75087, '\p{Is_Block=earlydynasticcuneiform}', "");
    Expect(0, 75087, '\p{^Is_Block=earlydynasticcuneiform}', "");
    Expect(0, 75087, '\P{Is_Block=earlydynasticcuneiform}', "");
    Expect(1, 75087, '\P{^Is_Block=earlydynasticcuneiform}', "");
    Expect(0, 75088, '\p{Is_Block=earlydynasticcuneiform}', "");
    Expect(1, 75088, '\p{^Is_Block=earlydynasticcuneiform}', "");
    Expect(1, 75088, '\P{Is_Block=earlydynasticcuneiform}', "");
    Expect(0, 75088, '\P{^Is_Block=earlydynasticcuneiform}', "");
    Expect(1, 75087, '\p{Is_Block=__early_DYNASTIC_cuneiform}', "");
    Expect(0, 75087, '\p{^Is_Block=__early_DYNASTIC_cuneiform}', "");
    Expect(0, 75087, '\P{Is_Block=__early_DYNASTIC_cuneiform}', "");
    Expect(1, 75087, '\P{^Is_Block=__early_DYNASTIC_cuneiform}', "");
    Expect(0, 75088, '\p{Is_Block=__early_DYNASTIC_cuneiform}', "");
    Expect(1, 75088, '\p{^Is_Block=__early_DYNASTIC_cuneiform}', "");
    Expect(1, 75088, '\P{Is_Block=__early_DYNASTIC_cuneiform}', "");
    Expect(0, 75088, '\P{^Is_Block=__early_DYNASTIC_cuneiform}', "");
    Error('\p{Is_Blk=/a/ early_Dynastic_Cuneiform}');
    Error('\P{Is_Blk=/a/ early_Dynastic_Cuneiform}');
    Expect(1, 75087, '\p{Is_Blk=earlydynasticcuneiform}', "");
    Expect(0, 75087, '\p{^Is_Blk=earlydynasticcuneiform}', "");
    Expect(0, 75087, '\P{Is_Blk=earlydynasticcuneiform}', "");
    Expect(1, 75087, '\P{^Is_Blk=earlydynasticcuneiform}', "");
    Expect(0, 75088, '\p{Is_Blk=earlydynasticcuneiform}', "");
    Expect(1, 75088, '\p{^Is_Blk=earlydynasticcuneiform}', "");
    Expect(1, 75088, '\P{Is_Blk=earlydynasticcuneiform}', "");
    Expect(0, 75088, '\P{^Is_Blk=earlydynasticcuneiform}', "");
    Expect(1, 75087, '\p{Is_Blk=__Early_Dynastic_cuneiform}', "");
    Expect(0, 75087, '\p{^Is_Blk=__Early_Dynastic_cuneiform}', "");
    Expect(0, 75087, '\P{Is_Blk=__Early_Dynastic_cuneiform}', "");
    Expect(1, 75087, '\P{^Is_Blk=__Early_Dynastic_cuneiform}', "");
    Expect(0, 75088, '\p{Is_Blk=__Early_Dynastic_cuneiform}', "");
    Expect(1, 75088, '\p{^Is_Blk=__Early_Dynastic_cuneiform}', "");
    Expect(1, 75088, '\P{Is_Blk=__Early_Dynastic_cuneiform}', "");
    Expect(0, 75088, '\P{^Is_Blk=__Early_Dynastic_cuneiform}', "");
    Error('\p{Block= 	Egyptian_HIEROGLYPH_Format_Controls:=}');
    Error('\P{Block= 	Egyptian_HIEROGLYPH_Format_Controls:=}');
    Expect(1, 78911, '\p{Block=:\AEgyptian_Hieroglyph_Format_Controls\z:}', "");;
    Expect(0, 78912, '\p{Block=:\AEgyptian_Hieroglyph_Format_Controls\z:}', "");;
    Expect(1, 78911, '\p{Block=egyptianhieroglyphformatcontrols}', "");
    Expect(0, 78911, '\p{^Block=egyptianhieroglyphformatcontrols}', "");
    Expect(0, 78911, '\P{Block=egyptianhieroglyphformatcontrols}', "");
    Expect(1, 78911, '\P{^Block=egyptianhieroglyphformatcontrols}', "");
    Expect(0, 78912, '\p{Block=egyptianhieroglyphformatcontrols}', "");
    Expect(1, 78912, '\p{^Block=egyptianhieroglyphformatcontrols}', "");
    Expect(1, 78912, '\P{Block=egyptianhieroglyphformatcontrols}', "");
    Expect(0, 78912, '\P{^Block=egyptianhieroglyphformatcontrols}', "");
    Expect(1, 78911, '\p{Block=:\Aegyptianhieroglyphformatcontrols\z:}', "");;
    Expect(0, 78912, '\p{Block=:\Aegyptianhieroglyphformatcontrols\z:}', "");;
    Expect(1, 78911, '\p{Block=-Egyptian_hieroglyph_Format_controls}', "");
    Expect(0, 78911, '\p{^Block=-Egyptian_hieroglyph_Format_controls}', "");
    Expect(0, 78911, '\P{Block=-Egyptian_hieroglyph_Format_controls}', "");
    Expect(1, 78911, '\P{^Block=-Egyptian_hieroglyph_Format_controls}', "");
    Expect(0, 78912, '\p{Block=-Egyptian_hieroglyph_Format_controls}', "");
    Expect(1, 78912, '\p{^Block=-Egyptian_hieroglyph_Format_controls}', "");
    Expect(1, 78912, '\P{Block=-Egyptian_hieroglyph_Format_controls}', "");
    Expect(0, 78912, '\P{^Block=-Egyptian_hieroglyph_Format_controls}', "");
    Error('\p{Blk=	:=Egyptian_HIEROGLYPH_format_controls}');
    Error('\P{Blk=	:=Egyptian_HIEROGLYPH_format_controls}');
    Expect(1, 78911, '\p{Blk=:\AEgyptian_Hieroglyph_Format_Controls\z:}', "");;
    Expect(0, 78912, '\p{Blk=:\AEgyptian_Hieroglyph_Format_Controls\z:}', "");;
    Expect(1, 78911, '\p{Blk=egyptianhieroglyphformatcontrols}', "");
    Expect(0, 78911, '\p{^Blk=egyptianhieroglyphformatcontrols}', "");
    Expect(0, 78911, '\P{Blk=egyptianhieroglyphformatcontrols}', "");
    Expect(1, 78911, '\P{^Blk=egyptianhieroglyphformatcontrols}', "");
    Expect(0, 78912, '\p{Blk=egyptianhieroglyphformatcontrols}', "");
    Expect(1, 78912, '\p{^Blk=egyptianhieroglyphformatcontrols}', "");
    Expect(1, 78912, '\P{Blk=egyptianhieroglyphformatcontrols}', "");
    Expect(0, 78912, '\P{^Blk=egyptianhieroglyphformatcontrols}', "");
    Expect(1, 78911, '\p{Blk=:\Aegyptianhieroglyphformatcontrols\z:}', "");;
    Expect(0, 78912, '\p{Blk=:\Aegyptianhieroglyphformatcontrols\z:}', "");;
    Expect(1, 78911, '\p{Blk=_EGYPTIAN_Hieroglyph_format_controls}', "");
    Expect(0, 78911, '\p{^Blk=_EGYPTIAN_Hieroglyph_format_controls}', "");
    Expect(0, 78911, '\P{Blk=_EGYPTIAN_Hieroglyph_format_controls}', "");
    Expect(1, 78911, '\P{^Blk=_EGYPTIAN_Hieroglyph_format_controls}', "");
    Expect(0, 78912, '\p{Blk=_EGYPTIAN_Hieroglyph_format_controls}', "");
    Expect(1, 78912, '\p{^Blk=_EGYPTIAN_Hieroglyph_format_controls}', "");
    Expect(1, 78912, '\P{Blk=_EGYPTIAN_Hieroglyph_format_controls}', "");
    Expect(0, 78912, '\P{^Blk=_EGYPTIAN_Hieroglyph_format_controls}', "");
    Error('\p{Is_Block=	_Egyptian_Hieroglyph_Format_controls/a/}');
    Error('\P{Is_Block=	_Egyptian_Hieroglyph_Format_controls/a/}');
    Expect(1, 78911, '\p{Is_Block=egyptianhieroglyphformatcontrols}', "");
    Expect(0, 78911, '\p{^Is_Block=egyptianhieroglyphformatcontrols}', "");
    Expect(0, 78911, '\P{Is_Block=egyptianhieroglyphformatcontrols}', "");
    Expect(1, 78911, '\P{^Is_Block=egyptianhieroglyphformatcontrols}', "");
    Expect(0, 78912, '\p{Is_Block=egyptianhieroglyphformatcontrols}', "");
    Expect(1, 78912, '\p{^Is_Block=egyptianhieroglyphformatcontrols}', "");
    Expect(1, 78912, '\P{Is_Block=egyptianhieroglyphformatcontrols}', "");
    Expect(0, 78912, '\P{^Is_Block=egyptianhieroglyphformatcontrols}', "");
    Expect(1, 78911, '\p{Is_Block:		egyptian_hieroglyph_Format_controls}', "");
    Expect(0, 78911, '\p{^Is_Block:		egyptian_hieroglyph_Format_controls}', "");
    Expect(0, 78911, '\P{Is_Block:		egyptian_hieroglyph_Format_controls}', "");
    Expect(1, 78911, '\P{^Is_Block:		egyptian_hieroglyph_Format_controls}', "");
    Expect(0, 78912, '\p{Is_Block:		egyptian_hieroglyph_Format_controls}', "");
    Expect(1, 78912, '\p{^Is_Block:		egyptian_hieroglyph_Format_controls}', "");
    Expect(1, 78912, '\P{Is_Block:		egyptian_hieroglyph_Format_controls}', "");
    Expect(0, 78912, '\P{^Is_Block:		egyptian_hieroglyph_Format_controls}', "");
    Error('\p{Is_Blk=	:=Egyptian_hieroglyph_format_Controls}');
    Error('\P{Is_Blk=	:=Egyptian_hieroglyph_format_Controls}');
    Expect(1, 78911, '\p{Is_Blk:	egyptianhieroglyphformatcontrols}', "");
    Expect(0, 78911, '\p{^Is_Blk:	egyptianhieroglyphformatcontrols}', "");
    Expect(0, 78911, '\P{Is_Blk:	egyptianhieroglyphformatcontrols}', "");
    Expect(1, 78911, '\P{^Is_Blk:	egyptianhieroglyphformatcontrols}', "");
    Expect(0, 78912, '\p{Is_Blk:	egyptianhieroglyphformatcontrols}', "");
    Expect(1, 78912, '\p{^Is_Blk:	egyptianhieroglyphformatcontrols}', "");
    Expect(1, 78912, '\P{Is_Blk:	egyptianhieroglyphformatcontrols}', "");
    Expect(0, 78912, '\P{^Is_Blk:	egyptianhieroglyphformatcontrols}', "");
    Expect(1, 78911, '\p{Is_Blk=  Egyptian_Hieroglyph_format_CONTROLS}', "");
    Expect(0, 78911, '\p{^Is_Blk=  Egyptian_Hieroglyph_format_CONTROLS}', "");
    Expect(0, 78911, '\P{Is_Blk=  Egyptian_Hieroglyph_format_CONTROLS}', "");
    Expect(1, 78911, '\P{^Is_Blk=  Egyptian_Hieroglyph_format_CONTROLS}', "");
    Expect(0, 78912, '\p{Is_Blk=  Egyptian_Hieroglyph_format_CONTROLS}', "");
    Expect(1, 78912, '\p{^Is_Blk=  Egyptian_Hieroglyph_format_CONTROLS}', "");
    Expect(1, 78912, '\P{Is_Blk=  Egyptian_Hieroglyph_format_CONTROLS}', "");
    Expect(0, 78912, '\P{^Is_Blk=  Egyptian_Hieroglyph_format_CONTROLS}', "");
    Error('\p{Block: 	egyptian_Hieroglyphs:=}');
    Error('\P{Block: 	egyptian_Hieroglyphs:=}');
    Expect(1, 78895, '\p{Block=:\AEgyptian_Hieroglyphs\z:}', "");;
    Expect(0, 78896, '\p{Block=:\AEgyptian_Hieroglyphs\z:}', "");;
    Expect(1, 78895, '\p{Block=egyptianhieroglyphs}', "");
    Expect(0, 78895, '\p{^Block=egyptianhieroglyphs}', "");
    Expect(0, 78895, '\P{Block=egyptianhieroglyphs}', "");
    Expect(1, 78895, '\P{^Block=egyptianhieroglyphs}', "");
    Expect(0, 78896, '\p{Block=egyptianhieroglyphs}', "");
    Expect(1, 78896, '\p{^Block=egyptianhieroglyphs}', "");
    Expect(1, 78896, '\P{Block=egyptianhieroglyphs}', "");
    Expect(0, 78896, '\P{^Block=egyptianhieroglyphs}', "");
    Expect(1, 78895, '\p{Block=:\Aegyptianhieroglyphs\z:}', "");;
    Expect(0, 78896, '\p{Block=:\Aegyptianhieroglyphs\z:}', "");;
    Expect(1, 78895, '\p{Block=	Egyptian_Hieroglyphs}', "");
    Expect(0, 78895, '\p{^Block=	Egyptian_Hieroglyphs}', "");
    Expect(0, 78895, '\P{Block=	Egyptian_Hieroglyphs}', "");
    Expect(1, 78895, '\P{^Block=	Egyptian_Hieroglyphs}', "");
    Expect(0, 78896, '\p{Block=	Egyptian_Hieroglyphs}', "");
    Expect(1, 78896, '\p{^Block=	Egyptian_Hieroglyphs}', "");
    Expect(1, 78896, '\P{Block=	Egyptian_Hieroglyphs}', "");
    Expect(0, 78896, '\P{^Block=	Egyptian_Hieroglyphs}', "");
    Error('\p{Blk=/a/--egyptian_Hieroglyphs}');
    Error('\P{Blk=/a/--egyptian_Hieroglyphs}');
    Expect(1, 78895, '\p{Blk=:\AEgyptian_Hieroglyphs\z:}', "");;
    Expect(0, 78896, '\p{Blk=:\AEgyptian_Hieroglyphs\z:}', "");;
    Expect(1, 78895, '\p{Blk=egyptianhieroglyphs}', "");
    Expect(0, 78895, '\p{^Blk=egyptianhieroglyphs}', "");
    Expect(0, 78895, '\P{Blk=egyptianhieroglyphs}', "");
    Expect(1, 78895, '\P{^Blk=egyptianhieroglyphs}', "");
    Expect(0, 78896, '\p{Blk=egyptianhieroglyphs}', "");
    Expect(1, 78896, '\p{^Blk=egyptianhieroglyphs}', "");
    Expect(1, 78896, '\P{Blk=egyptianhieroglyphs}', "");
    Expect(0, 78896, '\P{^Blk=egyptianhieroglyphs}', "");
    Expect(1, 78895, '\p{Blk=:\Aegyptianhieroglyphs\z:}', "");;
    Expect(0, 78896, '\p{Blk=:\Aegyptianhieroglyphs\z:}', "");;
    Expect(1, 78895, '\p{Blk= _Egyptian_hieroglyphs}', "");
    Expect(0, 78895, '\p{^Blk= _Egyptian_hieroglyphs}', "");
    Expect(0, 78895, '\P{Blk= _Egyptian_hieroglyphs}', "");
    Expect(1, 78895, '\P{^Blk= _Egyptian_hieroglyphs}', "");
    Expect(0, 78896, '\p{Blk= _Egyptian_hieroglyphs}', "");
    Expect(1, 78896, '\p{^Blk= _Egyptian_hieroglyphs}', "");
    Expect(1, 78896, '\P{Blk= _Egyptian_hieroglyphs}', "");
    Expect(0, 78896, '\P{^Blk= _Egyptian_hieroglyphs}', "");
    Error('\p{Is_Block=:=		Egyptian_HIEROGLYPHS}');
    Error('\P{Is_Block=:=		Egyptian_HIEROGLYPHS}');
    Expect(1, 78895, '\p{Is_Block=egyptianhieroglyphs}', "");
    Expect(0, 78895, '\p{^Is_Block=egyptianhieroglyphs}', "");
    Expect(0, 78895, '\P{Is_Block=egyptianhieroglyphs}', "");
    Expect(1, 78895, '\P{^Is_Block=egyptianhieroglyphs}', "");
    Expect(0, 78896, '\p{Is_Block=egyptianhieroglyphs}', "");
    Expect(1, 78896, '\p{^Is_Block=egyptianhieroglyphs}', "");
    Expect(1, 78896, '\P{Is_Block=egyptianhieroglyphs}', "");
    Expect(0, 78896, '\P{^Is_Block=egyptianhieroglyphs}', "");
    Expect(1, 78895, '\p{Is_Block=-_Egyptian_Hieroglyphs}', "");
    Expect(0, 78895, '\p{^Is_Block=-_Egyptian_Hieroglyphs}', "");
    Expect(0, 78895, '\P{Is_Block=-_Egyptian_Hieroglyphs}', "");
    Expect(1, 78895, '\P{^Is_Block=-_Egyptian_Hieroglyphs}', "");
    Expect(0, 78896, '\p{Is_Block=-_Egyptian_Hieroglyphs}', "");
    Expect(1, 78896, '\p{^Is_Block=-_Egyptian_Hieroglyphs}', "");
    Expect(1, 78896, '\P{Is_Block=-_Egyptian_Hieroglyphs}', "");
    Expect(0, 78896, '\P{^Is_Block=-_Egyptian_Hieroglyphs}', "");
    Error('\p{Is_Blk:   -Egyptian_HIEROGLYPHS/a/}');
    Error('\P{Is_Blk:   -Egyptian_HIEROGLYPHS/a/}');
    Expect(1, 78895, '\p{Is_Blk=egyptianhieroglyphs}', "");
    Expect(0, 78895, '\p{^Is_Blk=egyptianhieroglyphs}', "");
    Expect(0, 78895, '\P{Is_Blk=egyptianhieroglyphs}', "");
    Expect(1, 78895, '\P{^Is_Blk=egyptianhieroglyphs}', "");
    Expect(0, 78896, '\p{Is_Blk=egyptianhieroglyphs}', "");
    Expect(1, 78896, '\p{^Is_Blk=egyptianhieroglyphs}', "");
    Expect(1, 78896, '\P{Is_Blk=egyptianhieroglyphs}', "");
    Expect(0, 78896, '\P{^Is_Blk=egyptianhieroglyphs}', "");
    Expect(1, 78895, '\p{Is_Blk=	Egyptian_HIEROGLYPHS}', "");
    Expect(0, 78895, '\p{^Is_Blk=	Egyptian_HIEROGLYPHS}', "");
    Expect(0, 78895, '\P{Is_Blk=	Egyptian_HIEROGLYPHS}', "");
    Expect(1, 78895, '\P{^Is_Blk=	Egyptian_HIEROGLYPHS}', "");
    Expect(0, 78896, '\p{Is_Blk=	Egyptian_HIEROGLYPHS}', "");
    Expect(1, 78896, '\p{^Is_Blk=	Egyptian_HIEROGLYPHS}', "");
    Expect(1, 78896, '\P{Is_Blk=	Egyptian_HIEROGLYPHS}', "");
    Expect(0, 78896, '\P{^Is_Blk=	Egyptian_HIEROGLYPHS}', "");
    Error('\p{Block:Elbasan/a/}');
    Error('\P{Block:Elbasan/a/}');
    Expect(1, 66863, '\p{Block=:\AElbasan\z:}', "");;
    Expect(0, 66864, '\p{Block=:\AElbasan\z:}', "");;
    Expect(1, 66863, '\p{Block=elbasan}', "");
    Expect(0, 66863, '\p{^Block=elbasan}', "");
    Expect(0, 66863, '\P{Block=elbasan}', "");
    Expect(1, 66863, '\P{^Block=elbasan}', "");
    Expect(0, 66864, '\p{Block=elbasan}', "");
    Expect(1, 66864, '\p{^Block=elbasan}', "");
    Expect(1, 66864, '\P{Block=elbasan}', "");
    Expect(0, 66864, '\P{^Block=elbasan}', "");
    Expect(1, 66863, '\p{Block=:\Aelbasan\z:}', "");;
    Expect(0, 66864, '\p{Block=:\Aelbasan\z:}', "");;
    Expect(1, 66863, '\p{Block: _Elbasan}', "");
    Expect(0, 66863, '\p{^Block: _Elbasan}', "");
    Expect(0, 66863, '\P{Block: _Elbasan}', "");
    Expect(1, 66863, '\P{^Block: _Elbasan}', "");
    Expect(0, 66864, '\p{Block: _Elbasan}', "");
    Expect(1, 66864, '\p{^Block: _Elbasan}', "");
    Expect(1, 66864, '\P{Block: _Elbasan}', "");
    Expect(0, 66864, '\P{^Block: _Elbasan}', "");
    Error('\p{Blk: /a/-ELBASAN}');
    Error('\P{Blk: /a/-ELBASAN}');
    Expect(1, 66863, '\p{Blk=:\AElbasan\z:}', "");;
    Expect(0, 66864, '\p{Blk=:\AElbasan\z:}', "");;
    Expect(1, 66863, '\p{Blk=elbasan}', "");
    Expect(0, 66863, '\p{^Blk=elbasan}', "");
    Expect(0, 66863, '\P{Blk=elbasan}', "");
    Expect(1, 66863, '\P{^Blk=elbasan}', "");
    Expect(0, 66864, '\p{Blk=elbasan}', "");
    Expect(1, 66864, '\p{^Blk=elbasan}', "");
    Expect(1, 66864, '\P{Blk=elbasan}', "");
    Expect(0, 66864, '\P{^Blk=elbasan}', "");
    Expect(1, 66863, '\p{Blk=:\Aelbasan\z:}', "");;
    Expect(0, 66864, '\p{Blk=:\Aelbasan\z:}', "");;
    Expect(1, 66863, '\p{Blk= 	Elbasan}', "");
    Expect(0, 66863, '\p{^Blk= 	Elbasan}', "");
    Expect(0, 66863, '\P{Blk= 	Elbasan}', "");
    Expect(1, 66863, '\P{^Blk= 	Elbasan}', "");
    Expect(0, 66864, '\p{Blk= 	Elbasan}', "");
    Expect(1, 66864, '\p{^Blk= 	Elbasan}', "");
    Expect(1, 66864, '\P{Blk= 	Elbasan}', "");
    Expect(0, 66864, '\P{^Blk= 	Elbasan}', "");
    Error('\p{Is_Block:-/a/Elbasan}');
    Error('\P{Is_Block:-/a/Elbasan}');
    Expect(1, 66863, '\p{Is_Block=elbasan}', "");
    Expect(0, 66863, '\p{^Is_Block=elbasan}', "");
    Expect(0, 66863, '\P{Is_Block=elbasan}', "");
    Expect(1, 66863, '\P{^Is_Block=elbasan}', "");
    Expect(0, 66864, '\p{Is_Block=elbasan}', "");
    Expect(1, 66864, '\p{^Is_Block=elbasan}', "");
    Expect(1, 66864, '\P{Is_Block=elbasan}', "");
    Expect(0, 66864, '\P{^Is_Block=elbasan}', "");
    Expect(1, 66863, '\p{Is_Block= 	Elbasan}', "");
    Expect(0, 66863, '\p{^Is_Block= 	Elbasan}', "");
    Expect(0, 66863, '\P{Is_Block= 	Elbasan}', "");
    Expect(1, 66863, '\P{^Is_Block= 	Elbasan}', "");
    Expect(0, 66864, '\p{Is_Block= 	Elbasan}', "");
    Expect(1, 66864, '\p{^Is_Block= 	Elbasan}', "");
    Expect(1, 66864, '\P{Is_Block= 	Elbasan}', "");
    Expect(0, 66864, '\P{^Is_Block= 	Elbasan}', "");
    Error('\p{Is_Blk=/a/elbasan}');
    Error('\P{Is_Blk=/a/elbasan}');
    Expect(1, 66863, '\p{Is_Blk: elbasan}', "");
    Expect(0, 66863, '\p{^Is_Blk: elbasan}', "");
    Expect(0, 66863, '\P{Is_Blk: elbasan}', "");
    Expect(1, 66863, '\P{^Is_Blk: elbasan}', "");
    Expect(0, 66864, '\p{Is_Blk: elbasan}', "");
    Expect(1, 66864, '\p{^Is_Blk: elbasan}', "");
    Expect(1, 66864, '\P{Is_Blk: elbasan}', "");
    Expect(0, 66864, '\P{^Is_Blk: elbasan}', "");
    Expect(1, 66863, '\p{Is_Blk=-elbasan}', "");
    Expect(0, 66863, '\p{^Is_Blk=-elbasan}', "");
    Expect(0, 66863, '\P{Is_Blk=-elbasan}', "");
    Expect(1, 66863, '\P{^Is_Blk=-elbasan}', "");
    Expect(0, 66864, '\p{Is_Blk=-elbasan}', "");
    Expect(1, 66864, '\p{^Is_Blk=-elbasan}', "");
    Expect(1, 66864, '\P{Is_Blk=-elbasan}', "");
    Expect(0, 66864, '\P{^Is_Blk=-elbasan}', "");
    Error('\p{Block:_Elymaic:=}');
    Error('\P{Block:_Elymaic:=}');
    Expect(1, 69631, '\p{Block=:\AElymaic\z:}', "");;
    Expect(0, 69632, '\p{Block=:\AElymaic\z:}', "");;
    Expect(1, 69631, '\p{Block=elymaic}', "");
    Expect(0, 69631, '\p{^Block=elymaic}', "");
    Expect(0, 69631, '\P{Block=elymaic}', "");
    Expect(1, 69631, '\P{^Block=elymaic}', "");
    Expect(0, 69632, '\p{Block=elymaic}', "");
    Expect(1, 69632, '\p{^Block=elymaic}', "");
    Expect(1, 69632, '\P{Block=elymaic}', "");
    Expect(0, 69632, '\P{^Block=elymaic}', "");
    Expect(1, 69631, '\p{Block=:\Aelymaic\z:}', "");;
    Expect(0, 69632, '\p{Block=:\Aelymaic\z:}', "");;
    Expect(1, 69631, '\p{Block=-elymaic}', "");
    Expect(0, 69631, '\p{^Block=-elymaic}', "");
    Expect(0, 69631, '\P{Block=-elymaic}', "");
    Expect(1, 69631, '\P{^Block=-elymaic}', "");
    Expect(0, 69632, '\p{Block=-elymaic}', "");
    Expect(1, 69632, '\p{^Block=-elymaic}', "");
    Expect(1, 69632, '\P{Block=-elymaic}', "");
    Expect(0, 69632, '\P{^Block=-elymaic}', "");
    Error('\p{Blk=:=Elymaic}');
    Error('\P{Blk=:=Elymaic}');
    Expect(1, 69631, '\p{Blk=:\AElymaic\z:}', "");;
    Expect(0, 69632, '\p{Blk=:\AElymaic\z:}', "");;
    Expect(1, 69631, '\p{Blk=elymaic}', "");
    Expect(0, 69631, '\p{^Blk=elymaic}', "");
    Expect(0, 69631, '\P{Blk=elymaic}', "");
    Expect(1, 69631, '\P{^Blk=elymaic}', "");
    Expect(0, 69632, '\p{Blk=elymaic}', "");
    Expect(1, 69632, '\p{^Blk=elymaic}', "");
    Expect(1, 69632, '\P{Blk=elymaic}', "");
    Expect(0, 69632, '\P{^Blk=elymaic}', "");
    Expect(1, 69631, '\p{Blk=:\Aelymaic\z:}', "");;
    Expect(0, 69632, '\p{Blk=:\Aelymaic\z:}', "");;
    Expect(1, 69631, '\p{Blk=_-ELYMAIC}', "");
    Expect(0, 69631, '\p{^Blk=_-ELYMAIC}', "");
    Expect(0, 69631, '\P{Blk=_-ELYMAIC}', "");
    Expect(1, 69631, '\P{^Blk=_-ELYMAIC}', "");
    Expect(0, 69632, '\p{Blk=_-ELYMAIC}', "");
    Expect(1, 69632, '\p{^Blk=_-ELYMAIC}', "");
    Expect(1, 69632, '\P{Blk=_-ELYMAIC}', "");
    Expect(0, 69632, '\P{^Blk=_-ELYMAIC}', "");
    Error('\p{Is_Block=/a/_-Elymaic}');
    Error('\P{Is_Block=/a/_-Elymaic}');
    Expect(1, 69631, '\p{Is_Block:   elymaic}', "");
    Expect(0, 69631, '\p{^Is_Block:   elymaic}', "");
    Expect(0, 69631, '\P{Is_Block:   elymaic}', "");
    Expect(1, 69631, '\P{^Is_Block:   elymaic}', "");
    Expect(0, 69632, '\p{Is_Block:   elymaic}', "");
    Expect(1, 69632, '\p{^Is_Block:   elymaic}', "");
    Expect(1, 69632, '\P{Is_Block:   elymaic}', "");
    Expect(0, 69632, '\P{^Is_Block:   elymaic}', "");
    Expect(1, 69631, '\p{Is_Block=	 Elymaic}', "");
    Expect(0, 69631, '\p{^Is_Block=	 Elymaic}', "");
    Expect(0, 69631, '\P{Is_Block=	 Elymaic}', "");
    Expect(1, 69631, '\P{^Is_Block=	 Elymaic}', "");
    Expect(0, 69632, '\p{Is_Block=	 Elymaic}', "");
    Expect(1, 69632, '\p{^Is_Block=	 Elymaic}', "");
    Expect(1, 69632, '\P{Is_Block=	 Elymaic}', "");
    Expect(0, 69632, '\P{^Is_Block=	 Elymaic}', "");
    Error('\p{Is_Blk=:=	_Elymaic}');
    Error('\P{Is_Blk=:=	_Elymaic}');
    Expect(1, 69631, '\p{Is_Blk=elymaic}', "");
    Expect(0, 69631, '\p{^Is_Blk=elymaic}', "");
    Expect(0, 69631, '\P{Is_Blk=elymaic}', "");
    Expect(1, 69631, '\P{^Is_Blk=elymaic}', "");
    Expect(0, 69632, '\p{Is_Blk=elymaic}', "");
    Expect(1, 69632, '\p{^Is_Blk=elymaic}', "");
    Expect(1, 69632, '\P{Is_Blk=elymaic}', "");
    Expect(0, 69632, '\P{^Is_Blk=elymaic}', "");
    Expect(1, 69631, '\p{Is_Blk= elymaic}', "");
    Expect(0, 69631, '\p{^Is_Blk= elymaic}', "");
    Expect(0, 69631, '\P{Is_Blk= elymaic}', "");
    Expect(1, 69631, '\P{^Is_Blk= elymaic}', "");
    Expect(0, 69632, '\p{Is_Blk= elymaic}', "");
    Expect(1, 69632, '\p{^Is_Blk= elymaic}', "");
    Expect(1, 69632, '\P{Is_Blk= elymaic}', "");
    Expect(0, 69632, '\P{^Is_Blk= elymaic}', "");
    Error('\p{Block= 	emoticons/a/}');
    Error('\P{Block= 	emoticons/a/}');
    Expect(1, 128591, '\p{Block=:\AEmoticons\z:}', "");;
    Expect(0, 128592, '\p{Block=:\AEmoticons\z:}', "");;
    Expect(1, 128591, '\p{Block=emoticons}', "");
    Expect(0, 128591, '\p{^Block=emoticons}', "");
    Expect(0, 128591, '\P{Block=emoticons}', "");
    Expect(1, 128591, '\P{^Block=emoticons}', "");
    Expect(0, 128592, '\p{Block=emoticons}', "");
    Expect(1, 128592, '\p{^Block=emoticons}', "");
    Expect(1, 128592, '\P{Block=emoticons}', "");
    Expect(0, 128592, '\P{^Block=emoticons}', "");
    Expect(1, 128591, '\p{Block=:\Aemoticons\z:}', "");;
    Expect(0, 128592, '\p{Block=:\Aemoticons\z:}', "");;
    Expect(1, 128591, '\p{Block=__emoticons}', "");
    Expect(0, 128591, '\p{^Block=__emoticons}', "");
    Expect(0, 128591, '\P{Block=__emoticons}', "");
    Expect(1, 128591, '\P{^Block=__emoticons}', "");
    Expect(0, 128592, '\p{Block=__emoticons}', "");
    Expect(1, 128592, '\p{^Block=__emoticons}', "");
    Expect(1, 128592, '\P{Block=__emoticons}', "");
    Expect(0, 128592, '\P{^Block=__emoticons}', "");
    Error('\p{Blk=_Emoticons/a/}');
    Error('\P{Blk=_Emoticons/a/}');
    Expect(1, 128591, '\p{Blk=:\AEmoticons\z:}', "");;
    Expect(0, 128592, '\p{Blk=:\AEmoticons\z:}', "");;
    Expect(1, 128591, '\p{Blk=emoticons}', "");
    Expect(0, 128591, '\p{^Blk=emoticons}', "");
    Expect(0, 128591, '\P{Blk=emoticons}', "");
    Expect(1, 128591, '\P{^Blk=emoticons}', "");
    Expect(0, 128592, '\p{Blk=emoticons}', "");
    Expect(1, 128592, '\p{^Blk=emoticons}', "");
    Expect(1, 128592, '\P{Blk=emoticons}', "");
    Expect(0, 128592, '\P{^Blk=emoticons}', "");
    Expect(1, 128591, '\p{Blk=:\Aemoticons\z:}', "");;
    Expect(0, 128592, '\p{Blk=:\Aemoticons\z:}', "");;
    Expect(1, 128591, '\p{Blk= emoticons}', "");
    Expect(0, 128591, '\p{^Blk= emoticons}', "");
    Expect(0, 128591, '\P{Blk= emoticons}', "");
    Expect(1, 128591, '\P{^Blk= emoticons}', "");
    Expect(0, 128592, '\p{Blk= emoticons}', "");
    Expect(1, 128592, '\p{^Blk= emoticons}', "");
    Expect(1, 128592, '\P{Blk= emoticons}', "");
    Expect(0, 128592, '\P{^Blk= emoticons}', "");
    Error('\p{Is_Block=_/a/Emoticons}');
    Error('\P{Is_Block=_/a/Emoticons}');
    Expect(1, 128591, '\p{Is_Block=emoticons}', "");
    Expect(0, 128591, '\p{^Is_Block=emoticons}', "");
    Expect(0, 128591, '\P{Is_Block=emoticons}', "");
    Expect(1, 128591, '\P{^Is_Block=emoticons}', "");
    Expect(0, 128592, '\p{Is_Block=emoticons}', "");
    Expect(1, 128592, '\p{^Is_Block=emoticons}', "");
    Expect(1, 128592, '\P{Is_Block=emoticons}', "");
    Expect(0, 128592, '\P{^Is_Block=emoticons}', "");
    Expect(1, 128591, '\p{Is_Block=--Emoticons}', "");
    Expect(0, 128591, '\p{^Is_Block=--Emoticons}', "");
    Expect(0, 128591, '\P{Is_Block=--Emoticons}', "");
    Expect(1, 128591, '\P{^Is_Block=--Emoticons}', "");
    Expect(0, 128592, '\p{Is_Block=--Emoticons}', "");
    Expect(1, 128592, '\p{^Is_Block=--Emoticons}', "");
    Expect(1, 128592, '\P{Is_Block=--Emoticons}', "");
    Expect(0, 128592, '\P{^Is_Block=--Emoticons}', "");
    Error('\p{Is_Blk=-:=Emoticons}');
    Error('\P{Is_Blk=-:=Emoticons}');
    Expect(1, 128591, '\p{Is_Blk=emoticons}', "");
    Expect(0, 128591, '\p{^Is_Blk=emoticons}', "");
    Expect(0, 128591, '\P{Is_Blk=emoticons}', "");
    Expect(1, 128591, '\P{^Is_Blk=emoticons}', "");
    Expect(0, 128592, '\p{Is_Blk=emoticons}', "");
    Expect(1, 128592, '\p{^Is_Blk=emoticons}', "");
    Expect(1, 128592, '\P{Is_Blk=emoticons}', "");
    Expect(0, 128592, '\P{^Is_Blk=emoticons}', "");
    Expect(1, 128591, '\p{Is_Blk=		emoticons}', "");
    Expect(0, 128591, '\p{^Is_Blk=		emoticons}', "");
    Expect(0, 128591, '\P{Is_Blk=		emoticons}', "");
    Expect(1, 128591, '\P{^Is_Blk=		emoticons}', "");
    Expect(0, 128592, '\p{Is_Blk=		emoticons}', "");
    Expect(1, 128592, '\p{^Is_Blk=		emoticons}', "");
    Expect(1, 128592, '\P{Is_Blk=		emoticons}', "");
    Expect(0, 128592, '\P{^Is_Blk=		emoticons}', "");
    Error('\p{Block= 	Enclosed_ALPHANUMERICS/a/}');
    Error('\P{Block= 	Enclosed_ALPHANUMERICS/a/}');
    Expect(1, 9471, '\p{Block=:\AEnclosed_Alphanumerics\z:}', "");;
    Expect(0, 9472, '\p{Block=:\AEnclosed_Alphanumerics\z:}', "");;
    Expect(1, 9471, '\p{Block=enclosedalphanumerics}', "");
    Expect(0, 9471, '\p{^Block=enclosedalphanumerics}', "");
    Expect(0, 9471, '\P{Block=enclosedalphanumerics}', "");
    Expect(1, 9471, '\P{^Block=enclosedalphanumerics}', "");
    Expect(0, 9472, '\p{Block=enclosedalphanumerics}', "");
    Expect(1, 9472, '\p{^Block=enclosedalphanumerics}', "");
    Expect(1, 9472, '\P{Block=enclosedalphanumerics}', "");
    Expect(0, 9472, '\P{^Block=enclosedalphanumerics}', "");
    Expect(1, 9471, '\p{Block=:\Aenclosedalphanumerics\z:}', "");;
    Expect(0, 9472, '\p{Block=:\Aenclosedalphanumerics\z:}', "");;
    Expect(1, 9471, '\p{Block=	 Enclosed_ALPHANUMERICS}', "");
    Expect(0, 9471, '\p{^Block=	 Enclosed_ALPHANUMERICS}', "");
    Expect(0, 9471, '\P{Block=	 Enclosed_ALPHANUMERICS}', "");
    Expect(1, 9471, '\P{^Block=	 Enclosed_ALPHANUMERICS}', "");
    Expect(0, 9472, '\p{Block=	 Enclosed_ALPHANUMERICS}', "");
    Expect(1, 9472, '\p{^Block=	 Enclosed_ALPHANUMERICS}', "");
    Expect(1, 9472, '\P{Block=	 Enclosed_ALPHANUMERICS}', "");
    Expect(0, 9472, '\P{^Block=	 Enclosed_ALPHANUMERICS}', "");
    Error('\p{Blk=:=_Enclosed_alphanum}');
    Error('\P{Blk=:=_Enclosed_alphanum}');
    Expect(1, 9471, '\p{Blk=:\AEnclosed_Alphanum\z:}', "");;
    Expect(0, 9472, '\p{Blk=:\AEnclosed_Alphanum\z:}', "");;
    Expect(1, 9471, '\p{Blk=enclosedalphanum}', "");
    Expect(0, 9471, '\p{^Blk=enclosedalphanum}', "");
    Expect(0, 9471, '\P{Blk=enclosedalphanum}', "");
    Expect(1, 9471, '\P{^Blk=enclosedalphanum}', "");
    Expect(0, 9472, '\p{Blk=enclosedalphanum}', "");
    Expect(1, 9472, '\p{^Blk=enclosedalphanum}', "");
    Expect(1, 9472, '\P{Blk=enclosedalphanum}', "");
    Expect(0, 9472, '\P{^Blk=enclosedalphanum}', "");
    Expect(1, 9471, '\p{Blk=:\Aenclosedalphanum\z:}', "");;
    Expect(0, 9472, '\p{Blk=:\Aenclosedalphanum\z:}', "");;
    Expect(1, 9471, '\p{Blk=  enclosed_ALPHANUM}', "");
    Expect(0, 9471, '\p{^Blk=  enclosed_ALPHANUM}', "");
    Expect(0, 9471, '\P{Blk=  enclosed_ALPHANUM}', "");
    Expect(1, 9471, '\P{^Blk=  enclosed_ALPHANUM}', "");
    Expect(0, 9472, '\p{Blk=  enclosed_ALPHANUM}', "");
    Expect(1, 9472, '\p{^Blk=  enclosed_ALPHANUM}', "");
    Expect(1, 9472, '\P{Blk=  enclosed_ALPHANUM}', "");
    Expect(0, 9472, '\P{^Blk=  enclosed_ALPHANUM}', "");
    Error('\p{Is_Block=-:=Enclosed_alphanumerics}');
    Error('\P{Is_Block=-:=Enclosed_alphanumerics}');
    Expect(1, 9471, '\p{Is_Block: enclosedalphanumerics}', "");
    Expect(0, 9471, '\p{^Is_Block: enclosedalphanumerics}', "");
    Expect(0, 9471, '\P{Is_Block: enclosedalphanumerics}', "");
    Expect(1, 9471, '\P{^Is_Block: enclosedalphanumerics}', "");
    Expect(0, 9472, '\p{Is_Block: enclosedalphanumerics}', "");
    Expect(1, 9472, '\p{^Is_Block: enclosedalphanumerics}', "");
    Expect(1, 9472, '\P{Is_Block: enclosedalphanumerics}', "");
    Expect(0, 9472, '\P{^Is_Block: enclosedalphanumerics}', "");
    Expect(1, 9471, '\p{Is_Block=_	Enclosed_alphanumerics}', "");
    Expect(0, 9471, '\p{^Is_Block=_	Enclosed_alphanumerics}', "");
    Expect(0, 9471, '\P{Is_Block=_	Enclosed_alphanumerics}', "");
    Expect(1, 9471, '\P{^Is_Block=_	Enclosed_alphanumerics}', "");
    Expect(0, 9472, '\p{Is_Block=_	Enclosed_alphanumerics}', "");
    Expect(1, 9472, '\p{^Is_Block=_	Enclosed_alphanumerics}', "");
    Expect(1, 9472, '\P{Is_Block=_	Enclosed_alphanumerics}', "");
    Expect(0, 9472, '\P{^Is_Block=_	Enclosed_alphanumerics}', "");
    Error('\p{Is_Blk=/a/-Enclosed_ALPHANUM}');
    Error('\P{Is_Blk=/a/-Enclosed_ALPHANUM}');
    Expect(1, 9471, '\p{Is_Blk=enclosedalphanum}', "");
    Expect(0, 9471, '\p{^Is_Blk=enclosedalphanum}', "");
    Expect(0, 9471, '\P{Is_Blk=enclosedalphanum}', "");
    Expect(1, 9471, '\P{^Is_Blk=enclosedalphanum}', "");
    Expect(0, 9472, '\p{Is_Blk=enclosedalphanum}', "");
    Expect(1, 9472, '\p{^Is_Blk=enclosedalphanum}', "");
    Expect(1, 9472, '\P{Is_Blk=enclosedalphanum}', "");
    Expect(0, 9472, '\P{^Is_Blk=enclosedalphanum}', "");
    Expect(1, 9471, '\p{Is_Blk=	Enclosed_Alphanum}', "");
    Expect(0, 9471, '\p{^Is_Blk=	Enclosed_Alphanum}', "");
    Expect(0, 9471, '\P{Is_Blk=	Enclosed_Alphanum}', "");
    Expect(1, 9471, '\P{^Is_Blk=	Enclosed_Alphanum}', "");
    Expect(0, 9472, '\p{Is_Blk=	Enclosed_Alphanum}', "");
    Expect(1, 9472, '\p{^Is_Blk=	Enclosed_Alphanum}', "");
    Expect(1, 9472, '\P{Is_Blk=	Enclosed_Alphanum}', "");
    Expect(0, 9472, '\P{^Is_Blk=	Enclosed_Alphanum}', "");
    Error('\p{Block=:= -ENCLOSED_Alphanumeric_SUPPLEMENT}');
    Error('\P{Block=:= -ENCLOSED_Alphanumeric_SUPPLEMENT}');
    Expect(1, 127487, '\p{Block=:\AEnclosed_Alphanumeric_Supplement\z:}', "");;
    Expect(0, 127488, '\p{Block=:\AEnclosed_Alphanumeric_Supplement\z:}', "");;
    Expect(1, 127487, '\p{Block=enclosedalphanumericsupplement}', "");
    Expect(0, 127487, '\p{^Block=enclosedalphanumericsupplement}', "");
    Expect(0, 127487, '\P{Block=enclosedalphanumericsupplement}', "");
    Expect(1, 127487, '\P{^Block=enclosedalphanumericsupplement}', "");
    Expect(0, 127488, '\p{Block=enclosedalphanumericsupplement}', "");
    Expect(1, 127488, '\p{^Block=enclosedalphanumericsupplement}', "");
    Expect(1, 127488, '\P{Block=enclosedalphanumericsupplement}', "");
    Expect(0, 127488, '\P{^Block=enclosedalphanumericsupplement}', "");
    Expect(1, 127487, '\p{Block=:\Aenclosedalphanumericsupplement\z:}', "");;
    Expect(0, 127488, '\p{Block=:\Aenclosedalphanumericsupplement\z:}', "");;
    Expect(1, 127487, '\p{Block=	 Enclosed_Alphanumeric_Supplement}', "");
    Expect(0, 127487, '\p{^Block=	 Enclosed_Alphanumeric_Supplement}', "");
    Expect(0, 127487, '\P{Block=	 Enclosed_Alphanumeric_Supplement}', "");
    Expect(1, 127487, '\P{^Block=	 Enclosed_Alphanumeric_Supplement}', "");
    Expect(0, 127488, '\p{Block=	 Enclosed_Alphanumeric_Supplement}', "");
    Expect(1, 127488, '\p{^Block=	 Enclosed_Alphanumeric_Supplement}', "");
    Expect(1, 127488, '\P{Block=	 Enclosed_Alphanumeric_Supplement}', "");
    Expect(0, 127488, '\P{^Block=	 Enclosed_Alphanumeric_Supplement}', "");
    Error('\p{Blk=:=_-ENCLOSED_Alphanum_Sup}');
    Error('\P{Blk=:=_-ENCLOSED_Alphanum_Sup}');
    Expect(1, 127487, '\p{Blk=:\AEnclosed_Alphanum_Sup\z:}', "");;
    Expect(0, 127488, '\p{Blk=:\AEnclosed_Alphanum_Sup\z:}', "");;
    Expect(1, 127487, '\p{Blk:   enclosedalphanumsup}', "");
    Expect(0, 127487, '\p{^Blk:   enclosedalphanumsup}', "");
    Expect(0, 127487, '\P{Blk:   enclosedalphanumsup}', "");
    Expect(1, 127487, '\P{^Blk:   enclosedalphanumsup}', "");
    Expect(0, 127488, '\p{Blk:   enclosedalphanumsup}', "");
    Expect(1, 127488, '\p{^Blk:   enclosedalphanumsup}', "");
    Expect(1, 127488, '\P{Blk:   enclosedalphanumsup}', "");
    Expect(0, 127488, '\P{^Blk:   enclosedalphanumsup}', "");
    Expect(1, 127487, '\p{Blk=:\Aenclosedalphanumsup\z:}', "");;
    Expect(0, 127488, '\p{Blk=:\Aenclosedalphanumsup\z:}', "");;
    Expect(1, 127487, '\p{Blk=-	enclosed_Alphanum_Sup}', "");
    Expect(0, 127487, '\p{^Blk=-	enclosed_Alphanum_Sup}', "");
    Expect(0, 127487, '\P{Blk=-	enclosed_Alphanum_Sup}', "");
    Expect(1, 127487, '\P{^Blk=-	enclosed_Alphanum_Sup}', "");
    Expect(0, 127488, '\p{Blk=-	enclosed_Alphanum_Sup}', "");
    Expect(1, 127488, '\p{^Blk=-	enclosed_Alphanum_Sup}', "");
    Expect(1, 127488, '\P{Blk=-	enclosed_Alphanum_Sup}', "");
    Expect(0, 127488, '\P{^Blk=-	enclosed_Alphanum_Sup}', "");
    Error('\p{Is_Block=/a/ENCLOSED_Alphanumeric_SUPPLEMENT}');
    Error('\P{Is_Block=/a/ENCLOSED_Alphanumeric_SUPPLEMENT}');
    Expect(1, 127487, '\p{Is_Block=enclosedalphanumericsupplement}', "");
    Expect(0, 127487, '\p{^Is_Block=enclosedalphanumericsupplement}', "");
    Expect(0, 127487, '\P{Is_Block=enclosedalphanumericsupplement}', "");
    Expect(1, 127487, '\P{^Is_Block=enclosedalphanumericsupplement}', "");
    Expect(0, 127488, '\p{Is_Block=enclosedalphanumericsupplement}', "");
    Expect(1, 127488, '\p{^Is_Block=enclosedalphanumericsupplement}', "");
    Expect(1, 127488, '\P{Is_Block=enclosedalphanumericsupplement}', "");
    Expect(0, 127488, '\P{^Is_Block=enclosedalphanumericsupplement}', "");
    Expect(1, 127487, '\p{Is_Block= -Enclosed_alphanumeric_SUPPLEMENT}', "");
    Expect(0, 127487, '\p{^Is_Block= -Enclosed_alphanumeric_SUPPLEMENT}', "");
    Expect(0, 127487, '\P{Is_Block= -Enclosed_alphanumeric_SUPPLEMENT}', "");
    Expect(1, 127487, '\P{^Is_Block= -Enclosed_alphanumeric_SUPPLEMENT}', "");
    Expect(0, 127488, '\p{Is_Block= -Enclosed_alphanumeric_SUPPLEMENT}', "");
    Expect(1, 127488, '\p{^Is_Block= -Enclosed_alphanumeric_SUPPLEMENT}', "");
    Expect(1, 127488, '\P{Is_Block= -Enclosed_alphanumeric_SUPPLEMENT}', "");
    Expect(0, 127488, '\P{^Is_Block= -Enclosed_alphanumeric_SUPPLEMENT}', "");
    Error('\p{Is_Blk=	/a/Enclosed_Alphanum_Sup}');
    Error('\P{Is_Blk=	/a/Enclosed_Alphanum_Sup}');
    Expect(1, 127487, '\p{Is_Blk=enclosedalphanumsup}', "");
    Expect(0, 127487, '\p{^Is_Blk=enclosedalphanumsup}', "");
    Expect(0, 127487, '\P{Is_Blk=enclosedalphanumsup}', "");
    Expect(1, 127487, '\P{^Is_Blk=enclosedalphanumsup}', "");
    Expect(0, 127488, '\p{Is_Blk=enclosedalphanumsup}', "");
    Expect(1, 127488, '\p{^Is_Blk=enclosedalphanumsup}', "");
    Expect(1, 127488, '\P{Is_Blk=enclosedalphanumsup}', "");
    Expect(0, 127488, '\P{^Is_Blk=enclosedalphanumsup}', "");
    Expect(1, 127487, '\p{Is_Blk=_enclosed_Alphanum_Sup}', "");
    Expect(0, 127487, '\p{^Is_Blk=_enclosed_Alphanum_Sup}', "");
    Expect(0, 127487, '\P{Is_Blk=_enclosed_Alphanum_Sup}', "");
    Expect(1, 127487, '\P{^Is_Blk=_enclosed_Alphanum_Sup}', "");
    Expect(0, 127488, '\p{Is_Blk=_enclosed_Alphanum_Sup}', "");
    Expect(1, 127488, '\p{^Is_Blk=_enclosed_Alphanum_Sup}', "");
    Expect(1, 127488, '\P{Is_Blk=_enclosed_Alphanum_Sup}', "");
    Expect(0, 127488, '\P{^Is_Blk=_enclosed_Alphanum_Sup}', "");
    Error('\p{Block= :=enclosed_CJK_Letters_and_MONTHS}');
    Error('\P{Block= :=enclosed_CJK_Letters_and_MONTHS}');
    Expect(1, 13055, '\p{Block=:\AEnclosed_CJK_Letters_And_Months\z:}', "");;
    Expect(0, 13056, '\p{Block=:\AEnclosed_CJK_Letters_And_Months\z:}', "");;
    Expect(1, 13055, '\p{Block:   enclosedcjklettersandmonths}', "");
    Expect(0, 13055, '\p{^Block:   enclosedcjklettersandmonths}', "");
    Expect(0, 13055, '\P{Block:   enclosedcjklettersandmonths}', "");
    Expect(1, 13055, '\P{^Block:   enclosedcjklettersandmonths}', "");
    Expect(0, 13056, '\p{Block:   enclosedcjklettersandmonths}', "");
    Expect(1, 13056, '\p{^Block:   enclosedcjklettersandmonths}', "");
    Expect(1, 13056, '\P{Block:   enclosedcjklettersandmonths}', "");
    Expect(0, 13056, '\P{^Block:   enclosedcjklettersandmonths}', "");
    Expect(1, 13055, '\p{Block=:\Aenclosedcjklettersandmonths\z:}', "");;
    Expect(0, 13056, '\p{Block=:\Aenclosedcjklettersandmonths\z:}', "");;
    Expect(1, 13055, '\p{Block=	-Enclosed_CJK_Letters_AND_Months}', "");
    Expect(0, 13055, '\p{^Block=	-Enclosed_CJK_Letters_AND_Months}', "");
    Expect(0, 13055, '\P{Block=	-Enclosed_CJK_Letters_AND_Months}', "");
    Expect(1, 13055, '\P{^Block=	-Enclosed_CJK_Letters_AND_Months}', "");
    Expect(0, 13056, '\p{Block=	-Enclosed_CJK_Letters_AND_Months}', "");
    Expect(1, 13056, '\p{^Block=	-Enclosed_CJK_Letters_AND_Months}', "");
    Expect(1, 13056, '\P{Block=	-Enclosed_CJK_Letters_AND_Months}', "");
    Expect(0, 13056, '\P{^Block=	-Enclosed_CJK_Letters_AND_Months}', "");
    Error('\p{Blk=/a/ Enclosed_CJK}');
    Error('\P{Blk=/a/ Enclosed_CJK}');
    Expect(1, 13055, '\p{Blk=:\AEnclosed_CJK\z:}', "");;
    Expect(0, 13056, '\p{Blk=:\AEnclosed_CJK\z:}', "");;
    Expect(1, 13055, '\p{Blk=enclosedcjk}', "");
    Expect(0, 13055, '\p{^Blk=enclosedcjk}', "");
    Expect(0, 13055, '\P{Blk=enclosedcjk}', "");
    Expect(1, 13055, '\P{^Blk=enclosedcjk}', "");
    Expect(0, 13056, '\p{Blk=enclosedcjk}', "");
    Expect(1, 13056, '\p{^Blk=enclosedcjk}', "");
    Expect(1, 13056, '\P{Blk=enclosedcjk}', "");
    Expect(0, 13056, '\P{^Blk=enclosedcjk}', "");
    Expect(1, 13055, '\p{Blk=:\Aenclosedcjk\z:}', "");;
    Expect(0, 13056, '\p{Blk=:\Aenclosedcjk\z:}', "");;
    Expect(1, 13055, '\p{Blk=__Enclosed_CJK}', "");
    Expect(0, 13055, '\p{^Blk=__Enclosed_CJK}', "");
    Expect(0, 13055, '\P{Blk=__Enclosed_CJK}', "");
    Expect(1, 13055, '\P{^Blk=__Enclosed_CJK}', "");
    Expect(0, 13056, '\p{Blk=__Enclosed_CJK}', "");
    Expect(1, 13056, '\p{^Blk=__Enclosed_CJK}', "");
    Expect(1, 13056, '\P{Blk=__Enclosed_CJK}', "");
    Expect(0, 13056, '\P{^Blk=__Enclosed_CJK}', "");
    Error('\p{Is_Block=/a/ENCLOSED_CJK_letters_And_MONTHS}');
    Error('\P{Is_Block=/a/ENCLOSED_CJK_letters_And_MONTHS}');
    Expect(1, 13055, '\p{Is_Block=enclosedcjklettersandmonths}', "");
    Expect(0, 13055, '\p{^Is_Block=enclosedcjklettersandmonths}', "");
    Expect(0, 13055, '\P{Is_Block=enclosedcjklettersandmonths}', "");
    Expect(1, 13055, '\P{^Is_Block=enclosedcjklettersandmonths}', "");
    Expect(0, 13056, '\p{Is_Block=enclosedcjklettersandmonths}', "");
    Expect(1, 13056, '\p{^Is_Block=enclosedcjklettersandmonths}', "");
    Expect(1, 13056, '\P{Is_Block=enclosedcjklettersandmonths}', "");
    Expect(0, 13056, '\P{^Is_Block=enclosedcjklettersandmonths}', "");
    Expect(1, 13055, '\p{Is_Block:     Enclosed_CJK_letters_and_Months}', "");
    Expect(0, 13055, '\p{^Is_Block:     Enclosed_CJK_letters_and_Months}', "");
    Expect(0, 13055, '\P{Is_Block:     Enclosed_CJK_letters_and_Months}', "");
    Expect(1, 13055, '\P{^Is_Block:     Enclosed_CJK_letters_and_Months}', "");
    Expect(0, 13056, '\p{Is_Block:     Enclosed_CJK_letters_and_Months}', "");
    Expect(1, 13056, '\p{^Is_Block:     Enclosed_CJK_letters_and_Months}', "");
    Expect(1, 13056, '\P{Is_Block:     Enclosed_CJK_letters_and_Months}', "");
    Expect(0, 13056, '\P{^Is_Block:     Enclosed_CJK_letters_and_Months}', "");
    Error('\p{Is_Blk:-ENCLOSED_CJK/a/}');
    Error('\P{Is_Blk:-ENCLOSED_CJK/a/}');
    Expect(1, 13055, '\p{Is_Blk=enclosedcjk}', "");
    Expect(0, 13055, '\p{^Is_Blk=enclosedcjk}', "");
    Expect(0, 13055, '\P{Is_Blk=enclosedcjk}', "");
    Expect(1, 13055, '\P{^Is_Blk=enclosedcjk}', "");
    Expect(0, 13056, '\p{Is_Blk=enclosedcjk}', "");
    Expect(1, 13056, '\p{^Is_Blk=enclosedcjk}', "");
    Expect(1, 13056, '\P{Is_Blk=enclosedcjk}', "");
    Expect(0, 13056, '\P{^Is_Blk=enclosedcjk}', "");
    Expect(1, 13055, '\p{Is_Blk: _ENCLOSED_CJK}', "");
    Expect(0, 13055, '\p{^Is_Blk: _ENCLOSED_CJK}', "");
    Expect(0, 13055, '\P{Is_Blk: _ENCLOSED_CJK}', "");
    Expect(1, 13055, '\P{^Is_Blk: _ENCLOSED_CJK}', "");
    Expect(0, 13056, '\p{Is_Blk: _ENCLOSED_CJK}', "");
    Expect(1, 13056, '\p{^Is_Blk: _ENCLOSED_CJK}', "");
    Expect(1, 13056, '\P{Is_Blk: _ENCLOSED_CJK}', "");
    Expect(0, 13056, '\P{^Is_Blk: _ENCLOSED_CJK}', "");
    Error('\p{Block=:=_ENCLOSED_Ideographic_supplement}');
    Error('\P{Block=:=_ENCLOSED_Ideographic_supplement}');
    Expect(1, 127743, '\p{Block=:\AEnclosed_Ideographic_Supplement\z:}', "");;
    Expect(0, 127744, '\p{Block=:\AEnclosed_Ideographic_Supplement\z:}', "");;
    Expect(1, 127743, '\p{Block=enclosedideographicsupplement}', "");
    Expect(0, 127743, '\p{^Block=enclosedideographicsupplement}', "");
    Expect(0, 127743, '\P{Block=enclosedideographicsupplement}', "");
    Expect(1, 127743, '\P{^Block=enclosedideographicsupplement}', "");
    Expect(0, 127744, '\p{Block=enclosedideographicsupplement}', "");
    Expect(1, 127744, '\p{^Block=enclosedideographicsupplement}', "");
    Expect(1, 127744, '\P{Block=enclosedideographicsupplement}', "");
    Expect(0, 127744, '\P{^Block=enclosedideographicsupplement}', "");
    Expect(1, 127743, '\p{Block=:\Aenclosedideographicsupplement\z:}', "");;
    Expect(0, 127744, '\p{Block=:\Aenclosedideographicsupplement\z:}', "");;
    Expect(1, 127743, '\p{Block=--Enclosed_ideographic_Supplement}', "");
    Expect(0, 127743, '\p{^Block=--Enclosed_ideographic_Supplement}', "");
    Expect(0, 127743, '\P{Block=--Enclosed_ideographic_Supplement}', "");
    Expect(1, 127743, '\P{^Block=--Enclosed_ideographic_Supplement}', "");
    Expect(0, 127744, '\p{Block=--Enclosed_ideographic_Supplement}', "");
    Expect(1, 127744, '\p{^Block=--Enclosed_ideographic_Supplement}', "");
    Expect(1, 127744, '\P{Block=--Enclosed_ideographic_Supplement}', "");
    Expect(0, 127744, '\P{^Block=--Enclosed_ideographic_Supplement}', "");
    Error('\p{Blk:   /a/-	Enclosed_Ideographic_sup}');
    Error('\P{Blk:   /a/-	Enclosed_Ideographic_sup}');
    Expect(1, 127743, '\p{Blk=:\AEnclosed_Ideographic_Sup\z:}', "");;
    Expect(0, 127744, '\p{Blk=:\AEnclosed_Ideographic_Sup\z:}', "");;
    Expect(1, 127743, '\p{Blk=enclosedideographicsup}', "");
    Expect(0, 127743, '\p{^Blk=enclosedideographicsup}', "");
    Expect(0, 127743, '\P{Blk=enclosedideographicsup}', "");
    Expect(1, 127743, '\P{^Blk=enclosedideographicsup}', "");
    Expect(0, 127744, '\p{Blk=enclosedideographicsup}', "");
    Expect(1, 127744, '\p{^Blk=enclosedideographicsup}', "");
    Expect(1, 127744, '\P{Blk=enclosedideographicsup}', "");
    Expect(0, 127744, '\P{^Blk=enclosedideographicsup}', "");
    Expect(1, 127743, '\p{Blk=:\Aenclosedideographicsup\z:}', "");;
    Expect(0, 127744, '\p{Blk=:\Aenclosedideographicsup\z:}', "");;
    Expect(1, 127743, '\p{Blk=	-Enclosed_Ideographic_Sup}', "");
    Expect(0, 127743, '\p{^Blk=	-Enclosed_Ideographic_Sup}', "");
    Expect(0, 127743, '\P{Blk=	-Enclosed_Ideographic_Sup}', "");
    Expect(1, 127743, '\P{^Blk=	-Enclosed_Ideographic_Sup}', "");
    Expect(0, 127744, '\p{Blk=	-Enclosed_Ideographic_Sup}', "");
    Expect(1, 127744, '\p{^Blk=	-Enclosed_Ideographic_Sup}', "");
    Expect(1, 127744, '\P{Blk=	-Enclosed_Ideographic_Sup}', "");
    Expect(0, 127744, '\P{^Blk=	-Enclosed_Ideographic_Sup}', "");
    Error('\p{Is_Block: :=	enclosed_Ideographic_Supplement}');
    Error('\P{Is_Block: :=	enclosed_Ideographic_Supplement}');
    Expect(1, 127743, '\p{Is_Block=enclosedideographicsupplement}', "");
    Expect(0, 127743, '\p{^Is_Block=enclosedideographicsupplement}', "");
    Expect(0, 127743, '\P{Is_Block=enclosedideographicsupplement}', "");
    Expect(1, 127743, '\P{^Is_Block=enclosedideographicsupplement}', "");
    Expect(0, 127744, '\p{Is_Block=enclosedideographicsupplement}', "");
    Expect(1, 127744, '\p{^Is_Block=enclosedideographicsupplement}', "");
    Expect(1, 127744, '\P{Is_Block=enclosedideographicsupplement}', "");
    Expect(0, 127744, '\P{^Is_Block=enclosedideographicsupplement}', "");
    Expect(1, 127743, '\p{Is_Block= Enclosed_Ideographic_SUPPLEMENT}', "");
    Expect(0, 127743, '\p{^Is_Block= Enclosed_Ideographic_SUPPLEMENT}', "");
    Expect(0, 127743, '\P{Is_Block= Enclosed_Ideographic_SUPPLEMENT}', "");
    Expect(1, 127743, '\P{^Is_Block= Enclosed_Ideographic_SUPPLEMENT}', "");
    Expect(0, 127744, '\p{Is_Block= Enclosed_Ideographic_SUPPLEMENT}', "");
    Expect(1, 127744, '\p{^Is_Block= Enclosed_Ideographic_SUPPLEMENT}', "");
    Expect(1, 127744, '\P{Is_Block= Enclosed_Ideographic_SUPPLEMENT}', "");
    Expect(0, 127744, '\P{^Is_Block= Enclosed_Ideographic_SUPPLEMENT}', "");
    Error('\p{Is_Blk:   -/a/ENCLOSED_IDEOGRAPHIC_Sup}');
    Error('\P{Is_Blk:   -/a/ENCLOSED_IDEOGRAPHIC_Sup}');
    Expect(1, 127743, '\p{Is_Blk=enclosedideographicsup}', "");
    Expect(0, 127743, '\p{^Is_Blk=enclosedideographicsup}', "");
    Expect(0, 127743, '\P{Is_Blk=enclosedideographicsup}', "");
    Expect(1, 127743, '\P{^Is_Blk=enclosedideographicsup}', "");
    Expect(0, 127744, '\p{Is_Blk=enclosedideographicsup}', "");
    Expect(1, 127744, '\p{^Is_Blk=enclosedideographicsup}', "");
    Expect(1, 127744, '\P{Is_Blk=enclosedideographicsup}', "");
    Expect(0, 127744, '\P{^Is_Blk=enclosedideographicsup}', "");
    Expect(1, 127743, '\p{Is_Blk=__enclosed_ideographic_Sup}', "");
    Expect(0, 127743, '\p{^Is_Blk=__enclosed_ideographic_Sup}', "");
    Expect(0, 127743, '\P{Is_Blk=__enclosed_ideographic_Sup}', "");
    Expect(1, 127743, '\P{^Is_Blk=__enclosed_ideographic_Sup}', "");
    Expect(0, 127744, '\p{Is_Blk=__enclosed_ideographic_Sup}', "");
    Expect(1, 127744, '\p{^Is_Blk=__enclosed_ideographic_Sup}', "");
    Expect(1, 127744, '\P{Is_Blk=__enclosed_ideographic_Sup}', "");
    Expect(0, 127744, '\P{^Is_Blk=__enclosed_ideographic_Sup}', "");
    Error('\p{Block=-	Ethiopic/a/}');
    Error('\P{Block=-	Ethiopic/a/}');
    Expect(1, 4991, '\p{Block=:\AEthiopic\z:}', "");;
    Expect(0, 4992, '\p{Block=:\AEthiopic\z:}', "");;
    Expect(1, 4991, '\p{Block: ethiopic}', "");
    Expect(0, 4991, '\p{^Block: ethiopic}', "");
    Expect(0, 4991, '\P{Block: ethiopic}', "");
    Expect(1, 4991, '\P{^Block: ethiopic}', "");
    Expect(0, 4992, '\p{Block: ethiopic}', "");
    Expect(1, 4992, '\p{^Block: ethiopic}', "");
    Expect(1, 4992, '\P{Block: ethiopic}', "");
    Expect(0, 4992, '\P{^Block: ethiopic}', "");
    Expect(1, 4991, '\p{Block=:\Aethiopic\z:}', "");;
    Expect(0, 4992, '\p{Block=:\Aethiopic\z:}', "");;
    Expect(1, 4991, '\p{Block=_ethiopic}', "");
    Expect(0, 4991, '\p{^Block=_ethiopic}', "");
    Expect(0, 4991, '\P{Block=_ethiopic}', "");
    Expect(1, 4991, '\P{^Block=_ethiopic}', "");
    Expect(0, 4992, '\p{Block=_ethiopic}', "");
    Expect(1, 4992, '\p{^Block=_ethiopic}', "");
    Expect(1, 4992, '\P{Block=_ethiopic}', "");
    Expect(0, 4992, '\P{^Block=_ethiopic}', "");
    Error('\p{Blk=	-Ethiopic:=}');
    Error('\P{Blk=	-Ethiopic:=}');
    Expect(1, 4991, '\p{Blk=:\AEthiopic\z:}', "");;
    Expect(0, 4992, '\p{Blk=:\AEthiopic\z:}', "");;
    Expect(1, 4991, '\p{Blk=ethiopic}', "");
    Expect(0, 4991, '\p{^Blk=ethiopic}', "");
    Expect(0, 4991, '\P{Blk=ethiopic}', "");
    Expect(1, 4991, '\P{^Blk=ethiopic}', "");
    Expect(0, 4992, '\p{Blk=ethiopic}', "");
    Expect(1, 4992, '\p{^Blk=ethiopic}', "");
    Expect(1, 4992, '\P{Blk=ethiopic}', "");
    Expect(0, 4992, '\P{^Blk=ethiopic}', "");
    Expect(1, 4991, '\p{Blk=:\Aethiopic\z:}', "");;
    Expect(0, 4992, '\p{Blk=:\Aethiopic\z:}', "");;
    Expect(1, 4991, '\p{Blk: -ETHIOPIC}', "");
    Expect(0, 4991, '\p{^Blk: -ETHIOPIC}', "");
    Expect(0, 4991, '\P{Blk: -ETHIOPIC}', "");
    Expect(1, 4991, '\P{^Blk: -ETHIOPIC}', "");
    Expect(0, 4992, '\p{Blk: -ETHIOPIC}', "");
    Expect(1, 4992, '\p{^Blk: -ETHIOPIC}', "");
    Expect(1, 4992, '\P{Blk: -ETHIOPIC}', "");
    Expect(0, 4992, '\P{^Blk: -ETHIOPIC}', "");
    Error('\p{Is_Block=	/a/Ethiopic}');
    Error('\P{Is_Block=	/a/Ethiopic}');
    Expect(1, 4991, '\p{Is_Block=ethiopic}', "");
    Expect(0, 4991, '\p{^Is_Block=ethiopic}', "");
    Expect(0, 4991, '\P{Is_Block=ethiopic}', "");
    Expect(1, 4991, '\P{^Is_Block=ethiopic}', "");
    Expect(0, 4992, '\p{Is_Block=ethiopic}', "");
    Expect(1, 4992, '\p{^Is_Block=ethiopic}', "");
    Expect(1, 4992, '\P{Is_Block=ethiopic}', "");
    Expect(0, 4992, '\P{^Is_Block=ethiopic}', "");
    Expect(1, 4991, '\p{Is_Block= _ethiopic}', "");
    Expect(0, 4991, '\p{^Is_Block= _ethiopic}', "");
    Expect(0, 4991, '\P{Is_Block= _ethiopic}', "");
    Expect(1, 4991, '\P{^Is_Block= _ethiopic}', "");
    Expect(0, 4992, '\p{Is_Block= _ethiopic}', "");
    Expect(1, 4992, '\p{^Is_Block= _ethiopic}', "");
    Expect(1, 4992, '\P{Is_Block= _ethiopic}', "");
    Expect(0, 4992, '\P{^Is_Block= _ethiopic}', "");
    Error('\p{Is_Blk=:=ethiopic}');
    Error('\P{Is_Blk=:=ethiopic}');
    Expect(1, 4991, '\p{Is_Blk=ethiopic}', "");
    Expect(0, 4991, '\p{^Is_Blk=ethiopic}', "");
    Expect(0, 4991, '\P{Is_Blk=ethiopic}', "");
    Expect(1, 4991, '\P{^Is_Blk=ethiopic}', "");
    Expect(0, 4992, '\p{Is_Blk=ethiopic}', "");
    Expect(1, 4992, '\p{^Is_Blk=ethiopic}', "");
    Expect(1, 4992, '\P{Is_Blk=ethiopic}', "");
    Expect(0, 4992, '\P{^Is_Blk=ethiopic}', "");
    Expect(1, 4991, '\p{Is_Blk= ETHIOPIC}', "");
    Expect(0, 4991, '\p{^Is_Blk= ETHIOPIC}', "");
    Expect(0, 4991, '\P{Is_Blk= ETHIOPIC}', "");
    Expect(1, 4991, '\P{^Is_Blk= ETHIOPIC}', "");
    Expect(0, 4992, '\p{Is_Blk= ETHIOPIC}', "");
    Expect(1, 4992, '\p{^Is_Blk= ETHIOPIC}', "");
    Expect(1, 4992, '\P{Is_Blk= ETHIOPIC}', "");
    Expect(0, 4992, '\P{^Is_Blk= ETHIOPIC}', "");
    Error('\p{Block=/a/-ethiopic_extended}');
    Error('\P{Block=/a/-ethiopic_extended}');
    Expect(1, 11743, '\p{Block=:\AEthiopic_Extended\z:}', "");;
    Expect(0, 11744, '\p{Block=:\AEthiopic_Extended\z:}', "");;
    Expect(1, 11743, '\p{Block=ethiopicextended}', "");
    Expect(0, 11743, '\p{^Block=ethiopicextended}', "");
    Expect(0, 11743, '\P{Block=ethiopicextended}', "");
    Expect(1, 11743, '\P{^Block=ethiopicextended}', "");
    Expect(0, 11744, '\p{Block=ethiopicextended}', "");
    Expect(1, 11744, '\p{^Block=ethiopicextended}', "");
    Expect(1, 11744, '\P{Block=ethiopicextended}', "");
    Expect(0, 11744, '\P{^Block=ethiopicextended}', "");
    Expect(1, 11743, '\p{Block=:\Aethiopicextended\z:}', "");;
    Expect(0, 11744, '\p{Block=:\Aethiopicextended\z:}', "");;
    Expect(1, 11743, '\p{Block=--Ethiopic_Extended}', "");
    Expect(0, 11743, '\p{^Block=--Ethiopic_Extended}', "");
    Expect(0, 11743, '\P{Block=--Ethiopic_Extended}', "");
    Expect(1, 11743, '\P{^Block=--Ethiopic_Extended}', "");
    Expect(0, 11744, '\p{Block=--Ethiopic_Extended}', "");
    Expect(1, 11744, '\p{^Block=--Ethiopic_Extended}', "");
    Expect(1, 11744, '\P{Block=--Ethiopic_Extended}', "");
    Expect(0, 11744, '\P{^Block=--Ethiopic_Extended}', "");
    Error('\p{Blk=:=Ethiopic_EXT}');
    Error('\P{Blk=:=Ethiopic_EXT}');
    Expect(1, 11743, '\p{Blk=:\AEthiopic_Ext\z:}', "");;
    Expect(0, 11744, '\p{Blk=:\AEthiopic_Ext\z:}', "");;
    Expect(1, 11743, '\p{Blk=ethiopicext}', "");
    Expect(0, 11743, '\p{^Blk=ethiopicext}', "");
    Expect(0, 11743, '\P{Blk=ethiopicext}', "");
    Expect(1, 11743, '\P{^Blk=ethiopicext}', "");
    Expect(0, 11744, '\p{Blk=ethiopicext}', "");
    Expect(1, 11744, '\p{^Blk=ethiopicext}', "");
    Expect(1, 11744, '\P{Blk=ethiopicext}', "");
    Expect(0, 11744, '\P{^Blk=ethiopicext}', "");
    Expect(1, 11743, '\p{Blk=:\Aethiopicext\z:}', "");;
    Expect(0, 11744, '\p{Blk=:\Aethiopicext\z:}', "");;
    Expect(1, 11743, '\p{Blk:   -ETHIOPIC_EXT}', "");
    Expect(0, 11743, '\p{^Blk:   -ETHIOPIC_EXT}', "");
    Expect(0, 11743, '\P{Blk:   -ETHIOPIC_EXT}', "");
    Expect(1, 11743, '\P{^Blk:   -ETHIOPIC_EXT}', "");
    Expect(0, 11744, '\p{Blk:   -ETHIOPIC_EXT}', "");
    Expect(1, 11744, '\p{^Blk:   -ETHIOPIC_EXT}', "");
    Expect(1, 11744, '\P{Blk:   -ETHIOPIC_EXT}', "");
    Expect(0, 11744, '\P{^Blk:   -ETHIOPIC_EXT}', "");
    Error('\p{Is_Block=_-Ethiopic_EXTENDED:=}');
    Error('\P{Is_Block=_-Ethiopic_EXTENDED:=}');
    Expect(1, 11743, '\p{Is_Block:ethiopicextended}', "");
    Expect(0, 11743, '\p{^Is_Block:ethiopicextended}', "");
    Expect(0, 11743, '\P{Is_Block:ethiopicextended}', "");
    Expect(1, 11743, '\P{^Is_Block:ethiopicextended}', "");
    Expect(0, 11744, '\p{Is_Block:ethiopicextended}', "");
    Expect(1, 11744, '\p{^Is_Block:ethiopicextended}', "");
    Expect(1, 11744, '\P{Is_Block:ethiopicextended}', "");
    Expect(0, 11744, '\P{^Is_Block:ethiopicextended}', "");
    Expect(1, 11743, '\p{Is_Block=	 Ethiopic_Extended}', "");
    Expect(0, 11743, '\p{^Is_Block=	 Ethiopic_Extended}', "");
    Expect(0, 11743, '\P{Is_Block=	 Ethiopic_Extended}', "");
    Expect(1, 11743, '\P{^Is_Block=	 Ethiopic_Extended}', "");
    Expect(0, 11744, '\p{Is_Block=	 Ethiopic_Extended}', "");
    Expect(1, 11744, '\p{^Is_Block=	 Ethiopic_Extended}', "");
    Expect(1, 11744, '\P{Is_Block=	 Ethiopic_Extended}', "");
    Expect(0, 11744, '\P{^Is_Block=	 Ethiopic_Extended}', "");
    Error('\p{Is_Blk=:= Ethiopic_Ext}');
    Error('\P{Is_Blk=:= Ethiopic_Ext}');
    Expect(1, 11743, '\p{Is_Blk=ethiopicext}', "");
    Expect(0, 11743, '\p{^Is_Blk=ethiopicext}', "");
    Expect(0, 11743, '\P{Is_Blk=ethiopicext}', "");
    Expect(1, 11743, '\P{^Is_Blk=ethiopicext}', "");
    Expect(0, 11744, '\p{Is_Blk=ethiopicext}', "");
    Expect(1, 11744, '\p{^Is_Blk=ethiopicext}', "");
    Expect(1, 11744, '\P{Is_Blk=ethiopicext}', "");
    Expect(0, 11744, '\P{^Is_Blk=ethiopicext}', "");
    Expect(1, 11743, '\p{Is_Blk:_	Ethiopic_Ext}', "");
    Expect(0, 11743, '\p{^Is_Blk:_	Ethiopic_Ext}', "");
    Expect(0, 11743, '\P{Is_Blk:_	Ethiopic_Ext}', "");
    Expect(1, 11743, '\P{^Is_Blk:_	Ethiopic_Ext}', "");
    Expect(0, 11744, '\p{Is_Blk:_	Ethiopic_Ext}', "");
    Expect(1, 11744, '\p{^Is_Blk:_	Ethiopic_Ext}', "");
    Expect(1, 11744, '\P{Is_Blk:_	Ethiopic_Ext}', "");
    Expect(0, 11744, '\P{^Is_Blk:_	Ethiopic_Ext}', "");
    Error('\p{Block:   :=  Ethiopic_Extended_A}');
    Error('\P{Block:   :=  Ethiopic_Extended_A}');
    Expect(1, 43823, '\p{Block=:\AEthiopic_Extended_A\z:}', "");;
    Expect(0, 43824, '\p{Block=:\AEthiopic_Extended_A\z:}', "");;
    Expect(1, 43823, '\p{Block=ethiopicextendeda}', "");
    Expect(0, 43823, '\p{^Block=ethiopicextendeda}', "");
    Expect(0, 43823, '\P{Block=ethiopicextendeda}', "");
    Expect(1, 43823, '\P{^Block=ethiopicextendeda}', "");
    Expect(0, 43824, '\p{Block=ethiopicextendeda}', "");
    Expect(1, 43824, '\p{^Block=ethiopicextendeda}', "");
    Expect(1, 43824, '\P{Block=ethiopicextendeda}', "");
    Expect(0, 43824, '\P{^Block=ethiopicextendeda}', "");
    Expect(1, 43823, '\p{Block=:\Aethiopicextendeda\z:}', "");;
    Expect(0, 43824, '\p{Block=:\Aethiopicextendeda\z:}', "");;
    Expect(1, 43823, '\p{Block= -Ethiopic_Extended_A}', "");
    Expect(0, 43823, '\p{^Block= -Ethiopic_Extended_A}', "");
    Expect(0, 43823, '\P{Block= -Ethiopic_Extended_A}', "");
    Expect(1, 43823, '\P{^Block= -Ethiopic_Extended_A}', "");
    Expect(0, 43824, '\p{Block= -Ethiopic_Extended_A}', "");
    Expect(1, 43824, '\p{^Block= -Ethiopic_Extended_A}', "");
    Expect(1, 43824, '\P{Block= -Ethiopic_Extended_A}', "");
    Expect(0, 43824, '\P{^Block= -Ethiopic_Extended_A}', "");
    Error('\p{Blk=-:=ethiopic_Ext_A}');
    Error('\P{Blk=-:=ethiopic_Ext_A}');
    Expect(1, 43823, '\p{Blk=:\AEthiopic_Ext_A\z:}', "");;
    Expect(0, 43824, '\p{Blk=:\AEthiopic_Ext_A\z:}', "");;
    Expect(1, 43823, '\p{Blk=ethiopicexta}', "");
    Expect(0, 43823, '\p{^Blk=ethiopicexta}', "");
    Expect(0, 43823, '\P{Blk=ethiopicexta}', "");
    Expect(1, 43823, '\P{^Blk=ethiopicexta}', "");
    Expect(0, 43824, '\p{Blk=ethiopicexta}', "");
    Expect(1, 43824, '\p{^Blk=ethiopicexta}', "");
    Expect(1, 43824, '\P{Blk=ethiopicexta}', "");
    Expect(0, 43824, '\P{^Blk=ethiopicexta}', "");
    Expect(1, 43823, '\p{Blk=:\Aethiopicexta\z:}', "");;
    Expect(0, 43824, '\p{Blk=:\Aethiopicexta\z:}', "");;
    Expect(1, 43823, '\p{Blk= Ethiopic_ext_a}', "");
    Expect(0, 43823, '\p{^Blk= Ethiopic_ext_a}', "");
    Expect(0, 43823, '\P{Blk= Ethiopic_ext_a}', "");
    Expect(1, 43823, '\P{^Blk= Ethiopic_ext_a}', "");
    Expect(0, 43824, '\p{Blk= Ethiopic_ext_a}', "");
    Expect(1, 43824, '\p{^Blk= Ethiopic_ext_a}', "");
    Expect(1, 43824, '\P{Blk= Ethiopic_ext_a}', "");
    Expect(0, 43824, '\P{^Blk= Ethiopic_ext_a}', "");
    Error('\p{Is_Block=/a/ethiopic_Extended_A}');
    Error('\P{Is_Block=/a/ethiopic_Extended_A}');
    Expect(1, 43823, '\p{Is_Block=ethiopicextendeda}', "");
    Expect(0, 43823, '\p{^Is_Block=ethiopicextendeda}', "");
    Expect(0, 43823, '\P{Is_Block=ethiopicextendeda}', "");
    Expect(1, 43823, '\P{^Is_Block=ethiopicextendeda}', "");
    Expect(0, 43824, '\p{Is_Block=ethiopicextendeda}', "");
    Expect(1, 43824, '\p{^Is_Block=ethiopicextendeda}', "");
    Expect(1, 43824, '\P{Is_Block=ethiopicextendeda}', "");
    Expect(0, 43824, '\P{^Is_Block=ethiopicextendeda}', "");
    Expect(1, 43823, '\p{Is_Block=_-Ethiopic_extended_A}', "");
    Expect(0, 43823, '\p{^Is_Block=_-Ethiopic_extended_A}', "");
    Expect(0, 43823, '\P{Is_Block=_-Ethiopic_extended_A}', "");
    Expect(1, 43823, '\P{^Is_Block=_-Ethiopic_extended_A}', "");
    Expect(0, 43824, '\p{Is_Block=_-Ethiopic_extended_A}', "");
    Expect(1, 43824, '\p{^Is_Block=_-Ethiopic_extended_A}', "");
    Expect(1, 43824, '\P{Is_Block=_-Ethiopic_extended_A}', "");
    Expect(0, 43824, '\P{^Is_Block=_-Ethiopic_extended_A}', "");
    Error('\p{Is_Blk=-	ETHIOPIC_EXT_a:=}');
    Error('\P{Is_Blk=-	ETHIOPIC_EXT_a:=}');
    Expect(1, 43823, '\p{Is_Blk=ethiopicexta}', "");
    Expect(0, 43823, '\p{^Is_Blk=ethiopicexta}', "");
    Expect(0, 43823, '\P{Is_Blk=ethiopicexta}', "");
    Expect(1, 43823, '\P{^Is_Blk=ethiopicexta}', "");
    Expect(0, 43824, '\p{Is_Blk=ethiopicexta}', "");
    Expect(1, 43824, '\p{^Is_Blk=ethiopicexta}', "");
    Expect(1, 43824, '\P{Is_Blk=ethiopicexta}', "");
    Expect(0, 43824, '\P{^Is_Blk=ethiopicexta}', "");
    Expect(1, 43823, '\p{Is_Blk=	Ethiopic_EXT_A}', "");
    Expect(0, 43823, '\p{^Is_Blk=	Ethiopic_EXT_A}', "");
    Expect(0, 43823, '\P{Is_Blk=	Ethiopic_EXT_A}', "");
    Expect(1, 43823, '\P{^Is_Blk=	Ethiopic_EXT_A}', "");
    Expect(0, 43824, '\p{Is_Blk=	Ethiopic_EXT_A}', "");
    Expect(1, 43824, '\p{^Is_Blk=	Ethiopic_EXT_A}', "");
    Expect(1, 43824, '\P{Is_Blk=	Ethiopic_EXT_A}', "");
    Expect(0, 43824, '\P{^Is_Blk=	Ethiopic_EXT_A}', "");
    Error('\p{Block: /a/ Ethiopic_Supplement}');
    Error('\P{Block: /a/ Ethiopic_Supplement}');
    Expect(1, 5023, '\p{Block=:\AEthiopic_Supplement\z:}', "");;
    Expect(0, 5024, '\p{Block=:\AEthiopic_Supplement\z:}', "");;
    Expect(1, 5023, '\p{Block=ethiopicsupplement}', "");
    Expect(0, 5023, '\p{^Block=ethiopicsupplement}', "");
    Expect(0, 5023, '\P{Block=ethiopicsupplement}', "");
    Expect(1, 5023, '\P{^Block=ethiopicsupplement}', "");
    Expect(0, 5024, '\p{Block=ethiopicsupplement}', "");
    Expect(1, 5024, '\p{^Block=ethiopicsupplement}', "");
    Expect(1, 5024, '\P{Block=ethiopicsupplement}', "");
    Expect(0, 5024, '\P{^Block=ethiopicsupplement}', "");
    Expect(1, 5023, '\p{Block=:\Aethiopicsupplement\z:}', "");;
    Expect(0, 5024, '\p{Block=:\Aethiopicsupplement\z:}', "");;
    Expect(1, 5023, '\p{Block=- Ethiopic_supplement}', "");
    Expect(0, 5023, '\p{^Block=- Ethiopic_supplement}', "");
    Expect(0, 5023, '\P{Block=- Ethiopic_supplement}', "");
    Expect(1, 5023, '\P{^Block=- Ethiopic_supplement}', "");
    Expect(0, 5024, '\p{Block=- Ethiopic_supplement}', "");
    Expect(1, 5024, '\p{^Block=- Ethiopic_supplement}', "");
    Expect(1, 5024, '\P{Block=- Ethiopic_supplement}', "");
    Expect(0, 5024, '\P{^Block=- Ethiopic_supplement}', "");
    Error('\p{Blk=:=_ETHIOPIC_SUP}');
    Error('\P{Blk=:=_ETHIOPIC_SUP}');
    Expect(1, 5023, '\p{Blk=:\AEthiopic_Sup\z:}', "");;
    Expect(0, 5024, '\p{Blk=:\AEthiopic_Sup\z:}', "");;
    Expect(1, 5023, '\p{Blk=ethiopicsup}', "");
    Expect(0, 5023, '\p{^Blk=ethiopicsup}', "");
    Expect(0, 5023, '\P{Blk=ethiopicsup}', "");
    Expect(1, 5023, '\P{^Blk=ethiopicsup}', "");
    Expect(0, 5024, '\p{Blk=ethiopicsup}', "");
    Expect(1, 5024, '\p{^Blk=ethiopicsup}', "");
    Expect(1, 5024, '\P{Blk=ethiopicsup}', "");
    Expect(0, 5024, '\P{^Blk=ethiopicsup}', "");
    Expect(1, 5023, '\p{Blk=:\Aethiopicsup\z:}', "");;
    Expect(0, 5024, '\p{Blk=:\Aethiopicsup\z:}', "");;
    Expect(1, 5023, '\p{Blk=__ethiopic_Sup}', "");
    Expect(0, 5023, '\p{^Blk=__ethiopic_Sup}', "");
    Expect(0, 5023, '\P{Blk=__ethiopic_Sup}', "");
    Expect(1, 5023, '\P{^Blk=__ethiopic_Sup}', "");
    Expect(0, 5024, '\p{Blk=__ethiopic_Sup}', "");
    Expect(1, 5024, '\p{^Blk=__ethiopic_Sup}', "");
    Expect(1, 5024, '\P{Blk=__ethiopic_Sup}', "");
    Expect(0, 5024, '\P{^Blk=__ethiopic_Sup}', "");
    Error('\p{Is_Block=:= Ethiopic_Supplement}');
    Error('\P{Is_Block=:= Ethiopic_Supplement}');
    Expect(1, 5023, '\p{Is_Block=ethiopicsupplement}', "");
    Expect(0, 5023, '\p{^Is_Block=ethiopicsupplement}', "");
    Expect(0, 5023, '\P{Is_Block=ethiopicsupplement}', "");
    Expect(1, 5023, '\P{^Is_Block=ethiopicsupplement}', "");
    Expect(0, 5024, '\p{Is_Block=ethiopicsupplement}', "");
    Expect(1, 5024, '\p{^Is_Block=ethiopicsupplement}', "");
    Expect(1, 5024, '\P{Is_Block=ethiopicsupplement}', "");
    Expect(0, 5024, '\P{^Is_Block=ethiopicsupplement}', "");
    Expect(1, 5023, '\p{Is_Block= Ethiopic_Supplement}', "");
    Expect(0, 5023, '\p{^Is_Block= Ethiopic_Supplement}', "");
    Expect(0, 5023, '\P{Is_Block= Ethiopic_Supplement}', "");
    Expect(1, 5023, '\P{^Is_Block= Ethiopic_Supplement}', "");
    Expect(0, 5024, '\p{Is_Block= Ethiopic_Supplement}', "");
    Expect(1, 5024, '\p{^Is_Block= Ethiopic_Supplement}', "");
    Expect(1, 5024, '\P{Is_Block= Ethiopic_Supplement}', "");
    Expect(0, 5024, '\P{^Is_Block= Ethiopic_Supplement}', "");
    Error('\p{Is_Blk=-/a/ethiopic_Sup}');
    Error('\P{Is_Blk=-/a/ethiopic_Sup}');
    Expect(1, 5023, '\p{Is_Blk=ethiopicsup}', "");
    Expect(0, 5023, '\p{^Is_Blk=ethiopicsup}', "");
    Expect(0, 5023, '\P{Is_Blk=ethiopicsup}', "");
    Expect(1, 5023, '\P{^Is_Blk=ethiopicsup}', "");
    Expect(0, 5024, '\p{Is_Blk=ethiopicsup}', "");
    Expect(1, 5024, '\p{^Is_Blk=ethiopicsup}', "");
    Expect(1, 5024, '\P{Is_Blk=ethiopicsup}', "");
    Expect(0, 5024, '\P{^Is_Blk=ethiopicsup}', "");
    Expect(1, 5023, '\p{Is_Blk= _Ethiopic_SUP}', "");
    Expect(0, 5023, '\p{^Is_Blk= _Ethiopic_SUP}', "");
    Expect(0, 5023, '\P{Is_Blk= _Ethiopic_SUP}', "");
    Expect(1, 5023, '\P{^Is_Blk= _Ethiopic_SUP}', "");
    Expect(0, 5024, '\p{Is_Blk= _Ethiopic_SUP}', "");
    Expect(1, 5024, '\p{^Is_Blk= _Ethiopic_SUP}', "");
    Expect(1, 5024, '\P{Is_Blk= _Ethiopic_SUP}', "");
    Expect(0, 5024, '\P{^Is_Blk= _Ethiopic_SUP}', "");
    Error('\p{Block=:=_Geometric_SHAPES}');
    Error('\P{Block=:=_Geometric_SHAPES}');
    Expect(1, 9727, '\p{Block=:\AGeometric_Shapes\z:}', "");;
    Expect(0, 9728, '\p{Block=:\AGeometric_Shapes\z:}', "");;
    Expect(1, 9727, '\p{Block: geometricshapes}', "");
    Expect(0, 9727, '\p{^Block: geometricshapes}', "");
    Expect(0, 9727, '\P{Block: geometricshapes}', "");
    Expect(1, 9727, '\P{^Block: geometricshapes}', "");
    Expect(0, 9728, '\p{Block: geometricshapes}', "");
    Expect(1, 9728, '\p{^Block: geometricshapes}', "");
    Expect(1, 9728, '\P{Block: geometricshapes}', "");
    Expect(0, 9728, '\P{^Block: geometricshapes}', "");
    Expect(1, 9727, '\p{Block=:\Ageometricshapes\z:}', "");;
    Expect(0, 9728, '\p{Block=:\Ageometricshapes\z:}', "");;
    Expect(1, 9727, '\p{Block= GEOMETRIC_Shapes}', "");
    Expect(0, 9727, '\p{^Block= GEOMETRIC_Shapes}', "");
    Expect(0, 9727, '\P{Block= GEOMETRIC_Shapes}', "");
    Expect(1, 9727, '\P{^Block= GEOMETRIC_Shapes}', "");
    Expect(0, 9728, '\p{Block= GEOMETRIC_Shapes}', "");
    Expect(1, 9728, '\p{^Block= GEOMETRIC_Shapes}', "");
    Expect(1, 9728, '\P{Block= GEOMETRIC_Shapes}', "");
    Expect(0, 9728, '\P{^Block= GEOMETRIC_Shapes}', "");
    Error('\p{Blk:-:=Geometric_Shapes}');
    Error('\P{Blk:-:=Geometric_Shapes}');
    Expect(1, 9727, '\p{Blk=:\AGeometric_Shapes\z:}', "");;
    Expect(0, 9728, '\p{Blk=:\AGeometric_Shapes\z:}', "");;
    Expect(1, 9727, '\p{Blk: geometricshapes}', "");
    Expect(0, 9727, '\p{^Blk: geometricshapes}', "");
    Expect(0, 9727, '\P{Blk: geometricshapes}', "");
    Expect(1, 9727, '\P{^Blk: geometricshapes}', "");
    Expect(0, 9728, '\p{Blk: geometricshapes}', "");
    Expect(1, 9728, '\p{^Blk: geometricshapes}', "");
    Expect(1, 9728, '\P{Blk: geometricshapes}', "");
    Expect(0, 9728, '\P{^Blk: geometricshapes}', "");
    Expect(1, 9727, '\p{Blk=:\Ageometricshapes\z:}', "");;
    Expect(0, 9728, '\p{Blk=:\Ageometricshapes\z:}', "");;
    Expect(1, 9727, '\p{Blk=-Geometric_Shapes}', "");
    Expect(0, 9727, '\p{^Blk=-Geometric_Shapes}', "");
    Expect(0, 9727, '\P{Blk=-Geometric_Shapes}', "");
    Expect(1, 9727, '\P{^Blk=-Geometric_Shapes}', "");
    Expect(0, 9728, '\p{Blk=-Geometric_Shapes}', "");
    Expect(1, 9728, '\p{^Blk=-Geometric_Shapes}', "");
    Expect(1, 9728, '\P{Blk=-Geometric_Shapes}', "");
    Expect(0, 9728, '\P{^Blk=-Geometric_Shapes}', "");
    Error('\p{Is_Block= 	GEOMETRIC_shapes/a/}');
    Error('\P{Is_Block= 	GEOMETRIC_shapes/a/}');
    Expect(1, 9727, '\p{Is_Block=geometricshapes}', "");
    Expect(0, 9727, '\p{^Is_Block=geometricshapes}', "");
    Expect(0, 9727, '\P{Is_Block=geometricshapes}', "");
    Expect(1, 9727, '\P{^Is_Block=geometricshapes}', "");
    Expect(0, 9728, '\p{Is_Block=geometricshapes}', "");
    Expect(1, 9728, '\p{^Is_Block=geometricshapes}', "");
    Expect(1, 9728, '\P{Is_Block=geometricshapes}', "");
    Expect(0, 9728, '\P{^Is_Block=geometricshapes}', "");
    Expect(1, 9727, '\p{Is_Block=-Geometric_SHAPES}', "");
    Expect(0, 9727, '\p{^Is_Block=-Geometric_SHAPES}', "");
    Expect(0, 9727, '\P{Is_Block=-Geometric_SHAPES}', "");
    Expect(1, 9727, '\P{^Is_Block=-Geometric_SHAPES}', "");
    Expect(0, 9728, '\p{Is_Block=-Geometric_SHAPES}', "");
    Expect(1, 9728, '\p{^Is_Block=-Geometric_SHAPES}', "");
    Expect(1, 9728, '\P{Is_Block=-Geometric_SHAPES}', "");
    Expect(0, 9728, '\P{^Is_Block=-Geometric_SHAPES}', "");
    Error('\p{Is_Blk=/a/	Geometric_Shapes}');
    Error('\P{Is_Blk=/a/	Geometric_Shapes}');
    Expect(1, 9727, '\p{Is_Blk=geometricshapes}', "");
    Expect(0, 9727, '\p{^Is_Blk=geometricshapes}', "");
    Expect(0, 9727, '\P{Is_Blk=geometricshapes}', "");
    Expect(1, 9727, '\P{^Is_Blk=geometricshapes}', "");
    Expect(0, 9728, '\p{Is_Blk=geometricshapes}', "");
    Expect(1, 9728, '\p{^Is_Blk=geometricshapes}', "");
    Expect(1, 9728, '\P{Is_Blk=geometricshapes}', "");
    Expect(0, 9728, '\P{^Is_Blk=geometricshapes}', "");
    Expect(1, 9727, '\p{Is_Blk= _Geometric_Shapes}', "");
    Expect(0, 9727, '\p{^Is_Blk= _Geometric_Shapes}', "");
    Expect(0, 9727, '\P{Is_Blk= _Geometric_Shapes}', "");
    Expect(1, 9727, '\P{^Is_Blk= _Geometric_Shapes}', "");
    Expect(0, 9728, '\p{Is_Blk= _Geometric_Shapes}', "");
    Expect(1, 9728, '\p{^Is_Blk= _Geometric_Shapes}', "");
    Expect(1, 9728, '\P{Is_Blk= _Geometric_Shapes}', "");
    Expect(0, 9728, '\P{^Is_Blk= _Geometric_Shapes}', "");
    Error('\p{Block= -GEOMETRIC_shapes_Extended:=}');
    Error('\P{Block= -GEOMETRIC_shapes_Extended:=}');
    Expect(1, 129023, '\p{Block=:\AGeometric_Shapes_Extended\z:}', "");;
    Expect(0, 129024, '\p{Block=:\AGeometric_Shapes_Extended\z:}', "");;
    Expect(1, 129023, '\p{Block=geometricshapesextended}', "");
    Expect(0, 129023, '\p{^Block=geometricshapesextended}', "");
    Expect(0, 129023, '\P{Block=geometricshapesextended}', "");
    Expect(1, 129023, '\P{^Block=geometricshapesextended}', "");
    Expect(0, 129024, '\p{Block=geometricshapesextended}', "");
    Expect(1, 129024, '\p{^Block=geometricshapesextended}', "");
    Expect(1, 129024, '\P{Block=geometricshapesextended}', "");
    Expect(0, 129024, '\P{^Block=geometricshapesextended}', "");
    Expect(1, 129023, '\p{Block=:\Ageometricshapesextended\z:}', "");;
    Expect(0, 129024, '\p{Block=:\Ageometricshapesextended\z:}', "");;
    Expect(1, 129023, '\p{Block=_ GEOMETRIC_Shapes_Extended}', "");
    Expect(0, 129023, '\p{^Block=_ GEOMETRIC_Shapes_Extended}', "");
    Expect(0, 129023, '\P{Block=_ GEOMETRIC_Shapes_Extended}', "");
    Expect(1, 129023, '\P{^Block=_ GEOMETRIC_Shapes_Extended}', "");
    Expect(0, 129024, '\p{Block=_ GEOMETRIC_Shapes_Extended}', "");
    Expect(1, 129024, '\p{^Block=_ GEOMETRIC_Shapes_Extended}', "");
    Expect(1, 129024, '\P{Block=_ GEOMETRIC_Shapes_Extended}', "");
    Expect(0, 129024, '\P{^Block=_ GEOMETRIC_Shapes_Extended}', "");
    Error('\p{Blk=_-Geometric_shapes_Ext/a/}');
    Error('\P{Blk=_-Geometric_shapes_Ext/a/}');
    Expect(1, 129023, '\p{Blk=:\AGeometric_Shapes_Ext\z:}', "");;
    Expect(0, 129024, '\p{Blk=:\AGeometric_Shapes_Ext\z:}', "");;
    Expect(1, 129023, '\p{Blk=geometricshapesext}', "");
    Expect(0, 129023, '\p{^Blk=geometricshapesext}', "");
    Expect(0, 129023, '\P{Blk=geometricshapesext}', "");
    Expect(1, 129023, '\P{^Blk=geometricshapesext}', "");
    Expect(0, 129024, '\p{Blk=geometricshapesext}', "");
    Expect(1, 129024, '\p{^Blk=geometricshapesext}', "");
    Expect(1, 129024, '\P{Blk=geometricshapesext}', "");
    Expect(0, 129024, '\P{^Blk=geometricshapesext}', "");
    Expect(1, 129023, '\p{Blk=:\Ageometricshapesext\z:}', "");;
    Expect(0, 129024, '\p{Blk=:\Ageometricshapesext\z:}', "");;
    Expect(1, 129023, '\p{Blk=  GEOMETRIC_Shapes_Ext}', "");
    Expect(0, 129023, '\p{^Blk=  GEOMETRIC_Shapes_Ext}', "");
    Expect(0, 129023, '\P{Blk=  GEOMETRIC_Shapes_Ext}', "");
    Expect(1, 129023, '\P{^Blk=  GEOMETRIC_Shapes_Ext}', "");
    Expect(0, 129024, '\p{Blk=  GEOMETRIC_Shapes_Ext}', "");
    Expect(1, 129024, '\p{^Blk=  GEOMETRIC_Shapes_Ext}', "");
    Expect(1, 129024, '\P{Blk=  GEOMETRIC_Shapes_Ext}', "");
    Expect(0, 129024, '\P{^Blk=  GEOMETRIC_Shapes_Ext}', "");
    Error('\p{Is_Block=/a/__Geometric_Shapes_Extended}');
    Error('\P{Is_Block=/a/__Geometric_Shapes_Extended}');
    Expect(1, 129023, '\p{Is_Block: geometricshapesextended}', "");
    Expect(0, 129023, '\p{^Is_Block: geometricshapesextended}', "");
    Expect(0, 129023, '\P{Is_Block: geometricshapesextended}', "");
    Expect(1, 129023, '\P{^Is_Block: geometricshapesextended}', "");
    Expect(0, 129024, '\p{Is_Block: geometricshapesextended}', "");
    Expect(1, 129024, '\p{^Is_Block: geometricshapesextended}', "");
    Expect(1, 129024, '\P{Is_Block: geometricshapesextended}', "");
    Expect(0, 129024, '\P{^Is_Block: geometricshapesextended}', "");
    Expect(1, 129023, '\p{Is_Block: geometric_SHAPES_Extended}', "");
    Expect(0, 129023, '\p{^Is_Block: geometric_SHAPES_Extended}', "");
    Expect(0, 129023, '\P{Is_Block: geometric_SHAPES_Extended}', "");
    Expect(1, 129023, '\P{^Is_Block: geometric_SHAPES_Extended}', "");
    Expect(0, 129024, '\p{Is_Block: geometric_SHAPES_Extended}', "");
    Expect(1, 129024, '\p{^Is_Block: geometric_SHAPES_Extended}', "");
    Expect(1, 129024, '\P{Is_Block: geometric_SHAPES_Extended}', "");
    Expect(0, 129024, '\P{^Is_Block: geometric_SHAPES_Extended}', "");
    Error('\p{Is_Blk: :=-geometric_Shapes_Ext}');
    Error('\P{Is_Blk: :=-geometric_Shapes_Ext}');
    Expect(1, 129023, '\p{Is_Blk=geometricshapesext}', "");
    Expect(0, 129023, '\p{^Is_Blk=geometricshapesext}', "");
    Expect(0, 129023, '\P{Is_Blk=geometricshapesext}', "");
    Expect(1, 129023, '\P{^Is_Blk=geometricshapesext}', "");
    Expect(0, 129024, '\p{Is_Blk=geometricshapesext}', "");
    Expect(1, 129024, '\p{^Is_Blk=geometricshapesext}', "");
    Expect(1, 129024, '\P{Is_Blk=geometricshapesext}', "");
    Expect(0, 129024, '\P{^Is_Blk=geometricshapesext}', "");
    Expect(1, 129023, '\p{Is_Blk=	_Geometric_SHAPES_EXT}', "");
    Expect(0, 129023, '\p{^Is_Blk=	_Geometric_SHAPES_EXT}', "");
    Expect(0, 129023, '\P{Is_Blk=	_Geometric_SHAPES_EXT}', "");
    Expect(1, 129023, '\P{^Is_Blk=	_Geometric_SHAPES_EXT}', "");
    Expect(0, 129024, '\p{Is_Blk=	_Geometric_SHAPES_EXT}', "");
    Expect(1, 129024, '\p{^Is_Blk=	_Geometric_SHAPES_EXT}', "");
    Expect(1, 129024, '\P{Is_Blk=	_Geometric_SHAPES_EXT}', "");
    Expect(0, 129024, '\P{^Is_Blk=	_Geometric_SHAPES_EXT}', "");
    Error('\p{Block=	-georgian:=}');
    Error('\P{Block=	-georgian:=}');
    Expect(1, 4351, '\p{Block=:\AGeorgian\z:}', "");;
    Expect(0, 4352, '\p{Block=:\AGeorgian\z:}', "");;
    Expect(1, 4351, '\p{Block=georgian}', "");
    Expect(0, 4351, '\p{^Block=georgian}', "");
    Expect(0, 4351, '\P{Block=georgian}', "");
    Expect(1, 4351, '\P{^Block=georgian}', "");
    Expect(0, 4352, '\p{Block=georgian}', "");
    Expect(1, 4352, '\p{^Block=georgian}', "");
    Expect(1, 4352, '\P{Block=georgian}', "");
    Expect(0, 4352, '\P{^Block=georgian}', "");
    Expect(1, 4351, '\p{Block=:\Ageorgian\z:}', "");;
    Expect(0, 4352, '\p{Block=:\Ageorgian\z:}', "");;
    Expect(1, 4351, '\p{Block=_ Georgian}', "");
    Expect(0, 4351, '\p{^Block=_ Georgian}', "");
    Expect(0, 4351, '\P{Block=_ Georgian}', "");
    Expect(1, 4351, '\P{^Block=_ Georgian}', "");
    Expect(0, 4352, '\p{Block=_ Georgian}', "");
    Expect(1, 4352, '\p{^Block=_ Georgian}', "");
    Expect(1, 4352, '\P{Block=_ Georgian}', "");
    Expect(0, 4352, '\P{^Block=_ Georgian}', "");
    Error('\p{Blk=	-Georgian:=}');
    Error('\P{Blk=	-Georgian:=}');
    Expect(1, 4351, '\p{Blk=:\AGeorgian\z:}', "");;
    Expect(0, 4352, '\p{Blk=:\AGeorgian\z:}', "");;
    Expect(1, 4351, '\p{Blk=georgian}', "");
    Expect(0, 4351, '\p{^Blk=georgian}', "");
    Expect(0, 4351, '\P{Blk=georgian}', "");
    Expect(1, 4351, '\P{^Blk=georgian}', "");
    Expect(0, 4352, '\p{Blk=georgian}', "");
    Expect(1, 4352, '\p{^Blk=georgian}', "");
    Expect(1, 4352, '\P{Blk=georgian}', "");
    Expect(0, 4352, '\P{^Blk=georgian}', "");
    Expect(1, 4351, '\p{Blk=:\Ageorgian\z:}', "");;
    Expect(0, 4352, '\p{Blk=:\Ageorgian\z:}', "");;
    Expect(1, 4351, '\p{Blk=		Georgian}', "");
    Expect(0, 4351, '\p{^Blk=		Georgian}', "");
    Expect(0, 4351, '\P{Blk=		Georgian}', "");
    Expect(1, 4351, '\P{^Blk=		Georgian}', "");
    Expect(0, 4352, '\p{Blk=		Georgian}', "");
    Expect(1, 4352, '\p{^Blk=		Georgian}', "");
    Expect(1, 4352, '\P{Blk=		Georgian}', "");
    Expect(0, 4352, '\P{^Blk=		Georgian}', "");
    Error('\p{Is_Block=	/a/Georgian}');
    Error('\P{Is_Block=	/a/Georgian}');
    Expect(1, 4351, '\p{Is_Block=georgian}', "");
    Expect(0, 4351, '\p{^Is_Block=georgian}', "");
    Expect(0, 4351, '\P{Is_Block=georgian}', "");
    Expect(1, 4351, '\P{^Is_Block=georgian}', "");
    Expect(0, 4352, '\p{Is_Block=georgian}', "");
    Expect(1, 4352, '\p{^Is_Block=georgian}', "");
    Expect(1, 4352, '\P{Is_Block=georgian}', "");
    Expect(0, 4352, '\P{^Is_Block=georgian}', "");
    Expect(1, 4351, '\p{Is_Block=__Georgian}', "");
    Expect(0, 4351, '\p{^Is_Block=__Georgian}', "");
    Expect(0, 4351, '\P{Is_Block=__Georgian}', "");
    Expect(1, 4351, '\P{^Is_Block=__Georgian}', "");
    Expect(0, 4352, '\p{Is_Block=__Georgian}', "");
    Expect(1, 4352, '\p{^Is_Block=__Georgian}', "");
    Expect(1, 4352, '\P{Is_Block=__Georgian}', "");
    Expect(0, 4352, '\P{^Is_Block=__Georgian}', "");
    Error('\p{Is_Blk= georgian:=}');
    Error('\P{Is_Blk= georgian:=}');
    Expect(1, 4351, '\p{Is_Blk=georgian}', "");
    Expect(0, 4351, '\p{^Is_Blk=georgian}', "");
    Expect(0, 4351, '\P{Is_Blk=georgian}', "");
    Expect(1, 4351, '\P{^Is_Blk=georgian}', "");
    Expect(0, 4352, '\p{Is_Blk=georgian}', "");
    Expect(1, 4352, '\p{^Is_Blk=georgian}', "");
    Expect(1, 4352, '\P{Is_Blk=georgian}', "");
    Expect(0, 4352, '\P{^Is_Blk=georgian}', "");
    Expect(1, 4351, '\p{Is_Blk=_GEORGIAN}', "");
    Expect(0, 4351, '\p{^Is_Blk=_GEORGIAN}', "");
    Expect(0, 4351, '\P{Is_Blk=_GEORGIAN}', "");
    Expect(1, 4351, '\P{^Is_Blk=_GEORGIAN}', "");
    Expect(0, 4352, '\p{Is_Blk=_GEORGIAN}', "");
    Expect(1, 4352, '\p{^Is_Blk=_GEORGIAN}', "");
    Expect(1, 4352, '\P{Is_Blk=_GEORGIAN}', "");
    Expect(0, 4352, '\P{^Is_Blk=_GEORGIAN}', "");
    Error('\p{Block=Georgian_extended/a/}');
    Error('\P{Block=Georgian_extended/a/}');
    Expect(1, 7359, '\p{Block=:\AGeorgian_Extended\z:}', "");;
    Expect(0, 7360, '\p{Block=:\AGeorgian_Extended\z:}', "");;
    Expect(1, 7359, '\p{Block=georgianextended}', "");
    Expect(0, 7359, '\p{^Block=georgianextended}', "");
    Expect(0, 7359, '\P{Block=georgianextended}', "");
    Expect(1, 7359, '\P{^Block=georgianextended}', "");
    Expect(0, 7360, '\p{Block=georgianextended}', "");
    Expect(1, 7360, '\p{^Block=georgianextended}', "");
    Expect(1, 7360, '\P{Block=georgianextended}', "");
    Expect(0, 7360, '\P{^Block=georgianextended}', "");
    Expect(1, 7359, '\p{Block=:\Ageorgianextended\z:}', "");;
    Expect(0, 7360, '\p{Block=:\Ageorgianextended\z:}', "");;
    Expect(1, 7359, '\p{Block=	Georgian_Extended}', "");
    Expect(0, 7359, '\p{^Block=	Georgian_Extended}', "");
    Expect(0, 7359, '\P{Block=	Georgian_Extended}', "");
    Expect(1, 7359, '\P{^Block=	Georgian_Extended}', "");
    Expect(0, 7360, '\p{Block=	Georgian_Extended}', "");
    Expect(1, 7360, '\p{^Block=	Georgian_Extended}', "");
    Expect(1, 7360, '\P{Block=	Georgian_Extended}', "");
    Expect(0, 7360, '\P{^Block=	Georgian_Extended}', "");
    Error('\p{Blk:    Georgian_EXT:=}');
    Error('\P{Blk:    Georgian_EXT:=}');
    Expect(1, 7359, '\p{Blk=:\AGeorgian_Ext\z:}', "");;
    Expect(0, 7360, '\p{Blk=:\AGeorgian_Ext\z:}', "");;
    Expect(1, 7359, '\p{Blk=georgianext}', "");
    Expect(0, 7359, '\p{^Blk=georgianext}', "");
    Expect(0, 7359, '\P{Blk=georgianext}', "");
    Expect(1, 7359, '\P{^Blk=georgianext}', "");
    Expect(0, 7360, '\p{Blk=georgianext}', "");
    Expect(1, 7360, '\p{^Blk=georgianext}', "");
    Expect(1, 7360, '\P{Blk=georgianext}', "");
    Expect(0, 7360, '\P{^Blk=georgianext}', "");
    Expect(1, 7359, '\p{Blk=:\Ageorgianext\z:}', "");;
    Expect(0, 7360, '\p{Blk=:\Ageorgianext\z:}', "");;
    Expect(1, 7359, '\p{Blk=	-GEORGIAN_Ext}', "");
    Expect(0, 7359, '\p{^Blk=	-GEORGIAN_Ext}', "");
    Expect(0, 7359, '\P{Blk=	-GEORGIAN_Ext}', "");
    Expect(1, 7359, '\P{^Blk=	-GEORGIAN_Ext}', "");
    Expect(0, 7360, '\p{Blk=	-GEORGIAN_Ext}', "");
    Expect(1, 7360, '\p{^Blk=	-GEORGIAN_Ext}', "");
    Expect(1, 7360, '\P{Blk=	-GEORGIAN_Ext}', "");
    Expect(0, 7360, '\P{^Blk=	-GEORGIAN_Ext}', "");
    Error('\p{Is_Block=	-georgian_EXTENDED:=}');
    Error('\P{Is_Block=	-georgian_EXTENDED:=}');
    Expect(1, 7359, '\p{Is_Block=georgianextended}', "");
    Expect(0, 7359, '\p{^Is_Block=georgianextended}', "");
    Expect(0, 7359, '\P{Is_Block=georgianextended}', "");
    Expect(1, 7359, '\P{^Is_Block=georgianextended}', "");
    Expect(0, 7360, '\p{Is_Block=georgianextended}', "");
    Expect(1, 7360, '\p{^Is_Block=georgianextended}', "");
    Expect(1, 7360, '\P{Is_Block=georgianextended}', "");
    Expect(0, 7360, '\P{^Is_Block=georgianextended}', "");
    Expect(1, 7359, '\p{Is_Block= -Georgian_Extended}', "");
    Expect(0, 7359, '\p{^Is_Block= -Georgian_Extended}', "");
    Expect(0, 7359, '\P{Is_Block= -Georgian_Extended}', "");
    Expect(1, 7359, '\P{^Is_Block= -Georgian_Extended}', "");
    Expect(0, 7360, '\p{Is_Block= -Georgian_Extended}', "");
    Expect(1, 7360, '\p{^Is_Block= -Georgian_Extended}', "");
    Expect(1, 7360, '\P{Is_Block= -Georgian_Extended}', "");
    Expect(0, 7360, '\P{^Is_Block= -Georgian_Extended}', "");
    Error('\p{Is_Blk=/a/  georgian_Ext}');
    Error('\P{Is_Blk=/a/  georgian_Ext}');
    Expect(1, 7359, '\p{Is_Blk=georgianext}', "");
    Expect(0, 7359, '\p{^Is_Blk=georgianext}', "");
    Expect(0, 7359, '\P{Is_Blk=georgianext}', "");
    Expect(1, 7359, '\P{^Is_Blk=georgianext}', "");
    Expect(0, 7360, '\p{Is_Blk=georgianext}', "");
    Expect(1, 7360, '\p{^Is_Blk=georgianext}', "");
    Expect(1, 7360, '\P{Is_Blk=georgianext}', "");
    Expect(0, 7360, '\P{^Is_Blk=georgianext}', "");
    Expect(1, 7359, '\p{Is_Blk=	-georgian_Ext}', "");
    Expect(0, 7359, '\p{^Is_Blk=	-georgian_Ext}', "");
    Expect(0, 7359, '\P{Is_Blk=	-georgian_Ext}', "");
    Expect(1, 7359, '\P{^Is_Blk=	-georgian_Ext}', "");
    Expect(0, 7360, '\p{Is_Blk=	-georgian_Ext}', "");
    Expect(1, 7360, '\p{^Is_Blk=	-georgian_Ext}', "");
    Expect(1, 7360, '\P{Is_Blk=	-georgian_Ext}', "");
    Expect(0, 7360, '\P{^Is_Blk=	-georgian_Ext}', "");
    Error('\p{Block=__georgian_Supplement:=}');
    Error('\P{Block=__georgian_Supplement:=}');
    Expect(1, 11567, '\p{Block=:\AGeorgian_Supplement\z:}', "");;
    Expect(0, 11568, '\p{Block=:\AGeorgian_Supplement\z:}', "");;
    Expect(1, 11567, '\p{Block=georgiansupplement}', "");
    Expect(0, 11567, '\p{^Block=georgiansupplement}', "");
    Expect(0, 11567, '\P{Block=georgiansupplement}', "");
    Expect(1, 11567, '\P{^Block=georgiansupplement}', "");
    Expect(0, 11568, '\p{Block=georgiansupplement}', "");
    Expect(1, 11568, '\p{^Block=georgiansupplement}', "");
    Expect(1, 11568, '\P{Block=georgiansupplement}', "");
    Expect(0, 11568, '\P{^Block=georgiansupplement}', "");
    Expect(1, 11567, '\p{Block=:\Ageorgiansupplement\z:}', "");;
    Expect(0, 11568, '\p{Block=:\Ageorgiansupplement\z:}', "");;
    Expect(1, 11567, '\p{Block=-GEORGIAN_Supplement}', "");
    Expect(0, 11567, '\p{^Block=-GEORGIAN_Supplement}', "");
    Expect(0, 11567, '\P{Block=-GEORGIAN_Supplement}', "");
    Expect(1, 11567, '\P{^Block=-GEORGIAN_Supplement}', "");
    Expect(0, 11568, '\p{Block=-GEORGIAN_Supplement}', "");
    Expect(1, 11568, '\p{^Block=-GEORGIAN_Supplement}', "");
    Expect(1, 11568, '\P{Block=-GEORGIAN_Supplement}', "");
    Expect(0, 11568, '\P{^Block=-GEORGIAN_Supplement}', "");
    Error('\p{Blk: 	/a/Georgian_Sup}');
    Error('\P{Blk: 	/a/Georgian_Sup}');
    Expect(1, 11567, '\p{Blk=:\AGeorgian_Sup\z:}', "");;
    Expect(0, 11568, '\p{Blk=:\AGeorgian_Sup\z:}', "");;
    Expect(1, 11567, '\p{Blk:	georgiansup}', "");
    Expect(0, 11567, '\p{^Blk:	georgiansup}', "");
    Expect(0, 11567, '\P{Blk:	georgiansup}', "");
    Expect(1, 11567, '\P{^Blk:	georgiansup}', "");
    Expect(0, 11568, '\p{Blk:	georgiansup}', "");
    Expect(1, 11568, '\p{^Blk:	georgiansup}', "");
    Expect(1, 11568, '\P{Blk:	georgiansup}', "");
    Expect(0, 11568, '\P{^Blk:	georgiansup}', "");
    Expect(1, 11567, '\p{Blk=:\Ageorgiansup\z:}', "");;
    Expect(0, 11568, '\p{Blk=:\Ageorgiansup\z:}', "");;
    Expect(1, 11567, '\p{Blk=	-Georgian_Sup}', "");
    Expect(0, 11567, '\p{^Blk=	-Georgian_Sup}', "");
    Expect(0, 11567, '\P{Blk=	-Georgian_Sup}', "");
    Expect(1, 11567, '\P{^Blk=	-Georgian_Sup}', "");
    Expect(0, 11568, '\p{Blk=	-Georgian_Sup}', "");
    Expect(1, 11568, '\p{^Blk=	-Georgian_Sup}', "");
    Expect(1, 11568, '\P{Blk=	-Georgian_Sup}', "");
    Expect(0, 11568, '\P{^Blk=	-Georgian_Sup}', "");
    Error('\p{Is_Block=:= Georgian_Supplement}');
    Error('\P{Is_Block=:= Georgian_Supplement}');
    Expect(1, 11567, '\p{Is_Block=georgiansupplement}', "");
    Expect(0, 11567, '\p{^Is_Block=georgiansupplement}', "");
    Expect(0, 11567, '\P{Is_Block=georgiansupplement}', "");
    Expect(1, 11567, '\P{^Is_Block=georgiansupplement}', "");
    Expect(0, 11568, '\p{Is_Block=georgiansupplement}', "");
    Expect(1, 11568, '\p{^Is_Block=georgiansupplement}', "");
    Expect(1, 11568, '\P{Is_Block=georgiansupplement}', "");
    Expect(0, 11568, '\P{^Is_Block=georgiansupplement}', "");
    Expect(1, 11567, '\p{Is_Block=__Georgian_Supplement}', "");
    Expect(0, 11567, '\p{^Is_Block=__Georgian_Supplement}', "");
    Expect(0, 11567, '\P{Is_Block=__Georgian_Supplement}', "");
    Expect(1, 11567, '\P{^Is_Block=__Georgian_Supplement}', "");
    Expect(0, 11568, '\p{Is_Block=__Georgian_Supplement}', "");
    Expect(1, 11568, '\p{^Is_Block=__Georgian_Supplement}', "");
    Expect(1, 11568, '\P{Is_Block=__Georgian_Supplement}', "");
    Expect(0, 11568, '\P{^Is_Block=__Georgian_Supplement}', "");
    Error('\p{Is_Blk=-_Georgian_SUP/a/}');
    Error('\P{Is_Blk=-_Georgian_SUP/a/}');
    Expect(1, 11567, '\p{Is_Blk=georgiansup}', "");
    Expect(0, 11567, '\p{^Is_Blk=georgiansup}', "");
    Expect(0, 11567, '\P{Is_Blk=georgiansup}', "");
    Expect(1, 11567, '\P{^Is_Blk=georgiansup}', "");
    Expect(0, 11568, '\p{Is_Blk=georgiansup}', "");
    Expect(1, 11568, '\p{^Is_Blk=georgiansup}', "");
    Expect(1, 11568, '\P{Is_Blk=georgiansup}', "");
    Expect(0, 11568, '\P{^Is_Blk=georgiansup}', "");
    Expect(1, 11567, '\p{Is_Blk=-Georgian_Sup}', "");
    Expect(0, 11567, '\p{^Is_Blk=-Georgian_Sup}', "");
    Expect(0, 11567, '\P{Is_Blk=-Georgian_Sup}', "");
    Expect(1, 11567, '\P{^Is_Blk=-Georgian_Sup}', "");
    Expect(0, 11568, '\p{Is_Blk=-Georgian_Sup}', "");
    Expect(1, 11568, '\p{^Is_Blk=-Georgian_Sup}', "");
    Expect(1, 11568, '\P{Is_Blk=-Georgian_Sup}', "");
    Expect(0, 11568, '\P{^Is_Blk=-Georgian_Sup}', "");
    Error('\p{Block=/a/GLAGOLITIC}');
    Error('\P{Block=/a/GLAGOLITIC}');
    Expect(1, 11359, '\p{Block=:\AGlagolitic\z:}', "");;
    Expect(0, 11360, '\p{Block=:\AGlagolitic\z:}', "");;
    Expect(1, 11359, '\p{Block=glagolitic}', "");
    Expect(0, 11359, '\p{^Block=glagolitic}', "");
    Expect(0, 11359, '\P{Block=glagolitic}', "");
    Expect(1, 11359, '\P{^Block=glagolitic}', "");
    Expect(0, 11360, '\p{Block=glagolitic}', "");
    Expect(1, 11360, '\p{^Block=glagolitic}', "");
    Expect(1, 11360, '\P{Block=glagolitic}', "");
    Expect(0, 11360, '\P{^Block=glagolitic}', "");
    Expect(1, 11359, '\p{Block=:\Aglagolitic\z:}', "");;
    Expect(0, 11360, '\p{Block=:\Aglagolitic\z:}', "");;
    Expect(1, 11359, '\p{Block: -Glagolitic}', "");
    Expect(0, 11359, '\p{^Block: -Glagolitic}', "");
    Expect(0, 11359, '\P{Block: -Glagolitic}', "");
    Expect(1, 11359, '\P{^Block: -Glagolitic}', "");
    Expect(0, 11360, '\p{Block: -Glagolitic}', "");
    Expect(1, 11360, '\p{^Block: -Glagolitic}', "");
    Expect(1, 11360, '\P{Block: -Glagolitic}', "");
    Expect(0, 11360, '\P{^Block: -Glagolitic}', "");
    Error('\p{Blk=  GLAGOLITIC/a/}');
    Error('\P{Blk=  GLAGOLITIC/a/}');
    Expect(1, 11359, '\p{Blk=:\AGlagolitic\z:}', "");;
    Expect(0, 11360, '\p{Blk=:\AGlagolitic\z:}', "");;
    Expect(1, 11359, '\p{Blk:glagolitic}', "");
    Expect(0, 11359, '\p{^Blk:glagolitic}', "");
    Expect(0, 11359, '\P{Blk:glagolitic}', "");
    Expect(1, 11359, '\P{^Blk:glagolitic}', "");
    Expect(0, 11360, '\p{Blk:glagolitic}', "");
    Expect(1, 11360, '\p{^Blk:glagolitic}', "");
    Expect(1, 11360, '\P{Blk:glagolitic}', "");
    Expect(0, 11360, '\P{^Blk:glagolitic}', "");
    Expect(1, 11359, '\p{Blk=:\Aglagolitic\z:}', "");;
    Expect(0, 11360, '\p{Blk=:\Aglagolitic\z:}', "");;
    Expect(1, 11359, '\p{Blk=__glagolitic}', "");
    Expect(0, 11359, '\p{^Blk=__glagolitic}', "");
    Expect(0, 11359, '\P{Blk=__glagolitic}', "");
    Expect(1, 11359, '\P{^Blk=__glagolitic}', "");
    Expect(0, 11360, '\p{Blk=__glagolitic}', "");
    Expect(1, 11360, '\p{^Blk=__glagolitic}', "");
    Expect(1, 11360, '\P{Blk=__glagolitic}', "");
    Expect(0, 11360, '\P{^Blk=__glagolitic}', "");
    Error('\p{Is_Block= -Glagolitic/a/}');
    Error('\P{Is_Block= -Glagolitic/a/}');
    Expect(1, 11359, '\p{Is_Block=glagolitic}', "");
    Expect(0, 11359, '\p{^Is_Block=glagolitic}', "");
    Expect(0, 11359, '\P{Is_Block=glagolitic}', "");
    Expect(1, 11359, '\P{^Is_Block=glagolitic}', "");
    Expect(0, 11360, '\p{Is_Block=glagolitic}', "");
    Expect(1, 11360, '\p{^Is_Block=glagolitic}', "");
    Expect(1, 11360, '\P{Is_Block=glagolitic}', "");
    Expect(0, 11360, '\P{^Is_Block=glagolitic}', "");
    Expect(1, 11359, '\p{Is_Block:	-	Glagolitic}', "");
    Expect(0, 11359, '\p{^Is_Block:	-	Glagolitic}', "");
    Expect(0, 11359, '\P{Is_Block:	-	Glagolitic}', "");
    Expect(1, 11359, '\P{^Is_Block:	-	Glagolitic}', "");
    Expect(0, 11360, '\p{Is_Block:	-	Glagolitic}', "");
    Expect(1, 11360, '\p{^Is_Block:	-	Glagolitic}', "");
    Expect(1, 11360, '\P{Is_Block:	-	Glagolitic}', "");
    Expect(0, 11360, '\P{^Is_Block:	-	Glagolitic}', "");
    Error('\p{Is_Blk=:=_-glagolitic}');
    Error('\P{Is_Blk=:=_-glagolitic}');
    Expect(1, 11359, '\p{Is_Blk=glagolitic}', "");
    Expect(0, 11359, '\p{^Is_Blk=glagolitic}', "");
    Expect(0, 11359, '\P{Is_Blk=glagolitic}', "");
    Expect(1, 11359, '\P{^Is_Blk=glagolitic}', "");
    Expect(0, 11360, '\p{Is_Blk=glagolitic}', "");
    Expect(1, 11360, '\p{^Is_Blk=glagolitic}', "");
    Expect(1, 11360, '\P{Is_Blk=glagolitic}', "");
    Expect(0, 11360, '\P{^Is_Blk=glagolitic}', "");
    Expect(1, 11359, '\p{Is_Blk= -Glagolitic}', "");
    Expect(0, 11359, '\p{^Is_Blk= -Glagolitic}', "");
    Expect(0, 11359, '\P{Is_Blk= -Glagolitic}', "");
    Expect(1, 11359, '\P{^Is_Blk= -Glagolitic}', "");
    Expect(0, 11360, '\p{Is_Blk= -Glagolitic}', "");
    Expect(1, 11360, '\p{^Is_Blk= -Glagolitic}', "");
    Expect(1, 11360, '\P{Is_Blk= -Glagolitic}', "");
    Expect(0, 11360, '\P{^Is_Blk= -Glagolitic}', "");
    Error('\p{Block=/a/_ GLAGOLITIC_Supplement}');
    Error('\P{Block=/a/_ GLAGOLITIC_Supplement}');
    Expect(1, 122927, '\p{Block=:\AGlagolitic_Supplement\z:}', "");;
    Expect(0, 122928, '\p{Block=:\AGlagolitic_Supplement\z:}', "");;
    Expect(1, 122927, '\p{Block=glagoliticsupplement}', "");
    Expect(0, 122927, '\p{^Block=glagoliticsupplement}', "");
    Expect(0, 122927, '\P{Block=glagoliticsupplement}', "");
    Expect(1, 122927, '\P{^Block=glagoliticsupplement}', "");
    Expect(0, 122928, '\p{Block=glagoliticsupplement}', "");
    Expect(1, 122928, '\p{^Block=glagoliticsupplement}', "");
    Expect(1, 122928, '\P{Block=glagoliticsupplement}', "");
    Expect(0, 122928, '\P{^Block=glagoliticsupplement}', "");
    Expect(1, 122927, '\p{Block=:\Aglagoliticsupplement\z:}', "");;
    Expect(0, 122928, '\p{Block=:\Aglagoliticsupplement\z:}', "");;
    Expect(1, 122927, '\p{Block=_ Glagolitic_Supplement}', "");
    Expect(0, 122927, '\p{^Block=_ Glagolitic_Supplement}', "");
    Expect(0, 122927, '\P{Block=_ Glagolitic_Supplement}', "");
    Expect(1, 122927, '\P{^Block=_ Glagolitic_Supplement}', "");
    Expect(0, 122928, '\p{Block=_ Glagolitic_Supplement}', "");
    Expect(1, 122928, '\p{^Block=_ Glagolitic_Supplement}', "");
    Expect(1, 122928, '\P{Block=_ Glagolitic_Supplement}', "");
    Expect(0, 122928, '\P{^Block=_ Glagolitic_Supplement}', "");
    Error('\p{Blk=	/a/glagolitic_sup}');
    Error('\P{Blk=	/a/glagolitic_sup}');
    Expect(1, 122927, '\p{Blk=:\AGlagolitic_Sup\z:}', "");;
    Expect(0, 122928, '\p{Blk=:\AGlagolitic_Sup\z:}', "");;
    Expect(1, 122927, '\p{Blk=glagoliticsup}', "");
    Expect(0, 122927, '\p{^Blk=glagoliticsup}', "");
    Expect(0, 122927, '\P{Blk=glagoliticsup}', "");
    Expect(1, 122927, '\P{^Blk=glagoliticsup}', "");
    Expect(0, 122928, '\p{Blk=glagoliticsup}', "");
    Expect(1, 122928, '\p{^Blk=glagoliticsup}', "");
    Expect(1, 122928, '\P{Blk=glagoliticsup}', "");
    Expect(0, 122928, '\P{^Blk=glagoliticsup}', "");
    Expect(1, 122927, '\p{Blk=:\Aglagoliticsup\z:}', "");;
    Expect(0, 122928, '\p{Blk=:\Aglagoliticsup\z:}', "");;
    Expect(1, 122927, '\p{Blk=__glagolitic_Sup}', "");
    Expect(0, 122927, '\p{^Blk=__glagolitic_Sup}', "");
    Expect(0, 122927, '\P{Blk=__glagolitic_Sup}', "");
    Expect(1, 122927, '\P{^Blk=__glagolitic_Sup}', "");
    Expect(0, 122928, '\p{Blk=__glagolitic_Sup}', "");
    Expect(1, 122928, '\p{^Blk=__glagolitic_Sup}', "");
    Expect(1, 122928, '\P{Blk=__glagolitic_Sup}', "");
    Expect(0, 122928, '\P{^Blk=__glagolitic_Sup}', "");
    Error('\p{Is_Block= 	GLAGOLITIC_Supplement:=}');
    Error('\P{Is_Block= 	GLAGOLITIC_Supplement:=}');
    Expect(1, 122927, '\p{Is_Block=glagoliticsupplement}', "");
    Expect(0, 122927, '\p{^Is_Block=glagoliticsupplement}', "");
    Expect(0, 122927, '\P{Is_Block=glagoliticsupplement}', "");
    Expect(1, 122927, '\P{^Is_Block=glagoliticsupplement}', "");
    Expect(0, 122928, '\p{Is_Block=glagoliticsupplement}', "");
    Expect(1, 122928, '\p{^Is_Block=glagoliticsupplement}', "");
    Expect(1, 122928, '\P{Is_Block=glagoliticsupplement}', "");
    Expect(0, 122928, '\P{^Is_Block=glagoliticsupplement}', "");
    Expect(1, 122927, '\p{Is_Block=_ Glagolitic_Supplement}', "");
    Expect(0, 122927, '\p{^Is_Block=_ Glagolitic_Supplement}', "");
    Expect(0, 122927, '\P{Is_Block=_ Glagolitic_Supplement}', "");
    Expect(1, 122927, '\P{^Is_Block=_ Glagolitic_Supplement}', "");
    Expect(0, 122928, '\p{Is_Block=_ Glagolitic_Supplement}', "");
    Expect(1, 122928, '\p{^Is_Block=_ Glagolitic_Supplement}', "");
    Expect(1, 122928, '\P{Is_Block=_ Glagolitic_Supplement}', "");
    Expect(0, 122928, '\P{^Is_Block=_ Glagolitic_Supplement}', "");
    Error('\p{Is_Blk::=-_Glagolitic_SUP}');
    Error('\P{Is_Blk::=-_Glagolitic_SUP}');
    Expect(1, 122927, '\p{Is_Blk=glagoliticsup}', "");
    Expect(0, 122927, '\p{^Is_Blk=glagoliticsup}', "");
    Expect(0, 122927, '\P{Is_Blk=glagoliticsup}', "");
    Expect(1, 122927, '\P{^Is_Blk=glagoliticsup}', "");
    Expect(0, 122928, '\p{Is_Blk=glagoliticsup}', "");
    Expect(1, 122928, '\p{^Is_Blk=glagoliticsup}', "");
    Expect(1, 122928, '\P{Is_Blk=glagoliticsup}', "");
    Expect(0, 122928, '\P{^Is_Blk=glagoliticsup}', "");
    Expect(1, 122927, '\p{Is_Blk=__GLAGOLITIC_Sup}', "");
    Expect(0, 122927, '\p{^Is_Blk=__GLAGOLITIC_Sup}', "");
    Expect(0, 122927, '\P{Is_Blk=__GLAGOLITIC_Sup}', "");
    Expect(1, 122927, '\P{^Is_Blk=__GLAGOLITIC_Sup}', "");
    Expect(0, 122928, '\p{Is_Blk=__GLAGOLITIC_Sup}', "");
    Expect(1, 122928, '\p{^Is_Blk=__GLAGOLITIC_Sup}', "");
    Expect(1, 122928, '\P{Is_Blk=__GLAGOLITIC_Sup}', "");
    Expect(0, 122928, '\P{^Is_Blk=__GLAGOLITIC_Sup}', "");
    Error('\p{Block=/a/Gothic}');
    Error('\P{Block=/a/Gothic}');
    Expect(1, 66383, '\p{Block=:\AGothic\z:}', "");;
    Expect(0, 66384, '\p{Block=:\AGothic\z:}', "");;
    Expect(1, 66383, '\p{Block=gothic}', "");
    Expect(0, 66383, '\p{^Block=gothic}', "");
    Expect(0, 66383, '\P{Block=gothic}', "");
    Expect(1, 66383, '\P{^Block=gothic}', "");
    Expect(0, 66384, '\p{Block=gothic}', "");
    Expect(1, 66384, '\p{^Block=gothic}', "");
    Expect(1, 66384, '\P{Block=gothic}', "");
    Expect(0, 66384, '\P{^Block=gothic}', "");
    Expect(1, 66383, '\p{Block=:\Agothic\z:}', "");;
    Expect(0, 66384, '\p{Block=:\Agothic\z:}', "");;
    Expect(1, 66383, '\p{Block= gothic}', "");
    Expect(0, 66383, '\p{^Block= gothic}', "");
    Expect(0, 66383, '\P{Block= gothic}', "");
    Expect(1, 66383, '\P{^Block= gothic}', "");
    Expect(0, 66384, '\p{Block= gothic}', "");
    Expect(1, 66384, '\p{^Block= gothic}', "");
    Expect(1, 66384, '\P{Block= gothic}', "");
    Expect(0, 66384, '\P{^Block= gothic}', "");
    Error('\p{Blk=_	gothic:=}');
    Error('\P{Blk=_	gothic:=}');
    Expect(1, 66383, '\p{Blk=:\AGothic\z:}', "");;
    Expect(0, 66384, '\p{Blk=:\AGothic\z:}', "");;
    Expect(1, 66383, '\p{Blk=gothic}', "");
    Expect(0, 66383, '\p{^Blk=gothic}', "");
    Expect(0, 66383, '\P{Blk=gothic}', "");
    Expect(1, 66383, '\P{^Blk=gothic}', "");
    Expect(0, 66384, '\p{Blk=gothic}', "");
    Expect(1, 66384, '\p{^Blk=gothic}', "");
    Expect(1, 66384, '\P{Blk=gothic}', "");
    Expect(0, 66384, '\P{^Blk=gothic}', "");
    Expect(1, 66383, '\p{Blk=:\Agothic\z:}', "");;
    Expect(0, 66384, '\p{Blk=:\Agothic\z:}', "");;
    Expect(1, 66383, '\p{Blk= Gothic}', "");
    Expect(0, 66383, '\p{^Blk= Gothic}', "");
    Expect(0, 66383, '\P{Blk= Gothic}', "");
    Expect(1, 66383, '\P{^Blk= Gothic}', "");
    Expect(0, 66384, '\p{Blk= Gothic}', "");
    Expect(1, 66384, '\p{^Blk= Gothic}', "");
    Expect(1, 66384, '\P{Blk= Gothic}', "");
    Expect(0, 66384, '\P{^Blk= Gothic}', "");
    Error('\p{Is_Block= 	Gothic/a/}');
    Error('\P{Is_Block= 	Gothic/a/}');
    Expect(1, 66383, '\p{Is_Block=gothic}', "");
    Expect(0, 66383, '\p{^Is_Block=gothic}', "");
    Expect(0, 66383, '\P{Is_Block=gothic}', "");
    Expect(1, 66383, '\P{^Is_Block=gothic}', "");
    Expect(0, 66384, '\p{Is_Block=gothic}', "");
    Expect(1, 66384, '\p{^Is_Block=gothic}', "");
    Expect(1, 66384, '\P{Is_Block=gothic}', "");
    Expect(0, 66384, '\P{^Is_Block=gothic}', "");
    Expect(1, 66383, '\p{Is_Block:		-GOTHIC}', "");
    Expect(0, 66383, '\p{^Is_Block:		-GOTHIC}', "");
    Expect(0, 66383, '\P{Is_Block:		-GOTHIC}', "");
    Expect(1, 66383, '\P{^Is_Block:		-GOTHIC}', "");
    Expect(0, 66384, '\p{Is_Block:		-GOTHIC}', "");
    Expect(1, 66384, '\p{^Is_Block:		-GOTHIC}', "");
    Expect(1, 66384, '\P{Is_Block:		-GOTHIC}', "");
    Expect(0, 66384, '\P{^Is_Block:		-GOTHIC}', "");
    Error('\p{Is_Blk: :=Gothic}');
    Error('\P{Is_Blk: :=Gothic}');
    Expect(1, 66383, '\p{Is_Blk=gothic}', "");
    Expect(0, 66383, '\p{^Is_Blk=gothic}', "");
    Expect(0, 66383, '\P{Is_Blk=gothic}', "");
    Expect(1, 66383, '\P{^Is_Blk=gothic}', "");
    Expect(0, 66384, '\p{Is_Blk=gothic}', "");
    Expect(1, 66384, '\p{^Is_Blk=gothic}', "");
    Expect(1, 66384, '\P{Is_Blk=gothic}', "");
    Expect(0, 66384, '\P{^Is_Blk=gothic}', "");
    Expect(1, 66383, '\p{Is_Blk=	Gothic}', "");
    Expect(0, 66383, '\p{^Is_Blk=	Gothic}', "");
    Expect(0, 66383, '\P{Is_Blk=	Gothic}', "");
    Expect(1, 66383, '\P{^Is_Blk=	Gothic}', "");
    Expect(0, 66384, '\p{Is_Blk=	Gothic}', "");
    Expect(1, 66384, '\p{^Is_Blk=	Gothic}', "");
    Expect(1, 66384, '\P{Is_Blk=	Gothic}', "");
    Expect(0, 66384, '\P{^Is_Blk=	Gothic}', "");
    Error('\p{Block=-:=grantha}');
    Error('\P{Block=-:=grantha}');
    Expect(1, 70527, '\p{Block=:\AGrantha\z:}', "");;
    Expect(0, 70528, '\p{Block=:\AGrantha\z:}', "");;
    Expect(1, 70527, '\p{Block=grantha}', "");
    Expect(0, 70527, '\p{^Block=grantha}', "");
    Expect(0, 70527, '\P{Block=grantha}', "");
    Expect(1, 70527, '\P{^Block=grantha}', "");
    Expect(0, 70528, '\p{Block=grantha}', "");
    Expect(1, 70528, '\p{^Block=grantha}', "");
    Expect(1, 70528, '\P{Block=grantha}', "");
    Expect(0, 70528, '\P{^Block=grantha}', "");
    Expect(1, 70527, '\p{Block=:\Agrantha\z:}', "");;
    Expect(0, 70528, '\p{Block=:\Agrantha\z:}', "");;
    Expect(1, 70527, '\p{Block:    Grantha}', "");
    Expect(0, 70527, '\p{^Block:    Grantha}', "");
    Expect(0, 70527, '\P{Block:    Grantha}', "");
    Expect(1, 70527, '\P{^Block:    Grantha}', "");
    Expect(0, 70528, '\p{Block:    Grantha}', "");
    Expect(1, 70528, '\p{^Block:    Grantha}', "");
    Expect(1, 70528, '\P{Block:    Grantha}', "");
    Expect(0, 70528, '\P{^Block:    Grantha}', "");
    Error('\p{Blk=_/a/Grantha}');
    Error('\P{Blk=_/a/Grantha}');
    Expect(1, 70527, '\p{Blk=:\AGrantha\z:}', "");;
    Expect(0, 70528, '\p{Blk=:\AGrantha\z:}', "");;
    Expect(1, 70527, '\p{Blk=grantha}', "");
    Expect(0, 70527, '\p{^Blk=grantha}', "");
    Expect(0, 70527, '\P{Blk=grantha}', "");
    Expect(1, 70527, '\P{^Blk=grantha}', "");
    Expect(0, 70528, '\p{Blk=grantha}', "");
    Expect(1, 70528, '\p{^Blk=grantha}', "");
    Expect(1, 70528, '\P{Blk=grantha}', "");
    Expect(0, 70528, '\P{^Blk=grantha}', "");
    Expect(1, 70527, '\p{Blk=:\Agrantha\z:}', "");;
    Expect(0, 70528, '\p{Blk=:\Agrantha\z:}', "");;
    Expect(1, 70527, '\p{Blk=		grantha}', "");
    Expect(0, 70527, '\p{^Blk=		grantha}', "");
    Expect(0, 70527, '\P{Blk=		grantha}', "");
    Expect(1, 70527, '\P{^Blk=		grantha}', "");
    Expect(0, 70528, '\p{Blk=		grantha}', "");
    Expect(1, 70528, '\p{^Blk=		grantha}', "");
    Expect(1, 70528, '\P{Blk=		grantha}', "");
    Expect(0, 70528, '\P{^Blk=		grantha}', "");
    Error('\p{Is_Block=/a/	_grantha}');
    Error('\P{Is_Block=/a/	_grantha}');
    Expect(1, 70527, '\p{Is_Block=grantha}', "");
    Expect(0, 70527, '\p{^Is_Block=grantha}', "");
    Expect(0, 70527, '\P{Is_Block=grantha}', "");
    Expect(1, 70527, '\P{^Is_Block=grantha}', "");
    Expect(0, 70528, '\p{Is_Block=grantha}', "");
    Expect(1, 70528, '\p{^Is_Block=grantha}', "");
    Expect(1, 70528, '\P{Is_Block=grantha}', "");
    Expect(0, 70528, '\P{^Is_Block=grantha}', "");
    Expect(1, 70527, '\p{Is_Block= GRANTHA}', "");
    Expect(0, 70527, '\p{^Is_Block= GRANTHA}', "");
    Expect(0, 70527, '\P{Is_Block= GRANTHA}', "");
    Expect(1, 70527, '\P{^Is_Block= GRANTHA}', "");
    Expect(0, 70528, '\p{Is_Block= GRANTHA}', "");
    Expect(1, 70528, '\p{^Is_Block= GRANTHA}', "");
    Expect(1, 70528, '\P{Is_Block= GRANTHA}', "");
    Expect(0, 70528, '\P{^Is_Block= GRANTHA}', "");
    Error('\p{Is_Blk=-:=Grantha}');
    Error('\P{Is_Blk=-:=Grantha}');
    Expect(1, 70527, '\p{Is_Blk=grantha}', "");
    Expect(0, 70527, '\p{^Is_Blk=grantha}', "");
    Expect(0, 70527, '\P{Is_Blk=grantha}', "");
    Expect(1, 70527, '\P{^Is_Blk=grantha}', "");
    Expect(0, 70528, '\p{Is_Blk=grantha}', "");
    Expect(1, 70528, '\p{^Is_Blk=grantha}', "");
    Expect(1, 70528, '\P{Is_Blk=grantha}', "");
    Expect(0, 70528, '\P{^Is_Blk=grantha}', "");
    Expect(1, 70527, '\p{Is_Blk=	_GRANTHA}', "");
    Expect(0, 70527, '\p{^Is_Blk=	_GRANTHA}', "");
    Expect(0, 70527, '\P{Is_Blk=	_GRANTHA}', "");
    Expect(1, 70527, '\P{^Is_Blk=	_GRANTHA}', "");
    Expect(0, 70528, '\p{Is_Blk=	_GRANTHA}', "");
    Expect(1, 70528, '\p{^Is_Blk=	_GRANTHA}', "");
    Expect(1, 70528, '\P{Is_Blk=	_GRANTHA}', "");
    Expect(0, 70528, '\P{^Is_Blk=	_GRANTHA}', "");
    Error('\p{Block=/a/GREEK_and_COPTIC}');
    Error('\P{Block=/a/GREEK_and_COPTIC}');
    Expect(1, 1023, '\p{Block=:\AGreek_And_Coptic\z:}', "");;
    Expect(0, 1024, '\p{Block=:\AGreek_And_Coptic\z:}', "");;
    Expect(1, 1023, '\p{Block:greekandcoptic}', "");
    Expect(0, 1023, '\p{^Block:greekandcoptic}', "");
    Expect(0, 1023, '\P{Block:greekandcoptic}', "");
    Expect(1, 1023, '\P{^Block:greekandcoptic}', "");
    Expect(0, 1024, '\p{Block:greekandcoptic}', "");
    Expect(1, 1024, '\p{^Block:greekandcoptic}', "");
    Expect(1, 1024, '\P{Block:greekandcoptic}', "");
    Expect(0, 1024, '\P{^Block:greekandcoptic}', "");
    Expect(1, 1023, '\p{Block=:\Agreekandcoptic\z:}', "");;
    Expect(0, 1024, '\p{Block=:\Agreekandcoptic\z:}', "");;
    Expect(1, 1023, '\p{Block=	greek_and_COPTIC}', "");
    Expect(0, 1023, '\p{^Block=	greek_and_COPTIC}', "");
    Expect(0, 1023, '\P{Block=	greek_and_COPTIC}', "");
    Expect(1, 1023, '\P{^Block=	greek_and_COPTIC}', "");
    Expect(0, 1024, '\p{Block=	greek_and_COPTIC}', "");
    Expect(1, 1024, '\p{^Block=	greek_and_COPTIC}', "");
    Expect(1, 1024, '\P{Block=	greek_and_COPTIC}', "");
    Expect(0, 1024, '\P{^Block=	greek_and_COPTIC}', "");
    Error('\p{Blk=/a/	_Greek}');
    Error('\P{Blk=/a/	_Greek}');
    Expect(1, 1023, '\p{Blk=:\AGreek\z:}', "");;
    Expect(0, 1024, '\p{Blk=:\AGreek\z:}', "");;
    Expect(1, 1023, '\p{Blk=greek}', "");
    Expect(0, 1023, '\p{^Blk=greek}', "");
    Expect(0, 1023, '\P{Blk=greek}', "");
    Expect(1, 1023, '\P{^Blk=greek}', "");
    Expect(0, 1024, '\p{Blk=greek}', "");
    Expect(1, 1024, '\p{^Blk=greek}', "");
    Expect(1, 1024, '\P{Blk=greek}', "");
    Expect(0, 1024, '\P{^Blk=greek}', "");
    Expect(1, 1023, '\p{Blk=:\Agreek\z:}', "");;
    Expect(0, 1024, '\p{Blk=:\Agreek\z:}', "");;
    Expect(1, 1023, '\p{Blk=- greek}', "");
    Expect(0, 1023, '\p{^Blk=- greek}', "");
    Expect(0, 1023, '\P{Blk=- greek}', "");
    Expect(1, 1023, '\P{^Blk=- greek}', "");
    Expect(0, 1024, '\p{Blk=- greek}', "");
    Expect(1, 1024, '\p{^Blk=- greek}', "");
    Expect(1, 1024, '\P{Blk=- greek}', "");
    Expect(0, 1024, '\P{^Blk=- greek}', "");
    Error('\p{Is_Block=-/a/Greek_AND_coptic}');
    Error('\P{Is_Block=-/a/Greek_AND_coptic}');
    Expect(1, 1023, '\p{Is_Block=greekandcoptic}', "");
    Expect(0, 1023, '\p{^Is_Block=greekandcoptic}', "");
    Expect(0, 1023, '\P{Is_Block=greekandcoptic}', "");
    Expect(1, 1023, '\P{^Is_Block=greekandcoptic}', "");
    Expect(0, 1024, '\p{Is_Block=greekandcoptic}', "");
    Expect(1, 1024, '\p{^Is_Block=greekandcoptic}', "");
    Expect(1, 1024, '\P{Is_Block=greekandcoptic}', "");
    Expect(0, 1024, '\P{^Is_Block=greekandcoptic}', "");
    Expect(1, 1023, '\p{Is_Block=	Greek_And_Coptic}', "");
    Expect(0, 1023, '\p{^Is_Block=	Greek_And_Coptic}', "");
    Expect(0, 1023, '\P{Is_Block=	Greek_And_Coptic}', "");
    Expect(1, 1023, '\P{^Is_Block=	Greek_And_Coptic}', "");
    Expect(0, 1024, '\p{Is_Block=	Greek_And_Coptic}', "");
    Expect(1, 1024, '\p{^Is_Block=	Greek_And_Coptic}', "");
    Expect(1, 1024, '\P{Is_Block=	Greek_And_Coptic}', "");
    Expect(0, 1024, '\P{^Is_Block=	Greek_And_Coptic}', "");
    Error('\p{Is_Blk=:=greek}');
    Error('\P{Is_Blk=:=greek}');
    Expect(1, 1023, '\p{Is_Blk=greek}', "");
    Expect(0, 1023, '\p{^Is_Blk=greek}', "");
    Expect(0, 1023, '\P{Is_Blk=greek}', "");
    Expect(1, 1023, '\P{^Is_Blk=greek}', "");
    Expect(0, 1024, '\p{Is_Blk=greek}', "");
    Expect(1, 1024, '\p{^Is_Blk=greek}', "");
    Expect(1, 1024, '\P{Is_Blk=greek}', "");
    Expect(0, 1024, '\P{^Is_Blk=greek}', "");
    Expect(1, 1023, '\p{Is_Blk=		greek}', "");
    Expect(0, 1023, '\p{^Is_Blk=		greek}', "");
    Expect(0, 1023, '\P{Is_Blk=		greek}', "");
    Expect(1, 1023, '\P{^Is_Blk=		greek}', "");
    Expect(0, 1024, '\p{Is_Blk=		greek}', "");
    Expect(1, 1024, '\p{^Is_Blk=		greek}', "");
    Expect(1, 1024, '\P{Is_Blk=		greek}', "");
    Expect(0, 1024, '\P{^Is_Blk=		greek}', "");
    Error('\p{Block=:=Greek_EXTENDED}');
    Error('\P{Block=:=Greek_EXTENDED}');
    Expect(1, 8191, '\p{Block=:\AGreek_Extended\z:}', "");;
    Expect(0, 8192, '\p{Block=:\AGreek_Extended\z:}', "");;
    Expect(1, 8191, '\p{Block: greekextended}', "");
    Expect(0, 8191, '\p{^Block: greekextended}', "");
    Expect(0, 8191, '\P{Block: greekextended}', "");
    Expect(1, 8191, '\P{^Block: greekextended}', "");
    Expect(0, 8192, '\p{Block: greekextended}', "");
    Expect(1, 8192, '\p{^Block: greekextended}', "");
    Expect(1, 8192, '\P{Block: greekextended}', "");
    Expect(0, 8192, '\P{^Block: greekextended}', "");
    Expect(1, 8191, '\p{Block=:\Agreekextended\z:}', "");;
    Expect(0, 8192, '\p{Block=:\Agreekextended\z:}', "");;
    Expect(1, 8191, '\p{Block=		Greek_extended}', "");
    Expect(0, 8191, '\p{^Block=		Greek_extended}', "");
    Expect(0, 8191, '\P{Block=		Greek_extended}', "");
    Expect(1, 8191, '\P{^Block=		Greek_extended}', "");
    Expect(0, 8192, '\p{Block=		Greek_extended}', "");
    Expect(1, 8192, '\p{^Block=		Greek_extended}', "");
    Expect(1, 8192, '\P{Block=		Greek_extended}', "");
    Expect(0, 8192, '\P{^Block=		Greek_extended}', "");
    Error('\p{Blk=-	greek_Ext:=}');
    Error('\P{Blk=-	greek_Ext:=}');
    Expect(1, 8191, '\p{Blk=:\AGreek_Ext\z:}', "");;
    Expect(0, 8192, '\p{Blk=:\AGreek_Ext\z:}', "");;
    Expect(1, 8191, '\p{Blk=greekext}', "");
    Expect(0, 8191, '\p{^Blk=greekext}', "");
    Expect(0, 8191, '\P{Blk=greekext}', "");
    Expect(1, 8191, '\P{^Blk=greekext}', "");
    Expect(0, 8192, '\p{Blk=greekext}', "");
    Expect(1, 8192, '\p{^Blk=greekext}', "");
    Expect(1, 8192, '\P{Blk=greekext}', "");
    Expect(0, 8192, '\P{^Blk=greekext}', "");
    Expect(1, 8191, '\p{Blk=:\Agreekext\z:}', "");;
    Expect(0, 8192, '\p{Blk=:\Agreekext\z:}', "");;
    Expect(1, 8191, '\p{Blk=_ GREEK_ext}', "");
    Expect(0, 8191, '\p{^Blk=_ GREEK_ext}', "");
    Expect(0, 8191, '\P{Blk=_ GREEK_ext}', "");
    Expect(1, 8191, '\P{^Blk=_ GREEK_ext}', "");
    Expect(0, 8192, '\p{Blk=_ GREEK_ext}', "");
    Expect(1, 8192, '\p{^Blk=_ GREEK_ext}', "");
    Expect(1, 8192, '\P{Blk=_ GREEK_ext}', "");
    Expect(0, 8192, '\P{^Blk=_ GREEK_ext}', "");
    Error('\p{Is_Block=:=- Greek_Extended}');
    Error('\P{Is_Block=:=- Greek_Extended}');
    Expect(1, 8191, '\p{Is_Block=greekextended}', "");
    Expect(0, 8191, '\p{^Is_Block=greekextended}', "");
    Expect(0, 8191, '\P{Is_Block=greekextended}', "");
    Expect(1, 8191, '\P{^Is_Block=greekextended}', "");
    Expect(0, 8192, '\p{Is_Block=greekextended}', "");
    Expect(1, 8192, '\p{^Is_Block=greekextended}', "");
    Expect(1, 8192, '\P{Is_Block=greekextended}', "");
    Expect(0, 8192, '\P{^Is_Block=greekextended}', "");
    Expect(1, 8191, '\p{Is_Block:	 Greek_EXTENDED}', "");
    Expect(0, 8191, '\p{^Is_Block:	 Greek_EXTENDED}', "");
    Expect(0, 8191, '\P{Is_Block:	 Greek_EXTENDED}', "");
    Expect(1, 8191, '\P{^Is_Block:	 Greek_EXTENDED}', "");
    Expect(0, 8192, '\p{Is_Block:	 Greek_EXTENDED}', "");
    Expect(1, 8192, '\p{^Is_Block:	 Greek_EXTENDED}', "");
    Expect(1, 8192, '\P{Is_Block:	 Greek_EXTENDED}', "");
    Expect(0, 8192, '\P{^Is_Block:	 Greek_EXTENDED}', "");
    Error('\p{Is_Blk=/a/-	Greek_Ext}');
    Error('\P{Is_Blk=/a/-	Greek_Ext}');
    Expect(1, 8191, '\p{Is_Blk=greekext}', "");
    Expect(0, 8191, '\p{^Is_Blk=greekext}', "");
    Expect(0, 8191, '\P{Is_Blk=greekext}', "");
    Expect(1, 8191, '\P{^Is_Blk=greekext}', "");
    Expect(0, 8192, '\p{Is_Blk=greekext}', "");
    Expect(1, 8192, '\p{^Is_Blk=greekext}', "");
    Expect(1, 8192, '\P{Is_Blk=greekext}', "");
    Expect(0, 8192, '\P{^Is_Blk=greekext}', "");
    Expect(1, 8191, '\p{Is_Blk=--greek_Ext}', "");
    Expect(0, 8191, '\p{^Is_Blk=--greek_Ext}', "");
    Expect(0, 8191, '\P{Is_Blk=--greek_Ext}', "");
    Expect(1, 8191, '\P{^Is_Blk=--greek_Ext}', "");
    Expect(0, 8192, '\p{Is_Blk=--greek_Ext}', "");
    Expect(1, 8192, '\p{^Is_Blk=--greek_Ext}', "");
    Expect(1, 8192, '\P{Is_Blk=--greek_Ext}', "");
    Expect(0, 8192, '\P{^Is_Blk=--greek_Ext}', "");
    Error('\p{Block=_:=gujarati}');
    Error('\P{Block=_:=gujarati}');
    Expect(1, 2815, '\p{Block=:\AGujarati\z:}', "");;
    Expect(0, 2816, '\p{Block=:\AGujarati\z:}', "");;
    Expect(1, 2815, '\p{Block=gujarati}', "");
    Expect(0, 2815, '\p{^Block=gujarati}', "");
    Expect(0, 2815, '\P{Block=gujarati}', "");
    Expect(1, 2815, '\P{^Block=gujarati}', "");
    Expect(0, 2816, '\p{Block=gujarati}', "");
    Expect(1, 2816, '\p{^Block=gujarati}', "");
    Expect(1, 2816, '\P{Block=gujarati}', "");
    Expect(0, 2816, '\P{^Block=gujarati}', "");
    Expect(1, 2815, '\p{Block=:\Agujarati\z:}', "");;
    Expect(0, 2816, '\p{Block=:\Agujarati\z:}', "");;
    Expect(1, 2815, '\p{Block=- GUJARATI}', "");
    Expect(0, 2815, '\p{^Block=- GUJARATI}', "");
    Expect(0, 2815, '\P{Block=- GUJARATI}', "");
    Expect(1, 2815, '\P{^Block=- GUJARATI}', "");
    Expect(0, 2816, '\p{Block=- GUJARATI}', "");
    Expect(1, 2816, '\p{^Block=- GUJARATI}', "");
    Expect(1, 2816, '\P{Block=- GUJARATI}', "");
    Expect(0, 2816, '\P{^Block=- GUJARATI}', "");
    Error('\p{Blk=/a/_GUJARATI}');
    Error('\P{Blk=/a/_GUJARATI}');
    Expect(1, 2815, '\p{Blk=:\AGujarati\z:}', "");;
    Expect(0, 2816, '\p{Blk=:\AGujarati\z:}', "");;
    Expect(1, 2815, '\p{Blk=gujarati}', "");
    Expect(0, 2815, '\p{^Blk=gujarati}', "");
    Expect(0, 2815, '\P{Blk=gujarati}', "");
    Expect(1, 2815, '\P{^Blk=gujarati}', "");
    Expect(0, 2816, '\p{Blk=gujarati}', "");
    Expect(1, 2816, '\p{^Blk=gujarati}', "");
    Expect(1, 2816, '\P{Blk=gujarati}', "");
    Expect(0, 2816, '\P{^Blk=gujarati}', "");
    Expect(1, 2815, '\p{Blk=:\Agujarati\z:}', "");;
    Expect(0, 2816, '\p{Blk=:\Agujarati\z:}', "");;
    Expect(1, 2815, '\p{Blk=--Gujarati}', "");
    Expect(0, 2815, '\p{^Blk=--Gujarati}', "");
    Expect(0, 2815, '\P{Blk=--Gujarati}', "");
    Expect(1, 2815, '\P{^Blk=--Gujarati}', "");
    Expect(0, 2816, '\p{Blk=--Gujarati}', "");
    Expect(1, 2816, '\p{^Blk=--Gujarati}', "");
    Expect(1, 2816, '\P{Blk=--Gujarati}', "");
    Expect(0, 2816, '\P{^Blk=--Gujarati}', "");
    Error('\p{Is_Block=	:=gujarati}');
    Error('\P{Is_Block=	:=gujarati}');
    Expect(1, 2815, '\p{Is_Block=gujarati}', "");
    Expect(0, 2815, '\p{^Is_Block=gujarati}', "");
    Expect(0, 2815, '\P{Is_Block=gujarati}', "");
    Expect(1, 2815, '\P{^Is_Block=gujarati}', "");
    Expect(0, 2816, '\p{Is_Block=gujarati}', "");
    Expect(1, 2816, '\p{^Is_Block=gujarati}', "");
    Expect(1, 2816, '\P{Is_Block=gujarati}', "");
    Expect(0, 2816, '\P{^Is_Block=gujarati}', "");
    Expect(1, 2815, '\p{Is_Block=	Gujarati}', "");
    Expect(0, 2815, '\p{^Is_Block=	Gujarati}', "");
    Expect(0, 2815, '\P{Is_Block=	Gujarati}', "");
    Expect(1, 2815, '\P{^Is_Block=	Gujarati}', "");
    Expect(0, 2816, '\p{Is_Block=	Gujarati}', "");
    Expect(1, 2816, '\p{^Is_Block=	Gujarati}', "");
    Expect(1, 2816, '\P{Is_Block=	Gujarati}', "");
    Expect(0, 2816, '\P{^Is_Block=	Gujarati}', "");
    Error('\p{Is_Blk:	GUJARATI/a/}');
    Error('\P{Is_Blk:	GUJARATI/a/}');
    Expect(1, 2815, '\p{Is_Blk=gujarati}', "");
    Expect(0, 2815, '\p{^Is_Blk=gujarati}', "");
    Expect(0, 2815, '\P{Is_Blk=gujarati}', "");
    Expect(1, 2815, '\P{^Is_Blk=gujarati}', "");
    Expect(0, 2816, '\p{Is_Blk=gujarati}', "");
    Expect(1, 2816, '\p{^Is_Blk=gujarati}', "");
    Expect(1, 2816, '\P{Is_Blk=gujarati}', "");
    Expect(0, 2816, '\P{^Is_Blk=gujarati}', "");
    Expect(1, 2815, '\p{Is_Blk: -_Gujarati}', "");
    Expect(0, 2815, '\p{^Is_Blk: -_Gujarati}', "");
    Expect(0, 2815, '\P{Is_Blk: -_Gujarati}', "");
    Expect(1, 2815, '\P{^Is_Blk: -_Gujarati}', "");
    Expect(0, 2816, '\p{Is_Blk: -_Gujarati}', "");
    Expect(1, 2816, '\p{^Is_Blk: -_Gujarati}', "");
    Expect(1, 2816, '\P{Is_Blk: -_Gujarati}', "");
    Expect(0, 2816, '\P{^Is_Blk: -_Gujarati}', "");
    Error('\p{Block=-:=gunjala_Gondi}');
    Error('\P{Block=-:=gunjala_Gondi}');
    Expect(1, 73135, '\p{Block=:\AGunjala_Gondi\z:}', "");;
    Expect(0, 73136, '\p{Block=:\AGunjala_Gondi\z:}', "");;
    Expect(1, 73135, '\p{Block=gunjalagondi}', "");
    Expect(0, 73135, '\p{^Block=gunjalagondi}', "");
    Expect(0, 73135, '\P{Block=gunjalagondi}', "");
    Expect(1, 73135, '\P{^Block=gunjalagondi}', "");
    Expect(0, 73136, '\p{Block=gunjalagondi}', "");
    Expect(1, 73136, '\p{^Block=gunjalagondi}', "");
    Expect(1, 73136, '\P{Block=gunjalagondi}', "");
    Expect(0, 73136, '\P{^Block=gunjalagondi}', "");
    Expect(1, 73135, '\p{Block=:\Agunjalagondi\z:}', "");;
    Expect(0, 73136, '\p{Block=:\Agunjalagondi\z:}', "");;
    Expect(1, 73135, '\p{Block=  GUNJALA_GONDI}', "");
    Expect(0, 73135, '\p{^Block=  GUNJALA_GONDI}', "");
    Expect(0, 73135, '\P{Block=  GUNJALA_GONDI}', "");
    Expect(1, 73135, '\P{^Block=  GUNJALA_GONDI}', "");
    Expect(0, 73136, '\p{Block=  GUNJALA_GONDI}', "");
    Expect(1, 73136, '\p{^Block=  GUNJALA_GONDI}', "");
    Expect(1, 73136, '\P{Block=  GUNJALA_GONDI}', "");
    Expect(0, 73136, '\P{^Block=  GUNJALA_GONDI}', "");
    Error('\p{Blk=_Gunjala_Gondi/a/}');
    Error('\P{Blk=_Gunjala_Gondi/a/}');
    Expect(1, 73135, '\p{Blk=:\AGunjala_Gondi\z:}', "");;
    Expect(0, 73136, '\p{Blk=:\AGunjala_Gondi\z:}', "");;
    Expect(1, 73135, '\p{Blk=gunjalagondi}', "");
    Expect(0, 73135, '\p{^Blk=gunjalagondi}', "");
    Expect(0, 73135, '\P{Blk=gunjalagondi}', "");
    Expect(1, 73135, '\P{^Blk=gunjalagondi}', "");
    Expect(0, 73136, '\p{Blk=gunjalagondi}', "");
    Expect(1, 73136, '\p{^Blk=gunjalagondi}', "");
    Expect(1, 73136, '\P{Blk=gunjalagondi}', "");
    Expect(0, 73136, '\P{^Blk=gunjalagondi}', "");
    Expect(1, 73135, '\p{Blk=:\Agunjalagondi\z:}', "");;
    Expect(0, 73136, '\p{Blk=:\Agunjalagondi\z:}', "");;
    Expect(1, 73135, '\p{Blk=_	gunjala_gondi}', "");
    Expect(0, 73135, '\p{^Blk=_	gunjala_gondi}', "");
    Expect(0, 73135, '\P{Blk=_	gunjala_gondi}', "");
    Expect(1, 73135, '\P{^Blk=_	gunjala_gondi}', "");
    Expect(0, 73136, '\p{Blk=_	gunjala_gondi}', "");
    Expect(1, 73136, '\p{^Blk=_	gunjala_gondi}', "");
    Expect(1, 73136, '\P{Blk=_	gunjala_gondi}', "");
    Expect(0, 73136, '\P{^Blk=_	gunjala_gondi}', "");
    Error('\p{Is_Block= gunjala_GONDI/a/}');
    Error('\P{Is_Block= gunjala_GONDI/a/}');
    Expect(1, 73135, '\p{Is_Block=gunjalagondi}', "");
    Expect(0, 73135, '\p{^Is_Block=gunjalagondi}', "");
    Expect(0, 73135, '\P{Is_Block=gunjalagondi}', "");
    Expect(1, 73135, '\P{^Is_Block=gunjalagondi}', "");
    Expect(0, 73136, '\p{Is_Block=gunjalagondi}', "");
    Expect(1, 73136, '\p{^Is_Block=gunjalagondi}', "");
    Expect(1, 73136, '\P{Is_Block=gunjalagondi}', "");
    Expect(0, 73136, '\P{^Is_Block=gunjalagondi}', "");
    Expect(1, 73135, '\p{Is_Block=- gunjala_gondi}', "");
    Expect(0, 73135, '\p{^Is_Block=- gunjala_gondi}', "");
    Expect(0, 73135, '\P{Is_Block=- gunjala_gondi}', "");
    Expect(1, 73135, '\P{^Is_Block=- gunjala_gondi}', "");
    Expect(0, 73136, '\p{Is_Block=- gunjala_gondi}', "");
    Expect(1, 73136, '\p{^Is_Block=- gunjala_gondi}', "");
    Expect(1, 73136, '\P{Is_Block=- gunjala_gondi}', "");
    Expect(0, 73136, '\P{^Is_Block=- gunjala_gondi}', "");
    Error('\p{Is_Blk= :=GUNJALA_GONDI}');
    Error('\P{Is_Blk= :=GUNJALA_GONDI}');
    Expect(1, 73135, '\p{Is_Blk:   gunjalagondi}', "");
    Expect(0, 73135, '\p{^Is_Blk:   gunjalagondi}', "");
    Expect(0, 73135, '\P{Is_Blk:   gunjalagondi}', "");
    Expect(1, 73135, '\P{^Is_Blk:   gunjalagondi}', "");
    Expect(0, 73136, '\p{Is_Blk:   gunjalagondi}', "");
    Expect(1, 73136, '\p{^Is_Blk:   gunjalagondi}', "");
    Expect(1, 73136, '\P{Is_Blk:   gunjalagondi}', "");
    Expect(0, 73136, '\P{^Is_Blk:   gunjalagondi}', "");
    Expect(1, 73135, '\p{Is_Blk= _Gunjala_Gondi}', "");
    Expect(0, 73135, '\p{^Is_Blk= _Gunjala_Gondi}', "");
    Expect(0, 73135, '\P{Is_Blk= _Gunjala_Gondi}', "");
    Expect(1, 73135, '\P{^Is_Blk= _Gunjala_Gondi}', "");
    Expect(0, 73136, '\p{Is_Blk= _Gunjala_Gondi}', "");
    Expect(1, 73136, '\p{^Is_Blk= _Gunjala_Gondi}', "");
    Expect(1, 73136, '\P{Is_Blk= _Gunjala_Gondi}', "");
    Expect(0, 73136, '\P{^Is_Blk= _Gunjala_Gondi}', "");
    Error('\p{Block=	_gurmukhi:=}');
    Error('\P{Block=	_gurmukhi:=}');
    Expect(1, 2687, '\p{Block=:\AGurmukhi\z:}', "");;
    Expect(0, 2688, '\p{Block=:\AGurmukhi\z:}', "");;
    Expect(1, 2687, '\p{Block=gurmukhi}', "");
    Expect(0, 2687, '\p{^Block=gurmukhi}', "");
    Expect(0, 2687, '\P{Block=gurmukhi}', "");
    Expect(1, 2687, '\P{^Block=gurmukhi}', "");
    Expect(0, 2688, '\p{Block=gurmukhi}', "");
    Expect(1, 2688, '\p{^Block=gurmukhi}', "");
    Expect(1, 2688, '\P{Block=gurmukhi}', "");
    Expect(0, 2688, '\P{^Block=gurmukhi}', "");
    Expect(1, 2687, '\p{Block=:\Agurmukhi\z:}', "");;
    Expect(0, 2688, '\p{Block=:\Agurmukhi\z:}', "");;
    Expect(1, 2687, '\p{Block: __Gurmukhi}', "");
    Expect(0, 2687, '\p{^Block: __Gurmukhi}', "");
    Expect(0, 2687, '\P{Block: __Gurmukhi}', "");
    Expect(1, 2687, '\P{^Block: __Gurmukhi}', "");
    Expect(0, 2688, '\p{Block: __Gurmukhi}', "");
    Expect(1, 2688, '\p{^Block: __Gurmukhi}', "");
    Expect(1, 2688, '\P{Block: __Gurmukhi}', "");
    Expect(0, 2688, '\P{^Block: __Gurmukhi}', "");
    Error('\p{Blk=_GURMUKHI:=}');
    Error('\P{Blk=_GURMUKHI:=}');
    Expect(1, 2687, '\p{Blk=:\AGurmukhi\z:}', "");;
    Expect(0, 2688, '\p{Blk=:\AGurmukhi\z:}', "");;
    Expect(1, 2687, '\p{Blk=gurmukhi}', "");
    Expect(0, 2687, '\p{^Blk=gurmukhi}', "");
    Expect(0, 2687, '\P{Blk=gurmukhi}', "");
    Expect(1, 2687, '\P{^Blk=gurmukhi}', "");
    Expect(0, 2688, '\p{Blk=gurmukhi}', "");
    Expect(1, 2688, '\p{^Blk=gurmukhi}', "");
    Expect(1, 2688, '\P{Blk=gurmukhi}', "");
    Expect(0, 2688, '\P{^Blk=gurmukhi}', "");
    Expect(1, 2687, '\p{Blk=:\Agurmukhi\z:}', "");;
    Expect(0, 2688, '\p{Blk=:\Agurmukhi\z:}', "");;
    Expect(1, 2687, '\p{Blk=	_GURMUKHI}', "");
    Expect(0, 2687, '\p{^Blk=	_GURMUKHI}', "");
    Expect(0, 2687, '\P{Blk=	_GURMUKHI}', "");
    Expect(1, 2687, '\P{^Blk=	_GURMUKHI}', "");
    Expect(0, 2688, '\p{Blk=	_GURMUKHI}', "");
    Expect(1, 2688, '\p{^Blk=	_GURMUKHI}', "");
    Expect(1, 2688, '\P{Blk=	_GURMUKHI}', "");
    Expect(0, 2688, '\P{^Blk=	_GURMUKHI}', "");
    Error('\p{Is_Block=_ Gurmukhi/a/}');
    Error('\P{Is_Block=_ Gurmukhi/a/}');
    Expect(1, 2687, '\p{Is_Block=gurmukhi}', "");
    Expect(0, 2687, '\p{^Is_Block=gurmukhi}', "");
    Expect(0, 2687, '\P{Is_Block=gurmukhi}', "");
    Expect(1, 2687, '\P{^Is_Block=gurmukhi}', "");
    Expect(0, 2688, '\p{Is_Block=gurmukhi}', "");
    Expect(1, 2688, '\p{^Is_Block=gurmukhi}', "");
    Expect(1, 2688, '\P{Is_Block=gurmukhi}', "");
    Expect(0, 2688, '\P{^Is_Block=gurmukhi}', "");
    Expect(1, 2687, '\p{Is_Block=_ GURMUKHI}', "");
    Expect(0, 2687, '\p{^Is_Block=_ GURMUKHI}', "");
    Expect(0, 2687, '\P{Is_Block=_ GURMUKHI}', "");
    Expect(1, 2687, '\P{^Is_Block=_ GURMUKHI}', "");
    Expect(0, 2688, '\p{Is_Block=_ GURMUKHI}', "");
    Expect(1, 2688, '\p{^Is_Block=_ GURMUKHI}', "");
    Expect(1, 2688, '\P{Is_Block=_ GURMUKHI}', "");
    Expect(0, 2688, '\P{^Is_Block=_ GURMUKHI}', "");
    Error('\p{Is_Blk=- gurmukhi:=}');
    Error('\P{Is_Blk=- gurmukhi:=}');
    Expect(1, 2687, '\p{Is_Blk=gurmukhi}', "");
    Expect(0, 2687, '\p{^Is_Blk=gurmukhi}', "");
    Expect(0, 2687, '\P{Is_Blk=gurmukhi}', "");
    Expect(1, 2687, '\P{^Is_Blk=gurmukhi}', "");
    Expect(0, 2688, '\p{Is_Blk=gurmukhi}', "");
    Expect(1, 2688, '\p{^Is_Blk=gurmukhi}', "");
    Expect(1, 2688, '\P{Is_Blk=gurmukhi}', "");
    Expect(0, 2688, '\P{^Is_Blk=gurmukhi}', "");
    Expect(1, 2687, '\p{Is_Blk=-gurmukhi}', "");
    Expect(0, 2687, '\p{^Is_Blk=-gurmukhi}', "");
    Expect(0, 2687, '\P{Is_Blk=-gurmukhi}', "");
    Expect(1, 2687, '\P{^Is_Blk=-gurmukhi}', "");
    Expect(0, 2688, '\p{Is_Blk=-gurmukhi}', "");
    Expect(1, 2688, '\p{^Is_Blk=-gurmukhi}', "");
    Expect(1, 2688, '\P{Is_Blk=-gurmukhi}', "");
    Expect(0, 2688, '\P{^Is_Blk=-gurmukhi}', "");
    Error('\p{Block=-/a/Halfwidth_And_FULLWIDTH_FORMS}');
    Error('\P{Block=-/a/Halfwidth_And_FULLWIDTH_FORMS}');
    Expect(1, 65519, '\p{Block=:\AHalfwidth_And_Fullwidth_Forms\z:}', "");;
    Expect(0, 65520, '\p{Block=:\AHalfwidth_And_Fullwidth_Forms\z:}', "");;
    Expect(1, 65519, '\p{Block=halfwidthandfullwidthforms}', "");
    Expect(0, 65519, '\p{^Block=halfwidthandfullwidthforms}', "");
    Expect(0, 65519, '\P{Block=halfwidthandfullwidthforms}', "");
    Expect(1, 65519, '\P{^Block=halfwidthandfullwidthforms}', "");
    Expect(0, 65520, '\p{Block=halfwidthandfullwidthforms}', "");
    Expect(1, 65520, '\p{^Block=halfwidthandfullwidthforms}', "");
    Expect(1, 65520, '\P{Block=halfwidthandfullwidthforms}', "");
    Expect(0, 65520, '\P{^Block=halfwidthandfullwidthforms}', "");
    Expect(1, 65519, '\p{Block=:\Ahalfwidthandfullwidthforms\z:}', "");;
    Expect(0, 65520, '\p{Block=:\Ahalfwidthandfullwidthforms\z:}', "");;
    Expect(1, 65519, '\p{Block=	HALFWIDTH_and_Fullwidth_forms}', "");
    Expect(0, 65519, '\p{^Block=	HALFWIDTH_and_Fullwidth_forms}', "");
    Expect(0, 65519, '\P{Block=	HALFWIDTH_and_Fullwidth_forms}', "");
    Expect(1, 65519, '\P{^Block=	HALFWIDTH_and_Fullwidth_forms}', "");
    Expect(0, 65520, '\p{Block=	HALFWIDTH_and_Fullwidth_forms}', "");
    Expect(1, 65520, '\p{^Block=	HALFWIDTH_and_Fullwidth_forms}', "");
    Expect(1, 65520, '\P{Block=	HALFWIDTH_and_Fullwidth_forms}', "");
    Expect(0, 65520, '\P{^Block=	HALFWIDTH_and_Fullwidth_forms}', "");
    Error('\p{Blk=__half_And_full_forms:=}');
    Error('\P{Blk=__half_And_full_forms:=}');
    Expect(1, 65519, '\p{Blk=:\AHalf_And_Full_Forms\z:}', "");;
    Expect(0, 65520, '\p{Blk=:\AHalf_And_Full_Forms\z:}', "");;
    Expect(1, 65519, '\p{Blk=halfandfullforms}', "");
    Expect(0, 65519, '\p{^Blk=halfandfullforms}', "");
    Expect(0, 65519, '\P{Blk=halfandfullforms}', "");
    Expect(1, 65519, '\P{^Blk=halfandfullforms}', "");
    Expect(0, 65520, '\p{Blk=halfandfullforms}', "");
    Expect(1, 65520, '\p{^Blk=halfandfullforms}', "");
    Expect(1, 65520, '\P{Blk=halfandfullforms}', "");
    Expect(0, 65520, '\P{^Blk=halfandfullforms}', "");
    Expect(1, 65519, '\p{Blk=:\Ahalfandfullforms\z:}', "");;
    Expect(0, 65520, '\p{Blk=:\Ahalfandfullforms\z:}', "");;
    Expect(1, 65519, '\p{Blk:   --HALF_AND_Full_Forms}', "");
    Expect(0, 65519, '\p{^Blk:   --HALF_AND_Full_Forms}', "");
    Expect(0, 65519, '\P{Blk:   --HALF_AND_Full_Forms}', "");
    Expect(1, 65519, '\P{^Blk:   --HALF_AND_Full_Forms}', "");
    Expect(0, 65520, '\p{Blk:   --HALF_AND_Full_Forms}', "");
    Expect(1, 65520, '\p{^Blk:   --HALF_AND_Full_Forms}', "");
    Expect(1, 65520, '\P{Blk:   --HALF_AND_Full_Forms}', "");
    Expect(0, 65520, '\P{^Blk:   --HALF_AND_Full_Forms}', "");
    Error('\p{Is_Block=-HALFWIDTH_And_Fullwidth_Forms:=}');
    Error('\P{Is_Block=-HALFWIDTH_And_Fullwidth_Forms:=}');
    Expect(1, 65519, '\p{Is_Block=halfwidthandfullwidthforms}', "");
    Expect(0, 65519, '\p{^Is_Block=halfwidthandfullwidthforms}', "");
    Expect(0, 65519, '\P{Is_Block=halfwidthandfullwidthforms}', "");
    Expect(1, 65519, '\P{^Is_Block=halfwidthandfullwidthforms}', "");
    Expect(0, 65520, '\p{Is_Block=halfwidthandfullwidthforms}', "");
    Expect(1, 65520, '\p{^Is_Block=halfwidthandfullwidthforms}', "");
    Expect(1, 65520, '\P{Is_Block=halfwidthandfullwidthforms}', "");
    Expect(0, 65520, '\P{^Is_Block=halfwidthandfullwidthforms}', "");
    Expect(1, 65519, '\p{Is_Block=-	halfwidth_AND_fullwidth_FORMS}', "");
    Expect(0, 65519, '\p{^Is_Block=-	halfwidth_AND_fullwidth_FORMS}', "");
    Expect(0, 65519, '\P{Is_Block=-	halfwidth_AND_fullwidth_FORMS}', "");
    Expect(1, 65519, '\P{^Is_Block=-	halfwidth_AND_fullwidth_FORMS}', "");
    Expect(0, 65520, '\p{Is_Block=-	halfwidth_AND_fullwidth_FORMS}', "");
    Expect(1, 65520, '\p{^Is_Block=-	halfwidth_AND_fullwidth_FORMS}', "");
    Expect(1, 65520, '\P{Is_Block=-	halfwidth_AND_fullwidth_FORMS}', "");
    Expect(0, 65520, '\P{^Is_Block=-	halfwidth_AND_fullwidth_FORMS}', "");
    Error('\p{Is_Blk=_Half_and_FULL_FORMS:=}');
    Error('\P{Is_Blk=_Half_and_FULL_FORMS:=}');
    Expect(1, 65519, '\p{Is_Blk=halfandfullforms}', "");
    Expect(0, 65519, '\p{^Is_Blk=halfandfullforms}', "");
    Expect(0, 65519, '\P{Is_Blk=halfandfullforms}', "");
    Expect(1, 65519, '\P{^Is_Blk=halfandfullforms}', "");
    Expect(0, 65520, '\p{Is_Blk=halfandfullforms}', "");
    Expect(1, 65520, '\p{^Is_Blk=halfandfullforms}', "");
    Expect(1, 65520, '\P{Is_Blk=halfandfullforms}', "");
    Expect(0, 65520, '\P{^Is_Blk=halfandfullforms}', "");
    Expect(1, 65519, '\p{Is_Blk=	_half_And_full_Forms}', "");
    Expect(0, 65519, '\p{^Is_Blk=	_half_And_full_Forms}', "");
    Expect(0, 65519, '\P{Is_Blk=	_half_And_full_Forms}', "");
    Expect(1, 65519, '\P{^Is_Blk=	_half_And_full_Forms}', "");
    Expect(0, 65520, '\p{Is_Blk=	_half_And_full_Forms}', "");
    Expect(1, 65520, '\p{^Is_Blk=	_half_And_full_Forms}', "");
    Expect(1, 65520, '\P{Is_Blk=	_half_And_full_Forms}', "");
    Expect(0, 65520, '\P{^Is_Blk=	_half_And_full_Forms}', "");
    Error('\p{Block= COMBINING_Half_Marks:=}');
    Error('\P{Block= COMBINING_Half_Marks:=}');
    Expect(1, 65071, '\p{Block=:\ACombining_Half_Marks\z:}', "");;
    Expect(0, 65072, '\p{Block=:\ACombining_Half_Marks\z:}', "");;
    Expect(1, 65071, '\p{Block=combininghalfmarks}', "");
    Expect(0, 65071, '\p{^Block=combininghalfmarks}', "");
    Expect(0, 65071, '\P{Block=combininghalfmarks}', "");
    Expect(1, 65071, '\P{^Block=combininghalfmarks}', "");
    Expect(0, 65072, '\p{Block=combininghalfmarks}', "");
    Expect(1, 65072, '\p{^Block=combininghalfmarks}', "");
    Expect(1, 65072, '\P{Block=combininghalfmarks}', "");
    Expect(0, 65072, '\P{^Block=combininghalfmarks}', "");
    Expect(1, 65071, '\p{Block=:\Acombininghalfmarks\z:}', "");;
    Expect(0, 65072, '\p{Block=:\Acombininghalfmarks\z:}', "");;
    Expect(1, 65071, '\p{Block=  COMBINING_Half_MARKS}', "");
    Expect(0, 65071, '\p{^Block=  COMBINING_Half_MARKS}', "");
    Expect(0, 65071, '\P{Block=  COMBINING_Half_MARKS}', "");
    Expect(1, 65071, '\P{^Block=  COMBINING_Half_MARKS}', "");
    Expect(0, 65072, '\p{Block=  COMBINING_Half_MARKS}', "");
    Expect(1, 65072, '\p{^Block=  COMBINING_Half_MARKS}', "");
    Expect(1, 65072, '\P{Block=  COMBINING_Half_MARKS}', "");
    Expect(0, 65072, '\P{^Block=  COMBINING_Half_MARKS}', "");
    Error('\p{Blk=_/a/HALF_Marks}');
    Error('\P{Blk=_/a/HALF_Marks}');
    Expect(1, 65071, '\p{Blk=:\AHalf_Marks\z:}', "");;
    Expect(0, 65072, '\p{Blk=:\AHalf_Marks\z:}', "");;
    Expect(1, 65071, '\p{Blk=halfmarks}', "");
    Expect(0, 65071, '\p{^Blk=halfmarks}', "");
    Expect(0, 65071, '\P{Blk=halfmarks}', "");
    Expect(1, 65071, '\P{^Blk=halfmarks}', "");
    Expect(0, 65072, '\p{Blk=halfmarks}', "");
    Expect(1, 65072, '\p{^Blk=halfmarks}', "");
    Expect(1, 65072, '\P{Blk=halfmarks}', "");
    Expect(0, 65072, '\P{^Blk=halfmarks}', "");
    Expect(1, 65071, '\p{Blk=:\Ahalfmarks\z:}', "");;
    Expect(0, 65072, '\p{Blk=:\Ahalfmarks\z:}', "");;
    Expect(1, 65071, '\p{Blk= Half_marks}', "");
    Expect(0, 65071, '\p{^Blk= Half_marks}', "");
    Expect(0, 65071, '\P{Blk= Half_marks}', "");
    Expect(1, 65071, '\P{^Blk= Half_marks}', "");
    Expect(0, 65072, '\p{Blk= Half_marks}', "");
    Expect(1, 65072, '\p{^Blk= Half_marks}', "");
    Expect(1, 65072, '\P{Blk= Half_marks}', "");
    Expect(0, 65072, '\P{^Blk= Half_marks}', "");
    Error('\p{Is_Block=__combining_half_Marks/a/}');
    Error('\P{Is_Block=__combining_half_Marks/a/}');
    Expect(1, 65071, '\p{Is_Block=combininghalfmarks}', "");
    Expect(0, 65071, '\p{^Is_Block=combininghalfmarks}', "");
    Expect(0, 65071, '\P{Is_Block=combininghalfmarks}', "");
    Expect(1, 65071, '\P{^Is_Block=combininghalfmarks}', "");
    Expect(0, 65072, '\p{Is_Block=combininghalfmarks}', "");
    Expect(1, 65072, '\p{^Is_Block=combininghalfmarks}', "");
    Expect(1, 65072, '\P{Is_Block=combininghalfmarks}', "");
    Expect(0, 65072, '\P{^Is_Block=combininghalfmarks}', "");
    Expect(1, 65071, '\p{Is_Block=	Combining_HALF_Marks}', "");
    Expect(0, 65071, '\p{^Is_Block=	Combining_HALF_Marks}', "");
    Expect(0, 65071, '\P{Is_Block=	Combining_HALF_Marks}', "");
    Expect(1, 65071, '\P{^Is_Block=	Combining_HALF_Marks}', "");
    Expect(0, 65072, '\p{Is_Block=	Combining_HALF_Marks}', "");
    Expect(1, 65072, '\p{^Is_Block=	Combining_HALF_Marks}', "");
    Expect(1, 65072, '\P{Is_Block=	Combining_HALF_Marks}', "");
    Expect(0, 65072, '\P{^Is_Block=	Combining_HALF_Marks}', "");
    Error('\p{Is_Blk=_-Half_Marks/a/}');
    Error('\P{Is_Blk=_-Half_Marks/a/}');
    Expect(1, 65071, '\p{Is_Blk=halfmarks}', "");
    Expect(0, 65071, '\p{^Is_Blk=halfmarks}', "");
    Expect(0, 65071, '\P{Is_Blk=halfmarks}', "");
    Expect(1, 65071, '\P{^Is_Blk=halfmarks}', "");
    Expect(0, 65072, '\p{Is_Blk=halfmarks}', "");
    Expect(1, 65072, '\p{^Is_Blk=halfmarks}', "");
    Expect(1, 65072, '\P{Is_Blk=halfmarks}', "");
    Expect(0, 65072, '\P{^Is_Blk=halfmarks}', "");
    Expect(1, 65071, '\p{Is_Blk=	 half_marks}', "");
    Expect(0, 65071, '\p{^Is_Blk=	 half_marks}', "");
    Expect(0, 65071, '\P{Is_Blk=	 half_marks}', "");
    Expect(1, 65071, '\P{^Is_Blk=	 half_marks}', "");
    Expect(0, 65072, '\p{Is_Blk=	 half_marks}', "");
    Expect(1, 65072, '\p{^Is_Blk=	 half_marks}', "");
    Expect(1, 65072, '\P{Is_Blk=	 half_marks}', "");
    Expect(0, 65072, '\P{^Is_Blk=	 half_marks}', "");
    Error('\p{Block=/a/_ Hangul_syllables}');
    Error('\P{Block=/a/_ Hangul_syllables}');
    Expect(1, 55215, '\p{Block=:\AHangul_Syllables\z:}', "");;
    Expect(0, 55216, '\p{Block=:\AHangul_Syllables\z:}', "");;
    Expect(1, 55215, '\p{Block=hangulsyllables}', "");
    Expect(0, 55215, '\p{^Block=hangulsyllables}', "");
    Expect(0, 55215, '\P{Block=hangulsyllables}', "");
    Expect(1, 55215, '\P{^Block=hangulsyllables}', "");
    Expect(0, 55216, '\p{Block=hangulsyllables}', "");
    Expect(1, 55216, '\p{^Block=hangulsyllables}', "");
    Expect(1, 55216, '\P{Block=hangulsyllables}', "");
    Expect(0, 55216, '\P{^Block=hangulsyllables}', "");
    Expect(1, 55215, '\p{Block=:\Ahangulsyllables\z:}', "");;
    Expect(0, 55216, '\p{Block=:\Ahangulsyllables\z:}', "");;
    Expect(1, 55215, '\p{Block= hangul_SYLLABLES}', "");
    Expect(0, 55215, '\p{^Block= hangul_SYLLABLES}', "");
    Expect(0, 55215, '\P{Block= hangul_SYLLABLES}', "");
    Expect(1, 55215, '\P{^Block= hangul_SYLLABLES}', "");
    Expect(0, 55216, '\p{Block= hangul_SYLLABLES}', "");
    Expect(1, 55216, '\p{^Block= hangul_SYLLABLES}', "");
    Expect(1, 55216, '\P{Block= hangul_SYLLABLES}', "");
    Expect(0, 55216, '\P{^Block= hangul_SYLLABLES}', "");
    Error('\p{Blk=-HANGUL/a/}');
    Error('\P{Blk=-HANGUL/a/}');
    Expect(1, 55215, '\p{Blk=:\AHangul\z:}', "");;
    Expect(0, 55216, '\p{Blk=:\AHangul\z:}', "");;
    Expect(1, 55215, '\p{Blk=hangul}', "");
    Expect(0, 55215, '\p{^Blk=hangul}', "");
    Expect(0, 55215, '\P{Blk=hangul}', "");
    Expect(1, 55215, '\P{^Blk=hangul}', "");
    Expect(0, 55216, '\p{Blk=hangul}', "");
    Expect(1, 55216, '\p{^Blk=hangul}', "");
    Expect(1, 55216, '\P{Blk=hangul}', "");
    Expect(0, 55216, '\P{^Blk=hangul}', "");
    Expect(1, 55215, '\p{Blk=:\Ahangul\z:}', "");;
    Expect(0, 55216, '\p{Blk=:\Ahangul\z:}', "");;
    Expect(1, 55215, '\p{Blk=- Hangul}', "");
    Expect(0, 55215, '\p{^Blk=- Hangul}', "");
    Expect(0, 55215, '\P{Blk=- Hangul}', "");
    Expect(1, 55215, '\P{^Blk=- Hangul}', "");
    Expect(0, 55216, '\p{Blk=- Hangul}', "");
    Expect(1, 55216, '\p{^Blk=- Hangul}', "");
    Expect(1, 55216, '\P{Blk=- Hangul}', "");
    Expect(0, 55216, '\P{^Blk=- Hangul}', "");
    Error('\p{Is_Block= Hangul_Syllables/a/}');
    Error('\P{Is_Block= Hangul_Syllables/a/}');
    Expect(1, 55215, '\p{Is_Block=hangulsyllables}', "");
    Expect(0, 55215, '\p{^Is_Block=hangulsyllables}', "");
    Expect(0, 55215, '\P{Is_Block=hangulsyllables}', "");
    Expect(1, 55215, '\P{^Is_Block=hangulsyllables}', "");
    Expect(0, 55216, '\p{Is_Block=hangulsyllables}', "");
    Expect(1, 55216, '\p{^Is_Block=hangulsyllables}', "");
    Expect(1, 55216, '\P{Is_Block=hangulsyllables}', "");
    Expect(0, 55216, '\P{^Is_Block=hangulsyllables}', "");
    Expect(1, 55215, '\p{Is_Block:	-	hangul_SYLLABLES}', "");
    Expect(0, 55215, '\p{^Is_Block:	-	hangul_SYLLABLES}', "");
    Expect(0, 55215, '\P{Is_Block:	-	hangul_SYLLABLES}', "");
    Expect(1, 55215, '\P{^Is_Block:	-	hangul_SYLLABLES}', "");
    Expect(0, 55216, '\p{Is_Block:	-	hangul_SYLLABLES}', "");
    Expect(1, 55216, '\p{^Is_Block:	-	hangul_SYLLABLES}', "");
    Expect(1, 55216, '\P{Is_Block:	-	hangul_SYLLABLES}', "");
    Expect(0, 55216, '\P{^Is_Block:	-	hangul_SYLLABLES}', "");
    Error('\p{Is_Blk= :=hangul}');
    Error('\P{Is_Blk= :=hangul}');
    Expect(1, 55215, '\p{Is_Blk=hangul}', "");
    Expect(0, 55215, '\p{^Is_Blk=hangul}', "");
    Expect(0, 55215, '\P{Is_Blk=hangul}', "");
    Expect(1, 55215, '\P{^Is_Blk=hangul}', "");
    Expect(0, 55216, '\p{Is_Blk=hangul}', "");
    Expect(1, 55216, '\p{^Is_Blk=hangul}', "");
    Expect(1, 55216, '\P{Is_Blk=hangul}', "");
    Expect(0, 55216, '\P{^Is_Blk=hangul}', "");
    Expect(1, 55215, '\p{Is_Blk=-hangul}', "");
    Expect(0, 55215, '\p{^Is_Blk=-hangul}', "");
    Expect(0, 55215, '\P{Is_Blk=-hangul}', "");
    Expect(1, 55215, '\P{^Is_Blk=-hangul}', "");
    Expect(0, 55216, '\p{Is_Blk=-hangul}', "");
    Expect(1, 55216, '\p{^Is_Blk=-hangul}', "");
    Expect(1, 55216, '\P{Is_Blk=-hangul}', "");
    Expect(0, 55216, '\P{^Is_Blk=-hangul}', "");
    Error('\p{Block: :=	_Hanifi_Rohingya}');
    Error('\P{Block: :=	_Hanifi_Rohingya}');
    Expect(1, 68927, '\p{Block=:\AHanifi_Rohingya\z:}', "");;
    Expect(0, 68928, '\p{Block=:\AHanifi_Rohingya\z:}', "");;
    Expect(1, 68927, '\p{Block=hanifirohingya}', "");
    Expect(0, 68927, '\p{^Block=hanifirohingya}', "");
    Expect(0, 68927, '\P{Block=hanifirohingya}', "");
    Expect(1, 68927, '\P{^Block=hanifirohingya}', "");
    Expect(0, 68928, '\p{Block=hanifirohingya}', "");
    Expect(1, 68928, '\p{^Block=hanifirohingya}', "");
    Expect(1, 68928, '\P{Block=hanifirohingya}', "");
    Expect(0, 68928, '\P{^Block=hanifirohingya}', "");
    Expect(1, 68927, '\p{Block=:\Ahanifirohingya\z:}', "");;
    Expect(0, 68928, '\p{Block=:\Ahanifirohingya\z:}', "");;
    Expect(1, 68927, '\p{Block= -Hanifi_Rohingya}', "");
    Expect(0, 68927, '\p{^Block= -Hanifi_Rohingya}', "");
    Expect(0, 68927, '\P{Block= -Hanifi_Rohingya}', "");
    Expect(1, 68927, '\P{^Block= -Hanifi_Rohingya}', "");
    Expect(0, 68928, '\p{Block= -Hanifi_Rohingya}', "");
    Expect(1, 68928, '\p{^Block= -Hanifi_Rohingya}', "");
    Expect(1, 68928, '\P{Block= -Hanifi_Rohingya}', "");
    Expect(0, 68928, '\P{^Block= -Hanifi_Rohingya}', "");
    Error('\p{Blk:	/a/-_Hanifi_rohingya}');
    Error('\P{Blk:	/a/-_Hanifi_rohingya}');
    Expect(1, 68927, '\p{Blk=:\AHanifi_Rohingya\z:}', "");;
    Expect(0, 68928, '\p{Blk=:\AHanifi_Rohingya\z:}', "");;
    Expect(1, 68927, '\p{Blk=hanifirohingya}', "");
    Expect(0, 68927, '\p{^Blk=hanifirohingya}', "");
    Expect(0, 68927, '\P{Blk=hanifirohingya}', "");
    Expect(1, 68927, '\P{^Blk=hanifirohingya}', "");
    Expect(0, 68928, '\p{Blk=hanifirohingya}', "");
    Expect(1, 68928, '\p{^Blk=hanifirohingya}', "");
    Expect(1, 68928, '\P{Blk=hanifirohingya}', "");
    Expect(0, 68928, '\P{^Blk=hanifirohingya}', "");
    Expect(1, 68927, '\p{Blk=:\Ahanifirohingya\z:}', "");;
    Expect(0, 68928, '\p{Blk=:\Ahanifirohingya\z:}', "");;
    Expect(1, 68927, '\p{Blk=_ HANIFI_Rohingya}', "");
    Expect(0, 68927, '\p{^Blk=_ HANIFI_Rohingya}', "");
    Expect(0, 68927, '\P{Blk=_ HANIFI_Rohingya}', "");
    Expect(1, 68927, '\P{^Blk=_ HANIFI_Rohingya}', "");
    Expect(0, 68928, '\p{Blk=_ HANIFI_Rohingya}', "");
    Expect(1, 68928, '\p{^Blk=_ HANIFI_Rohingya}', "");
    Expect(1, 68928, '\P{Blk=_ HANIFI_Rohingya}', "");
    Expect(0, 68928, '\P{^Blk=_ HANIFI_Rohingya}', "");
    Error('\p{Is_Block=:=-hanifi_rohingya}');
    Error('\P{Is_Block=:=-hanifi_rohingya}');
    Expect(1, 68927, '\p{Is_Block=hanifirohingya}', "");
    Expect(0, 68927, '\p{^Is_Block=hanifirohingya}', "");
    Expect(0, 68927, '\P{Is_Block=hanifirohingya}', "");
    Expect(1, 68927, '\P{^Is_Block=hanifirohingya}', "");
    Expect(0, 68928, '\p{Is_Block=hanifirohingya}', "");
    Expect(1, 68928, '\p{^Is_Block=hanifirohingya}', "");
    Expect(1, 68928, '\P{Is_Block=hanifirohingya}', "");
    Expect(0, 68928, '\P{^Is_Block=hanifirohingya}', "");
    Expect(1, 68927, '\p{Is_Block=	 Hanifi_ROHINGYA}', "");
    Expect(0, 68927, '\p{^Is_Block=	 Hanifi_ROHINGYA}', "");
    Expect(0, 68927, '\P{Is_Block=	 Hanifi_ROHINGYA}', "");
    Expect(1, 68927, '\P{^Is_Block=	 Hanifi_ROHINGYA}', "");
    Expect(0, 68928, '\p{Is_Block=	 Hanifi_ROHINGYA}', "");
    Expect(1, 68928, '\p{^Is_Block=	 Hanifi_ROHINGYA}', "");
    Expect(1, 68928, '\P{Is_Block=	 Hanifi_ROHINGYA}', "");
    Expect(0, 68928, '\P{^Is_Block=	 Hanifi_ROHINGYA}', "");
    Error('\p{Is_Blk=:=-	hanifi_Rohingya}');
    Error('\P{Is_Blk=:=-	hanifi_Rohingya}');
    Expect(1, 68927, '\p{Is_Blk=hanifirohingya}', "");
    Expect(0, 68927, '\p{^Is_Blk=hanifirohingya}', "");
    Expect(0, 68927, '\P{Is_Blk=hanifirohingya}', "");
    Expect(1, 68927, '\P{^Is_Blk=hanifirohingya}', "");
    Expect(0, 68928, '\p{Is_Blk=hanifirohingya}', "");
    Expect(1, 68928, '\p{^Is_Blk=hanifirohingya}', "");
    Expect(1, 68928, '\P{Is_Blk=hanifirohingya}', "");
    Expect(0, 68928, '\P{^Is_Blk=hanifirohingya}', "");
    Expect(1, 68927, '\p{Is_Blk=_-hanifi_ROHINGYA}', "");
    Expect(0, 68927, '\p{^Is_Blk=_-hanifi_ROHINGYA}', "");
    Expect(0, 68927, '\P{Is_Blk=_-hanifi_ROHINGYA}', "");
    Expect(1, 68927, '\P{^Is_Blk=_-hanifi_ROHINGYA}', "");
    Expect(0, 68928, '\p{Is_Blk=_-hanifi_ROHINGYA}', "");
    Expect(1, 68928, '\p{^Is_Blk=_-hanifi_ROHINGYA}', "");
    Expect(1, 68928, '\P{Is_Blk=_-hanifi_ROHINGYA}', "");
    Expect(0, 68928, '\P{^Is_Blk=_-hanifi_ROHINGYA}', "");
    Error('\p{Block=  hanunoo:=}');
    Error('\P{Block=  hanunoo:=}');
    Expect(1, 5951, '\p{Block=:\AHanunoo\z:}', "");;
    Expect(0, 5952, '\p{Block=:\AHanunoo\z:}', "");;
    Expect(1, 5951, '\p{Block=hanunoo}', "");
    Expect(0, 5951, '\p{^Block=hanunoo}', "");
    Expect(0, 5951, '\P{Block=hanunoo}', "");
    Expect(1, 5951, '\P{^Block=hanunoo}', "");
    Expect(0, 5952, '\p{Block=hanunoo}', "");
    Expect(1, 5952, '\p{^Block=hanunoo}', "");
    Expect(1, 5952, '\P{Block=hanunoo}', "");
    Expect(0, 5952, '\P{^Block=hanunoo}', "");
    Expect(1, 5951, '\p{Block=:\Ahanunoo\z:}', "");;
    Expect(0, 5952, '\p{Block=:\Ahanunoo\z:}', "");;
    Expect(1, 5951, '\p{Block= hanunoo}', "");
    Expect(0, 5951, '\p{^Block= hanunoo}', "");
    Expect(0, 5951, '\P{Block= hanunoo}', "");
    Expect(1, 5951, '\P{^Block= hanunoo}', "");
    Expect(0, 5952, '\p{Block= hanunoo}', "");
    Expect(1, 5952, '\p{^Block= hanunoo}', "");
    Expect(1, 5952, '\P{Block= hanunoo}', "");
    Expect(0, 5952, '\P{^Block= hanunoo}', "");
    Error('\p{Blk= /a/hanunoo}');
    Error('\P{Blk= /a/hanunoo}');
    Expect(1, 5951, '\p{Blk=:\AHanunoo\z:}', "");;
    Expect(0, 5952, '\p{Blk=:\AHanunoo\z:}', "");;
    Expect(1, 5951, '\p{Blk=hanunoo}', "");
    Expect(0, 5951, '\p{^Blk=hanunoo}', "");
    Expect(0, 5951, '\P{Blk=hanunoo}', "");
    Expect(1, 5951, '\P{^Blk=hanunoo}', "");
    Expect(0, 5952, '\p{Blk=hanunoo}', "");
    Expect(1, 5952, '\p{^Blk=hanunoo}', "");
    Expect(1, 5952, '\P{Blk=hanunoo}', "");
    Expect(0, 5952, '\P{^Blk=hanunoo}', "");
    Expect(1, 5951, '\p{Blk=:\Ahanunoo\z:}', "");;
    Expect(0, 5952, '\p{Blk=:\Ahanunoo\z:}', "");;
    Expect(1, 5951, '\p{Blk=-	hanunoo}', "");
    Expect(0, 5951, '\p{^Blk=-	hanunoo}', "");
    Expect(0, 5951, '\P{Blk=-	hanunoo}', "");
    Expect(1, 5951, '\P{^Blk=-	hanunoo}', "");
    Expect(0, 5952, '\p{Blk=-	hanunoo}', "");
    Expect(1, 5952, '\p{^Blk=-	hanunoo}', "");
    Expect(1, 5952, '\P{Blk=-	hanunoo}', "");
    Expect(0, 5952, '\P{^Blk=-	hanunoo}', "");
    Error('\p{Is_Block=  hanunoo:=}');
    Error('\P{Is_Block=  hanunoo:=}');
    Expect(1, 5951, '\p{Is_Block=hanunoo}', "");
    Expect(0, 5951, '\p{^Is_Block=hanunoo}', "");
    Expect(0, 5951, '\P{Is_Block=hanunoo}', "");
    Expect(1, 5951, '\P{^Is_Block=hanunoo}', "");
    Expect(0, 5952, '\p{Is_Block=hanunoo}', "");
    Expect(1, 5952, '\p{^Is_Block=hanunoo}', "");
    Expect(1, 5952, '\P{Is_Block=hanunoo}', "");
    Expect(0, 5952, '\P{^Is_Block=hanunoo}', "");
    Expect(1, 5951, '\p{Is_Block=	_Hanunoo}', "");
    Expect(0, 5951, '\p{^Is_Block=	_Hanunoo}', "");
    Expect(0, 5951, '\P{Is_Block=	_Hanunoo}', "");
    Expect(1, 5951, '\P{^Is_Block=	_Hanunoo}', "");
    Expect(0, 5952, '\p{Is_Block=	_Hanunoo}', "");
    Expect(1, 5952, '\p{^Is_Block=	_Hanunoo}', "");
    Expect(1, 5952, '\P{Is_Block=	_Hanunoo}', "");
    Expect(0, 5952, '\P{^Is_Block=	_Hanunoo}', "");
    Error('\p{Is_Blk=- HANUNOO/a/}');
    Error('\P{Is_Blk=- HANUNOO/a/}');
    Expect(1, 5951, '\p{Is_Blk=hanunoo}', "");
    Expect(0, 5951, '\p{^Is_Blk=hanunoo}', "");
    Expect(0, 5951, '\P{Is_Blk=hanunoo}', "");
    Expect(1, 5951, '\P{^Is_Blk=hanunoo}', "");
    Expect(0, 5952, '\p{Is_Blk=hanunoo}', "");
    Expect(1, 5952, '\p{^Is_Blk=hanunoo}', "");
    Expect(1, 5952, '\P{Is_Blk=hanunoo}', "");
    Expect(0, 5952, '\P{^Is_Blk=hanunoo}', "");
    Expect(1, 5951, '\p{Is_Blk=__Hanunoo}', "");
    Expect(0, 5951, '\p{^Is_Blk=__Hanunoo}', "");
    Expect(0, 5951, '\P{Is_Blk=__Hanunoo}', "");
    Expect(1, 5951, '\P{^Is_Blk=__Hanunoo}', "");
    Expect(0, 5952, '\p{Is_Blk=__Hanunoo}', "");
    Expect(1, 5952, '\p{^Is_Blk=__Hanunoo}', "");
    Expect(1, 5952, '\P{Is_Blk=__Hanunoo}', "");
    Expect(0, 5952, '\P{^Is_Blk=__Hanunoo}', "");
    Error('\p{Block=:=__hatran}');
    Error('\P{Block=:=__hatran}');
    Expect(1, 67839, '\p{Block=:\AHatran\z:}', "");;
    Expect(0, 67840, '\p{Block=:\AHatran\z:}', "");;
    Expect(1, 67839, '\p{Block=hatran}', "");
    Expect(0, 67839, '\p{^Block=hatran}', "");
    Expect(0, 67839, '\P{Block=hatran}', "");
    Expect(1, 67839, '\P{^Block=hatran}', "");
    Expect(0, 67840, '\p{Block=hatran}', "");
    Expect(1, 67840, '\p{^Block=hatran}', "");
    Expect(1, 67840, '\P{Block=hatran}', "");
    Expect(0, 67840, '\P{^Block=hatran}', "");
    Expect(1, 67839, '\p{Block=:\Ahatran\z:}', "");;
    Expect(0, 67840, '\p{Block=:\Ahatran\z:}', "");;
    Expect(1, 67839, '\p{Block=Hatran}', "");
    Expect(0, 67839, '\p{^Block=Hatran}', "");
    Expect(0, 67839, '\P{Block=Hatran}', "");
    Expect(1, 67839, '\P{^Block=Hatran}', "");
    Expect(0, 67840, '\p{Block=Hatran}', "");
    Expect(1, 67840, '\p{^Block=Hatran}', "");
    Expect(1, 67840, '\P{Block=Hatran}', "");
    Expect(0, 67840, '\P{^Block=Hatran}', "");
    Error('\p{Blk=_ hatran:=}');
    Error('\P{Blk=_ hatran:=}');
    Expect(1, 67839, '\p{Blk=:\AHatran\z:}', "");;
    Expect(0, 67840, '\p{Blk=:\AHatran\z:}', "");;
    Expect(1, 67839, '\p{Blk=hatran}', "");
    Expect(0, 67839, '\p{^Blk=hatran}', "");
    Expect(0, 67839, '\P{Blk=hatran}', "");
    Expect(1, 67839, '\P{^Blk=hatran}', "");
    Expect(0, 67840, '\p{Blk=hatran}', "");
    Expect(1, 67840, '\p{^Blk=hatran}', "");
    Expect(1, 67840, '\P{Blk=hatran}', "");
    Expect(0, 67840, '\P{^Blk=hatran}', "");
    Expect(1, 67839, '\p{Blk=:\Ahatran\z:}', "");;
    Expect(0, 67840, '\p{Blk=:\Ahatran\z:}', "");;
    Expect(1, 67839, '\p{Blk=-_HATRAN}', "");
    Expect(0, 67839, '\p{^Blk=-_HATRAN}', "");
    Expect(0, 67839, '\P{Blk=-_HATRAN}', "");
    Expect(1, 67839, '\P{^Blk=-_HATRAN}', "");
    Expect(0, 67840, '\p{Blk=-_HATRAN}', "");
    Expect(1, 67840, '\p{^Blk=-_HATRAN}', "");
    Expect(1, 67840, '\P{Blk=-_HATRAN}', "");
    Expect(0, 67840, '\P{^Blk=-_HATRAN}', "");
    Error('\p{Is_Block=	hatran:=}');
    Error('\P{Is_Block=	hatran:=}');
    Expect(1, 67839, '\p{Is_Block=hatran}', "");
    Expect(0, 67839, '\p{^Is_Block=hatran}', "");
    Expect(0, 67839, '\P{Is_Block=hatran}', "");
    Expect(1, 67839, '\P{^Is_Block=hatran}', "");
    Expect(0, 67840, '\p{Is_Block=hatran}', "");
    Expect(1, 67840, '\p{^Is_Block=hatran}', "");
    Expect(1, 67840, '\P{Is_Block=hatran}', "");
    Expect(0, 67840, '\P{^Is_Block=hatran}', "");
    Expect(1, 67839, '\p{Is_Block= -Hatran}', "");
    Expect(0, 67839, '\p{^Is_Block= -Hatran}', "");
    Expect(0, 67839, '\P{Is_Block= -Hatran}', "");
    Expect(1, 67839, '\P{^Is_Block= -Hatran}', "");
    Expect(0, 67840, '\p{Is_Block= -Hatran}', "");
    Expect(1, 67840, '\p{^Is_Block= -Hatran}', "");
    Expect(1, 67840, '\P{Is_Block= -Hatran}', "");
    Expect(0, 67840, '\P{^Is_Block= -Hatran}', "");
    Error('\p{Is_Blk=- Hatran/a/}');
    Error('\P{Is_Blk=- Hatran/a/}');
    Expect(1, 67839, '\p{Is_Blk=hatran}', "");
    Expect(0, 67839, '\p{^Is_Blk=hatran}', "");
    Expect(0, 67839, '\P{Is_Blk=hatran}', "");
    Expect(1, 67839, '\P{^Is_Blk=hatran}', "");
    Expect(0, 67840, '\p{Is_Blk=hatran}', "");
    Expect(1, 67840, '\p{^Is_Blk=hatran}', "");
    Expect(1, 67840, '\P{Is_Blk=hatran}', "");
    Expect(0, 67840, '\P{^Is_Blk=hatran}', "");
    Expect(1, 67839, '\p{Is_Blk=-_Hatran}', "");
    Expect(0, 67839, '\p{^Is_Blk=-_Hatran}', "");
    Expect(0, 67839, '\P{Is_Blk=-_Hatran}', "");
    Expect(1, 67839, '\P{^Is_Blk=-_Hatran}', "");
    Expect(0, 67840, '\p{Is_Blk=-_Hatran}', "");
    Expect(1, 67840, '\p{^Is_Blk=-_Hatran}', "");
    Expect(1, 67840, '\P{Is_Blk=-_Hatran}', "");
    Expect(0, 67840, '\P{^Is_Blk=-_Hatran}', "");
    Error('\p{Block=/a/- Hebrew}');
    Error('\P{Block=/a/- Hebrew}');
    Expect(1, 1535, '\p{Block=:\AHebrew\z:}', "");;
    Expect(0, 1536, '\p{Block=:\AHebrew\z:}', "");;
    Expect(1, 1535, '\p{Block:hebrew}', "");
    Expect(0, 1535, '\p{^Block:hebrew}', "");
    Expect(0, 1535, '\P{Block:hebrew}', "");
    Expect(1, 1535, '\P{^Block:hebrew}', "");
    Expect(0, 1536, '\p{Block:hebrew}', "");
    Expect(1, 1536, '\p{^Block:hebrew}', "");
    Expect(1, 1536, '\P{Block:hebrew}', "");
    Expect(0, 1536, '\P{^Block:hebrew}', "");
    Expect(1, 1535, '\p{Block=:\Ahebrew\z:}', "");;
    Expect(0, 1536, '\p{Block=:\Ahebrew\z:}', "");;
    Expect(1, 1535, '\p{Block=	Hebrew}', "");
    Expect(0, 1535, '\p{^Block=	Hebrew}', "");
    Expect(0, 1535, '\P{Block=	Hebrew}', "");
    Expect(1, 1535, '\P{^Block=	Hebrew}', "");
    Expect(0, 1536, '\p{Block=	Hebrew}', "");
    Expect(1, 1536, '\p{^Block=	Hebrew}', "");
    Expect(1, 1536, '\P{Block=	Hebrew}', "");
    Expect(0, 1536, '\P{^Block=	Hebrew}', "");
    Error('\p{Blk=:=-Hebrew}');
    Error('\P{Blk=:=-Hebrew}');
    Expect(1, 1535, '\p{Blk=:\AHebrew\z:}', "");;
    Expect(0, 1536, '\p{Blk=:\AHebrew\z:}', "");;
    Expect(1, 1535, '\p{Blk=hebrew}', "");
    Expect(0, 1535, '\p{^Blk=hebrew}', "");
    Expect(0, 1535, '\P{Blk=hebrew}', "");
    Expect(1, 1535, '\P{^Blk=hebrew}', "");
    Expect(0, 1536, '\p{Blk=hebrew}', "");
    Expect(1, 1536, '\p{^Blk=hebrew}', "");
    Expect(1, 1536, '\P{Blk=hebrew}', "");
    Expect(0, 1536, '\P{^Blk=hebrew}', "");
    Expect(1, 1535, '\p{Blk=:\Ahebrew\z:}', "");;
    Expect(0, 1536, '\p{Blk=:\Ahebrew\z:}', "");;
    Expect(1, 1535, '\p{Blk= -hebrew}', "");
    Expect(0, 1535, '\p{^Blk= -hebrew}', "");
    Expect(0, 1535, '\P{Blk= -hebrew}', "");
    Expect(1, 1535, '\P{^Blk= -hebrew}', "");
    Expect(0, 1536, '\p{Blk= -hebrew}', "");
    Expect(1, 1536, '\p{^Blk= -hebrew}', "");
    Expect(1, 1536, '\P{Blk= -hebrew}', "");
    Expect(0, 1536, '\P{^Blk= -hebrew}', "");
    Error('\p{Is_Block=/a/	-Hebrew}');
    Error('\P{Is_Block=/a/	-Hebrew}');
    Expect(1, 1535, '\p{Is_Block=hebrew}', "");
    Expect(0, 1535, '\p{^Is_Block=hebrew}', "");
    Expect(0, 1535, '\P{Is_Block=hebrew}', "");
    Expect(1, 1535, '\P{^Is_Block=hebrew}', "");
    Expect(0, 1536, '\p{Is_Block=hebrew}', "");
    Expect(1, 1536, '\p{^Is_Block=hebrew}', "");
    Expect(1, 1536, '\P{Is_Block=hebrew}', "");
    Expect(0, 1536, '\P{^Is_Block=hebrew}', "");
    Expect(1, 1535, '\p{Is_Block= hebrew}', "");
    Expect(0, 1535, '\p{^Is_Block= hebrew}', "");
    Expect(0, 1535, '\P{Is_Block= hebrew}', "");
    Expect(1, 1535, '\P{^Is_Block= hebrew}', "");
    Expect(0, 1536, '\p{Is_Block= hebrew}', "");
    Expect(1, 1536, '\p{^Is_Block= hebrew}', "");
    Expect(1, 1536, '\P{Is_Block= hebrew}', "");
    Expect(0, 1536, '\P{^Is_Block= hebrew}', "");
    Error('\p{Is_Blk= HEBREW:=}');
    Error('\P{Is_Blk= HEBREW:=}');
    Expect(1, 1535, '\p{Is_Blk=hebrew}', "");
    Expect(0, 1535, '\p{^Is_Blk=hebrew}', "");
    Expect(0, 1535, '\P{Is_Blk=hebrew}', "");
    Expect(1, 1535, '\P{^Is_Blk=hebrew}', "");
    Expect(0, 1536, '\p{Is_Blk=hebrew}', "");
    Expect(1, 1536, '\p{^Is_Blk=hebrew}', "");
    Expect(1, 1536, '\P{Is_Blk=hebrew}', "");
    Expect(0, 1536, '\P{^Is_Blk=hebrew}', "");
    Expect(1, 1535, '\p{Is_Blk:-HEBREW}', "");
    Expect(0, 1535, '\p{^Is_Blk:-HEBREW}', "");
    Expect(0, 1535, '\P{Is_Blk:-HEBREW}', "");
    Expect(1, 1535, '\P{^Is_Blk:-HEBREW}', "");
    Expect(0, 1536, '\p{Is_Blk:-HEBREW}', "");
    Expect(1, 1536, '\p{^Is_Blk:-HEBREW}', "");
    Expect(1, 1536, '\P{Is_Blk:-HEBREW}', "");
    Expect(0, 1536, '\P{^Is_Blk:-HEBREW}', "");
    Error('\p{Block=-	High_private_use_Surrogates:=}');
    Error('\P{Block=-	High_private_use_Surrogates:=}');
    Expect(1, 56319, '\p{Block=:\AHigh_Private_Use_Surrogates\z:}', "");;
    Expect(0, 57344, '\p{Block=:\AHigh_Private_Use_Surrogates\z:}', "");;
    Expect(1, 56319, '\p{Block=highprivateusesurrogates}', "");
    Expect(0, 56319, '\p{^Block=highprivateusesurrogates}', "");
    Expect(0, 56319, '\P{Block=highprivateusesurrogates}', "");
    Expect(1, 56319, '\P{^Block=highprivateusesurrogates}', "");
    Expect(0, 57344, '\p{Block=highprivateusesurrogates}', "");
    Expect(1, 57344, '\p{^Block=highprivateusesurrogates}', "");
    Expect(1, 57344, '\P{Block=highprivateusesurrogates}', "");
    Expect(0, 57344, '\P{^Block=highprivateusesurrogates}', "");
    Expect(1, 56319, '\p{Block=:\Ahighprivateusesurrogates\z:}', "");;
    Expect(0, 57344, '\p{Block=:\Ahighprivateusesurrogates\z:}', "");;
    Expect(1, 56319, '\p{Block: _high_private_Use_Surrogates}', "");
    Expect(0, 56319, '\p{^Block: _high_private_Use_Surrogates}', "");
    Expect(0, 56319, '\P{Block: _high_private_Use_Surrogates}', "");
    Expect(1, 56319, '\P{^Block: _high_private_Use_Surrogates}', "");
    Expect(0, 57344, '\p{Block: _high_private_Use_Surrogates}', "");
    Expect(1, 57344, '\p{^Block: _high_private_Use_Surrogates}', "");
    Expect(1, 57344, '\P{Block: _high_private_Use_Surrogates}', "");
    Expect(0, 57344, '\P{^Block: _high_private_Use_Surrogates}', "");
    Error('\p{Blk=:=high_PU_surrogates}');
    Error('\P{Blk=:=high_PU_surrogates}');
    Expect(1, 56319, '\p{Blk=:\AHigh_PU_Surrogates\z:}', "");;
    Expect(0, 57344, '\p{Blk=:\AHigh_PU_Surrogates\z:}', "");;
    Expect(1, 56319, '\p{Blk=highpusurrogates}', "");
    Expect(0, 56319, '\p{^Blk=highpusurrogates}', "");
    Expect(0, 56319, '\P{Blk=highpusurrogates}', "");
    Expect(1, 56319, '\P{^Blk=highpusurrogates}', "");
    Expect(0, 57344, '\p{Blk=highpusurrogates}', "");
    Expect(1, 57344, '\p{^Blk=highpusurrogates}', "");
    Expect(1, 57344, '\P{Blk=highpusurrogates}', "");
    Expect(0, 57344, '\P{^Blk=highpusurrogates}', "");
    Expect(1, 56319, '\p{Blk=:\Ahighpusurrogates\z:}', "");;
    Expect(0, 57344, '\p{Blk=:\Ahighpusurrogates\z:}', "");;
    Expect(1, 56319, '\p{Blk=-High_PU_Surrogates}', "");
    Expect(0, 56319, '\p{^Blk=-High_PU_Surrogates}', "");
    Expect(0, 56319, '\P{Blk=-High_PU_Surrogates}', "");
    Expect(1, 56319, '\P{^Blk=-High_PU_Surrogates}', "");
    Expect(0, 57344, '\p{Blk=-High_PU_Surrogates}', "");
    Expect(1, 57344, '\p{^Blk=-High_PU_Surrogates}', "");
    Expect(1, 57344, '\P{Blk=-High_PU_Surrogates}', "");
    Expect(0, 57344, '\P{^Blk=-High_PU_Surrogates}', "");
    Error('\p{Is_Block=	:=High_PRIVATE_Use_Surrogates}');
    Error('\P{Is_Block=	:=High_PRIVATE_Use_Surrogates}');
    Expect(1, 56319, '\p{Is_Block=highprivateusesurrogates}', "");
    Expect(0, 56319, '\p{^Is_Block=highprivateusesurrogates}', "");
    Expect(0, 56319, '\P{Is_Block=highprivateusesurrogates}', "");
    Expect(1, 56319, '\P{^Is_Block=highprivateusesurrogates}', "");
    Expect(0, 57344, '\p{Is_Block=highprivateusesurrogates}', "");
    Expect(1, 57344, '\p{^Is_Block=highprivateusesurrogates}', "");
    Expect(1, 57344, '\P{Is_Block=highprivateusesurrogates}', "");
    Expect(0, 57344, '\P{^Is_Block=highprivateusesurrogates}', "");
    Expect(1, 56319, '\p{Is_Block=_-high_Private_use_Surrogates}', "");
    Expect(0, 56319, '\p{^Is_Block=_-high_Private_use_Surrogates}', "");
    Expect(0, 56319, '\P{Is_Block=_-high_Private_use_Surrogates}', "");
    Expect(1, 56319, '\P{^Is_Block=_-high_Private_use_Surrogates}', "");
    Expect(0, 57344, '\p{Is_Block=_-high_Private_use_Surrogates}', "");
    Expect(1, 57344, '\p{^Is_Block=_-high_Private_use_Surrogates}', "");
    Expect(1, 57344, '\P{Is_Block=_-high_Private_use_Surrogates}', "");
    Expect(0, 57344, '\P{^Is_Block=_-high_Private_use_Surrogates}', "");
    Error('\p{Is_Blk=/a/high_pu_SURROGATES}');
    Error('\P{Is_Blk=/a/high_pu_SURROGATES}');
    Expect(1, 56319, '\p{Is_Blk=highpusurrogates}', "");
    Expect(0, 56319, '\p{^Is_Blk=highpusurrogates}', "");
    Expect(0, 56319, '\P{Is_Blk=highpusurrogates}', "");
    Expect(1, 56319, '\P{^Is_Blk=highpusurrogates}', "");
    Expect(0, 57344, '\p{Is_Blk=highpusurrogates}', "");
    Expect(1, 57344, '\p{^Is_Blk=highpusurrogates}', "");
    Expect(1, 57344, '\P{Is_Blk=highpusurrogates}', "");
    Expect(0, 57344, '\P{^Is_Blk=highpusurrogates}', "");
    Expect(1, 56319, '\p{Is_Blk=	High_PU_SURROGATES}', "");
    Expect(0, 56319, '\p{^Is_Blk=	High_PU_SURROGATES}', "");
    Expect(0, 56319, '\P{Is_Blk=	High_PU_SURROGATES}', "");
    Expect(1, 56319, '\P{^Is_Blk=	High_PU_SURROGATES}', "");
    Expect(0, 57344, '\p{Is_Blk=	High_PU_SURROGATES}', "");
    Expect(1, 57344, '\p{^Is_Blk=	High_PU_SURROGATES}', "");
    Expect(1, 57344, '\P{Is_Blk=	High_PU_SURROGATES}', "");
    Expect(0, 57344, '\P{^Is_Blk=	High_PU_SURROGATES}', "");
    Error('\p{Block=	:=HIGH_Surrogates}');
    Error('\P{Block=	:=HIGH_Surrogates}');
    Expect(1, 56191, '\p{Block=:\AHigh_Surrogates\z:}', "");;
    Expect(0, 57344, '\p{Block=:\AHigh_Surrogates\z:}', "");;
    Expect(1, 56191, '\p{Block=highsurrogates}', "");
    Expect(0, 56191, '\p{^Block=highsurrogates}', "");
    Expect(0, 56191, '\P{Block=highsurrogates}', "");
    Expect(1, 56191, '\P{^Block=highsurrogates}', "");
    Expect(0, 57344, '\p{Block=highsurrogates}', "");
    Expect(1, 57344, '\p{^Block=highsurrogates}', "");
    Expect(1, 57344, '\P{Block=highsurrogates}', "");
    Expect(0, 57344, '\P{^Block=highsurrogates}', "");
    Expect(1, 56191, '\p{Block=:\Ahighsurrogates\z:}', "");;
    Expect(0, 57344, '\p{Block=:\Ahighsurrogates\z:}', "");;
    Expect(1, 56191, '\p{Block=HIGH_Surrogates}', "");
    Expect(0, 56191, '\p{^Block=HIGH_Surrogates}', "");
    Expect(0, 56191, '\P{Block=HIGH_Surrogates}', "");
    Expect(1, 56191, '\P{^Block=HIGH_Surrogates}', "");
    Expect(0, 57344, '\p{Block=HIGH_Surrogates}', "");
    Expect(1, 57344, '\p{^Block=HIGH_Surrogates}', "");
    Expect(1, 57344, '\P{Block=HIGH_Surrogates}', "");
    Expect(0, 57344, '\P{^Block=HIGH_Surrogates}', "");
    Error('\p{Blk=- High_Surrogates:=}');
    Error('\P{Blk=- High_Surrogates:=}');
    Expect(1, 56191, '\p{Blk=:\AHigh_Surrogates\z:}', "");;
    Expect(0, 57344, '\p{Blk=:\AHigh_Surrogates\z:}', "");;
    Expect(1, 56191, '\p{Blk=highsurrogates}', "");
    Expect(0, 56191, '\p{^Blk=highsurrogates}', "");
    Expect(0, 56191, '\P{Blk=highsurrogates}', "");
    Expect(1, 56191, '\P{^Blk=highsurrogates}', "");
    Expect(0, 57344, '\p{Blk=highsurrogates}', "");
    Expect(1, 57344, '\p{^Blk=highsurrogates}', "");
    Expect(1, 57344, '\P{Blk=highsurrogates}', "");
    Expect(0, 57344, '\P{^Blk=highsurrogates}', "");
    Expect(1, 56191, '\p{Blk=:\Ahighsurrogates\z:}', "");;
    Expect(0, 57344, '\p{Blk=:\Ahighsurrogates\z:}', "");;
    Expect(1, 56191, '\p{Blk= High_SURROGATES}', "");
    Expect(0, 56191, '\p{^Blk= High_SURROGATES}', "");
    Expect(0, 56191, '\P{Blk= High_SURROGATES}', "");
    Expect(1, 56191, '\P{^Blk= High_SURROGATES}', "");
    Expect(0, 57344, '\p{Blk= High_SURROGATES}', "");
    Expect(1, 57344, '\p{^Blk= High_SURROGATES}', "");
    Expect(1, 57344, '\P{Blk= High_SURROGATES}', "");
    Expect(0, 57344, '\P{^Blk= High_SURROGATES}', "");
    Error('\p{Is_Block=  High_surrogates:=}');
    Error('\P{Is_Block=  High_surrogates:=}');
    Expect(1, 56191, '\p{Is_Block=highsurrogates}', "");
    Expect(0, 56191, '\p{^Is_Block=highsurrogates}', "");
    Expect(0, 56191, '\P{Is_Block=highsurrogates}', "");
    Expect(1, 56191, '\P{^Is_Block=highsurrogates}', "");
    Expect(0, 57344, '\p{Is_Block=highsurrogates}', "");
    Expect(1, 57344, '\p{^Is_Block=highsurrogates}', "");
    Expect(1, 57344, '\P{Is_Block=highsurrogates}', "");
    Expect(0, 57344, '\P{^Is_Block=highsurrogates}', "");
    Expect(1, 56191, '\p{Is_Block=-High_Surrogates}', "");
    Expect(0, 56191, '\p{^Is_Block=-High_Surrogates}', "");
    Expect(0, 56191, '\P{Is_Block=-High_Surrogates}', "");
    Expect(1, 56191, '\P{^Is_Block=-High_Surrogates}', "");
    Expect(0, 57344, '\p{Is_Block=-High_Surrogates}', "");
    Expect(1, 57344, '\p{^Is_Block=-High_Surrogates}', "");
    Expect(1, 57344, '\P{Is_Block=-High_Surrogates}', "");
    Expect(0, 57344, '\P{^Is_Block=-High_Surrogates}', "");
    Error('\p{Is_Blk=	:=High_Surrogates}');
    Error('\P{Is_Blk=	:=High_Surrogates}');
    Expect(1, 56191, '\p{Is_Blk=highsurrogates}', "");
    Expect(0, 56191, '\p{^Is_Blk=highsurrogates}', "");
    Expect(0, 56191, '\P{Is_Blk=highsurrogates}', "");
    Expect(1, 56191, '\P{^Is_Blk=highsurrogates}', "");
    Expect(0, 57344, '\p{Is_Blk=highsurrogates}', "");
    Expect(1, 57344, '\p{^Is_Blk=highsurrogates}', "");
    Expect(1, 57344, '\P{Is_Blk=highsurrogates}', "");
    Expect(0, 57344, '\P{^Is_Blk=highsurrogates}', "");
    Expect(1, 56191, '\p{Is_Blk=--high_Surrogates}', "");
    Expect(0, 56191, '\p{^Is_Blk=--high_Surrogates}', "");
    Expect(0, 56191, '\P{Is_Blk=--high_Surrogates}', "");
    Expect(1, 56191, '\P{^Is_Blk=--high_Surrogates}', "");
    Expect(0, 57344, '\p{Is_Blk=--high_Surrogates}', "");
    Expect(1, 57344, '\p{^Is_Blk=--high_Surrogates}', "");
    Expect(1, 57344, '\P{Is_Blk=--high_Surrogates}', "");
    Expect(0, 57344, '\P{^Is_Blk=--high_Surrogates}', "");
    Error('\p{Block=- Hiragana:=}');
    Error('\P{Block=- Hiragana:=}');
    Expect(1, 12447, '\p{Block=:\AHiragana\z:}', "");;
    Expect(0, 12448, '\p{Block=:\AHiragana\z:}', "");;
    Expect(1, 12447, '\p{Block=hiragana}', "");
    Expect(0, 12447, '\p{^Block=hiragana}', "");
    Expect(0, 12447, '\P{Block=hiragana}', "");
    Expect(1, 12447, '\P{^Block=hiragana}', "");
    Expect(0, 12448, '\p{Block=hiragana}', "");
    Expect(1, 12448, '\p{^Block=hiragana}', "");
    Expect(1, 12448, '\P{Block=hiragana}', "");
    Expect(0, 12448, '\P{^Block=hiragana}', "");
    Expect(1, 12447, '\p{Block=:\Ahiragana\z:}', "");;
    Expect(0, 12448, '\p{Block=:\Ahiragana\z:}', "");;
    Expect(1, 12447, '\p{Block=Hiragana}', "");
    Expect(0, 12447, '\p{^Block=Hiragana}', "");
    Expect(0, 12447, '\P{Block=Hiragana}', "");
    Expect(1, 12447, '\P{^Block=Hiragana}', "");
    Expect(0, 12448, '\p{Block=Hiragana}', "");
    Expect(1, 12448, '\p{^Block=Hiragana}', "");
    Expect(1, 12448, '\P{Block=Hiragana}', "");
    Expect(0, 12448, '\P{^Block=Hiragana}', "");
    Error('\p{Blk=	hiragana:=}');
    Error('\P{Blk=	hiragana:=}');
    Expect(1, 12447, '\p{Blk=:\AHiragana\z:}', "");;
    Expect(0, 12448, '\p{Blk=:\AHiragana\z:}', "");;
    Expect(1, 12447, '\p{Blk=hiragana}', "");
    Expect(0, 12447, '\p{^Blk=hiragana}', "");
    Expect(0, 12447, '\P{Blk=hiragana}', "");
    Expect(1, 12447, '\P{^Blk=hiragana}', "");
    Expect(0, 12448, '\p{Blk=hiragana}', "");
    Expect(1, 12448, '\p{^Blk=hiragana}', "");
    Expect(1, 12448, '\P{Blk=hiragana}', "");
    Expect(0, 12448, '\P{^Blk=hiragana}', "");
    Expect(1, 12447, '\p{Blk=:\Ahiragana\z:}', "");;
    Expect(0, 12448, '\p{Blk=:\Ahiragana\z:}', "");;
    Expect(1, 12447, '\p{Blk=	-HIRAGANA}', "");
    Expect(0, 12447, '\p{^Blk=	-HIRAGANA}', "");
    Expect(0, 12447, '\P{Blk=	-HIRAGANA}', "");
    Expect(1, 12447, '\P{^Blk=	-HIRAGANA}', "");
    Expect(0, 12448, '\p{Blk=	-HIRAGANA}', "");
    Expect(1, 12448, '\p{^Blk=	-HIRAGANA}', "");
    Expect(1, 12448, '\P{Blk=	-HIRAGANA}', "");
    Expect(0, 12448, '\P{^Blk=	-HIRAGANA}', "");
    Error('\p{Is_Block=-:=Hiragana}');
    Error('\P{Is_Block=-:=Hiragana}');
    Expect(1, 12447, '\p{Is_Block=hiragana}', "");
    Expect(0, 12447, '\p{^Is_Block=hiragana}', "");
    Expect(0, 12447, '\P{Is_Block=hiragana}', "");
    Expect(1, 12447, '\P{^Is_Block=hiragana}', "");
    Expect(0, 12448, '\p{Is_Block=hiragana}', "");
    Expect(1, 12448, '\p{^Is_Block=hiragana}', "");
    Expect(1, 12448, '\P{Is_Block=hiragana}', "");
    Expect(0, 12448, '\P{^Is_Block=hiragana}', "");
    Expect(1, 12447, '\p{Is_Block=- HIRAGANA}', "");
    Expect(0, 12447, '\p{^Is_Block=- HIRAGANA}', "");
    Expect(0, 12447, '\P{Is_Block=- HIRAGANA}', "");
    Expect(1, 12447, '\P{^Is_Block=- HIRAGANA}', "");
    Expect(0, 12448, '\p{Is_Block=- HIRAGANA}', "");
    Expect(1, 12448, '\p{^Is_Block=- HIRAGANA}', "");
    Expect(1, 12448, '\P{Is_Block=- HIRAGANA}', "");
    Expect(0, 12448, '\P{^Is_Block=- HIRAGANA}', "");
    Error('\p{Is_Blk:   /a/ Hiragana}');
    Error('\P{Is_Blk:   /a/ Hiragana}');
    Expect(1, 12447, '\p{Is_Blk=hiragana}', "");
    Expect(0, 12447, '\p{^Is_Blk=hiragana}', "");
    Expect(0, 12447, '\P{Is_Blk=hiragana}', "");
    Expect(1, 12447, '\P{^Is_Blk=hiragana}', "");
    Expect(0, 12448, '\p{Is_Blk=hiragana}', "");
    Expect(1, 12448, '\p{^Is_Blk=hiragana}', "");
    Expect(1, 12448, '\P{Is_Blk=hiragana}', "");
    Expect(0, 12448, '\P{^Is_Blk=hiragana}', "");
    Expect(1, 12447, '\p{Is_Blk= hiragana}', "");
    Expect(0, 12447, '\p{^Is_Blk= hiragana}', "");
    Expect(0, 12447, '\P{Is_Blk= hiragana}', "");
    Expect(1, 12447, '\P{^Is_Blk= hiragana}', "");
    Expect(0, 12448, '\p{Is_Blk= hiragana}', "");
    Expect(1, 12448, '\p{^Is_Blk= hiragana}', "");
    Expect(1, 12448, '\P{Is_Blk= hiragana}', "");
    Expect(0, 12448, '\P{^Is_Blk= hiragana}', "");
    Error('\p{Block=-	ideographic_Description_characters:=}');
    Error('\P{Block=-	ideographic_Description_characters:=}');
    Expect(1, 12287, '\p{Block=:\AIdeographic_Description_Characters\z:}', "");;
    Expect(0, 12288, '\p{Block=:\AIdeographic_Description_Characters\z:}', "");;
    Expect(1, 12287, '\p{Block=ideographicdescriptioncharacters}', "");
    Expect(0, 12287, '\p{^Block=ideographicdescriptioncharacters}', "");
    Expect(0, 12287, '\P{Block=ideographicdescriptioncharacters}', "");
    Expect(1, 12287, '\P{^Block=ideographicdescriptioncharacters}', "");
    Expect(0, 12288, '\p{Block=ideographicdescriptioncharacters}', "");
    Expect(1, 12288, '\p{^Block=ideographicdescriptioncharacters}', "");
    Expect(1, 12288, '\P{Block=ideographicdescriptioncharacters}', "");
    Expect(0, 12288, '\P{^Block=ideographicdescriptioncharacters}', "");
    Expect(1, 12287, '\p{Block=:\Aideographicdescriptioncharacters\z:}', "");;
    Expect(0, 12288, '\p{Block=:\Aideographicdescriptioncharacters\z:}', "");;
    Expect(1, 12287, '\p{Block:   	ideographic_Description_characters}', "");
    Expect(0, 12287, '\p{^Block:   	ideographic_Description_characters}', "");
    Expect(0, 12287, '\P{Block:   	ideographic_Description_characters}', "");
    Expect(1, 12287, '\P{^Block:   	ideographic_Description_characters}', "");
    Expect(0, 12288, '\p{Block:   	ideographic_Description_characters}', "");
    Expect(1, 12288, '\p{^Block:   	ideographic_Description_characters}', "");
    Expect(1, 12288, '\P{Block:   	ideographic_Description_characters}', "");
    Expect(0, 12288, '\P{^Block:   	ideographic_Description_characters}', "");
    Error('\p{Blk=/a/_	IDC}');
    Error('\P{Blk=/a/_	IDC}');
    Expect(1, 12287, '\p{Blk=:\AIDC\z:}', "");;
    Expect(0, 12288, '\p{Blk=:\AIDC\z:}', "");;
    Expect(1, 12287, '\p{Blk=idc}', "");
    Expect(0, 12287, '\p{^Blk=idc}', "");
    Expect(0, 12287, '\P{Blk=idc}', "");
    Expect(1, 12287, '\P{^Blk=idc}', "");
    Expect(0, 12288, '\p{Blk=idc}', "");
    Expect(1, 12288, '\p{^Blk=idc}', "");
    Expect(1, 12288, '\P{Blk=idc}', "");
    Expect(0, 12288, '\P{^Blk=idc}', "");
    Expect(1, 12287, '\p{Blk=:\Aidc\z:}', "");;
    Expect(0, 12288, '\p{Blk=:\Aidc\z:}', "");;
    Expect(1, 12287, '\p{Blk= IDC}', "");
    Expect(0, 12287, '\p{^Blk= IDC}', "");
    Expect(0, 12287, '\P{Blk= IDC}', "");
    Expect(1, 12287, '\P{^Blk= IDC}', "");
    Expect(0, 12288, '\p{Blk= IDC}', "");
    Expect(1, 12288, '\p{^Blk= IDC}', "");
    Expect(1, 12288, '\P{Blk= IDC}', "");
    Expect(0, 12288, '\P{^Blk= IDC}', "");
    Error('\p{Is_Block=	ideographic_DESCRIPTION_characters/a/}');
    Error('\P{Is_Block=	ideographic_DESCRIPTION_characters/a/}');
    Expect(1, 12287, '\p{Is_Block=ideographicdescriptioncharacters}', "");
    Expect(0, 12287, '\p{^Is_Block=ideographicdescriptioncharacters}', "");
    Expect(0, 12287, '\P{Is_Block=ideographicdescriptioncharacters}', "");
    Expect(1, 12287, '\P{^Is_Block=ideographicdescriptioncharacters}', "");
    Expect(0, 12288, '\p{Is_Block=ideographicdescriptioncharacters}', "");
    Expect(1, 12288, '\p{^Is_Block=ideographicdescriptioncharacters}', "");
    Expect(1, 12288, '\P{Is_Block=ideographicdescriptioncharacters}', "");
    Expect(0, 12288, '\P{^Is_Block=ideographicdescriptioncharacters}', "");
    Expect(1, 12287, '\p{Is_Block=  IDEOGRAPHIC_Description_characters}', "");
    Expect(0, 12287, '\p{^Is_Block=  IDEOGRAPHIC_Description_characters}', "");
    Expect(0, 12287, '\P{Is_Block=  IDEOGRAPHIC_Description_characters}', "");
    Expect(1, 12287, '\P{^Is_Block=  IDEOGRAPHIC_Description_characters}', "");
    Expect(0, 12288, '\p{Is_Block=  IDEOGRAPHIC_Description_characters}', "");
    Expect(1, 12288, '\p{^Is_Block=  IDEOGRAPHIC_Description_characters}', "");
    Expect(1, 12288, '\P{Is_Block=  IDEOGRAPHIC_Description_characters}', "");
    Expect(0, 12288, '\P{^Is_Block=  IDEOGRAPHIC_Description_characters}', "");
    Error('\p{Is_Blk=	IDC/a/}');
    Error('\P{Is_Blk=	IDC/a/}');
    Expect(1, 12287, '\p{Is_Blk=idc}', "");
    Expect(0, 12287, '\p{^Is_Blk=idc}', "");
    Expect(0, 12287, '\P{Is_Blk=idc}', "");
    Expect(1, 12287, '\P{^Is_Blk=idc}', "");
    Expect(0, 12288, '\p{Is_Blk=idc}', "");
    Expect(1, 12288, '\p{^Is_Blk=idc}', "");
    Expect(1, 12288, '\P{Is_Blk=idc}', "");
    Expect(0, 12288, '\P{^Is_Blk=idc}', "");
    Expect(1, 12287, '\p{Is_Blk: 	_idc}', "");
    Expect(0, 12287, '\p{^Is_Blk: 	_idc}', "");
    Expect(0, 12287, '\P{Is_Blk: 	_idc}', "");
    Expect(1, 12287, '\P{^Is_Blk: 	_idc}', "");
    Expect(0, 12288, '\p{Is_Blk: 	_idc}', "");
    Expect(1, 12288, '\p{^Is_Blk: 	_idc}', "");
    Expect(1, 12288, '\P{Is_Blk: 	_idc}', "");
    Expect(0, 12288, '\P{^Is_Blk: 	_idc}', "");
    Error('\p{Block=		Ideographic_SYMBOLS_And_Punctuation/a/}');
    Error('\P{Block=		Ideographic_SYMBOLS_And_Punctuation/a/}');
    Expect(1, 94207, '\p{Block=:\AIdeographic_Symbols_And_Punctuation\z:}', "");;
    Expect(0, 94208, '\p{Block=:\AIdeographic_Symbols_And_Punctuation\z:}', "");;
    Expect(1, 94207, '\p{Block=ideographicsymbolsandpunctuation}', "");
    Expect(0, 94207, '\p{^Block=ideographicsymbolsandpunctuation}', "");
    Expect(0, 94207, '\P{Block=ideographicsymbolsandpunctuation}', "");
    Expect(1, 94207, '\P{^Block=ideographicsymbolsandpunctuation}', "");
    Expect(0, 94208, '\p{Block=ideographicsymbolsandpunctuation}', "");
    Expect(1, 94208, '\p{^Block=ideographicsymbolsandpunctuation}', "");
    Expect(1, 94208, '\P{Block=ideographicsymbolsandpunctuation}', "");
    Expect(0, 94208, '\P{^Block=ideographicsymbolsandpunctuation}', "");
    Expect(1, 94207, '\p{Block=:\Aideographicsymbolsandpunctuation\z:}', "");;
    Expect(0, 94208, '\p{Block=:\Aideographicsymbolsandpunctuation\z:}', "");;
    Expect(1, 94207, '\p{Block: _ideographic_symbols_and_PUNCTUATION}', "");
    Expect(0, 94207, '\p{^Block: _ideographic_symbols_and_PUNCTUATION}', "");
    Expect(0, 94207, '\P{Block: _ideographic_symbols_and_PUNCTUATION}', "");
    Expect(1, 94207, '\P{^Block: _ideographic_symbols_and_PUNCTUATION}', "");
    Expect(0, 94208, '\p{Block: _ideographic_symbols_and_PUNCTUATION}', "");
    Expect(1, 94208, '\p{^Block: _ideographic_symbols_and_PUNCTUATION}', "");
    Expect(1, 94208, '\P{Block: _ideographic_symbols_and_PUNCTUATION}', "");
    Expect(0, 94208, '\P{^Block: _ideographic_symbols_and_PUNCTUATION}', "");
    Error('\p{Blk=/a/ _Ideographic_Symbols}');
    Error('\P{Blk=/a/ _Ideographic_Symbols}');
    Expect(1, 94207, '\p{Blk=:\AIdeographic_Symbols\z:}', "");;
    Expect(0, 94208, '\p{Blk=:\AIdeographic_Symbols\z:}', "");;
    Expect(1, 94207, '\p{Blk=ideographicsymbols}', "");
    Expect(0, 94207, '\p{^Blk=ideographicsymbols}', "");
    Expect(0, 94207, '\P{Blk=ideographicsymbols}', "");
    Expect(1, 94207, '\P{^Blk=ideographicsymbols}', "");
    Expect(0, 94208, '\p{Blk=ideographicsymbols}', "");
    Expect(1, 94208, '\p{^Blk=ideographicsymbols}', "");
    Expect(1, 94208, '\P{Blk=ideographicsymbols}', "");
    Expect(0, 94208, '\P{^Blk=ideographicsymbols}', "");
    Expect(1, 94207, '\p{Blk=:\Aideographicsymbols\z:}', "");;
    Expect(0, 94208, '\p{Blk=:\Aideographicsymbols\z:}', "");;
    Expect(1, 94207, '\p{Blk=-_Ideographic_Symbols}', "");
    Expect(0, 94207, '\p{^Blk=-_Ideographic_Symbols}', "");
    Expect(0, 94207, '\P{Blk=-_Ideographic_Symbols}', "");
    Expect(1, 94207, '\P{^Blk=-_Ideographic_Symbols}', "");
    Expect(0, 94208, '\p{Blk=-_Ideographic_Symbols}', "");
    Expect(1, 94208, '\p{^Blk=-_Ideographic_Symbols}', "");
    Expect(1, 94208, '\P{Blk=-_Ideographic_Symbols}', "");
    Expect(0, 94208, '\P{^Blk=-_Ideographic_Symbols}', "");
    Error('\p{Is_Block=_IDEOGRAPHIC_SYMBOLS_and_Punctuation:=}');
    Error('\P{Is_Block=_IDEOGRAPHIC_SYMBOLS_and_Punctuation:=}');
    Expect(1, 94207, '\p{Is_Block=ideographicsymbolsandpunctuation}', "");
    Expect(0, 94207, '\p{^Is_Block=ideographicsymbolsandpunctuation}', "");
    Expect(0, 94207, '\P{Is_Block=ideographicsymbolsandpunctuation}', "");
    Expect(1, 94207, '\P{^Is_Block=ideographicsymbolsandpunctuation}', "");
    Expect(0, 94208, '\p{Is_Block=ideographicsymbolsandpunctuation}', "");
    Expect(1, 94208, '\p{^Is_Block=ideographicsymbolsandpunctuation}', "");
    Expect(1, 94208, '\P{Is_Block=ideographicsymbolsandpunctuation}', "");
    Expect(0, 94208, '\P{^Is_Block=ideographicsymbolsandpunctuation}', "");
    Expect(1, 94207, '\p{Is_Block:   ideographic_SYMBOLS_and_PUNCTUATION}', "");
    Expect(0, 94207, '\p{^Is_Block:   ideographic_SYMBOLS_and_PUNCTUATION}', "");
    Expect(0, 94207, '\P{Is_Block:   ideographic_SYMBOLS_and_PUNCTUATION}', "");
    Expect(1, 94207, '\P{^Is_Block:   ideographic_SYMBOLS_and_PUNCTUATION}', "");
    Expect(0, 94208, '\p{Is_Block:   ideographic_SYMBOLS_and_PUNCTUATION}', "");
    Expect(1, 94208, '\p{^Is_Block:   ideographic_SYMBOLS_and_PUNCTUATION}', "");
    Expect(1, 94208, '\P{Is_Block:   ideographic_SYMBOLS_and_PUNCTUATION}', "");
    Expect(0, 94208, '\P{^Is_Block:   ideographic_SYMBOLS_and_PUNCTUATION}', "");
    Error('\p{Is_Blk= -ideographic_Symbols:=}');
    Error('\P{Is_Blk= -ideographic_Symbols:=}');
    Expect(1, 94207, '\p{Is_Blk=ideographicsymbols}', "");
    Expect(0, 94207, '\p{^Is_Blk=ideographicsymbols}', "");
    Expect(0, 94207, '\P{Is_Blk=ideographicsymbols}', "");
    Expect(1, 94207, '\P{^Is_Blk=ideographicsymbols}', "");
    Expect(0, 94208, '\p{Is_Blk=ideographicsymbols}', "");
    Expect(1, 94208, '\p{^Is_Blk=ideographicsymbols}', "");
    Expect(1, 94208, '\P{Is_Blk=ideographicsymbols}', "");
    Expect(0, 94208, '\P{^Is_Blk=ideographicsymbols}', "");
    Expect(1, 94207, '\p{Is_Blk=	IDEOGRAPHIC_Symbols}', "");
    Expect(0, 94207, '\p{^Is_Blk=	IDEOGRAPHIC_Symbols}', "");
    Expect(0, 94207, '\P{Is_Blk=	IDEOGRAPHIC_Symbols}', "");
    Expect(1, 94207, '\P{^Is_Blk=	IDEOGRAPHIC_Symbols}', "");
    Expect(0, 94208, '\p{Is_Blk=	IDEOGRAPHIC_Symbols}', "");
    Expect(1, 94208, '\p{^Is_Blk=	IDEOGRAPHIC_Symbols}', "");
    Expect(1, 94208, '\P{Is_Blk=	IDEOGRAPHIC_Symbols}', "");
    Expect(0, 94208, '\P{^Is_Blk=	IDEOGRAPHIC_Symbols}', "");
    Error('\p{Block=:= -Imperial_Aramaic}');
    Error('\P{Block=:= -Imperial_Aramaic}');
    Expect(1, 67679, '\p{Block=:\AImperial_Aramaic\z:}', "");;
    Expect(0, 67680, '\p{Block=:\AImperial_Aramaic\z:}', "");;
    Expect(1, 67679, '\p{Block: imperialaramaic}', "");
    Expect(0, 67679, '\p{^Block: imperialaramaic}', "");
    Expect(0, 67679, '\P{Block: imperialaramaic}', "");
    Expect(1, 67679, '\P{^Block: imperialaramaic}', "");
    Expect(0, 67680, '\p{Block: imperialaramaic}', "");
    Expect(1, 67680, '\p{^Block: imperialaramaic}', "");
    Expect(1, 67680, '\P{Block: imperialaramaic}', "");
    Expect(0, 67680, '\P{^Block: imperialaramaic}', "");
    Expect(1, 67679, '\p{Block=:\Aimperialaramaic\z:}', "");;
    Expect(0, 67680, '\p{Block=:\Aimperialaramaic\z:}', "");;
    Expect(1, 67679, '\p{Block=	imperial_aramaic}', "");
    Expect(0, 67679, '\p{^Block=	imperial_aramaic}', "");
    Expect(0, 67679, '\P{Block=	imperial_aramaic}', "");
    Expect(1, 67679, '\P{^Block=	imperial_aramaic}', "");
    Expect(0, 67680, '\p{Block=	imperial_aramaic}', "");
    Expect(1, 67680, '\p{^Block=	imperial_aramaic}', "");
    Expect(1, 67680, '\P{Block=	imperial_aramaic}', "");
    Expect(0, 67680, '\P{^Block=	imperial_aramaic}', "");
    Error('\p{Blk=__Imperial_Aramaic:=}');
    Error('\P{Blk=__Imperial_Aramaic:=}');
    Expect(1, 67679, '\p{Blk=:\AImperial_Aramaic\z:}', "");;
    Expect(0, 67680, '\p{Blk=:\AImperial_Aramaic\z:}', "");;
    Expect(1, 67679, '\p{Blk: imperialaramaic}', "");
    Expect(0, 67679, '\p{^Blk: imperialaramaic}', "");
    Expect(0, 67679, '\P{Blk: imperialaramaic}', "");
    Expect(1, 67679, '\P{^Blk: imperialaramaic}', "");
    Expect(0, 67680, '\p{Blk: imperialaramaic}', "");
    Expect(1, 67680, '\p{^Blk: imperialaramaic}', "");
    Expect(1, 67680, '\P{Blk: imperialaramaic}', "");
    Expect(0, 67680, '\P{^Blk: imperialaramaic}', "");
    Expect(1, 67679, '\p{Blk=:\Aimperialaramaic\z:}', "");;
    Expect(0, 67680, '\p{Blk=:\Aimperialaramaic\z:}', "");;
    Expect(1, 67679, '\p{Blk= IMPERIAL_Aramaic}', "");
    Expect(0, 67679, '\p{^Blk= IMPERIAL_Aramaic}', "");
    Expect(0, 67679, '\P{Blk= IMPERIAL_Aramaic}', "");
    Expect(1, 67679, '\P{^Blk= IMPERIAL_Aramaic}', "");
    Expect(0, 67680, '\p{Blk= IMPERIAL_Aramaic}', "");
    Expect(1, 67680, '\p{^Blk= IMPERIAL_Aramaic}', "");
    Expect(1, 67680, '\P{Blk= IMPERIAL_Aramaic}', "");
    Expect(0, 67680, '\P{^Blk= IMPERIAL_Aramaic}', "");
    Error('\p{Is_Block:-/a/Imperial_ARAMAIC}');
    Error('\P{Is_Block:-/a/Imperial_ARAMAIC}');
    Expect(1, 67679, '\p{Is_Block=imperialaramaic}', "");
    Expect(0, 67679, '\p{^Is_Block=imperialaramaic}', "");
    Expect(0, 67679, '\P{Is_Block=imperialaramaic}', "");
    Expect(1, 67679, '\P{^Is_Block=imperialaramaic}', "");
    Expect(0, 67680, '\p{Is_Block=imperialaramaic}', "");
    Expect(1, 67680, '\p{^Is_Block=imperialaramaic}', "");
    Expect(1, 67680, '\P{Is_Block=imperialaramaic}', "");
    Expect(0, 67680, '\P{^Is_Block=imperialaramaic}', "");
    Expect(1, 67679, '\p{Is_Block=-Imperial_Aramaic}', "");
    Expect(0, 67679, '\p{^Is_Block=-Imperial_Aramaic}', "");
    Expect(0, 67679, '\P{Is_Block=-Imperial_Aramaic}', "");
    Expect(1, 67679, '\P{^Is_Block=-Imperial_Aramaic}', "");
    Expect(0, 67680, '\p{Is_Block=-Imperial_Aramaic}', "");
    Expect(1, 67680, '\p{^Is_Block=-Imperial_Aramaic}', "");
    Expect(1, 67680, '\P{Is_Block=-Imperial_Aramaic}', "");
    Expect(0, 67680, '\P{^Is_Block=-Imperial_Aramaic}', "");
    Error('\p{Is_Blk=:=	Imperial_Aramaic}');
    Error('\P{Is_Blk=:=	Imperial_Aramaic}');
    Expect(1, 67679, '\p{Is_Blk=imperialaramaic}', "");
    Expect(0, 67679, '\p{^Is_Blk=imperialaramaic}', "");
    Expect(0, 67679, '\P{Is_Blk=imperialaramaic}', "");
    Expect(1, 67679, '\P{^Is_Blk=imperialaramaic}', "");
    Expect(0, 67680, '\p{Is_Blk=imperialaramaic}', "");
    Expect(1, 67680, '\p{^Is_Blk=imperialaramaic}', "");
    Expect(1, 67680, '\P{Is_Blk=imperialaramaic}', "");
    Expect(0, 67680, '\P{^Is_Blk=imperialaramaic}', "");
    Expect(1, 67679, '\p{Is_Blk=		Imperial_Aramaic}', "");
    Expect(0, 67679, '\p{^Is_Blk=		Imperial_Aramaic}', "");
    Expect(0, 67679, '\P{Is_Blk=		Imperial_Aramaic}', "");
    Expect(1, 67679, '\P{^Is_Blk=		Imperial_Aramaic}', "");
    Expect(0, 67680, '\p{Is_Blk=		Imperial_Aramaic}', "");
    Expect(1, 67680, '\p{^Is_Blk=		Imperial_Aramaic}', "");
    Expect(1, 67680, '\P{Is_Blk=		Imperial_Aramaic}', "");
    Expect(0, 67680, '\P{^Is_Blk=		Imperial_Aramaic}', "");
    Error('\p{Block= :=COMMON_Indic_Number_forms}');
    Error('\P{Block= :=COMMON_Indic_Number_forms}');
    Expect(1, 43071, '\p{Block=:\ACommon_Indic_Number_Forms\z:}', "");;
    Expect(0, 43072, '\p{Block=:\ACommon_Indic_Number_Forms\z:}', "");;
    Expect(1, 43071, '\p{Block=commonindicnumberforms}', "");
    Expect(0, 43071, '\p{^Block=commonindicnumberforms}', "");
    Expect(0, 43071, '\P{Block=commonindicnumberforms}', "");
    Expect(1, 43071, '\P{^Block=commonindicnumberforms}', "");
    Expect(0, 43072, '\p{Block=commonindicnumberforms}', "");
    Expect(1, 43072, '\p{^Block=commonindicnumberforms}', "");
    Expect(1, 43072, '\P{Block=commonindicnumberforms}', "");
    Expect(0, 43072, '\P{^Block=commonindicnumberforms}', "");
    Expect(1, 43071, '\p{Block=:\Acommonindicnumberforms\z:}', "");;
    Expect(0, 43072, '\p{Block=:\Acommonindicnumberforms\z:}', "");;
    Expect(1, 43071, '\p{Block=- common_Indic_NUMBER_Forms}', "");
    Expect(0, 43071, '\p{^Block=- common_Indic_NUMBER_Forms}', "");
    Expect(0, 43071, '\P{Block=- common_Indic_NUMBER_Forms}', "");
    Expect(1, 43071, '\P{^Block=- common_Indic_NUMBER_Forms}', "");
    Expect(0, 43072, '\p{Block=- common_Indic_NUMBER_Forms}', "");
    Expect(1, 43072, '\p{^Block=- common_Indic_NUMBER_Forms}', "");
    Expect(1, 43072, '\P{Block=- common_Indic_NUMBER_Forms}', "");
    Expect(0, 43072, '\P{^Block=- common_Indic_NUMBER_Forms}', "");
    Error('\p{Blk=__INDIC_Number_Forms/a/}');
    Error('\P{Blk=__INDIC_Number_Forms/a/}');
    Expect(1, 43071, '\p{Blk=:\AIndic_Number_Forms\z:}', "");;
    Expect(0, 43072, '\p{Blk=:\AIndic_Number_Forms\z:}', "");;
    Expect(1, 43071, '\p{Blk=indicnumberforms}', "");
    Expect(0, 43071, '\p{^Blk=indicnumberforms}', "");
    Expect(0, 43071, '\P{Blk=indicnumberforms}', "");
    Expect(1, 43071, '\P{^Blk=indicnumberforms}', "");
    Expect(0, 43072, '\p{Blk=indicnumberforms}', "");
    Expect(1, 43072, '\p{^Blk=indicnumberforms}', "");
    Expect(1, 43072, '\P{Blk=indicnumberforms}', "");
    Expect(0, 43072, '\P{^Blk=indicnumberforms}', "");
    Expect(1, 43071, '\p{Blk=:\Aindicnumberforms\z:}', "");;
    Expect(0, 43072, '\p{Blk=:\Aindicnumberforms\z:}', "");;
    Expect(1, 43071, '\p{Blk=  Indic_number_FORMS}', "");
    Expect(0, 43071, '\p{^Blk=  Indic_number_FORMS}', "");
    Expect(0, 43071, '\P{Blk=  Indic_number_FORMS}', "");
    Expect(1, 43071, '\P{^Blk=  Indic_number_FORMS}', "");
    Expect(0, 43072, '\p{Blk=  Indic_number_FORMS}', "");
    Expect(1, 43072, '\p{^Blk=  Indic_number_FORMS}', "");
    Expect(1, 43072, '\P{Blk=  Indic_number_FORMS}', "");
    Expect(0, 43072, '\P{^Blk=  Indic_number_FORMS}', "");
    Error('\p{Is_Block=_ COMMON_indic_Number_forms:=}');
    Error('\P{Is_Block=_ COMMON_indic_Number_forms:=}');
    Expect(1, 43071, '\p{Is_Block=commonindicnumberforms}', "");
    Expect(0, 43071, '\p{^Is_Block=commonindicnumberforms}', "");
    Expect(0, 43071, '\P{Is_Block=commonindicnumberforms}', "");
    Expect(1, 43071, '\P{^Is_Block=commonindicnumberforms}', "");
    Expect(0, 43072, '\p{Is_Block=commonindicnumberforms}', "");
    Expect(1, 43072, '\p{^Is_Block=commonindicnumberforms}', "");
    Expect(1, 43072, '\P{Is_Block=commonindicnumberforms}', "");
    Expect(0, 43072, '\P{^Is_Block=commonindicnumberforms}', "");
    Expect(1, 43071, '\p{Is_Block=__COMMON_Indic_Number_Forms}', "");
    Expect(0, 43071, '\p{^Is_Block=__COMMON_Indic_Number_Forms}', "");
    Expect(0, 43071, '\P{Is_Block=__COMMON_Indic_Number_Forms}', "");
    Expect(1, 43071, '\P{^Is_Block=__COMMON_Indic_Number_Forms}', "");
    Expect(0, 43072, '\p{Is_Block=__COMMON_Indic_Number_Forms}', "");
    Expect(1, 43072, '\p{^Is_Block=__COMMON_Indic_Number_Forms}', "");
    Expect(1, 43072, '\P{Is_Block=__COMMON_Indic_Number_Forms}', "");
    Expect(0, 43072, '\P{^Is_Block=__COMMON_Indic_Number_Forms}', "");
    Error('\p{Is_Blk=/a/INDIC_number_Forms}');
    Error('\P{Is_Blk=/a/INDIC_number_Forms}');
    Expect(1, 43071, '\p{Is_Blk=indicnumberforms}', "");
    Expect(0, 43071, '\p{^Is_Blk=indicnumberforms}', "");
    Expect(0, 43071, '\P{Is_Blk=indicnumberforms}', "");
    Expect(1, 43071, '\P{^Is_Blk=indicnumberforms}', "");
    Expect(0, 43072, '\p{Is_Blk=indicnumberforms}', "");
    Expect(1, 43072, '\p{^Is_Blk=indicnumberforms}', "");
    Expect(1, 43072, '\P{Is_Blk=indicnumberforms}', "");
    Expect(0, 43072, '\P{^Is_Blk=indicnumberforms}', "");
    Expect(1, 43071, '\p{Is_Blk=-_Indic_NUMBER_forms}', "");
    Expect(0, 43071, '\p{^Is_Blk=-_Indic_NUMBER_forms}', "");
    Expect(0, 43071, '\P{Is_Blk=-_Indic_NUMBER_forms}', "");
    Expect(1, 43071, '\P{^Is_Blk=-_Indic_NUMBER_forms}', "");
    Expect(0, 43072, '\p{Is_Blk=-_Indic_NUMBER_forms}', "");
    Expect(1, 43072, '\p{^Is_Blk=-_Indic_NUMBER_forms}', "");
    Expect(1, 43072, '\P{Is_Blk=-_Indic_NUMBER_forms}', "");
    Expect(0, 43072, '\P{^Is_Blk=-_Indic_NUMBER_forms}', "");
    Error('\p{Block= :=Indic_SIYAQ_NUMBERS}');
    Error('\P{Block= :=Indic_SIYAQ_NUMBERS}');
    Expect(1, 126143, '\p{Block=:\AIndic_Siyaq_Numbers\z:}', "");;
    Expect(0, 126144, '\p{Block=:\AIndic_Siyaq_Numbers\z:}', "");;
    Expect(1, 126143, '\p{Block=indicsiyaqnumbers}', "");
    Expect(0, 126143, '\p{^Block=indicsiyaqnumbers}', "");
    Expect(0, 126143, '\P{Block=indicsiyaqnumbers}', "");
    Expect(1, 126143, '\P{^Block=indicsiyaqnumbers}', "");
    Expect(0, 126144, '\p{Block=indicsiyaqnumbers}', "");
    Expect(1, 126144, '\p{^Block=indicsiyaqnumbers}', "");
    Expect(1, 126144, '\P{Block=indicsiyaqnumbers}', "");
    Expect(0, 126144, '\P{^Block=indicsiyaqnumbers}', "");
    Expect(1, 126143, '\p{Block=:\Aindicsiyaqnumbers\z:}', "");;
    Expect(0, 126144, '\p{Block=:\Aindicsiyaqnumbers\z:}', "");;
    Expect(1, 126143, '\p{Block=-_Indic_siyaq_NUMBERS}', "");
    Expect(0, 126143, '\p{^Block=-_Indic_siyaq_NUMBERS}', "");
    Expect(0, 126143, '\P{Block=-_Indic_siyaq_NUMBERS}', "");
    Expect(1, 126143, '\P{^Block=-_Indic_siyaq_NUMBERS}', "");
    Expect(0, 126144, '\p{Block=-_Indic_siyaq_NUMBERS}', "");
    Expect(1, 126144, '\p{^Block=-_Indic_siyaq_NUMBERS}', "");
    Expect(1, 126144, '\P{Block=-_Indic_siyaq_NUMBERS}', "");
    Expect(0, 126144, '\P{^Block=-_Indic_siyaq_NUMBERS}', "");
    Error('\p{Blk=-:=Indic_siyaq_Numbers}');
    Error('\P{Blk=-:=Indic_siyaq_Numbers}');
    Expect(1, 126143, '\p{Blk=:\AIndic_Siyaq_Numbers\z:}', "");;
    Expect(0, 126144, '\p{Blk=:\AIndic_Siyaq_Numbers\z:}', "");;
    Expect(1, 126143, '\p{Blk=indicsiyaqnumbers}', "");
    Expect(0, 126143, '\p{^Blk=indicsiyaqnumbers}', "");
    Expect(0, 126143, '\P{Blk=indicsiyaqnumbers}', "");
    Expect(1, 126143, '\P{^Blk=indicsiyaqnumbers}', "");
    Expect(0, 126144, '\p{Blk=indicsiyaqnumbers}', "");
    Expect(1, 126144, '\p{^Blk=indicsiyaqnumbers}', "");
    Expect(1, 126144, '\P{Blk=indicsiyaqnumbers}', "");
    Expect(0, 126144, '\P{^Blk=indicsiyaqnumbers}', "");
    Expect(1, 126143, '\p{Blk=:\Aindicsiyaqnumbers\z:}', "");;
    Expect(0, 126144, '\p{Blk=:\Aindicsiyaqnumbers\z:}', "");;
    Expect(1, 126143, '\p{Blk= 	INDIC_SIYAQ_Numbers}', "");
    Expect(0, 126143, '\p{^Blk= 	INDIC_SIYAQ_Numbers}', "");
    Expect(0, 126143, '\P{Blk= 	INDIC_SIYAQ_Numbers}', "");
    Expect(1, 126143, '\P{^Blk= 	INDIC_SIYAQ_Numbers}', "");
    Expect(0, 126144, '\p{Blk= 	INDIC_SIYAQ_Numbers}', "");
    Expect(1, 126144, '\p{^Blk= 	INDIC_SIYAQ_Numbers}', "");
    Expect(1, 126144, '\P{Blk= 	INDIC_SIYAQ_Numbers}', "");
    Expect(0, 126144, '\P{^Blk= 	INDIC_SIYAQ_Numbers}', "");
    Error('\p{Is_Block=_/a/indic_Siyaq_Numbers}');
    Error('\P{Is_Block=_/a/indic_Siyaq_Numbers}');
    Expect(1, 126143, '\p{Is_Block: indicsiyaqnumbers}', "");
    Expect(0, 126143, '\p{^Is_Block: indicsiyaqnumbers}', "");
    Expect(0, 126143, '\P{Is_Block: indicsiyaqnumbers}', "");
    Expect(1, 126143, '\P{^Is_Block: indicsiyaqnumbers}', "");
    Expect(0, 126144, '\p{Is_Block: indicsiyaqnumbers}', "");
    Expect(1, 126144, '\p{^Is_Block: indicsiyaqnumbers}', "");
    Expect(1, 126144, '\P{Is_Block: indicsiyaqnumbers}', "");
    Expect(0, 126144, '\P{^Is_Block: indicsiyaqnumbers}', "");
    Expect(1, 126143, '\p{Is_Block=  Indic_SIYAQ_Numbers}', "");
    Expect(0, 126143, '\p{^Is_Block=  Indic_SIYAQ_Numbers}', "");
    Expect(0, 126143, '\P{Is_Block=  Indic_SIYAQ_Numbers}', "");
    Expect(1, 126143, '\P{^Is_Block=  Indic_SIYAQ_Numbers}', "");
    Expect(0, 126144, '\p{Is_Block=  Indic_SIYAQ_Numbers}', "");
    Expect(1, 126144, '\p{^Is_Block=  Indic_SIYAQ_Numbers}', "");
    Expect(1, 126144, '\P{Is_Block=  Indic_SIYAQ_Numbers}', "");
    Expect(0, 126144, '\P{^Is_Block=  Indic_SIYAQ_Numbers}', "");
    Error('\p{Is_Blk=/a/ _Indic_siyaq_numbers}');
    Error('\P{Is_Blk=/a/ _Indic_siyaq_numbers}');
    Expect(1, 126143, '\p{Is_Blk=indicsiyaqnumbers}', "");
    Expect(0, 126143, '\p{^Is_Blk=indicsiyaqnumbers}', "");
    Expect(0, 126143, '\P{Is_Blk=indicsiyaqnumbers}', "");
    Expect(1, 126143, '\P{^Is_Blk=indicsiyaqnumbers}', "");
    Expect(0, 126144, '\p{Is_Blk=indicsiyaqnumbers}', "");
    Expect(1, 126144, '\p{^Is_Blk=indicsiyaqnumbers}', "");
    Expect(1, 126144, '\P{Is_Blk=indicsiyaqnumbers}', "");
    Expect(0, 126144, '\P{^Is_Blk=indicsiyaqnumbers}', "");
    Expect(1, 126143, '\p{Is_Blk=  Indic_Siyaq_Numbers}', "");
    Expect(0, 126143, '\p{^Is_Blk=  Indic_Siyaq_Numbers}', "");
    Expect(0, 126143, '\P{Is_Blk=  Indic_Siyaq_Numbers}', "");
    Expect(1, 126143, '\P{^Is_Blk=  Indic_Siyaq_Numbers}', "");
    Expect(0, 126144, '\p{Is_Blk=  Indic_Siyaq_Numbers}', "");
    Expect(1, 126144, '\p{^Is_Blk=  Indic_Siyaq_Numbers}', "");
    Expect(1, 126144, '\P{Is_Blk=  Indic_Siyaq_Numbers}', "");
    Expect(0, 126144, '\P{^Is_Blk=  Indic_Siyaq_Numbers}', "");
    Error('\p{Block=- Inscriptional_Pahlavi/a/}');
    Error('\P{Block=- Inscriptional_Pahlavi/a/}');
    Expect(1, 68479, '\p{Block=:\AInscriptional_Pahlavi\z:}', "");;
    Expect(0, 68480, '\p{Block=:\AInscriptional_Pahlavi\z:}', "");;
    Expect(1, 68479, '\p{Block=inscriptionalpahlavi}', "");
    Expect(0, 68479, '\p{^Block=inscriptionalpahlavi}', "");
    Expect(0, 68479, '\P{Block=inscriptionalpahlavi}', "");
    Expect(1, 68479, '\P{^Block=inscriptionalpahlavi}', "");
    Expect(0, 68480, '\p{Block=inscriptionalpahlavi}', "");
    Expect(1, 68480, '\p{^Block=inscriptionalpahlavi}', "");
    Expect(1, 68480, '\P{Block=inscriptionalpahlavi}', "");
    Expect(0, 68480, '\P{^Block=inscriptionalpahlavi}', "");
    Expect(1, 68479, '\p{Block=:\Ainscriptionalpahlavi\z:}', "");;
    Expect(0, 68480, '\p{Block=:\Ainscriptionalpahlavi\z:}', "");;
    Expect(1, 68479, '\p{Block=_Inscriptional_pahlavi}', "");
    Expect(0, 68479, '\p{^Block=_Inscriptional_pahlavi}', "");
    Expect(0, 68479, '\P{Block=_Inscriptional_pahlavi}', "");
    Expect(1, 68479, '\P{^Block=_Inscriptional_pahlavi}', "");
    Expect(0, 68480, '\p{Block=_Inscriptional_pahlavi}', "");
    Expect(1, 68480, '\p{^Block=_Inscriptional_pahlavi}', "");
    Expect(1, 68480, '\P{Block=_Inscriptional_pahlavi}', "");
    Expect(0, 68480, '\P{^Block=_Inscriptional_pahlavi}', "");
    Error('\p{Blk:	 	INSCRIPTIONAL_Pahlavi/a/}');
    Error('\P{Blk:	 	INSCRIPTIONAL_Pahlavi/a/}');
    Expect(1, 68479, '\p{Blk=:\AInscriptional_Pahlavi\z:}', "");;
    Expect(0, 68480, '\p{Blk=:\AInscriptional_Pahlavi\z:}', "");;
    Expect(1, 68479, '\p{Blk:	inscriptionalpahlavi}', "");
    Expect(0, 68479, '\p{^Blk:	inscriptionalpahlavi}', "");
    Expect(0, 68479, '\P{Blk:	inscriptionalpahlavi}', "");
    Expect(1, 68479, '\P{^Blk:	inscriptionalpahlavi}', "");
    Expect(0, 68480, '\p{Blk:	inscriptionalpahlavi}', "");
    Expect(1, 68480, '\p{^Blk:	inscriptionalpahlavi}', "");
    Expect(1, 68480, '\P{Blk:	inscriptionalpahlavi}', "");
    Expect(0, 68480, '\P{^Blk:	inscriptionalpahlavi}', "");
    Expect(1, 68479, '\p{Blk=:\Ainscriptionalpahlavi\z:}', "");;
    Expect(0, 68480, '\p{Blk=:\Ainscriptionalpahlavi\z:}', "");;
    Expect(1, 68479, '\p{Blk=_-Inscriptional_Pahlavi}', "");
    Expect(0, 68479, '\p{^Blk=_-Inscriptional_Pahlavi}', "");
    Expect(0, 68479, '\P{Blk=_-Inscriptional_Pahlavi}', "");
    Expect(1, 68479, '\P{^Blk=_-Inscriptional_Pahlavi}', "");
    Expect(0, 68480, '\p{Blk=_-Inscriptional_Pahlavi}', "");
    Expect(1, 68480, '\p{^Blk=_-Inscriptional_Pahlavi}', "");
    Expect(1, 68480, '\P{Blk=_-Inscriptional_Pahlavi}', "");
    Expect(0, 68480, '\P{^Blk=_-Inscriptional_Pahlavi}', "");
    Error('\p{Is_Block=/a/Inscriptional_Pahlavi}');
    Error('\P{Is_Block=/a/Inscriptional_Pahlavi}');
    Expect(1, 68479, '\p{Is_Block=inscriptionalpahlavi}', "");
    Expect(0, 68479, '\p{^Is_Block=inscriptionalpahlavi}', "");
    Expect(0, 68479, '\P{Is_Block=inscriptionalpahlavi}', "");
    Expect(1, 68479, '\P{^Is_Block=inscriptionalpahlavi}', "");
    Expect(0, 68480, '\p{Is_Block=inscriptionalpahlavi}', "");
    Expect(1, 68480, '\p{^Is_Block=inscriptionalpahlavi}', "");
    Expect(1, 68480, '\P{Is_Block=inscriptionalpahlavi}', "");
    Expect(0, 68480, '\P{^Is_Block=inscriptionalpahlavi}', "");
    Expect(1, 68479, '\p{Is_Block=	Inscriptional_Pahlavi}', "");
    Expect(0, 68479, '\p{^Is_Block=	Inscriptional_Pahlavi}', "");
    Expect(0, 68479, '\P{Is_Block=	Inscriptional_Pahlavi}', "");
    Expect(1, 68479, '\P{^Is_Block=	Inscriptional_Pahlavi}', "");
    Expect(0, 68480, '\p{Is_Block=	Inscriptional_Pahlavi}', "");
    Expect(1, 68480, '\p{^Is_Block=	Inscriptional_Pahlavi}', "");
    Expect(1, 68480, '\P{Is_Block=	Inscriptional_Pahlavi}', "");
    Expect(0, 68480, '\P{^Is_Block=	Inscriptional_Pahlavi}', "");
    Error('\p{Is_Blk=/a/	Inscriptional_Pahlavi}');
    Error('\P{Is_Blk=/a/	Inscriptional_Pahlavi}');
    Expect(1, 68479, '\p{Is_Blk=inscriptionalpahlavi}', "");
    Expect(0, 68479, '\p{^Is_Blk=inscriptionalpahlavi}', "");
    Expect(0, 68479, '\P{Is_Blk=inscriptionalpahlavi}', "");
    Expect(1, 68479, '\P{^Is_Blk=inscriptionalpahlavi}', "");
    Expect(0, 68480, '\p{Is_Blk=inscriptionalpahlavi}', "");
    Expect(1, 68480, '\p{^Is_Blk=inscriptionalpahlavi}', "");
    Expect(1, 68480, '\P{Is_Blk=inscriptionalpahlavi}', "");
    Expect(0, 68480, '\P{^Is_Blk=inscriptionalpahlavi}', "");
    Expect(1, 68479, '\p{Is_Blk= _Inscriptional_PAHLAVI}', "");
    Expect(0, 68479, '\p{^Is_Blk= _Inscriptional_PAHLAVI}', "");
    Expect(0, 68479, '\P{Is_Blk= _Inscriptional_PAHLAVI}', "");
    Expect(1, 68479, '\P{^Is_Blk= _Inscriptional_PAHLAVI}', "");
    Expect(0, 68480, '\p{Is_Blk= _Inscriptional_PAHLAVI}', "");
    Expect(1, 68480, '\p{^Is_Blk= _Inscriptional_PAHLAVI}', "");
    Expect(1, 68480, '\P{Is_Blk= _Inscriptional_PAHLAVI}', "");
    Expect(0, 68480, '\P{^Is_Blk= _Inscriptional_PAHLAVI}', "");
    Error('\p{Block:/a/-Inscriptional_parthian}');
    Error('\P{Block:/a/-Inscriptional_parthian}');
    Expect(1, 68447, '\p{Block=:\AInscriptional_Parthian\z:}', "");;
    Expect(0, 68448, '\p{Block=:\AInscriptional_Parthian\z:}', "");;
    Expect(1, 68447, '\p{Block=inscriptionalparthian}', "");
    Expect(0, 68447, '\p{^Block=inscriptionalparthian}', "");
    Expect(0, 68447, '\P{Block=inscriptionalparthian}', "");
    Expect(1, 68447, '\P{^Block=inscriptionalparthian}', "");
    Expect(0, 68448, '\p{Block=inscriptionalparthian}', "");
    Expect(1, 68448, '\p{^Block=inscriptionalparthian}', "");
    Expect(1, 68448, '\P{Block=inscriptionalparthian}', "");
    Expect(0, 68448, '\P{^Block=inscriptionalparthian}', "");
    Expect(1, 68447, '\p{Block=:\Ainscriptionalparthian\z:}', "");;
    Expect(0, 68448, '\p{Block=:\Ainscriptionalparthian\z:}', "");;
    Expect(1, 68447, '\p{Block=--inscriptional_parthian}', "");
    Expect(0, 68447, '\p{^Block=--inscriptional_parthian}', "");
    Expect(0, 68447, '\P{Block=--inscriptional_parthian}', "");
    Expect(1, 68447, '\P{^Block=--inscriptional_parthian}', "");
    Expect(0, 68448, '\p{Block=--inscriptional_parthian}', "");
    Expect(1, 68448, '\p{^Block=--inscriptional_parthian}', "");
    Expect(1, 68448, '\P{Block=--inscriptional_parthian}', "");
    Expect(0, 68448, '\P{^Block=--inscriptional_parthian}', "");
    Error('\p{Blk=-:=Inscriptional_Parthian}');
    Error('\P{Blk=-:=Inscriptional_Parthian}');
    Expect(1, 68447, '\p{Blk=:\AInscriptional_Parthian\z:}', "");;
    Expect(0, 68448, '\p{Blk=:\AInscriptional_Parthian\z:}', "");;
    Expect(1, 68447, '\p{Blk:   inscriptionalparthian}', "");
    Expect(0, 68447, '\p{^Blk:   inscriptionalparthian}', "");
    Expect(0, 68447, '\P{Blk:   inscriptionalparthian}', "");
    Expect(1, 68447, '\P{^Blk:   inscriptionalparthian}', "");
    Expect(0, 68448, '\p{Blk:   inscriptionalparthian}', "");
    Expect(1, 68448, '\p{^Blk:   inscriptionalparthian}', "");
    Expect(1, 68448, '\P{Blk:   inscriptionalparthian}', "");
    Expect(0, 68448, '\P{^Blk:   inscriptionalparthian}', "");
    Expect(1, 68447, '\p{Blk=:\Ainscriptionalparthian\z:}', "");;
    Expect(0, 68448, '\p{Blk=:\Ainscriptionalparthian\z:}', "");;
    Expect(1, 68447, '\p{Blk=- Inscriptional_parthian}', "");
    Expect(0, 68447, '\p{^Blk=- Inscriptional_parthian}', "");
    Expect(0, 68447, '\P{Blk=- Inscriptional_parthian}', "");
    Expect(1, 68447, '\P{^Blk=- Inscriptional_parthian}', "");
    Expect(0, 68448, '\p{Blk=- Inscriptional_parthian}', "");
    Expect(1, 68448, '\p{^Blk=- Inscriptional_parthian}', "");
    Expect(1, 68448, '\P{Blk=- Inscriptional_parthian}', "");
    Expect(0, 68448, '\P{^Blk=- Inscriptional_parthian}', "");
    Error('\p{Is_Block=-/a/Inscriptional_parthian}');
    Error('\P{Is_Block=-/a/Inscriptional_parthian}');
    Expect(1, 68447, '\p{Is_Block=inscriptionalparthian}', "");
    Expect(0, 68447, '\p{^Is_Block=inscriptionalparthian}', "");
    Expect(0, 68447, '\P{Is_Block=inscriptionalparthian}', "");
    Expect(1, 68447, '\P{^Is_Block=inscriptionalparthian}', "");
    Expect(0, 68448, '\p{Is_Block=inscriptionalparthian}', "");
    Expect(1, 68448, '\p{^Is_Block=inscriptionalparthian}', "");
    Expect(1, 68448, '\P{Is_Block=inscriptionalparthian}', "");
    Expect(0, 68448, '\P{^Is_Block=inscriptionalparthian}', "");
    Expect(1, 68447, '\p{Is_Block=	 Inscriptional_PARTHIAN}', "");
    Expect(0, 68447, '\p{^Is_Block=	 Inscriptional_PARTHIAN}', "");
    Expect(0, 68447, '\P{Is_Block=	 Inscriptional_PARTHIAN}', "");
    Expect(1, 68447, '\P{^Is_Block=	 Inscriptional_PARTHIAN}', "");
    Expect(0, 68448, '\p{Is_Block=	 Inscriptional_PARTHIAN}', "");
    Expect(1, 68448, '\p{^Is_Block=	 Inscriptional_PARTHIAN}', "");
    Expect(1, 68448, '\P{Is_Block=	 Inscriptional_PARTHIAN}', "");
    Expect(0, 68448, '\P{^Is_Block=	 Inscriptional_PARTHIAN}', "");
    Error('\p{Is_Blk:   /a/	 inscriptional_Parthian}');
    Error('\P{Is_Blk:   /a/	 inscriptional_Parthian}');
    Expect(1, 68447, '\p{Is_Blk=inscriptionalparthian}', "");
    Expect(0, 68447, '\p{^Is_Blk=inscriptionalparthian}', "");
    Expect(0, 68447, '\P{Is_Blk=inscriptionalparthian}', "");
    Expect(1, 68447, '\P{^Is_Blk=inscriptionalparthian}', "");
    Expect(0, 68448, '\p{Is_Blk=inscriptionalparthian}', "");
    Expect(1, 68448, '\p{^Is_Blk=inscriptionalparthian}', "");
    Expect(1, 68448, '\P{Is_Blk=inscriptionalparthian}', "");
    Expect(0, 68448, '\P{^Is_Blk=inscriptionalparthian}', "");
    Expect(1, 68447, '\p{Is_Blk= _inscriptional_Parthian}', "");
    Expect(0, 68447, '\p{^Is_Blk= _inscriptional_Parthian}', "");
    Expect(0, 68447, '\P{Is_Blk= _inscriptional_Parthian}', "");
    Expect(1, 68447, '\P{^Is_Blk= _inscriptional_Parthian}', "");
    Expect(0, 68448, '\p{Is_Blk= _inscriptional_Parthian}', "");
    Expect(1, 68448, '\p{^Is_Blk= _inscriptional_Parthian}', "");
    Expect(1, 68448, '\P{Is_Blk= _inscriptional_Parthian}', "");
    Expect(0, 68448, '\P{^Is_Blk= _inscriptional_Parthian}', "");
    Error('\p{Block:    /a/ipa_Extensions}');
    Error('\P{Block:    /a/ipa_Extensions}');
    Expect(1, 687, '\p{Block=:\AIPA_Extensions\z:}', "");;
    Expect(0, 688, '\p{Block=:\AIPA_Extensions\z:}', "");;
    Expect(1, 687, '\p{Block=ipaextensions}', "");
    Expect(0, 687, '\p{^Block=ipaextensions}', "");
    Expect(0, 687, '\P{Block=ipaextensions}', "");
    Expect(1, 687, '\P{^Block=ipaextensions}', "");
    Expect(0, 688, '\p{Block=ipaextensions}', "");
    Expect(1, 688, '\p{^Block=ipaextensions}', "");
    Expect(1, 688, '\P{Block=ipaextensions}', "");
    Expect(0, 688, '\P{^Block=ipaextensions}', "");
    Expect(1, 687, '\p{Block=:\Aipaextensions\z:}', "");;
    Expect(0, 688, '\p{Block=:\Aipaextensions\z:}', "");;
    Expect(1, 687, '\p{Block=	 IPA_extensions}', "");
    Expect(0, 687, '\p{^Block=	 IPA_extensions}', "");
    Expect(0, 687, '\P{Block=	 IPA_extensions}', "");
    Expect(1, 687, '\P{^Block=	 IPA_extensions}', "");
    Expect(0, 688, '\p{Block=	 IPA_extensions}', "");
    Expect(1, 688, '\p{^Block=	 IPA_extensions}', "");
    Expect(1, 688, '\P{Block=	 IPA_extensions}', "");
    Expect(0, 688, '\P{^Block=	 IPA_extensions}', "");
    Error('\p{Blk=-_IPA_Ext/a/}');
    Error('\P{Blk=-_IPA_Ext/a/}');
    Expect(1, 687, '\p{Blk=:\AIPA_Ext\z:}', "");;
    Expect(0, 688, '\p{Blk=:\AIPA_Ext\z:}', "");;
    Expect(1, 687, '\p{Blk=ipaext}', "");
    Expect(0, 687, '\p{^Blk=ipaext}', "");
    Expect(0, 687, '\P{Blk=ipaext}', "");
    Expect(1, 687, '\P{^Blk=ipaext}', "");
    Expect(0, 688, '\p{Blk=ipaext}', "");
    Expect(1, 688, '\p{^Blk=ipaext}', "");
    Expect(1, 688, '\P{Blk=ipaext}', "");
    Expect(0, 688, '\P{^Blk=ipaext}', "");
    Expect(1, 687, '\p{Blk=:\Aipaext\z:}', "");;
    Expect(0, 688, '\p{Blk=:\Aipaext\z:}', "");;
    Expect(1, 687, '\p{Blk=_ IPA_Ext}', "");
    Expect(0, 687, '\p{^Blk=_ IPA_Ext}', "");
    Expect(0, 687, '\P{Blk=_ IPA_Ext}', "");
    Expect(1, 687, '\P{^Blk=_ IPA_Ext}', "");
    Expect(0, 688, '\p{Blk=_ IPA_Ext}', "");
    Expect(1, 688, '\p{^Blk=_ IPA_Ext}', "");
    Expect(1, 688, '\P{Blk=_ IPA_Ext}', "");
    Expect(0, 688, '\P{^Blk=_ IPA_Ext}', "");
    Error('\p{Is_Block=:= _IPA_extensions}');
    Error('\P{Is_Block=:= _IPA_extensions}');
    Expect(1, 687, '\p{Is_Block=ipaextensions}', "");
    Expect(0, 687, '\p{^Is_Block=ipaextensions}', "");
    Expect(0, 687, '\P{Is_Block=ipaextensions}', "");
    Expect(1, 687, '\P{^Is_Block=ipaextensions}', "");
    Expect(0, 688, '\p{Is_Block=ipaextensions}', "");
    Expect(1, 688, '\p{^Is_Block=ipaextensions}', "");
    Expect(1, 688, '\P{Is_Block=ipaextensions}', "");
    Expect(0, 688, '\P{^Is_Block=ipaextensions}', "");
    Expect(1, 687, '\p{Is_Block= _IPA_EXTENSIONS}', "");
    Expect(0, 687, '\p{^Is_Block= _IPA_EXTENSIONS}', "");
    Expect(0, 687, '\P{Is_Block= _IPA_EXTENSIONS}', "");
    Expect(1, 687, '\P{^Is_Block= _IPA_EXTENSIONS}', "");
    Expect(0, 688, '\p{Is_Block= _IPA_EXTENSIONS}', "");
    Expect(1, 688, '\p{^Is_Block= _IPA_EXTENSIONS}', "");
    Expect(1, 688, '\P{Is_Block= _IPA_EXTENSIONS}', "");
    Expect(0, 688, '\P{^Is_Block= _IPA_EXTENSIONS}', "");
    Error('\p{Is_Blk=_/a/ipa_Ext}');
    Error('\P{Is_Blk=_/a/ipa_Ext}');
    Expect(1, 687, '\p{Is_Blk=ipaext}', "");
    Expect(0, 687, '\p{^Is_Blk=ipaext}', "");
    Expect(0, 687, '\P{Is_Blk=ipaext}', "");
    Expect(1, 687, '\P{^Is_Blk=ipaext}', "");
    Expect(0, 688, '\p{Is_Blk=ipaext}', "");
    Expect(1, 688, '\p{^Is_Blk=ipaext}', "");
    Expect(1, 688, '\P{Is_Blk=ipaext}', "");
    Expect(0, 688, '\P{^Is_Blk=ipaext}', "");
    Expect(1, 687, '\p{Is_Blk: - IPA_Ext}', "");
    Expect(0, 687, '\p{^Is_Blk: - IPA_Ext}', "");
    Expect(0, 687, '\P{Is_Blk: - IPA_Ext}', "");
    Expect(1, 687, '\P{^Is_Blk: - IPA_Ext}', "");
    Expect(0, 688, '\p{Is_Blk: - IPA_Ext}', "");
    Expect(1, 688, '\p{^Is_Blk: - IPA_Ext}', "");
    Expect(1, 688, '\P{Is_Blk: - IPA_Ext}', "");
    Expect(0, 688, '\P{^Is_Blk: - IPA_Ext}', "");
    Error('\p{Block=:=-_hangul_JAMO}');
    Error('\P{Block=:=-_hangul_JAMO}');
    Expect(1, 4607, '\p{Block=:\AHangul_Jamo\z:}', "");;
    Expect(0, 4608, '\p{Block=:\AHangul_Jamo\z:}', "");;
    Expect(1, 4607, '\p{Block=hanguljamo}', "");
    Expect(0, 4607, '\p{^Block=hanguljamo}', "");
    Expect(0, 4607, '\P{Block=hanguljamo}', "");
    Expect(1, 4607, '\P{^Block=hanguljamo}', "");
    Expect(0, 4608, '\p{Block=hanguljamo}', "");
    Expect(1, 4608, '\p{^Block=hanguljamo}', "");
    Expect(1, 4608, '\P{Block=hanguljamo}', "");
    Expect(0, 4608, '\P{^Block=hanguljamo}', "");
    Expect(1, 4607, '\p{Block=:\Ahanguljamo\z:}', "");;
    Expect(0, 4608, '\p{Block=:\Ahanguljamo\z:}', "");;
    Expect(1, 4607, '\p{Block=		hangul_JAMO}', "");
    Expect(0, 4607, '\p{^Block=		hangul_JAMO}', "");
    Expect(0, 4607, '\P{Block=		hangul_JAMO}', "");
    Expect(1, 4607, '\P{^Block=		hangul_JAMO}', "");
    Expect(0, 4608, '\p{Block=		hangul_JAMO}', "");
    Expect(1, 4608, '\p{^Block=		hangul_JAMO}', "");
    Expect(1, 4608, '\P{Block=		hangul_JAMO}', "");
    Expect(0, 4608, '\P{^Block=		hangul_JAMO}', "");
    Error('\p{Blk=	Jamo:=}');
    Error('\P{Blk=	Jamo:=}');
    Expect(1, 4607, '\p{Blk=:\AJamo\z:}', "");;
    Expect(0, 4608, '\p{Blk=:\AJamo\z:}', "");;
    Expect(1, 4607, '\p{Blk: jamo}', "");
    Expect(0, 4607, '\p{^Blk: jamo}', "");
    Expect(0, 4607, '\P{Blk: jamo}', "");
    Expect(1, 4607, '\P{^Blk: jamo}', "");
    Expect(0, 4608, '\p{Blk: jamo}', "");
    Expect(1, 4608, '\p{^Blk: jamo}', "");
    Expect(1, 4608, '\P{Blk: jamo}', "");
    Expect(0, 4608, '\P{^Blk: jamo}', "");
    Expect(1, 4607, '\p{Blk=:\Ajamo\z:}', "");;
    Expect(0, 4608, '\p{Blk=:\Ajamo\z:}', "");;
    Expect(1, 4607, '\p{Blk:   Jamo}', "");
    Expect(0, 4607, '\p{^Blk:   Jamo}', "");
    Expect(0, 4607, '\P{Blk:   Jamo}', "");
    Expect(1, 4607, '\P{^Blk:   Jamo}', "");
    Expect(0, 4608, '\p{Blk:   Jamo}', "");
    Expect(1, 4608, '\p{^Blk:   Jamo}', "");
    Expect(1, 4608, '\P{Blk:   Jamo}', "");
    Expect(0, 4608, '\P{^Blk:   Jamo}', "");
    Error('\p{Is_Block=	-HANGUL_Jamo:=}');
    Error('\P{Is_Block=	-HANGUL_Jamo:=}');
    Expect(1, 4607, '\p{Is_Block=hanguljamo}', "");
    Expect(0, 4607, '\p{^Is_Block=hanguljamo}', "");
    Expect(0, 4607, '\P{Is_Block=hanguljamo}', "");
    Expect(1, 4607, '\P{^Is_Block=hanguljamo}', "");
    Expect(0, 4608, '\p{Is_Block=hanguljamo}', "");
    Expect(1, 4608, '\p{^Is_Block=hanguljamo}', "");
    Expect(1, 4608, '\P{Is_Block=hanguljamo}', "");
    Expect(0, 4608, '\P{^Is_Block=hanguljamo}', "");
    Expect(1, 4607, '\p{Is_Block= _Hangul_Jamo}', "");
    Expect(0, 4607, '\p{^Is_Block= _Hangul_Jamo}', "");
    Expect(0, 4607, '\P{Is_Block= _Hangul_Jamo}', "");
    Expect(1, 4607, '\P{^Is_Block= _Hangul_Jamo}', "");
    Expect(0, 4608, '\p{Is_Block= _Hangul_Jamo}', "");
    Expect(1, 4608, '\p{^Is_Block= _Hangul_Jamo}', "");
    Expect(1, 4608, '\P{Is_Block= _Hangul_Jamo}', "");
    Expect(0, 4608, '\P{^Is_Block= _Hangul_Jamo}', "");
    Error('\p{Is_Blk=_:=jamo}');
    Error('\P{Is_Blk=_:=jamo}');
    Expect(1, 4607, '\p{Is_Blk: jamo}', "");
    Expect(0, 4607, '\p{^Is_Blk: jamo}', "");
    Expect(0, 4607, '\P{Is_Blk: jamo}', "");
    Expect(1, 4607, '\P{^Is_Blk: jamo}', "");
    Expect(0, 4608, '\p{Is_Blk: jamo}', "");
    Expect(1, 4608, '\p{^Is_Blk: jamo}', "");
    Expect(1, 4608, '\P{Is_Blk: jamo}', "");
    Expect(0, 4608, '\P{^Is_Blk: jamo}', "");
    Expect(1, 4607, '\p{Is_Blk=_jamo}', "");
    Expect(0, 4607, '\p{^Is_Blk=_jamo}', "");
    Expect(0, 4607, '\P{Is_Blk=_jamo}', "");
    Expect(1, 4607, '\P{^Is_Blk=_jamo}', "");
    Expect(0, 4608, '\p{Is_Blk=_jamo}', "");
    Expect(1, 4608, '\p{^Is_Blk=_jamo}', "");
    Expect(1, 4608, '\P{Is_Blk=_jamo}', "");
    Expect(0, 4608, '\P{^Is_Blk=_jamo}', "");
    Error('\p{Block=:=_ HANGUL_Jamo_extended_a}');
    Error('\P{Block=:=_ HANGUL_Jamo_extended_a}');
    Expect(1, 43391, '\p{Block=:\AHangul_Jamo_Extended_A\z:}', "");;
    Expect(0, 43392, '\p{Block=:\AHangul_Jamo_Extended_A\z:}', "");;
    Expect(1, 43391, '\p{Block=hanguljamoextendeda}', "");
    Expect(0, 43391, '\p{^Block=hanguljamoextendeda}', "");
    Expect(0, 43391, '\P{Block=hanguljamoextendeda}', "");
    Expect(1, 43391, '\P{^Block=hanguljamoextendeda}', "");
    Expect(0, 43392, '\p{Block=hanguljamoextendeda}', "");
    Expect(1, 43392, '\p{^Block=hanguljamoextendeda}', "");
    Expect(1, 43392, '\P{Block=hanguljamoextendeda}', "");
    Expect(0, 43392, '\P{^Block=hanguljamoextendeda}', "");
    Expect(1, 43391, '\p{Block=:\Ahanguljamoextendeda\z:}', "");;
    Expect(0, 43392, '\p{Block=:\Ahanguljamoextendeda\z:}', "");;
    Expect(1, 43391, '\p{Block= Hangul_JAMO_Extended_a}', "");
    Expect(0, 43391, '\p{^Block= Hangul_JAMO_Extended_a}', "");
    Expect(0, 43391, '\P{Block= Hangul_JAMO_Extended_a}', "");
    Expect(1, 43391, '\P{^Block= Hangul_JAMO_Extended_a}', "");
    Expect(0, 43392, '\p{Block= Hangul_JAMO_Extended_a}', "");
    Expect(1, 43392, '\p{^Block= Hangul_JAMO_Extended_a}', "");
    Expect(1, 43392, '\P{Block= Hangul_JAMO_Extended_a}', "");
    Expect(0, 43392, '\P{^Block= Hangul_JAMO_Extended_a}', "");
    Error('\p{Blk=_/a/Jamo_Ext_A}');
    Error('\P{Blk=_/a/Jamo_Ext_A}');
    Expect(1, 43391, '\p{Blk=:\AJamo_Ext_A\z:}', "");;
    Expect(0, 43392, '\p{Blk=:\AJamo_Ext_A\z:}', "");;
    Expect(1, 43391, '\p{Blk=jamoexta}', "");
    Expect(0, 43391, '\p{^Blk=jamoexta}', "");
    Expect(0, 43391, '\P{Blk=jamoexta}', "");
    Expect(1, 43391, '\P{^Blk=jamoexta}', "");
    Expect(0, 43392, '\p{Blk=jamoexta}', "");
    Expect(1, 43392, '\p{^Blk=jamoexta}', "");
    Expect(1, 43392, '\P{Blk=jamoexta}', "");
    Expect(0, 43392, '\P{^Blk=jamoexta}', "");
    Expect(1, 43391, '\p{Blk=:\Ajamoexta\z:}', "");;
    Expect(0, 43392, '\p{Blk=:\Ajamoexta\z:}', "");;
    Expect(1, 43391, '\p{Blk=	Jamo_EXT_A}', "");
    Expect(0, 43391, '\p{^Blk=	Jamo_EXT_A}', "");
    Expect(0, 43391, '\P{Blk=	Jamo_EXT_A}', "");
    Expect(1, 43391, '\P{^Blk=	Jamo_EXT_A}', "");
    Expect(0, 43392, '\p{Blk=	Jamo_EXT_A}', "");
    Expect(1, 43392, '\p{^Blk=	Jamo_EXT_A}', "");
    Expect(1, 43392, '\P{Blk=	Jamo_EXT_A}', "");
    Expect(0, 43392, '\P{^Blk=	Jamo_EXT_A}', "");
    Error('\p{Is_Block= Hangul_jamo_EXTENDED_A:=}');
    Error('\P{Is_Block= Hangul_jamo_EXTENDED_A:=}');
    Expect(1, 43391, '\p{Is_Block: hanguljamoextendeda}', "");
    Expect(0, 43391, '\p{^Is_Block: hanguljamoextendeda}', "");
    Expect(0, 43391, '\P{Is_Block: hanguljamoextendeda}', "");
    Expect(1, 43391, '\P{^Is_Block: hanguljamoextendeda}', "");
    Expect(0, 43392, '\p{Is_Block: hanguljamoextendeda}', "");
    Expect(1, 43392, '\p{^Is_Block: hanguljamoextendeda}', "");
    Expect(1, 43392, '\P{Is_Block: hanguljamoextendeda}', "");
    Expect(0, 43392, '\P{^Is_Block: hanguljamoextendeda}', "");
    Expect(1, 43391, '\p{Is_Block=_-Hangul_JAMO_Extended_A}', "");
    Expect(0, 43391, '\p{^Is_Block=_-Hangul_JAMO_Extended_A}', "");
    Expect(0, 43391, '\P{Is_Block=_-Hangul_JAMO_Extended_A}', "");
    Expect(1, 43391, '\P{^Is_Block=_-Hangul_JAMO_Extended_A}', "");
    Expect(0, 43392, '\p{Is_Block=_-Hangul_JAMO_Extended_A}', "");
    Expect(1, 43392, '\p{^Is_Block=_-Hangul_JAMO_Extended_A}', "");
    Expect(1, 43392, '\P{Is_Block=_-Hangul_JAMO_Extended_A}', "");
    Expect(0, 43392, '\P{^Is_Block=_-Hangul_JAMO_Extended_A}', "");
    Error('\p{Is_Blk=/a/ jamo_ext_A}');
    Error('\P{Is_Blk=/a/ jamo_ext_A}');
    Expect(1, 43391, '\p{Is_Blk=jamoexta}', "");
    Expect(0, 43391, '\p{^Is_Blk=jamoexta}', "");
    Expect(0, 43391, '\P{Is_Blk=jamoexta}', "");
    Expect(1, 43391, '\P{^Is_Blk=jamoexta}', "");
    Expect(0, 43392, '\p{Is_Blk=jamoexta}', "");
    Expect(1, 43392, '\p{^Is_Blk=jamoexta}', "");
    Expect(1, 43392, '\P{Is_Blk=jamoexta}', "");
    Expect(0, 43392, '\P{^Is_Blk=jamoexta}', "");
    Expect(1, 43391, '\p{Is_Blk=-JAMO_Ext_A}', "");
    Expect(0, 43391, '\p{^Is_Blk=-JAMO_Ext_A}', "");
    Expect(0, 43391, '\P{Is_Blk=-JAMO_Ext_A}', "");
    Expect(1, 43391, '\P{^Is_Blk=-JAMO_Ext_A}', "");
    Expect(0, 43392, '\p{Is_Blk=-JAMO_Ext_A}', "");
    Expect(1, 43392, '\p{^Is_Blk=-JAMO_Ext_A}', "");
    Expect(1, 43392, '\P{Is_Blk=-JAMO_Ext_A}', "");
    Expect(0, 43392, '\P{^Is_Blk=-JAMO_Ext_A}', "");
    Error('\p{Block=:=-	Hangul_Jamo_Extended_b}');
    Error('\P{Block=:=-	Hangul_Jamo_Extended_b}');
    Expect(1, 55295, '\p{Block=:\AHangul_Jamo_Extended_B\z:}', "");;
    Expect(0, 57344, '\p{Block=:\AHangul_Jamo_Extended_B\z:}', "");;
    Expect(1, 55295, '\p{Block=hanguljamoextendedb}', "");
    Expect(0, 55295, '\p{^Block=hanguljamoextendedb}', "");
    Expect(0, 55295, '\P{Block=hanguljamoextendedb}', "");
    Expect(1, 55295, '\P{^Block=hanguljamoextendedb}', "");
    Expect(0, 57344, '\p{Block=hanguljamoextendedb}', "");
    Expect(1, 57344, '\p{^Block=hanguljamoextendedb}', "");
    Expect(1, 57344, '\P{Block=hanguljamoextendedb}', "");
    Expect(0, 57344, '\P{^Block=hanguljamoextendedb}', "");
    Expect(1, 55295, '\p{Block=:\Ahanguljamoextendedb\z:}', "");;
    Expect(0, 57344, '\p{Block=:\Ahanguljamoextendedb\z:}', "");;
    Expect(1, 55295, '\p{Block=	-HANGUL_jamo_EXTENDED_B}', "");
    Expect(0, 55295, '\p{^Block=	-HANGUL_jamo_EXTENDED_B}', "");
    Expect(0, 55295, '\P{Block=	-HANGUL_jamo_EXTENDED_B}', "");
    Expect(1, 55295, '\P{^Block=	-HANGUL_jamo_EXTENDED_B}', "");
    Expect(0, 57344, '\p{Block=	-HANGUL_jamo_EXTENDED_B}', "");
    Expect(1, 57344, '\p{^Block=	-HANGUL_jamo_EXTENDED_B}', "");
    Expect(1, 57344, '\P{Block=	-HANGUL_jamo_EXTENDED_B}', "");
    Expect(0, 57344, '\P{^Block=	-HANGUL_jamo_EXTENDED_B}', "");
    Error('\p{Blk=/a/-	Jamo_ext_B}');
    Error('\P{Blk=/a/-	Jamo_ext_B}');
    Expect(1, 55295, '\p{Blk=:\AJamo_Ext_B\z:}', "");;
    Expect(0, 57344, '\p{Blk=:\AJamo_Ext_B\z:}', "");;
    Expect(1, 55295, '\p{Blk=jamoextb}', "");
    Expect(0, 55295, '\p{^Blk=jamoextb}', "");
    Expect(0, 55295, '\P{Blk=jamoextb}', "");
    Expect(1, 55295, '\P{^Blk=jamoextb}', "");
    Expect(0, 57344, '\p{Blk=jamoextb}', "");
    Expect(1, 57344, '\p{^Blk=jamoextb}', "");
    Expect(1, 57344, '\P{Blk=jamoextb}', "");
    Expect(0, 57344, '\P{^Blk=jamoextb}', "");
    Expect(1, 55295, '\p{Blk=:\Ajamoextb\z:}', "");;
    Expect(0, 57344, '\p{Blk=:\Ajamoextb\z:}', "");;
    Expect(1, 55295, '\p{Blk=  Jamo_ext_b}', "");
    Expect(0, 55295, '\p{^Blk=  Jamo_ext_b}', "");
    Expect(0, 55295, '\P{Blk=  Jamo_ext_b}', "");
    Expect(1, 55295, '\P{^Blk=  Jamo_ext_b}', "");
    Expect(0, 57344, '\p{Blk=  Jamo_ext_b}', "");
    Expect(1, 57344, '\p{^Blk=  Jamo_ext_b}', "");
    Expect(1, 57344, '\P{Blk=  Jamo_ext_b}', "");
    Expect(0, 57344, '\P{^Blk=  Jamo_ext_b}', "");
    Error('\p{Is_Block=:=hangul_JAMO_extended_B}');
    Error('\P{Is_Block=:=hangul_JAMO_extended_B}');
    Expect(1, 55295, '\p{Is_Block:	hanguljamoextendedb}', "");
    Expect(0, 55295, '\p{^Is_Block:	hanguljamoextendedb}', "");
    Expect(0, 55295, '\P{Is_Block:	hanguljamoextendedb}', "");
    Expect(1, 55295, '\P{^Is_Block:	hanguljamoextendedb}', "");
    Expect(0, 57344, '\p{Is_Block:	hanguljamoextendedb}', "");
    Expect(1, 57344, '\p{^Is_Block:	hanguljamoextendedb}', "");
    Expect(1, 57344, '\P{Is_Block:	hanguljamoextendedb}', "");
    Expect(0, 57344, '\P{^Is_Block:	hanguljamoextendedb}', "");
    Expect(1, 55295, '\p{Is_Block=--hangul_Jamo_extended_B}', "");
    Expect(0, 55295, '\p{^Is_Block=--hangul_Jamo_extended_B}', "");
    Expect(0, 55295, '\P{Is_Block=--hangul_Jamo_extended_B}', "");
    Expect(1, 55295, '\P{^Is_Block=--hangul_Jamo_extended_B}', "");
    Expect(0, 57344, '\p{Is_Block=--hangul_Jamo_extended_B}', "");
    Expect(1, 57344, '\p{^Is_Block=--hangul_Jamo_extended_B}', "");
    Expect(1, 57344, '\P{Is_Block=--hangul_Jamo_extended_B}', "");
    Expect(0, 57344, '\P{^Is_Block=--hangul_Jamo_extended_B}', "");
    Error('\p{Is_Blk=-	jamo_ext_B:=}');
    Error('\P{Is_Blk=-	jamo_ext_B:=}');
    Expect(1, 55295, '\p{Is_Blk=jamoextb}', "");
    Expect(0, 55295, '\p{^Is_Blk=jamoextb}', "");
    Expect(0, 55295, '\P{Is_Blk=jamoextb}', "");
    Expect(1, 55295, '\P{^Is_Blk=jamoextb}', "");
    Expect(0, 57344, '\p{Is_Blk=jamoextb}', "");
    Expect(1, 57344, '\p{^Is_Blk=jamoextb}', "");
    Expect(1, 57344, '\P{Is_Blk=jamoextb}', "");
    Expect(0, 57344, '\P{^Is_Blk=jamoextb}', "");
    Expect(1, 55295, '\p{Is_Blk=Jamo_EXT_B}', "");
    Expect(0, 55295, '\p{^Is_Blk=Jamo_EXT_B}', "");
    Expect(0, 55295, '\P{Is_Blk=Jamo_EXT_B}', "");
    Expect(1, 55295, '\P{^Is_Blk=Jamo_EXT_B}', "");
    Expect(0, 57344, '\p{Is_Blk=Jamo_EXT_B}', "");
    Expect(1, 57344, '\p{^Is_Blk=Jamo_EXT_B}', "");
    Expect(1, 57344, '\P{Is_Blk=Jamo_EXT_B}', "");
    Expect(0, 57344, '\P{^Is_Blk=Jamo_EXT_B}', "");
    Error('\p{Block: :=-JAVANESE}');
    Error('\P{Block: :=-JAVANESE}');
    Expect(1, 43487, '\p{Block=:\AJavanese\z:}', "");;
    Expect(0, 43488, '\p{Block=:\AJavanese\z:}', "");;
    Expect(1, 43487, '\p{Block=javanese}', "");
    Expect(0, 43487, '\p{^Block=javanese}', "");
    Expect(0, 43487, '\P{Block=javanese}', "");
    Expect(1, 43487, '\P{^Block=javanese}', "");
    Expect(0, 43488, '\p{Block=javanese}', "");
    Expect(1, 43488, '\p{^Block=javanese}', "");
    Expect(1, 43488, '\P{Block=javanese}', "");
    Expect(0, 43488, '\P{^Block=javanese}', "");
    Expect(1, 43487, '\p{Block=:\Ajavanese\z:}', "");;
    Expect(0, 43488, '\p{Block=:\Ajavanese\z:}', "");;
    Expect(1, 43487, '\p{Block=-javanese}', "");
    Expect(0, 43487, '\p{^Block=-javanese}', "");
    Expect(0, 43487, '\P{Block=-javanese}', "");
    Expect(1, 43487, '\P{^Block=-javanese}', "");
    Expect(0, 43488, '\p{Block=-javanese}', "");
    Expect(1, 43488, '\p{^Block=-javanese}', "");
    Expect(1, 43488, '\P{Block=-javanese}', "");
    Expect(0, 43488, '\P{^Block=-javanese}', "");
    Error('\p{Blk=/a/ _javanese}');
    Error('\P{Blk=/a/ _javanese}');
    Expect(1, 43487, '\p{Blk=:\AJavanese\z:}', "");;
    Expect(0, 43488, '\p{Blk=:\AJavanese\z:}', "");;
    Expect(1, 43487, '\p{Blk=javanese}', "");
    Expect(0, 43487, '\p{^Blk=javanese}', "");
    Expect(0, 43487, '\P{Blk=javanese}', "");
    Expect(1, 43487, '\P{^Blk=javanese}', "");
    Expect(0, 43488, '\p{Blk=javanese}', "");
    Expect(1, 43488, '\p{^Blk=javanese}', "");
    Expect(1, 43488, '\P{Blk=javanese}', "");
    Expect(0, 43488, '\P{^Blk=javanese}', "");
    Expect(1, 43487, '\p{Blk=:\Ajavanese\z:}', "");;
    Expect(0, 43488, '\p{Blk=:\Ajavanese\z:}', "");;
    Expect(1, 43487, '\p{Blk=- Javanese}', "");
    Expect(0, 43487, '\p{^Blk=- Javanese}', "");
    Expect(0, 43487, '\P{Blk=- Javanese}', "");
    Expect(1, 43487, '\P{^Blk=- Javanese}', "");
    Expect(0, 43488, '\p{Blk=- Javanese}', "");
    Expect(1, 43488, '\p{^Blk=- Javanese}', "");
    Expect(1, 43488, '\P{Blk=- Javanese}', "");
    Expect(0, 43488, '\P{^Blk=- Javanese}', "");
    Error('\p{Is_Block=	:=Javanese}');
    Error('\P{Is_Block=	:=Javanese}');
    Expect(1, 43487, '\p{Is_Block=javanese}', "");
    Expect(0, 43487, '\p{^Is_Block=javanese}', "");
    Expect(0, 43487, '\P{Is_Block=javanese}', "");
    Expect(1, 43487, '\P{^Is_Block=javanese}', "");
    Expect(0, 43488, '\p{Is_Block=javanese}', "");
    Expect(1, 43488, '\p{^Is_Block=javanese}', "");
    Expect(1, 43488, '\P{Is_Block=javanese}', "");
    Expect(0, 43488, '\P{^Is_Block=javanese}', "");
    Expect(1, 43487, '\p{Is_Block: - javanese}', "");
    Expect(0, 43487, '\p{^Is_Block: - javanese}', "");
    Expect(0, 43487, '\P{Is_Block: - javanese}', "");
    Expect(1, 43487, '\P{^Is_Block: - javanese}', "");
    Expect(0, 43488, '\p{Is_Block: - javanese}', "");
    Expect(1, 43488, '\p{^Is_Block: - javanese}', "");
    Expect(1, 43488, '\P{Is_Block: - javanese}', "");
    Expect(0, 43488, '\P{^Is_Block: - javanese}', "");
    Error('\p{Is_Blk=_-javanese/a/}');
    Error('\P{Is_Blk=_-javanese/a/}');
    Expect(1, 43487, '\p{Is_Blk=javanese}', "");
    Expect(0, 43487, '\p{^Is_Blk=javanese}', "");
    Expect(0, 43487, '\P{Is_Blk=javanese}', "");
    Expect(1, 43487, '\P{^Is_Blk=javanese}', "");
    Expect(0, 43488, '\p{Is_Blk=javanese}', "");
    Expect(1, 43488, '\p{^Is_Blk=javanese}', "");
    Expect(1, 43488, '\P{Is_Blk=javanese}', "");
    Expect(0, 43488, '\P{^Is_Blk=javanese}', "");
    Expect(1, 43487, '\p{Is_Blk=Javanese}', "");
    Expect(0, 43487, '\p{^Is_Blk=Javanese}', "");
    Expect(0, 43487, '\P{Is_Blk=Javanese}', "");
    Expect(1, 43487, '\P{^Is_Blk=Javanese}', "");
    Expect(0, 43488, '\p{Is_Blk=Javanese}', "");
    Expect(1, 43488, '\p{^Is_Blk=Javanese}', "");
    Expect(1, 43488, '\P{Is_Blk=Javanese}', "");
    Expect(0, 43488, '\P{^Is_Blk=Javanese}', "");
    Error('\p{Block=_/a/Kaithi}');
    Error('\P{Block=_/a/Kaithi}');
    Expect(1, 69839, '\p{Block=:\AKaithi\z:}', "");;
    Expect(0, 69840, '\p{Block=:\AKaithi\z:}', "");;
    Expect(1, 69839, '\p{Block=kaithi}', "");
    Expect(0, 69839, '\p{^Block=kaithi}', "");
    Expect(0, 69839, '\P{Block=kaithi}', "");
    Expect(1, 69839, '\P{^Block=kaithi}', "");
    Expect(0, 69840, '\p{Block=kaithi}', "");
    Expect(1, 69840, '\p{^Block=kaithi}', "");
    Expect(1, 69840, '\P{Block=kaithi}', "");
    Expect(0, 69840, '\P{^Block=kaithi}', "");
    Expect(1, 69839, '\p{Block=:\Akaithi\z:}', "");;
    Expect(0, 69840, '\p{Block=:\Akaithi\z:}', "");;
    Expect(1, 69839, '\p{Block=	_Kaithi}', "");
    Expect(0, 69839, '\p{^Block=	_Kaithi}', "");
    Expect(0, 69839, '\P{Block=	_Kaithi}', "");
    Expect(1, 69839, '\P{^Block=	_Kaithi}', "");
    Expect(0, 69840, '\p{Block=	_Kaithi}', "");
    Expect(1, 69840, '\p{^Block=	_Kaithi}', "");
    Expect(1, 69840, '\P{Block=	_Kaithi}', "");
    Expect(0, 69840, '\P{^Block=	_Kaithi}', "");
    Error('\p{Blk: :=Kaithi}');
    Error('\P{Blk: :=Kaithi}');
    Expect(1, 69839, '\p{Blk=:\AKaithi\z:}', "");;
    Expect(0, 69840, '\p{Blk=:\AKaithi\z:}', "");;
    Expect(1, 69839, '\p{Blk=kaithi}', "");
    Expect(0, 69839, '\p{^Blk=kaithi}', "");
    Expect(0, 69839, '\P{Blk=kaithi}', "");
    Expect(1, 69839, '\P{^Blk=kaithi}', "");
    Expect(0, 69840, '\p{Blk=kaithi}', "");
    Expect(1, 69840, '\p{^Blk=kaithi}', "");
    Expect(1, 69840, '\P{Blk=kaithi}', "");
    Expect(0, 69840, '\P{^Blk=kaithi}', "");
    Expect(1, 69839, '\p{Blk=:\Akaithi\z:}', "");;
    Expect(0, 69840, '\p{Blk=:\Akaithi\z:}', "");;
    Expect(1, 69839, '\p{Blk=	-kaithi}', "");
    Expect(0, 69839, '\p{^Blk=	-kaithi}', "");
    Expect(0, 69839, '\P{Blk=	-kaithi}', "");
    Expect(1, 69839, '\P{^Blk=	-kaithi}', "");
    Expect(0, 69840, '\p{Blk=	-kaithi}', "");
    Expect(1, 69840, '\p{^Blk=	-kaithi}', "");
    Expect(1, 69840, '\P{Blk=	-kaithi}', "");
    Expect(0, 69840, '\P{^Blk=	-kaithi}', "");
    Error('\p{Is_Block=/a/-	Kaithi}');
    Error('\P{Is_Block=/a/-	Kaithi}');
    Expect(1, 69839, '\p{Is_Block=kaithi}', "");
    Expect(0, 69839, '\p{^Is_Block=kaithi}', "");
    Expect(0, 69839, '\P{Is_Block=kaithi}', "");
    Expect(1, 69839, '\P{^Is_Block=kaithi}', "");
    Expect(0, 69840, '\p{Is_Block=kaithi}', "");
    Expect(1, 69840, '\p{^Is_Block=kaithi}', "");
    Expect(1, 69840, '\P{Is_Block=kaithi}', "");
    Expect(0, 69840, '\P{^Is_Block=kaithi}', "");
    Expect(1, 69839, '\p{Is_Block=  Kaithi}', "");
    Expect(0, 69839, '\p{^Is_Block=  Kaithi}', "");
    Expect(0, 69839, '\P{Is_Block=  Kaithi}', "");
    Expect(1, 69839, '\P{^Is_Block=  Kaithi}', "");
    Expect(0, 69840, '\p{Is_Block=  Kaithi}', "");
    Expect(1, 69840, '\p{^Is_Block=  Kaithi}', "");
    Expect(1, 69840, '\P{Is_Block=  Kaithi}', "");
    Expect(0, 69840, '\P{^Is_Block=  Kaithi}', "");
    Error('\p{Is_Blk:	 _Kaithi:=}');
    Error('\P{Is_Blk:	 _Kaithi:=}');
    Expect(1, 69839, '\p{Is_Blk=kaithi}', "");
    Expect(0, 69839, '\p{^Is_Blk=kaithi}', "");
    Expect(0, 69839, '\P{Is_Blk=kaithi}', "");
    Expect(1, 69839, '\P{^Is_Blk=kaithi}', "");
    Expect(0, 69840, '\p{Is_Blk=kaithi}', "");
    Expect(1, 69840, '\p{^Is_Blk=kaithi}', "");
    Expect(1, 69840, '\P{Is_Blk=kaithi}', "");
    Expect(0, 69840, '\P{^Is_Blk=kaithi}', "");
    Expect(1, 69839, '\p{Is_Blk=  Kaithi}', "");
    Expect(0, 69839, '\p{^Is_Blk=  Kaithi}', "");
    Expect(0, 69839, '\P{Is_Blk=  Kaithi}', "");
    Expect(1, 69839, '\P{^Is_Blk=  Kaithi}', "");
    Expect(0, 69840, '\p{Is_Blk=  Kaithi}', "");
    Expect(1, 69840, '\p{^Is_Blk=  Kaithi}', "");
    Expect(1, 69840, '\P{Is_Blk=  Kaithi}', "");
    Expect(0, 69840, '\P{^Is_Blk=  Kaithi}', "");
    Error('\p{Block= /a/Kana_EXTENDED_A}');
    Error('\P{Block= /a/Kana_EXTENDED_A}');
    Expect(1, 110895, '\p{Block=:\AKana_Extended_A\z:}', "");;
    Expect(0, 110896, '\p{Block=:\AKana_Extended_A\z:}', "");;
    Expect(1, 110895, '\p{Block=kanaextendeda}', "");
    Expect(0, 110895, '\p{^Block=kanaextendeda}', "");
    Expect(0, 110895, '\P{Block=kanaextendeda}', "");
    Expect(1, 110895, '\P{^Block=kanaextendeda}', "");
    Expect(0, 110896, '\p{Block=kanaextendeda}', "");
    Expect(1, 110896, '\p{^Block=kanaextendeda}', "");
    Expect(1, 110896, '\P{Block=kanaextendeda}', "");
    Expect(0, 110896, '\P{^Block=kanaextendeda}', "");
    Expect(1, 110895, '\p{Block=:\Akanaextendeda\z:}', "");;
    Expect(0, 110896, '\p{Block=:\Akanaextendeda\z:}', "");;
    Expect(1, 110895, '\p{Block= _Kana_EXTENDED_A}', "");
    Expect(0, 110895, '\p{^Block= _Kana_EXTENDED_A}', "");
    Expect(0, 110895, '\P{Block= _Kana_EXTENDED_A}', "");
    Expect(1, 110895, '\P{^Block= _Kana_EXTENDED_A}', "");
    Expect(0, 110896, '\p{Block= _Kana_EXTENDED_A}', "");
    Expect(1, 110896, '\p{^Block= _Kana_EXTENDED_A}', "");
    Expect(1, 110896, '\P{Block= _Kana_EXTENDED_A}', "");
    Expect(0, 110896, '\P{^Block= _Kana_EXTENDED_A}', "");
    Error('\p{Blk=	/a/Kana_Ext_A}');
    Error('\P{Blk=	/a/Kana_Ext_A}');
    Expect(1, 110895, '\p{Blk=:\AKana_Ext_A\z:}', "");;
    Expect(0, 110896, '\p{Blk=:\AKana_Ext_A\z:}', "");;
    Expect(1, 110895, '\p{Blk=kanaexta}', "");
    Expect(0, 110895, '\p{^Blk=kanaexta}', "");
    Expect(0, 110895, '\P{Blk=kanaexta}', "");
    Expect(1, 110895, '\P{^Blk=kanaexta}', "");
    Expect(0, 110896, '\p{Blk=kanaexta}', "");
    Expect(1, 110896, '\p{^Blk=kanaexta}', "");
    Expect(1, 110896, '\P{Blk=kanaexta}', "");
    Expect(0, 110896, '\P{^Blk=kanaexta}', "");
    Expect(1, 110895, '\p{Blk=:\Akanaexta\z:}', "");;
    Expect(0, 110896, '\p{Blk=:\Akanaexta\z:}', "");;
    Expect(1, 110895, '\p{Blk=	Kana_Ext_A}', "");
    Expect(0, 110895, '\p{^Blk=	Kana_Ext_A}', "");
    Expect(0, 110895, '\P{Blk=	Kana_Ext_A}', "");
    Expect(1, 110895, '\P{^Blk=	Kana_Ext_A}', "");
    Expect(0, 110896, '\p{Blk=	Kana_Ext_A}', "");
    Expect(1, 110896, '\p{^Blk=	Kana_Ext_A}', "");
    Expect(1, 110896, '\P{Blk=	Kana_Ext_A}', "");
    Expect(0, 110896, '\P{^Blk=	Kana_Ext_A}', "");
    Error('\p{Is_Block=		Kana_extended_A:=}');
    Error('\P{Is_Block=		Kana_extended_A:=}');
    Expect(1, 110895, '\p{Is_Block=kanaextendeda}', "");
    Expect(0, 110895, '\p{^Is_Block=kanaextendeda}', "");
    Expect(0, 110895, '\P{Is_Block=kanaextendeda}', "");
    Expect(1, 110895, '\P{^Is_Block=kanaextendeda}', "");
    Expect(0, 110896, '\p{Is_Block=kanaextendeda}', "");
    Expect(1, 110896, '\p{^Is_Block=kanaextendeda}', "");
    Expect(1, 110896, '\P{Is_Block=kanaextendeda}', "");
    Expect(0, 110896, '\P{^Is_Block=kanaextendeda}', "");
    Expect(1, 110895, '\p{Is_Block=  Kana_Extended_A}', "");
    Expect(0, 110895, '\p{^Is_Block=  Kana_Extended_A}', "");
    Expect(0, 110895, '\P{Is_Block=  Kana_Extended_A}', "");
    Expect(1, 110895, '\P{^Is_Block=  Kana_Extended_A}', "");
    Expect(0, 110896, '\p{Is_Block=  Kana_Extended_A}', "");
    Expect(1, 110896, '\p{^Is_Block=  Kana_Extended_A}', "");
    Expect(1, 110896, '\P{Is_Block=  Kana_Extended_A}', "");
    Expect(0, 110896, '\P{^Is_Block=  Kana_Extended_A}', "");
    Error('\p{Is_Blk=:=		Kana_EXT_a}');
    Error('\P{Is_Blk=:=		Kana_EXT_a}');
    Expect(1, 110895, '\p{Is_Blk=kanaexta}', "");
    Expect(0, 110895, '\p{^Is_Blk=kanaexta}', "");
    Expect(0, 110895, '\P{Is_Blk=kanaexta}', "");
    Expect(1, 110895, '\P{^Is_Blk=kanaexta}', "");
    Expect(0, 110896, '\p{Is_Blk=kanaexta}', "");
    Expect(1, 110896, '\p{^Is_Blk=kanaexta}', "");
    Expect(1, 110896, '\P{Is_Blk=kanaexta}', "");
    Expect(0, 110896, '\P{^Is_Blk=kanaexta}', "");
    Expect(1, 110895, '\p{Is_Blk:		-Kana_ext_A}', "");
    Expect(0, 110895, '\p{^Is_Blk:		-Kana_ext_A}', "");
    Expect(0, 110895, '\P{Is_Blk:		-Kana_ext_A}', "");
    Expect(1, 110895, '\P{^Is_Blk:		-Kana_ext_A}', "");
    Expect(0, 110896, '\p{Is_Blk:		-Kana_ext_A}', "");
    Expect(1, 110896, '\p{^Is_Blk:		-Kana_ext_A}', "");
    Expect(1, 110896, '\P{Is_Blk:		-Kana_ext_A}', "");
    Expect(0, 110896, '\P{^Is_Blk:		-Kana_ext_A}', "");
    Error('\p{Block=/a/_ Kana_supplement}');
    Error('\P{Block=/a/_ Kana_supplement}');
    Expect(1, 110847, '\p{Block=:\AKana_Supplement\z:}', "");;
    Expect(0, 110848, '\p{Block=:\AKana_Supplement\z:}', "");;
    Expect(1, 110847, '\p{Block:	kanasupplement}', "");
    Expect(0, 110847, '\p{^Block:	kanasupplement}', "");
    Expect(0, 110847, '\P{Block:	kanasupplement}', "");
    Expect(1, 110847, '\P{^Block:	kanasupplement}', "");
    Expect(0, 110848, '\p{Block:	kanasupplement}', "");
    Expect(1, 110848, '\p{^Block:	kanasupplement}', "");
    Expect(1, 110848, '\P{Block:	kanasupplement}', "");
    Expect(0, 110848, '\P{^Block:	kanasupplement}', "");
    Expect(1, 110847, '\p{Block=:\Akanasupplement\z:}', "");;
    Expect(0, 110848, '\p{Block=:\Akanasupplement\z:}', "");;
    Expect(1, 110847, '\p{Block=  Kana_Supplement}', "");
    Expect(0, 110847, '\p{^Block=  Kana_Supplement}', "");
    Expect(0, 110847, '\P{Block=  Kana_Supplement}', "");
    Expect(1, 110847, '\P{^Block=  Kana_Supplement}', "");
    Expect(0, 110848, '\p{Block=  Kana_Supplement}', "");
    Expect(1, 110848, '\p{^Block=  Kana_Supplement}', "");
    Expect(1, 110848, '\P{Block=  Kana_Supplement}', "");
    Expect(0, 110848, '\P{^Block=  Kana_Supplement}', "");
    Error('\p{Blk=:=__Kana_SUP}');
    Error('\P{Blk=:=__Kana_SUP}');
    Expect(1, 110847, '\p{Blk=:\AKana_Sup\z:}', "");;
    Expect(0, 110848, '\p{Blk=:\AKana_Sup\z:}', "");;
    Expect(1, 110847, '\p{Blk=kanasup}', "");
    Expect(0, 110847, '\p{^Blk=kanasup}', "");
    Expect(0, 110847, '\P{Blk=kanasup}', "");
    Expect(1, 110847, '\P{^Blk=kanasup}', "");
    Expect(0, 110848, '\p{Blk=kanasup}', "");
    Expect(1, 110848, '\p{^Blk=kanasup}', "");
    Expect(1, 110848, '\P{Blk=kanasup}', "");
    Expect(0, 110848, '\P{^Blk=kanasup}', "");
    Expect(1, 110847, '\p{Blk=:\Akanasup\z:}', "");;
    Expect(0, 110848, '\p{Blk=:\Akanasup\z:}', "");;
    Expect(1, 110847, '\p{Blk=--Kana_SUP}', "");
    Expect(0, 110847, '\p{^Blk=--Kana_SUP}', "");
    Expect(0, 110847, '\P{Blk=--Kana_SUP}', "");
    Expect(1, 110847, '\P{^Blk=--Kana_SUP}', "");
    Expect(0, 110848, '\p{Blk=--Kana_SUP}', "");
    Expect(1, 110848, '\p{^Blk=--Kana_SUP}', "");
    Expect(1, 110848, '\P{Blk=--Kana_SUP}', "");
    Expect(0, 110848, '\P{^Blk=--Kana_SUP}', "");
    Error('\p{Is_Block=	:=Kana_supplement}');
    Error('\P{Is_Block=	:=Kana_supplement}');
    Expect(1, 110847, '\p{Is_Block=kanasupplement}', "");
    Expect(0, 110847, '\p{^Is_Block=kanasupplement}', "");
    Expect(0, 110847, '\P{Is_Block=kanasupplement}', "");
    Expect(1, 110847, '\P{^Is_Block=kanasupplement}', "");
    Expect(0, 110848, '\p{Is_Block=kanasupplement}', "");
    Expect(1, 110848, '\p{^Is_Block=kanasupplement}', "");
    Expect(1, 110848, '\P{Is_Block=kanasupplement}', "");
    Expect(0, 110848, '\P{^Is_Block=kanasupplement}', "");
    Expect(1, 110847, '\p{Is_Block=_Kana_SUPPLEMENT}', "");
    Expect(0, 110847, '\p{^Is_Block=_Kana_SUPPLEMENT}', "");
    Expect(0, 110847, '\P{Is_Block=_Kana_SUPPLEMENT}', "");
    Expect(1, 110847, '\P{^Is_Block=_Kana_SUPPLEMENT}', "");
    Expect(0, 110848, '\p{Is_Block=_Kana_SUPPLEMENT}', "");
    Expect(1, 110848, '\p{^Is_Block=_Kana_SUPPLEMENT}', "");
    Expect(1, 110848, '\P{Is_Block=_Kana_SUPPLEMENT}', "");
    Expect(0, 110848, '\P{^Is_Block=_Kana_SUPPLEMENT}', "");
    Error('\p{Is_Blk= -Kana_Sup/a/}');
    Error('\P{Is_Blk= -Kana_Sup/a/}');
    Expect(1, 110847, '\p{Is_Blk=kanasup}', "");
    Expect(0, 110847, '\p{^Is_Blk=kanasup}', "");
    Expect(0, 110847, '\P{Is_Blk=kanasup}', "");
    Expect(1, 110847, '\P{^Is_Blk=kanasup}', "");
    Expect(0, 110848, '\p{Is_Blk=kanasup}', "");
    Expect(1, 110848, '\p{^Is_Blk=kanasup}', "");
    Expect(1, 110848, '\P{Is_Blk=kanasup}', "");
    Expect(0, 110848, '\P{^Is_Blk=kanasup}', "");
    Expect(1, 110847, '\p{Is_Blk= Kana_sup}', "");
    Expect(0, 110847, '\p{^Is_Blk= Kana_sup}', "");
    Expect(0, 110847, '\P{Is_Blk= Kana_sup}', "");
    Expect(1, 110847, '\P{^Is_Blk= Kana_sup}', "");
    Expect(0, 110848, '\p{Is_Blk= Kana_sup}', "");
    Expect(1, 110848, '\p{^Is_Blk= Kana_sup}', "");
    Expect(1, 110848, '\P{Is_Blk= Kana_sup}', "");
    Expect(0, 110848, '\P{^Is_Blk= Kana_sup}', "");
    Error('\p{Block=_/a/kanbun}');
    Error('\P{Block=_/a/kanbun}');
    Expect(1, 12703, '\p{Block=:\AKanbun\z:}', "");;
    Expect(0, 12704, '\p{Block=:\AKanbun\z:}', "");;
    Expect(1, 12703, '\p{Block=kanbun}', "");
    Expect(0, 12703, '\p{^Block=kanbun}', "");
    Expect(0, 12703, '\P{Block=kanbun}', "");
    Expect(1, 12703, '\P{^Block=kanbun}', "");
    Expect(0, 12704, '\p{Block=kanbun}', "");
    Expect(1, 12704, '\p{^Block=kanbun}', "");
    Expect(1, 12704, '\P{Block=kanbun}', "");
    Expect(0, 12704, '\P{^Block=kanbun}', "");
    Expect(1, 12703, '\p{Block=:\Akanbun\z:}', "");;
    Expect(0, 12704, '\p{Block=:\Akanbun\z:}', "");;
    Expect(1, 12703, '\p{Block=_	Kanbun}', "");
    Expect(0, 12703, '\p{^Block=_	Kanbun}', "");
    Expect(0, 12703, '\P{Block=_	Kanbun}', "");
    Expect(1, 12703, '\P{^Block=_	Kanbun}', "");
    Expect(0, 12704, '\p{Block=_	Kanbun}', "");
    Expect(1, 12704, '\p{^Block=_	Kanbun}', "");
    Expect(1, 12704, '\P{Block=_	Kanbun}', "");
    Expect(0, 12704, '\P{^Block=_	Kanbun}', "");
    Error('\p{Blk=--Kanbun/a/}');
    Error('\P{Blk=--Kanbun/a/}');
    Expect(1, 12703, '\p{Blk=:\AKanbun\z:}', "");;
    Expect(0, 12704, '\p{Blk=:\AKanbun\z:}', "");;
    Expect(1, 12703, '\p{Blk:   kanbun}', "");
    Expect(0, 12703, '\p{^Blk:   kanbun}', "");
    Expect(0, 12703, '\P{Blk:   kanbun}', "");
    Expect(1, 12703, '\P{^Blk:   kanbun}', "");
    Expect(0, 12704, '\p{Blk:   kanbun}', "");
    Expect(1, 12704, '\p{^Blk:   kanbun}', "");
    Expect(1, 12704, '\P{Blk:   kanbun}', "");
    Expect(0, 12704, '\P{^Blk:   kanbun}', "");
    Expect(1, 12703, '\p{Blk=:\Akanbun\z:}', "");;
    Expect(0, 12704, '\p{Blk=:\Akanbun\z:}', "");;
    Expect(1, 12703, '\p{Blk=_-KANBUN}', "");
    Expect(0, 12703, '\p{^Blk=_-KANBUN}', "");
    Expect(0, 12703, '\P{Blk=_-KANBUN}', "");
    Expect(1, 12703, '\P{^Blk=_-KANBUN}', "");
    Expect(0, 12704, '\p{Blk=_-KANBUN}', "");
    Expect(1, 12704, '\p{^Blk=_-KANBUN}', "");
    Expect(1, 12704, '\P{Blk=_-KANBUN}', "");
    Expect(0, 12704, '\P{^Blk=_-KANBUN}', "");
    Error('\p{Is_Block: :=_	Kanbun}');
    Error('\P{Is_Block: :=_	Kanbun}');
    Expect(1, 12703, '\p{Is_Block=kanbun}', "");
    Expect(0, 12703, '\p{^Is_Block=kanbun}', "");
    Expect(0, 12703, '\P{Is_Block=kanbun}', "");
    Expect(1, 12703, '\P{^Is_Block=kanbun}', "");
    Expect(0, 12704, '\p{Is_Block=kanbun}', "");
    Expect(1, 12704, '\p{^Is_Block=kanbun}', "");
    Expect(1, 12704, '\P{Is_Block=kanbun}', "");
    Expect(0, 12704, '\P{^Is_Block=kanbun}', "");
    Expect(1, 12703, '\p{Is_Block= -KANBUN}', "");
    Expect(0, 12703, '\p{^Is_Block= -KANBUN}', "");
    Expect(0, 12703, '\P{Is_Block= -KANBUN}', "");
    Expect(1, 12703, '\P{^Is_Block= -KANBUN}', "");
    Expect(0, 12704, '\p{Is_Block= -KANBUN}', "");
    Expect(1, 12704, '\p{^Is_Block= -KANBUN}', "");
    Expect(1, 12704, '\P{Is_Block= -KANBUN}', "");
    Expect(0, 12704, '\P{^Is_Block= -KANBUN}', "");
    Error('\p{Is_Blk=:=  Kanbun}');
    Error('\P{Is_Blk=:=  Kanbun}');
    Expect(1, 12703, '\p{Is_Blk=kanbun}', "");
    Expect(0, 12703, '\p{^Is_Blk=kanbun}', "");
    Expect(0, 12703, '\P{Is_Blk=kanbun}', "");
    Expect(1, 12703, '\P{^Is_Blk=kanbun}', "");
    Expect(0, 12704, '\p{Is_Blk=kanbun}', "");
    Expect(1, 12704, '\p{^Is_Blk=kanbun}', "");
    Expect(1, 12704, '\P{Is_Blk=kanbun}', "");
    Expect(0, 12704, '\P{^Is_Blk=kanbun}', "");
    Expect(1, 12703, '\p{Is_Blk=- KANBUN}', "");
    Expect(0, 12703, '\p{^Is_Blk=- KANBUN}', "");
    Expect(0, 12703, '\P{Is_Blk=- KANBUN}', "");
    Expect(1, 12703, '\P{^Is_Blk=- KANBUN}', "");
    Expect(0, 12704, '\p{Is_Blk=- KANBUN}', "");
    Expect(1, 12704, '\p{^Is_Blk=- KANBUN}', "");
    Expect(1, 12704, '\P{Is_Blk=- KANBUN}', "");
    Expect(0, 12704, '\P{^Is_Blk=- KANBUN}', "");
    Error('\p{Block=	kangxi_RADICALS/a/}');
    Error('\P{Block=	kangxi_RADICALS/a/}');
    Expect(1, 12255, '\p{Block=:\AKangxi_Radicals\z:}', "");;
    Expect(0, 12256, '\p{Block=:\AKangxi_Radicals\z:}', "");;
    Expect(1, 12255, '\p{Block=kangxiradicals}', "");
    Expect(0, 12255, '\p{^Block=kangxiradicals}', "");
    Expect(0, 12255, '\P{Block=kangxiradicals}', "");
    Expect(1, 12255, '\P{^Block=kangxiradicals}', "");
    Expect(0, 12256, '\p{Block=kangxiradicals}', "");
    Expect(1, 12256, '\p{^Block=kangxiradicals}', "");
    Expect(1, 12256, '\P{Block=kangxiradicals}', "");
    Expect(0, 12256, '\P{^Block=kangxiradicals}', "");
    Expect(1, 12255, '\p{Block=:\Akangxiradicals\z:}', "");;
    Expect(0, 12256, '\p{Block=:\Akangxiradicals\z:}', "");;
    Expect(1, 12255, '\p{Block=		Kangxi_Radicals}', "");
    Expect(0, 12255, '\p{^Block=		Kangxi_Radicals}', "");
    Expect(0, 12255, '\P{Block=		Kangxi_Radicals}', "");
    Expect(1, 12255, '\P{^Block=		Kangxi_Radicals}', "");
    Expect(0, 12256, '\p{Block=		Kangxi_Radicals}', "");
    Expect(1, 12256, '\p{^Block=		Kangxi_Radicals}', "");
    Expect(1, 12256, '\P{Block=		Kangxi_Radicals}', "");
    Expect(0, 12256, '\P{^Block=		Kangxi_Radicals}', "");
    Error('\p{Blk=-_kangxi:=}');
    Error('\P{Blk=-_kangxi:=}');
    Expect(1, 12255, '\p{Blk=:\AKangxi\z:}', "");;
    Expect(0, 12256, '\p{Blk=:\AKangxi\z:}', "");;
    Expect(1, 12255, '\p{Blk=kangxi}', "");
    Expect(0, 12255, '\p{^Blk=kangxi}', "");
    Expect(0, 12255, '\P{Blk=kangxi}', "");
    Expect(1, 12255, '\P{^Blk=kangxi}', "");
    Expect(0, 12256, '\p{Blk=kangxi}', "");
    Expect(1, 12256, '\p{^Blk=kangxi}', "");
    Expect(1, 12256, '\P{Blk=kangxi}', "");
    Expect(0, 12256, '\P{^Blk=kangxi}', "");
    Expect(1, 12255, '\p{Blk=:\Akangxi\z:}', "");;
    Expect(0, 12256, '\p{Blk=:\Akangxi\z:}', "");;
    Expect(1, 12255, '\p{Blk= 	Kangxi}', "");
    Expect(0, 12255, '\p{^Blk= 	Kangxi}', "");
    Expect(0, 12255, '\P{Blk= 	Kangxi}', "");
    Expect(1, 12255, '\P{^Blk= 	Kangxi}', "");
    Expect(0, 12256, '\p{Blk= 	Kangxi}', "");
    Expect(1, 12256, '\p{^Blk= 	Kangxi}', "");
    Expect(1, 12256, '\P{Blk= 	Kangxi}', "");
    Expect(0, 12256, '\P{^Blk= 	Kangxi}', "");
    Error('\p{Is_Block=/a/	_KANGXI_Radicals}');
    Error('\P{Is_Block=/a/	_KANGXI_Radicals}');
    Expect(1, 12255, '\p{Is_Block=kangxiradicals}', "");
    Expect(0, 12255, '\p{^Is_Block=kangxiradicals}', "");
    Expect(0, 12255, '\P{Is_Block=kangxiradicals}', "");
    Expect(1, 12255, '\P{^Is_Block=kangxiradicals}', "");
    Expect(0, 12256, '\p{Is_Block=kangxiradicals}', "");
    Expect(1, 12256, '\p{^Is_Block=kangxiradicals}', "");
    Expect(1, 12256, '\P{Is_Block=kangxiradicals}', "");
    Expect(0, 12256, '\P{^Is_Block=kangxiradicals}', "");
    Expect(1, 12255, '\p{Is_Block= kangxi_Radicals}', "");
    Expect(0, 12255, '\p{^Is_Block= kangxi_Radicals}', "");
    Expect(0, 12255, '\P{Is_Block= kangxi_Radicals}', "");
    Expect(1, 12255, '\P{^Is_Block= kangxi_Radicals}', "");
    Expect(0, 12256, '\p{Is_Block= kangxi_Radicals}', "");
    Expect(1, 12256, '\p{^Is_Block= kangxi_Radicals}', "");
    Expect(1, 12256, '\P{Is_Block= kangxi_Radicals}', "");
    Expect(0, 12256, '\P{^Is_Block= kangxi_Radicals}', "");
    Error('\p{Is_Blk= kangxi:=}');
    Error('\P{Is_Blk= kangxi:=}');
    Expect(1, 12255, '\p{Is_Blk=kangxi}', "");
    Expect(0, 12255, '\p{^Is_Blk=kangxi}', "");
    Expect(0, 12255, '\P{Is_Blk=kangxi}', "");
    Expect(1, 12255, '\P{^Is_Blk=kangxi}', "");
    Expect(0, 12256, '\p{Is_Blk=kangxi}', "");
    Expect(1, 12256, '\p{^Is_Blk=kangxi}', "");
    Expect(1, 12256, '\P{Is_Blk=kangxi}', "");
    Expect(0, 12256, '\P{^Is_Blk=kangxi}', "");
    Expect(1, 12255, '\p{Is_Blk=-Kangxi}', "");
    Expect(0, 12255, '\p{^Is_Blk=-Kangxi}', "");
    Expect(0, 12255, '\P{Is_Blk=-Kangxi}', "");
    Expect(1, 12255, '\P{^Is_Blk=-Kangxi}', "");
    Expect(0, 12256, '\p{Is_Blk=-Kangxi}', "");
    Expect(1, 12256, '\p{^Is_Blk=-Kangxi}', "");
    Expect(1, 12256, '\P{Is_Blk=-Kangxi}', "");
    Expect(0, 12256, '\P{^Is_Blk=-Kangxi}', "");
    Error('\p{Block=/a/Kannada}');
    Error('\P{Block=/a/Kannada}');
    Expect(1, 3327, '\p{Block=:\AKannada\z:}', "");;
    Expect(0, 3328, '\p{Block=:\AKannada\z:}', "");;
    Expect(1, 3327, '\p{Block=kannada}', "");
    Expect(0, 3327, '\p{^Block=kannada}', "");
    Expect(0, 3327, '\P{Block=kannada}', "");
    Expect(1, 3327, '\P{^Block=kannada}', "");
    Expect(0, 3328, '\p{Block=kannada}', "");
    Expect(1, 3328, '\p{^Block=kannada}', "");
    Expect(1, 3328, '\P{Block=kannada}', "");
    Expect(0, 3328, '\P{^Block=kannada}', "");
    Expect(1, 3327, '\p{Block=:\Akannada\z:}', "");;
    Expect(0, 3328, '\p{Block=:\Akannada\z:}', "");;
    Expect(1, 3327, '\p{Block:		kannada}', "");
    Expect(0, 3327, '\p{^Block:		kannada}', "");
    Expect(0, 3327, '\P{Block:		kannada}', "");
    Expect(1, 3327, '\P{^Block:		kannada}', "");
    Expect(0, 3328, '\p{Block:		kannada}', "");
    Expect(1, 3328, '\p{^Block:		kannada}', "");
    Expect(1, 3328, '\P{Block:		kannada}', "");
    Expect(0, 3328, '\P{^Block:		kannada}', "");
    Error('\p{Blk=-:=Kannada}');
    Error('\P{Blk=-:=Kannada}');
    Expect(1, 3327, '\p{Blk=:\AKannada\z:}', "");;
    Expect(0, 3328, '\p{Blk=:\AKannada\z:}', "");;
    Expect(1, 3327, '\p{Blk=kannada}', "");
    Expect(0, 3327, '\p{^Blk=kannada}', "");
    Expect(0, 3327, '\P{Blk=kannada}', "");
    Expect(1, 3327, '\P{^Blk=kannada}', "");
    Expect(0, 3328, '\p{Blk=kannada}', "");
    Expect(1, 3328, '\p{^Blk=kannada}', "");
    Expect(1, 3328, '\P{Blk=kannada}', "");
    Expect(0, 3328, '\P{^Blk=kannada}', "");
    Expect(1, 3327, '\p{Blk=:\Akannada\z:}', "");;
    Expect(0, 3328, '\p{Blk=:\Akannada\z:}', "");;
    Expect(1, 3327, '\p{Blk=_ Kannada}', "");
    Expect(0, 3327, '\p{^Blk=_ Kannada}', "");
    Expect(0, 3327, '\P{Blk=_ Kannada}', "");
    Expect(1, 3327, '\P{^Blk=_ Kannada}', "");
    Expect(0, 3328, '\p{Blk=_ Kannada}', "");
    Expect(1, 3328, '\p{^Blk=_ Kannada}', "");
    Expect(1, 3328, '\P{Blk=_ Kannada}', "");
    Expect(0, 3328, '\P{^Blk=_ Kannada}', "");
    Error('\p{Is_Block=/a/ _Kannada}');
    Error('\P{Is_Block=/a/ _Kannada}');
    Expect(1, 3327, '\p{Is_Block:   kannada}', "");
    Expect(0, 3327, '\p{^Is_Block:   kannada}', "");
    Expect(0, 3327, '\P{Is_Block:   kannada}', "");
    Expect(1, 3327, '\P{^Is_Block:   kannada}', "");
    Expect(0, 3328, '\p{Is_Block:   kannada}', "");
    Expect(1, 3328, '\p{^Is_Block:   kannada}', "");
    Expect(1, 3328, '\P{Is_Block:   kannada}', "");
    Expect(0, 3328, '\P{^Is_Block:   kannada}', "");
    Expect(1, 3327, '\p{Is_Block=-KANNADA}', "");
    Expect(0, 3327, '\p{^Is_Block=-KANNADA}', "");
    Expect(0, 3327, '\P{Is_Block=-KANNADA}', "");
    Expect(1, 3327, '\P{^Is_Block=-KANNADA}', "");
    Expect(0, 3328, '\p{Is_Block=-KANNADA}', "");
    Expect(1, 3328, '\p{^Is_Block=-KANNADA}', "");
    Expect(1, 3328, '\P{Is_Block=-KANNADA}', "");
    Expect(0, 3328, '\P{^Is_Block=-KANNADA}', "");
    Error('\p{Is_Blk=-:=Kannada}');
    Error('\P{Is_Blk=-:=Kannada}');
    Expect(1, 3327, '\p{Is_Blk=kannada}', "");
    Expect(0, 3327, '\p{^Is_Blk=kannada}', "");
    Expect(0, 3327, '\P{Is_Blk=kannada}', "");
    Expect(1, 3327, '\P{^Is_Blk=kannada}', "");
    Expect(0, 3328, '\p{Is_Blk=kannada}', "");
    Expect(1, 3328, '\p{^Is_Blk=kannada}', "");
    Expect(1, 3328, '\P{Is_Blk=kannada}', "");
    Expect(0, 3328, '\P{^Is_Blk=kannada}', "");
    Expect(1, 3327, '\p{Is_Blk:	 _Kannada}', "");
    Expect(0, 3327, '\p{^Is_Blk:	 _Kannada}', "");
    Expect(0, 3327, '\P{Is_Blk:	 _Kannada}', "");
    Expect(1, 3327, '\P{^Is_Blk:	 _Kannada}', "");
    Expect(0, 3328, '\p{Is_Blk:	 _Kannada}', "");
    Expect(1, 3328, '\p{^Is_Blk:	 _Kannada}', "");
    Expect(1, 3328, '\P{Is_Blk:	 _Kannada}', "");
    Expect(0, 3328, '\P{^Is_Blk:	 _Kannada}', "");
    Error('\p{Block=:= katakana}');
    Error('\P{Block=:= katakana}');
    Expect(1, 12543, '\p{Block=:\AKatakana\z:}', "");;
    Expect(0, 12544, '\p{Block=:\AKatakana\z:}', "");;
    Expect(1, 12543, '\p{Block=katakana}', "");
    Expect(0, 12543, '\p{^Block=katakana}', "");
    Expect(0, 12543, '\P{Block=katakana}', "");
    Expect(1, 12543, '\P{^Block=katakana}', "");
    Expect(0, 12544, '\p{Block=katakana}', "");
    Expect(1, 12544, '\p{^Block=katakana}', "");
    Expect(1, 12544, '\P{Block=katakana}', "");
    Expect(0, 12544, '\P{^Block=katakana}', "");
    Expect(1, 12543, '\p{Block=:\Akatakana\z:}', "");;
    Expect(0, 12544, '\p{Block=:\Akatakana\z:}', "");;
    Error('\p{Blk=	/a/KATAKANA}');
    Error('\P{Blk=	/a/KATAKANA}');
    Expect(1, 12543, '\p{Blk=:\AKatakana\z:}', "");;
    Expect(0, 12544, '\p{Blk=:\AKatakana\z:}', "");;
    Expect(1, 12543, '\p{Blk=katakana}', "");
    Expect(0, 12543, '\p{^Blk=katakana}', "");
    Expect(0, 12543, '\P{Blk=katakana}', "");
    Expect(1, 12543, '\P{^Blk=katakana}', "");
    Expect(0, 12544, '\p{Blk=katakana}', "");
    Expect(1, 12544, '\p{^Blk=katakana}', "");
    Expect(1, 12544, '\P{Blk=katakana}', "");
    Expect(0, 12544, '\P{^Blk=katakana}', "");
    Expect(1, 12543, '\p{Blk=:\Akatakana\z:}', "");;
    Expect(0, 12544, '\p{Blk=:\Akatakana\z:}', "");;
    Expect(1, 12543, '\p{Blk:   katakana}', "");
    Expect(0, 12543, '\p{^Blk:   katakana}', "");
    Expect(0, 12543, '\P{Blk:   katakana}', "");
    Expect(1, 12543, '\P{^Blk:   katakana}', "");
    Expect(0, 12544, '\p{Blk:   katakana}', "");
    Expect(1, 12544, '\p{^Blk:   katakana}', "");
    Expect(1, 12544, '\P{Blk:   katakana}', "");
    Expect(0, 12544, '\P{^Blk:   katakana}', "");
    Error('\p{Is_Block=:=	_katakana}');
    Error('\P{Is_Block=:=	_katakana}');
    Expect(1, 12543, '\p{Is_Block=katakana}', "");
    Expect(0, 12543, '\p{^Is_Block=katakana}', "");
    Expect(0, 12543, '\P{Is_Block=katakana}', "");
    Expect(1, 12543, '\P{^Is_Block=katakana}', "");
    Expect(0, 12544, '\p{Is_Block=katakana}', "");
    Expect(1, 12544, '\p{^Is_Block=katakana}', "");
    Expect(1, 12544, '\P{Is_Block=katakana}', "");
    Expect(0, 12544, '\P{^Is_Block=katakana}', "");
    Expect(1, 12543, '\p{Is_Block= Katakana}', "");
    Expect(0, 12543, '\p{^Is_Block= Katakana}', "");
    Expect(0, 12543, '\P{Is_Block= Katakana}', "");
    Expect(1, 12543, '\P{^Is_Block= Katakana}', "");
    Expect(0, 12544, '\p{Is_Block= Katakana}', "");
    Expect(1, 12544, '\p{^Is_Block= Katakana}', "");
    Expect(1, 12544, '\P{Is_Block= Katakana}', "");
    Expect(0, 12544, '\P{^Is_Block= Katakana}', "");
    Error('\p{Is_Blk=_/a/Katakana}');
    Error('\P{Is_Blk=_/a/Katakana}');
    Expect(1, 12543, '\p{Is_Blk: katakana}', "");
    Expect(0, 12543, '\p{^Is_Blk: katakana}', "");
    Expect(0, 12543, '\P{Is_Blk: katakana}', "");
    Expect(1, 12543, '\P{^Is_Blk: katakana}', "");
    Expect(0, 12544, '\p{Is_Blk: katakana}', "");
    Expect(1, 12544, '\p{^Is_Blk: katakana}', "");
    Expect(1, 12544, '\P{Is_Blk: katakana}', "");
    Expect(0, 12544, '\P{^Is_Blk: katakana}', "");
    Expect(1, 12543, '\p{Is_Blk=	 KATAKANA}', "");
    Expect(0, 12543, '\p{^Is_Blk=	 KATAKANA}', "");
    Expect(0, 12543, '\P{Is_Blk=	 KATAKANA}', "");
    Expect(1, 12543, '\P{^Is_Blk=	 KATAKANA}', "");
    Expect(0, 12544, '\p{Is_Blk=	 KATAKANA}', "");
    Expect(1, 12544, '\p{^Is_Blk=	 KATAKANA}', "");
    Expect(1, 12544, '\P{Is_Blk=	 KATAKANA}', "");
    Expect(0, 12544, '\P{^Is_Blk=	 KATAKANA}', "");
    Error('\p{Block=_:=katakana_Phonetic_EXTENSIONS}');
    Error('\P{Block=_:=katakana_Phonetic_EXTENSIONS}');
    Expect(1, 12799, '\p{Block=:\AKatakana_Phonetic_Extensions\z:}', "");;
    Expect(0, 12800, '\p{Block=:\AKatakana_Phonetic_Extensions\z:}', "");;
    Expect(1, 12799, '\p{Block=katakanaphoneticextensions}', "");
    Expect(0, 12799, '\p{^Block=katakanaphoneticextensions}', "");
    Expect(0, 12799, '\P{Block=katakanaphoneticextensions}', "");
    Expect(1, 12799, '\P{^Block=katakanaphoneticextensions}', "");
    Expect(0, 12800, '\p{Block=katakanaphoneticextensions}', "");
    Expect(1, 12800, '\p{^Block=katakanaphoneticextensions}', "");
    Expect(1, 12800, '\P{Block=katakanaphoneticextensions}', "");
    Expect(0, 12800, '\P{^Block=katakanaphoneticextensions}', "");
    Expect(1, 12799, '\p{Block=:\Akatakanaphoneticextensions\z:}', "");;
    Expect(0, 12800, '\p{Block=:\Akatakanaphoneticextensions\z:}', "");;
    Expect(1, 12799, '\p{Block=_	KATAKANA_Phonetic_extensions}', "");
    Expect(0, 12799, '\p{^Block=_	KATAKANA_Phonetic_extensions}', "");
    Expect(0, 12799, '\P{Block=_	KATAKANA_Phonetic_extensions}', "");
    Expect(1, 12799, '\P{^Block=_	KATAKANA_Phonetic_extensions}', "");
    Expect(0, 12800, '\p{Block=_	KATAKANA_Phonetic_extensions}', "");
    Expect(1, 12800, '\p{^Block=_	KATAKANA_Phonetic_extensions}', "");
    Expect(1, 12800, '\P{Block=_	KATAKANA_Phonetic_extensions}', "");
    Expect(0, 12800, '\P{^Block=_	KATAKANA_Phonetic_extensions}', "");
    Error('\p{Blk=_-katakana_EXT/a/}');
    Error('\P{Blk=_-katakana_EXT/a/}');
    Expect(1, 12799, '\p{Blk=:\AKatakana_Ext\z:}', "");;
    Expect(0, 12800, '\p{Blk=:\AKatakana_Ext\z:}', "");;
    Expect(1, 12799, '\p{Blk=katakanaext}', "");
    Expect(0, 12799, '\p{^Blk=katakanaext}', "");
    Expect(0, 12799, '\P{Blk=katakanaext}', "");
    Expect(1, 12799, '\P{^Blk=katakanaext}', "");
    Expect(0, 12800, '\p{Blk=katakanaext}', "");
    Expect(1, 12800, '\p{^Blk=katakanaext}', "");
    Expect(1, 12800, '\P{Blk=katakanaext}', "");
    Expect(0, 12800, '\P{^Blk=katakanaext}', "");
    Expect(1, 12799, '\p{Blk=:\Akatakanaext\z:}', "");;
    Expect(0, 12800, '\p{Blk=:\Akatakanaext\z:}', "");;
    Expect(1, 12799, '\p{Blk=	Katakana_Ext}', "");
    Expect(0, 12799, '\p{^Blk=	Katakana_Ext}', "");
    Expect(0, 12799, '\P{Blk=	Katakana_Ext}', "");
    Expect(1, 12799, '\P{^Blk=	Katakana_Ext}', "");
    Expect(0, 12800, '\p{Blk=	Katakana_Ext}', "");
    Expect(1, 12800, '\p{^Blk=	Katakana_Ext}', "");
    Expect(1, 12800, '\P{Blk=	Katakana_Ext}', "");
    Expect(0, 12800, '\P{^Blk=	Katakana_Ext}', "");
    Error('\p{Is_Block=:=-	Katakana_PHONETIC_extensions}');
    Error('\P{Is_Block=:=-	Katakana_PHONETIC_extensions}');
    Expect(1, 12799, '\p{Is_Block=katakanaphoneticextensions}', "");
    Expect(0, 12799, '\p{^Is_Block=katakanaphoneticextensions}', "");
    Expect(0, 12799, '\P{Is_Block=katakanaphoneticextensions}', "");
    Expect(1, 12799, '\P{^Is_Block=katakanaphoneticextensions}', "");
    Expect(0, 12800, '\p{Is_Block=katakanaphoneticextensions}', "");
    Expect(1, 12800, '\p{^Is_Block=katakanaphoneticextensions}', "");
    Expect(1, 12800, '\P{Is_Block=katakanaphoneticextensions}', "");
    Expect(0, 12800, '\P{^Is_Block=katakanaphoneticextensions}', "");
    Expect(1, 12799, '\p{Is_Block=__KATAKANA_PHONETIC_Extensions}', "");
    Expect(0, 12799, '\p{^Is_Block=__KATAKANA_PHONETIC_Extensions}', "");
    Expect(0, 12799, '\P{Is_Block=__KATAKANA_PHONETIC_Extensions}', "");
    Expect(1, 12799, '\P{^Is_Block=__KATAKANA_PHONETIC_Extensions}', "");
    Expect(0, 12800, '\p{Is_Block=__KATAKANA_PHONETIC_Extensions}', "");
    Expect(1, 12800, '\p{^Is_Block=__KATAKANA_PHONETIC_Extensions}', "");
    Expect(1, 12800, '\P{Is_Block=__KATAKANA_PHONETIC_Extensions}', "");
    Expect(0, 12800, '\P{^Is_Block=__KATAKANA_PHONETIC_Extensions}', "");
    Error('\p{Is_Blk=-	KATAKANA_Ext/a/}');
    Error('\P{Is_Blk=-	KATAKANA_Ext/a/}');
    Expect(1, 12799, '\p{Is_Blk=katakanaext}', "");
    Expect(0, 12799, '\p{^Is_Blk=katakanaext}', "");
    Expect(0, 12799, '\P{Is_Blk=katakanaext}', "");
    Expect(1, 12799, '\P{^Is_Blk=katakanaext}', "");
    Expect(0, 12800, '\p{Is_Blk=katakanaext}', "");
    Expect(1, 12800, '\p{^Is_Blk=katakanaext}', "");
    Expect(1, 12800, '\P{Is_Blk=katakanaext}', "");
    Expect(0, 12800, '\P{^Is_Blk=katakanaext}', "");
    Expect(1, 12799, '\p{Is_Blk=	-KATAKANA_EXT}', "");
    Expect(0, 12799, '\p{^Is_Blk=	-KATAKANA_EXT}', "");
    Expect(0, 12799, '\P{Is_Blk=	-KATAKANA_EXT}', "");
    Expect(1, 12799, '\P{^Is_Blk=	-KATAKANA_EXT}', "");
    Expect(0, 12800, '\p{Is_Blk=	-KATAKANA_EXT}', "");
    Expect(1, 12800, '\p{^Is_Blk=	-KATAKANA_EXT}', "");
    Expect(1, 12800, '\P{Is_Blk=	-KATAKANA_EXT}', "");
    Expect(0, 12800, '\P{^Is_Blk=	-KATAKANA_EXT}', "");
    Error('\p{Block=		KAYAH_li/a/}');
    Error('\P{Block=		KAYAH_li/a/}');
    Expect(1, 43311, '\p{Block=:\AKayah_Li\z:}', "");;
    Expect(0, 43312, '\p{Block=:\AKayah_Li\z:}', "");;
    Expect(1, 43311, '\p{Block=kayahli}', "");
    Expect(0, 43311, '\p{^Block=kayahli}', "");
    Expect(0, 43311, '\P{Block=kayahli}', "");
    Expect(1, 43311, '\P{^Block=kayahli}', "");
    Expect(0, 43312, '\p{Block=kayahli}', "");
    Expect(1, 43312, '\p{^Block=kayahli}', "");
    Expect(1, 43312, '\P{Block=kayahli}', "");
    Expect(0, 43312, '\P{^Block=kayahli}', "");
    Expect(1, 43311, '\p{Block=:\Akayahli\z:}', "");;
    Expect(0, 43312, '\p{Block=:\Akayahli\z:}', "");;
    Expect(1, 43311, '\p{Block=_ Kayah_Li}', "");
    Expect(0, 43311, '\p{^Block=_ Kayah_Li}', "");
    Expect(0, 43311, '\P{Block=_ Kayah_Li}', "");
    Expect(1, 43311, '\P{^Block=_ Kayah_Li}', "");
    Expect(0, 43312, '\p{Block=_ Kayah_Li}', "");
    Expect(1, 43312, '\p{^Block=_ Kayah_Li}', "");
    Expect(1, 43312, '\P{Block=_ Kayah_Li}', "");
    Expect(0, 43312, '\P{^Block=_ Kayah_Li}', "");
    Error('\p{Blk=/a/	_KAYAH_Li}');
    Error('\P{Blk=/a/	_KAYAH_Li}');
    Expect(1, 43311, '\p{Blk=:\AKayah_Li\z:}', "");;
    Expect(0, 43312, '\p{Blk=:\AKayah_Li\z:}', "");;
    Expect(1, 43311, '\p{Blk=kayahli}', "");
    Expect(0, 43311, '\p{^Blk=kayahli}', "");
    Expect(0, 43311, '\P{Blk=kayahli}', "");
    Expect(1, 43311, '\P{^Blk=kayahli}', "");
    Expect(0, 43312, '\p{Blk=kayahli}', "");
    Expect(1, 43312, '\p{^Blk=kayahli}', "");
    Expect(1, 43312, '\P{Blk=kayahli}', "");
    Expect(0, 43312, '\P{^Blk=kayahli}', "");
    Expect(1, 43311, '\p{Blk=:\Akayahli\z:}', "");;
    Expect(0, 43312, '\p{Blk=:\Akayahli\z:}', "");;
    Expect(1, 43311, '\p{Blk=- KAYAH_li}', "");
    Expect(0, 43311, '\p{^Blk=- KAYAH_li}', "");
    Expect(0, 43311, '\P{Blk=- KAYAH_li}', "");
    Expect(1, 43311, '\P{^Blk=- KAYAH_li}', "");
    Expect(0, 43312, '\p{Blk=- KAYAH_li}', "");
    Expect(1, 43312, '\p{^Blk=- KAYAH_li}', "");
    Expect(1, 43312, '\P{Blk=- KAYAH_li}', "");
    Expect(0, 43312, '\P{^Blk=- KAYAH_li}', "");
    Error('\p{Is_Block:	/a/Kayah_Li}');
    Error('\P{Is_Block:	/a/Kayah_Li}');
    Expect(1, 43311, '\p{Is_Block=kayahli}', "");
    Expect(0, 43311, '\p{^Is_Block=kayahli}', "");
    Expect(0, 43311, '\P{Is_Block=kayahli}', "");
    Expect(1, 43311, '\P{^Is_Block=kayahli}', "");
    Expect(0, 43312, '\p{Is_Block=kayahli}', "");
    Expect(1, 43312, '\p{^Is_Block=kayahli}', "");
    Expect(1, 43312, '\P{Is_Block=kayahli}', "");
    Expect(0, 43312, '\P{^Is_Block=kayahli}', "");
    Expect(1, 43311, '\p{Is_Block=_ kayah_li}', "");
    Expect(0, 43311, '\p{^Is_Block=_ kayah_li}', "");
    Expect(0, 43311, '\P{Is_Block=_ kayah_li}', "");
    Expect(1, 43311, '\P{^Is_Block=_ kayah_li}', "");
    Expect(0, 43312, '\p{Is_Block=_ kayah_li}', "");
    Expect(1, 43312, '\p{^Is_Block=_ kayah_li}', "");
    Expect(1, 43312, '\P{Is_Block=_ kayah_li}', "");
    Expect(0, 43312, '\P{^Is_Block=_ kayah_li}', "");
    Error('\p{Is_Blk=_/a/Kayah_LI}');
    Error('\P{Is_Blk=_/a/Kayah_LI}');
    Expect(1, 43311, '\p{Is_Blk=kayahli}', "");
    Expect(0, 43311, '\p{^Is_Blk=kayahli}', "");
    Expect(0, 43311, '\P{Is_Blk=kayahli}', "");
    Expect(1, 43311, '\P{^Is_Blk=kayahli}', "");
    Expect(0, 43312, '\p{Is_Blk=kayahli}', "");
    Expect(1, 43312, '\p{^Is_Blk=kayahli}', "");
    Expect(1, 43312, '\P{Is_Blk=kayahli}', "");
    Expect(0, 43312, '\P{^Is_Blk=kayahli}', "");
    Expect(1, 43311, '\p{Is_Blk=	 Kayah_LI}', "");
    Expect(0, 43311, '\p{^Is_Blk=	 Kayah_LI}', "");
    Expect(0, 43311, '\P{Is_Blk=	 Kayah_LI}', "");
    Expect(1, 43311, '\P{^Is_Blk=	 Kayah_LI}', "");
    Expect(0, 43312, '\p{Is_Blk=	 Kayah_LI}', "");
    Expect(1, 43312, '\p{^Is_Blk=	 Kayah_LI}', "");
    Expect(1, 43312, '\P{Is_Blk=	 Kayah_LI}', "");
    Expect(0, 43312, '\P{^Is_Blk=	 Kayah_LI}', "");
    Error('\p{Block=/a/--kharoshthi}');
    Error('\P{Block=/a/--kharoshthi}');
    Expect(1, 68191, '\p{Block=:\AKharoshthi\z:}', "");;
    Expect(0, 68192, '\p{Block=:\AKharoshthi\z:}', "");;
    Expect(1, 68191, '\p{Block=kharoshthi}', "");
    Expect(0, 68191, '\p{^Block=kharoshthi}', "");
    Expect(0, 68191, '\P{Block=kharoshthi}', "");
    Expect(1, 68191, '\P{^Block=kharoshthi}', "");
    Expect(0, 68192, '\p{Block=kharoshthi}', "");
    Expect(1, 68192, '\p{^Block=kharoshthi}', "");
    Expect(1, 68192, '\P{Block=kharoshthi}', "");
    Expect(0, 68192, '\P{^Block=kharoshthi}', "");
    Expect(1, 68191, '\p{Block=:\Akharoshthi\z:}', "");;
    Expect(0, 68192, '\p{Block=:\Akharoshthi\z:}', "");;
    Expect(1, 68191, '\p{Block=__Kharoshthi}', "");
    Expect(0, 68191, '\p{^Block=__Kharoshthi}', "");
    Expect(0, 68191, '\P{Block=__Kharoshthi}', "");
    Expect(1, 68191, '\P{^Block=__Kharoshthi}', "");
    Expect(0, 68192, '\p{Block=__Kharoshthi}', "");
    Expect(1, 68192, '\p{^Block=__Kharoshthi}', "");
    Expect(1, 68192, '\P{Block=__Kharoshthi}', "");
    Expect(0, 68192, '\P{^Block=__Kharoshthi}', "");
    Error('\p{Blk=/a/-KHAROSHTHI}');
    Error('\P{Blk=/a/-KHAROSHTHI}');
    Expect(1, 68191, '\p{Blk=:\AKharoshthi\z:}', "");;
    Expect(0, 68192, '\p{Blk=:\AKharoshthi\z:}', "");;
    Expect(1, 68191, '\p{Blk:	kharoshthi}', "");
    Expect(0, 68191, '\p{^Blk:	kharoshthi}', "");
    Expect(0, 68191, '\P{Blk:	kharoshthi}', "");
    Expect(1, 68191, '\P{^Blk:	kharoshthi}', "");
    Expect(0, 68192, '\p{Blk:	kharoshthi}', "");
    Expect(1, 68192, '\p{^Blk:	kharoshthi}', "");
    Expect(1, 68192, '\P{Blk:	kharoshthi}', "");
    Expect(0, 68192, '\P{^Blk:	kharoshthi}', "");
    Expect(1, 68191, '\p{Blk=:\Akharoshthi\z:}', "");;
    Expect(0, 68192, '\p{Blk=:\Akharoshthi\z:}', "");;
    Expect(1, 68191, '\p{Blk:   --Kharoshthi}', "");
    Expect(0, 68191, '\p{^Blk:   --Kharoshthi}', "");
    Expect(0, 68191, '\P{Blk:   --Kharoshthi}', "");
    Expect(1, 68191, '\P{^Blk:   --Kharoshthi}', "");
    Expect(0, 68192, '\p{Blk:   --Kharoshthi}', "");
    Expect(1, 68192, '\p{^Blk:   --Kharoshthi}', "");
    Expect(1, 68192, '\P{Blk:   --Kharoshthi}', "");
    Expect(0, 68192, '\P{^Blk:   --Kharoshthi}', "");
    Error('\p{Is_Block=_	kharoshthi:=}');
    Error('\P{Is_Block=_	kharoshthi:=}');
    Expect(1, 68191, '\p{Is_Block:kharoshthi}', "");
    Expect(0, 68191, '\p{^Is_Block:kharoshthi}', "");
    Expect(0, 68191, '\P{Is_Block:kharoshthi}', "");
    Expect(1, 68191, '\P{^Is_Block:kharoshthi}', "");
    Expect(0, 68192, '\p{Is_Block:kharoshthi}', "");
    Expect(1, 68192, '\p{^Is_Block:kharoshthi}', "");
    Expect(1, 68192, '\P{Is_Block:kharoshthi}', "");
    Expect(0, 68192, '\P{^Is_Block:kharoshthi}', "");
    Expect(1, 68191, '\p{Is_Block=	 KHAROSHTHI}', "");
    Expect(0, 68191, '\p{^Is_Block=	 KHAROSHTHI}', "");
    Expect(0, 68191, '\P{Is_Block=	 KHAROSHTHI}', "");
    Expect(1, 68191, '\P{^Is_Block=	 KHAROSHTHI}', "");
    Expect(0, 68192, '\p{Is_Block=	 KHAROSHTHI}', "");
    Expect(1, 68192, '\p{^Is_Block=	 KHAROSHTHI}', "");
    Expect(1, 68192, '\P{Is_Block=	 KHAROSHTHI}', "");
    Expect(0, 68192, '\P{^Is_Block=	 KHAROSHTHI}', "");
    Error('\p{Is_Blk=:=-	Kharoshthi}');
    Error('\P{Is_Blk=:=-	Kharoshthi}');
    Expect(1, 68191, '\p{Is_Blk=kharoshthi}', "");
    Expect(0, 68191, '\p{^Is_Blk=kharoshthi}', "");
    Expect(0, 68191, '\P{Is_Blk=kharoshthi}', "");
    Expect(1, 68191, '\P{^Is_Blk=kharoshthi}', "");
    Expect(0, 68192, '\p{Is_Blk=kharoshthi}', "");
    Expect(1, 68192, '\p{^Is_Blk=kharoshthi}', "");
    Expect(1, 68192, '\P{Is_Blk=kharoshthi}', "");
    Expect(0, 68192, '\P{^Is_Blk=kharoshthi}', "");
    Expect(1, 68191, '\p{Is_Blk:__Kharoshthi}', "");
    Expect(0, 68191, '\p{^Is_Blk:__Kharoshthi}', "");
    Expect(0, 68191, '\P{Is_Blk:__Kharoshthi}', "");
    Expect(1, 68191, '\P{^Is_Blk:__Kharoshthi}', "");
    Expect(0, 68192, '\p{Is_Blk:__Kharoshthi}', "");
    Expect(1, 68192, '\p{^Is_Blk:__Kharoshthi}', "");
    Expect(1, 68192, '\P{Is_Blk:__Kharoshthi}', "");
    Expect(0, 68192, '\P{^Is_Blk:__Kharoshthi}', "");
    Error('\p{Block=	-khitan_SMALL_Script/a/}');
    Error('\P{Block=	-khitan_SMALL_Script/a/}');
    Expect(1, 101631, '\p{Block=:\AKhitan_Small_Script\z:}', "");;
    Expect(0, 101632, '\p{Block=:\AKhitan_Small_Script\z:}', "");;
    Expect(1, 101631, '\p{Block=khitansmallscript}', "");
    Expect(0, 101631, '\p{^Block=khitansmallscript}', "");
    Expect(0, 101631, '\P{Block=khitansmallscript}', "");
    Expect(1, 101631, '\P{^Block=khitansmallscript}', "");
    Expect(0, 101632, '\p{Block=khitansmallscript}', "");
    Expect(1, 101632, '\p{^Block=khitansmallscript}', "");
    Expect(1, 101632, '\P{Block=khitansmallscript}', "");
    Expect(0, 101632, '\P{^Block=khitansmallscript}', "");
    Expect(1, 101631, '\p{Block=:\Akhitansmallscript\z:}', "");;
    Expect(0, 101632, '\p{Block=:\Akhitansmallscript\z:}', "");;
    Expect(1, 101631, '\p{Block=_	Khitan_Small_SCRIPT}', "");
    Expect(0, 101631, '\p{^Block=_	Khitan_Small_SCRIPT}', "");
    Expect(0, 101631, '\P{Block=_	Khitan_Small_SCRIPT}', "");
    Expect(1, 101631, '\P{^Block=_	Khitan_Small_SCRIPT}', "");
    Expect(0, 101632, '\p{Block=_	Khitan_Small_SCRIPT}', "");
    Expect(1, 101632, '\p{^Block=_	Khitan_Small_SCRIPT}', "");
    Expect(1, 101632, '\P{Block=_	Khitan_Small_SCRIPT}', "");
    Expect(0, 101632, '\P{^Block=_	Khitan_Small_SCRIPT}', "");
    Error('\p{Blk=_KHITAN_Small_Script:=}');
    Error('\P{Blk=_KHITAN_Small_Script:=}');
    Expect(1, 101631, '\p{Blk=:\AKhitan_Small_Script\z:}', "");;
    Expect(0, 101632, '\p{Blk=:\AKhitan_Small_Script\z:}', "");;
    Expect(1, 101631, '\p{Blk=khitansmallscript}', "");
    Expect(0, 101631, '\p{^Blk=khitansmallscript}', "");
    Expect(0, 101631, '\P{Blk=khitansmallscript}', "");
    Expect(1, 101631, '\P{^Blk=khitansmallscript}', "");
    Expect(0, 101632, '\p{Blk=khitansmallscript}', "");
    Expect(1, 101632, '\p{^Blk=khitansmallscript}', "");
    Expect(1, 101632, '\P{Blk=khitansmallscript}', "");
    Expect(0, 101632, '\P{^Blk=khitansmallscript}', "");
    Expect(1, 101631, '\p{Blk=:\Akhitansmallscript\z:}', "");;
    Expect(0, 101632, '\p{Blk=:\Akhitansmallscript\z:}', "");;
    Expect(1, 101631, '\p{Blk=_khitan_small_Script}', "");
    Expect(0, 101631, '\p{^Blk=_khitan_small_Script}', "");
    Expect(0, 101631, '\P{Blk=_khitan_small_Script}', "");
    Expect(1, 101631, '\P{^Blk=_khitan_small_Script}', "");
    Expect(0, 101632, '\p{Blk=_khitan_small_Script}', "");
    Expect(1, 101632, '\p{^Blk=_khitan_small_Script}', "");
    Expect(1, 101632, '\P{Blk=_khitan_small_Script}', "");
    Expect(0, 101632, '\P{^Blk=_khitan_small_Script}', "");
    Error('\p{Is_Block:	 /a/khitan_Small_Script}');
    Error('\P{Is_Block:	 /a/khitan_Small_Script}');
    Expect(1, 101631, '\p{Is_Block=khitansmallscript}', "");
    Expect(0, 101631, '\p{^Is_Block=khitansmallscript}', "");
    Expect(0, 101631, '\P{Is_Block=khitansmallscript}', "");
    Expect(1, 101631, '\P{^Is_Block=khitansmallscript}', "");
    Expect(0, 101632, '\p{Is_Block=khitansmallscript}', "");
    Expect(1, 101632, '\p{^Is_Block=khitansmallscript}', "");
    Expect(1, 101632, '\P{Is_Block=khitansmallscript}', "");
    Expect(0, 101632, '\P{^Is_Block=khitansmallscript}', "");
    Expect(1, 101631, '\p{Is_Block=		Khitan_Small_Script}', "");
    Expect(0, 101631, '\p{^Is_Block=		Khitan_Small_Script}', "");
    Expect(0, 101631, '\P{Is_Block=		Khitan_Small_Script}', "");
    Expect(1, 101631, '\P{^Is_Block=		Khitan_Small_Script}', "");
    Expect(0, 101632, '\p{Is_Block=		Khitan_Small_Script}', "");
    Expect(1, 101632, '\p{^Is_Block=		Khitan_Small_Script}', "");
    Expect(1, 101632, '\P{Is_Block=		Khitan_Small_Script}', "");
    Expect(0, 101632, '\P{^Is_Block=		Khitan_Small_Script}', "");
    Error('\p{Is_Blk=:=	 KHITAN_SMALL_Script}');
    Error('\P{Is_Blk=:=	 KHITAN_SMALL_Script}');
    Expect(1, 101631, '\p{Is_Blk=khitansmallscript}', "");
    Expect(0, 101631, '\p{^Is_Blk=khitansmallscript}', "");
    Expect(0, 101631, '\P{Is_Blk=khitansmallscript}', "");
    Expect(1, 101631, '\P{^Is_Blk=khitansmallscript}', "");
    Expect(0, 101632, '\p{Is_Blk=khitansmallscript}', "");
    Expect(1, 101632, '\p{^Is_Blk=khitansmallscript}', "");
    Expect(1, 101632, '\P{Is_Blk=khitansmallscript}', "");
    Expect(0, 101632, '\P{^Is_Blk=khitansmallscript}', "");
    Expect(1, 101631, '\p{Is_Blk=	Khitan_Small_Script}', "");
    Expect(0, 101631, '\p{^Is_Blk=	Khitan_Small_Script}', "");
    Expect(0, 101631, '\P{Is_Blk=	Khitan_Small_Script}', "");
    Expect(1, 101631, '\P{^Is_Blk=	Khitan_Small_Script}', "");
    Expect(0, 101632, '\p{Is_Blk=	Khitan_Small_Script}', "");
    Expect(1, 101632, '\p{^Is_Blk=	Khitan_Small_Script}', "");
    Expect(1, 101632, '\P{Is_Blk=	Khitan_Small_Script}', "");
    Expect(0, 101632, '\P{^Is_Blk=	Khitan_Small_Script}', "");
    Error('\p{Block=_Khmer/a/}');
    Error('\P{Block=_Khmer/a/}');
    Expect(1, 6143, '\p{Block=:\AKhmer\z:}', "");;
    Expect(0, 6144, '\p{Block=:\AKhmer\z:}', "");;
    Expect(1, 6143, '\p{Block=khmer}', "");
    Expect(0, 6143, '\p{^Block=khmer}', "");
    Expect(0, 6143, '\P{Block=khmer}', "");
    Expect(1, 6143, '\P{^Block=khmer}', "");
    Expect(0, 6144, '\p{Block=khmer}', "");
    Expect(1, 6144, '\p{^Block=khmer}', "");
    Expect(1, 6144, '\P{Block=khmer}', "");
    Expect(0, 6144, '\P{^Block=khmer}', "");
    Expect(1, 6143, '\p{Block=:\Akhmer\z:}', "");;
    Expect(0, 6144, '\p{Block=:\Akhmer\z:}', "");;
    Expect(1, 6143, '\p{Block= Khmer}', "");
    Expect(0, 6143, '\p{^Block= Khmer}', "");
    Expect(0, 6143, '\P{Block= Khmer}', "");
    Expect(1, 6143, '\P{^Block= Khmer}', "");
    Expect(0, 6144, '\p{Block= Khmer}', "");
    Expect(1, 6144, '\p{^Block= Khmer}', "");
    Expect(1, 6144, '\P{Block= Khmer}', "");
    Expect(0, 6144, '\P{^Block= Khmer}', "");
    Error('\p{Blk= /a/Khmer}');
    Error('\P{Blk= /a/Khmer}');
    Expect(1, 6143, '\p{Blk=:\AKhmer\z:}', "");;
    Expect(0, 6144, '\p{Blk=:\AKhmer\z:}', "");;
    Expect(1, 6143, '\p{Blk=khmer}', "");
    Expect(0, 6143, '\p{^Blk=khmer}', "");
    Expect(0, 6143, '\P{Blk=khmer}', "");
    Expect(1, 6143, '\P{^Blk=khmer}', "");
    Expect(0, 6144, '\p{Blk=khmer}', "");
    Expect(1, 6144, '\p{^Blk=khmer}', "");
    Expect(1, 6144, '\P{Blk=khmer}', "");
    Expect(0, 6144, '\P{^Blk=khmer}', "");
    Expect(1, 6143, '\p{Blk=:\Akhmer\z:}', "");;
    Expect(0, 6144, '\p{Blk=:\Akhmer\z:}', "");;
    Expect(1, 6143, '\p{Blk=  Khmer}', "");
    Expect(0, 6143, '\p{^Blk=  Khmer}', "");
    Expect(0, 6143, '\P{Blk=  Khmer}', "");
    Expect(1, 6143, '\P{^Blk=  Khmer}', "");
    Expect(0, 6144, '\p{Blk=  Khmer}', "");
    Expect(1, 6144, '\p{^Blk=  Khmer}', "");
    Expect(1, 6144, '\P{Blk=  Khmer}', "");
    Expect(0, 6144, '\P{^Blk=  Khmer}', "");
    Error('\p{Is_Block=- khmer:=}');
    Error('\P{Is_Block=- khmer:=}');
    Expect(1, 6143, '\p{Is_Block=khmer}', "");
    Expect(0, 6143, '\p{^Is_Block=khmer}', "");
    Expect(0, 6143, '\P{Is_Block=khmer}', "");
    Expect(1, 6143, '\P{^Is_Block=khmer}', "");
    Expect(0, 6144, '\p{Is_Block=khmer}', "");
    Expect(1, 6144, '\p{^Is_Block=khmer}', "");
    Expect(1, 6144, '\P{Is_Block=khmer}', "");
    Expect(0, 6144, '\P{^Is_Block=khmer}', "");
    Expect(1, 6143, '\p{Is_Block=	_Khmer}', "");
    Expect(0, 6143, '\p{^Is_Block=	_Khmer}', "");
    Expect(0, 6143, '\P{Is_Block=	_Khmer}', "");
    Expect(1, 6143, '\P{^Is_Block=	_Khmer}', "");
    Expect(0, 6144, '\p{Is_Block=	_Khmer}', "");
    Expect(1, 6144, '\p{^Is_Block=	_Khmer}', "");
    Expect(1, 6144, '\P{Is_Block=	_Khmer}', "");
    Expect(0, 6144, '\P{^Is_Block=	_Khmer}', "");
    Error('\p{Is_Blk=:= 	Khmer}');
    Error('\P{Is_Blk=:= 	Khmer}');
    Expect(1, 6143, '\p{Is_Blk=khmer}', "");
    Expect(0, 6143, '\p{^Is_Blk=khmer}', "");
    Expect(0, 6143, '\P{Is_Blk=khmer}', "");
    Expect(1, 6143, '\P{^Is_Blk=khmer}', "");
    Expect(0, 6144, '\p{Is_Blk=khmer}', "");
    Expect(1, 6144, '\p{^Is_Blk=khmer}', "");
    Expect(1, 6144, '\P{Is_Blk=khmer}', "");
    Expect(0, 6144, '\P{^Is_Blk=khmer}', "");
    Expect(1, 6143, '\p{Is_Blk=	Khmer}', "");
    Expect(0, 6143, '\p{^Is_Blk=	Khmer}', "");
    Expect(0, 6143, '\P{Is_Blk=	Khmer}', "");
    Expect(1, 6143, '\P{^Is_Blk=	Khmer}', "");
    Expect(0, 6144, '\p{Is_Blk=	Khmer}', "");
    Expect(1, 6144, '\p{^Is_Blk=	Khmer}', "");
    Expect(1, 6144, '\P{Is_Blk=	Khmer}', "");
    Expect(0, 6144, '\P{^Is_Blk=	Khmer}', "");
    Error('\p{Block=	KHMER_symbols:=}');
    Error('\P{Block=	KHMER_symbols:=}');
    Expect(1, 6655, '\p{Block=:\AKhmer_Symbols\z:}', "");;
    Expect(0, 6656, '\p{Block=:\AKhmer_Symbols\z:}', "");;
    Expect(1, 6655, '\p{Block=khmersymbols}', "");
    Expect(0, 6655, '\p{^Block=khmersymbols}', "");
    Expect(0, 6655, '\P{Block=khmersymbols}', "");
    Expect(1, 6655, '\P{^Block=khmersymbols}', "");
    Expect(0, 6656, '\p{Block=khmersymbols}', "");
    Expect(1, 6656, '\p{^Block=khmersymbols}', "");
    Expect(1, 6656, '\P{Block=khmersymbols}', "");
    Expect(0, 6656, '\P{^Block=khmersymbols}', "");
    Expect(1, 6655, '\p{Block=:\Akhmersymbols\z:}', "");;
    Expect(0, 6656, '\p{Block=:\Akhmersymbols\z:}', "");;
    Expect(1, 6655, '\p{Block= KHMER_Symbols}', "");
    Expect(0, 6655, '\p{^Block= KHMER_Symbols}', "");
    Expect(0, 6655, '\P{Block= KHMER_Symbols}', "");
    Expect(1, 6655, '\P{^Block= KHMER_Symbols}', "");
    Expect(0, 6656, '\p{Block= KHMER_Symbols}', "");
    Expect(1, 6656, '\p{^Block= KHMER_Symbols}', "");
    Expect(1, 6656, '\P{Block= KHMER_Symbols}', "");
    Expect(0, 6656, '\P{^Block= KHMER_Symbols}', "");
    Error('\p{Blk:	:=	-Khmer_Symbols}');
    Error('\P{Blk:	:=	-Khmer_Symbols}');
    Expect(1, 6655, '\p{Blk=:\AKhmer_Symbols\z:}', "");;
    Expect(0, 6656, '\p{Blk=:\AKhmer_Symbols\z:}', "");;
    Expect(1, 6655, '\p{Blk=khmersymbols}', "");
    Expect(0, 6655, '\p{^Blk=khmersymbols}', "");
    Expect(0, 6655, '\P{Blk=khmersymbols}', "");
    Expect(1, 6655, '\P{^Blk=khmersymbols}', "");
    Expect(0, 6656, '\p{Blk=khmersymbols}', "");
    Expect(1, 6656, '\p{^Blk=khmersymbols}', "");
    Expect(1, 6656, '\P{Blk=khmersymbols}', "");
    Expect(0, 6656, '\P{^Blk=khmersymbols}', "");
    Expect(1, 6655, '\p{Blk=:\Akhmersymbols\z:}', "");;
    Expect(0, 6656, '\p{Blk=:\Akhmersymbols\z:}', "");;
    Expect(1, 6655, '\p{Blk= Khmer_SYMBOLS}', "");
    Expect(0, 6655, '\p{^Blk= Khmer_SYMBOLS}', "");
    Expect(0, 6655, '\P{Blk= Khmer_SYMBOLS}', "");
    Expect(1, 6655, '\P{^Blk= Khmer_SYMBOLS}', "");
    Expect(0, 6656, '\p{Blk= Khmer_SYMBOLS}', "");
    Expect(1, 6656, '\p{^Blk= Khmer_SYMBOLS}', "");
    Expect(1, 6656, '\P{Blk= Khmer_SYMBOLS}', "");
    Expect(0, 6656, '\P{^Blk= Khmer_SYMBOLS}', "");
    Error('\p{Is_Block=:=-Khmer_symbols}');
    Error('\P{Is_Block=:=-Khmer_symbols}');
    Expect(1, 6655, '\p{Is_Block:   khmersymbols}', "");
    Expect(0, 6655, '\p{^Is_Block:   khmersymbols}', "");
    Expect(0, 6655, '\P{Is_Block:   khmersymbols}', "");
    Expect(1, 6655, '\P{^Is_Block:   khmersymbols}', "");
    Expect(0, 6656, '\p{Is_Block:   khmersymbols}', "");
    Expect(1, 6656, '\p{^Is_Block:   khmersymbols}', "");
    Expect(1, 6656, '\P{Is_Block:   khmersymbols}', "");
    Expect(0, 6656, '\P{^Is_Block:   khmersymbols}', "");
    Expect(1, 6655, '\p{Is_Block= 	KHMER_Symbols}', "");
    Expect(0, 6655, '\p{^Is_Block= 	KHMER_Symbols}', "");
    Expect(0, 6655, '\P{Is_Block= 	KHMER_Symbols}', "");
    Expect(1, 6655, '\P{^Is_Block= 	KHMER_Symbols}', "");
    Expect(0, 6656, '\p{Is_Block= 	KHMER_Symbols}', "");
    Expect(1, 6656, '\p{^Is_Block= 	KHMER_Symbols}', "");
    Expect(1, 6656, '\P{Is_Block= 	KHMER_Symbols}', "");
    Expect(0, 6656, '\P{^Is_Block= 	KHMER_Symbols}', "");
    Error('\p{Is_Blk=_:=Khmer_SYMBOLS}');
    Error('\P{Is_Blk=_:=Khmer_SYMBOLS}');
    Expect(1, 6655, '\p{Is_Blk=khmersymbols}', "");
    Expect(0, 6655, '\p{^Is_Blk=khmersymbols}', "");
    Expect(0, 6655, '\P{Is_Blk=khmersymbols}', "");
    Expect(1, 6655, '\P{^Is_Blk=khmersymbols}', "");
    Expect(0, 6656, '\p{Is_Blk=khmersymbols}', "");
    Expect(1, 6656, '\p{^Is_Blk=khmersymbols}', "");
    Expect(1, 6656, '\P{Is_Blk=khmersymbols}', "");
    Expect(0, 6656, '\P{^Is_Blk=khmersymbols}', "");
    Expect(1, 6655, '\p{Is_Blk=--khmer_SYMBOLS}', "");
    Expect(0, 6655, '\p{^Is_Blk=--khmer_SYMBOLS}', "");
    Expect(0, 6655, '\P{Is_Blk=--khmer_SYMBOLS}', "");
    Expect(1, 6655, '\P{^Is_Blk=--khmer_SYMBOLS}', "");
    Expect(0, 6656, '\p{Is_Blk=--khmer_SYMBOLS}', "");
    Expect(1, 6656, '\p{^Is_Blk=--khmer_SYMBOLS}', "");
    Expect(1, 6656, '\P{Is_Blk=--khmer_SYMBOLS}', "");
    Expect(0, 6656, '\P{^Is_Blk=--khmer_SYMBOLS}', "");
    Error('\p{Block=/a/khojki}');
    Error('\P{Block=/a/khojki}');
    Expect(1, 70223, '\p{Block=:\AKhojki\z:}', "");;
    Expect(0, 70224, '\p{Block=:\AKhojki\z:}', "");;
    Expect(1, 70223, '\p{Block=khojki}', "");
    Expect(0, 70223, '\p{^Block=khojki}', "");
    Expect(0, 70223, '\P{Block=khojki}', "");
    Expect(1, 70223, '\P{^Block=khojki}', "");
    Expect(0, 70224, '\p{Block=khojki}', "");
    Expect(1, 70224, '\p{^Block=khojki}', "");
    Expect(1, 70224, '\P{Block=khojki}', "");
    Expect(0, 70224, '\P{^Block=khojki}', "");
    Expect(1, 70223, '\p{Block=:\Akhojki\z:}', "");;
    Expect(0, 70224, '\p{Block=:\Akhojki\z:}', "");;
    Expect(1, 70223, '\p{Block=_Khojki}', "");
    Expect(0, 70223, '\p{^Block=_Khojki}', "");
    Expect(0, 70223, '\P{Block=_Khojki}', "");
    Expect(1, 70223, '\P{^Block=_Khojki}', "");
    Expect(0, 70224, '\p{Block=_Khojki}', "");
    Expect(1, 70224, '\p{^Block=_Khojki}', "");
    Expect(1, 70224, '\P{Block=_Khojki}', "");
    Expect(0, 70224, '\P{^Block=_Khojki}', "");
    Error('\p{Blk=:=  khojki}');
    Error('\P{Blk=:=  khojki}');
    Expect(1, 70223, '\p{Blk=:\AKhojki\z:}', "");;
    Expect(0, 70224, '\p{Blk=:\AKhojki\z:}', "");;
    Expect(1, 70223, '\p{Blk=khojki}', "");
    Expect(0, 70223, '\p{^Blk=khojki}', "");
    Expect(0, 70223, '\P{Blk=khojki}', "");
    Expect(1, 70223, '\P{^Blk=khojki}', "");
    Expect(0, 70224, '\p{Blk=khojki}', "");
    Expect(1, 70224, '\p{^Blk=khojki}', "");
    Expect(1, 70224, '\P{Blk=khojki}', "");
    Expect(0, 70224, '\P{^Blk=khojki}', "");
    Expect(1, 70223, '\p{Blk=:\Akhojki\z:}', "");;
    Expect(0, 70224, '\p{Blk=:\Akhojki\z:}', "");;
    Expect(1, 70223, '\p{Blk=_-Khojki}', "");
    Expect(0, 70223, '\p{^Blk=_-Khojki}', "");
    Expect(0, 70223, '\P{Blk=_-Khojki}', "");
    Expect(1, 70223, '\P{^Blk=_-Khojki}', "");
    Expect(0, 70224, '\p{Blk=_-Khojki}', "");
    Expect(1, 70224, '\p{^Blk=_-Khojki}', "");
    Expect(1, 70224, '\P{Blk=_-Khojki}', "");
    Expect(0, 70224, '\P{^Blk=_-Khojki}', "");
    Error('\p{Is_Block= /a/Khojki}');
    Error('\P{Is_Block= /a/Khojki}');
    Expect(1, 70223, '\p{Is_Block=khojki}', "");
    Expect(0, 70223, '\p{^Is_Block=khojki}', "");
    Expect(0, 70223, '\P{Is_Block=khojki}', "");
    Expect(1, 70223, '\P{^Is_Block=khojki}', "");
    Expect(0, 70224, '\p{Is_Block=khojki}', "");
    Expect(1, 70224, '\p{^Is_Block=khojki}', "");
    Expect(1, 70224, '\P{Is_Block=khojki}', "");
    Expect(0, 70224, '\P{^Is_Block=khojki}', "");
    Expect(1, 70223, '\p{Is_Block=	_Khojki}', "");
    Expect(0, 70223, '\p{^Is_Block=	_Khojki}', "");
    Expect(0, 70223, '\P{Is_Block=	_Khojki}', "");
    Expect(1, 70223, '\P{^Is_Block=	_Khojki}', "");
    Expect(0, 70224, '\p{Is_Block=	_Khojki}', "");
    Expect(1, 70224, '\p{^Is_Block=	_Khojki}', "");
    Expect(1, 70224, '\P{Is_Block=	_Khojki}', "");
    Expect(0, 70224, '\P{^Is_Block=	_Khojki}', "");
    Error('\p{Is_Blk=	/a/Khojki}');
    Error('\P{Is_Blk=	/a/Khojki}');
    Expect(1, 70223, '\p{Is_Blk=khojki}', "");
    Expect(0, 70223, '\p{^Is_Blk=khojki}', "");
    Expect(0, 70223, '\P{Is_Blk=khojki}', "");
    Expect(1, 70223, '\P{^Is_Blk=khojki}', "");
    Expect(0, 70224, '\p{Is_Blk=khojki}', "");
    Expect(1, 70224, '\p{^Is_Blk=khojki}', "");
    Expect(1, 70224, '\P{Is_Blk=khojki}', "");
    Expect(0, 70224, '\P{^Is_Blk=khojki}', "");
    Expect(1, 70223, '\p{Is_Blk=  khojki}', "");
    Expect(0, 70223, '\p{^Is_Blk=  khojki}', "");
    Expect(0, 70223, '\P{Is_Blk=  khojki}', "");
    Expect(1, 70223, '\P{^Is_Blk=  khojki}', "");
    Expect(0, 70224, '\p{Is_Blk=  khojki}', "");
    Expect(1, 70224, '\p{^Is_Blk=  khojki}', "");
    Expect(1, 70224, '\P{Is_Blk=  khojki}', "");
    Expect(0, 70224, '\P{^Is_Blk=  khojki}', "");
    Error('\p{Block=_	KHUDAWADI:=}');
    Error('\P{Block=_	KHUDAWADI:=}');
    Expect(1, 70399, '\p{Block=:\AKhudawadi\z:}', "");;
    Expect(0, 70400, '\p{Block=:\AKhudawadi\z:}', "");;
    Expect(1, 70399, '\p{Block=khudawadi}', "");
    Expect(0, 70399, '\p{^Block=khudawadi}', "");
    Expect(0, 70399, '\P{Block=khudawadi}', "");
    Expect(1, 70399, '\P{^Block=khudawadi}', "");
    Expect(0, 70400, '\p{Block=khudawadi}', "");
    Expect(1, 70400, '\p{^Block=khudawadi}', "");
    Expect(1, 70400, '\P{Block=khudawadi}', "");
    Expect(0, 70400, '\P{^Block=khudawadi}', "");
    Expect(1, 70399, '\p{Block=:\Akhudawadi\z:}', "");;
    Expect(0, 70400, '\p{Block=:\Akhudawadi\z:}', "");;
    Expect(1, 70399, '\p{Block=_khudawadi}', "");
    Expect(0, 70399, '\p{^Block=_khudawadi}', "");
    Expect(0, 70399, '\P{Block=_khudawadi}', "");
    Expect(1, 70399, '\P{^Block=_khudawadi}', "");
    Expect(0, 70400, '\p{Block=_khudawadi}', "");
    Expect(1, 70400, '\p{^Block=_khudawadi}', "");
    Expect(1, 70400, '\P{Block=_khudawadi}', "");
    Expect(0, 70400, '\P{^Block=_khudawadi}', "");
    Error('\p{Blk=/a/ _Khudawadi}');
    Error('\P{Blk=/a/ _Khudawadi}');
    Expect(1, 70399, '\p{Blk=:\AKhudawadi\z:}', "");;
    Expect(0, 70400, '\p{Blk=:\AKhudawadi\z:}', "");;
    Expect(1, 70399, '\p{Blk:   khudawadi}', "");
    Expect(0, 70399, '\p{^Blk:   khudawadi}', "");
    Expect(0, 70399, '\P{Blk:   khudawadi}', "");
    Expect(1, 70399, '\P{^Blk:   khudawadi}', "");
    Expect(0, 70400, '\p{Blk:   khudawadi}', "");
    Expect(1, 70400, '\p{^Blk:   khudawadi}', "");
    Expect(1, 70400, '\P{Blk:   khudawadi}', "");
    Expect(0, 70400, '\P{^Blk:   khudawadi}', "");
    Expect(1, 70399, '\p{Blk=:\Akhudawadi\z:}', "");;
    Expect(0, 70400, '\p{Blk=:\Akhudawadi\z:}', "");;
    Expect(1, 70399, '\p{Blk=_ Khudawadi}', "");
    Expect(0, 70399, '\p{^Blk=_ Khudawadi}', "");
    Expect(0, 70399, '\P{Blk=_ Khudawadi}', "");
    Expect(1, 70399, '\P{^Blk=_ Khudawadi}', "");
    Expect(0, 70400, '\p{Blk=_ Khudawadi}', "");
    Expect(1, 70400, '\p{^Blk=_ Khudawadi}', "");
    Expect(1, 70400, '\P{Blk=_ Khudawadi}', "");
    Expect(0, 70400, '\P{^Blk=_ Khudawadi}', "");
    Error('\p{Is_Block=	/a/KHUDAWADI}');
    Error('\P{Is_Block=	/a/KHUDAWADI}');
    Expect(1, 70399, '\p{Is_Block=khudawadi}', "");
    Expect(0, 70399, '\p{^Is_Block=khudawadi}', "");
    Expect(0, 70399, '\P{Is_Block=khudawadi}', "");
    Expect(1, 70399, '\P{^Is_Block=khudawadi}', "");
    Expect(0, 70400, '\p{Is_Block=khudawadi}', "");
    Expect(1, 70400, '\p{^Is_Block=khudawadi}', "");
    Expect(1, 70400, '\P{Is_Block=khudawadi}', "");
    Expect(0, 70400, '\P{^Is_Block=khudawadi}', "");
    Expect(1, 70399, '\p{Is_Block=-_Khudawadi}', "");
    Expect(0, 70399, '\p{^Is_Block=-_Khudawadi}', "");
    Expect(0, 70399, '\P{Is_Block=-_Khudawadi}', "");
    Expect(1, 70399, '\P{^Is_Block=-_Khudawadi}', "");
    Expect(0, 70400, '\p{Is_Block=-_Khudawadi}', "");
    Expect(1, 70400, '\p{^Is_Block=-_Khudawadi}', "");
    Expect(1, 70400, '\P{Is_Block=-_Khudawadi}', "");
    Expect(0, 70400, '\P{^Is_Block=-_Khudawadi}', "");
    Error('\p{Is_Blk=-KHUDAWADI/a/}');
    Error('\P{Is_Blk=-KHUDAWADI/a/}');
    Expect(1, 70399, '\p{Is_Blk=khudawadi}', "");
    Expect(0, 70399, '\p{^Is_Blk=khudawadi}', "");
    Expect(0, 70399, '\P{Is_Blk=khudawadi}', "");
    Expect(1, 70399, '\P{^Is_Blk=khudawadi}', "");
    Expect(0, 70400, '\p{Is_Blk=khudawadi}', "");
    Expect(1, 70400, '\p{^Is_Blk=khudawadi}', "");
    Expect(1, 70400, '\P{Is_Blk=khudawadi}', "");
    Expect(0, 70400, '\P{^Is_Blk=khudawadi}', "");
    Expect(1, 70399, '\p{Is_Blk= 	Khudawadi}', "");
    Expect(0, 70399, '\p{^Is_Blk= 	Khudawadi}', "");
    Expect(0, 70399, '\P{Is_Blk= 	Khudawadi}', "");
    Expect(1, 70399, '\P{^Is_Blk= 	Khudawadi}', "");
    Expect(0, 70400, '\p{Is_Blk= 	Khudawadi}', "");
    Expect(1, 70400, '\p{^Is_Blk= 	Khudawadi}', "");
    Expect(1, 70400, '\P{Is_Blk= 	Khudawadi}', "");
    Expect(0, 70400, '\P{^Is_Blk= 	Khudawadi}', "");
    Error('\p{Block=		lao/a/}');
    Error('\P{Block=		lao/a/}');
    Expect(1, 3839, '\p{Block=:\ALao\z:}', "");;
    Expect(0, 3840, '\p{Block=:\ALao\z:}', "");;
    Expect(1, 3839, '\p{Block=lao}', "");
    Expect(0, 3839, '\p{^Block=lao}', "");
    Expect(0, 3839, '\P{Block=lao}', "");
    Expect(1, 3839, '\P{^Block=lao}', "");
    Expect(0, 3840, '\p{Block=lao}', "");
    Expect(1, 3840, '\p{^Block=lao}', "");
    Expect(1, 3840, '\P{Block=lao}', "");
    Expect(0, 3840, '\P{^Block=lao}', "");
    Expect(1, 3839, '\p{Block=:\Alao\z:}', "");;
    Expect(0, 3840, '\p{Block=:\Alao\z:}', "");;
    Expect(1, 3839, '\p{Block=-	lao}', "");
    Expect(0, 3839, '\p{^Block=-	lao}', "");
    Expect(0, 3839, '\P{Block=-	lao}', "");
    Expect(1, 3839, '\P{^Block=-	lao}', "");
    Expect(0, 3840, '\p{Block=-	lao}', "");
    Expect(1, 3840, '\p{^Block=-	lao}', "");
    Expect(1, 3840, '\P{Block=-	lao}', "");
    Expect(0, 3840, '\P{^Block=-	lao}', "");
    Error('\p{Blk= -LAO/a/}');
    Error('\P{Blk= -LAO/a/}');
    Expect(1, 3839, '\p{Blk=:\ALao\z:}', "");;
    Expect(0, 3840, '\p{Blk=:\ALao\z:}', "");;
    Expect(1, 3839, '\p{Blk=lao}', "");
    Expect(0, 3839, '\p{^Blk=lao}', "");
    Expect(0, 3839, '\P{Blk=lao}', "");
    Expect(1, 3839, '\P{^Blk=lao}', "");
    Expect(0, 3840, '\p{Blk=lao}', "");
    Expect(1, 3840, '\p{^Blk=lao}', "");
    Expect(1, 3840, '\P{Blk=lao}', "");
    Expect(0, 3840, '\P{^Blk=lao}', "");
    Expect(1, 3839, '\p{Blk=:\Alao\z:}', "");;
    Expect(0, 3840, '\p{Blk=:\Alao\z:}', "");;
    Expect(1, 3839, '\p{Blk=-LAO}', "");
    Expect(0, 3839, '\p{^Blk=-LAO}', "");
    Expect(0, 3839, '\P{Blk=-LAO}', "");
    Expect(1, 3839, '\P{^Blk=-LAO}', "");
    Expect(0, 3840, '\p{Blk=-LAO}', "");
    Expect(1, 3840, '\p{^Blk=-LAO}', "");
    Expect(1, 3840, '\P{Blk=-LAO}', "");
    Expect(0, 3840, '\P{^Blk=-LAO}', "");
    Error('\p{Is_Block=/a/_	LAO}');
    Error('\P{Is_Block=/a/_	LAO}');
    Expect(1, 3839, '\p{Is_Block=lao}', "");
    Expect(0, 3839, '\p{^Is_Block=lao}', "");
    Expect(0, 3839, '\P{Is_Block=lao}', "");
    Expect(1, 3839, '\P{^Is_Block=lao}', "");
    Expect(0, 3840, '\p{Is_Block=lao}', "");
    Expect(1, 3840, '\p{^Is_Block=lao}', "");
    Expect(1, 3840, '\P{Is_Block=lao}', "");
    Expect(0, 3840, '\P{^Is_Block=lao}', "");
    Expect(1, 3839, '\p{Is_Block=--LAO}', "");
    Expect(0, 3839, '\p{^Is_Block=--LAO}', "");
    Expect(0, 3839, '\P{Is_Block=--LAO}', "");
    Expect(1, 3839, '\P{^Is_Block=--LAO}', "");
    Expect(0, 3840, '\p{Is_Block=--LAO}', "");
    Expect(1, 3840, '\p{^Is_Block=--LAO}', "");
    Expect(1, 3840, '\P{Is_Block=--LAO}', "");
    Expect(0, 3840, '\P{^Is_Block=--LAO}', "");
    Error('\p{Is_Blk=_	lao:=}');
    Error('\P{Is_Blk=_	lao:=}');
    Expect(1, 3839, '\p{Is_Blk=lao}', "");
    Expect(0, 3839, '\p{^Is_Blk=lao}', "");
    Expect(0, 3839, '\P{Is_Blk=lao}', "");
    Expect(1, 3839, '\P{^Is_Blk=lao}', "");
    Expect(0, 3840, '\p{Is_Blk=lao}', "");
    Expect(1, 3840, '\p{^Is_Blk=lao}', "");
    Expect(1, 3840, '\P{Is_Blk=lao}', "");
    Expect(0, 3840, '\P{^Is_Blk=lao}', "");
    Expect(1, 3839, '\p{Is_Blk=	-Lao}', "");
    Expect(0, 3839, '\p{^Is_Blk=	-Lao}', "");
    Expect(0, 3839, '\P{Is_Blk=	-Lao}', "");
    Expect(1, 3839, '\P{^Is_Blk=	-Lao}', "");
    Expect(0, 3840, '\p{Is_Blk=	-Lao}', "");
    Expect(1, 3840, '\p{^Is_Blk=	-Lao}', "");
    Expect(1, 3840, '\P{Is_Blk=	-Lao}', "");
    Expect(0, 3840, '\P{^Is_Blk=	-Lao}', "");
    Error('\p{Block=- LATIN_1_supplement/a/}');
    Error('\P{Block=- LATIN_1_supplement/a/}');
    Expect(1, 255, '\p{Block=:\ALatin_1_Supplement\z:}', "");;
    Expect(0, 256, '\p{Block=:\ALatin_1_Supplement\z:}', "");;
    Expect(1, 255, '\p{Block=latin1supplement}', "");
    Expect(0, 255, '\p{^Block=latin1supplement}', "");
    Expect(0, 255, '\P{Block=latin1supplement}', "");
    Expect(1, 255, '\P{^Block=latin1supplement}', "");
    Expect(0, 256, '\p{Block=latin1supplement}', "");
    Expect(1, 256, '\p{^Block=latin1supplement}', "");
    Expect(1, 256, '\P{Block=latin1supplement}', "");
    Expect(0, 256, '\P{^Block=latin1supplement}', "");
    Expect(1, 255, '\p{Block=:\Alatin1supplement\z:}', "");;
    Expect(0, 256, '\p{Block=:\Alatin1supplement\z:}', "");;
    Expect(1, 255, '\p{Block= _latin_1_supplement}', "");
    Expect(0, 255, '\p{^Block= _latin_1_supplement}', "");
    Expect(0, 255, '\P{Block= _latin_1_supplement}', "");
    Expect(1, 255, '\P{^Block= _latin_1_supplement}', "");
    Expect(0, 256, '\p{Block= _latin_1_supplement}', "");
    Expect(1, 256, '\p{^Block= _latin_1_supplement}', "");
    Expect(1, 256, '\P{Block= _latin_1_supplement}', "");
    Expect(0, 256, '\P{^Block= _latin_1_supplement}', "");
    Error('\p{Blk: __LATIN_1_SUP/a/}');
    Error('\P{Blk: __LATIN_1_SUP/a/}');
    Expect(1, 255, '\p{Blk=:\ALatin_1_Sup\z:}', "");;
    Expect(0, 256, '\p{Blk=:\ALatin_1_Sup\z:}', "");;
    Expect(1, 255, '\p{Blk=latin1sup}', "");
    Expect(0, 255, '\p{^Blk=latin1sup}', "");
    Expect(0, 255, '\P{Blk=latin1sup}', "");
    Expect(1, 255, '\P{^Blk=latin1sup}', "");
    Expect(0, 256, '\p{Blk=latin1sup}', "");
    Expect(1, 256, '\p{^Blk=latin1sup}', "");
    Expect(1, 256, '\P{Blk=latin1sup}', "");
    Expect(0, 256, '\P{^Blk=latin1sup}', "");
    Expect(1, 255, '\p{Blk=:\Alatin1sup\z:}', "");;
    Expect(0, 256, '\p{Blk=:\Alatin1sup\z:}', "");;
    Expect(1, 255, '\p{Blk=__Latin_1_Sup}', "");
    Expect(0, 255, '\p{^Blk=__Latin_1_Sup}', "");
    Expect(0, 255, '\P{Blk=__Latin_1_Sup}', "");
    Expect(1, 255, '\P{^Blk=__Latin_1_Sup}', "");
    Expect(0, 256, '\p{Blk=__Latin_1_Sup}', "");
    Expect(1, 256, '\p{^Blk=__Latin_1_Sup}', "");
    Expect(1, 256, '\P{Blk=__Latin_1_Sup}', "");
    Expect(0, 256, '\P{^Blk=__Latin_1_Sup}', "");
    Error('\p{Is_Block=:=-_Latin_1}');
    Error('\P{Is_Block=:=-_Latin_1}');
    Expect(1, 255, '\p{Is_Block=latin1}', "");
    Expect(0, 255, '\p{^Is_Block=latin1}', "");
    Expect(0, 255, '\P{Is_Block=latin1}', "");
    Expect(1, 255, '\P{^Is_Block=latin1}', "");
    Expect(0, 256, '\p{Is_Block=latin1}', "");
    Expect(1, 256, '\p{^Is_Block=latin1}', "");
    Expect(1, 256, '\P{Is_Block=latin1}', "");
    Expect(0, 256, '\P{^Is_Block=latin1}', "");
    Expect(1, 255, '\p{Is_Block= latin_1}', "");
    Expect(0, 255, '\p{^Is_Block= latin_1}', "");
    Expect(0, 255, '\P{Is_Block= latin_1}', "");
    Expect(1, 255, '\P{^Is_Block= latin_1}', "");
    Expect(0, 256, '\p{Is_Block= latin_1}', "");
    Expect(1, 256, '\p{^Is_Block= latin_1}', "");
    Expect(1, 256, '\P{Is_Block= latin_1}', "");
    Expect(0, 256, '\P{^Is_Block= latin_1}', "");
    Error('\p{Is_Blk= _Latin_1_Supplement:=}');
    Error('\P{Is_Blk= _Latin_1_Supplement:=}');
    Expect(1, 255, '\p{Is_Blk=latin1supplement}', "");
    Expect(0, 255, '\p{^Is_Blk=latin1supplement}', "");
    Expect(0, 255, '\P{Is_Blk=latin1supplement}', "");
    Expect(1, 255, '\P{^Is_Blk=latin1supplement}', "");
    Expect(0, 256, '\p{Is_Blk=latin1supplement}', "");
    Expect(1, 256, '\p{^Is_Blk=latin1supplement}', "");
    Expect(1, 256, '\P{Is_Blk=latin1supplement}', "");
    Expect(0, 256, '\P{^Is_Blk=latin1supplement}', "");
    Expect(1, 255, '\p{Is_Blk=	_latin_1_SUPPLEMENT}', "");
    Expect(0, 255, '\p{^Is_Blk=	_latin_1_SUPPLEMENT}', "");
    Expect(0, 255, '\P{Is_Blk=	_latin_1_SUPPLEMENT}', "");
    Expect(1, 255, '\P{^Is_Blk=	_latin_1_SUPPLEMENT}', "");
    Expect(0, 256, '\p{Is_Blk=	_latin_1_SUPPLEMENT}', "");
    Expect(1, 256, '\p{^Is_Blk=	_latin_1_SUPPLEMENT}', "");
    Expect(1, 256, '\P{Is_Blk=	_latin_1_SUPPLEMENT}', "");
    Expect(0, 256, '\P{^Is_Blk=	_latin_1_SUPPLEMENT}', "");
    Error('\p{Block= /a/LATIN_EXTENDED_A}');
    Error('\P{Block= /a/LATIN_EXTENDED_A}');
    Expect(1, 383, '\p{Block=:\ALatin_Extended_A\z:}', "");;
    Expect(0, 384, '\p{Block=:\ALatin_Extended_A\z:}', "");;
    Expect(1, 383, '\p{Block=latinextendeda}', "");
    Expect(0, 383, '\p{^Block=latinextendeda}', "");
    Expect(0, 383, '\P{Block=latinextendeda}', "");
    Expect(1, 383, '\P{^Block=latinextendeda}', "");
    Expect(0, 384, '\p{Block=latinextendeda}', "");
    Expect(1, 384, '\p{^Block=latinextendeda}', "");
    Expect(1, 384, '\P{Block=latinextendeda}', "");
    Expect(0, 384, '\P{^Block=latinextendeda}', "");
    Expect(1, 383, '\p{Block=:\Alatinextendeda\z:}', "");;
    Expect(0, 384, '\p{Block=:\Alatinextendeda\z:}', "");;
    Expect(1, 383, '\p{Block=_ LATIN_EXTENDED_A}', "");
    Expect(0, 383, '\p{^Block=_ LATIN_EXTENDED_A}', "");
    Expect(0, 383, '\P{Block=_ LATIN_EXTENDED_A}', "");
    Expect(1, 383, '\P{^Block=_ LATIN_EXTENDED_A}', "");
    Expect(0, 384, '\p{Block=_ LATIN_EXTENDED_A}', "");
    Expect(1, 384, '\p{^Block=_ LATIN_EXTENDED_A}', "");
    Expect(1, 384, '\P{Block=_ LATIN_EXTENDED_A}', "");
    Expect(0, 384, '\P{^Block=_ LATIN_EXTENDED_A}', "");
    Error('\p{Blk=- latin_Ext_A:=}');
    Error('\P{Blk=- latin_Ext_A:=}');
    Expect(1, 383, '\p{Blk=:\ALatin_Ext_A\z:}', "");;
    Expect(0, 384, '\p{Blk=:\ALatin_Ext_A\z:}', "");;
    Expect(1, 383, '\p{Blk=latinexta}', "");
    Expect(0, 383, '\p{^Blk=latinexta}', "");
    Expect(0, 383, '\P{Blk=latinexta}', "");
    Expect(1, 383, '\P{^Blk=latinexta}', "");
    Expect(0, 384, '\p{Blk=latinexta}', "");
    Expect(1, 384, '\p{^Blk=latinexta}', "");
    Expect(1, 384, '\P{Blk=latinexta}', "");
    Expect(0, 384, '\P{^Blk=latinexta}', "");
    Expect(1, 383, '\p{Blk=:\Alatinexta\z:}', "");;
    Expect(0, 384, '\p{Blk=:\Alatinexta\z:}', "");;
    Expect(1, 383, '\p{Blk=	Latin_ext_A}', "");
    Expect(0, 383, '\p{^Blk=	Latin_ext_A}', "");
    Expect(0, 383, '\P{Blk=	Latin_ext_A}', "");
    Expect(1, 383, '\P{^Blk=	Latin_ext_A}', "");
    Expect(0, 384, '\p{Blk=	Latin_ext_A}', "");
    Expect(1, 384, '\p{^Blk=	Latin_ext_A}', "");
    Expect(1, 384, '\P{Blk=	Latin_ext_A}', "");
    Expect(0, 384, '\P{^Blk=	Latin_ext_A}', "");
    Error('\p{Is_Block=	:=Latin_extended_A}');
    Error('\P{Is_Block=	:=Latin_extended_A}');
    Expect(1, 383, '\p{Is_Block=latinextendeda}', "");
    Expect(0, 383, '\p{^Is_Block=latinextendeda}', "");
    Expect(0, 383, '\P{Is_Block=latinextendeda}', "");
    Expect(1, 383, '\P{^Is_Block=latinextendeda}', "");
    Expect(0, 384, '\p{Is_Block=latinextendeda}', "");
    Expect(1, 384, '\p{^Is_Block=latinextendeda}', "");
    Expect(1, 384, '\P{Is_Block=latinextendeda}', "");
    Expect(0, 384, '\P{^Is_Block=latinextendeda}', "");
    Expect(1, 383, '\p{Is_Block=	Latin_EXTENDED_A}', "");
    Expect(0, 383, '\p{^Is_Block=	Latin_EXTENDED_A}', "");
    Expect(0, 383, '\P{Is_Block=	Latin_EXTENDED_A}', "");
    Expect(1, 383, '\P{^Is_Block=	Latin_EXTENDED_A}', "");
    Expect(0, 384, '\p{Is_Block=	Latin_EXTENDED_A}', "");
    Expect(1, 384, '\p{^Is_Block=	Latin_EXTENDED_A}', "");
    Expect(1, 384, '\P{Is_Block=	Latin_EXTENDED_A}', "");
    Expect(0, 384, '\P{^Is_Block=	Latin_EXTENDED_A}', "");
    Error('\p{Is_Blk:	_/a/latin_EXT_a}');
    Error('\P{Is_Blk:	_/a/latin_EXT_a}');
    Expect(1, 383, '\p{Is_Blk=latinexta}', "");
    Expect(0, 383, '\p{^Is_Blk=latinexta}', "");
    Expect(0, 383, '\P{Is_Blk=latinexta}', "");
    Expect(1, 383, '\P{^Is_Blk=latinexta}', "");
    Expect(0, 384, '\p{Is_Blk=latinexta}', "");
    Expect(1, 384, '\p{^Is_Blk=latinexta}', "");
    Expect(1, 384, '\P{Is_Blk=latinexta}', "");
    Expect(0, 384, '\P{^Is_Blk=latinexta}', "");
    Expect(1, 383, '\p{Is_Blk= Latin_Ext_A}', "");
    Expect(0, 383, '\p{^Is_Blk= Latin_Ext_A}', "");
    Expect(0, 383, '\P{Is_Blk= Latin_Ext_A}', "");
    Expect(1, 383, '\P{^Is_Blk= Latin_Ext_A}', "");
    Expect(0, 384, '\p{Is_Blk= Latin_Ext_A}', "");
    Expect(1, 384, '\p{^Is_Blk= Latin_Ext_A}', "");
    Expect(1, 384, '\P{Is_Blk= Latin_Ext_A}', "");
    Expect(0, 384, '\P{^Is_Blk= Latin_Ext_A}', "");
    Error('\p{Block=_ Latin_EXTENDED_additional:=}');
    Error('\P{Block=_ Latin_EXTENDED_additional:=}');
    Expect(1, 7935, '\p{Block=:\ALatin_Extended_Additional\z:}', "");;
    Expect(0, 7936, '\p{Block=:\ALatin_Extended_Additional\z:}', "");;
    Expect(1, 7935, '\p{Block=latinextendedadditional}', "");
    Expect(0, 7935, '\p{^Block=latinextendedadditional}', "");
    Expect(0, 7935, '\P{Block=latinextendedadditional}', "");
    Expect(1, 7935, '\P{^Block=latinextendedadditional}', "");
    Expect(0, 7936, '\p{Block=latinextendedadditional}', "");
    Expect(1, 7936, '\p{^Block=latinextendedadditional}', "");
    Expect(1, 7936, '\P{Block=latinextendedadditional}', "");
    Expect(0, 7936, '\P{^Block=latinextendedadditional}', "");
    Expect(1, 7935, '\p{Block=:\Alatinextendedadditional\z:}', "");;
    Expect(0, 7936, '\p{Block=:\Alatinextendedadditional\z:}', "");;
    Expect(1, 7935, '\p{Block= 	LATIN_EXTENDED_additional}', "");
    Expect(0, 7935, '\p{^Block= 	LATIN_EXTENDED_additional}', "");
    Expect(0, 7935, '\P{Block= 	LATIN_EXTENDED_additional}', "");
    Expect(1, 7935, '\P{^Block= 	LATIN_EXTENDED_additional}', "");
    Expect(0, 7936, '\p{Block= 	LATIN_EXTENDED_additional}', "");
    Expect(1, 7936, '\p{^Block= 	LATIN_EXTENDED_additional}', "");
    Expect(1, 7936, '\P{Block= 	LATIN_EXTENDED_additional}', "");
    Expect(0, 7936, '\P{^Block= 	LATIN_EXTENDED_additional}', "");
    Error('\p{Blk=:=-_Latin_Ext_Additional}');
    Error('\P{Blk=:=-_Latin_Ext_Additional}');
    Expect(1, 7935, '\p{Blk=:\ALatin_Ext_Additional\z:}', "");;
    Expect(0, 7936, '\p{Blk=:\ALatin_Ext_Additional\z:}', "");;
    Expect(1, 7935, '\p{Blk=latinextadditional}', "");
    Expect(0, 7935, '\p{^Blk=latinextadditional}', "");
    Expect(0, 7935, '\P{Blk=latinextadditional}', "");
    Expect(1, 7935, '\P{^Blk=latinextadditional}', "");
    Expect(0, 7936, '\p{Blk=latinextadditional}', "");
    Expect(1, 7936, '\p{^Blk=latinextadditional}', "");
    Expect(1, 7936, '\P{Blk=latinextadditional}', "");
    Expect(0, 7936, '\P{^Blk=latinextadditional}', "");
    Expect(1, 7935, '\p{Blk=:\Alatinextadditional\z:}', "");;
    Expect(0, 7936, '\p{Blk=:\Alatinextadditional\z:}', "");;
    Expect(1, 7935, '\p{Blk=_latin_Ext_Additional}', "");
    Expect(0, 7935, '\p{^Blk=_latin_Ext_Additional}', "");
    Expect(0, 7935, '\P{Blk=_latin_Ext_Additional}', "");
    Expect(1, 7935, '\P{^Blk=_latin_Ext_Additional}', "");
    Expect(0, 7936, '\p{Blk=_latin_Ext_Additional}', "");
    Expect(1, 7936, '\p{^Blk=_latin_Ext_Additional}', "");
    Expect(1, 7936, '\P{Blk=_latin_Ext_Additional}', "");
    Expect(0, 7936, '\P{^Blk=_latin_Ext_Additional}', "");
    Error('\p{Is_Block=/a/	_Latin_extended_ADDITIONAL}');
    Error('\P{Is_Block=/a/	_Latin_extended_ADDITIONAL}');
    Expect(1, 7935, '\p{Is_Block=latinextendedadditional}', "");
    Expect(0, 7935, '\p{^Is_Block=latinextendedadditional}', "");
    Expect(0, 7935, '\P{Is_Block=latinextendedadditional}', "");
    Expect(1, 7935, '\P{^Is_Block=latinextendedadditional}', "");
    Expect(0, 7936, '\p{Is_Block=latinextendedadditional}', "");
    Expect(1, 7936, '\p{^Is_Block=latinextendedadditional}', "");
    Expect(1, 7936, '\P{Is_Block=latinextendedadditional}', "");
    Expect(0, 7936, '\P{^Is_Block=latinextendedadditional}', "");
    Expect(1, 7935, '\p{Is_Block=	LATIN_Extended_Additional}', "");
    Expect(0, 7935, '\p{^Is_Block=	LATIN_Extended_Additional}', "");
    Expect(0, 7935, '\P{Is_Block=	LATIN_Extended_Additional}', "");
    Expect(1, 7935, '\P{^Is_Block=	LATIN_Extended_Additional}', "");
    Expect(0, 7936, '\p{Is_Block=	LATIN_Extended_Additional}', "");
    Expect(1, 7936, '\p{^Is_Block=	LATIN_Extended_Additional}', "");
    Expect(1, 7936, '\P{Is_Block=	LATIN_Extended_Additional}', "");
    Expect(0, 7936, '\P{^Is_Block=	LATIN_Extended_Additional}', "");
    Error('\p{Is_Blk= :=Latin_ext_ADDITIONAL}');
    Error('\P{Is_Blk= :=Latin_ext_ADDITIONAL}');
    Expect(1, 7935, '\p{Is_Blk=latinextadditional}', "");
    Expect(0, 7935, '\p{^Is_Blk=latinextadditional}', "");
    Expect(0, 7935, '\P{Is_Blk=latinextadditional}', "");
    Expect(1, 7935, '\P{^Is_Blk=latinextadditional}', "");
    Expect(0, 7936, '\p{Is_Blk=latinextadditional}', "");
    Expect(1, 7936, '\p{^Is_Blk=latinextadditional}', "");
    Expect(1, 7936, '\P{Is_Blk=latinextadditional}', "");
    Expect(0, 7936, '\P{^Is_Blk=latinextadditional}', "");
    Expect(1, 7935, '\p{Is_Blk=_LATIN_Ext_Additional}', "");
    Expect(0, 7935, '\p{^Is_Blk=_LATIN_Ext_Additional}', "");
    Expect(0, 7935, '\P{Is_Blk=_LATIN_Ext_Additional}', "");
    Expect(1, 7935, '\P{^Is_Blk=_LATIN_Ext_Additional}', "");
    Expect(0, 7936, '\p{Is_Blk=_LATIN_Ext_Additional}', "");
    Expect(1, 7936, '\p{^Is_Blk=_LATIN_Ext_Additional}', "");
    Expect(1, 7936, '\P{Is_Blk=_LATIN_Ext_Additional}', "");
    Expect(0, 7936, '\P{^Is_Blk=_LATIN_Ext_Additional}', "");
    Error('\p{Block=:=-Latin_EXTENDED_B}');
    Error('\P{Block=:=-Latin_EXTENDED_B}');
    Expect(1, 591, '\p{Block=:\ALatin_Extended_B\z:}', "");;
    Expect(0, 592, '\p{Block=:\ALatin_Extended_B\z:}', "");;
    Expect(1, 591, '\p{Block=latinextendedb}', "");
    Expect(0, 591, '\p{^Block=latinextendedb}', "");
    Expect(0, 591, '\P{Block=latinextendedb}', "");
    Expect(1, 591, '\P{^Block=latinextendedb}', "");
    Expect(0, 592, '\p{Block=latinextendedb}', "");
    Expect(1, 592, '\p{^Block=latinextendedb}', "");
    Expect(1, 592, '\P{Block=latinextendedb}', "");
    Expect(0, 592, '\P{^Block=latinextendedb}', "");
    Expect(1, 591, '\p{Block=:\Alatinextendedb\z:}', "");;
    Expect(0, 592, '\p{Block=:\Alatinextendedb\z:}', "");;
    Expect(1, 591, '\p{Block=_Latin_Extended_B}', "");
    Expect(0, 591, '\p{^Block=_Latin_Extended_B}', "");
    Expect(0, 591, '\P{Block=_Latin_Extended_B}', "");
    Expect(1, 591, '\P{^Block=_Latin_Extended_B}', "");
    Expect(0, 592, '\p{Block=_Latin_Extended_B}', "");
    Expect(1, 592, '\p{^Block=_Latin_Extended_B}', "");
    Expect(1, 592, '\P{Block=_Latin_Extended_B}', "");
    Expect(0, 592, '\P{^Block=_Latin_Extended_B}', "");
    Error('\p{Blk=:=	LATIN_ext_B}');
    Error('\P{Blk=:=	LATIN_ext_B}');
    Expect(1, 591, '\p{Blk=:\ALatin_Ext_B\z:}', "");;
    Expect(0, 592, '\p{Blk=:\ALatin_Ext_B\z:}', "");;
    Expect(1, 591, '\p{Blk=latinextb}', "");
    Expect(0, 591, '\p{^Blk=latinextb}', "");
    Expect(0, 591, '\P{Blk=latinextb}', "");
    Expect(1, 591, '\P{^Blk=latinextb}', "");
    Expect(0, 592, '\p{Blk=latinextb}', "");
    Expect(1, 592, '\p{^Blk=latinextb}', "");
    Expect(1, 592, '\P{Blk=latinextb}', "");
    Expect(0, 592, '\P{^Blk=latinextb}', "");
    Expect(1, 591, '\p{Blk=:\Alatinextb\z:}', "");;
    Expect(0, 592, '\p{Blk=:\Alatinextb\z:}', "");;
    Expect(1, 591, '\p{Blk=_	Latin_Ext_B}', "");
    Expect(0, 591, '\p{^Blk=_	Latin_Ext_B}', "");
    Expect(0, 591, '\P{Blk=_	Latin_Ext_B}', "");
    Expect(1, 591, '\P{^Blk=_	Latin_Ext_B}', "");
    Expect(0, 592, '\p{Blk=_	Latin_Ext_B}', "");
    Expect(1, 592, '\p{^Blk=_	Latin_Ext_B}', "");
    Expect(1, 592, '\P{Blk=_	Latin_Ext_B}', "");
    Expect(0, 592, '\P{^Blk=_	Latin_Ext_B}', "");
    Error('\p{Is_Block=:= _latin_EXTENDED_B}');
    Error('\P{Is_Block=:= _latin_EXTENDED_B}');
    Expect(1, 591, '\p{Is_Block=latinextendedb}', "");
    Expect(0, 591, '\p{^Is_Block=latinextendedb}', "");
    Expect(0, 591, '\P{Is_Block=latinextendedb}', "");
    Expect(1, 591, '\P{^Is_Block=latinextendedb}', "");
    Expect(0, 592, '\p{Is_Block=latinextendedb}', "");
    Expect(1, 592, '\p{^Is_Block=latinextendedb}', "");
    Expect(1, 592, '\P{Is_Block=latinextendedb}', "");
    Expect(0, 592, '\P{^Is_Block=latinextendedb}', "");
    Expect(1, 591, '\p{Is_Block=_	latin_extended_B}', "");
    Expect(0, 591, '\p{^Is_Block=_	latin_extended_B}', "");
    Expect(0, 591, '\P{Is_Block=_	latin_extended_B}', "");
    Expect(1, 591, '\P{^Is_Block=_	latin_extended_B}', "");
    Expect(0, 592, '\p{Is_Block=_	latin_extended_B}', "");
    Expect(1, 592, '\p{^Is_Block=_	latin_extended_B}', "");
    Expect(1, 592, '\P{Is_Block=_	latin_extended_B}', "");
    Expect(0, 592, '\P{^Is_Block=_	latin_extended_B}', "");
    Error('\p{Is_Blk=-LATIN_Ext_B:=}');
    Error('\P{Is_Blk=-LATIN_Ext_B:=}');
    Expect(1, 591, '\p{Is_Blk: latinextb}', "");
    Expect(0, 591, '\p{^Is_Blk: latinextb}', "");
    Expect(0, 591, '\P{Is_Blk: latinextb}', "");
    Expect(1, 591, '\P{^Is_Blk: latinextb}', "");
    Expect(0, 592, '\p{Is_Blk: latinextb}', "");
    Expect(1, 592, '\p{^Is_Blk: latinextb}', "");
    Expect(1, 592, '\P{Is_Blk: latinextb}', "");
    Expect(0, 592, '\P{^Is_Blk: latinextb}', "");
    Expect(1, 591, '\p{Is_Blk=- Latin_Ext_B}', "");
    Expect(0, 591, '\p{^Is_Blk=- Latin_Ext_B}', "");
    Expect(0, 591, '\P{Is_Blk=- Latin_Ext_B}', "");
    Expect(1, 591, '\P{^Is_Blk=- Latin_Ext_B}', "");
    Expect(0, 592, '\p{Is_Blk=- Latin_Ext_B}', "");
    Expect(1, 592, '\p{^Is_Blk=- Latin_Ext_B}', "");
    Expect(1, 592, '\P{Is_Blk=- Latin_Ext_B}', "");
    Expect(0, 592, '\P{^Is_Blk=- Latin_Ext_B}', "");
    Error('\p{Block: /a/Latin_extended_C}');
    Error('\P{Block: /a/Latin_extended_C}');
    Expect(1, 11391, '\p{Block=:\ALatin_Extended_C\z:}', "");;
    Expect(0, 11392, '\p{Block=:\ALatin_Extended_C\z:}', "");;
    Expect(1, 11391, '\p{Block=latinextendedc}', "");
    Expect(0, 11391, '\p{^Block=latinextendedc}', "");
    Expect(0, 11391, '\P{Block=latinextendedc}', "");
    Expect(1, 11391, '\P{^Block=latinextendedc}', "");
    Expect(0, 11392, '\p{Block=latinextendedc}', "");
    Expect(1, 11392, '\p{^Block=latinextendedc}', "");
    Expect(1, 11392, '\P{Block=latinextendedc}', "");
    Expect(0, 11392, '\P{^Block=latinextendedc}', "");
    Expect(1, 11391, '\p{Block=:\Alatinextendedc\z:}', "");;
    Expect(0, 11392, '\p{Block=:\Alatinextendedc\z:}', "");;
    Expect(1, 11391, '\p{Block=_	Latin_extended_C}', "");
    Expect(0, 11391, '\p{^Block=_	Latin_extended_C}', "");
    Expect(0, 11391, '\P{Block=_	Latin_extended_C}', "");
    Expect(1, 11391, '\P{^Block=_	Latin_extended_C}', "");
    Expect(0, 11392, '\p{Block=_	Latin_extended_C}', "");
    Expect(1, 11392, '\p{^Block=_	Latin_extended_C}', "");
    Expect(1, 11392, '\P{Block=_	Latin_extended_C}', "");
    Expect(0, 11392, '\P{^Block=_	Latin_extended_C}', "");
    Error('\p{Blk= 	Latin_Ext_C/a/}');
    Error('\P{Blk= 	Latin_Ext_C/a/}');
    Expect(1, 11391, '\p{Blk=:\ALatin_Ext_C\z:}', "");;
    Expect(0, 11392, '\p{Blk=:\ALatin_Ext_C\z:}', "");;
    Expect(1, 11391, '\p{Blk=latinextc}', "");
    Expect(0, 11391, '\p{^Blk=latinextc}', "");
    Expect(0, 11391, '\P{Blk=latinextc}', "");
    Expect(1, 11391, '\P{^Blk=latinextc}', "");
    Expect(0, 11392, '\p{Blk=latinextc}', "");
    Expect(1, 11392, '\p{^Blk=latinextc}', "");
    Expect(1, 11392, '\P{Blk=latinextc}', "");
    Expect(0, 11392, '\P{^Blk=latinextc}', "");
    Expect(1, 11391, '\p{Blk=:\Alatinextc\z:}', "");;
    Expect(0, 11392, '\p{Blk=:\Alatinextc\z:}', "");;
    Expect(1, 11391, '\p{Blk:   	LATIN_Ext_C}', "");
    Expect(0, 11391, '\p{^Blk:   	LATIN_Ext_C}', "");
    Expect(0, 11391, '\P{Blk:   	LATIN_Ext_C}', "");
    Expect(1, 11391, '\P{^Blk:   	LATIN_Ext_C}', "");
    Expect(0, 11392, '\p{Blk:   	LATIN_Ext_C}', "");
    Expect(1, 11392, '\p{^Blk:   	LATIN_Ext_C}', "");
    Expect(1, 11392, '\P{Blk:   	LATIN_Ext_C}', "");
    Expect(0, 11392, '\P{^Blk:   	LATIN_Ext_C}', "");
    Error('\p{Is_Block=/a/	LATIN_Extended_C}');
    Error('\P{Is_Block=/a/	LATIN_Extended_C}');
    Expect(1, 11391, '\p{Is_Block=latinextendedc}', "");
    Expect(0, 11391, '\p{^Is_Block=latinextendedc}', "");
    Expect(0, 11391, '\P{Is_Block=latinextendedc}', "");
    Expect(1, 11391, '\P{^Is_Block=latinextendedc}', "");
    Expect(0, 11392, '\p{Is_Block=latinextendedc}', "");
    Expect(1, 11392, '\p{^Is_Block=latinextendedc}', "");
    Expect(1, 11392, '\P{Is_Block=latinextendedc}', "");
    Expect(0, 11392, '\P{^Is_Block=latinextendedc}', "");
    Expect(1, 11391, '\p{Is_Block: _latin_Extended_c}', "");
    Expect(0, 11391, '\p{^Is_Block: _latin_Extended_c}', "");
    Expect(0, 11391, '\P{Is_Block: _latin_Extended_c}', "");
    Expect(1, 11391, '\P{^Is_Block: _latin_Extended_c}', "");
    Expect(0, 11392, '\p{Is_Block: _latin_Extended_c}', "");
    Expect(1, 11392, '\p{^Is_Block: _latin_Extended_c}', "");
    Expect(1, 11392, '\P{Is_Block: _latin_Extended_c}', "");
    Expect(0, 11392, '\P{^Is_Block: _latin_Extended_c}', "");
    Error('\p{Is_Blk=-Latin_ext_C:=}');
    Error('\P{Is_Blk=-Latin_ext_C:=}');
    Expect(1, 11391, '\p{Is_Blk=latinextc}', "");
    Expect(0, 11391, '\p{^Is_Blk=latinextc}', "");
    Expect(0, 11391, '\P{Is_Blk=latinextc}', "");
    Expect(1, 11391, '\P{^Is_Blk=latinextc}', "");
    Expect(0, 11392, '\p{Is_Blk=latinextc}', "");
    Expect(1, 11392, '\p{^Is_Blk=latinextc}', "");
    Expect(1, 11392, '\P{Is_Blk=latinextc}', "");
    Expect(0, 11392, '\P{^Is_Blk=latinextc}', "");
    Expect(1, 11391, '\p{Is_Blk=- latin_EXT_C}', "");
    Expect(0, 11391, '\p{^Is_Blk=- latin_EXT_C}', "");
    Expect(0, 11391, '\P{Is_Blk=- latin_EXT_C}', "");
    Expect(1, 11391, '\P{^Is_Blk=- latin_EXT_C}', "");
    Expect(0, 11392, '\p{Is_Blk=- latin_EXT_C}', "");
    Expect(1, 11392, '\p{^Is_Blk=- latin_EXT_C}', "");
    Expect(1, 11392, '\P{Is_Blk=- latin_EXT_C}', "");
    Expect(0, 11392, '\P{^Is_Blk=- latin_EXT_C}', "");
    Error('\p{Block=:=	latin_Extended_D}');
    Error('\P{Block=:=	latin_Extended_D}');
    Expect(1, 43007, '\p{Block=:\ALatin_Extended_D\z:}', "");;
    Expect(0, 43008, '\p{Block=:\ALatin_Extended_D\z:}', "");;
    Expect(1, 43007, '\p{Block=latinextendedd}', "");
    Expect(0, 43007, '\p{^Block=latinextendedd}', "");
    Expect(0, 43007, '\P{Block=latinextendedd}', "");
    Expect(1, 43007, '\P{^Block=latinextendedd}', "");
    Expect(0, 43008, '\p{Block=latinextendedd}', "");
    Expect(1, 43008, '\p{^Block=latinextendedd}', "");
    Expect(1, 43008, '\P{Block=latinextendedd}', "");
    Expect(0, 43008, '\P{^Block=latinextendedd}', "");
    Expect(1, 43007, '\p{Block=:\Alatinextendedd\z:}', "");;
    Expect(0, 43008, '\p{Block=:\Alatinextendedd\z:}', "");;
    Expect(1, 43007, '\p{Block=_Latin_extended_D}', "");
    Expect(0, 43007, '\p{^Block=_Latin_extended_D}', "");
    Expect(0, 43007, '\P{Block=_Latin_extended_D}', "");
    Expect(1, 43007, '\P{^Block=_Latin_extended_D}', "");
    Expect(0, 43008, '\p{Block=_Latin_extended_D}', "");
    Expect(1, 43008, '\p{^Block=_Latin_extended_D}', "");
    Expect(1, 43008, '\P{Block=_Latin_extended_D}', "");
    Expect(0, 43008, '\P{^Block=_Latin_extended_D}', "");
    Error('\p{Blk= LATIN_EXT_D:=}');
    Error('\P{Blk= LATIN_EXT_D:=}');
    Expect(1, 43007, '\p{Blk=:\ALatin_Ext_D\z:}', "");;
    Expect(0, 43008, '\p{Blk=:\ALatin_Ext_D\z:}', "");;
    Expect(1, 43007, '\p{Blk=latinextd}', "");
    Expect(0, 43007, '\p{^Blk=latinextd}', "");
    Expect(0, 43007, '\P{Blk=latinextd}', "");
    Expect(1, 43007, '\P{^Blk=latinextd}', "");
    Expect(0, 43008, '\p{Blk=latinextd}', "");
    Expect(1, 43008, '\p{^Blk=latinextd}', "");
    Expect(1, 43008, '\P{Blk=latinextd}', "");
    Expect(0, 43008, '\P{^Blk=latinextd}', "");
    Expect(1, 43007, '\p{Blk=:\Alatinextd\z:}', "");;
    Expect(0, 43008, '\p{Blk=:\Alatinextd\z:}', "");;
    Expect(1, 43007, '\p{Blk= -Latin_Ext_D}', "");
    Expect(0, 43007, '\p{^Blk= -Latin_Ext_D}', "");
    Expect(0, 43007, '\P{Blk= -Latin_Ext_D}', "");
    Expect(1, 43007, '\P{^Blk= -Latin_Ext_D}', "");
    Expect(0, 43008, '\p{Blk= -Latin_Ext_D}', "");
    Expect(1, 43008, '\p{^Blk= -Latin_Ext_D}', "");
    Expect(1, 43008, '\P{Blk= -Latin_Ext_D}', "");
    Expect(0, 43008, '\P{^Blk= -Latin_Ext_D}', "");
    Error('\p{Is_Block=__LATIN_EXTENDED_d:=}');
    Error('\P{Is_Block=__LATIN_EXTENDED_d:=}');
    Expect(1, 43007, '\p{Is_Block=latinextendedd}', "");
    Expect(0, 43007, '\p{^Is_Block=latinextendedd}', "");
    Expect(0, 43007, '\P{Is_Block=latinextendedd}', "");
    Expect(1, 43007, '\P{^Is_Block=latinextendedd}', "");
    Expect(0, 43008, '\p{Is_Block=latinextendedd}', "");
    Expect(1, 43008, '\p{^Is_Block=latinextendedd}', "");
    Expect(1, 43008, '\P{Is_Block=latinextendedd}', "");
    Expect(0, 43008, '\P{^Is_Block=latinextendedd}', "");
    Expect(1, 43007, '\p{Is_Block=-	LATIN_extended_D}', "");
    Expect(0, 43007, '\p{^Is_Block=-	LATIN_extended_D}', "");
    Expect(0, 43007, '\P{Is_Block=-	LATIN_extended_D}', "");
    Expect(1, 43007, '\P{^Is_Block=-	LATIN_extended_D}', "");
    Expect(0, 43008, '\p{Is_Block=-	LATIN_extended_D}', "");
    Expect(1, 43008, '\p{^Is_Block=-	LATIN_extended_D}', "");
    Expect(1, 43008, '\P{Is_Block=-	LATIN_extended_D}', "");
    Expect(0, 43008, '\P{^Is_Block=-	LATIN_extended_D}', "");
    Error('\p{Is_Blk=	:=latin_Ext_d}');
    Error('\P{Is_Blk=	:=latin_Ext_d}');
    Expect(1, 43007, '\p{Is_Blk=latinextd}', "");
    Expect(0, 43007, '\p{^Is_Blk=latinextd}', "");
    Expect(0, 43007, '\P{Is_Blk=latinextd}', "");
    Expect(1, 43007, '\P{^Is_Blk=latinextd}', "");
    Expect(0, 43008, '\p{Is_Blk=latinextd}', "");
    Expect(1, 43008, '\p{^Is_Blk=latinextd}', "");
    Expect(1, 43008, '\P{Is_Blk=latinextd}', "");
    Expect(0, 43008, '\P{^Is_Blk=latinextd}', "");
    Expect(1, 43007, '\p{Is_Blk:	 LATIN_ext_D}', "");
    Expect(0, 43007, '\p{^Is_Blk:	 LATIN_ext_D}', "");
    Expect(0, 43007, '\P{Is_Blk:	 LATIN_ext_D}', "");
    Expect(1, 43007, '\P{^Is_Blk:	 LATIN_ext_D}', "");
    Expect(0, 43008, '\p{Is_Blk:	 LATIN_ext_D}', "");
    Expect(1, 43008, '\p{^Is_Blk:	 LATIN_ext_D}', "");
    Expect(1, 43008, '\P{Is_Blk:	 LATIN_ext_D}', "");
    Expect(0, 43008, '\P{^Is_Blk:	 LATIN_ext_D}', "");
    Error('\p{Block=:=-Latin_EXTENDED_e}');
    Error('\P{Block=:=-Latin_EXTENDED_e}');
    Expect(1, 43887, '\p{Block=:\ALatin_Extended_E\z:}', "");;
    Expect(0, 43888, '\p{Block=:\ALatin_Extended_E\z:}', "");;
    Expect(1, 43887, '\p{Block=latinextendede}', "");
    Expect(0, 43887, '\p{^Block=latinextendede}', "");
    Expect(0, 43887, '\P{Block=latinextendede}', "");
    Expect(1, 43887, '\P{^Block=latinextendede}', "");
    Expect(0, 43888, '\p{Block=latinextendede}', "");
    Expect(1, 43888, '\p{^Block=latinextendede}', "");
    Expect(1, 43888, '\P{Block=latinextendede}', "");
    Expect(0, 43888, '\P{^Block=latinextendede}', "");
    Expect(1, 43887, '\p{Block=:\Alatinextendede\z:}', "");;
    Expect(0, 43888, '\p{Block=:\Alatinextendede\z:}', "");;
    Expect(1, 43887, '\p{Block=_-Latin_EXTENDED_E}', "");
    Expect(0, 43887, '\p{^Block=_-Latin_EXTENDED_E}', "");
    Expect(0, 43887, '\P{Block=_-Latin_EXTENDED_E}', "");
    Expect(1, 43887, '\P{^Block=_-Latin_EXTENDED_E}', "");
    Expect(0, 43888, '\p{Block=_-Latin_EXTENDED_E}', "");
    Expect(1, 43888, '\p{^Block=_-Latin_EXTENDED_E}', "");
    Expect(1, 43888, '\P{Block=_-Latin_EXTENDED_E}', "");
    Expect(0, 43888, '\P{^Block=_-Latin_EXTENDED_E}', "");
    Error('\p{Blk=/a/ Latin_EXT_E}');
    Error('\P{Blk=/a/ Latin_EXT_E}');
    Expect(1, 43887, '\p{Blk=:\ALatin_Ext_E\z:}', "");;
    Expect(0, 43888, '\p{Blk=:\ALatin_Ext_E\z:}', "");;
    Expect(1, 43887, '\p{Blk=latinexte}', "");
    Expect(0, 43887, '\p{^Blk=latinexte}', "");
    Expect(0, 43887, '\P{Blk=latinexte}', "");
    Expect(1, 43887, '\P{^Blk=latinexte}', "");
    Expect(0, 43888, '\p{Blk=latinexte}', "");
    Expect(1, 43888, '\p{^Blk=latinexte}', "");
    Expect(1, 43888, '\P{Blk=latinexte}', "");
    Expect(0, 43888, '\P{^Blk=latinexte}', "");
    Expect(1, 43887, '\p{Blk=:\Alatinexte\z:}', "");;
    Expect(0, 43888, '\p{Blk=:\Alatinexte\z:}', "");;
    Expect(1, 43887, '\p{Blk=_ LATIN_ext_e}', "");
    Expect(0, 43887, '\p{^Blk=_ LATIN_ext_e}', "");
    Expect(0, 43887, '\P{Blk=_ LATIN_ext_e}', "");
    Expect(1, 43887, '\P{^Blk=_ LATIN_ext_e}', "");
    Expect(0, 43888, '\p{Blk=_ LATIN_ext_e}', "");
    Expect(1, 43888, '\p{^Blk=_ LATIN_ext_e}', "");
    Expect(1, 43888, '\P{Blk=_ LATIN_ext_e}', "");
    Expect(0, 43888, '\P{^Blk=_ LATIN_ext_e}', "");
    Error('\p{Is_Block=/a/--LATIN_EXTENDED_E}');
    Error('\P{Is_Block=/a/--LATIN_EXTENDED_E}');
    Expect(1, 43887, '\p{Is_Block: latinextendede}', "");
    Expect(0, 43887, '\p{^Is_Block: latinextendede}', "");
    Expect(0, 43887, '\P{Is_Block: latinextendede}', "");
    Expect(1, 43887, '\P{^Is_Block: latinextendede}', "");
    Expect(0, 43888, '\p{Is_Block: latinextendede}', "");
    Expect(1, 43888, '\p{^Is_Block: latinextendede}', "");
    Expect(1, 43888, '\P{Is_Block: latinextendede}', "");
    Expect(0, 43888, '\P{^Is_Block: latinextendede}', "");
    Expect(1, 43887, '\p{Is_Block=--Latin_extended_E}', "");
    Expect(0, 43887, '\p{^Is_Block=--Latin_extended_E}', "");
    Expect(0, 43887, '\P{Is_Block=--Latin_extended_E}', "");
    Expect(1, 43887, '\P{^Is_Block=--Latin_extended_E}', "");
    Expect(0, 43888, '\p{Is_Block=--Latin_extended_E}', "");
    Expect(1, 43888, '\p{^Is_Block=--Latin_extended_E}', "");
    Expect(1, 43888, '\P{Is_Block=--Latin_extended_E}', "");
    Expect(0, 43888, '\P{^Is_Block=--Latin_extended_E}', "");
    Error('\p{Is_Blk=-/a/latin_EXT_E}');
    Error('\P{Is_Blk=-/a/latin_EXT_E}');
    Expect(1, 43887, '\p{Is_Blk=latinexte}', "");
    Expect(0, 43887, '\p{^Is_Blk=latinexte}', "");
    Expect(0, 43887, '\P{Is_Blk=latinexte}', "");
    Expect(1, 43887, '\P{^Is_Blk=latinexte}', "");
    Expect(0, 43888, '\p{Is_Blk=latinexte}', "");
    Expect(1, 43888, '\p{^Is_Blk=latinexte}', "");
    Expect(1, 43888, '\P{Is_Blk=latinexte}', "");
    Expect(0, 43888, '\P{^Is_Blk=latinexte}', "");
    Expect(1, 43887, '\p{Is_Blk:-LATIN_Ext_E}', "");
    Expect(0, 43887, '\p{^Is_Blk:-LATIN_Ext_E}', "");
    Expect(0, 43887, '\P{Is_Blk:-LATIN_Ext_E}', "");
    Expect(1, 43887, '\P{^Is_Blk:-LATIN_Ext_E}', "");
    Expect(0, 43888, '\p{Is_Blk:-LATIN_Ext_E}', "");
    Expect(1, 43888, '\p{^Is_Blk:-LATIN_Ext_E}', "");
    Expect(1, 43888, '\P{Is_Blk:-LATIN_Ext_E}', "");
    Expect(0, 43888, '\P{^Is_Blk:-LATIN_Ext_E}', "");
    Error('\p{Block=:=_Lepcha}');
    Error('\P{Block=:=_Lepcha}');
    Expect(1, 7247, '\p{Block=:\ALepcha\z:}', "");;
    Expect(0, 7248, '\p{Block=:\ALepcha\z:}', "");;
    Expect(1, 7247, '\p{Block=lepcha}', "");
    Expect(0, 7247, '\p{^Block=lepcha}', "");
    Expect(0, 7247, '\P{Block=lepcha}', "");
    Expect(1, 7247, '\P{^Block=lepcha}', "");
    Expect(0, 7248, '\p{Block=lepcha}', "");
    Expect(1, 7248, '\p{^Block=lepcha}', "");
    Expect(1, 7248, '\P{Block=lepcha}', "");
    Expect(0, 7248, '\P{^Block=lepcha}', "");
    Expect(1, 7247, '\p{Block=:\Alepcha\z:}', "");;
    Expect(0, 7248, '\p{Block=:\Alepcha\z:}', "");;
    Expect(1, 7247, '\p{Block=_-Lepcha}', "");
    Expect(0, 7247, '\p{^Block=_-Lepcha}', "");
    Expect(0, 7247, '\P{Block=_-Lepcha}', "");
    Expect(1, 7247, '\P{^Block=_-Lepcha}', "");
    Expect(0, 7248, '\p{Block=_-Lepcha}', "");
    Expect(1, 7248, '\p{^Block=_-Lepcha}', "");
    Expect(1, 7248, '\P{Block=_-Lepcha}', "");
    Expect(0, 7248, '\P{^Block=_-Lepcha}', "");
    Error('\p{Blk=:=_LEPCHA}');
    Error('\P{Blk=:=_LEPCHA}');
    Expect(1, 7247, '\p{Blk=:\ALepcha\z:}', "");;
    Expect(0, 7248, '\p{Blk=:\ALepcha\z:}', "");;
    Expect(1, 7247, '\p{Blk=lepcha}', "");
    Expect(0, 7247, '\p{^Blk=lepcha}', "");
    Expect(0, 7247, '\P{Blk=lepcha}', "");
    Expect(1, 7247, '\P{^Blk=lepcha}', "");
    Expect(0, 7248, '\p{Blk=lepcha}', "");
    Expect(1, 7248, '\p{^Blk=lepcha}', "");
    Expect(1, 7248, '\P{Blk=lepcha}', "");
    Expect(0, 7248, '\P{^Blk=lepcha}', "");
    Expect(1, 7247, '\p{Blk=:\Alepcha\z:}', "");;
    Expect(0, 7248, '\p{Blk=:\Alepcha\z:}', "");;
    Expect(1, 7247, '\p{Blk= LEPCHA}', "");
    Expect(0, 7247, '\p{^Blk= LEPCHA}', "");
    Expect(0, 7247, '\P{Blk= LEPCHA}', "");
    Expect(1, 7247, '\P{^Blk= LEPCHA}', "");
    Expect(0, 7248, '\p{Blk= LEPCHA}', "");
    Expect(1, 7248, '\p{^Blk= LEPCHA}', "");
    Expect(1, 7248, '\P{Blk= LEPCHA}', "");
    Expect(0, 7248, '\P{^Blk= LEPCHA}', "");
    Error('\p{Is_Block= Lepcha:=}');
    Error('\P{Is_Block= Lepcha:=}');
    Expect(1, 7247, '\p{Is_Block=lepcha}', "");
    Expect(0, 7247, '\p{^Is_Block=lepcha}', "");
    Expect(0, 7247, '\P{Is_Block=lepcha}', "");
    Expect(1, 7247, '\P{^Is_Block=lepcha}', "");
    Expect(0, 7248, '\p{Is_Block=lepcha}', "");
    Expect(1, 7248, '\p{^Is_Block=lepcha}', "");
    Expect(1, 7248, '\P{Is_Block=lepcha}', "");
    Expect(0, 7248, '\P{^Is_Block=lepcha}', "");
    Expect(1, 7247, '\p{Is_Block=-	Lepcha}', "");
    Expect(0, 7247, '\p{^Is_Block=-	Lepcha}', "");
    Expect(0, 7247, '\P{Is_Block=-	Lepcha}', "");
    Expect(1, 7247, '\P{^Is_Block=-	Lepcha}', "");
    Expect(0, 7248, '\p{Is_Block=-	Lepcha}', "");
    Expect(1, 7248, '\p{^Is_Block=-	Lepcha}', "");
    Expect(1, 7248, '\P{Is_Block=-	Lepcha}', "");
    Expect(0, 7248, '\P{^Is_Block=-	Lepcha}', "");
    Error('\p{Is_Blk=:=-	Lepcha}');
    Error('\P{Is_Blk=:=-	Lepcha}');
    Expect(1, 7247, '\p{Is_Blk=lepcha}', "");
    Expect(0, 7247, '\p{^Is_Blk=lepcha}', "");
    Expect(0, 7247, '\P{Is_Blk=lepcha}', "");
    Expect(1, 7247, '\P{^Is_Blk=lepcha}', "");
    Expect(0, 7248, '\p{Is_Blk=lepcha}', "");
    Expect(1, 7248, '\p{^Is_Blk=lepcha}', "");
    Expect(1, 7248, '\P{Is_Blk=lepcha}', "");
    Expect(0, 7248, '\P{^Is_Blk=lepcha}', "");
    Error('\p{Block:   /a/ -LETTERLIKE_SYMBOLS}');
    Error('\P{Block:   /a/ -LETTERLIKE_SYMBOLS}');
    Expect(1, 8527, '\p{Block=:\ALetterlike_Symbols\z:}', "");;
    Expect(0, 8528, '\p{Block=:\ALetterlike_Symbols\z:}', "");;
    Expect(1, 8527, '\p{Block:letterlikesymbols}', "");
    Expect(0, 8527, '\p{^Block:letterlikesymbols}', "");
    Expect(0, 8527, '\P{Block:letterlikesymbols}', "");
    Expect(1, 8527, '\P{^Block:letterlikesymbols}', "");
    Expect(0, 8528, '\p{Block:letterlikesymbols}', "");
    Expect(1, 8528, '\p{^Block:letterlikesymbols}', "");
    Expect(1, 8528, '\P{Block:letterlikesymbols}', "");
    Expect(0, 8528, '\P{^Block:letterlikesymbols}', "");
    Expect(1, 8527, '\p{Block=:\Aletterlikesymbols\z:}', "");;
    Expect(0, 8528, '\p{Block=:\Aletterlikesymbols\z:}', "");;
    Expect(1, 8527, '\p{Block:	 Letterlike_Symbols}', "");
    Expect(0, 8527, '\p{^Block:	 Letterlike_Symbols}', "");
    Expect(0, 8527, '\P{Block:	 Letterlike_Symbols}', "");
    Expect(1, 8527, '\P{^Block:	 Letterlike_Symbols}', "");
    Expect(0, 8528, '\p{Block:	 Letterlike_Symbols}', "");
    Expect(1, 8528, '\p{^Block:	 Letterlike_Symbols}', "");
    Expect(1, 8528, '\P{Block:	 Letterlike_Symbols}', "");
    Expect(0, 8528, '\P{^Block:	 Letterlike_Symbols}', "");
    Error('\p{Blk=_letterlike_symbols:=}');
    Error('\P{Blk=_letterlike_symbols:=}');
    Expect(1, 8527, '\p{Blk=:\ALetterlike_Symbols\z:}', "");;
    Expect(0, 8528, '\p{Blk=:\ALetterlike_Symbols\z:}', "");;
    Expect(1, 8527, '\p{Blk=letterlikesymbols}', "");
    Expect(0, 8527, '\p{^Blk=letterlikesymbols}', "");
    Expect(0, 8527, '\P{Blk=letterlikesymbols}', "");
    Expect(1, 8527, '\P{^Blk=letterlikesymbols}', "");
    Expect(0, 8528, '\p{Blk=letterlikesymbols}', "");
    Expect(1, 8528, '\p{^Blk=letterlikesymbols}', "");
    Expect(1, 8528, '\P{Blk=letterlikesymbols}', "");
    Expect(0, 8528, '\P{^Blk=letterlikesymbols}', "");
    Expect(1, 8527, '\p{Blk=:\Aletterlikesymbols\z:}', "");;
    Expect(0, 8528, '\p{Blk=:\Aletterlikesymbols\z:}', "");;
    Expect(1, 8527, '\p{Blk=-LETTERLIKE_Symbols}', "");
    Expect(0, 8527, '\p{^Blk=-LETTERLIKE_Symbols}', "");
    Expect(0, 8527, '\P{Blk=-LETTERLIKE_Symbols}', "");
    Expect(1, 8527, '\P{^Blk=-LETTERLIKE_Symbols}', "");
    Expect(0, 8528, '\p{Blk=-LETTERLIKE_Symbols}', "");
    Expect(1, 8528, '\p{^Blk=-LETTERLIKE_Symbols}', "");
    Expect(1, 8528, '\P{Blk=-LETTERLIKE_Symbols}', "");
    Expect(0, 8528, '\P{^Blk=-LETTERLIKE_Symbols}', "");
    Error('\p{Is_Block=:= Letterlike_Symbols}');
    Error('\P{Is_Block=:= Letterlike_Symbols}');
    Expect(1, 8527, '\p{Is_Block=letterlikesymbols}', "");
    Expect(0, 8527, '\p{^Is_Block=letterlikesymbols}', "");
    Expect(0, 8527, '\P{Is_Block=letterlikesymbols}', "");
    Expect(1, 8527, '\P{^Is_Block=letterlikesymbols}', "");
    Expect(0, 8528, '\p{Is_Block=letterlikesymbols}', "");
    Expect(1, 8528, '\p{^Is_Block=letterlikesymbols}', "");
    Expect(1, 8528, '\P{Is_Block=letterlikesymbols}', "");
    Expect(0, 8528, '\P{^Is_Block=letterlikesymbols}', "");
    Expect(1, 8527, '\p{Is_Block=_-LETTERLIKE_symbols}', "");
    Expect(0, 8527, '\p{^Is_Block=_-LETTERLIKE_symbols}', "");
    Expect(0, 8527, '\P{Is_Block=_-LETTERLIKE_symbols}', "");
    Expect(1, 8527, '\P{^Is_Block=_-LETTERLIKE_symbols}', "");
    Expect(0, 8528, '\p{Is_Block=_-LETTERLIKE_symbols}', "");
    Expect(1, 8528, '\p{^Is_Block=_-LETTERLIKE_symbols}', "");
    Expect(1, 8528, '\P{Is_Block=_-LETTERLIKE_symbols}', "");
    Expect(0, 8528, '\P{^Is_Block=_-LETTERLIKE_symbols}', "");
    Error('\p{Is_Blk=/a/ -LETTERLIKE_SYMBOLS}');
    Error('\P{Is_Blk=/a/ -LETTERLIKE_SYMBOLS}');
    Expect(1, 8527, '\p{Is_Blk=letterlikesymbols}', "");
    Expect(0, 8527, '\p{^Is_Blk=letterlikesymbols}', "");
    Expect(0, 8527, '\P{Is_Blk=letterlikesymbols}', "");
    Expect(1, 8527, '\P{^Is_Blk=letterlikesymbols}', "");
    Expect(0, 8528, '\p{Is_Blk=letterlikesymbols}', "");
    Expect(1, 8528, '\p{^Is_Blk=letterlikesymbols}', "");
    Expect(1, 8528, '\P{Is_Blk=letterlikesymbols}', "");
    Expect(0, 8528, '\P{^Is_Blk=letterlikesymbols}', "");
    Expect(1, 8527, '\p{Is_Blk=_letterlike_Symbols}', "");
    Expect(0, 8527, '\p{^Is_Blk=_letterlike_Symbols}', "");
    Expect(0, 8527, '\P{Is_Blk=_letterlike_Symbols}', "");
    Expect(1, 8527, '\P{^Is_Blk=_letterlike_Symbols}', "");
    Expect(0, 8528, '\p{Is_Blk=_letterlike_Symbols}', "");
    Expect(1, 8528, '\p{^Is_Blk=_letterlike_Symbols}', "");
    Expect(1, 8528, '\P{Is_Blk=_letterlike_Symbols}', "");
    Expect(0, 8528, '\P{^Is_Blk=_letterlike_Symbols}', "");
    Error('\p{Block=	Limbu/a/}');
    Error('\P{Block=	Limbu/a/}');
    Expect(1, 6479, '\p{Block=:\ALimbu\z:}', "");;
    Expect(0, 6480, '\p{Block=:\ALimbu\z:}', "");;
    Expect(1, 6479, '\p{Block=limbu}', "");
    Expect(0, 6479, '\p{^Block=limbu}', "");
    Expect(0, 6479, '\P{Block=limbu}', "");
    Expect(1, 6479, '\P{^Block=limbu}', "");
    Expect(0, 6480, '\p{Block=limbu}', "");
    Expect(1, 6480, '\p{^Block=limbu}', "");
    Expect(1, 6480, '\P{Block=limbu}', "");
    Expect(0, 6480, '\P{^Block=limbu}', "");
    Expect(1, 6479, '\p{Block=:\Alimbu\z:}', "");;
    Expect(0, 6480, '\p{Block=:\Alimbu\z:}', "");;
    Expect(1, 6479, '\p{Block: -Limbu}', "");
    Expect(0, 6479, '\p{^Block: -Limbu}', "");
    Expect(0, 6479, '\P{Block: -Limbu}', "");
    Expect(1, 6479, '\P{^Block: -Limbu}', "");
    Expect(0, 6480, '\p{Block: -Limbu}', "");
    Expect(1, 6480, '\p{^Block: -Limbu}', "");
    Expect(1, 6480, '\P{Block: -Limbu}', "");
    Expect(0, 6480, '\P{^Block: -Limbu}', "");
    Error('\p{Blk= Limbu:=}');
    Error('\P{Blk= Limbu:=}');
    Expect(1, 6479, '\p{Blk=:\ALimbu\z:}', "");;
    Expect(0, 6480, '\p{Blk=:\ALimbu\z:}', "");;
    Expect(1, 6479, '\p{Blk=limbu}', "");
    Expect(0, 6479, '\p{^Blk=limbu}', "");
    Expect(0, 6479, '\P{Blk=limbu}', "");
    Expect(1, 6479, '\P{^Blk=limbu}', "");
    Expect(0, 6480, '\p{Blk=limbu}', "");
    Expect(1, 6480, '\p{^Blk=limbu}', "");
    Expect(1, 6480, '\P{Blk=limbu}', "");
    Expect(0, 6480, '\P{^Blk=limbu}', "");
    Expect(1, 6479, '\p{Blk=:\Alimbu\z:}', "");;
    Expect(0, 6480, '\p{Blk=:\Alimbu\z:}', "");;
    Expect(1, 6479, '\p{Blk=		LIMBU}', "");
    Expect(0, 6479, '\p{^Blk=		LIMBU}', "");
    Expect(0, 6479, '\P{Blk=		LIMBU}', "");
    Expect(1, 6479, '\P{^Blk=		LIMBU}', "");
    Expect(0, 6480, '\p{Blk=		LIMBU}', "");
    Expect(1, 6480, '\p{^Blk=		LIMBU}', "");
    Expect(1, 6480, '\P{Blk=		LIMBU}', "");
    Expect(0, 6480, '\P{^Blk=		LIMBU}', "");
    Error('\p{Is_Block=:=		limbu}');
    Error('\P{Is_Block=:=		limbu}');
    Expect(1, 6479, '\p{Is_Block=limbu}', "");
    Expect(0, 6479, '\p{^Is_Block=limbu}', "");
    Expect(0, 6479, '\P{Is_Block=limbu}', "");
    Expect(1, 6479, '\P{^Is_Block=limbu}', "");
    Expect(0, 6480, '\p{Is_Block=limbu}', "");
    Expect(1, 6480, '\p{^Is_Block=limbu}', "");
    Expect(1, 6480, '\P{Is_Block=limbu}', "");
    Expect(0, 6480, '\P{^Is_Block=limbu}', "");
    Expect(1, 6479, '\p{Is_Block=_-Limbu}', "");
    Expect(0, 6479, '\p{^Is_Block=_-Limbu}', "");
    Expect(0, 6479, '\P{Is_Block=_-Limbu}', "");
    Expect(1, 6479, '\P{^Is_Block=_-Limbu}', "");
    Expect(0, 6480, '\p{Is_Block=_-Limbu}', "");
    Expect(1, 6480, '\p{^Is_Block=_-Limbu}', "");
    Expect(1, 6480, '\P{Is_Block=_-Limbu}', "");
    Expect(0, 6480, '\P{^Is_Block=_-Limbu}', "");
    Error('\p{Is_Blk:   _-Limbu:=}');
    Error('\P{Is_Blk:   _-Limbu:=}');
    Expect(1, 6479, '\p{Is_Blk:   limbu}', "");
    Expect(0, 6479, '\p{^Is_Blk:   limbu}', "");
    Expect(0, 6479, '\P{Is_Blk:   limbu}', "");
    Expect(1, 6479, '\P{^Is_Blk:   limbu}', "");
    Expect(0, 6480, '\p{Is_Blk:   limbu}', "");
    Expect(1, 6480, '\p{^Is_Blk:   limbu}', "");
    Expect(1, 6480, '\P{Is_Blk:   limbu}', "");
    Expect(0, 6480, '\P{^Is_Blk:   limbu}', "");
    Expect(1, 6479, '\p{Is_Blk=	_Limbu}', "");
    Expect(0, 6479, '\p{^Is_Blk=	_Limbu}', "");
    Expect(0, 6479, '\P{Is_Blk=	_Limbu}', "");
    Expect(1, 6479, '\P{^Is_Blk=	_Limbu}', "");
    Expect(0, 6480, '\p{Is_Blk=	_Limbu}', "");
    Expect(1, 6480, '\p{^Is_Blk=	_Limbu}', "");
    Expect(1, 6480, '\P{Is_Blk=	_Limbu}', "");
    Expect(0, 6480, '\P{^Is_Blk=	_Limbu}', "");
    Error('\p{Block=/a/-_Linear_A}');
    Error('\P{Block=/a/-_Linear_A}');
    Expect(1, 67455, '\p{Block=:\ALinear_A\z:}', "");;
    Expect(0, 67456, '\p{Block=:\ALinear_A\z:}', "");;
    Expect(1, 67455, '\p{Block=lineara}', "");
    Expect(0, 67455, '\p{^Block=lineara}', "");
    Expect(0, 67455, '\P{Block=lineara}', "");
    Expect(1, 67455, '\P{^Block=lineara}', "");
    Expect(0, 67456, '\p{Block=lineara}', "");
    Expect(1, 67456, '\p{^Block=lineara}', "");
    Expect(1, 67456, '\P{Block=lineara}', "");
    Expect(0, 67456, '\P{^Block=lineara}', "");
    Expect(1, 67455, '\p{Block=:\Alineara\z:}', "");;
    Expect(0, 67456, '\p{Block=:\Alineara\z:}', "");;
    Expect(1, 67455, '\p{Block:_ LINEAR_A}', "");
    Expect(0, 67455, '\p{^Block:_ LINEAR_A}', "");
    Expect(0, 67455, '\P{Block:_ LINEAR_A}', "");
    Expect(1, 67455, '\P{^Block:_ LINEAR_A}', "");
    Expect(0, 67456, '\p{Block:_ LINEAR_A}', "");
    Expect(1, 67456, '\p{^Block:_ LINEAR_A}', "");
    Expect(1, 67456, '\P{Block:_ LINEAR_A}', "");
    Expect(0, 67456, '\P{^Block:_ LINEAR_A}', "");
    Error('\p{Blk=--Linear_A:=}');
    Error('\P{Blk=--Linear_A:=}');
    Expect(1, 67455, '\p{Blk=:\ALinear_A\z:}', "");;
    Expect(0, 67456, '\p{Blk=:\ALinear_A\z:}', "");;
    Expect(1, 67455, '\p{Blk=lineara}', "");
    Expect(0, 67455, '\p{^Blk=lineara}', "");
    Expect(0, 67455, '\P{Blk=lineara}', "");
    Expect(1, 67455, '\P{^Blk=lineara}', "");
    Expect(0, 67456, '\p{Blk=lineara}', "");
    Expect(1, 67456, '\p{^Blk=lineara}', "");
    Expect(1, 67456, '\P{Blk=lineara}', "");
    Expect(0, 67456, '\P{^Blk=lineara}', "");
    Expect(1, 67455, '\p{Blk=:\Alineara\z:}', "");;
    Expect(0, 67456, '\p{Blk=:\Alineara\z:}', "");;
    Expect(1, 67455, '\p{Blk: 	 Linear_A}', "");
    Expect(0, 67455, '\p{^Blk: 	 Linear_A}', "");
    Expect(0, 67455, '\P{Blk: 	 Linear_A}', "");
    Expect(1, 67455, '\P{^Blk: 	 Linear_A}', "");
    Expect(0, 67456, '\p{Blk: 	 Linear_A}', "");
    Expect(1, 67456, '\p{^Blk: 	 Linear_A}', "");
    Expect(1, 67456, '\P{Blk: 	 Linear_A}', "");
    Expect(0, 67456, '\P{^Blk: 	 Linear_A}', "");
    Error('\p{Is_Block=:=-_Linear_A}');
    Error('\P{Is_Block=:=-_Linear_A}');
    Expect(1, 67455, '\p{Is_Block=lineara}', "");
    Expect(0, 67455, '\p{^Is_Block=lineara}', "");
    Expect(0, 67455, '\P{Is_Block=lineara}', "");
    Expect(1, 67455, '\P{^Is_Block=lineara}', "");
    Expect(0, 67456, '\p{Is_Block=lineara}', "");
    Expect(1, 67456, '\p{^Is_Block=lineara}', "");
    Expect(1, 67456, '\P{Is_Block=lineara}', "");
    Expect(0, 67456, '\P{^Is_Block=lineara}', "");
    Expect(1, 67455, '\p{Is_Block=-	linear_a}', "");
    Expect(0, 67455, '\p{^Is_Block=-	linear_a}', "");
    Expect(0, 67455, '\P{Is_Block=-	linear_a}', "");
    Expect(1, 67455, '\P{^Is_Block=-	linear_a}', "");
    Expect(0, 67456, '\p{Is_Block=-	linear_a}', "");
    Expect(1, 67456, '\p{^Is_Block=-	linear_a}', "");
    Expect(1, 67456, '\P{Is_Block=-	linear_a}', "");
    Expect(0, 67456, '\P{^Is_Block=-	linear_a}', "");
    Error('\p{Is_Blk=	/a/Linear_a}');
    Error('\P{Is_Blk=	/a/Linear_a}');
    Expect(1, 67455, '\p{Is_Blk=lineara}', "");
    Expect(0, 67455, '\p{^Is_Blk=lineara}', "");
    Expect(0, 67455, '\P{Is_Blk=lineara}', "");
    Expect(1, 67455, '\P{^Is_Blk=lineara}', "");
    Expect(0, 67456, '\p{Is_Blk=lineara}', "");
    Expect(1, 67456, '\p{^Is_Blk=lineara}', "");
    Expect(1, 67456, '\P{Is_Blk=lineara}', "");
    Expect(0, 67456, '\P{^Is_Blk=lineara}', "");
    Expect(1, 67455, '\p{Is_Blk= LINEAR_A}', "");
    Expect(0, 67455, '\p{^Is_Blk= LINEAR_A}', "");
    Expect(0, 67455, '\P{Is_Blk= LINEAR_A}', "");
    Expect(1, 67455, '\P{^Is_Blk= LINEAR_A}', "");
    Expect(0, 67456, '\p{Is_Blk= LINEAR_A}', "");
    Expect(1, 67456, '\p{^Is_Blk= LINEAR_A}', "");
    Expect(1, 67456, '\P{Is_Blk= LINEAR_A}', "");
    Expect(0, 67456, '\P{^Is_Blk= LINEAR_A}', "");
    Error('\p{Block=:=- LINEAR_B_Ideograms}');
    Error('\P{Block=:=- LINEAR_B_Ideograms}');
    Expect(1, 65791, '\p{Block=:\ALinear_B_Ideograms\z:}', "");;
    Expect(0, 65792, '\p{Block=:\ALinear_B_Ideograms\z:}', "");;
    Expect(1, 65791, '\p{Block=linearbideograms}', "");
    Expect(0, 65791, '\p{^Block=linearbideograms}', "");
    Expect(0, 65791, '\P{Block=linearbideograms}', "");
    Expect(1, 65791, '\P{^Block=linearbideograms}', "");
    Expect(0, 65792, '\p{Block=linearbideograms}', "");
    Expect(1, 65792, '\p{^Block=linearbideograms}', "");
    Expect(1, 65792, '\P{Block=linearbideograms}', "");
    Expect(0, 65792, '\P{^Block=linearbideograms}', "");
    Expect(1, 65791, '\p{Block=:\Alinearbideograms\z:}', "");;
    Expect(0, 65792, '\p{Block=:\Alinearbideograms\z:}', "");;
    Expect(1, 65791, '\p{Block=	_linear_B_IDEOGRAMS}', "");
    Expect(0, 65791, '\p{^Block=	_linear_B_IDEOGRAMS}', "");
    Expect(0, 65791, '\P{Block=	_linear_B_IDEOGRAMS}', "");
    Expect(1, 65791, '\P{^Block=	_linear_B_IDEOGRAMS}', "");
    Expect(0, 65792, '\p{Block=	_linear_B_IDEOGRAMS}', "");
    Expect(1, 65792, '\p{^Block=	_linear_B_IDEOGRAMS}', "");
    Expect(1, 65792, '\P{Block=	_linear_B_IDEOGRAMS}', "");
    Expect(0, 65792, '\P{^Block=	_linear_B_IDEOGRAMS}', "");
    Error('\p{Blk=/a/	Linear_B_Ideograms}');
    Error('\P{Blk=/a/	Linear_B_Ideograms}');
    Expect(1, 65791, '\p{Blk=:\ALinear_B_Ideograms\z:}', "");;
    Expect(0, 65792, '\p{Blk=:\ALinear_B_Ideograms\z:}', "");;
    Expect(1, 65791, '\p{Blk=linearbideograms}', "");
    Expect(0, 65791, '\p{^Blk=linearbideograms}', "");
    Expect(0, 65791, '\P{Blk=linearbideograms}', "");
    Expect(1, 65791, '\P{^Blk=linearbideograms}', "");
    Expect(0, 65792, '\p{Blk=linearbideograms}', "");
    Expect(1, 65792, '\p{^Blk=linearbideograms}', "");
    Expect(1, 65792, '\P{Blk=linearbideograms}', "");
    Expect(0, 65792, '\P{^Blk=linearbideograms}', "");
    Expect(1, 65791, '\p{Blk=:\Alinearbideograms\z:}', "");;
    Expect(0, 65792, '\p{Blk=:\Alinearbideograms\z:}', "");;
    Expect(1, 65791, '\p{Blk=--Linear_b_Ideograms}', "");
    Expect(0, 65791, '\p{^Blk=--Linear_b_Ideograms}', "");
    Expect(0, 65791, '\P{Blk=--Linear_b_Ideograms}', "");
    Expect(1, 65791, '\P{^Blk=--Linear_b_Ideograms}', "");
    Expect(0, 65792, '\p{Blk=--Linear_b_Ideograms}', "");
    Expect(1, 65792, '\p{^Blk=--Linear_b_Ideograms}', "");
    Expect(1, 65792, '\P{Blk=--Linear_b_Ideograms}', "");
    Expect(0, 65792, '\P{^Blk=--Linear_b_Ideograms}', "");
    Error('\p{Is_Block=/a/-linear_B_Ideograms}');
    Error('\P{Is_Block=/a/-linear_B_Ideograms}');
    Expect(1, 65791, '\p{Is_Block=linearbideograms}', "");
    Expect(0, 65791, '\p{^Is_Block=linearbideograms}', "");
    Expect(0, 65791, '\P{Is_Block=linearbideograms}', "");
    Expect(1, 65791, '\P{^Is_Block=linearbideograms}', "");
    Expect(0, 65792, '\p{Is_Block=linearbideograms}', "");
    Expect(1, 65792, '\p{^Is_Block=linearbideograms}', "");
    Expect(1, 65792, '\P{Is_Block=linearbideograms}', "");
    Expect(0, 65792, '\P{^Is_Block=linearbideograms}', "");
    Expect(1, 65791, '\p{Is_Block:-_Linear_B_Ideograms}', "");
    Expect(0, 65791, '\p{^Is_Block:-_Linear_B_Ideograms}', "");
    Expect(0, 65791, '\P{Is_Block:-_Linear_B_Ideograms}', "");
    Expect(1, 65791, '\P{^Is_Block:-_Linear_B_Ideograms}', "");
    Expect(0, 65792, '\p{Is_Block:-_Linear_B_Ideograms}', "");
    Expect(1, 65792, '\p{^Is_Block:-_Linear_B_Ideograms}', "");
    Expect(1, 65792, '\P{Is_Block:-_Linear_B_Ideograms}', "");
    Expect(0, 65792, '\P{^Is_Block:-_Linear_B_Ideograms}', "");
    Error('\p{Is_Blk=		LINEAR_B_Ideograms/a/}');
    Error('\P{Is_Blk=		LINEAR_B_Ideograms/a/}');
    Expect(1, 65791, '\p{Is_Blk=linearbideograms}', "");
    Expect(0, 65791, '\p{^Is_Blk=linearbideograms}', "");
    Expect(0, 65791, '\P{Is_Blk=linearbideograms}', "");
    Expect(1, 65791, '\P{^Is_Blk=linearbideograms}', "");
    Expect(0, 65792, '\p{Is_Blk=linearbideograms}', "");
    Expect(1, 65792, '\p{^Is_Blk=linearbideograms}', "");
    Expect(1, 65792, '\P{Is_Blk=linearbideograms}', "");
    Expect(0, 65792, '\P{^Is_Blk=linearbideograms}', "");
    Expect(1, 65791, '\p{Is_Blk=	Linear_b_Ideograms}', "");
    Expect(0, 65791, '\p{^Is_Blk=	Linear_b_Ideograms}', "");
    Expect(0, 65791, '\P{Is_Blk=	Linear_b_Ideograms}', "");
    Expect(1, 65791, '\P{^Is_Blk=	Linear_b_Ideograms}', "");
    Expect(0, 65792, '\p{Is_Blk=	Linear_b_Ideograms}', "");
    Expect(1, 65792, '\p{^Is_Blk=	Linear_b_Ideograms}', "");
    Expect(1, 65792, '\P{Is_Blk=	Linear_b_Ideograms}', "");
    Expect(0, 65792, '\P{^Is_Blk=	Linear_b_Ideograms}', "");
    Error('\p{Block=-:=Linear_B_SYLLABARY}');
    Error('\P{Block=-:=Linear_B_SYLLABARY}');
    Expect(1, 65663, '\p{Block=:\ALinear_B_Syllabary\z:}', "");;
    Expect(0, 65664, '\p{Block=:\ALinear_B_Syllabary\z:}', "");;
    Expect(1, 65663, '\p{Block=linearbsyllabary}', "");
    Expect(0, 65663, '\p{^Block=linearbsyllabary}', "");
    Expect(0, 65663, '\P{Block=linearbsyllabary}', "");
    Expect(1, 65663, '\P{^Block=linearbsyllabary}', "");
    Expect(0, 65664, '\p{Block=linearbsyllabary}', "");
    Expect(1, 65664, '\p{^Block=linearbsyllabary}', "");
    Expect(1, 65664, '\P{Block=linearbsyllabary}', "");
    Expect(0, 65664, '\P{^Block=linearbsyllabary}', "");
    Expect(1, 65663, '\p{Block=:\Alinearbsyllabary\z:}', "");;
    Expect(0, 65664, '\p{Block=:\Alinearbsyllabary\z:}', "");;
    Expect(1, 65663, '\p{Block=  Linear_B_Syllabary}', "");
    Expect(0, 65663, '\p{^Block=  Linear_B_Syllabary}', "");
    Expect(0, 65663, '\P{Block=  Linear_B_Syllabary}', "");
    Expect(1, 65663, '\P{^Block=  Linear_B_Syllabary}', "");
    Expect(0, 65664, '\p{Block=  Linear_B_Syllabary}', "");
    Expect(1, 65664, '\p{^Block=  Linear_B_Syllabary}', "");
    Expect(1, 65664, '\P{Block=  Linear_B_Syllabary}', "");
    Expect(0, 65664, '\P{^Block=  Linear_B_Syllabary}', "");
    Error('\p{Blk=:=_-LINEAR_B_SYLLABARY}');
    Error('\P{Blk=:=_-LINEAR_B_SYLLABARY}');
    Expect(1, 65663, '\p{Blk=:\ALinear_B_Syllabary\z:}', "");;
    Expect(0, 65664, '\p{Blk=:\ALinear_B_Syllabary\z:}', "");;
    Expect(1, 65663, '\p{Blk=linearbsyllabary}', "");
    Expect(0, 65663, '\p{^Blk=linearbsyllabary}', "");
    Expect(0, 65663, '\P{Blk=linearbsyllabary}', "");
    Expect(1, 65663, '\P{^Blk=linearbsyllabary}', "");
    Expect(0, 65664, '\p{Blk=linearbsyllabary}', "");
    Expect(1, 65664, '\p{^Blk=linearbsyllabary}', "");
    Expect(1, 65664, '\P{Blk=linearbsyllabary}', "");
    Expect(0, 65664, '\P{^Blk=linearbsyllabary}', "");
    Expect(1, 65663, '\p{Blk=:\Alinearbsyllabary\z:}', "");;
    Expect(0, 65664, '\p{Blk=:\Alinearbsyllabary\z:}', "");;
    Expect(1, 65663, '\p{Blk=		Linear_B_Syllabary}', "");
    Expect(0, 65663, '\p{^Blk=		Linear_B_Syllabary}', "");
    Expect(0, 65663, '\P{Blk=		Linear_B_Syllabary}', "");
    Expect(1, 65663, '\P{^Blk=		Linear_B_Syllabary}', "");
    Expect(0, 65664, '\p{Blk=		Linear_B_Syllabary}', "");
    Expect(1, 65664, '\p{^Blk=		Linear_B_Syllabary}', "");
    Expect(1, 65664, '\P{Blk=		Linear_B_Syllabary}', "");
    Expect(0, 65664, '\P{^Blk=		Linear_B_Syllabary}', "");
    Error('\p{Is_Block=/a/ 	linear_B_Syllabary}');
    Error('\P{Is_Block=/a/ 	linear_B_Syllabary}');
    Expect(1, 65663, '\p{Is_Block=linearbsyllabary}', "");
    Expect(0, 65663, '\p{^Is_Block=linearbsyllabary}', "");
    Expect(0, 65663, '\P{Is_Block=linearbsyllabary}', "");
    Expect(1, 65663, '\P{^Is_Block=linearbsyllabary}', "");
    Expect(0, 65664, '\p{Is_Block=linearbsyllabary}', "");
    Expect(1, 65664, '\p{^Is_Block=linearbsyllabary}', "");
    Expect(1, 65664, '\P{Is_Block=linearbsyllabary}', "");
    Expect(0, 65664, '\P{^Is_Block=linearbsyllabary}', "");
    Expect(1, 65663, '\p{Is_Block=_Linear_b_syllabary}', "");
    Expect(0, 65663, '\p{^Is_Block=_Linear_b_syllabary}', "");
    Expect(0, 65663, '\P{Is_Block=_Linear_b_syllabary}', "");
    Expect(1, 65663, '\P{^Is_Block=_Linear_b_syllabary}', "");
    Expect(0, 65664, '\p{Is_Block=_Linear_b_syllabary}', "");
    Expect(1, 65664, '\p{^Is_Block=_Linear_b_syllabary}', "");
    Expect(1, 65664, '\P{Is_Block=_Linear_b_syllabary}', "");
    Expect(0, 65664, '\P{^Is_Block=_Linear_b_syllabary}', "");
    Error('\p{Is_Blk=_-linear_b_SYLLABARY/a/}');
    Error('\P{Is_Blk=_-linear_b_SYLLABARY/a/}');
    Expect(1, 65663, '\p{Is_Blk=linearbsyllabary}', "");
    Expect(0, 65663, '\p{^Is_Blk=linearbsyllabary}', "");
    Expect(0, 65663, '\P{Is_Blk=linearbsyllabary}', "");
    Expect(1, 65663, '\P{^Is_Blk=linearbsyllabary}', "");
    Expect(0, 65664, '\p{Is_Blk=linearbsyllabary}', "");
    Expect(1, 65664, '\p{^Is_Blk=linearbsyllabary}', "");
    Expect(1, 65664, '\P{Is_Blk=linearbsyllabary}', "");
    Expect(0, 65664, '\P{^Is_Blk=linearbsyllabary}', "");
    Expect(1, 65663, '\p{Is_Blk:	 LINEAR_B_syllabary}', "");
    Expect(0, 65663, '\p{^Is_Blk:	 LINEAR_B_syllabary}', "");
    Expect(0, 65663, '\P{Is_Blk:	 LINEAR_B_syllabary}', "");
    Expect(1, 65663, '\P{^Is_Blk:	 LINEAR_B_syllabary}', "");
    Expect(0, 65664, '\p{Is_Blk:	 LINEAR_B_syllabary}', "");
    Expect(1, 65664, '\p{^Is_Blk:	 LINEAR_B_syllabary}', "");
    Expect(1, 65664, '\P{Is_Blk:	 LINEAR_B_syllabary}', "");
    Expect(0, 65664, '\P{^Is_Blk:	 LINEAR_B_syllabary}', "");
    Error('\p{Block= :=Lisu}');
    Error('\P{Block= :=Lisu}');
    Expect(1, 42239, '\p{Block=:\ALisu\z:}', "");;
    Expect(0, 42240, '\p{Block=:\ALisu\z:}', "");;
    Expect(1, 42239, '\p{Block=lisu}', "");
    Expect(0, 42239, '\p{^Block=lisu}', "");
    Expect(0, 42239, '\P{Block=lisu}', "");
    Expect(1, 42239, '\P{^Block=lisu}', "");
    Expect(0, 42240, '\p{Block=lisu}', "");
    Expect(1, 42240, '\p{^Block=lisu}', "");
    Expect(1, 42240, '\P{Block=lisu}', "");
    Expect(0, 42240, '\P{^Block=lisu}', "");
    Expect(1, 42239, '\p{Block=:\Alisu\z:}', "");;
    Expect(0, 42240, '\p{Block=:\Alisu\z:}', "");;
    Expect(1, 42239, '\p{Block=--lisu}', "");
    Expect(0, 42239, '\p{^Block=--lisu}', "");
    Expect(0, 42239, '\P{Block=--lisu}', "");
    Expect(1, 42239, '\P{^Block=--lisu}', "");
    Expect(0, 42240, '\p{Block=--lisu}', "");
    Expect(1, 42240, '\p{^Block=--lisu}', "");
    Expect(1, 42240, '\P{Block=--lisu}', "");
    Expect(0, 42240, '\P{^Block=--lisu}', "");
    Error('\p{Blk=:=	Lisu}');
    Error('\P{Blk=:=	Lisu}');
    Expect(1, 42239, '\p{Blk=:\ALisu\z:}', "");;
    Expect(0, 42240, '\p{Blk=:\ALisu\z:}', "");;
    Expect(1, 42239, '\p{Blk=lisu}', "");
    Expect(0, 42239, '\p{^Blk=lisu}', "");
    Expect(0, 42239, '\P{Blk=lisu}', "");
    Expect(1, 42239, '\P{^Blk=lisu}', "");
    Expect(0, 42240, '\p{Blk=lisu}', "");
    Expect(1, 42240, '\p{^Blk=lisu}', "");
    Expect(1, 42240, '\P{Blk=lisu}', "");
    Expect(0, 42240, '\P{^Blk=lisu}', "");
    Expect(1, 42239, '\p{Blk=:\Alisu\z:}', "");;
    Expect(0, 42240, '\p{Blk=:\Alisu\z:}', "");;
    Expect(1, 42239, '\p{Blk= 	LISU}', "");
    Expect(0, 42239, '\p{^Blk= 	LISU}', "");
    Expect(0, 42239, '\P{Blk= 	LISU}', "");
    Expect(1, 42239, '\P{^Blk= 	LISU}', "");
    Expect(0, 42240, '\p{Blk= 	LISU}', "");
    Expect(1, 42240, '\p{^Blk= 	LISU}', "");
    Expect(1, 42240, '\P{Blk= 	LISU}', "");
    Expect(0, 42240, '\P{^Blk= 	LISU}', "");
    Error('\p{Is_Block:_:=lisu}');
    Error('\P{Is_Block:_:=lisu}');
    Expect(1, 42239, '\p{Is_Block=lisu}', "");
    Expect(0, 42239, '\p{^Is_Block=lisu}', "");
    Expect(0, 42239, '\P{Is_Block=lisu}', "");
    Expect(1, 42239, '\P{^Is_Block=lisu}', "");
    Expect(0, 42240, '\p{Is_Block=lisu}', "");
    Expect(1, 42240, '\p{^Is_Block=lisu}', "");
    Expect(1, 42240, '\P{Is_Block=lisu}', "");
    Expect(0, 42240, '\P{^Is_Block=lisu}', "");
    Expect(1, 42239, '\p{Is_Block= LISU}', "");
    Expect(0, 42239, '\p{^Is_Block= LISU}', "");
    Expect(0, 42239, '\P{Is_Block= LISU}', "");
    Expect(1, 42239, '\P{^Is_Block= LISU}', "");
    Expect(0, 42240, '\p{Is_Block= LISU}', "");
    Expect(1, 42240, '\p{^Is_Block= LISU}', "");
    Expect(1, 42240, '\P{Is_Block= LISU}', "");
    Expect(0, 42240, '\P{^Is_Block= LISU}', "");
    Error('\p{Is_Blk: /a/ _Lisu}');
    Error('\P{Is_Blk: /a/ _Lisu}');
    Expect(1, 42239, '\p{Is_Blk=lisu}', "");
    Expect(0, 42239, '\p{^Is_Blk=lisu}', "");
    Expect(0, 42239, '\P{Is_Blk=lisu}', "");
    Expect(1, 42239, '\P{^Is_Blk=lisu}', "");
    Expect(0, 42240, '\p{Is_Blk=lisu}', "");
    Expect(1, 42240, '\p{^Is_Blk=lisu}', "");
    Expect(1, 42240, '\P{Is_Blk=lisu}', "");
    Expect(0, 42240, '\P{^Is_Blk=lisu}', "");
    Expect(1, 42239, '\p{Is_Blk= -lisu}', "");
    Expect(0, 42239, '\p{^Is_Blk= -lisu}', "");
    Expect(0, 42239, '\P{Is_Blk= -lisu}', "");
    Expect(1, 42239, '\P{^Is_Blk= -lisu}', "");
    Expect(0, 42240, '\p{Is_Blk= -lisu}', "");
    Expect(1, 42240, '\p{^Is_Blk= -lisu}', "");
    Expect(1, 42240, '\P{Is_Blk= -lisu}', "");
    Expect(0, 42240, '\P{^Is_Blk= -lisu}', "");
    Error('\p{Block=--Lisu_SUPPLEMENT:=}');
    Error('\P{Block=--Lisu_SUPPLEMENT:=}');
    Expect(1, 73663, '\p{Block=:\ALisu_Supplement\z:}', "");;
    Expect(0, 73664, '\p{Block=:\ALisu_Supplement\z:}', "");;
    Expect(1, 73663, '\p{Block=lisusupplement}', "");
    Expect(0, 73663, '\p{^Block=lisusupplement}', "");
    Expect(0, 73663, '\P{Block=lisusupplement}', "");
    Expect(1, 73663, '\P{^Block=lisusupplement}', "");
    Expect(0, 73664, '\p{Block=lisusupplement}', "");
    Expect(1, 73664, '\p{^Block=lisusupplement}', "");
    Expect(1, 73664, '\P{Block=lisusupplement}', "");
    Expect(0, 73664, '\P{^Block=lisusupplement}', "");
    Expect(1, 73663, '\p{Block=:\Alisusupplement\z:}', "");;
    Expect(0, 73664, '\p{Block=:\Alisusupplement\z:}', "");;
    Expect(1, 73663, '\p{Block=__Lisu_supplement}', "");
    Expect(0, 73663, '\p{^Block=__Lisu_supplement}', "");
    Expect(0, 73663, '\P{Block=__Lisu_supplement}', "");
    Expect(1, 73663, '\P{^Block=__Lisu_supplement}', "");
    Expect(0, 73664, '\p{Block=__Lisu_supplement}', "");
    Expect(1, 73664, '\p{^Block=__Lisu_supplement}', "");
    Expect(1, 73664, '\P{Block=__Lisu_supplement}', "");
    Expect(0, 73664, '\P{^Block=__Lisu_supplement}', "");
    Error('\p{Blk=		LISU_Sup/a/}');
    Error('\P{Blk=		LISU_Sup/a/}');
    Expect(1, 73663, '\p{Blk=:\ALisu_Sup\z:}', "");;
    Expect(0, 73664, '\p{Blk=:\ALisu_Sup\z:}', "");;
    Expect(1, 73663, '\p{Blk=lisusup}', "");
    Expect(0, 73663, '\p{^Blk=lisusup}', "");
    Expect(0, 73663, '\P{Blk=lisusup}', "");
    Expect(1, 73663, '\P{^Blk=lisusup}', "");
    Expect(0, 73664, '\p{Blk=lisusup}', "");
    Expect(1, 73664, '\p{^Blk=lisusup}', "");
    Expect(1, 73664, '\P{Blk=lisusup}', "");
    Expect(0, 73664, '\P{^Blk=lisusup}', "");
    Expect(1, 73663, '\p{Blk=:\Alisusup\z:}', "");;
    Expect(0, 73664, '\p{Blk=:\Alisusup\z:}', "");;
    Expect(1, 73663, '\p{Blk=	-Lisu_sup}', "");
    Expect(0, 73663, '\p{^Blk=	-Lisu_sup}', "");
    Expect(0, 73663, '\P{Blk=	-Lisu_sup}', "");
    Expect(1, 73663, '\P{^Blk=	-Lisu_sup}', "");
    Expect(0, 73664, '\p{Blk=	-Lisu_sup}', "");
    Expect(1, 73664, '\p{^Blk=	-Lisu_sup}', "");
    Expect(1, 73664, '\P{Blk=	-Lisu_sup}', "");
    Expect(0, 73664, '\P{^Blk=	-Lisu_sup}', "");
    Error('\p{Is_Block=	_Lisu_Supplement:=}');
    Error('\P{Is_Block=	_Lisu_Supplement:=}');
    Expect(1, 73663, '\p{Is_Block=lisusupplement}', "");
    Expect(0, 73663, '\p{^Is_Block=lisusupplement}', "");
    Expect(0, 73663, '\P{Is_Block=lisusupplement}', "");
    Expect(1, 73663, '\P{^Is_Block=lisusupplement}', "");
    Expect(0, 73664, '\p{Is_Block=lisusupplement}', "");
    Expect(1, 73664, '\p{^Is_Block=lisusupplement}', "");
    Expect(1, 73664, '\P{Is_Block=lisusupplement}', "");
    Expect(0, 73664, '\P{^Is_Block=lisusupplement}', "");
    Expect(1, 73663, '\p{Is_Block:_Lisu_Supplement}', "");
    Expect(0, 73663, '\p{^Is_Block:_Lisu_Supplement}', "");
    Expect(0, 73663, '\P{Is_Block:_Lisu_Supplement}', "");
    Expect(1, 73663, '\P{^Is_Block:_Lisu_Supplement}', "");
    Expect(0, 73664, '\p{Is_Block:_Lisu_Supplement}', "");
    Expect(1, 73664, '\p{^Is_Block:_Lisu_Supplement}', "");
    Expect(1, 73664, '\P{Is_Block:_Lisu_Supplement}', "");
    Expect(0, 73664, '\P{^Is_Block:_Lisu_Supplement}', "");
    Error('\p{Is_Blk=	-Lisu_Sup:=}');
    Error('\P{Is_Blk=	-Lisu_Sup:=}');
    Expect(1, 73663, '\p{Is_Blk=lisusup}', "");
    Expect(0, 73663, '\p{^Is_Blk=lisusup}', "");
    Expect(0, 73663, '\P{Is_Blk=lisusup}', "");
    Expect(1, 73663, '\P{^Is_Blk=lisusup}', "");
    Expect(0, 73664, '\p{Is_Blk=lisusup}', "");
    Expect(1, 73664, '\p{^Is_Blk=lisusup}', "");
    Expect(1, 73664, '\P{Is_Blk=lisusup}', "");
    Expect(0, 73664, '\P{^Is_Blk=lisusup}', "");
    Expect(1, 73663, '\p{Is_Blk=-_Lisu_Sup}', "");
    Expect(0, 73663, '\p{^Is_Blk=-_Lisu_Sup}', "");
    Expect(0, 73663, '\P{Is_Blk=-_Lisu_Sup}', "");
    Expect(1, 73663, '\P{^Is_Blk=-_Lisu_Sup}', "");
    Expect(0, 73664, '\p{Is_Blk=-_Lisu_Sup}', "");
    Expect(1, 73664, '\p{^Is_Blk=-_Lisu_Sup}', "");
    Expect(1, 73664, '\P{Is_Blk=-_Lisu_Sup}', "");
    Expect(0, 73664, '\P{^Is_Blk=-_Lisu_Sup}', "");
    Error('\p{Block:	:=-_low_Surrogates}');
    Error('\P{Block:	:=-_low_Surrogates}');
    Expect(1, 57343, '\p{Block=:\ALow_Surrogates\z:}', "");;
    Expect(0, 57344, '\p{Block=:\ALow_Surrogates\z:}', "");;
    Expect(1, 57343, '\p{Block=lowsurrogates}', "");
    Expect(0, 57343, '\p{^Block=lowsurrogates}', "");
    Expect(0, 57343, '\P{Block=lowsurrogates}', "");
    Expect(1, 57343, '\P{^Block=lowsurrogates}', "");
    Expect(0, 57344, '\p{Block=lowsurrogates}', "");
    Expect(1, 57344, '\p{^Block=lowsurrogates}', "");
    Expect(1, 57344, '\P{Block=lowsurrogates}', "");
    Expect(0, 57344, '\P{^Block=lowsurrogates}', "");
    Expect(1, 57343, '\p{Block=:\Alowsurrogates\z:}', "");;
    Expect(0, 57344, '\p{Block=:\Alowsurrogates\z:}', "");;
    Expect(1, 57343, '\p{Block:	_-Low_surrogates}', "");
    Expect(0, 57343, '\p{^Block:	_-Low_surrogates}', "");
    Expect(0, 57343, '\P{Block:	_-Low_surrogates}', "");
    Expect(1, 57343, '\P{^Block:	_-Low_surrogates}', "");
    Expect(0, 57344, '\p{Block:	_-Low_surrogates}', "");
    Expect(1, 57344, '\p{^Block:	_-Low_surrogates}', "");
    Expect(1, 57344, '\P{Block:	_-Low_surrogates}', "");
    Expect(0, 57344, '\P{^Block:	_-Low_surrogates}', "");
    Error('\p{Blk=-/a/Low_surrogates}');
    Error('\P{Blk=-/a/Low_surrogates}');
    Expect(1, 57343, '\p{Blk=:\ALow_Surrogates\z:}', "");;
    Expect(0, 57344, '\p{Blk=:\ALow_Surrogates\z:}', "");;
    Expect(1, 57343, '\p{Blk=lowsurrogates}', "");
    Expect(0, 57343, '\p{^Blk=lowsurrogates}', "");
    Expect(0, 57343, '\P{Blk=lowsurrogates}', "");
    Expect(1, 57343, '\P{^Blk=lowsurrogates}', "");
    Expect(0, 57344, '\p{Blk=lowsurrogates}', "");
    Expect(1, 57344, '\p{^Blk=lowsurrogates}', "");
    Expect(1, 57344, '\P{Blk=lowsurrogates}', "");
    Expect(0, 57344, '\P{^Blk=lowsurrogates}', "");
    Expect(1, 57343, '\p{Blk=:\Alowsurrogates\z:}', "");;
    Expect(0, 57344, '\p{Blk=:\Alowsurrogates\z:}', "");;
    Expect(1, 57343, '\p{Blk=  LOW_Surrogates}', "");
    Expect(0, 57343, '\p{^Blk=  LOW_Surrogates}', "");
    Expect(0, 57343, '\P{Blk=  LOW_Surrogates}', "");
    Expect(1, 57343, '\P{^Blk=  LOW_Surrogates}', "");
    Expect(0, 57344, '\p{Blk=  LOW_Surrogates}', "");
    Expect(1, 57344, '\p{^Blk=  LOW_Surrogates}', "");
    Expect(1, 57344, '\P{Blk=  LOW_Surrogates}', "");
    Expect(0, 57344, '\P{^Blk=  LOW_Surrogates}', "");
    Error('\p{Is_Block: :=_	Low_Surrogates}');
    Error('\P{Is_Block: :=_	Low_Surrogates}');
    Expect(1, 57343, '\p{Is_Block=lowsurrogates}', "");
    Expect(0, 57343, '\p{^Is_Block=lowsurrogates}', "");
    Expect(0, 57343, '\P{Is_Block=lowsurrogates}', "");
    Expect(1, 57343, '\P{^Is_Block=lowsurrogates}', "");
    Expect(0, 57344, '\p{Is_Block=lowsurrogates}', "");
    Expect(1, 57344, '\p{^Is_Block=lowsurrogates}', "");
    Expect(1, 57344, '\P{Is_Block=lowsurrogates}', "");
    Expect(0, 57344, '\P{^Is_Block=lowsurrogates}', "");
    Expect(1, 57343, '\p{Is_Block:   Low_SURROGATES}', "");
    Expect(0, 57343, '\p{^Is_Block:   Low_SURROGATES}', "");
    Expect(0, 57343, '\P{Is_Block:   Low_SURROGATES}', "");
    Expect(1, 57343, '\P{^Is_Block:   Low_SURROGATES}', "");
    Expect(0, 57344, '\p{Is_Block:   Low_SURROGATES}', "");
    Expect(1, 57344, '\p{^Is_Block:   Low_SURROGATES}', "");
    Expect(1, 57344, '\P{Is_Block:   Low_SURROGATES}', "");
    Expect(0, 57344, '\P{^Is_Block:   Low_SURROGATES}', "");
    Error('\p{Is_Blk= -Low_Surrogates/a/}');
    Error('\P{Is_Blk= -Low_Surrogates/a/}');
    Expect(1, 57343, '\p{Is_Blk=lowsurrogates}', "");
    Expect(0, 57343, '\p{^Is_Blk=lowsurrogates}', "");
    Expect(0, 57343, '\P{Is_Blk=lowsurrogates}', "");
    Expect(1, 57343, '\P{^Is_Blk=lowsurrogates}', "");
    Expect(0, 57344, '\p{Is_Blk=lowsurrogates}', "");
    Expect(1, 57344, '\p{^Is_Blk=lowsurrogates}', "");
    Expect(1, 57344, '\P{Is_Blk=lowsurrogates}', "");
    Expect(0, 57344, '\P{^Is_Blk=lowsurrogates}', "");
    Expect(1, 57343, '\p{Is_Blk=	low_Surrogates}', "");
    Expect(0, 57343, '\p{^Is_Blk=	low_Surrogates}', "");
    Expect(0, 57343, '\P{Is_Blk=	low_Surrogates}', "");
    Expect(1, 57343, '\P{^Is_Blk=	low_Surrogates}', "");
    Expect(0, 57344, '\p{Is_Blk=	low_Surrogates}', "");
    Expect(1, 57344, '\p{^Is_Blk=	low_Surrogates}', "");
    Expect(1, 57344, '\P{Is_Blk=	low_Surrogates}', "");
    Expect(0, 57344, '\P{^Is_Blk=	low_Surrogates}', "");
    Error('\p{Block=-Lycian/a/}');
    Error('\P{Block=-Lycian/a/}');
    Expect(1, 66207, '\p{Block=:\ALycian\z:}', "");;
    Expect(0, 66208, '\p{Block=:\ALycian\z:}', "");;
    Expect(1, 66207, '\p{Block=lycian}', "");
    Expect(0, 66207, '\p{^Block=lycian}', "");
    Expect(0, 66207, '\P{Block=lycian}', "");
    Expect(1, 66207, '\P{^Block=lycian}', "");
    Expect(0, 66208, '\p{Block=lycian}', "");
    Expect(1, 66208, '\p{^Block=lycian}', "");
    Expect(1, 66208, '\P{Block=lycian}', "");
    Expect(0, 66208, '\P{^Block=lycian}', "");
    Expect(1, 66207, '\p{Block=:\Alycian\z:}', "");;
    Expect(0, 66208, '\p{Block=:\Alycian\z:}', "");;
    Expect(1, 66207, '\p{Block=	Lycian}', "");
    Expect(0, 66207, '\p{^Block=	Lycian}', "");
    Expect(0, 66207, '\P{Block=	Lycian}', "");
    Expect(1, 66207, '\P{^Block=	Lycian}', "");
    Expect(0, 66208, '\p{Block=	Lycian}', "");
    Expect(1, 66208, '\p{^Block=	Lycian}', "");
    Expect(1, 66208, '\P{Block=	Lycian}', "");
    Expect(0, 66208, '\P{^Block=	Lycian}', "");
    Error('\p{Blk:-	lycian:=}');
    Error('\P{Blk:-	lycian:=}');
    Expect(1, 66207, '\p{Blk=:\ALycian\z:}', "");;
    Expect(0, 66208, '\p{Blk=:\ALycian\z:}', "");;
    Expect(1, 66207, '\p{Blk=lycian}', "");
    Expect(0, 66207, '\p{^Blk=lycian}', "");
    Expect(0, 66207, '\P{Blk=lycian}', "");
    Expect(1, 66207, '\P{^Blk=lycian}', "");
    Expect(0, 66208, '\p{Blk=lycian}', "");
    Expect(1, 66208, '\p{^Blk=lycian}', "");
    Expect(1, 66208, '\P{Blk=lycian}', "");
    Expect(0, 66208, '\P{^Blk=lycian}', "");
    Expect(1, 66207, '\p{Blk=:\Alycian\z:}', "");;
    Expect(0, 66208, '\p{Blk=:\Alycian\z:}', "");;
    Expect(1, 66207, '\p{Blk=-_lycian}', "");
    Expect(0, 66207, '\p{^Blk=-_lycian}', "");
    Expect(0, 66207, '\P{Blk=-_lycian}', "");
    Expect(1, 66207, '\P{^Blk=-_lycian}', "");
    Expect(0, 66208, '\p{Blk=-_lycian}', "");
    Expect(1, 66208, '\p{^Blk=-_lycian}', "");
    Expect(1, 66208, '\P{Blk=-_lycian}', "");
    Expect(0, 66208, '\P{^Blk=-_lycian}', "");
    Error('\p{Is_Block=:=	Lycian}');
    Error('\P{Is_Block=:=	Lycian}');
    Expect(1, 66207, '\p{Is_Block=lycian}', "");
    Expect(0, 66207, '\p{^Is_Block=lycian}', "");
    Expect(0, 66207, '\P{Is_Block=lycian}', "");
    Expect(1, 66207, '\P{^Is_Block=lycian}', "");
    Expect(0, 66208, '\p{Is_Block=lycian}', "");
    Expect(1, 66208, '\p{^Is_Block=lycian}', "");
    Expect(1, 66208, '\P{Is_Block=lycian}', "");
    Expect(0, 66208, '\P{^Is_Block=lycian}', "");
    Expect(1, 66207, '\p{Is_Block=	Lycian}', "");
    Expect(0, 66207, '\p{^Is_Block=	Lycian}', "");
    Expect(0, 66207, '\P{Is_Block=	Lycian}', "");
    Expect(1, 66207, '\P{^Is_Block=	Lycian}', "");
    Expect(0, 66208, '\p{Is_Block=	Lycian}', "");
    Expect(1, 66208, '\p{^Is_Block=	Lycian}', "");
    Expect(1, 66208, '\P{Is_Block=	Lycian}', "");
    Expect(0, 66208, '\P{^Is_Block=	Lycian}', "");
    Error('\p{Is_Blk=  Lycian/a/}');
    Error('\P{Is_Blk=  Lycian/a/}');
    Expect(1, 66207, '\p{Is_Blk=lycian}', "");
    Expect(0, 66207, '\p{^Is_Blk=lycian}', "");
    Expect(0, 66207, '\P{Is_Blk=lycian}', "");
    Expect(1, 66207, '\P{^Is_Blk=lycian}', "");
    Expect(0, 66208, '\p{Is_Blk=lycian}', "");
    Expect(1, 66208, '\p{^Is_Blk=lycian}', "");
    Expect(1, 66208, '\P{Is_Blk=lycian}', "");
    Expect(0, 66208, '\P{^Is_Blk=lycian}', "");
    Expect(1, 66207, '\p{Is_Blk=-	Lycian}', "");
    Expect(0, 66207, '\p{^Is_Blk=-	Lycian}', "");
    Expect(0, 66207, '\P{Is_Blk=-	Lycian}', "");
    Expect(1, 66207, '\P{^Is_Blk=-	Lycian}', "");
    Expect(0, 66208, '\p{Is_Blk=-	Lycian}', "");
    Expect(1, 66208, '\p{^Is_Blk=-	Lycian}', "");
    Expect(1, 66208, '\P{Is_Blk=-	Lycian}', "");
    Expect(0, 66208, '\P{^Is_Blk=-	Lycian}', "");
    Error('\p{Block=/a/_Lydian}');
    Error('\P{Block=/a/_Lydian}');
    Expect(1, 67903, '\p{Block=:\ALydian\z:}', "");;
    Expect(0, 67904, '\p{Block=:\ALydian\z:}', "");;
    Expect(1, 67903, '\p{Block=lydian}', "");
    Expect(0, 67903, '\p{^Block=lydian}', "");
    Expect(0, 67903, '\P{Block=lydian}', "");
    Expect(1, 67903, '\P{^Block=lydian}', "");
    Expect(0, 67904, '\p{Block=lydian}', "");
    Expect(1, 67904, '\p{^Block=lydian}', "");
    Expect(1, 67904, '\P{Block=lydian}', "");
    Expect(0, 67904, '\P{^Block=lydian}', "");
    Expect(1, 67903, '\p{Block=:\Alydian\z:}', "");;
    Expect(0, 67904, '\p{Block=:\Alydian\z:}', "");;
    Expect(1, 67903, '\p{Block=  LYDIAN}', "");
    Expect(0, 67903, '\p{^Block=  LYDIAN}', "");
    Expect(0, 67903, '\P{Block=  LYDIAN}', "");
    Expect(1, 67903, '\P{^Block=  LYDIAN}', "");
    Expect(0, 67904, '\p{Block=  LYDIAN}', "");
    Expect(1, 67904, '\p{^Block=  LYDIAN}', "");
    Expect(1, 67904, '\P{Block=  LYDIAN}', "");
    Expect(0, 67904, '\P{^Block=  LYDIAN}', "");
    Error('\p{Blk:	:=lydian}');
    Error('\P{Blk:	:=lydian}');
    Expect(1, 67903, '\p{Blk=:\ALydian\z:}', "");;
    Expect(0, 67904, '\p{Blk=:\ALydian\z:}', "");;
    Expect(1, 67903, '\p{Blk=lydian}', "");
    Expect(0, 67903, '\p{^Blk=lydian}', "");
    Expect(0, 67903, '\P{Blk=lydian}', "");
    Expect(1, 67903, '\P{^Blk=lydian}', "");
    Expect(0, 67904, '\p{Blk=lydian}', "");
    Expect(1, 67904, '\p{^Blk=lydian}', "");
    Expect(1, 67904, '\P{Blk=lydian}', "");
    Expect(0, 67904, '\P{^Blk=lydian}', "");
    Expect(1, 67903, '\p{Blk=:\Alydian\z:}', "");;
    Expect(0, 67904, '\p{Blk=:\Alydian\z:}', "");;
    Expect(1, 67903, '\p{Blk=	 lydian}', "");
    Expect(0, 67903, '\p{^Blk=	 lydian}', "");
    Expect(0, 67903, '\P{Blk=	 lydian}', "");
    Expect(1, 67903, '\P{^Blk=	 lydian}', "");
    Expect(0, 67904, '\p{Blk=	 lydian}', "");
    Expect(1, 67904, '\p{^Blk=	 lydian}', "");
    Expect(1, 67904, '\P{Blk=	 lydian}', "");
    Expect(0, 67904, '\P{^Blk=	 lydian}', "");
    Error('\p{Is_Block= /a/LYDIAN}');
    Error('\P{Is_Block= /a/LYDIAN}');
    Expect(1, 67903, '\p{Is_Block=lydian}', "");
    Expect(0, 67903, '\p{^Is_Block=lydian}', "");
    Expect(0, 67903, '\P{Is_Block=lydian}', "");
    Expect(1, 67903, '\P{^Is_Block=lydian}', "");
    Expect(0, 67904, '\p{Is_Block=lydian}', "");
    Expect(1, 67904, '\p{^Is_Block=lydian}', "");
    Expect(1, 67904, '\P{Is_Block=lydian}', "");
    Expect(0, 67904, '\P{^Is_Block=lydian}', "");
    Expect(1, 67903, '\p{Is_Block= -Lydian}', "");
    Expect(0, 67903, '\p{^Is_Block= -Lydian}', "");
    Expect(0, 67903, '\P{Is_Block= -Lydian}', "");
    Expect(1, 67903, '\P{^Is_Block= -Lydian}', "");
    Expect(0, 67904, '\p{Is_Block= -Lydian}', "");
    Expect(1, 67904, '\p{^Is_Block= -Lydian}', "");
    Expect(1, 67904, '\P{Is_Block= -Lydian}', "");
    Expect(0, 67904, '\P{^Is_Block= -Lydian}', "");
    Error('\p{Is_Blk:	-/a/LYDIAN}');
    Error('\P{Is_Blk:	-/a/LYDIAN}');
    Expect(1, 67903, '\p{Is_Blk: lydian}', "");
    Expect(0, 67903, '\p{^Is_Blk: lydian}', "");
    Expect(0, 67903, '\P{Is_Blk: lydian}', "");
    Expect(1, 67903, '\P{^Is_Blk: lydian}', "");
    Expect(0, 67904, '\p{Is_Blk: lydian}', "");
    Expect(1, 67904, '\p{^Is_Blk: lydian}', "");
    Expect(1, 67904, '\P{Is_Blk: lydian}', "");
    Expect(0, 67904, '\P{^Is_Blk: lydian}', "");
    Expect(1, 67903, '\p{Is_Blk=-	lydian}', "");
    Expect(0, 67903, '\p{^Is_Blk=-	lydian}', "");
    Expect(0, 67903, '\P{Is_Blk=-	lydian}', "");
    Expect(1, 67903, '\P{^Is_Blk=-	lydian}', "");
    Expect(0, 67904, '\p{Is_Blk=-	lydian}', "");
    Expect(1, 67904, '\p{^Is_Blk=-	lydian}', "");
    Expect(1, 67904, '\P{Is_Blk=-	lydian}', "");
    Expect(0, 67904, '\P{^Is_Blk=-	lydian}', "");
    Error('\p{Block= :=MAHAJANI}');
    Error('\P{Block= :=MAHAJANI}');
    Expect(1, 70015, '\p{Block=:\AMahajani\z:}', "");;
    Expect(0, 70016, '\p{Block=:\AMahajani\z:}', "");;
    Expect(1, 70015, '\p{Block=mahajani}', "");
    Expect(0, 70015, '\p{^Block=mahajani}', "");
    Expect(0, 70015, '\P{Block=mahajani}', "");
    Expect(1, 70015, '\P{^Block=mahajani}', "");
    Expect(0, 70016, '\p{Block=mahajani}', "");
    Expect(1, 70016, '\p{^Block=mahajani}', "");
    Expect(1, 70016, '\P{Block=mahajani}', "");
    Expect(0, 70016, '\P{^Block=mahajani}', "");
    Expect(1, 70015, '\p{Block=:\Amahajani\z:}', "");;
    Expect(0, 70016, '\p{Block=:\Amahajani\z:}', "");;
    Expect(1, 70015, '\p{Block= 	Mahajani}', "");
    Expect(0, 70015, '\p{^Block= 	Mahajani}', "");
    Expect(0, 70015, '\P{Block= 	Mahajani}', "");
    Expect(1, 70015, '\P{^Block= 	Mahajani}', "");
    Expect(0, 70016, '\p{Block= 	Mahajani}', "");
    Expect(1, 70016, '\p{^Block= 	Mahajani}', "");
    Expect(1, 70016, '\P{Block= 	Mahajani}', "");
    Expect(0, 70016, '\P{^Block= 	Mahajani}', "");
    Error('\p{Blk=:= MAHAJANI}');
    Error('\P{Blk=:= MAHAJANI}');
    Expect(1, 70015, '\p{Blk=:\AMahajani\z:}', "");;
    Expect(0, 70016, '\p{Blk=:\AMahajani\z:}', "");;
    Expect(1, 70015, '\p{Blk: mahajani}', "");
    Expect(0, 70015, '\p{^Blk: mahajani}', "");
    Expect(0, 70015, '\P{Blk: mahajani}', "");
    Expect(1, 70015, '\P{^Blk: mahajani}', "");
    Expect(0, 70016, '\p{Blk: mahajani}', "");
    Expect(1, 70016, '\p{^Blk: mahajani}', "");
    Expect(1, 70016, '\P{Blk: mahajani}', "");
    Expect(0, 70016, '\P{^Blk: mahajani}', "");
    Expect(1, 70015, '\p{Blk=:\Amahajani\z:}', "");;
    Expect(0, 70016, '\p{Blk=:\Amahajani\z:}', "");;
    Expect(1, 70015, '\p{Blk= 	MAHAJANI}', "");
    Expect(0, 70015, '\p{^Blk= 	MAHAJANI}', "");
    Expect(0, 70015, '\P{Blk= 	MAHAJANI}', "");
    Expect(1, 70015, '\P{^Blk= 	MAHAJANI}', "");
    Expect(0, 70016, '\p{Blk= 	MAHAJANI}', "");
    Expect(1, 70016, '\p{^Blk= 	MAHAJANI}', "");
    Expect(1, 70016, '\P{Blk= 	MAHAJANI}', "");
    Expect(0, 70016, '\P{^Blk= 	MAHAJANI}', "");
    Error('\p{Is_Block= MAHAJANI/a/}');
    Error('\P{Is_Block= MAHAJANI/a/}');
    Expect(1, 70015, '\p{Is_Block=mahajani}', "");
    Expect(0, 70015, '\p{^Is_Block=mahajani}', "");
    Expect(0, 70015, '\P{Is_Block=mahajani}', "");
    Expect(1, 70015, '\P{^Is_Block=mahajani}', "");
    Expect(0, 70016, '\p{Is_Block=mahajani}', "");
    Expect(1, 70016, '\p{^Is_Block=mahajani}', "");
    Expect(1, 70016, '\P{Is_Block=mahajani}', "");
    Expect(0, 70016, '\P{^Is_Block=mahajani}', "");
    Expect(1, 70015, '\p{Is_Block=_MAHAJANI}', "");
    Expect(0, 70015, '\p{^Is_Block=_MAHAJANI}', "");
    Expect(0, 70015, '\P{Is_Block=_MAHAJANI}', "");
    Expect(1, 70015, '\P{^Is_Block=_MAHAJANI}', "");
    Expect(0, 70016, '\p{Is_Block=_MAHAJANI}', "");
    Expect(1, 70016, '\p{^Is_Block=_MAHAJANI}', "");
    Expect(1, 70016, '\P{Is_Block=_MAHAJANI}', "");
    Expect(0, 70016, '\P{^Is_Block=_MAHAJANI}', "");
    Error('\p{Is_Blk=_	MAHAJANI/a/}');
    Error('\P{Is_Blk=_	MAHAJANI/a/}');
    Expect(1, 70015, '\p{Is_Blk=mahajani}', "");
    Expect(0, 70015, '\p{^Is_Blk=mahajani}', "");
    Expect(0, 70015, '\P{Is_Blk=mahajani}', "");
    Expect(1, 70015, '\P{^Is_Blk=mahajani}', "");
    Expect(0, 70016, '\p{Is_Blk=mahajani}', "");
    Expect(1, 70016, '\p{^Is_Blk=mahajani}', "");
    Expect(1, 70016, '\P{Is_Blk=mahajani}', "");
    Expect(0, 70016, '\P{^Is_Blk=mahajani}', "");
    Expect(1, 70015, '\p{Is_Blk=	-MAHAJANI}', "");
    Expect(0, 70015, '\p{^Is_Blk=	-MAHAJANI}', "");
    Expect(0, 70015, '\P{Is_Blk=	-MAHAJANI}', "");
    Expect(1, 70015, '\P{^Is_Blk=	-MAHAJANI}', "");
    Expect(0, 70016, '\p{Is_Blk=	-MAHAJANI}', "");
    Expect(1, 70016, '\p{^Is_Blk=	-MAHAJANI}', "");
    Expect(1, 70016, '\P{Is_Blk=	-MAHAJANI}', "");
    Expect(0, 70016, '\P{^Is_Blk=	-MAHAJANI}', "");
    Error('\p{Block=__Mahjong_tiles:=}');
    Error('\P{Block=__Mahjong_tiles:=}');
    Expect(1, 127023, '\p{Block=:\AMahjong_Tiles\z:}', "");;
    Expect(0, 127024, '\p{Block=:\AMahjong_Tiles\z:}', "");;
    Expect(1, 127023, '\p{Block=mahjongtiles}', "");
    Expect(0, 127023, '\p{^Block=mahjongtiles}', "");
    Expect(0, 127023, '\P{Block=mahjongtiles}', "");
    Expect(1, 127023, '\P{^Block=mahjongtiles}', "");
    Expect(0, 127024, '\p{Block=mahjongtiles}', "");
    Expect(1, 127024, '\p{^Block=mahjongtiles}', "");
    Expect(1, 127024, '\P{Block=mahjongtiles}', "");
    Expect(0, 127024, '\P{^Block=mahjongtiles}', "");
    Expect(1, 127023, '\p{Block=:\Amahjongtiles\z:}', "");;
    Expect(0, 127024, '\p{Block=:\Amahjongtiles\z:}', "");;
    Expect(1, 127023, '\p{Block=	-mahjong_Tiles}', "");
    Expect(0, 127023, '\p{^Block=	-mahjong_Tiles}', "");
    Expect(0, 127023, '\P{Block=	-mahjong_Tiles}', "");
    Expect(1, 127023, '\P{^Block=	-mahjong_Tiles}', "");
    Expect(0, 127024, '\p{Block=	-mahjong_Tiles}', "");
    Expect(1, 127024, '\p{^Block=	-mahjong_Tiles}', "");
    Expect(1, 127024, '\P{Block=	-mahjong_Tiles}', "");
    Expect(0, 127024, '\P{^Block=	-mahjong_Tiles}', "");
    Error('\p{Blk= /a/MAHJONG}');
    Error('\P{Blk= /a/MAHJONG}');
    Expect(1, 127023, '\p{Blk=:\AMahjong\z:}', "");;
    Expect(0, 127024, '\p{Blk=:\AMahjong\z:}', "");;
    Expect(1, 127023, '\p{Blk=mahjong}', "");
    Expect(0, 127023, '\p{^Blk=mahjong}', "");
    Expect(0, 127023, '\P{Blk=mahjong}', "");
    Expect(1, 127023, '\P{^Blk=mahjong}', "");
    Expect(0, 127024, '\p{Blk=mahjong}', "");
    Expect(1, 127024, '\p{^Blk=mahjong}', "");
    Expect(1, 127024, '\P{Blk=mahjong}', "");
    Expect(0, 127024, '\P{^Blk=mahjong}', "");
    Expect(1, 127023, '\p{Blk=:\Amahjong\z:}', "");;
    Expect(0, 127024, '\p{Blk=:\Amahjong\z:}', "");;
    Expect(1, 127023, '\p{Blk=	Mahjong}', "");
    Expect(0, 127023, '\p{^Blk=	Mahjong}', "");
    Expect(0, 127023, '\P{Blk=	Mahjong}', "");
    Expect(1, 127023, '\P{^Blk=	Mahjong}', "");
    Expect(0, 127024, '\p{Blk=	Mahjong}', "");
    Expect(1, 127024, '\p{^Blk=	Mahjong}', "");
    Expect(1, 127024, '\P{Blk=	Mahjong}', "");
    Expect(0, 127024, '\P{^Blk=	Mahjong}', "");
    Error('\p{Is_Block=:=	 MAHJONG_Tiles}');
    Error('\P{Is_Block=:=	 MAHJONG_Tiles}');
    Expect(1, 127023, '\p{Is_Block=mahjongtiles}', "");
    Expect(0, 127023, '\p{^Is_Block=mahjongtiles}', "");
    Expect(0, 127023, '\P{Is_Block=mahjongtiles}', "");
    Expect(1, 127023, '\P{^Is_Block=mahjongtiles}', "");
    Expect(0, 127024, '\p{Is_Block=mahjongtiles}', "");
    Expect(1, 127024, '\p{^Is_Block=mahjongtiles}', "");
    Expect(1, 127024, '\P{Is_Block=mahjongtiles}', "");
    Expect(0, 127024, '\P{^Is_Block=mahjongtiles}', "");
    Expect(1, 127023, '\p{Is_Block= _Mahjong_tiles}', "");
    Expect(0, 127023, '\p{^Is_Block= _Mahjong_tiles}', "");
    Expect(0, 127023, '\P{Is_Block= _Mahjong_tiles}', "");
    Expect(1, 127023, '\P{^Is_Block= _Mahjong_tiles}', "");
    Expect(0, 127024, '\p{Is_Block= _Mahjong_tiles}', "");
    Expect(1, 127024, '\p{^Is_Block= _Mahjong_tiles}', "");
    Expect(1, 127024, '\P{Is_Block= _Mahjong_tiles}', "");
    Expect(0, 127024, '\P{^Is_Block= _Mahjong_tiles}', "");
    Error('\p{Is_Blk=:=-_Mahjong}');
    Error('\P{Is_Blk=:=-_Mahjong}');
    Expect(1, 127023, '\p{Is_Blk=mahjong}', "");
    Expect(0, 127023, '\p{^Is_Blk=mahjong}', "");
    Expect(0, 127023, '\P{Is_Blk=mahjong}', "");
    Expect(1, 127023, '\P{^Is_Blk=mahjong}', "");
    Expect(0, 127024, '\p{Is_Blk=mahjong}', "");
    Expect(1, 127024, '\p{^Is_Blk=mahjong}', "");
    Expect(1, 127024, '\P{Is_Blk=mahjong}', "");
    Expect(0, 127024, '\P{^Is_Blk=mahjong}', "");
    Expect(1, 127023, '\p{Is_Blk= Mahjong}', "");
    Expect(0, 127023, '\p{^Is_Blk= Mahjong}', "");
    Expect(0, 127023, '\P{Is_Blk= Mahjong}', "");
    Expect(1, 127023, '\P{^Is_Blk= Mahjong}', "");
    Expect(0, 127024, '\p{Is_Blk= Mahjong}', "");
    Expect(1, 127024, '\p{^Is_Blk= Mahjong}', "");
    Expect(1, 127024, '\P{Is_Blk= Mahjong}', "");
    Expect(0, 127024, '\P{^Is_Blk= Mahjong}', "");
    Error('\p{Block=	:=MAKASAR}');
    Error('\P{Block=	:=MAKASAR}');
    Expect(1, 73471, '\p{Block=:\AMakasar\z:}', "");;
    Expect(0, 73472, '\p{Block=:\AMakasar\z:}', "");;
    Expect(1, 73471, '\p{Block=makasar}', "");
    Expect(0, 73471, '\p{^Block=makasar}', "");
    Expect(0, 73471, '\P{Block=makasar}', "");
    Expect(1, 73471, '\P{^Block=makasar}', "");
    Expect(0, 73472, '\p{Block=makasar}', "");
    Expect(1, 73472, '\p{^Block=makasar}', "");
    Expect(1, 73472, '\P{Block=makasar}', "");
    Expect(0, 73472, '\P{^Block=makasar}', "");
    Expect(1, 73471, '\p{Block=:\Amakasar\z:}', "");;
    Expect(0, 73472, '\p{Block=:\Amakasar\z:}', "");;
    Expect(1, 73471, '\p{Block=  Makasar}', "");
    Expect(0, 73471, '\p{^Block=  Makasar}', "");
    Expect(0, 73471, '\P{Block=  Makasar}', "");
    Expect(1, 73471, '\P{^Block=  Makasar}', "");
    Expect(0, 73472, '\p{Block=  Makasar}', "");
    Expect(1, 73472, '\p{^Block=  Makasar}', "");
    Expect(1, 73472, '\P{Block=  Makasar}', "");
    Expect(0, 73472, '\P{^Block=  Makasar}', "");
    Error('\p{Blk=_:=Makasar}');
    Error('\P{Blk=_:=Makasar}');
    Expect(1, 73471, '\p{Blk=:\AMakasar\z:}', "");;
    Expect(0, 73472, '\p{Blk=:\AMakasar\z:}', "");;
    Expect(1, 73471, '\p{Blk=makasar}', "");
    Expect(0, 73471, '\p{^Blk=makasar}', "");
    Expect(0, 73471, '\P{Blk=makasar}', "");
    Expect(1, 73471, '\P{^Blk=makasar}', "");
    Expect(0, 73472, '\p{Blk=makasar}', "");
    Expect(1, 73472, '\p{^Blk=makasar}', "");
    Expect(1, 73472, '\P{Blk=makasar}', "");
    Expect(0, 73472, '\P{^Blk=makasar}', "");
    Expect(1, 73471, '\p{Blk=:\Amakasar\z:}', "");;
    Expect(0, 73472, '\p{Blk=:\Amakasar\z:}', "");;
    Expect(1, 73471, '\p{Blk=_	Makasar}', "");
    Expect(0, 73471, '\p{^Blk=_	Makasar}', "");
    Expect(0, 73471, '\P{Blk=_	Makasar}', "");
    Expect(1, 73471, '\P{^Blk=_	Makasar}', "");
    Expect(0, 73472, '\p{Blk=_	Makasar}', "");
    Expect(1, 73472, '\p{^Blk=_	Makasar}', "");
    Expect(1, 73472, '\P{Blk=_	Makasar}', "");
    Expect(0, 73472, '\P{^Blk=_	Makasar}', "");
    Error('\p{Is_Block: _-Makasar/a/}');
    Error('\P{Is_Block: _-Makasar/a/}');
    Expect(1, 73471, '\p{Is_Block=makasar}', "");
    Expect(0, 73471, '\p{^Is_Block=makasar}', "");
    Expect(0, 73471, '\P{Is_Block=makasar}', "");
    Expect(1, 73471, '\P{^Is_Block=makasar}', "");
    Expect(0, 73472, '\p{Is_Block=makasar}', "");
    Expect(1, 73472, '\p{^Is_Block=makasar}', "");
    Expect(1, 73472, '\P{Is_Block=makasar}', "");
    Expect(0, 73472, '\P{^Is_Block=makasar}', "");
    Expect(1, 73471, '\p{Is_Block=_Makasar}', "");
    Expect(0, 73471, '\p{^Is_Block=_Makasar}', "");
    Expect(0, 73471, '\P{Is_Block=_Makasar}', "");
    Expect(1, 73471, '\P{^Is_Block=_Makasar}', "");
    Expect(0, 73472, '\p{Is_Block=_Makasar}', "");
    Expect(1, 73472, '\p{^Is_Block=_Makasar}', "");
    Expect(1, 73472, '\P{Is_Block=_Makasar}', "");
    Expect(0, 73472, '\P{^Is_Block=_Makasar}', "");
    Error('\p{Is_Blk=:=	MAKASAR}');
    Error('\P{Is_Blk=:=	MAKASAR}');
    Expect(1, 73471, '\p{Is_Blk=makasar}', "");
    Expect(0, 73471, '\p{^Is_Blk=makasar}', "");
    Expect(0, 73471, '\P{Is_Blk=makasar}', "");
    Expect(1, 73471, '\P{^Is_Blk=makasar}', "");
    Expect(0, 73472, '\p{Is_Blk=makasar}', "");
    Expect(1, 73472, '\p{^Is_Blk=makasar}', "");
    Expect(1, 73472, '\P{Is_Blk=makasar}', "");
    Expect(0, 73472, '\P{^Is_Blk=makasar}', "");
    Expect(1, 73471, '\p{Is_Blk:    -makasar}', "");
    Expect(0, 73471, '\p{^Is_Blk:    -makasar}', "");
    Expect(0, 73471, '\P{Is_Blk:    -makasar}', "");
    Expect(1, 73471, '\P{^Is_Blk:    -makasar}', "");
    Expect(0, 73472, '\p{Is_Blk:    -makasar}', "");
    Expect(1, 73472, '\p{^Is_Blk:    -makasar}', "");
    Expect(1, 73472, '\P{Is_Blk:    -makasar}', "");
    Expect(0, 73472, '\P{^Is_Blk:    -makasar}', "");
    Error('\p{Block=/a/Malayalam}');
    Error('\P{Block=/a/Malayalam}');
    Expect(1, 3455, '\p{Block=:\AMalayalam\z:}', "");;
    Expect(0, 3456, '\p{Block=:\AMalayalam\z:}', "");;
    Expect(1, 3455, '\p{Block=malayalam}', "");
    Expect(0, 3455, '\p{^Block=malayalam}', "");
    Expect(0, 3455, '\P{Block=malayalam}', "");
    Expect(1, 3455, '\P{^Block=malayalam}', "");
    Expect(0, 3456, '\p{Block=malayalam}', "");
    Expect(1, 3456, '\p{^Block=malayalam}', "");
    Expect(1, 3456, '\P{Block=malayalam}', "");
    Expect(0, 3456, '\P{^Block=malayalam}', "");
    Expect(1, 3455, '\p{Block=:\Amalayalam\z:}', "");;
    Expect(0, 3456, '\p{Block=:\Amalayalam\z:}', "");;
    Expect(1, 3455, '\p{Block=  Malayalam}', "");
    Expect(0, 3455, '\p{^Block=  Malayalam}', "");
    Expect(0, 3455, '\P{Block=  Malayalam}', "");
    Expect(1, 3455, '\P{^Block=  Malayalam}', "");
    Expect(0, 3456, '\p{Block=  Malayalam}', "");
    Expect(1, 3456, '\p{^Block=  Malayalam}', "");
    Expect(1, 3456, '\P{Block=  Malayalam}', "");
    Expect(0, 3456, '\P{^Block=  Malayalam}', "");
    Error('\p{Blk= malayalam/a/}');
    Error('\P{Blk= malayalam/a/}');
    Expect(1, 3455, '\p{Blk=:\AMalayalam\z:}', "");;
    Expect(0, 3456, '\p{Blk=:\AMalayalam\z:}', "");;
    Expect(1, 3455, '\p{Blk:malayalam}', "");
    Expect(0, 3455, '\p{^Blk:malayalam}', "");
    Expect(0, 3455, '\P{Blk:malayalam}', "");
    Expect(1, 3455, '\P{^Blk:malayalam}', "");
    Expect(0, 3456, '\p{Blk:malayalam}', "");
    Expect(1, 3456, '\p{^Blk:malayalam}', "");
    Expect(1, 3456, '\P{Blk:malayalam}', "");
    Expect(0, 3456, '\P{^Blk:malayalam}', "");
    Expect(1, 3455, '\p{Blk=:\Amalayalam\z:}', "");;
    Expect(0, 3456, '\p{Blk=:\Amalayalam\z:}', "");;
    Expect(1, 3455, '\p{Blk=_-MALAYALAM}', "");
    Expect(0, 3455, '\p{^Blk=_-MALAYALAM}', "");
    Expect(0, 3455, '\P{Blk=_-MALAYALAM}', "");
    Expect(1, 3455, '\P{^Blk=_-MALAYALAM}', "");
    Expect(0, 3456, '\p{Blk=_-MALAYALAM}', "");
    Expect(1, 3456, '\p{^Blk=_-MALAYALAM}', "");
    Expect(1, 3456, '\P{Blk=_-MALAYALAM}', "");
    Expect(0, 3456, '\P{^Blk=_-MALAYALAM}', "");
    Error('\p{Is_Block:   _/a/Malayalam}');
    Error('\P{Is_Block:   _/a/Malayalam}');
    Expect(1, 3455, '\p{Is_Block=malayalam}', "");
    Expect(0, 3455, '\p{^Is_Block=malayalam}', "");
    Expect(0, 3455, '\P{Is_Block=malayalam}', "");
    Expect(1, 3455, '\P{^Is_Block=malayalam}', "");
    Expect(0, 3456, '\p{Is_Block=malayalam}', "");
    Expect(1, 3456, '\p{^Is_Block=malayalam}', "");
    Expect(1, 3456, '\P{Is_Block=malayalam}', "");
    Expect(0, 3456, '\P{^Is_Block=malayalam}', "");
    Expect(1, 3455, '\p{Is_Block=		malayalam}', "");
    Expect(0, 3455, '\p{^Is_Block=		malayalam}', "");
    Expect(0, 3455, '\P{Is_Block=		malayalam}', "");
    Expect(1, 3455, '\P{^Is_Block=		malayalam}', "");
    Expect(0, 3456, '\p{Is_Block=		malayalam}', "");
    Expect(1, 3456, '\p{^Is_Block=		malayalam}', "");
    Expect(1, 3456, '\P{Is_Block=		malayalam}', "");
    Expect(0, 3456, '\P{^Is_Block=		malayalam}', "");
    Error('\p{Is_Blk=/a/	_Malayalam}');
    Error('\P{Is_Blk=/a/	_Malayalam}');
    Expect(1, 3455, '\p{Is_Blk=malayalam}', "");
    Expect(0, 3455, '\p{^Is_Blk=malayalam}', "");
    Expect(0, 3455, '\P{Is_Blk=malayalam}', "");
    Expect(1, 3455, '\P{^Is_Blk=malayalam}', "");
    Expect(0, 3456, '\p{Is_Blk=malayalam}', "");
    Expect(1, 3456, '\p{^Is_Blk=malayalam}', "");
    Expect(1, 3456, '\P{Is_Blk=malayalam}', "");
    Expect(0, 3456, '\P{^Is_Blk=malayalam}', "");
    Expect(1, 3455, '\p{Is_Blk=- MALAYALAM}', "");
    Expect(0, 3455, '\p{^Is_Blk=- MALAYALAM}', "");
    Expect(0, 3455, '\P{Is_Blk=- MALAYALAM}', "");
    Expect(1, 3455, '\P{^Is_Blk=- MALAYALAM}', "");
    Expect(0, 3456, '\p{Is_Blk=- MALAYALAM}', "");
    Expect(1, 3456, '\p{^Is_Blk=- MALAYALAM}', "");
    Expect(1, 3456, '\P{Is_Blk=- MALAYALAM}', "");
    Expect(0, 3456, '\P{^Is_Blk=- MALAYALAM}', "");
    Error('\p{Block=-:=MANDAIC}');
    Error('\P{Block=-:=MANDAIC}');
    Expect(1, 2143, '\p{Block=:\AMandaic\z:}', "");;
    Expect(0, 2144, '\p{Block=:\AMandaic\z:}', "");;
    Expect(1, 2143, '\p{Block=mandaic}', "");
    Expect(0, 2143, '\p{^Block=mandaic}', "");
    Expect(0, 2143, '\P{Block=mandaic}', "");
    Expect(1, 2143, '\P{^Block=mandaic}', "");
    Expect(0, 2144, '\p{Block=mandaic}', "");
    Expect(1, 2144, '\p{^Block=mandaic}', "");
    Expect(1, 2144, '\P{Block=mandaic}', "");
    Expect(0, 2144, '\P{^Block=mandaic}', "");
    Expect(1, 2143, '\p{Block=:\Amandaic\z:}', "");;
    Expect(0, 2144, '\p{Block=:\Amandaic\z:}', "");;
    Expect(1, 2143, '\p{Block=_Mandaic}', "");
    Expect(0, 2143, '\p{^Block=_Mandaic}', "");
    Expect(0, 2143, '\P{Block=_Mandaic}', "");
    Expect(1, 2143, '\P{^Block=_Mandaic}', "");
    Expect(0, 2144, '\p{Block=_Mandaic}', "");
    Expect(1, 2144, '\p{^Block=_Mandaic}', "");
    Expect(1, 2144, '\P{Block=_Mandaic}', "");
    Expect(0, 2144, '\P{^Block=_Mandaic}', "");
    Error('\p{Blk= :=Mandaic}');
    Error('\P{Blk= :=Mandaic}');
    Expect(1, 2143, '\p{Blk=:\AMandaic\z:}', "");;
    Expect(0, 2144, '\p{Blk=:\AMandaic\z:}', "");;
    Expect(1, 2143, '\p{Blk=mandaic}', "");
    Expect(0, 2143, '\p{^Blk=mandaic}', "");
    Expect(0, 2143, '\P{Blk=mandaic}', "");
    Expect(1, 2143, '\P{^Blk=mandaic}', "");
    Expect(0, 2144, '\p{Blk=mandaic}', "");
    Expect(1, 2144, '\p{^Blk=mandaic}', "");
    Expect(1, 2144, '\P{Blk=mandaic}', "");
    Expect(0, 2144, '\P{^Blk=mandaic}', "");
    Expect(1, 2143, '\p{Blk=:\Amandaic\z:}', "");;
    Expect(0, 2144, '\p{Blk=:\Amandaic\z:}', "");;
    Expect(1, 2143, '\p{Blk=Mandaic}', "");
    Expect(0, 2143, '\p{^Blk=Mandaic}', "");
    Expect(0, 2143, '\P{Blk=Mandaic}', "");
    Expect(1, 2143, '\P{^Blk=Mandaic}', "");
    Expect(0, 2144, '\p{Blk=Mandaic}', "");
    Expect(1, 2144, '\p{^Blk=Mandaic}', "");
    Expect(1, 2144, '\P{Blk=Mandaic}', "");
    Expect(0, 2144, '\P{^Blk=Mandaic}', "");
    Error('\p{Is_Block=/a/	_Mandaic}');
    Error('\P{Is_Block=/a/	_Mandaic}');
    Expect(1, 2143, '\p{Is_Block=mandaic}', "");
    Expect(0, 2143, '\p{^Is_Block=mandaic}', "");
    Expect(0, 2143, '\P{Is_Block=mandaic}', "");
    Expect(1, 2143, '\P{^Is_Block=mandaic}', "");
    Expect(0, 2144, '\p{Is_Block=mandaic}', "");
    Expect(1, 2144, '\p{^Is_Block=mandaic}', "");
    Expect(1, 2144, '\P{Is_Block=mandaic}', "");
    Expect(0, 2144, '\P{^Is_Block=mandaic}', "");
    Expect(1, 2143, '\p{Is_Block=  Mandaic}', "");
    Expect(0, 2143, '\p{^Is_Block=  Mandaic}', "");
    Expect(0, 2143, '\P{Is_Block=  Mandaic}', "");
    Expect(1, 2143, '\P{^Is_Block=  Mandaic}', "");
    Expect(0, 2144, '\p{Is_Block=  Mandaic}', "");
    Expect(1, 2144, '\p{^Is_Block=  Mandaic}', "");
    Expect(1, 2144, '\P{Is_Block=  Mandaic}', "");
    Expect(0, 2144, '\P{^Is_Block=  Mandaic}', "");
    Error('\p{Is_Blk=_-MANDAIC:=}');
    Error('\P{Is_Blk=_-MANDAIC:=}');
    Expect(1, 2143, '\p{Is_Blk=mandaic}', "");
    Expect(0, 2143, '\p{^Is_Blk=mandaic}', "");
    Expect(0, 2143, '\P{Is_Blk=mandaic}', "");
    Expect(1, 2143, '\P{^Is_Blk=mandaic}', "");
    Expect(0, 2144, '\p{Is_Blk=mandaic}', "");
    Expect(1, 2144, '\p{^Is_Blk=mandaic}', "");
    Expect(1, 2144, '\P{Is_Blk=mandaic}', "");
    Expect(0, 2144, '\P{^Is_Blk=mandaic}', "");
    Expect(1, 2143, '\p{Is_Blk:_mandaic}', "");
    Expect(0, 2143, '\p{^Is_Blk:_mandaic}', "");
    Expect(0, 2143, '\P{Is_Blk:_mandaic}', "");
    Expect(1, 2143, '\P{^Is_Blk:_mandaic}', "");
    Expect(0, 2144, '\p{Is_Blk:_mandaic}', "");
    Expect(1, 2144, '\p{^Is_Blk:_mandaic}', "");
    Expect(1, 2144, '\P{Is_Blk:_mandaic}', "");
    Expect(0, 2144, '\P{^Is_Blk:_mandaic}', "");
    Error('\p{Block=	 Manichaean:=}');
    Error('\P{Block=	 Manichaean:=}');
    Expect(1, 68351, '\p{Block=:\AManichaean\z:}', "");;
    Expect(0, 68352, '\p{Block=:\AManichaean\z:}', "");;
    Expect(1, 68351, '\p{Block=manichaean}', "");
    Expect(0, 68351, '\p{^Block=manichaean}', "");
    Expect(0, 68351, '\P{Block=manichaean}', "");
    Expect(1, 68351, '\P{^Block=manichaean}', "");
    Expect(0, 68352, '\p{Block=manichaean}', "");
    Expect(1, 68352, '\p{^Block=manichaean}', "");
    Expect(1, 68352, '\P{Block=manichaean}', "");
    Expect(0, 68352, '\P{^Block=manichaean}', "");
    Expect(1, 68351, '\p{Block=:\Amanichaean\z:}', "");;
    Expect(0, 68352, '\p{Block=:\Amanichaean\z:}', "");;
    Expect(1, 68351, '\p{Block=  Manichaean}', "");
    Expect(0, 68351, '\p{^Block=  Manichaean}', "");
    Expect(0, 68351, '\P{Block=  Manichaean}', "");
    Expect(1, 68351, '\P{^Block=  Manichaean}', "");
    Expect(0, 68352, '\p{Block=  Manichaean}', "");
    Expect(1, 68352, '\p{^Block=  Manichaean}', "");
    Expect(1, 68352, '\P{Block=  Manichaean}', "");
    Expect(0, 68352, '\P{^Block=  Manichaean}', "");
    Error('\p{Blk:   _	Manichaean/a/}');
    Error('\P{Blk:   _	Manichaean/a/}');
    Expect(1, 68351, '\p{Blk=:\AManichaean\z:}', "");;
    Expect(0, 68352, '\p{Blk=:\AManichaean\z:}', "");;
    Expect(1, 68351, '\p{Blk=manichaean}', "");
    Expect(0, 68351, '\p{^Blk=manichaean}', "");
    Expect(0, 68351, '\P{Blk=manichaean}', "");
    Expect(1, 68351, '\P{^Blk=manichaean}', "");
    Expect(0, 68352, '\p{Blk=manichaean}', "");
    Expect(1, 68352, '\p{^Blk=manichaean}', "");
    Expect(1, 68352, '\P{Blk=manichaean}', "");
    Expect(0, 68352, '\P{^Blk=manichaean}', "");
    Expect(1, 68351, '\p{Blk=:\Amanichaean\z:}', "");;
    Expect(0, 68352, '\p{Blk=:\Amanichaean\z:}', "");;
    Expect(1, 68351, '\p{Blk=	Manichaean}', "");
    Expect(0, 68351, '\p{^Blk=	Manichaean}', "");
    Expect(0, 68351, '\P{Blk=	Manichaean}', "");
    Expect(1, 68351, '\P{^Blk=	Manichaean}', "");
    Expect(0, 68352, '\p{Blk=	Manichaean}', "");
    Expect(1, 68352, '\p{^Blk=	Manichaean}', "");
    Expect(1, 68352, '\P{Blk=	Manichaean}', "");
    Expect(0, 68352, '\P{^Blk=	Manichaean}', "");
    Error('\p{Is_Block=_ manichaean:=}');
    Error('\P{Is_Block=_ manichaean:=}');
    Expect(1, 68351, '\p{Is_Block=manichaean}', "");
    Expect(0, 68351, '\p{^Is_Block=manichaean}', "");
    Expect(0, 68351, '\P{Is_Block=manichaean}', "");
    Expect(1, 68351, '\P{^Is_Block=manichaean}', "");
    Expect(0, 68352, '\p{Is_Block=manichaean}', "");
    Expect(1, 68352, '\p{^Is_Block=manichaean}', "");
    Expect(1, 68352, '\P{Is_Block=manichaean}', "");
    Expect(0, 68352, '\P{^Is_Block=manichaean}', "");
    Expect(1, 68351, '\p{Is_Block=-Manichaean}', "");
    Expect(0, 68351, '\p{^Is_Block=-Manichaean}', "");
    Expect(0, 68351, '\P{Is_Block=-Manichaean}', "");
    Expect(1, 68351, '\P{^Is_Block=-Manichaean}', "");
    Expect(0, 68352, '\p{Is_Block=-Manichaean}', "");
    Expect(1, 68352, '\p{^Is_Block=-Manichaean}', "");
    Expect(1, 68352, '\P{Is_Block=-Manichaean}', "");
    Expect(0, 68352, '\P{^Is_Block=-Manichaean}', "");
    Error('\p{Is_Blk=	:=MANICHAEAN}');
    Error('\P{Is_Blk=	:=MANICHAEAN}');
    Expect(1, 68351, '\p{Is_Blk: manichaean}', "");
    Expect(0, 68351, '\p{^Is_Blk: manichaean}', "");
    Expect(0, 68351, '\P{Is_Blk: manichaean}', "");
    Expect(1, 68351, '\P{^Is_Blk: manichaean}', "");
    Expect(0, 68352, '\p{Is_Blk: manichaean}', "");
    Expect(1, 68352, '\p{^Is_Blk: manichaean}', "");
    Expect(1, 68352, '\P{Is_Blk: manichaean}', "");
    Expect(0, 68352, '\P{^Is_Blk: manichaean}', "");
    Expect(1, 68351, '\p{Is_Blk=__Manichaean}', "");
    Expect(0, 68351, '\p{^Is_Blk=__Manichaean}', "");
    Expect(0, 68351, '\P{Is_Blk=__Manichaean}', "");
    Expect(1, 68351, '\P{^Is_Blk=__Manichaean}', "");
    Expect(0, 68352, '\p{Is_Blk=__Manichaean}', "");
    Expect(1, 68352, '\p{^Is_Blk=__Manichaean}', "");
    Expect(1, 68352, '\P{Is_Blk=__Manichaean}', "");
    Expect(0, 68352, '\P{^Is_Blk=__Manichaean}', "");
    Error('\p{Block=	-marchen:=}');
    Error('\P{Block=	-marchen:=}');
    Expect(1, 72895, '\p{Block=:\AMarchen\z:}', "");;
    Expect(0, 72896, '\p{Block=:\AMarchen\z:}', "");;
    Expect(1, 72895, '\p{Block=marchen}', "");
    Expect(0, 72895, '\p{^Block=marchen}', "");
    Expect(0, 72895, '\P{Block=marchen}', "");
    Expect(1, 72895, '\P{^Block=marchen}', "");
    Expect(0, 72896, '\p{Block=marchen}', "");
    Expect(1, 72896, '\p{^Block=marchen}', "");
    Expect(1, 72896, '\P{Block=marchen}', "");
    Expect(0, 72896, '\P{^Block=marchen}', "");
    Expect(1, 72895, '\p{Block=:\Amarchen\z:}', "");;
    Expect(0, 72896, '\p{Block=:\Amarchen\z:}', "");;
    Expect(1, 72895, '\p{Block=_-MARCHEN}', "");
    Expect(0, 72895, '\p{^Block=_-MARCHEN}', "");
    Expect(0, 72895, '\P{Block=_-MARCHEN}', "");
    Expect(1, 72895, '\P{^Block=_-MARCHEN}', "");
    Expect(0, 72896, '\p{Block=_-MARCHEN}', "");
    Expect(1, 72896, '\p{^Block=_-MARCHEN}', "");
    Expect(1, 72896, '\P{Block=_-MARCHEN}', "");
    Expect(0, 72896, '\P{^Block=_-MARCHEN}', "");
    Error('\p{Blk=	:=Marchen}');
    Error('\P{Blk=	:=Marchen}');
    Expect(1, 72895, '\p{Blk=:\AMarchen\z:}', "");;
    Expect(0, 72896, '\p{Blk=:\AMarchen\z:}', "");;
    Expect(1, 72895, '\p{Blk=marchen}', "");
    Expect(0, 72895, '\p{^Blk=marchen}', "");
    Expect(0, 72895, '\P{Blk=marchen}', "");
    Expect(1, 72895, '\P{^Blk=marchen}', "");
    Expect(0, 72896, '\p{Blk=marchen}', "");
    Expect(1, 72896, '\p{^Blk=marchen}', "");
    Expect(1, 72896, '\P{Blk=marchen}', "");
    Expect(0, 72896, '\P{^Blk=marchen}', "");
    Expect(1, 72895, '\p{Blk=:\Amarchen\z:}', "");;
    Expect(0, 72896, '\p{Blk=:\Amarchen\z:}', "");;
    Expect(1, 72895, '\p{Blk=	-Marchen}', "");
    Expect(0, 72895, '\p{^Blk=	-Marchen}', "");
    Expect(0, 72895, '\P{Blk=	-Marchen}', "");
    Expect(1, 72895, '\P{^Blk=	-Marchen}', "");
    Expect(0, 72896, '\p{Blk=	-Marchen}', "");
    Expect(1, 72896, '\p{^Blk=	-Marchen}', "");
    Expect(1, 72896, '\P{Blk=	-Marchen}', "");
    Expect(0, 72896, '\P{^Blk=	-Marchen}', "");
    Error('\p{Is_Block=/a/Marchen}');
    Error('\P{Is_Block=/a/Marchen}');
    Expect(1, 72895, '\p{Is_Block=marchen}', "");
    Expect(0, 72895, '\p{^Is_Block=marchen}', "");
    Expect(0, 72895, '\P{Is_Block=marchen}', "");
    Expect(1, 72895, '\P{^Is_Block=marchen}', "");
    Expect(0, 72896, '\p{Is_Block=marchen}', "");
    Expect(1, 72896, '\p{^Is_Block=marchen}', "");
    Expect(1, 72896, '\P{Is_Block=marchen}', "");
    Expect(0, 72896, '\P{^Is_Block=marchen}', "");
    Expect(1, 72895, '\p{Is_Block=-_MARCHEN}', "");
    Expect(0, 72895, '\p{^Is_Block=-_MARCHEN}', "");
    Expect(0, 72895, '\P{Is_Block=-_MARCHEN}', "");
    Expect(1, 72895, '\P{^Is_Block=-_MARCHEN}', "");
    Expect(0, 72896, '\p{Is_Block=-_MARCHEN}', "");
    Expect(1, 72896, '\p{^Is_Block=-_MARCHEN}', "");
    Expect(1, 72896, '\P{Is_Block=-_MARCHEN}', "");
    Expect(0, 72896, '\P{^Is_Block=-_MARCHEN}', "");
    Error('\p{Is_Blk=_:=marchen}');
    Error('\P{Is_Blk=_:=marchen}');
    Expect(1, 72895, '\p{Is_Blk=marchen}', "");
    Expect(0, 72895, '\p{^Is_Blk=marchen}', "");
    Expect(0, 72895, '\P{Is_Blk=marchen}', "");
    Expect(1, 72895, '\P{^Is_Blk=marchen}', "");
    Expect(0, 72896, '\p{Is_Blk=marchen}', "");
    Expect(1, 72896, '\p{^Is_Blk=marchen}', "");
    Expect(1, 72896, '\P{Is_Blk=marchen}', "");
    Expect(0, 72896, '\P{^Is_Blk=marchen}', "");
    Expect(1, 72895, '\p{Is_Blk=_marchen}', "");
    Expect(0, 72895, '\p{^Is_Blk=_marchen}', "");
    Expect(0, 72895, '\P{Is_Blk=_marchen}', "");
    Expect(1, 72895, '\P{^Is_Blk=_marchen}', "");
    Expect(0, 72896, '\p{Is_Blk=_marchen}', "");
    Expect(1, 72896, '\p{^Is_Blk=_marchen}', "");
    Expect(1, 72896, '\P{Is_Blk=_marchen}', "");
    Expect(0, 72896, '\P{^Is_Blk=_marchen}', "");
    Error('\p{Block=:=-MASARAM_Gondi}');
    Error('\P{Block=:=-MASARAM_Gondi}');
    Expect(1, 73055, '\p{Block=:\AMasaram_Gondi\z:}', "");;
    Expect(0, 73056, '\p{Block=:\AMasaram_Gondi\z:}', "");;
    Expect(1, 73055, '\p{Block:	masaramgondi}', "");
    Expect(0, 73055, '\p{^Block:	masaramgondi}', "");
    Expect(0, 73055, '\P{Block:	masaramgondi}', "");
    Expect(1, 73055, '\P{^Block:	masaramgondi}', "");
    Expect(0, 73056, '\p{Block:	masaramgondi}', "");
    Expect(1, 73056, '\p{^Block:	masaramgondi}', "");
    Expect(1, 73056, '\P{Block:	masaramgondi}', "");
    Expect(0, 73056, '\P{^Block:	masaramgondi}', "");
    Expect(1, 73055, '\p{Block=:\Amasaramgondi\z:}', "");;
    Expect(0, 73056, '\p{Block=:\Amasaramgondi\z:}', "");;
    Expect(1, 73055, '\p{Block=Masaram_gondi}', "");
    Expect(0, 73055, '\p{^Block=Masaram_gondi}', "");
    Expect(0, 73055, '\P{Block=Masaram_gondi}', "");
    Expect(1, 73055, '\P{^Block=Masaram_gondi}', "");
    Expect(0, 73056, '\p{Block=Masaram_gondi}', "");
    Expect(1, 73056, '\p{^Block=Masaram_gondi}', "");
    Expect(1, 73056, '\P{Block=Masaram_gondi}', "");
    Expect(0, 73056, '\P{^Block=Masaram_gondi}', "");
    Error('\p{Blk= Masaram_Gondi:=}');
    Error('\P{Blk= Masaram_Gondi:=}');
    Expect(1, 73055, '\p{Blk=:\AMasaram_Gondi\z:}', "");;
    Expect(0, 73056, '\p{Blk=:\AMasaram_Gondi\z:}', "");;
    Expect(1, 73055, '\p{Blk:	masaramgondi}', "");
    Expect(0, 73055, '\p{^Blk:	masaramgondi}', "");
    Expect(0, 73055, '\P{Blk:	masaramgondi}', "");
    Expect(1, 73055, '\P{^Blk:	masaramgondi}', "");
    Expect(0, 73056, '\p{Blk:	masaramgondi}', "");
    Expect(1, 73056, '\p{^Blk:	masaramgondi}', "");
    Expect(1, 73056, '\P{Blk:	masaramgondi}', "");
    Expect(0, 73056, '\P{^Blk:	masaramgondi}', "");
    Expect(1, 73055, '\p{Blk=:\Amasaramgondi\z:}', "");;
    Expect(0, 73056, '\p{Blk=:\Amasaramgondi\z:}', "");;
    Expect(1, 73055, '\p{Blk=-	masaram_gondi}', "");
    Expect(0, 73055, '\p{^Blk=-	masaram_gondi}', "");
    Expect(0, 73055, '\P{Blk=-	masaram_gondi}', "");
    Expect(1, 73055, '\P{^Blk=-	masaram_gondi}', "");
    Expect(0, 73056, '\p{Blk=-	masaram_gondi}', "");
    Expect(1, 73056, '\p{^Blk=-	masaram_gondi}', "");
    Expect(1, 73056, '\P{Blk=-	masaram_gondi}', "");
    Expect(0, 73056, '\P{^Blk=-	masaram_gondi}', "");
    Error('\p{Is_Block=--MASARAM_gondi/a/}');
    Error('\P{Is_Block=--MASARAM_gondi/a/}');
    Expect(1, 73055, '\p{Is_Block=masaramgondi}', "");
    Expect(0, 73055, '\p{^Is_Block=masaramgondi}', "");
    Expect(0, 73055, '\P{Is_Block=masaramgondi}', "");
    Expect(1, 73055, '\P{^Is_Block=masaramgondi}', "");
    Expect(0, 73056, '\p{Is_Block=masaramgondi}', "");
    Expect(1, 73056, '\p{^Is_Block=masaramgondi}', "");
    Expect(1, 73056, '\P{Is_Block=masaramgondi}', "");
    Expect(0, 73056, '\P{^Is_Block=masaramgondi}', "");
    Expect(1, 73055, '\p{Is_Block= Masaram_gondi}', "");
    Expect(0, 73055, '\p{^Is_Block= Masaram_gondi}', "");
    Expect(0, 73055, '\P{Is_Block= Masaram_gondi}', "");
    Expect(1, 73055, '\P{^Is_Block= Masaram_gondi}', "");
    Expect(0, 73056, '\p{Is_Block= Masaram_gondi}', "");
    Expect(1, 73056, '\p{^Is_Block= Masaram_gondi}', "");
    Expect(1, 73056, '\P{Is_Block= Masaram_gondi}', "");
    Expect(0, 73056, '\P{^Is_Block= Masaram_gondi}', "");
    Error('\p{Is_Blk=	/a/masaram_gondi}');
    Error('\P{Is_Blk=	/a/masaram_gondi}');
    Expect(1, 73055, '\p{Is_Blk=masaramgondi}', "");
    Expect(0, 73055, '\p{^Is_Blk=masaramgondi}', "");
    Expect(0, 73055, '\P{Is_Blk=masaramgondi}', "");
    Expect(1, 73055, '\P{^Is_Blk=masaramgondi}', "");
    Expect(0, 73056, '\p{Is_Blk=masaramgondi}', "");
    Expect(1, 73056, '\p{^Is_Blk=masaramgondi}', "");
    Expect(1, 73056, '\P{Is_Blk=masaramgondi}', "");
    Expect(0, 73056, '\P{^Is_Blk=masaramgondi}', "");
    Expect(1, 73055, '\p{Is_Blk=Masaram_gondi}', "");
    Expect(0, 73055, '\p{^Is_Blk=Masaram_gondi}', "");
    Expect(0, 73055, '\P{Is_Blk=Masaram_gondi}', "");
    Expect(1, 73055, '\P{^Is_Blk=Masaram_gondi}', "");
    Expect(0, 73056, '\p{Is_Blk=Masaram_gondi}', "");
    Expect(1, 73056, '\p{^Is_Blk=Masaram_gondi}', "");
    Expect(1, 73056, '\P{Is_Blk=Masaram_gondi}', "");
    Expect(0, 73056, '\P{^Is_Blk=Masaram_gondi}', "");
    Error('\p{Block=:=_ Mathematical_Alphanumeric_Symbols}');
    Error('\P{Block=:=_ Mathematical_Alphanumeric_Symbols}');
    Expect(1, 120831, '\p{Block=:\AMathematical_Alphanumeric_Symbols\z:}', "");;
    Expect(0, 120832, '\p{Block=:\AMathematical_Alphanumeric_Symbols\z:}', "");;
    Expect(1, 120831, '\p{Block:   mathematicalalphanumericsymbols}', "");
    Expect(0, 120831, '\p{^Block:   mathematicalalphanumericsymbols}', "");
    Expect(0, 120831, '\P{Block:   mathematicalalphanumericsymbols}', "");
    Expect(1, 120831, '\P{^Block:   mathematicalalphanumericsymbols}', "");
    Expect(0, 120832, '\p{Block:   mathematicalalphanumericsymbols}', "");
    Expect(1, 120832, '\p{^Block:   mathematicalalphanumericsymbols}', "");
    Expect(1, 120832, '\P{Block:   mathematicalalphanumericsymbols}', "");
    Expect(0, 120832, '\P{^Block:   mathematicalalphanumericsymbols}', "");
    Expect(1, 120831, '\p{Block=:\Amathematicalalphanumericsymbols\z:}', "");;
    Expect(0, 120832, '\p{Block=:\Amathematicalalphanumericsymbols\z:}', "");;
    Expect(1, 120831, '\p{Block= _Mathematical_Alphanumeric_Symbols}', "");
    Expect(0, 120831, '\p{^Block= _Mathematical_Alphanumeric_Symbols}', "");
    Expect(0, 120831, '\P{Block= _Mathematical_Alphanumeric_Symbols}', "");
    Expect(1, 120831, '\P{^Block= _Mathematical_Alphanumeric_Symbols}', "");
    Expect(0, 120832, '\p{Block= _Mathematical_Alphanumeric_Symbols}', "");
    Expect(1, 120832, '\p{^Block= _Mathematical_Alphanumeric_Symbols}', "");
    Expect(1, 120832, '\P{Block= _Mathematical_Alphanumeric_Symbols}', "");
    Expect(0, 120832, '\P{^Block= _Mathematical_Alphanumeric_Symbols}', "");
    Error('\p{Blk=:=	math_alphanum}');
    Error('\P{Blk=:=	math_alphanum}');
    Expect(1, 120831, '\p{Blk=:\AMath_Alphanum\z:}', "");;
    Expect(0, 120832, '\p{Blk=:\AMath_Alphanum\z:}', "");;
    Expect(1, 120831, '\p{Blk=mathalphanum}', "");
    Expect(0, 120831, '\p{^Blk=mathalphanum}', "");
    Expect(0, 120831, '\P{Blk=mathalphanum}', "");
    Expect(1, 120831, '\P{^Blk=mathalphanum}', "");
    Expect(0, 120832, '\p{Blk=mathalphanum}', "");
    Expect(1, 120832, '\p{^Blk=mathalphanum}', "");
    Expect(1, 120832, '\P{Blk=mathalphanum}', "");
    Expect(0, 120832, '\P{^Blk=mathalphanum}', "");
    Expect(1, 120831, '\p{Blk=:\Amathalphanum\z:}', "");;
    Expect(0, 120832, '\p{Blk=:\Amathalphanum\z:}', "");;
    Expect(1, 120831, '\p{Blk=__MATH_Alphanum}', "");
    Expect(0, 120831, '\p{^Blk=__MATH_Alphanum}', "");
    Expect(0, 120831, '\P{Blk=__MATH_Alphanum}', "");
    Expect(1, 120831, '\P{^Blk=__MATH_Alphanum}', "");
    Expect(0, 120832, '\p{Blk=__MATH_Alphanum}', "");
    Expect(1, 120832, '\p{^Blk=__MATH_Alphanum}', "");
    Expect(1, 120832, '\P{Blk=__MATH_Alphanum}', "");
    Expect(0, 120832, '\P{^Blk=__MATH_Alphanum}', "");
    Error('\p{Is_Block=_ MATHEMATICAL_ALPHANUMERIC_SYMBOLS/a/}');
    Error('\P{Is_Block=_ MATHEMATICAL_ALPHANUMERIC_SYMBOLS/a/}');
    Expect(1, 120831, '\p{Is_Block=mathematicalalphanumericsymbols}', "");
    Expect(0, 120831, '\p{^Is_Block=mathematicalalphanumericsymbols}', "");
    Expect(0, 120831, '\P{Is_Block=mathematicalalphanumericsymbols}', "");
    Expect(1, 120831, '\P{^Is_Block=mathematicalalphanumericsymbols}', "");
    Expect(0, 120832, '\p{Is_Block=mathematicalalphanumericsymbols}', "");
    Expect(1, 120832, '\p{^Is_Block=mathematicalalphanumericsymbols}', "");
    Expect(1, 120832, '\P{Is_Block=mathematicalalphanumericsymbols}', "");
    Expect(0, 120832, '\P{^Is_Block=mathematicalalphanumericsymbols}', "");
    Expect(1, 120831, '\p{Is_Block: -MATHEMATICAL_alphanumeric_Symbols}', "");
    Expect(0, 120831, '\p{^Is_Block: -MATHEMATICAL_alphanumeric_Symbols}', "");
    Expect(0, 120831, '\P{Is_Block: -MATHEMATICAL_alphanumeric_Symbols}', "");
    Expect(1, 120831, '\P{^Is_Block: -MATHEMATICAL_alphanumeric_Symbols}', "");
    Expect(0, 120832, '\p{Is_Block: -MATHEMATICAL_alphanumeric_Symbols}', "");
    Expect(1, 120832, '\p{^Is_Block: -MATHEMATICAL_alphanumeric_Symbols}', "");
    Expect(1, 120832, '\P{Is_Block: -MATHEMATICAL_alphanumeric_Symbols}', "");
    Expect(0, 120832, '\P{^Is_Block: -MATHEMATICAL_alphanumeric_Symbols}', "");
    Error('\p{Is_Blk=:=_	Math_ALPHANUM}');
    Error('\P{Is_Blk=:=_	Math_ALPHANUM}');
    Expect(1, 120831, '\p{Is_Blk=mathalphanum}', "");
    Expect(0, 120831, '\p{^Is_Blk=mathalphanum}', "");
    Expect(0, 120831, '\P{Is_Blk=mathalphanum}', "");
    Expect(1, 120831, '\P{^Is_Blk=mathalphanum}', "");
    Expect(0, 120832, '\p{Is_Blk=mathalphanum}', "");
    Expect(1, 120832, '\p{^Is_Blk=mathalphanum}', "");
    Expect(1, 120832, '\P{Is_Blk=mathalphanum}', "");
    Expect(0, 120832, '\P{^Is_Blk=mathalphanum}', "");
    Expect(1, 120831, '\p{Is_Blk= -math_Alphanum}', "");
    Expect(0, 120831, '\p{^Is_Blk= -math_Alphanum}', "");
    Expect(0, 120831, '\P{Is_Blk= -math_Alphanum}', "");
    Expect(1, 120831, '\P{^Is_Blk= -math_Alphanum}', "");
    Expect(0, 120832, '\p{Is_Blk= -math_Alphanum}', "");
    Expect(1, 120832, '\p{^Is_Blk= -math_Alphanum}', "");
    Expect(1, 120832, '\P{Is_Blk= -math_Alphanum}', "");
    Expect(0, 120832, '\P{^Is_Blk= -math_Alphanum}', "");
    Error('\p{Block=_-Mathematical_Operators/a/}');
    Error('\P{Block=_-Mathematical_Operators/a/}');
    Expect(1, 8959, '\p{Block=:\AMathematical_Operators\z:}', "");;
    Expect(0, 8960, '\p{Block=:\AMathematical_Operators\z:}', "");;
    Expect(1, 8959, '\p{Block=mathematicaloperators}', "");
    Expect(0, 8959, '\p{^Block=mathematicaloperators}', "");
    Expect(0, 8959, '\P{Block=mathematicaloperators}', "");
    Expect(1, 8959, '\P{^Block=mathematicaloperators}', "");
    Expect(0, 8960, '\p{Block=mathematicaloperators}', "");
    Expect(1, 8960, '\p{^Block=mathematicaloperators}', "");
    Expect(1, 8960, '\P{Block=mathematicaloperators}', "");
    Expect(0, 8960, '\P{^Block=mathematicaloperators}', "");
    Expect(1, 8959, '\p{Block=:\Amathematicaloperators\z:}', "");;
    Expect(0, 8960, '\p{Block=:\Amathematicaloperators\z:}', "");;
    Expect(1, 8959, '\p{Block:   _-Mathematical_Operators}', "");
    Expect(0, 8959, '\p{^Block:   _-Mathematical_Operators}', "");
    Expect(0, 8959, '\P{Block:   _-Mathematical_Operators}', "");
    Expect(1, 8959, '\P{^Block:   _-Mathematical_Operators}', "");
    Expect(0, 8960, '\p{Block:   _-Mathematical_Operators}', "");
    Expect(1, 8960, '\p{^Block:   _-Mathematical_Operators}', "");
    Expect(1, 8960, '\P{Block:   _-Mathematical_Operators}', "");
    Expect(0, 8960, '\P{^Block:   _-Mathematical_Operators}', "");
    Error('\p{Blk=:=	_Math_OPERATORS}');
    Error('\P{Blk=:=	_Math_OPERATORS}');
    Expect(1, 8959, '\p{Blk=:\AMath_Operators\z:}', "");;
    Expect(0, 8960, '\p{Blk=:\AMath_Operators\z:}', "");;
    Expect(1, 8959, '\p{Blk=mathoperators}', "");
    Expect(0, 8959, '\p{^Blk=mathoperators}', "");
    Expect(0, 8959, '\P{Blk=mathoperators}', "");
    Expect(1, 8959, '\P{^Blk=mathoperators}', "");
    Expect(0, 8960, '\p{Blk=mathoperators}', "");
    Expect(1, 8960, '\p{^Blk=mathoperators}', "");
    Expect(1, 8960, '\P{Blk=mathoperators}', "");
    Expect(0, 8960, '\P{^Blk=mathoperators}', "");
    Expect(1, 8959, '\p{Blk=:\Amathoperators\z:}', "");;
    Expect(0, 8960, '\p{Blk=:\Amathoperators\z:}', "");;
    Expect(1, 8959, '\p{Blk=	_MATH_Operators}', "");
    Expect(0, 8959, '\p{^Blk=	_MATH_Operators}', "");
    Expect(0, 8959, '\P{Blk=	_MATH_Operators}', "");
    Expect(1, 8959, '\P{^Blk=	_MATH_Operators}', "");
    Expect(0, 8960, '\p{Blk=	_MATH_Operators}', "");
    Expect(1, 8960, '\p{^Blk=	_MATH_Operators}', "");
    Expect(1, 8960, '\P{Blk=	_MATH_Operators}', "");
    Expect(0, 8960, '\P{^Blk=	_MATH_Operators}', "");
    Error('\p{Is_Block= :=mathematical_Operators}');
    Error('\P{Is_Block= :=mathematical_Operators}');
    Expect(1, 8959, '\p{Is_Block=mathematicaloperators}', "");
    Expect(0, 8959, '\p{^Is_Block=mathematicaloperators}', "");
    Expect(0, 8959, '\P{Is_Block=mathematicaloperators}', "");
    Expect(1, 8959, '\P{^Is_Block=mathematicaloperators}', "");
    Expect(0, 8960, '\p{Is_Block=mathematicaloperators}', "");
    Expect(1, 8960, '\p{^Is_Block=mathematicaloperators}', "");
    Expect(1, 8960, '\P{Is_Block=mathematicaloperators}', "");
    Expect(0, 8960, '\P{^Is_Block=mathematicaloperators}', "");
    Expect(1, 8959, '\p{Is_Block=- MATHEMATICAL_OPERATORS}', "");
    Expect(0, 8959, '\p{^Is_Block=- MATHEMATICAL_OPERATORS}', "");
    Expect(0, 8959, '\P{Is_Block=- MATHEMATICAL_OPERATORS}', "");
    Expect(1, 8959, '\P{^Is_Block=- MATHEMATICAL_OPERATORS}', "");
    Expect(0, 8960, '\p{Is_Block=- MATHEMATICAL_OPERATORS}', "");
    Expect(1, 8960, '\p{^Is_Block=- MATHEMATICAL_OPERATORS}', "");
    Expect(1, 8960, '\P{Is_Block=- MATHEMATICAL_OPERATORS}', "");
    Expect(0, 8960, '\P{^Is_Block=- MATHEMATICAL_OPERATORS}', "");
    Error('\p{Is_Blk=/a/ _math_Operators}');
    Error('\P{Is_Blk=/a/ _math_Operators}');
    Expect(1, 8959, '\p{Is_Blk: mathoperators}', "");
    Expect(0, 8959, '\p{^Is_Blk: mathoperators}', "");
    Expect(0, 8959, '\P{Is_Blk: mathoperators}', "");
    Expect(1, 8959, '\P{^Is_Blk: mathoperators}', "");
    Expect(0, 8960, '\p{Is_Blk: mathoperators}', "");
    Expect(1, 8960, '\p{^Is_Blk: mathoperators}', "");
    Expect(1, 8960, '\P{Is_Blk: mathoperators}', "");
    Expect(0, 8960, '\P{^Is_Blk: mathoperators}', "");
    Expect(1, 8959, '\p{Is_Blk= -math_Operators}', "");
    Expect(0, 8959, '\p{^Is_Blk= -math_Operators}', "");
    Expect(0, 8959, '\P{Is_Blk= -math_Operators}', "");
    Expect(1, 8959, '\P{^Is_Blk= -math_Operators}', "");
    Expect(0, 8960, '\p{Is_Blk= -math_Operators}', "");
    Expect(1, 8960, '\p{^Is_Blk= -math_Operators}', "");
    Expect(1, 8960, '\P{Is_Blk= -math_Operators}', "");
    Expect(0, 8960, '\P{^Is_Blk= -math_Operators}', "");
    Error('\p{Block= _MAYAN_Numerals:=}');
    Error('\P{Block= _MAYAN_Numerals:=}');
    Expect(1, 119551, '\p{Block=:\AMayan_Numerals\z:}', "");;
    Expect(0, 119552, '\p{Block=:\AMayan_Numerals\z:}', "");;
    Expect(1, 119551, '\p{Block=mayannumerals}', "");
    Expect(0, 119551, '\p{^Block=mayannumerals}', "");
    Expect(0, 119551, '\P{Block=mayannumerals}', "");
    Expect(1, 119551, '\P{^Block=mayannumerals}', "");
    Expect(0, 119552, '\p{Block=mayannumerals}', "");
    Expect(1, 119552, '\p{^Block=mayannumerals}', "");
    Expect(1, 119552, '\P{Block=mayannumerals}', "");
    Expect(0, 119552, '\P{^Block=mayannumerals}', "");
    Expect(1, 119551, '\p{Block=:\Amayannumerals\z:}', "");;
    Expect(0, 119552, '\p{Block=:\Amayannumerals\z:}', "");;
    Expect(1, 119551, '\p{Block=		MAYAN_numerals}', "");
    Expect(0, 119551, '\p{^Block=		MAYAN_numerals}', "");
    Expect(0, 119551, '\P{Block=		MAYAN_numerals}', "");
    Expect(1, 119551, '\P{^Block=		MAYAN_numerals}', "");
    Expect(0, 119552, '\p{Block=		MAYAN_numerals}', "");
    Expect(1, 119552, '\p{^Block=		MAYAN_numerals}', "");
    Expect(1, 119552, '\P{Block=		MAYAN_numerals}', "");
    Expect(0, 119552, '\P{^Block=		MAYAN_numerals}', "");
    Error('\p{Blk= :=MAYAN_numerals}');
    Error('\P{Blk= :=MAYAN_numerals}');
    Expect(1, 119551, '\p{Blk=:\AMayan_Numerals\z:}', "");;
    Expect(0, 119552, '\p{Blk=:\AMayan_Numerals\z:}', "");;
    Expect(1, 119551, '\p{Blk=mayannumerals}', "");
    Expect(0, 119551, '\p{^Blk=mayannumerals}', "");
    Expect(0, 119551, '\P{Blk=mayannumerals}', "");
    Expect(1, 119551, '\P{^Blk=mayannumerals}', "");
    Expect(0, 119552, '\p{Blk=mayannumerals}', "");
    Expect(1, 119552, '\p{^Blk=mayannumerals}', "");
    Expect(1, 119552, '\P{Blk=mayannumerals}', "");
    Expect(0, 119552, '\P{^Blk=mayannumerals}', "");
    Expect(1, 119551, '\p{Blk=:\Amayannumerals\z:}', "");;
    Expect(0, 119552, '\p{Blk=:\Amayannumerals\z:}', "");;
    Expect(1, 119551, '\p{Blk= Mayan_NUMERALS}', "");
    Expect(0, 119551, '\p{^Blk= Mayan_NUMERALS}', "");
    Expect(0, 119551, '\P{Blk= Mayan_NUMERALS}', "");
    Expect(1, 119551, '\P{^Blk= Mayan_NUMERALS}', "");
    Expect(0, 119552, '\p{Blk= Mayan_NUMERALS}', "");
    Expect(1, 119552, '\p{^Blk= Mayan_NUMERALS}', "");
    Expect(1, 119552, '\P{Blk= Mayan_NUMERALS}', "");
    Expect(0, 119552, '\P{^Blk= Mayan_NUMERALS}', "");
    Error('\p{Is_Block=:=_Mayan_numerals}');
    Error('\P{Is_Block=:=_Mayan_numerals}');
    Expect(1, 119551, '\p{Is_Block:	mayannumerals}', "");
    Expect(0, 119551, '\p{^Is_Block:	mayannumerals}', "");
    Expect(0, 119551, '\P{Is_Block:	mayannumerals}', "");
    Expect(1, 119551, '\P{^Is_Block:	mayannumerals}', "");
    Expect(0, 119552, '\p{Is_Block:	mayannumerals}', "");
    Expect(1, 119552, '\p{^Is_Block:	mayannumerals}', "");
    Expect(1, 119552, '\P{Is_Block:	mayannumerals}', "");
    Expect(0, 119552, '\P{^Is_Block:	mayannumerals}', "");
    Expect(1, 119551, '\p{Is_Block=_Mayan_Numerals}', "");
    Expect(0, 119551, '\p{^Is_Block=_Mayan_Numerals}', "");
    Expect(0, 119551, '\P{Is_Block=_Mayan_Numerals}', "");
    Expect(1, 119551, '\P{^Is_Block=_Mayan_Numerals}', "");
    Expect(0, 119552, '\p{Is_Block=_Mayan_Numerals}', "");
    Expect(1, 119552, '\p{^Is_Block=_Mayan_Numerals}', "");
    Expect(1, 119552, '\P{Is_Block=_Mayan_Numerals}', "");
    Expect(0, 119552, '\P{^Is_Block=_Mayan_Numerals}', "");
    Error('\p{Is_Blk=__Mayan_Numerals:=}');
    Error('\P{Is_Blk=__Mayan_Numerals:=}');
    Expect(1, 119551, '\p{Is_Blk:   mayannumerals}', "");
    Expect(0, 119551, '\p{^Is_Blk:   mayannumerals}', "");
    Expect(0, 119551, '\P{Is_Blk:   mayannumerals}', "");
    Expect(1, 119551, '\P{^Is_Blk:   mayannumerals}', "");
    Expect(0, 119552, '\p{Is_Blk:   mayannumerals}', "");
    Expect(1, 119552, '\p{^Is_Blk:   mayannumerals}', "");
    Expect(1, 119552, '\P{Is_Blk:   mayannumerals}', "");
    Expect(0, 119552, '\P{^Is_Blk:   mayannumerals}', "");
    Expect(1, 119551, '\p{Is_Blk=	-MAYAN_Numerals}', "");
    Expect(0, 119551, '\p{^Is_Blk=	-MAYAN_Numerals}', "");
    Expect(0, 119551, '\P{Is_Blk=	-MAYAN_Numerals}', "");
    Expect(1, 119551, '\P{^Is_Blk=	-MAYAN_Numerals}', "");
    Expect(0, 119552, '\p{Is_Blk=	-MAYAN_Numerals}', "");
    Expect(1, 119552, '\p{^Is_Blk=	-MAYAN_Numerals}', "");
    Expect(1, 119552, '\P{Is_Blk=	-MAYAN_Numerals}', "");
    Expect(0, 119552, '\P{^Is_Blk=	-MAYAN_Numerals}', "");
    Error('\p{Block= :=Medefaidrin}');
    Error('\P{Block= :=Medefaidrin}');
    Expect(1, 93855, '\p{Block=:\AMedefaidrin\z:}', "");;
    Expect(0, 93856, '\p{Block=:\AMedefaidrin\z:}', "");;
    Expect(1, 93855, '\p{Block=medefaidrin}', "");
    Expect(0, 93855, '\p{^Block=medefaidrin}', "");
    Expect(0, 93855, '\P{Block=medefaidrin}', "");
    Expect(1, 93855, '\P{^Block=medefaidrin}', "");
    Expect(0, 93856, '\p{Block=medefaidrin}', "");
    Expect(1, 93856, '\p{^Block=medefaidrin}', "");
    Expect(1, 93856, '\P{Block=medefaidrin}', "");
    Expect(0, 93856, '\P{^Block=medefaidrin}', "");
    Expect(1, 93855, '\p{Block=:\Amedefaidrin\z:}', "");;
    Expect(0, 93856, '\p{Block=:\Amedefaidrin\z:}', "");;
    Expect(1, 93855, '\p{Block=--Medefaidrin}', "");
    Expect(0, 93855, '\p{^Block=--Medefaidrin}', "");
    Expect(0, 93855, '\P{Block=--Medefaidrin}', "");
    Expect(1, 93855, '\P{^Block=--Medefaidrin}', "");
    Expect(0, 93856, '\p{Block=--Medefaidrin}', "");
    Expect(1, 93856, '\p{^Block=--Medefaidrin}', "");
    Expect(1, 93856, '\P{Block=--Medefaidrin}', "");
    Expect(0, 93856, '\P{^Block=--Medefaidrin}', "");
    Error('\p{Blk=:=_	Medefaidrin}');
    Error('\P{Blk=:=_	Medefaidrin}');
    Expect(1, 93855, '\p{Blk=:\AMedefaidrin\z:}', "");;
    Expect(0, 93856, '\p{Blk=:\AMedefaidrin\z:}', "");;
    Expect(1, 93855, '\p{Blk=medefaidrin}', "");
    Expect(0, 93855, '\p{^Blk=medefaidrin}', "");
    Expect(0, 93855, '\P{Blk=medefaidrin}', "");
    Expect(1, 93855, '\P{^Blk=medefaidrin}', "");
    Expect(0, 93856, '\p{Blk=medefaidrin}', "");
    Expect(1, 93856, '\p{^Blk=medefaidrin}', "");
    Expect(1, 93856, '\P{Blk=medefaidrin}', "");
    Expect(0, 93856, '\P{^Blk=medefaidrin}', "");
    Expect(1, 93855, '\p{Blk=:\Amedefaidrin\z:}', "");;
    Expect(0, 93856, '\p{Blk=:\Amedefaidrin\z:}', "");;
    Expect(1, 93855, '\p{Blk=_Medefaidrin}', "");
    Expect(0, 93855, '\p{^Blk=_Medefaidrin}', "");
    Expect(0, 93855, '\P{Blk=_Medefaidrin}', "");
    Expect(1, 93855, '\P{^Blk=_Medefaidrin}', "");
    Expect(0, 93856, '\p{Blk=_Medefaidrin}', "");
    Expect(1, 93856, '\p{^Blk=_Medefaidrin}', "");
    Expect(1, 93856, '\P{Blk=_Medefaidrin}', "");
    Expect(0, 93856, '\P{^Blk=_Medefaidrin}', "");
    Error('\p{Is_Block=:=Medefaidrin}');
    Error('\P{Is_Block=:=Medefaidrin}');
    Expect(1, 93855, '\p{Is_Block=medefaidrin}', "");
    Expect(0, 93855, '\p{^Is_Block=medefaidrin}', "");
    Expect(0, 93855, '\P{Is_Block=medefaidrin}', "");
    Expect(1, 93855, '\P{^Is_Block=medefaidrin}', "");
    Expect(0, 93856, '\p{Is_Block=medefaidrin}', "");
    Expect(1, 93856, '\p{^Is_Block=medefaidrin}', "");
    Expect(1, 93856, '\P{Is_Block=medefaidrin}', "");
    Expect(0, 93856, '\P{^Is_Block=medefaidrin}', "");
    Expect(1, 93855, '\p{Is_Block=	Medefaidrin}', "");
    Expect(0, 93855, '\p{^Is_Block=	Medefaidrin}', "");
    Expect(0, 93855, '\P{Is_Block=	Medefaidrin}', "");
    Expect(1, 93855, '\P{^Is_Block=	Medefaidrin}', "");
    Expect(0, 93856, '\p{Is_Block=	Medefaidrin}', "");
    Expect(1, 93856, '\p{^Is_Block=	Medefaidrin}', "");
    Expect(1, 93856, '\P{Is_Block=	Medefaidrin}', "");
    Expect(0, 93856, '\P{^Is_Block=	Medefaidrin}', "");
    Error('\p{Is_Blk:	/a/medefaidrin}');
    Error('\P{Is_Blk:	/a/medefaidrin}');
    Expect(1, 93855, '\p{Is_Blk=medefaidrin}', "");
    Expect(0, 93855, '\p{^Is_Blk=medefaidrin}', "");
    Expect(0, 93855, '\P{Is_Blk=medefaidrin}', "");
    Expect(1, 93855, '\P{^Is_Blk=medefaidrin}', "");
    Expect(0, 93856, '\p{Is_Blk=medefaidrin}', "");
    Expect(1, 93856, '\p{^Is_Blk=medefaidrin}', "");
    Expect(1, 93856, '\P{Is_Blk=medefaidrin}', "");
    Expect(0, 93856, '\P{^Is_Blk=medefaidrin}', "");
    Expect(1, 93855, '\p{Is_Blk=-Medefaidrin}', "");
    Expect(0, 93855, '\p{^Is_Blk=-Medefaidrin}', "");
    Expect(0, 93855, '\P{Is_Blk=-Medefaidrin}', "");
    Expect(1, 93855, '\P{^Is_Blk=-Medefaidrin}', "");
    Expect(0, 93856, '\p{Is_Blk=-Medefaidrin}', "");
    Expect(1, 93856, '\p{^Is_Blk=-Medefaidrin}', "");
    Expect(1, 93856, '\P{Is_Blk=-Medefaidrin}', "");
    Expect(0, 93856, '\P{^Is_Blk=-Medefaidrin}', "");
    Error('\p{Block=		Meetei_Mayek/a/}');
    Error('\P{Block=		Meetei_Mayek/a/}');
    Expect(1, 44031, '\p{Block=:\AMeetei_Mayek\z:}', "");;
    Expect(0, 44032, '\p{Block=:\AMeetei_Mayek\z:}', "");;
    Expect(1, 44031, '\p{Block=meeteimayek}', "");
    Expect(0, 44031, '\p{^Block=meeteimayek}', "");
    Expect(0, 44031, '\P{Block=meeteimayek}', "");
    Expect(1, 44031, '\P{^Block=meeteimayek}', "");
    Expect(0, 44032, '\p{Block=meeteimayek}', "");
    Expect(1, 44032, '\p{^Block=meeteimayek}', "");
    Expect(1, 44032, '\P{Block=meeteimayek}', "");
    Expect(0, 44032, '\P{^Block=meeteimayek}', "");
    Expect(1, 44031, '\p{Block=:\Ameeteimayek\z:}', "");;
    Expect(0, 44032, '\p{Block=:\Ameeteimayek\z:}', "");;
    Expect(1, 44031, '\p{Block=_-Meetei_MAYEK}', "");
    Expect(0, 44031, '\p{^Block=_-Meetei_MAYEK}', "");
    Expect(0, 44031, '\P{Block=_-Meetei_MAYEK}', "");
    Expect(1, 44031, '\P{^Block=_-Meetei_MAYEK}', "");
    Expect(0, 44032, '\p{Block=_-Meetei_MAYEK}', "");
    Expect(1, 44032, '\p{^Block=_-Meetei_MAYEK}', "");
    Expect(1, 44032, '\P{Block=_-Meetei_MAYEK}', "");
    Expect(0, 44032, '\P{^Block=_-Meetei_MAYEK}', "");
    Error('\p{Blk=:= Meetei_Mayek}');
    Error('\P{Blk=:= Meetei_Mayek}');
    Expect(1, 44031, '\p{Blk=:\AMeetei_Mayek\z:}', "");;
    Expect(0, 44032, '\p{Blk=:\AMeetei_Mayek\z:}', "");;
    Expect(1, 44031, '\p{Blk=meeteimayek}', "");
    Expect(0, 44031, '\p{^Blk=meeteimayek}', "");
    Expect(0, 44031, '\P{Blk=meeteimayek}', "");
    Expect(1, 44031, '\P{^Blk=meeteimayek}', "");
    Expect(0, 44032, '\p{Blk=meeteimayek}', "");
    Expect(1, 44032, '\p{^Blk=meeteimayek}', "");
    Expect(1, 44032, '\P{Blk=meeteimayek}', "");
    Expect(0, 44032, '\P{^Blk=meeteimayek}', "");
    Expect(1, 44031, '\p{Blk=:\Ameeteimayek\z:}', "");;
    Expect(0, 44032, '\p{Blk=:\Ameeteimayek\z:}', "");;
    Expect(1, 44031, '\p{Blk=- meetei_MAYEK}', "");
    Expect(0, 44031, '\p{^Blk=- meetei_MAYEK}', "");
    Expect(0, 44031, '\P{Blk=- meetei_MAYEK}', "");
    Expect(1, 44031, '\P{^Blk=- meetei_MAYEK}', "");
    Expect(0, 44032, '\p{Blk=- meetei_MAYEK}', "");
    Expect(1, 44032, '\p{^Blk=- meetei_MAYEK}', "");
    Expect(1, 44032, '\P{Blk=- meetei_MAYEK}', "");
    Expect(0, 44032, '\P{^Blk=- meetei_MAYEK}', "");
    Error('\p{Is_Block=_	Meetei_Mayek:=}');
    Error('\P{Is_Block=_	Meetei_Mayek:=}');
    Expect(1, 44031, '\p{Is_Block=meeteimayek}', "");
    Expect(0, 44031, '\p{^Is_Block=meeteimayek}', "");
    Expect(0, 44031, '\P{Is_Block=meeteimayek}', "");
    Expect(1, 44031, '\P{^Is_Block=meeteimayek}', "");
    Expect(0, 44032, '\p{Is_Block=meeteimayek}', "");
    Expect(1, 44032, '\p{^Is_Block=meeteimayek}', "");
    Expect(1, 44032, '\P{Is_Block=meeteimayek}', "");
    Expect(0, 44032, '\P{^Is_Block=meeteimayek}', "");
    Expect(1, 44031, '\p{Is_Block=- Meetei_Mayek}', "");
    Expect(0, 44031, '\p{^Is_Block=- Meetei_Mayek}', "");
    Expect(0, 44031, '\P{Is_Block=- Meetei_Mayek}', "");
    Expect(1, 44031, '\P{^Is_Block=- Meetei_Mayek}', "");
    Expect(0, 44032, '\p{Is_Block=- Meetei_Mayek}', "");
    Expect(1, 44032, '\p{^Is_Block=- Meetei_Mayek}', "");
    Expect(1, 44032, '\P{Is_Block=- Meetei_Mayek}', "");
    Expect(0, 44032, '\P{^Is_Block=- Meetei_Mayek}', "");
    Error('\p{Is_Blk=_:=Meetei_Mayek}');
    Error('\P{Is_Blk=_:=Meetei_Mayek}');
    Expect(1, 44031, '\p{Is_Blk=meeteimayek}', "");
    Expect(0, 44031, '\p{^Is_Blk=meeteimayek}', "");
    Expect(0, 44031, '\P{Is_Blk=meeteimayek}', "");
    Expect(1, 44031, '\P{^Is_Blk=meeteimayek}', "");
    Expect(0, 44032, '\p{Is_Blk=meeteimayek}', "");
    Expect(1, 44032, '\p{^Is_Blk=meeteimayek}', "");
    Expect(1, 44032, '\P{Is_Blk=meeteimayek}', "");
    Expect(0, 44032, '\P{^Is_Blk=meeteimayek}', "");
    Expect(1, 44031, '\p{Is_Blk= 	MEETEI_MAYEK}', "");
    Expect(0, 44031, '\p{^Is_Blk= 	MEETEI_MAYEK}', "");
    Expect(0, 44031, '\P{Is_Blk= 	MEETEI_MAYEK}', "");
    Expect(1, 44031, '\P{^Is_Blk= 	MEETEI_MAYEK}', "");
    Expect(0, 44032, '\p{Is_Blk= 	MEETEI_MAYEK}', "");
    Expect(1, 44032, '\p{^Is_Blk= 	MEETEI_MAYEK}', "");
    Expect(1, 44032, '\P{Is_Blk= 	MEETEI_MAYEK}', "");
    Expect(0, 44032, '\P{^Is_Blk= 	MEETEI_MAYEK}', "");
    Error('\p{Block=		MEETEI_MAYEK_extensions/a/}');
    Error('\P{Block=		MEETEI_MAYEK_extensions/a/}');
    Expect(1, 43775, '\p{Block=:\AMeetei_Mayek_Extensions\z:}', "");;
    Expect(0, 43776, '\p{Block=:\AMeetei_Mayek_Extensions\z:}', "");;
    Expect(1, 43775, '\p{Block=meeteimayekextensions}', "");
    Expect(0, 43775, '\p{^Block=meeteimayekextensions}', "");
    Expect(0, 43775, '\P{Block=meeteimayekextensions}', "");
    Expect(1, 43775, '\P{^Block=meeteimayekextensions}', "");
    Expect(0, 43776, '\p{Block=meeteimayekextensions}', "");
    Expect(1, 43776, '\p{^Block=meeteimayekextensions}', "");
    Expect(1, 43776, '\P{Block=meeteimayekextensions}', "");
    Expect(0, 43776, '\P{^Block=meeteimayekextensions}', "");
    Expect(1, 43775, '\p{Block=:\Ameeteimayekextensions\z:}', "");;
    Expect(0, 43776, '\p{Block=:\Ameeteimayekextensions\z:}', "");;
    Expect(1, 43775, '\p{Block= -meetei_Mayek_Extensions}', "");
    Expect(0, 43775, '\p{^Block= -meetei_Mayek_Extensions}', "");
    Expect(0, 43775, '\P{Block= -meetei_Mayek_Extensions}', "");
    Expect(1, 43775, '\P{^Block= -meetei_Mayek_Extensions}', "");
    Expect(0, 43776, '\p{Block= -meetei_Mayek_Extensions}', "");
    Expect(1, 43776, '\p{^Block= -meetei_Mayek_Extensions}', "");
    Expect(1, 43776, '\P{Block= -meetei_Mayek_Extensions}', "");
    Expect(0, 43776, '\P{^Block= -meetei_Mayek_Extensions}', "");
    Error('\p{Blk:   :=	Meetei_Mayek_Ext}');
    Error('\P{Blk:   :=	Meetei_Mayek_Ext}');
    Expect(1, 43775, '\p{Blk=:\AMeetei_Mayek_Ext\z:}', "");;
    Expect(0, 43776, '\p{Blk=:\AMeetei_Mayek_Ext\z:}', "");;
    Expect(1, 43775, '\p{Blk=meeteimayekext}', "");
    Expect(0, 43775, '\p{^Blk=meeteimayekext}', "");
    Expect(0, 43775, '\P{Blk=meeteimayekext}', "");
    Expect(1, 43775, '\P{^Blk=meeteimayekext}', "");
    Expect(0, 43776, '\p{Blk=meeteimayekext}', "");
    Expect(1, 43776, '\p{^Blk=meeteimayekext}', "");
    Expect(1, 43776, '\P{Blk=meeteimayekext}', "");
    Expect(0, 43776, '\P{^Blk=meeteimayekext}', "");
    Expect(1, 43775, '\p{Blk=:\Ameeteimayekext\z:}', "");;
    Expect(0, 43776, '\p{Blk=:\Ameeteimayekext\z:}', "");;
    Expect(1, 43775, '\p{Blk=_MEETEI_Mayek_Ext}', "");
    Expect(0, 43775, '\p{^Blk=_MEETEI_Mayek_Ext}', "");
    Expect(0, 43775, '\P{Blk=_MEETEI_Mayek_Ext}', "");
    Expect(1, 43775, '\P{^Blk=_MEETEI_Mayek_Ext}', "");
    Expect(0, 43776, '\p{Blk=_MEETEI_Mayek_Ext}', "");
    Expect(1, 43776, '\p{^Blk=_MEETEI_Mayek_Ext}', "");
    Expect(1, 43776, '\P{Blk=_MEETEI_Mayek_Ext}', "");
    Expect(0, 43776, '\P{^Blk=_MEETEI_Mayek_Ext}', "");
    Error('\p{Is_Block=-	Meetei_Mayek_Extensions:=}');
    Error('\P{Is_Block=-	Meetei_Mayek_Extensions:=}');
    Expect(1, 43775, '\p{Is_Block=meeteimayekextensions}', "");
    Expect(0, 43775, '\p{^Is_Block=meeteimayekextensions}', "");
    Expect(0, 43775, '\P{Is_Block=meeteimayekextensions}', "");
    Expect(1, 43775, '\P{^Is_Block=meeteimayekextensions}', "");
    Expect(0, 43776, '\p{Is_Block=meeteimayekextensions}', "");
    Expect(1, 43776, '\p{^Is_Block=meeteimayekextensions}', "");
    Expect(1, 43776, '\P{Is_Block=meeteimayekextensions}', "");
    Expect(0, 43776, '\P{^Is_Block=meeteimayekextensions}', "");
    Expect(1, 43775, '\p{Is_Block= Meetei_Mayek_Extensions}', "");
    Expect(0, 43775, '\p{^Is_Block= Meetei_Mayek_Extensions}', "");
    Expect(0, 43775, '\P{Is_Block= Meetei_Mayek_Extensions}', "");
    Expect(1, 43775, '\P{^Is_Block= Meetei_Mayek_Extensions}', "");
    Expect(0, 43776, '\p{Is_Block= Meetei_Mayek_Extensions}', "");
    Expect(1, 43776, '\p{^Is_Block= Meetei_Mayek_Extensions}', "");
    Expect(1, 43776, '\P{Is_Block= Meetei_Mayek_Extensions}', "");
    Expect(0, 43776, '\P{^Is_Block= Meetei_Mayek_Extensions}', "");
    Error('\p{Is_Blk:   	Meetei_Mayek_ext:=}');
    Error('\P{Is_Blk:   	Meetei_Mayek_ext:=}');
    Expect(1, 43775, '\p{Is_Blk=meeteimayekext}', "");
    Expect(0, 43775, '\p{^Is_Blk=meeteimayekext}', "");
    Expect(0, 43775, '\P{Is_Blk=meeteimayekext}', "");
    Expect(1, 43775, '\P{^Is_Blk=meeteimayekext}', "");
    Expect(0, 43776, '\p{Is_Blk=meeteimayekext}', "");
    Expect(1, 43776, '\p{^Is_Blk=meeteimayekext}', "");
    Expect(1, 43776, '\P{Is_Blk=meeteimayekext}', "");
    Expect(0, 43776, '\P{^Is_Blk=meeteimayekext}', "");
    Expect(1, 43775, '\p{Is_Blk=__meetei_Mayek_ext}', "");
    Expect(0, 43775, '\p{^Is_Blk=__meetei_Mayek_ext}', "");
    Expect(0, 43775, '\P{Is_Blk=__meetei_Mayek_ext}', "");
    Expect(1, 43775, '\P{^Is_Blk=__meetei_Mayek_ext}', "");
    Expect(0, 43776, '\p{Is_Blk=__meetei_Mayek_ext}', "");
    Expect(1, 43776, '\p{^Is_Blk=__meetei_Mayek_ext}', "");
    Expect(1, 43776, '\P{Is_Blk=__meetei_Mayek_ext}', "");
    Expect(0, 43776, '\P{^Is_Blk=__meetei_Mayek_ext}', "");
    Error('\p{Block=	:=MENDE_kikakui}');
    Error('\P{Block=	:=MENDE_kikakui}');
    Expect(1, 125151, '\p{Block=:\AMende_Kikakui\z:}', "");;
    Expect(0, 125152, '\p{Block=:\AMende_Kikakui\z:}', "");;
    Expect(1, 125151, '\p{Block=mendekikakui}', "");
    Expect(0, 125151, '\p{^Block=mendekikakui}', "");
    Expect(0, 125151, '\P{Block=mendekikakui}', "");
    Expect(1, 125151, '\P{^Block=mendekikakui}', "");
    Expect(0, 125152, '\p{Block=mendekikakui}', "");
    Expect(1, 125152, '\p{^Block=mendekikakui}', "");
    Expect(1, 125152, '\P{Block=mendekikakui}', "");
    Expect(0, 125152, '\P{^Block=mendekikakui}', "");
    Expect(1, 125151, '\p{Block=:\Amendekikakui\z:}', "");;
    Expect(0, 125152, '\p{Block=:\Amendekikakui\z:}', "");;
    Expect(1, 125151, '\p{Block=	_MENDE_Kikakui}', "");
    Expect(0, 125151, '\p{^Block=	_MENDE_Kikakui}', "");
    Expect(0, 125151, '\P{Block=	_MENDE_Kikakui}', "");
    Expect(1, 125151, '\P{^Block=	_MENDE_Kikakui}', "");
    Expect(0, 125152, '\p{Block=	_MENDE_Kikakui}', "");
    Expect(1, 125152, '\p{^Block=	_MENDE_Kikakui}', "");
    Expect(1, 125152, '\P{Block=	_MENDE_Kikakui}', "");
    Expect(0, 125152, '\P{^Block=	_MENDE_Kikakui}', "");
    Error('\p{Blk=/a/mende_Kikakui}');
    Error('\P{Blk=/a/mende_Kikakui}');
    Expect(1, 125151, '\p{Blk=:\AMende_Kikakui\z:}', "");;
    Expect(0, 125152, '\p{Blk=:\AMende_Kikakui\z:}', "");;
    Expect(1, 125151, '\p{Blk=mendekikakui}', "");
    Expect(0, 125151, '\p{^Blk=mendekikakui}', "");
    Expect(0, 125151, '\P{Blk=mendekikakui}', "");
    Expect(1, 125151, '\P{^Blk=mendekikakui}', "");
    Expect(0, 125152, '\p{Blk=mendekikakui}', "");
    Expect(1, 125152, '\p{^Blk=mendekikakui}', "");
    Expect(1, 125152, '\P{Blk=mendekikakui}', "");
    Expect(0, 125152, '\P{^Blk=mendekikakui}', "");
    Expect(1, 125151, '\p{Blk=:\Amendekikakui\z:}', "");;
    Expect(0, 125152, '\p{Blk=:\Amendekikakui\z:}', "");;
    Expect(1, 125151, '\p{Blk=mende_kikakui}', "");
    Expect(0, 125151, '\p{^Blk=mende_kikakui}', "");
    Expect(0, 125151, '\P{Blk=mende_kikakui}', "");
    Expect(1, 125151, '\P{^Blk=mende_kikakui}', "");
    Expect(0, 125152, '\p{Blk=mende_kikakui}', "");
    Expect(1, 125152, '\p{^Blk=mende_kikakui}', "");
    Expect(1, 125152, '\P{Blk=mende_kikakui}', "");
    Expect(0, 125152, '\P{^Blk=mende_kikakui}', "");
    Error('\p{Is_Block=	:=Mende_Kikakui}');
    Error('\P{Is_Block=	:=Mende_Kikakui}');
    Expect(1, 125151, '\p{Is_Block=mendekikakui}', "");
    Expect(0, 125151, '\p{^Is_Block=mendekikakui}', "");
    Expect(0, 125151, '\P{Is_Block=mendekikakui}', "");
    Expect(1, 125151, '\P{^Is_Block=mendekikakui}', "");
    Expect(0, 125152, '\p{Is_Block=mendekikakui}', "");
    Expect(1, 125152, '\p{^Is_Block=mendekikakui}', "");
    Expect(1, 125152, '\P{Is_Block=mendekikakui}', "");
    Expect(0, 125152, '\P{^Is_Block=mendekikakui}', "");
    Expect(1, 125151, '\p{Is_Block= 	mende_Kikakui}', "");
    Expect(0, 125151, '\p{^Is_Block= 	mende_Kikakui}', "");
    Expect(0, 125151, '\P{Is_Block= 	mende_Kikakui}', "");
    Expect(1, 125151, '\P{^Is_Block= 	mende_Kikakui}', "");
    Expect(0, 125152, '\p{Is_Block= 	mende_Kikakui}', "");
    Expect(1, 125152, '\p{^Is_Block= 	mende_Kikakui}', "");
    Expect(1, 125152, '\P{Is_Block= 	mende_Kikakui}', "");
    Expect(0, 125152, '\P{^Is_Block= 	mende_Kikakui}', "");
    Error('\p{Is_Blk= MENDE_kikakui:=}');
    Error('\P{Is_Blk= MENDE_kikakui:=}');
    Expect(1, 125151, '\p{Is_Blk=mendekikakui}', "");
    Expect(0, 125151, '\p{^Is_Blk=mendekikakui}', "");
    Expect(0, 125151, '\P{Is_Blk=mendekikakui}', "");
    Expect(1, 125151, '\P{^Is_Blk=mendekikakui}', "");
    Expect(0, 125152, '\p{Is_Blk=mendekikakui}', "");
    Expect(1, 125152, '\p{^Is_Blk=mendekikakui}', "");
    Expect(1, 125152, '\P{Is_Blk=mendekikakui}', "");
    Expect(0, 125152, '\P{^Is_Blk=mendekikakui}', "");
    Expect(1, 125151, '\p{Is_Blk=-_mende_Kikakui}', "");
    Expect(0, 125151, '\p{^Is_Blk=-_mende_Kikakui}', "");
    Expect(0, 125151, '\P{Is_Blk=-_mende_Kikakui}', "");
    Expect(1, 125151, '\P{^Is_Blk=-_mende_Kikakui}', "");
    Expect(0, 125152, '\p{Is_Blk=-_mende_Kikakui}', "");
    Expect(1, 125152, '\p{^Is_Blk=-_mende_Kikakui}', "");
    Expect(1, 125152, '\P{Is_Blk=-_mende_Kikakui}', "");
    Expect(0, 125152, '\P{^Is_Blk=-_mende_Kikakui}', "");
    Error('\p{Block=-:=Meroitic_cursive}');
    Error('\P{Block=-:=Meroitic_cursive}');
    Expect(1, 68095, '\p{Block=:\AMeroitic_Cursive\z:}', "");;
    Expect(0, 68096, '\p{Block=:\AMeroitic_Cursive\z:}', "");;
    Expect(1, 68095, '\p{Block=meroiticcursive}', "");
    Expect(0, 68095, '\p{^Block=meroiticcursive}', "");
    Expect(0, 68095, '\P{Block=meroiticcursive}', "");
    Expect(1, 68095, '\P{^Block=meroiticcursive}', "");
    Expect(0, 68096, '\p{Block=meroiticcursive}', "");
    Expect(1, 68096, '\p{^Block=meroiticcursive}', "");
    Expect(1, 68096, '\P{Block=meroiticcursive}', "");
    Expect(0, 68096, '\P{^Block=meroiticcursive}', "");
    Expect(1, 68095, '\p{Block=:\Ameroiticcursive\z:}', "");;
    Expect(0, 68096, '\p{Block=:\Ameroiticcursive\z:}', "");;
    Expect(1, 68095, '\p{Block=_ Meroitic_Cursive}', "");
    Expect(0, 68095, '\p{^Block=_ Meroitic_Cursive}', "");
    Expect(0, 68095, '\P{Block=_ Meroitic_Cursive}', "");
    Expect(1, 68095, '\P{^Block=_ Meroitic_Cursive}', "");
    Expect(0, 68096, '\p{Block=_ Meroitic_Cursive}', "");
    Expect(1, 68096, '\p{^Block=_ Meroitic_Cursive}', "");
    Expect(1, 68096, '\P{Block=_ Meroitic_Cursive}', "");
    Expect(0, 68096, '\P{^Block=_ Meroitic_Cursive}', "");
    Error('\p{Blk=:=Meroitic_cursive}');
    Error('\P{Blk=:=Meroitic_cursive}');
    Expect(1, 68095, '\p{Blk=:\AMeroitic_Cursive\z:}', "");;
    Expect(0, 68096, '\p{Blk=:\AMeroitic_Cursive\z:}', "");;
    Expect(1, 68095, '\p{Blk=meroiticcursive}', "");
    Expect(0, 68095, '\p{^Blk=meroiticcursive}', "");
    Expect(0, 68095, '\P{Blk=meroiticcursive}', "");
    Expect(1, 68095, '\P{^Blk=meroiticcursive}', "");
    Expect(0, 68096, '\p{Blk=meroiticcursive}', "");
    Expect(1, 68096, '\p{^Blk=meroiticcursive}', "");
    Expect(1, 68096, '\P{Blk=meroiticcursive}', "");
    Expect(0, 68096, '\P{^Blk=meroiticcursive}', "");
    Expect(1, 68095, '\p{Blk=:\Ameroiticcursive\z:}', "");;
    Expect(0, 68096, '\p{Blk=:\Ameroiticcursive\z:}', "");;
    Expect(1, 68095, '\p{Blk= MEROITIC_Cursive}', "");
    Expect(0, 68095, '\p{^Blk= MEROITIC_Cursive}', "");
    Expect(0, 68095, '\P{Blk= MEROITIC_Cursive}', "");
    Expect(1, 68095, '\P{^Blk= MEROITIC_Cursive}', "");
    Expect(0, 68096, '\p{Blk= MEROITIC_Cursive}', "");
    Expect(1, 68096, '\p{^Blk= MEROITIC_Cursive}', "");
    Expect(1, 68096, '\P{Blk= MEROITIC_Cursive}', "");
    Expect(0, 68096, '\P{^Blk= MEROITIC_Cursive}', "");
    Error('\p{Is_Block=/a/ 	meroitic_cursive}');
    Error('\P{Is_Block=/a/ 	meroitic_cursive}');
    Expect(1, 68095, '\p{Is_Block=meroiticcursive}', "");
    Expect(0, 68095, '\p{^Is_Block=meroiticcursive}', "");
    Expect(0, 68095, '\P{Is_Block=meroiticcursive}', "");
    Expect(1, 68095, '\P{^Is_Block=meroiticcursive}', "");
    Expect(0, 68096, '\p{Is_Block=meroiticcursive}', "");
    Expect(1, 68096, '\p{^Is_Block=meroiticcursive}', "");
    Expect(1, 68096, '\P{Is_Block=meroiticcursive}', "");
    Expect(0, 68096, '\P{^Is_Block=meroiticcursive}', "");
    Expect(1, 68095, '\p{Is_Block=	 meroitic_CURSIVE}', "");
    Expect(0, 68095, '\p{^Is_Block=	 meroitic_CURSIVE}', "");
    Expect(0, 68095, '\P{Is_Block=	 meroitic_CURSIVE}', "");
    Expect(1, 68095, '\P{^Is_Block=	 meroitic_CURSIVE}', "");
    Expect(0, 68096, '\p{Is_Block=	 meroitic_CURSIVE}', "");
    Expect(1, 68096, '\p{^Is_Block=	 meroitic_CURSIVE}', "");
    Expect(1, 68096, '\P{Is_Block=	 meroitic_CURSIVE}', "");
    Expect(0, 68096, '\P{^Is_Block=	 meroitic_CURSIVE}', "");
    Error('\p{Is_Blk=/a/Meroitic_Cursive}');
    Error('\P{Is_Blk=/a/Meroitic_Cursive}');
    Expect(1, 68095, '\p{Is_Blk=meroiticcursive}', "");
    Expect(0, 68095, '\p{^Is_Blk=meroiticcursive}', "");
    Expect(0, 68095, '\P{Is_Blk=meroiticcursive}', "");
    Expect(1, 68095, '\P{^Is_Blk=meroiticcursive}', "");
    Expect(0, 68096, '\p{Is_Blk=meroiticcursive}', "");
    Expect(1, 68096, '\p{^Is_Blk=meroiticcursive}', "");
    Expect(1, 68096, '\P{Is_Blk=meroiticcursive}', "");
    Expect(0, 68096, '\P{^Is_Blk=meroiticcursive}', "");
    Expect(1, 68095, '\p{Is_Blk= -Meroitic_CURSIVE}', "");
    Expect(0, 68095, '\p{^Is_Blk= -Meroitic_CURSIVE}', "");
    Expect(0, 68095, '\P{Is_Blk= -Meroitic_CURSIVE}', "");
    Expect(1, 68095, '\P{^Is_Blk= -Meroitic_CURSIVE}', "");
    Expect(0, 68096, '\p{Is_Blk= -Meroitic_CURSIVE}', "");
    Expect(1, 68096, '\p{^Is_Blk= -Meroitic_CURSIVE}', "");
    Expect(1, 68096, '\P{Is_Blk= -Meroitic_CURSIVE}', "");
    Expect(0, 68096, '\P{^Is_Blk= -Meroitic_CURSIVE}', "");
    Error('\p{Block=__meroitic_Hieroglyphs/a/}');
    Error('\P{Block=__meroitic_Hieroglyphs/a/}');
    Expect(1, 67999, '\p{Block=:\AMeroitic_Hieroglyphs\z:}', "");;
    Expect(0, 68000, '\p{Block=:\AMeroitic_Hieroglyphs\z:}', "");;
    Expect(1, 67999, '\p{Block:   meroitichieroglyphs}', "");
    Expect(0, 67999, '\p{^Block:   meroitichieroglyphs}', "");
    Expect(0, 67999, '\P{Block:   meroitichieroglyphs}', "");
    Expect(1, 67999, '\P{^Block:   meroitichieroglyphs}', "");
    Expect(0, 68000, '\p{Block:   meroitichieroglyphs}', "");
    Expect(1, 68000, '\p{^Block:   meroitichieroglyphs}', "");
    Expect(1, 68000, '\P{Block:   meroitichieroglyphs}', "");
    Expect(0, 68000, '\P{^Block:   meroitichieroglyphs}', "");
    Expect(1, 67999, '\p{Block=:\Ameroitichieroglyphs\z:}', "");;
    Expect(0, 68000, '\p{Block=:\Ameroitichieroglyphs\z:}', "");;
    Expect(1, 67999, '\p{Block=	Meroitic_Hieroglyphs}', "");
    Expect(0, 67999, '\p{^Block=	Meroitic_Hieroglyphs}', "");
    Expect(0, 67999, '\P{Block=	Meroitic_Hieroglyphs}', "");
    Expect(1, 67999, '\P{^Block=	Meroitic_Hieroglyphs}', "");
    Expect(0, 68000, '\p{Block=	Meroitic_Hieroglyphs}', "");
    Expect(1, 68000, '\p{^Block=	Meroitic_Hieroglyphs}', "");
    Expect(1, 68000, '\P{Block=	Meroitic_Hieroglyphs}', "");
    Expect(0, 68000, '\P{^Block=	Meroitic_Hieroglyphs}', "");
    Error('\p{Blk=meroitic_HIEROGLYPHS:=}');
    Error('\P{Blk=meroitic_HIEROGLYPHS:=}');
    Expect(1, 67999, '\p{Blk=:\AMeroitic_Hieroglyphs\z:}', "");;
    Expect(0, 68000, '\p{Blk=:\AMeroitic_Hieroglyphs\z:}', "");;
    Expect(1, 67999, '\p{Blk=meroitichieroglyphs}', "");
    Expect(0, 67999, '\p{^Blk=meroitichieroglyphs}', "");
    Expect(0, 67999, '\P{Blk=meroitichieroglyphs}', "");
    Expect(1, 67999, '\P{^Blk=meroitichieroglyphs}', "");
    Expect(0, 68000, '\p{Blk=meroitichieroglyphs}', "");
    Expect(1, 68000, '\p{^Blk=meroitichieroglyphs}', "");
    Expect(1, 68000, '\P{Blk=meroitichieroglyphs}', "");
    Expect(0, 68000, '\P{^Blk=meroitichieroglyphs}', "");
    Expect(1, 67999, '\p{Blk=:\Ameroitichieroglyphs\z:}', "");;
    Expect(0, 68000, '\p{Blk=:\Ameroitichieroglyphs\z:}', "");;
    Expect(1, 67999, '\p{Blk=MEROITIC_hieroglyphs}', "");
    Expect(0, 67999, '\p{^Blk=MEROITIC_hieroglyphs}', "");
    Expect(0, 67999, '\P{Blk=MEROITIC_hieroglyphs}', "");
    Expect(1, 67999, '\P{^Blk=MEROITIC_hieroglyphs}', "");
    Expect(0, 68000, '\p{Blk=MEROITIC_hieroglyphs}', "");
    Expect(1, 68000, '\p{^Blk=MEROITIC_hieroglyphs}', "");
    Expect(1, 68000, '\P{Blk=MEROITIC_hieroglyphs}', "");
    Expect(0, 68000, '\P{^Blk=MEROITIC_hieroglyphs}', "");
    Error('\p{Is_Block=/a/_ MEROITIC_Hieroglyphs}');
    Error('\P{Is_Block=/a/_ MEROITIC_Hieroglyphs}');
    Expect(1, 67999, '\p{Is_Block=meroitichieroglyphs}', "");
    Expect(0, 67999, '\p{^Is_Block=meroitichieroglyphs}', "");
    Expect(0, 67999, '\P{Is_Block=meroitichieroglyphs}', "");
    Expect(1, 67999, '\P{^Is_Block=meroitichieroglyphs}', "");
    Expect(0, 68000, '\p{Is_Block=meroitichieroglyphs}', "");
    Expect(1, 68000, '\p{^Is_Block=meroitichieroglyphs}', "");
    Expect(1, 68000, '\P{Is_Block=meroitichieroglyphs}', "");
    Expect(0, 68000, '\P{^Is_Block=meroitichieroglyphs}', "");
    Expect(1, 67999, '\p{Is_Block=MEROITIC_Hieroglyphs}', "");
    Expect(0, 67999, '\p{^Is_Block=MEROITIC_Hieroglyphs}', "");
    Expect(0, 67999, '\P{Is_Block=MEROITIC_Hieroglyphs}', "");
    Expect(1, 67999, '\P{^Is_Block=MEROITIC_Hieroglyphs}', "");
    Expect(0, 68000, '\p{Is_Block=MEROITIC_Hieroglyphs}', "");
    Expect(1, 68000, '\p{^Is_Block=MEROITIC_Hieroglyphs}', "");
    Expect(1, 68000, '\P{Is_Block=MEROITIC_Hieroglyphs}', "");
    Expect(0, 68000, '\P{^Is_Block=MEROITIC_Hieroglyphs}', "");
    Error('\p{Is_Blk=:= _Meroitic_Hieroglyphs}');
    Error('\P{Is_Blk=:= _Meroitic_Hieroglyphs}');
    Expect(1, 67999, '\p{Is_Blk=meroitichieroglyphs}', "");
    Expect(0, 67999, '\p{^Is_Blk=meroitichieroglyphs}', "");
    Expect(0, 67999, '\P{Is_Blk=meroitichieroglyphs}', "");
    Expect(1, 67999, '\P{^Is_Blk=meroitichieroglyphs}', "");
    Expect(0, 68000, '\p{Is_Blk=meroitichieroglyphs}', "");
    Expect(1, 68000, '\p{^Is_Blk=meroitichieroglyphs}', "");
    Expect(1, 68000, '\P{Is_Blk=meroitichieroglyphs}', "");
    Expect(0, 68000, '\P{^Is_Blk=meroitichieroglyphs}', "");
    Expect(1, 67999, '\p{Is_Blk=-	meroitic_hieroglyphs}', "");
    Expect(0, 67999, '\p{^Is_Blk=-	meroitic_hieroglyphs}', "");
    Expect(0, 67999, '\P{Is_Blk=-	meroitic_hieroglyphs}', "");
    Expect(1, 67999, '\P{^Is_Blk=-	meroitic_hieroglyphs}', "");
    Expect(0, 68000, '\p{Is_Blk=-	meroitic_hieroglyphs}', "");
    Expect(1, 68000, '\p{^Is_Blk=-	meroitic_hieroglyphs}', "");
    Expect(1, 68000, '\P{Is_Blk=-	meroitic_hieroglyphs}', "");
    Expect(0, 68000, '\P{^Is_Blk=-	meroitic_hieroglyphs}', "");
    Error('\p{Block=_/a/MIAO}');
    Error('\P{Block=_/a/MIAO}');
    Expect(1, 94111, '\p{Block=:\AMiao\z:}', "");;
    Expect(0, 94112, '\p{Block=:\AMiao\z:}', "");;
    Expect(1, 94111, '\p{Block=miao}', "");
    Expect(0, 94111, '\p{^Block=miao}', "");
    Expect(0, 94111, '\P{Block=miao}', "");
    Expect(1, 94111, '\P{^Block=miao}', "");
    Expect(0, 94112, '\p{Block=miao}', "");
    Expect(1, 94112, '\p{^Block=miao}', "");
    Expect(1, 94112, '\P{Block=miao}', "");
    Expect(0, 94112, '\P{^Block=miao}', "");
    Expect(1, 94111, '\p{Block=:\Amiao\z:}', "");;
    Expect(0, 94112, '\p{Block=:\Amiao\z:}', "");;
    Expect(1, 94111, '\p{Block:Miao}', "");
    Expect(0, 94111, '\p{^Block:Miao}', "");
    Expect(0, 94111, '\P{Block:Miao}', "");
    Expect(1, 94111, '\P{^Block:Miao}', "");
    Expect(0, 94112, '\p{Block:Miao}', "");
    Expect(1, 94112, '\p{^Block:Miao}', "");
    Expect(1, 94112, '\P{Block:Miao}', "");
    Expect(0, 94112, '\P{^Block:Miao}', "");
    Error('\p{Blk=-_miao/a/}');
    Error('\P{Blk=-_miao/a/}');
    Expect(1, 94111, '\p{Blk=:\AMiao\z:}', "");;
    Expect(0, 94112, '\p{Blk=:\AMiao\z:}', "");;
    Expect(1, 94111, '\p{Blk=miao}', "");
    Expect(0, 94111, '\p{^Blk=miao}', "");
    Expect(0, 94111, '\P{Blk=miao}', "");
    Expect(1, 94111, '\P{^Blk=miao}', "");
    Expect(0, 94112, '\p{Blk=miao}', "");
    Expect(1, 94112, '\p{^Blk=miao}', "");
    Expect(1, 94112, '\P{Blk=miao}', "");
    Expect(0, 94112, '\P{^Blk=miao}', "");
    Expect(1, 94111, '\p{Blk=:\Amiao\z:}', "");;
    Expect(0, 94112, '\p{Blk=:\Amiao\z:}', "");;
    Expect(1, 94111, '\p{Blk=_ Miao}', "");
    Expect(0, 94111, '\p{^Blk=_ Miao}', "");
    Expect(0, 94111, '\P{Blk=_ Miao}', "");
    Expect(1, 94111, '\P{^Blk=_ Miao}', "");
    Expect(0, 94112, '\p{Blk=_ Miao}', "");
    Expect(1, 94112, '\p{^Blk=_ Miao}', "");
    Expect(1, 94112, '\P{Blk=_ Miao}', "");
    Expect(0, 94112, '\P{^Blk=_ Miao}', "");
    Error('\p{Is_Block=/a/Miao}');
    Error('\P{Is_Block=/a/Miao}');
    Expect(1, 94111, '\p{Is_Block=miao}', "");
    Expect(0, 94111, '\p{^Is_Block=miao}', "");
    Expect(0, 94111, '\P{Is_Block=miao}', "");
    Expect(1, 94111, '\P{^Is_Block=miao}', "");
    Expect(0, 94112, '\p{Is_Block=miao}', "");
    Expect(1, 94112, '\p{^Is_Block=miao}', "");
    Expect(1, 94112, '\P{Is_Block=miao}', "");
    Expect(0, 94112, '\P{^Is_Block=miao}', "");
    Expect(1, 94111, '\p{Is_Block=-MIAO}', "");
    Expect(0, 94111, '\p{^Is_Block=-MIAO}', "");
    Expect(0, 94111, '\P{Is_Block=-MIAO}', "");
    Expect(1, 94111, '\P{^Is_Block=-MIAO}', "");
    Expect(0, 94112, '\p{Is_Block=-MIAO}', "");
    Expect(1, 94112, '\p{^Is_Block=-MIAO}', "");
    Expect(1, 94112, '\P{Is_Block=-MIAO}', "");
    Expect(0, 94112, '\P{^Is_Block=-MIAO}', "");
    Error('\p{Is_Blk=:= Miao}');
    Error('\P{Is_Blk=:= Miao}');
    Expect(1, 94111, '\p{Is_Blk=miao}', "");
    Expect(0, 94111, '\p{^Is_Blk=miao}', "");
    Expect(0, 94111, '\P{Is_Blk=miao}', "");
    Expect(1, 94111, '\P{^Is_Blk=miao}', "");
    Expect(0, 94112, '\p{Is_Blk=miao}', "");
    Expect(1, 94112, '\p{^Is_Blk=miao}', "");
    Expect(1, 94112, '\P{Is_Blk=miao}', "");
    Expect(0, 94112, '\P{^Is_Blk=miao}', "");
    Expect(1, 94111, '\p{Is_Blk= 	Miao}', "");
    Expect(0, 94111, '\p{^Is_Blk= 	Miao}', "");
    Expect(0, 94111, '\P{Is_Blk= 	Miao}', "");
    Expect(1, 94111, '\P{^Is_Blk= 	Miao}', "");
    Expect(0, 94112, '\p{Is_Blk= 	Miao}', "");
    Expect(1, 94112, '\p{^Is_Blk= 	Miao}', "");
    Expect(1, 94112, '\P{Is_Blk= 	Miao}', "");
    Expect(0, 94112, '\P{^Is_Blk= 	Miao}', "");
    Error('\p{Block:   :=Miscellaneous_SYMBOLS_And_Arrows}');
    Error('\P{Block:   :=Miscellaneous_SYMBOLS_And_Arrows}');
    Expect(1, 11263, '\p{Block=:\AMiscellaneous_Symbols_And_Arrows\z:}', "");;
    Expect(0, 11264, '\p{Block=:\AMiscellaneous_Symbols_And_Arrows\z:}', "");;
    Expect(1, 11263, '\p{Block=miscellaneoussymbolsandarrows}', "");
    Expect(0, 11263, '\p{^Block=miscellaneoussymbolsandarrows}', "");
    Expect(0, 11263, '\P{Block=miscellaneoussymbolsandarrows}', "");
    Expect(1, 11263, '\P{^Block=miscellaneoussymbolsandarrows}', "");
    Expect(0, 11264, '\p{Block=miscellaneoussymbolsandarrows}', "");
    Expect(1, 11264, '\p{^Block=miscellaneoussymbolsandarrows}', "");
    Expect(1, 11264, '\P{Block=miscellaneoussymbolsandarrows}', "");
    Expect(0, 11264, '\P{^Block=miscellaneoussymbolsandarrows}', "");
    Expect(1, 11263, '\p{Block=:\Amiscellaneoussymbolsandarrows\z:}', "");;
    Expect(0, 11264, '\p{Block=:\Amiscellaneoussymbolsandarrows\z:}', "");;
    Expect(1, 11263, '\p{Block=_-MISCELLANEOUS_Symbols_And_Arrows}', "");
    Expect(0, 11263, '\p{^Block=_-MISCELLANEOUS_Symbols_And_Arrows}', "");
    Expect(0, 11263, '\P{Block=_-MISCELLANEOUS_Symbols_And_Arrows}', "");
    Expect(1, 11263, '\P{^Block=_-MISCELLANEOUS_Symbols_And_Arrows}', "");
    Expect(0, 11264, '\p{Block=_-MISCELLANEOUS_Symbols_And_Arrows}', "");
    Expect(1, 11264, '\p{^Block=_-MISCELLANEOUS_Symbols_And_Arrows}', "");
    Expect(1, 11264, '\P{Block=_-MISCELLANEOUS_Symbols_And_Arrows}', "");
    Expect(0, 11264, '\P{^Block=_-MISCELLANEOUS_Symbols_And_Arrows}', "");
    Error('\p{Blk=-misc_arrows/a/}');
    Error('\P{Blk=-misc_arrows/a/}');
    Expect(1, 11263, '\p{Blk=:\AMisc_Arrows\z:}', "");;
    Expect(0, 11264, '\p{Blk=:\AMisc_Arrows\z:}', "");;
    Expect(1, 11263, '\p{Blk=miscarrows}', "");
    Expect(0, 11263, '\p{^Blk=miscarrows}', "");
    Expect(0, 11263, '\P{Blk=miscarrows}', "");
    Expect(1, 11263, '\P{^Blk=miscarrows}', "");
    Expect(0, 11264, '\p{Blk=miscarrows}', "");
    Expect(1, 11264, '\p{^Blk=miscarrows}', "");
    Expect(1, 11264, '\P{Blk=miscarrows}', "");
    Expect(0, 11264, '\P{^Blk=miscarrows}', "");
    Expect(1, 11263, '\p{Blk=:\Amiscarrows\z:}', "");;
    Expect(0, 11264, '\p{Blk=:\Amiscarrows\z:}', "");;
    Expect(1, 11263, '\p{Blk=_	MISC_Arrows}', "");
    Expect(0, 11263, '\p{^Blk=_	MISC_Arrows}', "");
    Expect(0, 11263, '\P{Blk=_	MISC_Arrows}', "");
    Expect(1, 11263, '\P{^Blk=_	MISC_Arrows}', "");
    Expect(0, 11264, '\p{Blk=_	MISC_Arrows}', "");
    Expect(1, 11264, '\p{^Blk=_	MISC_Arrows}', "");
    Expect(1, 11264, '\P{Blk=_	MISC_Arrows}', "");
    Expect(0, 11264, '\P{^Blk=_	MISC_Arrows}', "");
    Error('\p{Is_Block=--Miscellaneous_Symbols_And_arrows:=}');
    Error('\P{Is_Block=--Miscellaneous_Symbols_And_arrows:=}');
    Expect(1, 11263, '\p{Is_Block=miscellaneoussymbolsandarrows}', "");
    Expect(0, 11263, '\p{^Is_Block=miscellaneoussymbolsandarrows}', "");
    Expect(0, 11263, '\P{Is_Block=miscellaneoussymbolsandarrows}', "");
    Expect(1, 11263, '\P{^Is_Block=miscellaneoussymbolsandarrows}', "");
    Expect(0, 11264, '\p{Is_Block=miscellaneoussymbolsandarrows}', "");
    Expect(1, 11264, '\p{^Is_Block=miscellaneoussymbolsandarrows}', "");
    Expect(1, 11264, '\P{Is_Block=miscellaneoussymbolsandarrows}', "");
    Expect(0, 11264, '\P{^Is_Block=miscellaneoussymbolsandarrows}', "");
    Expect(1, 11263, '\p{Is_Block=_miscellaneous_Symbols_AND_ARROWS}', "");
    Expect(0, 11263, '\p{^Is_Block=_miscellaneous_Symbols_AND_ARROWS}', "");
    Expect(0, 11263, '\P{Is_Block=_miscellaneous_Symbols_AND_ARROWS}', "");
    Expect(1, 11263, '\P{^Is_Block=_miscellaneous_Symbols_AND_ARROWS}', "");
    Expect(0, 11264, '\p{Is_Block=_miscellaneous_Symbols_AND_ARROWS}', "");
    Expect(1, 11264, '\p{^Is_Block=_miscellaneous_Symbols_AND_ARROWS}', "");
    Expect(1, 11264, '\P{Is_Block=_miscellaneous_Symbols_AND_ARROWS}', "");
    Expect(0, 11264, '\P{^Is_Block=_miscellaneous_Symbols_AND_ARROWS}', "");
    Error('\p{Is_Blk=/a/MISC_arrows}');
    Error('\P{Is_Blk=/a/MISC_arrows}');
    Expect(1, 11263, '\p{Is_Blk=miscarrows}', "");
    Expect(0, 11263, '\p{^Is_Blk=miscarrows}', "");
    Expect(0, 11263, '\P{Is_Blk=miscarrows}', "");
    Expect(1, 11263, '\P{^Is_Blk=miscarrows}', "");
    Expect(0, 11264, '\p{Is_Blk=miscarrows}', "");
    Expect(1, 11264, '\p{^Is_Blk=miscarrows}', "");
    Expect(1, 11264, '\P{Is_Blk=miscarrows}', "");
    Expect(0, 11264, '\P{^Is_Blk=miscarrows}', "");
    Expect(1, 11263, '\p{Is_Blk=	 Misc_Arrows}', "");
    Expect(0, 11263, '\p{^Is_Blk=	 Misc_Arrows}', "");
    Expect(0, 11263, '\P{Is_Blk=	 Misc_Arrows}', "");
    Expect(1, 11263, '\P{^Is_Blk=	 Misc_Arrows}', "");
    Expect(0, 11264, '\p{Is_Blk=	 Misc_Arrows}', "");
    Expect(1, 11264, '\p{^Is_Blk=	 Misc_Arrows}', "");
    Expect(1, 11264, '\P{Is_Blk=	 Misc_Arrows}', "");
    Expect(0, 11264, '\P{^Is_Blk=	 Misc_Arrows}', "");
    Error('\p{Block=/a/_Miscellaneous_MATHEMATICAL_Symbols_A}');
    Error('\P{Block=/a/_Miscellaneous_MATHEMATICAL_Symbols_A}');
    Expect(1, 10223, '\p{Block=:\AMiscellaneous_Mathematical_Symbols_A\z:}', "");;
    Expect(0, 10224, '\p{Block=:\AMiscellaneous_Mathematical_Symbols_A\z:}', "");;
    Expect(1, 10223, '\p{Block=miscellaneousmathematicalsymbolsa}', "");
    Expect(0, 10223, '\p{^Block=miscellaneousmathematicalsymbolsa}', "");
    Expect(0, 10223, '\P{Block=miscellaneousmathematicalsymbolsa}', "");
    Expect(1, 10223, '\P{^Block=miscellaneousmathematicalsymbolsa}', "");
    Expect(0, 10224, '\p{Block=miscellaneousmathematicalsymbolsa}', "");
    Expect(1, 10224, '\p{^Block=miscellaneousmathematicalsymbolsa}', "");
    Expect(1, 10224, '\P{Block=miscellaneousmathematicalsymbolsa}', "");
    Expect(0, 10224, '\P{^Block=miscellaneousmathematicalsymbolsa}', "");
    Expect(1, 10223, '\p{Block=:\Amiscellaneousmathematicalsymbolsa\z:}', "");;
    Expect(0, 10224, '\p{Block=:\Amiscellaneousmathematicalsymbolsa\z:}', "");;
    Expect(1, 10223, '\p{Block=	miscellaneous_mathematical_Symbols_a}', "");
    Expect(0, 10223, '\p{^Block=	miscellaneous_mathematical_Symbols_a}', "");
    Expect(0, 10223, '\P{Block=	miscellaneous_mathematical_Symbols_a}', "");
    Expect(1, 10223, '\P{^Block=	miscellaneous_mathematical_Symbols_a}', "");
    Expect(0, 10224, '\p{Block=	miscellaneous_mathematical_Symbols_a}', "");
    Expect(1, 10224, '\p{^Block=	miscellaneous_mathematical_Symbols_a}', "");
    Expect(1, 10224, '\P{Block=	miscellaneous_mathematical_Symbols_a}', "");
    Expect(0, 10224, '\P{^Block=	miscellaneous_mathematical_Symbols_a}', "");
    Error('\p{Blk=:=-Misc_math_Symbols_A}');
    Error('\P{Blk=:=-Misc_math_Symbols_A}');
    Expect(1, 10223, '\p{Blk=:\AMisc_Math_Symbols_A\z:}', "");;
    Expect(0, 10224, '\p{Blk=:\AMisc_Math_Symbols_A\z:}', "");;
    Expect(1, 10223, '\p{Blk=miscmathsymbolsa}', "");
    Expect(0, 10223, '\p{^Blk=miscmathsymbolsa}', "");
    Expect(0, 10223, '\P{Blk=miscmathsymbolsa}', "");
    Expect(1, 10223, '\P{^Blk=miscmathsymbolsa}', "");
    Expect(0, 10224, '\p{Blk=miscmathsymbolsa}', "");
    Expect(1, 10224, '\p{^Blk=miscmathsymbolsa}', "");
    Expect(1, 10224, '\P{Blk=miscmathsymbolsa}', "");
    Expect(0, 10224, '\P{^Blk=miscmathsymbolsa}', "");
    Expect(1, 10223, '\p{Blk=:\Amiscmathsymbolsa\z:}', "");;
    Expect(0, 10224, '\p{Blk=:\Amiscmathsymbolsa\z:}', "");;
    Expect(1, 10223, '\p{Blk=--MISC_MATH_symbols_A}', "");
    Expect(0, 10223, '\p{^Blk=--MISC_MATH_symbols_A}', "");
    Expect(0, 10223, '\P{Blk=--MISC_MATH_symbols_A}', "");
    Expect(1, 10223, '\P{^Blk=--MISC_MATH_symbols_A}', "");
    Expect(0, 10224, '\p{Blk=--MISC_MATH_symbols_A}', "");
    Expect(1, 10224, '\p{^Blk=--MISC_MATH_symbols_A}', "");
    Expect(1, 10224, '\P{Blk=--MISC_MATH_symbols_A}', "");
    Expect(0, 10224, '\P{^Blk=--MISC_MATH_symbols_A}', "");
    Error('\p{Is_Block=/a/  miscellaneous_MATHEMATICAL_Symbols_a}');
    Error('\P{Is_Block=/a/  miscellaneous_MATHEMATICAL_Symbols_a}');
    Expect(1, 10223, '\p{Is_Block=miscellaneousmathematicalsymbolsa}', "");
    Expect(0, 10223, '\p{^Is_Block=miscellaneousmathematicalsymbolsa}', "");
    Expect(0, 10223, '\P{Is_Block=miscellaneousmathematicalsymbolsa}', "");
    Expect(1, 10223, '\P{^Is_Block=miscellaneousmathematicalsymbolsa}', "");
    Expect(0, 10224, '\p{Is_Block=miscellaneousmathematicalsymbolsa}', "");
    Expect(1, 10224, '\p{^Is_Block=miscellaneousmathematicalsymbolsa}', "");
    Expect(1, 10224, '\P{Is_Block=miscellaneousmathematicalsymbolsa}', "");
    Expect(0, 10224, '\P{^Is_Block=miscellaneousmathematicalsymbolsa}', "");
    Expect(1, 10223, '\p{Is_Block=-miscellaneous_Mathematical_Symbols_a}', "");
    Expect(0, 10223, '\p{^Is_Block=-miscellaneous_Mathematical_Symbols_a}', "");
    Expect(0, 10223, '\P{Is_Block=-miscellaneous_Mathematical_Symbols_a}', "");
    Expect(1, 10223, '\P{^Is_Block=-miscellaneous_Mathematical_Symbols_a}', "");
    Expect(0, 10224, '\p{Is_Block=-miscellaneous_Mathematical_Symbols_a}', "");
    Expect(1, 10224, '\p{^Is_Block=-miscellaneous_Mathematical_Symbols_a}', "");
    Expect(1, 10224, '\P{Is_Block=-miscellaneous_Mathematical_Symbols_a}', "");
    Expect(0, 10224, '\P{^Is_Block=-miscellaneous_Mathematical_Symbols_a}', "");
    Error('\p{Is_Blk=-/a/Misc_Math_Symbols_A}');
    Error('\P{Is_Blk=-/a/Misc_Math_Symbols_A}');
    Expect(1, 10223, '\p{Is_Blk=miscmathsymbolsa}', "");
    Expect(0, 10223, '\p{^Is_Blk=miscmathsymbolsa}', "");
    Expect(0, 10223, '\P{Is_Blk=miscmathsymbolsa}', "");
    Expect(1, 10223, '\P{^Is_Blk=miscmathsymbolsa}', "");
    Expect(0, 10224, '\p{Is_Blk=miscmathsymbolsa}', "");
    Expect(1, 10224, '\p{^Is_Blk=miscmathsymbolsa}', "");
    Expect(1, 10224, '\P{Is_Blk=miscmathsymbolsa}', "");
    Expect(0, 10224, '\P{^Is_Blk=miscmathsymbolsa}', "");
    Expect(1, 10223, '\p{Is_Blk=	Misc_Math_SYMBOLS_A}', "");
    Expect(0, 10223, '\p{^Is_Blk=	Misc_Math_SYMBOLS_A}', "");
    Expect(0, 10223, '\P{Is_Blk=	Misc_Math_SYMBOLS_A}', "");
    Expect(1, 10223, '\P{^Is_Blk=	Misc_Math_SYMBOLS_A}', "");
    Expect(0, 10224, '\p{Is_Blk=	Misc_Math_SYMBOLS_A}', "");
    Expect(1, 10224, '\p{^Is_Blk=	Misc_Math_SYMBOLS_A}', "");
    Expect(1, 10224, '\P{Is_Blk=	Misc_Math_SYMBOLS_A}', "");
    Expect(0, 10224, '\P{^Is_Blk=	Misc_Math_SYMBOLS_A}', "");
    Error('\p{Block=/a/ _miscellaneous_Mathematical_symbols_B}');
    Error('\P{Block=/a/ _miscellaneous_Mathematical_symbols_B}');
    Expect(1, 10751, '\p{Block=:\AMiscellaneous_Mathematical_Symbols_B\z:}', "");;
    Expect(0, 10752, '\p{Block=:\AMiscellaneous_Mathematical_Symbols_B\z:}', "");;
    Expect(1, 10751, '\p{Block:   miscellaneousmathematicalsymbolsb}', "");
    Expect(0, 10751, '\p{^Block:   miscellaneousmathematicalsymbolsb}', "");
    Expect(0, 10751, '\P{Block:   miscellaneousmathematicalsymbolsb}', "");
    Expect(1, 10751, '\P{^Block:   miscellaneousmathematicalsymbolsb}', "");
    Expect(0, 10752, '\p{Block:   miscellaneousmathematicalsymbolsb}', "");
    Expect(1, 10752, '\p{^Block:   miscellaneousmathematicalsymbolsb}', "");
    Expect(1, 10752, '\P{Block:   miscellaneousmathematicalsymbolsb}', "");
    Expect(0, 10752, '\P{^Block:   miscellaneousmathematicalsymbolsb}', "");
    Expect(1, 10751, '\p{Block=:\Amiscellaneousmathematicalsymbolsb\z:}', "");;
    Expect(0, 10752, '\p{Block=:\Amiscellaneousmathematicalsymbolsb\z:}', "");;
    Expect(1, 10751, '\p{Block:   -_Miscellaneous_mathematical_symbols_B}', "");
    Expect(0, 10751, '\p{^Block:   -_Miscellaneous_mathematical_symbols_B}', "");
    Expect(0, 10751, '\P{Block:   -_Miscellaneous_mathematical_symbols_B}', "");
    Expect(1, 10751, '\P{^Block:   -_Miscellaneous_mathematical_symbols_B}', "");
    Expect(0, 10752, '\p{Block:   -_Miscellaneous_mathematical_symbols_B}', "");
    Expect(1, 10752, '\p{^Block:   -_Miscellaneous_mathematical_symbols_B}', "");
    Expect(1, 10752, '\P{Block:   -_Miscellaneous_mathematical_symbols_B}', "");
    Expect(0, 10752, '\P{^Block:   -_Miscellaneous_mathematical_symbols_B}', "");
    Error('\p{Blk=_:=MISC_Math_Symbols_B}');
    Error('\P{Blk=_:=MISC_Math_Symbols_B}');
    Expect(1, 10751, '\p{Blk=:\AMisc_Math_Symbols_B\z:}', "");;
    Expect(0, 10752, '\p{Blk=:\AMisc_Math_Symbols_B\z:}', "");;
    Expect(1, 10751, '\p{Blk=miscmathsymbolsb}', "");
    Expect(0, 10751, '\p{^Blk=miscmathsymbolsb}', "");
    Expect(0, 10751, '\P{Blk=miscmathsymbolsb}', "");
    Expect(1, 10751, '\P{^Blk=miscmathsymbolsb}', "");
    Expect(0, 10752, '\p{Blk=miscmathsymbolsb}', "");
    Expect(1, 10752, '\p{^Blk=miscmathsymbolsb}', "");
    Expect(1, 10752, '\P{Blk=miscmathsymbolsb}', "");
    Expect(0, 10752, '\P{^Blk=miscmathsymbolsb}', "");
    Expect(1, 10751, '\p{Blk=:\Amiscmathsymbolsb\z:}', "");;
    Expect(0, 10752, '\p{Blk=:\Amiscmathsymbolsb\z:}', "");;
    Expect(1, 10751, '\p{Blk=-Misc_MATH_Symbols_b}', "");
    Expect(0, 10751, '\p{^Blk=-Misc_MATH_Symbols_b}', "");
    Expect(0, 10751, '\P{Blk=-Misc_MATH_Symbols_b}', "");
    Expect(1, 10751, '\P{^Blk=-Misc_MATH_Symbols_b}', "");
    Expect(0, 10752, '\p{Blk=-Misc_MATH_Symbols_b}', "");
    Expect(1, 10752, '\p{^Blk=-Misc_MATH_Symbols_b}', "");
    Expect(1, 10752, '\P{Blk=-Misc_MATH_Symbols_b}', "");
    Expect(0, 10752, '\P{^Blk=-Misc_MATH_Symbols_b}', "");
    Error('\p{Is_Block=/a/Miscellaneous_Mathematical_symbols_B}');
    Error('\P{Is_Block=/a/Miscellaneous_Mathematical_symbols_B}');
    Expect(1, 10751, '\p{Is_Block=miscellaneousmathematicalsymbolsb}', "");
    Expect(0, 10751, '\p{^Is_Block=miscellaneousmathematicalsymbolsb}', "");
    Expect(0, 10751, '\P{Is_Block=miscellaneousmathematicalsymbolsb}', "");
    Expect(1, 10751, '\P{^Is_Block=miscellaneousmathematicalsymbolsb}', "");
    Expect(0, 10752, '\p{Is_Block=miscellaneousmathematicalsymbolsb}', "");
    Expect(1, 10752, '\p{^Is_Block=miscellaneousmathematicalsymbolsb}', "");
    Expect(1, 10752, '\P{Is_Block=miscellaneousmathematicalsymbolsb}', "");
    Expect(0, 10752, '\P{^Is_Block=miscellaneousmathematicalsymbolsb}', "");
    Expect(1, 10751, '\p{Is_Block= miscellaneous_Mathematical_SYMBOLS_B}', "");
    Expect(0, 10751, '\p{^Is_Block= miscellaneous_Mathematical_SYMBOLS_B}', "");
    Expect(0, 10751, '\P{Is_Block= miscellaneous_Mathematical_SYMBOLS_B}', "");
    Expect(1, 10751, '\P{^Is_Block= miscellaneous_Mathematical_SYMBOLS_B}', "");
    Expect(0, 10752, '\p{Is_Block= miscellaneous_Mathematical_SYMBOLS_B}', "");
    Expect(1, 10752, '\p{^Is_Block= miscellaneous_Mathematical_SYMBOLS_B}', "");
    Expect(1, 10752, '\P{Is_Block= miscellaneous_Mathematical_SYMBOLS_B}', "");
    Expect(0, 10752, '\P{^Is_Block= miscellaneous_Mathematical_SYMBOLS_B}', "");
    Error('\p{Is_Blk=--Misc_Math_SYMBOLS_B:=}');
    Error('\P{Is_Blk=--Misc_Math_SYMBOLS_B:=}');
    Expect(1, 10751, '\p{Is_Blk=miscmathsymbolsb}', "");
    Expect(0, 10751, '\p{^Is_Blk=miscmathsymbolsb}', "");
    Expect(0, 10751, '\P{Is_Blk=miscmathsymbolsb}', "");
    Expect(1, 10751, '\P{^Is_Blk=miscmathsymbolsb}', "");
    Expect(0, 10752, '\p{Is_Blk=miscmathsymbolsb}', "");
    Expect(1, 10752, '\p{^Is_Blk=miscmathsymbolsb}', "");
    Expect(1, 10752, '\P{Is_Blk=miscmathsymbolsb}', "");
    Expect(0, 10752, '\P{^Is_Blk=miscmathsymbolsb}', "");
    Expect(1, 10751, '\p{Is_Blk=_MISC_Math_SYMBOLS_B}', "");
    Expect(0, 10751, '\p{^Is_Blk=_MISC_Math_SYMBOLS_B}', "");
    Expect(0, 10751, '\P{Is_Blk=_MISC_Math_SYMBOLS_B}', "");
    Expect(1, 10751, '\P{^Is_Blk=_MISC_Math_SYMBOLS_B}', "");
    Expect(0, 10752, '\p{Is_Blk=_MISC_Math_SYMBOLS_B}', "");
    Expect(1, 10752, '\p{^Is_Blk=_MISC_Math_SYMBOLS_B}', "");
    Expect(1, 10752, '\P{Is_Blk=_MISC_Math_SYMBOLS_B}', "");
    Expect(0, 10752, '\P{^Is_Blk=_MISC_Math_SYMBOLS_B}', "");
    Error('\p{Block=:=-_miscellaneous_Symbols_AND_Pictographs}');
    Error('\P{Block=:=-_miscellaneous_Symbols_AND_Pictographs}');
    Expect(1, 128511, '\p{Block=:\AMiscellaneous_Symbols_And_Pictographs\z:}', "");;
    Expect(0, 128512, '\p{Block=:\AMiscellaneous_Symbols_And_Pictographs\z:}', "");;
    Expect(1, 128511, '\p{Block=miscellaneoussymbolsandpictographs}', "");
    Expect(0, 128511, '\p{^Block=miscellaneoussymbolsandpictographs}', "");
    Expect(0, 128511, '\P{Block=miscellaneoussymbolsandpictographs}', "");
    Expect(1, 128511, '\P{^Block=miscellaneoussymbolsandpictographs}', "");
    Expect(0, 128512, '\p{Block=miscellaneoussymbolsandpictographs}', "");
    Expect(1, 128512, '\p{^Block=miscellaneoussymbolsandpictographs}', "");
    Expect(1, 128512, '\P{Block=miscellaneoussymbolsandpictographs}', "");
    Expect(0, 128512, '\P{^Block=miscellaneoussymbolsandpictographs}', "");
    Expect(1, 128511, '\p{Block=:\Amiscellaneoussymbolsandpictographs\z:}', "");;
    Expect(0, 128512, '\p{Block=:\Amiscellaneoussymbolsandpictographs\z:}', "");;
    Expect(1, 128511, '\p{Block=--Miscellaneous_Symbols_and_Pictographs}', "");
    Expect(0, 128511, '\p{^Block=--Miscellaneous_Symbols_and_Pictographs}', "");
    Expect(0, 128511, '\P{Block=--Miscellaneous_Symbols_and_Pictographs}', "");
    Expect(1, 128511, '\P{^Block=--Miscellaneous_Symbols_and_Pictographs}', "");
    Expect(0, 128512, '\p{Block=--Miscellaneous_Symbols_and_Pictographs}', "");
    Expect(1, 128512, '\p{^Block=--Miscellaneous_Symbols_and_Pictographs}', "");
    Expect(1, 128512, '\P{Block=--Miscellaneous_Symbols_and_Pictographs}', "");
    Expect(0, 128512, '\P{^Block=--Miscellaneous_Symbols_and_Pictographs}', "");
    Error('\p{Blk=/a/- MISC_PICTOGRAPHS}');
    Error('\P{Blk=/a/- MISC_PICTOGRAPHS}');
    Expect(1, 128511, '\p{Blk=:\AMisc_Pictographs\z:}', "");;
    Expect(0, 128512, '\p{Blk=:\AMisc_Pictographs\z:}', "");;
    Expect(1, 128511, '\p{Blk=miscpictographs}', "");
    Expect(0, 128511, '\p{^Blk=miscpictographs}', "");
    Expect(0, 128511, '\P{Blk=miscpictographs}', "");
    Expect(1, 128511, '\P{^Blk=miscpictographs}', "");
    Expect(0, 128512, '\p{Blk=miscpictographs}', "");
    Expect(1, 128512, '\p{^Blk=miscpictographs}', "");
    Expect(1, 128512, '\P{Blk=miscpictographs}', "");
    Expect(0, 128512, '\P{^Blk=miscpictographs}', "");
    Expect(1, 128511, '\p{Blk=:\Amiscpictographs\z:}', "");;
    Expect(0, 128512, '\p{Blk=:\Amiscpictographs\z:}', "");;
    Expect(1, 128511, '\p{Blk= -Misc_Pictographs}', "");
    Expect(0, 128511, '\p{^Blk= -Misc_Pictographs}', "");
    Expect(0, 128511, '\P{Blk= -Misc_Pictographs}', "");
    Expect(1, 128511, '\P{^Blk= -Misc_Pictographs}', "");
    Expect(0, 128512, '\p{Blk= -Misc_Pictographs}', "");
    Expect(1, 128512, '\p{^Blk= -Misc_Pictographs}', "");
    Expect(1, 128512, '\P{Blk= -Misc_Pictographs}', "");
    Expect(0, 128512, '\P{^Blk= -Misc_Pictographs}', "");
    Error('\p{Is_Block=:=-miscellaneous_Symbols_And_PICTOGRAPHS}');
    Error('\P{Is_Block=:=-miscellaneous_Symbols_And_PICTOGRAPHS}');
    Expect(1, 128511, '\p{Is_Block=miscellaneoussymbolsandpictographs}', "");
    Expect(0, 128511, '\p{^Is_Block=miscellaneoussymbolsandpictographs}', "");
    Expect(0, 128511, '\P{Is_Block=miscellaneoussymbolsandpictographs}', "");
    Expect(1, 128511, '\P{^Is_Block=miscellaneoussymbolsandpictographs}', "");
    Expect(0, 128512, '\p{Is_Block=miscellaneoussymbolsandpictographs}', "");
    Expect(1, 128512, '\p{^Is_Block=miscellaneoussymbolsandpictographs}', "");
    Expect(1, 128512, '\P{Is_Block=miscellaneoussymbolsandpictographs}', "");
    Expect(0, 128512, '\P{^Is_Block=miscellaneoussymbolsandpictographs}', "");
    Expect(1, 128511, '\p{Is_Block=- Miscellaneous_Symbols_And_Pictographs}', "");
    Expect(0, 128511, '\p{^Is_Block=- Miscellaneous_Symbols_And_Pictographs}', "");
    Expect(0, 128511, '\P{Is_Block=- Miscellaneous_Symbols_And_Pictographs}', "");
    Expect(1, 128511, '\P{^Is_Block=- Miscellaneous_Symbols_And_Pictographs}', "");
    Expect(0, 128512, '\p{Is_Block=- Miscellaneous_Symbols_And_Pictographs}', "");
    Expect(1, 128512, '\p{^Is_Block=- Miscellaneous_Symbols_And_Pictographs}', "");
    Expect(1, 128512, '\P{Is_Block=- Miscellaneous_Symbols_And_Pictographs}', "");
    Expect(0, 128512, '\P{^Is_Block=- Miscellaneous_Symbols_And_Pictographs}', "");
    Error('\p{Is_Blk=-:=MISC_pictographs}');
    Error('\P{Is_Blk=-:=MISC_pictographs}');
    Expect(1, 128511, '\p{Is_Blk=miscpictographs}', "");
    Expect(0, 128511, '\p{^Is_Blk=miscpictographs}', "");
    Expect(0, 128511, '\P{Is_Blk=miscpictographs}', "");
    Expect(1, 128511, '\P{^Is_Blk=miscpictographs}', "");
    Expect(0, 128512, '\p{Is_Blk=miscpictographs}', "");
    Expect(1, 128512, '\p{^Is_Blk=miscpictographs}', "");
    Expect(1, 128512, '\P{Is_Blk=miscpictographs}', "");
    Expect(0, 128512, '\P{^Is_Blk=miscpictographs}', "");
    Expect(1, 128511, '\p{Is_Blk=	MISC_pictographs}', "");
    Expect(0, 128511, '\p{^Is_Blk=	MISC_pictographs}', "");
    Expect(0, 128511, '\P{Is_Blk=	MISC_pictographs}', "");
    Expect(1, 128511, '\P{^Is_Blk=	MISC_pictographs}', "");
    Expect(0, 128512, '\p{Is_Blk=	MISC_pictographs}', "");
    Expect(1, 128512, '\p{^Is_Blk=	MISC_pictographs}', "");
    Expect(1, 128512, '\P{Is_Blk=	MISC_pictographs}', "");
    Expect(0, 128512, '\P{^Is_Blk=	MISC_pictographs}', "");
    Error('\p{Block=-miscellaneous_Symbols:=}');
    Error('\P{Block=-miscellaneous_Symbols:=}');
    Expect(1, 9983, '\p{Block=:\AMiscellaneous_Symbols\z:}', "");;
    Expect(0, 9984, '\p{Block=:\AMiscellaneous_Symbols\z:}', "");;
    Expect(1, 9983, '\p{Block=miscellaneoussymbols}', "");
    Expect(0, 9983, '\p{^Block=miscellaneoussymbols}', "");
    Expect(0, 9983, '\P{Block=miscellaneoussymbols}', "");
    Expect(1, 9983, '\P{^Block=miscellaneoussymbols}', "");
    Expect(0, 9984, '\p{Block=miscellaneoussymbols}', "");
    Expect(1, 9984, '\p{^Block=miscellaneoussymbols}', "");
    Expect(1, 9984, '\P{Block=miscellaneoussymbols}', "");
    Expect(0, 9984, '\P{^Block=miscellaneoussymbols}', "");
    Expect(1, 9983, '\p{Block=:\Amiscellaneoussymbols\z:}', "");;
    Expect(0, 9984, '\p{Block=:\Amiscellaneoussymbols\z:}', "");;
    Expect(1, 9983, '\p{Block:		Miscellaneous_SYMBOLS}', "");
    Expect(0, 9983, '\p{^Block:		Miscellaneous_SYMBOLS}', "");
    Expect(0, 9983, '\P{Block:		Miscellaneous_SYMBOLS}', "");
    Expect(1, 9983, '\P{^Block:		Miscellaneous_SYMBOLS}', "");
    Expect(0, 9984, '\p{Block:		Miscellaneous_SYMBOLS}', "");
    Expect(1, 9984, '\p{^Block:		Miscellaneous_SYMBOLS}', "");
    Expect(1, 9984, '\P{Block:		Miscellaneous_SYMBOLS}', "");
    Expect(0, 9984, '\P{^Block:		Miscellaneous_SYMBOLS}', "");
    Error('\p{Blk=__Misc_symbols/a/}');
    Error('\P{Blk=__Misc_symbols/a/}');
    Expect(1, 9983, '\p{Blk=:\AMisc_Symbols\z:}', "");;
    Expect(0, 9984, '\p{Blk=:\AMisc_Symbols\z:}', "");;
    Expect(1, 9983, '\p{Blk=miscsymbols}', "");
    Expect(0, 9983, '\p{^Blk=miscsymbols}', "");
    Expect(0, 9983, '\P{Blk=miscsymbols}', "");
    Expect(1, 9983, '\P{^Blk=miscsymbols}', "");
    Expect(0, 9984, '\p{Blk=miscsymbols}', "");
    Expect(1, 9984, '\p{^Blk=miscsymbols}', "");
    Expect(1, 9984, '\P{Blk=miscsymbols}', "");
    Expect(0, 9984, '\P{^Blk=miscsymbols}', "");
    Expect(1, 9983, '\p{Blk=:\Amiscsymbols\z:}', "");;
    Expect(0, 9984, '\p{Blk=:\Amiscsymbols\z:}', "");;
    Expect(1, 9983, '\p{Blk=-MISC_SYMBOLS}', "");
    Expect(0, 9983, '\p{^Blk=-MISC_SYMBOLS}', "");
    Expect(0, 9983, '\P{Blk=-MISC_SYMBOLS}', "");
    Expect(1, 9983, '\P{^Blk=-MISC_SYMBOLS}', "");
    Expect(0, 9984, '\p{Blk=-MISC_SYMBOLS}', "");
    Expect(1, 9984, '\p{^Blk=-MISC_SYMBOLS}', "");
    Expect(1, 9984, '\P{Blk=-MISC_SYMBOLS}', "");
    Expect(0, 9984, '\P{^Blk=-MISC_SYMBOLS}', "");
    Error('\p{Is_Block=-_Miscellaneous_Symbols:=}');
    Error('\P{Is_Block=-_Miscellaneous_Symbols:=}');
    Expect(1, 9983, '\p{Is_Block=miscellaneoussymbols}', "");
    Expect(0, 9983, '\p{^Is_Block=miscellaneoussymbols}', "");
    Expect(0, 9983, '\P{Is_Block=miscellaneoussymbols}', "");
    Expect(1, 9983, '\P{^Is_Block=miscellaneoussymbols}', "");
    Expect(0, 9984, '\p{Is_Block=miscellaneoussymbols}', "");
    Expect(1, 9984, '\p{^Is_Block=miscellaneoussymbols}', "");
    Expect(1, 9984, '\P{Is_Block=miscellaneoussymbols}', "");
    Expect(0, 9984, '\P{^Is_Block=miscellaneoussymbols}', "");
    Expect(1, 9983, '\p{Is_Block= Miscellaneous_Symbols}', "");
    Expect(0, 9983, '\p{^Is_Block= Miscellaneous_Symbols}', "");
    Expect(0, 9983, '\P{Is_Block= Miscellaneous_Symbols}', "");
    Expect(1, 9983, '\P{^Is_Block= Miscellaneous_Symbols}', "");
    Expect(0, 9984, '\p{Is_Block= Miscellaneous_Symbols}', "");
    Expect(1, 9984, '\p{^Is_Block= Miscellaneous_Symbols}', "");
    Expect(1, 9984, '\P{Is_Block= Miscellaneous_Symbols}', "");
    Expect(0, 9984, '\P{^Is_Block= Miscellaneous_Symbols}', "");
    Error('\p{Is_Blk=-_MISC_Symbols:=}');
    Error('\P{Is_Blk=-_MISC_Symbols:=}');
    Expect(1, 9983, '\p{Is_Blk=miscsymbols}', "");
    Expect(0, 9983, '\p{^Is_Blk=miscsymbols}', "");
    Expect(0, 9983, '\P{Is_Blk=miscsymbols}', "");
    Expect(1, 9983, '\P{^Is_Blk=miscsymbols}', "");
    Expect(0, 9984, '\p{Is_Blk=miscsymbols}', "");
    Expect(1, 9984, '\p{^Is_Blk=miscsymbols}', "");
    Expect(1, 9984, '\P{Is_Blk=miscsymbols}', "");
    Expect(0, 9984, '\P{^Is_Blk=miscsymbols}', "");
    Expect(1, 9983, '\p{Is_Blk=__MISC_symbols}', "");
    Expect(0, 9983, '\p{^Is_Blk=__MISC_symbols}', "");
    Expect(0, 9983, '\P{Is_Blk=__MISC_symbols}', "");
    Expect(1, 9983, '\P{^Is_Blk=__MISC_symbols}', "");
    Expect(0, 9984, '\p{Is_Blk=__MISC_symbols}', "");
    Expect(1, 9984, '\p{^Is_Blk=__MISC_symbols}', "");
    Expect(1, 9984, '\P{Is_Blk=__MISC_symbols}', "");
    Expect(0, 9984, '\P{^Is_Blk=__MISC_symbols}', "");
    Error('\p{Block: /a/--MISCELLANEOUS_TECHNICAL}');
    Error('\P{Block: /a/--MISCELLANEOUS_TECHNICAL}');
    Expect(1, 9215, '\p{Block=:\AMiscellaneous_Technical\z:}', "");;
    Expect(0, 9216, '\p{Block=:\AMiscellaneous_Technical\z:}', "");;
    Expect(1, 9215, '\p{Block=miscellaneoustechnical}', "");
    Expect(0, 9215, '\p{^Block=miscellaneoustechnical}', "");
    Expect(0, 9215, '\P{Block=miscellaneoustechnical}', "");
    Expect(1, 9215, '\P{^Block=miscellaneoustechnical}', "");
    Expect(0, 9216, '\p{Block=miscellaneoustechnical}', "");
    Expect(1, 9216, '\p{^Block=miscellaneoustechnical}', "");
    Expect(1, 9216, '\P{Block=miscellaneoustechnical}', "");
    Expect(0, 9216, '\P{^Block=miscellaneoustechnical}', "");
    Expect(1, 9215, '\p{Block=:\Amiscellaneoustechnical\z:}', "");;
    Expect(0, 9216, '\p{Block=:\Amiscellaneoustechnical\z:}', "");;
    Expect(1, 9215, '\p{Block=-	Miscellaneous_Technical}', "");
    Expect(0, 9215, '\p{^Block=-	Miscellaneous_Technical}', "");
    Expect(0, 9215, '\P{Block=-	Miscellaneous_Technical}', "");
    Expect(1, 9215, '\P{^Block=-	Miscellaneous_Technical}', "");
    Expect(0, 9216, '\p{Block=-	Miscellaneous_Technical}', "");
    Expect(1, 9216, '\p{^Block=-	Miscellaneous_Technical}', "");
    Expect(1, 9216, '\P{Block=-	Miscellaneous_Technical}', "");
    Expect(0, 9216, '\P{^Block=-	Miscellaneous_Technical}', "");
    Error('\p{Blk=	_Misc_technical:=}');
    Error('\P{Blk=	_Misc_technical:=}');
    Expect(1, 9215, '\p{Blk=:\AMisc_Technical\z:}', "");;
    Expect(0, 9216, '\p{Blk=:\AMisc_Technical\z:}', "");;
    Expect(1, 9215, '\p{Blk=misctechnical}', "");
    Expect(0, 9215, '\p{^Blk=misctechnical}', "");
    Expect(0, 9215, '\P{Blk=misctechnical}', "");
    Expect(1, 9215, '\P{^Blk=misctechnical}', "");
    Expect(0, 9216, '\p{Blk=misctechnical}', "");
    Expect(1, 9216, '\p{^Blk=misctechnical}', "");
    Expect(1, 9216, '\P{Blk=misctechnical}', "");
    Expect(0, 9216, '\P{^Blk=misctechnical}', "");
    Expect(1, 9215, '\p{Blk=:\Amisctechnical\z:}', "");;
    Expect(0, 9216, '\p{Blk=:\Amisctechnical\z:}', "");;
    Expect(1, 9215, '\p{Blk=--misc_technical}', "");
    Expect(0, 9215, '\p{^Blk=--misc_technical}', "");
    Expect(0, 9215, '\P{Blk=--misc_technical}', "");
    Expect(1, 9215, '\P{^Blk=--misc_technical}', "");
    Expect(0, 9216, '\p{Blk=--misc_technical}', "");
    Expect(1, 9216, '\p{^Blk=--misc_technical}', "");
    Expect(1, 9216, '\P{Blk=--misc_technical}', "");
    Expect(0, 9216, '\P{^Blk=--misc_technical}', "");
    Error('\p{Is_Block=-Miscellaneous_Technical/a/}');
    Error('\P{Is_Block=-Miscellaneous_Technical/a/}');
    Expect(1, 9215, '\p{Is_Block=miscellaneoustechnical}', "");
    Expect(0, 9215, '\p{^Is_Block=miscellaneoustechnical}', "");
    Expect(0, 9215, '\P{Is_Block=miscellaneoustechnical}', "");
    Expect(1, 9215, '\P{^Is_Block=miscellaneoustechnical}', "");
    Expect(0, 9216, '\p{Is_Block=miscellaneoustechnical}', "");
    Expect(1, 9216, '\p{^Is_Block=miscellaneoustechnical}', "");
    Expect(1, 9216, '\P{Is_Block=miscellaneoustechnical}', "");
    Expect(0, 9216, '\P{^Is_Block=miscellaneoustechnical}', "");
    Expect(1, 9215, '\p{Is_Block=_ miscellaneous_Technical}', "");
    Expect(0, 9215, '\p{^Is_Block=_ miscellaneous_Technical}', "");
    Expect(0, 9215, '\P{Is_Block=_ miscellaneous_Technical}', "");
    Expect(1, 9215, '\P{^Is_Block=_ miscellaneous_Technical}', "");
    Expect(0, 9216, '\p{Is_Block=_ miscellaneous_Technical}', "");
    Expect(1, 9216, '\p{^Is_Block=_ miscellaneous_Technical}', "");
    Expect(1, 9216, '\P{Is_Block=_ miscellaneous_Technical}', "");
    Expect(0, 9216, '\P{^Is_Block=_ miscellaneous_Technical}', "");
    Error('\p{Is_Blk= -MISC_Technical/a/}');
    Error('\P{Is_Blk= -MISC_Technical/a/}');
    Expect(1, 9215, '\p{Is_Blk=misctechnical}', "");
    Expect(0, 9215, '\p{^Is_Blk=misctechnical}', "");
    Expect(0, 9215, '\P{Is_Blk=misctechnical}', "");
    Expect(1, 9215, '\P{^Is_Blk=misctechnical}', "");
    Expect(0, 9216, '\p{Is_Blk=misctechnical}', "");
    Expect(1, 9216, '\p{^Is_Blk=misctechnical}', "");
    Expect(1, 9216, '\P{Is_Blk=misctechnical}', "");
    Expect(0, 9216, '\P{^Is_Blk=misctechnical}', "");
    Expect(1, 9215, '\p{Is_Blk=	 Misc_TECHNICAL}', "");
    Expect(0, 9215, '\p{^Is_Blk=	 Misc_TECHNICAL}', "");
    Expect(0, 9215, '\P{Is_Blk=	 Misc_TECHNICAL}', "");
    Expect(1, 9215, '\P{^Is_Blk=	 Misc_TECHNICAL}', "");
    Expect(0, 9216, '\p{Is_Blk=	 Misc_TECHNICAL}', "");
    Expect(1, 9216, '\p{^Is_Blk=	 Misc_TECHNICAL}', "");
    Expect(1, 9216, '\P{Is_Blk=	 Misc_TECHNICAL}', "");
    Expect(0, 9216, '\P{^Is_Blk=	 Misc_TECHNICAL}', "");
    Error('\p{Block=	Modi:=}');
    Error('\P{Block=	Modi:=}');
    Expect(1, 71263, '\p{Block=:\AModi\z:}', "");;
    Expect(0, 71264, '\p{Block=:\AModi\z:}', "");;
    Expect(1, 71263, '\p{Block: modi}', "");
    Expect(0, 71263, '\p{^Block: modi}', "");
    Expect(0, 71263, '\P{Block: modi}', "");
    Expect(1, 71263, '\P{^Block: modi}', "");
    Expect(0, 71264, '\p{Block: modi}', "");
    Expect(1, 71264, '\p{^Block: modi}', "");
    Expect(1, 71264, '\P{Block: modi}', "");
    Expect(0, 71264, '\P{^Block: modi}', "");
    Expect(1, 71263, '\p{Block=:\Amodi\z:}', "");;
    Expect(0, 71264, '\p{Block=:\Amodi\z:}', "");;
    Expect(1, 71263, '\p{Block=- Modi}', "");
    Expect(0, 71263, '\p{^Block=- Modi}', "");
    Expect(0, 71263, '\P{Block=- Modi}', "");
    Expect(1, 71263, '\P{^Block=- Modi}', "");
    Expect(0, 71264, '\p{Block=- Modi}', "");
    Expect(1, 71264, '\p{^Block=- Modi}', "");
    Expect(1, 71264, '\P{Block=- Modi}', "");
    Expect(0, 71264, '\P{^Block=- Modi}', "");
    Error('\p{Blk=:=-Modi}');
    Error('\P{Blk=:=-Modi}');
    Expect(1, 71263, '\p{Blk=:\AModi\z:}', "");;
    Expect(0, 71264, '\p{Blk=:\AModi\z:}', "");;
    Expect(1, 71263, '\p{Blk:modi}', "");
    Expect(0, 71263, '\p{^Blk:modi}', "");
    Expect(0, 71263, '\P{Blk:modi}', "");
    Expect(1, 71263, '\P{^Blk:modi}', "");
    Expect(0, 71264, '\p{Blk:modi}', "");
    Expect(1, 71264, '\p{^Blk:modi}', "");
    Expect(1, 71264, '\P{Blk:modi}', "");
    Expect(0, 71264, '\P{^Blk:modi}', "");
    Expect(1, 71263, '\p{Blk=:\Amodi\z:}', "");;
    Expect(0, 71264, '\p{Blk=:\Amodi\z:}', "");;
    Expect(1, 71263, '\p{Blk= 	Modi}', "");
    Expect(0, 71263, '\p{^Blk= 	Modi}', "");
    Expect(0, 71263, '\P{Blk= 	Modi}', "");
    Expect(1, 71263, '\P{^Blk= 	Modi}', "");
    Expect(0, 71264, '\p{Blk= 	Modi}', "");
    Expect(1, 71264, '\p{^Blk= 	Modi}', "");
    Expect(1, 71264, '\P{Blk= 	Modi}', "");
    Expect(0, 71264, '\P{^Blk= 	Modi}', "");
    Error('\p{Is_Block:	-_MODI/a/}');
    Error('\P{Is_Block:	-_MODI/a/}');
    Expect(1, 71263, '\p{Is_Block=modi}', "");
    Expect(0, 71263, '\p{^Is_Block=modi}', "");
    Expect(0, 71263, '\P{Is_Block=modi}', "");
    Expect(1, 71263, '\P{^Is_Block=modi}', "");
    Expect(0, 71264, '\p{Is_Block=modi}', "");
    Expect(1, 71264, '\p{^Is_Block=modi}', "");
    Expect(1, 71264, '\P{Is_Block=modi}', "");
    Expect(0, 71264, '\P{^Is_Block=modi}', "");
    Expect(1, 71263, '\p{Is_Block:	 	Modi}', "");
    Expect(0, 71263, '\p{^Is_Block:	 	Modi}', "");
    Expect(0, 71263, '\P{Is_Block:	 	Modi}', "");
    Expect(1, 71263, '\P{^Is_Block:	 	Modi}', "");
    Expect(0, 71264, '\p{Is_Block:	 	Modi}', "");
    Expect(1, 71264, '\p{^Is_Block:	 	Modi}', "");
    Expect(1, 71264, '\P{Is_Block:	 	Modi}', "");
    Expect(0, 71264, '\P{^Is_Block:	 	Modi}', "");
    Error('\p{Is_Blk=	Modi:=}');
    Error('\P{Is_Blk=	Modi:=}');
    Expect(1, 71263, '\p{Is_Blk=modi}', "");
    Expect(0, 71263, '\p{^Is_Blk=modi}', "");
    Expect(0, 71263, '\P{Is_Blk=modi}', "");
    Expect(1, 71263, '\P{^Is_Blk=modi}', "");
    Expect(0, 71264, '\p{Is_Blk=modi}', "");
    Expect(1, 71264, '\p{^Is_Blk=modi}', "");
    Expect(1, 71264, '\P{Is_Blk=modi}', "");
    Expect(0, 71264, '\P{^Is_Blk=modi}', "");
    Expect(1, 71263, '\p{Is_Blk=	-Modi}', "");
    Expect(0, 71263, '\p{^Is_Blk=	-Modi}', "");
    Expect(0, 71263, '\P{Is_Blk=	-Modi}', "");
    Expect(1, 71263, '\P{^Is_Blk=	-Modi}', "");
    Expect(0, 71264, '\p{Is_Blk=	-Modi}', "");
    Expect(1, 71264, '\p{^Is_Blk=	-Modi}', "");
    Expect(1, 71264, '\P{Is_Blk=	-Modi}', "");
    Expect(0, 71264, '\P{^Is_Blk=	-Modi}', "");
    Error('\p{Block=/a/- SPACING_Modifier_Letters}');
    Error('\P{Block=/a/- SPACING_Modifier_Letters}');
    Expect(1, 767, '\p{Block=:\ASpacing_Modifier_Letters\z:}', "");;
    Expect(0, 768, '\p{Block=:\ASpacing_Modifier_Letters\z:}', "");;
    Expect(1, 767, '\p{Block=spacingmodifierletters}', "");
    Expect(0, 767, '\p{^Block=spacingmodifierletters}', "");
    Expect(0, 767, '\P{Block=spacingmodifierletters}', "");
    Expect(1, 767, '\P{^Block=spacingmodifierletters}', "");
    Expect(0, 768, '\p{Block=spacingmodifierletters}', "");
    Expect(1, 768, '\p{^Block=spacingmodifierletters}', "");
    Expect(1, 768, '\P{Block=spacingmodifierletters}', "");
    Expect(0, 768, '\P{^Block=spacingmodifierletters}', "");
    Expect(1, 767, '\p{Block=:\Aspacingmodifierletters\z:}', "");;
    Expect(0, 768, '\p{Block=:\Aspacingmodifierletters\z:}', "");;
    Expect(1, 767, '\p{Block= 	Spacing_MODIFIER_letters}', "");
    Expect(0, 767, '\p{^Block= 	Spacing_MODIFIER_letters}', "");
    Expect(0, 767, '\P{Block= 	Spacing_MODIFIER_letters}', "");
    Expect(1, 767, '\P{^Block= 	Spacing_MODIFIER_letters}', "");
    Expect(0, 768, '\p{Block= 	Spacing_MODIFIER_letters}', "");
    Expect(1, 768, '\p{^Block= 	Spacing_MODIFIER_letters}', "");
    Expect(1, 768, '\P{Block= 	Spacing_MODIFIER_letters}', "");
    Expect(0, 768, '\P{^Block= 	Spacing_MODIFIER_letters}', "");
    Error('\p{Blk:  /a/modifier_Letters}');
    Error('\P{Blk:  /a/modifier_Letters}');
    Expect(1, 767, '\p{Blk=:\AModifier_Letters\z:}', "");;
    Expect(0, 768, '\p{Blk=:\AModifier_Letters\z:}', "");;
    Expect(1, 767, '\p{Blk=modifierletters}', "");
    Expect(0, 767, '\p{^Blk=modifierletters}', "");
    Expect(0, 767, '\P{Blk=modifierletters}', "");
    Expect(1, 767, '\P{^Blk=modifierletters}', "");
    Expect(0, 768, '\p{Blk=modifierletters}', "");
    Expect(1, 768, '\p{^Blk=modifierletters}', "");
    Expect(1, 768, '\P{Blk=modifierletters}', "");
    Expect(0, 768, '\P{^Blk=modifierletters}', "");
    Expect(1, 767, '\p{Blk=:\Amodifierletters\z:}', "");;
    Expect(0, 768, '\p{Blk=:\Amodifierletters\z:}', "");;
    Expect(1, 767, '\p{Blk=  MODIFIER_Letters}', "");
    Expect(0, 767, '\p{^Blk=  MODIFIER_Letters}', "");
    Expect(0, 767, '\P{Blk=  MODIFIER_Letters}', "");
    Expect(1, 767, '\P{^Blk=  MODIFIER_Letters}', "");
    Expect(0, 768, '\p{Blk=  MODIFIER_Letters}', "");
    Expect(1, 768, '\p{^Blk=  MODIFIER_Letters}', "");
    Expect(1, 768, '\P{Blk=  MODIFIER_Letters}', "");
    Expect(0, 768, '\P{^Blk=  MODIFIER_Letters}', "");
    Error('\p{Is_Block=-/a/SPACING_MODIFIER_Letters}');
    Error('\P{Is_Block=-/a/SPACING_MODIFIER_Letters}');
    Expect(1, 767, '\p{Is_Block=spacingmodifierletters}', "");
    Expect(0, 767, '\p{^Is_Block=spacingmodifierletters}', "");
    Expect(0, 767, '\P{Is_Block=spacingmodifierletters}', "");
    Expect(1, 767, '\P{^Is_Block=spacingmodifierletters}', "");
    Expect(0, 768, '\p{Is_Block=spacingmodifierletters}', "");
    Expect(1, 768, '\p{^Is_Block=spacingmodifierletters}', "");
    Expect(1, 768, '\P{Is_Block=spacingmodifierletters}', "");
    Expect(0, 768, '\P{^Is_Block=spacingmodifierletters}', "");
    Expect(1, 767, '\p{Is_Block=-_Spacing_Modifier_letters}', "");
    Expect(0, 767, '\p{^Is_Block=-_Spacing_Modifier_letters}', "");
    Expect(0, 767, '\P{Is_Block=-_Spacing_Modifier_letters}', "");
    Expect(1, 767, '\P{^Is_Block=-_Spacing_Modifier_letters}', "");
    Expect(0, 768, '\p{Is_Block=-_Spacing_Modifier_letters}', "");
    Expect(1, 768, '\p{^Is_Block=-_Spacing_Modifier_letters}', "");
    Expect(1, 768, '\P{Is_Block=-_Spacing_Modifier_letters}', "");
    Expect(0, 768, '\P{^Is_Block=-_Spacing_Modifier_letters}', "");
    Error('\p{Is_Blk=:=modifier_Letters}');
    Error('\P{Is_Blk=:=modifier_Letters}');
    Expect(1, 767, '\p{Is_Blk=modifierletters}', "");
    Expect(0, 767, '\p{^Is_Blk=modifierletters}', "");
    Expect(0, 767, '\P{Is_Blk=modifierletters}', "");
    Expect(1, 767, '\P{^Is_Blk=modifierletters}', "");
    Expect(0, 768, '\p{Is_Blk=modifierletters}', "");
    Expect(1, 768, '\p{^Is_Blk=modifierletters}', "");
    Expect(1, 768, '\P{Is_Blk=modifierletters}', "");
    Expect(0, 768, '\P{^Is_Blk=modifierletters}', "");
    Expect(1, 767, '\p{Is_Blk=-MODIFIER_Letters}', "");
    Expect(0, 767, '\p{^Is_Blk=-MODIFIER_Letters}', "");
    Expect(0, 767, '\P{Is_Blk=-MODIFIER_Letters}', "");
    Expect(1, 767, '\P{^Is_Blk=-MODIFIER_Letters}', "");
    Expect(0, 768, '\p{Is_Blk=-MODIFIER_Letters}', "");
    Expect(1, 768, '\p{^Is_Blk=-MODIFIER_Letters}', "");
    Expect(1, 768, '\P{Is_Blk=-MODIFIER_Letters}', "");
    Expect(0, 768, '\P{^Is_Blk=-MODIFIER_Letters}', "");
    Error('\p{Block::=Modifier_Tone_Letters}');
    Error('\P{Block::=Modifier_Tone_Letters}');
    Expect(1, 42783, '\p{Block=:\AModifier_Tone_Letters\z:}', "");;
    Expect(0, 42784, '\p{Block=:\AModifier_Tone_Letters\z:}', "");;
    Expect(1, 42783, '\p{Block=modifiertoneletters}', "");
    Expect(0, 42783, '\p{^Block=modifiertoneletters}', "");
    Expect(0, 42783, '\P{Block=modifiertoneletters}', "");
    Expect(1, 42783, '\P{^Block=modifiertoneletters}', "");
    Expect(0, 42784, '\p{Block=modifiertoneletters}', "");
    Expect(1, 42784, '\p{^Block=modifiertoneletters}', "");
    Expect(1, 42784, '\P{Block=modifiertoneletters}', "");
    Expect(0, 42784, '\P{^Block=modifiertoneletters}', "");
    Expect(1, 42783, '\p{Block=:\Amodifiertoneletters\z:}', "");;
    Expect(0, 42784, '\p{Block=:\Amodifiertoneletters\z:}', "");;
    Expect(1, 42783, '\p{Block=	modifier_tone_letters}', "");
    Expect(0, 42783, '\p{^Block=	modifier_tone_letters}', "");
    Expect(0, 42783, '\P{Block=	modifier_tone_letters}', "");
    Expect(1, 42783, '\P{^Block=	modifier_tone_letters}', "");
    Expect(0, 42784, '\p{Block=	modifier_tone_letters}', "");
    Expect(1, 42784, '\p{^Block=	modifier_tone_letters}', "");
    Expect(1, 42784, '\P{Block=	modifier_tone_letters}', "");
    Expect(0, 42784, '\P{^Block=	modifier_tone_letters}', "");
    Error('\p{Blk= /a/Modifier_Tone_Letters}');
    Error('\P{Blk= /a/Modifier_Tone_Letters}');
    Expect(1, 42783, '\p{Blk=:\AModifier_Tone_Letters\z:}', "");;
    Expect(0, 42784, '\p{Blk=:\AModifier_Tone_Letters\z:}', "");;
    Expect(1, 42783, '\p{Blk=modifiertoneletters}', "");
    Expect(0, 42783, '\p{^Blk=modifiertoneletters}', "");
    Expect(0, 42783, '\P{Blk=modifiertoneletters}', "");
    Expect(1, 42783, '\P{^Blk=modifiertoneletters}', "");
    Expect(0, 42784, '\p{Blk=modifiertoneletters}', "");
    Expect(1, 42784, '\p{^Blk=modifiertoneletters}', "");
    Expect(1, 42784, '\P{Blk=modifiertoneletters}', "");
    Expect(0, 42784, '\P{^Blk=modifiertoneletters}', "");
    Expect(1, 42783, '\p{Blk=:\Amodifiertoneletters\z:}', "");;
    Expect(0, 42784, '\p{Blk=:\Amodifiertoneletters\z:}', "");;
    Expect(1, 42783, '\p{Blk=-Modifier_TONE_letters}', "");
    Expect(0, 42783, '\p{^Blk=-Modifier_TONE_letters}', "");
    Expect(0, 42783, '\P{Blk=-Modifier_TONE_letters}', "");
    Expect(1, 42783, '\P{^Blk=-Modifier_TONE_letters}', "");
    Expect(0, 42784, '\p{Blk=-Modifier_TONE_letters}', "");
    Expect(1, 42784, '\p{^Blk=-Modifier_TONE_letters}', "");
    Expect(1, 42784, '\P{Blk=-Modifier_TONE_letters}', "");
    Expect(0, 42784, '\P{^Blk=-Modifier_TONE_letters}', "");
    Error('\p{Is_Block=_	MODIFIER_tone_Letters/a/}');
    Error('\P{Is_Block=_	MODIFIER_tone_Letters/a/}');
    Expect(1, 42783, '\p{Is_Block=modifiertoneletters}', "");
    Expect(0, 42783, '\p{^Is_Block=modifiertoneletters}', "");
    Expect(0, 42783, '\P{Is_Block=modifiertoneletters}', "");
    Expect(1, 42783, '\P{^Is_Block=modifiertoneletters}', "");
    Expect(0, 42784, '\p{Is_Block=modifiertoneletters}', "");
    Expect(1, 42784, '\p{^Is_Block=modifiertoneletters}', "");
    Expect(1, 42784, '\P{Is_Block=modifiertoneletters}', "");
    Expect(0, 42784, '\P{^Is_Block=modifiertoneletters}', "");
    Expect(1, 42783, '\p{Is_Block=--Modifier_tone_Letters}', "");
    Expect(0, 42783, '\p{^Is_Block=--Modifier_tone_Letters}', "");
    Expect(0, 42783, '\P{Is_Block=--Modifier_tone_Letters}', "");
    Expect(1, 42783, '\P{^Is_Block=--Modifier_tone_Letters}', "");
    Expect(0, 42784, '\p{Is_Block=--Modifier_tone_Letters}', "");
    Expect(1, 42784, '\p{^Is_Block=--Modifier_tone_Letters}', "");
    Expect(1, 42784, '\P{Is_Block=--Modifier_tone_Letters}', "");
    Expect(0, 42784, '\P{^Is_Block=--Modifier_tone_Letters}', "");
    Error('\p{Is_Blk=_:=Modifier_Tone_LETTERS}');
    Error('\P{Is_Blk=_:=Modifier_Tone_LETTERS}');
    Expect(1, 42783, '\p{Is_Blk:	modifiertoneletters}', "");
    Expect(0, 42783, '\p{^Is_Blk:	modifiertoneletters}', "");
    Expect(0, 42783, '\P{Is_Blk:	modifiertoneletters}', "");
    Expect(1, 42783, '\P{^Is_Blk:	modifiertoneletters}', "");
    Expect(0, 42784, '\p{Is_Blk:	modifiertoneletters}', "");
    Expect(1, 42784, '\p{^Is_Blk:	modifiertoneletters}', "");
    Expect(1, 42784, '\P{Is_Blk:	modifiertoneletters}', "");
    Expect(0, 42784, '\P{^Is_Blk:	modifiertoneletters}', "");
    Expect(1, 42783, '\p{Is_Blk=__Modifier_Tone_Letters}', "");
    Expect(0, 42783, '\p{^Is_Blk=__Modifier_Tone_Letters}', "");
    Expect(0, 42783, '\P{Is_Blk=__Modifier_Tone_Letters}', "");
    Expect(1, 42783, '\P{^Is_Blk=__Modifier_Tone_Letters}', "");
    Expect(0, 42784, '\p{Is_Blk=__Modifier_Tone_Letters}', "");
    Expect(1, 42784, '\p{^Is_Blk=__Modifier_Tone_Letters}', "");
    Expect(1, 42784, '\P{Is_Blk=__Modifier_Tone_Letters}', "");
    Expect(0, 42784, '\P{^Is_Blk=__Modifier_Tone_Letters}', "");
    Error('\p{Block=/a/Mongolian}');
    Error('\P{Block=/a/Mongolian}');
    Expect(1, 6319, '\p{Block=:\AMongolian\z:}', "");;
    Expect(0, 6320, '\p{Block=:\AMongolian\z:}', "");;
    Expect(1, 6319, '\p{Block=mongolian}', "");
    Expect(0, 6319, '\p{^Block=mongolian}', "");
    Expect(0, 6319, '\P{Block=mongolian}', "");
    Expect(1, 6319, '\P{^Block=mongolian}', "");
    Expect(0, 6320, '\p{Block=mongolian}', "");
    Expect(1, 6320, '\p{^Block=mongolian}', "");
    Expect(1, 6320, '\P{Block=mongolian}', "");
    Expect(0, 6320, '\P{^Block=mongolian}', "");
    Expect(1, 6319, '\p{Block=:\Amongolian\z:}', "");;
    Expect(0, 6320, '\p{Block=:\Amongolian\z:}', "");;
    Expect(1, 6319, '\p{Block=	_MONGOLIAN}', "");
    Expect(0, 6319, '\p{^Block=	_MONGOLIAN}', "");
    Expect(0, 6319, '\P{Block=	_MONGOLIAN}', "");
    Expect(1, 6319, '\P{^Block=	_MONGOLIAN}', "");
    Expect(0, 6320, '\p{Block=	_MONGOLIAN}', "");
    Expect(1, 6320, '\p{^Block=	_MONGOLIAN}', "");
    Expect(1, 6320, '\P{Block=	_MONGOLIAN}', "");
    Expect(0, 6320, '\P{^Block=	_MONGOLIAN}', "");
    Error('\p{Blk=:=- Mongolian}');
    Error('\P{Blk=:=- Mongolian}');
    Expect(1, 6319, '\p{Blk=:\AMongolian\z:}', "");;
    Expect(0, 6320, '\p{Blk=:\AMongolian\z:}', "");;
    Expect(1, 6319, '\p{Blk=mongolian}', "");
    Expect(0, 6319, '\p{^Blk=mongolian}', "");
    Expect(0, 6319, '\P{Blk=mongolian}', "");
    Expect(1, 6319, '\P{^Blk=mongolian}', "");
    Expect(0, 6320, '\p{Blk=mongolian}', "");
    Expect(1, 6320, '\p{^Blk=mongolian}', "");
    Expect(1, 6320, '\P{Blk=mongolian}', "");
    Expect(0, 6320, '\P{^Blk=mongolian}', "");
    Expect(1, 6319, '\p{Blk=:\Amongolian\z:}', "");;
    Expect(0, 6320, '\p{Blk=:\Amongolian\z:}', "");;
    Expect(1, 6319, '\p{Blk= _Mongolian}', "");
    Expect(0, 6319, '\p{^Blk= _Mongolian}', "");
    Expect(0, 6319, '\P{Blk= _Mongolian}', "");
    Expect(1, 6319, '\P{^Blk= _Mongolian}', "");
    Expect(0, 6320, '\p{Blk= _Mongolian}', "");
    Expect(1, 6320, '\p{^Blk= _Mongolian}', "");
    Expect(1, 6320, '\P{Blk= _Mongolian}', "");
    Expect(0, 6320, '\P{^Blk= _Mongolian}', "");
    Error('\p{Is_Block=_	Mongolian:=}');
    Error('\P{Is_Block=_	Mongolian:=}');
    Expect(1, 6319, '\p{Is_Block=mongolian}', "");
    Expect(0, 6319, '\p{^Is_Block=mongolian}', "");
    Expect(0, 6319, '\P{Is_Block=mongolian}', "");
    Expect(1, 6319, '\P{^Is_Block=mongolian}', "");
    Expect(0, 6320, '\p{Is_Block=mongolian}', "");
    Expect(1, 6320, '\p{^Is_Block=mongolian}', "");
    Expect(1, 6320, '\P{Is_Block=mongolian}', "");
    Expect(0, 6320, '\P{^Is_Block=mongolian}', "");
    Expect(1, 6319, '\p{Is_Block:-	Mongolian}', "");
    Expect(0, 6319, '\p{^Is_Block:-	Mongolian}', "");
    Expect(0, 6319, '\P{Is_Block:-	Mongolian}', "");
    Expect(1, 6319, '\P{^Is_Block:-	Mongolian}', "");
    Expect(0, 6320, '\p{Is_Block:-	Mongolian}', "");
    Expect(1, 6320, '\p{^Is_Block:-	Mongolian}', "");
    Expect(1, 6320, '\P{Is_Block:-	Mongolian}', "");
    Expect(0, 6320, '\P{^Is_Block:-	Mongolian}', "");
    Error('\p{Is_Blk=/a/_	Mongolian}');
    Error('\P{Is_Blk=/a/_	Mongolian}');
    Expect(1, 6319, '\p{Is_Blk:mongolian}', "");
    Expect(0, 6319, '\p{^Is_Blk:mongolian}', "");
    Expect(0, 6319, '\P{Is_Blk:mongolian}', "");
    Expect(1, 6319, '\P{^Is_Blk:mongolian}', "");
    Expect(0, 6320, '\p{Is_Blk:mongolian}', "");
    Expect(1, 6320, '\p{^Is_Blk:mongolian}', "");
    Expect(1, 6320, '\P{Is_Blk:mongolian}', "");
    Expect(0, 6320, '\P{^Is_Blk:mongolian}', "");
    Expect(1, 6319, '\p{Is_Blk=-	mongolian}', "");
    Expect(0, 6319, '\p{^Is_Blk=-	mongolian}', "");
    Expect(0, 6319, '\P{Is_Blk=-	mongolian}', "");
    Expect(1, 6319, '\P{^Is_Blk=-	mongolian}', "");
    Expect(0, 6320, '\p{Is_Blk=-	mongolian}', "");
    Expect(1, 6320, '\p{^Is_Blk=-	mongolian}', "");
    Expect(1, 6320, '\P{Is_Blk=-	mongolian}', "");
    Expect(0, 6320, '\P{^Is_Blk=-	mongolian}', "");
    Error('\p{Block= -MONGOLIAN_Supplement/a/}');
    Error('\P{Block= -MONGOLIAN_Supplement/a/}');
    Expect(1, 71295, '\p{Block=:\AMongolian_Supplement\z:}', "");;
    Expect(0, 71296, '\p{Block=:\AMongolian_Supplement\z:}', "");;
    Expect(1, 71295, '\p{Block=mongoliansupplement}', "");
    Expect(0, 71295, '\p{^Block=mongoliansupplement}', "");
    Expect(0, 71295, '\P{Block=mongoliansupplement}', "");
    Expect(1, 71295, '\P{^Block=mongoliansupplement}', "");
    Expect(0, 71296, '\p{Block=mongoliansupplement}', "");
    Expect(1, 71296, '\p{^Block=mongoliansupplement}', "");
    Expect(1, 71296, '\P{Block=mongoliansupplement}', "");
    Expect(0, 71296, '\P{^Block=mongoliansupplement}', "");
    Expect(1, 71295, '\p{Block=:\Amongoliansupplement\z:}', "");;
    Expect(0, 71296, '\p{Block=:\Amongoliansupplement\z:}', "");;
    Expect(1, 71295, '\p{Block=	MONGOLIAN_SUPPLEMENT}', "");
    Expect(0, 71295, '\p{^Block=	MONGOLIAN_SUPPLEMENT}', "");
    Expect(0, 71295, '\P{Block=	MONGOLIAN_SUPPLEMENT}', "");
    Expect(1, 71295, '\P{^Block=	MONGOLIAN_SUPPLEMENT}', "");
    Expect(0, 71296, '\p{Block=	MONGOLIAN_SUPPLEMENT}', "");
    Expect(1, 71296, '\p{^Block=	MONGOLIAN_SUPPLEMENT}', "");
    Expect(1, 71296, '\P{Block=	MONGOLIAN_SUPPLEMENT}', "");
    Expect(0, 71296, '\P{^Block=	MONGOLIAN_SUPPLEMENT}', "");
    Error('\p{Blk=:=_	MONGOLIAN_SUP}');
    Error('\P{Blk=:=_	MONGOLIAN_SUP}');
    Expect(1, 71295, '\p{Blk=:\AMongolian_Sup\z:}', "");;
    Expect(0, 71296, '\p{Blk=:\AMongolian_Sup\z:}', "");;
    Expect(1, 71295, '\p{Blk=mongoliansup}', "");
    Expect(0, 71295, '\p{^Blk=mongoliansup}', "");
    Expect(0, 71295, '\P{Blk=mongoliansup}', "");
    Expect(1, 71295, '\P{^Blk=mongoliansup}', "");
    Expect(0, 71296, '\p{Blk=mongoliansup}', "");
    Expect(1, 71296, '\p{^Blk=mongoliansup}', "");
    Expect(1, 71296, '\P{Blk=mongoliansup}', "");
    Expect(0, 71296, '\P{^Blk=mongoliansup}', "");
    Expect(1, 71295, '\p{Blk=:\Amongoliansup\z:}', "");;
    Expect(0, 71296, '\p{Blk=:\Amongoliansup\z:}', "");;
    Expect(1, 71295, '\p{Blk=-mongolian_SUP}', "");
    Expect(0, 71295, '\p{^Blk=-mongolian_SUP}', "");
    Expect(0, 71295, '\P{Blk=-mongolian_SUP}', "");
    Expect(1, 71295, '\P{^Blk=-mongolian_SUP}', "");
    Expect(0, 71296, '\p{Blk=-mongolian_SUP}', "");
    Expect(1, 71296, '\p{^Blk=-mongolian_SUP}', "");
    Expect(1, 71296, '\P{Blk=-mongolian_SUP}', "");
    Expect(0, 71296, '\P{^Blk=-mongolian_SUP}', "");
    Error('\p{Is_Block=:=-	Mongolian_Supplement}');
    Error('\P{Is_Block=:=-	Mongolian_Supplement}');
    Expect(1, 71295, '\p{Is_Block=mongoliansupplement}', "");
    Expect(0, 71295, '\p{^Is_Block=mongoliansupplement}', "");
    Expect(0, 71295, '\P{Is_Block=mongoliansupplement}', "");
    Expect(1, 71295, '\P{^Is_Block=mongoliansupplement}', "");
    Expect(0, 71296, '\p{Is_Block=mongoliansupplement}', "");
    Expect(1, 71296, '\p{^Is_Block=mongoliansupplement}', "");
    Expect(1, 71296, '\P{Is_Block=mongoliansupplement}', "");
    Expect(0, 71296, '\P{^Is_Block=mongoliansupplement}', "");
    Expect(1, 71295, '\p{Is_Block:	MONGOLIAN_supplement}', "");
    Expect(0, 71295, '\p{^Is_Block:	MONGOLIAN_supplement}', "");
    Expect(0, 71295, '\P{Is_Block:	MONGOLIAN_supplement}', "");
    Expect(1, 71295, '\P{^Is_Block:	MONGOLIAN_supplement}', "");
    Expect(0, 71296, '\p{Is_Block:	MONGOLIAN_supplement}', "");
    Expect(1, 71296, '\p{^Is_Block:	MONGOLIAN_supplement}', "");
    Expect(1, 71296, '\P{Is_Block:	MONGOLIAN_supplement}', "");
    Expect(0, 71296, '\P{^Is_Block:	MONGOLIAN_supplement}', "");
    Error('\p{Is_Blk=:=	-Mongolian_SUP}');
    Error('\P{Is_Blk=:=	-Mongolian_SUP}');
    Expect(1, 71295, '\p{Is_Blk=mongoliansup}', "");
    Expect(0, 71295, '\p{^Is_Blk=mongoliansup}', "");
    Expect(0, 71295, '\P{Is_Blk=mongoliansup}', "");
    Expect(1, 71295, '\P{^Is_Blk=mongoliansup}', "");
    Expect(0, 71296, '\p{Is_Blk=mongoliansup}', "");
    Expect(1, 71296, '\p{^Is_Blk=mongoliansup}', "");
    Expect(1, 71296, '\P{Is_Blk=mongoliansup}', "");
    Expect(0, 71296, '\P{^Is_Blk=mongoliansup}', "");
    Expect(1, 71295, '\p{Is_Blk=-mongolian_SUP}', "");
    Expect(0, 71295, '\p{^Is_Blk=-mongolian_SUP}', "");
    Expect(0, 71295, '\P{Is_Blk=-mongolian_SUP}', "");
    Expect(1, 71295, '\P{^Is_Blk=-mongolian_SUP}', "");
    Expect(0, 71296, '\p{Is_Blk=-mongolian_SUP}', "");
    Expect(1, 71296, '\p{^Is_Blk=-mongolian_SUP}', "");
    Expect(1, 71296, '\P{Is_Blk=-mongolian_SUP}', "");
    Expect(0, 71296, '\P{^Is_Blk=-mongolian_SUP}', "");
    Error('\p{Block=/a/-	MRO}');
    Error('\P{Block=/a/-	MRO}');
    Expect(1, 92783, '\p{Block=:\AMro\z:}', "");;
    Expect(0, 92784, '\p{Block=:\AMro\z:}', "");;
    Expect(1, 92783, '\p{Block=mro}', "");
    Expect(0, 92783, '\p{^Block=mro}', "");
    Expect(0, 92783, '\P{Block=mro}', "");
    Expect(1, 92783, '\P{^Block=mro}', "");
    Expect(0, 92784, '\p{Block=mro}', "");
    Expect(1, 92784, '\p{^Block=mro}', "");
    Expect(1, 92784, '\P{Block=mro}', "");
    Expect(0, 92784, '\P{^Block=mro}', "");
    Expect(1, 92783, '\p{Block=:\Amro\z:}', "");;
    Expect(0, 92784, '\p{Block=:\Amro\z:}', "");;
    Expect(1, 92783, '\p{Block=-	MRO}', "");
    Expect(0, 92783, '\p{^Block=-	MRO}', "");
    Expect(0, 92783, '\P{Block=-	MRO}', "");
    Expect(1, 92783, '\P{^Block=-	MRO}', "");
    Expect(0, 92784, '\p{Block=-	MRO}', "");
    Expect(1, 92784, '\p{^Block=-	MRO}', "");
    Expect(1, 92784, '\P{Block=-	MRO}', "");
    Expect(0, 92784, '\P{^Block=-	MRO}', "");
    Error('\p{Blk=-:=mro}');
    Error('\P{Blk=-:=mro}');
    Expect(1, 92783, '\p{Blk=:\AMro\z:}', "");;
    Expect(0, 92784, '\p{Blk=:\AMro\z:}', "");;
    Expect(1, 92783, '\p{Blk=mro}', "");
    Expect(0, 92783, '\p{^Blk=mro}', "");
    Expect(0, 92783, '\P{Blk=mro}', "");
    Expect(1, 92783, '\P{^Blk=mro}', "");
    Expect(0, 92784, '\p{Blk=mro}', "");
    Expect(1, 92784, '\p{^Blk=mro}', "");
    Expect(1, 92784, '\P{Blk=mro}', "");
    Expect(0, 92784, '\P{^Blk=mro}', "");
    Expect(1, 92783, '\p{Blk=:\Amro\z:}', "");;
    Expect(0, 92784, '\p{Blk=:\Amro\z:}', "");;
    Expect(1, 92783, '\p{Blk=_mro}', "");
    Expect(0, 92783, '\p{^Blk=_mro}', "");
    Expect(0, 92783, '\P{Blk=_mro}', "");
    Expect(1, 92783, '\P{^Blk=_mro}', "");
    Expect(0, 92784, '\p{Blk=_mro}', "");
    Expect(1, 92784, '\p{^Blk=_mro}', "");
    Expect(1, 92784, '\P{Blk=_mro}', "");
    Expect(0, 92784, '\P{^Blk=_mro}', "");
    Error('\p{Is_Block=	MRO:=}');
    Error('\P{Is_Block=	MRO:=}');
    Expect(1, 92783, '\p{Is_Block=mro}', "");
    Expect(0, 92783, '\p{^Is_Block=mro}', "");
    Expect(0, 92783, '\P{Is_Block=mro}', "");
    Expect(1, 92783, '\P{^Is_Block=mro}', "");
    Expect(0, 92784, '\p{Is_Block=mro}', "");
    Expect(1, 92784, '\p{^Is_Block=mro}', "");
    Expect(1, 92784, '\P{Is_Block=mro}', "");
    Expect(0, 92784, '\P{^Is_Block=mro}', "");
    Expect(1, 92783, '\p{Is_Block:  Mro}', "");
    Expect(0, 92783, '\p{^Is_Block:  Mro}', "");
    Expect(0, 92783, '\P{Is_Block:  Mro}', "");
    Expect(1, 92783, '\P{^Is_Block:  Mro}', "");
    Expect(0, 92784, '\p{Is_Block:  Mro}', "");
    Expect(1, 92784, '\p{^Is_Block:  Mro}', "");
    Expect(1, 92784, '\P{Is_Block:  Mro}', "");
    Expect(0, 92784, '\P{^Is_Block:  Mro}', "");
    Error('\p{Is_Blk= :=MRO}');
    Error('\P{Is_Blk= :=MRO}');
    Expect(1, 92783, '\p{Is_Blk=mro}', "");
    Expect(0, 92783, '\p{^Is_Blk=mro}', "");
    Expect(0, 92783, '\P{Is_Blk=mro}', "");
    Expect(1, 92783, '\P{^Is_Blk=mro}', "");
    Expect(0, 92784, '\p{Is_Blk=mro}', "");
    Expect(1, 92784, '\p{^Is_Blk=mro}', "");
    Expect(1, 92784, '\P{Is_Blk=mro}', "");
    Expect(0, 92784, '\P{^Is_Blk=mro}', "");
    Expect(1, 92783, '\p{Is_Blk=-MRO}', "");
    Expect(0, 92783, '\p{^Is_Blk=-MRO}', "");
    Expect(0, 92783, '\P{Is_Blk=-MRO}', "");
    Expect(1, 92783, '\P{^Is_Blk=-MRO}', "");
    Expect(0, 92784, '\p{Is_Blk=-MRO}', "");
    Expect(1, 92784, '\p{^Is_Blk=-MRO}', "");
    Expect(1, 92784, '\P{Is_Blk=-MRO}', "");
    Expect(0, 92784, '\P{^Is_Blk=-MRO}', "");
    Error('\p{Block=/a/__MULTANI}');
    Error('\P{Block=/a/__MULTANI}');
    Expect(1, 70319, '\p{Block=:\AMultani\z:}', "");;
    Expect(0, 70320, '\p{Block=:\AMultani\z:}', "");;
    Expect(1, 70319, '\p{Block=multani}', "");
    Expect(0, 70319, '\p{^Block=multani}', "");
    Expect(0, 70319, '\P{Block=multani}', "");
    Expect(1, 70319, '\P{^Block=multani}', "");
    Expect(0, 70320, '\p{Block=multani}', "");
    Expect(1, 70320, '\p{^Block=multani}', "");
    Expect(1, 70320, '\P{Block=multani}', "");
    Expect(0, 70320, '\P{^Block=multani}', "");
    Expect(1, 70319, '\p{Block=:\Amultani\z:}', "");;
    Expect(0, 70320, '\p{Block=:\Amultani\z:}', "");;
    Expect(1, 70319, '\p{Block=--Multani}', "");
    Expect(0, 70319, '\p{^Block=--Multani}', "");
    Expect(0, 70319, '\P{Block=--Multani}', "");
    Expect(1, 70319, '\P{^Block=--Multani}', "");
    Expect(0, 70320, '\p{Block=--Multani}', "");
    Expect(1, 70320, '\p{^Block=--Multani}', "");
    Expect(1, 70320, '\P{Block=--Multani}', "");
    Expect(0, 70320, '\P{^Block=--Multani}', "");
    Error('\p{Blk=--Multani/a/}');
    Error('\P{Blk=--Multani/a/}');
    Expect(1, 70319, '\p{Blk=:\AMultani\z:}', "");;
    Expect(0, 70320, '\p{Blk=:\AMultani\z:}', "");;
    Expect(1, 70319, '\p{Blk=multani}', "");
    Expect(0, 70319, '\p{^Blk=multani}', "");
    Expect(0, 70319, '\P{Blk=multani}', "");
    Expect(1, 70319, '\P{^Blk=multani}', "");
    Expect(0, 70320, '\p{Blk=multani}', "");
    Expect(1, 70320, '\p{^Blk=multani}', "");
    Expect(1, 70320, '\P{Blk=multani}', "");
    Expect(0, 70320, '\P{^Blk=multani}', "");
    Expect(1, 70319, '\p{Blk=:\Amultani\z:}', "");;
    Expect(0, 70320, '\p{Blk=:\Amultani\z:}', "");;
    Error('\p{Is_Block= Multani:=}');
    Error('\P{Is_Block= Multani:=}');
    Expect(1, 70319, '\p{Is_Block=multani}', "");
    Expect(0, 70319, '\p{^Is_Block=multani}', "");
    Expect(0, 70319, '\P{Is_Block=multani}', "");
    Expect(1, 70319, '\P{^Is_Block=multani}', "");
    Expect(0, 70320, '\p{Is_Block=multani}', "");
    Expect(1, 70320, '\p{^Is_Block=multani}', "");
    Expect(1, 70320, '\P{Is_Block=multani}', "");
    Expect(0, 70320, '\P{^Is_Block=multani}', "");
    Expect(1, 70319, '\p{Is_Block= _Multani}', "");
    Expect(0, 70319, '\p{^Is_Block= _Multani}', "");
    Expect(0, 70319, '\P{Is_Block= _Multani}', "");
    Expect(1, 70319, '\P{^Is_Block= _Multani}', "");
    Expect(0, 70320, '\p{Is_Block= _Multani}', "");
    Expect(1, 70320, '\p{^Is_Block= _Multani}', "");
    Expect(1, 70320, '\P{Is_Block= _Multani}', "");
    Expect(0, 70320, '\P{^Is_Block= _Multani}', "");
    Error('\p{Is_Blk=:=	_Multani}');
    Error('\P{Is_Blk=:=	_Multani}');
    Expect(1, 70319, '\p{Is_Blk=multani}', "");
    Expect(0, 70319, '\p{^Is_Blk=multani}', "");
    Expect(0, 70319, '\P{Is_Blk=multani}', "");
    Expect(1, 70319, '\P{^Is_Blk=multani}', "");
    Expect(0, 70320, '\p{Is_Blk=multani}', "");
    Expect(1, 70320, '\p{^Is_Blk=multani}', "");
    Expect(1, 70320, '\P{Is_Blk=multani}', "");
    Expect(0, 70320, '\P{^Is_Blk=multani}', "");
    Expect(1, 70319, '\p{Is_Blk=-MULTANI}', "");
    Expect(0, 70319, '\p{^Is_Blk=-MULTANI}', "");
    Expect(0, 70319, '\P{Is_Blk=-MULTANI}', "");
    Expect(1, 70319, '\P{^Is_Blk=-MULTANI}', "");
    Expect(0, 70320, '\p{Is_Blk=-MULTANI}', "");
    Expect(1, 70320, '\p{^Is_Blk=-MULTANI}', "");
    Expect(1, 70320, '\P{Is_Blk=-MULTANI}', "");
    Expect(0, 70320, '\P{^Is_Blk=-MULTANI}', "");
    Error('\p{Block= /a/Musical_SYMBOLS}');
    Error('\P{Block= /a/Musical_SYMBOLS}');
    Expect(1, 119295, '\p{Block=:\AMusical_Symbols\z:}', "");;
    Expect(0, 119296, '\p{Block=:\AMusical_Symbols\z:}', "");;
    Expect(1, 119295, '\p{Block:	musicalsymbols}', "");
    Expect(0, 119295, '\p{^Block:	musicalsymbols}', "");
    Expect(0, 119295, '\P{Block:	musicalsymbols}', "");
    Expect(1, 119295, '\P{^Block:	musicalsymbols}', "");
    Expect(0, 119296, '\p{Block:	musicalsymbols}', "");
    Expect(1, 119296, '\p{^Block:	musicalsymbols}', "");
    Expect(1, 119296, '\P{Block:	musicalsymbols}', "");
    Expect(0, 119296, '\P{^Block:	musicalsymbols}', "");
    Expect(1, 119295, '\p{Block=:\Amusicalsymbols\z:}', "");;
    Expect(0, 119296, '\p{Block=:\Amusicalsymbols\z:}', "");;
    Expect(1, 119295, '\p{Block=__musical_SYMBOLS}', "");
    Expect(0, 119295, '\p{^Block=__musical_SYMBOLS}', "");
    Expect(0, 119295, '\P{Block=__musical_SYMBOLS}', "");
    Expect(1, 119295, '\P{^Block=__musical_SYMBOLS}', "");
    Expect(0, 119296, '\p{Block=__musical_SYMBOLS}', "");
    Expect(1, 119296, '\p{^Block=__musical_SYMBOLS}', "");
    Expect(1, 119296, '\P{Block=__musical_SYMBOLS}', "");
    Expect(0, 119296, '\P{^Block=__musical_SYMBOLS}', "");
    Error('\p{Blk=:=  MUSIC}');
    Error('\P{Blk=:=  MUSIC}');
    Expect(1, 119295, '\p{Blk=:\AMusic\z:}', "");;
    Expect(0, 119296, '\p{Blk=:\AMusic\z:}', "");;
    Expect(1, 119295, '\p{Blk=music}', "");
    Expect(0, 119295, '\p{^Blk=music}', "");
    Expect(0, 119295, '\P{Blk=music}', "");
    Expect(1, 119295, '\P{^Blk=music}', "");
    Expect(0, 119296, '\p{Blk=music}', "");
    Expect(1, 119296, '\p{^Blk=music}', "");
    Expect(1, 119296, '\P{Blk=music}', "");
    Expect(0, 119296, '\P{^Blk=music}', "");
    Expect(1, 119295, '\p{Blk=:\Amusic\z:}', "");;
    Expect(0, 119296, '\p{Blk=:\Amusic\z:}', "");;
    Expect(1, 119295, '\p{Blk=Music}', "");
    Expect(0, 119295, '\p{^Blk=Music}', "");
    Expect(0, 119295, '\P{Blk=Music}', "");
    Expect(1, 119295, '\P{^Blk=Music}', "");
    Expect(0, 119296, '\p{Blk=Music}', "");
    Expect(1, 119296, '\p{^Blk=Music}', "");
    Expect(1, 119296, '\P{Blk=Music}', "");
    Expect(0, 119296, '\P{^Blk=Music}', "");
    Error('\p{Is_Block=	:=MUSICAL_Symbols}');
    Error('\P{Is_Block=	:=MUSICAL_Symbols}');
    Expect(1, 119295, '\p{Is_Block=musicalsymbols}', "");
    Expect(0, 119295, '\p{^Is_Block=musicalsymbols}', "");
    Expect(0, 119295, '\P{Is_Block=musicalsymbols}', "");
    Expect(1, 119295, '\P{^Is_Block=musicalsymbols}', "");
    Expect(0, 119296, '\p{Is_Block=musicalsymbols}', "");
    Expect(1, 119296, '\p{^Is_Block=musicalsymbols}', "");
    Expect(1, 119296, '\P{Is_Block=musicalsymbols}', "");
    Expect(0, 119296, '\P{^Is_Block=musicalsymbols}', "");
    Expect(1, 119295, '\p{Is_Block=__MUSICAL_Symbols}', "");
    Expect(0, 119295, '\p{^Is_Block=__MUSICAL_Symbols}', "");
    Expect(0, 119295, '\P{Is_Block=__MUSICAL_Symbols}', "");
    Expect(1, 119295, '\P{^Is_Block=__MUSICAL_Symbols}', "");
    Expect(0, 119296, '\p{Is_Block=__MUSICAL_Symbols}', "");
    Expect(1, 119296, '\p{^Is_Block=__MUSICAL_Symbols}', "");
    Expect(1, 119296, '\P{Is_Block=__MUSICAL_Symbols}', "");
    Expect(0, 119296, '\P{^Is_Block=__MUSICAL_Symbols}', "");
    Error('\p{Is_Blk=:=_-MUSIC}');
    Error('\P{Is_Blk=:=_-MUSIC}');
    Expect(1, 119295, '\p{Is_Blk=music}', "");
    Expect(0, 119295, '\p{^Is_Blk=music}', "");
    Expect(0, 119295, '\P{Is_Blk=music}', "");
    Expect(1, 119295, '\P{^Is_Blk=music}', "");
    Expect(0, 119296, '\p{Is_Blk=music}', "");
    Expect(1, 119296, '\p{^Is_Blk=music}', "");
    Expect(1, 119296, '\P{Is_Blk=music}', "");
    Expect(0, 119296, '\P{^Is_Blk=music}', "");
    Expect(1, 119295, '\p{Is_Blk=	Music}', "");
    Expect(0, 119295, '\p{^Is_Blk=	Music}', "");
    Expect(0, 119295, '\P{Is_Blk=	Music}', "");
    Expect(1, 119295, '\P{^Is_Blk=	Music}', "");
    Expect(0, 119296, '\p{Is_Blk=	Music}', "");
    Expect(1, 119296, '\p{^Is_Blk=	Music}', "");
    Expect(1, 119296, '\P{Is_Blk=	Music}', "");
    Expect(0, 119296, '\P{^Is_Blk=	Music}', "");
    Error('\p{Block=		myanmar/a/}');
    Error('\P{Block=		myanmar/a/}');
    Expect(1, 4255, '\p{Block=:\AMyanmar\z:}', "");;
    Expect(0, 4256, '\p{Block=:\AMyanmar\z:}', "");;
    Expect(1, 4255, '\p{Block=myanmar}', "");
    Expect(0, 4255, '\p{^Block=myanmar}', "");
    Expect(0, 4255, '\P{Block=myanmar}', "");
    Expect(1, 4255, '\P{^Block=myanmar}', "");
    Expect(0, 4256, '\p{Block=myanmar}', "");
    Expect(1, 4256, '\p{^Block=myanmar}', "");
    Expect(1, 4256, '\P{Block=myanmar}', "");
    Expect(0, 4256, '\P{^Block=myanmar}', "");
    Expect(1, 4255, '\p{Block=:\Amyanmar\z:}', "");;
    Expect(0, 4256, '\p{Block=:\Amyanmar\z:}', "");;
    Expect(1, 4255, '\p{Block=_Myanmar}', "");
    Expect(0, 4255, '\p{^Block=_Myanmar}', "");
    Expect(0, 4255, '\P{Block=_Myanmar}', "");
    Expect(1, 4255, '\P{^Block=_Myanmar}', "");
    Expect(0, 4256, '\p{Block=_Myanmar}', "");
    Expect(1, 4256, '\p{^Block=_Myanmar}', "");
    Expect(1, 4256, '\P{Block=_Myanmar}', "");
    Expect(0, 4256, '\P{^Block=_Myanmar}', "");
    Error('\p{Blk=:=__Myanmar}');
    Error('\P{Blk=:=__Myanmar}');
    Expect(1, 4255, '\p{Blk=:\AMyanmar\z:}', "");;
    Expect(0, 4256, '\p{Blk=:\AMyanmar\z:}', "");;
    Expect(1, 4255, '\p{Blk=myanmar}', "");
    Expect(0, 4255, '\p{^Blk=myanmar}', "");
    Expect(0, 4255, '\P{Blk=myanmar}', "");
    Expect(1, 4255, '\P{^Blk=myanmar}', "");
    Expect(0, 4256, '\p{Blk=myanmar}', "");
    Expect(1, 4256, '\p{^Blk=myanmar}', "");
    Expect(1, 4256, '\P{Blk=myanmar}', "");
    Expect(0, 4256, '\P{^Blk=myanmar}', "");
    Expect(1, 4255, '\p{Blk=:\Amyanmar\z:}', "");;
    Expect(0, 4256, '\p{Blk=:\Amyanmar\z:}', "");;
    Expect(1, 4255, '\p{Blk=__myanmar}', "");
    Expect(0, 4255, '\p{^Blk=__myanmar}', "");
    Expect(0, 4255, '\P{Blk=__myanmar}', "");
    Expect(1, 4255, '\P{^Blk=__myanmar}', "");
    Expect(0, 4256, '\p{Blk=__myanmar}', "");
    Expect(1, 4256, '\p{^Blk=__myanmar}', "");
    Expect(1, 4256, '\P{Blk=__myanmar}', "");
    Expect(0, 4256, '\P{^Blk=__myanmar}', "");
    Error('\p{Is_Block=:=MYANMAR}');
    Error('\P{Is_Block=:=MYANMAR}');
    Expect(1, 4255, '\p{Is_Block=myanmar}', "");
    Expect(0, 4255, '\p{^Is_Block=myanmar}', "");
    Expect(0, 4255, '\P{Is_Block=myanmar}', "");
    Expect(1, 4255, '\P{^Is_Block=myanmar}', "");
    Expect(0, 4256, '\p{Is_Block=myanmar}', "");
    Expect(1, 4256, '\p{^Is_Block=myanmar}', "");
    Expect(1, 4256, '\P{Is_Block=myanmar}', "");
    Expect(0, 4256, '\P{^Is_Block=myanmar}', "");
    Expect(1, 4255, '\p{Is_Block=_MYANMAR}', "");
    Expect(0, 4255, '\p{^Is_Block=_MYANMAR}', "");
    Expect(0, 4255, '\P{Is_Block=_MYANMAR}', "");
    Expect(1, 4255, '\P{^Is_Block=_MYANMAR}', "");
    Expect(0, 4256, '\p{Is_Block=_MYANMAR}', "");
    Expect(1, 4256, '\p{^Is_Block=_MYANMAR}', "");
    Expect(1, 4256, '\P{Is_Block=_MYANMAR}', "");
    Expect(0, 4256, '\P{^Is_Block=_MYANMAR}', "");
    Error('\p{Is_Blk:   :=-	Myanmar}');
    Error('\P{Is_Blk:   :=-	Myanmar}');
    Expect(1, 4255, '\p{Is_Blk: myanmar}', "");
    Expect(0, 4255, '\p{^Is_Blk: myanmar}', "");
    Expect(0, 4255, '\P{Is_Blk: myanmar}', "");
    Expect(1, 4255, '\P{^Is_Blk: myanmar}', "");
    Expect(0, 4256, '\p{Is_Blk: myanmar}', "");
    Expect(1, 4256, '\p{^Is_Blk: myanmar}', "");
    Expect(1, 4256, '\P{Is_Blk: myanmar}', "");
    Expect(0, 4256, '\P{^Is_Blk: myanmar}', "");
    Expect(1, 4255, '\p{Is_Blk=_	myanmar}', "");
    Expect(0, 4255, '\p{^Is_Blk=_	myanmar}', "");
    Expect(0, 4255, '\P{Is_Blk=_	myanmar}', "");
    Expect(1, 4255, '\P{^Is_Blk=_	myanmar}', "");
    Expect(0, 4256, '\p{Is_Blk=_	myanmar}', "");
    Expect(1, 4256, '\p{^Is_Blk=_	myanmar}', "");
    Expect(1, 4256, '\P{Is_Blk=_	myanmar}', "");
    Expect(0, 4256, '\P{^Is_Blk=_	myanmar}', "");
    Error('\p{Block=	:=myanmar_extended_A}');
    Error('\P{Block=	:=myanmar_extended_A}');
    Expect(1, 43647, '\p{Block=:\AMyanmar_Extended_A\z:}', "");;
    Expect(0, 43648, '\p{Block=:\AMyanmar_Extended_A\z:}', "");;
    Expect(1, 43647, '\p{Block=myanmarextendeda}', "");
    Expect(0, 43647, '\p{^Block=myanmarextendeda}', "");
    Expect(0, 43647, '\P{Block=myanmarextendeda}', "");
    Expect(1, 43647, '\P{^Block=myanmarextendeda}', "");
    Expect(0, 43648, '\p{Block=myanmarextendeda}', "");
    Expect(1, 43648, '\p{^Block=myanmarextendeda}', "");
    Expect(1, 43648, '\P{Block=myanmarextendeda}', "");
    Expect(0, 43648, '\P{^Block=myanmarextendeda}', "");
    Expect(1, 43647, '\p{Block=:\Amyanmarextendeda\z:}', "");;
    Expect(0, 43648, '\p{Block=:\Amyanmarextendeda\z:}', "");;
    Expect(1, 43647, '\p{Block:    Myanmar_extended_A}', "");
    Expect(0, 43647, '\p{^Block:    Myanmar_extended_A}', "");
    Expect(0, 43647, '\P{Block:    Myanmar_extended_A}', "");
    Expect(1, 43647, '\P{^Block:    Myanmar_extended_A}', "");
    Expect(0, 43648, '\p{Block:    Myanmar_extended_A}', "");
    Expect(1, 43648, '\p{^Block:    Myanmar_extended_A}', "");
    Expect(1, 43648, '\P{Block:    Myanmar_extended_A}', "");
    Expect(0, 43648, '\P{^Block:    Myanmar_extended_A}', "");
    Error('\p{Blk=/a/_myanmar_ext_A}');
    Error('\P{Blk=/a/_myanmar_ext_A}');
    Expect(1, 43647, '\p{Blk=:\AMyanmar_Ext_A\z:}', "");;
    Expect(0, 43648, '\p{Blk=:\AMyanmar_Ext_A\z:}', "");;
    Expect(1, 43647, '\p{Blk=myanmarexta}', "");
    Expect(0, 43647, '\p{^Blk=myanmarexta}', "");
    Expect(0, 43647, '\P{Blk=myanmarexta}', "");
    Expect(1, 43647, '\P{^Blk=myanmarexta}', "");
    Expect(0, 43648, '\p{Blk=myanmarexta}', "");
    Expect(1, 43648, '\p{^Blk=myanmarexta}', "");
    Expect(1, 43648, '\P{Blk=myanmarexta}', "");
    Expect(0, 43648, '\P{^Blk=myanmarexta}', "");
    Expect(1, 43647, '\p{Blk=:\Amyanmarexta\z:}', "");;
    Expect(0, 43648, '\p{Blk=:\Amyanmarexta\z:}', "");;
    Expect(1, 43647, '\p{Blk=		MYANMAR_Ext_A}', "");
    Expect(0, 43647, '\p{^Blk=		MYANMAR_Ext_A}', "");
    Expect(0, 43647, '\P{Blk=		MYANMAR_Ext_A}', "");
    Expect(1, 43647, '\P{^Blk=		MYANMAR_Ext_A}', "");
    Expect(0, 43648, '\p{Blk=		MYANMAR_Ext_A}', "");
    Expect(1, 43648, '\p{^Blk=		MYANMAR_Ext_A}', "");
    Expect(1, 43648, '\P{Blk=		MYANMAR_Ext_A}', "");
    Expect(0, 43648, '\P{^Blk=		MYANMAR_Ext_A}', "");
    Error('\p{Is_Block=/a/	 Myanmar_extended_A}');
    Error('\P{Is_Block=/a/	 Myanmar_extended_A}');
    Expect(1, 43647, '\p{Is_Block=myanmarextendeda}', "");
    Expect(0, 43647, '\p{^Is_Block=myanmarextendeda}', "");
    Expect(0, 43647, '\P{Is_Block=myanmarextendeda}', "");
    Expect(1, 43647, '\P{^Is_Block=myanmarextendeda}', "");
    Expect(0, 43648, '\p{Is_Block=myanmarextendeda}', "");
    Expect(1, 43648, '\p{^Is_Block=myanmarextendeda}', "");
    Expect(1, 43648, '\P{Is_Block=myanmarextendeda}', "");
    Expect(0, 43648, '\P{^Is_Block=myanmarextendeda}', "");
    Expect(1, 43647, '\p{Is_Block=-MYANMAR_EXTENDED_A}', "");
    Expect(0, 43647, '\p{^Is_Block=-MYANMAR_EXTENDED_A}', "");
    Expect(0, 43647, '\P{Is_Block=-MYANMAR_EXTENDED_A}', "");
    Expect(1, 43647, '\P{^Is_Block=-MYANMAR_EXTENDED_A}', "");
    Expect(0, 43648, '\p{Is_Block=-MYANMAR_EXTENDED_A}', "");
    Expect(1, 43648, '\p{^Is_Block=-MYANMAR_EXTENDED_A}', "");
    Expect(1, 43648, '\P{Is_Block=-MYANMAR_EXTENDED_A}', "");
    Expect(0, 43648, '\P{^Is_Block=-MYANMAR_EXTENDED_A}', "");
    Error('\p{Is_Blk:	-:=Myanmar_ext_a}');
    Error('\P{Is_Blk:	-:=Myanmar_ext_a}');
    Expect(1, 43647, '\p{Is_Blk=myanmarexta}', "");
    Expect(0, 43647, '\p{^Is_Blk=myanmarexta}', "");
    Expect(0, 43647, '\P{Is_Blk=myanmarexta}', "");
    Expect(1, 43647, '\P{^Is_Blk=myanmarexta}', "");
    Expect(0, 43648, '\p{Is_Blk=myanmarexta}', "");
    Expect(1, 43648, '\p{^Is_Blk=myanmarexta}', "");
    Expect(1, 43648, '\P{Is_Blk=myanmarexta}', "");
    Expect(0, 43648, '\P{^Is_Blk=myanmarexta}', "");
    Expect(1, 43647, '\p{Is_Blk=	 MYANMAR_Ext_A}', "");
    Expect(0, 43647, '\p{^Is_Blk=	 MYANMAR_Ext_A}', "");
    Expect(0, 43647, '\P{Is_Blk=	 MYANMAR_Ext_A}', "");
    Expect(1, 43647, '\P{^Is_Blk=	 MYANMAR_Ext_A}', "");
    Expect(0, 43648, '\p{Is_Blk=	 MYANMAR_Ext_A}', "");
    Expect(1, 43648, '\p{^Is_Blk=	 MYANMAR_Ext_A}', "");
    Expect(1, 43648, '\P{Is_Blk=	 MYANMAR_Ext_A}', "");
    Expect(0, 43648, '\P{^Is_Blk=	 MYANMAR_Ext_A}', "");
    Error('\p{Block:			myanmar_EXTENDED_B:=}');
    Error('\P{Block:			myanmar_EXTENDED_B:=}');
    Expect(1, 43519, '\p{Block=:\AMyanmar_Extended_B\z:}', "");;
    Expect(0, 43520, '\p{Block=:\AMyanmar_Extended_B\z:}', "");;
    Expect(1, 43519, '\p{Block:myanmarextendedb}', "");
    Expect(0, 43519, '\p{^Block:myanmarextendedb}', "");
    Expect(0, 43519, '\P{Block:myanmarextendedb}', "");
    Expect(1, 43519, '\P{^Block:myanmarextendedb}', "");
    Expect(0, 43520, '\p{Block:myanmarextendedb}', "");
    Expect(1, 43520, '\p{^Block:myanmarextendedb}', "");
    Expect(1, 43520, '\P{Block:myanmarextendedb}', "");
    Expect(0, 43520, '\P{^Block:myanmarextendedb}', "");
    Expect(1, 43519, '\p{Block=:\Amyanmarextendedb\z:}', "");;
    Expect(0, 43520, '\p{Block=:\Amyanmarextendedb\z:}', "");;
    Expect(1, 43519, '\p{Block: 	Myanmar_Extended_B}', "");
    Expect(0, 43519, '\p{^Block: 	Myanmar_Extended_B}', "");
    Expect(0, 43519, '\P{Block: 	Myanmar_Extended_B}', "");
    Expect(1, 43519, '\P{^Block: 	Myanmar_Extended_B}', "");
    Expect(0, 43520, '\p{Block: 	Myanmar_Extended_B}', "");
    Expect(1, 43520, '\p{^Block: 	Myanmar_Extended_B}', "");
    Expect(1, 43520, '\P{Block: 	Myanmar_Extended_B}', "");
    Expect(0, 43520, '\P{^Block: 	Myanmar_Extended_B}', "");
    Error('\p{Blk:   :=	MYANMAR_ext_B}');
    Error('\P{Blk:   :=	MYANMAR_ext_B}');
    Expect(1, 43519, '\p{Blk=:\AMyanmar_Ext_B\z:}', "");;
    Expect(0, 43520, '\p{Blk=:\AMyanmar_Ext_B\z:}', "");;
    Expect(1, 43519, '\p{Blk=myanmarextb}', "");
    Expect(0, 43519, '\p{^Blk=myanmarextb}', "");
    Expect(0, 43519, '\P{Blk=myanmarextb}', "");
    Expect(1, 43519, '\P{^Blk=myanmarextb}', "");
    Expect(0, 43520, '\p{Blk=myanmarextb}', "");
    Expect(1, 43520, '\p{^Blk=myanmarextb}', "");
    Expect(1, 43520, '\P{Blk=myanmarextb}', "");
    Expect(0, 43520, '\P{^Blk=myanmarextb}', "");
    Expect(1, 43519, '\p{Blk=:\Amyanmarextb\z:}', "");;
    Expect(0, 43520, '\p{Blk=:\Amyanmarextb\z:}', "");;
    Expect(1, 43519, '\p{Blk=--Myanmar_Ext_B}', "");
    Expect(0, 43519, '\p{^Blk=--Myanmar_Ext_B}', "");
    Expect(0, 43519, '\P{Blk=--Myanmar_Ext_B}', "");
    Expect(1, 43519, '\P{^Blk=--Myanmar_Ext_B}', "");
    Expect(0, 43520, '\p{Blk=--Myanmar_Ext_B}', "");
    Expect(1, 43520, '\p{^Blk=--Myanmar_Ext_B}', "");
    Expect(1, 43520, '\P{Blk=--Myanmar_Ext_B}', "");
    Expect(0, 43520, '\P{^Blk=--Myanmar_Ext_B}', "");
    Error('\p{Is_Block=	:=myanmar_Extended_B}');
    Error('\P{Is_Block=	:=myanmar_Extended_B}');
    Expect(1, 43519, '\p{Is_Block=myanmarextendedb}', "");
    Expect(0, 43519, '\p{^Is_Block=myanmarextendedb}', "");
    Expect(0, 43519, '\P{Is_Block=myanmarextendedb}', "");
    Expect(1, 43519, '\P{^Is_Block=myanmarextendedb}', "");
    Expect(0, 43520, '\p{Is_Block=myanmarextendedb}', "");
    Expect(1, 43520, '\p{^Is_Block=myanmarextendedb}', "");
    Expect(1, 43520, '\P{Is_Block=myanmarextendedb}', "");
    Expect(0, 43520, '\P{^Is_Block=myanmarextendedb}', "");
    Expect(1, 43519, '\p{Is_Block=_Myanmar_Extended_B}', "");
    Expect(0, 43519, '\p{^Is_Block=_Myanmar_Extended_B}', "");
    Expect(0, 43519, '\P{Is_Block=_Myanmar_Extended_B}', "");
    Expect(1, 43519, '\P{^Is_Block=_Myanmar_Extended_B}', "");
    Expect(0, 43520, '\p{Is_Block=_Myanmar_Extended_B}', "");
    Expect(1, 43520, '\p{^Is_Block=_Myanmar_Extended_B}', "");
    Expect(1, 43520, '\P{Is_Block=_Myanmar_Extended_B}', "");
    Expect(0, 43520, '\P{^Is_Block=_Myanmar_Extended_B}', "");
    Error('\p{Is_Blk=	 myanmar_ext_b:=}');
    Error('\P{Is_Blk=	 myanmar_ext_b:=}');
    Expect(1, 43519, '\p{Is_Blk=myanmarextb}', "");
    Expect(0, 43519, '\p{^Is_Blk=myanmarextb}', "");
    Expect(0, 43519, '\P{Is_Blk=myanmarextb}', "");
    Expect(1, 43519, '\P{^Is_Blk=myanmarextb}', "");
    Expect(0, 43520, '\p{Is_Blk=myanmarextb}', "");
    Expect(1, 43520, '\p{^Is_Blk=myanmarextb}', "");
    Expect(1, 43520, '\P{Is_Blk=myanmarextb}', "");
    Expect(0, 43520, '\P{^Is_Blk=myanmarextb}', "");
    Expect(1, 43519, '\p{Is_Blk= MYANMAR_Ext_B}', "");
    Expect(0, 43519, '\p{^Is_Blk= MYANMAR_Ext_B}', "");
    Expect(0, 43519, '\P{Is_Blk= MYANMAR_Ext_B}', "");
    Expect(1, 43519, '\P{^Is_Blk= MYANMAR_Ext_B}', "");
    Expect(0, 43520, '\p{Is_Blk= MYANMAR_Ext_B}', "");
    Expect(1, 43520, '\p{^Is_Blk= MYANMAR_Ext_B}', "");
    Expect(1, 43520, '\P{Is_Blk= MYANMAR_Ext_B}', "");
    Expect(0, 43520, '\P{^Is_Blk= MYANMAR_Ext_B}', "");
    Error('\p{Block:/a/ Nabataean}');
    Error('\P{Block:/a/ Nabataean}');
    Expect(1, 67759, '\p{Block=:\ANabataean\z:}', "");;
    Expect(0, 67760, '\p{Block=:\ANabataean\z:}', "");;
    Expect(1, 67759, '\p{Block=nabataean}', "");
    Expect(0, 67759, '\p{^Block=nabataean}', "");
    Expect(0, 67759, '\P{Block=nabataean}', "");
    Expect(1, 67759, '\P{^Block=nabataean}', "");
    Expect(0, 67760, '\p{Block=nabataean}', "");
    Expect(1, 67760, '\p{^Block=nabataean}', "");
    Expect(1, 67760, '\P{Block=nabataean}', "");
    Expect(0, 67760, '\P{^Block=nabataean}', "");
    Expect(1, 67759, '\p{Block=:\Anabataean\z:}', "");;
    Expect(0, 67760, '\p{Block=:\Anabataean\z:}', "");;
    Expect(1, 67759, '\p{Block=	 Nabataean}', "");
    Expect(0, 67759, '\p{^Block=	 Nabataean}', "");
    Expect(0, 67759, '\P{Block=	 Nabataean}', "");
    Expect(1, 67759, '\P{^Block=	 Nabataean}', "");
    Expect(0, 67760, '\p{Block=	 Nabataean}', "");
    Expect(1, 67760, '\p{^Block=	 Nabataean}', "");
    Expect(1, 67760, '\P{Block=	 Nabataean}', "");
    Expect(0, 67760, '\P{^Block=	 Nabataean}', "");
    Error('\p{Blk=:=_ Nabataean}');
    Error('\P{Blk=:=_ Nabataean}');
    Expect(1, 67759, '\p{Blk=:\ANabataean\z:}', "");;
    Expect(0, 67760, '\p{Blk=:\ANabataean\z:}', "");;
    Expect(1, 67759, '\p{Blk:   nabataean}', "");
    Expect(0, 67759, '\p{^Blk:   nabataean}', "");
    Expect(0, 67759, '\P{Blk:   nabataean}', "");
    Expect(1, 67759, '\P{^Blk:   nabataean}', "");
    Expect(0, 67760, '\p{Blk:   nabataean}', "");
    Expect(1, 67760, '\p{^Blk:   nabataean}', "");
    Expect(1, 67760, '\P{Blk:   nabataean}', "");
    Expect(0, 67760, '\P{^Blk:   nabataean}', "");
    Expect(1, 67759, '\p{Blk=:\Anabataean\z:}', "");;
    Expect(0, 67760, '\p{Blk=:\Anabataean\z:}', "");;
    Expect(1, 67759, '\p{Blk=	NABATAEAN}', "");
    Expect(0, 67759, '\p{^Blk=	NABATAEAN}', "");
    Expect(0, 67759, '\P{Blk=	NABATAEAN}', "");
    Expect(1, 67759, '\P{^Blk=	NABATAEAN}', "");
    Expect(0, 67760, '\p{Blk=	NABATAEAN}', "");
    Expect(1, 67760, '\p{^Blk=	NABATAEAN}', "");
    Expect(1, 67760, '\P{Blk=	NABATAEAN}', "");
    Expect(0, 67760, '\P{^Blk=	NABATAEAN}', "");
    Error('\p{Is_Block=-:=Nabataean}');
    Error('\P{Is_Block=-:=Nabataean}');
    Expect(1, 67759, '\p{Is_Block=nabataean}', "");
    Expect(0, 67759, '\p{^Is_Block=nabataean}', "");
    Expect(0, 67759, '\P{Is_Block=nabataean}', "");
    Expect(1, 67759, '\P{^Is_Block=nabataean}', "");
    Expect(0, 67760, '\p{Is_Block=nabataean}', "");
    Expect(1, 67760, '\p{^Is_Block=nabataean}', "");
    Expect(1, 67760, '\P{Is_Block=nabataean}', "");
    Expect(0, 67760, '\P{^Is_Block=nabataean}', "");
    Expect(1, 67759, '\p{Is_Block=-NABATAEAN}', "");
    Expect(0, 67759, '\p{^Is_Block=-NABATAEAN}', "");
    Expect(0, 67759, '\P{Is_Block=-NABATAEAN}', "");
    Expect(1, 67759, '\P{^Is_Block=-NABATAEAN}', "");
    Expect(0, 67760, '\p{Is_Block=-NABATAEAN}', "");
    Expect(1, 67760, '\p{^Is_Block=-NABATAEAN}', "");
    Expect(1, 67760, '\P{Is_Block=-NABATAEAN}', "");
    Expect(0, 67760, '\P{^Is_Block=-NABATAEAN}', "");
    Error('\p{Is_Blk=/a/_nabataean}');
    Error('\P{Is_Blk=/a/_nabataean}');
    Expect(1, 67759, '\p{Is_Blk=nabataean}', "");
    Expect(0, 67759, '\p{^Is_Blk=nabataean}', "");
    Expect(0, 67759, '\P{Is_Blk=nabataean}', "");
    Expect(1, 67759, '\P{^Is_Blk=nabataean}', "");
    Expect(0, 67760, '\p{Is_Blk=nabataean}', "");
    Expect(1, 67760, '\p{^Is_Blk=nabataean}', "");
    Expect(1, 67760, '\P{Is_Blk=nabataean}', "");
    Expect(0, 67760, '\P{^Is_Blk=nabataean}', "");
    Expect(1, 67759, '\p{Is_Blk:  NABATAEAN}', "");
    Expect(0, 67759, '\p{^Is_Blk:  NABATAEAN}', "");
    Expect(0, 67759, '\P{Is_Blk:  NABATAEAN}', "");
    Expect(1, 67759, '\P{^Is_Blk:  NABATAEAN}', "");
    Expect(0, 67760, '\p{Is_Blk:  NABATAEAN}', "");
    Expect(1, 67760, '\p{^Is_Blk:  NABATAEAN}', "");
    Expect(1, 67760, '\P{Is_Blk:  NABATAEAN}', "");
    Expect(0, 67760, '\P{^Is_Blk:  NABATAEAN}', "");
    Error('\p{Block=/a/Nandinagari}');
    Error('\P{Block=/a/Nandinagari}');
    Expect(1, 72191, '\p{Block=:\ANandinagari\z:}', "");;
    Expect(0, 72192, '\p{Block=:\ANandinagari\z:}', "");;
    Expect(1, 72191, '\p{Block=nandinagari}', "");
    Expect(0, 72191, '\p{^Block=nandinagari}', "");
    Expect(0, 72191, '\P{Block=nandinagari}', "");
    Expect(1, 72191, '\P{^Block=nandinagari}', "");
    Expect(0, 72192, '\p{Block=nandinagari}', "");
    Expect(1, 72192, '\p{^Block=nandinagari}', "");
    Expect(1, 72192, '\P{Block=nandinagari}', "");
    Expect(0, 72192, '\P{^Block=nandinagari}', "");
    Expect(1, 72191, '\p{Block=:\Anandinagari\z:}', "");;
    Expect(0, 72192, '\p{Block=:\Anandinagari\z:}', "");;
    Expect(1, 72191, '\p{Block=_ NANDINAGARI}', "");
    Expect(0, 72191, '\p{^Block=_ NANDINAGARI}', "");
    Expect(0, 72191, '\P{Block=_ NANDINAGARI}', "");
    Expect(1, 72191, '\P{^Block=_ NANDINAGARI}', "");
    Expect(0, 72192, '\p{Block=_ NANDINAGARI}', "");
    Expect(1, 72192, '\p{^Block=_ NANDINAGARI}', "");
    Expect(1, 72192, '\P{Block=_ NANDINAGARI}', "");
    Expect(0, 72192, '\P{^Block=_ NANDINAGARI}', "");
    Error('\p{Blk=/a/ NANDINAGARI}');
    Error('\P{Blk=/a/ NANDINAGARI}');
    Expect(1, 72191, '\p{Blk=:\ANandinagari\z:}', "");;
    Expect(0, 72192, '\p{Blk=:\ANandinagari\z:}', "");;
    Expect(1, 72191, '\p{Blk=nandinagari}', "");
    Expect(0, 72191, '\p{^Blk=nandinagari}', "");
    Expect(0, 72191, '\P{Blk=nandinagari}', "");
    Expect(1, 72191, '\P{^Blk=nandinagari}', "");
    Expect(0, 72192, '\p{Blk=nandinagari}', "");
    Expect(1, 72192, '\p{^Blk=nandinagari}', "");
    Expect(1, 72192, '\P{Blk=nandinagari}', "");
    Expect(0, 72192, '\P{^Blk=nandinagari}', "");
    Expect(1, 72191, '\p{Blk=:\Anandinagari\z:}', "");;
    Expect(0, 72192, '\p{Blk=:\Anandinagari\z:}', "");;
    Expect(1, 72191, '\p{Blk=__Nandinagari}', "");
    Expect(0, 72191, '\p{^Blk=__Nandinagari}', "");
    Expect(0, 72191, '\P{Blk=__Nandinagari}', "");
    Expect(1, 72191, '\P{^Blk=__Nandinagari}', "");
    Expect(0, 72192, '\p{Blk=__Nandinagari}', "");
    Expect(1, 72192, '\p{^Blk=__Nandinagari}', "");
    Expect(1, 72192, '\P{Blk=__Nandinagari}', "");
    Expect(0, 72192, '\P{^Blk=__Nandinagari}', "");
    Error('\p{Is_Block:	_nandinagari:=}');
    Error('\P{Is_Block:	_nandinagari:=}');
    Expect(1, 72191, '\p{Is_Block=nandinagari}', "");
    Expect(0, 72191, '\p{^Is_Block=nandinagari}', "");
    Expect(0, 72191, '\P{Is_Block=nandinagari}', "");
    Expect(1, 72191, '\P{^Is_Block=nandinagari}', "");
    Expect(0, 72192, '\p{Is_Block=nandinagari}', "");
    Expect(1, 72192, '\p{^Is_Block=nandinagari}', "");
    Expect(1, 72192, '\P{Is_Block=nandinagari}', "");
    Expect(0, 72192, '\P{^Is_Block=nandinagari}', "");
    Expect(1, 72191, '\p{Is_Block= nandinagari}', "");
    Expect(0, 72191, '\p{^Is_Block= nandinagari}', "");
    Expect(0, 72191, '\P{Is_Block= nandinagari}', "");
    Expect(1, 72191, '\P{^Is_Block= nandinagari}', "");
    Expect(0, 72192, '\p{Is_Block= nandinagari}', "");
    Expect(1, 72192, '\p{^Is_Block= nandinagari}', "");
    Expect(1, 72192, '\P{Is_Block= nandinagari}', "");
    Expect(0, 72192, '\P{^Is_Block= nandinagari}', "");
    Error('\p{Is_Blk=	/a/nandinagari}');
    Error('\P{Is_Blk=	/a/nandinagari}');
    Expect(1, 72191, '\p{Is_Blk=nandinagari}', "");
    Expect(0, 72191, '\p{^Is_Blk=nandinagari}', "");
    Expect(0, 72191, '\P{Is_Blk=nandinagari}', "");
    Expect(1, 72191, '\P{^Is_Blk=nandinagari}', "");
    Expect(0, 72192, '\p{Is_Blk=nandinagari}', "");
    Expect(1, 72192, '\p{^Is_Blk=nandinagari}', "");
    Expect(1, 72192, '\P{Is_Blk=nandinagari}', "");
    Expect(0, 72192, '\P{^Is_Blk=nandinagari}', "");
    Expect(1, 72191, '\p{Is_Blk=_	Nandinagari}', "");
    Expect(0, 72191, '\p{^Is_Blk=_	Nandinagari}', "");
    Expect(0, 72191, '\P{Is_Blk=_	Nandinagari}', "");
    Expect(1, 72191, '\P{^Is_Blk=_	Nandinagari}', "");
    Expect(0, 72192, '\p{Is_Blk=_	Nandinagari}', "");
    Expect(1, 72192, '\p{^Is_Blk=_	Nandinagari}', "");
    Expect(1, 72192, '\P{Is_Blk=_	Nandinagari}', "");
    Expect(0, 72192, '\P{^Is_Blk=_	Nandinagari}', "");
    Error('\p{Block=-:=no_Block}');
    Error('\P{Block=-:=no_Block}');
    Expect(1, 918000, '\p{Block=:\ANo_Block\z:}', "");;
    Expect(0, 983040, '\p{Block=:\ANo_Block\z:}', "");;
    Expect(1, 918000, '\p{Block=noblock}', "");
    Expect(0, 918000, '\p{^Block=noblock}', "");
    Expect(0, 918000, '\P{Block=noblock}', "");
    Expect(1, 918000, '\P{^Block=noblock}', "");
    Expect(0, 983040, '\p{Block=noblock}', "");
    Expect(1, 983040, '\p{^Block=noblock}', "");
    Expect(1, 983040, '\P{Block=noblock}', "");
    Expect(0, 983040, '\P{^Block=noblock}', "");
    Expect(1, 918000, '\p{Block=:\Anoblock\z:}', "");;
    Expect(0, 983040, '\p{Block=:\Anoblock\z:}', "");;
    Expect(1, 918000, '\p{Block=  No_BLOCK}', "");
    Expect(0, 918000, '\p{^Block=  No_BLOCK}', "");
    Expect(0, 918000, '\P{Block=  No_BLOCK}', "");
    Expect(1, 918000, '\P{^Block=  No_BLOCK}', "");
    Expect(0, 983040, '\p{Block=  No_BLOCK}', "");
    Expect(1, 983040, '\p{^Block=  No_BLOCK}', "");
    Expect(1, 983040, '\P{Block=  No_BLOCK}', "");
    Expect(0, 983040, '\P{^Block=  No_BLOCK}', "");
    Error('\p{Blk=/a/_-NB}');
    Error('\P{Blk=/a/_-NB}');
    Expect(1, 918000, '\p{Blk=:\ANB\z:}', "");;
    Expect(0, 983040, '\p{Blk=:\ANB\z:}', "");;
    Expect(1, 918000, '\p{Blk=nb}', "");
    Expect(0, 918000, '\p{^Blk=nb}', "");
    Expect(0, 918000, '\P{Blk=nb}', "");
    Expect(1, 918000, '\P{^Blk=nb}', "");
    Expect(0, 983040, '\p{Blk=nb}', "");
    Expect(1, 983040, '\p{^Blk=nb}', "");
    Expect(1, 983040, '\P{Blk=nb}', "");
    Expect(0, 983040, '\P{^Blk=nb}', "");
    Expect(1, 918000, '\p{Blk=:\Anb\z:}', "");;
    Expect(0, 983040, '\p{Blk=:\Anb\z:}', "");;
    Expect(1, 918000, '\p{Blk=	NB}', "");
    Expect(0, 918000, '\p{^Blk=	NB}', "");
    Expect(0, 918000, '\P{Blk=	NB}', "");
    Expect(1, 918000, '\P{^Blk=	NB}', "");
    Expect(0, 983040, '\p{Blk=	NB}', "");
    Expect(1, 983040, '\p{^Blk=	NB}', "");
    Expect(1, 983040, '\P{Blk=	NB}', "");
    Expect(0, 983040, '\P{^Blk=	NB}', "");
    Error('\p{Is_Block=:=	_No_BLOCK}');
    Error('\P{Is_Block=:=	_No_BLOCK}');
    Expect(1, 918000, '\p{Is_Block=noblock}', "");
    Expect(0, 918000, '\p{^Is_Block=noblock}', "");
    Expect(0, 918000, '\P{Is_Block=noblock}', "");
    Expect(1, 918000, '\P{^Is_Block=noblock}', "");
    Expect(0, 983040, '\p{Is_Block=noblock}', "");
    Expect(1, 983040, '\p{^Is_Block=noblock}', "");
    Expect(1, 983040, '\P{Is_Block=noblock}', "");
    Expect(0, 983040, '\P{^Is_Block=noblock}', "");
    Expect(1, 918000, '\p{Is_Block= -NO_Block}', "");
    Expect(0, 918000, '\p{^Is_Block= -NO_Block}', "");
    Expect(0, 918000, '\P{Is_Block= -NO_Block}', "");
    Expect(1, 918000, '\P{^Is_Block= -NO_Block}', "");
    Expect(0, 983040, '\p{Is_Block= -NO_Block}', "");
    Expect(1, 983040, '\p{^Is_Block= -NO_Block}', "");
    Expect(1, 983040, '\P{Is_Block= -NO_Block}', "");
    Expect(0, 983040, '\P{^Is_Block= -NO_Block}', "");
    Error('\p{Is_Blk=/a/	-NB}');
    Error('\P{Is_Blk=/a/	-NB}');
    Expect(1, 918000, '\p{Is_Blk: nb}', "");
    Expect(0, 918000, '\p{^Is_Blk: nb}', "");
    Expect(0, 918000, '\P{Is_Blk: nb}', "");
    Expect(1, 918000, '\P{^Is_Blk: nb}', "");
    Expect(0, 983040, '\p{Is_Blk: nb}', "");
    Expect(1, 983040, '\p{^Is_Blk: nb}', "");
    Expect(1, 983040, '\P{Is_Blk: nb}', "");
    Expect(0, 983040, '\P{^Is_Blk: nb}', "");
    Expect(1, 918000, '\p{Is_Blk=	-nb}', "");
    Expect(0, 918000, '\p{^Is_Blk=	-nb}', "");
    Expect(0, 918000, '\P{Is_Blk=	-nb}', "");
    Expect(1, 918000, '\P{^Is_Blk=	-nb}', "");
    Expect(0, 983040, '\p{Is_Blk=	-nb}', "");
    Expect(1, 983040, '\p{^Is_Blk=	-nb}', "");
    Expect(1, 983040, '\P{Is_Blk=	-nb}', "");
    Expect(0, 983040, '\P{^Is_Blk=	-nb}', "");
    Error('\p{Block=/a/		new_TAI_Lue}');
    Error('\P{Block=/a/		new_TAI_Lue}');
    Expect(1, 6623, '\p{Block=:\ANew_Tai_Lue\z:}', "");;
    Expect(0, 6624, '\p{Block=:\ANew_Tai_Lue\z:}', "");;
    Expect(1, 6623, '\p{Block=newtailue}', "");
    Expect(0, 6623, '\p{^Block=newtailue}', "");
    Expect(0, 6623, '\P{Block=newtailue}', "");
    Expect(1, 6623, '\P{^Block=newtailue}', "");
    Expect(0, 6624, '\p{Block=newtailue}', "");
    Expect(1, 6624, '\p{^Block=newtailue}', "");
    Expect(1, 6624, '\P{Block=newtailue}', "");
    Expect(0, 6624, '\P{^Block=newtailue}', "");
    Expect(1, 6623, '\p{Block=:\Anewtailue\z:}', "");;
    Expect(0, 6624, '\p{Block=:\Anewtailue\z:}', "");;
    Expect(1, 6623, '\p{Block=- New_Tai_LUE}', "");
    Expect(0, 6623, '\p{^Block=- New_Tai_LUE}', "");
    Expect(0, 6623, '\P{Block=- New_Tai_LUE}', "");
    Expect(1, 6623, '\P{^Block=- New_Tai_LUE}', "");
    Expect(0, 6624, '\p{Block=- New_Tai_LUE}', "");
    Expect(1, 6624, '\p{^Block=- New_Tai_LUE}', "");
    Expect(1, 6624, '\P{Block=- New_Tai_LUE}', "");
    Expect(0, 6624, '\P{^Block=- New_Tai_LUE}', "");
    Error('\p{Blk=	NEW_Tai_LUE:=}');
    Error('\P{Blk=	NEW_Tai_LUE:=}');
    Expect(1, 6623, '\p{Blk=:\ANew_Tai_Lue\z:}', "");;
    Expect(0, 6624, '\p{Blk=:\ANew_Tai_Lue\z:}', "");;
    Expect(1, 6623, '\p{Blk=newtailue}', "");
    Expect(0, 6623, '\p{^Blk=newtailue}', "");
    Expect(0, 6623, '\P{Blk=newtailue}', "");
    Expect(1, 6623, '\P{^Blk=newtailue}', "");
    Expect(0, 6624, '\p{Blk=newtailue}', "");
    Expect(1, 6624, '\p{^Blk=newtailue}', "");
    Expect(1, 6624, '\P{Blk=newtailue}', "");
    Expect(0, 6624, '\P{^Blk=newtailue}', "");
    Expect(1, 6623, '\p{Blk=:\Anewtailue\z:}', "");;
    Expect(0, 6624, '\p{Blk=:\Anewtailue\z:}', "");;
    Expect(1, 6623, '\p{Blk=_new_Tai_lue}', "");
    Expect(0, 6623, '\p{^Blk=_new_Tai_lue}', "");
    Expect(0, 6623, '\P{Blk=_new_Tai_lue}', "");
    Expect(1, 6623, '\P{^Blk=_new_Tai_lue}', "");
    Expect(0, 6624, '\p{Blk=_new_Tai_lue}', "");
    Expect(1, 6624, '\p{^Blk=_new_Tai_lue}', "");
    Expect(1, 6624, '\P{Blk=_new_Tai_lue}', "");
    Expect(0, 6624, '\P{^Blk=_new_Tai_lue}', "");
    Error('\p{Is_Block=_/a/New_tai_Lue}');
    Error('\P{Is_Block=_/a/New_tai_Lue}');
    Expect(1, 6623, '\p{Is_Block=newtailue}', "");
    Expect(0, 6623, '\p{^Is_Block=newtailue}', "");
    Expect(0, 6623, '\P{Is_Block=newtailue}', "");
    Expect(1, 6623, '\P{^Is_Block=newtailue}', "");
    Expect(0, 6624, '\p{Is_Block=newtailue}', "");
    Expect(1, 6624, '\p{^Is_Block=newtailue}', "");
    Expect(1, 6624, '\P{Is_Block=newtailue}', "");
    Expect(0, 6624, '\P{^Is_Block=newtailue}', "");
    Expect(1, 6623, '\p{Is_Block=_	New_tai_Lue}', "");
    Expect(0, 6623, '\p{^Is_Block=_	New_tai_Lue}', "");
    Expect(0, 6623, '\P{Is_Block=_	New_tai_Lue}', "");
    Expect(1, 6623, '\P{^Is_Block=_	New_tai_Lue}', "");
    Expect(0, 6624, '\p{Is_Block=_	New_tai_Lue}', "");
    Expect(1, 6624, '\p{^Is_Block=_	New_tai_Lue}', "");
    Expect(1, 6624, '\P{Is_Block=_	New_tai_Lue}', "");
    Expect(0, 6624, '\P{^Is_Block=_	New_tai_Lue}', "");
    Error('\p{Is_Blk= _NEW_tai_LUE:=}');
    Error('\P{Is_Blk= _NEW_tai_LUE:=}');
    Expect(1, 6623, '\p{Is_Blk=newtailue}', "");
    Expect(0, 6623, '\p{^Is_Blk=newtailue}', "");
    Expect(0, 6623, '\P{Is_Blk=newtailue}', "");
    Expect(1, 6623, '\P{^Is_Blk=newtailue}', "");
    Expect(0, 6624, '\p{Is_Blk=newtailue}', "");
    Expect(1, 6624, '\p{^Is_Blk=newtailue}', "");
    Expect(1, 6624, '\P{Is_Blk=newtailue}', "");
    Expect(0, 6624, '\P{^Is_Blk=newtailue}', "");
    Expect(1, 6623, '\p{Is_Blk: _New_tai_LUE}', "");
    Expect(0, 6623, '\p{^Is_Blk: _New_tai_LUE}', "");
    Expect(0, 6623, '\P{Is_Blk: _New_tai_LUE}', "");
    Expect(1, 6623, '\P{^Is_Blk: _New_tai_LUE}', "");
    Expect(0, 6624, '\p{Is_Blk: _New_tai_LUE}', "");
    Expect(1, 6624, '\p{^Is_Blk: _New_tai_LUE}', "");
    Expect(1, 6624, '\P{Is_Blk: _New_tai_LUE}', "");
    Expect(0, 6624, '\P{^Is_Blk: _New_tai_LUE}', "");
    Error('\p{Block=/a/	 newa}');
    Error('\P{Block=/a/	 newa}');
    Expect(1, 70783, '\p{Block=:\ANewa\z:}', "");;
    Expect(0, 70784, '\p{Block=:\ANewa\z:}', "");;
    Expect(1, 70783, '\p{Block=newa}', "");
    Expect(0, 70783, '\p{^Block=newa}', "");
    Expect(0, 70783, '\P{Block=newa}', "");
    Expect(1, 70783, '\P{^Block=newa}', "");
    Expect(0, 70784, '\p{Block=newa}', "");
    Expect(1, 70784, '\p{^Block=newa}', "");
    Expect(1, 70784, '\P{Block=newa}', "");
    Expect(0, 70784, '\P{^Block=newa}', "");
    Expect(1, 70783, '\p{Block=:\Anewa\z:}', "");;
    Expect(0, 70784, '\p{Block=:\Anewa\z:}', "");;
    Expect(1, 70783, '\p{Block=	newa}', "");
    Expect(0, 70783, '\p{^Block=	newa}', "");
    Expect(0, 70783, '\P{Block=	newa}', "");
    Expect(1, 70783, '\P{^Block=	newa}', "");
    Expect(0, 70784, '\p{Block=	newa}', "");
    Expect(1, 70784, '\p{^Block=	newa}', "");
    Expect(1, 70784, '\P{Block=	newa}', "");
    Expect(0, 70784, '\P{^Block=	newa}', "");
    Error('\p{Blk=	 Newa:=}');
    Error('\P{Blk=	 Newa:=}');
    Expect(1, 70783, '\p{Blk=:\ANewa\z:}', "");;
    Expect(0, 70784, '\p{Blk=:\ANewa\z:}', "");;
    Expect(1, 70783, '\p{Blk: newa}', "");
    Expect(0, 70783, '\p{^Blk: newa}', "");
    Expect(0, 70783, '\P{Blk: newa}', "");
    Expect(1, 70783, '\P{^Blk: newa}', "");
    Expect(0, 70784, '\p{Blk: newa}', "");
    Expect(1, 70784, '\p{^Blk: newa}', "");
    Expect(1, 70784, '\P{Blk: newa}', "");
    Expect(0, 70784, '\P{^Blk: newa}', "");
    Expect(1, 70783, '\p{Blk=:\Anewa\z:}', "");;
    Expect(0, 70784, '\p{Blk=:\Anewa\z:}', "");;
    Expect(1, 70783, '\p{Blk=	-Newa}', "");
    Expect(0, 70783, '\p{^Blk=	-Newa}', "");
    Expect(0, 70783, '\P{Blk=	-Newa}', "");
    Expect(1, 70783, '\P{^Blk=	-Newa}', "");
    Expect(0, 70784, '\p{Blk=	-Newa}', "");
    Expect(1, 70784, '\p{^Blk=	-Newa}', "");
    Expect(1, 70784, '\P{Blk=	-Newa}', "");
    Expect(0, 70784, '\P{^Blk=	-Newa}', "");
    Error('\p{Is_Block: _-newa/a/}');
    Error('\P{Is_Block: _-newa/a/}');
    Expect(1, 70783, '\p{Is_Block=newa}', "");
    Expect(0, 70783, '\p{^Is_Block=newa}', "");
    Expect(0, 70783, '\P{Is_Block=newa}', "");
    Expect(1, 70783, '\P{^Is_Block=newa}', "");
    Expect(0, 70784, '\p{Is_Block=newa}', "");
    Expect(1, 70784, '\p{^Is_Block=newa}', "");
    Expect(1, 70784, '\P{Is_Block=newa}', "");
    Expect(0, 70784, '\P{^Is_Block=newa}', "");
    Expect(1, 70783, '\p{Is_Block=_-Newa}', "");
    Expect(0, 70783, '\p{^Is_Block=_-Newa}', "");
    Expect(0, 70783, '\P{Is_Block=_-Newa}', "");
    Expect(1, 70783, '\P{^Is_Block=_-Newa}', "");
    Expect(0, 70784, '\p{Is_Block=_-Newa}', "");
    Expect(1, 70784, '\p{^Is_Block=_-Newa}', "");
    Expect(1, 70784, '\P{Is_Block=_-Newa}', "");
    Expect(0, 70784, '\P{^Is_Block=_-Newa}', "");
    Error('\p{Is_Blk=:=	_Newa}');
    Error('\P{Is_Blk=:=	_Newa}');
    Expect(1, 70783, '\p{Is_Blk:   newa}', "");
    Expect(0, 70783, '\p{^Is_Blk:   newa}', "");
    Expect(0, 70783, '\P{Is_Blk:   newa}', "");
    Expect(1, 70783, '\P{^Is_Blk:   newa}', "");
    Expect(0, 70784, '\p{Is_Blk:   newa}', "");
    Expect(1, 70784, '\p{^Is_Blk:   newa}', "");
    Expect(1, 70784, '\P{Is_Blk:   newa}', "");
    Expect(0, 70784, '\P{^Is_Blk:   newa}', "");
    Expect(1, 70783, '\p{Is_Blk=-NEWA}', "");
    Expect(0, 70783, '\p{^Is_Blk=-NEWA}', "");
    Expect(0, 70783, '\P{Is_Blk=-NEWA}', "");
    Expect(1, 70783, '\P{^Is_Blk=-NEWA}', "");
    Expect(0, 70784, '\p{Is_Blk=-NEWA}', "");
    Expect(1, 70784, '\p{^Is_Blk=-NEWA}', "");
    Expect(1, 70784, '\P{Is_Blk=-NEWA}', "");
    Expect(0, 70784, '\P{^Is_Blk=-NEWA}', "");
    Error('\p{Block: /a/	NKO}');
    Error('\P{Block: /a/	NKO}');
    Expect(1, 2047, '\p{Block=:\ANKo\z:}', "");;
    Expect(0, 2048, '\p{Block=:\ANKo\z:}', "");;
    Expect(1, 2047, '\p{Block=nko}', "");
    Expect(0, 2047, '\p{^Block=nko}', "");
    Expect(0, 2047, '\P{Block=nko}', "");
    Expect(1, 2047, '\P{^Block=nko}', "");
    Expect(0, 2048, '\p{Block=nko}', "");
    Expect(1, 2048, '\p{^Block=nko}', "");
    Expect(1, 2048, '\P{Block=nko}', "");
    Expect(0, 2048, '\P{^Block=nko}', "");
    Expect(1, 2047, '\p{Block=:\Anko\z:}', "");;
    Expect(0, 2048, '\p{Block=:\Anko\z:}', "");;
    Expect(1, 2047, '\p{Block=	 NKo}', "");
    Expect(0, 2047, '\p{^Block=	 NKo}', "");
    Expect(0, 2047, '\P{Block=	 NKo}', "");
    Expect(1, 2047, '\P{^Block=	 NKo}', "");
    Expect(0, 2048, '\p{Block=	 NKo}', "");
    Expect(1, 2048, '\p{^Block=	 NKo}', "");
    Expect(1, 2048, '\P{Block=	 NKo}', "");
    Expect(0, 2048, '\P{^Block=	 NKo}', "");
    Error('\p{Blk= :=nko}');
    Error('\P{Blk= :=nko}');
    Expect(1, 2047, '\p{Blk=:\ANKo\z:}', "");;
    Expect(0, 2048, '\p{Blk=:\ANKo\z:}', "");;
    Expect(1, 2047, '\p{Blk: nko}', "");
    Expect(0, 2047, '\p{^Blk: nko}', "");
    Expect(0, 2047, '\P{Blk: nko}', "");
    Expect(1, 2047, '\P{^Blk: nko}', "");
    Expect(0, 2048, '\p{Blk: nko}', "");
    Expect(1, 2048, '\p{^Blk: nko}', "");
    Expect(1, 2048, '\P{Blk: nko}', "");
    Expect(0, 2048, '\P{^Blk: nko}', "");
    Expect(1, 2047, '\p{Blk=:\Anko\z:}', "");;
    Expect(0, 2048, '\p{Blk=:\Anko\z:}', "");;
    Expect(1, 2047, '\p{Blk= NKo}', "");
    Expect(0, 2047, '\p{^Blk= NKo}', "");
    Expect(0, 2047, '\P{Blk= NKo}', "");
    Expect(1, 2047, '\P{^Blk= NKo}', "");
    Expect(0, 2048, '\p{Blk= NKo}', "");
    Expect(1, 2048, '\p{^Blk= NKo}', "");
    Expect(1, 2048, '\P{Blk= NKo}', "");
    Expect(0, 2048, '\P{^Blk= NKo}', "");
    Error('\p{Is_Block= NKo:=}');
    Error('\P{Is_Block= NKo:=}');
    Expect(1, 2047, '\p{Is_Block=nko}', "");
    Expect(0, 2047, '\p{^Is_Block=nko}', "");
    Expect(0, 2047, '\P{Is_Block=nko}', "");
    Expect(1, 2047, '\P{^Is_Block=nko}', "");
    Expect(0, 2048, '\p{Is_Block=nko}', "");
    Expect(1, 2048, '\p{^Is_Block=nko}', "");
    Expect(1, 2048, '\P{Is_Block=nko}', "");
    Expect(0, 2048, '\P{^Is_Block=nko}', "");
    Expect(1, 2047, '\p{Is_Block=_NKo}', "");
    Expect(0, 2047, '\p{^Is_Block=_NKo}', "");
    Expect(0, 2047, '\P{Is_Block=_NKo}', "");
    Expect(1, 2047, '\P{^Is_Block=_NKo}', "");
    Expect(0, 2048, '\p{Is_Block=_NKo}', "");
    Expect(1, 2048, '\p{^Is_Block=_NKo}', "");
    Expect(1, 2048, '\P{Is_Block=_NKo}', "");
    Expect(0, 2048, '\P{^Is_Block=_NKo}', "");
    Error('\p{Is_Blk=	/a/NKo}');
    Error('\P{Is_Blk=	/a/NKo}');
    Expect(1, 2047, '\p{Is_Blk:   nko}', "");
    Expect(0, 2047, '\p{^Is_Blk:   nko}', "");
    Expect(0, 2047, '\P{Is_Blk:   nko}', "");
    Expect(1, 2047, '\P{^Is_Blk:   nko}', "");
    Expect(0, 2048, '\p{Is_Blk:   nko}', "");
    Expect(1, 2048, '\p{^Is_Blk:   nko}', "");
    Expect(1, 2048, '\P{Is_Blk:   nko}', "");
    Expect(0, 2048, '\P{^Is_Blk:   nko}', "");
    Expect(1, 2047, '\p{Is_Blk=-_nko}', "");
    Expect(0, 2047, '\p{^Is_Blk=-_nko}', "");
    Expect(0, 2047, '\P{Is_Blk=-_nko}', "");
    Expect(1, 2047, '\P{^Is_Blk=-_nko}', "");
    Expect(0, 2048, '\p{Is_Blk=-_nko}', "");
    Expect(1, 2048, '\p{^Is_Blk=-_nko}', "");
    Expect(1, 2048, '\P{Is_Blk=-_nko}', "");
    Expect(0, 2048, '\P{^Is_Blk=-_nko}', "");
    Error('\p{Block=--number_Forms:=}');
    Error('\P{Block=--number_Forms:=}');
    Expect(1, 8591, '\p{Block=:\ANumber_Forms\z:}', "");;
    Expect(0, 8592, '\p{Block=:\ANumber_Forms\z:}', "");;
    Expect(1, 8591, '\p{Block=numberforms}', "");
    Expect(0, 8591, '\p{^Block=numberforms}', "");
    Expect(0, 8591, '\P{Block=numberforms}', "");
    Expect(1, 8591, '\P{^Block=numberforms}', "");
    Expect(0, 8592, '\p{Block=numberforms}', "");
    Expect(1, 8592, '\p{^Block=numberforms}', "");
    Expect(1, 8592, '\P{Block=numberforms}', "");
    Expect(0, 8592, '\P{^Block=numberforms}', "");
    Expect(1, 8591, '\p{Block=:\Anumberforms\z:}', "");;
    Expect(0, 8592, '\p{Block=:\Anumberforms\z:}', "");;
    Expect(1, 8591, '\p{Block: _Number_Forms}', "");
    Expect(0, 8591, '\p{^Block: _Number_Forms}', "");
    Expect(0, 8591, '\P{Block: _Number_Forms}', "");
    Expect(1, 8591, '\P{^Block: _Number_Forms}', "");
    Expect(0, 8592, '\p{Block: _Number_Forms}', "");
    Expect(1, 8592, '\p{^Block: _Number_Forms}', "");
    Expect(1, 8592, '\P{Block: _Number_Forms}', "");
    Expect(0, 8592, '\P{^Block: _Number_Forms}', "");
    Error('\p{Blk= number_Forms/a/}');
    Error('\P{Blk= number_Forms/a/}');
    Expect(1, 8591, '\p{Blk=:\ANumber_Forms\z:}', "");;
    Expect(0, 8592, '\p{Blk=:\ANumber_Forms\z:}', "");;
    Expect(1, 8591, '\p{Blk=numberforms}', "");
    Expect(0, 8591, '\p{^Blk=numberforms}', "");
    Expect(0, 8591, '\P{Blk=numberforms}', "");
    Expect(1, 8591, '\P{^Blk=numberforms}', "");
    Expect(0, 8592, '\p{Blk=numberforms}', "");
    Expect(1, 8592, '\p{^Blk=numberforms}', "");
    Expect(1, 8592, '\P{Blk=numberforms}', "");
    Expect(0, 8592, '\P{^Blk=numberforms}', "");
    Expect(1, 8591, '\p{Blk=:\Anumberforms\z:}', "");;
    Expect(0, 8592, '\p{Blk=:\Anumberforms\z:}', "");;
    Expect(1, 8591, '\p{Blk=	_number_forms}', "");
    Expect(0, 8591, '\p{^Blk=	_number_forms}', "");
    Expect(0, 8591, '\P{Blk=	_number_forms}', "");
    Expect(1, 8591, '\P{^Blk=	_number_forms}', "");
    Expect(0, 8592, '\p{Blk=	_number_forms}', "");
    Expect(1, 8592, '\p{^Blk=	_number_forms}', "");
    Expect(1, 8592, '\P{Blk=	_number_forms}', "");
    Expect(0, 8592, '\P{^Blk=	_number_forms}', "");
    Error('\p{Is_Block=:=-Number_Forms}');
    Error('\P{Is_Block=:=-Number_Forms}');
    Expect(1, 8591, '\p{Is_Block:	numberforms}', "");
    Expect(0, 8591, '\p{^Is_Block:	numberforms}', "");
    Expect(0, 8591, '\P{Is_Block:	numberforms}', "");
    Expect(1, 8591, '\P{^Is_Block:	numberforms}', "");
    Expect(0, 8592, '\p{Is_Block:	numberforms}', "");
    Expect(1, 8592, '\p{^Is_Block:	numberforms}', "");
    Expect(1, 8592, '\P{Is_Block:	numberforms}', "");
    Expect(0, 8592, '\P{^Is_Block:	numberforms}', "");
    Expect(1, 8591, '\p{Is_Block=		NUMBER_Forms}', "");
    Expect(0, 8591, '\p{^Is_Block=		NUMBER_Forms}', "");
    Expect(0, 8591, '\P{Is_Block=		NUMBER_Forms}', "");
    Expect(1, 8591, '\P{^Is_Block=		NUMBER_Forms}', "");
    Expect(0, 8592, '\p{Is_Block=		NUMBER_Forms}', "");
    Expect(1, 8592, '\p{^Is_Block=		NUMBER_Forms}', "");
    Expect(1, 8592, '\P{Is_Block=		NUMBER_Forms}', "");
    Expect(0, 8592, '\P{^Is_Block=		NUMBER_Forms}', "");
    Error('\p{Is_Blk=:=	_number_FORMS}');
    Error('\P{Is_Blk=:=	_number_FORMS}');
    Expect(1, 8591, '\p{Is_Blk:numberforms}', "");
    Expect(0, 8591, '\p{^Is_Blk:numberforms}', "");
    Expect(0, 8591, '\P{Is_Blk:numberforms}', "");
    Expect(1, 8591, '\P{^Is_Blk:numberforms}', "");
    Expect(0, 8592, '\p{Is_Blk:numberforms}', "");
    Expect(1, 8592, '\p{^Is_Blk:numberforms}', "");
    Expect(1, 8592, '\P{Is_Blk:numberforms}', "");
    Expect(0, 8592, '\P{^Is_Blk:numberforms}', "");
    Expect(1, 8591, '\p{Is_Blk=- NUMBER_Forms}', "");
    Expect(0, 8591, '\p{^Is_Blk=- NUMBER_Forms}', "");
    Expect(0, 8591, '\P{Is_Blk=- NUMBER_Forms}', "");
    Expect(1, 8591, '\P{^Is_Blk=- NUMBER_Forms}', "");
    Expect(0, 8592, '\p{Is_Blk=- NUMBER_Forms}', "");
    Expect(1, 8592, '\p{^Is_Blk=- NUMBER_Forms}', "");
    Expect(1, 8592, '\P{Is_Blk=- NUMBER_Forms}', "");
    Expect(0, 8592, '\P{^Is_Blk=- NUMBER_Forms}', "");
    Error('\p{Block:	_ nushu/a/}');
    Error('\P{Block:	_ nushu/a/}');
    Expect(1, 111359, '\p{Block=:\ANushu\z:}', "");;
    Expect(0, 111360, '\p{Block=:\ANushu\z:}', "");;
    Expect(1, 111359, '\p{Block=nushu}', "");
    Expect(0, 111359, '\p{^Block=nushu}', "");
    Expect(0, 111359, '\P{Block=nushu}', "");
    Expect(1, 111359, '\P{^Block=nushu}', "");
    Expect(0, 111360, '\p{Block=nushu}', "");
    Expect(1, 111360, '\p{^Block=nushu}', "");
    Expect(1, 111360, '\P{Block=nushu}', "");
    Expect(0, 111360, '\P{^Block=nushu}', "");
    Expect(1, 111359, '\p{Block=:\Anushu\z:}', "");;
    Expect(0, 111360, '\p{Block=:\Anushu\z:}', "");;
    Expect(1, 111359, '\p{Block=		nushu}', "");
    Expect(0, 111359, '\p{^Block=		nushu}', "");
    Expect(0, 111359, '\P{Block=		nushu}', "");
    Expect(1, 111359, '\P{^Block=		nushu}', "");
    Expect(0, 111360, '\p{Block=		nushu}', "");
    Expect(1, 111360, '\p{^Block=		nushu}', "");
    Expect(1, 111360, '\P{Block=		nushu}', "");
    Expect(0, 111360, '\P{^Block=		nushu}', "");
    Error('\p{Blk=--nushu/a/}');
    Error('\P{Blk=--nushu/a/}');
    Expect(1, 111359, '\p{Blk=:\ANushu\z:}', "");;
    Expect(0, 111360, '\p{Blk=:\ANushu\z:}', "");;
    Expect(1, 111359, '\p{Blk:   nushu}', "");
    Expect(0, 111359, '\p{^Blk:   nushu}', "");
    Expect(0, 111359, '\P{Blk:   nushu}', "");
    Expect(1, 111359, '\P{^Blk:   nushu}', "");
    Expect(0, 111360, '\p{Blk:   nushu}', "");
    Expect(1, 111360, '\p{^Blk:   nushu}', "");
    Expect(1, 111360, '\P{Blk:   nushu}', "");
    Expect(0, 111360, '\P{^Blk:   nushu}', "");
    Expect(1, 111359, '\p{Blk=:\Anushu\z:}', "");;
    Expect(0, 111360, '\p{Blk=:\Anushu\z:}', "");;
    Expect(1, 111359, '\p{Blk=_-Nushu}', "");
    Expect(0, 111359, '\p{^Blk=_-Nushu}', "");
    Expect(0, 111359, '\P{Blk=_-Nushu}', "");
    Expect(1, 111359, '\P{^Blk=_-Nushu}', "");
    Expect(0, 111360, '\p{Blk=_-Nushu}', "");
    Expect(1, 111360, '\p{^Blk=_-Nushu}', "");
    Expect(1, 111360, '\P{Blk=_-Nushu}', "");
    Expect(0, 111360, '\P{^Blk=_-Nushu}', "");
    Error('\p{Is_Block=	_Nushu:=}');
    Error('\P{Is_Block=	_Nushu:=}');
    Expect(1, 111359, '\p{Is_Block=nushu}', "");
    Expect(0, 111359, '\p{^Is_Block=nushu}', "");
    Expect(0, 111359, '\P{Is_Block=nushu}', "");
    Expect(1, 111359, '\P{^Is_Block=nushu}', "");
    Expect(0, 111360, '\p{Is_Block=nushu}', "");
    Expect(1, 111360, '\p{^Is_Block=nushu}', "");
    Expect(1, 111360, '\P{Is_Block=nushu}', "");
    Expect(0, 111360, '\P{^Is_Block=nushu}', "");
    Expect(1, 111359, '\p{Is_Block=__Nushu}', "");
    Expect(0, 111359, '\p{^Is_Block=__Nushu}', "");
    Expect(0, 111359, '\P{Is_Block=__Nushu}', "");
    Expect(1, 111359, '\P{^Is_Block=__Nushu}', "");
    Expect(0, 111360, '\p{Is_Block=__Nushu}', "");
    Expect(1, 111360, '\p{^Is_Block=__Nushu}', "");
    Expect(1, 111360, '\P{Is_Block=__Nushu}', "");
    Expect(0, 111360, '\P{^Is_Block=__Nushu}', "");
    Error('\p{Is_Blk=:=_Nushu}');
    Error('\P{Is_Blk=:=_Nushu}');
    Expect(1, 111359, '\p{Is_Blk=nushu}', "");
    Expect(0, 111359, '\p{^Is_Blk=nushu}', "");
    Expect(0, 111359, '\P{Is_Blk=nushu}', "");
    Expect(1, 111359, '\P{^Is_Blk=nushu}', "");
    Expect(0, 111360, '\p{Is_Blk=nushu}', "");
    Expect(1, 111360, '\p{^Is_Blk=nushu}', "");
    Expect(1, 111360, '\P{Is_Blk=nushu}', "");
    Expect(0, 111360, '\P{^Is_Blk=nushu}', "");
    Expect(1, 111359, '\p{Is_Blk:	__NUSHU}', "");
    Expect(0, 111359, '\p{^Is_Blk:	__NUSHU}', "");
    Expect(0, 111359, '\P{Is_Blk:	__NUSHU}', "");
    Expect(1, 111359, '\P{^Is_Blk:	__NUSHU}', "");
    Expect(0, 111360, '\p{Is_Blk:	__NUSHU}', "");
    Expect(1, 111360, '\p{^Is_Blk:	__NUSHU}', "");
    Expect(1, 111360, '\P{Is_Blk:	__NUSHU}', "");
    Expect(0, 111360, '\P{^Is_Blk:	__NUSHU}', "");
    Error('\p{Block=:=-Nyiakeng_Puachue_Hmong}');
    Error('\P{Block=:=-Nyiakeng_Puachue_Hmong}');
    Expect(1, 123215, '\p{Block=:\ANyiakeng_Puachue_Hmong\z:}', "");;
    Expect(0, 123216, '\p{Block=:\ANyiakeng_Puachue_Hmong\z:}', "");;
    Expect(1, 123215, '\p{Block=nyiakengpuachuehmong}', "");
    Expect(0, 123215, '\p{^Block=nyiakengpuachuehmong}', "");
    Expect(0, 123215, '\P{Block=nyiakengpuachuehmong}', "");
    Expect(1, 123215, '\P{^Block=nyiakengpuachuehmong}', "");
    Expect(0, 123216, '\p{Block=nyiakengpuachuehmong}', "");
    Expect(1, 123216, '\p{^Block=nyiakengpuachuehmong}', "");
    Expect(1, 123216, '\P{Block=nyiakengpuachuehmong}', "");
    Expect(0, 123216, '\P{^Block=nyiakengpuachuehmong}', "");
    Expect(1, 123215, '\p{Block=:\Anyiakengpuachuehmong\z:}', "");;
    Expect(0, 123216, '\p{Block=:\Anyiakengpuachuehmong\z:}', "");;
    Expect(1, 123215, '\p{Block=		Nyiakeng_Puachue_hmong}', "");
    Expect(0, 123215, '\p{^Block=		Nyiakeng_Puachue_hmong}', "");
    Expect(0, 123215, '\P{Block=		Nyiakeng_Puachue_hmong}', "");
    Expect(1, 123215, '\P{^Block=		Nyiakeng_Puachue_hmong}', "");
    Expect(0, 123216, '\p{Block=		Nyiakeng_Puachue_hmong}', "");
    Expect(1, 123216, '\p{^Block=		Nyiakeng_Puachue_hmong}', "");
    Expect(1, 123216, '\P{Block=		Nyiakeng_Puachue_hmong}', "");
    Expect(0, 123216, '\P{^Block=		Nyiakeng_Puachue_hmong}', "");
    Error('\p{Blk=:=Nyiakeng_PUACHUE_hmong}');
    Error('\P{Blk=:=Nyiakeng_PUACHUE_hmong}');
    Expect(1, 123215, '\p{Blk=:\ANyiakeng_Puachue_Hmong\z:}', "");;
    Expect(0, 123216, '\p{Blk=:\ANyiakeng_Puachue_Hmong\z:}', "");;
    Expect(1, 123215, '\p{Blk:	nyiakengpuachuehmong}', "");
    Expect(0, 123215, '\p{^Blk:	nyiakengpuachuehmong}', "");
    Expect(0, 123215, '\P{Blk:	nyiakengpuachuehmong}', "");
    Expect(1, 123215, '\P{^Blk:	nyiakengpuachuehmong}', "");
    Expect(0, 123216, '\p{Blk:	nyiakengpuachuehmong}', "");
    Expect(1, 123216, '\p{^Blk:	nyiakengpuachuehmong}', "");
    Expect(1, 123216, '\P{Blk:	nyiakengpuachuehmong}', "");
    Expect(0, 123216, '\P{^Blk:	nyiakengpuachuehmong}', "");
    Expect(1, 123215, '\p{Blk=:\Anyiakengpuachuehmong\z:}', "");;
    Expect(0, 123216, '\p{Blk=:\Anyiakengpuachuehmong\z:}', "");;
    Expect(1, 123215, '\p{Blk=  nyiakeng_puachue_HMONG}', "");
    Expect(0, 123215, '\p{^Blk=  nyiakeng_puachue_HMONG}', "");
    Expect(0, 123215, '\P{Blk=  nyiakeng_puachue_HMONG}', "");
    Expect(1, 123215, '\P{^Blk=  nyiakeng_puachue_HMONG}', "");
    Expect(0, 123216, '\p{Blk=  nyiakeng_puachue_HMONG}', "");
    Expect(1, 123216, '\p{^Blk=  nyiakeng_puachue_HMONG}', "");
    Expect(1, 123216, '\P{Blk=  nyiakeng_puachue_HMONG}', "");
    Expect(0, 123216, '\P{^Blk=  nyiakeng_puachue_HMONG}', "");
    Error('\p{Is_Block=/a/ _NYIAKENG_PUACHUE_Hmong}');
    Error('\P{Is_Block=/a/ _NYIAKENG_PUACHUE_Hmong}');
    Expect(1, 123215, '\p{Is_Block=nyiakengpuachuehmong}', "");
    Expect(0, 123215, '\p{^Is_Block=nyiakengpuachuehmong}', "");
    Expect(0, 123215, '\P{Is_Block=nyiakengpuachuehmong}', "");
    Expect(1, 123215, '\P{^Is_Block=nyiakengpuachuehmong}', "");
    Expect(0, 123216, '\p{Is_Block=nyiakengpuachuehmong}', "");
    Expect(1, 123216, '\p{^Is_Block=nyiakengpuachuehmong}', "");
    Expect(1, 123216, '\P{Is_Block=nyiakengpuachuehmong}', "");
    Expect(0, 123216, '\P{^Is_Block=nyiakengpuachuehmong}', "");
    Expect(1, 123215, '\p{Is_Block=- Nyiakeng_PUACHUE_Hmong}', "");
    Expect(0, 123215, '\p{^Is_Block=- Nyiakeng_PUACHUE_Hmong}', "");
    Expect(0, 123215, '\P{Is_Block=- Nyiakeng_PUACHUE_Hmong}', "");
    Expect(1, 123215, '\P{^Is_Block=- Nyiakeng_PUACHUE_Hmong}', "");
    Expect(0, 123216, '\p{Is_Block=- Nyiakeng_PUACHUE_Hmong}', "");
    Expect(1, 123216, '\p{^Is_Block=- Nyiakeng_PUACHUE_Hmong}', "");
    Expect(1, 123216, '\P{Is_Block=- Nyiakeng_PUACHUE_Hmong}', "");
    Expect(0, 123216, '\P{^Is_Block=- Nyiakeng_PUACHUE_Hmong}', "");
    Error('\p{Is_Blk:	_:=Nyiakeng_PUACHUE_hmong}');
    Error('\P{Is_Blk:	_:=Nyiakeng_PUACHUE_hmong}');
    Expect(1, 123215, '\p{Is_Blk=nyiakengpuachuehmong}', "");
    Expect(0, 123215, '\p{^Is_Blk=nyiakengpuachuehmong}', "");
    Expect(0, 123215, '\P{Is_Blk=nyiakengpuachuehmong}', "");
    Expect(1, 123215, '\P{^Is_Blk=nyiakengpuachuehmong}', "");
    Expect(0, 123216, '\p{Is_Blk=nyiakengpuachuehmong}', "");
    Expect(1, 123216, '\p{^Is_Blk=nyiakengpuachuehmong}', "");
    Expect(1, 123216, '\P{Is_Blk=nyiakengpuachuehmong}', "");
    Expect(0, 123216, '\P{^Is_Blk=nyiakengpuachuehmong}', "");
    Expect(1, 123215, '\p{Is_Blk:--nyiakeng_Puachue_HMONG}', "");
    Expect(0, 123215, '\p{^Is_Blk:--nyiakeng_Puachue_HMONG}', "");
    Expect(0, 123215, '\P{Is_Blk:--nyiakeng_Puachue_HMONG}', "");
    Expect(1, 123215, '\P{^Is_Blk:--nyiakeng_Puachue_HMONG}', "");
    Expect(0, 123216, '\p{Is_Blk:--nyiakeng_Puachue_HMONG}', "");
    Expect(1, 123216, '\p{^Is_Blk:--nyiakeng_Puachue_HMONG}', "");
    Expect(1, 123216, '\P{Is_Blk:--nyiakeng_Puachue_HMONG}', "");
    Expect(0, 123216, '\P{^Is_Blk:--nyiakeng_Puachue_HMONG}', "");
    Error('\p{Block=-/a/optical_Character_Recognition}');
    Error('\P{Block=-/a/optical_Character_Recognition}');
    Expect(1, 9311, '\p{Block=:\AOptical_Character_Recognition\z:}', "");;
    Expect(0, 9312, '\p{Block=:\AOptical_Character_Recognition\z:}', "");;
    Expect(1, 9311, '\p{Block=opticalcharacterrecognition}', "");
    Expect(0, 9311, '\p{^Block=opticalcharacterrecognition}', "");
    Expect(0, 9311, '\P{Block=opticalcharacterrecognition}', "");
    Expect(1, 9311, '\P{^Block=opticalcharacterrecognition}', "");
    Expect(0, 9312, '\p{Block=opticalcharacterrecognition}', "");
    Expect(1, 9312, '\p{^Block=opticalcharacterrecognition}', "");
    Expect(1, 9312, '\P{Block=opticalcharacterrecognition}', "");
    Expect(0, 9312, '\P{^Block=opticalcharacterrecognition}', "");
    Expect(1, 9311, '\p{Block=:\Aopticalcharacterrecognition\z:}', "");;
    Expect(0, 9312, '\p{Block=:\Aopticalcharacterrecognition\z:}', "");;
    Expect(1, 9311, '\p{Block=	 Optical_character_recognition}', "");
    Expect(0, 9311, '\p{^Block=	 Optical_character_recognition}', "");
    Expect(0, 9311, '\P{Block=	 Optical_character_recognition}', "");
    Expect(1, 9311, '\P{^Block=	 Optical_character_recognition}', "");
    Expect(0, 9312, '\p{Block=	 Optical_character_recognition}', "");
    Expect(1, 9312, '\p{^Block=	 Optical_character_recognition}', "");
    Expect(1, 9312, '\P{Block=	 Optical_character_recognition}', "");
    Expect(0, 9312, '\P{^Block=	 Optical_character_recognition}', "");
    Error('\p{Blk=	ocr:=}');
    Error('\P{Blk=	ocr:=}');
    Expect(1, 9311, '\p{Blk=:\AOCR\z:}', "");;
    Expect(0, 9312, '\p{Blk=:\AOCR\z:}', "");;
    Expect(1, 9311, '\p{Blk: ocr}', "");
    Expect(0, 9311, '\p{^Blk: ocr}', "");
    Expect(0, 9311, '\P{Blk: ocr}', "");
    Expect(1, 9311, '\P{^Blk: ocr}', "");
    Expect(0, 9312, '\p{Blk: ocr}', "");
    Expect(1, 9312, '\p{^Blk: ocr}', "");
    Expect(1, 9312, '\P{Blk: ocr}', "");
    Expect(0, 9312, '\P{^Blk: ocr}', "");
    Expect(1, 9311, '\p{Blk=:\Aocr\z:}', "");;
    Expect(0, 9312, '\p{Blk=:\Aocr\z:}', "");;
    Expect(1, 9311, '\p{Blk=-OCR}', "");
    Expect(0, 9311, '\p{^Blk=-OCR}', "");
    Expect(0, 9311, '\P{Blk=-OCR}', "");
    Expect(1, 9311, '\P{^Blk=-OCR}', "");
    Expect(0, 9312, '\p{Blk=-OCR}', "");
    Expect(1, 9312, '\p{^Blk=-OCR}', "");
    Expect(1, 9312, '\P{Blk=-OCR}', "");
    Expect(0, 9312, '\P{^Blk=-OCR}', "");
    Error('\p{Is_Block:   __Optical_Character_RECOGNITION:=}');
    Error('\P{Is_Block:   __Optical_Character_RECOGNITION:=}');
    Expect(1, 9311, '\p{Is_Block=opticalcharacterrecognition}', "");
    Expect(0, 9311, '\p{^Is_Block=opticalcharacterrecognition}', "");
    Expect(0, 9311, '\P{Is_Block=opticalcharacterrecognition}', "");
    Expect(1, 9311, '\P{^Is_Block=opticalcharacterrecognition}', "");
    Expect(0, 9312, '\p{Is_Block=opticalcharacterrecognition}', "");
    Expect(1, 9312, '\p{^Is_Block=opticalcharacterrecognition}', "");
    Expect(1, 9312, '\P{Is_Block=opticalcharacterrecognition}', "");
    Expect(0, 9312, '\P{^Is_Block=opticalcharacterrecognition}', "");
    Expect(1, 9311, '\p{Is_Block=_Optical_CHARACTER_Recognition}', "");
    Expect(0, 9311, '\p{^Is_Block=_Optical_CHARACTER_Recognition}', "");
    Expect(0, 9311, '\P{Is_Block=_Optical_CHARACTER_Recognition}', "");
    Expect(1, 9311, '\P{^Is_Block=_Optical_CHARACTER_Recognition}', "");
    Expect(0, 9312, '\p{Is_Block=_Optical_CHARACTER_Recognition}', "");
    Expect(1, 9312, '\p{^Is_Block=_Optical_CHARACTER_Recognition}', "");
    Expect(1, 9312, '\P{Is_Block=_Optical_CHARACTER_Recognition}', "");
    Expect(0, 9312, '\P{^Is_Block=_Optical_CHARACTER_Recognition}', "");
    Error('\p{Is_Blk=_ocr/a/}');
    Error('\P{Is_Blk=_ocr/a/}');
    Expect(1, 9311, '\p{Is_Blk=ocr}', "");
    Expect(0, 9311, '\p{^Is_Blk=ocr}', "");
    Expect(0, 9311, '\P{Is_Blk=ocr}', "");
    Expect(1, 9311, '\P{^Is_Blk=ocr}', "");
    Expect(0, 9312, '\p{Is_Blk=ocr}', "");
    Expect(1, 9312, '\p{^Is_Blk=ocr}', "");
    Expect(1, 9312, '\P{Is_Blk=ocr}', "");
    Expect(0, 9312, '\P{^Is_Blk=ocr}', "");
    Expect(1, 9311, '\p{Is_Blk=_ocr}', "");
    Expect(0, 9311, '\p{^Is_Blk=_ocr}', "");
    Expect(0, 9311, '\P{Is_Blk=_ocr}', "");
    Expect(1, 9311, '\P{^Is_Blk=_ocr}', "");
    Expect(0, 9312, '\p{Is_Blk=_ocr}', "");
    Expect(1, 9312, '\p{^Is_Blk=_ocr}', "");
    Expect(1, 9312, '\P{Is_Blk=_ocr}', "");
    Expect(0, 9312, '\P{^Is_Blk=_ocr}', "");
    Error('\p{Block=_ Ogham/a/}');
    Error('\P{Block=_ Ogham/a/}');
    Expect(1, 5791, '\p{Block=:\AOgham\z:}', "");;
    Expect(0, 5792, '\p{Block=:\AOgham\z:}', "");;
    Expect(1, 5791, '\p{Block=ogham}', "");
    Expect(0, 5791, '\p{^Block=ogham}', "");
    Expect(0, 5791, '\P{Block=ogham}', "");
    Expect(1, 5791, '\P{^Block=ogham}', "");
    Expect(0, 5792, '\p{Block=ogham}', "");
    Expect(1, 5792, '\p{^Block=ogham}', "");
    Expect(1, 5792, '\P{Block=ogham}', "");
    Expect(0, 5792, '\P{^Block=ogham}', "");
    Expect(1, 5791, '\p{Block=:\Aogham\z:}', "");;
    Expect(0, 5792, '\p{Block=:\Aogham\z:}', "");;
    Expect(1, 5791, '\p{Block=	_ogham}', "");
    Expect(0, 5791, '\p{^Block=	_ogham}', "");
    Expect(0, 5791, '\P{Block=	_ogham}', "");
    Expect(1, 5791, '\P{^Block=	_ogham}', "");
    Expect(0, 5792, '\p{Block=	_ogham}', "");
    Expect(1, 5792, '\p{^Block=	_ogham}', "");
    Expect(1, 5792, '\P{Block=	_ogham}', "");
    Expect(0, 5792, '\P{^Block=	_ogham}', "");
    Error('\p{Blk=--Ogham:=}');
    Error('\P{Blk=--Ogham:=}');
    Expect(1, 5791, '\p{Blk=:\AOgham\z:}', "");;
    Expect(0, 5792, '\p{Blk=:\AOgham\z:}', "");;
    Expect(1, 5791, '\p{Blk=ogham}', "");
    Expect(0, 5791, '\p{^Blk=ogham}', "");
    Expect(0, 5791, '\P{Blk=ogham}', "");
    Expect(1, 5791, '\P{^Blk=ogham}', "");
    Expect(0, 5792, '\p{Blk=ogham}', "");
    Expect(1, 5792, '\p{^Blk=ogham}', "");
    Expect(1, 5792, '\P{Blk=ogham}', "");
    Expect(0, 5792, '\P{^Blk=ogham}', "");
    Expect(1, 5791, '\p{Blk=:\Aogham\z:}', "");;
    Expect(0, 5792, '\p{Blk=:\Aogham\z:}', "");;
    Expect(1, 5791, '\p{Blk=	_OGHAM}', "");
    Expect(0, 5791, '\p{^Blk=	_OGHAM}', "");
    Expect(0, 5791, '\P{Blk=	_OGHAM}', "");
    Expect(1, 5791, '\P{^Blk=	_OGHAM}', "");
    Expect(0, 5792, '\p{Blk=	_OGHAM}', "");
    Expect(1, 5792, '\p{^Blk=	_OGHAM}', "");
    Expect(1, 5792, '\P{Blk=	_OGHAM}', "");
    Expect(0, 5792, '\P{^Blk=	_OGHAM}', "");
    Error('\p{Is_Block=_/a/Ogham}');
    Error('\P{Is_Block=_/a/Ogham}');
    Expect(1, 5791, '\p{Is_Block=ogham}', "");
    Expect(0, 5791, '\p{^Is_Block=ogham}', "");
    Expect(0, 5791, '\P{Is_Block=ogham}', "");
    Expect(1, 5791, '\P{^Is_Block=ogham}', "");
    Expect(0, 5792, '\p{Is_Block=ogham}', "");
    Expect(1, 5792, '\p{^Is_Block=ogham}', "");
    Expect(1, 5792, '\P{Is_Block=ogham}', "");
    Expect(0, 5792, '\P{^Is_Block=ogham}', "");
    Expect(1, 5791, '\p{Is_Block: Ogham}', "");
    Expect(0, 5791, '\p{^Is_Block: Ogham}', "");
    Expect(0, 5791, '\P{Is_Block: Ogham}', "");
    Expect(1, 5791, '\P{^Is_Block: Ogham}', "");
    Expect(0, 5792, '\p{Is_Block: Ogham}', "");
    Expect(1, 5792, '\p{^Is_Block: Ogham}', "");
    Expect(1, 5792, '\P{Is_Block: Ogham}', "");
    Expect(0, 5792, '\P{^Is_Block: Ogham}', "");
    Error('\p{Is_Blk=--Ogham/a/}');
    Error('\P{Is_Blk=--Ogham/a/}');
    Expect(1, 5791, '\p{Is_Blk=ogham}', "");
    Expect(0, 5791, '\p{^Is_Blk=ogham}', "");
    Expect(0, 5791, '\P{Is_Blk=ogham}', "");
    Expect(1, 5791, '\P{^Is_Blk=ogham}', "");
    Expect(0, 5792, '\p{Is_Blk=ogham}', "");
    Expect(1, 5792, '\p{^Is_Blk=ogham}', "");
    Expect(1, 5792, '\P{Is_Blk=ogham}', "");
    Expect(0, 5792, '\P{^Is_Blk=ogham}', "");
    Expect(1, 5791, '\p{Is_Blk=- ogham}', "");
    Expect(0, 5791, '\p{^Is_Blk=- ogham}', "");
    Expect(0, 5791, '\P{Is_Blk=- ogham}', "");
    Expect(1, 5791, '\P{^Is_Blk=- ogham}', "");
    Expect(0, 5792, '\p{Is_Blk=- ogham}', "");
    Expect(1, 5792, '\p{^Is_Blk=- ogham}', "");
    Expect(1, 5792, '\P{Is_Blk=- ogham}', "");
    Expect(0, 5792, '\P{^Is_Blk=- ogham}', "");
    Error('\p{Block=_/a/OL_CHIKI}');
    Error('\P{Block=_/a/OL_CHIKI}');
    Expect(1, 7295, '\p{Block=:\AOl_Chiki\z:}', "");;
    Expect(0, 7296, '\p{Block=:\AOl_Chiki\z:}', "");;
    Expect(1, 7295, '\p{Block=olchiki}', "");
    Expect(0, 7295, '\p{^Block=olchiki}', "");
    Expect(0, 7295, '\P{Block=olchiki}', "");
    Expect(1, 7295, '\P{^Block=olchiki}', "");
    Expect(0, 7296, '\p{Block=olchiki}', "");
    Expect(1, 7296, '\p{^Block=olchiki}', "");
    Expect(1, 7296, '\P{Block=olchiki}', "");
    Expect(0, 7296, '\P{^Block=olchiki}', "");
    Expect(1, 7295, '\p{Block=:\Aolchiki\z:}', "");;
    Expect(0, 7296, '\p{Block=:\Aolchiki\z:}', "");;
    Expect(1, 7295, '\p{Block=	_OL_chiki}', "");
    Expect(0, 7295, '\p{^Block=	_OL_chiki}', "");
    Expect(0, 7295, '\P{Block=	_OL_chiki}', "");
    Expect(1, 7295, '\P{^Block=	_OL_chiki}', "");
    Expect(0, 7296, '\p{Block=	_OL_chiki}', "");
    Expect(1, 7296, '\p{^Block=	_OL_chiki}', "");
    Expect(1, 7296, '\P{Block=	_OL_chiki}', "");
    Expect(0, 7296, '\P{^Block=	_OL_chiki}', "");
    Error('\p{Blk=-:=ol_chiki}');
    Error('\P{Blk=-:=ol_chiki}');
    Expect(1, 7295, '\p{Blk=:\AOl_Chiki\z:}', "");;
    Expect(0, 7296, '\p{Blk=:\AOl_Chiki\z:}', "");;
    Expect(1, 7295, '\p{Blk=olchiki}', "");
    Expect(0, 7295, '\p{^Blk=olchiki}', "");
    Expect(0, 7295, '\P{Blk=olchiki}', "");
    Expect(1, 7295, '\P{^Blk=olchiki}', "");
    Expect(0, 7296, '\p{Blk=olchiki}', "");
    Expect(1, 7296, '\p{^Blk=olchiki}', "");
    Expect(1, 7296, '\P{Blk=olchiki}', "");
    Expect(0, 7296, '\P{^Blk=olchiki}', "");
    Expect(1, 7295, '\p{Blk=:\Aolchiki\z:}', "");;
    Expect(0, 7296, '\p{Blk=:\Aolchiki\z:}', "");;
    Expect(1, 7295, '\p{Blk=_ol_Chiki}', "");
    Expect(0, 7295, '\p{^Blk=_ol_Chiki}', "");
    Expect(0, 7295, '\P{Blk=_ol_Chiki}', "");
    Expect(1, 7295, '\P{^Blk=_ol_Chiki}', "");
    Expect(0, 7296, '\p{Blk=_ol_Chiki}', "");
    Expect(1, 7296, '\p{^Blk=_ol_Chiki}', "");
    Expect(1, 7296, '\P{Blk=_ol_Chiki}', "");
    Expect(0, 7296, '\P{^Blk=_ol_Chiki}', "");
    Error('\p{Is_Block=:=OL_Chiki}');
    Error('\P{Is_Block=:=OL_Chiki}');
    Expect(1, 7295, '\p{Is_Block=olchiki}', "");
    Expect(0, 7295, '\p{^Is_Block=olchiki}', "");
    Expect(0, 7295, '\P{Is_Block=olchiki}', "");
    Expect(1, 7295, '\P{^Is_Block=olchiki}', "");
    Expect(0, 7296, '\p{Is_Block=olchiki}', "");
    Expect(1, 7296, '\p{^Is_Block=olchiki}', "");
    Expect(1, 7296, '\P{Is_Block=olchiki}', "");
    Expect(0, 7296, '\P{^Is_Block=olchiki}', "");
    Expect(1, 7295, '\p{Is_Block=- OL_Chiki}', "");
    Expect(0, 7295, '\p{^Is_Block=- OL_Chiki}', "");
    Expect(0, 7295, '\P{Is_Block=- OL_Chiki}', "");
    Expect(1, 7295, '\P{^Is_Block=- OL_Chiki}', "");
    Expect(0, 7296, '\p{Is_Block=- OL_Chiki}', "");
    Expect(1, 7296, '\p{^Is_Block=- OL_Chiki}', "");
    Expect(1, 7296, '\P{Is_Block=- OL_Chiki}', "");
    Expect(0, 7296, '\P{^Is_Block=- OL_Chiki}', "");
    Error('\p{Is_Blk= /a/ol_chiki}');
    Error('\P{Is_Blk= /a/ol_chiki}');
    Expect(1, 7295, '\p{Is_Blk=olchiki}', "");
    Expect(0, 7295, '\p{^Is_Blk=olchiki}', "");
    Expect(0, 7295, '\P{Is_Blk=olchiki}', "");
    Expect(1, 7295, '\P{^Is_Blk=olchiki}', "");
    Expect(0, 7296, '\p{Is_Blk=olchiki}', "");
    Expect(1, 7296, '\p{^Is_Blk=olchiki}', "");
    Expect(1, 7296, '\P{Is_Blk=olchiki}', "");
    Expect(0, 7296, '\P{^Is_Blk=olchiki}', "");
    Expect(1, 7295, '\p{Is_Blk=_-Ol_Chiki}', "");
    Expect(0, 7295, '\p{^Is_Blk=_-Ol_Chiki}', "");
    Expect(0, 7295, '\P{Is_Blk=_-Ol_Chiki}', "");
    Expect(1, 7295, '\P{^Is_Blk=_-Ol_Chiki}', "");
    Expect(0, 7296, '\p{Is_Blk=_-Ol_Chiki}', "");
    Expect(1, 7296, '\p{^Is_Blk=_-Ol_Chiki}', "");
    Expect(1, 7296, '\P{Is_Blk=_-Ol_Chiki}', "");
    Expect(0, 7296, '\P{^Is_Blk=_-Ol_Chiki}', "");
    Error('\p{Block=	_OLD_Hungarian:=}');
    Error('\P{Block=	_OLD_Hungarian:=}');
    Expect(1, 68863, '\p{Block=:\AOld_Hungarian\z:}', "");;
    Expect(0, 68864, '\p{Block=:\AOld_Hungarian\z:}', "");;
    Expect(1, 68863, '\p{Block:	oldhungarian}', "");
    Expect(0, 68863, '\p{^Block:	oldhungarian}', "");
    Expect(0, 68863, '\P{Block:	oldhungarian}', "");
    Expect(1, 68863, '\P{^Block:	oldhungarian}', "");
    Expect(0, 68864, '\p{Block:	oldhungarian}', "");
    Expect(1, 68864, '\p{^Block:	oldhungarian}', "");
    Expect(1, 68864, '\P{Block:	oldhungarian}', "");
    Expect(0, 68864, '\P{^Block:	oldhungarian}', "");
    Expect(1, 68863, '\p{Block=:\Aoldhungarian\z:}', "");;
    Expect(0, 68864, '\p{Block=:\Aoldhungarian\z:}', "");;
    Expect(1, 68863, '\p{Block=_old_hungarian}', "");
    Expect(0, 68863, '\p{^Block=_old_hungarian}', "");
    Expect(0, 68863, '\P{Block=_old_hungarian}', "");
    Expect(1, 68863, '\P{^Block=_old_hungarian}', "");
    Expect(0, 68864, '\p{Block=_old_hungarian}', "");
    Expect(1, 68864, '\p{^Block=_old_hungarian}', "");
    Expect(1, 68864, '\P{Block=_old_hungarian}', "");
    Expect(0, 68864, '\P{^Block=_old_hungarian}', "");
    Error('\p{Blk=:=	_old_HUNGARIAN}');
    Error('\P{Blk=:=	_old_HUNGARIAN}');
    Expect(1, 68863, '\p{Blk=:\AOld_Hungarian\z:}', "");;
    Expect(0, 68864, '\p{Blk=:\AOld_Hungarian\z:}', "");;
    Expect(1, 68863, '\p{Blk=oldhungarian}', "");
    Expect(0, 68863, '\p{^Blk=oldhungarian}', "");
    Expect(0, 68863, '\P{Blk=oldhungarian}', "");
    Expect(1, 68863, '\P{^Blk=oldhungarian}', "");
    Expect(0, 68864, '\p{Blk=oldhungarian}', "");
    Expect(1, 68864, '\p{^Blk=oldhungarian}', "");
    Expect(1, 68864, '\P{Blk=oldhungarian}', "");
    Expect(0, 68864, '\P{^Blk=oldhungarian}', "");
    Expect(1, 68863, '\p{Blk=:\Aoldhungarian\z:}', "");;
    Expect(0, 68864, '\p{Blk=:\Aoldhungarian\z:}', "");;
    Expect(1, 68863, '\p{Blk:	  OLD_HUNGARIAN}', "");
    Expect(0, 68863, '\p{^Blk:	  OLD_HUNGARIAN}', "");
    Expect(0, 68863, '\P{Blk:	  OLD_HUNGARIAN}', "");
    Expect(1, 68863, '\P{^Blk:	  OLD_HUNGARIAN}', "");
    Expect(0, 68864, '\p{Blk:	  OLD_HUNGARIAN}', "");
    Expect(1, 68864, '\p{^Blk:	  OLD_HUNGARIAN}', "");
    Expect(1, 68864, '\P{Blk:	  OLD_HUNGARIAN}', "");
    Expect(0, 68864, '\P{^Blk:	  OLD_HUNGARIAN}', "");
    Error('\p{Is_Block=_/a/old_Hungarian}');
    Error('\P{Is_Block=_/a/old_Hungarian}');
    Expect(1, 68863, '\p{Is_Block=oldhungarian}', "");
    Expect(0, 68863, '\p{^Is_Block=oldhungarian}', "");
    Expect(0, 68863, '\P{Is_Block=oldhungarian}', "");
    Expect(1, 68863, '\P{^Is_Block=oldhungarian}', "");
    Expect(0, 68864, '\p{Is_Block=oldhungarian}', "");
    Expect(1, 68864, '\p{^Is_Block=oldhungarian}', "");
    Expect(1, 68864, '\P{Is_Block=oldhungarian}', "");
    Expect(0, 68864, '\P{^Is_Block=oldhungarian}', "");
    Expect(1, 68863, '\p{Is_Block:   	old_Hungarian}', "");
    Expect(0, 68863, '\p{^Is_Block:   	old_Hungarian}', "");
    Expect(0, 68863, '\P{Is_Block:   	old_Hungarian}', "");
    Expect(1, 68863, '\P{^Is_Block:   	old_Hungarian}', "");
    Expect(0, 68864, '\p{Is_Block:   	old_Hungarian}', "");
    Expect(1, 68864, '\p{^Is_Block:   	old_Hungarian}', "");
    Expect(1, 68864, '\P{Is_Block:   	old_Hungarian}', "");
    Expect(0, 68864, '\P{^Is_Block:   	old_Hungarian}', "");
    Error('\p{Is_Blk=	OLD_Hungarian/a/}');
    Error('\P{Is_Blk=	OLD_Hungarian/a/}');
    Expect(1, 68863, '\p{Is_Blk=oldhungarian}', "");
    Expect(0, 68863, '\p{^Is_Blk=oldhungarian}', "");
    Expect(0, 68863, '\P{Is_Blk=oldhungarian}', "");
    Expect(1, 68863, '\P{^Is_Blk=oldhungarian}', "");
    Expect(0, 68864, '\p{Is_Blk=oldhungarian}', "");
    Expect(1, 68864, '\p{^Is_Blk=oldhungarian}', "");
    Expect(1, 68864, '\P{Is_Blk=oldhungarian}', "");
    Expect(0, 68864, '\P{^Is_Blk=oldhungarian}', "");
    Expect(1, 68863, '\p{Is_Blk=	Old_Hungarian}', "");
    Expect(0, 68863, '\p{^Is_Blk=	Old_Hungarian}', "");
    Expect(0, 68863, '\P{Is_Blk=	Old_Hungarian}', "");
    Expect(1, 68863, '\P{^Is_Blk=	Old_Hungarian}', "");
    Expect(0, 68864, '\p{Is_Blk=	Old_Hungarian}', "");
    Expect(1, 68864, '\p{^Is_Blk=	Old_Hungarian}', "");
    Expect(1, 68864, '\P{Is_Blk=	Old_Hungarian}', "");
    Expect(0, 68864, '\P{^Is_Blk=	Old_Hungarian}', "");
    Error('\p{Block=_/a/OLD_Italic}');
    Error('\P{Block=_/a/OLD_Italic}');
    Expect(1, 66351, '\p{Block=:\AOld_Italic\z:}', "");;
    Expect(0, 66352, '\p{Block=:\AOld_Italic\z:}', "");;
    Expect(1, 66351, '\p{Block=olditalic}', "");
    Expect(0, 66351, '\p{^Block=olditalic}', "");
    Expect(0, 66351, '\P{Block=olditalic}', "");
    Expect(1, 66351, '\P{^Block=olditalic}', "");
    Expect(0, 66352, '\p{Block=olditalic}', "");
    Expect(1, 66352, '\p{^Block=olditalic}', "");
    Expect(1, 66352, '\P{Block=olditalic}', "");
    Expect(0, 66352, '\P{^Block=olditalic}', "");
    Expect(1, 66351, '\p{Block=:\Aolditalic\z:}', "");;
    Expect(0, 66352, '\p{Block=:\Aolditalic\z:}', "");;
    Expect(1, 66351, '\p{Block= old_Italic}', "");
    Expect(0, 66351, '\p{^Block= old_Italic}', "");
    Expect(0, 66351, '\P{Block= old_Italic}', "");
    Expect(1, 66351, '\P{^Block= old_Italic}', "");
    Expect(0, 66352, '\p{Block= old_Italic}', "");
    Expect(1, 66352, '\p{^Block= old_Italic}', "");
    Expect(1, 66352, '\P{Block= old_Italic}', "");
    Expect(0, 66352, '\P{^Block= old_Italic}', "");
    Error('\p{Blk=_/a/old_Italic}');
    Error('\P{Blk=_/a/old_Italic}');
    Expect(1, 66351, '\p{Blk=:\AOld_Italic\z:}', "");;
    Expect(0, 66352, '\p{Blk=:\AOld_Italic\z:}', "");;
    Expect(1, 66351, '\p{Blk=olditalic}', "");
    Expect(0, 66351, '\p{^Blk=olditalic}', "");
    Expect(0, 66351, '\P{Blk=olditalic}', "");
    Expect(1, 66351, '\P{^Blk=olditalic}', "");
    Expect(0, 66352, '\p{Blk=olditalic}', "");
    Expect(1, 66352, '\p{^Blk=olditalic}', "");
    Expect(1, 66352, '\P{Blk=olditalic}', "");
    Expect(0, 66352, '\P{^Blk=olditalic}', "");
    Expect(1, 66351, '\p{Blk=:\Aolditalic\z:}', "");;
    Expect(0, 66352, '\p{Blk=:\Aolditalic\z:}', "");;
    Expect(1, 66351, '\p{Blk=	old_italic}', "");
    Expect(0, 66351, '\p{^Blk=	old_italic}', "");
    Expect(0, 66351, '\P{Blk=	old_italic}', "");
    Expect(1, 66351, '\P{^Blk=	old_italic}', "");
    Expect(0, 66352, '\p{Blk=	old_italic}', "");
    Expect(1, 66352, '\p{^Blk=	old_italic}', "");
    Expect(1, 66352, '\P{Blk=	old_italic}', "");
    Expect(0, 66352, '\P{^Blk=	old_italic}', "");
    Error('\p{Is_Block=/a/Old_italic}');
    Error('\P{Is_Block=/a/Old_italic}');
    Expect(1, 66351, '\p{Is_Block=olditalic}', "");
    Expect(0, 66351, '\p{^Is_Block=olditalic}', "");
    Expect(0, 66351, '\P{Is_Block=olditalic}', "");
    Expect(1, 66351, '\P{^Is_Block=olditalic}', "");
    Expect(0, 66352, '\p{Is_Block=olditalic}', "");
    Expect(1, 66352, '\p{^Is_Block=olditalic}', "");
    Expect(1, 66352, '\P{Is_Block=olditalic}', "");
    Expect(0, 66352, '\P{^Is_Block=olditalic}', "");
    Expect(1, 66351, '\p{Is_Block= OLD_Italic}', "");
    Expect(0, 66351, '\p{^Is_Block= OLD_Italic}', "");
    Expect(0, 66351, '\P{Is_Block= OLD_Italic}', "");
    Expect(1, 66351, '\P{^Is_Block= OLD_Italic}', "");
    Expect(0, 66352, '\p{Is_Block= OLD_Italic}', "");
    Expect(1, 66352, '\p{^Is_Block= OLD_Italic}', "");
    Expect(1, 66352, '\P{Is_Block= OLD_Italic}', "");
    Expect(0, 66352, '\P{^Is_Block= OLD_Italic}', "");
    Error('\p{Is_Blk=:=- old_italic}');
    Error('\P{Is_Blk=:=- old_italic}');
    Expect(1, 66351, '\p{Is_Blk:olditalic}', "");
    Expect(0, 66351, '\p{^Is_Blk:olditalic}', "");
    Expect(0, 66351, '\P{Is_Blk:olditalic}', "");
    Expect(1, 66351, '\P{^Is_Blk:olditalic}', "");
    Expect(0, 66352, '\p{Is_Blk:olditalic}', "");
    Expect(1, 66352, '\p{^Is_Blk:olditalic}', "");
    Expect(1, 66352, '\P{Is_Blk:olditalic}', "");
    Expect(0, 66352, '\P{^Is_Blk:olditalic}', "");
    Expect(1, 66351, '\p{Is_Blk= 	Old_Italic}', "");
    Expect(0, 66351, '\p{^Is_Blk= 	Old_Italic}', "");
    Expect(0, 66351, '\P{Is_Blk= 	Old_Italic}', "");
    Expect(1, 66351, '\P{^Is_Blk= 	Old_Italic}', "");
    Expect(0, 66352, '\p{Is_Blk= 	Old_Italic}', "");
    Expect(1, 66352, '\p{^Is_Blk= 	Old_Italic}', "");
    Expect(1, 66352, '\P{Is_Blk= 	Old_Italic}', "");
    Expect(0, 66352, '\P{^Is_Blk= 	Old_Italic}', "");
    Error('\p{Block=	Old_North_arabian/a/}');
    Error('\P{Block=	Old_North_arabian/a/}');
    Expect(1, 68255, '\p{Block=:\AOld_North_Arabian\z:}', "");;
    Expect(0, 68256, '\p{Block=:\AOld_North_Arabian\z:}', "");;
    Expect(1, 68255, '\p{Block=oldnortharabian}', "");
    Expect(0, 68255, '\p{^Block=oldnortharabian}', "");
    Expect(0, 68255, '\P{Block=oldnortharabian}', "");
    Expect(1, 68255, '\P{^Block=oldnortharabian}', "");
    Expect(0, 68256, '\p{Block=oldnortharabian}', "");
    Expect(1, 68256, '\p{^Block=oldnortharabian}', "");
    Expect(1, 68256, '\P{Block=oldnortharabian}', "");
    Expect(0, 68256, '\P{^Block=oldnortharabian}', "");
    Expect(1, 68255, '\p{Block=:\Aoldnortharabian\z:}', "");;
    Expect(0, 68256, '\p{Block=:\Aoldnortharabian\z:}', "");;
    Expect(1, 68255, '\p{Block= -OLD_NORTH_Arabian}', "");
    Expect(0, 68255, '\p{^Block= -OLD_NORTH_Arabian}', "");
    Expect(0, 68255, '\P{Block= -OLD_NORTH_Arabian}', "");
    Expect(1, 68255, '\P{^Block= -OLD_NORTH_Arabian}', "");
    Expect(0, 68256, '\p{Block= -OLD_NORTH_Arabian}', "");
    Expect(1, 68256, '\p{^Block= -OLD_NORTH_Arabian}', "");
    Expect(1, 68256, '\P{Block= -OLD_NORTH_Arabian}', "");
    Expect(0, 68256, '\P{^Block= -OLD_NORTH_Arabian}', "");
    Error('\p{Blk= :=Old_north_ARABIAN}');
    Error('\P{Blk= :=Old_north_ARABIAN}');
    Expect(1, 68255, '\p{Blk=:\AOld_North_Arabian\z:}', "");;
    Expect(0, 68256, '\p{Blk=:\AOld_North_Arabian\z:}', "");;
    Expect(1, 68255, '\p{Blk=oldnortharabian}', "");
    Expect(0, 68255, '\p{^Blk=oldnortharabian}', "");
    Expect(0, 68255, '\P{Blk=oldnortharabian}', "");
    Expect(1, 68255, '\P{^Blk=oldnortharabian}', "");
    Expect(0, 68256, '\p{Blk=oldnortharabian}', "");
    Expect(1, 68256, '\p{^Blk=oldnortharabian}', "");
    Expect(1, 68256, '\P{Blk=oldnortharabian}', "");
    Expect(0, 68256, '\P{^Blk=oldnortharabian}', "");
    Expect(1, 68255, '\p{Blk=:\Aoldnortharabian\z:}', "");;
    Expect(0, 68256, '\p{Blk=:\Aoldnortharabian\z:}', "");;
    Expect(1, 68255, '\p{Blk=-_OLD_NORTH_Arabian}', "");
    Expect(0, 68255, '\p{^Blk=-_OLD_NORTH_Arabian}', "");
    Expect(0, 68255, '\P{Blk=-_OLD_NORTH_Arabian}', "");
    Expect(1, 68255, '\P{^Blk=-_OLD_NORTH_Arabian}', "");
    Expect(0, 68256, '\p{Blk=-_OLD_NORTH_Arabian}', "");
    Expect(1, 68256, '\p{^Blk=-_OLD_NORTH_Arabian}', "");
    Expect(1, 68256, '\P{Blk=-_OLD_NORTH_Arabian}', "");
    Expect(0, 68256, '\P{^Blk=-_OLD_NORTH_Arabian}', "");
    Error('\p{Is_Block=:=_ Old_NORTH_ARABIAN}');
    Error('\P{Is_Block=:=_ Old_NORTH_ARABIAN}');
    Expect(1, 68255, '\p{Is_Block=oldnortharabian}', "");
    Expect(0, 68255, '\p{^Is_Block=oldnortharabian}', "");
    Expect(0, 68255, '\P{Is_Block=oldnortharabian}', "");
    Expect(1, 68255, '\P{^Is_Block=oldnortharabian}', "");
    Expect(0, 68256, '\p{Is_Block=oldnortharabian}', "");
    Expect(1, 68256, '\p{^Is_Block=oldnortharabian}', "");
    Expect(1, 68256, '\P{Is_Block=oldnortharabian}', "");
    Expect(0, 68256, '\P{^Is_Block=oldnortharabian}', "");
    Expect(1, 68255, '\p{Is_Block=-_OLD_North_arabian}', "");
    Expect(0, 68255, '\p{^Is_Block=-_OLD_North_arabian}', "");
    Expect(0, 68255, '\P{Is_Block=-_OLD_North_arabian}', "");
    Expect(1, 68255, '\P{^Is_Block=-_OLD_North_arabian}', "");
    Expect(0, 68256, '\p{Is_Block=-_OLD_North_arabian}', "");
    Expect(1, 68256, '\p{^Is_Block=-_OLD_North_arabian}', "");
    Expect(1, 68256, '\P{Is_Block=-_OLD_North_arabian}', "");
    Expect(0, 68256, '\P{^Is_Block=-_OLD_North_arabian}', "");
    Error('\p{Is_Blk=-_Old_North_Arabian/a/}');
    Error('\P{Is_Blk=-_Old_North_Arabian/a/}');
    Expect(1, 68255, '\p{Is_Blk=oldnortharabian}', "");
    Expect(0, 68255, '\p{^Is_Blk=oldnortharabian}', "");
    Expect(0, 68255, '\P{Is_Blk=oldnortharabian}', "");
    Expect(1, 68255, '\P{^Is_Blk=oldnortharabian}', "");
    Expect(0, 68256, '\p{Is_Blk=oldnortharabian}', "");
    Expect(1, 68256, '\p{^Is_Blk=oldnortharabian}', "");
    Expect(1, 68256, '\P{Is_Blk=oldnortharabian}', "");
    Expect(0, 68256, '\P{^Is_Blk=oldnortharabian}', "");
    Expect(1, 68255, '\p{Is_Blk=	-old_North_Arabian}', "");
    Expect(0, 68255, '\p{^Is_Blk=	-old_North_Arabian}', "");
    Expect(0, 68255, '\P{Is_Blk=	-old_North_Arabian}', "");
    Expect(1, 68255, '\P{^Is_Blk=	-old_North_Arabian}', "");
    Expect(0, 68256, '\p{Is_Blk=	-old_North_Arabian}', "");
    Expect(1, 68256, '\p{^Is_Blk=	-old_North_Arabian}', "");
    Expect(1, 68256, '\P{Is_Blk=	-old_North_Arabian}', "");
    Expect(0, 68256, '\P{^Is_Blk=	-old_North_Arabian}', "");
    Error('\p{Block=_old_Permic:=}');
    Error('\P{Block=_old_Permic:=}');
    Expect(1, 66431, '\p{Block=:\AOld_Permic\z:}', "");;
    Expect(0, 66432, '\p{Block=:\AOld_Permic\z:}', "");;
    Expect(1, 66431, '\p{Block=oldpermic}', "");
    Expect(0, 66431, '\p{^Block=oldpermic}', "");
    Expect(0, 66431, '\P{Block=oldpermic}', "");
    Expect(1, 66431, '\P{^Block=oldpermic}', "");
    Expect(0, 66432, '\p{Block=oldpermic}', "");
    Expect(1, 66432, '\p{^Block=oldpermic}', "");
    Expect(1, 66432, '\P{Block=oldpermic}', "");
    Expect(0, 66432, '\P{^Block=oldpermic}', "");
    Expect(1, 66431, '\p{Block=:\Aoldpermic\z:}', "");;
    Expect(0, 66432, '\p{Block=:\Aoldpermic\z:}', "");;
    Expect(1, 66431, '\p{Block=	Old_Permic}', "");
    Expect(0, 66431, '\p{^Block=	Old_Permic}', "");
    Expect(0, 66431, '\P{Block=	Old_Permic}', "");
    Expect(1, 66431, '\P{^Block=	Old_Permic}', "");
    Expect(0, 66432, '\p{Block=	Old_Permic}', "");
    Expect(1, 66432, '\p{^Block=	Old_Permic}', "");
    Expect(1, 66432, '\P{Block=	Old_Permic}', "");
    Expect(0, 66432, '\P{^Block=	Old_Permic}', "");
    Error('\p{Blk=:=-OLD_Permic}');
    Error('\P{Blk=:=-OLD_Permic}');
    Expect(1, 66431, '\p{Blk=:\AOld_Permic\z:}', "");;
    Expect(0, 66432, '\p{Blk=:\AOld_Permic\z:}', "");;
    Expect(1, 66431, '\p{Blk:	oldpermic}', "");
    Expect(0, 66431, '\p{^Blk:	oldpermic}', "");
    Expect(0, 66431, '\P{Blk:	oldpermic}', "");
    Expect(1, 66431, '\P{^Blk:	oldpermic}', "");
    Expect(0, 66432, '\p{Blk:	oldpermic}', "");
    Expect(1, 66432, '\p{^Blk:	oldpermic}', "");
    Expect(1, 66432, '\P{Blk:	oldpermic}', "");
    Expect(0, 66432, '\P{^Blk:	oldpermic}', "");
    Expect(1, 66431, '\p{Blk=:\Aoldpermic\z:}', "");;
    Expect(0, 66432, '\p{Blk=:\Aoldpermic\z:}', "");;
    Expect(1, 66431, '\p{Blk= OLD_Permic}', "");
    Expect(0, 66431, '\p{^Blk= OLD_Permic}', "");
    Expect(0, 66431, '\P{Blk= OLD_Permic}', "");
    Expect(1, 66431, '\P{^Blk= OLD_Permic}', "");
    Expect(0, 66432, '\p{Blk= OLD_Permic}', "");
    Expect(1, 66432, '\p{^Blk= OLD_Permic}', "");
    Expect(1, 66432, '\P{Blk= OLD_Permic}', "");
    Expect(0, 66432, '\P{^Blk= OLD_Permic}', "");
    Error('\p{Is_Block=:=OLD_PERMIC}');
    Error('\P{Is_Block=:=OLD_PERMIC}');
    Expect(1, 66431, '\p{Is_Block=oldpermic}', "");
    Expect(0, 66431, '\p{^Is_Block=oldpermic}', "");
    Expect(0, 66431, '\P{Is_Block=oldpermic}', "");
    Expect(1, 66431, '\P{^Is_Block=oldpermic}', "");
    Expect(0, 66432, '\p{Is_Block=oldpermic}', "");
    Expect(1, 66432, '\p{^Is_Block=oldpermic}', "");
    Expect(1, 66432, '\P{Is_Block=oldpermic}', "");
    Expect(0, 66432, '\P{^Is_Block=oldpermic}', "");
    Expect(1, 66431, '\p{Is_Block= -OLD_Permic}', "");
    Expect(0, 66431, '\p{^Is_Block= -OLD_Permic}', "");
    Expect(0, 66431, '\P{Is_Block= -OLD_Permic}', "");
    Expect(1, 66431, '\P{^Is_Block= -OLD_Permic}', "");
    Expect(0, 66432, '\p{Is_Block= -OLD_Permic}', "");
    Expect(1, 66432, '\p{^Is_Block= -OLD_Permic}', "");
    Expect(1, 66432, '\P{Is_Block= -OLD_Permic}', "");
    Expect(0, 66432, '\P{^Is_Block= -OLD_Permic}', "");
    Error('\p{Is_Blk= old_Permic:=}');
    Error('\P{Is_Blk= old_Permic:=}');
    Expect(1, 66431, '\p{Is_Blk:oldpermic}', "");
    Expect(0, 66431, '\p{^Is_Blk:oldpermic}', "");
    Expect(0, 66431, '\P{Is_Blk:oldpermic}', "");
    Expect(1, 66431, '\P{^Is_Blk:oldpermic}', "");
    Expect(0, 66432, '\p{Is_Blk:oldpermic}', "");
    Expect(1, 66432, '\p{^Is_Blk:oldpermic}', "");
    Expect(1, 66432, '\P{Is_Blk:oldpermic}', "");
    Expect(0, 66432, '\P{^Is_Blk:oldpermic}', "");
    Expect(1, 66431, '\p{Is_Blk:	-_old_permic}', "");
    Expect(0, 66431, '\p{^Is_Blk:	-_old_permic}', "");
    Expect(0, 66431, '\P{Is_Blk:	-_old_permic}', "");
    Expect(1, 66431, '\P{^Is_Blk:	-_old_permic}', "");
    Expect(0, 66432, '\p{Is_Blk:	-_old_permic}', "");
    Expect(1, 66432, '\p{^Is_Blk:	-_old_permic}', "");
    Expect(1, 66432, '\P{Is_Blk:	-_old_permic}', "");
    Expect(0, 66432, '\P{^Is_Blk:	-_old_permic}', "");
    Error('\p{Block=-:=OLD_PERSIAN}');
    Error('\P{Block=-:=OLD_PERSIAN}');
    Expect(1, 66527, '\p{Block=:\AOld_Persian\z:}', "");;
    Expect(0, 66528, '\p{Block=:\AOld_Persian\z:}', "");;
    Expect(1, 66527, '\p{Block=oldpersian}', "");
    Expect(0, 66527, '\p{^Block=oldpersian}', "");
    Expect(0, 66527, '\P{Block=oldpersian}', "");
    Expect(1, 66527, '\P{^Block=oldpersian}', "");
    Expect(0, 66528, '\p{Block=oldpersian}', "");
    Expect(1, 66528, '\p{^Block=oldpersian}', "");
    Expect(1, 66528, '\P{Block=oldpersian}', "");
    Expect(0, 66528, '\P{^Block=oldpersian}', "");
    Expect(1, 66527, '\p{Block=:\Aoldpersian\z:}', "");;
    Expect(0, 66528, '\p{Block=:\Aoldpersian\z:}', "");;
    Expect(1, 66527, '\p{Block=_ Old_PERSIAN}', "");
    Expect(0, 66527, '\p{^Block=_ Old_PERSIAN}', "");
    Expect(0, 66527, '\P{Block=_ Old_PERSIAN}', "");
    Expect(1, 66527, '\P{^Block=_ Old_PERSIAN}', "");
    Expect(0, 66528, '\p{Block=_ Old_PERSIAN}', "");
    Expect(1, 66528, '\p{^Block=_ Old_PERSIAN}', "");
    Expect(1, 66528, '\P{Block=_ Old_PERSIAN}', "");
    Expect(0, 66528, '\P{^Block=_ Old_PERSIAN}', "");
    Error('\p{Blk=_	Old_Persian:=}');
    Error('\P{Blk=_	Old_Persian:=}');
    Expect(1, 66527, '\p{Blk=:\AOld_Persian\z:}', "");;
    Expect(0, 66528, '\p{Blk=:\AOld_Persian\z:}', "");;
    Expect(1, 66527, '\p{Blk: oldpersian}', "");
    Expect(0, 66527, '\p{^Blk: oldpersian}', "");
    Expect(0, 66527, '\P{Blk: oldpersian}', "");
    Expect(1, 66527, '\P{^Blk: oldpersian}', "");
    Expect(0, 66528, '\p{Blk: oldpersian}', "");
    Expect(1, 66528, '\p{^Blk: oldpersian}', "");
    Expect(1, 66528, '\P{Blk: oldpersian}', "");
    Expect(0, 66528, '\P{^Blk: oldpersian}', "");
    Expect(1, 66527, '\p{Blk=:\Aoldpersian\z:}', "");;
    Expect(0, 66528, '\p{Blk=:\Aoldpersian\z:}', "");;
    Expect(1, 66527, '\p{Blk=	Old_persian}', "");
    Expect(0, 66527, '\p{^Blk=	Old_persian}', "");
    Expect(0, 66527, '\P{Blk=	Old_persian}', "");
    Expect(1, 66527, '\P{^Blk=	Old_persian}', "");
    Expect(0, 66528, '\p{Blk=	Old_persian}', "");
    Expect(1, 66528, '\p{^Blk=	Old_persian}', "");
    Expect(1, 66528, '\P{Blk=	Old_persian}', "");
    Expect(0, 66528, '\P{^Blk=	Old_persian}', "");
    Error('\p{Is_Block:_-OLD_Persian/a/}');
    Error('\P{Is_Block:_-OLD_Persian/a/}');
    Expect(1, 66527, '\p{Is_Block=oldpersian}', "");
    Expect(0, 66527, '\p{^Is_Block=oldpersian}', "");
    Expect(0, 66527, '\P{Is_Block=oldpersian}', "");
    Expect(1, 66527, '\P{^Is_Block=oldpersian}', "");
    Expect(0, 66528, '\p{Is_Block=oldpersian}', "");
    Expect(1, 66528, '\p{^Is_Block=oldpersian}', "");
    Expect(1, 66528, '\P{Is_Block=oldpersian}', "");
    Expect(0, 66528, '\P{^Is_Block=oldpersian}', "");
    Expect(1, 66527, '\p{Is_Block=-Old_Persian}', "");
    Expect(0, 66527, '\p{^Is_Block=-Old_Persian}', "");
    Expect(0, 66527, '\P{Is_Block=-Old_Persian}', "");
    Expect(1, 66527, '\P{^Is_Block=-Old_Persian}', "");
    Expect(0, 66528, '\p{Is_Block=-Old_Persian}', "");
    Expect(1, 66528, '\p{^Is_Block=-Old_Persian}', "");
    Expect(1, 66528, '\P{Is_Block=-Old_Persian}', "");
    Expect(0, 66528, '\P{^Is_Block=-Old_Persian}', "");
    Error('\p{Is_Blk=_	Old_PERSIAN/a/}');
    Error('\P{Is_Blk=_	Old_PERSIAN/a/}');
    Expect(1, 66527, '\p{Is_Blk:	oldpersian}', "");
    Expect(0, 66527, '\p{^Is_Blk:	oldpersian}', "");
    Expect(0, 66527, '\P{Is_Blk:	oldpersian}', "");
    Expect(1, 66527, '\P{^Is_Blk:	oldpersian}', "");
    Expect(0, 66528, '\p{Is_Blk:	oldpersian}', "");
    Expect(1, 66528, '\p{^Is_Blk:	oldpersian}', "");
    Expect(1, 66528, '\P{Is_Blk:	oldpersian}', "");
    Expect(0, 66528, '\P{^Is_Blk:	oldpersian}', "");
    Expect(1, 66527, '\p{Is_Blk=_Old_persian}', "");
    Expect(0, 66527, '\p{^Is_Blk=_Old_persian}', "");
    Expect(0, 66527, '\P{Is_Blk=_Old_persian}', "");
    Expect(1, 66527, '\P{^Is_Blk=_Old_persian}', "");
    Expect(0, 66528, '\p{Is_Blk=_Old_persian}', "");
    Expect(1, 66528, '\p{^Is_Blk=_Old_persian}', "");
    Expect(1, 66528, '\P{Is_Blk=_Old_persian}', "");
    Expect(0, 66528, '\P{^Is_Blk=_Old_persian}', "");
    Error('\p{Block=/a/_Old_sogdian}');
    Error('\P{Block=/a/_Old_sogdian}');
    Expect(1, 69423, '\p{Block=:\AOld_Sogdian\z:}', "");;
    Expect(0, 69424, '\p{Block=:\AOld_Sogdian\z:}', "");;
    Expect(1, 69423, '\p{Block=oldsogdian}', "");
    Expect(0, 69423, '\p{^Block=oldsogdian}', "");
    Expect(0, 69423, '\P{Block=oldsogdian}', "");
    Expect(1, 69423, '\P{^Block=oldsogdian}', "");
    Expect(0, 69424, '\p{Block=oldsogdian}', "");
    Expect(1, 69424, '\p{^Block=oldsogdian}', "");
    Expect(1, 69424, '\P{Block=oldsogdian}', "");
    Expect(0, 69424, '\P{^Block=oldsogdian}', "");
    Expect(1, 69423, '\p{Block=:\Aoldsogdian\z:}', "");;
    Expect(0, 69424, '\p{Block=:\Aoldsogdian\z:}', "");;
    Expect(1, 69423, '\p{Block= -old_Sogdian}', "");
    Expect(0, 69423, '\p{^Block= -old_Sogdian}', "");
    Expect(0, 69423, '\P{Block= -old_Sogdian}', "");
    Expect(1, 69423, '\P{^Block= -old_Sogdian}', "");
    Expect(0, 69424, '\p{Block= -old_Sogdian}', "");
    Expect(1, 69424, '\p{^Block= -old_Sogdian}', "");
    Expect(1, 69424, '\P{Block= -old_Sogdian}', "");
    Expect(0, 69424, '\P{^Block= -old_Sogdian}', "");
    Error('\p{Blk=__OLD_Sogdian:=}');
    Error('\P{Blk=__OLD_Sogdian:=}');
    Expect(1, 69423, '\p{Blk=:\AOld_Sogdian\z:}', "");;
    Expect(0, 69424, '\p{Blk=:\AOld_Sogdian\z:}', "");;
    Expect(1, 69423, '\p{Blk=oldsogdian}', "");
    Expect(0, 69423, '\p{^Blk=oldsogdian}', "");
    Expect(0, 69423, '\P{Blk=oldsogdian}', "");
    Expect(1, 69423, '\P{^Blk=oldsogdian}', "");
    Expect(0, 69424, '\p{Blk=oldsogdian}', "");
    Expect(1, 69424, '\p{^Blk=oldsogdian}', "");
    Expect(1, 69424, '\P{Blk=oldsogdian}', "");
    Expect(0, 69424, '\P{^Blk=oldsogdian}', "");
    Expect(1, 69423, '\p{Blk=:\Aoldsogdian\z:}', "");;
    Expect(0, 69424, '\p{Blk=:\Aoldsogdian\z:}', "");;
    Expect(1, 69423, '\p{Blk=--OLD_Sogdian}', "");
    Expect(0, 69423, '\p{^Blk=--OLD_Sogdian}', "");
    Expect(0, 69423, '\P{Blk=--OLD_Sogdian}', "");
    Expect(1, 69423, '\P{^Blk=--OLD_Sogdian}', "");
    Expect(0, 69424, '\p{Blk=--OLD_Sogdian}', "");
    Expect(1, 69424, '\p{^Blk=--OLD_Sogdian}', "");
    Expect(1, 69424, '\P{Blk=--OLD_Sogdian}', "");
    Expect(0, 69424, '\P{^Blk=--OLD_Sogdian}', "");
    Error('\p{Is_Block=__OLD_Sogdian:=}');
    Error('\P{Is_Block=__OLD_Sogdian:=}');
    Expect(1, 69423, '\p{Is_Block=oldsogdian}', "");
    Expect(0, 69423, '\p{^Is_Block=oldsogdian}', "");
    Expect(0, 69423, '\P{Is_Block=oldsogdian}', "");
    Expect(1, 69423, '\P{^Is_Block=oldsogdian}', "");
    Expect(0, 69424, '\p{Is_Block=oldsogdian}', "");
    Expect(1, 69424, '\p{^Is_Block=oldsogdian}', "");
    Expect(1, 69424, '\P{Is_Block=oldsogdian}', "");
    Expect(0, 69424, '\P{^Is_Block=oldsogdian}', "");
    Expect(1, 69423, '\p{Is_Block= Old_sogdian}', "");
    Expect(0, 69423, '\p{^Is_Block= Old_sogdian}', "");
    Expect(0, 69423, '\P{Is_Block= Old_sogdian}', "");
    Expect(1, 69423, '\P{^Is_Block= Old_sogdian}', "");
    Expect(0, 69424, '\p{Is_Block= Old_sogdian}', "");
    Expect(1, 69424, '\p{^Is_Block= Old_sogdian}', "");
    Expect(1, 69424, '\P{Is_Block= Old_sogdian}', "");
    Expect(0, 69424, '\P{^Is_Block= Old_sogdian}', "");
    Error('\p{Is_Blk: _Old_Sogdian/a/}');
    Error('\P{Is_Blk: _Old_Sogdian/a/}');
    Expect(1, 69423, '\p{Is_Blk=oldsogdian}', "");
    Expect(0, 69423, '\p{^Is_Blk=oldsogdian}', "");
    Expect(0, 69423, '\P{Is_Blk=oldsogdian}', "");
    Expect(1, 69423, '\P{^Is_Blk=oldsogdian}', "");
    Expect(0, 69424, '\p{Is_Blk=oldsogdian}', "");
    Expect(1, 69424, '\p{^Is_Blk=oldsogdian}', "");
    Expect(1, 69424, '\P{Is_Blk=oldsogdian}', "");
    Expect(0, 69424, '\P{^Is_Blk=oldsogdian}', "");
    Expect(1, 69423, '\p{Is_Blk=	Old_Sogdian}', "");
    Expect(0, 69423, '\p{^Is_Blk=	Old_Sogdian}', "");
    Expect(0, 69423, '\P{Is_Blk=	Old_Sogdian}', "");
    Expect(1, 69423, '\P{^Is_Blk=	Old_Sogdian}', "");
    Expect(0, 69424, '\p{Is_Blk=	Old_Sogdian}', "");
    Expect(1, 69424, '\p{^Is_Blk=	Old_Sogdian}', "");
    Expect(1, 69424, '\P{Is_Blk=	Old_Sogdian}', "");
    Expect(0, 69424, '\P{^Is_Blk=	Old_Sogdian}', "");
    Error('\p{Block=  old_South_ARABIAN:=}');
    Error('\P{Block=  old_South_ARABIAN:=}');
    Expect(1, 68223, '\p{Block=:\AOld_South_Arabian\z:}', "");;
    Expect(0, 68224, '\p{Block=:\AOld_South_Arabian\z:}', "");;
    Expect(1, 68223, '\p{Block=oldsoutharabian}', "");
    Expect(0, 68223, '\p{^Block=oldsoutharabian}', "");
    Expect(0, 68223, '\P{Block=oldsoutharabian}', "");
    Expect(1, 68223, '\P{^Block=oldsoutharabian}', "");
    Expect(0, 68224, '\p{Block=oldsoutharabian}', "");
    Expect(1, 68224, '\p{^Block=oldsoutharabian}', "");
    Expect(1, 68224, '\P{Block=oldsoutharabian}', "");
    Expect(0, 68224, '\P{^Block=oldsoutharabian}', "");
    Expect(1, 68223, '\p{Block=:\Aoldsoutharabian\z:}', "");;
    Expect(0, 68224, '\p{Block=:\Aoldsoutharabian\z:}', "");;
    Expect(1, 68223, '\p{Block=-Old_south_Arabian}', "");
    Expect(0, 68223, '\p{^Block=-Old_south_Arabian}', "");
    Expect(0, 68223, '\P{Block=-Old_south_Arabian}', "");
    Expect(1, 68223, '\P{^Block=-Old_south_Arabian}', "");
    Expect(0, 68224, '\p{Block=-Old_south_Arabian}', "");
    Expect(1, 68224, '\p{^Block=-Old_south_Arabian}', "");
    Expect(1, 68224, '\P{Block=-Old_south_Arabian}', "");
    Expect(0, 68224, '\P{^Block=-Old_south_Arabian}', "");
    Error('\p{Blk=:=OLD_South_arabian}');
    Error('\P{Blk=:=OLD_South_arabian}');
    Expect(1, 68223, '\p{Blk=:\AOld_South_Arabian\z:}', "");;
    Expect(0, 68224, '\p{Blk=:\AOld_South_Arabian\z:}', "");;
    Expect(1, 68223, '\p{Blk=oldsoutharabian}', "");
    Expect(0, 68223, '\p{^Blk=oldsoutharabian}', "");
    Expect(0, 68223, '\P{Blk=oldsoutharabian}', "");
    Expect(1, 68223, '\P{^Blk=oldsoutharabian}', "");
    Expect(0, 68224, '\p{Blk=oldsoutharabian}', "");
    Expect(1, 68224, '\p{^Blk=oldsoutharabian}', "");
    Expect(1, 68224, '\P{Blk=oldsoutharabian}', "");
    Expect(0, 68224, '\P{^Blk=oldsoutharabian}', "");
    Expect(1, 68223, '\p{Blk=:\Aoldsoutharabian\z:}', "");;
    Expect(0, 68224, '\p{Blk=:\Aoldsoutharabian\z:}', "");;
    Expect(1, 68223, '\p{Blk=_old_south_Arabian}', "");
    Expect(0, 68223, '\p{^Blk=_old_south_Arabian}', "");
    Expect(0, 68223, '\P{Blk=_old_south_Arabian}', "");
    Expect(1, 68223, '\P{^Blk=_old_south_Arabian}', "");
    Expect(0, 68224, '\p{Blk=_old_south_Arabian}', "");
    Expect(1, 68224, '\p{^Blk=_old_south_Arabian}', "");
    Expect(1, 68224, '\P{Blk=_old_south_Arabian}', "");
    Expect(0, 68224, '\P{^Blk=_old_south_Arabian}', "");
    Error('\p{Is_Block=:=_	old_South_ARABIAN}');
    Error('\P{Is_Block=:=_	old_South_ARABIAN}');
    Expect(1, 68223, '\p{Is_Block=oldsoutharabian}', "");
    Expect(0, 68223, '\p{^Is_Block=oldsoutharabian}', "");
    Expect(0, 68223, '\P{Is_Block=oldsoutharabian}', "");
    Expect(1, 68223, '\P{^Is_Block=oldsoutharabian}', "");
    Expect(0, 68224, '\p{Is_Block=oldsoutharabian}', "");
    Expect(1, 68224, '\p{^Is_Block=oldsoutharabian}', "");
    Expect(1, 68224, '\P{Is_Block=oldsoutharabian}', "");
    Expect(0, 68224, '\P{^Is_Block=oldsoutharabian}', "");
    Expect(1, 68223, '\p{Is_Block:		old_South_ARABIAN}', "");
    Expect(0, 68223, '\p{^Is_Block:		old_South_ARABIAN}', "");
    Expect(0, 68223, '\P{Is_Block:		old_South_ARABIAN}', "");
    Expect(1, 68223, '\P{^Is_Block:		old_South_ARABIAN}', "");
    Expect(0, 68224, '\p{Is_Block:		old_South_ARABIAN}', "");
    Expect(1, 68224, '\p{^Is_Block:		old_South_ARABIAN}', "");
    Expect(1, 68224, '\P{Is_Block:		old_South_ARABIAN}', "");
    Expect(0, 68224, '\P{^Is_Block:		old_South_ARABIAN}', "");
    Error('\p{Is_Blk:   	/a/OLD_south_ARABIAN}');
    Error('\P{Is_Blk:   	/a/OLD_south_ARABIAN}');
    Expect(1, 68223, '\p{Is_Blk=oldsoutharabian}', "");
    Expect(0, 68223, '\p{^Is_Blk=oldsoutharabian}', "");
    Expect(0, 68223, '\P{Is_Blk=oldsoutharabian}', "");
    Expect(1, 68223, '\P{^Is_Blk=oldsoutharabian}', "");
    Expect(0, 68224, '\p{Is_Blk=oldsoutharabian}', "");
    Expect(1, 68224, '\p{^Is_Blk=oldsoutharabian}', "");
    Expect(1, 68224, '\P{Is_Blk=oldsoutharabian}', "");
    Expect(0, 68224, '\P{^Is_Blk=oldsoutharabian}', "");
    Expect(1, 68223, '\p{Is_Blk=_	OLD_SOUTH_arabian}', "");
    Expect(0, 68223, '\p{^Is_Blk=_	OLD_SOUTH_arabian}', "");
    Expect(0, 68223, '\P{Is_Blk=_	OLD_SOUTH_arabian}', "");
    Expect(1, 68223, '\P{^Is_Blk=_	OLD_SOUTH_arabian}', "");
    Expect(0, 68224, '\p{Is_Blk=_	OLD_SOUTH_arabian}', "");
    Expect(1, 68224, '\p{^Is_Blk=_	OLD_SOUTH_arabian}', "");
    Expect(1, 68224, '\P{Is_Blk=_	OLD_SOUTH_arabian}', "");
    Expect(0, 68224, '\P{^Is_Blk=_	OLD_SOUTH_arabian}', "");
    Error('\p{Block=/a/Old_TURKIC}');
    Error('\P{Block=/a/Old_TURKIC}');
    Expect(1, 68687, '\p{Block=:\AOld_Turkic\z:}', "");;
    Expect(0, 68688, '\p{Block=:\AOld_Turkic\z:}', "");;
    Expect(1, 68687, '\p{Block=oldturkic}', "");
    Expect(0, 68687, '\p{^Block=oldturkic}', "");
    Expect(0, 68687, '\P{Block=oldturkic}', "");
    Expect(1, 68687, '\P{^Block=oldturkic}', "");
    Expect(0, 68688, '\p{Block=oldturkic}', "");
    Expect(1, 68688, '\p{^Block=oldturkic}', "");
    Expect(1, 68688, '\P{Block=oldturkic}', "");
    Expect(0, 68688, '\P{^Block=oldturkic}', "");
    Expect(1, 68687, '\p{Block=:\Aoldturkic\z:}', "");;
    Expect(0, 68688, '\p{Block=:\Aoldturkic\z:}', "");;
    Expect(1, 68687, '\p{Block: _Old_TURKIC}', "");
    Expect(0, 68687, '\p{^Block: _Old_TURKIC}', "");
    Expect(0, 68687, '\P{Block: _Old_TURKIC}', "");
    Expect(1, 68687, '\P{^Block: _Old_TURKIC}', "");
    Expect(0, 68688, '\p{Block: _Old_TURKIC}', "");
    Expect(1, 68688, '\p{^Block: _Old_TURKIC}', "");
    Expect(1, 68688, '\P{Block: _Old_TURKIC}', "");
    Expect(0, 68688, '\P{^Block: _Old_TURKIC}', "");
    Error('\p{Blk= /a/old_Turkic}');
    Error('\P{Blk= /a/old_Turkic}');
    Expect(1, 68687, '\p{Blk=:\AOld_Turkic\z:}', "");;
    Expect(0, 68688, '\p{Blk=:\AOld_Turkic\z:}', "");;
    Expect(1, 68687, '\p{Blk:   oldturkic}', "");
    Expect(0, 68687, '\p{^Blk:   oldturkic}', "");
    Expect(0, 68687, '\P{Blk:   oldturkic}', "");
    Expect(1, 68687, '\P{^Blk:   oldturkic}', "");
    Expect(0, 68688, '\p{Blk:   oldturkic}', "");
    Expect(1, 68688, '\p{^Blk:   oldturkic}', "");
    Expect(1, 68688, '\P{Blk:   oldturkic}', "");
    Expect(0, 68688, '\P{^Blk:   oldturkic}', "");
    Expect(1, 68687, '\p{Blk=:\Aoldturkic\z:}', "");;
    Expect(0, 68688, '\p{Blk=:\Aoldturkic\z:}', "");;
    Expect(1, 68687, '\p{Blk=Old_Turkic}', "");
    Expect(0, 68687, '\p{^Blk=Old_Turkic}', "");
    Expect(0, 68687, '\P{Blk=Old_Turkic}', "");
    Expect(1, 68687, '\P{^Blk=Old_Turkic}', "");
    Expect(0, 68688, '\p{Blk=Old_Turkic}', "");
    Expect(1, 68688, '\p{^Blk=Old_Turkic}', "");
    Expect(1, 68688, '\P{Blk=Old_Turkic}', "");
    Expect(0, 68688, '\P{^Blk=Old_Turkic}', "");
    Error('\p{Is_Block= Old_TURKIC:=}');
    Error('\P{Is_Block= Old_TURKIC:=}');
    Expect(1, 68687, '\p{Is_Block=oldturkic}', "");
    Expect(0, 68687, '\p{^Is_Block=oldturkic}', "");
    Expect(0, 68687, '\P{Is_Block=oldturkic}', "");
    Expect(1, 68687, '\P{^Is_Block=oldturkic}', "");
    Expect(0, 68688, '\p{Is_Block=oldturkic}', "");
    Expect(1, 68688, '\p{^Is_Block=oldturkic}', "");
    Expect(1, 68688, '\P{Is_Block=oldturkic}', "");
    Expect(0, 68688, '\P{^Is_Block=oldturkic}', "");
    Expect(1, 68687, '\p{Is_Block=Old_turkic}', "");
    Expect(0, 68687, '\p{^Is_Block=Old_turkic}', "");
    Expect(0, 68687, '\P{Is_Block=Old_turkic}', "");
    Expect(1, 68687, '\P{^Is_Block=Old_turkic}', "");
    Expect(0, 68688, '\p{Is_Block=Old_turkic}', "");
    Expect(1, 68688, '\p{^Is_Block=Old_turkic}', "");
    Expect(1, 68688, '\P{Is_Block=Old_turkic}', "");
    Expect(0, 68688, '\P{^Is_Block=Old_turkic}', "");
    Error('\p{Is_Blk=-	Old_TURKIC/a/}');
    Error('\P{Is_Blk=-	Old_TURKIC/a/}');
    Expect(1, 68687, '\p{Is_Blk=oldturkic}', "");
    Expect(0, 68687, '\p{^Is_Blk=oldturkic}', "");
    Expect(0, 68687, '\P{Is_Blk=oldturkic}', "");
    Expect(1, 68687, '\P{^Is_Blk=oldturkic}', "");
    Expect(0, 68688, '\p{Is_Blk=oldturkic}', "");
    Expect(1, 68688, '\p{^Is_Blk=oldturkic}', "");
    Expect(1, 68688, '\P{Is_Blk=oldturkic}', "");
    Expect(0, 68688, '\P{^Is_Blk=oldturkic}', "");
    Expect(1, 68687, '\p{Is_Blk= _Old_turkic}', "");
    Expect(0, 68687, '\p{^Is_Blk= _Old_turkic}', "");
    Expect(0, 68687, '\P{Is_Blk= _Old_turkic}', "");
    Expect(1, 68687, '\P{^Is_Blk= _Old_turkic}', "");
    Expect(0, 68688, '\p{Is_Blk= _Old_turkic}', "");
    Expect(1, 68688, '\p{^Is_Blk= _Old_turkic}', "");
    Expect(1, 68688, '\P{Is_Blk= _Old_turkic}', "");
    Expect(0, 68688, '\P{^Is_Blk= _Old_turkic}', "");
    Error('\p{Block=/a/__ORIYA}');
    Error('\P{Block=/a/__ORIYA}');
    Expect(1, 2943, '\p{Block=:\AOriya\z:}', "");;
    Expect(0, 2944, '\p{Block=:\AOriya\z:}', "");;
    Expect(1, 2943, '\p{Block=oriya}', "");
    Expect(0, 2943, '\p{^Block=oriya}', "");
    Expect(0, 2943, '\P{Block=oriya}', "");
    Expect(1, 2943, '\P{^Block=oriya}', "");
    Expect(0, 2944, '\p{Block=oriya}', "");
    Expect(1, 2944, '\p{^Block=oriya}', "");
    Expect(1, 2944, '\P{Block=oriya}', "");
    Expect(0, 2944, '\P{^Block=oriya}', "");
    Expect(1, 2943, '\p{Block=:\Aoriya\z:}', "");;
    Expect(0, 2944, '\p{Block=:\Aoriya\z:}', "");;
    Expect(1, 2943, '\p{Block=_Oriya}', "");
    Expect(0, 2943, '\p{^Block=_Oriya}', "");
    Expect(0, 2943, '\P{Block=_Oriya}', "");
    Expect(1, 2943, '\P{^Block=_Oriya}', "");
    Expect(0, 2944, '\p{Block=_Oriya}', "");
    Expect(1, 2944, '\p{^Block=_Oriya}', "");
    Expect(1, 2944, '\P{Block=_Oriya}', "");
    Expect(0, 2944, '\P{^Block=_Oriya}', "");
    Error('\p{Blk= /a/Oriya}');
    Error('\P{Blk= /a/Oriya}');
    Expect(1, 2943, '\p{Blk=:\AOriya\z:}', "");;
    Expect(0, 2944, '\p{Blk=:\AOriya\z:}', "");;
    Expect(1, 2943, '\p{Blk=oriya}', "");
    Expect(0, 2943, '\p{^Blk=oriya}', "");
    Expect(0, 2943, '\P{Blk=oriya}', "");
    Expect(1, 2943, '\P{^Blk=oriya}', "");
    Expect(0, 2944, '\p{Blk=oriya}', "");
    Expect(1, 2944, '\p{^Blk=oriya}', "");
    Expect(1, 2944, '\P{Blk=oriya}', "");
    Expect(0, 2944, '\P{^Blk=oriya}', "");
    Expect(1, 2943, '\p{Blk=:\Aoriya\z:}', "");;
    Expect(0, 2944, '\p{Blk=:\Aoriya\z:}', "");;
    Expect(1, 2943, '\p{Blk=	Oriya}', "");
    Expect(0, 2943, '\p{^Blk=	Oriya}', "");
    Expect(0, 2943, '\P{Blk=	Oriya}', "");
    Expect(1, 2943, '\P{^Blk=	Oriya}', "");
    Expect(0, 2944, '\p{Blk=	Oriya}', "");
    Expect(1, 2944, '\p{^Blk=	Oriya}', "");
    Expect(1, 2944, '\P{Blk=	Oriya}', "");
    Expect(0, 2944, '\P{^Blk=	Oriya}', "");
    Error('\p{Is_Block=_:=ORIYA}');
    Error('\P{Is_Block=_:=ORIYA}');
    Expect(1, 2943, '\p{Is_Block=oriya}', "");
    Expect(0, 2943, '\p{^Is_Block=oriya}', "");
    Expect(0, 2943, '\P{Is_Block=oriya}', "");
    Expect(1, 2943, '\P{^Is_Block=oriya}', "");
    Expect(0, 2944, '\p{Is_Block=oriya}', "");
    Expect(1, 2944, '\p{^Is_Block=oriya}', "");
    Expect(1, 2944, '\P{Is_Block=oriya}', "");
    Expect(0, 2944, '\P{^Is_Block=oriya}', "");
    Error('\p{Is_Blk= Oriya/a/}');
    Error('\P{Is_Blk= Oriya/a/}');
    Expect(1, 2943, '\p{Is_Blk=oriya}', "");
    Expect(0, 2943, '\p{^Is_Blk=oriya}', "");
    Expect(0, 2943, '\P{Is_Blk=oriya}', "");
    Expect(1, 2943, '\P{^Is_Blk=oriya}', "");
    Expect(0, 2944, '\p{Is_Blk=oriya}', "");
    Expect(1, 2944, '\p{^Is_Blk=oriya}', "");
    Expect(1, 2944, '\P{Is_Blk=oriya}', "");
    Expect(0, 2944, '\P{^Is_Blk=oriya}', "");
    Expect(1, 2943, '\p{Is_Blk:-Oriya}', "");
    Expect(0, 2943, '\p{^Is_Blk:-Oriya}', "");
    Expect(0, 2943, '\P{Is_Blk:-Oriya}', "");
    Expect(1, 2943, '\P{^Is_Blk:-Oriya}', "");
    Expect(0, 2944, '\p{Is_Blk:-Oriya}', "");
    Expect(1, 2944, '\p{^Is_Blk:-Oriya}', "");
    Expect(1, 2944, '\P{Is_Blk:-Oriya}', "");
    Expect(0, 2944, '\P{^Is_Blk:-Oriya}', "");
    Error('\p{Block=_ ornamental_DINGBATS:=}');
    Error('\P{Block=_ ornamental_DINGBATS:=}');
    Expect(1, 128639, '\p{Block=:\AOrnamental_Dingbats\z:}', "");;
    Expect(0, 128640, '\p{Block=:\AOrnamental_Dingbats\z:}', "");;
    Expect(1, 128639, '\p{Block:ornamentaldingbats}', "");
    Expect(0, 128639, '\p{^Block:ornamentaldingbats}', "");
    Expect(0, 128639, '\P{Block:ornamentaldingbats}', "");
    Expect(1, 128639, '\P{^Block:ornamentaldingbats}', "");
    Expect(0, 128640, '\p{Block:ornamentaldingbats}', "");
    Expect(1, 128640, '\p{^Block:ornamentaldingbats}', "");
    Expect(1, 128640, '\P{Block:ornamentaldingbats}', "");
    Expect(0, 128640, '\P{^Block:ornamentaldingbats}', "");
    Expect(1, 128639, '\p{Block=:\Aornamentaldingbats\z:}', "");;
    Expect(0, 128640, '\p{Block=:\Aornamentaldingbats\z:}', "");;
    Expect(1, 128639, '\p{Block=	_ornamental_Dingbats}', "");
    Expect(0, 128639, '\p{^Block=	_ornamental_Dingbats}', "");
    Expect(0, 128639, '\P{Block=	_ornamental_Dingbats}', "");
    Expect(1, 128639, '\P{^Block=	_ornamental_Dingbats}', "");
    Expect(0, 128640, '\p{Block=	_ornamental_Dingbats}', "");
    Expect(1, 128640, '\p{^Block=	_ornamental_Dingbats}', "");
    Expect(1, 128640, '\P{Block=	_ornamental_Dingbats}', "");
    Expect(0, 128640, '\P{^Block=	_ornamental_Dingbats}', "");
    Error('\p{Blk=:=--ORNAMENTAL_Dingbats}');
    Error('\P{Blk=:=--ORNAMENTAL_Dingbats}');
    Expect(1, 128639, '\p{Blk=:\AOrnamental_Dingbats\z:}', "");;
    Expect(0, 128640, '\p{Blk=:\AOrnamental_Dingbats\z:}', "");;
    Expect(1, 128639, '\p{Blk=ornamentaldingbats}', "");
    Expect(0, 128639, '\p{^Blk=ornamentaldingbats}', "");
    Expect(0, 128639, '\P{Blk=ornamentaldingbats}', "");
    Expect(1, 128639, '\P{^Blk=ornamentaldingbats}', "");
    Expect(0, 128640, '\p{Blk=ornamentaldingbats}', "");
    Expect(1, 128640, '\p{^Blk=ornamentaldingbats}', "");
    Expect(1, 128640, '\P{Blk=ornamentaldingbats}', "");
    Expect(0, 128640, '\P{^Blk=ornamentaldingbats}', "");
    Expect(1, 128639, '\p{Blk=:\Aornamentaldingbats\z:}', "");;
    Expect(0, 128640, '\p{Blk=:\Aornamentaldingbats\z:}', "");;
    Expect(1, 128639, '\p{Blk= ornamental_Dingbats}', "");
    Expect(0, 128639, '\p{^Blk= ornamental_Dingbats}', "");
    Expect(0, 128639, '\P{Blk= ornamental_Dingbats}', "");
    Expect(1, 128639, '\P{^Blk= ornamental_Dingbats}', "");
    Expect(0, 128640, '\p{Blk= ornamental_Dingbats}', "");
    Expect(1, 128640, '\p{^Blk= ornamental_Dingbats}', "");
    Expect(1, 128640, '\P{Blk= ornamental_Dingbats}', "");
    Expect(0, 128640, '\P{^Blk= ornamental_Dingbats}', "");
    Error('\p{Is_Block=_/a/Ornamental_Dingbats}');
    Error('\P{Is_Block=_/a/Ornamental_Dingbats}');
    Expect(1, 128639, '\p{Is_Block=ornamentaldingbats}', "");
    Expect(0, 128639, '\p{^Is_Block=ornamentaldingbats}', "");
    Expect(0, 128639, '\P{Is_Block=ornamentaldingbats}', "");
    Expect(1, 128639, '\P{^Is_Block=ornamentaldingbats}', "");
    Expect(0, 128640, '\p{Is_Block=ornamentaldingbats}', "");
    Expect(1, 128640, '\p{^Is_Block=ornamentaldingbats}', "");
    Expect(1, 128640, '\P{Is_Block=ornamentaldingbats}', "");
    Expect(0, 128640, '\P{^Is_Block=ornamentaldingbats}', "");
    Expect(1, 128639, '\p{Is_Block=_-Ornamental_Dingbats}', "");
    Expect(0, 128639, '\p{^Is_Block=_-Ornamental_Dingbats}', "");
    Expect(0, 128639, '\P{Is_Block=_-Ornamental_Dingbats}', "");
    Expect(1, 128639, '\P{^Is_Block=_-Ornamental_Dingbats}', "");
    Expect(0, 128640, '\p{Is_Block=_-Ornamental_Dingbats}', "");
    Expect(1, 128640, '\p{^Is_Block=_-Ornamental_Dingbats}', "");
    Expect(1, 128640, '\P{Is_Block=_-Ornamental_Dingbats}', "");
    Expect(0, 128640, '\P{^Is_Block=_-Ornamental_Dingbats}', "");
    Error('\p{Is_Blk=_ornamental_dingbats:=}');
    Error('\P{Is_Blk=_ornamental_dingbats:=}');
    Expect(1, 128639, '\p{Is_Blk=ornamentaldingbats}', "");
    Expect(0, 128639, '\p{^Is_Blk=ornamentaldingbats}', "");
    Expect(0, 128639, '\P{Is_Blk=ornamentaldingbats}', "");
    Expect(1, 128639, '\P{^Is_Blk=ornamentaldingbats}', "");
    Expect(0, 128640, '\p{Is_Blk=ornamentaldingbats}', "");
    Expect(1, 128640, '\p{^Is_Blk=ornamentaldingbats}', "");
    Expect(1, 128640, '\P{Is_Blk=ornamentaldingbats}', "");
    Expect(0, 128640, '\P{^Is_Blk=ornamentaldingbats}', "");
    Expect(1, 128639, '\p{Is_Blk:	_Ornamental_Dingbats}', "");
    Expect(0, 128639, '\p{^Is_Blk:	_Ornamental_Dingbats}', "");
    Expect(0, 128639, '\P{Is_Blk:	_Ornamental_Dingbats}', "");
    Expect(1, 128639, '\P{^Is_Blk:	_Ornamental_Dingbats}', "");
    Expect(0, 128640, '\p{Is_Blk:	_Ornamental_Dingbats}', "");
    Expect(1, 128640, '\p{^Is_Blk:	_Ornamental_Dingbats}', "");
    Expect(1, 128640, '\P{Is_Blk:	_Ornamental_Dingbats}', "");
    Expect(0, 128640, '\P{^Is_Blk:	_Ornamental_Dingbats}', "");
    Error('\p{Block= 	osage/a/}');
    Error('\P{Block= 	osage/a/}');
    Expect(1, 66815, '\p{Block=:\AOsage\z:}', "");;
    Expect(0, 66816, '\p{Block=:\AOsage\z:}', "");;
    Expect(1, 66815, '\p{Block=osage}', "");
    Expect(0, 66815, '\p{^Block=osage}', "");
    Expect(0, 66815, '\P{Block=osage}', "");
    Expect(1, 66815, '\P{^Block=osage}', "");
    Expect(0, 66816, '\p{Block=osage}', "");
    Expect(1, 66816, '\p{^Block=osage}', "");
    Expect(1, 66816, '\P{Block=osage}', "");
    Expect(0, 66816, '\P{^Block=osage}', "");
    Expect(1, 66815, '\p{Block=:\Aosage\z:}', "");;
    Expect(0, 66816, '\p{Block=:\Aosage\z:}', "");;
    Expect(1, 66815, '\p{Block=	osage}', "");
    Expect(0, 66815, '\p{^Block=	osage}', "");
    Expect(0, 66815, '\P{Block=	osage}', "");
    Expect(1, 66815, '\P{^Block=	osage}', "");
    Expect(0, 66816, '\p{Block=	osage}', "");
    Expect(1, 66816, '\p{^Block=	osage}', "");
    Expect(1, 66816, '\P{Block=	osage}', "");
    Expect(0, 66816, '\P{^Block=	osage}', "");
    Error('\p{Blk=:=_ OSAGE}');
    Error('\P{Blk=:=_ OSAGE}');
    Expect(1, 66815, '\p{Blk=:\AOsage\z:}', "");;
    Expect(0, 66816, '\p{Blk=:\AOsage\z:}', "");;
    Expect(1, 66815, '\p{Blk=osage}', "");
    Expect(0, 66815, '\p{^Blk=osage}', "");
    Expect(0, 66815, '\P{Blk=osage}', "");
    Expect(1, 66815, '\P{^Blk=osage}', "");
    Expect(0, 66816, '\p{Blk=osage}', "");
    Expect(1, 66816, '\p{^Blk=osage}', "");
    Expect(1, 66816, '\P{Blk=osage}', "");
    Expect(0, 66816, '\P{^Blk=osage}', "");
    Expect(1, 66815, '\p{Blk=:\Aosage\z:}', "");;
    Expect(0, 66816, '\p{Blk=:\Aosage\z:}', "");;
    Expect(1, 66815, '\p{Blk=		OSAGE}', "");
    Expect(0, 66815, '\p{^Blk=		OSAGE}', "");
    Expect(0, 66815, '\P{Blk=		OSAGE}', "");
    Expect(1, 66815, '\P{^Blk=		OSAGE}', "");
    Expect(0, 66816, '\p{Blk=		OSAGE}', "");
    Expect(1, 66816, '\p{^Blk=		OSAGE}', "");
    Expect(1, 66816, '\P{Blk=		OSAGE}', "");
    Expect(0, 66816, '\P{^Blk=		OSAGE}', "");
    Error('\p{Is_Block=__Osage/a/}');
    Error('\P{Is_Block=__Osage/a/}');
    Expect(1, 66815, '\p{Is_Block:osage}', "");
    Expect(0, 66815, '\p{^Is_Block:osage}', "");
    Expect(0, 66815, '\P{Is_Block:osage}', "");
    Expect(1, 66815, '\P{^Is_Block:osage}', "");
    Expect(0, 66816, '\p{Is_Block:osage}', "");
    Expect(1, 66816, '\p{^Is_Block:osage}', "");
    Expect(1, 66816, '\P{Is_Block:osage}', "");
    Expect(0, 66816, '\P{^Is_Block:osage}', "");
    Expect(1, 66815, '\p{Is_Block=OSAGE}', "");
    Expect(0, 66815, '\p{^Is_Block=OSAGE}', "");
    Expect(0, 66815, '\P{Is_Block=OSAGE}', "");
    Expect(1, 66815, '\P{^Is_Block=OSAGE}', "");
    Expect(0, 66816, '\p{Is_Block=OSAGE}', "");
    Expect(1, 66816, '\p{^Is_Block=OSAGE}', "");
    Expect(1, 66816, '\P{Is_Block=OSAGE}', "");
    Expect(0, 66816, '\P{^Is_Block=OSAGE}', "");
    Error('\p{Is_Blk=:=--Osage}');
    Error('\P{Is_Blk=:=--Osage}');
    Expect(1, 66815, '\p{Is_Blk=osage}', "");
    Expect(0, 66815, '\p{^Is_Blk=osage}', "");
    Expect(0, 66815, '\P{Is_Blk=osage}', "");
    Expect(1, 66815, '\P{^Is_Blk=osage}', "");
    Expect(0, 66816, '\p{Is_Blk=osage}', "");
    Expect(1, 66816, '\p{^Is_Blk=osage}', "");
    Expect(1, 66816, '\P{Is_Blk=osage}', "");
    Expect(0, 66816, '\P{^Is_Blk=osage}', "");
    Expect(1, 66815, '\p{Is_Blk= -osage}', "");
    Expect(0, 66815, '\p{^Is_Blk= -osage}', "");
    Expect(0, 66815, '\P{Is_Blk= -osage}', "");
    Expect(1, 66815, '\P{^Is_Blk= -osage}', "");
    Expect(0, 66816, '\p{Is_Blk= -osage}', "");
    Expect(1, 66816, '\p{^Is_Blk= -osage}', "");
    Expect(1, 66816, '\P{Is_Blk= -osage}', "");
    Expect(0, 66816, '\P{^Is_Blk= -osage}', "");
    Error('\p{Block=_:=Osmanya}');
    Error('\P{Block=_:=Osmanya}');
    Expect(1, 66735, '\p{Block=:\AOsmanya\z:}', "");;
    Expect(0, 66736, '\p{Block=:\AOsmanya\z:}', "");;
    Expect(1, 66735, '\p{Block=osmanya}', "");
    Expect(0, 66735, '\p{^Block=osmanya}', "");
    Expect(0, 66735, '\P{Block=osmanya}', "");
    Expect(1, 66735, '\P{^Block=osmanya}', "");
    Expect(0, 66736, '\p{Block=osmanya}', "");
    Expect(1, 66736, '\p{^Block=osmanya}', "");
    Expect(1, 66736, '\P{Block=osmanya}', "");
    Expect(0, 66736, '\P{^Block=osmanya}', "");
    Expect(1, 66735, '\p{Block=:\Aosmanya\z:}', "");;
    Expect(0, 66736, '\p{Block=:\Aosmanya\z:}', "");;
    Expect(1, 66735, '\p{Block=- osmanya}', "");
    Expect(0, 66735, '\p{^Block=- osmanya}', "");
    Expect(0, 66735, '\P{Block=- osmanya}', "");
    Expect(1, 66735, '\P{^Block=- osmanya}', "");
    Expect(0, 66736, '\p{Block=- osmanya}', "");
    Expect(1, 66736, '\p{^Block=- osmanya}', "");
    Expect(1, 66736, '\P{Block=- osmanya}', "");
    Expect(0, 66736, '\P{^Block=- osmanya}', "");
    Error('\p{Blk= /a/Osmanya}');
    Error('\P{Blk= /a/Osmanya}');
    Expect(1, 66735, '\p{Blk=:\AOsmanya\z:}', "");;
    Expect(0, 66736, '\p{Blk=:\AOsmanya\z:}', "");;
    Expect(1, 66735, '\p{Blk=osmanya}', "");
    Expect(0, 66735, '\p{^Blk=osmanya}', "");
    Expect(0, 66735, '\P{Blk=osmanya}', "");
    Expect(1, 66735, '\P{^Blk=osmanya}', "");
    Expect(0, 66736, '\p{Blk=osmanya}', "");
    Expect(1, 66736, '\p{^Blk=osmanya}', "");
    Expect(1, 66736, '\P{Blk=osmanya}', "");
    Expect(0, 66736, '\P{^Blk=osmanya}', "");
    Expect(1, 66735, '\p{Blk=:\Aosmanya\z:}', "");;
    Expect(0, 66736, '\p{Blk=:\Aosmanya\z:}', "");;
    Error('\p{Is_Block:	  Osmanya/a/}');
    Error('\P{Is_Block:	  Osmanya/a/}');
    Expect(1, 66735, '\p{Is_Block=osmanya}', "");
    Expect(0, 66735, '\p{^Is_Block=osmanya}', "");
    Expect(0, 66735, '\P{Is_Block=osmanya}', "");
    Expect(1, 66735, '\P{^Is_Block=osmanya}', "");
    Expect(0, 66736, '\p{Is_Block=osmanya}', "");
    Expect(1, 66736, '\p{^Is_Block=osmanya}', "");
    Expect(1, 66736, '\P{Is_Block=osmanya}', "");
    Expect(0, 66736, '\P{^Is_Block=osmanya}', "");
    Expect(1, 66735, '\p{Is_Block= _OSMANYA}', "");
    Expect(0, 66735, '\p{^Is_Block= _OSMANYA}', "");
    Expect(0, 66735, '\P{Is_Block= _OSMANYA}', "");
    Expect(1, 66735, '\P{^Is_Block= _OSMANYA}', "");
    Expect(0, 66736, '\p{Is_Block= _OSMANYA}', "");
    Expect(1, 66736, '\p{^Is_Block= _OSMANYA}', "");
    Expect(1, 66736, '\P{Is_Block= _OSMANYA}', "");
    Expect(0, 66736, '\P{^Is_Block= _OSMANYA}', "");
    Error('\p{Is_Blk=-	Osmanya/a/}');
    Error('\P{Is_Blk=-	Osmanya/a/}');
    Expect(1, 66735, '\p{Is_Blk=osmanya}', "");
    Expect(0, 66735, '\p{^Is_Blk=osmanya}', "");
    Expect(0, 66735, '\P{Is_Blk=osmanya}', "");
    Expect(1, 66735, '\P{^Is_Blk=osmanya}', "");
    Expect(0, 66736, '\p{Is_Blk=osmanya}', "");
    Expect(1, 66736, '\p{^Is_Blk=osmanya}', "");
    Expect(1, 66736, '\P{Is_Blk=osmanya}', "");
    Expect(0, 66736, '\P{^Is_Blk=osmanya}', "");
    Error('\p{Block=/a/ _Ottoman_Siyaq_Numbers}');
    Error('\P{Block=/a/ _Ottoman_Siyaq_Numbers}');
    Expect(1, 126287, '\p{Block=:\AOttoman_Siyaq_Numbers\z:}', "");;
    Expect(0, 126288, '\p{Block=:\AOttoman_Siyaq_Numbers\z:}', "");;
    Expect(1, 126287, '\p{Block:	ottomansiyaqnumbers}', "");
    Expect(0, 126287, '\p{^Block:	ottomansiyaqnumbers}', "");
    Expect(0, 126287, '\P{Block:	ottomansiyaqnumbers}', "");
    Expect(1, 126287, '\P{^Block:	ottomansiyaqnumbers}', "");
    Expect(0, 126288, '\p{Block:	ottomansiyaqnumbers}', "");
    Expect(1, 126288, '\p{^Block:	ottomansiyaqnumbers}', "");
    Expect(1, 126288, '\P{Block:	ottomansiyaqnumbers}', "");
    Expect(0, 126288, '\P{^Block:	ottomansiyaqnumbers}', "");
    Expect(1, 126287, '\p{Block=:\Aottomansiyaqnumbers\z:}', "");;
    Expect(0, 126288, '\p{Block=:\Aottomansiyaqnumbers\z:}', "");;
    Expect(1, 126287, '\p{Block=__ottoman_SIYAQ_NUMBERS}', "");
    Expect(0, 126287, '\p{^Block=__ottoman_SIYAQ_NUMBERS}', "");
    Expect(0, 126287, '\P{Block=__ottoman_SIYAQ_NUMBERS}', "");
    Expect(1, 126287, '\P{^Block=__ottoman_SIYAQ_NUMBERS}', "");
    Expect(0, 126288, '\p{Block=__ottoman_SIYAQ_NUMBERS}', "");
    Expect(1, 126288, '\p{^Block=__ottoman_SIYAQ_NUMBERS}', "");
    Expect(1, 126288, '\P{Block=__ottoman_SIYAQ_NUMBERS}', "");
    Expect(0, 126288, '\P{^Block=__ottoman_SIYAQ_NUMBERS}', "");
    Error('\p{Blk=	/a/ottoman_siyaq_Numbers}');
    Error('\P{Blk=	/a/ottoman_siyaq_Numbers}');
    Expect(1, 126287, '\p{Blk=:\AOttoman_Siyaq_Numbers\z:}', "");;
    Expect(0, 126288, '\p{Blk=:\AOttoman_Siyaq_Numbers\z:}', "");;
    Expect(1, 126287, '\p{Blk:	ottomansiyaqnumbers}', "");
    Expect(0, 126287, '\p{^Blk:	ottomansiyaqnumbers}', "");
    Expect(0, 126287, '\P{Blk:	ottomansiyaqnumbers}', "");
    Expect(1, 126287, '\P{^Blk:	ottomansiyaqnumbers}', "");
    Expect(0, 126288, '\p{Blk:	ottomansiyaqnumbers}', "");
    Expect(1, 126288, '\p{^Blk:	ottomansiyaqnumbers}', "");
    Expect(1, 126288, '\P{Blk:	ottomansiyaqnumbers}', "");
    Expect(0, 126288, '\P{^Blk:	ottomansiyaqnumbers}', "");
    Expect(1, 126287, '\p{Blk=:\Aottomansiyaqnumbers\z:}', "");;
    Expect(0, 126288, '\p{Blk=:\Aottomansiyaqnumbers\z:}', "");;
    Expect(1, 126287, '\p{Blk=_	ottoman_Siyaq_Numbers}', "");
    Expect(0, 126287, '\p{^Blk=_	ottoman_Siyaq_Numbers}', "");
    Expect(0, 126287, '\P{Blk=_	ottoman_Siyaq_Numbers}', "");
    Expect(1, 126287, '\P{^Blk=_	ottoman_Siyaq_Numbers}', "");
    Expect(0, 126288, '\p{Blk=_	ottoman_Siyaq_Numbers}', "");
    Expect(1, 126288, '\p{^Blk=_	ottoman_Siyaq_Numbers}', "");
    Expect(1, 126288, '\P{Blk=_	ottoman_Siyaq_Numbers}', "");
    Expect(0, 126288, '\P{^Blk=_	ottoman_Siyaq_Numbers}', "");
    Error('\p{Is_Block=	:=OTTOMAN_SIYAQ_numbers}');
    Error('\P{Is_Block=	:=OTTOMAN_SIYAQ_numbers}');
    Expect(1, 126287, '\p{Is_Block=ottomansiyaqnumbers}', "");
    Expect(0, 126287, '\p{^Is_Block=ottomansiyaqnumbers}', "");
    Expect(0, 126287, '\P{Is_Block=ottomansiyaqnumbers}', "");
    Expect(1, 126287, '\P{^Is_Block=ottomansiyaqnumbers}', "");
    Expect(0, 126288, '\p{Is_Block=ottomansiyaqnumbers}', "");
    Expect(1, 126288, '\p{^Is_Block=ottomansiyaqnumbers}', "");
    Expect(1, 126288, '\P{Is_Block=ottomansiyaqnumbers}', "");
    Expect(0, 126288, '\P{^Is_Block=ottomansiyaqnumbers}', "");
    Expect(1, 126287, '\p{Is_Block=	Ottoman_Siyaq_Numbers}', "");
    Expect(0, 126287, '\p{^Is_Block=	Ottoman_Siyaq_Numbers}', "");
    Expect(0, 126287, '\P{Is_Block=	Ottoman_Siyaq_Numbers}', "");
    Expect(1, 126287, '\P{^Is_Block=	Ottoman_Siyaq_Numbers}', "");
    Expect(0, 126288, '\p{Is_Block=	Ottoman_Siyaq_Numbers}', "");
    Expect(1, 126288, '\p{^Is_Block=	Ottoman_Siyaq_Numbers}', "");
    Expect(1, 126288, '\P{Is_Block=	Ottoman_Siyaq_Numbers}', "");
    Expect(0, 126288, '\P{^Is_Block=	Ottoman_Siyaq_Numbers}', "");
    Error('\p{Is_Blk=:=OTTOMAN_siyaq_NUMBERS}');
    Error('\P{Is_Blk=:=OTTOMAN_siyaq_NUMBERS}');
    Expect(1, 126287, '\p{Is_Blk=ottomansiyaqnumbers}', "");
    Expect(0, 126287, '\p{^Is_Blk=ottomansiyaqnumbers}', "");
    Expect(0, 126287, '\P{Is_Blk=ottomansiyaqnumbers}', "");
    Expect(1, 126287, '\P{^Is_Blk=ottomansiyaqnumbers}', "");
    Expect(0, 126288, '\p{Is_Blk=ottomansiyaqnumbers}', "");
    Expect(1, 126288, '\p{^Is_Blk=ottomansiyaqnumbers}', "");
    Expect(1, 126288, '\P{Is_Blk=ottomansiyaqnumbers}', "");
    Expect(0, 126288, '\P{^Is_Blk=ottomansiyaqnumbers}', "");
    Expect(1, 126287, '\p{Is_Blk=-Ottoman_siyaq_Numbers}', "");
    Expect(0, 126287, '\p{^Is_Blk=-Ottoman_siyaq_Numbers}', "");
    Expect(0, 126287, '\P{Is_Blk=-Ottoman_siyaq_Numbers}', "");
    Expect(1, 126287, '\P{^Is_Blk=-Ottoman_siyaq_Numbers}', "");
    Expect(0, 126288, '\p{Is_Blk=-Ottoman_siyaq_Numbers}', "");
    Expect(1, 126288, '\p{^Is_Blk=-Ottoman_siyaq_Numbers}', "");
    Expect(1, 126288, '\P{Is_Blk=-Ottoman_siyaq_Numbers}', "");
    Expect(0, 126288, '\P{^Is_Blk=-Ottoman_siyaq_Numbers}', "");
    Error('\p{Block=-/a/pahawh_Hmong}');
    Error('\P{Block=-/a/pahawh_Hmong}');
    Expect(1, 93071, '\p{Block=:\APahawh_Hmong\z:}', "");;
    Expect(0, 93072, '\p{Block=:\APahawh_Hmong\z:}', "");;
    Expect(1, 93071, '\p{Block=pahawhhmong}', "");
    Expect(0, 93071, '\p{^Block=pahawhhmong}', "");
    Expect(0, 93071, '\P{Block=pahawhhmong}', "");
    Expect(1, 93071, '\P{^Block=pahawhhmong}', "");
    Expect(0, 93072, '\p{Block=pahawhhmong}', "");
    Expect(1, 93072, '\p{^Block=pahawhhmong}', "");
    Expect(1, 93072, '\P{Block=pahawhhmong}', "");
    Expect(0, 93072, '\P{^Block=pahawhhmong}', "");
    Expect(1, 93071, '\p{Block=:\Apahawhhmong\z:}', "");;
    Expect(0, 93072, '\p{Block=:\Apahawhhmong\z:}', "");;
    Expect(1, 93071, '\p{Block=	PAHAWH_Hmong}', "");
    Expect(0, 93071, '\p{^Block=	PAHAWH_Hmong}', "");
    Expect(0, 93071, '\P{Block=	PAHAWH_Hmong}', "");
    Expect(1, 93071, '\P{^Block=	PAHAWH_Hmong}', "");
    Expect(0, 93072, '\p{Block=	PAHAWH_Hmong}', "");
    Expect(1, 93072, '\p{^Block=	PAHAWH_Hmong}', "");
    Expect(1, 93072, '\P{Block=	PAHAWH_Hmong}', "");
    Expect(0, 93072, '\P{^Block=	PAHAWH_Hmong}', "");
    Error('\p{Blk=/a/pahawh_Hmong}');
    Error('\P{Blk=/a/pahawh_Hmong}');
    Expect(1, 93071, '\p{Blk=:\APahawh_Hmong\z:}', "");;
    Expect(0, 93072, '\p{Blk=:\APahawh_Hmong\z:}', "");;
    Expect(1, 93071, '\p{Blk=pahawhhmong}', "");
    Expect(0, 93071, '\p{^Blk=pahawhhmong}', "");
    Expect(0, 93071, '\P{Blk=pahawhhmong}', "");
    Expect(1, 93071, '\P{^Blk=pahawhhmong}', "");
    Expect(0, 93072, '\p{Blk=pahawhhmong}', "");
    Expect(1, 93072, '\p{^Blk=pahawhhmong}', "");
    Expect(1, 93072, '\P{Blk=pahawhhmong}', "");
    Expect(0, 93072, '\P{^Blk=pahawhhmong}', "");
    Expect(1, 93071, '\p{Blk=:\Apahawhhmong\z:}', "");;
    Expect(0, 93072, '\p{Blk=:\Apahawhhmong\z:}', "");;
    Expect(1, 93071, '\p{Blk: -_PAHAWH_hmong}', "");
    Expect(0, 93071, '\p{^Blk: -_PAHAWH_hmong}', "");
    Expect(0, 93071, '\P{Blk: -_PAHAWH_hmong}', "");
    Expect(1, 93071, '\P{^Blk: -_PAHAWH_hmong}', "");
    Expect(0, 93072, '\p{Blk: -_PAHAWH_hmong}', "");
    Expect(1, 93072, '\p{^Blk: -_PAHAWH_hmong}', "");
    Expect(1, 93072, '\P{Blk: -_PAHAWH_hmong}', "");
    Expect(0, 93072, '\P{^Blk: -_PAHAWH_hmong}', "");
    Error('\p{Is_Block= /a/Pahawh_HMONG}');
    Error('\P{Is_Block= /a/Pahawh_HMONG}');
    Expect(1, 93071, '\p{Is_Block=pahawhhmong}', "");
    Expect(0, 93071, '\p{^Is_Block=pahawhhmong}', "");
    Expect(0, 93071, '\P{Is_Block=pahawhhmong}', "");
    Expect(1, 93071, '\P{^Is_Block=pahawhhmong}', "");
    Expect(0, 93072, '\p{Is_Block=pahawhhmong}', "");
    Expect(1, 93072, '\p{^Is_Block=pahawhhmong}', "");
    Expect(1, 93072, '\P{Is_Block=pahawhhmong}', "");
    Expect(0, 93072, '\P{^Is_Block=pahawhhmong}', "");
    Expect(1, 93071, '\p{Is_Block= Pahawh_HMONG}', "");
    Expect(0, 93071, '\p{^Is_Block= Pahawh_HMONG}', "");
    Expect(0, 93071, '\P{Is_Block= Pahawh_HMONG}', "");
    Expect(1, 93071, '\P{^Is_Block= Pahawh_HMONG}', "");
    Expect(0, 93072, '\p{Is_Block= Pahawh_HMONG}', "");
    Expect(1, 93072, '\p{^Is_Block= Pahawh_HMONG}', "");
    Expect(1, 93072, '\P{Is_Block= Pahawh_HMONG}', "");
    Expect(0, 93072, '\P{^Is_Block= Pahawh_HMONG}', "");
    Error('\p{Is_Blk=_:=Pahawh_HMONG}');
    Error('\P{Is_Blk=_:=Pahawh_HMONG}');
    Expect(1, 93071, '\p{Is_Blk=pahawhhmong}', "");
    Expect(0, 93071, '\p{^Is_Blk=pahawhhmong}', "");
    Expect(0, 93071, '\P{Is_Blk=pahawhhmong}', "");
    Expect(1, 93071, '\P{^Is_Blk=pahawhhmong}', "");
    Expect(0, 93072, '\p{Is_Blk=pahawhhmong}', "");
    Expect(1, 93072, '\p{^Is_Blk=pahawhhmong}', "");
    Expect(1, 93072, '\P{Is_Blk=pahawhhmong}', "");
    Expect(0, 93072, '\P{^Is_Blk=pahawhhmong}', "");
    Expect(1, 93071, '\p{Is_Blk=		Pahawh_Hmong}', "");
    Expect(0, 93071, '\p{^Is_Blk=		Pahawh_Hmong}', "");
    Expect(0, 93071, '\P{Is_Blk=		Pahawh_Hmong}', "");
    Expect(1, 93071, '\P{^Is_Blk=		Pahawh_Hmong}', "");
    Expect(0, 93072, '\p{Is_Blk=		Pahawh_Hmong}', "");
    Expect(1, 93072, '\p{^Is_Blk=		Pahawh_Hmong}', "");
    Expect(1, 93072, '\P{Is_Blk=		Pahawh_Hmong}', "");
    Expect(0, 93072, '\P{^Is_Blk=		Pahawh_Hmong}', "");
    Error('\p{Block=-:=PALMYRENE}');
    Error('\P{Block=-:=PALMYRENE}');
    Expect(1, 67711, '\p{Block=:\APalmyrene\z:}', "");;
    Expect(0, 67712, '\p{Block=:\APalmyrene\z:}', "");;
    Expect(1, 67711, '\p{Block=palmyrene}', "");
    Expect(0, 67711, '\p{^Block=palmyrene}', "");
    Expect(0, 67711, '\P{Block=palmyrene}', "");
    Expect(1, 67711, '\P{^Block=palmyrene}', "");
    Expect(0, 67712, '\p{Block=palmyrene}', "");
    Expect(1, 67712, '\p{^Block=palmyrene}', "");
    Expect(1, 67712, '\P{Block=palmyrene}', "");
    Expect(0, 67712, '\P{^Block=palmyrene}', "");
    Expect(1, 67711, '\p{Block=:\Apalmyrene\z:}', "");;
    Expect(0, 67712, '\p{Block=:\Apalmyrene\z:}', "");;
    Expect(1, 67711, '\p{Block= palmyrene}', "");
    Expect(0, 67711, '\p{^Block= palmyrene}', "");
    Expect(0, 67711, '\P{Block= palmyrene}', "");
    Expect(1, 67711, '\P{^Block= palmyrene}', "");
    Expect(0, 67712, '\p{Block= palmyrene}', "");
    Expect(1, 67712, '\p{^Block= palmyrene}', "");
    Expect(1, 67712, '\P{Block= palmyrene}', "");
    Expect(0, 67712, '\P{^Block= palmyrene}', "");
    Error('\p{Blk=	:=Palmyrene}');
    Error('\P{Blk=	:=Palmyrene}');
    Expect(1, 67711, '\p{Blk=:\APalmyrene\z:}', "");;
    Expect(0, 67712, '\p{Blk=:\APalmyrene\z:}', "");;
    Expect(1, 67711, '\p{Blk=palmyrene}', "");
    Expect(0, 67711, '\p{^Blk=palmyrene}', "");
    Expect(0, 67711, '\P{Blk=palmyrene}', "");
    Expect(1, 67711, '\P{^Blk=palmyrene}', "");
    Expect(0, 67712, '\p{Blk=palmyrene}', "");
    Expect(1, 67712, '\p{^Blk=palmyrene}', "");
    Expect(1, 67712, '\P{Blk=palmyrene}', "");
    Expect(0, 67712, '\P{^Blk=palmyrene}', "");
    Expect(1, 67711, '\p{Blk=:\Apalmyrene\z:}', "");;
    Expect(0, 67712, '\p{Blk=:\Apalmyrene\z:}', "");;
    Expect(1, 67711, '\p{Blk= -Palmyrene}', "");
    Expect(0, 67711, '\p{^Blk= -Palmyrene}', "");
    Expect(0, 67711, '\P{Blk= -Palmyrene}', "");
    Expect(1, 67711, '\P{^Blk= -Palmyrene}', "");
    Expect(0, 67712, '\p{Blk= -Palmyrene}', "");
    Expect(1, 67712, '\p{^Blk= -Palmyrene}', "");
    Expect(1, 67712, '\P{Blk= -Palmyrene}', "");
    Expect(0, 67712, '\P{^Blk= -Palmyrene}', "");
    Error('\p{Is_Block=_	Palmyrene:=}');
    Error('\P{Is_Block=_	Palmyrene:=}');
    Expect(1, 67711, '\p{Is_Block:	palmyrene}', "");
    Expect(0, 67711, '\p{^Is_Block:	palmyrene}', "");
    Expect(0, 67711, '\P{Is_Block:	palmyrene}', "");
    Expect(1, 67711, '\P{^Is_Block:	palmyrene}', "");
    Expect(0, 67712, '\p{Is_Block:	palmyrene}', "");
    Expect(1, 67712, '\p{^Is_Block:	palmyrene}', "");
    Expect(1, 67712, '\P{Is_Block:	palmyrene}', "");
    Expect(0, 67712, '\P{^Is_Block:	palmyrene}', "");
    Expect(1, 67711, '\p{Is_Block=  Palmyrene}', "");
    Expect(0, 67711, '\p{^Is_Block=  Palmyrene}', "");
    Expect(0, 67711, '\P{Is_Block=  Palmyrene}', "");
    Expect(1, 67711, '\P{^Is_Block=  Palmyrene}', "");
    Expect(0, 67712, '\p{Is_Block=  Palmyrene}', "");
    Expect(1, 67712, '\p{^Is_Block=  Palmyrene}', "");
    Expect(1, 67712, '\P{Is_Block=  Palmyrene}', "");
    Expect(0, 67712, '\P{^Is_Block=  Palmyrene}', "");
    Error('\p{Is_Blk=__Palmyrene/a/}');
    Error('\P{Is_Blk=__Palmyrene/a/}');
    Expect(1, 67711, '\p{Is_Blk=palmyrene}', "");
    Expect(0, 67711, '\p{^Is_Blk=palmyrene}', "");
    Expect(0, 67711, '\P{Is_Blk=palmyrene}', "");
    Expect(1, 67711, '\P{^Is_Blk=palmyrene}', "");
    Expect(0, 67712, '\p{Is_Blk=palmyrene}', "");
    Expect(1, 67712, '\p{^Is_Blk=palmyrene}', "");
    Expect(1, 67712, '\P{Is_Blk=palmyrene}', "");
    Expect(0, 67712, '\P{^Is_Blk=palmyrene}', "");
    Expect(1, 67711, '\p{Is_Blk=-	palmyrene}', "");
    Expect(0, 67711, '\p{^Is_Blk=-	palmyrene}', "");
    Expect(0, 67711, '\P{Is_Blk=-	palmyrene}', "");
    Expect(1, 67711, '\P{^Is_Blk=-	palmyrene}', "");
    Expect(0, 67712, '\p{Is_Blk=-	palmyrene}', "");
    Expect(1, 67712, '\p{^Is_Blk=-	palmyrene}', "");
    Expect(1, 67712, '\P{Is_Blk=-	palmyrene}', "");
    Expect(0, 67712, '\P{^Is_Blk=-	palmyrene}', "");
    Error('\p{Block= /a/PAU_cin_Hau}');
    Error('\P{Block= /a/PAU_cin_Hau}');
    Expect(1, 72447, '\p{Block=:\APau_Cin_Hau\z:}', "");;
    Expect(0, 72448, '\p{Block=:\APau_Cin_Hau\z:}', "");;
    Expect(1, 72447, '\p{Block=paucinhau}', "");
    Expect(0, 72447, '\p{^Block=paucinhau}', "");
    Expect(0, 72447, '\P{Block=paucinhau}', "");
    Expect(1, 72447, '\P{^Block=paucinhau}', "");
    Expect(0, 72448, '\p{Block=paucinhau}', "");
    Expect(1, 72448, '\p{^Block=paucinhau}', "");
    Expect(1, 72448, '\P{Block=paucinhau}', "");
    Expect(0, 72448, '\P{^Block=paucinhau}', "");
    Expect(1, 72447, '\p{Block=:\Apaucinhau\z:}', "");;
    Expect(0, 72448, '\p{Block=:\Apaucinhau\z:}', "");;
    Expect(1, 72447, '\p{Block=	_pau_cin_Hau}', "");
    Expect(0, 72447, '\p{^Block=	_pau_cin_Hau}', "");
    Expect(0, 72447, '\P{Block=	_pau_cin_Hau}', "");
    Expect(1, 72447, '\P{^Block=	_pau_cin_Hau}', "");
    Expect(0, 72448, '\p{Block=	_pau_cin_Hau}', "");
    Expect(1, 72448, '\p{^Block=	_pau_cin_Hau}', "");
    Expect(1, 72448, '\P{Block=	_pau_cin_Hau}', "");
    Expect(0, 72448, '\P{^Block=	_pau_cin_Hau}', "");
    Error('\p{Blk=__Pau_cin_hau/a/}');
    Error('\P{Blk=__Pau_cin_hau/a/}');
    Expect(1, 72447, '\p{Blk=:\APau_Cin_Hau\z:}', "");;
    Expect(0, 72448, '\p{Blk=:\APau_Cin_Hau\z:}', "");;
    Expect(1, 72447, '\p{Blk=paucinhau}', "");
    Expect(0, 72447, '\p{^Blk=paucinhau}', "");
    Expect(0, 72447, '\P{Blk=paucinhau}', "");
    Expect(1, 72447, '\P{^Blk=paucinhau}', "");
    Expect(0, 72448, '\p{Blk=paucinhau}', "");
    Expect(1, 72448, '\p{^Blk=paucinhau}', "");
    Expect(1, 72448, '\P{Blk=paucinhau}', "");
    Expect(0, 72448, '\P{^Blk=paucinhau}', "");
    Expect(1, 72447, '\p{Blk=:\Apaucinhau\z:}', "");;
    Expect(0, 72448, '\p{Blk=:\Apaucinhau\z:}', "");;
    Expect(1, 72447, '\p{Blk=_pau_Cin_Hau}', "");
    Expect(0, 72447, '\p{^Blk=_pau_Cin_Hau}', "");
    Expect(0, 72447, '\P{Blk=_pau_Cin_Hau}', "");
    Expect(1, 72447, '\P{^Blk=_pau_Cin_Hau}', "");
    Expect(0, 72448, '\p{Blk=_pau_Cin_Hau}', "");
    Expect(1, 72448, '\p{^Blk=_pau_Cin_Hau}', "");
    Expect(1, 72448, '\P{Blk=_pau_Cin_Hau}', "");
    Expect(0, 72448, '\P{^Blk=_pau_Cin_Hau}', "");
    Error('\p{Is_Block= /a/pau_cin_Hau}');
    Error('\P{Is_Block= /a/pau_cin_Hau}');
    Expect(1, 72447, '\p{Is_Block=paucinhau}', "");
    Expect(0, 72447, '\p{^Is_Block=paucinhau}', "");
    Expect(0, 72447, '\P{Is_Block=paucinhau}', "");
    Expect(1, 72447, '\P{^Is_Block=paucinhau}', "");
    Expect(0, 72448, '\p{Is_Block=paucinhau}', "");
    Expect(1, 72448, '\p{^Is_Block=paucinhau}', "");
    Expect(1, 72448, '\P{Is_Block=paucinhau}', "");
    Expect(0, 72448, '\P{^Is_Block=paucinhau}', "");
    Expect(1, 72447, '\p{Is_Block=-	Pau_Cin_Hau}', "");
    Expect(0, 72447, '\p{^Is_Block=-	Pau_Cin_Hau}', "");
    Expect(0, 72447, '\P{Is_Block=-	Pau_Cin_Hau}', "");
    Expect(1, 72447, '\P{^Is_Block=-	Pau_Cin_Hau}', "");
    Expect(0, 72448, '\p{Is_Block=-	Pau_Cin_Hau}', "");
    Expect(1, 72448, '\p{^Is_Block=-	Pau_Cin_Hau}', "");
    Expect(1, 72448, '\P{Is_Block=-	Pau_Cin_Hau}', "");
    Expect(0, 72448, '\P{^Is_Block=-	Pau_Cin_Hau}', "");
    Error('\p{Is_Blk=/a/--Pau_Cin_hau}');
    Error('\P{Is_Blk=/a/--Pau_Cin_hau}');
    Expect(1, 72447, '\p{Is_Blk: paucinhau}', "");
    Expect(0, 72447, '\p{^Is_Blk: paucinhau}', "");
    Expect(0, 72447, '\P{Is_Blk: paucinhau}', "");
    Expect(1, 72447, '\P{^Is_Blk: paucinhau}', "");
    Expect(0, 72448, '\p{Is_Blk: paucinhau}', "");
    Expect(1, 72448, '\p{^Is_Blk: paucinhau}', "");
    Expect(1, 72448, '\P{Is_Blk: paucinhau}', "");
    Expect(0, 72448, '\P{^Is_Blk: paucinhau}', "");
    Expect(1, 72447, '\p{Is_Blk=	_Pau_Cin_HAU}', "");
    Expect(0, 72447, '\p{^Is_Blk=	_Pau_Cin_HAU}', "");
    Expect(0, 72447, '\P{Is_Blk=	_Pau_Cin_HAU}', "");
    Expect(1, 72447, '\P{^Is_Blk=	_Pau_Cin_HAU}', "");
    Expect(0, 72448, '\p{Is_Blk=	_Pau_Cin_HAU}', "");
    Expect(1, 72448, '\p{^Is_Blk=	_Pau_Cin_HAU}', "");
    Expect(1, 72448, '\P{Is_Blk=	_Pau_Cin_HAU}', "");
    Expect(0, 72448, '\P{^Is_Blk=	_Pau_Cin_HAU}', "");
    Error('\p{Block=:=phags_PA}');
    Error('\P{Block=:=phags_PA}');
    Expect(1, 43135, '\p{Block=:\APhags_Pa\z:}', "");;
    Expect(0, 43136, '\p{Block=:\APhags_Pa\z:}', "");;
    Expect(1, 43135, '\p{Block=phagspa}', "");
    Expect(0, 43135, '\p{^Block=phagspa}', "");
    Expect(0, 43135, '\P{Block=phagspa}', "");
    Expect(1, 43135, '\P{^Block=phagspa}', "");
    Expect(0, 43136, '\p{Block=phagspa}', "");
    Expect(1, 43136, '\p{^Block=phagspa}', "");
    Expect(1, 43136, '\P{Block=phagspa}', "");
    Expect(0, 43136, '\P{^Block=phagspa}', "");
    Expect(1, 43135, '\p{Block=:\Aphagspa\z:}', "");;
    Expect(0, 43136, '\p{Block=:\Aphagspa\z:}', "");;
    Expect(1, 43135, '\p{Block=_Phags_Pa}', "");
    Expect(0, 43135, '\p{^Block=_Phags_Pa}', "");
    Expect(0, 43135, '\P{Block=_Phags_Pa}', "");
    Expect(1, 43135, '\P{^Block=_Phags_Pa}', "");
    Expect(0, 43136, '\p{Block=_Phags_Pa}', "");
    Expect(1, 43136, '\p{^Block=_Phags_Pa}', "");
    Expect(1, 43136, '\P{Block=_Phags_Pa}', "");
    Expect(0, 43136, '\P{^Block=_Phags_Pa}', "");
    Error('\p{Blk=:=_phags_PA}');
    Error('\P{Blk=:=_phags_PA}');
    Expect(1, 43135, '\p{Blk=:\APhags_Pa\z:}', "");;
    Expect(0, 43136, '\p{Blk=:\APhags_Pa\z:}', "");;
    Expect(1, 43135, '\p{Blk=phagspa}', "");
    Expect(0, 43135, '\p{^Blk=phagspa}', "");
    Expect(0, 43135, '\P{Blk=phagspa}', "");
    Expect(1, 43135, '\P{^Blk=phagspa}', "");
    Expect(0, 43136, '\p{Blk=phagspa}', "");
    Expect(1, 43136, '\p{^Blk=phagspa}', "");
    Expect(1, 43136, '\P{Blk=phagspa}', "");
    Expect(0, 43136, '\P{^Blk=phagspa}', "");
    Expect(1, 43135, '\p{Blk=:\Aphagspa\z:}', "");;
    Expect(0, 43136, '\p{Blk=:\Aphagspa\z:}', "");;
    Expect(1, 43135, '\p{Blk=	PHAGS_PA}', "");
    Expect(0, 43135, '\p{^Blk=	PHAGS_PA}', "");
    Expect(0, 43135, '\P{Blk=	PHAGS_PA}', "");
    Expect(1, 43135, '\P{^Blk=	PHAGS_PA}', "");
    Expect(0, 43136, '\p{Blk=	PHAGS_PA}', "");
    Expect(1, 43136, '\p{^Blk=	PHAGS_PA}', "");
    Expect(1, 43136, '\P{Blk=	PHAGS_PA}', "");
    Expect(0, 43136, '\P{^Blk=	PHAGS_PA}', "");
    Error('\p{Is_Block=:=		PHAGS_Pa}');
    Error('\P{Is_Block=:=		PHAGS_Pa}');
    Expect(1, 43135, '\p{Is_Block:phagspa}', "");
    Expect(0, 43135, '\p{^Is_Block:phagspa}', "");
    Expect(0, 43135, '\P{Is_Block:phagspa}', "");
    Expect(1, 43135, '\P{^Is_Block:phagspa}', "");
    Expect(0, 43136, '\p{Is_Block:phagspa}', "");
    Expect(1, 43136, '\p{^Is_Block:phagspa}', "");
    Expect(1, 43136, '\P{Is_Block:phagspa}', "");
    Expect(0, 43136, '\P{^Is_Block:phagspa}', "");
    Expect(1, 43135, '\p{Is_Block=_Phags_pa}', "");
    Expect(0, 43135, '\p{^Is_Block=_Phags_pa}', "");
    Expect(0, 43135, '\P{Is_Block=_Phags_pa}', "");
    Expect(1, 43135, '\P{^Is_Block=_Phags_pa}', "");
    Expect(0, 43136, '\p{Is_Block=_Phags_pa}', "");
    Expect(1, 43136, '\p{^Is_Block=_Phags_pa}', "");
    Expect(1, 43136, '\P{Is_Block=_Phags_pa}', "");
    Expect(0, 43136, '\P{^Is_Block=_Phags_pa}', "");
    Error('\p{Is_Blk=_Phags_PA/a/}');
    Error('\P{Is_Blk=_Phags_PA/a/}');
    Expect(1, 43135, '\p{Is_Blk=phagspa}', "");
    Expect(0, 43135, '\p{^Is_Blk=phagspa}', "");
    Expect(0, 43135, '\P{Is_Blk=phagspa}', "");
    Expect(1, 43135, '\P{^Is_Blk=phagspa}', "");
    Expect(0, 43136, '\p{Is_Blk=phagspa}', "");
    Expect(1, 43136, '\p{^Is_Blk=phagspa}', "");
    Expect(1, 43136, '\P{Is_Blk=phagspa}', "");
    Expect(0, 43136, '\P{^Is_Blk=phagspa}', "");
    Expect(1, 43135, '\p{Is_Blk=Phags_pa}', "");
    Expect(0, 43135, '\p{^Is_Blk=Phags_pa}', "");
    Expect(0, 43135, '\P{Is_Blk=Phags_pa}', "");
    Expect(1, 43135, '\P{^Is_Blk=Phags_pa}', "");
    Expect(0, 43136, '\p{Is_Blk=Phags_pa}', "");
    Expect(1, 43136, '\p{^Is_Blk=Phags_pa}', "");
    Expect(1, 43136, '\P{Is_Blk=Phags_pa}', "");
    Expect(0, 43136, '\P{^Is_Blk=Phags_pa}', "");
    Error('\p{Block=_:=PHAISTOS_disc}');
    Error('\P{Block=_:=PHAISTOS_disc}');
    Expect(1, 66047, '\p{Block=:\APhaistos_Disc\z:}', "");;
    Expect(0, 66048, '\p{Block=:\APhaistos_Disc\z:}', "");;
    Expect(1, 66047, '\p{Block=phaistosdisc}', "");
    Expect(0, 66047, '\p{^Block=phaistosdisc}', "");
    Expect(0, 66047, '\P{Block=phaistosdisc}', "");
    Expect(1, 66047, '\P{^Block=phaistosdisc}', "");
    Expect(0, 66048, '\p{Block=phaistosdisc}', "");
    Expect(1, 66048, '\p{^Block=phaistosdisc}', "");
    Expect(1, 66048, '\P{Block=phaistosdisc}', "");
    Expect(0, 66048, '\P{^Block=phaistosdisc}', "");
    Expect(1, 66047, '\p{Block=:\Aphaistosdisc\z:}', "");;
    Expect(0, 66048, '\p{Block=:\Aphaistosdisc\z:}', "");;
    Expect(1, 66047, '\p{Block:	- Phaistos_DISC}', "");
    Expect(0, 66047, '\p{^Block:	- Phaistos_DISC}', "");
    Expect(0, 66047, '\P{Block:	- Phaistos_DISC}', "");
    Expect(1, 66047, '\P{^Block:	- Phaistos_DISC}', "");
    Expect(0, 66048, '\p{Block:	- Phaistos_DISC}', "");
    Expect(1, 66048, '\p{^Block:	- Phaistos_DISC}', "");
    Expect(1, 66048, '\P{Block:	- Phaistos_DISC}', "");
    Expect(0, 66048, '\P{^Block:	- Phaistos_DISC}', "");
    Error('\p{Blk=	:=phaistos}');
    Error('\P{Blk=	:=phaistos}');
    Expect(1, 66047, '\p{Blk=:\APhaistos\z:}', "");;
    Expect(0, 66048, '\p{Blk=:\APhaistos\z:}', "");;
    Expect(1, 66047, '\p{Blk=phaistos}', "");
    Expect(0, 66047, '\p{^Blk=phaistos}', "");
    Expect(0, 66047, '\P{Blk=phaistos}', "");
    Expect(1, 66047, '\P{^Blk=phaistos}', "");
    Expect(0, 66048, '\p{Blk=phaistos}', "");
    Expect(1, 66048, '\p{^Blk=phaistos}', "");
    Expect(1, 66048, '\P{Blk=phaistos}', "");
    Expect(0, 66048, '\P{^Blk=phaistos}', "");
    Expect(1, 66047, '\p{Blk=:\Aphaistos\z:}', "");;
    Expect(0, 66048, '\p{Blk=:\Aphaistos\z:}', "");;
    Expect(1, 66047, '\p{Blk=	_phaistos}', "");
    Expect(0, 66047, '\p{^Blk=	_phaistos}', "");
    Expect(0, 66047, '\P{Blk=	_phaistos}', "");
    Expect(1, 66047, '\P{^Blk=	_phaistos}', "");
    Expect(0, 66048, '\p{Blk=	_phaistos}', "");
    Expect(1, 66048, '\p{^Blk=	_phaistos}', "");
    Expect(1, 66048, '\P{Blk=	_phaistos}', "");
    Expect(0, 66048, '\P{^Blk=	_phaistos}', "");
    Error('\p{Is_Block:   _Phaistos_Disc:=}');
    Error('\P{Is_Block:   _Phaistos_Disc:=}');
    Expect(1, 66047, '\p{Is_Block=phaistosdisc}', "");
    Expect(0, 66047, '\p{^Is_Block=phaistosdisc}', "");
    Expect(0, 66047, '\P{Is_Block=phaistosdisc}', "");
    Expect(1, 66047, '\P{^Is_Block=phaistosdisc}', "");
    Expect(0, 66048, '\p{Is_Block=phaistosdisc}', "");
    Expect(1, 66048, '\p{^Is_Block=phaistosdisc}', "");
    Expect(1, 66048, '\P{Is_Block=phaistosdisc}', "");
    Expect(0, 66048, '\P{^Is_Block=phaistosdisc}', "");
    Expect(1, 66047, '\p{Is_Block=Phaistos_disc}', "");
    Expect(0, 66047, '\p{^Is_Block=Phaistos_disc}', "");
    Expect(0, 66047, '\P{Is_Block=Phaistos_disc}', "");
    Expect(1, 66047, '\P{^Is_Block=Phaistos_disc}', "");
    Expect(0, 66048, '\p{Is_Block=Phaistos_disc}', "");
    Expect(1, 66048, '\p{^Is_Block=Phaistos_disc}', "");
    Expect(1, 66048, '\P{Is_Block=Phaistos_disc}', "");
    Expect(0, 66048, '\P{^Is_Block=Phaistos_disc}', "");
    Error('\p{Is_Blk:   	Phaistos:=}');
    Error('\P{Is_Blk:   	Phaistos:=}');
    Expect(1, 66047, '\p{Is_Blk=phaistos}', "");
    Expect(0, 66047, '\p{^Is_Blk=phaistos}', "");
    Expect(0, 66047, '\P{Is_Blk=phaistos}', "");
    Expect(1, 66047, '\P{^Is_Blk=phaistos}', "");
    Expect(0, 66048, '\p{Is_Blk=phaistos}', "");
    Expect(1, 66048, '\p{^Is_Blk=phaistos}', "");
    Expect(1, 66048, '\P{Is_Blk=phaistos}', "");
    Expect(0, 66048, '\P{^Is_Blk=phaistos}', "");
    Expect(1, 66047, '\p{Is_Blk=Phaistos}', "");
    Expect(0, 66047, '\p{^Is_Blk=Phaistos}', "");
    Expect(0, 66047, '\P{Is_Blk=Phaistos}', "");
    Expect(1, 66047, '\P{^Is_Blk=Phaistos}', "");
    Expect(0, 66048, '\p{Is_Blk=Phaistos}', "");
    Expect(1, 66048, '\p{^Is_Blk=Phaistos}', "");
    Expect(1, 66048, '\P{Is_Blk=Phaistos}', "");
    Expect(0, 66048, '\P{^Is_Blk=Phaistos}', "");
    Error('\p{Block:   :=	_PHOENICIAN}');
    Error('\P{Block:   :=	_PHOENICIAN}');
    Expect(1, 67871, '\p{Block=:\APhoenician\z:}', "");;
    Expect(0, 67872, '\p{Block=:\APhoenician\z:}', "");;
    Expect(1, 67871, '\p{Block=phoenician}', "");
    Expect(0, 67871, '\p{^Block=phoenician}', "");
    Expect(0, 67871, '\P{Block=phoenician}', "");
    Expect(1, 67871, '\P{^Block=phoenician}', "");
    Expect(0, 67872, '\p{Block=phoenician}', "");
    Expect(1, 67872, '\p{^Block=phoenician}', "");
    Expect(1, 67872, '\P{Block=phoenician}', "");
    Expect(0, 67872, '\P{^Block=phoenician}', "");
    Expect(1, 67871, '\p{Block=:\Aphoenician\z:}', "");;
    Expect(0, 67872, '\p{Block=:\Aphoenician\z:}', "");;
    Expect(1, 67871, '\p{Block=-phoenician}', "");
    Expect(0, 67871, '\p{^Block=-phoenician}', "");
    Expect(0, 67871, '\P{Block=-phoenician}', "");
    Expect(1, 67871, '\P{^Block=-phoenician}', "");
    Expect(0, 67872, '\p{Block=-phoenician}', "");
    Expect(1, 67872, '\p{^Block=-phoenician}', "");
    Expect(1, 67872, '\P{Block=-phoenician}', "");
    Expect(0, 67872, '\P{^Block=-phoenician}', "");
    Error('\p{Blk=_phoenician/a/}');
    Error('\P{Blk=_phoenician/a/}');
    Expect(1, 67871, '\p{Blk=:\APhoenician\z:}', "");;
    Expect(0, 67872, '\p{Blk=:\APhoenician\z:}', "");;
    Expect(1, 67871, '\p{Blk=phoenician}', "");
    Expect(0, 67871, '\p{^Blk=phoenician}', "");
    Expect(0, 67871, '\P{Blk=phoenician}', "");
    Expect(1, 67871, '\P{^Blk=phoenician}', "");
    Expect(0, 67872, '\p{Blk=phoenician}', "");
    Expect(1, 67872, '\p{^Blk=phoenician}', "");
    Expect(1, 67872, '\P{Blk=phoenician}', "");
    Expect(0, 67872, '\P{^Blk=phoenician}', "");
    Expect(1, 67871, '\p{Blk=:\Aphoenician\z:}', "");;
    Expect(0, 67872, '\p{Blk=:\Aphoenician\z:}', "");;
    Expect(1, 67871, '\p{Blk=_phoenician}', "");
    Expect(0, 67871, '\p{^Blk=_phoenician}', "");
    Expect(0, 67871, '\P{Blk=_phoenician}', "");
    Expect(1, 67871, '\P{^Blk=_phoenician}', "");
    Expect(0, 67872, '\p{Blk=_phoenician}', "");
    Expect(1, 67872, '\p{^Blk=_phoenician}', "");
    Expect(1, 67872, '\P{Blk=_phoenician}', "");
    Expect(0, 67872, '\P{^Blk=_phoenician}', "");
    Error('\p{Is_Block=_-PHOENICIAN/a/}');
    Error('\P{Is_Block=_-PHOENICIAN/a/}');
    Expect(1, 67871, '\p{Is_Block:	phoenician}', "");
    Expect(0, 67871, '\p{^Is_Block:	phoenician}', "");
    Expect(0, 67871, '\P{Is_Block:	phoenician}', "");
    Expect(1, 67871, '\P{^Is_Block:	phoenician}', "");
    Expect(0, 67872, '\p{Is_Block:	phoenician}', "");
    Expect(1, 67872, '\p{^Is_Block:	phoenician}', "");
    Expect(1, 67872, '\P{Is_Block:	phoenician}', "");
    Expect(0, 67872, '\P{^Is_Block:	phoenician}', "");
    Expect(1, 67871, '\p{Is_Block=	-phoenician}', "");
    Expect(0, 67871, '\p{^Is_Block=	-phoenician}', "");
    Expect(0, 67871, '\P{Is_Block=	-phoenician}', "");
    Expect(1, 67871, '\P{^Is_Block=	-phoenician}', "");
    Expect(0, 67872, '\p{Is_Block=	-phoenician}', "");
    Expect(1, 67872, '\p{^Is_Block=	-phoenician}', "");
    Expect(1, 67872, '\P{Is_Block=	-phoenician}', "");
    Expect(0, 67872, '\P{^Is_Block=	-phoenician}', "");
    Error('\p{Is_Blk=-Phoenician:=}');
    Error('\P{Is_Blk=-Phoenician:=}');
    Expect(1, 67871, '\p{Is_Blk=phoenician}', "");
    Expect(0, 67871, '\p{^Is_Blk=phoenician}', "");
    Expect(0, 67871, '\P{Is_Blk=phoenician}', "");
    Expect(1, 67871, '\P{^Is_Blk=phoenician}', "");
    Expect(0, 67872, '\p{Is_Blk=phoenician}', "");
    Expect(1, 67872, '\p{^Is_Blk=phoenician}', "");
    Expect(1, 67872, '\P{Is_Blk=phoenician}', "");
    Expect(0, 67872, '\P{^Is_Blk=phoenician}', "");
    Expect(1, 67871, '\p{Is_Blk:   _Phoenician}', "");
    Expect(0, 67871, '\p{^Is_Blk:   _Phoenician}', "");
    Expect(0, 67871, '\P{Is_Blk:   _Phoenician}', "");
    Expect(1, 67871, '\P{^Is_Blk:   _Phoenician}', "");
    Expect(0, 67872, '\p{Is_Blk:   _Phoenician}', "");
    Expect(1, 67872, '\p{^Is_Blk:   _Phoenician}', "");
    Expect(1, 67872, '\P{Is_Blk:   _Phoenician}', "");
    Expect(0, 67872, '\P{^Is_Blk:   _Phoenician}', "");
    Error('\p{Block=phonetic_extensions:=}');
    Error('\P{Block=phonetic_extensions:=}');
    Expect(1, 7551, '\p{Block=:\APhonetic_Extensions\z:}', "");;
    Expect(0, 7552, '\p{Block=:\APhonetic_Extensions\z:}', "");;
    Expect(1, 7551, '\p{Block=phoneticextensions}', "");
    Expect(0, 7551, '\p{^Block=phoneticextensions}', "");
    Expect(0, 7551, '\P{Block=phoneticextensions}', "");
    Expect(1, 7551, '\P{^Block=phoneticextensions}', "");
    Expect(0, 7552, '\p{Block=phoneticextensions}', "");
    Expect(1, 7552, '\p{^Block=phoneticextensions}', "");
    Expect(1, 7552, '\P{Block=phoneticextensions}', "");
    Expect(0, 7552, '\P{^Block=phoneticextensions}', "");
    Expect(1, 7551, '\p{Block=:\Aphoneticextensions\z:}', "");;
    Expect(0, 7552, '\p{Block=:\Aphoneticextensions\z:}', "");;
    Expect(1, 7551, '\p{Block= 	phonetic_extensions}', "");
    Expect(0, 7551, '\p{^Block= 	phonetic_extensions}', "");
    Expect(0, 7551, '\P{Block= 	phonetic_extensions}', "");
    Expect(1, 7551, '\P{^Block= 	phonetic_extensions}', "");
    Expect(0, 7552, '\p{Block= 	phonetic_extensions}', "");
    Expect(1, 7552, '\p{^Block= 	phonetic_extensions}', "");
    Expect(1, 7552, '\P{Block= 	phonetic_extensions}', "");
    Expect(0, 7552, '\P{^Block= 	phonetic_extensions}', "");
    Error('\p{Blk=/a/_ Phonetic_EXT}');
    Error('\P{Blk=/a/_ Phonetic_EXT}');
    Expect(1, 7551, '\p{Blk=:\APhonetic_Ext\z:}', "");;
    Expect(0, 7552, '\p{Blk=:\APhonetic_Ext\z:}', "");;
    Expect(1, 7551, '\p{Blk=phoneticext}', "");
    Expect(0, 7551, '\p{^Blk=phoneticext}', "");
    Expect(0, 7551, '\P{Blk=phoneticext}', "");
    Expect(1, 7551, '\P{^Blk=phoneticext}', "");
    Expect(0, 7552, '\p{Blk=phoneticext}', "");
    Expect(1, 7552, '\p{^Blk=phoneticext}', "");
    Expect(1, 7552, '\P{Blk=phoneticext}', "");
    Expect(0, 7552, '\P{^Blk=phoneticext}', "");
    Expect(1, 7551, '\p{Blk=:\Aphoneticext\z:}', "");;
    Expect(0, 7552, '\p{Blk=:\Aphoneticext\z:}', "");;
    Expect(1, 7551, '\p{Blk=	 PHONETIC_EXT}', "");
    Expect(0, 7551, '\p{^Blk=	 PHONETIC_EXT}', "");
    Expect(0, 7551, '\P{Blk=	 PHONETIC_EXT}', "");
    Expect(1, 7551, '\P{^Blk=	 PHONETIC_EXT}', "");
    Expect(0, 7552, '\p{Blk=	 PHONETIC_EXT}', "");
    Expect(1, 7552, '\p{^Blk=	 PHONETIC_EXT}', "");
    Expect(1, 7552, '\P{Blk=	 PHONETIC_EXT}', "");
    Expect(0, 7552, '\P{^Blk=	 PHONETIC_EXT}', "");
    Error('\p{Is_Block=:=_Phonetic_Extensions}');
    Error('\P{Is_Block=:=_Phonetic_Extensions}');
    Expect(1, 7551, '\p{Is_Block=phoneticextensions}', "");
    Expect(0, 7551, '\p{^Is_Block=phoneticextensions}', "");
    Expect(0, 7551, '\P{Is_Block=phoneticextensions}', "");
    Expect(1, 7551, '\P{^Is_Block=phoneticextensions}', "");
    Expect(0, 7552, '\p{Is_Block=phoneticextensions}', "");
    Expect(1, 7552, '\p{^Is_Block=phoneticextensions}', "");
    Expect(1, 7552, '\P{Is_Block=phoneticextensions}', "");
    Expect(0, 7552, '\P{^Is_Block=phoneticextensions}', "");
    Expect(1, 7551, '\p{Is_Block=_	PHONETIC_extensions}', "");
    Expect(0, 7551, '\p{^Is_Block=_	PHONETIC_extensions}', "");
    Expect(0, 7551, '\P{Is_Block=_	PHONETIC_extensions}', "");
    Expect(1, 7551, '\P{^Is_Block=_	PHONETIC_extensions}', "");
    Expect(0, 7552, '\p{Is_Block=_	PHONETIC_extensions}', "");
    Expect(1, 7552, '\p{^Is_Block=_	PHONETIC_extensions}', "");
    Expect(1, 7552, '\P{Is_Block=_	PHONETIC_extensions}', "");
    Expect(0, 7552, '\P{^Is_Block=_	PHONETIC_extensions}', "");
    Error('\p{Is_Blk::=_-phonetic_Ext}');
    Error('\P{Is_Blk::=_-phonetic_Ext}');
    Expect(1, 7551, '\p{Is_Blk=phoneticext}', "");
    Expect(0, 7551, '\p{^Is_Blk=phoneticext}', "");
    Expect(0, 7551, '\P{Is_Blk=phoneticext}', "");
    Expect(1, 7551, '\P{^Is_Blk=phoneticext}', "");
    Expect(0, 7552, '\p{Is_Blk=phoneticext}', "");
    Expect(1, 7552, '\p{^Is_Blk=phoneticext}', "");
    Expect(1, 7552, '\P{Is_Blk=phoneticext}', "");
    Expect(0, 7552, '\P{^Is_Blk=phoneticext}', "");
    Expect(1, 7551, '\p{Is_Blk= 	phonetic_EXT}', "");
    Expect(0, 7551, '\p{^Is_Blk= 	phonetic_EXT}', "");
    Expect(0, 7551, '\P{Is_Blk= 	phonetic_EXT}', "");
    Expect(1, 7551, '\P{^Is_Blk= 	phonetic_EXT}', "");
    Expect(0, 7552, '\p{Is_Blk= 	phonetic_EXT}', "");
    Expect(1, 7552, '\p{^Is_Blk= 	phonetic_EXT}', "");
    Expect(1, 7552, '\P{Is_Blk= 	phonetic_EXT}', "");
    Expect(0, 7552, '\P{^Is_Blk= 	phonetic_EXT}', "");
    Error('\p{Block=_:=Phonetic_Extensions_Supplement}');
    Error('\P{Block=_:=Phonetic_Extensions_Supplement}');
    Expect(1, 7615, '\p{Block=:\APhonetic_Extensions_Supplement\z:}', "");;
    Expect(0, 7616, '\p{Block=:\APhonetic_Extensions_Supplement\z:}', "");;
    Expect(1, 7615, '\p{Block:phoneticextensionssupplement}', "");
    Expect(0, 7615, '\p{^Block:phoneticextensionssupplement}', "");
    Expect(0, 7615, '\P{Block:phoneticextensionssupplement}', "");
    Expect(1, 7615, '\P{^Block:phoneticextensionssupplement}', "");
    Expect(0, 7616, '\p{Block:phoneticextensionssupplement}', "");
    Expect(1, 7616, '\p{^Block:phoneticextensionssupplement}', "");
    Expect(1, 7616, '\P{Block:phoneticextensionssupplement}', "");
    Expect(0, 7616, '\P{^Block:phoneticextensionssupplement}', "");
    Expect(1, 7615, '\p{Block=:\Aphoneticextensionssupplement\z:}', "");;
    Expect(0, 7616, '\p{Block=:\Aphoneticextensionssupplement\z:}', "");;
    Expect(1, 7615, '\p{Block=_-PHONETIC_Extensions_Supplement}', "");
    Expect(0, 7615, '\p{^Block=_-PHONETIC_Extensions_Supplement}', "");
    Expect(0, 7615, '\P{Block=_-PHONETIC_Extensions_Supplement}', "");
    Expect(1, 7615, '\P{^Block=_-PHONETIC_Extensions_Supplement}', "");
    Expect(0, 7616, '\p{Block=_-PHONETIC_Extensions_Supplement}', "");
    Expect(1, 7616, '\p{^Block=_-PHONETIC_Extensions_Supplement}', "");
    Expect(1, 7616, '\P{Block=_-PHONETIC_Extensions_Supplement}', "");
    Expect(0, 7616, '\P{^Block=_-PHONETIC_Extensions_Supplement}', "");
    Error('\p{Blk=_	phonetic_ext_Sup/a/}');
    Error('\P{Blk=_	phonetic_ext_Sup/a/}');
    Expect(1, 7615, '\p{Blk=:\APhonetic_Ext_Sup\z:}', "");;
    Expect(0, 7616, '\p{Blk=:\APhonetic_Ext_Sup\z:}', "");;
    Expect(1, 7615, '\p{Blk=phoneticextsup}', "");
    Expect(0, 7615, '\p{^Blk=phoneticextsup}', "");
    Expect(0, 7615, '\P{Blk=phoneticextsup}', "");
    Expect(1, 7615, '\P{^Blk=phoneticextsup}', "");
    Expect(0, 7616, '\p{Blk=phoneticextsup}', "");
    Expect(1, 7616, '\p{^Blk=phoneticextsup}', "");
    Expect(1, 7616, '\P{Blk=phoneticextsup}', "");
    Expect(0, 7616, '\P{^Blk=phoneticextsup}', "");
    Expect(1, 7615, '\p{Blk=:\Aphoneticextsup\z:}', "");;
    Expect(0, 7616, '\p{Blk=:\Aphoneticextsup\z:}', "");;
    Expect(1, 7615, '\p{Blk=	_Phonetic_Ext_sup}', "");
    Expect(0, 7615, '\p{^Blk=	_Phonetic_Ext_sup}', "");
    Expect(0, 7615, '\P{Blk=	_Phonetic_Ext_sup}', "");
    Expect(1, 7615, '\P{^Blk=	_Phonetic_Ext_sup}', "");
    Expect(0, 7616, '\p{Blk=	_Phonetic_Ext_sup}', "");
    Expect(1, 7616, '\p{^Blk=	_Phonetic_Ext_sup}', "");
    Expect(1, 7616, '\P{Blk=	_Phonetic_Ext_sup}', "");
    Expect(0, 7616, '\P{^Blk=	_Phonetic_Ext_sup}', "");
    Error('\p{Is_Block=/a/ _Phonetic_extensions_supplement}');
    Error('\P{Is_Block=/a/ _Phonetic_extensions_supplement}');
    Expect(1, 7615, '\p{Is_Block=phoneticextensionssupplement}', "");
    Expect(0, 7615, '\p{^Is_Block=phoneticextensionssupplement}', "");
    Expect(0, 7615, '\P{Is_Block=phoneticextensionssupplement}', "");
    Expect(1, 7615, '\P{^Is_Block=phoneticextensionssupplement}', "");
    Expect(0, 7616, '\p{Is_Block=phoneticextensionssupplement}', "");
    Expect(1, 7616, '\p{^Is_Block=phoneticextensionssupplement}', "");
    Expect(1, 7616, '\P{Is_Block=phoneticextensionssupplement}', "");
    Expect(0, 7616, '\P{^Is_Block=phoneticextensionssupplement}', "");
    Expect(1, 7615, '\p{Is_Block=-PHONETIC_EXTENSIONS_Supplement}', "");
    Expect(0, 7615, '\p{^Is_Block=-PHONETIC_EXTENSIONS_Supplement}', "");
    Expect(0, 7615, '\P{Is_Block=-PHONETIC_EXTENSIONS_Supplement}', "");
    Expect(1, 7615, '\P{^Is_Block=-PHONETIC_EXTENSIONS_Supplement}', "");
    Expect(0, 7616, '\p{Is_Block=-PHONETIC_EXTENSIONS_Supplement}', "");
    Expect(1, 7616, '\p{^Is_Block=-PHONETIC_EXTENSIONS_Supplement}', "");
    Expect(1, 7616, '\P{Is_Block=-PHONETIC_EXTENSIONS_Supplement}', "");
    Expect(0, 7616, '\P{^Is_Block=-PHONETIC_EXTENSIONS_Supplement}', "");
    Error('\p{Is_Blk=/a/	-Phonetic_EXT_Sup}');
    Error('\P{Is_Blk=/a/	-Phonetic_EXT_Sup}');
    Expect(1, 7615, '\p{Is_Blk=phoneticextsup}', "");
    Expect(0, 7615, '\p{^Is_Blk=phoneticextsup}', "");
    Expect(0, 7615, '\P{Is_Blk=phoneticextsup}', "");
    Expect(1, 7615, '\P{^Is_Blk=phoneticextsup}', "");
    Expect(0, 7616, '\p{Is_Blk=phoneticextsup}', "");
    Expect(1, 7616, '\p{^Is_Blk=phoneticextsup}', "");
    Expect(1, 7616, '\P{Is_Blk=phoneticextsup}', "");
    Expect(0, 7616, '\P{^Is_Blk=phoneticextsup}', "");
    Expect(1, 7615, '\p{Is_Blk=phonetic_ext_Sup}', "");
    Expect(0, 7615, '\p{^Is_Blk=phonetic_ext_Sup}', "");
    Expect(0, 7615, '\P{Is_Blk=phonetic_ext_Sup}', "");
    Expect(1, 7615, '\P{^Is_Blk=phonetic_ext_Sup}', "");
    Expect(0, 7616, '\p{Is_Blk=phonetic_ext_Sup}', "");
    Expect(1, 7616, '\p{^Is_Blk=phonetic_ext_Sup}', "");
    Expect(1, 7616, '\P{Is_Blk=phonetic_ext_Sup}', "");
    Expect(0, 7616, '\P{^Is_Blk=phonetic_ext_Sup}', "");
    Error('\p{Block=	_playing_cards:=}');
    Error('\P{Block=	_playing_cards:=}');
    Expect(1, 127231, '\p{Block=:\APlaying_Cards\z:}', "");;
    Expect(0, 127232, '\p{Block=:\APlaying_Cards\z:}', "");;
    Expect(1, 127231, '\p{Block=playingcards}', "");
    Expect(0, 127231, '\p{^Block=playingcards}', "");
    Expect(0, 127231, '\P{Block=playingcards}', "");
    Expect(1, 127231, '\P{^Block=playingcards}', "");
    Expect(0, 127232, '\p{Block=playingcards}', "");
    Expect(1, 127232, '\p{^Block=playingcards}', "");
    Expect(1, 127232, '\P{Block=playingcards}', "");
    Expect(0, 127232, '\P{^Block=playingcards}', "");
    Expect(1, 127231, '\p{Block=:\Aplayingcards\z:}', "");;
    Expect(0, 127232, '\p{Block=:\Aplayingcards\z:}', "");;
    Expect(1, 127231, '\p{Block=-_Playing_Cards}', "");
    Expect(0, 127231, '\p{^Block=-_Playing_Cards}', "");
    Expect(0, 127231, '\P{Block=-_Playing_Cards}', "");
    Expect(1, 127231, '\P{^Block=-_Playing_Cards}', "");
    Expect(0, 127232, '\p{Block=-_Playing_Cards}', "");
    Expect(1, 127232, '\p{^Block=-_Playing_Cards}', "");
    Expect(1, 127232, '\P{Block=-_Playing_Cards}', "");
    Expect(0, 127232, '\P{^Block=-_Playing_Cards}', "");
    Error('\p{Blk= _PLAYING_Cards:=}');
    Error('\P{Blk= _PLAYING_Cards:=}');
    Expect(1, 127231, '\p{Blk=:\APlaying_Cards\z:}', "");;
    Expect(0, 127232, '\p{Blk=:\APlaying_Cards\z:}', "");;
    Expect(1, 127231, '\p{Blk:	playingcards}', "");
    Expect(0, 127231, '\p{^Blk:	playingcards}', "");
    Expect(0, 127231, '\P{Blk:	playingcards}', "");
    Expect(1, 127231, '\P{^Blk:	playingcards}', "");
    Expect(0, 127232, '\p{Blk:	playingcards}', "");
    Expect(1, 127232, '\p{^Blk:	playingcards}', "");
    Expect(1, 127232, '\P{Blk:	playingcards}', "");
    Expect(0, 127232, '\P{^Blk:	playingcards}', "");
    Expect(1, 127231, '\p{Blk=:\Aplayingcards\z:}', "");;
    Expect(0, 127232, '\p{Blk=:\Aplayingcards\z:}', "");;
    Expect(1, 127231, '\p{Blk=_-PLAYING_cards}', "");
    Expect(0, 127231, '\p{^Blk=_-PLAYING_cards}', "");
    Expect(0, 127231, '\P{Blk=_-PLAYING_cards}', "");
    Expect(1, 127231, '\P{^Blk=_-PLAYING_cards}', "");
    Expect(0, 127232, '\p{Blk=_-PLAYING_cards}', "");
    Expect(1, 127232, '\p{^Blk=_-PLAYING_cards}', "");
    Expect(1, 127232, '\P{Blk=_-PLAYING_cards}', "");
    Expect(0, 127232, '\P{^Blk=_-PLAYING_cards}', "");
    Error('\p{Is_Block=__PLAYING_cards:=}');
    Error('\P{Is_Block=__PLAYING_cards:=}');
    Expect(1, 127231, '\p{Is_Block=playingcards}', "");
    Expect(0, 127231, '\p{^Is_Block=playingcards}', "");
    Expect(0, 127231, '\P{Is_Block=playingcards}', "");
    Expect(1, 127231, '\P{^Is_Block=playingcards}', "");
    Expect(0, 127232, '\p{Is_Block=playingcards}', "");
    Expect(1, 127232, '\p{^Is_Block=playingcards}', "");
    Expect(1, 127232, '\P{Is_Block=playingcards}', "");
    Expect(0, 127232, '\P{^Is_Block=playingcards}', "");
    Expect(1, 127231, '\p{Is_Block: PLAYING_Cards}', "");
    Expect(0, 127231, '\p{^Is_Block: PLAYING_Cards}', "");
    Expect(0, 127231, '\P{Is_Block: PLAYING_Cards}', "");
    Expect(1, 127231, '\P{^Is_Block: PLAYING_Cards}', "");
    Expect(0, 127232, '\p{Is_Block: PLAYING_Cards}', "");
    Expect(1, 127232, '\p{^Is_Block: PLAYING_Cards}', "");
    Expect(1, 127232, '\P{Is_Block: PLAYING_Cards}', "");
    Expect(0, 127232, '\P{^Is_Block: PLAYING_Cards}', "");
    Error('\p{Is_Blk=:=_	PLAYING_CARDS}');
    Error('\P{Is_Blk=:=_	PLAYING_CARDS}');
    Expect(1, 127231, '\p{Is_Blk=playingcards}', "");
    Expect(0, 127231, '\p{^Is_Blk=playingcards}', "");
    Expect(0, 127231, '\P{Is_Blk=playingcards}', "");
    Expect(1, 127231, '\P{^Is_Blk=playingcards}', "");
    Expect(0, 127232, '\p{Is_Blk=playingcards}', "");
    Expect(1, 127232, '\p{^Is_Blk=playingcards}', "");
    Expect(1, 127232, '\P{Is_Blk=playingcards}', "");
    Expect(0, 127232, '\P{^Is_Blk=playingcards}', "");
    Expect(1, 127231, '\p{Is_Blk=		Playing_Cards}', "");
    Expect(0, 127231, '\p{^Is_Blk=		Playing_Cards}', "");
    Expect(0, 127231, '\P{Is_Blk=		Playing_Cards}', "");
    Expect(1, 127231, '\P{^Is_Blk=		Playing_Cards}', "");
    Expect(0, 127232, '\p{Is_Blk=		Playing_Cards}', "");
    Expect(1, 127232, '\p{^Is_Blk=		Playing_Cards}', "");
    Expect(1, 127232, '\P{Is_Blk=		Playing_Cards}', "");
    Expect(0, 127232, '\P{^Is_Blk=		Playing_Cards}', "");
    Error('\p{Block:		 PSALTER_Pahlavi:=}');
    Error('\P{Block:		 PSALTER_Pahlavi:=}');
    Expect(1, 68527, '\p{Block=:\APsalter_Pahlavi\z:}', "");;
    Expect(0, 68528, '\p{Block=:\APsalter_Pahlavi\z:}', "");;
    Expect(1, 68527, '\p{Block=psalterpahlavi}', "");
    Expect(0, 68527, '\p{^Block=psalterpahlavi}', "");
    Expect(0, 68527, '\P{Block=psalterpahlavi}', "");
    Expect(1, 68527, '\P{^Block=psalterpahlavi}', "");
    Expect(0, 68528, '\p{Block=psalterpahlavi}', "");
    Expect(1, 68528, '\p{^Block=psalterpahlavi}', "");
    Expect(1, 68528, '\P{Block=psalterpahlavi}', "");
    Expect(0, 68528, '\P{^Block=psalterpahlavi}', "");
    Expect(1, 68527, '\p{Block=:\Apsalterpahlavi\z:}', "");;
    Expect(0, 68528, '\p{Block=:\Apsalterpahlavi\z:}', "");;
    Expect(1, 68527, '\p{Block=  Psalter_Pahlavi}', "");
    Expect(0, 68527, '\p{^Block=  Psalter_Pahlavi}', "");
    Expect(0, 68527, '\P{Block=  Psalter_Pahlavi}', "");
    Expect(1, 68527, '\P{^Block=  Psalter_Pahlavi}', "");
    Expect(0, 68528, '\p{Block=  Psalter_Pahlavi}', "");
    Expect(1, 68528, '\p{^Block=  Psalter_Pahlavi}', "");
    Expect(1, 68528, '\P{Block=  Psalter_Pahlavi}', "");
    Expect(0, 68528, '\P{^Block=  Psalter_Pahlavi}', "");
    Error('\p{Blk= /a/PSALTER_Pahlavi}');
    Error('\P{Blk= /a/PSALTER_Pahlavi}');
    Expect(1, 68527, '\p{Blk=:\APsalter_Pahlavi\z:}', "");;
    Expect(0, 68528, '\p{Blk=:\APsalter_Pahlavi\z:}', "");;
    Expect(1, 68527, '\p{Blk=psalterpahlavi}', "");
    Expect(0, 68527, '\p{^Blk=psalterpahlavi}', "");
    Expect(0, 68527, '\P{Blk=psalterpahlavi}', "");
    Expect(1, 68527, '\P{^Blk=psalterpahlavi}', "");
    Expect(0, 68528, '\p{Blk=psalterpahlavi}', "");
    Expect(1, 68528, '\p{^Blk=psalterpahlavi}', "");
    Expect(1, 68528, '\P{Blk=psalterpahlavi}', "");
    Expect(0, 68528, '\P{^Blk=psalterpahlavi}', "");
    Expect(1, 68527, '\p{Blk=:\Apsalterpahlavi\z:}', "");;
    Expect(0, 68528, '\p{Blk=:\Apsalterpahlavi\z:}', "");;
    Expect(1, 68527, '\p{Blk= Psalter_Pahlavi}', "");
    Expect(0, 68527, '\p{^Blk= Psalter_Pahlavi}', "");
    Expect(0, 68527, '\P{Blk= Psalter_Pahlavi}', "");
    Expect(1, 68527, '\P{^Blk= Psalter_Pahlavi}', "");
    Expect(0, 68528, '\p{Blk= Psalter_Pahlavi}', "");
    Expect(1, 68528, '\p{^Blk= Psalter_Pahlavi}', "");
    Expect(1, 68528, '\P{Blk= Psalter_Pahlavi}', "");
    Expect(0, 68528, '\P{^Blk= Psalter_Pahlavi}', "");
    Error('\p{Is_Block=	-Psalter_Pahlavi:=}');
    Error('\P{Is_Block=	-Psalter_Pahlavi:=}');
    Expect(1, 68527, '\p{Is_Block=psalterpahlavi}', "");
    Expect(0, 68527, '\p{^Is_Block=psalterpahlavi}', "");
    Expect(0, 68527, '\P{Is_Block=psalterpahlavi}', "");
    Expect(1, 68527, '\P{^Is_Block=psalterpahlavi}', "");
    Expect(0, 68528, '\p{Is_Block=psalterpahlavi}', "");
    Expect(1, 68528, '\p{^Is_Block=psalterpahlavi}', "");
    Expect(1, 68528, '\P{Is_Block=psalterpahlavi}', "");
    Expect(0, 68528, '\P{^Is_Block=psalterpahlavi}', "");
    Expect(1, 68527, '\p{Is_Block=_-Psalter_Pahlavi}', "");
    Expect(0, 68527, '\p{^Is_Block=_-Psalter_Pahlavi}', "");
    Expect(0, 68527, '\P{Is_Block=_-Psalter_Pahlavi}', "");
    Expect(1, 68527, '\P{^Is_Block=_-Psalter_Pahlavi}', "");
    Expect(0, 68528, '\p{Is_Block=_-Psalter_Pahlavi}', "");
    Expect(1, 68528, '\p{^Is_Block=_-Psalter_Pahlavi}', "");
    Expect(1, 68528, '\P{Is_Block=_-Psalter_Pahlavi}', "");
    Expect(0, 68528, '\P{^Is_Block=_-Psalter_Pahlavi}', "");
    Error('\p{Is_Blk:	:=Psalter_Pahlavi}');
    Error('\P{Is_Blk:	:=Psalter_Pahlavi}');
    Expect(1, 68527, '\p{Is_Blk=psalterpahlavi}', "");
    Expect(0, 68527, '\p{^Is_Blk=psalterpahlavi}', "");
    Expect(0, 68527, '\P{Is_Blk=psalterpahlavi}', "");
    Expect(1, 68527, '\P{^Is_Blk=psalterpahlavi}', "");
    Expect(0, 68528, '\p{Is_Blk=psalterpahlavi}', "");
    Expect(1, 68528, '\p{^Is_Blk=psalterpahlavi}', "");
    Expect(1, 68528, '\P{Is_Blk=psalterpahlavi}', "");
    Expect(0, 68528, '\P{^Is_Blk=psalterpahlavi}', "");
    Expect(1, 68527, '\p{Is_Blk=--psalter_PAHLAVI}', "");
    Expect(0, 68527, '\p{^Is_Blk=--psalter_PAHLAVI}', "");
    Expect(0, 68527, '\P{Is_Blk=--psalter_PAHLAVI}', "");
    Expect(1, 68527, '\P{^Is_Blk=--psalter_PAHLAVI}', "");
    Expect(0, 68528, '\p{Is_Blk=--psalter_PAHLAVI}', "");
    Expect(1, 68528, '\p{^Is_Blk=--psalter_PAHLAVI}', "");
    Expect(1, 68528, '\P{Is_Blk=--psalter_PAHLAVI}', "");
    Expect(0, 68528, '\P{^Is_Blk=--psalter_PAHLAVI}', "");
    Error('\p{Block=-:=Private_use_Area}');
    Error('\P{Block=-:=Private_use_Area}');
    Expect(1, 63743, '\p{Block=:\APrivate_Use_Area\z:}', "");;
    Expect(0, 63744, '\p{Block=:\APrivate_Use_Area\z:}', "");;
    Expect(1, 63743, '\p{Block=privateusearea}', "");
    Expect(0, 63743, '\p{^Block=privateusearea}', "");
    Expect(0, 63743, '\P{Block=privateusearea}', "");
    Expect(1, 63743, '\P{^Block=privateusearea}', "");
    Expect(0, 63744, '\p{Block=privateusearea}', "");
    Expect(1, 63744, '\p{^Block=privateusearea}', "");
    Expect(1, 63744, '\P{Block=privateusearea}', "");
    Expect(0, 63744, '\P{^Block=privateusearea}', "");
    Expect(1, 63743, '\p{Block=:\Aprivateusearea\z:}', "");;
    Expect(0, 63744, '\p{Block=:\Aprivateusearea\z:}', "");;
    Expect(1, 63743, '\p{Block=  private_Use_AREA}', "");
    Expect(0, 63743, '\p{^Block=  private_Use_AREA}', "");
    Expect(0, 63743, '\P{Block=  private_Use_AREA}', "");
    Expect(1, 63743, '\P{^Block=  private_Use_AREA}', "");
    Expect(0, 63744, '\p{Block=  private_Use_AREA}', "");
    Expect(1, 63744, '\p{^Block=  private_Use_AREA}', "");
    Expect(1, 63744, '\P{Block=  private_Use_AREA}', "");
    Expect(0, 63744, '\P{^Block=  private_Use_AREA}', "");
    Error('\p{Blk=_-PUA/a/}');
    Error('\P{Blk=_-PUA/a/}');
    Expect(1, 63743, '\p{Blk=:\APUA\z:}', "");;
    Expect(0, 63744, '\p{Blk=:\APUA\z:}', "");;
    Expect(1, 63743, '\p{Blk=pua}', "");
    Expect(0, 63743, '\p{^Blk=pua}', "");
    Expect(0, 63743, '\P{Blk=pua}', "");
    Expect(1, 63743, '\P{^Blk=pua}', "");
    Expect(0, 63744, '\p{Blk=pua}', "");
    Expect(1, 63744, '\p{^Blk=pua}', "");
    Expect(1, 63744, '\P{Blk=pua}', "");
    Expect(0, 63744, '\P{^Blk=pua}', "");
    Expect(1, 63743, '\p{Blk=:\Apua\z:}', "");;
    Expect(0, 63744, '\p{Blk=:\Apua\z:}', "");;
    Expect(1, 63743, '\p{Blk=	PUA}', "");
    Expect(0, 63743, '\p{^Blk=	PUA}', "");
    Expect(0, 63743, '\P{Blk=	PUA}', "");
    Expect(1, 63743, '\P{^Blk=	PUA}', "");
    Expect(0, 63744, '\p{Blk=	PUA}', "");
    Expect(1, 63744, '\p{^Blk=	PUA}', "");
    Expect(1, 63744, '\P{Blk=	PUA}', "");
    Expect(0, 63744, '\P{^Blk=	PUA}', "");
    Error('\p{Is_Block=:=private_Use}');
    Error('\P{Is_Block=:=private_Use}');
    Expect(1, 63743, '\p{Is_Block=privateuse}', "");
    Expect(0, 63743, '\p{^Is_Block=privateuse}', "");
    Expect(0, 63743, '\P{Is_Block=privateuse}', "");
    Expect(1, 63743, '\P{^Is_Block=privateuse}', "");
    Expect(0, 63744, '\p{Is_Block=privateuse}', "");
    Expect(1, 63744, '\p{^Is_Block=privateuse}', "");
    Expect(1, 63744, '\P{Is_Block=privateuse}', "");
    Expect(0, 63744, '\P{^Is_Block=privateuse}', "");
    Expect(1, 63743, '\p{Is_Block= _private_use}', "");
    Expect(0, 63743, '\p{^Is_Block= _private_use}', "");
    Expect(0, 63743, '\P{Is_Block= _private_use}', "");
    Expect(1, 63743, '\P{^Is_Block= _private_use}', "");
    Expect(0, 63744, '\p{Is_Block= _private_use}', "");
    Expect(1, 63744, '\p{^Is_Block= _private_use}', "");
    Expect(1, 63744, '\P{Is_Block= _private_use}', "");
    Expect(0, 63744, '\P{^Is_Block= _private_use}', "");
    Error('\p{Is_Blk=-private_Use_AREA/a/}');
    Error('\P{Is_Blk=-private_Use_AREA/a/}');
    Expect(1, 63743, '\p{Is_Blk=privateusearea}', "");
    Expect(0, 63743, '\p{^Is_Blk=privateusearea}', "");
    Expect(0, 63743, '\P{Is_Blk=privateusearea}', "");
    Expect(1, 63743, '\P{^Is_Blk=privateusearea}', "");
    Expect(0, 63744, '\p{Is_Blk=privateusearea}', "");
    Expect(1, 63744, '\p{^Is_Blk=privateusearea}', "");
    Expect(1, 63744, '\P{Is_Blk=privateusearea}', "");
    Expect(0, 63744, '\P{^Is_Blk=privateusearea}', "");
    Expect(1, 63743, '\p{Is_Blk=	-Private_USE_Area}', "");
    Expect(0, 63743, '\p{^Is_Blk=	-Private_USE_Area}', "");
    Expect(0, 63743, '\P{Is_Blk=	-Private_USE_Area}', "");
    Expect(1, 63743, '\P{^Is_Blk=	-Private_USE_Area}', "");
    Expect(0, 63744, '\p{Is_Blk=	-Private_USE_Area}', "");
    Expect(1, 63744, '\p{^Is_Blk=	-Private_USE_Area}', "");
    Expect(1, 63744, '\P{Is_Blk=	-Private_USE_Area}', "");
    Expect(0, 63744, '\P{^Is_Blk=	-Private_USE_Area}', "");
    Error('\p{Block=-_GENERAL_Punctuation:=}');
    Error('\P{Block=-_GENERAL_Punctuation:=}');
    Expect(1, 8303, '\p{Block=:\AGeneral_Punctuation\z:}', "");;
    Expect(0, 8304, '\p{Block=:\AGeneral_Punctuation\z:}', "");;
    Expect(1, 8303, '\p{Block=generalpunctuation}', "");
    Expect(0, 8303, '\p{^Block=generalpunctuation}', "");
    Expect(0, 8303, '\P{Block=generalpunctuation}', "");
    Expect(1, 8303, '\P{^Block=generalpunctuation}', "");
    Expect(0, 8304, '\p{Block=generalpunctuation}', "");
    Expect(1, 8304, '\p{^Block=generalpunctuation}', "");
    Expect(1, 8304, '\P{Block=generalpunctuation}', "");
    Expect(0, 8304, '\P{^Block=generalpunctuation}', "");
    Expect(1, 8303, '\p{Block=:\Ageneralpunctuation\z:}', "");;
    Expect(0, 8304, '\p{Block=:\Ageneralpunctuation\z:}', "");;
    Expect(1, 8303, '\p{Block=--General_Punctuation}', "");
    Expect(0, 8303, '\p{^Block=--General_Punctuation}', "");
    Expect(0, 8303, '\P{Block=--General_Punctuation}', "");
    Expect(1, 8303, '\P{^Block=--General_Punctuation}', "");
    Expect(0, 8304, '\p{Block=--General_Punctuation}', "");
    Expect(1, 8304, '\p{^Block=--General_Punctuation}', "");
    Expect(1, 8304, '\P{Block=--General_Punctuation}', "");
    Expect(0, 8304, '\P{^Block=--General_Punctuation}', "");
    Error('\p{Blk:    Punctuation/a/}');
    Error('\P{Blk:    Punctuation/a/}');
    Expect(1, 8303, '\p{Blk=:\APunctuation\z:}', "");;
    Expect(0, 8304, '\p{Blk=:\APunctuation\z:}', "");;
    Expect(1, 8303, '\p{Blk=punctuation}', "");
    Expect(0, 8303, '\p{^Blk=punctuation}', "");
    Expect(0, 8303, '\P{Blk=punctuation}', "");
    Expect(1, 8303, '\P{^Blk=punctuation}', "");
    Expect(0, 8304, '\p{Blk=punctuation}', "");
    Expect(1, 8304, '\p{^Blk=punctuation}', "");
    Expect(1, 8304, '\P{Blk=punctuation}', "");
    Expect(0, 8304, '\P{^Blk=punctuation}', "");
    Expect(1, 8303, '\p{Blk=:\Apunctuation\z:}', "");;
    Expect(0, 8304, '\p{Blk=:\Apunctuation\z:}', "");;
    Expect(1, 8303, '\p{Blk=	_PUNCTUATION}', "");
    Expect(0, 8303, '\p{^Blk=	_PUNCTUATION}', "");
    Expect(0, 8303, '\P{Blk=	_PUNCTUATION}', "");
    Expect(1, 8303, '\P{^Blk=	_PUNCTUATION}', "");
    Expect(0, 8304, '\p{Blk=	_PUNCTUATION}', "");
    Expect(1, 8304, '\p{^Blk=	_PUNCTUATION}', "");
    Expect(1, 8304, '\P{Blk=	_PUNCTUATION}', "");
    Expect(0, 8304, '\P{^Blk=	_PUNCTUATION}', "");
    Error('\p{Is_Block=:=_	GENERAL_punctuation}');
    Error('\P{Is_Block=:=_	GENERAL_punctuation}');
    Expect(1, 8303, '\p{Is_Block=generalpunctuation}', "");
    Expect(0, 8303, '\p{^Is_Block=generalpunctuation}', "");
    Expect(0, 8303, '\P{Is_Block=generalpunctuation}', "");
    Expect(1, 8303, '\P{^Is_Block=generalpunctuation}', "");
    Expect(0, 8304, '\p{Is_Block=generalpunctuation}', "");
    Expect(1, 8304, '\p{^Is_Block=generalpunctuation}', "");
    Expect(1, 8304, '\P{Is_Block=generalpunctuation}', "");
    Expect(0, 8304, '\P{^Is_Block=generalpunctuation}', "");
    Expect(1, 8303, '\p{Is_Block=-General_punctuation}', "");
    Expect(0, 8303, '\p{^Is_Block=-General_punctuation}', "");
    Expect(0, 8303, '\P{Is_Block=-General_punctuation}', "");
    Expect(1, 8303, '\P{^Is_Block=-General_punctuation}', "");
    Expect(0, 8304, '\p{Is_Block=-General_punctuation}', "");
    Expect(1, 8304, '\p{^Is_Block=-General_punctuation}', "");
    Expect(1, 8304, '\P{Is_Block=-General_punctuation}', "");
    Expect(0, 8304, '\P{^Is_Block=-General_punctuation}', "");
    Error('\p{Is_Blk=-	Punctuation:=}');
    Error('\P{Is_Blk=-	Punctuation:=}');
    Expect(1, 8303, '\p{Is_Blk: punctuation}', "");
    Expect(0, 8303, '\p{^Is_Blk: punctuation}', "");
    Expect(0, 8303, '\P{Is_Blk: punctuation}', "");
    Expect(1, 8303, '\P{^Is_Blk: punctuation}', "");
    Expect(0, 8304, '\p{Is_Blk: punctuation}', "");
    Expect(1, 8304, '\p{^Is_Blk: punctuation}', "");
    Expect(1, 8304, '\P{Is_Blk: punctuation}', "");
    Expect(0, 8304, '\P{^Is_Blk: punctuation}', "");
    Expect(1, 8303, '\p{Is_Blk=	PUNCTUATION}', "");
    Expect(0, 8303, '\p{^Is_Blk=	PUNCTUATION}', "");
    Expect(0, 8303, '\P{Is_Blk=	PUNCTUATION}', "");
    Expect(1, 8303, '\P{^Is_Blk=	PUNCTUATION}', "");
    Expect(0, 8304, '\p{Is_Blk=	PUNCTUATION}', "");
    Expect(1, 8304, '\p{^Is_Blk=	PUNCTUATION}', "");
    Expect(1, 8304, '\P{Is_Blk=	PUNCTUATION}', "");
    Expect(0, 8304, '\P{^Is_Blk=	PUNCTUATION}', "");
    Error('\p{Block=-_rejang:=}');
    Error('\P{Block=-_rejang:=}');
    Expect(1, 43359, '\p{Block=:\ARejang\z:}', "");;
    Expect(0, 43360, '\p{Block=:\ARejang\z:}', "");;
    Expect(1, 43359, '\p{Block=rejang}', "");
    Expect(0, 43359, '\p{^Block=rejang}', "");
    Expect(0, 43359, '\P{Block=rejang}', "");
    Expect(1, 43359, '\P{^Block=rejang}', "");
    Expect(0, 43360, '\p{Block=rejang}', "");
    Expect(1, 43360, '\p{^Block=rejang}', "");
    Expect(1, 43360, '\P{Block=rejang}', "");
    Expect(0, 43360, '\P{^Block=rejang}', "");
    Expect(1, 43359, '\p{Block=:\Arejang\z:}', "");;
    Expect(0, 43360, '\p{Block=:\Arejang\z:}', "");;
    Expect(1, 43359, '\p{Block=-	rejang}', "");
    Expect(0, 43359, '\p{^Block=-	rejang}', "");
    Expect(0, 43359, '\P{Block=-	rejang}', "");
    Expect(1, 43359, '\P{^Block=-	rejang}', "");
    Expect(0, 43360, '\p{Block=-	rejang}', "");
    Expect(1, 43360, '\p{^Block=-	rejang}', "");
    Expect(1, 43360, '\P{Block=-	rejang}', "");
    Expect(0, 43360, '\P{^Block=-	rejang}', "");
    Error('\p{Blk=	REJANG/a/}');
    Error('\P{Blk=	REJANG/a/}');
    Expect(1, 43359, '\p{Blk=:\ARejang\z:}', "");;
    Expect(0, 43360, '\p{Blk=:\ARejang\z:}', "");;
    Expect(1, 43359, '\p{Blk=rejang}', "");
    Expect(0, 43359, '\p{^Blk=rejang}', "");
    Expect(0, 43359, '\P{Blk=rejang}', "");
    Expect(1, 43359, '\P{^Blk=rejang}', "");
    Expect(0, 43360, '\p{Blk=rejang}', "");
    Expect(1, 43360, '\p{^Blk=rejang}', "");
    Expect(1, 43360, '\P{Blk=rejang}', "");
    Expect(0, 43360, '\P{^Blk=rejang}', "");
    Expect(1, 43359, '\p{Blk=:\Arejang\z:}', "");;
    Expect(0, 43360, '\p{Blk=:\Arejang\z:}', "");;
    Expect(1, 43359, '\p{Blk=_	Rejang}', "");
    Expect(0, 43359, '\p{^Blk=_	Rejang}', "");
    Expect(0, 43359, '\P{Blk=_	Rejang}', "");
    Expect(1, 43359, '\P{^Blk=_	Rejang}', "");
    Expect(0, 43360, '\p{Blk=_	Rejang}', "");
    Expect(1, 43360, '\p{^Blk=_	Rejang}', "");
    Expect(1, 43360, '\P{Blk=_	Rejang}', "");
    Expect(0, 43360, '\P{^Blk=_	Rejang}', "");
    Error('\p{Is_Block=:=-rejang}');
    Error('\P{Is_Block=:=-rejang}');
    Expect(1, 43359, '\p{Is_Block=rejang}', "");
    Expect(0, 43359, '\p{^Is_Block=rejang}', "");
    Expect(0, 43359, '\P{Is_Block=rejang}', "");
    Expect(1, 43359, '\P{^Is_Block=rejang}', "");
    Expect(0, 43360, '\p{Is_Block=rejang}', "");
    Expect(1, 43360, '\p{^Is_Block=rejang}', "");
    Expect(1, 43360, '\P{Is_Block=rejang}', "");
    Expect(0, 43360, '\P{^Is_Block=rejang}', "");
    Expect(1, 43359, '\p{Is_Block=_-REJANG}', "");
    Expect(0, 43359, '\p{^Is_Block=_-REJANG}', "");
    Expect(0, 43359, '\P{Is_Block=_-REJANG}', "");
    Expect(1, 43359, '\P{^Is_Block=_-REJANG}', "");
    Expect(0, 43360, '\p{Is_Block=_-REJANG}', "");
    Expect(1, 43360, '\p{^Is_Block=_-REJANG}', "");
    Expect(1, 43360, '\P{Is_Block=_-REJANG}', "");
    Expect(0, 43360, '\P{^Is_Block=_-REJANG}', "");
    Error('\p{Is_Blk=  rejang/a/}');
    Error('\P{Is_Blk=  rejang/a/}');
    Expect(1, 43359, '\p{Is_Blk:   rejang}', "");
    Expect(0, 43359, '\p{^Is_Blk:   rejang}', "");
    Expect(0, 43359, '\P{Is_Blk:   rejang}', "");
    Expect(1, 43359, '\P{^Is_Blk:   rejang}', "");
    Expect(0, 43360, '\p{Is_Blk:   rejang}', "");
    Expect(1, 43360, '\p{^Is_Blk:   rejang}', "");
    Expect(1, 43360, '\P{Is_Blk:   rejang}', "");
    Expect(0, 43360, '\P{^Is_Blk:   rejang}', "");
    Expect(1, 43359, '\p{Is_Blk=		Rejang}', "");
    Expect(0, 43359, '\p{^Is_Blk=		Rejang}', "");
    Expect(0, 43359, '\P{Is_Blk=		Rejang}', "");
    Expect(1, 43359, '\P{^Is_Blk=		Rejang}', "");
    Expect(0, 43360, '\p{Is_Blk=		Rejang}', "");
    Expect(1, 43360, '\p{^Is_Blk=		Rejang}', "");
    Expect(1, 43360, '\P{Is_Blk=		Rejang}', "");
    Expect(0, 43360, '\P{^Is_Blk=		Rejang}', "");
    Error('\p{Block=	RUMI_numeral_Symbols/a/}');
    Error('\P{Block=	RUMI_numeral_Symbols/a/}');
    Expect(1, 69247, '\p{Block=:\ARumi_Numeral_Symbols\z:}', "");;
    Expect(0, 69248, '\p{Block=:\ARumi_Numeral_Symbols\z:}', "");;
    Expect(1, 69247, '\p{Block=ruminumeralsymbols}', "");
    Expect(0, 69247, '\p{^Block=ruminumeralsymbols}', "");
    Expect(0, 69247, '\P{Block=ruminumeralsymbols}', "");
    Expect(1, 69247, '\P{^Block=ruminumeralsymbols}', "");
    Expect(0, 69248, '\p{Block=ruminumeralsymbols}', "");
    Expect(1, 69248, '\p{^Block=ruminumeralsymbols}', "");
    Expect(1, 69248, '\P{Block=ruminumeralsymbols}', "");
    Expect(0, 69248, '\P{^Block=ruminumeralsymbols}', "");
    Expect(1, 69247, '\p{Block=:\Aruminumeralsymbols\z:}', "");;
    Expect(0, 69248, '\p{Block=:\Aruminumeralsymbols\z:}', "");;
    Expect(1, 69247, '\p{Block=--rumi_NUMERAL_symbols}', "");
    Expect(0, 69247, '\p{^Block=--rumi_NUMERAL_symbols}', "");
    Expect(0, 69247, '\P{Block=--rumi_NUMERAL_symbols}', "");
    Expect(1, 69247, '\P{^Block=--rumi_NUMERAL_symbols}', "");
    Expect(0, 69248, '\p{Block=--rumi_NUMERAL_symbols}', "");
    Expect(1, 69248, '\p{^Block=--rumi_NUMERAL_symbols}', "");
    Expect(1, 69248, '\P{Block=--rumi_NUMERAL_symbols}', "");
    Expect(0, 69248, '\P{^Block=--rumi_NUMERAL_symbols}', "");
    Error('\p{Blk=- rumi:=}');
    Error('\P{Blk=- rumi:=}');
    Expect(1, 69247, '\p{Blk=:\ARumi\z:}', "");;
    Expect(0, 69248, '\p{Blk=:\ARumi\z:}', "");;
    Expect(1, 69247, '\p{Blk: rumi}', "");
    Expect(0, 69247, '\p{^Blk: rumi}', "");
    Expect(0, 69247, '\P{Blk: rumi}', "");
    Expect(1, 69247, '\P{^Blk: rumi}', "");
    Expect(0, 69248, '\p{Blk: rumi}', "");
    Expect(1, 69248, '\p{^Blk: rumi}', "");
    Expect(1, 69248, '\P{Blk: rumi}', "");
    Expect(0, 69248, '\P{^Blk: rumi}', "");
    Expect(1, 69247, '\p{Blk=:\Arumi\z:}', "");;
    Expect(0, 69248, '\p{Blk=:\Arumi\z:}', "");;
    Expect(1, 69247, '\p{Blk=_Rumi}', "");
    Expect(0, 69247, '\p{^Blk=_Rumi}', "");
    Expect(0, 69247, '\P{Blk=_Rumi}', "");
    Expect(1, 69247, '\P{^Blk=_Rumi}', "");
    Expect(0, 69248, '\p{Blk=_Rumi}', "");
    Expect(1, 69248, '\p{^Blk=_Rumi}', "");
    Expect(1, 69248, '\P{Blk=_Rumi}', "");
    Expect(0, 69248, '\P{^Blk=_Rumi}', "");
    Error('\p{Is_Block=-_Rumi_Numeral_SYMBOLS/a/}');
    Error('\P{Is_Block=-_Rumi_Numeral_SYMBOLS/a/}');
    Expect(1, 69247, '\p{Is_Block=ruminumeralsymbols}', "");
    Expect(0, 69247, '\p{^Is_Block=ruminumeralsymbols}', "");
    Expect(0, 69247, '\P{Is_Block=ruminumeralsymbols}', "");
    Expect(1, 69247, '\P{^Is_Block=ruminumeralsymbols}', "");
    Expect(0, 69248, '\p{Is_Block=ruminumeralsymbols}', "");
    Expect(1, 69248, '\p{^Is_Block=ruminumeralsymbols}', "");
    Expect(1, 69248, '\P{Is_Block=ruminumeralsymbols}', "");
    Expect(0, 69248, '\P{^Is_Block=ruminumeralsymbols}', "");
    Expect(1, 69247, '\p{Is_Block=_Rumi_Numeral_Symbols}', "");
    Expect(0, 69247, '\p{^Is_Block=_Rumi_Numeral_Symbols}', "");
    Expect(0, 69247, '\P{Is_Block=_Rumi_Numeral_Symbols}', "");
    Expect(1, 69247, '\P{^Is_Block=_Rumi_Numeral_Symbols}', "");
    Expect(0, 69248, '\p{Is_Block=_Rumi_Numeral_Symbols}', "");
    Expect(1, 69248, '\p{^Is_Block=_Rumi_Numeral_Symbols}', "");
    Expect(1, 69248, '\P{Is_Block=_Rumi_Numeral_Symbols}', "");
    Expect(0, 69248, '\P{^Is_Block=_Rumi_Numeral_Symbols}', "");
    Error('\p{Is_Blk=	 RUMI:=}');
    Error('\P{Is_Blk=	 RUMI:=}');
    Expect(1, 69247, '\p{Is_Blk=rumi}', "");
    Expect(0, 69247, '\p{^Is_Blk=rumi}', "");
    Expect(0, 69247, '\P{Is_Blk=rumi}', "");
    Expect(1, 69247, '\P{^Is_Blk=rumi}', "");
    Expect(0, 69248, '\p{Is_Blk=rumi}', "");
    Expect(1, 69248, '\p{^Is_Blk=rumi}', "");
    Expect(1, 69248, '\P{Is_Blk=rumi}', "");
    Expect(0, 69248, '\P{^Is_Blk=rumi}', "");
    Expect(1, 69247, '\p{Is_Blk=_-RUMI}', "");
    Expect(0, 69247, '\p{^Is_Blk=_-RUMI}', "");
    Expect(0, 69247, '\P{Is_Blk=_-RUMI}', "");
    Expect(1, 69247, '\P{^Is_Blk=_-RUMI}', "");
    Expect(0, 69248, '\p{Is_Blk=_-RUMI}', "");
    Expect(1, 69248, '\p{^Is_Blk=_-RUMI}', "");
    Expect(1, 69248, '\P{Is_Blk=_-RUMI}', "");
    Expect(0, 69248, '\P{^Is_Blk=_-RUMI}', "");
    Error('\p{Block=_/a/Runic}');
    Error('\P{Block=_/a/Runic}');
    Expect(1, 5887, '\p{Block=:\ARunic\z:}', "");;
    Expect(0, 5888, '\p{Block=:\ARunic\z:}', "");;
    Expect(1, 5887, '\p{Block=runic}', "");
    Expect(0, 5887, '\p{^Block=runic}', "");
    Expect(0, 5887, '\P{Block=runic}', "");
    Expect(1, 5887, '\P{^Block=runic}', "");
    Expect(0, 5888, '\p{Block=runic}', "");
    Expect(1, 5888, '\p{^Block=runic}', "");
    Expect(1, 5888, '\P{Block=runic}', "");
    Expect(0, 5888, '\P{^Block=runic}', "");
    Expect(1, 5887, '\p{Block=:\Arunic\z:}', "");;
    Expect(0, 5888, '\p{Block=:\Arunic\z:}', "");;
    Expect(1, 5887, '\p{Block= -runic}', "");
    Expect(0, 5887, '\p{^Block= -runic}', "");
    Expect(0, 5887, '\P{Block= -runic}', "");
    Expect(1, 5887, '\P{^Block= -runic}', "");
    Expect(0, 5888, '\p{Block= -runic}', "");
    Expect(1, 5888, '\p{^Block= -runic}', "");
    Expect(1, 5888, '\P{Block= -runic}', "");
    Expect(0, 5888, '\P{^Block= -runic}', "");
    Error('\p{Blk:		 Runic/a/}');
    Error('\P{Blk:		 Runic/a/}');
    Expect(1, 5887, '\p{Blk=:\ARunic\z:}', "");;
    Expect(0, 5888, '\p{Blk=:\ARunic\z:}', "");;
    Expect(1, 5887, '\p{Blk=runic}', "");
    Expect(0, 5887, '\p{^Blk=runic}', "");
    Expect(0, 5887, '\P{Blk=runic}', "");
    Expect(1, 5887, '\P{^Blk=runic}', "");
    Expect(0, 5888, '\p{Blk=runic}', "");
    Expect(1, 5888, '\p{^Blk=runic}', "");
    Expect(1, 5888, '\P{Blk=runic}', "");
    Expect(0, 5888, '\P{^Blk=runic}', "");
    Expect(1, 5887, '\p{Blk=:\Arunic\z:}', "");;
    Expect(0, 5888, '\p{Blk=:\Arunic\z:}', "");;
    Expect(1, 5887, '\p{Blk: 	RUNIC}', "");
    Expect(0, 5887, '\p{^Blk: 	RUNIC}', "");
    Expect(0, 5887, '\P{Blk: 	RUNIC}', "");
    Expect(1, 5887, '\P{^Blk: 	RUNIC}', "");
    Expect(0, 5888, '\p{Blk: 	RUNIC}', "");
    Expect(1, 5888, '\p{^Blk: 	RUNIC}', "");
    Expect(1, 5888, '\P{Blk: 	RUNIC}', "");
    Expect(0, 5888, '\P{^Blk: 	RUNIC}', "");
    Error('\p{Is_Block= :=RUNIC}');
    Error('\P{Is_Block= :=RUNIC}');
    Expect(1, 5887, '\p{Is_Block=runic}', "");
    Expect(0, 5887, '\p{^Is_Block=runic}', "");
    Expect(0, 5887, '\P{Is_Block=runic}', "");
    Expect(1, 5887, '\P{^Is_Block=runic}', "");
    Expect(0, 5888, '\p{Is_Block=runic}', "");
    Expect(1, 5888, '\p{^Is_Block=runic}', "");
    Expect(1, 5888, '\P{Is_Block=runic}', "");
    Expect(0, 5888, '\P{^Is_Block=runic}', "");
    Expect(1, 5887, '\p{Is_Block=- Runic}', "");
    Expect(0, 5887, '\p{^Is_Block=- Runic}', "");
    Expect(0, 5887, '\P{Is_Block=- Runic}', "");
    Expect(1, 5887, '\P{^Is_Block=- Runic}', "");
    Expect(0, 5888, '\p{Is_Block=- Runic}', "");
    Expect(1, 5888, '\p{^Is_Block=- Runic}', "");
    Expect(1, 5888, '\P{Is_Block=- Runic}', "");
    Expect(0, 5888, '\P{^Is_Block=- Runic}', "");
    Error('\p{Is_Blk=/a/	-Runic}');
    Error('\P{Is_Blk=/a/	-Runic}');
    Expect(1, 5887, '\p{Is_Blk=runic}', "");
    Expect(0, 5887, '\p{^Is_Blk=runic}', "");
    Expect(0, 5887, '\P{Is_Blk=runic}', "");
    Expect(1, 5887, '\P{^Is_Blk=runic}', "");
    Expect(0, 5888, '\p{Is_Blk=runic}', "");
    Expect(1, 5888, '\p{^Is_Blk=runic}', "");
    Expect(1, 5888, '\P{Is_Blk=runic}', "");
    Expect(0, 5888, '\P{^Is_Blk=runic}', "");
    Expect(1, 5887, '\p{Is_Blk:	  RUNIC}', "");
    Expect(0, 5887, '\p{^Is_Blk:	  RUNIC}', "");
    Expect(0, 5887, '\P{Is_Blk:	  RUNIC}', "");
    Expect(1, 5887, '\P{^Is_Blk:	  RUNIC}', "");
    Expect(0, 5888, '\p{Is_Blk:	  RUNIC}', "");
    Expect(1, 5888, '\p{^Is_Blk:	  RUNIC}', "");
    Expect(1, 5888, '\P{Is_Blk:	  RUNIC}', "");
    Expect(0, 5888, '\P{^Is_Blk:	  RUNIC}', "");
    Error('\p{Block=_/a/SAMARITAN}');
    Error('\P{Block=_/a/SAMARITAN}');
    Expect(1, 2111, '\p{Block=:\ASamaritan\z:}', "");;
    Expect(0, 2112, '\p{Block=:\ASamaritan\z:}', "");;
    Expect(1, 2111, '\p{Block=samaritan}', "");
    Expect(0, 2111, '\p{^Block=samaritan}', "");
    Expect(0, 2111, '\P{Block=samaritan}', "");
    Expect(1, 2111, '\P{^Block=samaritan}', "");
    Expect(0, 2112, '\p{Block=samaritan}', "");
    Expect(1, 2112, '\p{^Block=samaritan}', "");
    Expect(1, 2112, '\P{Block=samaritan}', "");
    Expect(0, 2112, '\P{^Block=samaritan}', "");
    Expect(1, 2111, '\p{Block=:\Asamaritan\z:}', "");;
    Expect(0, 2112, '\p{Block=:\Asamaritan\z:}', "");;
    Expect(1, 2111, '\p{Block=Samaritan}', "");
    Expect(0, 2111, '\p{^Block=Samaritan}', "");
    Expect(0, 2111, '\P{Block=Samaritan}', "");
    Expect(1, 2111, '\P{^Block=Samaritan}', "");
    Expect(0, 2112, '\p{Block=Samaritan}', "");
    Expect(1, 2112, '\p{^Block=Samaritan}', "");
    Expect(1, 2112, '\P{Block=Samaritan}', "");
    Expect(0, 2112, '\P{^Block=Samaritan}', "");
    Error('\p{Blk=_samaritan:=}');
    Error('\P{Blk=_samaritan:=}');
    Expect(1, 2111, '\p{Blk=:\ASamaritan\z:}', "");;
    Expect(0, 2112, '\p{Blk=:\ASamaritan\z:}', "");;
    Expect(1, 2111, '\p{Blk=samaritan}', "");
    Expect(0, 2111, '\p{^Blk=samaritan}', "");
    Expect(0, 2111, '\P{Blk=samaritan}', "");
    Expect(1, 2111, '\P{^Blk=samaritan}', "");
    Expect(0, 2112, '\p{Blk=samaritan}', "");
    Expect(1, 2112, '\p{^Blk=samaritan}', "");
    Expect(1, 2112, '\P{Blk=samaritan}', "");
    Expect(0, 2112, '\P{^Blk=samaritan}', "");
    Expect(1, 2111, '\p{Blk=:\Asamaritan\z:}', "");;
    Expect(0, 2112, '\p{Blk=:\Asamaritan\z:}', "");;
    Expect(1, 2111, '\p{Blk=		Samaritan}', "");
    Expect(0, 2111, '\p{^Blk=		Samaritan}', "");
    Expect(0, 2111, '\P{Blk=		Samaritan}', "");
    Expect(1, 2111, '\P{^Blk=		Samaritan}', "");
    Expect(0, 2112, '\p{Blk=		Samaritan}', "");
    Expect(1, 2112, '\p{^Blk=		Samaritan}', "");
    Expect(1, 2112, '\P{Blk=		Samaritan}', "");
    Expect(0, 2112, '\P{^Blk=		Samaritan}', "");
    Error('\p{Is_Block:	-Samaritan:=}');
    Error('\P{Is_Block:	-Samaritan:=}');
    Expect(1, 2111, '\p{Is_Block=samaritan}', "");
    Expect(0, 2111, '\p{^Is_Block=samaritan}', "");
    Expect(0, 2111, '\P{Is_Block=samaritan}', "");
    Expect(1, 2111, '\P{^Is_Block=samaritan}', "");
    Expect(0, 2112, '\p{Is_Block=samaritan}', "");
    Expect(1, 2112, '\p{^Is_Block=samaritan}', "");
    Expect(1, 2112, '\P{Is_Block=samaritan}', "");
    Expect(0, 2112, '\P{^Is_Block=samaritan}', "");
    Expect(1, 2111, '\p{Is_Block= -samaritan}', "");
    Expect(0, 2111, '\p{^Is_Block= -samaritan}', "");
    Expect(0, 2111, '\P{Is_Block= -samaritan}', "");
    Expect(1, 2111, '\P{^Is_Block= -samaritan}', "");
    Expect(0, 2112, '\p{Is_Block= -samaritan}', "");
    Expect(1, 2112, '\p{^Is_Block= -samaritan}', "");
    Expect(1, 2112, '\P{Is_Block= -samaritan}', "");
    Expect(0, 2112, '\P{^Is_Block= -samaritan}', "");
    Error('\p{Is_Blk=Samaritan/a/}');
    Error('\P{Is_Blk=Samaritan/a/}');
    Expect(1, 2111, '\p{Is_Blk=samaritan}', "");
    Expect(0, 2111, '\p{^Is_Blk=samaritan}', "");
    Expect(0, 2111, '\P{Is_Blk=samaritan}', "");
    Expect(1, 2111, '\P{^Is_Blk=samaritan}', "");
    Expect(0, 2112, '\p{Is_Blk=samaritan}', "");
    Expect(1, 2112, '\p{^Is_Blk=samaritan}', "");
    Expect(1, 2112, '\P{Is_Blk=samaritan}', "");
    Expect(0, 2112, '\P{^Is_Blk=samaritan}', "");
    Expect(1, 2111, '\p{Is_Blk:	_ samaritan}', "");
    Expect(0, 2111, '\p{^Is_Blk:	_ samaritan}', "");
    Expect(0, 2111, '\P{Is_Blk:	_ samaritan}', "");
    Expect(1, 2111, '\P{^Is_Blk:	_ samaritan}', "");
    Expect(0, 2112, '\p{Is_Blk:	_ samaritan}', "");
    Expect(1, 2112, '\p{^Is_Blk:	_ samaritan}', "");
    Expect(1, 2112, '\P{Is_Blk:	_ samaritan}', "");
    Expect(0, 2112, '\P{^Is_Blk:	_ samaritan}', "");
    Error('\p{Block=_saurashtra:=}');
    Error('\P{Block=_saurashtra:=}');
    Expect(1, 43231, '\p{Block=:\ASaurashtra\z:}', "");;
    Expect(0, 43232, '\p{Block=:\ASaurashtra\z:}', "");;
    Expect(1, 43231, '\p{Block=saurashtra}', "");
    Expect(0, 43231, '\p{^Block=saurashtra}', "");
    Expect(0, 43231, '\P{Block=saurashtra}', "");
    Expect(1, 43231, '\P{^Block=saurashtra}', "");
    Expect(0, 43232, '\p{Block=saurashtra}', "");
    Expect(1, 43232, '\p{^Block=saurashtra}', "");
    Expect(1, 43232, '\P{Block=saurashtra}', "");
    Expect(0, 43232, '\P{^Block=saurashtra}', "");
    Expect(1, 43231, '\p{Block=:\Asaurashtra\z:}', "");;
    Expect(0, 43232, '\p{Block=:\Asaurashtra\z:}', "");;
    Expect(1, 43231, '\p{Block=_ Saurashtra}', "");
    Expect(0, 43231, '\p{^Block=_ Saurashtra}', "");
    Expect(0, 43231, '\P{Block=_ Saurashtra}', "");
    Expect(1, 43231, '\P{^Block=_ Saurashtra}', "");
    Expect(0, 43232, '\p{Block=_ Saurashtra}', "");
    Expect(1, 43232, '\p{^Block=_ Saurashtra}', "");
    Expect(1, 43232, '\P{Block=_ Saurashtra}', "");
    Expect(0, 43232, '\P{^Block=_ Saurashtra}', "");
    Error('\p{Blk= -Saurashtra:=}');
    Error('\P{Blk= -Saurashtra:=}');
    Expect(1, 43231, '\p{Blk=:\ASaurashtra\z:}', "");;
    Expect(0, 43232, '\p{Blk=:\ASaurashtra\z:}', "");;
    Expect(1, 43231, '\p{Blk=saurashtra}', "");
    Expect(0, 43231, '\p{^Blk=saurashtra}', "");
    Expect(0, 43231, '\P{Blk=saurashtra}', "");
    Expect(1, 43231, '\P{^Blk=saurashtra}', "");
    Expect(0, 43232, '\p{Blk=saurashtra}', "");
    Expect(1, 43232, '\p{^Blk=saurashtra}', "");
    Expect(1, 43232, '\P{Blk=saurashtra}', "");
    Expect(0, 43232, '\P{^Blk=saurashtra}', "");
    Expect(1, 43231, '\p{Blk=:\Asaurashtra\z:}', "");;
    Expect(0, 43232, '\p{Blk=:\Asaurashtra\z:}', "");;
    Expect(1, 43231, '\p{Blk=	SAURASHTRA}', "");
    Expect(0, 43231, '\p{^Blk=	SAURASHTRA}', "");
    Expect(0, 43231, '\P{Blk=	SAURASHTRA}', "");
    Expect(1, 43231, '\P{^Blk=	SAURASHTRA}', "");
    Expect(0, 43232, '\p{Blk=	SAURASHTRA}', "");
    Expect(1, 43232, '\p{^Blk=	SAURASHTRA}', "");
    Expect(1, 43232, '\P{Blk=	SAURASHTRA}', "");
    Expect(0, 43232, '\P{^Blk=	SAURASHTRA}', "");
    Error('\p{Is_Block=-/a/saurashtra}');
    Error('\P{Is_Block=-/a/saurashtra}');
    Expect(1, 43231, '\p{Is_Block=saurashtra}', "");
    Expect(0, 43231, '\p{^Is_Block=saurashtra}', "");
    Expect(0, 43231, '\P{Is_Block=saurashtra}', "");
    Expect(1, 43231, '\P{^Is_Block=saurashtra}', "");
    Expect(0, 43232, '\p{Is_Block=saurashtra}', "");
    Expect(1, 43232, '\p{^Is_Block=saurashtra}', "");
    Expect(1, 43232, '\P{Is_Block=saurashtra}', "");
    Expect(0, 43232, '\P{^Is_Block=saurashtra}', "");
    Expect(1, 43231, '\p{Is_Block=- Saurashtra}', "");
    Expect(0, 43231, '\p{^Is_Block=- Saurashtra}', "");
    Expect(0, 43231, '\P{Is_Block=- Saurashtra}', "");
    Expect(1, 43231, '\P{^Is_Block=- Saurashtra}', "");
    Expect(0, 43232, '\p{Is_Block=- Saurashtra}', "");
    Expect(1, 43232, '\p{^Is_Block=- Saurashtra}', "");
    Expect(1, 43232, '\P{Is_Block=- Saurashtra}', "");
    Expect(0, 43232, '\P{^Is_Block=- Saurashtra}', "");
    Error('\p{Is_Blk=:=	saurashtra}');
    Error('\P{Is_Blk=:=	saurashtra}');
    Expect(1, 43231, '\p{Is_Blk=saurashtra}', "");
    Expect(0, 43231, '\p{^Is_Blk=saurashtra}', "");
    Expect(0, 43231, '\P{Is_Blk=saurashtra}', "");
    Expect(1, 43231, '\P{^Is_Blk=saurashtra}', "");
    Expect(0, 43232, '\p{Is_Blk=saurashtra}', "");
    Expect(1, 43232, '\p{^Is_Blk=saurashtra}', "");
    Expect(1, 43232, '\P{Is_Blk=saurashtra}', "");
    Expect(0, 43232, '\P{^Is_Blk=saurashtra}', "");
    Expect(1, 43231, '\p{Is_Blk=-	Saurashtra}', "");
    Expect(0, 43231, '\p{^Is_Blk=-	Saurashtra}', "");
    Expect(0, 43231, '\P{Is_Blk=-	Saurashtra}', "");
    Expect(1, 43231, '\P{^Is_Blk=-	Saurashtra}', "");
    Expect(0, 43232, '\p{Is_Blk=-	Saurashtra}', "");
    Expect(1, 43232, '\p{^Is_Blk=-	Saurashtra}', "");
    Expect(1, 43232, '\P{Is_Blk=-	Saurashtra}', "");
    Expect(0, 43232, '\P{^Is_Blk=-	Saurashtra}', "");
    Error('\p{Block= /a/Sharada}');
    Error('\P{Block= /a/Sharada}');
    Expect(1, 70111, '\p{Block=:\ASharada\z:}', "");;
    Expect(0, 70112, '\p{Block=:\ASharada\z:}', "");;
    Expect(1, 70111, '\p{Block=sharada}', "");
    Expect(0, 70111, '\p{^Block=sharada}', "");
    Expect(0, 70111, '\P{Block=sharada}', "");
    Expect(1, 70111, '\P{^Block=sharada}', "");
    Expect(0, 70112, '\p{Block=sharada}', "");
    Expect(1, 70112, '\p{^Block=sharada}', "");
    Expect(1, 70112, '\P{Block=sharada}', "");
    Expect(0, 70112, '\P{^Block=sharada}', "");
    Expect(1, 70111, '\p{Block=:\Asharada\z:}', "");;
    Expect(0, 70112, '\p{Block=:\Asharada\z:}', "");;
    Expect(1, 70111, '\p{Block=--sharada}', "");
    Expect(0, 70111, '\p{^Block=--sharada}', "");
    Expect(0, 70111, '\P{Block=--sharada}', "");
    Expect(1, 70111, '\P{^Block=--sharada}', "");
    Expect(0, 70112, '\p{Block=--sharada}', "");
    Expect(1, 70112, '\p{^Block=--sharada}', "");
    Expect(1, 70112, '\P{Block=--sharada}', "");
    Expect(0, 70112, '\P{^Block=--sharada}', "");
    Error('\p{Blk=:=Sharada}');
    Error('\P{Blk=:=Sharada}');
    Expect(1, 70111, '\p{Blk=:\ASharada\z:}', "");;
    Expect(0, 70112, '\p{Blk=:\ASharada\z:}', "");;
    Expect(1, 70111, '\p{Blk=sharada}', "");
    Expect(0, 70111, '\p{^Blk=sharada}', "");
    Expect(0, 70111, '\P{Blk=sharada}', "");
    Expect(1, 70111, '\P{^Blk=sharada}', "");
    Expect(0, 70112, '\p{Blk=sharada}', "");
    Expect(1, 70112, '\p{^Blk=sharada}', "");
    Expect(1, 70112, '\P{Blk=sharada}', "");
    Expect(0, 70112, '\P{^Blk=sharada}', "");
    Expect(1, 70111, '\p{Blk=:\Asharada\z:}', "");;
    Expect(0, 70112, '\p{Blk=:\Asharada\z:}', "");;
    Expect(1, 70111, '\p{Blk=		Sharada}', "");
    Expect(0, 70111, '\p{^Blk=		Sharada}', "");
    Expect(0, 70111, '\P{Blk=		Sharada}', "");
    Expect(1, 70111, '\P{^Blk=		Sharada}', "");
    Expect(0, 70112, '\p{Blk=		Sharada}', "");
    Expect(1, 70112, '\p{^Blk=		Sharada}', "");
    Expect(1, 70112, '\P{Blk=		Sharada}', "");
    Expect(0, 70112, '\P{^Blk=		Sharada}', "");
    Error('\p{Is_Block=/a/Sharada}');
    Error('\P{Is_Block=/a/Sharada}');
    Expect(1, 70111, '\p{Is_Block=sharada}', "");
    Expect(0, 70111, '\p{^Is_Block=sharada}', "");
    Expect(0, 70111, '\P{Is_Block=sharada}', "");
    Expect(1, 70111, '\P{^Is_Block=sharada}', "");
    Expect(0, 70112, '\p{Is_Block=sharada}', "");
    Expect(1, 70112, '\p{^Is_Block=sharada}', "");
    Expect(1, 70112, '\P{Is_Block=sharada}', "");
    Expect(0, 70112, '\P{^Is_Block=sharada}', "");
    Expect(1, 70111, '\p{Is_Block=-_SHARADA}', "");
    Expect(0, 70111, '\p{^Is_Block=-_SHARADA}', "");
    Expect(0, 70111, '\P{Is_Block=-_SHARADA}', "");
    Expect(1, 70111, '\P{^Is_Block=-_SHARADA}', "");
    Expect(0, 70112, '\p{Is_Block=-_SHARADA}', "");
    Expect(1, 70112, '\p{^Is_Block=-_SHARADA}', "");
    Expect(1, 70112, '\P{Is_Block=-_SHARADA}', "");
    Expect(0, 70112, '\P{^Is_Block=-_SHARADA}', "");
    Error('\p{Is_Blk=-/a/Sharada}');
    Error('\P{Is_Blk=-/a/Sharada}');
    Expect(1, 70111, '\p{Is_Blk=sharada}', "");
    Expect(0, 70111, '\p{^Is_Blk=sharada}', "");
    Expect(0, 70111, '\P{Is_Blk=sharada}', "");
    Expect(1, 70111, '\P{^Is_Blk=sharada}', "");
    Expect(0, 70112, '\p{Is_Blk=sharada}', "");
    Expect(1, 70112, '\p{^Is_Blk=sharada}', "");
    Expect(1, 70112, '\P{Is_Blk=sharada}', "");
    Expect(0, 70112, '\P{^Is_Blk=sharada}', "");
    Expect(1, 70111, '\p{Is_Blk: _	Sharada}', "");
    Expect(0, 70111, '\p{^Is_Blk: _	Sharada}', "");
    Expect(0, 70111, '\P{Is_Blk: _	Sharada}', "");
    Expect(1, 70111, '\P{^Is_Blk: _	Sharada}', "");
    Expect(0, 70112, '\p{Is_Blk: _	Sharada}', "");
    Expect(1, 70112, '\p{^Is_Blk: _	Sharada}', "");
    Expect(1, 70112, '\P{Is_Blk: _	Sharada}', "");
    Expect(0, 70112, '\P{^Is_Blk: _	Sharada}', "");
    Error('\p{Block=:=-	Shavian}');
    Error('\P{Block=:=-	Shavian}');
    Expect(1, 66687, '\p{Block=:\AShavian\z:}', "");;
    Expect(0, 66688, '\p{Block=:\AShavian\z:}', "");;
    Expect(1, 66687, '\p{Block=shavian}', "");
    Expect(0, 66687, '\p{^Block=shavian}', "");
    Expect(0, 66687, '\P{Block=shavian}', "");
    Expect(1, 66687, '\P{^Block=shavian}', "");
    Expect(0, 66688, '\p{Block=shavian}', "");
    Expect(1, 66688, '\p{^Block=shavian}', "");
    Expect(1, 66688, '\P{Block=shavian}', "");
    Expect(0, 66688, '\P{^Block=shavian}', "");
    Expect(1, 66687, '\p{Block=:\Ashavian\z:}', "");;
    Expect(0, 66688, '\p{Block=:\Ashavian\z:}', "");;
    Expect(1, 66687, '\p{Block= -SHAVIAN}', "");
    Expect(0, 66687, '\p{^Block= -SHAVIAN}', "");
    Expect(0, 66687, '\P{Block= -SHAVIAN}', "");
    Expect(1, 66687, '\P{^Block= -SHAVIAN}', "");
    Expect(0, 66688, '\p{Block= -SHAVIAN}', "");
    Expect(1, 66688, '\p{^Block= -SHAVIAN}', "");
    Expect(1, 66688, '\P{Block= -SHAVIAN}', "");
    Expect(0, 66688, '\P{^Block= -SHAVIAN}', "");
    Error('\p{Blk=:=	 Shavian}');
    Error('\P{Blk=:=	 Shavian}');
    Expect(1, 66687, '\p{Blk=:\AShavian\z:}', "");;
    Expect(0, 66688, '\p{Blk=:\AShavian\z:}', "");;
    Expect(1, 66687, '\p{Blk=shavian}', "");
    Expect(0, 66687, '\p{^Blk=shavian}', "");
    Expect(0, 66687, '\P{Blk=shavian}', "");
    Expect(1, 66687, '\P{^Blk=shavian}', "");
    Expect(0, 66688, '\p{Blk=shavian}', "");
    Expect(1, 66688, '\p{^Blk=shavian}', "");
    Expect(1, 66688, '\P{Blk=shavian}', "");
    Expect(0, 66688, '\P{^Blk=shavian}', "");
    Expect(1, 66687, '\p{Blk=:\Ashavian\z:}', "");;
    Expect(0, 66688, '\p{Blk=:\Ashavian\z:}', "");;
    Expect(1, 66687, '\p{Blk= -shavian}', "");
    Expect(0, 66687, '\p{^Blk= -shavian}', "");
    Expect(0, 66687, '\P{Blk= -shavian}', "");
    Expect(1, 66687, '\P{^Blk= -shavian}', "");
    Expect(0, 66688, '\p{Blk= -shavian}', "");
    Expect(1, 66688, '\p{^Blk= -shavian}', "");
    Expect(1, 66688, '\P{Blk= -shavian}', "");
    Expect(0, 66688, '\P{^Blk= -shavian}', "");
    Error('\p{Is_Block=:=_	shavian}');
    Error('\P{Is_Block=:=_	shavian}');
    Expect(1, 66687, '\p{Is_Block=shavian}', "");
    Expect(0, 66687, '\p{^Is_Block=shavian}', "");
    Expect(0, 66687, '\P{Is_Block=shavian}', "");
    Expect(1, 66687, '\P{^Is_Block=shavian}', "");
    Expect(0, 66688, '\p{Is_Block=shavian}', "");
    Expect(1, 66688, '\p{^Is_Block=shavian}', "");
    Expect(1, 66688, '\P{Is_Block=shavian}', "");
    Expect(0, 66688, '\P{^Is_Block=shavian}', "");
    Expect(1, 66687, '\p{Is_Block= shavian}', "");
    Expect(0, 66687, '\p{^Is_Block= shavian}', "");
    Expect(0, 66687, '\P{Is_Block= shavian}', "");
    Expect(1, 66687, '\P{^Is_Block= shavian}', "");
    Expect(0, 66688, '\p{Is_Block= shavian}', "");
    Expect(1, 66688, '\p{^Is_Block= shavian}', "");
    Expect(1, 66688, '\P{Is_Block= shavian}', "");
    Expect(0, 66688, '\P{^Is_Block= shavian}', "");
    Error('\p{Is_Blk=:= _Shavian}');
    Error('\P{Is_Blk=:= _Shavian}');
    Expect(1, 66687, '\p{Is_Blk=shavian}', "");
    Expect(0, 66687, '\p{^Is_Blk=shavian}', "");
    Expect(0, 66687, '\P{Is_Blk=shavian}', "");
    Expect(1, 66687, '\P{^Is_Blk=shavian}', "");
    Expect(0, 66688, '\p{Is_Blk=shavian}', "");
    Expect(1, 66688, '\p{^Is_Blk=shavian}', "");
    Expect(1, 66688, '\P{Is_Blk=shavian}', "");
    Expect(0, 66688, '\P{^Is_Blk=shavian}', "");
    Expect(1, 66687, '\p{Is_Blk=-shavian}', "");
    Expect(0, 66687, '\p{^Is_Blk=-shavian}', "");
    Expect(0, 66687, '\P{Is_Blk=-shavian}', "");
    Expect(1, 66687, '\P{^Is_Blk=-shavian}', "");
    Expect(0, 66688, '\p{Is_Blk=-shavian}', "");
    Expect(1, 66688, '\p{^Is_Blk=-shavian}', "");
    Expect(1, 66688, '\P{Is_Blk=-shavian}', "");
    Expect(0, 66688, '\P{^Is_Blk=-shavian}', "");
    Error('\p{Block=:=  SHORTHAND_format_controls}');
    Error('\P{Block=:=  SHORTHAND_format_controls}');
    Expect(1, 113839, '\p{Block=:\AShorthand_Format_Controls\z:}', "");;
    Expect(0, 113840, '\p{Block=:\AShorthand_Format_Controls\z:}', "");;
    Expect(1, 113839, '\p{Block=shorthandformatcontrols}', "");
    Expect(0, 113839, '\p{^Block=shorthandformatcontrols}', "");
    Expect(0, 113839, '\P{Block=shorthandformatcontrols}', "");
    Expect(1, 113839, '\P{^Block=shorthandformatcontrols}', "");
    Expect(0, 113840, '\p{Block=shorthandformatcontrols}', "");
    Expect(1, 113840, '\p{^Block=shorthandformatcontrols}', "");
    Expect(1, 113840, '\P{Block=shorthandformatcontrols}', "");
    Expect(0, 113840, '\P{^Block=shorthandformatcontrols}', "");
    Expect(1, 113839, '\p{Block=:\Ashorthandformatcontrols\z:}', "");;
    Expect(0, 113840, '\p{Block=:\Ashorthandformatcontrols\z:}', "");;
    Expect(1, 113839, '\p{Block: _ SHORTHAND_Format_CONTROLS}', "");
    Expect(0, 113839, '\p{^Block: _ SHORTHAND_Format_CONTROLS}', "");
    Expect(0, 113839, '\P{Block: _ SHORTHAND_Format_CONTROLS}', "");
    Expect(1, 113839, '\P{^Block: _ SHORTHAND_Format_CONTROLS}', "");
    Expect(0, 113840, '\p{Block: _ SHORTHAND_Format_CONTROLS}', "");
    Expect(1, 113840, '\p{^Block: _ SHORTHAND_Format_CONTROLS}', "");
    Expect(1, 113840, '\P{Block: _ SHORTHAND_Format_CONTROLS}', "");
    Expect(0, 113840, '\P{^Block: _ SHORTHAND_Format_CONTROLS}', "");
    Error('\p{Blk::=  shorthand_format_controls}');
    Error('\P{Blk::=  shorthand_format_controls}');
    Expect(1, 113839, '\p{Blk=:\AShorthand_Format_Controls\z:}', "");;
    Expect(0, 113840, '\p{Blk=:\AShorthand_Format_Controls\z:}', "");;
    Expect(1, 113839, '\p{Blk=shorthandformatcontrols}', "");
    Expect(0, 113839, '\p{^Blk=shorthandformatcontrols}', "");
    Expect(0, 113839, '\P{Blk=shorthandformatcontrols}', "");
    Expect(1, 113839, '\P{^Blk=shorthandformatcontrols}', "");
    Expect(0, 113840, '\p{Blk=shorthandformatcontrols}', "");
    Expect(1, 113840, '\p{^Blk=shorthandformatcontrols}', "");
    Expect(1, 113840, '\P{Blk=shorthandformatcontrols}', "");
    Expect(0, 113840, '\P{^Blk=shorthandformatcontrols}', "");
    Expect(1, 113839, '\p{Blk=:\Ashorthandformatcontrols\z:}', "");;
    Expect(0, 113840, '\p{Blk=:\Ashorthandformatcontrols\z:}', "");;
    Expect(1, 113839, '\p{Blk=	shorthand_FORMAT_CONTROLS}', "");
    Expect(0, 113839, '\p{^Blk=	shorthand_FORMAT_CONTROLS}', "");
    Expect(0, 113839, '\P{Blk=	shorthand_FORMAT_CONTROLS}', "");
    Expect(1, 113839, '\P{^Blk=	shorthand_FORMAT_CONTROLS}', "");
    Expect(0, 113840, '\p{Blk=	shorthand_FORMAT_CONTROLS}', "");
    Expect(1, 113840, '\p{^Blk=	shorthand_FORMAT_CONTROLS}', "");
    Expect(1, 113840, '\P{Blk=	shorthand_FORMAT_CONTROLS}', "");
    Expect(0, 113840, '\P{^Blk=	shorthand_FORMAT_CONTROLS}', "");
    Error('\p{Is_Block=-/a/Shorthand_format_controls}');
    Error('\P{Is_Block=-/a/Shorthand_format_controls}');
    Expect(1, 113839, '\p{Is_Block=shorthandformatcontrols}', "");
    Expect(0, 113839, '\p{^Is_Block=shorthandformatcontrols}', "");
    Expect(0, 113839, '\P{Is_Block=shorthandformatcontrols}', "");
    Expect(1, 113839, '\P{^Is_Block=shorthandformatcontrols}', "");
    Expect(0, 113840, '\p{Is_Block=shorthandformatcontrols}', "");
    Expect(1, 113840, '\p{^Is_Block=shorthandformatcontrols}', "");
    Expect(1, 113840, '\P{Is_Block=shorthandformatcontrols}', "");
    Expect(0, 113840, '\P{^Is_Block=shorthandformatcontrols}', "");
    Expect(1, 113839, '\p{Is_Block=_	shorthand_Format_controls}', "");
    Expect(0, 113839, '\p{^Is_Block=_	shorthand_Format_controls}', "");
    Expect(0, 113839, '\P{Is_Block=_	shorthand_Format_controls}', "");
    Expect(1, 113839, '\P{^Is_Block=_	shorthand_Format_controls}', "");
    Expect(0, 113840, '\p{Is_Block=_	shorthand_Format_controls}', "");
    Expect(1, 113840, '\p{^Is_Block=_	shorthand_Format_controls}', "");
    Expect(1, 113840, '\P{Is_Block=_	shorthand_Format_controls}', "");
    Expect(0, 113840, '\P{^Is_Block=_	shorthand_Format_controls}', "");
    Error('\p{Is_Blk= /a/shorthand_Format_controls}');
    Error('\P{Is_Blk= /a/shorthand_Format_controls}');
    Expect(1, 113839, '\p{Is_Blk=shorthandformatcontrols}', "");
    Expect(0, 113839, '\p{^Is_Blk=shorthandformatcontrols}', "");
    Expect(0, 113839, '\P{Is_Blk=shorthandformatcontrols}', "");
    Expect(1, 113839, '\P{^Is_Blk=shorthandformatcontrols}', "");
    Expect(0, 113840, '\p{Is_Blk=shorthandformatcontrols}', "");
    Expect(1, 113840, '\p{^Is_Blk=shorthandformatcontrols}', "");
    Expect(1, 113840, '\P{Is_Blk=shorthandformatcontrols}', "");
    Expect(0, 113840, '\P{^Is_Blk=shorthandformatcontrols}', "");
    Expect(1, 113839, '\p{Is_Blk= SHORTHAND_Format_CONTROLS}', "");
    Expect(0, 113839, '\p{^Is_Blk= SHORTHAND_Format_CONTROLS}', "");
    Expect(0, 113839, '\P{Is_Blk= SHORTHAND_Format_CONTROLS}', "");
    Expect(1, 113839, '\P{^Is_Blk= SHORTHAND_Format_CONTROLS}', "");
    Expect(0, 113840, '\p{Is_Blk= SHORTHAND_Format_CONTROLS}', "");
    Expect(1, 113840, '\p{^Is_Blk= SHORTHAND_Format_CONTROLS}', "");
    Expect(1, 113840, '\P{Is_Blk= SHORTHAND_Format_CONTROLS}', "");
    Expect(0, 113840, '\P{^Is_Blk= SHORTHAND_Format_CONTROLS}', "");
    Error('\p{Block=_Siddham/a/}');
    Error('\P{Block=_Siddham/a/}');
    Expect(1, 71167, '\p{Block=:\ASiddham\z:}', "");;
    Expect(0, 71168, '\p{Block=:\ASiddham\z:}', "");;
    Expect(1, 71167, '\p{Block=siddham}', "");
    Expect(0, 71167, '\p{^Block=siddham}', "");
    Expect(0, 71167, '\P{Block=siddham}', "");
    Expect(1, 71167, '\P{^Block=siddham}', "");
    Expect(0, 71168, '\p{Block=siddham}', "");
    Expect(1, 71168, '\p{^Block=siddham}', "");
    Expect(1, 71168, '\P{Block=siddham}', "");
    Expect(0, 71168, '\P{^Block=siddham}', "");
    Expect(1, 71167, '\p{Block=:\Asiddham\z:}', "");;
    Expect(0, 71168, '\p{Block=:\Asiddham\z:}', "");;
    Expect(1, 71167, '\p{Block=- siddham}', "");
    Expect(0, 71167, '\p{^Block=- siddham}', "");
    Expect(0, 71167, '\P{Block=- siddham}', "");
    Expect(1, 71167, '\P{^Block=- siddham}', "");
    Expect(0, 71168, '\p{Block=- siddham}', "");
    Expect(1, 71168, '\p{^Block=- siddham}', "");
    Expect(1, 71168, '\P{Block=- siddham}', "");
    Expect(0, 71168, '\P{^Block=- siddham}', "");
    Error('\p{Blk=/a/ siddham}');
    Error('\P{Blk=/a/ siddham}');
    Expect(1, 71167, '\p{Blk=:\ASiddham\z:}', "");;
    Expect(0, 71168, '\p{Blk=:\ASiddham\z:}', "");;
    Expect(1, 71167, '\p{Blk=siddham}', "");
    Expect(0, 71167, '\p{^Blk=siddham}', "");
    Expect(0, 71167, '\P{Blk=siddham}', "");
    Expect(1, 71167, '\P{^Blk=siddham}', "");
    Expect(0, 71168, '\p{Blk=siddham}', "");
    Expect(1, 71168, '\p{^Blk=siddham}', "");
    Expect(1, 71168, '\P{Blk=siddham}', "");
    Expect(0, 71168, '\P{^Blk=siddham}', "");
    Expect(1, 71167, '\p{Blk=:\Asiddham\z:}', "");;
    Expect(0, 71168, '\p{Blk=:\Asiddham\z:}', "");;
    Expect(1, 71167, '\p{Blk=-SIDDHAM}', "");
    Expect(0, 71167, '\p{^Blk=-SIDDHAM}', "");
    Expect(0, 71167, '\P{Blk=-SIDDHAM}', "");
    Expect(1, 71167, '\P{^Blk=-SIDDHAM}', "");
    Expect(0, 71168, '\p{Blk=-SIDDHAM}', "");
    Expect(1, 71168, '\p{^Blk=-SIDDHAM}', "");
    Expect(1, 71168, '\P{Blk=-SIDDHAM}', "");
    Expect(0, 71168, '\P{^Blk=-SIDDHAM}', "");
    Error('\p{Is_Block=:=-_Siddham}');
    Error('\P{Is_Block=:=-_Siddham}');
    Expect(1, 71167, '\p{Is_Block:	siddham}', "");
    Expect(0, 71167, '\p{^Is_Block:	siddham}', "");
    Expect(0, 71167, '\P{Is_Block:	siddham}', "");
    Expect(1, 71167, '\P{^Is_Block:	siddham}', "");
    Expect(0, 71168, '\p{Is_Block:	siddham}', "");
    Expect(1, 71168, '\p{^Is_Block:	siddham}', "");
    Expect(1, 71168, '\P{Is_Block:	siddham}', "");
    Expect(0, 71168, '\P{^Is_Block:	siddham}', "");
    Expect(1, 71167, '\p{Is_Block=-_SIDDHAM}', "");
    Expect(0, 71167, '\p{^Is_Block=-_SIDDHAM}', "");
    Expect(0, 71167, '\P{Is_Block=-_SIDDHAM}', "");
    Expect(1, 71167, '\P{^Is_Block=-_SIDDHAM}', "");
    Expect(0, 71168, '\p{Is_Block=-_SIDDHAM}', "");
    Expect(1, 71168, '\p{^Is_Block=-_SIDDHAM}', "");
    Expect(1, 71168, '\P{Is_Block=-_SIDDHAM}', "");
    Expect(0, 71168, '\P{^Is_Block=-_SIDDHAM}', "");
    Error('\p{Is_Blk=:=-_Siddham}');
    Error('\P{Is_Blk=:=-_Siddham}');
    Expect(1, 71167, '\p{Is_Blk=siddham}', "");
    Expect(0, 71167, '\p{^Is_Blk=siddham}', "");
    Expect(0, 71167, '\P{Is_Blk=siddham}', "");
    Expect(1, 71167, '\P{^Is_Blk=siddham}', "");
    Expect(0, 71168, '\p{Is_Blk=siddham}', "");
    Expect(1, 71168, '\p{^Is_Blk=siddham}', "");
    Expect(1, 71168, '\P{Is_Blk=siddham}', "");
    Expect(0, 71168, '\P{^Is_Blk=siddham}', "");
    Expect(1, 71167, '\p{Is_Blk= SIDDHAM}', "");
    Expect(0, 71167, '\p{^Is_Blk= SIDDHAM}', "");
    Expect(0, 71167, '\P{Is_Blk= SIDDHAM}', "");
    Expect(1, 71167, '\P{^Is_Blk= SIDDHAM}', "");
    Expect(0, 71168, '\p{Is_Blk= SIDDHAM}', "");
    Expect(1, 71168, '\p{^Is_Blk= SIDDHAM}', "");
    Expect(1, 71168, '\P{Is_Blk= SIDDHAM}', "");
    Expect(0, 71168, '\P{^Is_Blk= SIDDHAM}', "");
    Error('\p{Block=	 Sinhala/a/}');
    Error('\P{Block=	 Sinhala/a/}');
    Expect(1, 3583, '\p{Block=:\ASinhala\z:}', "");;
    Expect(0, 3584, '\p{Block=:\ASinhala\z:}', "");;
    Expect(1, 3583, '\p{Block=sinhala}', "");
    Expect(0, 3583, '\p{^Block=sinhala}', "");
    Expect(0, 3583, '\P{Block=sinhala}', "");
    Expect(1, 3583, '\P{^Block=sinhala}', "");
    Expect(0, 3584, '\p{Block=sinhala}', "");
    Expect(1, 3584, '\p{^Block=sinhala}', "");
    Expect(1, 3584, '\P{Block=sinhala}', "");
    Expect(0, 3584, '\P{^Block=sinhala}', "");
    Expect(1, 3583, '\p{Block=:\Asinhala\z:}', "");;
    Expect(0, 3584, '\p{Block=:\Asinhala\z:}', "");;
    Expect(1, 3583, '\p{Block=-Sinhala}', "");
    Expect(0, 3583, '\p{^Block=-Sinhala}', "");
    Expect(0, 3583, '\P{Block=-Sinhala}', "");
    Expect(1, 3583, '\P{^Block=-Sinhala}', "");
    Expect(0, 3584, '\p{Block=-Sinhala}', "");
    Expect(1, 3584, '\p{^Block=-Sinhala}', "");
    Expect(1, 3584, '\P{Block=-Sinhala}', "");
    Expect(0, 3584, '\P{^Block=-Sinhala}', "");
    Error('\p{Blk=	-Sinhala:=}');
    Error('\P{Blk=	-Sinhala:=}');
    Expect(1, 3583, '\p{Blk=:\ASinhala\z:}', "");;
    Expect(0, 3584, '\p{Blk=:\ASinhala\z:}', "");;
    Expect(1, 3583, '\p{Blk=sinhala}', "");
    Expect(0, 3583, '\p{^Blk=sinhala}', "");
    Expect(0, 3583, '\P{Blk=sinhala}', "");
    Expect(1, 3583, '\P{^Blk=sinhala}', "");
    Expect(0, 3584, '\p{Blk=sinhala}', "");
    Expect(1, 3584, '\p{^Blk=sinhala}', "");
    Expect(1, 3584, '\P{Blk=sinhala}', "");
    Expect(0, 3584, '\P{^Blk=sinhala}', "");
    Expect(1, 3583, '\p{Blk=:\Asinhala\z:}', "");;
    Expect(0, 3584, '\p{Blk=:\Asinhala\z:}', "");;
    Expect(1, 3583, '\p{Blk=-_Sinhala}', "");
    Expect(0, 3583, '\p{^Blk=-_Sinhala}', "");
    Expect(0, 3583, '\P{Blk=-_Sinhala}', "");
    Expect(1, 3583, '\P{^Blk=-_Sinhala}', "");
    Expect(0, 3584, '\p{Blk=-_Sinhala}', "");
    Expect(1, 3584, '\p{^Blk=-_Sinhala}', "");
    Expect(1, 3584, '\P{Blk=-_Sinhala}', "");
    Expect(0, 3584, '\P{^Blk=-_Sinhala}', "");
    Error('\p{Is_Block:   :=  Sinhala}');
    Error('\P{Is_Block:   :=  Sinhala}');
    Expect(1, 3583, '\p{Is_Block=sinhala}', "");
    Expect(0, 3583, '\p{^Is_Block=sinhala}', "");
    Expect(0, 3583, '\P{Is_Block=sinhala}', "");
    Expect(1, 3583, '\P{^Is_Block=sinhala}', "");
    Expect(0, 3584, '\p{Is_Block=sinhala}', "");
    Expect(1, 3584, '\p{^Is_Block=sinhala}', "");
    Expect(1, 3584, '\P{Is_Block=sinhala}', "");
    Expect(0, 3584, '\P{^Is_Block=sinhala}', "");
    Expect(1, 3583, '\p{Is_Block=__sinhala}', "");
    Expect(0, 3583, '\p{^Is_Block=__sinhala}', "");
    Expect(0, 3583, '\P{Is_Block=__sinhala}', "");
    Expect(1, 3583, '\P{^Is_Block=__sinhala}', "");
    Expect(0, 3584, '\p{Is_Block=__sinhala}', "");
    Expect(1, 3584, '\p{^Is_Block=__sinhala}', "");
    Expect(1, 3584, '\P{Is_Block=__sinhala}', "");
    Expect(0, 3584, '\P{^Is_Block=__sinhala}', "");
    Error('\p{Is_Blk=	_Sinhala/a/}');
    Error('\P{Is_Blk=	_Sinhala/a/}');
    Expect(1, 3583, '\p{Is_Blk=sinhala}', "");
    Expect(0, 3583, '\p{^Is_Blk=sinhala}', "");
    Expect(0, 3583, '\P{Is_Blk=sinhala}', "");
    Expect(1, 3583, '\P{^Is_Blk=sinhala}', "");
    Expect(0, 3584, '\p{Is_Blk=sinhala}', "");
    Expect(1, 3584, '\p{^Is_Blk=sinhala}', "");
    Expect(1, 3584, '\P{Is_Blk=sinhala}', "");
    Expect(0, 3584, '\P{^Is_Blk=sinhala}', "");
    Expect(1, 3583, '\p{Is_Blk=	Sinhala}', "");
    Expect(0, 3583, '\p{^Is_Blk=	Sinhala}', "");
    Expect(0, 3583, '\P{Is_Blk=	Sinhala}', "");
    Expect(1, 3583, '\P{^Is_Blk=	Sinhala}', "");
    Expect(0, 3584, '\p{Is_Blk=	Sinhala}', "");
    Expect(1, 3584, '\p{^Is_Blk=	Sinhala}', "");
    Expect(1, 3584, '\P{Is_Blk=	Sinhala}', "");
    Expect(0, 3584, '\P{^Is_Blk=	Sinhala}', "");
    Error('\p{Block=-/a/sinhala_archaic_Numbers}');
    Error('\P{Block=-/a/sinhala_archaic_Numbers}');
    Expect(1, 70143, '\p{Block=:\ASinhala_Archaic_Numbers\z:}', "");;
    Expect(0, 70144, '\p{Block=:\ASinhala_Archaic_Numbers\z:}', "");;
    Expect(1, 70143, '\p{Block=sinhalaarchaicnumbers}', "");
    Expect(0, 70143, '\p{^Block=sinhalaarchaicnumbers}', "");
    Expect(0, 70143, '\P{Block=sinhalaarchaicnumbers}', "");
    Expect(1, 70143, '\P{^Block=sinhalaarchaicnumbers}', "");
    Expect(0, 70144, '\p{Block=sinhalaarchaicnumbers}', "");
    Expect(1, 70144, '\p{^Block=sinhalaarchaicnumbers}', "");
    Expect(1, 70144, '\P{Block=sinhalaarchaicnumbers}', "");
    Expect(0, 70144, '\P{^Block=sinhalaarchaicnumbers}', "");
    Expect(1, 70143, '\p{Block=:\Asinhalaarchaicnumbers\z:}', "");;
    Expect(0, 70144, '\p{Block=:\Asinhalaarchaicnumbers\z:}', "");;
    Expect(1, 70143, '\p{Block=		SINHALA_Archaic_Numbers}', "");
    Expect(0, 70143, '\p{^Block=		SINHALA_Archaic_Numbers}', "");
    Expect(0, 70143, '\P{Block=		SINHALA_Archaic_Numbers}', "");
    Expect(1, 70143, '\P{^Block=		SINHALA_Archaic_Numbers}', "");
    Expect(0, 70144, '\p{Block=		SINHALA_Archaic_Numbers}', "");
    Expect(1, 70144, '\p{^Block=		SINHALA_Archaic_Numbers}', "");
    Expect(1, 70144, '\P{Block=		SINHALA_Archaic_Numbers}', "");
    Expect(0, 70144, '\P{^Block=		SINHALA_Archaic_Numbers}', "");
    Error('\p{Blk=Sinhala_archaic_numbers:=}');
    Error('\P{Blk=Sinhala_archaic_numbers:=}');
    Expect(1, 70143, '\p{Blk=:\ASinhala_Archaic_Numbers\z:}', "");;
    Expect(0, 70144, '\p{Blk=:\ASinhala_Archaic_Numbers\z:}', "");;
    Expect(1, 70143, '\p{Blk=sinhalaarchaicnumbers}', "");
    Expect(0, 70143, '\p{^Blk=sinhalaarchaicnumbers}', "");
    Expect(0, 70143, '\P{Blk=sinhalaarchaicnumbers}', "");
    Expect(1, 70143, '\P{^Blk=sinhalaarchaicnumbers}', "");
    Expect(0, 70144, '\p{Blk=sinhalaarchaicnumbers}', "");
    Expect(1, 70144, '\p{^Blk=sinhalaarchaicnumbers}', "");
    Expect(1, 70144, '\P{Blk=sinhalaarchaicnumbers}', "");
    Expect(0, 70144, '\P{^Blk=sinhalaarchaicnumbers}', "");
    Expect(1, 70143, '\p{Blk=:\Asinhalaarchaicnumbers\z:}', "");;
    Expect(0, 70144, '\p{Blk=:\Asinhalaarchaicnumbers\z:}', "");;
    Expect(1, 70143, '\p{Blk=-SINHALA_Archaic_numbers}', "");
    Expect(0, 70143, '\p{^Blk=-SINHALA_Archaic_numbers}', "");
    Expect(0, 70143, '\P{Blk=-SINHALA_Archaic_numbers}', "");
    Expect(1, 70143, '\P{^Blk=-SINHALA_Archaic_numbers}', "");
    Expect(0, 70144, '\p{Blk=-SINHALA_Archaic_numbers}', "");
    Expect(1, 70144, '\p{^Blk=-SINHALA_Archaic_numbers}', "");
    Expect(1, 70144, '\P{Blk=-SINHALA_Archaic_numbers}', "");
    Expect(0, 70144, '\P{^Blk=-SINHALA_Archaic_numbers}', "");
    Error('\p{Is_Block=/a/ _SINHALA_Archaic_Numbers}');
    Error('\P{Is_Block=/a/ _SINHALA_Archaic_Numbers}');
    Expect(1, 70143, '\p{Is_Block:sinhalaarchaicnumbers}', "");
    Expect(0, 70143, '\p{^Is_Block:sinhalaarchaicnumbers}', "");
    Expect(0, 70143, '\P{Is_Block:sinhalaarchaicnumbers}', "");
    Expect(1, 70143, '\P{^Is_Block:sinhalaarchaicnumbers}', "");
    Expect(0, 70144, '\p{Is_Block:sinhalaarchaicnumbers}', "");
    Expect(1, 70144, '\p{^Is_Block:sinhalaarchaicnumbers}', "");
    Expect(1, 70144, '\P{Is_Block:sinhalaarchaicnumbers}', "");
    Expect(0, 70144, '\P{^Is_Block:sinhalaarchaicnumbers}', "");
    Expect(1, 70143, '\p{Is_Block=		SINHALA_Archaic_Numbers}', "");
    Expect(0, 70143, '\p{^Is_Block=		SINHALA_Archaic_Numbers}', "");
    Expect(0, 70143, '\P{Is_Block=		SINHALA_Archaic_Numbers}', "");
    Expect(1, 70143, '\P{^Is_Block=		SINHALA_Archaic_Numbers}', "");
    Expect(0, 70144, '\p{Is_Block=		SINHALA_Archaic_Numbers}', "");
    Expect(1, 70144, '\p{^Is_Block=		SINHALA_Archaic_Numbers}', "");
    Expect(1, 70144, '\P{Is_Block=		SINHALA_Archaic_Numbers}', "");
    Expect(0, 70144, '\P{^Is_Block=		SINHALA_Archaic_Numbers}', "");
    Error('\p{Is_Blk=_/a/Sinhala_Archaic_numbers}');
    Error('\P{Is_Blk=_/a/Sinhala_Archaic_numbers}');
    Expect(1, 70143, '\p{Is_Blk=sinhalaarchaicnumbers}', "");
    Expect(0, 70143, '\p{^Is_Blk=sinhalaarchaicnumbers}', "");
    Expect(0, 70143, '\P{Is_Blk=sinhalaarchaicnumbers}', "");
    Expect(1, 70143, '\P{^Is_Blk=sinhalaarchaicnumbers}', "");
    Expect(0, 70144, '\p{Is_Blk=sinhalaarchaicnumbers}', "");
    Expect(1, 70144, '\p{^Is_Blk=sinhalaarchaicnumbers}', "");
    Expect(1, 70144, '\P{Is_Blk=sinhalaarchaicnumbers}', "");
    Expect(0, 70144, '\P{^Is_Blk=sinhalaarchaicnumbers}', "");
    Expect(1, 70143, '\p{Is_Blk=-sinhala_Archaic_numbers}', "");
    Expect(0, 70143, '\p{^Is_Blk=-sinhala_Archaic_numbers}', "");
    Expect(0, 70143, '\P{Is_Blk=-sinhala_Archaic_numbers}', "");
    Expect(1, 70143, '\P{^Is_Blk=-sinhala_Archaic_numbers}', "");
    Expect(0, 70144, '\p{Is_Blk=-sinhala_Archaic_numbers}', "");
    Expect(1, 70144, '\p{^Is_Blk=-sinhala_Archaic_numbers}', "");
    Expect(1, 70144, '\P{Is_Blk=-sinhala_Archaic_numbers}', "");
    Expect(0, 70144, '\P{^Is_Blk=-sinhala_Archaic_numbers}', "");
    Error('\p{Block= small_Form_Variants/a/}');
    Error('\P{Block= small_Form_Variants/a/}');
    Expect(1, 65135, '\p{Block=:\ASmall_Form_Variants\z:}', "");;
    Expect(0, 65136, '\p{Block=:\ASmall_Form_Variants\z:}', "");;
    Expect(1, 65135, '\p{Block=smallformvariants}', "");
    Expect(0, 65135, '\p{^Block=smallformvariants}', "");
    Expect(0, 65135, '\P{Block=smallformvariants}', "");
    Expect(1, 65135, '\P{^Block=smallformvariants}', "");
    Expect(0, 65136, '\p{Block=smallformvariants}', "");
    Expect(1, 65136, '\p{^Block=smallformvariants}', "");
    Expect(1, 65136, '\P{Block=smallformvariants}', "");
    Expect(0, 65136, '\P{^Block=smallformvariants}', "");
    Expect(1, 65135, '\p{Block=:\Asmallformvariants\z:}', "");;
    Expect(0, 65136, '\p{Block=:\Asmallformvariants\z:}', "");;
    Expect(1, 65135, '\p{Block= 	SMALL_Form_variants}', "");
    Expect(0, 65135, '\p{^Block= 	SMALL_Form_variants}', "");
    Expect(0, 65135, '\P{Block= 	SMALL_Form_variants}', "");
    Expect(1, 65135, '\P{^Block= 	SMALL_Form_variants}', "");
    Expect(0, 65136, '\p{Block= 	SMALL_Form_variants}', "");
    Expect(1, 65136, '\p{^Block= 	SMALL_Form_variants}', "");
    Expect(1, 65136, '\P{Block= 	SMALL_Form_variants}', "");
    Expect(0, 65136, '\P{^Block= 	SMALL_Form_variants}', "");
    Error('\p{Blk:   -/a/SMALL_Forms}');
    Error('\P{Blk:   -/a/SMALL_Forms}');
    Expect(1, 65135, '\p{Blk=:\ASmall_Forms\z:}', "");;
    Expect(0, 65136, '\p{Blk=:\ASmall_Forms\z:}', "");;
    Expect(1, 65135, '\p{Blk=smallforms}', "");
    Expect(0, 65135, '\p{^Blk=smallforms}', "");
    Expect(0, 65135, '\P{Blk=smallforms}', "");
    Expect(1, 65135, '\P{^Blk=smallforms}', "");
    Expect(0, 65136, '\p{Blk=smallforms}', "");
    Expect(1, 65136, '\p{^Blk=smallforms}', "");
    Expect(1, 65136, '\P{Blk=smallforms}', "");
    Expect(0, 65136, '\P{^Blk=smallforms}', "");
    Expect(1, 65135, '\p{Blk=:\Asmallforms\z:}', "");;
    Expect(0, 65136, '\p{Blk=:\Asmallforms\z:}', "");;
    Expect(1, 65135, '\p{Blk:_	Small_Forms}', "");
    Expect(0, 65135, '\p{^Blk:_	Small_Forms}', "");
    Expect(0, 65135, '\P{Blk:_	Small_Forms}', "");
    Expect(1, 65135, '\P{^Blk:_	Small_Forms}', "");
    Expect(0, 65136, '\p{Blk:_	Small_Forms}', "");
    Expect(1, 65136, '\p{^Blk:_	Small_Forms}', "");
    Expect(1, 65136, '\P{Blk:_	Small_Forms}', "");
    Expect(0, 65136, '\P{^Blk:_	Small_Forms}', "");
    Error('\p{Is_Block=/a/Small_form_Variants}');
    Error('\P{Is_Block=/a/Small_form_Variants}');
    Expect(1, 65135, '\p{Is_Block=smallformvariants}', "");
    Expect(0, 65135, '\p{^Is_Block=smallformvariants}', "");
    Expect(0, 65135, '\P{Is_Block=smallformvariants}', "");
    Expect(1, 65135, '\P{^Is_Block=smallformvariants}', "");
    Expect(0, 65136, '\p{Is_Block=smallformvariants}', "");
    Expect(1, 65136, '\p{^Is_Block=smallformvariants}', "");
    Expect(1, 65136, '\P{Is_Block=smallformvariants}', "");
    Expect(0, 65136, '\P{^Is_Block=smallformvariants}', "");
    Expect(1, 65135, '\p{Is_Block=_	Small_FORM_VARIANTS}', "");
    Expect(0, 65135, '\p{^Is_Block=_	Small_FORM_VARIANTS}', "");
    Expect(0, 65135, '\P{Is_Block=_	Small_FORM_VARIANTS}', "");
    Expect(1, 65135, '\P{^Is_Block=_	Small_FORM_VARIANTS}', "");
    Expect(0, 65136, '\p{Is_Block=_	Small_FORM_VARIANTS}', "");
    Expect(1, 65136, '\p{^Is_Block=_	Small_FORM_VARIANTS}', "");
    Expect(1, 65136, '\P{Is_Block=_	Small_FORM_VARIANTS}', "");
    Expect(0, 65136, '\P{^Is_Block=_	Small_FORM_VARIANTS}', "");
    Error('\p{Is_Blk: -/a/SMALL_FORMS}');
    Error('\P{Is_Blk: -/a/SMALL_FORMS}');
    Expect(1, 65135, '\p{Is_Blk: smallforms}', "");
    Expect(0, 65135, '\p{^Is_Blk: smallforms}', "");
    Expect(0, 65135, '\P{Is_Blk: smallforms}', "");
    Expect(1, 65135, '\P{^Is_Blk: smallforms}', "");
    Expect(0, 65136, '\p{Is_Blk: smallforms}', "");
    Expect(1, 65136, '\p{^Is_Blk: smallforms}', "");
    Expect(1, 65136, '\P{Is_Blk: smallforms}', "");
    Expect(0, 65136, '\P{^Is_Blk: smallforms}', "");
    Expect(1, 65135, '\p{Is_Blk=-small_Forms}', "");
    Expect(0, 65135, '\p{^Is_Blk=-small_Forms}', "");
    Expect(0, 65135, '\P{Is_Blk=-small_Forms}', "");
    Expect(1, 65135, '\P{^Is_Blk=-small_Forms}', "");
    Expect(0, 65136, '\p{Is_Blk=-small_Forms}', "");
    Expect(1, 65136, '\p{^Is_Blk=-small_Forms}', "");
    Expect(1, 65136, '\P{Is_Blk=-small_Forms}', "");
    Expect(0, 65136, '\P{^Is_Blk=-small_Forms}', "");
    Error('\p{Block=/a/	_SMALL_kana_Extension}');
    Error('\P{Block=/a/	_SMALL_kana_Extension}');
    Expect(1, 110959, '\p{Block=:\ASmall_Kana_Extension\z:}', "");;
    Expect(0, 110960, '\p{Block=:\ASmall_Kana_Extension\z:}', "");;
    Expect(1, 110959, '\p{Block=smallkanaextension}', "");
    Expect(0, 110959, '\p{^Block=smallkanaextension}', "");
    Expect(0, 110959, '\P{Block=smallkanaextension}', "");
    Expect(1, 110959, '\P{^Block=smallkanaextension}', "");
    Expect(0, 110960, '\p{Block=smallkanaextension}', "");
    Expect(1, 110960, '\p{^Block=smallkanaextension}', "");
    Expect(1, 110960, '\P{Block=smallkanaextension}', "");
    Expect(0, 110960, '\P{^Block=smallkanaextension}', "");
    Expect(1, 110959, '\p{Block=:\Asmallkanaextension\z:}', "");;
    Expect(0, 110960, '\p{Block=:\Asmallkanaextension\z:}', "");;
    Expect(1, 110959, '\p{Block= 	SMALL_kana_extension}', "");
    Expect(0, 110959, '\p{^Block= 	SMALL_kana_extension}', "");
    Expect(0, 110959, '\P{Block= 	SMALL_kana_extension}', "");
    Expect(1, 110959, '\P{^Block= 	SMALL_kana_extension}', "");
    Expect(0, 110960, '\p{Block= 	SMALL_kana_extension}', "");
    Expect(1, 110960, '\p{^Block= 	SMALL_kana_extension}', "");
    Expect(1, 110960, '\P{Block= 	SMALL_kana_extension}', "");
    Expect(0, 110960, '\P{^Block= 	SMALL_kana_extension}', "");
    Error('\p{Blk=/a/ SMALL_Kana_Ext}');
    Error('\P{Blk=/a/ SMALL_Kana_Ext}');
    Expect(1, 110959, '\p{Blk=:\ASmall_Kana_Ext\z:}', "");;
    Expect(0, 110960, '\p{Blk=:\ASmall_Kana_Ext\z:}', "");;
    Expect(1, 110959, '\p{Blk=smallkanaext}', "");
    Expect(0, 110959, '\p{^Blk=smallkanaext}', "");
    Expect(0, 110959, '\P{Blk=smallkanaext}', "");
    Expect(1, 110959, '\P{^Blk=smallkanaext}', "");
    Expect(0, 110960, '\p{Blk=smallkanaext}', "");
    Expect(1, 110960, '\p{^Blk=smallkanaext}', "");
    Expect(1, 110960, '\P{Blk=smallkanaext}', "");
    Expect(0, 110960, '\P{^Blk=smallkanaext}', "");
    Expect(1, 110959, '\p{Blk=:\Asmallkanaext\z:}', "");;
    Expect(0, 110960, '\p{Blk=:\Asmallkanaext\z:}', "");;
    Expect(1, 110959, '\p{Blk=_ small_KANA_EXT}', "");
    Expect(0, 110959, '\p{^Blk=_ small_KANA_EXT}', "");
    Expect(0, 110959, '\P{Blk=_ small_KANA_EXT}', "");
    Expect(1, 110959, '\P{^Blk=_ small_KANA_EXT}', "");
    Expect(0, 110960, '\p{Blk=_ small_KANA_EXT}', "");
    Expect(1, 110960, '\p{^Blk=_ small_KANA_EXT}', "");
    Expect(1, 110960, '\P{Blk=_ small_KANA_EXT}', "");
    Expect(0, 110960, '\P{^Blk=_ small_KANA_EXT}', "");
    Error('\p{Is_Block=_:=Small_kana_extension}');
    Error('\P{Is_Block=_:=Small_kana_extension}');
    Expect(1, 110959, '\p{Is_Block=smallkanaextension}', "");
    Expect(0, 110959, '\p{^Is_Block=smallkanaextension}', "");
    Expect(0, 110959, '\P{Is_Block=smallkanaextension}', "");
    Expect(1, 110959, '\P{^Is_Block=smallkanaextension}', "");
    Expect(0, 110960, '\p{Is_Block=smallkanaextension}', "");
    Expect(1, 110960, '\p{^Is_Block=smallkanaextension}', "");
    Expect(1, 110960, '\P{Is_Block=smallkanaextension}', "");
    Expect(0, 110960, '\P{^Is_Block=smallkanaextension}', "");
    Expect(1, 110959, '\p{Is_Block= 	Small_Kana_extension}', "");
    Expect(0, 110959, '\p{^Is_Block= 	Small_Kana_extension}', "");
    Expect(0, 110959, '\P{Is_Block= 	Small_Kana_extension}', "");
    Expect(1, 110959, '\P{^Is_Block= 	Small_Kana_extension}', "");
    Expect(0, 110960, '\p{Is_Block= 	Small_Kana_extension}', "");
    Expect(1, 110960, '\p{^Is_Block= 	Small_Kana_extension}', "");
    Expect(1, 110960, '\P{Is_Block= 	Small_Kana_extension}', "");
    Expect(0, 110960, '\P{^Is_Block= 	Small_Kana_extension}', "");
    Error('\p{Is_Blk=:=_	SMALL_KANA_EXT}');
    Error('\P{Is_Blk=:=_	SMALL_KANA_EXT}');
    Expect(1, 110959, '\p{Is_Blk=smallkanaext}', "");
    Expect(0, 110959, '\p{^Is_Blk=smallkanaext}', "");
    Expect(0, 110959, '\P{Is_Blk=smallkanaext}', "");
    Expect(1, 110959, '\P{^Is_Blk=smallkanaext}', "");
    Expect(0, 110960, '\p{Is_Blk=smallkanaext}', "");
    Expect(1, 110960, '\p{^Is_Blk=smallkanaext}', "");
    Expect(1, 110960, '\P{Is_Blk=smallkanaext}', "");
    Expect(0, 110960, '\P{^Is_Blk=smallkanaext}', "");
    Expect(1, 110959, '\p{Is_Blk=	 small_KANA_Ext}', "");
    Expect(0, 110959, '\p{^Is_Blk=	 small_KANA_Ext}', "");
    Expect(0, 110959, '\P{Is_Blk=	 small_KANA_Ext}', "");
    Expect(1, 110959, '\P{^Is_Blk=	 small_KANA_Ext}', "");
    Expect(0, 110960, '\p{Is_Blk=	 small_KANA_Ext}', "");
    Expect(1, 110960, '\p{^Is_Blk=	 small_KANA_Ext}', "");
    Expect(1, 110960, '\P{Is_Blk=	 small_KANA_Ext}', "");
    Expect(0, 110960, '\P{^Is_Blk=	 small_KANA_Ext}', "");
    Error('\p{Block=_Sogdian:=}');
    Error('\P{Block=_Sogdian:=}');
    Expect(1, 69487, '\p{Block=:\ASogdian\z:}', "");;
    Expect(0, 69488, '\p{Block=:\ASogdian\z:}', "");;
    Expect(1, 69487, '\p{Block=sogdian}', "");
    Expect(0, 69487, '\p{^Block=sogdian}', "");
    Expect(0, 69487, '\P{Block=sogdian}', "");
    Expect(1, 69487, '\P{^Block=sogdian}', "");
    Expect(0, 69488, '\p{Block=sogdian}', "");
    Expect(1, 69488, '\p{^Block=sogdian}', "");
    Expect(1, 69488, '\P{Block=sogdian}', "");
    Expect(0, 69488, '\P{^Block=sogdian}', "");
    Expect(1, 69487, '\p{Block=:\Asogdian\z:}', "");;
    Expect(0, 69488, '\p{Block=:\Asogdian\z:}', "");;
    Expect(1, 69487, '\p{Block= Sogdian}', "");
    Expect(0, 69487, '\p{^Block= Sogdian}', "");
    Expect(0, 69487, '\P{Block= Sogdian}', "");
    Expect(1, 69487, '\P{^Block= Sogdian}', "");
    Expect(0, 69488, '\p{Block= Sogdian}', "");
    Expect(1, 69488, '\p{^Block= Sogdian}', "");
    Expect(1, 69488, '\P{Block= Sogdian}', "");
    Expect(0, 69488, '\P{^Block= Sogdian}', "");
    Error('\p{Blk:	-:=SOGDIAN}');
    Error('\P{Blk:	-:=SOGDIAN}');
    Expect(1, 69487, '\p{Blk=:\ASogdian\z:}', "");;
    Expect(0, 69488, '\p{Blk=:\ASogdian\z:}', "");;
    Expect(1, 69487, '\p{Blk=sogdian}', "");
    Expect(0, 69487, '\p{^Blk=sogdian}', "");
    Expect(0, 69487, '\P{Blk=sogdian}', "");
    Expect(1, 69487, '\P{^Blk=sogdian}', "");
    Expect(0, 69488, '\p{Blk=sogdian}', "");
    Expect(1, 69488, '\p{^Blk=sogdian}', "");
    Expect(1, 69488, '\P{Blk=sogdian}', "");
    Expect(0, 69488, '\P{^Blk=sogdian}', "");
    Expect(1, 69487, '\p{Blk=:\Asogdian\z:}', "");;
    Expect(0, 69488, '\p{Blk=:\Asogdian\z:}', "");;
    Expect(1, 69487, '\p{Blk=	-Sogdian}', "");
    Expect(0, 69487, '\p{^Blk=	-Sogdian}', "");
    Expect(0, 69487, '\P{Blk=	-Sogdian}', "");
    Expect(1, 69487, '\P{^Blk=	-Sogdian}', "");
    Expect(0, 69488, '\p{Blk=	-Sogdian}', "");
    Expect(1, 69488, '\p{^Blk=	-Sogdian}', "");
    Expect(1, 69488, '\P{Blk=	-Sogdian}', "");
    Expect(0, 69488, '\P{^Blk=	-Sogdian}', "");
    Error('\p{Is_Block=:=_-Sogdian}');
    Error('\P{Is_Block=:=_-Sogdian}');
    Expect(1, 69487, '\p{Is_Block=sogdian}', "");
    Expect(0, 69487, '\p{^Is_Block=sogdian}', "");
    Expect(0, 69487, '\P{Is_Block=sogdian}', "");
    Expect(1, 69487, '\P{^Is_Block=sogdian}', "");
    Expect(0, 69488, '\p{Is_Block=sogdian}', "");
    Expect(1, 69488, '\p{^Is_Block=sogdian}', "");
    Expect(1, 69488, '\P{Is_Block=sogdian}', "");
    Expect(0, 69488, '\P{^Is_Block=sogdian}', "");
    Expect(1, 69487, '\p{Is_Block= SOGDIAN}', "");
    Expect(0, 69487, '\p{^Is_Block= SOGDIAN}', "");
    Expect(0, 69487, '\P{Is_Block= SOGDIAN}', "");
    Expect(1, 69487, '\P{^Is_Block= SOGDIAN}', "");
    Expect(0, 69488, '\p{Is_Block= SOGDIAN}', "");
    Expect(1, 69488, '\p{^Is_Block= SOGDIAN}', "");
    Expect(1, 69488, '\P{Is_Block= SOGDIAN}', "");
    Expect(0, 69488, '\P{^Is_Block= SOGDIAN}', "");
    Error('\p{Is_Blk=:=	_SOGDIAN}');
    Error('\P{Is_Blk=:=	_SOGDIAN}');
    Expect(1, 69487, '\p{Is_Blk=sogdian}', "");
    Expect(0, 69487, '\p{^Is_Blk=sogdian}', "");
    Expect(0, 69487, '\P{Is_Blk=sogdian}', "");
    Expect(1, 69487, '\P{^Is_Blk=sogdian}', "");
    Expect(0, 69488, '\p{Is_Blk=sogdian}', "");
    Expect(1, 69488, '\p{^Is_Blk=sogdian}', "");
    Expect(1, 69488, '\P{Is_Blk=sogdian}', "");
    Expect(0, 69488, '\P{^Is_Blk=sogdian}', "");
    Expect(1, 69487, '\p{Is_Blk=	sogdian}', "");
    Expect(0, 69487, '\p{^Is_Blk=	sogdian}', "");
    Expect(0, 69487, '\P{Is_Blk=	sogdian}', "");
    Expect(1, 69487, '\P{^Is_Blk=	sogdian}', "");
    Expect(0, 69488, '\p{Is_Blk=	sogdian}', "");
    Expect(1, 69488, '\p{^Is_Blk=	sogdian}', "");
    Expect(1, 69488, '\P{Is_Blk=	sogdian}', "");
    Expect(0, 69488, '\P{^Is_Blk=	sogdian}', "");
    Error('\p{Block=_/a/SORA_Sompeng}');
    Error('\P{Block=_/a/SORA_Sompeng}');
    Expect(1, 69887, '\p{Block=:\ASora_Sompeng\z:}', "");;
    Expect(0, 69888, '\p{Block=:\ASora_Sompeng\z:}', "");;
    Expect(1, 69887, '\p{Block=sorasompeng}', "");
    Expect(0, 69887, '\p{^Block=sorasompeng}', "");
    Expect(0, 69887, '\P{Block=sorasompeng}', "");
    Expect(1, 69887, '\P{^Block=sorasompeng}', "");
    Expect(0, 69888, '\p{Block=sorasompeng}', "");
    Expect(1, 69888, '\p{^Block=sorasompeng}', "");
    Expect(1, 69888, '\P{Block=sorasompeng}', "");
    Expect(0, 69888, '\P{^Block=sorasompeng}', "");
    Expect(1, 69887, '\p{Block=:\Asorasompeng\z:}', "");;
    Expect(0, 69888, '\p{Block=:\Asorasompeng\z:}', "");;
    Expect(1, 69887, '\p{Block=sora_Sompeng}', "");
    Expect(0, 69887, '\p{^Block=sora_Sompeng}', "");
    Expect(0, 69887, '\P{Block=sora_Sompeng}', "");
    Expect(1, 69887, '\P{^Block=sora_Sompeng}', "");
    Expect(0, 69888, '\p{Block=sora_Sompeng}', "");
    Expect(1, 69888, '\p{^Block=sora_Sompeng}', "");
    Expect(1, 69888, '\P{Block=sora_Sompeng}', "");
    Expect(0, 69888, '\P{^Block=sora_Sompeng}', "");
    Error('\p{Blk: :=	-Sora_SOMPENG}');
    Error('\P{Blk: :=	-Sora_SOMPENG}');
    Expect(1, 69887, '\p{Blk=:\ASora_Sompeng\z:}', "");;
    Expect(0, 69888, '\p{Blk=:\ASora_Sompeng\z:}', "");;
    Expect(1, 69887, '\p{Blk:sorasompeng}', "");
    Expect(0, 69887, '\p{^Blk:sorasompeng}', "");
    Expect(0, 69887, '\P{Blk:sorasompeng}', "");
    Expect(1, 69887, '\P{^Blk:sorasompeng}', "");
    Expect(0, 69888, '\p{Blk:sorasompeng}', "");
    Expect(1, 69888, '\p{^Blk:sorasompeng}', "");
    Expect(1, 69888, '\P{Blk:sorasompeng}', "");
    Expect(0, 69888, '\P{^Blk:sorasompeng}', "");
    Expect(1, 69887, '\p{Blk=:\Asorasompeng\z:}', "");;
    Expect(0, 69888, '\p{Blk=:\Asorasompeng\z:}', "");;
    Expect(1, 69887, '\p{Blk=	sora_SOMPENG}', "");
    Expect(0, 69887, '\p{^Blk=	sora_SOMPENG}', "");
    Expect(0, 69887, '\P{Blk=	sora_SOMPENG}', "");
    Expect(1, 69887, '\P{^Blk=	sora_SOMPENG}', "");
    Expect(0, 69888, '\p{Blk=	sora_SOMPENG}', "");
    Expect(1, 69888, '\p{^Blk=	sora_SOMPENG}', "");
    Expect(1, 69888, '\P{Blk=	sora_SOMPENG}', "");
    Expect(0, 69888, '\P{^Blk=	sora_SOMPENG}', "");
    Error('\p{Is_Block=/a/sora_Sompeng}');
    Error('\P{Is_Block=/a/sora_Sompeng}');
    Expect(1, 69887, '\p{Is_Block=sorasompeng}', "");
    Expect(0, 69887, '\p{^Is_Block=sorasompeng}', "");
    Expect(0, 69887, '\P{Is_Block=sorasompeng}', "");
    Expect(1, 69887, '\P{^Is_Block=sorasompeng}', "");
    Expect(0, 69888, '\p{Is_Block=sorasompeng}', "");
    Expect(1, 69888, '\p{^Is_Block=sorasompeng}', "");
    Expect(1, 69888, '\P{Is_Block=sorasompeng}', "");
    Expect(0, 69888, '\P{^Is_Block=sorasompeng}', "");
    Expect(1, 69887, '\p{Is_Block= sora_SOMPENG}', "");
    Expect(0, 69887, '\p{^Is_Block= sora_SOMPENG}', "");
    Expect(0, 69887, '\P{Is_Block= sora_SOMPENG}', "");
    Expect(1, 69887, '\P{^Is_Block= sora_SOMPENG}', "");
    Expect(0, 69888, '\p{Is_Block= sora_SOMPENG}', "");
    Expect(1, 69888, '\p{^Is_Block= sora_SOMPENG}', "");
    Expect(1, 69888, '\P{Is_Block= sora_SOMPENG}', "");
    Expect(0, 69888, '\P{^Is_Block= sora_SOMPENG}', "");
    Error('\p{Is_Blk=_Sora_sompeng:=}');
    Error('\P{Is_Blk=_Sora_sompeng:=}');
    Expect(1, 69887, '\p{Is_Blk=sorasompeng}', "");
    Expect(0, 69887, '\p{^Is_Blk=sorasompeng}', "");
    Expect(0, 69887, '\P{Is_Blk=sorasompeng}', "");
    Expect(1, 69887, '\P{^Is_Blk=sorasompeng}', "");
    Expect(0, 69888, '\p{Is_Blk=sorasompeng}', "");
    Expect(1, 69888, '\p{^Is_Blk=sorasompeng}', "");
    Expect(1, 69888, '\P{Is_Blk=sorasompeng}', "");
    Expect(0, 69888, '\P{^Is_Blk=sorasompeng}', "");
    Expect(1, 69887, '\p{Is_Blk=		Sora_Sompeng}', "");
    Expect(0, 69887, '\p{^Is_Blk=		Sora_Sompeng}', "");
    Expect(0, 69887, '\P{Is_Blk=		Sora_Sompeng}', "");
    Expect(1, 69887, '\P{^Is_Blk=		Sora_Sompeng}', "");
    Expect(0, 69888, '\p{Is_Blk=		Sora_Sompeng}', "");
    Expect(1, 69888, '\p{^Is_Blk=		Sora_Sompeng}', "");
    Expect(1, 69888, '\P{Is_Blk=		Sora_Sompeng}', "");
    Expect(0, 69888, '\P{^Is_Blk=		Sora_Sompeng}', "");
    Error('\p{Block=-	Soyombo:=}');
    Error('\P{Block=-	Soyombo:=}');
    Expect(1, 72367, '\p{Block=:\ASoyombo\z:}', "");;
    Expect(0, 72368, '\p{Block=:\ASoyombo\z:}', "");;
    Expect(1, 72367, '\p{Block=soyombo}', "");
    Expect(0, 72367, '\p{^Block=soyombo}', "");
    Expect(0, 72367, '\P{Block=soyombo}', "");
    Expect(1, 72367, '\P{^Block=soyombo}', "");
    Expect(0, 72368, '\p{Block=soyombo}', "");
    Expect(1, 72368, '\p{^Block=soyombo}', "");
    Expect(1, 72368, '\P{Block=soyombo}', "");
    Expect(0, 72368, '\P{^Block=soyombo}', "");
    Expect(1, 72367, '\p{Block=:\Asoyombo\z:}', "");;
    Expect(0, 72368, '\p{Block=:\Asoyombo\z:}', "");;
    Expect(1, 72367, '\p{Block=__SOYOMBO}', "");
    Expect(0, 72367, '\p{^Block=__SOYOMBO}', "");
    Expect(0, 72367, '\P{Block=__SOYOMBO}', "");
    Expect(1, 72367, '\P{^Block=__SOYOMBO}', "");
    Expect(0, 72368, '\p{Block=__SOYOMBO}', "");
    Expect(1, 72368, '\p{^Block=__SOYOMBO}', "");
    Expect(1, 72368, '\P{Block=__SOYOMBO}', "");
    Expect(0, 72368, '\P{^Block=__SOYOMBO}', "");
    Error('\p{Blk:	/a/_-soyombo}');
    Error('\P{Blk:	/a/_-soyombo}');
    Expect(1, 72367, '\p{Blk=:\ASoyombo\z:}', "");;
    Expect(0, 72368, '\p{Blk=:\ASoyombo\z:}', "");;
    Expect(1, 72367, '\p{Blk=soyombo}', "");
    Expect(0, 72367, '\p{^Blk=soyombo}', "");
    Expect(0, 72367, '\P{Blk=soyombo}', "");
    Expect(1, 72367, '\P{^Blk=soyombo}', "");
    Expect(0, 72368, '\p{Blk=soyombo}', "");
    Expect(1, 72368, '\p{^Blk=soyombo}', "");
    Expect(1, 72368, '\P{Blk=soyombo}', "");
    Expect(0, 72368, '\P{^Blk=soyombo}', "");
    Expect(1, 72367, '\p{Blk=:\Asoyombo\z:}', "");;
    Expect(0, 72368, '\p{Blk=:\Asoyombo\z:}', "");;
    Expect(1, 72367, '\p{Blk=-Soyombo}', "");
    Expect(0, 72367, '\p{^Blk=-Soyombo}', "");
    Expect(0, 72367, '\P{Blk=-Soyombo}', "");
    Expect(1, 72367, '\P{^Blk=-Soyombo}', "");
    Expect(0, 72368, '\p{Blk=-Soyombo}', "");
    Expect(1, 72368, '\p{^Blk=-Soyombo}', "");
    Expect(1, 72368, '\P{Blk=-Soyombo}', "");
    Expect(0, 72368, '\P{^Blk=-Soyombo}', "");
    Error('\p{Is_Block=/a/Soyombo}');
    Error('\P{Is_Block=/a/Soyombo}');
    Expect(1, 72367, '\p{Is_Block=soyombo}', "");
    Expect(0, 72367, '\p{^Is_Block=soyombo}', "");
    Expect(0, 72367, '\P{Is_Block=soyombo}', "");
    Expect(1, 72367, '\P{^Is_Block=soyombo}', "");
    Expect(0, 72368, '\p{Is_Block=soyombo}', "");
    Expect(1, 72368, '\p{^Is_Block=soyombo}', "");
    Expect(1, 72368, '\P{Is_Block=soyombo}', "");
    Expect(0, 72368, '\P{^Is_Block=soyombo}', "");
    Expect(1, 72367, '\p{Is_Block=	Soyombo}', "");
    Expect(0, 72367, '\p{^Is_Block=	Soyombo}', "");
    Expect(0, 72367, '\P{Is_Block=	Soyombo}', "");
    Expect(1, 72367, '\P{^Is_Block=	Soyombo}', "");
    Expect(0, 72368, '\p{Is_Block=	Soyombo}', "");
    Expect(1, 72368, '\p{^Is_Block=	Soyombo}', "");
    Expect(1, 72368, '\P{Is_Block=	Soyombo}', "");
    Expect(0, 72368, '\P{^Is_Block=	Soyombo}', "");
    Error('\p{Is_Blk=	:=soyombo}');
    Error('\P{Is_Blk=	:=soyombo}');
    Expect(1, 72367, '\p{Is_Blk=soyombo}', "");
    Expect(0, 72367, '\p{^Is_Blk=soyombo}', "");
    Expect(0, 72367, '\P{Is_Blk=soyombo}', "");
    Expect(1, 72367, '\P{^Is_Blk=soyombo}', "");
    Expect(0, 72368, '\p{Is_Blk=soyombo}', "");
    Expect(1, 72368, '\p{^Is_Blk=soyombo}', "");
    Expect(1, 72368, '\P{Is_Blk=soyombo}', "");
    Expect(0, 72368, '\P{^Is_Blk=soyombo}', "");
    Expect(1, 72367, '\p{Is_Blk=-	soyombo}', "");
    Expect(0, 72367, '\p{^Is_Blk=-	soyombo}', "");
    Expect(0, 72367, '\P{Is_Blk=-	soyombo}', "");
    Expect(1, 72367, '\P{^Is_Blk=-	soyombo}', "");
    Expect(0, 72368, '\p{Is_Blk=-	soyombo}', "");
    Expect(1, 72368, '\p{^Is_Blk=-	soyombo}', "");
    Expect(1, 72368, '\P{Is_Blk=-	soyombo}', "");
    Expect(0, 72368, '\P{^Is_Blk=-	soyombo}', "");
    Error('\p{Block= Specials/a/}');
    Error('\P{Block= Specials/a/}');
    Expect(1, 65520, '\p{Block=:\ASpecials\z:}', "");;
    Expect(0, 65536, '\p{Block=:\ASpecials\z:}', "");;
    Expect(1, 65520, '\p{Block=specials}', "");
    Expect(0, 65520, '\p{^Block=specials}', "");
    Expect(0, 65520, '\P{Block=specials}', "");
    Expect(1, 65520, '\P{^Block=specials}', "");
    Expect(0, 65536, '\p{Block=specials}', "");
    Expect(1, 65536, '\p{^Block=specials}', "");
    Expect(1, 65536, '\P{Block=specials}', "");
    Expect(0, 65536, '\P{^Block=specials}', "");
    Expect(1, 65520, '\p{Block=:\Aspecials\z:}', "");;
    Expect(0, 65536, '\p{Block=:\Aspecials\z:}', "");;
    Expect(1, 65520, '\p{Block=  specials}', "");
    Expect(0, 65520, '\p{^Block=  specials}', "");
    Expect(0, 65520, '\P{Block=  specials}', "");
    Expect(1, 65520, '\P{^Block=  specials}', "");
    Expect(0, 65536, '\p{Block=  specials}', "");
    Expect(1, 65536, '\p{^Block=  specials}', "");
    Expect(1, 65536, '\P{Block=  specials}', "");
    Expect(0, 65536, '\P{^Block=  specials}', "");
    Error('\p{Blk=/a/	specials}');
    Error('\P{Blk=/a/	specials}');
    Expect(1, 65520, '\p{Blk=:\ASpecials\z:}', "");;
    Expect(0, 65536, '\p{Blk=:\ASpecials\z:}', "");;
    Expect(1, 65520, '\p{Blk=specials}', "");
    Expect(0, 65520, '\p{^Blk=specials}', "");
    Expect(0, 65520, '\P{Blk=specials}', "");
    Expect(1, 65520, '\P{^Blk=specials}', "");
    Expect(0, 65536, '\p{Blk=specials}', "");
    Expect(1, 65536, '\p{^Blk=specials}', "");
    Expect(1, 65536, '\P{Blk=specials}', "");
    Expect(0, 65536, '\P{^Blk=specials}', "");
    Expect(1, 65520, '\p{Blk=:\Aspecials\z:}', "");;
    Expect(0, 65536, '\p{Blk=:\Aspecials\z:}', "");;
    Expect(1, 65520, '\p{Blk:   		SPECIALS}', "");
    Expect(0, 65520, '\p{^Blk:   		SPECIALS}', "");
    Expect(0, 65520, '\P{Blk:   		SPECIALS}', "");
    Expect(1, 65520, '\P{^Blk:   		SPECIALS}', "");
    Expect(0, 65536, '\p{Blk:   		SPECIALS}', "");
    Expect(1, 65536, '\p{^Blk:   		SPECIALS}', "");
    Expect(1, 65536, '\P{Blk:   		SPECIALS}', "");
    Expect(0, 65536, '\P{^Blk:   		SPECIALS}', "");
    Error('\p{Is_Block=/a/-	specials}');
    Error('\P{Is_Block=/a/-	specials}');
    Expect(1, 65520, '\p{Is_Block=specials}', "");
    Expect(0, 65520, '\p{^Is_Block=specials}', "");
    Expect(0, 65520, '\P{Is_Block=specials}', "");
    Expect(1, 65520, '\P{^Is_Block=specials}', "");
    Expect(0, 65536, '\p{Is_Block=specials}', "");
    Expect(1, 65536, '\p{^Is_Block=specials}', "");
    Expect(1, 65536, '\P{Is_Block=specials}', "");
    Expect(0, 65536, '\P{^Is_Block=specials}', "");
    Expect(1, 65520, '\p{Is_Block=-SPECIALS}', "");
    Expect(0, 65520, '\p{^Is_Block=-SPECIALS}', "");
    Expect(0, 65520, '\P{Is_Block=-SPECIALS}', "");
    Expect(1, 65520, '\P{^Is_Block=-SPECIALS}', "");
    Expect(0, 65536, '\p{Is_Block=-SPECIALS}', "");
    Expect(1, 65536, '\p{^Is_Block=-SPECIALS}', "");
    Expect(1, 65536, '\P{Is_Block=-SPECIALS}', "");
    Expect(0, 65536, '\P{^Is_Block=-SPECIALS}', "");
    Error('\p{Is_Blk=:=	specials}');
    Error('\P{Is_Blk=:=	specials}');
    Expect(1, 65520, '\p{Is_Blk=specials}', "");
    Expect(0, 65520, '\p{^Is_Blk=specials}', "");
    Expect(0, 65520, '\P{Is_Blk=specials}', "");
    Expect(1, 65520, '\P{^Is_Blk=specials}', "");
    Expect(0, 65536, '\p{Is_Blk=specials}', "");
    Expect(1, 65536, '\p{^Is_Blk=specials}', "");
    Expect(1, 65536, '\P{Is_Blk=specials}', "");
    Expect(0, 65536, '\P{^Is_Blk=specials}', "");
    Expect(1, 65520, '\p{Is_Blk=_-Specials}', "");
    Expect(0, 65520, '\p{^Is_Blk=_-Specials}', "");
    Expect(0, 65520, '\P{Is_Blk=_-Specials}', "");
    Expect(1, 65520, '\P{^Is_Blk=_-Specials}', "");
    Expect(0, 65536, '\p{Is_Blk=_-Specials}', "");
    Expect(1, 65536, '\p{^Is_Blk=_-Specials}', "");
    Expect(1, 65536, '\P{Is_Blk=_-Specials}', "");
    Expect(0, 65536, '\P{^Is_Blk=_-Specials}', "");
    Error('\p{Block:	:=	sundanese}');
    Error('\P{Block:	:=	sundanese}');
    Expect(1, 7103, '\p{Block=:\ASundanese\z:}', "");;
    Expect(0, 7104, '\p{Block=:\ASundanese\z:}', "");;
    Expect(1, 7103, '\p{Block=sundanese}', "");
    Expect(0, 7103, '\p{^Block=sundanese}', "");
    Expect(0, 7103, '\P{Block=sundanese}', "");
    Expect(1, 7103, '\P{^Block=sundanese}', "");
    Expect(0, 7104, '\p{Block=sundanese}', "");
    Expect(1, 7104, '\p{^Block=sundanese}', "");
    Expect(1, 7104, '\P{Block=sundanese}', "");
    Expect(0, 7104, '\P{^Block=sundanese}', "");
    Expect(1, 7103, '\p{Block=:\Asundanese\z:}', "");;
    Expect(0, 7104, '\p{Block=:\Asundanese\z:}', "");;
    Expect(1, 7103, '\p{Block=_sundanese}', "");
    Expect(0, 7103, '\p{^Block=_sundanese}', "");
    Expect(0, 7103, '\P{Block=_sundanese}', "");
    Expect(1, 7103, '\P{^Block=_sundanese}', "");
    Expect(0, 7104, '\p{Block=_sundanese}', "");
    Expect(1, 7104, '\p{^Block=_sundanese}', "");
    Expect(1, 7104, '\P{Block=_sundanese}', "");
    Expect(0, 7104, '\P{^Block=_sundanese}', "");
    Error('\p{Blk= -sundanese/a/}');
    Error('\P{Blk= -sundanese/a/}');
    Expect(1, 7103, '\p{Blk=:\ASundanese\z:}', "");;
    Expect(0, 7104, '\p{Blk=:\ASundanese\z:}', "");;
    Expect(1, 7103, '\p{Blk=sundanese}', "");
    Expect(0, 7103, '\p{^Blk=sundanese}', "");
    Expect(0, 7103, '\P{Blk=sundanese}', "");
    Expect(1, 7103, '\P{^Blk=sundanese}', "");
    Expect(0, 7104, '\p{Blk=sundanese}', "");
    Expect(1, 7104, '\p{^Blk=sundanese}', "");
    Expect(1, 7104, '\P{Blk=sundanese}', "");
    Expect(0, 7104, '\P{^Blk=sundanese}', "");
    Expect(1, 7103, '\p{Blk=:\Asundanese\z:}', "");;
    Expect(0, 7104, '\p{Blk=:\Asundanese\z:}', "");;
    Expect(1, 7103, '\p{Blk= _Sundanese}', "");
    Expect(0, 7103, '\p{^Blk= _Sundanese}', "");
    Expect(0, 7103, '\P{Blk= _Sundanese}', "");
    Expect(1, 7103, '\P{^Blk= _Sundanese}', "");
    Expect(0, 7104, '\p{Blk= _Sundanese}', "");
    Expect(1, 7104, '\p{^Blk= _Sundanese}', "");
    Expect(1, 7104, '\P{Blk= _Sundanese}', "");
    Expect(0, 7104, '\P{^Blk= _Sundanese}', "");
    Error('\p{Is_Block=/a/ 	Sundanese}');
    Error('\P{Is_Block=/a/ 	Sundanese}');
    Expect(1, 7103, '\p{Is_Block=sundanese}', "");
    Expect(0, 7103, '\p{^Is_Block=sundanese}', "");
    Expect(0, 7103, '\P{Is_Block=sundanese}', "");
    Expect(1, 7103, '\P{^Is_Block=sundanese}', "");
    Expect(0, 7104, '\p{Is_Block=sundanese}', "");
    Expect(1, 7104, '\p{^Is_Block=sundanese}', "");
    Expect(1, 7104, '\P{Is_Block=sundanese}', "");
    Expect(0, 7104, '\P{^Is_Block=sundanese}', "");
    Expect(1, 7103, '\p{Is_Block=_sundanese}', "");
    Expect(0, 7103, '\p{^Is_Block=_sundanese}', "");
    Expect(0, 7103, '\P{Is_Block=_sundanese}', "");
    Expect(1, 7103, '\P{^Is_Block=_sundanese}', "");
    Expect(0, 7104, '\p{Is_Block=_sundanese}', "");
    Expect(1, 7104, '\p{^Is_Block=_sundanese}', "");
    Expect(1, 7104, '\P{Is_Block=_sundanese}', "");
    Expect(0, 7104, '\P{^Is_Block=_sundanese}', "");
    Error('\p{Is_Blk: _SUNDANESE:=}');
    Error('\P{Is_Blk: _SUNDANESE:=}');
    Expect(1, 7103, '\p{Is_Blk=sundanese}', "");
    Expect(0, 7103, '\p{^Is_Blk=sundanese}', "");
    Expect(0, 7103, '\P{Is_Blk=sundanese}', "");
    Expect(1, 7103, '\P{^Is_Blk=sundanese}', "");
    Expect(0, 7104, '\p{Is_Blk=sundanese}', "");
    Expect(1, 7104, '\p{^Is_Blk=sundanese}', "");
    Expect(1, 7104, '\P{Is_Blk=sundanese}', "");
    Expect(0, 7104, '\P{^Is_Blk=sundanese}', "");
    Expect(1, 7103, '\p{Is_Blk= sundanese}', "");
    Expect(0, 7103, '\p{^Is_Blk= sundanese}', "");
    Expect(0, 7103, '\P{Is_Blk= sundanese}', "");
    Expect(1, 7103, '\P{^Is_Blk= sundanese}', "");
    Expect(0, 7104, '\p{Is_Blk= sundanese}', "");
    Expect(1, 7104, '\p{^Is_Blk= sundanese}', "");
    Expect(1, 7104, '\P{Is_Blk= sundanese}', "");
    Expect(0, 7104, '\P{^Is_Blk= sundanese}', "");
    Error('\p{Block=  sundanese_SUPPLEMENT/a/}');
    Error('\P{Block=  sundanese_SUPPLEMENT/a/}');
    Expect(1, 7375, '\p{Block=:\ASundanese_Supplement\z:}', "");;
    Expect(0, 7376, '\p{Block=:\ASundanese_Supplement\z:}', "");;
    Expect(1, 7375, '\p{Block=sundanesesupplement}', "");
    Expect(0, 7375, '\p{^Block=sundanesesupplement}', "");
    Expect(0, 7375, '\P{Block=sundanesesupplement}', "");
    Expect(1, 7375, '\P{^Block=sundanesesupplement}', "");
    Expect(0, 7376, '\p{Block=sundanesesupplement}', "");
    Expect(1, 7376, '\p{^Block=sundanesesupplement}', "");
    Expect(1, 7376, '\P{Block=sundanesesupplement}', "");
    Expect(0, 7376, '\P{^Block=sundanesesupplement}', "");
    Expect(1, 7375, '\p{Block=:\Asundanesesupplement\z:}', "");;
    Expect(0, 7376, '\p{Block=:\Asundanesesupplement\z:}', "");;
    Expect(1, 7375, '\p{Block=-sundanese_supplement}', "");
    Expect(0, 7375, '\p{^Block=-sundanese_supplement}', "");
    Expect(0, 7375, '\P{Block=-sundanese_supplement}', "");
    Expect(1, 7375, '\P{^Block=-sundanese_supplement}', "");
    Expect(0, 7376, '\p{Block=-sundanese_supplement}', "");
    Expect(1, 7376, '\p{^Block=-sundanese_supplement}', "");
    Expect(1, 7376, '\P{Block=-sundanese_supplement}', "");
    Expect(0, 7376, '\P{^Block=-sundanese_supplement}', "");
    Error('\p{Blk=-:=Sundanese_SUP}');
    Error('\P{Blk=-:=Sundanese_SUP}');
    Expect(1, 7375, '\p{Blk=:\ASundanese_Sup\z:}', "");;
    Expect(0, 7376, '\p{Blk=:\ASundanese_Sup\z:}', "");;
    Expect(1, 7375, '\p{Blk:	sundanesesup}', "");
    Expect(0, 7375, '\p{^Blk:	sundanesesup}', "");
    Expect(0, 7375, '\P{Blk:	sundanesesup}', "");
    Expect(1, 7375, '\P{^Blk:	sundanesesup}', "");
    Expect(0, 7376, '\p{Blk:	sundanesesup}', "");
    Expect(1, 7376, '\p{^Blk:	sundanesesup}', "");
    Expect(1, 7376, '\P{Blk:	sundanesesup}', "");
    Expect(0, 7376, '\P{^Blk:	sundanesesup}', "");
    Expect(1, 7375, '\p{Blk=:\Asundanesesup\z:}', "");;
    Expect(0, 7376, '\p{Blk=:\Asundanesesup\z:}', "");;
    Expect(1, 7375, '\p{Blk=--sundanese_SUP}', "");
    Expect(0, 7375, '\p{^Blk=--sundanese_SUP}', "");
    Expect(0, 7375, '\P{Blk=--sundanese_SUP}', "");
    Expect(1, 7375, '\P{^Blk=--sundanese_SUP}', "");
    Expect(0, 7376, '\p{Blk=--sundanese_SUP}', "");
    Expect(1, 7376, '\p{^Blk=--sundanese_SUP}', "");
    Expect(1, 7376, '\P{Blk=--sundanese_SUP}', "");
    Expect(0, 7376, '\P{^Blk=--sundanese_SUP}', "");
    Error('\p{Is_Block=/a/	sundanese_Supplement}');
    Error('\P{Is_Block=/a/	sundanese_Supplement}');
    Expect(1, 7375, '\p{Is_Block=sundanesesupplement}', "");
    Expect(0, 7375, '\p{^Is_Block=sundanesesupplement}', "");
    Expect(0, 7375, '\P{Is_Block=sundanesesupplement}', "");
    Expect(1, 7375, '\P{^Is_Block=sundanesesupplement}', "");
    Expect(0, 7376, '\p{Is_Block=sundanesesupplement}', "");
    Expect(1, 7376, '\p{^Is_Block=sundanesesupplement}', "");
    Expect(1, 7376, '\P{Is_Block=sundanesesupplement}', "");
    Expect(0, 7376, '\P{^Is_Block=sundanesesupplement}', "");
    Expect(1, 7375, '\p{Is_Block:_-SUNDANESE_Supplement}', "");
    Expect(0, 7375, '\p{^Is_Block:_-SUNDANESE_Supplement}', "");
    Expect(0, 7375, '\P{Is_Block:_-SUNDANESE_Supplement}', "");
    Expect(1, 7375, '\P{^Is_Block:_-SUNDANESE_Supplement}', "");
    Expect(0, 7376, '\p{Is_Block:_-SUNDANESE_Supplement}', "");
    Expect(1, 7376, '\p{^Is_Block:_-SUNDANESE_Supplement}', "");
    Expect(1, 7376, '\P{Is_Block:_-SUNDANESE_Supplement}', "");
    Expect(0, 7376, '\P{^Is_Block:_-SUNDANESE_Supplement}', "");
    Error('\p{Is_Blk: :=_-Sundanese_Sup}');
    Error('\P{Is_Blk: :=_-Sundanese_Sup}');
    Expect(1, 7375, '\p{Is_Blk=sundanesesup}', "");
    Expect(0, 7375, '\p{^Is_Blk=sundanesesup}', "");
    Expect(0, 7375, '\P{Is_Blk=sundanesesup}', "");
    Expect(1, 7375, '\P{^Is_Blk=sundanesesup}', "");
    Expect(0, 7376, '\p{Is_Blk=sundanesesup}', "");
    Expect(1, 7376, '\p{^Is_Blk=sundanesesup}', "");
    Expect(1, 7376, '\P{Is_Blk=sundanesesup}', "");
    Expect(0, 7376, '\P{^Is_Blk=sundanesesup}', "");
    Expect(1, 7375, '\p{Is_Blk= Sundanese_Sup}', "");
    Expect(0, 7375, '\p{^Is_Blk= Sundanese_Sup}', "");
    Expect(0, 7375, '\P{Is_Blk= Sundanese_Sup}', "");
    Expect(1, 7375, '\P{^Is_Blk= Sundanese_Sup}', "");
    Expect(0, 7376, '\p{Is_Blk= Sundanese_Sup}', "");
    Expect(1, 7376, '\p{^Is_Blk= Sundanese_Sup}', "");
    Expect(1, 7376, '\P{Is_Blk= Sundanese_Sup}', "");
    Expect(0, 7376, '\P{^Is_Blk= Sundanese_Sup}', "");
    Error('\p{Block=-/a/SUPPLEMENTAL_ARROWS_A}');
    Error('\P{Block=-/a/SUPPLEMENTAL_ARROWS_A}');
    Expect(1, 10239, '\p{Block=:\ASupplemental_Arrows_A\z:}', "");;
    Expect(0, 10240, '\p{Block=:\ASupplemental_Arrows_A\z:}', "");;
    Expect(1, 10239, '\p{Block=supplementalarrowsa}', "");
    Expect(0, 10239, '\p{^Block=supplementalarrowsa}', "");
    Expect(0, 10239, '\P{Block=supplementalarrowsa}', "");
    Expect(1, 10239, '\P{^Block=supplementalarrowsa}', "");
    Expect(0, 10240, '\p{Block=supplementalarrowsa}', "");
    Expect(1, 10240, '\p{^Block=supplementalarrowsa}', "");
    Expect(1, 10240, '\P{Block=supplementalarrowsa}', "");
    Expect(0, 10240, '\P{^Block=supplementalarrowsa}', "");
    Expect(1, 10239, '\p{Block=:\Asupplementalarrowsa\z:}', "");;
    Expect(0, 10240, '\p{Block=:\Asupplementalarrowsa\z:}', "");;
    Expect(1, 10239, '\p{Block=-	SUPPLEMENTAL_ARROWS_A}', "");
    Expect(0, 10239, '\p{^Block=-	SUPPLEMENTAL_ARROWS_A}', "");
    Expect(0, 10239, '\P{Block=-	SUPPLEMENTAL_ARROWS_A}', "");
    Expect(1, 10239, '\P{^Block=-	SUPPLEMENTAL_ARROWS_A}', "");
    Expect(0, 10240, '\p{Block=-	SUPPLEMENTAL_ARROWS_A}', "");
    Expect(1, 10240, '\p{^Block=-	SUPPLEMENTAL_ARROWS_A}', "");
    Expect(1, 10240, '\P{Block=-	SUPPLEMENTAL_ARROWS_A}', "");
    Expect(0, 10240, '\P{^Block=-	SUPPLEMENTAL_ARROWS_A}', "");
    Error('\p{Blk=:=	Sup_Arrows_A}');
    Error('\P{Blk=:=	Sup_Arrows_A}');
    Expect(1, 10239, '\p{Blk=:\ASup_Arrows_A\z:}', "");;
    Expect(0, 10240, '\p{Blk=:\ASup_Arrows_A\z:}', "");;
    Expect(1, 10239, '\p{Blk=suparrowsa}', "");
    Expect(0, 10239, '\p{^Blk=suparrowsa}', "");
    Expect(0, 10239, '\P{Blk=suparrowsa}', "");
    Expect(1, 10239, '\P{^Blk=suparrowsa}', "");
    Expect(0, 10240, '\p{Blk=suparrowsa}', "");
    Expect(1, 10240, '\p{^Blk=suparrowsa}', "");
    Expect(1, 10240, '\P{Blk=suparrowsa}', "");
    Expect(0, 10240, '\P{^Blk=suparrowsa}', "");
    Expect(1, 10239, '\p{Blk=:\Asuparrowsa\z:}', "");;
    Expect(0, 10240, '\p{Blk=:\Asuparrowsa\z:}', "");;
    Expect(1, 10239, '\p{Blk=	Sup_Arrows_A}', "");
    Expect(0, 10239, '\p{^Blk=	Sup_Arrows_A}', "");
    Expect(0, 10239, '\P{Blk=	Sup_Arrows_A}', "");
    Expect(1, 10239, '\P{^Blk=	Sup_Arrows_A}', "");
    Expect(0, 10240, '\p{Blk=	Sup_Arrows_A}', "");
    Expect(1, 10240, '\p{^Blk=	Sup_Arrows_A}', "");
    Expect(1, 10240, '\P{Blk=	Sup_Arrows_A}', "");
    Expect(0, 10240, '\P{^Blk=	Sup_Arrows_A}', "");
    Error('\p{Is_Block=/a/ SUPPLEMENTAL_arrows_A}');
    Error('\P{Is_Block=/a/ SUPPLEMENTAL_arrows_A}');
    Expect(1, 10239, '\p{Is_Block=supplementalarrowsa}', "");
    Expect(0, 10239, '\p{^Is_Block=supplementalarrowsa}', "");
    Expect(0, 10239, '\P{Is_Block=supplementalarrowsa}', "");
    Expect(1, 10239, '\P{^Is_Block=supplementalarrowsa}', "");
    Expect(0, 10240, '\p{Is_Block=supplementalarrowsa}', "");
    Expect(1, 10240, '\p{^Is_Block=supplementalarrowsa}', "");
    Expect(1, 10240, '\P{Is_Block=supplementalarrowsa}', "");
    Expect(0, 10240, '\P{^Is_Block=supplementalarrowsa}', "");
    Expect(1, 10239, '\p{Is_Block:  Supplemental_ARROWS_a}', "");
    Expect(0, 10239, '\p{^Is_Block:  Supplemental_ARROWS_a}', "");
    Expect(0, 10239, '\P{Is_Block:  Supplemental_ARROWS_a}', "");
    Expect(1, 10239, '\P{^Is_Block:  Supplemental_ARROWS_a}', "");
    Expect(0, 10240, '\p{Is_Block:  Supplemental_ARROWS_a}', "");
    Expect(1, 10240, '\p{^Is_Block:  Supplemental_ARROWS_a}', "");
    Expect(1, 10240, '\P{Is_Block:  Supplemental_ARROWS_a}', "");
    Expect(0, 10240, '\P{^Is_Block:  Supplemental_ARROWS_a}', "");
    Error('\p{Is_Blk= /a/SUP_arrows_A}');
    Error('\P{Is_Blk= /a/SUP_arrows_A}');
    Expect(1, 10239, '\p{Is_Blk=suparrowsa}', "");
    Expect(0, 10239, '\p{^Is_Blk=suparrowsa}', "");
    Expect(0, 10239, '\P{Is_Blk=suparrowsa}', "");
    Expect(1, 10239, '\P{^Is_Blk=suparrowsa}', "");
    Expect(0, 10240, '\p{Is_Blk=suparrowsa}', "");
    Expect(1, 10240, '\p{^Is_Blk=suparrowsa}', "");
    Expect(1, 10240, '\P{Is_Blk=suparrowsa}', "");
    Expect(0, 10240, '\P{^Is_Blk=suparrowsa}', "");
    Expect(1, 10239, '\p{Is_Blk=Sup_Arrows_A}', "");
    Expect(0, 10239, '\p{^Is_Blk=Sup_Arrows_A}', "");
    Expect(0, 10239, '\P{Is_Blk=Sup_Arrows_A}', "");
    Expect(1, 10239, '\P{^Is_Blk=Sup_Arrows_A}', "");
    Expect(0, 10240, '\p{Is_Blk=Sup_Arrows_A}', "");
    Expect(1, 10240, '\p{^Is_Blk=Sup_Arrows_A}', "");
    Expect(1, 10240, '\P{Is_Blk=Sup_Arrows_A}', "");
    Expect(0, 10240, '\P{^Is_Blk=Sup_Arrows_A}', "");
    Error('\p{Block=:=	SUPPLEMENTAL_Arrows_B}');
    Error('\P{Block=:=	SUPPLEMENTAL_Arrows_B}');
    Expect(1, 10623, '\p{Block=:\ASupplemental_Arrows_B\z:}', "");;
    Expect(0, 10624, '\p{Block=:\ASupplemental_Arrows_B\z:}', "");;
    Expect(1, 10623, '\p{Block=supplementalarrowsb}', "");
    Expect(0, 10623, '\p{^Block=supplementalarrowsb}', "");
    Expect(0, 10623, '\P{Block=supplementalarrowsb}', "");
    Expect(1, 10623, '\P{^Block=supplementalarrowsb}', "");
    Expect(0, 10624, '\p{Block=supplementalarrowsb}', "");
    Expect(1, 10624, '\p{^Block=supplementalarrowsb}', "");
    Expect(1, 10624, '\P{Block=supplementalarrowsb}', "");
    Expect(0, 10624, '\P{^Block=supplementalarrowsb}', "");
    Expect(1, 10623, '\p{Block=:\Asupplementalarrowsb\z:}', "");;
    Expect(0, 10624, '\p{Block=:\Asupplementalarrowsb\z:}', "");;
    Expect(1, 10623, '\p{Block=	-supplemental_arrows_b}', "");
    Expect(0, 10623, '\p{^Block=	-supplemental_arrows_b}', "");
    Expect(0, 10623, '\P{Block=	-supplemental_arrows_b}', "");
    Expect(1, 10623, '\P{^Block=	-supplemental_arrows_b}', "");
    Expect(0, 10624, '\p{Block=	-supplemental_arrows_b}', "");
    Expect(1, 10624, '\p{^Block=	-supplemental_arrows_b}', "");
    Expect(1, 10624, '\P{Block=	-supplemental_arrows_b}', "");
    Expect(0, 10624, '\P{^Block=	-supplemental_arrows_b}', "");
    Error('\p{Blk:-	sup_Arrows_B/a/}');
    Error('\P{Blk:-	sup_Arrows_B/a/}');
    Expect(1, 10623, '\p{Blk=:\ASup_Arrows_B\z:}', "");;
    Expect(0, 10624, '\p{Blk=:\ASup_Arrows_B\z:}', "");;
    Expect(1, 10623, '\p{Blk=suparrowsb}', "");
    Expect(0, 10623, '\p{^Blk=suparrowsb}', "");
    Expect(0, 10623, '\P{Blk=suparrowsb}', "");
    Expect(1, 10623, '\P{^Blk=suparrowsb}', "");
    Expect(0, 10624, '\p{Blk=suparrowsb}', "");
    Expect(1, 10624, '\p{^Blk=suparrowsb}', "");
    Expect(1, 10624, '\P{Blk=suparrowsb}', "");
    Expect(0, 10624, '\P{^Blk=suparrowsb}', "");
    Expect(1, 10623, '\p{Blk=:\Asuparrowsb\z:}', "");;
    Expect(0, 10624, '\p{Blk=:\Asuparrowsb\z:}', "");;
    Expect(1, 10623, '\p{Blk:   -Sup_ARROWS_b}', "");
    Expect(0, 10623, '\p{^Blk:   -Sup_ARROWS_b}', "");
    Expect(0, 10623, '\P{Blk:   -Sup_ARROWS_b}', "");
    Expect(1, 10623, '\P{^Blk:   -Sup_ARROWS_b}', "");
    Expect(0, 10624, '\p{Blk:   -Sup_ARROWS_b}', "");
    Expect(1, 10624, '\p{^Blk:   -Sup_ARROWS_b}', "");
    Expect(1, 10624, '\P{Blk:   -Sup_ARROWS_b}', "");
    Expect(0, 10624, '\P{^Blk:   -Sup_ARROWS_b}', "");
    Error('\p{Is_Block=	/a/SUPPLEMENTAL_ARROWS_b}');
    Error('\P{Is_Block=	/a/SUPPLEMENTAL_ARROWS_b}');
    Expect(1, 10623, '\p{Is_Block=supplementalarrowsb}', "");
    Expect(0, 10623, '\p{^Is_Block=supplementalarrowsb}', "");
    Expect(0, 10623, '\P{Is_Block=supplementalarrowsb}', "");
    Expect(1, 10623, '\P{^Is_Block=supplementalarrowsb}', "");
    Expect(0, 10624, '\p{Is_Block=supplementalarrowsb}', "");
    Expect(1, 10624, '\p{^Is_Block=supplementalarrowsb}', "");
    Expect(1, 10624, '\P{Is_Block=supplementalarrowsb}', "");
    Expect(0, 10624, '\P{^Is_Block=supplementalarrowsb}', "");
    Expect(1, 10623, '\p{Is_Block=_Supplemental_arrows_B}', "");
    Expect(0, 10623, '\p{^Is_Block=_Supplemental_arrows_B}', "");
    Expect(0, 10623, '\P{Is_Block=_Supplemental_arrows_B}', "");
    Expect(1, 10623, '\P{^Is_Block=_Supplemental_arrows_B}', "");
    Expect(0, 10624, '\p{Is_Block=_Supplemental_arrows_B}', "");
    Expect(1, 10624, '\p{^Is_Block=_Supplemental_arrows_B}', "");
    Expect(1, 10624, '\P{Is_Block=_Supplemental_arrows_B}', "");
    Expect(0, 10624, '\P{^Is_Block=_Supplemental_arrows_B}', "");
    Error('\p{Is_Blk=:=	sup_ARROWS_B}');
    Error('\P{Is_Blk=:=	sup_ARROWS_B}');
    Expect(1, 10623, '\p{Is_Blk=suparrowsb}', "");
    Expect(0, 10623, '\p{^Is_Blk=suparrowsb}', "");
    Expect(0, 10623, '\P{Is_Blk=suparrowsb}', "");
    Expect(1, 10623, '\P{^Is_Blk=suparrowsb}', "");
    Expect(0, 10624, '\p{Is_Blk=suparrowsb}', "");
    Expect(1, 10624, '\p{^Is_Blk=suparrowsb}', "");
    Expect(1, 10624, '\P{Is_Blk=suparrowsb}', "");
    Expect(0, 10624, '\P{^Is_Blk=suparrowsb}', "");
    Expect(1, 10623, '\p{Is_Blk=-	Sup_Arrows_B}', "");
    Expect(0, 10623, '\p{^Is_Blk=-	Sup_Arrows_B}', "");
    Expect(0, 10623, '\P{Is_Blk=-	Sup_Arrows_B}', "");
    Expect(1, 10623, '\P{^Is_Blk=-	Sup_Arrows_B}', "");
    Expect(0, 10624, '\p{Is_Blk=-	Sup_Arrows_B}', "");
    Expect(1, 10624, '\p{^Is_Blk=-	Sup_Arrows_B}', "");
    Expect(1, 10624, '\P{Is_Blk=-	Sup_Arrows_B}', "");
    Expect(0, 10624, '\P{^Is_Blk=-	Sup_Arrows_B}', "");
    Error('\p{Block=:=_	supplemental_ARROWS_C}');
    Error('\P{Block=:=_	supplemental_ARROWS_C}');
    Expect(1, 129279, '\p{Block=:\ASupplemental_Arrows_C\z:}', "");;
    Expect(0, 129280, '\p{Block=:\ASupplemental_Arrows_C\z:}', "");;
    Expect(1, 129279, '\p{Block=supplementalarrowsc}', "");
    Expect(0, 129279, '\p{^Block=supplementalarrowsc}', "");
    Expect(0, 129279, '\P{Block=supplementalarrowsc}', "");
    Expect(1, 129279, '\P{^Block=supplementalarrowsc}', "");
    Expect(0, 129280, '\p{Block=supplementalarrowsc}', "");
    Expect(1, 129280, '\p{^Block=supplementalarrowsc}', "");
    Expect(1, 129280, '\P{Block=supplementalarrowsc}', "");
    Expect(0, 129280, '\P{^Block=supplementalarrowsc}', "");
    Expect(1, 129279, '\p{Block=:\Asupplementalarrowsc\z:}', "");;
    Expect(0, 129280, '\p{Block=:\Asupplementalarrowsc\z:}', "");;
    Expect(1, 129279, '\p{Block=-	SUPPLEMENTAL_ARROWS_C}', "");
    Expect(0, 129279, '\p{^Block=-	SUPPLEMENTAL_ARROWS_C}', "");
    Expect(0, 129279, '\P{Block=-	SUPPLEMENTAL_ARROWS_C}', "");
    Expect(1, 129279, '\P{^Block=-	SUPPLEMENTAL_ARROWS_C}', "");
    Expect(0, 129280, '\p{Block=-	SUPPLEMENTAL_ARROWS_C}', "");
    Expect(1, 129280, '\p{^Block=-	SUPPLEMENTAL_ARROWS_C}', "");
    Expect(1, 129280, '\P{Block=-	SUPPLEMENTAL_ARROWS_C}', "");
    Expect(0, 129280, '\P{^Block=-	SUPPLEMENTAL_ARROWS_C}', "");
    Error('\p{Blk=/a/  Sup_ARROWS_C}');
    Error('\P{Blk=/a/  Sup_ARROWS_C}');
    Expect(1, 129279, '\p{Blk=:\ASup_Arrows_C\z:}', "");;
    Expect(0, 129280, '\p{Blk=:\ASup_Arrows_C\z:}', "");;
    Expect(1, 129279, '\p{Blk=suparrowsc}', "");
    Expect(0, 129279, '\p{^Blk=suparrowsc}', "");
    Expect(0, 129279, '\P{Blk=suparrowsc}', "");
    Expect(1, 129279, '\P{^Blk=suparrowsc}', "");
    Expect(0, 129280, '\p{Blk=suparrowsc}', "");
    Expect(1, 129280, '\p{^Blk=suparrowsc}', "");
    Expect(1, 129280, '\P{Blk=suparrowsc}', "");
    Expect(0, 129280, '\P{^Blk=suparrowsc}', "");
    Expect(1, 129279, '\p{Blk=:\Asuparrowsc\z:}', "");;
    Expect(0, 129280, '\p{Blk=:\Asuparrowsc\z:}', "");;
    Expect(1, 129279, '\p{Blk=-Sup_Arrows_c}', "");
    Expect(0, 129279, '\p{^Blk=-Sup_Arrows_c}', "");
    Expect(0, 129279, '\P{Blk=-Sup_Arrows_c}', "");
    Expect(1, 129279, '\P{^Blk=-Sup_Arrows_c}', "");
    Expect(0, 129280, '\p{Blk=-Sup_Arrows_c}', "");
    Expect(1, 129280, '\p{^Blk=-Sup_Arrows_c}', "");
    Expect(1, 129280, '\P{Blk=-Sup_Arrows_c}', "");
    Expect(0, 129280, '\P{^Blk=-Sup_Arrows_c}', "");
    Error('\p{Is_Block:   :=-_Supplemental_ARROWS_C}');
    Error('\P{Is_Block:   :=-_Supplemental_ARROWS_C}');
    Expect(1, 129279, '\p{Is_Block=supplementalarrowsc}', "");
    Expect(0, 129279, '\p{^Is_Block=supplementalarrowsc}', "");
    Expect(0, 129279, '\P{Is_Block=supplementalarrowsc}', "");
    Expect(1, 129279, '\P{^Is_Block=supplementalarrowsc}', "");
    Expect(0, 129280, '\p{Is_Block=supplementalarrowsc}', "");
    Expect(1, 129280, '\p{^Is_Block=supplementalarrowsc}', "");
    Expect(1, 129280, '\P{Is_Block=supplementalarrowsc}', "");
    Expect(0, 129280, '\P{^Is_Block=supplementalarrowsc}', "");
    Expect(1, 129279, '\p{Is_Block=_supplemental_ARROWS_c}', "");
    Expect(0, 129279, '\p{^Is_Block=_supplemental_ARROWS_c}', "");
    Expect(0, 129279, '\P{Is_Block=_supplemental_ARROWS_c}', "");
    Expect(1, 129279, '\P{^Is_Block=_supplemental_ARROWS_c}', "");
    Expect(0, 129280, '\p{Is_Block=_supplemental_ARROWS_c}', "");
    Expect(1, 129280, '\p{^Is_Block=_supplemental_ARROWS_c}', "");
    Expect(1, 129280, '\P{Is_Block=_supplemental_ARROWS_c}', "");
    Expect(0, 129280, '\P{^Is_Block=_supplemental_ARROWS_c}', "");
    Error('\p{Is_Blk=-Sup_Arrows_C/a/}');
    Error('\P{Is_Blk=-Sup_Arrows_C/a/}');
    Expect(1, 129279, '\p{Is_Blk=suparrowsc}', "");
    Expect(0, 129279, '\p{^Is_Blk=suparrowsc}', "");
    Expect(0, 129279, '\P{Is_Blk=suparrowsc}', "");
    Expect(1, 129279, '\P{^Is_Blk=suparrowsc}', "");
    Expect(0, 129280, '\p{Is_Blk=suparrowsc}', "");
    Expect(1, 129280, '\p{^Is_Blk=suparrowsc}', "");
    Expect(1, 129280, '\P{Is_Blk=suparrowsc}', "");
    Expect(0, 129280, '\P{^Is_Blk=suparrowsc}', "");
    Expect(1, 129279, '\p{Is_Blk: --SUP_Arrows_C}', "");
    Expect(0, 129279, '\p{^Is_Blk: --SUP_Arrows_C}', "");
    Expect(0, 129279, '\P{Is_Blk: --SUP_Arrows_C}', "");
    Expect(1, 129279, '\P{^Is_Blk: --SUP_Arrows_C}', "");
    Expect(0, 129280, '\p{Is_Blk: --SUP_Arrows_C}', "");
    Expect(1, 129280, '\p{^Is_Blk: --SUP_Arrows_C}', "");
    Expect(1, 129280, '\P{Is_Blk: --SUP_Arrows_C}', "");
    Expect(0, 129280, '\P{^Is_Blk: --SUP_Arrows_C}', "");
    Error('\p{Block=/a/  Supplemental_Mathematical_Operators}');
    Error('\P{Block=/a/  Supplemental_Mathematical_Operators}');
    Expect(1, 11007, '\p{Block=:\ASupplemental_Mathematical_Operators\z:}', "");;
    Expect(0, 11008, '\p{Block=:\ASupplemental_Mathematical_Operators\z:}', "");;
    Expect(1, 11007, '\p{Block=supplementalmathematicaloperators}', "");
    Expect(0, 11007, '\p{^Block=supplementalmathematicaloperators}', "");
    Expect(0, 11007, '\P{Block=supplementalmathematicaloperators}', "");
    Expect(1, 11007, '\P{^Block=supplementalmathematicaloperators}', "");
    Expect(0, 11008, '\p{Block=supplementalmathematicaloperators}', "");
    Expect(1, 11008, '\p{^Block=supplementalmathematicaloperators}', "");
    Expect(1, 11008, '\P{Block=supplementalmathematicaloperators}', "");
    Expect(0, 11008, '\P{^Block=supplementalmathematicaloperators}', "");
    Expect(1, 11007, '\p{Block=:\Asupplementalmathematicaloperators\z:}', "");;
    Expect(0, 11008, '\p{Block=:\Asupplementalmathematicaloperators\z:}', "");;
    Expect(1, 11007, '\p{Block=	Supplemental_Mathematical_Operators}', "");
    Expect(0, 11007, '\p{^Block=	Supplemental_Mathematical_Operators}', "");
    Expect(0, 11007, '\P{Block=	Supplemental_Mathematical_Operators}', "");
    Expect(1, 11007, '\P{^Block=	Supplemental_Mathematical_Operators}', "");
    Expect(0, 11008, '\p{Block=	Supplemental_Mathematical_Operators}', "");
    Expect(1, 11008, '\p{^Block=	Supplemental_Mathematical_Operators}', "");
    Expect(1, 11008, '\P{Block=	Supplemental_Mathematical_Operators}', "");
    Expect(0, 11008, '\P{^Block=	Supplemental_Mathematical_Operators}', "");
    Error('\p{Blk=:=sup_Math_OPERATORS}');
    Error('\P{Blk=:=sup_Math_OPERATORS}');
    Expect(1, 11007, '\p{Blk=:\ASup_Math_Operators\z:}', "");;
    Expect(0, 11008, '\p{Blk=:\ASup_Math_Operators\z:}', "");;
    Expect(1, 11007, '\p{Blk: supmathoperators}', "");
    Expect(0, 11007, '\p{^Blk: supmathoperators}', "");
    Expect(0, 11007, '\P{Blk: supmathoperators}', "");
    Expect(1, 11007, '\P{^Blk: supmathoperators}', "");
    Expect(0, 11008, '\p{Blk: supmathoperators}', "");
    Expect(1, 11008, '\p{^Blk: supmathoperators}', "");
    Expect(1, 11008, '\P{Blk: supmathoperators}', "");
    Expect(0, 11008, '\P{^Blk: supmathoperators}', "");
    Expect(1, 11007, '\p{Blk=:\Asupmathoperators\z:}', "");;
    Expect(0, 11008, '\p{Blk=:\Asupmathoperators\z:}', "");;
    Expect(1, 11007, '\p{Blk=_	SUP_Math_OPERATORS}', "");
    Expect(0, 11007, '\p{^Blk=_	SUP_Math_OPERATORS}', "");
    Expect(0, 11007, '\P{Blk=_	SUP_Math_OPERATORS}', "");
    Expect(1, 11007, '\P{^Blk=_	SUP_Math_OPERATORS}', "");
    Expect(0, 11008, '\p{Blk=_	SUP_Math_OPERATORS}', "");
    Expect(1, 11008, '\p{^Blk=_	SUP_Math_OPERATORS}', "");
    Expect(1, 11008, '\P{Blk=_	SUP_Math_OPERATORS}', "");
    Expect(0, 11008, '\P{^Blk=_	SUP_Math_OPERATORS}', "");
    Error('\p{Is_Block=:=	_supplemental_mathematical_Operators}');
    Error('\P{Is_Block=:=	_supplemental_mathematical_Operators}');
    Expect(1, 11007, '\p{Is_Block=supplementalmathematicaloperators}', "");
    Expect(0, 11007, '\p{^Is_Block=supplementalmathematicaloperators}', "");
    Expect(0, 11007, '\P{Is_Block=supplementalmathematicaloperators}', "");
    Expect(1, 11007, '\P{^Is_Block=supplementalmathematicaloperators}', "");
    Expect(0, 11008, '\p{Is_Block=supplementalmathematicaloperators}', "");
    Expect(1, 11008, '\p{^Is_Block=supplementalmathematicaloperators}', "");
    Expect(1, 11008, '\P{Is_Block=supplementalmathematicaloperators}', "");
    Expect(0, 11008, '\P{^Is_Block=supplementalmathematicaloperators}', "");
    Expect(1, 11007, '\p{Is_Block:		Supplemental_mathematical_operators}', "");
    Expect(0, 11007, '\p{^Is_Block:		Supplemental_mathematical_operators}', "");
    Expect(0, 11007, '\P{Is_Block:		Supplemental_mathematical_operators}', "");
    Expect(1, 11007, '\P{^Is_Block:		Supplemental_mathematical_operators}', "");
    Expect(0, 11008, '\p{Is_Block:		Supplemental_mathematical_operators}', "");
    Expect(1, 11008, '\p{^Is_Block:		Supplemental_mathematical_operators}', "");
    Expect(1, 11008, '\P{Is_Block:		Supplemental_mathematical_operators}', "");
    Expect(0, 11008, '\P{^Is_Block:		Supplemental_mathematical_operators}', "");
    Error('\p{Is_Blk=__Sup_math_operators:=}');
    Error('\P{Is_Blk=__Sup_math_operators:=}');
    Expect(1, 11007, '\p{Is_Blk=supmathoperators}', "");
    Expect(0, 11007, '\p{^Is_Blk=supmathoperators}', "");
    Expect(0, 11007, '\P{Is_Blk=supmathoperators}', "");
    Expect(1, 11007, '\P{^Is_Blk=supmathoperators}', "");
    Expect(0, 11008, '\p{Is_Blk=supmathoperators}', "");
    Expect(1, 11008, '\p{^Is_Blk=supmathoperators}', "");
    Expect(1, 11008, '\P{Is_Blk=supmathoperators}', "");
    Expect(0, 11008, '\P{^Is_Blk=supmathoperators}', "");
    Expect(1, 11007, '\p{Is_Blk= -Sup_Math_Operators}', "");
    Expect(0, 11007, '\p{^Is_Blk= -Sup_Math_Operators}', "");
    Expect(0, 11007, '\P{Is_Blk= -Sup_Math_Operators}', "");
    Expect(1, 11007, '\P{^Is_Blk= -Sup_Math_Operators}', "");
    Expect(0, 11008, '\p{Is_Blk= -Sup_Math_Operators}', "");
    Expect(1, 11008, '\p{^Is_Blk= -Sup_Math_Operators}', "");
    Expect(1, 11008, '\P{Is_Blk= -Sup_Math_Operators}', "");
    Expect(0, 11008, '\P{^Is_Blk= -Sup_Math_Operators}', "");
    Error('\p{Block=:=	Supplementary_private_USE_area_A}');
    Error('\P{Block=:=	Supplementary_private_USE_area_A}');
    Expect(1, 983040, '\p{Block=:\ASupplementary_Private_Use_Area_A\z:}', "");;
    Expect(0, 1048576, '\p{Block=:\ASupplementary_Private_Use_Area_A\z:}', "");;
    Expect(1, 983040, '\p{Block=supplementaryprivateuseareaa}', "");
    Expect(0, 983040, '\p{^Block=supplementaryprivateuseareaa}', "");
    Expect(0, 983040, '\P{Block=supplementaryprivateuseareaa}', "");
    Expect(1, 983040, '\P{^Block=supplementaryprivateuseareaa}', "");
    Expect(0, 1048576, '\p{Block=supplementaryprivateuseareaa}', "");
    Expect(1, 1048576, '\p{^Block=supplementaryprivateuseareaa}', "");
    Expect(1, 1048576, '\P{Block=supplementaryprivateuseareaa}', "");
    Expect(0, 1048576, '\P{^Block=supplementaryprivateuseareaa}', "");
    Expect(1, 983040, '\p{Block=:\Asupplementaryprivateuseareaa\z:}', "");;
    Expect(0, 1048576, '\p{Block=:\Asupplementaryprivateuseareaa\z:}', "");;
    Expect(1, 983040, '\p{Block=--supplementary_private_USE_Area_a}', "");
    Expect(0, 983040, '\p{^Block=--supplementary_private_USE_Area_a}', "");
    Expect(0, 983040, '\P{Block=--supplementary_private_USE_Area_a}', "");
    Expect(1, 983040, '\P{^Block=--supplementary_private_USE_Area_a}', "");
    Expect(0, 1048576, '\p{Block=--supplementary_private_USE_Area_a}', "");
    Expect(1, 1048576, '\p{^Block=--supplementary_private_USE_Area_a}', "");
    Expect(1, 1048576, '\P{Block=--supplementary_private_USE_Area_a}', "");
    Expect(0, 1048576, '\P{^Block=--supplementary_private_USE_Area_a}', "");
    Error('\p{Blk=Sup_PUA_A:=}');
    Error('\P{Blk=Sup_PUA_A:=}');
    Expect(1, 983040, '\p{Blk=:\ASup_PUA_A\z:}', "");;
    Expect(0, 1048576, '\p{Blk=:\ASup_PUA_A\z:}', "");;
    Expect(1, 983040, '\p{Blk=suppuaa}', "");
    Expect(0, 983040, '\p{^Blk=suppuaa}', "");
    Expect(0, 983040, '\P{Blk=suppuaa}', "");
    Expect(1, 983040, '\P{^Blk=suppuaa}', "");
    Expect(0, 1048576, '\p{Blk=suppuaa}', "");
    Expect(1, 1048576, '\p{^Blk=suppuaa}', "");
    Expect(1, 1048576, '\P{Blk=suppuaa}', "");
    Expect(0, 1048576, '\P{^Blk=suppuaa}', "");
    Expect(1, 983040, '\p{Blk=:\Asuppuaa\z:}', "");;
    Expect(0, 1048576, '\p{Blk=:\Asuppuaa\z:}', "");;
    Expect(1, 983040, '\p{Blk=-sup_PUA_a}', "");
    Expect(0, 983040, '\p{^Blk=-sup_PUA_a}', "");
    Expect(0, 983040, '\P{Blk=-sup_PUA_a}', "");
    Expect(1, 983040, '\P{^Blk=-sup_PUA_a}', "");
    Expect(0, 1048576, '\p{Blk=-sup_PUA_a}', "");
    Expect(1, 1048576, '\p{^Blk=-sup_PUA_a}', "");
    Expect(1, 1048576, '\P{Blk=-sup_PUA_a}', "");
    Expect(0, 1048576, '\P{^Blk=-sup_PUA_a}', "");
    Error('\p{Is_Block=:=	-Supplementary_Private_Use_AREA_A}');
    Error('\P{Is_Block=:=	-Supplementary_Private_Use_AREA_A}');
    Expect(1, 983040, '\p{Is_Block=supplementaryprivateuseareaa}', "");
    Expect(0, 983040, '\p{^Is_Block=supplementaryprivateuseareaa}', "");
    Expect(0, 983040, '\P{Is_Block=supplementaryprivateuseareaa}', "");
    Expect(1, 983040, '\P{^Is_Block=supplementaryprivateuseareaa}', "");
    Expect(0, 1048576, '\p{Is_Block=supplementaryprivateuseareaa}', "");
    Expect(1, 1048576, '\p{^Is_Block=supplementaryprivateuseareaa}', "");
    Expect(1, 1048576, '\P{Is_Block=supplementaryprivateuseareaa}', "");
    Expect(0, 1048576, '\P{^Is_Block=supplementaryprivateuseareaa}', "");
    Expect(1, 983040, '\p{Is_Block= Supplementary_PRIVATE_Use_Area_A}', "");
    Expect(0, 983040, '\p{^Is_Block= Supplementary_PRIVATE_Use_Area_A}', "");
    Expect(0, 983040, '\P{Is_Block= Supplementary_PRIVATE_Use_Area_A}', "");
    Expect(1, 983040, '\P{^Is_Block= Supplementary_PRIVATE_Use_Area_A}', "");
    Expect(0, 1048576, '\p{Is_Block= Supplementary_PRIVATE_Use_Area_A}', "");
    Expect(1, 1048576, '\p{^Is_Block= Supplementary_PRIVATE_Use_Area_A}', "");
    Expect(1, 1048576, '\P{Is_Block= Supplementary_PRIVATE_Use_Area_A}', "");
    Expect(0, 1048576, '\P{^Is_Block= Supplementary_PRIVATE_Use_Area_A}', "");
    Error('\p{Is_Blk=	_SUP_PUA_A:=}');
    Error('\P{Is_Blk=	_SUP_PUA_A:=}');
    Expect(1, 983040, '\p{Is_Blk=suppuaa}', "");
    Expect(0, 983040, '\p{^Is_Blk=suppuaa}', "");
    Expect(0, 983040, '\P{Is_Blk=suppuaa}', "");
    Expect(1, 983040, '\P{^Is_Blk=suppuaa}', "");
    Expect(0, 1048576, '\p{Is_Blk=suppuaa}', "");
    Expect(1, 1048576, '\p{^Is_Blk=suppuaa}', "");
    Expect(1, 1048576, '\P{Is_Blk=suppuaa}', "");
    Expect(0, 1048576, '\P{^Is_Blk=suppuaa}', "");
    Expect(1, 983040, '\p{Is_Blk=	_Sup_PUA_a}', "");
    Expect(0, 983040, '\p{^Is_Blk=	_Sup_PUA_a}', "");
    Expect(0, 983040, '\P{Is_Blk=	_Sup_PUA_a}', "");
    Expect(1, 983040, '\P{^Is_Blk=	_Sup_PUA_a}', "");
    Expect(0, 1048576, '\p{Is_Blk=	_Sup_PUA_a}', "");
    Expect(1, 1048576, '\p{^Is_Blk=	_Sup_PUA_a}', "");
    Expect(1, 1048576, '\P{Is_Blk=	_Sup_PUA_a}', "");
    Expect(0, 1048576, '\P{^Is_Blk=	_Sup_PUA_a}', "");
    Error('\p{Block=_/a/SUPPLEMENTARY_Private_use_Area_B}');
    Error('\P{Block=_/a/SUPPLEMENTARY_Private_use_Area_B}');
    Expect(1, 1048576, '\p{Block=:\ASupplementary_Private_Use_Area_B\z:}', "");;
    Expect(0, 1, '\p{Block=:\ASupplementary_Private_Use_Area_B\z:}', "");;
    Expect(1, 1048576, '\p{Block=supplementaryprivateuseareab}', "");
    Expect(0, 1048576, '\p{^Block=supplementaryprivateuseareab}', "");
    Expect(0, 1048576, '\P{Block=supplementaryprivateuseareab}', "");
    Expect(1, 1048576, '\P{^Block=supplementaryprivateuseareab}', "");
    Expect(0, 1, '\p{Block=supplementaryprivateuseareab}', "");
    Expect(1, 1, '\p{^Block=supplementaryprivateuseareab}', "");
    Expect(1, 1, '\P{Block=supplementaryprivateuseareab}', "");
    Expect(0, 1, '\P{^Block=supplementaryprivateuseareab}', "");
    Expect(1, 1048576, '\p{Block=:\Asupplementaryprivateuseareab\z:}', "");;
    Expect(0, 1, '\p{Block=:\Asupplementaryprivateuseareab\z:}', "");;
    Expect(1, 1048576, '\p{Block=__supplementary_Private_use_area_b}', "");
    Expect(0, 1048576, '\p{^Block=__supplementary_Private_use_area_b}', "");
    Expect(0, 1048576, '\P{Block=__supplementary_Private_use_area_b}', "");
    Expect(1, 1048576, '\P{^Block=__supplementary_Private_use_area_b}', "");
    Expect(0, 1, '\p{Block=__supplementary_Private_use_area_b}', "");
    Expect(1, 1, '\p{^Block=__supplementary_Private_use_area_b}', "");
    Expect(1, 1, '\P{Block=__supplementary_Private_use_area_b}', "");
    Expect(0, 1, '\P{^Block=__supplementary_Private_use_area_b}', "");
    Error('\p{Blk= :=Sup_PUA_B}');
    Error('\P{Blk= :=Sup_PUA_B}');
    Expect(1, 1048576, '\p{Blk=:\ASup_PUA_B\z:}', "");;
    Expect(0, 1, '\p{Blk=:\ASup_PUA_B\z:}', "");;
    Expect(1, 1048576, '\p{Blk=suppuab}', "");
    Expect(0, 1048576, '\p{^Blk=suppuab}', "");
    Expect(0, 1048576, '\P{Blk=suppuab}', "");
    Expect(1, 1048576, '\P{^Blk=suppuab}', "");
    Expect(0, 1, '\p{Blk=suppuab}', "");
    Expect(1, 1, '\p{^Blk=suppuab}', "");
    Expect(1, 1, '\P{Blk=suppuab}', "");
    Expect(0, 1, '\P{^Blk=suppuab}', "");
    Expect(1, 1048576, '\p{Blk=:\Asuppuab\z:}', "");;
    Expect(0, 1, '\p{Blk=:\Asuppuab\z:}', "");;
    Expect(1, 1048576, '\p{Blk=--Sup_pua_B}', "");
    Expect(0, 1048576, '\p{^Blk=--Sup_pua_B}', "");
    Expect(0, 1048576, '\P{Blk=--Sup_pua_B}', "");
    Expect(1, 1048576, '\P{^Blk=--Sup_pua_B}', "");
    Expect(0, 1, '\p{Blk=--Sup_pua_B}', "");
    Expect(1, 1, '\p{^Blk=--Sup_pua_B}', "");
    Expect(1, 1, '\P{Blk=--Sup_pua_B}', "");
    Expect(0, 1, '\P{^Blk=--Sup_pua_B}', "");
    Error('\p{Is_Block=/a/  Supplementary_Private_Use_area_B}');
    Error('\P{Is_Block=/a/  Supplementary_Private_Use_area_B}');
    Expect(1, 1048576, '\p{Is_Block: supplementaryprivateuseareab}', "");
    Expect(0, 1048576, '\p{^Is_Block: supplementaryprivateuseareab}', "");
    Expect(0, 1048576, '\P{Is_Block: supplementaryprivateuseareab}', "");
    Expect(1, 1048576, '\P{^Is_Block: supplementaryprivateuseareab}', "");
    Expect(0, 1, '\p{Is_Block: supplementaryprivateuseareab}', "");
    Expect(1, 1, '\p{^Is_Block: supplementaryprivateuseareab}', "");
    Expect(1, 1, '\P{Is_Block: supplementaryprivateuseareab}', "");
    Expect(0, 1, '\P{^Is_Block: supplementaryprivateuseareab}', "");
    Expect(1, 1048576, '\p{Is_Block=	-SUPPLEMENTARY_Private_Use_AREA_B}', "");
    Expect(0, 1048576, '\p{^Is_Block=	-SUPPLEMENTARY_Private_Use_AREA_B}', "");
    Expect(0, 1048576, '\P{Is_Block=	-SUPPLEMENTARY_Private_Use_AREA_B}', "");
    Expect(1, 1048576, '\P{^Is_Block=	-SUPPLEMENTARY_Private_Use_AREA_B}', "");
    Expect(0, 1, '\p{Is_Block=	-SUPPLEMENTARY_Private_Use_AREA_B}', "");
    Expect(1, 1, '\p{^Is_Block=	-SUPPLEMENTARY_Private_Use_AREA_B}', "");
    Expect(1, 1, '\P{Is_Block=	-SUPPLEMENTARY_Private_Use_AREA_B}', "");
    Expect(0, 1, '\P{^Is_Block=	-SUPPLEMENTARY_Private_Use_AREA_B}', "");
    Error('\p{Is_Blk=:= Sup_PUA_b}');
    Error('\P{Is_Blk=:= Sup_PUA_b}');
    Expect(1, 1048576, '\p{Is_Blk=suppuab}', "");
    Expect(0, 1048576, '\p{^Is_Blk=suppuab}', "");
    Expect(0, 1048576, '\P{Is_Blk=suppuab}', "");
    Expect(1, 1048576, '\P{^Is_Blk=suppuab}', "");
    Expect(0, 1, '\p{Is_Blk=suppuab}', "");
    Expect(1, 1, '\p{^Is_Blk=suppuab}', "");
    Expect(1, 1, '\P{Is_Blk=suppuab}', "");
    Expect(0, 1, '\P{^Is_Blk=suppuab}', "");
    Expect(1, 1048576, '\p{Is_Blk=		sup_PUA_b}', "");
    Expect(0, 1048576, '\p{^Is_Blk=		sup_PUA_b}', "");
    Expect(0, 1048576, '\P{Is_Blk=		sup_PUA_b}', "");
    Expect(1, 1048576, '\P{^Is_Blk=		sup_PUA_b}', "");
    Expect(0, 1, '\p{Is_Blk=		sup_PUA_b}', "");
    Expect(1, 1, '\p{^Is_Blk=		sup_PUA_b}', "");
    Expect(1, 1, '\P{Is_Blk=		sup_PUA_b}', "");
    Expect(0, 1, '\P{^Is_Blk=		sup_PUA_b}', "");
    Error('\p{Block=-/a/Supplemental_Punctuation}');
    Error('\P{Block=-/a/Supplemental_Punctuation}');
    Expect(1, 11903, '\p{Block=:\ASupplemental_Punctuation\z:}', "");;
    Expect(0, 11904, '\p{Block=:\ASupplemental_Punctuation\z:}', "");;
    Expect(1, 11903, '\p{Block=supplementalpunctuation}', "");
    Expect(0, 11903, '\p{^Block=supplementalpunctuation}', "");
    Expect(0, 11903, '\P{Block=supplementalpunctuation}', "");
    Expect(1, 11903, '\P{^Block=supplementalpunctuation}', "");
    Expect(0, 11904, '\p{Block=supplementalpunctuation}', "");
    Expect(1, 11904, '\p{^Block=supplementalpunctuation}', "");
    Expect(1, 11904, '\P{Block=supplementalpunctuation}', "");
    Expect(0, 11904, '\P{^Block=supplementalpunctuation}', "");
    Expect(1, 11903, '\p{Block=:\Asupplementalpunctuation\z:}', "");;
    Expect(0, 11904, '\p{Block=:\Asupplementalpunctuation\z:}', "");;
    Expect(1, 11903, '\p{Block=	_supplemental_Punctuation}', "");
    Expect(0, 11903, '\p{^Block=	_supplemental_Punctuation}', "");
    Expect(0, 11903, '\P{Block=	_supplemental_Punctuation}', "");
    Expect(1, 11903, '\P{^Block=	_supplemental_Punctuation}', "");
    Expect(0, 11904, '\p{Block=	_supplemental_Punctuation}', "");
    Expect(1, 11904, '\p{^Block=	_supplemental_Punctuation}', "");
    Expect(1, 11904, '\P{Block=	_supplemental_Punctuation}', "");
    Expect(0, 11904, '\P{^Block=	_supplemental_Punctuation}', "");
    Error('\p{Blk= /a/sup_Punctuation}');
    Error('\P{Blk= /a/sup_Punctuation}');
    Expect(1, 11903, '\p{Blk=:\ASup_Punctuation\z:}', "");;
    Expect(0, 11904, '\p{Blk=:\ASup_Punctuation\z:}', "");;
    Expect(1, 11903, '\p{Blk:	suppunctuation}', "");
    Expect(0, 11903, '\p{^Blk:	suppunctuation}', "");
    Expect(0, 11903, '\P{Blk:	suppunctuation}', "");
    Expect(1, 11903, '\P{^Blk:	suppunctuation}', "");
    Expect(0, 11904, '\p{Blk:	suppunctuation}', "");
    Expect(1, 11904, '\p{^Blk:	suppunctuation}', "");
    Expect(1, 11904, '\P{Blk:	suppunctuation}', "");
    Expect(0, 11904, '\P{^Blk:	suppunctuation}', "");
    Expect(1, 11903, '\p{Blk=:\Asuppunctuation\z:}', "");;
    Expect(0, 11904, '\p{Blk=:\Asuppunctuation\z:}', "");;
    Expect(1, 11903, '\p{Blk= 	SUP_punctuation}', "");
    Expect(0, 11903, '\p{^Blk= 	SUP_punctuation}', "");
    Expect(0, 11903, '\P{Blk= 	SUP_punctuation}', "");
    Expect(1, 11903, '\P{^Blk= 	SUP_punctuation}', "");
    Expect(0, 11904, '\p{Blk= 	SUP_punctuation}', "");
    Expect(1, 11904, '\p{^Blk= 	SUP_punctuation}', "");
    Expect(1, 11904, '\P{Blk= 	SUP_punctuation}', "");
    Expect(0, 11904, '\P{^Blk= 	SUP_punctuation}', "");
    Error('\p{Is_Block:    /a/Supplemental_Punctuation}');
    Error('\P{Is_Block:    /a/Supplemental_Punctuation}');
    Expect(1, 11903, '\p{Is_Block=supplementalpunctuation}', "");
    Expect(0, 11903, '\p{^Is_Block=supplementalpunctuation}', "");
    Expect(0, 11903, '\P{Is_Block=supplementalpunctuation}', "");
    Expect(1, 11903, '\P{^Is_Block=supplementalpunctuation}', "");
    Expect(0, 11904, '\p{Is_Block=supplementalpunctuation}', "");
    Expect(1, 11904, '\p{^Is_Block=supplementalpunctuation}', "");
    Expect(1, 11904, '\P{Is_Block=supplementalpunctuation}', "");
    Expect(0, 11904, '\P{^Is_Block=supplementalpunctuation}', "");
    Expect(1, 11903, '\p{Is_Block= Supplemental_Punctuation}', "");
    Expect(0, 11903, '\p{^Is_Block= Supplemental_Punctuation}', "");
    Expect(0, 11903, '\P{Is_Block= Supplemental_Punctuation}', "");
    Expect(1, 11903, '\P{^Is_Block= Supplemental_Punctuation}', "");
    Expect(0, 11904, '\p{Is_Block= Supplemental_Punctuation}', "");
    Expect(1, 11904, '\p{^Is_Block= Supplemental_Punctuation}', "");
    Expect(1, 11904, '\P{Is_Block= Supplemental_Punctuation}', "");
    Expect(0, 11904, '\P{^Is_Block= Supplemental_Punctuation}', "");
    Error('\p{Is_Blk=	:=sup_punctuation}');
    Error('\P{Is_Blk=	:=sup_punctuation}');
    Expect(1, 11903, '\p{Is_Blk: suppunctuation}', "");
    Expect(0, 11903, '\p{^Is_Blk: suppunctuation}', "");
    Expect(0, 11903, '\P{Is_Blk: suppunctuation}', "");
    Expect(1, 11903, '\P{^Is_Blk: suppunctuation}', "");
    Expect(0, 11904, '\p{Is_Blk: suppunctuation}', "");
    Expect(1, 11904, '\p{^Is_Blk: suppunctuation}', "");
    Expect(1, 11904, '\P{Is_Blk: suppunctuation}', "");
    Expect(0, 11904, '\P{^Is_Blk: suppunctuation}', "");
    Expect(1, 11903, '\p{Is_Blk=--sup_punctuation}', "");
    Expect(0, 11903, '\p{^Is_Blk=--sup_punctuation}', "");
    Expect(0, 11903, '\P{Is_Blk=--sup_punctuation}', "");
    Expect(1, 11903, '\P{^Is_Blk=--sup_punctuation}', "");
    Expect(0, 11904, '\p{Is_Blk=--sup_punctuation}', "");
    Expect(1, 11904, '\p{^Is_Blk=--sup_punctuation}', "");
    Expect(1, 11904, '\P{Is_Blk=--sup_punctuation}', "");
    Expect(0, 11904, '\P{^Is_Blk=--sup_punctuation}', "");
    Error('\p{Block=_Supplemental_symbols_And_Pictographs:=}');
    Error('\P{Block=_Supplemental_symbols_And_Pictographs:=}');
    Expect(1, 129535, '\p{Block=:\ASupplemental_Symbols_And_Pictographs\z:}', "");;
    Expect(0, 129536, '\p{Block=:\ASupplemental_Symbols_And_Pictographs\z:}', "");;
    Expect(1, 129535, '\p{Block=supplementalsymbolsandpictographs}', "");
    Expect(0, 129535, '\p{^Block=supplementalsymbolsandpictographs}', "");
    Expect(0, 129535, '\P{Block=supplementalsymbolsandpictographs}', "");
    Expect(1, 129535, '\P{^Block=supplementalsymbolsandpictographs}', "");
    Expect(0, 129536, '\p{Block=supplementalsymbolsandpictographs}', "");
    Expect(1, 129536, '\p{^Block=supplementalsymbolsandpictographs}', "");
    Expect(1, 129536, '\P{Block=supplementalsymbolsandpictographs}', "");
    Expect(0, 129536, '\P{^Block=supplementalsymbolsandpictographs}', "");
    Expect(1, 129535, '\p{Block=:\Asupplementalsymbolsandpictographs\z:}', "");;
    Expect(0, 129536, '\p{Block=:\Asupplementalsymbolsandpictographs\z:}', "");;
    Expect(1, 129535, '\p{Block=-SUPPLEMENTAL_Symbols_AND_pictographs}', "");
    Expect(0, 129535, '\p{^Block=-SUPPLEMENTAL_Symbols_AND_pictographs}', "");
    Expect(0, 129535, '\P{Block=-SUPPLEMENTAL_Symbols_AND_pictographs}', "");
    Expect(1, 129535, '\P{^Block=-SUPPLEMENTAL_Symbols_AND_pictographs}', "");
    Expect(0, 129536, '\p{Block=-SUPPLEMENTAL_Symbols_AND_pictographs}', "");
    Expect(1, 129536, '\p{^Block=-SUPPLEMENTAL_Symbols_AND_pictographs}', "");
    Expect(1, 129536, '\P{Block=-SUPPLEMENTAL_Symbols_AND_pictographs}', "");
    Expect(0, 129536, '\P{^Block=-SUPPLEMENTAL_Symbols_AND_pictographs}', "");
    Error('\p{Blk=/a/ Sup_symbols_AND_Pictographs}');
    Error('\P{Blk=/a/ Sup_symbols_AND_Pictographs}');
    Expect(1, 129535, '\p{Blk=:\ASup_Symbols_And_Pictographs\z:}', "");;
    Expect(0, 129536, '\p{Blk=:\ASup_Symbols_And_Pictographs\z:}', "");;
    Expect(1, 129535, '\p{Blk:supsymbolsandpictographs}', "");
    Expect(0, 129535, '\p{^Blk:supsymbolsandpictographs}', "");
    Expect(0, 129535, '\P{Blk:supsymbolsandpictographs}', "");
    Expect(1, 129535, '\P{^Blk:supsymbolsandpictographs}', "");
    Expect(0, 129536, '\p{Blk:supsymbolsandpictographs}', "");
    Expect(1, 129536, '\p{^Blk:supsymbolsandpictographs}', "");
    Expect(1, 129536, '\P{Blk:supsymbolsandpictographs}', "");
    Expect(0, 129536, '\P{^Blk:supsymbolsandpictographs}', "");
    Expect(1, 129535, '\p{Blk=:\Asupsymbolsandpictographs\z:}', "");;
    Expect(0, 129536, '\p{Blk=:\Asupsymbolsandpictographs\z:}', "");;
    Expect(1, 129535, '\p{Blk=  SUP_SYMBOLS_And_pictographs}', "");
    Expect(0, 129535, '\p{^Blk=  SUP_SYMBOLS_And_pictographs}', "");
    Expect(0, 129535, '\P{Blk=  SUP_SYMBOLS_And_pictographs}', "");
    Expect(1, 129535, '\P{^Blk=  SUP_SYMBOLS_And_pictographs}', "");
    Expect(0, 129536, '\p{Blk=  SUP_SYMBOLS_And_pictographs}', "");
    Expect(1, 129536, '\p{^Blk=  SUP_SYMBOLS_And_pictographs}', "");
    Expect(1, 129536, '\P{Blk=  SUP_SYMBOLS_And_pictographs}', "");
    Expect(0, 129536, '\P{^Blk=  SUP_SYMBOLS_And_pictographs}', "");
    Error('\p{Is_Block=:=Supplemental_Symbols_AND_PICTOGRAPHS}');
    Error('\P{Is_Block=:=Supplemental_Symbols_AND_PICTOGRAPHS}');
    Expect(1, 129535, '\p{Is_Block=supplementalsymbolsandpictographs}', "");
    Expect(0, 129535, '\p{^Is_Block=supplementalsymbolsandpictographs}', "");
    Expect(0, 129535, '\P{Is_Block=supplementalsymbolsandpictographs}', "");
    Expect(1, 129535, '\P{^Is_Block=supplementalsymbolsandpictographs}', "");
    Expect(0, 129536, '\p{Is_Block=supplementalsymbolsandpictographs}', "");
    Expect(1, 129536, '\p{^Is_Block=supplementalsymbolsandpictographs}', "");
    Expect(1, 129536, '\P{Is_Block=supplementalsymbolsandpictographs}', "");
    Expect(0, 129536, '\P{^Is_Block=supplementalsymbolsandpictographs}', "");
    Expect(1, 129535, '\p{Is_Block:   -_SUPPLEMENTAL_Symbols_And_Pictographs}', "");
    Expect(0, 129535, '\p{^Is_Block:   -_SUPPLEMENTAL_Symbols_And_Pictographs}', "");
    Expect(0, 129535, '\P{Is_Block:   -_SUPPLEMENTAL_Symbols_And_Pictographs}', "");
    Expect(1, 129535, '\P{^Is_Block:   -_SUPPLEMENTAL_Symbols_And_Pictographs}', "");
    Expect(0, 129536, '\p{Is_Block:   -_SUPPLEMENTAL_Symbols_And_Pictographs}', "");
    Expect(1, 129536, '\p{^Is_Block:   -_SUPPLEMENTAL_Symbols_And_Pictographs}', "");
    Expect(1, 129536, '\P{Is_Block:   -_SUPPLEMENTAL_Symbols_And_Pictographs}', "");
    Expect(0, 129536, '\P{^Is_Block:   -_SUPPLEMENTAL_Symbols_And_Pictographs}', "");
    Error('\p{Is_Blk=:=SUP_Symbols_And_PICTOGRAPHS}');
    Error('\P{Is_Blk=:=SUP_Symbols_And_PICTOGRAPHS}');
    Expect(1, 129535, '\p{Is_Blk=supsymbolsandpictographs}', "");
    Expect(0, 129535, '\p{^Is_Blk=supsymbolsandpictographs}', "");
    Expect(0, 129535, '\P{Is_Blk=supsymbolsandpictographs}', "");
    Expect(1, 129535, '\P{^Is_Blk=supsymbolsandpictographs}', "");
    Expect(0, 129536, '\p{Is_Blk=supsymbolsandpictographs}', "");
    Expect(1, 129536, '\p{^Is_Blk=supsymbolsandpictographs}', "");
    Expect(1, 129536, '\P{Is_Blk=supsymbolsandpictographs}', "");
    Expect(0, 129536, '\P{^Is_Blk=supsymbolsandpictographs}', "");
    Expect(1, 129535, '\p{Is_Blk=__Sup_symbols_And_PICTOGRAPHS}', "");
    Expect(0, 129535, '\p{^Is_Blk=__Sup_symbols_And_PICTOGRAPHS}', "");
    Expect(0, 129535, '\P{Is_Blk=__Sup_symbols_And_PICTOGRAPHS}', "");
    Expect(1, 129535, '\P{^Is_Blk=__Sup_symbols_And_PICTOGRAPHS}', "");
    Expect(0, 129536, '\p{Is_Blk=__Sup_symbols_And_PICTOGRAPHS}', "");
    Expect(1, 129536, '\p{^Is_Blk=__Sup_symbols_And_PICTOGRAPHS}', "");
    Expect(1, 129536, '\P{Is_Blk=__Sup_symbols_And_PICTOGRAPHS}', "");
    Expect(0, 129536, '\P{^Is_Blk=__Sup_symbols_And_PICTOGRAPHS}', "");
    Error('\p{Block= _superscripts_And_SUBSCRIPTS/a/}');
    Error('\P{Block= _superscripts_And_SUBSCRIPTS/a/}');
    Expect(1, 8351, '\p{Block=:\ASuperscripts_And_Subscripts\z:}', "");;
    Expect(0, 8352, '\p{Block=:\ASuperscripts_And_Subscripts\z:}', "");;
    Expect(1, 8351, '\p{Block=superscriptsandsubscripts}', "");
    Expect(0, 8351, '\p{^Block=superscriptsandsubscripts}', "");
    Expect(0, 8351, '\P{Block=superscriptsandsubscripts}', "");
    Expect(1, 8351, '\P{^Block=superscriptsandsubscripts}', "");
    Expect(0, 8352, '\p{Block=superscriptsandsubscripts}', "");
    Expect(1, 8352, '\p{^Block=superscriptsandsubscripts}', "");
    Expect(1, 8352, '\P{Block=superscriptsandsubscripts}', "");
    Expect(0, 8352, '\P{^Block=superscriptsandsubscripts}', "");
    Expect(1, 8351, '\p{Block=:\Asuperscriptsandsubscripts\z:}', "");;
    Expect(0, 8352, '\p{Block=:\Asuperscriptsandsubscripts\z:}', "");;
    Expect(1, 8351, '\p{Block=		superscripts_and_subscripts}', "");
    Expect(0, 8351, '\p{^Block=		superscripts_and_subscripts}', "");
    Expect(0, 8351, '\P{Block=		superscripts_and_subscripts}', "");
    Expect(1, 8351, '\P{^Block=		superscripts_and_subscripts}', "");
    Expect(0, 8352, '\p{Block=		superscripts_and_subscripts}', "");
    Expect(1, 8352, '\p{^Block=		superscripts_and_subscripts}', "");
    Expect(1, 8352, '\P{Block=		superscripts_and_subscripts}', "");
    Expect(0, 8352, '\P{^Block=		superscripts_and_subscripts}', "");
    Error('\p{Blk=:=_-Super_AND_Sub}');
    Error('\P{Blk=:=_-Super_AND_Sub}');
    Expect(1, 8351, '\p{Blk=:\ASuper_And_Sub\z:}', "");;
    Expect(0, 8352, '\p{Blk=:\ASuper_And_Sub\z:}', "");;
    Expect(1, 8351, '\p{Blk:	superandsub}', "");
    Expect(0, 8351, '\p{^Blk:	superandsub}', "");
    Expect(0, 8351, '\P{Blk:	superandsub}', "");
    Expect(1, 8351, '\P{^Blk:	superandsub}', "");
    Expect(0, 8352, '\p{Blk:	superandsub}', "");
    Expect(1, 8352, '\p{^Blk:	superandsub}', "");
    Expect(1, 8352, '\P{Blk:	superandsub}', "");
    Expect(0, 8352, '\P{^Blk:	superandsub}', "");
    Expect(1, 8351, '\p{Blk=:\Asuperandsub\z:}', "");;
    Expect(0, 8352, '\p{Blk=:\Asuperandsub\z:}', "");;
    Expect(1, 8351, '\p{Blk=	Super_AND_Sub}', "");
    Expect(0, 8351, '\p{^Blk=	Super_AND_Sub}', "");
    Expect(0, 8351, '\P{Blk=	Super_AND_Sub}', "");
    Expect(1, 8351, '\P{^Blk=	Super_AND_Sub}', "");
    Expect(0, 8352, '\p{Blk=	Super_AND_Sub}', "");
    Expect(1, 8352, '\p{^Blk=	Super_AND_Sub}', "");
    Expect(1, 8352, '\P{Blk=	Super_AND_Sub}', "");
    Expect(0, 8352, '\P{^Blk=	Super_AND_Sub}', "");
    Error('\p{Is_Block=/a/Superscripts_and_Subscripts}');
    Error('\P{Is_Block=/a/Superscripts_and_Subscripts}');
    Expect(1, 8351, '\p{Is_Block=superscriptsandsubscripts}', "");
    Expect(0, 8351, '\p{^Is_Block=superscriptsandsubscripts}', "");
    Expect(0, 8351, '\P{Is_Block=superscriptsandsubscripts}', "");
    Expect(1, 8351, '\P{^Is_Block=superscriptsandsubscripts}', "");
    Expect(0, 8352, '\p{Is_Block=superscriptsandsubscripts}', "");
    Expect(1, 8352, '\p{^Is_Block=superscriptsandsubscripts}', "");
    Expect(1, 8352, '\P{Is_Block=superscriptsandsubscripts}', "");
    Expect(0, 8352, '\P{^Is_Block=superscriptsandsubscripts}', "");
    Expect(1, 8351, '\p{Is_Block=- superscripts_And_SUBSCRIPTS}', "");
    Expect(0, 8351, '\p{^Is_Block=- superscripts_And_SUBSCRIPTS}', "");
    Expect(0, 8351, '\P{Is_Block=- superscripts_And_SUBSCRIPTS}', "");
    Expect(1, 8351, '\P{^Is_Block=- superscripts_And_SUBSCRIPTS}', "");
    Expect(0, 8352, '\p{Is_Block=- superscripts_And_SUBSCRIPTS}', "");
    Expect(1, 8352, '\p{^Is_Block=- superscripts_And_SUBSCRIPTS}', "");
    Expect(1, 8352, '\P{Is_Block=- superscripts_And_SUBSCRIPTS}', "");
    Expect(0, 8352, '\P{^Is_Block=- superscripts_And_SUBSCRIPTS}', "");
    Error('\p{Is_Blk=	_super_And_SUB:=}');
    Error('\P{Is_Blk=	_super_And_SUB:=}');
    Expect(1, 8351, '\p{Is_Blk=superandsub}', "");
    Expect(0, 8351, '\p{^Is_Blk=superandsub}', "");
    Expect(0, 8351, '\P{Is_Blk=superandsub}', "");
    Expect(1, 8351, '\P{^Is_Blk=superandsub}', "");
    Expect(0, 8352, '\p{Is_Blk=superandsub}', "");
    Expect(1, 8352, '\p{^Is_Blk=superandsub}', "");
    Expect(1, 8352, '\P{Is_Blk=superandsub}', "");
    Expect(0, 8352, '\P{^Is_Blk=superandsub}', "");
    Expect(1, 8351, '\p{Is_Blk= 	SUPER_AND_SUB}', "");
    Expect(0, 8351, '\p{^Is_Blk= 	SUPER_AND_SUB}', "");
    Expect(0, 8351, '\P{Is_Blk= 	SUPER_AND_SUB}', "");
    Expect(1, 8351, '\P{^Is_Blk= 	SUPER_AND_SUB}', "");
    Expect(0, 8352, '\p{Is_Blk= 	SUPER_AND_SUB}', "");
    Expect(1, 8352, '\p{^Is_Blk= 	SUPER_AND_SUB}', "");
    Expect(1, 8352, '\P{Is_Blk= 	SUPER_AND_SUB}', "");
    Expect(0, 8352, '\P{^Is_Blk= 	SUPER_AND_SUB}', "");
    Error('\p{Block=/a/	_Sutton_SignWriting}');
    Error('\P{Block=/a/	_Sutton_SignWriting}');
    Expect(1, 121519, '\p{Block=:\ASutton_SignWriting\z:}', "");;
    Expect(0, 121520, '\p{Block=:\ASutton_SignWriting\z:}', "");;
    Expect(1, 121519, '\p{Block=suttonsignwriting}', "");
    Expect(0, 121519, '\p{^Block=suttonsignwriting}', "");
    Expect(0, 121519, '\P{Block=suttonsignwriting}', "");
    Expect(1, 121519, '\P{^Block=suttonsignwriting}', "");
    Expect(0, 121520, '\p{Block=suttonsignwriting}', "");
    Expect(1, 121520, '\p{^Block=suttonsignwriting}', "");
    Expect(1, 121520, '\P{Block=suttonsignwriting}', "");
    Expect(0, 121520, '\P{^Block=suttonsignwriting}', "");
    Expect(1, 121519, '\p{Block=:\Asuttonsignwriting\z:}', "");;
    Expect(0, 121520, '\p{Block=:\Asuttonsignwriting\z:}', "");;
    Expect(1, 121519, '\p{Block= -Sutton_signwriting}', "");
    Expect(0, 121519, '\p{^Block= -Sutton_signwriting}', "");
    Expect(0, 121519, '\P{Block= -Sutton_signwriting}', "");
    Expect(1, 121519, '\P{^Block= -Sutton_signwriting}', "");
    Expect(0, 121520, '\p{Block= -Sutton_signwriting}', "");
    Expect(1, 121520, '\p{^Block= -Sutton_signwriting}', "");
    Expect(1, 121520, '\P{Block= -Sutton_signwriting}', "");
    Expect(0, 121520, '\P{^Block= -Sutton_signwriting}', "");
    Error('\p{Blk=-_SUTTON_SIGNWRITING:=}');
    Error('\P{Blk=-_SUTTON_SIGNWRITING:=}');
    Expect(1, 121519, '\p{Blk=:\ASutton_SignWriting\z:}', "");;
    Expect(0, 121520, '\p{Blk=:\ASutton_SignWriting\z:}', "");;
    Expect(1, 121519, '\p{Blk=suttonsignwriting}', "");
    Expect(0, 121519, '\p{^Blk=suttonsignwriting}', "");
    Expect(0, 121519, '\P{Blk=suttonsignwriting}', "");
    Expect(1, 121519, '\P{^Blk=suttonsignwriting}', "");
    Expect(0, 121520, '\p{Blk=suttonsignwriting}', "");
    Expect(1, 121520, '\p{^Blk=suttonsignwriting}', "");
    Expect(1, 121520, '\P{Blk=suttonsignwriting}', "");
    Expect(0, 121520, '\P{^Blk=suttonsignwriting}', "");
    Expect(1, 121519, '\p{Blk=:\Asuttonsignwriting\z:}', "");;
    Expect(0, 121520, '\p{Blk=:\Asuttonsignwriting\z:}', "");;
    Expect(1, 121519, '\p{Blk=-Sutton_SIGNWRITING}', "");
    Expect(0, 121519, '\p{^Blk=-Sutton_SIGNWRITING}', "");
    Expect(0, 121519, '\P{Blk=-Sutton_SIGNWRITING}', "");
    Expect(1, 121519, '\P{^Blk=-Sutton_SIGNWRITING}', "");
    Expect(0, 121520, '\p{Blk=-Sutton_SIGNWRITING}', "");
    Expect(1, 121520, '\p{^Blk=-Sutton_SIGNWRITING}', "");
    Expect(1, 121520, '\P{Blk=-Sutton_SIGNWRITING}', "");
    Expect(0, 121520, '\P{^Blk=-Sutton_SIGNWRITING}', "");
    Error('\p{Is_Block=_	sutton_SignWriting/a/}');
    Error('\P{Is_Block=_	sutton_SignWriting/a/}');
    Expect(1, 121519, '\p{Is_Block=suttonsignwriting}', "");
    Expect(0, 121519, '\p{^Is_Block=suttonsignwriting}', "");
    Expect(0, 121519, '\P{Is_Block=suttonsignwriting}', "");
    Expect(1, 121519, '\P{^Is_Block=suttonsignwriting}', "");
    Expect(0, 121520, '\p{Is_Block=suttonsignwriting}', "");
    Expect(1, 121520, '\p{^Is_Block=suttonsignwriting}', "");
    Expect(1, 121520, '\P{Is_Block=suttonsignwriting}', "");
    Expect(0, 121520, '\P{^Is_Block=suttonsignwriting}', "");
    Expect(1, 121519, '\p{Is_Block=_-SUTTON_signwriting}', "");
    Expect(0, 121519, '\p{^Is_Block=_-SUTTON_signwriting}', "");
    Expect(0, 121519, '\P{Is_Block=_-SUTTON_signwriting}', "");
    Expect(1, 121519, '\P{^Is_Block=_-SUTTON_signwriting}', "");
    Expect(0, 121520, '\p{Is_Block=_-SUTTON_signwriting}', "");
    Expect(1, 121520, '\p{^Is_Block=_-SUTTON_signwriting}', "");
    Expect(1, 121520, '\P{Is_Block=_-SUTTON_signwriting}', "");
    Expect(0, 121520, '\P{^Is_Block=_-SUTTON_signwriting}', "");
    Error('\p{Is_Blk=/a/  Sutton_SignWriting}');
    Error('\P{Is_Blk=/a/  Sutton_SignWriting}');
    Expect(1, 121519, '\p{Is_Blk=suttonsignwriting}', "");
    Expect(0, 121519, '\p{^Is_Blk=suttonsignwriting}', "");
    Expect(0, 121519, '\P{Is_Blk=suttonsignwriting}', "");
    Expect(1, 121519, '\P{^Is_Blk=suttonsignwriting}', "");
    Expect(0, 121520, '\p{Is_Blk=suttonsignwriting}', "");
    Expect(1, 121520, '\p{^Is_Blk=suttonsignwriting}', "");
    Expect(1, 121520, '\P{Is_Blk=suttonsignwriting}', "");
    Expect(0, 121520, '\P{^Is_Blk=suttonsignwriting}', "");
    Expect(1, 121519, '\p{Is_Blk:   _Sutton_SignWriting}', "");
    Expect(0, 121519, '\p{^Is_Blk:   _Sutton_SignWriting}', "");
    Expect(0, 121519, '\P{Is_Blk:   _Sutton_SignWriting}', "");
    Expect(1, 121519, '\P{^Is_Blk:   _Sutton_SignWriting}', "");
    Expect(0, 121520, '\p{Is_Blk:   _Sutton_SignWriting}', "");
    Expect(1, 121520, '\p{^Is_Blk:   _Sutton_SignWriting}', "");
    Expect(1, 121520, '\P{Is_Blk:   _Sutton_SignWriting}', "");
    Expect(0, 121520, '\P{^Is_Blk:   _Sutton_SignWriting}', "");
    Error('\p{Block=:=__Syloti_Nagri}');
    Error('\P{Block=:=__Syloti_Nagri}');
    Expect(1, 43055, '\p{Block=:\ASyloti_Nagri\z:}', "");;
    Expect(0, 43056, '\p{Block=:\ASyloti_Nagri\z:}', "");;
    Expect(1, 43055, '\p{Block=sylotinagri}', "");
    Expect(0, 43055, '\p{^Block=sylotinagri}', "");
    Expect(0, 43055, '\P{Block=sylotinagri}', "");
    Expect(1, 43055, '\P{^Block=sylotinagri}', "");
    Expect(0, 43056, '\p{Block=sylotinagri}', "");
    Expect(1, 43056, '\p{^Block=sylotinagri}', "");
    Expect(1, 43056, '\P{Block=sylotinagri}', "");
    Expect(0, 43056, '\P{^Block=sylotinagri}', "");
    Expect(1, 43055, '\p{Block=:\Asylotinagri\z:}', "");;
    Expect(0, 43056, '\p{Block=:\Asylotinagri\z:}', "");;
    Expect(1, 43055, '\p{Block=	Syloti_NAGRI}', "");
    Expect(0, 43055, '\p{^Block=	Syloti_NAGRI}', "");
    Expect(0, 43055, '\P{Block=	Syloti_NAGRI}', "");
    Expect(1, 43055, '\P{^Block=	Syloti_NAGRI}', "");
    Expect(0, 43056, '\p{Block=	Syloti_NAGRI}', "");
    Expect(1, 43056, '\p{^Block=	Syloti_NAGRI}', "");
    Expect(1, 43056, '\P{Block=	Syloti_NAGRI}', "");
    Expect(0, 43056, '\P{^Block=	Syloti_NAGRI}', "");
    Error('\p{Blk=/a/	Syloti_Nagri}');
    Error('\P{Blk=/a/	Syloti_Nagri}');
    Expect(1, 43055, '\p{Blk=:\ASyloti_Nagri\z:}', "");;
    Expect(0, 43056, '\p{Blk=:\ASyloti_Nagri\z:}', "");;
    Expect(1, 43055, '\p{Blk=sylotinagri}', "");
    Expect(0, 43055, '\p{^Blk=sylotinagri}', "");
    Expect(0, 43055, '\P{Blk=sylotinagri}', "");
    Expect(1, 43055, '\P{^Blk=sylotinagri}', "");
    Expect(0, 43056, '\p{Blk=sylotinagri}', "");
    Expect(1, 43056, '\p{^Blk=sylotinagri}', "");
    Expect(1, 43056, '\P{Blk=sylotinagri}', "");
    Expect(0, 43056, '\P{^Blk=sylotinagri}', "");
    Expect(1, 43055, '\p{Blk=:\Asylotinagri\z:}', "");;
    Expect(0, 43056, '\p{Blk=:\Asylotinagri\z:}', "");;
    Expect(1, 43055, '\p{Blk= -SYLOTI_nagri}', "");
    Expect(0, 43055, '\p{^Blk= -SYLOTI_nagri}', "");
    Expect(0, 43055, '\P{Blk= -SYLOTI_nagri}', "");
    Expect(1, 43055, '\P{^Blk= -SYLOTI_nagri}', "");
    Expect(0, 43056, '\p{Blk= -SYLOTI_nagri}', "");
    Expect(1, 43056, '\p{^Blk= -SYLOTI_nagri}', "");
    Expect(1, 43056, '\P{Blk= -SYLOTI_nagri}', "");
    Expect(0, 43056, '\P{^Blk= -SYLOTI_nagri}', "");
    Error('\p{Is_Block=-/a/Syloti_nagri}');
    Error('\P{Is_Block=-/a/Syloti_nagri}');
    Expect(1, 43055, '\p{Is_Block=sylotinagri}', "");
    Expect(0, 43055, '\p{^Is_Block=sylotinagri}', "");
    Expect(0, 43055, '\P{Is_Block=sylotinagri}', "");
    Expect(1, 43055, '\P{^Is_Block=sylotinagri}', "");
    Expect(0, 43056, '\p{Is_Block=sylotinagri}', "");
    Expect(1, 43056, '\p{^Is_Block=sylotinagri}', "");
    Expect(1, 43056, '\P{Is_Block=sylotinagri}', "");
    Expect(0, 43056, '\P{^Is_Block=sylotinagri}', "");
    Expect(1, 43055, '\p{Is_Block:	 _syloti_nagri}', "");
    Expect(0, 43055, '\p{^Is_Block:	 _syloti_nagri}', "");
    Expect(0, 43055, '\P{Is_Block:	 _syloti_nagri}', "");
    Expect(1, 43055, '\P{^Is_Block:	 _syloti_nagri}', "");
    Expect(0, 43056, '\p{Is_Block:	 _syloti_nagri}', "");
    Expect(1, 43056, '\p{^Is_Block:	 _syloti_nagri}', "");
    Expect(1, 43056, '\P{Is_Block:	 _syloti_nagri}', "");
    Expect(0, 43056, '\P{^Is_Block:	 _syloti_nagri}', "");
    Error('\p{Is_Blk=-	syloti_Nagri:=}');
    Error('\P{Is_Blk=-	syloti_Nagri:=}');
    Expect(1, 43055, '\p{Is_Blk=sylotinagri}', "");
    Expect(0, 43055, '\p{^Is_Blk=sylotinagri}', "");
    Expect(0, 43055, '\P{Is_Blk=sylotinagri}', "");
    Expect(1, 43055, '\P{^Is_Blk=sylotinagri}', "");
    Expect(0, 43056, '\p{Is_Blk=sylotinagri}', "");
    Expect(1, 43056, '\p{^Is_Blk=sylotinagri}', "");
    Expect(1, 43056, '\P{Is_Blk=sylotinagri}', "");
    Expect(0, 43056, '\P{^Is_Blk=sylotinagri}', "");
    Expect(1, 43055, '\p{Is_Blk=  Syloti_nagri}', "");
    Expect(0, 43055, '\p{^Is_Blk=  Syloti_nagri}', "");
    Expect(0, 43055, '\P{Is_Blk=  Syloti_nagri}', "");
    Expect(1, 43055, '\P{^Is_Blk=  Syloti_nagri}', "");
    Expect(0, 43056, '\p{Is_Blk=  Syloti_nagri}', "");
    Expect(1, 43056, '\p{^Is_Blk=  Syloti_nagri}', "");
    Expect(1, 43056, '\P{Is_Blk=  Syloti_nagri}', "");
    Expect(0, 43056, '\P{^Is_Blk=  Syloti_nagri}', "");
    Error('\p{Block=-	Symbols_and_pictographs_extended_a:=}');
    Error('\P{Block=-	Symbols_and_pictographs_extended_a:=}');
    Expect(1, 129791, '\p{Block=:\ASymbols_And_Pictographs_Extended_A\z:}', "");;
    Expect(0, 129792, '\p{Block=:\ASymbols_And_Pictographs_Extended_A\z:}', "");;
    Expect(1, 129791, '\p{Block=symbolsandpictographsextendeda}', "");
    Expect(0, 129791, '\p{^Block=symbolsandpictographsextendeda}', "");
    Expect(0, 129791, '\P{Block=symbolsandpictographsextendeda}', "");
    Expect(1, 129791, '\P{^Block=symbolsandpictographsextendeda}', "");
    Expect(0, 129792, '\p{Block=symbolsandpictographsextendeda}', "");
    Expect(1, 129792, '\p{^Block=symbolsandpictographsextendeda}', "");
    Expect(1, 129792, '\P{Block=symbolsandpictographsextendeda}', "");
    Expect(0, 129792, '\P{^Block=symbolsandpictographsextendeda}', "");
    Expect(1, 129791, '\p{Block=:\Asymbolsandpictographsextendeda\z:}', "");;
    Expect(0, 129792, '\p{Block=:\Asymbolsandpictographsextendeda\z:}', "");;
    Expect(1, 129791, '\p{Block=SYMBOLS_AND_pictographs_Extended_a}', "");
    Expect(0, 129791, '\p{^Block=SYMBOLS_AND_pictographs_Extended_a}', "");
    Expect(0, 129791, '\P{Block=SYMBOLS_AND_pictographs_Extended_a}', "");
    Expect(1, 129791, '\P{^Block=SYMBOLS_AND_pictographs_Extended_a}', "");
    Expect(0, 129792, '\p{Block=SYMBOLS_AND_pictographs_Extended_a}', "");
    Expect(1, 129792, '\p{^Block=SYMBOLS_AND_pictographs_Extended_a}', "");
    Expect(1, 129792, '\P{Block=SYMBOLS_AND_pictographs_Extended_a}', "");
    Expect(0, 129792, '\P{^Block=SYMBOLS_AND_pictographs_Extended_a}', "");
    Error('\p{Blk:  _symbols_And_PICTOGRAPHS_Ext_A:=}');
    Error('\P{Blk:  _symbols_And_PICTOGRAPHS_Ext_A:=}');
    Expect(1, 129791, '\p{Blk=:\ASymbols_And_Pictographs_Ext_A\z:}', "");;
    Expect(0, 129792, '\p{Blk=:\ASymbols_And_Pictographs_Ext_A\z:}', "");;
    Expect(1, 129791, '\p{Blk=symbolsandpictographsexta}', "");
    Expect(0, 129791, '\p{^Blk=symbolsandpictographsexta}', "");
    Expect(0, 129791, '\P{Blk=symbolsandpictographsexta}', "");
    Expect(1, 129791, '\P{^Blk=symbolsandpictographsexta}', "");
    Expect(0, 129792, '\p{Blk=symbolsandpictographsexta}', "");
    Expect(1, 129792, '\p{^Blk=symbolsandpictographsexta}', "");
    Expect(1, 129792, '\P{Blk=symbolsandpictographsexta}', "");
    Expect(0, 129792, '\P{^Blk=symbolsandpictographsexta}', "");
    Expect(1, 129791, '\p{Blk=:\Asymbolsandpictographsexta\z:}', "");;
    Expect(0, 129792, '\p{Blk=:\Asymbolsandpictographsexta\z:}', "");;
    Expect(1, 129791, '\p{Blk= -Symbols_and_pictographs_ext_A}', "");
    Expect(0, 129791, '\p{^Blk= -Symbols_and_pictographs_ext_A}', "");
    Expect(0, 129791, '\P{Blk= -Symbols_and_pictographs_ext_A}', "");
    Expect(1, 129791, '\P{^Blk= -Symbols_and_pictographs_ext_A}', "");
    Expect(0, 129792, '\p{Blk= -Symbols_and_pictographs_ext_A}', "");
    Expect(1, 129792, '\p{^Blk= -Symbols_and_pictographs_ext_A}', "");
    Expect(1, 129792, '\P{Blk= -Symbols_and_pictographs_ext_A}', "");
    Expect(0, 129792, '\P{^Blk= -Symbols_and_pictographs_ext_A}', "");
    Error('\p{Is_Block=:=_ SYMBOLS_and_Pictographs_extended_a}');
    Error('\P{Is_Block=:=_ SYMBOLS_and_Pictographs_extended_a}');
    Expect(1, 129791, '\p{Is_Block=symbolsandpictographsextendeda}', "");
    Expect(0, 129791, '\p{^Is_Block=symbolsandpictographsextendeda}', "");
    Expect(0, 129791, '\P{Is_Block=symbolsandpictographsextendeda}', "");
    Expect(1, 129791, '\P{^Is_Block=symbolsandpictographsextendeda}', "");
    Expect(0, 129792, '\p{Is_Block=symbolsandpictographsextendeda}', "");
    Expect(1, 129792, '\p{^Is_Block=symbolsandpictographsextendeda}', "");
    Expect(1, 129792, '\P{Is_Block=symbolsandpictographsextendeda}', "");
    Expect(0, 129792, '\P{^Is_Block=symbolsandpictographsextendeda}', "");
    Expect(1, 129791, '\p{Is_Block=	_SYMBOLS_AND_PICTOGRAPHS_EXTENDED_a}', "");
    Expect(0, 129791, '\p{^Is_Block=	_SYMBOLS_AND_PICTOGRAPHS_EXTENDED_a}', "");
    Expect(0, 129791, '\P{Is_Block=	_SYMBOLS_AND_PICTOGRAPHS_EXTENDED_a}', "");
    Expect(1, 129791, '\P{^Is_Block=	_SYMBOLS_AND_PICTOGRAPHS_EXTENDED_a}', "");
    Expect(0, 129792, '\p{Is_Block=	_SYMBOLS_AND_PICTOGRAPHS_EXTENDED_a}', "");
    Expect(1, 129792, '\p{^Is_Block=	_SYMBOLS_AND_PICTOGRAPHS_EXTENDED_a}', "");
    Expect(1, 129792, '\P{Is_Block=	_SYMBOLS_AND_PICTOGRAPHS_EXTENDED_a}', "");
    Expect(0, 129792, '\P{^Is_Block=	_SYMBOLS_AND_PICTOGRAPHS_EXTENDED_a}', "");
    Error('\p{Is_Blk=_ Symbols_and_Pictographs_Ext_a/a/}');
    Error('\P{Is_Blk=_ Symbols_and_Pictographs_Ext_a/a/}');
    Expect(1, 129791, '\p{Is_Blk=symbolsandpictographsexta}', "");
    Expect(0, 129791, '\p{^Is_Blk=symbolsandpictographsexta}', "");
    Expect(0, 129791, '\P{Is_Blk=symbolsandpictographsexta}', "");
    Expect(1, 129791, '\P{^Is_Blk=symbolsandpictographsexta}', "");
    Expect(0, 129792, '\p{Is_Blk=symbolsandpictographsexta}', "");
    Expect(1, 129792, '\p{^Is_Blk=symbolsandpictographsexta}', "");
    Expect(1, 129792, '\P{Is_Blk=symbolsandpictographsexta}', "");
    Expect(0, 129792, '\P{^Is_Blk=symbolsandpictographsexta}', "");
    Expect(1, 129791, '\p{Is_Blk=- Symbols_And_Pictographs_Ext_A}', "");
    Expect(0, 129791, '\p{^Is_Blk=- Symbols_And_Pictographs_Ext_A}', "");
    Expect(0, 129791, '\P{Is_Blk=- Symbols_And_Pictographs_Ext_A}', "");
    Expect(1, 129791, '\P{^Is_Blk=- Symbols_And_Pictographs_Ext_A}', "");
    Expect(0, 129792, '\p{Is_Blk=- Symbols_And_Pictographs_Ext_A}', "");
    Expect(1, 129792, '\p{^Is_Blk=- Symbols_And_Pictographs_Ext_A}', "");
    Expect(1, 129792, '\P{Is_Blk=- Symbols_And_Pictographs_Ext_A}', "");
    Expect(0, 129792, '\P{^Is_Blk=- Symbols_And_Pictographs_Ext_A}', "");
    Error('\p{Block=	SYMBOLS_FOR_LEGACY_computing/a/}');
    Error('\P{Block=	SYMBOLS_FOR_LEGACY_computing/a/}');
    Expect(1, 130047, '\p{Block=:\ASymbols_For_Legacy_Computing\z:}', "");;
    Expect(0, 130048, '\p{Block=:\ASymbols_For_Legacy_Computing\z:}', "");;
    Expect(1, 130047, '\p{Block=symbolsforlegacycomputing}', "");
    Expect(0, 130047, '\p{^Block=symbolsforlegacycomputing}', "");
    Expect(0, 130047, '\P{Block=symbolsforlegacycomputing}', "");
    Expect(1, 130047, '\P{^Block=symbolsforlegacycomputing}', "");
    Expect(0, 130048, '\p{Block=symbolsforlegacycomputing}', "");
    Expect(1, 130048, '\p{^Block=symbolsforlegacycomputing}', "");
    Expect(1, 130048, '\P{Block=symbolsforlegacycomputing}', "");
    Expect(0, 130048, '\P{^Block=symbolsforlegacycomputing}', "");
    Expect(1, 130047, '\p{Block=:\Asymbolsforlegacycomputing\z:}', "");;
    Expect(0, 130048, '\p{Block=:\Asymbolsforlegacycomputing\z:}', "");;
    Expect(1, 130047, '\p{Block=_Symbols_FOR_legacy_Computing}', "");
    Expect(0, 130047, '\p{^Block=_Symbols_FOR_legacy_Computing}', "");
    Expect(0, 130047, '\P{Block=_Symbols_FOR_legacy_Computing}', "");
    Expect(1, 130047, '\P{^Block=_Symbols_FOR_legacy_Computing}', "");
    Expect(0, 130048, '\p{Block=_Symbols_FOR_legacy_Computing}', "");
    Expect(1, 130048, '\p{^Block=_Symbols_FOR_legacy_Computing}', "");
    Expect(1, 130048, '\P{Block=_Symbols_FOR_legacy_Computing}', "");
    Expect(0, 130048, '\P{^Block=_Symbols_FOR_legacy_Computing}', "");
    Error('\p{Blk=/a/_ Symbols_for_Legacy_Computing}');
    Error('\P{Blk=/a/_ Symbols_for_Legacy_Computing}');
    Expect(1, 130047, '\p{Blk=:\ASymbols_For_Legacy_Computing\z:}', "");;
    Expect(0, 130048, '\p{Blk=:\ASymbols_For_Legacy_Computing\z:}', "");;
    Expect(1, 130047, '\p{Blk=symbolsforlegacycomputing}', "");
    Expect(0, 130047, '\p{^Blk=symbolsforlegacycomputing}', "");
    Expect(0, 130047, '\P{Blk=symbolsforlegacycomputing}', "");
    Expect(1, 130047, '\P{^Blk=symbolsforlegacycomputing}', "");
    Expect(0, 130048, '\p{Blk=symbolsforlegacycomputing}', "");
    Expect(1, 130048, '\p{^Blk=symbolsforlegacycomputing}', "");
    Expect(1, 130048, '\P{Blk=symbolsforlegacycomputing}', "");
    Expect(0, 130048, '\P{^Blk=symbolsforlegacycomputing}', "");
    Expect(1, 130047, '\p{Blk=:\Asymbolsforlegacycomputing\z:}', "");;
    Expect(0, 130048, '\p{Blk=:\Asymbolsforlegacycomputing\z:}', "");;
    Expect(1, 130047, '\p{Blk=	 Symbols_FOR_legacy_Computing}', "");
    Expect(0, 130047, '\p{^Blk=	 Symbols_FOR_legacy_Computing}', "");
    Expect(0, 130047, '\P{Blk=	 Symbols_FOR_legacy_Computing}', "");
    Expect(1, 130047, '\P{^Blk=	 Symbols_FOR_legacy_Computing}', "");
    Expect(0, 130048, '\p{Blk=	 Symbols_FOR_legacy_Computing}', "");
    Expect(1, 130048, '\p{^Blk=	 Symbols_FOR_legacy_Computing}', "");
    Expect(1, 130048, '\P{Blk=	 Symbols_FOR_legacy_Computing}', "");
    Expect(0, 130048, '\P{^Blk=	 Symbols_FOR_legacy_Computing}', "");
    Error('\p{Is_Block=/a/  Symbols_For_Legacy_COMPUTING}');
    Error('\P{Is_Block=/a/  Symbols_For_Legacy_COMPUTING}');
    Expect(1, 130047, '\p{Is_Block:	symbolsforlegacycomputing}', "");
    Expect(0, 130047, '\p{^Is_Block:	symbolsforlegacycomputing}', "");
    Expect(0, 130047, '\P{Is_Block:	symbolsforlegacycomputing}', "");
    Expect(1, 130047, '\P{^Is_Block:	symbolsforlegacycomputing}', "");
    Expect(0, 130048, '\p{Is_Block:	symbolsforlegacycomputing}', "");
    Expect(1, 130048, '\p{^Is_Block:	symbolsforlegacycomputing}', "");
    Expect(1, 130048, '\P{Is_Block:	symbolsforlegacycomputing}', "");
    Expect(0, 130048, '\P{^Is_Block:	symbolsforlegacycomputing}', "");
    Expect(1, 130047, '\p{Is_Block=	-Symbols_For_Legacy_Computing}', "");
    Expect(0, 130047, '\p{^Is_Block=	-Symbols_For_Legacy_Computing}', "");
    Expect(0, 130047, '\P{Is_Block=	-Symbols_For_Legacy_Computing}', "");
    Expect(1, 130047, '\P{^Is_Block=	-Symbols_For_Legacy_Computing}', "");
    Expect(0, 130048, '\p{Is_Block=	-Symbols_For_Legacy_Computing}', "");
    Expect(1, 130048, '\p{^Is_Block=	-Symbols_For_Legacy_Computing}', "");
    Expect(1, 130048, '\P{Is_Block=	-Symbols_For_Legacy_Computing}', "");
    Expect(0, 130048, '\P{^Is_Block=	-Symbols_For_Legacy_Computing}', "");
    Error('\p{Is_Blk=:= 	Symbols_For_Legacy_COMPUTING}');
    Error('\P{Is_Blk=:= 	Symbols_For_Legacy_COMPUTING}');
    Expect(1, 130047, '\p{Is_Blk=symbolsforlegacycomputing}', "");
    Expect(0, 130047, '\p{^Is_Blk=symbolsforlegacycomputing}', "");
    Expect(0, 130047, '\P{Is_Blk=symbolsforlegacycomputing}', "");
    Expect(1, 130047, '\P{^Is_Blk=symbolsforlegacycomputing}', "");
    Expect(0, 130048, '\p{Is_Blk=symbolsforlegacycomputing}', "");
    Expect(1, 130048, '\p{^Is_Blk=symbolsforlegacycomputing}', "");
    Expect(1, 130048, '\P{Is_Blk=symbolsforlegacycomputing}', "");
    Expect(0, 130048, '\P{^Is_Blk=symbolsforlegacycomputing}', "");
    Expect(1, 130047, '\p{Is_Blk: _	Symbols_FOR_legacy_Computing}', "");
    Expect(0, 130047, '\p{^Is_Blk: _	Symbols_FOR_legacy_Computing}', "");
    Expect(0, 130047, '\P{Is_Blk: _	Symbols_FOR_legacy_Computing}', "");
    Expect(1, 130047, '\P{^Is_Blk: _	Symbols_FOR_legacy_Computing}', "");
    Expect(0, 130048, '\p{Is_Blk: _	Symbols_FOR_legacy_Computing}', "");
    Expect(1, 130048, '\p{^Is_Blk: _	Symbols_FOR_legacy_Computing}', "");
    Expect(1, 130048, '\P{Is_Blk: _	Symbols_FOR_legacy_Computing}', "");
    Expect(0, 130048, '\P{^Is_Blk: _	Symbols_FOR_legacy_Computing}', "");
    Error('\p{Block:   := syriac}');
    Error('\P{Block:   := syriac}');
    Expect(1, 1871, '\p{Block=:\ASyriac\z:}', "");;
    Expect(0, 1872, '\p{Block=:\ASyriac\z:}', "");;
    Expect(1, 1871, '\p{Block: syriac}', "");
    Expect(0, 1871, '\p{^Block: syriac}', "");
    Expect(0, 1871, '\P{Block: syriac}', "");
    Expect(1, 1871, '\P{^Block: syriac}', "");
    Expect(0, 1872, '\p{Block: syriac}', "");
    Expect(1, 1872, '\p{^Block: syriac}', "");
    Expect(1, 1872, '\P{Block: syriac}', "");
    Expect(0, 1872, '\P{^Block: syriac}', "");
    Expect(1, 1871, '\p{Block=:\Asyriac\z:}', "");;
    Expect(0, 1872, '\p{Block=:\Asyriac\z:}', "");;
    Expect(1, 1871, '\p{Block=		SYRIAC}', "");
    Expect(0, 1871, '\p{^Block=		SYRIAC}', "");
    Expect(0, 1871, '\P{Block=		SYRIAC}', "");
    Expect(1, 1871, '\P{^Block=		SYRIAC}', "");
    Expect(0, 1872, '\p{Block=		SYRIAC}', "");
    Expect(1, 1872, '\p{^Block=		SYRIAC}', "");
    Expect(1, 1872, '\P{Block=		SYRIAC}', "");
    Expect(0, 1872, '\P{^Block=		SYRIAC}', "");
    Error('\p{Blk=-/a/syriac}');
    Error('\P{Blk=-/a/syriac}');
    Expect(1, 1871, '\p{Blk=:\ASyriac\z:}', "");;
    Expect(0, 1872, '\p{Blk=:\ASyriac\z:}', "");;
    Expect(1, 1871, '\p{Blk=syriac}', "");
    Expect(0, 1871, '\p{^Blk=syriac}', "");
    Expect(0, 1871, '\P{Blk=syriac}', "");
    Expect(1, 1871, '\P{^Blk=syriac}', "");
    Expect(0, 1872, '\p{Blk=syriac}', "");
    Expect(1, 1872, '\p{^Blk=syriac}', "");
    Expect(1, 1872, '\P{Blk=syriac}', "");
    Expect(0, 1872, '\P{^Blk=syriac}', "");
    Expect(1, 1871, '\p{Blk=:\Asyriac\z:}', "");;
    Expect(0, 1872, '\p{Blk=:\Asyriac\z:}', "");;
    Expect(1, 1871, '\p{Blk=_ Syriac}', "");
    Expect(0, 1871, '\p{^Blk=_ Syriac}', "");
    Expect(0, 1871, '\P{Blk=_ Syriac}', "");
    Expect(1, 1871, '\P{^Blk=_ Syriac}', "");
    Expect(0, 1872, '\p{Blk=_ Syriac}', "");
    Expect(1, 1872, '\p{^Blk=_ Syriac}', "");
    Expect(1, 1872, '\P{Blk=_ Syriac}', "");
    Expect(0, 1872, '\P{^Blk=_ Syriac}', "");
    Error('\p{Is_Block=:=-	Syriac}');
    Error('\P{Is_Block=:=-	Syriac}');
    Expect(1, 1871, '\p{Is_Block:syriac}', "");
    Expect(0, 1871, '\p{^Is_Block:syriac}', "");
    Expect(0, 1871, '\P{Is_Block:syriac}', "");
    Expect(1, 1871, '\P{^Is_Block:syriac}', "");
    Expect(0, 1872, '\p{Is_Block:syriac}', "");
    Expect(1, 1872, '\p{^Is_Block:syriac}', "");
    Expect(1, 1872, '\P{Is_Block:syriac}', "");
    Expect(0, 1872, '\P{^Is_Block:syriac}', "");
    Expect(1, 1871, '\p{Is_Block=- syriac}', "");
    Expect(0, 1871, '\p{^Is_Block=- syriac}', "");
    Expect(0, 1871, '\P{Is_Block=- syriac}', "");
    Expect(1, 1871, '\P{^Is_Block=- syriac}', "");
    Expect(0, 1872, '\p{Is_Block=- syriac}', "");
    Expect(1, 1872, '\p{^Is_Block=- syriac}', "");
    Expect(1, 1872, '\P{Is_Block=- syriac}', "");
    Expect(0, 1872, '\P{^Is_Block=- syriac}', "");
    Error('\p{Is_Blk=_/a/syriac}');
    Error('\P{Is_Blk=_/a/syriac}');
    Expect(1, 1871, '\p{Is_Blk=syriac}', "");
    Expect(0, 1871, '\p{^Is_Blk=syriac}', "");
    Expect(0, 1871, '\P{Is_Blk=syriac}', "");
    Expect(1, 1871, '\P{^Is_Blk=syriac}', "");
    Expect(0, 1872, '\p{Is_Blk=syriac}', "");
    Expect(1, 1872, '\p{^Is_Blk=syriac}', "");
    Expect(1, 1872, '\P{Is_Blk=syriac}', "");
    Expect(0, 1872, '\P{^Is_Blk=syriac}', "");
    Expect(1, 1871, '\p{Is_Blk=_-Syriac}', "");
    Expect(0, 1871, '\p{^Is_Blk=_-Syriac}', "");
    Expect(0, 1871, '\P{Is_Blk=_-Syriac}', "");
    Expect(1, 1871, '\P{^Is_Blk=_-Syriac}', "");
    Expect(0, 1872, '\p{Is_Blk=_-Syriac}', "");
    Expect(1, 1872, '\p{^Is_Blk=_-Syriac}', "");
    Expect(1, 1872, '\P{Is_Blk=_-Syriac}', "");
    Expect(0, 1872, '\P{^Is_Blk=_-Syriac}', "");
    Error('\p{Block=	/a/SYRIAC_supplement}');
    Error('\P{Block=	/a/SYRIAC_supplement}');
    Expect(1, 2159, '\p{Block=:\ASyriac_Supplement\z:}', "");;
    Expect(0, 2160, '\p{Block=:\ASyriac_Supplement\z:}', "");;
    Expect(1, 2159, '\p{Block=syriacsupplement}', "");
    Expect(0, 2159, '\p{^Block=syriacsupplement}', "");
    Expect(0, 2159, '\P{Block=syriacsupplement}', "");
    Expect(1, 2159, '\P{^Block=syriacsupplement}', "");
    Expect(0, 2160, '\p{Block=syriacsupplement}', "");
    Expect(1, 2160, '\p{^Block=syriacsupplement}', "");
    Expect(1, 2160, '\P{Block=syriacsupplement}', "");
    Expect(0, 2160, '\P{^Block=syriacsupplement}', "");
    Expect(1, 2159, '\p{Block=:\Asyriacsupplement\z:}', "");;
    Expect(0, 2160, '\p{Block=:\Asyriacsupplement\z:}', "");;
    Expect(1, 2159, '\p{Block=- SYRIAC_Supplement}', "");
    Expect(0, 2159, '\p{^Block=- SYRIAC_Supplement}', "");
    Expect(0, 2159, '\P{Block=- SYRIAC_Supplement}', "");
    Expect(1, 2159, '\P{^Block=- SYRIAC_Supplement}', "");
    Expect(0, 2160, '\p{Block=- SYRIAC_Supplement}', "");
    Expect(1, 2160, '\p{^Block=- SYRIAC_Supplement}', "");
    Expect(1, 2160, '\P{Block=- SYRIAC_Supplement}', "");
    Expect(0, 2160, '\P{^Block=- SYRIAC_Supplement}', "");
    Error('\p{Blk=	/a/Syriac_Sup}');
    Error('\P{Blk=	/a/Syriac_Sup}');
    Expect(1, 2159, '\p{Blk=:\ASyriac_Sup\z:}', "");;
    Expect(0, 2160, '\p{Blk=:\ASyriac_Sup\z:}', "");;
    Expect(1, 2159, '\p{Blk=syriacsup}', "");
    Expect(0, 2159, '\p{^Blk=syriacsup}', "");
    Expect(0, 2159, '\P{Blk=syriacsup}', "");
    Expect(1, 2159, '\P{^Blk=syriacsup}', "");
    Expect(0, 2160, '\p{Blk=syriacsup}', "");
    Expect(1, 2160, '\p{^Blk=syriacsup}', "");
    Expect(1, 2160, '\P{Blk=syriacsup}', "");
    Expect(0, 2160, '\P{^Blk=syriacsup}', "");
    Expect(1, 2159, '\p{Blk=:\Asyriacsup\z:}', "");;
    Expect(0, 2160, '\p{Blk=:\Asyriacsup\z:}', "");;
    Expect(1, 2159, '\p{Blk:    SYRIAC_SUP}', "");
    Expect(0, 2159, '\p{^Blk:    SYRIAC_SUP}', "");
    Expect(0, 2159, '\P{Blk:    SYRIAC_SUP}', "");
    Expect(1, 2159, '\P{^Blk:    SYRIAC_SUP}', "");
    Expect(0, 2160, '\p{Blk:    SYRIAC_SUP}', "");
    Expect(1, 2160, '\p{^Blk:    SYRIAC_SUP}', "");
    Expect(1, 2160, '\P{Blk:    SYRIAC_SUP}', "");
    Expect(0, 2160, '\P{^Blk:    SYRIAC_SUP}', "");
    Error('\p{Is_Block=:=syriac_Supplement}');
    Error('\P{Is_Block=:=syriac_Supplement}');
    Expect(1, 2159, '\p{Is_Block=syriacsupplement}', "");
    Expect(0, 2159, '\p{^Is_Block=syriacsupplement}', "");
    Expect(0, 2159, '\P{Is_Block=syriacsupplement}', "");
    Expect(1, 2159, '\P{^Is_Block=syriacsupplement}', "");
    Expect(0, 2160, '\p{Is_Block=syriacsupplement}', "");
    Expect(1, 2160, '\p{^Is_Block=syriacsupplement}', "");
    Expect(1, 2160, '\P{Is_Block=syriacsupplement}', "");
    Expect(0, 2160, '\P{^Is_Block=syriacsupplement}', "");
    Expect(1, 2159, '\p{Is_Block=- Syriac_Supplement}', "");
    Expect(0, 2159, '\p{^Is_Block=- Syriac_Supplement}', "");
    Expect(0, 2159, '\P{Is_Block=- Syriac_Supplement}', "");
    Expect(1, 2159, '\P{^Is_Block=- Syriac_Supplement}', "");
    Expect(0, 2160, '\p{Is_Block=- Syriac_Supplement}', "");
    Expect(1, 2160, '\p{^Is_Block=- Syriac_Supplement}', "");
    Expect(1, 2160, '\P{Is_Block=- Syriac_Supplement}', "");
    Expect(0, 2160, '\P{^Is_Block=- Syriac_Supplement}', "");
    Error('\p{Is_Blk= :=Syriac_Sup}');
    Error('\P{Is_Blk= :=Syriac_Sup}');
    Expect(1, 2159, '\p{Is_Blk=syriacsup}', "");
    Expect(0, 2159, '\p{^Is_Blk=syriacsup}', "");
    Expect(0, 2159, '\P{Is_Blk=syriacsup}', "");
    Expect(1, 2159, '\P{^Is_Blk=syriacsup}', "");
    Expect(0, 2160, '\p{Is_Blk=syriacsup}', "");
    Expect(1, 2160, '\p{^Is_Blk=syriacsup}', "");
    Expect(1, 2160, '\P{Is_Blk=syriacsup}', "");
    Expect(0, 2160, '\P{^Is_Blk=syriacsup}', "");
    Expect(1, 2159, '\p{Is_Blk=-syriac_sup}', "");
    Expect(0, 2159, '\p{^Is_Blk=-syriac_sup}', "");
    Expect(0, 2159, '\P{Is_Blk=-syriac_sup}', "");
    Expect(1, 2159, '\P{^Is_Blk=-syriac_sup}', "");
    Expect(0, 2160, '\p{Is_Blk=-syriac_sup}', "");
    Expect(1, 2160, '\p{^Is_Blk=-syriac_sup}', "");
    Expect(1, 2160, '\P{Is_Blk=-syriac_sup}', "");
    Expect(0, 2160, '\P{^Is_Blk=-syriac_sup}', "");
    Error('\p{Block=/a/__TAGALOG}');
    Error('\P{Block=/a/__TAGALOG}');
    Expect(1, 5919, '\p{Block=:\ATagalog\z:}', "");;
    Expect(0, 5920, '\p{Block=:\ATagalog\z:}', "");;
    Expect(1, 5919, '\p{Block=tagalog}', "");
    Expect(0, 5919, '\p{^Block=tagalog}', "");
    Expect(0, 5919, '\P{Block=tagalog}', "");
    Expect(1, 5919, '\P{^Block=tagalog}', "");
    Expect(0, 5920, '\p{Block=tagalog}', "");
    Expect(1, 5920, '\p{^Block=tagalog}', "");
    Expect(1, 5920, '\P{Block=tagalog}', "");
    Expect(0, 5920, '\P{^Block=tagalog}', "");
    Expect(1, 5919, '\p{Block=:\Atagalog\z:}', "");;
    Expect(0, 5920, '\p{Block=:\Atagalog\z:}', "");;
    Expect(1, 5919, '\p{Block=	tagalog}', "");
    Expect(0, 5919, '\p{^Block=	tagalog}', "");
    Expect(0, 5919, '\P{Block=	tagalog}', "");
    Expect(1, 5919, '\P{^Block=	tagalog}', "");
    Expect(0, 5920, '\p{Block=	tagalog}', "");
    Expect(1, 5920, '\p{^Block=	tagalog}', "");
    Expect(1, 5920, '\P{Block=	tagalog}', "");
    Expect(0, 5920, '\P{^Block=	tagalog}', "");
    Error('\p{Blk=_ TAGALOG/a/}');
    Error('\P{Blk=_ TAGALOG/a/}');
    Expect(1, 5919, '\p{Blk=:\ATagalog\z:}', "");;
    Expect(0, 5920, '\p{Blk=:\ATagalog\z:}', "");;
    Expect(1, 5919, '\p{Blk=tagalog}', "");
    Expect(0, 5919, '\p{^Blk=tagalog}', "");
    Expect(0, 5919, '\P{Blk=tagalog}', "");
    Expect(1, 5919, '\P{^Blk=tagalog}', "");
    Expect(0, 5920, '\p{Blk=tagalog}', "");
    Expect(1, 5920, '\p{^Blk=tagalog}', "");
    Expect(1, 5920, '\P{Blk=tagalog}', "");
    Expect(0, 5920, '\P{^Blk=tagalog}', "");
    Expect(1, 5919, '\p{Blk=:\Atagalog\z:}', "");;
    Expect(0, 5920, '\p{Blk=:\Atagalog\z:}', "");;
    Expect(1, 5919, '\p{Blk= Tagalog}', "");
    Expect(0, 5919, '\p{^Blk= Tagalog}', "");
    Expect(0, 5919, '\P{Blk= Tagalog}', "");
    Expect(1, 5919, '\P{^Blk= Tagalog}', "");
    Expect(0, 5920, '\p{Blk= Tagalog}', "");
    Expect(1, 5920, '\p{^Blk= Tagalog}', "");
    Expect(1, 5920, '\P{Blk= Tagalog}', "");
    Expect(0, 5920, '\P{^Blk= Tagalog}', "");
    Error('\p{Is_Block= Tagalog/a/}');
    Error('\P{Is_Block= Tagalog/a/}');
    Expect(1, 5919, '\p{Is_Block=tagalog}', "");
    Expect(0, 5919, '\p{^Is_Block=tagalog}', "");
    Expect(0, 5919, '\P{Is_Block=tagalog}', "");
    Expect(1, 5919, '\P{^Is_Block=tagalog}', "");
    Expect(0, 5920, '\p{Is_Block=tagalog}', "");
    Expect(1, 5920, '\p{^Is_Block=tagalog}', "");
    Expect(1, 5920, '\P{Is_Block=tagalog}', "");
    Expect(0, 5920, '\P{^Is_Block=tagalog}', "");
    Expect(1, 5919, '\p{Is_Block=	TAGALOG}', "");
    Expect(0, 5919, '\p{^Is_Block=	TAGALOG}', "");
    Expect(0, 5919, '\P{Is_Block=	TAGALOG}', "");
    Expect(1, 5919, '\P{^Is_Block=	TAGALOG}', "");
    Expect(0, 5920, '\p{Is_Block=	TAGALOG}', "");
    Expect(1, 5920, '\p{^Is_Block=	TAGALOG}', "");
    Expect(1, 5920, '\P{Is_Block=	TAGALOG}', "");
    Expect(0, 5920, '\P{^Is_Block=	TAGALOG}', "");
    Error('\p{Is_Blk=/a/TAGALOG}');
    Error('\P{Is_Blk=/a/TAGALOG}');
    Expect(1, 5919, '\p{Is_Blk=tagalog}', "");
    Expect(0, 5919, '\p{^Is_Blk=tagalog}', "");
    Expect(0, 5919, '\P{Is_Blk=tagalog}', "");
    Expect(1, 5919, '\P{^Is_Blk=tagalog}', "");
    Expect(0, 5920, '\p{Is_Blk=tagalog}', "");
    Expect(1, 5920, '\p{^Is_Blk=tagalog}', "");
    Expect(1, 5920, '\P{Is_Blk=tagalog}', "");
    Expect(0, 5920, '\P{^Is_Blk=tagalog}', "");
    Expect(1, 5919, '\p{Is_Blk=Tagalog}', "");
    Expect(0, 5919, '\p{^Is_Blk=Tagalog}', "");
    Expect(0, 5919, '\P{Is_Blk=Tagalog}', "");
    Expect(1, 5919, '\P{^Is_Blk=Tagalog}', "");
    Expect(0, 5920, '\p{Is_Blk=Tagalog}', "");
    Expect(1, 5920, '\p{^Is_Blk=Tagalog}', "");
    Expect(1, 5920, '\P{Is_Blk=Tagalog}', "");
    Expect(0, 5920, '\P{^Is_Blk=Tagalog}', "");
    Error('\p{Block=/a/	 tagbanwa}');
    Error('\P{Block=/a/	 tagbanwa}');
    Expect(1, 6015, '\p{Block=:\ATagbanwa\z:}', "");;
    Expect(0, 6016, '\p{Block=:\ATagbanwa\z:}', "");;
    Expect(1, 6015, '\p{Block=tagbanwa}', "");
    Expect(0, 6015, '\p{^Block=tagbanwa}', "");
    Expect(0, 6015, '\P{Block=tagbanwa}', "");
    Expect(1, 6015, '\P{^Block=tagbanwa}', "");
    Expect(0, 6016, '\p{Block=tagbanwa}', "");
    Expect(1, 6016, '\p{^Block=tagbanwa}', "");
    Expect(1, 6016, '\P{Block=tagbanwa}', "");
    Expect(0, 6016, '\P{^Block=tagbanwa}', "");
    Expect(1, 6015, '\p{Block=:\Atagbanwa\z:}', "");;
    Expect(0, 6016, '\p{Block=:\Atagbanwa\z:}', "");;
    Expect(1, 6015, '\p{Block=_ tagbanwa}', "");
    Expect(0, 6015, '\p{^Block=_ tagbanwa}', "");
    Expect(0, 6015, '\P{Block=_ tagbanwa}', "");
    Expect(1, 6015, '\P{^Block=_ tagbanwa}', "");
    Expect(0, 6016, '\p{Block=_ tagbanwa}', "");
    Expect(1, 6016, '\p{^Block=_ tagbanwa}', "");
    Expect(1, 6016, '\P{Block=_ tagbanwa}', "");
    Expect(0, 6016, '\P{^Block=_ tagbanwa}', "");
    Error('\p{Blk=:=- Tagbanwa}');
    Error('\P{Blk=:=- Tagbanwa}');
    Expect(1, 6015, '\p{Blk=:\ATagbanwa\z:}', "");;
    Expect(0, 6016, '\p{Blk=:\ATagbanwa\z:}', "");;
    Expect(1, 6015, '\p{Blk=tagbanwa}', "");
    Expect(0, 6015, '\p{^Blk=tagbanwa}', "");
    Expect(0, 6015, '\P{Blk=tagbanwa}', "");
    Expect(1, 6015, '\P{^Blk=tagbanwa}', "");
    Expect(0, 6016, '\p{Blk=tagbanwa}', "");
    Expect(1, 6016, '\p{^Blk=tagbanwa}', "");
    Expect(1, 6016, '\P{Blk=tagbanwa}', "");
    Expect(0, 6016, '\P{^Blk=tagbanwa}', "");
    Expect(1, 6015, '\p{Blk=:\Atagbanwa\z:}', "");;
    Expect(0, 6016, '\p{Blk=:\Atagbanwa\z:}', "");;
    Expect(1, 6015, '\p{Blk=-	tagbanwa}', "");
    Expect(0, 6015, '\p{^Blk=-	tagbanwa}', "");
    Expect(0, 6015, '\P{Blk=-	tagbanwa}', "");
    Expect(1, 6015, '\P{^Blk=-	tagbanwa}', "");
    Expect(0, 6016, '\p{Blk=-	tagbanwa}', "");
    Expect(1, 6016, '\p{^Blk=-	tagbanwa}', "");
    Expect(1, 6016, '\P{Blk=-	tagbanwa}', "");
    Expect(0, 6016, '\P{^Blk=-	tagbanwa}', "");
    Error('\p{Is_Block=/a/_	Tagbanwa}');
    Error('\P{Is_Block=/a/_	Tagbanwa}');
    Expect(1, 6015, '\p{Is_Block: tagbanwa}', "");
    Expect(0, 6015, '\p{^Is_Block: tagbanwa}', "");
    Expect(0, 6015, '\P{Is_Block: tagbanwa}', "");
    Expect(1, 6015, '\P{^Is_Block: tagbanwa}', "");
    Expect(0, 6016, '\p{Is_Block: tagbanwa}', "");
    Expect(1, 6016, '\p{^Is_Block: tagbanwa}', "");
    Expect(1, 6016, '\P{Is_Block: tagbanwa}', "");
    Expect(0, 6016, '\P{^Is_Block: tagbanwa}', "");
    Expect(1, 6015, '\p{Is_Block=-	tagbanwa}', "");
    Expect(0, 6015, '\p{^Is_Block=-	tagbanwa}', "");
    Expect(0, 6015, '\P{Is_Block=-	tagbanwa}', "");
    Expect(1, 6015, '\P{^Is_Block=-	tagbanwa}', "");
    Expect(0, 6016, '\p{Is_Block=-	tagbanwa}', "");
    Expect(1, 6016, '\p{^Is_Block=-	tagbanwa}', "");
    Expect(1, 6016, '\P{Is_Block=-	tagbanwa}', "");
    Expect(0, 6016, '\P{^Is_Block=-	tagbanwa}', "");
    Error('\p{Is_Blk=/a/- tagbanwa}');
    Error('\P{Is_Blk=/a/- tagbanwa}');
    Expect(1, 6015, '\p{Is_Blk=tagbanwa}', "");
    Expect(0, 6015, '\p{^Is_Blk=tagbanwa}', "");
    Expect(0, 6015, '\P{Is_Blk=tagbanwa}', "");
    Expect(1, 6015, '\P{^Is_Blk=tagbanwa}', "");
    Expect(0, 6016, '\p{Is_Blk=tagbanwa}', "");
    Expect(1, 6016, '\p{^Is_Blk=tagbanwa}', "");
    Expect(1, 6016, '\P{Is_Blk=tagbanwa}', "");
    Expect(0, 6016, '\P{^Is_Blk=tagbanwa}', "");
    Expect(1, 6015, '\p{Is_Blk= _Tagbanwa}', "");
    Expect(0, 6015, '\p{^Is_Blk= _Tagbanwa}', "");
    Expect(0, 6015, '\P{Is_Blk= _Tagbanwa}', "");
    Expect(1, 6015, '\P{^Is_Blk= _Tagbanwa}', "");
    Expect(0, 6016, '\p{Is_Blk= _Tagbanwa}', "");
    Expect(1, 6016, '\p{^Is_Blk= _Tagbanwa}', "");
    Expect(1, 6016, '\P{Is_Blk= _Tagbanwa}', "");
    Expect(0, 6016, '\P{^Is_Blk= _Tagbanwa}', "");
    Error('\p{Block=-/a/TAGS}');
    Error('\P{Block=-/a/TAGS}');
    Expect(1, 917631, '\p{Block=:\ATags\z:}', "");;
    Expect(0, 917632, '\p{Block=:\ATags\z:}', "");;
    Expect(1, 917631, '\p{Block=tags}', "");
    Expect(0, 917631, '\p{^Block=tags}', "");
    Expect(0, 917631, '\P{Block=tags}', "");
    Expect(1, 917631, '\P{^Block=tags}', "");
    Expect(0, 917632, '\p{Block=tags}', "");
    Expect(1, 917632, '\p{^Block=tags}', "");
    Expect(1, 917632, '\P{Block=tags}', "");
    Expect(0, 917632, '\P{^Block=tags}', "");
    Expect(1, 917631, '\p{Block=:\Atags\z:}', "");;
    Expect(0, 917632, '\p{Block=:\Atags\z:}', "");;
    Expect(1, 917631, '\p{Block=		TAGS}', "");
    Expect(0, 917631, '\p{^Block=		TAGS}', "");
    Expect(0, 917631, '\P{Block=		TAGS}', "");
    Expect(1, 917631, '\P{^Block=		TAGS}', "");
    Expect(0, 917632, '\p{Block=		TAGS}', "");
    Expect(1, 917632, '\p{^Block=		TAGS}', "");
    Expect(1, 917632, '\P{Block=		TAGS}', "");
    Expect(0, 917632, '\P{^Block=		TAGS}', "");
    Error('\p{Blk=	/a/Tags}');
    Error('\P{Blk=	/a/Tags}');
    Expect(1, 917631, '\p{Blk=:\ATags\z:}', "");;
    Expect(0, 917632, '\p{Blk=:\ATags\z:}', "");;
    Expect(1, 917631, '\p{Blk=tags}', "");
    Expect(0, 917631, '\p{^Blk=tags}', "");
    Expect(0, 917631, '\P{Blk=tags}', "");
    Expect(1, 917631, '\P{^Blk=tags}', "");
    Expect(0, 917632, '\p{Blk=tags}', "");
    Expect(1, 917632, '\p{^Blk=tags}', "");
    Expect(1, 917632, '\P{Blk=tags}', "");
    Expect(0, 917632, '\P{^Blk=tags}', "");
    Expect(1, 917631, '\p{Blk=:\Atags\z:}', "");;
    Expect(0, 917632, '\p{Blk=:\Atags\z:}', "");;
    Expect(1, 917631, '\p{Blk=	Tags}', "");
    Expect(0, 917631, '\p{^Blk=	Tags}', "");
    Expect(0, 917631, '\P{Blk=	Tags}', "");
    Expect(1, 917631, '\P{^Blk=	Tags}', "");
    Expect(0, 917632, '\p{Blk=	Tags}', "");
    Expect(1, 917632, '\p{^Blk=	Tags}', "");
    Expect(1, 917632, '\P{Blk=	Tags}', "");
    Expect(0, 917632, '\P{^Blk=	Tags}', "");
    Error('\p{Is_Block: /a/tags}');
    Error('\P{Is_Block: /a/tags}');
    Expect(1, 917631, '\p{Is_Block=tags}', "");
    Expect(0, 917631, '\p{^Is_Block=tags}', "");
    Expect(0, 917631, '\P{Is_Block=tags}', "");
    Expect(1, 917631, '\P{^Is_Block=tags}', "");
    Expect(0, 917632, '\p{Is_Block=tags}', "");
    Expect(1, 917632, '\p{^Is_Block=tags}', "");
    Expect(1, 917632, '\P{Is_Block=tags}', "");
    Expect(0, 917632, '\P{^Is_Block=tags}', "");
    Expect(1, 917631, '\p{Is_Block=--TAGS}', "");
    Expect(0, 917631, '\p{^Is_Block=--TAGS}', "");
    Expect(0, 917631, '\P{Is_Block=--TAGS}', "");
    Expect(1, 917631, '\P{^Is_Block=--TAGS}', "");
    Expect(0, 917632, '\p{Is_Block=--TAGS}', "");
    Expect(1, 917632, '\p{^Is_Block=--TAGS}', "");
    Expect(1, 917632, '\P{Is_Block=--TAGS}', "");
    Expect(0, 917632, '\P{^Is_Block=--TAGS}', "");
    Error('\p{Is_Blk=_ TAGS/a/}');
    Error('\P{Is_Blk=_ TAGS/a/}');
    Expect(1, 917631, '\p{Is_Blk=tags}', "");
    Expect(0, 917631, '\p{^Is_Blk=tags}', "");
    Expect(0, 917631, '\P{Is_Blk=tags}', "");
    Expect(1, 917631, '\P{^Is_Blk=tags}', "");
    Expect(0, 917632, '\p{Is_Blk=tags}', "");
    Expect(1, 917632, '\p{^Is_Blk=tags}', "");
    Expect(1, 917632, '\P{Is_Blk=tags}', "");
    Expect(0, 917632, '\P{^Is_Blk=tags}', "");
    Expect(1, 917631, '\p{Is_Blk= 	TAGS}', "");
    Expect(0, 917631, '\p{^Is_Blk= 	TAGS}', "");
    Expect(0, 917631, '\P{Is_Blk= 	TAGS}', "");
    Expect(1, 917631, '\P{^Is_Blk= 	TAGS}', "");
    Expect(0, 917632, '\p{Is_Blk= 	TAGS}', "");
    Expect(1, 917632, '\p{^Is_Blk= 	TAGS}', "");
    Expect(1, 917632, '\P{Is_Blk= 	TAGS}', "");
    Expect(0, 917632, '\P{^Is_Blk= 	TAGS}', "");
    Error('\p{Block=	/a/Tai_Le}');
    Error('\P{Block=	/a/Tai_Le}');
    Expect(1, 6527, '\p{Block=:\ATai_Le\z:}', "");;
    Expect(0, 6528, '\p{Block=:\ATai_Le\z:}', "");;
    Expect(1, 6527, '\p{Block=taile}', "");
    Expect(0, 6527, '\p{^Block=taile}', "");
    Expect(0, 6527, '\P{Block=taile}', "");
    Expect(1, 6527, '\P{^Block=taile}', "");
    Expect(0, 6528, '\p{Block=taile}', "");
    Expect(1, 6528, '\p{^Block=taile}', "");
    Expect(1, 6528, '\P{Block=taile}', "");
    Expect(0, 6528, '\P{^Block=taile}', "");
    Expect(1, 6527, '\p{Block=:\Ataile\z:}', "");;
    Expect(0, 6528, '\p{Block=:\Ataile\z:}', "");;
    Expect(1, 6527, '\p{Block=-Tai_le}', "");
    Expect(0, 6527, '\p{^Block=-Tai_le}', "");
    Expect(0, 6527, '\P{Block=-Tai_le}', "");
    Expect(1, 6527, '\P{^Block=-Tai_le}', "");
    Expect(0, 6528, '\p{Block=-Tai_le}', "");
    Expect(1, 6528, '\p{^Block=-Tai_le}', "");
    Expect(1, 6528, '\P{Block=-Tai_le}', "");
    Expect(0, 6528, '\P{^Block=-Tai_le}', "");
    Error('\p{Blk=_:=Tai_Le}');
    Error('\P{Blk=_:=Tai_Le}');
    Expect(1, 6527, '\p{Blk=:\ATai_Le\z:}', "");;
    Expect(0, 6528, '\p{Blk=:\ATai_Le\z:}', "");;
    Expect(1, 6527, '\p{Blk=taile}', "");
    Expect(0, 6527, '\p{^Blk=taile}', "");
    Expect(0, 6527, '\P{Blk=taile}', "");
    Expect(1, 6527, '\P{^Blk=taile}', "");
    Expect(0, 6528, '\p{Blk=taile}', "");
    Expect(1, 6528, '\p{^Blk=taile}', "");
    Expect(1, 6528, '\P{Blk=taile}', "");
    Expect(0, 6528, '\P{^Blk=taile}', "");
    Expect(1, 6527, '\p{Blk=:\Ataile\z:}', "");;
    Expect(0, 6528, '\p{Blk=:\Ataile\z:}', "");;
    Expect(1, 6527, '\p{Blk=_ Tai_Le}', "");
    Expect(0, 6527, '\p{^Blk=_ Tai_Le}', "");
    Expect(0, 6527, '\P{Blk=_ Tai_Le}', "");
    Expect(1, 6527, '\P{^Blk=_ Tai_Le}', "");
    Expect(0, 6528, '\p{Blk=_ Tai_Le}', "");
    Expect(1, 6528, '\p{^Blk=_ Tai_Le}', "");
    Expect(1, 6528, '\P{Blk=_ Tai_Le}', "");
    Expect(0, 6528, '\P{^Blk=_ Tai_Le}', "");
    Error('\p{Is_Block=	:=TAI_le}');
    Error('\P{Is_Block=	:=TAI_le}');
    Expect(1, 6527, '\p{Is_Block=taile}', "");
    Expect(0, 6527, '\p{^Is_Block=taile}', "");
    Expect(0, 6527, '\P{Is_Block=taile}', "");
    Expect(1, 6527, '\P{^Is_Block=taile}', "");
    Expect(0, 6528, '\p{Is_Block=taile}', "");
    Expect(1, 6528, '\p{^Is_Block=taile}', "");
    Expect(1, 6528, '\P{Is_Block=taile}', "");
    Expect(0, 6528, '\P{^Is_Block=taile}', "");
    Expect(1, 6527, '\p{Is_Block=	Tai_LE}', "");
    Expect(0, 6527, '\p{^Is_Block=	Tai_LE}', "");
    Expect(0, 6527, '\P{Is_Block=	Tai_LE}', "");
    Expect(1, 6527, '\P{^Is_Block=	Tai_LE}', "");
    Expect(0, 6528, '\p{Is_Block=	Tai_LE}', "");
    Expect(1, 6528, '\p{^Is_Block=	Tai_LE}', "");
    Expect(1, 6528, '\P{Is_Block=	Tai_LE}', "");
    Expect(0, 6528, '\P{^Is_Block=	Tai_LE}', "");
    Error('\p{Is_Blk=_Tai_Le/a/}');
    Error('\P{Is_Blk=_Tai_Le/a/}');
    Expect(1, 6527, '\p{Is_Blk=taile}', "");
    Expect(0, 6527, '\p{^Is_Blk=taile}', "");
    Expect(0, 6527, '\P{Is_Blk=taile}', "");
    Expect(1, 6527, '\P{^Is_Blk=taile}', "");
    Expect(0, 6528, '\p{Is_Blk=taile}', "");
    Expect(1, 6528, '\p{^Is_Blk=taile}', "");
    Expect(1, 6528, '\P{Is_Blk=taile}', "");
    Expect(0, 6528, '\P{^Is_Blk=taile}', "");
    Expect(1, 6527, '\p{Is_Blk= -tai_Le}', "");
    Expect(0, 6527, '\p{^Is_Blk= -tai_Le}', "");
    Expect(0, 6527, '\P{Is_Blk= -tai_Le}', "");
    Expect(1, 6527, '\P{^Is_Blk= -tai_Le}', "");
    Expect(0, 6528, '\p{Is_Blk= -tai_Le}', "");
    Expect(1, 6528, '\p{^Is_Blk= -tai_Le}', "");
    Expect(1, 6528, '\P{Is_Blk= -tai_Le}', "");
    Expect(0, 6528, '\P{^Is_Blk= -tai_Le}', "");
    Error('\p{Block:-	Tai_Tham:=}');
    Error('\P{Block:-	Tai_Tham:=}');
    Expect(1, 6831, '\p{Block=:\ATai_Tham\z:}', "");;
    Expect(0, 6832, '\p{Block=:\ATai_Tham\z:}', "");;
    Expect(1, 6831, '\p{Block=taitham}', "");
    Expect(0, 6831, '\p{^Block=taitham}', "");
    Expect(0, 6831, '\P{Block=taitham}', "");
    Expect(1, 6831, '\P{^Block=taitham}', "");
    Expect(0, 6832, '\p{Block=taitham}', "");
    Expect(1, 6832, '\p{^Block=taitham}', "");
    Expect(1, 6832, '\P{Block=taitham}', "");
    Expect(0, 6832, '\P{^Block=taitham}', "");
    Expect(1, 6831, '\p{Block=:\Ataitham\z:}', "");;
    Expect(0, 6832, '\p{Block=:\Ataitham\z:}', "");;
    Expect(1, 6831, '\p{Block=__Tai_Tham}', "");
    Expect(0, 6831, '\p{^Block=__Tai_Tham}', "");
    Expect(0, 6831, '\P{Block=__Tai_Tham}', "");
    Expect(1, 6831, '\P{^Block=__Tai_Tham}', "");
    Expect(0, 6832, '\p{Block=__Tai_Tham}', "");
    Expect(1, 6832, '\p{^Block=__Tai_Tham}', "");
    Expect(1, 6832, '\P{Block=__Tai_Tham}', "");
    Expect(0, 6832, '\P{^Block=__Tai_Tham}', "");
    Error('\p{Blk=/a/--Tai_tham}');
    Error('\P{Blk=/a/--Tai_tham}');
    Expect(1, 6831, '\p{Blk=:\ATai_Tham\z:}', "");;
    Expect(0, 6832, '\p{Blk=:\ATai_Tham\z:}', "");;
    Expect(1, 6831, '\p{Blk=taitham}', "");
    Expect(0, 6831, '\p{^Blk=taitham}', "");
    Expect(0, 6831, '\P{Blk=taitham}', "");
    Expect(1, 6831, '\P{^Blk=taitham}', "");
    Expect(0, 6832, '\p{Blk=taitham}', "");
    Expect(1, 6832, '\p{^Blk=taitham}', "");
    Expect(1, 6832, '\P{Blk=taitham}', "");
    Expect(0, 6832, '\P{^Blk=taitham}', "");
    Expect(1, 6831, '\p{Blk=:\Ataitham\z:}', "");;
    Expect(0, 6832, '\p{Blk=:\Ataitham\z:}', "");;
    Expect(1, 6831, '\p{Blk=--Tai_Tham}', "");
    Expect(0, 6831, '\p{^Blk=--Tai_Tham}', "");
    Expect(0, 6831, '\P{Blk=--Tai_Tham}', "");
    Expect(1, 6831, '\P{^Blk=--Tai_Tham}', "");
    Expect(0, 6832, '\p{Blk=--Tai_Tham}', "");
    Expect(1, 6832, '\p{^Blk=--Tai_Tham}', "");
    Expect(1, 6832, '\P{Blk=--Tai_Tham}', "");
    Expect(0, 6832, '\P{^Blk=--Tai_Tham}', "");
    Error('\p{Is_Block=-	tai_tham/a/}');
    Error('\P{Is_Block=-	tai_tham/a/}');
    Expect(1, 6831, '\p{Is_Block=taitham}', "");
    Expect(0, 6831, '\p{^Is_Block=taitham}', "");
    Expect(0, 6831, '\P{Is_Block=taitham}', "");
    Expect(1, 6831, '\P{^Is_Block=taitham}', "");
    Expect(0, 6832, '\p{Is_Block=taitham}', "");
    Expect(1, 6832, '\p{^Is_Block=taitham}', "");
    Expect(1, 6832, '\P{Is_Block=taitham}', "");
    Expect(0, 6832, '\P{^Is_Block=taitham}', "");
    Expect(1, 6831, '\p{Is_Block= Tai_tham}', "");
    Expect(0, 6831, '\p{^Is_Block= Tai_tham}', "");
    Expect(0, 6831, '\P{Is_Block= Tai_tham}', "");
    Expect(1, 6831, '\P{^Is_Block= Tai_tham}', "");
    Expect(0, 6832, '\p{Is_Block= Tai_tham}', "");
    Expect(1, 6832, '\p{^Is_Block= Tai_tham}', "");
    Expect(1, 6832, '\P{Is_Block= Tai_tham}', "");
    Expect(0, 6832, '\P{^Is_Block= Tai_tham}', "");
    Error('\p{Is_Blk=:= Tai_Tham}');
    Error('\P{Is_Blk=:= Tai_Tham}');
    Expect(1, 6831, '\p{Is_Blk=taitham}', "");
    Expect(0, 6831, '\p{^Is_Blk=taitham}', "");
    Expect(0, 6831, '\P{Is_Blk=taitham}', "");
    Expect(1, 6831, '\P{^Is_Blk=taitham}', "");
    Expect(0, 6832, '\p{Is_Blk=taitham}', "");
    Expect(1, 6832, '\p{^Is_Blk=taitham}', "");
    Expect(1, 6832, '\P{Is_Blk=taitham}', "");
    Expect(0, 6832, '\P{^Is_Blk=taitham}', "");
    Expect(1, 6831, '\p{Is_Blk=_tai_tham}', "");
    Expect(0, 6831, '\p{^Is_Blk=_tai_tham}', "");
    Expect(0, 6831, '\P{Is_Blk=_tai_tham}', "");
    Expect(1, 6831, '\P{^Is_Blk=_tai_tham}', "");
    Expect(0, 6832, '\p{Is_Blk=_tai_tham}', "");
    Expect(1, 6832, '\p{^Is_Blk=_tai_tham}', "");
    Expect(1, 6832, '\P{Is_Blk=_tai_tham}', "");
    Expect(0, 6832, '\P{^Is_Blk=_tai_tham}', "");
    Error('\p{Block=	tai_Viet:=}');
    Error('\P{Block=	tai_Viet:=}');
    Expect(1, 43743, '\p{Block=:\ATai_Viet\z:}', "");;
    Expect(0, 43744, '\p{Block=:\ATai_Viet\z:}', "");;
    Expect(1, 43743, '\p{Block=taiviet}', "");
    Expect(0, 43743, '\p{^Block=taiviet}', "");
    Expect(0, 43743, '\P{Block=taiviet}', "");
    Expect(1, 43743, '\P{^Block=taiviet}', "");
    Expect(0, 43744, '\p{Block=taiviet}', "");
    Expect(1, 43744, '\p{^Block=taiviet}', "");
    Expect(1, 43744, '\P{Block=taiviet}', "");
    Expect(0, 43744, '\P{^Block=taiviet}', "");
    Expect(1, 43743, '\p{Block=:\Ataiviet\z:}', "");;
    Expect(0, 43744, '\p{Block=:\Ataiviet\z:}', "");;
    Expect(1, 43743, '\p{Block= -TAI_VIET}', "");
    Expect(0, 43743, '\p{^Block= -TAI_VIET}', "");
    Expect(0, 43743, '\P{Block= -TAI_VIET}', "");
    Expect(1, 43743, '\P{^Block= -TAI_VIET}', "");
    Expect(0, 43744, '\p{Block= -TAI_VIET}', "");
    Expect(1, 43744, '\p{^Block= -TAI_VIET}', "");
    Expect(1, 43744, '\P{Block= -TAI_VIET}', "");
    Expect(0, 43744, '\P{^Block= -TAI_VIET}', "");
    Error('\p{Blk=:=tai_Viet}');
    Error('\P{Blk=:=tai_Viet}');
    Expect(1, 43743, '\p{Blk=:\ATai_Viet\z:}', "");;
    Expect(0, 43744, '\p{Blk=:\ATai_Viet\z:}', "");;
    Expect(1, 43743, '\p{Blk=taiviet}', "");
    Expect(0, 43743, '\p{^Blk=taiviet}', "");
    Expect(0, 43743, '\P{Blk=taiviet}', "");
    Expect(1, 43743, '\P{^Blk=taiviet}', "");
    Expect(0, 43744, '\p{Blk=taiviet}', "");
    Expect(1, 43744, '\p{^Blk=taiviet}', "");
    Expect(1, 43744, '\P{Blk=taiviet}', "");
    Expect(0, 43744, '\P{^Blk=taiviet}', "");
    Expect(1, 43743, '\p{Blk=:\Ataiviet\z:}', "");;
    Expect(0, 43744, '\p{Blk=:\Ataiviet\z:}', "");;
    Expect(1, 43743, '\p{Blk=_	Tai_viet}', "");
    Expect(0, 43743, '\p{^Blk=_	Tai_viet}', "");
    Expect(0, 43743, '\P{Blk=_	Tai_viet}', "");
    Expect(1, 43743, '\P{^Blk=_	Tai_viet}', "");
    Expect(0, 43744, '\p{Blk=_	Tai_viet}', "");
    Expect(1, 43744, '\p{^Blk=_	Tai_viet}', "");
    Expect(1, 43744, '\P{Blk=_	Tai_viet}', "");
    Expect(0, 43744, '\P{^Blk=_	Tai_viet}', "");
    Error('\p{Is_Block=	-Tai_VIET/a/}');
    Error('\P{Is_Block=	-Tai_VIET/a/}');
    Expect(1, 43743, '\p{Is_Block=taiviet}', "");
    Expect(0, 43743, '\p{^Is_Block=taiviet}', "");
    Expect(0, 43743, '\P{Is_Block=taiviet}', "");
    Expect(1, 43743, '\P{^Is_Block=taiviet}', "");
    Expect(0, 43744, '\p{Is_Block=taiviet}', "");
    Expect(1, 43744, '\p{^Is_Block=taiviet}', "");
    Expect(1, 43744, '\P{Is_Block=taiviet}', "");
    Expect(0, 43744, '\P{^Is_Block=taiviet}', "");
    Expect(1, 43743, '\p{Is_Block:   _tai_Viet}', "");
    Expect(0, 43743, '\p{^Is_Block:   _tai_Viet}', "");
    Expect(0, 43743, '\P{Is_Block:   _tai_Viet}', "");
    Expect(1, 43743, '\P{^Is_Block:   _tai_Viet}', "");
    Expect(0, 43744, '\p{Is_Block:   _tai_Viet}', "");
    Expect(1, 43744, '\p{^Is_Block:   _tai_Viet}', "");
    Expect(1, 43744, '\P{Is_Block:   _tai_Viet}', "");
    Expect(0, 43744, '\P{^Is_Block:   _tai_Viet}', "");
    Error('\p{Is_Blk=/a/_ Tai_VIET}');
    Error('\P{Is_Blk=/a/_ Tai_VIET}');
    Expect(1, 43743, '\p{Is_Blk=taiviet}', "");
    Expect(0, 43743, '\p{^Is_Blk=taiviet}', "");
    Expect(0, 43743, '\P{Is_Blk=taiviet}', "");
    Expect(1, 43743, '\P{^Is_Blk=taiviet}', "");
    Expect(0, 43744, '\p{Is_Blk=taiviet}', "");
    Expect(1, 43744, '\p{^Is_Blk=taiviet}', "");
    Expect(1, 43744, '\P{Is_Blk=taiviet}', "");
    Expect(0, 43744, '\P{^Is_Blk=taiviet}', "");
    Expect(1, 43743, '\p{Is_Blk:   -	tai_Viet}', "");
    Expect(0, 43743, '\p{^Is_Blk:   -	tai_Viet}', "");
    Expect(0, 43743, '\P{Is_Blk:   -	tai_Viet}', "");
    Expect(1, 43743, '\P{^Is_Blk:   -	tai_Viet}', "");
    Expect(0, 43744, '\p{Is_Blk:   -	tai_Viet}', "");
    Expect(1, 43744, '\p{^Is_Blk:   -	tai_Viet}', "");
    Expect(1, 43744, '\P{Is_Blk:   -	tai_Viet}', "");
    Expect(0, 43744, '\P{^Is_Blk:   -	tai_Viet}', "");
    Error('\p{Block=/a/	-Tai_Xuan_Jing_symbols}');
    Error('\P{Block=/a/	-Tai_Xuan_Jing_symbols}');
    Expect(1, 119647, '\p{Block=:\ATai_Xuan_Jing_Symbols\z:}', "");;
    Expect(0, 119648, '\p{Block=:\ATai_Xuan_Jing_Symbols\z:}', "");;
    Expect(1, 119647, '\p{Block=taixuanjingsymbols}', "");
    Expect(0, 119647, '\p{^Block=taixuanjingsymbols}', "");
    Expect(0, 119647, '\P{Block=taixuanjingsymbols}', "");
    Expect(1, 119647, '\P{^Block=taixuanjingsymbols}', "");
    Expect(0, 119648, '\p{Block=taixuanjingsymbols}', "");
    Expect(1, 119648, '\p{^Block=taixuanjingsymbols}', "");
    Expect(1, 119648, '\P{Block=taixuanjingsymbols}', "");
    Expect(0, 119648, '\P{^Block=taixuanjingsymbols}', "");
    Expect(1, 119647, '\p{Block=:\Ataixuanjingsymbols\z:}', "");;
    Expect(0, 119648, '\p{Block=:\Ataixuanjingsymbols\z:}', "");;
    Expect(1, 119647, '\p{Block=_ TAI_xuan_Jing_SYMBOLS}', "");
    Expect(0, 119647, '\p{^Block=_ TAI_xuan_Jing_SYMBOLS}', "");
    Expect(0, 119647, '\P{Block=_ TAI_xuan_Jing_SYMBOLS}', "");
    Expect(1, 119647, '\P{^Block=_ TAI_xuan_Jing_SYMBOLS}', "");
    Expect(0, 119648, '\p{Block=_ TAI_xuan_Jing_SYMBOLS}', "");
    Expect(1, 119648, '\p{^Block=_ TAI_xuan_Jing_SYMBOLS}', "");
    Expect(1, 119648, '\P{Block=_ TAI_xuan_Jing_SYMBOLS}', "");
    Expect(0, 119648, '\P{^Block=_ TAI_xuan_Jing_SYMBOLS}', "");
    Error('\p{Blk= Tai_Xuan_JING:=}');
    Error('\P{Blk= Tai_Xuan_JING:=}');
    Expect(1, 119647, '\p{Blk=:\ATai_Xuan_Jing\z:}', "");;
    Expect(0, 119648, '\p{Blk=:\ATai_Xuan_Jing\z:}', "");;
    Expect(1, 119647, '\p{Blk=taixuanjing}', "");
    Expect(0, 119647, '\p{^Blk=taixuanjing}', "");
    Expect(0, 119647, '\P{Blk=taixuanjing}', "");
    Expect(1, 119647, '\P{^Blk=taixuanjing}', "");
    Expect(0, 119648, '\p{Blk=taixuanjing}', "");
    Expect(1, 119648, '\p{^Blk=taixuanjing}', "");
    Expect(1, 119648, '\P{Blk=taixuanjing}', "");
    Expect(0, 119648, '\P{^Blk=taixuanjing}', "");
    Expect(1, 119647, '\p{Blk=:\Ataixuanjing\z:}', "");;
    Expect(0, 119648, '\p{Blk=:\Ataixuanjing\z:}', "");;
    Expect(1, 119647, '\p{Blk= 	tai_Xuan_Jing}', "");
    Expect(0, 119647, '\p{^Blk= 	tai_Xuan_Jing}', "");
    Expect(0, 119647, '\P{Blk= 	tai_Xuan_Jing}', "");
    Expect(1, 119647, '\P{^Blk= 	tai_Xuan_Jing}', "");
    Expect(0, 119648, '\p{Blk= 	tai_Xuan_Jing}', "");
    Expect(1, 119648, '\p{^Blk= 	tai_Xuan_Jing}', "");
    Expect(1, 119648, '\P{Blk= 	tai_Xuan_Jing}', "");
    Expect(0, 119648, '\P{^Blk= 	tai_Xuan_Jing}', "");
    Error('\p{Is_Block=_/a/tai_XUAN_JING_Symbols}');
    Error('\P{Is_Block=_/a/tai_XUAN_JING_Symbols}');
    Expect(1, 119647, '\p{Is_Block:	taixuanjingsymbols}', "");
    Expect(0, 119647, '\p{^Is_Block:	taixuanjingsymbols}', "");
    Expect(0, 119647, '\P{Is_Block:	taixuanjingsymbols}', "");
    Expect(1, 119647, '\P{^Is_Block:	taixuanjingsymbols}', "");
    Expect(0, 119648, '\p{Is_Block:	taixuanjingsymbols}', "");
    Expect(1, 119648, '\p{^Is_Block:	taixuanjingsymbols}', "");
    Expect(1, 119648, '\P{Is_Block:	taixuanjingsymbols}', "");
    Expect(0, 119648, '\P{^Is_Block:	taixuanjingsymbols}', "");
    Expect(1, 119647, '\p{Is_Block= tai_Xuan_Jing_SYMBOLS}', "");
    Expect(0, 119647, '\p{^Is_Block= tai_Xuan_Jing_SYMBOLS}', "");
    Expect(0, 119647, '\P{Is_Block= tai_Xuan_Jing_SYMBOLS}', "");
    Expect(1, 119647, '\P{^Is_Block= tai_Xuan_Jing_SYMBOLS}', "");
    Expect(0, 119648, '\p{Is_Block= tai_Xuan_Jing_SYMBOLS}', "");
    Expect(1, 119648, '\p{^Is_Block= tai_Xuan_Jing_SYMBOLS}', "");
    Expect(1, 119648, '\P{Is_Block= tai_Xuan_Jing_SYMBOLS}', "");
    Expect(0, 119648, '\P{^Is_Block= tai_Xuan_Jing_SYMBOLS}', "");
    Error('\p{Is_Blk=  TAI_xuan_Jing:=}');
    Error('\P{Is_Blk=  TAI_xuan_Jing:=}');
    Expect(1, 119647, '\p{Is_Blk=taixuanjing}', "");
    Expect(0, 119647, '\p{^Is_Blk=taixuanjing}', "");
    Expect(0, 119647, '\P{Is_Blk=taixuanjing}', "");
    Expect(1, 119647, '\P{^Is_Blk=taixuanjing}', "");
    Expect(0, 119648, '\p{Is_Blk=taixuanjing}', "");
    Expect(1, 119648, '\p{^Is_Blk=taixuanjing}', "");
    Expect(1, 119648, '\P{Is_Blk=taixuanjing}', "");
    Expect(0, 119648, '\P{^Is_Blk=taixuanjing}', "");
    Expect(1, 119647, '\p{Is_Blk=_ tai_Xuan_Jing}', "");
    Expect(0, 119647, '\p{^Is_Blk=_ tai_Xuan_Jing}', "");
    Expect(0, 119647, '\P{Is_Blk=_ tai_Xuan_Jing}', "");
    Expect(1, 119647, '\P{^Is_Blk=_ tai_Xuan_Jing}', "");
    Expect(0, 119648, '\p{Is_Blk=_ tai_Xuan_Jing}', "");
    Expect(1, 119648, '\p{^Is_Blk=_ tai_Xuan_Jing}', "");
    Expect(1, 119648, '\P{Is_Blk=_ tai_Xuan_Jing}', "");
    Expect(0, 119648, '\P{^Is_Blk=_ tai_Xuan_Jing}', "");
    Error('\p{Block=	/a/takri}');
    Error('\P{Block=	/a/takri}');
    Expect(1, 71375, '\p{Block=:\ATakri\z:}', "");;
    Expect(0, 71376, '\p{Block=:\ATakri\z:}', "");;
    Expect(1, 71375, '\p{Block=takri}', "");
    Expect(0, 71375, '\p{^Block=takri}', "");
    Expect(0, 71375, '\P{Block=takri}', "");
    Expect(1, 71375, '\P{^Block=takri}', "");
    Expect(0, 71376, '\p{Block=takri}', "");
    Expect(1, 71376, '\p{^Block=takri}', "");
    Expect(1, 71376, '\P{Block=takri}', "");
    Expect(0, 71376, '\P{^Block=takri}', "");
    Expect(1, 71375, '\p{Block=:\Atakri\z:}', "");;
    Expect(0, 71376, '\p{Block=:\Atakri\z:}', "");;
    Expect(1, 71375, '\p{Block=--TAKRI}', "");
    Expect(0, 71375, '\p{^Block=--TAKRI}', "");
    Expect(0, 71375, '\P{Block=--TAKRI}', "");
    Expect(1, 71375, '\P{^Block=--TAKRI}', "");
    Expect(0, 71376, '\p{Block=--TAKRI}', "");
    Expect(1, 71376, '\p{^Block=--TAKRI}', "");
    Expect(1, 71376, '\P{Block=--TAKRI}', "");
    Expect(0, 71376, '\P{^Block=--TAKRI}', "");
    Error('\p{Blk=:=_ TAKRI}');
    Error('\P{Blk=:=_ TAKRI}');
    Expect(1, 71375, '\p{Blk=:\ATakri\z:}', "");;
    Expect(0, 71376, '\p{Blk=:\ATakri\z:}', "");;
    Expect(1, 71375, '\p{Blk=takri}', "");
    Expect(0, 71375, '\p{^Blk=takri}', "");
    Expect(0, 71375, '\P{Blk=takri}', "");
    Expect(1, 71375, '\P{^Blk=takri}', "");
    Expect(0, 71376, '\p{Blk=takri}', "");
    Expect(1, 71376, '\p{^Blk=takri}', "");
    Expect(1, 71376, '\P{Blk=takri}', "");
    Expect(0, 71376, '\P{^Blk=takri}', "");
    Expect(1, 71375, '\p{Blk=:\Atakri\z:}', "");;
    Expect(0, 71376, '\p{Blk=:\Atakri\z:}', "");;
    Expect(1, 71375, '\p{Blk=_-takri}', "");
    Expect(0, 71375, '\p{^Blk=_-takri}', "");
    Expect(0, 71375, '\P{Blk=_-takri}', "");
    Expect(1, 71375, '\P{^Blk=_-takri}', "");
    Expect(0, 71376, '\p{Blk=_-takri}', "");
    Expect(1, 71376, '\p{^Blk=_-takri}', "");
    Expect(1, 71376, '\P{Blk=_-takri}', "");
    Expect(0, 71376, '\P{^Blk=_-takri}', "");
    Error('\p{Is_Block=/a/ Takri}');
    Error('\P{Is_Block=/a/ Takri}');
    Expect(1, 71375, '\p{Is_Block=takri}', "");
    Expect(0, 71375, '\p{^Is_Block=takri}', "");
    Expect(0, 71375, '\P{Is_Block=takri}', "");
    Expect(1, 71375, '\P{^Is_Block=takri}', "");
    Expect(0, 71376, '\p{Is_Block=takri}', "");
    Expect(1, 71376, '\p{^Is_Block=takri}', "");
    Expect(1, 71376, '\P{Is_Block=takri}', "");
    Expect(0, 71376, '\P{^Is_Block=takri}', "");
    Expect(1, 71375, '\p{Is_Block= _takri}', "");
    Expect(0, 71375, '\p{^Is_Block= _takri}', "");
    Expect(0, 71375, '\P{Is_Block= _takri}', "");
    Expect(1, 71375, '\P{^Is_Block= _takri}', "");
    Expect(0, 71376, '\p{Is_Block= _takri}', "");
    Expect(1, 71376, '\p{^Is_Block= _takri}', "");
    Expect(1, 71376, '\P{Is_Block= _takri}', "");
    Expect(0, 71376, '\P{^Is_Block= _takri}', "");
    Error('\p{Is_Blk=-takri/a/}');
    Error('\P{Is_Blk=-takri/a/}');
    Expect(1, 71375, '\p{Is_Blk=takri}', "");
    Expect(0, 71375, '\p{^Is_Blk=takri}', "");
    Expect(0, 71375, '\P{Is_Blk=takri}', "");
    Expect(1, 71375, '\P{^Is_Blk=takri}', "");
    Expect(0, 71376, '\p{Is_Blk=takri}', "");
    Expect(1, 71376, '\p{^Is_Blk=takri}', "");
    Expect(1, 71376, '\P{Is_Blk=takri}', "");
    Expect(0, 71376, '\P{^Is_Blk=takri}', "");
    Expect(1, 71375, '\p{Is_Blk= 	Takri}', "");
    Expect(0, 71375, '\p{^Is_Blk= 	Takri}', "");
    Expect(0, 71375, '\P{Is_Blk= 	Takri}', "");
    Expect(1, 71375, '\P{^Is_Blk= 	Takri}', "");
    Expect(0, 71376, '\p{Is_Blk= 	Takri}', "");
    Expect(1, 71376, '\p{^Is_Blk= 	Takri}', "");
    Expect(1, 71376, '\P{Is_Blk= 	Takri}', "");
    Expect(0, 71376, '\P{^Is_Blk= 	Takri}', "");
    Error('\p{Block:_:=tamil}');
    Error('\P{Block:_:=tamil}');
    Expect(1, 3071, '\p{Block=:\ATamil\z:}', "");;
    Expect(0, 3072, '\p{Block=:\ATamil\z:}', "");;
    Expect(1, 3071, '\p{Block:	tamil}', "");
    Expect(0, 3071, '\p{^Block:	tamil}', "");
    Expect(0, 3071, '\P{Block:	tamil}', "");
    Expect(1, 3071, '\P{^Block:	tamil}', "");
    Expect(0, 3072, '\p{Block:	tamil}', "");
    Expect(1, 3072, '\p{^Block:	tamil}', "");
    Expect(1, 3072, '\P{Block:	tamil}', "");
    Expect(0, 3072, '\P{^Block:	tamil}', "");
    Expect(1, 3071, '\p{Block=:\Atamil\z:}', "");;
    Expect(0, 3072, '\p{Block=:\Atamil\z:}', "");;
    Expect(1, 3071, '\p{Block=	-Tamil}', "");
    Expect(0, 3071, '\p{^Block=	-Tamil}', "");
    Expect(0, 3071, '\P{Block=	-Tamil}', "");
    Expect(1, 3071, '\P{^Block=	-Tamil}', "");
    Expect(0, 3072, '\p{Block=	-Tamil}', "");
    Expect(1, 3072, '\p{^Block=	-Tamil}', "");
    Expect(1, 3072, '\P{Block=	-Tamil}', "");
    Expect(0, 3072, '\P{^Block=	-Tamil}', "");
    Error('\p{Blk=	/a/Tamil}');
    Error('\P{Blk=	/a/Tamil}');
    Expect(1, 3071, '\p{Blk=:\ATamil\z:}', "");;
    Expect(0, 3072, '\p{Blk=:\ATamil\z:}', "");;
    Expect(1, 3071, '\p{Blk=tamil}', "");
    Expect(0, 3071, '\p{^Blk=tamil}', "");
    Expect(0, 3071, '\P{Blk=tamil}', "");
    Expect(1, 3071, '\P{^Blk=tamil}', "");
    Expect(0, 3072, '\p{Blk=tamil}', "");
    Expect(1, 3072, '\p{^Blk=tamil}', "");
    Expect(1, 3072, '\P{Blk=tamil}', "");
    Expect(0, 3072, '\P{^Blk=tamil}', "");
    Expect(1, 3071, '\p{Blk=:\Atamil\z:}', "");;
    Expect(0, 3072, '\p{Blk=:\Atamil\z:}', "");;
    Expect(1, 3071, '\p{Blk=-	TAMIL}', "");
    Expect(0, 3071, '\p{^Blk=-	TAMIL}', "");
    Expect(0, 3071, '\P{Blk=-	TAMIL}', "");
    Expect(1, 3071, '\P{^Blk=-	TAMIL}', "");
    Expect(0, 3072, '\p{Blk=-	TAMIL}', "");
    Expect(1, 3072, '\p{^Blk=-	TAMIL}', "");
    Expect(1, 3072, '\P{Blk=-	TAMIL}', "");
    Expect(0, 3072, '\P{^Blk=-	TAMIL}', "");
    Error('\p{Is_Block=	 TAMIL:=}');
    Error('\P{Is_Block=	 TAMIL:=}');
    Expect(1, 3071, '\p{Is_Block=tamil}', "");
    Expect(0, 3071, '\p{^Is_Block=tamil}', "");
    Expect(0, 3071, '\P{Is_Block=tamil}', "");
    Expect(1, 3071, '\P{^Is_Block=tamil}', "");
    Expect(0, 3072, '\p{Is_Block=tamil}', "");
    Expect(1, 3072, '\p{^Is_Block=tamil}', "");
    Expect(1, 3072, '\P{Is_Block=tamil}', "");
    Expect(0, 3072, '\P{^Is_Block=tamil}', "");
    Expect(1, 3071, '\p{Is_Block=_	TAMIL}', "");
    Expect(0, 3071, '\p{^Is_Block=_	TAMIL}', "");
    Expect(0, 3071, '\P{Is_Block=_	TAMIL}', "");
    Expect(1, 3071, '\P{^Is_Block=_	TAMIL}', "");
    Expect(0, 3072, '\p{Is_Block=_	TAMIL}', "");
    Expect(1, 3072, '\p{^Is_Block=_	TAMIL}', "");
    Expect(1, 3072, '\P{Is_Block=_	TAMIL}', "");
    Expect(0, 3072, '\P{^Is_Block=_	TAMIL}', "");
    Error('\p{Is_Blk=:=TAMIL}');
    Error('\P{Is_Blk=:=TAMIL}');
    Expect(1, 3071, '\p{Is_Blk=tamil}', "");
    Expect(0, 3071, '\p{^Is_Blk=tamil}', "");
    Expect(0, 3071, '\P{Is_Blk=tamil}', "");
    Expect(1, 3071, '\P{^Is_Blk=tamil}', "");
    Expect(0, 3072, '\p{Is_Blk=tamil}', "");
    Expect(1, 3072, '\p{^Is_Blk=tamil}', "");
    Expect(1, 3072, '\P{Is_Blk=tamil}', "");
    Expect(0, 3072, '\P{^Is_Blk=tamil}', "");
    Expect(1, 3071, '\p{Is_Blk= 	tamil}', "");
    Expect(0, 3071, '\p{^Is_Blk= 	tamil}', "");
    Expect(0, 3071, '\P{Is_Blk= 	tamil}', "");
    Expect(1, 3071, '\P{^Is_Blk= 	tamil}', "");
    Expect(0, 3072, '\p{Is_Blk= 	tamil}', "");
    Expect(1, 3072, '\p{^Is_Blk= 	tamil}', "");
    Expect(1, 3072, '\P{Is_Blk= 	tamil}', "");
    Expect(0, 3072, '\P{^Is_Blk= 	tamil}', "");
    Error('\p{Block=:=Tamil_SUPPLEMENT}');
    Error('\P{Block=:=Tamil_SUPPLEMENT}');
    Expect(1, 73727, '\p{Block=:\ATamil_Supplement\z:}', "");;
    Expect(0, 73728, '\p{Block=:\ATamil_Supplement\z:}', "");;
    Expect(1, 73727, '\p{Block=tamilsupplement}', "");
    Expect(0, 73727, '\p{^Block=tamilsupplement}', "");
    Expect(0, 73727, '\P{Block=tamilsupplement}', "");
    Expect(1, 73727, '\P{^Block=tamilsupplement}', "");
    Expect(0, 73728, '\p{Block=tamilsupplement}', "");
    Expect(1, 73728, '\p{^Block=tamilsupplement}', "");
    Expect(1, 73728, '\P{Block=tamilsupplement}', "");
    Expect(0, 73728, '\P{^Block=tamilsupplement}', "");
    Expect(1, 73727, '\p{Block=:\Atamilsupplement\z:}', "");;
    Expect(0, 73728, '\p{Block=:\Atamilsupplement\z:}', "");;
    Expect(1, 73727, '\p{Block= -tamil_SUPPLEMENT}', "");
    Expect(0, 73727, '\p{^Block= -tamil_SUPPLEMENT}', "");
    Expect(0, 73727, '\P{Block= -tamil_SUPPLEMENT}', "");
    Expect(1, 73727, '\P{^Block= -tamil_SUPPLEMENT}', "");
    Expect(0, 73728, '\p{Block= -tamil_SUPPLEMENT}', "");
    Expect(1, 73728, '\p{^Block= -tamil_SUPPLEMENT}', "");
    Expect(1, 73728, '\P{Block= -tamil_SUPPLEMENT}', "");
    Expect(0, 73728, '\P{^Block= -tamil_SUPPLEMENT}', "");
    Error('\p{Blk=_/a/Tamil_sup}');
    Error('\P{Blk=_/a/Tamil_sup}');
    Expect(1, 73727, '\p{Blk=:\ATamil_Sup\z:}', "");;
    Expect(0, 73728, '\p{Blk=:\ATamil_Sup\z:}', "");;
    Expect(1, 73727, '\p{Blk=tamilsup}', "");
    Expect(0, 73727, '\p{^Blk=tamilsup}', "");
    Expect(0, 73727, '\P{Blk=tamilsup}', "");
    Expect(1, 73727, '\P{^Blk=tamilsup}', "");
    Expect(0, 73728, '\p{Blk=tamilsup}', "");
    Expect(1, 73728, '\p{^Blk=tamilsup}', "");
    Expect(1, 73728, '\P{Blk=tamilsup}', "");
    Expect(0, 73728, '\P{^Blk=tamilsup}', "");
    Expect(1, 73727, '\p{Blk=:\Atamilsup\z:}', "");;
    Expect(0, 73728, '\p{Blk=:\Atamilsup\z:}', "");;
    Expect(1, 73727, '\p{Blk=- Tamil_SUP}', "");
    Expect(0, 73727, '\p{^Blk=- Tamil_SUP}', "");
    Expect(0, 73727, '\P{Blk=- Tamil_SUP}', "");
    Expect(1, 73727, '\P{^Blk=- Tamil_SUP}', "");
    Expect(0, 73728, '\p{Blk=- Tamil_SUP}', "");
    Expect(1, 73728, '\p{^Blk=- Tamil_SUP}', "");
    Expect(1, 73728, '\P{Blk=- Tamil_SUP}', "");
    Expect(0, 73728, '\P{^Blk=- Tamil_SUP}', "");
    Error('\p{Is_Block=Tamil_SUPPLEMENT:=}');
    Error('\P{Is_Block=Tamil_SUPPLEMENT:=}');
    Expect(1, 73727, '\p{Is_Block=tamilsupplement}', "");
    Expect(0, 73727, '\p{^Is_Block=tamilsupplement}', "");
    Expect(0, 73727, '\P{Is_Block=tamilsupplement}', "");
    Expect(1, 73727, '\P{^Is_Block=tamilsupplement}', "");
    Expect(0, 73728, '\p{Is_Block=tamilsupplement}', "");
    Expect(1, 73728, '\p{^Is_Block=tamilsupplement}', "");
    Expect(1, 73728, '\P{Is_Block=tamilsupplement}', "");
    Expect(0, 73728, '\P{^Is_Block=tamilsupplement}', "");
    Expect(1, 73727, '\p{Is_Block=-	Tamil_SUPPLEMENT}', "");
    Expect(0, 73727, '\p{^Is_Block=-	Tamil_SUPPLEMENT}', "");
    Expect(0, 73727, '\P{Is_Block=-	Tamil_SUPPLEMENT}', "");
    Expect(1, 73727, '\P{^Is_Block=-	Tamil_SUPPLEMENT}', "");
    Expect(0, 73728, '\p{Is_Block=-	Tamil_SUPPLEMENT}', "");
    Expect(1, 73728, '\p{^Is_Block=-	Tamil_SUPPLEMENT}', "");
    Expect(1, 73728, '\P{Is_Block=-	Tamil_SUPPLEMENT}', "");
    Expect(0, 73728, '\P{^Is_Block=-	Tamil_SUPPLEMENT}', "");
    Error('\p{Is_Blk=	Tamil_SUP:=}');
    Error('\P{Is_Blk=	Tamil_SUP:=}');
    Expect(1, 73727, '\p{Is_Blk=tamilsup}', "");
    Expect(0, 73727, '\p{^Is_Blk=tamilsup}', "");
    Expect(0, 73727, '\P{Is_Blk=tamilsup}', "");
    Expect(1, 73727, '\P{^Is_Blk=tamilsup}', "");
    Expect(0, 73728, '\p{Is_Blk=tamilsup}', "");
    Expect(1, 73728, '\p{^Is_Blk=tamilsup}', "");
    Expect(1, 73728, '\P{Is_Blk=tamilsup}', "");
    Expect(0, 73728, '\P{^Is_Blk=tamilsup}', "");
    Expect(1, 73727, '\p{Is_Blk=- Tamil_Sup}', "");
    Expect(0, 73727, '\p{^Is_Blk=- Tamil_Sup}', "");
    Expect(0, 73727, '\P{Is_Blk=- Tamil_Sup}', "");
    Expect(1, 73727, '\P{^Is_Blk=- Tamil_Sup}', "");
    Expect(0, 73728, '\p{Is_Blk=- Tamil_Sup}', "");
    Expect(1, 73728, '\p{^Is_Blk=- Tamil_Sup}', "");
    Expect(1, 73728, '\P{Is_Blk=- Tamil_Sup}', "");
    Expect(0, 73728, '\P{^Is_Blk=- Tamil_Sup}', "");
    Error('\p{Block:-TANGUT/a/}');
    Error('\P{Block:-TANGUT/a/}');
    Expect(1, 100351, '\p{Block=:\ATangut\z:}', "");;
    Expect(0, 100352, '\p{Block=:\ATangut\z:}', "");;
    Expect(1, 100351, '\p{Block=tangut}', "");
    Expect(0, 100351, '\p{^Block=tangut}', "");
    Expect(0, 100351, '\P{Block=tangut}', "");
    Expect(1, 100351, '\P{^Block=tangut}', "");
    Expect(0, 100352, '\p{Block=tangut}', "");
    Expect(1, 100352, '\p{^Block=tangut}', "");
    Expect(1, 100352, '\P{Block=tangut}', "");
    Expect(0, 100352, '\P{^Block=tangut}', "");
    Expect(1, 100351, '\p{Block=:\Atangut\z:}', "");;
    Expect(0, 100352, '\p{Block=:\Atangut\z:}', "");;
    Expect(1, 100351, '\p{Block=	tangut}', "");
    Expect(0, 100351, '\p{^Block=	tangut}', "");
    Expect(0, 100351, '\P{Block=	tangut}', "");
    Expect(1, 100351, '\P{^Block=	tangut}', "");
    Expect(0, 100352, '\p{Block=	tangut}', "");
    Expect(1, 100352, '\p{^Block=	tangut}', "");
    Expect(1, 100352, '\P{Block=	tangut}', "");
    Expect(0, 100352, '\P{^Block=	tangut}', "");
    Error('\p{Blk=	:=TANGUT}');
    Error('\P{Blk=	:=TANGUT}');
    Expect(1, 100351, '\p{Blk=:\ATangut\z:}', "");;
    Expect(0, 100352, '\p{Blk=:\ATangut\z:}', "");;
    Expect(1, 100351, '\p{Blk=tangut}', "");
    Expect(0, 100351, '\p{^Blk=tangut}', "");
    Expect(0, 100351, '\P{Blk=tangut}', "");
    Expect(1, 100351, '\P{^Blk=tangut}', "");
    Expect(0, 100352, '\p{Blk=tangut}', "");
    Expect(1, 100352, '\p{^Blk=tangut}', "");
    Expect(1, 100352, '\P{Blk=tangut}', "");
    Expect(0, 100352, '\P{^Blk=tangut}', "");
    Expect(1, 100351, '\p{Blk=:\Atangut\z:}', "");;
    Expect(0, 100352, '\p{Blk=:\Atangut\z:}', "");;
    Expect(1, 100351, '\p{Blk=_-Tangut}', "");
    Expect(0, 100351, '\p{^Blk=_-Tangut}', "");
    Expect(0, 100351, '\P{Blk=_-Tangut}', "");
    Expect(1, 100351, '\P{^Blk=_-Tangut}', "");
    Expect(0, 100352, '\p{Blk=_-Tangut}', "");
    Expect(1, 100352, '\p{^Blk=_-Tangut}', "");
    Expect(1, 100352, '\P{Blk=_-Tangut}', "");
    Expect(0, 100352, '\P{^Blk=_-Tangut}', "");
    Error('\p{Is_Block=:=-Tangut}');
    Error('\P{Is_Block=:=-Tangut}');
    Expect(1, 100351, '\p{Is_Block=tangut}', "");
    Expect(0, 100351, '\p{^Is_Block=tangut}', "");
    Expect(0, 100351, '\P{Is_Block=tangut}', "");
    Expect(1, 100351, '\P{^Is_Block=tangut}', "");
    Expect(0, 100352, '\p{Is_Block=tangut}', "");
    Expect(1, 100352, '\p{^Is_Block=tangut}', "");
    Expect(1, 100352, '\P{Is_Block=tangut}', "");
    Expect(0, 100352, '\P{^Is_Block=tangut}', "");
    Expect(1, 100351, '\p{Is_Block= 	TANGUT}', "");
    Expect(0, 100351, '\p{^Is_Block= 	TANGUT}', "");
    Expect(0, 100351, '\P{Is_Block= 	TANGUT}', "");
    Expect(1, 100351, '\P{^Is_Block= 	TANGUT}', "");
    Expect(0, 100352, '\p{Is_Block= 	TANGUT}', "");
    Expect(1, 100352, '\p{^Is_Block= 	TANGUT}', "");
    Expect(1, 100352, '\P{Is_Block= 	TANGUT}', "");
    Expect(0, 100352, '\P{^Is_Block= 	TANGUT}', "");
    Error('\p{Is_Blk= _Tangut:=}');
    Error('\P{Is_Blk= _Tangut:=}');
    Expect(1, 100351, '\p{Is_Blk=tangut}', "");
    Expect(0, 100351, '\p{^Is_Blk=tangut}', "");
    Expect(0, 100351, '\P{Is_Blk=tangut}', "");
    Expect(1, 100351, '\P{^Is_Blk=tangut}', "");
    Expect(0, 100352, '\p{Is_Blk=tangut}', "");
    Expect(1, 100352, '\p{^Is_Blk=tangut}', "");
    Expect(1, 100352, '\P{Is_Blk=tangut}', "");
    Expect(0, 100352, '\P{^Is_Blk=tangut}', "");
    Expect(1, 100351, '\p{Is_Blk=--TANGUT}', "");
    Expect(0, 100351, '\p{^Is_Blk=--TANGUT}', "");
    Expect(0, 100351, '\P{Is_Blk=--TANGUT}', "");
    Expect(1, 100351, '\P{^Is_Blk=--TANGUT}', "");
    Expect(0, 100352, '\p{Is_Blk=--TANGUT}', "");
    Expect(1, 100352, '\p{^Is_Blk=--TANGUT}', "");
    Expect(1, 100352, '\P{Is_Blk=--TANGUT}', "");
    Expect(0, 100352, '\P{^Is_Blk=--TANGUT}', "");
    Error('\p{Block=/a/ _tangut_COMPONENTS}');
    Error('\P{Block=/a/ _tangut_COMPONENTS}');
    Expect(1, 101119, '\p{Block=:\ATangut_Components\z:}', "");;
    Expect(0, 101120, '\p{Block=:\ATangut_Components\z:}', "");;
    Expect(1, 101119, '\p{Block=tangutcomponents}', "");
    Expect(0, 101119, '\p{^Block=tangutcomponents}', "");
    Expect(0, 101119, '\P{Block=tangutcomponents}', "");
    Expect(1, 101119, '\P{^Block=tangutcomponents}', "");
    Expect(0, 101120, '\p{Block=tangutcomponents}', "");
    Expect(1, 101120, '\p{^Block=tangutcomponents}', "");
    Expect(1, 101120, '\P{Block=tangutcomponents}', "");
    Expect(0, 101120, '\P{^Block=tangutcomponents}', "");
    Expect(1, 101119, '\p{Block=:\Atangutcomponents\z:}', "");;
    Expect(0, 101120, '\p{Block=:\Atangutcomponents\z:}', "");;
    Expect(1, 101119, '\p{Block= _Tangut_COMPONENTS}', "");
    Expect(0, 101119, '\p{^Block= _Tangut_COMPONENTS}', "");
    Expect(0, 101119, '\P{Block= _Tangut_COMPONENTS}', "");
    Expect(1, 101119, '\P{^Block= _Tangut_COMPONENTS}', "");
    Expect(0, 101120, '\p{Block= _Tangut_COMPONENTS}', "");
    Expect(1, 101120, '\p{^Block= _Tangut_COMPONENTS}', "");
    Expect(1, 101120, '\P{Block= _Tangut_COMPONENTS}', "");
    Expect(0, 101120, '\P{^Block= _Tangut_COMPONENTS}', "");
    Error('\p{Blk= /a/TANGUT_Components}');
    Error('\P{Blk= /a/TANGUT_Components}');
    Expect(1, 101119, '\p{Blk=:\ATangut_Components\z:}', "");;
    Expect(0, 101120, '\p{Blk=:\ATangut_Components\z:}', "");;
    Expect(1, 101119, '\p{Blk=tangutcomponents}', "");
    Expect(0, 101119, '\p{^Blk=tangutcomponents}', "");
    Expect(0, 101119, '\P{Blk=tangutcomponents}', "");
    Expect(1, 101119, '\P{^Blk=tangutcomponents}', "");
    Expect(0, 101120, '\p{Blk=tangutcomponents}', "");
    Expect(1, 101120, '\p{^Blk=tangutcomponents}', "");
    Expect(1, 101120, '\P{Blk=tangutcomponents}', "");
    Expect(0, 101120, '\P{^Blk=tangutcomponents}', "");
    Expect(1, 101119, '\p{Blk=:\Atangutcomponents\z:}', "");;
    Expect(0, 101120, '\p{Blk=:\Atangutcomponents\z:}', "");;
    Expect(1, 101119, '\p{Blk=	TANGUT_Components}', "");
    Expect(0, 101119, '\p{^Blk=	TANGUT_Components}', "");
    Expect(0, 101119, '\P{Blk=	TANGUT_Components}', "");
    Expect(1, 101119, '\P{^Blk=	TANGUT_Components}', "");
    Expect(0, 101120, '\p{Blk=	TANGUT_Components}', "");
    Expect(1, 101120, '\p{^Blk=	TANGUT_Components}', "");
    Expect(1, 101120, '\P{Blk=	TANGUT_Components}', "");
    Expect(0, 101120, '\P{^Blk=	TANGUT_Components}', "");
    Error('\p{Is_Block=--TANGUT_Components/a/}');
    Error('\P{Is_Block=--TANGUT_Components/a/}');
    Expect(1, 101119, '\p{Is_Block=tangutcomponents}', "");
    Expect(0, 101119, '\p{^Is_Block=tangutcomponents}', "");
    Expect(0, 101119, '\P{Is_Block=tangutcomponents}', "");
    Expect(1, 101119, '\P{^Is_Block=tangutcomponents}', "");
    Expect(0, 101120, '\p{Is_Block=tangutcomponents}', "");
    Expect(1, 101120, '\p{^Is_Block=tangutcomponents}', "");
    Expect(1, 101120, '\P{Is_Block=tangutcomponents}', "");
    Expect(0, 101120, '\P{^Is_Block=tangutcomponents}', "");
    Expect(1, 101119, '\p{Is_Block=__Tangut_components}', "");
    Expect(0, 101119, '\p{^Is_Block=__Tangut_components}', "");
    Expect(0, 101119, '\P{Is_Block=__Tangut_components}', "");
    Expect(1, 101119, '\P{^Is_Block=__Tangut_components}', "");
    Expect(0, 101120, '\p{Is_Block=__Tangut_components}', "");
    Expect(1, 101120, '\p{^Is_Block=__Tangut_components}', "");
    Expect(1, 101120, '\P{Is_Block=__Tangut_components}', "");
    Expect(0, 101120, '\P{^Is_Block=__Tangut_components}', "");
    Error('\p{Is_Blk=-tangut_components:=}');
    Error('\P{Is_Blk=-tangut_components:=}');
    Expect(1, 101119, '\p{Is_Blk=tangutcomponents}', "");
    Expect(0, 101119, '\p{^Is_Blk=tangutcomponents}', "");
    Expect(0, 101119, '\P{Is_Blk=tangutcomponents}', "");
    Expect(1, 101119, '\P{^Is_Blk=tangutcomponents}', "");
    Expect(0, 101120, '\p{Is_Blk=tangutcomponents}', "");
    Expect(1, 101120, '\p{^Is_Blk=tangutcomponents}', "");
    Expect(1, 101120, '\P{Is_Blk=tangutcomponents}', "");
    Expect(0, 101120, '\P{^Is_Blk=tangutcomponents}', "");
    Expect(1, 101119, '\p{Is_Blk=tangut_COMPONENTS}', "");
    Expect(0, 101119, '\p{^Is_Blk=tangut_COMPONENTS}', "");
    Expect(0, 101119, '\P{Is_Blk=tangut_COMPONENTS}', "");
    Expect(1, 101119, '\P{^Is_Blk=tangut_COMPONENTS}', "");
    Expect(0, 101120, '\p{Is_Blk=tangut_COMPONENTS}', "");
    Expect(1, 101120, '\p{^Is_Blk=tangut_COMPONENTS}', "");
    Expect(1, 101120, '\P{Is_Blk=tangut_COMPONENTS}', "");
    Expect(0, 101120, '\P{^Is_Blk=tangut_COMPONENTS}', "");
    Error('\p{Block=/a/-_Tangut_Supplement}');
    Error('\P{Block=/a/-_Tangut_Supplement}');
    Expect(1, 101775, '\p{Block=:\ATangut_Supplement\z:}', "");;
    Expect(0, 101776, '\p{Block=:\ATangut_Supplement\z:}', "");;
    Expect(1, 101775, '\p{Block=tangutsupplement}', "");
    Expect(0, 101775, '\p{^Block=tangutsupplement}', "");
    Expect(0, 101775, '\P{Block=tangutsupplement}', "");
    Expect(1, 101775, '\P{^Block=tangutsupplement}', "");
    Expect(0, 101776, '\p{Block=tangutsupplement}', "");
    Expect(1, 101776, '\p{^Block=tangutsupplement}', "");
    Expect(1, 101776, '\P{Block=tangutsupplement}', "");
    Expect(0, 101776, '\P{^Block=tangutsupplement}', "");
    Expect(1, 101775, '\p{Block=:\Atangutsupplement\z:}', "");;
    Expect(0, 101776, '\p{Block=:\Atangutsupplement\z:}', "");;
    Expect(1, 101775, '\p{Block= _tangut_SUPPLEMENT}', "");
    Expect(0, 101775, '\p{^Block= _tangut_SUPPLEMENT}', "");
    Expect(0, 101775, '\P{Block= _tangut_SUPPLEMENT}', "");
    Expect(1, 101775, '\P{^Block= _tangut_SUPPLEMENT}', "");
    Expect(0, 101776, '\p{Block= _tangut_SUPPLEMENT}', "");
    Expect(1, 101776, '\p{^Block= _tangut_SUPPLEMENT}', "");
    Expect(1, 101776, '\P{Block= _tangut_SUPPLEMENT}', "");
    Expect(0, 101776, '\P{^Block= _tangut_SUPPLEMENT}', "");
    Error('\p{Blk=/a/__Tangut_Sup}');
    Error('\P{Blk=/a/__Tangut_Sup}');
    Expect(1, 101775, '\p{Blk=:\ATangut_Sup\z:}', "");;
    Expect(0, 101776, '\p{Blk=:\ATangut_Sup\z:}', "");;
    Expect(1, 101775, '\p{Blk=tangutsup}', "");
    Expect(0, 101775, '\p{^Blk=tangutsup}', "");
    Expect(0, 101775, '\P{Blk=tangutsup}', "");
    Expect(1, 101775, '\P{^Blk=tangutsup}', "");
    Expect(0, 101776, '\p{Blk=tangutsup}', "");
    Expect(1, 101776, '\p{^Blk=tangutsup}', "");
    Expect(1, 101776, '\P{Blk=tangutsup}', "");
    Expect(0, 101776, '\P{^Blk=tangutsup}', "");
    Expect(1, 101775, '\p{Blk=:\Atangutsup\z:}', "");;
    Expect(0, 101776, '\p{Blk=:\Atangutsup\z:}', "");;
    Expect(1, 101775, '\p{Blk= -Tangut_sup}', "");
    Expect(0, 101775, '\p{^Blk= -Tangut_sup}', "");
    Expect(0, 101775, '\P{Blk= -Tangut_sup}', "");
    Expect(1, 101775, '\P{^Blk= -Tangut_sup}', "");
    Expect(0, 101776, '\p{Blk= -Tangut_sup}', "");
    Expect(1, 101776, '\p{^Blk= -Tangut_sup}', "");
    Expect(1, 101776, '\P{Blk= -Tangut_sup}', "");
    Expect(0, 101776, '\P{^Blk= -Tangut_sup}', "");
    Error('\p{Is_Block:_-TANGUT_supplement/a/}');
    Error('\P{Is_Block:_-TANGUT_supplement/a/}');
    Expect(1, 101775, '\p{Is_Block=tangutsupplement}', "");
    Expect(0, 101775, '\p{^Is_Block=tangutsupplement}', "");
    Expect(0, 101775, '\P{Is_Block=tangutsupplement}', "");
    Expect(1, 101775, '\P{^Is_Block=tangutsupplement}', "");
    Expect(0, 101776, '\p{Is_Block=tangutsupplement}', "");
    Expect(1, 101776, '\p{^Is_Block=tangutsupplement}', "");
    Expect(1, 101776, '\P{Is_Block=tangutsupplement}', "");
    Expect(0, 101776, '\P{^Is_Block=tangutsupplement}', "");
    Expect(1, 101775, '\p{Is_Block=__TANGUT_Supplement}', "");
    Expect(0, 101775, '\p{^Is_Block=__TANGUT_Supplement}', "");
    Expect(0, 101775, '\P{Is_Block=__TANGUT_Supplement}', "");
    Expect(1, 101775, '\P{^Is_Block=__TANGUT_Supplement}', "");
    Expect(0, 101776, '\p{Is_Block=__TANGUT_Supplement}', "");
    Expect(1, 101776, '\p{^Is_Block=__TANGUT_Supplement}', "");
    Expect(1, 101776, '\P{Is_Block=__TANGUT_Supplement}', "");
    Expect(0, 101776, '\P{^Is_Block=__TANGUT_Supplement}', "");
    Error('\p{Is_Blk= 	Tangut_Sup/a/}');
    Error('\P{Is_Blk= 	Tangut_Sup/a/}');
    Expect(1, 101775, '\p{Is_Blk=tangutsup}', "");
    Expect(0, 101775, '\p{^Is_Blk=tangutsup}', "");
    Expect(0, 101775, '\P{Is_Blk=tangutsup}', "");
    Expect(1, 101775, '\P{^Is_Blk=tangutsup}', "");
    Expect(0, 101776, '\p{Is_Blk=tangutsup}', "");
    Expect(1, 101776, '\p{^Is_Blk=tangutsup}', "");
    Expect(1, 101776, '\P{Is_Blk=tangutsup}', "");
    Expect(0, 101776, '\P{^Is_Blk=tangutsup}', "");
    Expect(1, 101775, '\p{Is_Blk=	-tangut_sup}', "");
    Expect(0, 101775, '\p{^Is_Blk=	-tangut_sup}', "");
    Expect(0, 101775, '\P{Is_Blk=	-tangut_sup}', "");
    Expect(1, 101775, '\P{^Is_Blk=	-tangut_sup}', "");
    Expect(0, 101776, '\p{Is_Blk=	-tangut_sup}', "");
    Expect(1, 101776, '\p{^Is_Blk=	-tangut_sup}', "");
    Expect(1, 101776, '\P{Is_Blk=	-tangut_sup}', "");
    Expect(0, 101776, '\P{^Is_Blk=	-tangut_sup}', "");
    Error('\p{Block=  TELUGU:=}');
    Error('\P{Block=  TELUGU:=}');
    Expect(1, 3199, '\p{Block=:\ATelugu\z:}', "");;
    Expect(0, 3200, '\p{Block=:\ATelugu\z:}', "");;
    Expect(1, 3199, '\p{Block=telugu}', "");
    Expect(0, 3199, '\p{^Block=telugu}', "");
    Expect(0, 3199, '\P{Block=telugu}', "");
    Expect(1, 3199, '\P{^Block=telugu}', "");
    Expect(0, 3200, '\p{Block=telugu}', "");
    Expect(1, 3200, '\p{^Block=telugu}', "");
    Expect(1, 3200, '\P{Block=telugu}', "");
    Expect(0, 3200, '\P{^Block=telugu}', "");
    Expect(1, 3199, '\p{Block=:\Atelugu\z:}', "");;
    Expect(0, 3200, '\p{Block=:\Atelugu\z:}', "");;
    Expect(1, 3199, '\p{Block=_	Telugu}', "");
    Expect(0, 3199, '\p{^Block=_	Telugu}', "");
    Expect(0, 3199, '\P{Block=_	Telugu}', "");
    Expect(1, 3199, '\P{^Block=_	Telugu}', "");
    Expect(0, 3200, '\p{Block=_	Telugu}', "");
    Expect(1, 3200, '\p{^Block=_	Telugu}', "");
    Expect(1, 3200, '\P{Block=_	Telugu}', "");
    Expect(0, 3200, '\P{^Block=_	Telugu}', "");
    Error('\p{Blk=_-Telugu/a/}');
    Error('\P{Blk=_-Telugu/a/}');
    Expect(1, 3199, '\p{Blk=:\ATelugu\z:}', "");;
    Expect(0, 3200, '\p{Blk=:\ATelugu\z:}', "");;
    Expect(1, 3199, '\p{Blk=telugu}', "");
    Expect(0, 3199, '\p{^Blk=telugu}', "");
    Expect(0, 3199, '\P{Blk=telugu}', "");
    Expect(1, 3199, '\P{^Blk=telugu}', "");
    Expect(0, 3200, '\p{Blk=telugu}', "");
    Expect(1, 3200, '\p{^Blk=telugu}', "");
    Expect(1, 3200, '\P{Blk=telugu}', "");
    Expect(0, 3200, '\P{^Blk=telugu}', "");
    Expect(1, 3199, '\p{Blk=:\Atelugu\z:}', "");;
    Expect(0, 3200, '\p{Blk=:\Atelugu\z:}', "");;
    Expect(1, 3199, '\p{Blk=	Telugu}', "");
    Expect(0, 3199, '\p{^Blk=	Telugu}', "");
    Expect(0, 3199, '\P{Blk=	Telugu}', "");
    Expect(1, 3199, '\P{^Blk=	Telugu}', "");
    Expect(0, 3200, '\p{Blk=	Telugu}', "");
    Expect(1, 3200, '\p{^Blk=	Telugu}', "");
    Expect(1, 3200, '\P{Blk=	Telugu}', "");
    Expect(0, 3200, '\P{^Blk=	Telugu}', "");
    Error('\p{Is_Block= /a/TELUGU}');
    Error('\P{Is_Block= /a/TELUGU}');
    Expect(1, 3199, '\p{Is_Block=telugu}', "");
    Expect(0, 3199, '\p{^Is_Block=telugu}', "");
    Expect(0, 3199, '\P{Is_Block=telugu}', "");
    Expect(1, 3199, '\P{^Is_Block=telugu}', "");
    Expect(0, 3200, '\p{Is_Block=telugu}', "");
    Expect(1, 3200, '\p{^Is_Block=telugu}', "");
    Expect(1, 3200, '\P{Is_Block=telugu}', "");
    Expect(0, 3200, '\P{^Is_Block=telugu}', "");
    Expect(1, 3199, '\p{Is_Block= Telugu}', "");
    Expect(0, 3199, '\p{^Is_Block= Telugu}', "");
    Expect(0, 3199, '\P{Is_Block= Telugu}', "");
    Expect(1, 3199, '\P{^Is_Block= Telugu}', "");
    Expect(0, 3200, '\p{Is_Block= Telugu}', "");
    Expect(1, 3200, '\p{^Is_Block= Telugu}', "");
    Expect(1, 3200, '\P{Is_Block= Telugu}', "");
    Expect(0, 3200, '\P{^Is_Block= Telugu}', "");
    Error('\p{Is_Blk= Telugu/a/}');
    Error('\P{Is_Blk= Telugu/a/}');
    Expect(1, 3199, '\p{Is_Blk=telugu}', "");
    Expect(0, 3199, '\p{^Is_Blk=telugu}', "");
    Expect(0, 3199, '\P{Is_Blk=telugu}', "");
    Expect(1, 3199, '\P{^Is_Blk=telugu}', "");
    Expect(0, 3200, '\p{Is_Blk=telugu}', "");
    Expect(1, 3200, '\p{^Is_Blk=telugu}', "");
    Expect(1, 3200, '\P{Is_Blk=telugu}', "");
    Expect(0, 3200, '\P{^Is_Blk=telugu}', "");
    Expect(1, 3199, '\p{Is_Blk=_-Telugu}', "");
    Expect(0, 3199, '\p{^Is_Blk=_-Telugu}', "");
    Expect(0, 3199, '\P{Is_Blk=_-Telugu}', "");
    Expect(1, 3199, '\P{^Is_Blk=_-Telugu}', "");
    Expect(0, 3200, '\p{Is_Blk=_-Telugu}', "");
    Expect(1, 3200, '\p{^Is_Blk=_-Telugu}', "");
    Expect(1, 3200, '\P{Is_Blk=_-Telugu}', "");
    Expect(0, 3200, '\P{^Is_Blk=_-Telugu}', "");
    Error('\p{Block=		thaana:=}');
    Error('\P{Block=		thaana:=}');
    Expect(1, 1983, '\p{Block=:\AThaana\z:}', "");;
    Expect(0, 1984, '\p{Block=:\AThaana\z:}', "");;
    Expect(1, 1983, '\p{Block=thaana}', "");
    Expect(0, 1983, '\p{^Block=thaana}', "");
    Expect(0, 1983, '\P{Block=thaana}', "");
    Expect(1, 1983, '\P{^Block=thaana}', "");
    Expect(0, 1984, '\p{Block=thaana}', "");
    Expect(1, 1984, '\p{^Block=thaana}', "");
    Expect(1, 1984, '\P{Block=thaana}', "");
    Expect(0, 1984, '\P{^Block=thaana}', "");
    Expect(1, 1983, '\p{Block=:\Athaana\z:}', "");;
    Expect(0, 1984, '\p{Block=:\Athaana\z:}', "");;
    Expect(1, 1983, '\p{Block=-	Thaana}', "");
    Expect(0, 1983, '\p{^Block=-	Thaana}', "");
    Expect(0, 1983, '\P{Block=-	Thaana}', "");
    Expect(1, 1983, '\P{^Block=-	Thaana}', "");
    Expect(0, 1984, '\p{Block=-	Thaana}', "");
    Expect(1, 1984, '\p{^Block=-	Thaana}', "");
    Expect(1, 1984, '\P{Block=-	Thaana}', "");
    Expect(0, 1984, '\P{^Block=-	Thaana}', "");
    Error('\p{Blk=:=--Thaana}');
    Error('\P{Blk=:=--Thaana}');
    Expect(1, 1983, '\p{Blk=:\AThaana\z:}', "");;
    Expect(0, 1984, '\p{Blk=:\AThaana\z:}', "");;
    Expect(1, 1983, '\p{Blk=thaana}', "");
    Expect(0, 1983, '\p{^Blk=thaana}', "");
    Expect(0, 1983, '\P{Blk=thaana}', "");
    Expect(1, 1983, '\P{^Blk=thaana}', "");
    Expect(0, 1984, '\p{Blk=thaana}', "");
    Expect(1, 1984, '\p{^Blk=thaana}', "");
    Expect(1, 1984, '\P{Blk=thaana}', "");
    Expect(0, 1984, '\P{^Blk=thaana}', "");
    Expect(1, 1983, '\p{Blk=:\Athaana\z:}', "");;
    Expect(0, 1984, '\p{Blk=:\Athaana\z:}', "");;
    Expect(1, 1983, '\p{Blk=--Thaana}', "");
    Expect(0, 1983, '\p{^Blk=--Thaana}', "");
    Expect(0, 1983, '\P{Blk=--Thaana}', "");
    Expect(1, 1983, '\P{^Blk=--Thaana}', "");
    Expect(0, 1984, '\p{Blk=--Thaana}', "");
    Expect(1, 1984, '\p{^Blk=--Thaana}', "");
    Expect(1, 1984, '\P{Blk=--Thaana}', "");
    Expect(0, 1984, '\P{^Blk=--Thaana}', "");
    Error('\p{Is_Block=_thaana:=}');
    Error('\P{Is_Block=_thaana:=}');
    Expect(1, 1983, '\p{Is_Block=thaana}', "");
    Expect(0, 1983, '\p{^Is_Block=thaana}', "");
    Expect(0, 1983, '\P{Is_Block=thaana}', "");
    Expect(1, 1983, '\P{^Is_Block=thaana}', "");
    Expect(0, 1984, '\p{Is_Block=thaana}', "");
    Expect(1, 1984, '\p{^Is_Block=thaana}', "");
    Expect(1, 1984, '\P{Is_Block=thaana}', "");
    Expect(0, 1984, '\P{^Is_Block=thaana}', "");
    Expect(1, 1983, '\p{Is_Block=__Thaana}', "");
    Expect(0, 1983, '\p{^Is_Block=__Thaana}', "");
    Expect(0, 1983, '\P{Is_Block=__Thaana}', "");
    Expect(1, 1983, '\P{^Is_Block=__Thaana}', "");
    Expect(0, 1984, '\p{Is_Block=__Thaana}', "");
    Expect(1, 1984, '\p{^Is_Block=__Thaana}', "");
    Expect(1, 1984, '\P{Is_Block=__Thaana}', "");
    Expect(0, 1984, '\P{^Is_Block=__Thaana}', "");
    Error('\p{Is_Blk=/a/--thaana}');
    Error('\P{Is_Blk=/a/--thaana}');
    Expect(1, 1983, '\p{Is_Blk=thaana}', "");
    Expect(0, 1983, '\p{^Is_Blk=thaana}', "");
    Expect(0, 1983, '\P{Is_Blk=thaana}', "");
    Expect(1, 1983, '\P{^Is_Blk=thaana}', "");
    Expect(0, 1984, '\p{Is_Blk=thaana}', "");
    Expect(1, 1984, '\p{^Is_Blk=thaana}', "");
    Expect(1, 1984, '\P{Is_Blk=thaana}', "");
    Expect(0, 1984, '\P{^Is_Blk=thaana}', "");
    Expect(1, 1983, '\p{Is_Blk:  THAANA}', "");
    Expect(0, 1983, '\p{^Is_Blk:  THAANA}', "");
    Expect(0, 1983, '\P{Is_Blk:  THAANA}', "");
    Expect(1, 1983, '\P{^Is_Blk:  THAANA}', "");
    Expect(0, 1984, '\p{Is_Blk:  THAANA}', "");
    Expect(1, 1984, '\p{^Is_Blk:  THAANA}', "");
    Expect(1, 1984, '\P{Is_Blk:  THAANA}', "");
    Expect(0, 1984, '\P{^Is_Blk:  THAANA}', "");
    Error('\p{Block=:=	-Thai}');
    Error('\P{Block=:=	-Thai}');
    Expect(1, 3711, '\p{Block=:\AThai\z:}', "");;
    Expect(0, 3712, '\p{Block=:\AThai\z:}', "");;
    Expect(1, 3711, '\p{Block=thai}', "");
    Expect(0, 3711, '\p{^Block=thai}', "");
    Expect(0, 3711, '\P{Block=thai}', "");
    Expect(1, 3711, '\P{^Block=thai}', "");
    Expect(0, 3712, '\p{Block=thai}', "");
    Expect(1, 3712, '\p{^Block=thai}', "");
    Expect(1, 3712, '\P{Block=thai}', "");
    Expect(0, 3712, '\P{^Block=thai}', "");
    Expect(1, 3711, '\p{Block=:\Athai\z:}', "");;
    Expect(0, 3712, '\p{Block=:\Athai\z:}', "");;
    Expect(1, 3711, '\p{Block=_ Thai}', "");
    Expect(0, 3711, '\p{^Block=_ Thai}', "");
    Expect(0, 3711, '\P{Block=_ Thai}', "");
    Expect(1, 3711, '\P{^Block=_ Thai}', "");
    Expect(0, 3712, '\p{Block=_ Thai}', "");
    Expect(1, 3712, '\p{^Block=_ Thai}', "");
    Expect(1, 3712, '\P{Block=_ Thai}', "");
    Expect(0, 3712, '\P{^Block=_ Thai}', "");
    Error('\p{Blk=:=_	THAI}');
    Error('\P{Blk=:=_	THAI}');
    Expect(1, 3711, '\p{Blk=:\AThai\z:}', "");;
    Expect(0, 3712, '\p{Blk=:\AThai\z:}', "");;
    Expect(1, 3711, '\p{Blk=thai}', "");
    Expect(0, 3711, '\p{^Blk=thai}', "");
    Expect(0, 3711, '\P{Blk=thai}', "");
    Expect(1, 3711, '\P{^Blk=thai}', "");
    Expect(0, 3712, '\p{Blk=thai}', "");
    Expect(1, 3712, '\p{^Blk=thai}', "");
    Expect(1, 3712, '\P{Blk=thai}', "");
    Expect(0, 3712, '\P{^Blk=thai}', "");
    Expect(1, 3711, '\p{Blk=:\Athai\z:}', "");;
    Expect(0, 3712, '\p{Blk=:\Athai\z:}', "");;
    Expect(1, 3711, '\p{Blk= -thai}', "");
    Expect(0, 3711, '\p{^Blk= -thai}', "");
    Expect(0, 3711, '\P{Blk= -thai}', "");
    Expect(1, 3711, '\P{^Blk= -thai}', "");
    Expect(0, 3712, '\p{Blk= -thai}', "");
    Expect(1, 3712, '\p{^Blk= -thai}', "");
    Expect(1, 3712, '\P{Blk= -thai}', "");
    Expect(0, 3712, '\P{^Blk= -thai}', "");
    Error('\p{Is_Block=_	Thai/a/}');
    Error('\P{Is_Block=_	Thai/a/}');
    Expect(1, 3711, '\p{Is_Block=thai}', "");
    Expect(0, 3711, '\p{^Is_Block=thai}', "");
    Expect(0, 3711, '\P{Is_Block=thai}', "");
    Expect(1, 3711, '\P{^Is_Block=thai}', "");
    Expect(0, 3712, '\p{Is_Block=thai}', "");
    Expect(1, 3712, '\p{^Is_Block=thai}', "");
    Expect(1, 3712, '\P{Is_Block=thai}', "");
    Expect(0, 3712, '\P{^Is_Block=thai}', "");
    Expect(1, 3711, '\p{Is_Block=-Thai}', "");
    Expect(0, 3711, '\p{^Is_Block=-Thai}', "");
    Expect(0, 3711, '\P{Is_Block=-Thai}', "");
    Expect(1, 3711, '\P{^Is_Block=-Thai}', "");
    Expect(0, 3712, '\p{Is_Block=-Thai}', "");
    Expect(1, 3712, '\p{^Is_Block=-Thai}', "");
    Expect(1, 3712, '\P{Is_Block=-Thai}', "");
    Expect(0, 3712, '\P{^Is_Block=-Thai}', "");
    Error('\p{Is_Blk= /a/Thai}');
    Error('\P{Is_Blk= /a/Thai}');
    Expect(1, 3711, '\p{Is_Blk=thai}', "");
    Expect(0, 3711, '\p{^Is_Blk=thai}', "");
    Expect(0, 3711, '\P{Is_Blk=thai}', "");
    Expect(1, 3711, '\P{^Is_Blk=thai}', "");
    Expect(0, 3712, '\p{Is_Blk=thai}', "");
    Expect(1, 3712, '\p{^Is_Blk=thai}', "");
    Expect(1, 3712, '\P{Is_Blk=thai}', "");
    Expect(0, 3712, '\P{^Is_Blk=thai}', "");
    Expect(1, 3711, '\p{Is_Blk:   -_Thai}', "");
    Expect(0, 3711, '\p{^Is_Blk:   -_Thai}', "");
    Expect(0, 3711, '\P{Is_Blk:   -_Thai}', "");
    Expect(1, 3711, '\P{^Is_Blk:   -_Thai}', "");
    Expect(0, 3712, '\p{Is_Blk:   -_Thai}', "");
    Expect(1, 3712, '\p{^Is_Blk:   -_Thai}', "");
    Expect(1, 3712, '\P{Is_Blk:   -_Thai}', "");
    Expect(0, 3712, '\P{^Is_Blk:   -_Thai}', "");
    Error('\p{Block=	 Tibetan/a/}');
    Error('\P{Block=	 Tibetan/a/}');
    Expect(1, 4095, '\p{Block=:\ATibetan\z:}', "");;
    Expect(0, 4096, '\p{Block=:\ATibetan\z:}', "");;
    Expect(1, 4095, '\p{Block:	tibetan}', "");
    Expect(0, 4095, '\p{^Block:	tibetan}', "");
    Expect(0, 4095, '\P{Block:	tibetan}', "");
    Expect(1, 4095, '\P{^Block:	tibetan}', "");
    Expect(0, 4096, '\p{Block:	tibetan}', "");
    Expect(1, 4096, '\p{^Block:	tibetan}', "");
    Expect(1, 4096, '\P{Block:	tibetan}', "");
    Expect(0, 4096, '\P{^Block:	tibetan}', "");
    Expect(1, 4095, '\p{Block=:\Atibetan\z:}', "");;
    Expect(0, 4096, '\p{Block=:\Atibetan\z:}', "");;
    Expect(1, 4095, '\p{Block=_	tibetan}', "");
    Expect(0, 4095, '\p{^Block=_	tibetan}', "");
    Expect(0, 4095, '\P{Block=_	tibetan}', "");
    Expect(1, 4095, '\P{^Block=_	tibetan}', "");
    Expect(0, 4096, '\p{Block=_	tibetan}', "");
    Expect(1, 4096, '\p{^Block=_	tibetan}', "");
    Expect(1, 4096, '\P{Block=_	tibetan}', "");
    Expect(0, 4096, '\P{^Block=_	tibetan}', "");
    Error('\p{Blk=  Tibetan/a/}');
    Error('\P{Blk=  Tibetan/a/}');
    Expect(1, 4095, '\p{Blk=:\ATibetan\z:}', "");;
    Expect(0, 4096, '\p{Blk=:\ATibetan\z:}', "");;
    Expect(1, 4095, '\p{Blk=tibetan}', "");
    Expect(0, 4095, '\p{^Blk=tibetan}', "");
    Expect(0, 4095, '\P{Blk=tibetan}', "");
    Expect(1, 4095, '\P{^Blk=tibetan}', "");
    Expect(0, 4096, '\p{Blk=tibetan}', "");
    Expect(1, 4096, '\p{^Blk=tibetan}', "");
    Expect(1, 4096, '\P{Blk=tibetan}', "");
    Expect(0, 4096, '\P{^Blk=tibetan}', "");
    Expect(1, 4095, '\p{Blk=:\Atibetan\z:}', "");;
    Expect(0, 4096, '\p{Blk=:\Atibetan\z:}', "");;
    Expect(1, 4095, '\p{Blk=	-Tibetan}', "");
    Expect(0, 4095, '\p{^Blk=	-Tibetan}', "");
    Expect(0, 4095, '\P{Blk=	-Tibetan}', "");
    Expect(1, 4095, '\P{^Blk=	-Tibetan}', "");
    Expect(0, 4096, '\p{Blk=	-Tibetan}', "");
    Expect(1, 4096, '\p{^Blk=	-Tibetan}', "");
    Expect(1, 4096, '\P{Blk=	-Tibetan}', "");
    Expect(0, 4096, '\P{^Blk=	-Tibetan}', "");
    Error('\p{Is_Block:   -/a/Tibetan}');
    Error('\P{Is_Block:   -/a/Tibetan}');
    Expect(1, 4095, '\p{Is_Block=tibetan}', "");
    Expect(0, 4095, '\p{^Is_Block=tibetan}', "");
    Expect(0, 4095, '\P{Is_Block=tibetan}', "");
    Expect(1, 4095, '\P{^Is_Block=tibetan}', "");
    Expect(0, 4096, '\p{Is_Block=tibetan}', "");
    Expect(1, 4096, '\p{^Is_Block=tibetan}', "");
    Expect(1, 4096, '\P{Is_Block=tibetan}', "");
    Expect(0, 4096, '\P{^Is_Block=tibetan}', "");
    Expect(1, 4095, '\p{Is_Block=	-tibetan}', "");
    Expect(0, 4095, '\p{^Is_Block=	-tibetan}', "");
    Expect(0, 4095, '\P{Is_Block=	-tibetan}', "");
    Expect(1, 4095, '\P{^Is_Block=	-tibetan}', "");
    Expect(0, 4096, '\p{Is_Block=	-tibetan}', "");
    Expect(1, 4096, '\p{^Is_Block=	-tibetan}', "");
    Expect(1, 4096, '\P{Is_Block=	-tibetan}', "");
    Expect(0, 4096, '\P{^Is_Block=	-tibetan}', "");
    Error('\p{Is_Blk=	Tibetan:=}');
    Error('\P{Is_Blk=	Tibetan:=}');
    Expect(1, 4095, '\p{Is_Blk=tibetan}', "");
    Expect(0, 4095, '\p{^Is_Blk=tibetan}', "");
    Expect(0, 4095, '\P{Is_Blk=tibetan}', "");
    Expect(1, 4095, '\P{^Is_Blk=tibetan}', "");
    Expect(0, 4096, '\p{Is_Blk=tibetan}', "");
    Expect(1, 4096, '\p{^Is_Blk=tibetan}', "");
    Expect(1, 4096, '\P{Is_Blk=tibetan}', "");
    Expect(0, 4096, '\P{^Is_Blk=tibetan}', "");
    Expect(1, 4095, '\p{Is_Blk=_Tibetan}', "");
    Expect(0, 4095, '\p{^Is_Blk=_Tibetan}', "");
    Expect(0, 4095, '\P{Is_Blk=_Tibetan}', "");
    Expect(1, 4095, '\P{^Is_Blk=_Tibetan}', "");
    Expect(0, 4096, '\p{Is_Blk=_Tibetan}', "");
    Expect(1, 4096, '\p{^Is_Blk=_Tibetan}', "");
    Expect(1, 4096, '\P{Is_Blk=_Tibetan}', "");
    Expect(0, 4096, '\P{^Is_Blk=_Tibetan}', "");
    Error('\p{Block=:=Tifinagh}');
    Error('\P{Block=:=Tifinagh}');
    Expect(1, 11647, '\p{Block=:\ATifinagh\z:}', "");;
    Expect(0, 11648, '\p{Block=:\ATifinagh\z:}', "");;
    Expect(1, 11647, '\p{Block:	tifinagh}', "");
    Expect(0, 11647, '\p{^Block:	tifinagh}', "");
    Expect(0, 11647, '\P{Block:	tifinagh}', "");
    Expect(1, 11647, '\P{^Block:	tifinagh}', "");
    Expect(0, 11648, '\p{Block:	tifinagh}', "");
    Expect(1, 11648, '\p{^Block:	tifinagh}', "");
    Expect(1, 11648, '\P{Block:	tifinagh}', "");
    Expect(0, 11648, '\P{^Block:	tifinagh}', "");
    Expect(1, 11647, '\p{Block=:\Atifinagh\z:}', "");;
    Expect(0, 11648, '\p{Block=:\Atifinagh\z:}', "");;
    Expect(1, 11647, '\p{Block= -Tifinagh}', "");
    Expect(0, 11647, '\p{^Block= -Tifinagh}', "");
    Expect(0, 11647, '\P{Block= -Tifinagh}', "");
    Expect(1, 11647, '\P{^Block= -Tifinagh}', "");
    Expect(0, 11648, '\p{Block= -Tifinagh}', "");
    Expect(1, 11648, '\p{^Block= -Tifinagh}', "");
    Expect(1, 11648, '\P{Block= -Tifinagh}', "");
    Expect(0, 11648, '\P{^Block= -Tifinagh}', "");
    Error('\p{Blk=/a/Tifinagh}');
    Error('\P{Blk=/a/Tifinagh}');
    Expect(1, 11647, '\p{Blk=:\ATifinagh\z:}', "");;
    Expect(0, 11648, '\p{Blk=:\ATifinagh\z:}', "");;
    Expect(1, 11647, '\p{Blk=tifinagh}', "");
    Expect(0, 11647, '\p{^Blk=tifinagh}', "");
    Expect(0, 11647, '\P{Blk=tifinagh}', "");
    Expect(1, 11647, '\P{^Blk=tifinagh}', "");
    Expect(0, 11648, '\p{Blk=tifinagh}', "");
    Expect(1, 11648, '\p{^Blk=tifinagh}', "");
    Expect(1, 11648, '\P{Blk=tifinagh}', "");
    Expect(0, 11648, '\P{^Blk=tifinagh}', "");
    Expect(1, 11647, '\p{Blk=:\Atifinagh\z:}', "");;
    Expect(0, 11648, '\p{Blk=:\Atifinagh\z:}', "");;
    Expect(1, 11647, '\p{Blk=		tifinagh}', "");
    Expect(0, 11647, '\p{^Blk=		tifinagh}', "");
    Expect(0, 11647, '\P{Blk=		tifinagh}', "");
    Expect(1, 11647, '\P{^Blk=		tifinagh}', "");
    Expect(0, 11648, '\p{Blk=		tifinagh}', "");
    Expect(1, 11648, '\p{^Blk=		tifinagh}', "");
    Expect(1, 11648, '\P{Blk=		tifinagh}', "");
    Expect(0, 11648, '\P{^Blk=		tifinagh}', "");
    Error('\p{Is_Block:/a/	_tifinagh}');
    Error('\P{Is_Block:/a/	_tifinagh}');
    Expect(1, 11647, '\p{Is_Block=tifinagh}', "");
    Expect(0, 11647, '\p{^Is_Block=tifinagh}', "");
    Expect(0, 11647, '\P{Is_Block=tifinagh}', "");
    Expect(1, 11647, '\P{^Is_Block=tifinagh}', "");
    Expect(0, 11648, '\p{Is_Block=tifinagh}', "");
    Expect(1, 11648, '\p{^Is_Block=tifinagh}', "");
    Expect(1, 11648, '\P{Is_Block=tifinagh}', "");
    Expect(0, 11648, '\P{^Is_Block=tifinagh}', "");
    Expect(1, 11647, '\p{Is_Block=		Tifinagh}', "");
    Expect(0, 11647, '\p{^Is_Block=		Tifinagh}', "");
    Expect(0, 11647, '\P{Is_Block=		Tifinagh}', "");
    Expect(1, 11647, '\P{^Is_Block=		Tifinagh}', "");
    Expect(0, 11648, '\p{Is_Block=		Tifinagh}', "");
    Expect(1, 11648, '\p{^Is_Block=		Tifinagh}', "");
    Expect(1, 11648, '\P{Is_Block=		Tifinagh}', "");
    Expect(0, 11648, '\P{^Is_Block=		Tifinagh}', "");
    Error('\p{Is_Blk=:=- tifinagh}');
    Error('\P{Is_Blk=:=- tifinagh}');
    Expect(1, 11647, '\p{Is_Blk:	tifinagh}', "");
    Expect(0, 11647, '\p{^Is_Blk:	tifinagh}', "");
    Expect(0, 11647, '\P{Is_Blk:	tifinagh}', "");
    Expect(1, 11647, '\P{^Is_Blk:	tifinagh}', "");
    Expect(0, 11648, '\p{Is_Blk:	tifinagh}', "");
    Expect(1, 11648, '\p{^Is_Blk:	tifinagh}', "");
    Expect(1, 11648, '\P{Is_Blk:	tifinagh}', "");
    Expect(0, 11648, '\P{^Is_Blk:	tifinagh}', "");
    Expect(1, 11647, '\p{Is_Blk=	_Tifinagh}', "");
    Expect(0, 11647, '\p{^Is_Blk=	_Tifinagh}', "");
    Expect(0, 11647, '\P{Is_Blk=	_Tifinagh}', "");
    Expect(1, 11647, '\P{^Is_Blk=	_Tifinagh}', "");
    Expect(0, 11648, '\p{Is_Blk=	_Tifinagh}', "");
    Expect(1, 11648, '\p{^Is_Blk=	_Tifinagh}', "");
    Expect(1, 11648, '\P{Is_Blk=	_Tifinagh}', "");
    Expect(0, 11648, '\P{^Is_Blk=	_Tifinagh}', "");
    Error('\p{Block=_:=Tirhuta}');
    Error('\P{Block=_:=Tirhuta}');
    Expect(1, 70879, '\p{Block=:\ATirhuta\z:}', "");;
    Expect(0, 70880, '\p{Block=:\ATirhuta\z:}', "");;
    Expect(1, 70879, '\p{Block=tirhuta}', "");
    Expect(0, 70879, '\p{^Block=tirhuta}', "");
    Expect(0, 70879, '\P{Block=tirhuta}', "");
    Expect(1, 70879, '\P{^Block=tirhuta}', "");
    Expect(0, 70880, '\p{Block=tirhuta}', "");
    Expect(1, 70880, '\p{^Block=tirhuta}', "");
    Expect(1, 70880, '\P{Block=tirhuta}', "");
    Expect(0, 70880, '\P{^Block=tirhuta}', "");
    Expect(1, 70879, '\p{Block=:\Atirhuta\z:}', "");;
    Expect(0, 70880, '\p{Block=:\Atirhuta\z:}', "");;
    Expect(1, 70879, '\p{Block:     Tirhuta}', "");
    Expect(0, 70879, '\p{^Block:     Tirhuta}', "");
    Expect(0, 70879, '\P{Block:     Tirhuta}', "");
    Expect(1, 70879, '\P{^Block:     Tirhuta}', "");
    Expect(0, 70880, '\p{Block:     Tirhuta}', "");
    Expect(1, 70880, '\p{^Block:     Tirhuta}', "");
    Expect(1, 70880, '\P{Block:     Tirhuta}', "");
    Expect(0, 70880, '\P{^Block:     Tirhuta}', "");
    Error('\p{Blk:   /a/_TIRHUTA}');
    Error('\P{Blk:   /a/_TIRHUTA}');
    Expect(1, 70879, '\p{Blk=:\ATirhuta\z:}', "");;
    Expect(0, 70880, '\p{Blk=:\ATirhuta\z:}', "");;
    Expect(1, 70879, '\p{Blk=tirhuta}', "");
    Expect(0, 70879, '\p{^Blk=tirhuta}', "");
    Expect(0, 70879, '\P{Blk=tirhuta}', "");
    Expect(1, 70879, '\P{^Blk=tirhuta}', "");
    Expect(0, 70880, '\p{Blk=tirhuta}', "");
    Expect(1, 70880, '\p{^Blk=tirhuta}', "");
    Expect(1, 70880, '\P{Blk=tirhuta}', "");
    Expect(0, 70880, '\P{^Blk=tirhuta}', "");
    Expect(1, 70879, '\p{Blk=:\Atirhuta\z:}', "");;
    Expect(0, 70880, '\p{Blk=:\Atirhuta\z:}', "");;
    Expect(1, 70879, '\p{Blk: - tirhuta}', "");
    Expect(0, 70879, '\p{^Blk: - tirhuta}', "");
    Expect(0, 70879, '\P{Blk: - tirhuta}', "");
    Expect(1, 70879, '\P{^Blk: - tirhuta}', "");
    Expect(0, 70880, '\p{Blk: - tirhuta}', "");
    Expect(1, 70880, '\p{^Blk: - tirhuta}', "");
    Expect(1, 70880, '\P{Blk: - tirhuta}', "");
    Expect(0, 70880, '\P{^Blk: - tirhuta}', "");
    Error('\p{Is_Block=/a/		tirhuta}');
    Error('\P{Is_Block=/a/		tirhuta}');
    Expect(1, 70879, '\p{Is_Block=tirhuta}', "");
    Expect(0, 70879, '\p{^Is_Block=tirhuta}', "");
    Expect(0, 70879, '\P{Is_Block=tirhuta}', "");
    Expect(1, 70879, '\P{^Is_Block=tirhuta}', "");
    Expect(0, 70880, '\p{Is_Block=tirhuta}', "");
    Expect(1, 70880, '\p{^Is_Block=tirhuta}', "");
    Expect(1, 70880, '\P{Is_Block=tirhuta}', "");
    Expect(0, 70880, '\P{^Is_Block=tirhuta}', "");
    Expect(1, 70879, '\p{Is_Block=-_TIRHUTA}', "");
    Expect(0, 70879, '\p{^Is_Block=-_TIRHUTA}', "");
    Expect(0, 70879, '\P{Is_Block=-_TIRHUTA}', "");
    Expect(1, 70879, '\P{^Is_Block=-_TIRHUTA}', "");
    Expect(0, 70880, '\p{Is_Block=-_TIRHUTA}', "");
    Expect(1, 70880, '\p{^Is_Block=-_TIRHUTA}', "");
    Expect(1, 70880, '\P{Is_Block=-_TIRHUTA}', "");
    Expect(0, 70880, '\P{^Is_Block=-_TIRHUTA}', "");
    Error('\p{Is_Blk:  _Tirhuta:=}');
    Error('\P{Is_Blk:  _Tirhuta:=}');
    Expect(1, 70879, '\p{Is_Blk=tirhuta}', "");
    Expect(0, 70879, '\p{^Is_Blk=tirhuta}', "");
    Expect(0, 70879, '\P{Is_Blk=tirhuta}', "");
    Expect(1, 70879, '\P{^Is_Blk=tirhuta}', "");
    Expect(0, 70880, '\p{Is_Blk=tirhuta}', "");
    Expect(1, 70880, '\p{^Is_Blk=tirhuta}', "");
    Expect(1, 70880, '\P{Is_Blk=tirhuta}', "");
    Expect(0, 70880, '\P{^Is_Blk=tirhuta}', "");
    Expect(1, 70879, '\p{Is_Blk= 	Tirhuta}', "");
    Expect(0, 70879, '\p{^Is_Blk= 	Tirhuta}', "");
    Expect(0, 70879, '\P{Is_Blk= 	Tirhuta}', "");
    Expect(1, 70879, '\P{^Is_Blk= 	Tirhuta}', "");
    Expect(0, 70880, '\p{Is_Blk= 	Tirhuta}', "");
    Expect(1, 70880, '\p{^Is_Blk= 	Tirhuta}', "");
    Expect(1, 70880, '\P{Is_Blk= 	Tirhuta}', "");
    Expect(0, 70880, '\P{^Is_Blk= 	Tirhuta}', "");
    Error('\p{Block=	:=Transport_and_Map_SYMBOLS}');
    Error('\P{Block=	:=Transport_and_Map_SYMBOLS}');
    Expect(1, 128767, '\p{Block=:\ATransport_And_Map_Symbols\z:}', "");;
    Expect(0, 128768, '\p{Block=:\ATransport_And_Map_Symbols\z:}', "");;
    Expect(1, 128767, '\p{Block=transportandmapsymbols}', "");
    Expect(0, 128767, '\p{^Block=transportandmapsymbols}', "");
    Expect(0, 128767, '\P{Block=transportandmapsymbols}', "");
    Expect(1, 128767, '\P{^Block=transportandmapsymbols}', "");
    Expect(0, 128768, '\p{Block=transportandmapsymbols}', "");
    Expect(1, 128768, '\p{^Block=transportandmapsymbols}', "");
    Expect(1, 128768, '\P{Block=transportandmapsymbols}', "");
    Expect(0, 128768, '\P{^Block=transportandmapsymbols}', "");
    Expect(1, 128767, '\p{Block=:\Atransportandmapsymbols\z:}', "");;
    Expect(0, 128768, '\p{Block=:\Atransportandmapsymbols\z:}', "");;
    Expect(1, 128767, '\p{Block=	 transport_And_map_SYMBOLS}', "");
    Expect(0, 128767, '\p{^Block=	 transport_And_map_SYMBOLS}', "");
    Expect(0, 128767, '\P{Block=	 transport_And_map_SYMBOLS}', "");
    Expect(1, 128767, '\P{^Block=	 transport_And_map_SYMBOLS}', "");
    Expect(0, 128768, '\p{Block=	 transport_And_map_SYMBOLS}', "");
    Expect(1, 128768, '\p{^Block=	 transport_And_map_SYMBOLS}', "");
    Expect(1, 128768, '\P{Block=	 transport_And_map_SYMBOLS}', "");
    Expect(0, 128768, '\P{^Block=	 transport_And_map_SYMBOLS}', "");
    Error('\p{Blk= -TRANSPORT_And_MAP/a/}');
    Error('\P{Blk= -TRANSPORT_And_MAP/a/}');
    Expect(1, 128767, '\p{Blk=:\ATransport_And_Map\z:}', "");;
    Expect(0, 128768, '\p{Blk=:\ATransport_And_Map\z:}', "");;
    Expect(1, 128767, '\p{Blk=transportandmap}', "");
    Expect(0, 128767, '\p{^Blk=transportandmap}', "");
    Expect(0, 128767, '\P{Blk=transportandmap}', "");
    Expect(1, 128767, '\P{^Blk=transportandmap}', "");
    Expect(0, 128768, '\p{Blk=transportandmap}', "");
    Expect(1, 128768, '\p{^Blk=transportandmap}', "");
    Expect(1, 128768, '\P{Blk=transportandmap}', "");
    Expect(0, 128768, '\P{^Blk=transportandmap}', "");
    Expect(1, 128767, '\p{Blk=:\Atransportandmap\z:}', "");;
    Expect(0, 128768, '\p{Blk=:\Atransportandmap\z:}', "");;
    Expect(1, 128767, '\p{Blk= -TRANSPORT_AND_MAP}', "");
    Expect(0, 128767, '\p{^Blk= -TRANSPORT_AND_MAP}', "");
    Expect(0, 128767, '\P{Blk= -TRANSPORT_AND_MAP}', "");
    Expect(1, 128767, '\P{^Blk= -TRANSPORT_AND_MAP}', "");
    Expect(0, 128768, '\p{Blk= -TRANSPORT_AND_MAP}', "");
    Expect(1, 128768, '\p{^Blk= -TRANSPORT_AND_MAP}', "");
    Expect(1, 128768, '\P{Blk= -TRANSPORT_AND_MAP}', "");
    Expect(0, 128768, '\P{^Blk= -TRANSPORT_AND_MAP}', "");
    Error('\p{Is_Block=	/a/TRANSPORT_and_map_Symbols}');
    Error('\P{Is_Block=	/a/TRANSPORT_and_map_Symbols}');
    Expect(1, 128767, '\p{Is_Block=transportandmapsymbols}', "");
    Expect(0, 128767, '\p{^Is_Block=transportandmapsymbols}', "");
    Expect(0, 128767, '\P{Is_Block=transportandmapsymbols}', "");
    Expect(1, 128767, '\P{^Is_Block=transportandmapsymbols}', "");
    Expect(0, 128768, '\p{Is_Block=transportandmapsymbols}', "");
    Expect(1, 128768, '\p{^Is_Block=transportandmapsymbols}', "");
    Expect(1, 128768, '\P{Is_Block=transportandmapsymbols}', "");
    Expect(0, 128768, '\P{^Is_Block=transportandmapsymbols}', "");
    Expect(1, 128767, '\p{Is_Block=_ TRANSPORT_AND_map_symbols}', "");
    Expect(0, 128767, '\p{^Is_Block=_ TRANSPORT_AND_map_symbols}', "");
    Expect(0, 128767, '\P{Is_Block=_ TRANSPORT_AND_map_symbols}', "");
    Expect(1, 128767, '\P{^Is_Block=_ TRANSPORT_AND_map_symbols}', "");
    Expect(0, 128768, '\p{Is_Block=_ TRANSPORT_AND_map_symbols}', "");
    Expect(1, 128768, '\p{^Is_Block=_ TRANSPORT_AND_map_symbols}', "");
    Expect(1, 128768, '\P{Is_Block=_ TRANSPORT_AND_map_symbols}', "");
    Expect(0, 128768, '\P{^Is_Block=_ TRANSPORT_AND_map_symbols}', "");
    Error('\p{Is_Blk=	/a/TRANSPORT_And_map}');
    Error('\P{Is_Blk=	/a/TRANSPORT_And_map}');
    Expect(1, 128767, '\p{Is_Blk=transportandmap}', "");
    Expect(0, 128767, '\p{^Is_Blk=transportandmap}', "");
    Expect(0, 128767, '\P{Is_Blk=transportandmap}', "");
    Expect(1, 128767, '\P{^Is_Blk=transportandmap}', "");
    Expect(0, 128768, '\p{Is_Blk=transportandmap}', "");
    Expect(1, 128768, '\p{^Is_Blk=transportandmap}', "");
    Expect(1, 128768, '\P{Is_Blk=transportandmap}', "");
    Expect(0, 128768, '\P{^Is_Blk=transportandmap}', "");
    Expect(1, 128767, '\p{Is_Blk=-_Transport_And_Map}', "");
    Expect(0, 128767, '\p{^Is_Blk=-_Transport_And_Map}', "");
    Expect(0, 128767, '\P{Is_Blk=-_Transport_And_Map}', "");
    Expect(1, 128767, '\P{^Is_Blk=-_Transport_And_Map}', "");
    Expect(0, 128768, '\p{Is_Blk=-_Transport_And_Map}', "");
    Expect(1, 128768, '\p{^Is_Blk=-_Transport_And_Map}', "");
    Expect(1, 128768, '\P{Is_Blk=-_Transport_And_Map}', "");
    Expect(0, 128768, '\P{^Is_Blk=-_Transport_And_Map}', "");
    Error('\p{Block=/a/ Unified_canadian_ABORIGINAL_SYLLABICS}');
    Error('\P{Block=/a/ Unified_canadian_ABORIGINAL_SYLLABICS}');
    Expect(1, 5759, '\p{Block=:\AUnified_Canadian_Aboriginal_Syllabics\z:}', "");;
    Expect(0, 5760, '\p{Block=:\AUnified_Canadian_Aboriginal_Syllabics\z:}', "");;
    Expect(1, 5759, '\p{Block=unifiedcanadianaboriginalsyllabics}', "");
    Expect(0, 5759, '\p{^Block=unifiedcanadianaboriginalsyllabics}', "");
    Expect(0, 5759, '\P{Block=unifiedcanadianaboriginalsyllabics}', "");
    Expect(1, 5759, '\P{^Block=unifiedcanadianaboriginalsyllabics}', "");
    Expect(0, 5760, '\p{Block=unifiedcanadianaboriginalsyllabics}', "");
    Expect(1, 5760, '\p{^Block=unifiedcanadianaboriginalsyllabics}', "");
    Expect(1, 5760, '\P{Block=unifiedcanadianaboriginalsyllabics}', "");
    Expect(0, 5760, '\P{^Block=unifiedcanadianaboriginalsyllabics}', "");
    Expect(1, 5759, '\p{Block=:\Aunifiedcanadianaboriginalsyllabics\z:}', "");;
    Expect(0, 5760, '\p{Block=:\Aunifiedcanadianaboriginalsyllabics\z:}', "");;
    Expect(1, 5759, '\p{Block=	_Unified_Canadian_Aboriginal_SYLLABICS}', "");
    Expect(0, 5759, '\p{^Block=	_Unified_Canadian_Aboriginal_SYLLABICS}', "");
    Expect(0, 5759, '\P{Block=	_Unified_Canadian_Aboriginal_SYLLABICS}', "");
    Expect(1, 5759, '\P{^Block=	_Unified_Canadian_Aboriginal_SYLLABICS}', "");
    Expect(0, 5760, '\p{Block=	_Unified_Canadian_Aboriginal_SYLLABICS}', "");
    Expect(1, 5760, '\p{^Block=	_Unified_Canadian_Aboriginal_SYLLABICS}', "");
    Expect(1, 5760, '\P{Block=	_Unified_Canadian_Aboriginal_SYLLABICS}', "");
    Expect(0, 5760, '\P{^Block=	_Unified_Canadian_Aboriginal_SYLLABICS}', "");
    Error('\p{Blk=_:=ucas}');
    Error('\P{Blk=_:=ucas}');
    Expect(1, 5759, '\p{Blk=:\AUCAS\z:}', "");;
    Expect(0, 5760, '\p{Blk=:\AUCAS\z:}', "");;
    Expect(1, 5759, '\p{Blk=ucas}', "");
    Expect(0, 5759, '\p{^Blk=ucas}', "");
    Expect(0, 5759, '\P{Blk=ucas}', "");
    Expect(1, 5759, '\P{^Blk=ucas}', "");
    Expect(0, 5760, '\p{Blk=ucas}', "");
    Expect(1, 5760, '\p{^Blk=ucas}', "");
    Expect(1, 5760, '\P{Blk=ucas}', "");
    Expect(0, 5760, '\P{^Blk=ucas}', "");
    Expect(1, 5759, '\p{Blk=:\Aucas\z:}', "");;
    Expect(0, 5760, '\p{Blk=:\Aucas\z:}', "");;
    Expect(1, 5759, '\p{Blk=__UCAS}', "");
    Expect(0, 5759, '\p{^Blk=__UCAS}', "");
    Expect(0, 5759, '\P{Blk=__UCAS}', "");
    Expect(1, 5759, '\P{^Blk=__UCAS}', "");
    Expect(0, 5760, '\p{Blk=__UCAS}', "");
    Expect(1, 5760, '\p{^Blk=__UCAS}', "");
    Expect(1, 5760, '\P{Blk=__UCAS}', "");
    Expect(0, 5760, '\P{^Blk=__UCAS}', "");
    Error('\p{Is_Block=:=-_canadian_Syllabics}');
    Error('\P{Is_Block=:=-_canadian_Syllabics}');
    Expect(1, 5759, '\p{Is_Block: canadiansyllabics}', "");
    Expect(0, 5759, '\p{^Is_Block: canadiansyllabics}', "");
    Expect(0, 5759, '\P{Is_Block: canadiansyllabics}', "");
    Expect(1, 5759, '\P{^Is_Block: canadiansyllabics}', "");
    Expect(0, 5760, '\p{Is_Block: canadiansyllabics}', "");
    Expect(1, 5760, '\p{^Is_Block: canadiansyllabics}', "");
    Expect(1, 5760, '\P{Is_Block: canadiansyllabics}', "");
    Expect(0, 5760, '\P{^Is_Block: canadiansyllabics}', "");
    Expect(1, 5759, '\p{Is_Block=	canadian_syllabics}', "");
    Expect(0, 5759, '\p{^Is_Block=	canadian_syllabics}', "");
    Expect(0, 5759, '\P{Is_Block=	canadian_syllabics}', "");
    Expect(1, 5759, '\P{^Is_Block=	canadian_syllabics}', "");
    Expect(0, 5760, '\p{Is_Block=	canadian_syllabics}', "");
    Expect(1, 5760, '\p{^Is_Block=	canadian_syllabics}', "");
    Expect(1, 5760, '\P{Is_Block=	canadian_syllabics}', "");
    Expect(0, 5760, '\P{^Is_Block=	canadian_syllabics}', "");
    Error('\p{Is_Blk=/a/	_unified_Canadian_ABORIGINAL_SYLLABICS}');
    Error('\P{Is_Blk=/a/	_unified_Canadian_ABORIGINAL_SYLLABICS}');
    Expect(1, 5759, '\p{Is_Blk=unifiedcanadianaboriginalsyllabics}', "");
    Expect(0, 5759, '\p{^Is_Blk=unifiedcanadianaboriginalsyllabics}', "");
    Expect(0, 5759, '\P{Is_Blk=unifiedcanadianaboriginalsyllabics}', "");
    Expect(1, 5759, '\P{^Is_Blk=unifiedcanadianaboriginalsyllabics}', "");
    Expect(0, 5760, '\p{Is_Blk=unifiedcanadianaboriginalsyllabics}', "");
    Expect(1, 5760, '\p{^Is_Blk=unifiedcanadianaboriginalsyllabics}', "");
    Expect(1, 5760, '\P{Is_Blk=unifiedcanadianaboriginalsyllabics}', "");
    Expect(0, 5760, '\P{^Is_Blk=unifiedcanadianaboriginalsyllabics}', "");
    Expect(1, 5759, '\p{Is_Blk=	-UNIFIED_canadian_Aboriginal_SYLLABICS}', "");
    Expect(0, 5759, '\p{^Is_Blk=	-UNIFIED_canadian_Aboriginal_SYLLABICS}', "");
    Expect(0, 5759, '\P{Is_Blk=	-UNIFIED_canadian_Aboriginal_SYLLABICS}', "");
    Expect(1, 5759, '\P{^Is_Blk=	-UNIFIED_canadian_Aboriginal_SYLLABICS}', "");
    Expect(0, 5760, '\p{Is_Blk=	-UNIFIED_canadian_Aboriginal_SYLLABICS}', "");
    Expect(1, 5760, '\p{^Is_Blk=	-UNIFIED_canadian_Aboriginal_SYLLABICS}', "");
    Expect(1, 5760, '\P{Is_Blk=	-UNIFIED_canadian_Aboriginal_SYLLABICS}', "");
    Expect(0, 5760, '\P{^Is_Blk=	-UNIFIED_canadian_Aboriginal_SYLLABICS}', "");
    Error('\p{Block=_-UNIFIED_Canadian_Aboriginal_syllabics_EXTENDED/a/}');
    Error('\P{Block=_-UNIFIED_Canadian_Aboriginal_syllabics_EXTENDED/a/}');
    Expect(1, 6399, '\p{Block=:\AUnified_Canadian_Aboriginal_Syllabics_Extended\z:}', "");;
    Expect(0, 6400, '\p{Block=:\AUnified_Canadian_Aboriginal_Syllabics_Extended\z:}', "");;
    Expect(1, 6399, '\p{Block=unifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(0, 6399, '\p{^Block=unifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(0, 6399, '\P{Block=unifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(1, 6399, '\P{^Block=unifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(0, 6400, '\p{Block=unifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(1, 6400, '\p{^Block=unifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(1, 6400, '\P{Block=unifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(0, 6400, '\P{^Block=unifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(1, 6399, '\p{Block=:\Aunifiedcanadianaboriginalsyllabicsextended\z:}', "");;
    Expect(0, 6400, '\p{Block=:\Aunifiedcanadianaboriginalsyllabicsextended\z:}', "");;
    Expect(1, 6399, '\p{Block=- Unified_Canadian_ABORIGINAL_syllabics_extended}', "");
    Expect(0, 6399, '\p{^Block=- Unified_Canadian_ABORIGINAL_syllabics_extended}', "");
    Expect(0, 6399, '\P{Block=- Unified_Canadian_ABORIGINAL_syllabics_extended}', "");
    Expect(1, 6399, '\P{^Block=- Unified_Canadian_ABORIGINAL_syllabics_extended}', "");
    Expect(0, 6400, '\p{Block=- Unified_Canadian_ABORIGINAL_syllabics_extended}', "");
    Expect(1, 6400, '\p{^Block=- Unified_Canadian_ABORIGINAL_syllabics_extended}', "");
    Expect(1, 6400, '\P{Block=- Unified_Canadian_ABORIGINAL_syllabics_extended}', "");
    Expect(0, 6400, '\P{^Block=- Unified_Canadian_ABORIGINAL_syllabics_extended}', "");
    Error('\p{Blk= UCAS_Ext:=}');
    Error('\P{Blk= UCAS_Ext:=}');
    Expect(1, 6399, '\p{Blk=:\AUCAS_Ext\z:}', "");;
    Expect(0, 6400, '\p{Blk=:\AUCAS_Ext\z:}', "");;
    Expect(1, 6399, '\p{Blk=ucasext}', "");
    Expect(0, 6399, '\p{^Blk=ucasext}', "");
    Expect(0, 6399, '\P{Blk=ucasext}', "");
    Expect(1, 6399, '\P{^Blk=ucasext}', "");
    Expect(0, 6400, '\p{Blk=ucasext}', "");
    Expect(1, 6400, '\p{^Blk=ucasext}', "");
    Expect(1, 6400, '\P{Blk=ucasext}', "");
    Expect(0, 6400, '\P{^Blk=ucasext}', "");
    Expect(1, 6399, '\p{Blk=:\Aucasext\z:}', "");;
    Expect(0, 6400, '\p{Blk=:\Aucasext\z:}', "");;
    Expect(1, 6399, '\p{Blk:	_-ucas_ext}', "");
    Expect(0, 6399, '\p{^Blk:	_-ucas_ext}', "");
    Expect(0, 6399, '\P{Blk:	_-ucas_ext}', "");
    Expect(1, 6399, '\P{^Blk:	_-ucas_ext}', "");
    Expect(0, 6400, '\p{Blk:	_-ucas_ext}', "");
    Expect(1, 6400, '\p{^Blk:	_-ucas_ext}', "");
    Expect(1, 6400, '\P{Blk:	_-ucas_ext}', "");
    Expect(0, 6400, '\P{^Blk:	_-ucas_ext}', "");
    Error('\p{Is_Block= _UNIFIED_Canadian_Aboriginal_SYLLABICS_extended/a/}');
    Error('\P{Is_Block= _UNIFIED_Canadian_Aboriginal_SYLLABICS_extended/a/}');
    Expect(1, 6399, '\p{Is_Block: unifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(0, 6399, '\p{^Is_Block: unifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(0, 6399, '\P{Is_Block: unifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(1, 6399, '\P{^Is_Block: unifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(0, 6400, '\p{Is_Block: unifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(1, 6400, '\p{^Is_Block: unifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(1, 6400, '\P{Is_Block: unifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(0, 6400, '\P{^Is_Block: unifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(1, 6399, '\p{Is_Block= _UNIFIED_CANADIAN_Aboriginal_syllabics_extended}', "");
    Expect(0, 6399, '\p{^Is_Block= _UNIFIED_CANADIAN_Aboriginal_syllabics_extended}', "");
    Expect(0, 6399, '\P{Is_Block= _UNIFIED_CANADIAN_Aboriginal_syllabics_extended}', "");
    Expect(1, 6399, '\P{^Is_Block= _UNIFIED_CANADIAN_Aboriginal_syllabics_extended}', "");
    Expect(0, 6400, '\p{Is_Block= _UNIFIED_CANADIAN_Aboriginal_syllabics_extended}', "");
    Expect(1, 6400, '\p{^Is_Block= _UNIFIED_CANADIAN_Aboriginal_syllabics_extended}', "");
    Expect(1, 6400, '\P{Is_Block= _UNIFIED_CANADIAN_Aboriginal_syllabics_extended}', "");
    Expect(0, 6400, '\P{^Is_Block= _UNIFIED_CANADIAN_Aboriginal_syllabics_extended}', "");
    Error('\p{Is_Blk:	/a/UCAS_Ext}');
    Error('\P{Is_Blk:	/a/UCAS_Ext}');
    Expect(1, 6399, '\p{Is_Blk=ucasext}', "");
    Expect(0, 6399, '\p{^Is_Blk=ucasext}', "");
    Expect(0, 6399, '\P{Is_Blk=ucasext}', "");
    Expect(1, 6399, '\P{^Is_Blk=ucasext}', "");
    Expect(0, 6400, '\p{Is_Blk=ucasext}', "");
    Expect(1, 6400, '\p{^Is_Blk=ucasext}', "");
    Expect(1, 6400, '\P{Is_Blk=ucasext}', "");
    Expect(0, 6400, '\P{^Is_Blk=ucasext}', "");
    Expect(1, 6399, '\p{Is_Blk=		ucas_EXT}', "");
    Expect(0, 6399, '\p{^Is_Blk=		ucas_EXT}', "");
    Expect(0, 6399, '\P{Is_Blk=		ucas_EXT}', "");
    Expect(1, 6399, '\P{^Is_Blk=		ucas_EXT}', "");
    Expect(0, 6400, '\p{Is_Blk=		ucas_EXT}', "");
    Expect(1, 6400, '\p{^Is_Blk=		ucas_EXT}', "");
    Expect(1, 6400, '\P{Is_Blk=		ucas_EXT}', "");
    Expect(0, 6400, '\P{^Is_Blk=		ucas_EXT}', "");
    Error('\p{Block=--ugaritic/a/}');
    Error('\P{Block=--ugaritic/a/}');
    Expect(1, 66463, '\p{Block=:\AUgaritic\z:}', "");;
    Expect(0, 66464, '\p{Block=:\AUgaritic\z:}', "");;
    Expect(1, 66463, '\p{Block=ugaritic}', "");
    Expect(0, 66463, '\p{^Block=ugaritic}', "");
    Expect(0, 66463, '\P{Block=ugaritic}', "");
    Expect(1, 66463, '\P{^Block=ugaritic}', "");
    Expect(0, 66464, '\p{Block=ugaritic}', "");
    Expect(1, 66464, '\p{^Block=ugaritic}', "");
    Expect(1, 66464, '\P{Block=ugaritic}', "");
    Expect(0, 66464, '\P{^Block=ugaritic}', "");
    Expect(1, 66463, '\p{Block=:\Augaritic\z:}', "");;
    Expect(0, 66464, '\p{Block=:\Augaritic\z:}', "");;
    Expect(1, 66463, '\p{Block:  UGARITIC}', "");
    Expect(0, 66463, '\p{^Block:  UGARITIC}', "");
    Expect(0, 66463, '\P{Block:  UGARITIC}', "");
    Expect(1, 66463, '\P{^Block:  UGARITIC}', "");
    Expect(0, 66464, '\p{Block:  UGARITIC}', "");
    Expect(1, 66464, '\p{^Block:  UGARITIC}', "");
    Expect(1, 66464, '\P{Block:  UGARITIC}', "");
    Expect(0, 66464, '\P{^Block:  UGARITIC}', "");
    Error('\p{Blk: -:=ugaritic}');
    Error('\P{Blk: -:=ugaritic}');
    Expect(1, 66463, '\p{Blk=:\AUgaritic\z:}', "");;
    Expect(0, 66464, '\p{Blk=:\AUgaritic\z:}', "");;
    Expect(1, 66463, '\p{Blk:	ugaritic}', "");
    Expect(0, 66463, '\p{^Blk:	ugaritic}', "");
    Expect(0, 66463, '\P{Blk:	ugaritic}', "");
    Expect(1, 66463, '\P{^Blk:	ugaritic}', "");
    Expect(0, 66464, '\p{Blk:	ugaritic}', "");
    Expect(1, 66464, '\p{^Blk:	ugaritic}', "");
    Expect(1, 66464, '\P{Blk:	ugaritic}', "");
    Expect(0, 66464, '\P{^Blk:	ugaritic}', "");
    Expect(1, 66463, '\p{Blk=:\Augaritic\z:}', "");;
    Expect(0, 66464, '\p{Blk=:\Augaritic\z:}', "");;
    Expect(1, 66463, '\p{Blk:_Ugaritic}', "");
    Expect(0, 66463, '\p{^Blk:_Ugaritic}', "");
    Expect(0, 66463, '\P{Blk:_Ugaritic}', "");
    Expect(1, 66463, '\P{^Blk:_Ugaritic}', "");
    Expect(0, 66464, '\p{Blk:_Ugaritic}', "");
    Expect(1, 66464, '\p{^Blk:_Ugaritic}', "");
    Expect(1, 66464, '\P{Blk:_Ugaritic}', "");
    Expect(0, 66464, '\P{^Blk:_Ugaritic}', "");
    Error('\p{Is_Block=:=UGARITIC}');
    Error('\P{Is_Block=:=UGARITIC}');
    Expect(1, 66463, '\p{Is_Block=ugaritic}', "");
    Expect(0, 66463, '\p{^Is_Block=ugaritic}', "");
    Expect(0, 66463, '\P{Is_Block=ugaritic}', "");
    Expect(1, 66463, '\P{^Is_Block=ugaritic}', "");
    Expect(0, 66464, '\p{Is_Block=ugaritic}', "");
    Expect(1, 66464, '\p{^Is_Block=ugaritic}', "");
    Expect(1, 66464, '\P{Is_Block=ugaritic}', "");
    Expect(0, 66464, '\P{^Is_Block=ugaritic}', "");
    Expect(1, 66463, '\p{Is_Block=_ UGARITIC}', "");
    Expect(0, 66463, '\p{^Is_Block=_ UGARITIC}', "");
    Expect(0, 66463, '\P{Is_Block=_ UGARITIC}', "");
    Expect(1, 66463, '\P{^Is_Block=_ UGARITIC}', "");
    Expect(0, 66464, '\p{Is_Block=_ UGARITIC}', "");
    Expect(1, 66464, '\p{^Is_Block=_ UGARITIC}', "");
    Expect(1, 66464, '\P{Is_Block=_ UGARITIC}', "");
    Expect(0, 66464, '\P{^Is_Block=_ UGARITIC}', "");
    Error('\p{Is_Blk:   :=ugaritic}');
    Error('\P{Is_Blk:   :=ugaritic}');
    Expect(1, 66463, '\p{Is_Blk=ugaritic}', "");
    Expect(0, 66463, '\p{^Is_Blk=ugaritic}', "");
    Expect(0, 66463, '\P{Is_Blk=ugaritic}', "");
    Expect(1, 66463, '\P{^Is_Blk=ugaritic}', "");
    Expect(0, 66464, '\p{Is_Blk=ugaritic}', "");
    Expect(1, 66464, '\p{^Is_Blk=ugaritic}', "");
    Expect(1, 66464, '\P{Is_Blk=ugaritic}', "");
    Expect(0, 66464, '\P{^Is_Blk=ugaritic}', "");
    Expect(1, 66463, '\p{Is_Blk=__ugaritic}', "");
    Expect(0, 66463, '\p{^Is_Blk=__ugaritic}', "");
    Expect(0, 66463, '\P{Is_Blk=__ugaritic}', "");
    Expect(1, 66463, '\P{^Is_Blk=__ugaritic}', "");
    Expect(0, 66464, '\p{Is_Blk=__ugaritic}', "");
    Expect(1, 66464, '\p{^Is_Blk=__ugaritic}', "");
    Expect(1, 66464, '\P{Is_Blk=__ugaritic}', "");
    Expect(0, 66464, '\P{^Is_Blk=__ugaritic}', "");
    Error('\p{Block=-:=Vai}');
    Error('\P{Block=-:=Vai}');
    Expect(1, 42559, '\p{Block=:\AVai\z:}', "");;
    Expect(0, 42560, '\p{Block=:\AVai\z:}', "");;
    Expect(1, 42559, '\p{Block=vai}', "");
    Expect(0, 42559, '\p{^Block=vai}', "");
    Expect(0, 42559, '\P{Block=vai}', "");
    Expect(1, 42559, '\P{^Block=vai}', "");
    Expect(0, 42560, '\p{Block=vai}', "");
    Expect(1, 42560, '\p{^Block=vai}', "");
    Expect(1, 42560, '\P{Block=vai}', "");
    Expect(0, 42560, '\P{^Block=vai}', "");
    Expect(1, 42559, '\p{Block=:\Avai\z:}', "");;
    Expect(0, 42560, '\p{Block=:\Avai\z:}', "");;
    Expect(1, 42559, '\p{Block= vai}', "");
    Expect(0, 42559, '\p{^Block= vai}', "");
    Expect(0, 42559, '\P{Block= vai}', "");
    Expect(1, 42559, '\P{^Block= vai}', "");
    Expect(0, 42560, '\p{Block= vai}', "");
    Expect(1, 42560, '\p{^Block= vai}', "");
    Expect(1, 42560, '\P{Block= vai}', "");
    Expect(0, 42560, '\P{^Block= vai}', "");
    Error('\p{Blk=:=Vai}');
    Error('\P{Blk=:=Vai}');
    Expect(1, 42559, '\p{Blk=:\AVai\z:}', "");;
    Expect(0, 42560, '\p{Blk=:\AVai\z:}', "");;
    Expect(1, 42559, '\p{Blk=vai}', "");
    Expect(0, 42559, '\p{^Blk=vai}', "");
    Expect(0, 42559, '\P{Blk=vai}', "");
    Expect(1, 42559, '\P{^Blk=vai}', "");
    Expect(0, 42560, '\p{Blk=vai}', "");
    Expect(1, 42560, '\p{^Blk=vai}', "");
    Expect(1, 42560, '\P{Blk=vai}', "");
    Expect(0, 42560, '\P{^Blk=vai}', "");
    Expect(1, 42559, '\p{Blk=:\Avai\z:}', "");;
    Expect(0, 42560, '\p{Blk=:\Avai\z:}', "");;
    Expect(1, 42559, '\p{Blk= Vai}', "");
    Expect(0, 42559, '\p{^Blk= Vai}', "");
    Expect(0, 42559, '\P{Blk= Vai}', "");
    Expect(1, 42559, '\P{^Blk= Vai}', "");
    Expect(0, 42560, '\p{Blk= Vai}', "");
    Expect(1, 42560, '\p{^Blk= Vai}', "");
    Expect(1, 42560, '\P{Blk= Vai}', "");
    Expect(0, 42560, '\P{^Blk= Vai}', "");
    Error('\p{Is_Block=-/a/vai}');
    Error('\P{Is_Block=-/a/vai}');
    Expect(1, 42559, '\p{Is_Block=vai}', "");
    Expect(0, 42559, '\p{^Is_Block=vai}', "");
    Expect(0, 42559, '\P{Is_Block=vai}', "");
    Expect(1, 42559, '\P{^Is_Block=vai}', "");
    Expect(0, 42560, '\p{Is_Block=vai}', "");
    Expect(1, 42560, '\p{^Is_Block=vai}', "");
    Expect(1, 42560, '\P{Is_Block=vai}', "");
    Expect(0, 42560, '\P{^Is_Block=vai}', "");
    Expect(1, 42559, '\p{Is_Block:   	-VAI}', "");
    Expect(0, 42559, '\p{^Is_Block:   	-VAI}', "");
    Expect(0, 42559, '\P{Is_Block:   	-VAI}', "");
    Expect(1, 42559, '\P{^Is_Block:   	-VAI}', "");
    Expect(0, 42560, '\p{Is_Block:   	-VAI}', "");
    Expect(1, 42560, '\p{^Is_Block:   	-VAI}', "");
    Expect(1, 42560, '\P{Is_Block:   	-VAI}', "");
    Expect(0, 42560, '\P{^Is_Block:   	-VAI}', "");
    Error('\p{Is_Blk=:=vai}');
    Error('\P{Is_Blk=:=vai}');
    Expect(1, 42559, '\p{Is_Blk=vai}', "");
    Expect(0, 42559, '\p{^Is_Blk=vai}', "");
    Expect(0, 42559, '\P{Is_Blk=vai}', "");
    Expect(1, 42559, '\P{^Is_Blk=vai}', "");
    Expect(0, 42560, '\p{Is_Blk=vai}', "");
    Expect(1, 42560, '\p{^Is_Blk=vai}', "");
    Expect(1, 42560, '\P{Is_Blk=vai}', "");
    Expect(0, 42560, '\P{^Is_Blk=vai}', "");
    Expect(1, 42559, '\p{Is_Blk=-_Vai}', "");
    Expect(0, 42559, '\p{^Is_Blk=-_Vai}', "");
    Expect(0, 42559, '\P{Is_Blk=-_Vai}', "");
    Expect(1, 42559, '\P{^Is_Blk=-_Vai}', "");
    Expect(0, 42560, '\p{Is_Blk=-_Vai}', "");
    Expect(1, 42560, '\p{^Is_Blk=-_Vai}', "");
    Expect(1, 42560, '\P{Is_Blk=-_Vai}', "");
    Expect(0, 42560, '\P{^Is_Blk=-_Vai}', "");
    Error('\p{Block=-_vedic_Extensions/a/}');
    Error('\P{Block=-_vedic_Extensions/a/}');
    Expect(1, 7423, '\p{Block=:\AVedic_Extensions\z:}', "");;
    Expect(0, 7424, '\p{Block=:\AVedic_Extensions\z:}', "");;
    Expect(1, 7423, '\p{Block=vedicextensions}', "");
    Expect(0, 7423, '\p{^Block=vedicextensions}', "");
    Expect(0, 7423, '\P{Block=vedicextensions}', "");
    Expect(1, 7423, '\P{^Block=vedicextensions}', "");
    Expect(0, 7424, '\p{Block=vedicextensions}', "");
    Expect(1, 7424, '\p{^Block=vedicextensions}', "");
    Expect(1, 7424, '\P{Block=vedicextensions}', "");
    Expect(0, 7424, '\P{^Block=vedicextensions}', "");
    Expect(1, 7423, '\p{Block=:\Avedicextensions\z:}', "");;
    Expect(0, 7424, '\p{Block=:\Avedicextensions\z:}', "");;
    Expect(1, 7423, '\p{Block= 	vedic_EXTENSIONS}', "");
    Expect(0, 7423, '\p{^Block= 	vedic_EXTENSIONS}', "");
    Expect(0, 7423, '\P{Block= 	vedic_EXTENSIONS}', "");
    Expect(1, 7423, '\P{^Block= 	vedic_EXTENSIONS}', "");
    Expect(0, 7424, '\p{Block= 	vedic_EXTENSIONS}', "");
    Expect(1, 7424, '\p{^Block= 	vedic_EXTENSIONS}', "");
    Expect(1, 7424, '\P{Block= 	vedic_EXTENSIONS}', "");
    Expect(0, 7424, '\P{^Block= 	vedic_EXTENSIONS}', "");
    Error('\p{Blk=	/a/Vedic_Ext}');
    Error('\P{Blk=	/a/Vedic_Ext}');
    Expect(1, 7423, '\p{Blk=:\AVedic_Ext\z:}', "");;
    Expect(0, 7424, '\p{Blk=:\AVedic_Ext\z:}', "");;
    Expect(1, 7423, '\p{Blk=vedicext}', "");
    Expect(0, 7423, '\p{^Blk=vedicext}', "");
    Expect(0, 7423, '\P{Blk=vedicext}', "");
    Expect(1, 7423, '\P{^Blk=vedicext}', "");
    Expect(0, 7424, '\p{Blk=vedicext}', "");
    Expect(1, 7424, '\p{^Blk=vedicext}', "");
    Expect(1, 7424, '\P{Blk=vedicext}', "");
    Expect(0, 7424, '\P{^Blk=vedicext}', "");
    Expect(1, 7423, '\p{Blk=:\Avedicext\z:}', "");;
    Expect(0, 7424, '\p{Blk=:\Avedicext\z:}', "");;
    Expect(1, 7423, '\p{Blk= VEDIC_EXT}', "");
    Expect(0, 7423, '\p{^Blk= VEDIC_EXT}', "");
    Expect(0, 7423, '\P{Blk= VEDIC_EXT}', "");
    Expect(1, 7423, '\P{^Blk= VEDIC_EXT}', "");
    Expect(0, 7424, '\p{Blk= VEDIC_EXT}', "");
    Expect(1, 7424, '\p{^Blk= VEDIC_EXT}', "");
    Expect(1, 7424, '\P{Blk= VEDIC_EXT}', "");
    Expect(0, 7424, '\P{^Blk= VEDIC_EXT}', "");
    Error('\p{Is_Block=	Vedic_extensions:=}');
    Error('\P{Is_Block=	Vedic_extensions:=}');
    Expect(1, 7423, '\p{Is_Block=vedicextensions}', "");
    Expect(0, 7423, '\p{^Is_Block=vedicextensions}', "");
    Expect(0, 7423, '\P{Is_Block=vedicextensions}', "");
    Expect(1, 7423, '\P{^Is_Block=vedicextensions}', "");
    Expect(0, 7424, '\p{Is_Block=vedicextensions}', "");
    Expect(1, 7424, '\p{^Is_Block=vedicextensions}', "");
    Expect(1, 7424, '\P{Is_Block=vedicextensions}', "");
    Expect(0, 7424, '\P{^Is_Block=vedicextensions}', "");
    Expect(1, 7423, '\p{Is_Block=Vedic_Extensions}', "");
    Expect(0, 7423, '\p{^Is_Block=Vedic_Extensions}', "");
    Expect(0, 7423, '\P{Is_Block=Vedic_Extensions}', "");
    Expect(1, 7423, '\P{^Is_Block=Vedic_Extensions}', "");
    Expect(0, 7424, '\p{Is_Block=Vedic_Extensions}', "");
    Expect(1, 7424, '\p{^Is_Block=Vedic_Extensions}', "");
    Expect(1, 7424, '\P{Is_Block=Vedic_Extensions}', "");
    Expect(0, 7424, '\P{^Is_Block=Vedic_Extensions}', "");
    Error('\p{Is_Blk=_Vedic_EXT/a/}');
    Error('\P{Is_Blk=_Vedic_EXT/a/}');
    Expect(1, 7423, '\p{Is_Blk:vedicext}', "");
    Expect(0, 7423, '\p{^Is_Blk:vedicext}', "");
    Expect(0, 7423, '\P{Is_Blk:vedicext}', "");
    Expect(1, 7423, '\P{^Is_Blk:vedicext}', "");
    Expect(0, 7424, '\p{Is_Blk:vedicext}', "");
    Expect(1, 7424, '\p{^Is_Blk:vedicext}', "");
    Expect(1, 7424, '\P{Is_Blk:vedicext}', "");
    Expect(0, 7424, '\P{^Is_Blk:vedicext}', "");
    Expect(1, 7423, '\p{Is_Blk=	 Vedic_EXT}', "");
    Expect(0, 7423, '\p{^Is_Blk=	 Vedic_EXT}', "");
    Expect(0, 7423, '\P{Is_Blk=	 Vedic_EXT}', "");
    Expect(1, 7423, '\P{^Is_Blk=	 Vedic_EXT}', "");
    Expect(0, 7424, '\p{Is_Blk=	 Vedic_EXT}', "");
    Expect(1, 7424, '\p{^Is_Blk=	 Vedic_EXT}', "");
    Expect(1, 7424, '\P{Is_Blk=	 Vedic_EXT}', "");
    Expect(0, 7424, '\P{^Is_Blk=	 Vedic_EXT}', "");
    Error('\p{Block=--Vertical_Forms:=}');
    Error('\P{Block=--Vertical_Forms:=}');
    Expect(1, 65055, '\p{Block=:\AVertical_Forms\z:}', "");;
    Expect(0, 65056, '\p{Block=:\AVertical_Forms\z:}', "");;
    Expect(1, 65055, '\p{Block=verticalforms}', "");
    Expect(0, 65055, '\p{^Block=verticalforms}', "");
    Expect(0, 65055, '\P{Block=verticalforms}', "");
    Expect(1, 65055, '\P{^Block=verticalforms}', "");
    Expect(0, 65056, '\p{Block=verticalforms}', "");
    Expect(1, 65056, '\p{^Block=verticalforms}', "");
    Expect(1, 65056, '\P{Block=verticalforms}', "");
    Expect(0, 65056, '\P{^Block=verticalforms}', "");
    Expect(1, 65055, '\p{Block=:\Averticalforms\z:}', "");;
    Expect(0, 65056, '\p{Block=:\Averticalforms\z:}', "");;
    Expect(1, 65055, '\p{Block=_-VERTICAL_FORMS}', "");
    Expect(0, 65055, '\p{^Block=_-VERTICAL_FORMS}', "");
    Expect(0, 65055, '\P{Block=_-VERTICAL_FORMS}', "");
    Expect(1, 65055, '\P{^Block=_-VERTICAL_FORMS}', "");
    Expect(0, 65056, '\p{Block=_-VERTICAL_FORMS}', "");
    Expect(1, 65056, '\p{^Block=_-VERTICAL_FORMS}', "");
    Expect(1, 65056, '\P{Block=_-VERTICAL_FORMS}', "");
    Expect(0, 65056, '\P{^Block=_-VERTICAL_FORMS}', "");
    Error('\p{Blk=:=-VERTICAL_Forms}');
    Error('\P{Blk=:=-VERTICAL_Forms}');
    Expect(1, 65055, '\p{Blk=:\AVertical_Forms\z:}', "");;
    Expect(0, 65056, '\p{Blk=:\AVertical_Forms\z:}', "");;
    Expect(1, 65055, '\p{Blk: verticalforms}', "");
    Expect(0, 65055, '\p{^Blk: verticalforms}', "");
    Expect(0, 65055, '\P{Blk: verticalforms}', "");
    Expect(1, 65055, '\P{^Blk: verticalforms}', "");
    Expect(0, 65056, '\p{Blk: verticalforms}', "");
    Expect(1, 65056, '\p{^Blk: verticalforms}', "");
    Expect(1, 65056, '\P{Blk: verticalforms}', "");
    Expect(0, 65056, '\P{^Blk: verticalforms}', "");
    Expect(1, 65055, '\p{Blk=:\Averticalforms\z:}', "");;
    Expect(0, 65056, '\p{Blk=:\Averticalforms\z:}', "");;
    Expect(1, 65055, '\p{Blk=_vertical_FORMS}', "");
    Expect(0, 65055, '\p{^Blk=_vertical_FORMS}', "");
    Expect(0, 65055, '\P{Blk=_vertical_FORMS}', "");
    Expect(1, 65055, '\P{^Blk=_vertical_FORMS}', "");
    Expect(0, 65056, '\p{Blk=_vertical_FORMS}', "");
    Expect(1, 65056, '\p{^Blk=_vertical_FORMS}', "");
    Expect(1, 65056, '\P{Blk=_vertical_FORMS}', "");
    Expect(0, 65056, '\P{^Blk=_vertical_FORMS}', "");
    Error('\p{Is_Block=	-Vertical_Forms/a/}');
    Error('\P{Is_Block=	-Vertical_Forms/a/}');
    Expect(1, 65055, '\p{Is_Block=verticalforms}', "");
    Expect(0, 65055, '\p{^Is_Block=verticalforms}', "");
    Expect(0, 65055, '\P{Is_Block=verticalforms}', "");
    Expect(1, 65055, '\P{^Is_Block=verticalforms}', "");
    Expect(0, 65056, '\p{Is_Block=verticalforms}', "");
    Expect(1, 65056, '\p{^Is_Block=verticalforms}', "");
    Expect(1, 65056, '\P{Is_Block=verticalforms}', "");
    Expect(0, 65056, '\P{^Is_Block=verticalforms}', "");
    Expect(1, 65055, '\p{Is_Block=_ vertical_FORMS}', "");
    Expect(0, 65055, '\p{^Is_Block=_ vertical_FORMS}', "");
    Expect(0, 65055, '\P{Is_Block=_ vertical_FORMS}', "");
    Expect(1, 65055, '\P{^Is_Block=_ vertical_FORMS}', "");
    Expect(0, 65056, '\p{Is_Block=_ vertical_FORMS}', "");
    Expect(1, 65056, '\p{^Is_Block=_ vertical_FORMS}', "");
    Expect(1, 65056, '\P{Is_Block=_ vertical_FORMS}', "");
    Expect(0, 65056, '\P{^Is_Block=_ vertical_FORMS}', "");
    Error('\p{Is_Blk=	 Vertical_Forms/a/}');
    Error('\P{Is_Blk=	 Vertical_Forms/a/}');
    Expect(1, 65055, '\p{Is_Blk: verticalforms}', "");
    Expect(0, 65055, '\p{^Is_Blk: verticalforms}', "");
    Expect(0, 65055, '\P{Is_Blk: verticalforms}', "");
    Expect(1, 65055, '\P{^Is_Blk: verticalforms}', "");
    Expect(0, 65056, '\p{Is_Blk: verticalforms}', "");
    Expect(1, 65056, '\p{^Is_Blk: verticalforms}', "");
    Expect(1, 65056, '\P{Is_Blk: verticalforms}', "");
    Expect(0, 65056, '\P{^Is_Blk: verticalforms}', "");
    Expect(1, 65055, '\p{Is_Blk=_-Vertical_Forms}', "");
    Expect(0, 65055, '\p{^Is_Blk=_-Vertical_Forms}', "");
    Expect(0, 65055, '\P{Is_Blk=_-Vertical_Forms}', "");
    Expect(1, 65055, '\P{^Is_Blk=_-Vertical_Forms}', "");
    Expect(0, 65056, '\p{Is_Blk=_-Vertical_Forms}', "");
    Expect(1, 65056, '\p{^Is_Blk=_-Vertical_Forms}', "");
    Expect(1, 65056, '\P{Is_Blk=_-Vertical_Forms}', "");
    Expect(0, 65056, '\P{^Is_Blk=_-Vertical_Forms}', "");
    Error('\p{Block=:=variation_SELECTORS}');
    Error('\P{Block=:=variation_SELECTORS}');
    Expect(1, 65039, '\p{Block=:\AVariation_Selectors\z:}', "");;
    Expect(0, 65040, '\p{Block=:\AVariation_Selectors\z:}', "");;
    Expect(1, 65039, '\p{Block=variationselectors}', "");
    Expect(0, 65039, '\p{^Block=variationselectors}', "");
    Expect(0, 65039, '\P{Block=variationselectors}', "");
    Expect(1, 65039, '\P{^Block=variationselectors}', "");
    Expect(0, 65040, '\p{Block=variationselectors}', "");
    Expect(1, 65040, '\p{^Block=variationselectors}', "");
    Expect(1, 65040, '\P{Block=variationselectors}', "");
    Expect(0, 65040, '\P{^Block=variationselectors}', "");
    Expect(1, 65039, '\p{Block=:\Avariationselectors\z:}', "");;
    Expect(0, 65040, '\p{Block=:\Avariationselectors\z:}', "");;
    Expect(1, 65039, '\p{Block=__Variation_Selectors}', "");
    Expect(0, 65039, '\p{^Block=__Variation_Selectors}', "");
    Expect(0, 65039, '\P{Block=__Variation_Selectors}', "");
    Expect(1, 65039, '\P{^Block=__Variation_Selectors}', "");
    Expect(0, 65040, '\p{Block=__Variation_Selectors}', "");
    Expect(1, 65040, '\p{^Block=__Variation_Selectors}', "");
    Expect(1, 65040, '\P{Block=__Variation_Selectors}', "");
    Expect(0, 65040, '\P{^Block=__Variation_Selectors}', "");
    Error('\p{Blk=		vs:=}');
    Error('\P{Blk=		vs:=}');
    Expect(1, 65039, '\p{Blk=:\AVS\z:}', "");;
    Expect(0, 65040, '\p{Blk=:\AVS\z:}', "");;
    Expect(1, 65039, '\p{Blk=vs}', "");
    Expect(0, 65039, '\p{^Blk=vs}', "");
    Expect(0, 65039, '\P{Blk=vs}', "");
    Expect(1, 65039, '\P{^Blk=vs}', "");
    Expect(0, 65040, '\p{Blk=vs}', "");
    Expect(1, 65040, '\p{^Blk=vs}', "");
    Expect(1, 65040, '\P{Blk=vs}', "");
    Expect(0, 65040, '\P{^Blk=vs}', "");
    Expect(1, 65039, '\p{Blk=:\Avs\z:}', "");;
    Expect(0, 65040, '\p{Blk=:\Avs\z:}', "");;
    Expect(1, 65039, '\p{Blk:--vs}', "");
    Expect(0, 65039, '\p{^Blk:--vs}', "");
    Expect(0, 65039, '\P{Blk:--vs}', "");
    Expect(1, 65039, '\P{^Blk:--vs}', "");
    Expect(0, 65040, '\p{Blk:--vs}', "");
    Expect(1, 65040, '\p{^Blk:--vs}', "");
    Expect(1, 65040, '\P{Blk:--vs}', "");
    Expect(0, 65040, '\P{^Blk:--vs}', "");
    Error('\p{Is_Block:   /a/ _VARIATION_Selectors}');
    Error('\P{Is_Block:   /a/ _VARIATION_Selectors}');
    Expect(1, 65039, '\p{Is_Block=variationselectors}', "");
    Expect(0, 65039, '\p{^Is_Block=variationselectors}', "");
    Expect(0, 65039, '\P{Is_Block=variationselectors}', "");
    Expect(1, 65039, '\P{^Is_Block=variationselectors}', "");
    Expect(0, 65040, '\p{Is_Block=variationselectors}', "");
    Expect(1, 65040, '\p{^Is_Block=variationselectors}', "");
    Expect(1, 65040, '\P{Is_Block=variationselectors}', "");
    Expect(0, 65040, '\P{^Is_Block=variationselectors}', "");
    Expect(1, 65039, '\p{Is_Block=-variation_selectors}', "");
    Expect(0, 65039, '\p{^Is_Block=-variation_selectors}', "");
    Expect(0, 65039, '\P{Is_Block=-variation_selectors}', "");
    Expect(1, 65039, '\P{^Is_Block=-variation_selectors}', "");
    Expect(0, 65040, '\p{Is_Block=-variation_selectors}', "");
    Expect(1, 65040, '\p{^Is_Block=-variation_selectors}', "");
    Expect(1, 65040, '\P{Is_Block=-variation_selectors}', "");
    Expect(0, 65040, '\P{^Is_Block=-variation_selectors}', "");
    Error('\p{Is_Blk= -vs:=}');
    Error('\P{Is_Blk= -vs:=}');
    Expect(1, 65039, '\p{Is_Blk=vs}', "");
    Expect(0, 65039, '\p{^Is_Blk=vs}', "");
    Expect(0, 65039, '\P{Is_Blk=vs}', "");
    Expect(1, 65039, '\P{^Is_Blk=vs}', "");
    Expect(0, 65040, '\p{Is_Blk=vs}', "");
    Expect(1, 65040, '\p{^Is_Blk=vs}', "");
    Expect(1, 65040, '\P{Is_Blk=vs}', "");
    Expect(0, 65040, '\P{^Is_Blk=vs}', "");
    Error('\p{Block=_:=Variation_Selectors_SUPPLEMENT}');
    Error('\P{Block=_:=Variation_Selectors_SUPPLEMENT}');
    Expect(1, 917999, '\p{Block=:\AVariation_Selectors_Supplement\z:}', "");;
    Expect(0, 918000, '\p{Block=:\AVariation_Selectors_Supplement\z:}', "");;
    Expect(1, 917999, '\p{Block:   variationselectorssupplement}', "");
    Expect(0, 917999, '\p{^Block:   variationselectorssupplement}', "");
    Expect(0, 917999, '\P{Block:   variationselectorssupplement}', "");
    Expect(1, 917999, '\P{^Block:   variationselectorssupplement}', "");
    Expect(0, 918000, '\p{Block:   variationselectorssupplement}', "");
    Expect(1, 918000, '\p{^Block:   variationselectorssupplement}', "");
    Expect(1, 918000, '\P{Block:   variationselectorssupplement}', "");
    Expect(0, 918000, '\P{^Block:   variationselectorssupplement}', "");
    Expect(1, 917999, '\p{Block=:\Avariationselectorssupplement\z:}', "");;
    Expect(0, 918000, '\p{Block=:\Avariationselectorssupplement\z:}', "");;
    Expect(1, 917999, '\p{Block:- variation_Selectors_Supplement}', "");
    Expect(0, 917999, '\p{^Block:- variation_Selectors_Supplement}', "");
    Expect(0, 917999, '\P{Block:- variation_Selectors_Supplement}', "");
    Expect(1, 917999, '\P{^Block:- variation_Selectors_Supplement}', "");
    Expect(0, 918000, '\p{Block:- variation_Selectors_Supplement}', "");
    Expect(1, 918000, '\p{^Block:- variation_Selectors_Supplement}', "");
    Expect(1, 918000, '\P{Block:- variation_Selectors_Supplement}', "");
    Expect(0, 918000, '\P{^Block:- variation_Selectors_Supplement}', "");
    Error('\p{Blk=:= VS_SUP}');
    Error('\P{Blk=:= VS_SUP}');
    Expect(1, 917999, '\p{Blk=:\AVS_Sup\z:}', "");;
    Expect(0, 918000, '\p{Blk=:\AVS_Sup\z:}', "");;
    Expect(1, 917999, '\p{Blk=vssup}', "");
    Expect(0, 917999, '\p{^Blk=vssup}', "");
    Expect(0, 917999, '\P{Blk=vssup}', "");
    Expect(1, 917999, '\P{^Blk=vssup}', "");
    Expect(0, 918000, '\p{Blk=vssup}', "");
    Expect(1, 918000, '\p{^Blk=vssup}', "");
    Expect(1, 918000, '\P{Blk=vssup}', "");
    Expect(0, 918000, '\P{^Blk=vssup}', "");
    Expect(1, 917999, '\p{Blk=:\Avssup\z:}', "");;
    Expect(0, 918000, '\p{Blk=:\Avssup\z:}', "");;
    Expect(1, 917999, '\p{Blk=_vs_SUP}', "");
    Expect(0, 917999, '\p{^Blk=_vs_SUP}', "");
    Expect(0, 917999, '\P{Blk=_vs_SUP}', "");
    Expect(1, 917999, '\P{^Blk=_vs_SUP}', "");
    Expect(0, 918000, '\p{Blk=_vs_SUP}', "");
    Expect(1, 918000, '\p{^Blk=_vs_SUP}', "");
    Expect(1, 918000, '\P{Blk=_vs_SUP}', "");
    Expect(0, 918000, '\P{^Blk=_vs_SUP}', "");
    Error('\p{Is_Block= VARIATION_SELECTORS_Supplement/a/}');
    Error('\P{Is_Block= VARIATION_SELECTORS_Supplement/a/}');
    Expect(1, 917999, '\p{Is_Block=variationselectorssupplement}', "");
    Expect(0, 917999, '\p{^Is_Block=variationselectorssupplement}', "");
    Expect(0, 917999, '\P{Is_Block=variationselectorssupplement}', "");
    Expect(1, 917999, '\P{^Is_Block=variationselectorssupplement}', "");
    Expect(0, 918000, '\p{Is_Block=variationselectorssupplement}', "");
    Expect(1, 918000, '\p{^Is_Block=variationselectorssupplement}', "");
    Expect(1, 918000, '\P{Is_Block=variationselectorssupplement}', "");
    Expect(0, 918000, '\P{^Is_Block=variationselectorssupplement}', "");
    Expect(1, 917999, '\p{Is_Block=	-variation_Selectors_Supplement}', "");
    Expect(0, 917999, '\p{^Is_Block=	-variation_Selectors_Supplement}', "");
    Expect(0, 917999, '\P{Is_Block=	-variation_Selectors_Supplement}', "");
    Expect(1, 917999, '\P{^Is_Block=	-variation_Selectors_Supplement}', "");
    Expect(0, 918000, '\p{Is_Block=	-variation_Selectors_Supplement}', "");
    Expect(1, 918000, '\p{^Is_Block=	-variation_Selectors_Supplement}', "");
    Expect(1, 918000, '\P{Is_Block=	-variation_Selectors_Supplement}', "");
    Expect(0, 918000, '\P{^Is_Block=	-variation_Selectors_Supplement}', "");
    Error('\p{Is_Blk=/a/- VS_sup}');
    Error('\P{Is_Blk=/a/- VS_sup}');
    Expect(1, 917999, '\p{Is_Blk=vssup}', "");
    Expect(0, 917999, '\p{^Is_Blk=vssup}', "");
    Expect(0, 917999, '\P{Is_Blk=vssup}', "");
    Expect(1, 917999, '\P{^Is_Blk=vssup}', "");
    Expect(0, 918000, '\p{Is_Blk=vssup}', "");
    Expect(1, 918000, '\p{^Is_Blk=vssup}', "");
    Expect(1, 918000, '\P{Is_Blk=vssup}', "");
    Expect(0, 918000, '\P{^Is_Blk=vssup}', "");
    Expect(1, 917999, '\p{Is_Blk=  VS_Sup}', "");
    Expect(0, 917999, '\p{^Is_Blk=  VS_Sup}', "");
    Expect(0, 917999, '\P{Is_Blk=  VS_Sup}', "");
    Expect(1, 917999, '\P{^Is_Blk=  VS_Sup}', "");
    Expect(0, 918000, '\p{Is_Blk=  VS_Sup}', "");
    Expect(1, 918000, '\p{^Is_Blk=  VS_Sup}', "");
    Expect(1, 918000, '\P{Is_Blk=  VS_Sup}', "");
    Expect(0, 918000, '\P{^Is_Blk=  VS_Sup}', "");
    Error('\p{Block=-Wancho/a/}');
    Error('\P{Block=-Wancho/a/}');
    Expect(1, 123647, '\p{Block=:\AWancho\z:}', "");;
    Expect(0, 123648, '\p{Block=:\AWancho\z:}', "");;
    Expect(1, 123647, '\p{Block:   wancho}', "");
    Expect(0, 123647, '\p{^Block:   wancho}', "");
    Expect(0, 123647, '\P{Block:   wancho}', "");
    Expect(1, 123647, '\P{^Block:   wancho}', "");
    Expect(0, 123648, '\p{Block:   wancho}', "");
    Expect(1, 123648, '\p{^Block:   wancho}', "");
    Expect(1, 123648, '\P{Block:   wancho}', "");
    Expect(0, 123648, '\P{^Block:   wancho}', "");
    Expect(1, 123647, '\p{Block=:\Awancho\z:}', "");;
    Expect(0, 123648, '\p{Block=:\Awancho\z:}', "");;
    Expect(1, 123647, '\p{Block=WANCHO}', "");
    Expect(0, 123647, '\p{^Block=WANCHO}', "");
    Expect(0, 123647, '\P{Block=WANCHO}', "");
    Expect(1, 123647, '\P{^Block=WANCHO}', "");
    Expect(0, 123648, '\p{Block=WANCHO}', "");
    Expect(1, 123648, '\p{^Block=WANCHO}', "");
    Expect(1, 123648, '\P{Block=WANCHO}', "");
    Expect(0, 123648, '\P{^Block=WANCHO}', "");
    Error('\p{Blk=	:=Wancho}');
    Error('\P{Blk=	:=Wancho}');
    Expect(1, 123647, '\p{Blk=:\AWancho\z:}', "");;
    Expect(0, 123648, '\p{Blk=:\AWancho\z:}', "");;
    Expect(1, 123647, '\p{Blk=wancho}', "");
    Expect(0, 123647, '\p{^Blk=wancho}', "");
    Expect(0, 123647, '\P{Blk=wancho}', "");
    Expect(1, 123647, '\P{^Blk=wancho}', "");
    Expect(0, 123648, '\p{Blk=wancho}', "");
    Expect(1, 123648, '\p{^Blk=wancho}', "");
    Expect(1, 123648, '\P{Blk=wancho}', "");
    Expect(0, 123648, '\P{^Blk=wancho}', "");
    Expect(1, 123647, '\p{Blk=:\Awancho\z:}', "");;
    Expect(0, 123648, '\p{Blk=:\Awancho\z:}', "");;
    Expect(1, 123647, '\p{Blk=	WANCHO}', "");
    Expect(0, 123647, '\p{^Blk=	WANCHO}', "");
    Expect(0, 123647, '\P{Blk=	WANCHO}', "");
    Expect(1, 123647, '\P{^Blk=	WANCHO}', "");
    Expect(0, 123648, '\p{Blk=	WANCHO}', "");
    Expect(1, 123648, '\p{^Blk=	WANCHO}', "");
    Expect(1, 123648, '\P{Blk=	WANCHO}', "");
    Expect(0, 123648, '\P{^Blk=	WANCHO}', "");
    Error('\p{Is_Block=:=		wancho}');
    Error('\P{Is_Block=:=		wancho}');
    Expect(1, 123647, '\p{Is_Block:wancho}', "");
    Expect(0, 123647, '\p{^Is_Block:wancho}', "");
    Expect(0, 123647, '\P{Is_Block:wancho}', "");
    Expect(1, 123647, '\P{^Is_Block:wancho}', "");
    Expect(0, 123648, '\p{Is_Block:wancho}', "");
    Expect(1, 123648, '\p{^Is_Block:wancho}', "");
    Expect(1, 123648, '\P{Is_Block:wancho}', "");
    Expect(0, 123648, '\P{^Is_Block:wancho}', "");
    Expect(1, 123647, '\p{Is_Block:WANCHO}', "");
    Expect(0, 123647, '\p{^Is_Block:WANCHO}', "");
    Expect(0, 123647, '\P{Is_Block:WANCHO}', "");
    Expect(1, 123647, '\P{^Is_Block:WANCHO}', "");
    Expect(0, 123648, '\p{Is_Block:WANCHO}', "");
    Expect(1, 123648, '\p{^Is_Block:WANCHO}', "");
    Expect(1, 123648, '\P{Is_Block:WANCHO}', "");
    Expect(0, 123648, '\P{^Is_Block:WANCHO}', "");
    Error('\p{Is_Blk=-wancho:=}');
    Error('\P{Is_Blk=-wancho:=}');
    Expect(1, 123647, '\p{Is_Blk=wancho}', "");
    Expect(0, 123647, '\p{^Is_Blk=wancho}', "");
    Expect(0, 123647, '\P{Is_Blk=wancho}', "");
    Expect(1, 123647, '\P{^Is_Blk=wancho}', "");
    Expect(0, 123648, '\p{Is_Blk=wancho}', "");
    Expect(1, 123648, '\p{^Is_Blk=wancho}', "");
    Expect(1, 123648, '\P{Is_Blk=wancho}', "");
    Expect(0, 123648, '\P{^Is_Blk=wancho}', "");
    Expect(1, 123647, '\p{Is_Blk=_WANCHO}', "");
    Expect(0, 123647, '\p{^Is_Blk=_WANCHO}', "");
    Expect(0, 123647, '\P{Is_Blk=_WANCHO}', "");
    Expect(1, 123647, '\P{^Is_Blk=_WANCHO}', "");
    Expect(0, 123648, '\p{Is_Blk=_WANCHO}', "");
    Expect(1, 123648, '\p{^Is_Blk=_WANCHO}', "");
    Expect(1, 123648, '\P{Is_Blk=_WANCHO}', "");
    Expect(0, 123648, '\P{^Is_Blk=_WANCHO}', "");
    Error('\p{Block=/a/	Warang_citi}');
    Error('\P{Block=/a/	Warang_citi}');
    Expect(1, 71935, '\p{Block=:\AWarang_Citi\z:}', "");;
    Expect(0, 71936, '\p{Block=:\AWarang_Citi\z:}', "");;
    Expect(1, 71935, '\p{Block=warangciti}', "");
    Expect(0, 71935, '\p{^Block=warangciti}', "");
    Expect(0, 71935, '\P{Block=warangciti}', "");
    Expect(1, 71935, '\P{^Block=warangciti}', "");
    Expect(0, 71936, '\p{Block=warangciti}', "");
    Expect(1, 71936, '\p{^Block=warangciti}', "");
    Expect(1, 71936, '\P{Block=warangciti}', "");
    Expect(0, 71936, '\P{^Block=warangciti}', "");
    Expect(1, 71935, '\p{Block=:\Awarangciti\z:}', "");;
    Expect(0, 71936, '\p{Block=:\Awarangciti\z:}', "");;
    Expect(1, 71935, '\p{Block=-warang_Citi}', "");
    Expect(0, 71935, '\p{^Block=-warang_Citi}', "");
    Expect(0, 71935, '\P{Block=-warang_Citi}', "");
    Expect(1, 71935, '\P{^Block=-warang_Citi}', "");
    Expect(0, 71936, '\p{Block=-warang_Citi}', "");
    Expect(1, 71936, '\p{^Block=-warang_Citi}', "");
    Expect(1, 71936, '\P{Block=-warang_Citi}', "");
    Expect(0, 71936, '\P{^Block=-warang_Citi}', "");
    Error('\p{Blk=_/a/WARANG_citi}');
    Error('\P{Blk=_/a/WARANG_citi}');
    Expect(1, 71935, '\p{Blk=:\AWarang_Citi\z:}', "");;
    Expect(0, 71936, '\p{Blk=:\AWarang_Citi\z:}', "");;
    Expect(1, 71935, '\p{Blk=warangciti}', "");
    Expect(0, 71935, '\p{^Blk=warangciti}', "");
    Expect(0, 71935, '\P{Blk=warangciti}', "");
    Expect(1, 71935, '\P{^Blk=warangciti}', "");
    Expect(0, 71936, '\p{Blk=warangciti}', "");
    Expect(1, 71936, '\p{^Blk=warangciti}', "");
    Expect(1, 71936, '\P{Blk=warangciti}', "");
    Expect(0, 71936, '\P{^Blk=warangciti}', "");
    Expect(1, 71935, '\p{Blk=:\Awarangciti\z:}', "");;
    Expect(0, 71936, '\p{Blk=:\Awarangciti\z:}', "");;
    Expect(1, 71935, '\p{Blk= -WARANG_Citi}', "");
    Expect(0, 71935, '\p{^Blk= -WARANG_Citi}', "");
    Expect(0, 71935, '\P{Blk= -WARANG_Citi}', "");
    Expect(1, 71935, '\P{^Blk= -WARANG_Citi}', "");
    Expect(0, 71936, '\p{Blk= -WARANG_Citi}', "");
    Expect(1, 71936, '\p{^Blk= -WARANG_Citi}', "");
    Expect(1, 71936, '\P{Blk= -WARANG_Citi}', "");
    Expect(0, 71936, '\P{^Blk= -WARANG_Citi}', "");
    Error('\p{Is_Block=:=_ Warang_citi}');
    Error('\P{Is_Block=:=_ Warang_citi}');
    Expect(1, 71935, '\p{Is_Block=warangciti}', "");
    Expect(0, 71935, '\p{^Is_Block=warangciti}', "");
    Expect(0, 71935, '\P{Is_Block=warangciti}', "");
    Expect(1, 71935, '\P{^Is_Block=warangciti}', "");
    Expect(0, 71936, '\p{Is_Block=warangciti}', "");
    Expect(1, 71936, '\p{^Is_Block=warangciti}', "");
    Expect(1, 71936, '\P{Is_Block=warangciti}', "");
    Expect(0, 71936, '\P{^Is_Block=warangciti}', "");
    Expect(1, 71935, '\p{Is_Block=		Warang_Citi}', "");
    Expect(0, 71935, '\p{^Is_Block=		Warang_Citi}', "");
    Expect(0, 71935, '\P{Is_Block=		Warang_Citi}', "");
    Expect(1, 71935, '\P{^Is_Block=		Warang_Citi}', "");
    Expect(0, 71936, '\p{Is_Block=		Warang_Citi}', "");
    Expect(1, 71936, '\p{^Is_Block=		Warang_Citi}', "");
    Expect(1, 71936, '\P{Is_Block=		Warang_Citi}', "");
    Expect(0, 71936, '\P{^Is_Block=		Warang_Citi}', "");
    Error('\p{Is_Blk=__warang_Citi:=}');
    Error('\P{Is_Blk=__warang_Citi:=}');
    Expect(1, 71935, '\p{Is_Blk=warangciti}', "");
    Expect(0, 71935, '\p{^Is_Blk=warangciti}', "");
    Expect(0, 71935, '\P{Is_Blk=warangciti}', "");
    Expect(1, 71935, '\P{^Is_Blk=warangciti}', "");
    Expect(0, 71936, '\p{Is_Blk=warangciti}', "");
    Expect(1, 71936, '\p{^Is_Blk=warangciti}', "");
    Expect(1, 71936, '\P{Is_Blk=warangciti}', "");
    Expect(0, 71936, '\P{^Is_Blk=warangciti}', "");
    Expect(1, 71935, '\p{Is_Blk=-	Warang_CITI}', "");
    Expect(0, 71935, '\p{^Is_Blk=-	Warang_CITI}', "");
    Expect(0, 71935, '\P{Is_Blk=-	Warang_CITI}', "");
    Expect(1, 71935, '\P{^Is_Blk=-	Warang_CITI}', "");
    Expect(0, 71936, '\p{Is_Blk=-	Warang_CITI}', "");
    Expect(1, 71936, '\p{^Is_Blk=-	Warang_CITI}', "");
    Expect(1, 71936, '\P{Is_Blk=-	Warang_CITI}', "");
    Expect(0, 71936, '\P{^Is_Blk=-	Warang_CITI}', "");
    Error('\p{Block= :=YEZIDI}');
    Error('\P{Block= :=YEZIDI}');
    Expect(1, 69311, '\p{Block=:\AYezidi\z:}', "");;
    Expect(0, 69312, '\p{Block=:\AYezidi\z:}', "");;
    Expect(1, 69311, '\p{Block=yezidi}', "");
    Expect(0, 69311, '\p{^Block=yezidi}', "");
    Expect(0, 69311, '\P{Block=yezidi}', "");
    Expect(1, 69311, '\P{^Block=yezidi}', "");
    Expect(0, 69312, '\p{Block=yezidi}', "");
    Expect(1, 69312, '\p{^Block=yezidi}', "");
    Expect(1, 69312, '\P{Block=yezidi}', "");
    Expect(0, 69312, '\P{^Block=yezidi}', "");
    Expect(1, 69311, '\p{Block=:\Ayezidi\z:}', "");;
    Expect(0, 69312, '\p{Block=:\Ayezidi\z:}', "");;
    Expect(1, 69311, '\p{Block=--YEZIDI}', "");
    Expect(0, 69311, '\p{^Block=--YEZIDI}', "");
    Expect(0, 69311, '\P{Block=--YEZIDI}', "");
    Expect(1, 69311, '\P{^Block=--YEZIDI}', "");
    Expect(0, 69312, '\p{Block=--YEZIDI}', "");
    Expect(1, 69312, '\p{^Block=--YEZIDI}', "");
    Expect(1, 69312, '\P{Block=--YEZIDI}', "");
    Expect(0, 69312, '\P{^Block=--YEZIDI}', "");
    Error('\p{Blk=/a/- Yezidi}');
    Error('\P{Blk=/a/- Yezidi}');
    Expect(1, 69311, '\p{Blk=:\AYezidi\z:}', "");;
    Expect(0, 69312, '\p{Blk=:\AYezidi\z:}', "");;
    Expect(1, 69311, '\p{Blk=yezidi}', "");
    Expect(0, 69311, '\p{^Blk=yezidi}', "");
    Expect(0, 69311, '\P{Blk=yezidi}', "");
    Expect(1, 69311, '\P{^Blk=yezidi}', "");
    Expect(0, 69312, '\p{Blk=yezidi}', "");
    Expect(1, 69312, '\p{^Blk=yezidi}', "");
    Expect(1, 69312, '\P{Blk=yezidi}', "");
    Expect(0, 69312, '\P{^Blk=yezidi}', "");
    Expect(1, 69311, '\p{Blk=:\Ayezidi\z:}', "");;
    Expect(0, 69312, '\p{Blk=:\Ayezidi\z:}', "");;
    Expect(1, 69311, '\p{Blk=_ YEZIDI}', "");
    Expect(0, 69311, '\p{^Blk=_ YEZIDI}', "");
    Expect(0, 69311, '\P{Blk=_ YEZIDI}', "");
    Expect(1, 69311, '\P{^Blk=_ YEZIDI}', "");
    Expect(0, 69312, '\p{Blk=_ YEZIDI}', "");
    Expect(1, 69312, '\p{^Blk=_ YEZIDI}', "");
    Expect(1, 69312, '\P{Blk=_ YEZIDI}', "");
    Expect(0, 69312, '\P{^Blk=_ YEZIDI}', "");
    Error('\p{Is_Block=/a/yezidi}');
    Error('\P{Is_Block=/a/yezidi}');
    Expect(1, 69311, '\p{Is_Block=yezidi}', "");
    Expect(0, 69311, '\p{^Is_Block=yezidi}', "");
    Expect(0, 69311, '\P{Is_Block=yezidi}', "");
    Expect(1, 69311, '\P{^Is_Block=yezidi}', "");
    Expect(0, 69312, '\p{Is_Block=yezidi}', "");
    Expect(1, 69312, '\p{^Is_Block=yezidi}', "");
    Expect(1, 69312, '\P{Is_Block=yezidi}', "");
    Expect(0, 69312, '\P{^Is_Block=yezidi}', "");
    Expect(1, 69311, '\p{Is_Block= Yezidi}', "");
    Expect(0, 69311, '\p{^Is_Block= Yezidi}', "");
    Expect(0, 69311, '\P{Is_Block= Yezidi}', "");
    Expect(1, 69311, '\P{^Is_Block= Yezidi}', "");
    Expect(0, 69312, '\p{Is_Block= Yezidi}', "");
    Expect(1, 69312, '\p{^Is_Block= Yezidi}', "");
    Expect(1, 69312, '\P{Is_Block= Yezidi}', "");
    Expect(0, 69312, '\P{^Is_Block= Yezidi}', "");
    Error('\p{Is_Blk=:=-	YEZIDI}');
    Error('\P{Is_Blk=:=-	YEZIDI}');
    Expect(1, 69311, '\p{Is_Blk=yezidi}', "");
    Expect(0, 69311, '\p{^Is_Blk=yezidi}', "");
    Expect(0, 69311, '\P{Is_Blk=yezidi}', "");
    Expect(1, 69311, '\P{^Is_Blk=yezidi}', "");
    Expect(0, 69312, '\p{Is_Blk=yezidi}', "");
    Expect(1, 69312, '\p{^Is_Blk=yezidi}', "");
    Expect(1, 69312, '\P{Is_Blk=yezidi}', "");
    Expect(0, 69312, '\P{^Is_Blk=yezidi}', "");
    Expect(1, 69311, '\p{Is_Blk=--Yezidi}', "");
    Expect(0, 69311, '\p{^Is_Blk=--Yezidi}', "");
    Expect(0, 69311, '\P{Is_Blk=--Yezidi}', "");
    Expect(1, 69311, '\P{^Is_Blk=--Yezidi}', "");
    Expect(0, 69312, '\p{Is_Blk=--Yezidi}', "");
    Expect(1, 69312, '\p{^Is_Blk=--Yezidi}', "");
    Expect(1, 69312, '\P{Is_Blk=--Yezidi}', "");
    Expect(0, 69312, '\P{^Is_Blk=--Yezidi}', "");
    Error('\p{Block:yi_RADICALS/a/}');
    Error('\P{Block:yi_RADICALS/a/}');
    Expect(1, 42191, '\p{Block=:\AYi_Radicals\z:}', "");;
    Expect(0, 42192, '\p{Block=:\AYi_Radicals\z:}', "");;
    Expect(1, 42191, '\p{Block=yiradicals}', "");
    Expect(0, 42191, '\p{^Block=yiradicals}', "");
    Expect(0, 42191, '\P{Block=yiradicals}', "");
    Expect(1, 42191, '\P{^Block=yiradicals}', "");
    Expect(0, 42192, '\p{Block=yiradicals}', "");
    Expect(1, 42192, '\p{^Block=yiradicals}', "");
    Expect(1, 42192, '\P{Block=yiradicals}', "");
    Expect(0, 42192, '\P{^Block=yiradicals}', "");
    Expect(1, 42191, '\p{Block=:\Ayiradicals\z:}', "");;
    Expect(0, 42192, '\p{Block=:\Ayiradicals\z:}', "");;
    Expect(1, 42191, '\p{Block=YI_radicals}', "");
    Expect(0, 42191, '\p{^Block=YI_radicals}', "");
    Expect(0, 42191, '\P{Block=YI_radicals}', "");
    Expect(1, 42191, '\P{^Block=YI_radicals}', "");
    Expect(0, 42192, '\p{Block=YI_radicals}', "");
    Expect(1, 42192, '\p{^Block=YI_radicals}', "");
    Expect(1, 42192, '\P{Block=YI_radicals}', "");
    Expect(0, 42192, '\P{^Block=YI_radicals}', "");
    Error('\p{Blk=  yi_Radicals/a/}');
    Error('\P{Blk=  yi_Radicals/a/}');
    Expect(1, 42191, '\p{Blk=:\AYi_Radicals\z:}', "");;
    Expect(0, 42192, '\p{Blk=:\AYi_Radicals\z:}', "");;
    Expect(1, 42191, '\p{Blk=yiradicals}', "");
    Expect(0, 42191, '\p{^Blk=yiradicals}', "");
    Expect(0, 42191, '\P{Blk=yiradicals}', "");
    Expect(1, 42191, '\P{^Blk=yiradicals}', "");
    Expect(0, 42192, '\p{Blk=yiradicals}', "");
    Expect(1, 42192, '\p{^Blk=yiradicals}', "");
    Expect(1, 42192, '\P{Blk=yiradicals}', "");
    Expect(0, 42192, '\P{^Blk=yiradicals}', "");
    Expect(1, 42191, '\p{Blk=:\Ayiradicals\z:}', "");;
    Expect(0, 42192, '\p{Blk=:\Ayiradicals\z:}', "");;
    Expect(1, 42191, '\p{Blk=	-YI_RADICALS}', "");
    Expect(0, 42191, '\p{^Blk=	-YI_RADICALS}', "");
    Expect(0, 42191, '\P{Blk=	-YI_RADICALS}', "");
    Expect(1, 42191, '\P{^Blk=	-YI_RADICALS}', "");
    Expect(0, 42192, '\p{Blk=	-YI_RADICALS}', "");
    Expect(1, 42192, '\p{^Blk=	-YI_RADICALS}', "");
    Expect(1, 42192, '\P{Blk=	-YI_RADICALS}', "");
    Expect(0, 42192, '\P{^Blk=	-YI_RADICALS}', "");
    Error('\p{Is_Block:			YI_Radicals:=}');
    Error('\P{Is_Block:			YI_Radicals:=}');
    Expect(1, 42191, '\p{Is_Block=yiradicals}', "");
    Expect(0, 42191, '\p{^Is_Block=yiradicals}', "");
    Expect(0, 42191, '\P{Is_Block=yiradicals}', "");
    Expect(1, 42191, '\P{^Is_Block=yiradicals}', "");
    Expect(0, 42192, '\p{Is_Block=yiradicals}', "");
    Expect(1, 42192, '\p{^Is_Block=yiradicals}', "");
    Expect(1, 42192, '\P{Is_Block=yiradicals}', "");
    Expect(0, 42192, '\P{^Is_Block=yiradicals}', "");
    Expect(1, 42191, '\p{Is_Block=- Yi_Radicals}', "");
    Expect(0, 42191, '\p{^Is_Block=- Yi_Radicals}', "");
    Expect(0, 42191, '\P{Is_Block=- Yi_Radicals}', "");
    Expect(1, 42191, '\P{^Is_Block=- Yi_Radicals}', "");
    Expect(0, 42192, '\p{Is_Block=- Yi_Radicals}', "");
    Expect(1, 42192, '\p{^Is_Block=- Yi_Radicals}', "");
    Expect(1, 42192, '\P{Is_Block=- Yi_Radicals}', "");
    Expect(0, 42192, '\P{^Is_Block=- Yi_Radicals}', "");
    Error('\p{Is_Blk:   := Yi_RADICALS}');
    Error('\P{Is_Blk:   := Yi_RADICALS}');
    Expect(1, 42191, '\p{Is_Blk=yiradicals}', "");
    Expect(0, 42191, '\p{^Is_Blk=yiradicals}', "");
    Expect(0, 42191, '\P{Is_Blk=yiradicals}', "");
    Expect(1, 42191, '\P{^Is_Blk=yiradicals}', "");
    Expect(0, 42192, '\p{Is_Blk=yiradicals}', "");
    Expect(1, 42192, '\p{^Is_Blk=yiradicals}', "");
    Expect(1, 42192, '\P{Is_Blk=yiradicals}', "");
    Expect(0, 42192, '\P{^Is_Blk=yiradicals}', "");
    Expect(1, 42191, '\p{Is_Blk=- Yi_Radicals}', "");
    Expect(0, 42191, '\p{^Is_Blk=- Yi_Radicals}', "");
    Expect(0, 42191, '\P{Is_Blk=- Yi_Radicals}', "");
    Expect(1, 42191, '\P{^Is_Blk=- Yi_Radicals}', "");
    Expect(0, 42192, '\p{Is_Blk=- Yi_Radicals}', "");
    Expect(1, 42192, '\p{^Is_Blk=- Yi_Radicals}', "");
    Expect(1, 42192, '\P{Is_Blk=- Yi_Radicals}', "");
    Expect(0, 42192, '\P{^Is_Blk=- Yi_Radicals}', "");
    Error('\p{Block=/a/ 	Yi_Syllables}');
    Error('\P{Block=/a/ 	Yi_Syllables}');
    Expect(1, 42127, '\p{Block=:\AYi_Syllables\z:}', "");;
    Expect(0, 42128, '\p{Block=:\AYi_Syllables\z:}', "");;
    Expect(1, 42127, '\p{Block=yisyllables}', "");
    Expect(0, 42127, '\p{^Block=yisyllables}', "");
    Expect(0, 42127, '\P{Block=yisyllables}', "");
    Expect(1, 42127, '\P{^Block=yisyllables}', "");
    Expect(0, 42128, '\p{Block=yisyllables}', "");
    Expect(1, 42128, '\p{^Block=yisyllables}', "");
    Expect(1, 42128, '\P{Block=yisyllables}', "");
    Expect(0, 42128, '\P{^Block=yisyllables}', "");
    Expect(1, 42127, '\p{Block=:\Ayisyllables\z:}', "");;
    Expect(0, 42128, '\p{Block=:\Ayisyllables\z:}', "");;
    Expect(1, 42127, '\p{Block=_ yi_Syllables}', "");
    Expect(0, 42127, '\p{^Block=_ yi_Syllables}', "");
    Expect(0, 42127, '\P{Block=_ yi_Syllables}', "");
    Expect(1, 42127, '\P{^Block=_ yi_Syllables}', "");
    Expect(0, 42128, '\p{Block=_ yi_Syllables}', "");
    Expect(1, 42128, '\p{^Block=_ yi_Syllables}', "");
    Expect(1, 42128, '\P{Block=_ yi_Syllables}', "");
    Expect(0, 42128, '\P{^Block=_ yi_Syllables}', "");
    Error('\p{Blk=:=  yi_syllables}');
    Error('\P{Blk=:=  yi_syllables}');
    Expect(1, 42127, '\p{Blk=:\AYi_Syllables\z:}', "");;
    Expect(0, 42128, '\p{Blk=:\AYi_Syllables\z:}', "");;
    Expect(1, 42127, '\p{Blk=yisyllables}', "");
    Expect(0, 42127, '\p{^Blk=yisyllables}', "");
    Expect(0, 42127, '\P{Blk=yisyllables}', "");
    Expect(1, 42127, '\P{^Blk=yisyllables}', "");
    Expect(0, 42128, '\p{Blk=yisyllables}', "");
    Expect(1, 42128, '\p{^Blk=yisyllables}', "");
    Expect(1, 42128, '\P{Blk=yisyllables}', "");
    Expect(0, 42128, '\P{^Blk=yisyllables}', "");
    Expect(1, 42127, '\p{Blk=:\Ayisyllables\z:}', "");;
    Expect(0, 42128, '\p{Blk=:\Ayisyllables\z:}', "");;
    Expect(1, 42127, '\p{Blk=-_yi_syllables}', "");
    Expect(0, 42127, '\p{^Blk=-_yi_syllables}', "");
    Expect(0, 42127, '\P{Blk=-_yi_syllables}', "");
    Expect(1, 42127, '\P{^Blk=-_yi_syllables}', "");
    Expect(0, 42128, '\p{Blk=-_yi_syllables}', "");
    Expect(1, 42128, '\p{^Blk=-_yi_syllables}', "");
    Expect(1, 42128, '\P{Blk=-_yi_syllables}', "");
    Expect(0, 42128, '\P{^Blk=-_yi_syllables}', "");
    Error('\p{Is_Block=:=		YI_syllables}');
    Error('\P{Is_Block=:=		YI_syllables}');
    Expect(1, 42127, '\p{Is_Block=yisyllables}', "");
    Expect(0, 42127, '\p{^Is_Block=yisyllables}', "");
    Expect(0, 42127, '\P{Is_Block=yisyllables}', "");
    Expect(1, 42127, '\P{^Is_Block=yisyllables}', "");
    Expect(0, 42128, '\p{Is_Block=yisyllables}', "");
    Expect(1, 42128, '\p{^Is_Block=yisyllables}', "");
    Expect(1, 42128, '\P{Is_Block=yisyllables}', "");
    Expect(0, 42128, '\P{^Is_Block=yisyllables}', "");
    Expect(1, 42127, '\p{Is_Block=-Yi_SYLLABLES}', "");
    Expect(0, 42127, '\p{^Is_Block=-Yi_SYLLABLES}', "");
    Expect(0, 42127, '\P{Is_Block=-Yi_SYLLABLES}', "");
    Expect(1, 42127, '\P{^Is_Block=-Yi_SYLLABLES}', "");
    Expect(0, 42128, '\p{Is_Block=-Yi_SYLLABLES}', "");
    Expect(1, 42128, '\p{^Is_Block=-Yi_SYLLABLES}', "");
    Expect(1, 42128, '\P{Is_Block=-Yi_SYLLABLES}', "");
    Expect(0, 42128, '\P{^Is_Block=-Yi_SYLLABLES}', "");
    Error('\p{Is_Blk=-	yi_syllables/a/}');
    Error('\P{Is_Blk=-	yi_syllables/a/}');
    Expect(1, 42127, '\p{Is_Blk=yisyllables}', "");
    Expect(0, 42127, '\p{^Is_Blk=yisyllables}', "");
    Expect(0, 42127, '\P{Is_Blk=yisyllables}', "");
    Expect(1, 42127, '\P{^Is_Blk=yisyllables}', "");
    Expect(0, 42128, '\p{Is_Blk=yisyllables}', "");
    Expect(1, 42128, '\p{^Is_Blk=yisyllables}', "");
    Expect(1, 42128, '\P{Is_Blk=yisyllables}', "");
    Expect(0, 42128, '\P{^Is_Blk=yisyllables}', "");
    Expect(1, 42127, '\p{Is_Blk=__Yi_Syllables}', "");
    Expect(0, 42127, '\p{^Is_Blk=__Yi_Syllables}', "");
    Expect(0, 42127, '\P{Is_Blk=__Yi_Syllables}', "");
    Expect(1, 42127, '\P{^Is_Blk=__Yi_Syllables}', "");
    Expect(0, 42128, '\p{Is_Blk=__Yi_Syllables}', "");
    Expect(1, 42128, '\p{^Is_Blk=__Yi_Syllables}', "");
    Expect(1, 42128, '\P{Is_Blk=__Yi_Syllables}', "");
    Expect(0, 42128, '\P{^Is_Blk=__Yi_Syllables}', "");
    Error('\p{Block=/a/- Yijing_Hexagram_symbols}');
    Error('\P{Block=/a/- Yijing_Hexagram_symbols}');
    Expect(1, 19967, '\p{Block=:\AYijing_Hexagram_Symbols\z:}', "");;
    Expect(0, 19968, '\p{Block=:\AYijing_Hexagram_Symbols\z:}', "");;
    Expect(1, 19967, '\p{Block=yijinghexagramsymbols}', "");
    Expect(0, 19967, '\p{^Block=yijinghexagramsymbols}', "");
    Expect(0, 19967, '\P{Block=yijinghexagramsymbols}', "");
    Expect(1, 19967, '\P{^Block=yijinghexagramsymbols}', "");
    Expect(0, 19968, '\p{Block=yijinghexagramsymbols}', "");
    Expect(1, 19968, '\p{^Block=yijinghexagramsymbols}', "");
    Expect(1, 19968, '\P{Block=yijinghexagramsymbols}', "");
    Expect(0, 19968, '\P{^Block=yijinghexagramsymbols}', "");
    Expect(1, 19967, '\p{Block=:\Ayijinghexagramsymbols\z:}', "");;
    Expect(0, 19968, '\p{Block=:\Ayijinghexagramsymbols\z:}', "");;
    Expect(1, 19967, '\p{Block=__yijing_HEXAGRAM_SYMBOLS}', "");
    Expect(0, 19967, '\p{^Block=__yijing_HEXAGRAM_SYMBOLS}', "");
    Expect(0, 19967, '\P{Block=__yijing_HEXAGRAM_SYMBOLS}', "");
    Expect(1, 19967, '\P{^Block=__yijing_HEXAGRAM_SYMBOLS}', "");
    Expect(0, 19968, '\p{Block=__yijing_HEXAGRAM_SYMBOLS}', "");
    Expect(1, 19968, '\p{^Block=__yijing_HEXAGRAM_SYMBOLS}', "");
    Expect(1, 19968, '\P{Block=__yijing_HEXAGRAM_SYMBOLS}', "");
    Expect(0, 19968, '\P{^Block=__yijing_HEXAGRAM_SYMBOLS}', "");
    Error('\p{Blk=--Yijing/a/}');
    Error('\P{Blk=--Yijing/a/}');
    Expect(1, 19967, '\p{Blk=:\AYijing\z:}', "");;
    Expect(0, 19968, '\p{Blk=:\AYijing\z:}', "");;
    Expect(1, 19967, '\p{Blk=yijing}', "");
    Expect(0, 19967, '\p{^Blk=yijing}', "");
    Expect(0, 19967, '\P{Blk=yijing}', "");
    Expect(1, 19967, '\P{^Blk=yijing}', "");
    Expect(0, 19968, '\p{Blk=yijing}', "");
    Expect(1, 19968, '\p{^Blk=yijing}', "");
    Expect(1, 19968, '\P{Blk=yijing}', "");
    Expect(0, 19968, '\P{^Blk=yijing}', "");
    Expect(1, 19967, '\p{Blk=:\Ayijing\z:}', "");;
    Expect(0, 19968, '\p{Blk=:\Ayijing\z:}', "");;
    Expect(1, 19967, '\p{Blk=-Yijing}', "");
    Expect(0, 19967, '\p{^Blk=-Yijing}', "");
    Expect(0, 19967, '\P{Blk=-Yijing}', "");
    Expect(1, 19967, '\P{^Blk=-Yijing}', "");
    Expect(0, 19968, '\p{Blk=-Yijing}', "");
    Expect(1, 19968, '\p{^Blk=-Yijing}', "");
    Expect(1, 19968, '\P{Blk=-Yijing}', "");
    Expect(0, 19968, '\P{^Blk=-Yijing}', "");
    Error('\p{Is_Block=	 yijing_hexagram_Symbols/a/}');
    Error('\P{Is_Block=	 yijing_hexagram_Symbols/a/}');
    Expect(1, 19967, '\p{Is_Block=yijinghexagramsymbols}', "");
    Expect(0, 19967, '\p{^Is_Block=yijinghexagramsymbols}', "");
    Expect(0, 19967, '\P{Is_Block=yijinghexagramsymbols}', "");
    Expect(1, 19967, '\P{^Is_Block=yijinghexagramsymbols}', "");
    Expect(0, 19968, '\p{Is_Block=yijinghexagramsymbols}', "");
    Expect(1, 19968, '\p{^Is_Block=yijinghexagramsymbols}', "");
    Expect(1, 19968, '\P{Is_Block=yijinghexagramsymbols}', "");
    Expect(0, 19968, '\P{^Is_Block=yijinghexagramsymbols}', "");
    Expect(1, 19967, '\p{Is_Block=_	Yijing_Hexagram_symbols}', "");
    Expect(0, 19967, '\p{^Is_Block=_	Yijing_Hexagram_symbols}', "");
    Expect(0, 19967, '\P{Is_Block=_	Yijing_Hexagram_symbols}', "");
    Expect(1, 19967, '\P{^Is_Block=_	Yijing_Hexagram_symbols}', "");
    Expect(0, 19968, '\p{Is_Block=_	Yijing_Hexagram_symbols}', "");
    Expect(1, 19968, '\p{^Is_Block=_	Yijing_Hexagram_symbols}', "");
    Expect(1, 19968, '\P{Is_Block=_	Yijing_Hexagram_symbols}', "");
    Expect(0, 19968, '\P{^Is_Block=_	Yijing_Hexagram_symbols}', "");
    Error('\p{Is_Blk=-Yijing/a/}');
    Error('\P{Is_Blk=-Yijing/a/}');
    Expect(1, 19967, '\p{Is_Blk=yijing}', "");
    Expect(0, 19967, '\p{^Is_Blk=yijing}', "");
    Expect(0, 19967, '\P{Is_Blk=yijing}', "");
    Expect(1, 19967, '\P{^Is_Blk=yijing}', "");
    Expect(0, 19968, '\p{Is_Blk=yijing}', "");
    Expect(1, 19968, '\p{^Is_Blk=yijing}', "");
    Expect(1, 19968, '\P{Is_Blk=yijing}', "");
    Expect(0, 19968, '\P{^Is_Blk=yijing}', "");
    Expect(1, 19967, '\p{Is_Blk=	_yijing}', "");
    Expect(0, 19967, '\p{^Is_Blk=	_yijing}', "");
    Expect(0, 19967, '\P{Is_Blk=	_yijing}', "");
    Expect(1, 19967, '\P{^Is_Blk=	_yijing}', "");
    Expect(0, 19968, '\p{Is_Blk=	_yijing}', "");
    Expect(1, 19968, '\p{^Is_Blk=	_yijing}', "");
    Expect(1, 19968, '\P{Is_Blk=	_yijing}', "");
    Expect(0, 19968, '\P{^Is_Blk=	_yijing}', "");
    Error('\p{Block=:=	ZANABAZAR_square}');
    Error('\P{Block=:=	ZANABAZAR_square}');
    Expect(1, 72271, '\p{Block=:\AZanabazar_Square\z:}', "");;
    Expect(0, 72272, '\p{Block=:\AZanabazar_Square\z:}', "");;
    Expect(1, 72271, '\p{Block=zanabazarsquare}', "");
    Expect(0, 72271, '\p{^Block=zanabazarsquare}', "");
    Expect(0, 72271, '\P{Block=zanabazarsquare}', "");
    Expect(1, 72271, '\P{^Block=zanabazarsquare}', "");
    Expect(0, 72272, '\p{Block=zanabazarsquare}', "");
    Expect(1, 72272, '\p{^Block=zanabazarsquare}', "");
    Expect(1, 72272, '\P{Block=zanabazarsquare}', "");
    Expect(0, 72272, '\P{^Block=zanabazarsquare}', "");
    Expect(1, 72271, '\p{Block=:\Azanabazarsquare\z:}', "");;
    Expect(0, 72272, '\p{Block=:\Azanabazarsquare\z:}', "");;
    Expect(1, 72271, '\p{Block= -Zanabazar_square}', "");
    Expect(0, 72271, '\p{^Block= -Zanabazar_square}', "");
    Expect(0, 72271, '\P{Block= -Zanabazar_square}', "");
    Expect(1, 72271, '\P{^Block= -Zanabazar_square}', "");
    Expect(0, 72272, '\p{Block= -Zanabazar_square}', "");
    Expect(1, 72272, '\p{^Block= -Zanabazar_square}', "");
    Expect(1, 72272, '\P{Block= -Zanabazar_square}', "");
    Expect(0, 72272, '\P{^Block= -Zanabazar_square}', "");
    Error('\p{Blk:   	Zanabazar_Square:=}');
    Error('\P{Blk:   	Zanabazar_Square:=}');
    Expect(1, 72271, '\p{Blk=:\AZanabazar_Square\z:}', "");;
    Expect(0, 72272, '\p{Blk=:\AZanabazar_Square\z:}', "");;
    Expect(1, 72271, '\p{Blk=zanabazarsquare}', "");
    Expect(0, 72271, '\p{^Blk=zanabazarsquare}', "");
    Expect(0, 72271, '\P{Blk=zanabazarsquare}', "");
    Expect(1, 72271, '\P{^Blk=zanabazarsquare}', "");
    Expect(0, 72272, '\p{Blk=zanabazarsquare}', "");
    Expect(1, 72272, '\p{^Blk=zanabazarsquare}', "");
    Expect(1, 72272, '\P{Blk=zanabazarsquare}', "");
    Expect(0, 72272, '\P{^Blk=zanabazarsquare}', "");
    Expect(1, 72271, '\p{Blk=:\Azanabazarsquare\z:}', "");;
    Expect(0, 72272, '\p{Blk=:\Azanabazarsquare\z:}', "");;
    Expect(1, 72271, '\p{Blk=		Zanabazar_square}', "");
    Expect(0, 72271, '\p{^Blk=		Zanabazar_square}', "");
    Expect(0, 72271, '\P{Blk=		Zanabazar_square}', "");
    Expect(1, 72271, '\P{^Blk=		Zanabazar_square}', "");
    Expect(0, 72272, '\p{Blk=		Zanabazar_square}', "");
    Expect(1, 72272, '\p{^Blk=		Zanabazar_square}', "");
    Expect(1, 72272, '\P{Blk=		Zanabazar_square}', "");
    Expect(0, 72272, '\P{^Blk=		Zanabazar_square}', "");
    Error('\p{Is_Block=-:=Zanabazar_square}');
    Error('\P{Is_Block=-:=Zanabazar_square}');
    Expect(1, 72271, '\p{Is_Block=zanabazarsquare}', "");
    Expect(0, 72271, '\p{^Is_Block=zanabazarsquare}', "");
    Expect(0, 72271, '\P{Is_Block=zanabazarsquare}', "");
    Expect(1, 72271, '\P{^Is_Block=zanabazarsquare}', "");
    Expect(0, 72272, '\p{Is_Block=zanabazarsquare}', "");
    Expect(1, 72272, '\p{^Is_Block=zanabazarsquare}', "");
    Expect(1, 72272, '\P{Is_Block=zanabazarsquare}', "");
    Expect(0, 72272, '\P{^Is_Block=zanabazarsquare}', "");
    Expect(1, 72271, '\p{Is_Block=  Zanabazar_Square}', "");
    Expect(0, 72271, '\p{^Is_Block=  Zanabazar_Square}', "");
    Expect(0, 72271, '\P{Is_Block=  Zanabazar_Square}', "");
    Expect(1, 72271, '\P{^Is_Block=  Zanabazar_Square}', "");
    Expect(0, 72272, '\p{Is_Block=  Zanabazar_Square}', "");
    Expect(1, 72272, '\p{^Is_Block=  Zanabazar_Square}', "");
    Expect(1, 72272, '\P{Is_Block=  Zanabazar_Square}', "");
    Expect(0, 72272, '\P{^Is_Block=  Zanabazar_Square}', "");
    Error('\p{Is_Blk= Zanabazar_Square:=}');
    Error('\P{Is_Blk= Zanabazar_Square:=}');
    Expect(1, 72271, '\p{Is_Blk=zanabazarsquare}', "");
    Expect(0, 72271, '\p{^Is_Blk=zanabazarsquare}', "");
    Expect(0, 72271, '\P{Is_Blk=zanabazarsquare}', "");
    Expect(1, 72271, '\P{^Is_Blk=zanabazarsquare}', "");
    Expect(0, 72272, '\p{Is_Blk=zanabazarsquare}', "");
    Expect(1, 72272, '\p{^Is_Blk=zanabazarsquare}', "");
    Expect(1, 72272, '\P{Is_Blk=zanabazarsquare}', "");
    Expect(0, 72272, '\P{^Is_Blk=zanabazarsquare}', "");
    Expect(1, 72271, '\p{Is_Blk:   _-zanabazar_SQUARE}', "");
    Expect(0, 72271, '\p{^Is_Blk:   _-zanabazar_SQUARE}', "");
    Expect(0, 72271, '\P{Is_Blk:   _-zanabazar_SQUARE}', "");
    Expect(1, 72271, '\P{^Is_Blk:   _-zanabazar_SQUARE}', "");
    Expect(0, 72272, '\p{Is_Blk:   _-zanabazar_SQUARE}', "");
    Expect(1, 72272, '\p{^Is_Blk:   _-zanabazar_SQUARE}', "");
    Expect(1, 72272, '\P{Is_Blk:   _-zanabazar_SQUARE}', "");
    Expect(0, 72272, '\P{^Is_Blk:   _-zanabazar_SQUARE}', "");
    Error('\p{bidimirroringglyph}');
    Error('\P{bidimirroringglyph}');
    Error('\p{bmg}');
    Error('\P{bmg}');
    Error('\p{bidipairedbracket}');
    Error('\P{bidipairedbracket}');
    Error('\p{bpb}');
    Error('\P{bpb}');
    Error('\p{bidipairedbrackettype}');
    Error('\P{bidipairedbrackettype}');
    Error('\p{bpt}');
    Error('\P{bpt}');
    Error('\p{Bidi_Paired_Bracket_Type=/a/_close}');
    Error('\P{Bidi_Paired_Bracket_Type=/a/_close}');
    Expect(1, 65379, '\p{Bidi_Paired_Bracket_Type=:\AClose\z:}', "");;
    Expect(0, 65380, '\p{Bidi_Paired_Bracket_Type=:\AClose\z:}', "");;
    Expect(1, 65379, '\p{Bidi_Paired_Bracket_Type=close}', "");
    Expect(0, 65379, '\p{^Bidi_Paired_Bracket_Type=close}', "");
    Expect(0, 65379, '\P{Bidi_Paired_Bracket_Type=close}', "");
    Expect(1, 65379, '\P{^Bidi_Paired_Bracket_Type=close}', "");
    Expect(0, 65380, '\p{Bidi_Paired_Bracket_Type=close}', "");
    Expect(1, 65380, '\p{^Bidi_Paired_Bracket_Type=close}', "");
    Expect(1, 65380, '\P{Bidi_Paired_Bracket_Type=close}', "");
    Expect(0, 65380, '\P{^Bidi_Paired_Bracket_Type=close}', "");
    Expect(1, 65379, '\p{Bidi_Paired_Bracket_Type=:\Aclose\z:}', "");;
    Expect(0, 65380, '\p{Bidi_Paired_Bracket_Type=:\Aclose\z:}', "");;
    Expect(1, 65379, '\p{Bidi_Paired_Bracket_Type=_Close}', "");
    Expect(0, 65379, '\p{^Bidi_Paired_Bracket_Type=_Close}', "");
    Expect(0, 65379, '\P{Bidi_Paired_Bracket_Type=_Close}', "");
    Expect(1, 65379, '\P{^Bidi_Paired_Bracket_Type=_Close}', "");
    Expect(0, 65380, '\p{Bidi_Paired_Bracket_Type=_Close}', "");
    Expect(1, 65380, '\p{^Bidi_Paired_Bracket_Type=_Close}', "");
    Expect(1, 65380, '\P{Bidi_Paired_Bracket_Type=_Close}', "");
    Expect(0, 65380, '\P{^Bidi_Paired_Bracket_Type=_Close}', "");
    Error('\p{Bpt: -C:=}');
    Error('\P{Bpt: -C:=}');
    Expect(1, 65379, '\p{Bpt=:\AC\z:}', "");;
    Expect(0, 65380, '\p{Bpt=:\AC\z:}', "");;
    Expect(1, 65379, '\p{Bpt=c}', "");
    Expect(0, 65379, '\p{^Bpt=c}', "");
    Expect(0, 65379, '\P{Bpt=c}', "");
    Expect(1, 65379, '\P{^Bpt=c}', "");
    Expect(0, 65380, '\p{Bpt=c}', "");
    Expect(1, 65380, '\p{^Bpt=c}', "");
    Expect(1, 65380, '\P{Bpt=c}', "");
    Expect(0, 65380, '\P{^Bpt=c}', "");
    Expect(1, 65379, '\p{Bpt=:\Ac\z:}', "");;
    Expect(0, 65380, '\p{Bpt=:\Ac\z:}', "");;
    Expect(1, 65379, '\p{Bpt=_-C}', "");
    Expect(0, 65379, '\p{^Bpt=_-C}', "");
    Expect(0, 65379, '\P{Bpt=_-C}', "");
    Expect(1, 65379, '\P{^Bpt=_-C}', "");
    Expect(0, 65380, '\p{Bpt=_-C}', "");
    Expect(1, 65380, '\p{^Bpt=_-C}', "");
    Expect(1, 65380, '\P{Bpt=_-C}', "");
    Expect(0, 65380, '\P{^Bpt=_-C}', "");
    Error('\p{Is_Bidi_Paired_Bracket_Type:		/a/Close}');
    Error('\P{Is_Bidi_Paired_Bracket_Type:		/a/Close}');
    Expect(1, 65379, '\p{Is_Bidi_Paired_Bracket_Type=close}', "");
    Expect(0, 65379, '\p{^Is_Bidi_Paired_Bracket_Type=close}', "");
    Expect(0, 65379, '\P{Is_Bidi_Paired_Bracket_Type=close}', "");
    Expect(1, 65379, '\P{^Is_Bidi_Paired_Bracket_Type=close}', "");
    Expect(0, 65380, '\p{Is_Bidi_Paired_Bracket_Type=close}', "");
    Expect(1, 65380, '\p{^Is_Bidi_Paired_Bracket_Type=close}', "");
    Expect(1, 65380, '\P{Is_Bidi_Paired_Bracket_Type=close}', "");
    Expect(0, 65380, '\P{^Is_Bidi_Paired_Bracket_Type=close}', "");
    Expect(1, 65379, '\p{Is_Bidi_Paired_Bracket_Type=-Close}', "");
    Expect(0, 65379, '\p{^Is_Bidi_Paired_Bracket_Type=-Close}', "");
    Expect(0, 65379, '\P{Is_Bidi_Paired_Bracket_Type=-Close}', "");
    Expect(1, 65379, '\P{^Is_Bidi_Paired_Bracket_Type=-Close}', "");
    Expect(0, 65380, '\p{Is_Bidi_Paired_Bracket_Type=-Close}', "");
    Expect(1, 65380, '\p{^Is_Bidi_Paired_Bracket_Type=-Close}', "");
    Expect(1, 65380, '\P{Is_Bidi_Paired_Bracket_Type=-Close}', "");
    Expect(0, 65380, '\P{^Is_Bidi_Paired_Bracket_Type=-Close}', "");
    Error('\p{Is_Bpt= /a/c}');
    Error('\P{Is_Bpt= /a/c}');
    Expect(1, 65379, '\p{Is_Bpt=c}', "");
    Expect(0, 65379, '\p{^Is_Bpt=c}', "");
    Expect(0, 65379, '\P{Is_Bpt=c}', "");
    Expect(1, 65379, '\P{^Is_Bpt=c}', "");
    Expect(0, 65380, '\p{Is_Bpt=c}', "");
    Expect(1, 65380, '\p{^Is_Bpt=c}', "");
    Expect(1, 65380, '\P{Is_Bpt=c}', "");
    Expect(0, 65380, '\P{^Is_Bpt=c}', "");
    Expect(1, 65379, '\p{Is_Bpt=	 C}', "");
    Expect(0, 65379, '\p{^Is_Bpt=	 C}', "");
    Expect(0, 65379, '\P{Is_Bpt=	 C}', "");
    Expect(1, 65379, '\P{^Is_Bpt=	 C}', "");
    Expect(0, 65380, '\p{Is_Bpt=	 C}', "");
    Expect(1, 65380, '\p{^Is_Bpt=	 C}', "");
    Expect(1, 65380, '\P{Is_Bpt=	 C}', "");
    Expect(0, 65380, '\P{^Is_Bpt=	 C}', "");
    Error('\p{Bidi_Paired_Bracket_Type:   -_NONE/a/}');
    Error('\P{Bidi_Paired_Bracket_Type:   -_NONE/a/}');
    Expect(1, 65380, '\p{Bidi_Paired_Bracket_Type=:\ANone\z:}', "");;
    Expect(0, 65379, '\p{Bidi_Paired_Bracket_Type=:\ANone\z:}', "");;
    Expect(1, 65380, '\p{Bidi_Paired_Bracket_Type=none}', "");
    Expect(0, 65380, '\p{^Bidi_Paired_Bracket_Type=none}', "");
    Expect(0, 65380, '\P{Bidi_Paired_Bracket_Type=none}', "");
    Expect(1, 65380, '\P{^Bidi_Paired_Bracket_Type=none}', "");
    Expect(0, 65379, '\p{Bidi_Paired_Bracket_Type=none}', "");
    Expect(1, 65379, '\p{^Bidi_Paired_Bracket_Type=none}', "");
    Expect(1, 65379, '\P{Bidi_Paired_Bracket_Type=none}', "");
    Expect(0, 65379, '\P{^Bidi_Paired_Bracket_Type=none}', "");
    Expect(1, 65380, '\p{Bidi_Paired_Bracket_Type=:\Anone\z:}', "");;
    Expect(0, 65379, '\p{Bidi_Paired_Bracket_Type=:\Anone\z:}', "");;
    Expect(1, 65380, '\p{Bidi_Paired_Bracket_Type:	-None}', "");
    Expect(0, 65380, '\p{^Bidi_Paired_Bracket_Type:	-None}', "");
    Expect(0, 65380, '\P{Bidi_Paired_Bracket_Type:	-None}', "");
    Expect(1, 65380, '\P{^Bidi_Paired_Bracket_Type:	-None}', "");
    Expect(0, 65379, '\p{Bidi_Paired_Bracket_Type:	-None}', "");
    Expect(1, 65379, '\p{^Bidi_Paired_Bracket_Type:	-None}', "");
    Expect(1, 65379, '\P{Bidi_Paired_Bracket_Type:	-None}', "");
    Expect(0, 65379, '\P{^Bidi_Paired_Bracket_Type:	-None}', "");
    Error('\p{Bpt=_/a/N}');
    Error('\P{Bpt=_/a/N}');
    Expect(1, 65380, '\p{Bpt=:\AN\z:}', "");;
    Expect(0, 65379, '\p{Bpt=:\AN\z:}', "");;
    Expect(1, 65380, '\p{Bpt=n}', "");
    Expect(0, 65380, '\p{^Bpt=n}', "");
    Expect(0, 65380, '\P{Bpt=n}', "");
    Expect(1, 65380, '\P{^Bpt=n}', "");
    Expect(0, 65379, '\p{Bpt=n}', "");
    Expect(1, 65379, '\p{^Bpt=n}', "");
    Expect(1, 65379, '\P{Bpt=n}', "");
    Expect(0, 65379, '\P{^Bpt=n}', "");
    Expect(1, 65380, '\p{Bpt=:\An\z:}', "");;
    Expect(0, 65379, '\p{Bpt=:\An\z:}', "");;
    Expect(1, 65380, '\p{Bpt:_-n}', "");
    Expect(0, 65380, '\p{^Bpt:_-n}', "");
    Expect(0, 65380, '\P{Bpt:_-n}', "");
    Expect(1, 65380, '\P{^Bpt:_-n}', "");
    Expect(0, 65379, '\p{Bpt:_-n}', "");
    Expect(1, 65379, '\p{^Bpt:_-n}', "");
    Expect(1, 65379, '\P{Bpt:_-n}', "");
    Expect(0, 65379, '\P{^Bpt:_-n}', "");
    Error('\p{Is_Bidi_Paired_Bracket_Type=	 NONE/a/}');
    Error('\P{Is_Bidi_Paired_Bracket_Type=	 NONE/a/}');
    Expect(1, 65380, '\p{Is_Bidi_Paired_Bracket_Type=none}', "");
    Expect(0, 65380, '\p{^Is_Bidi_Paired_Bracket_Type=none}', "");
    Expect(0, 65380, '\P{Is_Bidi_Paired_Bracket_Type=none}', "");
    Expect(1, 65380, '\P{^Is_Bidi_Paired_Bracket_Type=none}', "");
    Expect(0, 65379, '\p{Is_Bidi_Paired_Bracket_Type=none}', "");
    Expect(1, 65379, '\p{^Is_Bidi_Paired_Bracket_Type=none}', "");
    Expect(1, 65379, '\P{Is_Bidi_Paired_Bracket_Type=none}', "");
    Expect(0, 65379, '\P{^Is_Bidi_Paired_Bracket_Type=none}', "");
    Expect(1, 65380, '\p{Is_Bidi_Paired_Bracket_Type=_None}', "");
    Expect(0, 65380, '\p{^Is_Bidi_Paired_Bracket_Type=_None}', "");
    Expect(0, 65380, '\P{Is_Bidi_Paired_Bracket_Type=_None}', "");
    Expect(1, 65380, '\P{^Is_Bidi_Paired_Bracket_Type=_None}', "");
    Expect(0, 65379, '\p{Is_Bidi_Paired_Bracket_Type=_None}', "");
    Expect(1, 65379, '\p{^Is_Bidi_Paired_Bracket_Type=_None}', "");
    Expect(1, 65379, '\P{Is_Bidi_Paired_Bracket_Type=_None}', "");
    Expect(0, 65379, '\P{^Is_Bidi_Paired_Bracket_Type=_None}', "");
    Error('\p{Is_Bpt=/a/_-n}');
    Error('\P{Is_Bpt=/a/_-n}');
    Expect(1, 65380, '\p{Is_Bpt=n}', "");
    Expect(0, 65380, '\p{^Is_Bpt=n}', "");
    Expect(0, 65380, '\P{Is_Bpt=n}', "");
    Expect(1, 65380, '\P{^Is_Bpt=n}', "");
    Expect(0, 65379, '\p{Is_Bpt=n}', "");
    Expect(1, 65379, '\p{^Is_Bpt=n}', "");
    Expect(1, 65379, '\P{Is_Bpt=n}', "");
    Expect(0, 65379, '\P{^Is_Bpt=n}', "");
    Expect(1, 65380, '\p{Is_Bpt=_n}', "");
    Expect(0, 65380, '\p{^Is_Bpt=_n}', "");
    Expect(0, 65380, '\P{Is_Bpt=_n}', "");
    Expect(1, 65380, '\P{^Is_Bpt=_n}', "");
    Expect(0, 65379, '\p{Is_Bpt=_n}', "");
    Expect(1, 65379, '\p{^Is_Bpt=_n}', "");
    Expect(1, 65379, '\P{Is_Bpt=_n}', "");
    Expect(0, 65379, '\P{^Is_Bpt=_n}', "");
    Error('\p{Bidi_Paired_Bracket_Type=:=_ Open}');
    Error('\P{Bidi_Paired_Bracket_Type=:=_ Open}');
    Expect(1, 65378, '\p{Bidi_Paired_Bracket_Type=:\AOpen\z:}', "");;
    Expect(0, 65379, '\p{Bidi_Paired_Bracket_Type=:\AOpen\z:}', "");;
    Expect(1, 65378, '\p{Bidi_Paired_Bracket_Type=open}', "");
    Expect(0, 65378, '\p{^Bidi_Paired_Bracket_Type=open}', "");
    Expect(0, 65378, '\P{Bidi_Paired_Bracket_Type=open}', "");
    Expect(1, 65378, '\P{^Bidi_Paired_Bracket_Type=open}', "");
    Expect(0, 65379, '\p{Bidi_Paired_Bracket_Type=open}', "");
    Expect(1, 65379, '\p{^Bidi_Paired_Bracket_Type=open}', "");
    Expect(1, 65379, '\P{Bidi_Paired_Bracket_Type=open}', "");
    Expect(0, 65379, '\P{^Bidi_Paired_Bracket_Type=open}', "");
    Expect(1, 65378, '\p{Bidi_Paired_Bracket_Type=:\Aopen\z:}', "");;
    Expect(0, 65379, '\p{Bidi_Paired_Bracket_Type=:\Aopen\z:}', "");;
    Expect(1, 65378, '\p{Bidi_Paired_Bracket_Type:   _Open}', "");
    Expect(0, 65378, '\p{^Bidi_Paired_Bracket_Type:   _Open}', "");
    Expect(0, 65378, '\P{Bidi_Paired_Bracket_Type:   _Open}', "");
    Expect(1, 65378, '\P{^Bidi_Paired_Bracket_Type:   _Open}', "");
    Expect(0, 65379, '\p{Bidi_Paired_Bracket_Type:   _Open}', "");
    Expect(1, 65379, '\p{^Bidi_Paired_Bracket_Type:   _Open}', "");
    Expect(1, 65379, '\P{Bidi_Paired_Bracket_Type:   _Open}', "");
    Expect(0, 65379, '\P{^Bidi_Paired_Bracket_Type:   _Open}', "");
    Error('\p{Bpt=-:=o}');
    Error('\P{Bpt=-:=o}');
    Expect(1, 65378, '\p{Bpt=:\AO\z:}', "");;
    Expect(0, 65379, '\p{Bpt=:\AO\z:}', "");;
    Expect(1, 65378, '\p{Bpt=o}', "");
    Expect(0, 65378, '\p{^Bpt=o}', "");
    Expect(0, 65378, '\P{Bpt=o}', "");
    Expect(1, 65378, '\P{^Bpt=o}', "");
    Expect(0, 65379, '\p{Bpt=o}', "");
    Expect(1, 65379, '\p{^Bpt=o}', "");
    Expect(1, 65379, '\P{Bpt=o}', "");
    Expect(0, 65379, '\P{^Bpt=o}', "");
    Expect(1, 65378, '\p{Bpt=:\Ao\z:}', "");;
    Expect(0, 65379, '\p{Bpt=:\Ao\z:}', "");;
    Expect(1, 65378, '\p{Bpt= _O}', "");
    Expect(0, 65378, '\p{^Bpt= _O}', "");
    Expect(0, 65378, '\P{Bpt= _O}', "");
    Expect(1, 65378, '\P{^Bpt= _O}', "");
    Expect(0, 65379, '\p{Bpt= _O}', "");
    Expect(1, 65379, '\p{^Bpt= _O}', "");
    Expect(1, 65379, '\P{Bpt= _O}', "");
    Expect(0, 65379, '\P{^Bpt= _O}', "");
    Error('\p{Is_Bidi_Paired_Bracket_Type=-:=Open}');
    Error('\P{Is_Bidi_Paired_Bracket_Type=-:=Open}');
    Expect(1, 65378, '\p{Is_Bidi_Paired_Bracket_Type=open}', "");
    Expect(0, 65378, '\p{^Is_Bidi_Paired_Bracket_Type=open}', "");
    Expect(0, 65378, '\P{Is_Bidi_Paired_Bracket_Type=open}', "");
    Expect(1, 65378, '\P{^Is_Bidi_Paired_Bracket_Type=open}', "");
    Expect(0, 65379, '\p{Is_Bidi_Paired_Bracket_Type=open}', "");
    Expect(1, 65379, '\p{^Is_Bidi_Paired_Bracket_Type=open}', "");
    Expect(1, 65379, '\P{Is_Bidi_Paired_Bracket_Type=open}', "");
    Expect(0, 65379, '\P{^Is_Bidi_Paired_Bracket_Type=open}', "");
    Expect(1, 65378, '\p{Is_Bidi_Paired_Bracket_Type:	- Open}', "");
    Expect(0, 65378, '\p{^Is_Bidi_Paired_Bracket_Type:	- Open}', "");
    Expect(0, 65378, '\P{Is_Bidi_Paired_Bracket_Type:	- Open}', "");
    Expect(1, 65378, '\P{^Is_Bidi_Paired_Bracket_Type:	- Open}', "");
    Expect(0, 65379, '\p{Is_Bidi_Paired_Bracket_Type:	- Open}', "");
    Expect(1, 65379, '\p{^Is_Bidi_Paired_Bracket_Type:	- Open}', "");
    Expect(1, 65379, '\P{Is_Bidi_Paired_Bracket_Type:	- Open}', "");
    Expect(0, 65379, '\P{^Is_Bidi_Paired_Bracket_Type:	- Open}', "");
    Error('\p{Is_Bpt=_	o:=}');
    Error('\P{Is_Bpt=_	o:=}');
    Expect(1, 65378, '\p{Is_Bpt=o}', "");
    Expect(0, 65378, '\p{^Is_Bpt=o}', "");
    Expect(0, 65378, '\P{Is_Bpt=o}', "");
    Expect(1, 65378, '\P{^Is_Bpt=o}', "");
    Expect(0, 65379, '\p{Is_Bpt=o}', "");
    Expect(1, 65379, '\p{^Is_Bpt=o}', "");
    Expect(1, 65379, '\P{Is_Bpt=o}', "");
    Expect(0, 65379, '\P{^Is_Bpt=o}', "");
    Expect(1, 65378, '\p{Is_Bpt=- o}', "");
    Expect(0, 65378, '\p{^Is_Bpt=- o}', "");
    Expect(0, 65378, '\P{Is_Bpt=- o}', "");
    Expect(1, 65378, '\P{^Is_Bpt=- o}', "");
    Expect(0, 65379, '\p{Is_Bpt=- o}', "");
    Expect(1, 65379, '\p{^Is_Bpt=- o}', "");
    Expect(1, 65379, '\P{Is_Bpt=- o}', "");
    Expect(0, 65379, '\P{^Is_Bpt=- o}', "");
    Error('\p{Cased=:=	 no}');
    Error('\P{Cased=:=	 no}');
    Expect(1, 127370, '\p{Cased=:\ANo\z:}', "");;
    Expect(0, 127369, '\p{Cased=:\ANo\z:}', "");;
    Expect(1, 127370, '\p{Cased=no}', "");
    Expect(0, 127370, '\p{^Cased=no}', "");
    Expect(0, 127370, '\P{Cased=no}', "");
    Expect(1, 127370, '\P{^Cased=no}', "");
    Expect(0, 127369, '\p{Cased=no}', "");
    Expect(1, 127369, '\p{^Cased=no}', "");
    Expect(1, 127369, '\P{Cased=no}', "");
    Expect(0, 127369, '\P{^Cased=no}', "");
    Expect(1, 127370, '\p{Cased=:\Ano\z:}', "");;
    Expect(0, 127369, '\p{Cased=:\Ano\z:}', "");;
    Expect(1, 127370, '\p{Cased=_	NO}', "");
    Expect(0, 127370, '\p{^Cased=_	NO}', "");
    Expect(0, 127370, '\P{Cased=_	NO}', "");
    Expect(1, 127370, '\P{^Cased=_	NO}', "");
    Expect(0, 127369, '\p{Cased=_	NO}', "");
    Expect(1, 127369, '\p{^Cased=_	NO}', "");
    Expect(1, 127369, '\P{Cased=_	NO}', "");
    Expect(0, 127369, '\P{^Cased=_	NO}', "");
    Error('\p{Is_Cased=_N:=}');
    Error('\P{Is_Cased=_N:=}');
    Expect(1, 127370, '\p{Is_Cased=n}', "");
    Expect(0, 127370, '\p{^Is_Cased=n}', "");
    Expect(0, 127370, '\P{Is_Cased=n}', "");
    Expect(1, 127370, '\P{^Is_Cased=n}', "");
    Expect(0, 127369, '\p{Is_Cased=n}', "");
    Expect(1, 127369, '\p{^Is_Cased=n}', "");
    Expect(1, 127369, '\P{Is_Cased=n}', "");
    Expect(0, 127369, '\P{^Is_Cased=n}', "");
    Expect(1, 127370, '\p{Is_Cased=	N}', "");
    Expect(0, 127370, '\p{^Is_Cased=	N}', "");
    Expect(0, 127370, '\P{Is_Cased=	N}', "");
    Expect(1, 127370, '\P{^Is_Cased=	N}', "");
    Expect(0, 127369, '\p{Is_Cased=	N}', "");
    Expect(1, 127369, '\p{^Is_Cased=	N}', "");
    Expect(1, 127369, '\P{Is_Cased=	N}', "");
    Expect(0, 127369, '\P{^Is_Cased=	N}', "");
    Error('\p{Cased:   /a/_	F}');
    Error('\P{Cased:   /a/_	F}');
    Expect(1, 127370, '\p{Cased=:\AF\z:}', "");;
    Expect(0, 127369, '\p{Cased=:\AF\z:}', "");;
    Expect(1, 127370, '\p{Cased=f}', "");
    Expect(0, 127370, '\p{^Cased=f}', "");
    Expect(0, 127370, '\P{Cased=f}', "");
    Expect(1, 127370, '\P{^Cased=f}', "");
    Expect(0, 127369, '\p{Cased=f}', "");
    Expect(1, 127369, '\p{^Cased=f}', "");
    Expect(1, 127369, '\P{Cased=f}', "");
    Expect(0, 127369, '\P{^Cased=f}', "");
    Expect(1, 127370, '\p{Cased=:\Af\z:}', "");;
    Expect(0, 127369, '\p{Cased=:\Af\z:}', "");;
    Expect(1, 127370, '\p{Cased=F}', "");
    Expect(0, 127370, '\p{^Cased=F}', "");
    Expect(0, 127370, '\P{Cased=F}', "");
    Expect(1, 127370, '\P{^Cased=F}', "");
    Expect(0, 127369, '\p{Cased=F}', "");
    Expect(1, 127369, '\p{^Cased=F}', "");
    Expect(1, 127369, '\P{Cased=F}', "");
    Expect(0, 127369, '\P{^Cased=F}', "");
    Error('\p{Is_Cased= /a/FALSE}');
    Error('\P{Is_Cased= /a/FALSE}');
    Expect(1, 127370, '\p{Is_Cased=false}', "");
    Expect(0, 127370, '\p{^Is_Cased=false}', "");
    Expect(0, 127370, '\P{Is_Cased=false}', "");
    Expect(1, 127370, '\P{^Is_Cased=false}', "");
    Expect(0, 127369, '\p{Is_Cased=false}', "");
    Expect(1, 127369, '\p{^Is_Cased=false}', "");
    Expect(1, 127369, '\P{Is_Cased=false}', "");
    Expect(0, 127369, '\P{^Is_Cased=false}', "");
    Expect(1, 127370, '\p{Is_Cased=  False}', "");
    Expect(0, 127370, '\p{^Is_Cased=  False}', "");
    Expect(0, 127370, '\P{Is_Cased=  False}', "");
    Expect(1, 127370, '\P{^Is_Cased=  False}', "");
    Expect(0, 127369, '\p{Is_Cased=  False}', "");
    Expect(1, 127369, '\p{^Is_Cased=  False}', "");
    Expect(1, 127369, '\P{Is_Cased=  False}', "");
    Expect(0, 127369, '\P{^Is_Cased=  False}', "");
    Error('\p{Cased=:= yes}');
    Error('\P{Cased=:= yes}');
    Expect(1, 127369, '\p{Cased=:\AYes\z:}', "");;
    Expect(0, 127370, '\p{Cased=:\AYes\z:}', "");;
    Expect(1, 127369, '\p{Cased=yes}', "");
    Expect(0, 127369, '\p{^Cased=yes}', "");
    Expect(0, 127369, '\P{Cased=yes}', "");
    Expect(1, 127369, '\P{^Cased=yes}', "");
    Expect(0, 127370, '\p{Cased=yes}', "");
    Expect(1, 127370, '\p{^Cased=yes}', "");
    Expect(1, 127370, '\P{Cased=yes}', "");
    Expect(0, 127370, '\P{^Cased=yes}', "");
    Expect(1, 127369, '\p{Cased=:\Ayes\z:}', "");;
    Expect(0, 127370, '\p{Cased=:\Ayes\z:}', "");;
    Expect(1, 127369, '\p{Cased=	_yes}', "");
    Expect(0, 127369, '\p{^Cased=	_yes}', "");
    Expect(0, 127369, '\P{Cased=	_yes}', "");
    Expect(1, 127369, '\P{^Cased=	_yes}', "");
    Expect(0, 127370, '\p{Cased=	_yes}', "");
    Expect(1, 127370, '\p{^Cased=	_yes}', "");
    Expect(1, 127370, '\P{Cased=	_yes}', "");
    Expect(0, 127370, '\P{^Cased=	_yes}', "");
    Error('\p{Is_Cased:   :=--Y}');
    Error('\P{Is_Cased:   :=--Y}');
    Expect(1, 127369, '\p{Is_Cased=y}', "");
    Expect(0, 127369, '\p{^Is_Cased=y}', "");
    Expect(0, 127369, '\P{Is_Cased=y}', "");
    Expect(1, 127369, '\P{^Is_Cased=y}', "");
    Expect(0, 127370, '\p{Is_Cased=y}', "");
    Expect(1, 127370, '\p{^Is_Cased=y}', "");
    Expect(1, 127370, '\P{Is_Cased=y}', "");
    Expect(0, 127370, '\P{^Is_Cased=y}', "");
    Expect(1, 127369, '\p{Is_Cased=_Y}', "");
    Expect(0, 127369, '\p{^Is_Cased=_Y}', "");
    Expect(0, 127369, '\P{Is_Cased=_Y}', "");
    Expect(1, 127369, '\P{^Is_Cased=_Y}', "");
    Expect(0, 127370, '\p{Is_Cased=_Y}', "");
    Expect(1, 127370, '\p{^Is_Cased=_Y}', "");
    Expect(1, 127370, '\P{Is_Cased=_Y}', "");
    Expect(0, 127370, '\P{^Is_Cased=_Y}', "");
    Error('\p{Cased=:=T}');
    Error('\P{Cased=:=T}');
    Expect(1, 127369, '\p{Cased=:\AT\z:}', "");;
    Expect(0, 127370, '\p{Cased=:\AT\z:}', "");;
    Expect(1, 127369, '\p{Cased=t}', "");
    Expect(0, 127369, '\p{^Cased=t}', "");
    Expect(0, 127369, '\P{Cased=t}', "");
    Expect(1, 127369, '\P{^Cased=t}', "");
    Expect(0, 127370, '\p{Cased=t}', "");
    Expect(1, 127370, '\p{^Cased=t}', "");
    Expect(1, 127370, '\P{Cased=t}', "");
    Expect(0, 127370, '\P{^Cased=t}', "");
    Expect(1, 127369, '\p{Cased=:\At\z:}', "");;
    Expect(0, 127370, '\p{Cased=:\At\z:}', "");;
    Expect(1, 127369, '\p{Cased=_-T}', "");
    Expect(0, 127369, '\p{^Cased=_-T}', "");
    Expect(0, 127369, '\P{Cased=_-T}', "");
    Expect(1, 127369, '\P{^Cased=_-T}', "");
    Expect(0, 127370, '\p{Cased=_-T}', "");
    Expect(1, 127370, '\p{^Cased=_-T}', "");
    Expect(1, 127370, '\P{Cased=_-T}', "");
    Expect(0, 127370, '\P{^Cased=_-T}', "");
    Error('\p{Is_Cased=		True/a/}');
    Error('\P{Is_Cased=		True/a/}');
    Expect(1, 127369, '\p{Is_Cased=true}', "");
    Expect(0, 127369, '\p{^Is_Cased=true}', "");
    Expect(0, 127369, '\P{Is_Cased=true}', "");
    Expect(1, 127369, '\P{^Is_Cased=true}', "");
    Expect(0, 127370, '\p{Is_Cased=true}', "");
    Expect(1, 127370, '\p{^Is_Cased=true}', "");
    Expect(1, 127370, '\P{Is_Cased=true}', "");
    Expect(0, 127370, '\P{^Is_Cased=true}', "");
    Expect(1, 127369, '\p{Is_Cased=_ True}', "");
    Expect(0, 127369, '\p{^Is_Cased=_ True}', "");
    Expect(0, 127369, '\P{Is_Cased=_ True}', "");
    Expect(1, 127369, '\P{^Is_Cased=_ True}', "");
    Expect(0, 127370, '\p{Is_Cased=_ True}', "");
    Expect(1, 127370, '\p{^Is_Cased=_ True}', "");
    Expect(1, 127370, '\P{Is_Cased=_ True}', "");
    Expect(0, 127370, '\P{^Is_Cased=_ True}', "");
    Error('\p{canonicalcombiningclass}');
    Error('\P{canonicalcombiningclass}');
    Error('\p{ccc}');
    Error('\P{ccc}');
    Error('\p{Canonical_Combining_Class: :=	 Above}');
    Error('\P{Canonical_Combining_Class: :=	 Above}');
    Expect(1, 125257, '\p{Canonical_Combining_Class=:\AAbove\z:}', "");;
    Expect(0, 125258, '\p{Canonical_Combining_Class=:\AAbove\z:}', "");;
    Expect(1, 125257, '\p{Canonical_Combining_Class: above}', "");
    Expect(0, 125257, '\p{^Canonical_Combining_Class: above}', "");
    Expect(0, 125257, '\P{Canonical_Combining_Class: above}', "");
    Expect(1, 125257, '\P{^Canonical_Combining_Class: above}', "");
    Expect(0, 125258, '\p{Canonical_Combining_Class: above}', "");
    Expect(1, 125258, '\p{^Canonical_Combining_Class: above}', "");
    Expect(1, 125258, '\P{Canonical_Combining_Class: above}', "");
    Expect(0, 125258, '\P{^Canonical_Combining_Class: above}', "");
    Expect(1, 125257, '\p{Canonical_Combining_Class=:\Aabove\z:}', "");;
    Expect(0, 125258, '\p{Canonical_Combining_Class=:\Aabove\z:}', "");;
    Expect(1, 125257, '\p{Canonical_Combining_Class:_ Above}', "");
    Expect(0, 125257, '\p{^Canonical_Combining_Class:_ Above}', "");
    Expect(0, 125257, '\P{Canonical_Combining_Class:_ Above}', "");
    Expect(1, 125257, '\P{^Canonical_Combining_Class:_ Above}', "");
    Expect(0, 125258, '\p{Canonical_Combining_Class:_ Above}', "");
    Expect(1, 125258, '\p{^Canonical_Combining_Class:_ Above}', "");
    Expect(1, 125258, '\P{Canonical_Combining_Class:_ Above}', "");
    Expect(0, 125258, '\P{^Canonical_Combining_Class:_ Above}', "");
    Error('\p{Ccc=	a/a/}');
    Error('\P{Ccc=	a/a/}');
    Expect(1, 125257, '\p{Ccc=:\AA\z:}', "");;
    Expect(0, 125258, '\p{Ccc=:\AA\z:}', "");;
    Expect(1, 125257, '\p{Ccc=a}', "");
    Expect(0, 125257, '\p{^Ccc=a}', "");
    Expect(0, 125257, '\P{Ccc=a}', "");
    Expect(1, 125257, '\P{^Ccc=a}', "");
    Expect(0, 125258, '\p{Ccc=a}', "");
    Expect(1, 125258, '\p{^Ccc=a}', "");
    Expect(1, 125258, '\P{Ccc=a}', "");
    Expect(0, 125258, '\P{^Ccc=a}', "");
    Expect(1, 125257, '\p{Ccc=:\Aa\z:}', "");;
    Expect(0, 125258, '\p{Ccc=:\Aa\z:}', "");;
    Expect(1, 125257, '\p{Ccc=-	A}', "");
    Expect(0, 125257, '\p{^Ccc=-	A}', "");
    Expect(0, 125257, '\P{Ccc=-	A}', "");
    Expect(1, 125257, '\P{^Ccc=-	A}', "");
    Expect(0, 125258, '\p{Ccc=-	A}', "");
    Expect(1, 125258, '\p{^Ccc=-	A}', "");
    Expect(1, 125258, '\P{Ccc=-	A}', "");
    Expect(0, 125258, '\P{^Ccc=-	A}', "");
    Error('\p{Is_Canonical_Combining_Class=/a/ _+230}');
    Error('\P{Is_Canonical_Combining_Class=/a/ _+230}');
    Expect(1, 125257, '\p{Is_Canonical_Combining_Class=+0_0_0_0_0_2_30}', "");
    Expect(0, 125257, '\p{^Is_Canonical_Combining_Class=+0_0_0_0_0_2_30}', "");
    Expect(0, 125257, '\P{Is_Canonical_Combining_Class=+0_0_0_0_0_2_30}', "");
    Expect(1, 125257, '\P{^Is_Canonical_Combining_Class=+0_0_0_0_0_2_30}', "");
    Expect(0, 125258, '\p{Is_Canonical_Combining_Class=+0_0_0_0_0_2_30}', "");
    Expect(1, 125258, '\p{^Is_Canonical_Combining_Class=+0_0_0_0_0_2_30}', "");
    Expect(1, 125258, '\P{Is_Canonical_Combining_Class=+0_0_0_0_0_2_30}', "");
    Expect(0, 125258, '\P{^Is_Canonical_Combining_Class=+0_0_0_0_0_2_30}', "");
    Error('\p{Is_Ccc=/a/  Above}');
    Error('\P{Is_Ccc=/a/  Above}');
    Expect(1, 125257, '\p{Is_Ccc=above}', "");
    Expect(0, 125257, '\p{^Is_Ccc=above}', "");
    Expect(0, 125257, '\P{Is_Ccc=above}', "");
    Expect(1, 125257, '\P{^Is_Ccc=above}', "");
    Expect(0, 125258, '\p{Is_Ccc=above}', "");
    Expect(1, 125258, '\p{^Is_Ccc=above}', "");
    Expect(1, 125258, '\P{Is_Ccc=above}', "");
    Expect(0, 125258, '\P{^Is_Ccc=above}', "");
    Expect(1, 125257, '\p{Is_Ccc=  ABOVE}', "");
    Expect(0, 125257, '\p{^Is_Ccc=  ABOVE}', "");
    Expect(0, 125257, '\P{Is_Ccc=  ABOVE}', "");
    Expect(1, 125257, '\P{^Is_Ccc=  ABOVE}', "");
    Expect(0, 125258, '\p{Is_Ccc=  ABOVE}', "");
    Expect(1, 125258, '\p{^Is_Ccc=  ABOVE}', "");
    Expect(1, 125258, '\P{Is_Ccc=  ABOVE}', "");
    Expect(0, 125258, '\P{^Is_Ccc=  ABOVE}', "");
    Error('\p{Canonical_Combining_Class=_:=above_left}');
    Error('\P{Canonical_Combining_Class=_:=above_left}');
    Expect(1, 12331, '\p{Canonical_Combining_Class=:\AAbove_Left\z:}', "");;
    Expect(0, 12332, '\p{Canonical_Combining_Class=:\AAbove_Left\z:}', "");;
    Expect(1, 12331, '\p{Canonical_Combining_Class=aboveleft}', "");
    Expect(0, 12331, '\p{^Canonical_Combining_Class=aboveleft}', "");
    Expect(0, 12331, '\P{Canonical_Combining_Class=aboveleft}', "");
    Expect(1, 12331, '\P{^Canonical_Combining_Class=aboveleft}', "");
    Expect(0, 12332, '\p{Canonical_Combining_Class=aboveleft}', "");
    Expect(1, 12332, '\p{^Canonical_Combining_Class=aboveleft}', "");
    Expect(1, 12332, '\P{Canonical_Combining_Class=aboveleft}', "");
    Expect(0, 12332, '\P{^Canonical_Combining_Class=aboveleft}', "");
    Expect(1, 12331, '\p{Canonical_Combining_Class=:\Aaboveleft\z:}', "");;
    Expect(0, 12332, '\p{Canonical_Combining_Class=:\Aaboveleft\z:}', "");;
    Expect(1, 12331, '\p{Canonical_Combining_Class=  Above_Left}', "");
    Expect(0, 12331, '\p{^Canonical_Combining_Class=  Above_Left}', "");
    Expect(0, 12331, '\P{Canonical_Combining_Class=  Above_Left}', "");
    Expect(1, 12331, '\P{^Canonical_Combining_Class=  Above_Left}', "");
    Expect(0, 12332, '\p{Canonical_Combining_Class=  Above_Left}', "");
    Expect(1, 12332, '\p{^Canonical_Combining_Class=  Above_Left}', "");
    Expect(1, 12332, '\P{Canonical_Combining_Class=  Above_Left}', "");
    Expect(0, 12332, '\P{^Canonical_Combining_Class=  Above_Left}', "");
    Error('\p{Ccc= /a/al}');
    Error('\P{Ccc= /a/al}');
    Expect(1, 12331, '\p{Ccc=:\AAL\z:}', "");;
    Expect(0, 12332, '\p{Ccc=:\AAL\z:}', "");;
    Expect(1, 12331, '\p{Ccc=al}', "");
    Expect(0, 12331, '\p{^Ccc=al}', "");
    Expect(0, 12331, '\P{Ccc=al}', "");
    Expect(1, 12331, '\P{^Ccc=al}', "");
    Expect(0, 12332, '\p{Ccc=al}', "");
    Expect(1, 12332, '\p{^Ccc=al}', "");
    Expect(1, 12332, '\P{Ccc=al}', "");
    Expect(0, 12332, '\P{^Ccc=al}', "");
    Expect(1, 12331, '\p{Ccc=:\Aal\z:}', "");;
    Expect(0, 12332, '\p{Ccc=:\Aal\z:}', "");;
    Expect(1, 12331, '\p{Ccc=_	AL}', "");
    Expect(0, 12331, '\p{^Ccc=_	AL}', "");
    Expect(0, 12331, '\P{Ccc=_	AL}', "");
    Expect(1, 12331, '\P{^Ccc=_	AL}', "");
    Expect(0, 12332, '\p{Ccc=_	AL}', "");
    Expect(1, 12332, '\p{^Ccc=_	AL}', "");
    Expect(1, 12332, '\P{Ccc=_	AL}', "");
    Expect(0, 12332, '\P{^Ccc=_	AL}', "");
    Error('\p{Is_Canonical_Combining_Class=	+00_00_02_28/a/}');
    Error('\P{Is_Canonical_Combining_Class=	+00_00_02_28/a/}');
    Expect(1, 12331, '\p{Is_Canonical_Combining_Class=+0_0_0_0_0228}', "");
    Expect(0, 12331, '\p{^Is_Canonical_Combining_Class=+0_0_0_0_0228}', "");
    Expect(0, 12331, '\P{Is_Canonical_Combining_Class=+0_0_0_0_0228}', "");
    Expect(1, 12331, '\P{^Is_Canonical_Combining_Class=+0_0_0_0_0228}', "");
    Expect(0, 12332, '\p{Is_Canonical_Combining_Class=+0_0_0_0_0228}', "");
    Expect(1, 12332, '\p{^Is_Canonical_Combining_Class=+0_0_0_0_0228}', "");
    Expect(1, 12332, '\P{Is_Canonical_Combining_Class=+0_0_0_0_0228}', "");
    Expect(0, 12332, '\P{^Is_Canonical_Combining_Class=+0_0_0_0_0228}', "");
    Error('\p{Is_Ccc=-:=above_left}');
    Error('\P{Is_Ccc=-:=above_left}');
    Expect(1, 12331, '\p{Is_Ccc=aboveleft}', "");
    Expect(0, 12331, '\p{^Is_Ccc=aboveleft}', "");
    Expect(0, 12331, '\P{Is_Ccc=aboveleft}', "");
    Expect(1, 12331, '\P{^Is_Ccc=aboveleft}', "");
    Expect(0, 12332, '\p{Is_Ccc=aboveleft}', "");
    Expect(1, 12332, '\p{^Is_Ccc=aboveleft}', "");
    Expect(1, 12332, '\P{Is_Ccc=aboveleft}', "");
    Expect(0, 12332, '\P{^Is_Ccc=aboveleft}', "");
    Expect(1, 12331, '\p{Is_Ccc= -Above_Left}', "");
    Expect(0, 12331, '\p{^Is_Ccc= -Above_Left}', "");
    Expect(0, 12331, '\P{Is_Ccc= -Above_Left}', "");
    Expect(1, 12331, '\P{^Is_Ccc= -Above_Left}', "");
    Expect(0, 12332, '\p{Is_Ccc= -Above_Left}', "");
    Expect(1, 12332, '\p{^Is_Ccc= -Above_Left}', "");
    Expect(1, 12332, '\P{Is_Ccc= -Above_Left}', "");
    Expect(0, 12332, '\P{^Is_Ccc= -Above_Left}', "");
    Error('\p{Canonical_Combining_Class=	-Above_Right:=}');
    Error('\P{Canonical_Combining_Class=	-Above_Right:=}');
    Expect(1, 12332, '\p{Canonical_Combining_Class=:\AAbove_Right\z:}', "");;
    Expect(0, 12333, '\p{Canonical_Combining_Class=:\AAbove_Right\z:}', "");;
    Expect(1, 12332, '\p{Canonical_Combining_Class:	aboveright}', "");
    Expect(0, 12332, '\p{^Canonical_Combining_Class:	aboveright}', "");
    Expect(0, 12332, '\P{Canonical_Combining_Class:	aboveright}', "");
    Expect(1, 12332, '\P{^Canonical_Combining_Class:	aboveright}', "");
    Expect(0, 12333, '\p{Canonical_Combining_Class:	aboveright}', "");
    Expect(1, 12333, '\p{^Canonical_Combining_Class:	aboveright}', "");
    Expect(1, 12333, '\P{Canonical_Combining_Class:	aboveright}', "");
    Expect(0, 12333, '\P{^Canonical_Combining_Class:	aboveright}', "");
    Expect(1, 12332, '\p{Canonical_Combining_Class=:\Aaboveright\z:}', "");;
    Expect(0, 12333, '\p{Canonical_Combining_Class=:\Aaboveright\z:}', "");;
    Expect(1, 12332, '\p{Canonical_Combining_Class=--ABOVE_Right}', "");
    Expect(0, 12332, '\p{^Canonical_Combining_Class=--ABOVE_Right}', "");
    Expect(0, 12332, '\P{Canonical_Combining_Class=--ABOVE_Right}', "");
    Expect(1, 12332, '\P{^Canonical_Combining_Class=--ABOVE_Right}', "");
    Expect(0, 12333, '\p{Canonical_Combining_Class=--ABOVE_Right}', "");
    Expect(1, 12333, '\p{^Canonical_Combining_Class=--ABOVE_Right}', "");
    Expect(1, 12333, '\P{Canonical_Combining_Class=--ABOVE_Right}', "");
    Expect(0, 12333, '\P{^Canonical_Combining_Class=--ABOVE_Right}', "");
    Error('\p{Ccc=/a/  AR}');
    Error('\P{Ccc=/a/  AR}');
    Expect(1, 12332, '\p{Ccc=:\AAR\z:}', "");;
    Expect(0, 12333, '\p{Ccc=:\AAR\z:}', "");;
    Expect(1, 12332, '\p{Ccc=ar}', "");
    Expect(0, 12332, '\p{^Ccc=ar}', "");
    Expect(0, 12332, '\P{Ccc=ar}', "");
    Expect(1, 12332, '\P{^Ccc=ar}', "");
    Expect(0, 12333, '\p{Ccc=ar}', "");
    Expect(1, 12333, '\p{^Ccc=ar}', "");
    Expect(1, 12333, '\P{Ccc=ar}', "");
    Expect(0, 12333, '\P{^Ccc=ar}', "");
    Expect(1, 12332, '\p{Ccc=:\Aar\z:}', "");;
    Expect(0, 12333, '\p{Ccc=:\Aar\z:}', "");;
    Expect(1, 12332, '\p{Ccc=	_ar}', "");
    Expect(0, 12332, '\p{^Ccc=	_ar}', "");
    Expect(0, 12332, '\P{Ccc=	_ar}', "");
    Expect(1, 12332, '\P{^Ccc=	_ar}', "");
    Expect(0, 12333, '\p{Ccc=	_ar}', "");
    Expect(1, 12333, '\p{^Ccc=	_ar}', "");
    Expect(1, 12333, '\P{Ccc=	_ar}', "");
    Expect(0, 12333, '\P{^Ccc=	_ar}', "");
    Error('\p{Is_Canonical_Combining_Class=/a/-_000000000232}');
    Error('\P{Is_Canonical_Combining_Class=/a/-_000000000232}');
    Expect(1, 12332, '\p{Is_Canonical_Combining_Class=00_02_32}', "");
    Expect(0, 12332, '\p{^Is_Canonical_Combining_Class=00_02_32}', "");
    Expect(0, 12332, '\P{Is_Canonical_Combining_Class=00_02_32}', "");
    Expect(1, 12332, '\P{^Is_Canonical_Combining_Class=00_02_32}', "");
    Expect(0, 12333, '\p{Is_Canonical_Combining_Class=00_02_32}', "");
    Expect(1, 12333, '\p{^Is_Canonical_Combining_Class=00_02_32}', "");
    Expect(1, 12333, '\P{Is_Canonical_Combining_Class=00_02_32}', "");
    Expect(0, 12333, '\P{^Is_Canonical_Combining_Class=00_02_32}', "");
    Error('\p{Is_Ccc=-_Above_right/a/}');
    Error('\P{Is_Ccc=-_Above_right/a/}');
    Expect(1, 12332, '\p{Is_Ccc=aboveright}', "");
    Expect(0, 12332, '\p{^Is_Ccc=aboveright}', "");
    Expect(0, 12332, '\P{Is_Ccc=aboveright}', "");
    Expect(1, 12332, '\P{^Is_Ccc=aboveright}', "");
    Expect(0, 12333, '\p{Is_Ccc=aboveright}', "");
    Expect(1, 12333, '\p{^Is_Ccc=aboveright}', "");
    Expect(1, 12333, '\P{Is_Ccc=aboveright}', "");
    Expect(0, 12333, '\P{^Is_Ccc=aboveright}', "");
    Expect(1, 12332, '\p{Is_Ccc=	 above_RIGHT}', "");
    Expect(0, 12332, '\p{^Is_Ccc=	 above_RIGHT}', "");
    Expect(0, 12332, '\P{Is_Ccc=	 above_RIGHT}', "");
    Expect(1, 12332, '\P{^Is_Ccc=	 above_RIGHT}', "");
    Expect(0, 12333, '\p{Is_Ccc=	 above_RIGHT}', "");
    Expect(1, 12333, '\p{^Is_Ccc=	 above_RIGHT}', "");
    Expect(1, 12333, '\P{Is_Ccc=	 above_RIGHT}', "");
    Expect(0, 12333, '\P{^Is_Ccc=	 above_RIGHT}', "");
    Error('\p{Canonical_Combining_Class=:=--Attached_Above}');
    Error('\P{Canonical_Combining_Class=:=--Attached_Above}');
    Expect(1, 7630, '\p{Canonical_Combining_Class=:\AAttached_Above\z:}', "");;
    Expect(0, 7631, '\p{Canonical_Combining_Class=:\AAttached_Above\z:}', "");;
    Expect(1, 7630, '\p{Canonical_Combining_Class:attachedabove}', "");
    Expect(0, 7630, '\p{^Canonical_Combining_Class:attachedabove}', "");
    Expect(0, 7630, '\P{Canonical_Combining_Class:attachedabove}', "");
    Expect(1, 7630, '\P{^Canonical_Combining_Class:attachedabove}', "");
    Expect(0, 7631, '\p{Canonical_Combining_Class:attachedabove}', "");
    Expect(1, 7631, '\p{^Canonical_Combining_Class:attachedabove}', "");
    Expect(1, 7631, '\P{Canonical_Combining_Class:attachedabove}', "");
    Expect(0, 7631, '\P{^Canonical_Combining_Class:attachedabove}', "");
    Expect(1, 7630, '\p{Canonical_Combining_Class=:\Aattachedabove\z:}', "");;
    Expect(0, 7631, '\p{Canonical_Combining_Class=:\Aattachedabove\z:}', "");;
    Expect(1, 7630, '\p{Canonical_Combining_Class= ATTACHED_ABOVE}', "");
    Expect(0, 7630, '\p{^Canonical_Combining_Class= ATTACHED_ABOVE}', "");
    Expect(0, 7630, '\P{Canonical_Combining_Class= ATTACHED_ABOVE}', "");
    Expect(1, 7630, '\P{^Canonical_Combining_Class= ATTACHED_ABOVE}', "");
    Expect(0, 7631, '\p{Canonical_Combining_Class= ATTACHED_ABOVE}', "");
    Expect(1, 7631, '\p{^Canonical_Combining_Class= ATTACHED_ABOVE}', "");
    Expect(1, 7631, '\P{Canonical_Combining_Class= ATTACHED_ABOVE}', "");
    Expect(0, 7631, '\P{^Canonical_Combining_Class= ATTACHED_ABOVE}', "");
    Error('\p{Ccc= -ATA:=}');
    Error('\P{Ccc= -ATA:=}');
    Expect(1, 7630, '\p{Ccc=:\AATA\z:}', "");;
    Expect(0, 7631, '\p{Ccc=:\AATA\z:}', "");;
    Expect(1, 7630, '\p{Ccc=ata}', "");
    Expect(0, 7630, '\p{^Ccc=ata}', "");
    Expect(0, 7630, '\P{Ccc=ata}', "");
    Expect(1, 7630, '\P{^Ccc=ata}', "");
    Expect(0, 7631, '\p{Ccc=ata}', "");
    Expect(1, 7631, '\p{^Ccc=ata}', "");
    Expect(1, 7631, '\P{Ccc=ata}', "");
    Expect(0, 7631, '\P{^Ccc=ata}', "");
    Expect(1, 7630, '\p{Ccc=:\Aata\z:}', "");;
    Expect(0, 7631, '\p{Ccc=:\Aata\z:}', "");;
    Expect(1, 7630, '\p{Ccc=- ATA}', "");
    Expect(0, 7630, '\p{^Ccc=- ATA}', "");
    Expect(0, 7630, '\P{Ccc=- ATA}', "");
    Expect(1, 7630, '\P{^Ccc=- ATA}', "");
    Expect(0, 7631, '\p{Ccc=- ATA}', "");
    Expect(1, 7631, '\p{^Ccc=- ATA}', "");
    Expect(1, 7631, '\P{Ccc=- ATA}', "");
    Expect(0, 7631, '\P{^Ccc=- ATA}', "");
    Error('\p{Is_Canonical_Combining_Class=__0_0_0_0_2_14/a/}');
    Error('\P{Is_Canonical_Combining_Class=__0_0_0_0_2_14/a/}');
    Expect(1, 7630, '\p{Is_Canonical_Combining_Class=00214}', "");
    Expect(0, 7630, '\p{^Is_Canonical_Combining_Class=00214}', "");
    Expect(0, 7630, '\P{Is_Canonical_Combining_Class=00214}', "");
    Expect(1, 7630, '\P{^Is_Canonical_Combining_Class=00214}', "");
    Expect(0, 7631, '\p{Is_Canonical_Combining_Class=00214}', "");
    Expect(1, 7631, '\p{^Is_Canonical_Combining_Class=00214}', "");
    Expect(1, 7631, '\P{Is_Canonical_Combining_Class=00214}', "");
    Expect(0, 7631, '\P{^Is_Canonical_Combining_Class=00214}', "");
    Error('\p{Is_Ccc= /a/Attached_above}');
    Error('\P{Is_Ccc= /a/Attached_above}');
    Expect(1, 7630, '\p{Is_Ccc:attachedabove}', "");
    Expect(0, 7630, '\p{^Is_Ccc:attachedabove}', "");
    Expect(0, 7630, '\P{Is_Ccc:attachedabove}', "");
    Expect(1, 7630, '\P{^Is_Ccc:attachedabove}', "");
    Expect(0, 7631, '\p{Is_Ccc:attachedabove}', "");
    Expect(1, 7631, '\p{^Is_Ccc:attachedabove}', "");
    Expect(1, 7631, '\P{Is_Ccc:attachedabove}', "");
    Expect(0, 7631, '\P{^Is_Ccc:attachedabove}', "");
    Expect(1, 7630, '\p{Is_Ccc: 	-ATTACHED_Above}', "");
    Expect(0, 7630, '\p{^Is_Ccc: 	-ATTACHED_Above}', "");
    Expect(0, 7630, '\P{Is_Ccc: 	-ATTACHED_Above}', "");
    Expect(1, 7630, '\P{^Is_Ccc: 	-ATTACHED_Above}', "");
    Expect(0, 7631, '\p{Is_Ccc: 	-ATTACHED_Above}', "");
    Expect(1, 7631, '\p{^Is_Ccc: 	-ATTACHED_Above}', "");
    Expect(1, 7631, '\P{Is_Ccc: 	-ATTACHED_Above}', "");
    Expect(0, 7631, '\P{^Is_Ccc: 	-ATTACHED_Above}', "");
    Error('\p{Canonical_Combining_Class=/a/	Attached_Above_right}');
    Error('\P{Canonical_Combining_Class=/a/	Attached_Above_right}');
    Expect(1, 119154, '\p{Canonical_Combining_Class=:\AAttached_Above_Right\z:}', "");;
    Expect(0, 119155, '\p{Canonical_Combining_Class=:\AAttached_Above_Right\z:}', "");;
    Expect(1, 119154, '\p{Canonical_Combining_Class=attachedaboveright}', "");
    Expect(0, 119154, '\p{^Canonical_Combining_Class=attachedaboveright}', "");
    Expect(0, 119154, '\P{Canonical_Combining_Class=attachedaboveright}', "");
    Expect(1, 119154, '\P{^Canonical_Combining_Class=attachedaboveright}', "");
    Expect(0, 119155, '\p{Canonical_Combining_Class=attachedaboveright}', "");
    Expect(1, 119155, '\p{^Canonical_Combining_Class=attachedaboveright}', "");
    Expect(1, 119155, '\P{Canonical_Combining_Class=attachedaboveright}', "");
    Expect(0, 119155, '\P{^Canonical_Combining_Class=attachedaboveright}', "");
    Expect(1, 119154, '\p{Canonical_Combining_Class=:\Aattachedaboveright\z:}', "");;
    Expect(0, 119155, '\p{Canonical_Combining_Class=:\Aattachedaboveright\z:}', "");;
    Expect(1, 119154, '\p{Canonical_Combining_Class=	ATTACHED_above_right}', "");
    Expect(0, 119154, '\p{^Canonical_Combining_Class=	ATTACHED_above_right}', "");
    Expect(0, 119154, '\P{Canonical_Combining_Class=	ATTACHED_above_right}', "");
    Expect(1, 119154, '\P{^Canonical_Combining_Class=	ATTACHED_above_right}', "");
    Expect(0, 119155, '\p{Canonical_Combining_Class=	ATTACHED_above_right}', "");
    Expect(1, 119155, '\p{^Canonical_Combining_Class=	ATTACHED_above_right}', "");
    Expect(1, 119155, '\P{Canonical_Combining_Class=	ATTACHED_above_right}', "");
    Expect(0, 119155, '\P{^Canonical_Combining_Class=	ATTACHED_above_right}', "");
    Error('\p{Ccc=/a/		ATAR}');
    Error('\P{Ccc=/a/		ATAR}');
    Expect(1, 119154, '\p{Ccc=:\AATAR\z:}', "");;
    Expect(0, 119155, '\p{Ccc=:\AATAR\z:}', "");;
    Expect(1, 119154, '\p{Ccc=atar}', "");
    Expect(0, 119154, '\p{^Ccc=atar}', "");
    Expect(0, 119154, '\P{Ccc=atar}', "");
    Expect(1, 119154, '\P{^Ccc=atar}', "");
    Expect(0, 119155, '\p{Ccc=atar}', "");
    Expect(1, 119155, '\p{^Ccc=atar}', "");
    Expect(1, 119155, '\P{Ccc=atar}', "");
    Expect(0, 119155, '\P{^Ccc=atar}', "");
    Expect(1, 119154, '\p{Ccc=:\Aatar\z:}', "");;
    Expect(0, 119155, '\p{Ccc=:\Aatar\z:}', "");;
    Expect(1, 119154, '\p{Ccc:	 -atar}', "");
    Expect(0, 119154, '\p{^Ccc:	 -atar}', "");
    Expect(0, 119154, '\P{Ccc:	 -atar}', "");
    Expect(1, 119154, '\P{^Ccc:	 -atar}', "");
    Expect(0, 119155, '\p{Ccc:	 -atar}', "");
    Expect(1, 119155, '\p{^Ccc:	 -atar}', "");
    Expect(1, 119155, '\P{Ccc:	 -atar}', "");
    Expect(0, 119155, '\P{^Ccc:	 -atar}', "");
    Error('\p{Is_Canonical_Combining_Class= /a/00_21_6}');
    Error('\P{Is_Canonical_Combining_Class= /a/00_21_6}');
    Expect(1, 119154, '\p{Is_Canonical_Combining_Class=+216}', "");
    Expect(0, 119154, '\p{^Is_Canonical_Combining_Class=+216}', "");
    Expect(0, 119154, '\P{Is_Canonical_Combining_Class=+216}', "");
    Expect(1, 119154, '\P{^Is_Canonical_Combining_Class=+216}', "");
    Expect(0, 119155, '\p{Is_Canonical_Combining_Class=+216}', "");
    Expect(1, 119155, '\p{^Is_Canonical_Combining_Class=+216}', "");
    Expect(1, 119155, '\P{Is_Canonical_Combining_Class=+216}', "");
    Expect(0, 119155, '\P{^Is_Canonical_Combining_Class=+216}', "");
    Error('\p{Is_Ccc=	/a/attached_Above_Right}');
    Error('\P{Is_Ccc=	/a/attached_Above_Right}');
    Expect(1, 119154, '\p{Is_Ccc=attachedaboveright}', "");
    Expect(0, 119154, '\p{^Is_Ccc=attachedaboveright}', "");
    Expect(0, 119154, '\P{Is_Ccc=attachedaboveright}', "");
    Expect(1, 119154, '\P{^Is_Ccc=attachedaboveright}', "");
    Expect(0, 119155, '\p{Is_Ccc=attachedaboveright}', "");
    Expect(1, 119155, '\p{^Is_Ccc=attachedaboveright}', "");
    Expect(1, 119155, '\P{Is_Ccc=attachedaboveright}', "");
    Expect(0, 119155, '\P{^Is_Ccc=attachedaboveright}', "");
    Expect(1, 119154, '\p{Is_Ccc:	-	Attached_Above_Right}', "");
    Expect(0, 119154, '\p{^Is_Ccc:	-	Attached_Above_Right}', "");
    Expect(0, 119154, '\P{Is_Ccc:	-	Attached_Above_Right}', "");
    Expect(1, 119154, '\P{^Is_Ccc:	-	Attached_Above_Right}', "");
    Expect(0, 119155, '\p{Is_Ccc:	-	Attached_Above_Right}', "");
    Expect(1, 119155, '\p{^Is_Ccc:	-	Attached_Above_Right}', "");
    Expect(1, 119155, '\P{Is_Ccc:	-	Attached_Above_Right}', "");
    Expect(0, 119155, '\P{^Is_Ccc:	-	Attached_Above_Right}', "");
    Error('\p{Canonical_Combining_Class= 	attached_below:=}');
    Error('\P{Canonical_Combining_Class= 	attached_below:=}');
    Expect(1, 7632, '\p{Canonical_Combining_Class=:\AAttached_Below\z:}', "");;
    Expect(0, 7633, '\p{Canonical_Combining_Class=:\AAttached_Below\z:}', "");;
    Expect(1, 7632, '\p{Canonical_Combining_Class=attachedbelow}', "");
    Expect(0, 7632, '\p{^Canonical_Combining_Class=attachedbelow}', "");
    Expect(0, 7632, '\P{Canonical_Combining_Class=attachedbelow}', "");
    Expect(1, 7632, '\P{^Canonical_Combining_Class=attachedbelow}', "");
    Expect(0, 7633, '\p{Canonical_Combining_Class=attachedbelow}', "");
    Expect(1, 7633, '\p{^Canonical_Combining_Class=attachedbelow}', "");
    Expect(1, 7633, '\P{Canonical_Combining_Class=attachedbelow}', "");
    Expect(0, 7633, '\P{^Canonical_Combining_Class=attachedbelow}', "");
    Expect(1, 7632, '\p{Canonical_Combining_Class=:\Aattachedbelow\z:}', "");;
    Expect(0, 7633, '\p{Canonical_Combining_Class=:\Aattachedbelow\z:}', "");;
    Expect(1, 7632, '\p{Canonical_Combining_Class=_	Attached_BELOW}', "");
    Expect(0, 7632, '\p{^Canonical_Combining_Class=_	Attached_BELOW}', "");
    Expect(0, 7632, '\P{Canonical_Combining_Class=_	Attached_BELOW}', "");
    Expect(1, 7632, '\P{^Canonical_Combining_Class=_	Attached_BELOW}', "");
    Expect(0, 7633, '\p{Canonical_Combining_Class=_	Attached_BELOW}', "");
    Expect(1, 7633, '\p{^Canonical_Combining_Class=_	Attached_BELOW}', "");
    Expect(1, 7633, '\P{Canonical_Combining_Class=_	Attached_BELOW}', "");
    Expect(0, 7633, '\P{^Canonical_Combining_Class=_	Attached_BELOW}', "");
    Error('\p{Ccc:-	ATB/a/}');
    Error('\P{Ccc:-	ATB/a/}');
    Expect(1, 7632, '\p{Ccc=:\AATB\z:}', "");;
    Expect(0, 7633, '\p{Ccc=:\AATB\z:}', "");;
    Expect(1, 7632, '\p{Ccc=atb}', "");
    Expect(0, 7632, '\p{^Ccc=atb}', "");
    Expect(0, 7632, '\P{Ccc=atb}', "");
    Expect(1, 7632, '\P{^Ccc=atb}', "");
    Expect(0, 7633, '\p{Ccc=atb}', "");
    Expect(1, 7633, '\p{^Ccc=atb}', "");
    Expect(1, 7633, '\P{Ccc=atb}', "");
    Expect(0, 7633, '\P{^Ccc=atb}', "");
    Expect(1, 7632, '\p{Ccc=:\Aatb\z:}', "");;
    Expect(0, 7633, '\p{Ccc=:\Aatb\z:}', "");;
    Expect(1, 7632, '\p{Ccc=	ATB}', "");
    Expect(0, 7632, '\p{^Ccc=	ATB}', "");
    Expect(0, 7632, '\P{Ccc=	ATB}', "");
    Expect(1, 7632, '\P{^Ccc=	ATB}', "");
    Expect(0, 7633, '\p{Ccc=	ATB}', "");
    Expect(1, 7633, '\p{^Ccc=	ATB}', "");
    Expect(1, 7633, '\P{Ccc=	ATB}', "");
    Expect(0, 7633, '\P{^Ccc=	ATB}', "");
    Error('\p{Is_Canonical_Combining_Class=:=202}');
    Error('\P{Is_Canonical_Combining_Class=:=202}');
    Expect(1, 7632, '\p{Is_Canonical_Combining_Class=+0000000202}', "");
    Expect(0, 7632, '\p{^Is_Canonical_Combining_Class=+0000000202}', "");
    Expect(0, 7632, '\P{Is_Canonical_Combining_Class=+0000000202}', "");
    Expect(1, 7632, '\P{^Is_Canonical_Combining_Class=+0000000202}', "");
    Expect(0, 7633, '\p{Is_Canonical_Combining_Class=+0000000202}', "");
    Expect(1, 7633, '\p{^Is_Canonical_Combining_Class=+0000000202}', "");
    Expect(1, 7633, '\P{Is_Canonical_Combining_Class=+0000000202}', "");
    Expect(0, 7633, '\P{^Is_Canonical_Combining_Class=+0000000202}', "");
    Error('\p{Is_Ccc= ATTACHED_Below:=}');
    Error('\P{Is_Ccc= ATTACHED_Below:=}');
    Expect(1, 7632, '\p{Is_Ccc=attachedbelow}', "");
    Expect(0, 7632, '\p{^Is_Ccc=attachedbelow}', "");
    Expect(0, 7632, '\P{Is_Ccc=attachedbelow}', "");
    Expect(1, 7632, '\P{^Is_Ccc=attachedbelow}', "");
    Expect(0, 7633, '\p{Is_Ccc=attachedbelow}', "");
    Expect(1, 7633, '\p{^Is_Ccc=attachedbelow}', "");
    Expect(1, 7633, '\P{Is_Ccc=attachedbelow}', "");
    Expect(0, 7633, '\P{^Is_Ccc=attachedbelow}', "");
    Expect(1, 7632, '\p{Is_Ccc=-ATTACHED_below}', "");
    Expect(0, 7632, '\p{^Is_Ccc=-ATTACHED_below}', "");
    Expect(0, 7632, '\P{Is_Ccc=-ATTACHED_below}', "");
    Expect(1, 7632, '\P{^Is_Ccc=-ATTACHED_below}', "");
    Expect(0, 7633, '\p{Is_Ccc=-ATTACHED_below}', "");
    Expect(1, 7633, '\p{^Is_Ccc=-ATTACHED_below}', "");
    Expect(1, 7633, '\P{Is_Ccc=-ATTACHED_below}', "");
    Expect(0, 7633, '\P{^Is_Ccc=-ATTACHED_below}', "");
    Error('\p{Canonical_Combining_Class=:=Attached_below_Left}');
    Error('\P{Canonical_Combining_Class=:=Attached_below_Left}');
    Expect(0, 1, '\p{Canonical_Combining_Class=:\AAttached_Below_Left\z:}', "");;
    Expect(0, 1, '\p{Canonical_Combining_Class=attachedbelowleft}', "");
    Expect(1, 1, '\p{^Canonical_Combining_Class=attachedbelowleft}', "");
    Expect(1, 1, '\P{Canonical_Combining_Class=attachedbelowleft}', "");
    Expect(0, 1, '\P{^Canonical_Combining_Class=attachedbelowleft}', "");
    Expect(0, 1, '\p{Canonical_Combining_Class=:\Aattachedbelowleft\z:}', "");;
    Expect(0, 1, '\p{Canonical_Combining_Class=__attached_Below_left}', "");
    Expect(1, 1, '\p{^Canonical_Combining_Class=__attached_Below_left}', "");
    Expect(1, 1, '\P{Canonical_Combining_Class=__attached_Below_left}', "");
    Expect(0, 1, '\P{^Canonical_Combining_Class=__attached_Below_left}', "");
    Error('\p{Ccc=_ ATBL/a/}');
    Error('\P{Ccc=_ ATBL/a/}');
    Expect(0, 1, '\p{Ccc=:\AATBL\z:}', "");;
    Expect(0, 1, '\p{Ccc=atbl}', "");
    Expect(1, 1, '\p{^Ccc=atbl}', "");
    Expect(1, 1, '\P{Ccc=atbl}', "");
    Expect(0, 1, '\P{^Ccc=atbl}', "");
    Expect(0, 1, '\p{Ccc=:\Aatbl\z:}', "");;
    Expect(0, 1, '\p{Ccc= 	ATBL}', "");
    Expect(1, 1, '\p{^Ccc= 	ATBL}', "");
    Expect(1, 1, '\P{Ccc= 	ATBL}', "");
    Expect(0, 1, '\P{^Ccc= 	ATBL}', "");
    Error('\p{Is_Canonical_Combining_Class= -+0_0_0_0_0_0_200/a/}');
    Error('\P{Is_Canonical_Combining_Class= -+0_0_0_0_0_0_200/a/}');
    Expect(0, 1, '\p{Is_Canonical_Combining_Class=00_00_00_20_0}', "");
    Expect(1, 1, '\p{^Is_Canonical_Combining_Class=00_00_00_20_0}', "");
    Expect(1, 1, '\P{Is_Canonical_Combining_Class=00_00_00_20_0}', "");
    Expect(0, 1, '\P{^Is_Canonical_Combining_Class=00_00_00_20_0}', "");
    Error('\p{Is_Ccc=:= -Attached_Below_LEFT}');
    Error('\P{Is_Ccc=:= -Attached_Below_LEFT}');
    Expect(0, 1, '\p{Is_Ccc=attachedbelowleft}', "");
    Expect(1, 1, '\p{^Is_Ccc=attachedbelowleft}', "");
    Expect(1, 1, '\P{Is_Ccc=attachedbelowleft}', "");
    Expect(0, 1, '\P{^Is_Ccc=attachedbelowleft}', "");
    Expect(0, 1, '\p{Is_Ccc: 	ATTACHED_Below_LEFT}', "");
    Expect(1, 1, '\p{^Is_Ccc: 	ATTACHED_Below_LEFT}', "");
    Expect(1, 1, '\P{Is_Ccc: 	ATTACHED_Below_LEFT}', "");
    Expect(0, 1, '\P{^Is_Ccc: 	ATTACHED_Below_LEFT}', "");
    Error('\p{Canonical_Combining_Class=_below:=}');
    Error('\P{Canonical_Combining_Class=_below:=}');
    Expect(1, 125142, '\p{Canonical_Combining_Class=:\ABelow\z:}', "");;
    Expect(0, 125143, '\p{Canonical_Combining_Class=:\ABelow\z:}', "");;
    Expect(1, 125142, '\p{Canonical_Combining_Class=below}', "");
    Expect(0, 125142, '\p{^Canonical_Combining_Class=below}', "");
    Expect(0, 125142, '\P{Canonical_Combining_Class=below}', "");
    Expect(1, 125142, '\P{^Canonical_Combining_Class=below}', "");
    Expect(0, 125143, '\p{Canonical_Combining_Class=below}', "");
    Expect(1, 125143, '\p{^Canonical_Combining_Class=below}', "");
    Expect(1, 125143, '\P{Canonical_Combining_Class=below}', "");
    Expect(0, 125143, '\P{^Canonical_Combining_Class=below}', "");
    Expect(1, 125142, '\p{Canonical_Combining_Class=:\Abelow\z:}', "");;
    Expect(0, 125143, '\p{Canonical_Combining_Class=:\Abelow\z:}', "");;
    Expect(1, 125142, '\p{Canonical_Combining_Class=	-below}', "");
    Expect(0, 125142, '\p{^Canonical_Combining_Class=	-below}', "");
    Expect(0, 125142, '\P{Canonical_Combining_Class=	-below}', "");
    Expect(1, 125142, '\P{^Canonical_Combining_Class=	-below}', "");
    Expect(0, 125143, '\p{Canonical_Combining_Class=	-below}', "");
    Expect(1, 125143, '\p{^Canonical_Combining_Class=	-below}', "");
    Expect(1, 125143, '\P{Canonical_Combining_Class=	-below}', "");
    Expect(0, 125143, '\P{^Canonical_Combining_Class=	-below}', "");
    Error('\p{Ccc=/a/__B}');
    Error('\P{Ccc=/a/__B}');
    Expect(1, 125142, '\p{Ccc=:\AB\z:}', "");;
    Expect(0, 125143, '\p{Ccc=:\AB\z:}', "");;
    Expect(1, 125142, '\p{Ccc=b}', "");
    Expect(0, 125142, '\p{^Ccc=b}', "");
    Expect(0, 125142, '\P{Ccc=b}', "");
    Expect(1, 125142, '\P{^Ccc=b}', "");
    Expect(0, 125143, '\p{Ccc=b}', "");
    Expect(1, 125143, '\p{^Ccc=b}', "");
    Expect(1, 125143, '\P{Ccc=b}', "");
    Expect(0, 125143, '\P{^Ccc=b}', "");
    Expect(1, 125142, '\p{Ccc=:\Ab\z:}', "");;
    Expect(0, 125143, '\p{Ccc=:\Ab\z:}', "");;
    Expect(1, 125142, '\p{Ccc= B}', "");
    Expect(0, 125142, '\p{^Ccc= B}', "");
    Expect(0, 125142, '\P{Ccc= B}', "");
    Expect(1, 125142, '\P{^Ccc= B}', "");
    Expect(0, 125143, '\p{Ccc= B}', "");
    Expect(1, 125143, '\p{^Ccc= B}', "");
    Expect(1, 125143, '\P{Ccc= B}', "");
    Expect(0, 125143, '\P{^Ccc= B}', "");
    Error('\p{Is_Canonical_Combining_Class:	:=00000220}');
    Error('\P{Is_Canonical_Combining_Class:	:=00000220}');
    Expect(1, 125142, '\p{Is_Canonical_Combining_Class=+00220}', "");
    Expect(0, 125142, '\p{^Is_Canonical_Combining_Class=+00220}', "");
    Expect(0, 125142, '\P{Is_Canonical_Combining_Class=+00220}', "");
    Expect(1, 125142, '\P{^Is_Canonical_Combining_Class=+00220}', "");
    Expect(0, 125143, '\p{Is_Canonical_Combining_Class=+00220}', "");
    Expect(1, 125143, '\p{^Is_Canonical_Combining_Class=+00220}', "");
    Expect(1, 125143, '\P{Is_Canonical_Combining_Class=+00220}', "");
    Expect(0, 125143, '\P{^Is_Canonical_Combining_Class=+00220}', "");
    Error('\p{Is_Ccc= 	below/a/}');
    Error('\P{Is_Ccc= 	below/a/}');
    Expect(1, 125142, '\p{Is_Ccc: below}', "");
    Expect(0, 125142, '\p{^Is_Ccc: below}', "");
    Expect(0, 125142, '\P{Is_Ccc: below}', "");
    Expect(1, 125142, '\P{^Is_Ccc: below}', "");
    Expect(0, 125143, '\p{Is_Ccc: below}', "");
    Expect(1, 125143, '\p{^Is_Ccc: below}', "");
    Expect(1, 125143, '\P{Is_Ccc: below}', "");
    Expect(0, 125143, '\P{^Is_Ccc: below}', "");
    Expect(1, 125142, '\p{Is_Ccc= 	below}', "");
    Expect(0, 125142, '\p{^Is_Ccc= 	below}', "");
    Expect(0, 125142, '\P{Is_Ccc= 	below}', "");
    Expect(1, 125142, '\P{^Is_Ccc= 	below}', "");
    Expect(0, 125143, '\p{Is_Ccc= 	below}', "");
    Expect(1, 125143, '\p{^Is_Ccc= 	below}', "");
    Expect(1, 125143, '\P{Is_Ccc= 	below}', "");
    Expect(0, 125143, '\P{^Is_Ccc= 	below}', "");
    Error('\p{Canonical_Combining_Class= :=below_left}');
    Error('\P{Canonical_Combining_Class= :=below_left}');
    Expect(1, 12330, '\p{Canonical_Combining_Class=:\ABelow_Left\z:}', "");;
    Expect(0, 12331, '\p{Canonical_Combining_Class=:\ABelow_Left\z:}', "");;
    Expect(1, 12330, '\p{Canonical_Combining_Class=belowleft}', "");
    Expect(0, 12330, '\p{^Canonical_Combining_Class=belowleft}', "");
    Expect(0, 12330, '\P{Canonical_Combining_Class=belowleft}', "");
    Expect(1, 12330, '\P{^Canonical_Combining_Class=belowleft}', "");
    Expect(0, 12331, '\p{Canonical_Combining_Class=belowleft}', "");
    Expect(1, 12331, '\p{^Canonical_Combining_Class=belowleft}', "");
    Expect(1, 12331, '\P{Canonical_Combining_Class=belowleft}', "");
    Expect(0, 12331, '\P{^Canonical_Combining_Class=belowleft}', "");
    Expect(1, 12330, '\p{Canonical_Combining_Class=:\Abelowleft\z:}', "");;
    Expect(0, 12331, '\p{Canonical_Combining_Class=:\Abelowleft\z:}', "");;
    Expect(1, 12330, '\p{Canonical_Combining_Class=--Below_LEFT}', "");
    Expect(0, 12330, '\p{^Canonical_Combining_Class=--Below_LEFT}', "");
    Expect(0, 12330, '\P{Canonical_Combining_Class=--Below_LEFT}', "");
    Expect(1, 12330, '\P{^Canonical_Combining_Class=--Below_LEFT}', "");
    Expect(0, 12331, '\p{Canonical_Combining_Class=--Below_LEFT}', "");
    Expect(1, 12331, '\p{^Canonical_Combining_Class=--Below_LEFT}', "");
    Expect(1, 12331, '\P{Canonical_Combining_Class=--Below_LEFT}', "");
    Expect(0, 12331, '\P{^Canonical_Combining_Class=--Below_LEFT}', "");
    Error('\p{Ccc=_:=BL}');
    Error('\P{Ccc=_:=BL}');
    Expect(1, 12330, '\p{Ccc=:\ABL\z:}', "");;
    Expect(0, 12331, '\p{Ccc=:\ABL\z:}', "");;
    Expect(1, 12330, '\p{Ccc=bl}', "");
    Expect(0, 12330, '\p{^Ccc=bl}', "");
    Expect(0, 12330, '\P{Ccc=bl}', "");
    Expect(1, 12330, '\P{^Ccc=bl}', "");
    Expect(0, 12331, '\p{Ccc=bl}', "");
    Expect(1, 12331, '\p{^Ccc=bl}', "");
    Expect(1, 12331, '\P{Ccc=bl}', "");
    Expect(0, 12331, '\P{^Ccc=bl}', "");
    Expect(1, 12330, '\p{Ccc=:\Abl\z:}', "");;
    Expect(0, 12331, '\p{Ccc=:\Abl\z:}', "");;
    Expect(1, 12330, '\p{Ccc=-BL}', "");
    Expect(0, 12330, '\p{^Ccc=-BL}', "");
    Expect(0, 12330, '\P{Ccc=-BL}', "");
    Expect(1, 12330, '\P{^Ccc=-BL}', "");
    Expect(0, 12331, '\p{Ccc=-BL}', "");
    Expect(1, 12331, '\p{^Ccc=-BL}', "");
    Expect(1, 12331, '\P{Ccc=-BL}', "");
    Expect(0, 12331, '\P{^Ccc=-BL}', "");
    Error('\p{Is_Canonical_Combining_Class=- 0000000218/a/}');
    Error('\P{Is_Canonical_Combining_Class=- 0000000218/a/}');
    Expect(1, 12330, '\p{Is_Canonical_Combining_Class=+21_8}', "");
    Expect(0, 12330, '\p{^Is_Canonical_Combining_Class=+21_8}', "");
    Expect(0, 12330, '\P{Is_Canonical_Combining_Class=+21_8}', "");
    Expect(1, 12330, '\P{^Is_Canonical_Combining_Class=+21_8}', "");
    Expect(0, 12331, '\p{Is_Canonical_Combining_Class=+21_8}', "");
    Expect(1, 12331, '\p{^Is_Canonical_Combining_Class=+21_8}', "");
    Expect(1, 12331, '\P{Is_Canonical_Combining_Class=+21_8}', "");
    Expect(0, 12331, '\P{^Is_Canonical_Combining_Class=+21_8}', "");
    Error('\p{Is_Ccc=/a/	BELOW_left}');
    Error('\P{Is_Ccc=/a/	BELOW_left}');
    Expect(1, 12330, '\p{Is_Ccc=belowleft}', "");
    Expect(0, 12330, '\p{^Is_Ccc=belowleft}', "");
    Expect(0, 12330, '\P{Is_Ccc=belowleft}', "");
    Expect(1, 12330, '\P{^Is_Ccc=belowleft}', "");
    Expect(0, 12331, '\p{Is_Ccc=belowleft}', "");
    Expect(1, 12331, '\p{^Is_Ccc=belowleft}', "");
    Expect(1, 12331, '\P{Is_Ccc=belowleft}', "");
    Expect(0, 12331, '\P{^Is_Ccc=belowleft}', "");
    Expect(1, 12330, '\p{Is_Ccc=		BELOW_Left}', "");
    Expect(0, 12330, '\p{^Is_Ccc=		BELOW_Left}', "");
    Expect(0, 12330, '\P{Is_Ccc=		BELOW_Left}', "");
    Expect(1, 12330, '\P{^Is_Ccc=		BELOW_Left}', "");
    Expect(0, 12331, '\p{Is_Ccc=		BELOW_Left}', "");
    Expect(1, 12331, '\p{^Is_Ccc=		BELOW_Left}', "");
    Expect(1, 12331, '\P{Is_Ccc=		BELOW_Left}', "");
    Expect(0, 12331, '\P{^Is_Ccc=		BELOW_Left}', "");
    Error('\p{Canonical_Combining_Class=:= 	below_Right}');
    Error('\P{Canonical_Combining_Class=:= 	below_Right}');
    Expect(1, 12333, '\p{Canonical_Combining_Class=:\ABelow_Right\z:}', "");;
    Expect(0, 12334, '\p{Canonical_Combining_Class=:\ABelow_Right\z:}', "");;
    Expect(1, 12333, '\p{Canonical_Combining_Class=belowright}', "");
    Expect(0, 12333, '\p{^Canonical_Combining_Class=belowright}', "");
    Expect(0, 12333, '\P{Canonical_Combining_Class=belowright}', "");
    Expect(1, 12333, '\P{^Canonical_Combining_Class=belowright}', "");
    Expect(0, 12334, '\p{Canonical_Combining_Class=belowright}', "");
    Expect(1, 12334, '\p{^Canonical_Combining_Class=belowright}', "");
    Expect(1, 12334, '\P{Canonical_Combining_Class=belowright}', "");
    Expect(0, 12334, '\P{^Canonical_Combining_Class=belowright}', "");
    Expect(1, 12333, '\p{Canonical_Combining_Class=:\Abelowright\z:}', "");;
    Expect(0, 12334, '\p{Canonical_Combining_Class=:\Abelowright\z:}', "");;
    Expect(1, 12333, '\p{Canonical_Combining_Class=-_Below_right}', "");
    Expect(0, 12333, '\p{^Canonical_Combining_Class=-_Below_right}', "");
    Expect(0, 12333, '\P{Canonical_Combining_Class=-_Below_right}', "");
    Expect(1, 12333, '\P{^Canonical_Combining_Class=-_Below_right}', "");
    Expect(0, 12334, '\p{Canonical_Combining_Class=-_Below_right}', "");
    Expect(1, 12334, '\p{^Canonical_Combining_Class=-_Below_right}', "");
    Expect(1, 12334, '\P{Canonical_Combining_Class=-_Below_right}', "");
    Expect(0, 12334, '\P{^Canonical_Combining_Class=-_Below_right}', "");
    Error('\p{Ccc=	:=BR}');
    Error('\P{Ccc=	:=BR}');
    Expect(1, 12333, '\p{Ccc=:\ABR\z:}', "");;
    Expect(0, 12334, '\p{Ccc=:\ABR\z:}', "");;
    Expect(1, 12333, '\p{Ccc=br}', "");
    Expect(0, 12333, '\p{^Ccc=br}', "");
    Expect(0, 12333, '\P{Ccc=br}', "");
    Expect(1, 12333, '\P{^Ccc=br}', "");
    Expect(0, 12334, '\p{Ccc=br}', "");
    Expect(1, 12334, '\p{^Ccc=br}', "");
    Expect(1, 12334, '\P{Ccc=br}', "");
    Expect(0, 12334, '\P{^Ccc=br}', "");
    Expect(1, 12333, '\p{Ccc=:\Abr\z:}', "");;
    Expect(0, 12334, '\p{Ccc=:\Abr\z:}', "");;
    Expect(1, 12333, '\p{Ccc=- BR}', "");
    Expect(0, 12333, '\p{^Ccc=- BR}', "");
    Expect(0, 12333, '\P{Ccc=- BR}', "");
    Expect(1, 12333, '\P{^Ccc=- BR}', "");
    Expect(0, 12334, '\p{Ccc=- BR}', "");
    Expect(1, 12334, '\p{^Ccc=- BR}', "");
    Expect(1, 12334, '\P{Ccc=- BR}', "");
    Expect(0, 12334, '\P{^Ccc=- BR}', "");
    Error('\p{Is_Canonical_Combining_Class=:=+0_0_2_22}');
    Error('\P{Is_Canonical_Combining_Class=:=+0_0_2_22}');
    Expect(1, 12333, '\p{Is_Canonical_Combining_Class=0_0_0_0_0_0_0_0_0_2_22}', "");
    Expect(0, 12333, '\p{^Is_Canonical_Combining_Class=0_0_0_0_0_0_0_0_0_2_22}', "");
    Expect(0, 12333, '\P{Is_Canonical_Combining_Class=0_0_0_0_0_0_0_0_0_2_22}', "");
    Expect(1, 12333, '\P{^Is_Canonical_Combining_Class=0_0_0_0_0_0_0_0_0_2_22}', "");
    Expect(0, 12334, '\p{Is_Canonical_Combining_Class=0_0_0_0_0_0_0_0_0_2_22}', "");
    Expect(1, 12334, '\p{^Is_Canonical_Combining_Class=0_0_0_0_0_0_0_0_0_2_22}', "");
    Expect(1, 12334, '\P{Is_Canonical_Combining_Class=0_0_0_0_0_0_0_0_0_2_22}', "");
    Expect(0, 12334, '\P{^Is_Canonical_Combining_Class=0_0_0_0_0_0_0_0_0_2_22}', "");
    Error('\p{Is_Ccc=/a/below_RIGHT}');
    Error('\P{Is_Ccc=/a/below_RIGHT}');
    Expect(1, 12333, '\p{Is_Ccc=belowright}', "");
    Expect(0, 12333, '\p{^Is_Ccc=belowright}', "");
    Expect(0, 12333, '\P{Is_Ccc=belowright}', "");
    Expect(1, 12333, '\P{^Is_Ccc=belowright}', "");
    Expect(0, 12334, '\p{Is_Ccc=belowright}', "");
    Expect(1, 12334, '\p{^Is_Ccc=belowright}', "");
    Expect(1, 12334, '\P{Is_Ccc=belowright}', "");
    Expect(0, 12334, '\P{^Is_Ccc=belowright}', "");
    Expect(1, 12333, '\p{Is_Ccc=	Below_Right}', "");
    Expect(0, 12333, '\p{^Is_Ccc=	Below_Right}', "");
    Expect(0, 12333, '\P{Is_Ccc=	Below_Right}', "");
    Expect(1, 12333, '\P{^Is_Ccc=	Below_Right}', "");
    Expect(0, 12334, '\p{Is_Ccc=	Below_Right}', "");
    Expect(1, 12334, '\p{^Is_Ccc=	Below_Right}', "");
    Expect(1, 12334, '\P{Is_Ccc=	Below_Right}', "");
    Expect(0, 12334, '\P{^Is_Ccc=	Below_Right}', "");
    Error('\p{Canonical_Combining_Class=:=	ccc10}');
    Error('\P{Canonical_Combining_Class=:=	ccc10}');
    Expect(1, 1456, '\p{Canonical_Combining_Class=:\ACCC10\z:}', "");;
    Expect(0, 1457, '\p{Canonical_Combining_Class=:\ACCC10\z:}', "");;
    Expect(1, 1456, '\p{Canonical_Combining_Class=ccc10}', "");
    Expect(0, 1456, '\p{^Canonical_Combining_Class=ccc10}', "");
    Expect(0, 1456, '\P{Canonical_Combining_Class=ccc10}', "");
    Expect(1, 1456, '\P{^Canonical_Combining_Class=ccc10}', "");
    Expect(0, 1457, '\p{Canonical_Combining_Class=ccc10}', "");
    Expect(1, 1457, '\p{^Canonical_Combining_Class=ccc10}', "");
    Expect(1, 1457, '\P{Canonical_Combining_Class=ccc10}', "");
    Expect(0, 1457, '\P{^Canonical_Combining_Class=ccc10}', "");
    Expect(1, 1456, '\p{Canonical_Combining_Class=:\Accc10\z:}', "");;
    Expect(0, 1457, '\p{Canonical_Combining_Class=:\Accc10\z:}', "");;
    Expect(1, 1456, '\p{Canonical_Combining_Class:   		CCC10}', "");
    Expect(0, 1456, '\p{^Canonical_Combining_Class:   		CCC10}', "");
    Expect(0, 1456, '\P{Canonical_Combining_Class:   		CCC10}', "");
    Expect(1, 1456, '\P{^Canonical_Combining_Class:   		CCC10}', "");
    Expect(0, 1457, '\p{Canonical_Combining_Class:   		CCC10}', "");
    Expect(1, 1457, '\p{^Canonical_Combining_Class:   		CCC10}', "");
    Expect(1, 1457, '\P{Canonical_Combining_Class:   		CCC10}', "");
    Expect(0, 1457, '\P{^Canonical_Combining_Class:   		CCC10}', "");
    Error('\p{Ccc=:=  00000000010}');
    Error('\P{Ccc=:=  00000000010}');
    Expect(1, 1456, '\p{Ccc=:\A10\z:}', "");;
    Expect(0, 1457, '\p{Ccc=:\A10\z:}', "");;
    Expect(1, 1456, '\p{Ccc:10}', "");
    Expect(0, 1456, '\p{^Ccc:10}', "");
    Expect(0, 1456, '\P{Ccc:10}', "");
    Expect(1, 1456, '\P{^Ccc:10}', "");
    Expect(0, 1457, '\p{Ccc:10}', "");
    Expect(1, 1457, '\p{^Ccc:10}', "");
    Expect(1, 1457, '\P{Ccc:10}', "");
    Expect(0, 1457, '\P{^Ccc:10}', "");
    Error('\p{Is_Canonical_Combining_Class=_:=CCC10}');
    Error('\P{Is_Canonical_Combining_Class=_:=CCC10}');
    Expect(1, 1456, '\p{Is_Canonical_Combining_Class=ccc10}', "");
    Expect(0, 1456, '\p{^Is_Canonical_Combining_Class=ccc10}', "");
    Expect(0, 1456, '\P{Is_Canonical_Combining_Class=ccc10}', "");
    Expect(1, 1456, '\P{^Is_Canonical_Combining_Class=ccc10}', "");
    Expect(0, 1457, '\p{Is_Canonical_Combining_Class=ccc10}', "");
    Expect(1, 1457, '\p{^Is_Canonical_Combining_Class=ccc10}', "");
    Expect(1, 1457, '\P{Is_Canonical_Combining_Class=ccc10}', "");
    Expect(0, 1457, '\P{^Is_Canonical_Combining_Class=ccc10}', "");
    Expect(1, 1456, '\p{Is_Canonical_Combining_Class=__CCC10}', "");
    Expect(0, 1456, '\p{^Is_Canonical_Combining_Class=__CCC10}', "");
    Expect(0, 1456, '\P{Is_Canonical_Combining_Class=__CCC10}', "");
    Expect(1, 1456, '\P{^Is_Canonical_Combining_Class=__CCC10}', "");
    Expect(0, 1457, '\p{Is_Canonical_Combining_Class=__CCC10}', "");
    Expect(1, 1457, '\p{^Is_Canonical_Combining_Class=__CCC10}', "");
    Expect(1, 1457, '\P{Is_Canonical_Combining_Class=__CCC10}', "");
    Expect(0, 1457, '\P{^Is_Canonical_Combining_Class=__CCC10}', "");
    Error('\p{Is_Ccc=_+0010/a/}');
    Error('\P{Is_Ccc=_+0010/a/}');
    Expect(1, 1456, '\p{Is_Ccc:	00000000010}', "");
    Expect(0, 1456, '\p{^Is_Ccc:	00000000010}', "");
    Expect(0, 1456, '\P{Is_Ccc:	00000000010}', "");
    Expect(1, 1456, '\P{^Is_Ccc:	00000000010}', "");
    Expect(0, 1457, '\p{Is_Ccc:	00000000010}', "");
    Expect(1, 1457, '\p{^Is_Ccc:	00000000010}', "");
    Expect(1, 1457, '\P{Is_Ccc:	00000000010}', "");
    Expect(0, 1457, '\P{^Is_Ccc:	00000000010}', "");
    Error('\p{Canonical_Combining_Class=/a/ 	CCC103}');
    Error('\P{Canonical_Combining_Class=/a/ 	CCC103}');
    Expect(1, 3641, '\p{Canonical_Combining_Class=:\ACCC103\z:}', "");;
    Expect(0, 3642, '\p{Canonical_Combining_Class=:\ACCC103\z:}', "");;
    Expect(1, 3641, '\p{Canonical_Combining_Class=ccc103}', "");
    Expect(0, 3641, '\p{^Canonical_Combining_Class=ccc103}', "");
    Expect(0, 3641, '\P{Canonical_Combining_Class=ccc103}', "");
    Expect(1, 3641, '\P{^Canonical_Combining_Class=ccc103}', "");
    Expect(0, 3642, '\p{Canonical_Combining_Class=ccc103}', "");
    Expect(1, 3642, '\p{^Canonical_Combining_Class=ccc103}', "");
    Expect(1, 3642, '\P{Canonical_Combining_Class=ccc103}', "");
    Expect(0, 3642, '\P{^Canonical_Combining_Class=ccc103}', "");
    Expect(1, 3641, '\p{Canonical_Combining_Class=:\Accc103\z:}', "");;
    Expect(0, 3642, '\p{Canonical_Combining_Class=:\Accc103\z:}', "");;
    Expect(1, 3641, '\p{Canonical_Combining_Class:	_-CCC103}', "");
    Expect(0, 3641, '\p{^Canonical_Combining_Class:	_-CCC103}', "");
    Expect(0, 3641, '\P{Canonical_Combining_Class:	_-CCC103}', "");
    Expect(1, 3641, '\P{^Canonical_Combining_Class:	_-CCC103}', "");
    Expect(0, 3642, '\p{Canonical_Combining_Class:	_-CCC103}', "");
    Expect(1, 3642, '\p{^Canonical_Combining_Class:	_-CCC103}', "");
    Expect(1, 3642, '\P{Canonical_Combining_Class:	_-CCC103}', "");
    Expect(0, 3642, '\P{^Canonical_Combining_Class:	_-CCC103}', "");
    Error('\p{Ccc=:= +00000103}');
    Error('\P{Ccc=:= +00000103}');
    Expect(1, 3641, '\p{Ccc=:\A103\z:}', "");;
    Expect(0, 3642, '\p{Ccc=:\A103\z:}', "");;
    Expect(1, 3641, '\p{Ccc=0_0_0_0_0_0103}', "");
    Expect(0, 3641, '\p{^Ccc=0_0_0_0_0_0103}', "");
    Expect(0, 3641, '\P{Ccc=0_0_0_0_0_0103}', "");
    Expect(1, 3641, '\P{^Ccc=0_0_0_0_0_0103}', "");
    Expect(0, 3642, '\p{Ccc=0_0_0_0_0_0103}', "");
    Expect(1, 3642, '\p{^Ccc=0_0_0_0_0_0103}', "");
    Expect(1, 3642, '\P{Ccc=0_0_0_0_0_0103}', "");
    Expect(0, 3642, '\P{^Ccc=0_0_0_0_0_0103}', "");
    Error('\p{Is_Canonical_Combining_Class=_	CCC103/a/}');
    Error('\P{Is_Canonical_Combining_Class=_	CCC103/a/}');
    Expect(1, 3641, '\p{Is_Canonical_Combining_Class=ccc103}', "");
    Expect(0, 3641, '\p{^Is_Canonical_Combining_Class=ccc103}', "");
    Expect(0, 3641, '\P{Is_Canonical_Combining_Class=ccc103}', "");
    Expect(1, 3641, '\P{^Is_Canonical_Combining_Class=ccc103}', "");
    Expect(0, 3642, '\p{Is_Canonical_Combining_Class=ccc103}', "");
    Expect(1, 3642, '\p{^Is_Canonical_Combining_Class=ccc103}', "");
    Expect(1, 3642, '\P{Is_Canonical_Combining_Class=ccc103}', "");
    Expect(0, 3642, '\P{^Is_Canonical_Combining_Class=ccc103}', "");
    Expect(1, 3641, '\p{Is_Canonical_Combining_Class= CCC103}', "");
    Expect(0, 3641, '\p{^Is_Canonical_Combining_Class= CCC103}', "");
    Expect(0, 3641, '\P{Is_Canonical_Combining_Class= CCC103}', "");
    Expect(1, 3641, '\P{^Is_Canonical_Combining_Class= CCC103}', "");
    Expect(0, 3642, '\p{Is_Canonical_Combining_Class= CCC103}', "");
    Expect(1, 3642, '\p{^Is_Canonical_Combining_Class= CCC103}', "");
    Expect(1, 3642, '\P{Is_Canonical_Combining_Class= CCC103}', "");
    Expect(0, 3642, '\P{^Is_Canonical_Combining_Class= CCC103}', "");
    Error('\p{Is_Ccc:	-0_0_0_0_0_103:=}');
    Error('\P{Is_Ccc:	-0_0_0_0_0_103:=}');
    Expect(1, 3641, '\p{Is_Ccc=000103}', "");
    Expect(0, 3641, '\p{^Is_Ccc=000103}', "");
    Expect(0, 3641, '\P{Is_Ccc=000103}', "");
    Expect(1, 3641, '\P{^Is_Ccc=000103}', "");
    Expect(0, 3642, '\p{Is_Ccc=000103}', "");
    Expect(1, 3642, '\p{^Is_Ccc=000103}', "");
    Expect(1, 3642, '\P{Is_Ccc=000103}', "");
    Expect(0, 3642, '\P{^Is_Ccc=000103}', "");
    Error('\p{Canonical_Combining_Class=	:=CCC107}');
    Error('\P{Canonical_Combining_Class=	:=CCC107}');
    Expect(1, 3659, '\p{Canonical_Combining_Class=:\ACCC107\z:}', "");;
    Expect(0, 3660, '\p{Canonical_Combining_Class=:\ACCC107\z:}', "");;
    Expect(1, 3659, '\p{Canonical_Combining_Class=ccc107}', "");
    Expect(0, 3659, '\p{^Canonical_Combining_Class=ccc107}', "");
    Expect(0, 3659, '\P{Canonical_Combining_Class=ccc107}', "");
    Expect(1, 3659, '\P{^Canonical_Combining_Class=ccc107}', "");
    Expect(0, 3660, '\p{Canonical_Combining_Class=ccc107}', "");
    Expect(1, 3660, '\p{^Canonical_Combining_Class=ccc107}', "");
    Expect(1, 3660, '\P{Canonical_Combining_Class=ccc107}', "");
    Expect(0, 3660, '\P{^Canonical_Combining_Class=ccc107}', "");
    Expect(1, 3659, '\p{Canonical_Combining_Class=:\Accc107\z:}', "");;
    Expect(0, 3660, '\p{Canonical_Combining_Class=:\Accc107\z:}', "");;
    Expect(1, 3659, '\p{Canonical_Combining_Class=		CCC107}', "");
    Expect(0, 3659, '\p{^Canonical_Combining_Class=		CCC107}', "");
    Expect(0, 3659, '\P{Canonical_Combining_Class=		CCC107}', "");
    Expect(1, 3659, '\P{^Canonical_Combining_Class=		CCC107}', "");
    Expect(0, 3660, '\p{Canonical_Combining_Class=		CCC107}', "");
    Expect(1, 3660, '\p{^Canonical_Combining_Class=		CCC107}', "");
    Expect(1, 3660, '\P{Canonical_Combining_Class=		CCC107}', "");
    Expect(0, 3660, '\P{^Canonical_Combining_Class=		CCC107}', "");
    Error('\p{Ccc=:=- +00000_00001_07}');
    Error('\P{Ccc=:=- +00000_00001_07}');
    Expect(1, 3659, '\p{Ccc=:\A107\z:}', "");;
    Expect(0, 3660, '\p{Ccc=:\A107\z:}', "");;
    Expect(1, 3659, '\p{Ccc=+0_0_0_0_0_0_000107}', "");
    Expect(0, 3659, '\p{^Ccc=+0_0_0_0_0_0_000107}', "");
    Expect(0, 3659, '\P{Ccc=+0_0_0_0_0_0_000107}', "");
    Expect(1, 3659, '\P{^Ccc=+0_0_0_0_0_0_000107}', "");
    Expect(0, 3660, '\p{Ccc=+0_0_0_0_0_0_000107}', "");
    Expect(1, 3660, '\p{^Ccc=+0_0_0_0_0_0_000107}', "");
    Expect(1, 3660, '\P{Ccc=+0_0_0_0_0_0_000107}', "");
    Expect(0, 3660, '\P{^Ccc=+0_0_0_0_0_0_000107}', "");
    Error('\p{Is_Canonical_Combining_Class=		CCC107/a/}');
    Error('\P{Is_Canonical_Combining_Class=		CCC107/a/}');
    Expect(1, 3659, '\p{Is_Canonical_Combining_Class=ccc107}', "");
    Expect(0, 3659, '\p{^Is_Canonical_Combining_Class=ccc107}', "");
    Expect(0, 3659, '\P{Is_Canonical_Combining_Class=ccc107}', "");
    Expect(1, 3659, '\P{^Is_Canonical_Combining_Class=ccc107}', "");
    Expect(0, 3660, '\p{Is_Canonical_Combining_Class=ccc107}', "");
    Expect(1, 3660, '\p{^Is_Canonical_Combining_Class=ccc107}', "");
    Expect(1, 3660, '\P{Is_Canonical_Combining_Class=ccc107}', "");
    Expect(0, 3660, '\P{^Is_Canonical_Combining_Class=ccc107}', "");
    Expect(1, 3659, '\p{Is_Canonical_Combining_Class=_	CCC107}', "");
    Expect(0, 3659, '\p{^Is_Canonical_Combining_Class=_	CCC107}', "");
    Expect(0, 3659, '\P{Is_Canonical_Combining_Class=_	CCC107}', "");
    Expect(1, 3659, '\P{^Is_Canonical_Combining_Class=_	CCC107}', "");
    Expect(0, 3660, '\p{Is_Canonical_Combining_Class=_	CCC107}', "");
    Expect(1, 3660, '\p{^Is_Canonical_Combining_Class=_	CCC107}', "");
    Expect(1, 3660, '\P{Is_Canonical_Combining_Class=_	CCC107}', "");
    Expect(0, 3660, '\P{^Is_Canonical_Combining_Class=_	CCC107}', "");
    Error('\p{Is_Ccc= /a/0_0_0_0_0_1_07}');
    Error('\P{Is_Ccc= /a/0_0_0_0_0_1_07}');
    Expect(1, 3659, '\p{Is_Ccc=0_0_0_107}', "");
    Expect(0, 3659, '\p{^Is_Ccc=0_0_0_107}', "");
    Expect(0, 3659, '\P{Is_Ccc=0_0_0_107}', "");
    Expect(1, 3659, '\P{^Is_Ccc=0_0_0_107}', "");
    Expect(0, 3660, '\p{Is_Ccc=0_0_0_107}', "");
    Expect(1, 3660, '\p{^Is_Ccc=0_0_0_107}', "");
    Expect(1, 3660, '\P{Is_Ccc=0_0_0_107}', "");
    Expect(0, 3660, '\P{^Is_Ccc=0_0_0_107}', "");
    Error('\p{Canonical_Combining_Class=/a/CCC11}');
    Error('\P{Canonical_Combining_Class=/a/CCC11}');
    Expect(1, 1457, '\p{Canonical_Combining_Class=:\ACCC11\z:}', "");;
    Expect(0, 1458, '\p{Canonical_Combining_Class=:\ACCC11\z:}', "");;
    Expect(1, 1457, '\p{Canonical_Combining_Class:ccc11}', "");
    Expect(0, 1457, '\p{^Canonical_Combining_Class:ccc11}', "");
    Expect(0, 1457, '\P{Canonical_Combining_Class:ccc11}', "");
    Expect(1, 1457, '\P{^Canonical_Combining_Class:ccc11}', "");
    Expect(0, 1458, '\p{Canonical_Combining_Class:ccc11}', "");
    Expect(1, 1458, '\p{^Canonical_Combining_Class:ccc11}', "");
    Expect(1, 1458, '\P{Canonical_Combining_Class:ccc11}', "");
    Expect(0, 1458, '\P{^Canonical_Combining_Class:ccc11}', "");
    Expect(1, 1457, '\p{Canonical_Combining_Class=:\Accc11\z:}', "");;
    Expect(0, 1458, '\p{Canonical_Combining_Class=:\Accc11\z:}', "");;
    Expect(1, 1457, '\p{Canonical_Combining_Class=-CCC11}', "");
    Expect(0, 1457, '\p{^Canonical_Combining_Class=-CCC11}', "");
    Expect(0, 1457, '\P{Canonical_Combining_Class=-CCC11}', "");
    Expect(1, 1457, '\P{^Canonical_Combining_Class=-CCC11}', "");
    Expect(0, 1458, '\p{Canonical_Combining_Class=-CCC11}', "");
    Expect(1, 1458, '\p{^Canonical_Combining_Class=-CCC11}', "");
    Expect(1, 1458, '\P{Canonical_Combining_Class=-CCC11}', "");
    Expect(0, 1458, '\P{^Canonical_Combining_Class=-CCC11}', "");
    Error('\p{Ccc=/a/ 0001_1}');
    Error('\P{Ccc=/a/ 0001_1}');
    Expect(1, 1457, '\p{Ccc=:\A11\z:}', "");;
    Expect(0, 1458, '\p{Ccc=:\A11\z:}', "");;
    Expect(1, 1457, '\p{Ccc=000000011}', "");
    Expect(0, 1457, '\p{^Ccc=000000011}', "");
    Expect(0, 1457, '\P{Ccc=000000011}', "");
    Expect(1, 1457, '\P{^Ccc=000000011}', "");
    Expect(0, 1458, '\p{Ccc=000000011}', "");
    Expect(1, 1458, '\p{^Ccc=000000011}', "");
    Expect(1, 1458, '\P{Ccc=000000011}', "");
    Expect(0, 1458, '\P{^Ccc=000000011}', "");
    Error('\p{Is_Canonical_Combining_Class=/a/ CCC11}');
    Error('\P{Is_Canonical_Combining_Class=/a/ CCC11}');
    Expect(1, 1457, '\p{Is_Canonical_Combining_Class=ccc11}', "");
    Expect(0, 1457, '\p{^Is_Canonical_Combining_Class=ccc11}', "");
    Expect(0, 1457, '\P{Is_Canonical_Combining_Class=ccc11}', "");
    Expect(1, 1457, '\P{^Is_Canonical_Combining_Class=ccc11}', "");
    Expect(0, 1458, '\p{Is_Canonical_Combining_Class=ccc11}', "");
    Expect(1, 1458, '\p{^Is_Canonical_Combining_Class=ccc11}', "");
    Expect(1, 1458, '\P{Is_Canonical_Combining_Class=ccc11}', "");
    Expect(0, 1458, '\P{^Is_Canonical_Combining_Class=ccc11}', "");
    Expect(1, 1457, '\p{Is_Canonical_Combining_Class=-	CCC11}', "");
    Expect(0, 1457, '\p{^Is_Canonical_Combining_Class=-	CCC11}', "");
    Expect(0, 1457, '\P{Is_Canonical_Combining_Class=-	CCC11}', "");
    Expect(1, 1457, '\P{^Is_Canonical_Combining_Class=-	CCC11}', "");
    Expect(0, 1458, '\p{Is_Canonical_Combining_Class=-	CCC11}', "");
    Expect(1, 1458, '\p{^Is_Canonical_Combining_Class=-	CCC11}', "");
    Expect(1, 1458, '\P{Is_Canonical_Combining_Class=-	CCC11}', "");
    Expect(0, 1458, '\P{^Is_Canonical_Combining_Class=-	CCC11}', "");
    Error('\p{Is_Ccc=	_+0001_1/a/}');
    Error('\P{Is_Ccc=	_+0001_1/a/}');
    Expect(1, 1457, '\p{Is_Ccc=+000000011}', "");
    Expect(0, 1457, '\p{^Is_Ccc=+000000011}', "");
    Expect(0, 1457, '\P{Is_Ccc=+000000011}', "");
    Expect(1, 1457, '\P{^Is_Ccc=+000000011}', "");
    Expect(0, 1458, '\p{Is_Ccc=+000000011}', "");
    Expect(1, 1458, '\p{^Is_Ccc=+000000011}', "");
    Expect(1, 1458, '\P{Is_Ccc=+000000011}', "");
    Expect(0, 1458, '\P{^Is_Ccc=+000000011}', "");
    Error('\p{Canonical_Combining_Class:_/a/ccc118}');
    Error('\P{Canonical_Combining_Class:_/a/ccc118}');
    Expect(1, 3769, '\p{Canonical_Combining_Class=:\ACCC118\z:}', "");;
    Expect(0, 3770, '\p{Canonical_Combining_Class=:\ACCC118\z:}', "");;
    Expect(1, 3769, '\p{Canonical_Combining_Class=ccc118}', "");
    Expect(0, 3769, '\p{^Canonical_Combining_Class=ccc118}', "");
    Expect(0, 3769, '\P{Canonical_Combining_Class=ccc118}', "");
    Expect(1, 3769, '\P{^Canonical_Combining_Class=ccc118}', "");
    Expect(0, 3770, '\p{Canonical_Combining_Class=ccc118}', "");
    Expect(1, 3770, '\p{^Canonical_Combining_Class=ccc118}', "");
    Expect(1, 3770, '\P{Canonical_Combining_Class=ccc118}', "");
    Expect(0, 3770, '\P{^Canonical_Combining_Class=ccc118}', "");
    Expect(1, 3769, '\p{Canonical_Combining_Class=:\Accc118\z:}', "");;
    Expect(0, 3770, '\p{Canonical_Combining_Class=:\Accc118\z:}', "");;
    Expect(1, 3769, '\p{Canonical_Combining_Class=-_CCC118}', "");
    Expect(0, 3769, '\p{^Canonical_Combining_Class=-_CCC118}', "");
    Expect(0, 3769, '\P{Canonical_Combining_Class=-_CCC118}', "");
    Expect(1, 3769, '\P{^Canonical_Combining_Class=-_CCC118}', "");
    Expect(0, 3770, '\p{Canonical_Combining_Class=-_CCC118}', "");
    Expect(1, 3770, '\p{^Canonical_Combining_Class=-_CCC118}', "");
    Expect(1, 3770, '\P{Canonical_Combining_Class=-_CCC118}', "");
    Expect(0, 3770, '\P{^Canonical_Combining_Class=-_CCC118}', "");
    Error('\p{Ccc=	-00000000118/a/}');
    Error('\P{Ccc=	-00000000118/a/}');
    Expect(1, 3769, '\p{Ccc=:\A118\z:}', "");;
    Expect(0, 3770, '\p{Ccc=:\A118\z:}', "");;
    Expect(1, 3769, '\p{Ccc=00_11_8}', "");
    Expect(0, 3769, '\p{^Ccc=00_11_8}', "");
    Expect(0, 3769, '\P{Ccc=00_11_8}', "");
    Expect(1, 3769, '\P{^Ccc=00_11_8}', "");
    Expect(0, 3770, '\p{Ccc=00_11_8}', "");
    Expect(1, 3770, '\p{^Ccc=00_11_8}', "");
    Expect(1, 3770, '\P{Ccc=00_11_8}', "");
    Expect(0, 3770, '\P{^Ccc=00_11_8}', "");
    Error('\p{Is_Canonical_Combining_Class:	--CCC118:=}');
    Error('\P{Is_Canonical_Combining_Class:	--CCC118:=}');
    Expect(1, 3769, '\p{Is_Canonical_Combining_Class:	ccc118}', "");
    Expect(0, 3769, '\p{^Is_Canonical_Combining_Class:	ccc118}', "");
    Expect(0, 3769, '\P{Is_Canonical_Combining_Class:	ccc118}', "");
    Expect(1, 3769, '\P{^Is_Canonical_Combining_Class:	ccc118}', "");
    Expect(0, 3770, '\p{Is_Canonical_Combining_Class:	ccc118}', "");
    Expect(1, 3770, '\p{^Is_Canonical_Combining_Class:	ccc118}', "");
    Expect(1, 3770, '\P{Is_Canonical_Combining_Class:	ccc118}', "");
    Expect(0, 3770, '\P{^Is_Canonical_Combining_Class:	ccc118}', "");
    Expect(1, 3769, '\p{Is_Canonical_Combining_Class=_CCC118}', "");
    Expect(0, 3769, '\p{^Is_Canonical_Combining_Class=_CCC118}', "");
    Expect(0, 3769, '\P{Is_Canonical_Combining_Class=_CCC118}', "");
    Expect(1, 3769, '\P{^Is_Canonical_Combining_Class=_CCC118}', "");
    Expect(0, 3770, '\p{Is_Canonical_Combining_Class=_CCC118}', "");
    Expect(1, 3770, '\p{^Is_Canonical_Combining_Class=_CCC118}', "");
    Expect(1, 3770, '\P{Is_Canonical_Combining_Class=_CCC118}', "");
    Expect(0, 3770, '\P{^Is_Canonical_Combining_Class=_CCC118}', "");
    Error('\p{Is_Ccc=-0118:=}');
    Error('\P{Is_Ccc=-0118:=}');
    Expect(1, 3769, '\p{Is_Ccc:+00000000118}', "");
    Expect(0, 3769, '\p{^Is_Ccc:+00000000118}', "");
    Expect(0, 3769, '\P{Is_Ccc:+00000000118}', "");
    Expect(1, 3769, '\P{^Is_Ccc:+00000000118}', "");
    Expect(0, 3770, '\p{Is_Ccc:+00000000118}', "");
    Expect(1, 3770, '\p{^Is_Ccc:+00000000118}', "");
    Expect(1, 3770, '\P{Is_Ccc:+00000000118}', "");
    Expect(0, 3770, '\P{^Is_Ccc:+00000000118}', "");
    Error('\p{Canonical_Combining_Class=:=-CCC12}');
    Error('\P{Canonical_Combining_Class=:=-CCC12}');
    Expect(1, 1458, '\p{Canonical_Combining_Class=:\ACCC12\z:}', "");;
    Expect(0, 1459, '\p{Canonical_Combining_Class=:\ACCC12\z:}', "");;
    Expect(1, 1458, '\p{Canonical_Combining_Class=ccc12}', "");
    Expect(0, 1458, '\p{^Canonical_Combining_Class=ccc12}', "");
    Expect(0, 1458, '\P{Canonical_Combining_Class=ccc12}', "");
    Expect(1, 1458, '\P{^Canonical_Combining_Class=ccc12}', "");
    Expect(0, 1459, '\p{Canonical_Combining_Class=ccc12}', "");
    Expect(1, 1459, '\p{^Canonical_Combining_Class=ccc12}', "");
    Expect(1, 1459, '\P{Canonical_Combining_Class=ccc12}', "");
    Expect(0, 1459, '\P{^Canonical_Combining_Class=ccc12}', "");
    Expect(1, 1458, '\p{Canonical_Combining_Class=:\Accc12\z:}', "");;
    Expect(0, 1459, '\p{Canonical_Combining_Class=:\Accc12\z:}', "");;
    Expect(1, 1458, '\p{Canonical_Combining_Class=CCC12}', "");
    Expect(0, 1458, '\p{^Canonical_Combining_Class=CCC12}', "");
    Expect(0, 1458, '\P{Canonical_Combining_Class=CCC12}', "");
    Expect(1, 1458, '\P{^Canonical_Combining_Class=CCC12}', "");
    Expect(0, 1459, '\p{Canonical_Combining_Class=CCC12}', "");
    Expect(1, 1459, '\p{^Canonical_Combining_Class=CCC12}', "");
    Expect(1, 1459, '\P{Canonical_Combining_Class=CCC12}', "");
    Expect(0, 1459, '\P{^Canonical_Combining_Class=CCC12}', "");
    Error('\p{Ccc=/a/000000012}');
    Error('\P{Ccc=/a/000000012}');
    Expect(1, 1458, '\p{Ccc=:\A12\z:}', "");;
    Expect(0, 1459, '\p{Ccc=:\A12\z:}', "");;
    Expect(1, 1458, '\p{Ccc=+0_0_0_0_0_0_0012}', "");
    Expect(0, 1458, '\p{^Ccc=+0_0_0_0_0_0_0012}', "");
    Expect(0, 1458, '\P{Ccc=+0_0_0_0_0_0_0012}', "");
    Expect(1, 1458, '\P{^Ccc=+0_0_0_0_0_0_0012}', "");
    Expect(0, 1459, '\p{Ccc=+0_0_0_0_0_0_0012}', "");
    Expect(1, 1459, '\p{^Ccc=+0_0_0_0_0_0_0012}', "");
    Expect(1, 1459, '\P{Ccc=+0_0_0_0_0_0_0012}', "");
    Expect(0, 1459, '\P{^Ccc=+0_0_0_0_0_0_0012}', "");
    Error('\p{Is_Canonical_Combining_Class::=-CCC12}');
    Error('\P{Is_Canonical_Combining_Class::=-CCC12}');
    Expect(1, 1458, '\p{Is_Canonical_Combining_Class=ccc12}', "");
    Expect(0, 1458, '\p{^Is_Canonical_Combining_Class=ccc12}', "");
    Expect(0, 1458, '\P{Is_Canonical_Combining_Class=ccc12}', "");
    Expect(1, 1458, '\P{^Is_Canonical_Combining_Class=ccc12}', "");
    Expect(0, 1459, '\p{Is_Canonical_Combining_Class=ccc12}', "");
    Expect(1, 1459, '\p{^Is_Canonical_Combining_Class=ccc12}', "");
    Expect(1, 1459, '\P{Is_Canonical_Combining_Class=ccc12}', "");
    Expect(0, 1459, '\P{^Is_Canonical_Combining_Class=ccc12}', "");
    Expect(1, 1458, '\p{Is_Canonical_Combining_Class=CCC12}', "");
    Expect(0, 1458, '\p{^Is_Canonical_Combining_Class=CCC12}', "");
    Expect(0, 1458, '\P{Is_Canonical_Combining_Class=CCC12}', "");
    Expect(1, 1458, '\P{^Is_Canonical_Combining_Class=CCC12}', "");
    Expect(0, 1459, '\p{Is_Canonical_Combining_Class=CCC12}', "");
    Expect(1, 1459, '\p{^Is_Canonical_Combining_Class=CCC12}', "");
    Expect(1, 1459, '\P{Is_Canonical_Combining_Class=CCC12}', "");
    Expect(0, 1459, '\P{^Is_Canonical_Combining_Class=CCC12}', "");
    Error('\p{Is_Ccc=	-0_0_0_0_0_0_12/a/}');
    Error('\P{Is_Ccc=	-0_0_0_0_0_0_12/a/}');
    Expect(1, 1458, '\p{Is_Ccc:	00_00_00_00_012}', "");
    Expect(0, 1458, '\p{^Is_Ccc:	00_00_00_00_012}', "");
    Expect(0, 1458, '\P{Is_Ccc:	00_00_00_00_012}', "");
    Expect(1, 1458, '\P{^Is_Ccc:	00_00_00_00_012}', "");
    Expect(0, 1459, '\p{Is_Ccc:	00_00_00_00_012}', "");
    Expect(1, 1459, '\p{^Is_Ccc:	00_00_00_00_012}', "");
    Expect(1, 1459, '\P{Is_Ccc:	00_00_00_00_012}', "");
    Expect(0, 1459, '\P{^Is_Ccc:	00_00_00_00_012}', "");
    Error('\p{Canonical_Combining_Class=	:=CCC122}');
    Error('\P{Canonical_Combining_Class=	:=CCC122}');
    Expect(1, 3787, '\p{Canonical_Combining_Class=:\ACCC122\z:}', "");;
    Expect(0, 3788, '\p{Canonical_Combining_Class=:\ACCC122\z:}', "");;
    Expect(1, 3787, '\p{Canonical_Combining_Class=ccc122}', "");
    Expect(0, 3787, '\p{^Canonical_Combining_Class=ccc122}', "");
    Expect(0, 3787, '\P{Canonical_Combining_Class=ccc122}', "");
    Expect(1, 3787, '\P{^Canonical_Combining_Class=ccc122}', "");
    Expect(0, 3788, '\p{Canonical_Combining_Class=ccc122}', "");
    Expect(1, 3788, '\p{^Canonical_Combining_Class=ccc122}', "");
    Expect(1, 3788, '\P{Canonical_Combining_Class=ccc122}', "");
    Expect(0, 3788, '\P{^Canonical_Combining_Class=ccc122}', "");
    Expect(1, 3787, '\p{Canonical_Combining_Class=:\Accc122\z:}', "");;
    Expect(0, 3788, '\p{Canonical_Combining_Class=:\Accc122\z:}', "");;
    Expect(1, 3787, '\p{Canonical_Combining_Class=		CCC122}', "");
    Expect(0, 3787, '\p{^Canonical_Combining_Class=		CCC122}', "");
    Expect(0, 3787, '\P{Canonical_Combining_Class=		CCC122}', "");
    Expect(1, 3787, '\P{^Canonical_Combining_Class=		CCC122}', "");
    Expect(0, 3788, '\p{Canonical_Combining_Class=		CCC122}', "");
    Expect(1, 3788, '\p{^Canonical_Combining_Class=		CCC122}', "");
    Expect(1, 3788, '\P{Canonical_Combining_Class=		CCC122}', "");
    Expect(0, 3788, '\P{^Canonical_Combining_Class=		CCC122}', "");
    Error('\p{Ccc:	:=	 000000000122}');
    Error('\P{Ccc:	:=	 000000000122}');
    Expect(1, 3787, '\p{Ccc=:\A122\z:}', "");;
    Expect(0, 3788, '\p{Ccc=:\A122\z:}', "");;
    Expect(1, 3787, '\p{Ccc=+00122}', "");
    Expect(0, 3787, '\p{^Ccc=+00122}', "");
    Expect(0, 3787, '\P{Ccc=+00122}', "");
    Expect(1, 3787, '\P{^Ccc=+00122}', "");
    Expect(0, 3788, '\p{Ccc=+00122}', "");
    Expect(1, 3788, '\p{^Ccc=+00122}', "");
    Expect(1, 3788, '\P{Ccc=+00122}', "");
    Expect(0, 3788, '\P{^Ccc=+00122}', "");
    Error('\p{Is_Canonical_Combining_Class=/a/	CCC122}');
    Error('\P{Is_Canonical_Combining_Class=/a/	CCC122}');
    Expect(1, 3787, '\p{Is_Canonical_Combining_Class=ccc122}', "");
    Expect(0, 3787, '\p{^Is_Canonical_Combining_Class=ccc122}', "");
    Expect(0, 3787, '\P{Is_Canonical_Combining_Class=ccc122}', "");
    Expect(1, 3787, '\P{^Is_Canonical_Combining_Class=ccc122}', "");
    Expect(0, 3788, '\p{Is_Canonical_Combining_Class=ccc122}', "");
    Expect(1, 3788, '\p{^Is_Canonical_Combining_Class=ccc122}', "");
    Expect(1, 3788, '\P{Is_Canonical_Combining_Class=ccc122}', "");
    Expect(0, 3788, '\P{^Is_Canonical_Combining_Class=ccc122}', "");
    Error('\p{Is_Ccc=	/a/000122}');
    Error('\P{Is_Ccc=	/a/000122}');
    Expect(1, 3787, '\p{Is_Ccc=00_12_2}', "");
    Expect(0, 3787, '\p{^Is_Ccc=00_12_2}', "");
    Expect(0, 3787, '\P{Is_Ccc=00_12_2}', "");
    Expect(1, 3787, '\P{^Is_Ccc=00_12_2}', "");
    Expect(0, 3788, '\p{Is_Ccc=00_12_2}', "");
    Expect(1, 3788, '\p{^Is_Ccc=00_12_2}', "");
    Expect(1, 3788, '\P{Is_Ccc=00_12_2}', "");
    Expect(0, 3788, '\P{^Is_Ccc=00_12_2}', "");
    Error('\p{Canonical_Combining_Class=/a/-CCC129}');
    Error('\P{Canonical_Combining_Class=/a/-CCC129}');
    Expect(1, 3953, '\p{Canonical_Combining_Class=:\ACCC129\z:}', "");;
    Expect(0, 3954, '\p{Canonical_Combining_Class=:\ACCC129\z:}', "");;
    Expect(1, 3953, '\p{Canonical_Combining_Class=ccc129}', "");
    Expect(0, 3953, '\p{^Canonical_Combining_Class=ccc129}', "");
    Expect(0, 3953, '\P{Canonical_Combining_Class=ccc129}', "");
    Expect(1, 3953, '\P{^Canonical_Combining_Class=ccc129}', "");
    Expect(0, 3954, '\p{Canonical_Combining_Class=ccc129}', "");
    Expect(1, 3954, '\p{^Canonical_Combining_Class=ccc129}', "");
    Expect(1, 3954, '\P{Canonical_Combining_Class=ccc129}', "");
    Expect(0, 3954, '\P{^Canonical_Combining_Class=ccc129}', "");
    Expect(1, 3953, '\p{Canonical_Combining_Class=:\Accc129\z:}', "");;
    Expect(0, 3954, '\p{Canonical_Combining_Class=:\Accc129\z:}', "");;
    Expect(1, 3953, '\p{Canonical_Combining_Class=_	ccc129}', "");
    Expect(0, 3953, '\p{^Canonical_Combining_Class=_	ccc129}', "");
    Expect(0, 3953, '\P{Canonical_Combining_Class=_	ccc129}', "");
    Expect(1, 3953, '\P{^Canonical_Combining_Class=_	ccc129}', "");
    Expect(0, 3954, '\p{Canonical_Combining_Class=_	ccc129}', "");
    Expect(1, 3954, '\p{^Canonical_Combining_Class=_	ccc129}', "");
    Expect(1, 3954, '\P{Canonical_Combining_Class=_	ccc129}', "");
    Expect(0, 3954, '\P{^Canonical_Combining_Class=_	ccc129}', "");
    Error('\p{Ccc=/a/ +00000000129}');
    Error('\P{Ccc=/a/ +00000000129}');
    Expect(1, 3953, '\p{Ccc=:\A129\z:}', "");;
    Expect(0, 3954, '\p{Ccc=:\A129\z:}', "");;
    Expect(1, 3953, '\p{Ccc=0_0_0_0_0129}', "");
    Expect(0, 3953, '\p{^Ccc=0_0_0_0_0129}', "");
    Expect(0, 3953, '\P{Ccc=0_0_0_0_0129}', "");
    Expect(1, 3953, '\P{^Ccc=0_0_0_0_0129}', "");
    Expect(0, 3954, '\p{Ccc=0_0_0_0_0129}', "");
    Expect(1, 3954, '\p{^Ccc=0_0_0_0_0129}', "");
    Expect(1, 3954, '\P{Ccc=0_0_0_0_0129}', "");
    Expect(0, 3954, '\P{^Ccc=0_0_0_0_0129}', "");
    Error('\p{Is_Canonical_Combining_Class= :=CCC129}');
    Error('\P{Is_Canonical_Combining_Class= :=CCC129}');
    Expect(1, 3953, '\p{Is_Canonical_Combining_Class=ccc129}', "");
    Expect(0, 3953, '\p{^Is_Canonical_Combining_Class=ccc129}', "");
    Expect(0, 3953, '\P{Is_Canonical_Combining_Class=ccc129}', "");
    Expect(1, 3953, '\P{^Is_Canonical_Combining_Class=ccc129}', "");
    Expect(0, 3954, '\p{Is_Canonical_Combining_Class=ccc129}', "");
    Expect(1, 3954, '\p{^Is_Canonical_Combining_Class=ccc129}', "");
    Expect(1, 3954, '\P{Is_Canonical_Combining_Class=ccc129}', "");
    Expect(0, 3954, '\P{^Is_Canonical_Combining_Class=ccc129}', "");
    Expect(1, 3953, '\p{Is_Canonical_Combining_Class=- CCC129}', "");
    Expect(0, 3953, '\p{^Is_Canonical_Combining_Class=- CCC129}', "");
    Expect(0, 3953, '\P{Is_Canonical_Combining_Class=- CCC129}', "");
    Expect(1, 3953, '\P{^Is_Canonical_Combining_Class=- CCC129}', "");
    Expect(0, 3954, '\p{Is_Canonical_Combining_Class=- CCC129}', "");
    Expect(1, 3954, '\p{^Is_Canonical_Combining_Class=- CCC129}', "");
    Expect(1, 3954, '\P{Is_Canonical_Combining_Class=- CCC129}', "");
    Expect(0, 3954, '\P{^Is_Canonical_Combining_Class=- CCC129}', "");
    Error('\p{Is_Ccc=-/a/+00129}');
    Error('\P{Is_Ccc=-/a/+00129}');
    Expect(1, 3953, '\p{Is_Ccc=+0_0_0_0_0_129}', "");
    Expect(0, 3953, '\p{^Is_Ccc=+0_0_0_0_0_129}', "");
    Expect(0, 3953, '\P{Is_Ccc=+0_0_0_0_0_129}', "");
    Expect(1, 3953, '\P{^Is_Ccc=+0_0_0_0_0_129}', "");
    Expect(0, 3954, '\p{Is_Ccc=+0_0_0_0_0_129}', "");
    Expect(1, 3954, '\p{^Is_Ccc=+0_0_0_0_0_129}', "");
    Expect(1, 3954, '\P{Is_Ccc=+0_0_0_0_0_129}', "");
    Expect(0, 3954, '\P{^Is_Ccc=+0_0_0_0_0_129}', "");
    Error('\p{Canonical_Combining_Class=_CCC13:=}');
    Error('\P{Canonical_Combining_Class=_CCC13:=}');
    Expect(1, 1459, '\p{Canonical_Combining_Class=:\ACCC13\z:}', "");;
    Expect(0, 1460, '\p{Canonical_Combining_Class=:\ACCC13\z:}', "");;
    Expect(1, 1459, '\p{Canonical_Combining_Class=ccc13}', "");
    Expect(0, 1459, '\p{^Canonical_Combining_Class=ccc13}', "");
    Expect(0, 1459, '\P{Canonical_Combining_Class=ccc13}', "");
    Expect(1, 1459, '\P{^Canonical_Combining_Class=ccc13}', "");
    Expect(0, 1460, '\p{Canonical_Combining_Class=ccc13}', "");
    Expect(1, 1460, '\p{^Canonical_Combining_Class=ccc13}', "");
    Expect(1, 1460, '\P{Canonical_Combining_Class=ccc13}', "");
    Expect(0, 1460, '\P{^Canonical_Combining_Class=ccc13}', "");
    Expect(1, 1459, '\p{Canonical_Combining_Class=:\Accc13\z:}', "");;
    Expect(0, 1460, '\p{Canonical_Combining_Class=:\Accc13\z:}', "");;
    Expect(1, 1459, '\p{Canonical_Combining_Class= ccc13}', "");
    Expect(0, 1459, '\p{^Canonical_Combining_Class= ccc13}', "");
    Expect(0, 1459, '\P{Canonical_Combining_Class= ccc13}', "");
    Expect(1, 1459, '\P{^Canonical_Combining_Class= ccc13}', "");
    Expect(0, 1460, '\p{Canonical_Combining_Class= ccc13}', "");
    Expect(1, 1460, '\p{^Canonical_Combining_Class= ccc13}', "");
    Expect(1, 1460, '\P{Canonical_Combining_Class= ccc13}', "");
    Expect(0, 1460, '\P{^Canonical_Combining_Class= ccc13}', "");
    Error('\p{Ccc= 1_3/a/}');
    Error('\P{Ccc= 1_3/a/}');
    Expect(1, 1459, '\p{Ccc=:\A13\z:}', "");;
    Expect(0, 1460, '\p{Ccc=:\A13\z:}', "");;
    Expect(1, 1459, '\p{Ccc: 0000000001_3}', "");
    Expect(0, 1459, '\p{^Ccc: 0000000001_3}', "");
    Expect(0, 1459, '\P{Ccc: 0000000001_3}', "");
    Expect(1, 1459, '\P{^Ccc: 0000000001_3}', "");
    Expect(0, 1460, '\p{Ccc: 0000000001_3}', "");
    Expect(1, 1460, '\p{^Ccc: 0000000001_3}', "");
    Expect(1, 1460, '\P{Ccc: 0000000001_3}', "");
    Expect(0, 1460, '\P{^Ccc: 0000000001_3}', "");
    Error('\p{Is_Canonical_Combining_Class=/a/CCC13}');
    Error('\P{Is_Canonical_Combining_Class=/a/CCC13}');
    Expect(1, 1459, '\p{Is_Canonical_Combining_Class=ccc13}', "");
    Expect(0, 1459, '\p{^Is_Canonical_Combining_Class=ccc13}', "");
    Expect(0, 1459, '\P{Is_Canonical_Combining_Class=ccc13}', "");
    Expect(1, 1459, '\P{^Is_Canonical_Combining_Class=ccc13}', "");
    Expect(0, 1460, '\p{Is_Canonical_Combining_Class=ccc13}', "");
    Expect(1, 1460, '\p{^Is_Canonical_Combining_Class=ccc13}', "");
    Expect(1, 1460, '\P{Is_Canonical_Combining_Class=ccc13}', "");
    Expect(0, 1460, '\P{^Is_Canonical_Combining_Class=ccc13}', "");
    Expect(1, 1459, '\p{Is_Canonical_Combining_Class=--CCC13}', "");
    Expect(0, 1459, '\p{^Is_Canonical_Combining_Class=--CCC13}', "");
    Expect(0, 1459, '\P{Is_Canonical_Combining_Class=--CCC13}', "");
    Expect(1, 1459, '\P{^Is_Canonical_Combining_Class=--CCC13}', "");
    Expect(0, 1460, '\p{Is_Canonical_Combining_Class=--CCC13}', "");
    Expect(1, 1460, '\p{^Is_Canonical_Combining_Class=--CCC13}', "");
    Expect(1, 1460, '\P{Is_Canonical_Combining_Class=--CCC13}', "");
    Expect(0, 1460, '\P{^Is_Canonical_Combining_Class=--CCC13}', "");
    Error('\p{Is_Ccc=_:=0_0_0_13}');
    Error('\P{Is_Ccc=_:=0_0_0_13}');
    Expect(1, 1459, '\p{Is_Ccc=+00_00_01_3}', "");
    Expect(0, 1459, '\p{^Is_Ccc=+00_00_01_3}', "");
    Expect(0, 1459, '\P{Is_Ccc=+00_00_01_3}', "");
    Expect(1, 1459, '\P{^Is_Ccc=+00_00_01_3}', "");
    Expect(0, 1460, '\p{Is_Ccc=+00_00_01_3}', "");
    Expect(1, 1460, '\p{^Is_Ccc=+00_00_01_3}', "");
    Expect(1, 1460, '\P{Is_Ccc=+00_00_01_3}', "");
    Expect(0, 1460, '\P{^Is_Ccc=+00_00_01_3}', "");
    Error('\p{Canonical_Combining_Class=/a/-	CCC130}');
    Error('\P{Canonical_Combining_Class=/a/-	CCC130}');
    Expect(1, 3968, '\p{Canonical_Combining_Class=:\ACCC130\z:}', "");;
    Expect(0, 3969, '\p{Canonical_Combining_Class=:\ACCC130\z:}', "");;
    Expect(1, 3968, '\p{Canonical_Combining_Class=ccc130}', "");
    Expect(0, 3968, '\p{^Canonical_Combining_Class=ccc130}', "");
    Expect(0, 3968, '\P{Canonical_Combining_Class=ccc130}', "");
    Expect(1, 3968, '\P{^Canonical_Combining_Class=ccc130}', "");
    Expect(0, 3969, '\p{Canonical_Combining_Class=ccc130}', "");
    Expect(1, 3969, '\p{^Canonical_Combining_Class=ccc130}', "");
    Expect(1, 3969, '\P{Canonical_Combining_Class=ccc130}', "");
    Expect(0, 3969, '\P{^Canonical_Combining_Class=ccc130}', "");
    Expect(1, 3968, '\p{Canonical_Combining_Class=:\Accc130\z:}', "");;
    Expect(0, 3969, '\p{Canonical_Combining_Class=:\Accc130\z:}', "");;
    Expect(1, 3968, '\p{Canonical_Combining_Class=	-CCC130}', "");
    Expect(0, 3968, '\p{^Canonical_Combining_Class=	-CCC130}', "");
    Expect(0, 3968, '\P{Canonical_Combining_Class=	-CCC130}', "");
    Expect(1, 3968, '\P{^Canonical_Combining_Class=	-CCC130}', "");
    Expect(0, 3969, '\p{Canonical_Combining_Class=	-CCC130}', "");
    Expect(1, 3969, '\p{^Canonical_Combining_Class=	-CCC130}', "");
    Expect(1, 3969, '\P{Canonical_Combining_Class=	-CCC130}', "");
    Expect(0, 3969, '\P{^Canonical_Combining_Class=	-CCC130}', "");
    Error('\p{Ccc=:= 0000130}');
    Error('\P{Ccc=:= 0000130}');
    Expect(1, 3968, '\p{Ccc=:\A130\z:}', "");;
    Expect(0, 3969, '\p{Ccc=:\A130\z:}', "");;
    Expect(1, 3968, '\p{Ccc=0_1_30}', "");
    Expect(0, 3968, '\p{^Ccc=0_1_30}', "");
    Expect(0, 3968, '\P{Ccc=0_1_30}', "");
    Expect(1, 3968, '\P{^Ccc=0_1_30}', "");
    Expect(0, 3969, '\p{Ccc=0_1_30}', "");
    Expect(1, 3969, '\p{^Ccc=0_1_30}', "");
    Expect(1, 3969, '\P{Ccc=0_1_30}', "");
    Expect(0, 3969, '\P{^Ccc=0_1_30}', "");
    Error('\p{Is_Canonical_Combining_Class=  CCC130:=}');
    Error('\P{Is_Canonical_Combining_Class=  CCC130:=}');
    Expect(1, 3968, '\p{Is_Canonical_Combining_Class=ccc130}', "");
    Expect(0, 3968, '\p{^Is_Canonical_Combining_Class=ccc130}', "");
    Expect(0, 3968, '\P{Is_Canonical_Combining_Class=ccc130}', "");
    Expect(1, 3968, '\P{^Is_Canonical_Combining_Class=ccc130}', "");
    Expect(0, 3969, '\p{Is_Canonical_Combining_Class=ccc130}', "");
    Expect(1, 3969, '\p{^Is_Canonical_Combining_Class=ccc130}', "");
    Expect(1, 3969, '\P{Is_Canonical_Combining_Class=ccc130}', "");
    Expect(0, 3969, '\P{^Is_Canonical_Combining_Class=ccc130}', "");
    Expect(1, 3968, '\p{Is_Canonical_Combining_Class=	-ccc130}', "");
    Expect(0, 3968, '\p{^Is_Canonical_Combining_Class=	-ccc130}', "");
    Expect(0, 3968, '\P{Is_Canonical_Combining_Class=	-ccc130}', "");
    Expect(1, 3968, '\P{^Is_Canonical_Combining_Class=	-ccc130}', "");
    Expect(0, 3969, '\p{Is_Canonical_Combining_Class=	-ccc130}', "");
    Expect(1, 3969, '\p{^Is_Canonical_Combining_Class=	-ccc130}', "");
    Expect(1, 3969, '\P{Is_Canonical_Combining_Class=	-ccc130}', "");
    Expect(0, 3969, '\P{^Is_Canonical_Combining_Class=	-ccc130}', "");
    Error('\p{Is_Ccc=:=+013_0}');
    Error('\P{Is_Ccc=:=+013_0}');
    Expect(1, 3968, '\p{Is_Ccc=0_0_0_0_0_130}', "");
    Expect(0, 3968, '\p{^Is_Ccc=0_0_0_0_0_130}', "");
    Expect(0, 3968, '\P{Is_Ccc=0_0_0_0_0_130}', "");
    Expect(1, 3968, '\P{^Is_Ccc=0_0_0_0_0_130}', "");
    Expect(0, 3969, '\p{Is_Ccc=0_0_0_0_0_130}', "");
    Expect(1, 3969, '\p{^Is_Ccc=0_0_0_0_0_130}', "");
    Expect(1, 3969, '\P{Is_Ccc=0_0_0_0_0_130}', "");
    Expect(0, 3969, '\P{^Is_Ccc=0_0_0_0_0_130}', "");
    Error('\p{Canonical_Combining_Class=:=	CCC132}');
    Error('\P{Canonical_Combining_Class=:=	CCC132}');
    Expect(1, 3956, '\p{Canonical_Combining_Class=:\ACCC132\z:}', "");;
    Expect(0, 3957, '\p{Canonical_Combining_Class=:\ACCC132\z:}', "");;
    Expect(1, 3956, '\p{Canonical_Combining_Class=ccc132}', "");
    Expect(0, 3956, '\p{^Canonical_Combining_Class=ccc132}', "");
    Expect(0, 3956, '\P{Canonical_Combining_Class=ccc132}', "");
    Expect(1, 3956, '\P{^Canonical_Combining_Class=ccc132}', "");
    Expect(0, 3957, '\p{Canonical_Combining_Class=ccc132}', "");
    Expect(1, 3957, '\p{^Canonical_Combining_Class=ccc132}', "");
    Expect(1, 3957, '\P{Canonical_Combining_Class=ccc132}', "");
    Expect(0, 3957, '\P{^Canonical_Combining_Class=ccc132}', "");
    Expect(1, 3956, '\p{Canonical_Combining_Class=:\Accc132\z:}', "");;
    Expect(0, 3957, '\p{Canonical_Combining_Class=:\Accc132\z:}', "");;
    Expect(1, 3956, '\p{Canonical_Combining_Class=		CCC132}', "");
    Expect(0, 3956, '\p{^Canonical_Combining_Class=		CCC132}', "");
    Expect(0, 3956, '\P{Canonical_Combining_Class=		CCC132}', "");
    Expect(1, 3956, '\P{^Canonical_Combining_Class=		CCC132}', "");
    Expect(0, 3957, '\p{Canonical_Combining_Class=		CCC132}', "");
    Expect(1, 3957, '\p{^Canonical_Combining_Class=		CCC132}', "");
    Expect(1, 3957, '\P{Canonical_Combining_Class=		CCC132}', "");
    Expect(0, 3957, '\P{^Canonical_Combining_Class=		CCC132}', "");
    Error('\p{Ccc=/a/_0_1_32}');
    Error('\P{Ccc=/a/_0_1_32}');
    Expect(1, 3956, '\p{Ccc=:\A132\z:}', "");;
    Expect(0, 3957, '\p{Ccc=:\A132\z:}', "");;
    Expect(1, 3956, '\p{Ccc=00_01_32}', "");
    Expect(0, 3956, '\p{^Ccc=00_01_32}', "");
    Expect(0, 3956, '\P{Ccc=00_01_32}', "");
    Expect(1, 3956, '\P{^Ccc=00_01_32}', "");
    Expect(0, 3957, '\p{Ccc=00_01_32}', "");
    Expect(1, 3957, '\p{^Ccc=00_01_32}', "");
    Expect(1, 3957, '\P{Ccc=00_01_32}', "");
    Expect(0, 3957, '\P{^Ccc=00_01_32}', "");
    Error('\p{Is_Canonical_Combining_Class=-:=CCC132}');
    Error('\P{Is_Canonical_Combining_Class=-:=CCC132}');
    Expect(1, 3956, '\p{Is_Canonical_Combining_Class=ccc132}', "");
    Expect(0, 3956, '\p{^Is_Canonical_Combining_Class=ccc132}', "");
    Expect(0, 3956, '\P{Is_Canonical_Combining_Class=ccc132}', "");
    Expect(1, 3956, '\P{^Is_Canonical_Combining_Class=ccc132}', "");
    Expect(0, 3957, '\p{Is_Canonical_Combining_Class=ccc132}', "");
    Expect(1, 3957, '\p{^Is_Canonical_Combining_Class=ccc132}', "");
    Expect(1, 3957, '\P{Is_Canonical_Combining_Class=ccc132}', "");
    Expect(0, 3957, '\P{^Is_Canonical_Combining_Class=ccc132}', "");
    Expect(1, 3956, '\p{Is_Canonical_Combining_Class= CCC132}', "");
    Expect(0, 3956, '\p{^Is_Canonical_Combining_Class= CCC132}', "");
    Expect(0, 3956, '\P{Is_Canonical_Combining_Class= CCC132}', "");
    Expect(1, 3956, '\P{^Is_Canonical_Combining_Class= CCC132}', "");
    Expect(0, 3957, '\p{Is_Canonical_Combining_Class= CCC132}', "");
    Expect(1, 3957, '\p{^Is_Canonical_Combining_Class= CCC132}', "");
    Expect(1, 3957, '\P{Is_Canonical_Combining_Class= CCC132}', "");
    Expect(0, 3957, '\P{^Is_Canonical_Combining_Class= CCC132}', "");
    Error('\p{Is_Ccc=/a/	00_00_00_00_01_32}');
    Error('\P{Is_Ccc=/a/	00_00_00_00_01_32}');
    Expect(1, 3956, '\p{Is_Ccc=0_0_0_0_1_32}', "");
    Expect(0, 3956, '\p{^Is_Ccc=0_0_0_0_1_32}', "");
    Expect(0, 3956, '\P{Is_Ccc=0_0_0_0_1_32}', "");
    Expect(1, 3956, '\P{^Is_Ccc=0_0_0_0_1_32}', "");
    Expect(0, 3957, '\p{Is_Ccc=0_0_0_0_1_32}', "");
    Expect(1, 3957, '\p{^Is_Ccc=0_0_0_0_1_32}', "");
    Expect(1, 3957, '\P{Is_Ccc=0_0_0_0_1_32}', "");
    Expect(0, 3957, '\P{^Is_Ccc=0_0_0_0_1_32}', "");
    Error('\p{Canonical_Combining_Class:	 :=ccc133}');
    Error('\P{Canonical_Combining_Class:	 :=ccc133}');
    Expect(0, 1, '\p{Canonical_Combining_Class=:\ACCC133\z:}', "");;
    Expect(0, 1, '\p{Canonical_Combining_Class=ccc133}', "");
    Expect(1, 1, '\p{^Canonical_Combining_Class=ccc133}', "");
    Expect(1, 1, '\P{Canonical_Combining_Class=ccc133}', "");
    Expect(0, 1, '\P{^Canonical_Combining_Class=ccc133}', "");
    Expect(0, 1, '\p{Canonical_Combining_Class=:\Accc133\z:}', "");;
    Expect(0, 1, '\p{Canonical_Combining_Class=_CCC133}', "");
    Expect(1, 1, '\p{^Canonical_Combining_Class=_CCC133}', "");
    Expect(1, 1, '\P{Canonical_Combining_Class=_CCC133}', "");
    Expect(0, 1, '\P{^Canonical_Combining_Class=_CCC133}', "");
    Error('\p{Ccc:   --+00133:=}');
    Error('\P{Ccc:   --+00133:=}');
    Expect(0, 1, '\p{Ccc=:\A133\z:}', "");;
    Expect(0, 1, '\p{Ccc=133}', "");
    Expect(1, 1, '\p{^Ccc=133}', "");
    Expect(1, 1, '\P{Ccc=133}', "");
    Expect(0, 1, '\P{^Ccc=133}', "");
    Error('\p{Is_Canonical_Combining_Class=_ CCC133/a/}');
    Error('\P{Is_Canonical_Combining_Class=_ CCC133/a/}');
    Expect(0, 1, '\p{Is_Canonical_Combining_Class:	ccc133}', "");
    Expect(1, 1, '\p{^Is_Canonical_Combining_Class:	ccc133}', "");
    Expect(1, 1, '\P{Is_Canonical_Combining_Class:	ccc133}', "");
    Expect(0, 1, '\P{^Is_Canonical_Combining_Class:	ccc133}', "");
    Expect(0, 1, '\p{Is_Canonical_Combining_Class=--ccc133}', "");
    Expect(1, 1, '\p{^Is_Canonical_Combining_Class=--ccc133}', "");
    Expect(1, 1, '\P{Is_Canonical_Combining_Class=--ccc133}', "");
    Expect(0, 1, '\P{^Is_Canonical_Combining_Class=--ccc133}', "");
    Error('\p{Is_Ccc=  0_0_0_1_33/a/}');
    Error('\P{Is_Ccc=  0_0_0_1_33/a/}');
    Expect(0, 1, '\p{Is_Ccc=+00_01_33}', "");
    Expect(1, 1, '\p{^Is_Ccc=+00_01_33}', "");
    Expect(1, 1, '\P{Is_Ccc=+00_01_33}', "");
    Expect(0, 1, '\P{^Is_Ccc=+00_01_33}', "");
    Error('\p{Canonical_Combining_Class=	_CCC14:=}');
    Error('\P{Canonical_Combining_Class=	_CCC14:=}');
    Expect(1, 1460, '\p{Canonical_Combining_Class=:\ACCC14\z:}', "");;
    Expect(0, 1461, '\p{Canonical_Combining_Class=:\ACCC14\z:}', "");;
    Expect(1, 1460, '\p{Canonical_Combining_Class=ccc14}', "");
    Expect(0, 1460, '\p{^Canonical_Combining_Class=ccc14}', "");
    Expect(0, 1460, '\P{Canonical_Combining_Class=ccc14}', "");
    Expect(1, 1460, '\P{^Canonical_Combining_Class=ccc14}', "");
    Expect(0, 1461, '\p{Canonical_Combining_Class=ccc14}', "");
    Expect(1, 1461, '\p{^Canonical_Combining_Class=ccc14}', "");
    Expect(1, 1461, '\P{Canonical_Combining_Class=ccc14}', "");
    Expect(0, 1461, '\P{^Canonical_Combining_Class=ccc14}', "");
    Expect(1, 1460, '\p{Canonical_Combining_Class=:\Accc14\z:}', "");;
    Expect(0, 1461, '\p{Canonical_Combining_Class=:\Accc14\z:}', "");;
    Expect(1, 1460, '\p{Canonical_Combining_Class=	ccc14}', "");
    Expect(0, 1460, '\p{^Canonical_Combining_Class=	ccc14}', "");
    Expect(0, 1460, '\P{Canonical_Combining_Class=	ccc14}', "");
    Expect(1, 1460, '\P{^Canonical_Combining_Class=	ccc14}', "");
    Expect(0, 1461, '\p{Canonical_Combining_Class=	ccc14}', "");
    Expect(1, 1461, '\p{^Canonical_Combining_Class=	ccc14}', "");
    Expect(1, 1461, '\P{Canonical_Combining_Class=	ccc14}', "");
    Expect(0, 1461, '\P{^Canonical_Combining_Class=	ccc14}', "");
    Error('\p{Ccc=__00000000014:=}');
    Error('\P{Ccc=__00000000014:=}');
    Expect(1, 1460, '\p{Ccc=:\A14\z:}', "");;
    Expect(0, 1461, '\p{Ccc=:\A14\z:}', "");;
    Expect(1, 1460, '\p{Ccc=0014}', "");
    Expect(0, 1460, '\p{^Ccc=0014}', "");
    Expect(0, 1460, '\P{Ccc=0014}', "");
    Expect(1, 1460, '\P{^Ccc=0014}', "");
    Expect(0, 1461, '\p{Ccc=0014}', "");
    Expect(1, 1461, '\p{^Ccc=0014}', "");
    Expect(1, 1461, '\P{Ccc=0014}', "");
    Expect(0, 1461, '\P{^Ccc=0014}', "");
    Error('\p{Is_Canonical_Combining_Class=:= 	CCC14}');
    Error('\P{Is_Canonical_Combining_Class=:= 	CCC14}');
    Expect(1, 1460, '\p{Is_Canonical_Combining_Class=ccc14}', "");
    Expect(0, 1460, '\p{^Is_Canonical_Combining_Class=ccc14}', "");
    Expect(0, 1460, '\P{Is_Canonical_Combining_Class=ccc14}', "");
    Expect(1, 1460, '\P{^Is_Canonical_Combining_Class=ccc14}', "");
    Expect(0, 1461, '\p{Is_Canonical_Combining_Class=ccc14}', "");
    Expect(1, 1461, '\p{^Is_Canonical_Combining_Class=ccc14}', "");
    Expect(1, 1461, '\P{Is_Canonical_Combining_Class=ccc14}', "");
    Expect(0, 1461, '\P{^Is_Canonical_Combining_Class=ccc14}', "");
    Expect(1, 1460, '\p{Is_Canonical_Combining_Class=		ccc14}', "");
    Expect(0, 1460, '\p{^Is_Canonical_Combining_Class=		ccc14}', "");
    Expect(0, 1460, '\P{Is_Canonical_Combining_Class=		ccc14}', "");
    Expect(1, 1460, '\P{^Is_Canonical_Combining_Class=		ccc14}', "");
    Expect(0, 1461, '\p{Is_Canonical_Combining_Class=		ccc14}', "");
    Expect(1, 1461, '\p{^Is_Canonical_Combining_Class=		ccc14}', "");
    Expect(1, 1461, '\P{Is_Canonical_Combining_Class=		ccc14}', "");
    Expect(0, 1461, '\P{^Is_Canonical_Combining_Class=		ccc14}', "");
    Error('\p{Is_Ccc= :=0_0_0_14}');
    Error('\P{Is_Ccc= :=0_0_0_14}');
    Expect(1, 1460, '\p{Is_Ccc=1_4}', "");
    Expect(0, 1460, '\p{^Is_Ccc=1_4}', "");
    Expect(0, 1460, '\P{Is_Ccc=1_4}', "");
    Expect(1, 1460, '\P{^Is_Ccc=1_4}', "");
    Expect(0, 1461, '\p{Is_Ccc=1_4}', "");
    Expect(1, 1461, '\p{^Is_Ccc=1_4}', "");
    Expect(1, 1461, '\P{Is_Ccc=1_4}', "");
    Expect(0, 1461, '\P{^Is_Ccc=1_4}', "");
    Error('\p{Canonical_Combining_Class:	:=- CCC15}');
    Error('\P{Canonical_Combining_Class:	:=- CCC15}');
    Expect(1, 1461, '\p{Canonical_Combining_Class=:\ACCC15\z:}', "");;
    Expect(0, 1462, '\p{Canonical_Combining_Class=:\ACCC15\z:}', "");;
    Expect(1, 1461, '\p{Canonical_Combining_Class=ccc15}', "");
    Expect(0, 1461, '\p{^Canonical_Combining_Class=ccc15}', "");
    Expect(0, 1461, '\P{Canonical_Combining_Class=ccc15}', "");
    Expect(1, 1461, '\P{^Canonical_Combining_Class=ccc15}', "");
    Expect(0, 1462, '\p{Canonical_Combining_Class=ccc15}', "");
    Expect(1, 1462, '\p{^Canonical_Combining_Class=ccc15}', "");
    Expect(1, 1462, '\P{Canonical_Combining_Class=ccc15}', "");
    Expect(0, 1462, '\P{^Canonical_Combining_Class=ccc15}', "");
    Expect(1, 1461, '\p{Canonical_Combining_Class=:\Accc15\z:}', "");;
    Expect(0, 1462, '\p{Canonical_Combining_Class=:\Accc15\z:}', "");;
    Expect(1, 1461, '\p{Canonical_Combining_Class=	_CCC15}', "");
    Expect(0, 1461, '\p{^Canonical_Combining_Class=	_CCC15}', "");
    Expect(0, 1461, '\P{Canonical_Combining_Class=	_CCC15}', "");
    Expect(1, 1461, '\P{^Canonical_Combining_Class=	_CCC15}', "");
    Expect(0, 1462, '\p{Canonical_Combining_Class=	_CCC15}', "");
    Expect(1, 1462, '\p{^Canonical_Combining_Class=	_CCC15}', "");
    Expect(1, 1462, '\P{Canonical_Combining_Class=	_CCC15}', "");
    Expect(0, 1462, '\P{^Canonical_Combining_Class=	_CCC15}', "");
    Error('\p{Ccc=_ +0_0_0_0_0_00015/a/}');
    Error('\P{Ccc=_ +0_0_0_0_0_00015/a/}');
    Expect(1, 1461, '\p{Ccc=:\A15\z:}', "");;
    Expect(0, 1462, '\p{Ccc=:\A15\z:}', "");;
    Expect(1, 1461, '\p{Ccc=+01_5}', "");
    Expect(0, 1461, '\p{^Ccc=+01_5}', "");
    Expect(0, 1461, '\P{Ccc=+01_5}', "");
    Expect(1, 1461, '\P{^Ccc=+01_5}', "");
    Expect(0, 1462, '\p{Ccc=+01_5}', "");
    Expect(1, 1462, '\p{^Ccc=+01_5}', "");
    Expect(1, 1462, '\P{Ccc=+01_5}', "");
    Expect(0, 1462, '\P{^Ccc=+01_5}', "");
    Error('\p{Is_Canonical_Combining_Class:	/a/CCC15}');
    Error('\P{Is_Canonical_Combining_Class:	/a/CCC15}');
    Expect(1, 1461, '\p{Is_Canonical_Combining_Class=ccc15}', "");
    Expect(0, 1461, '\p{^Is_Canonical_Combining_Class=ccc15}', "");
    Expect(0, 1461, '\P{Is_Canonical_Combining_Class=ccc15}', "");
    Expect(1, 1461, '\P{^Is_Canonical_Combining_Class=ccc15}', "");
    Expect(0, 1462, '\p{Is_Canonical_Combining_Class=ccc15}', "");
    Expect(1, 1462, '\p{^Is_Canonical_Combining_Class=ccc15}', "");
    Expect(1, 1462, '\P{Is_Canonical_Combining_Class=ccc15}', "");
    Expect(0, 1462, '\P{^Is_Canonical_Combining_Class=ccc15}', "");
    Expect(1, 1461, '\p{Is_Canonical_Combining_Class=_ CCC15}', "");
    Expect(0, 1461, '\p{^Is_Canonical_Combining_Class=_ CCC15}', "");
    Expect(0, 1461, '\P{Is_Canonical_Combining_Class=_ CCC15}', "");
    Expect(1, 1461, '\P{^Is_Canonical_Combining_Class=_ CCC15}', "");
    Expect(0, 1462, '\p{Is_Canonical_Combining_Class=_ CCC15}', "");
    Expect(1, 1462, '\p{^Is_Canonical_Combining_Class=_ CCC15}', "");
    Expect(1, 1462, '\P{Is_Canonical_Combining_Class=_ CCC15}', "");
    Expect(0, 1462, '\P{^Is_Canonical_Combining_Class=_ CCC15}', "");
    Error('\p{Is_Ccc=-:=+00000015}');
    Error('\P{Is_Ccc=-:=+00000015}');
    Expect(1, 1461, '\p{Is_Ccc=+00000001_5}', "");
    Expect(0, 1461, '\p{^Is_Ccc=+00000001_5}', "");
    Expect(0, 1461, '\P{Is_Ccc=+00000001_5}', "");
    Expect(1, 1461, '\P{^Is_Ccc=+00000001_5}', "");
    Expect(0, 1462, '\p{Is_Ccc=+00000001_5}', "");
    Expect(1, 1462, '\p{^Is_Ccc=+00000001_5}', "");
    Expect(1, 1462, '\P{Is_Ccc=+00000001_5}', "");
    Expect(0, 1462, '\P{^Is_Ccc=+00000001_5}', "");
    Error('\p{Canonical_Combining_Class:    /a/CCC16}');
    Error('\P{Canonical_Combining_Class:    /a/CCC16}');
    Expect(1, 1462, '\p{Canonical_Combining_Class=:\ACCC16\z:}', "");;
    Expect(0, 1463, '\p{Canonical_Combining_Class=:\ACCC16\z:}', "");;
    Expect(1, 1462, '\p{Canonical_Combining_Class=ccc16}', "");
    Expect(0, 1462, '\p{^Canonical_Combining_Class=ccc16}', "");
    Expect(0, 1462, '\P{Canonical_Combining_Class=ccc16}', "");
    Expect(1, 1462, '\P{^Canonical_Combining_Class=ccc16}', "");
    Expect(0, 1463, '\p{Canonical_Combining_Class=ccc16}', "");
    Expect(1, 1463, '\p{^Canonical_Combining_Class=ccc16}', "");
    Expect(1, 1463, '\P{Canonical_Combining_Class=ccc16}', "");
    Expect(0, 1463, '\P{^Canonical_Combining_Class=ccc16}', "");
    Expect(1, 1462, '\p{Canonical_Combining_Class=:\Accc16\z:}', "");;
    Expect(0, 1463, '\p{Canonical_Combining_Class=:\Accc16\z:}', "");;
    Expect(1, 1462, '\p{Canonical_Combining_Class=	CCC16}', "");
    Expect(0, 1462, '\p{^Canonical_Combining_Class=	CCC16}', "");
    Expect(0, 1462, '\P{Canonical_Combining_Class=	CCC16}', "");
    Expect(1, 1462, '\P{^Canonical_Combining_Class=	CCC16}', "");
    Expect(0, 1463, '\p{Canonical_Combining_Class=	CCC16}', "");
    Expect(1, 1463, '\p{^Canonical_Combining_Class=	CCC16}', "");
    Expect(1, 1463, '\P{Canonical_Combining_Class=	CCC16}', "");
    Expect(0, 1463, '\P{^Canonical_Combining_Class=	CCC16}', "");
    Error('\p{Ccc=-:=0_0_0_16}');
    Error('\P{Ccc=-:=0_0_0_16}');
    Expect(1, 1462, '\p{Ccc=:\A16\z:}', "");;
    Expect(0, 1463, '\p{Ccc=:\A16\z:}', "");;
    Expect(1, 1462, '\p{Ccc=+016}', "");
    Expect(0, 1462, '\p{^Ccc=+016}', "");
    Expect(0, 1462, '\P{Ccc=+016}', "");
    Expect(1, 1462, '\P{^Ccc=+016}', "");
    Expect(0, 1463, '\p{Ccc=+016}', "");
    Expect(1, 1463, '\p{^Ccc=+016}', "");
    Expect(1, 1463, '\P{Ccc=+016}', "");
    Expect(0, 1463, '\P{^Ccc=+016}', "");
    Error('\p{Is_Canonical_Combining_Class=:=-	CCC16}');
    Error('\P{Is_Canonical_Combining_Class=:=-	CCC16}');
    Expect(1, 1462, '\p{Is_Canonical_Combining_Class=ccc16}', "");
    Expect(0, 1462, '\p{^Is_Canonical_Combining_Class=ccc16}', "");
    Expect(0, 1462, '\P{Is_Canonical_Combining_Class=ccc16}', "");
    Expect(1, 1462, '\P{^Is_Canonical_Combining_Class=ccc16}', "");
    Expect(0, 1463, '\p{Is_Canonical_Combining_Class=ccc16}', "");
    Expect(1, 1463, '\p{^Is_Canonical_Combining_Class=ccc16}', "");
    Expect(1, 1463, '\P{Is_Canonical_Combining_Class=ccc16}', "");
    Expect(0, 1463, '\P{^Is_Canonical_Combining_Class=ccc16}', "");
    Expect(1, 1462, '\p{Is_Canonical_Combining_Class= CCC16}', "");
    Expect(0, 1462, '\p{^Is_Canonical_Combining_Class= CCC16}', "");
    Expect(0, 1462, '\P{Is_Canonical_Combining_Class= CCC16}', "");
    Expect(1, 1462, '\P{^Is_Canonical_Combining_Class= CCC16}', "");
    Expect(0, 1463, '\p{Is_Canonical_Combining_Class= CCC16}', "");
    Expect(1, 1463, '\p{^Is_Canonical_Combining_Class= CCC16}', "");
    Expect(1, 1463, '\P{Is_Canonical_Combining_Class= CCC16}', "");
    Expect(0, 1463, '\P{^Is_Canonical_Combining_Class= CCC16}', "");
    Error('\p{Is_Ccc=:= 	000016}');
    Error('\P{Is_Ccc=:= 	000016}');
    Expect(1, 1462, '\p{Is_Ccc=+16}', "");
    Expect(0, 1462, '\p{^Is_Ccc=+16}', "");
    Expect(0, 1462, '\P{Is_Ccc=+16}', "");
    Expect(1, 1462, '\P{^Is_Ccc=+16}', "");
    Expect(0, 1463, '\p{Is_Ccc=+16}', "");
    Expect(1, 1463, '\p{^Is_Ccc=+16}', "");
    Expect(1, 1463, '\P{Is_Ccc=+16}', "");
    Expect(0, 1463, '\P{^Is_Ccc=+16}', "");
    Error('\p{Canonical_Combining_Class:	-/a/CCC17}');
    Error('\P{Canonical_Combining_Class:	-/a/CCC17}');
    Expect(1, 1463, '\p{Canonical_Combining_Class=:\ACCC17\z:}', "");;
    Expect(0, 1464, '\p{Canonical_Combining_Class=:\ACCC17\z:}', "");;
    Expect(1, 1463, '\p{Canonical_Combining_Class=ccc17}', "");
    Expect(0, 1463, '\p{^Canonical_Combining_Class=ccc17}', "");
    Expect(0, 1463, '\P{Canonical_Combining_Class=ccc17}', "");
    Expect(1, 1463, '\P{^Canonical_Combining_Class=ccc17}', "");
    Expect(0, 1464, '\p{Canonical_Combining_Class=ccc17}', "");
    Expect(1, 1464, '\p{^Canonical_Combining_Class=ccc17}', "");
    Expect(1, 1464, '\P{Canonical_Combining_Class=ccc17}', "");
    Expect(0, 1464, '\P{^Canonical_Combining_Class=ccc17}', "");
    Expect(1, 1463, '\p{Canonical_Combining_Class=:\Accc17\z:}', "");;
    Expect(0, 1464, '\p{Canonical_Combining_Class=:\Accc17\z:}', "");;
    Expect(1, 1463, '\p{Canonical_Combining_Class= -ccc17}', "");
    Expect(0, 1463, '\p{^Canonical_Combining_Class= -ccc17}', "");
    Expect(0, 1463, '\P{Canonical_Combining_Class= -ccc17}', "");
    Expect(1, 1463, '\P{^Canonical_Combining_Class= -ccc17}', "");
    Expect(0, 1464, '\p{Canonical_Combining_Class= -ccc17}', "");
    Expect(1, 1464, '\p{^Canonical_Combining_Class= -ccc17}', "");
    Expect(1, 1464, '\P{Canonical_Combining_Class= -ccc17}', "");
    Expect(0, 1464, '\P{^Canonical_Combining_Class= -ccc17}', "");
    Error('\p{Ccc=  000000017:=}');
    Error('\P{Ccc=  000000017:=}');
    Expect(1, 1463, '\p{Ccc=:\A17\z:}', "");;
    Expect(0, 1464, '\p{Ccc=:\A17\z:}', "");;
    Expect(1, 1463, '\p{Ccc=0017}', "");
    Expect(0, 1463, '\p{^Ccc=0017}', "");
    Expect(0, 1463, '\P{Ccc=0017}', "");
    Expect(1, 1463, '\P{^Ccc=0017}', "");
    Expect(0, 1464, '\p{Ccc=0017}', "");
    Expect(1, 1464, '\p{^Ccc=0017}', "");
    Expect(1, 1464, '\P{Ccc=0017}', "");
    Expect(0, 1464, '\P{^Ccc=0017}', "");
    Error('\p{Is_Canonical_Combining_Class=:=__CCC17}');
    Error('\P{Is_Canonical_Combining_Class=:=__CCC17}');
    Expect(1, 1463, '\p{Is_Canonical_Combining_Class=ccc17}', "");
    Expect(0, 1463, '\p{^Is_Canonical_Combining_Class=ccc17}', "");
    Expect(0, 1463, '\P{Is_Canonical_Combining_Class=ccc17}', "");
    Expect(1, 1463, '\P{^Is_Canonical_Combining_Class=ccc17}', "");
    Expect(0, 1464, '\p{Is_Canonical_Combining_Class=ccc17}', "");
    Expect(1, 1464, '\p{^Is_Canonical_Combining_Class=ccc17}', "");
    Expect(1, 1464, '\P{Is_Canonical_Combining_Class=ccc17}', "");
    Expect(0, 1464, '\P{^Is_Canonical_Combining_Class=ccc17}', "");
    Expect(1, 1463, '\p{Is_Canonical_Combining_Class=_ CCC17}', "");
    Expect(0, 1463, '\p{^Is_Canonical_Combining_Class=_ CCC17}', "");
    Expect(0, 1463, '\P{Is_Canonical_Combining_Class=_ CCC17}', "");
    Expect(1, 1463, '\P{^Is_Canonical_Combining_Class=_ CCC17}', "");
    Expect(0, 1464, '\p{Is_Canonical_Combining_Class=_ CCC17}', "");
    Expect(1, 1464, '\p{^Is_Canonical_Combining_Class=_ CCC17}', "");
    Expect(1, 1464, '\P{Is_Canonical_Combining_Class=_ CCC17}', "");
    Expect(0, 1464, '\P{^Is_Canonical_Combining_Class=_ CCC17}', "");
    Error('\p{Is_Ccc=/a/-	+0000017}');
    Error('\P{Is_Ccc=/a/-	+0000017}');
    Expect(1, 1463, '\p{Is_Ccc=+01_7}', "");
    Expect(0, 1463, '\p{^Is_Ccc=+01_7}', "");
    Expect(0, 1463, '\P{Is_Ccc=+01_7}', "");
    Expect(1, 1463, '\P{^Is_Ccc=+01_7}', "");
    Expect(0, 1464, '\p{Is_Ccc=+01_7}', "");
    Expect(1, 1464, '\p{^Is_Ccc=+01_7}', "");
    Expect(1, 1464, '\P{Is_Ccc=+01_7}', "");
    Expect(0, 1464, '\P{^Is_Ccc=+01_7}', "");
    Error('\p{Canonical_Combining_Class:	_/a/CCC18}');
    Error('\P{Canonical_Combining_Class:	_/a/CCC18}');
    Expect(1, 1479, '\p{Canonical_Combining_Class=:\ACCC18\z:}', "");;
    Expect(0, 1480, '\p{Canonical_Combining_Class=:\ACCC18\z:}', "");;
    Expect(1, 1479, '\p{Canonical_Combining_Class=ccc18}', "");
    Expect(0, 1479, '\p{^Canonical_Combining_Class=ccc18}', "");
    Expect(0, 1479, '\P{Canonical_Combining_Class=ccc18}', "");
    Expect(1, 1479, '\P{^Canonical_Combining_Class=ccc18}', "");
    Expect(0, 1480, '\p{Canonical_Combining_Class=ccc18}', "");
    Expect(1, 1480, '\p{^Canonical_Combining_Class=ccc18}', "");
    Expect(1, 1480, '\P{Canonical_Combining_Class=ccc18}', "");
    Expect(0, 1480, '\P{^Canonical_Combining_Class=ccc18}', "");
    Expect(1, 1479, '\p{Canonical_Combining_Class=:\Accc18\z:}', "");;
    Expect(0, 1480, '\p{Canonical_Combining_Class=:\Accc18\z:}', "");;
    Expect(1, 1479, '\p{Canonical_Combining_Class=	 CCC18}', "");
    Expect(0, 1479, '\p{^Canonical_Combining_Class=	 CCC18}', "");
    Expect(0, 1479, '\P{Canonical_Combining_Class=	 CCC18}', "");
    Expect(1, 1479, '\P{^Canonical_Combining_Class=	 CCC18}', "");
    Expect(0, 1480, '\p{Canonical_Combining_Class=	 CCC18}', "");
    Expect(1, 1480, '\p{^Canonical_Combining_Class=	 CCC18}', "");
    Expect(1, 1480, '\P{Canonical_Combining_Class=	 CCC18}', "");
    Expect(0, 1480, '\P{^Canonical_Combining_Class=	 CCC18}', "");
    Error('\p{Ccc=/a/ 000000018}');
    Error('\P{Ccc=/a/ 000000018}');
    Expect(1, 1479, '\p{Ccc=:\A18\z:}', "");;
    Expect(0, 1480, '\p{Ccc=:\A18\z:}', "");;
    Expect(1, 1479, '\p{Ccc=00000000018}', "");
    Expect(0, 1479, '\p{^Ccc=00000000018}', "");
    Expect(0, 1479, '\P{Ccc=00000000018}', "");
    Expect(1, 1479, '\P{^Ccc=00000000018}', "");
    Expect(0, 1480, '\p{Ccc=00000000018}', "");
    Expect(1, 1480, '\p{^Ccc=00000000018}', "");
    Expect(1, 1480, '\P{Ccc=00000000018}', "");
    Expect(0, 1480, '\P{^Ccc=00000000018}', "");
    Error('\p{Is_Canonical_Combining_Class=	CCC18:=}');
    Error('\P{Is_Canonical_Combining_Class=	CCC18:=}');
    Expect(1, 1479, '\p{Is_Canonical_Combining_Class=ccc18}', "");
    Expect(0, 1479, '\p{^Is_Canonical_Combining_Class=ccc18}', "");
    Expect(0, 1479, '\P{Is_Canonical_Combining_Class=ccc18}', "");
    Expect(1, 1479, '\P{^Is_Canonical_Combining_Class=ccc18}', "");
    Expect(0, 1480, '\p{Is_Canonical_Combining_Class=ccc18}', "");
    Expect(1, 1480, '\p{^Is_Canonical_Combining_Class=ccc18}', "");
    Expect(1, 1480, '\P{Is_Canonical_Combining_Class=ccc18}', "");
    Expect(0, 1480, '\P{^Is_Canonical_Combining_Class=ccc18}', "");
    Expect(1, 1479, '\p{Is_Canonical_Combining_Class=	_CCC18}', "");
    Expect(0, 1479, '\p{^Is_Canonical_Combining_Class=	_CCC18}', "");
    Expect(0, 1479, '\P{Is_Canonical_Combining_Class=	_CCC18}', "");
    Expect(1, 1479, '\P{^Is_Canonical_Combining_Class=	_CCC18}', "");
    Expect(0, 1480, '\p{Is_Canonical_Combining_Class=	_CCC18}', "");
    Expect(1, 1480, '\p{^Is_Canonical_Combining_Class=	_CCC18}', "");
    Expect(1, 1480, '\P{Is_Canonical_Combining_Class=	_CCC18}', "");
    Expect(0, 1480, '\P{^Is_Canonical_Combining_Class=	_CCC18}', "");
    Error('\p{Is_Ccc=-	0_0_0_18/a/}');
    Error('\P{Is_Ccc=-	0_0_0_18/a/}');
    Expect(1, 1479, '\p{Is_Ccc=0_0_0_0_0_0_0018}', "");
    Expect(0, 1479, '\p{^Is_Ccc=0_0_0_0_0_0_0018}', "");
    Expect(0, 1479, '\P{Is_Ccc=0_0_0_0_0_0_0018}', "");
    Expect(1, 1479, '\P{^Is_Ccc=0_0_0_0_0_0_0018}', "");
    Expect(0, 1480, '\p{Is_Ccc=0_0_0_0_0_0_0018}', "");
    Expect(1, 1480, '\p{^Is_Ccc=0_0_0_0_0_0_0018}', "");
    Expect(1, 1480, '\P{Is_Ccc=0_0_0_0_0_0_0018}', "");
    Expect(0, 1480, '\P{^Is_Ccc=0_0_0_0_0_0_0018}', "");
    Error('\p{Canonical_Combining_Class=	ccc19:=}');
    Error('\P{Canonical_Combining_Class=	ccc19:=}');
    Expect(1, 1466, '\p{Canonical_Combining_Class=:\ACCC19\z:}', "");;
    Expect(0, 1467, '\p{Canonical_Combining_Class=:\ACCC19\z:}', "");;
    Expect(1, 1466, '\p{Canonical_Combining_Class=ccc19}', "");
    Expect(0, 1466, '\p{^Canonical_Combining_Class=ccc19}', "");
    Expect(0, 1466, '\P{Canonical_Combining_Class=ccc19}', "");
    Expect(1, 1466, '\P{^Canonical_Combining_Class=ccc19}', "");
    Expect(0, 1467, '\p{Canonical_Combining_Class=ccc19}', "");
    Expect(1, 1467, '\p{^Canonical_Combining_Class=ccc19}', "");
    Expect(1, 1467, '\P{Canonical_Combining_Class=ccc19}', "");
    Expect(0, 1467, '\P{^Canonical_Combining_Class=ccc19}', "");
    Expect(1, 1466, '\p{Canonical_Combining_Class=:\Accc19\z:}', "");;
    Expect(0, 1467, '\p{Canonical_Combining_Class=:\Accc19\z:}', "");;
    Expect(1, 1466, '\p{Canonical_Combining_Class= CCC19}', "");
    Expect(0, 1466, '\p{^Canonical_Combining_Class= CCC19}', "");
    Expect(0, 1466, '\P{Canonical_Combining_Class= CCC19}', "");
    Expect(1, 1466, '\P{^Canonical_Combining_Class= CCC19}', "");
    Expect(0, 1467, '\p{Canonical_Combining_Class= CCC19}', "");
    Expect(1, 1467, '\p{^Canonical_Combining_Class= CCC19}', "");
    Expect(1, 1467, '\P{Canonical_Combining_Class= CCC19}', "");
    Expect(0, 1467, '\P{^Canonical_Combining_Class= CCC19}', "");
    Error('\p{Ccc=-:=+00001_9}');
    Error('\P{Ccc=-:=+00001_9}');
    Expect(1, 1466, '\p{Ccc=:\A19\z:}', "");;
    Expect(0, 1467, '\p{Ccc=:\A19\z:}', "");;
    Expect(1, 1466, '\p{Ccc=00000000019}', "");
    Expect(0, 1466, '\p{^Ccc=00000000019}', "");
    Expect(0, 1466, '\P{Ccc=00000000019}', "");
    Expect(1, 1466, '\P{^Ccc=00000000019}', "");
    Expect(0, 1467, '\p{Ccc=00000000019}', "");
    Expect(1, 1467, '\p{^Ccc=00000000019}', "");
    Expect(1, 1467, '\P{Ccc=00000000019}', "");
    Expect(0, 1467, '\P{^Ccc=00000000019}', "");
    Error('\p{Is_Canonical_Combining_Class:   :=-CCC19}');
    Error('\P{Is_Canonical_Combining_Class:   :=-CCC19}');
    Expect(1, 1466, '\p{Is_Canonical_Combining_Class=ccc19}', "");
    Expect(0, 1466, '\p{^Is_Canonical_Combining_Class=ccc19}', "");
    Expect(0, 1466, '\P{Is_Canonical_Combining_Class=ccc19}', "");
    Expect(1, 1466, '\P{^Is_Canonical_Combining_Class=ccc19}', "");
    Expect(0, 1467, '\p{Is_Canonical_Combining_Class=ccc19}', "");
    Expect(1, 1467, '\p{^Is_Canonical_Combining_Class=ccc19}', "");
    Expect(1, 1467, '\P{Is_Canonical_Combining_Class=ccc19}', "");
    Expect(0, 1467, '\P{^Is_Canonical_Combining_Class=ccc19}', "");
    Expect(1, 1466, '\p{Is_Canonical_Combining_Class=_CCC19}', "");
    Expect(0, 1466, '\p{^Is_Canonical_Combining_Class=_CCC19}', "");
    Expect(0, 1466, '\P{Is_Canonical_Combining_Class=_CCC19}', "");
    Expect(1, 1466, '\P{^Is_Canonical_Combining_Class=_CCC19}', "");
    Expect(0, 1467, '\p{Is_Canonical_Combining_Class=_CCC19}', "");
    Expect(1, 1467, '\p{^Is_Canonical_Combining_Class=_CCC19}', "");
    Expect(1, 1467, '\P{Is_Canonical_Combining_Class=_CCC19}', "");
    Expect(0, 1467, '\P{^Is_Canonical_Combining_Class=_CCC19}', "");
    Error('\p{Is_Ccc=-:=0019}');
    Error('\P{Is_Ccc=-:=0019}');
    Expect(1, 1466, '\p{Is_Ccc=+000000019}', "");
    Expect(0, 1466, '\p{^Is_Ccc=+000000019}', "");
    Expect(0, 1466, '\P{Is_Ccc=+000000019}', "");
    Expect(1, 1466, '\P{^Is_Ccc=+000000019}', "");
    Expect(0, 1467, '\p{Is_Ccc=+000000019}', "");
    Expect(1, 1467, '\p{^Is_Ccc=+000000019}', "");
    Expect(1, 1467, '\P{Is_Ccc=+000000019}', "");
    Expect(0, 1467, '\P{^Is_Ccc=+000000019}', "");
    Error('\p{Canonical_Combining_Class=__ccc20/a/}');
    Error('\P{Canonical_Combining_Class=__ccc20/a/}');
    Expect(1, 1467, '\p{Canonical_Combining_Class=:\ACCC20\z:}', "");;
    Expect(0, 1468, '\p{Canonical_Combining_Class=:\ACCC20\z:}', "");;
    Expect(1, 1467, '\p{Canonical_Combining_Class=ccc20}', "");
    Expect(0, 1467, '\p{^Canonical_Combining_Class=ccc20}', "");
    Expect(0, 1467, '\P{Canonical_Combining_Class=ccc20}', "");
    Expect(1, 1467, '\P{^Canonical_Combining_Class=ccc20}', "");
    Expect(0, 1468, '\p{Canonical_Combining_Class=ccc20}', "");
    Expect(1, 1468, '\p{^Canonical_Combining_Class=ccc20}', "");
    Expect(1, 1468, '\P{Canonical_Combining_Class=ccc20}', "");
    Expect(0, 1468, '\P{^Canonical_Combining_Class=ccc20}', "");
    Expect(1, 1467, '\p{Canonical_Combining_Class=:\Accc20\z:}', "");;
    Expect(0, 1468, '\p{Canonical_Combining_Class=:\Accc20\z:}', "");;
    Expect(1, 1467, '\p{Canonical_Combining_Class=-_CCC20}', "");
    Expect(0, 1467, '\p{^Canonical_Combining_Class=-_CCC20}', "");
    Expect(0, 1467, '\P{Canonical_Combining_Class=-_CCC20}', "");
    Expect(1, 1467, '\P{^Canonical_Combining_Class=-_CCC20}', "");
    Expect(0, 1468, '\p{Canonical_Combining_Class=-_CCC20}', "");
    Expect(1, 1468, '\p{^Canonical_Combining_Class=-_CCC20}', "");
    Expect(1, 1468, '\P{Canonical_Combining_Class=-_CCC20}', "");
    Expect(0, 1468, '\P{^Canonical_Combining_Class=-_CCC20}', "");
    Error('\p{Ccc=/a/	_000020}');
    Error('\P{Ccc=/a/	_000020}');
    Expect(1, 1467, '\p{Ccc=:\A20\z:}', "");;
    Expect(0, 1468, '\p{Ccc=:\A20\z:}', "");;
    Expect(1, 1467, '\p{Ccc=+000000020}', "");
    Expect(0, 1467, '\p{^Ccc=+000000020}', "");
    Expect(0, 1467, '\P{Ccc=+000000020}', "");
    Expect(1, 1467, '\P{^Ccc=+000000020}', "");
    Expect(0, 1468, '\p{Ccc=+000000020}', "");
    Expect(1, 1468, '\p{^Ccc=+000000020}', "");
    Expect(1, 1468, '\P{Ccc=+000000020}', "");
    Expect(0, 1468, '\P{^Ccc=+000000020}', "");
    Error('\p{Is_Canonical_Combining_Class=/a/_-ccc20}');
    Error('\P{Is_Canonical_Combining_Class=/a/_-ccc20}');
    Expect(1, 1467, '\p{Is_Canonical_Combining_Class=ccc20}', "");
    Expect(0, 1467, '\p{^Is_Canonical_Combining_Class=ccc20}', "");
    Expect(0, 1467, '\P{Is_Canonical_Combining_Class=ccc20}', "");
    Expect(1, 1467, '\P{^Is_Canonical_Combining_Class=ccc20}', "");
    Expect(0, 1468, '\p{Is_Canonical_Combining_Class=ccc20}', "");
    Expect(1, 1468, '\p{^Is_Canonical_Combining_Class=ccc20}', "");
    Expect(1, 1468, '\P{Is_Canonical_Combining_Class=ccc20}', "");
    Expect(0, 1468, '\P{^Is_Canonical_Combining_Class=ccc20}', "");
    Expect(1, 1467, '\p{Is_Canonical_Combining_Class=		ccc20}', "");
    Expect(0, 1467, '\p{^Is_Canonical_Combining_Class=		ccc20}', "");
    Expect(0, 1467, '\P{Is_Canonical_Combining_Class=		ccc20}', "");
    Expect(1, 1467, '\P{^Is_Canonical_Combining_Class=		ccc20}', "");
    Expect(0, 1468, '\p{Is_Canonical_Combining_Class=		ccc20}', "");
    Expect(1, 1468, '\p{^Is_Canonical_Combining_Class=		ccc20}', "");
    Expect(1, 1468, '\P{Is_Canonical_Combining_Class=		ccc20}', "");
    Expect(0, 1468, '\P{^Is_Canonical_Combining_Class=		ccc20}', "");
    Error('\p{Is_Ccc=:=-+00020}');
    Error('\P{Is_Ccc=:=-+00020}');
    Expect(1, 1467, '\p{Is_Ccc=00000020}', "");
    Expect(0, 1467, '\p{^Is_Ccc=00000020}', "");
    Expect(0, 1467, '\P{Is_Ccc=00000020}', "");
    Expect(1, 1467, '\P{^Is_Ccc=00000020}', "");
    Expect(0, 1468, '\p{Is_Ccc=00000020}', "");
    Expect(1, 1468, '\p{^Is_Ccc=00000020}', "");
    Expect(1, 1468, '\P{Is_Ccc=00000020}', "");
    Expect(0, 1468, '\P{^Is_Ccc=00000020}', "");
    Error('\p{Canonical_Combining_Class=_	CCC21:=}');
    Error('\P{Canonical_Combining_Class=_	CCC21:=}');
    Expect(1, 1468, '\p{Canonical_Combining_Class=:\ACCC21\z:}', "");;
    Expect(0, 1469, '\p{Canonical_Combining_Class=:\ACCC21\z:}', "");;
    Expect(1, 1468, '\p{Canonical_Combining_Class=ccc21}', "");
    Expect(0, 1468, '\p{^Canonical_Combining_Class=ccc21}', "");
    Expect(0, 1468, '\P{Canonical_Combining_Class=ccc21}', "");
    Expect(1, 1468, '\P{^Canonical_Combining_Class=ccc21}', "");
    Expect(0, 1469, '\p{Canonical_Combining_Class=ccc21}', "");
    Expect(1, 1469, '\p{^Canonical_Combining_Class=ccc21}', "");
    Expect(1, 1469, '\P{Canonical_Combining_Class=ccc21}', "");
    Expect(0, 1469, '\P{^Canonical_Combining_Class=ccc21}', "");
    Expect(1, 1468, '\p{Canonical_Combining_Class=:\Accc21\z:}', "");;
    Expect(0, 1469, '\p{Canonical_Combining_Class=:\Accc21\z:}', "");;
    Expect(1, 1468, '\p{Canonical_Combining_Class= 	CCC21}', "");
    Expect(0, 1468, '\p{^Canonical_Combining_Class= 	CCC21}', "");
    Expect(0, 1468, '\P{Canonical_Combining_Class= 	CCC21}', "");
    Expect(1, 1468, '\P{^Canonical_Combining_Class= 	CCC21}', "");
    Expect(0, 1469, '\p{Canonical_Combining_Class= 	CCC21}', "");
    Expect(1, 1469, '\p{^Canonical_Combining_Class= 	CCC21}', "");
    Expect(1, 1469, '\P{Canonical_Combining_Class= 	CCC21}', "");
    Expect(0, 1469, '\P{^Canonical_Combining_Class= 	CCC21}', "");
    Error('\p{Ccc=/a/ -000000021}');
    Error('\P{Ccc=/a/ -000000021}');
    Expect(1, 1468, '\p{Ccc=:\A21\z:}', "");;
    Expect(0, 1469, '\p{Ccc=:\A21\z:}', "");;
    Expect(1, 1468, '\p{Ccc=0_0_0_21}', "");
    Expect(0, 1468, '\p{^Ccc=0_0_0_21}', "");
    Expect(0, 1468, '\P{Ccc=0_0_0_21}', "");
    Expect(1, 1468, '\P{^Ccc=0_0_0_21}', "");
    Expect(0, 1469, '\p{Ccc=0_0_0_21}', "");
    Expect(1, 1469, '\p{^Ccc=0_0_0_21}', "");
    Expect(1, 1469, '\P{Ccc=0_0_0_21}', "");
    Expect(0, 1469, '\P{^Ccc=0_0_0_21}', "");
    Error('\p{Is_Canonical_Combining_Class= 	CCC21/a/}');
    Error('\P{Is_Canonical_Combining_Class= 	CCC21/a/}');
    Expect(1, 1468, '\p{Is_Canonical_Combining_Class=ccc21}', "");
    Expect(0, 1468, '\p{^Is_Canonical_Combining_Class=ccc21}', "");
    Expect(0, 1468, '\P{Is_Canonical_Combining_Class=ccc21}', "");
    Expect(1, 1468, '\P{^Is_Canonical_Combining_Class=ccc21}', "");
    Expect(0, 1469, '\p{Is_Canonical_Combining_Class=ccc21}', "");
    Expect(1, 1469, '\p{^Is_Canonical_Combining_Class=ccc21}', "");
    Expect(1, 1469, '\P{Is_Canonical_Combining_Class=ccc21}', "");
    Expect(0, 1469, '\P{^Is_Canonical_Combining_Class=ccc21}', "");
    Expect(1, 1468, '\p{Is_Canonical_Combining_Class= ccc21}', "");
    Expect(0, 1468, '\p{^Is_Canonical_Combining_Class= ccc21}', "");
    Expect(0, 1468, '\P{Is_Canonical_Combining_Class= ccc21}', "");
    Expect(1, 1468, '\P{^Is_Canonical_Combining_Class= ccc21}', "");
    Expect(0, 1469, '\p{Is_Canonical_Combining_Class= ccc21}', "");
    Expect(1, 1469, '\p{^Is_Canonical_Combining_Class= ccc21}', "");
    Expect(1, 1469, '\P{Is_Canonical_Combining_Class= ccc21}', "");
    Expect(0, 1469, '\P{^Is_Canonical_Combining_Class= ccc21}', "");
    Error('\p{Is_Ccc=_ 0_0_0_0_0_0_0_0_0_21/a/}');
    Error('\P{Is_Ccc=_ 0_0_0_0_0_0_0_0_0_21/a/}');
    Expect(1, 1468, '\p{Is_Ccc=+00_00_00_21}', "");
    Expect(0, 1468, '\p{^Is_Ccc=+00_00_00_21}', "");
    Expect(0, 1468, '\P{Is_Ccc=+00_00_00_21}', "");
    Expect(1, 1468, '\P{^Is_Ccc=+00_00_00_21}', "");
    Expect(0, 1469, '\p{Is_Ccc=+00_00_00_21}', "");
    Expect(1, 1469, '\p{^Is_Ccc=+00_00_00_21}', "");
    Expect(1, 1469, '\P{Is_Ccc=+00_00_00_21}', "");
    Expect(0, 1469, '\P{^Is_Ccc=+00_00_00_21}', "");
    Error('\p{Canonical_Combining_Class=/a/__CCC22}');
    Error('\P{Canonical_Combining_Class=/a/__CCC22}');
    Expect(1, 1469, '\p{Canonical_Combining_Class=:\ACCC22\z:}', "");;
    Expect(0, 1470, '\p{Canonical_Combining_Class=:\ACCC22\z:}', "");;
    Expect(1, 1469, '\p{Canonical_Combining_Class=ccc22}', "");
    Expect(0, 1469, '\p{^Canonical_Combining_Class=ccc22}', "");
    Expect(0, 1469, '\P{Canonical_Combining_Class=ccc22}', "");
    Expect(1, 1469, '\P{^Canonical_Combining_Class=ccc22}', "");
    Expect(0, 1470, '\p{Canonical_Combining_Class=ccc22}', "");
    Expect(1, 1470, '\p{^Canonical_Combining_Class=ccc22}', "");
    Expect(1, 1470, '\P{Canonical_Combining_Class=ccc22}', "");
    Expect(0, 1470, '\P{^Canonical_Combining_Class=ccc22}', "");
    Expect(1, 1469, '\p{Canonical_Combining_Class=:\Accc22\z:}', "");;
    Expect(0, 1470, '\p{Canonical_Combining_Class=:\Accc22\z:}', "");;
    Expect(1, 1469, '\p{Canonical_Combining_Class=_ ccc22}', "");
    Expect(0, 1469, '\p{^Canonical_Combining_Class=_ ccc22}', "");
    Expect(0, 1469, '\P{Canonical_Combining_Class=_ ccc22}', "");
    Expect(1, 1469, '\P{^Canonical_Combining_Class=_ ccc22}', "");
    Expect(0, 1470, '\p{Canonical_Combining_Class=_ ccc22}', "");
    Expect(1, 1470, '\p{^Canonical_Combining_Class=_ ccc22}', "");
    Expect(1, 1470, '\P{Canonical_Combining_Class=_ ccc22}', "");
    Expect(0, 1470, '\P{^Canonical_Combining_Class=_ ccc22}', "");
    Error('\p{Ccc=	000022/a/}');
    Error('\P{Ccc=	000022/a/}');
    Expect(1, 1469, '\p{Ccc=:\A22\z:}', "");;
    Expect(0, 1470, '\p{Ccc=:\A22\z:}', "");;
    Expect(1, 1469, '\p{Ccc=0_0_0_0_0_22}', "");
    Expect(0, 1469, '\p{^Ccc=0_0_0_0_0_22}', "");
    Expect(0, 1469, '\P{Ccc=0_0_0_0_0_22}', "");
    Expect(1, 1469, '\P{^Ccc=0_0_0_0_0_22}', "");
    Expect(0, 1470, '\p{Ccc=0_0_0_0_0_22}', "");
    Expect(1, 1470, '\p{^Ccc=0_0_0_0_0_22}', "");
    Expect(1, 1470, '\P{Ccc=0_0_0_0_0_22}', "");
    Expect(0, 1470, '\P{^Ccc=0_0_0_0_0_22}', "");
    Error('\p{Is_Canonical_Combining_Class=  CCC22:=}');
    Error('\P{Is_Canonical_Combining_Class=  CCC22:=}');
    Expect(1, 1469, '\p{Is_Canonical_Combining_Class=ccc22}', "");
    Expect(0, 1469, '\p{^Is_Canonical_Combining_Class=ccc22}', "");
    Expect(0, 1469, '\P{Is_Canonical_Combining_Class=ccc22}', "");
    Expect(1, 1469, '\P{^Is_Canonical_Combining_Class=ccc22}', "");
    Expect(0, 1470, '\p{Is_Canonical_Combining_Class=ccc22}', "");
    Expect(1, 1470, '\p{^Is_Canonical_Combining_Class=ccc22}', "");
    Expect(1, 1470, '\P{Is_Canonical_Combining_Class=ccc22}', "");
    Expect(0, 1470, '\P{^Is_Canonical_Combining_Class=ccc22}', "");
    Expect(1, 1469, '\p{Is_Canonical_Combining_Class:		ccc22}', "");
    Expect(0, 1469, '\p{^Is_Canonical_Combining_Class:		ccc22}', "");
    Expect(0, 1469, '\P{Is_Canonical_Combining_Class:		ccc22}', "");
    Expect(1, 1469, '\P{^Is_Canonical_Combining_Class:		ccc22}', "");
    Expect(0, 1470, '\p{Is_Canonical_Combining_Class:		ccc22}', "");
    Expect(1, 1470, '\p{^Is_Canonical_Combining_Class:		ccc22}', "");
    Expect(1, 1470, '\P{Is_Canonical_Combining_Class:		ccc22}', "");
    Expect(0, 1470, '\P{^Is_Canonical_Combining_Class:		ccc22}', "");
    Error('\p{Is_Ccc=-00000000022:=}');
    Error('\P{Is_Ccc=-00000000022:=}');
    Expect(1, 1469, '\p{Is_Ccc=+022}', "");
    Expect(0, 1469, '\p{^Is_Ccc=+022}', "");
    Expect(0, 1469, '\P{Is_Ccc=+022}', "");
    Expect(1, 1469, '\P{^Is_Ccc=+022}', "");
    Expect(0, 1470, '\p{Is_Ccc=+022}', "");
    Expect(1, 1470, '\p{^Is_Ccc=+022}', "");
    Expect(1, 1470, '\P{Is_Ccc=+022}', "");
    Expect(0, 1470, '\P{^Is_Ccc=+022}', "");
    Error('\p{Canonical_Combining_Class=-:=CCC23}');
    Error('\P{Canonical_Combining_Class=-:=CCC23}');
    Expect(1, 1471, '\p{Canonical_Combining_Class=:\ACCC23\z:}', "");;
    Expect(0, 1472, '\p{Canonical_Combining_Class=:\ACCC23\z:}', "");;
    Expect(1, 1471, '\p{Canonical_Combining_Class=ccc23}', "");
    Expect(0, 1471, '\p{^Canonical_Combining_Class=ccc23}', "");
    Expect(0, 1471, '\P{Canonical_Combining_Class=ccc23}', "");
    Expect(1, 1471, '\P{^Canonical_Combining_Class=ccc23}', "");
    Expect(0, 1472, '\p{Canonical_Combining_Class=ccc23}', "");
    Expect(1, 1472, '\p{^Canonical_Combining_Class=ccc23}', "");
    Expect(1, 1472, '\P{Canonical_Combining_Class=ccc23}', "");
    Expect(0, 1472, '\P{^Canonical_Combining_Class=ccc23}', "");
    Expect(1, 1471, '\p{Canonical_Combining_Class=:\Accc23\z:}', "");;
    Expect(0, 1472, '\p{Canonical_Combining_Class=:\Accc23\z:}', "");;
    Expect(1, 1471, '\p{Canonical_Combining_Class= -CCC23}', "");
    Expect(0, 1471, '\p{^Canonical_Combining_Class= -CCC23}', "");
    Expect(0, 1471, '\P{Canonical_Combining_Class= -CCC23}', "");
    Expect(1, 1471, '\P{^Canonical_Combining_Class= -CCC23}', "");
    Expect(0, 1472, '\p{Canonical_Combining_Class= -CCC23}', "");
    Expect(1, 1472, '\p{^Canonical_Combining_Class= -CCC23}', "");
    Expect(1, 1472, '\P{Canonical_Combining_Class= -CCC23}', "");
    Expect(0, 1472, '\P{^Canonical_Combining_Class= -CCC23}', "");
    Error('\p{Ccc= _+00_00_00_00_23/a/}');
    Error('\P{Ccc= _+00_00_00_00_23/a/}');
    Expect(1, 1471, '\p{Ccc=:\A23\z:}', "");;
    Expect(0, 1472, '\p{Ccc=:\A23\z:}', "");;
    Expect(1, 1471, '\p{Ccc=00023}', "");
    Expect(0, 1471, '\p{^Ccc=00023}', "");
    Expect(0, 1471, '\P{Ccc=00023}', "");
    Expect(1, 1471, '\P{^Ccc=00023}', "");
    Expect(0, 1472, '\p{Ccc=00023}', "");
    Expect(1, 1472, '\p{^Ccc=00023}', "");
    Expect(1, 1472, '\P{Ccc=00023}', "");
    Expect(0, 1472, '\P{^Ccc=00023}', "");
    Error('\p{Is_Canonical_Combining_Class=:=		CCC23}');
    Error('\P{Is_Canonical_Combining_Class=:=		CCC23}');
    Expect(1, 1471, '\p{Is_Canonical_Combining_Class=ccc23}', "");
    Expect(0, 1471, '\p{^Is_Canonical_Combining_Class=ccc23}', "");
    Expect(0, 1471, '\P{Is_Canonical_Combining_Class=ccc23}', "");
    Expect(1, 1471, '\P{^Is_Canonical_Combining_Class=ccc23}', "");
    Expect(0, 1472, '\p{Is_Canonical_Combining_Class=ccc23}', "");
    Expect(1, 1472, '\p{^Is_Canonical_Combining_Class=ccc23}', "");
    Expect(1, 1472, '\P{Is_Canonical_Combining_Class=ccc23}', "");
    Expect(0, 1472, '\P{^Is_Canonical_Combining_Class=ccc23}', "");
    Expect(1, 1471, '\p{Is_Canonical_Combining_Class=-ccc23}', "");
    Expect(0, 1471, '\p{^Is_Canonical_Combining_Class=-ccc23}', "");
    Expect(0, 1471, '\P{Is_Canonical_Combining_Class=-ccc23}', "");
    Expect(1, 1471, '\P{^Is_Canonical_Combining_Class=-ccc23}', "");
    Expect(0, 1472, '\p{Is_Canonical_Combining_Class=-ccc23}', "");
    Expect(1, 1472, '\p{^Is_Canonical_Combining_Class=-ccc23}', "");
    Expect(1, 1472, '\P{Is_Canonical_Combining_Class=-ccc23}', "");
    Expect(0, 1472, '\P{^Is_Canonical_Combining_Class=-ccc23}', "");
    Error('\p{Is_Ccc=_:=0000023}');
    Error('\P{Is_Ccc=_:=0000023}');
    Expect(1, 1471, '\p{Is_Ccc:023}', "");
    Expect(0, 1471, '\p{^Is_Ccc:023}', "");
    Expect(0, 1471, '\P{Is_Ccc:023}', "");
    Expect(1, 1471, '\P{^Is_Ccc:023}', "");
    Expect(0, 1472, '\p{Is_Ccc:023}', "");
    Expect(1, 1472, '\p{^Is_Ccc:023}', "");
    Expect(1, 1472, '\P{Is_Ccc:023}', "");
    Expect(0, 1472, '\P{^Is_Ccc:023}', "");
    Error('\p{Canonical_Combining_Class= _CCC24/a/}');
    Error('\P{Canonical_Combining_Class= _CCC24/a/}');
    Expect(1, 1473, '\p{Canonical_Combining_Class=:\ACCC24\z:}', "");;
    Expect(0, 1474, '\p{Canonical_Combining_Class=:\ACCC24\z:}', "");;
    Expect(1, 1473, '\p{Canonical_Combining_Class=ccc24}', "");
    Expect(0, 1473, '\p{^Canonical_Combining_Class=ccc24}', "");
    Expect(0, 1473, '\P{Canonical_Combining_Class=ccc24}', "");
    Expect(1, 1473, '\P{^Canonical_Combining_Class=ccc24}', "");
    Expect(0, 1474, '\p{Canonical_Combining_Class=ccc24}', "");
    Expect(1, 1474, '\p{^Canonical_Combining_Class=ccc24}', "");
    Expect(1, 1474, '\P{Canonical_Combining_Class=ccc24}', "");
    Expect(0, 1474, '\P{^Canonical_Combining_Class=ccc24}', "");
    Expect(1, 1473, '\p{Canonical_Combining_Class=:\Accc24\z:}', "");;
    Expect(0, 1474, '\p{Canonical_Combining_Class=:\Accc24\z:}', "");;
    Expect(1, 1473, '\p{Canonical_Combining_Class:	- CCC24}', "");
    Expect(0, 1473, '\p{^Canonical_Combining_Class:	- CCC24}', "");
    Expect(0, 1473, '\P{Canonical_Combining_Class:	- CCC24}', "");
    Expect(1, 1473, '\P{^Canonical_Combining_Class:	- CCC24}', "");
    Expect(0, 1474, '\p{Canonical_Combining_Class:	- CCC24}', "");
    Expect(1, 1474, '\p{^Canonical_Combining_Class:	- CCC24}', "");
    Expect(1, 1474, '\P{Canonical_Combining_Class:	- CCC24}', "");
    Expect(0, 1474, '\P{^Canonical_Combining_Class:	- CCC24}', "");
    Error('\p{Ccc: :=		000_000_24}');
    Error('\P{Ccc: :=		000_000_24}');
    Expect(1, 1473, '\p{Ccc=:\A24\z:}', "");;
    Expect(0, 1474, '\p{Ccc=:\A24\z:}', "");;
    Expect(1, 1473, '\p{Ccc=0000000024}', "");
    Expect(0, 1473, '\p{^Ccc=0000000024}', "");
    Expect(0, 1473, '\P{Ccc=0000000024}', "");
    Expect(1, 1473, '\P{^Ccc=0000000024}', "");
    Expect(0, 1474, '\p{Ccc=0000000024}', "");
    Expect(1, 1474, '\p{^Ccc=0000000024}', "");
    Expect(1, 1474, '\P{Ccc=0000000024}', "");
    Expect(0, 1474, '\P{^Ccc=0000000024}', "");
    Error('\p{Is_Canonical_Combining_Class=-CCC24:=}');
    Error('\P{Is_Canonical_Combining_Class=-CCC24:=}');
    Expect(1, 1473, '\p{Is_Canonical_Combining_Class=ccc24}', "");
    Expect(0, 1473, '\p{^Is_Canonical_Combining_Class=ccc24}', "");
    Expect(0, 1473, '\P{Is_Canonical_Combining_Class=ccc24}', "");
    Expect(1, 1473, '\P{^Is_Canonical_Combining_Class=ccc24}', "");
    Expect(0, 1474, '\p{Is_Canonical_Combining_Class=ccc24}', "");
    Expect(1, 1474, '\p{^Is_Canonical_Combining_Class=ccc24}', "");
    Expect(1, 1474, '\P{Is_Canonical_Combining_Class=ccc24}', "");
    Expect(0, 1474, '\P{^Is_Canonical_Combining_Class=ccc24}', "");
    Expect(1, 1473, '\p{Is_Canonical_Combining_Class= _ccc24}', "");
    Expect(0, 1473, '\p{^Is_Canonical_Combining_Class= _ccc24}', "");
    Expect(0, 1473, '\P{Is_Canonical_Combining_Class= _ccc24}', "");
    Expect(1, 1473, '\P{^Is_Canonical_Combining_Class= _ccc24}', "");
    Expect(0, 1474, '\p{Is_Canonical_Combining_Class= _ccc24}', "");
    Expect(1, 1474, '\p{^Is_Canonical_Combining_Class= _ccc24}', "");
    Expect(1, 1474, '\P{Is_Canonical_Combining_Class= _ccc24}', "");
    Expect(0, 1474, '\P{^Is_Canonical_Combining_Class= _ccc24}', "");
    Error('\p{Is_Ccc=-0000_0002_4/a/}');
    Error('\P{Is_Ccc=-0000_0002_4/a/}');
    Expect(1, 1473, '\p{Is_Ccc=+000_000_24}', "");
    Expect(0, 1473, '\p{^Is_Ccc=+000_000_24}', "");
    Expect(0, 1473, '\P{Is_Ccc=+000_000_24}', "");
    Expect(1, 1473, '\P{^Is_Ccc=+000_000_24}', "");
    Expect(0, 1474, '\p{Is_Ccc=+000_000_24}', "");
    Expect(1, 1474, '\p{^Is_Ccc=+000_000_24}', "");
    Expect(1, 1474, '\P{Is_Ccc=+000_000_24}', "");
    Expect(0, 1474, '\P{^Is_Ccc=+000_000_24}', "");
    Error('\p{Canonical_Combining_Class=_:=CCC25}');
    Error('\P{Canonical_Combining_Class=_:=CCC25}');
    Expect(1, 1474, '\p{Canonical_Combining_Class=:\ACCC25\z:}', "");;
    Expect(0, 1475, '\p{Canonical_Combining_Class=:\ACCC25\z:}', "");;
    Expect(1, 1474, '\p{Canonical_Combining_Class=ccc25}', "");
    Expect(0, 1474, '\p{^Canonical_Combining_Class=ccc25}', "");
    Expect(0, 1474, '\P{Canonical_Combining_Class=ccc25}', "");
    Expect(1, 1474, '\P{^Canonical_Combining_Class=ccc25}', "");
    Expect(0, 1475, '\p{Canonical_Combining_Class=ccc25}', "");
    Expect(1, 1475, '\p{^Canonical_Combining_Class=ccc25}', "");
    Expect(1, 1475, '\P{Canonical_Combining_Class=ccc25}', "");
    Expect(0, 1475, '\P{^Canonical_Combining_Class=ccc25}', "");
    Expect(1, 1474, '\p{Canonical_Combining_Class=:\Accc25\z:}', "");;
    Expect(0, 1475, '\p{Canonical_Combining_Class=:\Accc25\z:}', "");;
    Expect(1, 1474, '\p{Canonical_Combining_Class: --CCC25}', "");
    Expect(0, 1474, '\p{^Canonical_Combining_Class: --CCC25}', "");
    Expect(0, 1474, '\P{Canonical_Combining_Class: --CCC25}', "");
    Expect(1, 1474, '\P{^Canonical_Combining_Class: --CCC25}', "");
    Expect(0, 1475, '\p{Canonical_Combining_Class: --CCC25}', "");
    Expect(1, 1475, '\p{^Canonical_Combining_Class: --CCC25}', "");
    Expect(1, 1475, '\P{Canonical_Combining_Class: --CCC25}', "");
    Expect(0, 1475, '\P{^Canonical_Combining_Class: --CCC25}', "");
    Error('\p{Ccc:--+000000025:=}');
    Error('\P{Ccc:--+000000025:=}');
    Expect(1, 1474, '\p{Ccc=:\A25\z:}', "");;
    Expect(0, 1475, '\p{Ccc=:\A25\z:}', "");;
    Expect(1, 1474, '\p{Ccc=25}', "");
    Expect(0, 1474, '\p{^Ccc=25}', "");
    Expect(0, 1474, '\P{Ccc=25}', "");
    Expect(1, 1474, '\P{^Ccc=25}', "");
    Expect(0, 1475, '\p{Ccc=25}', "");
    Expect(1, 1475, '\p{^Ccc=25}', "");
    Expect(1, 1475, '\P{Ccc=25}', "");
    Expect(0, 1475, '\P{^Ccc=25}', "");
    Error('\p{Is_Canonical_Combining_Class=CCC25:=}');
    Error('\P{Is_Canonical_Combining_Class=CCC25:=}');
    Expect(1, 1474, '\p{Is_Canonical_Combining_Class:	ccc25}', "");
    Expect(0, 1474, '\p{^Is_Canonical_Combining_Class:	ccc25}', "");
    Expect(0, 1474, '\P{Is_Canonical_Combining_Class:	ccc25}', "");
    Expect(1, 1474, '\P{^Is_Canonical_Combining_Class:	ccc25}', "");
    Expect(0, 1475, '\p{Is_Canonical_Combining_Class:	ccc25}', "");
    Expect(1, 1475, '\p{^Is_Canonical_Combining_Class:	ccc25}', "");
    Expect(1, 1475, '\P{Is_Canonical_Combining_Class:	ccc25}', "");
    Expect(0, 1475, '\P{^Is_Canonical_Combining_Class:	ccc25}', "");
    Expect(1, 1474, '\p{Is_Canonical_Combining_Class=- ccc25}', "");
    Expect(0, 1474, '\p{^Is_Canonical_Combining_Class=- ccc25}', "");
    Expect(0, 1474, '\P{Is_Canonical_Combining_Class=- ccc25}', "");
    Expect(1, 1474, '\P{^Is_Canonical_Combining_Class=- ccc25}', "");
    Expect(0, 1475, '\p{Is_Canonical_Combining_Class=- ccc25}', "");
    Expect(1, 1475, '\p{^Is_Canonical_Combining_Class=- ccc25}', "");
    Expect(1, 1475, '\P{Is_Canonical_Combining_Class=- ccc25}', "");
    Expect(0, 1475, '\P{^Is_Canonical_Combining_Class=- ccc25}', "");
    Error('\p{Is_Ccc=- 02_5:=}');
    Error('\P{Is_Ccc=- 02_5:=}');
    Expect(1, 1474, '\p{Is_Ccc: 00000025}', "");
    Expect(0, 1474, '\p{^Is_Ccc: 00000025}', "");
    Expect(0, 1474, '\P{Is_Ccc: 00000025}', "");
    Expect(1, 1474, '\P{^Is_Ccc: 00000025}', "");
    Expect(0, 1475, '\p{Is_Ccc: 00000025}', "");
    Expect(1, 1475, '\p{^Is_Ccc: 00000025}', "");
    Expect(1, 1475, '\P{Is_Ccc: 00000025}', "");
    Expect(0, 1475, '\P{^Is_Ccc: 00000025}', "");
    Error('\p{Canonical_Combining_Class=-/a/ccc26}');
    Error('\P{Canonical_Combining_Class=-/a/ccc26}');
    Expect(1, 64286, '\p{Canonical_Combining_Class=:\ACCC26\z:}', "");;
    Expect(0, 64287, '\p{Canonical_Combining_Class=:\ACCC26\z:}', "");;
    Expect(1, 64286, '\p{Canonical_Combining_Class=ccc26}', "");
    Expect(0, 64286, '\p{^Canonical_Combining_Class=ccc26}', "");
    Expect(0, 64286, '\P{Canonical_Combining_Class=ccc26}', "");
    Expect(1, 64286, '\P{^Canonical_Combining_Class=ccc26}', "");
    Expect(0, 64287, '\p{Canonical_Combining_Class=ccc26}', "");
    Expect(1, 64287, '\p{^Canonical_Combining_Class=ccc26}', "");
    Expect(1, 64287, '\P{Canonical_Combining_Class=ccc26}', "");
    Expect(0, 64287, '\P{^Canonical_Combining_Class=ccc26}', "");
    Expect(1, 64286, '\p{Canonical_Combining_Class=:\Accc26\z:}', "");;
    Expect(0, 64287, '\p{Canonical_Combining_Class=:\Accc26\z:}', "");;
    Expect(1, 64286, '\p{Canonical_Combining_Class= CCC26}', "");
    Expect(0, 64286, '\p{^Canonical_Combining_Class= CCC26}', "");
    Expect(0, 64286, '\P{Canonical_Combining_Class= CCC26}', "");
    Expect(1, 64286, '\P{^Canonical_Combining_Class= CCC26}', "");
    Expect(0, 64287, '\p{Canonical_Combining_Class= CCC26}', "");
    Expect(1, 64287, '\p{^Canonical_Combining_Class= CCC26}', "");
    Expect(1, 64287, '\P{Canonical_Combining_Class= CCC26}', "");
    Expect(0, 64287, '\P{^Canonical_Combining_Class= CCC26}', "");
    Error('\p{Ccc=:=	_0000000026}');
    Error('\P{Ccc=:=	_0000000026}');
    Expect(1, 64286, '\p{Ccc=:\A26\z:}', "");;
    Expect(0, 64287, '\p{Ccc=:\A26\z:}', "");;
    Expect(1, 64286, '\p{Ccc=0_0_26}', "");
    Expect(0, 64286, '\p{^Ccc=0_0_26}', "");
    Expect(0, 64286, '\P{Ccc=0_0_26}', "");
    Expect(1, 64286, '\P{^Ccc=0_0_26}', "");
    Expect(0, 64287, '\p{Ccc=0_0_26}', "");
    Expect(1, 64287, '\p{^Ccc=0_0_26}', "");
    Expect(1, 64287, '\P{Ccc=0_0_26}', "");
    Expect(0, 64287, '\P{^Ccc=0_0_26}', "");
    Error('\p{Is_Canonical_Combining_Class=:=CCC26}');
    Error('\P{Is_Canonical_Combining_Class=:=CCC26}');
    Expect(1, 64286, '\p{Is_Canonical_Combining_Class=ccc26}', "");
    Expect(0, 64286, '\p{^Is_Canonical_Combining_Class=ccc26}', "");
    Expect(0, 64286, '\P{Is_Canonical_Combining_Class=ccc26}', "");
    Expect(1, 64286, '\P{^Is_Canonical_Combining_Class=ccc26}', "");
    Expect(0, 64287, '\p{Is_Canonical_Combining_Class=ccc26}', "");
    Expect(1, 64287, '\p{^Is_Canonical_Combining_Class=ccc26}', "");
    Expect(1, 64287, '\P{Is_Canonical_Combining_Class=ccc26}', "");
    Expect(0, 64287, '\P{^Is_Canonical_Combining_Class=ccc26}', "");
    Expect(1, 64286, '\p{Is_Canonical_Combining_Class=  CCC26}', "");
    Expect(0, 64286, '\p{^Is_Canonical_Combining_Class=  CCC26}', "");
    Expect(0, 64286, '\P{Is_Canonical_Combining_Class=  CCC26}', "");
    Expect(1, 64286, '\P{^Is_Canonical_Combining_Class=  CCC26}', "");
    Expect(0, 64287, '\p{Is_Canonical_Combining_Class=  CCC26}', "");
    Expect(1, 64287, '\p{^Is_Canonical_Combining_Class=  CCC26}', "");
    Expect(1, 64287, '\P{Is_Canonical_Combining_Class=  CCC26}', "");
    Expect(0, 64287, '\P{^Is_Canonical_Combining_Class=  CCC26}', "");
    Error('\p{Is_Ccc= 0_0_0_0_0026/a/}');
    Error('\P{Is_Ccc= 0_0_0_0_0026/a/}');
    Expect(1, 64286, '\p{Is_Ccc=+000_002_6}', "");
    Expect(0, 64286, '\p{^Is_Ccc=+000_002_6}', "");
    Expect(0, 64286, '\P{Is_Ccc=+000_002_6}', "");
    Expect(1, 64286, '\P{^Is_Ccc=+000_002_6}', "");
    Expect(0, 64287, '\p{Is_Ccc=+000_002_6}', "");
    Expect(1, 64287, '\p{^Is_Ccc=+000_002_6}', "");
    Expect(1, 64287, '\P{Is_Ccc=+000_002_6}', "");
    Expect(0, 64287, '\P{^Is_Ccc=+000_002_6}', "");
    Error('\p{Canonical_Combining_Class=	CCC27/a/}');
    Error('\P{Canonical_Combining_Class=	CCC27/a/}');
    Expect(1, 2288, '\p{Canonical_Combining_Class=:\ACCC27\z:}', "");;
    Expect(0, 2289, '\p{Canonical_Combining_Class=:\ACCC27\z:}', "");;
    Expect(1, 2288, '\p{Canonical_Combining_Class=ccc27}', "");
    Expect(0, 2288, '\p{^Canonical_Combining_Class=ccc27}', "");
    Expect(0, 2288, '\P{Canonical_Combining_Class=ccc27}', "");
    Expect(1, 2288, '\P{^Canonical_Combining_Class=ccc27}', "");
    Expect(0, 2289, '\p{Canonical_Combining_Class=ccc27}', "");
    Expect(1, 2289, '\p{^Canonical_Combining_Class=ccc27}', "");
    Expect(1, 2289, '\P{Canonical_Combining_Class=ccc27}', "");
    Expect(0, 2289, '\P{^Canonical_Combining_Class=ccc27}', "");
    Expect(1, 2288, '\p{Canonical_Combining_Class=:\Accc27\z:}', "");;
    Expect(0, 2289, '\p{Canonical_Combining_Class=:\Accc27\z:}', "");;
    Expect(1, 2288, '\p{Canonical_Combining_Class= CCC27}', "");
    Expect(0, 2288, '\p{^Canonical_Combining_Class= CCC27}', "");
    Expect(0, 2288, '\P{Canonical_Combining_Class= CCC27}', "");
    Expect(1, 2288, '\P{^Canonical_Combining_Class= CCC27}', "");
    Expect(0, 2289, '\p{Canonical_Combining_Class= CCC27}', "");
    Expect(1, 2289, '\p{^Canonical_Combining_Class= CCC27}', "");
    Expect(1, 2289, '\P{Canonical_Combining_Class= CCC27}', "");
    Expect(0, 2289, '\P{^Canonical_Combining_Class= CCC27}', "");
    Error('\p{Ccc:	 :=+00_00_00_027}');
    Error('\P{Ccc:	 :=+00_00_00_027}');
    Expect(1, 2288, '\p{Ccc=:\A27\z:}', "");;
    Expect(0, 2289, '\p{Ccc=:\A27\z:}', "");;
    Expect(1, 2288, '\p{Ccc=+027}', "");
    Expect(0, 2288, '\p{^Ccc=+027}', "");
    Expect(0, 2288, '\P{Ccc=+027}', "");
    Expect(1, 2288, '\P{^Ccc=+027}', "");
    Expect(0, 2289, '\p{Ccc=+027}', "");
    Expect(1, 2289, '\p{^Ccc=+027}', "");
    Expect(1, 2289, '\P{Ccc=+027}', "");
    Expect(0, 2289, '\P{^Ccc=+027}', "");
    Error('\p{Is_Canonical_Combining_Class=_:=CCC27}');
    Error('\P{Is_Canonical_Combining_Class=_:=CCC27}');
    Expect(1, 2288, '\p{Is_Canonical_Combining_Class=ccc27}', "");
    Expect(0, 2288, '\p{^Is_Canonical_Combining_Class=ccc27}', "");
    Expect(0, 2288, '\P{Is_Canonical_Combining_Class=ccc27}', "");
    Expect(1, 2288, '\P{^Is_Canonical_Combining_Class=ccc27}', "");
    Expect(0, 2289, '\p{Is_Canonical_Combining_Class=ccc27}', "");
    Expect(1, 2289, '\p{^Is_Canonical_Combining_Class=ccc27}', "");
    Expect(1, 2289, '\P{Is_Canonical_Combining_Class=ccc27}', "");
    Expect(0, 2289, '\P{^Is_Canonical_Combining_Class=ccc27}', "");
    Expect(1, 2288, '\p{Is_Canonical_Combining_Class= ccc27}', "");
    Expect(0, 2288, '\p{^Is_Canonical_Combining_Class= ccc27}', "");
    Expect(0, 2288, '\P{Is_Canonical_Combining_Class= ccc27}', "");
    Expect(1, 2288, '\P{^Is_Canonical_Combining_Class= ccc27}', "");
    Expect(0, 2289, '\p{Is_Canonical_Combining_Class= ccc27}', "");
    Expect(1, 2289, '\p{^Is_Canonical_Combining_Class= ccc27}', "");
    Expect(1, 2289, '\P{Is_Canonical_Combining_Class= ccc27}', "");
    Expect(0, 2289, '\P{^Is_Canonical_Combining_Class= ccc27}', "");
    Error('\p{Is_Ccc=--0000000027/a/}');
    Error('\P{Is_Ccc=--0000000027/a/}');
    Expect(1, 2288, '\p{Is_Ccc=00000000027}', "");
    Expect(0, 2288, '\p{^Is_Ccc=00000000027}', "");
    Expect(0, 2288, '\P{Is_Ccc=00000000027}', "");
    Expect(1, 2288, '\P{^Is_Ccc=00000000027}', "");
    Expect(0, 2289, '\p{Is_Ccc=00000000027}', "");
    Expect(1, 2289, '\p{^Is_Ccc=00000000027}', "");
    Expect(1, 2289, '\P{Is_Ccc=00000000027}', "");
    Expect(0, 2289, '\P{^Is_Ccc=00000000027}', "");
    Error('\p{Canonical_Combining_Class=_-ccc28/a/}');
    Error('\P{Canonical_Combining_Class=_-ccc28/a/}');
    Expect(1, 2289, '\p{Canonical_Combining_Class=:\ACCC28\z:}', "");;
    Expect(0, 2290, '\p{Canonical_Combining_Class=:\ACCC28\z:}', "");;
    Expect(1, 2289, '\p{Canonical_Combining_Class=ccc28}', "");
    Expect(0, 2289, '\p{^Canonical_Combining_Class=ccc28}', "");
    Expect(0, 2289, '\P{Canonical_Combining_Class=ccc28}', "");
    Expect(1, 2289, '\P{^Canonical_Combining_Class=ccc28}', "");
    Expect(0, 2290, '\p{Canonical_Combining_Class=ccc28}', "");
    Expect(1, 2290, '\p{^Canonical_Combining_Class=ccc28}', "");
    Expect(1, 2290, '\P{Canonical_Combining_Class=ccc28}', "");
    Expect(0, 2290, '\P{^Canonical_Combining_Class=ccc28}', "");
    Expect(1, 2289, '\p{Canonical_Combining_Class=:\Accc28\z:}', "");;
    Expect(0, 2290, '\p{Canonical_Combining_Class=:\Accc28\z:}', "");;
    Expect(1, 2289, '\p{Canonical_Combining_Class=	CCC28}', "");
    Expect(0, 2289, '\p{^Canonical_Combining_Class=	CCC28}', "");
    Expect(0, 2289, '\P{Canonical_Combining_Class=	CCC28}', "");
    Expect(1, 2289, '\P{^Canonical_Combining_Class=	CCC28}', "");
    Expect(0, 2290, '\p{Canonical_Combining_Class=	CCC28}', "");
    Expect(1, 2290, '\p{^Canonical_Combining_Class=	CCC28}', "");
    Expect(1, 2290, '\P{Canonical_Combining_Class=	CCC28}', "");
    Expect(0, 2290, '\P{^Canonical_Combining_Class=	CCC28}', "");
    Error('\p{Ccc=-/a/0_0_28}');
    Error('\P{Ccc=-/a/0_0_28}');
    Expect(1, 2289, '\p{Ccc=:\A28\z:}', "");;
    Expect(0, 2290, '\p{Ccc=:\A28\z:}', "");;
    Expect(1, 2289, '\p{Ccc=00028}', "");
    Expect(0, 2289, '\p{^Ccc=00028}', "");
    Expect(0, 2289, '\P{Ccc=00028}', "");
    Expect(1, 2289, '\P{^Ccc=00028}', "");
    Expect(0, 2290, '\p{Ccc=00028}', "");
    Expect(1, 2290, '\p{^Ccc=00028}', "");
    Expect(1, 2290, '\P{Ccc=00028}', "");
    Expect(0, 2290, '\P{^Ccc=00028}', "");
    Error('\p{Is_Canonical_Combining_Class: _-ccc28/a/}');
    Error('\P{Is_Canonical_Combining_Class: _-ccc28/a/}');
    Expect(1, 2289, '\p{Is_Canonical_Combining_Class=ccc28}', "");
    Expect(0, 2289, '\p{^Is_Canonical_Combining_Class=ccc28}', "");
    Expect(0, 2289, '\P{Is_Canonical_Combining_Class=ccc28}', "");
    Expect(1, 2289, '\P{^Is_Canonical_Combining_Class=ccc28}', "");
    Expect(0, 2290, '\p{Is_Canonical_Combining_Class=ccc28}', "");
    Expect(1, 2290, '\p{^Is_Canonical_Combining_Class=ccc28}', "");
    Expect(1, 2290, '\P{Is_Canonical_Combining_Class=ccc28}', "");
    Expect(0, 2290, '\P{^Is_Canonical_Combining_Class=ccc28}', "");
    Expect(1, 2289, '\p{Is_Canonical_Combining_Class=	ccc28}', "");
    Expect(0, 2289, '\p{^Is_Canonical_Combining_Class=	ccc28}', "");
    Expect(0, 2289, '\P{Is_Canonical_Combining_Class=	ccc28}', "");
    Expect(1, 2289, '\P{^Is_Canonical_Combining_Class=	ccc28}', "");
    Expect(0, 2290, '\p{Is_Canonical_Combining_Class=	ccc28}', "");
    Expect(1, 2290, '\p{^Is_Canonical_Combining_Class=	ccc28}', "");
    Expect(1, 2290, '\P{Is_Canonical_Combining_Class=	ccc28}', "");
    Expect(0, 2290, '\P{^Is_Canonical_Combining_Class=	ccc28}', "");
    Error('\p{Is_Ccc:   _+000000028:=}');
    Error('\P{Is_Ccc:   _+000000028:=}');
    Expect(1, 2289, '\p{Is_Ccc=28}', "");
    Expect(0, 2289, '\p{^Is_Ccc=28}', "");
    Expect(0, 2289, '\P{Is_Ccc=28}', "");
    Expect(1, 2289, '\P{^Is_Ccc=28}', "");
    Expect(0, 2290, '\p{Is_Ccc=28}', "");
    Expect(1, 2290, '\p{^Is_Ccc=28}', "");
    Expect(1, 2290, '\P{Is_Ccc=28}', "");
    Expect(0, 2290, '\P{^Is_Ccc=28}', "");
    Error('\p{Canonical_Combining_Class=-ccc29:=}');
    Error('\P{Canonical_Combining_Class=-ccc29:=}');
    Expect(1, 2290, '\p{Canonical_Combining_Class=:\ACCC29\z:}', "");;
    Expect(0, 2291, '\p{Canonical_Combining_Class=:\ACCC29\z:}', "");;
    Expect(1, 2290, '\p{Canonical_Combining_Class=ccc29}', "");
    Expect(0, 2290, '\p{^Canonical_Combining_Class=ccc29}', "");
    Expect(0, 2290, '\P{Canonical_Combining_Class=ccc29}', "");
    Expect(1, 2290, '\P{^Canonical_Combining_Class=ccc29}', "");
    Expect(0, 2291, '\p{Canonical_Combining_Class=ccc29}', "");
    Expect(1, 2291, '\p{^Canonical_Combining_Class=ccc29}', "");
    Expect(1, 2291, '\P{Canonical_Combining_Class=ccc29}', "");
    Expect(0, 2291, '\P{^Canonical_Combining_Class=ccc29}', "");
    Expect(1, 2290, '\p{Canonical_Combining_Class=:\Accc29\z:}', "");;
    Expect(0, 2291, '\p{Canonical_Combining_Class=:\Accc29\z:}', "");;
    Expect(1, 2290, '\p{Canonical_Combining_Class=	CCC29}', "");
    Expect(0, 2290, '\p{^Canonical_Combining_Class=	CCC29}', "");
    Expect(0, 2290, '\P{Canonical_Combining_Class=	CCC29}', "");
    Expect(1, 2290, '\P{^Canonical_Combining_Class=	CCC29}', "");
    Expect(0, 2291, '\p{Canonical_Combining_Class=	CCC29}', "");
    Expect(1, 2291, '\p{^Canonical_Combining_Class=	CCC29}', "");
    Expect(1, 2291, '\P{Canonical_Combining_Class=	CCC29}', "");
    Expect(0, 2291, '\P{^Canonical_Combining_Class=	CCC29}', "");
    Error('\p{Ccc=_ 2_9/a/}');
    Error('\P{Ccc=_ 2_9/a/}');
    Expect(1, 2290, '\p{Ccc=:\A29\z:}', "");;
    Expect(0, 2291, '\p{Ccc=:\A29\z:}', "");;
    Expect(1, 2290, '\p{Ccc=0029}', "");
    Expect(0, 2290, '\p{^Ccc=0029}', "");
    Expect(0, 2290, '\P{Ccc=0029}', "");
    Expect(1, 2290, '\P{^Ccc=0029}', "");
    Expect(0, 2291, '\p{Ccc=0029}', "");
    Expect(1, 2291, '\p{^Ccc=0029}', "");
    Expect(1, 2291, '\P{Ccc=0029}', "");
    Expect(0, 2291, '\P{^Ccc=0029}', "");
    Error('\p{Is_Canonical_Combining_Class= :=ccc29}');
    Error('\P{Is_Canonical_Combining_Class= :=ccc29}');
    Expect(1, 2290, '\p{Is_Canonical_Combining_Class=ccc29}', "");
    Expect(0, 2290, '\p{^Is_Canonical_Combining_Class=ccc29}', "");
    Expect(0, 2290, '\P{Is_Canonical_Combining_Class=ccc29}', "");
    Expect(1, 2290, '\P{^Is_Canonical_Combining_Class=ccc29}', "");
    Expect(0, 2291, '\p{Is_Canonical_Combining_Class=ccc29}', "");
    Expect(1, 2291, '\p{^Is_Canonical_Combining_Class=ccc29}', "");
    Expect(1, 2291, '\P{Is_Canonical_Combining_Class=ccc29}', "");
    Expect(0, 2291, '\P{^Is_Canonical_Combining_Class=ccc29}', "");
    Expect(1, 2290, '\p{Is_Canonical_Combining_Class= CCC29}', "");
    Expect(0, 2290, '\p{^Is_Canonical_Combining_Class= CCC29}', "");
    Expect(0, 2290, '\P{Is_Canonical_Combining_Class= CCC29}', "");
    Expect(1, 2290, '\P{^Is_Canonical_Combining_Class= CCC29}', "");
    Expect(0, 2291, '\p{Is_Canonical_Combining_Class= CCC29}', "");
    Expect(1, 2291, '\p{^Is_Canonical_Combining_Class= CCC29}', "");
    Expect(1, 2291, '\P{Is_Canonical_Combining_Class= CCC29}', "");
    Expect(0, 2291, '\P{^Is_Canonical_Combining_Class= CCC29}', "");
    Error('\p{Is_Ccc=/a/-0_0_0_0_0_0_00029}');
    Error('\P{Is_Ccc=/a/-0_0_0_0_0_0_00029}');
    Expect(1, 2290, '\p{Is_Ccc=+0000029}', "");
    Expect(0, 2290, '\p{^Is_Ccc=+0000029}', "");
    Expect(0, 2290, '\P{Is_Ccc=+0000029}', "");
    Expect(1, 2290, '\P{^Is_Ccc=+0000029}', "");
    Expect(0, 2291, '\p{Is_Ccc=+0000029}', "");
    Expect(1, 2291, '\p{^Is_Ccc=+0000029}', "");
    Expect(1, 2291, '\P{Is_Ccc=+0000029}', "");
    Expect(0, 2291, '\P{^Is_Ccc=+0000029}', "");
    Error('\p{Canonical_Combining_Class=	CCC30/a/}');
    Error('\P{Canonical_Combining_Class=	CCC30/a/}');
    Expect(1, 1614, '\p{Canonical_Combining_Class=:\ACCC30\z:}', "");;
    Expect(0, 1615, '\p{Canonical_Combining_Class=:\ACCC30\z:}', "");;
    Expect(1, 1614, '\p{Canonical_Combining_Class=ccc30}', "");
    Expect(0, 1614, '\p{^Canonical_Combining_Class=ccc30}', "");
    Expect(0, 1614, '\P{Canonical_Combining_Class=ccc30}', "");
    Expect(1, 1614, '\P{^Canonical_Combining_Class=ccc30}', "");
    Expect(0, 1615, '\p{Canonical_Combining_Class=ccc30}', "");
    Expect(1, 1615, '\p{^Canonical_Combining_Class=ccc30}', "");
    Expect(1, 1615, '\P{Canonical_Combining_Class=ccc30}', "");
    Expect(0, 1615, '\P{^Canonical_Combining_Class=ccc30}', "");
    Expect(1, 1614, '\p{Canonical_Combining_Class=:\Accc30\z:}', "");;
    Expect(0, 1615, '\p{Canonical_Combining_Class=:\Accc30\z:}', "");;
    Expect(1, 1614, '\p{Canonical_Combining_Class=	-CCC30}', "");
    Expect(0, 1614, '\p{^Canonical_Combining_Class=	-CCC30}', "");
    Expect(0, 1614, '\P{Canonical_Combining_Class=	-CCC30}', "");
    Expect(1, 1614, '\P{^Canonical_Combining_Class=	-CCC30}', "");
    Expect(0, 1615, '\p{Canonical_Combining_Class=	-CCC30}', "");
    Expect(1, 1615, '\p{^Canonical_Combining_Class=	-CCC30}', "");
    Expect(1, 1615, '\P{Canonical_Combining_Class=	-CCC30}', "");
    Expect(0, 1615, '\P{^Canonical_Combining_Class=	-CCC30}', "");
    Error('\p{Ccc=:=	_0000_0000_30}');
    Error('\P{Ccc=:=	_0000_0000_30}');
    Expect(1, 1614, '\p{Ccc=:\A30\z:}', "");;
    Expect(0, 1615, '\p{Ccc=:\A30\z:}', "");;
    Expect(1, 1614, '\p{Ccc=00_03_0}', "");
    Expect(0, 1614, '\p{^Ccc=00_03_0}', "");
    Expect(0, 1614, '\P{Ccc=00_03_0}', "");
    Expect(1, 1614, '\P{^Ccc=00_03_0}', "");
    Expect(0, 1615, '\p{Ccc=00_03_0}', "");
    Expect(1, 1615, '\p{^Ccc=00_03_0}', "");
    Expect(1, 1615, '\P{Ccc=00_03_0}', "");
    Expect(0, 1615, '\P{^Ccc=00_03_0}', "");
    Error('\p{Is_Canonical_Combining_Class=:=  CCC30}');
    Error('\P{Is_Canonical_Combining_Class=:=  CCC30}');
    Expect(1, 1614, '\p{Is_Canonical_Combining_Class=ccc30}', "");
    Expect(0, 1614, '\p{^Is_Canonical_Combining_Class=ccc30}', "");
    Expect(0, 1614, '\P{Is_Canonical_Combining_Class=ccc30}', "");
    Expect(1, 1614, '\P{^Is_Canonical_Combining_Class=ccc30}', "");
    Expect(0, 1615, '\p{Is_Canonical_Combining_Class=ccc30}', "");
    Expect(1, 1615, '\p{^Is_Canonical_Combining_Class=ccc30}', "");
    Expect(1, 1615, '\P{Is_Canonical_Combining_Class=ccc30}', "");
    Expect(0, 1615, '\P{^Is_Canonical_Combining_Class=ccc30}', "");
    Expect(1, 1614, '\p{Is_Canonical_Combining_Class=-_CCC30}', "");
    Expect(0, 1614, '\p{^Is_Canonical_Combining_Class=-_CCC30}', "");
    Expect(0, 1614, '\P{Is_Canonical_Combining_Class=-_CCC30}', "");
    Expect(1, 1614, '\P{^Is_Canonical_Combining_Class=-_CCC30}', "");
    Expect(0, 1615, '\p{Is_Canonical_Combining_Class=-_CCC30}', "");
    Expect(1, 1615, '\p{^Is_Canonical_Combining_Class=-_CCC30}', "");
    Expect(1, 1615, '\P{Is_Canonical_Combining_Class=-_CCC30}', "");
    Expect(0, 1615, '\P{^Is_Canonical_Combining_Class=-_CCC30}', "");
    Error('\p{Is_Ccc=	00000030/a/}');
    Error('\P{Is_Ccc=	00000030/a/}');
    Expect(1, 1614, '\p{Is_Ccc=030}', "");
    Expect(0, 1614, '\p{^Is_Ccc=030}', "");
    Expect(0, 1614, '\P{Is_Ccc=030}', "");
    Expect(1, 1614, '\P{^Is_Ccc=030}', "");
    Expect(0, 1615, '\p{Is_Ccc=030}', "");
    Expect(1, 1615, '\p{^Is_Ccc=030}', "");
    Expect(1, 1615, '\P{Is_Ccc=030}', "");
    Expect(0, 1615, '\P{^Is_Ccc=030}', "");
    Error('\p{Canonical_Combining_Class=	:=CCC31}');
    Error('\P{Canonical_Combining_Class=	:=CCC31}');
    Expect(1, 1615, '\p{Canonical_Combining_Class=:\ACCC31\z:}', "");;
    Expect(0, 1616, '\p{Canonical_Combining_Class=:\ACCC31\z:}', "");;
    Expect(1, 1615, '\p{Canonical_Combining_Class=ccc31}', "");
    Expect(0, 1615, '\p{^Canonical_Combining_Class=ccc31}', "");
    Expect(0, 1615, '\P{Canonical_Combining_Class=ccc31}', "");
    Expect(1, 1615, '\P{^Canonical_Combining_Class=ccc31}', "");
    Expect(0, 1616, '\p{Canonical_Combining_Class=ccc31}', "");
    Expect(1, 1616, '\p{^Canonical_Combining_Class=ccc31}', "");
    Expect(1, 1616, '\P{Canonical_Combining_Class=ccc31}', "");
    Expect(0, 1616, '\P{^Canonical_Combining_Class=ccc31}', "");
    Expect(1, 1615, '\p{Canonical_Combining_Class=:\Accc31\z:}', "");;
    Expect(0, 1616, '\p{Canonical_Combining_Class=:\Accc31\z:}', "");;
    Expect(1, 1615, '\p{Canonical_Combining_Class= 	CCC31}', "");
    Expect(0, 1615, '\p{^Canonical_Combining_Class= 	CCC31}', "");
    Expect(0, 1615, '\P{Canonical_Combining_Class= 	CCC31}', "");
    Expect(1, 1615, '\P{^Canonical_Combining_Class= 	CCC31}', "");
    Expect(0, 1616, '\p{Canonical_Combining_Class= 	CCC31}', "");
    Expect(1, 1616, '\p{^Canonical_Combining_Class= 	CCC31}', "");
    Expect(1, 1616, '\P{Canonical_Combining_Class= 	CCC31}', "");
    Expect(0, 1616, '\P{^Canonical_Combining_Class= 	CCC31}', "");
    Error('\p{Ccc:   :=--0003_1}');
    Error('\P{Ccc:   :=--0003_1}');
    Expect(1, 1615, '\p{Ccc=:\A31\z:}', "");;
    Expect(0, 1616, '\p{Ccc=:\A31\z:}', "");;
    Expect(1, 1615, '\p{Ccc=003_1}', "");
    Expect(0, 1615, '\p{^Ccc=003_1}', "");
    Expect(0, 1615, '\P{Ccc=003_1}', "");
    Expect(1, 1615, '\P{^Ccc=003_1}', "");
    Expect(0, 1616, '\p{Ccc=003_1}', "");
    Expect(1, 1616, '\p{^Ccc=003_1}', "");
    Expect(1, 1616, '\P{Ccc=003_1}', "");
    Expect(0, 1616, '\P{^Ccc=003_1}', "");
    Error('\p{Is_Canonical_Combining_Class=:=CCC31}');
    Error('\P{Is_Canonical_Combining_Class=:=CCC31}');
    Expect(1, 1615, '\p{Is_Canonical_Combining_Class=ccc31}', "");
    Expect(0, 1615, '\p{^Is_Canonical_Combining_Class=ccc31}', "");
    Expect(0, 1615, '\P{Is_Canonical_Combining_Class=ccc31}', "");
    Expect(1, 1615, '\P{^Is_Canonical_Combining_Class=ccc31}', "");
    Expect(0, 1616, '\p{Is_Canonical_Combining_Class=ccc31}', "");
    Expect(1, 1616, '\p{^Is_Canonical_Combining_Class=ccc31}', "");
    Expect(1, 1616, '\P{Is_Canonical_Combining_Class=ccc31}', "");
    Expect(0, 1616, '\P{^Is_Canonical_Combining_Class=ccc31}', "");
    Expect(1, 1615, '\p{Is_Canonical_Combining_Class=	_CCC31}', "");
    Expect(0, 1615, '\p{^Is_Canonical_Combining_Class=	_CCC31}', "");
    Expect(0, 1615, '\P{Is_Canonical_Combining_Class=	_CCC31}', "");
    Expect(1, 1615, '\P{^Is_Canonical_Combining_Class=	_CCC31}', "");
    Expect(0, 1616, '\p{Is_Canonical_Combining_Class=	_CCC31}', "");
    Expect(1, 1616, '\p{^Is_Canonical_Combining_Class=	_CCC31}', "");
    Expect(1, 1616, '\P{Is_Canonical_Combining_Class=	_CCC31}', "");
    Expect(0, 1616, '\P{^Is_Canonical_Combining_Class=	_CCC31}', "");
    Error('\p{Is_Ccc=	000031/a/}');
    Error('\P{Is_Ccc=	000031/a/}');
    Expect(1, 1615, '\p{Is_Ccc=0_0_0_031}', "");
    Expect(0, 1615, '\p{^Is_Ccc=0_0_0_031}', "");
    Expect(0, 1615, '\P{Is_Ccc=0_0_0_031}', "");
    Expect(1, 1615, '\P{^Is_Ccc=0_0_0_031}', "");
    Expect(0, 1616, '\p{Is_Ccc=0_0_0_031}', "");
    Expect(1, 1616, '\p{^Is_Ccc=0_0_0_031}', "");
    Expect(1, 1616, '\P{Is_Ccc=0_0_0_031}', "");
    Expect(0, 1616, '\P{^Is_Ccc=0_0_0_031}', "");
    Error('\p{Canonical_Combining_Class= /a/CCC32}');
    Error('\P{Canonical_Combining_Class= /a/CCC32}');
    Expect(1, 1616, '\p{Canonical_Combining_Class=:\ACCC32\z:}', "");;
    Expect(0, 1617, '\p{Canonical_Combining_Class=:\ACCC32\z:}', "");;
    Expect(1, 1616, '\p{Canonical_Combining_Class:   ccc32}', "");
    Expect(0, 1616, '\p{^Canonical_Combining_Class:   ccc32}', "");
    Expect(0, 1616, '\P{Canonical_Combining_Class:   ccc32}', "");
    Expect(1, 1616, '\P{^Canonical_Combining_Class:   ccc32}', "");
    Expect(0, 1617, '\p{Canonical_Combining_Class:   ccc32}', "");
    Expect(1, 1617, '\p{^Canonical_Combining_Class:   ccc32}', "");
    Expect(1, 1617, '\P{Canonical_Combining_Class:   ccc32}', "");
    Expect(0, 1617, '\P{^Canonical_Combining_Class:   ccc32}', "");
    Expect(1, 1616, '\p{Canonical_Combining_Class=:\Accc32\z:}', "");;
    Expect(0, 1617, '\p{Canonical_Combining_Class=:\Accc32\z:}', "");;
    Expect(1, 1616, '\p{Canonical_Combining_Class=-CCC32}', "");
    Expect(0, 1616, '\p{^Canonical_Combining_Class=-CCC32}', "");
    Expect(0, 1616, '\P{Canonical_Combining_Class=-CCC32}', "");
    Expect(1, 1616, '\P{^Canonical_Combining_Class=-CCC32}', "");
    Expect(0, 1617, '\p{Canonical_Combining_Class=-CCC32}', "");
    Expect(1, 1617, '\p{^Canonical_Combining_Class=-CCC32}', "");
    Expect(1, 1617, '\P{Canonical_Combining_Class=-CCC32}', "");
    Expect(0, 1617, '\P{^Canonical_Combining_Class=-CCC32}', "");
    Error('\p{Ccc:	:=03_2}');
    Error('\P{Ccc:	:=03_2}');
    Expect(1, 1616, '\p{Ccc=:\A32\z:}', "");;
    Expect(0, 1617, '\p{Ccc=:\A32\z:}', "");;
    Expect(1, 1616, '\p{Ccc=+003_2}', "");
    Expect(0, 1616, '\p{^Ccc=+003_2}', "");
    Expect(0, 1616, '\P{Ccc=+003_2}', "");
    Expect(1, 1616, '\P{^Ccc=+003_2}', "");
    Expect(0, 1617, '\p{Ccc=+003_2}', "");
    Expect(1, 1617, '\p{^Ccc=+003_2}', "");
    Expect(1, 1617, '\P{Ccc=+003_2}', "");
    Expect(0, 1617, '\P{^Ccc=+003_2}', "");
    Error('\p{Is_Canonical_Combining_Class=:=_	CCC32}');
    Error('\P{Is_Canonical_Combining_Class=:=_	CCC32}');
    Expect(1, 1616, '\p{Is_Canonical_Combining_Class=ccc32}', "");
    Expect(0, 1616, '\p{^Is_Canonical_Combining_Class=ccc32}', "");
    Expect(0, 1616, '\P{Is_Canonical_Combining_Class=ccc32}', "");
    Expect(1, 1616, '\P{^Is_Canonical_Combining_Class=ccc32}', "");
    Expect(0, 1617, '\p{Is_Canonical_Combining_Class=ccc32}', "");
    Expect(1, 1617, '\p{^Is_Canonical_Combining_Class=ccc32}', "");
    Expect(1, 1617, '\P{Is_Canonical_Combining_Class=ccc32}', "");
    Expect(0, 1617, '\P{^Is_Canonical_Combining_Class=ccc32}', "");
    Expect(1, 1616, '\p{Is_Canonical_Combining_Class=_CCC32}', "");
    Expect(0, 1616, '\p{^Is_Canonical_Combining_Class=_CCC32}', "");
    Expect(0, 1616, '\P{Is_Canonical_Combining_Class=_CCC32}', "");
    Expect(1, 1616, '\P{^Is_Canonical_Combining_Class=_CCC32}', "");
    Expect(0, 1617, '\p{Is_Canonical_Combining_Class=_CCC32}', "");
    Expect(1, 1617, '\p{^Is_Canonical_Combining_Class=_CCC32}', "");
    Expect(1, 1617, '\P{Is_Canonical_Combining_Class=_CCC32}', "");
    Expect(0, 1617, '\P{^Is_Canonical_Combining_Class=_CCC32}', "");
    Error('\p{Is_Ccc=-+00_00_00_03_2:=}');
    Error('\P{Is_Ccc=-+00_00_00_03_2:=}');
    Expect(1, 1616, '\p{Is_Ccc=+0_0_32}', "");
    Expect(0, 1616, '\p{^Is_Ccc=+0_0_32}', "");
    Expect(0, 1616, '\P{Is_Ccc=+0_0_32}', "");
    Expect(1, 1616, '\P{^Is_Ccc=+0_0_32}', "");
    Expect(0, 1617, '\p{Is_Ccc=+0_0_32}', "");
    Expect(1, 1617, '\p{^Is_Ccc=+0_0_32}', "");
    Expect(1, 1617, '\P{Is_Ccc=+0_0_32}', "");
    Expect(0, 1617, '\P{^Is_Ccc=+0_0_32}', "");
    Error('\p{Canonical_Combining_Class= :=CCC33}');
    Error('\P{Canonical_Combining_Class= :=CCC33}');
    Expect(1, 1617, '\p{Canonical_Combining_Class=:\ACCC33\z:}', "");;
    Expect(0, 1618, '\p{Canonical_Combining_Class=:\ACCC33\z:}', "");;
    Expect(1, 1617, '\p{Canonical_Combining_Class=ccc33}', "");
    Expect(0, 1617, '\p{^Canonical_Combining_Class=ccc33}', "");
    Expect(0, 1617, '\P{Canonical_Combining_Class=ccc33}', "");
    Expect(1, 1617, '\P{^Canonical_Combining_Class=ccc33}', "");
    Expect(0, 1618, '\p{Canonical_Combining_Class=ccc33}', "");
    Expect(1, 1618, '\p{^Canonical_Combining_Class=ccc33}', "");
    Expect(1, 1618, '\P{Canonical_Combining_Class=ccc33}', "");
    Expect(0, 1618, '\P{^Canonical_Combining_Class=ccc33}', "");
    Expect(1, 1617, '\p{Canonical_Combining_Class=:\Accc33\z:}', "");;
    Expect(0, 1618, '\p{Canonical_Combining_Class=:\Accc33\z:}', "");;
    Expect(1, 1617, '\p{Canonical_Combining_Class=	 CCC33}', "");
    Expect(0, 1617, '\p{^Canonical_Combining_Class=	 CCC33}', "");
    Expect(0, 1617, '\P{Canonical_Combining_Class=	 CCC33}', "");
    Expect(1, 1617, '\P{^Canonical_Combining_Class=	 CCC33}', "");
    Expect(0, 1618, '\p{Canonical_Combining_Class=	 CCC33}', "");
    Expect(1, 1618, '\p{^Canonical_Combining_Class=	 CCC33}', "");
    Expect(1, 1618, '\P{Canonical_Combining_Class=	 CCC33}', "");
    Expect(0, 1618, '\P{^Canonical_Combining_Class=	 CCC33}', "");
    Error('\p{Ccc=:=_-00033}');
    Error('\P{Ccc=:=_-00033}');
    Expect(1, 1617, '\p{Ccc=:\A33\z:}', "");;
    Expect(0, 1618, '\p{Ccc=:\A33\z:}', "");;
    Expect(1, 1617, '\p{Ccc=+33}', "");
    Expect(0, 1617, '\p{^Ccc=+33}', "");
    Expect(0, 1617, '\P{Ccc=+33}', "");
    Expect(1, 1617, '\P{^Ccc=+33}', "");
    Expect(0, 1618, '\p{Ccc=+33}', "");
    Expect(1, 1618, '\p{^Ccc=+33}', "");
    Expect(1, 1618, '\P{Ccc=+33}', "");
    Expect(0, 1618, '\P{^Ccc=+33}', "");
    Error('\p{Is_Canonical_Combining_Class=_/a/CCC33}');
    Error('\P{Is_Canonical_Combining_Class=_/a/CCC33}');
    Expect(1, 1617, '\p{Is_Canonical_Combining_Class=ccc33}', "");
    Expect(0, 1617, '\p{^Is_Canonical_Combining_Class=ccc33}', "");
    Expect(0, 1617, '\P{Is_Canonical_Combining_Class=ccc33}', "");
    Expect(1, 1617, '\P{^Is_Canonical_Combining_Class=ccc33}', "");
    Expect(0, 1618, '\p{Is_Canonical_Combining_Class=ccc33}', "");
    Expect(1, 1618, '\p{^Is_Canonical_Combining_Class=ccc33}', "");
    Expect(1, 1618, '\P{Is_Canonical_Combining_Class=ccc33}', "");
    Expect(0, 1618, '\P{^Is_Canonical_Combining_Class=ccc33}', "");
    Expect(1, 1617, '\p{Is_Canonical_Combining_Class= _CCC33}', "");
    Expect(0, 1617, '\p{^Is_Canonical_Combining_Class= _CCC33}', "");
    Expect(0, 1617, '\P{Is_Canonical_Combining_Class= _CCC33}', "");
    Expect(1, 1617, '\P{^Is_Canonical_Combining_Class= _CCC33}', "");
    Expect(0, 1618, '\p{Is_Canonical_Combining_Class= _CCC33}', "");
    Expect(1, 1618, '\p{^Is_Canonical_Combining_Class= _CCC33}', "");
    Expect(1, 1618, '\P{Is_Canonical_Combining_Class= _CCC33}', "");
    Expect(0, 1618, '\P{^Is_Canonical_Combining_Class= _CCC33}', "");
    Error('\p{Is_Ccc=/a/ -0033}');
    Error('\P{Is_Ccc=/a/ -0033}');
    Expect(1, 1617, '\p{Is_Ccc=00000033}', "");
    Expect(0, 1617, '\p{^Is_Ccc=00000033}', "");
    Expect(0, 1617, '\P{Is_Ccc=00000033}', "");
    Expect(1, 1617, '\P{^Is_Ccc=00000033}', "");
    Expect(0, 1618, '\p{Is_Ccc=00000033}', "");
    Expect(1, 1618, '\p{^Is_Ccc=00000033}', "");
    Expect(1, 1618, '\P{Is_Ccc=00000033}', "");
    Expect(0, 1618, '\P{^Is_Ccc=00000033}', "");
    Error('\p{Canonical_Combining_Class=--CCC34:=}');
    Error('\P{Canonical_Combining_Class=--CCC34:=}');
    Expect(1, 1618, '\p{Canonical_Combining_Class=:\ACCC34\z:}', "");;
    Expect(0, 1619, '\p{Canonical_Combining_Class=:\ACCC34\z:}', "");;
    Expect(1, 1618, '\p{Canonical_Combining_Class=ccc34}', "");
    Expect(0, 1618, '\p{^Canonical_Combining_Class=ccc34}', "");
    Expect(0, 1618, '\P{Canonical_Combining_Class=ccc34}', "");
    Expect(1, 1618, '\P{^Canonical_Combining_Class=ccc34}', "");
    Expect(0, 1619, '\p{Canonical_Combining_Class=ccc34}', "");
    Expect(1, 1619, '\p{^Canonical_Combining_Class=ccc34}', "");
    Expect(1, 1619, '\P{Canonical_Combining_Class=ccc34}', "");
    Expect(0, 1619, '\P{^Canonical_Combining_Class=ccc34}', "");
    Expect(1, 1618, '\p{Canonical_Combining_Class=:\Accc34\z:}', "");;
    Expect(0, 1619, '\p{Canonical_Combining_Class=:\Accc34\z:}', "");;
    Expect(1, 1618, '\p{Canonical_Combining_Class:  CCC34}', "");
    Expect(0, 1618, '\p{^Canonical_Combining_Class:  CCC34}', "");
    Expect(0, 1618, '\P{Canonical_Combining_Class:  CCC34}', "");
    Expect(1, 1618, '\P{^Canonical_Combining_Class:  CCC34}', "");
    Expect(0, 1619, '\p{Canonical_Combining_Class:  CCC34}', "");
    Expect(1, 1619, '\p{^Canonical_Combining_Class:  CCC34}', "");
    Expect(1, 1619, '\P{Canonical_Combining_Class:  CCC34}', "");
    Expect(0, 1619, '\P{^Canonical_Combining_Class:  CCC34}', "");
    Error('\p{Ccc=-:=000034}');
    Error('\P{Ccc=-:=000034}');
    Expect(1, 1618, '\p{Ccc=:\A34\z:}', "");;
    Expect(0, 1619, '\p{Ccc=:\A34\z:}', "");;
    Expect(1, 1618, '\p{Ccc=3_4}', "");
    Expect(0, 1618, '\p{^Ccc=3_4}', "");
    Expect(0, 1618, '\P{Ccc=3_4}', "");
    Expect(1, 1618, '\P{^Ccc=3_4}', "");
    Expect(0, 1619, '\p{Ccc=3_4}', "");
    Expect(1, 1619, '\p{^Ccc=3_4}', "");
    Expect(1, 1619, '\P{Ccc=3_4}', "");
    Expect(0, 1619, '\P{^Ccc=3_4}', "");
    Error('\p{Is_Canonical_Combining_Class=/a/	CCC34}');
    Error('\P{Is_Canonical_Combining_Class=/a/	CCC34}');
    Expect(1, 1618, '\p{Is_Canonical_Combining_Class=ccc34}', "");
    Expect(0, 1618, '\p{^Is_Canonical_Combining_Class=ccc34}', "");
    Expect(0, 1618, '\P{Is_Canonical_Combining_Class=ccc34}', "");
    Expect(1, 1618, '\P{^Is_Canonical_Combining_Class=ccc34}', "");
    Expect(0, 1619, '\p{Is_Canonical_Combining_Class=ccc34}', "");
    Expect(1, 1619, '\p{^Is_Canonical_Combining_Class=ccc34}', "");
    Expect(1, 1619, '\P{Is_Canonical_Combining_Class=ccc34}', "");
    Expect(0, 1619, '\P{^Is_Canonical_Combining_Class=ccc34}', "");
    Expect(1, 1618, '\p{Is_Canonical_Combining_Class=	 CCC34}', "");
    Expect(0, 1618, '\p{^Is_Canonical_Combining_Class=	 CCC34}', "");
    Expect(0, 1618, '\P{Is_Canonical_Combining_Class=	 CCC34}', "");
    Expect(1, 1618, '\P{^Is_Canonical_Combining_Class=	 CCC34}', "");
    Expect(0, 1619, '\p{Is_Canonical_Combining_Class=	 CCC34}', "");
    Expect(1, 1619, '\p{^Is_Canonical_Combining_Class=	 CCC34}', "");
    Expect(1, 1619, '\P{Is_Canonical_Combining_Class=	 CCC34}', "");
    Expect(0, 1619, '\P{^Is_Canonical_Combining_Class=	 CCC34}', "");
    Error('\p{Is_Ccc=-:=34}');
    Error('\P{Is_Ccc=-:=34}');
    Expect(1, 1618, '\p{Is_Ccc=00000000034}', "");
    Expect(0, 1618, '\p{^Is_Ccc=00000000034}', "");
    Expect(0, 1618, '\P{Is_Ccc=00000000034}', "");
    Expect(1, 1618, '\P{^Is_Ccc=00000000034}', "");
    Expect(0, 1619, '\p{Is_Ccc=00000000034}', "");
    Expect(1, 1619, '\p{^Is_Ccc=00000000034}', "");
    Expect(1, 1619, '\P{Is_Ccc=00000000034}', "");
    Expect(0, 1619, '\P{^Is_Ccc=00000000034}', "");
    Error('\p{Canonical_Combining_Class= CCC35:=}');
    Error('\P{Canonical_Combining_Class= CCC35:=}');
    Expect(1, 1648, '\p{Canonical_Combining_Class=:\ACCC35\z:}', "");;
    Expect(0, 1649, '\p{Canonical_Combining_Class=:\ACCC35\z:}', "");;
    Expect(1, 1648, '\p{Canonical_Combining_Class=ccc35}', "");
    Expect(0, 1648, '\p{^Canonical_Combining_Class=ccc35}', "");
    Expect(0, 1648, '\P{Canonical_Combining_Class=ccc35}', "");
    Expect(1, 1648, '\P{^Canonical_Combining_Class=ccc35}', "");
    Expect(0, 1649, '\p{Canonical_Combining_Class=ccc35}', "");
    Expect(1, 1649, '\p{^Canonical_Combining_Class=ccc35}', "");
    Expect(1, 1649, '\P{Canonical_Combining_Class=ccc35}', "");
    Expect(0, 1649, '\P{^Canonical_Combining_Class=ccc35}', "");
    Expect(1, 1648, '\p{Canonical_Combining_Class=:\Accc35\z:}', "");;
    Expect(0, 1649, '\p{Canonical_Combining_Class=:\Accc35\z:}', "");;
    Expect(1, 1648, '\p{Canonical_Combining_Class= CCC35}', "");
    Expect(0, 1648, '\p{^Canonical_Combining_Class= CCC35}', "");
    Expect(0, 1648, '\P{Canonical_Combining_Class= CCC35}', "");
    Expect(1, 1648, '\P{^Canonical_Combining_Class= CCC35}', "");
    Expect(0, 1649, '\p{Canonical_Combining_Class= CCC35}', "");
    Expect(1, 1649, '\p{^Canonical_Combining_Class= CCC35}', "");
    Expect(1, 1649, '\P{Canonical_Combining_Class= CCC35}', "");
    Expect(0, 1649, '\P{^Canonical_Combining_Class= CCC35}', "");
    Error('\p{Ccc=  035:=}');
    Error('\P{Ccc=  035:=}');
    Expect(1, 1648, '\p{Ccc=:\A35\z:}', "");;
    Expect(0, 1649, '\p{Ccc=:\A35\z:}', "");;
    Expect(1, 1648, '\p{Ccc=0_0_0_035}', "");
    Expect(0, 1648, '\p{^Ccc=0_0_0_035}', "");
    Expect(0, 1648, '\P{Ccc=0_0_0_035}', "");
    Expect(1, 1648, '\P{^Ccc=0_0_0_035}', "");
    Expect(0, 1649, '\p{Ccc=0_0_0_035}', "");
    Expect(1, 1649, '\p{^Ccc=0_0_0_035}', "");
    Expect(1, 1649, '\P{Ccc=0_0_0_035}', "");
    Expect(0, 1649, '\P{^Ccc=0_0_0_035}', "");
    Error('\p{Is_Canonical_Combining_Class=_-CCC35:=}');
    Error('\P{Is_Canonical_Combining_Class=_-CCC35:=}');
    Expect(1, 1648, '\p{Is_Canonical_Combining_Class=ccc35}', "");
    Expect(0, 1648, '\p{^Is_Canonical_Combining_Class=ccc35}', "");
    Expect(0, 1648, '\P{Is_Canonical_Combining_Class=ccc35}', "");
    Expect(1, 1648, '\P{^Is_Canonical_Combining_Class=ccc35}', "");
    Expect(0, 1649, '\p{Is_Canonical_Combining_Class=ccc35}', "");
    Expect(1, 1649, '\p{^Is_Canonical_Combining_Class=ccc35}', "");
    Expect(1, 1649, '\P{Is_Canonical_Combining_Class=ccc35}', "");
    Expect(0, 1649, '\P{^Is_Canonical_Combining_Class=ccc35}', "");
    Expect(1, 1648, '\p{Is_Canonical_Combining_Class=_ CCC35}', "");
    Expect(0, 1648, '\p{^Is_Canonical_Combining_Class=_ CCC35}', "");
    Expect(0, 1648, '\P{Is_Canonical_Combining_Class=_ CCC35}', "");
    Expect(1, 1648, '\P{^Is_Canonical_Combining_Class=_ CCC35}', "");
    Expect(0, 1649, '\p{Is_Canonical_Combining_Class=_ CCC35}', "");
    Expect(1, 1649, '\p{^Is_Canonical_Combining_Class=_ CCC35}', "");
    Expect(1, 1649, '\P{Is_Canonical_Combining_Class=_ CCC35}', "");
    Expect(0, 1649, '\P{^Is_Canonical_Combining_Class=_ CCC35}', "");
    Error('\p{Is_Ccc=  0000000035:=}');
    Error('\P{Is_Ccc=  0000000035:=}');
    Expect(1, 1648, '\p{Is_Ccc=000_003_5}', "");
    Expect(0, 1648, '\p{^Is_Ccc=000_003_5}', "");
    Expect(0, 1648, '\P{Is_Ccc=000_003_5}', "");
    Expect(1, 1648, '\P{^Is_Ccc=000_003_5}', "");
    Expect(0, 1649, '\p{Is_Ccc=000_003_5}', "");
    Expect(1, 1649, '\p{^Is_Ccc=000_003_5}', "");
    Expect(1, 1649, '\P{Is_Ccc=000_003_5}', "");
    Expect(0, 1649, '\P{^Is_Ccc=000_003_5}', "");
    Error('\p{Canonical_Combining_Class=--CCC36:=}');
    Error('\P{Canonical_Combining_Class=--CCC36:=}');
    Expect(1, 1809, '\p{Canonical_Combining_Class=:\ACCC36\z:}', "");;
    Expect(0, 1810, '\p{Canonical_Combining_Class=:\ACCC36\z:}', "");;
    Expect(1, 1809, '\p{Canonical_Combining_Class=ccc36}', "");
    Expect(0, 1809, '\p{^Canonical_Combining_Class=ccc36}', "");
    Expect(0, 1809, '\P{Canonical_Combining_Class=ccc36}', "");
    Expect(1, 1809, '\P{^Canonical_Combining_Class=ccc36}', "");
    Expect(0, 1810, '\p{Canonical_Combining_Class=ccc36}', "");
    Expect(1, 1810, '\p{^Canonical_Combining_Class=ccc36}', "");
    Expect(1, 1810, '\P{Canonical_Combining_Class=ccc36}', "");
    Expect(0, 1810, '\P{^Canonical_Combining_Class=ccc36}', "");
    Expect(1, 1809, '\p{Canonical_Combining_Class=:\Accc36\z:}', "");;
    Expect(0, 1810, '\p{Canonical_Combining_Class=:\Accc36\z:}', "");;
    Expect(1, 1809, '\p{Canonical_Combining_Class=_	CCC36}', "");
    Expect(0, 1809, '\p{^Canonical_Combining_Class=_	CCC36}', "");
    Expect(0, 1809, '\P{Canonical_Combining_Class=_	CCC36}', "");
    Expect(1, 1809, '\P{^Canonical_Combining_Class=_	CCC36}', "");
    Expect(0, 1810, '\p{Canonical_Combining_Class=_	CCC36}', "");
    Expect(1, 1810, '\p{^Canonical_Combining_Class=_	CCC36}', "");
    Expect(1, 1810, '\P{Canonical_Combining_Class=_	CCC36}', "");
    Expect(0, 1810, '\P{^Canonical_Combining_Class=_	CCC36}', "");
    Error('\p{Ccc=	:=03_6}');
    Error('\P{Ccc=	:=03_6}');
    Expect(1, 1809, '\p{Ccc=:\A36\z:}', "");;
    Expect(0, 1810, '\p{Ccc=:\A36\z:}', "");;
    Expect(1, 1809, '\p{Ccc=000003_6}', "");
    Expect(0, 1809, '\p{^Ccc=000003_6}', "");
    Expect(0, 1809, '\P{Ccc=000003_6}', "");
    Expect(1, 1809, '\P{^Ccc=000003_6}', "");
    Expect(0, 1810, '\p{Ccc=000003_6}', "");
    Expect(1, 1810, '\p{^Ccc=000003_6}', "");
    Expect(1, 1810, '\P{Ccc=000003_6}', "");
    Expect(0, 1810, '\P{^Ccc=000003_6}', "");
    Error('\p{Is_Canonical_Combining_Class= -CCC36:=}');
    Error('\P{Is_Canonical_Combining_Class= -CCC36:=}');
    Expect(1, 1809, '\p{Is_Canonical_Combining_Class=ccc36}', "");
    Expect(0, 1809, '\p{^Is_Canonical_Combining_Class=ccc36}', "");
    Expect(0, 1809, '\P{Is_Canonical_Combining_Class=ccc36}', "");
    Expect(1, 1809, '\P{^Is_Canonical_Combining_Class=ccc36}', "");
    Expect(0, 1810, '\p{Is_Canonical_Combining_Class=ccc36}', "");
    Expect(1, 1810, '\p{^Is_Canonical_Combining_Class=ccc36}', "");
    Expect(1, 1810, '\P{Is_Canonical_Combining_Class=ccc36}', "");
    Expect(0, 1810, '\P{^Is_Canonical_Combining_Class=ccc36}', "");
    Expect(1, 1809, '\p{Is_Canonical_Combining_Class=- ccc36}', "");
    Expect(0, 1809, '\p{^Is_Canonical_Combining_Class=- ccc36}', "");
    Expect(0, 1809, '\P{Is_Canonical_Combining_Class=- ccc36}', "");
    Expect(1, 1809, '\P{^Is_Canonical_Combining_Class=- ccc36}', "");
    Expect(0, 1810, '\p{Is_Canonical_Combining_Class=- ccc36}', "");
    Expect(1, 1810, '\p{^Is_Canonical_Combining_Class=- ccc36}', "");
    Expect(1, 1810, '\P{Is_Canonical_Combining_Class=- ccc36}', "");
    Expect(0, 1810, '\P{^Is_Canonical_Combining_Class=- ccc36}', "");
    Error('\p{Is_Ccc=-:=03_6}');
    Error('\P{Is_Ccc=-:=03_6}');
    Expect(1, 1809, '\p{Is_Ccc=00000036}', "");
    Expect(0, 1809, '\p{^Is_Ccc=00000036}', "");
    Expect(0, 1809, '\P{Is_Ccc=00000036}', "");
    Expect(1, 1809, '\P{^Is_Ccc=00000036}', "");
    Expect(0, 1810, '\p{Is_Ccc=00000036}', "");
    Expect(1, 1810, '\p{^Is_Ccc=00000036}', "");
    Expect(1, 1810, '\P{Is_Ccc=00000036}', "");
    Expect(0, 1810, '\P{^Is_Ccc=00000036}', "");
    Error('\p{Canonical_Combining_Class=	:=CCC84}');
    Error('\P{Canonical_Combining_Class=	:=CCC84}');
    Expect(1, 3157, '\p{Canonical_Combining_Class=:\ACCC84\z:}', "");;
    Expect(0, 3158, '\p{Canonical_Combining_Class=:\ACCC84\z:}', "");;
    Expect(1, 3157, '\p{Canonical_Combining_Class=ccc84}', "");
    Expect(0, 3157, '\p{^Canonical_Combining_Class=ccc84}', "");
    Expect(0, 3157, '\P{Canonical_Combining_Class=ccc84}', "");
    Expect(1, 3157, '\P{^Canonical_Combining_Class=ccc84}', "");
    Expect(0, 3158, '\p{Canonical_Combining_Class=ccc84}', "");
    Expect(1, 3158, '\p{^Canonical_Combining_Class=ccc84}', "");
    Expect(1, 3158, '\P{Canonical_Combining_Class=ccc84}', "");
    Expect(0, 3158, '\P{^Canonical_Combining_Class=ccc84}', "");
    Expect(1, 3157, '\p{Canonical_Combining_Class=:\Accc84\z:}', "");;
    Expect(0, 3158, '\p{Canonical_Combining_Class=:\Accc84\z:}', "");;
    Expect(1, 3157, '\p{Canonical_Combining_Class=--CCC84}', "");
    Expect(0, 3157, '\p{^Canonical_Combining_Class=--CCC84}', "");
    Expect(0, 3157, '\P{Canonical_Combining_Class=--CCC84}', "");
    Expect(1, 3157, '\P{^Canonical_Combining_Class=--CCC84}', "");
    Expect(0, 3158, '\p{Canonical_Combining_Class=--CCC84}', "");
    Expect(1, 3158, '\p{^Canonical_Combining_Class=--CCC84}', "");
    Expect(1, 3158, '\P{Canonical_Combining_Class=--CCC84}', "");
    Expect(0, 3158, '\P{^Canonical_Combining_Class=--CCC84}', "");
    Error('\p{Ccc=  0_0_0_0_0_0_0_0084/a/}');
    Error('\P{Ccc=  0_0_0_0_0_0_0_0084/a/}');
    Expect(1, 3157, '\p{Ccc=:\A84\z:}', "");;
    Expect(0, 3158, '\p{Ccc=:\A84\z:}', "");;
    Expect(1, 3157, '\p{Ccc=+000084}', "");
    Expect(0, 3157, '\p{^Ccc=+000084}', "");
    Expect(0, 3157, '\P{Ccc=+000084}', "");
    Expect(1, 3157, '\P{^Ccc=+000084}', "");
    Expect(0, 3158, '\p{Ccc=+000084}', "");
    Expect(1, 3158, '\p{^Ccc=+000084}', "");
    Expect(1, 3158, '\P{Ccc=+000084}', "");
    Expect(0, 3158, '\P{^Ccc=+000084}', "");
    Error('\p{Is_Canonical_Combining_Class:    /a/ccc84}');
    Error('\P{Is_Canonical_Combining_Class:    /a/ccc84}');
    Expect(1, 3157, '\p{Is_Canonical_Combining_Class=ccc84}', "");
    Expect(0, 3157, '\p{^Is_Canonical_Combining_Class=ccc84}', "");
    Expect(0, 3157, '\P{Is_Canonical_Combining_Class=ccc84}', "");
    Expect(1, 3157, '\P{^Is_Canonical_Combining_Class=ccc84}', "");
    Expect(0, 3158, '\p{Is_Canonical_Combining_Class=ccc84}', "");
    Expect(1, 3158, '\p{^Is_Canonical_Combining_Class=ccc84}', "");
    Expect(1, 3158, '\P{Is_Canonical_Combining_Class=ccc84}', "");
    Expect(0, 3158, '\P{^Is_Canonical_Combining_Class=ccc84}', "");
    Expect(1, 3157, '\p{Is_Canonical_Combining_Class= _ccc84}', "");
    Expect(0, 3157, '\p{^Is_Canonical_Combining_Class= _ccc84}', "");
    Expect(0, 3157, '\P{Is_Canonical_Combining_Class= _ccc84}', "");
    Expect(1, 3157, '\P{^Is_Canonical_Combining_Class= _ccc84}', "");
    Expect(0, 3158, '\p{Is_Canonical_Combining_Class= _ccc84}', "");
    Expect(1, 3158, '\p{^Is_Canonical_Combining_Class= _ccc84}', "");
    Expect(1, 3158, '\P{Is_Canonical_Combining_Class= _ccc84}', "");
    Expect(0, 3158, '\P{^Is_Canonical_Combining_Class= _ccc84}', "");
    Error('\p{Is_Ccc=:=- 00_00_00_08_4}');
    Error('\P{Is_Ccc=:=- 00_00_00_08_4}');
    Expect(1, 3157, '\p{Is_Ccc=8_4}', "");
    Expect(0, 3157, '\p{^Is_Ccc=8_4}', "");
    Expect(0, 3157, '\P{Is_Ccc=8_4}', "");
    Expect(1, 3157, '\P{^Is_Ccc=8_4}', "");
    Expect(0, 3158, '\p{Is_Ccc=8_4}', "");
    Expect(1, 3158, '\p{^Is_Ccc=8_4}', "");
    Expect(1, 3158, '\P{Is_Ccc=8_4}', "");
    Expect(0, 3158, '\P{^Is_Ccc=8_4}', "");
    Error('\p{Canonical_Combining_Class=- CCC91/a/}');
    Error('\P{Canonical_Combining_Class=- CCC91/a/}');
    Expect(1, 3158, '\p{Canonical_Combining_Class=:\ACCC91\z:}', "");;
    Expect(0, 3159, '\p{Canonical_Combining_Class=:\ACCC91\z:}', "");;
    Expect(1, 3158, '\p{Canonical_Combining_Class=ccc91}', "");
    Expect(0, 3158, '\p{^Canonical_Combining_Class=ccc91}', "");
    Expect(0, 3158, '\P{Canonical_Combining_Class=ccc91}', "");
    Expect(1, 3158, '\P{^Canonical_Combining_Class=ccc91}', "");
    Expect(0, 3159, '\p{Canonical_Combining_Class=ccc91}', "");
    Expect(1, 3159, '\p{^Canonical_Combining_Class=ccc91}', "");
    Expect(1, 3159, '\P{Canonical_Combining_Class=ccc91}', "");
    Expect(0, 3159, '\P{^Canonical_Combining_Class=ccc91}', "");
    Expect(1, 3158, '\p{Canonical_Combining_Class=:\Accc91\z:}', "");;
    Expect(0, 3159, '\p{Canonical_Combining_Class=:\Accc91\z:}', "");;
    Expect(1, 3158, '\p{Canonical_Combining_Class=	_ccc91}', "");
    Expect(0, 3158, '\p{^Canonical_Combining_Class=	_ccc91}', "");
    Expect(0, 3158, '\P{Canonical_Combining_Class=	_ccc91}', "");
    Expect(1, 3158, '\P{^Canonical_Combining_Class=	_ccc91}', "");
    Expect(0, 3159, '\p{Canonical_Combining_Class=	_ccc91}', "");
    Expect(1, 3159, '\p{^Canonical_Combining_Class=	_ccc91}', "");
    Expect(1, 3159, '\P{Canonical_Combining_Class=	_ccc91}', "");
    Expect(0, 3159, '\P{^Canonical_Combining_Class=	_ccc91}', "");
    Error('\p{Ccc= /a/0000091}');
    Error('\P{Ccc= /a/0000091}');
    Expect(1, 3158, '\p{Ccc=:\A91\z:}', "");;
    Expect(0, 3159, '\p{Ccc=:\A91\z:}', "");;
    Expect(1, 3158, '\p{Ccc=+00091}', "");
    Expect(0, 3158, '\p{^Ccc=+00091}', "");
    Expect(0, 3158, '\P{Ccc=+00091}', "");
    Expect(1, 3158, '\P{^Ccc=+00091}', "");
    Expect(0, 3159, '\p{Ccc=+00091}', "");
    Expect(1, 3159, '\p{^Ccc=+00091}', "");
    Expect(1, 3159, '\P{Ccc=+00091}', "");
    Expect(0, 3159, '\P{^Ccc=+00091}', "");
    Error('\p{Is_Canonical_Combining_Class= CCC91/a/}');
    Error('\P{Is_Canonical_Combining_Class= CCC91/a/}');
    Expect(1, 3158, '\p{Is_Canonical_Combining_Class=ccc91}', "");
    Expect(0, 3158, '\p{^Is_Canonical_Combining_Class=ccc91}', "");
    Expect(0, 3158, '\P{Is_Canonical_Combining_Class=ccc91}', "");
    Expect(1, 3158, '\P{^Is_Canonical_Combining_Class=ccc91}', "");
    Expect(0, 3159, '\p{Is_Canonical_Combining_Class=ccc91}', "");
    Expect(1, 3159, '\p{^Is_Canonical_Combining_Class=ccc91}', "");
    Expect(1, 3159, '\P{Is_Canonical_Combining_Class=ccc91}', "");
    Expect(0, 3159, '\P{^Is_Canonical_Combining_Class=ccc91}', "");
    Expect(1, 3158, '\p{Is_Canonical_Combining_Class=--CCC91}', "");
    Expect(0, 3158, '\p{^Is_Canonical_Combining_Class=--CCC91}', "");
    Expect(0, 3158, '\P{Is_Canonical_Combining_Class=--CCC91}', "");
    Expect(1, 3158, '\P{^Is_Canonical_Combining_Class=--CCC91}', "");
    Expect(0, 3159, '\p{Is_Canonical_Combining_Class=--CCC91}', "");
    Expect(1, 3159, '\p{^Is_Canonical_Combining_Class=--CCC91}', "");
    Expect(1, 3159, '\P{Is_Canonical_Combining_Class=--CCC91}', "");
    Expect(0, 3159, '\P{^Is_Canonical_Combining_Class=--CCC91}', "");
    Error('\p{Is_Ccc=-+000091/a/}');
    Error('\P{Is_Ccc=-+000091/a/}');
    Expect(1, 3158, '\p{Is_Ccc=00000000091}', "");
    Expect(0, 3158, '\p{^Is_Ccc=00000000091}', "");
    Expect(0, 3158, '\P{Is_Ccc=00000000091}', "");
    Expect(1, 3158, '\P{^Is_Ccc=00000000091}', "");
    Expect(0, 3159, '\p{Is_Ccc=00000000091}', "");
    Expect(1, 3159, '\p{^Is_Ccc=00000000091}', "");
    Expect(1, 3159, '\P{Is_Ccc=00000000091}', "");
    Expect(0, 3159, '\P{^Is_Ccc=00000000091}', "");
    Error('\p{Canonical_Combining_Class=:=-Double_above}');
    Error('\P{Canonical_Combining_Class=:=-Double_above}');
    Expect(1, 7629, '\p{Canonical_Combining_Class=:\ADouble_Above\z:}', "");;
    Expect(0, 7630, '\p{Canonical_Combining_Class=:\ADouble_Above\z:}', "");;
    Expect(1, 7629, '\p{Canonical_Combining_Class=doubleabove}', "");
    Expect(0, 7629, '\p{^Canonical_Combining_Class=doubleabove}', "");
    Expect(0, 7629, '\P{Canonical_Combining_Class=doubleabove}', "");
    Expect(1, 7629, '\P{^Canonical_Combining_Class=doubleabove}', "");
    Expect(0, 7630, '\p{Canonical_Combining_Class=doubleabove}', "");
    Expect(1, 7630, '\p{^Canonical_Combining_Class=doubleabove}', "");
    Expect(1, 7630, '\P{Canonical_Combining_Class=doubleabove}', "");
    Expect(0, 7630, '\P{^Canonical_Combining_Class=doubleabove}', "");
    Expect(1, 7629, '\p{Canonical_Combining_Class=:\Adoubleabove\z:}', "");;
    Expect(0, 7630, '\p{Canonical_Combining_Class=:\Adoubleabove\z:}', "");;
    Expect(1, 7629, '\p{Canonical_Combining_Class=-_DOUBLE_Above}', "");
    Expect(0, 7629, '\p{^Canonical_Combining_Class=-_DOUBLE_Above}', "");
    Expect(0, 7629, '\P{Canonical_Combining_Class=-_DOUBLE_Above}', "");
    Expect(1, 7629, '\P{^Canonical_Combining_Class=-_DOUBLE_Above}', "");
    Expect(0, 7630, '\p{Canonical_Combining_Class=-_DOUBLE_Above}', "");
    Expect(1, 7630, '\p{^Canonical_Combining_Class=-_DOUBLE_Above}', "");
    Expect(1, 7630, '\P{Canonical_Combining_Class=-_DOUBLE_Above}', "");
    Expect(0, 7630, '\P{^Canonical_Combining_Class=-_DOUBLE_Above}', "");
    Error('\p{Ccc=DA/a/}');
    Error('\P{Ccc=DA/a/}');
    Expect(1, 7629, '\p{Ccc=:\ADA\z:}', "");;
    Expect(0, 7630, '\p{Ccc=:\ADA\z:}', "");;
    Expect(1, 7629, '\p{Ccc=da}', "");
    Expect(0, 7629, '\p{^Ccc=da}', "");
    Expect(0, 7629, '\P{Ccc=da}', "");
    Expect(1, 7629, '\P{^Ccc=da}', "");
    Expect(0, 7630, '\p{Ccc=da}', "");
    Expect(1, 7630, '\p{^Ccc=da}', "");
    Expect(1, 7630, '\P{Ccc=da}', "");
    Expect(0, 7630, '\P{^Ccc=da}', "");
    Expect(1, 7629, '\p{Ccc=:\Ada\z:}', "");;
    Expect(0, 7630, '\p{Ccc=:\Ada\z:}', "");;
    Expect(1, 7629, '\p{Ccc=_	DA}', "");
    Expect(0, 7629, '\p{^Ccc=_	DA}', "");
    Expect(0, 7629, '\P{Ccc=_	DA}', "");
    Expect(1, 7629, '\P{^Ccc=_	DA}', "");
    Expect(0, 7630, '\p{Ccc=_	DA}', "");
    Expect(1, 7630, '\p{^Ccc=_	DA}', "");
    Expect(1, 7630, '\P{Ccc=_	DA}', "");
    Expect(0, 7630, '\P{^Ccc=_	DA}', "");
    Error('\p{Is_Canonical_Combining_Class=	0234:=}');
    Error('\P{Is_Canonical_Combining_Class=	0234:=}');
    Expect(1, 7629, '\p{Is_Canonical_Combining_Class=0000000023_4}', "");
    Expect(0, 7629, '\p{^Is_Canonical_Combining_Class=0000000023_4}', "");
    Expect(0, 7629, '\P{Is_Canonical_Combining_Class=0000000023_4}', "");
    Expect(1, 7629, '\P{^Is_Canonical_Combining_Class=0000000023_4}', "");
    Expect(0, 7630, '\p{Is_Canonical_Combining_Class=0000000023_4}', "");
    Expect(1, 7630, '\p{^Is_Canonical_Combining_Class=0000000023_4}', "");
    Expect(1, 7630, '\P{Is_Canonical_Combining_Class=0000000023_4}', "");
    Expect(0, 7630, '\P{^Is_Canonical_Combining_Class=0000000023_4}', "");
    Error('\p{Is_Ccc=	-Double_Above/a/}');
    Error('\P{Is_Ccc=	-Double_Above/a/}');
    Expect(1, 7629, '\p{Is_Ccc=doubleabove}', "");
    Expect(0, 7629, '\p{^Is_Ccc=doubleabove}', "");
    Expect(0, 7629, '\P{Is_Ccc=doubleabove}', "");
    Expect(1, 7629, '\P{^Is_Ccc=doubleabove}', "");
    Expect(0, 7630, '\p{Is_Ccc=doubleabove}', "");
    Expect(1, 7630, '\p{^Is_Ccc=doubleabove}', "");
    Expect(1, 7630, '\P{Is_Ccc=doubleabove}', "");
    Expect(0, 7630, '\P{^Is_Ccc=doubleabove}', "");
    Expect(1, 7629, '\p{Is_Ccc=-_double_Above}', "");
    Expect(0, 7629, '\p{^Is_Ccc=-_double_Above}', "");
    Expect(0, 7629, '\P{Is_Ccc=-_double_Above}', "");
    Expect(1, 7629, '\P{^Is_Ccc=-_double_Above}', "");
    Expect(0, 7630, '\p{Is_Ccc=-_double_Above}', "");
    Expect(1, 7630, '\p{^Is_Ccc=-_double_Above}', "");
    Expect(1, 7630, '\P{Is_Ccc=-_double_Above}', "");
    Expect(0, 7630, '\P{^Is_Ccc=-_double_Above}', "");
    Error('\p{Canonical_Combining_Class=	/a/DOUBLE_below}');
    Error('\P{Canonical_Combining_Class=	/a/DOUBLE_below}');
    Expect(1, 7676, '\p{Canonical_Combining_Class=:\ADouble_Below\z:}', "");;
    Expect(0, 7677, '\p{Canonical_Combining_Class=:\ADouble_Below\z:}', "");;
    Expect(1, 7676, '\p{Canonical_Combining_Class=doublebelow}', "");
    Expect(0, 7676, '\p{^Canonical_Combining_Class=doublebelow}', "");
    Expect(0, 7676, '\P{Canonical_Combining_Class=doublebelow}', "");
    Expect(1, 7676, '\P{^Canonical_Combining_Class=doublebelow}', "");
    Expect(0, 7677, '\p{Canonical_Combining_Class=doublebelow}', "");
    Expect(1, 7677, '\p{^Canonical_Combining_Class=doublebelow}', "");
    Expect(1, 7677, '\P{Canonical_Combining_Class=doublebelow}', "");
    Expect(0, 7677, '\P{^Canonical_Combining_Class=doublebelow}', "");
    Expect(1, 7676, '\p{Canonical_Combining_Class=:\Adoublebelow\z:}', "");;
    Expect(0, 7677, '\p{Canonical_Combining_Class=:\Adoublebelow\z:}', "");;
    Expect(1, 7676, '\p{Canonical_Combining_Class=_DOUBLE_BELOW}', "");
    Expect(0, 7676, '\p{^Canonical_Combining_Class=_DOUBLE_BELOW}', "");
    Expect(0, 7676, '\P{Canonical_Combining_Class=_DOUBLE_BELOW}', "");
    Expect(1, 7676, '\P{^Canonical_Combining_Class=_DOUBLE_BELOW}', "");
    Expect(0, 7677, '\p{Canonical_Combining_Class=_DOUBLE_BELOW}', "");
    Expect(1, 7677, '\p{^Canonical_Combining_Class=_DOUBLE_BELOW}', "");
    Expect(1, 7677, '\P{Canonical_Combining_Class=_DOUBLE_BELOW}', "");
    Expect(0, 7677, '\P{^Canonical_Combining_Class=_DOUBLE_BELOW}', "");
    Error('\p{Ccc:   /a/-DB}');
    Error('\P{Ccc:   /a/-DB}');
    Expect(1, 7676, '\p{Ccc=:\ADB\z:}', "");;
    Expect(0, 7677, '\p{Ccc=:\ADB\z:}', "");;
    Expect(1, 7676, '\p{Ccc:db}', "");
    Expect(0, 7676, '\p{^Ccc:db}', "");
    Expect(0, 7676, '\P{Ccc:db}', "");
    Expect(1, 7676, '\P{^Ccc:db}', "");
    Expect(0, 7677, '\p{Ccc:db}', "");
    Expect(1, 7677, '\p{^Ccc:db}', "");
    Expect(1, 7677, '\P{Ccc:db}', "");
    Expect(0, 7677, '\P{^Ccc:db}', "");
    Expect(1, 7676, '\p{Ccc=:\Adb\z:}', "");;
    Expect(0, 7677, '\p{Ccc=:\Adb\z:}', "");;
    Expect(1, 7676, '\p{Ccc=_db}', "");
    Expect(0, 7676, '\p{^Ccc=_db}', "");
    Expect(0, 7676, '\P{Ccc=_db}', "");
    Expect(1, 7676, '\P{^Ccc=_db}', "");
    Expect(0, 7677, '\p{Ccc=_db}', "");
    Expect(1, 7677, '\p{^Ccc=_db}', "");
    Expect(1, 7677, '\P{Ccc=_db}', "");
    Expect(0, 7677, '\P{^Ccc=_db}', "");
    Error('\p{Is_Canonical_Combining_Class=:=	00_02_33}');
    Error('\P{Is_Canonical_Combining_Class=:=	00_02_33}');
    Expect(1, 7676, '\p{Is_Canonical_Combining_Class: 000000233}', "");
    Expect(0, 7676, '\p{^Is_Canonical_Combining_Class: 000000233}', "");
    Expect(0, 7676, '\P{Is_Canonical_Combining_Class: 000000233}', "");
    Expect(1, 7676, '\P{^Is_Canonical_Combining_Class: 000000233}', "");
    Expect(0, 7677, '\p{Is_Canonical_Combining_Class: 000000233}', "");
    Expect(1, 7677, '\p{^Is_Canonical_Combining_Class: 000000233}', "");
    Expect(1, 7677, '\P{Is_Canonical_Combining_Class: 000000233}', "");
    Expect(0, 7677, '\P{^Is_Canonical_Combining_Class: 000000233}', "");
    Error('\p{Is_Ccc=/a/Double_below}');
    Error('\P{Is_Ccc=/a/Double_below}');
    Expect(1, 7676, '\p{Is_Ccc=doublebelow}', "");
    Expect(0, 7676, '\p{^Is_Ccc=doublebelow}', "");
    Expect(0, 7676, '\P{Is_Ccc=doublebelow}', "");
    Expect(1, 7676, '\P{^Is_Ccc=doublebelow}', "");
    Expect(0, 7677, '\p{Is_Ccc=doublebelow}', "");
    Expect(1, 7677, '\p{^Is_Ccc=doublebelow}', "");
    Expect(1, 7677, '\P{Is_Ccc=doublebelow}', "");
    Expect(0, 7677, '\P{^Is_Ccc=doublebelow}', "");
    Expect(1, 7676, '\p{Is_Ccc=- Double_Below}', "");
    Expect(0, 7676, '\p{^Is_Ccc=- Double_Below}', "");
    Expect(0, 7676, '\P{Is_Ccc=- Double_Below}', "");
    Expect(1, 7676, '\P{^Is_Ccc=- Double_Below}', "");
    Expect(0, 7677, '\p{Is_Ccc=- Double_Below}', "");
    Expect(1, 7677, '\p{^Is_Ccc=- Double_Below}', "");
    Expect(1, 7677, '\P{Is_Ccc=- Double_Below}', "");
    Expect(0, 7677, '\P{^Is_Ccc=- Double_Below}', "");
    Error('\p{Canonical_Combining_Class=:=_Han_READING}');
    Error('\P{Canonical_Combining_Class=:=_Han_READING}');
    Expect(1, 94193, '\p{Canonical_Combining_Class=:\AHan_Reading\z:}', "");;
    Expect(0, 94194, '\p{Canonical_Combining_Class=:\AHan_Reading\z:}', "");;
    Expect(1, 94193, '\p{Canonical_Combining_Class: hanreading}', "");
    Expect(0, 94193, '\p{^Canonical_Combining_Class: hanreading}', "");
    Expect(0, 94193, '\P{Canonical_Combining_Class: hanreading}', "");
    Expect(1, 94193, '\P{^Canonical_Combining_Class: hanreading}', "");
    Expect(0, 94194, '\p{Canonical_Combining_Class: hanreading}', "");
    Expect(1, 94194, '\p{^Canonical_Combining_Class: hanreading}', "");
    Expect(1, 94194, '\P{Canonical_Combining_Class: hanreading}', "");
    Expect(0, 94194, '\P{^Canonical_Combining_Class: hanreading}', "");
    Expect(1, 94193, '\p{Canonical_Combining_Class=:\Ahanreading\z:}', "");;
    Expect(0, 94194, '\p{Canonical_Combining_Class=:\Ahanreading\z:}', "");;
    Expect(1, 94193, '\p{Canonical_Combining_Class=_ Han_READING}', "");
    Expect(0, 94193, '\p{^Canonical_Combining_Class=_ Han_READING}', "");
    Expect(0, 94193, '\P{Canonical_Combining_Class=_ Han_READING}', "");
    Expect(1, 94193, '\P{^Canonical_Combining_Class=_ Han_READING}', "");
    Expect(0, 94194, '\p{Canonical_Combining_Class=_ Han_READING}', "");
    Expect(1, 94194, '\p{^Canonical_Combining_Class=_ Han_READING}', "");
    Expect(1, 94194, '\P{Canonical_Combining_Class=_ Han_READING}', "");
    Expect(0, 94194, '\P{^Canonical_Combining_Class=_ Han_READING}', "");
    Error('\p{Ccc=/a/ -HANR}');
    Error('\P{Ccc=/a/ -HANR}');
    Expect(1, 94193, '\p{Ccc=:\AHANR\z:}', "");;
    Expect(0, 94194, '\p{Ccc=:\AHANR\z:}', "");;
    Expect(1, 94193, '\p{Ccc=hanr}', "");
    Expect(0, 94193, '\p{^Ccc=hanr}', "");
    Expect(0, 94193, '\P{Ccc=hanr}', "");
    Expect(1, 94193, '\P{^Ccc=hanr}', "");
    Expect(0, 94194, '\p{Ccc=hanr}', "");
    Expect(1, 94194, '\p{^Ccc=hanr}', "");
    Expect(1, 94194, '\P{Ccc=hanr}', "");
    Expect(0, 94194, '\P{^Ccc=hanr}', "");
    Expect(1, 94193, '\p{Ccc=:\Ahanr\z:}', "");;
    Expect(0, 94194, '\p{Ccc=:\Ahanr\z:}', "");;
    Expect(1, 94193, '\p{Ccc=-HANR}', "");
    Expect(0, 94193, '\p{^Ccc=-HANR}', "");
    Expect(0, 94193, '\P{Ccc=-HANR}', "");
    Expect(1, 94193, '\P{^Ccc=-HANR}', "");
    Expect(0, 94194, '\p{Ccc=-HANR}', "");
    Expect(1, 94194, '\p{^Ccc=-HANR}', "");
    Expect(1, 94194, '\P{Ccc=-HANR}', "");
    Expect(0, 94194, '\P{^Ccc=-HANR}', "");
    Error('\p{Is_Canonical_Combining_Class=/a/	_0_0_0_0_0_0_006}');
    Error('\P{Is_Canonical_Combining_Class=/a/	_0_0_0_0_0_0_006}');
    Expect(1, 94193, '\p{Is_Canonical_Combining_Class=6}', "");
    Expect(0, 94193, '\p{^Is_Canonical_Combining_Class=6}', "");
    Expect(0, 94193, '\P{Is_Canonical_Combining_Class=6}', "");
    Expect(1, 94193, '\P{^Is_Canonical_Combining_Class=6}', "");
    Expect(0, 94194, '\p{Is_Canonical_Combining_Class=6}', "");
    Expect(1, 94194, '\p{^Is_Canonical_Combining_Class=6}', "");
    Expect(1, 94194, '\P{Is_Canonical_Combining_Class=6}', "");
    Expect(0, 94194, '\P{^Is_Canonical_Combining_Class=6}', "");
    Error('\p{Is_Ccc=/a/Han_Reading}');
    Error('\P{Is_Ccc=/a/Han_Reading}');
    Expect(1, 94193, '\p{Is_Ccc:	hanreading}', "");
    Expect(0, 94193, '\p{^Is_Ccc:	hanreading}', "");
    Expect(0, 94193, '\P{Is_Ccc:	hanreading}', "");
    Expect(1, 94193, '\P{^Is_Ccc:	hanreading}', "");
    Expect(0, 94194, '\p{Is_Ccc:	hanreading}', "");
    Expect(1, 94194, '\p{^Is_Ccc:	hanreading}', "");
    Expect(1, 94194, '\P{Is_Ccc:	hanreading}', "");
    Expect(0, 94194, '\P{^Is_Ccc:	hanreading}', "");
    Expect(1, 94193, '\p{Is_Ccc: Han_READING}', "");
    Expect(0, 94193, '\p{^Is_Ccc: Han_READING}', "");
    Expect(0, 94193, '\P{Is_Ccc: Han_READING}', "");
    Expect(1, 94193, '\P{^Is_Ccc: Han_READING}', "");
    Expect(0, 94194, '\p{Is_Ccc: Han_READING}', "");
    Expect(1, 94194, '\p{^Is_Ccc: Han_READING}', "");
    Expect(1, 94194, '\P{Is_Ccc: Han_READING}', "");
    Expect(0, 94194, '\P{^Is_Ccc: Han_READING}', "");
    Error('\p{Canonical_Combining_Class=-:=iota_subscript}');
    Error('\P{Canonical_Combining_Class=-:=iota_subscript}');
    Expect(1, 837, '\p{Canonical_Combining_Class=:\AIota_Subscript\z:}', "");;
    Expect(0, 838, '\p{Canonical_Combining_Class=:\AIota_Subscript\z:}', "");;
    Expect(1, 837, '\p{Canonical_Combining_Class=iotasubscript}', "");
    Expect(0, 837, '\p{^Canonical_Combining_Class=iotasubscript}', "");
    Expect(0, 837, '\P{Canonical_Combining_Class=iotasubscript}', "");
    Expect(1, 837, '\P{^Canonical_Combining_Class=iotasubscript}', "");
    Expect(0, 838, '\p{Canonical_Combining_Class=iotasubscript}', "");
    Expect(1, 838, '\p{^Canonical_Combining_Class=iotasubscript}', "");
    Expect(1, 838, '\P{Canonical_Combining_Class=iotasubscript}', "");
    Expect(0, 838, '\P{^Canonical_Combining_Class=iotasubscript}', "");
    Expect(1, 837, '\p{Canonical_Combining_Class=:\Aiotasubscript\z:}', "");;
    Expect(0, 838, '\p{Canonical_Combining_Class=:\Aiotasubscript\z:}', "");;
    Expect(1, 837, '\p{Canonical_Combining_Class=_IOTA_Subscript}', "");
    Expect(0, 837, '\p{^Canonical_Combining_Class=_IOTA_Subscript}', "");
    Expect(0, 837, '\P{Canonical_Combining_Class=_IOTA_Subscript}', "");
    Expect(1, 837, '\P{^Canonical_Combining_Class=_IOTA_Subscript}', "");
    Expect(0, 838, '\p{Canonical_Combining_Class=_IOTA_Subscript}', "");
    Expect(1, 838, '\p{^Canonical_Combining_Class=_IOTA_Subscript}', "");
    Expect(1, 838, '\P{Canonical_Combining_Class=_IOTA_Subscript}', "");
    Expect(0, 838, '\P{^Canonical_Combining_Class=_IOTA_Subscript}', "");
    Error('\p{Ccc=	:=is}');
    Error('\P{Ccc=	:=is}');
    Expect(1, 837, '\p{Ccc=:\AIS\z:}', "");;
    Expect(0, 838, '\p{Ccc=:\AIS\z:}', "");;
    Expect(1, 837, '\p{Ccc=is}', "");
    Expect(0, 837, '\p{^Ccc=is}', "");
    Expect(0, 837, '\P{Ccc=is}', "");
    Expect(1, 837, '\P{^Ccc=is}', "");
    Expect(0, 838, '\p{Ccc=is}', "");
    Expect(1, 838, '\p{^Ccc=is}', "");
    Expect(1, 838, '\P{Ccc=is}', "");
    Expect(0, 838, '\P{^Ccc=is}', "");
    Expect(1, 837, '\p{Ccc=:\Ais\z:}', "");;
    Expect(0, 838, '\p{Ccc=:\Ais\z:}', "");;
    Expect(1, 837, '\p{Ccc=-	is}', "");
    Expect(0, 837, '\p{^Ccc=-	is}', "");
    Expect(0, 837, '\P{Ccc=-	is}', "");
    Expect(1, 837, '\P{^Ccc=-	is}', "");
    Expect(0, 838, '\p{Ccc=-	is}', "");
    Expect(1, 838, '\p{^Ccc=-	is}', "");
    Expect(1, 838, '\P{Ccc=-	is}', "");
    Expect(0, 838, '\P{^Ccc=-	is}', "");
    Error('\p{Is_Canonical_Combining_Class=:=024_0}');
    Error('\P{Is_Canonical_Combining_Class=:=024_0}');
    Expect(1, 837, '\p{Is_Canonical_Combining_Class=0000240}', "");
    Expect(0, 837, '\p{^Is_Canonical_Combining_Class=0000240}', "");
    Expect(0, 837, '\P{Is_Canonical_Combining_Class=0000240}', "");
    Expect(1, 837, '\P{^Is_Canonical_Combining_Class=0000240}', "");
    Expect(0, 838, '\p{Is_Canonical_Combining_Class=0000240}', "");
    Expect(1, 838, '\p{^Is_Canonical_Combining_Class=0000240}', "");
    Expect(1, 838, '\P{Is_Canonical_Combining_Class=0000240}', "");
    Expect(0, 838, '\P{^Is_Canonical_Combining_Class=0000240}', "");
    Error('\p{Is_Ccc:	_ IOTA_Subscript/a/}');
    Error('\P{Is_Ccc:	_ IOTA_Subscript/a/}');
    Expect(1, 837, '\p{Is_Ccc=iotasubscript}', "");
    Expect(0, 837, '\p{^Is_Ccc=iotasubscript}', "");
    Expect(0, 837, '\P{Is_Ccc=iotasubscript}', "");
    Expect(1, 837, '\P{^Is_Ccc=iotasubscript}', "");
    Expect(0, 838, '\p{Is_Ccc=iotasubscript}', "");
    Expect(1, 838, '\p{^Is_Ccc=iotasubscript}', "");
    Expect(1, 838, '\P{Is_Ccc=iotasubscript}', "");
    Expect(0, 838, '\P{^Is_Ccc=iotasubscript}', "");
    Expect(1, 837, '\p{Is_Ccc=  iota_SUBSCRIPT}', "");
    Expect(0, 837, '\p{^Is_Ccc=  iota_SUBSCRIPT}', "");
    Expect(0, 837, '\P{Is_Ccc=  iota_SUBSCRIPT}', "");
    Expect(1, 837, '\P{^Is_Ccc=  iota_SUBSCRIPT}', "");
    Expect(0, 838, '\p{Is_Ccc=  iota_SUBSCRIPT}', "");
    Expect(1, 838, '\p{^Is_Ccc=  iota_SUBSCRIPT}', "");
    Expect(1, 838, '\P{Is_Ccc=  iota_SUBSCRIPT}', "");
    Expect(0, 838, '\P{^Is_Ccc=  iota_SUBSCRIPT}', "");
    Error('\p{Canonical_Combining_Class=__kana_Voicing/a/}');
    Error('\P{Canonical_Combining_Class=__kana_Voicing/a/}');
    Expect(1, 12442, '\p{Canonical_Combining_Class=:\AKana_Voicing\z:}', "");;
    Expect(0, 12443, '\p{Canonical_Combining_Class=:\AKana_Voicing\z:}', "");;
    Expect(1, 12442, '\p{Canonical_Combining_Class=kanavoicing}', "");
    Expect(0, 12442, '\p{^Canonical_Combining_Class=kanavoicing}', "");
    Expect(0, 12442, '\P{Canonical_Combining_Class=kanavoicing}', "");
    Expect(1, 12442, '\P{^Canonical_Combining_Class=kanavoicing}', "");
    Expect(0, 12443, '\p{Canonical_Combining_Class=kanavoicing}', "");
    Expect(1, 12443, '\p{^Canonical_Combining_Class=kanavoicing}', "");
    Expect(1, 12443, '\P{Canonical_Combining_Class=kanavoicing}', "");
    Expect(0, 12443, '\P{^Canonical_Combining_Class=kanavoicing}', "");
    Expect(1, 12442, '\p{Canonical_Combining_Class=:\Akanavoicing\z:}', "");;
    Expect(0, 12443, '\p{Canonical_Combining_Class=:\Akanavoicing\z:}', "");;
    Expect(1, 12442, '\p{Canonical_Combining_Class=-	Kana_voicing}', "");
    Expect(0, 12442, '\p{^Canonical_Combining_Class=-	Kana_voicing}', "");
    Expect(0, 12442, '\P{Canonical_Combining_Class=-	Kana_voicing}', "");
    Expect(1, 12442, '\P{^Canonical_Combining_Class=-	Kana_voicing}', "");
    Expect(0, 12443, '\p{Canonical_Combining_Class=-	Kana_voicing}', "");
    Expect(1, 12443, '\p{^Canonical_Combining_Class=-	Kana_voicing}', "");
    Expect(1, 12443, '\P{Canonical_Combining_Class=-	Kana_voicing}', "");
    Expect(0, 12443, '\P{^Canonical_Combining_Class=-	Kana_voicing}', "");
    Error('\p{Ccc=:=_-kv}');
    Error('\P{Ccc=:=_-kv}');
    Expect(1, 12442, '\p{Ccc=:\AKV\z:}', "");;
    Expect(0, 12443, '\p{Ccc=:\AKV\z:}', "");;
    Expect(1, 12442, '\p{Ccc=kv}', "");
    Expect(0, 12442, '\p{^Ccc=kv}', "");
    Expect(0, 12442, '\P{Ccc=kv}', "");
    Expect(1, 12442, '\P{^Ccc=kv}', "");
    Expect(0, 12443, '\p{Ccc=kv}', "");
    Expect(1, 12443, '\p{^Ccc=kv}', "");
    Expect(1, 12443, '\P{Ccc=kv}', "");
    Expect(0, 12443, '\P{^Ccc=kv}', "");
    Expect(1, 12442, '\p{Ccc=:\Akv\z:}', "");;
    Expect(0, 12443, '\p{Ccc=:\Akv\z:}', "");;
    Expect(1, 12442, '\p{Ccc=	_KV}', "");
    Expect(0, 12442, '\p{^Ccc=	_KV}', "");
    Expect(0, 12442, '\P{Ccc=	_KV}', "");
    Expect(1, 12442, '\P{^Ccc=	_KV}', "");
    Expect(0, 12443, '\p{Ccc=	_KV}', "");
    Expect(1, 12443, '\p{^Ccc=	_KV}', "");
    Expect(1, 12443, '\P{Ccc=	_KV}', "");
    Expect(0, 12443, '\P{^Ccc=	_KV}', "");
    Error('\p{Is_Canonical_Combining_Class: /a/0000008}');
    Error('\P{Is_Canonical_Combining_Class: /a/0000008}');
    Expect(1, 12442, '\p{Is_Canonical_Combining_Class=0_0_0_0_0_00008}', "");
    Expect(0, 12442, '\p{^Is_Canonical_Combining_Class=0_0_0_0_0_00008}', "");
    Expect(0, 12442, '\P{Is_Canonical_Combining_Class=0_0_0_0_0_00008}', "");
    Expect(1, 12442, '\P{^Is_Canonical_Combining_Class=0_0_0_0_0_00008}', "");
    Expect(0, 12443, '\p{Is_Canonical_Combining_Class=0_0_0_0_0_00008}', "");
    Expect(1, 12443, '\p{^Is_Canonical_Combining_Class=0_0_0_0_0_00008}', "");
    Expect(1, 12443, '\P{Is_Canonical_Combining_Class=0_0_0_0_0_00008}', "");
    Expect(0, 12443, '\P{^Is_Canonical_Combining_Class=0_0_0_0_0_00008}', "");
    Error('\p{Is_Ccc= _Kana_Voicing:=}');
    Error('\P{Is_Ccc= _Kana_Voicing:=}');
    Expect(1, 12442, '\p{Is_Ccc=kanavoicing}', "");
    Expect(0, 12442, '\p{^Is_Ccc=kanavoicing}', "");
    Expect(0, 12442, '\P{Is_Ccc=kanavoicing}', "");
    Expect(1, 12442, '\P{^Is_Ccc=kanavoicing}', "");
    Expect(0, 12443, '\p{Is_Ccc=kanavoicing}', "");
    Expect(1, 12443, '\p{^Is_Ccc=kanavoicing}', "");
    Expect(1, 12443, '\P{Is_Ccc=kanavoicing}', "");
    Expect(0, 12443, '\P{^Is_Ccc=kanavoicing}', "");
    Expect(1, 12442, '\p{Is_Ccc=_KANA_VOICING}', "");
    Expect(0, 12442, '\p{^Is_Ccc=_KANA_VOICING}', "");
    Expect(0, 12442, '\P{Is_Ccc=_KANA_VOICING}', "");
    Expect(1, 12442, '\P{^Is_Ccc=_KANA_VOICING}', "");
    Expect(0, 12443, '\p{Is_Ccc=_KANA_VOICING}', "");
    Expect(1, 12443, '\p{^Is_Ccc=_KANA_VOICING}', "");
    Expect(1, 12443, '\P{Is_Ccc=_KANA_VOICING}', "");
    Expect(0, 12443, '\P{^Is_Ccc=_KANA_VOICING}', "");
    Error('\p{Canonical_Combining_Class=_Left:=}');
    Error('\P{Canonical_Combining_Class=_Left:=}');
    Expect(1, 12335, '\p{Canonical_Combining_Class=:\ALeft\z:}', "");;
    Expect(0, 12336, '\p{Canonical_Combining_Class=:\ALeft\z:}', "");;
    Expect(1, 12335, '\p{Canonical_Combining_Class=left}', "");
    Expect(0, 12335, '\p{^Canonical_Combining_Class=left}', "");
    Expect(0, 12335, '\P{Canonical_Combining_Class=left}', "");
    Expect(1, 12335, '\P{^Canonical_Combining_Class=left}', "");
    Expect(0, 12336, '\p{Canonical_Combining_Class=left}', "");
    Expect(1, 12336, '\p{^Canonical_Combining_Class=left}', "");
    Expect(1, 12336, '\P{Canonical_Combining_Class=left}', "");
    Expect(0, 12336, '\P{^Canonical_Combining_Class=left}', "");
    Expect(1, 12335, '\p{Canonical_Combining_Class=:\Aleft\z:}', "");;
    Expect(0, 12336, '\p{Canonical_Combining_Class=:\Aleft\z:}', "");;
    Expect(1, 12335, '\p{Canonical_Combining_Class=	-Left}', "");
    Expect(0, 12335, '\p{^Canonical_Combining_Class=	-Left}', "");
    Expect(0, 12335, '\P{Canonical_Combining_Class=	-Left}', "");
    Expect(1, 12335, '\P{^Canonical_Combining_Class=	-Left}', "");
    Expect(0, 12336, '\p{Canonical_Combining_Class=	-Left}', "");
    Expect(1, 12336, '\p{^Canonical_Combining_Class=	-Left}', "");
    Expect(1, 12336, '\P{Canonical_Combining_Class=	-Left}', "");
    Expect(0, 12336, '\P{^Canonical_Combining_Class=	-Left}', "");
    Error('\p{Ccc=:=	 L}');
    Error('\P{Ccc=:=	 L}');
    Expect(1, 12335, '\p{Ccc=:\AL\z:}', "");;
    Expect(0, 12336, '\p{Ccc=:\AL\z:}', "");;
    Expect(1, 12335, '\p{Ccc:l}', "");
    Expect(0, 12335, '\p{^Ccc:l}', "");
    Expect(0, 12335, '\P{Ccc:l}', "");
    Expect(1, 12335, '\P{^Ccc:l}', "");
    Expect(0, 12336, '\p{Ccc:l}', "");
    Expect(1, 12336, '\p{^Ccc:l}', "");
    Expect(1, 12336, '\P{Ccc:l}', "");
    Expect(0, 12336, '\P{^Ccc:l}', "");
    Expect(1, 12335, '\p{Ccc=:\Al\z:}', "");;
    Expect(0, 12336, '\p{Ccc=:\Al\z:}', "");;
    Expect(1, 12335, '\p{Ccc=  L}', "");
    Expect(0, 12335, '\p{^Ccc=  L}', "");
    Expect(0, 12335, '\P{Ccc=  L}', "");
    Expect(1, 12335, '\P{^Ccc=  L}', "");
    Expect(0, 12336, '\p{Ccc=  L}', "");
    Expect(1, 12336, '\p{^Ccc=  L}', "");
    Expect(1, 12336, '\P{Ccc=  L}', "");
    Expect(0, 12336, '\P{^Ccc=  L}', "");
    Error('\p{Is_Canonical_Combining_Class=/a/_+0_0_0_0_0_0_0_0_0224}');
    Error('\P{Is_Canonical_Combining_Class=/a/_+0_0_0_0_0_0_0_0_0224}');
    Expect(1, 12335, '\p{Is_Canonical_Combining_Class=224}', "");
    Expect(0, 12335, '\p{^Is_Canonical_Combining_Class=224}', "");
    Expect(0, 12335, '\P{Is_Canonical_Combining_Class=224}', "");
    Expect(1, 12335, '\P{^Is_Canonical_Combining_Class=224}', "");
    Expect(0, 12336, '\p{Is_Canonical_Combining_Class=224}', "");
    Expect(1, 12336, '\p{^Is_Canonical_Combining_Class=224}', "");
    Expect(1, 12336, '\P{Is_Canonical_Combining_Class=224}', "");
    Expect(0, 12336, '\P{^Is_Canonical_Combining_Class=224}', "");
    Error('\p{Is_Ccc:   -:=Left}');
    Error('\P{Is_Ccc:   -:=Left}');
    Expect(1, 12335, '\p{Is_Ccc=left}', "");
    Expect(0, 12335, '\p{^Is_Ccc=left}', "");
    Expect(0, 12335, '\P{Is_Ccc=left}', "");
    Expect(1, 12335, '\P{^Is_Ccc=left}', "");
    Expect(0, 12336, '\p{Is_Ccc=left}', "");
    Expect(1, 12336, '\p{^Is_Ccc=left}', "");
    Expect(1, 12336, '\P{Is_Ccc=left}', "");
    Expect(0, 12336, '\P{^Is_Ccc=left}', "");
    Expect(1, 12335, '\p{Is_Ccc: _left}', "");
    Expect(0, 12335, '\p{^Is_Ccc: _left}', "");
    Expect(0, 12335, '\P{Is_Ccc: _left}', "");
    Expect(1, 12335, '\P{^Is_Ccc: _left}', "");
    Expect(0, 12336, '\p{Is_Ccc: _left}', "");
    Expect(1, 12336, '\p{^Is_Ccc: _left}', "");
    Expect(1, 12336, '\P{Is_Ccc: _left}', "");
    Expect(0, 12336, '\P{^Is_Ccc: _left}', "");
    Error('\p{Canonical_Combining_Class=/a/Nukta}');
    Error('\P{Canonical_Combining_Class=/a/Nukta}');
    Expect(1, 125258, '\p{Canonical_Combining_Class=:\ANukta\z:}', "");;
    Expect(0, 125259, '\p{Canonical_Combining_Class=:\ANukta\z:}', "");;
    Expect(1, 125258, '\p{Canonical_Combining_Class=nukta}', "");
    Expect(0, 125258, '\p{^Canonical_Combining_Class=nukta}', "");
    Expect(0, 125258, '\P{Canonical_Combining_Class=nukta}', "");
    Expect(1, 125258, '\P{^Canonical_Combining_Class=nukta}', "");
    Expect(0, 125259, '\p{Canonical_Combining_Class=nukta}', "");
    Expect(1, 125259, '\p{^Canonical_Combining_Class=nukta}', "");
    Expect(1, 125259, '\P{Canonical_Combining_Class=nukta}', "");
    Expect(0, 125259, '\P{^Canonical_Combining_Class=nukta}', "");
    Expect(1, 125258, '\p{Canonical_Combining_Class=:\Anukta\z:}', "");;
    Expect(0, 125259, '\p{Canonical_Combining_Class=:\Anukta\z:}', "");;
    Expect(1, 125258, '\p{Canonical_Combining_Class=Nukta}', "");
    Expect(0, 125258, '\p{^Canonical_Combining_Class=Nukta}', "");
    Expect(0, 125258, '\P{Canonical_Combining_Class=Nukta}', "");
    Expect(1, 125258, '\P{^Canonical_Combining_Class=Nukta}', "");
    Expect(0, 125259, '\p{Canonical_Combining_Class=Nukta}', "");
    Expect(1, 125259, '\p{^Canonical_Combining_Class=Nukta}', "");
    Expect(1, 125259, '\P{Canonical_Combining_Class=Nukta}', "");
    Expect(0, 125259, '\P{^Canonical_Combining_Class=Nukta}', "");
    Error('\p{Ccc= /a/NK}');
    Error('\P{Ccc= /a/NK}');
    Expect(1, 125258, '\p{Ccc=:\ANK\z:}', "");;
    Expect(0, 125259, '\p{Ccc=:\ANK\z:}', "");;
    Expect(1, 125258, '\p{Ccc=nk}', "");
    Expect(0, 125258, '\p{^Ccc=nk}', "");
    Expect(0, 125258, '\P{Ccc=nk}', "");
    Expect(1, 125258, '\P{^Ccc=nk}', "");
    Expect(0, 125259, '\p{Ccc=nk}', "");
    Expect(1, 125259, '\p{^Ccc=nk}', "");
    Expect(1, 125259, '\P{Ccc=nk}', "");
    Expect(0, 125259, '\P{^Ccc=nk}', "");
    Expect(1, 125258, '\p{Ccc=:\Ank\z:}', "");;
    Expect(0, 125259, '\p{Ccc=:\Ank\z:}', "");;
    Expect(1, 125258, '\p{Ccc=	 NK}', "");
    Expect(0, 125258, '\p{^Ccc=	 NK}', "");
    Expect(0, 125258, '\P{Ccc=	 NK}', "");
    Expect(1, 125258, '\P{^Ccc=	 NK}', "");
    Expect(0, 125259, '\p{Ccc=	 NK}', "");
    Expect(1, 125259, '\p{^Ccc=	 NK}', "");
    Expect(1, 125259, '\P{Ccc=	 NK}', "");
    Expect(0, 125259, '\P{^Ccc=	 NK}', "");
    Error('\p{Is_Canonical_Combining_Class= -0_7/a/}');
    Error('\P{Is_Canonical_Combining_Class= -0_7/a/}');
    Expect(1, 125258, '\p{Is_Canonical_Combining_Class=+000_7}', "");
    Expect(0, 125258, '\p{^Is_Canonical_Combining_Class=+000_7}', "");
    Expect(0, 125258, '\P{Is_Canonical_Combining_Class=+000_7}', "");
    Expect(1, 125258, '\P{^Is_Canonical_Combining_Class=+000_7}', "");
    Expect(0, 125259, '\p{Is_Canonical_Combining_Class=+000_7}', "");
    Expect(1, 125259, '\p{^Is_Canonical_Combining_Class=+000_7}', "");
    Expect(1, 125259, '\P{Is_Canonical_Combining_Class=+000_7}', "");
    Expect(0, 125259, '\P{^Is_Canonical_Combining_Class=+000_7}', "");
    Error('\p{Is_Ccc=/a/-	Nukta}');
    Error('\P{Is_Ccc=/a/-	Nukta}');
    Expect(1, 125258, '\p{Is_Ccc=nukta}', "");
    Expect(0, 125258, '\p{^Is_Ccc=nukta}', "");
    Expect(0, 125258, '\P{Is_Ccc=nukta}', "");
    Expect(1, 125258, '\P{^Is_Ccc=nukta}', "");
    Expect(0, 125259, '\p{Is_Ccc=nukta}', "");
    Expect(1, 125259, '\p{^Is_Ccc=nukta}', "");
    Expect(1, 125259, '\P{Is_Ccc=nukta}', "");
    Expect(0, 125259, '\P{^Is_Ccc=nukta}', "");
    Expect(1, 125258, '\p{Is_Ccc=	Nukta}', "");
    Expect(0, 125258, '\p{^Is_Ccc=	Nukta}', "");
    Expect(0, 125258, '\P{Is_Ccc=	Nukta}', "");
    Expect(1, 125258, '\P{^Is_Ccc=	Nukta}', "");
    Expect(0, 125259, '\p{Is_Ccc=	Nukta}', "");
    Expect(1, 125259, '\p{^Is_Ccc=	Nukta}', "");
    Expect(1, 125259, '\P{Is_Ccc=	Nukta}', "");
    Expect(0, 125259, '\P{^Is_Ccc=	Nukta}', "");
    Error('\p{Canonical_Combining_Class=	Not_reordered/a/}');
    Error('\P{Canonical_Combining_Class=	Not_reordered/a/}');
    Expect(1, 125259, '\p{Canonical_Combining_Class=:\ANot_Reordered\z:}', "");;
    Expect(0, 125258, '\p{Canonical_Combining_Class=:\ANot_Reordered\z:}', "");;
    Expect(1, 125259, '\p{Canonical_Combining_Class=notreordered}', "");
    Expect(0, 125259, '\p{^Canonical_Combining_Class=notreordered}', "");
    Expect(0, 125259, '\P{Canonical_Combining_Class=notreordered}', "");
    Expect(1, 125259, '\P{^Canonical_Combining_Class=notreordered}', "");
    Expect(0, 125258, '\p{Canonical_Combining_Class=notreordered}', "");
    Expect(1, 125258, '\p{^Canonical_Combining_Class=notreordered}', "");
    Expect(1, 125258, '\P{Canonical_Combining_Class=notreordered}', "");
    Expect(0, 125258, '\P{^Canonical_Combining_Class=notreordered}', "");
    Expect(1, 125259, '\p{Canonical_Combining_Class=:\Anotreordered\z:}', "");;
    Expect(0, 125258, '\p{Canonical_Combining_Class=:\Anotreordered\z:}', "");;
    Expect(1, 125259, '\p{Canonical_Combining_Class=  not_Reordered}', "");
    Expect(0, 125259, '\p{^Canonical_Combining_Class=  not_Reordered}', "");
    Expect(0, 125259, '\P{Canonical_Combining_Class=  not_Reordered}', "");
    Expect(1, 125259, '\P{^Canonical_Combining_Class=  not_Reordered}', "");
    Expect(0, 125258, '\p{Canonical_Combining_Class=  not_Reordered}', "");
    Expect(1, 125258, '\p{^Canonical_Combining_Class=  not_Reordered}', "");
    Expect(1, 125258, '\P{Canonical_Combining_Class=  not_Reordered}', "");
    Expect(0, 125258, '\P{^Canonical_Combining_Class=  not_Reordered}', "");
    Error('\p{Ccc=:=		NR}');
    Error('\P{Ccc=:=		NR}');
    Expect(1, 125259, '\p{Ccc=:\ANR\z:}', "");;
    Expect(0, 125258, '\p{Ccc=:\ANR\z:}', "");;
    Expect(1, 125259, '\p{Ccc:   nr}', "");
    Expect(0, 125259, '\p{^Ccc:   nr}', "");
    Expect(0, 125259, '\P{Ccc:   nr}', "");
    Expect(1, 125259, '\P{^Ccc:   nr}', "");
    Expect(0, 125258, '\p{Ccc:   nr}', "");
    Expect(1, 125258, '\p{^Ccc:   nr}', "");
    Expect(1, 125258, '\P{Ccc:   nr}', "");
    Expect(0, 125258, '\P{^Ccc:   nr}', "");
    Expect(1, 125259, '\p{Ccc=:\Anr\z:}', "");;
    Expect(0, 125258, '\p{Ccc=:\Anr\z:}', "");;
    Expect(1, 125259, '\p{Ccc=_nr}', "");
    Expect(0, 125259, '\p{^Ccc=_nr}', "");
    Expect(0, 125259, '\P{Ccc=_nr}', "");
    Expect(1, 125259, '\P{^Ccc=_nr}', "");
    Expect(0, 125258, '\p{Ccc=_nr}', "");
    Expect(1, 125258, '\p{^Ccc=_nr}', "");
    Expect(1, 125258, '\P{Ccc=_nr}', "");
    Expect(0, 125258, '\P{^Ccc=_nr}', "");
    Error('\p{Is_Canonical_Combining_Class=0000000000/a/}');
    Error('\P{Is_Canonical_Combining_Class=0000000000/a/}');
    Expect(1, 125259, '\p{Is_Canonical_Combining_Class=00000}', "");
    Expect(0, 125259, '\p{^Is_Canonical_Combining_Class=00000}', "");
    Expect(0, 125259, '\P{Is_Canonical_Combining_Class=00000}', "");
    Expect(1, 125259, '\P{^Is_Canonical_Combining_Class=00000}', "");
    Expect(0, 125258, '\p{Is_Canonical_Combining_Class=00000}', "");
    Expect(1, 125258, '\p{^Is_Canonical_Combining_Class=00000}', "");
    Expect(1, 125258, '\P{Is_Canonical_Combining_Class=00000}', "");
    Expect(0, 125258, '\P{^Is_Canonical_Combining_Class=00000}', "");
    Error('\p{Is_Ccc= :=Not_Reordered}');
    Error('\P{Is_Ccc= :=Not_Reordered}');
    Expect(1, 125259, '\p{Is_Ccc=notreordered}', "");
    Expect(0, 125259, '\p{^Is_Ccc=notreordered}', "");
    Expect(0, 125259, '\P{Is_Ccc=notreordered}', "");
    Expect(1, 125259, '\P{^Is_Ccc=notreordered}', "");
    Expect(0, 125258, '\p{Is_Ccc=notreordered}', "");
    Expect(1, 125258, '\p{^Is_Ccc=notreordered}', "");
    Expect(1, 125258, '\P{Is_Ccc=notreordered}', "");
    Expect(0, 125258, '\P{^Is_Ccc=notreordered}', "");
    Expect(1, 125259, '\p{Is_Ccc=	Not_REORDERED}', "");
    Expect(0, 125259, '\p{^Is_Ccc=	Not_REORDERED}', "");
    Expect(0, 125259, '\P{Is_Ccc=	Not_REORDERED}', "");
    Expect(1, 125259, '\P{^Is_Ccc=	Not_REORDERED}', "");
    Expect(0, 125258, '\p{Is_Ccc=	Not_REORDERED}', "");
    Expect(1, 125258, '\p{^Is_Ccc=	Not_REORDERED}', "");
    Expect(1, 125258, '\P{Is_Ccc=	Not_REORDERED}', "");
    Expect(0, 125258, '\P{^Is_Ccc=	Not_REORDERED}', "");
    Error('\p{Canonical_Combining_Class=:=_-overlay}');
    Error('\P{Canonical_Combining_Class=:=_-overlay}');
    Expect(1, 119145, '\p{Canonical_Combining_Class=:\AOverlay\z:}', "");;
    Expect(0, 119146, '\p{Canonical_Combining_Class=:\AOverlay\z:}', "");;
    Expect(1, 119145, '\p{Canonical_Combining_Class=overlay}', "");
    Expect(0, 119145, '\p{^Canonical_Combining_Class=overlay}', "");
    Expect(0, 119145, '\P{Canonical_Combining_Class=overlay}', "");
    Expect(1, 119145, '\P{^Canonical_Combining_Class=overlay}', "");
    Expect(0, 119146, '\p{Canonical_Combining_Class=overlay}', "");
    Expect(1, 119146, '\p{^Canonical_Combining_Class=overlay}', "");
    Expect(1, 119146, '\P{Canonical_Combining_Class=overlay}', "");
    Expect(0, 119146, '\P{^Canonical_Combining_Class=overlay}', "");
    Expect(1, 119145, '\p{Canonical_Combining_Class=:\Aoverlay\z:}', "");;
    Expect(0, 119146, '\p{Canonical_Combining_Class=:\Aoverlay\z:}', "");;
    Expect(1, 119145, '\p{Canonical_Combining_Class=_Overlay}', "");
    Expect(0, 119145, '\p{^Canonical_Combining_Class=_Overlay}', "");
    Expect(0, 119145, '\P{Canonical_Combining_Class=_Overlay}', "");
    Expect(1, 119145, '\P{^Canonical_Combining_Class=_Overlay}', "");
    Expect(0, 119146, '\p{Canonical_Combining_Class=_Overlay}', "");
    Expect(1, 119146, '\p{^Canonical_Combining_Class=_Overlay}', "");
    Expect(1, 119146, '\P{Canonical_Combining_Class=_Overlay}', "");
    Expect(0, 119146, '\P{^Canonical_Combining_Class=_Overlay}', "");
    Error('\p{Ccc= ov:=}');
    Error('\P{Ccc= ov:=}');
    Expect(1, 119145, '\p{Ccc=:\AOV\z:}', "");;
    Expect(0, 119146, '\p{Ccc=:\AOV\z:}', "");;
    Expect(1, 119145, '\p{Ccc=ov}', "");
    Expect(0, 119145, '\p{^Ccc=ov}', "");
    Expect(0, 119145, '\P{Ccc=ov}', "");
    Expect(1, 119145, '\P{^Ccc=ov}', "");
    Expect(0, 119146, '\p{Ccc=ov}', "");
    Expect(1, 119146, '\p{^Ccc=ov}', "");
    Expect(1, 119146, '\P{Ccc=ov}', "");
    Expect(0, 119146, '\P{^Ccc=ov}', "");
    Expect(1, 119145, '\p{Ccc=:\Aov\z:}', "");;
    Expect(0, 119146, '\p{Ccc=:\Aov\z:}', "");;
    Expect(1, 119145, '\p{Ccc=-	OV}', "");
    Expect(0, 119145, '\p{^Ccc=-	OV}', "");
    Expect(0, 119145, '\P{Ccc=-	OV}', "");
    Expect(1, 119145, '\P{^Ccc=-	OV}', "");
    Expect(0, 119146, '\p{Ccc=-	OV}', "");
    Expect(1, 119146, '\p{^Ccc=-	OV}', "");
    Expect(1, 119146, '\P{Ccc=-	OV}', "");
    Expect(0, 119146, '\P{^Ccc=-	OV}', "");
    Error('\p{Is_Canonical_Combining_Class=+0001:=}');
    Error('\P{Is_Canonical_Combining_Class=+0001:=}');
    Expect(1, 119145, '\p{Is_Canonical_Combining_Class=00000001}', "");
    Expect(0, 119145, '\p{^Is_Canonical_Combining_Class=00000001}', "");
    Expect(0, 119145, '\P{Is_Canonical_Combining_Class=00000001}', "");
    Expect(1, 119145, '\P{^Is_Canonical_Combining_Class=00000001}', "");
    Expect(0, 119146, '\p{Is_Canonical_Combining_Class=00000001}', "");
    Expect(1, 119146, '\p{^Is_Canonical_Combining_Class=00000001}', "");
    Expect(1, 119146, '\P{Is_Canonical_Combining_Class=00000001}', "");
    Expect(0, 119146, '\P{^Is_Canonical_Combining_Class=00000001}', "");
    Error('\p{Is_Ccc=:=_-overlay}');
    Error('\P{Is_Ccc=:=_-overlay}');
    Expect(1, 119145, '\p{Is_Ccc=overlay}', "");
    Expect(0, 119145, '\p{^Is_Ccc=overlay}', "");
    Expect(0, 119145, '\P{Is_Ccc=overlay}', "");
    Expect(1, 119145, '\P{^Is_Ccc=overlay}', "");
    Expect(0, 119146, '\p{Is_Ccc=overlay}', "");
    Expect(1, 119146, '\p{^Is_Ccc=overlay}', "");
    Expect(1, 119146, '\P{Is_Ccc=overlay}', "");
    Expect(0, 119146, '\P{^Is_Ccc=overlay}', "");
    Expect(1, 119145, '\p{Is_Ccc= -Overlay}', "");
    Expect(0, 119145, '\p{^Is_Ccc= -Overlay}', "");
    Expect(0, 119145, '\P{Is_Ccc= -Overlay}', "");
    Expect(1, 119145, '\P{^Is_Ccc= -Overlay}', "");
    Expect(0, 119146, '\p{Is_Ccc= -Overlay}', "");
    Expect(1, 119146, '\p{^Is_Ccc= -Overlay}', "");
    Expect(1, 119146, '\P{Is_Ccc= -Overlay}', "");
    Expect(0, 119146, '\P{^Is_Ccc= -Overlay}', "");
    Error('\p{Canonical_Combining_Class= RIGHT/a/}');
    Error('\P{Canonical_Combining_Class= RIGHT/a/}');
    Expect(1, 119149, '\p{Canonical_Combining_Class=:\ARight\z:}', "");;
    Expect(0, 119150, '\p{Canonical_Combining_Class=:\ARight\z:}', "");;
    Expect(1, 119149, '\p{Canonical_Combining_Class=right}', "");
    Expect(0, 119149, '\p{^Canonical_Combining_Class=right}', "");
    Expect(0, 119149, '\P{Canonical_Combining_Class=right}', "");
    Expect(1, 119149, '\P{^Canonical_Combining_Class=right}', "");
    Expect(0, 119150, '\p{Canonical_Combining_Class=right}', "");
    Expect(1, 119150, '\p{^Canonical_Combining_Class=right}', "");
    Expect(1, 119150, '\P{Canonical_Combining_Class=right}', "");
    Expect(0, 119150, '\P{^Canonical_Combining_Class=right}', "");
    Expect(1, 119149, '\p{Canonical_Combining_Class=:\Aright\z:}', "");;
    Expect(0, 119150, '\p{Canonical_Combining_Class=:\Aright\z:}', "");;
    Expect(1, 119149, '\p{Canonical_Combining_Class=	Right}', "");
    Expect(0, 119149, '\p{^Canonical_Combining_Class=	Right}', "");
    Expect(0, 119149, '\P{Canonical_Combining_Class=	Right}', "");
    Expect(1, 119149, '\P{^Canonical_Combining_Class=	Right}', "");
    Expect(0, 119150, '\p{Canonical_Combining_Class=	Right}', "");
    Expect(1, 119150, '\p{^Canonical_Combining_Class=	Right}', "");
    Expect(1, 119150, '\P{Canonical_Combining_Class=	Right}', "");
    Expect(0, 119150, '\P{^Canonical_Combining_Class=	Right}', "");
    Error('\p{Ccc=/a/_R}');
    Error('\P{Ccc=/a/_R}');
    Expect(1, 119149, '\p{Ccc=:\AR\z:}', "");;
    Expect(0, 119150, '\p{Ccc=:\AR\z:}', "");;
    Expect(1, 119149, '\p{Ccc=r}', "");
    Expect(0, 119149, '\p{^Ccc=r}', "");
    Expect(0, 119149, '\P{Ccc=r}', "");
    Expect(1, 119149, '\P{^Ccc=r}', "");
    Expect(0, 119150, '\p{Ccc=r}', "");
    Expect(1, 119150, '\p{^Ccc=r}', "");
    Expect(1, 119150, '\P{Ccc=r}', "");
    Expect(0, 119150, '\P{^Ccc=r}', "");
    Expect(1, 119149, '\p{Ccc=:\Ar\z:}', "");;
    Expect(0, 119150, '\p{Ccc=:\Ar\z:}', "");;
    Expect(1, 119149, '\p{Ccc= -r}', "");
    Expect(0, 119149, '\p{^Ccc= -r}', "");
    Expect(0, 119149, '\P{Ccc= -r}', "");
    Expect(1, 119149, '\P{^Ccc= -r}', "");
    Expect(0, 119150, '\p{Ccc= -r}', "");
    Expect(1, 119150, '\p{^Ccc= -r}', "");
    Expect(1, 119150, '\P{Ccc= -r}', "");
    Expect(0, 119150, '\P{^Ccc= -r}', "");
    Error('\p{Is_Canonical_Combining_Class=/a/	 00000000226}');
    Error('\P{Is_Canonical_Combining_Class=/a/	 00000000226}');
    Expect(1, 119149, '\p{Is_Canonical_Combining_Class:+0_0_0_0_2_26}', "");
    Expect(0, 119149, '\p{^Is_Canonical_Combining_Class:+0_0_0_0_2_26}', "");
    Expect(0, 119149, '\P{Is_Canonical_Combining_Class:+0_0_0_0_2_26}', "");
    Expect(1, 119149, '\P{^Is_Canonical_Combining_Class:+0_0_0_0_2_26}', "");
    Expect(0, 119150, '\p{Is_Canonical_Combining_Class:+0_0_0_0_2_26}', "");
    Expect(1, 119150, '\p{^Is_Canonical_Combining_Class:+0_0_0_0_2_26}', "");
    Expect(1, 119150, '\P{Is_Canonical_Combining_Class:+0_0_0_0_2_26}', "");
    Expect(0, 119150, '\P{^Is_Canonical_Combining_Class:+0_0_0_0_2_26}', "");
    Error('\p{Is_Ccc=/a/ _Right}');
    Error('\P{Is_Ccc=/a/ _Right}');
    Expect(1, 119149, '\p{Is_Ccc=right}', "");
    Expect(0, 119149, '\p{^Is_Ccc=right}', "");
    Expect(0, 119149, '\P{Is_Ccc=right}', "");
    Expect(1, 119149, '\P{^Is_Ccc=right}', "");
    Expect(0, 119150, '\p{Is_Ccc=right}', "");
    Expect(1, 119150, '\p{^Is_Ccc=right}', "");
    Expect(1, 119150, '\P{Is_Ccc=right}', "");
    Expect(0, 119150, '\P{^Is_Ccc=right}', "");
    Expect(1, 119149, '\p{Is_Ccc=_-Right}', "");
    Expect(0, 119149, '\p{^Is_Ccc=_-Right}', "");
    Expect(0, 119149, '\P{Is_Ccc=_-Right}', "");
    Expect(1, 119149, '\P{^Is_Ccc=_-Right}', "");
    Expect(0, 119150, '\p{Is_Ccc=_-Right}', "");
    Expect(1, 119150, '\p{^Is_Ccc=_-Right}', "");
    Expect(1, 119150, '\P{Is_Ccc=_-Right}', "");
    Expect(0, 119150, '\P{^Is_Ccc=_-Right}', "");
    Error('\p{Canonical_Combining_Class:	_Virama:=}');
    Error('\P{Canonical_Combining_Class:	_Virama:=}');
    Expect(1, 73111, '\p{Canonical_Combining_Class=:\AVirama\z:}', "");;
    Expect(0, 73112, '\p{Canonical_Combining_Class=:\AVirama\z:}', "");;
    Expect(1, 73111, '\p{Canonical_Combining_Class=virama}', "");
    Expect(0, 73111, '\p{^Canonical_Combining_Class=virama}', "");
    Expect(0, 73111, '\P{Canonical_Combining_Class=virama}', "");
    Expect(1, 73111, '\P{^Canonical_Combining_Class=virama}', "");
    Expect(0, 73112, '\p{Canonical_Combining_Class=virama}', "");
    Expect(1, 73112, '\p{^Canonical_Combining_Class=virama}', "");
    Expect(1, 73112, '\P{Canonical_Combining_Class=virama}', "");
    Expect(0, 73112, '\P{^Canonical_Combining_Class=virama}', "");
    Expect(1, 73111, '\p{Canonical_Combining_Class=:\Avirama\z:}', "");;
    Expect(0, 73112, '\p{Canonical_Combining_Class=:\Avirama\z:}', "");;
    Expect(1, 73111, '\p{Canonical_Combining_Class= Virama}', "");
    Expect(0, 73111, '\p{^Canonical_Combining_Class= Virama}', "");
    Expect(0, 73111, '\P{Canonical_Combining_Class= Virama}', "");
    Expect(1, 73111, '\P{^Canonical_Combining_Class= Virama}', "");
    Expect(0, 73112, '\p{Canonical_Combining_Class= Virama}', "");
    Expect(1, 73112, '\p{^Canonical_Combining_Class= Virama}', "");
    Expect(1, 73112, '\P{Canonical_Combining_Class= Virama}', "");
    Expect(0, 73112, '\P{^Canonical_Combining_Class= Virama}', "");
    Error('\p{Ccc=- VR:=}');
    Error('\P{Ccc=- VR:=}');
    Expect(1, 73111, '\p{Ccc=:\AVR\z:}', "");;
    Expect(0, 73112, '\p{Ccc=:\AVR\z:}', "");;
    Expect(1, 73111, '\p{Ccc=vr}', "");
    Expect(0, 73111, '\p{^Ccc=vr}', "");
    Expect(0, 73111, '\P{Ccc=vr}', "");
    Expect(1, 73111, '\P{^Ccc=vr}', "");
    Expect(0, 73112, '\p{Ccc=vr}', "");
    Expect(1, 73112, '\p{^Ccc=vr}', "");
    Expect(1, 73112, '\P{Ccc=vr}', "");
    Expect(0, 73112, '\P{^Ccc=vr}', "");
    Expect(1, 73111, '\p{Ccc=:\Avr\z:}', "");;
    Expect(0, 73112, '\p{Ccc=:\Avr\z:}', "");;
    Expect(1, 73111, '\p{Ccc=  VR}', "");
    Expect(0, 73111, '\p{^Ccc=  VR}', "");
    Expect(0, 73111, '\P{Ccc=  VR}', "");
    Expect(1, 73111, '\P{^Ccc=  VR}', "");
    Expect(0, 73112, '\p{Ccc=  VR}', "");
    Expect(1, 73112, '\p{^Ccc=  VR}', "");
    Expect(1, 73112, '\P{Ccc=  VR}', "");
    Expect(0, 73112, '\P{^Ccc=  VR}', "");
    Error('\p{Is_Canonical_Combining_Class=-_00000009:=}');
    Error('\P{Is_Canonical_Combining_Class=-_00000009:=}');
    Expect(1, 73111, '\p{Is_Canonical_Combining_Class=000_9}', "");
    Expect(0, 73111, '\p{^Is_Canonical_Combining_Class=000_9}', "");
    Expect(0, 73111, '\P{Is_Canonical_Combining_Class=000_9}', "");
    Expect(1, 73111, '\P{^Is_Canonical_Combining_Class=000_9}', "");
    Expect(0, 73112, '\p{Is_Canonical_Combining_Class=000_9}', "");
    Expect(1, 73112, '\p{^Is_Canonical_Combining_Class=000_9}', "");
    Expect(1, 73112, '\P{Is_Canonical_Combining_Class=000_9}', "");
    Expect(0, 73112, '\P{^Is_Canonical_Combining_Class=000_9}', "");
    Error('\p{Is_Ccc=	Virama/a/}');
    Error('\P{Is_Ccc=	Virama/a/}');
    Expect(1, 73111, '\p{Is_Ccc: virama}', "");
    Expect(0, 73111, '\p{^Is_Ccc: virama}', "");
    Expect(0, 73111, '\P{Is_Ccc: virama}', "");
    Expect(1, 73111, '\P{^Is_Ccc: virama}', "");
    Expect(0, 73112, '\p{Is_Ccc: virama}', "");
    Expect(1, 73112, '\p{^Is_Ccc: virama}', "");
    Expect(1, 73112, '\P{Is_Ccc: virama}', "");
    Expect(0, 73112, '\P{^Is_Ccc: virama}', "");
    Expect(1, 73111, '\p{Is_Ccc= 	Virama}', "");
    Expect(0, 73111, '\p{^Is_Ccc= 	Virama}', "");
    Expect(0, 73111, '\P{Is_Ccc= 	Virama}', "");
    Expect(1, 73111, '\P{^Is_Ccc= 	Virama}', "");
    Expect(0, 73112, '\p{Is_Ccc= 	Virama}', "");
    Expect(1, 73112, '\p{^Is_Ccc= 	Virama}', "");
    Expect(1, 73112, '\P{Is_Ccc= 	Virama}', "");
    Expect(0, 73112, '\P{^Is_Ccc= 	Virama}', "");
    Error('\p{Composition_Exclusion=	No:=}');
    Error('\P{Composition_Exclusion=	No:=}');
    Expect(1, 119233, '\p{Composition_Exclusion=:\ANo\z:}', "");;
    Expect(0, 119232, '\p{Composition_Exclusion=:\ANo\z:}', "");;
    Expect(1, 119233, '\p{Composition_Exclusion=no}', "");
    Expect(0, 119233, '\p{^Composition_Exclusion=no}', "");
    Expect(0, 119233, '\P{Composition_Exclusion=no}', "");
    Expect(1, 119233, '\P{^Composition_Exclusion=no}', "");
    Expect(0, 119232, '\p{Composition_Exclusion=no}', "");
    Expect(1, 119232, '\p{^Composition_Exclusion=no}', "");
    Expect(1, 119232, '\P{Composition_Exclusion=no}', "");
    Expect(0, 119232, '\P{^Composition_Exclusion=no}', "");
    Expect(1, 119233, '\p{Composition_Exclusion=:\Ano\z:}', "");;
    Expect(0, 119232, '\p{Composition_Exclusion=:\Ano\z:}', "");;
    Expect(1, 119233, '\p{Composition_Exclusion: 	 NO}', "");
    Expect(0, 119233, '\p{^Composition_Exclusion: 	 NO}', "");
    Expect(0, 119233, '\P{Composition_Exclusion: 	 NO}', "");
    Expect(1, 119233, '\P{^Composition_Exclusion: 	 NO}', "");
    Expect(0, 119232, '\p{Composition_Exclusion: 	 NO}', "");
    Expect(1, 119232, '\p{^Composition_Exclusion: 	 NO}', "");
    Expect(1, 119232, '\P{Composition_Exclusion: 	 NO}', "");
    Expect(0, 119232, '\P{^Composition_Exclusion: 	 NO}', "");
    Error('\p{CE=_n/a/}');
    Error('\P{CE=_n/a/}');
    Expect(1, 119233, '\p{CE=:\AN\z:}', "");;
    Expect(0, 119232, '\p{CE=:\AN\z:}', "");;
    Expect(1, 119233, '\p{CE=n}', "");
    Expect(0, 119233, '\p{^CE=n}', "");
    Expect(0, 119233, '\P{CE=n}', "");
    Expect(1, 119233, '\P{^CE=n}', "");
    Expect(0, 119232, '\p{CE=n}', "");
    Expect(1, 119232, '\p{^CE=n}', "");
    Expect(1, 119232, '\P{CE=n}', "");
    Expect(0, 119232, '\P{^CE=n}', "");
    Expect(1, 119233, '\p{CE=:\An\z:}', "");;
    Expect(0, 119232, '\p{CE=:\An\z:}', "");;
    Expect(1, 119233, '\p{CE=-	N}', "");
    Expect(0, 119233, '\p{^CE=-	N}', "");
    Expect(0, 119233, '\P{CE=-	N}', "");
    Expect(1, 119233, '\P{^CE=-	N}', "");
    Expect(0, 119232, '\p{CE=-	N}', "");
    Expect(1, 119232, '\p{^CE=-	N}', "");
    Expect(1, 119232, '\P{CE=-	N}', "");
    Expect(0, 119232, '\P{^CE=-	N}', "");
    Error('\p{Is_Composition_Exclusion=	-f:=}');
    Error('\P{Is_Composition_Exclusion=	-f:=}');
    Expect(1, 119233, '\p{Is_Composition_Exclusion=f}', "");
    Expect(0, 119233, '\p{^Is_Composition_Exclusion=f}', "");
    Expect(0, 119233, '\P{Is_Composition_Exclusion=f}', "");
    Expect(1, 119233, '\P{^Is_Composition_Exclusion=f}', "");
    Expect(0, 119232, '\p{Is_Composition_Exclusion=f}', "");
    Expect(1, 119232, '\p{^Is_Composition_Exclusion=f}', "");
    Expect(1, 119232, '\P{Is_Composition_Exclusion=f}', "");
    Expect(0, 119232, '\P{^Is_Composition_Exclusion=f}', "");
    Expect(1, 119233, '\p{Is_Composition_Exclusion=_f}', "");
    Expect(0, 119233, '\p{^Is_Composition_Exclusion=_f}', "");
    Expect(0, 119233, '\P{Is_Composition_Exclusion=_f}', "");
    Expect(1, 119233, '\P{^Is_Composition_Exclusion=_f}', "");
    Expect(0, 119232, '\p{Is_Composition_Exclusion=_f}', "");
    Expect(1, 119232, '\p{^Is_Composition_Exclusion=_f}', "");
    Expect(1, 119232, '\P{Is_Composition_Exclusion=_f}', "");
    Expect(0, 119232, '\P{^Is_Composition_Exclusion=_f}', "");
    Error('\p{Is_CE=/a/_ FALSE}');
    Error('\P{Is_CE=/a/_ FALSE}');
    Expect(1, 119233, '\p{Is_CE:	false}', "");
    Expect(0, 119233, '\p{^Is_CE:	false}', "");
    Expect(0, 119233, '\P{Is_CE:	false}', "");
    Expect(1, 119233, '\P{^Is_CE:	false}', "");
    Expect(0, 119232, '\p{Is_CE:	false}', "");
    Expect(1, 119232, '\p{^Is_CE:	false}', "");
    Expect(1, 119232, '\P{Is_CE:	false}', "");
    Expect(0, 119232, '\P{^Is_CE:	false}', "");
    Expect(1, 119233, '\p{Is_CE=_ false}', "");
    Expect(0, 119233, '\p{^Is_CE=_ false}', "");
    Expect(0, 119233, '\P{Is_CE=_ false}', "");
    Expect(1, 119233, '\P{^Is_CE=_ false}', "");
    Expect(0, 119232, '\p{Is_CE=_ false}', "");
    Expect(1, 119232, '\p{^Is_CE=_ false}', "");
    Expect(1, 119232, '\P{Is_CE=_ false}', "");
    Expect(0, 119232, '\P{^Is_CE=_ false}', "");
    Error('\p{Composition_Exclusion=-:=YES}');
    Error('\P{Composition_Exclusion=-:=YES}');
    Expect(1, 119232, '\p{Composition_Exclusion=:\AYes\z:}', "");;
    Expect(0, 119233, '\p{Composition_Exclusion=:\AYes\z:}', "");;
    Expect(1, 119232, '\p{Composition_Exclusion=yes}', "");
    Expect(0, 119232, '\p{^Composition_Exclusion=yes}', "");
    Expect(0, 119232, '\P{Composition_Exclusion=yes}', "");
    Expect(1, 119232, '\P{^Composition_Exclusion=yes}', "");
    Expect(0, 119233, '\p{Composition_Exclusion=yes}', "");
    Expect(1, 119233, '\p{^Composition_Exclusion=yes}', "");
    Expect(1, 119233, '\P{Composition_Exclusion=yes}', "");
    Expect(0, 119233, '\P{^Composition_Exclusion=yes}', "");
    Expect(1, 119232, '\p{Composition_Exclusion=:\Ayes\z:}', "");;
    Expect(0, 119233, '\p{Composition_Exclusion=:\Ayes\z:}', "");;
    Expect(1, 119232, '\p{Composition_Exclusion= 	YES}', "");
    Expect(0, 119232, '\p{^Composition_Exclusion= 	YES}', "");
    Expect(0, 119232, '\P{Composition_Exclusion= 	YES}', "");
    Expect(1, 119232, '\P{^Composition_Exclusion= 	YES}', "");
    Expect(0, 119233, '\p{Composition_Exclusion= 	YES}', "");
    Expect(1, 119233, '\p{^Composition_Exclusion= 	YES}', "");
    Expect(1, 119233, '\P{Composition_Exclusion= 	YES}', "");
    Expect(0, 119233, '\P{^Composition_Exclusion= 	YES}', "");
    Error('\p{CE=:=Y}');
    Error('\P{CE=:=Y}');
    Expect(1, 119232, '\p{CE=:\AY\z:}', "");;
    Expect(0, 119233, '\p{CE=:\AY\z:}', "");;
    Expect(1, 119232, '\p{CE=y}', "");
    Expect(0, 119232, '\p{^CE=y}', "");
    Expect(0, 119232, '\P{CE=y}', "");
    Expect(1, 119232, '\P{^CE=y}', "");
    Expect(0, 119233, '\p{CE=y}', "");
    Expect(1, 119233, '\p{^CE=y}', "");
    Expect(1, 119233, '\P{CE=y}', "");
    Expect(0, 119233, '\P{^CE=y}', "");
    Expect(1, 119232, '\p{CE=:\Ay\z:}', "");;
    Expect(0, 119233, '\p{CE=:\Ay\z:}', "");;
    Expect(1, 119232, '\p{CE=_	y}', "");
    Expect(0, 119232, '\p{^CE=_	y}', "");
    Expect(0, 119232, '\P{CE=_	y}', "");
    Expect(1, 119232, '\P{^CE=_	y}', "");
    Expect(0, 119233, '\p{CE=_	y}', "");
    Expect(1, 119233, '\p{^CE=_	y}', "");
    Expect(1, 119233, '\P{CE=_	y}', "");
    Expect(0, 119233, '\P{^CE=_	y}', "");
    Error('\p{Is_Composition_Exclusion=/a/_T}');
    Error('\P{Is_Composition_Exclusion=/a/_T}');
    Expect(1, 119232, '\p{Is_Composition_Exclusion=t}', "");
    Expect(0, 119232, '\p{^Is_Composition_Exclusion=t}', "");
    Expect(0, 119232, '\P{Is_Composition_Exclusion=t}', "");
    Expect(1, 119232, '\P{^Is_Composition_Exclusion=t}', "");
    Expect(0, 119233, '\p{Is_Composition_Exclusion=t}', "");
    Expect(1, 119233, '\p{^Is_Composition_Exclusion=t}', "");
    Expect(1, 119233, '\P{Is_Composition_Exclusion=t}', "");
    Expect(0, 119233, '\P{^Is_Composition_Exclusion=t}', "");
    Expect(1, 119232, '\p{Is_Composition_Exclusion=--T}', "");
    Expect(0, 119232, '\p{^Is_Composition_Exclusion=--T}', "");
    Expect(0, 119232, '\P{Is_Composition_Exclusion=--T}', "");
    Expect(1, 119232, '\P{^Is_Composition_Exclusion=--T}', "");
    Expect(0, 119233, '\p{Is_Composition_Exclusion=--T}', "");
    Expect(1, 119233, '\p{^Is_Composition_Exclusion=--T}', "");
    Expect(1, 119233, '\P{Is_Composition_Exclusion=--T}', "");
    Expect(0, 119233, '\P{^Is_Composition_Exclusion=--T}', "");
    Error('\p{Is_CE=-/a/True}');
    Error('\P{Is_CE=-/a/True}');
    Expect(1, 119232, '\p{Is_CE=true}', "");
    Expect(0, 119232, '\p{^Is_CE=true}', "");
    Expect(0, 119232, '\P{Is_CE=true}', "");
    Expect(1, 119232, '\P{^Is_CE=true}', "");
    Expect(0, 119233, '\p{Is_CE=true}', "");
    Expect(1, 119233, '\p{^Is_CE=true}', "");
    Expect(1, 119233, '\P{Is_CE=true}', "");
    Expect(0, 119233, '\P{^Is_CE=true}', "");
    Expect(1, 119232, '\p{Is_CE:		TRUE}', "");
    Expect(0, 119232, '\p{^Is_CE:		TRUE}', "");
    Expect(0, 119232, '\P{Is_CE:		TRUE}', "");
    Expect(1, 119232, '\P{^Is_CE:		TRUE}', "");
    Expect(0, 119233, '\p{Is_CE:		TRUE}', "");
    Expect(1, 119233, '\p{^Is_CE:		TRUE}', "");
    Expect(1, 119233, '\P{Is_CE:		TRUE}', "");
    Expect(0, 119233, '\P{^Is_CE:		TRUE}', "");
    Error('\p{casefolding}');
    Error('\P{casefolding}');
    Error('\p{Case_Ignorable=_No:=}');
    Error('\P{Case_Ignorable=_No:=}');
    Expect(1, 918000, '\p{Case_Ignorable=:\ANo\z:}', "");;
    Expect(0, 917999, '\p{Case_Ignorable=:\ANo\z:}', "");;
    Expect(1, 918000, '\p{Case_Ignorable=no}', "");
    Expect(0, 918000, '\p{^Case_Ignorable=no}', "");
    Expect(0, 918000, '\P{Case_Ignorable=no}', "");
    Expect(1, 918000, '\P{^Case_Ignorable=no}', "");
    Expect(0, 917999, '\p{Case_Ignorable=no}', "");
    Expect(1, 917999, '\p{^Case_Ignorable=no}', "");
    Expect(1, 917999, '\P{Case_Ignorable=no}', "");
    Expect(0, 917999, '\P{^Case_Ignorable=no}', "");
    Expect(1, 918000, '\p{Case_Ignorable=:\Ano\z:}', "");;
    Expect(0, 917999, '\p{Case_Ignorable=:\Ano\z:}', "");;
    Expect(1, 918000, '\p{Case_Ignorable=	no}', "");
    Expect(0, 918000, '\p{^Case_Ignorable=	no}', "");
    Expect(0, 918000, '\P{Case_Ignorable=	no}', "");
    Expect(1, 918000, '\P{^Case_Ignorable=	no}', "");
    Expect(0, 917999, '\p{Case_Ignorable=	no}', "");
    Expect(1, 917999, '\p{^Case_Ignorable=	no}', "");
    Expect(1, 917999, '\P{Case_Ignorable=	no}', "");
    Expect(0, 917999, '\P{^Case_Ignorable=	no}', "");
    Error('\p{CI: 	:=N}');
    Error('\P{CI: 	:=N}');
    Expect(1, 918000, '\p{CI=:\AN\z:}', "");;
    Expect(0, 917999, '\p{CI=:\AN\z:}', "");;
    Expect(1, 918000, '\p{CI=n}', "");
    Expect(0, 918000, '\p{^CI=n}', "");
    Expect(0, 918000, '\P{CI=n}', "");
    Expect(1, 918000, '\P{^CI=n}', "");
    Expect(0, 917999, '\p{CI=n}', "");
    Expect(1, 917999, '\p{^CI=n}', "");
    Expect(1, 917999, '\P{CI=n}', "");
    Expect(0, 917999, '\P{^CI=n}', "");
    Expect(1, 918000, '\p{CI=:\An\z:}', "");;
    Expect(0, 917999, '\p{CI=:\An\z:}', "");;
    Expect(1, 918000, '\p{CI=  n}', "");
    Expect(0, 918000, '\p{^CI=  n}', "");
    Expect(0, 918000, '\P{CI=  n}', "");
    Expect(1, 918000, '\P{^CI=  n}', "");
    Expect(0, 917999, '\p{CI=  n}', "");
    Expect(1, 917999, '\p{^CI=  n}', "");
    Expect(1, 917999, '\P{CI=  n}', "");
    Expect(0, 917999, '\P{^CI=  n}', "");
    Error('\p{Is_Case_Ignorable=:=	F}');
    Error('\P{Is_Case_Ignorable=:=	F}');
    Expect(1, 918000, '\p{Is_Case_Ignorable=f}', "");
    Expect(0, 918000, '\p{^Is_Case_Ignorable=f}', "");
    Expect(0, 918000, '\P{Is_Case_Ignorable=f}', "");
    Expect(1, 918000, '\P{^Is_Case_Ignorable=f}', "");
    Expect(0, 917999, '\p{Is_Case_Ignorable=f}', "");
    Expect(1, 917999, '\p{^Is_Case_Ignorable=f}', "");
    Expect(1, 917999, '\P{Is_Case_Ignorable=f}', "");
    Expect(0, 917999, '\P{^Is_Case_Ignorable=f}', "");
    Expect(1, 918000, '\p{Is_Case_Ignorable=	-F}', "");
    Expect(0, 918000, '\p{^Is_Case_Ignorable=	-F}', "");
    Expect(0, 918000, '\P{Is_Case_Ignorable=	-F}', "");
    Expect(1, 918000, '\P{^Is_Case_Ignorable=	-F}', "");
    Expect(0, 917999, '\p{Is_Case_Ignorable=	-F}', "");
    Expect(1, 917999, '\p{^Is_Case_Ignorable=	-F}', "");
    Expect(1, 917999, '\P{Is_Case_Ignorable=	-F}', "");
    Expect(0, 917999, '\P{^Is_Case_Ignorable=	-F}', "");
    Error('\p{Is_CI=:= -False}');
    Error('\P{Is_CI=:= -False}');
    Expect(1, 918000, '\p{Is_CI=false}', "");
    Expect(0, 918000, '\p{^Is_CI=false}', "");
    Expect(0, 918000, '\P{Is_CI=false}', "");
    Expect(1, 918000, '\P{^Is_CI=false}', "");
    Expect(0, 917999, '\p{Is_CI=false}', "");
    Expect(1, 917999, '\p{^Is_CI=false}', "");
    Expect(1, 917999, '\P{Is_CI=false}', "");
    Expect(0, 917999, '\P{^Is_CI=false}', "");
    Expect(1, 918000, '\p{Is_CI=- False}', "");
    Expect(0, 918000, '\p{^Is_CI=- False}', "");
    Expect(0, 918000, '\P{Is_CI=- False}', "");
    Expect(1, 918000, '\P{^Is_CI=- False}', "");
    Expect(0, 917999, '\p{Is_CI=- False}', "");
    Expect(1, 917999, '\p{^Is_CI=- False}', "");
    Expect(1, 917999, '\P{Is_CI=- False}', "");
    Expect(0, 917999, '\P{^Is_CI=- False}', "");
    Error('\p{Case_Ignorable: 	:=Yes}');
    Error('\P{Case_Ignorable: 	:=Yes}');
    Expect(1, 917999, '\p{Case_Ignorable=:\AYes\z:}', "");;
    Expect(0, 918000, '\p{Case_Ignorable=:\AYes\z:}', "");;
    Expect(1, 917999, '\p{Case_Ignorable=yes}', "");
    Expect(0, 917999, '\p{^Case_Ignorable=yes}', "");
    Expect(0, 917999, '\P{Case_Ignorable=yes}', "");
    Expect(1, 917999, '\P{^Case_Ignorable=yes}', "");
    Expect(0, 918000, '\p{Case_Ignorable=yes}', "");
    Expect(1, 918000, '\p{^Case_Ignorable=yes}', "");
    Expect(1, 918000, '\P{Case_Ignorable=yes}', "");
    Expect(0, 918000, '\P{^Case_Ignorable=yes}', "");
    Expect(1, 917999, '\p{Case_Ignorable=:\Ayes\z:}', "");;
    Expect(0, 918000, '\p{Case_Ignorable=:\Ayes\z:}', "");;
    Expect(1, 917999, '\p{Case_Ignorable=-	Yes}', "");
    Expect(0, 917999, '\p{^Case_Ignorable=-	Yes}', "");
    Expect(0, 917999, '\P{Case_Ignorable=-	Yes}', "");
    Expect(1, 917999, '\P{^Case_Ignorable=-	Yes}', "");
    Expect(0, 918000, '\p{Case_Ignorable=-	Yes}', "");
    Expect(1, 918000, '\p{^Case_Ignorable=-	Yes}', "");
    Expect(1, 918000, '\P{Case_Ignorable=-	Yes}', "");
    Expect(0, 918000, '\P{^Case_Ignorable=-	Yes}', "");
    Error('\p{CI=-/a/Y}');
    Error('\P{CI=-/a/Y}');
    Expect(1, 917999, '\p{CI=:\AY\z:}', "");;
    Expect(0, 918000, '\p{CI=:\AY\z:}', "");;
    Expect(1, 917999, '\p{CI=y}', "");
    Expect(0, 917999, '\p{^CI=y}', "");
    Expect(0, 917999, '\P{CI=y}', "");
    Expect(1, 917999, '\P{^CI=y}', "");
    Expect(0, 918000, '\p{CI=y}', "");
    Expect(1, 918000, '\p{^CI=y}', "");
    Expect(1, 918000, '\P{CI=y}', "");
    Expect(0, 918000, '\P{^CI=y}', "");
    Expect(1, 917999, '\p{CI=:\Ay\z:}', "");;
    Expect(0, 918000, '\p{CI=:\Ay\z:}', "");;
    Expect(1, 917999, '\p{CI=  Y}', "");
    Expect(0, 917999, '\p{^CI=  Y}', "");
    Expect(0, 917999, '\P{CI=  Y}', "");
    Expect(1, 917999, '\P{^CI=  Y}', "");
    Expect(0, 918000, '\p{CI=  Y}', "");
    Expect(1, 918000, '\p{^CI=  Y}', "");
    Expect(1, 918000, '\P{CI=  Y}', "");
    Expect(0, 918000, '\P{^CI=  Y}', "");
    Error('\p{Is_Case_Ignorable=_/a/T}');
    Error('\P{Is_Case_Ignorable=_/a/T}');
    Expect(1, 917999, '\p{Is_Case_Ignorable=t}', "");
    Expect(0, 917999, '\p{^Is_Case_Ignorable=t}', "");
    Expect(0, 917999, '\P{Is_Case_Ignorable=t}', "");
    Expect(1, 917999, '\P{^Is_Case_Ignorable=t}', "");
    Expect(0, 918000, '\p{Is_Case_Ignorable=t}', "");
    Expect(1, 918000, '\p{^Is_Case_Ignorable=t}', "");
    Expect(1, 918000, '\P{Is_Case_Ignorable=t}', "");
    Expect(0, 918000, '\P{^Is_Case_Ignorable=t}', "");
    Expect(1, 917999, '\p{Is_Case_Ignorable=-_T}', "");
    Expect(0, 917999, '\p{^Is_Case_Ignorable=-_T}', "");
    Expect(0, 917999, '\P{Is_Case_Ignorable=-_T}', "");
    Expect(1, 917999, '\P{^Is_Case_Ignorable=-_T}', "");
    Expect(0, 918000, '\p{Is_Case_Ignorable=-_T}', "");
    Expect(1, 918000, '\p{^Is_Case_Ignorable=-_T}', "");
    Expect(1, 918000, '\P{Is_Case_Ignorable=-_T}', "");
    Expect(0, 918000, '\P{^Is_Case_Ignorable=-_T}', "");
    Error('\p{Is_CI=	/a/true}');
    Error('\P{Is_CI=	/a/true}');
    Expect(1, 917999, '\p{Is_CI=true}', "");
    Expect(0, 917999, '\p{^Is_CI=true}', "");
    Expect(0, 917999, '\P{Is_CI=true}', "");
    Expect(1, 917999, '\P{^Is_CI=true}', "");
    Expect(0, 918000, '\p{Is_CI=true}', "");
    Expect(1, 918000, '\p{^Is_CI=true}', "");
    Expect(1, 918000, '\P{Is_CI=true}', "");
    Expect(0, 918000, '\P{^Is_CI=true}', "");
    Expect(1, 917999, '\p{Is_CI=_-True}', "");
    Expect(0, 917999, '\p{^Is_CI=_-True}', "");
    Expect(0, 917999, '\P{Is_CI=_-True}', "");
    Expect(1, 917999, '\P{^Is_CI=_-True}', "");
    Expect(0, 918000, '\p{Is_CI=_-True}', "");
    Expect(1, 918000, '\p{^Is_CI=_-True}', "");
    Expect(1, 918000, '\P{Is_CI=_-True}', "");
    Expect(0, 918000, '\P{^Is_CI=_-True}', "");
    Error('\p{kaccountingnumeric}');
    Error('\P{kaccountingnumeric}');
    Error('\p{cjkaccountingnumeric}');
    Error('\P{cjkaccountingnumeric}');
    Error('\p{kcompatibilityvariant}');
    Error('\P{kcompatibilityvariant}');
    Error('\p{cjkcompatibilityvariant}');
    Error('\P{cjkcompatibilityvariant}');
    Error('\p{kiicore}');
    Error('\P{kiicore}');
    Error('\p{cjkiicore}');
    Error('\P{cjkiicore}');
    Error('\p{kirggsource}');
    Error('\P{kirggsource}');
    Error('\p{cjkirggsource}');
    Error('\P{cjkirggsource}');
    Error('\p{kirghsource}');
    Error('\P{kirghsource}');
    Error('\p{cjkirghsource}');
    Error('\P{cjkirghsource}');
    Error('\p{kirgjsource}');
    Error('\P{kirgjsource}');
    Error('\p{cjkirgjsource}');
    Error('\P{cjkirgjsource}');
    Error('\p{kirgkpsource}');
    Error('\P{kirgkpsource}');
    Error('\p{cjkirgkpsource}');
    Error('\P{cjkirgkpsource}');
    Error('\p{kirgksource}');
    Error('\P{kirgksource}');
    Error('\p{cjkirgksource}');
    Error('\P{cjkirgksource}');
    Error('\p{kirgmsource}');
    Error('\P{kirgmsource}');
    Error('\p{cjkirgmsource}');
    Error('\P{cjkirgmsource}');
    Error('\p{kirgssource}');
    Error('\P{kirgssource}');
    Error('\p{cjkirgssource}');
    Error('\P{cjkirgssource}');
    Error('\p{kirgtsource}');
    Error('\P{kirgtsource}');
    Error('\p{cjkirgtsource}');
    Error('\P{cjkirgtsource}');
    Error('\p{kirguksource}');
    Error('\P{kirguksource}');
    Error('\p{cjkirguksource}');
    Error('\P{cjkirguksource}');
    Error('\p{kirgusource}');
    Error('\P{kirgusource}');
    Error('\p{cjkirgusource}');
    Error('\P{cjkirgusource}');
    Error('\p{kirgvsource}');
    Error('\P{kirgvsource}');
    Error('\p{cjkirgvsource}');
    Error('\P{cjkirgvsource}');
    Error('\p{kothernumeric}');
    Error('\P{kothernumeric}');
    Error('\p{cjkothernumeric}');
    Error('\P{cjkothernumeric}');
    Error('\p{kprimarynumeric}');
    Error('\P{kprimarynumeric}');
    Error('\p{cjkprimarynumeric}');
    Error('\P{cjkprimarynumeric}');
    Error('\p{krsunicode}');
    Error('\P{krsunicode}');
    Error('\p{cjkrsunicode}');
    Error('\P{cjkrsunicode}');
    Error('\p{unicoderadicalstroke}');
    Error('\P{unicoderadicalstroke}');
    Error('\p{urs}');
    Error('\P{urs}');
    Error('\p{Full_Composition_Exclusion=_ no:=}');
    Error('\P{Full_Composition_Exclusion=_ no:=}');
    Expect(1, 195102, '\p{Full_Composition_Exclusion=:\ANo\z:}', "");;
    Expect(0, 195101, '\p{Full_Composition_Exclusion=:\ANo\z:}', "");;
    Expect(1, 195102, '\p{Full_Composition_Exclusion=no}', "");
    Expect(0, 195102, '\p{^Full_Composition_Exclusion=no}', "");
    Expect(0, 195102, '\P{Full_Composition_Exclusion=no}', "");
    Expect(1, 195102, '\P{^Full_Composition_Exclusion=no}', "");
    Expect(0, 195101, '\p{Full_Composition_Exclusion=no}', "");
    Expect(1, 195101, '\p{^Full_Composition_Exclusion=no}', "");
    Expect(1, 195101, '\P{Full_Composition_Exclusion=no}', "");
    Expect(0, 195101, '\P{^Full_Composition_Exclusion=no}', "");
    Expect(1, 195102, '\p{Full_Composition_Exclusion=:\Ano\z:}', "");;
    Expect(0, 195101, '\p{Full_Composition_Exclusion=:\Ano\z:}', "");;
    Expect(1, 195102, '\p{Full_Composition_Exclusion= _NO}', "");
    Expect(0, 195102, '\p{^Full_Composition_Exclusion= _NO}', "");
    Expect(0, 195102, '\P{Full_Composition_Exclusion= _NO}', "");
    Expect(1, 195102, '\P{^Full_Composition_Exclusion= _NO}', "");
    Expect(0, 195101, '\p{Full_Composition_Exclusion= _NO}', "");
    Expect(1, 195101, '\p{^Full_Composition_Exclusion= _NO}', "");
    Expect(1, 195101, '\P{Full_Composition_Exclusion= _NO}', "");
    Expect(0, 195101, '\P{^Full_Composition_Exclusion= _NO}', "");
    Error('\p{Comp_Ex=-	N:=}');
    Error('\P{Comp_Ex=-	N:=}');
    Expect(1, 195102, '\p{Comp_Ex=:\AN\z:}', "");;
    Expect(0, 195101, '\p{Comp_Ex=:\AN\z:}', "");;
    Expect(1, 195102, '\p{Comp_Ex=n}', "");
    Expect(0, 195102, '\p{^Comp_Ex=n}', "");
    Expect(0, 195102, '\P{Comp_Ex=n}', "");
    Expect(1, 195102, '\P{^Comp_Ex=n}', "");
    Expect(0, 195101, '\p{Comp_Ex=n}', "");
    Expect(1, 195101, '\p{^Comp_Ex=n}', "");
    Expect(1, 195101, '\P{Comp_Ex=n}', "");
    Expect(0, 195101, '\P{^Comp_Ex=n}', "");
    Expect(1, 195102, '\p{Comp_Ex=:\An\z:}', "");;
    Expect(0, 195101, '\p{Comp_Ex=:\An\z:}', "");;
    Expect(1, 195102, '\p{Comp_Ex=__N}', "");
    Expect(0, 195102, '\p{^Comp_Ex=__N}', "");
    Expect(0, 195102, '\P{Comp_Ex=__N}', "");
    Expect(1, 195102, '\P{^Comp_Ex=__N}', "");
    Expect(0, 195101, '\p{Comp_Ex=__N}', "");
    Expect(1, 195101, '\p{^Comp_Ex=__N}', "");
    Expect(1, 195101, '\P{Comp_Ex=__N}', "");
    Expect(0, 195101, '\P{^Comp_Ex=__N}', "");
    Error('\p{Is_Full_Composition_Exclusion=/a/ -F}');
    Error('\P{Is_Full_Composition_Exclusion=/a/ -F}');
    Expect(1, 195102, '\p{Is_Full_Composition_Exclusion=f}', "");
    Expect(0, 195102, '\p{^Is_Full_Composition_Exclusion=f}', "");
    Expect(0, 195102, '\P{Is_Full_Composition_Exclusion=f}', "");
    Expect(1, 195102, '\P{^Is_Full_Composition_Exclusion=f}', "");
    Expect(0, 195101, '\p{Is_Full_Composition_Exclusion=f}', "");
    Expect(1, 195101, '\p{^Is_Full_Composition_Exclusion=f}', "");
    Expect(1, 195101, '\P{Is_Full_Composition_Exclusion=f}', "");
    Expect(0, 195101, '\P{^Is_Full_Composition_Exclusion=f}', "");
    Expect(1, 195102, '\p{Is_Full_Composition_Exclusion=	 F}', "");
    Expect(0, 195102, '\p{^Is_Full_Composition_Exclusion=	 F}', "");
    Expect(0, 195102, '\P{Is_Full_Composition_Exclusion=	 F}', "");
    Expect(1, 195102, '\P{^Is_Full_Composition_Exclusion=	 F}', "");
    Expect(0, 195101, '\p{Is_Full_Composition_Exclusion=	 F}', "");
    Expect(1, 195101, '\p{^Is_Full_Composition_Exclusion=	 F}', "");
    Expect(1, 195101, '\P{Is_Full_Composition_Exclusion=	 F}', "");
    Expect(0, 195101, '\P{^Is_Full_Composition_Exclusion=	 F}', "");
    Error('\p{Is_Comp_Ex=:=	false}');
    Error('\P{Is_Comp_Ex=:=	false}');
    Expect(1, 195102, '\p{Is_Comp_Ex=false}', "");
    Expect(0, 195102, '\p{^Is_Comp_Ex=false}', "");
    Expect(0, 195102, '\P{Is_Comp_Ex=false}', "");
    Expect(1, 195102, '\P{^Is_Comp_Ex=false}', "");
    Expect(0, 195101, '\p{Is_Comp_Ex=false}', "");
    Expect(1, 195101, '\p{^Is_Comp_Ex=false}', "");
    Expect(1, 195101, '\P{Is_Comp_Ex=false}', "");
    Expect(0, 195101, '\P{^Is_Comp_Ex=false}', "");
    Expect(1, 195102, '\p{Is_Comp_Ex=-	False}', "");
    Expect(0, 195102, '\p{^Is_Comp_Ex=-	False}', "");
    Expect(0, 195102, '\P{Is_Comp_Ex=-	False}', "");
    Expect(1, 195102, '\P{^Is_Comp_Ex=-	False}', "");
    Expect(0, 195101, '\p{Is_Comp_Ex=-	False}', "");
    Expect(1, 195101, '\p{^Is_Comp_Ex=-	False}', "");
    Expect(1, 195101, '\P{Is_Comp_Ex=-	False}', "");
    Expect(0, 195101, '\P{^Is_Comp_Ex=-	False}', "");
    Error('\p{Full_Composition_Exclusion=-yes/a/}');
    Error('\P{Full_Composition_Exclusion=-yes/a/}');
    Expect(1, 195101, '\p{Full_Composition_Exclusion=:\AYes\z:}', "");;
    Expect(0, 195102, '\p{Full_Composition_Exclusion=:\AYes\z:}', "");;
    Expect(1, 195101, '\p{Full_Composition_Exclusion: yes}', "");
    Expect(0, 195101, '\p{^Full_Composition_Exclusion: yes}', "");
    Expect(0, 195101, '\P{Full_Composition_Exclusion: yes}', "");
    Expect(1, 195101, '\P{^Full_Composition_Exclusion: yes}', "");
    Expect(0, 195102, '\p{Full_Composition_Exclusion: yes}', "");
    Expect(1, 195102, '\p{^Full_Composition_Exclusion: yes}', "");
    Expect(1, 195102, '\P{Full_Composition_Exclusion: yes}', "");
    Expect(0, 195102, '\P{^Full_Composition_Exclusion: yes}', "");
    Expect(1, 195101, '\p{Full_Composition_Exclusion=:\Ayes\z:}', "");;
    Expect(0, 195102, '\p{Full_Composition_Exclusion=:\Ayes\z:}', "");;
    Expect(1, 195101, '\p{Full_Composition_Exclusion= yes}', "");
    Expect(0, 195101, '\p{^Full_Composition_Exclusion= yes}', "");
    Expect(0, 195101, '\P{Full_Composition_Exclusion= yes}', "");
    Expect(1, 195101, '\P{^Full_Composition_Exclusion= yes}', "");
    Expect(0, 195102, '\p{Full_Composition_Exclusion= yes}', "");
    Expect(1, 195102, '\p{^Full_Composition_Exclusion= yes}', "");
    Expect(1, 195102, '\P{Full_Composition_Exclusion= yes}', "");
    Expect(0, 195102, '\P{^Full_Composition_Exclusion= yes}', "");
    Error('\p{Comp_Ex=_:=Y}');
    Error('\P{Comp_Ex=_:=Y}');
    Expect(1, 195101, '\p{Comp_Ex=:\AY\z:}', "");;
    Expect(0, 195102, '\p{Comp_Ex=:\AY\z:}', "");;
    Expect(1, 195101, '\p{Comp_Ex=y}', "");
    Expect(0, 195101, '\p{^Comp_Ex=y}', "");
    Expect(0, 195101, '\P{Comp_Ex=y}', "");
    Expect(1, 195101, '\P{^Comp_Ex=y}', "");
    Expect(0, 195102, '\p{Comp_Ex=y}', "");
    Expect(1, 195102, '\p{^Comp_Ex=y}', "");
    Expect(1, 195102, '\P{Comp_Ex=y}', "");
    Expect(0, 195102, '\P{^Comp_Ex=y}', "");
    Expect(1, 195101, '\p{Comp_Ex=:\Ay\z:}', "");;
    Expect(0, 195102, '\p{Comp_Ex=:\Ay\z:}', "");;
    Expect(1, 195101, '\p{Comp_Ex=__Y}', "");
    Expect(0, 195101, '\p{^Comp_Ex=__Y}', "");
    Expect(0, 195101, '\P{Comp_Ex=__Y}', "");
    Expect(1, 195101, '\P{^Comp_Ex=__Y}', "");
    Expect(0, 195102, '\p{Comp_Ex=__Y}', "");
    Expect(1, 195102, '\p{^Comp_Ex=__Y}', "");
    Expect(1, 195102, '\P{Comp_Ex=__Y}', "");
    Expect(0, 195102, '\P{^Comp_Ex=__Y}', "");
    Error('\p{Is_Full_Composition_Exclusion=_t/a/}');
    Error('\P{Is_Full_Composition_Exclusion=_t/a/}');
    Expect(1, 195101, '\p{Is_Full_Composition_Exclusion=t}', "");
    Expect(0, 195101, '\p{^Is_Full_Composition_Exclusion=t}', "");
    Expect(0, 195101, '\P{Is_Full_Composition_Exclusion=t}', "");
    Expect(1, 195101, '\P{^Is_Full_Composition_Exclusion=t}', "");
    Expect(0, 195102, '\p{Is_Full_Composition_Exclusion=t}', "");
    Expect(1, 195102, '\p{^Is_Full_Composition_Exclusion=t}', "");
    Expect(1, 195102, '\P{Is_Full_Composition_Exclusion=t}', "");
    Expect(0, 195102, '\P{^Is_Full_Composition_Exclusion=t}', "");
    Expect(1, 195101, '\p{Is_Full_Composition_Exclusion:   -_T}', "");
    Expect(0, 195101, '\p{^Is_Full_Composition_Exclusion:   -_T}', "");
    Expect(0, 195101, '\P{Is_Full_Composition_Exclusion:   -_T}', "");
    Expect(1, 195101, '\P{^Is_Full_Composition_Exclusion:   -_T}', "");
    Expect(0, 195102, '\p{Is_Full_Composition_Exclusion:   -_T}', "");
    Expect(1, 195102, '\p{^Is_Full_Composition_Exclusion:   -_T}', "");
    Expect(1, 195102, '\P{Is_Full_Composition_Exclusion:   -_T}', "");
    Expect(0, 195102, '\P{^Is_Full_Composition_Exclusion:   -_T}', "");
    Error('\p{Is_Comp_Ex=_/a/true}');
    Error('\P{Is_Comp_Ex=_/a/true}');
    Expect(1, 195101, '\p{Is_Comp_Ex=true}', "");
    Expect(0, 195101, '\p{^Is_Comp_Ex=true}', "");
    Expect(0, 195101, '\P{Is_Comp_Ex=true}', "");
    Expect(1, 195101, '\P{^Is_Comp_Ex=true}', "");
    Expect(0, 195102, '\p{Is_Comp_Ex=true}', "");
    Expect(1, 195102, '\p{^Is_Comp_Ex=true}', "");
    Expect(1, 195102, '\P{Is_Comp_Ex=true}', "");
    Expect(0, 195102, '\P{^Is_Comp_Ex=true}', "");
    Expect(1, 195101, '\p{Is_Comp_Ex= -True}', "");
    Expect(0, 195101, '\p{^Is_Comp_Ex= -True}', "");
    Expect(0, 195101, '\P{Is_Comp_Ex= -True}', "");
    Expect(1, 195101, '\P{^Is_Comp_Ex= -True}', "");
    Expect(0, 195102, '\p{Is_Comp_Ex= -True}', "");
    Expect(1, 195102, '\p{^Is_Comp_Ex= -True}', "");
    Expect(1, 195102, '\P{Is_Comp_Ex= -True}', "");
    Expect(0, 195102, '\P{^Is_Comp_Ex= -True}', "");
    Error('\p{Changes_When_Casefolded=-:=no}');
    Error('\P{Changes_When_Casefolded=-:=no}');
    Expect(1, 125218, '\p{Changes_When_Casefolded=:\ANo\z:}', "");;
    Expect(0, 125217, '\p{Changes_When_Casefolded=:\ANo\z:}', "");;
    Expect(1, 125218, '\p{Changes_When_Casefolded=no}', "");
    Expect(0, 125218, '\p{^Changes_When_Casefolded=no}', "");
    Expect(0, 125218, '\P{Changes_When_Casefolded=no}', "");
    Expect(1, 125218, '\P{^Changes_When_Casefolded=no}', "");
    Expect(0, 125217, '\p{Changes_When_Casefolded=no}', "");
    Expect(1, 125217, '\p{^Changes_When_Casefolded=no}', "");
    Expect(1, 125217, '\P{Changes_When_Casefolded=no}', "");
    Expect(0, 125217, '\P{^Changes_When_Casefolded=no}', "");
    Expect(1, 125218, '\p{Changes_When_Casefolded=:\Ano\z:}', "");;
    Expect(0, 125217, '\p{Changes_When_Casefolded=:\Ano\z:}', "");;
    Expect(1, 125218, '\p{Changes_When_Casefolded=-No}', "");
    Expect(0, 125218, '\p{^Changes_When_Casefolded=-No}', "");
    Expect(0, 125218, '\P{Changes_When_Casefolded=-No}', "");
    Expect(1, 125218, '\P{^Changes_When_Casefolded=-No}', "");
    Expect(0, 125217, '\p{Changes_When_Casefolded=-No}', "");
    Expect(1, 125217, '\p{^Changes_When_Casefolded=-No}', "");
    Expect(1, 125217, '\P{Changes_When_Casefolded=-No}', "");
    Expect(0, 125217, '\P{^Changes_When_Casefolded=-No}', "");
    Error('\p{CWCF:N:=}');
    Error('\P{CWCF:N:=}');
    Expect(1, 125218, '\p{CWCF=:\AN\z:}', "");;
    Expect(0, 125217, '\p{CWCF=:\AN\z:}', "");;
    Expect(1, 125218, '\p{CWCF:n}', "");
    Expect(0, 125218, '\p{^CWCF:n}', "");
    Expect(0, 125218, '\P{CWCF:n}', "");
    Expect(1, 125218, '\P{^CWCF:n}', "");
    Expect(0, 125217, '\p{CWCF:n}', "");
    Expect(1, 125217, '\p{^CWCF:n}', "");
    Expect(1, 125217, '\P{CWCF:n}', "");
    Expect(0, 125217, '\P{^CWCF:n}', "");
    Expect(1, 125218, '\p{CWCF=:\An\z:}', "");;
    Expect(0, 125217, '\p{CWCF=:\An\z:}', "");;
    Expect(1, 125218, '\p{CWCF=_N}', "");
    Expect(0, 125218, '\p{^CWCF=_N}', "");
    Expect(0, 125218, '\P{CWCF=_N}', "");
    Expect(1, 125218, '\P{^CWCF=_N}', "");
    Expect(0, 125217, '\p{CWCF=_N}', "");
    Expect(1, 125217, '\p{^CWCF=_N}', "");
    Expect(1, 125217, '\P{CWCF=_N}', "");
    Expect(0, 125217, '\P{^CWCF=_N}', "");
    Error('\p{Is_Changes_When_Casefolded=--F/a/}');
    Error('\P{Is_Changes_When_Casefolded=--F/a/}');
    Expect(1, 125218, '\p{Is_Changes_When_Casefolded=f}', "");
    Expect(0, 125218, '\p{^Is_Changes_When_Casefolded=f}', "");
    Expect(0, 125218, '\P{Is_Changes_When_Casefolded=f}', "");
    Expect(1, 125218, '\P{^Is_Changes_When_Casefolded=f}', "");
    Expect(0, 125217, '\p{Is_Changes_When_Casefolded=f}', "");
    Expect(1, 125217, '\p{^Is_Changes_When_Casefolded=f}', "");
    Expect(1, 125217, '\P{Is_Changes_When_Casefolded=f}', "");
    Expect(0, 125217, '\P{^Is_Changes_When_Casefolded=f}', "");
    Expect(1, 125218, '\p{Is_Changes_When_Casefolded=	f}', "");
    Expect(0, 125218, '\p{^Is_Changes_When_Casefolded=	f}', "");
    Expect(0, 125218, '\P{Is_Changes_When_Casefolded=	f}', "");
    Expect(1, 125218, '\P{^Is_Changes_When_Casefolded=	f}', "");
    Expect(0, 125217, '\p{Is_Changes_When_Casefolded=	f}', "");
    Expect(1, 125217, '\p{^Is_Changes_When_Casefolded=	f}', "");
    Expect(1, 125217, '\P{Is_Changes_When_Casefolded=	f}', "");
    Expect(0, 125217, '\P{^Is_Changes_When_Casefolded=	f}', "");
    Error('\p{Is_CWCF=_-False:=}');
    Error('\P{Is_CWCF=_-False:=}');
    Expect(1, 125218, '\p{Is_CWCF=false}', "");
    Expect(0, 125218, '\p{^Is_CWCF=false}', "");
    Expect(0, 125218, '\P{Is_CWCF=false}', "");
    Expect(1, 125218, '\P{^Is_CWCF=false}', "");
    Expect(0, 125217, '\p{Is_CWCF=false}', "");
    Expect(1, 125217, '\p{^Is_CWCF=false}', "");
    Expect(1, 125217, '\P{Is_CWCF=false}', "");
    Expect(0, 125217, '\P{^Is_CWCF=false}', "");
    Expect(1, 125218, '\p{Is_CWCF:_ False}', "");
    Expect(0, 125218, '\p{^Is_CWCF:_ False}', "");
    Expect(0, 125218, '\P{Is_CWCF:_ False}', "");
    Expect(1, 125218, '\P{^Is_CWCF:_ False}', "");
    Expect(0, 125217, '\p{Is_CWCF:_ False}', "");
    Expect(1, 125217, '\p{^Is_CWCF:_ False}', "");
    Expect(1, 125217, '\P{Is_CWCF:_ False}', "");
    Expect(0, 125217, '\P{^Is_CWCF:_ False}', "");
    Error('\p{Changes_When_Casefolded=-/a/Yes}');
    Error('\P{Changes_When_Casefolded=-/a/Yes}');
    Expect(1, 125217, '\p{Changes_When_Casefolded=:\AYes\z:}', "");;
    Expect(0, 125218, '\p{Changes_When_Casefolded=:\AYes\z:}', "");;
    Expect(1, 125217, '\p{Changes_When_Casefolded=yes}', "");
    Expect(0, 125217, '\p{^Changes_When_Casefolded=yes}', "");
    Expect(0, 125217, '\P{Changes_When_Casefolded=yes}', "");
    Expect(1, 125217, '\P{^Changes_When_Casefolded=yes}', "");
    Expect(0, 125218, '\p{Changes_When_Casefolded=yes}', "");
    Expect(1, 125218, '\p{^Changes_When_Casefolded=yes}', "");
    Expect(1, 125218, '\P{Changes_When_Casefolded=yes}', "");
    Expect(0, 125218, '\P{^Changes_When_Casefolded=yes}', "");
    Expect(1, 125217, '\p{Changes_When_Casefolded=:\Ayes\z:}', "");;
    Expect(0, 125218, '\p{Changes_When_Casefolded=:\Ayes\z:}', "");;
    Expect(1, 125217, '\p{Changes_When_Casefolded= -Yes}', "");
    Expect(0, 125217, '\p{^Changes_When_Casefolded= -Yes}', "");
    Expect(0, 125217, '\P{Changes_When_Casefolded= -Yes}', "");
    Expect(1, 125217, '\P{^Changes_When_Casefolded= -Yes}', "");
    Expect(0, 125218, '\p{Changes_When_Casefolded= -Yes}', "");
    Expect(1, 125218, '\p{^Changes_When_Casefolded= -Yes}', "");
    Expect(1, 125218, '\P{Changes_When_Casefolded= -Yes}', "");
    Expect(0, 125218, '\P{^Changes_When_Casefolded= -Yes}', "");
    Error('\p{CWCF=- Y/a/}');
    Error('\P{CWCF=- Y/a/}');
    Expect(1, 125217, '\p{CWCF=:\AY\z:}', "");;
    Expect(0, 125218, '\p{CWCF=:\AY\z:}', "");;
    Expect(1, 125217, '\p{CWCF=y}', "");
    Expect(0, 125217, '\p{^CWCF=y}', "");
    Expect(0, 125217, '\P{CWCF=y}', "");
    Expect(1, 125217, '\P{^CWCF=y}', "");
    Expect(0, 125218, '\p{CWCF=y}', "");
    Expect(1, 125218, '\p{^CWCF=y}', "");
    Expect(1, 125218, '\P{CWCF=y}', "");
    Expect(0, 125218, '\P{^CWCF=y}', "");
    Expect(1, 125217, '\p{CWCF=:\Ay\z:}', "");;
    Expect(0, 125218, '\p{CWCF=:\Ay\z:}', "");;
    Expect(1, 125217, '\p{CWCF:   Y}', "");
    Expect(0, 125217, '\p{^CWCF:   Y}', "");
    Expect(0, 125217, '\P{CWCF:   Y}', "");
    Expect(1, 125217, '\P{^CWCF:   Y}', "");
    Expect(0, 125218, '\p{CWCF:   Y}', "");
    Expect(1, 125218, '\p{^CWCF:   Y}', "");
    Expect(1, 125218, '\P{CWCF:   Y}', "");
    Expect(0, 125218, '\P{^CWCF:   Y}', "");
    Error('\p{Is_Changes_When_Casefolded=--T/a/}');
    Error('\P{Is_Changes_When_Casefolded=--T/a/}');
    Expect(1, 125217, '\p{Is_Changes_When_Casefolded=t}', "");
    Expect(0, 125217, '\p{^Is_Changes_When_Casefolded=t}', "");
    Expect(0, 125217, '\P{Is_Changes_When_Casefolded=t}', "");
    Expect(1, 125217, '\P{^Is_Changes_When_Casefolded=t}', "");
    Expect(0, 125218, '\p{Is_Changes_When_Casefolded=t}', "");
    Expect(1, 125218, '\p{^Is_Changes_When_Casefolded=t}', "");
    Expect(1, 125218, '\P{Is_Changes_When_Casefolded=t}', "");
    Expect(0, 125218, '\P{^Is_Changes_When_Casefolded=t}', "");
    Expect(1, 125217, '\p{Is_Changes_When_Casefolded=- T}', "");
    Expect(0, 125217, '\p{^Is_Changes_When_Casefolded=- T}', "");
    Expect(0, 125217, '\P{Is_Changes_When_Casefolded=- T}', "");
    Expect(1, 125217, '\P{^Is_Changes_When_Casefolded=- T}', "");
    Expect(0, 125218, '\p{Is_Changes_When_Casefolded=- T}', "");
    Expect(1, 125218, '\p{^Is_Changes_When_Casefolded=- T}', "");
    Expect(1, 125218, '\P{Is_Changes_When_Casefolded=- T}', "");
    Expect(0, 125218, '\P{^Is_Changes_When_Casefolded=- T}', "");
    Error('\p{Is_CWCF=		true/a/}');
    Error('\P{Is_CWCF=		true/a/}');
    Expect(1, 125217, '\p{Is_CWCF=true}', "");
    Expect(0, 125217, '\p{^Is_CWCF=true}', "");
    Expect(0, 125217, '\P{Is_CWCF=true}', "");
    Expect(1, 125217, '\P{^Is_CWCF=true}', "");
    Expect(0, 125218, '\p{Is_CWCF=true}', "");
    Expect(1, 125218, '\p{^Is_CWCF=true}', "");
    Expect(1, 125218, '\P{Is_CWCF=true}', "");
    Expect(0, 125218, '\P{^Is_CWCF=true}', "");
    Expect(1, 125217, '\p{Is_CWCF:	-	true}', "");
    Expect(0, 125217, '\p{^Is_CWCF:	-	true}', "");
    Expect(0, 125217, '\P{Is_CWCF:	-	true}', "");
    Expect(1, 125217, '\P{^Is_CWCF:	-	true}', "");
    Expect(0, 125218, '\p{Is_CWCF:	-	true}', "");
    Expect(1, 125218, '\p{^Is_CWCF:	-	true}', "");
    Expect(1, 125218, '\P{Is_CWCF:	-	true}', "");
    Expect(0, 125218, '\P{^Is_CWCF:	-	true}', "");
    Error('\p{Changes_When_Casemapped= /a/no}');
    Error('\P{Changes_When_Casemapped= /a/no}');
    Expect(1, 125252, '\p{Changes_When_Casemapped=:\ANo\z:}', "");;
    Expect(0, 125251, '\p{Changes_When_Casemapped=:\ANo\z:}', "");;
    Expect(1, 125252, '\p{Changes_When_Casemapped=no}', "");
    Expect(0, 125252, '\p{^Changes_When_Casemapped=no}', "");
    Expect(0, 125252, '\P{Changes_When_Casemapped=no}', "");
    Expect(1, 125252, '\P{^Changes_When_Casemapped=no}', "");
    Expect(0, 125251, '\p{Changes_When_Casemapped=no}', "");
    Expect(1, 125251, '\p{^Changes_When_Casemapped=no}', "");
    Expect(1, 125251, '\P{Changes_When_Casemapped=no}', "");
    Expect(0, 125251, '\P{^Changes_When_Casemapped=no}', "");
    Expect(1, 125252, '\p{Changes_When_Casemapped=:\Ano\z:}', "");;
    Expect(0, 125251, '\p{Changes_When_Casemapped=:\Ano\z:}', "");;
    Expect(1, 125252, '\p{Changes_When_Casemapped=	-No}', "");
    Expect(0, 125252, '\p{^Changes_When_Casemapped=	-No}', "");
    Expect(0, 125252, '\P{Changes_When_Casemapped=	-No}', "");
    Expect(1, 125252, '\P{^Changes_When_Casemapped=	-No}', "");
    Expect(0, 125251, '\p{Changes_When_Casemapped=	-No}', "");
    Expect(1, 125251, '\p{^Changes_When_Casemapped=	-No}', "");
    Expect(1, 125251, '\P{Changes_When_Casemapped=	-No}', "");
    Expect(0, 125251, '\P{^Changes_When_Casemapped=	-No}', "");
    Error('\p{CWCM=:=  N}');
    Error('\P{CWCM=:=  N}');
    Expect(1, 125252, '\p{CWCM=:\AN\z:}', "");;
    Expect(0, 125251, '\p{CWCM=:\AN\z:}', "");;
    Expect(1, 125252, '\p{CWCM=n}', "");
    Expect(0, 125252, '\p{^CWCM=n}', "");
    Expect(0, 125252, '\P{CWCM=n}', "");
    Expect(1, 125252, '\P{^CWCM=n}', "");
    Expect(0, 125251, '\p{CWCM=n}', "");
    Expect(1, 125251, '\p{^CWCM=n}', "");
    Expect(1, 125251, '\P{CWCM=n}', "");
    Expect(0, 125251, '\P{^CWCM=n}', "");
    Expect(1, 125252, '\p{CWCM=:\An\z:}', "");;
    Expect(0, 125251, '\p{CWCM=:\An\z:}', "");;
    Expect(1, 125252, '\p{CWCM=_-N}', "");
    Expect(0, 125252, '\p{^CWCM=_-N}', "");
    Expect(0, 125252, '\P{CWCM=_-N}', "");
    Expect(1, 125252, '\P{^CWCM=_-N}', "");
    Expect(0, 125251, '\p{CWCM=_-N}', "");
    Expect(1, 125251, '\p{^CWCM=_-N}', "");
    Expect(1, 125251, '\P{CWCM=_-N}', "");
    Expect(0, 125251, '\P{^CWCM=_-N}', "");
    Error('\p{Is_Changes_When_Casemapped=-_f:=}');
    Error('\P{Is_Changes_When_Casemapped=-_f:=}');
    Expect(1, 125252, '\p{Is_Changes_When_Casemapped:	f}', "");
    Expect(0, 125252, '\p{^Is_Changes_When_Casemapped:	f}', "");
    Expect(0, 125252, '\P{Is_Changes_When_Casemapped:	f}', "");
    Expect(1, 125252, '\P{^Is_Changes_When_Casemapped:	f}', "");
    Expect(0, 125251, '\p{Is_Changes_When_Casemapped:	f}', "");
    Expect(1, 125251, '\p{^Is_Changes_When_Casemapped:	f}', "");
    Expect(1, 125251, '\P{Is_Changes_When_Casemapped:	f}', "");
    Expect(0, 125251, '\P{^Is_Changes_When_Casemapped:	f}', "");
    Expect(1, 125252, '\p{Is_Changes_When_Casemapped=	 F}', "");
    Expect(0, 125252, '\p{^Is_Changes_When_Casemapped=	 F}', "");
    Expect(0, 125252, '\P{Is_Changes_When_Casemapped=	 F}', "");
    Expect(1, 125252, '\P{^Is_Changes_When_Casemapped=	 F}', "");
    Expect(0, 125251, '\p{Is_Changes_When_Casemapped=	 F}', "");
    Expect(1, 125251, '\p{^Is_Changes_When_Casemapped=	 F}', "");
    Expect(1, 125251, '\P{Is_Changes_When_Casemapped=	 F}', "");
    Expect(0, 125251, '\P{^Is_Changes_When_Casemapped=	 F}', "");
    Error('\p{Is_CWCM:--false/a/}');
    Error('\P{Is_CWCM:--false/a/}');
    Expect(1, 125252, '\p{Is_CWCM=false}', "");
    Expect(0, 125252, '\p{^Is_CWCM=false}', "");
    Expect(0, 125252, '\P{Is_CWCM=false}', "");
    Expect(1, 125252, '\P{^Is_CWCM=false}', "");
    Expect(0, 125251, '\p{Is_CWCM=false}', "");
    Expect(1, 125251, '\p{^Is_CWCM=false}', "");
    Expect(1, 125251, '\P{Is_CWCM=false}', "");
    Expect(0, 125251, '\P{^Is_CWCM=false}', "");
    Expect(1, 125252, '\p{Is_CWCM=	 False}', "");
    Expect(0, 125252, '\p{^Is_CWCM=	 False}', "");
    Expect(0, 125252, '\P{Is_CWCM=	 False}', "");
    Expect(1, 125252, '\P{^Is_CWCM=	 False}', "");
    Expect(0, 125251, '\p{Is_CWCM=	 False}', "");
    Expect(1, 125251, '\p{^Is_CWCM=	 False}', "");
    Expect(1, 125251, '\P{Is_CWCM=	 False}', "");
    Expect(0, 125251, '\P{^Is_CWCM=	 False}', "");
    Error('\p{Changes_When_Casemapped=_Yes/a/}');
    Error('\P{Changes_When_Casemapped=_Yes/a/}');
    Expect(1, 125251, '\p{Changes_When_Casemapped=:\AYes\z:}', "");;
    Expect(0, 125252, '\p{Changes_When_Casemapped=:\AYes\z:}', "");;
    Expect(1, 125251, '\p{Changes_When_Casemapped=yes}', "");
    Expect(0, 125251, '\p{^Changes_When_Casemapped=yes}', "");
    Expect(0, 125251, '\P{Changes_When_Casemapped=yes}', "");
    Expect(1, 125251, '\P{^Changes_When_Casemapped=yes}', "");
    Expect(0, 125252, '\p{Changes_When_Casemapped=yes}', "");
    Expect(1, 125252, '\p{^Changes_When_Casemapped=yes}', "");
    Expect(1, 125252, '\P{Changes_When_Casemapped=yes}', "");
    Expect(0, 125252, '\P{^Changes_When_Casemapped=yes}', "");
    Expect(1, 125251, '\p{Changes_When_Casemapped=:\Ayes\z:}', "");;
    Expect(0, 125252, '\p{Changes_When_Casemapped=:\Ayes\z:}', "");;
    Expect(1, 125251, '\p{Changes_When_Casemapped=	 Yes}', "");
    Expect(0, 125251, '\p{^Changes_When_Casemapped=	 Yes}', "");
    Expect(0, 125251, '\P{Changes_When_Casemapped=	 Yes}', "");
    Expect(1, 125251, '\P{^Changes_When_Casemapped=	 Yes}', "");
    Expect(0, 125252, '\p{Changes_When_Casemapped=	 Yes}', "");
    Expect(1, 125252, '\p{^Changes_When_Casemapped=	 Yes}', "");
    Expect(1, 125252, '\P{Changes_When_Casemapped=	 Yes}', "");
    Expect(0, 125252, '\P{^Changes_When_Casemapped=	 Yes}', "");
    Error('\p{CWCM= :=Y}');
    Error('\P{CWCM= :=Y}');
    Expect(1, 125251, '\p{CWCM=:\AY\z:}', "");;
    Expect(0, 125252, '\p{CWCM=:\AY\z:}', "");;
    Expect(1, 125251, '\p{CWCM=y}', "");
    Expect(0, 125251, '\p{^CWCM=y}', "");
    Expect(0, 125251, '\P{CWCM=y}', "");
    Expect(1, 125251, '\P{^CWCM=y}', "");
    Expect(0, 125252, '\p{CWCM=y}', "");
    Expect(1, 125252, '\p{^CWCM=y}', "");
    Expect(1, 125252, '\P{CWCM=y}', "");
    Expect(0, 125252, '\P{^CWCM=y}', "");
    Expect(1, 125251, '\p{CWCM=:\Ay\z:}', "");;
    Expect(0, 125252, '\p{CWCM=:\Ay\z:}', "");;
    Expect(1, 125251, '\p{CWCM=-	Y}', "");
    Expect(0, 125251, '\p{^CWCM=-	Y}', "");
    Expect(0, 125251, '\P{CWCM=-	Y}', "");
    Expect(1, 125251, '\P{^CWCM=-	Y}', "");
    Expect(0, 125252, '\p{CWCM=-	Y}', "");
    Expect(1, 125252, '\p{^CWCM=-	Y}', "");
    Expect(1, 125252, '\P{CWCM=-	Y}', "");
    Expect(0, 125252, '\P{^CWCM=-	Y}', "");
    Error('\p{Is_Changes_When_Casemapped=:=		T}');
    Error('\P{Is_Changes_When_Casemapped=:=		T}');
    Expect(1, 125251, '\p{Is_Changes_When_Casemapped:t}', "");
    Expect(0, 125251, '\p{^Is_Changes_When_Casemapped:t}', "");
    Expect(0, 125251, '\P{Is_Changes_When_Casemapped:t}', "");
    Expect(1, 125251, '\P{^Is_Changes_When_Casemapped:t}', "");
    Expect(0, 125252, '\p{Is_Changes_When_Casemapped:t}', "");
    Expect(1, 125252, '\p{^Is_Changes_When_Casemapped:t}', "");
    Expect(1, 125252, '\P{Is_Changes_When_Casemapped:t}', "");
    Expect(0, 125252, '\P{^Is_Changes_When_Casemapped:t}', "");
    Expect(1, 125251, '\p{Is_Changes_When_Casemapped=	 T}', "");
    Expect(0, 125251, '\p{^Is_Changes_When_Casemapped=	 T}', "");
    Expect(0, 125251, '\P{Is_Changes_When_Casemapped=	 T}', "");
    Expect(1, 125251, '\P{^Is_Changes_When_Casemapped=	 T}', "");
    Expect(0, 125252, '\p{Is_Changes_When_Casemapped=	 T}', "");
    Expect(1, 125252, '\p{^Is_Changes_When_Casemapped=	 T}', "");
    Expect(1, 125252, '\P{Is_Changes_When_Casemapped=	 T}', "");
    Expect(0, 125252, '\P{^Is_Changes_When_Casemapped=	 T}', "");
    Error('\p{Is_CWCM=	-True/a/}');
    Error('\P{Is_CWCM=	-True/a/}');
    Expect(1, 125251, '\p{Is_CWCM=true}', "");
    Expect(0, 125251, '\p{^Is_CWCM=true}', "");
    Expect(0, 125251, '\P{Is_CWCM=true}', "");
    Expect(1, 125251, '\P{^Is_CWCM=true}', "");
    Expect(0, 125252, '\p{Is_CWCM=true}', "");
    Expect(1, 125252, '\p{^Is_CWCM=true}', "");
    Expect(1, 125252, '\P{Is_CWCM=true}', "");
    Expect(0, 125252, '\P{^Is_CWCM=true}', "");
    Expect(1, 125251, '\p{Is_CWCM=-true}', "");
    Expect(0, 125251, '\p{^Is_CWCM=-true}', "");
    Expect(0, 125251, '\P{Is_CWCM=-true}', "");
    Expect(1, 125251, '\P{^Is_CWCM=-true}', "");
    Expect(0, 125252, '\p{Is_CWCM=-true}', "");
    Expect(1, 125252, '\p{^Is_CWCM=-true}', "");
    Expect(1, 125252, '\P{Is_CWCM=-true}', "");
    Expect(0, 125252, '\P{^Is_CWCM=-true}', "");
    Error('\p{Changes_When_NFKC_Casefolded=	NO:=}');
    Error('\P{Changes_When_NFKC_Casefolded=	NO:=}');
    Expect(1, 921600, '\p{Changes_When_NFKC_Casefolded=:\ANo\z:}', "");;
    Expect(0, 921599, '\p{Changes_When_NFKC_Casefolded=:\ANo\z:}', "");;
    Expect(1, 921600, '\p{Changes_When_NFKC_Casefolded=no}', "");
    Expect(0, 921600, '\p{^Changes_When_NFKC_Casefolded=no}', "");
    Expect(0, 921600, '\P{Changes_When_NFKC_Casefolded=no}', "");
    Expect(1, 921600, '\P{^Changes_When_NFKC_Casefolded=no}', "");
    Expect(0, 921599, '\p{Changes_When_NFKC_Casefolded=no}', "");
    Expect(1, 921599, '\p{^Changes_When_NFKC_Casefolded=no}', "");
    Expect(1, 921599, '\P{Changes_When_NFKC_Casefolded=no}', "");
    Expect(0, 921599, '\P{^Changes_When_NFKC_Casefolded=no}', "");
    Expect(1, 921600, '\p{Changes_When_NFKC_Casefolded=:\Ano\z:}', "");;
    Expect(0, 921599, '\p{Changes_When_NFKC_Casefolded=:\Ano\z:}', "");;
    Expect(1, 921600, '\p{Changes_When_NFKC_Casefolded:  No}', "");
    Expect(0, 921600, '\p{^Changes_When_NFKC_Casefolded:  No}', "");
    Expect(0, 921600, '\P{Changes_When_NFKC_Casefolded:  No}', "");
    Expect(1, 921600, '\P{^Changes_When_NFKC_Casefolded:  No}', "");
    Expect(0, 921599, '\p{Changes_When_NFKC_Casefolded:  No}', "");
    Expect(1, 921599, '\p{^Changes_When_NFKC_Casefolded:  No}', "");
    Expect(1, 921599, '\P{Changes_When_NFKC_Casefolded:  No}', "");
    Expect(0, 921599, '\P{^Changes_When_NFKC_Casefolded:  No}', "");
    Error('\p{CWKCF=/a/  N}');
    Error('\P{CWKCF=/a/  N}');
    Expect(1, 921600, '\p{CWKCF=:\AN\z:}', "");;
    Expect(0, 921599, '\p{CWKCF=:\AN\z:}', "");;
    Expect(1, 921600, '\p{CWKCF:   n}', "");
    Expect(0, 921600, '\p{^CWKCF:   n}', "");
    Expect(0, 921600, '\P{CWKCF:   n}', "");
    Expect(1, 921600, '\P{^CWKCF:   n}', "");
    Expect(0, 921599, '\p{CWKCF:   n}', "");
    Expect(1, 921599, '\p{^CWKCF:   n}', "");
    Expect(1, 921599, '\P{CWKCF:   n}', "");
    Expect(0, 921599, '\P{^CWKCF:   n}', "");
    Expect(1, 921600, '\p{CWKCF=:\An\z:}', "");;
    Expect(0, 921599, '\p{CWKCF=:\An\z:}', "");;
    Expect(1, 921600, '\p{CWKCF=_ n}', "");
    Expect(0, 921600, '\p{^CWKCF=_ n}', "");
    Expect(0, 921600, '\P{CWKCF=_ n}', "");
    Expect(1, 921600, '\P{^CWKCF=_ n}', "");
    Expect(0, 921599, '\p{CWKCF=_ n}', "");
    Expect(1, 921599, '\p{^CWKCF=_ n}', "");
    Expect(1, 921599, '\P{CWKCF=_ n}', "");
    Expect(0, 921599, '\P{^CWKCF=_ n}', "");
    Error('\p{Is_Changes_When_NFKC_Casefolded=:=__F}');
    Error('\P{Is_Changes_When_NFKC_Casefolded=:=__F}');
    Expect(1, 921600, '\p{Is_Changes_When_NFKC_Casefolded=f}', "");
    Expect(0, 921600, '\p{^Is_Changes_When_NFKC_Casefolded=f}', "");
    Expect(0, 921600, '\P{Is_Changes_When_NFKC_Casefolded=f}', "");
    Expect(1, 921600, '\P{^Is_Changes_When_NFKC_Casefolded=f}', "");
    Expect(0, 921599, '\p{Is_Changes_When_NFKC_Casefolded=f}', "");
    Expect(1, 921599, '\p{^Is_Changes_When_NFKC_Casefolded=f}', "");
    Expect(1, 921599, '\P{Is_Changes_When_NFKC_Casefolded=f}', "");
    Expect(0, 921599, '\P{^Is_Changes_When_NFKC_Casefolded=f}', "");
    Expect(1, 921600, '\p{Is_Changes_When_NFKC_Casefolded=  f}', "");
    Expect(0, 921600, '\p{^Is_Changes_When_NFKC_Casefolded=  f}', "");
    Expect(0, 921600, '\P{Is_Changes_When_NFKC_Casefolded=  f}', "");
    Expect(1, 921600, '\P{^Is_Changes_When_NFKC_Casefolded=  f}', "");
    Expect(0, 921599, '\p{Is_Changes_When_NFKC_Casefolded=  f}', "");
    Expect(1, 921599, '\p{^Is_Changes_When_NFKC_Casefolded=  f}', "");
    Expect(1, 921599, '\P{Is_Changes_When_NFKC_Casefolded=  f}', "");
    Expect(0, 921599, '\P{^Is_Changes_When_NFKC_Casefolded=  f}', "");
    Error('\p{Is_CWKCF=/a/_-False}');
    Error('\P{Is_CWKCF=/a/_-False}');
    Expect(1, 921600, '\p{Is_CWKCF=false}', "");
    Expect(0, 921600, '\p{^Is_CWKCF=false}', "");
    Expect(0, 921600, '\P{Is_CWKCF=false}', "");
    Expect(1, 921600, '\P{^Is_CWKCF=false}', "");
    Expect(0, 921599, '\p{Is_CWKCF=false}', "");
    Expect(1, 921599, '\p{^Is_CWKCF=false}', "");
    Expect(1, 921599, '\P{Is_CWKCF=false}', "");
    Expect(0, 921599, '\P{^Is_CWKCF=false}', "");
    Expect(1, 921600, '\p{Is_CWKCF=  False}', "");
    Expect(0, 921600, '\p{^Is_CWKCF=  False}', "");
    Expect(0, 921600, '\P{Is_CWKCF=  False}', "");
    Expect(1, 921600, '\P{^Is_CWKCF=  False}', "");
    Expect(0, 921599, '\p{Is_CWKCF=  False}', "");
    Expect(1, 921599, '\p{^Is_CWKCF=  False}', "");
    Expect(1, 921599, '\P{Is_CWKCF=  False}', "");
    Expect(0, 921599, '\P{^Is_CWKCF=  False}', "");
    Error('\p{Changes_When_NFKC_Casefolded=:=_	yes}');
    Error('\P{Changes_When_NFKC_Casefolded=:=_	yes}');
    Expect(1, 921599, '\p{Changes_When_NFKC_Casefolded=:\AYes\z:}', "");;
    Expect(0, 921600, '\p{Changes_When_NFKC_Casefolded=:\AYes\z:}', "");;
    Expect(1, 921599, '\p{Changes_When_NFKC_Casefolded=yes}', "");
    Expect(0, 921599, '\p{^Changes_When_NFKC_Casefolded=yes}', "");
    Expect(0, 921599, '\P{Changes_When_NFKC_Casefolded=yes}', "");
    Expect(1, 921599, '\P{^Changes_When_NFKC_Casefolded=yes}', "");
    Expect(0, 921600, '\p{Changes_When_NFKC_Casefolded=yes}', "");
    Expect(1, 921600, '\p{^Changes_When_NFKC_Casefolded=yes}', "");
    Expect(1, 921600, '\P{Changes_When_NFKC_Casefolded=yes}', "");
    Expect(0, 921600, '\P{^Changes_When_NFKC_Casefolded=yes}', "");
    Expect(1, 921599, '\p{Changes_When_NFKC_Casefolded=:\Ayes\z:}', "");;
    Expect(0, 921600, '\p{Changes_When_NFKC_Casefolded=:\Ayes\z:}', "");;
    Expect(1, 921599, '\p{Changes_When_NFKC_Casefolded=_-YES}', "");
    Expect(0, 921599, '\p{^Changes_When_NFKC_Casefolded=_-YES}', "");
    Expect(0, 921599, '\P{Changes_When_NFKC_Casefolded=_-YES}', "");
    Expect(1, 921599, '\P{^Changes_When_NFKC_Casefolded=_-YES}', "");
    Expect(0, 921600, '\p{Changes_When_NFKC_Casefolded=_-YES}', "");
    Expect(1, 921600, '\p{^Changes_When_NFKC_Casefolded=_-YES}', "");
    Expect(1, 921600, '\P{Changes_When_NFKC_Casefolded=_-YES}', "");
    Expect(0, 921600, '\P{^Changes_When_NFKC_Casefolded=_-YES}', "");
    Error('\p{CWKCF=:=--Y}');
    Error('\P{CWKCF=:=--Y}');
    Expect(1, 921599, '\p{CWKCF=:\AY\z:}', "");;
    Expect(0, 921600, '\p{CWKCF=:\AY\z:}', "");;
    Expect(1, 921599, '\p{CWKCF=y}', "");
    Expect(0, 921599, '\p{^CWKCF=y}', "");
    Expect(0, 921599, '\P{CWKCF=y}', "");
    Expect(1, 921599, '\P{^CWKCF=y}', "");
    Expect(0, 921600, '\p{CWKCF=y}', "");
    Expect(1, 921600, '\p{^CWKCF=y}', "");
    Expect(1, 921600, '\P{CWKCF=y}', "");
    Expect(0, 921600, '\P{^CWKCF=y}', "");
    Expect(1, 921599, '\p{CWKCF=:\Ay\z:}', "");;
    Expect(0, 921600, '\p{CWKCF=:\Ay\z:}', "");;
    Expect(1, 921599, '\p{CWKCF=	Y}', "");
    Expect(0, 921599, '\p{^CWKCF=	Y}', "");
    Expect(0, 921599, '\P{CWKCF=	Y}', "");
    Expect(1, 921599, '\P{^CWKCF=	Y}', "");
    Expect(0, 921600, '\p{CWKCF=	Y}', "");
    Expect(1, 921600, '\p{^CWKCF=	Y}', "");
    Expect(1, 921600, '\P{CWKCF=	Y}', "");
    Expect(0, 921600, '\P{^CWKCF=	Y}', "");
    Error('\p{Is_Changes_When_NFKC_Casefolded:   :=	_T}');
    Error('\P{Is_Changes_When_NFKC_Casefolded:   :=	_T}');
    Expect(1, 921599, '\p{Is_Changes_When_NFKC_Casefolded=t}', "");
    Expect(0, 921599, '\p{^Is_Changes_When_NFKC_Casefolded=t}', "");
    Expect(0, 921599, '\P{Is_Changes_When_NFKC_Casefolded=t}', "");
    Expect(1, 921599, '\P{^Is_Changes_When_NFKC_Casefolded=t}', "");
    Expect(0, 921600, '\p{Is_Changes_When_NFKC_Casefolded=t}', "");
    Expect(1, 921600, '\p{^Is_Changes_When_NFKC_Casefolded=t}', "");
    Expect(1, 921600, '\P{Is_Changes_When_NFKC_Casefolded=t}', "");
    Expect(0, 921600, '\P{^Is_Changes_When_NFKC_Casefolded=t}', "");
    Expect(1, 921599, '\p{Is_Changes_When_NFKC_Casefolded= 	T}', "");
    Expect(0, 921599, '\p{^Is_Changes_When_NFKC_Casefolded= 	T}', "");
    Expect(0, 921599, '\P{Is_Changes_When_NFKC_Casefolded= 	T}', "");
    Expect(1, 921599, '\P{^Is_Changes_When_NFKC_Casefolded= 	T}', "");
    Expect(0, 921600, '\p{Is_Changes_When_NFKC_Casefolded= 	T}', "");
    Expect(1, 921600, '\p{^Is_Changes_When_NFKC_Casefolded= 	T}', "");
    Expect(1, 921600, '\P{Is_Changes_When_NFKC_Casefolded= 	T}', "");
    Expect(0, 921600, '\P{^Is_Changes_When_NFKC_Casefolded= 	T}', "");
    Error('\p{Is_CWKCF= :=TRUE}');
    Error('\P{Is_CWKCF= :=TRUE}');
    Expect(1, 921599, '\p{Is_CWKCF=true}', "");
    Expect(0, 921599, '\p{^Is_CWKCF=true}', "");
    Expect(0, 921599, '\P{Is_CWKCF=true}', "");
    Expect(1, 921599, '\P{^Is_CWKCF=true}', "");
    Expect(0, 921600, '\p{Is_CWKCF=true}', "");
    Expect(1, 921600, '\p{^Is_CWKCF=true}', "");
    Expect(1, 921600, '\P{Is_CWKCF=true}', "");
    Expect(0, 921600, '\P{^Is_CWKCF=true}', "");
    Expect(1, 921599, '\p{Is_CWKCF=	True}', "");
    Expect(0, 921599, '\p{^Is_CWKCF=	True}', "");
    Expect(0, 921599, '\P{Is_CWKCF=	True}', "");
    Expect(1, 921599, '\P{^Is_CWKCF=	True}', "");
    Expect(0, 921600, '\p{Is_CWKCF=	True}', "");
    Expect(1, 921600, '\p{^Is_CWKCF=	True}', "");
    Expect(1, 921600, '\P{Is_CWKCF=	True}', "");
    Expect(0, 921600, '\P{^Is_CWKCF=	True}', "");
    Error('\p{Changes_When_Lowercased: :=		NO}');
    Error('\P{Changes_When_Lowercased: :=		NO}');
    Expect(1, 125218, '\p{Changes_When_Lowercased=:\ANo\z:}', "");;
    Expect(0, 125217, '\p{Changes_When_Lowercased=:\ANo\z:}', "");;
    Expect(1, 125218, '\p{Changes_When_Lowercased=no}', "");
    Expect(0, 125218, '\p{^Changes_When_Lowercased=no}', "");
    Expect(0, 125218, '\P{Changes_When_Lowercased=no}', "");
    Expect(1, 125218, '\P{^Changes_When_Lowercased=no}', "");
    Expect(0, 125217, '\p{Changes_When_Lowercased=no}', "");
    Expect(1, 125217, '\p{^Changes_When_Lowercased=no}', "");
    Expect(1, 125217, '\P{Changes_When_Lowercased=no}', "");
    Expect(0, 125217, '\P{^Changes_When_Lowercased=no}', "");
    Expect(1, 125218, '\p{Changes_When_Lowercased=:\Ano\z:}', "");;
    Expect(0, 125217, '\p{Changes_When_Lowercased=:\Ano\z:}', "");;
    Expect(1, 125218, '\p{Changes_When_Lowercased: -No}', "");
    Expect(0, 125218, '\p{^Changes_When_Lowercased: -No}', "");
    Expect(0, 125218, '\P{Changes_When_Lowercased: -No}', "");
    Expect(1, 125218, '\P{^Changes_When_Lowercased: -No}', "");
    Expect(0, 125217, '\p{Changes_When_Lowercased: -No}', "");
    Expect(1, 125217, '\p{^Changes_When_Lowercased: -No}', "");
    Expect(1, 125217, '\P{Changes_When_Lowercased: -No}', "");
    Expect(0, 125217, '\P{^Changes_When_Lowercased: -No}', "");
    Error('\p{CWL= _N:=}');
    Error('\P{CWL= _N:=}');
    Expect(1, 125218, '\p{CWL=:\AN\z:}', "");;
    Expect(0, 125217, '\p{CWL=:\AN\z:}', "");;
    Expect(1, 125218, '\p{CWL=n}', "");
    Expect(0, 125218, '\p{^CWL=n}', "");
    Expect(0, 125218, '\P{CWL=n}', "");
    Expect(1, 125218, '\P{^CWL=n}', "");
    Expect(0, 125217, '\p{CWL=n}', "");
    Expect(1, 125217, '\p{^CWL=n}', "");
    Expect(1, 125217, '\P{CWL=n}', "");
    Expect(0, 125217, '\P{^CWL=n}', "");
    Expect(1, 125218, '\p{CWL=:\An\z:}', "");;
    Expect(0, 125217, '\p{CWL=:\An\z:}', "");;
    Expect(1, 125218, '\p{CWL= 	N}', "");
    Expect(0, 125218, '\p{^CWL= 	N}', "");
    Expect(0, 125218, '\P{CWL= 	N}', "");
    Expect(1, 125218, '\P{^CWL= 	N}', "");
    Expect(0, 125217, '\p{CWL= 	N}', "");
    Expect(1, 125217, '\p{^CWL= 	N}', "");
    Expect(1, 125217, '\P{CWL= 	N}', "");
    Expect(0, 125217, '\P{^CWL= 	N}', "");
    Error('\p{Is_Changes_When_Lowercased=/a/	F}');
    Error('\P{Is_Changes_When_Lowercased=/a/	F}');
    Expect(1, 125218, '\p{Is_Changes_When_Lowercased=f}', "");
    Expect(0, 125218, '\p{^Is_Changes_When_Lowercased=f}', "");
    Expect(0, 125218, '\P{Is_Changes_When_Lowercased=f}', "");
    Expect(1, 125218, '\P{^Is_Changes_When_Lowercased=f}', "");
    Expect(0, 125217, '\p{Is_Changes_When_Lowercased=f}', "");
    Expect(1, 125217, '\p{^Is_Changes_When_Lowercased=f}', "");
    Expect(1, 125217, '\P{Is_Changes_When_Lowercased=f}', "");
    Expect(0, 125217, '\P{^Is_Changes_When_Lowercased=f}', "");
    Error('\p{Is_CWL:     False:=}');
    Error('\P{Is_CWL:     False:=}');
    Expect(1, 125218, '\p{Is_CWL=false}', "");
    Expect(0, 125218, '\p{^Is_CWL=false}', "");
    Expect(0, 125218, '\P{Is_CWL=false}', "");
    Expect(1, 125218, '\P{^Is_CWL=false}', "");
    Expect(0, 125217, '\p{Is_CWL=false}', "");
    Expect(1, 125217, '\p{^Is_CWL=false}', "");
    Expect(1, 125217, '\P{Is_CWL=false}', "");
    Expect(0, 125217, '\P{^Is_CWL=false}', "");
    Expect(1, 125218, '\p{Is_CWL=_ False}', "");
    Expect(0, 125218, '\p{^Is_CWL=_ False}', "");
    Expect(0, 125218, '\P{Is_CWL=_ False}', "");
    Expect(1, 125218, '\P{^Is_CWL=_ False}', "");
    Expect(0, 125217, '\p{Is_CWL=_ False}', "");
    Expect(1, 125217, '\p{^Is_CWL=_ False}', "");
    Expect(1, 125217, '\P{Is_CWL=_ False}', "");
    Expect(0, 125217, '\P{^Is_CWL=_ False}', "");
    Error('\p{Changes_When_Lowercased= YES/a/}');
    Error('\P{Changes_When_Lowercased= YES/a/}');
    Expect(1, 125217, '\p{Changes_When_Lowercased=:\AYes\z:}', "");;
    Expect(0, 125218, '\p{Changes_When_Lowercased=:\AYes\z:}', "");;
    Expect(1, 125217, '\p{Changes_When_Lowercased=yes}', "");
    Expect(0, 125217, '\p{^Changes_When_Lowercased=yes}', "");
    Expect(0, 125217, '\P{Changes_When_Lowercased=yes}', "");
    Expect(1, 125217, '\P{^Changes_When_Lowercased=yes}', "");
    Expect(0, 125218, '\p{Changes_When_Lowercased=yes}', "");
    Expect(1, 125218, '\p{^Changes_When_Lowercased=yes}', "");
    Expect(1, 125218, '\P{Changes_When_Lowercased=yes}', "");
    Expect(0, 125218, '\P{^Changes_When_Lowercased=yes}', "");
    Expect(1, 125217, '\p{Changes_When_Lowercased=:\Ayes\z:}', "");;
    Expect(0, 125218, '\p{Changes_When_Lowercased=:\Ayes\z:}', "");;
    Expect(1, 125217, '\p{Changes_When_Lowercased=_ Yes}', "");
    Expect(0, 125217, '\p{^Changes_When_Lowercased=_ Yes}', "");
    Expect(0, 125217, '\P{Changes_When_Lowercased=_ Yes}', "");
    Expect(1, 125217, '\P{^Changes_When_Lowercased=_ Yes}', "");
    Expect(0, 125218, '\p{Changes_When_Lowercased=_ Yes}', "");
    Expect(1, 125218, '\p{^Changes_When_Lowercased=_ Yes}', "");
    Expect(1, 125218, '\P{Changes_When_Lowercased=_ Yes}', "");
    Expect(0, 125218, '\P{^Changes_When_Lowercased=_ Yes}', "");
    Error('\p{CWL=/a/-Y}');
    Error('\P{CWL=/a/-Y}');
    Expect(1, 125217, '\p{CWL=:\AY\z:}', "");;
    Expect(0, 125218, '\p{CWL=:\AY\z:}', "");;
    Expect(1, 125217, '\p{CWL=y}', "");
    Expect(0, 125217, '\p{^CWL=y}', "");
    Expect(0, 125217, '\P{CWL=y}', "");
    Expect(1, 125217, '\P{^CWL=y}', "");
    Expect(0, 125218, '\p{CWL=y}', "");
    Expect(1, 125218, '\p{^CWL=y}', "");
    Expect(1, 125218, '\P{CWL=y}', "");
    Expect(0, 125218, '\P{^CWL=y}', "");
    Expect(1, 125217, '\p{CWL=:\Ay\z:}', "");;
    Expect(0, 125218, '\p{CWL=:\Ay\z:}', "");;
    Expect(1, 125217, '\p{CWL=-	y}', "");
    Expect(0, 125217, '\p{^CWL=-	y}', "");
    Expect(0, 125217, '\P{CWL=-	y}', "");
    Expect(1, 125217, '\P{^CWL=-	y}', "");
    Expect(0, 125218, '\p{CWL=-	y}', "");
    Expect(1, 125218, '\p{^CWL=-	y}', "");
    Expect(1, 125218, '\P{CWL=-	y}', "");
    Expect(0, 125218, '\P{^CWL=-	y}', "");
    Error('\p{Is_Changes_When_Lowercased=_	T:=}');
    Error('\P{Is_Changes_When_Lowercased=_	T:=}');
    Expect(1, 125217, '\p{Is_Changes_When_Lowercased=t}', "");
    Expect(0, 125217, '\p{^Is_Changes_When_Lowercased=t}', "");
    Expect(0, 125217, '\P{Is_Changes_When_Lowercased=t}', "");
    Expect(1, 125217, '\P{^Is_Changes_When_Lowercased=t}', "");
    Expect(0, 125218, '\p{Is_Changes_When_Lowercased=t}', "");
    Expect(1, 125218, '\p{^Is_Changes_When_Lowercased=t}', "");
    Expect(1, 125218, '\P{Is_Changes_When_Lowercased=t}', "");
    Expect(0, 125218, '\P{^Is_Changes_When_Lowercased=t}', "");
    Expect(1, 125217, '\p{Is_Changes_When_Lowercased=_ t}', "");
    Expect(0, 125217, '\p{^Is_Changes_When_Lowercased=_ t}', "");
    Expect(0, 125217, '\P{Is_Changes_When_Lowercased=_ t}', "");
    Expect(1, 125217, '\P{^Is_Changes_When_Lowercased=_ t}', "");
    Expect(0, 125218, '\p{Is_Changes_When_Lowercased=_ t}', "");
    Expect(1, 125218, '\p{^Is_Changes_When_Lowercased=_ t}', "");
    Expect(1, 125218, '\P{Is_Changes_When_Lowercased=_ t}', "");
    Expect(0, 125218, '\P{^Is_Changes_When_Lowercased=_ t}', "");
    Error('\p{Is_CWL=:=_True}');
    Error('\P{Is_CWL=:=_True}');
    Expect(1, 125217, '\p{Is_CWL:true}', "");
    Expect(0, 125217, '\p{^Is_CWL:true}', "");
    Expect(0, 125217, '\P{Is_CWL:true}', "");
    Expect(1, 125217, '\P{^Is_CWL:true}', "");
    Expect(0, 125218, '\p{Is_CWL:true}', "");
    Expect(1, 125218, '\p{^Is_CWL:true}', "");
    Expect(1, 125218, '\P{Is_CWL:true}', "");
    Expect(0, 125218, '\P{^Is_CWL:true}', "");
    Expect(1, 125217, '\p{Is_CWL=		True}', "");
    Expect(0, 125217, '\p{^Is_CWL=		True}', "");
    Expect(0, 125217, '\P{Is_CWL=		True}', "");
    Expect(1, 125217, '\P{^Is_CWL=		True}', "");
    Expect(0, 125218, '\p{Is_CWL=		True}', "");
    Expect(1, 125218, '\p{^Is_CWL=		True}', "");
    Expect(1, 125218, '\P{Is_CWL=		True}', "");
    Expect(0, 125218, '\P{^Is_CWL=		True}', "");
    Error('\p{Changes_When_Titlecased=:=	_no}');
    Error('\P{Changes_When_Titlecased=:=	_no}');
    Expect(1, 125252, '\p{Changes_When_Titlecased=:\ANo\z:}', "");;
    Expect(0, 125251, '\p{Changes_When_Titlecased=:\ANo\z:}', "");;
    Expect(1, 125252, '\p{Changes_When_Titlecased:	no}', "");
    Expect(0, 125252, '\p{^Changes_When_Titlecased:	no}', "");
    Expect(0, 125252, '\P{Changes_When_Titlecased:	no}', "");
    Expect(1, 125252, '\P{^Changes_When_Titlecased:	no}', "");
    Expect(0, 125251, '\p{Changes_When_Titlecased:	no}', "");
    Expect(1, 125251, '\p{^Changes_When_Titlecased:	no}', "");
    Expect(1, 125251, '\P{Changes_When_Titlecased:	no}', "");
    Expect(0, 125251, '\P{^Changes_When_Titlecased:	no}', "");
    Expect(1, 125252, '\p{Changes_When_Titlecased=:\Ano\z:}', "");;
    Expect(0, 125251, '\p{Changes_When_Titlecased=:\Ano\z:}', "");;
    Expect(1, 125252, '\p{Changes_When_Titlecased=- No}', "");
    Expect(0, 125252, '\p{^Changes_When_Titlecased=- No}', "");
    Expect(0, 125252, '\P{Changes_When_Titlecased=- No}', "");
    Expect(1, 125252, '\P{^Changes_When_Titlecased=- No}', "");
    Expect(0, 125251, '\p{Changes_When_Titlecased=- No}', "");
    Expect(1, 125251, '\p{^Changes_When_Titlecased=- No}', "");
    Expect(1, 125251, '\P{Changes_When_Titlecased=- No}', "");
    Expect(0, 125251, '\P{^Changes_When_Titlecased=- No}', "");
    Error('\p{CWT=--N:=}');
    Error('\P{CWT=--N:=}');
    Expect(1, 125252, '\p{CWT=:\AN\z:}', "");;
    Expect(0, 125251, '\p{CWT=:\AN\z:}', "");;
    Expect(1, 125252, '\p{CWT:	n}', "");
    Expect(0, 125252, '\p{^CWT:	n}', "");
    Expect(0, 125252, '\P{CWT:	n}', "");
    Expect(1, 125252, '\P{^CWT:	n}', "");
    Expect(0, 125251, '\p{CWT:	n}', "");
    Expect(1, 125251, '\p{^CWT:	n}', "");
    Expect(1, 125251, '\P{CWT:	n}', "");
    Expect(0, 125251, '\P{^CWT:	n}', "");
    Expect(1, 125252, '\p{CWT=:\An\z:}', "");;
    Expect(0, 125251, '\p{CWT=:\An\z:}', "");;
    Expect(1, 125252, '\p{CWT=- N}', "");
    Expect(0, 125252, '\p{^CWT=- N}', "");
    Expect(0, 125252, '\P{CWT=- N}', "");
    Expect(1, 125252, '\P{^CWT=- N}', "");
    Expect(0, 125251, '\p{CWT=- N}', "");
    Expect(1, 125251, '\p{^CWT=- N}', "");
    Expect(1, 125251, '\P{CWT=- N}', "");
    Expect(0, 125251, '\P{^CWT=- N}', "");
    Error('\p{Is_Changes_When_Titlecased=	_F:=}');
    Error('\P{Is_Changes_When_Titlecased=	_F:=}');
    Expect(1, 125252, '\p{Is_Changes_When_Titlecased=f}', "");
    Expect(0, 125252, '\p{^Is_Changes_When_Titlecased=f}', "");
    Expect(0, 125252, '\P{Is_Changes_When_Titlecased=f}', "");
    Expect(1, 125252, '\P{^Is_Changes_When_Titlecased=f}', "");
    Expect(0, 125251, '\p{Is_Changes_When_Titlecased=f}', "");
    Expect(1, 125251, '\p{^Is_Changes_When_Titlecased=f}', "");
    Expect(1, 125251, '\P{Is_Changes_When_Titlecased=f}', "");
    Expect(0, 125251, '\P{^Is_Changes_When_Titlecased=f}', "");
    Expect(1, 125252, '\p{Is_Changes_When_Titlecased= _F}', "");
    Expect(0, 125252, '\p{^Is_Changes_When_Titlecased= _F}', "");
    Expect(0, 125252, '\P{Is_Changes_When_Titlecased= _F}', "");
    Expect(1, 125252, '\P{^Is_Changes_When_Titlecased= _F}', "");
    Expect(0, 125251, '\p{Is_Changes_When_Titlecased= _F}', "");
    Expect(1, 125251, '\p{^Is_Changes_When_Titlecased= _F}', "");
    Expect(1, 125251, '\P{Is_Changes_When_Titlecased= _F}', "");
    Expect(0, 125251, '\P{^Is_Changes_When_Titlecased= _F}', "");
    Error('\p{Is_CWT=:=	-FALSE}');
    Error('\P{Is_CWT=:=	-FALSE}');
    Expect(1, 125252, '\p{Is_CWT=false}', "");
    Expect(0, 125252, '\p{^Is_CWT=false}', "");
    Expect(0, 125252, '\P{Is_CWT=false}', "");
    Expect(1, 125252, '\P{^Is_CWT=false}', "");
    Expect(0, 125251, '\p{Is_CWT=false}', "");
    Expect(1, 125251, '\p{^Is_CWT=false}', "");
    Expect(1, 125251, '\P{Is_CWT=false}', "");
    Expect(0, 125251, '\P{^Is_CWT=false}', "");
    Expect(1, 125252, '\p{Is_CWT=_ FALSE}', "");
    Expect(0, 125252, '\p{^Is_CWT=_ FALSE}', "");
    Expect(0, 125252, '\P{Is_CWT=_ FALSE}', "");
    Expect(1, 125252, '\P{^Is_CWT=_ FALSE}', "");
    Expect(0, 125251, '\p{Is_CWT=_ FALSE}', "");
    Expect(1, 125251, '\p{^Is_CWT=_ FALSE}', "");
    Expect(1, 125251, '\P{Is_CWT=_ FALSE}', "");
    Expect(0, 125251, '\P{^Is_CWT=_ FALSE}', "");
    Error('\p{Changes_When_Titlecased=/a/Yes}');
    Error('\P{Changes_When_Titlecased=/a/Yes}');
    Expect(1, 125251, '\p{Changes_When_Titlecased=:\AYes\z:}', "");;
    Expect(0, 125252, '\p{Changes_When_Titlecased=:\AYes\z:}', "");;
    Expect(1, 125251, '\p{Changes_When_Titlecased=yes}', "");
    Expect(0, 125251, '\p{^Changes_When_Titlecased=yes}', "");
    Expect(0, 125251, '\P{Changes_When_Titlecased=yes}', "");
    Expect(1, 125251, '\P{^Changes_When_Titlecased=yes}', "");
    Expect(0, 125252, '\p{Changes_When_Titlecased=yes}', "");
    Expect(1, 125252, '\p{^Changes_When_Titlecased=yes}', "");
    Expect(1, 125252, '\P{Changes_When_Titlecased=yes}', "");
    Expect(0, 125252, '\P{^Changes_When_Titlecased=yes}', "");
    Expect(1, 125251, '\p{Changes_When_Titlecased=:\Ayes\z:}', "");;
    Expect(0, 125252, '\p{Changes_When_Titlecased=:\Ayes\z:}', "");;
    Expect(1, 125251, '\p{Changes_When_Titlecased=_YES}', "");
    Expect(0, 125251, '\p{^Changes_When_Titlecased=_YES}', "");
    Expect(0, 125251, '\P{Changes_When_Titlecased=_YES}', "");
    Expect(1, 125251, '\P{^Changes_When_Titlecased=_YES}', "");
    Expect(0, 125252, '\p{Changes_When_Titlecased=_YES}', "");
    Expect(1, 125252, '\p{^Changes_When_Titlecased=_YES}', "");
    Expect(1, 125252, '\P{Changes_When_Titlecased=_YES}', "");
    Expect(0, 125252, '\P{^Changes_When_Titlecased=_YES}', "");
    Error('\p{CWT=_/a/Y}');
    Error('\P{CWT=_/a/Y}');
    Expect(1, 125251, '\p{CWT=:\AY\z:}', "");;
    Expect(0, 125252, '\p{CWT=:\AY\z:}', "");;
    Expect(1, 125251, '\p{CWT=y}', "");
    Expect(0, 125251, '\p{^CWT=y}', "");
    Expect(0, 125251, '\P{CWT=y}', "");
    Expect(1, 125251, '\P{^CWT=y}', "");
    Expect(0, 125252, '\p{CWT=y}', "");
    Expect(1, 125252, '\p{^CWT=y}', "");
    Expect(1, 125252, '\P{CWT=y}', "");
    Expect(0, 125252, '\P{^CWT=y}', "");
    Expect(1, 125251, '\p{CWT=:\Ay\z:}', "");;
    Expect(0, 125252, '\p{CWT=:\Ay\z:}', "");;
    Expect(1, 125251, '\p{CWT=- Y}', "");
    Expect(0, 125251, '\p{^CWT=- Y}', "");
    Expect(0, 125251, '\P{CWT=- Y}', "");
    Expect(1, 125251, '\P{^CWT=- Y}', "");
    Expect(0, 125252, '\p{CWT=- Y}', "");
    Expect(1, 125252, '\p{^CWT=- Y}', "");
    Expect(1, 125252, '\P{CWT=- Y}', "");
    Expect(0, 125252, '\P{^CWT=- Y}', "");
    Error('\p{Is_Changes_When_Titlecased=__T/a/}');
    Error('\P{Is_Changes_When_Titlecased=__T/a/}');
    Expect(1, 125251, '\p{Is_Changes_When_Titlecased=t}', "");
    Expect(0, 125251, '\p{^Is_Changes_When_Titlecased=t}', "");
    Expect(0, 125251, '\P{Is_Changes_When_Titlecased=t}', "");
    Expect(1, 125251, '\P{^Is_Changes_When_Titlecased=t}', "");
    Expect(0, 125252, '\p{Is_Changes_When_Titlecased=t}', "");
    Expect(1, 125252, '\p{^Is_Changes_When_Titlecased=t}', "");
    Expect(1, 125252, '\P{Is_Changes_When_Titlecased=t}', "");
    Expect(0, 125252, '\P{^Is_Changes_When_Titlecased=t}', "");
    Expect(1, 125251, '\p{Is_Changes_When_Titlecased=--T}', "");
    Expect(0, 125251, '\p{^Is_Changes_When_Titlecased=--T}', "");
    Expect(0, 125251, '\P{Is_Changes_When_Titlecased=--T}', "");
    Expect(1, 125251, '\P{^Is_Changes_When_Titlecased=--T}', "");
    Expect(0, 125252, '\p{Is_Changes_When_Titlecased=--T}', "");
    Expect(1, 125252, '\p{^Is_Changes_When_Titlecased=--T}', "");
    Expect(1, 125252, '\P{Is_Changes_When_Titlecased=--T}', "");
    Expect(0, 125252, '\P{^Is_Changes_When_Titlecased=--T}', "");
    Error('\p{Is_CWT=:=-_True}');
    Error('\P{Is_CWT=:=-_True}');
    Expect(1, 125251, '\p{Is_CWT:true}', "");
    Expect(0, 125251, '\p{^Is_CWT:true}', "");
    Expect(0, 125251, '\P{Is_CWT:true}', "");
    Expect(1, 125251, '\P{^Is_CWT:true}', "");
    Expect(0, 125252, '\p{Is_CWT:true}', "");
    Expect(1, 125252, '\p{^Is_CWT:true}', "");
    Expect(1, 125252, '\P{Is_CWT:true}', "");
    Expect(0, 125252, '\P{^Is_CWT:true}', "");
    Expect(1, 125251, '\p{Is_CWT=-_TRUE}', "");
    Expect(0, 125251, '\p{^Is_CWT=-_TRUE}', "");
    Expect(0, 125251, '\P{Is_CWT=-_TRUE}', "");
    Expect(1, 125251, '\P{^Is_CWT=-_TRUE}', "");
    Expect(0, 125252, '\p{Is_CWT=-_TRUE}', "");
    Expect(1, 125252, '\p{^Is_CWT=-_TRUE}', "");
    Expect(1, 125252, '\P{Is_CWT=-_TRUE}', "");
    Expect(0, 125252, '\P{^Is_CWT=-_TRUE}', "");
    Error('\p{Changes_When_Uppercased=/a/	NO}');
    Error('\P{Changes_When_Uppercased=/a/	NO}');
    Expect(1, 125252, '\p{Changes_When_Uppercased=:\ANo\z:}', "");;
    Expect(0, 125251, '\p{Changes_When_Uppercased=:\ANo\z:}', "");;
    Expect(1, 125252, '\p{Changes_When_Uppercased=no}', "");
    Expect(0, 125252, '\p{^Changes_When_Uppercased=no}', "");
    Expect(0, 125252, '\P{Changes_When_Uppercased=no}', "");
    Expect(1, 125252, '\P{^Changes_When_Uppercased=no}', "");
    Expect(0, 125251, '\p{Changes_When_Uppercased=no}', "");
    Expect(1, 125251, '\p{^Changes_When_Uppercased=no}', "");
    Expect(1, 125251, '\P{Changes_When_Uppercased=no}', "");
    Expect(0, 125251, '\P{^Changes_When_Uppercased=no}', "");
    Expect(1, 125252, '\p{Changes_When_Uppercased=:\Ano\z:}', "");;
    Expect(0, 125251, '\p{Changes_When_Uppercased=:\Ano\z:}', "");;
    Expect(1, 125252, '\p{Changes_When_Uppercased= no}', "");
    Expect(0, 125252, '\p{^Changes_When_Uppercased= no}', "");
    Expect(0, 125252, '\P{Changes_When_Uppercased= no}', "");
    Expect(1, 125252, '\P{^Changes_When_Uppercased= no}', "");
    Expect(0, 125251, '\p{Changes_When_Uppercased= no}', "");
    Expect(1, 125251, '\p{^Changes_When_Uppercased= no}', "");
    Expect(1, 125251, '\P{Changes_When_Uppercased= no}', "");
    Expect(0, 125251, '\P{^Changes_When_Uppercased= no}', "");
    Error('\p{CWU: 	:=n}');
    Error('\P{CWU: 	:=n}');
    Expect(1, 125252, '\p{CWU=:\AN\z:}', "");;
    Expect(0, 125251, '\p{CWU=:\AN\z:}', "");;
    Expect(1, 125252, '\p{CWU: n}', "");
    Expect(0, 125252, '\p{^CWU: n}', "");
    Expect(0, 125252, '\P{CWU: n}', "");
    Expect(1, 125252, '\P{^CWU: n}', "");
    Expect(0, 125251, '\p{CWU: n}', "");
    Expect(1, 125251, '\p{^CWU: n}', "");
    Expect(1, 125251, '\P{CWU: n}', "");
    Expect(0, 125251, '\P{^CWU: n}', "");
    Expect(1, 125252, '\p{CWU=:\An\z:}', "");;
    Expect(0, 125251, '\p{CWU=:\An\z:}', "");;
    Expect(1, 125252, '\p{CWU: -n}', "");
    Expect(0, 125252, '\p{^CWU: -n}', "");
    Expect(0, 125252, '\P{CWU: -n}', "");
    Expect(1, 125252, '\P{^CWU: -n}', "");
    Expect(0, 125251, '\p{CWU: -n}', "");
    Expect(1, 125251, '\p{^CWU: -n}', "");
    Expect(1, 125251, '\P{CWU: -n}', "");
    Expect(0, 125251, '\P{^CWU: -n}', "");
    Error('\p{Is_Changes_When_Uppercased= /a/F}');
    Error('\P{Is_Changes_When_Uppercased= /a/F}');
    Expect(1, 125252, '\p{Is_Changes_When_Uppercased=f}', "");
    Expect(0, 125252, '\p{^Is_Changes_When_Uppercased=f}', "");
    Expect(0, 125252, '\P{Is_Changes_When_Uppercased=f}', "");
    Expect(1, 125252, '\P{^Is_Changes_When_Uppercased=f}', "");
    Expect(0, 125251, '\p{Is_Changes_When_Uppercased=f}', "");
    Expect(1, 125251, '\p{^Is_Changes_When_Uppercased=f}', "");
    Expect(1, 125251, '\P{Is_Changes_When_Uppercased=f}', "");
    Expect(0, 125251, '\P{^Is_Changes_When_Uppercased=f}', "");
    Expect(1, 125252, '\p{Is_Changes_When_Uppercased=	_F}', "");
    Expect(0, 125252, '\p{^Is_Changes_When_Uppercased=	_F}', "");
    Expect(0, 125252, '\P{Is_Changes_When_Uppercased=	_F}', "");
    Expect(1, 125252, '\P{^Is_Changes_When_Uppercased=	_F}', "");
    Expect(0, 125251, '\p{Is_Changes_When_Uppercased=	_F}', "");
    Expect(1, 125251, '\p{^Is_Changes_When_Uppercased=	_F}', "");
    Expect(1, 125251, '\P{Is_Changes_When_Uppercased=	_F}', "");
    Expect(0, 125251, '\P{^Is_Changes_When_Uppercased=	_F}', "");
    Error('\p{Is_CWU= /a/false}');
    Error('\P{Is_CWU= /a/false}');
    Expect(1, 125252, '\p{Is_CWU=false}', "");
    Expect(0, 125252, '\p{^Is_CWU=false}', "");
    Expect(0, 125252, '\P{Is_CWU=false}', "");
    Expect(1, 125252, '\P{^Is_CWU=false}', "");
    Expect(0, 125251, '\p{Is_CWU=false}', "");
    Expect(1, 125251, '\p{^Is_CWU=false}', "");
    Expect(1, 125251, '\P{Is_CWU=false}', "");
    Expect(0, 125251, '\P{^Is_CWU=false}', "");
    Expect(1, 125252, '\p{Is_CWU:   _-False}', "");
    Expect(0, 125252, '\p{^Is_CWU:   _-False}', "");
    Expect(0, 125252, '\P{Is_CWU:   _-False}', "");
    Expect(1, 125252, '\P{^Is_CWU:   _-False}', "");
    Expect(0, 125251, '\p{Is_CWU:   _-False}', "");
    Expect(1, 125251, '\p{^Is_CWU:   _-False}', "");
    Expect(1, 125251, '\P{Is_CWU:   _-False}', "");
    Expect(0, 125251, '\P{^Is_CWU:   _-False}', "");
    Error('\p{Changes_When_Uppercased=:= yes}');
    Error('\P{Changes_When_Uppercased=:= yes}');
    Expect(1, 125251, '\p{Changes_When_Uppercased=:\AYes\z:}', "");;
    Expect(0, 125252, '\p{Changes_When_Uppercased=:\AYes\z:}', "");;
    Expect(1, 125251, '\p{Changes_When_Uppercased:yes}', "");
    Expect(0, 125251, '\p{^Changes_When_Uppercased:yes}', "");
    Expect(0, 125251, '\P{Changes_When_Uppercased:yes}', "");
    Expect(1, 125251, '\P{^Changes_When_Uppercased:yes}', "");
    Expect(0, 125252, '\p{Changes_When_Uppercased:yes}', "");
    Expect(1, 125252, '\p{^Changes_When_Uppercased:yes}', "");
    Expect(1, 125252, '\P{Changes_When_Uppercased:yes}', "");
    Expect(0, 125252, '\P{^Changes_When_Uppercased:yes}', "");
    Expect(1, 125251, '\p{Changes_When_Uppercased=:\Ayes\z:}', "");;
    Expect(0, 125252, '\p{Changes_When_Uppercased=:\Ayes\z:}', "");;
    Expect(1, 125251, '\p{Changes_When_Uppercased=	 YES}', "");
    Expect(0, 125251, '\p{^Changes_When_Uppercased=	 YES}', "");
    Expect(0, 125251, '\P{Changes_When_Uppercased=	 YES}', "");
    Expect(1, 125251, '\P{^Changes_When_Uppercased=	 YES}', "");
    Expect(0, 125252, '\p{Changes_When_Uppercased=	 YES}', "");
    Expect(1, 125252, '\p{^Changes_When_Uppercased=	 YES}', "");
    Expect(1, 125252, '\P{Changes_When_Uppercased=	 YES}', "");
    Expect(0, 125252, '\P{^Changes_When_Uppercased=	 YES}', "");
    Error('\p{CWU= Y/a/}');
    Error('\P{CWU= Y/a/}');
    Expect(1, 125251, '\p{CWU=:\AY\z:}', "");;
    Expect(0, 125252, '\p{CWU=:\AY\z:}', "");;
    Expect(1, 125251, '\p{CWU: y}', "");
    Expect(0, 125251, '\p{^CWU: y}', "");
    Expect(0, 125251, '\P{CWU: y}', "");
    Expect(1, 125251, '\P{^CWU: y}', "");
    Expect(0, 125252, '\p{CWU: y}', "");
    Expect(1, 125252, '\p{^CWU: y}', "");
    Expect(1, 125252, '\P{CWU: y}', "");
    Expect(0, 125252, '\P{^CWU: y}', "");
    Expect(1, 125251, '\p{CWU=:\Ay\z:}', "");;
    Expect(0, 125252, '\p{CWU=:\Ay\z:}', "");;
    Expect(1, 125251, '\p{CWU=_Y}', "");
    Expect(0, 125251, '\p{^CWU=_Y}', "");
    Expect(0, 125251, '\P{CWU=_Y}', "");
    Expect(1, 125251, '\P{^CWU=_Y}', "");
    Expect(0, 125252, '\p{CWU=_Y}', "");
    Expect(1, 125252, '\p{^CWU=_Y}', "");
    Expect(1, 125252, '\P{CWU=_Y}', "");
    Expect(0, 125252, '\P{^CWU=_Y}', "");
    Error('\p{Is_Changes_When_Uppercased=:=	_T}');
    Error('\P{Is_Changes_When_Uppercased=:=	_T}');
    Expect(1, 125251, '\p{Is_Changes_When_Uppercased=t}', "");
    Expect(0, 125251, '\p{^Is_Changes_When_Uppercased=t}', "");
    Expect(0, 125251, '\P{Is_Changes_When_Uppercased=t}', "");
    Expect(1, 125251, '\P{^Is_Changes_When_Uppercased=t}', "");
    Expect(0, 125252, '\p{Is_Changes_When_Uppercased=t}', "");
    Expect(1, 125252, '\p{^Is_Changes_When_Uppercased=t}', "");
    Expect(1, 125252, '\P{Is_Changes_When_Uppercased=t}', "");
    Expect(0, 125252, '\P{^Is_Changes_When_Uppercased=t}', "");
    Expect(1, 125251, '\p{Is_Changes_When_Uppercased=	T}', "");
    Expect(0, 125251, '\p{^Is_Changes_When_Uppercased=	T}', "");
    Expect(0, 125251, '\P{Is_Changes_When_Uppercased=	T}', "");
    Expect(1, 125251, '\P{^Is_Changes_When_Uppercased=	T}', "");
    Expect(0, 125252, '\p{Is_Changes_When_Uppercased=	T}', "");
    Expect(1, 125252, '\p{^Is_Changes_When_Uppercased=	T}', "");
    Expect(1, 125252, '\P{Is_Changes_When_Uppercased=	T}', "");
    Expect(0, 125252, '\P{^Is_Changes_When_Uppercased=	T}', "");
    Error('\p{Is_CWU=	-True/a/}');
    Error('\P{Is_CWU=	-True/a/}');
    Expect(1, 125251, '\p{Is_CWU=true}', "");
    Expect(0, 125251, '\p{^Is_CWU=true}', "");
    Expect(0, 125251, '\P{Is_CWU=true}', "");
    Expect(1, 125251, '\P{^Is_CWU=true}', "");
    Expect(0, 125252, '\p{Is_CWU=true}', "");
    Expect(1, 125252, '\p{^Is_CWU=true}', "");
    Expect(1, 125252, '\P{Is_CWU=true}', "");
    Expect(0, 125252, '\P{^Is_CWU=true}', "");
    Expect(1, 125251, '\p{Is_CWU=	_True}', "");
    Expect(0, 125251, '\p{^Is_CWU=	_True}', "");
    Expect(0, 125251, '\P{Is_CWU=	_True}', "");
    Expect(1, 125251, '\P{^Is_CWU=	_True}', "");
    Expect(0, 125252, '\p{Is_CWU=	_True}', "");
    Expect(1, 125252, '\p{^Is_CWU=	_True}', "");
    Expect(1, 125252, '\P{Is_CWU=	_True}', "");
    Expect(0, 125252, '\P{^Is_CWU=	_True}', "");
    Error('\p{Dash=/a/ -No}');
    Error('\P{Dash=/a/ -No}');
    Expect(1, 69294, '\p{Dash=:\ANo\z:}', "");;
    Expect(0, 69293, '\p{Dash=:\ANo\z:}', "");;
    Expect(1, 69294, '\p{Dash=no}', "");
    Expect(0, 69294, '\p{^Dash=no}', "");
    Expect(0, 69294, '\P{Dash=no}', "");
    Expect(1, 69294, '\P{^Dash=no}', "");
    Expect(0, 69293, '\p{Dash=no}', "");
    Expect(1, 69293, '\p{^Dash=no}', "");
    Expect(1, 69293, '\P{Dash=no}', "");
    Expect(0, 69293, '\P{^Dash=no}', "");
    Expect(1, 69294, '\p{Dash=:\Ano\z:}', "");;
    Expect(0, 69293, '\p{Dash=:\Ano\z:}', "");;
    Expect(1, 69294, '\p{Dash= -No}', "");
    Expect(0, 69294, '\p{^Dash= -No}', "");
    Expect(0, 69294, '\P{Dash= -No}', "");
    Expect(1, 69294, '\P{^Dash= -No}', "");
    Expect(0, 69293, '\p{Dash= -No}', "");
    Expect(1, 69293, '\p{^Dash= -No}', "");
    Expect(1, 69293, '\P{Dash= -No}', "");
    Expect(0, 69293, '\P{^Dash= -No}', "");
    Error('\p{Is_Dash=/a/-	N}');
    Error('\P{Is_Dash=/a/-	N}');
    Expect(1, 69294, '\p{Is_Dash:   n}', "");
    Expect(0, 69294, '\p{^Is_Dash:   n}', "");
    Expect(0, 69294, '\P{Is_Dash:   n}', "");
    Expect(1, 69294, '\P{^Is_Dash:   n}', "");
    Expect(0, 69293, '\p{Is_Dash:   n}', "");
    Expect(1, 69293, '\p{^Is_Dash:   n}', "");
    Expect(1, 69293, '\P{Is_Dash:   n}', "");
    Expect(0, 69293, '\P{^Is_Dash:   n}', "");
    Expect(1, 69294, '\p{Is_Dash=-n}', "");
    Expect(0, 69294, '\p{^Is_Dash=-n}', "");
    Expect(0, 69294, '\P{Is_Dash=-n}', "");
    Expect(1, 69294, '\P{^Is_Dash=-n}', "");
    Expect(0, 69293, '\p{Is_Dash=-n}', "");
    Expect(1, 69293, '\p{^Is_Dash=-n}', "");
    Expect(1, 69293, '\P{Is_Dash=-n}', "");
    Expect(0, 69293, '\P{^Is_Dash=-n}', "");
    Error('\p{Dash=	-F:=}');
    Error('\P{Dash=	-F:=}');
    Expect(1, 69294, '\p{Dash=:\AF\z:}', "");;
    Expect(0, 69293, '\p{Dash=:\AF\z:}', "");;
    Expect(1, 69294, '\p{Dash=f}', "");
    Expect(0, 69294, '\p{^Dash=f}', "");
    Expect(0, 69294, '\P{Dash=f}', "");
    Expect(1, 69294, '\P{^Dash=f}', "");
    Expect(0, 69293, '\p{Dash=f}', "");
    Expect(1, 69293, '\p{^Dash=f}', "");
    Expect(1, 69293, '\P{Dash=f}', "");
    Expect(0, 69293, '\P{^Dash=f}', "");
    Expect(1, 69294, '\p{Dash=:\Af\z:}', "");;
    Expect(0, 69293, '\p{Dash=:\Af\z:}', "");;
    Expect(1, 69294, '\p{Dash=_ F}', "");
    Expect(0, 69294, '\p{^Dash=_ F}', "");
    Expect(0, 69294, '\P{Dash=_ F}', "");
    Expect(1, 69294, '\P{^Dash=_ F}', "");
    Expect(0, 69293, '\p{Dash=_ F}', "");
    Expect(1, 69293, '\p{^Dash=_ F}', "");
    Expect(1, 69293, '\P{Dash=_ F}', "");
    Expect(0, 69293, '\P{^Dash=_ F}', "");
    Error('\p{Is_Dash=	:=False}');
    Error('\P{Is_Dash=	:=False}');
    Expect(1, 69294, '\p{Is_Dash: false}', "");
    Expect(0, 69294, '\p{^Is_Dash: false}', "");
    Expect(0, 69294, '\P{Is_Dash: false}', "");
    Expect(1, 69294, '\P{^Is_Dash: false}', "");
    Expect(0, 69293, '\p{Is_Dash: false}', "");
    Expect(1, 69293, '\p{^Is_Dash: false}', "");
    Expect(1, 69293, '\P{Is_Dash: false}', "");
    Expect(0, 69293, '\P{^Is_Dash: false}', "");
    Expect(1, 69294, '\p{Is_Dash=-_FALSE}', "");
    Expect(0, 69294, '\p{^Is_Dash=-_FALSE}', "");
    Expect(0, 69294, '\P{Is_Dash=-_FALSE}', "");
    Expect(1, 69294, '\P{^Is_Dash=-_FALSE}', "");
    Expect(0, 69293, '\p{Is_Dash=-_FALSE}', "");
    Expect(1, 69293, '\p{^Is_Dash=-_FALSE}', "");
    Expect(1, 69293, '\P{Is_Dash=-_FALSE}', "");
    Expect(0, 69293, '\P{^Is_Dash=-_FALSE}', "");
    Error('\p{Dash=:=_yes}');
    Error('\P{Dash=:=_yes}');
    Expect(1, 69293, '\p{Dash=:\AYes\z:}', "");;
    Expect(0, 69294, '\p{Dash=:\AYes\z:}', "");;
    Expect(1, 69293, '\p{Dash:   yes}', "");
    Expect(0, 69293, '\p{^Dash:   yes}', "");
    Expect(0, 69293, '\P{Dash:   yes}', "");
    Expect(1, 69293, '\P{^Dash:   yes}', "");
    Expect(0, 69294, '\p{Dash:   yes}', "");
    Expect(1, 69294, '\p{^Dash:   yes}', "");
    Expect(1, 69294, '\P{Dash:   yes}', "");
    Expect(0, 69294, '\P{^Dash:   yes}', "");
    Expect(1, 69293, '\p{Dash=:\Ayes\z:}', "");;
    Expect(0, 69294, '\p{Dash=:\Ayes\z:}', "");;
    Expect(1, 69293, '\p{Dash: YES}', "");
    Expect(0, 69293, '\p{^Dash: YES}', "");
    Expect(0, 69293, '\P{Dash: YES}', "");
    Expect(1, 69293, '\P{^Dash: YES}', "");
    Expect(0, 69294, '\p{Dash: YES}', "");
    Expect(1, 69294, '\p{^Dash: YES}', "");
    Expect(1, 69294, '\P{Dash: YES}', "");
    Expect(0, 69294, '\P{^Dash: YES}', "");
    Error('\p{Is_Dash= /a/Y}');
    Error('\P{Is_Dash= /a/Y}');
    Expect(1, 69293, '\p{Is_Dash=y}', "");
    Expect(0, 69293, '\p{^Is_Dash=y}', "");
    Expect(0, 69293, '\P{Is_Dash=y}', "");
    Expect(1, 69293, '\P{^Is_Dash=y}', "");
    Expect(0, 69294, '\p{Is_Dash=y}', "");
    Expect(1, 69294, '\p{^Is_Dash=y}', "");
    Expect(1, 69294, '\P{Is_Dash=y}', "");
    Expect(0, 69294, '\P{^Is_Dash=y}', "");
    Expect(1, 69293, '\p{Is_Dash=		Y}', "");
    Expect(0, 69293, '\p{^Is_Dash=		Y}', "");
    Expect(0, 69293, '\P{Is_Dash=		Y}', "");
    Expect(1, 69293, '\P{^Is_Dash=		Y}', "");
    Expect(0, 69294, '\p{Is_Dash=		Y}', "");
    Expect(1, 69294, '\p{^Is_Dash=		Y}', "");
    Expect(1, 69294, '\P{Is_Dash=		Y}', "");
    Expect(0, 69294, '\P{^Is_Dash=		Y}', "");
    Error('\p{Dash=	_T/a/}');
    Error('\P{Dash=	_T/a/}');
    Expect(1, 69293, '\p{Dash=:\AT\z:}', "");;
    Expect(0, 69294, '\p{Dash=:\AT\z:}', "");;
    Expect(1, 69293, '\p{Dash=t}', "");
    Expect(0, 69293, '\p{^Dash=t}', "");
    Expect(0, 69293, '\P{Dash=t}', "");
    Expect(1, 69293, '\P{^Dash=t}', "");
    Expect(0, 69294, '\p{Dash=t}', "");
    Expect(1, 69294, '\p{^Dash=t}', "");
    Expect(1, 69294, '\P{Dash=t}', "");
    Expect(0, 69294, '\P{^Dash=t}', "");
    Expect(1, 69293, '\p{Dash=:\At\z:}', "");;
    Expect(0, 69294, '\p{Dash=:\At\z:}', "");;
    Expect(1, 69293, '\p{Dash=_t}', "");
    Expect(0, 69293, '\p{^Dash=_t}', "");
    Expect(0, 69293, '\P{Dash=_t}', "");
    Expect(1, 69293, '\P{^Dash=_t}', "");
    Expect(0, 69294, '\p{Dash=_t}', "");
    Expect(1, 69294, '\p{^Dash=_t}', "");
    Expect(1, 69294, '\P{Dash=_t}', "");
    Expect(0, 69294, '\P{^Dash=_t}', "");
    Error('\p{Is_Dash=	true/a/}');
    Error('\P{Is_Dash=	true/a/}');
    Expect(1, 69293, '\p{Is_Dash=true}', "");
    Expect(0, 69293, '\p{^Is_Dash=true}', "");
    Expect(0, 69293, '\P{Is_Dash=true}', "");
    Expect(1, 69293, '\P{^Is_Dash=true}', "");
    Expect(0, 69294, '\p{Is_Dash=true}', "");
    Expect(1, 69294, '\p{^Is_Dash=true}', "");
    Expect(1, 69294, '\P{Is_Dash=true}', "");
    Expect(0, 69294, '\P{^Is_Dash=true}', "");
    Expect(1, 69293, '\p{Is_Dash=	-True}', "");
    Expect(0, 69293, '\p{^Is_Dash=	-True}', "");
    Expect(0, 69293, '\P{Is_Dash=	-True}', "");
    Expect(1, 69293, '\P{^Is_Dash=	-True}', "");
    Expect(0, 69294, '\p{Is_Dash=	-True}', "");
    Expect(1, 69294, '\p{^Is_Dash=	-True}', "");
    Expect(1, 69294, '\P{Is_Dash=	-True}', "");
    Expect(0, 69294, '\P{^Is_Dash=	-True}', "");
    Error('\p{Deprecated=_:=No}');
    Error('\P{Deprecated=_:=No}');
    Expect(1, 917506, '\p{Deprecated=:\ANo\z:}', "");;
    Expect(0, 917505, '\p{Deprecated=:\ANo\z:}', "");;
    Expect(1, 917506, '\p{Deprecated:	no}', "");
    Expect(0, 917506, '\p{^Deprecated:	no}', "");
    Expect(0, 917506, '\P{Deprecated:	no}', "");
    Expect(1, 917506, '\P{^Deprecated:	no}', "");
    Expect(0, 917505, '\p{Deprecated:	no}', "");
    Expect(1, 917505, '\p{^Deprecated:	no}', "");
    Expect(1, 917505, '\P{Deprecated:	no}', "");
    Expect(0, 917505, '\P{^Deprecated:	no}', "");
    Expect(1, 917506, '\p{Deprecated=:\Ano\z:}', "");;
    Expect(0, 917505, '\p{Deprecated=:\Ano\z:}', "");;
    Expect(1, 917506, '\p{Deprecated= no}', "");
    Expect(0, 917506, '\p{^Deprecated= no}', "");
    Expect(0, 917506, '\P{Deprecated= no}', "");
    Expect(1, 917506, '\P{^Deprecated= no}', "");
    Expect(0, 917505, '\p{Deprecated= no}', "");
    Expect(1, 917505, '\p{^Deprecated= no}', "");
    Expect(1, 917505, '\P{Deprecated= no}', "");
    Expect(0, 917505, '\P{^Deprecated= no}', "");
    Error('\p{Dep=/a/n}');
    Error('\P{Dep=/a/n}');
    Expect(1, 917506, '\p{Dep=:\AN\z:}', "");;
    Expect(0, 917505, '\p{Dep=:\AN\z:}', "");;
    Expect(1, 917506, '\p{Dep=n}', "");
    Expect(0, 917506, '\p{^Dep=n}', "");
    Expect(0, 917506, '\P{Dep=n}', "");
    Expect(1, 917506, '\P{^Dep=n}', "");
    Expect(0, 917505, '\p{Dep=n}', "");
    Expect(1, 917505, '\p{^Dep=n}', "");
    Expect(1, 917505, '\P{Dep=n}', "");
    Expect(0, 917505, '\P{^Dep=n}', "");
    Expect(1, 917506, '\p{Dep=:\An\z:}', "");;
    Expect(0, 917505, '\p{Dep=:\An\z:}', "");;
    Expect(1, 917506, '\p{Dep=__N}', "");
    Expect(0, 917506, '\p{^Dep=__N}', "");
    Expect(0, 917506, '\P{Dep=__N}', "");
    Expect(1, 917506, '\P{^Dep=__N}', "");
    Expect(0, 917505, '\p{Dep=__N}', "");
    Expect(1, 917505, '\p{^Dep=__N}', "");
    Expect(1, 917505, '\P{Dep=__N}', "");
    Expect(0, 917505, '\P{^Dep=__N}', "");
    Error('\p{Is_Deprecated=-/a/F}');
    Error('\P{Is_Deprecated=-/a/F}');
    Expect(1, 917506, '\p{Is_Deprecated=f}', "");
    Expect(0, 917506, '\p{^Is_Deprecated=f}', "");
    Expect(0, 917506, '\P{Is_Deprecated=f}', "");
    Expect(1, 917506, '\P{^Is_Deprecated=f}', "");
    Expect(0, 917505, '\p{Is_Deprecated=f}', "");
    Expect(1, 917505, '\p{^Is_Deprecated=f}', "");
    Expect(1, 917505, '\P{Is_Deprecated=f}', "");
    Expect(0, 917505, '\P{^Is_Deprecated=f}', "");
    Expect(1, 917506, '\p{Is_Deprecated= _F}', "");
    Expect(0, 917506, '\p{^Is_Deprecated= _F}', "");
    Expect(0, 917506, '\P{Is_Deprecated= _F}', "");
    Expect(1, 917506, '\P{^Is_Deprecated= _F}', "");
    Expect(0, 917505, '\p{Is_Deprecated= _F}', "");
    Expect(1, 917505, '\p{^Is_Deprecated= _F}', "");
    Expect(1, 917505, '\P{Is_Deprecated= _F}', "");
    Expect(0, 917505, '\P{^Is_Deprecated= _F}', "");
    Error('\p{Is_Dep=/a/_False}');
    Error('\P{Is_Dep=/a/_False}');
    Expect(1, 917506, '\p{Is_Dep=false}', "");
    Expect(0, 917506, '\p{^Is_Dep=false}', "");
    Expect(0, 917506, '\P{Is_Dep=false}', "");
    Expect(1, 917506, '\P{^Is_Dep=false}', "");
    Expect(0, 917505, '\p{Is_Dep=false}', "");
    Expect(1, 917505, '\p{^Is_Dep=false}', "");
    Expect(1, 917505, '\P{Is_Dep=false}', "");
    Expect(0, 917505, '\P{^Is_Dep=false}', "");
    Expect(1, 917506, '\p{Is_Dep=-_False}', "");
    Expect(0, 917506, '\p{^Is_Dep=-_False}', "");
    Expect(0, 917506, '\P{Is_Dep=-_False}', "");
    Expect(1, 917506, '\P{^Is_Dep=-_False}', "");
    Expect(0, 917505, '\p{Is_Dep=-_False}', "");
    Expect(1, 917505, '\p{^Is_Dep=-_False}', "");
    Expect(1, 917505, '\P{Is_Dep=-_False}', "");
    Expect(0, 917505, '\P{^Is_Dep=-_False}', "");
    Error('\p{Deprecated=	Yes/a/}');
    Error('\P{Deprecated=	Yes/a/}');
    Expect(1, 917505, '\p{Deprecated=:\AYes\z:}', "");;
    Expect(0, 917506, '\p{Deprecated=:\AYes\z:}', "");;
    Expect(1, 917505, '\p{Deprecated=yes}', "");
    Expect(0, 917505, '\p{^Deprecated=yes}', "");
    Expect(0, 917505, '\P{Deprecated=yes}', "");
    Expect(1, 917505, '\P{^Deprecated=yes}', "");
    Expect(0, 917506, '\p{Deprecated=yes}', "");
    Expect(1, 917506, '\p{^Deprecated=yes}', "");
    Expect(1, 917506, '\P{Deprecated=yes}', "");
    Expect(0, 917506, '\P{^Deprecated=yes}', "");
    Expect(1, 917505, '\p{Deprecated=:\Ayes\z:}', "");;
    Expect(0, 917506, '\p{Deprecated=:\Ayes\z:}', "");;
    Expect(1, 917505, '\p{Deprecated=_-Yes}', "");
    Expect(0, 917505, '\p{^Deprecated=_-Yes}', "");
    Expect(0, 917505, '\P{Deprecated=_-Yes}', "");
    Expect(1, 917505, '\P{^Deprecated=_-Yes}', "");
    Expect(0, 917506, '\p{Deprecated=_-Yes}', "");
    Expect(1, 917506, '\p{^Deprecated=_-Yes}', "");
    Expect(1, 917506, '\P{Deprecated=_-Yes}', "");
    Expect(0, 917506, '\P{^Deprecated=_-Yes}', "");
    Error('\p{Dep= /a/Y}');
    Error('\P{Dep= /a/Y}');
    Expect(1, 917505, '\p{Dep=:\AY\z:}', "");;
    Expect(0, 917506, '\p{Dep=:\AY\z:}', "");;
    Expect(1, 917505, '\p{Dep=y}', "");
    Expect(0, 917505, '\p{^Dep=y}', "");
    Expect(0, 917505, '\P{Dep=y}', "");
    Expect(1, 917505, '\P{^Dep=y}', "");
    Expect(0, 917506, '\p{Dep=y}', "");
    Expect(1, 917506, '\p{^Dep=y}', "");
    Expect(1, 917506, '\P{Dep=y}', "");
    Expect(0, 917506, '\P{^Dep=y}', "");
    Expect(1, 917505, '\p{Dep=:\Ay\z:}', "");;
    Expect(0, 917506, '\p{Dep=:\Ay\z:}', "");;
    Expect(1, 917505, '\p{Dep=_y}', "");
    Expect(0, 917505, '\p{^Dep=_y}', "");
    Expect(0, 917505, '\P{Dep=_y}', "");
    Expect(1, 917505, '\P{^Dep=_y}', "");
    Expect(0, 917506, '\p{Dep=_y}', "");
    Expect(1, 917506, '\p{^Dep=_y}', "");
    Expect(1, 917506, '\P{Dep=_y}', "");
    Expect(0, 917506, '\P{^Dep=_y}', "");
    Error('\p{Is_Deprecated=-_T:=}');
    Error('\P{Is_Deprecated=-_T:=}');
    Expect(1, 917505, '\p{Is_Deprecated:	t}', "");
    Expect(0, 917505, '\p{^Is_Deprecated:	t}', "");
    Expect(0, 917505, '\P{Is_Deprecated:	t}', "");
    Expect(1, 917505, '\P{^Is_Deprecated:	t}', "");
    Expect(0, 917506, '\p{Is_Deprecated:	t}', "");
    Expect(1, 917506, '\p{^Is_Deprecated:	t}', "");
    Expect(1, 917506, '\P{Is_Deprecated:	t}', "");
    Expect(0, 917506, '\P{^Is_Deprecated:	t}', "");
    Expect(1, 917505, '\p{Is_Deprecated= 	T}', "");
    Expect(0, 917505, '\p{^Is_Deprecated= 	T}', "");
    Expect(0, 917505, '\P{Is_Deprecated= 	T}', "");
    Expect(1, 917505, '\P{^Is_Deprecated= 	T}', "");
    Expect(0, 917506, '\p{Is_Deprecated= 	T}', "");
    Expect(1, 917506, '\p{^Is_Deprecated= 	T}', "");
    Expect(1, 917506, '\P{Is_Deprecated= 	T}', "");
    Expect(0, 917506, '\P{^Is_Deprecated= 	T}', "");
    Error('\p{Is_Dep=__TRUE/a/}');
    Error('\P{Is_Dep=__TRUE/a/}');
    Expect(1, 917505, '\p{Is_Dep=true}', "");
    Expect(0, 917505, '\p{^Is_Dep=true}', "");
    Expect(0, 917505, '\P{Is_Dep=true}', "");
    Expect(1, 917505, '\P{^Is_Dep=true}', "");
    Expect(0, 917506, '\p{Is_Dep=true}', "");
    Expect(1, 917506, '\p{^Is_Dep=true}', "");
    Expect(1, 917506, '\P{Is_Dep=true}', "");
    Expect(0, 917506, '\P{^Is_Dep=true}', "");
    Expect(1, 917505, '\p{Is_Dep= -True}', "");
    Expect(0, 917505, '\p{^Is_Dep= -True}', "");
    Expect(0, 917505, '\P{Is_Dep= -True}', "");
    Expect(1, 917505, '\P{^Is_Dep= -True}', "");
    Expect(0, 917506, '\p{Is_Dep= -True}', "");
    Expect(1, 917506, '\p{^Is_Dep= -True}', "");
    Expect(1, 917506, '\P{Is_Dep= -True}', "");
    Expect(0, 917506, '\P{^Is_Dep= -True}', "");
    Error('\p{Default_Ignorable_Code_Point=__No:=}');
    Error('\P{Default_Ignorable_Code_Point=__No:=}');
    Expect(1, 921600, '\p{Default_Ignorable_Code_Point=:\ANo\z:}', "");;
    Expect(0, 921599, '\p{Default_Ignorable_Code_Point=:\ANo\z:}', "");;
    Expect(1, 921600, '\p{Default_Ignorable_Code_Point=no}', "");
    Expect(0, 921600, '\p{^Default_Ignorable_Code_Point=no}', "");
    Expect(0, 921600, '\P{Default_Ignorable_Code_Point=no}', "");
    Expect(1, 921600, '\P{^Default_Ignorable_Code_Point=no}', "");
    Expect(0, 921599, '\p{Default_Ignorable_Code_Point=no}', "");
    Expect(1, 921599, '\p{^Default_Ignorable_Code_Point=no}', "");
    Expect(1, 921599, '\P{Default_Ignorable_Code_Point=no}', "");
    Expect(0, 921599, '\P{^Default_Ignorable_Code_Point=no}', "");
    Expect(1, 921600, '\p{Default_Ignorable_Code_Point=:\Ano\z:}', "");;
    Expect(0, 921599, '\p{Default_Ignorable_Code_Point=:\Ano\z:}', "");;
    Expect(1, 921600, '\p{Default_Ignorable_Code_Point=	NO}', "");
    Expect(0, 921600, '\p{^Default_Ignorable_Code_Point=	NO}', "");
    Expect(0, 921600, '\P{Default_Ignorable_Code_Point=	NO}', "");
    Expect(1, 921600, '\P{^Default_Ignorable_Code_Point=	NO}', "");
    Expect(0, 921599, '\p{Default_Ignorable_Code_Point=	NO}', "");
    Expect(1, 921599, '\p{^Default_Ignorable_Code_Point=	NO}', "");
    Expect(1, 921599, '\P{Default_Ignorable_Code_Point=	NO}', "");
    Expect(0, 921599, '\P{^Default_Ignorable_Code_Point=	NO}', "");
    Error('\p{DI= N/a/}');
    Error('\P{DI= N/a/}');
    Expect(1, 921600, '\p{DI=:\AN\z:}', "");;
    Expect(0, 921599, '\p{DI=:\AN\z:}', "");;
    Expect(1, 921600, '\p{DI:	n}', "");
    Expect(0, 921600, '\p{^DI:	n}', "");
    Expect(0, 921600, '\P{DI:	n}', "");
    Expect(1, 921600, '\P{^DI:	n}', "");
    Expect(0, 921599, '\p{DI:	n}', "");
    Expect(1, 921599, '\p{^DI:	n}', "");
    Expect(1, 921599, '\P{DI:	n}', "");
    Expect(0, 921599, '\P{^DI:	n}', "");
    Expect(1, 921600, '\p{DI=:\An\z:}', "");;
    Expect(0, 921599, '\p{DI=:\An\z:}', "");;
    Expect(1, 921600, '\p{DI=N}', "");
    Expect(0, 921600, '\p{^DI=N}', "");
    Expect(0, 921600, '\P{DI=N}', "");
    Expect(1, 921600, '\P{^DI=N}', "");
    Expect(0, 921599, '\p{DI=N}', "");
    Expect(1, 921599, '\p{^DI=N}', "");
    Expect(1, 921599, '\P{DI=N}', "");
    Expect(0, 921599, '\P{^DI=N}', "");
    Error('\p{Is_Default_Ignorable_Code_Point:   		F:=}');
    Error('\P{Is_Default_Ignorable_Code_Point:   		F:=}');
    Expect(1, 921600, '\p{Is_Default_Ignorable_Code_Point:   f}', "");
    Expect(0, 921600, '\p{^Is_Default_Ignorable_Code_Point:   f}', "");
    Expect(0, 921600, '\P{Is_Default_Ignorable_Code_Point:   f}', "");
    Expect(1, 921600, '\P{^Is_Default_Ignorable_Code_Point:   f}', "");
    Expect(0, 921599, '\p{Is_Default_Ignorable_Code_Point:   f}', "");
    Expect(1, 921599, '\p{^Is_Default_Ignorable_Code_Point:   f}', "");
    Expect(1, 921599, '\P{Is_Default_Ignorable_Code_Point:   f}', "");
    Expect(0, 921599, '\P{^Is_Default_Ignorable_Code_Point:   f}', "");
    Expect(1, 921600, '\p{Is_Default_Ignorable_Code_Point=	f}', "");
    Expect(0, 921600, '\p{^Is_Default_Ignorable_Code_Point=	f}', "");
    Expect(0, 921600, '\P{Is_Default_Ignorable_Code_Point=	f}', "");
    Expect(1, 921600, '\P{^Is_Default_Ignorable_Code_Point=	f}', "");
    Expect(0, 921599, '\p{Is_Default_Ignorable_Code_Point=	f}', "");
    Expect(1, 921599, '\p{^Is_Default_Ignorable_Code_Point=	f}', "");
    Expect(1, 921599, '\P{Is_Default_Ignorable_Code_Point=	f}', "");
    Expect(0, 921599, '\P{^Is_Default_Ignorable_Code_Point=	f}', "");
    Error('\p{Is_DI=		false/a/}');
    Error('\P{Is_DI=		false/a/}');
    Expect(1, 921600, '\p{Is_DI=false}', "");
    Expect(0, 921600, '\p{^Is_DI=false}', "");
    Expect(0, 921600, '\P{Is_DI=false}', "");
    Expect(1, 921600, '\P{^Is_DI=false}', "");
    Expect(0, 921599, '\p{Is_DI=false}', "");
    Expect(1, 921599, '\p{^Is_DI=false}', "");
    Expect(1, 921599, '\P{Is_DI=false}', "");
    Expect(0, 921599, '\P{^Is_DI=false}', "");
    Expect(1, 921600, '\p{Is_DI=-_False}', "");
    Expect(0, 921600, '\p{^Is_DI=-_False}', "");
    Expect(0, 921600, '\P{Is_DI=-_False}', "");
    Expect(1, 921600, '\P{^Is_DI=-_False}', "");
    Expect(0, 921599, '\p{Is_DI=-_False}', "");
    Expect(1, 921599, '\p{^Is_DI=-_False}', "");
    Expect(1, 921599, '\P{Is_DI=-_False}', "");
    Expect(0, 921599, '\P{^Is_DI=-_False}', "");
    Error('\p{Default_Ignorable_Code_Point=:=	-Yes}');
    Error('\P{Default_Ignorable_Code_Point=:=	-Yes}');
    Expect(1, 921599, '\p{Default_Ignorable_Code_Point=:\AYes\z:}', "");;
    Expect(0, 921600, '\p{Default_Ignorable_Code_Point=:\AYes\z:}', "");;
    Expect(1, 921599, '\p{Default_Ignorable_Code_Point=yes}', "");
    Expect(0, 921599, '\p{^Default_Ignorable_Code_Point=yes}', "");
    Expect(0, 921599, '\P{Default_Ignorable_Code_Point=yes}', "");
    Expect(1, 921599, '\P{^Default_Ignorable_Code_Point=yes}', "");
    Expect(0, 921600, '\p{Default_Ignorable_Code_Point=yes}', "");
    Expect(1, 921600, '\p{^Default_Ignorable_Code_Point=yes}', "");
    Expect(1, 921600, '\P{Default_Ignorable_Code_Point=yes}', "");
    Expect(0, 921600, '\P{^Default_Ignorable_Code_Point=yes}', "");
    Expect(1, 921599, '\p{Default_Ignorable_Code_Point=:\Ayes\z:}', "");;
    Expect(0, 921600, '\p{Default_Ignorable_Code_Point=:\Ayes\z:}', "");;
    Expect(1, 921599, '\p{Default_Ignorable_Code_Point=_yes}', "");
    Expect(0, 921599, '\p{^Default_Ignorable_Code_Point=_yes}', "");
    Expect(0, 921599, '\P{Default_Ignorable_Code_Point=_yes}', "");
    Expect(1, 921599, '\P{^Default_Ignorable_Code_Point=_yes}', "");
    Expect(0, 921600, '\p{Default_Ignorable_Code_Point=_yes}', "");
    Expect(1, 921600, '\p{^Default_Ignorable_Code_Point=_yes}', "");
    Expect(1, 921600, '\P{Default_Ignorable_Code_Point=_yes}', "");
    Expect(0, 921600, '\P{^Default_Ignorable_Code_Point=_yes}', "");
    Error('\p{DI=:=_-y}');
    Error('\P{DI=:=_-y}');
    Expect(1, 921599, '\p{DI=:\AY\z:}', "");;
    Expect(0, 921600, '\p{DI=:\AY\z:}', "");;
    Expect(1, 921599, '\p{DI=y}', "");
    Expect(0, 921599, '\p{^DI=y}', "");
    Expect(0, 921599, '\P{DI=y}', "");
    Expect(1, 921599, '\P{^DI=y}', "");
    Expect(0, 921600, '\p{DI=y}', "");
    Expect(1, 921600, '\p{^DI=y}', "");
    Expect(1, 921600, '\P{DI=y}', "");
    Expect(0, 921600, '\P{^DI=y}', "");
    Expect(1, 921599, '\p{DI=:\Ay\z:}', "");;
    Expect(0, 921600, '\p{DI=:\Ay\z:}', "");;
    Expect(1, 921599, '\p{DI=	-Y}', "");
    Expect(0, 921599, '\p{^DI=	-Y}', "");
    Expect(0, 921599, '\P{DI=	-Y}', "");
    Expect(1, 921599, '\P{^DI=	-Y}', "");
    Expect(0, 921600, '\p{DI=	-Y}', "");
    Expect(1, 921600, '\p{^DI=	-Y}', "");
    Expect(1, 921600, '\P{DI=	-Y}', "");
    Expect(0, 921600, '\P{^DI=	-Y}', "");
    Error('\p{Is_Default_Ignorable_Code_Point= _T/a/}');
    Error('\P{Is_Default_Ignorable_Code_Point= _T/a/}');
    Expect(1, 921599, '\p{Is_Default_Ignorable_Code_Point=t}', "");
    Expect(0, 921599, '\p{^Is_Default_Ignorable_Code_Point=t}', "");
    Expect(0, 921599, '\P{Is_Default_Ignorable_Code_Point=t}', "");
    Expect(1, 921599, '\P{^Is_Default_Ignorable_Code_Point=t}', "");
    Expect(0, 921600, '\p{Is_Default_Ignorable_Code_Point=t}', "");
    Expect(1, 921600, '\p{^Is_Default_Ignorable_Code_Point=t}', "");
    Expect(1, 921600, '\P{Is_Default_Ignorable_Code_Point=t}', "");
    Expect(0, 921600, '\P{^Is_Default_Ignorable_Code_Point=t}', "");
    Expect(1, 921599, '\p{Is_Default_Ignorable_Code_Point=_t}', "");
    Expect(0, 921599, '\p{^Is_Default_Ignorable_Code_Point=_t}', "");
    Expect(0, 921599, '\P{Is_Default_Ignorable_Code_Point=_t}', "");
    Expect(1, 921599, '\P{^Is_Default_Ignorable_Code_Point=_t}', "");
    Expect(0, 921600, '\p{Is_Default_Ignorable_Code_Point=_t}', "");
    Expect(1, 921600, '\p{^Is_Default_Ignorable_Code_Point=_t}', "");
    Expect(1, 921600, '\P{Is_Default_Ignorable_Code_Point=_t}', "");
    Expect(0, 921600, '\P{^Is_Default_Ignorable_Code_Point=_t}', "");
    Error('\p{Is_DI=/a/	 True}');
    Error('\P{Is_DI=/a/	 True}');
    Expect(1, 921599, '\p{Is_DI=true}', "");
    Expect(0, 921599, '\p{^Is_DI=true}', "");
    Expect(0, 921599, '\P{Is_DI=true}', "");
    Expect(1, 921599, '\P{^Is_DI=true}', "");
    Expect(0, 921600, '\p{Is_DI=true}', "");
    Expect(1, 921600, '\p{^Is_DI=true}', "");
    Expect(1, 921600, '\P{Is_DI=true}', "");
    Expect(0, 921600, '\P{^Is_DI=true}', "");
    Expect(1, 921599, '\p{Is_DI= _true}', "");
    Expect(0, 921599, '\p{^Is_DI= _true}', "");
    Expect(0, 921599, '\P{Is_DI= _true}', "");
    Expect(1, 921599, '\P{^Is_DI= _true}', "");
    Expect(0, 921600, '\p{Is_DI= _true}', "");
    Expect(1, 921600, '\p{^Is_DI= _true}', "");
    Expect(1, 921600, '\P{Is_DI= _true}', "");
    Expect(0, 921600, '\P{^Is_DI= _true}', "");
    Error('\p{Diacritic:/a/	 no}');
    Error('\P{Diacritic:/a/	 no}');
    Expect(1, 125259, '\p{Diacritic=:\ANo\z:}', "");;
    Expect(0, 125258, '\p{Diacritic=:\ANo\z:}', "");;
    Expect(1, 125259, '\p{Diacritic:no}', "");
    Expect(0, 125259, '\p{^Diacritic:no}', "");
    Expect(0, 125259, '\P{Diacritic:no}', "");
    Expect(1, 125259, '\P{^Diacritic:no}', "");
    Expect(0, 125258, '\p{Diacritic:no}', "");
    Expect(1, 125258, '\p{^Diacritic:no}', "");
    Expect(1, 125258, '\P{Diacritic:no}', "");
    Expect(0, 125258, '\P{^Diacritic:no}', "");
    Expect(1, 125259, '\p{Diacritic=:\Ano\z:}', "");;
    Expect(0, 125258, '\p{Diacritic=:\Ano\z:}', "");;
    Expect(1, 125259, '\p{Diacritic=	_No}', "");
    Expect(0, 125259, '\p{^Diacritic=	_No}', "");
    Expect(0, 125259, '\P{Diacritic=	_No}', "");
    Expect(1, 125259, '\P{^Diacritic=	_No}', "");
    Expect(0, 125258, '\p{Diacritic=	_No}', "");
    Expect(1, 125258, '\p{^Diacritic=	_No}', "");
    Expect(1, 125258, '\P{Diacritic=	_No}', "");
    Expect(0, 125258, '\P{^Diacritic=	_No}', "");
    Error('\p{Dia=-_n/a/}');
    Error('\P{Dia=-_n/a/}');
    Expect(1, 125259, '\p{Dia=:\AN\z:}', "");;
    Expect(0, 125258, '\p{Dia=:\AN\z:}', "");;
    Expect(1, 125259, '\p{Dia=n}', "");
    Expect(0, 125259, '\p{^Dia=n}', "");
    Expect(0, 125259, '\P{Dia=n}', "");
    Expect(1, 125259, '\P{^Dia=n}', "");
    Expect(0, 125258, '\p{Dia=n}', "");
    Expect(1, 125258, '\p{^Dia=n}', "");
    Expect(1, 125258, '\P{Dia=n}', "");
    Expect(0, 125258, '\P{^Dia=n}', "");
    Expect(1, 125259, '\p{Dia=:\An\z:}', "");;
    Expect(0, 125258, '\p{Dia=:\An\z:}', "");;
    Expect(1, 125259, '\p{Dia=-N}', "");
    Expect(0, 125259, '\p{^Dia=-N}', "");
    Expect(0, 125259, '\P{Dia=-N}', "");
    Expect(1, 125259, '\P{^Dia=-N}', "");
    Expect(0, 125258, '\p{Dia=-N}', "");
    Expect(1, 125258, '\p{^Dia=-N}', "");
    Expect(1, 125258, '\P{Dia=-N}', "");
    Expect(0, 125258, '\P{^Dia=-N}', "");
    Error('\p{Is_Diacritic=:=_-F}');
    Error('\P{Is_Diacritic=:=_-F}');
    Expect(1, 125259, '\p{Is_Diacritic=f}', "");
    Expect(0, 125259, '\p{^Is_Diacritic=f}', "");
    Expect(0, 125259, '\P{Is_Diacritic=f}', "");
    Expect(1, 125259, '\P{^Is_Diacritic=f}', "");
    Expect(0, 125258, '\p{Is_Diacritic=f}', "");
    Expect(1, 125258, '\p{^Is_Diacritic=f}', "");
    Expect(1, 125258, '\P{Is_Diacritic=f}', "");
    Expect(0, 125258, '\P{^Is_Diacritic=f}', "");
    Expect(1, 125259, '\p{Is_Diacritic=-	F}', "");
    Expect(0, 125259, '\p{^Is_Diacritic=-	F}', "");
    Expect(0, 125259, '\P{Is_Diacritic=-	F}', "");
    Expect(1, 125259, '\P{^Is_Diacritic=-	F}', "");
    Expect(0, 125258, '\p{Is_Diacritic=-	F}', "");
    Expect(1, 125258, '\p{^Is_Diacritic=-	F}', "");
    Expect(1, 125258, '\P{Is_Diacritic=-	F}', "");
    Expect(0, 125258, '\P{^Is_Diacritic=-	F}', "");
    Error('\p{Is_Dia=/a/	-False}');
    Error('\P{Is_Dia=/a/	-False}');
    Expect(1, 125259, '\p{Is_Dia=false}', "");
    Expect(0, 125259, '\p{^Is_Dia=false}', "");
    Expect(0, 125259, '\P{Is_Dia=false}', "");
    Expect(1, 125259, '\P{^Is_Dia=false}', "");
    Expect(0, 125258, '\p{Is_Dia=false}', "");
    Expect(1, 125258, '\p{^Is_Dia=false}', "");
    Expect(1, 125258, '\P{Is_Dia=false}', "");
    Expect(0, 125258, '\P{^Is_Dia=false}', "");
    Expect(1, 125259, '\p{Is_Dia=	False}', "");
    Expect(0, 125259, '\p{^Is_Dia=	False}', "");
    Expect(0, 125259, '\P{Is_Dia=	False}', "");
    Expect(1, 125259, '\P{^Is_Dia=	False}', "");
    Expect(0, 125258, '\p{Is_Dia=	False}', "");
    Expect(1, 125258, '\p{^Is_Dia=	False}', "");
    Expect(1, 125258, '\P{Is_Dia=	False}', "");
    Expect(0, 125258, '\P{^Is_Dia=	False}', "");
    Error('\p{Diacritic=_YES:=}');
    Error('\P{Diacritic=_YES:=}');
    Expect(1, 125258, '\p{Diacritic=:\AYes\z:}', "");;
    Expect(0, 125259, '\p{Diacritic=:\AYes\z:}', "");;
    Expect(1, 125258, '\p{Diacritic=yes}', "");
    Expect(0, 125258, '\p{^Diacritic=yes}', "");
    Expect(0, 125258, '\P{Diacritic=yes}', "");
    Expect(1, 125258, '\P{^Diacritic=yes}', "");
    Expect(0, 125259, '\p{Diacritic=yes}', "");
    Expect(1, 125259, '\p{^Diacritic=yes}', "");
    Expect(1, 125259, '\P{Diacritic=yes}', "");
    Expect(0, 125259, '\P{^Diacritic=yes}', "");
    Expect(1, 125258, '\p{Diacritic=:\Ayes\z:}', "");;
    Expect(0, 125259, '\p{Diacritic=:\Ayes\z:}', "");;
    Expect(1, 125258, '\p{Diacritic=	 yes}', "");
    Expect(0, 125258, '\p{^Diacritic=	 yes}', "");
    Expect(0, 125258, '\P{Diacritic=	 yes}', "");
    Expect(1, 125258, '\P{^Diacritic=	 yes}', "");
    Expect(0, 125259, '\p{Diacritic=	 yes}', "");
    Expect(1, 125259, '\p{^Diacritic=	 yes}', "");
    Expect(1, 125259, '\P{Diacritic=	 yes}', "");
    Expect(0, 125259, '\P{^Diacritic=	 yes}', "");
    Error('\p{Dia=_ Y:=}');
    Error('\P{Dia=_ Y:=}');
    Expect(1, 125258, '\p{Dia=:\AY\z:}', "");;
    Expect(0, 125259, '\p{Dia=:\AY\z:}', "");;
    Expect(1, 125258, '\p{Dia=y}', "");
    Expect(0, 125258, '\p{^Dia=y}', "");
    Expect(0, 125258, '\P{Dia=y}', "");
    Expect(1, 125258, '\P{^Dia=y}', "");
    Expect(0, 125259, '\p{Dia=y}', "");
    Expect(1, 125259, '\p{^Dia=y}', "");
    Expect(1, 125259, '\P{Dia=y}', "");
    Expect(0, 125259, '\P{^Dia=y}', "");
    Expect(1, 125258, '\p{Dia=:\Ay\z:}', "");;
    Expect(0, 125259, '\p{Dia=:\Ay\z:}', "");;
    Expect(1, 125258, '\p{Dia=--Y}', "");
    Expect(0, 125258, '\p{^Dia=--Y}', "");
    Expect(0, 125258, '\P{Dia=--Y}', "");
    Expect(1, 125258, '\P{^Dia=--Y}', "");
    Expect(0, 125259, '\p{Dia=--Y}', "");
    Expect(1, 125259, '\p{^Dia=--Y}', "");
    Expect(1, 125259, '\P{Dia=--Y}', "");
    Expect(0, 125259, '\P{^Dia=--Y}', "");
    Error('\p{Is_Diacritic: /a/_T}');
    Error('\P{Is_Diacritic: /a/_T}');
    Expect(1, 125258, '\p{Is_Diacritic=t}', "");
    Expect(0, 125258, '\p{^Is_Diacritic=t}', "");
    Expect(0, 125258, '\P{Is_Diacritic=t}', "");
    Expect(1, 125258, '\P{^Is_Diacritic=t}', "");
    Expect(0, 125259, '\p{Is_Diacritic=t}', "");
    Expect(1, 125259, '\p{^Is_Diacritic=t}', "");
    Expect(1, 125259, '\P{Is_Diacritic=t}', "");
    Expect(0, 125259, '\P{^Is_Diacritic=t}', "");
    Expect(1, 125258, '\p{Is_Diacritic= T}', "");
    Expect(0, 125258, '\p{^Is_Diacritic= T}', "");
    Expect(0, 125258, '\P{Is_Diacritic= T}', "");
    Expect(1, 125258, '\P{^Is_Diacritic= T}', "");
    Expect(0, 125259, '\p{Is_Diacritic= T}', "");
    Expect(1, 125259, '\p{^Is_Diacritic= T}', "");
    Expect(1, 125259, '\P{Is_Diacritic= T}', "");
    Expect(0, 125259, '\P{^Is_Diacritic= T}', "");
    Error('\p{Is_Dia=-:=true}');
    Error('\P{Is_Dia=-:=true}');
    Expect(1, 125258, '\p{Is_Dia=true}', "");
    Expect(0, 125258, '\p{^Is_Dia=true}', "");
    Expect(0, 125258, '\P{Is_Dia=true}', "");
    Expect(1, 125258, '\P{^Is_Dia=true}', "");
    Expect(0, 125259, '\p{Is_Dia=true}', "");
    Expect(1, 125259, '\p{^Is_Dia=true}', "");
    Expect(1, 125259, '\P{Is_Dia=true}', "");
    Expect(0, 125259, '\P{^Is_Dia=true}', "");
    Expect(1, 125258, '\p{Is_Dia=_ TRUE}', "");
    Expect(0, 125258, '\p{^Is_Dia=_ TRUE}', "");
    Expect(0, 125258, '\P{Is_Dia=_ TRUE}', "");
    Expect(1, 125258, '\P{^Is_Dia=_ TRUE}', "");
    Expect(0, 125259, '\p{Is_Dia=_ TRUE}', "");
    Expect(1, 125259, '\p{^Is_Dia=_ TRUE}', "");
    Expect(1, 125259, '\P{Is_Dia=_ TRUE}', "");
    Expect(0, 125259, '\P{^Is_Dia=_ TRUE}', "");
    Error('\p{decompositionmapping}');
    Error('\P{decompositionmapping}');
    Error('\p{dm}');
    Error('\P{dm}');
    Error('\p{decompositiontype}');
    Error('\P{decompositiontype}');
    Error('\p{dt}');
    Error('\P{dt}');
    Error('\p{Decomposition_Type=_Canonical/a/}');
    Error('\P{Decomposition_Type=_Canonical/a/}');
    Expect(1, 195101, '\p{Decomposition_Type=:\ACanonical\z:}', "");;
    Expect(0, 195102, '\p{Decomposition_Type=:\ACanonical\z:}', "");;
    Expect(1, 195101, '\p{Decomposition_Type=canonical}', "");
    Expect(0, 195101, '\p{^Decomposition_Type=canonical}', "");
    Expect(0, 195101, '\P{Decomposition_Type=canonical}', "");
    Expect(1, 195101, '\P{^Decomposition_Type=canonical}', "");
    Expect(0, 195102, '\p{Decomposition_Type=canonical}', "");
    Expect(1, 195102, '\p{^Decomposition_Type=canonical}', "");
    Expect(1, 195102, '\P{Decomposition_Type=canonical}', "");
    Expect(0, 195102, '\P{^Decomposition_Type=canonical}', "");
    Expect(1, 195101, '\p{Decomposition_Type=:\Acanonical\z:}', "");;
    Expect(0, 195102, '\p{Decomposition_Type=:\Acanonical\z:}', "");;
    Expect(1, 195101, '\p{Decomposition_Type=_-canonical}', "");
    Expect(0, 195101, '\p{^Decomposition_Type=_-canonical}', "");
    Expect(0, 195101, '\P{Decomposition_Type=_-canonical}', "");
    Expect(1, 195101, '\P{^Decomposition_Type=_-canonical}', "");
    Expect(0, 195102, '\p{Decomposition_Type=_-canonical}', "");
    Expect(1, 195102, '\p{^Decomposition_Type=_-canonical}', "");
    Expect(1, 195102, '\P{Decomposition_Type=_-canonical}', "");
    Expect(0, 195102, '\P{^Decomposition_Type=_-canonical}', "");
    Error('\p{Dt=_:=Can}');
    Error('\P{Dt=_:=Can}');
    Expect(1, 195101, '\p{Dt=:\ACan\z:}', "");;
    Expect(0, 195102, '\p{Dt=:\ACan\z:}', "");;
    Expect(1, 195101, '\p{Dt=can}', "");
    Expect(0, 195101, '\p{^Dt=can}', "");
    Expect(0, 195101, '\P{Dt=can}', "");
    Expect(1, 195101, '\P{^Dt=can}', "");
    Expect(0, 195102, '\p{Dt=can}', "");
    Expect(1, 195102, '\p{^Dt=can}', "");
    Expect(1, 195102, '\P{Dt=can}', "");
    Expect(0, 195102, '\P{^Dt=can}', "");
    Expect(1, 195101, '\p{Dt=:\Acan\z:}', "");;
    Expect(0, 195102, '\p{Dt=:\Acan\z:}', "");;
    Expect(1, 195101, '\p{Dt=-can}', "");
    Expect(0, 195101, '\p{^Dt=-can}', "");
    Expect(0, 195101, '\P{Dt=-can}', "");
    Expect(1, 195101, '\P{^Dt=-can}', "");
    Expect(0, 195102, '\p{Dt=-can}', "");
    Expect(1, 195102, '\p{^Dt=-can}', "");
    Expect(1, 195102, '\P{Dt=-can}', "");
    Expect(0, 195102, '\P{^Dt=-can}', "");
    Error('\p{Is_Decomposition_Type=/a/CANONICAL}');
    Error('\P{Is_Decomposition_Type=/a/CANONICAL}');
    Expect(1, 195101, '\p{Is_Decomposition_Type=canonical}', "");
    Expect(0, 195101, '\p{^Is_Decomposition_Type=canonical}', "");
    Expect(0, 195101, '\P{Is_Decomposition_Type=canonical}', "");
    Expect(1, 195101, '\P{^Is_Decomposition_Type=canonical}', "");
    Expect(0, 195102, '\p{Is_Decomposition_Type=canonical}', "");
    Expect(1, 195102, '\p{^Is_Decomposition_Type=canonical}', "");
    Expect(1, 195102, '\P{Is_Decomposition_Type=canonical}', "");
    Expect(0, 195102, '\P{^Is_Decomposition_Type=canonical}', "");
    Expect(1, 195101, '\p{Is_Decomposition_Type= 	Canonical}', "");
    Expect(0, 195101, '\p{^Is_Decomposition_Type= 	Canonical}', "");
    Expect(0, 195101, '\P{Is_Decomposition_Type= 	Canonical}', "");
    Expect(1, 195101, '\P{^Is_Decomposition_Type= 	Canonical}', "");
    Expect(0, 195102, '\p{Is_Decomposition_Type= 	Canonical}', "");
    Expect(1, 195102, '\p{^Is_Decomposition_Type= 	Canonical}', "");
    Expect(1, 195102, '\P{Is_Decomposition_Type= 	Canonical}', "");
    Expect(0, 195102, '\P{^Is_Decomposition_Type= 	Canonical}', "");
    Error('\p{Is_Dt=/a/_can}');
    Error('\P{Is_Dt=/a/_can}');
    Expect(1, 195101, '\p{Is_Dt=can}', "");
    Expect(0, 195101, '\p{^Is_Dt=can}', "");
    Expect(0, 195101, '\P{Is_Dt=can}', "");
    Expect(1, 195101, '\P{^Is_Dt=can}', "");
    Expect(0, 195102, '\p{Is_Dt=can}', "");
    Expect(1, 195102, '\p{^Is_Dt=can}', "");
    Expect(1, 195102, '\P{Is_Dt=can}', "");
    Expect(0, 195102, '\P{^Is_Dt=can}', "");
    Expect(1, 195101, '\p{Is_Dt=__Can}', "");
    Expect(0, 195101, '\p{^Is_Dt=__Can}', "");
    Expect(0, 195101, '\P{Is_Dt=__Can}', "");
    Expect(1, 195101, '\P{^Is_Dt=__Can}', "");
    Expect(0, 195102, '\p{Is_Dt=__Can}', "");
    Expect(1, 195102, '\p{^Is_Dt=__Can}', "");
    Expect(1, 195102, '\P{Is_Dt=__Can}', "");
    Expect(0, 195102, '\P{^Is_Dt=__Can}', "");
    Error('\p{Decomposition_Type:	:=Compat}');
    Error('\P{Decomposition_Type:	:=Compat}');
    Expect(1, 127560, '\p{Decomposition_Type=:\ACompat\z:}', "");;
    Expect(0, 127561, '\p{Decomposition_Type=:\ACompat\z:}', "");;
    Expect(1, 127560, '\p{Decomposition_Type=compat}', "");
    Expect(0, 127560, '\p{^Decomposition_Type=compat}', "");
    Expect(0, 127560, '\P{Decomposition_Type=compat}', "");
    Expect(1, 127560, '\P{^Decomposition_Type=compat}', "");
    Expect(0, 127561, '\p{Decomposition_Type=compat}', "");
    Expect(1, 127561, '\p{^Decomposition_Type=compat}', "");
    Expect(1, 127561, '\P{Decomposition_Type=compat}', "");
    Expect(0, 127561, '\P{^Decomposition_Type=compat}', "");
    Expect(1, 127560, '\p{Decomposition_Type=:\Acompat\z:}', "");;
    Expect(0, 127561, '\p{Decomposition_Type=:\Acompat\z:}', "");;
    Expect(1, 127560, '\p{Decomposition_Type=-COMPAT}', "");
    Expect(0, 127560, '\p{^Decomposition_Type=-COMPAT}', "");
    Expect(0, 127560, '\P{Decomposition_Type=-COMPAT}', "");
    Expect(1, 127560, '\P{^Decomposition_Type=-COMPAT}', "");
    Expect(0, 127561, '\p{Decomposition_Type=-COMPAT}', "");
    Expect(1, 127561, '\p{^Decomposition_Type=-COMPAT}', "");
    Expect(1, 127561, '\P{Decomposition_Type=-COMPAT}', "");
    Expect(0, 127561, '\P{^Decomposition_Type=-COMPAT}', "");
    Error('\p{Dt=_-COM:=}');
    Error('\P{Dt=_-COM:=}');
    Expect(1, 127560, '\p{Dt=:\ACom\z:}', "");;
    Expect(0, 127561, '\p{Dt=:\ACom\z:}', "");;
    Expect(1, 127560, '\p{Dt=com}', "");
    Expect(0, 127560, '\p{^Dt=com}', "");
    Expect(0, 127560, '\P{Dt=com}', "");
    Expect(1, 127560, '\P{^Dt=com}', "");
    Expect(0, 127561, '\p{Dt=com}', "");
    Expect(1, 127561, '\p{^Dt=com}', "");
    Expect(1, 127561, '\P{Dt=com}', "");
    Expect(0, 127561, '\P{^Dt=com}', "");
    Expect(1, 127560, '\p{Dt=:\Acom\z:}', "");;
    Expect(0, 127561, '\p{Dt=:\Acom\z:}', "");;
    Expect(1, 127560, '\p{Dt=-_Com}', "");
    Expect(0, 127560, '\p{^Dt=-_Com}', "");
    Expect(0, 127560, '\P{Dt=-_Com}', "");
    Expect(1, 127560, '\P{^Dt=-_Com}', "");
    Expect(0, 127561, '\p{Dt=-_Com}', "");
    Expect(1, 127561, '\p{^Dt=-_Com}', "");
    Expect(1, 127561, '\P{Dt=-_Com}', "");
    Expect(0, 127561, '\P{^Dt=-_Com}', "");
    Error('\p{Is_Decomposition_Type=:=_ COMPAT}');
    Error('\P{Is_Decomposition_Type=:=_ COMPAT}');
    Expect(1, 127560, '\p{Is_Decomposition_Type=compat}', "");
    Expect(0, 127560, '\p{^Is_Decomposition_Type=compat}', "");
    Expect(0, 127560, '\P{Is_Decomposition_Type=compat}', "");
    Expect(1, 127560, '\P{^Is_Decomposition_Type=compat}', "");
    Expect(0, 127561, '\p{Is_Decomposition_Type=compat}', "");
    Expect(1, 127561, '\p{^Is_Decomposition_Type=compat}', "");
    Expect(1, 127561, '\P{Is_Decomposition_Type=compat}', "");
    Expect(0, 127561, '\P{^Is_Decomposition_Type=compat}', "");
    Expect(1, 127560, '\p{Is_Decomposition_Type=-_Compat}', "");
    Expect(0, 127560, '\p{^Is_Decomposition_Type=-_Compat}', "");
    Expect(0, 127560, '\P{Is_Decomposition_Type=-_Compat}', "");
    Expect(1, 127560, '\P{^Is_Decomposition_Type=-_Compat}', "");
    Expect(0, 127561, '\p{Is_Decomposition_Type=-_Compat}', "");
    Expect(1, 127561, '\p{^Is_Decomposition_Type=-_Compat}', "");
    Expect(1, 127561, '\P{Is_Decomposition_Type=-_Compat}', "");
    Expect(0, 127561, '\P{^Is_Decomposition_Type=-_Compat}', "");
    Error('\p{Is_Dt=		COM/a/}');
    Error('\P{Is_Dt=		COM/a/}');
    Expect(1, 127560, '\p{Is_Dt=com}', "");
    Expect(0, 127560, '\p{^Is_Dt=com}', "");
    Expect(0, 127560, '\P{Is_Dt=com}', "");
    Expect(1, 127560, '\P{^Is_Dt=com}', "");
    Expect(0, 127561, '\p{Is_Dt=com}', "");
    Expect(1, 127561, '\p{^Is_Dt=com}', "");
    Expect(1, 127561, '\P{Is_Dt=com}', "");
    Expect(0, 127561, '\P{^Is_Dt=com}', "");
    Expect(1, 127560, '\p{Is_Dt=		com}', "");
    Expect(0, 127560, '\p{^Is_Dt=		com}', "");
    Expect(0, 127560, '\P{Is_Dt=		com}', "");
    Expect(1, 127560, '\P{^Is_Dt=		com}', "");
    Expect(0, 127561, '\p{Is_Dt=		com}', "");
    Expect(1, 127561, '\p{^Is_Dt=		com}', "");
    Expect(1, 127561, '\P{Is_Dt=		com}', "");
    Expect(0, 127561, '\P{^Is_Dt=		com}', "");
    Error('\p{Decomposition_Type=-:=circle}');
    Error('\P{Decomposition_Type=-:=circle}');
    Expect(1, 127569, '\p{Decomposition_Type=:\ACircle\z:}', "");;
    Expect(0, 127570, '\p{Decomposition_Type=:\ACircle\z:}', "");;
    Expect(1, 127569, '\p{Decomposition_Type=circle}', "");
    Expect(0, 127569, '\p{^Decomposition_Type=circle}', "");
    Expect(0, 127569, '\P{Decomposition_Type=circle}', "");
    Expect(1, 127569, '\P{^Decomposition_Type=circle}', "");
    Expect(0, 127570, '\p{Decomposition_Type=circle}', "");
    Expect(1, 127570, '\p{^Decomposition_Type=circle}', "");
    Expect(1, 127570, '\P{Decomposition_Type=circle}', "");
    Expect(0, 127570, '\P{^Decomposition_Type=circle}', "");
    Expect(1, 127569, '\p{Decomposition_Type=:\Acircle\z:}', "");;
    Expect(0, 127570, '\p{Decomposition_Type=:\Acircle\z:}', "");;
    Expect(1, 127569, '\p{Decomposition_Type=-CIRCLE}', "");
    Expect(0, 127569, '\p{^Decomposition_Type=-CIRCLE}', "");
    Expect(0, 127569, '\P{Decomposition_Type=-CIRCLE}', "");
    Expect(1, 127569, '\P{^Decomposition_Type=-CIRCLE}', "");
    Expect(0, 127570, '\p{Decomposition_Type=-CIRCLE}', "");
    Expect(1, 127570, '\p{^Decomposition_Type=-CIRCLE}', "");
    Expect(1, 127570, '\P{Decomposition_Type=-CIRCLE}', "");
    Expect(0, 127570, '\P{^Decomposition_Type=-CIRCLE}', "");
    Error('\p{Dt=:=_Enc}');
    Error('\P{Dt=:=_Enc}');
    Expect(1, 127569, '\p{Dt=:\AEnc\z:}', "");;
    Expect(0, 127570, '\p{Dt=:\AEnc\z:}', "");;
    Expect(1, 127569, '\p{Dt=enc}', "");
    Expect(0, 127569, '\p{^Dt=enc}', "");
    Expect(0, 127569, '\P{Dt=enc}', "");
    Expect(1, 127569, '\P{^Dt=enc}', "");
    Expect(0, 127570, '\p{Dt=enc}', "");
    Expect(1, 127570, '\p{^Dt=enc}', "");
    Expect(1, 127570, '\P{Dt=enc}', "");
    Expect(0, 127570, '\P{^Dt=enc}', "");
    Expect(1, 127569, '\p{Dt=:\Aenc\z:}', "");;
    Expect(0, 127570, '\p{Dt=:\Aenc\z:}', "");;
    Expect(1, 127569, '\p{Dt=	Enc}', "");
    Expect(0, 127569, '\p{^Dt=	Enc}', "");
    Expect(0, 127569, '\P{Dt=	Enc}', "");
    Expect(1, 127569, '\P{^Dt=	Enc}', "");
    Expect(0, 127570, '\p{Dt=	Enc}', "");
    Expect(1, 127570, '\p{^Dt=	Enc}', "");
    Expect(1, 127570, '\P{Dt=	Enc}', "");
    Expect(0, 127570, '\P{^Dt=	Enc}', "");
    Error('\p{Is_Decomposition_Type:	/a/  circle}');
    Error('\P{Is_Decomposition_Type:	/a/  circle}');
    Expect(1, 127569, '\p{Is_Decomposition_Type=circle}', "");
    Expect(0, 127569, '\p{^Is_Decomposition_Type=circle}', "");
    Expect(0, 127569, '\P{Is_Decomposition_Type=circle}', "");
    Expect(1, 127569, '\P{^Is_Decomposition_Type=circle}', "");
    Expect(0, 127570, '\p{Is_Decomposition_Type=circle}', "");
    Expect(1, 127570, '\p{^Is_Decomposition_Type=circle}', "");
    Expect(1, 127570, '\P{Is_Decomposition_Type=circle}', "");
    Expect(0, 127570, '\P{^Is_Decomposition_Type=circle}', "");
    Expect(1, 127569, '\p{Is_Decomposition_Type=_circle}', "");
    Expect(0, 127569, '\p{^Is_Decomposition_Type=_circle}', "");
    Expect(0, 127569, '\P{Is_Decomposition_Type=_circle}', "");
    Expect(1, 127569, '\P{^Is_Decomposition_Type=_circle}', "");
    Expect(0, 127570, '\p{Is_Decomposition_Type=_circle}', "");
    Expect(1, 127570, '\p{^Is_Decomposition_Type=_circle}', "");
    Expect(1, 127570, '\P{Is_Decomposition_Type=_circle}', "");
    Expect(0, 127570, '\P{^Is_Decomposition_Type=_circle}', "");
    Error('\p{Is_Dt=_	enc/a/}');
    Error('\P{Is_Dt=_	enc/a/}');
    Expect(1, 127569, '\p{Is_Dt=enc}', "");
    Expect(0, 127569, '\p{^Is_Dt=enc}', "");
    Expect(0, 127569, '\P{Is_Dt=enc}', "");
    Expect(1, 127569, '\P{^Is_Dt=enc}', "");
    Expect(0, 127570, '\p{Is_Dt=enc}', "");
    Expect(1, 127570, '\p{^Is_Dt=enc}', "");
    Expect(1, 127570, '\P{Is_Dt=enc}', "");
    Expect(0, 127570, '\P{^Is_Dt=enc}', "");
    Expect(1, 127569, '\p{Is_Dt=	_ENC}', "");
    Expect(0, 127569, '\p{^Is_Dt=	_ENC}', "");
    Expect(0, 127569, '\P{Is_Dt=	_ENC}', "");
    Expect(1, 127569, '\P{^Is_Dt=	_ENC}', "");
    Expect(0, 127570, '\p{Is_Dt=	_ENC}', "");
    Expect(1, 127570, '\p{^Is_Dt=	_ENC}', "");
    Expect(1, 127570, '\P{Is_Dt=	_ENC}', "");
    Expect(0, 127570, '\P{^Is_Dt=	_ENC}', "");
    Error('\p{Decomposition_Type=_/a/final}');
    Error('\P{Decomposition_Type=_/a/final}');
    Expect(1, 65276, '\p{Decomposition_Type=:\AFinal\z:}', "");;
    Expect(0, 65277, '\p{Decomposition_Type=:\AFinal\z:}', "");;
    Expect(1, 65276, '\p{Decomposition_Type=final}', "");
    Expect(0, 65276, '\p{^Decomposition_Type=final}', "");
    Expect(0, 65276, '\P{Decomposition_Type=final}', "");
    Expect(1, 65276, '\P{^Decomposition_Type=final}', "");
    Expect(0, 65277, '\p{Decomposition_Type=final}', "");
    Expect(1, 65277, '\p{^Decomposition_Type=final}', "");
    Expect(1, 65277, '\P{Decomposition_Type=final}', "");
    Expect(0, 65277, '\P{^Decomposition_Type=final}', "");
    Expect(1, 65276, '\p{Decomposition_Type=:\Afinal\z:}', "");;
    Expect(0, 65277, '\p{Decomposition_Type=:\Afinal\z:}', "");;
    Expect(1, 65276, '\p{Decomposition_Type= Final}', "");
    Expect(0, 65276, '\p{^Decomposition_Type= Final}', "");
    Expect(0, 65276, '\P{Decomposition_Type= Final}', "");
    Expect(1, 65276, '\P{^Decomposition_Type= Final}', "");
    Expect(0, 65277, '\p{Decomposition_Type= Final}', "");
    Expect(1, 65277, '\p{^Decomposition_Type= Final}', "");
    Expect(1, 65277, '\P{Decomposition_Type= Final}', "");
    Expect(0, 65277, '\P{^Decomposition_Type= Final}', "");
    Error('\p{Dt=:=-fin}');
    Error('\P{Dt=:=-fin}');
    Expect(1, 65276, '\p{Dt=:\AFin\z:}', "");;
    Expect(0, 65277, '\p{Dt=:\AFin\z:}', "");;
    Expect(1, 65276, '\p{Dt:	fin}', "");
    Expect(0, 65276, '\p{^Dt:	fin}', "");
    Expect(0, 65276, '\P{Dt:	fin}', "");
    Expect(1, 65276, '\P{^Dt:	fin}', "");
    Expect(0, 65277, '\p{Dt:	fin}', "");
    Expect(1, 65277, '\p{^Dt:	fin}', "");
    Expect(1, 65277, '\P{Dt:	fin}', "");
    Expect(0, 65277, '\P{^Dt:	fin}', "");
    Expect(1, 65276, '\p{Dt=:\Afin\z:}', "");;
    Expect(0, 65277, '\p{Dt=:\Afin\z:}', "");;
    Expect(1, 65276, '\p{Dt=__FIN}', "");
    Expect(0, 65276, '\p{^Dt=__FIN}', "");
    Expect(0, 65276, '\P{Dt=__FIN}', "");
    Expect(1, 65276, '\P{^Dt=__FIN}', "");
    Expect(0, 65277, '\p{Dt=__FIN}', "");
    Expect(1, 65277, '\p{^Dt=__FIN}', "");
    Expect(1, 65277, '\P{Dt=__FIN}', "");
    Expect(0, 65277, '\P{^Dt=__FIN}', "");
    Error('\p{Is_Decomposition_Type=	/a/FINAL}');
    Error('\P{Is_Decomposition_Type=	/a/FINAL}');
    Expect(1, 65276, '\p{Is_Decomposition_Type=final}', "");
    Expect(0, 65276, '\p{^Is_Decomposition_Type=final}', "");
    Expect(0, 65276, '\P{Is_Decomposition_Type=final}', "");
    Expect(1, 65276, '\P{^Is_Decomposition_Type=final}', "");
    Expect(0, 65277, '\p{Is_Decomposition_Type=final}', "");
    Expect(1, 65277, '\p{^Is_Decomposition_Type=final}', "");
    Expect(1, 65277, '\P{Is_Decomposition_Type=final}', "");
    Expect(0, 65277, '\P{^Is_Decomposition_Type=final}', "");
    Expect(1, 65276, '\p{Is_Decomposition_Type:	Final}', "");
    Expect(0, 65276, '\p{^Is_Decomposition_Type:	Final}', "");
    Expect(0, 65276, '\P{Is_Decomposition_Type:	Final}', "");
    Expect(1, 65276, '\P{^Is_Decomposition_Type:	Final}', "");
    Expect(0, 65277, '\p{Is_Decomposition_Type:	Final}', "");
    Expect(1, 65277, '\p{^Is_Decomposition_Type:	Final}', "");
    Expect(1, 65277, '\P{Is_Decomposition_Type:	Final}', "");
    Expect(0, 65277, '\P{^Is_Decomposition_Type:	Final}', "");
    Error('\p{Is_Dt=  Fin:=}');
    Error('\P{Is_Dt=  Fin:=}');
    Expect(1, 65276, '\p{Is_Dt=fin}', "");
    Expect(0, 65276, '\p{^Is_Dt=fin}', "");
    Expect(0, 65276, '\P{Is_Dt=fin}', "");
    Expect(1, 65276, '\P{^Is_Dt=fin}', "");
    Expect(0, 65277, '\p{Is_Dt=fin}', "");
    Expect(1, 65277, '\p{^Is_Dt=fin}', "");
    Expect(1, 65277, '\P{Is_Dt=fin}', "");
    Expect(0, 65277, '\P{^Is_Dt=fin}', "");
    Expect(1, 65276, '\p{Is_Dt=-	FIN}', "");
    Expect(0, 65276, '\p{^Is_Dt=-	FIN}', "");
    Expect(0, 65276, '\P{Is_Dt=-	FIN}', "");
    Expect(1, 65276, '\P{^Is_Dt=-	FIN}', "");
    Expect(0, 65277, '\p{Is_Dt=-	FIN}', "");
    Expect(1, 65277, '\p{^Is_Dt=-	FIN}', "");
    Expect(1, 65277, '\P{Is_Dt=-	FIN}', "");
    Expect(0, 65277, '\P{^Is_Dt=-	FIN}', "");
    Error('\p{Decomposition_Type= _Font:=}');
    Error('\P{Decomposition_Type= _Font:=}');
    Expect(1, 130041, '\p{Decomposition_Type=:\AFont\z:}', "");;
    Expect(0, 130042, '\p{Decomposition_Type=:\AFont\z:}', "");;
    Expect(1, 130041, '\p{Decomposition_Type=font}', "");
    Expect(0, 130041, '\p{^Decomposition_Type=font}', "");
    Expect(0, 130041, '\P{Decomposition_Type=font}', "");
    Expect(1, 130041, '\P{^Decomposition_Type=font}', "");
    Expect(0, 130042, '\p{Decomposition_Type=font}', "");
    Expect(1, 130042, '\p{^Decomposition_Type=font}', "");
    Expect(1, 130042, '\P{Decomposition_Type=font}', "");
    Expect(0, 130042, '\P{^Decomposition_Type=font}', "");
    Expect(1, 130041, '\p{Decomposition_Type=:\Afont\z:}', "");;
    Expect(0, 130042, '\p{Decomposition_Type=:\Afont\z:}', "");;
    Expect(1, 130041, '\p{Decomposition_Type=	-Font}', "");
    Expect(0, 130041, '\p{^Decomposition_Type=	-Font}', "");
    Expect(0, 130041, '\P{Decomposition_Type=	-Font}', "");
    Expect(1, 130041, '\P{^Decomposition_Type=	-Font}', "");
    Expect(0, 130042, '\p{Decomposition_Type=	-Font}', "");
    Expect(1, 130042, '\p{^Decomposition_Type=	-Font}', "");
    Expect(1, 130042, '\P{Decomposition_Type=	-Font}', "");
    Expect(0, 130042, '\P{^Decomposition_Type=	-Font}', "");
    Error('\p{Dt=-:=font}');
    Error('\P{Dt=-:=font}');
    Expect(1, 130041, '\p{Dt=:\AFont\z:}', "");;
    Expect(0, 130042, '\p{Dt=:\AFont\z:}', "");;
    Expect(1, 130041, '\p{Dt=font}', "");
    Expect(0, 130041, '\p{^Dt=font}', "");
    Expect(0, 130041, '\P{Dt=font}', "");
    Expect(1, 130041, '\P{^Dt=font}', "");
    Expect(0, 130042, '\p{Dt=font}', "");
    Expect(1, 130042, '\p{^Dt=font}', "");
    Expect(1, 130042, '\P{Dt=font}', "");
    Expect(0, 130042, '\P{^Dt=font}', "");
    Expect(1, 130041, '\p{Dt=:\Afont\z:}', "");;
    Expect(0, 130042, '\p{Dt=:\Afont\z:}', "");;
    Expect(1, 130041, '\p{Dt=_Font}', "");
    Expect(0, 130041, '\p{^Dt=_Font}', "");
    Expect(0, 130041, '\P{Dt=_Font}', "");
    Expect(1, 130041, '\P{^Dt=_Font}', "");
    Expect(0, 130042, '\p{Dt=_Font}', "");
    Expect(1, 130042, '\p{^Dt=_Font}', "");
    Expect(1, 130042, '\P{Dt=_Font}', "");
    Expect(0, 130042, '\P{^Dt=_Font}', "");
    Error('\p{Is_Decomposition_Type=:=Font}');
    Error('\P{Is_Decomposition_Type=:=Font}');
    Expect(1, 130041, '\p{Is_Decomposition_Type=font}', "");
    Expect(0, 130041, '\p{^Is_Decomposition_Type=font}', "");
    Expect(0, 130041, '\P{Is_Decomposition_Type=font}', "");
    Expect(1, 130041, '\P{^Is_Decomposition_Type=font}', "");
    Expect(0, 130042, '\p{Is_Decomposition_Type=font}', "");
    Expect(1, 130042, '\p{^Is_Decomposition_Type=font}', "");
    Expect(1, 130042, '\P{Is_Decomposition_Type=font}', "");
    Expect(0, 130042, '\P{^Is_Decomposition_Type=font}', "");
    Expect(1, 130041, '\p{Is_Decomposition_Type:	FONT}', "");
    Expect(0, 130041, '\p{^Is_Decomposition_Type:	FONT}', "");
    Expect(0, 130041, '\P{Is_Decomposition_Type:	FONT}', "");
    Expect(1, 130041, '\P{^Is_Decomposition_Type:	FONT}', "");
    Expect(0, 130042, '\p{Is_Decomposition_Type:	FONT}', "");
    Expect(1, 130042, '\p{^Is_Decomposition_Type:	FONT}', "");
    Expect(1, 130042, '\P{Is_Decomposition_Type:	FONT}', "");
    Expect(0, 130042, '\P{^Is_Decomposition_Type:	FONT}', "");
    Error('\p{Is_Dt=:= -font}');
    Error('\P{Is_Dt=:= -font}');
    Expect(1, 130041, '\p{Is_Dt=font}', "");
    Expect(0, 130041, '\p{^Is_Dt=font}', "");
    Expect(0, 130041, '\P{Is_Dt=font}', "");
    Expect(1, 130041, '\P{^Is_Dt=font}', "");
    Expect(0, 130042, '\p{Is_Dt=font}', "");
    Expect(1, 130042, '\p{^Is_Dt=font}', "");
    Expect(1, 130042, '\P{Is_Dt=font}', "");
    Expect(0, 130042, '\P{^Is_Dt=font}', "");
    Expect(1, 130041, '\p{Is_Dt=_ Font}', "");
    Expect(0, 130041, '\p{^Is_Dt=_ Font}', "");
    Expect(0, 130041, '\P{Is_Dt=_ Font}', "");
    Expect(1, 130041, '\P{^Is_Dt=_ Font}', "");
    Expect(0, 130042, '\p{Is_Dt=_ Font}', "");
    Expect(1, 130042, '\p{^Is_Dt=_ Font}', "");
    Expect(1, 130042, '\P{Is_Dt=_ Font}', "");
    Expect(0, 130042, '\P{^Is_Dt=_ Font}', "");
    Error('\p{Decomposition_Type::=--FRACTION}');
    Error('\P{Decomposition_Type::=--FRACTION}');
    Expect(1, 8585, '\p{Decomposition_Type=:\AFraction\z:}', "");;
    Expect(0, 8586, '\p{Decomposition_Type=:\AFraction\z:}', "");;
    Expect(1, 8585, '\p{Decomposition_Type=fraction}', "");
    Expect(0, 8585, '\p{^Decomposition_Type=fraction}', "");
    Expect(0, 8585, '\P{Decomposition_Type=fraction}', "");
    Expect(1, 8585, '\P{^Decomposition_Type=fraction}', "");
    Expect(0, 8586, '\p{Decomposition_Type=fraction}', "");
    Expect(1, 8586, '\p{^Decomposition_Type=fraction}', "");
    Expect(1, 8586, '\P{Decomposition_Type=fraction}', "");
    Expect(0, 8586, '\P{^Decomposition_Type=fraction}', "");
    Expect(1, 8585, '\p{Decomposition_Type=:\Afraction\z:}', "");;
    Expect(0, 8586, '\p{Decomposition_Type=:\Afraction\z:}', "");;
    Error('\p{Dt= /a/Fra}');
    Error('\P{Dt= /a/Fra}');
    Expect(1, 8585, '\p{Dt=:\AFra\z:}', "");;
    Expect(0, 8586, '\p{Dt=:\AFra\z:}', "");;
    Expect(1, 8585, '\p{Dt=fra}', "");
    Expect(0, 8585, '\p{^Dt=fra}', "");
    Expect(0, 8585, '\P{Dt=fra}', "");
    Expect(1, 8585, '\P{^Dt=fra}', "");
    Expect(0, 8586, '\p{Dt=fra}', "");
    Expect(1, 8586, '\p{^Dt=fra}', "");
    Expect(1, 8586, '\P{Dt=fra}', "");
    Expect(0, 8586, '\P{^Dt=fra}', "");
    Expect(1, 8585, '\p{Dt=:\Afra\z:}', "");;
    Expect(0, 8586, '\p{Dt=:\Afra\z:}', "");;
    Expect(1, 8585, '\p{Dt=_Fra}', "");
    Expect(0, 8585, '\p{^Dt=_Fra}', "");
    Expect(0, 8585, '\P{Dt=_Fra}', "");
    Expect(1, 8585, '\P{^Dt=_Fra}', "");
    Expect(0, 8586, '\p{Dt=_Fra}', "");
    Expect(1, 8586, '\p{^Dt=_Fra}', "");
    Expect(1, 8586, '\P{Dt=_Fra}', "");
    Expect(0, 8586, '\P{^Dt=_Fra}', "");
    Error('\p{Is_Decomposition_Type=	-Fraction/a/}');
    Error('\P{Is_Decomposition_Type=	-Fraction/a/}');
    Expect(1, 8585, '\p{Is_Decomposition_Type=fraction}', "");
    Expect(0, 8585, '\p{^Is_Decomposition_Type=fraction}', "");
    Expect(0, 8585, '\P{Is_Decomposition_Type=fraction}', "");
    Expect(1, 8585, '\P{^Is_Decomposition_Type=fraction}', "");
    Expect(0, 8586, '\p{Is_Decomposition_Type=fraction}', "");
    Expect(1, 8586, '\p{^Is_Decomposition_Type=fraction}', "");
    Expect(1, 8586, '\P{Is_Decomposition_Type=fraction}', "");
    Expect(0, 8586, '\P{^Is_Decomposition_Type=fraction}', "");
    Expect(1, 8585, '\p{Is_Decomposition_Type=	_FRACTION}', "");
    Expect(0, 8585, '\p{^Is_Decomposition_Type=	_FRACTION}', "");
    Expect(0, 8585, '\P{Is_Decomposition_Type=	_FRACTION}', "");
    Expect(1, 8585, '\P{^Is_Decomposition_Type=	_FRACTION}', "");
    Expect(0, 8586, '\p{Is_Decomposition_Type=	_FRACTION}', "");
    Expect(1, 8586, '\p{^Is_Decomposition_Type=	_FRACTION}', "");
    Expect(1, 8586, '\P{Is_Decomposition_Type=	_FRACTION}', "");
    Expect(0, 8586, '\P{^Is_Decomposition_Type=	_FRACTION}', "");
    Error('\p{Is_Dt:	 Fra:=}');
    Error('\P{Is_Dt:	 Fra:=}');
    Expect(1, 8585, '\p{Is_Dt=fra}', "");
    Expect(0, 8585, '\p{^Is_Dt=fra}', "");
    Expect(0, 8585, '\P{Is_Dt=fra}', "");
    Expect(1, 8585, '\P{^Is_Dt=fra}', "");
    Expect(0, 8586, '\p{Is_Dt=fra}', "");
    Expect(1, 8586, '\p{^Is_Dt=fra}', "");
    Expect(1, 8586, '\P{Is_Dt=fra}', "");
    Expect(0, 8586, '\P{^Is_Dt=fra}', "");
    Expect(1, 8585, '\p{Is_Dt=	-Fra}', "");
    Expect(0, 8585, '\p{^Is_Dt=	-Fra}', "");
    Expect(0, 8585, '\P{Is_Dt=	-Fra}', "");
    Expect(1, 8585, '\P{^Is_Dt=	-Fra}', "");
    Expect(0, 8586, '\p{Is_Dt=	-Fra}', "");
    Expect(1, 8586, '\p{^Is_Dt=	-Fra}', "");
    Expect(1, 8586, '\P{Is_Dt=	-Fra}', "");
    Expect(0, 8586, '\P{^Is_Dt=	-Fra}', "");
    Error('\p{Decomposition_Type= -INITIAL/a/}');
    Error('\P{Decomposition_Type= -INITIAL/a/}');
    Expect(1, 65267, '\p{Decomposition_Type=:\AInitial\z:}', "");;
    Expect(0, 65268, '\p{Decomposition_Type=:\AInitial\z:}', "");;
    Expect(1, 65267, '\p{Decomposition_Type=initial}', "");
    Expect(0, 65267, '\p{^Decomposition_Type=initial}', "");
    Expect(0, 65267, '\P{Decomposition_Type=initial}', "");
    Expect(1, 65267, '\P{^Decomposition_Type=initial}', "");
    Expect(0, 65268, '\p{Decomposition_Type=initial}', "");
    Expect(1, 65268, '\p{^Decomposition_Type=initial}', "");
    Expect(1, 65268, '\P{Decomposition_Type=initial}', "");
    Expect(0, 65268, '\P{^Decomposition_Type=initial}', "");
    Expect(1, 65267, '\p{Decomposition_Type=:\Ainitial\z:}', "");;
    Expect(0, 65268, '\p{Decomposition_Type=:\Ainitial\z:}', "");;
    Expect(1, 65267, '\p{Decomposition_Type=_initial}', "");
    Expect(0, 65267, '\p{^Decomposition_Type=_initial}', "");
    Expect(0, 65267, '\P{Decomposition_Type=_initial}', "");
    Expect(1, 65267, '\P{^Decomposition_Type=_initial}', "");
    Expect(0, 65268, '\p{Decomposition_Type=_initial}', "");
    Expect(1, 65268, '\p{^Decomposition_Type=_initial}', "");
    Expect(1, 65268, '\P{Decomposition_Type=_initial}', "");
    Expect(0, 65268, '\P{^Decomposition_Type=_initial}', "");
    Error('\p{Dt=	init:=}');
    Error('\P{Dt=	init:=}');
    Expect(1, 65267, '\p{Dt=:\AInit\z:}', "");;
    Expect(0, 65268, '\p{Dt=:\AInit\z:}', "");;
    Expect(1, 65267, '\p{Dt=init}', "");
    Expect(0, 65267, '\p{^Dt=init}', "");
    Expect(0, 65267, '\P{Dt=init}', "");
    Expect(1, 65267, '\P{^Dt=init}', "");
    Expect(0, 65268, '\p{Dt=init}', "");
    Expect(1, 65268, '\p{^Dt=init}', "");
    Expect(1, 65268, '\P{Dt=init}', "");
    Expect(0, 65268, '\P{^Dt=init}', "");
    Expect(1, 65267, '\p{Dt=:\Ainit\z:}', "");;
    Expect(0, 65268, '\p{Dt=:\Ainit\z:}', "");;
    Expect(1, 65267, '\p{Dt= _init}', "");
    Expect(0, 65267, '\p{^Dt= _init}', "");
    Expect(0, 65267, '\P{Dt= _init}', "");
    Expect(1, 65267, '\P{^Dt= _init}', "");
    Expect(0, 65268, '\p{Dt= _init}', "");
    Expect(1, 65268, '\p{^Dt= _init}', "");
    Expect(1, 65268, '\P{Dt= _init}', "");
    Expect(0, 65268, '\P{^Dt= _init}', "");
    Error('\p{Is_Decomposition_Type= INITIAL/a/}');
    Error('\P{Is_Decomposition_Type= INITIAL/a/}');
    Expect(1, 65267, '\p{Is_Decomposition_Type=initial}', "");
    Expect(0, 65267, '\p{^Is_Decomposition_Type=initial}', "");
    Expect(0, 65267, '\P{Is_Decomposition_Type=initial}', "");
    Expect(1, 65267, '\P{^Is_Decomposition_Type=initial}', "");
    Expect(0, 65268, '\p{Is_Decomposition_Type=initial}', "");
    Expect(1, 65268, '\p{^Is_Decomposition_Type=initial}', "");
    Expect(1, 65268, '\P{Is_Decomposition_Type=initial}', "");
    Expect(0, 65268, '\P{^Is_Decomposition_Type=initial}', "");
    Expect(1, 65267, '\p{Is_Decomposition_Type=Initial}', "");
    Expect(0, 65267, '\p{^Is_Decomposition_Type=Initial}', "");
    Expect(0, 65267, '\P{Is_Decomposition_Type=Initial}', "");
    Expect(1, 65267, '\P{^Is_Decomposition_Type=Initial}', "");
    Expect(0, 65268, '\p{Is_Decomposition_Type=Initial}', "");
    Expect(1, 65268, '\p{^Is_Decomposition_Type=Initial}', "");
    Expect(1, 65268, '\P{Is_Decomposition_Type=Initial}', "");
    Expect(0, 65268, '\P{^Is_Decomposition_Type=Initial}', "");
    Error('\p{Is_Dt=_INIT/a/}');
    Error('\P{Is_Dt=_INIT/a/}');
    Expect(1, 65267, '\p{Is_Dt=init}', "");
    Expect(0, 65267, '\p{^Is_Dt=init}', "");
    Expect(0, 65267, '\P{Is_Dt=init}', "");
    Expect(1, 65267, '\P{^Is_Dt=init}', "");
    Expect(0, 65268, '\p{Is_Dt=init}', "");
    Expect(1, 65268, '\p{^Is_Dt=init}', "");
    Expect(1, 65268, '\P{Is_Dt=init}', "");
    Expect(0, 65268, '\P{^Is_Dt=init}', "");
    Expect(1, 65267, '\p{Is_Dt=_INIT}', "");
    Expect(0, 65267, '\p{^Is_Dt=_INIT}', "");
    Expect(0, 65267, '\P{Is_Dt=_INIT}', "");
    Expect(1, 65267, '\P{^Is_Dt=_INIT}', "");
    Expect(0, 65268, '\p{Is_Dt=_INIT}', "");
    Expect(1, 65268, '\p{^Is_Dt=_INIT}', "");
    Expect(1, 65268, '\P{Is_Dt=_INIT}', "");
    Expect(0, 65268, '\P{^Is_Dt=_INIT}', "");
    Error('\p{Decomposition_Type= _ISOLATED/a/}');
    Error('\P{Decomposition_Type= _ISOLATED/a/}');
    Expect(1, 65275, '\p{Decomposition_Type=:\AIsolated\z:}', "");;
    Expect(0, 65276, '\p{Decomposition_Type=:\AIsolated\z:}', "");;
    Expect(1, 65275, '\p{Decomposition_Type=isolated}', "");
    Expect(0, 65275, '\p{^Decomposition_Type=isolated}', "");
    Expect(0, 65275, '\P{Decomposition_Type=isolated}', "");
    Expect(1, 65275, '\P{^Decomposition_Type=isolated}', "");
    Expect(0, 65276, '\p{Decomposition_Type=isolated}', "");
    Expect(1, 65276, '\p{^Decomposition_Type=isolated}', "");
    Expect(1, 65276, '\P{Decomposition_Type=isolated}', "");
    Expect(0, 65276, '\P{^Decomposition_Type=isolated}', "");
    Expect(1, 65275, '\p{Decomposition_Type=:\Aisolated\z:}', "");;
    Expect(0, 65276, '\p{Decomposition_Type=:\Aisolated\z:}', "");;
    Expect(1, 65275, '\p{Decomposition_Type: Isolated}', "");
    Expect(0, 65275, '\p{^Decomposition_Type: Isolated}', "");
    Expect(0, 65275, '\P{Decomposition_Type: Isolated}', "");
    Expect(1, 65275, '\P{^Decomposition_Type: Isolated}', "");
    Expect(0, 65276, '\p{Decomposition_Type: Isolated}', "");
    Expect(1, 65276, '\p{^Decomposition_Type: Isolated}', "");
    Expect(1, 65276, '\P{Decomposition_Type: Isolated}', "");
    Expect(0, 65276, '\P{^Decomposition_Type: Isolated}', "");
    Error('\p{Dt=:= -Iso}');
    Error('\P{Dt=:= -Iso}');
    Expect(1, 65275, '\p{Dt=:\AIso\z:}', "");;
    Expect(0, 65276, '\p{Dt=:\AIso\z:}', "");;
    Expect(1, 65275, '\p{Dt=iso}', "");
    Expect(0, 65275, '\p{^Dt=iso}', "");
    Expect(0, 65275, '\P{Dt=iso}', "");
    Expect(1, 65275, '\P{^Dt=iso}', "");
    Expect(0, 65276, '\p{Dt=iso}', "");
    Expect(1, 65276, '\p{^Dt=iso}', "");
    Expect(1, 65276, '\P{Dt=iso}', "");
    Expect(0, 65276, '\P{^Dt=iso}', "");
    Expect(1, 65275, '\p{Dt=:\Aiso\z:}', "");;
    Expect(0, 65276, '\p{Dt=:\Aiso\z:}', "");;
    Expect(1, 65275, '\p{Dt=-iso}', "");
    Expect(0, 65275, '\p{^Dt=-iso}', "");
    Expect(0, 65275, '\P{Dt=-iso}', "");
    Expect(1, 65275, '\P{^Dt=-iso}', "");
    Expect(0, 65276, '\p{Dt=-iso}', "");
    Expect(1, 65276, '\p{^Dt=-iso}', "");
    Expect(1, 65276, '\P{Dt=-iso}', "");
    Expect(0, 65276, '\P{^Dt=-iso}', "");
    Error('\p{Is_Decomposition_Type=_	Isolated:=}');
    Error('\P{Is_Decomposition_Type=_	Isolated:=}');
    Expect(1, 65275, '\p{Is_Decomposition_Type=isolated}', "");
    Expect(0, 65275, '\p{^Is_Decomposition_Type=isolated}', "");
    Expect(0, 65275, '\P{Is_Decomposition_Type=isolated}', "");
    Expect(1, 65275, '\P{^Is_Decomposition_Type=isolated}', "");
    Expect(0, 65276, '\p{Is_Decomposition_Type=isolated}', "");
    Expect(1, 65276, '\p{^Is_Decomposition_Type=isolated}', "");
    Expect(1, 65276, '\P{Is_Decomposition_Type=isolated}', "");
    Expect(0, 65276, '\P{^Is_Decomposition_Type=isolated}', "");
    Expect(1, 65275, '\p{Is_Decomposition_Type=-	Isolated}', "");
    Expect(0, 65275, '\p{^Is_Decomposition_Type=-	Isolated}', "");
    Expect(0, 65275, '\P{Is_Decomposition_Type=-	Isolated}', "");
    Expect(1, 65275, '\P{^Is_Decomposition_Type=-	Isolated}', "");
    Expect(0, 65276, '\p{Is_Decomposition_Type=-	Isolated}', "");
    Expect(1, 65276, '\p{^Is_Decomposition_Type=-	Isolated}', "");
    Expect(1, 65276, '\P{Is_Decomposition_Type=-	Isolated}', "");
    Expect(0, 65276, '\P{^Is_Decomposition_Type=-	Isolated}', "");
    Error('\p{Is_Dt=/a/ -iso}');
    Error('\P{Is_Dt=/a/ -iso}');
    Expect(1, 65275, '\p{Is_Dt=iso}', "");
    Expect(0, 65275, '\p{^Is_Dt=iso}', "");
    Expect(0, 65275, '\P{Is_Dt=iso}', "");
    Expect(1, 65275, '\P{^Is_Dt=iso}', "");
    Expect(0, 65276, '\p{Is_Dt=iso}', "");
    Expect(1, 65276, '\p{^Is_Dt=iso}', "");
    Expect(1, 65276, '\P{Is_Dt=iso}', "");
    Expect(0, 65276, '\P{^Is_Dt=iso}', "");
    Expect(1, 65275, '\p{Is_Dt=__Iso}', "");
    Expect(0, 65275, '\p{^Is_Dt=__Iso}', "");
    Expect(0, 65275, '\P{Is_Dt=__Iso}', "");
    Expect(1, 65275, '\P{^Is_Dt=__Iso}', "");
    Expect(0, 65276, '\p{Is_Dt=__Iso}', "");
    Expect(1, 65276, '\p{^Is_Dt=__Iso}', "");
    Expect(1, 65276, '\P{Is_Dt=__Iso}', "");
    Expect(0, 65276, '\P{^Is_Dt=__Iso}', "");
    Error('\p{Decomposition_Type=_-medial:=}');
    Error('\P{Decomposition_Type=_-medial:=}');
    Expect(1, 65268, '\p{Decomposition_Type=:\AMedial\z:}', "");;
    Expect(0, 65269, '\p{Decomposition_Type=:\AMedial\z:}', "");;
    Expect(1, 65268, '\p{Decomposition_Type=medial}', "");
    Expect(0, 65268, '\p{^Decomposition_Type=medial}', "");
    Expect(0, 65268, '\P{Decomposition_Type=medial}', "");
    Expect(1, 65268, '\P{^Decomposition_Type=medial}', "");
    Expect(0, 65269, '\p{Decomposition_Type=medial}', "");
    Expect(1, 65269, '\p{^Decomposition_Type=medial}', "");
    Expect(1, 65269, '\P{Decomposition_Type=medial}', "");
    Expect(0, 65269, '\P{^Decomposition_Type=medial}', "");
    Expect(1, 65268, '\p{Decomposition_Type=:\Amedial\z:}', "");;
    Expect(0, 65269, '\p{Decomposition_Type=:\Amedial\z:}', "");;
    Expect(1, 65268, '\p{Decomposition_Type=-Medial}', "");
    Expect(0, 65268, '\p{^Decomposition_Type=-Medial}', "");
    Expect(0, 65268, '\P{Decomposition_Type=-Medial}', "");
    Expect(1, 65268, '\P{^Decomposition_Type=-Medial}', "");
    Expect(0, 65269, '\p{Decomposition_Type=-Medial}', "");
    Expect(1, 65269, '\p{^Decomposition_Type=-Medial}', "");
    Expect(1, 65269, '\P{Decomposition_Type=-Medial}', "");
    Expect(0, 65269, '\P{^Decomposition_Type=-Medial}', "");
    Error('\p{Dt=- Med:=}');
    Error('\P{Dt=- Med:=}');
    Expect(1, 65268, '\p{Dt=:\AMed\z:}', "");;
    Expect(0, 65269, '\p{Dt=:\AMed\z:}', "");;
    Expect(1, 65268, '\p{Dt:   med}', "");
    Expect(0, 65268, '\p{^Dt:   med}', "");
    Expect(0, 65268, '\P{Dt:   med}', "");
    Expect(1, 65268, '\P{^Dt:   med}', "");
    Expect(0, 65269, '\p{Dt:   med}', "");
    Expect(1, 65269, '\p{^Dt:   med}', "");
    Expect(1, 65269, '\P{Dt:   med}', "");
    Expect(0, 65269, '\P{^Dt:   med}', "");
    Expect(1, 65268, '\p{Dt=:\Amed\z:}', "");;
    Expect(0, 65269, '\p{Dt=:\Amed\z:}', "");;
    Expect(1, 65268, '\p{Dt=	 Med}', "");
    Expect(0, 65268, '\p{^Dt=	 Med}', "");
    Expect(0, 65268, '\P{Dt=	 Med}', "");
    Expect(1, 65268, '\P{^Dt=	 Med}', "");
    Expect(0, 65269, '\p{Dt=	 Med}', "");
    Expect(1, 65269, '\p{^Dt=	 Med}', "");
    Expect(1, 65269, '\P{Dt=	 Med}', "");
    Expect(0, 65269, '\P{^Dt=	 Med}', "");
    Error('\p{Is_Decomposition_Type=/a/-_Medial}');
    Error('\P{Is_Decomposition_Type=/a/-_Medial}');
    Expect(1, 65268, '\p{Is_Decomposition_Type=medial}', "");
    Expect(0, 65268, '\p{^Is_Decomposition_Type=medial}', "");
    Expect(0, 65268, '\P{Is_Decomposition_Type=medial}', "");
    Expect(1, 65268, '\P{^Is_Decomposition_Type=medial}', "");
    Expect(0, 65269, '\p{Is_Decomposition_Type=medial}', "");
    Expect(1, 65269, '\p{^Is_Decomposition_Type=medial}', "");
    Expect(1, 65269, '\P{Is_Decomposition_Type=medial}', "");
    Expect(0, 65269, '\P{^Is_Decomposition_Type=medial}', "");
    Expect(1, 65268, '\p{Is_Decomposition_Type=-Medial}', "");
    Expect(0, 65268, '\p{^Is_Decomposition_Type=-Medial}', "");
    Expect(0, 65268, '\P{Is_Decomposition_Type=-Medial}', "");
    Expect(1, 65268, '\P{^Is_Decomposition_Type=-Medial}', "");
    Expect(0, 65269, '\p{Is_Decomposition_Type=-Medial}', "");
    Expect(1, 65269, '\p{^Is_Decomposition_Type=-Medial}', "");
    Expect(1, 65269, '\P{Is_Decomposition_Type=-Medial}', "");
    Expect(0, 65269, '\P{^Is_Decomposition_Type=-Medial}', "");
    Error('\p{Is_Dt:    /a/med}');
    Error('\P{Is_Dt:    /a/med}');
    Expect(1, 65268, '\p{Is_Dt=med}', "");
    Expect(0, 65268, '\p{^Is_Dt=med}', "");
    Expect(0, 65268, '\P{Is_Dt=med}', "");
    Expect(1, 65268, '\P{^Is_Dt=med}', "");
    Expect(0, 65269, '\p{Is_Dt=med}', "");
    Expect(1, 65269, '\p{^Is_Dt=med}', "");
    Expect(1, 65269, '\P{Is_Dt=med}', "");
    Expect(0, 65269, '\P{^Is_Dt=med}', "");
    Expect(1, 65268, '\p{Is_Dt=-MED}', "");
    Expect(0, 65268, '\p{^Is_Dt=-MED}', "");
    Expect(0, 65268, '\P{Is_Dt=-MED}', "");
    Expect(1, 65268, '\P{^Is_Dt=-MED}', "");
    Expect(0, 65269, '\p{Is_Dt=-MED}', "");
    Expect(1, 65269, '\p{^Is_Dt=-MED}', "");
    Expect(1, 65269, '\P{Is_Dt=-MED}', "");
    Expect(0, 65269, '\P{^Is_Dt=-MED}', "");
    Error('\p{Decomposition_Type=		Narrow/a/}');
    Error('\P{Decomposition_Type=		Narrow/a/}');
    Expect(1, 65518, '\p{Decomposition_Type=:\ANarrow\z:}', "");;
    Expect(0, 65519, '\p{Decomposition_Type=:\ANarrow\z:}', "");;
    Expect(1, 65518, '\p{Decomposition_Type=narrow}', "");
    Expect(0, 65518, '\p{^Decomposition_Type=narrow}', "");
    Expect(0, 65518, '\P{Decomposition_Type=narrow}', "");
    Expect(1, 65518, '\P{^Decomposition_Type=narrow}', "");
    Expect(0, 65519, '\p{Decomposition_Type=narrow}', "");
    Expect(1, 65519, '\p{^Decomposition_Type=narrow}', "");
    Expect(1, 65519, '\P{Decomposition_Type=narrow}', "");
    Expect(0, 65519, '\P{^Decomposition_Type=narrow}', "");
    Expect(1, 65518, '\p{Decomposition_Type=:\Anarrow\z:}', "");;
    Expect(0, 65519, '\p{Decomposition_Type=:\Anarrow\z:}', "");;
    Expect(1, 65518, '\p{Decomposition_Type=  Narrow}', "");
    Expect(0, 65518, '\p{^Decomposition_Type=  Narrow}', "");
    Expect(0, 65518, '\P{Decomposition_Type=  Narrow}', "");
    Expect(1, 65518, '\P{^Decomposition_Type=  Narrow}', "");
    Expect(0, 65519, '\p{Decomposition_Type=  Narrow}', "");
    Expect(1, 65519, '\p{^Decomposition_Type=  Narrow}', "");
    Expect(1, 65519, '\P{Decomposition_Type=  Narrow}', "");
    Expect(0, 65519, '\P{^Decomposition_Type=  Narrow}', "");
    Error('\p{Dt=		Nar:=}');
    Error('\P{Dt=		Nar:=}');
    Expect(1, 65518, '\p{Dt=:\ANar\z:}', "");;
    Expect(0, 65519, '\p{Dt=:\ANar\z:}', "");;
    Expect(1, 65518, '\p{Dt=nar}', "");
    Expect(0, 65518, '\p{^Dt=nar}', "");
    Expect(0, 65518, '\P{Dt=nar}', "");
    Expect(1, 65518, '\P{^Dt=nar}', "");
    Expect(0, 65519, '\p{Dt=nar}', "");
    Expect(1, 65519, '\p{^Dt=nar}', "");
    Expect(1, 65519, '\P{Dt=nar}', "");
    Expect(0, 65519, '\P{^Dt=nar}', "");
    Expect(1, 65518, '\p{Dt=:\Anar\z:}', "");;
    Expect(0, 65519, '\p{Dt=:\Anar\z:}', "");;
    Expect(1, 65518, '\p{Dt=Nar}', "");
    Expect(0, 65518, '\p{^Dt=Nar}', "");
    Expect(0, 65518, '\P{Dt=Nar}', "");
    Expect(1, 65518, '\P{^Dt=Nar}', "");
    Expect(0, 65519, '\p{Dt=Nar}', "");
    Expect(1, 65519, '\p{^Dt=Nar}', "");
    Expect(1, 65519, '\P{Dt=Nar}', "");
    Expect(0, 65519, '\P{^Dt=Nar}', "");
    Error('\p{Is_Decomposition_Type= _Narrow:=}');
    Error('\P{Is_Decomposition_Type= _Narrow:=}');
    Expect(1, 65518, '\p{Is_Decomposition_Type=narrow}', "");
    Expect(0, 65518, '\p{^Is_Decomposition_Type=narrow}', "");
    Expect(0, 65518, '\P{Is_Decomposition_Type=narrow}', "");
    Expect(1, 65518, '\P{^Is_Decomposition_Type=narrow}', "");
    Expect(0, 65519, '\p{Is_Decomposition_Type=narrow}', "");
    Expect(1, 65519, '\p{^Is_Decomposition_Type=narrow}', "");
    Expect(1, 65519, '\P{Is_Decomposition_Type=narrow}', "");
    Expect(0, 65519, '\P{^Is_Decomposition_Type=narrow}', "");
    Expect(1, 65518, '\p{Is_Decomposition_Type= Narrow}', "");
    Expect(0, 65518, '\p{^Is_Decomposition_Type= Narrow}', "");
    Expect(0, 65518, '\P{Is_Decomposition_Type= Narrow}', "");
    Expect(1, 65518, '\P{^Is_Decomposition_Type= Narrow}', "");
    Expect(0, 65519, '\p{Is_Decomposition_Type= Narrow}', "");
    Expect(1, 65519, '\p{^Is_Decomposition_Type= Narrow}', "");
    Expect(1, 65519, '\P{Is_Decomposition_Type= Narrow}', "");
    Expect(0, 65519, '\P{^Is_Decomposition_Type= Narrow}', "");
    Error('\p{Is_Dt=	_Nar/a/}');
    Error('\P{Is_Dt=	_Nar/a/}');
    Expect(1, 65518, '\p{Is_Dt=nar}', "");
    Expect(0, 65518, '\p{^Is_Dt=nar}', "");
    Expect(0, 65518, '\P{Is_Dt=nar}', "");
    Expect(1, 65518, '\P{^Is_Dt=nar}', "");
    Expect(0, 65519, '\p{Is_Dt=nar}', "");
    Expect(1, 65519, '\p{^Is_Dt=nar}', "");
    Expect(1, 65519, '\P{Is_Dt=nar}', "");
    Expect(0, 65519, '\P{^Is_Dt=nar}', "");
    Expect(1, 65518, '\p{Is_Dt=-	NAR}', "");
    Expect(0, 65518, '\p{^Is_Dt=-	NAR}', "");
    Expect(0, 65518, '\P{Is_Dt=-	NAR}', "");
    Expect(1, 65518, '\P{^Is_Dt=-	NAR}', "");
    Expect(0, 65519, '\p{Is_Dt=-	NAR}', "");
    Expect(1, 65519, '\p{^Is_Dt=-	NAR}', "");
    Expect(1, 65519, '\P{Is_Dt=-	NAR}', "");
    Expect(0, 65519, '\P{^Is_Dt=-	NAR}', "");
    Error('\p{Decomposition_Type= _Nobreak/a/}');
    Error('\P{Decomposition_Type= _Nobreak/a/}');
    Expect(1, 8239, '\p{Decomposition_Type=:\ANobreak\z:}', "");;
    Expect(0, 8240, '\p{Decomposition_Type=:\ANobreak\z:}', "");;
    Expect(1, 8239, '\p{Decomposition_Type=nobreak}', "");
    Expect(0, 8239, '\p{^Decomposition_Type=nobreak}', "");
    Expect(0, 8239, '\P{Decomposition_Type=nobreak}', "");
    Expect(1, 8239, '\P{^Decomposition_Type=nobreak}', "");
    Expect(0, 8240, '\p{Decomposition_Type=nobreak}', "");
    Expect(1, 8240, '\p{^Decomposition_Type=nobreak}', "");
    Expect(1, 8240, '\P{Decomposition_Type=nobreak}', "");
    Expect(0, 8240, '\P{^Decomposition_Type=nobreak}', "");
    Expect(1, 8239, '\p{Decomposition_Type=:\Anobreak\z:}', "");;
    Expect(0, 8240, '\p{Decomposition_Type=:\Anobreak\z:}', "");;
    Expect(1, 8239, '\p{Decomposition_Type=	Nobreak}', "");
    Expect(0, 8239, '\p{^Decomposition_Type=	Nobreak}', "");
    Expect(0, 8239, '\P{Decomposition_Type=	Nobreak}', "");
    Expect(1, 8239, '\P{^Decomposition_Type=	Nobreak}', "");
    Expect(0, 8240, '\p{Decomposition_Type=	Nobreak}', "");
    Expect(1, 8240, '\p{^Decomposition_Type=	Nobreak}', "");
    Expect(1, 8240, '\P{Decomposition_Type=	Nobreak}', "");
    Expect(0, 8240, '\P{^Decomposition_Type=	Nobreak}', "");
    Error('\p{Dt=_:=nb}');
    Error('\P{Dt=_:=nb}');
    Expect(1, 8239, '\p{Dt=:\ANb\z:}', "");;
    Expect(0, 8240, '\p{Dt=:\ANb\z:}', "");;
    Expect(1, 8239, '\p{Dt:nb}', "");
    Expect(0, 8239, '\p{^Dt:nb}', "");
    Expect(0, 8239, '\P{Dt:nb}', "");
    Expect(1, 8239, '\P{^Dt:nb}', "");
    Expect(0, 8240, '\p{Dt:nb}', "");
    Expect(1, 8240, '\p{^Dt:nb}', "");
    Expect(1, 8240, '\P{Dt:nb}', "");
    Expect(0, 8240, '\P{^Dt:nb}', "");
    Expect(1, 8239, '\p{Dt=:\Anb\z:}', "");;
    Expect(0, 8240, '\p{Dt=:\Anb\z:}', "");;
    Expect(1, 8239, '\p{Dt=-Nb}', "");
    Expect(0, 8239, '\p{^Dt=-Nb}', "");
    Expect(0, 8239, '\P{Dt=-Nb}', "");
    Expect(1, 8239, '\P{^Dt=-Nb}', "");
    Expect(0, 8240, '\p{Dt=-Nb}', "");
    Expect(1, 8240, '\p{^Dt=-Nb}', "");
    Expect(1, 8240, '\P{Dt=-Nb}', "");
    Expect(0, 8240, '\P{^Dt=-Nb}', "");
    Error('\p{Is_Decomposition_Type=:=	-NOBREAK}');
    Error('\P{Is_Decomposition_Type=:=	-NOBREAK}');
    Expect(1, 8239, '\p{Is_Decomposition_Type:nobreak}', "");
    Expect(0, 8239, '\p{^Is_Decomposition_Type:nobreak}', "");
    Expect(0, 8239, '\P{Is_Decomposition_Type:nobreak}', "");
    Expect(1, 8239, '\P{^Is_Decomposition_Type:nobreak}', "");
    Expect(0, 8240, '\p{Is_Decomposition_Type:nobreak}', "");
    Expect(1, 8240, '\p{^Is_Decomposition_Type:nobreak}', "");
    Expect(1, 8240, '\P{Is_Decomposition_Type:nobreak}', "");
    Expect(0, 8240, '\P{^Is_Decomposition_Type:nobreak}', "");
    Expect(1, 8239, '\p{Is_Decomposition_Type=_NOBREAK}', "");
    Expect(0, 8239, '\p{^Is_Decomposition_Type=_NOBREAK}', "");
    Expect(0, 8239, '\P{Is_Decomposition_Type=_NOBREAK}', "");
    Expect(1, 8239, '\P{^Is_Decomposition_Type=_NOBREAK}', "");
    Expect(0, 8240, '\p{Is_Decomposition_Type=_NOBREAK}', "");
    Expect(1, 8240, '\p{^Is_Decomposition_Type=_NOBREAK}', "");
    Expect(1, 8240, '\P{Is_Decomposition_Type=_NOBREAK}', "");
    Expect(0, 8240, '\P{^Is_Decomposition_Type=_NOBREAK}', "");
    Error('\p{Is_Dt:		nb/a/}');
    Error('\P{Is_Dt:		nb/a/}');
    Expect(1, 8239, '\p{Is_Dt:   nb}', "");
    Expect(0, 8239, '\p{^Is_Dt:   nb}', "");
    Expect(0, 8239, '\P{Is_Dt:   nb}', "");
    Expect(1, 8239, '\P{^Is_Dt:   nb}', "");
    Expect(0, 8240, '\p{Is_Dt:   nb}', "");
    Expect(1, 8240, '\p{^Is_Dt:   nb}', "");
    Expect(1, 8240, '\P{Is_Dt:   nb}', "");
    Expect(0, 8240, '\P{^Is_Dt:   nb}', "");
    Expect(1, 8239, '\p{Is_Dt=-Nb}', "");
    Expect(0, 8239, '\p{^Is_Dt=-Nb}', "");
    Expect(0, 8239, '\P{Is_Dt=-Nb}', "");
    Expect(1, 8239, '\P{^Is_Dt=-Nb}', "");
    Expect(0, 8240, '\p{Is_Dt=-Nb}', "");
    Expect(1, 8240, '\p{^Is_Dt=-Nb}', "");
    Expect(1, 8240, '\P{Is_Dt=-Nb}', "");
    Expect(0, 8240, '\P{^Is_Dt=-Nb}', "");
    Error('\p{Decomposition_Type= Non_Canonical:=}');
    Error('\P{Decomposition_Type= Non_Canonical:=}');
    Expect(1, 130041, '\p{Decomposition_Type=:\ANon_Canonical\z:}', "");;
    Expect(0, 130042, '\p{Decomposition_Type=:\ANon_Canonical\z:}', "");;
    Expect(1, 130041, '\p{Decomposition_Type=noncanonical}', "");
    Expect(0, 130041, '\p{^Decomposition_Type=noncanonical}', "");
    Expect(0, 130041, '\P{Decomposition_Type=noncanonical}', "");
    Expect(1, 130041, '\P{^Decomposition_Type=noncanonical}', "");
    Expect(0, 130042, '\p{Decomposition_Type=noncanonical}', "");
    Expect(1, 130042, '\p{^Decomposition_Type=noncanonical}', "");
    Expect(1, 130042, '\P{Decomposition_Type=noncanonical}', "");
    Expect(0, 130042, '\P{^Decomposition_Type=noncanonical}', "");
    Expect(1, 130041, '\p{Decomposition_Type=:\Anoncanonical\z:}', "");;
    Expect(0, 130042, '\p{Decomposition_Type=:\Anoncanonical\z:}', "");;
    Expect(1, 130041, '\p{Decomposition_Type=-NON_CANONICAL}', "");
    Expect(0, 130041, '\p{^Decomposition_Type=-NON_CANONICAL}', "");
    Expect(0, 130041, '\P{Decomposition_Type=-NON_CANONICAL}', "");
    Expect(1, 130041, '\P{^Decomposition_Type=-NON_CANONICAL}', "");
    Expect(0, 130042, '\p{Decomposition_Type=-NON_CANONICAL}', "");
    Expect(1, 130042, '\p{^Decomposition_Type=-NON_CANONICAL}', "");
    Expect(1, 130042, '\P{Decomposition_Type=-NON_CANONICAL}', "");
    Expect(0, 130042, '\P{^Decomposition_Type=-NON_CANONICAL}', "");
    Error('\p{Dt=_:=NON_canon}');
    Error('\P{Dt=_:=NON_canon}');
    Expect(1, 130041, '\p{Dt=:\ANon_Canon\z:}', "");;
    Expect(0, 130042, '\p{Dt=:\ANon_Canon\z:}', "");;
    Expect(1, 130041, '\p{Dt=noncanon}', "");
    Expect(0, 130041, '\p{^Dt=noncanon}', "");
    Expect(0, 130041, '\P{Dt=noncanon}', "");
    Expect(1, 130041, '\P{^Dt=noncanon}', "");
    Expect(0, 130042, '\p{Dt=noncanon}', "");
    Expect(1, 130042, '\p{^Dt=noncanon}', "");
    Expect(1, 130042, '\P{Dt=noncanon}', "");
    Expect(0, 130042, '\P{^Dt=noncanon}', "");
    Expect(1, 130041, '\p{Dt=:\Anoncanon\z:}', "");;
    Expect(0, 130042, '\p{Dt=:\Anoncanon\z:}', "");;
    Expect(1, 130041, '\p{Dt:    non_canon}', "");
    Expect(0, 130041, '\p{^Dt:    non_canon}', "");
    Expect(0, 130041, '\P{Dt:    non_canon}', "");
    Expect(1, 130041, '\P{^Dt:    non_canon}', "");
    Expect(0, 130042, '\p{Dt:    non_canon}', "");
    Expect(1, 130042, '\p{^Dt:    non_canon}', "");
    Expect(1, 130042, '\P{Dt:    non_canon}', "");
    Expect(0, 130042, '\P{^Dt:    non_canon}', "");
    Error('\p{Is_Decomposition_Type=_ non_CANONICAL:=}');
    Error('\P{Is_Decomposition_Type=_ non_CANONICAL:=}');
    Expect(1, 130041, '\p{Is_Decomposition_Type=noncanonical}', "");
    Expect(0, 130041, '\p{^Is_Decomposition_Type=noncanonical}', "");
    Expect(0, 130041, '\P{Is_Decomposition_Type=noncanonical}', "");
    Expect(1, 130041, '\P{^Is_Decomposition_Type=noncanonical}', "");
    Expect(0, 130042, '\p{Is_Decomposition_Type=noncanonical}', "");
    Expect(1, 130042, '\p{^Is_Decomposition_Type=noncanonical}', "");
    Expect(1, 130042, '\P{Is_Decomposition_Type=noncanonical}', "");
    Expect(0, 130042, '\P{^Is_Decomposition_Type=noncanonical}', "");
    Expect(1, 130041, '\p{Is_Decomposition_Type:	 Non_Canonical}', "");
    Expect(0, 130041, '\p{^Is_Decomposition_Type:	 Non_Canonical}', "");
    Expect(0, 130041, '\P{Is_Decomposition_Type:	 Non_Canonical}', "");
    Expect(1, 130041, '\P{^Is_Decomposition_Type:	 Non_Canonical}', "");
    Expect(0, 130042, '\p{Is_Decomposition_Type:	 Non_Canonical}', "");
    Expect(1, 130042, '\p{^Is_Decomposition_Type:	 Non_Canonical}', "");
    Expect(1, 130042, '\P{Is_Decomposition_Type:	 Non_Canonical}', "");
    Expect(0, 130042, '\P{^Is_Decomposition_Type:	 Non_Canonical}', "");
    Error('\p{Is_Dt=_NON_canon/a/}');
    Error('\P{Is_Dt=_NON_canon/a/}');
    Expect(1, 130041, '\p{Is_Dt=noncanon}', "");
    Expect(0, 130041, '\p{^Is_Dt=noncanon}', "");
    Expect(0, 130041, '\P{Is_Dt=noncanon}', "");
    Expect(1, 130041, '\P{^Is_Dt=noncanon}', "");
    Expect(0, 130042, '\p{Is_Dt=noncanon}', "");
    Expect(1, 130042, '\p{^Is_Dt=noncanon}', "");
    Expect(1, 130042, '\P{Is_Dt=noncanon}', "");
    Expect(0, 130042, '\P{^Is_Dt=noncanon}', "");
    Expect(1, 130041, '\p{Is_Dt=  Non_Canon}', "");
    Expect(0, 130041, '\p{^Is_Dt=  Non_Canon}', "");
    Expect(0, 130041, '\P{Is_Dt=  Non_Canon}', "");
    Expect(1, 130041, '\P{^Is_Dt=  Non_Canon}', "");
    Expect(0, 130042, '\p{Is_Dt=  Non_Canon}', "");
    Expect(1, 130042, '\p{^Is_Dt=  Non_Canon}', "");
    Expect(1, 130042, '\P{Is_Dt=  Non_Canon}', "");
    Expect(0, 130042, '\P{^Is_Dt=  Non_Canon}', "");
    Error('\p{Decomposition_Type=/a/NONE}');
    Error('\P{Decomposition_Type=/a/NONE}');
    Expect(1, 195102, '\p{Decomposition_Type=:\ANone\z:}', "");;
    Expect(0, 195101, '\p{Decomposition_Type=:\ANone\z:}', "");;
    Expect(1, 195102, '\p{Decomposition_Type=none}', "");
    Expect(0, 195102, '\p{^Decomposition_Type=none}', "");
    Expect(0, 195102, '\P{Decomposition_Type=none}', "");
    Expect(1, 195102, '\P{^Decomposition_Type=none}', "");
    Expect(0, 195101, '\p{Decomposition_Type=none}', "");
    Expect(1, 195101, '\p{^Decomposition_Type=none}', "");
    Expect(1, 195101, '\P{Decomposition_Type=none}', "");
    Expect(0, 195101, '\P{^Decomposition_Type=none}', "");
    Expect(1, 195102, '\p{Decomposition_Type=:\Anone\z:}', "");;
    Expect(0, 195101, '\p{Decomposition_Type=:\Anone\z:}', "");;
    Expect(1, 195102, '\p{Decomposition_Type=-	None}', "");
    Expect(0, 195102, '\p{^Decomposition_Type=-	None}', "");
    Expect(0, 195102, '\P{Decomposition_Type=-	None}', "");
    Expect(1, 195102, '\P{^Decomposition_Type=-	None}', "");
    Expect(0, 195101, '\p{Decomposition_Type=-	None}', "");
    Expect(1, 195101, '\p{^Decomposition_Type=-	None}', "");
    Expect(1, 195101, '\P{Decomposition_Type=-	None}', "");
    Expect(0, 195101, '\P{^Decomposition_Type=-	None}', "");
    Error('\p{Dt=_None:=}');
    Error('\P{Dt=_None:=}');
    Expect(1, 195102, '\p{Dt=:\ANone\z:}', "");;
    Expect(0, 195101, '\p{Dt=:\ANone\z:}', "");;
    Expect(1, 195102, '\p{Dt=none}', "");
    Expect(0, 195102, '\p{^Dt=none}', "");
    Expect(0, 195102, '\P{Dt=none}', "");
    Expect(1, 195102, '\P{^Dt=none}', "");
    Expect(0, 195101, '\p{Dt=none}', "");
    Expect(1, 195101, '\p{^Dt=none}', "");
    Expect(1, 195101, '\P{Dt=none}', "");
    Expect(0, 195101, '\P{^Dt=none}', "");
    Expect(1, 195102, '\p{Dt=:\Anone\z:}', "");;
    Expect(0, 195101, '\p{Dt=:\Anone\z:}', "");;
    Expect(1, 195102, '\p{Dt:	_ none}', "");
    Expect(0, 195102, '\p{^Dt:	_ none}', "");
    Expect(0, 195102, '\P{Dt:	_ none}', "");
    Expect(1, 195102, '\P{^Dt:	_ none}', "");
    Expect(0, 195101, '\p{Dt:	_ none}', "");
    Expect(1, 195101, '\p{^Dt:	_ none}', "");
    Expect(1, 195101, '\P{Dt:	_ none}', "");
    Expect(0, 195101, '\P{^Dt:	_ none}', "");
    Error('\p{Is_Decomposition_Type:   :=	_none}');
    Error('\P{Is_Decomposition_Type:   :=	_none}');
    Expect(1, 195102, '\p{Is_Decomposition_Type=none}', "");
    Expect(0, 195102, '\p{^Is_Decomposition_Type=none}', "");
    Expect(0, 195102, '\P{Is_Decomposition_Type=none}', "");
    Expect(1, 195102, '\P{^Is_Decomposition_Type=none}', "");
    Expect(0, 195101, '\p{Is_Decomposition_Type=none}', "");
    Expect(1, 195101, '\p{^Is_Decomposition_Type=none}', "");
    Expect(1, 195101, '\P{Is_Decomposition_Type=none}', "");
    Expect(0, 195101, '\P{^Is_Decomposition_Type=none}', "");
    Expect(1, 195102, '\p{Is_Decomposition_Type= None}', "");
    Expect(0, 195102, '\p{^Is_Decomposition_Type= None}', "");
    Expect(0, 195102, '\P{Is_Decomposition_Type= None}', "");
    Expect(1, 195102, '\P{^Is_Decomposition_Type= None}', "");
    Expect(0, 195101, '\p{Is_Decomposition_Type= None}', "");
    Expect(1, 195101, '\p{^Is_Decomposition_Type= None}', "");
    Expect(1, 195101, '\P{Is_Decomposition_Type= None}', "");
    Expect(0, 195101, '\P{^Is_Decomposition_Type= None}', "");
    Error('\p{Is_Dt=_	NONE:=}');
    Error('\P{Is_Dt=_	NONE:=}');
    Expect(1, 195102, '\p{Is_Dt=none}', "");
    Expect(0, 195102, '\p{^Is_Dt=none}', "");
    Expect(0, 195102, '\P{Is_Dt=none}', "");
    Expect(1, 195102, '\P{^Is_Dt=none}', "");
    Expect(0, 195101, '\p{Is_Dt=none}', "");
    Expect(1, 195101, '\p{^Is_Dt=none}', "");
    Expect(1, 195101, '\P{Is_Dt=none}', "");
    Expect(0, 195101, '\P{^Is_Dt=none}', "");
    Expect(1, 195102, '\p{Is_Dt:	 -None}', "");
    Expect(0, 195102, '\p{^Is_Dt:	 -None}', "");
    Expect(0, 195102, '\P{Is_Dt:	 -None}', "");
    Expect(1, 195102, '\P{^Is_Dt:	 -None}', "");
    Expect(0, 195101, '\p{Is_Dt:	 -None}', "");
    Expect(1, 195101, '\p{^Is_Dt:	 -None}', "");
    Expect(1, 195101, '\P{Is_Dt:	 -None}', "");
    Expect(0, 195101, '\P{^Is_Dt:	 -None}', "");
    Error('\p{Decomposition_Type=_ Small/a/}');
    Error('\P{Decomposition_Type=_ Small/a/}');
    Expect(1, 65131, '\p{Decomposition_Type=:\ASmall\z:}', "");;
    Expect(0, 65132, '\p{Decomposition_Type=:\ASmall\z:}', "");;
    Expect(1, 65131, '\p{Decomposition_Type:small}', "");
    Expect(0, 65131, '\p{^Decomposition_Type:small}', "");
    Expect(0, 65131, '\P{Decomposition_Type:small}', "");
    Expect(1, 65131, '\P{^Decomposition_Type:small}', "");
    Expect(0, 65132, '\p{Decomposition_Type:small}', "");
    Expect(1, 65132, '\p{^Decomposition_Type:small}', "");
    Expect(1, 65132, '\P{Decomposition_Type:small}', "");
    Expect(0, 65132, '\P{^Decomposition_Type:small}', "");
    Expect(1, 65131, '\p{Decomposition_Type=:\Asmall\z:}', "");;
    Expect(0, 65132, '\p{Decomposition_Type=:\Asmall\z:}', "");;
    Expect(1, 65131, '\p{Decomposition_Type=-Small}', "");
    Expect(0, 65131, '\p{^Decomposition_Type=-Small}', "");
    Expect(0, 65131, '\P{Decomposition_Type=-Small}', "");
    Expect(1, 65131, '\P{^Decomposition_Type=-Small}', "");
    Expect(0, 65132, '\p{Decomposition_Type=-Small}', "");
    Expect(1, 65132, '\p{^Decomposition_Type=-Small}', "");
    Expect(1, 65132, '\P{Decomposition_Type=-Small}', "");
    Expect(0, 65132, '\P{^Decomposition_Type=-Small}', "");
    Error('\p{Dt=-/a/sml}');
    Error('\P{Dt=-/a/sml}');
    Expect(1, 65131, '\p{Dt=:\ASml\z:}', "");;
    Expect(0, 65132, '\p{Dt=:\ASml\z:}', "");;
    Expect(1, 65131, '\p{Dt=sml}', "");
    Expect(0, 65131, '\p{^Dt=sml}', "");
    Expect(0, 65131, '\P{Dt=sml}', "");
    Expect(1, 65131, '\P{^Dt=sml}', "");
    Expect(0, 65132, '\p{Dt=sml}', "");
    Expect(1, 65132, '\p{^Dt=sml}', "");
    Expect(1, 65132, '\P{Dt=sml}', "");
    Expect(0, 65132, '\P{^Dt=sml}', "");
    Expect(1, 65131, '\p{Dt=:\Asml\z:}', "");;
    Expect(0, 65132, '\p{Dt=:\Asml\z:}', "");;
    Expect(1, 65131, '\p{Dt=	Sml}', "");
    Expect(0, 65131, '\p{^Dt=	Sml}', "");
    Expect(0, 65131, '\P{Dt=	Sml}', "");
    Expect(1, 65131, '\P{^Dt=	Sml}', "");
    Expect(0, 65132, '\p{Dt=	Sml}', "");
    Expect(1, 65132, '\p{^Dt=	Sml}', "");
    Expect(1, 65132, '\P{Dt=	Sml}', "");
    Expect(0, 65132, '\P{^Dt=	Sml}', "");
    Error('\p{Is_Decomposition_Type= 	SMALL/a/}');
    Error('\P{Is_Decomposition_Type= 	SMALL/a/}');
    Expect(1, 65131, '\p{Is_Decomposition_Type: small}', "");
    Expect(0, 65131, '\p{^Is_Decomposition_Type: small}', "");
    Expect(0, 65131, '\P{Is_Decomposition_Type: small}', "");
    Expect(1, 65131, '\P{^Is_Decomposition_Type: small}', "");
    Expect(0, 65132, '\p{Is_Decomposition_Type: small}', "");
    Expect(1, 65132, '\p{^Is_Decomposition_Type: small}', "");
    Expect(1, 65132, '\P{Is_Decomposition_Type: small}', "");
    Expect(0, 65132, '\P{^Is_Decomposition_Type: small}', "");
    Expect(1, 65131, '\p{Is_Decomposition_Type=- Small}', "");
    Expect(0, 65131, '\p{^Is_Decomposition_Type=- Small}', "");
    Expect(0, 65131, '\P{Is_Decomposition_Type=- Small}', "");
    Expect(1, 65131, '\P{^Is_Decomposition_Type=- Small}', "");
    Expect(0, 65132, '\p{Is_Decomposition_Type=- Small}', "");
    Expect(1, 65132, '\p{^Is_Decomposition_Type=- Small}', "");
    Expect(1, 65132, '\P{Is_Decomposition_Type=- Small}', "");
    Expect(0, 65132, '\P{^Is_Decomposition_Type=- Small}', "");
    Error('\p{Is_Dt=	_sml/a/}');
    Error('\P{Is_Dt=	_sml/a/}');
    Expect(1, 65131, '\p{Is_Dt=sml}', "");
    Expect(0, 65131, '\p{^Is_Dt=sml}', "");
    Expect(0, 65131, '\P{Is_Dt=sml}', "");
    Expect(1, 65131, '\P{^Is_Dt=sml}', "");
    Expect(0, 65132, '\p{Is_Dt=sml}', "");
    Expect(1, 65132, '\p{^Is_Dt=sml}', "");
    Expect(1, 65132, '\P{Is_Dt=sml}', "");
    Expect(0, 65132, '\P{^Is_Dt=sml}', "");
    Expect(1, 65131, '\p{Is_Dt=__Sml}', "");
    Expect(0, 65131, '\p{^Is_Dt=__Sml}', "");
    Expect(0, 65131, '\P{Is_Dt=__Sml}', "");
    Expect(1, 65131, '\P{^Is_Dt=__Sml}', "");
    Expect(0, 65132, '\p{Is_Dt=__Sml}', "");
    Expect(1, 65132, '\p{^Is_Dt=__Sml}', "");
    Expect(1, 65132, '\P{Is_Dt=__Sml}', "");
    Expect(0, 65132, '\P{^Is_Dt=__Sml}', "");
    Error('\p{Decomposition_Type:   	/a/SQUARE}');
    Error('\P{Decomposition_Type:   	/a/SQUARE}');
    Expect(1, 127547, '\p{Decomposition_Type=:\ASquare\z:}', "");;
    Expect(0, 127548, '\p{Decomposition_Type=:\ASquare\z:}', "");;
    Expect(1, 127547, '\p{Decomposition_Type=square}', "");
    Expect(0, 127547, '\p{^Decomposition_Type=square}', "");
    Expect(0, 127547, '\P{Decomposition_Type=square}', "");
    Expect(1, 127547, '\P{^Decomposition_Type=square}', "");
    Expect(0, 127548, '\p{Decomposition_Type=square}', "");
    Expect(1, 127548, '\p{^Decomposition_Type=square}', "");
    Expect(1, 127548, '\P{Decomposition_Type=square}', "");
    Expect(0, 127548, '\P{^Decomposition_Type=square}', "");
    Expect(1, 127547, '\p{Decomposition_Type=:\Asquare\z:}', "");;
    Expect(0, 127548, '\p{Decomposition_Type=:\Asquare\z:}', "");;
    Expect(1, 127547, '\p{Decomposition_Type:    Square}', "");
    Expect(0, 127547, '\p{^Decomposition_Type:    Square}', "");
    Expect(0, 127547, '\P{Decomposition_Type:    Square}', "");
    Expect(1, 127547, '\P{^Decomposition_Type:    Square}', "");
    Expect(0, 127548, '\p{Decomposition_Type:    Square}', "");
    Expect(1, 127548, '\p{^Decomposition_Type:    Square}', "");
    Expect(1, 127548, '\P{Decomposition_Type:    Square}', "");
    Expect(0, 127548, '\P{^Decomposition_Type:    Square}', "");
    Error('\p{Dt=:=SQR}');
    Error('\P{Dt=:=SQR}');
    Expect(1, 127547, '\p{Dt=:\ASqr\z:}', "");;
    Expect(0, 127548, '\p{Dt=:\ASqr\z:}', "");;
    Expect(1, 127547, '\p{Dt=sqr}', "");
    Expect(0, 127547, '\p{^Dt=sqr}', "");
    Expect(0, 127547, '\P{Dt=sqr}', "");
    Expect(1, 127547, '\P{^Dt=sqr}', "");
    Expect(0, 127548, '\p{Dt=sqr}', "");
    Expect(1, 127548, '\p{^Dt=sqr}', "");
    Expect(1, 127548, '\P{Dt=sqr}', "");
    Expect(0, 127548, '\P{^Dt=sqr}', "");
    Expect(1, 127547, '\p{Dt=:\Asqr\z:}', "");;
    Expect(0, 127548, '\p{Dt=:\Asqr\z:}', "");;
    Expect(1, 127547, '\p{Dt:   -Sqr}', "");
    Expect(0, 127547, '\p{^Dt:   -Sqr}', "");
    Expect(0, 127547, '\P{Dt:   -Sqr}', "");
    Expect(1, 127547, '\P{^Dt:   -Sqr}', "");
    Expect(0, 127548, '\p{Dt:   -Sqr}', "");
    Expect(1, 127548, '\p{^Dt:   -Sqr}', "");
    Expect(1, 127548, '\P{Dt:   -Sqr}', "");
    Expect(0, 127548, '\P{^Dt:   -Sqr}', "");
    Error('\p{Is_Decomposition_Type=	-square/a/}');
    Error('\P{Is_Decomposition_Type=	-square/a/}');
    Expect(1, 127547, '\p{Is_Decomposition_Type=square}', "");
    Expect(0, 127547, '\p{^Is_Decomposition_Type=square}', "");
    Expect(0, 127547, '\P{Is_Decomposition_Type=square}', "");
    Expect(1, 127547, '\P{^Is_Decomposition_Type=square}', "");
    Expect(0, 127548, '\p{Is_Decomposition_Type=square}', "");
    Expect(1, 127548, '\p{^Is_Decomposition_Type=square}', "");
    Expect(1, 127548, '\P{Is_Decomposition_Type=square}', "");
    Expect(0, 127548, '\P{^Is_Decomposition_Type=square}', "");
    Expect(1, 127547, '\p{Is_Decomposition_Type=	square}', "");
    Expect(0, 127547, '\p{^Is_Decomposition_Type=	square}', "");
    Expect(0, 127547, '\P{Is_Decomposition_Type=	square}', "");
    Expect(1, 127547, '\P{^Is_Decomposition_Type=	square}', "");
    Expect(0, 127548, '\p{Is_Decomposition_Type=	square}', "");
    Expect(1, 127548, '\p{^Is_Decomposition_Type=	square}', "");
    Expect(1, 127548, '\P{Is_Decomposition_Type=	square}', "");
    Expect(0, 127548, '\P{^Is_Decomposition_Type=	square}', "");
    Error('\p{Is_Dt: 	:=SQR}');
    Error('\P{Is_Dt: 	:=SQR}');
    Expect(1, 127547, '\p{Is_Dt=sqr}', "");
    Expect(0, 127547, '\p{^Is_Dt=sqr}', "");
    Expect(0, 127547, '\P{Is_Dt=sqr}', "");
    Expect(1, 127547, '\P{^Is_Dt=sqr}', "");
    Expect(0, 127548, '\p{Is_Dt=sqr}', "");
    Expect(1, 127548, '\p{^Is_Dt=sqr}', "");
    Expect(1, 127548, '\P{Is_Dt=sqr}', "");
    Expect(0, 127548, '\P{^Is_Dt=sqr}', "");
    Expect(1, 127547, '\p{Is_Dt=- SQR}', "");
    Expect(0, 127547, '\p{^Is_Dt=- SQR}', "");
    Expect(0, 127547, '\P{Is_Dt=- SQR}', "");
    Expect(1, 127547, '\P{^Is_Dt=- SQR}', "");
    Expect(0, 127548, '\p{Is_Dt=- SQR}', "");
    Expect(1, 127548, '\p{^Is_Dt=- SQR}', "");
    Expect(1, 127548, '\P{Is_Dt=- SQR}', "");
    Expect(0, 127548, '\P{^Is_Dt=- SQR}', "");
    Error('\p{Decomposition_Type=_ sub:=}');
    Error('\P{Decomposition_Type=_ sub:=}');
    Expect(1, 11388, '\p{Decomposition_Type=:\ASub\z:}', "");;
    Expect(0, 11389, '\p{Decomposition_Type=:\ASub\z:}', "");;
    Expect(1, 11388, '\p{Decomposition_Type=sub}', "");
    Expect(0, 11388, '\p{^Decomposition_Type=sub}', "");
    Expect(0, 11388, '\P{Decomposition_Type=sub}', "");
    Expect(1, 11388, '\P{^Decomposition_Type=sub}', "");
    Expect(0, 11389, '\p{Decomposition_Type=sub}', "");
    Expect(1, 11389, '\p{^Decomposition_Type=sub}', "");
    Expect(1, 11389, '\P{Decomposition_Type=sub}', "");
    Expect(0, 11389, '\P{^Decomposition_Type=sub}', "");
    Expect(1, 11388, '\p{Decomposition_Type=:\Asub\z:}', "");;
    Expect(0, 11389, '\p{Decomposition_Type=:\Asub\z:}', "");;
    Expect(1, 11388, '\p{Decomposition_Type: 	sub}', "");
    Expect(0, 11388, '\p{^Decomposition_Type: 	sub}', "");
    Expect(0, 11388, '\P{Decomposition_Type: 	sub}', "");
    Expect(1, 11388, '\P{^Decomposition_Type: 	sub}', "");
    Expect(0, 11389, '\p{Decomposition_Type: 	sub}', "");
    Expect(1, 11389, '\p{^Decomposition_Type: 	sub}', "");
    Expect(1, 11389, '\P{Decomposition_Type: 	sub}', "");
    Expect(0, 11389, '\P{^Decomposition_Type: 	sub}', "");
    Error('\p{Dt=--Sub/a/}');
    Error('\P{Dt=--Sub/a/}');
    Expect(1, 11388, '\p{Dt=:\ASub\z:}', "");;
    Expect(0, 11389, '\p{Dt=:\ASub\z:}', "");;
    Expect(1, 11388, '\p{Dt=sub}', "");
    Expect(0, 11388, '\p{^Dt=sub}', "");
    Expect(0, 11388, '\P{Dt=sub}', "");
    Expect(1, 11388, '\P{^Dt=sub}', "");
    Expect(0, 11389, '\p{Dt=sub}', "");
    Expect(1, 11389, '\p{^Dt=sub}', "");
    Expect(1, 11389, '\P{Dt=sub}', "");
    Expect(0, 11389, '\P{^Dt=sub}', "");
    Expect(1, 11388, '\p{Dt=:\Asub\z:}', "");;
    Expect(0, 11389, '\p{Dt=:\Asub\z:}', "");;
    Expect(1, 11388, '\p{Dt=_sub}', "");
    Expect(0, 11388, '\p{^Dt=_sub}', "");
    Expect(0, 11388, '\P{Dt=_sub}', "");
    Expect(1, 11388, '\P{^Dt=_sub}', "");
    Expect(0, 11389, '\p{Dt=_sub}', "");
    Expect(1, 11389, '\p{^Dt=_sub}', "");
    Expect(1, 11389, '\P{Dt=_sub}', "");
    Expect(0, 11389, '\P{^Dt=_sub}', "");
    Error('\p{Is_Decomposition_Type=_Sub:=}');
    Error('\P{Is_Decomposition_Type=_Sub:=}');
    Expect(1, 11388, '\p{Is_Decomposition_Type=sub}', "");
    Expect(0, 11388, '\p{^Is_Decomposition_Type=sub}', "");
    Expect(0, 11388, '\P{Is_Decomposition_Type=sub}', "");
    Expect(1, 11388, '\P{^Is_Decomposition_Type=sub}', "");
    Expect(0, 11389, '\p{Is_Decomposition_Type=sub}', "");
    Expect(1, 11389, '\p{^Is_Decomposition_Type=sub}', "");
    Expect(1, 11389, '\P{Is_Decomposition_Type=sub}', "");
    Expect(0, 11389, '\P{^Is_Decomposition_Type=sub}', "");
    Expect(1, 11388, '\p{Is_Decomposition_Type=--Sub}', "");
    Expect(0, 11388, '\p{^Is_Decomposition_Type=--Sub}', "");
    Expect(0, 11388, '\P{Is_Decomposition_Type=--Sub}', "");
    Expect(1, 11388, '\P{^Is_Decomposition_Type=--Sub}', "");
    Expect(0, 11389, '\p{Is_Decomposition_Type=--Sub}', "");
    Expect(1, 11389, '\p{^Is_Decomposition_Type=--Sub}', "");
    Expect(1, 11389, '\P{Is_Decomposition_Type=--Sub}', "");
    Expect(0, 11389, '\P{^Is_Decomposition_Type=--Sub}', "");
    Error('\p{Is_Dt=-_Sub/a/}');
    Error('\P{Is_Dt=-_Sub/a/}');
    Expect(1, 11388, '\p{Is_Dt=sub}', "");
    Expect(0, 11388, '\p{^Is_Dt=sub}', "");
    Expect(0, 11388, '\P{Is_Dt=sub}', "");
    Expect(1, 11388, '\P{^Is_Dt=sub}', "");
    Expect(0, 11389, '\p{Is_Dt=sub}', "");
    Expect(1, 11389, '\p{^Is_Dt=sub}', "");
    Expect(1, 11389, '\P{Is_Dt=sub}', "");
    Expect(0, 11389, '\P{^Is_Dt=sub}', "");
    Expect(1, 11388, '\p{Is_Dt=	_SUB}', "");
    Expect(0, 11388, '\p{^Is_Dt=	_SUB}', "");
    Expect(0, 11388, '\P{Is_Dt=	_SUB}', "");
    Expect(1, 11388, '\P{^Is_Dt=	_SUB}', "");
    Expect(0, 11389, '\p{Is_Dt=	_SUB}', "");
    Expect(1, 11389, '\p{^Is_Dt=	_SUB}', "");
    Expect(1, 11389, '\P{Is_Dt=	_SUB}', "");
    Expect(0, 11389, '\P{^Is_Dt=	_SUB}', "");
    Error('\p{Decomposition_Type=_ Super:=}');
    Error('\P{Decomposition_Type=_ Super:=}');
    Expect(1, 127340, '\p{Decomposition_Type=:\ASuper\z:}', "");;
    Expect(0, 127341, '\p{Decomposition_Type=:\ASuper\z:}', "");;
    Expect(1, 127340, '\p{Decomposition_Type=super}', "");
    Expect(0, 127340, '\p{^Decomposition_Type=super}', "");
    Expect(0, 127340, '\P{Decomposition_Type=super}', "");
    Expect(1, 127340, '\P{^Decomposition_Type=super}', "");
    Expect(0, 127341, '\p{Decomposition_Type=super}', "");
    Expect(1, 127341, '\p{^Decomposition_Type=super}', "");
    Expect(1, 127341, '\P{Decomposition_Type=super}', "");
    Expect(0, 127341, '\P{^Decomposition_Type=super}', "");
    Expect(1, 127340, '\p{Decomposition_Type=:\Asuper\z:}', "");;
    Expect(0, 127341, '\p{Decomposition_Type=:\Asuper\z:}', "");;
    Expect(1, 127340, '\p{Decomposition_Type=-	Super}', "");
    Expect(0, 127340, '\p{^Decomposition_Type=-	Super}', "");
    Expect(0, 127340, '\P{Decomposition_Type=-	Super}', "");
    Expect(1, 127340, '\P{^Decomposition_Type=-	Super}', "");
    Expect(0, 127341, '\p{Decomposition_Type=-	Super}', "");
    Expect(1, 127341, '\p{^Decomposition_Type=-	Super}', "");
    Expect(1, 127341, '\P{Decomposition_Type=-	Super}', "");
    Expect(0, 127341, '\P{^Decomposition_Type=-	Super}', "");
    Error('\p{Dt=SUP/a/}');
    Error('\P{Dt=SUP/a/}');
    Expect(1, 127340, '\p{Dt=:\ASup\z:}', "");;
    Expect(0, 127341, '\p{Dt=:\ASup\z:}', "");;
    Expect(1, 127340, '\p{Dt=sup}', "");
    Expect(0, 127340, '\p{^Dt=sup}', "");
    Expect(0, 127340, '\P{Dt=sup}', "");
    Expect(1, 127340, '\P{^Dt=sup}', "");
    Expect(0, 127341, '\p{Dt=sup}', "");
    Expect(1, 127341, '\p{^Dt=sup}', "");
    Expect(1, 127341, '\P{Dt=sup}', "");
    Expect(0, 127341, '\P{^Dt=sup}', "");
    Expect(1, 127340, '\p{Dt=:\Asup\z:}', "");;
    Expect(0, 127341, '\p{Dt=:\Asup\z:}', "");;
    Expect(1, 127340, '\p{Dt=  Sup}', "");
    Expect(0, 127340, '\p{^Dt=  Sup}', "");
    Expect(0, 127340, '\P{Dt=  Sup}', "");
    Expect(1, 127340, '\P{^Dt=  Sup}', "");
    Expect(0, 127341, '\p{Dt=  Sup}', "");
    Expect(1, 127341, '\p{^Dt=  Sup}', "");
    Expect(1, 127341, '\P{Dt=  Sup}', "");
    Expect(0, 127341, '\P{^Dt=  Sup}', "");
    Error('\p{Is_Decomposition_Type=/a/_Super}');
    Error('\P{Is_Decomposition_Type=/a/_Super}');
    Expect(1, 127340, '\p{Is_Decomposition_Type: super}', "");
    Expect(0, 127340, '\p{^Is_Decomposition_Type: super}', "");
    Expect(0, 127340, '\P{Is_Decomposition_Type: super}', "");
    Expect(1, 127340, '\P{^Is_Decomposition_Type: super}', "");
    Expect(0, 127341, '\p{Is_Decomposition_Type: super}', "");
    Expect(1, 127341, '\p{^Is_Decomposition_Type: super}', "");
    Expect(1, 127341, '\P{Is_Decomposition_Type: super}', "");
    Expect(0, 127341, '\P{^Is_Decomposition_Type: super}', "");
    Expect(1, 127340, '\p{Is_Decomposition_Type= _super}', "");
    Expect(0, 127340, '\p{^Is_Decomposition_Type= _super}', "");
    Expect(0, 127340, '\P{Is_Decomposition_Type= _super}', "");
    Expect(1, 127340, '\P{^Is_Decomposition_Type= _super}', "");
    Expect(0, 127341, '\p{Is_Decomposition_Type= _super}', "");
    Expect(1, 127341, '\p{^Is_Decomposition_Type= _super}', "");
    Expect(1, 127341, '\P{Is_Decomposition_Type= _super}', "");
    Expect(0, 127341, '\P{^Is_Decomposition_Type= _super}', "");
    Error('\p{Is_Dt=/a/ _SUP}');
    Error('\P{Is_Dt=/a/ _SUP}');
    Expect(1, 127340, '\p{Is_Dt=sup}', "");
    Expect(0, 127340, '\p{^Is_Dt=sup}', "");
    Expect(0, 127340, '\P{Is_Dt=sup}', "");
    Expect(1, 127340, '\P{^Is_Dt=sup}', "");
    Expect(0, 127341, '\p{Is_Dt=sup}', "");
    Expect(1, 127341, '\p{^Is_Dt=sup}', "");
    Expect(1, 127341, '\P{Is_Dt=sup}', "");
    Expect(0, 127341, '\P{^Is_Dt=sup}', "");
    Expect(1, 127340, '\p{Is_Dt= Sup}', "");
    Expect(0, 127340, '\p{^Is_Dt= Sup}', "");
    Expect(0, 127340, '\P{Is_Dt= Sup}', "");
    Expect(1, 127340, '\P{^Is_Dt= Sup}', "");
    Expect(0, 127341, '\p{Is_Dt= Sup}', "");
    Expect(1, 127341, '\p{^Is_Dt= Sup}', "");
    Expect(1, 127341, '\P{Is_Dt= Sup}', "");
    Expect(0, 127341, '\P{^Is_Dt= Sup}', "");
    Error('\p{Decomposition_Type:   /a/vertical}');
    Error('\P{Decomposition_Type:   /a/vertical}');
    Expect(1, 65096, '\p{Decomposition_Type=:\AVertical\z:}', "");;
    Expect(0, 65097, '\p{Decomposition_Type=:\AVertical\z:}', "");;
    Expect(1, 65096, '\p{Decomposition_Type=vertical}', "");
    Expect(0, 65096, '\p{^Decomposition_Type=vertical}', "");
    Expect(0, 65096, '\P{Decomposition_Type=vertical}', "");
    Expect(1, 65096, '\P{^Decomposition_Type=vertical}', "");
    Expect(0, 65097, '\p{Decomposition_Type=vertical}', "");
    Expect(1, 65097, '\p{^Decomposition_Type=vertical}', "");
    Expect(1, 65097, '\P{Decomposition_Type=vertical}', "");
    Expect(0, 65097, '\P{^Decomposition_Type=vertical}', "");
    Expect(1, 65096, '\p{Decomposition_Type=:\Avertical\z:}', "");;
    Expect(0, 65097, '\p{Decomposition_Type=:\Avertical\z:}', "");;
    Expect(1, 65096, '\p{Decomposition_Type= _vertical}', "");
    Expect(0, 65096, '\p{^Decomposition_Type= _vertical}', "");
    Expect(0, 65096, '\P{Decomposition_Type= _vertical}', "");
    Expect(1, 65096, '\P{^Decomposition_Type= _vertical}', "");
    Expect(0, 65097, '\p{Decomposition_Type= _vertical}', "");
    Expect(1, 65097, '\p{^Decomposition_Type= _vertical}', "");
    Expect(1, 65097, '\P{Decomposition_Type= _vertical}', "");
    Expect(0, 65097, '\P{^Decomposition_Type= _vertical}', "");
    Error('\p{Dt=_vert:=}');
    Error('\P{Dt=_vert:=}');
    Expect(1, 65096, '\p{Dt=:\AVert\z:}', "");;
    Expect(0, 65097, '\p{Dt=:\AVert\z:}', "");;
    Expect(1, 65096, '\p{Dt=vert}', "");
    Expect(0, 65096, '\p{^Dt=vert}', "");
    Expect(0, 65096, '\P{Dt=vert}', "");
    Expect(1, 65096, '\P{^Dt=vert}', "");
    Expect(0, 65097, '\p{Dt=vert}', "");
    Expect(1, 65097, '\p{^Dt=vert}', "");
    Expect(1, 65097, '\P{Dt=vert}', "");
    Expect(0, 65097, '\P{^Dt=vert}', "");
    Expect(1, 65096, '\p{Dt=:\Avert\z:}', "");;
    Expect(0, 65097, '\p{Dt=:\Avert\z:}', "");;
    Expect(1, 65096, '\p{Dt= Vert}', "");
    Expect(0, 65096, '\p{^Dt= Vert}', "");
    Expect(0, 65096, '\P{Dt= Vert}', "");
    Expect(1, 65096, '\P{^Dt= Vert}', "");
    Expect(0, 65097, '\p{Dt= Vert}', "");
    Expect(1, 65097, '\p{^Dt= Vert}', "");
    Expect(1, 65097, '\P{Dt= Vert}', "");
    Expect(0, 65097, '\P{^Dt= Vert}', "");
    Error('\p{Is_Decomposition_Type=:=-_vertical}');
    Error('\P{Is_Decomposition_Type=:=-_vertical}');
    Expect(1, 65096, '\p{Is_Decomposition_Type=vertical}', "");
    Expect(0, 65096, '\p{^Is_Decomposition_Type=vertical}', "");
    Expect(0, 65096, '\P{Is_Decomposition_Type=vertical}', "");
    Expect(1, 65096, '\P{^Is_Decomposition_Type=vertical}', "");
    Expect(0, 65097, '\p{Is_Decomposition_Type=vertical}', "");
    Expect(1, 65097, '\p{^Is_Decomposition_Type=vertical}', "");
    Expect(1, 65097, '\P{Is_Decomposition_Type=vertical}', "");
    Expect(0, 65097, '\P{^Is_Decomposition_Type=vertical}', "");
    Expect(1, 65096, '\p{Is_Decomposition_Type= 	Vertical}', "");
    Expect(0, 65096, '\p{^Is_Decomposition_Type= 	Vertical}', "");
    Expect(0, 65096, '\P{Is_Decomposition_Type= 	Vertical}', "");
    Expect(1, 65096, '\P{^Is_Decomposition_Type= 	Vertical}', "");
    Expect(0, 65097, '\p{Is_Decomposition_Type= 	Vertical}', "");
    Expect(1, 65097, '\p{^Is_Decomposition_Type= 	Vertical}', "");
    Expect(1, 65097, '\P{Is_Decomposition_Type= 	Vertical}', "");
    Expect(0, 65097, '\P{^Is_Decomposition_Type= 	Vertical}', "");
    Error('\p{Is_Dt=-_Vert:=}');
    Error('\P{Is_Dt=-_Vert:=}');
    Expect(1, 65096, '\p{Is_Dt=vert}', "");
    Expect(0, 65096, '\p{^Is_Dt=vert}', "");
    Expect(0, 65096, '\P{Is_Dt=vert}', "");
    Expect(1, 65096, '\P{^Is_Dt=vert}', "");
    Expect(0, 65097, '\p{Is_Dt=vert}', "");
    Expect(1, 65097, '\p{^Is_Dt=vert}', "");
    Expect(1, 65097, '\P{Is_Dt=vert}', "");
    Expect(0, 65097, '\P{^Is_Dt=vert}', "");
    Expect(1, 65096, '\p{Is_Dt=_	Vert}', "");
    Expect(0, 65096, '\p{^Is_Dt=_	Vert}', "");
    Expect(0, 65096, '\P{Is_Dt=_	Vert}', "");
    Expect(1, 65096, '\P{^Is_Dt=_	Vert}', "");
    Expect(0, 65097, '\p{Is_Dt=_	Vert}', "");
    Expect(1, 65097, '\p{^Is_Dt=_	Vert}', "");
    Expect(1, 65097, '\P{Is_Dt=_	Vert}', "");
    Expect(0, 65097, '\P{^Is_Dt=_	Vert}', "");
    Error('\p{Decomposition_Type=	/a/Wide}');
    Error('\P{Decomposition_Type=	/a/Wide}');
    Expect(1, 65510, '\p{Decomposition_Type=:\AWide\z:}', "");;
    Expect(0, 65511, '\p{Decomposition_Type=:\AWide\z:}', "");;
    Expect(1, 65510, '\p{Decomposition_Type=wide}', "");
    Expect(0, 65510, '\p{^Decomposition_Type=wide}', "");
    Expect(0, 65510, '\P{Decomposition_Type=wide}', "");
    Expect(1, 65510, '\P{^Decomposition_Type=wide}', "");
    Expect(0, 65511, '\p{Decomposition_Type=wide}', "");
    Expect(1, 65511, '\p{^Decomposition_Type=wide}', "");
    Expect(1, 65511, '\P{Decomposition_Type=wide}', "");
    Expect(0, 65511, '\P{^Decomposition_Type=wide}', "");
    Expect(1, 65510, '\p{Decomposition_Type=:\Awide\z:}', "");;
    Expect(0, 65511, '\p{Decomposition_Type=:\Awide\z:}', "");;
    Expect(1, 65510, '\p{Decomposition_Type: 	 Wide}', "");
    Expect(0, 65510, '\p{^Decomposition_Type: 	 Wide}', "");
    Expect(0, 65510, '\P{Decomposition_Type: 	 Wide}', "");
    Expect(1, 65510, '\P{^Decomposition_Type: 	 Wide}', "");
    Expect(0, 65511, '\p{Decomposition_Type: 	 Wide}', "");
    Expect(1, 65511, '\p{^Decomposition_Type: 	 Wide}', "");
    Expect(1, 65511, '\P{Decomposition_Type: 	 Wide}', "");
    Expect(0, 65511, '\P{^Decomposition_Type: 	 Wide}', "");
    Error('\p{Dt=:=-_wide}');
    Error('\P{Dt=:=-_wide}');
    Expect(1, 65510, '\p{Dt=:\AWide\z:}', "");;
    Expect(0, 65511, '\p{Dt=:\AWide\z:}', "");;
    Expect(1, 65510, '\p{Dt:	wide}', "");
    Expect(0, 65510, '\p{^Dt:	wide}', "");
    Expect(0, 65510, '\P{Dt:	wide}', "");
    Expect(1, 65510, '\P{^Dt:	wide}', "");
    Expect(0, 65511, '\p{Dt:	wide}', "");
    Expect(1, 65511, '\p{^Dt:	wide}', "");
    Expect(1, 65511, '\P{Dt:	wide}', "");
    Expect(0, 65511, '\P{^Dt:	wide}', "");
    Expect(1, 65510, '\p{Dt=:\Awide\z:}', "");;
    Expect(0, 65511, '\p{Dt=:\Awide\z:}', "");;
    Expect(1, 65510, '\p{Dt= 	wide}', "");
    Expect(0, 65510, '\p{^Dt= 	wide}', "");
    Expect(0, 65510, '\P{Dt= 	wide}', "");
    Expect(1, 65510, '\P{^Dt= 	wide}', "");
    Expect(0, 65511, '\p{Dt= 	wide}', "");
    Expect(1, 65511, '\p{^Dt= 	wide}', "");
    Expect(1, 65511, '\P{Dt= 	wide}', "");
    Expect(0, 65511, '\P{^Dt= 	wide}', "");
    Error('\p{Is_Decomposition_Type:	 Wide/a/}');
    Error('\P{Is_Decomposition_Type:	 Wide/a/}');
    Expect(1, 65510, '\p{Is_Decomposition_Type=wide}', "");
    Expect(0, 65510, '\p{^Is_Decomposition_Type=wide}', "");
    Expect(0, 65510, '\P{Is_Decomposition_Type=wide}', "");
    Expect(1, 65510, '\P{^Is_Decomposition_Type=wide}', "");
    Expect(0, 65511, '\p{Is_Decomposition_Type=wide}', "");
    Expect(1, 65511, '\p{^Is_Decomposition_Type=wide}', "");
    Expect(1, 65511, '\P{Is_Decomposition_Type=wide}', "");
    Expect(0, 65511, '\P{^Is_Decomposition_Type=wide}', "");
    Expect(1, 65510, '\p{Is_Decomposition_Type=_WIDE}', "");
    Expect(0, 65510, '\p{^Is_Decomposition_Type=_WIDE}', "");
    Expect(0, 65510, '\P{Is_Decomposition_Type=_WIDE}', "");
    Expect(1, 65510, '\P{^Is_Decomposition_Type=_WIDE}', "");
    Expect(0, 65511, '\p{Is_Decomposition_Type=_WIDE}', "");
    Expect(1, 65511, '\p{^Is_Decomposition_Type=_WIDE}', "");
    Expect(1, 65511, '\P{Is_Decomposition_Type=_WIDE}', "");
    Expect(0, 65511, '\P{^Is_Decomposition_Type=_WIDE}', "");
    Error('\p{Is_Dt=/a/Wide}');
    Error('\P{Is_Dt=/a/Wide}');
    Expect(1, 65510, '\p{Is_Dt=wide}', "");
    Expect(0, 65510, '\p{^Is_Dt=wide}', "");
    Expect(0, 65510, '\P{Is_Dt=wide}', "");
    Expect(1, 65510, '\P{^Is_Dt=wide}', "");
    Expect(0, 65511, '\p{Is_Dt=wide}', "");
    Expect(1, 65511, '\p{^Is_Dt=wide}', "");
    Expect(1, 65511, '\P{Is_Dt=wide}', "");
    Expect(0, 65511, '\P{^Is_Dt=wide}', "");
    Expect(1, 65510, '\p{Is_Dt=	 wide}', "");
    Expect(0, 65510, '\p{^Is_Dt=	 wide}', "");
    Expect(0, 65510, '\P{Is_Dt=	 wide}', "");
    Expect(1, 65510, '\P{^Is_Dt=	 wide}', "");
    Expect(0, 65511, '\p{Is_Dt=	 wide}', "");
    Expect(1, 65511, '\p{^Is_Dt=	 wide}', "");
    Expect(1, 65511, '\P{Is_Dt=	 wide}', "");
    Expect(0, 65511, '\P{^Is_Dt=	 wide}', "");
    Error('\p{eastasianwidth}');
    Error('\P{eastasianwidth}');
    Error('\p{ea}');
    Error('\P{ea}');
    Error('\p{East_Asian_Width=_/a/Ambiguous}');
    Error('\P{East_Asian_Width=_/a/Ambiguous}');
    Expect(1, 1114109, '\p{East_Asian_Width=:\AAmbiguous\z:}', "");;
    Expect(0, 918000, '\p{East_Asian_Width=:\AAmbiguous\z:}', "");;
    Expect(1, 1114109, '\p{East_Asian_Width:   ambiguous}', "");
    Expect(0, 1114109, '\p{^East_Asian_Width:   ambiguous}', "");
    Expect(0, 1114109, '\P{East_Asian_Width:   ambiguous}', "");
    Expect(1, 1114109, '\P{^East_Asian_Width:   ambiguous}', "");
    Expect(0, 918000, '\p{East_Asian_Width:   ambiguous}', "");
    Expect(1, 918000, '\p{^East_Asian_Width:   ambiguous}', "");
    Expect(1, 918000, '\P{East_Asian_Width:   ambiguous}', "");
    Expect(0, 918000, '\P{^East_Asian_Width:   ambiguous}', "");
    Expect(1, 1114109, '\p{East_Asian_Width=:\Aambiguous\z:}', "");;
    Expect(0, 918000, '\p{East_Asian_Width=:\Aambiguous\z:}', "");;
    Expect(1, 1114109, '\p{East_Asian_Width=-_AMBIGUOUS}', "");
    Expect(0, 1114109, '\p{^East_Asian_Width=-_AMBIGUOUS}', "");
    Expect(0, 1114109, '\P{East_Asian_Width=-_AMBIGUOUS}', "");
    Expect(1, 1114109, '\P{^East_Asian_Width=-_AMBIGUOUS}', "");
    Expect(0, 918000, '\p{East_Asian_Width=-_AMBIGUOUS}', "");
    Expect(1, 918000, '\p{^East_Asian_Width=-_AMBIGUOUS}', "");
    Expect(1, 918000, '\P{East_Asian_Width=-_AMBIGUOUS}', "");
    Expect(0, 918000, '\P{^East_Asian_Width=-_AMBIGUOUS}', "");
    Error('\p{Ea=/a/__A}');
    Error('\P{Ea=/a/__A}');
    Expect(1, 1114109, '\p{Ea=:\AA\z:}', "");;
    Expect(0, 918000, '\p{Ea=:\AA\z:}', "");;
    Expect(1, 1114109, '\p{Ea:	a}', "");
    Expect(0, 1114109, '\p{^Ea:	a}', "");
    Expect(0, 1114109, '\P{Ea:	a}', "");
    Expect(1, 1114109, '\P{^Ea:	a}', "");
    Expect(0, 918000, '\p{Ea:	a}', "");
    Expect(1, 918000, '\p{^Ea:	a}', "");
    Expect(1, 918000, '\P{Ea:	a}', "");
    Expect(0, 918000, '\P{^Ea:	a}', "");
    Expect(1, 1114109, '\p{Ea=:\Aa\z:}', "");;
    Expect(0, 918000, '\p{Ea=:\Aa\z:}', "");;
    Expect(1, 1114109, '\p{Ea=  a}', "");
    Expect(0, 1114109, '\p{^Ea=  a}', "");
    Expect(0, 1114109, '\P{Ea=  a}', "");
    Expect(1, 1114109, '\P{^Ea=  a}', "");
    Expect(0, 918000, '\p{Ea=  a}', "");
    Expect(1, 918000, '\p{^Ea=  a}', "");
    Expect(1, 918000, '\P{Ea=  a}', "");
    Expect(0, 918000, '\P{^Ea=  a}', "");
    Error('\p{Is_East_Asian_Width=:=-Ambiguous}');
    Error('\P{Is_East_Asian_Width=:=-Ambiguous}');
    Expect(1, 1114109, '\p{Is_East_Asian_Width=ambiguous}', "");
    Expect(0, 1114109, '\p{^Is_East_Asian_Width=ambiguous}', "");
    Expect(0, 1114109, '\P{Is_East_Asian_Width=ambiguous}', "");
    Expect(1, 1114109, '\P{^Is_East_Asian_Width=ambiguous}', "");
    Expect(0, 918000, '\p{Is_East_Asian_Width=ambiguous}', "");
    Expect(1, 918000, '\p{^Is_East_Asian_Width=ambiguous}', "");
    Expect(1, 918000, '\P{Is_East_Asian_Width=ambiguous}', "");
    Expect(0, 918000, '\P{^Is_East_Asian_Width=ambiguous}', "");
    Expect(1, 1114109, '\p{Is_East_Asian_Width:	  AMBIGUOUS}', "");
    Expect(0, 1114109, '\p{^Is_East_Asian_Width:	  AMBIGUOUS}', "");
    Expect(0, 1114109, '\P{Is_East_Asian_Width:	  AMBIGUOUS}', "");
    Expect(1, 1114109, '\P{^Is_East_Asian_Width:	  AMBIGUOUS}', "");
    Expect(0, 918000, '\p{Is_East_Asian_Width:	  AMBIGUOUS}', "");
    Expect(1, 918000, '\p{^Is_East_Asian_Width:	  AMBIGUOUS}', "");
    Expect(1, 918000, '\P{Is_East_Asian_Width:	  AMBIGUOUS}', "");
    Expect(0, 918000, '\P{^Is_East_Asian_Width:	  AMBIGUOUS}', "");
    Error('\p{Is_Ea=--a:=}');
    Error('\P{Is_Ea=--a:=}');
    Expect(1, 1114109, '\p{Is_Ea=a}', "");
    Expect(0, 1114109, '\p{^Is_Ea=a}', "");
    Expect(0, 1114109, '\P{Is_Ea=a}', "");
    Expect(1, 1114109, '\P{^Is_Ea=a}', "");
    Expect(0, 918000, '\p{Is_Ea=a}', "");
    Expect(1, 918000, '\p{^Is_Ea=a}', "");
    Expect(1, 918000, '\P{Is_Ea=a}', "");
    Expect(0, 918000, '\P{^Is_Ea=a}', "");
    Expect(1, 1114109, '\p{Is_Ea=--a}', "");
    Expect(0, 1114109, '\p{^Is_Ea=--a}', "");
    Expect(0, 1114109, '\P{Is_Ea=--a}', "");
    Expect(1, 1114109, '\P{^Is_Ea=--a}', "");
    Expect(0, 918000, '\p{Is_Ea=--a}', "");
    Expect(1, 918000, '\p{^Is_Ea=--a}', "");
    Expect(1, 918000, '\P{Is_Ea=--a}', "");
    Expect(0, 918000, '\P{^Is_Ea=--a}', "");
    Error('\p{East_Asian_Width=	Fullwidth/a/}');
    Error('\P{East_Asian_Width=	Fullwidth/a/}');
    Expect(1, 65510, '\p{East_Asian_Width=:\AFullwidth\z:}', "");;
    Expect(0, 65511, '\p{East_Asian_Width=:\AFullwidth\z:}', "");;
    Expect(1, 65510, '\p{East_Asian_Width=fullwidth}', "");
    Expect(0, 65510, '\p{^East_Asian_Width=fullwidth}', "");
    Expect(0, 65510, '\P{East_Asian_Width=fullwidth}', "");
    Expect(1, 65510, '\P{^East_Asian_Width=fullwidth}', "");
    Expect(0, 65511, '\p{East_Asian_Width=fullwidth}', "");
    Expect(1, 65511, '\p{^East_Asian_Width=fullwidth}', "");
    Expect(1, 65511, '\P{East_Asian_Width=fullwidth}', "");
    Expect(0, 65511, '\P{^East_Asian_Width=fullwidth}', "");
    Expect(1, 65510, '\p{East_Asian_Width=:\Afullwidth\z:}', "");;
    Expect(0, 65511, '\p{East_Asian_Width=:\Afullwidth\z:}', "");;
    Expect(1, 65510, '\p{East_Asian_Width=	Fullwidth}', "");
    Expect(0, 65510, '\p{^East_Asian_Width=	Fullwidth}', "");
    Expect(0, 65510, '\P{East_Asian_Width=	Fullwidth}', "");
    Expect(1, 65510, '\P{^East_Asian_Width=	Fullwidth}', "");
    Expect(0, 65511, '\p{East_Asian_Width=	Fullwidth}', "");
    Expect(1, 65511, '\p{^East_Asian_Width=	Fullwidth}', "");
    Expect(1, 65511, '\P{East_Asian_Width=	Fullwidth}', "");
    Expect(0, 65511, '\P{^East_Asian_Width=	Fullwidth}', "");
    Error('\p{Ea= -F/a/}');
    Error('\P{Ea= -F/a/}');
    Expect(1, 65510, '\p{Ea=:\AF\z:}', "");;
    Expect(0, 65511, '\p{Ea=:\AF\z:}', "");;
    Expect(1, 65510, '\p{Ea=f}', "");
    Expect(0, 65510, '\p{^Ea=f}', "");
    Expect(0, 65510, '\P{Ea=f}', "");
    Expect(1, 65510, '\P{^Ea=f}', "");
    Expect(0, 65511, '\p{Ea=f}', "");
    Expect(1, 65511, '\p{^Ea=f}', "");
    Expect(1, 65511, '\P{Ea=f}', "");
    Expect(0, 65511, '\P{^Ea=f}', "");
    Expect(1, 65510, '\p{Ea=:\Af\z:}', "");;
    Expect(0, 65511, '\p{Ea=:\Af\z:}', "");;
    Expect(1, 65510, '\p{Ea=	f}', "");
    Expect(0, 65510, '\p{^Ea=	f}', "");
    Expect(0, 65510, '\P{Ea=	f}', "");
    Expect(1, 65510, '\P{^Ea=	f}', "");
    Expect(0, 65511, '\p{Ea=	f}', "");
    Expect(1, 65511, '\p{^Ea=	f}', "");
    Expect(1, 65511, '\P{Ea=	f}', "");
    Expect(0, 65511, '\P{^Ea=	f}', "");
    Error('\p{Is_East_Asian_Width:	:=  fullwidth}');
    Error('\P{Is_East_Asian_Width:	:=  fullwidth}');
    Expect(1, 65510, '\p{Is_East_Asian_Width=fullwidth}', "");
    Expect(0, 65510, '\p{^Is_East_Asian_Width=fullwidth}', "");
    Expect(0, 65510, '\P{Is_East_Asian_Width=fullwidth}', "");
    Expect(1, 65510, '\P{^Is_East_Asian_Width=fullwidth}', "");
    Expect(0, 65511, '\p{Is_East_Asian_Width=fullwidth}', "");
    Expect(1, 65511, '\p{^Is_East_Asian_Width=fullwidth}', "");
    Expect(1, 65511, '\P{Is_East_Asian_Width=fullwidth}', "");
    Expect(0, 65511, '\P{^Is_East_Asian_Width=fullwidth}', "");
    Expect(1, 65510, '\p{Is_East_Asian_Width=-_fullwidth}', "");
    Expect(0, 65510, '\p{^Is_East_Asian_Width=-_fullwidth}', "");
    Expect(0, 65510, '\P{Is_East_Asian_Width=-_fullwidth}', "");
    Expect(1, 65510, '\P{^Is_East_Asian_Width=-_fullwidth}', "");
    Expect(0, 65511, '\p{Is_East_Asian_Width=-_fullwidth}', "");
    Expect(1, 65511, '\p{^Is_East_Asian_Width=-_fullwidth}', "");
    Expect(1, 65511, '\P{Is_East_Asian_Width=-_fullwidth}', "");
    Expect(0, 65511, '\P{^Is_East_Asian_Width=-_fullwidth}', "");
    Error('\p{Is_Ea=/a/_F}');
    Error('\P{Is_Ea=/a/_F}');
    Expect(1, 65510, '\p{Is_Ea=f}', "");
    Expect(0, 65510, '\p{^Is_Ea=f}', "");
    Expect(0, 65510, '\P{Is_Ea=f}', "");
    Expect(1, 65510, '\P{^Is_Ea=f}', "");
    Expect(0, 65511, '\p{Is_Ea=f}', "");
    Expect(1, 65511, '\p{^Is_Ea=f}', "");
    Expect(1, 65511, '\P{Is_Ea=f}', "");
    Expect(0, 65511, '\P{^Is_Ea=f}', "");
    Expect(1, 65510, '\p{Is_Ea=		F}', "");
    Expect(0, 65510, '\p{^Is_Ea=		F}', "");
    Expect(0, 65510, '\P{Is_Ea=		F}', "");
    Expect(1, 65510, '\P{^Is_Ea=		F}', "");
    Expect(0, 65511, '\p{Is_Ea=		F}', "");
    Expect(1, 65511, '\p{^Is_Ea=		F}', "");
    Expect(1, 65511, '\P{Is_Ea=		F}', "");
    Expect(0, 65511, '\P{^Is_Ea=		F}', "");
    Error('\p{East_Asian_Width=/a/_Halfwidth}');
    Error('\P{East_Asian_Width=/a/_Halfwidth}');
    Expect(1, 65518, '\p{East_Asian_Width=:\AHalfwidth\z:}', "");;
    Expect(0, 65519, '\p{East_Asian_Width=:\AHalfwidth\z:}', "");;
    Expect(1, 65518, '\p{East_Asian_Width=halfwidth}', "");
    Expect(0, 65518, '\p{^East_Asian_Width=halfwidth}', "");
    Expect(0, 65518, '\P{East_Asian_Width=halfwidth}', "");
    Expect(1, 65518, '\P{^East_Asian_Width=halfwidth}', "");
    Expect(0, 65519, '\p{East_Asian_Width=halfwidth}', "");
    Expect(1, 65519, '\p{^East_Asian_Width=halfwidth}', "");
    Expect(1, 65519, '\P{East_Asian_Width=halfwidth}', "");
    Expect(0, 65519, '\P{^East_Asian_Width=halfwidth}', "");
    Expect(1, 65518, '\p{East_Asian_Width=:\Ahalfwidth\z:}', "");;
    Expect(0, 65519, '\p{East_Asian_Width=:\Ahalfwidth\z:}', "");;
    Expect(1, 65518, '\p{East_Asian_Width: -Halfwidth}', "");
    Expect(0, 65518, '\p{^East_Asian_Width: -Halfwidth}', "");
    Expect(0, 65518, '\P{East_Asian_Width: -Halfwidth}', "");
    Expect(1, 65518, '\P{^East_Asian_Width: -Halfwidth}', "");
    Expect(0, 65519, '\p{East_Asian_Width: -Halfwidth}', "");
    Expect(1, 65519, '\p{^East_Asian_Width: -Halfwidth}', "");
    Expect(1, 65519, '\P{East_Asian_Width: -Halfwidth}', "");
    Expect(0, 65519, '\P{^East_Asian_Width: -Halfwidth}', "");
    Error('\p{Ea=_	h:=}');
    Error('\P{Ea=_	h:=}');
    Expect(1, 65518, '\p{Ea=:\AH\z:}', "");;
    Expect(0, 65519, '\p{Ea=:\AH\z:}', "");;
    Expect(1, 65518, '\p{Ea=h}', "");
    Expect(0, 65518, '\p{^Ea=h}', "");
    Expect(0, 65518, '\P{Ea=h}', "");
    Expect(1, 65518, '\P{^Ea=h}', "");
    Expect(0, 65519, '\p{Ea=h}', "");
    Expect(1, 65519, '\p{^Ea=h}', "");
    Expect(1, 65519, '\P{Ea=h}', "");
    Expect(0, 65519, '\P{^Ea=h}', "");
    Expect(1, 65518, '\p{Ea=:\Ah\z:}', "");;
    Expect(0, 65519, '\p{Ea=:\Ah\z:}', "");;
    Expect(1, 65518, '\p{Ea:   _h}', "");
    Expect(0, 65518, '\p{^Ea:   _h}', "");
    Expect(0, 65518, '\P{Ea:   _h}', "");
    Expect(1, 65518, '\P{^Ea:   _h}', "");
    Expect(0, 65519, '\p{Ea:   _h}', "");
    Expect(1, 65519, '\p{^Ea:   _h}', "");
    Expect(1, 65519, '\P{Ea:   _h}', "");
    Expect(0, 65519, '\P{^Ea:   _h}', "");
    Error('\p{Is_East_Asian_Width=:= 	Halfwidth}');
    Error('\P{Is_East_Asian_Width=:= 	Halfwidth}');
    Expect(1, 65518, '\p{Is_East_Asian_Width=halfwidth}', "");
    Expect(0, 65518, '\p{^Is_East_Asian_Width=halfwidth}', "");
    Expect(0, 65518, '\P{Is_East_Asian_Width=halfwidth}', "");
    Expect(1, 65518, '\P{^Is_East_Asian_Width=halfwidth}', "");
    Expect(0, 65519, '\p{Is_East_Asian_Width=halfwidth}', "");
    Expect(1, 65519, '\p{^Is_East_Asian_Width=halfwidth}', "");
    Expect(1, 65519, '\P{Is_East_Asian_Width=halfwidth}', "");
    Expect(0, 65519, '\P{^Is_East_Asian_Width=halfwidth}', "");
    Expect(1, 65518, '\p{Is_East_Asian_Width:   - halfwidth}', "");
    Expect(0, 65518, '\p{^Is_East_Asian_Width:   - halfwidth}', "");
    Expect(0, 65518, '\P{Is_East_Asian_Width:   - halfwidth}', "");
    Expect(1, 65518, '\P{^Is_East_Asian_Width:   - halfwidth}', "");
    Expect(0, 65519, '\p{Is_East_Asian_Width:   - halfwidth}', "");
    Expect(1, 65519, '\p{^Is_East_Asian_Width:   - halfwidth}', "");
    Expect(1, 65519, '\P{Is_East_Asian_Width:   - halfwidth}', "");
    Expect(0, 65519, '\P{^Is_East_Asian_Width:   - halfwidth}', "");
    Error('\p{Is_Ea=/a/-_h}');
    Error('\P{Is_Ea=/a/-_h}');
    Expect(1, 65518, '\p{Is_Ea=h}', "");
    Expect(0, 65518, '\p{^Is_Ea=h}', "");
    Expect(0, 65518, '\P{Is_Ea=h}', "");
    Expect(1, 65518, '\P{^Is_Ea=h}', "");
    Expect(0, 65519, '\p{Is_Ea=h}', "");
    Expect(1, 65519, '\p{^Is_Ea=h}', "");
    Expect(1, 65519, '\P{Is_Ea=h}', "");
    Expect(0, 65519, '\P{^Is_Ea=h}', "");
    Expect(1, 65518, '\p{Is_Ea=  H}', "");
    Expect(0, 65518, '\p{^Is_Ea=  H}', "");
    Expect(0, 65518, '\P{Is_Ea=  H}', "");
    Expect(1, 65518, '\P{^Is_Ea=  H}', "");
    Expect(0, 65519, '\p{Is_Ea=  H}', "");
    Expect(1, 65519, '\p{^Is_Ea=  H}', "");
    Expect(1, 65519, '\P{Is_Ea=  H}', "");
    Expect(0, 65519, '\P{^Is_Ea=  H}', "");
    Error('\p{East_Asian_Width=--Neutral:=}');
    Error('\P{East_Asian_Width=--Neutral:=}');
    Expect(1, 918000, '\p{East_Asian_Width=:\ANeutral\z:}', "");;
    Expect(0, 1114109, '\p{East_Asian_Width=:\ANeutral\z:}', "");;
    Expect(1, 918000, '\p{East_Asian_Width:   neutral}', "");
    Expect(0, 918000, '\p{^East_Asian_Width:   neutral}', "");
    Expect(0, 918000, '\P{East_Asian_Width:   neutral}', "");
    Expect(1, 918000, '\P{^East_Asian_Width:   neutral}', "");
    Expect(0, 1114109, '\p{East_Asian_Width:   neutral}', "");
    Expect(1, 1114109, '\p{^East_Asian_Width:   neutral}', "");
    Expect(1, 1114109, '\P{East_Asian_Width:   neutral}', "");
    Expect(0, 1114109, '\P{^East_Asian_Width:   neutral}', "");
    Expect(1, 918000, '\p{East_Asian_Width=:\Aneutral\z:}', "");;
    Expect(0, 1114109, '\p{East_Asian_Width=:\Aneutral\z:}', "");;
    Expect(1, 918000, '\p{East_Asian_Width=	Neutral}', "");
    Expect(0, 918000, '\p{^East_Asian_Width=	Neutral}', "");
    Expect(0, 918000, '\P{East_Asian_Width=	Neutral}', "");
    Expect(1, 918000, '\P{^East_Asian_Width=	Neutral}', "");
    Expect(0, 1114109, '\p{East_Asian_Width=	Neutral}', "");
    Expect(1, 1114109, '\p{^East_Asian_Width=	Neutral}', "");
    Expect(1, 1114109, '\P{East_Asian_Width=	Neutral}', "");
    Expect(0, 1114109, '\P{^East_Asian_Width=	Neutral}', "");
    Error('\p{Ea=/a/ n}');
    Error('\P{Ea=/a/ n}');
    Expect(1, 918000, '\p{Ea=:\AN\z:}', "");;
    Expect(0, 1114109, '\p{Ea=:\AN\z:}', "");;
    Expect(1, 918000, '\p{Ea=n}', "");
    Expect(0, 918000, '\p{^Ea=n}', "");
    Expect(0, 918000, '\P{Ea=n}', "");
    Expect(1, 918000, '\P{^Ea=n}', "");
    Expect(0, 1114109, '\p{Ea=n}', "");
    Expect(1, 1114109, '\p{^Ea=n}', "");
    Expect(1, 1114109, '\P{Ea=n}', "");
    Expect(0, 1114109, '\P{^Ea=n}', "");
    Expect(1, 918000, '\p{Ea=:\An\z:}', "");;
    Expect(0, 1114109, '\p{Ea=:\An\z:}', "");;
    Expect(1, 918000, '\p{Ea=	-N}', "");
    Expect(0, 918000, '\p{^Ea=	-N}', "");
    Expect(0, 918000, '\P{Ea=	-N}', "");
    Expect(1, 918000, '\P{^Ea=	-N}', "");
    Expect(0, 1114109, '\p{Ea=	-N}', "");
    Expect(1, 1114109, '\p{^Ea=	-N}', "");
    Expect(1, 1114109, '\P{Ea=	-N}', "");
    Expect(0, 1114109, '\P{^Ea=	-N}', "");
    Error('\p{Is_East_Asian_Width:   := 	Neutral}');
    Error('\P{Is_East_Asian_Width:   := 	Neutral}');
    Expect(1, 918000, '\p{Is_East_Asian_Width=neutral}', "");
    Expect(0, 918000, '\p{^Is_East_Asian_Width=neutral}', "");
    Expect(0, 918000, '\P{Is_East_Asian_Width=neutral}', "");
    Expect(1, 918000, '\P{^Is_East_Asian_Width=neutral}', "");
    Expect(0, 1114109, '\p{Is_East_Asian_Width=neutral}', "");
    Expect(1, 1114109, '\p{^Is_East_Asian_Width=neutral}', "");
    Expect(1, 1114109, '\P{Is_East_Asian_Width=neutral}', "");
    Expect(0, 1114109, '\P{^Is_East_Asian_Width=neutral}', "");
    Expect(1, 918000, '\p{Is_East_Asian_Width=-	Neutral}', "");
    Expect(0, 918000, '\p{^Is_East_Asian_Width=-	Neutral}', "");
    Expect(0, 918000, '\P{Is_East_Asian_Width=-	Neutral}', "");
    Expect(1, 918000, '\P{^Is_East_Asian_Width=-	Neutral}', "");
    Expect(0, 1114109, '\p{Is_East_Asian_Width=-	Neutral}', "");
    Expect(1, 1114109, '\p{^Is_East_Asian_Width=-	Neutral}', "");
    Expect(1, 1114109, '\P{Is_East_Asian_Width=-	Neutral}', "");
    Expect(0, 1114109, '\P{^Is_East_Asian_Width=-	Neutral}', "");
    Error('\p{Is_Ea=-/a/N}');
    Error('\P{Is_Ea=-/a/N}');
    Expect(1, 918000, '\p{Is_Ea=n}', "");
    Expect(0, 918000, '\p{^Is_Ea=n}', "");
    Expect(0, 918000, '\P{Is_Ea=n}', "");
    Expect(1, 918000, '\P{^Is_Ea=n}', "");
    Expect(0, 1114109, '\p{Is_Ea=n}', "");
    Expect(1, 1114109, '\p{^Is_Ea=n}', "");
    Expect(1, 1114109, '\P{Is_Ea=n}', "");
    Expect(0, 1114109, '\P{^Is_Ea=n}', "");
    Expect(1, 918000, '\p{Is_Ea=- n}', "");
    Expect(0, 918000, '\p{^Is_Ea=- n}', "");
    Expect(0, 918000, '\P{Is_Ea=- n}', "");
    Expect(1, 918000, '\P{^Is_Ea=- n}', "");
    Expect(0, 1114109, '\p{Is_Ea=- n}', "");
    Expect(1, 1114109, '\p{^Is_Ea=- n}', "");
    Expect(1, 1114109, '\P{Is_Ea=- n}', "");
    Expect(0, 1114109, '\P{^Is_Ea=- n}', "");
    Error('\p{East_Asian_Width:	_-Narrow:=}');
    Error('\P{East_Asian_Width:	_-Narrow:=}');
    Expect(1, 10630, '\p{East_Asian_Width=:\ANarrow\z:}', "");;
    Expect(0, 10631, '\p{East_Asian_Width=:\ANarrow\z:}', "");;
    Expect(1, 10630, '\p{East_Asian_Width=narrow}', "");
    Expect(0, 10630, '\p{^East_Asian_Width=narrow}', "");
    Expect(0, 10630, '\P{East_Asian_Width=narrow}', "");
    Expect(1, 10630, '\P{^East_Asian_Width=narrow}', "");
    Expect(0, 10631, '\p{East_Asian_Width=narrow}', "");
    Expect(1, 10631, '\p{^East_Asian_Width=narrow}', "");
    Expect(1, 10631, '\P{East_Asian_Width=narrow}', "");
    Expect(0, 10631, '\P{^East_Asian_Width=narrow}', "");
    Expect(1, 10630, '\p{East_Asian_Width=:\Anarrow\z:}', "");;
    Expect(0, 10631, '\p{East_Asian_Width=:\Anarrow\z:}', "");;
    Expect(1, 10630, '\p{East_Asian_Width:	_Narrow}', "");
    Expect(0, 10630, '\p{^East_Asian_Width:	_Narrow}', "");
    Expect(0, 10630, '\P{East_Asian_Width:	_Narrow}', "");
    Expect(1, 10630, '\P{^East_Asian_Width:	_Narrow}', "");
    Expect(0, 10631, '\p{East_Asian_Width:	_Narrow}', "");
    Expect(1, 10631, '\p{^East_Asian_Width:	_Narrow}', "");
    Expect(1, 10631, '\P{East_Asian_Width:	_Narrow}', "");
    Expect(0, 10631, '\P{^East_Asian_Width:	_Narrow}', "");
    Error('\p{Ea: 	Na/a/}');
    Error('\P{Ea: 	Na/a/}');
    Expect(1, 10630, '\p{Ea=:\ANa\z:}', "");;
    Expect(0, 10631, '\p{Ea=:\ANa\z:}', "");;
    Expect(1, 10630, '\p{Ea:na}', "");
    Expect(0, 10630, '\p{^Ea:na}', "");
    Expect(0, 10630, '\P{Ea:na}', "");
    Expect(1, 10630, '\P{^Ea:na}', "");
    Expect(0, 10631, '\p{Ea:na}', "");
    Expect(1, 10631, '\p{^Ea:na}', "");
    Expect(1, 10631, '\P{Ea:na}', "");
    Expect(0, 10631, '\P{^Ea:na}', "");
    Expect(1, 10630, '\p{Ea=:\Ana\z:}', "");;
    Expect(0, 10631, '\p{Ea=:\Ana\z:}', "");;
    Expect(1, 10630, '\p{Ea=	na}', "");
    Expect(0, 10630, '\p{^Ea=	na}', "");
    Expect(0, 10630, '\P{Ea=	na}', "");
    Expect(1, 10630, '\P{^Ea=	na}', "");
    Expect(0, 10631, '\p{Ea=	na}', "");
    Expect(1, 10631, '\p{^Ea=	na}', "");
    Expect(1, 10631, '\P{Ea=	na}', "");
    Expect(0, 10631, '\P{^Ea=	na}', "");
    Error('\p{Is_East_Asian_Width:	:=	NARROW}');
    Error('\P{Is_East_Asian_Width:	:=	NARROW}');
    Expect(1, 10630, '\p{Is_East_Asian_Width: narrow}', "");
    Expect(0, 10630, '\p{^Is_East_Asian_Width: narrow}', "");
    Expect(0, 10630, '\P{Is_East_Asian_Width: narrow}', "");
    Expect(1, 10630, '\P{^Is_East_Asian_Width: narrow}', "");
    Expect(0, 10631, '\p{Is_East_Asian_Width: narrow}', "");
    Expect(1, 10631, '\p{^Is_East_Asian_Width: narrow}', "");
    Expect(1, 10631, '\P{Is_East_Asian_Width: narrow}', "");
    Expect(0, 10631, '\P{^Is_East_Asian_Width: narrow}', "");
    Expect(1, 10630, '\p{Is_East_Asian_Width=_	Narrow}', "");
    Expect(0, 10630, '\p{^Is_East_Asian_Width=_	Narrow}', "");
    Expect(0, 10630, '\P{Is_East_Asian_Width=_	Narrow}', "");
    Expect(1, 10630, '\P{^Is_East_Asian_Width=_	Narrow}', "");
    Expect(0, 10631, '\p{Is_East_Asian_Width=_	Narrow}', "");
    Expect(1, 10631, '\p{^Is_East_Asian_Width=_	Narrow}', "");
    Expect(1, 10631, '\P{Is_East_Asian_Width=_	Narrow}', "");
    Expect(0, 10631, '\P{^Is_East_Asian_Width=_	Narrow}', "");
    Error('\p{Is_Ea:		na/a/}');
    Error('\P{Is_Ea:		na/a/}');
    Expect(1, 10630, '\p{Is_Ea: na}', "");
    Expect(0, 10630, '\p{^Is_Ea: na}', "");
    Expect(0, 10630, '\P{Is_Ea: na}', "");
    Expect(1, 10630, '\P{^Is_Ea: na}', "");
    Expect(0, 10631, '\p{Is_Ea: na}', "");
    Expect(1, 10631, '\p{^Is_Ea: na}', "");
    Expect(1, 10631, '\P{Is_Ea: na}', "");
    Expect(0, 10631, '\P{^Is_Ea: na}', "");
    Expect(1, 10630, '\p{Is_Ea= Na}', "");
    Expect(0, 10630, '\p{^Is_Ea= Na}', "");
    Expect(0, 10630, '\P{Is_Ea= Na}', "");
    Expect(1, 10630, '\P{^Is_Ea= Na}', "");
    Expect(0, 10631, '\p{Is_Ea= Na}', "");
    Expect(1, 10631, '\p{^Is_Ea= Na}', "");
    Expect(1, 10631, '\P{Is_Ea= Na}', "");
    Expect(0, 10631, '\P{^Is_Ea= Na}', "");
    Error('\p{East_Asian_Width=:=	Wide}');
    Error('\P{East_Asian_Width=:=	Wide}');
    Expect(1, 262141, '\p{East_Asian_Width=:\AWide\z:}', "");;
    Expect(0, 262144, '\p{East_Asian_Width=:\AWide\z:}', "");;
    Expect(1, 262141, '\p{East_Asian_Width=wide}', "");
    Expect(0, 262141, '\p{^East_Asian_Width=wide}', "");
    Expect(0, 262141, '\P{East_Asian_Width=wide}', "");
    Expect(1, 262141, '\P{^East_Asian_Width=wide}', "");
    Expect(0, 262144, '\p{East_Asian_Width=wide}', "");
    Expect(1, 262144, '\p{^East_Asian_Width=wide}', "");
    Expect(1, 262144, '\P{East_Asian_Width=wide}', "");
    Expect(0, 262144, '\P{^East_Asian_Width=wide}', "");
    Expect(1, 262141, '\p{East_Asian_Width=:\Awide\z:}', "");;
    Expect(0, 262144, '\p{East_Asian_Width=:\Awide\z:}', "");;
    Expect(1, 262141, '\p{East_Asian_Width=-WIDE}', "");
    Expect(0, 262141, '\p{^East_Asian_Width=-WIDE}', "");
    Expect(0, 262141, '\P{East_Asian_Width=-WIDE}', "");
    Expect(1, 262141, '\P{^East_Asian_Width=-WIDE}', "");
    Expect(0, 262144, '\p{East_Asian_Width=-WIDE}', "");
    Expect(1, 262144, '\p{^East_Asian_Width=-WIDE}', "");
    Expect(1, 262144, '\P{East_Asian_Width=-WIDE}', "");
    Expect(0, 262144, '\P{^East_Asian_Width=-WIDE}', "");
    Error('\p{Ea=/a/-W}');
    Error('\P{Ea=/a/-W}');
    Expect(1, 262141, '\p{Ea=:\AW\z:}', "");;
    Expect(0, 262144, '\p{Ea=:\AW\z:}', "");;
    Expect(1, 262141, '\p{Ea=w}', "");
    Expect(0, 262141, '\p{^Ea=w}', "");
    Expect(0, 262141, '\P{Ea=w}', "");
    Expect(1, 262141, '\P{^Ea=w}', "");
    Expect(0, 262144, '\p{Ea=w}', "");
    Expect(1, 262144, '\p{^Ea=w}', "");
    Expect(1, 262144, '\P{Ea=w}', "");
    Expect(0, 262144, '\P{^Ea=w}', "");
    Expect(1, 262141, '\p{Ea=:\Aw\z:}', "");;
    Expect(0, 262144, '\p{Ea=:\Aw\z:}', "");;
    Expect(1, 262141, '\p{Ea:    _W}', "");
    Expect(0, 262141, '\p{^Ea:    _W}', "");
    Expect(0, 262141, '\P{Ea:    _W}', "");
    Expect(1, 262141, '\P{^Ea:    _W}', "");
    Expect(0, 262144, '\p{Ea:    _W}', "");
    Expect(1, 262144, '\p{^Ea:    _W}', "");
    Expect(1, 262144, '\P{Ea:    _W}', "");
    Expect(0, 262144, '\P{^Ea:    _W}', "");
    Error('\p{Is_East_Asian_Width= :=WIDE}');
    Error('\P{Is_East_Asian_Width= :=WIDE}');
    Expect(1, 262141, '\p{Is_East_Asian_Width=wide}', "");
    Expect(0, 262141, '\p{^Is_East_Asian_Width=wide}', "");
    Expect(0, 262141, '\P{Is_East_Asian_Width=wide}', "");
    Expect(1, 262141, '\P{^Is_East_Asian_Width=wide}', "");
    Expect(0, 262144, '\p{Is_East_Asian_Width=wide}', "");
    Expect(1, 262144, '\p{^Is_East_Asian_Width=wide}', "");
    Expect(1, 262144, '\P{Is_East_Asian_Width=wide}', "");
    Expect(0, 262144, '\P{^Is_East_Asian_Width=wide}', "");
    Expect(1, 262141, '\p{Is_East_Asian_Width=	Wide}', "");
    Expect(0, 262141, '\p{^Is_East_Asian_Width=	Wide}', "");
    Expect(0, 262141, '\P{Is_East_Asian_Width=	Wide}', "");
    Expect(1, 262141, '\P{^Is_East_Asian_Width=	Wide}', "");
    Expect(0, 262144, '\p{Is_East_Asian_Width=	Wide}', "");
    Expect(1, 262144, '\p{^Is_East_Asian_Width=	Wide}', "");
    Expect(1, 262144, '\P{Is_East_Asian_Width=	Wide}', "");
    Expect(0, 262144, '\P{^Is_East_Asian_Width=	Wide}', "");
    Error('\p{Is_Ea=_ w:=}');
    Error('\P{Is_Ea=_ w:=}');
    Expect(1, 262141, '\p{Is_Ea=w}', "");
    Expect(0, 262141, '\p{^Is_Ea=w}', "");
    Expect(0, 262141, '\P{Is_Ea=w}', "");
    Expect(1, 262141, '\P{^Is_Ea=w}', "");
    Expect(0, 262144, '\p{Is_Ea=w}', "");
    Expect(1, 262144, '\p{^Is_Ea=w}', "");
    Expect(1, 262144, '\P{Is_Ea=w}', "");
    Expect(0, 262144, '\P{^Is_Ea=w}', "");
    Expect(1, 262141, '\p{Is_Ea= w}', "");
    Expect(0, 262141, '\p{^Is_Ea= w}', "");
    Expect(0, 262141, '\P{Is_Ea= w}', "");
    Expect(1, 262141, '\P{^Is_Ea= w}', "");
    Expect(0, 262144, '\p{Is_Ea= w}', "");
    Expect(1, 262144, '\p{^Is_Ea= w}', "");
    Expect(1, 262144, '\P{Is_Ea= w}', "");
    Expect(0, 262144, '\P{^Is_Ea= w}', "");
    Error('\p{Emoji_Modifier_Base=	 No/a/}');
    Error('\P{Emoji_Modifier_Base=	 No/a/}');
    Expect(1, 129502, '\p{Emoji_Modifier_Base=:\ANo\z:}', "");;
    Expect(0, 129501, '\p{Emoji_Modifier_Base=:\ANo\z:}', "");;
    Expect(1, 129502, '\p{Emoji_Modifier_Base=no}', "");
    Expect(0, 129502, '\p{^Emoji_Modifier_Base=no}', "");
    Expect(0, 129502, '\P{Emoji_Modifier_Base=no}', "");
    Expect(1, 129502, '\P{^Emoji_Modifier_Base=no}', "");
    Expect(0, 129501, '\p{Emoji_Modifier_Base=no}', "");
    Expect(1, 129501, '\p{^Emoji_Modifier_Base=no}', "");
    Expect(1, 129501, '\P{Emoji_Modifier_Base=no}', "");
    Expect(0, 129501, '\P{^Emoji_Modifier_Base=no}', "");
    Expect(1, 129502, '\p{Emoji_Modifier_Base=:\Ano\z:}', "");;
    Expect(0, 129501, '\p{Emoji_Modifier_Base=:\Ano\z:}', "");;
    Expect(1, 129502, '\p{Emoji_Modifier_Base=_ NO}', "");
    Expect(0, 129502, '\p{^Emoji_Modifier_Base=_ NO}', "");
    Expect(0, 129502, '\P{Emoji_Modifier_Base=_ NO}', "");
    Expect(1, 129502, '\P{^Emoji_Modifier_Base=_ NO}', "");
    Expect(0, 129501, '\p{Emoji_Modifier_Base=_ NO}', "");
    Expect(1, 129501, '\p{^Emoji_Modifier_Base=_ NO}', "");
    Expect(1, 129501, '\P{Emoji_Modifier_Base=_ NO}', "");
    Expect(0, 129501, '\P{^Emoji_Modifier_Base=_ NO}', "");
    Error('\p{EBase= N:=}');
    Error('\P{EBase= N:=}');
    Expect(1, 129502, '\p{EBase=:\AN\z:}', "");;
    Expect(0, 129501, '\p{EBase=:\AN\z:}', "");;
    Expect(1, 129502, '\p{EBase: n}', "");
    Expect(0, 129502, '\p{^EBase: n}', "");
    Expect(0, 129502, '\P{EBase: n}', "");
    Expect(1, 129502, '\P{^EBase: n}', "");
    Expect(0, 129501, '\p{EBase: n}', "");
    Expect(1, 129501, '\p{^EBase: n}', "");
    Expect(1, 129501, '\P{EBase: n}', "");
    Expect(0, 129501, '\P{^EBase: n}', "");
    Expect(1, 129502, '\p{EBase=:\An\z:}', "");;
    Expect(0, 129501, '\p{EBase=:\An\z:}', "");;
    Expect(1, 129502, '\p{EBase=__N}', "");
    Expect(0, 129502, '\p{^EBase=__N}', "");
    Expect(0, 129502, '\P{EBase=__N}', "");
    Expect(1, 129502, '\P{^EBase=__N}', "");
    Expect(0, 129501, '\p{EBase=__N}', "");
    Expect(1, 129501, '\p{^EBase=__N}', "");
    Expect(1, 129501, '\P{EBase=__N}', "");
    Expect(0, 129501, '\P{^EBase=__N}', "");
    Error('\p{Is_Emoji_Modifier_Base=:=  F}');
    Error('\P{Is_Emoji_Modifier_Base=:=  F}');
    Expect(1, 129502, '\p{Is_Emoji_Modifier_Base=f}', "");
    Expect(0, 129502, '\p{^Is_Emoji_Modifier_Base=f}', "");
    Expect(0, 129502, '\P{Is_Emoji_Modifier_Base=f}', "");
    Expect(1, 129502, '\P{^Is_Emoji_Modifier_Base=f}', "");
    Expect(0, 129501, '\p{Is_Emoji_Modifier_Base=f}', "");
    Expect(1, 129501, '\p{^Is_Emoji_Modifier_Base=f}', "");
    Expect(1, 129501, '\P{Is_Emoji_Modifier_Base=f}', "");
    Expect(0, 129501, '\P{^Is_Emoji_Modifier_Base=f}', "");
    Expect(1, 129502, '\p{Is_Emoji_Modifier_Base=F}', "");
    Expect(0, 129502, '\p{^Is_Emoji_Modifier_Base=F}', "");
    Expect(0, 129502, '\P{Is_Emoji_Modifier_Base=F}', "");
    Expect(1, 129502, '\P{^Is_Emoji_Modifier_Base=F}', "");
    Expect(0, 129501, '\p{Is_Emoji_Modifier_Base=F}', "");
    Expect(1, 129501, '\p{^Is_Emoji_Modifier_Base=F}', "");
    Expect(1, 129501, '\P{Is_Emoji_Modifier_Base=F}', "");
    Expect(0, 129501, '\P{^Is_Emoji_Modifier_Base=F}', "");
    Error('\p{Is_EBase:	:=false}');
    Error('\P{Is_EBase:	:=false}');
    Expect(1, 129502, '\p{Is_EBase=false}', "");
    Expect(0, 129502, '\p{^Is_EBase=false}', "");
    Expect(0, 129502, '\P{Is_EBase=false}', "");
    Expect(1, 129502, '\P{^Is_EBase=false}', "");
    Expect(0, 129501, '\p{Is_EBase=false}', "");
    Expect(1, 129501, '\p{^Is_EBase=false}', "");
    Expect(1, 129501, '\P{Is_EBase=false}', "");
    Expect(0, 129501, '\P{^Is_EBase=false}', "");
    Expect(1, 129502, '\p{Is_EBase=_False}', "");
    Expect(0, 129502, '\p{^Is_EBase=_False}', "");
    Expect(0, 129502, '\P{Is_EBase=_False}', "");
    Expect(1, 129502, '\P{^Is_EBase=_False}', "");
    Expect(0, 129501, '\p{Is_EBase=_False}', "");
    Expect(1, 129501, '\p{^Is_EBase=_False}', "");
    Expect(1, 129501, '\P{Is_EBase=_False}', "");
    Expect(0, 129501, '\P{^Is_EBase=_False}', "");
    Error('\p{Emoji_Modifier_Base=	_Yes/a/}');
    Error('\P{Emoji_Modifier_Base=	_Yes/a/}');
    Expect(1, 129501, '\p{Emoji_Modifier_Base=:\AYes\z:}', "");;
    Expect(0, 129502, '\p{Emoji_Modifier_Base=:\AYes\z:}', "");;
    Expect(1, 129501, '\p{Emoji_Modifier_Base=yes}', "");
    Expect(0, 129501, '\p{^Emoji_Modifier_Base=yes}', "");
    Expect(0, 129501, '\P{Emoji_Modifier_Base=yes}', "");
    Expect(1, 129501, '\P{^Emoji_Modifier_Base=yes}', "");
    Expect(0, 129502, '\p{Emoji_Modifier_Base=yes}', "");
    Expect(1, 129502, '\p{^Emoji_Modifier_Base=yes}', "");
    Expect(1, 129502, '\P{Emoji_Modifier_Base=yes}', "");
    Expect(0, 129502, '\P{^Emoji_Modifier_Base=yes}', "");
    Expect(1, 129501, '\p{Emoji_Modifier_Base=:\Ayes\z:}', "");;
    Expect(0, 129502, '\p{Emoji_Modifier_Base=:\Ayes\z:}', "");;
    Expect(1, 129501, '\p{Emoji_Modifier_Base= YES}', "");
    Expect(0, 129501, '\p{^Emoji_Modifier_Base= YES}', "");
    Expect(0, 129501, '\P{Emoji_Modifier_Base= YES}', "");
    Expect(1, 129501, '\P{^Emoji_Modifier_Base= YES}', "");
    Expect(0, 129502, '\p{Emoji_Modifier_Base= YES}', "");
    Expect(1, 129502, '\p{^Emoji_Modifier_Base= YES}', "");
    Expect(1, 129502, '\P{Emoji_Modifier_Base= YES}', "");
    Expect(0, 129502, '\P{^Emoji_Modifier_Base= YES}', "");
    Error('\p{EBase:   /a/		Y}');
    Error('\P{EBase:   /a/		Y}');
    Expect(1, 129501, '\p{EBase=:\AY\z:}', "");;
    Expect(0, 129502, '\p{EBase=:\AY\z:}', "");;
    Expect(1, 129501, '\p{EBase=y}', "");
    Expect(0, 129501, '\p{^EBase=y}', "");
    Expect(0, 129501, '\P{EBase=y}', "");
    Expect(1, 129501, '\P{^EBase=y}', "");
    Expect(0, 129502, '\p{EBase=y}', "");
    Expect(1, 129502, '\p{^EBase=y}', "");
    Expect(1, 129502, '\P{EBase=y}', "");
    Expect(0, 129502, '\P{^EBase=y}', "");
    Expect(1, 129501, '\p{EBase=:\Ay\z:}', "");;
    Expect(0, 129502, '\p{EBase=:\Ay\z:}', "");;
    Expect(1, 129501, '\p{EBase= _Y}', "");
    Expect(0, 129501, '\p{^EBase= _Y}', "");
    Expect(0, 129501, '\P{EBase= _Y}', "");
    Expect(1, 129501, '\P{^EBase= _Y}', "");
    Expect(0, 129502, '\p{EBase= _Y}', "");
    Expect(1, 129502, '\p{^EBase= _Y}', "");
    Expect(1, 129502, '\P{EBase= _Y}', "");
    Expect(0, 129502, '\P{^EBase= _Y}', "");
    Error('\p{Is_Emoji_Modifier_Base=	_T:=}');
    Error('\P{Is_Emoji_Modifier_Base=	_T:=}');
    Expect(1, 129501, '\p{Is_Emoji_Modifier_Base:	t}', "");
    Expect(0, 129501, '\p{^Is_Emoji_Modifier_Base:	t}', "");
    Expect(0, 129501, '\P{Is_Emoji_Modifier_Base:	t}', "");
    Expect(1, 129501, '\P{^Is_Emoji_Modifier_Base:	t}', "");
    Expect(0, 129502, '\p{Is_Emoji_Modifier_Base:	t}', "");
    Expect(1, 129502, '\p{^Is_Emoji_Modifier_Base:	t}', "");
    Expect(1, 129502, '\P{Is_Emoji_Modifier_Base:	t}', "");
    Expect(0, 129502, '\P{^Is_Emoji_Modifier_Base:	t}', "");
    Expect(1, 129501, '\p{Is_Emoji_Modifier_Base= 	T}', "");
    Expect(0, 129501, '\p{^Is_Emoji_Modifier_Base= 	T}', "");
    Expect(0, 129501, '\P{Is_Emoji_Modifier_Base= 	T}', "");
    Expect(1, 129501, '\P{^Is_Emoji_Modifier_Base= 	T}', "");
    Expect(0, 129502, '\p{Is_Emoji_Modifier_Base= 	T}', "");
    Expect(1, 129502, '\p{^Is_Emoji_Modifier_Base= 	T}', "");
    Expect(1, 129502, '\P{Is_Emoji_Modifier_Base= 	T}', "");
    Expect(0, 129502, '\P{^Is_Emoji_Modifier_Base= 	T}', "");
    Error('\p{Is_EBase=/a/--true}');
    Error('\P{Is_EBase=/a/--true}');
    Expect(1, 129501, '\p{Is_EBase=true}', "");
    Expect(0, 129501, '\p{^Is_EBase=true}', "");
    Expect(0, 129501, '\P{Is_EBase=true}', "");
    Expect(1, 129501, '\P{^Is_EBase=true}', "");
    Expect(0, 129502, '\p{Is_EBase=true}', "");
    Expect(1, 129502, '\p{^Is_EBase=true}', "");
    Expect(1, 129502, '\P{Is_EBase=true}', "");
    Expect(0, 129502, '\P{^Is_EBase=true}', "");
    Expect(1, 129501, '\p{Is_EBase:  	true}', "");
    Expect(0, 129501, '\p{^Is_EBase:  	true}', "");
    Expect(0, 129501, '\P{Is_EBase:  	true}', "");
    Expect(1, 129501, '\P{^Is_EBase:  	true}', "");
    Expect(0, 129502, '\p{Is_EBase:  	true}', "");
    Expect(1, 129502, '\p{^Is_EBase:  	true}', "");
    Expect(1, 129502, '\P{Is_EBase:  	true}', "");
    Expect(0, 129502, '\P{^Is_EBase:  	true}', "");
    Error('\p{Emoji_Component=-/a/No}');
    Error('\P{Emoji_Component=-/a/No}');
    Expect(1, 917632, '\p{Emoji_Component=:\ANo\z:}', "");;
    Expect(0, 917631, '\p{Emoji_Component=:\ANo\z:}', "");;
    Expect(1, 917632, '\p{Emoji_Component:no}', "");
    Expect(0, 917632, '\p{^Emoji_Component:no}', "");
    Expect(0, 917632, '\P{Emoji_Component:no}', "");
    Expect(1, 917632, '\P{^Emoji_Component:no}', "");
    Expect(0, 917631, '\p{Emoji_Component:no}', "");
    Expect(1, 917631, '\p{^Emoji_Component:no}', "");
    Expect(1, 917631, '\P{Emoji_Component:no}', "");
    Expect(0, 917631, '\P{^Emoji_Component:no}', "");
    Expect(1, 917632, '\p{Emoji_Component=:\Ano\z:}', "");;
    Expect(0, 917631, '\p{Emoji_Component=:\Ano\z:}', "");;
    Expect(1, 917632, '\p{Emoji_Component=_ no}', "");
    Expect(0, 917632, '\p{^Emoji_Component=_ no}', "");
    Expect(0, 917632, '\P{Emoji_Component=_ no}', "");
    Expect(1, 917632, '\P{^Emoji_Component=_ no}', "");
    Expect(0, 917631, '\p{Emoji_Component=_ no}', "");
    Expect(1, 917631, '\p{^Emoji_Component=_ no}', "");
    Expect(1, 917631, '\P{Emoji_Component=_ no}', "");
    Expect(0, 917631, '\P{^Emoji_Component=_ no}', "");
    Error('\p{EComp=/a/__N}');
    Error('\P{EComp=/a/__N}');
    Expect(1, 917632, '\p{EComp=:\AN\z:}', "");;
    Expect(0, 917631, '\p{EComp=:\AN\z:}', "");;
    Expect(1, 917632, '\p{EComp=n}', "");
    Expect(0, 917632, '\p{^EComp=n}', "");
    Expect(0, 917632, '\P{EComp=n}', "");
    Expect(1, 917632, '\P{^EComp=n}', "");
    Expect(0, 917631, '\p{EComp=n}', "");
    Expect(1, 917631, '\p{^EComp=n}', "");
    Expect(1, 917631, '\P{EComp=n}', "");
    Expect(0, 917631, '\P{^EComp=n}', "");
    Expect(1, 917632, '\p{EComp=:\An\z:}', "");;
    Expect(0, 917631, '\p{EComp=:\An\z:}', "");;
    Expect(1, 917632, '\p{EComp= -N}', "");
    Expect(0, 917632, '\p{^EComp= -N}', "");
    Expect(0, 917632, '\P{EComp= -N}', "");
    Expect(1, 917632, '\P{^EComp= -N}', "");
    Expect(0, 917631, '\p{EComp= -N}', "");
    Expect(1, 917631, '\p{^EComp= -N}', "");
    Expect(1, 917631, '\P{EComp= -N}', "");
    Expect(0, 917631, '\P{^EComp= -N}', "");
    Error('\p{Is_Emoji_Component=-_F:=}');
    Error('\P{Is_Emoji_Component=-_F:=}');
    Expect(1, 917632, '\p{Is_Emoji_Component=f}', "");
    Expect(0, 917632, '\p{^Is_Emoji_Component=f}', "");
    Expect(0, 917632, '\P{Is_Emoji_Component=f}', "");
    Expect(1, 917632, '\P{^Is_Emoji_Component=f}', "");
    Expect(0, 917631, '\p{Is_Emoji_Component=f}', "");
    Expect(1, 917631, '\p{^Is_Emoji_Component=f}', "");
    Expect(1, 917631, '\P{Is_Emoji_Component=f}', "");
    Expect(0, 917631, '\P{^Is_Emoji_Component=f}', "");
    Expect(1, 917632, '\p{Is_Emoji_Component= _F}', "");
    Expect(0, 917632, '\p{^Is_Emoji_Component= _F}', "");
    Expect(0, 917632, '\P{Is_Emoji_Component= _F}', "");
    Expect(1, 917632, '\P{^Is_Emoji_Component= _F}', "");
    Expect(0, 917631, '\p{Is_Emoji_Component= _F}', "");
    Expect(1, 917631, '\p{^Is_Emoji_Component= _F}', "");
    Expect(1, 917631, '\P{Is_Emoji_Component= _F}', "");
    Expect(0, 917631, '\P{^Is_Emoji_Component= _F}', "");
    Error('\p{Is_EComp=_FALSE:=}');
    Error('\P{Is_EComp=_FALSE:=}');
    Expect(1, 917632, '\p{Is_EComp=false}', "");
    Expect(0, 917632, '\p{^Is_EComp=false}', "");
    Expect(0, 917632, '\P{Is_EComp=false}', "");
    Expect(1, 917632, '\P{^Is_EComp=false}', "");
    Expect(0, 917631, '\p{Is_EComp=false}', "");
    Expect(1, 917631, '\p{^Is_EComp=false}', "");
    Expect(1, 917631, '\P{Is_EComp=false}', "");
    Expect(0, 917631, '\P{^Is_EComp=false}', "");
    Expect(1, 917632, '\p{Is_EComp= False}', "");
    Expect(0, 917632, '\p{^Is_EComp= False}', "");
    Expect(0, 917632, '\P{Is_EComp= False}', "");
    Expect(1, 917632, '\P{^Is_EComp= False}', "");
    Expect(0, 917631, '\p{Is_EComp= False}', "");
    Expect(1, 917631, '\p{^Is_EComp= False}', "");
    Expect(1, 917631, '\P{Is_EComp= False}', "");
    Expect(0, 917631, '\P{^Is_EComp= False}', "");
    Error('\p{Emoji_Component=/a/_	Yes}');
    Error('\P{Emoji_Component=/a/_	Yes}');
    Expect(1, 917631, '\p{Emoji_Component=:\AYes\z:}', "");;
    Expect(0, 917632, '\p{Emoji_Component=:\AYes\z:}', "");;
    Expect(1, 917631, '\p{Emoji_Component=yes}', "");
    Expect(0, 917631, '\p{^Emoji_Component=yes}', "");
    Expect(0, 917631, '\P{Emoji_Component=yes}', "");
    Expect(1, 917631, '\P{^Emoji_Component=yes}', "");
    Expect(0, 917632, '\p{Emoji_Component=yes}', "");
    Expect(1, 917632, '\p{^Emoji_Component=yes}', "");
    Expect(1, 917632, '\P{Emoji_Component=yes}', "");
    Expect(0, 917632, '\P{^Emoji_Component=yes}', "");
    Expect(1, 917631, '\p{Emoji_Component=:\Ayes\z:}', "");;
    Expect(0, 917632, '\p{Emoji_Component=:\Ayes\z:}', "");;
    Expect(1, 917631, '\p{Emoji_Component=		YES}', "");
    Expect(0, 917631, '\p{^Emoji_Component=		YES}', "");
    Expect(0, 917631, '\P{Emoji_Component=		YES}', "");
    Expect(1, 917631, '\P{^Emoji_Component=		YES}', "");
    Expect(0, 917632, '\p{Emoji_Component=		YES}', "");
    Expect(1, 917632, '\p{^Emoji_Component=		YES}', "");
    Expect(1, 917632, '\P{Emoji_Component=		YES}', "");
    Expect(0, 917632, '\P{^Emoji_Component=		YES}', "");
    Error('\p{EComp=_:=Y}');
    Error('\P{EComp=_:=Y}');
    Expect(1, 917631, '\p{EComp=:\AY\z:}', "");;
    Expect(0, 917632, '\p{EComp=:\AY\z:}', "");;
    Expect(1, 917631, '\p{EComp=y}', "");
    Expect(0, 917631, '\p{^EComp=y}', "");
    Expect(0, 917631, '\P{EComp=y}', "");
    Expect(1, 917631, '\P{^EComp=y}', "");
    Expect(0, 917632, '\p{EComp=y}', "");
    Expect(1, 917632, '\p{^EComp=y}', "");
    Expect(1, 917632, '\P{EComp=y}', "");
    Expect(0, 917632, '\P{^EComp=y}', "");
    Expect(1, 917631, '\p{EComp=:\Ay\z:}', "");;
    Expect(0, 917632, '\p{EComp=:\Ay\z:}', "");;
    Expect(1, 917631, '\p{EComp= Y}', "");
    Expect(0, 917631, '\p{^EComp= Y}', "");
    Expect(0, 917631, '\P{EComp= Y}', "");
    Expect(1, 917631, '\P{^EComp= Y}', "");
    Expect(0, 917632, '\p{EComp= Y}', "");
    Expect(1, 917632, '\p{^EComp= Y}', "");
    Expect(1, 917632, '\P{EComp= Y}', "");
    Expect(0, 917632, '\P{^EComp= Y}', "");
    Error('\p{Is_Emoji_Component=_ t/a/}');
    Error('\P{Is_Emoji_Component=_ t/a/}');
    Expect(1, 917631, '\p{Is_Emoji_Component=t}', "");
    Expect(0, 917631, '\p{^Is_Emoji_Component=t}', "");
    Expect(0, 917631, '\P{Is_Emoji_Component=t}', "");
    Expect(1, 917631, '\P{^Is_Emoji_Component=t}', "");
    Expect(0, 917632, '\p{Is_Emoji_Component=t}', "");
    Expect(1, 917632, '\p{^Is_Emoji_Component=t}', "");
    Expect(1, 917632, '\P{Is_Emoji_Component=t}', "");
    Expect(0, 917632, '\P{^Is_Emoji_Component=t}', "");
    Expect(1, 917631, '\p{Is_Emoji_Component=--t}', "");
    Expect(0, 917631, '\p{^Is_Emoji_Component=--t}', "");
    Expect(0, 917631, '\P{Is_Emoji_Component=--t}', "");
    Expect(1, 917631, '\P{^Is_Emoji_Component=--t}', "");
    Expect(0, 917632, '\p{Is_Emoji_Component=--t}', "");
    Expect(1, 917632, '\p{^Is_Emoji_Component=--t}', "");
    Expect(1, 917632, '\P{Is_Emoji_Component=--t}', "");
    Expect(0, 917632, '\P{^Is_Emoji_Component=--t}', "");
    Error('\p{Is_EComp=/a/-TRUE}');
    Error('\P{Is_EComp=/a/-TRUE}');
    Expect(1, 917631, '\p{Is_EComp=true}', "");
    Expect(0, 917631, '\p{^Is_EComp=true}', "");
    Expect(0, 917631, '\P{Is_EComp=true}', "");
    Expect(1, 917631, '\P{^Is_EComp=true}', "");
    Expect(0, 917632, '\p{Is_EComp=true}', "");
    Expect(1, 917632, '\p{^Is_EComp=true}', "");
    Expect(1, 917632, '\P{Is_EComp=true}', "");
    Expect(0, 917632, '\P{^Is_EComp=true}', "");
    Expect(1, 917631, '\p{Is_EComp: TRUE}', "");
    Expect(0, 917631, '\p{^Is_EComp: TRUE}', "");
    Expect(0, 917631, '\P{Is_EComp: TRUE}', "");
    Expect(1, 917631, '\P{^Is_EComp: TRUE}', "");
    Expect(0, 917632, '\p{Is_EComp: TRUE}', "");
    Expect(1, 917632, '\p{^Is_EComp: TRUE}', "");
    Expect(1, 917632, '\P{Is_EComp: TRUE}', "");
    Expect(0, 917632, '\P{^Is_EComp: TRUE}', "");
    Error('\p{Emoji_Modifier=:= _No}');
    Error('\P{Emoji_Modifier=:= _No}');
    Expect(1, 128000, '\p{Emoji_Modifier=:\ANo\z:}', "");;
    Expect(0, 127999, '\p{Emoji_Modifier=:\ANo\z:}', "");;
    Expect(1, 128000, '\p{Emoji_Modifier=no}', "");
    Expect(0, 128000, '\p{^Emoji_Modifier=no}', "");
    Expect(0, 128000, '\P{Emoji_Modifier=no}', "");
    Expect(1, 128000, '\P{^Emoji_Modifier=no}', "");
    Expect(0, 127999, '\p{Emoji_Modifier=no}', "");
    Expect(1, 127999, '\p{^Emoji_Modifier=no}', "");
    Expect(1, 127999, '\P{Emoji_Modifier=no}', "");
    Expect(0, 127999, '\P{^Emoji_Modifier=no}', "");
    Expect(1, 128000, '\p{Emoji_Modifier=:\Ano\z:}', "");;
    Expect(0, 127999, '\p{Emoji_Modifier=:\Ano\z:}', "");;
    Expect(1, 128000, '\p{Emoji_Modifier=	-No}', "");
    Expect(0, 128000, '\p{^Emoji_Modifier=	-No}', "");
    Expect(0, 128000, '\P{Emoji_Modifier=	-No}', "");
    Expect(1, 128000, '\P{^Emoji_Modifier=	-No}', "");
    Expect(0, 127999, '\p{Emoji_Modifier=	-No}', "");
    Expect(1, 127999, '\p{^Emoji_Modifier=	-No}', "");
    Expect(1, 127999, '\P{Emoji_Modifier=	-No}', "");
    Expect(0, 127999, '\P{^Emoji_Modifier=	-No}', "");
    Error('\p{EMod=_/a/n}');
    Error('\P{EMod=_/a/n}');
    Expect(1, 128000, '\p{EMod=:\AN\z:}', "");;
    Expect(0, 127999, '\p{EMod=:\AN\z:}', "");;
    Expect(1, 128000, '\p{EMod=n}', "");
    Expect(0, 128000, '\p{^EMod=n}', "");
    Expect(0, 128000, '\P{EMod=n}', "");
    Expect(1, 128000, '\P{^EMod=n}', "");
    Expect(0, 127999, '\p{EMod=n}', "");
    Expect(1, 127999, '\p{^EMod=n}', "");
    Expect(1, 127999, '\P{EMod=n}', "");
    Expect(0, 127999, '\P{^EMod=n}', "");
    Expect(1, 128000, '\p{EMod=:\An\z:}', "");;
    Expect(0, 127999, '\p{EMod=:\An\z:}', "");;
    Expect(1, 128000, '\p{EMod=	 N}', "");
    Expect(0, 128000, '\p{^EMod=	 N}', "");
    Expect(0, 128000, '\P{EMod=	 N}', "");
    Expect(1, 128000, '\P{^EMod=	 N}', "");
    Expect(0, 127999, '\p{EMod=	 N}', "");
    Expect(1, 127999, '\p{^EMod=	 N}', "");
    Expect(1, 127999, '\P{EMod=	 N}', "");
    Expect(0, 127999, '\P{^EMod=	 N}', "");
    Error('\p{Is_Emoji_Modifier=	f:=}');
    Error('\P{Is_Emoji_Modifier=	f:=}');
    Expect(1, 128000, '\p{Is_Emoji_Modifier=f}', "");
    Expect(0, 128000, '\p{^Is_Emoji_Modifier=f}', "");
    Expect(0, 128000, '\P{Is_Emoji_Modifier=f}', "");
    Expect(1, 128000, '\P{^Is_Emoji_Modifier=f}', "");
    Expect(0, 127999, '\p{Is_Emoji_Modifier=f}', "");
    Expect(1, 127999, '\p{^Is_Emoji_Modifier=f}', "");
    Expect(1, 127999, '\P{Is_Emoji_Modifier=f}', "");
    Expect(0, 127999, '\P{^Is_Emoji_Modifier=f}', "");
    Expect(1, 128000, '\p{Is_Emoji_Modifier:    -F}', "");
    Expect(0, 128000, '\p{^Is_Emoji_Modifier:    -F}', "");
    Expect(0, 128000, '\P{Is_Emoji_Modifier:    -F}', "");
    Expect(1, 128000, '\P{^Is_Emoji_Modifier:    -F}', "");
    Expect(0, 127999, '\p{Is_Emoji_Modifier:    -F}', "");
    Expect(1, 127999, '\p{^Is_Emoji_Modifier:    -F}', "");
    Expect(1, 127999, '\P{Is_Emoji_Modifier:    -F}', "");
    Expect(0, 127999, '\P{^Is_Emoji_Modifier:    -F}', "");
    Error('\p{Is_EMod= _false:=}');
    Error('\P{Is_EMod= _false:=}');
    Expect(1, 128000, '\p{Is_EMod=false}', "");
    Expect(0, 128000, '\p{^Is_EMod=false}', "");
    Expect(0, 128000, '\P{Is_EMod=false}', "");
    Expect(1, 128000, '\P{^Is_EMod=false}', "");
    Expect(0, 127999, '\p{Is_EMod=false}', "");
    Expect(1, 127999, '\p{^Is_EMod=false}', "");
    Expect(1, 127999, '\P{Is_EMod=false}', "");
    Expect(0, 127999, '\P{^Is_EMod=false}', "");
    Expect(1, 128000, '\p{Is_EMod=_False}', "");
    Expect(0, 128000, '\p{^Is_EMod=_False}', "");
    Expect(0, 128000, '\P{Is_EMod=_False}', "");
    Expect(1, 128000, '\P{^Is_EMod=_False}', "");
    Expect(0, 127999, '\p{Is_EMod=_False}', "");
    Expect(1, 127999, '\p{^Is_EMod=_False}', "");
    Expect(1, 127999, '\P{Is_EMod=_False}', "");
    Expect(0, 127999, '\P{^Is_EMod=_False}', "");
    Error('\p{Emoji_Modifier=-:=Yes}');
    Error('\P{Emoji_Modifier=-:=Yes}');
    Expect(1, 127999, '\p{Emoji_Modifier=:\AYes\z:}', "");;
    Expect(0, 128000, '\p{Emoji_Modifier=:\AYes\z:}', "");;
    Expect(1, 127999, '\p{Emoji_Modifier=yes}', "");
    Expect(0, 127999, '\p{^Emoji_Modifier=yes}', "");
    Expect(0, 127999, '\P{Emoji_Modifier=yes}', "");
    Expect(1, 127999, '\P{^Emoji_Modifier=yes}', "");
    Expect(0, 128000, '\p{Emoji_Modifier=yes}', "");
    Expect(1, 128000, '\p{^Emoji_Modifier=yes}', "");
    Expect(1, 128000, '\P{Emoji_Modifier=yes}', "");
    Expect(0, 128000, '\P{^Emoji_Modifier=yes}', "");
    Expect(1, 127999, '\p{Emoji_Modifier=:\Ayes\z:}', "");;
    Expect(0, 128000, '\p{Emoji_Modifier=:\Ayes\z:}', "");;
    Expect(1, 127999, '\p{Emoji_Modifier=_ Yes}', "");
    Expect(0, 127999, '\p{^Emoji_Modifier=_ Yes}', "");
    Expect(0, 127999, '\P{Emoji_Modifier=_ Yes}', "");
    Expect(1, 127999, '\P{^Emoji_Modifier=_ Yes}', "");
    Expect(0, 128000, '\p{Emoji_Modifier=_ Yes}', "");
    Expect(1, 128000, '\p{^Emoji_Modifier=_ Yes}', "");
    Expect(1, 128000, '\P{Emoji_Modifier=_ Yes}', "");
    Expect(0, 128000, '\P{^Emoji_Modifier=_ Yes}', "");
    Error('\p{EMod=/a/-_y}');
    Error('\P{EMod=/a/-_y}');
    Expect(1, 127999, '\p{EMod=:\AY\z:}', "");;
    Expect(0, 128000, '\p{EMod=:\AY\z:}', "");;
    Expect(1, 127999, '\p{EMod=y}', "");
    Expect(0, 127999, '\p{^EMod=y}', "");
    Expect(0, 127999, '\P{EMod=y}', "");
    Expect(1, 127999, '\P{^EMod=y}', "");
    Expect(0, 128000, '\p{EMod=y}', "");
    Expect(1, 128000, '\p{^EMod=y}', "");
    Expect(1, 128000, '\P{EMod=y}', "");
    Expect(0, 128000, '\P{^EMod=y}', "");
    Expect(1, 127999, '\p{EMod=:\Ay\z:}', "");;
    Expect(0, 128000, '\p{EMod=:\Ay\z:}', "");;
    Expect(1, 127999, '\p{EMod= Y}', "");
    Expect(0, 127999, '\p{^EMod= Y}', "");
    Expect(0, 127999, '\P{EMod= Y}', "");
    Expect(1, 127999, '\P{^EMod= Y}', "");
    Expect(0, 128000, '\p{EMod= Y}', "");
    Expect(1, 128000, '\p{^EMod= Y}', "");
    Expect(1, 128000, '\P{EMod= Y}', "");
    Expect(0, 128000, '\P{^EMod= Y}', "");
    Error('\p{Is_Emoji_Modifier=/a/_t}');
    Error('\P{Is_Emoji_Modifier=/a/_t}');
    Expect(1, 127999, '\p{Is_Emoji_Modifier=t}', "");
    Expect(0, 127999, '\p{^Is_Emoji_Modifier=t}', "");
    Expect(0, 127999, '\P{Is_Emoji_Modifier=t}', "");
    Expect(1, 127999, '\P{^Is_Emoji_Modifier=t}', "");
    Expect(0, 128000, '\p{Is_Emoji_Modifier=t}', "");
    Expect(1, 128000, '\p{^Is_Emoji_Modifier=t}', "");
    Expect(1, 128000, '\P{Is_Emoji_Modifier=t}', "");
    Expect(0, 128000, '\P{^Is_Emoji_Modifier=t}', "");
    Expect(1, 127999, '\p{Is_Emoji_Modifier=	T}', "");
    Expect(0, 127999, '\p{^Is_Emoji_Modifier=	T}', "");
    Expect(0, 127999, '\P{Is_Emoji_Modifier=	T}', "");
    Expect(1, 127999, '\P{^Is_Emoji_Modifier=	T}', "");
    Expect(0, 128000, '\p{Is_Emoji_Modifier=	T}', "");
    Expect(1, 128000, '\p{^Is_Emoji_Modifier=	T}', "");
    Expect(1, 128000, '\P{Is_Emoji_Modifier=	T}', "");
    Expect(0, 128000, '\P{^Is_Emoji_Modifier=	T}', "");
    Error('\p{Is_EMod=:=	_True}');
    Error('\P{Is_EMod=:=	_True}');
    Expect(1, 127999, '\p{Is_EMod=true}', "");
    Expect(0, 127999, '\p{^Is_EMod=true}', "");
    Expect(0, 127999, '\P{Is_EMod=true}', "");
    Expect(1, 127999, '\P{^Is_EMod=true}', "");
    Expect(0, 128000, '\p{Is_EMod=true}', "");
    Expect(1, 128000, '\p{^Is_EMod=true}', "");
    Expect(1, 128000, '\P{Is_EMod=true}', "");
    Expect(0, 128000, '\P{^Is_EMod=true}', "");
    Expect(1, 127999, '\p{Is_EMod:		 true}', "");
    Expect(0, 127999, '\p{^Is_EMod:		 true}', "");
    Expect(0, 127999, '\P{Is_EMod:		 true}', "");
    Expect(1, 127999, '\P{^Is_EMod:		 true}', "");
    Expect(0, 128000, '\p{Is_EMod:		 true}', "");
    Expect(1, 128000, '\p{^Is_EMod:		 true}', "");
    Expect(1, 128000, '\P{Is_EMod:		 true}', "");
    Expect(0, 128000, '\P{^Is_EMod:		 true}', "");
    Error('\p{Emoji=/a/	no}');
    Error('\P{Emoji=/a/	no}');
    Expect(1, 129751, '\p{Emoji=:\ANo\z:}', "");;
    Expect(0, 129750, '\p{Emoji=:\ANo\z:}', "");;
    Expect(1, 129751, '\p{Emoji=no}', "");
    Expect(0, 129751, '\p{^Emoji=no}', "");
    Expect(0, 129751, '\P{Emoji=no}', "");
    Expect(1, 129751, '\P{^Emoji=no}', "");
    Expect(0, 129750, '\p{Emoji=no}', "");
    Expect(1, 129750, '\p{^Emoji=no}', "");
    Expect(1, 129750, '\P{Emoji=no}', "");
    Expect(0, 129750, '\P{^Emoji=no}', "");
    Expect(1, 129751, '\p{Emoji=:\Ano\z:}', "");;
    Expect(0, 129750, '\p{Emoji=:\Ano\z:}', "");;
    Expect(1, 129751, '\p{Emoji=_NO}', "");
    Expect(0, 129751, '\p{^Emoji=_NO}', "");
    Expect(0, 129751, '\P{Emoji=_NO}', "");
    Expect(1, 129751, '\P{^Emoji=_NO}', "");
    Expect(0, 129750, '\p{Emoji=_NO}', "");
    Expect(1, 129750, '\p{^Emoji=_NO}', "");
    Expect(1, 129750, '\P{Emoji=_NO}', "");
    Expect(0, 129750, '\P{^Emoji=_NO}', "");
    Error('\p{Is_Emoji=/a/ N}');
    Error('\P{Is_Emoji=/a/ N}');
    Expect(1, 129751, '\p{Is_Emoji=n}', "");
    Expect(0, 129751, '\p{^Is_Emoji=n}', "");
    Expect(0, 129751, '\P{Is_Emoji=n}', "");
    Expect(1, 129751, '\P{^Is_Emoji=n}', "");
    Expect(0, 129750, '\p{Is_Emoji=n}', "");
    Expect(1, 129750, '\p{^Is_Emoji=n}', "");
    Expect(1, 129750, '\P{Is_Emoji=n}', "");
    Expect(0, 129750, '\P{^Is_Emoji=n}', "");
    Expect(1, 129751, '\p{Is_Emoji=	-N}', "");
    Expect(0, 129751, '\p{^Is_Emoji=	-N}', "");
    Expect(0, 129751, '\P{Is_Emoji=	-N}', "");
    Expect(1, 129751, '\P{^Is_Emoji=	-N}', "");
    Expect(0, 129750, '\p{Is_Emoji=	-N}', "");
    Expect(1, 129750, '\p{^Is_Emoji=	-N}', "");
    Expect(1, 129750, '\P{Is_Emoji=	-N}', "");
    Expect(0, 129750, '\P{^Is_Emoji=	-N}', "");
    Error('\p{Emoji= F:=}');
    Error('\P{Emoji= F:=}');
    Expect(1, 129751, '\p{Emoji=:\AF\z:}', "");;
    Expect(0, 129750, '\p{Emoji=:\AF\z:}', "");;
    Expect(1, 129751, '\p{Emoji=f}', "");
    Expect(0, 129751, '\p{^Emoji=f}', "");
    Expect(0, 129751, '\P{Emoji=f}', "");
    Expect(1, 129751, '\P{^Emoji=f}', "");
    Expect(0, 129750, '\p{Emoji=f}', "");
    Expect(1, 129750, '\p{^Emoji=f}', "");
    Expect(1, 129750, '\P{Emoji=f}', "");
    Expect(0, 129750, '\P{^Emoji=f}', "");
    Expect(1, 129751, '\p{Emoji=:\Af\z:}', "");;
    Expect(0, 129750, '\p{Emoji=:\Af\z:}', "");;
    Expect(1, 129751, '\p{Emoji= -F}', "");
    Expect(0, 129751, '\p{^Emoji= -F}', "");
    Expect(0, 129751, '\P{Emoji= -F}', "");
    Expect(1, 129751, '\P{^Emoji= -F}', "");
    Expect(0, 129750, '\p{Emoji= -F}', "");
    Expect(1, 129750, '\p{^Emoji= -F}', "");
    Expect(1, 129750, '\P{Emoji= -F}', "");
    Expect(0, 129750, '\P{^Emoji= -F}', "");
    Error('\p{Is_Emoji=/a/		False}');
    Error('\P{Is_Emoji=/a/		False}');
    Expect(1, 129751, '\p{Is_Emoji=false}', "");
    Expect(0, 129751, '\p{^Is_Emoji=false}', "");
    Expect(0, 129751, '\P{Is_Emoji=false}', "");
    Expect(1, 129751, '\P{^Is_Emoji=false}', "");
    Expect(0, 129750, '\p{Is_Emoji=false}', "");
    Expect(1, 129750, '\p{^Is_Emoji=false}', "");
    Expect(1, 129750, '\P{Is_Emoji=false}', "");
    Expect(0, 129750, '\P{^Is_Emoji=false}', "");
    Expect(1, 129751, '\p{Is_Emoji=--False}', "");
    Expect(0, 129751, '\p{^Is_Emoji=--False}', "");
    Expect(0, 129751, '\P{Is_Emoji=--False}', "");
    Expect(1, 129751, '\P{^Is_Emoji=--False}', "");
    Expect(0, 129750, '\p{Is_Emoji=--False}', "");
    Expect(1, 129750, '\p{^Is_Emoji=--False}', "");
    Expect(1, 129750, '\P{Is_Emoji=--False}', "");
    Expect(0, 129750, '\P{^Is_Emoji=--False}', "");
    Error('\p{Emoji=/a/  YES}');
    Error('\P{Emoji=/a/  YES}');
    Expect(1, 129750, '\p{Emoji=:\AYes\z:}', "");;
    Expect(0, 129751, '\p{Emoji=:\AYes\z:}', "");;
    Expect(1, 129750, '\p{Emoji=yes}', "");
    Expect(0, 129750, '\p{^Emoji=yes}', "");
    Expect(0, 129750, '\P{Emoji=yes}', "");
    Expect(1, 129750, '\P{^Emoji=yes}', "");
    Expect(0, 129751, '\p{Emoji=yes}', "");
    Expect(1, 129751, '\p{^Emoji=yes}', "");
    Expect(1, 129751, '\P{Emoji=yes}', "");
    Expect(0, 129751, '\P{^Emoji=yes}', "");
    Expect(1, 129750, '\p{Emoji=:\Ayes\z:}', "");;
    Expect(0, 129751, '\p{Emoji=:\Ayes\z:}', "");;
    Expect(1, 129750, '\p{Emoji=	-yes}', "");
    Expect(0, 129750, '\p{^Emoji=	-yes}', "");
    Expect(0, 129750, '\P{Emoji=	-yes}', "");
    Expect(1, 129750, '\P{^Emoji=	-yes}', "");
    Expect(0, 129751, '\p{Emoji=	-yes}', "");
    Expect(1, 129751, '\p{^Emoji=	-yes}', "");
    Expect(1, 129751, '\P{Emoji=	-yes}', "");
    Expect(0, 129751, '\P{^Emoji=	-yes}', "");
    Error('\p{Is_Emoji=Y:=}');
    Error('\P{Is_Emoji=Y:=}');
    Expect(1, 129750, '\p{Is_Emoji:	y}', "");
    Expect(0, 129750, '\p{^Is_Emoji:	y}', "");
    Expect(0, 129750, '\P{Is_Emoji:	y}', "");
    Expect(1, 129750, '\P{^Is_Emoji:	y}', "");
    Expect(0, 129751, '\p{Is_Emoji:	y}', "");
    Expect(1, 129751, '\p{^Is_Emoji:	y}', "");
    Expect(1, 129751, '\P{Is_Emoji:	y}', "");
    Expect(0, 129751, '\P{^Is_Emoji:	y}', "");
    Expect(1, 129750, '\p{Is_Emoji=	Y}', "");
    Expect(0, 129750, '\p{^Is_Emoji=	Y}', "");
    Expect(0, 129750, '\P{Is_Emoji=	Y}', "");
    Expect(1, 129750, '\P{^Is_Emoji=	Y}', "");
    Expect(0, 129751, '\p{Is_Emoji=	Y}', "");
    Expect(1, 129751, '\p{^Is_Emoji=	Y}', "");
    Expect(1, 129751, '\P{Is_Emoji=	Y}', "");
    Expect(0, 129751, '\P{^Is_Emoji=	Y}', "");
    Error('\p{Emoji=/a/_t}');
    Error('\P{Emoji=/a/_t}');
    Expect(1, 129750, '\p{Emoji=:\AT\z:}', "");;
    Expect(0, 129751, '\p{Emoji=:\AT\z:}', "");;
    Expect(1, 129750, '\p{Emoji=t}', "");
    Expect(0, 129750, '\p{^Emoji=t}', "");
    Expect(0, 129750, '\P{Emoji=t}', "");
    Expect(1, 129750, '\P{^Emoji=t}', "");
    Expect(0, 129751, '\p{Emoji=t}', "");
    Expect(1, 129751, '\p{^Emoji=t}', "");
    Expect(1, 129751, '\P{Emoji=t}', "");
    Expect(0, 129751, '\P{^Emoji=t}', "");
    Expect(1, 129750, '\p{Emoji=:\At\z:}', "");;
    Expect(0, 129751, '\p{Emoji=:\At\z:}', "");;
    Expect(1, 129750, '\p{Emoji=--T}', "");
    Expect(0, 129750, '\p{^Emoji=--T}', "");
    Expect(0, 129750, '\P{Emoji=--T}', "");
    Expect(1, 129750, '\P{^Emoji=--T}', "");
    Expect(0, 129751, '\p{Emoji=--T}', "");
    Expect(1, 129751, '\p{^Emoji=--T}', "");
    Expect(1, 129751, '\P{Emoji=--T}', "");
    Expect(0, 129751, '\P{^Emoji=--T}', "");
    Error('\p{Is_Emoji:   	-True:=}');
    Error('\P{Is_Emoji:   	-True:=}');
    Expect(1, 129750, '\p{Is_Emoji=true}', "");
    Expect(0, 129750, '\p{^Is_Emoji=true}', "");
    Expect(0, 129750, '\P{Is_Emoji=true}', "");
    Expect(1, 129750, '\P{^Is_Emoji=true}', "");
    Expect(0, 129751, '\p{Is_Emoji=true}', "");
    Expect(1, 129751, '\p{^Is_Emoji=true}', "");
    Expect(1, 129751, '\P{Is_Emoji=true}', "");
    Expect(0, 129751, '\P{^Is_Emoji=true}', "");
    Expect(1, 129750, '\p{Is_Emoji= true}', "");
    Expect(0, 129750, '\p{^Is_Emoji= true}', "");
    Expect(0, 129750, '\P{Is_Emoji= true}', "");
    Expect(1, 129750, '\P{^Is_Emoji= true}', "");
    Expect(0, 129751, '\p{Is_Emoji= true}', "");
    Expect(1, 129751, '\p{^Is_Emoji= true}', "");
    Expect(1, 129751, '\P{Is_Emoji= true}', "");
    Expect(0, 129751, '\P{^Is_Emoji= true}', "");
    Error('\p{Emoji_Presentation:   -:=no}');
    Error('\P{Emoji_Presentation:   -:=no}');
    Expect(1, 129751, '\p{Emoji_Presentation=:\ANo\z:}', "");;
    Expect(0, 129750, '\p{Emoji_Presentation=:\ANo\z:}', "");;
    Expect(1, 129751, '\p{Emoji_Presentation=no}', "");
    Expect(0, 129751, '\p{^Emoji_Presentation=no}', "");
    Expect(0, 129751, '\P{Emoji_Presentation=no}', "");
    Expect(1, 129751, '\P{^Emoji_Presentation=no}', "");
    Expect(0, 129750, '\p{Emoji_Presentation=no}', "");
    Expect(1, 129750, '\p{^Emoji_Presentation=no}', "");
    Expect(1, 129750, '\P{Emoji_Presentation=no}', "");
    Expect(0, 129750, '\P{^Emoji_Presentation=no}', "");
    Expect(1, 129751, '\p{Emoji_Presentation=:\Ano\z:}', "");;
    Expect(0, 129750, '\p{Emoji_Presentation=:\Ano\z:}', "");;
    Expect(1, 129751, '\p{Emoji_Presentation=_NO}', "");
    Expect(0, 129751, '\p{^Emoji_Presentation=_NO}', "");
    Expect(0, 129751, '\P{Emoji_Presentation=_NO}', "");
    Expect(1, 129751, '\P{^Emoji_Presentation=_NO}', "");
    Expect(0, 129750, '\p{Emoji_Presentation=_NO}', "");
    Expect(1, 129750, '\p{^Emoji_Presentation=_NO}', "");
    Expect(1, 129750, '\P{Emoji_Presentation=_NO}', "");
    Expect(0, 129750, '\P{^Emoji_Presentation=_NO}', "");
    Error('\p{EPres= :=N}');
    Error('\P{EPres= :=N}');
    Expect(1, 129751, '\p{EPres=:\AN\z:}', "");;
    Expect(0, 129750, '\p{EPres=:\AN\z:}', "");;
    Expect(1, 129751, '\p{EPres=n}', "");
    Expect(0, 129751, '\p{^EPres=n}', "");
    Expect(0, 129751, '\P{EPres=n}', "");
    Expect(1, 129751, '\P{^EPres=n}', "");
    Expect(0, 129750, '\p{EPres=n}', "");
    Expect(1, 129750, '\p{^EPres=n}', "");
    Expect(1, 129750, '\P{EPres=n}', "");
    Expect(0, 129750, '\P{^EPres=n}', "");
    Expect(1, 129751, '\p{EPres=:\An\z:}', "");;
    Expect(0, 129750, '\p{EPres=:\An\z:}', "");;
    Expect(1, 129751, '\p{EPres=	-N}', "");
    Expect(0, 129751, '\p{^EPres=	-N}', "");
    Expect(0, 129751, '\P{EPres=	-N}', "");
    Expect(1, 129751, '\P{^EPres=	-N}', "");
    Expect(0, 129750, '\p{EPres=	-N}', "");
    Expect(1, 129750, '\p{^EPres=	-N}', "");
    Expect(1, 129750, '\P{EPres=	-N}', "");
    Expect(0, 129750, '\P{^EPres=	-N}', "");
    Error('\p{Is_Emoji_Presentation=/a/_ f}');
    Error('\P{Is_Emoji_Presentation=/a/_ f}');
    Expect(1, 129751, '\p{Is_Emoji_Presentation=f}', "");
    Expect(0, 129751, '\p{^Is_Emoji_Presentation=f}', "");
    Expect(0, 129751, '\P{Is_Emoji_Presentation=f}', "");
    Expect(1, 129751, '\P{^Is_Emoji_Presentation=f}', "");
    Expect(0, 129750, '\p{Is_Emoji_Presentation=f}', "");
    Expect(1, 129750, '\p{^Is_Emoji_Presentation=f}', "");
    Expect(1, 129750, '\P{Is_Emoji_Presentation=f}', "");
    Expect(0, 129750, '\P{^Is_Emoji_Presentation=f}', "");
    Expect(1, 129751, '\p{Is_Emoji_Presentation=_F}', "");
    Expect(0, 129751, '\p{^Is_Emoji_Presentation=_F}', "");
    Expect(0, 129751, '\P{Is_Emoji_Presentation=_F}', "");
    Expect(1, 129751, '\P{^Is_Emoji_Presentation=_F}', "");
    Expect(0, 129750, '\p{Is_Emoji_Presentation=_F}', "");
    Expect(1, 129750, '\p{^Is_Emoji_Presentation=_F}', "");
    Expect(1, 129750, '\P{Is_Emoji_Presentation=_F}', "");
    Expect(0, 129750, '\P{^Is_Emoji_Presentation=_F}', "");
    Error('\p{Is_EPres=	/a/false}');
    Error('\P{Is_EPres=	/a/false}');
    Expect(1, 129751, '\p{Is_EPres=false}', "");
    Expect(0, 129751, '\p{^Is_EPres=false}', "");
    Expect(0, 129751, '\P{Is_EPres=false}', "");
    Expect(1, 129751, '\P{^Is_EPres=false}', "");
    Expect(0, 129750, '\p{Is_EPres=false}', "");
    Expect(1, 129750, '\p{^Is_EPres=false}', "");
    Expect(1, 129750, '\P{Is_EPres=false}', "");
    Expect(0, 129750, '\P{^Is_EPres=false}', "");
    Expect(1, 129751, '\p{Is_EPres=  False}', "");
    Expect(0, 129751, '\p{^Is_EPres=  False}', "");
    Expect(0, 129751, '\P{Is_EPres=  False}', "");
    Expect(1, 129751, '\P{^Is_EPres=  False}', "");
    Expect(0, 129750, '\p{Is_EPres=  False}', "");
    Expect(1, 129750, '\p{^Is_EPres=  False}', "");
    Expect(1, 129750, '\P{Is_EPres=  False}', "");
    Expect(0, 129750, '\P{^Is_EPres=  False}', "");
    Error('\p{Emoji_Presentation=:=__Yes}');
    Error('\P{Emoji_Presentation=:=__Yes}');
    Expect(1, 129750, '\p{Emoji_Presentation=:\AYes\z:}', "");;
    Expect(0, 129751, '\p{Emoji_Presentation=:\AYes\z:}', "");;
    Expect(1, 129750, '\p{Emoji_Presentation=yes}', "");
    Expect(0, 129750, '\p{^Emoji_Presentation=yes}', "");
    Expect(0, 129750, '\P{Emoji_Presentation=yes}', "");
    Expect(1, 129750, '\P{^Emoji_Presentation=yes}', "");
    Expect(0, 129751, '\p{Emoji_Presentation=yes}', "");
    Expect(1, 129751, '\p{^Emoji_Presentation=yes}', "");
    Expect(1, 129751, '\P{Emoji_Presentation=yes}', "");
    Expect(0, 129751, '\P{^Emoji_Presentation=yes}', "");
    Expect(1, 129750, '\p{Emoji_Presentation=:\Ayes\z:}', "");;
    Expect(0, 129751, '\p{Emoji_Presentation=:\Ayes\z:}', "");;
    Expect(1, 129750, '\p{Emoji_Presentation:	 Yes}', "");
    Expect(0, 129750, '\p{^Emoji_Presentation:	 Yes}', "");
    Expect(0, 129750, '\P{Emoji_Presentation:	 Yes}', "");
    Expect(1, 129750, '\P{^Emoji_Presentation:	 Yes}', "");
    Expect(0, 129751, '\p{Emoji_Presentation:	 Yes}', "");
    Expect(1, 129751, '\p{^Emoji_Presentation:	 Yes}', "");
    Expect(1, 129751, '\P{Emoji_Presentation:	 Yes}', "");
    Expect(0, 129751, '\P{^Emoji_Presentation:	 Yes}', "");
    Error('\p{EPres=/a/-	Y}');
    Error('\P{EPres=/a/-	Y}');
    Expect(1, 129750, '\p{EPres=:\AY\z:}', "");;
    Expect(0, 129751, '\p{EPres=:\AY\z:}', "");;
    Expect(1, 129750, '\p{EPres=y}', "");
    Expect(0, 129750, '\p{^EPres=y}', "");
    Expect(0, 129750, '\P{EPres=y}', "");
    Expect(1, 129750, '\P{^EPres=y}', "");
    Expect(0, 129751, '\p{EPres=y}', "");
    Expect(1, 129751, '\p{^EPres=y}', "");
    Expect(1, 129751, '\P{EPres=y}', "");
    Expect(0, 129751, '\P{^EPres=y}', "");
    Expect(1, 129750, '\p{EPres=:\Ay\z:}', "");;
    Expect(0, 129751, '\p{EPres=:\Ay\z:}', "");;
    Expect(1, 129750, '\p{EPres=	y}', "");
    Expect(0, 129750, '\p{^EPres=	y}', "");
    Expect(0, 129750, '\P{EPres=	y}', "");
    Expect(1, 129750, '\P{^EPres=	y}', "");
    Expect(0, 129751, '\p{EPres=	y}', "");
    Expect(1, 129751, '\p{^EPres=	y}', "");
    Expect(1, 129751, '\P{EPres=	y}', "");
    Expect(0, 129751, '\P{^EPres=	y}', "");
    Error('\p{Is_Emoji_Presentation=:=T}');
    Error('\P{Is_Emoji_Presentation=:=T}');
    Expect(1, 129750, '\p{Is_Emoji_Presentation=t}', "");
    Expect(0, 129750, '\p{^Is_Emoji_Presentation=t}', "");
    Expect(0, 129750, '\P{Is_Emoji_Presentation=t}', "");
    Expect(1, 129750, '\P{^Is_Emoji_Presentation=t}', "");
    Expect(0, 129751, '\p{Is_Emoji_Presentation=t}', "");
    Expect(1, 129751, '\p{^Is_Emoji_Presentation=t}', "");
    Expect(1, 129751, '\P{Is_Emoji_Presentation=t}', "");
    Expect(0, 129751, '\P{^Is_Emoji_Presentation=t}', "");
    Expect(1, 129750, '\p{Is_Emoji_Presentation= t}', "");
    Expect(0, 129750, '\p{^Is_Emoji_Presentation= t}', "");
    Expect(0, 129750, '\P{Is_Emoji_Presentation= t}', "");
    Expect(1, 129750, '\P{^Is_Emoji_Presentation= t}', "");
    Expect(0, 129751, '\p{Is_Emoji_Presentation= t}', "");
    Expect(1, 129751, '\p{^Is_Emoji_Presentation= t}', "");
    Expect(1, 129751, '\P{Is_Emoji_Presentation= t}', "");
    Expect(0, 129751, '\P{^Is_Emoji_Presentation= t}', "");
    Error('\p{Is_EPres=:=__True}');
    Error('\P{Is_EPres=:=__True}');
    Expect(1, 129750, '\p{Is_EPres=true}', "");
    Expect(0, 129750, '\p{^Is_EPres=true}', "");
    Expect(0, 129750, '\P{Is_EPres=true}', "");
    Expect(1, 129750, '\P{^Is_EPres=true}', "");
    Expect(0, 129751, '\p{Is_EPres=true}', "");
    Expect(1, 129751, '\p{^Is_EPres=true}', "");
    Expect(1, 129751, '\P{Is_EPres=true}', "");
    Expect(0, 129751, '\P{^Is_EPres=true}', "");
    Expect(1, 129750, '\p{Is_EPres:	_true}', "");
    Expect(0, 129750, '\p{^Is_EPres:	_true}', "");
    Expect(0, 129750, '\P{Is_EPres:	_true}', "");
    Expect(1, 129750, '\P{^Is_EPres:	_true}', "");
    Expect(0, 129751, '\p{Is_EPres:	_true}', "");
    Expect(1, 129751, '\p{^Is_EPres:	_true}', "");
    Expect(1, 129751, '\P{Is_EPres:	_true}', "");
    Expect(0, 129751, '\P{^Is_EPres:	_true}', "");
    Error('\p{equivalentunifiedideograph}');
    Error('\P{equivalentunifiedideograph}');
    Error('\p{equideo}');
    Error('\P{equideo}');
    Error('\p{Extender=/a/no}');
    Error('\P{Extender=/a/no}');
    Expect(1, 125255, '\p{Extender=:\ANo\z:}', "");;
    Expect(0, 125254, '\p{Extender=:\ANo\z:}', "");;
    Expect(1, 125255, '\p{Extender=no}', "");
    Expect(0, 125255, '\p{^Extender=no}', "");
    Expect(0, 125255, '\P{Extender=no}', "");
    Expect(1, 125255, '\P{^Extender=no}', "");
    Expect(0, 125254, '\p{Extender=no}', "");
    Expect(1, 125254, '\p{^Extender=no}', "");
    Expect(1, 125254, '\P{Extender=no}', "");
    Expect(0, 125254, '\P{^Extender=no}', "");
    Expect(1, 125255, '\p{Extender=:\Ano\z:}', "");;
    Expect(0, 125254, '\p{Extender=:\Ano\z:}', "");;
    Expect(1, 125255, '\p{Extender=	NO}', "");
    Expect(0, 125255, '\p{^Extender=	NO}', "");
    Expect(0, 125255, '\P{Extender=	NO}', "");
    Expect(1, 125255, '\P{^Extender=	NO}', "");
    Expect(0, 125254, '\p{Extender=	NO}', "");
    Expect(1, 125254, '\p{^Extender=	NO}', "");
    Expect(1, 125254, '\P{Extender=	NO}', "");
    Expect(0, 125254, '\P{^Extender=	NO}', "");
    Error('\p{Ext= N:=}');
    Error('\P{Ext= N:=}');
    Expect(1, 125255, '\p{Ext=:\AN\z:}', "");;
    Expect(0, 125254, '\p{Ext=:\AN\z:}', "");;
    Expect(1, 125255, '\p{Ext=n}', "");
    Expect(0, 125255, '\p{^Ext=n}', "");
    Expect(0, 125255, '\P{Ext=n}', "");
    Expect(1, 125255, '\P{^Ext=n}', "");
    Expect(0, 125254, '\p{Ext=n}', "");
    Expect(1, 125254, '\p{^Ext=n}', "");
    Expect(1, 125254, '\P{Ext=n}', "");
    Expect(0, 125254, '\P{^Ext=n}', "");
    Expect(1, 125255, '\p{Ext=:\An\z:}', "");;
    Expect(0, 125254, '\p{Ext=:\An\z:}', "");;
    Expect(1, 125255, '\p{Ext:   _n}', "");
    Expect(0, 125255, '\p{^Ext:   _n}', "");
    Expect(0, 125255, '\P{Ext:   _n}', "");
    Expect(1, 125255, '\P{^Ext:   _n}', "");
    Expect(0, 125254, '\p{Ext:   _n}', "");
    Expect(1, 125254, '\p{^Ext:   _n}', "");
    Expect(1, 125254, '\P{Ext:   _n}', "");
    Expect(0, 125254, '\P{^Ext:   _n}', "");
    Error('\p{Is_Extender=	-F:=}');
    Error('\P{Is_Extender=	-F:=}');
    Expect(1, 125255, '\p{Is_Extender=f}', "");
    Expect(0, 125255, '\p{^Is_Extender=f}', "");
    Expect(0, 125255, '\P{Is_Extender=f}', "");
    Expect(1, 125255, '\P{^Is_Extender=f}', "");
    Expect(0, 125254, '\p{Is_Extender=f}', "");
    Expect(1, 125254, '\p{^Is_Extender=f}', "");
    Expect(1, 125254, '\P{Is_Extender=f}', "");
    Expect(0, 125254, '\P{^Is_Extender=f}', "");
    Expect(1, 125255, '\p{Is_Extender=_	F}', "");
    Expect(0, 125255, '\p{^Is_Extender=_	F}', "");
    Expect(0, 125255, '\P{Is_Extender=_	F}', "");
    Expect(1, 125255, '\P{^Is_Extender=_	F}', "");
    Expect(0, 125254, '\p{Is_Extender=_	F}', "");
    Expect(1, 125254, '\p{^Is_Extender=_	F}', "");
    Expect(1, 125254, '\P{Is_Extender=_	F}', "");
    Expect(0, 125254, '\P{^Is_Extender=_	F}', "");
    Error('\p{Is_Ext=-/a/false}');
    Error('\P{Is_Ext=-/a/false}');
    Expect(1, 125255, '\p{Is_Ext=false}', "");
    Expect(0, 125255, '\p{^Is_Ext=false}', "");
    Expect(0, 125255, '\P{Is_Ext=false}', "");
    Expect(1, 125255, '\P{^Is_Ext=false}', "");
    Expect(0, 125254, '\p{Is_Ext=false}', "");
    Expect(1, 125254, '\p{^Is_Ext=false}', "");
    Expect(1, 125254, '\P{Is_Ext=false}', "");
    Expect(0, 125254, '\P{^Is_Ext=false}', "");
    Expect(1, 125255, '\p{Is_Ext:_ False}', "");
    Expect(0, 125255, '\p{^Is_Ext:_ False}', "");
    Expect(0, 125255, '\P{Is_Ext:_ False}', "");
    Expect(1, 125255, '\P{^Is_Ext:_ False}', "");
    Expect(0, 125254, '\p{Is_Ext:_ False}', "");
    Expect(1, 125254, '\p{^Is_Ext:_ False}', "");
    Expect(1, 125254, '\P{Is_Ext:_ False}', "");
    Expect(0, 125254, '\P{^Is_Ext:_ False}', "");
    Error('\p{Extender=_/a/yes}');
    Error('\P{Extender=_/a/yes}');
    Expect(1, 125254, '\p{Extender=:\AYes\z:}', "");;
    Expect(0, 125255, '\p{Extender=:\AYes\z:}', "");;
    Expect(1, 125254, '\p{Extender=yes}', "");
    Expect(0, 125254, '\p{^Extender=yes}', "");
    Expect(0, 125254, '\P{Extender=yes}', "");
    Expect(1, 125254, '\P{^Extender=yes}', "");
    Expect(0, 125255, '\p{Extender=yes}', "");
    Expect(1, 125255, '\p{^Extender=yes}', "");
    Expect(1, 125255, '\P{Extender=yes}', "");
    Expect(0, 125255, '\P{^Extender=yes}', "");
    Expect(1, 125254, '\p{Extender=:\Ayes\z:}', "");;
    Expect(0, 125255, '\p{Extender=:\Ayes\z:}', "");;
    Expect(1, 125254, '\p{Extender:	-Yes}', "");
    Expect(0, 125254, '\p{^Extender:	-Yes}', "");
    Expect(0, 125254, '\P{Extender:	-Yes}', "");
    Expect(1, 125254, '\P{^Extender:	-Yes}', "");
    Expect(0, 125255, '\p{Extender:	-Yes}', "");
    Expect(1, 125255, '\p{^Extender:	-Yes}', "");
    Expect(1, 125255, '\P{Extender:	-Yes}', "");
    Expect(0, 125255, '\P{^Extender:	-Yes}', "");
    Error('\p{Ext=_-Y/a/}');
    Error('\P{Ext=_-Y/a/}');
    Expect(1, 125254, '\p{Ext=:\AY\z:}', "");;
    Expect(0, 125255, '\p{Ext=:\AY\z:}', "");;
    Expect(1, 125254, '\p{Ext=y}', "");
    Expect(0, 125254, '\p{^Ext=y}', "");
    Expect(0, 125254, '\P{Ext=y}', "");
    Expect(1, 125254, '\P{^Ext=y}', "");
    Expect(0, 125255, '\p{Ext=y}', "");
    Expect(1, 125255, '\p{^Ext=y}', "");
    Expect(1, 125255, '\P{Ext=y}', "");
    Expect(0, 125255, '\P{^Ext=y}', "");
    Expect(1, 125254, '\p{Ext=:\Ay\z:}', "");;
    Expect(0, 125255, '\p{Ext=:\Ay\z:}', "");;
    Expect(1, 125254, '\p{Ext=	Y}', "");
    Expect(0, 125254, '\p{^Ext=	Y}', "");
    Expect(0, 125254, '\P{Ext=	Y}', "");
    Expect(1, 125254, '\P{^Ext=	Y}', "");
    Expect(0, 125255, '\p{Ext=	Y}', "");
    Expect(1, 125255, '\p{^Ext=	Y}', "");
    Expect(1, 125255, '\P{Ext=	Y}', "");
    Expect(0, 125255, '\P{^Ext=	Y}', "");
    Error('\p{Is_Extender= 	t/a/}');
    Error('\P{Is_Extender= 	t/a/}');
    Expect(1, 125254, '\p{Is_Extender=t}', "");
    Expect(0, 125254, '\p{^Is_Extender=t}', "");
    Expect(0, 125254, '\P{Is_Extender=t}', "");
    Expect(1, 125254, '\P{^Is_Extender=t}', "");
    Expect(0, 125255, '\p{Is_Extender=t}', "");
    Expect(1, 125255, '\p{^Is_Extender=t}', "");
    Expect(1, 125255, '\P{Is_Extender=t}', "");
    Expect(0, 125255, '\P{^Is_Extender=t}', "");
    Expect(1, 125254, '\p{Is_Extender=T}', "");
    Expect(0, 125254, '\p{^Is_Extender=T}', "");
    Expect(0, 125254, '\P{Is_Extender=T}', "");
    Expect(1, 125254, '\P{^Is_Extender=T}', "");
    Expect(0, 125255, '\p{Is_Extender=T}', "");
    Expect(1, 125255, '\p{^Is_Extender=T}', "");
    Expect(1, 125255, '\P{Is_Extender=T}', "");
    Expect(0, 125255, '\P{^Is_Extender=T}', "");
    Error('\p{Is_Ext:-/a/true}');
    Error('\P{Is_Ext:-/a/true}');
    Expect(1, 125254, '\p{Is_Ext=true}', "");
    Expect(0, 125254, '\p{^Is_Ext=true}', "");
    Expect(0, 125254, '\P{Is_Ext=true}', "");
    Expect(1, 125254, '\P{^Is_Ext=true}', "");
    Expect(0, 125255, '\p{Is_Ext=true}', "");
    Expect(1, 125255, '\p{^Is_Ext=true}', "");
    Expect(1, 125255, '\P{Is_Ext=true}', "");
    Expect(0, 125255, '\P{^Is_Ext=true}', "");
    Expect(1, 125254, '\p{Is_Ext= _True}', "");
    Expect(0, 125254, '\p{^Is_Ext= _True}', "");
    Expect(0, 125254, '\P{Is_Ext= _True}', "");
    Expect(1, 125254, '\P{^Is_Ext= _True}', "");
    Expect(0, 125255, '\p{Is_Ext= _True}', "");
    Expect(1, 125255, '\p{^Is_Ext= _True}', "");
    Expect(1, 125255, '\P{Is_Ext= _True}', "");
    Expect(0, 125255, '\P{^Is_Ext= _True}', "");
    Error('\p{Extended_Pictographic=_/a/No}');
    Error('\P{Extended_Pictographic=_/a/No}');
    Expect(1, 131072, '\p{Extended_Pictographic=:\ANo\z:}', "");;
    Expect(0, 131069, '\p{Extended_Pictographic=:\ANo\z:}', "");;
    Expect(1, 131072, '\p{Extended_Pictographic=no}', "");
    Expect(0, 131072, '\p{^Extended_Pictographic=no}', "");
    Expect(0, 131072, '\P{Extended_Pictographic=no}', "");
    Expect(1, 131072, '\P{^Extended_Pictographic=no}', "");
    Expect(0, 131069, '\p{Extended_Pictographic=no}', "");
    Expect(1, 131069, '\p{^Extended_Pictographic=no}', "");
    Expect(1, 131069, '\P{Extended_Pictographic=no}', "");
    Expect(0, 131069, '\P{^Extended_Pictographic=no}', "");
    Expect(1, 131072, '\p{Extended_Pictographic=:\Ano\z:}', "");;
    Expect(0, 131069, '\p{Extended_Pictographic=:\Ano\z:}', "");;
    Expect(1, 131072, '\p{Extended_Pictographic= -No}', "");
    Expect(0, 131072, '\p{^Extended_Pictographic= -No}', "");
    Expect(0, 131072, '\P{Extended_Pictographic= -No}', "");
    Expect(1, 131072, '\P{^Extended_Pictographic= -No}', "");
    Expect(0, 131069, '\p{Extended_Pictographic= -No}', "");
    Expect(1, 131069, '\p{^Extended_Pictographic= -No}', "");
    Expect(1, 131069, '\P{Extended_Pictographic= -No}', "");
    Expect(0, 131069, '\P{^Extended_Pictographic= -No}', "");
    Error('\p{ExtPict=_/a/N}');
    Error('\P{ExtPict=_/a/N}');
    Expect(1, 131072, '\p{ExtPict=:\AN\z:}', "");;
    Expect(0, 131069, '\p{ExtPict=:\AN\z:}', "");;
    Expect(1, 131072, '\p{ExtPict=n}', "");
    Expect(0, 131072, '\p{^ExtPict=n}', "");
    Expect(0, 131072, '\P{ExtPict=n}', "");
    Expect(1, 131072, '\P{^ExtPict=n}', "");
    Expect(0, 131069, '\p{ExtPict=n}', "");
    Expect(1, 131069, '\p{^ExtPict=n}', "");
    Expect(1, 131069, '\P{ExtPict=n}', "");
    Expect(0, 131069, '\P{^ExtPict=n}', "");
    Expect(1, 131072, '\p{ExtPict=:\An\z:}', "");;
    Expect(0, 131069, '\p{ExtPict=:\An\z:}', "");;
    Expect(1, 131072, '\p{ExtPict=	_N}', "");
    Expect(0, 131072, '\p{^ExtPict=	_N}', "");
    Expect(0, 131072, '\P{ExtPict=	_N}', "");
    Expect(1, 131072, '\P{^ExtPict=	_N}', "");
    Expect(0, 131069, '\p{ExtPict=	_N}', "");
    Expect(1, 131069, '\p{^ExtPict=	_N}', "");
    Expect(1, 131069, '\P{ExtPict=	_N}', "");
    Expect(0, 131069, '\P{^ExtPict=	_N}', "");
    Error('\p{Is_Extended_Pictographic=:= _F}');
    Error('\P{Is_Extended_Pictographic=:= _F}');
    Expect(1, 131072, '\p{Is_Extended_Pictographic=f}', "");
    Expect(0, 131072, '\p{^Is_Extended_Pictographic=f}', "");
    Expect(0, 131072, '\P{Is_Extended_Pictographic=f}', "");
    Expect(1, 131072, '\P{^Is_Extended_Pictographic=f}', "");
    Expect(0, 131069, '\p{Is_Extended_Pictographic=f}', "");
    Expect(1, 131069, '\p{^Is_Extended_Pictographic=f}', "");
    Expect(1, 131069, '\P{Is_Extended_Pictographic=f}', "");
    Expect(0, 131069, '\P{^Is_Extended_Pictographic=f}', "");
    Expect(1, 131072, '\p{Is_Extended_Pictographic=	F}', "");
    Expect(0, 131072, '\p{^Is_Extended_Pictographic=	F}', "");
    Expect(0, 131072, '\P{Is_Extended_Pictographic=	F}', "");
    Expect(1, 131072, '\P{^Is_Extended_Pictographic=	F}', "");
    Expect(0, 131069, '\p{Is_Extended_Pictographic=	F}', "");
    Expect(1, 131069, '\p{^Is_Extended_Pictographic=	F}', "");
    Expect(1, 131069, '\P{Is_Extended_Pictographic=	F}', "");
    Expect(0, 131069, '\P{^Is_Extended_Pictographic=	F}', "");
    Error('\p{Is_ExtPict=-_false/a/}');
    Error('\P{Is_ExtPict=-_false/a/}');
    Expect(1, 131072, '\p{Is_ExtPict=false}', "");
    Expect(0, 131072, '\p{^Is_ExtPict=false}', "");
    Expect(0, 131072, '\P{Is_ExtPict=false}', "");
    Expect(1, 131072, '\P{^Is_ExtPict=false}', "");
    Expect(0, 131069, '\p{Is_ExtPict=false}', "");
    Expect(1, 131069, '\p{^Is_ExtPict=false}', "");
    Expect(1, 131069, '\P{Is_ExtPict=false}', "");
    Expect(0, 131069, '\P{^Is_ExtPict=false}', "");
    Expect(1, 131072, '\p{Is_ExtPict=_FALSE}', "");
    Expect(0, 131072, '\p{^Is_ExtPict=_FALSE}', "");
    Expect(0, 131072, '\P{Is_ExtPict=_FALSE}', "");
    Expect(1, 131072, '\P{^Is_ExtPict=_FALSE}', "");
    Expect(0, 131069, '\p{Is_ExtPict=_FALSE}', "");
    Expect(1, 131069, '\p{^Is_ExtPict=_FALSE}', "");
    Expect(1, 131069, '\P{Is_ExtPict=_FALSE}', "");
    Expect(0, 131069, '\P{^Is_ExtPict=_FALSE}', "");
    Error('\p{Extended_Pictographic=_:=YES}');
    Error('\P{Extended_Pictographic=_:=YES}');
    Expect(1, 131069, '\p{Extended_Pictographic=:\AYes\z:}', "");;
    Expect(0, 131072, '\p{Extended_Pictographic=:\AYes\z:}', "");;
    Expect(1, 131069, '\p{Extended_Pictographic=yes}', "");
    Expect(0, 131069, '\p{^Extended_Pictographic=yes}', "");
    Expect(0, 131069, '\P{Extended_Pictographic=yes}', "");
    Expect(1, 131069, '\P{^Extended_Pictographic=yes}', "");
    Expect(0, 131072, '\p{Extended_Pictographic=yes}', "");
    Expect(1, 131072, '\p{^Extended_Pictographic=yes}', "");
    Expect(1, 131072, '\P{Extended_Pictographic=yes}', "");
    Expect(0, 131072, '\P{^Extended_Pictographic=yes}', "");
    Expect(1, 131069, '\p{Extended_Pictographic=:\Ayes\z:}', "");;
    Expect(0, 131072, '\p{Extended_Pictographic=:\Ayes\z:}', "");;
    Expect(1, 131069, '\p{Extended_Pictographic=- YES}', "");
    Expect(0, 131069, '\p{^Extended_Pictographic=- YES}', "");
    Expect(0, 131069, '\P{Extended_Pictographic=- YES}', "");
    Expect(1, 131069, '\P{^Extended_Pictographic=- YES}', "");
    Expect(0, 131072, '\p{Extended_Pictographic=- YES}', "");
    Expect(1, 131072, '\p{^Extended_Pictographic=- YES}', "");
    Expect(1, 131072, '\P{Extended_Pictographic=- YES}', "");
    Expect(0, 131072, '\P{^Extended_Pictographic=- YES}', "");
    Error('\p{ExtPict=-Y/a/}');
    Error('\P{ExtPict=-Y/a/}');
    Expect(1, 131069, '\p{ExtPict=:\AY\z:}', "");;
    Expect(0, 131072, '\p{ExtPict=:\AY\z:}', "");;
    Expect(1, 131069, '\p{ExtPict=y}', "");
    Expect(0, 131069, '\p{^ExtPict=y}', "");
    Expect(0, 131069, '\P{ExtPict=y}', "");
    Expect(1, 131069, '\P{^ExtPict=y}', "");
    Expect(0, 131072, '\p{ExtPict=y}', "");
    Expect(1, 131072, '\p{^ExtPict=y}', "");
    Expect(1, 131072, '\P{ExtPict=y}', "");
    Expect(0, 131072, '\P{^ExtPict=y}', "");
    Expect(1, 131069, '\p{ExtPict=:\Ay\z:}', "");;
    Expect(0, 131072, '\p{ExtPict=:\Ay\z:}', "");;
    Expect(1, 131069, '\p{ExtPict=	-Y}', "");
    Expect(0, 131069, '\p{^ExtPict=	-Y}', "");
    Expect(0, 131069, '\P{ExtPict=	-Y}', "");
    Expect(1, 131069, '\P{^ExtPict=	-Y}', "");
    Expect(0, 131072, '\p{ExtPict=	-Y}', "");
    Expect(1, 131072, '\p{^ExtPict=	-Y}', "");
    Expect(1, 131072, '\P{ExtPict=	-Y}', "");
    Expect(0, 131072, '\P{^ExtPict=	-Y}', "");
    Error('\p{Is_Extended_Pictographic:    	T/a/}');
    Error('\P{Is_Extended_Pictographic:    	T/a/}');
    Expect(1, 131069, '\p{Is_Extended_Pictographic=t}', "");
    Expect(0, 131069, '\p{^Is_Extended_Pictographic=t}', "");
    Expect(0, 131069, '\P{Is_Extended_Pictographic=t}', "");
    Expect(1, 131069, '\P{^Is_Extended_Pictographic=t}', "");
    Expect(0, 131072, '\p{Is_Extended_Pictographic=t}', "");
    Expect(1, 131072, '\p{^Is_Extended_Pictographic=t}', "");
    Expect(1, 131072, '\P{Is_Extended_Pictographic=t}', "");
    Expect(0, 131072, '\P{^Is_Extended_Pictographic=t}', "");
    Expect(1, 131069, '\p{Is_Extended_Pictographic=	_T}', "");
    Expect(0, 131069, '\p{^Is_Extended_Pictographic=	_T}', "");
    Expect(0, 131069, '\P{Is_Extended_Pictographic=	_T}', "");
    Expect(1, 131069, '\P{^Is_Extended_Pictographic=	_T}', "");
    Expect(0, 131072, '\p{Is_Extended_Pictographic=	_T}', "");
    Expect(1, 131072, '\p{^Is_Extended_Pictographic=	_T}', "");
    Expect(1, 131072, '\P{Is_Extended_Pictographic=	_T}', "");
    Expect(0, 131072, '\P{^Is_Extended_Pictographic=	_T}', "");
    Error('\p{Is_ExtPict= True/a/}');
    Error('\P{Is_ExtPict= True/a/}');
    Expect(1, 131069, '\p{Is_ExtPict=true}', "");
    Expect(0, 131069, '\p{^Is_ExtPict=true}', "");
    Expect(0, 131069, '\P{Is_ExtPict=true}', "");
    Expect(1, 131069, '\P{^Is_ExtPict=true}', "");
    Expect(0, 131072, '\p{Is_ExtPict=true}', "");
    Expect(1, 131072, '\p{^Is_ExtPict=true}', "");
    Expect(1, 131072, '\P{Is_ExtPict=true}', "");
    Expect(0, 131072, '\P{^Is_ExtPict=true}', "");
    Error('\p{fcnfkcclosure}');
    Error('\P{fcnfkcclosure}');
    Error('\p{fcnfkc}');
    Error('\P{fcnfkc}');
    Error('\p{generalcategory}');
    Error('\P{generalcategory}');
    Error('\p{gc}');
    Error('\P{gc}');
    Error('\p{category}');
    Error('\P{category}');
    Error('\p{General_Category=	OTHER/a/}');
    Error('\P{General_Category=	OTHER/a/}');
    Expect(1, 918000, '\p{General_Category=:\AOther\z:}', "");;
    Expect(0, 917999, '\p{General_Category=:\AOther\z:}', "");;
    Expect(1, 918000, '\p{General_Category=other}', "");
    Expect(0, 918000, '\p{^General_Category=other}', "");
    Expect(0, 918000, '\P{General_Category=other}', "");
    Expect(1, 918000, '\P{^General_Category=other}', "");
    Expect(0, 917999, '\p{General_Category=other}', "");
    Expect(1, 917999, '\p{^General_Category=other}', "");
    Expect(1, 917999, '\P{General_Category=other}', "");
    Expect(0, 917999, '\P{^General_Category=other}', "");
    Expect(1, 918000, '\p{General_Category=:\Aother\z:}', "");;
    Expect(0, 917999, '\p{General_Category=:\Aother\z:}', "");;
    Expect(1, 918000, '\p{General_Category=_other}', "");
    Expect(0, 918000, '\p{^General_Category=_other}', "");
    Expect(0, 918000, '\P{General_Category=_other}', "");
    Expect(1, 918000, '\P{^General_Category=_other}', "");
    Expect(0, 917999, '\p{General_Category=_other}', "");
    Expect(1, 917999, '\p{^General_Category=_other}', "");
    Expect(1, 917999, '\P{General_Category=_other}', "");
    Expect(0, 917999, '\P{^General_Category=_other}', "");
    Error('\p{Gc=/a/_-c}');
    Error('\P{Gc=/a/_-c}');
    Expect(1, 918000, '\p{Gc=:\AC\z:}', "");;
    Expect(0, 917999, '\p{Gc=:\AC\z:}', "");;
    Expect(1, 918000, '\p{Gc:c}', "");
    Expect(0, 918000, '\p{^Gc:c}', "");
    Expect(0, 918000, '\P{Gc:c}', "");
    Expect(1, 918000, '\P{^Gc:c}', "");
    Expect(0, 917999, '\p{Gc:c}', "");
    Expect(1, 917999, '\p{^Gc:c}', "");
    Expect(1, 917999, '\P{Gc:c}', "");
    Expect(0, 917999, '\P{^Gc:c}', "");
    Expect(1, 918000, '\p{Gc=:\Ac\z:}', "");;
    Expect(0, 917999, '\p{Gc=:\Ac\z:}', "");;
    Expect(1, 918000, '\p{Gc= -C}', "");
    Expect(0, 918000, '\p{^Gc= -C}', "");
    Expect(0, 918000, '\P{Gc= -C}', "");
    Expect(1, 918000, '\P{^Gc= -C}', "");
    Expect(0, 917999, '\p{Gc= -C}', "");
    Expect(1, 917999, '\p{^Gc= -C}', "");
    Expect(1, 917999, '\P{Gc= -C}', "");
    Expect(0, 917999, '\P{^Gc= -C}', "");
    Error('\p{Category=-_Other/a/}');
    Error('\P{Category=-_Other/a/}');
    Expect(1, 918000, '\p{Category=:\AOther\z:}', "");;
    Expect(0, 917999, '\p{Category=:\AOther\z:}', "");;
    Expect(1, 918000, '\p{Category=other}', "");
    Expect(0, 918000, '\p{^Category=other}', "");
    Expect(0, 918000, '\P{Category=other}', "");
    Expect(1, 918000, '\P{^Category=other}', "");
    Expect(0, 917999, '\p{Category=other}', "");
    Expect(1, 917999, '\p{^Category=other}', "");
    Expect(1, 917999, '\P{Category=other}', "");
    Expect(0, 917999, '\P{^Category=other}', "");
    Expect(1, 918000, '\p{Category=:\Aother\z:}', "");;
    Expect(0, 917999, '\p{Category=:\Aother\z:}', "");;
    Expect(1, 918000, '\p{Category= 	Other}', "");
    Expect(0, 918000, '\p{^Category= 	Other}', "");
    Expect(0, 918000, '\P{Category= 	Other}', "");
    Expect(1, 918000, '\P{^Category= 	Other}', "");
    Expect(0, 917999, '\p{Category= 	Other}', "");
    Expect(1, 917999, '\p{^Category= 	Other}', "");
    Expect(1, 917999, '\P{Category= 	Other}', "");
    Expect(0, 917999, '\P{^Category= 	Other}', "");
    Error('\p{Is_General_Category=/a/-C}');
    Error('\P{Is_General_Category=/a/-C}');
    Expect(1, 918000, '\p{Is_General_Category=c}', "");
    Expect(0, 918000, '\p{^Is_General_Category=c}', "");
    Expect(0, 918000, '\P{Is_General_Category=c}', "");
    Expect(1, 918000, '\P{^Is_General_Category=c}', "");
    Expect(0, 917999, '\p{Is_General_Category=c}', "");
    Expect(1, 917999, '\p{^Is_General_Category=c}', "");
    Expect(1, 917999, '\P{Is_General_Category=c}', "");
    Expect(0, 917999, '\P{^Is_General_Category=c}', "");
    Expect(1, 918000, '\p{Is_General_Category=	C}', "");
    Expect(0, 918000, '\p{^Is_General_Category=	C}', "");
    Expect(0, 918000, '\P{Is_General_Category=	C}', "");
    Expect(1, 918000, '\P{^Is_General_Category=	C}', "");
    Expect(0, 917999, '\p{Is_General_Category=	C}', "");
    Expect(1, 917999, '\p{^Is_General_Category=	C}', "");
    Expect(1, 917999, '\P{Is_General_Category=	C}', "");
    Expect(0, 917999, '\P{^Is_General_Category=	C}', "");
    Error('\p{Is_Gc:   /a/ 	OTHER}');
    Error('\P{Is_Gc:   /a/ 	OTHER}');
    Expect(1, 918000, '\p{Is_Gc=other}', "");
    Expect(0, 918000, '\p{^Is_Gc=other}', "");
    Expect(0, 918000, '\P{Is_Gc=other}', "");
    Expect(1, 918000, '\P{^Is_Gc=other}', "");
    Expect(0, 917999, '\p{Is_Gc=other}', "");
    Expect(1, 917999, '\p{^Is_Gc=other}', "");
    Expect(1, 917999, '\P{Is_Gc=other}', "");
    Expect(0, 917999, '\P{^Is_Gc=other}', "");
    Expect(1, 918000, '\p{Is_Gc= other}', "");
    Expect(0, 918000, '\p{^Is_Gc= other}', "");
    Expect(0, 918000, '\P{Is_Gc= other}', "");
    Expect(1, 918000, '\P{^Is_Gc= other}', "");
    Expect(0, 917999, '\p{Is_Gc= other}', "");
    Expect(1, 917999, '\p{^Is_Gc= other}', "");
    Expect(1, 917999, '\P{Is_Gc= other}', "");
    Expect(0, 917999, '\P{^Is_Gc= other}', "");
    Error('\p{Is_Category=:= C}');
    Error('\P{Is_Category=:= C}');
    Expect(1, 918000, '\p{Is_Category=c}', "");
    Expect(0, 918000, '\p{^Is_Category=c}', "");
    Expect(0, 918000, '\P{Is_Category=c}', "");
    Expect(1, 918000, '\P{^Is_Category=c}', "");
    Expect(0, 917999, '\p{Is_Category=c}', "");
    Expect(1, 917999, '\p{^Is_Category=c}', "");
    Expect(1, 917999, '\P{Is_Category=c}', "");
    Expect(0, 917999, '\P{^Is_Category=c}', "");
    Expect(1, 918000, '\p{Is_Category=	-C}', "");
    Expect(0, 918000, '\p{^Is_Category=	-C}', "");
    Expect(0, 918000, '\P{Is_Category=	-C}', "");
    Expect(1, 918000, '\P{^Is_Category=	-C}', "");
    Expect(0, 917999, '\p{Is_Category=	-C}', "");
    Expect(1, 917999, '\p{^Is_Category=	-C}', "");
    Expect(1, 917999, '\P{Is_Category=	-C}', "");
    Expect(0, 917999, '\P{^Is_Category=	-C}', "");
    Error('\p{General_Category=/a/ CONTROL}');
    Error('\P{General_Category=/a/ CONTROL}');
    Expect(1, 159, '\p{General_Category=:\AControl\z:}', "");;
    Expect(0, 160, '\p{General_Category=:\AControl\z:}', "");;
    Expect(1, 159, '\p{General_Category=control}', "");
    Expect(0, 159, '\p{^General_Category=control}', "");
    Expect(0, 159, '\P{General_Category=control}', "");
    Expect(1, 159, '\P{^General_Category=control}', "");
    Expect(0, 160, '\p{General_Category=control}', "");
    Expect(1, 160, '\p{^General_Category=control}', "");
    Expect(1, 160, '\P{General_Category=control}', "");
    Expect(0, 160, '\P{^General_Category=control}', "");
    Expect(1, 159, '\p{General_Category=:\Acontrol\z:}', "");;
    Expect(0, 160, '\p{General_Category=:\Acontrol\z:}', "");;
    Expect(1, 159, '\p{General_Category=-Control}', "");
    Expect(0, 159, '\p{^General_Category=-Control}', "");
    Expect(0, 159, '\P{General_Category=-Control}', "");
    Expect(1, 159, '\P{^General_Category=-Control}', "");
    Expect(0, 160, '\p{General_Category=-Control}', "");
    Expect(1, 160, '\p{^General_Category=-Control}', "");
    Expect(1, 160, '\P{General_Category=-Control}', "");
    Expect(0, 160, '\P{^General_Category=-Control}', "");
    Error('\p{Gc: 	Cc/a/}');
    Error('\P{Gc: 	Cc/a/}');
    Expect(1, 159, '\p{Gc=:\ACc\z:}', "");;
    Expect(0, 160, '\p{Gc=:\ACc\z:}', "");;
    Expect(1, 159, '\p{Gc=cc}', "");
    Expect(0, 159, '\p{^Gc=cc}', "");
    Expect(0, 159, '\P{Gc=cc}', "");
    Expect(1, 159, '\P{^Gc=cc}', "");
    Expect(0, 160, '\p{Gc=cc}', "");
    Expect(1, 160, '\p{^Gc=cc}', "");
    Expect(1, 160, '\P{Gc=cc}', "");
    Expect(0, 160, '\P{^Gc=cc}', "");
    Expect(1, 159, '\p{Gc=:\Acc\z:}', "");;
    Expect(0, 160, '\p{Gc=:\Acc\z:}', "");;
    Expect(1, 159, '\p{Gc:	cc}', "");
    Expect(0, 159, '\p{^Gc:	cc}', "");
    Expect(0, 159, '\P{Gc:	cc}', "");
    Expect(1, 159, '\P{^Gc:	cc}', "");
    Expect(0, 160, '\p{Gc:	cc}', "");
    Expect(1, 160, '\p{^Gc:	cc}', "");
    Expect(1, 160, '\P{Gc:	cc}', "");
    Expect(0, 160, '\P{^Gc:	cc}', "");
    Error('\p{Category=_/a/CNTRL}');
    Error('\P{Category=_/a/CNTRL}');
    Expect(1, 159, '\p{Category=:\ACntrl\z:}', "");;
    Expect(0, 160, '\p{Category=:\ACntrl\z:}', "");;
    Expect(1, 159, '\p{Category=cntrl}', "");
    Expect(0, 159, '\p{^Category=cntrl}', "");
    Expect(0, 159, '\P{Category=cntrl}', "");
    Expect(1, 159, '\P{^Category=cntrl}', "");
    Expect(0, 160, '\p{Category=cntrl}', "");
    Expect(1, 160, '\p{^Category=cntrl}', "");
    Expect(1, 160, '\P{Category=cntrl}', "");
    Expect(0, 160, '\P{^Category=cntrl}', "");
    Expect(1, 159, '\p{Category=:\Acntrl\z:}', "");;
    Expect(0, 160, '\p{Category=:\Acntrl\z:}', "");;
    Expect(1, 159, '\p{Category=-Cntrl}', "");
    Expect(0, 159, '\p{^Category=-Cntrl}', "");
    Expect(0, 159, '\P{Category=-Cntrl}', "");
    Expect(1, 159, '\P{^Category=-Cntrl}', "");
    Expect(0, 160, '\p{Category=-Cntrl}', "");
    Expect(1, 160, '\p{^Category=-Cntrl}', "");
    Expect(1, 160, '\P{Category=-Cntrl}', "");
    Expect(0, 160, '\P{^Category=-Cntrl}', "");
    Error('\p{Is_General_Category=/a/_Control}');
    Error('\P{Is_General_Category=/a/_Control}');
    Expect(1, 159, '\p{Is_General_Category=control}', "");
    Expect(0, 159, '\p{^Is_General_Category=control}', "");
    Expect(0, 159, '\P{Is_General_Category=control}', "");
    Expect(1, 159, '\P{^Is_General_Category=control}', "");
    Expect(0, 160, '\p{Is_General_Category=control}', "");
    Expect(1, 160, '\p{^Is_General_Category=control}', "");
    Expect(1, 160, '\P{Is_General_Category=control}', "");
    Expect(0, 160, '\P{^Is_General_Category=control}', "");
    Expect(1, 159, '\p{Is_General_Category=		Control}', "");
    Expect(0, 159, '\p{^Is_General_Category=		Control}', "");
    Expect(0, 159, '\P{Is_General_Category=		Control}', "");
    Expect(1, 159, '\P{^Is_General_Category=		Control}', "");
    Expect(0, 160, '\p{Is_General_Category=		Control}', "");
    Expect(1, 160, '\p{^Is_General_Category=		Control}', "");
    Expect(1, 160, '\P{Is_General_Category=		Control}', "");
    Expect(0, 160, '\P{^Is_General_Category=		Control}', "");
    Error('\p{Is_Gc=-	cc:=}');
    Error('\P{Is_Gc=-	cc:=}');
    Expect(1, 159, '\p{Is_Gc=cc}', "");
    Expect(0, 159, '\p{^Is_Gc=cc}', "");
    Expect(0, 159, '\P{Is_Gc=cc}', "");
    Expect(1, 159, '\P{^Is_Gc=cc}', "");
    Expect(0, 160, '\p{Is_Gc=cc}', "");
    Expect(1, 160, '\p{^Is_Gc=cc}', "");
    Expect(1, 160, '\P{Is_Gc=cc}', "");
    Expect(0, 160, '\P{^Is_Gc=cc}', "");
    Expect(1, 159, '\p{Is_Gc=__CC}', "");
    Expect(0, 159, '\p{^Is_Gc=__CC}', "");
    Expect(0, 159, '\P{Is_Gc=__CC}', "");
    Expect(1, 159, '\P{^Is_Gc=__CC}', "");
    Expect(0, 160, '\p{Is_Gc=__CC}', "");
    Expect(1, 160, '\p{^Is_Gc=__CC}', "");
    Expect(1, 160, '\P{Is_Gc=__CC}', "");
    Expect(0, 160, '\P{^Is_Gc=__CC}', "");
    Error('\p{Is_Category=	cntrl/a/}');
    Error('\P{Is_Category=	cntrl/a/}');
    Expect(1, 159, '\p{Is_Category=cntrl}', "");
    Expect(0, 159, '\p{^Is_Category=cntrl}', "");
    Expect(0, 159, '\P{Is_Category=cntrl}', "");
    Expect(1, 159, '\P{^Is_Category=cntrl}', "");
    Expect(0, 160, '\p{Is_Category=cntrl}', "");
    Expect(1, 160, '\p{^Is_Category=cntrl}', "");
    Expect(1, 160, '\P{Is_Category=cntrl}', "");
    Expect(0, 160, '\P{^Is_Category=cntrl}', "");
    Expect(1, 159, '\p{Is_Category=	_CNTRL}', "");
    Expect(0, 159, '\p{^Is_Category=	_CNTRL}', "");
    Expect(0, 159, '\P{Is_Category=	_CNTRL}', "");
    Expect(1, 159, '\P{^Is_Category=	_CNTRL}', "");
    Expect(0, 160, '\p{Is_Category=	_CNTRL}', "");
    Expect(1, 160, '\p{^Is_Category=	_CNTRL}', "");
    Expect(1, 160, '\P{Is_Category=	_CNTRL}', "");
    Expect(0, 160, '\P{^Is_Category=	_CNTRL}', "");
    Error('\p{General_Category=/a/-Format}');
    Error('\P{General_Category=/a/-Format}');
    Expect(1, 917631, '\p{General_Category=:\AFormat\z:}', "");;
    Expect(0, 917632, '\p{General_Category=:\AFormat\z:}', "");;
    Expect(1, 917631, '\p{General_Category=format}', "");
    Expect(0, 917631, '\p{^General_Category=format}', "");
    Expect(0, 917631, '\P{General_Category=format}', "");
    Expect(1, 917631, '\P{^General_Category=format}', "");
    Expect(0, 917632, '\p{General_Category=format}', "");
    Expect(1, 917632, '\p{^General_Category=format}', "");
    Expect(1, 917632, '\P{General_Category=format}', "");
    Expect(0, 917632, '\P{^General_Category=format}', "");
    Expect(1, 917631, '\p{General_Category=:\Aformat\z:}', "");;
    Expect(0, 917632, '\p{General_Category=:\Aformat\z:}', "");;
    Expect(1, 917631, '\p{General_Category=	_FORMAT}', "");
    Expect(0, 917631, '\p{^General_Category=	_FORMAT}', "");
    Expect(0, 917631, '\P{General_Category=	_FORMAT}', "");
    Expect(1, 917631, '\P{^General_Category=	_FORMAT}', "");
    Expect(0, 917632, '\p{General_Category=	_FORMAT}', "");
    Expect(1, 917632, '\p{^General_Category=	_FORMAT}', "");
    Expect(1, 917632, '\P{General_Category=	_FORMAT}', "");
    Expect(0, 917632, '\P{^General_Category=	_FORMAT}', "");
    Error('\p{Gc=	_cf:=}');
    Error('\P{Gc=	_cf:=}');
    Expect(1, 917631, '\p{Gc=:\ACf\z:}', "");;
    Expect(0, 917632, '\p{Gc=:\ACf\z:}', "");;
    Expect(1, 917631, '\p{Gc=cf}', "");
    Expect(0, 917631, '\p{^Gc=cf}', "");
    Expect(0, 917631, '\P{Gc=cf}', "");
    Expect(1, 917631, '\P{^Gc=cf}', "");
    Expect(0, 917632, '\p{Gc=cf}', "");
    Expect(1, 917632, '\p{^Gc=cf}', "");
    Expect(1, 917632, '\P{Gc=cf}', "");
    Expect(0, 917632, '\P{^Gc=cf}', "");
    Expect(1, 917631, '\p{Gc=:\Acf\z:}', "");;
    Expect(0, 917632, '\p{Gc=:\Acf\z:}', "");;
    Expect(1, 917631, '\p{Gc: 		Cf}', "");
    Expect(0, 917631, '\p{^Gc: 		Cf}', "");
    Expect(0, 917631, '\P{Gc: 		Cf}', "");
    Expect(1, 917631, '\P{^Gc: 		Cf}', "");
    Expect(0, 917632, '\p{Gc: 		Cf}', "");
    Expect(1, 917632, '\p{^Gc: 		Cf}', "");
    Expect(1, 917632, '\P{Gc: 		Cf}', "");
    Expect(0, 917632, '\P{^Gc: 		Cf}', "");
    Error('\p{Category=	:=format}');
    Error('\P{Category=	:=format}');
    Expect(1, 917631, '\p{Category=:\AFormat\z:}', "");;
    Expect(0, 917632, '\p{Category=:\AFormat\z:}', "");;
    Expect(1, 917631, '\p{Category=format}', "");
    Expect(0, 917631, '\p{^Category=format}', "");
    Expect(0, 917631, '\P{Category=format}', "");
    Expect(1, 917631, '\P{^Category=format}', "");
    Expect(0, 917632, '\p{Category=format}', "");
    Expect(1, 917632, '\p{^Category=format}', "");
    Expect(1, 917632, '\P{Category=format}', "");
    Expect(0, 917632, '\P{^Category=format}', "");
    Expect(1, 917631, '\p{Category=:\Aformat\z:}', "");;
    Expect(0, 917632, '\p{Category=:\Aformat\z:}', "");;
    Expect(1, 917631, '\p{Category=	_format}', "");
    Expect(0, 917631, '\p{^Category=	_format}', "");
    Expect(0, 917631, '\P{Category=	_format}', "");
    Expect(1, 917631, '\P{^Category=	_format}', "");
    Expect(0, 917632, '\p{Category=	_format}', "");
    Expect(1, 917632, '\p{^Category=	_format}', "");
    Expect(1, 917632, '\P{Category=	_format}', "");
    Expect(0, 917632, '\P{^Category=	_format}', "");
    Error('\p{Is_General_Category=_/a/Cf}');
    Error('\P{Is_General_Category=_/a/Cf}');
    Expect(1, 917631, '\p{Is_General_Category=cf}', "");
    Expect(0, 917631, '\p{^Is_General_Category=cf}', "");
    Expect(0, 917631, '\P{Is_General_Category=cf}', "");
    Expect(1, 917631, '\P{^Is_General_Category=cf}', "");
    Expect(0, 917632, '\p{Is_General_Category=cf}', "");
    Expect(1, 917632, '\p{^Is_General_Category=cf}', "");
    Expect(1, 917632, '\P{Is_General_Category=cf}', "");
    Expect(0, 917632, '\P{^Is_General_Category=cf}', "");
    Expect(1, 917631, '\p{Is_General_Category=	cf}', "");
    Expect(0, 917631, '\p{^Is_General_Category=	cf}', "");
    Expect(0, 917631, '\P{Is_General_Category=	cf}', "");
    Expect(1, 917631, '\P{^Is_General_Category=	cf}', "");
    Expect(0, 917632, '\p{Is_General_Category=	cf}', "");
    Expect(1, 917632, '\p{^Is_General_Category=	cf}', "");
    Expect(1, 917632, '\P{Is_General_Category=	cf}', "");
    Expect(0, 917632, '\P{^Is_General_Category=	cf}', "");
    Error('\p{Is_Gc=_/a/format}');
    Error('\P{Is_Gc=_/a/format}');
    Expect(1, 917631, '\p{Is_Gc:	format}', "");
    Expect(0, 917631, '\p{^Is_Gc:	format}', "");
    Expect(0, 917631, '\P{Is_Gc:	format}', "");
    Expect(1, 917631, '\P{^Is_Gc:	format}', "");
    Expect(0, 917632, '\p{Is_Gc:	format}', "");
    Expect(1, 917632, '\p{^Is_Gc:	format}', "");
    Expect(1, 917632, '\P{Is_Gc:	format}', "");
    Expect(0, 917632, '\P{^Is_Gc:	format}', "");
    Expect(1, 917631, '\p{Is_Gc=-_FORMAT}', "");
    Expect(0, 917631, '\p{^Is_Gc=-_FORMAT}', "");
    Expect(0, 917631, '\P{Is_Gc=-_FORMAT}', "");
    Expect(1, 917631, '\P{^Is_Gc=-_FORMAT}', "");
    Expect(0, 917632, '\p{Is_Gc=-_FORMAT}', "");
    Expect(1, 917632, '\p{^Is_Gc=-_FORMAT}', "");
    Expect(1, 917632, '\P{Is_Gc=-_FORMAT}', "");
    Expect(0, 917632, '\P{^Is_Gc=-_FORMAT}', "");
    Error('\p{Is_Category=:=	_CF}');
    Error('\P{Is_Category=:=	_CF}');
    Expect(1, 917631, '\p{Is_Category=cf}', "");
    Expect(0, 917631, '\p{^Is_Category=cf}', "");
    Expect(0, 917631, '\P{Is_Category=cf}', "");
    Expect(1, 917631, '\P{^Is_Category=cf}', "");
    Expect(0, 917632, '\p{Is_Category=cf}', "");
    Expect(1, 917632, '\p{^Is_Category=cf}', "");
    Expect(1, 917632, '\P{Is_Category=cf}', "");
    Expect(0, 917632, '\P{^Is_Category=cf}', "");
    Expect(1, 917631, '\p{Is_Category=_Cf}', "");
    Expect(0, 917631, '\p{^Is_Category=_Cf}', "");
    Expect(0, 917631, '\P{Is_Category=_Cf}', "");
    Expect(1, 917631, '\P{^Is_Category=_Cf}', "");
    Expect(0, 917632, '\p{Is_Category=_Cf}', "");
    Expect(1, 917632, '\p{^Is_Category=_Cf}', "");
    Expect(1, 917632, '\P{Is_Category=_Cf}', "");
    Expect(0, 917632, '\P{^Is_Category=_Cf}', "");
    Error('\p{General_Category=:=  UNASSIGNED}');
    Error('\P{General_Category=:=  UNASSIGNED}');
    Expect(1, 918000, '\p{General_Category=:\AUnassigned\z:}', "");;
    Expect(0, 1114109, '\p{General_Category=:\AUnassigned\z:}', "");;
    Expect(1, 918000, '\p{General_Category=unassigned}', "");
    Expect(0, 918000, '\p{^General_Category=unassigned}', "");
    Expect(0, 918000, '\P{General_Category=unassigned}', "");
    Expect(1, 918000, '\P{^General_Category=unassigned}', "");
    Expect(0, 1114109, '\p{General_Category=unassigned}', "");
    Expect(1, 1114109, '\p{^General_Category=unassigned}', "");
    Expect(1, 1114109, '\P{General_Category=unassigned}', "");
    Expect(0, 1114109, '\P{^General_Category=unassigned}', "");
    Expect(1, 918000, '\p{General_Category=:\Aunassigned\z:}', "");;
    Expect(0, 1114109, '\p{General_Category=:\Aunassigned\z:}', "");;
    Expect(1, 918000, '\p{General_Category= -UNASSIGNED}', "");
    Expect(0, 918000, '\p{^General_Category= -UNASSIGNED}', "");
    Expect(0, 918000, '\P{General_Category= -UNASSIGNED}', "");
    Expect(1, 918000, '\P{^General_Category= -UNASSIGNED}', "");
    Expect(0, 1114109, '\p{General_Category= -UNASSIGNED}', "");
    Expect(1, 1114109, '\p{^General_Category= -UNASSIGNED}', "");
    Expect(1, 1114109, '\P{General_Category= -UNASSIGNED}', "");
    Expect(0, 1114109, '\P{^General_Category= -UNASSIGNED}', "");
    Error('\p{Gc=/a/	cn}');
    Error('\P{Gc=/a/	cn}');
    Expect(1, 918000, '\p{Gc=:\ACn\z:}', "");;
    Expect(0, 1114109, '\p{Gc=:\ACn\z:}', "");;
    Expect(1, 918000, '\p{Gc=cn}', "");
    Expect(0, 918000, '\p{^Gc=cn}', "");
    Expect(0, 918000, '\P{Gc=cn}', "");
    Expect(1, 918000, '\P{^Gc=cn}', "");
    Expect(0, 1114109, '\p{Gc=cn}', "");
    Expect(1, 1114109, '\p{^Gc=cn}', "");
    Expect(1, 1114109, '\P{Gc=cn}', "");
    Expect(0, 1114109, '\P{^Gc=cn}', "");
    Expect(1, 918000, '\p{Gc=:\Acn\z:}', "");;
    Expect(0, 1114109, '\p{Gc=:\Acn\z:}', "");;
    Expect(1, 918000, '\p{Gc= CN}', "");
    Expect(0, 918000, '\p{^Gc= CN}', "");
    Expect(0, 918000, '\P{Gc= CN}', "");
    Expect(1, 918000, '\P{^Gc= CN}', "");
    Expect(0, 1114109, '\p{Gc= CN}', "");
    Expect(1, 1114109, '\p{^Gc= CN}', "");
    Expect(1, 1114109, '\P{Gc= CN}', "");
    Expect(0, 1114109, '\P{^Gc= CN}', "");
    Error('\p{Category=/a/_unassigned}');
    Error('\P{Category=/a/_unassigned}');
    Expect(1, 918000, '\p{Category=:\AUnassigned\z:}', "");;
    Expect(0, 1114109, '\p{Category=:\AUnassigned\z:}', "");;
    Expect(1, 918000, '\p{Category=unassigned}', "");
    Expect(0, 918000, '\p{^Category=unassigned}', "");
    Expect(0, 918000, '\P{Category=unassigned}', "");
    Expect(1, 918000, '\P{^Category=unassigned}', "");
    Expect(0, 1114109, '\p{Category=unassigned}', "");
    Expect(1, 1114109, '\p{^Category=unassigned}', "");
    Expect(1, 1114109, '\P{Category=unassigned}', "");
    Expect(0, 1114109, '\P{^Category=unassigned}', "");
    Expect(1, 918000, '\p{Category=:\Aunassigned\z:}', "");;
    Expect(0, 1114109, '\p{Category=:\Aunassigned\z:}', "");;
    Expect(1, 918000, '\p{Category= UNASSIGNED}', "");
    Expect(0, 918000, '\p{^Category= UNASSIGNED}', "");
    Expect(0, 918000, '\P{Category= UNASSIGNED}', "");
    Expect(1, 918000, '\P{^Category= UNASSIGNED}', "");
    Expect(0, 1114109, '\p{Category= UNASSIGNED}', "");
    Expect(1, 1114109, '\p{^Category= UNASSIGNED}', "");
    Expect(1, 1114109, '\P{Category= UNASSIGNED}', "");
    Expect(0, 1114109, '\P{^Category= UNASSIGNED}', "");
    Error('\p{Is_General_Category=:= Cn}');
    Error('\P{Is_General_Category=:= Cn}');
    Expect(1, 918000, '\p{Is_General_Category=cn}', "");
    Expect(0, 918000, '\p{^Is_General_Category=cn}', "");
    Expect(0, 918000, '\P{Is_General_Category=cn}', "");
    Expect(1, 918000, '\P{^Is_General_Category=cn}', "");
    Expect(0, 1114109, '\p{Is_General_Category=cn}', "");
    Expect(1, 1114109, '\p{^Is_General_Category=cn}', "");
    Expect(1, 1114109, '\P{Is_General_Category=cn}', "");
    Expect(0, 1114109, '\P{^Is_General_Category=cn}', "");
    Expect(1, 918000, '\p{Is_General_Category=_-Cn}', "");
    Expect(0, 918000, '\p{^Is_General_Category=_-Cn}', "");
    Expect(0, 918000, '\P{Is_General_Category=_-Cn}', "");
    Expect(1, 918000, '\P{^Is_General_Category=_-Cn}', "");
    Expect(0, 1114109, '\p{Is_General_Category=_-Cn}', "");
    Expect(1, 1114109, '\p{^Is_General_Category=_-Cn}', "");
    Expect(1, 1114109, '\P{Is_General_Category=_-Cn}', "");
    Expect(0, 1114109, '\P{^Is_General_Category=_-Cn}', "");
    Error('\p{Is_Gc=_-unassigned:=}');
    Error('\P{Is_Gc=_-unassigned:=}');
    Expect(1, 918000, '\p{Is_Gc=unassigned}', "");
    Expect(0, 918000, '\p{^Is_Gc=unassigned}', "");
    Expect(0, 918000, '\P{Is_Gc=unassigned}', "");
    Expect(1, 918000, '\P{^Is_Gc=unassigned}', "");
    Expect(0, 1114109, '\p{Is_Gc=unassigned}', "");
    Expect(1, 1114109, '\p{^Is_Gc=unassigned}', "");
    Expect(1, 1114109, '\P{Is_Gc=unassigned}', "");
    Expect(0, 1114109, '\P{^Is_Gc=unassigned}', "");
    Expect(1, 918000, '\p{Is_Gc:	__UNASSIGNED}', "");
    Expect(0, 918000, '\p{^Is_Gc:	__UNASSIGNED}', "");
    Expect(0, 918000, '\P{Is_Gc:	__UNASSIGNED}', "");
    Expect(1, 918000, '\P{^Is_Gc:	__UNASSIGNED}', "");
    Expect(0, 1114109, '\p{Is_Gc:	__UNASSIGNED}', "");
    Expect(1, 1114109, '\p{^Is_Gc:	__UNASSIGNED}', "");
    Expect(1, 1114109, '\P{Is_Gc:	__UNASSIGNED}', "");
    Expect(0, 1114109, '\P{^Is_Gc:	__UNASSIGNED}', "");
    Error('\p{Is_Category=_/a/CN}');
    Error('\P{Is_Category=_/a/CN}');
    Expect(1, 918000, '\p{Is_Category=cn}', "");
    Expect(0, 918000, '\p{^Is_Category=cn}', "");
    Expect(0, 918000, '\P{Is_Category=cn}', "");
    Expect(1, 918000, '\P{^Is_Category=cn}', "");
    Expect(0, 1114109, '\p{Is_Category=cn}', "");
    Expect(1, 1114109, '\p{^Is_Category=cn}', "");
    Expect(1, 1114109, '\P{Is_Category=cn}', "");
    Expect(0, 1114109, '\P{^Is_Category=cn}', "");
    Expect(1, 918000, '\p{Is_Category: 	cn}', "");
    Expect(0, 918000, '\p{^Is_Category: 	cn}', "");
    Expect(0, 918000, '\P{Is_Category: 	cn}', "");
    Expect(1, 918000, '\P{^Is_Category: 	cn}', "");
    Expect(0, 1114109, '\p{Is_Category: 	cn}', "");
    Expect(1, 1114109, '\p{^Is_Category: 	cn}', "");
    Expect(1, 1114109, '\P{Is_Category: 	cn}', "");
    Expect(0, 1114109, '\P{^Is_Category: 	cn}', "");
    Error('\p{General_Category=/a/Private_Use}');
    Error('\P{General_Category=/a/Private_Use}');
    Expect(1, 1114109, '\p{General_Category=:\APrivate_Use\z:}', "");;
    Expect(0, 63744, '\p{General_Category=:\APrivate_Use\z:}', "");;
    Expect(1, 1114109, '\p{General_Category=privateuse}', "");
    Expect(0, 1114109, '\p{^General_Category=privateuse}', "");
    Expect(0, 1114109, '\P{General_Category=privateuse}', "");
    Expect(1, 1114109, '\P{^General_Category=privateuse}', "");
    Expect(0, 63744, '\p{General_Category=privateuse}', "");
    Expect(1, 63744, '\p{^General_Category=privateuse}', "");
    Expect(1, 63744, '\P{General_Category=privateuse}', "");
    Expect(0, 63744, '\P{^General_Category=privateuse}', "");
    Expect(1, 1114109, '\p{General_Category=:\Aprivateuse\z:}', "");;
    Expect(0, 63744, '\p{General_Category=:\Aprivateuse\z:}', "");;
    Expect(1, 1114109, '\p{General_Category= Private_use}', "");
    Expect(0, 1114109, '\p{^General_Category= Private_use}', "");
    Expect(0, 1114109, '\P{General_Category= Private_use}', "");
    Expect(1, 1114109, '\P{^General_Category= Private_use}', "");
    Expect(0, 63744, '\p{General_Category= Private_use}', "");
    Expect(1, 63744, '\p{^General_Category= Private_use}', "");
    Expect(1, 63744, '\P{General_Category= Private_use}', "");
    Expect(0, 63744, '\P{^General_Category= Private_use}', "");
    Error('\p{Gc=-:=Co}');
    Error('\P{Gc=-:=Co}');
    Expect(1, 1114109, '\p{Gc=:\ACo\z:}', "");;
    Expect(0, 63744, '\p{Gc=:\ACo\z:}', "");;
    Expect(1, 1114109, '\p{Gc=co}', "");
    Expect(0, 1114109, '\p{^Gc=co}', "");
    Expect(0, 1114109, '\P{Gc=co}', "");
    Expect(1, 1114109, '\P{^Gc=co}', "");
    Expect(0, 63744, '\p{Gc=co}', "");
    Expect(1, 63744, '\p{^Gc=co}', "");
    Expect(1, 63744, '\P{Gc=co}', "");
    Expect(0, 63744, '\P{^Gc=co}', "");
    Expect(1, 1114109, '\p{Gc=:\Aco\z:}', "");;
    Expect(0, 63744, '\p{Gc=:\Aco\z:}', "");;
    Expect(1, 1114109, '\p{Gc=_ Co}', "");
    Expect(0, 1114109, '\p{^Gc=_ Co}', "");
    Expect(0, 1114109, '\P{Gc=_ Co}', "");
    Expect(1, 1114109, '\P{^Gc=_ Co}', "");
    Expect(0, 63744, '\p{Gc=_ Co}', "");
    Expect(1, 63744, '\p{^Gc=_ Co}', "");
    Expect(1, 63744, '\P{Gc=_ Co}', "");
    Expect(0, 63744, '\P{^Gc=_ Co}', "");
    Error('\p{Category=	:=Private_use}');
    Error('\P{Category=	:=Private_use}');
    Expect(1, 1114109, '\p{Category=:\APrivate_Use\z:}', "");;
    Expect(0, 63744, '\p{Category=:\APrivate_Use\z:}', "");;
    Expect(1, 1114109, '\p{Category=privateuse}', "");
    Expect(0, 1114109, '\p{^Category=privateuse}', "");
    Expect(0, 1114109, '\P{Category=privateuse}', "");
    Expect(1, 1114109, '\P{^Category=privateuse}', "");
    Expect(0, 63744, '\p{Category=privateuse}', "");
    Expect(1, 63744, '\p{^Category=privateuse}', "");
    Expect(1, 63744, '\P{Category=privateuse}', "");
    Expect(0, 63744, '\P{^Category=privateuse}', "");
    Expect(1, 1114109, '\p{Category=:\Aprivateuse\z:}', "");;
    Expect(0, 63744, '\p{Category=:\Aprivateuse\z:}', "");;
    Expect(1, 1114109, '\p{Category:	_PRIVATE_USE}', "");
    Expect(0, 1114109, '\p{^Category:	_PRIVATE_USE}', "");
    Expect(0, 1114109, '\P{Category:	_PRIVATE_USE}', "");
    Expect(1, 1114109, '\P{^Category:	_PRIVATE_USE}', "");
    Expect(0, 63744, '\p{Category:	_PRIVATE_USE}', "");
    Expect(1, 63744, '\p{^Category:	_PRIVATE_USE}', "");
    Expect(1, 63744, '\P{Category:	_PRIVATE_USE}', "");
    Expect(0, 63744, '\P{^Category:	_PRIVATE_USE}', "");
    Error('\p{Is_General_Category=/a/--Co}');
    Error('\P{Is_General_Category=/a/--Co}');
    Expect(1, 1114109, '\p{Is_General_Category=co}', "");
    Expect(0, 1114109, '\p{^Is_General_Category=co}', "");
    Expect(0, 1114109, '\P{Is_General_Category=co}', "");
    Expect(1, 1114109, '\P{^Is_General_Category=co}', "");
    Expect(0, 63744, '\p{Is_General_Category=co}', "");
    Expect(1, 63744, '\p{^Is_General_Category=co}', "");
    Expect(1, 63744, '\P{Is_General_Category=co}', "");
    Expect(0, 63744, '\P{^Is_General_Category=co}', "");
    Expect(1, 1114109, '\p{Is_General_Category=-CO}', "");
    Expect(0, 1114109, '\p{^Is_General_Category=-CO}', "");
    Expect(0, 1114109, '\P{Is_General_Category=-CO}', "");
    Expect(1, 1114109, '\P{^Is_General_Category=-CO}', "");
    Expect(0, 63744, '\p{Is_General_Category=-CO}', "");
    Expect(1, 63744, '\p{^Is_General_Category=-CO}', "");
    Expect(1, 63744, '\P{Is_General_Category=-CO}', "");
    Expect(0, 63744, '\P{^Is_General_Category=-CO}', "");
    Error('\p{Is_Gc=:=_	Private_Use}');
    Error('\P{Is_Gc=:=_	Private_Use}');
    Expect(1, 1114109, '\p{Is_Gc=privateuse}', "");
    Expect(0, 1114109, '\p{^Is_Gc=privateuse}', "");
    Expect(0, 1114109, '\P{Is_Gc=privateuse}', "");
    Expect(1, 1114109, '\P{^Is_Gc=privateuse}', "");
    Expect(0, 63744, '\p{Is_Gc=privateuse}', "");
    Expect(1, 63744, '\p{^Is_Gc=privateuse}', "");
    Expect(1, 63744, '\P{Is_Gc=privateuse}', "");
    Expect(0, 63744, '\P{^Is_Gc=privateuse}', "");
    Expect(1, 1114109, '\p{Is_Gc=PRIVATE_use}', "");
    Expect(0, 1114109, '\p{^Is_Gc=PRIVATE_use}', "");
    Expect(0, 1114109, '\P{Is_Gc=PRIVATE_use}', "");
    Expect(1, 1114109, '\P{^Is_Gc=PRIVATE_use}', "");
    Expect(0, 63744, '\p{Is_Gc=PRIVATE_use}', "");
    Expect(1, 63744, '\p{^Is_Gc=PRIVATE_use}', "");
    Expect(1, 63744, '\P{Is_Gc=PRIVATE_use}', "");
    Expect(0, 63744, '\P{^Is_Gc=PRIVATE_use}', "");
    Error('\p{Is_Category=:=-_Co}');
    Error('\P{Is_Category=:=-_Co}');
    Expect(1, 1114109, '\p{Is_Category=co}', "");
    Expect(0, 1114109, '\p{^Is_Category=co}', "");
    Expect(0, 1114109, '\P{Is_Category=co}', "");
    Expect(1, 1114109, '\P{^Is_Category=co}', "");
    Expect(0, 63744, '\p{Is_Category=co}', "");
    Expect(1, 63744, '\p{^Is_Category=co}', "");
    Expect(1, 63744, '\P{Is_Category=co}', "");
    Expect(0, 63744, '\P{^Is_Category=co}', "");
    Expect(1, 1114109, '\p{Is_Category= -CO}', "");
    Expect(0, 1114109, '\p{^Is_Category= -CO}', "");
    Expect(0, 1114109, '\P{Is_Category= -CO}', "");
    Expect(1, 1114109, '\P{^Is_Category= -CO}', "");
    Expect(0, 63744, '\p{Is_Category= -CO}', "");
    Expect(1, 63744, '\p{^Is_Category= -CO}', "");
    Expect(1, 63744, '\P{Is_Category= -CO}', "");
    Expect(0, 63744, '\P{^Is_Category= -CO}', "");
    Error('\p{General_Category=-:=Surrogate}');
    Error('\P{General_Category=-:=Surrogate}');
    Expect(1, 57343, '\p{General_Category=:\ASurrogate\z:}', "");;
    Expect(0, 57344, '\p{General_Category=:\ASurrogate\z:}', "");;
    Expect(1, 57343, '\p{General_Category=surrogate}', "");
    Expect(0, 57343, '\p{^General_Category=surrogate}', "");
    Expect(0, 57343, '\P{General_Category=surrogate}', "");
    Expect(1, 57343, '\P{^General_Category=surrogate}', "");
    Expect(0, 57344, '\p{General_Category=surrogate}', "");
    Expect(1, 57344, '\p{^General_Category=surrogate}', "");
    Expect(1, 57344, '\P{General_Category=surrogate}', "");
    Expect(0, 57344, '\P{^General_Category=surrogate}', "");
    Expect(1, 57343, '\p{General_Category=:\Asurrogate\z:}', "");;
    Expect(0, 57344, '\p{General_Category=:\Asurrogate\z:}', "");;
    Expect(1, 57343, '\p{General_Category=_	SURROGATE}', "");
    Expect(0, 57343, '\p{^General_Category=_	SURROGATE}', "");
    Expect(0, 57343, '\P{General_Category=_	SURROGATE}', "");
    Expect(1, 57343, '\P{^General_Category=_	SURROGATE}', "");
    Expect(0, 57344, '\p{General_Category=_	SURROGATE}', "");
    Expect(1, 57344, '\p{^General_Category=_	SURROGATE}', "");
    Expect(1, 57344, '\P{General_Category=_	SURROGATE}', "");
    Expect(0, 57344, '\P{^General_Category=_	SURROGATE}', "");
    Error('\p{Gc= cs/a/}');
    Error('\P{Gc= cs/a/}');
    Expect(1, 57343, '\p{Gc=:\ACs\z:}', "");;
    Expect(0, 57344, '\p{Gc=:\ACs\z:}', "");;
    Expect(1, 57343, '\p{Gc=cs}', "");
    Expect(0, 57343, '\p{^Gc=cs}', "");
    Expect(0, 57343, '\P{Gc=cs}', "");
    Expect(1, 57343, '\P{^Gc=cs}', "");
    Expect(0, 57344, '\p{Gc=cs}', "");
    Expect(1, 57344, '\p{^Gc=cs}', "");
    Expect(1, 57344, '\P{Gc=cs}', "");
    Expect(0, 57344, '\P{^Gc=cs}', "");
    Expect(1, 57343, '\p{Gc=:\Acs\z:}', "");;
    Expect(0, 57344, '\p{Gc=:\Acs\z:}', "");;
    Expect(1, 57343, '\p{Gc=  cs}', "");
    Expect(0, 57343, '\p{^Gc=  cs}', "");
    Expect(0, 57343, '\P{Gc=  cs}', "");
    Expect(1, 57343, '\P{^Gc=  cs}', "");
    Expect(0, 57344, '\p{Gc=  cs}', "");
    Expect(1, 57344, '\p{^Gc=  cs}', "");
    Expect(1, 57344, '\P{Gc=  cs}', "");
    Expect(0, 57344, '\P{^Gc=  cs}', "");
    Error('\p{Category=_-Surrogate/a/}');
    Error('\P{Category=_-Surrogate/a/}');
    Expect(1, 57343, '\p{Category=:\ASurrogate\z:}', "");;
    Expect(0, 57344, '\p{Category=:\ASurrogate\z:}', "");;
    Expect(1, 57343, '\p{Category=surrogate}', "");
    Expect(0, 57343, '\p{^Category=surrogate}', "");
    Expect(0, 57343, '\P{Category=surrogate}', "");
    Expect(1, 57343, '\P{^Category=surrogate}', "");
    Expect(0, 57344, '\p{Category=surrogate}', "");
    Expect(1, 57344, '\p{^Category=surrogate}', "");
    Expect(1, 57344, '\P{Category=surrogate}', "");
    Expect(0, 57344, '\P{^Category=surrogate}', "");
    Expect(1, 57343, '\p{Category=:\Asurrogate\z:}', "");;
    Expect(0, 57344, '\p{Category=:\Asurrogate\z:}', "");;
    Expect(1, 57343, '\p{Category=		Surrogate}', "");
    Expect(0, 57343, '\p{^Category=		Surrogate}', "");
    Expect(0, 57343, '\P{Category=		Surrogate}', "");
    Expect(1, 57343, '\P{^Category=		Surrogate}', "");
    Expect(0, 57344, '\p{Category=		Surrogate}', "");
    Expect(1, 57344, '\p{^Category=		Surrogate}', "");
    Expect(1, 57344, '\P{Category=		Surrogate}', "");
    Expect(0, 57344, '\P{^Category=		Surrogate}', "");
    Error('\p{Is_General_Category= CS:=}');
    Error('\P{Is_General_Category= CS:=}');
    Expect(1, 57343, '\p{Is_General_Category=cs}', "");
    Expect(0, 57343, '\p{^Is_General_Category=cs}', "");
    Expect(0, 57343, '\P{Is_General_Category=cs}', "");
    Expect(1, 57343, '\P{^Is_General_Category=cs}', "");
    Expect(0, 57344, '\p{Is_General_Category=cs}', "");
    Expect(1, 57344, '\p{^Is_General_Category=cs}', "");
    Expect(1, 57344, '\P{Is_General_Category=cs}', "");
    Expect(0, 57344, '\P{^Is_General_Category=cs}', "");
    Expect(1, 57343, '\p{Is_General_Category=_ cs}', "");
    Expect(0, 57343, '\p{^Is_General_Category=_ cs}', "");
    Expect(0, 57343, '\P{Is_General_Category=_ cs}', "");
    Expect(1, 57343, '\P{^Is_General_Category=_ cs}', "");
    Expect(0, 57344, '\p{Is_General_Category=_ cs}', "");
    Expect(1, 57344, '\p{^Is_General_Category=_ cs}', "");
    Expect(1, 57344, '\P{Is_General_Category=_ cs}', "");
    Expect(0, 57344, '\P{^Is_General_Category=_ cs}', "");
    Error('\p{Is_Gc= :=Surrogate}');
    Error('\P{Is_Gc= :=Surrogate}');
    Expect(1, 57343, '\p{Is_Gc=surrogate}', "");
    Expect(0, 57343, '\p{^Is_Gc=surrogate}', "");
    Expect(0, 57343, '\P{Is_Gc=surrogate}', "");
    Expect(1, 57343, '\P{^Is_Gc=surrogate}', "");
    Expect(0, 57344, '\p{Is_Gc=surrogate}', "");
    Expect(1, 57344, '\p{^Is_Gc=surrogate}', "");
    Expect(1, 57344, '\P{Is_Gc=surrogate}', "");
    Expect(0, 57344, '\P{^Is_Gc=surrogate}', "");
    Expect(1, 57343, '\p{Is_Gc=--SURROGATE}', "");
    Expect(0, 57343, '\p{^Is_Gc=--SURROGATE}', "");
    Expect(0, 57343, '\P{Is_Gc=--SURROGATE}', "");
    Expect(1, 57343, '\P{^Is_Gc=--SURROGATE}', "");
    Expect(0, 57344, '\p{Is_Gc=--SURROGATE}', "");
    Expect(1, 57344, '\p{^Is_Gc=--SURROGATE}', "");
    Expect(1, 57344, '\P{Is_Gc=--SURROGATE}', "");
    Expect(0, 57344, '\P{^Is_Gc=--SURROGATE}', "");
    Error('\p{Is_Category= 	Cs/a/}');
    Error('\P{Is_Category= 	Cs/a/}');
    Expect(1, 57343, '\p{Is_Category=cs}', "");
    Expect(0, 57343, '\p{^Is_Category=cs}', "");
    Expect(0, 57343, '\P{Is_Category=cs}', "");
    Expect(1, 57343, '\P{^Is_Category=cs}', "");
    Expect(0, 57344, '\p{Is_Category=cs}', "");
    Expect(1, 57344, '\p{^Is_Category=cs}', "");
    Expect(1, 57344, '\P{Is_Category=cs}', "");
    Expect(0, 57344, '\P{^Is_Category=cs}', "");
    Expect(1, 57343, '\p{Is_Category= _CS}', "");
    Expect(0, 57343, '\p{^Is_Category= _CS}', "");
    Expect(0, 57343, '\P{Is_Category= _CS}', "");
    Expect(1, 57343, '\P{^Is_Category= _CS}', "");
    Expect(0, 57344, '\p{Is_Category= _CS}', "");
    Expect(1, 57344, '\p{^Is_Category= _CS}', "");
    Expect(1, 57344, '\P{Is_Category= _CS}', "");
    Expect(0, 57344, '\P{^Is_Category= _CS}', "");
    Error('\p{General_Category=:=-LETTER}');
    Error('\P{General_Category=:=-LETTER}');
    Expect(1, 201546, '\p{General_Category=:\ALetter\z:}', "");;
    Expect(0, 201547, '\p{General_Category=:\ALetter\z:}', "");;
    Expect(1, 201546, '\p{General_Category=letter}', "");
    Expect(0, 201546, '\p{^General_Category=letter}', "");
    Expect(0, 201546, '\P{General_Category=letter}', "");
    Expect(1, 201546, '\P{^General_Category=letter}', "");
    Expect(0, 201547, '\p{General_Category=letter}', "");
    Expect(1, 201547, '\p{^General_Category=letter}', "");
    Expect(1, 201547, '\P{General_Category=letter}', "");
    Expect(0, 201547, '\P{^General_Category=letter}', "");
    Expect(1, 201546, '\p{General_Category=:\Aletter\z:}', "");;
    Expect(0, 201547, '\p{General_Category=:\Aletter\z:}', "");;
    Expect(1, 201546, '\p{General_Category=-_letter}', "");
    Expect(0, 201546, '\p{^General_Category=-_letter}', "");
    Expect(0, 201546, '\P{General_Category=-_letter}', "");
    Expect(1, 201546, '\P{^General_Category=-_letter}', "");
    Expect(0, 201547, '\p{General_Category=-_letter}', "");
    Expect(1, 201547, '\p{^General_Category=-_letter}', "");
    Expect(1, 201547, '\P{General_Category=-_letter}', "");
    Expect(0, 201547, '\P{^General_Category=-_letter}', "");
    Error('\p{Gc=/a/--l}');
    Error('\P{Gc=/a/--l}');
    Expect(1, 201546, '\p{Gc=:\AL\z:}', "");;
    Expect(0, 201547, '\p{Gc=:\AL\z:}', "");;
    Expect(1, 201546, '\p{Gc=l}', "");
    Expect(0, 201546, '\p{^Gc=l}', "");
    Expect(0, 201546, '\P{Gc=l}', "");
    Expect(1, 201546, '\P{^Gc=l}', "");
    Expect(0, 201547, '\p{Gc=l}', "");
    Expect(1, 201547, '\p{^Gc=l}', "");
    Expect(1, 201547, '\P{Gc=l}', "");
    Expect(0, 201547, '\P{^Gc=l}', "");
    Expect(1, 201546, '\p{Gc=:\Al\z:}', "");;
    Expect(0, 201547, '\p{Gc=:\Al\z:}', "");;
    Expect(1, 201546, '\p{Gc=--L}', "");
    Expect(0, 201546, '\p{^Gc=--L}', "");
    Expect(0, 201546, '\P{Gc=--L}', "");
    Expect(1, 201546, '\P{^Gc=--L}', "");
    Expect(0, 201547, '\p{Gc=--L}', "");
    Expect(1, 201547, '\p{^Gc=--L}', "");
    Expect(1, 201547, '\P{Gc=--L}', "");
    Expect(0, 201547, '\P{^Gc=--L}', "");
    Error('\p{Category=:=_-Letter}');
    Error('\P{Category=:=_-Letter}');
    Expect(1, 201546, '\p{Category=:\ALetter\z:}', "");;
    Expect(0, 201547, '\p{Category=:\ALetter\z:}', "");;
    Expect(1, 201546, '\p{Category=letter}', "");
    Expect(0, 201546, '\p{^Category=letter}', "");
    Expect(0, 201546, '\P{Category=letter}', "");
    Expect(1, 201546, '\P{^Category=letter}', "");
    Expect(0, 201547, '\p{Category=letter}', "");
    Expect(1, 201547, '\p{^Category=letter}', "");
    Expect(1, 201547, '\P{Category=letter}', "");
    Expect(0, 201547, '\P{^Category=letter}', "");
    Expect(1, 201546, '\p{Category=:\Aletter\z:}', "");;
    Expect(0, 201547, '\p{Category=:\Aletter\z:}', "");;
    Expect(1, 201546, '\p{Category=-Letter}', "");
    Expect(0, 201546, '\p{^Category=-Letter}', "");
    Expect(0, 201546, '\P{Category=-Letter}', "");
    Expect(1, 201546, '\P{^Category=-Letter}', "");
    Expect(0, 201547, '\p{Category=-Letter}', "");
    Expect(1, 201547, '\p{^Category=-Letter}', "");
    Expect(1, 201547, '\P{Category=-Letter}', "");
    Expect(0, 201547, '\P{^Category=-Letter}', "");
    Error('\p{Is_General_Category:	L:=}');
    Error('\P{Is_General_Category:	L:=}');
    Expect(1, 201546, '\p{Is_General_Category=l}', "");
    Expect(0, 201546, '\p{^Is_General_Category=l}', "");
    Expect(0, 201546, '\P{Is_General_Category=l}', "");
    Expect(1, 201546, '\P{^Is_General_Category=l}', "");
    Expect(0, 201547, '\p{Is_General_Category=l}', "");
    Expect(1, 201547, '\p{^Is_General_Category=l}', "");
    Expect(1, 201547, '\P{Is_General_Category=l}', "");
    Expect(0, 201547, '\P{^Is_General_Category=l}', "");
    Expect(1, 201546, '\p{Is_General_Category=--l}', "");
    Expect(0, 201546, '\p{^Is_General_Category=--l}', "");
    Expect(0, 201546, '\P{Is_General_Category=--l}', "");
    Expect(1, 201546, '\P{^Is_General_Category=--l}', "");
    Expect(0, 201547, '\p{Is_General_Category=--l}', "");
    Expect(1, 201547, '\p{^Is_General_Category=--l}', "");
    Expect(1, 201547, '\P{Is_General_Category=--l}', "");
    Expect(0, 201547, '\P{^Is_General_Category=--l}', "");
    Error('\p{Is_Gc=	 Letter/a/}');
    Error('\P{Is_Gc=	 Letter/a/}');
    Expect(1, 201546, '\p{Is_Gc=letter}', "");
    Expect(0, 201546, '\p{^Is_Gc=letter}', "");
    Expect(0, 201546, '\P{Is_Gc=letter}', "");
    Expect(1, 201546, '\P{^Is_Gc=letter}', "");
    Expect(0, 201547, '\p{Is_Gc=letter}', "");
    Expect(1, 201547, '\p{^Is_Gc=letter}', "");
    Expect(1, 201547, '\P{Is_Gc=letter}', "");
    Expect(0, 201547, '\P{^Is_Gc=letter}', "");
    Expect(1, 201546, '\p{Is_Gc=_	LETTER}', "");
    Expect(0, 201546, '\p{^Is_Gc=_	LETTER}', "");
    Expect(0, 201546, '\P{Is_Gc=_	LETTER}', "");
    Expect(1, 201546, '\P{^Is_Gc=_	LETTER}', "");
    Expect(0, 201547, '\p{Is_Gc=_	LETTER}', "");
    Expect(1, 201547, '\p{^Is_Gc=_	LETTER}', "");
    Expect(1, 201547, '\P{Is_Gc=_	LETTER}', "");
    Expect(0, 201547, '\P{^Is_Gc=_	LETTER}', "");
    Error('\p{Is_Category= 	L/a/}');
    Error('\P{Is_Category= 	L/a/}');
    Expect(1, 201546, '\p{Is_Category=l}', "");
    Expect(0, 201546, '\p{^Is_Category=l}', "");
    Expect(0, 201546, '\P{Is_Category=l}', "");
    Expect(1, 201546, '\P{^Is_Category=l}', "");
    Expect(0, 201547, '\p{Is_Category=l}', "");
    Expect(1, 201547, '\p{^Is_Category=l}', "");
    Expect(1, 201547, '\P{Is_Category=l}', "");
    Expect(0, 201547, '\P{^Is_Category=l}', "");
    Expect(1, 201546, '\p{Is_Category=-	L}', "");
    Expect(0, 201546, '\p{^Is_Category=-	L}', "");
    Expect(0, 201546, '\P{Is_Category=-	L}', "");
    Expect(1, 201546, '\P{^Is_Category=-	L}', "");
    Expect(0, 201547, '\p{Is_Category=-	L}', "");
    Expect(1, 201547, '\p{^Is_Category=-	L}', "");
    Expect(1, 201547, '\P{Is_Category=-	L}', "");
    Expect(0, 201547, '\P{^Is_Category=-	L}', "");
    Error('\p{General_Category=:=_ Cased_Letter}');
    Error('\P{General_Category=:=_ Cased_Letter}');
    Expect(1, 125251, '\p{General_Category=:\ACased_Letter\z:}', "");;
    Expect(0, 125252, '\p{General_Category=:\ACased_Letter\z:}', "");;
    Expect(1, 125251, '\p{General_Category=casedletter}', "");
    Expect(0, 125251, '\p{^General_Category=casedletter}', "");
    Expect(0, 125251, '\P{General_Category=casedletter}', "");
    Expect(1, 125251, '\P{^General_Category=casedletter}', "");
    Expect(0, 125252, '\p{General_Category=casedletter}', "");
    Expect(1, 125252, '\p{^General_Category=casedletter}', "");
    Expect(1, 125252, '\P{General_Category=casedletter}', "");
    Expect(0, 125252, '\P{^General_Category=casedletter}', "");
    Expect(1, 125251, '\p{General_Category=:\Acasedletter\z:}', "");;
    Expect(0, 125252, '\p{General_Category=:\Acasedletter\z:}', "");;
    Expect(1, 125251, '\p{General_Category=_ Cased_LETTER}', "");
    Expect(0, 125251, '\p{^General_Category=_ Cased_LETTER}', "");
    Expect(0, 125251, '\P{General_Category=_ Cased_LETTER}', "");
    Expect(1, 125251, '\P{^General_Category=_ Cased_LETTER}', "");
    Expect(0, 125252, '\p{General_Category=_ Cased_LETTER}', "");
    Expect(1, 125252, '\p{^General_Category=_ Cased_LETTER}', "");
    Expect(1, 125252, '\P{General_Category=_ Cased_LETTER}', "");
    Expect(0, 125252, '\P{^General_Category=_ Cased_LETTER}', "");
    Error('\p{Gc=:=--lc}');
    Error('\P{Gc=:=--lc}');
    Expect(1, 125251, '\p{Gc=:\ALC\z:}', "");;
    Expect(0, 125252, '\p{Gc=:\ALC\z:}', "");;
    Expect(1, 125251, '\p{Gc=lc}', "");
    Expect(0, 125251, '\p{^Gc=lc}', "");
    Expect(0, 125251, '\P{Gc=lc}', "");
    Expect(1, 125251, '\P{^Gc=lc}', "");
    Expect(0, 125252, '\p{Gc=lc}', "");
    Expect(1, 125252, '\p{^Gc=lc}', "");
    Expect(1, 125252, '\P{Gc=lc}', "");
    Expect(0, 125252, '\P{^Gc=lc}', "");
    Expect(1, 125251, '\p{Gc=:\Alc\z:}', "");;
    Expect(0, 125252, '\p{Gc=:\Alc\z:}', "");;
    Expect(1, 125251, '\p{Gc=	 lc}', "");
    Expect(0, 125251, '\p{^Gc=	 lc}', "");
    Expect(0, 125251, '\P{Gc=	 lc}', "");
    Expect(1, 125251, '\P{^Gc=	 lc}', "");
    Expect(0, 125252, '\p{Gc=	 lc}', "");
    Expect(1, 125252, '\p{^Gc=	 lc}', "");
    Expect(1, 125252, '\P{Gc=	 lc}', "");
    Expect(0, 125252, '\P{^Gc=	 lc}', "");
    Error('\p{Category= :=L_}');
    Error('\P{Category= :=L_}');
    Expect(1, 125251, '\p{Category=l_}', "");
    Expect(0, 125251, '\p{^Category=l_}', "");
    Expect(0, 125251, '\P{Category=l_}', "");
    Expect(1, 125251, '\P{^Category=l_}', "");
    Expect(0, 125252, '\p{Category=l_}', "");
    Expect(1, 125252, '\p{^Category=l_}', "");
    Expect(1, 125252, '\P{Category=l_}', "");
    Expect(0, 125252, '\P{^Category=l_}', "");
    Expect(1, 125251, '\p{Category=_l_}', "");
    Expect(0, 125251, '\p{^Category=_l_}', "");
    Expect(0, 125251, '\P{Category=_l_}', "");
    Expect(1, 125251, '\P{^Category=_l_}', "");
    Expect(0, 125252, '\p{Category=_l_}', "");
    Expect(1, 125252, '\p{^Category=_l_}', "");
    Expect(1, 125252, '\P{Category=_l_}', "");
    Expect(0, 125252, '\P{^Category=_l_}', "");
    Error('\p{Is_General_Category=_-L&:=}');
    Error('\P{Is_General_Category=_-L&:=}');
    Expect(1, 125251, '\p{Is_General_Category=l&}', "");
    Expect(0, 125251, '\p{^Is_General_Category=l&}', "");
    Expect(0, 125251, '\P{Is_General_Category=l&}', "");
    Expect(1, 125251, '\P{^Is_General_Category=l&}', "");
    Expect(0, 125252, '\p{Is_General_Category=l&}', "");
    Expect(1, 125252, '\p{^Is_General_Category=l&}', "");
    Expect(1, 125252, '\P{Is_General_Category=l&}', "");
    Expect(0, 125252, '\P{^Is_General_Category=l&}', "");
    Expect(1, 125251, '\p{Is_General_Category=	L&}', "");
    Expect(0, 125251, '\p{^Is_General_Category=	L&}', "");
    Expect(0, 125251, '\P{Is_General_Category=	L&}', "");
    Expect(1, 125251, '\P{^Is_General_Category=	L&}', "");
    Expect(0, 125252, '\p{Is_General_Category=	L&}', "");
    Expect(1, 125252, '\p{^Is_General_Category=	L&}', "");
    Expect(1, 125252, '\P{Is_General_Category=	L&}', "");
    Expect(0, 125252, '\P{^Is_General_Category=	L&}', "");
    Error('\p{Is_Gc:	/a/  Cased_Letter}');
    Error('\P{Is_Gc:	/a/  Cased_Letter}');
    Expect(1, 125251, '\p{Is_Gc=casedletter}', "");
    Expect(0, 125251, '\p{^Is_Gc=casedletter}', "");
    Expect(0, 125251, '\P{Is_Gc=casedletter}', "");
    Expect(1, 125251, '\P{^Is_Gc=casedletter}', "");
    Expect(0, 125252, '\p{Is_Gc=casedletter}', "");
    Expect(1, 125252, '\p{^Is_Gc=casedletter}', "");
    Expect(1, 125252, '\P{Is_Gc=casedletter}', "");
    Expect(0, 125252, '\P{^Is_Gc=casedletter}', "");
    Expect(1, 125251, '\p{Is_Gc: 	-cased_letter}', "");
    Expect(0, 125251, '\p{^Is_Gc: 	-cased_letter}', "");
    Expect(0, 125251, '\P{Is_Gc: 	-cased_letter}', "");
    Expect(1, 125251, '\P{^Is_Gc: 	-cased_letter}', "");
    Expect(0, 125252, '\p{Is_Gc: 	-cased_letter}', "");
    Expect(1, 125252, '\p{^Is_Gc: 	-cased_letter}', "");
    Expect(1, 125252, '\P{Is_Gc: 	-cased_letter}', "");
    Expect(0, 125252, '\P{^Is_Gc: 	-cased_letter}', "");
    Error('\p{Is_Category=/a/lc}');
    Error('\P{Is_Category=/a/lc}');
    Expect(1, 125251, '\p{Is_Category=lc}', "");
    Expect(0, 125251, '\p{^Is_Category=lc}', "");
    Expect(0, 125251, '\P{Is_Category=lc}', "");
    Expect(1, 125251, '\P{^Is_Category=lc}', "");
    Expect(0, 125252, '\p{Is_Category=lc}', "");
    Expect(1, 125252, '\p{^Is_Category=lc}', "");
    Expect(1, 125252, '\P{Is_Category=lc}', "");
    Expect(0, 125252, '\P{^Is_Category=lc}', "");
    Expect(1, 125251, '\p{Is_Category:		 LC}', "");
    Expect(0, 125251, '\p{^Is_Category:		 LC}', "");
    Expect(0, 125251, '\P{Is_Category:		 LC}', "");
    Expect(1, 125251, '\P{^Is_Category:		 LC}', "");
    Expect(0, 125252, '\p{Is_Category:		 LC}', "");
    Expect(1, 125252, '\p{^Is_Category:		 LC}', "");
    Expect(1, 125252, '\P{Is_Category:		 LC}', "");
    Expect(0, 125252, '\P{^Is_Category:		 LC}', "");
    Error('\p{General_Category=_:=lowercase_letter}');
    Error('\P{General_Category=_:=lowercase_letter}');
    Expect(1, 125251, '\p{General_Category=:\ALowercase_Letter\z:}', "");;
    Expect(0, 125252, '\p{General_Category=:\ALowercase_Letter\z:}', "");;
    Expect(1, 125251, '\p{General_Category=lowercaseletter}', "");
    Expect(0, 125251, '\p{^General_Category=lowercaseletter}', "");
    Expect(0, 125251, '\P{General_Category=lowercaseletter}', "");
    Expect(1, 125251, '\P{^General_Category=lowercaseletter}', "");
    Expect(0, 125252, '\p{General_Category=lowercaseletter}', "");
    Expect(1, 125252, '\p{^General_Category=lowercaseletter}', "");
    Expect(1, 125252, '\P{General_Category=lowercaseletter}', "");
    Expect(0, 125252, '\P{^General_Category=lowercaseletter}', "");
    Expect(1, 125251, '\p{General_Category=:\Alowercaseletter\z:}', "");;
    Expect(0, 125252, '\p{General_Category=:\Alowercaseletter\z:}', "");;
    Expect(1, 125251, '\p{General_Category=__Lowercase_Letter}', "");
    Expect(0, 125251, '\p{^General_Category=__Lowercase_Letter}', "");
    Expect(0, 125251, '\P{General_Category=__Lowercase_Letter}', "");
    Expect(1, 125251, '\P{^General_Category=__Lowercase_Letter}', "");
    Expect(0, 125252, '\p{General_Category=__Lowercase_Letter}', "");
    Expect(1, 125252, '\p{^General_Category=__Lowercase_Letter}', "");
    Expect(1, 125252, '\P{General_Category=__Lowercase_Letter}', "");
    Expect(0, 125252, '\P{^General_Category=__Lowercase_Letter}', "");
    Error('\p{Gc=:=__LL}');
    Error('\P{Gc=:=__LL}');
    Expect(1, 125251, '\p{Gc=:\ALl\z:}', "");;
    Expect(0, 125252, '\p{Gc=:\ALl\z:}', "");;
    Expect(1, 125251, '\p{Gc=ll}', "");
    Expect(0, 125251, '\p{^Gc=ll}', "");
    Expect(0, 125251, '\P{Gc=ll}', "");
    Expect(1, 125251, '\P{^Gc=ll}', "");
    Expect(0, 125252, '\p{Gc=ll}', "");
    Expect(1, 125252, '\p{^Gc=ll}', "");
    Expect(1, 125252, '\P{Gc=ll}', "");
    Expect(0, 125252, '\P{^Gc=ll}', "");
    Expect(1, 125251, '\p{Gc=:\All\z:}', "");;
    Expect(0, 125252, '\p{Gc=:\All\z:}', "");;
    Expect(1, 125251, '\p{Gc=Ll}', "");
    Expect(0, 125251, '\p{^Gc=Ll}', "");
    Expect(0, 125251, '\P{Gc=Ll}', "");
    Expect(1, 125251, '\P{^Gc=Ll}', "");
    Expect(0, 125252, '\p{Gc=Ll}', "");
    Expect(1, 125252, '\p{^Gc=Ll}', "");
    Expect(1, 125252, '\P{Gc=Ll}', "");
    Expect(0, 125252, '\P{^Gc=Ll}', "");
    Error('\p{Category=-:=Lowercase_LETTER}');
    Error('\P{Category=-:=Lowercase_LETTER}');
    Expect(1, 125251, '\p{Category=:\ALowercase_Letter\z:}', "");;
    Expect(0, 125252, '\p{Category=:\ALowercase_Letter\z:}', "");;
    Expect(1, 125251, '\p{Category=lowercaseletter}', "");
    Expect(0, 125251, '\p{^Category=lowercaseletter}', "");
    Expect(0, 125251, '\P{Category=lowercaseletter}', "");
    Expect(1, 125251, '\P{^Category=lowercaseletter}', "");
    Expect(0, 125252, '\p{Category=lowercaseletter}', "");
    Expect(1, 125252, '\p{^Category=lowercaseletter}', "");
    Expect(1, 125252, '\P{Category=lowercaseletter}', "");
    Expect(0, 125252, '\P{^Category=lowercaseletter}', "");
    Expect(1, 125251, '\p{Category=:\Alowercaseletter\z:}', "");;
    Expect(0, 125252, '\p{Category=:\Alowercaseletter\z:}', "");;
    Expect(1, 125251, '\p{Category=_	lowercase_Letter}', "");
    Expect(0, 125251, '\p{^Category=_	lowercase_Letter}', "");
    Expect(0, 125251, '\P{Category=_	lowercase_Letter}', "");
    Expect(1, 125251, '\P{^Category=_	lowercase_Letter}', "");
    Expect(0, 125252, '\p{Category=_	lowercase_Letter}', "");
    Expect(1, 125252, '\p{^Category=_	lowercase_Letter}', "");
    Expect(1, 125252, '\P{Category=_	lowercase_Letter}', "");
    Expect(0, 125252, '\P{^Category=_	lowercase_Letter}', "");
    Error('\p{Is_General_Category=:=- ll}');
    Error('\P{Is_General_Category=:=- ll}');
    Expect(1, 125251, '\p{Is_General_Category=ll}', "");
    Expect(0, 125251, '\p{^Is_General_Category=ll}', "");
    Expect(0, 125251, '\P{Is_General_Category=ll}', "");
    Expect(1, 125251, '\P{^Is_General_Category=ll}', "");
    Expect(0, 125252, '\p{Is_General_Category=ll}', "");
    Expect(1, 125252, '\p{^Is_General_Category=ll}', "");
    Expect(1, 125252, '\P{Is_General_Category=ll}', "");
    Expect(0, 125252, '\P{^Is_General_Category=ll}', "");
    Expect(1, 125251, '\p{Is_General_Category=_	Ll}', "");
    Expect(0, 125251, '\p{^Is_General_Category=_	Ll}', "");
    Expect(0, 125251, '\P{Is_General_Category=_	Ll}', "");
    Expect(1, 125251, '\P{^Is_General_Category=_	Ll}', "");
    Expect(0, 125252, '\p{Is_General_Category=_	Ll}', "");
    Expect(1, 125252, '\p{^Is_General_Category=_	Ll}', "");
    Expect(1, 125252, '\P{Is_General_Category=_	Ll}', "");
    Expect(0, 125252, '\P{^Is_General_Category=_	Ll}', "");
    Error('\p{Is_Gc=  LOWERCASE_LETTER:=}');
    Error('\P{Is_Gc=  LOWERCASE_LETTER:=}');
    Expect(1, 125251, '\p{Is_Gc=lowercaseletter}', "");
    Expect(0, 125251, '\p{^Is_Gc=lowercaseletter}', "");
    Expect(0, 125251, '\P{Is_Gc=lowercaseletter}', "");
    Expect(1, 125251, '\P{^Is_Gc=lowercaseletter}', "");
    Expect(0, 125252, '\p{Is_Gc=lowercaseletter}', "");
    Expect(1, 125252, '\p{^Is_Gc=lowercaseletter}', "");
    Expect(1, 125252, '\P{Is_Gc=lowercaseletter}', "");
    Expect(0, 125252, '\P{^Is_Gc=lowercaseletter}', "");
    Expect(1, 125251, '\p{Is_Gc=--Lowercase_LETTER}', "");
    Expect(0, 125251, '\p{^Is_Gc=--Lowercase_LETTER}', "");
    Expect(0, 125251, '\P{Is_Gc=--Lowercase_LETTER}', "");
    Expect(1, 125251, '\P{^Is_Gc=--Lowercase_LETTER}', "");
    Expect(0, 125252, '\p{Is_Gc=--Lowercase_LETTER}', "");
    Expect(1, 125252, '\p{^Is_Gc=--Lowercase_LETTER}', "");
    Expect(1, 125252, '\P{Is_Gc=--Lowercase_LETTER}', "");
    Expect(0, 125252, '\P{^Is_Gc=--Lowercase_LETTER}', "");
    Error('\p{Is_Category= :=Ll}');
    Error('\P{Is_Category= :=Ll}');
    Expect(1, 125251, '\p{Is_Category=ll}', "");
    Expect(0, 125251, '\p{^Is_Category=ll}', "");
    Expect(0, 125251, '\P{Is_Category=ll}', "");
    Expect(1, 125251, '\P{^Is_Category=ll}', "");
    Expect(0, 125252, '\p{Is_Category=ll}', "");
    Expect(1, 125252, '\p{^Is_Category=ll}', "");
    Expect(1, 125252, '\P{Is_Category=ll}', "");
    Expect(0, 125252, '\P{^Is_Category=ll}', "");
    Expect(1, 125251, '\p{Is_Category:   _-Ll}', "");
    Expect(0, 125251, '\p{^Is_Category:   _-Ll}', "");
    Expect(0, 125251, '\P{Is_Category:   _-Ll}', "");
    Expect(1, 125251, '\P{^Is_Category:   _-Ll}', "");
    Expect(0, 125252, '\p{Is_Category:   _-Ll}', "");
    Expect(1, 125252, '\p{^Is_Category:   _-Ll}', "");
    Expect(1, 125252, '\P{Is_Category:   _-Ll}', "");
    Expect(0, 125252, '\P{^Is_Category:   _-Ll}', "");
    Error('\p{General_Category=/a/__modifier_Letter}');
    Error('\P{General_Category=/a/__modifier_Letter}');
    Expect(1, 125259, '\p{General_Category=:\AModifier_Letter\z:}', "");;
    Expect(0, 125260, '\p{General_Category=:\AModifier_Letter\z:}', "");;
    Expect(1, 125259, '\p{General_Category=modifierletter}', "");
    Expect(0, 125259, '\p{^General_Category=modifierletter}', "");
    Expect(0, 125259, '\P{General_Category=modifierletter}', "");
    Expect(1, 125259, '\P{^General_Category=modifierletter}', "");
    Expect(0, 125260, '\p{General_Category=modifierletter}', "");
    Expect(1, 125260, '\p{^General_Category=modifierletter}', "");
    Expect(1, 125260, '\P{General_Category=modifierletter}', "");
    Expect(0, 125260, '\P{^General_Category=modifierletter}', "");
    Expect(1, 125259, '\p{General_Category=:\Amodifierletter\z:}', "");;
    Expect(0, 125260, '\p{General_Category=:\Amodifierletter\z:}', "");;
    Expect(1, 125259, '\p{General_Category=		MODIFIER_Letter}', "");
    Expect(0, 125259, '\p{^General_Category=		MODIFIER_Letter}', "");
    Expect(0, 125259, '\P{General_Category=		MODIFIER_Letter}', "");
    Expect(1, 125259, '\P{^General_Category=		MODIFIER_Letter}', "");
    Expect(0, 125260, '\p{General_Category=		MODIFIER_Letter}', "");
    Expect(1, 125260, '\p{^General_Category=		MODIFIER_Letter}', "");
    Expect(1, 125260, '\P{General_Category=		MODIFIER_Letter}', "");
    Expect(0, 125260, '\P{^General_Category=		MODIFIER_Letter}', "");
    Error('\p{Gc=/a/	 LM}');
    Error('\P{Gc=/a/	 LM}');
    Expect(1, 125259, '\p{Gc=:\ALm\z:}', "");;
    Expect(0, 125260, '\p{Gc=:\ALm\z:}', "");;
    Expect(1, 125259, '\p{Gc: lm}', "");
    Expect(0, 125259, '\p{^Gc: lm}', "");
    Expect(0, 125259, '\P{Gc: lm}', "");
    Expect(1, 125259, '\P{^Gc: lm}', "");
    Expect(0, 125260, '\p{Gc: lm}', "");
    Expect(1, 125260, '\p{^Gc: lm}', "");
    Expect(1, 125260, '\P{Gc: lm}', "");
    Expect(0, 125260, '\P{^Gc: lm}', "");
    Expect(1, 125259, '\p{Gc=:\Alm\z:}', "");;
    Expect(0, 125260, '\p{Gc=:\Alm\z:}', "");;
    Expect(1, 125259, '\p{Gc= LM}', "");
    Expect(0, 125259, '\p{^Gc= LM}', "");
    Expect(0, 125259, '\P{Gc= LM}', "");
    Expect(1, 125259, '\P{^Gc= LM}', "");
    Expect(0, 125260, '\p{Gc= LM}', "");
    Expect(1, 125260, '\p{^Gc= LM}', "");
    Expect(1, 125260, '\P{Gc= LM}', "");
    Expect(0, 125260, '\P{^Gc= LM}', "");
    Error('\p{Category=__Modifier_letter:=}');
    Error('\P{Category=__Modifier_letter:=}');
    Expect(1, 125259, '\p{Category=:\AModifier_Letter\z:}', "");;
    Expect(0, 125260, '\p{Category=:\AModifier_Letter\z:}', "");;
    Expect(1, 125259, '\p{Category=modifierletter}', "");
    Expect(0, 125259, '\p{^Category=modifierletter}', "");
    Expect(0, 125259, '\P{Category=modifierletter}', "");
    Expect(1, 125259, '\P{^Category=modifierletter}', "");
    Expect(0, 125260, '\p{Category=modifierletter}', "");
    Expect(1, 125260, '\p{^Category=modifierletter}', "");
    Expect(1, 125260, '\P{Category=modifierletter}', "");
    Expect(0, 125260, '\P{^Category=modifierletter}', "");
    Expect(1, 125259, '\p{Category=:\Amodifierletter\z:}', "");;
    Expect(0, 125260, '\p{Category=:\Amodifierletter\z:}', "");;
    Expect(1, 125259, '\p{Category=_	MODIFIER_LETTER}', "");
    Expect(0, 125259, '\p{^Category=_	MODIFIER_LETTER}', "");
    Expect(0, 125259, '\P{Category=_	MODIFIER_LETTER}', "");
    Expect(1, 125259, '\P{^Category=_	MODIFIER_LETTER}', "");
    Expect(0, 125260, '\p{Category=_	MODIFIER_LETTER}', "");
    Expect(1, 125260, '\p{^Category=_	MODIFIER_LETTER}', "");
    Expect(1, 125260, '\P{Category=_	MODIFIER_LETTER}', "");
    Expect(0, 125260, '\P{^Category=_	MODIFIER_LETTER}', "");
    Error('\p{Is_General_Category= /a/Lm}');
    Error('\P{Is_General_Category= /a/Lm}');
    Expect(1, 125259, '\p{Is_General_Category=lm}', "");
    Expect(0, 125259, '\p{^Is_General_Category=lm}', "");
}
if (!$::TESTCHUNK or $::TESTCHUNK == 2) {
    Expect(0, 125259, '\P{Is_General_Category=lm}', "");
    Expect(1, 125259, '\P{^Is_General_Category=lm}', "");
    Expect(0, 125260, '\p{Is_General_Category=lm}', "");
    Expect(1, 125260, '\p{^Is_General_Category=lm}', "");
    Expect(1, 125260, '\P{Is_General_Category=lm}', "");
    Expect(0, 125260, '\P{^Is_General_Category=lm}', "");
    Expect(1, 125259, '\p{Is_General_Category=	_LM}', "");
    Expect(0, 125259, '\p{^Is_General_Category=	_LM}', "");
    Expect(0, 125259, '\P{Is_General_Category=	_LM}', "");
    Expect(1, 125259, '\P{^Is_General_Category=	_LM}', "");
    Expect(0, 125260, '\p{Is_General_Category=	_LM}', "");
    Expect(1, 125260, '\p{^Is_General_Category=	_LM}', "");
    Expect(1, 125260, '\P{Is_General_Category=	_LM}', "");
    Expect(0, 125260, '\P{^Is_General_Category=	_LM}', "");
    Error('\p{Is_Gc:	_ MODIFIER_letter/a/}');
    Error('\P{Is_Gc:	_ MODIFIER_letter/a/}');
    Expect(1, 125259, '\p{Is_Gc=modifierletter}', "");
    Expect(0, 125259, '\p{^Is_Gc=modifierletter}', "");
    Expect(0, 125259, '\P{Is_Gc=modifierletter}', "");
    Expect(1, 125259, '\P{^Is_Gc=modifierletter}', "");
    Expect(0, 125260, '\p{Is_Gc=modifierletter}', "");
    Expect(1, 125260, '\p{^Is_Gc=modifierletter}', "");
    Expect(1, 125260, '\P{Is_Gc=modifierletter}', "");
    Expect(0, 125260, '\P{^Is_Gc=modifierletter}', "");
    Expect(1, 125259, '\p{Is_Gc=-_Modifier_letter}', "");
    Expect(0, 125259, '\p{^Is_Gc=-_Modifier_letter}', "");
    Expect(0, 125259, '\P{Is_Gc=-_Modifier_letter}', "");
    Expect(1, 125259, '\P{^Is_Gc=-_Modifier_letter}', "");
    Expect(0, 125260, '\p{Is_Gc=-_Modifier_letter}', "");
    Expect(1, 125260, '\p{^Is_Gc=-_Modifier_letter}', "");
    Expect(1, 125260, '\P{Is_Gc=-_Modifier_letter}', "");
    Expect(0, 125260, '\P{^Is_Gc=-_Modifier_letter}', "");
    Error('\p{Is_Category=/a/ Lm}');
    Error('\P{Is_Category=/a/ Lm}');
    Expect(1, 125259, '\p{Is_Category=lm}', "");
    Expect(0, 125259, '\p{^Is_Category=lm}', "");
    Expect(0, 125259, '\P{Is_Category=lm}', "");
    Expect(1, 125259, '\P{^Is_Category=lm}', "");
    Expect(0, 125260, '\p{Is_Category=lm}', "");
    Expect(1, 125260, '\p{^Is_Category=lm}', "");
    Expect(1, 125260, '\P{Is_Category=lm}', "");
    Expect(0, 125260, '\P{^Is_Category=lm}', "");
    Expect(1, 125259, '\p{Is_Category=_ Lm}', "");
    Expect(0, 125259, '\p{^Is_Category=_ Lm}', "");
    Expect(0, 125259, '\P{Is_Category=_ Lm}', "");
    Expect(1, 125259, '\P{^Is_Category=_ Lm}', "");
    Expect(0, 125260, '\p{Is_Category=_ Lm}', "");
    Expect(1, 125260, '\p{^Is_Category=_ Lm}', "");
    Expect(1, 125260, '\P{Is_Category=_ Lm}', "");
    Expect(0, 125260, '\P{^Is_Category=_ Lm}', "");
    Error('\p{General_Category=_	other_letter:=}');
    Error('\P{General_Category=_	other_letter:=}');
    Expect(1, 201546, '\p{General_Category=:\AOther_Letter\z:}', "");;
    Expect(0, 201547, '\p{General_Category=:\AOther_Letter\z:}', "");;
    Expect(1, 201546, '\p{General_Category=otherletter}', "");
    Expect(0, 201546, '\p{^General_Category=otherletter}', "");
    Expect(0, 201546, '\P{General_Category=otherletter}', "");
    Expect(1, 201546, '\P{^General_Category=otherletter}', "");
    Expect(0, 201547, '\p{General_Category=otherletter}', "");
    Expect(1, 201547, '\p{^General_Category=otherletter}', "");
    Expect(1, 201547, '\P{General_Category=otherletter}', "");
    Expect(0, 201547, '\P{^General_Category=otherletter}', "");
    Expect(1, 201546, '\p{General_Category=:\Aotherletter\z:}', "");;
    Expect(0, 201547, '\p{General_Category=:\Aotherletter\z:}', "");;
    Expect(1, 201546, '\p{General_Category=-_Other_letter}', "");
    Expect(0, 201546, '\p{^General_Category=-_Other_letter}', "");
    Expect(0, 201546, '\P{General_Category=-_Other_letter}', "");
    Expect(1, 201546, '\P{^General_Category=-_Other_letter}', "");
    Expect(0, 201547, '\p{General_Category=-_Other_letter}', "");
    Expect(1, 201547, '\p{^General_Category=-_Other_letter}', "");
    Expect(1, 201547, '\P{General_Category=-_Other_letter}', "");
    Expect(0, 201547, '\P{^General_Category=-_Other_letter}', "");
    Error('\p{Gc=	:=LO}');
    Error('\P{Gc=	:=LO}');
    Expect(1, 201546, '\p{Gc=:\ALo\z:}', "");;
    Expect(0, 201547, '\p{Gc=:\ALo\z:}', "");;
    Expect(1, 201546, '\p{Gc=lo}', "");
    Expect(0, 201546, '\p{^Gc=lo}', "");
    Expect(0, 201546, '\P{Gc=lo}', "");
    Expect(1, 201546, '\P{^Gc=lo}', "");
    Expect(0, 201547, '\p{Gc=lo}', "");
    Expect(1, 201547, '\p{^Gc=lo}', "");
    Expect(1, 201547, '\P{Gc=lo}', "");
    Expect(0, 201547, '\P{^Gc=lo}', "");
    Expect(1, 201546, '\p{Gc=:\Alo\z:}', "");;
    Expect(0, 201547, '\p{Gc=:\Alo\z:}', "");;
    Expect(1, 201546, '\p{Gc=-Lo}', "");
    Expect(0, 201546, '\p{^Gc=-Lo}', "");
    Expect(0, 201546, '\P{Gc=-Lo}', "");
    Expect(1, 201546, '\P{^Gc=-Lo}', "");
    Expect(0, 201547, '\p{Gc=-Lo}', "");
    Expect(1, 201547, '\p{^Gc=-Lo}', "");
    Expect(1, 201547, '\P{Gc=-Lo}', "");
    Expect(0, 201547, '\P{^Gc=-Lo}', "");
    Error('\p{Category=:=_other_Letter}');
    Error('\P{Category=:=_other_Letter}');
    Expect(1, 201546, '\p{Category=:\AOther_Letter\z:}', "");;
    Expect(0, 201547, '\p{Category=:\AOther_Letter\z:}', "");;
    Expect(1, 201546, '\p{Category=otherletter}', "");
    Expect(0, 201546, '\p{^Category=otherletter}', "");
    Expect(0, 201546, '\P{Category=otherletter}', "");
    Expect(1, 201546, '\P{^Category=otherletter}', "");
    Expect(0, 201547, '\p{Category=otherletter}', "");
    Expect(1, 201547, '\p{^Category=otherletter}', "");
    Expect(1, 201547, '\P{Category=otherletter}', "");
    Expect(0, 201547, '\P{^Category=otherletter}', "");
    Expect(1, 201546, '\p{Category=:\Aotherletter\z:}', "");;
    Expect(0, 201547, '\p{Category=:\Aotherletter\z:}', "");;
    Expect(1, 201546, '\p{Category=--Other_Letter}', "");
    Expect(0, 201546, '\p{^Category=--Other_Letter}', "");
    Expect(0, 201546, '\P{Category=--Other_Letter}', "");
    Expect(1, 201546, '\P{^Category=--Other_Letter}', "");
    Expect(0, 201547, '\p{Category=--Other_Letter}', "");
    Expect(1, 201547, '\p{^Category=--Other_Letter}', "");
    Expect(1, 201547, '\P{Category=--Other_Letter}', "");
    Expect(0, 201547, '\P{^Category=--Other_Letter}', "");
    Error('\p{Is_General_Category=:=-LO}');
    Error('\P{Is_General_Category=:=-LO}');
    Expect(1, 201546, '\p{Is_General_Category=lo}', "");
    Expect(0, 201546, '\p{^Is_General_Category=lo}', "");
    Expect(0, 201546, '\P{Is_General_Category=lo}', "");
    Expect(1, 201546, '\P{^Is_General_Category=lo}', "");
    Expect(0, 201547, '\p{Is_General_Category=lo}', "");
    Expect(1, 201547, '\p{^Is_General_Category=lo}', "");
    Expect(1, 201547, '\P{Is_General_Category=lo}', "");
    Expect(0, 201547, '\P{^Is_General_Category=lo}', "");
    Expect(1, 201546, '\p{Is_General_Category=-lo}', "");
    Expect(0, 201546, '\p{^Is_General_Category=-lo}', "");
    Expect(0, 201546, '\P{Is_General_Category=-lo}', "");
    Expect(1, 201546, '\P{^Is_General_Category=-lo}', "");
    Expect(0, 201547, '\p{Is_General_Category=-lo}', "");
    Expect(1, 201547, '\p{^Is_General_Category=-lo}', "");
    Expect(1, 201547, '\P{Is_General_Category=-lo}', "");
    Expect(0, 201547, '\P{^Is_General_Category=-lo}', "");
    Error('\p{Is_Gc:   	-other_Letter/a/}');
    Error('\P{Is_Gc:   	-other_Letter/a/}');
    Expect(1, 201546, '\p{Is_Gc=otherletter}', "");
    Expect(0, 201546, '\p{^Is_Gc=otherletter}', "");
    Expect(0, 201546, '\P{Is_Gc=otherletter}', "");
    Expect(1, 201546, '\P{^Is_Gc=otherletter}', "");
    Expect(0, 201547, '\p{Is_Gc=otherletter}', "");
    Expect(1, 201547, '\p{^Is_Gc=otherletter}', "");
    Expect(1, 201547, '\P{Is_Gc=otherletter}', "");
    Expect(0, 201547, '\P{^Is_Gc=otherletter}', "");
    Expect(1, 201546, '\p{Is_Gc=_-other_Letter}', "");
    Expect(0, 201546, '\p{^Is_Gc=_-other_Letter}', "");
    Expect(0, 201546, '\P{Is_Gc=_-other_Letter}', "");
    Expect(1, 201546, '\P{^Is_Gc=_-other_Letter}', "");
    Expect(0, 201547, '\p{Is_Gc=_-other_Letter}', "");
    Expect(1, 201547, '\p{^Is_Gc=_-other_Letter}', "");
    Expect(1, 201547, '\P{Is_Gc=_-other_Letter}', "");
    Expect(0, 201547, '\P{^Is_Gc=_-other_Letter}', "");
    Error('\p{Is_Category=	:=LO}');
    Error('\P{Is_Category=	:=LO}');
    Expect(1, 201546, '\p{Is_Category=lo}', "");
    Expect(0, 201546, '\p{^Is_Category=lo}', "");
    Expect(0, 201546, '\P{Is_Category=lo}', "");
    Expect(1, 201546, '\P{^Is_Category=lo}', "");
    Expect(0, 201547, '\p{Is_Category=lo}', "");
    Expect(1, 201547, '\p{^Is_Category=lo}', "");
    Expect(1, 201547, '\P{Is_Category=lo}', "");
    Expect(0, 201547, '\P{^Is_Category=lo}', "");
    Expect(1, 201546, '\p{Is_Category=_	LO}', "");
    Expect(0, 201546, '\p{^Is_Category=_	LO}', "");
    Expect(0, 201546, '\P{Is_Category=_	LO}', "");
    Expect(1, 201546, '\P{^Is_Category=_	LO}', "");
    Expect(0, 201547, '\p{Is_Category=_	LO}', "");
    Expect(1, 201547, '\p{^Is_Category=_	LO}', "");
    Expect(1, 201547, '\P{Is_Category=_	LO}', "");
    Expect(0, 201547, '\P{^Is_Category=_	LO}', "");
    Error('\p{General_Category= /a/Titlecase_Letter}');
    Error('\P{General_Category= /a/Titlecase_Letter}');
    Expect(1, 8188, '\p{General_Category=:\ATitlecase_Letter\z:}', "");;
    Expect(0, 8189, '\p{General_Category=:\ATitlecase_Letter\z:}', "");;
    Expect(1, 8188, '\p{General_Category=titlecaseletter}', "");
    Expect(0, 8188, '\p{^General_Category=titlecaseletter}', "");
    Expect(0, 8188, '\P{General_Category=titlecaseletter}', "");
    Expect(1, 8188, '\P{^General_Category=titlecaseletter}', "");
    Expect(0, 8189, '\p{General_Category=titlecaseletter}', "");
    Expect(1, 8189, '\p{^General_Category=titlecaseletter}', "");
    Expect(1, 8189, '\P{General_Category=titlecaseletter}', "");
    Expect(0, 8189, '\P{^General_Category=titlecaseletter}', "");
    Expect(1, 8188, '\p{General_Category=:\Atitlecaseletter\z:}', "");;
    Expect(0, 8189, '\p{General_Category=:\Atitlecaseletter\z:}', "");;
    Expect(1, 8188, '\p{General_Category= Titlecase_letter}', "");
    Expect(0, 8188, '\p{^General_Category= Titlecase_letter}', "");
    Expect(0, 8188, '\P{General_Category= Titlecase_letter}', "");
    Expect(1, 8188, '\P{^General_Category= Titlecase_letter}', "");
    Expect(0, 8189, '\p{General_Category= Titlecase_letter}', "");
    Expect(1, 8189, '\p{^General_Category= Titlecase_letter}', "");
    Expect(1, 8189, '\P{General_Category= Titlecase_letter}', "");
    Expect(0, 8189, '\P{^General_Category= Titlecase_letter}', "");
    Error('\p{Gc= :=lt}');
    Error('\P{Gc= :=lt}');
    Expect(1, 8188, '\p{Gc=:\ALt\z:}', "");;
    Expect(0, 8189, '\p{Gc=:\ALt\z:}', "");;
    Expect(1, 8188, '\p{Gc=lt}', "");
    Expect(0, 8188, '\p{^Gc=lt}', "");
    Expect(0, 8188, '\P{Gc=lt}', "");
    Expect(1, 8188, '\P{^Gc=lt}', "");
    Expect(0, 8189, '\p{Gc=lt}', "");
    Expect(1, 8189, '\p{^Gc=lt}', "");
    Expect(1, 8189, '\P{Gc=lt}', "");
    Expect(0, 8189, '\P{^Gc=lt}', "");
    Expect(1, 8188, '\p{Gc=:\Alt\z:}', "");;
    Expect(0, 8189, '\p{Gc=:\Alt\z:}', "");;
    Expect(1, 8188, '\p{Gc=- lt}', "");
    Expect(0, 8188, '\p{^Gc=- lt}', "");
    Expect(0, 8188, '\P{Gc=- lt}', "");
    Expect(1, 8188, '\P{^Gc=- lt}', "");
    Expect(0, 8189, '\p{Gc=- lt}', "");
    Expect(1, 8189, '\p{^Gc=- lt}', "");
    Expect(1, 8189, '\P{Gc=- lt}', "");
    Expect(0, 8189, '\P{^Gc=- lt}', "");
    Error('\p{Category=/a/ _TITLECASE_Letter}');
    Error('\P{Category=/a/ _TITLECASE_Letter}');
    Expect(1, 8188, '\p{Category=:\ATitlecase_Letter\z:}', "");;
    Expect(0, 8189, '\p{Category=:\ATitlecase_Letter\z:}', "");;
    Expect(1, 8188, '\p{Category=titlecaseletter}', "");
    Expect(0, 8188, '\p{^Category=titlecaseletter}', "");
    Expect(0, 8188, '\P{Category=titlecaseletter}', "");
    Expect(1, 8188, '\P{^Category=titlecaseletter}', "");
    Expect(0, 8189, '\p{Category=titlecaseletter}', "");
    Expect(1, 8189, '\p{^Category=titlecaseletter}', "");
    Expect(1, 8189, '\P{Category=titlecaseletter}', "");
    Expect(0, 8189, '\P{^Category=titlecaseletter}', "");
    Expect(1, 8188, '\p{Category=:\Atitlecaseletter\z:}', "");;
    Expect(0, 8189, '\p{Category=:\Atitlecaseletter\z:}', "");;
    Expect(1, 8188, '\p{Category= -Titlecase_Letter}', "");
    Expect(0, 8188, '\p{^Category= -Titlecase_Letter}', "");
    Expect(0, 8188, '\P{Category= -Titlecase_Letter}', "");
    Expect(1, 8188, '\P{^Category= -Titlecase_Letter}', "");
    Expect(0, 8189, '\p{Category= -Titlecase_Letter}', "");
    Expect(1, 8189, '\p{^Category= -Titlecase_Letter}', "");
    Expect(1, 8189, '\P{Category= -Titlecase_Letter}', "");
    Expect(0, 8189, '\P{^Category= -Titlecase_Letter}', "");
    Error('\p{Is_General_Category: -:=Lt}');
    Error('\P{Is_General_Category: -:=Lt}');
    Expect(1, 8188, '\p{Is_General_Category=lt}', "");
    Expect(0, 8188, '\p{^Is_General_Category=lt}', "");
    Expect(0, 8188, '\P{Is_General_Category=lt}', "");
    Expect(1, 8188, '\P{^Is_General_Category=lt}', "");
    Expect(0, 8189, '\p{Is_General_Category=lt}', "");
    Expect(1, 8189, '\p{^Is_General_Category=lt}', "");
    Expect(1, 8189, '\P{Is_General_Category=lt}', "");
    Expect(0, 8189, '\P{^Is_General_Category=lt}', "");
    Expect(1, 8188, '\p{Is_General_Category=	 LT}', "");
    Expect(0, 8188, '\p{^Is_General_Category=	 LT}', "");
    Expect(0, 8188, '\P{Is_General_Category=	 LT}', "");
    Expect(1, 8188, '\P{^Is_General_Category=	 LT}', "");
    Expect(0, 8189, '\p{Is_General_Category=	 LT}', "");
    Expect(1, 8189, '\p{^Is_General_Category=	 LT}', "");
    Expect(1, 8189, '\P{Is_General_Category=	 LT}', "");
    Expect(0, 8189, '\P{^Is_General_Category=	 LT}', "");
    Error('\p{Is_Gc=-/a/titlecase_LETTER}');
    Error('\P{Is_Gc=-/a/titlecase_LETTER}');
    Expect(1, 8188, '\p{Is_Gc=titlecaseletter}', "");
    Expect(0, 8188, '\p{^Is_Gc=titlecaseletter}', "");
    Expect(0, 8188, '\P{Is_Gc=titlecaseletter}', "");
    Expect(1, 8188, '\P{^Is_Gc=titlecaseletter}', "");
    Expect(0, 8189, '\p{Is_Gc=titlecaseletter}', "");
    Expect(1, 8189, '\p{^Is_Gc=titlecaseletter}', "");
    Expect(1, 8189, '\P{Is_Gc=titlecaseletter}', "");
    Expect(0, 8189, '\P{^Is_Gc=titlecaseletter}', "");
    Expect(1, 8188, '\p{Is_Gc:   --titlecase_Letter}', "");
    Expect(0, 8188, '\p{^Is_Gc:   --titlecase_Letter}', "");
    Expect(0, 8188, '\P{Is_Gc:   --titlecase_Letter}', "");
    Expect(1, 8188, '\P{^Is_Gc:   --titlecase_Letter}', "");
    Expect(0, 8189, '\p{Is_Gc:   --titlecase_Letter}', "");
    Expect(1, 8189, '\p{^Is_Gc:   --titlecase_Letter}', "");
    Expect(1, 8189, '\P{Is_Gc:   --titlecase_Letter}', "");
    Expect(0, 8189, '\P{^Is_Gc:   --titlecase_Letter}', "");
    Error('\p{Is_Category=:= _lt}');
    Error('\P{Is_Category=:= _lt}');
    Expect(1, 8188, '\p{Is_Category=lt}', "");
    Expect(0, 8188, '\p{^Is_Category=lt}', "");
    Expect(0, 8188, '\P{Is_Category=lt}', "");
    Expect(1, 8188, '\P{^Is_Category=lt}', "");
    Expect(0, 8189, '\p{Is_Category=lt}', "");
    Expect(1, 8189, '\p{^Is_Category=lt}', "");
    Expect(1, 8189, '\P{Is_Category=lt}', "");
    Expect(0, 8189, '\P{^Is_Category=lt}', "");
    Expect(1, 8188, '\p{Is_Category:   _Lt}', "");
    Expect(0, 8188, '\p{^Is_Category:   _Lt}', "");
    Expect(0, 8188, '\P{Is_Category:   _Lt}', "");
    Expect(1, 8188, '\P{^Is_Category:   _Lt}', "");
    Expect(0, 8189, '\p{Is_Category:   _Lt}', "");
    Expect(1, 8189, '\p{^Is_Category:   _Lt}', "");
    Expect(1, 8189, '\P{Is_Category:   _Lt}', "");
    Expect(0, 8189, '\P{^Is_Category:   _Lt}', "");
    Error('\p{General_Category=/a/ Uppercase_Letter}');
    Error('\P{General_Category=/a/ Uppercase_Letter}');
    Expect(1, 125217, '\p{General_Category=:\AUppercase_Letter\z:}', "");;
    Expect(0, 125218, '\p{General_Category=:\AUppercase_Letter\z:}', "");;
    Expect(1, 125217, '\p{General_Category=uppercaseletter}', "");
    Expect(0, 125217, '\p{^General_Category=uppercaseletter}', "");
    Expect(0, 125217, '\P{General_Category=uppercaseletter}', "");
    Expect(1, 125217, '\P{^General_Category=uppercaseletter}', "");
    Expect(0, 125218, '\p{General_Category=uppercaseletter}', "");
    Expect(1, 125218, '\p{^General_Category=uppercaseletter}', "");
    Expect(1, 125218, '\P{General_Category=uppercaseletter}', "");
    Expect(0, 125218, '\P{^General_Category=uppercaseletter}', "");
    Expect(1, 125217, '\p{General_Category=:\Auppercaseletter\z:}', "");;
    Expect(0, 125218, '\p{General_Category=:\Auppercaseletter\z:}', "");;
    Expect(1, 125217, '\p{General_Category= 	uppercase_letter}', "");
    Expect(0, 125217, '\p{^General_Category= 	uppercase_letter}', "");
    Expect(0, 125217, '\P{General_Category= 	uppercase_letter}', "");
    Expect(1, 125217, '\P{^General_Category= 	uppercase_letter}', "");
    Expect(0, 125218, '\p{General_Category= 	uppercase_letter}', "");
    Expect(1, 125218, '\p{^General_Category= 	uppercase_letter}', "");
    Expect(1, 125218, '\P{General_Category= 	uppercase_letter}', "");
    Expect(0, 125218, '\P{^General_Category= 	uppercase_letter}', "");
    Error('\p{Gc= LU/a/}');
    Error('\P{Gc= LU/a/}');
    Expect(1, 125217, '\p{Gc=:\ALu\z:}', "");;
    Expect(0, 125218, '\p{Gc=:\ALu\z:}', "");;
    Expect(1, 125217, '\p{Gc:	lu}', "");
    Expect(0, 125217, '\p{^Gc:	lu}', "");
    Expect(0, 125217, '\P{Gc:	lu}', "");
    Expect(1, 125217, '\P{^Gc:	lu}', "");
    Expect(0, 125218, '\p{Gc:	lu}', "");
    Expect(1, 125218, '\p{^Gc:	lu}', "");
    Expect(1, 125218, '\P{Gc:	lu}', "");
    Expect(0, 125218, '\P{^Gc:	lu}', "");
    Expect(1, 125217, '\p{Gc=:\Alu\z:}', "");;
    Expect(0, 125218, '\p{Gc=:\Alu\z:}', "");;
    Expect(1, 125217, '\p{Gc=--Lu}', "");
    Expect(0, 125217, '\p{^Gc=--Lu}', "");
    Expect(0, 125217, '\P{Gc=--Lu}', "");
    Expect(1, 125217, '\P{^Gc=--Lu}', "");
    Expect(0, 125218, '\p{Gc=--Lu}', "");
    Expect(1, 125218, '\p{^Gc=--Lu}', "");
    Expect(1, 125218, '\P{Gc=--Lu}', "");
    Expect(0, 125218, '\P{^Gc=--Lu}', "");
    Error('\p{Category=	/a/uppercase_letter}');
    Error('\P{Category=	/a/uppercase_letter}');
    Expect(1, 125217, '\p{Category=:\AUppercase_Letter\z:}', "");;
    Expect(0, 125218, '\p{Category=:\AUppercase_Letter\z:}', "");;
    Expect(1, 125217, '\p{Category=uppercaseletter}', "");
    Expect(0, 125217, '\p{^Category=uppercaseletter}', "");
    Expect(0, 125217, '\P{Category=uppercaseletter}', "");
    Expect(1, 125217, '\P{^Category=uppercaseletter}', "");
    Expect(0, 125218, '\p{Category=uppercaseletter}', "");
    Expect(1, 125218, '\p{^Category=uppercaseletter}', "");
    Expect(1, 125218, '\P{Category=uppercaseletter}', "");
    Expect(0, 125218, '\P{^Category=uppercaseletter}', "");
    Expect(1, 125217, '\p{Category=:\Auppercaseletter\z:}', "");;
    Expect(0, 125218, '\p{Category=:\Auppercaseletter\z:}', "");;
    Expect(1, 125217, '\p{Category:   	Uppercase_Letter}', "");
    Expect(0, 125217, '\p{^Category:   	Uppercase_Letter}', "");
    Expect(0, 125217, '\P{Category:   	Uppercase_Letter}', "");
    Expect(1, 125217, '\P{^Category:   	Uppercase_Letter}', "");
    Expect(0, 125218, '\p{Category:   	Uppercase_Letter}', "");
    Expect(1, 125218, '\p{^Category:   	Uppercase_Letter}', "");
    Expect(1, 125218, '\P{Category:   	Uppercase_Letter}', "");
    Expect(0, 125218, '\P{^Category:   	Uppercase_Letter}', "");
    Error('\p{Is_General_Category=:=lu}');
    Error('\P{Is_General_Category=:=lu}');
    Expect(1, 125217, '\p{Is_General_Category=lu}', "");
    Expect(0, 125217, '\p{^Is_General_Category=lu}', "");
    Expect(0, 125217, '\P{Is_General_Category=lu}', "");
    Expect(1, 125217, '\P{^Is_General_Category=lu}', "");
    Expect(0, 125218, '\p{Is_General_Category=lu}', "");
    Expect(1, 125218, '\p{^Is_General_Category=lu}', "");
    Expect(1, 125218, '\P{Is_General_Category=lu}', "");
    Expect(0, 125218, '\P{^Is_General_Category=lu}', "");
    Expect(1, 125217, '\p{Is_General_Category:	-Lu}', "");
    Expect(0, 125217, '\p{^Is_General_Category:	-Lu}', "");
    Expect(0, 125217, '\P{Is_General_Category:	-Lu}', "");
    Expect(1, 125217, '\P{^Is_General_Category:	-Lu}', "");
    Expect(0, 125218, '\p{Is_General_Category:	-Lu}', "");
    Expect(1, 125218, '\p{^Is_General_Category:	-Lu}', "");
    Expect(1, 125218, '\P{Is_General_Category:	-Lu}', "");
    Expect(0, 125218, '\P{^Is_General_Category:	-Lu}', "");
    Error('\p{Is_Gc=	Uppercase_letter:=}');
    Error('\P{Is_Gc=	Uppercase_letter:=}');
    Expect(1, 125217, '\p{Is_Gc=uppercaseletter}', "");
    Expect(0, 125217, '\p{^Is_Gc=uppercaseletter}', "");
    Expect(0, 125217, '\P{Is_Gc=uppercaseletter}', "");
    Expect(1, 125217, '\P{^Is_Gc=uppercaseletter}', "");
    Expect(0, 125218, '\p{Is_Gc=uppercaseletter}', "");
    Expect(1, 125218, '\p{^Is_Gc=uppercaseletter}', "");
    Expect(1, 125218, '\P{Is_Gc=uppercaseletter}', "");
    Expect(0, 125218, '\P{^Is_Gc=uppercaseletter}', "");
    Expect(1, 125217, '\p{Is_Gc:   -Uppercase_Letter}', "");
    Expect(0, 125217, '\p{^Is_Gc:   -Uppercase_Letter}', "");
    Expect(0, 125217, '\P{Is_Gc:   -Uppercase_Letter}', "");
    Expect(1, 125217, '\P{^Is_Gc:   -Uppercase_Letter}', "");
    Expect(0, 125218, '\p{Is_Gc:   -Uppercase_Letter}', "");
    Expect(1, 125218, '\p{^Is_Gc:   -Uppercase_Letter}', "");
    Expect(1, 125218, '\P{Is_Gc:   -Uppercase_Letter}', "");
    Expect(0, 125218, '\P{^Is_Gc:   -Uppercase_Letter}', "");
    Error('\p{Is_Category=:=_lu}');
    Error('\P{Is_Category=:=_lu}');
    Expect(1, 125217, '\p{Is_Category=lu}', "");
    Expect(0, 125217, '\p{^Is_Category=lu}', "");
    Expect(0, 125217, '\P{Is_Category=lu}', "");
    Expect(1, 125217, '\P{^Is_Category=lu}', "");
    Expect(0, 125218, '\p{Is_Category=lu}', "");
    Expect(1, 125218, '\p{^Is_Category=lu}', "");
    Expect(1, 125218, '\P{Is_Category=lu}', "");
    Expect(0, 125218, '\P{^Is_Category=lu}', "");
    Expect(1, 125217, '\p{Is_Category=- Lu}', "");
    Expect(0, 125217, '\p{^Is_Category=- Lu}', "");
    Expect(0, 125217, '\P{Is_Category=- Lu}', "");
    Expect(1, 125217, '\P{^Is_Category=- Lu}', "");
    Expect(0, 125218, '\p{Is_Category=- Lu}', "");
    Expect(1, 125218, '\p{^Is_Category=- Lu}', "");
    Expect(1, 125218, '\P{Is_Category=- Lu}', "");
    Expect(0, 125218, '\P{^Is_Category=- Lu}', "");
    Error('\p{General_Category=	_mark/a/}');
    Error('\P{General_Category=	_mark/a/}');
    Expect(1, 917999, '\p{General_Category=:\AMark\z:}', "");;
    Expect(0, 918000, '\p{General_Category=:\AMark\z:}', "");;
    Expect(1, 917999, '\p{General_Category=mark}', "");
    Expect(0, 917999, '\p{^General_Category=mark}', "");
    Expect(0, 917999, '\P{General_Category=mark}', "");
    Expect(1, 917999, '\P{^General_Category=mark}', "");
    Expect(0, 918000, '\p{General_Category=mark}', "");
    Expect(1, 918000, '\p{^General_Category=mark}', "");
    Expect(1, 918000, '\P{General_Category=mark}', "");
    Expect(0, 918000, '\P{^General_Category=mark}', "");
    Expect(1, 917999, '\p{General_Category=:\Amark\z:}', "");;
    Expect(0, 918000, '\p{General_Category=:\Amark\z:}', "");;
    Expect(1, 917999, '\p{General_Category= -mark}', "");
    Expect(0, 917999, '\p{^General_Category= -mark}', "");
    Expect(0, 917999, '\P{General_Category= -mark}', "");
    Expect(1, 917999, '\P{^General_Category= -mark}', "");
    Expect(0, 918000, '\p{General_Category= -mark}', "");
    Expect(1, 918000, '\p{^General_Category= -mark}', "");
    Expect(1, 918000, '\P{General_Category= -mark}', "");
    Expect(0, 918000, '\P{^General_Category= -mark}', "");
    Error('\p{Gc=:= 	M}');
    Error('\P{Gc=:= 	M}');
    Expect(1, 917999, '\p{Gc=:\AM\z:}', "");;
    Expect(0, 918000, '\p{Gc=:\AM\z:}', "");;
    Expect(1, 917999, '\p{Gc=m}', "");
    Expect(0, 917999, '\p{^Gc=m}', "");
    Expect(0, 917999, '\P{Gc=m}', "");
    Expect(1, 917999, '\P{^Gc=m}', "");
    Expect(0, 918000, '\p{Gc=m}', "");
    Expect(1, 918000, '\p{^Gc=m}', "");
    Expect(1, 918000, '\P{Gc=m}', "");
    Expect(0, 918000, '\P{^Gc=m}', "");
    Expect(1, 917999, '\p{Gc=:\Am\z:}', "");;
    Expect(0, 918000, '\p{Gc=:\Am\z:}', "");;
    Expect(1, 917999, '\p{Gc=--M}', "");
    Expect(0, 917999, '\p{^Gc=--M}', "");
    Expect(0, 917999, '\P{Gc=--M}', "");
    Expect(1, 917999, '\P{^Gc=--M}', "");
    Expect(0, 918000, '\p{Gc=--M}', "");
    Expect(1, 918000, '\p{^Gc=--M}', "");
    Expect(1, 918000, '\P{Gc=--M}', "");
    Expect(0, 918000, '\P{^Gc=--M}', "");
    Error('\p{Category= /a/COMBINING_Mark}');
    Error('\P{Category= /a/COMBINING_Mark}');
    Expect(1, 917999, '\p{Category=:\ACombining_Mark\z:}', "");;
    Expect(0, 918000, '\p{Category=:\ACombining_Mark\z:}', "");;
    Expect(1, 917999, '\p{Category:   combiningmark}', "");
    Expect(0, 917999, '\p{^Category:   combiningmark}', "");
    Expect(0, 917999, '\P{Category:   combiningmark}', "");
    Expect(1, 917999, '\P{^Category:   combiningmark}', "");
    Expect(0, 918000, '\p{Category:   combiningmark}', "");
    Expect(1, 918000, '\p{^Category:   combiningmark}', "");
    Expect(1, 918000, '\P{Category:   combiningmark}', "");
    Expect(0, 918000, '\P{^Category:   combiningmark}', "");
    Expect(1, 917999, '\p{Category=:\Acombiningmark\z:}', "");;
    Expect(0, 918000, '\p{Category=:\Acombiningmark\z:}', "");;
    Expect(1, 917999, '\p{Category= combining_MARK}', "");
    Expect(0, 917999, '\p{^Category= combining_MARK}', "");
    Expect(0, 917999, '\P{Category= combining_MARK}', "");
    Expect(1, 917999, '\P{^Category= combining_MARK}', "");
    Expect(0, 918000, '\p{Category= combining_MARK}', "");
    Expect(1, 918000, '\p{^Category= combining_MARK}', "");
    Expect(1, 918000, '\P{Category= combining_MARK}', "");
    Expect(0, 918000, '\P{^Category= combining_MARK}', "");
    Error('\p{Is_General_Category=/a/ 	Mark}');
    Error('\P{Is_General_Category=/a/ 	Mark}');
    Expect(1, 917999, '\p{Is_General_Category=mark}', "");
    Expect(0, 917999, '\p{^Is_General_Category=mark}', "");
    Expect(0, 917999, '\P{Is_General_Category=mark}', "");
    Expect(1, 917999, '\P{^Is_General_Category=mark}', "");
    Expect(0, 918000, '\p{Is_General_Category=mark}', "");
    Expect(1, 918000, '\p{^Is_General_Category=mark}', "");
    Expect(1, 918000, '\P{Is_General_Category=mark}', "");
    Expect(0, 918000, '\P{^Is_General_Category=mark}', "");
    Expect(1, 917999, '\p{Is_General_Category=_Mark}', "");
    Expect(0, 917999, '\p{^Is_General_Category=_Mark}', "");
    Expect(0, 917999, '\P{Is_General_Category=_Mark}', "");
    Expect(1, 917999, '\P{^Is_General_Category=_Mark}', "");
    Expect(0, 918000, '\p{Is_General_Category=_Mark}', "");
    Expect(1, 918000, '\p{^Is_General_Category=_Mark}', "");
    Expect(1, 918000, '\P{Is_General_Category=_Mark}', "");
    Expect(0, 918000, '\P{^Is_General_Category=_Mark}', "");
    Error('\p{Is_Gc=-M:=}');
    Error('\P{Is_Gc=-M:=}');
    Expect(1, 917999, '\p{Is_Gc=m}', "");
    Expect(0, 917999, '\p{^Is_Gc=m}', "");
    Expect(0, 917999, '\P{Is_Gc=m}', "");
    Expect(1, 917999, '\P{^Is_Gc=m}', "");
    Expect(0, 918000, '\p{Is_Gc=m}', "");
    Expect(1, 918000, '\p{^Is_Gc=m}', "");
    Expect(1, 918000, '\P{Is_Gc=m}', "");
    Expect(0, 918000, '\P{^Is_Gc=m}', "");
    Expect(1, 917999, '\p{Is_Gc:   _ M}', "");
    Expect(0, 917999, '\p{^Is_Gc:   _ M}', "");
    Expect(0, 917999, '\P{Is_Gc:   _ M}', "");
    Expect(1, 917999, '\P{^Is_Gc:   _ M}', "");
    Expect(0, 918000, '\p{Is_Gc:   _ M}', "");
    Expect(1, 918000, '\p{^Is_Gc:   _ M}', "");
    Expect(1, 918000, '\P{Is_Gc:   _ M}', "");
    Expect(0, 918000, '\P{^Is_Gc:   _ M}', "");
    Error('\p{Is_Category=:=_combining_Mark}');
    Error('\P{Is_Category=:=_combining_Mark}');
    Expect(1, 917999, '\p{Is_Category=combiningmark}', "");
    Expect(0, 917999, '\p{^Is_Category=combiningmark}', "");
    Expect(0, 917999, '\P{Is_Category=combiningmark}', "");
    Expect(1, 917999, '\P{^Is_Category=combiningmark}', "");
    Expect(0, 918000, '\p{Is_Category=combiningmark}', "");
    Expect(1, 918000, '\p{^Is_Category=combiningmark}', "");
    Expect(1, 918000, '\P{Is_Category=combiningmark}', "");
    Expect(0, 918000, '\P{^Is_Category=combiningmark}', "");
    Expect(1, 917999, '\p{Is_Category: _combining_MARK}', "");
    Expect(0, 917999, '\p{^Is_Category: _combining_MARK}', "");
    Expect(0, 917999, '\P{Is_Category: _combining_MARK}', "");
    Expect(1, 917999, '\P{^Is_Category: _combining_MARK}', "");
    Expect(0, 918000, '\p{Is_Category: _combining_MARK}', "");
    Expect(1, 918000, '\p{^Is_Category: _combining_MARK}', "");
    Expect(1, 918000, '\P{Is_Category: _combining_MARK}', "");
    Expect(0, 918000, '\P{^Is_Category: _combining_MARK}', "");
    Error('\p{General_Category=:= Spacing_Mark}');
    Error('\P{General_Category=:= Spacing_Mark}');
    Expect(1, 119154, '\p{General_Category=:\ASpacing_Mark\z:}', "");;
    Expect(0, 119155, '\p{General_Category=:\ASpacing_Mark\z:}', "");;
    Expect(1, 119154, '\p{General_Category:	spacingmark}', "");
    Expect(0, 119154, '\p{^General_Category:	spacingmark}', "");
    Expect(0, 119154, '\P{General_Category:	spacingmark}', "");
    Expect(1, 119154, '\P{^General_Category:	spacingmark}', "");
    Expect(0, 119155, '\p{General_Category:	spacingmark}', "");
    Expect(1, 119155, '\p{^General_Category:	spacingmark}', "");
    Expect(1, 119155, '\P{General_Category:	spacingmark}', "");
    Expect(0, 119155, '\P{^General_Category:	spacingmark}', "");
    Expect(1, 119154, '\p{General_Category=:\Aspacingmark\z:}', "");;
    Expect(0, 119155, '\p{General_Category=:\Aspacingmark\z:}', "");;
    Expect(1, 119154, '\p{General_Category=		SPACING_Mark}', "");
    Expect(0, 119154, '\p{^General_Category=		SPACING_Mark}', "");
    Expect(0, 119154, '\P{General_Category=		SPACING_Mark}', "");
    Expect(1, 119154, '\P{^General_Category=		SPACING_Mark}', "");
    Expect(0, 119155, '\p{General_Category=		SPACING_Mark}', "");
    Expect(1, 119155, '\p{^General_Category=		SPACING_Mark}', "");
    Expect(1, 119155, '\P{General_Category=		SPACING_Mark}', "");
    Expect(0, 119155, '\P{^General_Category=		SPACING_Mark}', "");
    Error('\p{Gc=-:=Mc}');
    Error('\P{Gc=-:=Mc}');
    Expect(1, 119154, '\p{Gc=:\AMc\z:}', "");;
    Expect(0, 119155, '\p{Gc=:\AMc\z:}', "");;
    Expect(1, 119154, '\p{Gc=mc}', "");
    Expect(0, 119154, '\p{^Gc=mc}', "");
    Expect(0, 119154, '\P{Gc=mc}', "");
    Expect(1, 119154, '\P{^Gc=mc}', "");
    Expect(0, 119155, '\p{Gc=mc}', "");
    Expect(1, 119155, '\p{^Gc=mc}', "");
    Expect(1, 119155, '\P{Gc=mc}', "");
    Expect(0, 119155, '\P{^Gc=mc}', "");
    Expect(1, 119154, '\p{Gc=:\Amc\z:}', "");;
    Expect(0, 119155, '\p{Gc=:\Amc\z:}', "");;
    Expect(1, 119154, '\p{Gc=	_MC}', "");
    Expect(0, 119154, '\p{^Gc=	_MC}', "");
    Expect(0, 119154, '\P{Gc=	_MC}', "");
    Expect(1, 119154, '\P{^Gc=	_MC}', "");
    Expect(0, 119155, '\p{Gc=	_MC}', "");
    Expect(1, 119155, '\p{^Gc=	_MC}', "");
    Expect(1, 119155, '\P{Gc=	_MC}', "");
    Expect(0, 119155, '\P{^Gc=	_MC}', "");
    Error('\p{Category:	/a/__SPACING_mark}');
    Error('\P{Category:	/a/__SPACING_mark}');
    Expect(1, 119154, '\p{Category=:\ASpacing_Mark\z:}', "");;
    Expect(0, 119155, '\p{Category=:\ASpacing_Mark\z:}', "");;
    Expect(1, 119154, '\p{Category=spacingmark}', "");
    Expect(0, 119154, '\p{^Category=spacingmark}', "");
    Expect(0, 119154, '\P{Category=spacingmark}', "");
    Expect(1, 119154, '\P{^Category=spacingmark}', "");
    Expect(0, 119155, '\p{Category=spacingmark}', "");
    Expect(1, 119155, '\p{^Category=spacingmark}', "");
    Expect(1, 119155, '\P{Category=spacingmark}', "");
    Expect(0, 119155, '\P{^Category=spacingmark}', "");
    Expect(1, 119154, '\p{Category=:\Aspacingmark\z:}', "");;
    Expect(0, 119155, '\p{Category=:\Aspacingmark\z:}', "");;
    Expect(1, 119154, '\p{Category=_-SPACING_MARK}', "");
    Expect(0, 119154, '\p{^Category=_-SPACING_MARK}', "");
    Expect(0, 119154, '\P{Category=_-SPACING_MARK}', "");
    Expect(1, 119154, '\P{^Category=_-SPACING_MARK}', "");
    Expect(0, 119155, '\p{Category=_-SPACING_MARK}', "");
    Expect(1, 119155, '\p{^Category=_-SPACING_MARK}', "");
    Expect(1, 119155, '\P{Category=_-SPACING_MARK}', "");
    Expect(0, 119155, '\P{^Category=_-SPACING_MARK}', "");
    Error('\p{Is_General_Category=/a/mc}');
    Error('\P{Is_General_Category=/a/mc}');
    Expect(1, 119154, '\p{Is_General_Category:mc}', "");
    Expect(0, 119154, '\p{^Is_General_Category:mc}', "");
    Expect(0, 119154, '\P{Is_General_Category:mc}', "");
    Expect(1, 119154, '\P{^Is_General_Category:mc}', "");
    Expect(0, 119155, '\p{Is_General_Category:mc}', "");
    Expect(1, 119155, '\p{^Is_General_Category:mc}', "");
    Expect(1, 119155, '\P{Is_General_Category:mc}', "");
    Expect(0, 119155, '\P{^Is_General_Category:mc}', "");
    Expect(1, 119154, '\p{Is_General_Category=- mc}', "");
    Expect(0, 119154, '\p{^Is_General_Category=- mc}', "");
    Expect(0, 119154, '\P{Is_General_Category=- mc}', "");
    Expect(1, 119154, '\P{^Is_General_Category=- mc}', "");
    Expect(0, 119155, '\p{Is_General_Category=- mc}', "");
    Expect(1, 119155, '\p{^Is_General_Category=- mc}', "");
    Expect(1, 119155, '\P{Is_General_Category=- mc}', "");
    Expect(0, 119155, '\P{^Is_General_Category=- mc}', "");
    Error('\p{Is_Gc=	:=spacing_Mark}');
    Error('\P{Is_Gc=	:=spacing_Mark}');
    Expect(1, 119154, '\p{Is_Gc=spacingmark}', "");
    Expect(0, 119154, '\p{^Is_Gc=spacingmark}', "");
    Expect(0, 119154, '\P{Is_Gc=spacingmark}', "");
    Expect(1, 119154, '\P{^Is_Gc=spacingmark}', "");
    Expect(0, 119155, '\p{Is_Gc=spacingmark}', "");
    Expect(1, 119155, '\p{^Is_Gc=spacingmark}', "");
    Expect(1, 119155, '\P{Is_Gc=spacingmark}', "");
    Expect(0, 119155, '\P{^Is_Gc=spacingmark}', "");
    Expect(1, 119154, '\p{Is_Gc=_Spacing_Mark}', "");
    Expect(0, 119154, '\p{^Is_Gc=_Spacing_Mark}', "");
    Expect(0, 119154, '\P{Is_Gc=_Spacing_Mark}', "");
    Expect(1, 119154, '\P{^Is_Gc=_Spacing_Mark}', "");
    Expect(0, 119155, '\p{Is_Gc=_Spacing_Mark}', "");
    Expect(1, 119155, '\p{^Is_Gc=_Spacing_Mark}', "");
    Expect(1, 119155, '\P{Is_Gc=_Spacing_Mark}', "");
    Expect(0, 119155, '\P{^Is_Gc=_Spacing_Mark}', "");
    Error('\p{Is_Category:   /a/ mc}');
    Error('\P{Is_Category:   /a/ mc}');
    Expect(1, 119154, '\p{Is_Category=mc}', "");
    Expect(0, 119154, '\p{^Is_Category=mc}', "");
    Expect(0, 119154, '\P{Is_Category=mc}', "");
    Expect(1, 119154, '\P{^Is_Category=mc}', "");
    Expect(0, 119155, '\p{Is_Category=mc}', "");
    Expect(1, 119155, '\p{^Is_Category=mc}', "");
    Expect(1, 119155, '\P{Is_Category=mc}', "");
    Expect(0, 119155, '\P{^Is_Category=mc}', "");
    Expect(1, 119154, '\p{Is_Category=  Mc}', "");
    Expect(0, 119154, '\p{^Is_Category=  Mc}', "");
    Expect(0, 119154, '\P{Is_Category=  Mc}', "");
    Expect(1, 119154, '\P{^Is_Category=  Mc}', "");
    Expect(0, 119155, '\p{Is_Category=  Mc}', "");
    Expect(1, 119155, '\p{^Is_Category=  Mc}', "");
    Expect(1, 119155, '\P{Is_Category=  Mc}', "");
    Expect(0, 119155, '\P{^Is_Category=  Mc}', "");
    Error('\p{General_Category=:=-_Enclosing_MARK}');
    Error('\P{General_Category=:=-_Enclosing_MARK}');
    Expect(1, 42610, '\p{General_Category=:\AEnclosing_Mark\z:}', "");;
    Expect(0, 42611, '\p{General_Category=:\AEnclosing_Mark\z:}', "");;
    Expect(1, 42610, '\p{General_Category=enclosingmark}', "");
    Expect(0, 42610, '\p{^General_Category=enclosingmark}', "");
    Expect(0, 42610, '\P{General_Category=enclosingmark}', "");
    Expect(1, 42610, '\P{^General_Category=enclosingmark}', "");
    Expect(0, 42611, '\p{General_Category=enclosingmark}', "");
    Expect(1, 42611, '\p{^General_Category=enclosingmark}', "");
    Expect(1, 42611, '\P{General_Category=enclosingmark}', "");
    Expect(0, 42611, '\P{^General_Category=enclosingmark}', "");
    Expect(1, 42610, '\p{General_Category=:\Aenclosingmark\z:}', "");;
    Expect(0, 42611, '\p{General_Category=:\Aenclosingmark\z:}', "");;
    Expect(1, 42610, '\p{General_Category:  enclosing_mark}', "");
    Expect(0, 42610, '\p{^General_Category:  enclosing_mark}', "");
    Expect(0, 42610, '\P{General_Category:  enclosing_mark}', "");
    Expect(1, 42610, '\P{^General_Category:  enclosing_mark}', "");
    Expect(0, 42611, '\p{General_Category:  enclosing_mark}', "");
    Expect(1, 42611, '\p{^General_Category:  enclosing_mark}', "");
    Expect(1, 42611, '\P{General_Category:  enclosing_mark}', "");
    Expect(0, 42611, '\P{^General_Category:  enclosing_mark}', "");
    Error('\p{Gc=/a/- Me}');
    Error('\P{Gc=/a/- Me}');
    Expect(1, 42610, '\p{Gc=:\AMe\z:}', "");;
    Expect(0, 42611, '\p{Gc=:\AMe\z:}', "");;
    Expect(1, 42610, '\p{Gc=me}', "");
    Expect(0, 42610, '\p{^Gc=me}', "");
    Expect(0, 42610, '\P{Gc=me}', "");
    Expect(1, 42610, '\P{^Gc=me}', "");
    Expect(0, 42611, '\p{Gc=me}', "");
    Expect(1, 42611, '\p{^Gc=me}', "");
    Expect(1, 42611, '\P{Gc=me}', "");
    Expect(0, 42611, '\P{^Gc=me}', "");
    Expect(1, 42610, '\p{Gc=:\Ame\z:}', "");;
    Expect(0, 42611, '\p{Gc=:\Ame\z:}', "");;
    Expect(1, 42610, '\p{Gc=_Me}', "");
    Expect(0, 42610, '\p{^Gc=_Me}', "");
    Expect(0, 42610, '\P{Gc=_Me}', "");
    Expect(1, 42610, '\P{^Gc=_Me}', "");
    Expect(0, 42611, '\p{Gc=_Me}', "");
    Expect(1, 42611, '\p{^Gc=_Me}', "");
    Expect(1, 42611, '\P{Gc=_Me}', "");
    Expect(0, 42611, '\P{^Gc=_Me}', "");
    Error('\p{Category=/a/_	enclosing_Mark}');
    Error('\P{Category=/a/_	enclosing_Mark}');
    Expect(1, 42610, '\p{Category=:\AEnclosing_Mark\z:}', "");;
    Expect(0, 42611, '\p{Category=:\AEnclosing_Mark\z:}', "");;
    Expect(1, 42610, '\p{Category=enclosingmark}', "");
    Expect(0, 42610, '\p{^Category=enclosingmark}', "");
    Expect(0, 42610, '\P{Category=enclosingmark}', "");
    Expect(1, 42610, '\P{^Category=enclosingmark}', "");
    Expect(0, 42611, '\p{Category=enclosingmark}', "");
    Expect(1, 42611, '\p{^Category=enclosingmark}', "");
    Expect(1, 42611, '\P{Category=enclosingmark}', "");
    Expect(0, 42611, '\P{^Category=enclosingmark}', "");
    Expect(1, 42610, '\p{Category=:\Aenclosingmark\z:}', "");;
    Expect(0, 42611, '\p{Category=:\Aenclosingmark\z:}', "");;
    Expect(1, 42610, '\p{Category=Enclosing_Mark}', "");
    Expect(0, 42610, '\p{^Category=Enclosing_Mark}', "");
    Expect(0, 42610, '\P{Category=Enclosing_Mark}', "");
    Expect(1, 42610, '\P{^Category=Enclosing_Mark}', "");
    Expect(0, 42611, '\p{Category=Enclosing_Mark}', "");
    Expect(1, 42611, '\p{^Category=Enclosing_Mark}', "");
    Expect(1, 42611, '\P{Category=Enclosing_Mark}', "");
    Expect(0, 42611, '\P{^Category=Enclosing_Mark}', "");
    Error('\p{Is_General_Category=/a/ME}');
    Error('\P{Is_General_Category=/a/ME}');
    Expect(1, 42610, '\p{Is_General_Category=me}', "");
    Expect(0, 42610, '\p{^Is_General_Category=me}', "");
    Expect(0, 42610, '\P{Is_General_Category=me}', "");
    Expect(1, 42610, '\P{^Is_General_Category=me}', "");
    Expect(0, 42611, '\p{Is_General_Category=me}', "");
    Expect(1, 42611, '\p{^Is_General_Category=me}', "");
    Expect(1, 42611, '\P{Is_General_Category=me}', "");
    Expect(0, 42611, '\P{^Is_General_Category=me}', "");
    Expect(1, 42610, '\p{Is_General_Category=__Me}', "");
    Expect(0, 42610, '\p{^Is_General_Category=__Me}', "");
    Expect(0, 42610, '\P{Is_General_Category=__Me}', "");
    Expect(1, 42610, '\P{^Is_General_Category=__Me}', "");
    Expect(0, 42611, '\p{Is_General_Category=__Me}', "");
    Expect(1, 42611, '\p{^Is_General_Category=__Me}', "");
    Expect(1, 42611, '\P{Is_General_Category=__Me}', "");
    Expect(0, 42611, '\P{^Is_General_Category=__Me}', "");
    Error('\p{Is_Gc=_/a/enclosing_Mark}');
    Error('\P{Is_Gc=_/a/enclosing_Mark}');
    Expect(1, 42610, '\p{Is_Gc:   enclosingmark}', "");
    Expect(0, 42610, '\p{^Is_Gc:   enclosingmark}', "");
    Expect(0, 42610, '\P{Is_Gc:   enclosingmark}', "");
    Expect(1, 42610, '\P{^Is_Gc:   enclosingmark}', "");
    Expect(0, 42611, '\p{Is_Gc:   enclosingmark}', "");
    Expect(1, 42611, '\p{^Is_Gc:   enclosingmark}', "");
    Expect(1, 42611, '\P{Is_Gc:   enclosingmark}', "");
    Expect(0, 42611, '\P{^Is_Gc:   enclosingmark}', "");
    Expect(1, 42610, '\p{Is_Gc=	_Enclosing_mark}', "");
    Expect(0, 42610, '\p{^Is_Gc=	_Enclosing_mark}', "");
    Expect(0, 42610, '\P{Is_Gc=	_Enclosing_mark}', "");
    Expect(1, 42610, '\P{^Is_Gc=	_Enclosing_mark}', "");
    Expect(0, 42611, '\p{Is_Gc=	_Enclosing_mark}', "");
    Expect(1, 42611, '\p{^Is_Gc=	_Enclosing_mark}', "");
    Expect(1, 42611, '\P{Is_Gc=	_Enclosing_mark}', "");
    Expect(0, 42611, '\P{^Is_Gc=	_Enclosing_mark}', "");
    Error('\p{Is_Category=:=		Me}');
    Error('\P{Is_Category=:=		Me}');
    Expect(1, 42610, '\p{Is_Category=me}', "");
    Expect(0, 42610, '\p{^Is_Category=me}', "");
    Expect(0, 42610, '\P{Is_Category=me}', "");
    Expect(1, 42610, '\P{^Is_Category=me}', "");
    Expect(0, 42611, '\p{Is_Category=me}', "");
    Expect(1, 42611, '\p{^Is_Category=me}', "");
    Expect(1, 42611, '\P{Is_Category=me}', "");
    Expect(0, 42611, '\P{^Is_Category=me}', "");
    Expect(1, 42610, '\p{Is_Category=	me}', "");
    Expect(0, 42610, '\p{^Is_Category=	me}', "");
    Expect(0, 42610, '\P{Is_Category=	me}', "");
    Expect(1, 42610, '\P{^Is_Category=	me}', "");
    Expect(0, 42611, '\p{Is_Category=	me}', "");
    Expect(1, 42611, '\p{^Is_Category=	me}', "");
    Expect(1, 42611, '\P{Is_Category=	me}', "");
    Expect(0, 42611, '\P{^Is_Category=	me}', "");
    Error('\p{General_Category=	/a/NONSPACING_MARK}');
    Error('\P{General_Category=	/a/NONSPACING_MARK}');
    Expect(1, 917999, '\p{General_Category=:\ANonspacing_Mark\z:}', "");;
    Expect(0, 918000, '\p{General_Category=:\ANonspacing_Mark\z:}', "");;
    Expect(1, 917999, '\p{General_Category=nonspacingmark}', "");
    Expect(0, 917999, '\p{^General_Category=nonspacingmark}', "");
    Expect(0, 917999, '\P{General_Category=nonspacingmark}', "");
    Expect(1, 917999, '\P{^General_Category=nonspacingmark}', "");
    Expect(0, 918000, '\p{General_Category=nonspacingmark}', "");
    Expect(1, 918000, '\p{^General_Category=nonspacingmark}', "");
    Expect(1, 918000, '\P{General_Category=nonspacingmark}', "");
    Expect(0, 918000, '\P{^General_Category=nonspacingmark}', "");
    Expect(1, 917999, '\p{General_Category=:\Anonspacingmark\z:}', "");;
    Expect(0, 918000, '\p{General_Category=:\Anonspacingmark\z:}', "");;
    Expect(1, 917999, '\p{General_Category:   --Nonspacing_MARK}', "");
    Expect(0, 917999, '\p{^General_Category:   --Nonspacing_MARK}', "");
    Expect(0, 917999, '\P{General_Category:   --Nonspacing_MARK}', "");
    Expect(1, 917999, '\P{^General_Category:   --Nonspacing_MARK}', "");
    Expect(0, 918000, '\p{General_Category:   --Nonspacing_MARK}', "");
    Expect(1, 918000, '\p{^General_Category:   --Nonspacing_MARK}', "");
    Expect(1, 918000, '\P{General_Category:   --Nonspacing_MARK}', "");
    Expect(0, 918000, '\P{^General_Category:   --Nonspacing_MARK}', "");
    Error('\p{Gc=	 Mn/a/}');
    Error('\P{Gc=	 Mn/a/}');
    Expect(1, 917999, '\p{Gc=:\AMn\z:}', "");;
    Expect(0, 918000, '\p{Gc=:\AMn\z:}', "");;
    Expect(1, 917999, '\p{Gc=mn}', "");
    Expect(0, 917999, '\p{^Gc=mn}', "");
    Expect(0, 917999, '\P{Gc=mn}', "");
    Expect(1, 917999, '\P{^Gc=mn}', "");
    Expect(0, 918000, '\p{Gc=mn}', "");
    Expect(1, 918000, '\p{^Gc=mn}', "");
    Expect(1, 918000, '\P{Gc=mn}', "");
    Expect(0, 918000, '\P{^Gc=mn}', "");
    Expect(1, 917999, '\p{Gc=:\Amn\z:}', "");;
    Expect(0, 918000, '\p{Gc=:\Amn\z:}', "");;
    Expect(1, 917999, '\p{Gc=	 Mn}', "");
    Expect(0, 917999, '\p{^Gc=	 Mn}', "");
    Expect(0, 917999, '\P{Gc=	 Mn}', "");
    Expect(1, 917999, '\P{^Gc=	 Mn}', "");
    Expect(0, 918000, '\p{Gc=	 Mn}', "");
    Expect(1, 918000, '\p{^Gc=	 Mn}', "");
    Expect(1, 918000, '\P{Gc=	 Mn}', "");
    Expect(0, 918000, '\P{^Gc=	 Mn}', "");
    Error('\p{Category=:=		NONSPACING_Mark}');
    Error('\P{Category=:=		NONSPACING_Mark}');
    Expect(1, 917999, '\p{Category=:\ANonspacing_Mark\z:}', "");;
    Expect(0, 918000, '\p{Category=:\ANonspacing_Mark\z:}', "");;
    Expect(1, 917999, '\p{Category=nonspacingmark}', "");
    Expect(0, 917999, '\p{^Category=nonspacingmark}', "");
    Expect(0, 917999, '\P{Category=nonspacingmark}', "");
    Expect(1, 917999, '\P{^Category=nonspacingmark}', "");
    Expect(0, 918000, '\p{Category=nonspacingmark}', "");
    Expect(1, 918000, '\p{^Category=nonspacingmark}', "");
    Expect(1, 918000, '\P{Category=nonspacingmark}', "");
    Expect(0, 918000, '\P{^Category=nonspacingmark}', "");
    Expect(1, 917999, '\p{Category=:\Anonspacingmark\z:}', "");;
    Expect(0, 918000, '\p{Category=:\Anonspacingmark\z:}', "");;
    Expect(1, 917999, '\p{Category= NONSPACING_Mark}', "");
    Expect(0, 917999, '\p{^Category= NONSPACING_Mark}', "");
    Expect(0, 917999, '\P{Category= NONSPACING_Mark}', "");
    Expect(1, 917999, '\P{^Category= NONSPACING_Mark}', "");
    Expect(0, 918000, '\p{Category= NONSPACING_Mark}', "");
    Expect(1, 918000, '\p{^Category= NONSPACING_Mark}', "");
    Expect(1, 918000, '\P{Category= NONSPACING_Mark}', "");
    Expect(0, 918000, '\P{^Category= NONSPACING_Mark}', "");
    Error('\p{Is_General_Category:	_ MN/a/}');
    Error('\P{Is_General_Category:	_ MN/a/}');
    Expect(1, 917999, '\p{Is_General_Category=mn}', "");
    Expect(0, 917999, '\p{^Is_General_Category=mn}', "");
    Expect(0, 917999, '\P{Is_General_Category=mn}', "");
    Expect(1, 917999, '\P{^Is_General_Category=mn}', "");
    Expect(0, 918000, '\p{Is_General_Category=mn}', "");
    Expect(1, 918000, '\p{^Is_General_Category=mn}', "");
    Expect(1, 918000, '\P{Is_General_Category=mn}', "");
    Expect(0, 918000, '\P{^Is_General_Category=mn}', "");
    Expect(1, 917999, '\p{Is_General_Category=	 MN}', "");
    Expect(0, 917999, '\p{^Is_General_Category=	 MN}', "");
    Expect(0, 917999, '\P{Is_General_Category=	 MN}', "");
    Expect(1, 917999, '\P{^Is_General_Category=	 MN}', "");
    Expect(0, 918000, '\p{Is_General_Category=	 MN}', "");
    Expect(1, 918000, '\p{^Is_General_Category=	 MN}', "");
    Expect(1, 918000, '\P{Is_General_Category=	 MN}', "");
    Expect(0, 918000, '\P{^Is_General_Category=	 MN}', "");
    Error('\p{Is_Gc=/a/ -nonspacing_Mark}');
    Error('\P{Is_Gc=/a/ -nonspacing_Mark}');
    Expect(1, 917999, '\p{Is_Gc:	nonspacingmark}', "");
    Expect(0, 917999, '\p{^Is_Gc:	nonspacingmark}', "");
    Expect(0, 917999, '\P{Is_Gc:	nonspacingmark}', "");
    Expect(1, 917999, '\P{^Is_Gc:	nonspacingmark}', "");
    Expect(0, 918000, '\p{Is_Gc:	nonspacingmark}', "");
    Expect(1, 918000, '\p{^Is_Gc:	nonspacingmark}', "");
    Expect(1, 918000, '\P{Is_Gc:	nonspacingmark}', "");
    Expect(0, 918000, '\P{^Is_Gc:	nonspacingmark}', "");
    Expect(1, 917999, '\p{Is_Gc=		Nonspacing_Mark}', "");
    Expect(0, 917999, '\p{^Is_Gc=		Nonspacing_Mark}', "");
    Expect(0, 917999, '\P{Is_Gc=		Nonspacing_Mark}', "");
    Expect(1, 917999, '\P{^Is_Gc=		Nonspacing_Mark}', "");
    Expect(0, 918000, '\p{Is_Gc=		Nonspacing_Mark}', "");
    Expect(1, 918000, '\p{^Is_Gc=		Nonspacing_Mark}', "");
    Expect(1, 918000, '\P{Is_Gc=		Nonspacing_Mark}', "");
    Expect(0, 918000, '\P{^Is_Gc=		Nonspacing_Mark}', "");
    Error('\p{Is_Category=:=-MN}');
    Error('\P{Is_Category=:=-MN}');
    Expect(1, 917999, '\p{Is_Category=mn}', "");
    Expect(0, 917999, '\p{^Is_Category=mn}', "");
    Expect(0, 917999, '\P{Is_Category=mn}', "");
    Expect(1, 917999, '\P{^Is_Category=mn}', "");
    Expect(0, 918000, '\p{Is_Category=mn}', "");
    Expect(1, 918000, '\p{^Is_Category=mn}', "");
    Expect(1, 918000, '\P{Is_Category=mn}', "");
    Expect(0, 918000, '\P{^Is_Category=mn}', "");
    Expect(1, 917999, '\p{Is_Category:   -	Mn}', "");
    Expect(0, 917999, '\p{^Is_Category:   -	Mn}', "");
    Expect(0, 917999, '\P{Is_Category:   -	Mn}', "");
    Expect(1, 917999, '\P{^Is_Category:   -	Mn}', "");
    Expect(0, 918000, '\p{Is_Category:   -	Mn}', "");
    Expect(1, 918000, '\p{^Is_Category:   -	Mn}', "");
    Expect(1, 918000, '\P{Is_Category:   -	Mn}', "");
    Expect(0, 918000, '\P{^Is_Category:   -	Mn}', "");
    Error('\p{General_Category=/a/	 Number}');
    Error('\P{General_Category=/a/	 Number}');
    Expect(1, 130041, '\p{General_Category=:\ANumber\z:}', "");;
    Expect(0, 130042, '\p{General_Category=:\ANumber\z:}', "");;
    Expect(1, 130041, '\p{General_Category:   number}', "");
    Expect(0, 130041, '\p{^General_Category:   number}', "");
    Expect(0, 130041, '\P{General_Category:   number}', "");
    Expect(1, 130041, '\P{^General_Category:   number}', "");
    Expect(0, 130042, '\p{General_Category:   number}', "");
    Expect(1, 130042, '\p{^General_Category:   number}', "");
    Expect(1, 130042, '\P{General_Category:   number}', "");
    Expect(0, 130042, '\P{^General_Category:   number}', "");
    Expect(1, 130041, '\p{General_Category=:\Anumber\z:}', "");;
    Expect(0, 130042, '\p{General_Category=:\Anumber\z:}', "");;
    Expect(1, 130041, '\p{General_Category=-	number}', "");
    Expect(0, 130041, '\p{^General_Category=-	number}', "");
    Expect(0, 130041, '\P{General_Category=-	number}', "");
    Expect(1, 130041, '\P{^General_Category=-	number}', "");
    Expect(0, 130042, '\p{General_Category=-	number}', "");
    Expect(1, 130042, '\p{^General_Category=-	number}', "");
    Expect(1, 130042, '\P{General_Category=-	number}', "");
    Expect(0, 130042, '\P{^General_Category=-	number}', "");
    Error('\p{Gc=		N:=}');
    Error('\P{Gc=		N:=}');
    Expect(1, 130041, '\p{Gc=:\AN\z:}', "");;
    Expect(0, 130042, '\p{Gc=:\AN\z:}', "");;
    Expect(1, 130041, '\p{Gc=n}', "");
    Expect(0, 130041, '\p{^Gc=n}', "");
    Expect(0, 130041, '\P{Gc=n}', "");
    Expect(1, 130041, '\P{^Gc=n}', "");
    Expect(0, 130042, '\p{Gc=n}', "");
    Expect(1, 130042, '\p{^Gc=n}', "");
    Expect(1, 130042, '\P{Gc=n}', "");
    Expect(0, 130042, '\P{^Gc=n}', "");
    Expect(1, 130041, '\p{Gc=:\An\z:}', "");;
    Expect(0, 130042, '\p{Gc=:\An\z:}', "");;
    Expect(1, 130041, '\p{Gc=_N}', "");
    Expect(0, 130041, '\p{^Gc=_N}', "");
    Expect(0, 130041, '\P{Gc=_N}', "");
    Expect(1, 130041, '\P{^Gc=_N}', "");
    Expect(0, 130042, '\p{Gc=_N}', "");
    Expect(1, 130042, '\p{^Gc=_N}', "");
    Expect(1, 130042, '\P{Gc=_N}', "");
    Expect(0, 130042, '\P{^Gc=_N}', "");
    Error('\p{Category=/a/_-number}');
    Error('\P{Category=/a/_-number}');
    Expect(1, 130041, '\p{Category=:\ANumber\z:}', "");;
    Expect(0, 130042, '\p{Category=:\ANumber\z:}', "");;
    Expect(1, 130041, '\p{Category=number}', "");
    Expect(0, 130041, '\p{^Category=number}', "");
    Expect(0, 130041, '\P{Category=number}', "");
    Expect(1, 130041, '\P{^Category=number}', "");
    Expect(0, 130042, '\p{Category=number}', "");
    Expect(1, 130042, '\p{^Category=number}', "");
    Expect(1, 130042, '\P{Category=number}', "");
    Expect(0, 130042, '\P{^Category=number}', "");
    Expect(1, 130041, '\p{Category=:\Anumber\z:}', "");;
    Expect(0, 130042, '\p{Category=:\Anumber\z:}', "");;
    Expect(1, 130041, '\p{Category=_	Number}', "");
    Expect(0, 130041, '\p{^Category=_	Number}', "");
    Expect(0, 130041, '\P{Category=_	Number}', "");
    Expect(1, 130041, '\P{^Category=_	Number}', "");
    Expect(0, 130042, '\p{Category=_	Number}', "");
    Expect(1, 130042, '\p{^Category=_	Number}', "");
    Expect(1, 130042, '\P{Category=_	Number}', "");
    Expect(0, 130042, '\P{^Category=_	Number}', "");
    Error('\p{Is_General_Category=/a/- N}');
    Error('\P{Is_General_Category=/a/- N}');
    Expect(1, 130041, '\p{Is_General_Category=n}', "");
    Expect(0, 130041, '\p{^Is_General_Category=n}', "");
    Expect(0, 130041, '\P{Is_General_Category=n}', "");
    Expect(1, 130041, '\P{^Is_General_Category=n}', "");
    Expect(0, 130042, '\p{Is_General_Category=n}', "");
    Expect(1, 130042, '\p{^Is_General_Category=n}', "");
    Expect(1, 130042, '\P{Is_General_Category=n}', "");
    Expect(0, 130042, '\P{^Is_General_Category=n}', "");
    Expect(1, 130041, '\p{Is_General_Category=		N}', "");
    Expect(0, 130041, '\p{^Is_General_Category=		N}', "");
    Expect(0, 130041, '\P{Is_General_Category=		N}', "");
    Expect(1, 130041, '\P{^Is_General_Category=		N}', "");
    Expect(0, 130042, '\p{Is_General_Category=		N}', "");
    Expect(1, 130042, '\p{^Is_General_Category=		N}', "");
    Expect(1, 130042, '\P{Is_General_Category=		N}', "");
    Expect(0, 130042, '\P{^Is_General_Category=		N}', "");
    Error('\p{Is_Gc=_ number:=}');
    Error('\P{Is_Gc=_ number:=}');
    Expect(1, 130041, '\p{Is_Gc=number}', "");
    Expect(0, 130041, '\p{^Is_Gc=number}', "");
    Expect(0, 130041, '\P{Is_Gc=number}', "");
    Expect(1, 130041, '\P{^Is_Gc=number}', "");
    Expect(0, 130042, '\p{Is_Gc=number}', "");
    Expect(1, 130042, '\p{^Is_Gc=number}', "");
    Expect(1, 130042, '\P{Is_Gc=number}', "");
    Expect(0, 130042, '\P{^Is_Gc=number}', "");
    Expect(1, 130041, '\p{Is_Gc=-Number}', "");
    Expect(0, 130041, '\p{^Is_Gc=-Number}', "");
    Expect(0, 130041, '\P{Is_Gc=-Number}', "");
    Expect(1, 130041, '\P{^Is_Gc=-Number}', "");
    Expect(0, 130042, '\p{Is_Gc=-Number}', "");
    Expect(1, 130042, '\p{^Is_Gc=-Number}', "");
    Expect(1, 130042, '\P{Is_Gc=-Number}', "");
    Expect(0, 130042, '\P{^Is_Gc=-Number}', "");
    Error('\p{Is_Category=	-n/a/}');
    Error('\P{Is_Category=	-n/a/}');
    Expect(1, 130041, '\p{Is_Category=n}', "");
    Expect(0, 130041, '\p{^Is_Category=n}', "");
    Expect(0, 130041, '\P{Is_Category=n}', "");
    Expect(1, 130041, '\P{^Is_Category=n}', "");
    Expect(0, 130042, '\p{Is_Category=n}', "");
    Expect(1, 130042, '\p{^Is_Category=n}', "");
    Expect(1, 130042, '\P{Is_Category=n}', "");
    Expect(0, 130042, '\P{^Is_Category=n}', "");
    Expect(1, 130041, '\p{Is_Category=_-N}', "");
    Expect(0, 130041, '\p{^Is_Category=_-N}', "");
    Expect(0, 130041, '\P{Is_Category=_-N}', "");
    Expect(1, 130041, '\P{^Is_Category=_-N}', "");
    Expect(0, 130042, '\p{Is_Category=_-N}', "");
    Expect(1, 130042, '\p{^Is_Category=_-N}', "");
    Expect(1, 130042, '\P{Is_Category=_-N}', "");
    Expect(0, 130042, '\P{^Is_Category=_-N}', "");
    Error('\p{General_Category=-:=Decimal_NUMBER}');
    Error('\P{General_Category=-:=Decimal_NUMBER}');
    Expect(1, 130041, '\p{General_Category=:\ADecimal_Number\z:}', "");;
    Expect(0, 130042, '\p{General_Category=:\ADecimal_Number\z:}', "");;
    Expect(1, 130041, '\p{General_Category=decimalnumber}', "");
    Expect(0, 130041, '\p{^General_Category=decimalnumber}', "");
    Expect(0, 130041, '\P{General_Category=decimalnumber}', "");
    Expect(1, 130041, '\P{^General_Category=decimalnumber}', "");
    Expect(0, 130042, '\p{General_Category=decimalnumber}', "");
    Expect(1, 130042, '\p{^General_Category=decimalnumber}', "");
    Expect(1, 130042, '\P{General_Category=decimalnumber}', "");
    Expect(0, 130042, '\P{^General_Category=decimalnumber}', "");
    Expect(1, 130041, '\p{General_Category=:\Adecimalnumber\z:}', "");;
    Expect(0, 130042, '\p{General_Category=:\Adecimalnumber\z:}', "");;
    Expect(1, 130041, '\p{General_Category= _DECIMAL_NUMBER}', "");
    Expect(0, 130041, '\p{^General_Category= _DECIMAL_NUMBER}', "");
    Expect(0, 130041, '\P{General_Category= _DECIMAL_NUMBER}', "");
    Expect(1, 130041, '\P{^General_Category= _DECIMAL_NUMBER}', "");
    Expect(0, 130042, '\p{General_Category= _DECIMAL_NUMBER}', "");
    Expect(1, 130042, '\p{^General_Category= _DECIMAL_NUMBER}', "");
    Expect(1, 130042, '\P{General_Category= _DECIMAL_NUMBER}', "");
    Expect(0, 130042, '\P{^General_Category= _DECIMAL_NUMBER}', "");
    Error('\p{Gc=:=Nd}');
    Error('\P{Gc=:=Nd}');
    Expect(1, 130041, '\p{Gc=:\ANd\z:}', "");;
    Expect(0, 130042, '\p{Gc=:\ANd\z:}', "");;
    Expect(1, 130041, '\p{Gc: nd}', "");
    Expect(0, 130041, '\p{^Gc: nd}', "");
    Expect(0, 130041, '\P{Gc: nd}', "");
    Expect(1, 130041, '\P{^Gc: nd}', "");
    Expect(0, 130042, '\p{Gc: nd}', "");
    Expect(1, 130042, '\p{^Gc: nd}', "");
    Expect(1, 130042, '\P{Gc: nd}', "");
    Expect(0, 130042, '\P{^Gc: nd}', "");
    Expect(1, 130041, '\p{Gc=:\And\z:}', "");;
    Expect(0, 130042, '\p{Gc=:\And\z:}', "");;
    Expect(1, 130041, '\p{Gc:   		Nd}', "");
    Expect(0, 130041, '\p{^Gc:   		Nd}', "");
    Expect(0, 130041, '\P{Gc:   		Nd}', "");
    Expect(1, 130041, '\P{^Gc:   		Nd}', "");
    Expect(0, 130042, '\p{Gc:   		Nd}', "");
    Expect(1, 130042, '\p{^Gc:   		Nd}', "");
    Expect(1, 130042, '\P{Gc:   		Nd}', "");
    Expect(0, 130042, '\P{^Gc:   		Nd}', "");
    Error('\p{Category=:=-Digit}');
    Error('\P{Category=:=-Digit}');
    Expect(1, 130041, '\p{Category=:\ADigit\z:}', "");;
    Expect(0, 130042, '\p{Category=:\ADigit\z:}', "");;
    Expect(1, 130041, '\p{Category=digit}', "");
    Expect(0, 130041, '\p{^Category=digit}', "");
    Expect(0, 130041, '\P{Category=digit}', "");
    Expect(1, 130041, '\P{^Category=digit}', "");
    Expect(0, 130042, '\p{Category=digit}', "");
    Expect(1, 130042, '\p{^Category=digit}', "");
    Expect(1, 130042, '\P{Category=digit}', "");
    Expect(0, 130042, '\P{^Category=digit}', "");
    Expect(1, 130041, '\p{Category=:\Adigit\z:}', "");;
    Expect(0, 130042, '\p{Category=:\Adigit\z:}', "");;
    Expect(1, 130041, '\p{Category=_Digit}', "");
    Expect(0, 130041, '\p{^Category=_Digit}', "");
    Expect(0, 130041, '\P{Category=_Digit}', "");
    Expect(1, 130041, '\P{^Category=_Digit}', "");
    Expect(0, 130042, '\p{Category=_Digit}', "");
    Expect(1, 130042, '\p{^Category=_Digit}', "");
    Expect(1, 130042, '\P{Category=_Digit}', "");
    Expect(0, 130042, '\P{^Category=_Digit}', "");
    Error('\p{Is_General_Category=_:=Decimal_Number}');
    Error('\P{Is_General_Category=_:=Decimal_Number}');
    Expect(1, 130041, '\p{Is_General_Category: decimalnumber}', "");
    Expect(0, 130041, '\p{^Is_General_Category: decimalnumber}', "");
    Expect(0, 130041, '\P{Is_General_Category: decimalnumber}', "");
    Expect(1, 130041, '\P{^Is_General_Category: decimalnumber}', "");
    Expect(0, 130042, '\p{Is_General_Category: decimalnumber}', "");
    Expect(1, 130042, '\p{^Is_General_Category: decimalnumber}', "");
    Expect(1, 130042, '\P{Is_General_Category: decimalnumber}', "");
    Expect(0, 130042, '\P{^Is_General_Category: decimalnumber}', "");
    Expect(1, 130041, '\p{Is_General_Category:		decimal_Number}', "");
    Expect(0, 130041, '\p{^Is_General_Category:		decimal_Number}', "");
    Expect(0, 130041, '\P{Is_General_Category:		decimal_Number}', "");
    Expect(1, 130041, '\P{^Is_General_Category:		decimal_Number}', "");
    Expect(0, 130042, '\p{Is_General_Category:		decimal_Number}', "");
    Expect(1, 130042, '\p{^Is_General_Category:		decimal_Number}', "");
    Expect(1, 130042, '\P{Is_General_Category:		decimal_Number}', "");
    Expect(0, 130042, '\P{^Is_General_Category:		decimal_Number}', "");
    Error('\p{Is_Gc= Nd:=}');
    Error('\P{Is_Gc= Nd:=}');
    Expect(1, 130041, '\p{Is_Gc=nd}', "");
    Expect(0, 130041, '\p{^Is_Gc=nd}', "");
    Expect(0, 130041, '\P{Is_Gc=nd}', "");
    Expect(1, 130041, '\P{^Is_Gc=nd}', "");
    Expect(0, 130042, '\p{Is_Gc=nd}', "");
    Expect(1, 130042, '\p{^Is_Gc=nd}', "");
    Expect(1, 130042, '\P{Is_Gc=nd}', "");
    Expect(0, 130042, '\P{^Is_Gc=nd}', "");
    Expect(1, 130041, '\p{Is_Gc= Nd}', "");
    Expect(0, 130041, '\p{^Is_Gc= Nd}', "");
    Expect(0, 130041, '\P{Is_Gc= Nd}', "");
    Expect(1, 130041, '\P{^Is_Gc= Nd}', "");
    Expect(0, 130042, '\p{Is_Gc= Nd}', "");
    Expect(1, 130042, '\p{^Is_Gc= Nd}', "");
    Expect(1, 130042, '\P{Is_Gc= Nd}', "");
    Expect(0, 130042, '\P{^Is_Gc= Nd}', "");
    Error('\p{Is_Category=_ Digit:=}');
    Error('\P{Is_Category=_ Digit:=}');
    Expect(1, 130041, '\p{Is_Category=digit}', "");
    Expect(0, 130041, '\p{^Is_Category=digit}', "");
    Expect(0, 130041, '\P{Is_Category=digit}', "");
    Expect(1, 130041, '\P{^Is_Category=digit}', "");
    Expect(0, 130042, '\p{Is_Category=digit}', "");
    Expect(1, 130042, '\p{^Is_Category=digit}', "");
    Expect(1, 130042, '\P{Is_Category=digit}', "");
    Expect(0, 130042, '\P{^Is_Category=digit}', "");
    Expect(1, 130041, '\p{Is_Category=  Digit}', "");
    Expect(0, 130041, '\p{^Is_Category=  Digit}', "");
    Expect(0, 130041, '\P{Is_Category=  Digit}', "");
    Expect(1, 130041, '\P{^Is_Category=  Digit}', "");
    Expect(0, 130042, '\p{Is_Category=  Digit}', "");
    Expect(1, 130042, '\p{^Is_Category=  Digit}', "");
    Expect(1, 130042, '\P{Is_Category=  Digit}', "");
    Expect(0, 130042, '\P{^Is_Category=  Digit}', "");
    Error('\p{General_Category=_/a/Letter_Number}');
    Error('\P{General_Category=_/a/Letter_Number}');
    Expect(1, 74862, '\p{General_Category=:\ALetter_Number\z:}', "");;
    Expect(0, 74863, '\p{General_Category=:\ALetter_Number\z:}', "");;
    Expect(1, 74862, '\p{General_Category=letternumber}', "");
    Expect(0, 74862, '\p{^General_Category=letternumber}', "");
    Expect(0, 74862, '\P{General_Category=letternumber}', "");
    Expect(1, 74862, '\P{^General_Category=letternumber}', "");
    Expect(0, 74863, '\p{General_Category=letternumber}', "");
    Expect(1, 74863, '\p{^General_Category=letternumber}', "");
    Expect(1, 74863, '\P{General_Category=letternumber}', "");
    Expect(0, 74863, '\P{^General_Category=letternumber}', "");
    Expect(1, 74862, '\p{General_Category=:\Aletternumber\z:}', "");;
    Expect(0, 74863, '\p{General_Category=:\Aletternumber\z:}', "");;
    Expect(1, 74862, '\p{General_Category:_letter_NUMBER}', "");
    Expect(0, 74862, '\p{^General_Category:_letter_NUMBER}', "");
    Expect(0, 74862, '\P{General_Category:_letter_NUMBER}', "");
    Expect(1, 74862, '\P{^General_Category:_letter_NUMBER}', "");
    Expect(0, 74863, '\p{General_Category:_letter_NUMBER}', "");
    Expect(1, 74863, '\p{^General_Category:_letter_NUMBER}', "");
    Expect(1, 74863, '\P{General_Category:_letter_NUMBER}', "");
    Expect(0, 74863, '\P{^General_Category:_letter_NUMBER}', "");
    Error('\p{Gc=-:=nl}');
    Error('\P{Gc=-:=nl}');
    Expect(1, 74862, '\p{Gc=:\ANl\z:}', "");;
    Expect(0, 74863, '\p{Gc=:\ANl\z:}', "");;
    Expect(1, 74862, '\p{Gc=nl}', "");
    Expect(0, 74862, '\p{^Gc=nl}', "");
    Expect(0, 74862, '\P{Gc=nl}', "");
    Expect(1, 74862, '\P{^Gc=nl}', "");
    Expect(0, 74863, '\p{Gc=nl}', "");
    Expect(1, 74863, '\p{^Gc=nl}', "");
    Expect(1, 74863, '\P{Gc=nl}', "");
    Expect(0, 74863, '\P{^Gc=nl}', "");
    Expect(1, 74862, '\p{Gc=:\Anl\z:}', "");;
    Expect(0, 74863, '\p{Gc=:\Anl\z:}', "");;
    Expect(1, 74862, '\p{Gc=	Nl}', "");
    Expect(0, 74862, '\p{^Gc=	Nl}', "");
    Expect(0, 74862, '\P{Gc=	Nl}', "");
    Expect(1, 74862, '\P{^Gc=	Nl}', "");
    Expect(0, 74863, '\p{Gc=	Nl}', "");
    Expect(1, 74863, '\p{^Gc=	Nl}', "");
    Expect(1, 74863, '\P{Gc=	Nl}', "");
    Expect(0, 74863, '\P{^Gc=	Nl}', "");
    Error('\p{Category=_ Letter_Number:=}');
    Error('\P{Category=_ Letter_Number:=}');
    Expect(1, 74862, '\p{Category=:\ALetter_Number\z:}', "");;
    Expect(0, 74863, '\p{Category=:\ALetter_Number\z:}', "");;
    Expect(1, 74862, '\p{Category=letternumber}', "");
    Expect(0, 74862, '\p{^Category=letternumber}', "");
    Expect(0, 74862, '\P{Category=letternumber}', "");
    Expect(1, 74862, '\P{^Category=letternumber}', "");
    Expect(0, 74863, '\p{Category=letternumber}', "");
    Expect(1, 74863, '\p{^Category=letternumber}', "");
    Expect(1, 74863, '\P{Category=letternumber}', "");
    Expect(0, 74863, '\P{^Category=letternumber}', "");
    Expect(1, 74862, '\p{Category=:\Aletternumber\z:}', "");;
    Expect(0, 74863, '\p{Category=:\Aletternumber\z:}', "");;
    Expect(1, 74862, '\p{Category:	_ letter_Number}', "");
    Expect(0, 74862, '\p{^Category:	_ letter_Number}', "");
    Expect(0, 74862, '\P{Category:	_ letter_Number}', "");
    Expect(1, 74862, '\P{^Category:	_ letter_Number}', "");
    Expect(0, 74863, '\p{Category:	_ letter_Number}', "");
    Expect(1, 74863, '\p{^Category:	_ letter_Number}', "");
    Expect(1, 74863, '\P{Category:	_ letter_Number}', "");
    Expect(0, 74863, '\P{^Category:	_ letter_Number}', "");
    Error('\p{Is_General_Category= 	NL:=}');
    Error('\P{Is_General_Category= 	NL:=}');
    Expect(1, 74862, '\p{Is_General_Category=nl}', "");
    Expect(0, 74862, '\p{^Is_General_Category=nl}', "");
    Expect(0, 74862, '\P{Is_General_Category=nl}', "");
    Expect(1, 74862, '\P{^Is_General_Category=nl}', "");
    Expect(0, 74863, '\p{Is_General_Category=nl}', "");
    Expect(1, 74863, '\p{^Is_General_Category=nl}', "");
    Expect(1, 74863, '\P{Is_General_Category=nl}', "");
    Expect(0, 74863, '\P{^Is_General_Category=nl}', "");
    Expect(1, 74862, '\p{Is_General_Category=_Nl}', "");
    Expect(0, 74862, '\p{^Is_General_Category=_Nl}', "");
    Expect(0, 74862, '\P{Is_General_Category=_Nl}', "");
    Expect(1, 74862, '\P{^Is_General_Category=_Nl}', "");
    Expect(0, 74863, '\p{Is_General_Category=_Nl}', "");
    Expect(1, 74863, '\p{^Is_General_Category=_Nl}', "");
    Expect(1, 74863, '\P{Is_General_Category=_Nl}', "");
    Expect(0, 74863, '\P{^Is_General_Category=_Nl}', "");
    Error('\p{Is_Gc: -:=letter_Number}');
    Error('\P{Is_Gc: -:=letter_Number}');
    Expect(1, 74862, '\p{Is_Gc=letternumber}', "");
    Expect(0, 74862, '\p{^Is_Gc=letternumber}', "");
    Expect(0, 74862, '\P{Is_Gc=letternumber}', "");
    Expect(1, 74862, '\P{^Is_Gc=letternumber}', "");
    Expect(0, 74863, '\p{Is_Gc=letternumber}', "");
    Expect(1, 74863, '\p{^Is_Gc=letternumber}', "");
    Expect(1, 74863, '\P{Is_Gc=letternumber}', "");
    Expect(0, 74863, '\P{^Is_Gc=letternumber}', "");
    Expect(1, 74862, '\p{Is_Gc=	_letter_Number}', "");
    Expect(0, 74862, '\p{^Is_Gc=	_letter_Number}', "");
    Expect(0, 74862, '\P{Is_Gc=	_letter_Number}', "");
    Expect(1, 74862, '\P{^Is_Gc=	_letter_Number}', "");
    Expect(0, 74863, '\p{Is_Gc=	_letter_Number}', "");
    Expect(1, 74863, '\p{^Is_Gc=	_letter_Number}', "");
    Expect(1, 74863, '\P{Is_Gc=	_letter_Number}', "");
    Expect(0, 74863, '\P{^Is_Gc=	_letter_Number}', "");
    Error('\p{Is_Category=_:=nl}');
    Error('\P{Is_Category=_:=nl}');
    Expect(1, 74862, '\p{Is_Category=nl}', "");
    Expect(0, 74862, '\p{^Is_Category=nl}', "");
    Expect(0, 74862, '\P{Is_Category=nl}', "");
    Expect(1, 74862, '\P{^Is_Category=nl}', "");
    Expect(0, 74863, '\p{Is_Category=nl}', "");
    Expect(1, 74863, '\p{^Is_Category=nl}', "");
    Expect(1, 74863, '\P{Is_Category=nl}', "");
    Expect(0, 74863, '\P{^Is_Category=nl}', "");
    Expect(1, 74862, '\p{Is_Category=	-NL}', "");
    Expect(0, 74862, '\p{^Is_Category=	-NL}', "");
    Expect(0, 74862, '\P{Is_Category=	-NL}', "");
    Expect(1, 74862, '\P{^Is_Category=	-NL}', "");
    Expect(0, 74863, '\p{Is_Category=	-NL}', "");
    Expect(1, 74863, '\p{^Is_Category=	-NL}', "");
    Expect(1, 74863, '\P{Is_Category=	-NL}', "");
    Expect(0, 74863, '\P{^Is_Category=	-NL}', "");
    Error('\p{General_Category=-Other_NUMBER:=}');
    Error('\P{General_Category=-Other_NUMBER:=}');
    Expect(1, 127244, '\p{General_Category=:\AOther_Number\z:}', "");;
    Expect(0, 127245, '\p{General_Category=:\AOther_Number\z:}', "");;
    Expect(1, 127244, '\p{General_Category=othernumber}', "");
    Expect(0, 127244, '\p{^General_Category=othernumber}', "");
    Expect(0, 127244, '\P{General_Category=othernumber}', "");
    Expect(1, 127244, '\P{^General_Category=othernumber}', "");
    Expect(0, 127245, '\p{General_Category=othernumber}', "");
    Expect(1, 127245, '\p{^General_Category=othernumber}', "");
    Expect(1, 127245, '\P{General_Category=othernumber}', "");
    Expect(0, 127245, '\P{^General_Category=othernumber}', "");
    Expect(1, 127244, '\p{General_Category=:\Aothernumber\z:}', "");;
    Expect(0, 127245, '\p{General_Category=:\Aothernumber\z:}', "");;
    Expect(1, 127244, '\p{General_Category:	_ other_number}', "");
    Expect(0, 127244, '\p{^General_Category:	_ other_number}', "");
    Expect(0, 127244, '\P{General_Category:	_ other_number}', "");
    Expect(1, 127244, '\P{^General_Category:	_ other_number}', "");
    Expect(0, 127245, '\p{General_Category:	_ other_number}', "");
    Expect(1, 127245, '\p{^General_Category:	_ other_number}', "");
    Expect(1, 127245, '\P{General_Category:	_ other_number}', "");
    Expect(0, 127245, '\P{^General_Category:	_ other_number}', "");
    Error('\p{Gc:/a/		NO}');
    Error('\P{Gc:/a/		NO}');
    Expect(1, 127244, '\p{Gc=:\ANo\z:}', "");;
    Expect(0, 127245, '\p{Gc=:\ANo\z:}', "");;
    Expect(1, 127244, '\p{Gc=no}', "");
    Expect(0, 127244, '\p{^Gc=no}', "");
    Expect(0, 127244, '\P{Gc=no}', "");
    Expect(1, 127244, '\P{^Gc=no}', "");
    Expect(0, 127245, '\p{Gc=no}', "");
    Expect(1, 127245, '\p{^Gc=no}', "");
    Expect(1, 127245, '\P{Gc=no}', "");
    Expect(0, 127245, '\P{^Gc=no}', "");
    Expect(1, 127244, '\p{Gc=:\Ano\z:}', "");;
    Expect(0, 127245, '\p{Gc=:\Ano\z:}', "");;
    Expect(1, 127244, '\p{Gc=-_no}', "");
    Expect(0, 127244, '\p{^Gc=-_no}', "");
    Expect(0, 127244, '\P{Gc=-_no}', "");
    Expect(1, 127244, '\P{^Gc=-_no}', "");
    Expect(0, 127245, '\p{Gc=-_no}', "");
    Expect(1, 127245, '\p{^Gc=-_no}', "");
    Expect(1, 127245, '\P{Gc=-_no}', "");
    Expect(0, 127245, '\P{^Gc=-_no}', "");
    Error('\p{Category=	-other_Number/a/}');
    Error('\P{Category=	-other_Number/a/}');
    Expect(1, 127244, '\p{Category=:\AOther_Number\z:}', "");;
    Expect(0, 127245, '\p{Category=:\AOther_Number\z:}', "");;
    Expect(1, 127244, '\p{Category=othernumber}', "");
    Expect(0, 127244, '\p{^Category=othernumber}', "");
    Expect(0, 127244, '\P{Category=othernumber}', "");
    Expect(1, 127244, '\P{^Category=othernumber}', "");
    Expect(0, 127245, '\p{Category=othernumber}', "");
    Expect(1, 127245, '\p{^Category=othernumber}', "");
    Expect(1, 127245, '\P{Category=othernumber}', "");
    Expect(0, 127245, '\P{^Category=othernumber}', "");
    Expect(1, 127244, '\p{Category=:\Aothernumber\z:}', "");;
    Expect(0, 127245, '\p{Category=:\Aothernumber\z:}', "");;
    Expect(1, 127244, '\p{Category=_Other_Number}', "");
    Expect(0, 127244, '\p{^Category=_Other_Number}', "");
    Expect(0, 127244, '\P{Category=_Other_Number}', "");
    Expect(1, 127244, '\P{^Category=_Other_Number}', "");
    Expect(0, 127245, '\p{Category=_Other_Number}', "");
    Expect(1, 127245, '\p{^Category=_Other_Number}', "");
    Expect(1, 127245, '\P{Category=_Other_Number}', "");
    Expect(0, 127245, '\P{^Category=_Other_Number}', "");
    Error('\p{Is_General_Category=:=-No}');
    Error('\P{Is_General_Category=:=-No}');
    Expect(1, 127244, '\p{Is_General_Category=no}', "");
    Expect(0, 127244, '\p{^Is_General_Category=no}', "");
    Expect(0, 127244, '\P{Is_General_Category=no}', "");
    Expect(1, 127244, '\P{^Is_General_Category=no}', "");
    Expect(0, 127245, '\p{Is_General_Category=no}', "");
    Expect(1, 127245, '\p{^Is_General_Category=no}', "");
    Expect(1, 127245, '\P{Is_General_Category=no}', "");
    Expect(0, 127245, '\P{^Is_General_Category=no}', "");
    Expect(1, 127244, '\p{Is_General_Category=_NO}', "");
    Expect(0, 127244, '\p{^Is_General_Category=_NO}', "");
    Expect(0, 127244, '\P{Is_General_Category=_NO}', "");
    Expect(1, 127244, '\P{^Is_General_Category=_NO}', "");
    Expect(0, 127245, '\p{Is_General_Category=_NO}', "");
    Expect(1, 127245, '\p{^Is_General_Category=_NO}', "");
    Expect(1, 127245, '\P{Is_General_Category=_NO}', "");
    Expect(0, 127245, '\P{^Is_General_Category=_NO}', "");
    Error('\p{Is_Gc=	Other_NUMBER:=}');
    Error('\P{Is_Gc=	Other_NUMBER:=}');
    Expect(1, 127244, '\p{Is_Gc=othernumber}', "");
    Expect(0, 127244, '\p{^Is_Gc=othernumber}', "");
    Expect(0, 127244, '\P{Is_Gc=othernumber}', "");
    Expect(1, 127244, '\P{^Is_Gc=othernumber}', "");
    Expect(0, 127245, '\p{Is_Gc=othernumber}', "");
    Expect(1, 127245, '\p{^Is_Gc=othernumber}', "");
    Expect(1, 127245, '\P{Is_Gc=othernumber}', "");
    Expect(0, 127245, '\P{^Is_Gc=othernumber}', "");
    Expect(1, 127244, '\p{Is_Gc=	other_Number}', "");
    Expect(0, 127244, '\p{^Is_Gc=	other_Number}', "");
    Expect(0, 127244, '\P{Is_Gc=	other_Number}', "");
    Expect(1, 127244, '\P{^Is_Gc=	other_Number}', "");
    Expect(0, 127245, '\p{Is_Gc=	other_Number}', "");
    Expect(1, 127245, '\p{^Is_Gc=	other_Number}', "");
    Expect(1, 127245, '\P{Is_Gc=	other_Number}', "");
    Expect(0, 127245, '\P{^Is_Gc=	other_Number}', "");
    Error('\p{Is_Category=-_No/a/}');
    Error('\P{Is_Category=-_No/a/}');
    Expect(1, 127244, '\p{Is_Category=no}', "");
    Expect(0, 127244, '\p{^Is_Category=no}', "");
    Expect(0, 127244, '\P{Is_Category=no}', "");
    Expect(1, 127244, '\P{^Is_Category=no}', "");
    Expect(0, 127245, '\p{Is_Category=no}', "");
    Expect(1, 127245, '\p{^Is_Category=no}', "");
    Expect(1, 127245, '\P{Is_Category=no}', "");
    Expect(0, 127245, '\P{^Is_Category=no}', "");
    Expect(1, 127244, '\p{Is_Category=	-no}', "");
    Expect(0, 127244, '\p{^Is_Category=	-no}', "");
    Expect(0, 127244, '\P{Is_Category=	-no}', "");
    Expect(1, 127244, '\P{^Is_Category=	-no}', "");
    Expect(0, 127245, '\p{Is_Category=	-no}', "");
    Expect(1, 127245, '\p{^Is_Category=	-no}', "");
    Expect(1, 127245, '\P{Is_Category=	-no}', "");
    Expect(0, 127245, '\P{^Is_Category=	-no}', "");
    Error('\p{General_Category=:= punctuation}');
    Error('\P{General_Category=:= punctuation}');
    Expect(1, 125279, '\p{General_Category=:\APunctuation\z:}', "");;
    Expect(0, 125280, '\p{General_Category=:\APunctuation\z:}', "");;
    Expect(1, 125279, '\p{General_Category=punctuation}', "");
    Expect(0, 125279, '\p{^General_Category=punctuation}', "");
    Expect(0, 125279, '\P{General_Category=punctuation}', "");
    Expect(1, 125279, '\P{^General_Category=punctuation}', "");
    Expect(0, 125280, '\p{General_Category=punctuation}', "");
    Expect(1, 125280, '\p{^General_Category=punctuation}', "");
    Expect(1, 125280, '\P{General_Category=punctuation}', "");
    Expect(0, 125280, '\P{^General_Category=punctuation}', "");
    Expect(1, 125279, '\p{General_Category=:\Apunctuation\z:}', "");;
    Expect(0, 125280, '\p{General_Category=:\Apunctuation\z:}', "");;
    Expect(1, 125279, '\p{General_Category= _Punctuation}', "");
    Expect(0, 125279, '\p{^General_Category= _Punctuation}', "");
    Expect(0, 125279, '\P{General_Category= _Punctuation}', "");
    Expect(1, 125279, '\P{^General_Category= _Punctuation}', "");
    Expect(0, 125280, '\p{General_Category= _Punctuation}', "");
    Expect(1, 125280, '\p{^General_Category= _Punctuation}', "");
    Expect(1, 125280, '\P{General_Category= _Punctuation}', "");
    Expect(0, 125280, '\P{^General_Category= _Punctuation}', "");
    Error('\p{Gc=:=P}');
    Error('\P{Gc=:=P}');
    Expect(1, 125279, '\p{Gc=:\AP\z:}', "");;
    Expect(0, 125280, '\p{Gc=:\AP\z:}', "");;
    Expect(1, 125279, '\p{Gc=p}', "");
    Expect(0, 125279, '\p{^Gc=p}', "");
    Expect(0, 125279, '\P{Gc=p}', "");
    Expect(1, 125279, '\P{^Gc=p}', "");
    Expect(0, 125280, '\p{Gc=p}', "");
    Expect(1, 125280, '\p{^Gc=p}', "");
    Expect(1, 125280, '\P{Gc=p}', "");
    Expect(0, 125280, '\P{^Gc=p}', "");
    Expect(1, 125279, '\p{Gc=:\Ap\z:}', "");;
    Expect(0, 125280, '\p{Gc=:\Ap\z:}', "");;
    Expect(1, 125279, '\p{Gc=-P}', "");
    Expect(0, 125279, '\p{^Gc=-P}', "");
    Expect(0, 125279, '\P{Gc=-P}', "");
    Expect(1, 125279, '\P{^Gc=-P}', "");
    Expect(0, 125280, '\p{Gc=-P}', "");
    Expect(1, 125280, '\p{^Gc=-P}', "");
    Expect(1, 125280, '\P{Gc=-P}', "");
    Expect(0, 125280, '\P{^Gc=-P}', "");
    Error('\p{Category=:=PUNCT}');
    Error('\P{Category=:=PUNCT}');
    Expect(1, 125279, '\p{Category=:\APunct\z:}', "");;
    Expect(0, 125280, '\p{Category=:\APunct\z:}', "");;
    Expect(1, 125279, '\p{Category=punct}', "");
    Expect(0, 125279, '\p{^Category=punct}', "");
    Expect(0, 125279, '\P{Category=punct}', "");
    Expect(1, 125279, '\P{^Category=punct}', "");
    Expect(0, 125280, '\p{Category=punct}', "");
    Expect(1, 125280, '\p{^Category=punct}', "");
    Expect(1, 125280, '\P{Category=punct}', "");
    Expect(0, 125280, '\P{^Category=punct}', "");
    Expect(1, 125279, '\p{Category=:\Apunct\z:}', "");;
    Expect(0, 125280, '\p{Category=:\Apunct\z:}', "");;
    Expect(1, 125279, '\p{Category=-	Punct}', "");
    Expect(0, 125279, '\p{^Category=-	Punct}', "");
    Expect(0, 125279, '\P{Category=-	Punct}', "");
    Expect(1, 125279, '\P{^Category=-	Punct}', "");
    Expect(0, 125280, '\p{Category=-	Punct}', "");
    Expect(1, 125280, '\p{^Category=-	Punct}', "");
    Expect(1, 125280, '\P{Category=-	Punct}', "");
    Expect(0, 125280, '\P{^Category=-	Punct}', "");
    Error('\p{Is_General_Category=_ punctuation/a/}');
    Error('\P{Is_General_Category=_ punctuation/a/}');
    Expect(1, 125279, '\p{Is_General_Category=punctuation}', "");
    Expect(0, 125279, '\p{^Is_General_Category=punctuation}', "");
    Expect(0, 125279, '\P{Is_General_Category=punctuation}', "");
    Expect(1, 125279, '\P{^Is_General_Category=punctuation}', "");
    Expect(0, 125280, '\p{Is_General_Category=punctuation}', "");
    Expect(1, 125280, '\p{^Is_General_Category=punctuation}', "");
    Expect(1, 125280, '\P{Is_General_Category=punctuation}', "");
    Expect(0, 125280, '\P{^Is_General_Category=punctuation}', "");
    Expect(1, 125279, '\p{Is_General_Category=	_punctuation}', "");
    Expect(0, 125279, '\p{^Is_General_Category=	_punctuation}', "");
    Expect(0, 125279, '\P{Is_General_Category=	_punctuation}', "");
    Expect(1, 125279, '\P{^Is_General_Category=	_punctuation}', "");
    Expect(0, 125280, '\p{Is_General_Category=	_punctuation}', "");
    Expect(1, 125280, '\p{^Is_General_Category=	_punctuation}', "");
    Expect(1, 125280, '\P{Is_General_Category=	_punctuation}', "");
    Expect(0, 125280, '\P{^Is_General_Category=	_punctuation}', "");
    Error('\p{Is_Gc=:=P}');
    Error('\P{Is_Gc=:=P}');
    Expect(1, 125279, '\p{Is_Gc=p}', "");
    Expect(0, 125279, '\p{^Is_Gc=p}', "");
    Expect(0, 125279, '\P{Is_Gc=p}', "");
    Expect(1, 125279, '\P{^Is_Gc=p}', "");
    Expect(0, 125280, '\p{Is_Gc=p}', "");
    Expect(1, 125280, '\p{^Is_Gc=p}', "");
    Expect(1, 125280, '\P{Is_Gc=p}', "");
    Expect(0, 125280, '\P{^Is_Gc=p}', "");
    Expect(1, 125279, '\p{Is_Gc=_ P}', "");
    Expect(0, 125279, '\p{^Is_Gc=_ P}', "");
    Expect(0, 125279, '\P{Is_Gc=_ P}', "");
    Expect(1, 125279, '\P{^Is_Gc=_ P}', "");
    Expect(0, 125280, '\p{Is_Gc=_ P}', "");
    Expect(1, 125280, '\p{^Is_Gc=_ P}', "");
    Expect(1, 125280, '\P{Is_Gc=_ P}', "");
    Expect(0, 125280, '\P{^Is_Gc=_ P}', "");
    Error('\p{Is_Category=:=punct}');
    Error('\P{Is_Category=:=punct}');
    Expect(1, 125279, '\p{Is_Category:punct}', "");
    Expect(0, 125279, '\p{^Is_Category:punct}', "");
    Expect(0, 125279, '\P{Is_Category:punct}', "");
    Expect(1, 125279, '\P{^Is_Category:punct}', "");
    Expect(0, 125280, '\p{Is_Category:punct}', "");
    Expect(1, 125280, '\p{^Is_Category:punct}', "");
    Expect(1, 125280, '\P{Is_Category:punct}', "");
    Expect(0, 125280, '\P{^Is_Category:punct}', "");
    Expect(1, 125279, '\p{Is_Category=_-PUNCT}', "");
    Expect(0, 125279, '\p{^Is_Category=_-PUNCT}', "");
    Expect(0, 125279, '\P{Is_Category=_-PUNCT}', "");
    Expect(1, 125279, '\P{^Is_Category=_-PUNCT}', "");
    Expect(0, 125280, '\p{Is_Category=_-PUNCT}', "");
    Expect(1, 125280, '\p{^Is_Category=_-PUNCT}', "");
    Expect(1, 125280, '\P{Is_Category=_-PUNCT}', "");
    Expect(0, 125280, '\P{^Is_Category=_-PUNCT}', "");
    Error('\p{General_Category:	-:=Connector_punctuation}');
    Error('\P{General_Category:	-:=Connector_punctuation}');
    Expect(1, 65343, '\p{General_Category=:\AConnector_Punctuation\z:}', "");;
    Expect(0, 65344, '\p{General_Category=:\AConnector_Punctuation\z:}', "");;
    Expect(1, 65343, '\p{General_Category:   connectorpunctuation}', "");
    Expect(0, 65343, '\p{^General_Category:   connectorpunctuation}', "");
    Expect(0, 65343, '\P{General_Category:   connectorpunctuation}', "");
    Expect(1, 65343, '\P{^General_Category:   connectorpunctuation}', "");
    Expect(0, 65344, '\p{General_Category:   connectorpunctuation}', "");
    Expect(1, 65344, '\p{^General_Category:   connectorpunctuation}', "");
    Expect(1, 65344, '\P{General_Category:   connectorpunctuation}', "");
    Expect(0, 65344, '\P{^General_Category:   connectorpunctuation}', "");
    Expect(1, 65343, '\p{General_Category=:\Aconnectorpunctuation\z:}', "");;
    Expect(0, 65344, '\p{General_Category=:\Aconnectorpunctuation\z:}', "");;
    Expect(1, 65343, '\p{General_Category=-	Connector_punctuation}', "");
    Expect(0, 65343, '\p{^General_Category=-	Connector_punctuation}', "");
    Expect(0, 65343, '\P{General_Category=-	Connector_punctuation}', "");
    Expect(1, 65343, '\P{^General_Category=-	Connector_punctuation}', "");
    Expect(0, 65344, '\p{General_Category=-	Connector_punctuation}', "");
    Expect(1, 65344, '\p{^General_Category=-	Connector_punctuation}', "");
    Expect(1, 65344, '\P{General_Category=-	Connector_punctuation}', "");
    Expect(0, 65344, '\P{^General_Category=-	Connector_punctuation}', "");
    Error('\p{Gc= /a/PC}');
    Error('\P{Gc= /a/PC}');
    Expect(1, 65343, '\p{Gc=:\APc\z:}', "");;
    Expect(0, 65344, '\p{Gc=:\APc\z:}', "");;
    Expect(1, 65343, '\p{Gc=pc}', "");
    Expect(0, 65343, '\p{^Gc=pc}', "");
    Expect(0, 65343, '\P{Gc=pc}', "");
    Expect(1, 65343, '\P{^Gc=pc}', "");
    Expect(0, 65344, '\p{Gc=pc}', "");
    Expect(1, 65344, '\p{^Gc=pc}', "");
    Expect(1, 65344, '\P{Gc=pc}', "");
    Expect(0, 65344, '\P{^Gc=pc}', "");
    Expect(1, 65343, '\p{Gc=:\Apc\z:}', "");;
    Expect(0, 65344, '\p{Gc=:\Apc\z:}', "");;
    Expect(1, 65343, '\p{Gc=_-Pc}', "");
    Expect(0, 65343, '\p{^Gc=_-Pc}', "");
    Expect(0, 65343, '\P{Gc=_-Pc}', "");
    Expect(1, 65343, '\P{^Gc=_-Pc}', "");
    Expect(0, 65344, '\p{Gc=_-Pc}', "");
    Expect(1, 65344, '\p{^Gc=_-Pc}', "");
    Expect(1, 65344, '\P{Gc=_-Pc}', "");
    Expect(0, 65344, '\P{^Gc=_-Pc}', "");
    Error('\p{Category= -Connector_punctuation:=}');
    Error('\P{Category= -Connector_punctuation:=}');
    Expect(1, 65343, '\p{Category=:\AConnector_Punctuation\z:}', "");;
    Expect(0, 65344, '\p{Category=:\AConnector_Punctuation\z:}', "");;
    Expect(1, 65343, '\p{Category:   connectorpunctuation}', "");
    Expect(0, 65343, '\p{^Category:   connectorpunctuation}', "");
    Expect(0, 65343, '\P{Category:   connectorpunctuation}', "");
    Expect(1, 65343, '\P{^Category:   connectorpunctuation}', "");
    Expect(0, 65344, '\p{Category:   connectorpunctuation}', "");
    Expect(1, 65344, '\p{^Category:   connectorpunctuation}', "");
    Expect(1, 65344, '\P{Category:   connectorpunctuation}', "");
    Expect(0, 65344, '\P{^Category:   connectorpunctuation}', "");
    Expect(1, 65343, '\p{Category=:\Aconnectorpunctuation\z:}', "");;
    Expect(0, 65344, '\p{Category=:\Aconnectorpunctuation\z:}', "");;
    Expect(1, 65343, '\p{Category=--CONNECTOR_PUNCTUATION}', "");
    Expect(0, 65343, '\p{^Category=--CONNECTOR_PUNCTUATION}', "");
    Expect(0, 65343, '\P{Category=--CONNECTOR_PUNCTUATION}', "");
    Expect(1, 65343, '\P{^Category=--CONNECTOR_PUNCTUATION}', "");
    Expect(0, 65344, '\p{Category=--CONNECTOR_PUNCTUATION}', "");
    Expect(1, 65344, '\p{^Category=--CONNECTOR_PUNCTUATION}', "");
    Expect(1, 65344, '\P{Category=--CONNECTOR_PUNCTUATION}', "");
    Expect(0, 65344, '\P{^Category=--CONNECTOR_PUNCTUATION}', "");
    Error('\p{Is_General_Category: -:=Pc}');
    Error('\P{Is_General_Category: -:=Pc}');
    Expect(1, 65343, '\p{Is_General_Category=pc}', "");
    Expect(0, 65343, '\p{^Is_General_Category=pc}', "");
    Expect(0, 65343, '\P{Is_General_Category=pc}', "");
    Expect(1, 65343, '\P{^Is_General_Category=pc}', "");
    Expect(0, 65344, '\p{Is_General_Category=pc}', "");
    Expect(1, 65344, '\p{^Is_General_Category=pc}', "");
    Expect(1, 65344, '\P{Is_General_Category=pc}', "");
    Expect(0, 65344, '\P{^Is_General_Category=pc}', "");
    Expect(1, 65343, '\p{Is_General_Category:   _PC}', "");
    Expect(0, 65343, '\p{^Is_General_Category:   _PC}', "");
    Expect(0, 65343, '\P{Is_General_Category:   _PC}', "");
    Expect(1, 65343, '\P{^Is_General_Category:   _PC}', "");
    Expect(0, 65344, '\p{Is_General_Category:   _PC}', "");
    Expect(1, 65344, '\p{^Is_General_Category:   _PC}', "");
    Expect(1, 65344, '\P{Is_General_Category:   _PC}', "");
    Expect(0, 65344, '\P{^Is_General_Category:   _PC}', "");
    Error('\p{Is_Gc:   :=-CONNECTOR_Punctuation}');
    Error('\P{Is_Gc:   :=-CONNECTOR_Punctuation}');
    Expect(1, 65343, '\p{Is_Gc=connectorpunctuation}', "");
    Expect(0, 65343, '\p{^Is_Gc=connectorpunctuation}', "");
    Expect(0, 65343, '\P{Is_Gc=connectorpunctuation}', "");
    Expect(1, 65343, '\P{^Is_Gc=connectorpunctuation}', "");
    Expect(0, 65344, '\p{Is_Gc=connectorpunctuation}', "");
    Expect(1, 65344, '\p{^Is_Gc=connectorpunctuation}', "");
    Expect(1, 65344, '\P{Is_Gc=connectorpunctuation}', "");
    Expect(0, 65344, '\P{^Is_Gc=connectorpunctuation}', "");
    Expect(1, 65343, '\p{Is_Gc=_Connector_PUNCTUATION}', "");
    Expect(0, 65343, '\p{^Is_Gc=_Connector_PUNCTUATION}', "");
    Expect(0, 65343, '\P{Is_Gc=_Connector_PUNCTUATION}', "");
    Expect(1, 65343, '\P{^Is_Gc=_Connector_PUNCTUATION}', "");
    Expect(0, 65344, '\p{Is_Gc=_Connector_PUNCTUATION}', "");
    Expect(1, 65344, '\p{^Is_Gc=_Connector_PUNCTUATION}', "");
    Expect(1, 65344, '\P{Is_Gc=_Connector_PUNCTUATION}', "");
    Expect(0, 65344, '\P{^Is_Gc=_Connector_PUNCTUATION}', "");
    Error('\p{Is_Category= /a/PC}');
    Error('\P{Is_Category= /a/PC}');
    Expect(1, 65343, '\p{Is_Category=pc}', "");
    Expect(0, 65343, '\p{^Is_Category=pc}', "");
    Expect(0, 65343, '\P{Is_Category=pc}', "");
    Expect(1, 65343, '\P{^Is_Category=pc}', "");
    Expect(0, 65344, '\p{Is_Category=pc}', "");
    Expect(1, 65344, '\p{^Is_Category=pc}', "");
    Expect(1, 65344, '\P{Is_Category=pc}', "");
    Expect(0, 65344, '\P{^Is_Category=pc}', "");
    Error('\p{General_Category= :=Dash_Punctuation}');
    Error('\P{General_Category= :=Dash_Punctuation}');
    Expect(1, 69293, '\p{General_Category=:\ADash_Punctuation\z:}', "");;
    Expect(0, 69294, '\p{General_Category=:\ADash_Punctuation\z:}', "");;
    Expect(1, 69293, '\p{General_Category=dashpunctuation}', "");
    Expect(0, 69293, '\p{^General_Category=dashpunctuation}', "");
    Expect(0, 69293, '\P{General_Category=dashpunctuation}', "");
    Expect(1, 69293, '\P{^General_Category=dashpunctuation}', "");
    Expect(0, 69294, '\p{General_Category=dashpunctuation}', "");
    Expect(1, 69294, '\p{^General_Category=dashpunctuation}', "");
    Expect(1, 69294, '\P{General_Category=dashpunctuation}', "");
    Expect(0, 69294, '\P{^General_Category=dashpunctuation}', "");
    Expect(1, 69293, '\p{General_Category=:\Adashpunctuation\z:}', "");;
    Expect(0, 69294, '\p{General_Category=:\Adashpunctuation\z:}', "");;
    Expect(1, 69293, '\p{General_Category=--Dash_Punctuation}', "");
    Expect(0, 69293, '\p{^General_Category=--Dash_Punctuation}', "");
    Expect(0, 69293, '\P{General_Category=--Dash_Punctuation}', "");
    Expect(1, 69293, '\P{^General_Category=--Dash_Punctuation}', "");
    Expect(0, 69294, '\p{General_Category=--Dash_Punctuation}', "");
    Expect(1, 69294, '\p{^General_Category=--Dash_Punctuation}', "");
    Expect(1, 69294, '\P{General_Category=--Dash_Punctuation}', "");
    Expect(0, 69294, '\P{^General_Category=--Dash_Punctuation}', "");
    Error('\p{Gc=:=_ Pd}');
    Error('\P{Gc=:=_ Pd}');
    Expect(1, 69293, '\p{Gc=:\APd\z:}', "");;
    Expect(0, 69294, '\p{Gc=:\APd\z:}', "");;
    Expect(1, 69293, '\p{Gc=pd}', "");
    Expect(0, 69293, '\p{^Gc=pd}', "");
    Expect(0, 69293, '\P{Gc=pd}', "");
    Expect(1, 69293, '\P{^Gc=pd}', "");
    Expect(0, 69294, '\p{Gc=pd}', "");
    Expect(1, 69294, '\p{^Gc=pd}', "");
    Expect(1, 69294, '\P{Gc=pd}', "");
    Expect(0, 69294, '\P{^Gc=pd}', "");
    Expect(1, 69293, '\p{Gc=:\Apd\z:}', "");;
    Expect(0, 69294, '\p{Gc=:\Apd\z:}', "");;
    Expect(1, 69293, '\p{Gc=--Pd}', "");
    Expect(0, 69293, '\p{^Gc=--Pd}', "");
    Expect(0, 69293, '\P{Gc=--Pd}', "");
    Expect(1, 69293, '\P{^Gc=--Pd}', "");
    Expect(0, 69294, '\p{Gc=--Pd}', "");
    Expect(1, 69294, '\p{^Gc=--Pd}', "");
    Expect(1, 69294, '\P{Gc=--Pd}', "");
    Expect(0, 69294, '\P{^Gc=--Pd}', "");
    Error('\p{Category=/a/	 DASH_Punctuation}');
    Error('\P{Category=/a/	 DASH_Punctuation}');
    Expect(1, 69293, '\p{Category=:\ADash_Punctuation\z:}', "");;
    Expect(0, 69294, '\p{Category=:\ADash_Punctuation\z:}', "");;
    Expect(1, 69293, '\p{Category=dashpunctuation}', "");
    Expect(0, 69293, '\p{^Category=dashpunctuation}', "");
    Expect(0, 69293, '\P{Category=dashpunctuation}', "");
    Expect(1, 69293, '\P{^Category=dashpunctuation}', "");
    Expect(0, 69294, '\p{Category=dashpunctuation}', "");
    Expect(1, 69294, '\p{^Category=dashpunctuation}', "");
    Expect(1, 69294, '\P{Category=dashpunctuation}', "");
    Expect(0, 69294, '\P{^Category=dashpunctuation}', "");
    Expect(1, 69293, '\p{Category=:\Adashpunctuation\z:}', "");;
    Expect(0, 69294, '\p{Category=:\Adashpunctuation\z:}', "");;
    Expect(1, 69293, '\p{Category=--DASH_Punctuation}', "");
    Expect(0, 69293, '\p{^Category=--DASH_Punctuation}', "");
    Expect(0, 69293, '\P{Category=--DASH_Punctuation}', "");
    Expect(1, 69293, '\P{^Category=--DASH_Punctuation}', "");
    Expect(0, 69294, '\p{Category=--DASH_Punctuation}', "");
    Expect(1, 69294, '\p{^Category=--DASH_Punctuation}', "");
    Expect(1, 69294, '\P{Category=--DASH_Punctuation}', "");
    Expect(0, 69294, '\P{^Category=--DASH_Punctuation}', "");
    Error('\p{Is_General_Category=--pd/a/}');
    Error('\P{Is_General_Category=--pd/a/}');
    Expect(1, 69293, '\p{Is_General_Category=pd}', "");
    Expect(0, 69293, '\p{^Is_General_Category=pd}', "");
    Expect(0, 69293, '\P{Is_General_Category=pd}', "");
    Expect(1, 69293, '\P{^Is_General_Category=pd}', "");
    Expect(0, 69294, '\p{Is_General_Category=pd}', "");
    Expect(1, 69294, '\p{^Is_General_Category=pd}', "");
    Expect(1, 69294, '\P{Is_General_Category=pd}', "");
    Expect(0, 69294, '\P{^Is_General_Category=pd}', "");
    Expect(1, 69293, '\p{Is_General_Category= -Pd}', "");
    Expect(0, 69293, '\p{^Is_General_Category= -Pd}', "");
    Expect(0, 69293, '\P{Is_General_Category= -Pd}', "");
    Expect(1, 69293, '\P{^Is_General_Category= -Pd}', "");
    Expect(0, 69294, '\p{Is_General_Category= -Pd}', "");
    Expect(1, 69294, '\p{^Is_General_Category= -Pd}', "");
    Expect(1, 69294, '\P{Is_General_Category= -Pd}', "");
    Expect(0, 69294, '\P{^Is_General_Category= -Pd}', "");
    Error('\p{Is_Gc=/a/	-Dash_Punctuation}');
    Error('\P{Is_Gc=/a/	-Dash_Punctuation}');
    Expect(1, 69293, '\p{Is_Gc=dashpunctuation}', "");
    Expect(0, 69293, '\p{^Is_Gc=dashpunctuation}', "");
    Expect(0, 69293, '\P{Is_Gc=dashpunctuation}', "");
    Expect(1, 69293, '\P{^Is_Gc=dashpunctuation}', "");
    Expect(0, 69294, '\p{Is_Gc=dashpunctuation}', "");
    Expect(1, 69294, '\p{^Is_Gc=dashpunctuation}', "");
    Expect(1, 69294, '\P{Is_Gc=dashpunctuation}', "");
    Expect(0, 69294, '\P{^Is_Gc=dashpunctuation}', "");
    Expect(1, 69293, '\p{Is_Gc=Dash_punctuation}', "");
    Expect(0, 69293, '\p{^Is_Gc=Dash_punctuation}', "");
    Expect(0, 69293, '\P{Is_Gc=Dash_punctuation}', "");
    Expect(1, 69293, '\P{^Is_Gc=Dash_punctuation}', "");
    Expect(0, 69294, '\p{Is_Gc=Dash_punctuation}', "");
    Expect(1, 69294, '\p{^Is_Gc=Dash_punctuation}', "");
    Expect(1, 69294, '\P{Is_Gc=Dash_punctuation}', "");
    Expect(0, 69294, '\P{^Is_Gc=Dash_punctuation}', "");
    Error('\p{Is_Category:/a/ 	PD}');
    Error('\P{Is_Category:/a/ 	PD}');
    Expect(1, 69293, '\p{Is_Category:   pd}', "");
    Expect(0, 69293, '\p{^Is_Category:   pd}', "");
    Expect(0, 69293, '\P{Is_Category:   pd}', "");
    Expect(1, 69293, '\P{^Is_Category:   pd}', "");
    Expect(0, 69294, '\p{Is_Category:   pd}', "");
    Expect(1, 69294, '\p{^Is_Category:   pd}', "");
    Expect(1, 69294, '\P{Is_Category:   pd}', "");
    Expect(0, 69294, '\P{^Is_Category:   pd}', "");
    Expect(1, 69293, '\p{Is_Category=	 Pd}', "");
    Expect(0, 69293, '\p{^Is_Category=	 Pd}', "");
    Expect(0, 69293, '\P{Is_Category=	 Pd}', "");
    Expect(1, 69293, '\P{^Is_Category=	 Pd}', "");
    Expect(0, 69294, '\p{Is_Category=	 Pd}', "");
    Expect(1, 69294, '\p{^Is_Category=	 Pd}', "");
    Expect(1, 69294, '\P{Is_Category=	 Pd}', "");
    Expect(0, 69294, '\P{^Is_Category=	 Pd}', "");
    Error('\p{General_Category= _CLOSE_Punctuation/a/}');
    Error('\P{General_Category= _CLOSE_Punctuation/a/}');
    Expect(1, 65379, '\p{General_Category=:\AClose_Punctuation\z:}', "");;
    Expect(0, 65380, '\p{General_Category=:\AClose_Punctuation\z:}', "");;
    Expect(1, 65379, '\p{General_Category=closepunctuation}', "");
    Expect(0, 65379, '\p{^General_Category=closepunctuation}', "");
    Expect(0, 65379, '\P{General_Category=closepunctuation}', "");
    Expect(1, 65379, '\P{^General_Category=closepunctuation}', "");
    Expect(0, 65380, '\p{General_Category=closepunctuation}', "");
    Expect(1, 65380, '\p{^General_Category=closepunctuation}', "");
    Expect(1, 65380, '\P{General_Category=closepunctuation}', "");
    Expect(0, 65380, '\P{^General_Category=closepunctuation}', "");
    Expect(1, 65379, '\p{General_Category=:\Aclosepunctuation\z:}', "");;
    Expect(0, 65380, '\p{General_Category=:\Aclosepunctuation\z:}', "");;
    Expect(1, 65379, '\p{General_Category=--Close_PUNCTUATION}', "");
    Expect(0, 65379, '\p{^General_Category=--Close_PUNCTUATION}', "");
    Expect(0, 65379, '\P{General_Category=--Close_PUNCTUATION}', "");
    Expect(1, 65379, '\P{^General_Category=--Close_PUNCTUATION}', "");
    Expect(0, 65380, '\p{General_Category=--Close_PUNCTUATION}', "");
    Expect(1, 65380, '\p{^General_Category=--Close_PUNCTUATION}', "");
    Expect(1, 65380, '\P{General_Category=--Close_PUNCTUATION}', "");
    Expect(0, 65380, '\P{^General_Category=--Close_PUNCTUATION}', "");
    Error('\p{Gc=/a/ -PE}');
    Error('\P{Gc=/a/ -PE}');
    Expect(1, 65379, '\p{Gc=:\APe\z:}', "");;
    Expect(0, 65380, '\p{Gc=:\APe\z:}', "");;
    Expect(1, 65379, '\p{Gc=pe}', "");
    Expect(0, 65379, '\p{^Gc=pe}', "");
    Expect(0, 65379, '\P{Gc=pe}', "");
    Expect(1, 65379, '\P{^Gc=pe}', "");
    Expect(0, 65380, '\p{Gc=pe}', "");
    Expect(1, 65380, '\p{^Gc=pe}', "");
    Expect(1, 65380, '\P{Gc=pe}', "");
    Expect(0, 65380, '\P{^Gc=pe}', "");
    Expect(1, 65379, '\p{Gc=:\Ape\z:}', "");;
    Expect(0, 65380, '\p{Gc=:\Ape\z:}', "");;
    Expect(1, 65379, '\p{Gc=-Pe}', "");
    Expect(0, 65379, '\p{^Gc=-Pe}', "");
    Expect(0, 65379, '\P{Gc=-Pe}', "");
    Expect(1, 65379, '\P{^Gc=-Pe}', "");
    Expect(0, 65380, '\p{Gc=-Pe}', "");
    Expect(1, 65380, '\p{^Gc=-Pe}', "");
    Expect(1, 65380, '\P{Gc=-Pe}', "");
    Expect(0, 65380, '\P{^Gc=-Pe}', "");
    Error('\p{Category=/a/Close_Punctuation}');
    Error('\P{Category=/a/Close_Punctuation}');
    Expect(1, 65379, '\p{Category=:\AClose_Punctuation\z:}', "");;
    Expect(0, 65380, '\p{Category=:\AClose_Punctuation\z:}', "");;
    Expect(1, 65379, '\p{Category=closepunctuation}', "");
    Expect(0, 65379, '\p{^Category=closepunctuation}', "");
    Expect(0, 65379, '\P{Category=closepunctuation}', "");
    Expect(1, 65379, '\P{^Category=closepunctuation}', "");
    Expect(0, 65380, '\p{Category=closepunctuation}', "");
    Expect(1, 65380, '\p{^Category=closepunctuation}', "");
    Expect(1, 65380, '\P{Category=closepunctuation}', "");
    Expect(0, 65380, '\P{^Category=closepunctuation}', "");
    Expect(1, 65379, '\p{Category=:\Aclosepunctuation\z:}', "");;
    Expect(0, 65380, '\p{Category=:\Aclosepunctuation\z:}', "");;
    Expect(1, 65379, '\p{Category=	-close_PUNCTUATION}', "");
    Expect(0, 65379, '\p{^Category=	-close_PUNCTUATION}', "");
    Expect(0, 65379, '\P{Category=	-close_PUNCTUATION}', "");
    Expect(1, 65379, '\P{^Category=	-close_PUNCTUATION}', "");
    Expect(0, 65380, '\p{Category=	-close_PUNCTUATION}', "");
    Expect(1, 65380, '\p{^Category=	-close_PUNCTUATION}', "");
    Expect(1, 65380, '\P{Category=	-close_PUNCTUATION}', "");
    Expect(0, 65380, '\P{^Category=	-close_PUNCTUATION}', "");
    Error('\p{Is_General_Category:   /a/-	PE}');
    Error('\P{Is_General_Category:   /a/-	PE}');
    Expect(1, 65379, '\p{Is_General_Category=pe}', "");
    Expect(0, 65379, '\p{^Is_General_Category=pe}', "");
    Expect(0, 65379, '\P{Is_General_Category=pe}', "");
    Expect(1, 65379, '\P{^Is_General_Category=pe}', "");
    Expect(0, 65380, '\p{Is_General_Category=pe}', "");
    Expect(1, 65380, '\p{^Is_General_Category=pe}', "");
    Expect(1, 65380, '\P{Is_General_Category=pe}', "");
    Expect(0, 65380, '\P{^Is_General_Category=pe}', "");
    Expect(1, 65379, '\p{Is_General_Category=	-PE}', "");
    Expect(0, 65379, '\p{^Is_General_Category=	-PE}', "");
    Expect(0, 65379, '\P{Is_General_Category=	-PE}', "");
    Expect(1, 65379, '\P{^Is_General_Category=	-PE}', "");
    Expect(0, 65380, '\p{Is_General_Category=	-PE}', "");
    Expect(1, 65380, '\p{^Is_General_Category=	-PE}', "");
    Expect(1, 65380, '\P{Is_General_Category=	-PE}', "");
    Expect(0, 65380, '\P{^Is_General_Category=	-PE}', "");
    Error('\p{Is_Gc= :=Close_Punctuation}');
    Error('\P{Is_Gc= :=Close_Punctuation}');
    Expect(1, 65379, '\p{Is_Gc=closepunctuation}', "");
    Expect(0, 65379, '\p{^Is_Gc=closepunctuation}', "");
    Expect(0, 65379, '\P{Is_Gc=closepunctuation}', "");
    Expect(1, 65379, '\P{^Is_Gc=closepunctuation}', "");
    Expect(0, 65380, '\p{Is_Gc=closepunctuation}', "");
    Expect(1, 65380, '\p{^Is_Gc=closepunctuation}', "");
    Expect(1, 65380, '\P{Is_Gc=closepunctuation}', "");
    Expect(0, 65380, '\P{^Is_Gc=closepunctuation}', "");
    Expect(1, 65379, '\p{Is_Gc=-_Close_Punctuation}', "");
    Expect(0, 65379, '\p{^Is_Gc=-_Close_Punctuation}', "");
    Expect(0, 65379, '\P{Is_Gc=-_Close_Punctuation}', "");
    Expect(1, 65379, '\P{^Is_Gc=-_Close_Punctuation}', "");
    Expect(0, 65380, '\p{Is_Gc=-_Close_Punctuation}', "");
    Expect(1, 65380, '\p{^Is_Gc=-_Close_Punctuation}', "");
    Expect(1, 65380, '\P{Is_Gc=-_Close_Punctuation}', "");
    Expect(0, 65380, '\P{^Is_Gc=-_Close_Punctuation}', "");
    Error('\p{Is_Category= _pe/a/}');
    Error('\P{Is_Category= _pe/a/}');
    Expect(1, 65379, '\p{Is_Category:pe}', "");
    Expect(0, 65379, '\p{^Is_Category:pe}', "");
    Expect(0, 65379, '\P{Is_Category:pe}', "");
    Expect(1, 65379, '\P{^Is_Category:pe}', "");
    Expect(0, 65380, '\p{Is_Category:pe}', "");
    Expect(1, 65380, '\p{^Is_Category:pe}', "");
    Expect(1, 65380, '\P{Is_Category:pe}', "");
    Expect(0, 65380, '\P{^Is_Category:pe}', "");
    Expect(1, 65379, '\p{Is_Category=_-pe}', "");
    Expect(0, 65379, '\p{^Is_Category=_-pe}', "");
    Expect(0, 65379, '\P{Is_Category=_-pe}', "");
    Expect(1, 65379, '\P{^Is_Category=_-pe}', "");
    Expect(0, 65380, '\p{Is_Category=_-pe}', "");
    Expect(1, 65380, '\p{^Is_Category=_-pe}', "");
    Expect(1, 65380, '\P{Is_Category=_-pe}', "");
    Expect(0, 65380, '\P{^Is_Category=_-pe}', "");
    Error('\p{General_Category=:=Final_PUNCTUATION}');
    Error('\P{General_Category=:=Final_PUNCTUATION}');
    Expect(1, 11809, '\p{General_Category=:\AFinal_Punctuation\z:}', "");;
    Expect(0, 11810, '\p{General_Category=:\AFinal_Punctuation\z:}', "");;
    Expect(1, 11809, '\p{General_Category=finalpunctuation}', "");
    Expect(0, 11809, '\p{^General_Category=finalpunctuation}', "");
    Expect(0, 11809, '\P{General_Category=finalpunctuation}', "");
    Expect(1, 11809, '\P{^General_Category=finalpunctuation}', "");
    Expect(0, 11810, '\p{General_Category=finalpunctuation}', "");
    Expect(1, 11810, '\p{^General_Category=finalpunctuation}', "");
    Expect(1, 11810, '\P{General_Category=finalpunctuation}', "");
    Expect(0, 11810, '\P{^General_Category=finalpunctuation}', "");
    Expect(1, 11809, '\p{General_Category=:\Afinalpunctuation\z:}', "");;
    Expect(0, 11810, '\p{General_Category=:\Afinalpunctuation\z:}', "");;
    Expect(1, 11809, '\p{General_Category=__FINAL_PUNCTUATION}', "");
    Expect(0, 11809, '\p{^General_Category=__FINAL_PUNCTUATION}', "");
    Expect(0, 11809, '\P{General_Category=__FINAL_PUNCTUATION}', "");
    Expect(1, 11809, '\P{^General_Category=__FINAL_PUNCTUATION}', "");
    Expect(0, 11810, '\p{General_Category=__FINAL_PUNCTUATION}', "");
    Expect(1, 11810, '\p{^General_Category=__FINAL_PUNCTUATION}', "");
    Expect(1, 11810, '\P{General_Category=__FINAL_PUNCTUATION}', "");
    Expect(0, 11810, '\P{^General_Category=__FINAL_PUNCTUATION}', "");
    Error('\p{Gc: - Pf/a/}');
    Error('\P{Gc: - Pf/a/}');
    Expect(1, 11809, '\p{Gc=:\APf\z:}', "");;
    Expect(0, 11810, '\p{Gc=:\APf\z:}', "");;
    Expect(1, 11809, '\p{Gc=pf}', "");
    Expect(0, 11809, '\p{^Gc=pf}', "");
    Expect(0, 11809, '\P{Gc=pf}', "");
    Expect(1, 11809, '\P{^Gc=pf}', "");
    Expect(0, 11810, '\p{Gc=pf}', "");
    Expect(1, 11810, '\p{^Gc=pf}', "");
    Expect(1, 11810, '\P{Gc=pf}', "");
    Expect(0, 11810, '\P{^Gc=pf}', "");
    Expect(1, 11809, '\p{Gc=:\Apf\z:}', "");;
    Expect(0, 11810, '\p{Gc=:\Apf\z:}', "");;
    Expect(1, 11809, '\p{Gc:	 	pf}', "");
    Expect(0, 11809, '\p{^Gc:	 	pf}', "");
    Expect(0, 11809, '\P{Gc:	 	pf}', "");
    Expect(1, 11809, '\P{^Gc:	 	pf}', "");
    Expect(0, 11810, '\p{Gc:	 	pf}', "");
    Expect(1, 11810, '\p{^Gc:	 	pf}', "");
    Expect(1, 11810, '\P{Gc:	 	pf}', "");
    Expect(0, 11810, '\P{^Gc:	 	pf}', "");
    Error('\p{Category= :=Final_punctuation}');
    Error('\P{Category= :=Final_punctuation}');
    Expect(1, 11809, '\p{Category=:\AFinal_Punctuation\z:}', "");;
    Expect(0, 11810, '\p{Category=:\AFinal_Punctuation\z:}', "");;
    Expect(1, 11809, '\p{Category:   finalpunctuation}', "");
    Expect(0, 11809, '\p{^Category:   finalpunctuation}', "");
    Expect(0, 11809, '\P{Category:   finalpunctuation}', "");
    Expect(1, 11809, '\P{^Category:   finalpunctuation}', "");
    Expect(0, 11810, '\p{Category:   finalpunctuation}', "");
    Expect(1, 11810, '\p{^Category:   finalpunctuation}', "");
    Expect(1, 11810, '\P{Category:   finalpunctuation}', "");
    Expect(0, 11810, '\P{^Category:   finalpunctuation}', "");
    Expect(1, 11809, '\p{Category=:\Afinalpunctuation\z:}', "");;
    Expect(0, 11810, '\p{Category=:\Afinalpunctuation\z:}', "");;
    Expect(1, 11809, '\p{Category=_-Final_Punctuation}', "");
    Expect(0, 11809, '\p{^Category=_-Final_Punctuation}', "");
    Expect(0, 11809, '\P{Category=_-Final_Punctuation}', "");
    Expect(1, 11809, '\P{^Category=_-Final_Punctuation}', "");
    Expect(0, 11810, '\p{Category=_-Final_Punctuation}', "");
    Expect(1, 11810, '\p{^Category=_-Final_Punctuation}', "");
    Expect(1, 11810, '\P{Category=_-Final_Punctuation}', "");
    Expect(0, 11810, '\P{^Category=_-Final_Punctuation}', "");
    Error('\p{Is_General_Category=:=PF}');
    Error('\P{Is_General_Category=:=PF}');
    Expect(1, 11809, '\p{Is_General_Category:   pf}', "");
    Expect(0, 11809, '\p{^Is_General_Category:   pf}', "");
    Expect(0, 11809, '\P{Is_General_Category:   pf}', "");
    Expect(1, 11809, '\P{^Is_General_Category:   pf}', "");
    Expect(0, 11810, '\p{Is_General_Category:   pf}', "");
    Expect(1, 11810, '\p{^Is_General_Category:   pf}', "");
    Expect(1, 11810, '\P{Is_General_Category:   pf}', "");
    Expect(0, 11810, '\P{^Is_General_Category:   pf}', "");
    Expect(1, 11809, '\p{Is_General_Category= _Pf}', "");
    Expect(0, 11809, '\p{^Is_General_Category= _Pf}', "");
    Expect(0, 11809, '\P{Is_General_Category= _Pf}', "");
    Expect(1, 11809, '\P{^Is_General_Category= _Pf}', "");
    Expect(0, 11810, '\p{Is_General_Category= _Pf}', "");
    Expect(1, 11810, '\p{^Is_General_Category= _Pf}', "");
    Expect(1, 11810, '\P{Is_General_Category= _Pf}', "");
    Expect(0, 11810, '\P{^Is_General_Category= _Pf}', "");
    Error('\p{Is_Gc::=__Final_Punctuation}');
    Error('\P{Is_Gc::=__Final_Punctuation}');
    Expect(1, 11809, '\p{Is_Gc=finalpunctuation}', "");
    Expect(0, 11809, '\p{^Is_Gc=finalpunctuation}', "");
    Expect(0, 11809, '\P{Is_Gc=finalpunctuation}', "");
    Expect(1, 11809, '\P{^Is_Gc=finalpunctuation}', "");
    Expect(0, 11810, '\p{Is_Gc=finalpunctuation}', "");
    Expect(1, 11810, '\p{^Is_Gc=finalpunctuation}', "");
    Expect(1, 11810, '\P{Is_Gc=finalpunctuation}', "");
    Expect(0, 11810, '\P{^Is_Gc=finalpunctuation}', "");
    Expect(1, 11809, '\p{Is_Gc=-	FINAL_Punctuation}', "");
    Expect(0, 11809, '\p{^Is_Gc=-	FINAL_Punctuation}', "");
    Expect(0, 11809, '\P{Is_Gc=-	FINAL_Punctuation}', "");
    Expect(1, 11809, '\P{^Is_Gc=-	FINAL_Punctuation}', "");
    Expect(0, 11810, '\p{Is_Gc=-	FINAL_Punctuation}', "");
    Expect(1, 11810, '\p{^Is_Gc=-	FINAL_Punctuation}', "");
    Expect(1, 11810, '\P{Is_Gc=-	FINAL_Punctuation}', "");
    Expect(0, 11810, '\P{^Is_Gc=-	FINAL_Punctuation}', "");
    Error('\p{Is_Category=:=PF}');
    Error('\P{Is_Category=:=PF}');
    Expect(1, 11809, '\p{Is_Category=pf}', "");
    Expect(0, 11809, '\p{^Is_Category=pf}', "");
    Expect(0, 11809, '\P{Is_Category=pf}', "");
    Expect(1, 11809, '\P{^Is_Category=pf}', "");
    Expect(0, 11810, '\p{Is_Category=pf}', "");
    Expect(1, 11810, '\p{^Is_Category=pf}', "");
    Expect(1, 11810, '\P{Is_Category=pf}', "");
    Expect(0, 11810, '\P{^Is_Category=pf}', "");
    Expect(1, 11809, '\p{Is_Category=_pf}', "");
    Expect(0, 11809, '\p{^Is_Category=_pf}', "");
    Expect(0, 11809, '\P{Is_Category=_pf}', "");
    Expect(1, 11809, '\P{^Is_Category=_pf}', "");
    Expect(0, 11810, '\p{Is_Category=_pf}', "");
    Expect(1, 11810, '\p{^Is_Category=_pf}', "");
    Expect(1, 11810, '\P{Is_Category=_pf}', "");
    Expect(0, 11810, '\P{^Is_Category=_pf}', "");
    Error('\p{General_Category=	:=Initial_PUNCTUATION}');
    Error('\P{General_Category=	:=Initial_PUNCTUATION}');
    Expect(1, 11808, '\p{General_Category=:\AInitial_Punctuation\z:}', "");;
    Expect(0, 11809, '\p{General_Category=:\AInitial_Punctuation\z:}', "");;
    Expect(1, 11808, '\p{General_Category=initialpunctuation}', "");
    Expect(0, 11808, '\p{^General_Category=initialpunctuation}', "");
    Expect(0, 11808, '\P{General_Category=initialpunctuation}', "");
    Expect(1, 11808, '\P{^General_Category=initialpunctuation}', "");
    Expect(0, 11809, '\p{General_Category=initialpunctuation}', "");
    Expect(1, 11809, '\p{^General_Category=initialpunctuation}', "");
    Expect(1, 11809, '\P{General_Category=initialpunctuation}', "");
    Expect(0, 11809, '\P{^General_Category=initialpunctuation}', "");
    Expect(1, 11808, '\p{General_Category=:\Ainitialpunctuation\z:}', "");;
    Expect(0, 11809, '\p{General_Category=:\Ainitialpunctuation\z:}', "");;
    Expect(1, 11808, '\p{General_Category= -initial_punctuation}', "");
    Expect(0, 11808, '\p{^General_Category= -initial_punctuation}', "");
    Expect(0, 11808, '\P{General_Category= -initial_punctuation}', "");
    Expect(1, 11808, '\P{^General_Category= -initial_punctuation}', "");
    Expect(0, 11809, '\p{General_Category= -initial_punctuation}', "");
    Expect(1, 11809, '\p{^General_Category= -initial_punctuation}', "");
    Expect(1, 11809, '\P{General_Category= -initial_punctuation}', "");
    Expect(0, 11809, '\P{^General_Category= -initial_punctuation}', "");
    Error('\p{Gc=-/a/Pi}');
    Error('\P{Gc=-/a/Pi}');
    Expect(1, 11808, '\p{Gc=:\APi\z:}', "");;
    Expect(0, 11809, '\p{Gc=:\APi\z:}', "");;
    Expect(1, 11808, '\p{Gc=pi}', "");
    Expect(0, 11808, '\p{^Gc=pi}', "");
    Expect(0, 11808, '\P{Gc=pi}', "");
    Expect(1, 11808, '\P{^Gc=pi}', "");
    Expect(0, 11809, '\p{Gc=pi}', "");
    Expect(1, 11809, '\p{^Gc=pi}', "");
    Expect(1, 11809, '\P{Gc=pi}', "");
    Expect(0, 11809, '\P{^Gc=pi}', "");
    Expect(1, 11808, '\p{Gc=:\Api\z:}', "");;
    Expect(0, 11809, '\p{Gc=:\Api\z:}', "");;
    Expect(1, 11808, '\p{Gc=	pi}', "");
    Expect(0, 11808, '\p{^Gc=	pi}', "");
    Expect(0, 11808, '\P{Gc=	pi}', "");
    Expect(1, 11808, '\P{^Gc=	pi}', "");
    Expect(0, 11809, '\p{Gc=	pi}', "");
    Expect(1, 11809, '\p{^Gc=	pi}', "");
    Expect(1, 11809, '\P{Gc=	pi}', "");
    Expect(0, 11809, '\P{^Gc=	pi}', "");
    Error('\p{Category: _/a/Initial_Punctuation}');
    Error('\P{Category: _/a/Initial_Punctuation}');
    Expect(1, 11808, '\p{Category=:\AInitial_Punctuation\z:}', "");;
    Expect(0, 11809, '\p{Category=:\AInitial_Punctuation\z:}', "");;
    Expect(1, 11808, '\p{Category=initialpunctuation}', "");
    Expect(0, 11808, '\p{^Category=initialpunctuation}', "");
    Expect(0, 11808, '\P{Category=initialpunctuation}', "");
    Expect(1, 11808, '\P{^Category=initialpunctuation}', "");
    Expect(0, 11809, '\p{Category=initialpunctuation}', "");
    Expect(1, 11809, '\p{^Category=initialpunctuation}', "");
    Expect(1, 11809, '\P{Category=initialpunctuation}', "");
    Expect(0, 11809, '\P{^Category=initialpunctuation}', "");
    Expect(1, 11808, '\p{Category=:\Ainitialpunctuation\z:}', "");;
    Expect(0, 11809, '\p{Category=:\Ainitialpunctuation\z:}', "");;
    Expect(1, 11808, '\p{Category=-Initial_punctuation}', "");
    Expect(0, 11808, '\p{^Category=-Initial_punctuation}', "");
    Expect(0, 11808, '\P{Category=-Initial_punctuation}', "");
    Expect(1, 11808, '\P{^Category=-Initial_punctuation}', "");
    Expect(0, 11809, '\p{Category=-Initial_punctuation}', "");
    Expect(1, 11809, '\p{^Category=-Initial_punctuation}', "");
    Expect(1, 11809, '\P{Category=-Initial_punctuation}', "");
    Expect(0, 11809, '\P{^Category=-Initial_punctuation}', "");
    Error('\p{Is_General_Category=	/a/Pi}');
    Error('\P{Is_General_Category=	/a/Pi}');
    Expect(1, 11808, '\p{Is_General_Category=pi}', "");
    Expect(0, 11808, '\p{^Is_General_Category=pi}', "");
    Expect(0, 11808, '\P{Is_General_Category=pi}', "");
    Expect(1, 11808, '\P{^Is_General_Category=pi}', "");
    Expect(0, 11809, '\p{Is_General_Category=pi}', "");
    Expect(1, 11809, '\p{^Is_General_Category=pi}', "");
    Expect(1, 11809, '\P{Is_General_Category=pi}', "");
    Expect(0, 11809, '\P{^Is_General_Category=pi}', "");
    Expect(1, 11808, '\p{Is_General_Category=	Pi}', "");
    Expect(0, 11808, '\p{^Is_General_Category=	Pi}', "");
    Expect(0, 11808, '\P{Is_General_Category=	Pi}', "");
    Expect(1, 11808, '\P{^Is_General_Category=	Pi}', "");
    Expect(0, 11809, '\p{Is_General_Category=	Pi}', "");
    Expect(1, 11809, '\p{^Is_General_Category=	Pi}', "");
    Expect(1, 11809, '\P{Is_General_Category=	Pi}', "");
    Expect(0, 11809, '\P{^Is_General_Category=	Pi}', "");
    Error('\p{Is_Gc: 	/a/Initial_Punctuation}');
    Error('\P{Is_Gc: 	/a/Initial_Punctuation}');
    Expect(1, 11808, '\p{Is_Gc: initialpunctuation}', "");
    Expect(0, 11808, '\p{^Is_Gc: initialpunctuation}', "");
    Expect(0, 11808, '\P{Is_Gc: initialpunctuation}', "");
    Expect(1, 11808, '\P{^Is_Gc: initialpunctuation}', "");
    Expect(0, 11809, '\p{Is_Gc: initialpunctuation}', "");
    Expect(1, 11809, '\p{^Is_Gc: initialpunctuation}', "");
    Expect(1, 11809, '\P{Is_Gc: initialpunctuation}', "");
    Expect(0, 11809, '\P{^Is_Gc: initialpunctuation}', "");
    Expect(1, 11808, '\p{Is_Gc:	_initial_Punctuation}', "");
    Expect(0, 11808, '\p{^Is_Gc:	_initial_Punctuation}', "");
    Expect(0, 11808, '\P{Is_Gc:	_initial_Punctuation}', "");
    Expect(1, 11808, '\P{^Is_Gc:	_initial_Punctuation}', "");
    Expect(0, 11809, '\p{Is_Gc:	_initial_Punctuation}', "");
    Expect(1, 11809, '\p{^Is_Gc:	_initial_Punctuation}', "");
    Expect(1, 11809, '\P{Is_Gc:	_initial_Punctuation}', "");
    Expect(0, 11809, '\P{^Is_Gc:	_initial_Punctuation}', "");
    Error('\p{Is_Category=-PI/a/}');
    Error('\P{Is_Category=-PI/a/}');
    Expect(1, 11808, '\p{Is_Category=pi}', "");
    Expect(0, 11808, '\p{^Is_Category=pi}', "");
    Expect(0, 11808, '\P{Is_Category=pi}', "");
    Expect(1, 11808, '\P{^Is_Category=pi}', "");
    Expect(0, 11809, '\p{Is_Category=pi}', "");
    Expect(1, 11809, '\p{^Is_Category=pi}', "");
    Expect(1, 11809, '\P{Is_Category=pi}', "");
    Expect(0, 11809, '\P{^Is_Category=pi}', "");
    Expect(1, 11808, '\p{Is_Category: -PI}', "");
    Expect(0, 11808, '\p{^Is_Category: -PI}', "");
    Expect(0, 11808, '\P{Is_Category: -PI}', "");
    Expect(1, 11808, '\P{^Is_Category: -PI}', "");
    Expect(0, 11809, '\p{Is_Category: -PI}', "");
    Expect(1, 11809, '\p{^Is_Category: -PI}', "");
    Expect(1, 11809, '\P{Is_Category: -PI}', "");
    Expect(0, 11809, '\P{^Is_Category: -PI}', "");
    Error('\p{General_Category=_Other_Punctuation/a/}');
    Error('\P{General_Category=_Other_Punctuation/a/}');
    Expect(1, 125279, '\p{General_Category=:\AOther_Punctuation\z:}', "");;
    Expect(0, 125280, '\p{General_Category=:\AOther_Punctuation\z:}', "");;
    Expect(1, 125279, '\p{General_Category=otherpunctuation}', "");
    Expect(0, 125279, '\p{^General_Category=otherpunctuation}', "");
    Expect(0, 125279, '\P{General_Category=otherpunctuation}', "");
    Expect(1, 125279, '\P{^General_Category=otherpunctuation}', "");
    Expect(0, 125280, '\p{General_Category=otherpunctuation}', "");
    Expect(1, 125280, '\p{^General_Category=otherpunctuation}', "");
    Expect(1, 125280, '\P{General_Category=otherpunctuation}', "");
    Expect(0, 125280, '\P{^General_Category=otherpunctuation}', "");
    Expect(1, 125279, '\p{General_Category=:\Aotherpunctuation\z:}', "");;
    Expect(0, 125280, '\p{General_Category=:\Aotherpunctuation\z:}', "");;
    Expect(1, 125279, '\p{General_Category=	 Other_Punctuation}', "");
    Expect(0, 125279, '\p{^General_Category=	 Other_Punctuation}', "");
    Expect(0, 125279, '\P{General_Category=	 Other_Punctuation}', "");
    Expect(1, 125279, '\P{^General_Category=	 Other_Punctuation}', "");
    Expect(0, 125280, '\p{General_Category=	 Other_Punctuation}', "");
    Expect(1, 125280, '\p{^General_Category=	 Other_Punctuation}', "");
    Expect(1, 125280, '\P{General_Category=	 Other_Punctuation}', "");
    Expect(0, 125280, '\P{^General_Category=	 Other_Punctuation}', "");
    Error('\p{Gc=-_po/a/}');
    Error('\P{Gc=-_po/a/}');
    Expect(1, 125279, '\p{Gc=:\APo\z:}', "");;
    Expect(0, 125280, '\p{Gc=:\APo\z:}', "");;
    Expect(1, 125279, '\p{Gc=po}', "");
    Expect(0, 125279, '\p{^Gc=po}', "");
    Expect(0, 125279, '\P{Gc=po}', "");
    Expect(1, 125279, '\P{^Gc=po}', "");
    Expect(0, 125280, '\p{Gc=po}', "");
    Expect(1, 125280, '\p{^Gc=po}', "");
    Expect(1, 125280, '\P{Gc=po}', "");
    Expect(0, 125280, '\P{^Gc=po}', "");
    Expect(1, 125279, '\p{Gc=:\Apo\z:}', "");;
    Expect(0, 125280, '\p{Gc=:\Apo\z:}', "");;
    Expect(1, 125279, '\p{Gc=	PO}', "");
    Expect(0, 125279, '\p{^Gc=	PO}', "");
    Expect(0, 125279, '\P{Gc=	PO}', "");
    Expect(1, 125279, '\P{^Gc=	PO}', "");
    Expect(0, 125280, '\p{Gc=	PO}', "");
    Expect(1, 125280, '\p{^Gc=	PO}', "");
    Expect(1, 125280, '\P{Gc=	PO}', "");
    Expect(0, 125280, '\P{^Gc=	PO}', "");
    Error('\p{Category=/a/-OTHER_PUNCTUATION}');
    Error('\P{Category=/a/-OTHER_PUNCTUATION}');
    Expect(1, 125279, '\p{Category=:\AOther_Punctuation\z:}', "");;
    Expect(0, 125280, '\p{Category=:\AOther_Punctuation\z:}', "");;
    Expect(1, 125279, '\p{Category=otherpunctuation}', "");
    Expect(0, 125279, '\p{^Category=otherpunctuation}', "");
    Expect(0, 125279, '\P{Category=otherpunctuation}', "");
    Expect(1, 125279, '\P{^Category=otherpunctuation}', "");
    Expect(0, 125280, '\p{Category=otherpunctuation}', "");
    Expect(1, 125280, '\p{^Category=otherpunctuation}', "");
    Expect(1, 125280, '\P{Category=otherpunctuation}', "");
    Expect(0, 125280, '\P{^Category=otherpunctuation}', "");
    Expect(1, 125279, '\p{Category=:\Aotherpunctuation\z:}', "");;
    Expect(0, 125280, '\p{Category=:\Aotherpunctuation\z:}', "");;
    Expect(1, 125279, '\p{Category= -OTHER_punctuation}', "");
    Expect(0, 125279, '\p{^Category= -OTHER_punctuation}', "");
    Expect(0, 125279, '\P{Category= -OTHER_punctuation}', "");
    Expect(1, 125279, '\P{^Category= -OTHER_punctuation}', "");
    Expect(0, 125280, '\p{Category= -OTHER_punctuation}', "");
    Expect(1, 125280, '\p{^Category= -OTHER_punctuation}', "");
    Expect(1, 125280, '\P{Category= -OTHER_punctuation}', "");
    Expect(0, 125280, '\P{^Category= -OTHER_punctuation}', "");
    Error('\p{Is_General_Category=__po:=}');
    Error('\P{Is_General_Category=__po:=}');
    Expect(1, 125279, '\p{Is_General_Category=po}', "");
    Expect(0, 125279, '\p{^Is_General_Category=po}', "");
    Expect(0, 125279, '\P{Is_General_Category=po}', "");
    Expect(1, 125279, '\P{^Is_General_Category=po}', "");
    Expect(0, 125280, '\p{Is_General_Category=po}', "");
    Expect(1, 125280, '\p{^Is_General_Category=po}', "");
    Expect(1, 125280, '\P{Is_General_Category=po}', "");
    Expect(0, 125280, '\P{^Is_General_Category=po}', "");
    Expect(1, 125279, '\p{Is_General_Category= -po}', "");
    Expect(0, 125279, '\p{^Is_General_Category= -po}', "");
    Expect(0, 125279, '\P{Is_General_Category= -po}', "");
    Expect(1, 125279, '\P{^Is_General_Category= -po}', "");
    Expect(0, 125280, '\p{Is_General_Category= -po}', "");
    Expect(1, 125280, '\p{^Is_General_Category= -po}', "");
    Expect(1, 125280, '\P{Is_General_Category= -po}', "");
    Expect(0, 125280, '\P{^Is_General_Category= -po}', "");
    Error('\p{Is_Gc=  OTHER_Punctuation:=}');
    Error('\P{Is_Gc=  OTHER_Punctuation:=}');
    Expect(1, 125279, '\p{Is_Gc=otherpunctuation}', "");
    Expect(0, 125279, '\p{^Is_Gc=otherpunctuation}', "");
    Expect(0, 125279, '\P{Is_Gc=otherpunctuation}', "");
    Expect(1, 125279, '\P{^Is_Gc=otherpunctuation}', "");
    Expect(0, 125280, '\p{Is_Gc=otherpunctuation}', "");
    Expect(1, 125280, '\p{^Is_Gc=otherpunctuation}', "");
    Expect(1, 125280, '\P{Is_Gc=otherpunctuation}', "");
    Expect(0, 125280, '\P{^Is_Gc=otherpunctuation}', "");
    Expect(1, 125279, '\p{Is_Gc=	 OTHER_Punctuation}', "");
    Expect(0, 125279, '\p{^Is_Gc=	 OTHER_Punctuation}', "");
    Expect(0, 125279, '\P{Is_Gc=	 OTHER_Punctuation}', "");
    Expect(1, 125279, '\P{^Is_Gc=	 OTHER_Punctuation}', "");
    Expect(0, 125280, '\p{Is_Gc=	 OTHER_Punctuation}', "");
    Expect(1, 125280, '\p{^Is_Gc=	 OTHER_Punctuation}', "");
    Expect(1, 125280, '\P{Is_Gc=	 OTHER_Punctuation}', "");
    Expect(0, 125280, '\P{^Is_Gc=	 OTHER_Punctuation}', "");
    Error('\p{Is_Category=	:=Po}');
    Error('\P{Is_Category=	:=Po}');
    Expect(1, 125279, '\p{Is_Category=po}', "");
    Expect(0, 125279, '\p{^Is_Category=po}', "");
    Expect(0, 125279, '\P{Is_Category=po}', "");
    Expect(1, 125279, '\P{^Is_Category=po}', "");
    Expect(0, 125280, '\p{Is_Category=po}', "");
    Expect(1, 125280, '\p{^Is_Category=po}', "");
    Expect(1, 125280, '\P{Is_Category=po}', "");
    Expect(0, 125280, '\P{^Is_Category=po}', "");
    Expect(1, 125279, '\p{Is_Category= PO}', "");
    Expect(0, 125279, '\p{^Is_Category= PO}', "");
    Expect(0, 125279, '\P{Is_Category= PO}', "");
    Expect(1, 125279, '\P{^Is_Category= PO}', "");
    Expect(0, 125280, '\p{Is_Category= PO}', "");
    Expect(1, 125280, '\p{^Is_Category= PO}', "");
    Expect(1, 125280, '\P{Is_Category= PO}', "");
    Expect(0, 125280, '\P{^Is_Category= PO}', "");
    Error('\p{General_Category:/a/-_Open_Punctuation}');
    Error('\P{General_Category:/a/-_Open_Punctuation}');
    Expect(1, 65378, '\p{General_Category=:\AOpen_Punctuation\z:}', "");;
    Expect(0, 65379, '\p{General_Category=:\AOpen_Punctuation\z:}', "");;
    Expect(1, 65378, '\p{General_Category=openpunctuation}', "");
    Expect(0, 65378, '\p{^General_Category=openpunctuation}', "");
    Expect(0, 65378, '\P{General_Category=openpunctuation}', "");
    Expect(1, 65378, '\P{^General_Category=openpunctuation}', "");
    Expect(0, 65379, '\p{General_Category=openpunctuation}', "");
    Expect(1, 65379, '\p{^General_Category=openpunctuation}', "");
    Expect(1, 65379, '\P{General_Category=openpunctuation}', "");
    Expect(0, 65379, '\P{^General_Category=openpunctuation}', "");
    Expect(1, 65378, '\p{General_Category=:\Aopenpunctuation\z:}', "");;
    Expect(0, 65379, '\p{General_Category=:\Aopenpunctuation\z:}', "");;
    Expect(1, 65378, '\p{General_Category= -OPEN_Punctuation}', "");
    Expect(0, 65378, '\p{^General_Category= -OPEN_Punctuation}', "");
    Expect(0, 65378, '\P{General_Category= -OPEN_Punctuation}', "");
    Expect(1, 65378, '\P{^General_Category= -OPEN_Punctuation}', "");
    Expect(0, 65379, '\p{General_Category= -OPEN_Punctuation}', "");
    Expect(1, 65379, '\p{^General_Category= -OPEN_Punctuation}', "");
    Expect(1, 65379, '\P{General_Category= -OPEN_Punctuation}', "");
    Expect(0, 65379, '\P{^General_Category= -OPEN_Punctuation}', "");
    Error('\p{Gc=Ps/a/}');
    Error('\P{Gc=Ps/a/}');
    Expect(1, 65378, '\p{Gc=:\APs\z:}', "");;
    Expect(0, 65379, '\p{Gc=:\APs\z:}', "");;
    Expect(1, 65378, '\p{Gc=ps}', "");
    Expect(0, 65378, '\p{^Gc=ps}', "");
    Expect(0, 65378, '\P{Gc=ps}', "");
    Expect(1, 65378, '\P{^Gc=ps}', "");
    Expect(0, 65379, '\p{Gc=ps}', "");
    Expect(1, 65379, '\p{^Gc=ps}', "");
    Expect(1, 65379, '\P{Gc=ps}', "");
    Expect(0, 65379, '\P{^Gc=ps}', "");
    Expect(1, 65378, '\p{Gc=:\Aps\z:}', "");;
    Expect(0, 65379, '\p{Gc=:\Aps\z:}', "");;
    Expect(1, 65378, '\p{Gc=	PS}', "");
    Expect(0, 65378, '\p{^Gc=	PS}', "");
    Expect(0, 65378, '\P{Gc=	PS}', "");
    Expect(1, 65378, '\P{^Gc=	PS}', "");
    Expect(0, 65379, '\p{Gc=	PS}', "");
    Expect(1, 65379, '\p{^Gc=	PS}', "");
    Expect(1, 65379, '\P{Gc=	PS}', "");
    Expect(0, 65379, '\P{^Gc=	PS}', "");
    Error('\p{Category=__open_punctuation:=}');
    Error('\P{Category=__open_punctuation:=}');
    Expect(1, 65378, '\p{Category=:\AOpen_Punctuation\z:}', "");;
    Expect(0, 65379, '\p{Category=:\AOpen_Punctuation\z:}', "");;
    Expect(1, 65378, '\p{Category=openpunctuation}', "");
    Expect(0, 65378, '\p{^Category=openpunctuation}', "");
    Expect(0, 65378, '\P{Category=openpunctuation}', "");
    Expect(1, 65378, '\P{^Category=openpunctuation}', "");
    Expect(0, 65379, '\p{Category=openpunctuation}', "");
    Expect(1, 65379, '\p{^Category=openpunctuation}', "");
    Expect(1, 65379, '\P{Category=openpunctuation}', "");
    Expect(0, 65379, '\P{^Category=openpunctuation}', "");
    Expect(1, 65378, '\p{Category=:\Aopenpunctuation\z:}', "");;
    Expect(0, 65379, '\p{Category=:\Aopenpunctuation\z:}', "");;
    Expect(1, 65378, '\p{Category=-_Open_Punctuation}', "");
    Expect(0, 65378, '\p{^Category=-_Open_Punctuation}', "");
    Expect(0, 65378, '\P{Category=-_Open_Punctuation}', "");
    Expect(1, 65378, '\P{^Category=-_Open_Punctuation}', "");
    Expect(0, 65379, '\p{Category=-_Open_Punctuation}', "");
    Expect(1, 65379, '\p{^Category=-_Open_Punctuation}', "");
    Expect(1, 65379, '\P{Category=-_Open_Punctuation}', "");
    Expect(0, 65379, '\P{^Category=-_Open_Punctuation}', "");
    Error('\p{Is_General_Category=:=	ps}');
    Error('\P{Is_General_Category=:=	ps}');
    Expect(1, 65378, '\p{Is_General_Category=ps}', "");
    Expect(0, 65378, '\p{^Is_General_Category=ps}', "");
    Expect(0, 65378, '\P{Is_General_Category=ps}', "");
    Expect(1, 65378, '\P{^Is_General_Category=ps}', "");
    Expect(0, 65379, '\p{Is_General_Category=ps}', "");
    Expect(1, 65379, '\p{^Is_General_Category=ps}', "");
    Expect(1, 65379, '\P{Is_General_Category=ps}', "");
    Expect(0, 65379, '\P{^Is_General_Category=ps}', "");
    Expect(1, 65378, '\p{Is_General_Category=_PS}', "");
    Expect(0, 65378, '\p{^Is_General_Category=_PS}', "");
    Expect(0, 65378, '\P{Is_General_Category=_PS}', "");
    Expect(1, 65378, '\P{^Is_General_Category=_PS}', "");
    Expect(0, 65379, '\p{Is_General_Category=_PS}', "");
    Expect(1, 65379, '\p{^Is_General_Category=_PS}', "");
    Expect(1, 65379, '\P{Is_General_Category=_PS}', "");
    Expect(0, 65379, '\P{^Is_General_Category=_PS}', "");
    Error('\p{Is_Gc=:=	open_PUNCTUATION}');
    Error('\P{Is_Gc=:=	open_PUNCTUATION}');
    Expect(1, 65378, '\p{Is_Gc: openpunctuation}', "");
    Expect(0, 65378, '\p{^Is_Gc: openpunctuation}', "");
    Expect(0, 65378, '\P{Is_Gc: openpunctuation}', "");
    Expect(1, 65378, '\P{^Is_Gc: openpunctuation}', "");
    Expect(0, 65379, '\p{Is_Gc: openpunctuation}', "");
    Expect(1, 65379, '\p{^Is_Gc: openpunctuation}', "");
    Expect(1, 65379, '\P{Is_Gc: openpunctuation}', "");
    Expect(0, 65379, '\P{^Is_Gc: openpunctuation}', "");
    Expect(1, 65378, '\p{Is_Gc=_	OPEN_Punctuation}', "");
    Expect(0, 65378, '\p{^Is_Gc=_	OPEN_Punctuation}', "");
    Expect(0, 65378, '\P{Is_Gc=_	OPEN_Punctuation}', "");
    Expect(1, 65378, '\P{^Is_Gc=_	OPEN_Punctuation}', "");
    Expect(0, 65379, '\p{Is_Gc=_	OPEN_Punctuation}', "");
    Expect(1, 65379, '\p{^Is_Gc=_	OPEN_Punctuation}', "");
    Expect(1, 65379, '\P{Is_Gc=_	OPEN_Punctuation}', "");
    Expect(0, 65379, '\P{^Is_Gc=_	OPEN_Punctuation}', "");
    Error('\p{Is_Category:	-ps/a/}');
    Error('\P{Is_Category:	-ps/a/}');
    Expect(1, 65378, '\p{Is_Category=ps}', "");
    Expect(0, 65378, '\p{^Is_Category=ps}', "");
    Expect(0, 65378, '\P{Is_Category=ps}', "");
    Expect(1, 65378, '\P{^Is_Category=ps}', "");
    Expect(0, 65379, '\p{Is_Category=ps}', "");
    Expect(1, 65379, '\p{^Is_Category=ps}', "");
    Expect(1, 65379, '\P{Is_Category=ps}', "");
    Expect(0, 65379, '\P{^Is_Category=ps}', "");
    Expect(1, 65378, '\p{Is_Category=-PS}', "");
    Expect(0, 65378, '\p{^Is_Category=-PS}', "");
    Expect(0, 65378, '\P{Is_Category=-PS}', "");
    Expect(1, 65378, '\P{^Is_Category=-PS}', "");
    Expect(0, 65379, '\p{Is_Category=-PS}', "");
    Expect(1, 65379, '\p{^Is_Category=-PS}', "");
    Expect(1, 65379, '\P{Is_Category=-PS}', "");
    Expect(0, 65379, '\P{^Is_Category=-PS}', "");
    Error('\p{General_Category=:=  Symbol}');
    Error('\P{General_Category=:=  Symbol}');
    Expect(1, 129994, '\p{General_Category=:\ASymbol\z:}', "");;
    Expect(0, 129995, '\p{General_Category=:\ASymbol\z:}', "");;
    Expect(1, 129994, '\p{General_Category=symbol}', "");
    Expect(0, 129994, '\p{^General_Category=symbol}', "");
    Expect(0, 129994, '\P{General_Category=symbol}', "");
    Expect(1, 129994, '\P{^General_Category=symbol}', "");
    Expect(0, 129995, '\p{General_Category=symbol}', "");
    Expect(1, 129995, '\p{^General_Category=symbol}', "");
    Expect(1, 129995, '\P{General_Category=symbol}', "");
    Expect(0, 129995, '\P{^General_Category=symbol}', "");
    Expect(1, 129994, '\p{General_Category=:\Asymbol\z:}', "");;
    Expect(0, 129995, '\p{General_Category=:\Asymbol\z:}', "");;
    Expect(1, 129994, '\p{General_Category=__Symbol}', "");
    Expect(0, 129994, '\p{^General_Category=__Symbol}', "");
    Expect(0, 129994, '\P{General_Category=__Symbol}', "");
    Expect(1, 129994, '\P{^General_Category=__Symbol}', "");
    Expect(0, 129995, '\p{General_Category=__Symbol}', "");
    Expect(1, 129995, '\p{^General_Category=__Symbol}', "");
    Expect(1, 129995, '\P{General_Category=__Symbol}', "");
    Expect(0, 129995, '\P{^General_Category=__Symbol}', "");
    Error('\p{Gc=- S/a/}');
    Error('\P{Gc=- S/a/}');
    Expect(1, 129994, '\p{Gc=:\AS\z:}', "");;
    Expect(0, 129995, '\p{Gc=:\AS\z:}', "");;
    Expect(1, 129994, '\p{Gc=s}', "");
    Expect(0, 129994, '\p{^Gc=s}', "");
    Expect(0, 129994, '\P{Gc=s}', "");
    Expect(1, 129994, '\P{^Gc=s}', "");
    Expect(0, 129995, '\p{Gc=s}', "");
    Expect(1, 129995, '\p{^Gc=s}', "");
    Expect(1, 129995, '\P{Gc=s}', "");
    Expect(0, 129995, '\P{^Gc=s}', "");
    Expect(1, 129994, '\p{Gc=:\As\z:}', "");;
    Expect(0, 129995, '\p{Gc=:\As\z:}', "");;
    Expect(1, 129994, '\p{Gc: 	s}', "");
    Expect(0, 129994, '\p{^Gc: 	s}', "");
    Expect(0, 129994, '\P{Gc: 	s}', "");
    Expect(1, 129994, '\P{^Gc: 	s}', "");
    Expect(0, 129995, '\p{Gc: 	s}', "");
    Expect(1, 129995, '\p{^Gc: 	s}', "");
    Expect(1, 129995, '\P{Gc: 	s}', "");
    Expect(0, 129995, '\P{^Gc: 	s}', "");
    Error('\p{Category= SYMBOL:=}');
    Error('\P{Category= SYMBOL:=}');
    Expect(1, 129994, '\p{Category=:\ASymbol\z:}', "");;
    Expect(0, 129995, '\p{Category=:\ASymbol\z:}', "");;
    Expect(1, 129994, '\p{Category=symbol}', "");
    Expect(0, 129994, '\p{^Category=symbol}', "");
    Expect(0, 129994, '\P{Category=symbol}', "");
    Expect(1, 129994, '\P{^Category=symbol}', "");
    Expect(0, 129995, '\p{Category=symbol}', "");
    Expect(1, 129995, '\p{^Category=symbol}', "");
    Expect(1, 129995, '\P{Category=symbol}', "");
    Expect(0, 129995, '\P{^Category=symbol}', "");
    Expect(1, 129994, '\p{Category=:\Asymbol\z:}', "");;
    Expect(0, 129995, '\p{Category=:\Asymbol\z:}', "");;
    Expect(1, 129994, '\p{Category:     SYMBOL}', "");
    Expect(0, 129994, '\p{^Category:     SYMBOL}', "");
    Expect(0, 129994, '\P{Category:     SYMBOL}', "");
    Expect(1, 129994, '\P{^Category:     SYMBOL}', "");
    Expect(0, 129995, '\p{Category:     SYMBOL}', "");
    Expect(1, 129995, '\p{^Category:     SYMBOL}', "");
    Expect(1, 129995, '\P{Category:     SYMBOL}', "");
    Expect(0, 129995, '\P{^Category:     SYMBOL}', "");
    Error('\p{Is_General_Category=_:=S}');
    Error('\P{Is_General_Category=_:=S}');
    Expect(1, 129994, '\p{Is_General_Category=s}', "");
    Expect(0, 129994, '\p{^Is_General_Category=s}', "");
    Expect(0, 129994, '\P{Is_General_Category=s}', "");
    Expect(1, 129994, '\P{^Is_General_Category=s}', "");
    Expect(0, 129995, '\p{Is_General_Category=s}', "");
    Expect(1, 129995, '\p{^Is_General_Category=s}', "");
    Expect(1, 129995, '\P{Is_General_Category=s}', "");
    Expect(0, 129995, '\P{^Is_General_Category=s}', "");
    Expect(1, 129994, '\p{Is_General_Category=_-S}', "");
    Expect(0, 129994, '\p{^Is_General_Category=_-S}', "");
    Expect(0, 129994, '\P{Is_General_Category=_-S}', "");
    Expect(1, 129994, '\P{^Is_General_Category=_-S}', "");
    Expect(0, 129995, '\p{Is_General_Category=_-S}', "");
    Expect(1, 129995, '\p{^Is_General_Category=_-S}', "");
    Expect(1, 129995, '\P{Is_General_Category=_-S}', "");
    Expect(0, 129995, '\P{^Is_General_Category=_-S}', "");
    Error('\p{Is_Gc=	_Symbol:=}');
    Error('\P{Is_Gc=	_Symbol:=}');
    Expect(1, 129994, '\p{Is_Gc=symbol}', "");
    Expect(0, 129994, '\p{^Is_Gc=symbol}', "");
    Expect(0, 129994, '\P{Is_Gc=symbol}', "");
    Expect(1, 129994, '\P{^Is_Gc=symbol}', "");
    Expect(0, 129995, '\p{Is_Gc=symbol}', "");
    Expect(1, 129995, '\p{^Is_Gc=symbol}', "");
    Expect(1, 129995, '\P{Is_Gc=symbol}', "");
    Expect(0, 129995, '\P{^Is_Gc=symbol}', "");
    Expect(1, 129994, '\p{Is_Gc=_SYMBOL}', "");
    Expect(0, 129994, '\p{^Is_Gc=_SYMBOL}', "");
    Expect(0, 129994, '\P{Is_Gc=_SYMBOL}', "");
    Expect(1, 129994, '\P{^Is_Gc=_SYMBOL}', "");
    Expect(0, 129995, '\p{Is_Gc=_SYMBOL}', "");
    Expect(1, 129995, '\p{^Is_Gc=_SYMBOL}', "");
    Expect(1, 129995, '\P{Is_Gc=_SYMBOL}', "");
    Expect(0, 129995, '\P{^Is_Gc=_SYMBOL}', "");
    Error('\p{Is_Category=/a/	 S}');
    Error('\P{Is_Category=/a/	 S}');
    Expect(1, 129994, '\p{Is_Category=s}', "");
    Expect(0, 129994, '\p{^Is_Category=s}', "");
    Expect(0, 129994, '\P{Is_Category=s}', "");
    Expect(1, 129994, '\P{^Is_Category=s}', "");
    Expect(0, 129995, '\p{Is_Category=s}', "");
    Expect(1, 129995, '\p{^Is_Category=s}', "");
    Expect(1, 129995, '\P{Is_Category=s}', "");
    Expect(0, 129995, '\P{^Is_Category=s}', "");
    Expect(1, 129994, '\p{Is_Category=_-S}', "");
    Expect(0, 129994, '\p{^Is_Category=_-S}', "");
    Expect(0, 129994, '\P{Is_Category=_-S}', "");
    Expect(1, 129994, '\P{^Is_Category=_-S}', "");
    Expect(0, 129995, '\p{Is_Category=_-S}', "");
    Expect(1, 129995, '\p{^Is_Category=_-S}', "");
    Expect(1, 129995, '\P{Is_Category=_-S}', "");
    Expect(0, 129995, '\P{^Is_Category=_-S}', "");
    Error('\p{General_Category=/a/		CURRENCY_SYMBOL}');
    Error('\P{General_Category=/a/		CURRENCY_SYMBOL}');
    Expect(1, 126128, '\p{General_Category=:\ACurrency_Symbol\z:}', "");;
    Expect(0, 126129, '\p{General_Category=:\ACurrency_Symbol\z:}', "");;
    Expect(1, 126128, '\p{General_Category=currencysymbol}', "");
    Expect(0, 126128, '\p{^General_Category=currencysymbol}', "");
    Expect(0, 126128, '\P{General_Category=currencysymbol}', "");
    Expect(1, 126128, '\P{^General_Category=currencysymbol}', "");
    Expect(0, 126129, '\p{General_Category=currencysymbol}', "");
    Expect(1, 126129, '\p{^General_Category=currencysymbol}', "");
    Expect(1, 126129, '\P{General_Category=currencysymbol}', "");
    Expect(0, 126129, '\P{^General_Category=currencysymbol}', "");
    Expect(1, 126128, '\p{General_Category=:\Acurrencysymbol\z:}', "");;
    Expect(0, 126129, '\p{General_Category=:\Acurrencysymbol\z:}', "");;
    Expect(1, 126128, '\p{General_Category=--CURRENCY_Symbol}', "");
    Expect(0, 126128, '\p{^General_Category=--CURRENCY_Symbol}', "");
    Expect(0, 126128, '\P{General_Category=--CURRENCY_Symbol}', "");
    Expect(1, 126128, '\P{^General_Category=--CURRENCY_Symbol}', "");
    Expect(0, 126129, '\p{General_Category=--CURRENCY_Symbol}', "");
    Expect(1, 126129, '\p{^General_Category=--CURRENCY_Symbol}', "");
    Expect(1, 126129, '\P{General_Category=--CURRENCY_Symbol}', "");
    Expect(0, 126129, '\P{^General_Category=--CURRENCY_Symbol}', "");
    Error('\p{Gc=:=__Sc}');
    Error('\P{Gc=:=__Sc}');
    Expect(1, 126128, '\p{Gc=:\ASc\z:}', "");;
    Expect(0, 126129, '\p{Gc=:\ASc\z:}', "");;
    Expect(1, 126128, '\p{Gc=sc}', "");
    Expect(0, 126128, '\p{^Gc=sc}', "");
    Expect(0, 126128, '\P{Gc=sc}', "");
    Expect(1, 126128, '\P{^Gc=sc}', "");
    Expect(0, 126129, '\p{Gc=sc}', "");
    Expect(1, 126129, '\p{^Gc=sc}', "");
    Expect(1, 126129, '\P{Gc=sc}', "");
    Expect(0, 126129, '\P{^Gc=sc}', "");
    Expect(1, 126128, '\p{Gc=:\Asc\z:}', "");;
    Expect(0, 126129, '\p{Gc=:\Asc\z:}', "");;
    Expect(1, 126128, '\p{Gc=_ sc}', "");
    Expect(0, 126128, '\p{^Gc=_ sc}', "");
    Expect(0, 126128, '\P{Gc=_ sc}', "");
    Expect(1, 126128, '\P{^Gc=_ sc}', "");
    Expect(0, 126129, '\p{Gc=_ sc}', "");
    Expect(1, 126129, '\p{^Gc=_ sc}', "");
    Expect(1, 126129, '\P{Gc=_ sc}', "");
    Expect(0, 126129, '\P{^Gc=_ sc}', "");
    Error('\p{Category= /a/Currency_SYMBOL}');
    Error('\P{Category= /a/Currency_SYMBOL}');
    Expect(1, 126128, '\p{Category=:\ACurrency_Symbol\z:}', "");;
    Expect(0, 126129, '\p{Category=:\ACurrency_Symbol\z:}', "");;
    Expect(1, 126128, '\p{Category=currencysymbol}', "");
    Expect(0, 126128, '\p{^Category=currencysymbol}', "");
    Expect(0, 126128, '\P{Category=currencysymbol}', "");
    Expect(1, 126128, '\P{^Category=currencysymbol}', "");
    Expect(0, 126129, '\p{Category=currencysymbol}', "");
    Expect(1, 126129, '\p{^Category=currencysymbol}', "");
    Expect(1, 126129, '\P{Category=currencysymbol}', "");
    Expect(0, 126129, '\P{^Category=currencysymbol}', "");
    Expect(1, 126128, '\p{Category=:\Acurrencysymbol\z:}', "");;
    Expect(0, 126129, '\p{Category=:\Acurrencysymbol\z:}', "");;
    Expect(1, 126128, '\p{Category:   --currency_Symbol}', "");
    Expect(0, 126128, '\p{^Category:   --currency_Symbol}', "");
    Expect(0, 126128, '\P{Category:   --currency_Symbol}', "");
    Expect(1, 126128, '\P{^Category:   --currency_Symbol}', "");
    Expect(0, 126129, '\p{Category:   --currency_Symbol}', "");
    Expect(1, 126129, '\p{^Category:   --currency_Symbol}', "");
    Expect(1, 126129, '\P{Category:   --currency_Symbol}', "");
    Expect(0, 126129, '\P{^Category:   --currency_Symbol}', "");
    Error('\p{Is_General_Category=:=_ Sc}');
    Error('\P{Is_General_Category=:=_ Sc}');
    Expect(1, 126128, '\p{Is_General_Category=sc}', "");
    Expect(0, 126128, '\p{^Is_General_Category=sc}', "");
    Expect(0, 126128, '\P{Is_General_Category=sc}', "");
    Expect(1, 126128, '\P{^Is_General_Category=sc}', "");
    Expect(0, 126129, '\p{Is_General_Category=sc}', "");
    Expect(1, 126129, '\p{^Is_General_Category=sc}', "");
    Expect(1, 126129, '\P{Is_General_Category=sc}', "");
    Expect(0, 126129, '\P{^Is_General_Category=sc}', "");
    Error('\p{Is_Gc=/a/  currency_Symbol}');
    Error('\P{Is_Gc=/a/  currency_Symbol}');
    Expect(1, 126128, '\p{Is_Gc=currencysymbol}', "");
    Expect(0, 126128, '\p{^Is_Gc=currencysymbol}', "");
    Expect(0, 126128, '\P{Is_Gc=currencysymbol}', "");
    Expect(1, 126128, '\P{^Is_Gc=currencysymbol}', "");
    Expect(0, 126129, '\p{Is_Gc=currencysymbol}', "");
    Expect(1, 126129, '\p{^Is_Gc=currencysymbol}', "");
    Expect(1, 126129, '\P{Is_Gc=currencysymbol}', "");
    Expect(0, 126129, '\P{^Is_Gc=currencysymbol}', "");
    Expect(1, 126128, '\p{Is_Gc:	CURRENCY_symbol}', "");
    Expect(0, 126128, '\p{^Is_Gc:	CURRENCY_symbol}', "");
    Expect(0, 126128, '\P{Is_Gc:	CURRENCY_symbol}', "");
    Expect(1, 126128, '\P{^Is_Gc:	CURRENCY_symbol}', "");
    Expect(0, 126129, '\p{Is_Gc:	CURRENCY_symbol}', "");
    Expect(1, 126129, '\p{^Is_Gc:	CURRENCY_symbol}', "");
    Expect(1, 126129, '\P{Is_Gc:	CURRENCY_symbol}', "");
    Expect(0, 126129, '\P{^Is_Gc:	CURRENCY_symbol}', "");
    Error('\p{Is_Category= Sc/a/}');
    Error('\P{Is_Category= Sc/a/}');
    Expect(1, 126128, '\p{Is_Category=sc}', "");
    Expect(0, 126128, '\p{^Is_Category=sc}', "");
    Expect(0, 126128, '\P{Is_Category=sc}', "");
    Expect(1, 126128, '\P{^Is_Category=sc}', "");
    Expect(0, 126129, '\p{Is_Category=sc}', "");
    Expect(1, 126129, '\p{^Is_Category=sc}', "");
    Expect(1, 126129, '\P{Is_Category=sc}', "");
    Expect(0, 126129, '\P{^Is_Category=sc}', "");
    Expect(1, 126128, '\p{Is_Category: 	_Sc}', "");
    Expect(0, 126128, '\p{^Is_Category: 	_Sc}', "");
    Expect(0, 126128, '\P{Is_Category: 	_Sc}', "");
    Expect(1, 126128, '\P{^Is_Category: 	_Sc}', "");
    Expect(0, 126129, '\p{Is_Category: 	_Sc}', "");
    Expect(1, 126129, '\p{^Is_Category: 	_Sc}', "");
    Expect(1, 126129, '\P{Is_Category: 	_Sc}', "");
    Expect(0, 126129, '\P{^Is_Category: 	_Sc}', "");
    Error('\p{General_Category=/a/_modifier_SYMBOL}');
    Error('\P{General_Category=/a/_modifier_SYMBOL}');
    Expect(1, 127999, '\p{General_Category=:\AModifier_Symbol\z:}', "");;
    Expect(0, 128000, '\p{General_Category=:\AModifier_Symbol\z:}', "");;
    Expect(1, 127999, '\p{General_Category=modifiersymbol}', "");
    Expect(0, 127999, '\p{^General_Category=modifiersymbol}', "");
    Expect(0, 127999, '\P{General_Category=modifiersymbol}', "");
    Expect(1, 127999, '\P{^General_Category=modifiersymbol}', "");
    Expect(0, 128000, '\p{General_Category=modifiersymbol}', "");
    Expect(1, 128000, '\p{^General_Category=modifiersymbol}', "");
    Expect(1, 128000, '\P{General_Category=modifiersymbol}', "");
    Expect(0, 128000, '\P{^General_Category=modifiersymbol}', "");
    Expect(1, 127999, '\p{General_Category=:\Amodifiersymbol\z:}', "");;
    Expect(0, 128000, '\p{General_Category=:\Amodifiersymbol\z:}', "");;
    Expect(1, 127999, '\p{General_Category:	_	Modifier_Symbol}', "");
    Expect(0, 127999, '\p{^General_Category:	_	Modifier_Symbol}', "");
    Expect(0, 127999, '\P{General_Category:	_	Modifier_Symbol}', "");
    Expect(1, 127999, '\P{^General_Category:	_	Modifier_Symbol}', "");
    Expect(0, 128000, '\p{General_Category:	_	Modifier_Symbol}', "");
    Expect(1, 128000, '\p{^General_Category:	_	Modifier_Symbol}', "");
    Expect(1, 128000, '\P{General_Category:	_	Modifier_Symbol}', "");
    Expect(0, 128000, '\P{^General_Category:	_	Modifier_Symbol}', "");
    Error('\p{Gc:-SK:=}');
    Error('\P{Gc:-SK:=}');
    Expect(1, 127999, '\p{Gc=:\ASk\z:}', "");;
    Expect(0, 128000, '\p{Gc=:\ASk\z:}', "");;
    Expect(1, 127999, '\p{Gc=sk}', "");
    Expect(0, 127999, '\p{^Gc=sk}', "");
    Expect(0, 127999, '\P{Gc=sk}', "");
    Expect(1, 127999, '\P{^Gc=sk}', "");
    Expect(0, 128000, '\p{Gc=sk}', "");
    Expect(1, 128000, '\p{^Gc=sk}', "");
    Expect(1, 128000, '\P{Gc=sk}', "");
    Expect(0, 128000, '\P{^Gc=sk}', "");
    Expect(1, 127999, '\p{Gc=:\Ask\z:}', "");;
    Expect(0, 128000, '\p{Gc=:\Ask\z:}', "");;
    Expect(1, 127999, '\p{Gc=  sk}', "");
    Expect(0, 127999, '\p{^Gc=  sk}', "");
    Expect(0, 127999, '\P{Gc=  sk}', "");
    Expect(1, 127999, '\P{^Gc=  sk}', "");
    Expect(0, 128000, '\p{Gc=  sk}', "");
    Expect(1, 128000, '\p{^Gc=  sk}', "");
    Expect(1, 128000, '\P{Gc=  sk}', "");
    Expect(0, 128000, '\P{^Gc=  sk}', "");
    Error('\p{Category=-/a/modifier_SYMBOL}');
    Error('\P{Category=-/a/modifier_SYMBOL}');
    Expect(1, 127999, '\p{Category=:\AModifier_Symbol\z:}', "");;
    Expect(0, 128000, '\p{Category=:\AModifier_Symbol\z:}', "");;
    Expect(1, 127999, '\p{Category:modifiersymbol}', "");
    Expect(0, 127999, '\p{^Category:modifiersymbol}', "");
    Expect(0, 127999, '\P{Category:modifiersymbol}', "");
    Expect(1, 127999, '\P{^Category:modifiersymbol}', "");
    Expect(0, 128000, '\p{Category:modifiersymbol}', "");
    Expect(1, 128000, '\p{^Category:modifiersymbol}', "");
    Expect(1, 128000, '\P{Category:modifiersymbol}', "");
    Expect(0, 128000, '\P{^Category:modifiersymbol}', "");
    Expect(1, 127999, '\p{Category=:\Amodifiersymbol\z:}', "");;
    Expect(0, 128000, '\p{Category=:\Amodifiersymbol\z:}', "");;
    Expect(1, 127999, '\p{Category= MODIFIER_symbol}', "");
    Expect(0, 127999, '\p{^Category= MODIFIER_symbol}', "");
    Expect(0, 127999, '\P{Category= MODIFIER_symbol}', "");
    Expect(1, 127999, '\P{^Category= MODIFIER_symbol}', "");
    Expect(0, 128000, '\p{Category= MODIFIER_symbol}', "");
    Expect(1, 128000, '\p{^Category= MODIFIER_symbol}', "");
    Expect(1, 128000, '\P{Category= MODIFIER_symbol}', "");
    Expect(0, 128000, '\P{^Category= MODIFIER_symbol}', "");
    Error('\p{Is_General_Category=:=--Sk}');
    Error('\P{Is_General_Category=:=--Sk}');
    Expect(1, 127999, '\p{Is_General_Category=sk}', "");
    Expect(0, 127999, '\p{^Is_General_Category=sk}', "");
    Expect(0, 127999, '\P{Is_General_Category=sk}', "");
    Expect(1, 127999, '\P{^Is_General_Category=sk}', "");
    Expect(0, 128000, '\p{Is_General_Category=sk}', "");
    Expect(1, 128000, '\p{^Is_General_Category=sk}', "");
    Expect(1, 128000, '\P{Is_General_Category=sk}', "");
    Expect(0, 128000, '\P{^Is_General_Category=sk}', "");
    Expect(1, 127999, '\p{Is_General_Category=_	SK}', "");
    Expect(0, 127999, '\p{^Is_General_Category=_	SK}', "");
    Expect(0, 127999, '\P{Is_General_Category=_	SK}', "");
    Expect(1, 127999, '\P{^Is_General_Category=_	SK}', "");
    Expect(0, 128000, '\p{Is_General_Category=_	SK}', "");
    Expect(1, 128000, '\p{^Is_General_Category=_	SK}', "");
    Expect(1, 128000, '\P{Is_General_Category=_	SK}', "");
    Expect(0, 128000, '\P{^Is_General_Category=_	SK}', "");
    Error('\p{Is_Gc=_/a/MODIFIER_Symbol}');
    Error('\P{Is_Gc=_/a/MODIFIER_Symbol}');
    Expect(1, 127999, '\p{Is_Gc=modifiersymbol}', "");
    Expect(0, 127999, '\p{^Is_Gc=modifiersymbol}', "");
    Expect(0, 127999, '\P{Is_Gc=modifiersymbol}', "");
    Expect(1, 127999, '\P{^Is_Gc=modifiersymbol}', "");
    Expect(0, 128000, '\p{Is_Gc=modifiersymbol}', "");
    Expect(1, 128000, '\p{^Is_Gc=modifiersymbol}', "");
    Expect(1, 128000, '\P{Is_Gc=modifiersymbol}', "");
    Expect(0, 128000, '\P{^Is_Gc=modifiersymbol}', "");
    Expect(1, 127999, '\p{Is_Gc:   	modifier_Symbol}', "");
    Expect(0, 127999, '\p{^Is_Gc:   	modifier_Symbol}', "");
    Expect(0, 127999, '\P{Is_Gc:   	modifier_Symbol}', "");
    Expect(1, 127999, '\P{^Is_Gc:   	modifier_Symbol}', "");
    Expect(0, 128000, '\p{Is_Gc:   	modifier_Symbol}', "");
    Expect(1, 128000, '\p{^Is_Gc:   	modifier_Symbol}', "");
    Expect(1, 128000, '\P{Is_Gc:   	modifier_Symbol}', "");
    Expect(0, 128000, '\P{^Is_Gc:   	modifier_Symbol}', "");
    Error('\p{Is_Category=		Sk:=}');
    Error('\P{Is_Category=		Sk:=}');
    Expect(1, 127999, '\p{Is_Category=sk}', "");
    Expect(0, 127999, '\p{^Is_Category=sk}', "");
    Expect(0, 127999, '\P{Is_Category=sk}', "");
    Expect(1, 127999, '\P{^Is_Category=sk}', "");
    Expect(0, 128000, '\p{Is_Category=sk}', "");
    Expect(1, 128000, '\p{^Is_Category=sk}', "");
    Expect(1, 128000, '\P{Is_Category=sk}', "");
    Expect(0, 128000, '\P{^Is_Category=sk}', "");
    Expect(1, 127999, '\p{Is_Category=		SK}', "");
    Expect(0, 127999, '\p{^Is_Category=		SK}', "");
    Expect(0, 127999, '\P{Is_Category=		SK}', "");
    Expect(1, 127999, '\P{^Is_Category=		SK}', "");
    Expect(0, 128000, '\p{Is_Category=		SK}', "");
    Expect(1, 128000, '\p{^Is_Category=		SK}', "");
    Expect(1, 128000, '\P{Is_Category=		SK}', "");
    Expect(0, 128000, '\P{^Is_Category=		SK}', "");
    Error('\p{General_Category=/a/math_symbol}');
    Error('\P{General_Category=/a/math_symbol}');
    Expect(1, 126705, '\p{General_Category=:\AMath_Symbol\z:}', "");;
    Expect(0, 126706, '\p{General_Category=:\AMath_Symbol\z:}', "");;
    Expect(1, 126705, '\p{General_Category=mathsymbol}', "");
    Expect(0, 126705, '\p{^General_Category=mathsymbol}', "");
    Expect(0, 126705, '\P{General_Category=mathsymbol}', "");
    Expect(1, 126705, '\P{^General_Category=mathsymbol}', "");
    Expect(0, 126706, '\p{General_Category=mathsymbol}', "");
    Expect(1, 126706, '\p{^General_Category=mathsymbol}', "");
    Expect(1, 126706, '\P{General_Category=mathsymbol}', "");
    Expect(0, 126706, '\P{^General_Category=mathsymbol}', "");
    Expect(1, 126705, '\p{General_Category=:\Amathsymbol\z:}', "");;
    Expect(0, 126706, '\p{General_Category=:\Amathsymbol\z:}', "");;
    Expect(1, 126705, '\p{General_Category: _-MATH_Symbol}', "");
    Expect(0, 126705, '\p{^General_Category: _-MATH_Symbol}', "");
    Expect(0, 126705, '\P{General_Category: _-MATH_Symbol}', "");
    Expect(1, 126705, '\P{^General_Category: _-MATH_Symbol}', "");
    Expect(0, 126706, '\p{General_Category: _-MATH_Symbol}', "");
    Expect(1, 126706, '\p{^General_Category: _-MATH_Symbol}', "");
    Expect(1, 126706, '\P{General_Category: _-MATH_Symbol}', "");
    Expect(0, 126706, '\P{^General_Category: _-MATH_Symbol}', "");
    Error('\p{Gc=-:=Sm}');
    Error('\P{Gc=-:=Sm}');
    Expect(1, 126705, '\p{Gc=:\ASm\z:}', "");;
    Expect(0, 126706, '\p{Gc=:\ASm\z:}', "");;
    Expect(1, 126705, '\p{Gc=sm}', "");
    Expect(0, 126705, '\p{^Gc=sm}', "");
    Expect(0, 126705, '\P{Gc=sm}', "");
    Expect(1, 126705, '\P{^Gc=sm}', "");
    Expect(0, 126706, '\p{Gc=sm}', "");
    Expect(1, 126706, '\p{^Gc=sm}', "");
    Expect(1, 126706, '\P{Gc=sm}', "");
    Expect(0, 126706, '\P{^Gc=sm}', "");
    Expect(1, 126705, '\p{Gc=:\Asm\z:}', "");;
    Expect(0, 126706, '\p{Gc=:\Asm\z:}', "");;
    Expect(1, 126705, '\p{Gc=	-SM}', "");
    Expect(0, 126705, '\p{^Gc=	-SM}', "");
    Expect(0, 126705, '\P{Gc=	-SM}', "");
    Expect(1, 126705, '\P{^Gc=	-SM}', "");
    Expect(0, 126706, '\p{Gc=	-SM}', "");
    Expect(1, 126706, '\p{^Gc=	-SM}', "");
    Expect(1, 126706, '\P{Gc=	-SM}', "");
    Expect(0, 126706, '\P{^Gc=	-SM}', "");
    Error('\p{Category:	_	MATH_symbol:=}');
    Error('\P{Category:	_	MATH_symbol:=}');
    Expect(1, 126705, '\p{Category=:\AMath_Symbol\z:}', "");;
    Expect(0, 126706, '\p{Category=:\AMath_Symbol\z:}', "");;
    Expect(1, 126705, '\p{Category=mathsymbol}', "");
    Expect(0, 126705, '\p{^Category=mathsymbol}', "");
    Expect(0, 126705, '\P{Category=mathsymbol}', "");
    Expect(1, 126705, '\P{^Category=mathsymbol}', "");
    Expect(0, 126706, '\p{Category=mathsymbol}', "");
    Expect(1, 126706, '\p{^Category=mathsymbol}', "");
    Expect(1, 126706, '\P{Category=mathsymbol}', "");
    Expect(0, 126706, '\P{^Category=mathsymbol}', "");
    Expect(1, 126705, '\p{Category=:\Amathsymbol\z:}', "");;
    Expect(0, 126706, '\p{Category=:\Amathsymbol\z:}', "");;
    Expect(1, 126705, '\p{Category= _Math_Symbol}', "");
    Expect(0, 126705, '\p{^Category= _Math_Symbol}', "");
    Expect(0, 126705, '\P{Category= _Math_Symbol}', "");
    Expect(1, 126705, '\P{^Category= _Math_Symbol}', "");
    Expect(0, 126706, '\p{Category= _Math_Symbol}', "");
    Expect(1, 126706, '\p{^Category= _Math_Symbol}', "");
    Expect(1, 126706, '\P{Category= _Math_Symbol}', "");
    Expect(0, 126706, '\P{^Category= _Math_Symbol}', "");
    Error('\p{Is_General_Category= :=Sm}');
    Error('\P{Is_General_Category= :=Sm}');
    Expect(1, 126705, '\p{Is_General_Category:   sm}', "");
    Expect(0, 126705, '\p{^Is_General_Category:   sm}', "");
    Expect(0, 126705, '\P{Is_General_Category:   sm}', "");
    Expect(1, 126705, '\P{^Is_General_Category:   sm}', "");
    Expect(0, 126706, '\p{Is_General_Category:   sm}', "");
    Expect(1, 126706, '\p{^Is_General_Category:   sm}', "");
    Expect(1, 126706, '\P{Is_General_Category:   sm}', "");
    Expect(0, 126706, '\P{^Is_General_Category:   sm}', "");
    Expect(1, 126705, '\p{Is_General_Category= _sm}', "");
    Expect(0, 126705, '\p{^Is_General_Category= _sm}', "");
    Expect(0, 126705, '\P{Is_General_Category= _sm}', "");
    Expect(1, 126705, '\P{^Is_General_Category= _sm}', "");
    Expect(0, 126706, '\p{Is_General_Category= _sm}', "");
    Expect(1, 126706, '\p{^Is_General_Category= _sm}', "");
    Expect(1, 126706, '\P{Is_General_Category= _sm}', "");
    Expect(0, 126706, '\P{^Is_General_Category= _sm}', "");
    Error('\p{Is_Gc=:= Math_Symbol}');
    Error('\P{Is_Gc=:= Math_Symbol}');
    Expect(1, 126705, '\p{Is_Gc=mathsymbol}', "");
    Expect(0, 126705, '\p{^Is_Gc=mathsymbol}', "");
    Expect(0, 126705, '\P{Is_Gc=mathsymbol}', "");
    Expect(1, 126705, '\P{^Is_Gc=mathsymbol}', "");
    Expect(0, 126706, '\p{Is_Gc=mathsymbol}', "");
    Expect(1, 126706, '\p{^Is_Gc=mathsymbol}', "");
    Expect(1, 126706, '\P{Is_Gc=mathsymbol}', "");
    Expect(0, 126706, '\P{^Is_Gc=mathsymbol}', "");
    Expect(1, 126705, '\p{Is_Gc=	math_Symbol}', "");
    Expect(0, 126705, '\p{^Is_Gc=	math_Symbol}', "");
    Expect(0, 126705, '\P{Is_Gc=	math_Symbol}', "");
    Expect(1, 126705, '\P{^Is_Gc=	math_Symbol}', "");
    Expect(0, 126706, '\p{Is_Gc=	math_Symbol}', "");
    Expect(1, 126706, '\p{^Is_Gc=	math_Symbol}', "");
    Expect(1, 126706, '\P{Is_Gc=	math_Symbol}', "");
    Expect(0, 126706, '\P{^Is_Gc=	math_Symbol}', "");
    Error('\p{Is_Category=:=-Sm}');
    Error('\P{Is_Category=:=-Sm}');
    Expect(1, 126705, '\p{Is_Category=sm}', "");
    Expect(0, 126705, '\p{^Is_Category=sm}', "");
    Expect(0, 126705, '\P{Is_Category=sm}', "");
    Expect(1, 126705, '\P{^Is_Category=sm}', "");
    Expect(0, 126706, '\p{Is_Category=sm}', "");
    Expect(1, 126706, '\p{^Is_Category=sm}', "");
    Expect(1, 126706, '\P{Is_Category=sm}', "");
    Expect(0, 126706, '\P{^Is_Category=sm}', "");
    Expect(1, 126705, '\p{Is_Category= _Sm}', "");
    Expect(0, 126705, '\p{^Is_Category= _Sm}', "");
    Expect(0, 126705, '\P{Is_Category= _Sm}', "");
    Expect(1, 126705, '\P{^Is_Category= _Sm}', "");
    Expect(0, 126706, '\p{Is_Category= _Sm}', "");
    Expect(1, 126706, '\p{^Is_Category= _Sm}', "");
    Expect(1, 126706, '\P{Is_Category= _Sm}', "");
    Expect(0, 126706, '\P{^Is_Category= _Sm}', "");
    Error('\p{General_Category= -Other_Symbol:=}');
    Error('\P{General_Category= -Other_Symbol:=}');
    Expect(1, 129994, '\p{General_Category=:\AOther_Symbol\z:}', "");;
    Expect(0, 129995, '\p{General_Category=:\AOther_Symbol\z:}', "");;
    Expect(1, 129994, '\p{General_Category=othersymbol}', "");
    Expect(0, 129994, '\p{^General_Category=othersymbol}', "");
    Expect(0, 129994, '\P{General_Category=othersymbol}', "");
    Expect(1, 129994, '\P{^General_Category=othersymbol}', "");
    Expect(0, 129995, '\p{General_Category=othersymbol}', "");
    Expect(1, 129995, '\p{^General_Category=othersymbol}', "");
    Expect(1, 129995, '\P{General_Category=othersymbol}', "");
    Expect(0, 129995, '\P{^General_Category=othersymbol}', "");
    Expect(1, 129994, '\p{General_Category=:\Aothersymbol\z:}', "");;
    Expect(0, 129995, '\p{General_Category=:\Aothersymbol\z:}', "");;
    Expect(1, 129994, '\p{General_Category=	OTHER_Symbol}', "");
    Expect(0, 129994, '\p{^General_Category=	OTHER_Symbol}', "");
    Expect(0, 129994, '\P{General_Category=	OTHER_Symbol}', "");
    Expect(1, 129994, '\P{^General_Category=	OTHER_Symbol}', "");
    Expect(0, 129995, '\p{General_Category=	OTHER_Symbol}', "");
    Expect(1, 129995, '\p{^General_Category=	OTHER_Symbol}', "");
    Expect(1, 129995, '\P{General_Category=	OTHER_Symbol}', "");
    Expect(0, 129995, '\P{^General_Category=	OTHER_Symbol}', "");
    Error('\p{Gc= :=so}');
    Error('\P{Gc= :=so}');
    Expect(1, 129994, '\p{Gc=:\ASo\z:}', "");;
    Expect(0, 129995, '\p{Gc=:\ASo\z:}', "");;
    Expect(1, 129994, '\p{Gc=so}', "");
    Expect(0, 129994, '\p{^Gc=so}', "");
    Expect(0, 129994, '\P{Gc=so}', "");
    Expect(1, 129994, '\P{^Gc=so}', "");
    Expect(0, 129995, '\p{Gc=so}', "");
    Expect(1, 129995, '\p{^Gc=so}', "");
    Expect(1, 129995, '\P{Gc=so}', "");
    Expect(0, 129995, '\P{^Gc=so}', "");
    Expect(1, 129994, '\p{Gc=:\Aso\z:}', "");;
    Expect(0, 129995, '\p{Gc=:\Aso\z:}', "");;
    Expect(1, 129994, '\p{Gc: 	so}', "");
    Expect(0, 129994, '\p{^Gc: 	so}', "");
    Expect(0, 129994, '\P{Gc: 	so}', "");
    Expect(1, 129994, '\P{^Gc: 	so}', "");
    Expect(0, 129995, '\p{Gc: 	so}', "");
    Expect(1, 129995, '\p{^Gc: 	so}', "");
    Expect(1, 129995, '\P{Gc: 	so}', "");
    Expect(0, 129995, '\P{^Gc: 	so}', "");
    Error('\p{Category=	Other_SYMBOL/a/}');
    Error('\P{Category=	Other_SYMBOL/a/}');
    Expect(1, 129994, '\p{Category=:\AOther_Symbol\z:}', "");;
    Expect(0, 129995, '\p{Category=:\AOther_Symbol\z:}', "");;
    Expect(1, 129994, '\p{Category=othersymbol}', "");
    Expect(0, 129994, '\p{^Category=othersymbol}', "");
    Expect(0, 129994, '\P{Category=othersymbol}', "");
    Expect(1, 129994, '\P{^Category=othersymbol}', "");
    Expect(0, 129995, '\p{Category=othersymbol}', "");
    Expect(1, 129995, '\p{^Category=othersymbol}', "");
    Expect(1, 129995, '\P{Category=othersymbol}', "");
    Expect(0, 129995, '\P{^Category=othersymbol}', "");
    Expect(1, 129994, '\p{Category=:\Aothersymbol\z:}', "");;
    Expect(0, 129995, '\p{Category=:\Aothersymbol\z:}', "");;
    Expect(1, 129994, '\p{Category=		Other_symbol}', "");
    Expect(0, 129994, '\p{^Category=		Other_symbol}', "");
    Expect(0, 129994, '\P{Category=		Other_symbol}', "");
    Expect(1, 129994, '\P{^Category=		Other_symbol}', "");
    Expect(0, 129995, '\p{Category=		Other_symbol}', "");
    Expect(1, 129995, '\p{^Category=		Other_symbol}', "");
    Expect(1, 129995, '\P{Category=		Other_symbol}', "");
    Expect(0, 129995, '\P{^Category=		Other_symbol}', "");
    Error('\p{Is_General_Category=__SO/a/}');
    Error('\P{Is_General_Category=__SO/a/}');
    Expect(1, 129994, '\p{Is_General_Category=so}', "");
    Expect(0, 129994, '\p{^Is_General_Category=so}', "");
    Expect(0, 129994, '\P{Is_General_Category=so}', "");
    Expect(1, 129994, '\P{^Is_General_Category=so}', "");
    Expect(0, 129995, '\p{Is_General_Category=so}', "");
    Expect(1, 129995, '\p{^Is_General_Category=so}', "");
    Expect(1, 129995, '\P{Is_General_Category=so}', "");
    Expect(0, 129995, '\P{^Is_General_Category=so}', "");
    Expect(1, 129994, '\p{Is_General_Category=-_SO}', "");
    Expect(0, 129994, '\p{^Is_General_Category=-_SO}', "");
    Expect(0, 129994, '\P{Is_General_Category=-_SO}', "");
    Expect(1, 129994, '\P{^Is_General_Category=-_SO}', "");
    Expect(0, 129995, '\p{Is_General_Category=-_SO}', "");
    Expect(1, 129995, '\p{^Is_General_Category=-_SO}', "");
    Expect(1, 129995, '\P{Is_General_Category=-_SO}', "");
    Expect(0, 129995, '\P{^Is_General_Category=-_SO}', "");
    Error('\p{Is_Gc=_/a/Other_SYMBOL}');
    Error('\P{Is_Gc=_/a/Other_SYMBOL}');
    Expect(1, 129994, '\p{Is_Gc=othersymbol}', "");
    Expect(0, 129994, '\p{^Is_Gc=othersymbol}', "");
    Expect(0, 129994, '\P{Is_Gc=othersymbol}', "");
    Expect(1, 129994, '\P{^Is_Gc=othersymbol}', "");
    Expect(0, 129995, '\p{Is_Gc=othersymbol}', "");
    Expect(1, 129995, '\p{^Is_Gc=othersymbol}', "");
    Expect(1, 129995, '\P{Is_Gc=othersymbol}', "");
    Expect(0, 129995, '\P{^Is_Gc=othersymbol}', "");
    Expect(1, 129994, '\p{Is_Gc=	_OTHER_Symbol}', "");
    Expect(0, 129994, '\p{^Is_Gc=	_OTHER_Symbol}', "");
    Expect(0, 129994, '\P{Is_Gc=	_OTHER_Symbol}', "");
    Expect(1, 129994, '\P{^Is_Gc=	_OTHER_Symbol}', "");
    Expect(0, 129995, '\p{Is_Gc=	_OTHER_Symbol}', "");
    Expect(1, 129995, '\p{^Is_Gc=	_OTHER_Symbol}', "");
    Expect(1, 129995, '\P{Is_Gc=	_OTHER_Symbol}', "");
    Expect(0, 129995, '\P{^Is_Gc=	_OTHER_Symbol}', "");
    Error('\p{Is_Category=/a/ SO}');
    Error('\P{Is_Category=/a/ SO}');
    Expect(1, 129994, '\p{Is_Category=so}', "");
    Expect(0, 129994, '\p{^Is_Category=so}', "");
    Expect(0, 129994, '\P{Is_Category=so}', "");
    Expect(1, 129994, '\P{^Is_Category=so}', "");
    Expect(0, 129995, '\p{Is_Category=so}', "");
    Expect(1, 129995, '\p{^Is_Category=so}', "");
    Expect(1, 129995, '\P{Is_Category=so}', "");
    Expect(0, 129995, '\P{^Is_Category=so}', "");
    Expect(1, 129994, '\p{Is_Category=  SO}', "");
    Expect(0, 129994, '\p{^Is_Category=  SO}', "");
    Expect(0, 129994, '\P{Is_Category=  SO}', "");
    Expect(1, 129994, '\P{^Is_Category=  SO}', "");
    Expect(0, 129995, '\p{Is_Category=  SO}', "");
    Expect(1, 129995, '\p{^Is_Category=  SO}', "");
    Expect(1, 129995, '\P{Is_Category=  SO}', "");
    Expect(0, 129995, '\P{^Is_Category=  SO}', "");
    Error('\p{General_Category=/a/separator}');
    Error('\P{General_Category=/a/separator}');
    Expect(1, 12288, '\p{General_Category=:\ASeparator\z:}', "");;
    Expect(0, 12289, '\p{General_Category=:\ASeparator\z:}', "");;
    Expect(1, 12288, '\p{General_Category=separator}', "");
    Expect(0, 12288, '\p{^General_Category=separator}', "");
    Expect(0, 12288, '\P{General_Category=separator}', "");
    Expect(1, 12288, '\P{^General_Category=separator}', "");
    Expect(0, 12289, '\p{General_Category=separator}', "");
    Expect(1, 12289, '\p{^General_Category=separator}', "");
    Expect(1, 12289, '\P{General_Category=separator}', "");
    Expect(0, 12289, '\P{^General_Category=separator}', "");
    Expect(1, 12288, '\p{General_Category=:\Aseparator\z:}', "");;
    Expect(0, 12289, '\p{General_Category=:\Aseparator\z:}', "");;
    Expect(1, 12288, '\p{General_Category:	--Separator}', "");
    Expect(0, 12288, '\p{^General_Category:	--Separator}', "");
    Expect(0, 12288, '\P{General_Category:	--Separator}', "");
    Expect(1, 12288, '\P{^General_Category:	--Separator}', "");
    Expect(0, 12289, '\p{General_Category:	--Separator}', "");
    Expect(1, 12289, '\p{^General_Category:	--Separator}', "");
    Expect(1, 12289, '\P{General_Category:	--Separator}', "");
    Expect(0, 12289, '\P{^General_Category:	--Separator}', "");
    Error('\p{Gc=_ Z:=}');
    Error('\P{Gc=_ Z:=}');
    Expect(1, 12288, '\p{Gc=:\AZ\z:}', "");;
    Expect(0, 12289, '\p{Gc=:\AZ\z:}', "");;
    Expect(1, 12288, '\p{Gc=z}', "");
    Expect(0, 12288, '\p{^Gc=z}', "");
    Expect(0, 12288, '\P{Gc=z}', "");
    Expect(1, 12288, '\P{^Gc=z}', "");
    Expect(0, 12289, '\p{Gc=z}', "");
    Expect(1, 12289, '\p{^Gc=z}', "");
    Expect(1, 12289, '\P{Gc=z}', "");
    Expect(0, 12289, '\P{^Gc=z}', "");
    Expect(1, 12288, '\p{Gc=:\Az\z:}', "");;
    Expect(0, 12289, '\p{Gc=:\Az\z:}', "");;
    Expect(1, 12288, '\p{Gc=- Z}', "");
    Expect(0, 12288, '\p{^Gc=- Z}', "");
    Expect(0, 12288, '\P{Gc=- Z}', "");
    Expect(1, 12288, '\P{^Gc=- Z}', "");
    Expect(0, 12289, '\p{Gc=- Z}', "");
    Expect(1, 12289, '\p{^Gc=- Z}', "");
    Expect(1, 12289, '\P{Gc=- Z}', "");
    Expect(0, 12289, '\P{^Gc=- Z}', "");
    Error('\p{Category=-_separator/a/}');
    Error('\P{Category=-_separator/a/}');
    Expect(1, 12288, '\p{Category=:\ASeparator\z:}', "");;
    Expect(0, 12289, '\p{Category=:\ASeparator\z:}', "");;
    Expect(1, 12288, '\p{Category=separator}', "");
    Expect(0, 12288, '\p{^Category=separator}', "");
    Expect(0, 12288, '\P{Category=separator}', "");
    Expect(1, 12288, '\P{^Category=separator}', "");
    Expect(0, 12289, '\p{Category=separator}', "");
    Expect(1, 12289, '\p{^Category=separator}', "");
    Expect(1, 12289, '\P{Category=separator}', "");
    Expect(0, 12289, '\P{^Category=separator}', "");
    Expect(1, 12288, '\p{Category=:\Aseparator\z:}', "");;
    Expect(0, 12289, '\p{Category=:\Aseparator\z:}', "");;
    Expect(1, 12288, '\p{Category=	Separator}', "");
    Expect(0, 12288, '\p{^Category=	Separator}', "");
    Expect(0, 12288, '\P{Category=	Separator}', "");
    Expect(1, 12288, '\P{^Category=	Separator}', "");
    Expect(0, 12289, '\p{Category=	Separator}', "");
    Expect(1, 12289, '\p{^Category=	Separator}', "");
    Expect(1, 12289, '\P{Category=	Separator}', "");
    Expect(0, 12289, '\P{^Category=	Separator}', "");
    Error('\p{Is_General_Category=/a/	z}');
    Error('\P{Is_General_Category=/a/	z}');
    Expect(1, 12288, '\p{Is_General_Category=z}', "");
    Expect(0, 12288, '\p{^Is_General_Category=z}', "");
    Expect(0, 12288, '\P{Is_General_Category=z}', "");
    Expect(1, 12288, '\P{^Is_General_Category=z}', "");
    Expect(0, 12289, '\p{Is_General_Category=z}', "");
    Expect(1, 12289, '\p{^Is_General_Category=z}', "");
    Expect(1, 12289, '\P{Is_General_Category=z}', "");
    Expect(0, 12289, '\P{^Is_General_Category=z}', "");
    Expect(1, 12288, '\p{Is_General_Category=-	Z}', "");
    Expect(0, 12288, '\p{^Is_General_Category=-	Z}', "");
    Expect(0, 12288, '\P{Is_General_Category=-	Z}', "");
    Expect(1, 12288, '\P{^Is_General_Category=-	Z}', "");
    Expect(0, 12289, '\p{Is_General_Category=-	Z}', "");
    Expect(1, 12289, '\p{^Is_General_Category=-	Z}', "");
    Expect(1, 12289, '\P{Is_General_Category=-	Z}', "");
    Expect(0, 12289, '\P{^Is_General_Category=-	Z}', "");
    Error('\p{Is_Gc::=Separator}');
    Error('\P{Is_Gc::=Separator}');
    Expect(1, 12288, '\p{Is_Gc: separator}', "");
    Expect(0, 12288, '\p{^Is_Gc: separator}', "");
    Expect(0, 12288, '\P{Is_Gc: separator}', "");
    Expect(1, 12288, '\P{^Is_Gc: separator}', "");
    Expect(0, 12289, '\p{Is_Gc: separator}', "");
    Expect(1, 12289, '\p{^Is_Gc: separator}', "");
    Expect(1, 12289, '\P{Is_Gc: separator}', "");
    Expect(0, 12289, '\P{^Is_Gc: separator}', "");
    Expect(1, 12288, '\p{Is_Gc= Separator}', "");
    Expect(0, 12288, '\p{^Is_Gc= Separator}', "");
    Expect(0, 12288, '\P{Is_Gc= Separator}', "");
    Expect(1, 12288, '\P{^Is_Gc= Separator}', "");
    Expect(0, 12289, '\p{Is_Gc= Separator}', "");
    Expect(1, 12289, '\p{^Is_Gc= Separator}', "");
    Expect(1, 12289, '\P{Is_Gc= Separator}', "");
    Expect(0, 12289, '\P{^Is_Gc= Separator}', "");
    Error('\p{Is_Category=:=_z}');
    Error('\P{Is_Category=:=_z}');
    Expect(1, 12288, '\p{Is_Category=z}', "");
    Expect(0, 12288, '\p{^Is_Category=z}', "");
    Expect(0, 12288, '\P{Is_Category=z}', "");
    Expect(1, 12288, '\P{^Is_Category=z}', "");
    Expect(0, 12289, '\p{Is_Category=z}', "");
    Expect(1, 12289, '\p{^Is_Category=z}', "");
    Expect(1, 12289, '\P{Is_Category=z}', "");
    Expect(0, 12289, '\P{^Is_Category=z}', "");
    Expect(1, 12288, '\p{Is_Category= Z}', "");
    Expect(0, 12288, '\p{^Is_Category= Z}', "");
    Expect(0, 12288, '\P{Is_Category= Z}', "");
    Expect(1, 12288, '\P{^Is_Category= Z}', "");
    Expect(0, 12289, '\p{Is_Category= Z}', "");
    Expect(1, 12289, '\p{^Is_Category= Z}', "");
    Expect(1, 12289, '\P{Is_Category= Z}', "");
    Expect(0, 12289, '\P{^Is_Category= Z}', "");
    Error('\p{General_Category=/a/  Line_Separator}');
    Error('\P{General_Category=/a/  Line_Separator}');
    Expect(1, 8232, '\p{General_Category=:\ALine_Separator\z:}', "");;
    Expect(0, 8233, '\p{General_Category=:\ALine_Separator\z:}', "");;
    Expect(1, 8232, '\p{General_Category=lineseparator}', "");
    Expect(0, 8232, '\p{^General_Category=lineseparator}', "");
    Expect(0, 8232, '\P{General_Category=lineseparator}', "");
    Expect(1, 8232, '\P{^General_Category=lineseparator}', "");
    Expect(0, 8233, '\p{General_Category=lineseparator}', "");
    Expect(1, 8233, '\p{^General_Category=lineseparator}', "");
    Expect(1, 8233, '\P{General_Category=lineseparator}', "");
    Expect(0, 8233, '\P{^General_Category=lineseparator}', "");
    Expect(1, 8232, '\p{General_Category=:\Alineseparator\z:}', "");;
    Expect(0, 8233, '\p{General_Category=:\Alineseparator\z:}', "");;
    Expect(1, 8232, '\p{General_Category:   	LINE_separator}', "");
    Expect(0, 8232, '\p{^General_Category:   	LINE_separator}', "");
    Expect(0, 8232, '\P{General_Category:   	LINE_separator}', "");
    Expect(1, 8232, '\P{^General_Category:   	LINE_separator}', "");
    Expect(0, 8233, '\p{General_Category:   	LINE_separator}', "");
    Expect(1, 8233, '\p{^General_Category:   	LINE_separator}', "");
    Expect(1, 8233, '\P{General_Category:   	LINE_separator}', "");
    Expect(0, 8233, '\P{^General_Category:   	LINE_separator}', "");
    Error('\p{Gc:	 /a/Zl}');
    Error('\P{Gc:	 /a/Zl}');
    Expect(1, 8232, '\p{Gc=:\AZl\z:}', "");;
    Expect(0, 8233, '\p{Gc=:\AZl\z:}', "");;
    Expect(1, 8232, '\p{Gc=zl}', "");
    Expect(0, 8232, '\p{^Gc=zl}', "");
    Expect(0, 8232, '\P{Gc=zl}', "");
    Expect(1, 8232, '\P{^Gc=zl}', "");
    Expect(0, 8233, '\p{Gc=zl}', "");
    Expect(1, 8233, '\p{^Gc=zl}', "");
    Expect(1, 8233, '\P{Gc=zl}', "");
    Expect(0, 8233, '\P{^Gc=zl}', "");
    Expect(1, 8232, '\p{Gc=:\Azl\z:}', "");;
    Expect(0, 8233, '\p{Gc=:\Azl\z:}', "");;
    Expect(1, 8232, '\p{Gc=__zl}', "");
    Expect(0, 8232, '\p{^Gc=__zl}', "");
    Expect(0, 8232, '\P{Gc=__zl}', "");
    Expect(1, 8232, '\P{^Gc=__zl}', "");
    Expect(0, 8233, '\p{Gc=__zl}', "");
    Expect(1, 8233, '\p{^Gc=__zl}', "");
    Expect(1, 8233, '\P{Gc=__zl}', "");
    Expect(0, 8233, '\P{^Gc=__zl}', "");
    Error('\p{Category=/a/  line_separator}');
    Error('\P{Category=/a/  line_separator}');
    Expect(1, 8232, '\p{Category=:\ALine_Separator\z:}', "");;
    Expect(0, 8233, '\p{Category=:\ALine_Separator\z:}', "");;
    Expect(1, 8232, '\p{Category:	lineseparator}', "");
    Expect(0, 8232, '\p{^Category:	lineseparator}', "");
    Expect(0, 8232, '\P{Category:	lineseparator}', "");
    Expect(1, 8232, '\P{^Category:	lineseparator}', "");
    Expect(0, 8233, '\p{Category:	lineseparator}', "");
    Expect(1, 8233, '\p{^Category:	lineseparator}', "");
    Expect(1, 8233, '\P{Category:	lineseparator}', "");
    Expect(0, 8233, '\P{^Category:	lineseparator}', "");
    Expect(1, 8232, '\p{Category=:\Alineseparator\z:}', "");;
    Expect(0, 8233, '\p{Category=:\Alineseparator\z:}', "");;
    Expect(1, 8232, '\p{Category=-	LINE_Separator}', "");
    Expect(0, 8232, '\p{^Category=-	LINE_Separator}', "");
    Expect(0, 8232, '\P{Category=-	LINE_Separator}', "");
    Expect(1, 8232, '\P{^Category=-	LINE_Separator}', "");
    Expect(0, 8233, '\p{Category=-	LINE_Separator}', "");
    Expect(1, 8233, '\p{^Category=-	LINE_Separator}', "");
    Expect(1, 8233, '\P{Category=-	LINE_Separator}', "");
    Expect(0, 8233, '\P{^Category=-	LINE_Separator}', "");
    Error('\p{Is_General_Category=/a/--Zl}');
    Error('\P{Is_General_Category=/a/--Zl}');
    Expect(1, 8232, '\p{Is_General_Category=zl}', "");
    Expect(0, 8232, '\p{^Is_General_Category=zl}', "");
    Expect(0, 8232, '\P{Is_General_Category=zl}', "");
    Expect(1, 8232, '\P{^Is_General_Category=zl}', "");
    Expect(0, 8233, '\p{Is_General_Category=zl}', "");
    Expect(1, 8233, '\p{^Is_General_Category=zl}', "");
    Expect(1, 8233, '\P{Is_General_Category=zl}', "");
    Expect(0, 8233, '\P{^Is_General_Category=zl}', "");
    Expect(1, 8232, '\p{Is_General_Category=- Zl}', "");
    Expect(0, 8232, '\p{^Is_General_Category=- Zl}', "");
    Expect(0, 8232, '\P{Is_General_Category=- Zl}', "");
    Expect(1, 8232, '\P{^Is_General_Category=- Zl}', "");
    Expect(0, 8233, '\p{Is_General_Category=- Zl}', "");
    Expect(1, 8233, '\p{^Is_General_Category=- Zl}', "");
    Expect(1, 8233, '\P{Is_General_Category=- Zl}', "");
    Expect(0, 8233, '\P{^Is_General_Category=- Zl}', "");
    Error('\p{Is_Gc=-/a/line_Separator}');
    Error('\P{Is_Gc=-/a/line_Separator}');
    Expect(1, 8232, '\p{Is_Gc=lineseparator}', "");
    Expect(0, 8232, '\p{^Is_Gc=lineseparator}', "");
    Expect(0, 8232, '\P{Is_Gc=lineseparator}', "");
    Expect(1, 8232, '\P{^Is_Gc=lineseparator}', "");
    Expect(0, 8233, '\p{Is_Gc=lineseparator}', "");
    Expect(1, 8233, '\p{^Is_Gc=lineseparator}', "");
    Expect(1, 8233, '\P{Is_Gc=lineseparator}', "");
    Expect(0, 8233, '\P{^Is_Gc=lineseparator}', "");
    Expect(1, 8232, '\p{Is_Gc=-_Line_Separator}', "");
    Expect(0, 8232, '\p{^Is_Gc=-_Line_Separator}', "");
    Expect(0, 8232, '\P{Is_Gc=-_Line_Separator}', "");
    Expect(1, 8232, '\P{^Is_Gc=-_Line_Separator}', "");
    Expect(0, 8233, '\p{Is_Gc=-_Line_Separator}', "");
    Expect(1, 8233, '\p{^Is_Gc=-_Line_Separator}', "");
    Expect(1, 8233, '\P{Is_Gc=-_Line_Separator}', "");
    Expect(0, 8233, '\P{^Is_Gc=-_Line_Separator}', "");
    Error('\p{Is_Category= _Zl:=}');
    Error('\P{Is_Category= _Zl:=}');
    Expect(1, 8232, '\p{Is_Category=zl}', "");
    Expect(0, 8232, '\p{^Is_Category=zl}', "");
    Expect(0, 8232, '\P{Is_Category=zl}', "");
    Expect(1, 8232, '\P{^Is_Category=zl}', "");
    Expect(0, 8233, '\p{Is_Category=zl}', "");
    Expect(1, 8233, '\p{^Is_Category=zl}', "");
    Expect(1, 8233, '\P{Is_Category=zl}', "");
    Expect(0, 8233, '\P{^Is_Category=zl}', "");
    Expect(1, 8232, '\p{Is_Category=	-zl}', "");
    Expect(0, 8232, '\p{^Is_Category=	-zl}', "");
    Expect(0, 8232, '\P{Is_Category=	-zl}', "");
    Expect(1, 8232, '\P{^Is_Category=	-zl}', "");
    Expect(0, 8233, '\p{Is_Category=	-zl}', "");
    Expect(1, 8233, '\p{^Is_Category=	-zl}', "");
    Expect(1, 8233, '\P{Is_Category=	-zl}', "");
    Expect(0, 8233, '\P{^Is_Category=	-zl}', "");
    Error('\p{General_Category=-:=PARAGRAPH_Separator}');
    Error('\P{General_Category=-:=PARAGRAPH_Separator}');
    Expect(1, 8233, '\p{General_Category=:\AParagraph_Separator\z:}', "");;
    Expect(0, 8234, '\p{General_Category=:\AParagraph_Separator\z:}', "");;
    Expect(1, 8233, '\p{General_Category=paragraphseparator}', "");
    Expect(0, 8233, '\p{^General_Category=paragraphseparator}', "");
    Expect(0, 8233, '\P{General_Category=paragraphseparator}', "");
    Expect(1, 8233, '\P{^General_Category=paragraphseparator}', "");
    Expect(0, 8234, '\p{General_Category=paragraphseparator}', "");
    Expect(1, 8234, '\p{^General_Category=paragraphseparator}', "");
    Expect(1, 8234, '\P{General_Category=paragraphseparator}', "");
    Expect(0, 8234, '\P{^General_Category=paragraphseparator}', "");
    Expect(1, 8233, '\p{General_Category=:\Aparagraphseparator\z:}', "");;
    Expect(0, 8234, '\p{General_Category=:\Aparagraphseparator\z:}', "");;
    Expect(1, 8233, '\p{General_Category=-Paragraph_Separator}', "");
    Expect(0, 8233, '\p{^General_Category=-Paragraph_Separator}', "");
    Expect(0, 8233, '\P{General_Category=-Paragraph_Separator}', "");
    Expect(1, 8233, '\P{^General_Category=-Paragraph_Separator}', "");
    Expect(0, 8234, '\p{General_Category=-Paragraph_Separator}', "");
    Expect(1, 8234, '\p{^General_Category=-Paragraph_Separator}', "");
    Expect(1, 8234, '\P{General_Category=-Paragraph_Separator}', "");
    Expect(0, 8234, '\P{^General_Category=-Paragraph_Separator}', "");
    Error('\p{Gc=:=  ZP}');
    Error('\P{Gc=:=  ZP}');
    Expect(1, 8233, '\p{Gc=:\AZp\z:}', "");;
    Expect(0, 8234, '\p{Gc=:\AZp\z:}', "");;
    Expect(1, 8233, '\p{Gc=zp}', "");
    Expect(0, 8233, '\p{^Gc=zp}', "");
    Expect(0, 8233, '\P{Gc=zp}', "");
    Expect(1, 8233, '\P{^Gc=zp}', "");
    Expect(0, 8234, '\p{Gc=zp}', "");
    Expect(1, 8234, '\p{^Gc=zp}', "");
    Expect(1, 8234, '\P{Gc=zp}', "");
    Expect(0, 8234, '\P{^Gc=zp}', "");
    Expect(1, 8233, '\p{Gc=:\Azp\z:}', "");;
    Expect(0, 8234, '\p{Gc=:\Azp\z:}', "");;
    Expect(1, 8233, '\p{Gc=	 Zp}', "");
    Expect(0, 8233, '\p{^Gc=	 Zp}', "");
    Expect(0, 8233, '\P{Gc=	 Zp}', "");
    Expect(1, 8233, '\P{^Gc=	 Zp}', "");
    Expect(0, 8234, '\p{Gc=	 Zp}', "");
    Expect(1, 8234, '\p{^Gc=	 Zp}', "");
    Expect(1, 8234, '\P{Gc=	 Zp}', "");
    Expect(0, 8234, '\P{^Gc=	 Zp}', "");
    Error('\p{Category=:=Paragraph_separator}');
    Error('\P{Category=:=Paragraph_separator}');
    Expect(1, 8233, '\p{Category=:\AParagraph_Separator\z:}', "");;
    Expect(0, 8234, '\p{Category=:\AParagraph_Separator\z:}', "");;
    Expect(1, 8233, '\p{Category=paragraphseparator}', "");
    Expect(0, 8233, '\p{^Category=paragraphseparator}', "");
    Expect(0, 8233, '\P{Category=paragraphseparator}', "");
    Expect(1, 8233, '\P{^Category=paragraphseparator}', "");
    Expect(0, 8234, '\p{Category=paragraphseparator}', "");
    Expect(1, 8234, '\p{^Category=paragraphseparator}', "");
    Expect(1, 8234, '\P{Category=paragraphseparator}', "");
    Expect(0, 8234, '\P{^Category=paragraphseparator}', "");
    Expect(1, 8233, '\p{Category=:\Aparagraphseparator\z:}', "");;
    Expect(0, 8234, '\p{Category=:\Aparagraphseparator\z:}', "");;
    Expect(1, 8233, '\p{Category=_	paragraph_Separator}', "");
    Expect(0, 8233, '\p{^Category=_	paragraph_Separator}', "");
    Expect(0, 8233, '\P{Category=_	paragraph_Separator}', "");
    Expect(1, 8233, '\P{^Category=_	paragraph_Separator}', "");
    Expect(0, 8234, '\p{Category=_	paragraph_Separator}', "");
    Expect(1, 8234, '\p{^Category=_	paragraph_Separator}', "");
    Expect(1, 8234, '\P{Category=_	paragraph_Separator}', "");
    Expect(0, 8234, '\P{^Category=_	paragraph_Separator}', "");
    Error('\p{Is_General_Category: 		Zp:=}');
    Error('\P{Is_General_Category: 		Zp:=}');
    Expect(1, 8233, '\p{Is_General_Category=zp}', "");
    Expect(0, 8233, '\p{^Is_General_Category=zp}', "");
    Expect(0, 8233, '\P{Is_General_Category=zp}', "");
    Expect(1, 8233, '\P{^Is_General_Category=zp}', "");
    Expect(0, 8234, '\p{Is_General_Category=zp}', "");
    Expect(1, 8234, '\p{^Is_General_Category=zp}', "");
    Expect(1, 8234, '\P{Is_General_Category=zp}', "");
    Expect(0, 8234, '\P{^Is_General_Category=zp}', "");
    Expect(1, 8233, '\p{Is_General_Category:	 Zp}', "");
    Expect(0, 8233, '\p{^Is_General_Category:	 Zp}', "");
    Expect(0, 8233, '\P{Is_General_Category:	 Zp}', "");
    Expect(1, 8233, '\P{^Is_General_Category:	 Zp}', "");
    Expect(0, 8234, '\p{Is_General_Category:	 Zp}', "");
    Expect(1, 8234, '\p{^Is_General_Category:	 Zp}', "");
    Expect(1, 8234, '\P{Is_General_Category:	 Zp}', "");
    Expect(0, 8234, '\P{^Is_General_Category:	 Zp}', "");
    Error('\p{Is_Gc=-Paragraph_Separator/a/}');
    Error('\P{Is_Gc=-Paragraph_Separator/a/}');
    Expect(1, 8233, '\p{Is_Gc=paragraphseparator}', "");
    Expect(0, 8233, '\p{^Is_Gc=paragraphseparator}', "");
    Expect(0, 8233, '\P{Is_Gc=paragraphseparator}', "");
    Expect(1, 8233, '\P{^Is_Gc=paragraphseparator}', "");
    Expect(0, 8234, '\p{Is_Gc=paragraphseparator}', "");
    Expect(1, 8234, '\p{^Is_Gc=paragraphseparator}', "");
    Expect(1, 8234, '\P{Is_Gc=paragraphseparator}', "");
    Expect(0, 8234, '\P{^Is_Gc=paragraphseparator}', "");
    Expect(1, 8233, '\p{Is_Gc= -Paragraph_Separator}', "");
    Expect(0, 8233, '\p{^Is_Gc= -Paragraph_Separator}', "");
    Expect(0, 8233, '\P{Is_Gc= -Paragraph_Separator}', "");
    Expect(1, 8233, '\P{^Is_Gc= -Paragraph_Separator}', "");
    Expect(0, 8234, '\p{Is_Gc= -Paragraph_Separator}', "");
    Expect(1, 8234, '\p{^Is_Gc= -Paragraph_Separator}', "");
    Expect(1, 8234, '\P{Is_Gc= -Paragraph_Separator}', "");
    Expect(0, 8234, '\P{^Is_Gc= -Paragraph_Separator}', "");
    Error('\p{Is_Category= /a/zp}');
    Error('\P{Is_Category= /a/zp}');
    Expect(1, 8233, '\p{Is_Category=zp}', "");
    Expect(0, 8233, '\p{^Is_Category=zp}', "");
    Expect(0, 8233, '\P{Is_Category=zp}', "");
    Expect(1, 8233, '\P{^Is_Category=zp}', "");
    Expect(0, 8234, '\p{Is_Category=zp}', "");
    Expect(1, 8234, '\p{^Is_Category=zp}', "");
    Expect(1, 8234, '\P{Is_Category=zp}', "");
    Expect(0, 8234, '\P{^Is_Category=zp}', "");
    Expect(1, 8233, '\p{Is_Category=- Zp}', "");
    Expect(0, 8233, '\p{^Is_Category=- Zp}', "");
    Expect(0, 8233, '\P{Is_Category=- Zp}', "");
    Expect(1, 8233, '\P{^Is_Category=- Zp}', "");
    Expect(0, 8234, '\p{Is_Category=- Zp}', "");
    Expect(1, 8234, '\p{^Is_Category=- Zp}', "");
    Expect(1, 8234, '\P{Is_Category=- Zp}', "");
    Expect(0, 8234, '\P{^Is_Category=- Zp}', "");
    Error('\p{General_Category=-/a/space_Separator}');
    Error('\P{General_Category=-/a/space_Separator}');
    Expect(1, 12288, '\p{General_Category=:\ASpace_Separator\z:}', "");;
    Expect(0, 12289, '\p{General_Category=:\ASpace_Separator\z:}', "");;
    Expect(1, 12288, '\p{General_Category=spaceseparator}', "");
    Expect(0, 12288, '\p{^General_Category=spaceseparator}', "");
    Expect(0, 12288, '\P{General_Category=spaceseparator}', "");
    Expect(1, 12288, '\P{^General_Category=spaceseparator}', "");
    Expect(0, 12289, '\p{General_Category=spaceseparator}', "");
    Expect(1, 12289, '\p{^General_Category=spaceseparator}', "");
    Expect(1, 12289, '\P{General_Category=spaceseparator}', "");
    Expect(0, 12289, '\P{^General_Category=spaceseparator}', "");
    Expect(1, 12288, '\p{General_Category=:\Aspaceseparator\z:}', "");;
    Expect(0, 12289, '\p{General_Category=:\Aspaceseparator\z:}', "");;
    Expect(1, 12288, '\p{General_Category:--Space_Separator}', "");
    Expect(0, 12288, '\p{^General_Category:--Space_Separator}', "");
    Expect(0, 12288, '\P{General_Category:--Space_Separator}', "");
    Expect(1, 12288, '\P{^General_Category:--Space_Separator}', "");
    Expect(0, 12289, '\p{General_Category:--Space_Separator}', "");
    Expect(1, 12289, '\p{^General_Category:--Space_Separator}', "");
    Expect(1, 12289, '\P{General_Category:--Space_Separator}', "");
    Expect(0, 12289, '\P{^General_Category:--Space_Separator}', "");
    Error('\p{Gc:	:=zs}');
    Error('\P{Gc:	:=zs}');
    Expect(1, 12288, '\p{Gc=:\AZs\z:}', "");;
    Expect(0, 12289, '\p{Gc=:\AZs\z:}', "");;
    Expect(1, 12288, '\p{Gc=zs}', "");
    Expect(0, 12288, '\p{^Gc=zs}', "");
    Expect(0, 12288, '\P{Gc=zs}', "");
    Expect(1, 12288, '\P{^Gc=zs}', "");
    Expect(0, 12289, '\p{Gc=zs}', "");
    Expect(1, 12289, '\p{^Gc=zs}', "");
    Expect(1, 12289, '\P{Gc=zs}', "");
    Expect(0, 12289, '\P{^Gc=zs}', "");
    Expect(1, 12288, '\p{Gc=:\Azs\z:}', "");;
    Expect(0, 12289, '\p{Gc=:\Azs\z:}', "");;
    Expect(1, 12288, '\p{Gc:			Zs}', "");
    Expect(0, 12288, '\p{^Gc:			Zs}', "");
    Expect(0, 12288, '\P{Gc:			Zs}', "");
    Expect(1, 12288, '\P{^Gc:			Zs}', "");
    Expect(0, 12289, '\p{Gc:			Zs}', "");
    Expect(1, 12289, '\p{^Gc:			Zs}', "");
    Expect(1, 12289, '\P{Gc:			Zs}', "");
    Expect(0, 12289, '\P{^Gc:			Zs}', "");
    Error('\p{Category=space_separator/a/}');
    Error('\P{Category=space_separator/a/}');
    Expect(1, 12288, '\p{Category=:\ASpace_Separator\z:}', "");;
    Expect(0, 12289, '\p{Category=:\ASpace_Separator\z:}', "");;
    Expect(1, 12288, '\p{Category=spaceseparator}', "");
    Expect(0, 12288, '\p{^Category=spaceseparator}', "");
    Expect(0, 12288, '\P{Category=spaceseparator}', "");
    Expect(1, 12288, '\P{^Category=spaceseparator}', "");
    Expect(0, 12289, '\p{Category=spaceseparator}', "");
    Expect(1, 12289, '\p{^Category=spaceseparator}', "");
    Expect(1, 12289, '\P{Category=spaceseparator}', "");
    Expect(0, 12289, '\P{^Category=spaceseparator}', "");
    Expect(1, 12288, '\p{Category=:\Aspaceseparator\z:}', "");;
    Expect(0, 12289, '\p{Category=:\Aspaceseparator\z:}', "");;
    Expect(1, 12288, '\p{Category: 	-SPACE_SEPARATOR}', "");
    Expect(0, 12288, '\p{^Category: 	-SPACE_SEPARATOR}', "");
    Expect(0, 12288, '\P{Category: 	-SPACE_SEPARATOR}', "");
    Expect(1, 12288, '\P{^Category: 	-SPACE_SEPARATOR}', "");
    Expect(0, 12289, '\p{Category: 	-SPACE_SEPARATOR}', "");
    Expect(1, 12289, '\p{^Category: 	-SPACE_SEPARATOR}', "");
    Expect(1, 12289, '\P{Category: 	-SPACE_SEPARATOR}', "");
    Expect(0, 12289, '\P{^Category: 	-SPACE_SEPARATOR}', "");
    Error('\p{Is_General_Category=:=_	ZS}');
    Error('\P{Is_General_Category=:=_	ZS}');
    Expect(1, 12288, '\p{Is_General_Category=zs}', "");
    Expect(0, 12288, '\p{^Is_General_Category=zs}', "");
    Expect(0, 12288, '\P{Is_General_Category=zs}', "");
    Expect(1, 12288, '\P{^Is_General_Category=zs}', "");
    Expect(0, 12289, '\p{Is_General_Category=zs}', "");
    Expect(1, 12289, '\p{^Is_General_Category=zs}', "");
    Expect(1, 12289, '\P{Is_General_Category=zs}', "");
    Expect(0, 12289, '\P{^Is_General_Category=zs}', "");
    Expect(1, 12288, '\p{Is_General_Category=  ZS}', "");
    Expect(0, 12288, '\p{^Is_General_Category=  ZS}', "");
    Expect(0, 12288, '\P{Is_General_Category=  ZS}', "");
    Expect(1, 12288, '\P{^Is_General_Category=  ZS}', "");
    Expect(0, 12289, '\p{Is_General_Category=  ZS}', "");
    Expect(1, 12289, '\p{^Is_General_Category=  ZS}', "");
    Expect(1, 12289, '\P{Is_General_Category=  ZS}', "");
    Expect(0, 12289, '\P{^Is_General_Category=  ZS}', "");
    Error('\p{Is_Gc=:=-_Space_SEPARATOR}');
    Error('\P{Is_Gc=:=-_Space_SEPARATOR}');
    Expect(1, 12288, '\p{Is_Gc=spaceseparator}', "");
    Expect(0, 12288, '\p{^Is_Gc=spaceseparator}', "");
    Expect(0, 12288, '\P{Is_Gc=spaceseparator}', "");
    Expect(1, 12288, '\P{^Is_Gc=spaceseparator}', "");
    Expect(0, 12289, '\p{Is_Gc=spaceseparator}', "");
    Expect(1, 12289, '\p{^Is_Gc=spaceseparator}', "");
    Expect(1, 12289, '\P{Is_Gc=spaceseparator}', "");
    Expect(0, 12289, '\P{^Is_Gc=spaceseparator}', "");
    Expect(1, 12288, '\p{Is_Gc=	_Space_Separator}', "");
    Expect(0, 12288, '\p{^Is_Gc=	_Space_Separator}', "");
    Expect(0, 12288, '\P{Is_Gc=	_Space_Separator}', "");
    Expect(1, 12288, '\P{^Is_Gc=	_Space_Separator}', "");
    Expect(0, 12289, '\p{Is_Gc=	_Space_Separator}', "");
    Expect(1, 12289, '\p{^Is_Gc=	_Space_Separator}', "");
    Expect(1, 12289, '\P{Is_Gc=	_Space_Separator}', "");
    Expect(0, 12289, '\P{^Is_Gc=	_Space_Separator}', "");
    Error('\p{Is_Category=--zs:=}');
    Error('\P{Is_Category=--zs:=}');
    Expect(1, 12288, '\p{Is_Category=zs}', "");
    Expect(0, 12288, '\p{^Is_Category=zs}', "");
    Expect(0, 12288, '\P{Is_Category=zs}', "");
    Expect(1, 12288, '\P{^Is_Category=zs}', "");
    Expect(0, 12289, '\p{Is_Category=zs}', "");
    Expect(1, 12289, '\p{^Is_Category=zs}', "");
    Expect(1, 12289, '\P{Is_Category=zs}', "");
    Expect(0, 12289, '\P{^Is_Category=zs}', "");
    Expect(1, 12288, '\p{Is_Category=_	ZS}', "");
    Expect(0, 12288, '\p{^Is_Category=_	ZS}', "");
    Expect(0, 12288, '\P{Is_Category=_	ZS}', "");
    Expect(1, 12288, '\P{^Is_Category=_	ZS}', "");
    Expect(0, 12289, '\p{Is_Category=_	ZS}', "");
    Expect(1, 12289, '\p{^Is_Category=_	ZS}', "");
    Expect(1, 12289, '\P{Is_Category=_	ZS}', "");
    Expect(0, 12289, '\P{^Is_Category=_	ZS}', "");
    Error('\p{graphemeclusterbreak}');
    Error('\P{graphemeclusterbreak}');
    Error('\p{gcb}');
    Error('\P{gcb}');
    Error('\p{_perlgcb}');
    Error('\P{_perlgcb}');
    Error('\p{Grapheme_Cluster_Break=/a/	Control}');
    Error('\P{Grapheme_Cluster_Break=/a/	Control}');
    Expect(1, 921599, '\p{Grapheme_Cluster_Break=:\AControl\z:}', "");;
    Expect(0, 921600, '\p{Grapheme_Cluster_Break=:\AControl\z:}', "");;
    Expect(1, 921599, '\p{Grapheme_Cluster_Break=control}', "");
    Expect(0, 921599, '\p{^Grapheme_Cluster_Break=control}', "");
    Expect(0, 921599, '\P{Grapheme_Cluster_Break=control}', "");
    Expect(1, 921599, '\P{^Grapheme_Cluster_Break=control}', "");
    Expect(0, 921600, '\p{Grapheme_Cluster_Break=control}', "");
    Expect(1, 921600, '\p{^Grapheme_Cluster_Break=control}', "");
    Expect(1, 921600, '\P{Grapheme_Cluster_Break=control}', "");
    Expect(0, 921600, '\P{^Grapheme_Cluster_Break=control}', "");
    Expect(1, 921599, '\p{Grapheme_Cluster_Break=:\Acontrol\z:}', "");;
    Expect(0, 921600, '\p{Grapheme_Cluster_Break=:\Acontrol\z:}', "");;
    Expect(1, 921599, '\p{Grapheme_Cluster_Break=	Control}', "");
    Expect(0, 921599, '\p{^Grapheme_Cluster_Break=	Control}', "");
    Expect(0, 921599, '\P{Grapheme_Cluster_Break=	Control}', "");
    Expect(1, 921599, '\P{^Grapheme_Cluster_Break=	Control}', "");
    Expect(0, 921600, '\p{Grapheme_Cluster_Break=	Control}', "");
    Expect(1, 921600, '\p{^Grapheme_Cluster_Break=	Control}', "");
    Expect(1, 921600, '\P{Grapheme_Cluster_Break=	Control}', "");
    Expect(0, 921600, '\P{^Grapheme_Cluster_Break=	Control}', "");
    Error('\p{GCB=	_CN/a/}');
    Error('\P{GCB=	_CN/a/}');
    Expect(1, 921599, '\p{GCB=:\ACN\z:}', "");;
    Expect(0, 921600, '\p{GCB=:\ACN\z:}', "");;
    Expect(1, 921599, '\p{GCB=cn}', "");
    Expect(0, 921599, '\p{^GCB=cn}', "");
    Expect(0, 921599, '\P{GCB=cn}', "");
    Expect(1, 921599, '\P{^GCB=cn}', "");
    Expect(0, 921600, '\p{GCB=cn}', "");
    Expect(1, 921600, '\p{^GCB=cn}', "");
    Expect(1, 921600, '\P{GCB=cn}', "");
    Expect(0, 921600, '\P{^GCB=cn}', "");
    Expect(1, 921599, '\p{GCB=:\Acn\z:}', "");;
    Expect(0, 921600, '\p{GCB=:\Acn\z:}', "");;
    Expect(1, 921599, '\p{GCB= -CN}', "");
    Expect(0, 921599, '\p{^GCB= -CN}', "");
    Expect(0, 921599, '\P{GCB= -CN}', "");
    Expect(1, 921599, '\P{^GCB= -CN}', "");
    Expect(0, 921600, '\p{GCB= -CN}', "");
    Expect(1, 921600, '\p{^GCB= -CN}', "");
    Expect(1, 921600, '\P{GCB= -CN}', "");
    Expect(0, 921600, '\P{^GCB= -CN}', "");
    Error('\p{Is_Grapheme_Cluster_Break:   /a/ 	Control}');
    Error('\P{Is_Grapheme_Cluster_Break:   /a/ 	Control}');
    Expect(1, 921599, '\p{Is_Grapheme_Cluster_Break=control}', "");
    Expect(0, 921599, '\p{^Is_Grapheme_Cluster_Break=control}', "");
    Expect(0, 921599, '\P{Is_Grapheme_Cluster_Break=control}', "");
    Expect(1, 921599, '\P{^Is_Grapheme_Cluster_Break=control}', "");
    Expect(0, 921600, '\p{Is_Grapheme_Cluster_Break=control}', "");
    Expect(1, 921600, '\p{^Is_Grapheme_Cluster_Break=control}', "");
    Expect(1, 921600, '\P{Is_Grapheme_Cluster_Break=control}', "");
    Expect(0, 921600, '\P{^Is_Grapheme_Cluster_Break=control}', "");
    Expect(1, 921599, '\p{Is_Grapheme_Cluster_Break=_	control}', "");
    Expect(0, 921599, '\p{^Is_Grapheme_Cluster_Break=_	control}', "");
    Expect(0, 921599, '\P{Is_Grapheme_Cluster_Break=_	control}', "");
    Expect(1, 921599, '\P{^Is_Grapheme_Cluster_Break=_	control}', "");
    Expect(0, 921600, '\p{Is_Grapheme_Cluster_Break=_	control}', "");
    Expect(1, 921600, '\p{^Is_Grapheme_Cluster_Break=_	control}', "");
    Expect(1, 921600, '\P{Is_Grapheme_Cluster_Break=_	control}', "");
    Expect(0, 921600, '\P{^Is_Grapheme_Cluster_Break=_	control}', "");
    Error('\p{Is_GCB=-/a/CN}');
    Error('\P{Is_GCB=-/a/CN}');
    Expect(1, 921599, '\p{Is_GCB:   cn}', "");
    Expect(0, 921599, '\p{^Is_GCB:   cn}', "");
    Expect(0, 921599, '\P{Is_GCB:   cn}', "");
    Expect(1, 921599, '\P{^Is_GCB:   cn}', "");
    Expect(0, 921600, '\p{Is_GCB:   cn}', "");
    Expect(1, 921600, '\p{^Is_GCB:   cn}', "");
    Expect(1, 921600, '\P{Is_GCB:   cn}', "");
    Expect(0, 921600, '\P{^Is_GCB:   cn}', "");
    Expect(1, 921599, '\p{Is_GCB=	 CN}', "");
    Expect(0, 921599, '\p{^Is_GCB=	 CN}', "");
    Expect(0, 921599, '\P{Is_GCB=	 CN}', "");
    Expect(1, 921599, '\P{^Is_GCB=	 CN}', "");
    Expect(0, 921600, '\p{Is_GCB=	 CN}', "");
    Expect(1, 921600, '\p{^Is_GCB=	 CN}', "");
    Expect(1, 921600, '\P{Is_GCB=	 CN}', "");
    Expect(0, 921600, '\P{^Is_GCB=	 CN}', "");
    Error('\p{Grapheme_Cluster_Break=:=_	CR}');
    Error('\P{Grapheme_Cluster_Break=:=_	CR}');
    Expect(1, 13, '\p{Grapheme_Cluster_Break=:\ACR\z:}', "");;
    Expect(0, 14, '\p{Grapheme_Cluster_Break=:\ACR\z:}', "");;
    Expect(1, 13, '\p{Grapheme_Cluster_Break=cr}', "");
    Expect(0, 13, '\p{^Grapheme_Cluster_Break=cr}', "");
    Expect(0, 13, '\P{Grapheme_Cluster_Break=cr}', "");
    Expect(1, 13, '\P{^Grapheme_Cluster_Break=cr}', "");
    Expect(0, 14, '\p{Grapheme_Cluster_Break=cr}', "");
    Expect(1, 14, '\p{^Grapheme_Cluster_Break=cr}', "");
    Expect(1, 14, '\P{Grapheme_Cluster_Break=cr}', "");
    Expect(0, 14, '\P{^Grapheme_Cluster_Break=cr}', "");
    Expect(1, 13, '\p{Grapheme_Cluster_Break=:\Acr\z:}', "");;
    Expect(0, 14, '\p{Grapheme_Cluster_Break=:\Acr\z:}', "");;
    Expect(1, 13, '\p{Grapheme_Cluster_Break=-CR}', "");
    Expect(0, 13, '\p{^Grapheme_Cluster_Break=-CR}', "");
    Expect(0, 13, '\P{Grapheme_Cluster_Break=-CR}', "");
    Expect(1, 13, '\P{^Grapheme_Cluster_Break=-CR}', "");
    Expect(0, 14, '\p{Grapheme_Cluster_Break=-CR}', "");
    Expect(1, 14, '\p{^Grapheme_Cluster_Break=-CR}', "");
    Expect(1, 14, '\P{Grapheme_Cluster_Break=-CR}', "");
    Expect(0, 14, '\P{^Grapheme_Cluster_Break=-CR}', "");
    Error('\p{GCB=__CR:=}');
    Error('\P{GCB=__CR:=}');
    Expect(1, 13, '\p{GCB=:\ACR\z:}', "");;
    Expect(0, 14, '\p{GCB=:\ACR\z:}', "");;
    Expect(1, 13, '\p{GCB=cr}', "");
    Expect(0, 13, '\p{^GCB=cr}', "");
    Expect(0, 13, '\P{GCB=cr}', "");
    Expect(1, 13, '\P{^GCB=cr}', "");
    Expect(0, 14, '\p{GCB=cr}', "");
    Expect(1, 14, '\p{^GCB=cr}', "");
    Expect(1, 14, '\P{GCB=cr}', "");
    Expect(0, 14, '\P{^GCB=cr}', "");
    Expect(1, 13, '\p{GCB=:\Acr\z:}', "");;
    Expect(0, 14, '\p{GCB=:\Acr\z:}', "");;
    Expect(1, 13, '\p{GCB:    -CR}', "");
    Expect(0, 13, '\p{^GCB:    -CR}', "");
    Expect(0, 13, '\P{GCB:    -CR}', "");
    Expect(1, 13, '\P{^GCB:    -CR}', "");
    Expect(0, 14, '\p{GCB:    -CR}', "");
    Expect(1, 14, '\p{^GCB:    -CR}', "");
    Expect(1, 14, '\P{GCB:    -CR}', "");
    Expect(0, 14, '\P{^GCB:    -CR}', "");
    Error('\p{Is_Grapheme_Cluster_Break=/a/--CR}');
    Error('\P{Is_Grapheme_Cluster_Break=/a/--CR}');
    Expect(1, 13, '\p{Is_Grapheme_Cluster_Break=cr}', "");
    Expect(0, 13, '\p{^Is_Grapheme_Cluster_Break=cr}', "");
    Expect(0, 13, '\P{Is_Grapheme_Cluster_Break=cr}', "");
    Expect(1, 13, '\P{^Is_Grapheme_Cluster_Break=cr}', "");
    Expect(0, 14, '\p{Is_Grapheme_Cluster_Break=cr}', "");
    Expect(1, 14, '\p{^Is_Grapheme_Cluster_Break=cr}', "");
    Expect(1, 14, '\P{Is_Grapheme_Cluster_Break=cr}', "");
    Expect(0, 14, '\P{^Is_Grapheme_Cluster_Break=cr}', "");
    Expect(1, 13, '\p{Is_Grapheme_Cluster_Break=- CR}', "");
    Expect(0, 13, '\p{^Is_Grapheme_Cluster_Break=- CR}', "");
    Expect(0, 13, '\P{Is_Grapheme_Cluster_Break=- CR}', "");
    Expect(1, 13, '\P{^Is_Grapheme_Cluster_Break=- CR}', "");
    Expect(0, 14, '\p{Is_Grapheme_Cluster_Break=- CR}', "");
    Expect(1, 14, '\p{^Is_Grapheme_Cluster_Break=- CR}', "");
    Expect(1, 14, '\P{Is_Grapheme_Cluster_Break=- CR}', "");
    Expect(0, 14, '\P{^Is_Grapheme_Cluster_Break=- CR}', "");
    Error('\p{Is_GCB=:=CR}');
    Error('\P{Is_GCB=:=CR}');
    Expect(1, 13, '\p{Is_GCB=cr}', "");
    Expect(0, 13, '\p{^Is_GCB=cr}', "");
    Expect(0, 13, '\P{Is_GCB=cr}', "");
    Expect(1, 13, '\P{^Is_GCB=cr}', "");
    Expect(0, 14, '\p{Is_GCB=cr}', "");
    Expect(1, 14, '\p{^Is_GCB=cr}', "");
    Expect(1, 14, '\P{Is_GCB=cr}', "");
    Expect(0, 14, '\P{^Is_GCB=cr}', "");
    Expect(1, 13, '\p{Is_GCB=_CR}', "");
    Expect(0, 13, '\p{^Is_GCB=_CR}', "");
    Expect(0, 13, '\P{Is_GCB=_CR}', "");
    Expect(1, 13, '\P{^Is_GCB=_CR}', "");
    Expect(0, 14, '\p{Is_GCB=_CR}', "");
    Expect(1, 14, '\p{^Is_GCB=_CR}', "");
    Expect(1, 14, '\P{Is_GCB=_CR}', "");
    Expect(0, 14, '\P{^Is_GCB=_CR}', "");
    Error('\p{Grapheme_Cluster_Break=-:=E_BASE}');
    Error('\P{Grapheme_Cluster_Break=-:=E_BASE}');
    Expect(0, 1, '\p{Grapheme_Cluster_Break=:\AE_Base\z:}', "");;
    Expect(0, 1, '\p{Grapheme_Cluster_Break:ebase}', "");
    Expect(1, 1, '\p{^Grapheme_Cluster_Break:ebase}', "");
    Expect(1, 1, '\P{Grapheme_Cluster_Break:ebase}', "");
    Expect(0, 1, '\P{^Grapheme_Cluster_Break:ebase}', "");
    Expect(0, 1, '\p{Grapheme_Cluster_Break=:\Aebase\z:}', "");;
    Expect(0, 1, '\p{Grapheme_Cluster_Break=-	E_BASE}', "");
    Expect(1, 1, '\p{^Grapheme_Cluster_Break=-	E_BASE}', "");
    Expect(1, 1, '\P{Grapheme_Cluster_Break=-	E_BASE}', "");
    Expect(0, 1, '\P{^Grapheme_Cluster_Break=-	E_BASE}', "");
    Error('\p{GCB=/a/- EB}');
    Error('\P{GCB=/a/- EB}');
    Expect(0, 1, '\p{GCB=:\AEB\z:}', "");;
    Expect(0, 1, '\p{GCB=eb}', "");
    Expect(1, 1, '\p{^GCB=eb}', "");
    Expect(1, 1, '\P{GCB=eb}', "");
    Expect(0, 1, '\P{^GCB=eb}', "");
    Expect(0, 1, '\p{GCB=:\Aeb\z:}', "");;
    Expect(0, 1, '\p{GCB=	EB}', "");
    Expect(1, 1, '\p{^GCB=	EB}', "");
    Expect(1, 1, '\P{GCB=	EB}', "");
    Expect(0, 1, '\P{^GCB=	EB}', "");
    Error('\p{Is_Grapheme_Cluster_Break=	/a/E_base}');
    Error('\P{Is_Grapheme_Cluster_Break=	/a/E_base}');
    Expect(0, 1, '\p{Is_Grapheme_Cluster_Break=ebase}', "");
    Expect(1, 1, '\p{^Is_Grapheme_Cluster_Break=ebase}', "");
    Expect(1, 1, '\P{Is_Grapheme_Cluster_Break=ebase}', "");
    Expect(0, 1, '\P{^Is_Grapheme_Cluster_Break=ebase}', "");
    Expect(0, 1, '\p{Is_Grapheme_Cluster_Break=--E_Base}', "");
    Expect(1, 1, '\p{^Is_Grapheme_Cluster_Break=--E_Base}', "");
    Expect(1, 1, '\P{Is_Grapheme_Cluster_Break=--E_Base}', "");
    Expect(0, 1, '\P{^Is_Grapheme_Cluster_Break=--E_Base}', "");
    Error('\p{Is_GCB=:=	EB}');
    Error('\P{Is_GCB=:=	EB}');
    Expect(0, 1, '\p{Is_GCB=eb}', "");
    Expect(1, 1, '\p{^Is_GCB=eb}', "");
    Expect(1, 1, '\P{Is_GCB=eb}', "");
    Expect(0, 1, '\P{^Is_GCB=eb}', "");
    Expect(0, 1, '\p{Is_GCB=	-EB}', "");
    Expect(1, 1, '\p{^Is_GCB=	-EB}', "");
    Expect(1, 1, '\P{Is_GCB=	-EB}', "");
    Expect(0, 1, '\P{^Is_GCB=	-EB}', "");
    Error('\p{Grapheme_Cluster_Break=-E_BASE_GAZ:=}');
    Error('\P{Grapheme_Cluster_Break=-E_BASE_GAZ:=}');
    Expect(0, 1, '\p{Grapheme_Cluster_Break=:\AE_Base_GAZ\z:}', "");;
    Expect(0, 1, '\p{Grapheme_Cluster_Break=ebasegaz}', "");
    Expect(1, 1, '\p{^Grapheme_Cluster_Break=ebasegaz}', "");
    Expect(1, 1, '\P{Grapheme_Cluster_Break=ebasegaz}', "");
    Expect(0, 1, '\P{^Grapheme_Cluster_Break=ebasegaz}', "");
    Expect(0, 1, '\p{Grapheme_Cluster_Break=:\Aebasegaz\z:}', "");;
    Expect(0, 1, '\p{Grapheme_Cluster_Break=_e_Base_GAZ}', "");
    Expect(1, 1, '\p{^Grapheme_Cluster_Break=_e_Base_GAZ}', "");
    Expect(1, 1, '\P{Grapheme_Cluster_Break=_e_Base_GAZ}', "");
    Expect(0, 1, '\P{^Grapheme_Cluster_Break=_e_Base_GAZ}', "");
    Error('\p{GCB=	:=EBG}');
    Error('\P{GCB=	:=EBG}');
    Expect(0, 1, '\p{GCB=:\AEBG\z:}', "");;
    Expect(0, 1, '\p{GCB=ebg}', "");
    Expect(1, 1, '\p{^GCB=ebg}', "");
    Expect(1, 1, '\P{GCB=ebg}', "");
    Expect(0, 1, '\P{^GCB=ebg}', "");
    Expect(0, 1, '\p{GCB=:\Aebg\z:}', "");;
    Expect(0, 1, '\p{GCB= EBG}', "");
    Expect(1, 1, '\p{^GCB= EBG}', "");
    Expect(1, 1, '\P{GCB= EBG}', "");
    Expect(0, 1, '\P{^GCB= EBG}', "");
    Error('\p{Is_Grapheme_Cluster_Break=	-E_base_GAZ/a/}');
    Error('\P{Is_Grapheme_Cluster_Break=	-E_base_GAZ/a/}');
    Expect(0, 1, '\p{Is_Grapheme_Cluster_Break=ebasegaz}', "");
    Expect(1, 1, '\p{^Is_Grapheme_Cluster_Break=ebasegaz}', "");
    Expect(1, 1, '\P{Is_Grapheme_Cluster_Break=ebasegaz}', "");
    Expect(0, 1, '\P{^Is_Grapheme_Cluster_Break=ebasegaz}', "");
    Expect(0, 1, '\p{Is_Grapheme_Cluster_Break=	 E_Base_gaz}', "");
    Expect(1, 1, '\p{^Is_Grapheme_Cluster_Break=	 E_Base_gaz}', "");
    Expect(1, 1, '\P{Is_Grapheme_Cluster_Break=	 E_Base_gaz}', "");
    Expect(0, 1, '\P{^Is_Grapheme_Cluster_Break=	 E_Base_gaz}', "");
    Error('\p{Is_GCB=/a/-	EBG}');
    Error('\P{Is_GCB=/a/-	EBG}');
    Expect(0, 1, '\p{Is_GCB=ebg}', "");
    Expect(1, 1, '\p{^Is_GCB=ebg}', "");
    Expect(1, 1, '\P{Is_GCB=ebg}', "");
    Expect(0, 1, '\P{^Is_GCB=ebg}', "");
    Expect(0, 1, '\p{Is_GCB=-_ebg}', "");
    Expect(1, 1, '\p{^Is_GCB=-_ebg}', "");
    Expect(1, 1, '\P{Is_GCB=-_ebg}', "");
    Expect(0, 1, '\P{^Is_GCB=-_ebg}', "");
    Error('\p{Grapheme_Cluster_Break=- E_Modifier:=}');
    Error('\P{Grapheme_Cluster_Break=- E_Modifier:=}');
    Expect(0, 1, '\p{Grapheme_Cluster_Break=:\AE_Modifier\z:}', "");;
    Expect(0, 1, '\p{Grapheme_Cluster_Break=emodifier}', "");
    Expect(1, 1, '\p{^Grapheme_Cluster_Break=emodifier}', "");
    Expect(1, 1, '\P{Grapheme_Cluster_Break=emodifier}', "");
    Expect(0, 1, '\P{^Grapheme_Cluster_Break=emodifier}', "");
    Expect(0, 1, '\p{Grapheme_Cluster_Break=:\Aemodifier\z:}', "");;
    Expect(0, 1, '\p{Grapheme_Cluster_Break=	_E_modifier}', "");
    Expect(1, 1, '\p{^Grapheme_Cluster_Break=	_E_modifier}', "");
    Expect(1, 1, '\P{Grapheme_Cluster_Break=	_E_modifier}', "");
    Expect(0, 1, '\P{^Grapheme_Cluster_Break=	_E_modifier}', "");
    Error('\p{GCB= _EM/a/}');
    Error('\P{GCB= _EM/a/}');
    Expect(0, 1, '\p{GCB=:\AEM\z:}', "");;
    Expect(0, 1, '\p{GCB=em}', "");
    Expect(1, 1, '\p{^GCB=em}', "");
    Expect(1, 1, '\P{GCB=em}', "");
    Expect(0, 1, '\P{^GCB=em}', "");
    Expect(0, 1, '\p{GCB=:\Aem\z:}', "");;
    Expect(0, 1, '\p{GCB: --EM}', "");
    Expect(1, 1, '\p{^GCB: --EM}', "");
    Expect(1, 1, '\P{GCB: --EM}', "");
    Expect(0, 1, '\P{^GCB: --EM}', "");
    Error('\p{Is_Grapheme_Cluster_Break::= 	e_modifier}');
    Error('\P{Is_Grapheme_Cluster_Break::= 	e_modifier}');
    Expect(0, 1, '\p{Is_Grapheme_Cluster_Break=emodifier}', "");
    Expect(1, 1, '\p{^Is_Grapheme_Cluster_Break=emodifier}', "");
    Expect(1, 1, '\P{Is_Grapheme_Cluster_Break=emodifier}', "");
    Expect(0, 1, '\P{^Is_Grapheme_Cluster_Break=emodifier}', "");
    Expect(0, 1, '\p{Is_Grapheme_Cluster_Break= _E_modifier}', "");
    Expect(1, 1, '\p{^Is_Grapheme_Cluster_Break= _E_modifier}', "");
    Expect(1, 1, '\P{Is_Grapheme_Cluster_Break= _E_modifier}', "");
    Expect(0, 1, '\P{^Is_Grapheme_Cluster_Break= _E_modifier}', "");
    Error('\p{Is_GCB=/a/EM}');
    Error('\P{Is_GCB=/a/EM}');
    Expect(0, 1, '\p{Is_GCB=em}', "");
    Expect(1, 1, '\p{^Is_GCB=em}', "");
    Expect(1, 1, '\P{Is_GCB=em}', "");
    Expect(0, 1, '\P{^Is_GCB=em}', "");
    Expect(0, 1, '\p{Is_GCB: _ EM}', "");
    Expect(1, 1, '\p{^Is_GCB: _ EM}', "");
    Expect(1, 1, '\P{Is_GCB: _ EM}', "");
    Expect(0, 1, '\P{^Is_GCB: _ EM}', "");
    Error('\p{Grapheme_Cluster_Break=Extend:=}');
    Error('\P{Grapheme_Cluster_Break=Extend:=}');
    Expect(1, 917999, '\p{Grapheme_Cluster_Break=:\AExtend\z:}', "");;
    Expect(0, 918000, '\p{Grapheme_Cluster_Break=:\AExtend\z:}', "");;
    Expect(1, 917999, '\p{Grapheme_Cluster_Break=extend}', "");
    Expect(0, 917999, '\p{^Grapheme_Cluster_Break=extend}', "");
    Expect(0, 917999, '\P{Grapheme_Cluster_Break=extend}', "");
    Expect(1, 917999, '\P{^Grapheme_Cluster_Break=extend}', "");
    Expect(0, 918000, '\p{Grapheme_Cluster_Break=extend}', "");
    Expect(1, 918000, '\p{^Grapheme_Cluster_Break=extend}', "");
    Expect(1, 918000, '\P{Grapheme_Cluster_Break=extend}', "");
    Expect(0, 918000, '\P{^Grapheme_Cluster_Break=extend}', "");
    Expect(1, 917999, '\p{Grapheme_Cluster_Break=:\Aextend\z:}', "");;
    Expect(0, 918000, '\p{Grapheme_Cluster_Break=:\Aextend\z:}', "");;
    Expect(1, 917999, '\p{Grapheme_Cluster_Break=		EXTEND}', "");
    Expect(0, 917999, '\p{^Grapheme_Cluster_Break=		EXTEND}', "");
    Expect(0, 917999, '\P{Grapheme_Cluster_Break=		EXTEND}', "");
    Expect(1, 917999, '\P{^Grapheme_Cluster_Break=		EXTEND}', "");
    Expect(0, 918000, '\p{Grapheme_Cluster_Break=		EXTEND}', "");
    Expect(1, 918000, '\p{^Grapheme_Cluster_Break=		EXTEND}', "");
    Expect(1, 918000, '\P{Grapheme_Cluster_Break=		EXTEND}', "");
    Expect(0, 918000, '\P{^Grapheme_Cluster_Break=		EXTEND}', "");
    Error('\p{GCB=_:=EX}');
    Error('\P{GCB=_:=EX}');
    Expect(1, 917999, '\p{GCB=:\AEX\z:}', "");;
    Expect(0, 918000, '\p{GCB=:\AEX\z:}', "");;
    Expect(1, 917999, '\p{GCB=ex}', "");
    Expect(0, 917999, '\p{^GCB=ex}', "");
    Expect(0, 917999, '\P{GCB=ex}', "");
    Expect(1, 917999, '\P{^GCB=ex}', "");
    Expect(0, 918000, '\p{GCB=ex}', "");
    Expect(1, 918000, '\p{^GCB=ex}', "");
    Expect(1, 918000, '\P{GCB=ex}', "");
    Expect(0, 918000, '\P{^GCB=ex}', "");
    Expect(1, 917999, '\p{GCB=:\Aex\z:}', "");;
    Expect(0, 918000, '\p{GCB=:\Aex\z:}', "");;
    Expect(1, 917999, '\p{GCB=_-EX}', "");
    Expect(0, 917999, '\p{^GCB=_-EX}', "");
    Expect(0, 917999, '\P{GCB=_-EX}', "");
    Expect(1, 917999, '\P{^GCB=_-EX}', "");
    Expect(0, 918000, '\p{GCB=_-EX}', "");
    Expect(1, 918000, '\p{^GCB=_-EX}', "");
    Expect(1, 918000, '\P{GCB=_-EX}', "");
    Expect(0, 918000, '\P{^GCB=_-EX}', "");
    Error('\p{Is_Grapheme_Cluster_Break=	/a/extend}');
    Error('\P{Is_Grapheme_Cluster_Break=	/a/extend}');
    Expect(1, 917999, '\p{Is_Grapheme_Cluster_Break=extend}', "");
    Expect(0, 917999, '\p{^Is_Grapheme_Cluster_Break=extend}', "");
    Expect(0, 917999, '\P{Is_Grapheme_Cluster_Break=extend}', "");
    Expect(1, 917999, '\P{^Is_Grapheme_Cluster_Break=extend}', "");
    Expect(0, 918000, '\p{Is_Grapheme_Cluster_Break=extend}', "");
    Expect(1, 918000, '\p{^Is_Grapheme_Cluster_Break=extend}', "");
    Expect(1, 918000, '\P{Is_Grapheme_Cluster_Break=extend}', "");
    Expect(0, 918000, '\P{^Is_Grapheme_Cluster_Break=extend}', "");
    Expect(1, 917999, '\p{Is_Grapheme_Cluster_Break=-	Extend}', "");
    Expect(0, 917999, '\p{^Is_Grapheme_Cluster_Break=-	Extend}', "");
    Expect(0, 917999, '\P{Is_Grapheme_Cluster_Break=-	Extend}', "");
    Expect(1, 917999, '\P{^Is_Grapheme_Cluster_Break=-	Extend}', "");
    Expect(0, 918000, '\p{Is_Grapheme_Cluster_Break=-	Extend}', "");
    Expect(1, 918000, '\p{^Is_Grapheme_Cluster_Break=-	Extend}', "");
    Expect(1, 918000, '\P{Is_Grapheme_Cluster_Break=-	Extend}', "");
    Expect(0, 918000, '\P{^Is_Grapheme_Cluster_Break=-	Extend}', "");
    Error('\p{Is_GCB=:=- EX}');
    Error('\P{Is_GCB=:=- EX}');
    Expect(1, 917999, '\p{Is_GCB=ex}', "");
    Expect(0, 917999, '\p{^Is_GCB=ex}', "");
    Expect(0, 917999, '\P{Is_GCB=ex}', "");
    Expect(1, 917999, '\P{^Is_GCB=ex}', "");
    Expect(0, 918000, '\p{Is_GCB=ex}', "");
    Expect(1, 918000, '\p{^Is_GCB=ex}', "");
    Expect(1, 918000, '\P{Is_GCB=ex}', "");
    Expect(0, 918000, '\P{^Is_GCB=ex}', "");
    Expect(1, 917999, '\p{Is_GCB:  _ex}', "");
    Expect(0, 917999, '\p{^Is_GCB:  _ex}', "");
    Expect(0, 917999, '\P{Is_GCB:  _ex}', "");
    Expect(1, 917999, '\P{^Is_GCB:  _ex}', "");
    Expect(0, 918000, '\p{Is_GCB:  _ex}', "");
    Expect(1, 918000, '\p{^Is_GCB:  _ex}', "");
    Expect(1, 918000, '\P{Is_GCB:  _ex}', "");
    Expect(0, 918000, '\P{^Is_GCB:  _ex}', "");
    Error('\p{Grapheme_Cluster_Break= GLUE_After_ZWJ/a/}');
    Error('\P{Grapheme_Cluster_Break= GLUE_After_ZWJ/a/}');
    Expect(0, 1, '\p{Grapheme_Cluster_Break=:\AGlue_After_Zwj\z:}', "");;
    Expect(0, 1, '\p{Grapheme_Cluster_Break=glueafterzwj}', "");
    Expect(1, 1, '\p{^Grapheme_Cluster_Break=glueafterzwj}', "");
    Expect(1, 1, '\P{Grapheme_Cluster_Break=glueafterzwj}', "");
    Expect(0, 1, '\P{^Grapheme_Cluster_Break=glueafterzwj}', "");
    Expect(0, 1, '\p{Grapheme_Cluster_Break=:\Aglueafterzwj\z:}', "");;
    Expect(0, 1, '\p{Grapheme_Cluster_Break=- Glue_after_ZWJ}', "");
    Expect(1, 1, '\p{^Grapheme_Cluster_Break=- Glue_after_ZWJ}', "");
    Expect(1, 1, '\P{Grapheme_Cluster_Break=- Glue_after_ZWJ}', "");
    Expect(0, 1, '\P{^Grapheme_Cluster_Break=- Glue_after_ZWJ}', "");
    Error('\p{GCB=-/a/GAZ}');
    Error('\P{GCB=-/a/GAZ}');
    Expect(0, 1, '\p{GCB=:\AGAZ\z:}', "");;
    Expect(0, 1, '\p{GCB=gaz}', "");
    Expect(1, 1, '\p{^GCB=gaz}', "");
    Expect(1, 1, '\P{GCB=gaz}', "");
    Expect(0, 1, '\P{^GCB=gaz}', "");
    Expect(0, 1, '\p{GCB=:\Agaz\z:}', "");;
    Expect(0, 1, '\p{GCB= _GAZ}', "");
    Expect(1, 1, '\p{^GCB= _GAZ}', "");
    Expect(1, 1, '\P{GCB= _GAZ}', "");
    Expect(0, 1, '\P{^GCB= _GAZ}', "");
    Error('\p{Is_Grapheme_Cluster_Break=:=_ Glue_after_Zwj}');
    Error('\P{Is_Grapheme_Cluster_Break=:=_ Glue_after_Zwj}');
    Expect(0, 1, '\p{Is_Grapheme_Cluster_Break=glueafterzwj}', "");
    Expect(1, 1, '\p{^Is_Grapheme_Cluster_Break=glueafterzwj}', "");
    Expect(1, 1, '\P{Is_Grapheme_Cluster_Break=glueafterzwj}', "");
    Expect(0, 1, '\P{^Is_Grapheme_Cluster_Break=glueafterzwj}', "");
    Expect(0, 1, '\p{Is_Grapheme_Cluster_Break= Glue_after_Zwj}', "");
    Expect(1, 1, '\p{^Is_Grapheme_Cluster_Break= Glue_after_Zwj}', "");
    Expect(1, 1, '\P{Is_Grapheme_Cluster_Break= Glue_after_Zwj}', "");
    Expect(0, 1, '\P{^Is_Grapheme_Cluster_Break= Glue_after_Zwj}', "");
    Error('\p{Is_GCB=--gaz:=}');
    Error('\P{Is_GCB=--gaz:=}');
    Expect(0, 1, '\p{Is_GCB:   gaz}', "");
    Expect(1, 1, '\p{^Is_GCB:   gaz}', "");
    Expect(1, 1, '\P{Is_GCB:   gaz}', "");
    Expect(0, 1, '\P{^Is_GCB:   gaz}', "");
    Expect(0, 1, '\p{Is_GCB=_GAZ}', "");
    Expect(1, 1, '\p{^Is_GCB=_GAZ}', "");
    Expect(1, 1, '\P{Is_GCB=_GAZ}', "");
    Expect(0, 1, '\P{^Is_GCB=_GAZ}', "");
    Error('\p{Grapheme_Cluster_Break=:=		L}');
    Error('\P{Grapheme_Cluster_Break=:=		L}');
    Expect(1, 43388, '\p{Grapheme_Cluster_Break=:\AL\z:}', "");;
    Expect(0, 43389, '\p{Grapheme_Cluster_Break=:\AL\z:}', "");;
    Expect(1, 43388, '\p{Grapheme_Cluster_Break=l}', "");
    Expect(0, 43388, '\p{^Grapheme_Cluster_Break=l}', "");
    Expect(0, 43388, '\P{Grapheme_Cluster_Break=l}', "");
    Expect(1, 43388, '\P{^Grapheme_Cluster_Break=l}', "");
    Expect(0, 43389, '\p{Grapheme_Cluster_Break=l}', "");
    Expect(1, 43389, '\p{^Grapheme_Cluster_Break=l}', "");
    Expect(1, 43389, '\P{Grapheme_Cluster_Break=l}', "");
    Expect(0, 43389, '\P{^Grapheme_Cluster_Break=l}', "");
    Expect(1, 43388, '\p{Grapheme_Cluster_Break=:\Al\z:}', "");;
    Expect(0, 43389, '\p{Grapheme_Cluster_Break=:\Al\z:}', "");;
    Expect(1, 43388, '\p{Grapheme_Cluster_Break= 	L}', "");
    Expect(0, 43388, '\p{^Grapheme_Cluster_Break= 	L}', "");
    Expect(0, 43388, '\P{Grapheme_Cluster_Break= 	L}', "");
    Expect(1, 43388, '\P{^Grapheme_Cluster_Break= 	L}', "");
    Expect(0, 43389, '\p{Grapheme_Cluster_Break= 	L}', "");
    Expect(1, 43389, '\p{^Grapheme_Cluster_Break= 	L}', "");
    Expect(1, 43389, '\P{Grapheme_Cluster_Break= 	L}', "");
    Expect(0, 43389, '\P{^Grapheme_Cluster_Break= 	L}', "");
    Error('\p{GCB=_/a/l}');
    Error('\P{GCB=_/a/l}');
    Expect(1, 43388, '\p{GCB=:\AL\z:}', "");;
    Expect(0, 43389, '\p{GCB=:\AL\z:}', "");;
    Expect(1, 43388, '\p{GCB: l}', "");
    Expect(0, 43388, '\p{^GCB: l}', "");
    Expect(0, 43388, '\P{GCB: l}', "");
    Expect(1, 43388, '\P{^GCB: l}', "");
    Expect(0, 43389, '\p{GCB: l}', "");
    Expect(1, 43389, '\p{^GCB: l}', "");
    Expect(1, 43389, '\P{GCB: l}', "");
    Expect(0, 43389, '\P{^GCB: l}', "");
    Expect(1, 43388, '\p{GCB=:\Al\z:}', "");;
    Expect(0, 43389, '\p{GCB=:\Al\z:}', "");;
    Expect(1, 43388, '\p{GCB=-L}', "");
    Expect(0, 43388, '\p{^GCB=-L}', "");
    Expect(0, 43388, '\P{GCB=-L}', "");
    Expect(1, 43388, '\P{^GCB=-L}', "");
    Expect(0, 43389, '\p{GCB=-L}', "");
    Expect(1, 43389, '\p{^GCB=-L}', "");
    Expect(1, 43389, '\P{GCB=-L}', "");
    Expect(0, 43389, '\P{^GCB=-L}', "");
    Error('\p{Is_Grapheme_Cluster_Break= _L/a/}');
    Error('\P{Is_Grapheme_Cluster_Break= _L/a/}');
    Expect(1, 43388, '\p{Is_Grapheme_Cluster_Break=l}', "");
    Expect(0, 43388, '\p{^Is_Grapheme_Cluster_Break=l}', "");
    Expect(0, 43388, '\P{Is_Grapheme_Cluster_Break=l}', "");
    Expect(1, 43388, '\P{^Is_Grapheme_Cluster_Break=l}', "");
    Expect(0, 43389, '\p{Is_Grapheme_Cluster_Break=l}', "");
    Expect(1, 43389, '\p{^Is_Grapheme_Cluster_Break=l}', "");
    Expect(1, 43389, '\P{Is_Grapheme_Cluster_Break=l}', "");
    Expect(0, 43389, '\P{^Is_Grapheme_Cluster_Break=l}', "");
    Expect(1, 43388, '\p{Is_Grapheme_Cluster_Break=	_L}', "");
    Expect(0, 43388, '\p{^Is_Grapheme_Cluster_Break=	_L}', "");
    Expect(0, 43388, '\P{Is_Grapheme_Cluster_Break=	_L}', "");
    Expect(1, 43388, '\P{^Is_Grapheme_Cluster_Break=	_L}', "");
    Expect(0, 43389, '\p{Is_Grapheme_Cluster_Break=	_L}', "");
    Expect(1, 43389, '\p{^Is_Grapheme_Cluster_Break=	_L}', "");
    Expect(1, 43389, '\P{Is_Grapheme_Cluster_Break=	_L}', "");
    Expect(0, 43389, '\P{^Is_Grapheme_Cluster_Break=	_L}', "");
    Error('\p{Is_GCB: /a/_ L}');
    Error('\P{Is_GCB: /a/_ L}');
    Expect(1, 43388, '\p{Is_GCB=l}', "");
    Expect(0, 43388, '\p{^Is_GCB=l}', "");
    Expect(0, 43388, '\P{Is_GCB=l}', "");
    Expect(1, 43388, '\P{^Is_GCB=l}', "");
    Expect(0, 43389, '\p{Is_GCB=l}', "");
    Expect(1, 43389, '\p{^Is_GCB=l}', "");
    Expect(1, 43389, '\P{Is_GCB=l}', "");
    Expect(0, 43389, '\P{^Is_GCB=l}', "");
    Expect(1, 43388, '\p{Is_GCB=--l}', "");
    Expect(0, 43388, '\p{^Is_GCB=--l}', "");
    Expect(0, 43388, '\P{Is_GCB=--l}', "");
    Expect(1, 43388, '\P{^Is_GCB=--l}', "");
    Expect(0, 43389, '\p{Is_GCB=--l}', "");
    Expect(1, 43389, '\p{^Is_GCB=--l}', "");
    Expect(1, 43389, '\P{Is_GCB=--l}', "");
    Expect(0, 43389, '\P{^Is_GCB=--l}', "");
    Error('\p{Grapheme_Cluster_Break=/a/	_lf}');
    Error('\P{Grapheme_Cluster_Break=/a/	_lf}');
    Expect(1, 10, '\p{Grapheme_Cluster_Break=:\ALF\z:}', "");;
    Expect(0, 11, '\p{Grapheme_Cluster_Break=:\ALF\z:}', "");;
    Expect(1, 10, '\p{Grapheme_Cluster_Break=lf}', "");
    Expect(0, 10, '\p{^Grapheme_Cluster_Break=lf}', "");
    Expect(0, 10, '\P{Grapheme_Cluster_Break=lf}', "");
    Expect(1, 10, '\P{^Grapheme_Cluster_Break=lf}', "");
    Expect(0, 11, '\p{Grapheme_Cluster_Break=lf}', "");
    Expect(1, 11, '\p{^Grapheme_Cluster_Break=lf}', "");
    Expect(1, 11, '\P{Grapheme_Cluster_Break=lf}', "");
    Expect(0, 11, '\P{^Grapheme_Cluster_Break=lf}', "");
    Expect(1, 10, '\p{Grapheme_Cluster_Break=:\Alf\z:}', "");;
    Expect(0, 11, '\p{Grapheme_Cluster_Break=:\Alf\z:}', "");;
    Expect(1, 10, '\p{Grapheme_Cluster_Break=  LF}', "");
    Expect(0, 10, '\p{^Grapheme_Cluster_Break=  LF}', "");
    Expect(0, 10, '\P{Grapheme_Cluster_Break=  LF}', "");
    Expect(1, 10, '\P{^Grapheme_Cluster_Break=  LF}', "");
    Expect(0, 11, '\p{Grapheme_Cluster_Break=  LF}', "");
    Expect(1, 11, '\p{^Grapheme_Cluster_Break=  LF}', "");
    Expect(1, 11, '\P{Grapheme_Cluster_Break=  LF}', "");
    Expect(0, 11, '\P{^Grapheme_Cluster_Break=  LF}', "");
    Error('\p{GCB=:=--lf}');
    Error('\P{GCB=:=--lf}');
    Expect(1, 10, '\p{GCB=:\ALF\z:}', "");;
    Expect(0, 11, '\p{GCB=:\ALF\z:}', "");;
    Expect(1, 10, '\p{GCB=lf}', "");
    Expect(0, 10, '\p{^GCB=lf}', "");
    Expect(0, 10, '\P{GCB=lf}', "");
    Expect(1, 10, '\P{^GCB=lf}', "");
    Expect(0, 11, '\p{GCB=lf}', "");
    Expect(1, 11, '\p{^GCB=lf}', "");
    Expect(1, 11, '\P{GCB=lf}', "");
    Expect(0, 11, '\P{^GCB=lf}', "");
    Expect(1, 10, '\p{GCB=:\Alf\z:}', "");;
    Expect(0, 11, '\p{GCB=:\Alf\z:}', "");;
    Expect(1, 10, '\p{GCB=-lf}', "");
    Expect(0, 10, '\p{^GCB=-lf}', "");
    Expect(0, 10, '\P{GCB=-lf}', "");
    Expect(1, 10, '\P{^GCB=-lf}', "");
    Expect(0, 11, '\p{GCB=-lf}', "");
    Expect(1, 11, '\p{^GCB=-lf}', "");
    Expect(1, 11, '\P{GCB=-lf}', "");
    Expect(0, 11, '\P{^GCB=-lf}', "");
    Error('\p{Is_Grapheme_Cluster_Break= :=LF}');
    Error('\P{Is_Grapheme_Cluster_Break= :=LF}');
    Expect(1, 10, '\p{Is_Grapheme_Cluster_Break=lf}', "");
    Expect(0, 10, '\p{^Is_Grapheme_Cluster_Break=lf}', "");
    Expect(0, 10, '\P{Is_Grapheme_Cluster_Break=lf}', "");
    Expect(1, 10, '\P{^Is_Grapheme_Cluster_Break=lf}', "");
    Expect(0, 11, '\p{Is_Grapheme_Cluster_Break=lf}', "");
    Expect(1, 11, '\p{^Is_Grapheme_Cluster_Break=lf}', "");
    Expect(1, 11, '\P{Is_Grapheme_Cluster_Break=lf}', "");
    Expect(0, 11, '\P{^Is_Grapheme_Cluster_Break=lf}', "");
    Expect(1, 10, '\p{Is_Grapheme_Cluster_Break=	_LF}', "");
    Expect(0, 10, '\p{^Is_Grapheme_Cluster_Break=	_LF}', "");
    Expect(0, 10, '\P{Is_Grapheme_Cluster_Break=	_LF}', "");
    Expect(1, 10, '\P{^Is_Grapheme_Cluster_Break=	_LF}', "");
    Expect(0, 11, '\p{Is_Grapheme_Cluster_Break=	_LF}', "");
    Expect(1, 11, '\p{^Is_Grapheme_Cluster_Break=	_LF}', "");
    Expect(1, 11, '\P{Is_Grapheme_Cluster_Break=	_LF}', "");
    Expect(0, 11, '\P{^Is_Grapheme_Cluster_Break=	_LF}', "");
    Error('\p{Is_GCB= -LF/a/}');
    Error('\P{Is_GCB= -LF/a/}');
    Expect(1, 10, '\p{Is_GCB=lf}', "");
    Expect(0, 10, '\p{^Is_GCB=lf}', "");
    Expect(0, 10, '\P{Is_GCB=lf}', "");
    Expect(1, 10, '\P{^Is_GCB=lf}', "");
    Expect(0, 11, '\p{Is_GCB=lf}', "");
    Expect(1, 11, '\p{^Is_GCB=lf}', "");
    Expect(1, 11, '\P{Is_GCB=lf}', "");
    Expect(0, 11, '\P{^Is_GCB=lf}', "");
    Expect(1, 10, '\p{Is_GCB=__LF}', "");
    Expect(0, 10, '\p{^Is_GCB=__LF}', "");
    Expect(0, 10, '\P{Is_GCB=__LF}', "");
    Expect(1, 10, '\P{^Is_GCB=__LF}', "");
    Expect(0, 11, '\p{Is_GCB=__LF}', "");
    Expect(1, 11, '\p{^Is_GCB=__LF}', "");
    Expect(1, 11, '\P{Is_GCB=__LF}', "");
    Expect(0, 11, '\P{^Is_GCB=__LF}', "");
    Error('\p{Grapheme_Cluster_Break=:=- lv}');
    Error('\P{Grapheme_Cluster_Break=:=- lv}');
    Expect(1, 55176, '\p{Grapheme_Cluster_Break=:\ALV\z:}', "");;
    Expect(0, 55177, '\p{Grapheme_Cluster_Break=:\ALV\z:}', "");;
    Expect(1, 55176, '\p{Grapheme_Cluster_Break=lv}', "");
    Expect(0, 55176, '\p{^Grapheme_Cluster_Break=lv}', "");
    Expect(0, 55176, '\P{Grapheme_Cluster_Break=lv}', "");
    Expect(1, 55176, '\P{^Grapheme_Cluster_Break=lv}', "");
    Expect(0, 55177, '\p{Grapheme_Cluster_Break=lv}', "");
    Expect(1, 55177, '\p{^Grapheme_Cluster_Break=lv}', "");
    Expect(1, 55177, '\P{Grapheme_Cluster_Break=lv}', "");
    Expect(0, 55177, '\P{^Grapheme_Cluster_Break=lv}', "");
    Expect(1, 55176, '\p{Grapheme_Cluster_Break=:\Alv\z:}', "");;
    Expect(0, 55177, '\p{Grapheme_Cluster_Break=:\Alv\z:}', "");;
    Expect(1, 55176, '\p{Grapheme_Cluster_Break= LV}', "");
    Expect(0, 55176, '\p{^Grapheme_Cluster_Break= LV}', "");
    Expect(0, 55176, '\P{Grapheme_Cluster_Break= LV}', "");
    Expect(1, 55176, '\P{^Grapheme_Cluster_Break= LV}', "");
    Expect(0, 55177, '\p{Grapheme_Cluster_Break= LV}', "");
    Expect(1, 55177, '\p{^Grapheme_Cluster_Break= LV}', "");
    Expect(1, 55177, '\P{Grapheme_Cluster_Break= LV}', "");
    Expect(0, 55177, '\P{^Grapheme_Cluster_Break= LV}', "");
    Error('\p{GCB: /a/ LV}');
    Error('\P{GCB: /a/ LV}');
    Expect(1, 55176, '\p{GCB=:\ALV\z:}', "");;
    Expect(0, 55177, '\p{GCB=:\ALV\z:}', "");;
    Expect(1, 55176, '\p{GCB=lv}', "");
    Expect(0, 55176, '\p{^GCB=lv}', "");
    Expect(0, 55176, '\P{GCB=lv}', "");
    Expect(1, 55176, '\P{^GCB=lv}', "");
    Expect(0, 55177, '\p{GCB=lv}', "");
    Expect(1, 55177, '\p{^GCB=lv}', "");
    Expect(1, 55177, '\P{GCB=lv}', "");
    Expect(0, 55177, '\P{^GCB=lv}', "");
    Expect(1, 55176, '\p{GCB=:\Alv\z:}', "");;
    Expect(0, 55177, '\p{GCB=:\Alv\z:}', "");;
    Expect(1, 55176, '\p{GCB=__LV}', "");
    Expect(0, 55176, '\p{^GCB=__LV}', "");
    Expect(0, 55176, '\P{GCB=__LV}', "");
    Expect(1, 55176, '\P{^GCB=__LV}', "");
    Expect(0, 55177, '\p{GCB=__LV}', "");
    Expect(1, 55177, '\p{^GCB=__LV}', "");
    Expect(1, 55177, '\P{GCB=__LV}', "");
    Expect(0, 55177, '\P{^GCB=__LV}', "");
    Error('\p{Is_Grapheme_Cluster_Break=-LV:=}');
    Error('\P{Is_Grapheme_Cluster_Break=-LV:=}');
    Expect(1, 55176, '\p{Is_Grapheme_Cluster_Break=lv}', "");
    Expect(0, 55176, '\p{^Is_Grapheme_Cluster_Break=lv}', "");
    Expect(0, 55176, '\P{Is_Grapheme_Cluster_Break=lv}', "");
    Expect(1, 55176, '\P{^Is_Grapheme_Cluster_Break=lv}', "");
    Expect(0, 55177, '\p{Is_Grapheme_Cluster_Break=lv}', "");
    Expect(1, 55177, '\p{^Is_Grapheme_Cluster_Break=lv}', "");
    Expect(1, 55177, '\P{Is_Grapheme_Cluster_Break=lv}', "");
    Expect(0, 55177, '\P{^Is_Grapheme_Cluster_Break=lv}', "");
    Expect(1, 55176, '\p{Is_Grapheme_Cluster_Break=  LV}', "");
    Expect(0, 55176, '\p{^Is_Grapheme_Cluster_Break=  LV}', "");
    Expect(0, 55176, '\P{Is_Grapheme_Cluster_Break=  LV}', "");
    Expect(1, 55176, '\P{^Is_Grapheme_Cluster_Break=  LV}', "");
    Expect(0, 55177, '\p{Is_Grapheme_Cluster_Break=  LV}', "");
    Expect(1, 55177, '\p{^Is_Grapheme_Cluster_Break=  LV}', "");
    Expect(1, 55177, '\P{Is_Grapheme_Cluster_Break=  LV}', "");
    Expect(0, 55177, '\P{^Is_Grapheme_Cluster_Break=  LV}', "");
    Error('\p{Is_GCB:	 :=LV}');
    Error('\P{Is_GCB:	 :=LV}');
    Expect(1, 55176, '\p{Is_GCB=lv}', "");
    Expect(0, 55176, '\p{^Is_GCB=lv}', "");
    Expect(0, 55176, '\P{Is_GCB=lv}', "");
    Expect(1, 55176, '\P{^Is_GCB=lv}', "");
    Expect(0, 55177, '\p{Is_GCB=lv}', "");
    Expect(1, 55177, '\p{^Is_GCB=lv}', "");
    Expect(1, 55177, '\P{Is_GCB=lv}', "");
    Expect(0, 55177, '\P{^Is_GCB=lv}', "");
    Expect(1, 55176, '\p{Is_GCB=--LV}', "");
    Expect(0, 55176, '\p{^Is_GCB=--LV}', "");
    Expect(0, 55176, '\P{Is_GCB=--LV}', "");
    Expect(1, 55176, '\P{^Is_GCB=--LV}', "");
    Expect(0, 55177, '\p{Is_GCB=--LV}', "");
    Expect(1, 55177, '\p{^Is_GCB=--LV}', "");
    Expect(1, 55177, '\P{Is_GCB=--LV}', "");
    Expect(0, 55177, '\P{^Is_GCB=--LV}', "");
    Error('\p{Grapheme_Cluster_Break=_	LVT:=}');
    Error('\P{Grapheme_Cluster_Break=_	LVT:=}');
    Expect(1, 55203, '\p{Grapheme_Cluster_Break=:\ALVT\z:}', "");;
    Expect(0, 55204, '\p{Grapheme_Cluster_Break=:\ALVT\z:}', "");;
    Expect(1, 55203, '\p{Grapheme_Cluster_Break: lvt}', "");
    Expect(0, 55203, '\p{^Grapheme_Cluster_Break: lvt}', "");
    Expect(0, 55203, '\P{Grapheme_Cluster_Break: lvt}', "");
    Expect(1, 55203, '\P{^Grapheme_Cluster_Break: lvt}', "");
    Expect(0, 55204, '\p{Grapheme_Cluster_Break: lvt}', "");
    Expect(1, 55204, '\p{^Grapheme_Cluster_Break: lvt}', "");
    Expect(1, 55204, '\P{Grapheme_Cluster_Break: lvt}', "");
    Expect(0, 55204, '\P{^Grapheme_Cluster_Break: lvt}', "");
    Expect(1, 55203, '\p{Grapheme_Cluster_Break=:\Alvt\z:}', "");;
    Expect(0, 55204, '\p{Grapheme_Cluster_Break=:\Alvt\z:}', "");;
    Expect(1, 55203, '\p{Grapheme_Cluster_Break:_LVT}', "");
    Expect(0, 55203, '\p{^Grapheme_Cluster_Break:_LVT}', "");
    Expect(0, 55203, '\P{Grapheme_Cluster_Break:_LVT}', "");
    Expect(1, 55203, '\P{^Grapheme_Cluster_Break:_LVT}', "");
    Expect(0, 55204, '\p{Grapheme_Cluster_Break:_LVT}', "");
    Expect(1, 55204, '\p{^Grapheme_Cluster_Break:_LVT}', "");
    Expect(1, 55204, '\P{Grapheme_Cluster_Break:_LVT}', "");
    Expect(0, 55204, '\P{^Grapheme_Cluster_Break:_LVT}', "");
    Error('\p{GCB=	:=LVT}');
    Error('\P{GCB=	:=LVT}');
    Expect(1, 55203, '\p{GCB=:\ALVT\z:}', "");;
    Expect(0, 55204, '\p{GCB=:\ALVT\z:}', "");;
    Expect(1, 55203, '\p{GCB=lvt}', "");
    Expect(0, 55203, '\p{^GCB=lvt}', "");
    Expect(0, 55203, '\P{GCB=lvt}', "");
    Expect(1, 55203, '\P{^GCB=lvt}', "");
    Expect(0, 55204, '\p{GCB=lvt}', "");
    Expect(1, 55204, '\p{^GCB=lvt}', "");
    Expect(1, 55204, '\P{GCB=lvt}', "");
    Expect(0, 55204, '\P{^GCB=lvt}', "");
    Expect(1, 55203, '\p{GCB=:\Alvt\z:}', "");;
    Expect(0, 55204, '\p{GCB=:\Alvt\z:}', "");;
    Expect(1, 55203, '\p{GCB= LVT}', "");
    Expect(0, 55203, '\p{^GCB= LVT}', "");
    Expect(0, 55203, '\P{GCB= LVT}', "");
    Expect(1, 55203, '\P{^GCB= LVT}', "");
    Expect(0, 55204, '\p{GCB= LVT}', "");
    Expect(1, 55204, '\p{^GCB= LVT}', "");
    Expect(1, 55204, '\P{GCB= LVT}', "");
    Expect(0, 55204, '\P{^GCB= LVT}', "");
    Error('\p{Is_Grapheme_Cluster_Break=/a/-_lvt}');
    Error('\P{Is_Grapheme_Cluster_Break=/a/-_lvt}');
    Expect(1, 55203, '\p{Is_Grapheme_Cluster_Break=lvt}', "");
    Expect(0, 55203, '\p{^Is_Grapheme_Cluster_Break=lvt}', "");
    Expect(0, 55203, '\P{Is_Grapheme_Cluster_Break=lvt}', "");
    Expect(1, 55203, '\P{^Is_Grapheme_Cluster_Break=lvt}', "");
    Expect(0, 55204, '\p{Is_Grapheme_Cluster_Break=lvt}', "");
    Expect(1, 55204, '\p{^Is_Grapheme_Cluster_Break=lvt}', "");
    Expect(1, 55204, '\P{Is_Grapheme_Cluster_Break=lvt}', "");
    Expect(0, 55204, '\P{^Is_Grapheme_Cluster_Break=lvt}', "");
    Error('\p{Is_GCB=/a/lvt}');
    Error('\P{Is_GCB=/a/lvt}');
    Expect(1, 55203, '\p{Is_GCB=lvt}', "");
    Expect(0, 55203, '\p{^Is_GCB=lvt}', "");
    Expect(0, 55203, '\P{Is_GCB=lvt}', "");
    Expect(1, 55203, '\P{^Is_GCB=lvt}', "");
    Expect(0, 55204, '\p{Is_GCB=lvt}', "");
    Expect(1, 55204, '\p{^Is_GCB=lvt}', "");
    Expect(1, 55204, '\P{Is_GCB=lvt}', "");
    Expect(0, 55204, '\P{^Is_GCB=lvt}', "");
    Expect(1, 55203, '\p{Is_GCB=_	LVT}', "");
    Expect(0, 55203, '\p{^Is_GCB=_	LVT}', "");
    Expect(0, 55203, '\P{Is_GCB=_	LVT}', "");
    Expect(1, 55203, '\P{^Is_GCB=_	LVT}', "");
    Expect(0, 55204, '\p{Is_GCB=_	LVT}', "");
    Expect(1, 55204, '\p{^Is_GCB=_	LVT}', "");
    Expect(1, 55204, '\P{Is_GCB=_	LVT}', "");
    Expect(0, 55204, '\P{^Is_GCB=_	LVT}', "");
    Error('\p{Grapheme_Cluster_Break=/a/_Prepend}');
    Error('\P{Grapheme_Cluster_Break=/a/_Prepend}');
    Expect(1, 73030, '\p{Grapheme_Cluster_Break=:\APrepend\z:}', "");;
    Expect(0, 73031, '\p{Grapheme_Cluster_Break=:\APrepend\z:}', "");;
    Expect(1, 73030, '\p{Grapheme_Cluster_Break=prepend}', "");
    Expect(0, 73030, '\p{^Grapheme_Cluster_Break=prepend}', "");
    Expect(0, 73030, '\P{Grapheme_Cluster_Break=prepend}', "");
    Expect(1, 73030, '\P{^Grapheme_Cluster_Break=prepend}', "");
    Expect(0, 73031, '\p{Grapheme_Cluster_Break=prepend}', "");
    Expect(1, 73031, '\p{^Grapheme_Cluster_Break=prepend}', "");
    Expect(1, 73031, '\P{Grapheme_Cluster_Break=prepend}', "");
    Expect(0, 73031, '\P{^Grapheme_Cluster_Break=prepend}', "");
    Expect(1, 73030, '\p{Grapheme_Cluster_Break=:\Aprepend\z:}', "");;
    Expect(0, 73031, '\p{Grapheme_Cluster_Break=:\Aprepend\z:}', "");;
    Expect(1, 73030, '\p{Grapheme_Cluster_Break=-_prepend}', "");
    Expect(0, 73030, '\p{^Grapheme_Cluster_Break=-_prepend}', "");
    Expect(0, 73030, '\P{Grapheme_Cluster_Break=-_prepend}', "");
    Expect(1, 73030, '\P{^Grapheme_Cluster_Break=-_prepend}', "");
    Expect(0, 73031, '\p{Grapheme_Cluster_Break=-_prepend}', "");
    Expect(1, 73031, '\p{^Grapheme_Cluster_Break=-_prepend}', "");
    Expect(1, 73031, '\P{Grapheme_Cluster_Break=-_prepend}', "");
    Expect(0, 73031, '\P{^Grapheme_Cluster_Break=-_prepend}', "");
    Error('\p{GCB=/a/ PP}');
    Error('\P{GCB=/a/ PP}');
    Expect(1, 73030, '\p{GCB=:\APP\z:}', "");;
    Expect(0, 73031, '\p{GCB=:\APP\z:}', "");;
    Expect(1, 73030, '\p{GCB=pp}', "");
    Expect(0, 73030, '\p{^GCB=pp}', "");
    Expect(0, 73030, '\P{GCB=pp}', "");
    Expect(1, 73030, '\P{^GCB=pp}', "");
    Expect(0, 73031, '\p{GCB=pp}', "");
    Expect(1, 73031, '\p{^GCB=pp}', "");
    Expect(1, 73031, '\P{GCB=pp}', "");
    Expect(0, 73031, '\P{^GCB=pp}', "");
    Expect(1, 73030, '\p{GCB=:\App\z:}', "");;
    Expect(0, 73031, '\p{GCB=:\App\z:}', "");;
    Expect(1, 73030, '\p{GCB=	-PP}', "");
    Expect(0, 73030, '\p{^GCB=	-PP}', "");
    Expect(0, 73030, '\P{GCB=	-PP}', "");
    Expect(1, 73030, '\P{^GCB=	-PP}', "");
    Expect(0, 73031, '\p{GCB=	-PP}', "");
    Expect(1, 73031, '\p{^GCB=	-PP}', "");
    Expect(1, 73031, '\P{GCB=	-PP}', "");
    Expect(0, 73031, '\P{^GCB=	-PP}', "");
    Error('\p{Is_Grapheme_Cluster_Break=	:=PREPEND}');
    Error('\P{Is_Grapheme_Cluster_Break=	:=PREPEND}');
    Expect(1, 73030, '\p{Is_Grapheme_Cluster_Break=prepend}', "");
    Expect(0, 73030, '\p{^Is_Grapheme_Cluster_Break=prepend}', "");
    Expect(0, 73030, '\P{Is_Grapheme_Cluster_Break=prepend}', "");
    Expect(1, 73030, '\P{^Is_Grapheme_Cluster_Break=prepend}', "");
    Expect(0, 73031, '\p{Is_Grapheme_Cluster_Break=prepend}', "");
    Expect(1, 73031, '\p{^Is_Grapheme_Cluster_Break=prepend}', "");
    Expect(1, 73031, '\P{Is_Grapheme_Cluster_Break=prepend}', "");
    Expect(0, 73031, '\P{^Is_Grapheme_Cluster_Break=prepend}', "");
    Expect(1, 73030, '\p{Is_Grapheme_Cluster_Break:   	-prepend}', "");
    Expect(0, 73030, '\p{^Is_Grapheme_Cluster_Break:   	-prepend}', "");
    Expect(0, 73030, '\P{Is_Grapheme_Cluster_Break:   	-prepend}', "");
    Expect(1, 73030, '\P{^Is_Grapheme_Cluster_Break:   	-prepend}', "");
    Expect(0, 73031, '\p{Is_Grapheme_Cluster_Break:   	-prepend}', "");
    Expect(1, 73031, '\p{^Is_Grapheme_Cluster_Break:   	-prepend}', "");
    Expect(1, 73031, '\P{Is_Grapheme_Cluster_Break:   	-prepend}', "");
    Expect(0, 73031, '\P{^Is_Grapheme_Cluster_Break:   	-prepend}', "");
    Error('\p{Is_GCB=/a/		PP}');
    Error('\P{Is_GCB=/a/		PP}');
    Expect(1, 73030, '\p{Is_GCB=pp}', "");
    Expect(0, 73030, '\p{^Is_GCB=pp}', "");
    Expect(0, 73030, '\P{Is_GCB=pp}', "");
    Expect(1, 73030, '\P{^Is_GCB=pp}', "");
    Expect(0, 73031, '\p{Is_GCB=pp}', "");
    Expect(1, 73031, '\p{^Is_GCB=pp}', "");
    Expect(1, 73031, '\P{Is_GCB=pp}', "");
    Expect(0, 73031, '\P{^Is_GCB=pp}', "");
    Expect(1, 73030, '\p{Is_GCB=_pp}', "");
    Expect(0, 73030, '\p{^Is_GCB=_pp}', "");
    Expect(0, 73030, '\P{Is_GCB=_pp}', "");
    Expect(1, 73030, '\P{^Is_GCB=_pp}', "");
    Expect(0, 73031, '\p{Is_GCB=_pp}', "");
    Expect(1, 73031, '\p{^Is_GCB=_pp}', "");
    Expect(1, 73031, '\P{Is_GCB=_pp}', "");
    Expect(0, 73031, '\P{^Is_GCB=_pp}', "");
    Error('\p{Grapheme_Cluster_Break=:=- Regional_Indicator}');
    Error('\P{Grapheme_Cluster_Break=:=- Regional_Indicator}');
    Expect(1, 127487, '\p{Grapheme_Cluster_Break=:\ARegional_Indicator\z:}', "");;
    Expect(0, 127488, '\p{Grapheme_Cluster_Break=:\ARegional_Indicator\z:}', "");;
    Expect(1, 127487, '\p{Grapheme_Cluster_Break=regionalindicator}', "");
    Expect(0, 127487, '\p{^Grapheme_Cluster_Break=regionalindicator}', "");
    Expect(0, 127487, '\P{Grapheme_Cluster_Break=regionalindicator}', "");
    Expect(1, 127487, '\P{^Grapheme_Cluster_Break=regionalindicator}', "");
    Expect(0, 127488, '\p{Grapheme_Cluster_Break=regionalindicator}', "");
    Expect(1, 127488, '\p{^Grapheme_Cluster_Break=regionalindicator}', "");
    Expect(1, 127488, '\P{Grapheme_Cluster_Break=regionalindicator}', "");
    Expect(0, 127488, '\P{^Grapheme_Cluster_Break=regionalindicator}', "");
    Expect(1, 127487, '\p{Grapheme_Cluster_Break=:\Aregionalindicator\z:}', "");;
    Expect(0, 127488, '\p{Grapheme_Cluster_Break=:\Aregionalindicator\z:}', "");;
    Expect(1, 127487, '\p{Grapheme_Cluster_Break:   _ regional_indicator}', "");
    Expect(0, 127487, '\p{^Grapheme_Cluster_Break:   _ regional_indicator}', "");
    Expect(0, 127487, '\P{Grapheme_Cluster_Break:   _ regional_indicator}', "");
    Expect(1, 127487, '\P{^Grapheme_Cluster_Break:   _ regional_indicator}', "");
    Expect(0, 127488, '\p{Grapheme_Cluster_Break:   _ regional_indicator}', "");
    Expect(1, 127488, '\p{^Grapheme_Cluster_Break:   _ regional_indicator}', "");
    Expect(1, 127488, '\P{Grapheme_Cluster_Break:   _ regional_indicator}', "");
    Expect(0, 127488, '\P{^Grapheme_Cluster_Break:   _ regional_indicator}', "");
    Error('\p{GCB=/a/_	RI}');
    Error('\P{GCB=/a/_	RI}');
    Expect(1, 127487, '\p{GCB=:\ARI\z:}', "");;
    Expect(0, 127488, '\p{GCB=:\ARI\z:}', "");;
    Expect(1, 127487, '\p{GCB=ri}', "");
    Expect(0, 127487, '\p{^GCB=ri}', "");
    Expect(0, 127487, '\P{GCB=ri}', "");
    Expect(1, 127487, '\P{^GCB=ri}', "");
    Expect(0, 127488, '\p{GCB=ri}', "");
    Expect(1, 127488, '\p{^GCB=ri}', "");
    Expect(1, 127488, '\P{GCB=ri}', "");
    Expect(0, 127488, '\P{^GCB=ri}', "");
    Expect(1, 127487, '\p{GCB=:\Ari\z:}', "");;
    Expect(0, 127488, '\p{GCB=:\Ari\z:}', "");;
    Expect(1, 127487, '\p{GCB=_RI}', "");
    Expect(0, 127487, '\p{^GCB=_RI}', "");
    Expect(0, 127487, '\P{GCB=_RI}', "");
    Expect(1, 127487, '\P{^GCB=_RI}', "");
    Expect(0, 127488, '\p{GCB=_RI}', "");
    Expect(1, 127488, '\p{^GCB=_RI}', "");
    Expect(1, 127488, '\P{GCB=_RI}', "");
    Expect(0, 127488, '\P{^GCB=_RI}', "");
    Error('\p{Is_Grapheme_Cluster_Break=/a/ Regional_indicator}');
    Error('\P{Is_Grapheme_Cluster_Break=/a/ Regional_indicator}');
    Expect(1, 127487, '\p{Is_Grapheme_Cluster_Break=regionalindicator}', "");
    Expect(0, 127487, '\p{^Is_Grapheme_Cluster_Break=regionalindicator}', "");
    Expect(0, 127487, '\P{Is_Grapheme_Cluster_Break=regionalindicator}', "");
    Expect(1, 127487, '\P{^Is_Grapheme_Cluster_Break=regionalindicator}', "");
    Expect(0, 127488, '\p{Is_Grapheme_Cluster_Break=regionalindicator}', "");
    Expect(1, 127488, '\p{^Is_Grapheme_Cluster_Break=regionalindicator}', "");
    Expect(1, 127488, '\P{Is_Grapheme_Cluster_Break=regionalindicator}', "");
    Expect(0, 127488, '\P{^Is_Grapheme_Cluster_Break=regionalindicator}', "");
    Expect(1, 127487, '\p{Is_Grapheme_Cluster_Break=__regional_Indicator}', "");
    Expect(0, 127487, '\p{^Is_Grapheme_Cluster_Break=__regional_Indicator}', "");
    Expect(0, 127487, '\P{Is_Grapheme_Cluster_Break=__regional_Indicator}', "");
    Expect(1, 127487, '\P{^Is_Grapheme_Cluster_Break=__regional_Indicator}', "");
    Expect(0, 127488, '\p{Is_Grapheme_Cluster_Break=__regional_Indicator}', "");
    Expect(1, 127488, '\p{^Is_Grapheme_Cluster_Break=__regional_Indicator}', "");
    Expect(1, 127488, '\P{Is_Grapheme_Cluster_Break=__regional_Indicator}', "");
    Expect(0, 127488, '\P{^Is_Grapheme_Cluster_Break=__regional_Indicator}', "");
    Error('\p{Is_GCB=/a/-	ri}');
    Error('\P{Is_GCB=/a/-	ri}');
    Expect(1, 127487, '\p{Is_GCB=ri}', "");
    Expect(0, 127487, '\p{^Is_GCB=ri}', "");
    Expect(0, 127487, '\P{Is_GCB=ri}', "");
    Expect(1, 127487, '\P{^Is_GCB=ri}', "");
    Expect(0, 127488, '\p{Is_GCB=ri}', "");
    Expect(1, 127488, '\p{^Is_GCB=ri}', "");
    Expect(1, 127488, '\P{Is_GCB=ri}', "");
    Expect(0, 127488, '\P{^Is_GCB=ri}', "");
    Expect(1, 127487, '\p{Is_GCB=	RI}', "");
    Expect(0, 127487, '\p{^Is_GCB=	RI}', "");
    Expect(0, 127487, '\P{Is_GCB=	RI}', "");
    Expect(1, 127487, '\P{^Is_GCB=	RI}', "");
    Expect(0, 127488, '\p{Is_GCB=	RI}', "");
    Expect(1, 127488, '\p{^Is_GCB=	RI}', "");
    Expect(1, 127488, '\P{Is_GCB=	RI}', "");
    Expect(0, 127488, '\P{^Is_GCB=	RI}', "");
    Error('\p{Grapheme_Cluster_Break=	/a/SpacingMark}');
    Error('\P{Grapheme_Cluster_Break=	/a/SpacingMark}');
    Expect(1, 119149, '\p{Grapheme_Cluster_Break=:\ASpacingMark\z:}', "");;
    Expect(0, 119150, '\p{Grapheme_Cluster_Break=:\ASpacingMark\z:}', "");;
    Expect(1, 119149, '\p{Grapheme_Cluster_Break=spacingmark}', "");
    Expect(0, 119149, '\p{^Grapheme_Cluster_Break=spacingmark}', "");
    Expect(0, 119149, '\P{Grapheme_Cluster_Break=spacingmark}', "");
    Expect(1, 119149, '\P{^Grapheme_Cluster_Break=spacingmark}', "");
    Expect(0, 119150, '\p{Grapheme_Cluster_Break=spacingmark}', "");
    Expect(1, 119150, '\p{^Grapheme_Cluster_Break=spacingmark}', "");
    Expect(1, 119150, '\P{Grapheme_Cluster_Break=spacingmark}', "");
    Expect(0, 119150, '\P{^Grapheme_Cluster_Break=spacingmark}', "");
    Expect(1, 119149, '\p{Grapheme_Cluster_Break=:\Aspacingmark\z:}', "");;
    Expect(0, 119150, '\p{Grapheme_Cluster_Break=:\Aspacingmark\z:}', "");;
    Expect(1, 119149, '\p{Grapheme_Cluster_Break=_	SPACINGMARK}', "");
    Expect(0, 119149, '\p{^Grapheme_Cluster_Break=_	SPACINGMARK}', "");
    Expect(0, 119149, '\P{Grapheme_Cluster_Break=_	SPACINGMARK}', "");
    Expect(1, 119149, '\P{^Grapheme_Cluster_Break=_	SPACINGMARK}', "");
    Expect(0, 119150, '\p{Grapheme_Cluster_Break=_	SPACINGMARK}', "");
    Expect(1, 119150, '\p{^Grapheme_Cluster_Break=_	SPACINGMARK}', "");
    Expect(1, 119150, '\P{Grapheme_Cluster_Break=_	SPACINGMARK}', "");
    Expect(0, 119150, '\P{^Grapheme_Cluster_Break=_	SPACINGMARK}', "");
    Error('\p{GCB=:=SM}');
    Error('\P{GCB=:=SM}');
    Expect(1, 119149, '\p{GCB=:\ASM\z:}', "");;
    Expect(0, 119150, '\p{GCB=:\ASM\z:}', "");;
    Expect(1, 119149, '\p{GCB=sm}', "");
    Expect(0, 119149, '\p{^GCB=sm}', "");
    Expect(0, 119149, '\P{GCB=sm}', "");
    Expect(1, 119149, '\P{^GCB=sm}', "");
    Expect(0, 119150, '\p{GCB=sm}', "");
    Expect(1, 119150, '\p{^GCB=sm}', "");
    Expect(1, 119150, '\P{GCB=sm}', "");
    Expect(0, 119150, '\P{^GCB=sm}', "");
    Expect(1, 119149, '\p{GCB=:\Asm\z:}', "");;
    Expect(0, 119150, '\p{GCB=:\Asm\z:}', "");;
    Expect(1, 119149, '\p{GCB= 	SM}', "");
    Expect(0, 119149, '\p{^GCB= 	SM}', "");
    Expect(0, 119149, '\P{GCB= 	SM}', "");
    Expect(1, 119149, '\P{^GCB= 	SM}', "");
    Expect(0, 119150, '\p{GCB= 	SM}', "");
    Expect(1, 119150, '\p{^GCB= 	SM}', "");
    Expect(1, 119150, '\P{GCB= 	SM}', "");
    Expect(0, 119150, '\P{^GCB= 	SM}', "");
    Error('\p{Is_Grapheme_Cluster_Break= 	SPACINGMARK:=}');
    Error('\P{Is_Grapheme_Cluster_Break= 	SPACINGMARK:=}');
    Expect(1, 119149, '\p{Is_Grapheme_Cluster_Break=spacingmark}', "");
    Expect(0, 119149, '\p{^Is_Grapheme_Cluster_Break=spacingmark}', "");
    Expect(0, 119149, '\P{Is_Grapheme_Cluster_Break=spacingmark}', "");
    Expect(1, 119149, '\P{^Is_Grapheme_Cluster_Break=spacingmark}', "");
    Expect(0, 119150, '\p{Is_Grapheme_Cluster_Break=spacingmark}', "");
    Expect(1, 119150, '\p{^Is_Grapheme_Cluster_Break=spacingmark}', "");
    Expect(1, 119150, '\P{Is_Grapheme_Cluster_Break=spacingmark}', "");
    Expect(0, 119150, '\P{^Is_Grapheme_Cluster_Break=spacingmark}', "");
    Expect(1, 119149, '\p{Is_Grapheme_Cluster_Break:   _-SpacingMark}', "");
    Expect(0, 119149, '\p{^Is_Grapheme_Cluster_Break:   _-SpacingMark}', "");
    Expect(0, 119149, '\P{Is_Grapheme_Cluster_Break:   _-SpacingMark}', "");
    Expect(1, 119149, '\P{^Is_Grapheme_Cluster_Break:   _-SpacingMark}', "");
    Expect(0, 119150, '\p{Is_Grapheme_Cluster_Break:   _-SpacingMark}', "");
    Expect(1, 119150, '\p{^Is_Grapheme_Cluster_Break:   _-SpacingMark}', "");
    Expect(1, 119150, '\P{Is_Grapheme_Cluster_Break:   _-SpacingMark}', "");
    Expect(0, 119150, '\P{^Is_Grapheme_Cluster_Break:   _-SpacingMark}', "");
    Error('\p{Is_GCB=:=	-sm}');
    Error('\P{Is_GCB=:=	-sm}');
    Expect(1, 119149, '\p{Is_GCB:   sm}', "");
    Expect(0, 119149, '\p{^Is_GCB:   sm}', "");
    Expect(0, 119149, '\P{Is_GCB:   sm}', "");
    Expect(1, 119149, '\P{^Is_GCB:   sm}', "");
    Expect(0, 119150, '\p{Is_GCB:   sm}', "");
    Expect(1, 119150, '\p{^Is_GCB:   sm}', "");
    Expect(1, 119150, '\P{Is_GCB:   sm}', "");
    Expect(0, 119150, '\P{^Is_GCB:   sm}', "");
    Expect(1, 119149, '\p{Is_GCB=--SM}', "");
    Expect(0, 119149, '\p{^Is_GCB=--SM}', "");
    Expect(0, 119149, '\P{Is_GCB=--SM}', "");
    Expect(1, 119149, '\P{^Is_GCB=--SM}', "");
    Expect(0, 119150, '\p{Is_GCB=--SM}', "");
    Expect(1, 119150, '\p{^Is_GCB=--SM}', "");
    Expect(1, 119150, '\P{Is_GCB=--SM}', "");
    Expect(0, 119150, '\P{^Is_GCB=--SM}', "");
    Error('\p{Grapheme_Cluster_Break= _T:=}');
    Error('\P{Grapheme_Cluster_Break= _T:=}');
    Expect(1, 55291, '\p{Grapheme_Cluster_Break=:\AT\z:}', "");;
    Expect(0, 55292, '\p{Grapheme_Cluster_Break=:\AT\z:}', "");;
    Expect(1, 55291, '\p{Grapheme_Cluster_Break=t}', "");
    Expect(0, 55291, '\p{^Grapheme_Cluster_Break=t}', "");
    Expect(0, 55291, '\P{Grapheme_Cluster_Break=t}', "");
    Expect(1, 55291, '\P{^Grapheme_Cluster_Break=t}', "");
    Expect(0, 55292, '\p{Grapheme_Cluster_Break=t}', "");
    Expect(1, 55292, '\p{^Grapheme_Cluster_Break=t}', "");
    Expect(1, 55292, '\P{Grapheme_Cluster_Break=t}', "");
    Expect(0, 55292, '\P{^Grapheme_Cluster_Break=t}', "");
    Expect(1, 55291, '\p{Grapheme_Cluster_Break=:\At\z:}', "");;
    Expect(0, 55292, '\p{Grapheme_Cluster_Break=:\At\z:}', "");;
    Expect(1, 55291, '\p{Grapheme_Cluster_Break= 	T}', "");
    Expect(0, 55291, '\p{^Grapheme_Cluster_Break= 	T}', "");
    Expect(0, 55291, '\P{Grapheme_Cluster_Break= 	T}', "");
    Expect(1, 55291, '\P{^Grapheme_Cluster_Break= 	T}', "");
    Expect(0, 55292, '\p{Grapheme_Cluster_Break= 	T}', "");
    Expect(1, 55292, '\p{^Grapheme_Cluster_Break= 	T}', "");
    Expect(1, 55292, '\P{Grapheme_Cluster_Break= 	T}', "");
    Expect(0, 55292, '\P{^Grapheme_Cluster_Break= 	T}', "");
    Error('\p{GCB:	:= _t}');
    Error('\P{GCB:	:= _t}');
    Expect(1, 55291, '\p{GCB=:\AT\z:}', "");;
    Expect(0, 55292, '\p{GCB=:\AT\z:}', "");;
    Expect(1, 55291, '\p{GCB=t}', "");
    Expect(0, 55291, '\p{^GCB=t}', "");
    Expect(0, 55291, '\P{GCB=t}', "");
    Expect(1, 55291, '\P{^GCB=t}', "");
    Expect(0, 55292, '\p{GCB=t}', "");
    Expect(1, 55292, '\p{^GCB=t}', "");
    Expect(1, 55292, '\P{GCB=t}', "");
    Expect(0, 55292, '\P{^GCB=t}', "");
    Expect(1, 55291, '\p{GCB=:\At\z:}', "");;
    Expect(0, 55292, '\p{GCB=:\At\z:}', "");;
    Expect(1, 55291, '\p{GCB=-	T}', "");
    Expect(0, 55291, '\p{^GCB=-	T}', "");
    Expect(0, 55291, '\P{GCB=-	T}', "");
    Expect(1, 55291, '\P{^GCB=-	T}', "");
    Expect(0, 55292, '\p{GCB=-	T}', "");
    Expect(1, 55292, '\p{^GCB=-	T}', "");
    Expect(1, 55292, '\P{GCB=-	T}', "");
    Expect(0, 55292, '\P{^GCB=-	T}', "");
    Error('\p{Is_Grapheme_Cluster_Break=/a/T}');
    Error('\P{Is_Grapheme_Cluster_Break=/a/T}');
    Expect(1, 55291, '\p{Is_Grapheme_Cluster_Break:	t}', "");
    Expect(0, 55291, '\p{^Is_Grapheme_Cluster_Break:	t}', "");
    Expect(0, 55291, '\P{Is_Grapheme_Cluster_Break:	t}', "");
    Expect(1, 55291, '\P{^Is_Grapheme_Cluster_Break:	t}', "");
    Expect(0, 55292, '\p{Is_Grapheme_Cluster_Break:	t}', "");
    Expect(1, 55292, '\p{^Is_Grapheme_Cluster_Break:	t}', "");
    Expect(1, 55292, '\P{Is_Grapheme_Cluster_Break:	t}', "");
    Expect(0, 55292, '\P{^Is_Grapheme_Cluster_Break:	t}', "");
    Expect(1, 55291, '\p{Is_Grapheme_Cluster_Break: _T}', "");
    Expect(0, 55291, '\p{^Is_Grapheme_Cluster_Break: _T}', "");
    Expect(0, 55291, '\P{Is_Grapheme_Cluster_Break: _T}', "");
    Expect(1, 55291, '\P{^Is_Grapheme_Cluster_Break: _T}', "");
    Expect(0, 55292, '\p{Is_Grapheme_Cluster_Break: _T}', "");
    Expect(1, 55292, '\p{^Is_Grapheme_Cluster_Break: _T}', "");
    Expect(1, 55292, '\P{Is_Grapheme_Cluster_Break: _T}', "");
    Expect(0, 55292, '\P{^Is_Grapheme_Cluster_Break: _T}', "");
    Error('\p{Is_GCB=/a/ -T}');
    Error('\P{Is_GCB=/a/ -T}');
    Expect(1, 55291, '\p{Is_GCB=t}', "");
    Expect(0, 55291, '\p{^Is_GCB=t}', "");
    Expect(0, 55291, '\P{Is_GCB=t}', "");
    Expect(1, 55291, '\P{^Is_GCB=t}', "");
    Expect(0, 55292, '\p{Is_GCB=t}', "");
    Expect(1, 55292, '\p{^Is_GCB=t}', "");
    Expect(1, 55292, '\P{Is_GCB=t}', "");
    Expect(0, 55292, '\P{^Is_GCB=t}', "");
    Expect(1, 55291, '\p{Is_GCB=_-T}', "");
    Expect(0, 55291, '\p{^Is_GCB=_-T}', "");
    Expect(0, 55291, '\P{Is_GCB=_-T}', "");
    Expect(1, 55291, '\P{^Is_GCB=_-T}', "");
    Expect(0, 55292, '\p{Is_GCB=_-T}', "");
    Expect(1, 55292, '\p{^Is_GCB=_-T}', "");
    Expect(1, 55292, '\P{Is_GCB=_-T}', "");
    Expect(0, 55292, '\P{^Is_GCB=_-T}', "");
    Error('\p{Grapheme_Cluster_Break=	/a/V}');
    Error('\P{Grapheme_Cluster_Break=	/a/V}');
    Expect(1, 55238, '\p{Grapheme_Cluster_Break=:\AV\z:}', "");;
    Expect(0, 55239, '\p{Grapheme_Cluster_Break=:\AV\z:}', "");;
    Expect(1, 55238, '\p{Grapheme_Cluster_Break:	v}', "");
    Expect(0, 55238, '\p{^Grapheme_Cluster_Break:	v}', "");
    Expect(0, 55238, '\P{Grapheme_Cluster_Break:	v}', "");
    Expect(1, 55238, '\P{^Grapheme_Cluster_Break:	v}', "");
    Expect(0, 55239, '\p{Grapheme_Cluster_Break:	v}', "");
    Expect(1, 55239, '\p{^Grapheme_Cluster_Break:	v}', "");
    Expect(1, 55239, '\P{Grapheme_Cluster_Break:	v}', "");
    Expect(0, 55239, '\P{^Grapheme_Cluster_Break:	v}', "");
    Expect(1, 55238, '\p{Grapheme_Cluster_Break=:\Av\z:}', "");;
    Expect(0, 55239, '\p{Grapheme_Cluster_Break=:\Av\z:}', "");;
    Expect(1, 55238, '\p{Grapheme_Cluster_Break=  v}', "");
    Expect(0, 55238, '\p{^Grapheme_Cluster_Break=  v}', "");
    Expect(0, 55238, '\P{Grapheme_Cluster_Break=  v}', "");
    Expect(1, 55238, '\P{^Grapheme_Cluster_Break=  v}', "");
    Expect(0, 55239, '\p{Grapheme_Cluster_Break=  v}', "");
    Expect(1, 55239, '\p{^Grapheme_Cluster_Break=  v}', "");
    Expect(1, 55239, '\P{Grapheme_Cluster_Break=  v}', "");
    Expect(0, 55239, '\P{^Grapheme_Cluster_Break=  v}', "");
    Error('\p{GCB=_V:=}');
    Error('\P{GCB=_V:=}');
    Expect(1, 55238, '\p{GCB=:\AV\z:}', "");;
    Expect(0, 55239, '\p{GCB=:\AV\z:}', "");;
    Expect(1, 55238, '\p{GCB=v}', "");
    Expect(0, 55238, '\p{^GCB=v}', "");
    Expect(0, 55238, '\P{GCB=v}', "");
    Expect(1, 55238, '\P{^GCB=v}', "");
    Expect(0, 55239, '\p{GCB=v}', "");
    Expect(1, 55239, '\p{^GCB=v}', "");
    Expect(1, 55239, '\P{GCB=v}', "");
    Expect(0, 55239, '\P{^GCB=v}', "");
    Expect(1, 55238, '\p{GCB=:\Av\z:}', "");;
    Expect(0, 55239, '\p{GCB=:\Av\z:}', "");;
    Expect(1, 55238, '\p{GCB: --v}', "");
    Expect(0, 55238, '\p{^GCB: --v}', "");
    Expect(0, 55238, '\P{GCB: --v}', "");
    Expect(1, 55238, '\P{^GCB: --v}', "");
    Expect(0, 55239, '\p{GCB: --v}', "");
    Expect(1, 55239, '\p{^GCB: --v}', "");
    Expect(1, 55239, '\P{GCB: --v}', "");
    Expect(0, 55239, '\P{^GCB: --v}', "");
    Error('\p{Is_Grapheme_Cluster_Break=_/a/V}');
    Error('\P{Is_Grapheme_Cluster_Break=_/a/V}');
    Expect(1, 55238, '\p{Is_Grapheme_Cluster_Break:   v}', "");
    Expect(0, 55238, '\p{^Is_Grapheme_Cluster_Break:   v}', "");
    Expect(0, 55238, '\P{Is_Grapheme_Cluster_Break:   v}', "");
    Expect(1, 55238, '\P{^Is_Grapheme_Cluster_Break:   v}', "");
    Expect(0, 55239, '\p{Is_Grapheme_Cluster_Break:   v}', "");
    Expect(1, 55239, '\p{^Is_Grapheme_Cluster_Break:   v}', "");
    Expect(1, 55239, '\P{Is_Grapheme_Cluster_Break:   v}', "");
    Expect(0, 55239, '\P{^Is_Grapheme_Cluster_Break:   v}', "");
    Expect(1, 55238, '\p{Is_Grapheme_Cluster_Break=- V}', "");
    Expect(0, 55238, '\p{^Is_Grapheme_Cluster_Break=- V}', "");
    Expect(0, 55238, '\P{Is_Grapheme_Cluster_Break=- V}', "");
    Expect(1, 55238, '\P{^Is_Grapheme_Cluster_Break=- V}', "");
    Expect(0, 55239, '\p{Is_Grapheme_Cluster_Break=- V}', "");
    Expect(1, 55239, '\p{^Is_Grapheme_Cluster_Break=- V}', "");
    Expect(1, 55239, '\P{Is_Grapheme_Cluster_Break=- V}', "");
    Expect(0, 55239, '\P{^Is_Grapheme_Cluster_Break=- V}', "");
    Error('\p{Is_GCB=/a/ -v}');
    Error('\P{Is_GCB=/a/ -v}');
    Expect(1, 55238, '\p{Is_GCB:v}', "");
    Expect(0, 55238, '\p{^Is_GCB:v}', "");
    Expect(0, 55238, '\P{Is_GCB:v}', "");
    Expect(1, 55238, '\P{^Is_GCB:v}', "");
    Expect(0, 55239, '\p{Is_GCB:v}', "");
    Expect(1, 55239, '\p{^Is_GCB:v}', "");
    Expect(1, 55239, '\P{Is_GCB:v}', "");
    Expect(0, 55239, '\P{^Is_GCB:v}', "");
    Expect(1, 55238, '\p{Is_GCB=	-V}', "");
    Expect(0, 55238, '\p{^Is_GCB=	-V}', "");
    Expect(0, 55238, '\P{Is_GCB=	-V}', "");
    Expect(1, 55238, '\P{^Is_GCB=	-V}', "");
    Expect(0, 55239, '\p{Is_GCB=	-V}', "");
    Expect(1, 55239, '\p{^Is_GCB=	-V}', "");
    Expect(1, 55239, '\P{Is_GCB=	-V}', "");
    Expect(0, 55239, '\P{^Is_GCB=	-V}', "");
    Error('\p{Grapheme_Cluster_Break= /a/Other}');
    Error('\P{Grapheme_Cluster_Break= /a/Other}');
    Expect(1, 921600, '\p{Grapheme_Cluster_Break=:\AOther\z:}', "");;
    Expect(0, 921599, '\p{Grapheme_Cluster_Break=:\AOther\z:}', "");;
    Expect(1, 921600, '\p{Grapheme_Cluster_Break:other}', "");
    Expect(0, 921600, '\p{^Grapheme_Cluster_Break:other}', "");
    Expect(0, 921600, '\P{Grapheme_Cluster_Break:other}', "");
    Expect(1, 921600, '\P{^Grapheme_Cluster_Break:other}', "");
    Expect(0, 921599, '\p{Grapheme_Cluster_Break:other}', "");
    Expect(1, 921599, '\p{^Grapheme_Cluster_Break:other}', "");
    Expect(1, 921599, '\P{Grapheme_Cluster_Break:other}', "");
    Expect(0, 921599, '\P{^Grapheme_Cluster_Break:other}', "");
    Expect(1, 921600, '\p{Grapheme_Cluster_Break=:\Aother\z:}', "");;
    Expect(0, 921599, '\p{Grapheme_Cluster_Break=:\Aother\z:}', "");;
    Expect(1, 921600, '\p{Grapheme_Cluster_Break=-	other}', "");
    Expect(0, 921600, '\p{^Grapheme_Cluster_Break=-	other}', "");
    Expect(0, 921600, '\P{Grapheme_Cluster_Break=-	other}', "");
    Expect(1, 921600, '\P{^Grapheme_Cluster_Break=-	other}', "");
    Expect(0, 921599, '\p{Grapheme_Cluster_Break=-	other}', "");
    Expect(1, 921599, '\p{^Grapheme_Cluster_Break=-	other}', "");
    Expect(1, 921599, '\P{Grapheme_Cluster_Break=-	other}', "");
    Expect(0, 921599, '\P{^Grapheme_Cluster_Break=-	other}', "");
    Error('\p{GCB=_	XX/a/}');
    Error('\P{GCB=_	XX/a/}');
    Expect(1, 921600, '\p{GCB=:\AXX\z:}', "");;
    Expect(0, 921599, '\p{GCB=:\AXX\z:}', "");;
    Expect(1, 921600, '\p{GCB=xx}', "");
    Expect(0, 921600, '\p{^GCB=xx}', "");
    Expect(0, 921600, '\P{GCB=xx}', "");
    Expect(1, 921600, '\P{^GCB=xx}', "");
    Expect(0, 921599, '\p{GCB=xx}', "");
    Expect(1, 921599, '\p{^GCB=xx}', "");
    Expect(1, 921599, '\P{GCB=xx}', "");
    Expect(0, 921599, '\P{^GCB=xx}', "");
    Expect(1, 921600, '\p{GCB=:\Axx\z:}', "");;
    Expect(0, 921599, '\p{GCB=:\Axx\z:}', "");;
    Expect(1, 921600, '\p{GCB= -xx}', "");
    Expect(0, 921600, '\p{^GCB= -xx}', "");
    Expect(0, 921600, '\P{GCB= -xx}', "");
    Expect(1, 921600, '\P{^GCB= -xx}', "");
    Expect(0, 921599, '\p{GCB= -xx}', "");
    Expect(1, 921599, '\p{^GCB= -xx}', "");
    Expect(1, 921599, '\P{GCB= -xx}', "");
    Expect(0, 921599, '\P{^GCB= -xx}', "");
    Error('\p{Is_Grapheme_Cluster_Break= Other/a/}');
    Error('\P{Is_Grapheme_Cluster_Break= Other/a/}');
    Expect(1, 921600, '\p{Is_Grapheme_Cluster_Break=other}', "");
    Expect(0, 921600, '\p{^Is_Grapheme_Cluster_Break=other}', "");
    Expect(0, 921600, '\P{Is_Grapheme_Cluster_Break=other}', "");
    Expect(1, 921600, '\P{^Is_Grapheme_Cluster_Break=other}', "");
    Expect(0, 921599, '\p{Is_Grapheme_Cluster_Break=other}', "");
    Expect(1, 921599, '\p{^Is_Grapheme_Cluster_Break=other}', "");
    Expect(1, 921599, '\P{Is_Grapheme_Cluster_Break=other}', "");
    Expect(0, 921599, '\P{^Is_Grapheme_Cluster_Break=other}', "");
    Expect(1, 921600, '\p{Is_Grapheme_Cluster_Break=__Other}', "");
    Expect(0, 921600, '\p{^Is_Grapheme_Cluster_Break=__Other}', "");
    Expect(0, 921600, '\P{Is_Grapheme_Cluster_Break=__Other}', "");
    Expect(1, 921600, '\P{^Is_Grapheme_Cluster_Break=__Other}', "");
    Expect(0, 921599, '\p{Is_Grapheme_Cluster_Break=__Other}', "");
    Expect(1, 921599, '\p{^Is_Grapheme_Cluster_Break=__Other}', "");
    Expect(1, 921599, '\P{Is_Grapheme_Cluster_Break=__Other}', "");
    Expect(0, 921599, '\P{^Is_Grapheme_Cluster_Break=__Other}', "");
    Error('\p{Is_GCB=-XX/a/}');
    Error('\P{Is_GCB=-XX/a/}');
    Expect(1, 921600, '\p{Is_GCB=xx}', "");
    Expect(0, 921600, '\p{^Is_GCB=xx}', "");
    Expect(0, 921600, '\P{Is_GCB=xx}', "");
    Expect(1, 921600, '\P{^Is_GCB=xx}', "");
    Expect(0, 921599, '\p{Is_GCB=xx}', "");
    Expect(1, 921599, '\p{^Is_GCB=xx}', "");
    Expect(1, 921599, '\P{Is_GCB=xx}', "");
    Expect(0, 921599, '\P{^Is_GCB=xx}', "");
    Expect(1, 921600, '\p{Is_GCB=-	XX}', "");
    Expect(0, 921600, '\p{^Is_GCB=-	XX}', "");
    Expect(0, 921600, '\P{Is_GCB=-	XX}', "");
    Expect(1, 921600, '\P{^Is_GCB=-	XX}', "");
    Expect(0, 921599, '\p{Is_GCB=-	XX}', "");
    Expect(1, 921599, '\p{^Is_GCB=-	XX}', "");
    Expect(1, 921599, '\P{Is_GCB=-	XX}', "");
    Expect(0, 921599, '\P{^Is_GCB=-	XX}', "");
    Error('\p{Grapheme_Cluster_Break= /a/ZWJ}');
    Error('\P{Grapheme_Cluster_Break= /a/ZWJ}');
    Expect(1, 8205, '\p{Grapheme_Cluster_Break=:\AZWJ\z:}', "");;
    Expect(0, 8206, '\p{Grapheme_Cluster_Break=:\AZWJ\z:}', "");;
    Expect(1, 8205, '\p{Grapheme_Cluster_Break=zwj}', "");
    Expect(0, 8205, '\p{^Grapheme_Cluster_Break=zwj}', "");
    Expect(0, 8205, '\P{Grapheme_Cluster_Break=zwj}', "");
    Expect(1, 8205, '\P{^Grapheme_Cluster_Break=zwj}', "");
    Expect(0, 8206, '\p{Grapheme_Cluster_Break=zwj}', "");
    Expect(1, 8206, '\p{^Grapheme_Cluster_Break=zwj}', "");
    Expect(1, 8206, '\P{Grapheme_Cluster_Break=zwj}', "");
    Expect(0, 8206, '\P{^Grapheme_Cluster_Break=zwj}', "");
    Expect(1, 8205, '\p{Grapheme_Cluster_Break=:\Azwj\z:}', "");;
    Expect(0, 8206, '\p{Grapheme_Cluster_Break=:\Azwj\z:}', "");;
    Expect(1, 8205, '\p{Grapheme_Cluster_Break= _zwj}', "");
    Expect(0, 8205, '\p{^Grapheme_Cluster_Break= _zwj}', "");
    Expect(0, 8205, '\P{Grapheme_Cluster_Break= _zwj}', "");
    Expect(1, 8205, '\P{^Grapheme_Cluster_Break= _zwj}', "");
    Expect(0, 8206, '\p{Grapheme_Cluster_Break= _zwj}', "");
    Expect(1, 8206, '\p{^Grapheme_Cluster_Break= _zwj}', "");
    Expect(1, 8206, '\P{Grapheme_Cluster_Break= _zwj}', "");
    Expect(0, 8206, '\P{^Grapheme_Cluster_Break= _zwj}', "");
    Error('\p{GCB=:= -zwj}');
    Error('\P{GCB=:= -zwj}');
    Expect(1, 8205, '\p{GCB=:\AZWJ\z:}', "");;
    Expect(0, 8206, '\p{GCB=:\AZWJ\z:}', "");;
    Expect(1, 8205, '\p{GCB:   zwj}', "");
    Expect(0, 8205, '\p{^GCB:   zwj}', "");
    Expect(0, 8205, '\P{GCB:   zwj}', "");
    Expect(1, 8205, '\P{^GCB:   zwj}', "");
    Expect(0, 8206, '\p{GCB:   zwj}', "");
    Expect(1, 8206, '\p{^GCB:   zwj}', "");
    Expect(1, 8206, '\P{GCB:   zwj}', "");
    Expect(0, 8206, '\P{^GCB:   zwj}', "");
    Expect(1, 8205, '\p{GCB=:\Azwj\z:}', "");;
    Expect(0, 8206, '\p{GCB=:\Azwj\z:}', "");;
    Expect(1, 8205, '\p{GCB=_	zwj}', "");
    Expect(0, 8205, '\p{^GCB=_	zwj}', "");
    Expect(0, 8205, '\P{GCB=_	zwj}', "");
    Expect(1, 8205, '\P{^GCB=_	zwj}', "");
    Expect(0, 8206, '\p{GCB=_	zwj}', "");
    Expect(1, 8206, '\p{^GCB=_	zwj}', "");
    Expect(1, 8206, '\P{GCB=_	zwj}', "");
    Expect(0, 8206, '\P{^GCB=_	zwj}', "");
    Error('\p{Is_Grapheme_Cluster_Break=- ZWJ:=}');
    Error('\P{Is_Grapheme_Cluster_Break=- ZWJ:=}');
    Expect(1, 8205, '\p{Is_Grapheme_Cluster_Break=zwj}', "");
    Expect(0, 8205, '\p{^Is_Grapheme_Cluster_Break=zwj}', "");
    Expect(0, 8205, '\P{Is_Grapheme_Cluster_Break=zwj}', "");
    Expect(1, 8205, '\P{^Is_Grapheme_Cluster_Break=zwj}', "");
    Expect(0, 8206, '\p{Is_Grapheme_Cluster_Break=zwj}', "");
    Expect(1, 8206, '\p{^Is_Grapheme_Cluster_Break=zwj}', "");
    Expect(1, 8206, '\P{Is_Grapheme_Cluster_Break=zwj}', "");
    Expect(0, 8206, '\P{^Is_Grapheme_Cluster_Break=zwj}', "");
    Error('\p{Is_GCB:   	:=zwj}');
    Error('\P{Is_GCB:   	:=zwj}');
    Expect(1, 8205, '\p{Is_GCB=zwj}', "");
    Expect(0, 8205, '\p{^Is_GCB=zwj}', "");
    Expect(0, 8205, '\P{Is_GCB=zwj}', "");
    Expect(1, 8205, '\P{^Is_GCB=zwj}', "");
    Expect(0, 8206, '\p{Is_GCB=zwj}', "");
    Expect(1, 8206, '\p{^Is_GCB=zwj}', "");
    Expect(1, 8206, '\P{Is_GCB=zwj}', "");
    Expect(0, 8206, '\P{^Is_GCB=zwj}', "");
    Expect(1, 8205, '\p{Is_GCB=	 zwj}', "");
    Expect(0, 8205, '\p{^Is_GCB=	 zwj}', "");
    Expect(0, 8205, '\P{Is_GCB=	 zwj}', "");
    Expect(1, 8205, '\P{^Is_GCB=	 zwj}', "");
    Expect(0, 8206, '\p{Is_GCB=	 zwj}', "");
    Expect(1, 8206, '\p{^Is_GCB=	 zwj}', "");
    Expect(1, 8206, '\P{Is_GCB=	 zwj}', "");
    Expect(0, 8206, '\P{^Is_GCB=	 zwj}', "");
    Error('\p{Grapheme_Base=:=	No}');
    Error('\P{Grapheme_Base=:=	No}');
    Expect(1, 201547, '\p{Grapheme_Base=:\ANo\z:}', "");;
    Expect(0, 201546, '\p{Grapheme_Base=:\ANo\z:}', "");;
    Expect(1, 201547, '\p{Grapheme_Base:   no}', "");
    Expect(0, 201547, '\p{^Grapheme_Base:   no}', "");
    Expect(0, 201547, '\P{Grapheme_Base:   no}', "");
    Expect(1, 201547, '\P{^Grapheme_Base:   no}', "");
    Expect(0, 201546, '\p{Grapheme_Base:   no}', "");
    Expect(1, 201546, '\p{^Grapheme_Base:   no}', "");
    Expect(1, 201546, '\P{Grapheme_Base:   no}', "");
    Expect(0, 201546, '\P{^Grapheme_Base:   no}', "");
    Expect(1, 201547, '\p{Grapheme_Base=:\Ano\z:}', "");;
    Expect(0, 201546, '\p{Grapheme_Base=:\Ano\z:}', "");;
    Expect(1, 201547, '\p{Grapheme_Base=-_No}', "");
    Expect(0, 201547, '\p{^Grapheme_Base=-_No}', "");
    Expect(0, 201547, '\P{Grapheme_Base=-_No}', "");
    Expect(1, 201547, '\P{^Grapheme_Base=-_No}', "");
    Expect(0, 201546, '\p{Grapheme_Base=-_No}', "");
    Expect(1, 201546, '\p{^Grapheme_Base=-_No}', "");
    Expect(1, 201546, '\P{Grapheme_Base=-_No}', "");
    Expect(0, 201546, '\P{^Grapheme_Base=-_No}', "");
    Error('\p{Gr_Base=:=-_N}');
    Error('\P{Gr_Base=:=-_N}');
    Expect(1, 201547, '\p{Gr_Base=:\AN\z:}', "");;
    Expect(0, 201546, '\p{Gr_Base=:\AN\z:}', "");;
    Expect(1, 201547, '\p{Gr_Base=n}', "");
    Expect(0, 201547, '\p{^Gr_Base=n}', "");
    Expect(0, 201547, '\P{Gr_Base=n}', "");
    Expect(1, 201547, '\P{^Gr_Base=n}', "");
    Expect(0, 201546, '\p{Gr_Base=n}', "");
    Expect(1, 201546, '\p{^Gr_Base=n}', "");
    Expect(1, 201546, '\P{Gr_Base=n}', "");
    Expect(0, 201546, '\P{^Gr_Base=n}', "");
    Expect(1, 201547, '\p{Gr_Base=:\An\z:}', "");;
    Expect(0, 201546, '\p{Gr_Base=:\An\z:}', "");;
    Expect(1, 201547, '\p{Gr_Base:	-N}', "");
    Expect(0, 201547, '\p{^Gr_Base:	-N}', "");
    Expect(0, 201547, '\P{Gr_Base:	-N}', "");
    Expect(1, 201547, '\P{^Gr_Base:	-N}', "");
    Expect(0, 201546, '\p{Gr_Base:	-N}', "");
    Expect(1, 201546, '\p{^Gr_Base:	-N}', "");
    Expect(1, 201546, '\P{Gr_Base:	-N}', "");
    Expect(0, 201546, '\P{^Gr_Base:	-N}', "");
    Error('\p{Is_Grapheme_Base=	-F/a/}');
    Error('\P{Is_Grapheme_Base=	-F/a/}');
    Expect(1, 201547, '\p{Is_Grapheme_Base=f}', "");
    Expect(0, 201547, '\p{^Is_Grapheme_Base=f}', "");
    Expect(0, 201547, '\P{Is_Grapheme_Base=f}', "");
    Expect(1, 201547, '\P{^Is_Grapheme_Base=f}', "");
    Expect(0, 201546, '\p{Is_Grapheme_Base=f}', "");
    Expect(1, 201546, '\p{^Is_Grapheme_Base=f}', "");
    Expect(1, 201546, '\P{Is_Grapheme_Base=f}', "");
    Expect(0, 201546, '\P{^Is_Grapheme_Base=f}', "");
    Expect(1, 201547, '\p{Is_Grapheme_Base=__F}', "");
    Expect(0, 201547, '\p{^Is_Grapheme_Base=__F}', "");
    Expect(0, 201547, '\P{Is_Grapheme_Base=__F}', "");
    Expect(1, 201547, '\P{^Is_Grapheme_Base=__F}', "");
    Expect(0, 201546, '\p{Is_Grapheme_Base=__F}', "");
    Expect(1, 201546, '\p{^Is_Grapheme_Base=__F}', "");
    Expect(1, 201546, '\P{Is_Grapheme_Base=__F}', "");
    Expect(0, 201546, '\P{^Is_Grapheme_Base=__F}', "");
    Error('\p{Is_Gr_Base=/a/ 	false}');
    Error('\P{Is_Gr_Base=/a/ 	false}');
    Expect(1, 201547, '\p{Is_Gr_Base=false}', "");
    Expect(0, 201547, '\p{^Is_Gr_Base=false}', "");
    Expect(0, 201547, '\P{Is_Gr_Base=false}', "");
    Expect(1, 201547, '\P{^Is_Gr_Base=false}', "");
    Expect(0, 201546, '\p{Is_Gr_Base=false}', "");
    Expect(1, 201546, '\p{^Is_Gr_Base=false}', "");
    Expect(1, 201546, '\P{Is_Gr_Base=false}', "");
    Expect(0, 201546, '\P{^Is_Gr_Base=false}', "");
    Expect(1, 201547, '\p{Is_Gr_Base=-False}', "");
    Expect(0, 201547, '\p{^Is_Gr_Base=-False}', "");
    Expect(0, 201547, '\P{Is_Gr_Base=-False}', "");
    Expect(1, 201547, '\P{^Is_Gr_Base=-False}', "");
    Expect(0, 201546, '\p{Is_Gr_Base=-False}', "");
    Expect(1, 201546, '\p{^Is_Gr_Base=-False}', "");
    Expect(1, 201546, '\P{Is_Gr_Base=-False}', "");
    Expect(0, 201546, '\P{^Is_Gr_Base=-False}', "");
    Error('\p{Grapheme_Base=_/a/Yes}');
    Error('\P{Grapheme_Base=_/a/Yes}');
    Expect(1, 201546, '\p{Grapheme_Base=:\AYes\z:}', "");;
    Expect(0, 201547, '\p{Grapheme_Base=:\AYes\z:}', "");;
    Expect(1, 201546, '\p{Grapheme_Base=yes}', "");
    Expect(0, 201546, '\p{^Grapheme_Base=yes}', "");
    Expect(0, 201546, '\P{Grapheme_Base=yes}', "");
    Expect(1, 201546, '\P{^Grapheme_Base=yes}', "");
    Expect(0, 201547, '\p{Grapheme_Base=yes}', "");
    Expect(1, 201547, '\p{^Grapheme_Base=yes}', "");
    Expect(1, 201547, '\P{Grapheme_Base=yes}', "");
    Expect(0, 201547, '\P{^Grapheme_Base=yes}', "");
    Expect(1, 201546, '\p{Grapheme_Base=:\Ayes\z:}', "");;
    Expect(0, 201547, '\p{Grapheme_Base=:\Ayes\z:}', "");;
    Expect(1, 201546, '\p{Grapheme_Base=-yes}', "");
    Expect(0, 201546, '\p{^Grapheme_Base=-yes}', "");
    Expect(0, 201546, '\P{Grapheme_Base=-yes}', "");
    Expect(1, 201546, '\P{^Grapheme_Base=-yes}', "");
    Expect(0, 201547, '\p{Grapheme_Base=-yes}', "");
    Expect(1, 201547, '\p{^Grapheme_Base=-yes}', "");
    Expect(1, 201547, '\P{Grapheme_Base=-yes}', "");
    Expect(0, 201547, '\P{^Grapheme_Base=-yes}', "");
    Error('\p{Gr_Base=/a/ 	Y}');
    Error('\P{Gr_Base=/a/ 	Y}');
    Expect(1, 201546, '\p{Gr_Base=:\AY\z:}', "");;
    Expect(0, 201547, '\p{Gr_Base=:\AY\z:}', "");;
    Expect(1, 201546, '\p{Gr_Base=y}', "");
    Expect(0, 201546, '\p{^Gr_Base=y}', "");
    Expect(0, 201546, '\P{Gr_Base=y}', "");
    Expect(1, 201546, '\P{^Gr_Base=y}', "");
    Expect(0, 201547, '\p{Gr_Base=y}', "");
    Expect(1, 201547, '\p{^Gr_Base=y}', "");
    Expect(1, 201547, '\P{Gr_Base=y}', "");
    Expect(0, 201547, '\P{^Gr_Base=y}', "");
    Expect(1, 201546, '\p{Gr_Base=:\Ay\z:}', "");;
    Expect(0, 201547, '\p{Gr_Base=:\Ay\z:}', "");;
    Expect(1, 201546, '\p{Gr_Base=		y}', "");
    Expect(0, 201546, '\p{^Gr_Base=		y}', "");
    Expect(0, 201546, '\P{Gr_Base=		y}', "");
    Expect(1, 201546, '\P{^Gr_Base=		y}', "");
    Expect(0, 201547, '\p{Gr_Base=		y}', "");
    Expect(1, 201547, '\p{^Gr_Base=		y}', "");
    Expect(1, 201547, '\P{Gr_Base=		y}', "");
    Expect(0, 201547, '\P{^Gr_Base=		y}', "");
    Error('\p{Is_Grapheme_Base=:=--t}');
    Error('\P{Is_Grapheme_Base=:=--t}');
    Expect(1, 201546, '\p{Is_Grapheme_Base=t}', "");
    Expect(0, 201546, '\p{^Is_Grapheme_Base=t}', "");
    Expect(0, 201546, '\P{Is_Grapheme_Base=t}', "");
    Expect(1, 201546, '\P{^Is_Grapheme_Base=t}', "");
    Expect(0, 201547, '\p{Is_Grapheme_Base=t}', "");
    Expect(1, 201547, '\p{^Is_Grapheme_Base=t}', "");
    Expect(1, 201547, '\P{Is_Grapheme_Base=t}', "");
    Expect(0, 201547, '\P{^Is_Grapheme_Base=t}', "");
    Expect(1, 201546, '\p{Is_Grapheme_Base= T}', "");
    Expect(0, 201546, '\p{^Is_Grapheme_Base= T}', "");
    Expect(0, 201546, '\P{Is_Grapheme_Base= T}', "");
    Expect(1, 201546, '\P{^Is_Grapheme_Base= T}', "");
    Expect(0, 201547, '\p{Is_Grapheme_Base= T}', "");
    Expect(1, 201547, '\p{^Is_Grapheme_Base= T}', "");
    Expect(1, 201547, '\P{Is_Grapheme_Base= T}', "");
    Expect(0, 201547, '\P{^Is_Grapheme_Base= T}', "");
    Error('\p{Is_Gr_Base=-true:=}');
    Error('\P{Is_Gr_Base=-true:=}');
    Expect(1, 201546, '\p{Is_Gr_Base=true}', "");
    Expect(0, 201546, '\p{^Is_Gr_Base=true}', "");
    Expect(0, 201546, '\P{Is_Gr_Base=true}', "");
    Expect(1, 201546, '\P{^Is_Gr_Base=true}', "");
    Expect(0, 201547, '\p{Is_Gr_Base=true}', "");
    Expect(1, 201547, '\p{^Is_Gr_Base=true}', "");
    Expect(1, 201547, '\P{Is_Gr_Base=true}', "");
    Expect(0, 201547, '\P{^Is_Gr_Base=true}', "");
    Expect(1, 201546, '\p{Is_Gr_Base=	-True}', "");
    Expect(0, 201546, '\p{^Is_Gr_Base=	-True}', "");
    Expect(0, 201546, '\P{Is_Gr_Base=	-True}', "");
    Expect(1, 201546, '\P{^Is_Gr_Base=	-True}', "");
    Expect(0, 201547, '\p{Is_Gr_Base=	-True}', "");
    Expect(1, 201547, '\p{^Is_Gr_Base=	-True}', "");
    Expect(1, 201547, '\P{Is_Gr_Base=	-True}', "");
    Expect(0, 201547, '\P{^Is_Gr_Base=	-True}', "");
    Error('\p{Grapheme_Extend=/a/_ No}');
    Error('\P{Grapheme_Extend=/a/_ No}');
    Expect(1, 918000, '\p{Grapheme_Extend=:\ANo\z:}', "");;
    Expect(0, 917999, '\p{Grapheme_Extend=:\ANo\z:}', "");;
    Expect(1, 918000, '\p{Grapheme_Extend:   no}', "");
    Expect(0, 918000, '\p{^Grapheme_Extend:   no}', "");
    Expect(0, 918000, '\P{Grapheme_Extend:   no}', "");
    Expect(1, 918000, '\P{^Grapheme_Extend:   no}', "");
    Expect(0, 917999, '\p{Grapheme_Extend:   no}', "");
    Expect(1, 917999, '\p{^Grapheme_Extend:   no}', "");
    Expect(1, 917999, '\P{Grapheme_Extend:   no}', "");
    Expect(0, 917999, '\P{^Grapheme_Extend:   no}', "");
    Expect(1, 918000, '\p{Grapheme_Extend=:\Ano\z:}', "");;
    Expect(0, 917999, '\p{Grapheme_Extend=:\Ano\z:}', "");;
    Expect(1, 918000, '\p{Grapheme_Extend=No}', "");
    Expect(0, 918000, '\p{^Grapheme_Extend=No}', "");
    Expect(0, 918000, '\P{Grapheme_Extend=No}', "");
    Expect(1, 918000, '\P{^Grapheme_Extend=No}', "");
    Expect(0, 917999, '\p{Grapheme_Extend=No}', "");
    Expect(1, 917999, '\p{^Grapheme_Extend=No}', "");
    Expect(1, 917999, '\P{Grapheme_Extend=No}', "");
    Expect(0, 917999, '\P{^Grapheme_Extend=No}', "");
    Error('\p{Gr_Ext:	_-N:=}');
    Error('\P{Gr_Ext:	_-N:=}');
    Expect(1, 918000, '\p{Gr_Ext=:\AN\z:}', "");;
    Expect(0, 917999, '\p{Gr_Ext=:\AN\z:}', "");;
    Expect(1, 918000, '\p{Gr_Ext=n}', "");
    Expect(0, 918000, '\p{^Gr_Ext=n}', "");
    Expect(0, 918000, '\P{Gr_Ext=n}', "");
    Expect(1, 918000, '\P{^Gr_Ext=n}', "");
    Expect(0, 917999, '\p{Gr_Ext=n}', "");
    Expect(1, 917999, '\p{^Gr_Ext=n}', "");
    Expect(1, 917999, '\P{Gr_Ext=n}', "");
    Expect(0, 917999, '\P{^Gr_Ext=n}', "");
    Expect(1, 918000, '\p{Gr_Ext=:\An\z:}', "");;
    Expect(0, 917999, '\p{Gr_Ext=:\An\z:}', "");;
    Expect(1, 918000, '\p{Gr_Ext=	n}', "");
    Expect(0, 918000, '\p{^Gr_Ext=	n}', "");
    Expect(0, 918000, '\P{Gr_Ext=	n}', "");
    Expect(1, 918000, '\P{^Gr_Ext=	n}', "");
    Expect(0, 917999, '\p{Gr_Ext=	n}', "");
    Expect(1, 917999, '\p{^Gr_Ext=	n}', "");
    Expect(1, 917999, '\P{Gr_Ext=	n}', "");
    Expect(0, 917999, '\P{^Gr_Ext=	n}', "");
    Error('\p{Is_Grapheme_Extend=:=_ f}');
    Error('\P{Is_Grapheme_Extend=:=_ f}');
    Expect(1, 918000, '\p{Is_Grapheme_Extend=f}', "");
    Expect(0, 918000, '\p{^Is_Grapheme_Extend=f}', "");
    Expect(0, 918000, '\P{Is_Grapheme_Extend=f}', "");
    Expect(1, 918000, '\P{^Is_Grapheme_Extend=f}', "");
    Expect(0, 917999, '\p{Is_Grapheme_Extend=f}', "");
    Expect(1, 917999, '\p{^Is_Grapheme_Extend=f}', "");
    Expect(1, 917999, '\P{Is_Grapheme_Extend=f}', "");
    Expect(0, 917999, '\P{^Is_Grapheme_Extend=f}', "");
    Expect(1, 918000, '\p{Is_Grapheme_Extend= 	F}', "");
    Expect(0, 918000, '\p{^Is_Grapheme_Extend= 	F}', "");
    Expect(0, 918000, '\P{Is_Grapheme_Extend= 	F}', "");
    Expect(1, 918000, '\P{^Is_Grapheme_Extend= 	F}', "");
    Expect(0, 917999, '\p{Is_Grapheme_Extend= 	F}', "");
    Expect(1, 917999, '\p{^Is_Grapheme_Extend= 	F}', "");
    Expect(1, 917999, '\P{Is_Grapheme_Extend= 	F}', "");
    Expect(0, 917999, '\P{^Is_Grapheme_Extend= 	F}', "");
    Error('\p{Is_Gr_Ext= :=FALSE}');
    Error('\P{Is_Gr_Ext= :=FALSE}');
    Expect(1, 918000, '\p{Is_Gr_Ext=false}', "");
    Expect(0, 918000, '\p{^Is_Gr_Ext=false}', "");
    Expect(0, 918000, '\P{Is_Gr_Ext=false}', "");
    Expect(1, 918000, '\P{^Is_Gr_Ext=false}', "");
    Expect(0, 917999, '\p{Is_Gr_Ext=false}', "");
    Expect(1, 917999, '\p{^Is_Gr_Ext=false}', "");
    Expect(1, 917999, '\P{Is_Gr_Ext=false}', "");
    Expect(0, 917999, '\P{^Is_Gr_Ext=false}', "");
    Expect(1, 918000, '\p{Is_Gr_Ext=- False}', "");
    Expect(0, 918000, '\p{^Is_Gr_Ext=- False}', "");
    Expect(0, 918000, '\P{Is_Gr_Ext=- False}', "");
    Expect(1, 918000, '\P{^Is_Gr_Ext=- False}', "");
    Expect(0, 917999, '\p{Is_Gr_Ext=- False}', "");
    Expect(1, 917999, '\p{^Is_Gr_Ext=- False}', "");
    Expect(1, 917999, '\P{Is_Gr_Ext=- False}', "");
    Expect(0, 917999, '\P{^Is_Gr_Ext=- False}', "");
    Error('\p{Grapheme_Extend=_:=YES}');
    Error('\P{Grapheme_Extend=_:=YES}');
    Expect(1, 917999, '\p{Grapheme_Extend=:\AYes\z:}', "");;
    Expect(0, 918000, '\p{Grapheme_Extend=:\AYes\z:}', "");;
    Expect(1, 917999, '\p{Grapheme_Extend=yes}', "");
    Expect(0, 917999, '\p{^Grapheme_Extend=yes}', "");
    Expect(0, 917999, '\P{Grapheme_Extend=yes}', "");
    Expect(1, 917999, '\P{^Grapheme_Extend=yes}', "");
    Expect(0, 918000, '\p{Grapheme_Extend=yes}', "");
    Expect(1, 918000, '\p{^Grapheme_Extend=yes}', "");
    Expect(1, 918000, '\P{Grapheme_Extend=yes}', "");
    Expect(0, 918000, '\P{^Grapheme_Extend=yes}', "");
    Expect(1, 917999, '\p{Grapheme_Extend=:\Ayes\z:}', "");;
    Expect(0, 918000, '\p{Grapheme_Extend=:\Ayes\z:}', "");;
    Expect(1, 917999, '\p{Grapheme_Extend=_ Yes}', "");
    Expect(0, 917999, '\p{^Grapheme_Extend=_ Yes}', "");
    Expect(0, 917999, '\P{Grapheme_Extend=_ Yes}', "");
    Expect(1, 917999, '\P{^Grapheme_Extend=_ Yes}', "");
    Expect(0, 918000, '\p{Grapheme_Extend=_ Yes}', "");
    Expect(1, 918000, '\p{^Grapheme_Extend=_ Yes}', "");
    Expect(1, 918000, '\P{Grapheme_Extend=_ Yes}', "");
    Expect(0, 918000, '\P{^Grapheme_Extend=_ Yes}', "");
    Error('\p{Gr_Ext=_y:=}');
    Error('\P{Gr_Ext=_y:=}');
    Expect(1, 917999, '\p{Gr_Ext=:\AY\z:}', "");;
    Expect(0, 918000, '\p{Gr_Ext=:\AY\z:}', "");;
    Expect(1, 917999, '\p{Gr_Ext=y}', "");
    Expect(0, 917999, '\p{^Gr_Ext=y}', "");
    Expect(0, 917999, '\P{Gr_Ext=y}', "");
    Expect(1, 917999, '\P{^Gr_Ext=y}', "");
    Expect(0, 918000, '\p{Gr_Ext=y}', "");
    Expect(1, 918000, '\p{^Gr_Ext=y}', "");
    Expect(1, 918000, '\P{Gr_Ext=y}', "");
    Expect(0, 918000, '\P{^Gr_Ext=y}', "");
    Expect(1, 917999, '\p{Gr_Ext=:\Ay\z:}', "");;
    Expect(0, 918000, '\p{Gr_Ext=:\Ay\z:}', "");;
    Expect(1, 917999, '\p{Gr_Ext= 	Y}', "");
    Expect(0, 917999, '\p{^Gr_Ext= 	Y}', "");
    Expect(0, 917999, '\P{Gr_Ext= 	Y}', "");
    Expect(1, 917999, '\P{^Gr_Ext= 	Y}', "");
    Expect(0, 918000, '\p{Gr_Ext= 	Y}', "");
    Expect(1, 918000, '\p{^Gr_Ext= 	Y}', "");
    Expect(1, 918000, '\P{Gr_Ext= 	Y}', "");
    Expect(0, 918000, '\P{^Gr_Ext= 	Y}', "");
    Error('\p{Is_Grapheme_Extend=_	T:=}');
    Error('\P{Is_Grapheme_Extend=_	T:=}');
    Expect(1, 917999, '\p{Is_Grapheme_Extend=t}', "");
    Expect(0, 917999, '\p{^Is_Grapheme_Extend=t}', "");
    Expect(0, 917999, '\P{Is_Grapheme_Extend=t}', "");
    Expect(1, 917999, '\P{^Is_Grapheme_Extend=t}', "");
    Expect(0, 918000, '\p{Is_Grapheme_Extend=t}', "");
    Expect(1, 918000, '\p{^Is_Grapheme_Extend=t}', "");
    Expect(1, 918000, '\P{Is_Grapheme_Extend=t}', "");
    Expect(0, 918000, '\P{^Is_Grapheme_Extend=t}', "");
    Expect(1, 917999, '\p{Is_Grapheme_Extend=	T}', "");
    Expect(0, 917999, '\p{^Is_Grapheme_Extend=	T}', "");
    Expect(0, 917999, '\P{Is_Grapheme_Extend=	T}', "");
    Expect(1, 917999, '\P{^Is_Grapheme_Extend=	T}', "");
    Expect(0, 918000, '\p{Is_Grapheme_Extend=	T}', "");
    Expect(1, 918000, '\p{^Is_Grapheme_Extend=	T}', "");
    Expect(1, 918000, '\P{Is_Grapheme_Extend=	T}', "");
    Expect(0, 918000, '\P{^Is_Grapheme_Extend=	T}', "");
    Error('\p{Is_Gr_Ext=_true:=}');
    Error('\P{Is_Gr_Ext=_true:=}');
    Expect(1, 917999, '\p{Is_Gr_Ext=true}', "");
    Expect(0, 917999, '\p{^Is_Gr_Ext=true}', "");
    Expect(0, 917999, '\P{Is_Gr_Ext=true}', "");
    Expect(1, 917999, '\P{^Is_Gr_Ext=true}', "");
    Expect(0, 918000, '\p{Is_Gr_Ext=true}', "");
    Expect(1, 918000, '\p{^Is_Gr_Ext=true}', "");
    Expect(1, 918000, '\P{Is_Gr_Ext=true}', "");
    Expect(0, 918000, '\P{^Is_Gr_Ext=true}', "");
    Expect(1, 917999, '\p{Is_Gr_Ext= _True}', "");
    Expect(0, 917999, '\p{^Is_Gr_Ext= _True}', "");
    Expect(0, 917999, '\P{Is_Gr_Ext= _True}', "");
    Expect(1, 917999, '\P{^Is_Gr_Ext= _True}', "");
    Expect(0, 918000, '\p{Is_Gr_Ext= _True}', "");
    Expect(1, 918000, '\p{^Is_Gr_Ext= _True}', "");
    Expect(1, 918000, '\P{Is_Gr_Ext= _True}', "");
    Expect(0, 918000, '\P{^Is_Gr_Ext= _True}', "");
    Error('\p{Grapheme_Link=No}');
    Error('\P{Grapheme_Link=No}');
    Error('\p{Gr_Link=N}');
    Error('\P{Gr_Link=N}');
    Error('\p{Is_Grapheme_Link=F}');
    Error('\P{Is_Grapheme_Link=F}');
    Error('\p{Is_Gr_Link=False}');
    Error('\P{Is_Gr_Link=False}');
    Error('\p{Grapheme_Link=Yes}');
    Error('\P{Grapheme_Link=Yes}');
    Error('\p{Gr_Link:Y}');
    Error('\P{Gr_Link:Y}');
    Error('\p{Is_Grapheme_Link:	T}');
    Error('\P{Is_Grapheme_Link:	T}');
    Error('\p{Is_Gr_Link=True}');
    Error('\P{Is_Gr_Link=True}');
    Error('\p{Hex_Digit=:= 	no}');
    Error('\P{Hex_Digit=:= 	no}');
    Expect(1, 65351, '\p{Hex_Digit=:\ANo\z:}', "");;
    Expect(0, 65350, '\p{Hex_Digit=:\ANo\z:}', "");;
    Expect(1, 65351, '\p{Hex_Digit=no}', "");
    Expect(0, 65351, '\p{^Hex_Digit=no}', "");
    Expect(0, 65351, '\P{Hex_Digit=no}', "");
    Expect(1, 65351, '\P{^Hex_Digit=no}', "");
    Expect(0, 65350, '\p{Hex_Digit=no}', "");
    Expect(1, 65350, '\p{^Hex_Digit=no}', "");
    Expect(1, 65350, '\P{Hex_Digit=no}', "");
    Expect(0, 65350, '\P{^Hex_Digit=no}', "");
    Expect(1, 65351, '\p{Hex_Digit=:\Ano\z:}', "");;
    Expect(0, 65350, '\p{Hex_Digit=:\Ano\z:}', "");;
    Expect(1, 65351, '\p{Hex_Digit=__NO}', "");
    Expect(0, 65351, '\p{^Hex_Digit=__NO}', "");
    Expect(0, 65351, '\P{Hex_Digit=__NO}', "");
    Expect(1, 65351, '\P{^Hex_Digit=__NO}', "");
    Expect(0, 65350, '\p{Hex_Digit=__NO}', "");
    Expect(1, 65350, '\p{^Hex_Digit=__NO}', "");
    Expect(1, 65350, '\P{Hex_Digit=__NO}', "");
    Expect(0, 65350, '\P{^Hex_Digit=__NO}', "");
    Error('\p{Hex=/a/N}');
    Error('\P{Hex=/a/N}');
    Expect(1, 65351, '\p{Hex=:\AN\z:}', "");;
    Expect(0, 65350, '\p{Hex=:\AN\z:}', "");;
    Expect(1, 65351, '\p{Hex=n}', "");
    Expect(0, 65351, '\p{^Hex=n}', "");
    Expect(0, 65351, '\P{Hex=n}', "");
    Expect(1, 65351, '\P{^Hex=n}', "");
    Expect(0, 65350, '\p{Hex=n}', "");
    Expect(1, 65350, '\p{^Hex=n}', "");
    Expect(1, 65350, '\P{Hex=n}', "");
    Expect(0, 65350, '\P{^Hex=n}', "");
    Expect(1, 65351, '\p{Hex=:\An\z:}', "");;
    Expect(0, 65350, '\p{Hex=:\An\z:}', "");;
    Expect(1, 65351, '\p{Hex=- N}', "");
    Expect(0, 65351, '\p{^Hex=- N}', "");
    Expect(0, 65351, '\P{Hex=- N}', "");
    Expect(1, 65351, '\P{^Hex=- N}', "");
    Expect(0, 65350, '\p{Hex=- N}', "");
    Expect(1, 65350, '\p{^Hex=- N}', "");
    Expect(1, 65350, '\P{Hex=- N}', "");
    Expect(0, 65350, '\P{^Hex=- N}', "");
    Error('\p{Is_Hex_Digit=/a/ 	F}');
    Error('\P{Is_Hex_Digit=/a/ 	F}');
    Expect(1, 65351, '\p{Is_Hex_Digit=f}', "");
    Expect(0, 65351, '\p{^Is_Hex_Digit=f}', "");
    Expect(0, 65351, '\P{Is_Hex_Digit=f}', "");
    Expect(1, 65351, '\P{^Is_Hex_Digit=f}', "");
    Expect(0, 65350, '\p{Is_Hex_Digit=f}', "");
    Expect(1, 65350, '\p{^Is_Hex_Digit=f}', "");
    Expect(1, 65350, '\P{Is_Hex_Digit=f}', "");
    Expect(0, 65350, '\P{^Is_Hex_Digit=f}', "");
    Expect(1, 65351, '\p{Is_Hex_Digit=-_F}', "");
    Expect(0, 65351, '\p{^Is_Hex_Digit=-_F}', "");
    Expect(0, 65351, '\P{Is_Hex_Digit=-_F}', "");
    Expect(1, 65351, '\P{^Is_Hex_Digit=-_F}', "");
    Expect(0, 65350, '\p{Is_Hex_Digit=-_F}', "");
    Expect(1, 65350, '\p{^Is_Hex_Digit=-_F}', "");
    Expect(1, 65350, '\P{Is_Hex_Digit=-_F}', "");
    Expect(0, 65350, '\P{^Is_Hex_Digit=-_F}', "");
    Error('\p{Is_Hex=-_False:=}');
    Error('\P{Is_Hex=-_False:=}');
    Expect(1, 65351, '\p{Is_Hex=false}', "");
    Expect(0, 65351, '\p{^Is_Hex=false}', "");
    Expect(0, 65351, '\P{Is_Hex=false}', "");
    Expect(1, 65351, '\P{^Is_Hex=false}', "");
    Expect(0, 65350, '\p{Is_Hex=false}', "");
    Expect(1, 65350, '\p{^Is_Hex=false}', "");
    Expect(1, 65350, '\P{Is_Hex=false}', "");
    Expect(0, 65350, '\P{^Is_Hex=false}', "");
    Expect(1, 65351, '\p{Is_Hex=  false}', "");
    Expect(0, 65351, '\p{^Is_Hex=  false}', "");
    Expect(0, 65351, '\P{Is_Hex=  false}', "");
    Expect(1, 65351, '\P{^Is_Hex=  false}', "");
    Expect(0, 65350, '\p{Is_Hex=  false}', "");
    Expect(1, 65350, '\p{^Is_Hex=  false}', "");
    Expect(1, 65350, '\P{Is_Hex=  false}', "");
    Expect(0, 65350, '\P{^Is_Hex=  false}', "");
    Error('\p{Hex_Digit=-:=Yes}');
    Error('\P{Hex_Digit=-:=Yes}');
    Expect(1, 65350, '\p{Hex_Digit=:\AYes\z:}', "");;
    Expect(0, 65351, '\p{Hex_Digit=:\AYes\z:}', "");;
    Expect(1, 65350, '\p{Hex_Digit=yes}', "");
    Expect(0, 65350, '\p{^Hex_Digit=yes}', "");
    Expect(0, 65350, '\P{Hex_Digit=yes}', "");
    Expect(1, 65350, '\P{^Hex_Digit=yes}', "");
    Expect(0, 65351, '\p{Hex_Digit=yes}', "");
    Expect(1, 65351, '\p{^Hex_Digit=yes}', "");
    Expect(1, 65351, '\P{Hex_Digit=yes}', "");
    Expect(0, 65351, '\P{^Hex_Digit=yes}', "");
    Expect(1, 65350, '\p{Hex_Digit=:\Ayes\z:}', "");;
    Expect(0, 65351, '\p{Hex_Digit=:\Ayes\z:}', "");;
    Expect(1, 65350, '\p{Hex_Digit=	YES}', "");
    Expect(0, 65350, '\p{^Hex_Digit=	YES}', "");
    Expect(0, 65350, '\P{Hex_Digit=	YES}', "");
    Expect(1, 65350, '\P{^Hex_Digit=	YES}', "");
    Expect(0, 65351, '\p{Hex_Digit=	YES}', "");
    Expect(1, 65351, '\p{^Hex_Digit=	YES}', "");
    Expect(1, 65351, '\P{Hex_Digit=	YES}', "");
    Expect(0, 65351, '\P{^Hex_Digit=	YES}', "");
    Error('\p{Hex=/a/-	Y}');
    Error('\P{Hex=/a/-	Y}');
    Expect(1, 65350, '\p{Hex=:\AY\z:}', "");;
    Expect(0, 65351, '\p{Hex=:\AY\z:}', "");;
    Expect(1, 65350, '\p{Hex=y}', "");
    Expect(0, 65350, '\p{^Hex=y}', "");
    Expect(0, 65350, '\P{Hex=y}', "");
    Expect(1, 65350, '\P{^Hex=y}', "");
    Expect(0, 65351, '\p{Hex=y}', "");
    Expect(1, 65351, '\p{^Hex=y}', "");
    Expect(1, 65351, '\P{Hex=y}', "");
    Expect(0, 65351, '\P{^Hex=y}', "");
    Expect(1, 65350, '\p{Hex=:\Ay\z:}', "");;
    Expect(0, 65351, '\p{Hex=:\Ay\z:}', "");;
    Expect(1, 65350, '\p{Hex=	 Y}', "");
    Expect(0, 65350, '\p{^Hex=	 Y}', "");
    Expect(0, 65350, '\P{Hex=	 Y}', "");
    Expect(1, 65350, '\P{^Hex=	 Y}', "");
    Expect(0, 65351, '\p{Hex=	 Y}', "");
    Expect(1, 65351, '\p{^Hex=	 Y}', "");
    Expect(1, 65351, '\P{Hex=	 Y}', "");
    Expect(0, 65351, '\P{^Hex=	 Y}', "");
    Error('\p{Is_Hex_Digit=/a/	-T}');
    Error('\P{Is_Hex_Digit=/a/	-T}');
    Expect(1, 65350, '\p{Is_Hex_Digit=t}', "");
    Expect(0, 65350, '\p{^Is_Hex_Digit=t}', "");
    Expect(0, 65350, '\P{Is_Hex_Digit=t}', "");
    Expect(1, 65350, '\P{^Is_Hex_Digit=t}', "");
    Expect(0, 65351, '\p{Is_Hex_Digit=t}', "");
    Expect(1, 65351, '\p{^Is_Hex_Digit=t}', "");
    Expect(1, 65351, '\P{Is_Hex_Digit=t}', "");
    Expect(0, 65351, '\P{^Is_Hex_Digit=t}', "");
    Expect(1, 65350, '\p{Is_Hex_Digit= T}', "");
    Expect(0, 65350, '\p{^Is_Hex_Digit= T}', "");
    Expect(0, 65350, '\P{Is_Hex_Digit= T}', "");
    Expect(1, 65350, '\P{^Is_Hex_Digit= T}', "");
    Expect(0, 65351, '\p{Is_Hex_Digit= T}', "");
    Expect(1, 65351, '\p{^Is_Hex_Digit= T}', "");
    Expect(1, 65351, '\P{Is_Hex_Digit= T}', "");
    Expect(0, 65351, '\P{^Is_Hex_Digit= T}', "");
    Error('\p{Is_Hex=_/a/True}');
    Error('\P{Is_Hex=_/a/True}');
    Expect(1, 65350, '\p{Is_Hex=true}', "");
    Expect(0, 65350, '\p{^Is_Hex=true}', "");
    Expect(0, 65350, '\P{Is_Hex=true}', "");
    Expect(1, 65350, '\P{^Is_Hex=true}', "");
    Expect(0, 65351, '\p{Is_Hex=true}', "");
    Expect(1, 65351, '\p{^Is_Hex=true}', "");
    Expect(1, 65351, '\P{Is_Hex=true}', "");
    Expect(0, 65351, '\P{^Is_Hex=true}', "");
    Expect(1, 65350, '\p{Is_Hex:    True}', "");
    Expect(0, 65350, '\p{^Is_Hex:    True}', "");
    Expect(0, 65350, '\P{Is_Hex:    True}', "");
    Expect(1, 65350, '\P{^Is_Hex:    True}', "");
    Expect(0, 65351, '\p{Is_Hex:    True}', "");
    Expect(1, 65351, '\p{^Is_Hex:    True}', "");
    Expect(1, 65351, '\P{Is_Hex:    True}', "");
    Expect(0, 65351, '\P{^Is_Hex:    True}', "");
    Error('\p{hangulsyllabletype}');
    Error('\P{hangulsyllabletype}');
    Error('\p{hst}');
    Error('\P{hst}');
    Error('\p{Hangul_Syllable_Type=-_Leading_Jamo/a/}');
    Error('\P{Hangul_Syllable_Type=-_Leading_Jamo/a/}');
    Expect(1, 43388, '\p{Hangul_Syllable_Type=:\ALeading_Jamo\z:}', "");;
    Expect(0, 43389, '\p{Hangul_Syllable_Type=:\ALeading_Jamo\z:}', "");;
    Expect(1, 43388, '\p{Hangul_Syllable_Type=leadingjamo}', "");
    Expect(0, 43388, '\p{^Hangul_Syllable_Type=leadingjamo}', "");
    Expect(0, 43388, '\P{Hangul_Syllable_Type=leadingjamo}', "");
    Expect(1, 43388, '\P{^Hangul_Syllable_Type=leadingjamo}', "");
    Expect(0, 43389, '\p{Hangul_Syllable_Type=leadingjamo}', "");
    Expect(1, 43389, '\p{^Hangul_Syllable_Type=leadingjamo}', "");
    Expect(1, 43389, '\P{Hangul_Syllable_Type=leadingjamo}', "");
    Expect(0, 43389, '\P{^Hangul_Syllable_Type=leadingjamo}', "");
    Expect(1, 43388, '\p{Hangul_Syllable_Type=:\Aleadingjamo\z:}', "");;
    Expect(0, 43389, '\p{Hangul_Syllable_Type=:\Aleadingjamo\z:}', "");;
    Expect(1, 43388, '\p{Hangul_Syllable_Type= -leading_JAMO}', "");
    Expect(0, 43388, '\p{^Hangul_Syllable_Type= -leading_JAMO}', "");
    Expect(0, 43388, '\P{Hangul_Syllable_Type= -leading_JAMO}', "");
    Expect(1, 43388, '\P{^Hangul_Syllable_Type= -leading_JAMO}', "");
    Expect(0, 43389, '\p{Hangul_Syllable_Type= -leading_JAMO}', "");
    Expect(1, 43389, '\p{^Hangul_Syllable_Type= -leading_JAMO}', "");
    Expect(1, 43389, '\P{Hangul_Syllable_Type= -leading_JAMO}', "");
    Expect(0, 43389, '\P{^Hangul_Syllable_Type= -leading_JAMO}', "");
    Error('\p{Hst:/a/_L}');
    Error('\P{Hst:/a/_L}');
    Expect(1, 43388, '\p{Hst=:\AL\z:}', "");;
    Expect(0, 43389, '\p{Hst=:\AL\z:}', "");;
    Expect(1, 43388, '\p{Hst=l}', "");
    Expect(0, 43388, '\p{^Hst=l}', "");
    Expect(0, 43388, '\P{Hst=l}', "");
    Expect(1, 43388, '\P{^Hst=l}', "");
    Expect(0, 43389, '\p{Hst=l}', "");
    Expect(1, 43389, '\p{^Hst=l}', "");
    Expect(1, 43389, '\P{Hst=l}', "");
    Expect(0, 43389, '\P{^Hst=l}', "");
    Expect(1, 43388, '\p{Hst=:\Al\z:}', "");;
    Expect(0, 43389, '\p{Hst=:\Al\z:}', "");;
    Expect(1, 43388, '\p{Hst=	L}', "");
    Expect(0, 43388, '\p{^Hst=	L}', "");
    Expect(0, 43388, '\P{Hst=	L}', "");
    Expect(1, 43388, '\P{^Hst=	L}', "");
    Expect(0, 43389, '\p{Hst=	L}', "");
    Expect(1, 43389, '\p{^Hst=	L}', "");
    Expect(1, 43389, '\P{Hst=	L}', "");
    Expect(0, 43389, '\P{^Hst=	L}', "");
    Error('\p{Is_Hangul_Syllable_Type=	/a/leading_Jamo}');
    Error('\P{Is_Hangul_Syllable_Type=	/a/leading_Jamo}');
    Expect(1, 43388, '\p{Is_Hangul_Syllable_Type=leadingjamo}', "");
    Expect(0, 43388, '\p{^Is_Hangul_Syllable_Type=leadingjamo}', "");
    Expect(0, 43388, '\P{Is_Hangul_Syllable_Type=leadingjamo}', "");
    Expect(1, 43388, '\P{^Is_Hangul_Syllable_Type=leadingjamo}', "");
    Expect(0, 43389, '\p{Is_Hangul_Syllable_Type=leadingjamo}', "");
    Expect(1, 43389, '\p{^Is_Hangul_Syllable_Type=leadingjamo}', "");
    Expect(1, 43389, '\P{Is_Hangul_Syllable_Type=leadingjamo}', "");
    Expect(0, 43389, '\P{^Is_Hangul_Syllable_Type=leadingjamo}', "");
    Expect(1, 43388, '\p{Is_Hangul_Syllable_Type=-Leading_Jamo}', "");
    Expect(0, 43388, '\p{^Is_Hangul_Syllable_Type=-Leading_Jamo}', "");
    Expect(0, 43388, '\P{Is_Hangul_Syllable_Type=-Leading_Jamo}', "");
    Expect(1, 43388, '\P{^Is_Hangul_Syllable_Type=-Leading_Jamo}', "");
    Expect(0, 43389, '\p{Is_Hangul_Syllable_Type=-Leading_Jamo}', "");
    Expect(1, 43389, '\p{^Is_Hangul_Syllable_Type=-Leading_Jamo}', "");
    Expect(1, 43389, '\P{Is_Hangul_Syllable_Type=-Leading_Jamo}', "");
    Expect(0, 43389, '\P{^Is_Hangul_Syllable_Type=-Leading_Jamo}', "");
    Error('\p{Is_Hst=:= _L}');
    Error('\P{Is_Hst=:= _L}');
    Expect(1, 43388, '\p{Is_Hst=l}', "");
    Expect(0, 43388, '\p{^Is_Hst=l}', "");
    Expect(0, 43388, '\P{Is_Hst=l}', "");
    Expect(1, 43388, '\P{^Is_Hst=l}', "");
    Expect(0, 43389, '\p{Is_Hst=l}', "");
    Expect(1, 43389, '\p{^Is_Hst=l}', "");
    Expect(1, 43389, '\P{Is_Hst=l}', "");
    Expect(0, 43389, '\P{^Is_Hst=l}', "");
    Expect(1, 43388, '\p{Is_Hst=_-l}', "");
    Expect(0, 43388, '\p{^Is_Hst=_-l}', "");
    Expect(0, 43388, '\P{Is_Hst=_-l}', "");
    Expect(1, 43388, '\P{^Is_Hst=_-l}', "");
    Expect(0, 43389, '\p{Is_Hst=_-l}', "");
    Expect(1, 43389, '\p{^Is_Hst=_-l}', "");
    Expect(1, 43389, '\P{Is_Hst=_-l}', "");
    Expect(0, 43389, '\P{^Is_Hst=_-l}', "");
    Error('\p{Hangul_Syllable_Type=:=LV_syllable}');
    Error('\P{Hangul_Syllable_Type=:=LV_syllable}');
    Expect(1, 55176, '\p{Hangul_Syllable_Type=:\ALV_Syllable\z:}', "");;
    Expect(0, 55177, '\p{Hangul_Syllable_Type=:\ALV_Syllable\z:}', "");;
    Expect(1, 55176, '\p{Hangul_Syllable_Type=lvsyllable}', "");
    Expect(0, 55176, '\p{^Hangul_Syllable_Type=lvsyllable}', "");
    Expect(0, 55176, '\P{Hangul_Syllable_Type=lvsyllable}', "");
    Expect(1, 55176, '\P{^Hangul_Syllable_Type=lvsyllable}', "");
    Expect(0, 55177, '\p{Hangul_Syllable_Type=lvsyllable}', "");
    Expect(1, 55177, '\p{^Hangul_Syllable_Type=lvsyllable}', "");
    Expect(1, 55177, '\P{Hangul_Syllable_Type=lvsyllable}', "");
    Expect(0, 55177, '\P{^Hangul_Syllable_Type=lvsyllable}', "");
    Expect(1, 55176, '\p{Hangul_Syllable_Type=:\Alvsyllable\z:}', "");;
    Expect(0, 55177, '\p{Hangul_Syllable_Type=:\Alvsyllable\z:}', "");;
    Expect(1, 55176, '\p{Hangul_Syllable_Type= LV_Syllable}', "");
    Expect(0, 55176, '\p{^Hangul_Syllable_Type= LV_Syllable}', "");
    Expect(0, 55176, '\P{Hangul_Syllable_Type= LV_Syllable}', "");
    Expect(1, 55176, '\P{^Hangul_Syllable_Type= LV_Syllable}', "");
    Expect(0, 55177, '\p{Hangul_Syllable_Type= LV_Syllable}', "");
    Expect(1, 55177, '\p{^Hangul_Syllable_Type= LV_Syllable}', "");
    Expect(1, 55177, '\P{Hangul_Syllable_Type= LV_Syllable}', "");
    Expect(0, 55177, '\P{^Hangul_Syllable_Type= LV_Syllable}', "");
    Error('\p{Hst= LV/a/}');
    Error('\P{Hst= LV/a/}');
    Expect(1, 55176, '\p{Hst=:\ALV\z:}', "");;
    Expect(0, 55177, '\p{Hst=:\ALV\z:}', "");;
    Expect(1, 55176, '\p{Hst=lv}', "");
    Expect(0, 55176, '\p{^Hst=lv}', "");
    Expect(0, 55176, '\P{Hst=lv}', "");
    Expect(1, 55176, '\P{^Hst=lv}', "");
    Expect(0, 55177, '\p{Hst=lv}', "");
    Expect(1, 55177, '\p{^Hst=lv}', "");
    Expect(1, 55177, '\P{Hst=lv}', "");
    Expect(0, 55177, '\P{^Hst=lv}', "");
    Expect(1, 55176, '\p{Hst=:\Alv\z:}', "");;
    Expect(0, 55177, '\p{Hst=:\Alv\z:}', "");;
    Expect(1, 55176, '\p{Hst=-	lv}', "");
    Expect(0, 55176, '\p{^Hst=-	lv}', "");
    Expect(0, 55176, '\P{Hst=-	lv}', "");
    Expect(1, 55176, '\P{^Hst=-	lv}', "");
    Expect(0, 55177, '\p{Hst=-	lv}', "");
    Expect(1, 55177, '\p{^Hst=-	lv}', "");
    Expect(1, 55177, '\P{Hst=-	lv}', "");
    Expect(0, 55177, '\P{^Hst=-	lv}', "");
    Error('\p{Is_Hangul_Syllable_Type=	-LV_SYLLABLE/a/}');
    Error('\P{Is_Hangul_Syllable_Type=	-LV_SYLLABLE/a/}');
    Expect(1, 55176, '\p{Is_Hangul_Syllable_Type=lvsyllable}', "");
    Expect(0, 55176, '\p{^Is_Hangul_Syllable_Type=lvsyllable}', "");
    Expect(0, 55176, '\P{Is_Hangul_Syllable_Type=lvsyllable}', "");
    Expect(1, 55176, '\P{^Is_Hangul_Syllable_Type=lvsyllable}', "");
    Expect(0, 55177, '\p{Is_Hangul_Syllable_Type=lvsyllable}', "");
    Expect(1, 55177, '\p{^Is_Hangul_Syllable_Type=lvsyllable}', "");
    Expect(1, 55177, '\P{Is_Hangul_Syllable_Type=lvsyllable}', "");
    Expect(0, 55177, '\P{^Is_Hangul_Syllable_Type=lvsyllable}', "");
    Expect(1, 55176, '\p{Is_Hangul_Syllable_Type=  LV_Syllable}', "");
    Expect(0, 55176, '\p{^Is_Hangul_Syllable_Type=  LV_Syllable}', "");
    Expect(0, 55176, '\P{Is_Hangul_Syllable_Type=  LV_Syllable}', "");
    Expect(1, 55176, '\P{^Is_Hangul_Syllable_Type=  LV_Syllable}', "");
    Expect(0, 55177, '\p{Is_Hangul_Syllable_Type=  LV_Syllable}', "");
    Expect(1, 55177, '\p{^Is_Hangul_Syllable_Type=  LV_Syllable}', "");
    Expect(1, 55177, '\P{Is_Hangul_Syllable_Type=  LV_Syllable}', "");
    Expect(0, 55177, '\P{^Is_Hangul_Syllable_Type=  LV_Syllable}', "");
    Error('\p{Is_Hst=/a/-LV}');
    Error('\P{Is_Hst=/a/-LV}');
    Expect(1, 55176, '\p{Is_Hst=lv}', "");
    Expect(0, 55176, '\p{^Is_Hst=lv}', "");
    Expect(0, 55176, '\P{Is_Hst=lv}', "");
    Expect(1, 55176, '\P{^Is_Hst=lv}', "");
    Expect(0, 55177, '\p{Is_Hst=lv}', "");
    Expect(1, 55177, '\p{^Is_Hst=lv}', "");
    Expect(1, 55177, '\P{Is_Hst=lv}', "");
    Expect(0, 55177, '\P{^Is_Hst=lv}', "");
    Error('\p{Hangul_Syllable_Type=-:=LVT_Syllable}');
    Error('\P{Hangul_Syllable_Type=-:=LVT_Syllable}');
    Expect(1, 55203, '\p{Hangul_Syllable_Type=:\ALVT_Syllable\z:}', "");;
    Expect(0, 55204, '\p{Hangul_Syllable_Type=:\ALVT_Syllable\z:}', "");;
    Expect(1, 55203, '\p{Hangul_Syllable_Type=lvtsyllable}', "");
    Expect(0, 55203, '\p{^Hangul_Syllable_Type=lvtsyllable}', "");
    Expect(0, 55203, '\P{Hangul_Syllable_Type=lvtsyllable}', "");
    Expect(1, 55203, '\P{^Hangul_Syllable_Type=lvtsyllable}', "");
    Expect(0, 55204, '\p{Hangul_Syllable_Type=lvtsyllable}', "");
    Expect(1, 55204, '\p{^Hangul_Syllable_Type=lvtsyllable}', "");
    Expect(1, 55204, '\P{Hangul_Syllable_Type=lvtsyllable}', "");
    Expect(0, 55204, '\P{^Hangul_Syllable_Type=lvtsyllable}', "");
    Expect(1, 55203, '\p{Hangul_Syllable_Type=:\Alvtsyllable\z:}', "");;
    Expect(0, 55204, '\p{Hangul_Syllable_Type=:\Alvtsyllable\z:}', "");;
    Expect(1, 55203, '\p{Hangul_Syllable_Type= _LVT_syllable}', "");
    Expect(0, 55203, '\p{^Hangul_Syllable_Type= _LVT_syllable}', "");
    Expect(0, 55203, '\P{Hangul_Syllable_Type= _LVT_syllable}', "");
    Expect(1, 55203, '\P{^Hangul_Syllable_Type= _LVT_syllable}', "");
    Expect(0, 55204, '\p{Hangul_Syllable_Type= _LVT_syllable}', "");
    Expect(1, 55204, '\p{^Hangul_Syllable_Type= _LVT_syllable}', "");
    Expect(1, 55204, '\P{Hangul_Syllable_Type= _LVT_syllable}', "");
    Expect(0, 55204, '\P{^Hangul_Syllable_Type= _LVT_syllable}', "");
    Error('\p{Hst=/a/LVT}');
    Error('\P{Hst=/a/LVT}');
    Expect(1, 55203, '\p{Hst=:\ALVT\z:}', "");;
    Expect(0, 55204, '\p{Hst=:\ALVT\z:}', "");;
    Expect(1, 55203, '\p{Hst=lvt}', "");
    Expect(0, 55203, '\p{^Hst=lvt}', "");
    Expect(0, 55203, '\P{Hst=lvt}', "");
    Expect(1, 55203, '\P{^Hst=lvt}', "");
    Expect(0, 55204, '\p{Hst=lvt}', "");
    Expect(1, 55204, '\p{^Hst=lvt}', "");
    Expect(1, 55204, '\P{Hst=lvt}', "");
    Expect(0, 55204, '\P{^Hst=lvt}', "");
    Expect(1, 55203, '\p{Hst=:\Alvt\z:}', "");;
    Expect(0, 55204, '\p{Hst=:\Alvt\z:}', "");;
    Expect(1, 55203, '\p{Hst=  lvt}', "");
    Expect(0, 55203, '\p{^Hst=  lvt}', "");
    Expect(0, 55203, '\P{Hst=  lvt}', "");
    Expect(1, 55203, '\P{^Hst=  lvt}', "");
    Expect(0, 55204, '\p{Hst=  lvt}', "");
    Expect(1, 55204, '\p{^Hst=  lvt}', "");
    Expect(1, 55204, '\P{Hst=  lvt}', "");
    Expect(0, 55204, '\P{^Hst=  lvt}', "");
    Error('\p{Is_Hangul_Syllable_Type:    /a/LVT_syllable}');
    Error('\P{Is_Hangul_Syllable_Type:    /a/LVT_syllable}');
    Expect(1, 55203, '\p{Is_Hangul_Syllable_Type=lvtsyllable}', "");
    Expect(0, 55203, '\p{^Is_Hangul_Syllable_Type=lvtsyllable}', "");
    Expect(0, 55203, '\P{Is_Hangul_Syllable_Type=lvtsyllable}', "");
    Expect(1, 55203, '\P{^Is_Hangul_Syllable_Type=lvtsyllable}', "");
    Expect(0, 55204, '\p{Is_Hangul_Syllable_Type=lvtsyllable}', "");
    Expect(1, 55204, '\p{^Is_Hangul_Syllable_Type=lvtsyllable}', "");
    Expect(1, 55204, '\P{Is_Hangul_Syllable_Type=lvtsyllable}', "");
    Expect(0, 55204, '\P{^Is_Hangul_Syllable_Type=lvtsyllable}', "");
    Expect(1, 55203, '\p{Is_Hangul_Syllable_Type=	LVT_SYLLABLE}', "");
    Expect(0, 55203, '\p{^Is_Hangul_Syllable_Type=	LVT_SYLLABLE}', "");
    Expect(0, 55203, '\P{Is_Hangul_Syllable_Type=	LVT_SYLLABLE}', "");
    Expect(1, 55203, '\P{^Is_Hangul_Syllable_Type=	LVT_SYLLABLE}', "");
    Expect(0, 55204, '\p{Is_Hangul_Syllable_Type=	LVT_SYLLABLE}', "");
    Expect(1, 55204, '\p{^Is_Hangul_Syllable_Type=	LVT_SYLLABLE}', "");
    Expect(1, 55204, '\P{Is_Hangul_Syllable_Type=	LVT_SYLLABLE}', "");
    Expect(0, 55204, '\P{^Is_Hangul_Syllable_Type=	LVT_SYLLABLE}', "");
    Error('\p{Is_Hst=	LVT/a/}');
    Error('\P{Is_Hst=	LVT/a/}');
    Expect(1, 55203, '\p{Is_Hst=lvt}', "");
    Expect(0, 55203, '\p{^Is_Hst=lvt}', "");
    Expect(0, 55203, '\P{Is_Hst=lvt}', "");
    Expect(1, 55203, '\P{^Is_Hst=lvt}', "");
    Expect(0, 55204, '\p{Is_Hst=lvt}', "");
    Expect(1, 55204, '\p{^Is_Hst=lvt}', "");
    Expect(1, 55204, '\P{Is_Hst=lvt}', "");
    Expect(0, 55204, '\P{^Is_Hst=lvt}', "");
    Expect(1, 55203, '\p{Is_Hst=	-lvt}', "");
    Expect(0, 55203, '\p{^Is_Hst=	-lvt}', "");
    Expect(0, 55203, '\P{Is_Hst=	-lvt}', "");
    Expect(1, 55203, '\P{^Is_Hst=	-lvt}', "");
    Expect(0, 55204, '\p{Is_Hst=	-lvt}', "");
    Expect(1, 55204, '\p{^Is_Hst=	-lvt}', "");
    Expect(1, 55204, '\P{Is_Hst=	-lvt}', "");
    Expect(0, 55204, '\P{^Is_Hst=	-lvt}', "");
    Error('\p{Hangul_Syllable_Type: /a/-Not_Applicable}');
    Error('\P{Hangul_Syllable_Type: /a/-Not_Applicable}');
    Expect(1, 55292, '\p{Hangul_Syllable_Type=:\ANot_Applicable\z:}', "");;
    Expect(0, 55291, '\p{Hangul_Syllable_Type=:\ANot_Applicable\z:}', "");;
    Expect(1, 55292, '\p{Hangul_Syllable_Type:	notapplicable}', "");
    Expect(0, 55292, '\p{^Hangul_Syllable_Type:	notapplicable}', "");
    Expect(0, 55292, '\P{Hangul_Syllable_Type:	notapplicable}', "");
    Expect(1, 55292, '\P{^Hangul_Syllable_Type:	notapplicable}', "");
    Expect(0, 55291, '\p{Hangul_Syllable_Type:	notapplicable}', "");
    Expect(1, 55291, '\p{^Hangul_Syllable_Type:	notapplicable}', "");
    Expect(1, 55291, '\P{Hangul_Syllable_Type:	notapplicable}', "");
    Expect(0, 55291, '\P{^Hangul_Syllable_Type:	notapplicable}', "");
    Expect(1, 55292, '\p{Hangul_Syllable_Type=:\Anotapplicable\z:}', "");;
    Expect(0, 55291, '\p{Hangul_Syllable_Type=:\Anotapplicable\z:}', "");;
    Expect(1, 55292, '\p{Hangul_Syllable_Type=		Not_Applicable}', "");
    Expect(0, 55292, '\p{^Hangul_Syllable_Type=		Not_Applicable}', "");
    Expect(0, 55292, '\P{Hangul_Syllable_Type=		Not_Applicable}', "");
    Expect(1, 55292, '\P{^Hangul_Syllable_Type=		Not_Applicable}', "");
    Expect(0, 55291, '\p{Hangul_Syllable_Type=		Not_Applicable}', "");
    Expect(1, 55291, '\p{^Hangul_Syllable_Type=		Not_Applicable}', "");
    Expect(1, 55291, '\P{Hangul_Syllable_Type=		Not_Applicable}', "");
    Expect(0, 55291, '\P{^Hangul_Syllable_Type=		Not_Applicable}', "");
    Error('\p{Hst=/a/	 NA}');
    Error('\P{Hst=/a/	 NA}');
    Expect(1, 55292, '\p{Hst=:\ANA\z:}', "");;
    Expect(0, 55291, '\p{Hst=:\ANA\z:}', "");;
    Expect(1, 55292, '\p{Hst:na}', "");
    Expect(0, 55292, '\p{^Hst:na}', "");
    Expect(0, 55292, '\P{Hst:na}', "");
    Expect(1, 55292, '\P{^Hst:na}', "");
    Expect(0, 55291, '\p{Hst:na}', "");
    Expect(1, 55291, '\p{^Hst:na}', "");
    Expect(1, 55291, '\P{Hst:na}', "");
    Expect(0, 55291, '\P{^Hst:na}', "");
    Expect(1, 55292, '\p{Hst=:\Ana\z:}', "");;
    Expect(0, 55291, '\p{Hst=:\Ana\z:}', "");;
    Expect(1, 55292, '\p{Hst= na}', "");
    Expect(0, 55292, '\p{^Hst= na}', "");
    Expect(0, 55292, '\P{Hst= na}', "");
    Expect(1, 55292, '\P{^Hst= na}', "");
    Expect(0, 55291, '\p{Hst= na}', "");
    Expect(1, 55291, '\p{^Hst= na}', "");
    Expect(1, 55291, '\P{Hst= na}', "");
    Expect(0, 55291, '\P{^Hst= na}', "");
    Error('\p{Is_Hangul_Syllable_Type:   Not_Applicable:=}');
    Error('\P{Is_Hangul_Syllable_Type:   Not_Applicable:=}');
    Expect(1, 55292, '\p{Is_Hangul_Syllable_Type=notapplicable}', "");
    Expect(0, 55292, '\p{^Is_Hangul_Syllable_Type=notapplicable}', "");
    Expect(0, 55292, '\P{Is_Hangul_Syllable_Type=notapplicable}', "");
    Expect(1, 55292, '\P{^Is_Hangul_Syllable_Type=notapplicable}', "");
    Expect(0, 55291, '\p{Is_Hangul_Syllable_Type=notapplicable}', "");
    Expect(1, 55291, '\p{^Is_Hangul_Syllable_Type=notapplicable}', "");
    Expect(1, 55291, '\P{Is_Hangul_Syllable_Type=notapplicable}', "");
    Expect(0, 55291, '\P{^Is_Hangul_Syllable_Type=notapplicable}', "");
    Expect(1, 55292, '\p{Is_Hangul_Syllable_Type= _Not_applicable}', "");
    Expect(0, 55292, '\p{^Is_Hangul_Syllable_Type= _Not_applicable}', "");
    Expect(0, 55292, '\P{Is_Hangul_Syllable_Type= _Not_applicable}', "");
    Expect(1, 55292, '\P{^Is_Hangul_Syllable_Type= _Not_applicable}', "");
    Expect(0, 55291, '\p{Is_Hangul_Syllable_Type= _Not_applicable}', "");
    Expect(1, 55291, '\p{^Is_Hangul_Syllable_Type= _Not_applicable}', "");
    Expect(1, 55291, '\P{Is_Hangul_Syllable_Type= _Not_applicable}', "");
    Expect(0, 55291, '\P{^Is_Hangul_Syllable_Type= _Not_applicable}', "");
    Error('\p{Is_Hst=--NA/a/}');
    Error('\P{Is_Hst=--NA/a/}');
    Expect(1, 55292, '\p{Is_Hst:na}', "");
    Expect(0, 55292, '\p{^Is_Hst:na}', "");
    Expect(0, 55292, '\P{Is_Hst:na}', "");
    Expect(1, 55292, '\P{^Is_Hst:na}', "");
    Expect(0, 55291, '\p{Is_Hst:na}', "");
    Expect(1, 55291, '\p{^Is_Hst:na}', "");
    Expect(1, 55291, '\P{Is_Hst:na}', "");
    Expect(0, 55291, '\P{^Is_Hst:na}', "");
    Expect(1, 55292, '\p{Is_Hst=_	NA}', "");
    Expect(0, 55292, '\p{^Is_Hst=_	NA}', "");
    Expect(0, 55292, '\P{Is_Hst=_	NA}', "");
    Expect(1, 55292, '\P{^Is_Hst=_	NA}', "");
    Expect(0, 55291, '\p{Is_Hst=_	NA}', "");
    Expect(1, 55291, '\p{^Is_Hst=_	NA}', "");
    Expect(1, 55291, '\P{Is_Hst=_	NA}', "");
    Expect(0, 55291, '\P{^Is_Hst=_	NA}', "");
    Error('\p{Hangul_Syllable_Type= _Trailing_jamo:=}');
    Error('\P{Hangul_Syllable_Type= _Trailing_jamo:=}');
    Expect(1, 55291, '\p{Hangul_Syllable_Type=:\ATrailing_Jamo\z:}', "");;
    Expect(0, 55292, '\p{Hangul_Syllable_Type=:\ATrailing_Jamo\z:}', "");;
    Expect(1, 55291, '\p{Hangul_Syllable_Type=trailingjamo}', "");
    Expect(0, 55291, '\p{^Hangul_Syllable_Type=trailingjamo}', "");
    Expect(0, 55291, '\P{Hangul_Syllable_Type=trailingjamo}', "");
    Expect(1, 55291, '\P{^Hangul_Syllable_Type=trailingjamo}', "");
    Expect(0, 55292, '\p{Hangul_Syllable_Type=trailingjamo}', "");
    Expect(1, 55292, '\p{^Hangul_Syllable_Type=trailingjamo}', "");
    Expect(1, 55292, '\P{Hangul_Syllable_Type=trailingjamo}', "");
    Expect(0, 55292, '\P{^Hangul_Syllable_Type=trailingjamo}', "");
    Expect(1, 55291, '\p{Hangul_Syllable_Type=:\Atrailingjamo\z:}', "");;
    Expect(0, 55292, '\p{Hangul_Syllable_Type=:\Atrailingjamo\z:}', "");;
    Expect(1, 55291, '\p{Hangul_Syllable_Type=	-TRAILING_jamo}', "");
    Expect(0, 55291, '\p{^Hangul_Syllable_Type=	-TRAILING_jamo}', "");
    Expect(0, 55291, '\P{Hangul_Syllable_Type=	-TRAILING_jamo}', "");
    Expect(1, 55291, '\P{^Hangul_Syllable_Type=	-TRAILING_jamo}', "");
    Expect(0, 55292, '\p{Hangul_Syllable_Type=	-TRAILING_jamo}', "");
    Expect(1, 55292, '\p{^Hangul_Syllable_Type=	-TRAILING_jamo}', "");
    Expect(1, 55292, '\P{Hangul_Syllable_Type=	-TRAILING_jamo}', "");
    Expect(0, 55292, '\P{^Hangul_Syllable_Type=	-TRAILING_jamo}', "");
    Error('\p{Hst=	:=T}');
    Error('\P{Hst=	:=T}');
    Expect(1, 55291, '\p{Hst=:\AT\z:}', "");;
    Expect(0, 55292, '\p{Hst=:\AT\z:}', "");;
    Expect(1, 55291, '\p{Hst=t}', "");
    Expect(0, 55291, '\p{^Hst=t}', "");
    Expect(0, 55291, '\P{Hst=t}', "");
    Expect(1, 55291, '\P{^Hst=t}', "");
    Expect(0, 55292, '\p{Hst=t}', "");
    Expect(1, 55292, '\p{^Hst=t}', "");
    Expect(1, 55292, '\P{Hst=t}', "");
    Expect(0, 55292, '\P{^Hst=t}', "");
    Expect(1, 55291, '\p{Hst=:\At\z:}', "");;
    Expect(0, 55292, '\p{Hst=:\At\z:}', "");;
    Expect(1, 55291, '\p{Hst= T}', "");
    Expect(0, 55291, '\p{^Hst= T}', "");
    Expect(0, 55291, '\P{Hst= T}', "");
    Expect(1, 55291, '\P{^Hst= T}', "");
    Expect(0, 55292, '\p{Hst= T}', "");
    Expect(1, 55292, '\p{^Hst= T}', "");
    Expect(1, 55292, '\P{Hst= T}', "");
    Expect(0, 55292, '\P{^Hst= T}', "");
    Error('\p{Is_Hangul_Syllable_Type=:=	_trailing_JAMO}');
    Error('\P{Is_Hangul_Syllable_Type=:=	_trailing_JAMO}');
    Expect(1, 55291, '\p{Is_Hangul_Syllable_Type=trailingjamo}', "");
    Expect(0, 55291, '\p{^Is_Hangul_Syllable_Type=trailingjamo}', "");
    Expect(0, 55291, '\P{Is_Hangul_Syllable_Type=trailingjamo}', "");
    Expect(1, 55291, '\P{^Is_Hangul_Syllable_Type=trailingjamo}', "");
    Expect(0, 55292, '\p{Is_Hangul_Syllable_Type=trailingjamo}', "");
    Expect(1, 55292, '\p{^Is_Hangul_Syllable_Type=trailingjamo}', "");
    Expect(1, 55292, '\P{Is_Hangul_Syllable_Type=trailingjamo}', "");
    Expect(0, 55292, '\P{^Is_Hangul_Syllable_Type=trailingjamo}', "");
    Expect(1, 55291, '\p{Is_Hangul_Syllable_Type=	Trailing_JAMO}', "");
    Expect(0, 55291, '\p{^Is_Hangul_Syllable_Type=	Trailing_JAMO}', "");
    Expect(0, 55291, '\P{Is_Hangul_Syllable_Type=	Trailing_JAMO}', "");
    Expect(1, 55291, '\P{^Is_Hangul_Syllable_Type=	Trailing_JAMO}', "");
    Expect(0, 55292, '\p{Is_Hangul_Syllable_Type=	Trailing_JAMO}', "");
    Expect(1, 55292, '\p{^Is_Hangul_Syllable_Type=	Trailing_JAMO}', "");
    Expect(1, 55292, '\P{Is_Hangul_Syllable_Type=	Trailing_JAMO}', "");
    Expect(0, 55292, '\P{^Is_Hangul_Syllable_Type=	Trailing_JAMO}', "");
    Error('\p{Is_Hst=-	t:=}');
    Error('\P{Is_Hst=-	t:=}');
    Expect(1, 55291, '\p{Is_Hst=t}', "");
    Expect(0, 55291, '\p{^Is_Hst=t}', "");
    Expect(0, 55291, '\P{Is_Hst=t}', "");
    Expect(1, 55291, '\P{^Is_Hst=t}', "");
    Expect(0, 55292, '\p{Is_Hst=t}', "");
    Expect(1, 55292, '\p{^Is_Hst=t}', "");
    Expect(1, 55292, '\P{Is_Hst=t}', "");
    Expect(0, 55292, '\P{^Is_Hst=t}', "");
    Expect(1, 55291, '\p{Is_Hst=-	T}', "");
    Expect(0, 55291, '\p{^Is_Hst=-	T}', "");
    Expect(0, 55291, '\P{Is_Hst=-	T}', "");
    Expect(1, 55291, '\P{^Is_Hst=-	T}', "");
    Expect(0, 55292, '\p{Is_Hst=-	T}', "");
    Expect(1, 55292, '\p{^Is_Hst=-	T}', "");
    Expect(1, 55292, '\P{Is_Hst=-	T}', "");
    Expect(0, 55292, '\P{^Is_Hst=-	T}', "");
    Error('\p{Hangul_Syllable_Type=/a/ VOWEL_jamo}');
    Error('\P{Hangul_Syllable_Type=/a/ VOWEL_jamo}');
    Expect(1, 55238, '\p{Hangul_Syllable_Type=:\AVowel_Jamo\z:}', "");;
    Expect(0, 55239, '\p{Hangul_Syllable_Type=:\AVowel_Jamo\z:}', "");;
    Expect(1, 55238, '\p{Hangul_Syllable_Type=voweljamo}', "");
    Expect(0, 55238, '\p{^Hangul_Syllable_Type=voweljamo}', "");
    Expect(0, 55238, '\P{Hangul_Syllable_Type=voweljamo}', "");
    Expect(1, 55238, '\P{^Hangul_Syllable_Type=voweljamo}', "");
    Expect(0, 55239, '\p{Hangul_Syllable_Type=voweljamo}', "");
    Expect(1, 55239, '\p{^Hangul_Syllable_Type=voweljamo}', "");
    Expect(1, 55239, '\P{Hangul_Syllable_Type=voweljamo}', "");
    Expect(0, 55239, '\P{^Hangul_Syllable_Type=voweljamo}', "");
    Expect(1, 55238, '\p{Hangul_Syllable_Type=:\Avoweljamo\z:}', "");;
    Expect(0, 55239, '\p{Hangul_Syllable_Type=:\Avoweljamo\z:}', "");;
    Expect(1, 55238, '\p{Hangul_Syllable_Type=_vowel_jamo}', "");
    Expect(0, 55238, '\p{^Hangul_Syllable_Type=_vowel_jamo}', "");
    Expect(0, 55238, '\P{Hangul_Syllable_Type=_vowel_jamo}', "");
    Expect(1, 55238, '\P{^Hangul_Syllable_Type=_vowel_jamo}', "");
    Expect(0, 55239, '\p{Hangul_Syllable_Type=_vowel_jamo}', "");
    Expect(1, 55239, '\p{^Hangul_Syllable_Type=_vowel_jamo}', "");
    Expect(1, 55239, '\P{Hangul_Syllable_Type=_vowel_jamo}', "");
    Expect(0, 55239, '\P{^Hangul_Syllable_Type=_vowel_jamo}', "");
    Error('\p{Hst=/a/	_V}');
    Error('\P{Hst=/a/	_V}');
    Expect(1, 55238, '\p{Hst=:\AV\z:}', "");;
    Expect(0, 55239, '\p{Hst=:\AV\z:}', "");;
    Expect(1, 55238, '\p{Hst=v}', "");
    Expect(0, 55238, '\p{^Hst=v}', "");
    Expect(0, 55238, '\P{Hst=v}', "");
    Expect(1, 55238, '\P{^Hst=v}', "");
    Expect(0, 55239, '\p{Hst=v}', "");
    Expect(1, 55239, '\p{^Hst=v}', "");
    Expect(1, 55239, '\P{Hst=v}', "");
    Expect(0, 55239, '\P{^Hst=v}', "");
    Expect(1, 55238, '\p{Hst=:\Av\z:}', "");;
    Expect(0, 55239, '\p{Hst=:\Av\z:}', "");;
    Expect(1, 55238, '\p{Hst= -V}', "");
    Expect(0, 55238, '\p{^Hst= -V}', "");
    Expect(0, 55238, '\P{Hst= -V}', "");
    Expect(1, 55238, '\P{^Hst= -V}', "");
    Expect(0, 55239, '\p{Hst= -V}', "");
    Expect(1, 55239, '\p{^Hst= -V}', "");
    Expect(1, 55239, '\P{Hst= -V}', "");
    Expect(0, 55239, '\P{^Hst= -V}', "");
    Error('\p{Is_Hangul_Syllable_Type=_/a/Vowel_jamo}');
    Error('\P{Is_Hangul_Syllable_Type=_/a/Vowel_jamo}');
    Expect(1, 55238, '\p{Is_Hangul_Syllable_Type=voweljamo}', "");
    Expect(0, 55238, '\p{^Is_Hangul_Syllable_Type=voweljamo}', "");
    Expect(0, 55238, '\P{Is_Hangul_Syllable_Type=voweljamo}', "");
    Expect(1, 55238, '\P{^Is_Hangul_Syllable_Type=voweljamo}', "");
    Expect(0, 55239, '\p{Is_Hangul_Syllable_Type=voweljamo}', "");
    Expect(1, 55239, '\p{^Is_Hangul_Syllable_Type=voweljamo}', "");
    Expect(1, 55239, '\P{Is_Hangul_Syllable_Type=voweljamo}', "");
    Expect(0, 55239, '\P{^Is_Hangul_Syllable_Type=voweljamo}', "");
    Expect(1, 55238, '\p{Is_Hangul_Syllable_Type=_vowel_Jamo}', "");
    Expect(0, 55238, '\p{^Is_Hangul_Syllable_Type=_vowel_Jamo}', "");
    Expect(0, 55238, '\P{Is_Hangul_Syllable_Type=_vowel_Jamo}', "");
    Expect(1, 55238, '\P{^Is_Hangul_Syllable_Type=_vowel_Jamo}', "");
    Expect(0, 55239, '\p{Is_Hangul_Syllable_Type=_vowel_Jamo}', "");
    Expect(1, 55239, '\p{^Is_Hangul_Syllable_Type=_vowel_Jamo}', "");
    Expect(1, 55239, '\P{Is_Hangul_Syllable_Type=_vowel_Jamo}', "");
    Expect(0, 55239, '\P{^Is_Hangul_Syllable_Type=_vowel_Jamo}', "");
    Error('\p{Is_Hst=/a/__V}');
    Error('\P{Is_Hst=/a/__V}');
    Expect(1, 55238, '\p{Is_Hst=v}', "");
    Expect(0, 55238, '\p{^Is_Hst=v}', "");
    Expect(0, 55238, '\P{Is_Hst=v}', "");
    Expect(1, 55238, '\P{^Is_Hst=v}', "");
    Expect(0, 55239, '\p{Is_Hst=v}', "");
    Expect(1, 55239, '\p{^Is_Hst=v}', "");
    Expect(1, 55239, '\P{Is_Hst=v}', "");
    Expect(0, 55239, '\P{^Is_Hst=v}', "");
    Expect(1, 55238, '\p{Is_Hst=_ v}', "");
    Expect(0, 55238, '\p{^Is_Hst=_ v}', "");
    Expect(0, 55238, '\P{Is_Hst=_ v}', "");
    Expect(1, 55238, '\P{^Is_Hst=_ v}', "");
    Expect(0, 55239, '\p{Is_Hst=_ v}', "");
    Expect(1, 55239, '\p{^Is_Hst=_ v}', "");
    Expect(1, 55239, '\P{Is_Hst=_ v}', "");
    Expect(0, 55239, '\P{^Is_Hst=_ v}', "");
    Error('\p{Hyphen= no/a/}');
    Error('\P{Hyphen= no/a/}');
    Expect(1, 65382, '\p{Hyphen=no}', 'deprecated');
    Expect(0, 65382, '\p{^Hyphen=no}', 'deprecated');
    Expect(0, 65382, '\P{Hyphen=no}', 'deprecated');
    Expect(1, 65382, '\P{^Hyphen=no}', 'deprecated');
    Expect(0, 65381, '\p{Hyphen=no}', 'deprecated');
    Expect(1, 65381, '\p{^Hyphen=no}', 'deprecated');
    Expect(1, 65381, '\P{Hyphen=no}', 'deprecated');
    Expect(0, 65381, '\P{^Hyphen=no}', 'deprecated');
    Expect(1, 65382, '\p{Hyphen=- No}', 'deprecated');
    Expect(0, 65382, '\p{^Hyphen=- No}', 'deprecated');
    Expect(0, 65382, '\P{Hyphen=- No}', 'deprecated');
    Expect(1, 65382, '\P{^Hyphen=- No}', 'deprecated');
    Expect(0, 65381, '\p{Hyphen=- No}', 'deprecated');
    Expect(1, 65381, '\p{^Hyphen=- No}', 'deprecated');
    Expect(1, 65381, '\P{Hyphen=- No}', 'deprecated');
    Expect(0, 65381, '\P{^Hyphen=- No}', 'deprecated');
    Error('\p{Is_Hyphen: /a/  N}');
    Error('\P{Is_Hyphen: /a/  N}');
    Expect(1, 65382, '\p{Is_Hyphen=n}', 'deprecated');
    Expect(0, 65382, '\p{^Is_Hyphen=n}', 'deprecated');
    Expect(0, 65382, '\P{Is_Hyphen=n}', 'deprecated');
    Expect(1, 65382, '\P{^Is_Hyphen=n}', 'deprecated');
    Expect(0, 65381, '\p{Is_Hyphen=n}', 'deprecated');
    Expect(1, 65381, '\p{^Is_Hyphen=n}', 'deprecated');
    Expect(1, 65381, '\P{Is_Hyphen=n}', 'deprecated');
    Expect(0, 65381, '\P{^Is_Hyphen=n}', 'deprecated');
    Expect(1, 65382, '\p{Is_Hyphen: -n}', 'deprecated');
    Expect(0, 65382, '\p{^Is_Hyphen: -n}', 'deprecated');
    Expect(0, 65382, '\P{Is_Hyphen: -n}', 'deprecated');
    Expect(1, 65382, '\P{^Is_Hyphen: -n}', 'deprecated');
    Expect(0, 65381, '\p{Is_Hyphen: -n}', 'deprecated');
    Expect(1, 65381, '\p{^Is_Hyphen: -n}', 'deprecated');
    Expect(1, 65381, '\P{Is_Hyphen: -n}', 'deprecated');
    Expect(0, 65381, '\P{^Is_Hyphen: -n}', 'deprecated');
    Error('\p{Hyphen=:=		f}');
    Error('\P{Hyphen=:=		f}');
    Expect(1, 65382, '\p{Hyphen=:\AF\z:}', 'deprecated');;
    Expect(0, 65381, '\p{Hyphen=:\AF\z:}', 'deprecated');;
    Expect(1, 65382, '\p{Hyphen=f}', 'deprecated');
    Expect(0, 65382, '\p{^Hyphen=f}', 'deprecated');
    Expect(0, 65382, '\P{Hyphen=f}', 'deprecated');
    Expect(1, 65382, '\P{^Hyphen=f}', 'deprecated');
    Expect(0, 65381, '\p{Hyphen=f}', 'deprecated');
    Expect(1, 65381, '\p{^Hyphen=f}', 'deprecated');
    Expect(1, 65381, '\P{Hyphen=f}', 'deprecated');
    Expect(0, 65381, '\P{^Hyphen=f}', 'deprecated');
    Expect(1, 65382, '\p{Hyphen=:\Af\z:}', 'deprecated');;
    Expect(0, 65381, '\p{Hyphen=:\Af\z:}', 'deprecated');;
    Expect(1, 65382, '\p{Hyphen:F}', 'deprecated');
    Expect(0, 65382, '\p{^Hyphen:F}', 'deprecated');
    Expect(0, 65382, '\P{Hyphen:F}', 'deprecated');
    Expect(1, 65382, '\P{^Hyphen:F}', 'deprecated');
    Expect(0, 65381, '\p{Hyphen:F}', 'deprecated');
    Expect(1, 65381, '\p{^Hyphen:F}', 'deprecated');
    Expect(1, 65381, '\P{Hyphen:F}', 'deprecated');
    Expect(0, 65381, '\P{^Hyphen:F}', 'deprecated');
    Error('\p{Is_Hyphen=:=__False}');
    Error('\P{Is_Hyphen=:=__False}');
    Expect(1, 65382, '\p{Is_Hyphen=false}', 'deprecated');
    Expect(0, 65382, '\p{^Is_Hyphen=false}', 'deprecated');
    Expect(0, 65382, '\P{Is_Hyphen=false}', 'deprecated');
    Expect(1, 65382, '\P{^Is_Hyphen=false}', 'deprecated');
    Expect(0, 65381, '\p{Is_Hyphen=false}', 'deprecated');
    Expect(1, 65381, '\p{^Is_Hyphen=false}', 'deprecated');
    Expect(1, 65381, '\P{Is_Hyphen=false}', 'deprecated');
    Expect(0, 65381, '\P{^Is_Hyphen=false}', 'deprecated');
    Expect(1, 65382, '\p{Is_Hyphen=	False}', 'deprecated');
    Expect(0, 65382, '\p{^Is_Hyphen=	False}', 'deprecated');
    Expect(0, 65382, '\P{Is_Hyphen=	False}', 'deprecated');
    Expect(1, 65382, '\P{^Is_Hyphen=	False}', 'deprecated');
    Expect(0, 65381, '\p{Is_Hyphen=	False}', 'deprecated');
    Expect(1, 65381, '\p{^Is_Hyphen=	False}', 'deprecated');
    Expect(1, 65381, '\P{Is_Hyphen=	False}', 'deprecated');
    Expect(0, 65381, '\P{^Is_Hyphen=	False}', 'deprecated');
    Error('\p{Hyphen=	Yes/a/}');
    Error('\P{Hyphen=	Yes/a/}');
    Expect(1, 65381, '\p{Hyphen=yes}', 'deprecated');
    Expect(0, 65381, '\p{^Hyphen=yes}', 'deprecated');
    Expect(0, 65381, '\P{Hyphen=yes}', 'deprecated');
    Expect(1, 65381, '\P{^Hyphen=yes}', 'deprecated');
    Expect(0, 65382, '\p{Hyphen=yes}', 'deprecated');
    Expect(1, 65382, '\p{^Hyphen=yes}', 'deprecated');
    Expect(1, 65382, '\P{Hyphen=yes}', 'deprecated');
    Expect(0, 65382, '\P{^Hyphen=yes}', 'deprecated');
    Expect(1, 65381, '\p{Hyphen=__yes}', 'deprecated');
    Expect(0, 65381, '\p{^Hyphen=__yes}', 'deprecated');
    Expect(0, 65381, '\P{Hyphen=__yes}', 'deprecated');
    Expect(1, 65381, '\P{^Hyphen=__yes}', 'deprecated');
    Expect(0, 65382, '\p{Hyphen=__yes}', 'deprecated');
    Expect(1, 65382, '\p{^Hyphen=__yes}', 'deprecated');
    Expect(1, 65382, '\P{Hyphen=__yes}', 'deprecated');
    Expect(0, 65382, '\P{^Hyphen=__yes}', 'deprecated');
    Error('\p{Is_Hyphen=/a/_	Y}');
    Error('\P{Is_Hyphen=/a/_	Y}');
    Expect(1, 65381, '\p{Is_Hyphen:	y}', 'deprecated');
    Expect(0, 65381, '\p{^Is_Hyphen:	y}', 'deprecated');
    Expect(0, 65381, '\P{Is_Hyphen:	y}', 'deprecated');
    Expect(1, 65381, '\P{^Is_Hyphen:	y}', 'deprecated');
    Expect(0, 65382, '\p{Is_Hyphen:	y}', 'deprecated');
    Expect(1, 65382, '\p{^Is_Hyphen:	y}', 'deprecated');
    Expect(1, 65382, '\P{Is_Hyphen:	y}', 'deprecated');
    Expect(0, 65382, '\P{^Is_Hyphen:	y}', 'deprecated');
    Expect(1, 65381, '\p{Is_Hyphen=		Y}', 'deprecated');
    Expect(0, 65381, '\p{^Is_Hyphen=		Y}', 'deprecated');
    Expect(0, 65381, '\P{Is_Hyphen=		Y}', 'deprecated');
    Expect(1, 65381, '\P{^Is_Hyphen=		Y}', 'deprecated');
    Expect(0, 65382, '\p{Is_Hyphen=		Y}', 'deprecated');
    Expect(1, 65382, '\p{^Is_Hyphen=		Y}', 'deprecated');
    Expect(1, 65382, '\P{Is_Hyphen=		Y}', 'deprecated');
    Expect(0, 65382, '\P{^Is_Hyphen=		Y}', 'deprecated');
    Error('\p{Hyphen=/a/-T}');
    Error('\P{Hyphen=/a/-T}');
    Expect(1, 65381, '\p{Hyphen=:\AT\z:}', 'deprecated');;
    Expect(0, 65382, '\p{Hyphen=:\AT\z:}', 'deprecated');;
    Expect(1, 65381, '\p{Hyphen=t}', 'deprecated');
    Expect(0, 65381, '\p{^Hyphen=t}', 'deprecated');
    Expect(0, 65381, '\P{Hyphen=t}', 'deprecated');
    Expect(1, 65381, '\P{^Hyphen=t}', 'deprecated');
    Expect(0, 65382, '\p{Hyphen=t}', 'deprecated');
    Expect(1, 65382, '\p{^Hyphen=t}', 'deprecated');
    Expect(1, 65382, '\P{Hyphen=t}', 'deprecated');
    Expect(0, 65382, '\P{^Hyphen=t}', 'deprecated');
    Expect(1, 65381, '\p{Hyphen=:\At\z:}', 'deprecated');;
    Expect(0, 65382, '\p{Hyphen=:\At\z:}', 'deprecated');;
    Expect(1, 65381, '\p{Hyphen=-	T}', 'deprecated');
    Expect(0, 65381, '\p{^Hyphen=-	T}', 'deprecated');
    Expect(0, 65381, '\P{Hyphen=-	T}', 'deprecated');
    Expect(1, 65381, '\P{^Hyphen=-	T}', 'deprecated');
    Expect(0, 65382, '\p{Hyphen=-	T}', 'deprecated');
    Expect(1, 65382, '\p{^Hyphen=-	T}', 'deprecated');
    Expect(1, 65382, '\P{Hyphen=-	T}', 'deprecated');
    Expect(0, 65382, '\P{^Hyphen=-	T}', 'deprecated');
    Error('\p{Is_Hyphen=/a/True}');
    Error('\P{Is_Hyphen=/a/True}');
    Expect(1, 65381, '\p{Is_Hyphen=true}', 'deprecated');
    Expect(0, 65381, '\p{^Is_Hyphen=true}', 'deprecated');
    Expect(0, 65381, '\P{Is_Hyphen=true}', 'deprecated');
    Expect(1, 65381, '\P{^Is_Hyphen=true}', 'deprecated');
    Expect(0, 65382, '\p{Is_Hyphen=true}', 'deprecated');
    Expect(1, 65382, '\p{^Is_Hyphen=true}', 'deprecated');
    Expect(1, 65382, '\P{Is_Hyphen=true}', 'deprecated');
    Expect(0, 65382, '\P{^Is_Hyphen=true}', 'deprecated');
    Expect(1, 65381, '\p{Is_Hyphen=-TRUE}', 'deprecated');
    Expect(0, 65381, '\p{^Is_Hyphen=-TRUE}', 'deprecated');
    Expect(0, 65381, '\P{Is_Hyphen=-TRUE}', 'deprecated');
    Expect(1, 65381, '\P{^Is_Hyphen=-TRUE}', 'deprecated');
    Expect(0, 65382, '\p{Is_Hyphen=-TRUE}', 'deprecated');
    Expect(1, 65382, '\p{^Is_Hyphen=-TRUE}', 'deprecated');
    Expect(1, 65382, '\P{Is_Hyphen=-TRUE}', 'deprecated');
    Expect(0, 65382, '\P{^Is_Hyphen=-TRUE}', 'deprecated');
    Error('\p{ID_Continue=:=No}');
    Error('\P{ID_Continue=:=No}');
    Expect(1, 918000, '\p{ID_Continue=:\ANo\z:}', "");;
    Expect(0, 917999, '\p{ID_Continue=:\ANo\z:}', "");;
    Expect(1, 918000, '\p{ID_Continue=no}', "");
    Expect(0, 918000, '\p{^ID_Continue=no}', "");
    Expect(0, 918000, '\P{ID_Continue=no}', "");
    Expect(1, 918000, '\P{^ID_Continue=no}', "");
    Expect(0, 917999, '\p{ID_Continue=no}', "");
    Expect(1, 917999, '\p{^ID_Continue=no}', "");
    Expect(1, 917999, '\P{ID_Continue=no}', "");
    Expect(0, 917999, '\P{^ID_Continue=no}', "");
    Expect(1, 918000, '\p{ID_Continue=:\Ano\z:}', "");;
    Expect(0, 917999, '\p{ID_Continue=:\Ano\z:}', "");;
    Expect(1, 918000, '\p{ID_Continue=-No}', "");
    Expect(0, 918000, '\p{^ID_Continue=-No}', "");
    Expect(0, 918000, '\P{ID_Continue=-No}', "");
    Expect(1, 918000, '\P{^ID_Continue=-No}', "");
    Expect(0, 917999, '\p{ID_Continue=-No}', "");
    Expect(1, 917999, '\p{^ID_Continue=-No}', "");
    Expect(1, 917999, '\P{ID_Continue=-No}', "");
    Expect(0, 917999, '\P{^ID_Continue=-No}', "");
    Error('\p{IDC=	/a/N}');
    Error('\P{IDC=	/a/N}');
    Expect(1, 918000, '\p{IDC=:\AN\z:}', "");;
    Expect(0, 917999, '\p{IDC=:\AN\z:}', "");;
    Expect(1, 918000, '\p{IDC=n}', "");
    Expect(0, 918000, '\p{^IDC=n}', "");
    Expect(0, 918000, '\P{IDC=n}', "");
    Expect(1, 918000, '\P{^IDC=n}', "");
    Expect(0, 917999, '\p{IDC=n}', "");
    Expect(1, 917999, '\p{^IDC=n}', "");
    Expect(1, 917999, '\P{IDC=n}', "");
    Expect(0, 917999, '\P{^IDC=n}', "");
    Expect(1, 918000, '\p{IDC=:\An\z:}', "");;
    Expect(0, 917999, '\p{IDC=:\An\z:}', "");;
    Expect(1, 918000, '\p{IDC=_N}', "");
    Expect(0, 918000, '\p{^IDC=_N}', "");
    Expect(0, 918000, '\P{IDC=_N}', "");
    Expect(1, 918000, '\P{^IDC=_N}', "");
    Expect(0, 917999, '\p{IDC=_N}', "");
    Expect(1, 917999, '\p{^IDC=_N}', "");
    Expect(1, 917999, '\P{IDC=_N}', "");
    Expect(0, 917999, '\P{^IDC=_N}', "");
    Error('\p{Is_ID_Continue=/a/--F}');
    Error('\P{Is_ID_Continue=/a/--F}');
    Expect(1, 918000, '\p{Is_ID_Continue:	f}', "");
    Expect(0, 918000, '\p{^Is_ID_Continue:	f}', "");
    Expect(0, 918000, '\P{Is_ID_Continue:	f}', "");
    Expect(1, 918000, '\P{^Is_ID_Continue:	f}', "");
    Expect(0, 917999, '\p{Is_ID_Continue:	f}', "");
    Expect(1, 917999, '\p{^Is_ID_Continue:	f}', "");
    Expect(1, 917999, '\P{Is_ID_Continue:	f}', "");
    Expect(0, 917999, '\P{^Is_ID_Continue:	f}', "");
    Expect(1, 918000, '\p{Is_ID_Continue=		f}', "");
    Expect(0, 918000, '\p{^Is_ID_Continue=		f}', "");
    Expect(0, 918000, '\P{Is_ID_Continue=		f}', "");
    Expect(1, 918000, '\P{^Is_ID_Continue=		f}', "");
    Expect(0, 917999, '\p{Is_ID_Continue=		f}', "");
    Expect(1, 917999, '\p{^Is_ID_Continue=		f}', "");
    Expect(1, 917999, '\P{Is_ID_Continue=		f}', "");
    Expect(0, 917999, '\P{^Is_ID_Continue=		f}', "");
    Error('\p{Is_IDC=/a/_	False}');
    Error('\P{Is_IDC=/a/_	False}');
    Expect(1, 918000, '\p{Is_IDC:	false}', "");
    Expect(0, 918000, '\p{^Is_IDC:	false}', "");
    Expect(0, 918000, '\P{Is_IDC:	false}', "");
    Expect(1, 918000, '\P{^Is_IDC:	false}', "");
    Expect(0, 917999, '\p{Is_IDC:	false}', "");
    Expect(1, 917999, '\p{^Is_IDC:	false}', "");
    Expect(1, 917999, '\P{Is_IDC:	false}', "");
    Expect(0, 917999, '\P{^Is_IDC:	false}', "");
    Expect(1, 918000, '\p{Is_IDC=_ false}', "");
    Expect(0, 918000, '\p{^Is_IDC=_ false}', "");
    Expect(0, 918000, '\P{Is_IDC=_ false}', "");
    Expect(1, 918000, '\P{^Is_IDC=_ false}', "");
    Expect(0, 917999, '\p{Is_IDC=_ false}', "");
    Expect(1, 917999, '\p{^Is_IDC=_ false}', "");
    Expect(1, 917999, '\P{Is_IDC=_ false}', "");
    Expect(0, 917999, '\P{^Is_IDC=_ false}', "");
    Error('\p{ID_Continue=/a/Yes}');
    Error('\P{ID_Continue=/a/Yes}');
    Expect(1, 917999, '\p{ID_Continue=:\AYes\z:}', "");;
    Expect(0, 918000, '\p{ID_Continue=:\AYes\z:}', "");;
    Expect(1, 917999, '\p{ID_Continue=yes}', "");
    Expect(0, 917999, '\p{^ID_Continue=yes}', "");
    Expect(0, 917999, '\P{ID_Continue=yes}', "");
    Expect(1, 917999, '\P{^ID_Continue=yes}', "");
    Expect(0, 918000, '\p{ID_Continue=yes}', "");
    Expect(1, 918000, '\p{^ID_Continue=yes}', "");
    Expect(1, 918000, '\P{ID_Continue=yes}', "");
    Expect(0, 918000, '\P{^ID_Continue=yes}', "");
    Expect(1, 917999, '\p{ID_Continue=:\Ayes\z:}', "");;
    Expect(0, 918000, '\p{ID_Continue=:\Ayes\z:}', "");;
    Expect(1, 917999, '\p{ID_Continue=-yes}', "");
    Expect(0, 917999, '\p{^ID_Continue=-yes}', "");
    Expect(0, 917999, '\P{ID_Continue=-yes}', "");
    Expect(1, 917999, '\P{^ID_Continue=-yes}', "");
    Expect(0, 918000, '\p{ID_Continue=-yes}', "");
    Expect(1, 918000, '\p{^ID_Continue=-yes}', "");
    Expect(1, 918000, '\P{ID_Continue=-yes}', "");
    Expect(0, 918000, '\P{^ID_Continue=-yes}', "");
    Error('\p{IDC=/a/Y}');
    Error('\P{IDC=/a/Y}');
    Expect(1, 917999, '\p{IDC=:\AY\z:}', "");;
    Expect(0, 918000, '\p{IDC=:\AY\z:}', "");;
    Expect(1, 917999, '\p{IDC=y}', "");
    Expect(0, 917999, '\p{^IDC=y}', "");
    Expect(0, 917999, '\P{IDC=y}', "");
    Expect(1, 917999, '\P{^IDC=y}', "");
    Expect(0, 918000, '\p{IDC=y}', "");
    Expect(1, 918000, '\p{^IDC=y}', "");
    Expect(1, 918000, '\P{IDC=y}', "");
    Expect(0, 918000, '\P{^IDC=y}', "");
    Expect(1, 917999, '\p{IDC=:\Ay\z:}', "");;
    Expect(0, 918000, '\p{IDC=:\Ay\z:}', "");;
    Expect(1, 917999, '\p{IDC=Y}', "");
    Expect(0, 917999, '\p{^IDC=Y}', "");
    Expect(0, 917999, '\P{IDC=Y}', "");
    Expect(1, 917999, '\P{^IDC=Y}', "");
    Expect(0, 918000, '\p{IDC=Y}', "");
    Expect(1, 918000, '\p{^IDC=Y}', "");
    Expect(1, 918000, '\P{IDC=Y}', "");
    Expect(0, 918000, '\P{^IDC=Y}', "");
    Error('\p{Is_ID_Continue= 	T:=}');
    Error('\P{Is_ID_Continue= 	T:=}');
    Expect(1, 917999, '\p{Is_ID_Continue=t}', "");
    Expect(0, 917999, '\p{^Is_ID_Continue=t}', "");
    Expect(0, 917999, '\P{Is_ID_Continue=t}', "");
    Expect(1, 917999, '\P{^Is_ID_Continue=t}', "");
    Expect(0, 918000, '\p{Is_ID_Continue=t}', "");
    Expect(1, 918000, '\p{^Is_ID_Continue=t}', "");
    Expect(1, 918000, '\P{Is_ID_Continue=t}', "");
    Expect(0, 918000, '\P{^Is_ID_Continue=t}', "");
    Expect(1, 917999, '\p{Is_ID_Continue=_	T}', "");
    Expect(0, 917999, '\p{^Is_ID_Continue=_	T}', "");
    Expect(0, 917999, '\P{Is_ID_Continue=_	T}', "");
    Expect(1, 917999, '\P{^Is_ID_Continue=_	T}', "");
    Expect(0, 918000, '\p{Is_ID_Continue=_	T}', "");
    Expect(1, 918000, '\p{^Is_ID_Continue=_	T}', "");
    Expect(1, 918000, '\P{Is_ID_Continue=_	T}', "");
    Expect(0, 918000, '\P{^Is_ID_Continue=_	T}', "");
    Error('\p{Is_IDC=_TRUE:=}');
    Error('\P{Is_IDC=_TRUE:=}');
    Expect(1, 917999, '\p{Is_IDC=true}', "");
    Expect(0, 917999, '\p{^Is_IDC=true}', "");
    Expect(0, 917999, '\P{Is_IDC=true}', "");
    Expect(1, 917999, '\P{^Is_IDC=true}', "");
    Expect(0, 918000, '\p{Is_IDC=true}', "");
    Expect(1, 918000, '\p{^Is_IDC=true}', "");
    Expect(1, 918000, '\P{Is_IDC=true}', "");
    Expect(0, 918000, '\P{^Is_IDC=true}', "");
    Expect(1, 917999, '\p{Is_IDC= 	True}', "");
    Expect(0, 917999, '\p{^Is_IDC= 	True}', "");
    Expect(0, 917999, '\P{Is_IDC= 	True}', "");
    Expect(1, 917999, '\P{^Is_IDC= 	True}', "");
    Expect(0, 918000, '\p{Is_IDC= 	True}', "");
    Expect(1, 918000, '\p{^Is_IDC= 	True}', "");
    Expect(1, 918000, '\P{Is_IDC= 	True}', "");
    Expect(0, 918000, '\P{^Is_IDC= 	True}', "");
    Error('\p{identifierstatus}');
    Error('\P{identifierstatus}');
    Error('\p{Identifier_Status:	_ALLOWED/a/}');
    Error('\P{Identifier_Status:	_ALLOWED/a/}');
    Expect(1, 201546, '\p{Identifier_Status=:\AAllowed\z:}', "");;
    Expect(0, 201547, '\p{Identifier_Status=:\AAllowed\z:}', "");;
    Expect(1, 201546, '\p{Identifier_Status=allowed}', "");
    Expect(0, 201546, '\p{^Identifier_Status=allowed}', "");
    Expect(0, 201546, '\P{Identifier_Status=allowed}', "");
    Expect(1, 201546, '\P{^Identifier_Status=allowed}', "");
    Expect(0, 201547, '\p{Identifier_Status=allowed}', "");
    Expect(1, 201547, '\p{^Identifier_Status=allowed}', "");
    Expect(1, 201547, '\P{Identifier_Status=allowed}', "");
    Expect(0, 201547, '\P{^Identifier_Status=allowed}', "");
    Expect(1, 201546, '\p{Identifier_Status=:\Aallowed\z:}', "");;
    Expect(0, 201547, '\p{Identifier_Status=:\Aallowed\z:}', "");;
    Expect(1, 201546, '\p{Identifier_Status=	 Allowed}', "");
    Expect(0, 201546, '\p{^Identifier_Status=	 Allowed}', "");
    Expect(0, 201546, '\P{Identifier_Status=	 Allowed}', "");
    Expect(1, 201546, '\P{^Identifier_Status=	 Allowed}', "");
    Expect(0, 201547, '\p{Identifier_Status=	 Allowed}', "");
    Expect(1, 201547, '\p{^Identifier_Status=	 Allowed}', "");
    Expect(1, 201547, '\P{Identifier_Status=	 Allowed}', "");
    Expect(0, 201547, '\P{^Identifier_Status=	 Allowed}', "");
    Error('\p{Is_Identifier_Status=:=	-ALLOWED}');
    Error('\P{Is_Identifier_Status=:=	-ALLOWED}');
    Expect(1, 201546, '\p{Is_Identifier_Status=allowed}', "");
    Expect(0, 201546, '\p{^Is_Identifier_Status=allowed}', "");
    Expect(0, 201546, '\P{Is_Identifier_Status=allowed}', "");
    Expect(1, 201546, '\P{^Is_Identifier_Status=allowed}', "");
    Expect(0, 201547, '\p{Is_Identifier_Status=allowed}', "");
    Expect(1, 201547, '\p{^Is_Identifier_Status=allowed}', "");
    Expect(1, 201547, '\P{Is_Identifier_Status=allowed}', "");
    Expect(0, 201547, '\P{^Is_Identifier_Status=allowed}', "");
    Expect(1, 201546, '\p{Is_Identifier_Status=	-Allowed}', "");
    Expect(0, 201546, '\p{^Is_Identifier_Status=	-Allowed}', "");
    Expect(0, 201546, '\P{Is_Identifier_Status=	-Allowed}', "");
    Expect(1, 201546, '\P{^Is_Identifier_Status=	-Allowed}', "");
    Expect(0, 201547, '\p{Is_Identifier_Status=	-Allowed}', "");
    Expect(1, 201547, '\p{^Is_Identifier_Status=	-Allowed}', "");
    Expect(1, 201547, '\P{Is_Identifier_Status=	-Allowed}', "");
    Expect(0, 201547, '\P{^Is_Identifier_Status=	-Allowed}', "");
    Error('\p{Identifier_Status=--Restricted:=}');
    Error('\P{Identifier_Status=--Restricted:=}');
    Expect(1, 201547, '\p{Identifier_Status=:\ARestricted\z:}', "");;
    Expect(0, 201546, '\p{Identifier_Status=:\ARestricted\z:}', "");;
    Expect(1, 201547, '\p{Identifier_Status=restricted}', "");
    Expect(0, 201547, '\p{^Identifier_Status=restricted}', "");
    Expect(0, 201547, '\P{Identifier_Status=restricted}', "");
    Expect(1, 201547, '\P{^Identifier_Status=restricted}', "");
    Expect(0, 201546, '\p{Identifier_Status=restricted}', "");
    Expect(1, 201546, '\p{^Identifier_Status=restricted}', "");
    Expect(1, 201546, '\P{Identifier_Status=restricted}', "");
    Expect(0, 201546, '\P{^Identifier_Status=restricted}', "");
    Expect(1, 201547, '\p{Identifier_Status=:\Arestricted\z:}', "");;
    Expect(0, 201546, '\p{Identifier_Status=:\Arestricted\z:}', "");;
    Expect(1, 201547, '\p{Identifier_Status=Restricted}', "");
    Expect(0, 201547, '\p{^Identifier_Status=Restricted}', "");
    Expect(0, 201547, '\P{Identifier_Status=Restricted}', "");
    Expect(1, 201547, '\P{^Identifier_Status=Restricted}', "");
    Expect(0, 201546, '\p{Identifier_Status=Restricted}', "");
    Expect(1, 201546, '\p{^Identifier_Status=Restricted}', "");
    Expect(1, 201546, '\P{Identifier_Status=Restricted}', "");
    Expect(0, 201546, '\P{^Identifier_Status=Restricted}', "");
    Error('\p{Is_Identifier_Status=:=Restricted}');
    Error('\P{Is_Identifier_Status=:=Restricted}');
    Expect(1, 201547, '\p{Is_Identifier_Status=restricted}', "");
    Expect(0, 201547, '\p{^Is_Identifier_Status=restricted}', "");
    Expect(0, 201547, '\P{Is_Identifier_Status=restricted}', "");
    Expect(1, 201547, '\P{^Is_Identifier_Status=restricted}', "");
    Expect(0, 201546, '\p{Is_Identifier_Status=restricted}', "");
    Expect(1, 201546, '\p{^Is_Identifier_Status=restricted}', "");
    Expect(1, 201546, '\P{Is_Identifier_Status=restricted}', "");
    Expect(0, 201546, '\P{^Is_Identifier_Status=restricted}', "");
    Expect(1, 201547, '\p{Is_Identifier_Status=--RESTRICTED}', "");
    Expect(0, 201547, '\p{^Is_Identifier_Status=--RESTRICTED}', "");
    Expect(0, 201547, '\P{Is_Identifier_Status=--RESTRICTED}', "");
    Expect(1, 201547, '\P{^Is_Identifier_Status=--RESTRICTED}', "");
    Expect(0, 201546, '\p{Is_Identifier_Status=--RESTRICTED}', "");
    Expect(1, 201546, '\p{^Is_Identifier_Status=--RESTRICTED}', "");
    Expect(1, 201546, '\P{Is_Identifier_Status=--RESTRICTED}', "");
    Expect(0, 201546, '\P{^Is_Identifier_Status=--RESTRICTED}', "");
    Error('\p{identifiertype}');
    Error('\P{identifiertype}');
    Error('\p{Identifier_Type=-default_ignorable:=}');
    Error('\P{Identifier_Type=-default_ignorable:=}');
    Expect(1, 917999, '\p{Identifier_Type=:\ADefault_Ignorable\z:}', "");;
    Expect(0, 918000, '\p{Identifier_Type=:\ADefault_Ignorable\z:}', "");;
    Expect(1, 917999, '\p{Identifier_Type: defaultignorable}', "");
    Expect(0, 917999, '\p{^Identifier_Type: defaultignorable}', "");
    Expect(0, 917999, '\P{Identifier_Type: defaultignorable}', "");
    Expect(1, 917999, '\P{^Identifier_Type: defaultignorable}', "");
    Expect(0, 918000, '\p{Identifier_Type: defaultignorable}', "");
    Expect(1, 918000, '\p{^Identifier_Type: defaultignorable}', "");
    Expect(1, 918000, '\P{Identifier_Type: defaultignorable}', "");
    Expect(0, 918000, '\P{^Identifier_Type: defaultignorable}', "");
    Expect(1, 917999, '\p{Identifier_Type=:\Adefaultignorable\z:}', "");;
    Expect(0, 918000, '\p{Identifier_Type=:\Adefaultignorable\z:}', "");;
    Expect(1, 917999, '\p{Identifier_Type:-DEFAULT_IGNORABLE}', "");
    Expect(0, 917999, '\p{^Identifier_Type:-DEFAULT_IGNORABLE}', "");
    Expect(0, 917999, '\P{Identifier_Type:-DEFAULT_IGNORABLE}', "");
    Expect(1, 917999, '\P{^Identifier_Type:-DEFAULT_IGNORABLE}', "");
    Expect(0, 918000, '\p{Identifier_Type:-DEFAULT_IGNORABLE}', "");
    Expect(1, 918000, '\p{^Identifier_Type:-DEFAULT_IGNORABLE}', "");
    Expect(1, 918000, '\P{Identifier_Type:-DEFAULT_IGNORABLE}', "");
    Expect(0, 918000, '\P{^Identifier_Type:-DEFAULT_IGNORABLE}', "");
    Error('\p{Is_Identifier_Type=_	DEFAULT_ignorable:=}');
    Error('\P{Is_Identifier_Type=_	DEFAULT_ignorable:=}');
    Expect(1, 917999, '\p{Is_Identifier_Type=defaultignorable}', "");
    Expect(0, 917999, '\p{^Is_Identifier_Type=defaultignorable}', "");
    Expect(0, 917999, '\P{Is_Identifier_Type=defaultignorable}', "");
    Expect(1, 917999, '\P{^Is_Identifier_Type=defaultignorable}', "");
    Expect(0, 918000, '\p{Is_Identifier_Type=defaultignorable}', "");
    Expect(1, 918000, '\p{^Is_Identifier_Type=defaultignorable}', "");
    Expect(1, 918000, '\P{Is_Identifier_Type=defaultignorable}', "");
    Expect(0, 918000, '\P{^Is_Identifier_Type=defaultignorable}', "");
    Expect(1, 917999, '\p{Is_Identifier_Type= -Default_Ignorable}', "");
    Expect(0, 917999, '\p{^Is_Identifier_Type= -Default_Ignorable}', "");
    Expect(0, 917999, '\P{Is_Identifier_Type= -Default_Ignorable}', "");
    Expect(1, 917999, '\P{^Is_Identifier_Type= -Default_Ignorable}', "");
    Expect(0, 918000, '\p{Is_Identifier_Type= -Default_Ignorable}', "");
    Expect(1, 918000, '\p{^Is_Identifier_Type= -Default_Ignorable}', "");
    Expect(1, 918000, '\P{Is_Identifier_Type= -Default_Ignorable}', "");
    Expect(0, 918000, '\P{^Is_Identifier_Type= -Default_Ignorable}', "");
    Error('\p{Identifier_Type=_Deprecated/a/}');
    Error('\P{Identifier_Type=_Deprecated/a/}');
    Expect(1, 917505, '\p{Identifier_Type=:\ADeprecated\z:}', "");;
    Expect(0, 917506, '\p{Identifier_Type=:\ADeprecated\z:}', "");;
    Expect(1, 917505, '\p{Identifier_Type=deprecated}', "");
    Expect(0, 917505, '\p{^Identifier_Type=deprecated}', "");
    Expect(0, 917505, '\P{Identifier_Type=deprecated}', "");
    Expect(1, 917505, '\P{^Identifier_Type=deprecated}', "");
    Expect(0, 917506, '\p{Identifier_Type=deprecated}', "");
    Expect(1, 917506, '\p{^Identifier_Type=deprecated}', "");
    Expect(1, 917506, '\P{Identifier_Type=deprecated}', "");
    Expect(0, 917506, '\P{^Identifier_Type=deprecated}', "");
    Expect(1, 917505, '\p{Identifier_Type=:\Adeprecated\z:}', "");;
    Expect(0, 917506, '\p{Identifier_Type=:\Adeprecated\z:}', "");;
    Expect(1, 917505, '\p{Identifier_Type=_Deprecated}', "");
    Expect(0, 917505, '\p{^Identifier_Type=_Deprecated}', "");
    Expect(0, 917505, '\P{Identifier_Type=_Deprecated}', "");
    Expect(1, 917505, '\P{^Identifier_Type=_Deprecated}', "");
    Expect(0, 917506, '\p{Identifier_Type=_Deprecated}', "");
    Expect(1, 917506, '\p{^Identifier_Type=_Deprecated}', "");
    Expect(1, 917506, '\P{Identifier_Type=_Deprecated}', "");
    Expect(0, 917506, '\P{^Identifier_Type=_Deprecated}', "");
    Error('\p{Is_Identifier_Type=:=--deprecated}');
    Error('\P{Is_Identifier_Type=:=--deprecated}');
    Expect(1, 917505, '\p{Is_Identifier_Type=deprecated}', "");
    Expect(0, 917505, '\p{^Is_Identifier_Type=deprecated}', "");
    Expect(0, 917505, '\P{Is_Identifier_Type=deprecated}', "");
    Expect(1, 917505, '\P{^Is_Identifier_Type=deprecated}', "");
    Expect(0, 917506, '\p{Is_Identifier_Type=deprecated}', "");
    Expect(1, 917506, '\p{^Is_Identifier_Type=deprecated}', "");
    Expect(1, 917506, '\P{Is_Identifier_Type=deprecated}', "");
    Expect(0, 917506, '\P{^Is_Identifier_Type=deprecated}', "");
    Expect(1, 917505, '\p{Is_Identifier_Type=- Deprecated}', "");
    Expect(0, 917505, '\p{^Is_Identifier_Type=- Deprecated}', "");
    Expect(0, 917505, '\P{Is_Identifier_Type=- Deprecated}', "");
    Expect(1, 917505, '\P{^Is_Identifier_Type=- Deprecated}', "");
    Expect(0, 917506, '\p{Is_Identifier_Type=- Deprecated}', "");
    Expect(1, 917506, '\p{^Is_Identifier_Type=- Deprecated}', "");
    Expect(1, 917506, '\P{Is_Identifier_Type=- Deprecated}', "");
    Expect(0, 917506, '\P{^Is_Identifier_Type=- Deprecated}', "");
    Error('\p{Identifier_Type=	 EXCLUSION:=}');
    Error('\P{Identifier_Type=	 EXCLUSION:=}');
    Expect(1, 125142, '\p{Identifier_Type=:\AExclusion\z:}', "");;
    Expect(0, 125143, '\p{Identifier_Type=:\AExclusion\z:}', "");;
    Expect(1, 125142, '\p{Identifier_Type=exclusion}', "");
    Expect(0, 125142, '\p{^Identifier_Type=exclusion}', "");
    Expect(0, 125142, '\P{Identifier_Type=exclusion}', "");
    Expect(1, 125142, '\P{^Identifier_Type=exclusion}', "");
    Expect(0, 125143, '\p{Identifier_Type=exclusion}', "");
    Expect(1, 125143, '\p{^Identifier_Type=exclusion}', "");
    Expect(1, 125143, '\P{Identifier_Type=exclusion}', "");
    Expect(0, 125143, '\P{^Identifier_Type=exclusion}', "");
    Expect(1, 125142, '\p{Identifier_Type=:\Aexclusion\z:}', "");;
    Expect(0, 125143, '\p{Identifier_Type=:\Aexclusion\z:}', "");;
    Expect(1, 125142, '\p{Identifier_Type=-	Exclusion}', "");
    Expect(0, 125142, '\p{^Identifier_Type=-	Exclusion}', "");
    Expect(0, 125142, '\P{Identifier_Type=-	Exclusion}', "");
    Expect(1, 125142, '\P{^Identifier_Type=-	Exclusion}', "");
    Expect(0, 125143, '\p{Identifier_Type=-	Exclusion}', "");
    Expect(1, 125143, '\p{^Identifier_Type=-	Exclusion}', "");
    Expect(1, 125143, '\P{Identifier_Type=-	Exclusion}', "");
    Expect(0, 125143, '\P{^Identifier_Type=-	Exclusion}', "");
    Error('\p{Is_Identifier_Type=/a/-_exclusion}');
    Error('\P{Is_Identifier_Type=/a/-_exclusion}');
    Expect(1, 125142, '\p{Is_Identifier_Type=exclusion}', "");
    Expect(0, 125142, '\p{^Is_Identifier_Type=exclusion}', "");
    Expect(0, 125142, '\P{Is_Identifier_Type=exclusion}', "");
    Expect(1, 125142, '\P{^Is_Identifier_Type=exclusion}', "");
    Expect(0, 125143, '\p{Is_Identifier_Type=exclusion}', "");
    Expect(1, 125143, '\p{^Is_Identifier_Type=exclusion}', "");
    Expect(1, 125143, '\P{Is_Identifier_Type=exclusion}', "");
    Expect(0, 125143, '\P{^Is_Identifier_Type=exclusion}', "");
    Expect(1, 125142, '\p{Is_Identifier_Type=_ exclusion}', "");
    Expect(0, 125142, '\p{^Is_Identifier_Type=_ exclusion}', "");
    Expect(0, 125142, '\P{Is_Identifier_Type=_ exclusion}', "");
    Expect(1, 125142, '\P{^Is_Identifier_Type=_ exclusion}', "");
    Expect(0, 125143, '\p{Is_Identifier_Type=_ exclusion}', "");
    Expect(1, 125143, '\p{^Is_Identifier_Type=_ exclusion}', "");
    Expect(1, 125143, '\P{Is_Identifier_Type=_ exclusion}', "");
    Expect(0, 125143, '\P{^Is_Identifier_Type=_ exclusion}', "");
    Error('\p{Identifier_Type:  Inclusion/a/}');
    Error('\P{Identifier_Type:  Inclusion/a/}');
    Expect(1, 12539, '\p{Identifier_Type=:\AInclusion\z:}', "");;
    Expect(0, 12540, '\p{Identifier_Type=:\AInclusion\z:}', "");;
    Expect(1, 12539, '\p{Identifier_Type=inclusion}', "");
    Expect(0, 12539, '\p{^Identifier_Type=inclusion}', "");
    Expect(0, 12539, '\P{Identifier_Type=inclusion}', "");
    Expect(1, 12539, '\P{^Identifier_Type=inclusion}', "");
    Expect(0, 12540, '\p{Identifier_Type=inclusion}', "");
    Expect(1, 12540, '\p{^Identifier_Type=inclusion}', "");
    Expect(1, 12540, '\P{Identifier_Type=inclusion}', "");
    Expect(0, 12540, '\P{^Identifier_Type=inclusion}', "");
    Expect(1, 12539, '\p{Identifier_Type=:\Ainclusion\z:}', "");;
    Expect(0, 12540, '\p{Identifier_Type=:\Ainclusion\z:}', "");;
    Expect(1, 12539, '\p{Identifier_Type= inclusion}', "");
    Expect(0, 12539, '\p{^Identifier_Type= inclusion}', "");
    Expect(0, 12539, '\P{Identifier_Type= inclusion}', "");
    Expect(1, 12539, '\P{^Identifier_Type= inclusion}', "");
    Expect(0, 12540, '\p{Identifier_Type= inclusion}', "");
    Expect(1, 12540, '\p{^Identifier_Type= inclusion}', "");
    Expect(1, 12540, '\P{Identifier_Type= inclusion}', "");
    Expect(0, 12540, '\P{^Identifier_Type= inclusion}', "");
    Error('\p{Is_Identifier_Type:INCLUSION/a/}');
    Error('\P{Is_Identifier_Type:INCLUSION/a/}');
    Expect(1, 12539, '\p{Is_Identifier_Type=inclusion}', "");
    Expect(0, 12539, '\p{^Is_Identifier_Type=inclusion}', "");
    Expect(0, 12539, '\P{Is_Identifier_Type=inclusion}', "");
    Expect(1, 12539, '\P{^Is_Identifier_Type=inclusion}', "");
    Expect(0, 12540, '\p{Is_Identifier_Type=inclusion}', "");
    Expect(1, 12540, '\p{^Is_Identifier_Type=inclusion}', "");
    Expect(1, 12540, '\P{Is_Identifier_Type=inclusion}', "");
    Expect(0, 12540, '\P{^Is_Identifier_Type=inclusion}', "");
    Expect(1, 12539, '\p{Is_Identifier_Type: _Inclusion}', "");
    Expect(0, 12539, '\p{^Is_Identifier_Type: _Inclusion}', "");
    Expect(0, 12539, '\P{Is_Identifier_Type: _Inclusion}', "");
    Expect(1, 12539, '\P{^Is_Identifier_Type: _Inclusion}', "");
    Expect(0, 12540, '\p{Is_Identifier_Type: _Inclusion}', "");
    Expect(1, 12540, '\p{^Is_Identifier_Type: _Inclusion}', "");
    Expect(1, 12540, '\P{Is_Identifier_Type: _Inclusion}', "");
    Expect(0, 12540, '\P{^Is_Identifier_Type: _Inclusion}', "");
    Error('\p{Identifier_Type=-/a/Limited_use}');
    Error('\P{Identifier_Type=-/a/Limited_use}');
    Expect(1, 125279, '\p{Identifier_Type=:\ALimited_Use\z:}', "");;
    Expect(0, 125280, '\p{Identifier_Type=:\ALimited_Use\z:}', "");;
    Expect(1, 125279, '\p{Identifier_Type=limiteduse}', "");
    Expect(0, 125279, '\p{^Identifier_Type=limiteduse}', "");
    Expect(0, 125279, '\P{Identifier_Type=limiteduse}', "");
    Expect(1, 125279, '\P{^Identifier_Type=limiteduse}', "");
    Expect(0, 125280, '\p{Identifier_Type=limiteduse}', "");
    Expect(1, 125280, '\p{^Identifier_Type=limiteduse}', "");
    Expect(1, 125280, '\P{Identifier_Type=limiteduse}', "");
    Expect(0, 125280, '\P{^Identifier_Type=limiteduse}', "");
    Expect(1, 125279, '\p{Identifier_Type=:\Alimiteduse\z:}', "");;
    Expect(0, 125280, '\p{Identifier_Type=:\Alimiteduse\z:}', "");;
    Expect(1, 125279, '\p{Identifier_Type:	_-limited_use}', "");
    Expect(0, 125279, '\p{^Identifier_Type:	_-limited_use}', "");
    Expect(0, 125279, '\P{Identifier_Type:	_-limited_use}', "");
    Expect(1, 125279, '\P{^Identifier_Type:	_-limited_use}', "");
    Expect(0, 125280, '\p{Identifier_Type:	_-limited_use}', "");
    Expect(1, 125280, '\p{^Identifier_Type:	_-limited_use}', "");
    Expect(1, 125280, '\P{Identifier_Type:	_-limited_use}', "");
    Expect(0, 125280, '\P{^Identifier_Type:	_-limited_use}', "");
    Error('\p{Is_Identifier_Type=/a/ -limited_Use}');
    Error('\P{Is_Identifier_Type=/a/ -limited_Use}');
    Expect(1, 125279, '\p{Is_Identifier_Type=limiteduse}', "");
    Expect(0, 125279, '\p{^Is_Identifier_Type=limiteduse}', "");
    Expect(0, 125279, '\P{Is_Identifier_Type=limiteduse}', "");
    Expect(1, 125279, '\P{^Is_Identifier_Type=limiteduse}', "");
    Expect(0, 125280, '\p{Is_Identifier_Type=limiteduse}', "");
    Expect(1, 125280, '\p{^Is_Identifier_Type=limiteduse}', "");
    Expect(1, 125280, '\P{Is_Identifier_Type=limiteduse}', "");
    Expect(0, 125280, '\P{^Is_Identifier_Type=limiteduse}', "");
    Expect(1, 125279, '\p{Is_Identifier_Type= Limited_Use}', "");
    Expect(0, 125279, '\p{^Is_Identifier_Type= Limited_Use}', "");
    Expect(0, 125279, '\P{Is_Identifier_Type= Limited_Use}', "");
    Expect(1, 125279, '\P{^Is_Identifier_Type= Limited_Use}', "");
    Expect(0, 125280, '\p{Is_Identifier_Type= Limited_Use}', "");
    Expect(1, 125280, '\p{^Is_Identifier_Type= Limited_Use}', "");
    Expect(1, 125280, '\P{Is_Identifier_Type= Limited_Use}', "");
    Expect(0, 125280, '\P{^Is_Identifier_Type= Limited_Use}', "");
    Error('\p{Identifier_Type=/a/-not_CHARACTER}');
    Error('\P{Identifier_Type=/a/-not_CHARACTER}');
    Expect(1, 918000, '\p{Identifier_Type=:\ANot_Character\z:}', "");;
    Expect(0, 917999, '\p{Identifier_Type=:\ANot_Character\z:}', "");;
    Expect(1, 918000, '\p{Identifier_Type:   notcharacter}', "");
    Expect(0, 918000, '\p{^Identifier_Type:   notcharacter}', "");
    Expect(0, 918000, '\P{Identifier_Type:   notcharacter}', "");
    Expect(1, 918000, '\P{^Identifier_Type:   notcharacter}', "");
    Expect(0, 917999, '\p{Identifier_Type:   notcharacter}', "");
    Expect(1, 917999, '\p{^Identifier_Type:   notcharacter}', "");
    Expect(1, 917999, '\P{Identifier_Type:   notcharacter}', "");
    Expect(0, 917999, '\P{^Identifier_Type:   notcharacter}', "");
    Expect(1, 918000, '\p{Identifier_Type=:\Anotcharacter\z:}', "");;
    Expect(0, 917999, '\p{Identifier_Type=:\Anotcharacter\z:}', "");;
    Expect(1, 918000, '\p{Identifier_Type=	NOT_Character}', "");
    Expect(0, 918000, '\p{^Identifier_Type=	NOT_Character}', "");
    Expect(0, 918000, '\P{Identifier_Type=	NOT_Character}', "");
    Expect(1, 918000, '\P{^Identifier_Type=	NOT_Character}', "");
    Expect(0, 917999, '\p{Identifier_Type=	NOT_Character}', "");
    Expect(1, 917999, '\p{^Identifier_Type=	NOT_Character}', "");
    Expect(1, 917999, '\P{Identifier_Type=	NOT_Character}', "");
    Expect(0, 917999, '\P{^Identifier_Type=	NOT_Character}', "");
    Error('\p{Is_Identifier_Type=/a/ _not_Character}');
    Error('\P{Is_Identifier_Type=/a/ _not_Character}');
    Expect(1, 918000, '\p{Is_Identifier_Type=notcharacter}', "");
    Expect(0, 918000, '\p{^Is_Identifier_Type=notcharacter}', "");
    Expect(0, 918000, '\P{Is_Identifier_Type=notcharacter}', "");
    Expect(1, 918000, '\P{^Is_Identifier_Type=notcharacter}', "");
    Expect(0, 917999, '\p{Is_Identifier_Type=notcharacter}', "");
    Expect(1, 917999, '\p{^Is_Identifier_Type=notcharacter}', "");
    Expect(1, 917999, '\P{Is_Identifier_Type=notcharacter}', "");
    Expect(0, 917999, '\P{^Is_Identifier_Type=notcharacter}', "");
    Expect(1, 918000, '\p{Is_Identifier_Type=	 Not_character}', "");
    Expect(0, 918000, '\p{^Is_Identifier_Type=	 Not_character}', "");
    Expect(0, 918000, '\P{Is_Identifier_Type=	 Not_character}', "");
    Expect(1, 918000, '\P{^Is_Identifier_Type=	 Not_character}', "");
    Expect(0, 917999, '\p{Is_Identifier_Type=	 Not_character}', "");
    Expect(1, 917999, '\p{^Is_Identifier_Type=	 Not_character}', "");
    Expect(1, 917999, '\P{Is_Identifier_Type=	 Not_character}', "");
    Expect(0, 917999, '\P{^Is_Identifier_Type=	 Not_character}', "");
    Error('\p{Identifier_Type=-/a/NOT_NFKC}');
    Error('\P{Identifier_Type=-/a/NOT_NFKC}');
    Expect(1, 195101, '\p{Identifier_Type=:\ANot_NFKC\z:}', "");;
    Expect(0, 195102, '\p{Identifier_Type=:\ANot_NFKC\z:}', "");;
    Expect(1, 195101, '\p{Identifier_Type=notnfkc}', "");
    Expect(0, 195101, '\p{^Identifier_Type=notnfkc}', "");
    Expect(0, 195101, '\P{Identifier_Type=notnfkc}', "");
    Expect(1, 195101, '\P{^Identifier_Type=notnfkc}', "");
    Expect(0, 195102, '\p{Identifier_Type=notnfkc}', "");
    Expect(1, 195102, '\p{^Identifier_Type=notnfkc}', "");
    Expect(1, 195102, '\P{Identifier_Type=notnfkc}', "");
    Expect(0, 195102, '\P{^Identifier_Type=notnfkc}', "");
    Expect(1, 195101, '\p{Identifier_Type=:\Anotnfkc\z:}', "");;
    Expect(0, 195102, '\p{Identifier_Type=:\Anotnfkc\z:}', "");;
    Expect(1, 195101, '\p{Identifier_Type=_	not_NFKC}', "");
    Expect(0, 195101, '\p{^Identifier_Type=_	not_NFKC}', "");
    Expect(0, 195101, '\P{Identifier_Type=_	not_NFKC}', "");
    Expect(1, 195101, '\P{^Identifier_Type=_	not_NFKC}', "");
    Expect(0, 195102, '\p{Identifier_Type=_	not_NFKC}', "");
    Expect(1, 195102, '\p{^Identifier_Type=_	not_NFKC}', "");
    Expect(1, 195102, '\P{Identifier_Type=_	not_NFKC}', "");
    Expect(0, 195102, '\P{^Identifier_Type=_	not_NFKC}', "");
    Error('\p{Is_Identifier_Type=/a/ -NOT_NFKC}');
    Error('\P{Is_Identifier_Type=/a/ -NOT_NFKC}');
    Expect(1, 195101, '\p{Is_Identifier_Type=notnfkc}', "");
    Expect(0, 195101, '\p{^Is_Identifier_Type=notnfkc}', "");
    Expect(0, 195101, '\P{Is_Identifier_Type=notnfkc}', "");
    Expect(1, 195101, '\P{^Is_Identifier_Type=notnfkc}', "");
    Expect(0, 195102, '\p{Is_Identifier_Type=notnfkc}', "");
    Expect(1, 195102, '\p{^Is_Identifier_Type=notnfkc}', "");
    Expect(1, 195102, '\P{Is_Identifier_Type=notnfkc}', "");
    Expect(0, 195102, '\P{^Is_Identifier_Type=notnfkc}', "");
    Expect(1, 195101, '\p{Is_Identifier_Type:   		NOT_NFKC}', "");
    Expect(0, 195101, '\p{^Is_Identifier_Type:   		NOT_NFKC}', "");
    Expect(0, 195101, '\P{Is_Identifier_Type:   		NOT_NFKC}', "");
    Expect(1, 195101, '\P{^Is_Identifier_Type:   		NOT_NFKC}', "");
    Expect(0, 195102, '\p{Is_Identifier_Type:   		NOT_NFKC}', "");
    Expect(1, 195102, '\p{^Is_Identifier_Type:   		NOT_NFKC}', "");
    Expect(1, 195102, '\P{Is_Identifier_Type:   		NOT_NFKC}', "");
    Expect(0, 195102, '\P{^Is_Identifier_Type:   		NOT_NFKC}', "");
    Error('\p{Identifier_Type=:=-Not_XID}');
    Error('\P{Identifier_Type=:=-Not_XID}');
    Expect(1, 129994, '\p{Identifier_Type=:\ANot_XID\z:}', "");;
    Expect(0, 129995, '\p{Identifier_Type=:\ANot_XID\z:}', "");;
    Expect(1, 129994, '\p{Identifier_Type=notxid}', "");
    Expect(0, 129994, '\p{^Identifier_Type=notxid}', "");
    Expect(0, 129994, '\P{Identifier_Type=notxid}', "");
    Expect(1, 129994, '\P{^Identifier_Type=notxid}', "");
    Expect(0, 129995, '\p{Identifier_Type=notxid}', "");
    Expect(1, 129995, '\p{^Identifier_Type=notxid}', "");
    Expect(1, 129995, '\P{Identifier_Type=notxid}', "");
    Expect(0, 129995, '\P{^Identifier_Type=notxid}', "");
    Expect(1, 129994, '\p{Identifier_Type=:\Anotxid\z:}', "");;
    Expect(0, 129995, '\p{Identifier_Type=:\Anotxid\z:}', "");;
    Expect(1, 129994, '\p{Identifier_Type=__not_XID}', "");
    Expect(0, 129994, '\p{^Identifier_Type=__not_XID}', "");
    Expect(0, 129994, '\P{Identifier_Type=__not_XID}', "");
    Expect(1, 129994, '\P{^Identifier_Type=__not_XID}', "");
    Expect(0, 129995, '\p{Identifier_Type=__not_XID}', "");
    Expect(1, 129995, '\p{^Identifier_Type=__not_XID}', "");
    Expect(1, 129995, '\P{Identifier_Type=__not_XID}', "");
    Expect(0, 129995, '\P{^Identifier_Type=__not_XID}', "");
    Error('\p{Is_Identifier_Type=-:=Not_XID}');
    Error('\P{Is_Identifier_Type=-:=Not_XID}');
    Expect(1, 129994, '\p{Is_Identifier_Type=notxid}', "");
    Expect(0, 129994, '\p{^Is_Identifier_Type=notxid}', "");
    Expect(0, 129994, '\P{Is_Identifier_Type=notxid}', "");
    Expect(1, 129994, '\P{^Is_Identifier_Type=notxid}', "");
    Expect(0, 129995, '\p{Is_Identifier_Type=notxid}', "");
    Expect(1, 129995, '\p{^Is_Identifier_Type=notxid}', "");
    Expect(1, 129995, '\P{Is_Identifier_Type=notxid}', "");
    Expect(0, 129995, '\P{^Is_Identifier_Type=notxid}', "");
    Expect(1, 129994, '\p{Is_Identifier_Type= -Not_XID}', "");
    Expect(0, 129994, '\p{^Is_Identifier_Type= -Not_XID}', "");
    Expect(0, 129994, '\P{Is_Identifier_Type= -Not_XID}', "");
    Expect(1, 129994, '\P{^Is_Identifier_Type= -Not_XID}', "");
    Expect(0, 129995, '\p{Is_Identifier_Type= -Not_XID}', "");
    Expect(1, 129995, '\p{^Is_Identifier_Type= -Not_XID}', "");
    Expect(1, 129995, '\P{Is_Identifier_Type= -Not_XID}', "");
    Expect(0, 129995, '\P{^Is_Identifier_Type= -Not_XID}', "");
    Error('\p{Identifier_Type=:=--Obsolete}');
    Error('\P{Identifier_Type=:=--Obsolete}');
    Expect(1, 119365, '\p{Identifier_Type=:\AObsolete\z:}', "");;
    Expect(0, 119366, '\p{Identifier_Type=:\AObsolete\z:}', "");;
    Expect(1, 119365, '\p{Identifier_Type=obsolete}', "");
    Expect(0, 119365, '\p{^Identifier_Type=obsolete}', "");
    Expect(0, 119365, '\P{Identifier_Type=obsolete}', "");
    Expect(1, 119365, '\P{^Identifier_Type=obsolete}', "");
    Expect(0, 119366, '\p{Identifier_Type=obsolete}', "");
    Expect(1, 119366, '\p{^Identifier_Type=obsolete}', "");
    Expect(1, 119366, '\P{Identifier_Type=obsolete}', "");
    Expect(0, 119366, '\P{^Identifier_Type=obsolete}', "");
    Expect(1, 119365, '\p{Identifier_Type=:\Aobsolete\z:}', "");;
    Expect(0, 119366, '\p{Identifier_Type=:\Aobsolete\z:}', "");;
    Expect(1, 119365, '\p{Identifier_Type=-obsolete}', "");
    Expect(0, 119365, '\p{^Identifier_Type=-obsolete}', "");
    Expect(0, 119365, '\P{Identifier_Type=-obsolete}', "");
    Expect(1, 119365, '\P{^Identifier_Type=-obsolete}', "");
    Expect(0, 119366, '\p{Identifier_Type=-obsolete}', "");
    Expect(1, 119366, '\p{^Identifier_Type=-obsolete}', "");
    Expect(1, 119366, '\P{Identifier_Type=-obsolete}', "");
    Expect(0, 119366, '\P{^Identifier_Type=-obsolete}', "");
    Error('\p{Is_Identifier_Type:    /a/obsolete}');
    Error('\P{Is_Identifier_Type:    /a/obsolete}');
    Expect(1, 119365, '\p{Is_Identifier_Type=obsolete}', "");
    Expect(0, 119365, '\p{^Is_Identifier_Type=obsolete}', "");
    Expect(0, 119365, '\P{Is_Identifier_Type=obsolete}', "");
    Expect(1, 119365, '\P{^Is_Identifier_Type=obsolete}', "");
    Expect(0, 119366, '\p{Is_Identifier_Type=obsolete}', "");
    Expect(1, 119366, '\p{^Is_Identifier_Type=obsolete}', "");
    Expect(1, 119366, '\P{Is_Identifier_Type=obsolete}', "");
    Expect(0, 119366, '\P{^Is_Identifier_Type=obsolete}', "");
    Expect(1, 119365, '\p{Is_Identifier_Type=	OBSOLETE}', "");
    Expect(0, 119365, '\p{^Is_Identifier_Type=	OBSOLETE}', "");
    Expect(0, 119365, '\P{Is_Identifier_Type=	OBSOLETE}', "");
    Expect(1, 119365, '\P{^Is_Identifier_Type=	OBSOLETE}', "");
    Expect(0, 119366, '\p{Is_Identifier_Type=	OBSOLETE}', "");
    Expect(1, 119366, '\p{^Is_Identifier_Type=	OBSOLETE}', "");
    Expect(1, 119366, '\P{Is_Identifier_Type=	OBSOLETE}', "");
    Expect(0, 119366, '\P{^Is_Identifier_Type=	OBSOLETE}', "");
    Error('\p{Identifier_Type= recommended:=}');
    Error('\P{Identifier_Type= recommended:=}');
    Expect(1, 201546, '\p{Identifier_Type=:\ARecommended\z:}', "");;
    Expect(0, 201547, '\p{Identifier_Type=:\ARecommended\z:}', "");;
    Expect(1, 201546, '\p{Identifier_Type=recommended}', "");
    Expect(0, 201546, '\p{^Identifier_Type=recommended}', "");
    Expect(0, 201546, '\P{Identifier_Type=recommended}', "");
    Expect(1, 201546, '\P{^Identifier_Type=recommended}', "");
    Expect(0, 201547, '\p{Identifier_Type=recommended}', "");
    Expect(1, 201547, '\p{^Identifier_Type=recommended}', "");
    Expect(1, 201547, '\P{Identifier_Type=recommended}', "");
    Expect(0, 201547, '\P{^Identifier_Type=recommended}', "");
    Expect(1, 201546, '\p{Identifier_Type=:\Arecommended\z:}', "");;
    Expect(0, 201547, '\p{Identifier_Type=:\Arecommended\z:}', "");;
    Expect(1, 201546, '\p{Identifier_Type= recommended}', "");
    Expect(0, 201546, '\p{^Identifier_Type= recommended}', "");
    Expect(0, 201546, '\P{Identifier_Type= recommended}', "");
    Expect(1, 201546, '\P{^Identifier_Type= recommended}', "");
    Expect(0, 201547, '\p{Identifier_Type= recommended}', "");
    Expect(1, 201547, '\p{^Identifier_Type= recommended}', "");
    Expect(1, 201547, '\P{Identifier_Type= recommended}', "");
    Expect(0, 201547, '\P{^Identifier_Type= recommended}', "");
    Error('\p{Is_Identifier_Type= -Recommended/a/}');
    Error('\P{Is_Identifier_Type= -Recommended/a/}');
    Expect(1, 201546, '\p{Is_Identifier_Type:   recommended}', "");
    Expect(0, 201546, '\p{^Is_Identifier_Type:   recommended}', "");
    Expect(0, 201546, '\P{Is_Identifier_Type:   recommended}', "");
    Expect(1, 201546, '\P{^Is_Identifier_Type:   recommended}', "");
    Expect(0, 201547, '\p{Is_Identifier_Type:   recommended}', "");
    Expect(1, 201547, '\p{^Is_Identifier_Type:   recommended}', "");
    Expect(1, 201547, '\P{Is_Identifier_Type:   recommended}', "");
    Expect(0, 201547, '\P{^Is_Identifier_Type:   recommended}', "");
    Expect(1, 201546, '\p{Is_Identifier_Type= RECOMMENDED}', "");
    Expect(0, 201546, '\p{^Is_Identifier_Type= RECOMMENDED}', "");
    Expect(0, 201546, '\P{Is_Identifier_Type= RECOMMENDED}', "");
    Expect(1, 201546, '\P{^Is_Identifier_Type= RECOMMENDED}', "");
    Expect(0, 201547, '\p{Is_Identifier_Type= RECOMMENDED}', "");
    Expect(1, 201547, '\p{^Is_Identifier_Type= RECOMMENDED}', "");
    Expect(1, 201547, '\P{Is_Identifier_Type= RECOMMENDED}', "");
    Expect(0, 201547, '\P{^Is_Identifier_Type= RECOMMENDED}', "");
    Error('\p{Identifier_Type=:=	technical}');
    Error('\P{Identifier_Type=:=	technical}');
    Expect(1, 119638, '\p{Identifier_Type=:\ATechnical\z:}', "");;
    Expect(0, 119639, '\p{Identifier_Type=:\ATechnical\z:}', "");;
    Expect(1, 119638, '\p{Identifier_Type=technical}', "");
    Expect(0, 119638, '\p{^Identifier_Type=technical}', "");
    Expect(0, 119638, '\P{Identifier_Type=technical}', "");
    Expect(1, 119638, '\P{^Identifier_Type=technical}', "");
    Expect(0, 119639, '\p{Identifier_Type=technical}', "");
    Expect(1, 119639, '\p{^Identifier_Type=technical}', "");
    Expect(1, 119639, '\P{Identifier_Type=technical}', "");
    Expect(0, 119639, '\P{^Identifier_Type=technical}', "");
    Expect(1, 119638, '\p{Identifier_Type=:\Atechnical\z:}', "");;
    Expect(0, 119639, '\p{Identifier_Type=:\Atechnical\z:}', "");;
    Expect(1, 119638, '\p{Identifier_Type=_TECHNICAL}', "");
    Expect(0, 119638, '\p{^Identifier_Type=_TECHNICAL}', "");
    Expect(0, 119638, '\P{Identifier_Type=_TECHNICAL}', "");
    Expect(1, 119638, '\P{^Identifier_Type=_TECHNICAL}', "");
    Expect(0, 119639, '\p{Identifier_Type=_TECHNICAL}', "");
    Expect(1, 119639, '\p{^Identifier_Type=_TECHNICAL}', "");
    Expect(1, 119639, '\P{Identifier_Type=_TECHNICAL}', "");
    Expect(0, 119639, '\P{^Identifier_Type=_TECHNICAL}', "");
    Error('\p{Is_Identifier_Type=	-TECHNICAL:=}');
    Error('\P{Is_Identifier_Type=	-TECHNICAL:=}');
    Expect(1, 119638, '\p{Is_Identifier_Type=technical}', "");
    Expect(0, 119638, '\p{^Is_Identifier_Type=technical}', "");
    Expect(0, 119638, '\P{Is_Identifier_Type=technical}', "");
    Expect(1, 119638, '\P{^Is_Identifier_Type=technical}', "");
    Expect(0, 119639, '\p{Is_Identifier_Type=technical}', "");
    Expect(1, 119639, '\p{^Is_Identifier_Type=technical}', "");
    Expect(1, 119639, '\P{Is_Identifier_Type=technical}', "");
    Expect(0, 119639, '\P{^Is_Identifier_Type=technical}', "");
    Expect(1, 119638, '\p{Is_Identifier_Type=_-technical}', "");
    Expect(0, 119638, '\p{^Is_Identifier_Type=_-technical}', "");
    Expect(0, 119638, '\P{Is_Identifier_Type=_-technical}', "");
    Expect(1, 119638, '\P{^Is_Identifier_Type=_-technical}', "");
    Expect(0, 119639, '\p{Is_Identifier_Type=_-technical}', "");
    Expect(1, 119639, '\p{^Is_Identifier_Type=_-technical}', "");
    Expect(1, 119639, '\P{Is_Identifier_Type=_-technical}', "");
    Expect(0, 119639, '\P{^Is_Identifier_Type=_-technical}', "");
    Error('\p{Identifier_Type=	:=UNCOMMON_USE}');
    Error('\P{Identifier_Type=	:=UNCOMMON_USE}');
    Expect(1, 128335, '\p{Identifier_Type=:\AUncommon_Use\z:}', "");;
    Expect(0, 128336, '\p{Identifier_Type=:\AUncommon_Use\z:}', "");;
    Expect(1, 128335, '\p{Identifier_Type: uncommonuse}', "");
    Expect(0, 128335, '\p{^Identifier_Type: uncommonuse}', "");
    Expect(0, 128335, '\P{Identifier_Type: uncommonuse}', "");
    Expect(1, 128335, '\P{^Identifier_Type: uncommonuse}', "");
    Expect(0, 128336, '\p{Identifier_Type: uncommonuse}', "");
    Expect(1, 128336, '\p{^Identifier_Type: uncommonuse}', "");
    Expect(1, 128336, '\P{Identifier_Type: uncommonuse}', "");
    Expect(0, 128336, '\P{^Identifier_Type: uncommonuse}', "");
    Expect(1, 128335, '\p{Identifier_Type=:\Auncommonuse\z:}', "");;
    Expect(0, 128336, '\p{Identifier_Type=:\Auncommonuse\z:}', "");;
    Expect(1, 128335, '\p{Identifier_Type= Uncommon_use}', "");
    Expect(0, 128335, '\p{^Identifier_Type= Uncommon_use}', "");
    Expect(0, 128335, '\P{Identifier_Type= Uncommon_use}', "");
    Expect(1, 128335, '\P{^Identifier_Type= Uncommon_use}', "");
    Expect(0, 128336, '\p{Identifier_Type= Uncommon_use}', "");
    Expect(1, 128336, '\p{^Identifier_Type= Uncommon_use}', "");
    Expect(1, 128336, '\P{Identifier_Type= Uncommon_use}', "");
    Expect(0, 128336, '\P{^Identifier_Type= Uncommon_use}', "");
    Error('\p{Is_Identifier_Type=:=  Uncommon_use}');
    Error('\P{Is_Identifier_Type=:=  Uncommon_use}');
    Expect(1, 128335, '\p{Is_Identifier_Type=uncommonuse}', "");
    Expect(0, 128335, '\p{^Is_Identifier_Type=uncommonuse}', "");
    Expect(0, 128335, '\P{Is_Identifier_Type=uncommonuse}', "");
    Expect(1, 128335, '\P{^Is_Identifier_Type=uncommonuse}', "");
    Expect(0, 128336, '\p{Is_Identifier_Type=uncommonuse}', "");
    Expect(1, 128336, '\p{^Is_Identifier_Type=uncommonuse}', "");
    Expect(1, 128336, '\P{Is_Identifier_Type=uncommonuse}', "");
    Expect(0, 128336, '\P{^Is_Identifier_Type=uncommonuse}', "");
    Expect(1, 128335, '\p{Is_Identifier_Type=-	Uncommon_Use}', "");
    Expect(0, 128335, '\p{^Is_Identifier_Type=-	Uncommon_Use}', "");
    Expect(0, 128335, '\P{Is_Identifier_Type=-	Uncommon_Use}', "");
    Expect(1, 128335, '\P{^Is_Identifier_Type=-	Uncommon_Use}', "");
    Expect(0, 128336, '\p{Is_Identifier_Type=-	Uncommon_Use}', "");
    Expect(1, 128336, '\p{^Is_Identifier_Type=-	Uncommon_Use}', "");
    Expect(1, 128336, '\P{Is_Identifier_Type=-	Uncommon_Use}', "");
    Expect(0, 128336, '\P{^Is_Identifier_Type=-	Uncommon_Use}', "");
    Error('\p{Ideographic=NO:=}');
    Error('\P{Ideographic=NO:=}');
    Expect(1, 201547, '\p{Ideographic=:\ANo\z:}', "");;
    Expect(0, 201546, '\p{Ideographic=:\ANo\z:}', "");;
    Expect(1, 201547, '\p{Ideographic=no}', "");
    Expect(0, 201547, '\p{^Ideographic=no}', "");
    Expect(0, 201547, '\P{Ideographic=no}', "");
    Expect(1, 201547, '\P{^Ideographic=no}', "");
    Expect(0, 201546, '\p{Ideographic=no}', "");
    Expect(1, 201546, '\p{^Ideographic=no}', "");
    Expect(1, 201546, '\P{Ideographic=no}', "");
    Expect(0, 201546, '\P{^Ideographic=no}', "");
    Expect(1, 201547, '\p{Ideographic=:\Ano\z:}', "");;
    Expect(0, 201546, '\p{Ideographic=:\Ano\z:}', "");;
    Expect(1, 201547, '\p{Ideographic=	_No}', "");
    Expect(0, 201547, '\p{^Ideographic=	_No}', "");
    Expect(0, 201547, '\P{Ideographic=	_No}', "");
    Expect(1, 201547, '\P{^Ideographic=	_No}', "");
    Expect(0, 201546, '\p{Ideographic=	_No}', "");
    Expect(1, 201546, '\p{^Ideographic=	_No}', "");
    Expect(1, 201546, '\P{Ideographic=	_No}', "");
    Expect(0, 201546, '\P{^Ideographic=	_No}', "");
    Error('\p{Ideo=	:=n}');
    Error('\P{Ideo=	:=n}');
    Expect(1, 201547, '\p{Ideo=:\AN\z:}', "");;
    Expect(0, 201546, '\p{Ideo=:\AN\z:}', "");;
    Expect(1, 201547, '\p{Ideo=n}', "");
    Expect(0, 201547, '\p{^Ideo=n}', "");
    Expect(0, 201547, '\P{Ideo=n}', "");
    Expect(1, 201547, '\P{^Ideo=n}', "");
    Expect(0, 201546, '\p{Ideo=n}', "");
    Expect(1, 201546, '\p{^Ideo=n}', "");
    Expect(1, 201546, '\P{Ideo=n}', "");
    Expect(0, 201546, '\P{^Ideo=n}', "");
    Expect(1, 201547, '\p{Ideo=:\An\z:}', "");;
    Expect(0, 201546, '\p{Ideo=:\An\z:}', "");;
    Expect(1, 201547, '\p{Ideo=-	n}', "");
    Expect(0, 201547, '\p{^Ideo=-	n}', "");
    Expect(0, 201547, '\P{Ideo=-	n}', "");
    Expect(1, 201547, '\P{^Ideo=-	n}', "");
    Expect(0, 201546, '\p{Ideo=-	n}', "");
    Expect(1, 201546, '\p{^Ideo=-	n}', "");
    Expect(1, 201546, '\P{Ideo=-	n}', "");
    Expect(0, 201546, '\P{^Ideo=-	n}', "");
    Error('\p{Is_Ideographic=-	F:=}');
    Error('\P{Is_Ideographic=-	F:=}');
    Expect(1, 201547, '\p{Is_Ideographic=f}', "");
    Expect(0, 201547, '\p{^Is_Ideographic=f}', "");
    Expect(0, 201547, '\P{Is_Ideographic=f}', "");
    Expect(1, 201547, '\P{^Is_Ideographic=f}', "");
    Expect(0, 201546, '\p{Is_Ideographic=f}', "");
    Expect(1, 201546, '\p{^Is_Ideographic=f}', "");
    Expect(1, 201546, '\P{Is_Ideographic=f}', "");
    Expect(0, 201546, '\P{^Is_Ideographic=f}', "");
    Expect(1, 201547, '\p{Is_Ideographic= _f}', "");
    Expect(0, 201547, '\p{^Is_Ideographic= _f}', "");
    Expect(0, 201547, '\P{Is_Ideographic= _f}', "");
    Expect(1, 201547, '\P{^Is_Ideographic= _f}', "");
    Expect(0, 201546, '\p{Is_Ideographic= _f}', "");
    Expect(1, 201546, '\p{^Is_Ideographic= _f}', "");
    Expect(1, 201546, '\P{Is_Ideographic= _f}', "");
    Expect(0, 201546, '\P{^Is_Ideographic= _f}', "");
    Error('\p{Is_Ideo=/a/ 	FALSE}');
    Error('\P{Is_Ideo=/a/ 	FALSE}');
    Expect(1, 201547, '\p{Is_Ideo=false}', "");
    Expect(0, 201547, '\p{^Is_Ideo=false}', "");
    Expect(0, 201547, '\P{Is_Ideo=false}', "");
    Expect(1, 201547, '\P{^Is_Ideo=false}', "");
    Expect(0, 201546, '\p{Is_Ideo=false}', "");
    Expect(1, 201546, '\p{^Is_Ideo=false}', "");
    Expect(1, 201546, '\P{Is_Ideo=false}', "");
    Expect(0, 201546, '\P{^Is_Ideo=false}', "");
    Expect(1, 201547, '\p{Is_Ideo=	_False}', "");
    Expect(0, 201547, '\p{^Is_Ideo=	_False}', "");
    Expect(0, 201547, '\P{Is_Ideo=	_False}', "");
    Expect(1, 201547, '\P{^Is_Ideo=	_False}', "");
    Expect(0, 201546, '\p{Is_Ideo=	_False}', "");
    Expect(1, 201546, '\p{^Is_Ideo=	_False}', "");
    Expect(1, 201546, '\P{Is_Ideo=	_False}', "");
    Expect(0, 201546, '\P{^Is_Ideo=	_False}', "");
    Error('\p{Ideographic=_:=Yes}');
    Error('\P{Ideographic=_:=Yes}');
    Expect(1, 201546, '\p{Ideographic=:\AYes\z:}', "");;
    Expect(0, 201547, '\p{Ideographic=:\AYes\z:}', "");;
    Expect(1, 201546, '\p{Ideographic=yes}', "");
    Expect(0, 201546, '\p{^Ideographic=yes}', "");
    Expect(0, 201546, '\P{Ideographic=yes}', "");
    Expect(1, 201546, '\P{^Ideographic=yes}', "");
    Expect(0, 201547, '\p{Ideographic=yes}', "");
    Expect(1, 201547, '\p{^Ideographic=yes}', "");
    Expect(1, 201547, '\P{Ideographic=yes}', "");
    Expect(0, 201547, '\P{^Ideographic=yes}', "");
    Expect(1, 201546, '\p{Ideographic=:\Ayes\z:}', "");;
    Expect(0, 201547, '\p{Ideographic=:\Ayes\z:}', "");;
    Expect(1, 201546, '\p{Ideographic=	 Yes}', "");
    Expect(0, 201546, '\p{^Ideographic=	 Yes}', "");
    Expect(0, 201546, '\P{Ideographic=	 Yes}', "");
    Expect(1, 201546, '\P{^Ideographic=	 Yes}', "");
    Expect(0, 201547, '\p{Ideographic=	 Yes}', "");
    Expect(1, 201547, '\p{^Ideographic=	 Yes}', "");
    Expect(1, 201547, '\P{Ideographic=	 Yes}', "");
    Expect(0, 201547, '\P{^Ideographic=	 Yes}', "");
    Error('\p{Ideo=:=_Y}');
    Error('\P{Ideo=:=_Y}');
    Expect(1, 201546, '\p{Ideo=:\AY\z:}', "");;
    Expect(0, 201547, '\p{Ideo=:\AY\z:}', "");;
    Expect(1, 201546, '\p{Ideo=y}', "");
    Expect(0, 201546, '\p{^Ideo=y}', "");
    Expect(0, 201546, '\P{Ideo=y}', "");
    Expect(1, 201546, '\P{^Ideo=y}', "");
    Expect(0, 201547, '\p{Ideo=y}', "");
    Expect(1, 201547, '\p{^Ideo=y}', "");
    Expect(1, 201547, '\P{Ideo=y}', "");
    Expect(0, 201547, '\P{^Ideo=y}', "");
    Expect(1, 201546, '\p{Ideo=:\Ay\z:}', "");;
    Expect(0, 201547, '\p{Ideo=:\Ay\z:}', "");;
    Expect(1, 201546, '\p{Ideo=_	Y}', "");
    Expect(0, 201546, '\p{^Ideo=_	Y}', "");
    Expect(0, 201546, '\P{Ideo=_	Y}', "");
    Expect(1, 201546, '\P{^Ideo=_	Y}', "");
    Expect(0, 201547, '\p{Ideo=_	Y}', "");
    Expect(1, 201547, '\p{^Ideo=_	Y}', "");
    Expect(1, 201547, '\P{Ideo=_	Y}', "");
    Expect(0, 201547, '\P{^Ideo=_	Y}', "");
    Error('\p{Is_Ideographic=/a/  T}');
    Error('\P{Is_Ideographic=/a/  T}');
    Expect(1, 201546, '\p{Is_Ideographic=t}', "");
    Expect(0, 201546, '\p{^Is_Ideographic=t}', "");
    Expect(0, 201546, '\P{Is_Ideographic=t}', "");
    Expect(1, 201546, '\P{^Is_Ideographic=t}', "");
    Expect(0, 201547, '\p{Is_Ideographic=t}', "");
    Expect(1, 201547, '\p{^Is_Ideographic=t}', "");
    Expect(1, 201547, '\P{Is_Ideographic=t}', "");
    Expect(0, 201547, '\P{^Is_Ideographic=t}', "");
    Expect(1, 201546, '\p{Is_Ideographic:	 -T}', "");
    Expect(0, 201546, '\p{^Is_Ideographic:	 -T}', "");
    Expect(0, 201546, '\P{Is_Ideographic:	 -T}', "");
    Expect(1, 201546, '\P{^Is_Ideographic:	 -T}', "");
    Expect(0, 201547, '\p{Is_Ideographic:	 -T}', "");
    Expect(1, 201547, '\p{^Is_Ideographic:	 -T}', "");
    Expect(1, 201547, '\P{Is_Ideographic:	 -T}', "");
    Expect(0, 201547, '\P{^Is_Ideographic:	 -T}', "");
    Error('\p{Is_Ideo: /a/-_True}');
    Error('\P{Is_Ideo: /a/-_True}');
    Expect(1, 201546, '\p{Is_Ideo=true}', "");
    Expect(0, 201546, '\p{^Is_Ideo=true}', "");
    Expect(0, 201546, '\P{Is_Ideo=true}', "");
    Expect(1, 201546, '\P{^Is_Ideo=true}', "");
    Expect(0, 201547, '\p{Is_Ideo=true}', "");
    Expect(1, 201547, '\p{^Is_Ideo=true}', "");
    Expect(1, 201547, '\P{Is_Ideo=true}', "");
    Expect(0, 201547, '\P{^Is_Ideo=true}', "");
    Expect(1, 201546, '\p{Is_Ideo: -TRUE}', "");
    Expect(0, 201546, '\p{^Is_Ideo: -TRUE}', "");
    Expect(0, 201546, '\P{Is_Ideo: -TRUE}', "");
    Expect(1, 201546, '\P{^Is_Ideo: -TRUE}', "");
    Expect(0, 201547, '\p{Is_Ideo: -TRUE}', "");
    Expect(1, 201547, '\p{^Is_Ideo: -TRUE}', "");
    Expect(1, 201547, '\P{Is_Ideo: -TRUE}', "");
    Expect(0, 201547, '\P{^Is_Ideo: -TRUE}', "");
    Error('\p{ID_Start::=_ NO}');
    Error('\P{ID_Start::=_ NO}');
    Expect(1, 201547, '\p{ID_Start=:\ANo\z:}', "");;
    Expect(0, 201546, '\p{ID_Start=:\ANo\z:}', "");;
    Expect(1, 201547, '\p{ID_Start=no}', "");
    Expect(0, 201547, '\p{^ID_Start=no}', "");
    Expect(0, 201547, '\P{ID_Start=no}', "");
    Expect(1, 201547, '\P{^ID_Start=no}', "");
    Expect(0, 201546, '\p{ID_Start=no}', "");
    Expect(1, 201546, '\p{^ID_Start=no}', "");
    Expect(1, 201546, '\P{ID_Start=no}', "");
    Expect(0, 201546, '\P{^ID_Start=no}', "");
    Expect(1, 201547, '\p{ID_Start=:\Ano\z:}', "");;
    Expect(0, 201546, '\p{ID_Start=:\Ano\z:}', "");;
    Expect(1, 201547, '\p{ID_Start= 	No}', "");
    Expect(0, 201547, '\p{^ID_Start= 	No}', "");
    Expect(0, 201547, '\P{ID_Start= 	No}', "");
    Expect(1, 201547, '\P{^ID_Start= 	No}', "");
    Expect(0, 201546, '\p{ID_Start= 	No}', "");
    Expect(1, 201546, '\p{^ID_Start= 	No}', "");
    Expect(1, 201546, '\P{ID_Start= 	No}', "");
    Expect(0, 201546, '\P{^ID_Start= 	No}', "");
    Error('\p{IDS= :=N}');
    Error('\P{IDS= :=N}');
    Expect(1, 201547, '\p{IDS=:\AN\z:}', "");;
    Expect(0, 201546, '\p{IDS=:\AN\z:}', "");;
    Expect(1, 201547, '\p{IDS=n}', "");
    Expect(0, 201547, '\p{^IDS=n}', "");
    Expect(0, 201547, '\P{IDS=n}', "");
    Expect(1, 201547, '\P{^IDS=n}', "");
    Expect(0, 201546, '\p{IDS=n}', "");
    Expect(1, 201546, '\p{^IDS=n}', "");
    Expect(1, 201546, '\P{IDS=n}', "");
    Expect(0, 201546, '\P{^IDS=n}', "");
    Expect(1, 201547, '\p{IDS=:\An\z:}', "");;
    Expect(0, 201546, '\p{IDS=:\An\z:}', "");;
    Expect(1, 201547, '\p{IDS=-N}', "");
    Expect(0, 201547, '\p{^IDS=-N}', "");
    Expect(0, 201547, '\P{IDS=-N}', "");
    Expect(1, 201547, '\P{^IDS=-N}', "");
    Expect(0, 201546, '\p{IDS=-N}', "");
    Expect(1, 201546, '\p{^IDS=-N}', "");
    Expect(1, 201546, '\P{IDS=-N}', "");
    Expect(0, 201546, '\P{^IDS=-N}', "");
    Error('\p{Is_ID_Start=--f:=}');
    Error('\P{Is_ID_Start=--f:=}');
    Expect(1, 201547, '\p{Is_ID_Start=f}', "");
    Expect(0, 201547, '\p{^Is_ID_Start=f}', "");
    Expect(0, 201547, '\P{Is_ID_Start=f}', "");
    Expect(1, 201547, '\P{^Is_ID_Start=f}', "");
    Expect(0, 201546, '\p{Is_ID_Start=f}', "");
    Expect(1, 201546, '\p{^Is_ID_Start=f}', "");
    Expect(1, 201546, '\P{Is_ID_Start=f}', "");
    Expect(0, 201546, '\P{^Is_ID_Start=f}', "");
    Expect(1, 201547, '\p{Is_ID_Start:	-F}', "");
    Expect(0, 201547, '\p{^Is_ID_Start:	-F}', "");
    Expect(0, 201547, '\P{Is_ID_Start:	-F}', "");
    Expect(1, 201547, '\P{^Is_ID_Start:	-F}', "");
    Expect(0, 201546, '\p{Is_ID_Start:	-F}', "");
    Expect(1, 201546, '\p{^Is_ID_Start:	-F}', "");
    Expect(1, 201546, '\P{Is_ID_Start:	-F}', "");
    Expect(0, 201546, '\P{^Is_ID_Start:	-F}', "");
    Error('\p{Is_IDS=_:=FALSE}');
    Error('\P{Is_IDS=_:=FALSE}');
    Expect(1, 201547, '\p{Is_IDS=false}', "");
    Expect(0, 201547, '\p{^Is_IDS=false}', "");
    Expect(0, 201547, '\P{Is_IDS=false}', "");
    Expect(1, 201547, '\P{^Is_IDS=false}', "");
    Expect(0, 201546, '\p{Is_IDS=false}', "");
    Expect(1, 201546, '\p{^Is_IDS=false}', "");
    Expect(1, 201546, '\P{Is_IDS=false}', "");
    Expect(0, 201546, '\P{^Is_IDS=false}', "");
    Expect(1, 201547, '\p{Is_IDS=	False}', "");
    Expect(0, 201547, '\p{^Is_IDS=	False}', "");
    Expect(0, 201547, '\P{Is_IDS=	False}', "");
    Expect(1, 201547, '\P{^Is_IDS=	False}', "");
    Expect(0, 201546, '\p{Is_IDS=	False}', "");
    Expect(1, 201546, '\p{^Is_IDS=	False}', "");
    Expect(1, 201546, '\P{Is_IDS=	False}', "");
    Expect(0, 201546, '\P{^Is_IDS=	False}', "");
    Error('\p{ID_Start=__YES/a/}');
    Error('\P{ID_Start=__YES/a/}');
    Expect(1, 201546, '\p{ID_Start=:\AYes\z:}', "");;
    Expect(0, 201547, '\p{ID_Start=:\AYes\z:}', "");;
    Expect(1, 201546, '\p{ID_Start=yes}', "");
    Expect(0, 201546, '\p{^ID_Start=yes}', "");
    Expect(0, 201546, '\P{ID_Start=yes}', "");
    Expect(1, 201546, '\P{^ID_Start=yes}', "");
    Expect(0, 201547, '\p{ID_Start=yes}', "");
    Expect(1, 201547, '\p{^ID_Start=yes}', "");
    Expect(1, 201547, '\P{ID_Start=yes}', "");
    Expect(0, 201547, '\P{^ID_Start=yes}', "");
    Expect(1, 201546, '\p{ID_Start=:\Ayes\z:}', "");;
    Expect(0, 201547, '\p{ID_Start=:\Ayes\z:}', "");;
    Expect(1, 201546, '\p{ID_Start=	YES}', "");
    Expect(0, 201546, '\p{^ID_Start=	YES}', "");
    Expect(0, 201546, '\P{ID_Start=	YES}', "");
    Expect(1, 201546, '\P{^ID_Start=	YES}', "");
    Expect(0, 201547, '\p{ID_Start=	YES}', "");
    Expect(1, 201547, '\p{^ID_Start=	YES}', "");
    Expect(1, 201547, '\P{ID_Start=	YES}', "");
    Expect(0, 201547, '\P{^ID_Start=	YES}', "");
    Error('\p{IDS=	Y/a/}');
    Error('\P{IDS=	Y/a/}');
    Expect(1, 201546, '\p{IDS=:\AY\z:}', "");;
    Expect(0, 201547, '\p{IDS=:\AY\z:}', "");;
    Expect(1, 201546, '\p{IDS=y}', "");
    Expect(0, 201546, '\p{^IDS=y}', "");
    Expect(0, 201546, '\P{IDS=y}', "");
    Expect(1, 201546, '\P{^IDS=y}', "");
    Expect(0, 201547, '\p{IDS=y}', "");
    Expect(1, 201547, '\p{^IDS=y}', "");
    Expect(1, 201547, '\P{IDS=y}', "");
    Expect(0, 201547, '\P{^IDS=y}', "");
    Expect(1, 201546, '\p{IDS=:\Ay\z:}', "");;
    Expect(0, 201547, '\p{IDS=:\Ay\z:}', "");;
    Expect(1, 201546, '\p{IDS=_	Y}', "");
    Expect(0, 201546, '\p{^IDS=_	Y}', "");
    Expect(0, 201546, '\P{IDS=_	Y}', "");
    Expect(1, 201546, '\P{^IDS=_	Y}', "");
    Expect(0, 201547, '\p{IDS=_	Y}', "");
    Expect(1, 201547, '\p{^IDS=_	Y}', "");
    Expect(1, 201547, '\P{IDS=_	Y}', "");
    Expect(0, 201547, '\P{^IDS=_	Y}', "");
    Error('\p{Is_ID_Start=- T/a/}');
    Error('\P{Is_ID_Start=- T/a/}');
    Expect(1, 201546, '\p{Is_ID_Start=t}', "");
    Expect(0, 201546, '\p{^Is_ID_Start=t}', "");
    Expect(0, 201546, '\P{Is_ID_Start=t}', "");
    Expect(1, 201546, '\P{^Is_ID_Start=t}', "");
    Expect(0, 201547, '\p{Is_ID_Start=t}', "");
    Expect(1, 201547, '\p{^Is_ID_Start=t}', "");
    Expect(1, 201547, '\P{Is_ID_Start=t}', "");
    Expect(0, 201547, '\P{^Is_ID_Start=t}', "");
    Expect(1, 201546, '\p{Is_ID_Start=  t}', "");
    Expect(0, 201546, '\p{^Is_ID_Start=  t}', "");
    Expect(0, 201546, '\P{Is_ID_Start=  t}', "");
    Expect(1, 201546, '\P{^Is_ID_Start=  t}', "");
    Expect(0, 201547, '\p{Is_ID_Start=  t}', "");
    Expect(1, 201547, '\p{^Is_ID_Start=  t}', "");
    Expect(1, 201547, '\P{Is_ID_Start=  t}', "");
    Expect(0, 201547, '\P{^Is_ID_Start=  t}', "");
    Error('\p{Is_IDS=-/a/True}');
    Error('\P{Is_IDS=-/a/True}');
    Expect(1, 201546, '\p{Is_IDS=true}', "");
    Expect(0, 201546, '\p{^Is_IDS=true}', "");
    Expect(0, 201546, '\P{Is_IDS=true}', "");
    Expect(1, 201546, '\P{^Is_IDS=true}', "");
    Expect(0, 201547, '\p{Is_IDS=true}', "");
    Expect(1, 201547, '\p{^Is_IDS=true}', "");
    Expect(1, 201547, '\P{Is_IDS=true}', "");
    Expect(0, 201547, '\P{^Is_IDS=true}', "");
    Expect(1, 201546, '\p{Is_IDS= 	True}', "");
    Expect(0, 201546, '\p{^Is_IDS= 	True}', "");
    Expect(0, 201546, '\P{Is_IDS= 	True}', "");
    Expect(1, 201546, '\P{^Is_IDS= 	True}', "");
    Expect(0, 201547, '\p{Is_IDS= 	True}', "");
    Expect(1, 201547, '\p{^Is_IDS= 	True}', "");
    Expect(1, 201547, '\P{Is_IDS= 	True}', "");
    Expect(0, 201547, '\P{^Is_IDS= 	True}', "");
    Error('\p{IDS_Binary_Operator= :=No}');
    Error('\P{IDS_Binary_Operator= :=No}');
    Expect(1, 12284, '\p{IDS_Binary_Operator=:\ANo\z:}', "");;
    Expect(0, 12283, '\p{IDS_Binary_Operator=:\ANo\z:}', "");;
    Expect(1, 12284, '\p{IDS_Binary_Operator=no}', "");
    Expect(0, 12284, '\p{^IDS_Binary_Operator=no}', "");
    Expect(0, 12284, '\P{IDS_Binary_Operator=no}', "");
    Expect(1, 12284, '\P{^IDS_Binary_Operator=no}', "");
    Expect(0, 12283, '\p{IDS_Binary_Operator=no}', "");
    Expect(1, 12283, '\p{^IDS_Binary_Operator=no}', "");
    Expect(1, 12283, '\P{IDS_Binary_Operator=no}', "");
    Expect(0, 12283, '\P{^IDS_Binary_Operator=no}', "");
    Expect(1, 12284, '\p{IDS_Binary_Operator=:\Ano\z:}', "");;
    Expect(0, 12283, '\p{IDS_Binary_Operator=:\Ano\z:}', "");;
    Expect(1, 12284, '\p{IDS_Binary_Operator=	 no}', "");
    Expect(0, 12284, '\p{^IDS_Binary_Operator=	 no}', "");
    Expect(0, 12284, '\P{IDS_Binary_Operator=	 no}', "");
    Expect(1, 12284, '\P{^IDS_Binary_Operator=	 no}', "");
    Expect(0, 12283, '\p{IDS_Binary_Operator=	 no}', "");
    Expect(1, 12283, '\p{^IDS_Binary_Operator=	 no}', "");
    Expect(1, 12283, '\P{IDS_Binary_Operator=	 no}', "");
    Expect(0, 12283, '\P{^IDS_Binary_Operator=	 no}', "");
    Error('\p{IDSB=_:=N}');
    Error('\P{IDSB=_:=N}');
    Expect(1, 12284, '\p{IDSB=:\AN\z:}', "");;
    Expect(0, 12283, '\p{IDSB=:\AN\z:}', "");;
    Expect(1, 12284, '\p{IDSB=n}', "");
    Expect(0, 12284, '\p{^IDSB=n}', "");
    Expect(0, 12284, '\P{IDSB=n}', "");
    Expect(1, 12284, '\P{^IDSB=n}', "");
    Expect(0, 12283, '\p{IDSB=n}', "");
    Expect(1, 12283, '\p{^IDSB=n}', "");
    Expect(1, 12283, '\P{IDSB=n}', "");
    Expect(0, 12283, '\P{^IDSB=n}', "");
    Expect(1, 12284, '\p{IDSB=:\An\z:}', "");;
    Expect(0, 12283, '\p{IDSB=:\An\z:}', "");;
    Expect(1, 12284, '\p{IDSB=-N}', "");
    Expect(0, 12284, '\p{^IDSB=-N}', "");
    Expect(0, 12284, '\P{IDSB=-N}', "");
    Expect(1, 12284, '\P{^IDSB=-N}', "");
    Expect(0, 12283, '\p{IDSB=-N}', "");
    Expect(1, 12283, '\p{^IDSB=-N}', "");
    Expect(1, 12283, '\P{IDSB=-N}', "");
    Expect(0, 12283, '\P{^IDSB=-N}', "");
    Error('\p{Is_IDS_Binary_Operator= f:=}');
    Error('\P{Is_IDS_Binary_Operator= f:=}');
    Expect(1, 12284, '\p{Is_IDS_Binary_Operator=f}', "");
    Expect(0, 12284, '\p{^Is_IDS_Binary_Operator=f}', "");
    Expect(0, 12284, '\P{Is_IDS_Binary_Operator=f}', "");
    Expect(1, 12284, '\P{^Is_IDS_Binary_Operator=f}', "");
    Expect(0, 12283, '\p{Is_IDS_Binary_Operator=f}', "");
    Expect(1, 12283, '\p{^Is_IDS_Binary_Operator=f}', "");
    Expect(1, 12283, '\P{Is_IDS_Binary_Operator=f}', "");
    Expect(0, 12283, '\P{^Is_IDS_Binary_Operator=f}', "");
    Expect(1, 12284, '\p{Is_IDS_Binary_Operator=		F}', "");
    Expect(0, 12284, '\p{^Is_IDS_Binary_Operator=		F}', "");
    Expect(0, 12284, '\P{Is_IDS_Binary_Operator=		F}', "");
    Expect(1, 12284, '\P{^Is_IDS_Binary_Operator=		F}', "");
    Expect(0, 12283, '\p{Is_IDS_Binary_Operator=		F}', "");
    Expect(1, 12283, '\p{^Is_IDS_Binary_Operator=		F}', "");
    Expect(1, 12283, '\P{Is_IDS_Binary_Operator=		F}', "");
    Expect(0, 12283, '\P{^Is_IDS_Binary_Operator=		F}', "");
    Error('\p{Is_IDSB=false:=}');
    Error('\P{Is_IDSB=false:=}');
    Expect(1, 12284, '\p{Is_IDSB=false}', "");
    Expect(0, 12284, '\p{^Is_IDSB=false}', "");
    Expect(0, 12284, '\P{Is_IDSB=false}', "");
    Expect(1, 12284, '\P{^Is_IDSB=false}', "");
    Expect(0, 12283, '\p{Is_IDSB=false}', "");
    Expect(1, 12283, '\p{^Is_IDSB=false}', "");
    Expect(1, 12283, '\P{Is_IDSB=false}', "");
    Expect(0, 12283, '\P{^Is_IDSB=false}', "");
    Expect(1, 12284, '\p{Is_IDSB= _false}', "");
    Expect(0, 12284, '\p{^Is_IDSB= _false}', "");
    Expect(0, 12284, '\P{Is_IDSB= _false}', "");
    Expect(1, 12284, '\P{^Is_IDSB= _false}', "");
    Expect(0, 12283, '\p{Is_IDSB= _false}', "");
    Expect(1, 12283, '\p{^Is_IDSB= _false}', "");
    Expect(1, 12283, '\P{Is_IDSB= _false}', "");
    Expect(0, 12283, '\P{^Is_IDSB= _false}', "");
    Error('\p{IDS_Binary_Operator=	-Yes:=}');
    Error('\P{IDS_Binary_Operator=	-Yes:=}');
    Expect(1, 12283, '\p{IDS_Binary_Operator=:\AYes\z:}', "");;
    Expect(0, 12284, '\p{IDS_Binary_Operator=:\AYes\z:}', "");;
    Expect(1, 12283, '\p{IDS_Binary_Operator:	yes}', "");
    Expect(0, 12283, '\p{^IDS_Binary_Operator:	yes}', "");
    Expect(0, 12283, '\P{IDS_Binary_Operator:	yes}', "");
    Expect(1, 12283, '\P{^IDS_Binary_Operator:	yes}', "");
    Expect(0, 12284, '\p{IDS_Binary_Operator:	yes}', "");
    Expect(1, 12284, '\p{^IDS_Binary_Operator:	yes}', "");
    Expect(1, 12284, '\P{IDS_Binary_Operator:	yes}', "");
    Expect(0, 12284, '\P{^IDS_Binary_Operator:	yes}', "");
    Expect(1, 12283, '\p{IDS_Binary_Operator=:\Ayes\z:}', "");;
    Expect(0, 12284, '\p{IDS_Binary_Operator=:\Ayes\z:}', "");;
    Expect(1, 12283, '\p{IDS_Binary_Operator=	Yes}', "");
    Expect(0, 12283, '\p{^IDS_Binary_Operator=	Yes}', "");
    Expect(0, 12283, '\P{IDS_Binary_Operator=	Yes}', "");
    Expect(1, 12283, '\P{^IDS_Binary_Operator=	Yes}', "");
    Expect(0, 12284, '\p{IDS_Binary_Operator=	Yes}', "");
    Expect(1, 12284, '\p{^IDS_Binary_Operator=	Yes}', "");
    Expect(1, 12284, '\P{IDS_Binary_Operator=	Yes}', "");
    Expect(0, 12284, '\P{^IDS_Binary_Operator=	Yes}', "");
    Error('\p{IDSB=	:=y}');
    Error('\P{IDSB=	:=y}');
    Expect(1, 12283, '\p{IDSB=:\AY\z:}', "");;
    Expect(0, 12284, '\p{IDSB=:\AY\z:}', "");;
    Expect(1, 12283, '\p{IDSB=y}', "");
    Expect(0, 12283, '\p{^IDSB=y}', "");
    Expect(0, 12283, '\P{IDSB=y}', "");
    Expect(1, 12283, '\P{^IDSB=y}', "");
    Expect(0, 12284, '\p{IDSB=y}', "");
    Expect(1, 12284, '\p{^IDSB=y}', "");
    Expect(1, 12284, '\P{IDSB=y}', "");
    Expect(0, 12284, '\P{^IDSB=y}', "");
    Expect(1, 12283, '\p{IDSB=:\Ay\z:}', "");;
    Expect(0, 12284, '\p{IDSB=:\Ay\z:}', "");;
    Expect(1, 12283, '\p{IDSB= y}', "");
    Expect(0, 12283, '\p{^IDSB= y}', "");
    Expect(0, 12283, '\P{IDSB= y}', "");
    Expect(1, 12283, '\P{^IDSB= y}', "");
    Expect(0, 12284, '\p{IDSB= y}', "");
    Expect(1, 12284, '\p{^IDSB= y}', "");
    Expect(1, 12284, '\P{IDSB= y}', "");
    Expect(0, 12284, '\P{^IDSB= y}', "");
    Error('\p{Is_IDS_Binary_Operator=__T/a/}');
    Error('\P{Is_IDS_Binary_Operator=__T/a/}');
    Expect(1, 12283, '\p{Is_IDS_Binary_Operator=t}', "");
    Expect(0, 12283, '\p{^Is_IDS_Binary_Operator=t}', "");
    Expect(0, 12283, '\P{Is_IDS_Binary_Operator=t}', "");
    Expect(1, 12283, '\P{^Is_IDS_Binary_Operator=t}', "");
    Expect(0, 12284, '\p{Is_IDS_Binary_Operator=t}', "");
    Expect(1, 12284, '\p{^Is_IDS_Binary_Operator=t}', "");
    Expect(1, 12284, '\P{Is_IDS_Binary_Operator=t}', "");
    Expect(0, 12284, '\P{^Is_IDS_Binary_Operator=t}', "");
    Expect(1, 12283, '\p{Is_IDS_Binary_Operator=- t}', "");
    Expect(0, 12283, '\p{^Is_IDS_Binary_Operator=- t}', "");
    Expect(0, 12283, '\P{Is_IDS_Binary_Operator=- t}', "");
    Expect(1, 12283, '\P{^Is_IDS_Binary_Operator=- t}', "");
    Expect(0, 12284, '\p{Is_IDS_Binary_Operator=- t}', "");
    Expect(1, 12284, '\p{^Is_IDS_Binary_Operator=- t}', "");
    Expect(1, 12284, '\P{Is_IDS_Binary_Operator=- t}', "");
    Expect(0, 12284, '\P{^Is_IDS_Binary_Operator=- t}', "");
    Error('\p{Is_IDSB=-/a/true}');
    Error('\P{Is_IDSB=-/a/true}');
    Expect(1, 12283, '\p{Is_IDSB=true}', "");
    Expect(0, 12283, '\p{^Is_IDSB=true}', "");
    Expect(0, 12283, '\P{Is_IDSB=true}', "");
    Expect(1, 12283, '\P{^Is_IDSB=true}', "");
    Expect(0, 12284, '\p{Is_IDSB=true}', "");
    Expect(1, 12284, '\p{^Is_IDSB=true}', "");
    Expect(1, 12284, '\P{Is_IDSB=true}', "");
    Expect(0, 12284, '\P{^Is_IDSB=true}', "");
    Expect(1, 12283, '\p{Is_IDSB= _True}', "");
    Expect(0, 12283, '\p{^Is_IDSB= _True}', "");
    Expect(0, 12283, '\P{Is_IDSB= _True}', "");
    Expect(1, 12283, '\P{^Is_IDSB= _True}', "");
    Expect(0, 12284, '\p{Is_IDSB= _True}', "");
    Expect(1, 12284, '\p{^Is_IDSB= _True}', "");
    Expect(1, 12284, '\P{Is_IDSB= _True}', "");
    Expect(0, 12284, '\P{^Is_IDSB= _True}', "");
    Error('\p{IDS_Trinary_Operator: /a/--no}');
    Error('\P{IDS_Trinary_Operator: /a/--no}');
    Expect(1, 12276, '\p{IDS_Trinary_Operator=:\ANo\z:}', "");;
    Expect(0, 12275, '\p{IDS_Trinary_Operator=:\ANo\z:}', "");;
    Expect(1, 12276, '\p{IDS_Trinary_Operator=no}', "");
    Expect(0, 12276, '\p{^IDS_Trinary_Operator=no}', "");
    Expect(0, 12276, '\P{IDS_Trinary_Operator=no}', "");
    Expect(1, 12276, '\P{^IDS_Trinary_Operator=no}', "");
    Expect(0, 12275, '\p{IDS_Trinary_Operator=no}', "");
    Expect(1, 12275, '\p{^IDS_Trinary_Operator=no}', "");
    Expect(1, 12275, '\P{IDS_Trinary_Operator=no}', "");
    Expect(0, 12275, '\P{^IDS_Trinary_Operator=no}', "");
    Expect(1, 12276, '\p{IDS_Trinary_Operator=:\Ano\z:}', "");;
    Expect(0, 12275, '\p{IDS_Trinary_Operator=:\Ano\z:}', "");;
    Expect(1, 12276, '\p{IDS_Trinary_Operator:--No}', "");
    Expect(0, 12276, '\p{^IDS_Trinary_Operator:--No}', "");
    Expect(0, 12276, '\P{IDS_Trinary_Operator:--No}', "");
    Expect(1, 12276, '\P{^IDS_Trinary_Operator:--No}', "");
    Expect(0, 12275, '\p{IDS_Trinary_Operator:--No}', "");
    Expect(1, 12275, '\p{^IDS_Trinary_Operator:--No}', "");
    Expect(1, 12275, '\P{IDS_Trinary_Operator:--No}', "");
    Expect(0, 12275, '\P{^IDS_Trinary_Operator:--No}', "");
    Error('\p{IDST=	:=N}');
    Error('\P{IDST=	:=N}');
    Expect(1, 12276, '\p{IDST=:\AN\z:}', "");;
    Expect(0, 12275, '\p{IDST=:\AN\z:}', "");;
    Expect(1, 12276, '\p{IDST=n}', "");
    Expect(0, 12276, '\p{^IDST=n}', "");
    Expect(0, 12276, '\P{IDST=n}', "");
    Expect(1, 12276, '\P{^IDST=n}', "");
    Expect(0, 12275, '\p{IDST=n}', "");
    Expect(1, 12275, '\p{^IDST=n}', "");
    Expect(1, 12275, '\P{IDST=n}', "");
    Expect(0, 12275, '\P{^IDST=n}', "");
    Expect(1, 12276, '\p{IDST=:\An\z:}', "");;
    Expect(0, 12275, '\p{IDST=:\An\z:}', "");;
    Expect(1, 12276, '\p{IDST=	 n}', "");
    Expect(0, 12276, '\p{^IDST=	 n}', "");
    Expect(0, 12276, '\P{IDST=	 n}', "");
    Expect(1, 12276, '\P{^IDST=	 n}', "");
    Expect(0, 12275, '\p{IDST=	 n}', "");
    Expect(1, 12275, '\p{^IDST=	 n}', "");
    Expect(1, 12275, '\P{IDST=	 n}', "");
    Expect(0, 12275, '\P{^IDST=	 n}', "");
    Error('\p{Is_IDS_Trinary_Operator=-_f:=}');
    Error('\P{Is_IDS_Trinary_Operator=-_f:=}');
    Expect(1, 12276, '\p{Is_IDS_Trinary_Operator=f}', "");
    Expect(0, 12276, '\p{^Is_IDS_Trinary_Operator=f}', "");
    Expect(0, 12276, '\P{Is_IDS_Trinary_Operator=f}', "");
    Expect(1, 12276, '\P{^Is_IDS_Trinary_Operator=f}', "");
    Expect(0, 12275, '\p{Is_IDS_Trinary_Operator=f}', "");
    Expect(1, 12275, '\p{^Is_IDS_Trinary_Operator=f}', "");
    Expect(1, 12275, '\P{Is_IDS_Trinary_Operator=f}', "");
    Expect(0, 12275, '\P{^Is_IDS_Trinary_Operator=f}', "");
    Expect(1, 12276, '\p{Is_IDS_Trinary_Operator= _F}', "");
    Expect(0, 12276, '\p{^Is_IDS_Trinary_Operator= _F}', "");
    Expect(0, 12276, '\P{Is_IDS_Trinary_Operator= _F}', "");
    Expect(1, 12276, '\P{^Is_IDS_Trinary_Operator= _F}', "");
    Expect(0, 12275, '\p{Is_IDS_Trinary_Operator= _F}', "");
    Expect(1, 12275, '\p{^Is_IDS_Trinary_Operator= _F}', "");
    Expect(1, 12275, '\P{Is_IDS_Trinary_Operator= _F}', "");
    Expect(0, 12275, '\P{^Is_IDS_Trinary_Operator= _F}', "");
    Error('\p{Is_IDST=:=false}');
    Error('\P{Is_IDST=:=false}');
    Expect(1, 12276, '\p{Is_IDST=false}', "");
    Expect(0, 12276, '\p{^Is_IDST=false}', "");
    Expect(0, 12276, '\P{Is_IDST=false}', "");
    Expect(1, 12276, '\P{^Is_IDST=false}', "");
    Expect(0, 12275, '\p{Is_IDST=false}', "");
    Expect(1, 12275, '\p{^Is_IDST=false}', "");
    Expect(1, 12275, '\P{Is_IDST=false}', "");
    Expect(0, 12275, '\P{^Is_IDST=false}', "");
    Expect(1, 12276, '\p{Is_IDST=		FALSE}', "");
    Expect(0, 12276, '\p{^Is_IDST=		FALSE}', "");
    Expect(0, 12276, '\P{Is_IDST=		FALSE}', "");
    Expect(1, 12276, '\P{^Is_IDST=		FALSE}', "");
    Expect(0, 12275, '\p{Is_IDST=		FALSE}', "");
    Expect(1, 12275, '\p{^Is_IDST=		FALSE}', "");
    Expect(1, 12275, '\P{Is_IDST=		FALSE}', "");
    Expect(0, 12275, '\P{^Is_IDST=		FALSE}', "");
    Error('\p{IDS_Trinary_Operator=		Yes:=}');
    Error('\P{IDS_Trinary_Operator=		Yes:=}');
    Expect(1, 12275, '\p{IDS_Trinary_Operator=:\AYes\z:}', "");;
    Expect(0, 12276, '\p{IDS_Trinary_Operator=:\AYes\z:}', "");;
    Expect(1, 12275, '\p{IDS_Trinary_Operator=yes}', "");
    Expect(0, 12275, '\p{^IDS_Trinary_Operator=yes}', "");
    Expect(0, 12275, '\P{IDS_Trinary_Operator=yes}', "");
    Expect(1, 12275, '\P{^IDS_Trinary_Operator=yes}', "");
    Expect(0, 12276, '\p{IDS_Trinary_Operator=yes}', "");
    Expect(1, 12276, '\p{^IDS_Trinary_Operator=yes}', "");
    Expect(1, 12276, '\P{IDS_Trinary_Operator=yes}', "");
    Expect(0, 12276, '\P{^IDS_Trinary_Operator=yes}', "");
    Expect(1, 12275, '\p{IDS_Trinary_Operator=:\Ayes\z:}', "");;
    Expect(0, 12276, '\p{IDS_Trinary_Operator=:\Ayes\z:}', "");;
    Expect(1, 12275, '\p{IDS_Trinary_Operator:_ YES}', "");
    Expect(0, 12275, '\p{^IDS_Trinary_Operator:_ YES}', "");
    Expect(0, 12275, '\P{IDS_Trinary_Operator:_ YES}', "");
    Expect(1, 12275, '\P{^IDS_Trinary_Operator:_ YES}', "");
    Expect(0, 12276, '\p{IDS_Trinary_Operator:_ YES}', "");
    Expect(1, 12276, '\p{^IDS_Trinary_Operator:_ YES}', "");
    Expect(1, 12276, '\P{IDS_Trinary_Operator:_ YES}', "");
    Expect(0, 12276, '\P{^IDS_Trinary_Operator:_ YES}', "");
    Error('\p{IDST::=y}');
    Error('\P{IDST::=y}');
    Expect(1, 12275, '\p{IDST=:\AY\z:}', "");;
    Expect(0, 12276, '\p{IDST=:\AY\z:}', "");;
    Expect(1, 12275, '\p{IDST=y}', "");
    Expect(0, 12275, '\p{^IDST=y}', "");
    Expect(0, 12275, '\P{IDST=y}', "");
    Expect(1, 12275, '\P{^IDST=y}', "");
    Expect(0, 12276, '\p{IDST=y}', "");
    Expect(1, 12276, '\p{^IDST=y}', "");
    Expect(1, 12276, '\P{IDST=y}', "");
    Expect(0, 12276, '\P{^IDST=y}', "");
    Expect(1, 12275, '\p{IDST=:\Ay\z:}', "");;
    Expect(0, 12276, '\p{IDST=:\Ay\z:}', "");;
    Expect(1, 12275, '\p{IDST=_	Y}', "");
    Expect(0, 12275, '\p{^IDST=_	Y}', "");
    Expect(0, 12275, '\P{IDST=_	Y}', "");
    Expect(1, 12275, '\P{^IDST=_	Y}', "");
    Expect(0, 12276, '\p{IDST=_	Y}', "");
    Expect(1, 12276, '\p{^IDST=_	Y}', "");
    Expect(1, 12276, '\P{IDST=_	Y}', "");
    Expect(0, 12276, '\P{^IDST=_	Y}', "");
    Error('\p{Is_IDS_Trinary_Operator=/a/_T}');
    Error('\P{Is_IDS_Trinary_Operator=/a/_T}');
    Expect(1, 12275, '\p{Is_IDS_Trinary_Operator=t}', "");
    Expect(0, 12275, '\p{^Is_IDS_Trinary_Operator=t}', "");
    Expect(0, 12275, '\P{Is_IDS_Trinary_Operator=t}', "");
    Expect(1, 12275, '\P{^Is_IDS_Trinary_Operator=t}', "");
    Expect(0, 12276, '\p{Is_IDS_Trinary_Operator=t}', "");
    Expect(1, 12276, '\p{^Is_IDS_Trinary_Operator=t}', "");
    Expect(1, 12276, '\P{Is_IDS_Trinary_Operator=t}', "");
    Expect(0, 12276, '\P{^Is_IDS_Trinary_Operator=t}', "");
    Expect(1, 12275, '\p{Is_IDS_Trinary_Operator= 	T}', "");
    Expect(0, 12275, '\p{^Is_IDS_Trinary_Operator= 	T}', "");
    Expect(0, 12275, '\P{Is_IDS_Trinary_Operator= 	T}', "");
    Expect(1, 12275, '\P{^Is_IDS_Trinary_Operator= 	T}', "");
    Expect(0, 12276, '\p{Is_IDS_Trinary_Operator= 	T}', "");
    Expect(1, 12276, '\p{^Is_IDS_Trinary_Operator= 	T}', "");
    Expect(1, 12276, '\P{Is_IDS_Trinary_Operator= 	T}', "");
    Expect(0, 12276, '\P{^Is_IDS_Trinary_Operator= 	T}', "");
    Error('\p{Is_IDST=	:=True}');
    Error('\P{Is_IDST=	:=True}');
    Expect(1, 12275, '\p{Is_IDST=true}', "");
    Expect(0, 12275, '\p{^Is_IDST=true}', "");
    Expect(0, 12275, '\P{Is_IDST=true}', "");
    Expect(1, 12275, '\P{^Is_IDST=true}', "");
    Expect(0, 12276, '\p{Is_IDST=true}', "");
    Expect(1, 12276, '\p{^Is_IDST=true}', "");
    Expect(1, 12276, '\P{Is_IDST=true}', "");
    Expect(0, 12276, '\P{^Is_IDST=true}', "");
    Expect(1, 12275, '\p{Is_IDST=-TRUE}', "");
    Expect(0, 12275, '\p{^Is_IDST=-TRUE}', "");
    Expect(0, 12275, '\P{Is_IDST=-TRUE}', "");
    Expect(1, 12275, '\P{^Is_IDST=-TRUE}', "");
    Expect(0, 12276, '\p{Is_IDST=-TRUE}', "");
    Expect(1, 12276, '\p{^Is_IDST=-TRUE}', "");
    Expect(1, 12276, '\P{Is_IDST=-TRUE}', "");
    Expect(0, 12276, '\P{^Is_IDST=-TRUE}', "");
    Error('\p{presentin}');
    Error('\P{presentin}');
    Error('\p{in}');
    Error('\P{in}');
    Error('\p{Present_In:   /a/	0_0_0_001.1}');
    Error('\P{Present_In:   /a/	0_0_0_001.1}');
    Expect(1, 65533, '\p{Present_In=:\A1.1\z:}', "");;
    Expect(0, 65536, '\p{Present_In=:\A1.1\z:}', "");;
    Expect(1, 65533, '\p{Present_In=0_0_0_0_0_0001.1}', "");
    Expect(0, 65533, '\p{^Present_In=0_0_0_0_0_0001.1}', "");
    Expect(0, 65533, '\P{Present_In=0_0_0_0_0_0001.1}', "");
    Expect(1, 65533, '\P{^Present_In=0_0_0_0_0_0001.1}', "");
    Expect(0, 65536, '\p{Present_In=0_0_0_0_0_0001.1}', "");
    Expect(1, 65536, '\p{^Present_In=0_0_0_0_0_0001.1}', "");
    Expect(1, 65536, '\P{Present_In=0_0_0_0_0_0001.1}', "");
    Expect(0, 65536, '\P{^Present_In=0_0_0_0_0_0001.1}', "");
    Error('\p{In=:=-0_0_0_0_0_0_0001.1}');
    Error('\P{In=:=-0_0_0_0_0_0_0001.1}');
    Expect(1, 65533, '\p{In=:\A1.1\z:}', "");;
    Expect(0, 65536, '\p{In=:\A1.1\z:}', "");;
    Expect(1, 65533, '\p{In=+1.1}', "");
    Expect(0, 65533, '\p{^In=+1.1}', "");
    Expect(0, 65533, '\P{In=+1.1}', "");
    Expect(1, 65533, '\P{^In=+1.1}', "");
    Expect(0, 65536, '\p{In=+1.1}', "");
    Expect(1, 65536, '\p{^In=+1.1}', "");
    Expect(1, 65536, '\P{In=+1.1}', "");
    Expect(0, 65536, '\P{^In=+1.1}', "");
    Error('\p{Is_Present_In=/a/	+0000000001.1}');
    Error('\P{Is_Present_In=/a/	+0000000001.1}');
    Expect(1, 65533, '\p{Is_Present_In:	0_1.1}', "");
    Expect(0, 65533, '\p{^Is_Present_In:	0_1.1}', "");
    Expect(0, 65533, '\P{Is_Present_In:	0_1.1}', "");
    Expect(1, 65533, '\P{^Is_Present_In:	0_1.1}', "");
    Expect(0, 65536, '\p{Is_Present_In:	0_1.1}', "");
    Expect(1, 65536, '\p{^Is_Present_In:	0_1.1}', "");
    Expect(1, 65536, '\P{Is_Present_In:	0_1.1}', "");
    Expect(0, 65536, '\P{^Is_Present_In:	0_1.1}', "");
    Error('\p{Is_In=_+000001.1:=}');
    Error('\P{Is_In=_+000001.1:=}');
    Expect(1, 65533, '\p{Is_In=0_0_0_0_0_0_0001.1}', "");
    Expect(0, 65533, '\p{^Is_In=0_0_0_0_0_0_0001.1}', "");
    Expect(0, 65533, '\P{Is_In=0_0_0_0_0_0_0001.1}', "");
    Expect(1, 65533, '\P{^Is_In=0_0_0_0_0_0_0001.1}', "");
    Expect(0, 65536, '\p{Is_In=0_0_0_0_0_0_0001.1}', "");
    Expect(1, 65536, '\p{^Is_In=0_0_0_0_0_0_0001.1}', "");
    Expect(1, 65536, '\P{Is_In=0_0_0_0_0_0_0001.1}', "");
    Expect(0, 65536, '\P{^Is_In=0_0_0_0_0_0_0001.1}', "");
    Error('\p{Present_In= :=+00000010.0}');
    Error('\P{Present_In= :=+00000010.0}');
    Expect(1, 983040, '\p{Present_In=:\A10.0\z:}', "");;
    Expect(0, 983037, '\p{Present_In=:\A10.0\z:}', "");;
    Expect(1, 983040, '\p{Present_In:   001_0.0}', "");
    Expect(0, 983040, '\p{^Present_In:   001_0.0}', "");
    Expect(0, 983040, '\P{Present_In:   001_0.0}', "");
    Expect(1, 983040, '\P{^Present_In:   001_0.0}', "");
    Expect(0, 983037, '\p{Present_In:   001_0.0}', "");
    Expect(1, 983037, '\p{^Present_In:   001_0.0}', "");
    Expect(1, 983037, '\P{Present_In:   001_0.0}', "");
    Expect(0, 983037, '\P{^Present_In:   001_0.0}', "");
    Error('\p{In:   -_V10_0/a/}');
    Error('\P{In:   -_V10_0/a/}');
    Expect(1, 983040, '\p{In=:\AV10_0\z:}', "");;
    Expect(0, 983037, '\p{In=:\AV10_0\z:}', "");;
    Expect(1, 983040, '\p{In=v100}', "");
    Expect(0, 983040, '\p{^In=v100}', "");
    Expect(0, 983040, '\P{In=v100}', "");
    Expect(1, 983040, '\P{^In=v100}', "");
    Expect(0, 983037, '\p{In=v100}', "");
    Expect(1, 983037, '\p{^In=v100}', "");
    Expect(1, 983037, '\P{In=v100}', "");
    Expect(0, 983037, '\P{^In=v100}', "");
    Expect(1, 983040, '\p{In=:\Av100\z:}', "");;
    Expect(0, 983037, '\p{In=:\Av100\z:}', "");;
    Expect(1, 983040, '\p{In=  v10_0}', "");
    Expect(0, 983040, '\p{^In=  v10_0}', "");
    Expect(0, 983040, '\P{In=  v10_0}', "");
    Expect(1, 983040, '\P{^In=  v10_0}', "");
    Expect(0, 983037, '\p{In=  v10_0}', "");
    Expect(1, 983037, '\p{^In=  v10_0}', "");
    Expect(1, 983037, '\P{In=  v10_0}', "");
    Expect(0, 983037, '\P{^In=  v10_0}', "");
    Error('\p{Is_Present_In=/a/ -0000010.0}');
    Error('\P{Is_Present_In=/a/ -0000010.0}');
    Expect(1, 983040, '\p{Is_Present_In=0010.0}', "");
    Expect(0, 983040, '\p{^Is_Present_In=0010.0}', "");
    Expect(0, 983040, '\P{Is_Present_In=0010.0}', "");
    Expect(1, 983040, '\P{^Is_Present_In=0010.0}', "");
    Expect(0, 983037, '\p{Is_Present_In=0010.0}', "");
    Expect(1, 983037, '\p{^Is_Present_In=0010.0}', "");
    Expect(1, 983037, '\P{Is_Present_In=0010.0}', "");
    Expect(0, 983037, '\P{^Is_Present_In=0010.0}', "");
    Error('\p{Is_In=	_v10_0:=}');
    Error('\P{Is_In=	_v10_0:=}');
    Expect(1, 983040, '\p{Is_In=v100}', "");
    Expect(0, 983040, '\p{^Is_In=v100}', "");
    Expect(0, 983040, '\P{Is_In=v100}', "");
    Expect(1, 983040, '\P{^Is_In=v100}', "");
    Expect(0, 983037, '\p{Is_In=v100}', "");
    Expect(1, 983037, '\p{^Is_In=v100}', "");
    Expect(1, 983037, '\P{Is_In=v100}', "");
    Expect(0, 983037, '\P{^Is_In=v100}', "");
    Expect(1, 983040, '\p{Is_In=_	V10_0}', "");
    Expect(0, 983040, '\p{^Is_In=_	V10_0}', "");
    Expect(0, 983040, '\P{Is_In=_	V10_0}', "");
    Expect(1, 983040, '\P{^Is_In=_	V10_0}', "");
    Expect(0, 983037, '\p{Is_In=_	V10_0}', "");
    Expect(1, 983037, '\p{^Is_In=_	V10_0}', "");
    Expect(1, 983037, '\P{Is_In=_	V10_0}', "");
    Expect(0, 983037, '\P{^Is_In=_	V10_0}', "");
    Error('\p{Present_In=-	+00000011.0:=}');
    Error('\P{Present_In=-	+00000011.0:=}');
    Expect(1, 983040, '\p{Present_In=:\A11.0\z:}', "");;
    Expect(0, 983037, '\p{Present_In=:\A11.0\z:}', "");;
    Expect(1, 983040, '\p{Present_In=+00_00_00_00_011.0}', "");
    Expect(0, 983040, '\p{^Present_In=+00_00_00_00_011.0}', "");
    Expect(0, 983040, '\P{Present_In=+00_00_00_00_011.0}', "");
    Expect(1, 983040, '\P{^Present_In=+00_00_00_00_011.0}', "");
    Expect(0, 983037, '\p{Present_In=+00_00_00_00_011.0}', "");
    Expect(1, 983037, '\p{^Present_In=+00_00_00_00_011.0}', "");
    Expect(1, 983037, '\P{Present_In=+00_00_00_00_011.0}', "");
    Expect(0, 983037, '\P{^Present_In=+00_00_00_00_011.0}', "");
    Error('\p{In=/a/_	V11_0}');
    Error('\P{In=/a/_	V11_0}');
    Expect(1, 983040, '\p{In=:\AV11_0\z:}', "");;
    Expect(0, 983037, '\p{In=:\AV11_0\z:}', "");;
    Expect(1, 983040, '\p{In=v110}', "");
    Expect(0, 983040, '\p{^In=v110}', "");
    Expect(0, 983040, '\P{In=v110}', "");
    Expect(1, 983040, '\P{^In=v110}', "");
    Expect(0, 983037, '\p{In=v110}', "");
    Expect(1, 983037, '\p{^In=v110}', "");
    Expect(1, 983037, '\P{In=v110}', "");
    Expect(0, 983037, '\P{^In=v110}', "");
    Expect(1, 983040, '\p{In=:\Av110\z:}', "");;
    Expect(0, 983037, '\p{In=:\Av110\z:}', "");;
    Expect(1, 983040, '\p{In=_-V11_0}', "");
    Expect(0, 983040, '\p{^In=_-V11_0}', "");
    Expect(0, 983040, '\P{In=_-V11_0}', "");
    Expect(1, 983040, '\P{^In=_-V11_0}', "");
    Expect(0, 983037, '\p{In=_-V11_0}', "");
    Expect(1, 983037, '\p{^In=_-V11_0}', "");
    Expect(1, 983037, '\P{In=_-V11_0}', "");
    Expect(0, 983037, '\P{^In=_-V11_0}', "");
    Error('\p{Is_Present_In=-/a/00_00_00_00_01_1.0}');
    Error('\P{Is_Present_In=-/a/00_00_00_00_01_1.0}');
    Expect(1, 983040, '\p{Is_Present_In=0000000011.0}', "");
    Expect(0, 983040, '\p{^Is_Present_In=0000000011.0}', "");
    Expect(0, 983040, '\P{Is_Present_In=0000000011.0}', "");
    Expect(1, 983040, '\P{^Is_Present_In=0000000011.0}', "");
    Expect(0, 983037, '\p{Is_Present_In=0000000011.0}', "");
    Expect(1, 983037, '\p{^Is_Present_In=0000000011.0}', "");
    Expect(1, 983037, '\P{Is_Present_In=0000000011.0}', "");
    Expect(0, 983037, '\P{^Is_Present_In=0000000011.0}', "");
    Error('\p{Is_In: :=V11_0}');
    Error('\P{Is_In: :=V11_0}');
    Expect(1, 983040, '\p{Is_In=v110}', "");
    Expect(0, 983040, '\p{^Is_In=v110}', "");
    Expect(0, 983040, '\P{Is_In=v110}', "");
    Expect(1, 983040, '\P{^Is_In=v110}', "");
    Expect(0, 983037, '\p{Is_In=v110}', "");
    Expect(1, 983037, '\p{^Is_In=v110}', "");
    Expect(1, 983037, '\P{Is_In=v110}', "");
    Expect(0, 983037, '\P{^Is_In=v110}', "");
    Expect(1, 983040, '\p{Is_In: _	v11_0}', "");
    Expect(0, 983040, '\p{^Is_In: _	v11_0}', "");
    Expect(0, 983040, '\P{Is_In: _	v11_0}', "");
    Expect(1, 983040, '\P{^Is_In: _	v11_0}', "");
    Expect(0, 983037, '\p{Is_In: _	v11_0}', "");
    Expect(1, 983037, '\p{^Is_In: _	v11_0}', "");
    Expect(1, 983037, '\P{Is_In: _	v11_0}', "");
    Expect(0, 983037, '\P{^Is_In: _	v11_0}', "");
    Error('\p{Present_In= :=+00001_2.0}');
    Error('\P{Present_In= :=+00001_2.0}');
    Expect(1, 983040, '\p{Present_In=:\A12.0\z:}', "");;
    Expect(0, 983037, '\p{Present_In=:\A12.0\z:}', "");;
    Expect(1, 983040, '\p{Present_In:   0000012.0}', "");
    Expect(0, 983040, '\p{^Present_In:   0000012.0}', "");
    Expect(0, 983040, '\P{Present_In:   0000012.0}', "");
    Expect(1, 983040, '\P{^Present_In:   0000012.0}', "");
    Expect(0, 983037, '\p{Present_In:   0000012.0}', "");
    Expect(1, 983037, '\p{^Present_In:   0000012.0}', "");
    Expect(1, 983037, '\P{Present_In:   0000012.0}', "");
    Expect(0, 983037, '\P{^Present_In:   0000012.0}', "");
    Error('\p{In= /a/V12_0}');
    Error('\P{In= /a/V12_0}');
    Expect(1, 983040, '\p{In=:\AV12_0\z:}', "");;
    Expect(0, 983037, '\p{In=:\AV12_0\z:}', "");;
    Expect(1, 983040, '\p{In=v120}', "");
    Expect(0, 983040, '\p{^In=v120}', "");
    Expect(0, 983040, '\P{In=v120}', "");
    Expect(1, 983040, '\P{^In=v120}', "");
    Expect(0, 983037, '\p{In=v120}', "");
    Expect(1, 983037, '\p{^In=v120}', "");
    Expect(1, 983037, '\P{In=v120}', "");
    Expect(0, 983037, '\P{^In=v120}', "");
    Expect(1, 983040, '\p{In=:\Av120\z:}', "");;
    Expect(0, 983037, '\p{In=:\Av120\z:}', "");;
    Expect(1, 983040, '\p{In=	 V12_0}', "");
    Expect(0, 983040, '\p{^In=	 V12_0}', "");
    Expect(0, 983040, '\P{In=	 V12_0}', "");
    Expect(1, 983040, '\P{^In=	 V12_0}', "");
    Expect(0, 983037, '\p{In=	 V12_0}', "");
    Expect(1, 983037, '\p{^In=	 V12_0}', "");
    Expect(1, 983037, '\P{In=	 V12_0}', "");
    Expect(0, 983037, '\P{^In=	 V12_0}', "");
    Error('\p{Is_Present_In=-	+0_0_0_0_0_0_0_012.0:=}');
    Error('\P{Is_Present_In=-	+0_0_0_0_0_0_0_012.0:=}');
    Expect(1, 983040, '\p{Is_Present_In=+0_0_0_0_0_012.0}', "");
    Expect(0, 983040, '\p{^Is_Present_In=+0_0_0_0_0_012.0}', "");
    Expect(0, 983040, '\P{Is_Present_In=+0_0_0_0_0_012.0}', "");
    Expect(1, 983040, '\P{^Is_Present_In=+0_0_0_0_0_012.0}', "");
    Expect(0, 983037, '\p{Is_Present_In=+0_0_0_0_0_012.0}', "");
    Expect(1, 983037, '\p{^Is_Present_In=+0_0_0_0_0_012.0}', "");
    Expect(1, 983037, '\P{Is_Present_In=+0_0_0_0_0_012.0}', "");
    Expect(0, 983037, '\P{^Is_Present_In=+0_0_0_0_0_012.0}', "");
    Error('\p{Is_In=V12_0/a/}');
    Error('\P{Is_In=V12_0/a/}');
    Expect(1, 983040, '\p{Is_In=v120}', "");
    Expect(0, 983040, '\p{^Is_In=v120}', "");
    Expect(0, 983040, '\P{Is_In=v120}', "");
    Expect(1, 983040, '\P{^Is_In=v120}', "");
    Expect(0, 983037, '\p{Is_In=v120}', "");
    Expect(1, 983037, '\p{^Is_In=v120}', "");
    Expect(1, 983037, '\P{Is_In=v120}', "");
    Expect(0, 983037, '\P{^Is_In=v120}', "");
    Expect(1, 983040, '\p{Is_In:    _V12_0}', "");
    Expect(0, 983040, '\p{^Is_In:    _V12_0}', "");
    Expect(0, 983040, '\P{Is_In:    _V12_0}', "");
    Expect(1, 983040, '\P{^Is_In:    _V12_0}', "");
    Expect(0, 983037, '\p{Is_In:    _V12_0}', "");
    Expect(1, 983037, '\p{^Is_In:    _V12_0}', "");
    Expect(1, 983037, '\P{Is_In:    _V12_0}', "");
    Expect(0, 983037, '\P{^Is_In:    _V12_0}', "");
    Error('\p{Present_In::=+0_0_0_012.1}');
    Error('\P{Present_In::=+0_0_0_012.1}');
    Expect(1, 983040, '\p{Present_In=:\A12.1\z:}', "");;
    Expect(0, 983037, '\p{Present_In=:\A12.1\z:}', "");;
    Expect(1, 983040, '\p{Present_In=000012.1}', "");
    Expect(0, 983040, '\p{^Present_In=000012.1}', "");
    Expect(0, 983040, '\P{Present_In=000012.1}', "");
    Expect(1, 983040, '\P{^Present_In=000012.1}', "");
    Expect(0, 983037, '\p{Present_In=000012.1}', "");
    Expect(1, 983037, '\p{^Present_In=000012.1}', "");
    Expect(1, 983037, '\P{Present_In=000012.1}', "");
    Expect(0, 983037, '\P{^Present_In=000012.1}', "");
    Error('\p{In= :=V12_1}');
    Error('\P{In= :=V12_1}');
    Expect(1, 983040, '\p{In=:\AV12_1\z:}', "");;
    Expect(0, 983037, '\p{In=:\AV12_1\z:}', "");;
    Expect(1, 983040, '\p{In=v121}', "");
    Expect(0, 983040, '\p{^In=v121}', "");
    Expect(0, 983040, '\P{In=v121}', "");
    Expect(1, 983040, '\P{^In=v121}', "");
    Expect(0, 983037, '\p{In=v121}', "");
    Expect(1, 983037, '\p{^In=v121}', "");
    Expect(1, 983037, '\P{In=v121}', "");
    Expect(0, 983037, '\P{^In=v121}', "");
    Expect(1, 983040, '\p{In=:\Av121\z:}', "");;
    Expect(0, 983037, '\p{In=:\Av121\z:}', "");;
    Expect(1, 983040, '\p{In=		V12_1}', "");
    Expect(0, 983040, '\p{^In=		V12_1}', "");
    Expect(0, 983040, '\P{In=		V12_1}', "");
    Expect(1, 983040, '\P{^In=		V12_1}', "");
    Expect(0, 983037, '\p{In=		V12_1}', "");
    Expect(1, 983037, '\p{^In=		V12_1}', "");
    Expect(1, 983037, '\P{In=		V12_1}', "");
    Expect(0, 983037, '\P{^In=		V12_1}', "");
    Error('\p{Is_Present_In=-/a/0_0_0_12.1}');
    Error('\P{Is_Present_In=-/a/0_0_0_12.1}');
    Expect(1, 983040, '\p{Is_Present_In=0000001_2.1}', "");
    Expect(0, 983040, '\p{^Is_Present_In=0000001_2.1}', "");
    Expect(0, 983040, '\P{Is_Present_In=0000001_2.1}', "");
    Expect(1, 983040, '\P{^Is_Present_In=0000001_2.1}', "");
    Expect(0, 983037, '\p{Is_Present_In=0000001_2.1}', "");
    Expect(1, 983037, '\p{^Is_Present_In=0000001_2.1}', "");
    Expect(1, 983037, '\P{Is_Present_In=0000001_2.1}', "");
    Expect(0, 983037, '\P{^Is_Present_In=0000001_2.1}', "");
    Error('\p{Is_In=		V12_1:=}');
    Error('\P{Is_In=		V12_1:=}');
    Expect(1, 983040, '\p{Is_In=v121}', "");
    Expect(0, 983040, '\p{^Is_In=v121}', "");
    Expect(0, 983040, '\P{Is_In=v121}', "");
    Expect(1, 983040, '\P{^Is_In=v121}', "");
    Expect(0, 983037, '\p{Is_In=v121}', "");
    Expect(1, 983037, '\p{^Is_In=v121}', "");
    Expect(1, 983037, '\P{Is_In=v121}', "");
    Expect(0, 983037, '\P{^Is_In=v121}', "");
    Expect(1, 983040, '\p{Is_In=_	V12_1}', "");
    Expect(0, 983040, '\p{^Is_In=_	V12_1}', "");
    Expect(0, 983040, '\P{Is_In=_	V12_1}', "");
    Expect(1, 983040, '\P{^Is_In=_	V12_1}', "");
    Expect(0, 983037, '\p{Is_In=_	V12_1}', "");
    Expect(1, 983037, '\p{^Is_In=_	V12_1}', "");
    Expect(1, 983037, '\P{Is_In=_	V12_1}', "");
    Expect(0, 983037, '\P{^Is_In=_	V12_1}', "");
    Error('\p{Present_In=/a/ 0_0_0_0_0_013.0}');
    Error('\P{Present_In=/a/ 0_0_0_0_0_013.0}');
    Expect(1, 983040, '\p{Present_In=:\A13.0\z:}', "");;
    Expect(0, 983037, '\p{Present_In=:\A13.0\z:}', "");;
    Expect(1, 983040, '\p{Present_In=00_00_01_3.0}', "");
    Expect(0, 983040, '\p{^Present_In=00_00_01_3.0}', "");
    Expect(0, 983040, '\P{Present_In=00_00_01_3.0}', "");
    Expect(1, 983040, '\P{^Present_In=00_00_01_3.0}', "");
    Expect(0, 983037, '\p{Present_In=00_00_01_3.0}', "");
    Expect(1, 983037, '\p{^Present_In=00_00_01_3.0}', "");
    Expect(1, 983037, '\P{Present_In=00_00_01_3.0}', "");
    Expect(0, 983037, '\P{^Present_In=00_00_01_3.0}', "");
    Error('\p{In= /a/V13_0}');
    Error('\P{In= /a/V13_0}');
    Expect(1, 983040, '\p{In=:\AV13_0\z:}', "");;
    Expect(0, 983037, '\p{In=:\AV13_0\z:}', "");;
    Expect(1, 983040, '\p{In=v130}', "");
    Expect(0, 983040, '\p{^In=v130}', "");
    Expect(0, 983040, '\P{In=v130}', "");
    Expect(1, 983040, '\P{^In=v130}', "");
    Expect(0, 983037, '\p{In=v130}', "");
    Expect(1, 983037, '\p{^In=v130}', "");
    Expect(1, 983037, '\P{In=v130}', "");
    Expect(0, 983037, '\P{^In=v130}', "");
    Expect(1, 983040, '\p{In=:\Av130\z:}', "");;
    Expect(0, 983037, '\p{In=:\Av130\z:}', "");;
    Expect(1, 983040, '\p{In:		V13_0}', "");
    Expect(0, 983040, '\p{^In:		V13_0}', "");
    Expect(0, 983040, '\P{In:		V13_0}', "");
    Expect(1, 983040, '\P{^In:		V13_0}', "");
    Expect(0, 983037, '\p{In:		V13_0}', "");
    Expect(1, 983037, '\p{^In:		V13_0}', "");
    Expect(1, 983037, '\P{In:		V13_0}', "");
    Expect(0, 983037, '\P{^In:		V13_0}', "");
    Error('\p{Is_Present_In=/a/+0_0_0_0_0_0_0_0_0_13.0}');
    Error('\P{Is_Present_In=/a/+0_0_0_0_0_0_0_0_0_13.0}');
    Expect(1, 983040, '\p{Is_Present_In=0_0_0_0_0_13.0}', "");
    Expect(0, 983040, '\p{^Is_Present_In=0_0_0_0_0_13.0}', "");
    Expect(0, 983040, '\P{Is_Present_In=0_0_0_0_0_13.0}', "");
    Expect(1, 983040, '\P{^Is_Present_In=0_0_0_0_0_13.0}', "");
    Expect(0, 983037, '\p{Is_Present_In=0_0_0_0_0_13.0}', "");
    Expect(1, 983037, '\p{^Is_Present_In=0_0_0_0_0_13.0}', "");
    Expect(1, 983037, '\P{Is_Present_In=0_0_0_0_0_13.0}', "");
    Expect(0, 983037, '\P{^Is_Present_In=0_0_0_0_0_13.0}', "");
    Error('\p{Is_In=-v13_0:=}');
    Error('\P{Is_In=-v13_0:=}');
    Expect(1, 983040, '\p{Is_In=v130}', "");
    Expect(0, 983040, '\p{^Is_In=v130}', "");
    Expect(0, 983040, '\P{Is_In=v130}', "");
    Expect(1, 983040, '\P{^Is_In=v130}', "");
    Expect(0, 983037, '\p{Is_In=v130}', "");
    Expect(1, 983037, '\p{^Is_In=v130}', "");
    Expect(1, 983037, '\P{Is_In=v130}', "");
    Expect(0, 983037, '\P{^Is_In=v130}', "");
    Expect(1, 983040, '\p{Is_In=_ v13_0}', "");
    Expect(0, 983040, '\p{^Is_In=_ v13_0}', "");
    Expect(0, 983040, '\P{Is_In=_ v13_0}', "");
    Expect(1, 983040, '\P{^Is_In=_ v13_0}', "");
    Expect(0, 983037, '\p{Is_In=_ v13_0}', "");
    Expect(1, 983037, '\p{^Is_In=_ v13_0}', "");
    Expect(1, 983037, '\P{Is_In=_ v13_0}', "");
    Expect(0, 983037, '\P{^Is_In=_ v13_0}', "");
    Error('\p{Present_In=:=-000002.0}');
    Error('\P{Present_In=:=-000002.0}');
    Expect(1, 983040, '\p{Present_In=:\A2.0\z:}', "");;
    Expect(0, 983037, '\p{Present_In=:\A2.0\z:}', "");;
    Expect(1, 983040, '\p{Present_In=+000002.0}', "");
    Expect(0, 983040, '\p{^Present_In=+000002.0}', "");
    Expect(0, 983040, '\P{Present_In=+000002.0}', "");
    Expect(1, 983040, '\P{^Present_In=+000002.0}', "");
    Expect(0, 983037, '\p{Present_In=+000002.0}', "");
    Expect(1, 983037, '\p{^Present_In=+000002.0}', "");
    Expect(1, 983037, '\P{Present_In=+000002.0}', "");
    Expect(0, 983037, '\P{^Present_In=+000002.0}', "");
    Error('\p{In=/a/-V2_0}');
    Error('\P{In=/a/-V2_0}');
    Expect(1, 983040, '\p{In=:\AV2_0\z:}', "");;
    Expect(0, 983037, '\p{In=:\AV2_0\z:}', "");;
    Expect(1, 983040, '\p{In=v20}', "");
    Expect(0, 983040, '\p{^In=v20}', "");
    Expect(0, 983040, '\P{In=v20}', "");
    Expect(1, 983040, '\P{^In=v20}', "");
    Expect(0, 983037, '\p{In=v20}', "");
    Expect(1, 983037, '\p{^In=v20}', "");
    Expect(1, 983037, '\P{In=v20}', "");
    Expect(0, 983037, '\P{^In=v20}', "");
    Expect(1, 983040, '\p{In=:\Av20\z:}', "");;
    Expect(0, 983037, '\p{In=:\Av20\z:}', "");;
    Expect(1, 983040, '\p{In=-_V2_0}', "");
    Expect(0, 983040, '\p{^In=-_V2_0}', "");
    Expect(0, 983040, '\P{In=-_V2_0}', "");
    Expect(1, 983040, '\P{^In=-_V2_0}', "");
    Expect(0, 983037, '\p{In=-_V2_0}', "");
    Expect(1, 983037, '\p{^In=-_V2_0}', "");
    Expect(1, 983037, '\P{In=-_V2_0}', "");
    Expect(0, 983037, '\P{^In=-_V2_0}', "");
    Error('\p{Is_Present_In::=	-0_0_02.0}');
    Error('\P{Is_Present_In::=	-0_0_02.0}');
    Expect(1, 983040, '\p{Is_Present_In=00_2.0}', "");
    Expect(0, 983040, '\p{^Is_Present_In=00_2.0}', "");
    Expect(0, 983040, '\P{Is_Present_In=00_2.0}', "");
    Expect(1, 983040, '\P{^Is_Present_In=00_2.0}', "");
    Expect(0, 983037, '\p{Is_Present_In=00_2.0}', "");
    Expect(1, 983037, '\p{^Is_Present_In=00_2.0}', "");
    Expect(1, 983037, '\P{Is_Present_In=00_2.0}', "");
    Expect(0, 983037, '\P{^Is_Present_In=00_2.0}', "");
    Error('\p{Is_In: :=V2_0}');
    Error('\P{Is_In: :=V2_0}');
    Expect(1, 983040, '\p{Is_In=v20}', "");
    Expect(0, 983040, '\p{^Is_In=v20}', "");
    Expect(0, 983040, '\P{Is_In=v20}', "");
    Expect(1, 983040, '\P{^Is_In=v20}', "");
    Expect(0, 983037, '\p{Is_In=v20}', "");
    Expect(1, 983037, '\p{^Is_In=v20}', "");
    Expect(1, 983037, '\P{Is_In=v20}', "");
    Expect(0, 983037, '\P{^Is_In=v20}', "");
    Expect(1, 983040, '\p{Is_In=-V2_0}', "");
    Expect(0, 983040, '\p{^Is_In=-V2_0}', "");
    Expect(0, 983040, '\P{Is_In=-V2_0}', "");
    Expect(1, 983040, '\P{^Is_In=-V2_0}', "");
    Expect(0, 983037, '\p{Is_In=-V2_0}', "");
    Expect(1, 983037, '\p{^Is_In=-V2_0}', "");
    Expect(1, 983037, '\P{Is_In=-V2_0}', "");
    Expect(0, 983037, '\P{^Is_In=-V2_0}', "");
    Error('\p{Present_In=:= 	2.1}');
    Error('\P{Present_In=:= 	2.1}');
    Expect(1, 983040, '\p{Present_In=:\A2.1\z:}', "");;
    Expect(0, 983037, '\p{Present_In=:\A2.1\z:}', "");;
    Expect(1, 983040, '\p{Present_In=+2.1}', "");
    Expect(0, 983040, '\p{^Present_In=+2.1}', "");
    Expect(0, 983040, '\P{Present_In=+2.1}', "");
    Expect(1, 983040, '\P{^Present_In=+2.1}', "");
    Expect(0, 983037, '\p{Present_In=+2.1}', "");
    Expect(1, 983037, '\p{^Present_In=+2.1}', "");
    Expect(1, 983037, '\P{Present_In=+2.1}', "");
    Expect(0, 983037, '\P{^Present_In=+2.1}', "");
    Error('\p{In:   	:=V2_1}');
    Error('\P{In:   	:=V2_1}');
    Expect(1, 983040, '\p{In=:\AV2_1\z:}', "");;
    Expect(0, 983037, '\p{In=:\AV2_1\z:}', "");;
    Expect(1, 983040, '\p{In=v21}', "");
    Expect(0, 983040, '\p{^In=v21}', "");
    Expect(0, 983040, '\P{In=v21}', "");
    Expect(1, 983040, '\P{^In=v21}', "");
    Expect(0, 983037, '\p{In=v21}', "");
    Expect(1, 983037, '\p{^In=v21}', "");
    Expect(1, 983037, '\P{In=v21}', "");
    Expect(0, 983037, '\P{^In=v21}', "");
    Expect(1, 983040, '\p{In=:\Av21\z:}', "");;
    Expect(0, 983037, '\p{In=:\Av21\z:}', "");;
    Expect(1, 983040, '\p{In=	V2_1}', "");
    Expect(0, 983040, '\p{^In=	V2_1}', "");
    Expect(0, 983040, '\P{In=	V2_1}', "");
    Expect(1, 983040, '\P{^In=	V2_1}', "");
    Expect(0, 983037, '\p{In=	V2_1}', "");
    Expect(1, 983037, '\p{^In=	V2_1}', "");
    Expect(1, 983037, '\P{In=	V2_1}', "");
    Expect(0, 983037, '\P{^In=	V2_1}', "");
    Error('\p{Is_Present_In=:=	 +0_0_0_02.1}');
    Error('\P{Is_Present_In=:=	 +0_0_0_02.1}');
    Expect(1, 983040, '\p{Is_Present_In=00002.1}', "");
    Expect(0, 983040, '\p{^Is_Present_In=00002.1}', "");
    Expect(0, 983040, '\P{Is_Present_In=00002.1}', "");
    Expect(1, 983040, '\P{^Is_Present_In=00002.1}', "");
    Expect(0, 983037, '\p{Is_Present_In=00002.1}', "");
    Expect(1, 983037, '\p{^Is_Present_In=00002.1}', "");
    Expect(1, 983037, '\P{Is_Present_In=00002.1}', "");
    Expect(0, 983037, '\P{^Is_Present_In=00002.1}', "");
    Error('\p{Is_In=/a/_ V2_1}');
    Error('\P{Is_In=/a/_ V2_1}');
    Expect(1, 983040, '\p{Is_In:   v21}', "");
    Expect(0, 983040, '\p{^Is_In:   v21}', "");
    Expect(0, 983040, '\P{Is_In:   v21}', "");
    Expect(1, 983040, '\P{^Is_In:   v21}', "");
    Expect(0, 983037, '\p{Is_In:   v21}', "");
    Expect(1, 983037, '\p{^Is_In:   v21}', "");
    Expect(1, 983037, '\P{Is_In:   v21}', "");
    Expect(0, 983037, '\P{^Is_In:   v21}', "");
    Expect(1, 983040, '\p{Is_In=-V2_1}', "");
    Expect(0, 983040, '\p{^Is_In=-V2_1}', "");
    Expect(0, 983040, '\P{Is_In=-V2_1}', "");
    Expect(1, 983040, '\P{^Is_In=-V2_1}', "");
    Expect(0, 983037, '\p{Is_In=-V2_1}', "");
    Expect(1, 983037, '\p{^Is_In=-V2_1}', "");
    Expect(1, 983037, '\P{Is_In=-V2_1}', "");
    Expect(0, 983037, '\P{^Is_In=-V2_1}', "");
    Error('\p{Present_In=:=+00_00_03.0}');
    Error('\P{Present_In=:=+00_00_03.0}');
    Expect(1, 983040, '\p{Present_In=:\A3.0\z:}', "");;
    Expect(0, 983037, '\p{Present_In=:\A3.0\z:}', "");;
    Expect(1, 983040, '\p{Present_In=000003.0}', "");
    Expect(0, 983040, '\p{^Present_In=000003.0}', "");
    Expect(0, 983040, '\P{Present_In=000003.0}', "");
    Expect(1, 983040, '\P{^Present_In=000003.0}', "");
    Expect(0, 983037, '\p{Present_In=000003.0}', "");
    Expect(1, 983037, '\p{^Present_In=000003.0}', "");
    Expect(1, 983037, '\P{Present_In=000003.0}', "");
    Expect(0, 983037, '\P{^Present_In=000003.0}', "");
    Error('\p{In=_/a/v3_0}');
    Error('\P{In=_/a/v3_0}');
    Expect(1, 983040, '\p{In=:\AV3_0\z:}', "");;
    Expect(0, 983037, '\p{In=:\AV3_0\z:}', "");;
    Expect(1, 983040, '\p{In=v30}', "");
    Expect(0, 983040, '\p{^In=v30}', "");
    Expect(0, 983040, '\P{In=v30}', "");
    Expect(1, 983040, '\P{^In=v30}', "");
    Expect(0, 983037, '\p{In=v30}', "");
    Expect(1, 983037, '\p{^In=v30}', "");
    Expect(1, 983037, '\P{In=v30}', "");
    Expect(0, 983037, '\P{^In=v30}', "");
    Expect(1, 983040, '\p{In=:\Av30\z:}', "");;
    Expect(0, 983037, '\p{In=:\Av30\z:}', "");;
    Expect(1, 983040, '\p{In=	_V3_0}', "");
    Expect(0, 983040, '\p{^In=	_V3_0}', "");
    Expect(0, 983040, '\P{In=	_V3_0}', "");
    Expect(1, 983040, '\P{^In=	_V3_0}', "");
    Expect(0, 983037, '\p{In=	_V3_0}', "");
    Expect(1, 983037, '\p{^In=	_V3_0}', "");
    Expect(1, 983037, '\P{In=	_V3_0}', "");
    Expect(0, 983037, '\P{^In=	_V3_0}', "");
    Error('\p{Is_Present_In=	_0003.0/a/}');
    Error('\P{Is_Present_In=	_0003.0/a/}');
    Expect(1, 983040, '\p{Is_Present_In=+000003.0}', "");
    Expect(0, 983040, '\p{^Is_Present_In=+000003.0}', "");
    Expect(0, 983040, '\P{Is_Present_In=+000003.0}', "");
    Expect(1, 983040, '\P{^Is_Present_In=+000003.0}', "");
    Expect(0, 983037, '\p{Is_Present_In=+000003.0}', "");
    Expect(1, 983037, '\p{^Is_Present_In=+000003.0}', "");
    Expect(1, 983037, '\P{Is_Present_In=+000003.0}', "");
    Expect(0, 983037, '\P{^Is_Present_In=+000003.0}', "");
    Error('\p{Is_In=_	V3_0:=}');
    Error('\P{Is_In=_	V3_0:=}');
    Expect(1, 983040, '\p{Is_In=v30}', "");
    Expect(0, 983040, '\p{^Is_In=v30}', "");
    Expect(0, 983040, '\P{Is_In=v30}', "");
    Expect(1, 983040, '\P{^Is_In=v30}', "");
    Expect(0, 983037, '\p{Is_In=v30}', "");
    Expect(1, 983037, '\p{^Is_In=v30}', "");
    Expect(1, 983037, '\P{Is_In=v30}', "");
    Expect(0, 983037, '\P{^Is_In=v30}', "");
    Expect(1, 983040, '\p{Is_In=-V3_0}', "");
    Expect(0, 983040, '\p{^Is_In=-V3_0}', "");
    Expect(0, 983040, '\P{Is_In=-V3_0}', "");
    Expect(1, 983040, '\P{^Is_In=-V3_0}', "");
    Expect(0, 983037, '\p{Is_In=-V3_0}', "");
    Expect(1, 983037, '\p{^Is_In=-V3_0}', "");
    Expect(1, 983037, '\P{Is_In=-V3_0}', "");
    Expect(0, 983037, '\P{^Is_In=-V3_0}', "");
    Error('\p{Present_In=/a/ +0000_0000_3.1}');
    Error('\P{Present_In=/a/ +0000_0000_3.1}');
    Expect(1, 983040, '\p{Present_In=:\A3.1\z:}', "");;
    Expect(0, 983037, '\p{Present_In=:\A3.1\z:}', "");;
    Expect(1, 983040, '\p{Present_In=3.1}', "");
    Expect(0, 983040, '\p{^Present_In=3.1}', "");
    Expect(0, 983040, '\P{Present_In=3.1}', "");
    Expect(1, 983040, '\P{^Present_In=3.1}', "");
    Expect(0, 983037, '\p{Present_In=3.1}', "");
    Expect(1, 983037, '\p{^Present_In=3.1}', "");
    Expect(1, 983037, '\P{Present_In=3.1}', "");
    Expect(0, 983037, '\P{^Present_In=3.1}', "");
    Error('\p{In=/a/V3_1}');
    Error('\P{In=/a/V3_1}');
    Expect(1, 983040, '\p{In=:\AV3_1\z:}', "");;
    Expect(0, 983037, '\p{In=:\AV3_1\z:}', "");;
    Expect(1, 983040, '\p{In=v31}', "");
    Expect(0, 983040, '\p{^In=v31}', "");
    Expect(0, 983040, '\P{In=v31}', "");
    Expect(1, 983040, '\P{^In=v31}', "");
    Expect(0, 983037, '\p{In=v31}', "");
    Expect(1, 983037, '\p{^In=v31}', "");
    Expect(1, 983037, '\P{In=v31}', "");
    Expect(0, 983037, '\P{^In=v31}', "");
    Expect(1, 983040, '\p{In=:\Av31\z:}', "");;
    Expect(0, 983037, '\p{In=:\Av31\z:}', "");;
    Expect(1, 983040, '\p{In= V3_1}', "");
    Expect(0, 983040, '\p{^In= V3_1}', "");
    Expect(0, 983040, '\P{In= V3_1}', "");
    Expect(1, 983040, '\P{^In= V3_1}', "");
    Expect(0, 983037, '\p{In= V3_1}', "");
    Expect(1, 983037, '\p{^In= V3_1}', "");
    Expect(1, 983037, '\P{In= V3_1}', "");
    Expect(0, 983037, '\P{^In= V3_1}', "");
    Error('\p{Is_Present_In=--00_00_00_3.1:=}');
    Error('\P{Is_Present_In=--00_00_00_3.1:=}');
    Expect(1, 983040, '\p{Is_Present_In=+00000_3.1}', "");
    Expect(0, 983040, '\p{^Is_Present_In=+00000_3.1}', "");
    Expect(0, 983040, '\P{Is_Present_In=+00000_3.1}', "");
    Expect(1, 983040, '\P{^Is_Present_In=+00000_3.1}', "");
    Expect(0, 983037, '\p{Is_Present_In=+00000_3.1}', "");
    Expect(1, 983037, '\p{^Is_Present_In=+00000_3.1}', "");
    Expect(1, 983037, '\P{Is_Present_In=+00000_3.1}', "");
    Expect(0, 983037, '\P{^Is_Present_In=+00000_3.1}', "");
    Error('\p{Is_In=	V3_1:=}');
    Error('\P{Is_In=	V3_1:=}');
    Expect(1, 983040, '\p{Is_In=v31}', "");
    Expect(0, 983040, '\p{^Is_In=v31}', "");
    Expect(0, 983040, '\P{Is_In=v31}', "");
    Expect(1, 983040, '\P{^Is_In=v31}', "");
    Expect(0, 983037, '\p{Is_In=v31}', "");
    Expect(1, 983037, '\p{^Is_In=v31}', "");
    Expect(1, 983037, '\P{Is_In=v31}', "");
    Expect(0, 983037, '\P{^Is_In=v31}', "");
    Expect(1, 983040, '\p{Is_In=	_V3_1}', "");
    Expect(0, 983040, '\p{^Is_In=	_V3_1}', "");
    Expect(0, 983040, '\P{Is_In=	_V3_1}', "");
    Expect(1, 983040, '\P{^Is_In=	_V3_1}', "");
    Expect(0, 983037, '\p{Is_In=	_V3_1}', "");
    Expect(1, 983037, '\p{^Is_In=	_V3_1}', "");
    Expect(1, 983037, '\P{Is_In=	_V3_1}', "");
    Expect(0, 983037, '\P{^Is_In=	_V3_1}', "");
    Error('\p{Present_In=  +00003.2/a/}');
    Error('\P{Present_In=  +00003.2/a/}');
    Expect(1, 983040, '\p{Present_In=:\A3.2\z:}', "");;
    Expect(0, 983037, '\p{Present_In=:\A3.2\z:}', "");;
    Expect(1, 983040, '\p{Present_In=00_00_00_3.2}', "");
    Expect(0, 983040, '\p{^Present_In=00_00_00_3.2}', "");
    Expect(0, 983040, '\P{Present_In=00_00_00_3.2}', "");
    Expect(1, 983040, '\P{^Present_In=00_00_00_3.2}', "");
    Expect(0, 983037, '\p{Present_In=00_00_00_3.2}', "");
    Expect(1, 983037, '\p{^Present_In=00_00_00_3.2}', "");
    Expect(1, 983037, '\P{Present_In=00_00_00_3.2}', "");
    Expect(0, 983037, '\P{^Present_In=00_00_00_3.2}', "");
    Error('\p{In=:=  V3_2}');
    Error('\P{In=:=  V3_2}');
    Expect(1, 983040, '\p{In=:\AV3_2\z:}', "");;
    Expect(0, 983037, '\p{In=:\AV3_2\z:}', "");;
    Expect(1, 983040, '\p{In=v32}', "");
    Expect(0, 983040, '\p{^In=v32}', "");
    Expect(0, 983040, '\P{In=v32}', "");
    Expect(1, 983040, '\P{^In=v32}', "");
    Expect(0, 983037, '\p{In=v32}', "");
    Expect(1, 983037, '\p{^In=v32}', "");
    Expect(1, 983037, '\P{In=v32}', "");
    Expect(0, 983037, '\P{^In=v32}', "");
    Expect(1, 983040, '\p{In=:\Av32\z:}', "");;
    Expect(0, 983037, '\p{In=:\Av32\z:}', "");;
    Expect(1, 983040, '\p{In=-_V3_2}', "");
    Expect(0, 983040, '\p{^In=-_V3_2}', "");
    Expect(0, 983040, '\P{In=-_V3_2}', "");
    Expect(1, 983040, '\P{^In=-_V3_2}', "");
    Expect(0, 983037, '\p{In=-_V3_2}', "");
    Expect(1, 983037, '\p{^In=-_V3_2}', "");
    Expect(1, 983037, '\P{In=-_V3_2}', "");
    Expect(0, 983037, '\P{^In=-_V3_2}', "");
    Error('\p{Is_Present_In=	_003.2/a/}');
    Error('\P{Is_Present_In=	_003.2/a/}');
    Expect(1, 983040, '\p{Is_Present_In=0000000_3.2}', "");
    Expect(0, 983040, '\p{^Is_Present_In=0000000_3.2}', "");
    Expect(0, 983040, '\P{Is_Present_In=0000000_3.2}', "");
    Expect(1, 983040, '\P{^Is_Present_In=0000000_3.2}', "");
    Expect(0, 983037, '\p{Is_Present_In=0000000_3.2}', "");
    Expect(1, 983037, '\p{^Is_Present_In=0000000_3.2}', "");
    Expect(1, 983037, '\P{Is_Present_In=0000000_3.2}', "");
    Expect(0, 983037, '\P{^Is_Present_In=0000000_3.2}', "");
    Error('\p{Is_In=_V3_2/a/}');
    Error('\P{Is_In=_V3_2/a/}');
    Expect(1, 983040, '\p{Is_In=v32}', "");
    Expect(0, 983040, '\p{^Is_In=v32}', "");
    Expect(0, 983040, '\P{Is_In=v32}', "");
    Expect(1, 983040, '\P{^Is_In=v32}', "");
    Expect(0, 983037, '\p{Is_In=v32}', "");
    Expect(1, 983037, '\p{^Is_In=v32}', "");
    Expect(1, 983037, '\P{Is_In=v32}', "");
    Expect(0, 983037, '\P{^Is_In=v32}', "");
    Expect(1, 983040, '\p{Is_In=-	V3_2}', "");
    Expect(0, 983040, '\p{^Is_In=-	V3_2}', "");
    Expect(0, 983040, '\P{Is_In=-	V3_2}', "");
    Expect(1, 983040, '\P{^Is_In=-	V3_2}', "");
    Expect(0, 983037, '\p{Is_In=-	V3_2}', "");
    Expect(1, 983037, '\p{^Is_In=-	V3_2}', "");
    Expect(1, 983037, '\P{Is_In=-	V3_2}', "");
    Expect(0, 983037, '\P{^Is_In=-	V3_2}', "");
    Error('\p{Present_In=/a/_-+000_4.0}');
    Error('\P{Present_In=/a/_-+000_4.0}');
    Expect(1, 983040, '\p{Present_In=:\A4.0\z:}', "");;
    Expect(0, 983037, '\p{Present_In=:\A4.0\z:}', "");;
    Expect(1, 983040, '\p{Present_In=+000000004.0}', "");
    Expect(0, 983040, '\p{^Present_In=+000000004.0}', "");
    Expect(0, 983040, '\P{Present_In=+000000004.0}', "");
    Expect(1, 983040, '\P{^Present_In=+000000004.0}', "");
    Expect(0, 983037, '\p{Present_In=+000000004.0}', "");
    Expect(1, 983037, '\p{^Present_In=+000000004.0}', "");
    Expect(1, 983037, '\P{Present_In=+000000004.0}', "");
    Expect(0, 983037, '\P{^Present_In=+000000004.0}', "");
    Error('\p{In=-:=V4_0}');
    Error('\P{In=-:=V4_0}');
    Expect(1, 983040, '\p{In=:\AV4_0\z:}', "");;
    Expect(0, 983037, '\p{In=:\AV4_0\z:}', "");;
    Expect(1, 983040, '\p{In=v40}', "");
    Expect(0, 983040, '\p{^In=v40}', "");
    Expect(0, 983040, '\P{In=v40}', "");
    Expect(1, 983040, '\P{^In=v40}', "");
    Expect(0, 983037, '\p{In=v40}', "");
    Expect(1, 983037, '\p{^In=v40}', "");
    Expect(1, 983037, '\P{In=v40}', "");
    Expect(0, 983037, '\P{^In=v40}', "");
    Expect(1, 983040, '\p{In=:\Av40\z:}', "");;
    Expect(0, 983037, '\p{In=:\Av40\z:}', "");;
    Expect(1, 983040, '\p{In=v4_0}', "");
    Expect(0, 983040, '\p{^In=v4_0}', "");
    Expect(0, 983040, '\P{In=v4_0}', "");
    Expect(1, 983040, '\P{^In=v4_0}', "");
    Expect(0, 983037, '\p{In=v4_0}', "");
    Expect(1, 983037, '\p{^In=v4_0}', "");
    Expect(1, 983037, '\P{In=v4_0}', "");
    Expect(0, 983037, '\P{^In=v4_0}', "");
    Error('\p{Is_Present_In:   :=+00000004.0}');
    Error('\P{Is_Present_In:   :=+00000004.0}');
    Expect(1, 983040, '\p{Is_Present_In=0000000004.0}', "");
    Expect(0, 983040, '\p{^Is_Present_In=0000000004.0}', "");
    Expect(0, 983040, '\P{Is_Present_In=0000000004.0}', "");
    Expect(1, 983040, '\P{^Is_Present_In=0000000004.0}', "");
    Expect(0, 983037, '\p{Is_Present_In=0000000004.0}', "");
    Expect(1, 983037, '\p{^Is_Present_In=0000000004.0}', "");
    Expect(1, 983037, '\P{Is_Present_In=0000000004.0}', "");
    Expect(0, 983037, '\P{^Is_Present_In=0000000004.0}', "");
    Error('\p{Is_In=_/a/V4_0}');
    Error('\P{Is_In=_/a/V4_0}');
    Expect(1, 983040, '\p{Is_In:	v40}', "");
    Expect(0, 983040, '\p{^Is_In:	v40}', "");
    Expect(0, 983040, '\P{Is_In:	v40}', "");
    Expect(1, 983040, '\P{^Is_In:	v40}', "");
    Expect(0, 983037, '\p{Is_In:	v40}', "");
    Expect(1, 983037, '\p{^Is_In:	v40}', "");
    Expect(1, 983037, '\P{Is_In:	v40}', "");
    Expect(0, 983037, '\P{^Is_In:	v40}', "");
    Expect(1, 983040, '\p{Is_In=	v4_0}', "");
    Expect(0, 983040, '\p{^Is_In=	v4_0}', "");
    Expect(0, 983040, '\P{Is_In=	v4_0}', "");
    Expect(1, 983040, '\P{^Is_In=	v4_0}', "");
    Expect(0, 983037, '\p{Is_In=	v4_0}', "");
    Expect(1, 983037, '\p{^Is_In=	v4_0}', "");
    Expect(1, 983037, '\P{Is_In=	v4_0}', "");
    Expect(0, 983037, '\P{^Is_In=	v4_0}', "");
    Error('\p{Present_In=_	004.1:=}');
    Error('\P{Present_In=_	004.1:=}');
    Expect(1, 983040, '\p{Present_In=:\A4.1\z:}', "");;
    Expect(0, 983037, '\p{Present_In=:\A4.1\z:}', "");;
    Expect(1, 983040, '\p{Present_In=0_0_04.1}', "");
    Expect(0, 983040, '\p{^Present_In=0_0_04.1}', "");
    Expect(0, 983040, '\P{Present_In=0_0_04.1}', "");
    Expect(1, 983040, '\P{^Present_In=0_0_04.1}', "");
    Expect(0, 983037, '\p{Present_In=0_0_04.1}', "");
    Expect(1, 983037, '\p{^Present_In=0_0_04.1}', "");
    Expect(1, 983037, '\P{Present_In=0_0_04.1}', "");
    Expect(0, 983037, '\P{^Present_In=0_0_04.1}', "");
    Error('\p{In:		v4_1/a/}');
    Error('\P{In:		v4_1/a/}');
    Expect(1, 983040, '\p{In=:\AV4_1\z:}', "");;
    Expect(0, 983037, '\p{In=:\AV4_1\z:}', "");;
    Expect(1, 983040, '\p{In=v41}', "");
    Expect(0, 983040, '\p{^In=v41}', "");
    Expect(0, 983040, '\P{In=v41}', "");
    Expect(1, 983040, '\P{^In=v41}', "");
    Expect(0, 983037, '\p{In=v41}', "");
    Expect(1, 983037, '\p{^In=v41}', "");
    Expect(1, 983037, '\P{In=v41}', "");
    Expect(0, 983037, '\P{^In=v41}', "");
    Expect(1, 983040, '\p{In=:\Av41\z:}', "");;
    Expect(0, 983037, '\p{In=:\Av41\z:}', "");;
    Expect(1, 983040, '\p{In=		V4_1}', "");
    Expect(0, 983040, '\p{^In=		V4_1}', "");
    Expect(0, 983040, '\P{In=		V4_1}', "");
    Expect(1, 983040, '\P{^In=		V4_1}', "");
    Expect(0, 983037, '\p{In=		V4_1}', "");
    Expect(1, 983037, '\p{^In=		V4_1}', "");
    Expect(1, 983037, '\P{In=		V4_1}', "");
    Expect(0, 983037, '\P{^In=		V4_1}', "");
    Error('\p{Is_Present_In=	0_0_04.1/a/}');
    Error('\P{Is_Present_In=	0_0_04.1/a/}');
    Expect(1, 983040, '\p{Is_Present_In=4.1}', "");
    Expect(0, 983040, '\p{^Is_Present_In=4.1}', "");
    Expect(0, 983040, '\P{Is_Present_In=4.1}', "");
    Expect(1, 983040, '\P{^Is_Present_In=4.1}', "");
    Expect(0, 983037, '\p{Is_Present_In=4.1}', "");
    Expect(1, 983037, '\p{^Is_Present_In=4.1}', "");
    Expect(1, 983037, '\P{Is_Present_In=4.1}', "");
    Expect(0, 983037, '\P{^Is_Present_In=4.1}', "");
    Error('\p{Is_In=		V4_1:=}');
    Error('\P{Is_In=		V4_1:=}');
    Expect(1, 983040, '\p{Is_In=v41}', "");
    Expect(0, 983040, '\p{^Is_In=v41}', "");
    Expect(0, 983040, '\P{Is_In=v41}', "");
    Expect(1, 983040, '\P{^Is_In=v41}', "");
    Expect(0, 983037, '\p{Is_In=v41}', "");
    Expect(1, 983037, '\p{^Is_In=v41}', "");
    Expect(1, 983037, '\P{Is_In=v41}', "");
    Expect(0, 983037, '\P{^Is_In=v41}', "");
    Expect(1, 983040, '\p{Is_In= -v4_1}', "");
    Expect(0, 983040, '\p{^Is_In= -v4_1}', "");
    Expect(0, 983040, '\P{Is_In= -v4_1}', "");
    Expect(1, 983040, '\P{^Is_In= -v4_1}', "");
    Expect(0, 983037, '\p{Is_In= -v4_1}', "");
    Expect(1, 983037, '\p{^Is_In= -v4_1}', "");
    Expect(1, 983037, '\P{Is_In= -v4_1}', "");
    Expect(0, 983037, '\P{^Is_In= -v4_1}', "");
    Error('\p{Present_In=	_0_0_0_0_0_0_0_05.0:=}');
    Error('\P{Present_In=	_0_0_0_0_0_0_0_05.0:=}');
    Expect(1, 983040, '\p{Present_In=:\A5.0\z:}', "");;
    Expect(0, 983037, '\p{Present_In=:\A5.0\z:}', "");;
    Expect(1, 983040, '\p{Present_In=000000005.0}', "");
    Expect(0, 983040, '\p{^Present_In=000000005.0}', "");
    Expect(0, 983040, '\P{Present_In=000000005.0}', "");
    Expect(1, 983040, '\P{^Present_In=000000005.0}', "");
    Expect(0, 983037, '\p{Present_In=000000005.0}', "");
    Expect(1, 983037, '\p{^Present_In=000000005.0}', "");
    Expect(1, 983037, '\P{Present_In=000000005.0}', "");
    Expect(0, 983037, '\P{^Present_In=000000005.0}', "");
    Error('\p{In=/a/_ V5_0}');
    Error('\P{In=/a/_ V5_0}');
    Expect(1, 983040, '\p{In=:\AV5_0\z:}', "");;
    Expect(0, 983037, '\p{In=:\AV5_0\z:}', "");;
    Expect(1, 983040, '\p{In=v50}', "");
    Expect(0, 983040, '\p{^In=v50}', "");
    Expect(0, 983040, '\P{In=v50}', "");
    Expect(1, 983040, '\P{^In=v50}', "");
    Expect(0, 983037, '\p{In=v50}', "");
    Expect(1, 983037, '\p{^In=v50}', "");
    Expect(1, 983037, '\P{In=v50}', "");
    Expect(0, 983037, '\P{^In=v50}', "");
    Expect(1, 983040, '\p{In=:\Av50\z:}', "");;
    Expect(0, 983037, '\p{In=:\Av50\z:}', "");;
    Expect(1, 983040, '\p{In= _V5_0}', "");
    Expect(0, 983040, '\p{^In= _V5_0}', "");
    Expect(0, 983040, '\P{In= _V5_0}', "");
    Expect(1, 983040, '\P{^In= _V5_0}', "");
    Expect(0, 983037, '\p{In= _V5_0}', "");
    Expect(1, 983037, '\p{^In= _V5_0}', "");
    Expect(1, 983037, '\P{In= _V5_0}', "");
    Expect(0, 983037, '\P{^In= _V5_0}', "");
    Error('\p{Is_Present_In=/a/_000005.0}');
    Error('\P{Is_Present_In=/a/_000005.0}');
    Expect(1, 983040, '\p{Is_Present_In=05.0}', "");
    Expect(0, 983040, '\p{^Is_Present_In=05.0}', "");
    Expect(0, 983040, '\P{Is_Present_In=05.0}', "");
    Expect(1, 983040, '\P{^Is_Present_In=05.0}', "");
    Expect(0, 983037, '\p{Is_Present_In=05.0}', "");
    Expect(1, 983037, '\p{^Is_Present_In=05.0}', "");
    Expect(1, 983037, '\P{Is_Present_In=05.0}', "");
    Expect(0, 983037, '\P{^Is_Present_In=05.0}', "");
    Error('\p{Is_In=-:=V5_0}');
    Error('\P{Is_In=-:=V5_0}');
    Expect(1, 983040, '\p{Is_In=v50}', "");
    Expect(0, 983040, '\p{^Is_In=v50}', "");
    Expect(0, 983040, '\P{Is_In=v50}', "");
    Expect(1, 983040, '\P{^Is_In=v50}', "");
    Expect(0, 983037, '\p{Is_In=v50}', "");
    Expect(1, 983037, '\p{^Is_In=v50}', "");
    Expect(1, 983037, '\P{Is_In=v50}', "");
    Expect(0, 983037, '\P{^Is_In=v50}', "");
    Expect(1, 983040, '\p{Is_In:--V5_0}', "");
    Expect(0, 983040, '\p{^Is_In:--V5_0}', "");
    Expect(0, 983040, '\P{Is_In:--V5_0}', "");
    Expect(1, 983040, '\P{^Is_In:--V5_0}', "");
    Expect(0, 983037, '\p{Is_In:--V5_0}', "");
    Expect(1, 983037, '\p{^Is_In:--V5_0}', "");
    Expect(1, 983037, '\P{Is_In:--V5_0}', "");
    Expect(0, 983037, '\P{^Is_In:--V5_0}', "");
    Error('\p{Present_In=	 5.1:=}');
    Error('\P{Present_In=	 5.1:=}');
    Expect(1, 983040, '\p{Present_In=:\A5.1\z:}', "");;
    Expect(0, 983037, '\p{Present_In=:\A5.1\z:}', "");;
    Expect(1, 983040, '\p{Present_In=00005.1}', "");
    Expect(0, 983040, '\p{^Present_In=00005.1}', "");
    Expect(0, 983040, '\P{Present_In=00005.1}', "");
    Expect(1, 983040, '\P{^Present_In=00005.1}', "");
    Expect(0, 983037, '\p{Present_In=00005.1}', "");
    Expect(1, 983037, '\p{^Present_In=00005.1}', "");
    Expect(1, 983037, '\P{Present_In=00005.1}', "");
    Expect(0, 983037, '\P{^Present_In=00005.1}', "");
    Error('\p{In=-_V5_1/a/}');
    Error('\P{In=-_V5_1/a/}');
    Expect(1, 983040, '\p{In=:\AV5_1\z:}', "");;
    Expect(0, 983037, '\p{In=:\AV5_1\z:}', "");;
    Expect(1, 983040, '\p{In=v51}', "");
    Expect(0, 983040, '\p{^In=v51}', "");
    Expect(0, 983040, '\P{In=v51}', "");
    Expect(1, 983040, '\P{^In=v51}', "");
    Expect(0, 983037, '\p{In=v51}', "");
    Expect(1, 983037, '\p{^In=v51}', "");
    Expect(1, 983037, '\P{In=v51}', "");
    Expect(0, 983037, '\P{^In=v51}', "");
    Expect(1, 983040, '\p{In=:\Av51\z:}', "");;
    Expect(0, 983037, '\p{In=:\Av51\z:}', "");;
    Expect(1, 983040, '\p{In=	v5_1}', "");
    Expect(0, 983040, '\p{^In=	v5_1}', "");
    Expect(0, 983040, '\P{In=	v5_1}', "");
    Expect(1, 983040, '\P{^In=	v5_1}', "");
    Expect(0, 983037, '\p{In=	v5_1}', "");
    Expect(1, 983037, '\p{^In=	v5_1}', "");
    Expect(1, 983037, '\P{In=	v5_1}', "");
    Expect(0, 983037, '\P{^In=	v5_1}', "");
    Error('\p{Is_Present_In=_000_000_05.1:=}');
    Error('\P{Is_Present_In=_000_000_05.1:=}');
    Expect(1, 983040, '\p{Is_Present_In=+0_0_0_0_0_00005.1}', "");
    Expect(0, 983040, '\p{^Is_Present_In=+0_0_0_0_0_00005.1}', "");
    Expect(0, 983040, '\P{Is_Present_In=+0_0_0_0_0_00005.1}', "");
    Expect(1, 983040, '\P{^Is_Present_In=+0_0_0_0_0_00005.1}', "");
    Expect(0, 983037, '\p{Is_Present_In=+0_0_0_0_0_00005.1}', "");
    Expect(1, 983037, '\p{^Is_Present_In=+0_0_0_0_0_00005.1}', "");
    Expect(1, 983037, '\P{Is_Present_In=+0_0_0_0_0_00005.1}', "");
    Expect(0, 983037, '\P{^Is_Present_In=+0_0_0_0_0_00005.1}', "");
    Error('\p{Is_In= /a/v5_1}');
    Error('\P{Is_In= /a/v5_1}');
    Expect(1, 983040, '\p{Is_In=v51}', "");
    Expect(0, 983040, '\p{^Is_In=v51}', "");
    Expect(0, 983040, '\P{Is_In=v51}', "");
    Expect(1, 983040, '\P{^Is_In=v51}', "");
    Expect(0, 983037, '\p{Is_In=v51}', "");
    Expect(1, 983037, '\p{^Is_In=v51}', "");
    Expect(1, 983037, '\P{Is_In=v51}', "");
    Expect(0, 983037, '\P{^Is_In=v51}', "");
    Expect(1, 983040, '\p{Is_In= -V5_1}', "");
    Expect(0, 983040, '\p{^Is_In= -V5_1}', "");
    Expect(0, 983040, '\P{Is_In= -V5_1}', "");
    Expect(1, 983040, '\P{^Is_In= -V5_1}', "");
    Expect(0, 983037, '\p{Is_In= -V5_1}', "");
    Expect(1, 983037, '\p{^Is_In= -V5_1}', "");
    Expect(1, 983037, '\P{Is_In= -V5_1}', "");
    Expect(0, 983037, '\P{^Is_In= -V5_1}', "");
    Error('\p{Present_In=-000000000_5.2/a/}');
    Error('\P{Present_In=-000000000_5.2/a/}');
    Expect(1, 983040, '\p{Present_In=:\A5.2\z:}', "");;
    Expect(0, 983037, '\p{Present_In=:\A5.2\z:}', "");;
    Expect(1, 983040, '\p{Present_In=000005.2}', "");
    Expect(0, 983040, '\p{^Present_In=000005.2}', "");
    Expect(0, 983040, '\P{Present_In=000005.2}', "");
    Expect(1, 983040, '\P{^Present_In=000005.2}', "");
    Expect(0, 983037, '\p{Present_In=000005.2}', "");
    Expect(1, 983037, '\p{^Present_In=000005.2}', "");
    Expect(1, 983037, '\P{Present_In=000005.2}', "");
    Expect(0, 983037, '\P{^Present_In=000005.2}', "");
    Error('\p{In=	:=v5_2}');
    Error('\P{In=	:=v5_2}');
    Expect(1, 983040, '\p{In=:\AV5_2\z:}', "");;
    Expect(0, 983037, '\p{In=:\AV5_2\z:}', "");;
    Expect(1, 983040, '\p{In=v52}', "");
    Expect(0, 983040, '\p{^In=v52}', "");
    Expect(0, 983040, '\P{In=v52}', "");
    Expect(1, 983040, '\P{^In=v52}', "");
    Expect(0, 983037, '\p{In=v52}', "");
    Expect(1, 983037, '\p{^In=v52}', "");
    Expect(1, 983037, '\P{In=v52}', "");
    Expect(0, 983037, '\P{^In=v52}', "");
    Expect(1, 983040, '\p{In=:\Av52\z:}', "");;
    Expect(0, 983037, '\p{In=:\Av52\z:}', "");;
    Expect(1, 983040, '\p{In:- V5_2}', "");
    Expect(0, 983040, '\p{^In:- V5_2}', "");
    Expect(0, 983040, '\P{In:- V5_2}', "");
    Expect(1, 983040, '\P{^In:- V5_2}', "");
    Expect(0, 983037, '\p{In:- V5_2}', "");
    Expect(1, 983037, '\p{^In:- V5_2}', "");
    Expect(1, 983037, '\P{In:- V5_2}', "");
    Expect(0, 983037, '\P{^In:- V5_2}', "");
    Error('\p{Is_Present_In=:=00005.2}');
    Error('\P{Is_Present_In=:=00005.2}');
    Expect(1, 983040, '\p{Is_Present_In=+0000_5.2}', "");
    Expect(0, 983040, '\p{^Is_Present_In=+0000_5.2}', "");
    Expect(0, 983040, '\P{Is_Present_In=+0000_5.2}', "");
    Expect(1, 983040, '\P{^Is_Present_In=+0000_5.2}', "");
    Expect(0, 983037, '\p{Is_Present_In=+0000_5.2}', "");
    Expect(1, 983037, '\p{^Is_Present_In=+0000_5.2}', "");
    Expect(1, 983037, '\P{Is_Present_In=+0000_5.2}', "");
    Expect(0, 983037, '\P{^Is_Present_In=+0000_5.2}', "");
    Error('\p{Is_In=:= _V5_2}');
    Error('\P{Is_In=:= _V5_2}');
    Expect(1, 983040, '\p{Is_In=v52}', "");
    Expect(0, 983040, '\p{^Is_In=v52}', "");
    Expect(0, 983040, '\P{Is_In=v52}', "");
    Expect(1, 983040, '\P{^Is_In=v52}', "");
    Expect(0, 983037, '\p{Is_In=v52}', "");
    Expect(1, 983037, '\p{^Is_In=v52}', "");
    Expect(1, 983037, '\P{Is_In=v52}', "");
    Expect(0, 983037, '\P{^Is_In=v52}', "");
    Expect(1, 983040, '\p{Is_In=	 V5_2}', "");
    Expect(0, 983040, '\p{^Is_In=	 V5_2}', "");
    Expect(0, 983040, '\P{Is_In=	 V5_2}', "");
    Expect(1, 983040, '\P{^Is_In=	 V5_2}', "");
    Expect(0, 983037, '\p{Is_In=	 V5_2}', "");
    Expect(1, 983037, '\p{^Is_In=	 V5_2}', "");
    Expect(1, 983037, '\P{Is_In=	 V5_2}', "");
    Expect(0, 983037, '\P{^Is_In=	 V5_2}', "");
    Error('\p{Present_In=:=-006.0}');
    Error('\P{Present_In=:=-006.0}');
    Expect(1, 983040, '\p{Present_In=:\A6.0\z:}', "");;
    Expect(0, 983037, '\p{Present_In=:\A6.0\z:}', "");;
    Expect(1, 983040, '\p{Present_In=000006.0}', "");
    Expect(0, 983040, '\p{^Present_In=000006.0}', "");
    Expect(0, 983040, '\P{Present_In=000006.0}', "");
    Expect(1, 983040, '\P{^Present_In=000006.0}', "");
    Expect(0, 983037, '\p{Present_In=000006.0}', "");
    Expect(1, 983037, '\p{^Present_In=000006.0}', "");
    Expect(1, 983037, '\P{Present_In=000006.0}', "");
    Expect(0, 983037, '\P{^Present_In=000006.0}', "");
    Error('\p{In=	V6_0:=}');
    Error('\P{In=	V6_0:=}');
    Expect(1, 983040, '\p{In=:\AV6_0\z:}', "");;
    Expect(0, 983037, '\p{In=:\AV6_0\z:}', "");;
    Expect(1, 983040, '\p{In=v60}', "");
    Expect(0, 983040, '\p{^In=v60}', "");
    Expect(0, 983040, '\P{In=v60}', "");
    Expect(1, 983040, '\P{^In=v60}', "");
    Expect(0, 983037, '\p{In=v60}', "");
    Expect(1, 983037, '\p{^In=v60}', "");
    Expect(1, 983037, '\P{In=v60}', "");
    Expect(0, 983037, '\P{^In=v60}', "");
    Expect(1, 983040, '\p{In=:\Av60\z:}', "");;
    Expect(0, 983037, '\p{In=:\Av60\z:}', "");;
    Expect(1, 983040, '\p{In=		V6_0}', "");
    Expect(0, 983040, '\p{^In=		V6_0}', "");
    Expect(0, 983040, '\P{In=		V6_0}', "");
    Expect(1, 983040, '\P{^In=		V6_0}', "");
    Expect(0, 983037, '\p{In=		V6_0}', "");
    Expect(1, 983037, '\p{^In=		V6_0}', "");
    Expect(1, 983037, '\P{In=		V6_0}', "");
    Expect(0, 983037, '\P{^In=		V6_0}', "");
    Error('\p{Is_Present_In=-:=06.0}');
    Error('\P{Is_Present_In=-:=06.0}');
    Expect(1, 983040, '\p{Is_Present_In=+0006.0}', "");
    Expect(0, 983040, '\p{^Is_Present_In=+0006.0}', "");
    Expect(0, 983040, '\P{Is_Present_In=+0006.0}', "");
    Expect(1, 983040, '\P{^Is_Present_In=+0006.0}', "");
    Expect(0, 983037, '\p{Is_Present_In=+0006.0}', "");
    Expect(1, 983037, '\p{^Is_Present_In=+0006.0}', "");
    Expect(1, 983037, '\P{Is_Present_In=+0006.0}', "");
    Expect(0, 983037, '\P{^Is_Present_In=+0006.0}', "");
    Error('\p{Is_In=	/a/V6_0}');
    Error('\P{Is_In=	/a/V6_0}');
    Expect(1, 983040, '\p{Is_In=v60}', "");
    Expect(0, 983040, '\p{^Is_In=v60}', "");
    Expect(0, 983040, '\P{Is_In=v60}', "");
    Expect(1, 983040, '\P{^Is_In=v60}', "");
    Expect(0, 983037, '\p{Is_In=v60}', "");
    Expect(1, 983037, '\p{^Is_In=v60}', "");
    Expect(1, 983037, '\P{Is_In=v60}', "");
    Expect(0, 983037, '\P{^Is_In=v60}', "");
    Expect(1, 983040, '\p{Is_In=-	V6_0}', "");
    Expect(0, 983040, '\p{^Is_In=-	V6_0}', "");
    Expect(0, 983040, '\P{Is_In=-	V6_0}', "");
    Expect(1, 983040, '\P{^Is_In=-	V6_0}', "");
    Expect(0, 983037, '\p{Is_In=-	V6_0}', "");
    Expect(1, 983037, '\p{^Is_In=-	V6_0}', "");
    Expect(1, 983037, '\P{Is_In=-	V6_0}', "");
    Expect(0, 983037, '\P{^Is_In=-	V6_0}', "");
    Error('\p{Present_In=	00006.1/a/}');
    Error('\P{Present_In=	00006.1/a/}');
    Expect(1, 983040, '\p{Present_In=:\A6.1\z:}', "");;
    Expect(0, 983037, '\p{Present_In=:\A6.1\z:}', "");;
    Expect(1, 983040, '\p{Present_In=+000_6.1}', "");
    Expect(0, 983040, '\p{^Present_In=+000_6.1}', "");
    Expect(0, 983040, '\P{Present_In=+000_6.1}', "");
    Expect(1, 983040, '\P{^Present_In=+000_6.1}', "");
    Expect(0, 983037, '\p{Present_In=+000_6.1}', "");
    Expect(1, 983037, '\p{^Present_In=+000_6.1}', "");
    Expect(1, 983037, '\P{Present_In=+000_6.1}', "");
    Expect(0, 983037, '\P{^Present_In=+000_6.1}', "");
    Error('\p{In=/a/	v6_1}');
    Error('\P{In=/a/	v6_1}');
    Expect(1, 983040, '\p{In=:\AV6_1\z:}', "");;
    Expect(0, 983037, '\p{In=:\AV6_1\z:}', "");;
    Expect(1, 983040, '\p{In:   v61}', "");
    Expect(0, 983040, '\p{^In:   v61}', "");
    Expect(0, 983040, '\P{In:   v61}', "");
    Expect(1, 983040, '\P{^In:   v61}', "");
    Expect(0, 983037, '\p{In:   v61}', "");
    Expect(1, 983037, '\p{^In:   v61}', "");
    Expect(1, 983037, '\P{In:   v61}', "");
    Expect(0, 983037, '\P{^In:   v61}', "");
    Expect(1, 983040, '\p{In=:\Av61\z:}', "");;
    Expect(0, 983037, '\p{In=:\Av61\z:}', "");;
    Expect(1, 983040, '\p{In=_-v6_1}', "");
    Expect(0, 983040, '\p{^In=_-v6_1}', "");
    Expect(0, 983040, '\P{In=_-v6_1}', "");
    Expect(1, 983040, '\P{^In=_-v6_1}', "");
    Expect(0, 983037, '\p{In=_-v6_1}', "");
    Expect(1, 983037, '\p{^In=_-v6_1}', "");
    Expect(1, 983037, '\P{In=_-v6_1}', "");
    Expect(0, 983037, '\P{^In=_-v6_1}', "");
    Error('\p{Is_Present_In=:=-_006.1}');
    Error('\P{Is_Present_In=:=-_006.1}');
    Expect(1, 983040, '\p{Is_Present_In=+0_0_0_006.1}', "");
    Expect(0, 983040, '\p{^Is_Present_In=+0_0_0_006.1}', "");
    Expect(0, 983040, '\P{Is_Present_In=+0_0_0_006.1}', "");
    Expect(1, 983040, '\P{^Is_Present_In=+0_0_0_006.1}', "");
    Expect(0, 983037, '\p{Is_Present_In=+0_0_0_006.1}', "");
    Expect(1, 983037, '\p{^Is_Present_In=+0_0_0_006.1}', "");
    Expect(1, 983037, '\P{Is_Present_In=+0_0_0_006.1}', "");
    Expect(0, 983037, '\P{^Is_Present_In=+0_0_0_006.1}', "");
    Error('\p{Is_In:   :=- V6_1}');
    Error('\P{Is_In:   :=- V6_1}');
    Expect(1, 983040, '\p{Is_In=v61}', "");
    Expect(0, 983040, '\p{^Is_In=v61}', "");
    Expect(0, 983040, '\P{Is_In=v61}', "");
    Expect(1, 983040, '\P{^Is_In=v61}', "");
    Expect(0, 983037, '\p{Is_In=v61}', "");
    Expect(1, 983037, '\p{^Is_In=v61}', "");
    Expect(1, 983037, '\P{Is_In=v61}', "");
    Expect(0, 983037, '\P{^Is_In=v61}', "");
    Expect(1, 983040, '\p{Is_In= V6_1}', "");
    Expect(0, 983040, '\p{^Is_In= V6_1}', "");
    Expect(0, 983040, '\P{Is_In= V6_1}', "");
    Expect(1, 983040, '\P{^Is_In= V6_1}', "");
    Expect(0, 983037, '\p{Is_In= V6_1}', "");
    Expect(1, 983037, '\p{^Is_In= V6_1}', "");
    Expect(1, 983037, '\P{Is_In= V6_1}', "");
    Expect(0, 983037, '\P{^Is_In= V6_1}', "");
    Error('\p{Present_In= /a/+0000_6.2}');
    Error('\P{Present_In= /a/+0000_6.2}');
    Expect(1, 983040, '\p{Present_In=:\A6.2\z:}', "");;
    Expect(0, 983037, '\p{Present_In=:\A6.2\z:}', "");;
    Expect(1, 983040, '\p{Present_In=+000006.2}', "");
    Expect(0, 983040, '\p{^Present_In=+000006.2}', "");
    Expect(0, 983040, '\P{Present_In=+000006.2}', "");
    Expect(1, 983040, '\P{^Present_In=+000006.2}', "");
    Expect(0, 983037, '\p{Present_In=+000006.2}', "");
    Expect(1, 983037, '\p{^Present_In=+000006.2}', "");
    Expect(1, 983037, '\P{Present_In=+000006.2}', "");
    Expect(0, 983037, '\P{^Present_In=+000006.2}', "");
    Error('\p{In=	:=V6_2}');
    Error('\P{In=	:=V6_2}');
    Expect(1, 983040, '\p{In=:\AV6_2\z:}', "");;
    Expect(0, 983037, '\p{In=:\AV6_2\z:}', "");;
    Expect(1, 983040, '\p{In=v62}', "");
    Expect(0, 983040, '\p{^In=v62}', "");
    Expect(0, 983040, '\P{In=v62}', "");
    Expect(1, 983040, '\P{^In=v62}', "");
    Expect(0, 983037, '\p{In=v62}', "");
    Expect(1, 983037, '\p{^In=v62}', "");
    Expect(1, 983037, '\P{In=v62}', "");
    Expect(0, 983037, '\P{^In=v62}', "");
    Expect(1, 983040, '\p{In=:\Av62\z:}', "");;
    Expect(0, 983037, '\p{In=:\Av62\z:}', "");;
    Expect(1, 983040, '\p{In=_V6_2}', "");
    Expect(0, 983040, '\p{^In=_V6_2}', "");
    Expect(0, 983040, '\P{In=_V6_2}', "");
    Expect(1, 983040, '\P{^In=_V6_2}', "");
    Expect(0, 983037, '\p{In=_V6_2}', "");
    Expect(1, 983037, '\p{^In=_V6_2}', "");
    Expect(1, 983037, '\P{In=_V6_2}', "");
    Expect(0, 983037, '\P{^In=_V6_2}', "");
    Error('\p{Is_Present_In= 	+00_00_00_6.2:=}');
    Error('\P{Is_Present_In= 	+00_00_00_6.2:=}');
    Expect(1, 983040, '\p{Is_Present_In=000000000_6.2}', "");
    Expect(0, 983040, '\p{^Is_Present_In=000000000_6.2}', "");
    Expect(0, 983040, '\P{Is_Present_In=000000000_6.2}', "");
    Expect(1, 983040, '\P{^Is_Present_In=000000000_6.2}', "");
    Expect(0, 983037, '\p{Is_Present_In=000000000_6.2}', "");
    Expect(1, 983037, '\p{^Is_Present_In=000000000_6.2}', "");
    Expect(1, 983037, '\P{Is_Present_In=000000000_6.2}', "");
    Expect(0, 983037, '\P{^Is_Present_In=000000000_6.2}', "");
    Error('\p{Is_In=/a/--v6_2}');
    Error('\P{Is_In=/a/--v6_2}');
    Expect(1, 983040, '\p{Is_In=v62}', "");
    Expect(0, 983040, '\p{^Is_In=v62}', "");
    Expect(0, 983040, '\P{Is_In=v62}', "");
    Expect(1, 983040, '\P{^Is_In=v62}', "");
    Expect(0, 983037, '\p{Is_In=v62}', "");
    Expect(1, 983037, '\p{^Is_In=v62}', "");
    Expect(1, 983037, '\P{Is_In=v62}', "");
    Expect(0, 983037, '\P{^Is_In=v62}', "");
    Expect(1, 983040, '\p{Is_In=_V6_2}', "");
    Expect(0, 983040, '\p{^Is_In=_V6_2}', "");
    Expect(0, 983040, '\P{Is_In=_V6_2}', "");
    Expect(1, 983040, '\P{^Is_In=_V6_2}', "");
    Expect(0, 983037, '\p{Is_In=_V6_2}', "");
    Expect(1, 983037, '\p{^Is_In=_V6_2}', "");
    Expect(1, 983037, '\P{Is_In=_V6_2}', "");
    Expect(0, 983037, '\P{^Is_In=_V6_2}', "");
    Error('\p{Present_In=__0_0_0_0_06.3:=}');
    Error('\P{Present_In=__0_0_0_0_06.3:=}');
    Expect(1, 983040, '\p{Present_In=:\A6.3\z:}', "");;
    Expect(0, 983037, '\p{Present_In=:\A6.3\z:}', "");;
    Expect(1, 983040, '\p{Present_In:	0_0_0_06.3}', "");
    Expect(0, 983040, '\p{^Present_In:	0_0_0_06.3}', "");
    Expect(0, 983040, '\P{Present_In:	0_0_0_06.3}', "");
    Expect(1, 983040, '\P{^Present_In:	0_0_0_06.3}', "");
    Expect(0, 983037, '\p{Present_In:	0_0_0_06.3}', "");
    Expect(1, 983037, '\p{^Present_In:	0_0_0_06.3}', "");
    Expect(1, 983037, '\P{Present_In:	0_0_0_06.3}', "");
    Expect(0, 983037, '\P{^Present_In:	0_0_0_06.3}', "");
    Error('\p{In=:= 	V6_3}');
    Error('\P{In=:= 	V6_3}');
    Expect(1, 983040, '\p{In=:\AV6_3\z:}', "");;
    Expect(0, 983037, '\p{In=:\AV6_3\z:}', "");;
    Expect(1, 983040, '\p{In:v63}', "");
    Expect(0, 983040, '\p{^In:v63}', "");
    Expect(0, 983040, '\P{In:v63}', "");
    Expect(1, 983040, '\P{^In:v63}', "");
    Expect(0, 983037, '\p{In:v63}', "");
    Expect(1, 983037, '\p{^In:v63}', "");
    Expect(1, 983037, '\P{In:v63}', "");
    Expect(0, 983037, '\P{^In:v63}', "");
    Expect(1, 983040, '\p{In=:\Av63\z:}', "");;
    Expect(0, 983037, '\p{In=:\Av63\z:}', "");;
    Expect(1, 983040, '\p{In=	_v6_3}', "");
    Expect(0, 983040, '\p{^In=	_v6_3}', "");
    Expect(0, 983040, '\P{In=	_v6_3}', "");
    Expect(1, 983040, '\P{^In=	_v6_3}', "");
    Expect(0, 983037, '\p{In=	_v6_3}', "");
    Expect(1, 983037, '\p{^In=	_v6_3}', "");
    Expect(1, 983037, '\P{In=	_v6_3}', "");
    Expect(0, 983037, '\P{^In=	_v6_3}', "");
    Error('\p{Is_Present_In=:=_	00_6.3}');
    Error('\P{Is_Present_In=:=_	00_6.3}');
    Expect(1, 983040, '\p{Is_Present_In=0_0_0_0_006.3}', "");
    Expect(0, 983040, '\p{^Is_Present_In=0_0_0_0_006.3}', "");
    Expect(0, 983040, '\P{Is_Present_In=0_0_0_0_006.3}', "");
    Expect(1, 983040, '\P{^Is_Present_In=0_0_0_0_006.3}', "");
    Expect(0, 983037, '\p{Is_Present_In=0_0_0_0_006.3}', "");
    Expect(1, 983037, '\p{^Is_Present_In=0_0_0_0_006.3}', "");
    Expect(1, 983037, '\P{Is_Present_In=0_0_0_0_006.3}', "");
    Expect(0, 983037, '\P{^Is_Present_In=0_0_0_0_006.3}', "");
    Error('\p{Is_In=-:=V6_3}');
    Error('\P{Is_In=-:=V6_3}');
    Expect(1, 983040, '\p{Is_In=v63}', "");
    Expect(0, 983040, '\p{^Is_In=v63}', "");
    Expect(0, 983040, '\P{Is_In=v63}', "");
    Expect(1, 983040, '\P{^Is_In=v63}', "");
    Expect(0, 983037, '\p{Is_In=v63}', "");
    Expect(1, 983037, '\p{^Is_In=v63}', "");
    Expect(1, 983037, '\P{Is_In=v63}', "");
    Expect(0, 983037, '\P{^Is_In=v63}', "");
    Expect(1, 983040, '\p{Is_In=-V6_3}', "");
    Expect(0, 983040, '\p{^Is_In=-V6_3}', "");
    Expect(0, 983040, '\P{Is_In=-V6_3}', "");
    Expect(1, 983040, '\P{^Is_In=-V6_3}', "");
    Expect(0, 983037, '\p{Is_In=-V6_3}', "");
    Expect(1, 983037, '\p{^Is_In=-V6_3}', "");
    Expect(1, 983037, '\P{Is_In=-V6_3}', "");
    Expect(0, 983037, '\P{^Is_In=-V6_3}', "");
    Error('\p{Present_In=:=- 000007.0}');
    Error('\P{Present_In=:=- 000007.0}');
    Expect(1, 983040, '\p{Present_In=:\A7.0\z:}', "");;
    Expect(0, 983037, '\p{Present_In=:\A7.0\z:}', "");;
    Expect(1, 983040, '\p{Present_In=00_7.0}', "");
    Expect(0, 983040, '\p{^Present_In=00_7.0}', "");
    Expect(0, 983040, '\P{Present_In=00_7.0}', "");
    Expect(1, 983040, '\P{^Present_In=00_7.0}', "");
    Expect(0, 983037, '\p{Present_In=00_7.0}', "");
    Expect(1, 983037, '\p{^Present_In=00_7.0}', "");
    Expect(1, 983037, '\P{Present_In=00_7.0}', "");
    Expect(0, 983037, '\P{^Present_In=00_7.0}', "");
    Error('\p{In=	:=v7_0}');
    Error('\P{In=	:=v7_0}');
    Expect(1, 983040, '\p{In=:\AV7_0\z:}', "");;
    Expect(0, 983037, '\p{In=:\AV7_0\z:}', "");;
    Expect(1, 983040, '\p{In=v70}', "");
    Expect(0, 983040, '\p{^In=v70}', "");
    Expect(0, 983040, '\P{In=v70}', "");
    Expect(1, 983040, '\P{^In=v70}', "");
    Expect(0, 983037, '\p{In=v70}', "");
    Expect(1, 983037, '\p{^In=v70}', "");
    Expect(1, 983037, '\P{In=v70}', "");
    Expect(0, 983037, '\P{^In=v70}', "");
    Expect(1, 983040, '\p{In=:\Av70\z:}', "");;
    Expect(0, 983037, '\p{In=:\Av70\z:}', "");;
    Expect(1, 983040, '\p{In=v7_0}', "");
    Expect(0, 983040, '\p{^In=v7_0}', "");
    Expect(0, 983040, '\P{In=v7_0}', "");
    Expect(1, 983040, '\P{^In=v7_0}', "");
    Expect(0, 983037, '\p{In=v7_0}', "");
    Expect(1, 983037, '\p{^In=v7_0}', "");
    Expect(1, 983037, '\P{In=v7_0}', "");
    Expect(0, 983037, '\P{^In=v7_0}', "");
    Error('\p{Is_Present_In: :=7.0}');
    Error('\P{Is_Present_In: :=7.0}');
    Expect(1, 983040, '\p{Is_Present_In=0_0_0_0_0_007.0}', "");
    Expect(0, 983040, '\p{^Is_Present_In=0_0_0_0_0_007.0}', "");
    Expect(0, 983040, '\P{Is_Present_In=0_0_0_0_0_007.0}', "");
    Expect(1, 983040, '\P{^Is_Present_In=0_0_0_0_0_007.0}', "");
    Expect(0, 983037, '\p{Is_Present_In=0_0_0_0_0_007.0}', "");
    Expect(1, 983037, '\p{^Is_Present_In=0_0_0_0_0_007.0}', "");
    Expect(1, 983037, '\P{Is_Present_In=0_0_0_0_0_007.0}', "");
    Expect(0, 983037, '\P{^Is_Present_In=0_0_0_0_0_007.0}', "");
    Error('\p{Is_In=:=V7_0}');
    Error('\P{Is_In=:=V7_0}');
    Expect(1, 983040, '\p{Is_In=v70}', "");
    Expect(0, 983040, '\p{^Is_In=v70}', "");
    Expect(0, 983040, '\P{Is_In=v70}', "");
    Expect(1, 983040, '\P{^Is_In=v70}', "");
    Expect(0, 983037, '\p{Is_In=v70}', "");
    Expect(1, 983037, '\p{^Is_In=v70}', "");
    Expect(1, 983037, '\P{Is_In=v70}', "");
    Expect(0, 983037, '\P{^Is_In=v70}', "");
    Expect(1, 983040, '\p{Is_In: v7_0}', "");
    Expect(0, 983040, '\p{^Is_In: v7_0}', "");
    Expect(0, 983040, '\P{Is_In: v7_0}', "");
    Expect(1, 983040, '\P{^Is_In: v7_0}', "");
    Expect(0, 983037, '\p{Is_In: v7_0}', "");
    Expect(1, 983037, '\p{^Is_In: v7_0}', "");
    Expect(1, 983037, '\P{Is_In: v7_0}', "");
    Expect(0, 983037, '\P{^Is_In: v7_0}', "");
    Error('\p{Present_In=-:=000008.0}');
    Error('\P{Present_In=-:=000008.0}');
    Expect(1, 983040, '\p{Present_In=:\A8.0\z:}', "");;
    Expect(0, 983037, '\p{Present_In=:\A8.0\z:}', "");;
    Expect(1, 983040, '\p{Present_In=+00_8.0}', "");
    Expect(0, 983040, '\p{^Present_In=+00_8.0}', "");
    Expect(0, 983040, '\P{Present_In=+00_8.0}', "");
    Expect(1, 983040, '\P{^Present_In=+00_8.0}', "");
    Expect(0, 983037, '\p{Present_In=+00_8.0}', "");
    Expect(1, 983037, '\p{^Present_In=+00_8.0}', "");
    Expect(1, 983037, '\P{Present_In=+00_8.0}', "");
    Expect(0, 983037, '\P{^Present_In=+00_8.0}', "");
    Error('\p{In=/a/- V8_0}');
    Error('\P{In=/a/- V8_0}');
    Expect(1, 983040, '\p{In=:\AV8_0\z:}', "");;
    Expect(0, 983037, '\p{In=:\AV8_0\z:}', "");;
    Expect(1, 983040, '\p{In=v80}', "");
    Expect(0, 983040, '\p{^In=v80}', "");
    Expect(0, 983040, '\P{In=v80}', "");
    Expect(1, 983040, '\P{^In=v80}', "");
    Expect(0, 983037, '\p{In=v80}', "");
    Expect(1, 983037, '\p{^In=v80}', "");
    Expect(1, 983037, '\P{In=v80}', "");
    Expect(0, 983037, '\P{^In=v80}', "");
    Expect(1, 983040, '\p{In=:\Av80\z:}', "");;
    Expect(0, 983037, '\p{In=:\Av80\z:}', "");;
    Expect(1, 983040, '\p{In=  V8_0}', "");
    Expect(0, 983040, '\p{^In=  V8_0}', "");
    Expect(0, 983040, '\P{In=  V8_0}', "");
    Expect(1, 983040, '\P{^In=  V8_0}', "");
    Expect(0, 983037, '\p{In=  V8_0}', "");
    Expect(1, 983037, '\p{^In=  V8_0}', "");
    Expect(1, 983037, '\P{In=  V8_0}', "");
    Expect(0, 983037, '\P{^In=  V8_0}', "");
    Error('\p{Is_Present_In=/a/+0_0_0_0_0_0_008.0}');
    Error('\P{Is_Present_In=/a/+0_0_0_0_0_0_008.0}');
    Expect(1, 983040, '\p{Is_Present_In=8.0}', "");
    Expect(0, 983040, '\p{^Is_Present_In=8.0}', "");
    Expect(0, 983040, '\P{Is_Present_In=8.0}', "");
    Expect(1, 983040, '\P{^Is_Present_In=8.0}', "");
    Expect(0, 983037, '\p{Is_Present_In=8.0}', "");
    Expect(1, 983037, '\p{^Is_Present_In=8.0}', "");
    Expect(1, 983037, '\P{Is_Present_In=8.0}', "");
    Expect(0, 983037, '\P{^Is_Present_In=8.0}', "");
    Error('\p{Is_In=__V8_0/a/}');
    Error('\P{Is_In=__V8_0/a/}');
    Expect(1, 983040, '\p{Is_In=v80}', "");
    Expect(0, 983040, '\p{^Is_In=v80}', "");
    Expect(0, 983040, '\P{Is_In=v80}', "");
    Expect(1, 983040, '\P{^Is_In=v80}', "");
    Expect(0, 983037, '\p{Is_In=v80}', "");
    Expect(1, 983037, '\p{^Is_In=v80}', "");
    Expect(1, 983037, '\P{Is_In=v80}', "");
    Expect(0, 983037, '\P{^Is_In=v80}', "");
    Expect(1, 983040, '\p{Is_In=_V8_0}', "");
    Expect(0, 983040, '\p{^Is_In=_V8_0}', "");
    Expect(0, 983040, '\P{Is_In=_V8_0}', "");
    Expect(1, 983040, '\P{^Is_In=_V8_0}', "");
    Expect(0, 983037, '\p{Is_In=_V8_0}', "");
    Expect(1, 983037, '\p{^Is_In=_V8_0}', "");
    Expect(1, 983037, '\P{Is_In=_V8_0}', "");
    Expect(0, 983037, '\P{^Is_In=_V8_0}', "");
    Error('\p{Present_In=:=0_9.0}');
    Error('\P{Present_In=:=0_9.0}');
    Expect(1, 983040, '\p{Present_In=:\A9.0\z:}', "");;
    Expect(0, 983037, '\p{Present_In=:\A9.0\z:}', "");;
    Expect(1, 983040, '\p{Present_In:	09.0}', "");
    Expect(0, 983040, '\p{^Present_In:	09.0}', "");
    Expect(0, 983040, '\P{Present_In:	09.0}', "");
    Expect(1, 983040, '\P{^Present_In:	09.0}', "");
    Expect(0, 983037, '\p{Present_In:	09.0}', "");
    Expect(1, 983037, '\p{^Present_In:	09.0}', "");
    Expect(1, 983037, '\P{Present_In:	09.0}', "");
    Expect(0, 983037, '\P{^Present_In:	09.0}', "");
    Error('\p{In=-	V9_0/a/}');
    Error('\P{In=-	V9_0/a/}');
    Expect(1, 983040, '\p{In=:\AV9_0\z:}', "");;
    Expect(0, 983037, '\p{In=:\AV9_0\z:}', "");;
    Expect(1, 983040, '\p{In=v90}', "");
    Expect(0, 983040, '\p{^In=v90}', "");
    Expect(0, 983040, '\P{In=v90}', "");
    Expect(1, 983040, '\P{^In=v90}', "");
    Expect(0, 983037, '\p{In=v90}', "");
    Expect(1, 983037, '\p{^In=v90}', "");
    Expect(1, 983037, '\P{In=v90}', "");
    Expect(0, 983037, '\P{^In=v90}', "");
    Expect(1, 983040, '\p{In=:\Av90\z:}', "");;
    Expect(0, 983037, '\p{In=:\Av90\z:}', "");;
    Expect(1, 983040, '\p{In=--V9_0}', "");
    Expect(0, 983040, '\p{^In=--V9_0}', "");
    Expect(0, 983040, '\P{In=--V9_0}', "");
    Expect(1, 983040, '\P{^In=--V9_0}', "");
    Expect(0, 983037, '\p{In=--V9_0}', "");
    Expect(1, 983037, '\p{^In=--V9_0}', "");
    Expect(1, 983037, '\P{In=--V9_0}', "");
    Expect(0, 983037, '\P{^In=--V9_0}', "");
    Error('\p{Is_Present_In=_0_0_0_0_0_09.0:=}');
    Error('\P{Is_Present_In=_0_0_0_0_0_09.0:=}');
    Expect(1, 983040, '\p{Is_Present_In=0_0_0_0_0_009.0}', "");
    Expect(0, 983040, '\p{^Is_Present_In=0_0_0_0_0_009.0}', "");
    Expect(0, 983040, '\P{Is_Present_In=0_0_0_0_0_009.0}', "");
    Expect(1, 983040, '\P{^Is_Present_In=0_0_0_0_0_009.0}', "");
    Expect(0, 983037, '\p{Is_Present_In=0_0_0_0_0_009.0}', "");
    Expect(1, 983037, '\p{^Is_Present_In=0_0_0_0_0_009.0}', "");
    Expect(1, 983037, '\P{Is_Present_In=0_0_0_0_0_009.0}', "");
    Expect(0, 983037, '\P{^Is_Present_In=0_0_0_0_0_009.0}', "");
    Error('\p{Is_In=	-v9_0:=}');
    Error('\P{Is_In=	-v9_0:=}');
    Expect(1, 983040, '\p{Is_In=v90}', "");
    Expect(0, 983040, '\p{^Is_In=v90}', "");
    Expect(0, 983040, '\P{Is_In=v90}', "");
    Expect(1, 983040, '\P{^Is_In=v90}', "");
    Expect(0, 983037, '\p{Is_In=v90}', "");
    Expect(1, 983037, '\p{^Is_In=v90}', "");
    Expect(1, 983037, '\P{Is_In=v90}', "");
    Expect(0, 983037, '\P{^Is_In=v90}', "");
    Expect(1, 983040, '\p{Is_In=-	v9_0}', "");
    Expect(0, 983040, '\p{^Is_In=-	v9_0}', "");
    Expect(0, 983040, '\P{Is_In=-	v9_0}', "");
    Expect(1, 983040, '\P{^Is_In=-	v9_0}', "");
    Expect(0, 983037, '\p{Is_In=-	v9_0}', "");
    Expect(1, 983037, '\p{^Is_In=-	v9_0}', "");
    Expect(1, 983037, '\P{Is_In=-	v9_0}', "");
    Expect(0, 983037, '\P{^Is_In=-	v9_0}', "");
    Error('\p{Present_In:  :=Unassigned}');
    Error('\P{Present_In:  :=Unassigned}');
    Expect(1, 983037, '\p{Present_In=:\AUnassigned\z:}', "");;
    Expect(0, 983040, '\p{Present_In=:\AUnassigned\z:}', "");;
    Expect(1, 983037, '\p{Present_In=unassigned}', "");
    Expect(0, 983037, '\p{^Present_In=unassigned}', "");
    Expect(0, 983037, '\P{Present_In=unassigned}', "");
    Expect(1, 983037, '\P{^Present_In=unassigned}', "");
    Expect(0, 983040, '\p{Present_In=unassigned}', "");
    Expect(1, 983040, '\p{^Present_In=unassigned}', "");
    Expect(1, 983040, '\P{Present_In=unassigned}', "");
    Expect(0, 983040, '\P{^Present_In=unassigned}', "");
    Expect(1, 983037, '\p{Present_In=:\Aunassigned\z:}', "");;
    Expect(0, 983040, '\p{Present_In=:\Aunassigned\z:}', "");;
    Expect(1, 983037, '\p{Present_In=-	UNASSIGNED}', "");
    Expect(0, 983037, '\p{^Present_In=-	UNASSIGNED}', "");
    Expect(0, 983037, '\P{Present_In=-	UNASSIGNED}', "");
    Expect(1, 983037, '\P{^Present_In=-	UNASSIGNED}', "");
    Expect(0, 983040, '\p{Present_In=-	UNASSIGNED}', "");
    Expect(1, 983040, '\p{^Present_In=-	UNASSIGNED}', "");
    Expect(1, 983040, '\P{Present_In=-	UNASSIGNED}', "");
    Expect(0, 983040, '\P{^Present_In=-	UNASSIGNED}', "");
    Error('\p{In=:=UNASSIGNED}');
    Error('\P{In=:=UNASSIGNED}');
    Expect(1, 983037, '\p{In=:\AUnassigned\z:}', "");;
    Expect(0, 983040, '\p{In=:\AUnassigned\z:}', "");;
    Expect(1, 983037, '\p{In=unassigned}', "");
    Expect(0, 983037, '\p{^In=unassigned}', "");
    Expect(0, 983037, '\P{In=unassigned}', "");
    Expect(1, 983037, '\P{^In=unassigned}', "");
    Expect(0, 983040, '\p{In=unassigned}', "");
    Expect(1, 983040, '\p{^In=unassigned}', "");
    Expect(1, 983040, '\P{In=unassigned}', "");
    Expect(0, 983040, '\P{^In=unassigned}', "");
    Expect(1, 983037, '\p{In=:\Aunassigned\z:}', "");;
    Expect(0, 983040, '\p{In=:\Aunassigned\z:}', "");;
    Expect(1, 983037, '\p{In=-	Unassigned}', "");
    Expect(0, 983037, '\p{^In=-	Unassigned}', "");
    Expect(0, 983037, '\P{In=-	Unassigned}', "");
    Expect(1, 983037, '\P{^In=-	Unassigned}', "");
    Expect(0, 983040, '\p{In=-	Unassigned}', "");
    Expect(1, 983040, '\p{^In=-	Unassigned}', "");
    Expect(1, 983040, '\P{In=-	Unassigned}', "");
    Expect(0, 983040, '\P{^In=-	Unassigned}', "");
    Error('\p{Is_Present_In=-UNASSIGNED:=}');
    Error('\P{Is_Present_In=-UNASSIGNED:=}');
    Expect(1, 983037, '\p{Is_Present_In=unassigned}', "");
    Expect(0, 983037, '\p{^Is_Present_In=unassigned}', "");
    Expect(0, 983037, '\P{Is_Present_In=unassigned}', "");
    Expect(1, 983037, '\P{^Is_Present_In=unassigned}', "");
    Expect(0, 983040, '\p{Is_Present_In=unassigned}', "");
    Expect(1, 983040, '\p{^Is_Present_In=unassigned}', "");
    Expect(1, 983040, '\P{Is_Present_In=unassigned}', "");
    Expect(0, 983040, '\P{^Is_Present_In=unassigned}', "");
    Expect(1, 983037, '\p{Is_Present_In=  unassigned}', "");
    Expect(0, 983037, '\p{^Is_Present_In=  unassigned}', "");
    Expect(0, 983037, '\P{Is_Present_In=  unassigned}', "");
    Expect(1, 983037, '\P{^Is_Present_In=  unassigned}', "");
    Expect(0, 983040, '\p{Is_Present_In=  unassigned}', "");
    Expect(1, 983040, '\p{^Is_Present_In=  unassigned}', "");
    Expect(1, 983040, '\P{Is_Present_In=  unassigned}', "");
    Expect(0, 983040, '\P{^Is_Present_In=  unassigned}', "");
    Error('\p{Is_In= /a/UNASSIGNED}');
    Error('\P{Is_In= /a/UNASSIGNED}');
    Expect(1, 983037, '\p{Is_In=unassigned}', "");
    Expect(0, 983037, '\p{^Is_In=unassigned}', "");
    Expect(0, 983037, '\P{Is_In=unassigned}', "");
    Expect(1, 983037, '\P{^Is_In=unassigned}', "");
    Expect(0, 983040, '\p{Is_In=unassigned}', "");
    Expect(1, 983040, '\p{^Is_In=unassigned}', "");
    Expect(1, 983040, '\P{Is_In=unassigned}', "");
    Expect(0, 983040, '\P{^Is_In=unassigned}', "");
    Expect(1, 983037, '\p{Is_In=__Unassigned}', "");
    Expect(0, 983037, '\p{^Is_In=__Unassigned}', "");
    Expect(0, 983037, '\P{Is_In=__Unassigned}', "");
    Expect(1, 983037, '\P{^Is_In=__Unassigned}', "");
    Expect(0, 983040, '\p{Is_In=__Unassigned}', "");
    Expect(1, 983040, '\p{^Is_In=__Unassigned}', "");
    Expect(1, 983040, '\P{Is_In=__Unassigned}', "");
    Expect(0, 983040, '\P{^Is_In=__Unassigned}', "");
    Error('\p{indicpositionalcategory}');
    Error('\P{indicpositionalcategory}');
    Error('\p{inpc}');
    Error('\P{inpc}');
    Error('\p{Indic_Positional_Category:	-bottom:=}');
    Error('\P{Indic_Positional_Category:	-bottom:=}');
    Expect(1, 73460, '\p{Indic_Positional_Category=:\ABottom\z:}', "");;
    Expect(0, 73461, '\p{Indic_Positional_Category=:\ABottom\z:}', "");;
    Expect(1, 73460, '\p{Indic_Positional_Category=bottom}', "");
    Expect(0, 73460, '\p{^Indic_Positional_Category=bottom}', "");
    Expect(0, 73460, '\P{Indic_Positional_Category=bottom}', "");
    Expect(1, 73460, '\P{^Indic_Positional_Category=bottom}', "");
    Expect(0, 73461, '\p{Indic_Positional_Category=bottom}', "");
    Expect(1, 73461, '\p{^Indic_Positional_Category=bottom}', "");
    Expect(1, 73461, '\P{Indic_Positional_Category=bottom}', "");
    Expect(0, 73461, '\P{^Indic_Positional_Category=bottom}', "");
    Expect(1, 73460, '\p{Indic_Positional_Category=:\Abottom\z:}', "");;
    Expect(0, 73461, '\p{Indic_Positional_Category=:\Abottom\z:}', "");;
    Expect(1, 73460, '\p{Indic_Positional_Category= 	bottom}', "");
    Expect(0, 73460, '\p{^Indic_Positional_Category= 	bottom}', "");
    Expect(0, 73460, '\P{Indic_Positional_Category= 	bottom}', "");
    Expect(1, 73460, '\P{^Indic_Positional_Category= 	bottom}', "");
    Expect(0, 73461, '\p{Indic_Positional_Category= 	bottom}', "");
    Expect(1, 73461, '\p{^Indic_Positional_Category= 	bottom}', "");
    Expect(1, 73461, '\P{Indic_Positional_Category= 	bottom}', "");
    Expect(0, 73461, '\P{^Indic_Positional_Category= 	bottom}', "");
    Error('\p{InPC= -Bottom/a/}');
    Error('\P{InPC= -Bottom/a/}');
    Expect(1, 73460, '\p{InPC=:\ABottom\z:}', "");;
    Expect(0, 73461, '\p{InPC=:\ABottom\z:}', "");;
    Expect(1, 73460, '\p{InPC: bottom}', "");
    Expect(0, 73460, '\p{^InPC: bottom}', "");
    Expect(0, 73460, '\P{InPC: bottom}', "");
    Expect(1, 73460, '\P{^InPC: bottom}', "");
    Expect(0, 73461, '\p{InPC: bottom}', "");
    Expect(1, 73461, '\p{^InPC: bottom}', "");
    Expect(1, 73461, '\P{InPC: bottom}', "");
    Expect(0, 73461, '\P{^InPC: bottom}', "");
    Expect(1, 73460, '\p{InPC=:\Abottom\z:}', "");;
    Expect(0, 73461, '\p{InPC=:\Abottom\z:}', "");;
    Expect(1, 73460, '\p{InPC=	Bottom}', "");
    Expect(0, 73460, '\p{^InPC=	Bottom}', "");
    Expect(0, 73460, '\P{InPC=	Bottom}', "");
    Expect(1, 73460, '\P{^InPC=	Bottom}', "");
    Expect(0, 73461, '\p{InPC=	Bottom}', "");
    Expect(1, 73461, '\p{^InPC=	Bottom}', "");
    Expect(1, 73461, '\P{InPC=	Bottom}', "");
    Expect(0, 73461, '\P{^InPC=	Bottom}', "");
    Error('\p{Is_Indic_Positional_Category=:= Bottom}');
    Error('\P{Is_Indic_Positional_Category=:= Bottom}');
    Expect(1, 73460, '\p{Is_Indic_Positional_Category=bottom}', "");
    Expect(0, 73460, '\p{^Is_Indic_Positional_Category=bottom}', "");
    Expect(0, 73460, '\P{Is_Indic_Positional_Category=bottom}', "");
    Expect(1, 73460, '\P{^Is_Indic_Positional_Category=bottom}', "");
    Expect(0, 73461, '\p{Is_Indic_Positional_Category=bottom}', "");
    Expect(1, 73461, '\p{^Is_Indic_Positional_Category=bottom}', "");
    Expect(1, 73461, '\P{Is_Indic_Positional_Category=bottom}', "");
    Expect(0, 73461, '\P{^Is_Indic_Positional_Category=bottom}', "");
    Expect(1, 73460, '\p{Is_Indic_Positional_Category=__Bottom}', "");
    Expect(0, 73460, '\p{^Is_Indic_Positional_Category=__Bottom}', "");
    Expect(0, 73460, '\P{Is_Indic_Positional_Category=__Bottom}', "");
    Expect(1, 73460, '\P{^Is_Indic_Positional_Category=__Bottom}', "");
    Expect(0, 73461, '\p{Is_Indic_Positional_Category=__Bottom}', "");
    Expect(1, 73461, '\p{^Is_Indic_Positional_Category=__Bottom}', "");
    Expect(1, 73461, '\P{Is_Indic_Positional_Category=__Bottom}', "");
    Expect(0, 73461, '\P{^Is_Indic_Positional_Category=__Bottom}', "");
    Error('\p{Is_InPC:   -:=bottom}');
    Error('\P{Is_InPC:   -:=bottom}');
    Expect(1, 73460, '\p{Is_InPC=bottom}', "");
    Expect(0, 73460, '\p{^Is_InPC=bottom}', "");
    Expect(0, 73460, '\P{Is_InPC=bottom}', "");
    Expect(1, 73460, '\P{^Is_InPC=bottom}', "");
    Expect(0, 73461, '\p{Is_InPC=bottom}', "");
    Expect(1, 73461, '\p{^Is_InPC=bottom}', "");
    Expect(1, 73461, '\P{Is_InPC=bottom}', "");
    Expect(0, 73461, '\P{^Is_InPC=bottom}', "");
    Expect(1, 73460, '\p{Is_InPC= 	Bottom}', "");
    Expect(0, 73460, '\p{^Is_InPC= 	Bottom}', "");
    Expect(0, 73460, '\P{Is_InPC= 	Bottom}', "");
    Expect(1, 73460, '\P{^Is_InPC= 	Bottom}', "");
    Expect(0, 73461, '\p{Is_InPC= 	Bottom}', "");
    Expect(1, 73461, '\p{^Is_InPC= 	Bottom}', "");
    Expect(1, 73461, '\P{Is_InPC= 	Bottom}', "");
    Expect(0, 73461, '\P{^Is_InPC= 	Bottom}', "");
    Error('\p{Indic_Positional_Category= :=BOTTOM_AND_Left}');
    Error('\P{Indic_Positional_Category= :=BOTTOM_AND_Left}');
    Expect(1, 43455, '\p{Indic_Positional_Category=:\ABottom_And_Left\z:}', "");;
    Expect(0, 43456, '\p{Indic_Positional_Category=:\ABottom_And_Left\z:}', "");;
    Expect(1, 43455, '\p{Indic_Positional_Category=bottomandleft}', "");
    Expect(0, 43455, '\p{^Indic_Positional_Category=bottomandleft}', "");
    Expect(0, 43455, '\P{Indic_Positional_Category=bottomandleft}', "");
    Expect(1, 43455, '\P{^Indic_Positional_Category=bottomandleft}', "");
    Expect(0, 43456, '\p{Indic_Positional_Category=bottomandleft}', "");
    Expect(1, 43456, '\p{^Indic_Positional_Category=bottomandleft}', "");
    Expect(1, 43456, '\P{Indic_Positional_Category=bottomandleft}', "");
    Expect(0, 43456, '\P{^Indic_Positional_Category=bottomandleft}', "");
    Expect(1, 43455, '\p{Indic_Positional_Category=:\Abottomandleft\z:}', "");;
    Expect(0, 43456, '\p{Indic_Positional_Category=:\Abottomandleft\z:}', "");;
    Expect(1, 43455, '\p{Indic_Positional_Category=	 Bottom_And_Left}', "");
    Expect(0, 43455, '\p{^Indic_Positional_Category=	 Bottom_And_Left}', "");
    Expect(0, 43455, '\P{Indic_Positional_Category=	 Bottom_And_Left}', "");
    Expect(1, 43455, '\P{^Indic_Positional_Category=	 Bottom_And_Left}', "");
    Expect(0, 43456, '\p{Indic_Positional_Category=	 Bottom_And_Left}', "");
    Expect(1, 43456, '\p{^Indic_Positional_Category=	 Bottom_And_Left}', "");
    Expect(1, 43456, '\P{Indic_Positional_Category=	 Bottom_And_Left}', "");
    Expect(0, 43456, '\P{^Indic_Positional_Category=	 Bottom_And_Left}', "");
    Error('\p{InPC=	Bottom_AND_Left/a/}');
    Error('\P{InPC=	Bottom_AND_Left/a/}');
    Expect(1, 43455, '\p{InPC=:\ABottom_And_Left\z:}', "");;
    Expect(0, 43456, '\p{InPC=:\ABottom_And_Left\z:}', "");;
    Expect(1, 43455, '\p{InPC=bottomandleft}', "");
    Expect(0, 43455, '\p{^InPC=bottomandleft}', "");
    Expect(0, 43455, '\P{InPC=bottomandleft}', "");
    Expect(1, 43455, '\P{^InPC=bottomandleft}', "");
    Expect(0, 43456, '\p{InPC=bottomandleft}', "");
    Expect(1, 43456, '\p{^InPC=bottomandleft}', "");
    Expect(1, 43456, '\P{InPC=bottomandleft}', "");
    Expect(0, 43456, '\P{^InPC=bottomandleft}', "");
    Expect(1, 43455, '\p{InPC=:\Abottomandleft\z:}', "");;
    Expect(0, 43456, '\p{InPC=:\Abottomandleft\z:}', "");;
    Expect(1, 43455, '\p{InPC=-Bottom_And_Left}', "");
    Expect(0, 43455, '\p{^InPC=-Bottom_And_Left}', "");
    Expect(0, 43455, '\P{InPC=-Bottom_And_Left}', "");
    Expect(1, 43455, '\P{^InPC=-Bottom_And_Left}', "");
    Expect(0, 43456, '\p{InPC=-Bottom_And_Left}', "");
    Expect(1, 43456, '\p{^InPC=-Bottom_And_Left}', "");
    Expect(1, 43456, '\P{InPC=-Bottom_And_Left}', "");
    Expect(0, 43456, '\P{^InPC=-Bottom_And_Left}', "");
    Error('\p{Is_Indic_Positional_Category= BOTTOM_And_LEFT/a/}');
    Error('\P{Is_Indic_Positional_Category= BOTTOM_And_LEFT/a/}');
    Expect(1, 43455, '\p{Is_Indic_Positional_Category=bottomandleft}', "");
    Expect(0, 43455, '\p{^Is_Indic_Positional_Category=bottomandleft}', "");
    Expect(0, 43455, '\P{Is_Indic_Positional_Category=bottomandleft}', "");
    Expect(1, 43455, '\P{^Is_Indic_Positional_Category=bottomandleft}', "");
    Expect(0, 43456, '\p{Is_Indic_Positional_Category=bottomandleft}', "");
    Expect(1, 43456, '\p{^Is_Indic_Positional_Category=bottomandleft}', "");
    Expect(1, 43456, '\P{Is_Indic_Positional_Category=bottomandleft}', "");
    Expect(0, 43456, '\P{^Is_Indic_Positional_Category=bottomandleft}', "");
    Expect(1, 43455, '\p{Is_Indic_Positional_Category=_	BOTTOM_and_left}', "");
    Expect(0, 43455, '\p{^Is_Indic_Positional_Category=_	BOTTOM_and_left}', "");
    Expect(0, 43455, '\P{Is_Indic_Positional_Category=_	BOTTOM_and_left}', "");
    Expect(1, 43455, '\P{^Is_Indic_Positional_Category=_	BOTTOM_and_left}', "");
    Expect(0, 43456, '\p{Is_Indic_Positional_Category=_	BOTTOM_and_left}', "");
    Expect(1, 43456, '\p{^Is_Indic_Positional_Category=_	BOTTOM_and_left}', "");
    Expect(1, 43456, '\P{Is_Indic_Positional_Category=_	BOTTOM_and_left}', "");
    Expect(0, 43456, '\P{^Is_Indic_Positional_Category=_	BOTTOM_and_left}', "");
    Error('\p{Is_InPC= -BOTTOM_and_left:=}');
    Error('\P{Is_InPC= -BOTTOM_and_left:=}');
    Expect(1, 43455, '\p{Is_InPC=bottomandleft}', "");
    Expect(0, 43455, '\p{^Is_InPC=bottomandleft}', "");
    Expect(0, 43455, '\P{Is_InPC=bottomandleft}', "");
    Expect(1, 43455, '\P{^Is_InPC=bottomandleft}', "");
    Expect(0, 43456, '\p{Is_InPC=bottomandleft}', "");
    Expect(1, 43456, '\p{^Is_InPC=bottomandleft}', "");
    Expect(1, 43456, '\P{Is_InPC=bottomandleft}', "");
    Expect(0, 43456, '\P{^Is_InPC=bottomandleft}', "");
    Expect(1, 43455, '\p{Is_InPC=Bottom_And_LEFT}', "");
    Expect(0, 43455, '\p{^Is_InPC=Bottom_And_LEFT}', "");
    Expect(0, 43455, '\P{Is_InPC=Bottom_And_LEFT}', "");
    Expect(1, 43455, '\P{^Is_InPC=Bottom_And_LEFT}', "");
    Expect(0, 43456, '\p{Is_InPC=Bottom_And_LEFT}', "");
    Expect(1, 43456, '\p{^Is_InPC=Bottom_And_LEFT}', "");
    Expect(1, 43456, '\P{Is_InPC=Bottom_And_LEFT}', "");
    Expect(0, 43456, '\P{^Is_InPC=Bottom_And_LEFT}', "");
    Error('\p{Indic_Positional_Category=-BOTTOM_and_RIGHT/a/}');
    Error('\P{Indic_Positional_Category=-BOTTOM_and_RIGHT/a/}');
    Expect(1, 72002, '\p{Indic_Positional_Category=:\ABottom_And_Right\z:}', "");;
    Expect(0, 72003, '\p{Indic_Positional_Category=:\ABottom_And_Right\z:}', "");;
    Expect(1, 72002, '\p{Indic_Positional_Category=bottomandright}', "");
    Expect(0, 72002, '\p{^Indic_Positional_Category=bottomandright}', "");
    Expect(0, 72002, '\P{Indic_Positional_Category=bottomandright}', "");
    Expect(1, 72002, '\P{^Indic_Positional_Category=bottomandright}', "");
    Expect(0, 72003, '\p{Indic_Positional_Category=bottomandright}', "");
    Expect(1, 72003, '\p{^Indic_Positional_Category=bottomandright}', "");
    Expect(1, 72003, '\P{Indic_Positional_Category=bottomandright}', "");
    Expect(0, 72003, '\P{^Indic_Positional_Category=bottomandright}', "");
    Expect(1, 72002, '\p{Indic_Positional_Category=:\Abottomandright\z:}', "");;
    Expect(0, 72003, '\p{Indic_Positional_Category=:\Abottomandright\z:}', "");;
    Expect(1, 72002, '\p{Indic_Positional_Category=	 BOTTOM_and_Right}', "");
    Expect(0, 72002, '\p{^Indic_Positional_Category=	 BOTTOM_and_Right}', "");
    Expect(0, 72002, '\P{Indic_Positional_Category=	 BOTTOM_and_Right}', "");
    Expect(1, 72002, '\P{^Indic_Positional_Category=	 BOTTOM_and_Right}', "");
    Expect(0, 72003, '\p{Indic_Positional_Category=	 BOTTOM_and_Right}', "");
    Expect(1, 72003, '\p{^Indic_Positional_Category=	 BOTTOM_and_Right}', "");
    Expect(1, 72003, '\P{Indic_Positional_Category=	 BOTTOM_and_Right}', "");
    Expect(0, 72003, '\P{^Indic_Positional_Category=	 BOTTOM_and_Right}', "");
    Error('\p{InPC=_ bottom_AND_Right/a/}');
    Error('\P{InPC=_ bottom_AND_Right/a/}');
    Expect(1, 72002, '\p{InPC=:\ABottom_And_Right\z:}', "");;
    Expect(0, 72003, '\p{InPC=:\ABottom_And_Right\z:}', "");;
    Expect(1, 72002, '\p{InPC=bottomandright}', "");
    Expect(0, 72002, '\p{^InPC=bottomandright}', "");
    Expect(0, 72002, '\P{InPC=bottomandright}', "");
    Expect(1, 72002, '\P{^InPC=bottomandright}', "");
    Expect(0, 72003, '\p{InPC=bottomandright}', "");
    Expect(1, 72003, '\p{^InPC=bottomandright}', "");
    Expect(1, 72003, '\P{InPC=bottomandright}', "");
    Expect(0, 72003, '\P{^InPC=bottomandright}', "");
    Expect(1, 72002, '\p{InPC=:\Abottomandright\z:}', "");;
    Expect(0, 72003, '\p{InPC=:\Abottomandright\z:}', "");;
    Expect(1, 72002, '\p{InPC= _BOTTOM_And_right}', "");
    Expect(0, 72002, '\p{^InPC= _BOTTOM_And_right}', "");
    Expect(0, 72002, '\P{InPC= _BOTTOM_And_right}', "");
    Expect(1, 72002, '\P{^InPC= _BOTTOM_And_right}', "");
    Expect(0, 72003, '\p{InPC= _BOTTOM_And_right}', "");
    Expect(1, 72003, '\p{^InPC= _BOTTOM_And_right}', "");
    Expect(1, 72003, '\P{InPC= _BOTTOM_And_right}', "");
    Expect(0, 72003, '\P{^InPC= _BOTTOM_And_right}', "");
    Error('\p{Is_Indic_Positional_Category=	_Bottom_And_RIGHT/a/}');
    Error('\P{Is_Indic_Positional_Category=	_Bottom_And_RIGHT/a/}');
    Expect(1, 72002, '\p{Is_Indic_Positional_Category=bottomandright}', "");
    Expect(0, 72002, '\p{^Is_Indic_Positional_Category=bottomandright}', "");
    Expect(0, 72002, '\P{Is_Indic_Positional_Category=bottomandright}', "");
    Expect(1, 72002, '\P{^Is_Indic_Positional_Category=bottomandright}', "");
    Expect(0, 72003, '\p{Is_Indic_Positional_Category=bottomandright}', "");
    Expect(1, 72003, '\p{^Is_Indic_Positional_Category=bottomandright}', "");
    Expect(1, 72003, '\P{Is_Indic_Positional_Category=bottomandright}', "");
    Expect(0, 72003, '\P{^Is_Indic_Positional_Category=bottomandright}', "");
    Expect(1, 72002, '\p{Is_Indic_Positional_Category=_Bottom_AND_Right}', "");
    Expect(0, 72002, '\p{^Is_Indic_Positional_Category=_Bottom_AND_Right}', "");
    Expect(0, 72002, '\P{Is_Indic_Positional_Category=_Bottom_AND_Right}', "");
    Expect(1, 72002, '\P{^Is_Indic_Positional_Category=_Bottom_AND_Right}', "");
    Expect(0, 72003, '\p{Is_Indic_Positional_Category=_Bottom_AND_Right}', "");
    Expect(1, 72003, '\p{^Is_Indic_Positional_Category=_Bottom_AND_Right}', "");
    Expect(1, 72003, '\P{Is_Indic_Positional_Category=_Bottom_AND_Right}', "");
    Expect(0, 72003, '\P{^Is_Indic_Positional_Category=_Bottom_AND_Right}', "");
    Error('\p{Is_InPC=-:=Bottom_And_Right}');
    Error('\P{Is_InPC=-:=Bottom_And_Right}');
    Expect(1, 72002, '\p{Is_InPC=bottomandright}', "");
    Expect(0, 72002, '\p{^Is_InPC=bottomandright}', "");
    Expect(0, 72002, '\P{Is_InPC=bottomandright}', "");
    Expect(1, 72002, '\P{^Is_InPC=bottomandright}', "");
    Expect(0, 72003, '\p{Is_InPC=bottomandright}', "");
    Expect(1, 72003, '\p{^Is_InPC=bottomandright}', "");
    Expect(1, 72003, '\P{Is_InPC=bottomandright}', "");
    Expect(0, 72003, '\P{^Is_InPC=bottomandright}', "");
    Expect(1, 72002, '\p{Is_InPC:-_Bottom_And_RIGHT}', "");
    Expect(0, 72002, '\p{^Is_InPC:-_Bottom_And_RIGHT}', "");
    Expect(0, 72002, '\P{Is_InPC:-_Bottom_And_RIGHT}', "");
    Expect(1, 72002, '\P{^Is_InPC:-_Bottom_And_RIGHT}', "");
    Expect(0, 72003, '\p{Is_InPC:-_Bottom_And_RIGHT}', "");
    Expect(1, 72003, '\p{^Is_InPC:-_Bottom_And_RIGHT}', "");
    Expect(1, 72003, '\P{Is_InPC:-_Bottom_And_RIGHT}', "");
    Expect(0, 72003, '\P{^Is_InPC:-_Bottom_And_RIGHT}', "");
    Error('\p{Indic_Positional_Category=/a/_LEFT}');
    Error('\P{Indic_Positional_Category=/a/_LEFT}');
    Expect(1, 73461, '\p{Indic_Positional_Category=:\ALeft\z:}', "");;
    Expect(0, 73462, '\p{Indic_Positional_Category=:\ALeft\z:}', "");;
    Expect(1, 73461, '\p{Indic_Positional_Category=left}', "");
    Expect(0, 73461, '\p{^Indic_Positional_Category=left}', "");
    Expect(0, 73461, '\P{Indic_Positional_Category=left}', "");
    Expect(1, 73461, '\P{^Indic_Positional_Category=left}', "");
    Expect(0, 73462, '\p{Indic_Positional_Category=left}', "");
    Expect(1, 73462, '\p{^Indic_Positional_Category=left}', "");
    Expect(1, 73462, '\P{Indic_Positional_Category=left}', "");
    Expect(0, 73462, '\P{^Indic_Positional_Category=left}', "");
    Expect(1, 73461, '\p{Indic_Positional_Category=:\Aleft\z:}', "");;
    Expect(0, 73462, '\p{Indic_Positional_Category=:\Aleft\z:}', "");;
    Expect(1, 73461, '\p{Indic_Positional_Category=_	Left}', "");
    Expect(0, 73461, '\p{^Indic_Positional_Category=_	Left}', "");
    Expect(0, 73461, '\P{Indic_Positional_Category=_	Left}', "");
    Expect(1, 73461, '\P{^Indic_Positional_Category=_	Left}', "");
    Expect(0, 73462, '\p{Indic_Positional_Category=_	Left}', "");
    Expect(1, 73462, '\p{^Indic_Positional_Category=_	Left}', "");
    Expect(1, 73462, '\P{Indic_Positional_Category=_	Left}', "");
    Expect(0, 73462, '\P{^Indic_Positional_Category=_	Left}', "");
    Error('\p{InPC=-:=Left}');
    Error('\P{InPC=-:=Left}');
    Expect(1, 73461, '\p{InPC=:\ALeft\z:}', "");;
    Expect(0, 73462, '\p{InPC=:\ALeft\z:}', "");;
    Expect(1, 73461, '\p{InPC=left}', "");
    Expect(0, 73461, '\p{^InPC=left}', "");
    Expect(0, 73461, '\P{InPC=left}', "");
    Expect(1, 73461, '\P{^InPC=left}', "");
    Expect(0, 73462, '\p{InPC=left}', "");
    Expect(1, 73462, '\p{^InPC=left}', "");
    Expect(1, 73462, '\P{InPC=left}', "");
    Expect(0, 73462, '\P{^InPC=left}', "");
    Expect(1, 73461, '\p{InPC=:\Aleft\z:}', "");;
    Expect(0, 73462, '\p{InPC=:\Aleft\z:}', "");;
    Expect(1, 73461, '\p{InPC= Left}', "");
    Expect(0, 73461, '\p{^InPC= Left}', "");
    Expect(0, 73461, '\P{InPC= Left}', "");
    Expect(1, 73461, '\P{^InPC= Left}', "");
    Expect(0, 73462, '\p{InPC= Left}', "");
    Expect(1, 73462, '\p{^InPC= Left}', "");
    Expect(1, 73462, '\P{InPC= Left}', "");
    Expect(0, 73462, '\P{^InPC= Left}', "");
    Error('\p{Is_Indic_Positional_Category:	/a/Left}');
    Error('\P{Is_Indic_Positional_Category:	/a/Left}');
    Expect(1, 73461, '\p{Is_Indic_Positional_Category=left}', "");
    Expect(0, 73461, '\p{^Is_Indic_Positional_Category=left}', "");
    Expect(0, 73461, '\P{Is_Indic_Positional_Category=left}', "");
    Expect(1, 73461, '\P{^Is_Indic_Positional_Category=left}', "");
    Expect(0, 73462, '\p{Is_Indic_Positional_Category=left}', "");
    Expect(1, 73462, '\p{^Is_Indic_Positional_Category=left}', "");
    Expect(1, 73462, '\P{Is_Indic_Positional_Category=left}', "");
    Expect(0, 73462, '\P{^Is_Indic_Positional_Category=left}', "");
    Expect(1, 73461, '\p{Is_Indic_Positional_Category=- LEFT}', "");
    Expect(0, 73461, '\p{^Is_Indic_Positional_Category=- LEFT}', "");
    Expect(0, 73461, '\P{Is_Indic_Positional_Category=- LEFT}', "");
    Expect(1, 73461, '\P{^Is_Indic_Positional_Category=- LEFT}', "");
    Expect(0, 73462, '\p{Is_Indic_Positional_Category=- LEFT}', "");
    Expect(1, 73462, '\p{^Is_Indic_Positional_Category=- LEFT}', "");
    Expect(1, 73462, '\P{Is_Indic_Positional_Category=- LEFT}', "");
    Expect(0, 73462, '\P{^Is_Indic_Positional_Category=- LEFT}', "");
    Error('\p{Is_InPC::=_	Left}');
    Error('\P{Is_InPC::=_	Left}');
    Expect(1, 73461, '\p{Is_InPC=left}', "");
    Expect(0, 73461, '\p{^Is_InPC=left}', "");
    Expect(0, 73461, '\P{Is_InPC=left}', "");
    Expect(1, 73461, '\P{^Is_InPC=left}', "");
    Expect(0, 73462, '\p{Is_InPC=left}', "");
    Expect(1, 73462, '\p{^Is_InPC=left}', "");
    Expect(1, 73462, '\P{Is_InPC=left}', "");
    Expect(0, 73462, '\P{^Is_InPC=left}', "");
    Expect(1, 73461, '\p{Is_InPC=Left}', "");
    Expect(0, 73461, '\p{^Is_InPC=Left}', "");
    Expect(0, 73461, '\P{Is_InPC=Left}', "");
    Expect(1, 73461, '\P{^Is_InPC=Left}', "");
    Expect(0, 73462, '\p{Is_InPC=Left}', "");
    Expect(1, 73462, '\p{^Is_InPC=Left}', "");
    Expect(1, 73462, '\P{Is_InPC=Left}', "");
    Expect(0, 73462, '\P{^Is_InPC=Left}', "");
    Error('\p{Indic_Positional_Category=_:=Left_And_RIGHT}');
    Error('\P{Indic_Positional_Category=_:=Left_And_RIGHT}');
    Expect(1, 71992, '\p{Indic_Positional_Category=:\ALeft_And_Right\z:}', "");;
    Expect(0, 71993, '\p{Indic_Positional_Category=:\ALeft_And_Right\z:}', "");;
    Expect(1, 71992, '\p{Indic_Positional_Category=leftandright}', "");
    Expect(0, 71992, '\p{^Indic_Positional_Category=leftandright}', "");
    Expect(0, 71992, '\P{Indic_Positional_Category=leftandright}', "");
    Expect(1, 71992, '\P{^Indic_Positional_Category=leftandright}', "");
    Expect(0, 71993, '\p{Indic_Positional_Category=leftandright}', "");
    Expect(1, 71993, '\p{^Indic_Positional_Category=leftandright}', "");
    Expect(1, 71993, '\P{Indic_Positional_Category=leftandright}', "");
    Expect(0, 71993, '\P{^Indic_Positional_Category=leftandright}', "");
    Expect(1, 71992, '\p{Indic_Positional_Category=:\Aleftandright\z:}', "");;
    Expect(0, 71993, '\p{Indic_Positional_Category=:\Aleftandright\z:}', "");;
    Expect(1, 71992, '\p{Indic_Positional_Category= LEFT_And_Right}', "");
    Expect(0, 71992, '\p{^Indic_Positional_Category= LEFT_And_Right}', "");
    Expect(0, 71992, '\P{Indic_Positional_Category= LEFT_And_Right}', "");
    Expect(1, 71992, '\P{^Indic_Positional_Category= LEFT_And_Right}', "");
    Expect(0, 71993, '\p{Indic_Positional_Category= LEFT_And_Right}', "");
    Expect(1, 71993, '\p{^Indic_Positional_Category= LEFT_And_Right}', "");
    Expect(1, 71993, '\P{Indic_Positional_Category= LEFT_And_Right}', "");
    Expect(0, 71993, '\P{^Indic_Positional_Category= LEFT_And_Right}', "");
    Error('\p{InPC=/a/- Left_And_RIGHT}');
    Error('\P{InPC=/a/- Left_And_RIGHT}');
    Expect(1, 71992, '\p{InPC=:\ALeft_And_Right\z:}', "");;
    Expect(0, 71993, '\p{InPC=:\ALeft_And_Right\z:}', "");;
    Expect(1, 71992, '\p{InPC=leftandright}', "");
    Expect(0, 71992, '\p{^InPC=leftandright}', "");
    Expect(0, 71992, '\P{InPC=leftandright}', "");
    Expect(1, 71992, '\P{^InPC=leftandright}', "");
    Expect(0, 71993, '\p{InPC=leftandright}', "");
    Expect(1, 71993, '\p{^InPC=leftandright}', "");
    Expect(1, 71993, '\P{InPC=leftandright}', "");
    Expect(0, 71993, '\P{^InPC=leftandright}', "");
    Expect(1, 71992, '\p{InPC=:\Aleftandright\z:}', "");;
    Expect(0, 71993, '\p{InPC=:\Aleftandright\z:}', "");;
    Expect(1, 71992, '\p{InPC=__Left_And_right}', "");
    Expect(0, 71992, '\p{^InPC=__Left_And_right}', "");
    Expect(0, 71992, '\P{InPC=__Left_And_right}', "");
    Expect(1, 71992, '\P{^InPC=__Left_And_right}', "");
    Expect(0, 71993, '\p{InPC=__Left_And_right}', "");
    Expect(1, 71993, '\p{^InPC=__Left_And_right}', "");
    Expect(1, 71993, '\P{InPC=__Left_And_right}', "");
    Expect(0, 71993, '\P{^InPC=__Left_And_right}', "");
    Error('\p{Is_Indic_Positional_Category= -Left_and_RIGHT:=}');
    Error('\P{Is_Indic_Positional_Category= -Left_and_RIGHT:=}');
    Expect(1, 71992, '\p{Is_Indic_Positional_Category=leftandright}', "");
    Expect(0, 71992, '\p{^Is_Indic_Positional_Category=leftandright}', "");
    Expect(0, 71992, '\P{Is_Indic_Positional_Category=leftandright}', "");
    Expect(1, 71992, '\P{^Is_Indic_Positional_Category=leftandright}', "");
    Expect(0, 71993, '\p{Is_Indic_Positional_Category=leftandright}', "");
    Expect(1, 71993, '\p{^Is_Indic_Positional_Category=leftandright}', "");
    Expect(1, 71993, '\P{Is_Indic_Positional_Category=leftandright}', "");
    Expect(0, 71993, '\P{^Is_Indic_Positional_Category=leftandright}', "");
    Expect(1, 71992, '\p{Is_Indic_Positional_Category=-_left_and_Right}', "");
    Expect(0, 71992, '\p{^Is_Indic_Positional_Category=-_left_and_Right}', "");
    Expect(0, 71992, '\P{Is_Indic_Positional_Category=-_left_and_Right}', "");
    Expect(1, 71992, '\P{^Is_Indic_Positional_Category=-_left_and_Right}', "");
    Expect(0, 71993, '\p{Is_Indic_Positional_Category=-_left_and_Right}', "");
    Expect(1, 71993, '\p{^Is_Indic_Positional_Category=-_left_and_Right}', "");
    Expect(1, 71993, '\P{Is_Indic_Positional_Category=-_left_and_Right}', "");
    Expect(0, 71993, '\P{^Is_Indic_Positional_Category=-_left_and_Right}', "");
    Error('\p{Is_InPC= Left_AND_Right/a/}');
    Error('\P{Is_InPC= Left_AND_Right/a/}');
    Expect(1, 71992, '\p{Is_InPC=leftandright}', "");
    Expect(0, 71992, '\p{^Is_InPC=leftandright}', "");
    Expect(0, 71992, '\P{Is_InPC=leftandright}', "");
    Expect(1, 71992, '\P{^Is_InPC=leftandright}', "");
    Expect(0, 71993, '\p{Is_InPC=leftandright}', "");
    Expect(1, 71993, '\p{^Is_InPC=leftandright}', "");
    Expect(1, 71993, '\P{Is_InPC=leftandright}', "");
    Expect(0, 71993, '\P{^Is_InPC=leftandright}', "");
    Expect(1, 71992, '\p{Is_InPC=	-left_And_right}', "");
    Expect(0, 71992, '\p{^Is_InPC=	-left_And_right}', "");
    Expect(0, 71992, '\P{Is_InPC=	-left_And_right}', "");
    Expect(1, 71992, '\P{^Is_InPC=	-left_And_right}', "");
    Expect(0, 71993, '\p{Is_InPC=	-left_And_right}', "");
    Expect(1, 71993, '\p{^Is_InPC=	-left_And_right}', "");
    Expect(1, 71993, '\P{Is_InPC=	-left_And_right}', "");
    Expect(0, 71993, '\P{^Is_InPC=	-left_And_right}', "");
    Error('\p{Indic_Positional_Category=-na/a/}');
    Error('\P{Indic_Positional_Category=-na/a/}');
    Expect(1, 73463, '\p{Indic_Positional_Category=:\ANA\z:}', "");;
    Expect(0, 73462, '\p{Indic_Positional_Category=:\ANA\z:}', "");;
    Expect(1, 73463, '\p{Indic_Positional_Category=na}', "");
    Expect(0, 73463, '\p{^Indic_Positional_Category=na}', "");
    Expect(0, 73463, '\P{Indic_Positional_Category=na}', "");
    Expect(1, 73463, '\P{^Indic_Positional_Category=na}', "");
    Expect(0, 73462, '\p{Indic_Positional_Category=na}', "");
    Expect(1, 73462, '\p{^Indic_Positional_Category=na}', "");
    Expect(1, 73462, '\P{Indic_Positional_Category=na}', "");
    Expect(0, 73462, '\P{^Indic_Positional_Category=na}', "");
    Expect(1, 73463, '\p{Indic_Positional_Category=:\Ana\z:}', "");;
    Expect(0, 73462, '\p{Indic_Positional_Category=:\Ana\z:}', "");;
    Expect(1, 73463, '\p{Indic_Positional_Category=- NA}', "");
    Expect(0, 73463, '\p{^Indic_Positional_Category=- NA}', "");
    Expect(0, 73463, '\P{Indic_Positional_Category=- NA}', "");
    Expect(1, 73463, '\P{^Indic_Positional_Category=- NA}', "");
    Expect(0, 73462, '\p{Indic_Positional_Category=- NA}', "");
    Expect(1, 73462, '\p{^Indic_Positional_Category=- NA}', "");
    Expect(1, 73462, '\P{Indic_Positional_Category=- NA}', "");
    Expect(0, 73462, '\P{^Indic_Positional_Category=- NA}', "");
    Error('\p{InPC=:=NA}');
    Error('\P{InPC=:=NA}');
    Expect(1, 73463, '\p{InPC=:\ANA\z:}', "");;
    Expect(0, 73462, '\p{InPC=:\ANA\z:}', "");;
    Expect(1, 73463, '\p{InPC=na}', "");
    Expect(0, 73463, '\p{^InPC=na}', "");
    Expect(0, 73463, '\P{InPC=na}', "");
    Expect(1, 73463, '\P{^InPC=na}', "");
    Expect(0, 73462, '\p{InPC=na}', "");
    Expect(1, 73462, '\p{^InPC=na}', "");
    Expect(1, 73462, '\P{InPC=na}', "");
    Expect(0, 73462, '\P{^InPC=na}', "");
    Expect(1, 73463, '\p{InPC=:\Ana\z:}', "");;
    Expect(0, 73462, '\p{InPC=:\Ana\z:}', "");;
    Expect(1, 73463, '\p{InPC=- NA}', "");
    Expect(0, 73463, '\p{^InPC=- NA}', "");
    Expect(0, 73463, '\P{InPC=- NA}', "");
    Expect(1, 73463, '\P{^InPC=- NA}', "");
    Expect(0, 73462, '\p{InPC=- NA}', "");
    Expect(1, 73462, '\p{^InPC=- NA}', "");
    Expect(1, 73462, '\P{InPC=- NA}', "");
    Expect(0, 73462, '\P{^InPC=- NA}', "");
    Error('\p{Is_Indic_Positional_Category=__NA/a/}');
    Error('\P{Is_Indic_Positional_Category=__NA/a/}');
    Expect(1, 73463, '\p{Is_Indic_Positional_Category=na}', "");
    Expect(0, 73463, '\p{^Is_Indic_Positional_Category=na}', "");
    Expect(0, 73463, '\P{Is_Indic_Positional_Category=na}', "");
    Expect(1, 73463, '\P{^Is_Indic_Positional_Category=na}', "");
    Expect(0, 73462, '\p{Is_Indic_Positional_Category=na}', "");
    Expect(1, 73462, '\p{^Is_Indic_Positional_Category=na}', "");
    Expect(1, 73462, '\P{Is_Indic_Positional_Category=na}', "");
    Expect(0, 73462, '\P{^Is_Indic_Positional_Category=na}', "");
    Expect(1, 73463, '\p{Is_Indic_Positional_Category=_	NA}', "");
    Expect(0, 73463, '\p{^Is_Indic_Positional_Category=_	NA}', "");
    Expect(0, 73463, '\P{Is_Indic_Positional_Category=_	NA}', "");
    Expect(1, 73463, '\P{^Is_Indic_Positional_Category=_	NA}', "");
    Expect(0, 73462, '\p{Is_Indic_Positional_Category=_	NA}', "");
    Expect(1, 73462, '\p{^Is_Indic_Positional_Category=_	NA}', "");
    Expect(1, 73462, '\P{Is_Indic_Positional_Category=_	NA}', "");
    Expect(0, 73462, '\P{^Is_Indic_Positional_Category=_	NA}', "");
    Error('\p{Is_InPC=:=na}');
    Error('\P{Is_InPC=:=na}');
    Expect(1, 73463, '\p{Is_InPC=na}', "");
    Expect(0, 73463, '\p{^Is_InPC=na}', "");
    Expect(0, 73463, '\P{Is_InPC=na}', "");
    Expect(1, 73463, '\P{^Is_InPC=na}', "");
    Expect(0, 73462, '\p{Is_InPC=na}', "");
    Expect(1, 73462, '\p{^Is_InPC=na}', "");
    Expect(1, 73462, '\P{Is_InPC=na}', "");
    Expect(0, 73462, '\P{^Is_InPC=na}', "");
    Expect(1, 73463, '\p{Is_InPC=-	NA}', "");
    Expect(0, 73463, '\p{^Is_InPC=-	NA}', "");
    Expect(0, 73463, '\P{Is_InPC=-	NA}', "");
    Expect(1, 73463, '\P{^Is_InPC=-	NA}', "");
    Expect(0, 73462, '\p{Is_InPC=-	NA}', "");
    Expect(1, 73462, '\p{^Is_InPC=-	NA}', "");
    Expect(1, 73462, '\P{Is_InPC=-	NA}', "");
    Expect(0, 73462, '\P{^Is_InPC=-	NA}', "");
    Error('\p{Indic_Positional_Category:   /a/ 	Overstruck}');
    Error('\P{Indic_Positional_Category:   /a/ 	Overstruck}');
    Expect(1, 68102, '\p{Indic_Positional_Category=:\AOverstruck\z:}', "");;
    Expect(0, 68103, '\p{Indic_Positional_Category=:\AOverstruck\z:}', "");;
    Expect(1, 68102, '\p{Indic_Positional_Category=overstruck}', "");
    Expect(0, 68102, '\p{^Indic_Positional_Category=overstruck}', "");
    Expect(0, 68102, '\P{Indic_Positional_Category=overstruck}', "");
    Expect(1, 68102, '\P{^Indic_Positional_Category=overstruck}', "");
    Expect(0, 68103, '\p{Indic_Positional_Category=overstruck}', "");
    Expect(1, 68103, '\p{^Indic_Positional_Category=overstruck}', "");
    Expect(1, 68103, '\P{Indic_Positional_Category=overstruck}', "");
    Expect(0, 68103, '\P{^Indic_Positional_Category=overstruck}', "");
    Expect(1, 68102, '\p{Indic_Positional_Category=:\Aoverstruck\z:}', "");;
    Expect(0, 68103, '\p{Indic_Positional_Category=:\Aoverstruck\z:}', "");;
    Expect(1, 68102, '\p{Indic_Positional_Category=	OVERSTRUCK}', "");
    Expect(0, 68102, '\p{^Indic_Positional_Category=	OVERSTRUCK}', "");
    Expect(0, 68102, '\P{Indic_Positional_Category=	OVERSTRUCK}', "");
    Expect(1, 68102, '\P{^Indic_Positional_Category=	OVERSTRUCK}', "");
    Expect(0, 68103, '\p{Indic_Positional_Category=	OVERSTRUCK}', "");
    Expect(1, 68103, '\p{^Indic_Positional_Category=	OVERSTRUCK}', "");
    Expect(1, 68103, '\P{Indic_Positional_Category=	OVERSTRUCK}', "");
    Expect(0, 68103, '\P{^Indic_Positional_Category=	OVERSTRUCK}', "");
    Error('\p{InPC=/a/-OVERSTRUCK}');
    Error('\P{InPC=/a/-OVERSTRUCK}');
    Expect(1, 68102, '\p{InPC=:\AOverstruck\z:}', "");;
    Expect(0, 68103, '\p{InPC=:\AOverstruck\z:}', "");;
    Expect(1, 68102, '\p{InPC=overstruck}', "");
    Expect(0, 68102, '\p{^InPC=overstruck}', "");
    Expect(0, 68102, '\P{InPC=overstruck}', "");
    Expect(1, 68102, '\P{^InPC=overstruck}', "");
    Expect(0, 68103, '\p{InPC=overstruck}', "");
    Expect(1, 68103, '\p{^InPC=overstruck}', "");
    Expect(1, 68103, '\P{InPC=overstruck}', "");
    Expect(0, 68103, '\P{^InPC=overstruck}', "");
    Expect(1, 68102, '\p{InPC=:\Aoverstruck\z:}', "");;
    Expect(0, 68103, '\p{InPC=:\Aoverstruck\z:}', "");;
    Expect(1, 68102, '\p{InPC= OVERSTRUCK}', "");
    Expect(0, 68102, '\p{^InPC= OVERSTRUCK}', "");
    Expect(0, 68102, '\P{InPC= OVERSTRUCK}', "");
    Expect(1, 68102, '\P{^InPC= OVERSTRUCK}', "");
    Expect(0, 68103, '\p{InPC= OVERSTRUCK}', "");
    Expect(1, 68103, '\p{^InPC= OVERSTRUCK}', "");
    Expect(1, 68103, '\P{InPC= OVERSTRUCK}', "");
    Expect(0, 68103, '\P{^InPC= OVERSTRUCK}', "");
    Error('\p{Is_Indic_Positional_Category=_:=Overstruck}');
    Error('\P{Is_Indic_Positional_Category=_:=Overstruck}');
    Expect(1, 68102, '\p{Is_Indic_Positional_Category=overstruck}', "");
    Expect(0, 68102, '\p{^Is_Indic_Positional_Category=overstruck}', "");
    Expect(0, 68102, '\P{Is_Indic_Positional_Category=overstruck}', "");
    Expect(1, 68102, '\P{^Is_Indic_Positional_Category=overstruck}', "");
    Expect(0, 68103, '\p{Is_Indic_Positional_Category=overstruck}', "");
    Expect(1, 68103, '\p{^Is_Indic_Positional_Category=overstruck}', "");
    Expect(1, 68103, '\P{Is_Indic_Positional_Category=overstruck}', "");
    Expect(0, 68103, '\P{^Is_Indic_Positional_Category=overstruck}', "");
    Expect(1, 68102, '\p{Is_Indic_Positional_Category=	_Overstruck}', "");
    Expect(0, 68102, '\p{^Is_Indic_Positional_Category=	_Overstruck}', "");
    Expect(0, 68102, '\P{Is_Indic_Positional_Category=	_Overstruck}', "");
    Expect(1, 68102, '\P{^Is_Indic_Positional_Category=	_Overstruck}', "");
    Expect(0, 68103, '\p{Is_Indic_Positional_Category=	_Overstruck}', "");
    Expect(1, 68103, '\p{^Is_Indic_Positional_Category=	_Overstruck}', "");
    Expect(1, 68103, '\P{Is_Indic_Positional_Category=	_Overstruck}', "");
    Expect(0, 68103, '\P{^Is_Indic_Positional_Category=	_Overstruck}', "");
    Error('\p{Is_InPC=:=Overstruck}');
    Error('\P{Is_InPC=:=Overstruck}');
    Expect(1, 68102, '\p{Is_InPC=overstruck}', "");
    Expect(0, 68102, '\p{^Is_InPC=overstruck}', "");
    Expect(0, 68102, '\P{Is_InPC=overstruck}', "");
    Expect(1, 68102, '\P{^Is_InPC=overstruck}', "");
    Expect(0, 68103, '\p{Is_InPC=overstruck}', "");
    Expect(1, 68103, '\p{^Is_InPC=overstruck}', "");
    Expect(1, 68103, '\P{Is_InPC=overstruck}', "");
    Expect(0, 68103, '\P{^Is_InPC=overstruck}', "");
    Expect(1, 68102, '\p{Is_InPC=  Overstruck}', "");
    Expect(0, 68102, '\p{^Is_InPC=  Overstruck}', "");
    Expect(0, 68102, '\P{Is_InPC=  Overstruck}', "");
    Expect(1, 68102, '\P{^Is_InPC=  Overstruck}', "");
    Expect(0, 68103, '\p{Is_InPC=  Overstruck}', "");
    Expect(1, 68103, '\p{^Is_InPC=  Overstruck}', "");
    Expect(1, 68103, '\P{Is_InPC=  Overstruck}', "");
    Expect(0, 68103, '\P{^Is_InPC=  Overstruck}', "");
    Error('\p{Indic_Positional_Category=/a/ -right}');
    Error('\P{Indic_Positional_Category=/a/ -right}');
    Expect(1, 73462, '\p{Indic_Positional_Category=:\ARight\z:}', "");;
    Expect(0, 73463, '\p{Indic_Positional_Category=:\ARight\z:}', "");;
    Expect(1, 73462, '\p{Indic_Positional_Category: right}', "");
    Expect(0, 73462, '\p{^Indic_Positional_Category: right}', "");
    Expect(0, 73462, '\P{Indic_Positional_Category: right}', "");
    Expect(1, 73462, '\P{^Indic_Positional_Category: right}', "");
    Expect(0, 73463, '\p{Indic_Positional_Category: right}', "");
    Expect(1, 73463, '\p{^Indic_Positional_Category: right}', "");
    Expect(1, 73463, '\P{Indic_Positional_Category: right}', "");
    Expect(0, 73463, '\P{^Indic_Positional_Category: right}', "");
    Expect(1, 73462, '\p{Indic_Positional_Category=:\Aright\z:}', "");;
    Expect(0, 73463, '\p{Indic_Positional_Category=:\Aright\z:}', "");;
    Expect(1, 73462, '\p{Indic_Positional_Category=	RIGHT}', "");
    Expect(0, 73462, '\p{^Indic_Positional_Category=	RIGHT}', "");
    Expect(0, 73462, '\P{Indic_Positional_Category=	RIGHT}', "");
    Expect(1, 73462, '\P{^Indic_Positional_Category=	RIGHT}', "");
    Expect(0, 73463, '\p{Indic_Positional_Category=	RIGHT}', "");
    Expect(1, 73463, '\p{^Indic_Positional_Category=	RIGHT}', "");
    Expect(1, 73463, '\P{Indic_Positional_Category=	RIGHT}', "");
    Expect(0, 73463, '\P{^Indic_Positional_Category=	RIGHT}', "");
    Error('\p{InPC=:=	-RIGHT}');
    Error('\P{InPC=:=	-RIGHT}');
    Expect(1, 73462, '\p{InPC=:\ARight\z:}', "");;
    Expect(0, 73463, '\p{InPC=:\ARight\z:}', "");;
    Expect(1, 73462, '\p{InPC=right}', "");
    Expect(0, 73462, '\p{^InPC=right}', "");
    Expect(0, 73462, '\P{InPC=right}', "");
    Expect(1, 73462, '\P{^InPC=right}', "");
    Expect(0, 73463, '\p{InPC=right}', "");
    Expect(1, 73463, '\p{^InPC=right}', "");
    Expect(1, 73463, '\P{InPC=right}', "");
    Expect(0, 73463, '\P{^InPC=right}', "");
    Expect(1, 73462, '\p{InPC=:\Aright\z:}', "");;
    Expect(0, 73463, '\p{InPC=:\Aright\z:}', "");;
    Expect(1, 73462, '\p{InPC=- Right}', "");
    Expect(0, 73462, '\p{^InPC=- Right}', "");
    Expect(0, 73462, '\P{InPC=- Right}', "");
    Expect(1, 73462, '\P{^InPC=- Right}', "");
    Expect(0, 73463, '\p{InPC=- Right}', "");
    Expect(1, 73463, '\p{^InPC=- Right}', "");
    Expect(1, 73463, '\P{InPC=- Right}', "");
    Expect(0, 73463, '\P{^InPC=- Right}', "");
    Error('\p{Is_Indic_Positional_Category=/a/right}');
    Error('\P{Is_Indic_Positional_Category=/a/right}');
    Expect(1, 73462, '\p{Is_Indic_Positional_Category=right}', "");
    Expect(0, 73462, '\p{^Is_Indic_Positional_Category=right}', "");
    Expect(0, 73462, '\P{Is_Indic_Positional_Category=right}', "");
    Expect(1, 73462, '\P{^Is_Indic_Positional_Category=right}', "");
    Expect(0, 73463, '\p{Is_Indic_Positional_Category=right}', "");
    Expect(1, 73463, '\p{^Is_Indic_Positional_Category=right}', "");
    Expect(1, 73463, '\P{Is_Indic_Positional_Category=right}', "");
    Expect(0, 73463, '\P{^Is_Indic_Positional_Category=right}', "");
    Expect(1, 73462, '\p{Is_Indic_Positional_Category=- RIGHT}', "");
    Expect(0, 73462, '\p{^Is_Indic_Positional_Category=- RIGHT}', "");
    Expect(0, 73462, '\P{Is_Indic_Positional_Category=- RIGHT}', "");
    Expect(1, 73462, '\P{^Is_Indic_Positional_Category=- RIGHT}', "");
    Expect(0, 73463, '\p{Is_Indic_Positional_Category=- RIGHT}', "");
    Expect(1, 73463, '\p{^Is_Indic_Positional_Category=- RIGHT}', "");
    Expect(1, 73463, '\P{Is_Indic_Positional_Category=- RIGHT}', "");
    Expect(0, 73463, '\P{^Is_Indic_Positional_Category=- RIGHT}', "");
    Error('\p{Is_InPC=_-right:=}');
    Error('\P{Is_InPC=_-right:=}');
    Expect(1, 73462, '\p{Is_InPC=right}', "");
    Expect(0, 73462, '\p{^Is_InPC=right}', "");
    Expect(0, 73462, '\P{Is_InPC=right}', "");
    Expect(1, 73462, '\P{^Is_InPC=right}', "");
    Expect(0, 73463, '\p{Is_InPC=right}', "");
    Expect(1, 73463, '\p{^Is_InPC=right}', "");
    Expect(1, 73463, '\P{Is_InPC=right}', "");
    Expect(0, 73463, '\P{^Is_InPC=right}', "");
    Expect(1, 73462, '\p{Is_InPC=-_Right}', "");
    Expect(0, 73462, '\p{^Is_InPC=-_Right}', "");
    Expect(0, 73462, '\P{Is_InPC=-_Right}', "");
    Expect(1, 73462, '\P{^Is_InPC=-_Right}', "");
    Expect(0, 73463, '\p{Is_InPC=-_Right}', "");
    Expect(1, 73463, '\p{^Is_InPC=-_Right}', "");
    Expect(1, 73463, '\P{Is_InPC=-_Right}', "");
    Expect(0, 73463, '\P{^Is_InPC=-_Right}', "");
    Error('\p{Indic_Positional_Category=  Top:=}');
    Error('\P{Indic_Positional_Category=  Top:=}');
    Expect(1, 73459, '\p{Indic_Positional_Category=:\ATop\z:}', "");;
    Expect(0, 73460, '\p{Indic_Positional_Category=:\ATop\z:}', "");;
    Expect(1, 73459, '\p{Indic_Positional_Category=top}', "");
    Expect(0, 73459, '\p{^Indic_Positional_Category=top}', "");
    Expect(0, 73459, '\P{Indic_Positional_Category=top}', "");
    Expect(1, 73459, '\P{^Indic_Positional_Category=top}', "");
    Expect(0, 73460, '\p{Indic_Positional_Category=top}', "");
    Expect(1, 73460, '\p{^Indic_Positional_Category=top}', "");
    Expect(1, 73460, '\P{Indic_Positional_Category=top}', "");
    Expect(0, 73460, '\P{^Indic_Positional_Category=top}', "");
    Expect(1, 73459, '\p{Indic_Positional_Category=:\Atop\z:}', "");;
    Expect(0, 73460, '\p{Indic_Positional_Category=:\Atop\z:}', "");;
    Expect(1, 73459, '\p{Indic_Positional_Category=  Top}', "");
    Expect(0, 73459, '\p{^Indic_Positional_Category=  Top}', "");
    Expect(0, 73459, '\P{Indic_Positional_Category=  Top}', "");
    Expect(1, 73459, '\P{^Indic_Positional_Category=  Top}', "");
    Expect(0, 73460, '\p{Indic_Positional_Category=  Top}', "");
    Expect(1, 73460, '\p{^Indic_Positional_Category=  Top}', "");
    Expect(1, 73460, '\P{Indic_Positional_Category=  Top}', "");
    Expect(0, 73460, '\P{^Indic_Positional_Category=  Top}', "");
    Error('\p{InPC=__TOP:=}');
    Error('\P{InPC=__TOP:=}');
    Expect(1, 73459, '\p{InPC=:\ATop\z:}', "");;
    Expect(0, 73460, '\p{InPC=:\ATop\z:}', "");;
    Expect(1, 73459, '\p{InPC=top}', "");
    Expect(0, 73459, '\p{^InPC=top}', "");
    Expect(0, 73459, '\P{InPC=top}', "");
    Expect(1, 73459, '\P{^InPC=top}', "");
    Expect(0, 73460, '\p{InPC=top}', "");
    Expect(1, 73460, '\p{^InPC=top}', "");
    Expect(1, 73460, '\P{InPC=top}', "");
    Expect(0, 73460, '\P{^InPC=top}', "");
    Expect(1, 73459, '\p{InPC=:\Atop\z:}', "");;
    Expect(0, 73460, '\p{InPC=:\Atop\z:}', "");;
    Expect(1, 73459, '\p{InPC=_	TOP}', "");
    Expect(0, 73459, '\p{^InPC=_	TOP}', "");
    Expect(0, 73459, '\P{InPC=_	TOP}', "");
    Expect(1, 73459, '\P{^InPC=_	TOP}', "");
    Expect(0, 73460, '\p{InPC=_	TOP}', "");
    Expect(1, 73460, '\p{^InPC=_	TOP}', "");
    Expect(1, 73460, '\P{InPC=_	TOP}', "");
    Expect(0, 73460, '\P{^InPC=_	TOP}', "");
    Error('\p{Is_Indic_Positional_Category: /a/__TOP}');
    Error('\P{Is_Indic_Positional_Category: /a/__TOP}');
    Expect(1, 73459, '\p{Is_Indic_Positional_Category=top}', "");
    Expect(0, 73459, '\p{^Is_Indic_Positional_Category=top}', "");
    Expect(0, 73459, '\P{Is_Indic_Positional_Category=top}', "");
    Expect(1, 73459, '\P{^Is_Indic_Positional_Category=top}', "");
    Expect(0, 73460, '\p{Is_Indic_Positional_Category=top}', "");
    Expect(1, 73460, '\p{^Is_Indic_Positional_Category=top}', "");
    Expect(1, 73460, '\P{Is_Indic_Positional_Category=top}', "");
    Expect(0, 73460, '\P{^Is_Indic_Positional_Category=top}', "");
    Expect(1, 73459, '\p{Is_Indic_Positional_Category=_ Top}', "");
    Expect(0, 73459, '\p{^Is_Indic_Positional_Category=_ Top}', "");
    Expect(0, 73459, '\P{Is_Indic_Positional_Category=_ Top}', "");
    Expect(1, 73459, '\P{^Is_Indic_Positional_Category=_ Top}', "");
    Expect(0, 73460, '\p{Is_Indic_Positional_Category=_ Top}', "");
    Expect(1, 73460, '\p{^Is_Indic_Positional_Category=_ Top}', "");
    Expect(1, 73460, '\P{Is_Indic_Positional_Category=_ Top}', "");
    Expect(0, 73460, '\P{^Is_Indic_Positional_Category=_ Top}', "");
    Error('\p{Is_InPC= 	Top:=}');
    Error('\P{Is_InPC= 	Top:=}');
    Expect(1, 73459, '\p{Is_InPC=top}', "");
    Expect(0, 73459, '\p{^Is_InPC=top}', "");
    Expect(0, 73459, '\P{Is_InPC=top}', "");
    Expect(1, 73459, '\P{^Is_InPC=top}', "");
    Expect(0, 73460, '\p{Is_InPC=top}', "");
    Expect(1, 73460, '\p{^Is_InPC=top}', "");
    Expect(1, 73460, '\P{Is_InPC=top}', "");
    Expect(0, 73460, '\P{^Is_InPC=top}', "");
    Expect(1, 73459, '\p{Is_InPC=	Top}', "");
    Expect(0, 73459, '\p{^Is_InPC=	Top}', "");
    Expect(0, 73459, '\P{Is_InPC=	Top}', "");
    Expect(1, 73459, '\P{^Is_InPC=	Top}', "");
    Expect(0, 73460, '\p{Is_InPC=	Top}', "");
    Expect(1, 73460, '\p{^Is_InPC=	Top}', "");
    Expect(1, 73460, '\P{Is_InPC=	Top}', "");
    Expect(0, 73460, '\P{^Is_InPC=	Top}', "");
    Error('\p{Indic_Positional_Category=:=	-top_And_Bottom}');
    Error('\P{Indic_Positional_Category=:=	-top_And_Bottom}');
    Expect(1, 69935, '\p{Indic_Positional_Category=:\ATop_And_Bottom\z:}', "");;
    Expect(0, 69936, '\p{Indic_Positional_Category=:\ATop_And_Bottom\z:}', "");;
    Expect(1, 69935, '\p{Indic_Positional_Category=topandbottom}', "");
    Expect(0, 69935, '\p{^Indic_Positional_Category=topandbottom}', "");
    Expect(0, 69935, '\P{Indic_Positional_Category=topandbottom}', "");
    Expect(1, 69935, '\P{^Indic_Positional_Category=topandbottom}', "");
    Expect(0, 69936, '\p{Indic_Positional_Category=topandbottom}', "");
    Expect(1, 69936, '\p{^Indic_Positional_Category=topandbottom}', "");
    Expect(1, 69936, '\P{Indic_Positional_Category=topandbottom}', "");
    Expect(0, 69936, '\P{^Indic_Positional_Category=topandbottom}', "");
    Expect(1, 69935, '\p{Indic_Positional_Category=:\Atopandbottom\z:}', "");;
    Expect(0, 69936, '\p{Indic_Positional_Category=:\Atopandbottom\z:}', "");;
    Expect(1, 69935, '\p{Indic_Positional_Category= _Top_And_BOTTOM}', "");
    Expect(0, 69935, '\p{^Indic_Positional_Category= _Top_And_BOTTOM}', "");
    Expect(0, 69935, '\P{Indic_Positional_Category= _Top_And_BOTTOM}', "");
    Expect(1, 69935, '\P{^Indic_Positional_Category= _Top_And_BOTTOM}', "");
    Expect(0, 69936, '\p{Indic_Positional_Category= _Top_And_BOTTOM}', "");
    Expect(1, 69936, '\p{^Indic_Positional_Category= _Top_And_BOTTOM}', "");
    Expect(1, 69936, '\P{Indic_Positional_Category= _Top_And_BOTTOM}', "");
    Expect(0, 69936, '\P{^Indic_Positional_Category= _Top_And_BOTTOM}', "");
    Error('\p{InPC:		:=TOP_and_BOTTOM}');
    Error('\P{InPC:		:=TOP_and_BOTTOM}');
    Expect(1, 69935, '\p{InPC=:\ATop_And_Bottom\z:}', "");;
    Expect(0, 69936, '\p{InPC=:\ATop_And_Bottom\z:}', "");;
    Expect(1, 69935, '\p{InPC=topandbottom}', "");
    Expect(0, 69935, '\p{^InPC=topandbottom}', "");
    Expect(0, 69935, '\P{InPC=topandbottom}', "");
    Expect(1, 69935, '\P{^InPC=topandbottom}', "");
    Expect(0, 69936, '\p{InPC=topandbottom}', "");
    Expect(1, 69936, '\p{^InPC=topandbottom}', "");
    Expect(1, 69936, '\P{InPC=topandbottom}', "");
    Expect(0, 69936, '\P{^InPC=topandbottom}', "");
    Expect(1, 69935, '\p{InPC=:\Atopandbottom\z:}', "");;
    Expect(0, 69936, '\p{InPC=:\Atopandbottom\z:}', "");;
    Expect(1, 69935, '\p{InPC=_	Top_And_Bottom}', "");
    Expect(0, 69935, '\p{^InPC=_	Top_And_Bottom}', "");
    Expect(0, 69935, '\P{InPC=_	Top_And_Bottom}', "");
    Expect(1, 69935, '\P{^InPC=_	Top_And_Bottom}', "");
    Expect(0, 69936, '\p{InPC=_	Top_And_Bottom}', "");
    Expect(1, 69936, '\p{^InPC=_	Top_And_Bottom}', "");
    Expect(1, 69936, '\P{InPC=_	Top_And_Bottom}', "");
    Expect(0, 69936, '\P{^InPC=_	Top_And_Bottom}', "");
    Error('\p{Is_Indic_Positional_Category=		top_AND_Bottom/a/}');
    Error('\P{Is_Indic_Positional_Category=		top_AND_Bottom/a/}');
    Expect(1, 69935, '\p{Is_Indic_Positional_Category=topandbottom}', "");
    Expect(0, 69935, '\p{^Is_Indic_Positional_Category=topandbottom}', "");
    Expect(0, 69935, '\P{Is_Indic_Positional_Category=topandbottom}', "");
    Expect(1, 69935, '\P{^Is_Indic_Positional_Category=topandbottom}', "");
    Expect(0, 69936, '\p{Is_Indic_Positional_Category=topandbottom}', "");
    Expect(1, 69936, '\p{^Is_Indic_Positional_Category=topandbottom}', "");
    Expect(1, 69936, '\P{Is_Indic_Positional_Category=topandbottom}', "");
    Expect(0, 69936, '\P{^Is_Indic_Positional_Category=topandbottom}', "");
    Expect(1, 69935, '\p{Is_Indic_Positional_Category= 	Top_and_Bottom}', "");
    Expect(0, 69935, '\p{^Is_Indic_Positional_Category= 	Top_and_Bottom}', "");
    Expect(0, 69935, '\P{Is_Indic_Positional_Category= 	Top_and_Bottom}', "");
    Expect(1, 69935, '\P{^Is_Indic_Positional_Category= 	Top_and_Bottom}', "");
    Expect(0, 69936, '\p{Is_Indic_Positional_Category= 	Top_and_Bottom}', "");
    Expect(1, 69936, '\p{^Is_Indic_Positional_Category= 	Top_and_Bottom}', "");
    Expect(1, 69936, '\P{Is_Indic_Positional_Category= 	Top_and_Bottom}', "");
    Expect(0, 69936, '\P{^Is_Indic_Positional_Category= 	Top_and_Bottom}', "");
    Error('\p{Is_InPC=/a/ 	TOP_And_bottom}');
    Error('\P{Is_InPC=/a/ 	TOP_And_bottom}');
    Expect(1, 69935, '\p{Is_InPC=topandbottom}', "");
    Expect(0, 69935, '\p{^Is_InPC=topandbottom}', "");
    Expect(0, 69935, '\P{Is_InPC=topandbottom}', "");
    Expect(1, 69935, '\P{^Is_InPC=topandbottom}', "");
    Expect(0, 69936, '\p{Is_InPC=topandbottom}', "");
    Expect(1, 69936, '\p{^Is_InPC=topandbottom}', "");
    Expect(1, 69936, '\P{Is_InPC=topandbottom}', "");
    Expect(0, 69936, '\P{^Is_InPC=topandbottom}', "");
    Expect(1, 69935, '\p{Is_InPC: -_top_And_Bottom}', "");
    Expect(0, 69935, '\p{^Is_InPC: -_top_And_Bottom}', "");
    Expect(0, 69935, '\P{Is_InPC: -_top_And_Bottom}', "");
    Expect(1, 69935, '\P{^Is_InPC: -_top_And_Bottom}', "");
    Expect(0, 69936, '\p{Is_InPC: -_top_And_Bottom}', "");
    Expect(1, 69936, '\p{^Is_InPC: -_top_And_Bottom}', "");
    Expect(1, 69936, '\P{Is_InPC: -_top_And_Bottom}', "");
    Expect(0, 69936, '\P{^Is_InPC: -_top_And_Bottom}', "");
    Error('\p{Indic_Positional_Category=:=TOP_AND_BOTTOM_and_Left}');
    Error('\P{Indic_Positional_Category=:=TOP_AND_BOTTOM_and_Left}');
    Expect(1, 71454, '\p{Indic_Positional_Category=:\ATop_And_Bottom_And_Left\z:}', "");;
    Expect(0, 71455, '\p{Indic_Positional_Category=:\ATop_And_Bottom_And_Left\z:}', "");;
    Expect(1, 71454, '\p{Indic_Positional_Category=topandbottomandleft}', "");
    Expect(0, 71454, '\p{^Indic_Positional_Category=topandbottomandleft}', "");
    Expect(0, 71454, '\P{Indic_Positional_Category=topandbottomandleft}', "");
    Expect(1, 71454, '\P{^Indic_Positional_Category=topandbottomandleft}', "");
    Expect(0, 71455, '\p{Indic_Positional_Category=topandbottomandleft}', "");
    Expect(1, 71455, '\p{^Indic_Positional_Category=topandbottomandleft}', "");
    Expect(1, 71455, '\P{Indic_Positional_Category=topandbottomandleft}', "");
    Expect(0, 71455, '\P{^Indic_Positional_Category=topandbottomandleft}', "");
    Expect(1, 71454, '\p{Indic_Positional_Category=:\Atopandbottomandleft\z:}', "");;
    Expect(0, 71455, '\p{Indic_Positional_Category=:\Atopandbottomandleft\z:}', "");;
    Expect(1, 71454, '\p{Indic_Positional_Category=-_Top_AND_Bottom_and_Left}', "");
    Expect(0, 71454, '\p{^Indic_Positional_Category=-_Top_AND_Bottom_and_Left}', "");
    Expect(0, 71454, '\P{Indic_Positional_Category=-_Top_AND_Bottom_and_Left}', "");
    Expect(1, 71454, '\P{^Indic_Positional_Category=-_Top_AND_Bottom_and_Left}', "");
    Expect(0, 71455, '\p{Indic_Positional_Category=-_Top_AND_Bottom_and_Left}', "");
    Expect(1, 71455, '\p{^Indic_Positional_Category=-_Top_AND_Bottom_and_Left}', "");
    Expect(1, 71455, '\P{Indic_Positional_Category=-_Top_AND_Bottom_and_Left}', "");
    Expect(0, 71455, '\P{^Indic_Positional_Category=-_Top_AND_Bottom_and_Left}', "");
    Error('\p{InPC= /a/Top_and_Bottom_AND_LEFT}');
    Error('\P{InPC= /a/Top_and_Bottom_AND_LEFT}');
    Expect(1, 71454, '\p{InPC=:\ATop_And_Bottom_And_Left\z:}', "");;
    Expect(0, 71455, '\p{InPC=:\ATop_And_Bottom_And_Left\z:}', "");;
    Expect(1, 71454, '\p{InPC=topandbottomandleft}', "");
    Expect(0, 71454, '\p{^InPC=topandbottomandleft}', "");
    Expect(0, 71454, '\P{InPC=topandbottomandleft}', "");
    Expect(1, 71454, '\P{^InPC=topandbottomandleft}', "");
    Expect(0, 71455, '\p{InPC=topandbottomandleft}', "");
    Expect(1, 71455, '\p{^InPC=topandbottomandleft}', "");
    Expect(1, 71455, '\P{InPC=topandbottomandleft}', "");
    Expect(0, 71455, '\P{^InPC=topandbottomandleft}', "");
    Expect(1, 71454, '\p{InPC=:\Atopandbottomandleft\z:}', "");;
    Expect(0, 71455, '\p{InPC=:\Atopandbottomandleft\z:}', "");;
    Expect(1, 71454, '\p{InPC= _TOP_and_bottom_And_LEFT}', "");
    Expect(0, 71454, '\p{^InPC= _TOP_and_bottom_And_LEFT}', "");
    Expect(0, 71454, '\P{InPC= _TOP_and_bottom_And_LEFT}', "");
    Expect(1, 71454, '\P{^InPC= _TOP_and_bottom_And_LEFT}', "");
    Expect(0, 71455, '\p{InPC= _TOP_and_bottom_And_LEFT}', "");
    Expect(1, 71455, '\p{^InPC= _TOP_and_bottom_And_LEFT}', "");
    Expect(1, 71455, '\P{InPC= _TOP_and_bottom_And_LEFT}', "");
    Expect(0, 71455, '\P{^InPC= _TOP_and_bottom_And_LEFT}', "");
    Error('\p{Is_Indic_Positional_Category=:=-top_and_bottom_And_Left}');
    Error('\P{Is_Indic_Positional_Category=:=-top_and_bottom_And_Left}');
    Expect(1, 71454, '\p{Is_Indic_Positional_Category=topandbottomandleft}', "");
    Expect(0, 71454, '\p{^Is_Indic_Positional_Category=topandbottomandleft}', "");
    Expect(0, 71454, '\P{Is_Indic_Positional_Category=topandbottomandleft}', "");
    Expect(1, 71454, '\P{^Is_Indic_Positional_Category=topandbottomandleft}', "");
    Expect(0, 71455, '\p{Is_Indic_Positional_Category=topandbottomandleft}', "");
    Expect(1, 71455, '\p{^Is_Indic_Positional_Category=topandbottomandleft}', "");
    Expect(1, 71455, '\P{Is_Indic_Positional_Category=topandbottomandleft}', "");
    Expect(0, 71455, '\P{^Is_Indic_Positional_Category=topandbottomandleft}', "");
    Expect(1, 71454, '\p{Is_Indic_Positional_Category=_Top_And_BOTTOM_AND_Left}', "");
    Expect(0, 71454, '\p{^Is_Indic_Positional_Category=_Top_And_BOTTOM_AND_Left}', "");
    Expect(0, 71454, '\P{Is_Indic_Positional_Category=_Top_And_BOTTOM_AND_Left}', "");
    Expect(1, 71454, '\P{^Is_Indic_Positional_Category=_Top_And_BOTTOM_AND_Left}', "");
    Expect(0, 71455, '\p{Is_Indic_Positional_Category=_Top_And_BOTTOM_AND_Left}', "");
    Expect(1, 71455, '\p{^Is_Indic_Positional_Category=_Top_And_BOTTOM_AND_Left}', "");
    Expect(1, 71455, '\P{Is_Indic_Positional_Category=_Top_And_BOTTOM_AND_Left}', "");
    Expect(0, 71455, '\P{^Is_Indic_Positional_Category=_Top_And_BOTTOM_AND_Left}', "");
    Error('\p{Is_InPC=	_TOP_And_Bottom_And_left:=}');
    Error('\P{Is_InPC=	_TOP_And_Bottom_And_left:=}');
    Expect(1, 71454, '\p{Is_InPC=topandbottomandleft}', "");
    Expect(0, 71454, '\p{^Is_InPC=topandbottomandleft}', "");
    Expect(0, 71454, '\P{Is_InPC=topandbottomandleft}', "");
    Expect(1, 71454, '\P{^Is_InPC=topandbottomandleft}', "");
    Expect(0, 71455, '\p{Is_InPC=topandbottomandleft}', "");
    Expect(1, 71455, '\p{^Is_InPC=topandbottomandleft}', "");
    Expect(1, 71455, '\P{Is_InPC=topandbottomandleft}', "");
    Expect(0, 71455, '\P{^Is_InPC=topandbottomandleft}', "");
    Expect(1, 71454, '\p{Is_InPC:-	TOP_and_BOTTOM_And_Left}', "");
    Expect(0, 71454, '\p{^Is_InPC:-	TOP_and_BOTTOM_And_Left}', "");
    Expect(0, 71454, '\P{Is_InPC:-	TOP_and_BOTTOM_And_Left}', "");
    Expect(1, 71454, '\P{^Is_InPC:-	TOP_and_BOTTOM_And_Left}', "");
    Expect(0, 71455, '\p{Is_InPC:-	TOP_and_BOTTOM_And_Left}', "");
    Expect(1, 71455, '\p{^Is_InPC:-	TOP_and_BOTTOM_And_Left}', "");
    Expect(1, 71455, '\P{Is_InPC:-	TOP_and_BOTTOM_And_Left}', "");
    Expect(0, 71455, '\P{^Is_InPC:-	TOP_and_BOTTOM_And_Left}', "");
    Error('\p{Indic_Positional_Category:   :=_	top_And_bottom_And_Right}');
    Error('\P{Indic_Positional_Category:   :=_	top_And_bottom_And_Right}');
    Expect(1, 6973, '\p{Indic_Positional_Category=:\ATop_And_Bottom_And_Right\z:}', "");;
    Expect(0, 6974, '\p{Indic_Positional_Category=:\ATop_And_Bottom_And_Right\z:}', "");;
    Expect(1, 6973, '\p{Indic_Positional_Category=topandbottomandright}', "");
    Expect(0, 6973, '\p{^Indic_Positional_Category=topandbottomandright}', "");
    Expect(0, 6973, '\P{Indic_Positional_Category=topandbottomandright}', "");
    Expect(1, 6973, '\P{^Indic_Positional_Category=topandbottomandright}', "");
    Expect(0, 6974, '\p{Indic_Positional_Category=topandbottomandright}', "");
    Expect(1, 6974, '\p{^Indic_Positional_Category=topandbottomandright}', "");
    Expect(1, 6974, '\P{Indic_Positional_Category=topandbottomandright}', "");
    Expect(0, 6974, '\P{^Indic_Positional_Category=topandbottomandright}', "");
    Expect(1, 6973, '\p{Indic_Positional_Category=:\Atopandbottomandright\z:}', "");;
    Expect(0, 6974, '\p{Indic_Positional_Category=:\Atopandbottomandright\z:}', "");;
    Expect(1, 6973, '\p{Indic_Positional_Category= Top_And_Bottom_and_RIGHT}', "");
    Expect(0, 6973, '\p{^Indic_Positional_Category= Top_And_Bottom_and_RIGHT}', "");
    Expect(0, 6973, '\P{Indic_Positional_Category= Top_And_Bottom_and_RIGHT}', "");
    Expect(1, 6973, '\P{^Indic_Positional_Category= Top_And_Bottom_and_RIGHT}', "");
    Expect(0, 6974, '\p{Indic_Positional_Category= Top_And_Bottom_and_RIGHT}', "");
    Expect(1, 6974, '\p{^Indic_Positional_Category= Top_And_Bottom_and_RIGHT}', "");
    Expect(1, 6974, '\P{Indic_Positional_Category= Top_And_Bottom_and_RIGHT}', "");
    Expect(0, 6974, '\P{^Indic_Positional_Category= Top_And_Bottom_and_RIGHT}', "");
    Error('\p{InPC: :=TOP_and_bottom_AND_right}');
    Error('\P{InPC: :=TOP_and_bottom_AND_right}');
    Expect(1, 6973, '\p{InPC=:\ATop_And_Bottom_And_Right\z:}', "");;
    Expect(0, 6974, '\p{InPC=:\ATop_And_Bottom_And_Right\z:}', "");;
    Expect(1, 6973, '\p{InPC=topandbottomandright}', "");
    Expect(0, 6973, '\p{^InPC=topandbottomandright}', "");
    Expect(0, 6973, '\P{InPC=topandbottomandright}', "");
    Expect(1, 6973, '\P{^InPC=topandbottomandright}', "");
    Expect(0, 6974, '\p{InPC=topandbottomandright}', "");
    Expect(1, 6974, '\p{^InPC=topandbottomandright}', "");
    Expect(1, 6974, '\P{InPC=topandbottomandright}', "");
    Expect(0, 6974, '\P{^InPC=topandbottomandright}', "");
    Expect(1, 6973, '\p{InPC=:\Atopandbottomandright\z:}', "");;
    Expect(0, 6974, '\p{InPC=:\Atopandbottomandright\z:}', "");;
    Expect(1, 6973, '\p{InPC:   - Top_And_Bottom_and_Right}', "");
    Expect(0, 6973, '\p{^InPC:   - Top_And_Bottom_and_Right}', "");
    Expect(0, 6973, '\P{InPC:   - Top_And_Bottom_and_Right}', "");
    Expect(1, 6973, '\P{^InPC:   - Top_And_Bottom_and_Right}', "");
    Expect(0, 6974, '\p{InPC:   - Top_And_Bottom_and_Right}', "");
    Expect(1, 6974, '\p{^InPC:   - Top_And_Bottom_and_Right}', "");
    Expect(1, 6974, '\P{InPC:   - Top_And_Bottom_and_Right}', "");
    Expect(0, 6974, '\P{^InPC:   - Top_And_Bottom_and_Right}', "");
    Error('\p{Is_Indic_Positional_Category=/a/top_And_Bottom_AND_right}');
    Error('\P{Is_Indic_Positional_Category=/a/top_And_Bottom_AND_right}');
    Expect(1, 6973, '\p{Is_Indic_Positional_Category=topandbottomandright}', "");
    Expect(0, 6973, '\p{^Is_Indic_Positional_Category=topandbottomandright}', "");
    Expect(0, 6973, '\P{Is_Indic_Positional_Category=topandbottomandright}', "");
    Expect(1, 6973, '\P{^Is_Indic_Positional_Category=topandbottomandright}', "");
    Expect(0, 6974, '\p{Is_Indic_Positional_Category=topandbottomandright}', "");
    Expect(1, 6974, '\p{^Is_Indic_Positional_Category=topandbottomandright}', "");
    Expect(1, 6974, '\P{Is_Indic_Positional_Category=topandbottomandright}', "");
    Expect(0, 6974, '\P{^Is_Indic_Positional_Category=topandbottomandright}', "");
    Expect(1, 6973, '\p{Is_Indic_Positional_Category=- Top_And_bottom_And_right}', "");
    Expect(0, 6973, '\p{^Is_Indic_Positional_Category=- Top_And_bottom_And_right}', "");
    Expect(0, 6973, '\P{Is_Indic_Positional_Category=- Top_And_bottom_And_right}', "");
    Expect(1, 6973, '\P{^Is_Indic_Positional_Category=- Top_And_bottom_And_right}', "");
    Expect(0, 6974, '\p{Is_Indic_Positional_Category=- Top_And_bottom_And_right}', "");
    Expect(1, 6974, '\p{^Is_Indic_Positional_Category=- Top_And_bottom_And_right}', "");
    Expect(1, 6974, '\P{Is_Indic_Positional_Category=- Top_And_bottom_And_right}', "");
    Expect(0, 6974, '\P{^Is_Indic_Positional_Category=- Top_And_bottom_And_right}', "");
    Error('\p{Is_InPC=	/a/Top_and_Bottom_and_Right}');
    Error('\P{Is_InPC=	/a/Top_and_Bottom_and_Right}');
    Expect(1, 6973, '\p{Is_InPC=topandbottomandright}', "");
    Expect(0, 6973, '\p{^Is_InPC=topandbottomandright}', "");
    Expect(0, 6973, '\P{Is_InPC=topandbottomandright}', "");
    Expect(1, 6973, '\P{^Is_InPC=topandbottomandright}', "");
    Expect(0, 6974, '\p{Is_InPC=topandbottomandright}', "");
    Expect(1, 6974, '\p{^Is_InPC=topandbottomandright}', "");
    Expect(1, 6974, '\P{Is_InPC=topandbottomandright}', "");
    Expect(0, 6974, '\P{^Is_InPC=topandbottomandright}', "");
    Expect(1, 6973, '\p{Is_InPC=	 Top_AND_Bottom_And_right}', "");
    Expect(0, 6973, '\p{^Is_InPC=	 Top_AND_Bottom_And_right}', "");
    Expect(0, 6973, '\P{Is_InPC=	 Top_AND_Bottom_And_right}', "");
    Expect(1, 6973, '\P{^Is_InPC=	 Top_AND_Bottom_And_right}', "");
    Expect(0, 6974, '\p{Is_InPC=	 Top_AND_Bottom_And_right}', "");
    Expect(1, 6974, '\p{^Is_InPC=	 Top_AND_Bottom_And_right}', "");
    Expect(1, 6974, '\P{Is_InPC=	 Top_AND_Bottom_And_right}', "");
    Expect(0, 6974, '\P{^Is_InPC=	 Top_AND_Bottom_And_right}', "");
    Error('\p{Indic_Positional_Category=:=-TOP_And_LEFT}');
    Error('\P{Indic_Positional_Category=:=-TOP_And_LEFT}');
    Expect(1, 71097, '\p{Indic_Positional_Category=:\ATop_And_Left\z:}', "");;
    Expect(0, 71098, '\p{Indic_Positional_Category=:\ATop_And_Left\z:}', "");;
    Expect(1, 71097, '\p{Indic_Positional_Category=topandleft}', "");
    Expect(0, 71097, '\p{^Indic_Positional_Category=topandleft}', "");
    Expect(0, 71097, '\P{Indic_Positional_Category=topandleft}', "");
    Expect(1, 71097, '\P{^Indic_Positional_Category=topandleft}', "");
    Expect(0, 71098, '\p{Indic_Positional_Category=topandleft}', "");
    Expect(1, 71098, '\p{^Indic_Positional_Category=topandleft}', "");
    Expect(1, 71098, '\P{Indic_Positional_Category=topandleft}', "");
    Expect(0, 71098, '\P{^Indic_Positional_Category=topandleft}', "");
    Expect(1, 71097, '\p{Indic_Positional_Category=:\Atopandleft\z:}', "");;
    Expect(0, 71098, '\p{Indic_Positional_Category=:\Atopandleft\z:}', "");;
    Expect(1, 71097, '\p{Indic_Positional_Category:		Top_And_LEFT}', "");
    Expect(0, 71097, '\p{^Indic_Positional_Category:		Top_And_LEFT}', "");
    Expect(0, 71097, '\P{Indic_Positional_Category:		Top_And_LEFT}', "");
    Expect(1, 71097, '\P{^Indic_Positional_Category:		Top_And_LEFT}', "");
    Expect(0, 71098, '\p{Indic_Positional_Category:		Top_And_LEFT}', "");
    Expect(1, 71098, '\p{^Indic_Positional_Category:		Top_And_LEFT}', "");
    Expect(1, 71098, '\P{Indic_Positional_Category:		Top_And_LEFT}', "");
    Expect(0, 71098, '\P{^Indic_Positional_Category:		Top_And_LEFT}', "");
    Error('\p{InPC=  Top_And_left:=}');
    Error('\P{InPC=  Top_And_left:=}');
    Expect(1, 71097, '\p{InPC=:\ATop_And_Left\z:}', "");;
    Expect(0, 71098, '\p{InPC=:\ATop_And_Left\z:}', "");;
    Expect(1, 71097, '\p{InPC=topandleft}', "");
    Expect(0, 71097, '\p{^InPC=topandleft}', "");
    Expect(0, 71097, '\P{InPC=topandleft}', "");
    Expect(1, 71097, '\P{^InPC=topandleft}', "");
    Expect(0, 71098, '\p{InPC=topandleft}', "");
    Expect(1, 71098, '\p{^InPC=topandleft}', "");
    Expect(1, 71098, '\P{InPC=topandleft}', "");
    Expect(0, 71098, '\P{^InPC=topandleft}', "");
    Expect(1, 71097, '\p{InPC=:\Atopandleft\z:}', "");;
    Expect(0, 71098, '\p{InPC=:\Atopandleft\z:}', "");;
    Expect(1, 71097, '\p{InPC=  Top_and_Left}', "");
    Expect(0, 71097, '\p{^InPC=  Top_and_Left}', "");
    Expect(0, 71097, '\P{InPC=  Top_and_Left}', "");
    Expect(1, 71097, '\P{^InPC=  Top_and_Left}', "");
    Expect(0, 71098, '\p{InPC=  Top_and_Left}', "");
    Expect(1, 71098, '\p{^InPC=  Top_and_Left}', "");
    Expect(1, 71098, '\P{InPC=  Top_and_Left}', "");
    Expect(0, 71098, '\P{^InPC=  Top_and_Left}', "");
    Error('\p{Is_Indic_Positional_Category=  Top_and_Left:=}');
    Error('\P{Is_Indic_Positional_Category=  Top_and_Left:=}');
    Expect(1, 71097, '\p{Is_Indic_Positional_Category=topandleft}', "");
    Expect(0, 71097, '\p{^Is_Indic_Positional_Category=topandleft}', "");
    Expect(0, 71097, '\P{Is_Indic_Positional_Category=topandleft}', "");
    Expect(1, 71097, '\P{^Is_Indic_Positional_Category=topandleft}', "");
    Expect(0, 71098, '\p{Is_Indic_Positional_Category=topandleft}', "");
    Expect(1, 71098, '\p{^Is_Indic_Positional_Category=topandleft}', "");
    Expect(1, 71098, '\P{Is_Indic_Positional_Category=topandleft}', "");
    Expect(0, 71098, '\P{^Is_Indic_Positional_Category=topandleft}', "");
    Expect(1, 71097, '\p{Is_Indic_Positional_Category= _top_And_Left}', "");
    Expect(0, 71097, '\p{^Is_Indic_Positional_Category= _top_And_Left}', "");
    Expect(0, 71097, '\P{Is_Indic_Positional_Category= _top_And_Left}', "");
    Expect(1, 71097, '\P{^Is_Indic_Positional_Category= _top_And_Left}', "");
    Expect(0, 71098, '\p{Is_Indic_Positional_Category= _top_And_Left}', "");
    Expect(1, 71098, '\p{^Is_Indic_Positional_Category= _top_And_Left}', "");
    Expect(1, 71098, '\P{Is_Indic_Positional_Category= _top_And_Left}', "");
    Expect(0, 71098, '\P{^Is_Indic_Positional_Category= _top_And_Left}', "");
    Error('\p{Is_InPC=_/a/Top_And_left}');
    Error('\P{Is_InPC=_/a/Top_And_left}');
    Expect(1, 71097, '\p{Is_InPC=topandleft}', "");
    Expect(0, 71097, '\p{^Is_InPC=topandleft}', "");
    Expect(0, 71097, '\P{Is_InPC=topandleft}', "");
    Expect(1, 71097, '\P{^Is_InPC=topandleft}', "");
    Expect(0, 71098, '\p{Is_InPC=topandleft}', "");
    Expect(1, 71098, '\p{^Is_InPC=topandleft}', "");
    Expect(1, 71098, '\P{Is_InPC=topandleft}', "");
    Expect(0, 71098, '\P{^Is_InPC=topandleft}', "");
    Expect(1, 71097, '\p{Is_InPC=-	TOP_And_Left}', "");
    Expect(0, 71097, '\p{^Is_InPC=-	TOP_And_Left}', "");
    Expect(0, 71097, '\P{Is_InPC=-	TOP_And_Left}', "");
    Expect(1, 71097, '\P{^Is_InPC=-	TOP_And_Left}', "");
    Expect(0, 71098, '\p{Is_InPC=-	TOP_And_Left}', "");
    Expect(1, 71098, '\p{^Is_InPC=-	TOP_And_Left}', "");
    Expect(1, 71098, '\P{Is_InPC=-	TOP_And_Left}', "");
    Expect(0, 71098, '\P{^Is_InPC=-	TOP_And_Left}', "");
    Error('\p{Indic_Positional_Category=-:=TOP_And_Left_and_Right}');
    Error('\P{Indic_Positional_Category=-:=TOP_And_Left_and_Right}');
    Expect(1, 71099, '\p{Indic_Positional_Category=:\ATop_And_Left_And_Right\z:}', "");;
    Expect(0, 71100, '\p{Indic_Positional_Category=:\ATop_And_Left_And_Right\z:}', "");;
    Expect(1, 71099, '\p{Indic_Positional_Category=topandleftandright}', "");
    Expect(0, 71099, '\p{^Indic_Positional_Category=topandleftandright}', "");
    Expect(0, 71099, '\P{Indic_Positional_Category=topandleftandright}', "");
    Expect(1, 71099, '\P{^Indic_Positional_Category=topandleftandright}', "");
    Expect(0, 71100, '\p{Indic_Positional_Category=topandleftandright}', "");
    Expect(1, 71100, '\p{^Indic_Positional_Category=topandleftandright}', "");
    Expect(1, 71100, '\P{Indic_Positional_Category=topandleftandright}', "");
    Expect(0, 71100, '\P{^Indic_Positional_Category=topandleftandright}', "");
    Expect(1, 71099, '\p{Indic_Positional_Category=:\Atopandleftandright\z:}', "");;
    Expect(0, 71100, '\p{Indic_Positional_Category=:\Atopandleftandright\z:}', "");;
    Expect(1, 71099, '\p{Indic_Positional_Category=	TOP_And_Left_and_right}', "");
    Expect(0, 71099, '\p{^Indic_Positional_Category=	TOP_And_Left_and_right}', "");
    Expect(0, 71099, '\P{Indic_Positional_Category=	TOP_And_Left_and_right}', "");
    Expect(1, 71099, '\P{^Indic_Positional_Category=	TOP_And_Left_and_right}', "");
    Expect(0, 71100, '\p{Indic_Positional_Category=	TOP_And_Left_and_right}', "");
    Expect(1, 71100, '\p{^Indic_Positional_Category=	TOP_And_Left_and_right}', "");
    Expect(1, 71100, '\P{Indic_Positional_Category=	TOP_And_Left_and_right}', "");
    Expect(0, 71100, '\P{^Indic_Positional_Category=	TOP_And_Left_and_right}', "");
    Error('\p{InPC:	-/a/Top_and_LEFT_And_RIGHT}');
    Error('\P{InPC:	-/a/Top_and_LEFT_And_RIGHT}');
    Expect(1, 71099, '\p{InPC=:\ATop_And_Left_And_Right\z:}', "");;
    Expect(0, 71100, '\p{InPC=:\ATop_And_Left_And_Right\z:}', "");;
    Expect(1, 71099, '\p{InPC=topandleftandright}', "");
    Expect(0, 71099, '\p{^InPC=topandleftandright}', "");
    Expect(0, 71099, '\P{InPC=topandleftandright}', "");
    Expect(1, 71099, '\P{^InPC=topandleftandright}', "");
    Expect(0, 71100, '\p{InPC=topandleftandright}', "");
    Expect(1, 71100, '\p{^InPC=topandleftandright}', "");
    Expect(1, 71100, '\P{InPC=topandleftandright}', "");
    Expect(0, 71100, '\P{^InPC=topandleftandright}', "");
    Expect(1, 71099, '\p{InPC=:\Atopandleftandright\z:}', "");;
    Expect(0, 71100, '\p{InPC=:\Atopandleftandright\z:}', "");;
    Expect(1, 71099, '\p{InPC=-Top_And_Left_And_RIGHT}', "");
    Expect(0, 71099, '\p{^InPC=-Top_And_Left_And_RIGHT}', "");
    Expect(0, 71099, '\P{InPC=-Top_And_Left_And_RIGHT}', "");
    Expect(1, 71099, '\P{^InPC=-Top_And_Left_And_RIGHT}', "");
    Expect(0, 71100, '\p{InPC=-Top_And_Left_And_RIGHT}', "");
    Expect(1, 71100, '\p{^InPC=-Top_And_Left_And_RIGHT}', "");
    Expect(1, 71100, '\P{InPC=-Top_And_Left_And_RIGHT}', "");
    Expect(0, 71100, '\P{^InPC=-Top_And_Left_And_RIGHT}', "");
    Error('\p{Is_Indic_Positional_Category=/a/_ top_and_Left_And_Right}');
    Error('\P{Is_Indic_Positional_Category=/a/_ top_and_Left_And_Right}');
    Expect(1, 71099, '\p{Is_Indic_Positional_Category=topandleftandright}', "");
    Expect(0, 71099, '\p{^Is_Indic_Positional_Category=topandleftandright}', "");
    Expect(0, 71099, '\P{Is_Indic_Positional_Category=topandleftandright}', "");
    Expect(1, 71099, '\P{^Is_Indic_Positional_Category=topandleftandright}', "");
    Expect(0, 71100, '\p{Is_Indic_Positional_Category=topandleftandright}', "");
    Expect(1, 71100, '\p{^Is_Indic_Positional_Category=topandleftandright}', "");
    Expect(1, 71100, '\P{Is_Indic_Positional_Category=topandleftandright}', "");
    Expect(0, 71100, '\P{^Is_Indic_Positional_Category=topandleftandright}', "");
    Expect(1, 71099, '\p{Is_Indic_Positional_Category:_-Top_And_LEFT_and_right}', "");
    Expect(0, 71099, '\p{^Is_Indic_Positional_Category:_-Top_And_LEFT_and_right}', "");
    Expect(0, 71099, '\P{Is_Indic_Positional_Category:_-Top_And_LEFT_and_right}', "");
    Expect(1, 71099, '\P{^Is_Indic_Positional_Category:_-Top_And_LEFT_and_right}', "");
    Expect(0, 71100, '\p{Is_Indic_Positional_Category:_-Top_And_LEFT_and_right}', "");
    Expect(1, 71100, '\p{^Is_Indic_Positional_Category:_-Top_And_LEFT_and_right}', "");
    Expect(1, 71100, '\P{Is_Indic_Positional_Category:_-Top_And_LEFT_and_right}', "");
    Expect(0, 71100, '\P{^Is_Indic_Positional_Category:_-Top_And_LEFT_and_right}', "");
    Error('\p{Is_InPC= :=Top_AND_Left_And_Right}');
    Error('\P{Is_InPC= :=Top_AND_Left_And_Right}');
    Expect(1, 71099, '\p{Is_InPC=topandleftandright}', "");
    Expect(0, 71099, '\p{^Is_InPC=topandleftandright}', "");
    Expect(0, 71099, '\P{Is_InPC=topandleftandright}', "");
    Expect(1, 71099, '\P{^Is_InPC=topandleftandright}', "");
    Expect(0, 71100, '\p{Is_InPC=topandleftandright}', "");
    Expect(1, 71100, '\p{^Is_InPC=topandleftandright}', "");
    Expect(1, 71100, '\P{Is_InPC=topandleftandright}', "");
    Expect(0, 71100, '\P{^Is_InPC=topandleftandright}', "");
    Expect(1, 71099, '\p{Is_InPC=__TOP_AND_Left_And_RIGHT}', "");
    Expect(0, 71099, '\p{^Is_InPC=__TOP_AND_Left_And_RIGHT}', "");
    Expect(0, 71099, '\P{Is_InPC=__TOP_AND_Left_And_RIGHT}', "");
    Expect(1, 71099, '\P{^Is_InPC=__TOP_AND_Left_And_RIGHT}', "");
    Expect(0, 71100, '\p{Is_InPC=__TOP_AND_Left_And_RIGHT}', "");
    Expect(1, 71100, '\p{^Is_InPC=__TOP_AND_Left_And_RIGHT}', "");
    Expect(1, 71100, '\P{Is_InPC=__TOP_AND_Left_And_RIGHT}', "");
    Expect(0, 71100, '\P{^Is_InPC=__TOP_AND_Left_And_RIGHT}', "");
    Error('\p{Indic_Positional_Category=/a/	Top_AND_Right}');
    Error('\P{Indic_Positional_Category=/a/	Top_AND_Right}');
    Expect(1, 70195, '\p{Indic_Positional_Category=:\ATop_And_Right\z:}', "");;
    Expect(0, 70196, '\p{Indic_Positional_Category=:\ATop_And_Right\z:}', "");;
    Expect(1, 70195, '\p{Indic_Positional_Category=topandright}', "");
    Expect(0, 70195, '\p{^Indic_Positional_Category=topandright}', "");
    Expect(0, 70195, '\P{Indic_Positional_Category=topandright}', "");
    Expect(1, 70195, '\P{^Indic_Positional_Category=topandright}', "");
    Expect(0, 70196, '\p{Indic_Positional_Category=topandright}', "");
    Expect(1, 70196, '\p{^Indic_Positional_Category=topandright}', "");
    Expect(1, 70196, '\P{Indic_Positional_Category=topandright}', "");
    Expect(0, 70196, '\P{^Indic_Positional_Category=topandright}', "");
    Expect(1, 70195, '\p{Indic_Positional_Category=:\Atopandright\z:}', "");;
    Expect(0, 70196, '\p{Indic_Positional_Category=:\Atopandright\z:}', "");;
    Expect(1, 70195, '\p{Indic_Positional_Category:  	TOP_AND_RIGHT}', "");
    Expect(0, 70195, '\p{^Indic_Positional_Category:  	TOP_AND_RIGHT}', "");
    Expect(0, 70195, '\P{Indic_Positional_Category:  	TOP_AND_RIGHT}', "");
    Expect(1, 70195, '\P{^Indic_Positional_Category:  	TOP_AND_RIGHT}', "");
    Expect(0, 70196, '\p{Indic_Positional_Category:  	TOP_AND_RIGHT}', "");
    Expect(1, 70196, '\p{^Indic_Positional_Category:  	TOP_AND_RIGHT}', "");
    Expect(1, 70196, '\P{Indic_Positional_Category:  	TOP_AND_RIGHT}', "");
    Expect(0, 70196, '\P{^Indic_Positional_Category:  	TOP_AND_RIGHT}', "");
    Error('\p{InPC:   _	TOP_and_RIGHT/a/}');
    Error('\P{InPC:   _	TOP_and_RIGHT/a/}');
    Expect(1, 70195, '\p{InPC=:\ATop_And_Right\z:}', "");;
    Expect(0, 70196, '\p{InPC=:\ATop_And_Right\z:}', "");;
    Expect(1, 70195, '\p{InPC=topandright}', "");
    Expect(0, 70195, '\p{^InPC=topandright}', "");
    Expect(0, 70195, '\P{InPC=topandright}', "");
    Expect(1, 70195, '\P{^InPC=topandright}', "");
    Expect(0, 70196, '\p{InPC=topandright}', "");
    Expect(1, 70196, '\p{^InPC=topandright}', "");
    Expect(1, 70196, '\P{InPC=topandright}', "");
    Expect(0, 70196, '\P{^InPC=topandright}', "");
    Expect(1, 70195, '\p{InPC=:\Atopandright\z:}', "");;
    Expect(0, 70196, '\p{InPC=:\Atopandright\z:}', "");;
    Expect(1, 70195, '\p{InPC= _Top_and_RIGHT}', "");
    Expect(0, 70195, '\p{^InPC= _Top_and_RIGHT}', "");
    Expect(0, 70195, '\P{InPC= _Top_and_RIGHT}', "");
    Expect(1, 70195, '\P{^InPC= _Top_and_RIGHT}', "");
    Expect(0, 70196, '\p{InPC= _Top_and_RIGHT}', "");
    Expect(1, 70196, '\p{^InPC= _Top_and_RIGHT}', "");
    Expect(1, 70196, '\P{InPC= _Top_and_RIGHT}', "");
    Expect(0, 70196, '\P{^InPC= _Top_and_RIGHT}', "");
    Error('\p{Is_Indic_Positional_Category=:= _top_And_Right}');
    Error('\P{Is_Indic_Positional_Category=:= _top_And_Right}');
    Expect(1, 70195, '\p{Is_Indic_Positional_Category=topandright}', "");
    Expect(0, 70195, '\p{^Is_Indic_Positional_Category=topandright}', "");
    Expect(0, 70195, '\P{Is_Indic_Positional_Category=topandright}', "");
    Expect(1, 70195, '\P{^Is_Indic_Positional_Category=topandright}', "");
    Expect(0, 70196, '\p{Is_Indic_Positional_Category=topandright}', "");
    Expect(1, 70196, '\p{^Is_Indic_Positional_Category=topandright}', "");
    Expect(1, 70196, '\P{Is_Indic_Positional_Category=topandright}', "");
    Expect(0, 70196, '\P{^Is_Indic_Positional_Category=topandright}', "");
    Expect(1, 70195, '\p{Is_Indic_Positional_Category=	Top_AND_right}', "");
    Expect(0, 70195, '\p{^Is_Indic_Positional_Category=	Top_AND_right}', "");
    Expect(0, 70195, '\P{Is_Indic_Positional_Category=	Top_AND_right}', "");
    Expect(1, 70195, '\P{^Is_Indic_Positional_Category=	Top_AND_right}', "");
    Expect(0, 70196, '\p{Is_Indic_Positional_Category=	Top_AND_right}', "");
    Expect(1, 70196, '\p{^Is_Indic_Positional_Category=	Top_AND_right}', "");
    Expect(1, 70196, '\P{Is_Indic_Positional_Category=	Top_AND_right}', "");
    Expect(0, 70196, '\P{^Is_Indic_Positional_Category=	Top_AND_right}', "");
    Error('\p{Is_InPC=/a/Top_AND_RIGHT}');
    Error('\P{Is_InPC=/a/Top_AND_RIGHT}');
    Expect(1, 70195, '\p{Is_InPC=topandright}', "");
    Expect(0, 70195, '\p{^Is_InPC=topandright}', "");
    Expect(0, 70195, '\P{Is_InPC=topandright}', "");
    Expect(1, 70195, '\P{^Is_InPC=topandright}', "");
    Expect(0, 70196, '\p{Is_InPC=topandright}', "");
    Expect(1, 70196, '\p{^Is_InPC=topandright}', "");
    Expect(1, 70196, '\P{Is_InPC=topandright}', "");
    Expect(0, 70196, '\P{^Is_InPC=topandright}', "");
    Expect(1, 70195, '\p{Is_InPC=-Top_AND_right}', "");
    Expect(0, 70195, '\p{^Is_InPC=-Top_AND_right}', "");
    Expect(0, 70195, '\P{Is_InPC=-Top_AND_right}', "");
    Expect(1, 70195, '\P{^Is_InPC=-Top_AND_right}', "");
    Expect(0, 70196, '\p{Is_InPC=-Top_AND_right}', "");
    Expect(1, 70196, '\p{^Is_InPC=-Top_AND_right}', "");
    Expect(1, 70196, '\P{Is_InPC=-Top_AND_right}', "");
    Expect(0, 70196, '\P{^Is_InPC=-Top_AND_right}', "");
    Error('\p{Indic_Positional_Category=:=	-VISUAL_ORDER_Left}');
    Error('\P{Indic_Positional_Category=:=	-VISUAL_ORDER_Left}');
    Expect(1, 43708, '\p{Indic_Positional_Category=:\AVisual_Order_Left\z:}', "");;
    Expect(0, 43709, '\p{Indic_Positional_Category=:\AVisual_Order_Left\z:}', "");;
    Expect(1, 43708, '\p{Indic_Positional_Category=visualorderleft}', "");
    Expect(0, 43708, '\p{^Indic_Positional_Category=visualorderleft}', "");
    Expect(0, 43708, '\P{Indic_Positional_Category=visualorderleft}', "");
    Expect(1, 43708, '\P{^Indic_Positional_Category=visualorderleft}', "");
    Expect(0, 43709, '\p{Indic_Positional_Category=visualorderleft}', "");
    Expect(1, 43709, '\p{^Indic_Positional_Category=visualorderleft}', "");
    Expect(1, 43709, '\P{Indic_Positional_Category=visualorderleft}', "");
    Expect(0, 43709, '\P{^Indic_Positional_Category=visualorderleft}', "");
    Expect(1, 43708, '\p{Indic_Positional_Category=:\Avisualorderleft\z:}', "");;
    Expect(0, 43709, '\p{Indic_Positional_Category=:\Avisualorderleft\z:}', "");;
    Expect(1, 43708, '\p{Indic_Positional_Category=	visual_ORDER_left}', "");
    Expect(0, 43708, '\p{^Indic_Positional_Category=	visual_ORDER_left}', "");
    Expect(0, 43708, '\P{Indic_Positional_Category=	visual_ORDER_left}', "");
    Expect(1, 43708, '\P{^Indic_Positional_Category=	visual_ORDER_left}', "");
    Expect(0, 43709, '\p{Indic_Positional_Category=	visual_ORDER_left}', "");
    Expect(1, 43709, '\p{^Indic_Positional_Category=	visual_ORDER_left}', "");
    Expect(1, 43709, '\P{Indic_Positional_Category=	visual_ORDER_left}', "");
    Expect(0, 43709, '\P{^Indic_Positional_Category=	visual_ORDER_left}', "");
    Error('\p{InPC=_VISUAL_Order_left/a/}');
    Error('\P{InPC=_VISUAL_Order_left/a/}');
    Expect(1, 43708, '\p{InPC=:\AVisual_Order_Left\z:}', "");;
    Expect(0, 43709, '\p{InPC=:\AVisual_Order_Left\z:}', "");;
    Expect(1, 43708, '\p{InPC=visualorderleft}', "");
    Expect(0, 43708, '\p{^InPC=visualorderleft}', "");
    Expect(0, 43708, '\P{InPC=visualorderleft}', "");
    Expect(1, 43708, '\P{^InPC=visualorderleft}', "");
    Expect(0, 43709, '\p{InPC=visualorderleft}', "");
    Expect(1, 43709, '\p{^InPC=visualorderleft}', "");
    Expect(1, 43709, '\P{InPC=visualorderleft}', "");
    Expect(0, 43709, '\P{^InPC=visualorderleft}', "");
    Expect(1, 43708, '\p{InPC=:\Avisualorderleft\z:}', "");;
    Expect(0, 43709, '\p{InPC=:\Avisualorderleft\z:}', "");;
    Expect(1, 43708, '\p{InPC=	 visual_order_Left}', "");
    Expect(0, 43708, '\p{^InPC=	 visual_order_Left}', "");
    Expect(0, 43708, '\P{InPC=	 visual_order_Left}', "");
    Expect(1, 43708, '\P{^InPC=	 visual_order_Left}', "");
    Expect(0, 43709, '\p{InPC=	 visual_order_Left}', "");
    Expect(1, 43709, '\p{^InPC=	 visual_order_Left}', "");
    Expect(1, 43709, '\P{InPC=	 visual_order_Left}', "");
    Expect(0, 43709, '\P{^InPC=	 visual_order_Left}', "");
    Error('\p{Is_Indic_Positional_Category=-_Visual_Order_left/a/}');
    Error('\P{Is_Indic_Positional_Category=-_Visual_Order_left/a/}');
    Expect(1, 43708, '\p{Is_Indic_Positional_Category=visualorderleft}', "");
    Expect(0, 43708, '\p{^Is_Indic_Positional_Category=visualorderleft}', "");
    Expect(0, 43708, '\P{Is_Indic_Positional_Category=visualorderleft}', "");
    Expect(1, 43708, '\P{^Is_Indic_Positional_Category=visualorderleft}', "");
    Expect(0, 43709, '\p{Is_Indic_Positional_Category=visualorderleft}', "");
    Expect(1, 43709, '\p{^Is_Indic_Positional_Category=visualorderleft}', "");
    Expect(1, 43709, '\P{Is_Indic_Positional_Category=visualorderleft}', "");
    Expect(0, 43709, '\P{^Is_Indic_Positional_Category=visualorderleft}', "");
    Expect(1, 43708, '\p{Is_Indic_Positional_Category=_Visual_ORDER_Left}', "");
    Expect(0, 43708, '\p{^Is_Indic_Positional_Category=_Visual_ORDER_Left}', "");
    Expect(0, 43708, '\P{Is_Indic_Positional_Category=_Visual_ORDER_Left}', "");
    Expect(1, 43708, '\P{^Is_Indic_Positional_Category=_Visual_ORDER_Left}', "");
    Expect(0, 43709, '\p{Is_Indic_Positional_Category=_Visual_ORDER_Left}', "");
    Expect(1, 43709, '\p{^Is_Indic_Positional_Category=_Visual_ORDER_Left}', "");
    Expect(1, 43709, '\P{Is_Indic_Positional_Category=_Visual_ORDER_Left}', "");
    Expect(0, 43709, '\P{^Is_Indic_Positional_Category=_Visual_ORDER_Left}', "");
    Error('\p{Is_InPC=	visual_Order_left:=}');
    Error('\P{Is_InPC=	visual_Order_left:=}');
    Expect(1, 43708, '\p{Is_InPC:	visualorderleft}', "");
    Expect(0, 43708, '\p{^Is_InPC:	visualorderleft}', "");
    Expect(0, 43708, '\P{Is_InPC:	visualorderleft}', "");
    Expect(1, 43708, '\P{^Is_InPC:	visualorderleft}', "");
    Expect(0, 43709, '\p{Is_InPC:	visualorderleft}', "");
    Expect(1, 43709, '\p{^Is_InPC:	visualorderleft}', "");
    Expect(1, 43709, '\P{Is_InPC:	visualorderleft}', "");
    Expect(0, 43709, '\P{^Is_InPC:	visualorderleft}', "");
    Expect(1, 43708, '\p{Is_InPC= Visual_ORDER_Left}', "");
    Expect(0, 43708, '\p{^Is_InPC= Visual_ORDER_Left}', "");
    Expect(0, 43708, '\P{Is_InPC= Visual_ORDER_Left}', "");
    Expect(1, 43708, '\P{^Is_InPC= Visual_ORDER_Left}', "");
    Expect(0, 43709, '\p{Is_InPC= Visual_ORDER_Left}', "");
    Expect(1, 43709, '\p{^Is_InPC= Visual_ORDER_Left}', "");
    Expect(1, 43709, '\P{Is_InPC= Visual_ORDER_Left}', "");
    Expect(0, 43709, '\P{^Is_InPC= Visual_ORDER_Left}', "");
    Error('\p{indicsyllabiccategory}');
    Error('\P{indicsyllabiccategory}');
    Error('\p{insc}');
    Error('\P{insc}');
    Error('\p{Indic_Syllabic_Category= /a/Avagraha}');
    Error('\P{Indic_Syllabic_Category= /a/Avagraha}');
    Expect(1, 72768, '\p{Indic_Syllabic_Category=:\AAvagraha\z:}', "");;
    Expect(0, 72769, '\p{Indic_Syllabic_Category=:\AAvagraha\z:}', "");;
    Expect(1, 72768, '\p{Indic_Syllabic_Category=avagraha}', "");
    Expect(0, 72768, '\p{^Indic_Syllabic_Category=avagraha}', "");
    Expect(0, 72768, '\P{Indic_Syllabic_Category=avagraha}', "");
    Expect(1, 72768, '\P{^Indic_Syllabic_Category=avagraha}', "");
    Expect(0, 72769, '\p{Indic_Syllabic_Category=avagraha}', "");
    Expect(1, 72769, '\p{^Indic_Syllabic_Category=avagraha}', "");
    Expect(1, 72769, '\P{Indic_Syllabic_Category=avagraha}', "");
    Expect(0, 72769, '\P{^Indic_Syllabic_Category=avagraha}', "");
    Expect(1, 72768, '\p{Indic_Syllabic_Category=:\Aavagraha\z:}', "");;
    Expect(0, 72769, '\p{Indic_Syllabic_Category=:\Aavagraha\z:}', "");;
    Expect(1, 72768, '\p{Indic_Syllabic_Category=	 Avagraha}', "");
    Expect(0, 72768, '\p{^Indic_Syllabic_Category=	 Avagraha}', "");
    Expect(0, 72768, '\P{Indic_Syllabic_Category=	 Avagraha}', "");
    Expect(1, 72768, '\P{^Indic_Syllabic_Category=	 Avagraha}', "");
    Expect(0, 72769, '\p{Indic_Syllabic_Category=	 Avagraha}', "");
    Expect(1, 72769, '\p{^Indic_Syllabic_Category=	 Avagraha}', "");
    Expect(1, 72769, '\P{Indic_Syllabic_Category=	 Avagraha}', "");
    Expect(0, 72769, '\P{^Indic_Syllabic_Category=	 Avagraha}', "");
    Error('\p{InSC=/a/ AVAGRAHA}');
    Error('\P{InSC=/a/ AVAGRAHA}');
    Expect(1, 72768, '\p{InSC=:\AAvagraha\z:}', "");;
    Expect(0, 72769, '\p{InSC=:\AAvagraha\z:}', "");;
    Expect(1, 72768, '\p{InSC=avagraha}', "");
    Expect(0, 72768, '\p{^InSC=avagraha}', "");
    Expect(0, 72768, '\P{InSC=avagraha}', "");
    Expect(1, 72768, '\P{^InSC=avagraha}', "");
    Expect(0, 72769, '\p{InSC=avagraha}', "");
    Expect(1, 72769, '\p{^InSC=avagraha}', "");
    Expect(1, 72769, '\P{InSC=avagraha}', "");
    Expect(0, 72769, '\P{^InSC=avagraha}', "");
    Expect(1, 72768, '\p{InSC=:\Aavagraha\z:}', "");;
    Expect(0, 72769, '\p{InSC=:\Aavagraha\z:}', "");;
    Expect(1, 72768, '\p{InSC= Avagraha}', "");
    Expect(0, 72768, '\p{^InSC= Avagraha}', "");
    Expect(0, 72768, '\P{InSC= Avagraha}', "");
    Expect(1, 72768, '\P{^InSC= Avagraha}', "");
    Expect(0, 72769, '\p{InSC= Avagraha}', "");
    Expect(1, 72769, '\p{^InSC= Avagraha}', "");
    Expect(1, 72769, '\P{InSC= Avagraha}', "");
    Expect(0, 72769, '\P{^InSC= Avagraha}', "");
    Error('\p{Is_Indic_Syllabic_Category=:=__avagraha}');
    Error('\P{Is_Indic_Syllabic_Category=:=__avagraha}');
    Expect(1, 72768, '\p{Is_Indic_Syllabic_Category=avagraha}', "");
    Expect(0, 72768, '\p{^Is_Indic_Syllabic_Category=avagraha}', "");
    Expect(0, 72768, '\P{Is_Indic_Syllabic_Category=avagraha}', "");
    Expect(1, 72768, '\P{^Is_Indic_Syllabic_Category=avagraha}', "");
    Expect(0, 72769, '\p{Is_Indic_Syllabic_Category=avagraha}', "");
    Expect(1, 72769, '\p{^Is_Indic_Syllabic_Category=avagraha}', "");
    Expect(1, 72769, '\P{Is_Indic_Syllabic_Category=avagraha}', "");
    Expect(0, 72769, '\P{^Is_Indic_Syllabic_Category=avagraha}', "");
    Expect(1, 72768, '\p{Is_Indic_Syllabic_Category= 	avagraha}', "");
    Expect(0, 72768, '\p{^Is_Indic_Syllabic_Category= 	avagraha}', "");
    Expect(0, 72768, '\P{Is_Indic_Syllabic_Category= 	avagraha}', "");
    Expect(1, 72768, '\P{^Is_Indic_Syllabic_Category= 	avagraha}', "");
    Expect(0, 72769, '\p{Is_Indic_Syllabic_Category= 	avagraha}', "");
    Expect(1, 72769, '\p{^Is_Indic_Syllabic_Category= 	avagraha}', "");
    Expect(1, 72769, '\P{Is_Indic_Syllabic_Category= 	avagraha}', "");
    Expect(0, 72769, '\P{^Is_Indic_Syllabic_Category= 	avagraha}', "");
    Error('\p{Is_InSC=_:=Avagraha}');
    Error('\P{Is_InSC=_:=Avagraha}');
    Expect(1, 72768, '\p{Is_InSC=avagraha}', "");
    Expect(0, 72768, '\p{^Is_InSC=avagraha}', "");
    Expect(0, 72768, '\P{Is_InSC=avagraha}', "");
    Expect(1, 72768, '\P{^Is_InSC=avagraha}', "");
    Expect(0, 72769, '\p{Is_InSC=avagraha}', "");
    Expect(1, 72769, '\p{^Is_InSC=avagraha}', "");
    Expect(1, 72769, '\P{Is_InSC=avagraha}', "");
    Expect(0, 72769, '\P{^Is_InSC=avagraha}', "");
    Expect(1, 72768, '\p{Is_InSC= 	Avagraha}', "");
    Expect(0, 72768, '\p{^Is_InSC= 	Avagraha}', "");
    Expect(0, 72768, '\P{Is_InSC= 	Avagraha}', "");
    Expect(1, 72768, '\P{^Is_InSC= 	Avagraha}', "");
    Expect(0, 72769, '\p{Is_InSC= 	Avagraha}', "");
    Expect(1, 72769, '\p{^Is_InSC= 	Avagraha}', "");
    Expect(1, 72769, '\P{Is_InSC= 	Avagraha}', "");
    Expect(0, 72769, '\P{^Is_InSC= 	Avagraha}', "");
    Error('\p{Indic_Syllabic_Category=	/a/Bindu}');
    Error('\P{Indic_Syllabic_Category=	/a/Bindu}');
    Expect(1, 73109, '\p{Indic_Syllabic_Category=:\ABindu\z:}', "");;
    Expect(0, 73110, '\p{Indic_Syllabic_Category=:\ABindu\z:}', "");;
    Expect(1, 73109, '\p{Indic_Syllabic_Category=bindu}', "");
    Expect(0, 73109, '\p{^Indic_Syllabic_Category=bindu}', "");
    Expect(0, 73109, '\P{Indic_Syllabic_Category=bindu}', "");
    Expect(1, 73109, '\P{^Indic_Syllabic_Category=bindu}', "");
    Expect(0, 73110, '\p{Indic_Syllabic_Category=bindu}', "");
    Expect(1, 73110, '\p{^Indic_Syllabic_Category=bindu}', "");
    Expect(1, 73110, '\P{Indic_Syllabic_Category=bindu}', "");
    Expect(0, 73110, '\P{^Indic_Syllabic_Category=bindu}', "");
    Expect(1, 73109, '\p{Indic_Syllabic_Category=:\Abindu\z:}', "");;
    Expect(0, 73110, '\p{Indic_Syllabic_Category=:\Abindu\z:}', "");;
    Expect(1, 73109, '\p{Indic_Syllabic_Category=-	BINDU}', "");
    Expect(0, 73109, '\p{^Indic_Syllabic_Category=-	BINDU}', "");
    Expect(0, 73109, '\P{Indic_Syllabic_Category=-	BINDU}', "");
    Expect(1, 73109, '\P{^Indic_Syllabic_Category=-	BINDU}', "");
    Expect(0, 73110, '\p{Indic_Syllabic_Category=-	BINDU}', "");
    Expect(1, 73110, '\p{^Indic_Syllabic_Category=-	BINDU}', "");
    Expect(1, 73110, '\P{Indic_Syllabic_Category=-	BINDU}', "");
    Expect(0, 73110, '\P{^Indic_Syllabic_Category=-	BINDU}', "");
    Error('\p{InSC=-:=bindu}');
    Error('\P{InSC=-:=bindu}');
    Expect(1, 73109, '\p{InSC=:\ABindu\z:}', "");;
    Expect(0, 73110, '\p{InSC=:\ABindu\z:}', "");;
    Expect(1, 73109, '\p{InSC=bindu}', "");
    Expect(0, 73109, '\p{^InSC=bindu}', "");
    Expect(0, 73109, '\P{InSC=bindu}', "");
    Expect(1, 73109, '\P{^InSC=bindu}', "");
    Expect(0, 73110, '\p{InSC=bindu}', "");
    Expect(1, 73110, '\p{^InSC=bindu}', "");
    Expect(1, 73110, '\P{InSC=bindu}', "");
    Expect(0, 73110, '\P{^InSC=bindu}', "");
    Expect(1, 73109, '\p{InSC=:\Abindu\z:}', "");;
    Expect(0, 73110, '\p{InSC=:\Abindu\z:}', "");;
    Expect(1, 73109, '\p{InSC= Bindu}', "");
    Expect(0, 73109, '\p{^InSC= Bindu}', "");
    Expect(0, 73109, '\P{InSC= Bindu}', "");
    Expect(1, 73109, '\P{^InSC= Bindu}', "");
    Expect(0, 73110, '\p{InSC= Bindu}', "");
    Expect(1, 73110, '\p{^InSC= Bindu}', "");
    Expect(1, 73110, '\P{InSC= Bindu}', "");
    Expect(0, 73110, '\P{^InSC= Bindu}', "");
    Error('\p{Is_Indic_Syllabic_Category=/a/	_bindu}');
    Error('\P{Is_Indic_Syllabic_Category=/a/	_bindu}');
    Expect(1, 73109, '\p{Is_Indic_Syllabic_Category=bindu}', "");
    Expect(0, 73109, '\p{^Is_Indic_Syllabic_Category=bindu}', "");
    Expect(0, 73109, '\P{Is_Indic_Syllabic_Category=bindu}', "");
    Expect(1, 73109, '\P{^Is_Indic_Syllabic_Category=bindu}', "");
    Expect(0, 73110, '\p{Is_Indic_Syllabic_Category=bindu}', "");
    Expect(1, 73110, '\p{^Is_Indic_Syllabic_Category=bindu}', "");
    Expect(1, 73110, '\P{Is_Indic_Syllabic_Category=bindu}', "");
    Expect(0, 73110, '\P{^Is_Indic_Syllabic_Category=bindu}', "");
    Expect(1, 73109, '\p{Is_Indic_Syllabic_Category=		BINDU}', "");
    Expect(0, 73109, '\p{^Is_Indic_Syllabic_Category=		BINDU}', "");
    Expect(0, 73109, '\P{Is_Indic_Syllabic_Category=		BINDU}', "");
    Expect(1, 73109, '\P{^Is_Indic_Syllabic_Category=		BINDU}', "");
    Expect(0, 73110, '\p{Is_Indic_Syllabic_Category=		BINDU}', "");
    Expect(1, 73110, '\p{^Is_Indic_Syllabic_Category=		BINDU}', "");
    Expect(1, 73110, '\P{Is_Indic_Syllabic_Category=		BINDU}', "");
    Expect(0, 73110, '\P{^Is_Indic_Syllabic_Category=		BINDU}', "");
    Error('\p{Is_InSC:-:=Bindu}');
    Error('\P{Is_InSC:-:=Bindu}');
    Expect(1, 73109, '\p{Is_InSC=bindu}', "");
    Expect(0, 73109, '\p{^Is_InSC=bindu}', "");
    Expect(0, 73109, '\P{Is_InSC=bindu}', "");
    Expect(1, 73109, '\P{^Is_InSC=bindu}', "");
    Expect(0, 73110, '\p{Is_InSC=bindu}', "");
    Expect(1, 73110, '\p{^Is_InSC=bindu}', "");
    Expect(1, 73110, '\P{Is_InSC=bindu}', "");
    Expect(0, 73110, '\P{^Is_InSC=bindu}', "");
    Expect(1, 73109, '\p{Is_InSC=	-Bindu}', "");
    Expect(0, 73109, '\p{^Is_InSC=	-Bindu}', "");
    Expect(0, 73109, '\P{Is_InSC=	-Bindu}', "");
    Expect(1, 73109, '\P{^Is_InSC=	-Bindu}', "");
    Expect(0, 73110, '\p{Is_InSC=	-Bindu}', "");
    Expect(1, 73110, '\p{^Is_InSC=	-Bindu}', "");
    Expect(1, 73110, '\P{Is_InSC=	-Bindu}', "");
    Expect(0, 73110, '\P{^Is_InSC=	-Bindu}', "");
    Error('\p{Indic_Syllabic_Category=-_brahmi_Joining_Number/a/}');
    Error('\P{Indic_Syllabic_Category=-_brahmi_Joining_Number/a/}');
    Expect(1, 69733, '\p{Indic_Syllabic_Category=:\ABrahmi_Joining_Number\z:}', "");;
    Expect(0, 69734, '\p{Indic_Syllabic_Category=:\ABrahmi_Joining_Number\z:}', "");;
    Expect(1, 69733, '\p{Indic_Syllabic_Category=brahmijoiningnumber}', "");
    Expect(0, 69733, '\p{^Indic_Syllabic_Category=brahmijoiningnumber}', "");
    Expect(0, 69733, '\P{Indic_Syllabic_Category=brahmijoiningnumber}', "");
    Expect(1, 69733, '\P{^Indic_Syllabic_Category=brahmijoiningnumber}', "");
    Expect(0, 69734, '\p{Indic_Syllabic_Category=brahmijoiningnumber}', "");
    Expect(1, 69734, '\p{^Indic_Syllabic_Category=brahmijoiningnumber}', "");
    Expect(1, 69734, '\P{Indic_Syllabic_Category=brahmijoiningnumber}', "");
    Expect(0, 69734, '\P{^Indic_Syllabic_Category=brahmijoiningnumber}', "");
    Expect(1, 69733, '\p{Indic_Syllabic_Category=:\Abrahmijoiningnumber\z:}', "");;
    Expect(0, 69734, '\p{Indic_Syllabic_Category=:\Abrahmijoiningnumber\z:}', "");;
    Expect(1, 69733, '\p{Indic_Syllabic_Category=-BRAHMI_joining_number}', "");
    Expect(0, 69733, '\p{^Indic_Syllabic_Category=-BRAHMI_joining_number}', "");
    Expect(0, 69733, '\P{Indic_Syllabic_Category=-BRAHMI_joining_number}', "");
    Expect(1, 69733, '\P{^Indic_Syllabic_Category=-BRAHMI_joining_number}', "");
    Expect(0, 69734, '\p{Indic_Syllabic_Category=-BRAHMI_joining_number}', "");
    Expect(1, 69734, '\p{^Indic_Syllabic_Category=-BRAHMI_joining_number}', "");
    Expect(1, 69734, '\P{Indic_Syllabic_Category=-BRAHMI_joining_number}', "");
    Expect(0, 69734, '\P{^Indic_Syllabic_Category=-BRAHMI_joining_number}', "");
    Error('\p{InSC=_	BRAHMI_Joining_number:=}');
    Error('\P{InSC=_	BRAHMI_Joining_number:=}');
    Expect(1, 69733, '\p{InSC=:\ABrahmi_Joining_Number\z:}', "");;
    Expect(0, 69734, '\p{InSC=:\ABrahmi_Joining_Number\z:}', "");;
    Expect(1, 69733, '\p{InSC=brahmijoiningnumber}', "");
    Expect(0, 69733, '\p{^InSC=brahmijoiningnumber}', "");
    Expect(0, 69733, '\P{InSC=brahmijoiningnumber}', "");
    Expect(1, 69733, '\P{^InSC=brahmijoiningnumber}', "");
    Expect(0, 69734, '\p{InSC=brahmijoiningnumber}', "");
    Expect(1, 69734, '\p{^InSC=brahmijoiningnumber}', "");
    Expect(1, 69734, '\P{InSC=brahmijoiningnumber}', "");
    Expect(0, 69734, '\P{^InSC=brahmijoiningnumber}', "");
    Expect(1, 69733, '\p{InSC=:\Abrahmijoiningnumber\z:}', "");;
    Expect(0, 69734, '\p{InSC=:\Abrahmijoiningnumber\z:}', "");;
    Expect(1, 69733, '\p{InSC=	 BRAHMI_Joining_number}', "");
    Expect(0, 69733, '\p{^InSC=	 BRAHMI_Joining_number}', "");
    Expect(0, 69733, '\P{InSC=	 BRAHMI_Joining_number}', "");
    Expect(1, 69733, '\P{^InSC=	 BRAHMI_Joining_number}', "");
    Expect(0, 69734, '\p{InSC=	 BRAHMI_Joining_number}', "");
    Expect(1, 69734, '\p{^InSC=	 BRAHMI_Joining_number}', "");
    Expect(1, 69734, '\P{InSC=	 BRAHMI_Joining_number}', "");
    Expect(0, 69734, '\P{^InSC=	 BRAHMI_Joining_number}', "");
    Error('\p{Is_Indic_Syllabic_Category:   _Brahmi_JOINING_Number/a/}');
    Error('\P{Is_Indic_Syllabic_Category:   _Brahmi_JOINING_Number/a/}');
    Expect(1, 69733, '\p{Is_Indic_Syllabic_Category=brahmijoiningnumber}', "");
    Expect(0, 69733, '\p{^Is_Indic_Syllabic_Category=brahmijoiningnumber}', "");
    Expect(0, 69733, '\P{Is_Indic_Syllabic_Category=brahmijoiningnumber}', "");
    Expect(1, 69733, '\P{^Is_Indic_Syllabic_Category=brahmijoiningnumber}', "");
    Expect(0, 69734, '\p{Is_Indic_Syllabic_Category=brahmijoiningnumber}', "");
    Expect(1, 69734, '\p{^Is_Indic_Syllabic_Category=brahmijoiningnumber}', "");
    Expect(1, 69734, '\P{Is_Indic_Syllabic_Category=brahmijoiningnumber}', "");
    Expect(0, 69734, '\P{^Is_Indic_Syllabic_Category=brahmijoiningnumber}', "");
    Expect(1, 69733, '\p{Is_Indic_Syllabic_Category=_Brahmi_Joining_number}', "");
    Expect(0, 69733, '\p{^Is_Indic_Syllabic_Category=_Brahmi_Joining_number}', "");
    Expect(0, 69733, '\P{Is_Indic_Syllabic_Category=_Brahmi_Joining_number}', "");
    Expect(1, 69733, '\P{^Is_Indic_Syllabic_Category=_Brahmi_Joining_number}', "");
    Expect(0, 69734, '\p{Is_Indic_Syllabic_Category=_Brahmi_Joining_number}', "");
    Expect(1, 69734, '\p{^Is_Indic_Syllabic_Category=_Brahmi_Joining_number}', "");
    Expect(1, 69734, '\P{Is_Indic_Syllabic_Category=_Brahmi_Joining_number}', "");
    Expect(0, 69734, '\P{^Is_Indic_Syllabic_Category=_Brahmi_Joining_number}', "");
    Error('\p{Is_InSC=:=brahmi_Joining_Number}');
    Error('\P{Is_InSC=:=brahmi_Joining_Number}');
    Expect(1, 69733, '\p{Is_InSC=brahmijoiningnumber}', "");
    Expect(0, 69733, '\p{^Is_InSC=brahmijoiningnumber}', "");
    Expect(0, 69733, '\P{Is_InSC=brahmijoiningnumber}', "");
    Expect(1, 69733, '\P{^Is_InSC=brahmijoiningnumber}', "");
    Expect(0, 69734, '\p{Is_InSC=brahmijoiningnumber}', "");
    Expect(1, 69734, '\p{^Is_InSC=brahmijoiningnumber}', "");
    Expect(1, 69734, '\P{Is_InSC=brahmijoiningnumber}', "");
    Expect(0, 69734, '\P{^Is_InSC=brahmijoiningnumber}', "");
    Expect(1, 69733, '\p{Is_InSC=	_brahmi_JOINING_Number}', "");
    Expect(0, 69733, '\p{^Is_InSC=	_brahmi_JOINING_Number}', "");
    Expect(0, 69733, '\P{Is_InSC=	_brahmi_JOINING_Number}', "");
    Expect(1, 69733, '\P{^Is_InSC=	_brahmi_JOINING_Number}', "");
    Expect(0, 69734, '\p{Is_InSC=	_brahmi_JOINING_Number}', "");
    Expect(1, 69734, '\p{^Is_InSC=	_brahmi_JOINING_Number}', "");
    Expect(1, 69734, '\P{Is_InSC=	_brahmi_JOINING_Number}', "");
    Expect(0, 69734, '\P{^Is_InSC=	_brahmi_JOINING_Number}', "");
    Error('\p{Indic_Syllabic_Category::= CANTILLATION_Mark}');
    Error('\P{Indic_Syllabic_Category::= CANTILLATION_Mark}');
    Expect(1, 70516, '\p{Indic_Syllabic_Category=:\ACantillation_Mark\z:}', "");;
    Expect(0, 70517, '\p{Indic_Syllabic_Category=:\ACantillation_Mark\z:}', "");;
    Expect(1, 70516, '\p{Indic_Syllabic_Category=cantillationmark}', "");
    Expect(0, 70516, '\p{^Indic_Syllabic_Category=cantillationmark}', "");
    Expect(0, 70516, '\P{Indic_Syllabic_Category=cantillationmark}', "");
    Expect(1, 70516, '\P{^Indic_Syllabic_Category=cantillationmark}', "");
    Expect(0, 70517, '\p{Indic_Syllabic_Category=cantillationmark}', "");
    Expect(1, 70517, '\p{^Indic_Syllabic_Category=cantillationmark}', "");
    Expect(1, 70517, '\P{Indic_Syllabic_Category=cantillationmark}', "");
    Expect(0, 70517, '\P{^Indic_Syllabic_Category=cantillationmark}', "");
    Expect(1, 70516, '\p{Indic_Syllabic_Category=:\Acantillationmark\z:}', "");;
    Expect(0, 70517, '\p{Indic_Syllabic_Category=:\Acantillationmark\z:}', "");;
    Expect(1, 70516, '\p{Indic_Syllabic_Category=	Cantillation_Mark}', "");
    Expect(0, 70516, '\p{^Indic_Syllabic_Category=	Cantillation_Mark}', "");
    Expect(0, 70516, '\P{Indic_Syllabic_Category=	Cantillation_Mark}', "");
    Expect(1, 70516, '\P{^Indic_Syllabic_Category=	Cantillation_Mark}', "");
    Expect(0, 70517, '\p{Indic_Syllabic_Category=	Cantillation_Mark}', "");
    Expect(1, 70517, '\p{^Indic_Syllabic_Category=	Cantillation_Mark}', "");
    Expect(1, 70517, '\P{Indic_Syllabic_Category=	Cantillation_Mark}', "");
    Expect(0, 70517, '\P{^Indic_Syllabic_Category=	Cantillation_Mark}', "");
    Error('\p{InSC=/a/-Cantillation_mark}');
    Error('\P{InSC=/a/-Cantillation_mark}');
    Expect(1, 70516, '\p{InSC=:\ACantillation_Mark\z:}', "");;
    Expect(0, 70517, '\p{InSC=:\ACantillation_Mark\z:}', "");;
    Expect(1, 70516, '\p{InSC=cantillationmark}', "");
    Expect(0, 70516, '\p{^InSC=cantillationmark}', "");
    Expect(0, 70516, '\P{InSC=cantillationmark}', "");
    Expect(1, 70516, '\P{^InSC=cantillationmark}', "");
    Expect(0, 70517, '\p{InSC=cantillationmark}', "");
    Expect(1, 70517, '\p{^InSC=cantillationmark}', "");
    Expect(1, 70517, '\P{InSC=cantillationmark}', "");
    Expect(0, 70517, '\P{^InSC=cantillationmark}', "");
    Expect(1, 70516, '\p{InSC=:\Acantillationmark\z:}', "");;
    Expect(0, 70517, '\p{InSC=:\Acantillationmark\z:}', "");;
    Expect(1, 70516, '\p{InSC=	CANTILLATION_mark}', "");
    Expect(0, 70516, '\p{^InSC=	CANTILLATION_mark}', "");
    Expect(0, 70516, '\P{InSC=	CANTILLATION_mark}', "");
    Expect(1, 70516, '\P{^InSC=	CANTILLATION_mark}', "");
    Expect(0, 70517, '\p{InSC=	CANTILLATION_mark}', "");
    Expect(1, 70517, '\p{^InSC=	CANTILLATION_mark}', "");
    Expect(1, 70517, '\P{InSC=	CANTILLATION_mark}', "");
    Expect(0, 70517, '\P{^InSC=	CANTILLATION_mark}', "");
    Error('\p{Is_Indic_Syllabic_Category=/a/CANTILLATION_Mark}');
    Error('\P{Is_Indic_Syllabic_Category=/a/CANTILLATION_Mark}');
    Expect(1, 70516, '\p{Is_Indic_Syllabic_Category=cantillationmark}', "");
    Expect(0, 70516, '\p{^Is_Indic_Syllabic_Category=cantillationmark}', "");
    Expect(0, 70516, '\P{Is_Indic_Syllabic_Category=cantillationmark}', "");
    Expect(1, 70516, '\P{^Is_Indic_Syllabic_Category=cantillationmark}', "");
    Expect(0, 70517, '\p{Is_Indic_Syllabic_Category=cantillationmark}', "");
    Expect(1, 70517, '\p{^Is_Indic_Syllabic_Category=cantillationmark}', "");
    Expect(1, 70517, '\P{Is_Indic_Syllabic_Category=cantillationmark}', "");
    Expect(0, 70517, '\P{^Is_Indic_Syllabic_Category=cantillationmark}', "");
    Expect(1, 70516, '\p{Is_Indic_Syllabic_Category=- Cantillation_Mark}', "");
    Expect(0, 70516, '\p{^Is_Indic_Syllabic_Category=- Cantillation_Mark}', "");
    Expect(0, 70516, '\P{Is_Indic_Syllabic_Category=- Cantillation_Mark}', "");
    Expect(1, 70516, '\P{^Is_Indic_Syllabic_Category=- Cantillation_Mark}', "");
    Expect(0, 70517, '\p{Is_Indic_Syllabic_Category=- Cantillation_Mark}', "");
    Expect(1, 70517, '\p{^Is_Indic_Syllabic_Category=- Cantillation_Mark}', "");
    Expect(1, 70517, '\P{Is_Indic_Syllabic_Category=- Cantillation_Mark}', "");
    Expect(0, 70517, '\P{^Is_Indic_Syllabic_Category=- Cantillation_Mark}', "");
    Error('\p{Is_InSC=:=--Cantillation_mark}');
    Error('\P{Is_InSC=:=--Cantillation_mark}');
    Expect(1, 70516, '\p{Is_InSC=cantillationmark}', "");
    Expect(0, 70516, '\p{^Is_InSC=cantillationmark}', "");
    Expect(0, 70516, '\P{Is_InSC=cantillationmark}', "");
    Expect(1, 70516, '\P{^Is_InSC=cantillationmark}', "");
    Expect(0, 70517, '\p{Is_InSC=cantillationmark}', "");
    Expect(1, 70517, '\p{^Is_InSC=cantillationmark}', "");
    Expect(1, 70517, '\P{Is_InSC=cantillationmark}', "");
    Expect(0, 70517, '\P{^Is_InSC=cantillationmark}', "");
    Expect(1, 70516, '\p{Is_InSC=--Cantillation_Mark}', "");
    Expect(0, 70516, '\p{^Is_InSC=--Cantillation_Mark}', "");
    Expect(0, 70516, '\P{Is_InSC=--Cantillation_Mark}', "");
    Expect(1, 70516, '\P{^Is_InSC=--Cantillation_Mark}', "");
    Expect(0, 70517, '\p{Is_InSC=--Cantillation_Mark}', "");
    Expect(1, 70517, '\p{^Is_InSC=--Cantillation_Mark}', "");
    Expect(1, 70517, '\P{Is_InSC=--Cantillation_Mark}', "");
    Expect(0, 70517, '\P{^Is_InSC=--Cantillation_Mark}', "");
    Error('\p{Indic_Syllabic_Category= CONSONANT:=}');
    Error('\P{Indic_Syllabic_Category= CONSONANT:=}');
    Expect(1, 73457, '\p{Indic_Syllabic_Category=:\AConsonant\z:}', "");;
    Expect(0, 73458, '\p{Indic_Syllabic_Category=:\AConsonant\z:}', "");;
    Expect(1, 73457, '\p{Indic_Syllabic_Category=consonant}', "");
    Expect(0, 73457, '\p{^Indic_Syllabic_Category=consonant}', "");
    Expect(0, 73457, '\P{Indic_Syllabic_Category=consonant}', "");
    Expect(1, 73457, '\P{^Indic_Syllabic_Category=consonant}', "");
    Expect(0, 73458, '\p{Indic_Syllabic_Category=consonant}', "");
    Expect(1, 73458, '\p{^Indic_Syllabic_Category=consonant}', "");
    Expect(1, 73458, '\P{Indic_Syllabic_Category=consonant}', "");
    Expect(0, 73458, '\P{^Indic_Syllabic_Category=consonant}', "");
    Expect(1, 73457, '\p{Indic_Syllabic_Category=:\Aconsonant\z:}', "");;
    Expect(0, 73458, '\p{Indic_Syllabic_Category=:\Aconsonant\z:}', "");;
    Expect(1, 73457, '\p{Indic_Syllabic_Category=  CONSONANT}', "");
    Expect(0, 73457, '\p{^Indic_Syllabic_Category=  CONSONANT}', "");
    Expect(0, 73457, '\P{Indic_Syllabic_Category=  CONSONANT}', "");
    Expect(1, 73457, '\P{^Indic_Syllabic_Category=  CONSONANT}', "");
    Expect(0, 73458, '\p{Indic_Syllabic_Category=  CONSONANT}', "");
    Expect(1, 73458, '\p{^Indic_Syllabic_Category=  CONSONANT}', "");
    Expect(1, 73458, '\P{Indic_Syllabic_Category=  CONSONANT}', "");
    Expect(0, 73458, '\P{^Indic_Syllabic_Category=  CONSONANT}', "");
    Error('\p{InSC=:=Consonant}');
    Error('\P{InSC=:=Consonant}');
    Expect(1, 73457, '\p{InSC=:\AConsonant\z:}', "");;
    Expect(0, 73458, '\p{InSC=:\AConsonant\z:}', "");;
    Expect(1, 73457, '\p{InSC=consonant}', "");
    Expect(0, 73457, '\p{^InSC=consonant}', "");
    Expect(0, 73457, '\P{InSC=consonant}', "");
    Expect(1, 73457, '\P{^InSC=consonant}', "");
    Expect(0, 73458, '\p{InSC=consonant}', "");
    Expect(1, 73458, '\p{^InSC=consonant}', "");
    Expect(1, 73458, '\P{InSC=consonant}', "");
    Expect(0, 73458, '\P{^InSC=consonant}', "");
    Expect(1, 73457, '\p{InSC=:\Aconsonant\z:}', "");;
    Expect(0, 73458, '\p{InSC=:\Aconsonant\z:}', "");;
    Expect(1, 73457, '\p{InSC= _consonant}', "");
    Expect(0, 73457, '\p{^InSC= _consonant}', "");
    Expect(0, 73457, '\P{InSC= _consonant}', "");
    Expect(1, 73457, '\P{^InSC= _consonant}', "");
    Expect(0, 73458, '\p{InSC= _consonant}', "");
    Expect(1, 73458, '\p{^InSC= _consonant}', "");
    Expect(1, 73458, '\P{InSC= _consonant}', "");
    Expect(0, 73458, '\P{^InSC= _consonant}', "");
    Error('\p{Is_Indic_Syllabic_Category:    :=CONSONANT}');
    Error('\P{Is_Indic_Syllabic_Category:    :=CONSONANT}');
    Expect(1, 73457, '\p{Is_Indic_Syllabic_Category=consonant}', "");
    Expect(0, 73457, '\p{^Is_Indic_Syllabic_Category=consonant}', "");
    Expect(0, 73457, '\P{Is_Indic_Syllabic_Category=consonant}', "");
    Expect(1, 73457, '\P{^Is_Indic_Syllabic_Category=consonant}', "");
    Expect(0, 73458, '\p{Is_Indic_Syllabic_Category=consonant}', "");
    Expect(1, 73458, '\p{^Is_Indic_Syllabic_Category=consonant}', "");
    Expect(1, 73458, '\P{Is_Indic_Syllabic_Category=consonant}', "");
    Expect(0, 73458, '\P{^Is_Indic_Syllabic_Category=consonant}', "");
    Expect(1, 73457, '\p{Is_Indic_Syllabic_Category:	-	Consonant}', "");
    Expect(0, 73457, '\p{^Is_Indic_Syllabic_Category:	-	Consonant}', "");
    Expect(0, 73457, '\P{Is_Indic_Syllabic_Category:	-	Consonant}', "");
    Expect(1, 73457, '\P{^Is_Indic_Syllabic_Category:	-	Consonant}', "");
    Expect(0, 73458, '\p{Is_Indic_Syllabic_Category:	-	Consonant}', "");
    Expect(1, 73458, '\p{^Is_Indic_Syllabic_Category:	-	Consonant}', "");
    Expect(1, 73458, '\P{Is_Indic_Syllabic_Category:	-	Consonant}', "");
    Expect(0, 73458, '\P{^Is_Indic_Syllabic_Category:	-	Consonant}', "");
    Error('\p{Is_InSC=	_Consonant/a/}');
    Error('\P{Is_InSC=	_Consonant/a/}');
    Expect(1, 73457, '\p{Is_InSC=consonant}', "");
    Expect(0, 73457, '\p{^Is_InSC=consonant}', "");
    Expect(0, 73457, '\P{Is_InSC=consonant}', "");
    Expect(1, 73457, '\P{^Is_InSC=consonant}', "");
    Expect(0, 73458, '\p{Is_InSC=consonant}', "");
    Expect(1, 73458, '\p{^Is_InSC=consonant}', "");
    Expect(1, 73458, '\P{Is_InSC=consonant}', "");
    Expect(0, 73458, '\P{^Is_InSC=consonant}', "");
    Expect(1, 73457, '\p{Is_InSC= consonant}', "");
    Expect(0, 73457, '\p{^Is_InSC= consonant}', "");
    Expect(0, 73457, '\P{Is_InSC= consonant}', "");
    Expect(1, 73457, '\P{^Is_InSC= consonant}', "");
    Expect(0, 73458, '\p{Is_InSC= consonant}', "");
    Expect(1, 73458, '\p{^Is_InSC= consonant}', "");
    Expect(1, 73458, '\P{Is_InSC= consonant}', "");
    Expect(0, 73458, '\P{^Is_InSC= consonant}', "");
    Error('\p{Indic_Syllabic_Category=-:=Consonant_dead}');
    Error('\P{Indic_Syllabic_Category=-:=Consonant_dead}');
    Expect(1, 7411, '\p{Indic_Syllabic_Category=:\AConsonant_Dead\z:}', "");;
    Expect(0, 7412, '\p{Indic_Syllabic_Category=:\AConsonant_Dead\z:}', "");;
    Expect(1, 7411, '\p{Indic_Syllabic_Category=consonantdead}', "");
    Expect(0, 7411, '\p{^Indic_Syllabic_Category=consonantdead}', "");
    Expect(0, 7411, '\P{Indic_Syllabic_Category=consonantdead}', "");
    Expect(1, 7411, '\P{^Indic_Syllabic_Category=consonantdead}', "");
    Expect(0, 7412, '\p{Indic_Syllabic_Category=consonantdead}', "");
    Expect(1, 7412, '\p{^Indic_Syllabic_Category=consonantdead}', "");
    Expect(1, 7412, '\P{Indic_Syllabic_Category=consonantdead}', "");
    Expect(0, 7412, '\P{^Indic_Syllabic_Category=consonantdead}', "");
    Expect(1, 7411, '\p{Indic_Syllabic_Category=:\Aconsonantdead\z:}', "");;
    Expect(0, 7412, '\p{Indic_Syllabic_Category=:\Aconsonantdead\z:}', "");;
    Expect(1, 7411, '\p{Indic_Syllabic_Category:   		consonant_DEAD}', "");
    Expect(0, 7411, '\p{^Indic_Syllabic_Category:   		consonant_DEAD}', "");
    Expect(0, 7411, '\P{Indic_Syllabic_Category:   		consonant_DEAD}', "");
    Expect(1, 7411, '\P{^Indic_Syllabic_Category:   		consonant_DEAD}', "");
    Expect(0, 7412, '\p{Indic_Syllabic_Category:   		consonant_DEAD}', "");
    Expect(1, 7412, '\p{^Indic_Syllabic_Category:   		consonant_DEAD}', "");
    Expect(1, 7412, '\P{Indic_Syllabic_Category:   		consonant_DEAD}', "");
    Expect(0, 7412, '\P{^Indic_Syllabic_Category:   		consonant_DEAD}', "");
    Error('\p{InSC=	/a/Consonant_Dead}');
    Error('\P{InSC=	/a/Consonant_Dead}');
    Expect(1, 7411, '\p{InSC=:\AConsonant_Dead\z:}', "");;
    Expect(0, 7412, '\p{InSC=:\AConsonant_Dead\z:}', "");;
    Expect(1, 7411, '\p{InSC=consonantdead}', "");
    Expect(0, 7411, '\p{^InSC=consonantdead}', "");
    Expect(0, 7411, '\P{InSC=consonantdead}', "");
    Expect(1, 7411, '\P{^InSC=consonantdead}', "");
    Expect(0, 7412, '\p{InSC=consonantdead}', "");
    Expect(1, 7412, '\p{^InSC=consonantdead}', "");
    Expect(1, 7412, '\P{InSC=consonantdead}', "");
    Expect(0, 7412, '\P{^InSC=consonantdead}', "");
    Expect(1, 7411, '\p{InSC=:\Aconsonantdead\z:}', "");;
    Expect(0, 7412, '\p{InSC=:\Aconsonantdead\z:}', "");;
    Expect(1, 7411, '\p{InSC= Consonant_DEAD}', "");
    Expect(0, 7411, '\p{^InSC= Consonant_DEAD}', "");
    Expect(0, 7411, '\P{InSC= Consonant_DEAD}', "");
    Expect(1, 7411, '\P{^InSC= Consonant_DEAD}', "");
    Expect(0, 7412, '\p{InSC= Consonant_DEAD}', "");
    Expect(1, 7412, '\p{^InSC= Consonant_DEAD}', "");
    Expect(1, 7412, '\P{InSC= Consonant_DEAD}', "");
    Expect(0, 7412, '\P{^InSC= Consonant_DEAD}', "");
    Error('\p{Is_Indic_Syllabic_Category: /a/__Consonant_Dead}');
    Error('\P{Is_Indic_Syllabic_Category: /a/__Consonant_Dead}');
    Expect(1, 7411, '\p{Is_Indic_Syllabic_Category=consonantdead}', "");
    Expect(0, 7411, '\p{^Is_Indic_Syllabic_Category=consonantdead}', "");
    Expect(0, 7411, '\P{Is_Indic_Syllabic_Category=consonantdead}', "");
    Expect(1, 7411, '\P{^Is_Indic_Syllabic_Category=consonantdead}', "");
    Expect(0, 7412, '\p{Is_Indic_Syllabic_Category=consonantdead}', "");
    Expect(1, 7412, '\p{^Is_Indic_Syllabic_Category=consonantdead}', "");
    Expect(1, 7412, '\P{Is_Indic_Syllabic_Category=consonantdead}', "");
    Expect(0, 7412, '\P{^Is_Indic_Syllabic_Category=consonantdead}', "");
    Expect(1, 7411, '\p{Is_Indic_Syllabic_Category=-_consonant_Dead}', "");
    Expect(0, 7411, '\p{^Is_Indic_Syllabic_Category=-_consonant_Dead}', "");
    Expect(0, 7411, '\P{Is_Indic_Syllabic_Category=-_consonant_Dead}', "");
    Expect(1, 7411, '\P{^Is_Indic_Syllabic_Category=-_consonant_Dead}', "");
    Expect(0, 7412, '\p{Is_Indic_Syllabic_Category=-_consonant_Dead}', "");
    Expect(1, 7412, '\p{^Is_Indic_Syllabic_Category=-_consonant_Dead}', "");
    Expect(1, 7412, '\P{Is_Indic_Syllabic_Category=-_consonant_Dead}', "");
    Expect(0, 7412, '\P{^Is_Indic_Syllabic_Category=-_consonant_Dead}', "");
    Error('\p{Is_InSC=-	Consonant_DEAD:=}');
    Error('\P{Is_InSC=-	Consonant_DEAD:=}');
    Expect(1, 7411, '\p{Is_InSC=consonantdead}', "");
    Expect(0, 7411, '\p{^Is_InSC=consonantdead}', "");
    Expect(0, 7411, '\P{Is_InSC=consonantdead}', "");
    Expect(1, 7411, '\P{^Is_InSC=consonantdead}', "");
    Expect(0, 7412, '\p{Is_InSC=consonantdead}', "");
    Expect(1, 7412, '\p{^Is_InSC=consonantdead}', "");
    Expect(1, 7412, '\P{Is_InSC=consonantdead}', "");
    Expect(0, 7412, '\P{^Is_InSC=consonantdead}', "");
    Expect(1, 7411, '\p{Is_InSC=_-Consonant_DEAD}', "");
    Expect(0, 7411, '\p{^Is_InSC=_-Consonant_DEAD}', "");
    Expect(0, 7411, '\P{Is_InSC=_-Consonant_DEAD}', "");
    Expect(1, 7411, '\P{^Is_InSC=_-Consonant_DEAD}', "");
    Expect(0, 7412, '\p{Is_InSC=_-Consonant_DEAD}', "");
    Expect(1, 7412, '\p{^Is_InSC=_-Consonant_DEAD}', "");
    Expect(1, 7412, '\P{Is_InSC=_-Consonant_DEAD}', "");
    Expect(0, 7412, '\P{^Is_InSC=_-Consonant_DEAD}', "");
    Error('\p{Indic_Syllabic_Category=_/a/CONSONANT_FINAL}');
    Error('\P{Indic_Syllabic_Category=_/a/CONSONANT_FINAL}');
    Expect(1, 72341, '\p{Indic_Syllabic_Category=:\AConsonant_Final\z:}', "");;
    Expect(0, 72342, '\p{Indic_Syllabic_Category=:\AConsonant_Final\z:}', "");;
    Expect(1, 72341, '\p{Indic_Syllabic_Category=consonantfinal}', "");
    Expect(0, 72341, '\p{^Indic_Syllabic_Category=consonantfinal}', "");
    Expect(0, 72341, '\P{Indic_Syllabic_Category=consonantfinal}', "");
    Expect(1, 72341, '\P{^Indic_Syllabic_Category=consonantfinal}', "");
    Expect(0, 72342, '\p{Indic_Syllabic_Category=consonantfinal}', "");
    Expect(1, 72342, '\p{^Indic_Syllabic_Category=consonantfinal}', "");
    Expect(1, 72342, '\P{Indic_Syllabic_Category=consonantfinal}', "");
    Expect(0, 72342, '\P{^Indic_Syllabic_Category=consonantfinal}', "");
    Expect(1, 72341, '\p{Indic_Syllabic_Category=:\Aconsonantfinal\z:}', "");;
    Expect(0, 72342, '\p{Indic_Syllabic_Category=:\Aconsonantfinal\z:}', "");;
    Expect(1, 72341, '\p{Indic_Syllabic_Category=	_Consonant_FINAL}', "");
    Expect(0, 72341, '\p{^Indic_Syllabic_Category=	_Consonant_FINAL}', "");
    Expect(0, 72341, '\P{Indic_Syllabic_Category=	_Consonant_FINAL}', "");
    Expect(1, 72341, '\P{^Indic_Syllabic_Category=	_Consonant_FINAL}', "");
    Expect(0, 72342, '\p{Indic_Syllabic_Category=	_Consonant_FINAL}', "");
    Expect(1, 72342, '\p{^Indic_Syllabic_Category=	_Consonant_FINAL}', "");
    Expect(1, 72342, '\P{Indic_Syllabic_Category=	_Consonant_FINAL}', "");
    Expect(0, 72342, '\P{^Indic_Syllabic_Category=	_Consonant_FINAL}', "");
    Error('\p{InSC=	:=Consonant_final}');
    Error('\P{InSC=	:=Consonant_final}');
    Expect(1, 72341, '\p{InSC=:\AConsonant_Final\z:}', "");;
    Expect(0, 72342, '\p{InSC=:\AConsonant_Final\z:}', "");;
    Expect(1, 72341, '\p{InSC=consonantfinal}', "");
    Expect(0, 72341, '\p{^InSC=consonantfinal}', "");
    Expect(0, 72341, '\P{InSC=consonantfinal}', "");
    Expect(1, 72341, '\P{^InSC=consonantfinal}', "");
    Expect(0, 72342, '\p{InSC=consonantfinal}', "");
    Expect(1, 72342, '\p{^InSC=consonantfinal}', "");
    Expect(1, 72342, '\P{InSC=consonantfinal}', "");
    Expect(0, 72342, '\P{^InSC=consonantfinal}', "");
    Expect(1, 72341, '\p{InSC=:\Aconsonantfinal\z:}', "");;
    Expect(0, 72342, '\p{InSC=:\Aconsonantfinal\z:}', "");;
    Expect(1, 72341, '\p{InSC=_-Consonant_Final}', "");
    Expect(0, 72341, '\p{^InSC=_-Consonant_Final}', "");
    Expect(0, 72341, '\P{InSC=_-Consonant_Final}', "");
    Expect(1, 72341, '\P{^InSC=_-Consonant_Final}', "");
    Expect(0, 72342, '\p{InSC=_-Consonant_Final}', "");
    Expect(1, 72342, '\p{^InSC=_-Consonant_Final}', "");
    Expect(1, 72342, '\P{InSC=_-Consonant_Final}', "");
    Expect(0, 72342, '\P{^InSC=_-Consonant_Final}', "");
    Error('\p{Is_Indic_Syllabic_Category=		Consonant_Final/a/}');
    Error('\P{Is_Indic_Syllabic_Category=		Consonant_Final/a/}');
    Expect(1, 72341, '\p{Is_Indic_Syllabic_Category=consonantfinal}', "");
    Expect(0, 72341, '\p{^Is_Indic_Syllabic_Category=consonantfinal}', "");
    Expect(0, 72341, '\P{Is_Indic_Syllabic_Category=consonantfinal}', "");
    Expect(1, 72341, '\P{^Is_Indic_Syllabic_Category=consonantfinal}', "");
    Expect(0, 72342, '\p{Is_Indic_Syllabic_Category=consonantfinal}', "");
    Expect(1, 72342, '\p{^Is_Indic_Syllabic_Category=consonantfinal}', "");
    Expect(1, 72342, '\P{Is_Indic_Syllabic_Category=consonantfinal}', "");
    Expect(0, 72342, '\P{^Is_Indic_Syllabic_Category=consonantfinal}', "");
    Expect(1, 72341, '\p{Is_Indic_Syllabic_Category:		CONSONANT_Final}', "");
    Expect(0, 72341, '\p{^Is_Indic_Syllabic_Category:		CONSONANT_Final}', "");
    Expect(0, 72341, '\P{Is_Indic_Syllabic_Category:		CONSONANT_Final}', "");
    Expect(1, 72341, '\P{^Is_Indic_Syllabic_Category:		CONSONANT_Final}', "");
    Expect(0, 72342, '\p{Is_Indic_Syllabic_Category:		CONSONANT_Final}', "");
    Expect(1, 72342, '\p{^Is_Indic_Syllabic_Category:		CONSONANT_Final}', "");
    Expect(1, 72342, '\P{Is_Indic_Syllabic_Category:		CONSONANT_Final}', "");
    Expect(0, 72342, '\P{^Is_Indic_Syllabic_Category:		CONSONANT_Final}', "");
    Error('\p{Is_InSC=		consonant_FINAL/a/}');
    Error('\P{Is_InSC=		consonant_FINAL/a/}');
    Expect(1, 72341, '\p{Is_InSC=consonantfinal}', "");
    Expect(0, 72341, '\p{^Is_InSC=consonantfinal}', "");
    Expect(0, 72341, '\P{Is_InSC=consonantfinal}', "");
    Expect(1, 72341, '\P{^Is_InSC=consonantfinal}', "");
    Expect(0, 72342, '\p{Is_InSC=consonantfinal}', "");
    Expect(1, 72342, '\p{^Is_InSC=consonantfinal}', "");
    Expect(1, 72342, '\P{Is_InSC=consonantfinal}', "");
    Expect(0, 72342, '\P{^Is_InSC=consonantfinal}', "");
    Expect(1, 72341, '\p{Is_InSC:  _Consonant_Final}', "");
    Expect(0, 72341, '\p{^Is_InSC:  _Consonant_Final}', "");
    Expect(0, 72341, '\P{Is_InSC:  _Consonant_Final}', "");
    Expect(1, 72341, '\P{^Is_InSC:  _Consonant_Final}', "");
    Expect(0, 72342, '\p{Is_InSC:  _Consonant_Final}', "");
    Expect(1, 72342, '\p{^Is_InSC:  _Consonant_Final}', "");
    Expect(1, 72342, '\P{Is_InSC:  _Consonant_Final}', "");
    Expect(0, 72342, '\P{^Is_InSC:  _Consonant_Final}', "");
    Error('\p{Indic_Syllabic_Category:	-/a/Consonant_head_Letter}');
    Error('\P{Indic_Syllabic_Category:	-/a/Consonant_head_Letter}');
    Expect(1, 3980, '\p{Indic_Syllabic_Category=:\AConsonant_Head_Letter\z:}', "");;
    Expect(0, 3981, '\p{Indic_Syllabic_Category=:\AConsonant_Head_Letter\z:}', "");;
    Expect(1, 3980, '\p{Indic_Syllabic_Category=consonantheadletter}', "");
    Expect(0, 3980, '\p{^Indic_Syllabic_Category=consonantheadletter}', "");
    Expect(0, 3980, '\P{Indic_Syllabic_Category=consonantheadletter}', "");
    Expect(1, 3980, '\P{^Indic_Syllabic_Category=consonantheadletter}', "");
    Expect(0, 3981, '\p{Indic_Syllabic_Category=consonantheadletter}', "");
    Expect(1, 3981, '\p{^Indic_Syllabic_Category=consonantheadletter}', "");
    Expect(1, 3981, '\P{Indic_Syllabic_Category=consonantheadletter}', "");
    Expect(0, 3981, '\P{^Indic_Syllabic_Category=consonantheadletter}', "");
    Expect(1, 3980, '\p{Indic_Syllabic_Category=:\Aconsonantheadletter\z:}', "");;
    Expect(0, 3981, '\p{Indic_Syllabic_Category=:\Aconsonantheadletter\z:}', "");;
    Expect(1, 3980, '\p{Indic_Syllabic_Category=		Consonant_Head_letter}', "");
    Expect(0, 3980, '\p{^Indic_Syllabic_Category=		Consonant_Head_letter}', "");
    Expect(0, 3980, '\P{Indic_Syllabic_Category=		Consonant_Head_letter}', "");
    Expect(1, 3980, '\P{^Indic_Syllabic_Category=		Consonant_Head_letter}', "");
    Expect(0, 3981, '\p{Indic_Syllabic_Category=		Consonant_Head_letter}', "");
    Expect(1, 3981, '\p{^Indic_Syllabic_Category=		Consonant_Head_letter}', "");
    Expect(1, 3981, '\P{Indic_Syllabic_Category=		Consonant_Head_letter}', "");
    Expect(0, 3981, '\P{^Indic_Syllabic_Category=		Consonant_Head_letter}', "");
    Error('\p{InSC=-/a/consonant_Head_letter}');
    Error('\P{InSC=-/a/consonant_Head_letter}');
    Expect(1, 3980, '\p{InSC=:\AConsonant_Head_Letter\z:}', "");;
    Expect(0, 3981, '\p{InSC=:\AConsonant_Head_Letter\z:}', "");;
    Expect(1, 3980, '\p{InSC=consonantheadletter}', "");
    Expect(0, 3980, '\p{^InSC=consonantheadletter}', "");
    Expect(0, 3980, '\P{InSC=consonantheadletter}', "");
    Expect(1, 3980, '\P{^InSC=consonantheadletter}', "");
    Expect(0, 3981, '\p{InSC=consonantheadletter}', "");
    Expect(1, 3981, '\p{^InSC=consonantheadletter}', "");
    Expect(1, 3981, '\P{InSC=consonantheadletter}', "");
    Expect(0, 3981, '\P{^InSC=consonantheadletter}', "");
    Expect(1, 3980, '\p{InSC=:\Aconsonantheadletter\z:}', "");;
    Expect(0, 3981, '\p{InSC=:\Aconsonantheadletter\z:}', "");;
    Expect(1, 3980, '\p{InSC=-_Consonant_head_Letter}', "");
    Expect(0, 3980, '\p{^InSC=-_Consonant_head_Letter}', "");
    Expect(0, 3980, '\P{InSC=-_Consonant_head_Letter}', "");
    Expect(1, 3980, '\P{^InSC=-_Consonant_head_Letter}', "");
    Expect(0, 3981, '\p{InSC=-_Consonant_head_Letter}', "");
    Expect(1, 3981, '\p{^InSC=-_Consonant_head_Letter}', "");
    Expect(1, 3981, '\P{InSC=-_Consonant_head_Letter}', "");
    Expect(0, 3981, '\P{^InSC=-_Consonant_head_Letter}', "");
    Error('\p{Is_Indic_Syllabic_Category=:=-Consonant_head_LETTER}');
    Error('\P{Is_Indic_Syllabic_Category=:=-Consonant_head_LETTER}');
    Expect(1, 3980, '\p{Is_Indic_Syllabic_Category=consonantheadletter}', "");
    Expect(0, 3980, '\p{^Is_Indic_Syllabic_Category=consonantheadletter}', "");
    Expect(0, 3980, '\P{Is_Indic_Syllabic_Category=consonantheadletter}', "");
    Expect(1, 3980, '\P{^Is_Indic_Syllabic_Category=consonantheadletter}', "");
    Expect(0, 3981, '\p{Is_Indic_Syllabic_Category=consonantheadletter}', "");
    Expect(1, 3981, '\p{^Is_Indic_Syllabic_Category=consonantheadletter}', "");
    Expect(1, 3981, '\P{Is_Indic_Syllabic_Category=consonantheadletter}', "");
    Expect(0, 3981, '\P{^Is_Indic_Syllabic_Category=consonantheadletter}', "");
    Expect(1, 3980, '\p{Is_Indic_Syllabic_Category=CONSONANT_Head_Letter}', "");
    Expect(0, 3980, '\p{^Is_Indic_Syllabic_Category=CONSONANT_Head_Letter}', "");
    Expect(0, 3980, '\P{Is_Indic_Syllabic_Category=CONSONANT_Head_Letter}', "");
    Expect(1, 3980, '\P{^Is_Indic_Syllabic_Category=CONSONANT_Head_Letter}', "");
    Expect(0, 3981, '\p{Is_Indic_Syllabic_Category=CONSONANT_Head_Letter}', "");
    Expect(1, 3981, '\p{^Is_Indic_Syllabic_Category=CONSONANT_Head_Letter}', "");
    Expect(1, 3981, '\P{Is_Indic_Syllabic_Category=CONSONANT_Head_Letter}', "");
    Expect(0, 3981, '\P{^Is_Indic_Syllabic_Category=CONSONANT_Head_Letter}', "");
    Error('\p{Is_InSC=:=		consonant_Head_Letter}');
    Error('\P{Is_InSC=:=		consonant_Head_Letter}');
    Expect(1, 3980, '\p{Is_InSC=consonantheadletter}', "");
    Expect(0, 3980, '\p{^Is_InSC=consonantheadletter}', "");
    Expect(0, 3980, '\P{Is_InSC=consonantheadletter}', "");
    Expect(1, 3980, '\P{^Is_InSC=consonantheadletter}', "");
    Expect(0, 3981, '\p{Is_InSC=consonantheadletter}', "");
    Expect(1, 3981, '\p{^Is_InSC=consonantheadletter}', "");
    Expect(1, 3981, '\P{Is_InSC=consonantheadletter}', "");
    Expect(0, 3981, '\P{^Is_InSC=consonantheadletter}', "");
    Expect(1, 3980, '\p{Is_InSC=- CONSONANT_Head_Letter}', "");
    Expect(0, 3980, '\p{^Is_InSC=- CONSONANT_Head_Letter}', "");
    Expect(0, 3980, '\P{Is_InSC=- CONSONANT_Head_Letter}', "");
    Expect(1, 3980, '\P{^Is_InSC=- CONSONANT_Head_Letter}', "");
    Expect(0, 3981, '\p{Is_InSC=- CONSONANT_Head_Letter}', "");
    Expect(1, 3981, '\p{^Is_InSC=- CONSONANT_Head_Letter}', "");
    Expect(1, 3981, '\P{Is_InSC=- CONSONANT_Head_Letter}', "");
    Expect(0, 3981, '\P{^Is_InSC=- CONSONANT_Head_Letter}', "");
    Error('\p{Indic_Syllabic_Category= :=Consonant_Initial_POSTFIXED}');
    Error('\P{Indic_Syllabic_Category= :=Consonant_Initial_POSTFIXED}');
    Expect(1, 6746, '\p{Indic_Syllabic_Category=:\AConsonant_Initial_Postfixed\z:}', "");;
    Expect(0, 6747, '\p{Indic_Syllabic_Category=:\AConsonant_Initial_Postfixed\z:}', "");;
    Expect(1, 6746, '\p{Indic_Syllabic_Category=consonantinitialpostfixed}', "");
    Expect(0, 6746, '\p{^Indic_Syllabic_Category=consonantinitialpostfixed}', "");
    Expect(0, 6746, '\P{Indic_Syllabic_Category=consonantinitialpostfixed}', "");
    Expect(1, 6746, '\P{^Indic_Syllabic_Category=consonantinitialpostfixed}', "");
    Expect(0, 6747, '\p{Indic_Syllabic_Category=consonantinitialpostfixed}', "");
    Expect(1, 6747, '\p{^Indic_Syllabic_Category=consonantinitialpostfixed}', "");
    Expect(1, 6747, '\P{Indic_Syllabic_Category=consonantinitialpostfixed}', "");
    Expect(0, 6747, '\P{^Indic_Syllabic_Category=consonantinitialpostfixed}', "");
    Expect(1, 6746, '\p{Indic_Syllabic_Category=:\Aconsonantinitialpostfixed\z:}', "");;
    Expect(0, 6747, '\p{Indic_Syllabic_Category=:\Aconsonantinitialpostfixed\z:}', "");;
    Expect(1, 6746, '\p{Indic_Syllabic_Category:	- Consonant_Initial_Postfixed}', "");
    Expect(0, 6746, '\p{^Indic_Syllabic_Category:	- Consonant_Initial_Postfixed}', "");
    Expect(0, 6746, '\P{Indic_Syllabic_Category:	- Consonant_Initial_Postfixed}', "");
    Expect(1, 6746, '\P{^Indic_Syllabic_Category:	- Consonant_Initial_Postfixed}', "");
    Expect(0, 6747, '\p{Indic_Syllabic_Category:	- Consonant_Initial_Postfixed}', "");
    Expect(1, 6747, '\p{^Indic_Syllabic_Category:	- Consonant_Initial_Postfixed}', "");
    Expect(1, 6747, '\P{Indic_Syllabic_Category:	- Consonant_Initial_Postfixed}', "");
    Expect(0, 6747, '\P{^Indic_Syllabic_Category:	- Consonant_Initial_Postfixed}', "");
    Error('\p{InSC=__CONSONANT_Initial_Postfixed/a/}');
    Error('\P{InSC=__CONSONANT_Initial_Postfixed/a/}');
    Expect(1, 6746, '\p{InSC=:\AConsonant_Initial_Postfixed\z:}', "");;
    Expect(0, 6747, '\p{InSC=:\AConsonant_Initial_Postfixed\z:}', "");;
    Expect(1, 6746, '\p{InSC:consonantinitialpostfixed}', "");
    Expect(0, 6746, '\p{^InSC:consonantinitialpostfixed}', "");
    Expect(0, 6746, '\P{InSC:consonantinitialpostfixed}', "");
    Expect(1, 6746, '\P{^InSC:consonantinitialpostfixed}', "");
    Expect(0, 6747, '\p{InSC:consonantinitialpostfixed}', "");
    Expect(1, 6747, '\p{^InSC:consonantinitialpostfixed}', "");
    Expect(1, 6747, '\P{InSC:consonantinitialpostfixed}', "");
    Expect(0, 6747, '\P{^InSC:consonantinitialpostfixed}', "");
    Expect(1, 6746, '\p{InSC=:\Aconsonantinitialpostfixed\z:}', "");;
    Expect(0, 6747, '\p{InSC=:\Aconsonantinitialpostfixed\z:}', "");;
    Expect(1, 6746, '\p{InSC=__Consonant_initial_POSTFIXED}', "");
    Expect(0, 6746, '\p{^InSC=__Consonant_initial_POSTFIXED}', "");
    Expect(0, 6746, '\P{InSC=__Consonant_initial_POSTFIXED}', "");
    Expect(1, 6746, '\P{^InSC=__Consonant_initial_POSTFIXED}', "");
    Expect(0, 6747, '\p{InSC=__Consonant_initial_POSTFIXED}', "");
    Expect(1, 6747, '\p{^InSC=__Consonant_initial_POSTFIXED}', "");
    Expect(1, 6747, '\P{InSC=__Consonant_initial_POSTFIXED}', "");
    Expect(0, 6747, '\P{^InSC=__Consonant_initial_POSTFIXED}', "");
    Error('\p{Is_Indic_Syllabic_Category=	/a/Consonant_Initial_Postfixed}');
    Error('\P{Is_Indic_Syllabic_Category=	/a/Consonant_Initial_Postfixed}');
    Expect(1, 6746, '\p{Is_Indic_Syllabic_Category=consonantinitialpostfixed}', "");
    Expect(0, 6746, '\p{^Is_Indic_Syllabic_Category=consonantinitialpostfixed}', "");
    Expect(0, 6746, '\P{Is_Indic_Syllabic_Category=consonantinitialpostfixed}', "");
    Expect(1, 6746, '\P{^Is_Indic_Syllabic_Category=consonantinitialpostfixed}', "");
    Expect(0, 6747, '\p{Is_Indic_Syllabic_Category=consonantinitialpostfixed}', "");
    Expect(1, 6747, '\p{^Is_Indic_Syllabic_Category=consonantinitialpostfixed}', "");
    Expect(1, 6747, '\P{Is_Indic_Syllabic_Category=consonantinitialpostfixed}', "");
    Expect(0, 6747, '\P{^Is_Indic_Syllabic_Category=consonantinitialpostfixed}', "");
    Expect(1, 6746, '\p{Is_Indic_Syllabic_Category=	CONSONANT_Initial_Postfixed}', "");
    Expect(0, 6746, '\p{^Is_Indic_Syllabic_Category=	CONSONANT_Initial_Postfixed}', "");
    Expect(0, 6746, '\P{Is_Indic_Syllabic_Category=	CONSONANT_Initial_Postfixed}', "");
    Expect(1, 6746, '\P{^Is_Indic_Syllabic_Category=	CONSONANT_Initial_Postfixed}', "");
    Expect(0, 6747, '\p{Is_Indic_Syllabic_Category=	CONSONANT_Initial_Postfixed}', "");
    Expect(1, 6747, '\p{^Is_Indic_Syllabic_Category=	CONSONANT_Initial_Postfixed}', "");
    Expect(1, 6747, '\P{Is_Indic_Syllabic_Category=	CONSONANT_Initial_Postfixed}', "");
    Expect(0, 6747, '\P{^Is_Indic_Syllabic_Category=	CONSONANT_Initial_Postfixed}', "");
    Error('\p{Is_InSC=:=-	Consonant_initial_postfixed}');
    Error('\P{Is_InSC=:=-	Consonant_initial_postfixed}');
    Expect(1, 6746, '\p{Is_InSC=consonantinitialpostfixed}', "");
    Expect(0, 6746, '\p{^Is_InSC=consonantinitialpostfixed}', "");
    Expect(0, 6746, '\P{Is_InSC=consonantinitialpostfixed}', "");
    Expect(1, 6746, '\P{^Is_InSC=consonantinitialpostfixed}', "");
    Expect(0, 6747, '\p{Is_InSC=consonantinitialpostfixed}', "");
    Expect(1, 6747, '\p{^Is_InSC=consonantinitialpostfixed}', "");
    Expect(1, 6747, '\P{Is_InSC=consonantinitialpostfixed}', "");
    Expect(0, 6747, '\P{^Is_InSC=consonantinitialpostfixed}', "");
    Expect(1, 6746, '\p{Is_InSC=_CONSONANT_INITIAL_postfixed}', "");
    Expect(0, 6746, '\p{^Is_InSC=_CONSONANT_INITIAL_postfixed}', "");
    Expect(0, 6746, '\P{Is_InSC=_CONSONANT_INITIAL_postfixed}', "");
    Expect(1, 6746, '\P{^Is_InSC=_CONSONANT_INITIAL_postfixed}', "");
    Expect(0, 6747, '\p{Is_InSC=_CONSONANT_INITIAL_postfixed}', "");
    Expect(1, 6747, '\p{^Is_InSC=_CONSONANT_INITIAL_postfixed}', "");
    Expect(1, 6747, '\P{Is_InSC=_CONSONANT_INITIAL_postfixed}', "");
    Expect(0, 6747, '\P{^Is_InSC=_CONSONANT_INITIAL_postfixed}', "");
    Error('\p{Indic_Syllabic_Category=	/a/Consonant_Killer}');
    Error('\P{Indic_Syllabic_Category=	/a/Consonant_Killer}');
    Expect(1, 6093, '\p{Indic_Syllabic_Category=:\AConsonant_Killer\z:}', "");;
    Expect(0, 6094, '\p{Indic_Syllabic_Category=:\AConsonant_Killer\z:}', "");;
    Expect(1, 6093, '\p{Indic_Syllabic_Category=consonantkiller}', "");
    Expect(0, 6093, '\p{^Indic_Syllabic_Category=consonantkiller}', "");
    Expect(0, 6093, '\P{Indic_Syllabic_Category=consonantkiller}', "");
    Expect(1, 6093, '\P{^Indic_Syllabic_Category=consonantkiller}', "");
    Expect(0, 6094, '\p{Indic_Syllabic_Category=consonantkiller}', "");
    Expect(1, 6094, '\p{^Indic_Syllabic_Category=consonantkiller}', "");
    Expect(1, 6094, '\P{Indic_Syllabic_Category=consonantkiller}', "");
    Expect(0, 6094, '\P{^Indic_Syllabic_Category=consonantkiller}', "");
    Expect(1, 6093, '\p{Indic_Syllabic_Category=:\Aconsonantkiller\z:}', "");;
    Expect(0, 6094, '\p{Indic_Syllabic_Category=:\Aconsonantkiller\z:}', "");;
    Expect(1, 6093, '\p{Indic_Syllabic_Category=		Consonant_KILLER}', "");
    Expect(0, 6093, '\p{^Indic_Syllabic_Category=		Consonant_KILLER}', "");
    Expect(0, 6093, '\P{Indic_Syllabic_Category=		Consonant_KILLER}', "");
    Expect(1, 6093, '\P{^Indic_Syllabic_Category=		Consonant_KILLER}', "");
    Expect(0, 6094, '\p{Indic_Syllabic_Category=		Consonant_KILLER}', "");
    Expect(1, 6094, '\p{^Indic_Syllabic_Category=		Consonant_KILLER}', "");
    Expect(1, 6094, '\P{Indic_Syllabic_Category=		Consonant_KILLER}', "");
    Expect(0, 6094, '\P{^Indic_Syllabic_Category=		Consonant_KILLER}', "");
    Error('\p{InSC=/a/  Consonant_killer}');
    Error('\P{InSC=/a/  Consonant_killer}');
    Expect(1, 6093, '\p{InSC=:\AConsonant_Killer\z:}', "");;
    Expect(0, 6094, '\p{InSC=:\AConsonant_Killer\z:}', "");;
    Expect(1, 6093, '\p{InSC=consonantkiller}', "");
    Expect(0, 6093, '\p{^InSC=consonantkiller}', "");
    Expect(0, 6093, '\P{InSC=consonantkiller}', "");
    Expect(1, 6093, '\P{^InSC=consonantkiller}', "");
    Expect(0, 6094, '\p{InSC=consonantkiller}', "");
    Expect(1, 6094, '\p{^InSC=consonantkiller}', "");
    Expect(1, 6094, '\P{InSC=consonantkiller}', "");
    Expect(0, 6094, '\P{^InSC=consonantkiller}', "");
    Expect(1, 6093, '\p{InSC=:\Aconsonantkiller\z:}', "");;
    Expect(0, 6094, '\p{InSC=:\Aconsonantkiller\z:}', "");;
    Expect(1, 6093, '\p{InSC=__consonant_killer}', "");
    Expect(0, 6093, '\p{^InSC=__consonant_killer}', "");
    Expect(0, 6093, '\P{InSC=__consonant_killer}', "");
    Expect(1, 6093, '\P{^InSC=__consonant_killer}', "");
    Expect(0, 6094, '\p{InSC=__consonant_killer}', "");
    Expect(1, 6094, '\p{^InSC=__consonant_killer}', "");
    Expect(1, 6094, '\P{InSC=__consonant_killer}', "");
    Expect(0, 6094, '\P{^InSC=__consonant_killer}', "");
    Error('\p{Is_Indic_Syllabic_Category=	Consonant_KILLER/a/}');
    Error('\P{Is_Indic_Syllabic_Category=	Consonant_KILLER/a/}');
    Expect(1, 6093, '\p{Is_Indic_Syllabic_Category: consonantkiller}', "");
    Expect(0, 6093, '\p{^Is_Indic_Syllabic_Category: consonantkiller}', "");
    Expect(0, 6093, '\P{Is_Indic_Syllabic_Category: consonantkiller}', "");
    Expect(1, 6093, '\P{^Is_Indic_Syllabic_Category: consonantkiller}', "");
    Expect(0, 6094, '\p{Is_Indic_Syllabic_Category: consonantkiller}', "");
    Expect(1, 6094, '\p{^Is_Indic_Syllabic_Category: consonantkiller}', "");
    Expect(1, 6094, '\P{Is_Indic_Syllabic_Category: consonantkiller}', "");
    Expect(0, 6094, '\P{^Is_Indic_Syllabic_Category: consonantkiller}', "");
    Expect(1, 6093, '\p{Is_Indic_Syllabic_Category=-consonant_killer}', "");
    Expect(0, 6093, '\p{^Is_Indic_Syllabic_Category=-consonant_killer}', "");
    Expect(0, 6093, '\P{Is_Indic_Syllabic_Category=-consonant_killer}', "");
    Expect(1, 6093, '\P{^Is_Indic_Syllabic_Category=-consonant_killer}', "");
    Expect(0, 6094, '\p{Is_Indic_Syllabic_Category=-consonant_killer}', "");
    Expect(1, 6094, '\p{^Is_Indic_Syllabic_Category=-consonant_killer}', "");
    Expect(1, 6094, '\P{Is_Indic_Syllabic_Category=-consonant_killer}', "");
    Expect(0, 6094, '\P{^Is_Indic_Syllabic_Category=-consonant_killer}', "");
    Error('\p{Is_InSC=_/a/CONSONANT_Killer}');
    Error('\P{Is_InSC=_/a/CONSONANT_Killer}');
    Expect(1, 6093, '\p{Is_InSC=consonantkiller}', "");
    Expect(0, 6093, '\p{^Is_InSC=consonantkiller}', "");
    Expect(0, 6093, '\P{Is_InSC=consonantkiller}', "");
    Expect(1, 6093, '\P{^Is_InSC=consonantkiller}', "");
    Expect(0, 6094, '\p{Is_InSC=consonantkiller}', "");
    Expect(1, 6094, '\p{^Is_InSC=consonantkiller}', "");
    Expect(1, 6094, '\P{Is_InSC=consonantkiller}', "");
    Expect(0, 6094, '\P{^Is_InSC=consonantkiller}', "");
    Expect(1, 6093, '\p{Is_InSC=- Consonant_killer}', "");
    Expect(0, 6093, '\p{^Is_InSC=- Consonant_killer}', "");
    Expect(0, 6093, '\P{Is_InSC=- Consonant_killer}', "");
    Expect(1, 6093, '\P{^Is_InSC=- Consonant_killer}', "");
    Expect(0, 6094, '\p{Is_InSC=- Consonant_killer}', "");
    Expect(1, 6094, '\p{^Is_InSC=- Consonant_killer}', "");
    Expect(1, 6094, '\P{Is_InSC=- Consonant_killer}', "");
    Expect(0, 6094, '\P{^Is_InSC=- Consonant_killer}', "");
    Error('\p{Indic_Syllabic_Category= /a/Consonant_Medial}');
    Error('\P{Indic_Syllabic_Category= /a/Consonant_Medial}');
    Expect(1, 73031, '\p{Indic_Syllabic_Category=:\AConsonant_Medial\z:}', "");;
    Expect(0, 73032, '\p{Indic_Syllabic_Category=:\AConsonant_Medial\z:}', "");;
    Expect(1, 73031, '\p{Indic_Syllabic_Category=consonantmedial}', "");
    Expect(0, 73031, '\p{^Indic_Syllabic_Category=consonantmedial}', "");
    Expect(0, 73031, '\P{Indic_Syllabic_Category=consonantmedial}', "");
    Expect(1, 73031, '\P{^Indic_Syllabic_Category=consonantmedial}', "");
    Expect(0, 73032, '\p{Indic_Syllabic_Category=consonantmedial}', "");
    Expect(1, 73032, '\p{^Indic_Syllabic_Category=consonantmedial}', "");
    Expect(1, 73032, '\P{Indic_Syllabic_Category=consonantmedial}', "");
    Expect(0, 73032, '\P{^Indic_Syllabic_Category=consonantmedial}', "");
    Expect(1, 73031, '\p{Indic_Syllabic_Category=:\Aconsonantmedial\z:}', "");;
    Expect(0, 73032, '\p{Indic_Syllabic_Category=:\Aconsonantmedial\z:}', "");;
    Expect(1, 73031, '\p{Indic_Syllabic_Category=	consonant_Medial}', "");
    Expect(0, 73031, '\p{^Indic_Syllabic_Category=	consonant_Medial}', "");
    Expect(0, 73031, '\P{Indic_Syllabic_Category=	consonant_Medial}', "");
    Expect(1, 73031, '\P{^Indic_Syllabic_Category=	consonant_Medial}', "");
    Expect(0, 73032, '\p{Indic_Syllabic_Category=	consonant_Medial}', "");
    Expect(1, 73032, '\p{^Indic_Syllabic_Category=	consonant_Medial}', "");
    Expect(1, 73032, '\P{Indic_Syllabic_Category=	consonant_Medial}', "");
    Expect(0, 73032, '\P{^Indic_Syllabic_Category=	consonant_Medial}', "");
    Error('\p{InSC:	/a/CONSONANT_medial}');
    Error('\P{InSC:	/a/CONSONANT_medial}');
    Expect(1, 73031, '\p{InSC=:\AConsonant_Medial\z:}', "");;
    Expect(0, 73032, '\p{InSC=:\AConsonant_Medial\z:}', "");;
    Expect(1, 73031, '\p{InSC=consonantmedial}', "");
    Expect(0, 73031, '\p{^InSC=consonantmedial}', "");
    Expect(0, 73031, '\P{InSC=consonantmedial}', "");
    Expect(1, 73031, '\P{^InSC=consonantmedial}', "");
    Expect(0, 73032, '\p{InSC=consonantmedial}', "");
    Expect(1, 73032, '\p{^InSC=consonantmedial}', "");
    Expect(1, 73032, '\P{InSC=consonantmedial}', "");
    Expect(0, 73032, '\P{^InSC=consonantmedial}', "");
    Expect(1, 73031, '\p{InSC=:\Aconsonantmedial\z:}', "");;
    Expect(0, 73032, '\p{InSC=:\Aconsonantmedial\z:}', "");;
    Expect(1, 73031, '\p{InSC=-CONSONANT_Medial}', "");
    Expect(0, 73031, '\p{^InSC=-CONSONANT_Medial}', "");
    Expect(0, 73031, '\P{InSC=-CONSONANT_Medial}', "");
    Expect(1, 73031, '\P{^InSC=-CONSONANT_Medial}', "");
    Expect(0, 73032, '\p{InSC=-CONSONANT_Medial}', "");
    Expect(1, 73032, '\p{^InSC=-CONSONANT_Medial}', "");
    Expect(1, 73032, '\P{InSC=-CONSONANT_Medial}', "");
    Expect(0, 73032, '\P{^InSC=-CONSONANT_Medial}', "");
    Error('\p{Is_Indic_Syllabic_Category=_ Consonant_Medial/a/}');
    Error('\P{Is_Indic_Syllabic_Category=_ Consonant_Medial/a/}');
    Expect(1, 73031, '\p{Is_Indic_Syllabic_Category=consonantmedial}', "");
    Expect(0, 73031, '\p{^Is_Indic_Syllabic_Category=consonantmedial}', "");
    Expect(0, 73031, '\P{Is_Indic_Syllabic_Category=consonantmedial}', "");
    Expect(1, 73031, '\P{^Is_Indic_Syllabic_Category=consonantmedial}', "");
    Expect(0, 73032, '\p{Is_Indic_Syllabic_Category=consonantmedial}', "");
    Expect(1, 73032, '\p{^Is_Indic_Syllabic_Category=consonantmedial}', "");
    Expect(1, 73032, '\P{Is_Indic_Syllabic_Category=consonantmedial}', "");
    Expect(0, 73032, '\P{^Is_Indic_Syllabic_Category=consonantmedial}', "");
    Expect(1, 73031, '\p{Is_Indic_Syllabic_Category=	CONSONANT_Medial}', "");
    Expect(0, 73031, '\p{^Is_Indic_Syllabic_Category=	CONSONANT_Medial}', "");
    Expect(0, 73031, '\P{Is_Indic_Syllabic_Category=	CONSONANT_Medial}', "");
    Expect(1, 73031, '\P{^Is_Indic_Syllabic_Category=	CONSONANT_Medial}', "");
    Expect(0, 73032, '\p{Is_Indic_Syllabic_Category=	CONSONANT_Medial}', "");
    Expect(1, 73032, '\p{^Is_Indic_Syllabic_Category=	CONSONANT_Medial}', "");
    Expect(1, 73032, '\P{Is_Indic_Syllabic_Category=	CONSONANT_Medial}', "");
    Expect(0, 73032, '\P{^Is_Indic_Syllabic_Category=	CONSONANT_Medial}', "");
    Error('\p{Is_InSC=:=-	consonant_Medial}');
    Error('\P{Is_InSC=:=-	consonant_Medial}');
    Expect(1, 73031, '\p{Is_InSC=consonantmedial}', "");
    Expect(0, 73031, '\p{^Is_InSC=consonantmedial}', "");
    Expect(0, 73031, '\P{Is_InSC=consonantmedial}', "");
    Expect(1, 73031, '\P{^Is_InSC=consonantmedial}', "");
    Expect(0, 73032, '\p{Is_InSC=consonantmedial}', "");
    Expect(1, 73032, '\p{^Is_InSC=consonantmedial}', "");
    Expect(1, 73032, '\P{Is_InSC=consonantmedial}', "");
    Expect(0, 73032, '\P{^Is_InSC=consonantmedial}', "");
    Expect(1, 73031, '\p{Is_InSC=	 consonant_Medial}', "");
    Expect(0, 73031, '\p{^Is_InSC=	 consonant_Medial}', "");
    Expect(0, 73031, '\P{Is_InSC=	 consonant_Medial}', "");
    Expect(1, 73031, '\P{^Is_InSC=	 consonant_Medial}', "");
    Expect(0, 73032, '\p{Is_InSC=	 consonant_Medial}', "");
    Expect(1, 73032, '\p{^Is_InSC=	 consonant_Medial}', "");
    Expect(1, 73032, '\P{Is_InSC=	 consonant_Medial}', "");
    Expect(0, 73032, '\P{^Is_InSC=	 consonant_Medial}', "");
    Error('\p{Indic_Syllabic_Category=/a/-	CONSONANT_Placeholder}');
    Error('\P{Indic_Syllabic_Category=/a/-	CONSONANT_Placeholder}');
    Expect(1, 73458, '\p{Indic_Syllabic_Category=:\AConsonant_Placeholder\z:}', "");;
    Expect(0, 73459, '\p{Indic_Syllabic_Category=:\AConsonant_Placeholder\z:}', "");;
    Expect(1, 73458, '\p{Indic_Syllabic_Category=consonantplaceholder}', "");
    Expect(0, 73458, '\p{^Indic_Syllabic_Category=consonantplaceholder}', "");
    Expect(0, 73458, '\P{Indic_Syllabic_Category=consonantplaceholder}', "");
    Expect(1, 73458, '\P{^Indic_Syllabic_Category=consonantplaceholder}', "");
    Expect(0, 73459, '\p{Indic_Syllabic_Category=consonantplaceholder}', "");
    Expect(1, 73459, '\p{^Indic_Syllabic_Category=consonantplaceholder}', "");
    Expect(1, 73459, '\P{Indic_Syllabic_Category=consonantplaceholder}', "");
    Expect(0, 73459, '\P{^Indic_Syllabic_Category=consonantplaceholder}', "");
    Expect(1, 73458, '\p{Indic_Syllabic_Category=:\Aconsonantplaceholder\z:}', "");;
    Expect(0, 73459, '\p{Indic_Syllabic_Category=:\Aconsonantplaceholder\z:}', "");;
    Expect(1, 73458, '\p{Indic_Syllabic_Category=-consonant_PLACEHOLDER}', "");
    Expect(0, 73458, '\p{^Indic_Syllabic_Category=-consonant_PLACEHOLDER}', "");
    Expect(0, 73458, '\P{Indic_Syllabic_Category=-consonant_PLACEHOLDER}', "");
    Expect(1, 73458, '\P{^Indic_Syllabic_Category=-consonant_PLACEHOLDER}', "");
    Expect(0, 73459, '\p{Indic_Syllabic_Category=-consonant_PLACEHOLDER}', "");
    Expect(1, 73459, '\p{^Indic_Syllabic_Category=-consonant_PLACEHOLDER}', "");
    Expect(1, 73459, '\P{Indic_Syllabic_Category=-consonant_PLACEHOLDER}', "");
    Expect(0, 73459, '\P{^Indic_Syllabic_Category=-consonant_PLACEHOLDER}', "");
    Error('\p{InSC=	_CONSONANT_placeholder:=}');
    Error('\P{InSC=	_CONSONANT_placeholder:=}');
    Expect(1, 73458, '\p{InSC=:\AConsonant_Placeholder\z:}', "");;
    Expect(0, 73459, '\p{InSC=:\AConsonant_Placeholder\z:}', "");;
    Expect(1, 73458, '\p{InSC:	consonantplaceholder}', "");
    Expect(0, 73458, '\p{^InSC:	consonantplaceholder}', "");
    Expect(0, 73458, '\P{InSC:	consonantplaceholder}', "");
    Expect(1, 73458, '\P{^InSC:	consonantplaceholder}', "");
    Expect(0, 73459, '\p{InSC:	consonantplaceholder}', "");
    Expect(1, 73459, '\p{^InSC:	consonantplaceholder}', "");
    Expect(1, 73459, '\P{InSC:	consonantplaceholder}', "");
    Expect(0, 73459, '\P{^InSC:	consonantplaceholder}', "");
    Expect(1, 73458, '\p{InSC=:\Aconsonantplaceholder\z:}', "");;
    Expect(0, 73459, '\p{InSC=:\Aconsonantplaceholder\z:}', "");;
    Expect(1, 73458, '\p{InSC= _CONSONANT_Placeholder}', "");
    Expect(0, 73458, '\p{^InSC= _CONSONANT_Placeholder}', "");
    Expect(0, 73458, '\P{InSC= _CONSONANT_Placeholder}', "");
    Expect(1, 73458, '\P{^InSC= _CONSONANT_Placeholder}', "");
    Expect(0, 73459, '\p{InSC= _CONSONANT_Placeholder}', "");
    Expect(1, 73459, '\p{^InSC= _CONSONANT_Placeholder}', "");
    Expect(1, 73459, '\P{InSC= _CONSONANT_Placeholder}', "");
    Expect(0, 73459, '\P{^InSC= _CONSONANT_Placeholder}', "");
    Error('\p{Is_Indic_Syllabic_Category:-/a/Consonant_Placeholder}');
    Error('\P{Is_Indic_Syllabic_Category:-/a/Consonant_Placeholder}');
    Expect(1, 73458, '\p{Is_Indic_Syllabic_Category=consonantplaceholder}', "");
    Expect(0, 73458, '\p{^Is_Indic_Syllabic_Category=consonantplaceholder}', "");
    Expect(0, 73458, '\P{Is_Indic_Syllabic_Category=consonantplaceholder}', "");
    Expect(1, 73458, '\P{^Is_Indic_Syllabic_Category=consonantplaceholder}', "");
    Expect(0, 73459, '\p{Is_Indic_Syllabic_Category=consonantplaceholder}', "");
    Expect(1, 73459, '\p{^Is_Indic_Syllabic_Category=consonantplaceholder}', "");
    Expect(1, 73459, '\P{Is_Indic_Syllabic_Category=consonantplaceholder}', "");
    Expect(0, 73459, '\P{^Is_Indic_Syllabic_Category=consonantplaceholder}', "");
    Expect(1, 73458, '\p{Is_Indic_Syllabic_Category=-Consonant_Placeholder}', "");
    Expect(0, 73458, '\p{^Is_Indic_Syllabic_Category=-Consonant_Placeholder}', "");
    Expect(0, 73458, '\P{Is_Indic_Syllabic_Category=-Consonant_Placeholder}', "");
    Expect(1, 73458, '\P{^Is_Indic_Syllabic_Category=-Consonant_Placeholder}', "");
    Expect(0, 73459, '\p{Is_Indic_Syllabic_Category=-Consonant_Placeholder}', "");
    Expect(1, 73459, '\p{^Is_Indic_Syllabic_Category=-Consonant_Placeholder}', "");
    Expect(1, 73459, '\P{Is_Indic_Syllabic_Category=-Consonant_Placeholder}', "");
    Expect(0, 73459, '\P{^Is_Indic_Syllabic_Category=-Consonant_Placeholder}', "");
    Error('\p{Is_InSC= :=Consonant_placeholder}');
    Error('\P{Is_InSC= :=Consonant_placeholder}');
    Expect(1, 73458, '\p{Is_InSC=consonantplaceholder}', "");
    Expect(0, 73458, '\p{^Is_InSC=consonantplaceholder}', "");
    Expect(0, 73458, '\P{Is_InSC=consonantplaceholder}', "");
    Expect(1, 73458, '\P{^Is_InSC=consonantplaceholder}', "");
    Expect(0, 73459, '\p{Is_InSC=consonantplaceholder}', "");
    Expect(1, 73459, '\p{^Is_InSC=consonantplaceholder}', "");
    Expect(1, 73459, '\P{Is_InSC=consonantplaceholder}', "");
    Expect(0, 73459, '\P{^Is_InSC=consonantplaceholder}', "");
    Expect(1, 73458, '\p{Is_InSC=__CONSONANT_placeholder}', "");
    Expect(0, 73458, '\p{^Is_InSC=__CONSONANT_placeholder}', "");
    Expect(0, 73458, '\P{Is_InSC=__CONSONANT_placeholder}', "");
    Expect(1, 73458, '\P{^Is_InSC=__CONSONANT_placeholder}', "");
    Expect(0, 73459, '\p{Is_InSC=__CONSONANT_placeholder}', "");
    Expect(1, 73459, '\p{^Is_InSC=__CONSONANT_placeholder}', "");
    Expect(1, 73459, '\P{Is_InSC=__CONSONANT_placeholder}', "");
    Expect(0, 73459, '\P{^Is_InSC=__CONSONANT_placeholder}', "");
    Error('\p{Indic_Syllabic_Category=_	consonant_preceding_repha:=}');
    Error('\P{Indic_Syllabic_Category=_	consonant_preceding_repha:=}');
    Expect(1, 73030, '\p{Indic_Syllabic_Category=:\AConsonant_Preceding_Repha\z:}', "");;
    Expect(0, 73031, '\p{Indic_Syllabic_Category=:\AConsonant_Preceding_Repha\z:}', "");;
    Expect(1, 73030, '\p{Indic_Syllabic_Category=consonantprecedingrepha}', "");
    Expect(0, 73030, '\p{^Indic_Syllabic_Category=consonantprecedingrepha}', "");
    Expect(0, 73030, '\P{Indic_Syllabic_Category=consonantprecedingrepha}', "");
    Expect(1, 73030, '\P{^Indic_Syllabic_Category=consonantprecedingrepha}', "");
    Expect(0, 73031, '\p{Indic_Syllabic_Category=consonantprecedingrepha}', "");
    Expect(1, 73031, '\p{^Indic_Syllabic_Category=consonantprecedingrepha}', "");
    Expect(1, 73031, '\P{Indic_Syllabic_Category=consonantprecedingrepha}', "");
    Expect(0, 73031, '\P{^Indic_Syllabic_Category=consonantprecedingrepha}', "");
    Expect(1, 73030, '\p{Indic_Syllabic_Category=:\Aconsonantprecedingrepha\z:}', "");;
    Expect(0, 73031, '\p{Indic_Syllabic_Category=:\Aconsonantprecedingrepha\z:}', "");;
    Expect(1, 73030, '\p{Indic_Syllabic_Category=-Consonant_Preceding_repha}', "");
    Expect(0, 73030, '\p{^Indic_Syllabic_Category=-Consonant_Preceding_repha}', "");
    Expect(0, 73030, '\P{Indic_Syllabic_Category=-Consonant_Preceding_repha}', "");
    Expect(1, 73030, '\P{^Indic_Syllabic_Category=-Consonant_Preceding_repha}', "");
    Expect(0, 73031, '\p{Indic_Syllabic_Category=-Consonant_Preceding_repha}', "");
    Expect(1, 73031, '\p{^Indic_Syllabic_Category=-Consonant_Preceding_repha}', "");
    Expect(1, 73031, '\P{Indic_Syllabic_Category=-Consonant_Preceding_repha}', "");
    Expect(0, 73031, '\P{^Indic_Syllabic_Category=-Consonant_Preceding_repha}', "");
    Error('\p{InSC=	CONSONANT_PRECEDING_Repha:=}');
    Error('\P{InSC=	CONSONANT_PRECEDING_Repha:=}');
    Expect(1, 73030, '\p{InSC=:\AConsonant_Preceding_Repha\z:}', "");;
    Expect(0, 73031, '\p{InSC=:\AConsonant_Preceding_Repha\z:}', "");;
    Expect(1, 73030, '\p{InSC=consonantprecedingrepha}', "");
    Expect(0, 73030, '\p{^InSC=consonantprecedingrepha}', "");
    Expect(0, 73030, '\P{InSC=consonantprecedingrepha}', "");
    Expect(1, 73030, '\P{^InSC=consonantprecedingrepha}', "");
    Expect(0, 73031, '\p{InSC=consonantprecedingrepha}', "");
    Expect(1, 73031, '\p{^InSC=consonantprecedingrepha}', "");
    Expect(1, 73031, '\P{InSC=consonantprecedingrepha}', "");
    Expect(0, 73031, '\P{^InSC=consonantprecedingrepha}', "");
    Expect(1, 73030, '\p{InSC=:\Aconsonantprecedingrepha\z:}', "");;
    Expect(0, 73031, '\p{InSC=:\Aconsonantprecedingrepha\z:}', "");;
    Expect(1, 73030, '\p{InSC=	Consonant_PRECEDING_repha}', "");
    Expect(0, 73030, '\p{^InSC=	Consonant_PRECEDING_repha}', "");
    Expect(0, 73030, '\P{InSC=	Consonant_PRECEDING_repha}', "");
    Expect(1, 73030, '\P{^InSC=	Consonant_PRECEDING_repha}', "");
    Expect(0, 73031, '\p{InSC=	Consonant_PRECEDING_repha}', "");
    Expect(1, 73031, '\p{^InSC=	Consonant_PRECEDING_repha}', "");
    Expect(1, 73031, '\P{InSC=	Consonant_PRECEDING_repha}', "");
    Expect(0, 73031, '\P{^InSC=	Consonant_PRECEDING_repha}', "");
    Error('\p{Is_Indic_Syllabic_Category=- Consonant_Preceding_Repha/a/}');
    Error('\P{Is_Indic_Syllabic_Category=- Consonant_Preceding_Repha/a/}');
    Expect(1, 73030, '\p{Is_Indic_Syllabic_Category=consonantprecedingrepha}', "");
    Expect(0, 73030, '\p{^Is_Indic_Syllabic_Category=consonantprecedingrepha}', "");
    Expect(0, 73030, '\P{Is_Indic_Syllabic_Category=consonantprecedingrepha}', "");
    Expect(1, 73030, '\P{^Is_Indic_Syllabic_Category=consonantprecedingrepha}', "");
    Expect(0, 73031, '\p{Is_Indic_Syllabic_Category=consonantprecedingrepha}', "");
    Expect(1, 73031, '\p{^Is_Indic_Syllabic_Category=consonantprecedingrepha}', "");
    Expect(1, 73031, '\P{Is_Indic_Syllabic_Category=consonantprecedingrepha}', "");
    Expect(0, 73031, '\P{^Is_Indic_Syllabic_Category=consonantprecedingrepha}', "");
    Expect(1, 73030, '\p{Is_Indic_Syllabic_Category= _CONSONANT_Preceding_Repha}', "");
    Expect(0, 73030, '\p{^Is_Indic_Syllabic_Category= _CONSONANT_Preceding_Repha}', "");
    Expect(0, 73030, '\P{Is_Indic_Syllabic_Category= _CONSONANT_Preceding_Repha}', "");
    Expect(1, 73030, '\P{^Is_Indic_Syllabic_Category= _CONSONANT_Preceding_Repha}', "");
    Expect(0, 73031, '\p{Is_Indic_Syllabic_Category= _CONSONANT_Preceding_Repha}', "");
    Expect(1, 73031, '\p{^Is_Indic_Syllabic_Category= _CONSONANT_Preceding_Repha}', "");
    Expect(1, 73031, '\P{Is_Indic_Syllabic_Category= _CONSONANT_Preceding_Repha}', "");
    Expect(0, 73031, '\P{^Is_Indic_Syllabic_Category= _CONSONANT_Preceding_Repha}', "");
    Error('\p{Is_InSC=	:=CONSONANT_preceding_Repha}');
    Error('\P{Is_InSC=	:=CONSONANT_preceding_Repha}');
    Expect(1, 73030, '\p{Is_InSC=consonantprecedingrepha}', "");
    Expect(0, 73030, '\p{^Is_InSC=consonantprecedingrepha}', "");
    Expect(0, 73030, '\P{Is_InSC=consonantprecedingrepha}', "");
    Expect(1, 73030, '\P{^Is_InSC=consonantprecedingrepha}', "");
    Expect(0, 73031, '\p{Is_InSC=consonantprecedingrepha}', "");
    Expect(1, 73031, '\p{^Is_InSC=consonantprecedingrepha}', "");
    Expect(1, 73031, '\P{Is_InSC=consonantprecedingrepha}', "");
    Expect(0, 73031, '\P{^Is_InSC=consonantprecedingrepha}', "");
    Expect(1, 73030, '\p{Is_InSC=-	consonant_Preceding_repha}', "");
    Expect(0, 73030, '\p{^Is_InSC=-	consonant_Preceding_repha}', "");
    Expect(0, 73030, '\P{Is_InSC=-	consonant_Preceding_repha}', "");
    Expect(1, 73030, '\P{^Is_InSC=-	consonant_Preceding_repha}', "");
    Expect(0, 73031, '\p{Is_InSC=-	consonant_Preceding_repha}', "");
    Expect(1, 73031, '\p{^Is_InSC=-	consonant_Preceding_repha}', "");
    Expect(1, 73031, '\P{Is_InSC=-	consonant_Preceding_repha}', "");
    Expect(0, 73031, '\P{^Is_InSC=-	consonant_Preceding_repha}', "");
    Error('\p{Indic_Syllabic_Category=:=CONSONANT_PREFIXED}');
    Error('\P{Indic_Syllabic_Category=:=CONSONANT_PREFIXED}');
    Expect(1, 72329, '\p{Indic_Syllabic_Category=:\AConsonant_Prefixed\z:}', "");;
    Expect(0, 72330, '\p{Indic_Syllabic_Category=:\AConsonant_Prefixed\z:}', "");;
    Expect(1, 72329, '\p{Indic_Syllabic_Category=consonantprefixed}', "");
    Expect(0, 72329, '\p{^Indic_Syllabic_Category=consonantprefixed}', "");
    Expect(0, 72329, '\P{Indic_Syllabic_Category=consonantprefixed}', "");
    Expect(1, 72329, '\P{^Indic_Syllabic_Category=consonantprefixed}', "");
    Expect(0, 72330, '\p{Indic_Syllabic_Category=consonantprefixed}', "");
    Expect(1, 72330, '\p{^Indic_Syllabic_Category=consonantprefixed}', "");
    Expect(1, 72330, '\P{Indic_Syllabic_Category=consonantprefixed}', "");
    Expect(0, 72330, '\P{^Indic_Syllabic_Category=consonantprefixed}', "");
    Expect(1, 72329, '\p{Indic_Syllabic_Category=:\Aconsonantprefixed\z:}', "");;
    Expect(0, 72330, '\p{Indic_Syllabic_Category=:\Aconsonantprefixed\z:}', "");;
    Expect(1, 72329, '\p{Indic_Syllabic_Category= 	Consonant_Prefixed}', "");
    Expect(0, 72329, '\p{^Indic_Syllabic_Category= 	Consonant_Prefixed}', "");
    Expect(0, 72329, '\P{Indic_Syllabic_Category= 	Consonant_Prefixed}', "");
    Expect(1, 72329, '\P{^Indic_Syllabic_Category= 	Consonant_Prefixed}', "");
    Expect(0, 72330, '\p{Indic_Syllabic_Category= 	Consonant_Prefixed}', "");
    Expect(1, 72330, '\p{^Indic_Syllabic_Category= 	Consonant_Prefixed}', "");
    Expect(1, 72330, '\P{Indic_Syllabic_Category= 	Consonant_Prefixed}', "");
    Expect(0, 72330, '\P{^Indic_Syllabic_Category= 	Consonant_Prefixed}', "");
    Error('\p{InSC=_/a/Consonant_PREFIXED}');
    Error('\P{InSC=_/a/Consonant_PREFIXED}');
    Expect(1, 72329, '\p{InSC=:\AConsonant_Prefixed\z:}', "");;
    Expect(0, 72330, '\p{InSC=:\AConsonant_Prefixed\z:}', "");;
    Expect(1, 72329, '\p{InSC=consonantprefixed}', "");
    Expect(0, 72329, '\p{^InSC=consonantprefixed}', "");
    Expect(0, 72329, '\P{InSC=consonantprefixed}', "");
    Expect(1, 72329, '\P{^InSC=consonantprefixed}', "");
    Expect(0, 72330, '\p{InSC=consonantprefixed}', "");
    Expect(1, 72330, '\p{^InSC=consonantprefixed}', "");
    Expect(1, 72330, '\P{InSC=consonantprefixed}', "");
    Expect(0, 72330, '\P{^InSC=consonantprefixed}', "");
    Expect(1, 72329, '\p{InSC=:\Aconsonantprefixed\z:}', "");;
    Expect(0, 72330, '\p{InSC=:\Aconsonantprefixed\z:}', "");;
    Expect(1, 72329, '\p{InSC=- consonant_Prefixed}', "");
    Expect(0, 72329, '\p{^InSC=- consonant_Prefixed}', "");
    Expect(0, 72329, '\P{InSC=- consonant_Prefixed}', "");
    Expect(1, 72329, '\P{^InSC=- consonant_Prefixed}', "");
    Expect(0, 72330, '\p{InSC=- consonant_Prefixed}', "");
    Expect(1, 72330, '\p{^InSC=- consonant_Prefixed}', "");
    Expect(1, 72330, '\P{InSC=- consonant_Prefixed}', "");
    Expect(0, 72330, '\P{^InSC=- consonant_Prefixed}', "");
    Error('\p{Is_Indic_Syllabic_Category=_-Consonant_Prefixed:=}');
    Error('\P{Is_Indic_Syllabic_Category=_-Consonant_Prefixed:=}');
    Expect(1, 72329, '\p{Is_Indic_Syllabic_Category=consonantprefixed}', "");
    Expect(0, 72329, '\p{^Is_Indic_Syllabic_Category=consonantprefixed}', "");
    Expect(0, 72329, '\P{Is_Indic_Syllabic_Category=consonantprefixed}', "");
    Expect(1, 72329, '\P{^Is_Indic_Syllabic_Category=consonantprefixed}', "");
    Expect(0, 72330, '\p{Is_Indic_Syllabic_Category=consonantprefixed}', "");
    Expect(1, 72330, '\p{^Is_Indic_Syllabic_Category=consonantprefixed}', "");
    Expect(1, 72330, '\P{Is_Indic_Syllabic_Category=consonantprefixed}', "");
    Expect(0, 72330, '\P{^Is_Indic_Syllabic_Category=consonantprefixed}', "");
    Expect(1, 72329, '\p{Is_Indic_Syllabic_Category=-	Consonant_Prefixed}', "");
    Expect(0, 72329, '\p{^Is_Indic_Syllabic_Category=-	Consonant_Prefixed}', "");
    Expect(0, 72329, '\P{Is_Indic_Syllabic_Category=-	Consonant_Prefixed}', "");
    Expect(1, 72329, '\P{^Is_Indic_Syllabic_Category=-	Consonant_Prefixed}', "");
    Expect(0, 72330, '\p{Is_Indic_Syllabic_Category=-	Consonant_Prefixed}', "");
    Expect(1, 72330, '\p{^Is_Indic_Syllabic_Category=-	Consonant_Prefixed}', "");
    Expect(1, 72330, '\P{Is_Indic_Syllabic_Category=-	Consonant_Prefixed}', "");
    Expect(0, 72330, '\P{^Is_Indic_Syllabic_Category=-	Consonant_Prefixed}', "");
    Error('\p{Is_InSC= /a/CONSONANT_PREFIXED}');
    Error('\P{Is_InSC= /a/CONSONANT_PREFIXED}');
    Expect(1, 72329, '\p{Is_InSC=consonantprefixed}', "");
    Expect(0, 72329, '\p{^Is_InSC=consonantprefixed}', "");
    Expect(0, 72329, '\P{Is_InSC=consonantprefixed}', "");
    Expect(1, 72329, '\P{^Is_InSC=consonantprefixed}', "");
    Expect(0, 72330, '\p{Is_InSC=consonantprefixed}', "");
    Expect(1, 72330, '\p{^Is_InSC=consonantprefixed}', "");
    Expect(1, 72330, '\P{Is_InSC=consonantprefixed}', "");
    Expect(0, 72330, '\P{^Is_InSC=consonantprefixed}', "");
    Expect(1, 72329, '\p{Is_InSC: --consonant_prefixed}', "");
    Expect(0, 72329, '\p{^Is_InSC: --consonant_prefixed}', "");
    Expect(0, 72329, '\P{Is_InSC: --consonant_prefixed}', "");
    Expect(1, 72329, '\P{^Is_InSC: --consonant_prefixed}', "");
    Expect(0, 72330, '\p{Is_InSC: --consonant_prefixed}', "");
    Expect(1, 72330, '\p{^Is_InSC: --consonant_prefixed}', "");
    Expect(1, 72330, '\P{Is_InSC: --consonant_prefixed}', "");
    Expect(0, 72330, '\P{^Is_InSC: --consonant_prefixed}', "");
    Error('\p{Indic_Syllabic_Category: /a/Consonant_Subjoined}');
    Error('\P{Indic_Syllabic_Category: /a/Consonant_Subjoined}');
    Expect(1, 72879, '\p{Indic_Syllabic_Category=:\AConsonant_Subjoined\z:}', "");;
    Expect(0, 72880, '\p{Indic_Syllabic_Category=:\AConsonant_Subjoined\z:}', "");;
    Expect(1, 72879, '\p{Indic_Syllabic_Category=consonantsubjoined}', "");
    Expect(0, 72879, '\p{^Indic_Syllabic_Category=consonantsubjoined}', "");
    Expect(0, 72879, '\P{Indic_Syllabic_Category=consonantsubjoined}', "");
    Expect(1, 72879, '\P{^Indic_Syllabic_Category=consonantsubjoined}', "");
    Expect(0, 72880, '\p{Indic_Syllabic_Category=consonantsubjoined}', "");
    Expect(1, 72880, '\p{^Indic_Syllabic_Category=consonantsubjoined}', "");
    Expect(1, 72880, '\P{Indic_Syllabic_Category=consonantsubjoined}', "");
    Expect(0, 72880, '\P{^Indic_Syllabic_Category=consonantsubjoined}', "");
    Expect(1, 72879, '\p{Indic_Syllabic_Category=:\Aconsonantsubjoined\z:}', "");;
    Expect(0, 72880, '\p{Indic_Syllabic_Category=:\Aconsonantsubjoined\z:}', "");;
    Expect(1, 72879, '\p{Indic_Syllabic_Category=-	consonant_Subjoined}', "");
    Expect(0, 72879, '\p{^Indic_Syllabic_Category=-	consonant_Subjoined}', "");
    Expect(0, 72879, '\P{Indic_Syllabic_Category=-	consonant_Subjoined}', "");
    Expect(1, 72879, '\P{^Indic_Syllabic_Category=-	consonant_Subjoined}', "");
    Expect(0, 72880, '\p{Indic_Syllabic_Category=-	consonant_Subjoined}', "");
    Expect(1, 72880, '\p{^Indic_Syllabic_Category=-	consonant_Subjoined}', "");
    Expect(1, 72880, '\P{Indic_Syllabic_Category=-	consonant_Subjoined}', "");
    Expect(0, 72880, '\P{^Indic_Syllabic_Category=-	consonant_Subjoined}', "");
    Error('\p{InSC=consonant_Subjoined/a/}');
    Error('\P{InSC=consonant_Subjoined/a/}');
    Expect(1, 72879, '\p{InSC=:\AConsonant_Subjoined\z:}', "");;
    Expect(0, 72880, '\p{InSC=:\AConsonant_Subjoined\z:}', "");;
    Expect(1, 72879, '\p{InSC=consonantsubjoined}', "");
    Expect(0, 72879, '\p{^InSC=consonantsubjoined}', "");
    Expect(0, 72879, '\P{InSC=consonantsubjoined}', "");
    Expect(1, 72879, '\P{^InSC=consonantsubjoined}', "");
    Expect(0, 72880, '\p{InSC=consonantsubjoined}', "");
    Expect(1, 72880, '\p{^InSC=consonantsubjoined}', "");
    Expect(1, 72880, '\P{InSC=consonantsubjoined}', "");
    Expect(0, 72880, '\P{^InSC=consonantsubjoined}', "");
    Expect(1, 72879, '\p{InSC=:\Aconsonantsubjoined\z:}', "");;
    Expect(0, 72880, '\p{InSC=:\Aconsonantsubjoined\z:}', "");;
    Expect(1, 72879, '\p{InSC=_ Consonant_subjoined}', "");
    Expect(0, 72879, '\p{^InSC=_ Consonant_subjoined}', "");
    Expect(0, 72879, '\P{InSC=_ Consonant_subjoined}', "");
    Expect(1, 72879, '\P{^InSC=_ Consonant_subjoined}', "");
    Expect(0, 72880, '\p{InSC=_ Consonant_subjoined}', "");
    Expect(1, 72880, '\p{^InSC=_ Consonant_subjoined}', "");
    Expect(1, 72880, '\P{InSC=_ Consonant_subjoined}', "");
    Expect(0, 72880, '\P{^InSC=_ Consonant_subjoined}', "");
    Error('\p{Is_Indic_Syllabic_Category=	consonant_Subjoined/a/}');
    Error('\P{Is_Indic_Syllabic_Category=	consonant_Subjoined/a/}');
    Expect(1, 72879, '\p{Is_Indic_Syllabic_Category=consonantsubjoined}', "");
    Expect(0, 72879, '\p{^Is_Indic_Syllabic_Category=consonantsubjoined}', "");
    Expect(0, 72879, '\P{Is_Indic_Syllabic_Category=consonantsubjoined}', "");
    Expect(1, 72879, '\P{^Is_Indic_Syllabic_Category=consonantsubjoined}', "");
    Expect(0, 72880, '\p{Is_Indic_Syllabic_Category=consonantsubjoined}', "");
    Expect(1, 72880, '\p{^Is_Indic_Syllabic_Category=consonantsubjoined}', "");
    Expect(1, 72880, '\P{Is_Indic_Syllabic_Category=consonantsubjoined}', "");
    Expect(0, 72880, '\P{^Is_Indic_Syllabic_Category=consonantsubjoined}', "");
    Expect(1, 72879, '\p{Is_Indic_Syllabic_Category=_	Consonant_Subjoined}', "");
    Expect(0, 72879, '\p{^Is_Indic_Syllabic_Category=_	Consonant_Subjoined}', "");
    Expect(0, 72879, '\P{Is_Indic_Syllabic_Category=_	Consonant_Subjoined}', "");
    Expect(1, 72879, '\P{^Is_Indic_Syllabic_Category=_	Consonant_Subjoined}', "");
    Expect(0, 72880, '\p{Is_Indic_Syllabic_Category=_	Consonant_Subjoined}', "");
    Expect(1, 72880, '\p{^Is_Indic_Syllabic_Category=_	Consonant_Subjoined}', "");
    Expect(1, 72880, '\P{Is_Indic_Syllabic_Category=_	Consonant_Subjoined}', "");
    Expect(0, 72880, '\P{^Is_Indic_Syllabic_Category=_	Consonant_Subjoined}', "");
    Error('\p{Is_InSC: -/a/Consonant_Subjoined}');
    Error('\P{Is_InSC: -/a/Consonant_Subjoined}');
    Expect(1, 72879, '\p{Is_InSC=consonantsubjoined}', "");
    Expect(0, 72879, '\p{^Is_InSC=consonantsubjoined}', "");
    Expect(0, 72879, '\P{Is_InSC=consonantsubjoined}', "");
    Expect(1, 72879, '\P{^Is_InSC=consonantsubjoined}', "");
    Expect(0, 72880, '\p{Is_InSC=consonantsubjoined}', "");
    Expect(1, 72880, '\p{^Is_InSC=consonantsubjoined}', "");
    Expect(1, 72880, '\P{Is_InSC=consonantsubjoined}', "");
    Expect(0, 72880, '\P{^Is_InSC=consonantsubjoined}', "");
    Expect(1, 72879, '\p{Is_InSC=	-CONSONANT_subjoined}', "");
    Expect(0, 72879, '\p{^Is_InSC=	-CONSONANT_subjoined}', "");
    Expect(0, 72879, '\P{Is_InSC=	-CONSONANT_subjoined}', "");
    Expect(1, 72879, '\P{^Is_InSC=	-CONSONANT_subjoined}', "");
    Expect(0, 72880, '\p{Is_InSC=	-CONSONANT_subjoined}', "");
    Expect(1, 72880, '\p{^Is_InSC=	-CONSONANT_subjoined}', "");
    Expect(1, 72880, '\P{Is_InSC=	-CONSONANT_subjoined}', "");
    Expect(0, 72880, '\P{^Is_InSC=	-CONSONANT_subjoined}', "");
    Error('\p{Indic_Syllabic_Category=:=- consonant_Succeeding_Repha}');
    Error('\P{Indic_Syllabic_Category=:=- consonant_Succeeding_Repha}');
    Expect(1, 43394, '\p{Indic_Syllabic_Category=:\AConsonant_Succeeding_Repha\z:}', "");;
    Expect(0, 43395, '\p{Indic_Syllabic_Category=:\AConsonant_Succeeding_Repha\z:}', "");;
    Expect(1, 43394, '\p{Indic_Syllabic_Category=consonantsucceedingrepha}', "");
    Expect(0, 43394, '\p{^Indic_Syllabic_Category=consonantsucceedingrepha}', "");
    Expect(0, 43394, '\P{Indic_Syllabic_Category=consonantsucceedingrepha}', "");
    Expect(1, 43394, '\P{^Indic_Syllabic_Category=consonantsucceedingrepha}', "");
    Expect(0, 43395, '\p{Indic_Syllabic_Category=consonantsucceedingrepha}', "");
    Expect(1, 43395, '\p{^Indic_Syllabic_Category=consonantsucceedingrepha}', "");
    Expect(1, 43395, '\P{Indic_Syllabic_Category=consonantsucceedingrepha}', "");
    Expect(0, 43395, '\P{^Indic_Syllabic_Category=consonantsucceedingrepha}', "");
    Expect(1, 43394, '\p{Indic_Syllabic_Category=:\Aconsonantsucceedingrepha\z:}', "");;
    Expect(0, 43395, '\p{Indic_Syllabic_Category=:\Aconsonantsucceedingrepha\z:}', "");;
    Expect(1, 43394, '\p{Indic_Syllabic_Category=-	Consonant_succeeding_Repha}', "");
    Expect(0, 43394, '\p{^Indic_Syllabic_Category=-	Consonant_succeeding_Repha}', "");
    Expect(0, 43394, '\P{Indic_Syllabic_Category=-	Consonant_succeeding_Repha}', "");
    Expect(1, 43394, '\P{^Indic_Syllabic_Category=-	Consonant_succeeding_Repha}', "");
    Expect(0, 43395, '\p{Indic_Syllabic_Category=-	Consonant_succeeding_Repha}', "");
    Expect(1, 43395, '\p{^Indic_Syllabic_Category=-	Consonant_succeeding_Repha}', "");
    Expect(1, 43395, '\P{Indic_Syllabic_Category=-	Consonant_succeeding_Repha}', "");
    Expect(0, 43395, '\P{^Indic_Syllabic_Category=-	Consonant_succeeding_Repha}', "");
    Error('\p{InSC=		CONSONANT_succeeding_Repha/a/}');
    Error('\P{InSC=		CONSONANT_succeeding_Repha/a/}');
    Expect(1, 43394, '\p{InSC=:\AConsonant_Succeeding_Repha\z:}', "");;
    Expect(0, 43395, '\p{InSC=:\AConsonant_Succeeding_Repha\z:}', "");;
    Expect(1, 43394, '\p{InSC=consonantsucceedingrepha}', "");
    Expect(0, 43394, '\p{^InSC=consonantsucceedingrepha}', "");
    Expect(0, 43394, '\P{InSC=consonantsucceedingrepha}', "");
    Expect(1, 43394, '\P{^InSC=consonantsucceedingrepha}', "");
    Expect(0, 43395, '\p{InSC=consonantsucceedingrepha}', "");
    Expect(1, 43395, '\p{^InSC=consonantsucceedingrepha}', "");
    Expect(1, 43395, '\P{InSC=consonantsucceedingrepha}', "");
    Expect(0, 43395, '\P{^InSC=consonantsucceedingrepha}', "");
    Expect(1, 43394, '\p{InSC=:\Aconsonantsucceedingrepha\z:}', "");;
    Expect(0, 43395, '\p{InSC=:\Aconsonantsucceedingrepha\z:}', "");;
    Expect(1, 43394, '\p{InSC=-	CONSONANT_Succeeding_repha}', "");
    Expect(0, 43394, '\p{^InSC=-	CONSONANT_Succeeding_repha}', "");
    Expect(0, 43394, '\P{InSC=-	CONSONANT_Succeeding_repha}', "");
    Expect(1, 43394, '\P{^InSC=-	CONSONANT_Succeeding_repha}', "");
    Expect(0, 43395, '\p{InSC=-	CONSONANT_Succeeding_repha}', "");
    Expect(1, 43395, '\p{^InSC=-	CONSONANT_Succeeding_repha}', "");
    Expect(1, 43395, '\P{InSC=-	CONSONANT_Succeeding_repha}', "");
    Expect(0, 43395, '\P{^InSC=-	CONSONANT_Succeeding_repha}', "");
    Error('\p{Is_Indic_Syllabic_Category:	_Consonant_SUCCEEDING_repha:=}');
    Error('\P{Is_Indic_Syllabic_Category:	_Consonant_SUCCEEDING_repha:=}');
    Expect(1, 43394, '\p{Is_Indic_Syllabic_Category=consonantsucceedingrepha}', "");
    Expect(0, 43394, '\p{^Is_Indic_Syllabic_Category=consonantsucceedingrepha}', "");
    Expect(0, 43394, '\P{Is_Indic_Syllabic_Category=consonantsucceedingrepha}', "");
    Expect(1, 43394, '\P{^Is_Indic_Syllabic_Category=consonantsucceedingrepha}', "");
    Expect(0, 43395, '\p{Is_Indic_Syllabic_Category=consonantsucceedingrepha}', "");
    Expect(1, 43395, '\p{^Is_Indic_Syllabic_Category=consonantsucceedingrepha}', "");
    Expect(1, 43395, '\P{Is_Indic_Syllabic_Category=consonantsucceedingrepha}', "");
    Expect(0, 43395, '\P{^Is_Indic_Syllabic_Category=consonantsucceedingrepha}', "");
    Expect(1, 43394, '\p{Is_Indic_Syllabic_Category=	Consonant_Succeeding_REPHA}', "");
    Expect(0, 43394, '\p{^Is_Indic_Syllabic_Category=	Consonant_Succeeding_REPHA}', "");
    Expect(0, 43394, '\P{Is_Indic_Syllabic_Category=	Consonant_Succeeding_REPHA}', "");
    Expect(1, 43394, '\P{^Is_Indic_Syllabic_Category=	Consonant_Succeeding_REPHA}', "");
    Expect(0, 43395, '\p{Is_Indic_Syllabic_Category=	Consonant_Succeeding_REPHA}', "");
    Expect(1, 43395, '\p{^Is_Indic_Syllabic_Category=	Consonant_Succeeding_REPHA}', "");
    Expect(1, 43395, '\P{Is_Indic_Syllabic_Category=	Consonant_Succeeding_REPHA}', "");
    Expect(0, 43395, '\P{^Is_Indic_Syllabic_Category=	Consonant_Succeeding_REPHA}', "");
    Error('\p{Is_InSC:   - consonant_succeeding_Repha:=}');
    Error('\P{Is_InSC:   - consonant_succeeding_Repha:=}');
    Expect(1, 43394, '\p{Is_InSC=consonantsucceedingrepha}', "");
    Expect(0, 43394, '\p{^Is_InSC=consonantsucceedingrepha}', "");
    Expect(0, 43394, '\P{Is_InSC=consonantsucceedingrepha}', "");
    Expect(1, 43394, '\P{^Is_InSC=consonantsucceedingrepha}', "");
    Expect(0, 43395, '\p{Is_InSC=consonantsucceedingrepha}', "");
    Expect(1, 43395, '\p{^Is_InSC=consonantsucceedingrepha}', "");
    Expect(1, 43395, '\P{Is_InSC=consonantsucceedingrepha}', "");
    Expect(0, 43395, '\P{^Is_InSC=consonantsucceedingrepha}', "");
    Expect(1, 43394, '\p{Is_InSC=-_Consonant_SUCCEEDING_repha}', "");
    Expect(0, 43394, '\p{^Is_InSC=-_Consonant_SUCCEEDING_repha}', "");
    Expect(0, 43394, '\P{Is_InSC=-_Consonant_SUCCEEDING_repha}', "");
    Expect(1, 43394, '\P{^Is_InSC=-_Consonant_SUCCEEDING_repha}', "");
    Expect(0, 43395, '\p{Is_InSC=-_Consonant_SUCCEEDING_repha}', "");
    Expect(1, 43395, '\p{^Is_InSC=-_Consonant_SUCCEEDING_repha}', "");
    Expect(1, 43395, '\P{Is_InSC=-_Consonant_SUCCEEDING_repha}', "");
    Expect(0, 43395, '\P{^Is_InSC=-_Consonant_SUCCEEDING_repha}', "");
    Error('\p{Indic_Syllabic_Category=_:=consonant_With_stacker}');
    Error('\P{Indic_Syllabic_Category=_:=consonant_With_stacker}');
    Expect(1, 70753, '\p{Indic_Syllabic_Category=:\AConsonant_With_Stacker\z:}', "");;
    Expect(0, 70754, '\p{Indic_Syllabic_Category=:\AConsonant_With_Stacker\z:}', "");;
    Expect(1, 70753, '\p{Indic_Syllabic_Category: consonantwithstacker}', "");
    Expect(0, 70753, '\p{^Indic_Syllabic_Category: consonantwithstacker}', "");
    Expect(0, 70753, '\P{Indic_Syllabic_Category: consonantwithstacker}', "");
    Expect(1, 70753, '\P{^Indic_Syllabic_Category: consonantwithstacker}', "");
    Expect(0, 70754, '\p{Indic_Syllabic_Category: consonantwithstacker}', "");
    Expect(1, 70754, '\p{^Indic_Syllabic_Category: consonantwithstacker}', "");
    Expect(1, 70754, '\P{Indic_Syllabic_Category: consonantwithstacker}', "");
    Expect(0, 70754, '\P{^Indic_Syllabic_Category: consonantwithstacker}', "");
    Expect(1, 70753, '\p{Indic_Syllabic_Category=:\Aconsonantwithstacker\z:}', "");;
    Expect(0, 70754, '\p{Indic_Syllabic_Category=:\Aconsonantwithstacker\z:}', "");;
    Expect(1, 70753, '\p{Indic_Syllabic_Category=	_consonant_with_Stacker}', "");
    Expect(0, 70753, '\p{^Indic_Syllabic_Category=	_consonant_with_Stacker}', "");
    Expect(0, 70753, '\P{Indic_Syllabic_Category=	_consonant_with_Stacker}', "");
    Expect(1, 70753, '\P{^Indic_Syllabic_Category=	_consonant_with_Stacker}', "");
    Expect(0, 70754, '\p{Indic_Syllabic_Category=	_consonant_with_Stacker}', "");
    Expect(1, 70754, '\p{^Indic_Syllabic_Category=	_consonant_with_Stacker}', "");
    Expect(1, 70754, '\P{Indic_Syllabic_Category=	_consonant_with_Stacker}', "");
    Expect(0, 70754, '\P{^Indic_Syllabic_Category=	_consonant_with_Stacker}', "");
    Error('\p{InSC=	:=Consonant_With_Stacker}');
    Error('\P{InSC=	:=Consonant_With_Stacker}');
    Expect(1, 70753, '\p{InSC=:\AConsonant_With_Stacker\z:}', "");;
    Expect(0, 70754, '\p{InSC=:\AConsonant_With_Stacker\z:}', "");;
    Expect(1, 70753, '\p{InSC=consonantwithstacker}', "");
    Expect(0, 70753, '\p{^InSC=consonantwithstacker}', "");
    Expect(0, 70753, '\P{InSC=consonantwithstacker}', "");
    Expect(1, 70753, '\P{^InSC=consonantwithstacker}', "");
    Expect(0, 70754, '\p{InSC=consonantwithstacker}', "");
    Expect(1, 70754, '\p{^InSC=consonantwithstacker}', "");
    Expect(1, 70754, '\P{InSC=consonantwithstacker}', "");
    Expect(0, 70754, '\P{^InSC=consonantwithstacker}', "");
    Expect(1, 70753, '\p{InSC=:\Aconsonantwithstacker\z:}', "");;
    Expect(0, 70754, '\p{InSC=:\Aconsonantwithstacker\z:}', "");;
    Expect(1, 70753, '\p{InSC=	consonant_WITH_Stacker}', "");
    Expect(0, 70753, '\p{^InSC=	consonant_WITH_Stacker}', "");
    Expect(0, 70753, '\P{InSC=	consonant_WITH_Stacker}', "");
    Expect(1, 70753, '\P{^InSC=	consonant_WITH_Stacker}', "");
    Expect(0, 70754, '\p{InSC=	consonant_WITH_Stacker}', "");
    Expect(1, 70754, '\p{^InSC=	consonant_WITH_Stacker}', "");
    Expect(1, 70754, '\P{InSC=	consonant_WITH_Stacker}', "");
    Expect(0, 70754, '\P{^InSC=	consonant_WITH_Stacker}', "");
    Error('\p{Is_Indic_Syllabic_Category:   Consonant_With_Stacker/a/}');
    Error('\P{Is_Indic_Syllabic_Category:   Consonant_With_Stacker/a/}');
    Expect(1, 70753, '\p{Is_Indic_Syllabic_Category:consonantwithstacker}', "");
    Expect(0, 70753, '\p{^Is_Indic_Syllabic_Category:consonantwithstacker}', "");
    Expect(0, 70753, '\P{Is_Indic_Syllabic_Category:consonantwithstacker}', "");
    Expect(1, 70753, '\P{^Is_Indic_Syllabic_Category:consonantwithstacker}', "");
    Expect(0, 70754, '\p{Is_Indic_Syllabic_Category:consonantwithstacker}', "");
    Expect(1, 70754, '\p{^Is_Indic_Syllabic_Category:consonantwithstacker}', "");
    Expect(1, 70754, '\P{Is_Indic_Syllabic_Category:consonantwithstacker}', "");
    Expect(0, 70754, '\P{^Is_Indic_Syllabic_Category:consonantwithstacker}', "");
    Expect(1, 70753, '\p{Is_Indic_Syllabic_Category=		consonant_With_STACKER}', "");
    Expect(0, 70753, '\p{^Is_Indic_Syllabic_Category=		consonant_With_STACKER}', "");
    Expect(0, 70753, '\P{Is_Indic_Syllabic_Category=		consonant_With_STACKER}', "");
    Expect(1, 70753, '\P{^Is_Indic_Syllabic_Category=		consonant_With_STACKER}', "");
    Expect(0, 70754, '\p{Is_Indic_Syllabic_Category=		consonant_With_STACKER}', "");
    Expect(1, 70754, '\p{^Is_Indic_Syllabic_Category=		consonant_With_STACKER}', "");
    Expect(1, 70754, '\P{Is_Indic_Syllabic_Category=		consonant_With_STACKER}', "");
    Expect(0, 70754, '\P{^Is_Indic_Syllabic_Category=		consonant_With_STACKER}', "");
    Error('\p{Is_InSC=-	Consonant_With_STACKER/a/}');
    Error('\P{Is_InSC=-	Consonant_With_STACKER/a/}');
    Expect(1, 70753, '\p{Is_InSC=consonantwithstacker}', "");
    Expect(0, 70753, '\p{^Is_InSC=consonantwithstacker}', "");
    Expect(0, 70753, '\P{Is_InSC=consonantwithstacker}', "");
    Expect(1, 70753, '\P{^Is_InSC=consonantwithstacker}', "");
    Expect(0, 70754, '\p{Is_InSC=consonantwithstacker}', "");
    Expect(1, 70754, '\p{^Is_InSC=consonantwithstacker}', "");
    Expect(1, 70754, '\P{Is_InSC=consonantwithstacker}', "");
    Expect(0, 70754, '\P{^Is_InSC=consonantwithstacker}', "");
    Expect(1, 70753, '\p{Is_InSC=	_CONSONANT_with_stacker}', "");
    Expect(0, 70753, '\p{^Is_InSC=	_CONSONANT_with_stacker}', "");
    Expect(0, 70753, '\P{Is_InSC=	_CONSONANT_with_stacker}', "");
    Expect(1, 70753, '\P{^Is_InSC=	_CONSONANT_with_stacker}', "");
    Expect(0, 70754, '\p{Is_InSC=	_CONSONANT_with_stacker}', "");
    Expect(1, 70754, '\p{^Is_InSC=	_CONSONANT_with_stacker}', "");
    Expect(1, 70754, '\P{Is_InSC=	_CONSONANT_with_stacker}', "");
    Expect(0, 70754, '\P{^Is_InSC=	_CONSONANT_with_stacker}', "");
    Error('\p{Indic_Syllabic_Category:   /a/_-Gemination_Mark}');
    Error('\P{Indic_Syllabic_Category:   /a/_-Gemination_Mark}');
    Expect(1, 72344, '\p{Indic_Syllabic_Category=:\AGemination_Mark\z:}', "");;
    Expect(0, 72345, '\p{Indic_Syllabic_Category=:\AGemination_Mark\z:}', "");;
    Expect(1, 72344, '\p{Indic_Syllabic_Category=geminationmark}', "");
    Expect(0, 72344, '\p{^Indic_Syllabic_Category=geminationmark}', "");
    Expect(0, 72344, '\P{Indic_Syllabic_Category=geminationmark}', "");
    Expect(1, 72344, '\P{^Indic_Syllabic_Category=geminationmark}', "");
    Expect(0, 72345, '\p{Indic_Syllabic_Category=geminationmark}', "");
    Expect(1, 72345, '\p{^Indic_Syllabic_Category=geminationmark}', "");
    Expect(1, 72345, '\P{Indic_Syllabic_Category=geminationmark}', "");
    Expect(0, 72345, '\P{^Indic_Syllabic_Category=geminationmark}', "");
    Expect(1, 72344, '\p{Indic_Syllabic_Category=:\Ageminationmark\z:}', "");;
    Expect(0, 72345, '\p{Indic_Syllabic_Category=:\Ageminationmark\z:}', "");;
    Expect(1, 72344, '\p{Indic_Syllabic_Category:   __Gemination_MARK}', "");
    Expect(0, 72344, '\p{^Indic_Syllabic_Category:   __Gemination_MARK}', "");
    Expect(0, 72344, '\P{Indic_Syllabic_Category:   __Gemination_MARK}', "");
    Expect(1, 72344, '\P{^Indic_Syllabic_Category:   __Gemination_MARK}', "");
    Expect(0, 72345, '\p{Indic_Syllabic_Category:   __Gemination_MARK}', "");
    Expect(1, 72345, '\p{^Indic_Syllabic_Category:   __Gemination_MARK}', "");
    Expect(1, 72345, '\P{Indic_Syllabic_Category:   __Gemination_MARK}', "");
    Expect(0, 72345, '\P{^Indic_Syllabic_Category:   __Gemination_MARK}', "");
    Error('\p{InSC=:= 	gemination_Mark}');
    Error('\P{InSC=:= 	gemination_Mark}');
    Expect(1, 72344, '\p{InSC=:\AGemination_Mark\z:}', "");;
    Expect(0, 72345, '\p{InSC=:\AGemination_Mark\z:}', "");;
    Expect(1, 72344, '\p{InSC=geminationmark}', "");
    Expect(0, 72344, '\p{^InSC=geminationmark}', "");
    Expect(0, 72344, '\P{InSC=geminationmark}', "");
    Expect(1, 72344, '\P{^InSC=geminationmark}', "");
    Expect(0, 72345, '\p{InSC=geminationmark}', "");
    Expect(1, 72345, '\p{^InSC=geminationmark}', "");
    Expect(1, 72345, '\P{InSC=geminationmark}', "");
    Expect(0, 72345, '\P{^InSC=geminationmark}', "");
    Expect(1, 72344, '\p{InSC=:\Ageminationmark\z:}', "");;
    Expect(0, 72345, '\p{InSC=:\Ageminationmark\z:}', "");;
    Expect(1, 72344, '\p{InSC=		GEMINATION_Mark}', "");
    Expect(0, 72344, '\p{^InSC=		GEMINATION_Mark}', "");
    Expect(0, 72344, '\P{InSC=		GEMINATION_Mark}', "");
    Expect(1, 72344, '\P{^InSC=		GEMINATION_Mark}', "");
    Expect(0, 72345, '\p{InSC=		GEMINATION_Mark}', "");
    Expect(1, 72345, '\p{^InSC=		GEMINATION_Mark}', "");
    Expect(1, 72345, '\P{InSC=		GEMINATION_Mark}', "");
    Expect(0, 72345, '\P{^InSC=		GEMINATION_Mark}', "");
    Error('\p{Is_Indic_Syllabic_Category= 	gemination_Mark:=}');
    Error('\P{Is_Indic_Syllabic_Category= 	gemination_Mark:=}');
    Expect(1, 72344, '\p{Is_Indic_Syllabic_Category=geminationmark}', "");
    Expect(0, 72344, '\p{^Is_Indic_Syllabic_Category=geminationmark}', "");
    Expect(0, 72344, '\P{Is_Indic_Syllabic_Category=geminationmark}', "");
    Expect(1, 72344, '\P{^Is_Indic_Syllabic_Category=geminationmark}', "");
    Expect(0, 72345, '\p{Is_Indic_Syllabic_Category=geminationmark}', "");
    Expect(1, 72345, '\p{^Is_Indic_Syllabic_Category=geminationmark}', "");
    Expect(1, 72345, '\P{Is_Indic_Syllabic_Category=geminationmark}', "");
    Expect(0, 72345, '\P{^Is_Indic_Syllabic_Category=geminationmark}', "");
    Expect(1, 72344, '\p{Is_Indic_Syllabic_Category=	Gemination_Mark}', "");
    Expect(0, 72344, '\p{^Is_Indic_Syllabic_Category=	Gemination_Mark}', "");
    Expect(0, 72344, '\P{Is_Indic_Syllabic_Category=	Gemination_Mark}', "");
    Expect(1, 72344, '\P{^Is_Indic_Syllabic_Category=	Gemination_Mark}', "");
    Expect(0, 72345, '\p{Is_Indic_Syllabic_Category=	Gemination_Mark}', "");
    Expect(1, 72345, '\p{^Is_Indic_Syllabic_Category=	Gemination_Mark}', "");
    Expect(1, 72345, '\P{Is_Indic_Syllabic_Category=	Gemination_Mark}', "");
    Expect(0, 72345, '\P{^Is_Indic_Syllabic_Category=	Gemination_Mark}', "");
    Error('\p{Is_InSC= Gemination_mark:=}');
    Error('\P{Is_InSC= Gemination_mark:=}');
    Expect(1, 72344, '\p{Is_InSC=geminationmark}', "");
    Expect(0, 72344, '\p{^Is_InSC=geminationmark}', "");
    Expect(0, 72344, '\P{Is_InSC=geminationmark}', "");
    Expect(1, 72344, '\P{^Is_InSC=geminationmark}', "");
    Expect(0, 72345, '\p{Is_InSC=geminationmark}', "");
    Expect(1, 72345, '\p{^Is_InSC=geminationmark}', "");
    Expect(1, 72345, '\P{Is_InSC=geminationmark}', "");
    Expect(0, 72345, '\P{^Is_InSC=geminationmark}', "");
    Expect(1, 72344, '\p{Is_InSC= 	Gemination_Mark}', "");
    Expect(0, 72344, '\p{^Is_InSC= 	Gemination_Mark}', "");
    Expect(0, 72344, '\P{Is_InSC= 	Gemination_Mark}', "");
    Expect(1, 72344, '\P{^Is_InSC= 	Gemination_Mark}', "");
    Expect(0, 72345, '\p{Is_InSC= 	Gemination_Mark}', "");
    Expect(1, 72345, '\p{^Is_InSC= 	Gemination_Mark}', "");
    Expect(1, 72345, '\P{Is_InSC= 	Gemination_Mark}', "");
    Expect(0, 72345, '\P{^Is_InSC= 	Gemination_Mark}', "");
    Error('\p{Indic_Syllabic_Category=:= INVISIBLE_Stacker}');
    Error('\P{Indic_Syllabic_Category=:= INVISIBLE_Stacker}');
    Expect(1, 73111, '\p{Indic_Syllabic_Category=:\AInvisible_Stacker\z:}', "");;
    Expect(0, 73112, '\p{Indic_Syllabic_Category=:\AInvisible_Stacker\z:}', "");;
    Expect(1, 73111, '\p{Indic_Syllabic_Category=invisiblestacker}', "");
    Expect(0, 73111, '\p{^Indic_Syllabic_Category=invisiblestacker}', "");
    Expect(0, 73111, '\P{Indic_Syllabic_Category=invisiblestacker}', "");
    Expect(1, 73111, '\P{^Indic_Syllabic_Category=invisiblestacker}', "");
    Expect(0, 73112, '\p{Indic_Syllabic_Category=invisiblestacker}', "");
    Expect(1, 73112, '\p{^Indic_Syllabic_Category=invisiblestacker}', "");
    Expect(1, 73112, '\P{Indic_Syllabic_Category=invisiblestacker}', "");
    Expect(0, 73112, '\P{^Indic_Syllabic_Category=invisiblestacker}', "");
    Expect(1, 73111, '\p{Indic_Syllabic_Category=:\Ainvisiblestacker\z:}', "");;
    Expect(0, 73112, '\p{Indic_Syllabic_Category=:\Ainvisiblestacker\z:}', "");;
    Expect(1, 73111, '\p{Indic_Syllabic_Category=-Invisible_Stacker}', "");
    Expect(0, 73111, '\p{^Indic_Syllabic_Category=-Invisible_Stacker}', "");
    Expect(0, 73111, '\P{Indic_Syllabic_Category=-Invisible_Stacker}', "");
    Expect(1, 73111, '\P{^Indic_Syllabic_Category=-Invisible_Stacker}', "");
    Expect(0, 73112, '\p{Indic_Syllabic_Category=-Invisible_Stacker}', "");
    Expect(1, 73112, '\p{^Indic_Syllabic_Category=-Invisible_Stacker}', "");
    Expect(1, 73112, '\P{Indic_Syllabic_Category=-Invisible_Stacker}', "");
    Expect(0, 73112, '\P{^Indic_Syllabic_Category=-Invisible_Stacker}', "");
    Error('\p{InSC=_	INVISIBLE_Stacker/a/}');
    Error('\P{InSC=_	INVISIBLE_Stacker/a/}');
    Expect(1, 73111, '\p{InSC=:\AInvisible_Stacker\z:}', "");;
    Expect(0, 73112, '\p{InSC=:\AInvisible_Stacker\z:}', "");;
    Expect(1, 73111, '\p{InSC=invisiblestacker}', "");
    Expect(0, 73111, '\p{^InSC=invisiblestacker}', "");
    Expect(0, 73111, '\P{InSC=invisiblestacker}', "");
    Expect(1, 73111, '\P{^InSC=invisiblestacker}', "");
    Expect(0, 73112, '\p{InSC=invisiblestacker}', "");
    Expect(1, 73112, '\p{^InSC=invisiblestacker}', "");
    Expect(1, 73112, '\P{InSC=invisiblestacker}', "");
    Expect(0, 73112, '\P{^InSC=invisiblestacker}', "");
    Expect(1, 73111, '\p{InSC=:\Ainvisiblestacker\z:}', "");;
    Expect(0, 73112, '\p{InSC=:\Ainvisiblestacker\z:}', "");;
    Expect(1, 73111, '\p{InSC=_-INVISIBLE_STACKER}', "");
    Expect(0, 73111, '\p{^InSC=_-INVISIBLE_STACKER}', "");
    Expect(0, 73111, '\P{InSC=_-INVISIBLE_STACKER}', "");
    Expect(1, 73111, '\P{^InSC=_-INVISIBLE_STACKER}', "");
    Expect(0, 73112, '\p{InSC=_-INVISIBLE_STACKER}', "");
    Expect(1, 73112, '\p{^InSC=_-INVISIBLE_STACKER}', "");
    Expect(1, 73112, '\P{InSC=_-INVISIBLE_STACKER}', "");
    Expect(0, 73112, '\P{^InSC=_-INVISIBLE_STACKER}', "");
    Error('\p{Is_Indic_Syllabic_Category=:=INVISIBLE_Stacker}');
    Error('\P{Is_Indic_Syllabic_Category=:=INVISIBLE_Stacker}');
    Expect(1, 73111, '\p{Is_Indic_Syllabic_Category=invisiblestacker}', "");
    Expect(0, 73111, '\p{^Is_Indic_Syllabic_Category=invisiblestacker}', "");
    Expect(0, 73111, '\P{Is_Indic_Syllabic_Category=invisiblestacker}', "");
    Expect(1, 73111, '\P{^Is_Indic_Syllabic_Category=invisiblestacker}', "");
    Expect(0, 73112, '\p{Is_Indic_Syllabic_Category=invisiblestacker}', "");
    Expect(1, 73112, '\p{^Is_Indic_Syllabic_Category=invisiblestacker}', "");
    Expect(1, 73112, '\P{Is_Indic_Syllabic_Category=invisiblestacker}', "");
    Expect(0, 73112, '\P{^Is_Indic_Syllabic_Category=invisiblestacker}', "");
    Expect(1, 73111, '\p{Is_Indic_Syllabic_Category:	_	Invisible_stacker}', "");
    Expect(0, 73111, '\p{^Is_Indic_Syllabic_Category:	_	Invisible_stacker}', "");
    Expect(0, 73111, '\P{Is_Indic_Syllabic_Category:	_	Invisible_stacker}', "");
    Expect(1, 73111, '\P{^Is_Indic_Syllabic_Category:	_	Invisible_stacker}', "");
    Expect(0, 73112, '\p{Is_Indic_Syllabic_Category:	_	Invisible_stacker}', "");
    Expect(1, 73112, '\p{^Is_Indic_Syllabic_Category:	_	Invisible_stacker}', "");
    Expect(1, 73112, '\P{Is_Indic_Syllabic_Category:	_	Invisible_stacker}', "");
    Expect(0, 73112, '\P{^Is_Indic_Syllabic_Category:	_	Invisible_stacker}', "");
    Error('\p{Is_InSC=:=_	Invisible_stacker}');
    Error('\P{Is_InSC=:=_	Invisible_stacker}');
    Expect(1, 73111, '\p{Is_InSC=invisiblestacker}', "");
    Expect(0, 73111, '\p{^Is_InSC=invisiblestacker}', "");
    Expect(0, 73111, '\P{Is_InSC=invisiblestacker}', "");
    Expect(1, 73111, '\P{^Is_InSC=invisiblestacker}', "");
    Expect(0, 73112, '\p{Is_InSC=invisiblestacker}', "");
    Expect(1, 73112, '\p{^Is_InSC=invisiblestacker}', "");
    Expect(1, 73112, '\P{Is_InSC=invisiblestacker}', "");
    Expect(0, 73112, '\P{^Is_InSC=invisiblestacker}', "");
    Expect(1, 73111, '\p{Is_InSC=	_INVISIBLE_Stacker}', "");
    Expect(0, 73111, '\p{^Is_InSC=	_INVISIBLE_Stacker}', "");
    Expect(0, 73111, '\P{Is_InSC=	_INVISIBLE_Stacker}', "");
    Expect(1, 73111, '\P{^Is_InSC=	_INVISIBLE_Stacker}', "");
    Expect(0, 73112, '\p{Is_InSC=	_INVISIBLE_Stacker}', "");
    Expect(1, 73112, '\p{^Is_InSC=	_INVISIBLE_Stacker}', "");
    Expect(1, 73112, '\P{Is_InSC=	_INVISIBLE_Stacker}', "");
    Expect(0, 73112, '\P{^Is_InSC=	_INVISIBLE_Stacker}', "");
    Error('\p{Indic_Syllabic_Category=		Joiner:=}');
    Error('\P{Indic_Syllabic_Category=		Joiner:=}');
    Expect(1, 8205, '\p{Indic_Syllabic_Category=:\AJoiner\z:}', "");;
    Expect(0, 8206, '\p{Indic_Syllabic_Category=:\AJoiner\z:}', "");;
    Expect(1, 8205, '\p{Indic_Syllabic_Category=joiner}', "");
    Expect(0, 8205, '\p{^Indic_Syllabic_Category=joiner}', "");
    Expect(0, 8205, '\P{Indic_Syllabic_Category=joiner}', "");
    Expect(1, 8205, '\P{^Indic_Syllabic_Category=joiner}', "");
    Expect(0, 8206, '\p{Indic_Syllabic_Category=joiner}', "");
    Expect(1, 8206, '\p{^Indic_Syllabic_Category=joiner}', "");
    Expect(1, 8206, '\P{Indic_Syllabic_Category=joiner}', "");
    Expect(0, 8206, '\P{^Indic_Syllabic_Category=joiner}', "");
    Expect(1, 8205, '\p{Indic_Syllabic_Category=:\Ajoiner\z:}', "");;
    Expect(0, 8206, '\p{Indic_Syllabic_Category=:\Ajoiner\z:}', "");;
    Expect(1, 8205, '\p{Indic_Syllabic_Category=	Joiner}', "");
    Expect(0, 8205, '\p{^Indic_Syllabic_Category=	Joiner}', "");
    Expect(0, 8205, '\P{Indic_Syllabic_Category=	Joiner}', "");
    Expect(1, 8205, '\P{^Indic_Syllabic_Category=	Joiner}', "");
    Expect(0, 8206, '\p{Indic_Syllabic_Category=	Joiner}', "");
    Expect(1, 8206, '\p{^Indic_Syllabic_Category=	Joiner}', "");
    Expect(1, 8206, '\P{Indic_Syllabic_Category=	Joiner}', "");
    Expect(0, 8206, '\P{^Indic_Syllabic_Category=	Joiner}', "");
    Error('\p{InSC=-Joiner:=}');
    Error('\P{InSC=-Joiner:=}');
    Expect(1, 8205, '\p{InSC=:\AJoiner\z:}', "");;
    Expect(0, 8206, '\p{InSC=:\AJoiner\z:}', "");;
    Expect(1, 8205, '\p{InSC=joiner}', "");
    Expect(0, 8205, '\p{^InSC=joiner}', "");
    Expect(0, 8205, '\P{InSC=joiner}', "");
    Expect(1, 8205, '\P{^InSC=joiner}', "");
    Expect(0, 8206, '\p{InSC=joiner}', "");
    Expect(1, 8206, '\p{^InSC=joiner}', "");
    Expect(1, 8206, '\P{InSC=joiner}', "");
    Expect(0, 8206, '\P{^InSC=joiner}', "");
    Expect(1, 8205, '\p{InSC=:\Ajoiner\z:}', "");;
    Expect(0, 8206, '\p{InSC=:\Ajoiner\z:}', "");;
    Expect(1, 8205, '\p{InSC=_-joiner}', "");
    Expect(0, 8205, '\p{^InSC=_-joiner}', "");
    Expect(0, 8205, '\P{InSC=_-joiner}', "");
    Expect(1, 8205, '\P{^InSC=_-joiner}', "");
    Expect(0, 8206, '\p{InSC=_-joiner}', "");
    Expect(1, 8206, '\p{^InSC=_-joiner}', "");
    Expect(1, 8206, '\P{InSC=_-joiner}', "");
    Expect(0, 8206, '\P{^InSC=_-joiner}', "");
    Error('\p{Is_Indic_Syllabic_Category=/a/ JOINER}');
    Error('\P{Is_Indic_Syllabic_Category=/a/ JOINER}');
    Expect(1, 8205, '\p{Is_Indic_Syllabic_Category=joiner}', "");
    Expect(0, 8205, '\p{^Is_Indic_Syllabic_Category=joiner}', "");
    Expect(0, 8205, '\P{Is_Indic_Syllabic_Category=joiner}', "");
    Expect(1, 8205, '\P{^Is_Indic_Syllabic_Category=joiner}', "");
    Expect(0, 8206, '\p{Is_Indic_Syllabic_Category=joiner}', "");
    Expect(1, 8206, '\p{^Is_Indic_Syllabic_Category=joiner}', "");
    Expect(1, 8206, '\P{Is_Indic_Syllabic_Category=joiner}', "");
    Expect(0, 8206, '\P{^Is_Indic_Syllabic_Category=joiner}', "");
    Expect(1, 8205, '\p{Is_Indic_Syllabic_Category=-JOINER}', "");
    Expect(0, 8205, '\p{^Is_Indic_Syllabic_Category=-JOINER}', "");
    Expect(0, 8205, '\P{Is_Indic_Syllabic_Category=-JOINER}', "");
    Expect(1, 8205, '\P{^Is_Indic_Syllabic_Category=-JOINER}', "");
    Expect(0, 8206, '\p{Is_Indic_Syllabic_Category=-JOINER}', "");
    Expect(1, 8206, '\p{^Is_Indic_Syllabic_Category=-JOINER}', "");
    Expect(1, 8206, '\P{Is_Indic_Syllabic_Category=-JOINER}', "");
    Expect(0, 8206, '\P{^Is_Indic_Syllabic_Category=-JOINER}', "");
    Error('\p{Is_InSC= _JOINER/a/}');
    Error('\P{Is_InSC= _JOINER/a/}');
    Expect(1, 8205, '\p{Is_InSC=joiner}', "");
    Expect(0, 8205, '\p{^Is_InSC=joiner}', "");
    Expect(0, 8205, '\P{Is_InSC=joiner}', "");
    Expect(1, 8205, '\P{^Is_InSC=joiner}', "");
    Expect(0, 8206, '\p{Is_InSC=joiner}', "");
    Expect(1, 8206, '\p{^Is_InSC=joiner}', "");
    Expect(1, 8206, '\P{Is_InSC=joiner}', "");
    Expect(0, 8206, '\P{^Is_InSC=joiner}', "");
    Expect(1, 8205, '\p{Is_InSC=--Joiner}', "");
    Expect(0, 8205, '\p{^Is_InSC=--Joiner}', "");
    Expect(0, 8205, '\P{Is_InSC=--Joiner}', "");
    Expect(1, 8205, '\P{^Is_InSC=--Joiner}', "");
    Expect(0, 8206, '\p{Is_InSC=--Joiner}', "");
    Expect(1, 8206, '\p{^Is_InSC=--Joiner}', "");
    Expect(1, 8206, '\P{Is_InSC=--Joiner}', "");
    Expect(0, 8206, '\P{^Is_InSC=--Joiner}', "");
    Error('\p{Indic_Syllabic_Category:   -_modifying_LETTER/a/}');
    Error('\P{Indic_Syllabic_Category:   -_modifying_LETTER/a/}');
    Expect(1, 2947, '\p{Indic_Syllabic_Category=:\AModifying_Letter\z:}', "");;
    Expect(0, 2948, '\p{Indic_Syllabic_Category=:\AModifying_Letter\z:}', "");;
    Expect(1, 2947, '\p{Indic_Syllabic_Category=modifyingletter}', "");
    Expect(0, 2947, '\p{^Indic_Syllabic_Category=modifyingletter}', "");
    Expect(0, 2947, '\P{Indic_Syllabic_Category=modifyingletter}', "");
    Expect(1, 2947, '\P{^Indic_Syllabic_Category=modifyingletter}', "");
    Expect(0, 2948, '\p{Indic_Syllabic_Category=modifyingletter}', "");
    Expect(1, 2948, '\p{^Indic_Syllabic_Category=modifyingletter}', "");
    Expect(1, 2948, '\P{Indic_Syllabic_Category=modifyingletter}', "");
    Expect(0, 2948, '\P{^Indic_Syllabic_Category=modifyingletter}', "");
    Expect(1, 2947, '\p{Indic_Syllabic_Category=:\Amodifyingletter\z:}', "");;
    Expect(0, 2948, '\p{Indic_Syllabic_Category=:\Amodifyingletter\z:}', "");;
    Expect(1, 2947, '\p{Indic_Syllabic_Category:	 modifying_Letter}', "");
    Expect(0, 2947, '\p{^Indic_Syllabic_Category:	 modifying_Letter}', "");
    Expect(0, 2947, '\P{Indic_Syllabic_Category:	 modifying_Letter}', "");
    Expect(1, 2947, '\P{^Indic_Syllabic_Category:	 modifying_Letter}', "");
    Expect(0, 2948, '\p{Indic_Syllabic_Category:	 modifying_Letter}', "");
    Expect(1, 2948, '\p{^Indic_Syllabic_Category:	 modifying_Letter}', "");
    Expect(1, 2948, '\P{Indic_Syllabic_Category:	 modifying_Letter}', "");
    Expect(0, 2948, '\P{^Indic_Syllabic_Category:	 modifying_Letter}', "");
    Error('\p{InSC=-:=Modifying_LETTER}');
    Error('\P{InSC=-:=Modifying_LETTER}');
    Expect(1, 2947, '\p{InSC=:\AModifying_Letter\z:}', "");;
    Expect(0, 2948, '\p{InSC=:\AModifying_Letter\z:}', "");;
    Expect(1, 2947, '\p{InSC: modifyingletter}', "");
    Expect(0, 2947, '\p{^InSC: modifyingletter}', "");
    Expect(0, 2947, '\P{InSC: modifyingletter}', "");
    Expect(1, 2947, '\P{^InSC: modifyingletter}', "");
    Expect(0, 2948, '\p{InSC: modifyingletter}', "");
    Expect(1, 2948, '\p{^InSC: modifyingletter}', "");
    Expect(1, 2948, '\P{InSC: modifyingletter}', "");
    Expect(0, 2948, '\P{^InSC: modifyingletter}', "");
    Expect(1, 2947, '\p{InSC=:\Amodifyingletter\z:}', "");;
    Expect(0, 2948, '\p{InSC=:\Amodifyingletter\z:}', "");;
    Expect(1, 2947, '\p{InSC=-	MODIFYING_LETTER}', "");
    Expect(0, 2947, '\p{^InSC=-	MODIFYING_LETTER}', "");
    Expect(0, 2947, '\P{InSC=-	MODIFYING_LETTER}', "");
    Expect(1, 2947, '\P{^InSC=-	MODIFYING_LETTER}', "");
    Expect(0, 2948, '\p{InSC=-	MODIFYING_LETTER}', "");
    Expect(1, 2948, '\p{^InSC=-	MODIFYING_LETTER}', "");
    Expect(1, 2948, '\P{InSC=-	MODIFYING_LETTER}', "");
    Expect(0, 2948, '\P{^InSC=-	MODIFYING_LETTER}', "");
    Error('\p{Is_Indic_Syllabic_Category: 	-Modifying_Letter/a/}');
    Error('\P{Is_Indic_Syllabic_Category: 	-Modifying_Letter/a/}');
    Expect(1, 2947, '\p{Is_Indic_Syllabic_Category=modifyingletter}', "");
    Expect(0, 2947, '\p{^Is_Indic_Syllabic_Category=modifyingletter}', "");
    Expect(0, 2947, '\P{Is_Indic_Syllabic_Category=modifyingletter}', "");
    Expect(1, 2947, '\P{^Is_Indic_Syllabic_Category=modifyingletter}', "");
    Expect(0, 2948, '\p{Is_Indic_Syllabic_Category=modifyingletter}', "");
    Expect(1, 2948, '\p{^Is_Indic_Syllabic_Category=modifyingletter}', "");
    Expect(1, 2948, '\P{Is_Indic_Syllabic_Category=modifyingletter}', "");
    Expect(0, 2948, '\P{^Is_Indic_Syllabic_Category=modifyingletter}', "");
    Expect(1, 2947, '\p{Is_Indic_Syllabic_Category:	 Modifying_Letter}', "");
    Expect(0, 2947, '\p{^Is_Indic_Syllabic_Category:	 Modifying_Letter}', "");
    Expect(0, 2947, '\P{Is_Indic_Syllabic_Category:	 Modifying_Letter}', "");
    Expect(1, 2947, '\P{^Is_Indic_Syllabic_Category:	 Modifying_Letter}', "");
    Expect(0, 2948, '\p{Is_Indic_Syllabic_Category:	 Modifying_Letter}', "");
    Expect(1, 2948, '\p{^Is_Indic_Syllabic_Category:	 Modifying_Letter}', "");
    Expect(1, 2948, '\P{Is_Indic_Syllabic_Category:	 Modifying_Letter}', "");
    Expect(0, 2948, '\P{^Is_Indic_Syllabic_Category:	 Modifying_Letter}', "");
    Error('\p{Is_InSC=/a/modifying_letter}');
    Error('\P{Is_InSC=/a/modifying_letter}');
    Expect(1, 2947, '\p{Is_InSC=modifyingletter}', "");
    Expect(0, 2947, '\p{^Is_InSC=modifyingletter}', "");
    Expect(0, 2947, '\P{Is_InSC=modifyingletter}', "");
    Expect(1, 2947, '\P{^Is_InSC=modifyingletter}', "");
    Expect(0, 2948, '\p{Is_InSC=modifyingletter}', "");
    Expect(1, 2948, '\p{^Is_InSC=modifyingletter}', "");
    Expect(1, 2948, '\P{Is_InSC=modifyingletter}', "");
    Expect(0, 2948, '\P{^Is_InSC=modifyingletter}', "");
    Expect(1, 2947, '\p{Is_InSC:   _	modifying_Letter}', "");
    Expect(0, 2947, '\p{^Is_InSC:   _	modifying_Letter}', "");
    Expect(0, 2947, '\P{Is_InSC:   _	modifying_Letter}', "");
    Expect(1, 2947, '\P{^Is_InSC:   _	modifying_Letter}', "");
    Expect(0, 2948, '\p{Is_InSC:   _	modifying_Letter}', "");
    Expect(1, 2948, '\p{^Is_InSC:   _	modifying_Letter}', "");
    Expect(1, 2948, '\P{Is_InSC:   _	modifying_Letter}', "");
    Expect(0, 2948, '\P{^Is_InSC:   _	modifying_Letter}', "");
    Error('\p{Indic_Syllabic_Category= :=Non_Joiner}');
    Error('\P{Indic_Syllabic_Category= :=Non_Joiner}');
    Expect(1, 8204, '\p{Indic_Syllabic_Category=:\ANon_Joiner\z:}', "");;
    Expect(0, 8205, '\p{Indic_Syllabic_Category=:\ANon_Joiner\z:}', "");;
    Expect(1, 8204, '\p{Indic_Syllabic_Category=nonjoiner}', "");
    Expect(0, 8204, '\p{^Indic_Syllabic_Category=nonjoiner}', "");
    Expect(0, 8204, '\P{Indic_Syllabic_Category=nonjoiner}', "");
    Expect(1, 8204, '\P{^Indic_Syllabic_Category=nonjoiner}', "");
    Expect(0, 8205, '\p{Indic_Syllabic_Category=nonjoiner}', "");
    Expect(1, 8205, '\p{^Indic_Syllabic_Category=nonjoiner}', "");
    Expect(1, 8205, '\P{Indic_Syllabic_Category=nonjoiner}', "");
    Expect(0, 8205, '\P{^Indic_Syllabic_Category=nonjoiner}', "");
    Expect(1, 8204, '\p{Indic_Syllabic_Category=:\Anonjoiner\z:}', "");;
    Expect(0, 8205, '\p{Indic_Syllabic_Category=:\Anonjoiner\z:}', "");;
    Expect(1, 8204, '\p{Indic_Syllabic_Category= NON_joiner}', "");
    Expect(0, 8204, '\p{^Indic_Syllabic_Category= NON_joiner}', "");
    Expect(0, 8204, '\P{Indic_Syllabic_Category= NON_joiner}', "");
    Expect(1, 8204, '\P{^Indic_Syllabic_Category= NON_joiner}', "");
    Expect(0, 8205, '\p{Indic_Syllabic_Category= NON_joiner}', "");
    Expect(1, 8205, '\p{^Indic_Syllabic_Category= NON_joiner}', "");
    Expect(1, 8205, '\P{Indic_Syllabic_Category= NON_joiner}', "");
    Expect(0, 8205, '\P{^Indic_Syllabic_Category= NON_joiner}', "");
    Error('\p{InSC: /a/ -Non_Joiner}');
    Error('\P{InSC: /a/ -Non_Joiner}');
    Expect(1, 8204, '\p{InSC=:\ANon_Joiner\z:}', "");;
    Expect(0, 8205, '\p{InSC=:\ANon_Joiner\z:}', "");;
    Expect(1, 8204, '\p{InSC=nonjoiner}', "");
    Expect(0, 8204, '\p{^InSC=nonjoiner}', "");
    Expect(0, 8204, '\P{InSC=nonjoiner}', "");
    Expect(1, 8204, '\P{^InSC=nonjoiner}', "");
    Expect(0, 8205, '\p{InSC=nonjoiner}', "");
    Expect(1, 8205, '\p{^InSC=nonjoiner}', "");
    Expect(1, 8205, '\P{InSC=nonjoiner}', "");
    Expect(0, 8205, '\P{^InSC=nonjoiner}', "");
    Expect(1, 8204, '\p{InSC=:\Anonjoiner\z:}', "");;
    Expect(0, 8205, '\p{InSC=:\Anonjoiner\z:}', "");;
    Expect(1, 8204, '\p{InSC=_-NON_Joiner}', "");
    Expect(0, 8204, '\p{^InSC=_-NON_Joiner}', "");
    Expect(0, 8204, '\P{InSC=_-NON_Joiner}', "");
    Expect(1, 8204, '\P{^InSC=_-NON_Joiner}', "");
    Expect(0, 8205, '\p{InSC=_-NON_Joiner}', "");
    Expect(1, 8205, '\p{^InSC=_-NON_Joiner}', "");
    Expect(1, 8205, '\P{InSC=_-NON_Joiner}', "");
    Expect(0, 8205, '\P{^InSC=_-NON_Joiner}', "");
    Error('\p{Is_Indic_Syllabic_Category:	:=Non_JOINER}');
    Error('\P{Is_Indic_Syllabic_Category:	:=Non_JOINER}');
    Expect(1, 8204, '\p{Is_Indic_Syllabic_Category=nonjoiner}', "");
    Expect(0, 8204, '\p{^Is_Indic_Syllabic_Category=nonjoiner}', "");
    Expect(0, 8204, '\P{Is_Indic_Syllabic_Category=nonjoiner}', "");
    Expect(1, 8204, '\P{^Is_Indic_Syllabic_Category=nonjoiner}', "");
    Expect(0, 8205, '\p{Is_Indic_Syllabic_Category=nonjoiner}', "");
    Expect(1, 8205, '\p{^Is_Indic_Syllabic_Category=nonjoiner}', "");
    Expect(1, 8205, '\P{Is_Indic_Syllabic_Category=nonjoiner}', "");
    Expect(0, 8205, '\P{^Is_Indic_Syllabic_Category=nonjoiner}', "");
    Expect(1, 8204, '\p{Is_Indic_Syllabic_Category=-	Non_joiner}', "");
    Expect(0, 8204, '\p{^Is_Indic_Syllabic_Category=-	Non_joiner}', "");
    Expect(0, 8204, '\P{Is_Indic_Syllabic_Category=-	Non_joiner}', "");
    Expect(1, 8204, '\P{^Is_Indic_Syllabic_Category=-	Non_joiner}', "");
    Expect(0, 8205, '\p{Is_Indic_Syllabic_Category=-	Non_joiner}', "");
    Expect(1, 8205, '\p{^Is_Indic_Syllabic_Category=-	Non_joiner}', "");
    Expect(1, 8205, '\P{Is_Indic_Syllabic_Category=-	Non_joiner}', "");
    Expect(0, 8205, '\P{^Is_Indic_Syllabic_Category=-	Non_joiner}', "");
    Error('\p{Is_InSC=:= _Non_joiner}');
    Error('\P{Is_InSC=:= _Non_joiner}');
    Expect(1, 8204, '\p{Is_InSC=nonjoiner}', "");
    Expect(0, 8204, '\p{^Is_InSC=nonjoiner}', "");
    Expect(0, 8204, '\P{Is_InSC=nonjoiner}', "");
    Expect(1, 8204, '\P{^Is_InSC=nonjoiner}', "");
    Expect(0, 8205, '\p{Is_InSC=nonjoiner}', "");
    Expect(1, 8205, '\p{^Is_InSC=nonjoiner}', "");
    Expect(1, 8205, '\P{Is_InSC=nonjoiner}', "");
    Expect(0, 8205, '\P{^Is_InSC=nonjoiner}', "");
    Expect(1, 8204, '\p{Is_InSC=-NON_Joiner}', "");
    Expect(0, 8204, '\p{^Is_InSC=-NON_Joiner}', "");
    Expect(0, 8204, '\P{Is_InSC=-NON_Joiner}', "");
    Expect(1, 8204, '\P{^Is_InSC=-NON_Joiner}', "");
    Expect(0, 8205, '\p{Is_InSC=-NON_Joiner}', "");
    Expect(1, 8205, '\p{^Is_InSC=-NON_Joiner}', "");
    Expect(1, 8205, '\P{Is_InSC=-NON_Joiner}', "");
    Expect(0, 8205, '\P{^Is_InSC=-NON_Joiner}', "");
    Error('\p{Indic_Syllabic_Category= 	Nukta/a/}');
    Error('\P{Indic_Syllabic_Category= 	Nukta/a/}');
    Expect(1, 73026, '\p{Indic_Syllabic_Category=:\ANukta\z:}', "");;
    Expect(0, 73027, '\p{Indic_Syllabic_Category=:\ANukta\z:}', "");;
    Expect(1, 73026, '\p{Indic_Syllabic_Category=nukta}', "");
    Expect(0, 73026, '\p{^Indic_Syllabic_Category=nukta}', "");
    Expect(0, 73026, '\P{Indic_Syllabic_Category=nukta}', "");
    Expect(1, 73026, '\P{^Indic_Syllabic_Category=nukta}', "");
    Expect(0, 73027, '\p{Indic_Syllabic_Category=nukta}', "");
    Expect(1, 73027, '\p{^Indic_Syllabic_Category=nukta}', "");
    Expect(1, 73027, '\P{Indic_Syllabic_Category=nukta}', "");
    Expect(0, 73027, '\P{^Indic_Syllabic_Category=nukta}', "");
    Expect(1, 73026, '\p{Indic_Syllabic_Category=:\Anukta\z:}', "");;
    Expect(0, 73027, '\p{Indic_Syllabic_Category=:\Anukta\z:}', "");;
    Expect(1, 73026, '\p{Indic_Syllabic_Category=	nukta}', "");
    Expect(0, 73026, '\p{^Indic_Syllabic_Category=	nukta}', "");
    Expect(0, 73026, '\P{Indic_Syllabic_Category=	nukta}', "");
    Expect(1, 73026, '\P{^Indic_Syllabic_Category=	nukta}', "");
    Expect(0, 73027, '\p{Indic_Syllabic_Category=	nukta}', "");
    Expect(1, 73027, '\p{^Indic_Syllabic_Category=	nukta}', "");
    Expect(1, 73027, '\P{Indic_Syllabic_Category=	nukta}', "");
    Expect(0, 73027, '\P{^Indic_Syllabic_Category=	nukta}', "");
    Error('\p{InSC=:=		Nukta}');
    Error('\P{InSC=:=		Nukta}');
    Expect(1, 73026, '\p{InSC=:\ANukta\z:}', "");;
    Expect(0, 73027, '\p{InSC=:\ANukta\z:}', "");;
    Expect(1, 73026, '\p{InSC:nukta}', "");
    Expect(0, 73026, '\p{^InSC:nukta}', "");
    Expect(0, 73026, '\P{InSC:nukta}', "");
    Expect(1, 73026, '\P{^InSC:nukta}', "");
    Expect(0, 73027, '\p{InSC:nukta}', "");
    Expect(1, 73027, '\p{^InSC:nukta}', "");
    Expect(1, 73027, '\P{InSC:nukta}', "");
    Expect(0, 73027, '\P{^InSC:nukta}', "");
    Expect(1, 73026, '\p{InSC=:\Anukta\z:}', "");;
    Expect(0, 73027, '\p{InSC=:\Anukta\z:}', "");;
    Expect(1, 73026, '\p{InSC=_	Nukta}', "");
    Expect(0, 73026, '\p{^InSC=_	Nukta}', "");
    Expect(0, 73026, '\P{InSC=_	Nukta}', "");
    Expect(1, 73026, '\P{^InSC=_	Nukta}', "");
    Expect(0, 73027, '\p{InSC=_	Nukta}', "");
    Expect(1, 73027, '\p{^InSC=_	Nukta}', "");
    Expect(1, 73027, '\P{InSC=_	Nukta}', "");
    Expect(0, 73027, '\P{^InSC=_	Nukta}', "");
    Error('\p{Is_Indic_Syllabic_Category=	NUKTA/a/}');
    Error('\P{Is_Indic_Syllabic_Category=	NUKTA/a/}');
    Expect(1, 73026, '\p{Is_Indic_Syllabic_Category=nukta}', "");
    Expect(0, 73026, '\p{^Is_Indic_Syllabic_Category=nukta}', "");
    Expect(0, 73026, '\P{Is_Indic_Syllabic_Category=nukta}', "");
    Expect(1, 73026, '\P{^Is_Indic_Syllabic_Category=nukta}', "");
    Expect(0, 73027, '\p{Is_Indic_Syllabic_Category=nukta}', "");
    Expect(1, 73027, '\p{^Is_Indic_Syllabic_Category=nukta}', "");
    Expect(1, 73027, '\P{Is_Indic_Syllabic_Category=nukta}', "");
    Expect(0, 73027, '\P{^Is_Indic_Syllabic_Category=nukta}', "");
    Expect(1, 73026, '\p{Is_Indic_Syllabic_Category= nukta}', "");
    Expect(0, 73026, '\p{^Is_Indic_Syllabic_Category= nukta}', "");
    Expect(0, 73026, '\P{Is_Indic_Syllabic_Category= nukta}', "");
    Expect(1, 73026, '\P{^Is_Indic_Syllabic_Category= nukta}', "");
    Expect(0, 73027, '\p{Is_Indic_Syllabic_Category= nukta}', "");
    Expect(1, 73027, '\p{^Is_Indic_Syllabic_Category= nukta}', "");
    Expect(1, 73027, '\P{Is_Indic_Syllabic_Category= nukta}', "");
    Expect(0, 73027, '\P{^Is_Indic_Syllabic_Category= nukta}', "");
    Error('\p{Is_InSC=/a/_NUKTA}');
    Error('\P{Is_InSC=/a/_NUKTA}');
    Expect(1, 73026, '\p{Is_InSC=nukta}', "");
    Expect(0, 73026, '\p{^Is_InSC=nukta}', "");
    Expect(0, 73026, '\P{Is_InSC=nukta}', "");
    Expect(1, 73026, '\P{^Is_InSC=nukta}', "");
    Expect(0, 73027, '\p{Is_InSC=nukta}', "");
    Expect(1, 73027, '\p{^Is_InSC=nukta}', "");
    Expect(1, 73027, '\P{Is_InSC=nukta}', "");
    Expect(0, 73027, '\P{^Is_InSC=nukta}', "");
    Expect(1, 73026, '\p{Is_InSC: 	 nukta}', "");
    Expect(0, 73026, '\p{^Is_InSC: 	 nukta}', "");
    Expect(0, 73026, '\P{Is_InSC: 	 nukta}', "");
    Expect(1, 73026, '\P{^Is_InSC: 	 nukta}', "");
    Expect(0, 73027, '\p{Is_InSC: 	 nukta}', "");
    Expect(1, 73027, '\p{^Is_InSC: 	 nukta}', "");
    Expect(1, 73027, '\P{Is_InSC: 	 nukta}', "");
    Expect(0, 73027, '\P{^Is_InSC: 	 nukta}', "");
    Error('\p{Indic_Syllabic_Category=_:=Number}');
    Error('\P{Indic_Syllabic_Category=_:=Number}');
    Expect(1, 73129, '\p{Indic_Syllabic_Category=:\ANumber\z:}', "");;
    Expect(0, 73130, '\p{Indic_Syllabic_Category=:\ANumber\z:}', "");;
    Expect(1, 73129, '\p{Indic_Syllabic_Category=number}', "");
    Expect(0, 73129, '\p{^Indic_Syllabic_Category=number}', "");
    Expect(0, 73129, '\P{Indic_Syllabic_Category=number}', "");
    Expect(1, 73129, '\P{^Indic_Syllabic_Category=number}', "");
    Expect(0, 73130, '\p{Indic_Syllabic_Category=number}', "");
    Expect(1, 73130, '\p{^Indic_Syllabic_Category=number}', "");
    Expect(1, 73130, '\P{Indic_Syllabic_Category=number}', "");
    Expect(0, 73130, '\P{^Indic_Syllabic_Category=number}', "");
    Expect(1, 73129, '\p{Indic_Syllabic_Category=:\Anumber\z:}', "");;
    Expect(0, 73130, '\p{Indic_Syllabic_Category=:\Anumber\z:}', "");;
    Expect(1, 73129, '\p{Indic_Syllabic_Category=--NUMBER}', "");
    Expect(0, 73129, '\p{^Indic_Syllabic_Category=--NUMBER}', "");
    Expect(0, 73129, '\P{Indic_Syllabic_Category=--NUMBER}', "");
    Expect(1, 73129, '\P{^Indic_Syllabic_Category=--NUMBER}', "");
    Expect(0, 73130, '\p{Indic_Syllabic_Category=--NUMBER}', "");
    Expect(1, 73130, '\p{^Indic_Syllabic_Category=--NUMBER}', "");
    Expect(1, 73130, '\P{Indic_Syllabic_Category=--NUMBER}', "");
    Expect(0, 73130, '\P{^Indic_Syllabic_Category=--NUMBER}', "");
    Error('\p{InSC:/a/ number}');
    Error('\P{InSC:/a/ number}');
    Expect(1, 73129, '\p{InSC=:\ANumber\z:}', "");;
    Expect(0, 73130, '\p{InSC=:\ANumber\z:}', "");;
    Expect(1, 73129, '\p{InSC=number}', "");
    Expect(0, 73129, '\p{^InSC=number}', "");
    Expect(0, 73129, '\P{InSC=number}', "");
    Expect(1, 73129, '\P{^InSC=number}', "");
    Expect(0, 73130, '\p{InSC=number}', "");
    Expect(1, 73130, '\p{^InSC=number}', "");
    Expect(1, 73130, '\P{InSC=number}', "");
    Expect(0, 73130, '\P{^InSC=number}', "");
    Expect(1, 73129, '\p{InSC=:\Anumber\z:}', "");;
    Expect(0, 73130, '\p{InSC=:\Anumber\z:}', "");;
    Expect(1, 73129, '\p{InSC=		Number}', "");
    Expect(0, 73129, '\p{^InSC=		Number}', "");
    Expect(0, 73129, '\P{InSC=		Number}', "");
    Expect(1, 73129, '\P{^InSC=		Number}', "");
    Expect(0, 73130, '\p{InSC=		Number}', "");
    Expect(1, 73130, '\p{^InSC=		Number}', "");
    Expect(1, 73130, '\P{InSC=		Number}', "");
    Expect(0, 73130, '\P{^InSC=		Number}', "");
    Error('\p{Is_Indic_Syllabic_Category: /a/number}');
    Error('\P{Is_Indic_Syllabic_Category: /a/number}');
    Expect(1, 73129, '\p{Is_Indic_Syllabic_Category: number}', "");
    Expect(0, 73129, '\p{^Is_Indic_Syllabic_Category: number}', "");
    Expect(0, 73129, '\P{Is_Indic_Syllabic_Category: number}', "");
    Expect(1, 73129, '\P{^Is_Indic_Syllabic_Category: number}', "");
    Expect(0, 73130, '\p{Is_Indic_Syllabic_Category: number}', "");
    Expect(1, 73130, '\p{^Is_Indic_Syllabic_Category: number}', "");
    Expect(1, 73130, '\P{Is_Indic_Syllabic_Category: number}', "");
    Expect(0, 73130, '\P{^Is_Indic_Syllabic_Category: number}', "");
    Expect(1, 73129, '\p{Is_Indic_Syllabic_Category=_ NUMBER}', "");
    Expect(0, 73129, '\p{^Is_Indic_Syllabic_Category=_ NUMBER}', "");
    Expect(0, 73129, '\P{Is_Indic_Syllabic_Category=_ NUMBER}', "");
    Expect(1, 73129, '\P{^Is_Indic_Syllabic_Category=_ NUMBER}', "");
    Expect(0, 73130, '\p{Is_Indic_Syllabic_Category=_ NUMBER}', "");
    Expect(1, 73130, '\p{^Is_Indic_Syllabic_Category=_ NUMBER}', "");
    Expect(1, 73130, '\P{Is_Indic_Syllabic_Category=_ NUMBER}', "");
    Expect(0, 73130, '\P{^Is_Indic_Syllabic_Category=_ NUMBER}', "");
    Error('\p{Is_InSC=/a/number}');
    Error('\P{Is_InSC=/a/number}');
    Expect(1, 73129, '\p{Is_InSC=number}', "");
    Expect(0, 73129, '\p{^Is_InSC=number}', "");
    Expect(0, 73129, '\P{Is_InSC=number}', "");
    Expect(1, 73129, '\P{^Is_InSC=number}', "");
    Expect(0, 73130, '\p{Is_InSC=number}', "");
    Expect(1, 73130, '\p{^Is_InSC=number}', "");
    Expect(1, 73130, '\P{Is_InSC=number}', "");
    Expect(0, 73130, '\P{^Is_InSC=number}', "");
    Expect(1, 73129, '\p{Is_InSC=-NUMBER}', "");
    Expect(0, 73129, '\p{^Is_InSC=-NUMBER}', "");
    Expect(0, 73129, '\P{Is_InSC=-NUMBER}', "");
    Expect(1, 73129, '\P{^Is_InSC=-NUMBER}', "");
    Expect(0, 73130, '\p{Is_InSC=-NUMBER}', "");
    Expect(1, 73130, '\p{^Is_InSC=-NUMBER}', "");
    Expect(1, 73130, '\P{Is_InSC=-NUMBER}', "");
    Expect(0, 73130, '\P{^Is_InSC=-NUMBER}', "");
    Error('\p{Indic_Syllabic_Category=-:=Number_Joiner}');
    Error('\P{Indic_Syllabic_Category=-:=Number_Joiner}');
    Expect(1, 69759, '\p{Indic_Syllabic_Category=:\ANumber_Joiner\z:}', "");;
    Expect(0, 69760, '\p{Indic_Syllabic_Category=:\ANumber_Joiner\z:}', "");;
    Expect(1, 69759, '\p{Indic_Syllabic_Category=numberjoiner}', "");
    Expect(0, 69759, '\p{^Indic_Syllabic_Category=numberjoiner}', "");
    Expect(0, 69759, '\P{Indic_Syllabic_Category=numberjoiner}', "");
    Expect(1, 69759, '\P{^Indic_Syllabic_Category=numberjoiner}', "");
    Expect(0, 69760, '\p{Indic_Syllabic_Category=numberjoiner}', "");
    Expect(1, 69760, '\p{^Indic_Syllabic_Category=numberjoiner}', "");
    Expect(1, 69760, '\P{Indic_Syllabic_Category=numberjoiner}', "");
    Expect(0, 69760, '\P{^Indic_Syllabic_Category=numberjoiner}', "");
    Expect(1, 69759, '\p{Indic_Syllabic_Category=:\Anumberjoiner\z:}', "");;
    Expect(0, 69760, '\p{Indic_Syllabic_Category=:\Anumberjoiner\z:}', "");;
    Expect(1, 69759, '\p{Indic_Syllabic_Category=-Number_joiner}', "");
    Expect(0, 69759, '\p{^Indic_Syllabic_Category=-Number_joiner}', "");
    Expect(0, 69759, '\P{Indic_Syllabic_Category=-Number_joiner}', "");
    Expect(1, 69759, '\P{^Indic_Syllabic_Category=-Number_joiner}', "");
    Expect(0, 69760, '\p{Indic_Syllabic_Category=-Number_joiner}', "");
    Expect(1, 69760, '\p{^Indic_Syllabic_Category=-Number_joiner}', "");
    Expect(1, 69760, '\P{Indic_Syllabic_Category=-Number_joiner}', "");
    Expect(0, 69760, '\P{^Indic_Syllabic_Category=-Number_joiner}', "");
    Error('\p{InSC=/a/_Number_JOINER}');
    Error('\P{InSC=/a/_Number_JOINER}');
    Expect(1, 69759, '\p{InSC=:\ANumber_Joiner\z:}', "");;
    Expect(0, 69760, '\p{InSC=:\ANumber_Joiner\z:}', "");;
    Expect(1, 69759, '\p{InSC=numberjoiner}', "");
    Expect(0, 69759, '\p{^InSC=numberjoiner}', "");
    Expect(0, 69759, '\P{InSC=numberjoiner}', "");
    Expect(1, 69759, '\P{^InSC=numberjoiner}', "");
    Expect(0, 69760, '\p{InSC=numberjoiner}', "");
    Expect(1, 69760, '\p{^InSC=numberjoiner}', "");
    Expect(1, 69760, '\P{InSC=numberjoiner}', "");
    Expect(0, 69760, '\P{^InSC=numberjoiner}', "");
    Expect(1, 69759, '\p{InSC=:\Anumberjoiner\z:}', "");;
    Expect(0, 69760, '\p{InSC=:\Anumberjoiner\z:}', "");;
    Expect(1, 69759, '\p{InSC:   _-NUMBER_Joiner}', "");
    Expect(0, 69759, '\p{^InSC:   _-NUMBER_Joiner}', "");
    Expect(0, 69759, '\P{InSC:   _-NUMBER_Joiner}', "");
    Expect(1, 69759, '\P{^InSC:   _-NUMBER_Joiner}', "");
    Expect(0, 69760, '\p{InSC:   _-NUMBER_Joiner}', "");
    Expect(1, 69760, '\p{^InSC:   _-NUMBER_Joiner}', "");
    Expect(1, 69760, '\P{InSC:   _-NUMBER_Joiner}', "");
    Expect(0, 69760, '\P{^InSC:   _-NUMBER_Joiner}', "");
    Error('\p{Is_Indic_Syllabic_Category=/a/NUMBER_Joiner}');
    Error('\P{Is_Indic_Syllabic_Category=/a/NUMBER_Joiner}');
    Expect(1, 69759, '\p{Is_Indic_Syllabic_Category=numberjoiner}', "");
    Expect(0, 69759, '\p{^Is_Indic_Syllabic_Category=numberjoiner}', "");
    Expect(0, 69759, '\P{Is_Indic_Syllabic_Category=numberjoiner}', "");
    Expect(1, 69759, '\P{^Is_Indic_Syllabic_Category=numberjoiner}', "");
    Expect(0, 69760, '\p{Is_Indic_Syllabic_Category=numberjoiner}', "");
    Expect(1, 69760, '\p{^Is_Indic_Syllabic_Category=numberjoiner}', "");
    Expect(1, 69760, '\P{Is_Indic_Syllabic_Category=numberjoiner}', "");
    Expect(0, 69760, '\P{^Is_Indic_Syllabic_Category=numberjoiner}', "");
    Expect(1, 69759, '\p{Is_Indic_Syllabic_Category=--Number_Joiner}', "");
    Expect(0, 69759, '\p{^Is_Indic_Syllabic_Category=--Number_Joiner}', "");
    Expect(0, 69759, '\P{Is_Indic_Syllabic_Category=--Number_Joiner}', "");
    Expect(1, 69759, '\P{^Is_Indic_Syllabic_Category=--Number_Joiner}', "");
    Expect(0, 69760, '\p{Is_Indic_Syllabic_Category=--Number_Joiner}', "");
    Expect(1, 69760, '\p{^Is_Indic_Syllabic_Category=--Number_Joiner}', "");
    Expect(1, 69760, '\P{Is_Indic_Syllabic_Category=--Number_Joiner}', "");
    Expect(0, 69760, '\P{^Is_Indic_Syllabic_Category=--Number_Joiner}', "");
    Error('\p{Is_InSC=	-Number_joiner:=}');
    Error('\P{Is_InSC=	-Number_joiner:=}');
    Expect(1, 69759, '\p{Is_InSC=numberjoiner}', "");
    Expect(0, 69759, '\p{^Is_InSC=numberjoiner}', "");
    Expect(0, 69759, '\P{Is_InSC=numberjoiner}', "");
    Expect(1, 69759, '\P{^Is_InSC=numberjoiner}', "");
    Expect(0, 69760, '\p{Is_InSC=numberjoiner}', "");
    Expect(1, 69760, '\p{^Is_InSC=numberjoiner}', "");
    Expect(1, 69760, '\P{Is_InSC=numberjoiner}', "");
    Expect(0, 69760, '\P{^Is_InSC=numberjoiner}', "");
    Expect(1, 69759, '\p{Is_InSC=		Number_Joiner}', "");
    Expect(0, 69759, '\p{^Is_InSC=		Number_Joiner}', "");
    Expect(0, 69759, '\P{Is_InSC=		Number_Joiner}', "");
    Expect(1, 69759, '\P{^Is_InSC=		Number_Joiner}', "");
    Expect(0, 69760, '\p{Is_InSC=		Number_Joiner}', "");
    Expect(1, 69760, '\p{^Is_InSC=		Number_Joiner}', "");
    Expect(1, 69760, '\P{Is_InSC=		Number_Joiner}', "");
    Expect(0, 69760, '\P{^Is_InSC=		Number_Joiner}', "");
    Error('\p{Indic_Syllabic_Category= /a/Other}');
    Error('\P{Indic_Syllabic_Category= /a/Other}');
    Expect(1, 73463, '\p{Indic_Syllabic_Category=:\AOther\z:}', "");;
    Expect(0, 73462, '\p{Indic_Syllabic_Category=:\AOther\z:}', "");;
    Expect(1, 73463, '\p{Indic_Syllabic_Category=other}', "");
    Expect(0, 73463, '\p{^Indic_Syllabic_Category=other}', "");
    Expect(0, 73463, '\P{Indic_Syllabic_Category=other}', "");
    Expect(1, 73463, '\P{^Indic_Syllabic_Category=other}', "");
    Expect(0, 73462, '\p{Indic_Syllabic_Category=other}', "");
    Expect(1, 73462, '\p{^Indic_Syllabic_Category=other}', "");
    Expect(1, 73462, '\P{Indic_Syllabic_Category=other}', "");
    Expect(0, 73462, '\P{^Indic_Syllabic_Category=other}', "");
    Expect(1, 73463, '\p{Indic_Syllabic_Category=:\Aother\z:}', "");;
    Expect(0, 73462, '\p{Indic_Syllabic_Category=:\Aother\z:}', "");;
    Expect(1, 73463, '\p{Indic_Syllabic_Category= -OTHER}', "");
    Expect(0, 73463, '\p{^Indic_Syllabic_Category= -OTHER}', "");
    Expect(0, 73463, '\P{Indic_Syllabic_Category= -OTHER}', "");
    Expect(1, 73463, '\P{^Indic_Syllabic_Category= -OTHER}', "");
    Expect(0, 73462, '\p{Indic_Syllabic_Category= -OTHER}', "");
    Expect(1, 73462, '\p{^Indic_Syllabic_Category= -OTHER}', "");
    Expect(1, 73462, '\P{Indic_Syllabic_Category= -OTHER}', "");
    Expect(0, 73462, '\P{^Indic_Syllabic_Category= -OTHER}', "");
    Error('\p{InSC=/a/	OTHER}');
    Error('\P{InSC=/a/	OTHER}');
    Expect(1, 73463, '\p{InSC=:\AOther\z:}', "");;
    Expect(0, 73462, '\p{InSC=:\AOther\z:}', "");;
    Expect(1, 73463, '\p{InSC: other}', "");
    Expect(0, 73463, '\p{^InSC: other}', "");
    Expect(0, 73463, '\P{InSC: other}', "");
    Expect(1, 73463, '\P{^InSC: other}', "");
    Expect(0, 73462, '\p{InSC: other}', "");
    Expect(1, 73462, '\p{^InSC: other}', "");
    Expect(1, 73462, '\P{InSC: other}', "");
    Expect(0, 73462, '\P{^InSC: other}', "");
    Expect(1, 73463, '\p{InSC=:\Aother\z:}', "");;
    Expect(0, 73462, '\p{InSC=:\Aother\z:}', "");;
    Expect(1, 73463, '\p{InSC=_ other}', "");
    Expect(0, 73463, '\p{^InSC=_ other}', "");
    Expect(0, 73463, '\P{InSC=_ other}', "");
    Expect(1, 73463, '\P{^InSC=_ other}', "");
    Expect(0, 73462, '\p{InSC=_ other}', "");
    Expect(1, 73462, '\p{^InSC=_ other}', "");
    Expect(1, 73462, '\P{InSC=_ other}', "");
    Expect(0, 73462, '\P{^InSC=_ other}', "");
    Error('\p{Is_Indic_Syllabic_Category=/a/_-Other}');
    Error('\P{Is_Indic_Syllabic_Category=/a/_-Other}');
    Expect(1, 73463, '\p{Is_Indic_Syllabic_Category=other}', "");
    Expect(0, 73463, '\p{^Is_Indic_Syllabic_Category=other}', "");
    Expect(0, 73463, '\P{Is_Indic_Syllabic_Category=other}', "");
    Expect(1, 73463, '\P{^Is_Indic_Syllabic_Category=other}', "");
    Expect(0, 73462, '\p{Is_Indic_Syllabic_Category=other}', "");
    Expect(1, 73462, '\p{^Is_Indic_Syllabic_Category=other}', "");
    Expect(1, 73462, '\P{Is_Indic_Syllabic_Category=other}', "");
    Expect(0, 73462, '\P{^Is_Indic_Syllabic_Category=other}', "");
    Expect(1, 73463, '\p{Is_Indic_Syllabic_Category= _Other}', "");
    Expect(0, 73463, '\p{^Is_Indic_Syllabic_Category= _Other}', "");
    Expect(0, 73463, '\P{Is_Indic_Syllabic_Category= _Other}', "");
    Expect(1, 73463, '\P{^Is_Indic_Syllabic_Category= _Other}', "");
    Expect(0, 73462, '\p{Is_Indic_Syllabic_Category= _Other}', "");
    Expect(1, 73462, '\p{^Is_Indic_Syllabic_Category= _Other}', "");
    Expect(1, 73462, '\P{Is_Indic_Syllabic_Category= _Other}', "");
    Expect(0, 73462, '\P{^Is_Indic_Syllabic_Category= _Other}', "");
    Error('\p{Is_InSC=-Other/a/}');
    Error('\P{Is_InSC=-Other/a/}');
    Expect(1, 73463, '\p{Is_InSC=other}', "");
    Expect(0, 73463, '\p{^Is_InSC=other}', "");
    Expect(0, 73463, '\P{Is_InSC=other}', "");
    Expect(1, 73463, '\P{^Is_InSC=other}', "");
    Expect(0, 73462, '\p{Is_InSC=other}', "");
    Expect(1, 73462, '\p{^Is_InSC=other}', "");
    Expect(1, 73462, '\P{Is_InSC=other}', "");
    Expect(0, 73462, '\P{^Is_InSC=other}', "");
    Expect(1, 73463, '\p{Is_InSC: -	other}', "");
    Expect(0, 73463, '\p{^Is_InSC: -	other}', "");
    Expect(0, 73463, '\P{Is_InSC: -	other}', "");
    Expect(1, 73463, '\P{^Is_InSC: -	other}', "");
    Expect(0, 73462, '\p{Is_InSC: -	other}', "");
    Expect(1, 73462, '\p{^Is_InSC: -	other}', "");
    Expect(1, 73462, '\P{Is_InSC: -	other}', "");
    Expect(0, 73462, '\P{^Is_InSC: -	other}', "");
    Error('\p{Indic_Syllabic_Category=	:=pure_killer}');
    Error('\P{Indic_Syllabic_Category=	:=pure_killer}');
    Expect(1, 73028, '\p{Indic_Syllabic_Category=:\APure_Killer\z:}', "");;
    Expect(0, 73029, '\p{Indic_Syllabic_Category=:\APure_Killer\z:}', "");;
    Expect(1, 73028, '\p{Indic_Syllabic_Category:   purekiller}', "");
    Expect(0, 73028, '\p{^Indic_Syllabic_Category:   purekiller}', "");
    Expect(0, 73028, '\P{Indic_Syllabic_Category:   purekiller}', "");
    Expect(1, 73028, '\P{^Indic_Syllabic_Category:   purekiller}', "");
    Expect(0, 73029, '\p{Indic_Syllabic_Category:   purekiller}', "");
    Expect(1, 73029, '\p{^Indic_Syllabic_Category:   purekiller}', "");
    Expect(1, 73029, '\P{Indic_Syllabic_Category:   purekiller}', "");
    Expect(0, 73029, '\P{^Indic_Syllabic_Category:   purekiller}', "");
    Expect(1, 73028, '\p{Indic_Syllabic_Category=:\Apurekiller\z:}', "");;
    Expect(0, 73029, '\p{Indic_Syllabic_Category=:\Apurekiller\z:}', "");;
    Expect(1, 73028, '\p{Indic_Syllabic_Category=-	PURE_KILLER}', "");
    Expect(0, 73028, '\p{^Indic_Syllabic_Category=-	PURE_KILLER}', "");
    Expect(0, 73028, '\P{Indic_Syllabic_Category=-	PURE_KILLER}', "");
    Expect(1, 73028, '\P{^Indic_Syllabic_Category=-	PURE_KILLER}', "");
    Expect(0, 73029, '\p{Indic_Syllabic_Category=-	PURE_KILLER}', "");
    Expect(1, 73029, '\p{^Indic_Syllabic_Category=-	PURE_KILLER}', "");
    Expect(1, 73029, '\P{Indic_Syllabic_Category=-	PURE_KILLER}', "");
    Expect(0, 73029, '\P{^Indic_Syllabic_Category=-	PURE_KILLER}', "");
    Error('\p{InSC=	-pure_KILLER/a/}');
    Error('\P{InSC=	-pure_KILLER/a/}');
    Expect(1, 73028, '\p{InSC=:\APure_Killer\z:}', "");;
    Expect(0, 73029, '\p{InSC=:\APure_Killer\z:}', "");;
    Expect(1, 73028, '\p{InSC=purekiller}', "");
    Expect(0, 73028, '\p{^InSC=purekiller}', "");
    Expect(0, 73028, '\P{InSC=purekiller}', "");
    Expect(1, 73028, '\P{^InSC=purekiller}', "");
    Expect(0, 73029, '\p{InSC=purekiller}', "");
    Expect(1, 73029, '\p{^InSC=purekiller}', "");
    Expect(1, 73029, '\P{InSC=purekiller}', "");
    Expect(0, 73029, '\P{^InSC=purekiller}', "");
    Expect(1, 73028, '\p{InSC=:\Apurekiller\z:}', "");;
    Expect(0, 73029, '\p{InSC=:\Apurekiller\z:}', "");;
    Expect(1, 73028, '\p{InSC=  Pure_Killer}', "");
    Expect(0, 73028, '\p{^InSC=  Pure_Killer}', "");
    Expect(0, 73028, '\P{InSC=  Pure_Killer}', "");
    Expect(1, 73028, '\P{^InSC=  Pure_Killer}', "");
    Expect(0, 73029, '\p{InSC=  Pure_Killer}', "");
    Expect(1, 73029, '\p{^InSC=  Pure_Killer}', "");
    Expect(1, 73029, '\P{InSC=  Pure_Killer}', "");
    Expect(0, 73029, '\P{^InSC=  Pure_Killer}', "");
    Error('\p{Is_Indic_Syllabic_Category=_:=pure_killer}');
    Error('\P{Is_Indic_Syllabic_Category=_:=pure_killer}');
    Expect(1, 73028, '\p{Is_Indic_Syllabic_Category=purekiller}', "");
    Expect(0, 73028, '\p{^Is_Indic_Syllabic_Category=purekiller}', "");
    Expect(0, 73028, '\P{Is_Indic_Syllabic_Category=purekiller}', "");
    Expect(1, 73028, '\P{^Is_Indic_Syllabic_Category=purekiller}', "");
    Expect(0, 73029, '\p{Is_Indic_Syllabic_Category=purekiller}', "");
    Expect(1, 73029, '\p{^Is_Indic_Syllabic_Category=purekiller}', "");
    Expect(1, 73029, '\P{Is_Indic_Syllabic_Category=purekiller}', "");
    Expect(0, 73029, '\P{^Is_Indic_Syllabic_Category=purekiller}', "");
    Expect(1, 73028, '\p{Is_Indic_Syllabic_Category= PURE_killer}', "");
    Expect(0, 73028, '\p{^Is_Indic_Syllabic_Category= PURE_killer}', "");
    Expect(0, 73028, '\P{Is_Indic_Syllabic_Category= PURE_killer}', "");
    Expect(1, 73028, '\P{^Is_Indic_Syllabic_Category= PURE_killer}', "");
    Expect(0, 73029, '\p{Is_Indic_Syllabic_Category= PURE_killer}', "");
    Expect(1, 73029, '\p{^Is_Indic_Syllabic_Category= PURE_killer}', "");
    Expect(1, 73029, '\P{Is_Indic_Syllabic_Category= PURE_killer}', "");
    Expect(0, 73029, '\P{^Is_Indic_Syllabic_Category= PURE_killer}', "");
    Error('\p{Is_InSC=/a/ 	pure_killer}');
    Error('\P{Is_InSC=/a/ 	pure_killer}');
    Expect(1, 73028, '\p{Is_InSC=purekiller}', "");
    Expect(0, 73028, '\p{^Is_InSC=purekiller}', "");
    Expect(0, 73028, '\P{Is_InSC=purekiller}', "");
    Expect(1, 73028, '\P{^Is_InSC=purekiller}', "");
    Expect(0, 73029, '\p{Is_InSC=purekiller}', "");
    Expect(1, 73029, '\p{^Is_InSC=purekiller}', "");
    Expect(1, 73029, '\P{Is_InSC=purekiller}', "");
    Expect(0, 73029, '\P{^Is_InSC=purekiller}', "");
    Expect(1, 73028, '\p{Is_InSC=-Pure_Killer}', "");
    Expect(0, 73028, '\p{^Is_InSC=-Pure_Killer}', "");
    Expect(0, 73028, '\P{Is_InSC=-Pure_Killer}', "");
    Expect(1, 73028, '\P{^Is_InSC=-Pure_Killer}', "");
    Expect(0, 73029, '\p{Is_InSC=-Pure_Killer}', "");
    Expect(1, 73029, '\p{^Is_InSC=-Pure_Killer}', "");
    Expect(1, 73029, '\P{Is_InSC=-Pure_Killer}', "");
    Expect(0, 73029, '\P{^Is_InSC=-Pure_Killer}', "");
    Error('\p{Indic_Syllabic_Category=/a/-_REGISTER_Shifter}');
    Error('\P{Indic_Syllabic_Category=/a/-_REGISTER_Shifter}');
    Expect(1, 6090, '\p{Indic_Syllabic_Category=:\ARegister_Shifter\z:}', "");;
    Expect(0, 6091, '\p{Indic_Syllabic_Category=:\ARegister_Shifter\z:}', "");;
    Expect(1, 6090, '\p{Indic_Syllabic_Category=registershifter}', "");
    Expect(0, 6090, '\p{^Indic_Syllabic_Category=registershifter}', "");
    Expect(0, 6090, '\P{Indic_Syllabic_Category=registershifter}', "");
    Expect(1, 6090, '\P{^Indic_Syllabic_Category=registershifter}', "");
    Expect(0, 6091, '\p{Indic_Syllabic_Category=registershifter}', "");
    Expect(1, 6091, '\p{^Indic_Syllabic_Category=registershifter}', "");
    Expect(1, 6091, '\P{Indic_Syllabic_Category=registershifter}', "");
    Expect(0, 6091, '\P{^Indic_Syllabic_Category=registershifter}', "");
    Expect(1, 6090, '\p{Indic_Syllabic_Category=:\Aregistershifter\z:}', "");;
    Expect(0, 6091, '\p{Indic_Syllabic_Category=:\Aregistershifter\z:}', "");;
    Expect(1, 6090, '\p{Indic_Syllabic_Category=-REGISTER_shifter}', "");
    Expect(0, 6090, '\p{^Indic_Syllabic_Category=-REGISTER_shifter}', "");
    Expect(0, 6090, '\P{Indic_Syllabic_Category=-REGISTER_shifter}', "");
    Expect(1, 6090, '\P{^Indic_Syllabic_Category=-REGISTER_shifter}', "");
    Expect(0, 6091, '\p{Indic_Syllabic_Category=-REGISTER_shifter}', "");
    Expect(1, 6091, '\p{^Indic_Syllabic_Category=-REGISTER_shifter}', "");
    Expect(1, 6091, '\P{Indic_Syllabic_Category=-REGISTER_shifter}', "");
    Expect(0, 6091, '\P{^Indic_Syllabic_Category=-REGISTER_shifter}', "");
    Error('\p{InSC= :=REGISTER_shifter}');
    Error('\P{InSC= :=REGISTER_shifter}');
    Expect(1, 6090, '\p{InSC=:\ARegister_Shifter\z:}', "");;
    Expect(0, 6091, '\p{InSC=:\ARegister_Shifter\z:}', "");;
    Expect(1, 6090, '\p{InSC=registershifter}', "");
    Expect(0, 6090, '\p{^InSC=registershifter}', "");
    Expect(0, 6090, '\P{InSC=registershifter}', "");
    Expect(1, 6090, '\P{^InSC=registershifter}', "");
    Expect(0, 6091, '\p{InSC=registershifter}', "");
    Expect(1, 6091, '\p{^InSC=registershifter}', "");
    Expect(1, 6091, '\P{InSC=registershifter}', "");
    Expect(0, 6091, '\P{^InSC=registershifter}', "");
    Expect(1, 6090, '\p{InSC=:\Aregistershifter\z:}', "");;
    Expect(0, 6091, '\p{InSC=:\Aregistershifter\z:}', "");;
    Expect(1, 6090, '\p{InSC=	_Register_Shifter}', "");
    Expect(0, 6090, '\p{^InSC=	_Register_Shifter}', "");
    Expect(0, 6090, '\P{InSC=	_Register_Shifter}', "");
    Expect(1, 6090, '\P{^InSC=	_Register_Shifter}', "");
    Expect(0, 6091, '\p{InSC=	_Register_Shifter}', "");
    Expect(1, 6091, '\p{^InSC=	_Register_Shifter}', "");
    Expect(1, 6091, '\P{InSC=	_Register_Shifter}', "");
    Expect(0, 6091, '\P{^InSC=	_Register_Shifter}', "");
    Error('\p{Is_Indic_Syllabic_Category=--register_shifter:=}');
    Error('\P{Is_Indic_Syllabic_Category=--register_shifter:=}');
    Expect(1, 6090, '\p{Is_Indic_Syllabic_Category=registershifter}', "");
    Expect(0, 6090, '\p{^Is_Indic_Syllabic_Category=registershifter}', "");
    Expect(0, 6090, '\P{Is_Indic_Syllabic_Category=registershifter}', "");
    Expect(1, 6090, '\P{^Is_Indic_Syllabic_Category=registershifter}', "");
    Expect(0, 6091, '\p{Is_Indic_Syllabic_Category=registershifter}', "");
    Expect(1, 6091, '\p{^Is_Indic_Syllabic_Category=registershifter}', "");
    Expect(1, 6091, '\P{Is_Indic_Syllabic_Category=registershifter}', "");
    Expect(0, 6091, '\P{^Is_Indic_Syllabic_Category=registershifter}', "");
    Expect(1, 6090, '\p{Is_Indic_Syllabic_Category= Register_shifter}', "");
    Expect(0, 6090, '\p{^Is_Indic_Syllabic_Category= Register_shifter}', "");
    Expect(0, 6090, '\P{Is_Indic_Syllabic_Category= Register_shifter}', "");
    Expect(1, 6090, '\P{^Is_Indic_Syllabic_Category= Register_shifter}', "");
    Expect(0, 6091, '\p{Is_Indic_Syllabic_Category= Register_shifter}', "");
    Expect(1, 6091, '\p{^Is_Indic_Syllabic_Category= Register_shifter}', "");
    Expect(1, 6091, '\P{Is_Indic_Syllabic_Category= Register_shifter}', "");
    Expect(0, 6091, '\P{^Is_Indic_Syllabic_Category= Register_shifter}', "");
    Error('\p{Is_InSC=/a/_	REGISTER_SHIFTER}');
    Error('\P{Is_InSC=/a/_	REGISTER_SHIFTER}');
    Expect(1, 6090, '\p{Is_InSC: registershifter}', "");
    Expect(0, 6090, '\p{^Is_InSC: registershifter}', "");
    Expect(0, 6090, '\P{Is_InSC: registershifter}', "");
    Expect(1, 6090, '\P{^Is_InSC: registershifter}', "");
    Expect(0, 6091, '\p{Is_InSC: registershifter}', "");
    Expect(1, 6091, '\p{^Is_InSC: registershifter}', "");
    Expect(1, 6091, '\P{Is_InSC: registershifter}', "");
    Expect(0, 6091, '\P{^Is_InSC: registershifter}', "");
    Expect(1, 6090, '\p{Is_InSC:	- REGISTER_Shifter}', "");
    Expect(0, 6090, '\p{^Is_InSC:	- REGISTER_Shifter}', "");
    Expect(0, 6090, '\P{Is_InSC:	- REGISTER_Shifter}', "");
    Expect(1, 6090, '\P{^Is_InSC:	- REGISTER_Shifter}', "");
    Expect(0, 6091, '\p{Is_InSC:	- REGISTER_Shifter}', "");
    Expect(1, 6091, '\p{^Is_InSC:	- REGISTER_Shifter}', "");
    Expect(1, 6091, '\P{Is_InSC:	- REGISTER_Shifter}', "");
    Expect(0, 6091, '\P{^Is_InSC:	- REGISTER_Shifter}', "");
    Error('\p{Indic_Syllabic_Category=- Syllable_MODIFIER:=}');
    Error('\P{Indic_Syllabic_Category=- Syllable_MODIFIER:=}');
    Expect(1, 72243, '\p{Indic_Syllabic_Category=:\ASyllable_Modifier\z:}', "");;
    Expect(0, 72244, '\p{Indic_Syllabic_Category=:\ASyllable_Modifier\z:}', "");;
    Expect(1, 72243, '\p{Indic_Syllabic_Category=syllablemodifier}', "");
    Expect(0, 72243, '\p{^Indic_Syllabic_Category=syllablemodifier}', "");
    Expect(0, 72243, '\P{Indic_Syllabic_Category=syllablemodifier}', "");
    Expect(1, 72243, '\P{^Indic_Syllabic_Category=syllablemodifier}', "");
    Expect(0, 72244, '\p{Indic_Syllabic_Category=syllablemodifier}', "");
    Expect(1, 72244, '\p{^Indic_Syllabic_Category=syllablemodifier}', "");
    Expect(1, 72244, '\P{Indic_Syllabic_Category=syllablemodifier}', "");
    Expect(0, 72244, '\P{^Indic_Syllabic_Category=syllablemodifier}', "");
    Expect(1, 72243, '\p{Indic_Syllabic_Category=:\Asyllablemodifier\z:}', "");;
    Expect(0, 72244, '\p{Indic_Syllabic_Category=:\Asyllablemodifier\z:}', "");;
    Expect(1, 72243, '\p{Indic_Syllabic_Category= syllable_Modifier}', "");
    Expect(0, 72243, '\p{^Indic_Syllabic_Category= syllable_Modifier}', "");
    Expect(0, 72243, '\P{Indic_Syllabic_Category= syllable_Modifier}', "");
    Expect(1, 72243, '\P{^Indic_Syllabic_Category= syllable_Modifier}', "");
    Expect(0, 72244, '\p{Indic_Syllabic_Category= syllable_Modifier}', "");
    Expect(1, 72244, '\p{^Indic_Syllabic_Category= syllable_Modifier}', "");
    Expect(1, 72244, '\P{Indic_Syllabic_Category= syllable_Modifier}', "");
    Expect(0, 72244, '\P{^Indic_Syllabic_Category= syllable_Modifier}', "");
    Error('\p{InSC:   		Syllable_Modifier/a/}');
    Error('\P{InSC:   		Syllable_Modifier/a/}');
    Expect(1, 72243, '\p{InSC=:\ASyllable_Modifier\z:}', "");;
    Expect(0, 72244, '\p{InSC=:\ASyllable_Modifier\z:}', "");;
    Expect(1, 72243, '\p{InSC=syllablemodifier}', "");
    Expect(0, 72243, '\p{^InSC=syllablemodifier}', "");
    Expect(0, 72243, '\P{InSC=syllablemodifier}', "");
    Expect(1, 72243, '\P{^InSC=syllablemodifier}', "");
    Expect(0, 72244, '\p{InSC=syllablemodifier}', "");
    Expect(1, 72244, '\p{^InSC=syllablemodifier}', "");
    Expect(1, 72244, '\P{InSC=syllablemodifier}', "");
    Expect(0, 72244, '\P{^InSC=syllablemodifier}', "");
    Expect(1, 72243, '\p{InSC=:\Asyllablemodifier\z:}', "");;
    Expect(0, 72244, '\p{InSC=:\Asyllablemodifier\z:}', "");;
    Expect(1, 72243, '\p{InSC:    -Syllable_Modifier}', "");
    Expect(0, 72243, '\p{^InSC:    -Syllable_Modifier}', "");
    Expect(0, 72243, '\P{InSC:    -Syllable_Modifier}', "");
    Expect(1, 72243, '\P{^InSC:    -Syllable_Modifier}', "");
    Expect(0, 72244, '\p{InSC:    -Syllable_Modifier}', "");
    Expect(1, 72244, '\p{^InSC:    -Syllable_Modifier}', "");
    Expect(1, 72244, '\P{InSC:    -Syllable_Modifier}', "");
    Expect(0, 72244, '\P{^InSC:    -Syllable_Modifier}', "");
    Error('\p{Is_Indic_Syllabic_Category=	:=Syllable_modifier}');
    Error('\P{Is_Indic_Syllabic_Category=	:=Syllable_modifier}');
    Expect(1, 72243, '\p{Is_Indic_Syllabic_Category=syllablemodifier}', "");
    Expect(0, 72243, '\p{^Is_Indic_Syllabic_Category=syllablemodifier}', "");
    Expect(0, 72243, '\P{Is_Indic_Syllabic_Category=syllablemodifier}', "");
    Expect(1, 72243, '\P{^Is_Indic_Syllabic_Category=syllablemodifier}', "");
    Expect(0, 72244, '\p{Is_Indic_Syllabic_Category=syllablemodifier}', "");
    Expect(1, 72244, '\p{^Is_Indic_Syllabic_Category=syllablemodifier}', "");
    Expect(1, 72244, '\P{Is_Indic_Syllabic_Category=syllablemodifier}', "");
    Expect(0, 72244, '\P{^Is_Indic_Syllabic_Category=syllablemodifier}', "");
    Expect(1, 72243, '\p{Is_Indic_Syllabic_Category:   -syllable_Modifier}', "");
    Expect(0, 72243, '\p{^Is_Indic_Syllabic_Category:   -syllable_Modifier}', "");
    Expect(0, 72243, '\P{Is_Indic_Syllabic_Category:   -syllable_Modifier}', "");
    Expect(1, 72243, '\P{^Is_Indic_Syllabic_Category:   -syllable_Modifier}', "");
    Expect(0, 72244, '\p{Is_Indic_Syllabic_Category:   -syllable_Modifier}', "");
    Expect(1, 72244, '\p{^Is_Indic_Syllabic_Category:   -syllable_Modifier}', "");
    Expect(1, 72244, '\P{Is_Indic_Syllabic_Category:   -syllable_Modifier}', "");
    Expect(0, 72244, '\P{^Is_Indic_Syllabic_Category:   -syllable_Modifier}', "");
    Error('\p{Is_InSC=-	SYLLABLE_Modifier:=}');
    Error('\P{Is_InSC=-	SYLLABLE_Modifier:=}');
    Expect(1, 72243, '\p{Is_InSC:syllablemodifier}', "");
    Expect(0, 72243, '\p{^Is_InSC:syllablemodifier}', "");
    Expect(0, 72243, '\P{Is_InSC:syllablemodifier}', "");
    Expect(1, 72243, '\P{^Is_InSC:syllablemodifier}', "");
    Expect(0, 72244, '\p{Is_InSC:syllablemodifier}', "");
    Expect(1, 72244, '\p{^Is_InSC:syllablemodifier}', "");
    Expect(1, 72244, '\P{Is_InSC:syllablemodifier}', "");
    Expect(0, 72244, '\P{^Is_InSC:syllablemodifier}', "");
    Expect(1, 72243, '\p{Is_InSC:	_-syllable_Modifier}', "");
    Expect(0, 72243, '\p{^Is_InSC:	_-syllable_Modifier}', "");
    Expect(0, 72243, '\P{Is_InSC:	_-syllable_Modifier}', "");
    Expect(1, 72243, '\P{^Is_InSC:	_-syllable_Modifier}', "");
    Expect(0, 72244, '\p{Is_InSC:	_-syllable_Modifier}', "");
    Expect(1, 72244, '\p{^Is_InSC:	_-syllable_Modifier}', "");
    Expect(1, 72244, '\P{Is_InSC:	_-syllable_Modifier}', "");
    Expect(0, 72244, '\P{^Is_InSC:	_-syllable_Modifier}', "");
    Error('\p{Indic_Syllabic_Category=:=_Tone_Letter}');
    Error('\P{Indic_Syllabic_Category=:=_Tone_Letter}');
    Expect(1, 43714, '\p{Indic_Syllabic_Category=:\ATone_Letter\z:}', "");;
    Expect(0, 43715, '\p{Indic_Syllabic_Category=:\ATone_Letter\z:}', "");;
    Expect(1, 43714, '\p{Indic_Syllabic_Category=toneletter}', "");
    Expect(0, 43714, '\p{^Indic_Syllabic_Category=toneletter}', "");
    Expect(0, 43714, '\P{Indic_Syllabic_Category=toneletter}', "");
    Expect(1, 43714, '\P{^Indic_Syllabic_Category=toneletter}', "");
    Expect(0, 43715, '\p{Indic_Syllabic_Category=toneletter}', "");
    Expect(1, 43715, '\p{^Indic_Syllabic_Category=toneletter}', "");
    Expect(1, 43715, '\P{Indic_Syllabic_Category=toneletter}', "");
    Expect(0, 43715, '\P{^Indic_Syllabic_Category=toneletter}', "");
    Expect(1, 43714, '\p{Indic_Syllabic_Category=:\Atoneletter\z:}', "");;
    Expect(0, 43715, '\p{Indic_Syllabic_Category=:\Atoneletter\z:}', "");;
    Expect(1, 43714, '\p{Indic_Syllabic_Category=		Tone_Letter}', "");
    Expect(0, 43714, '\p{^Indic_Syllabic_Category=		Tone_Letter}', "");
    Expect(0, 43714, '\P{Indic_Syllabic_Category=		Tone_Letter}', "");
    Expect(1, 43714, '\P{^Indic_Syllabic_Category=		Tone_Letter}', "");
    Expect(0, 43715, '\p{Indic_Syllabic_Category=		Tone_Letter}', "");
    Expect(1, 43715, '\p{^Indic_Syllabic_Category=		Tone_Letter}', "");
    Expect(1, 43715, '\P{Indic_Syllabic_Category=		Tone_Letter}', "");
    Expect(0, 43715, '\P{^Indic_Syllabic_Category=		Tone_Letter}', "");
    Error('\p{InSC:/a/_-Tone_letter}');
    Error('\P{InSC:/a/_-Tone_letter}');
    Expect(1, 43714, '\p{InSC=:\ATone_Letter\z:}', "");;
    Expect(0, 43715, '\p{InSC=:\ATone_Letter\z:}', "");;
    Expect(1, 43714, '\p{InSC=toneletter}', "");
    Expect(0, 43714, '\p{^InSC=toneletter}', "");
    Expect(0, 43714, '\P{InSC=toneletter}', "");
    Expect(1, 43714, '\P{^InSC=toneletter}', "");
    Expect(0, 43715, '\p{InSC=toneletter}', "");
    Expect(1, 43715, '\p{^InSC=toneletter}', "");
    Expect(1, 43715, '\P{InSC=toneletter}', "");
    Expect(0, 43715, '\P{^InSC=toneletter}', "");
    Expect(1, 43714, '\p{InSC=:\Atoneletter\z:}', "");;
    Expect(0, 43715, '\p{InSC=:\Atoneletter\z:}', "");;
    Expect(1, 43714, '\p{InSC=_ TONE_letter}', "");
    Expect(0, 43714, '\p{^InSC=_ TONE_letter}', "");
    Expect(0, 43714, '\P{InSC=_ TONE_letter}', "");
    Expect(1, 43714, '\P{^InSC=_ TONE_letter}', "");
    Expect(0, 43715, '\p{InSC=_ TONE_letter}', "");
    Expect(1, 43715, '\p{^InSC=_ TONE_letter}', "");
    Expect(1, 43715, '\P{InSC=_ TONE_letter}', "");
    Expect(0, 43715, '\P{^InSC=_ TONE_letter}', "");
    Error('\p{Is_Indic_Syllabic_Category=-/a/Tone_letter}');
    Error('\P{Is_Indic_Syllabic_Category=-/a/Tone_letter}');
    Expect(1, 43714, '\p{Is_Indic_Syllabic_Category=toneletter}', "");
    Expect(0, 43714, '\p{^Is_Indic_Syllabic_Category=toneletter}', "");
    Expect(0, 43714, '\P{Is_Indic_Syllabic_Category=toneletter}', "");
    Expect(1, 43714, '\P{^Is_Indic_Syllabic_Category=toneletter}', "");
    Expect(0, 43715, '\p{Is_Indic_Syllabic_Category=toneletter}', "");
    Expect(1, 43715, '\p{^Is_Indic_Syllabic_Category=toneletter}', "");
    Expect(1, 43715, '\P{Is_Indic_Syllabic_Category=toneletter}', "");
    Expect(0, 43715, '\P{^Is_Indic_Syllabic_Category=toneletter}', "");
    Expect(1, 43714, '\p{Is_Indic_Syllabic_Category=	_Tone_Letter}', "");
    Expect(0, 43714, '\p{^Is_Indic_Syllabic_Category=	_Tone_Letter}', "");
    Expect(0, 43714, '\P{Is_Indic_Syllabic_Category=	_Tone_Letter}', "");
    Expect(1, 43714, '\P{^Is_Indic_Syllabic_Category=	_Tone_Letter}', "");
    Expect(0, 43715, '\p{Is_Indic_Syllabic_Category=	_Tone_Letter}', "");
    Expect(1, 43715, '\p{^Is_Indic_Syllabic_Category=	_Tone_Letter}', "");
    Expect(1, 43715, '\P{Is_Indic_Syllabic_Category=	_Tone_Letter}', "");
    Expect(0, 43715, '\P{^Is_Indic_Syllabic_Category=	_Tone_Letter}', "");
    Error('\p{Is_InSC=_ TONE_Letter:=}');
    Error('\P{Is_InSC=_ TONE_Letter:=}');
    Expect(1, 43714, '\p{Is_InSC=toneletter}', "");
    Expect(0, 43714, '\p{^Is_InSC=toneletter}', "");
    Expect(0, 43714, '\P{Is_InSC=toneletter}', "");
    Expect(1, 43714, '\P{^Is_InSC=toneletter}', "");
    Expect(0, 43715, '\p{Is_InSC=toneletter}', "");
    Expect(1, 43715, '\p{^Is_InSC=toneletter}', "");
    Expect(1, 43715, '\P{Is_InSC=toneletter}', "");
    Expect(0, 43715, '\P{^Is_InSC=toneletter}', "");
    Expect(1, 43714, '\p{Is_InSC=_	Tone_Letter}', "");
    Expect(0, 43714, '\p{^Is_InSC=_	Tone_Letter}', "");
    Expect(0, 43714, '\P{Is_InSC=_	Tone_Letter}', "");
    Expect(1, 43714, '\P{^Is_InSC=_	Tone_Letter}', "");
    Expect(0, 43715, '\p{Is_InSC=_	Tone_Letter}', "");
    Expect(1, 43715, '\p{^Is_InSC=_	Tone_Letter}', "");
    Expect(1, 43715, '\P{Is_InSC=_	Tone_Letter}', "");
    Expect(0, 43715, '\P{^Is_InSC=_	Tone_Letter}', "");
    Error('\p{Indic_Syllabic_Category=_:=Tone_Mark}');
    Error('\P{Indic_Syllabic_Category=_:=Tone_Mark}');
    Expect(1, 44012, '\p{Indic_Syllabic_Category=:\ATone_Mark\z:}', "");;
    Expect(0, 44013, '\p{Indic_Syllabic_Category=:\ATone_Mark\z:}', "");;
    Expect(1, 44012, '\p{Indic_Syllabic_Category=tonemark}', "");
    Expect(0, 44012, '\p{^Indic_Syllabic_Category=tonemark}', "");
    Expect(0, 44012, '\P{Indic_Syllabic_Category=tonemark}', "");
    Expect(1, 44012, '\P{^Indic_Syllabic_Category=tonemark}', "");
    Expect(0, 44013, '\p{Indic_Syllabic_Category=tonemark}', "");
    Expect(1, 44013, '\p{^Indic_Syllabic_Category=tonemark}', "");
    Expect(1, 44013, '\P{Indic_Syllabic_Category=tonemark}', "");
    Expect(0, 44013, '\P{^Indic_Syllabic_Category=tonemark}', "");
    Expect(1, 44012, '\p{Indic_Syllabic_Category=:\Atonemark\z:}', "");;
    Expect(0, 44013, '\p{Indic_Syllabic_Category=:\Atonemark\z:}', "");;
    Expect(1, 44012, '\p{Indic_Syllabic_Category: -tone_MARK}', "");
    Expect(0, 44012, '\p{^Indic_Syllabic_Category: -tone_MARK}', "");
    Expect(0, 44012, '\P{Indic_Syllabic_Category: -tone_MARK}', "");
    Expect(1, 44012, '\P{^Indic_Syllabic_Category: -tone_MARK}', "");
    Expect(0, 44013, '\p{Indic_Syllabic_Category: -tone_MARK}', "");
    Expect(1, 44013, '\p{^Indic_Syllabic_Category: -tone_MARK}', "");
    Expect(1, 44013, '\P{Indic_Syllabic_Category: -tone_MARK}', "");
    Expect(0, 44013, '\P{^Indic_Syllabic_Category: -tone_MARK}', "");
    Error('\p{InSC:	_ tone_mark/a/}');
    Error('\P{InSC:	_ tone_mark/a/}');
    Expect(1, 44012, '\p{InSC=:\ATone_Mark\z:}', "");;
    Expect(0, 44013, '\p{InSC=:\ATone_Mark\z:}', "");;
    Expect(1, 44012, '\p{InSC:	tonemark}', "");
    Expect(0, 44012, '\p{^InSC:	tonemark}', "");
    Expect(0, 44012, '\P{InSC:	tonemark}', "");
    Expect(1, 44012, '\P{^InSC:	tonemark}', "");
    Expect(0, 44013, '\p{InSC:	tonemark}', "");
    Expect(1, 44013, '\p{^InSC:	tonemark}', "");
    Expect(1, 44013, '\P{InSC:	tonemark}', "");
    Expect(0, 44013, '\P{^InSC:	tonemark}', "");
    Expect(1, 44012, '\p{InSC=:\Atonemark\z:}', "");;
    Expect(0, 44013, '\p{InSC=:\Atonemark\z:}', "");;
    Expect(1, 44012, '\p{InSC=tone_Mark}', "");
    Expect(0, 44012, '\p{^InSC=tone_Mark}', "");
    Expect(0, 44012, '\P{InSC=tone_Mark}', "");
    Expect(1, 44012, '\P{^InSC=tone_Mark}', "");
    Expect(0, 44013, '\p{InSC=tone_Mark}', "");
    Expect(1, 44013, '\p{^InSC=tone_Mark}', "");
    Expect(1, 44013, '\P{InSC=tone_Mark}', "");
    Expect(0, 44013, '\P{^InSC=tone_Mark}', "");
    Error('\p{Is_Indic_Syllabic_Category: :=	Tone_Mark}');
    Error('\P{Is_Indic_Syllabic_Category: :=	Tone_Mark}');
    Expect(1, 44012, '\p{Is_Indic_Syllabic_Category=tonemark}', "");
    Expect(0, 44012, '\p{^Is_Indic_Syllabic_Category=tonemark}', "");
    Expect(0, 44012, '\P{Is_Indic_Syllabic_Category=tonemark}', "");
    Expect(1, 44012, '\P{^Is_Indic_Syllabic_Category=tonemark}', "");
    Expect(0, 44013, '\p{Is_Indic_Syllabic_Category=tonemark}', "");
    Expect(1, 44013, '\p{^Is_Indic_Syllabic_Category=tonemark}', "");
    Expect(1, 44013, '\P{Is_Indic_Syllabic_Category=tonemark}', "");
    Expect(0, 44013, '\P{^Is_Indic_Syllabic_Category=tonemark}', "");
    Expect(1, 44012, '\p{Is_Indic_Syllabic_Category=- Tone_Mark}', "");
    Expect(0, 44012, '\p{^Is_Indic_Syllabic_Category=- Tone_Mark}', "");
    Expect(0, 44012, '\P{Is_Indic_Syllabic_Category=- Tone_Mark}', "");
    Expect(1, 44012, '\P{^Is_Indic_Syllabic_Category=- Tone_Mark}', "");
    Expect(0, 44013, '\p{Is_Indic_Syllabic_Category=- Tone_Mark}', "");
    Expect(1, 44013, '\p{^Is_Indic_Syllabic_Category=- Tone_Mark}', "");
    Expect(1, 44013, '\P{Is_Indic_Syllabic_Category=- Tone_Mark}', "");
    Expect(0, 44013, '\P{^Is_Indic_Syllabic_Category=- Tone_Mark}', "");
    Error('\p{Is_InSC=/a/ tone_Mark}');
    Error('\P{Is_InSC=/a/ tone_Mark}');
    Expect(1, 44012, '\p{Is_InSC=tonemark}', "");
    Expect(0, 44012, '\p{^Is_InSC=tonemark}', "");
    Expect(0, 44012, '\P{Is_InSC=tonemark}', "");
    Expect(1, 44012, '\P{^Is_InSC=tonemark}', "");
    Expect(0, 44013, '\p{Is_InSC=tonemark}', "");
    Expect(1, 44013, '\p{^Is_InSC=tonemark}', "");
    Expect(1, 44013, '\P{Is_InSC=tonemark}', "");
    Expect(0, 44013, '\P{^Is_InSC=tonemark}', "");
    Expect(1, 44012, '\p{Is_InSC=__TONE_mark}', "");
    Expect(0, 44012, '\p{^Is_InSC=__TONE_mark}', "");
    Expect(0, 44012, '\P{Is_InSC=__TONE_mark}', "");
    Expect(1, 44012, '\P{^Is_InSC=__TONE_mark}', "");
    Expect(0, 44013, '\p{Is_InSC=__TONE_mark}', "");
    Expect(1, 44013, '\p{^Is_InSC=__TONE_mark}', "");
    Expect(1, 44013, '\P{Is_InSC=__TONE_mark}', "");
    Expect(0, 44013, '\P{^Is_InSC=__TONE_mark}', "");
    Error('\p{Indic_Syllabic_Category=-:=Virama}');
    Error('\P{Indic_Syllabic_Category=-:=Virama}');
    Expect(1, 72767, '\p{Indic_Syllabic_Category=:\AVirama\z:}', "");;
    Expect(0, 72768, '\p{Indic_Syllabic_Category=:\AVirama\z:}', "");;
    Expect(1, 72767, '\p{Indic_Syllabic_Category:	virama}', "");
    Expect(0, 72767, '\p{^Indic_Syllabic_Category:	virama}', "");
    Expect(0, 72767, '\P{Indic_Syllabic_Category:	virama}', "");
    Expect(1, 72767, '\P{^Indic_Syllabic_Category:	virama}', "");
    Expect(0, 72768, '\p{Indic_Syllabic_Category:	virama}', "");
    Expect(1, 72768, '\p{^Indic_Syllabic_Category:	virama}', "");
    Expect(1, 72768, '\P{Indic_Syllabic_Category:	virama}', "");
    Expect(0, 72768, '\P{^Indic_Syllabic_Category:	virama}', "");
    Expect(1, 72767, '\p{Indic_Syllabic_Category=:\Avirama\z:}', "");;
    Expect(0, 72768, '\p{Indic_Syllabic_Category=:\Avirama\z:}', "");;
    Expect(1, 72767, '\p{Indic_Syllabic_Category:		VIRAMA}', "");
    Expect(0, 72767, '\p{^Indic_Syllabic_Category:		VIRAMA}', "");
    Expect(0, 72767, '\P{Indic_Syllabic_Category:		VIRAMA}', "");
    Expect(1, 72767, '\P{^Indic_Syllabic_Category:		VIRAMA}', "");
    Expect(0, 72768, '\p{Indic_Syllabic_Category:		VIRAMA}', "");
    Expect(1, 72768, '\p{^Indic_Syllabic_Category:		VIRAMA}', "");
    Expect(1, 72768, '\P{Indic_Syllabic_Category:		VIRAMA}', "");
    Expect(0, 72768, '\P{^Indic_Syllabic_Category:		VIRAMA}', "");
    Error('\p{InSC=	Virama:=}');
    Error('\P{InSC=	Virama:=}');
    Expect(1, 72767, '\p{InSC=:\AVirama\z:}', "");;
    Expect(0, 72768, '\p{InSC=:\AVirama\z:}', "");;
    Expect(1, 72767, '\p{InSC=virama}', "");
    Expect(0, 72767, '\p{^InSC=virama}', "");
    Expect(0, 72767, '\P{InSC=virama}', "");
    Expect(1, 72767, '\P{^InSC=virama}', "");
    Expect(0, 72768, '\p{InSC=virama}', "");
    Expect(1, 72768, '\p{^InSC=virama}', "");
    Expect(1, 72768, '\P{InSC=virama}', "");
    Expect(0, 72768, '\P{^InSC=virama}', "");
    Expect(1, 72767, '\p{InSC=:\Avirama\z:}', "");;
    Expect(0, 72768, '\p{InSC=:\Avirama\z:}', "");;
    Expect(1, 72767, '\p{InSC=	-VIRAMA}', "");
    Expect(0, 72767, '\p{^InSC=	-VIRAMA}', "");
    Expect(0, 72767, '\P{InSC=	-VIRAMA}', "");
    Expect(1, 72767, '\P{^InSC=	-VIRAMA}', "");
    Expect(0, 72768, '\p{InSC=	-VIRAMA}', "");
    Expect(1, 72768, '\p{^InSC=	-VIRAMA}', "");
    Expect(1, 72768, '\P{InSC=	-VIRAMA}', "");
    Expect(0, 72768, '\P{^InSC=	-VIRAMA}', "");
    Error('\p{Is_Indic_Syllabic_Category=- Virama/a/}');
    Error('\P{Is_Indic_Syllabic_Category=- Virama/a/}');
    Expect(1, 72767, '\p{Is_Indic_Syllabic_Category=virama}', "");
    Expect(0, 72767, '\p{^Is_Indic_Syllabic_Category=virama}', "");
    Expect(0, 72767, '\P{Is_Indic_Syllabic_Category=virama}', "");
    Expect(1, 72767, '\P{^Is_Indic_Syllabic_Category=virama}', "");
    Expect(0, 72768, '\p{Is_Indic_Syllabic_Category=virama}', "");
    Expect(1, 72768, '\p{^Is_Indic_Syllabic_Category=virama}', "");
    Expect(1, 72768, '\P{Is_Indic_Syllabic_Category=virama}', "");
    Expect(0, 72768, '\P{^Is_Indic_Syllabic_Category=virama}', "");
    Expect(1, 72767, '\p{Is_Indic_Syllabic_Category= Virama}', "");
    Expect(0, 72767, '\p{^Is_Indic_Syllabic_Category= Virama}', "");
    Expect(0, 72767, '\P{Is_Indic_Syllabic_Category= Virama}', "");
    Expect(1, 72767, '\P{^Is_Indic_Syllabic_Category= Virama}', "");
    Expect(0, 72768, '\p{Is_Indic_Syllabic_Category= Virama}', "");
    Expect(1, 72768, '\p{^Is_Indic_Syllabic_Category= Virama}', "");
    Expect(1, 72768, '\P{Is_Indic_Syllabic_Category= Virama}', "");
    Expect(0, 72768, '\P{^Is_Indic_Syllabic_Category= Virama}', "");
    Error('\p{Is_InSC=:=virama}');
    Error('\P{Is_InSC=:=virama}');
    Expect(1, 72767, '\p{Is_InSC: virama}', "");
    Expect(0, 72767, '\p{^Is_InSC: virama}', "");
    Expect(0, 72767, '\P{Is_InSC: virama}', "");
    Expect(1, 72767, '\P{^Is_InSC: virama}', "");
    Expect(0, 72768, '\p{Is_InSC: virama}', "");
    Expect(1, 72768, '\p{^Is_InSC: virama}', "");
    Expect(1, 72768, '\P{Is_InSC: virama}', "");
    Expect(0, 72768, '\P{^Is_InSC: virama}', "");
    Expect(1, 72767, '\p{Is_InSC=	VIRAMA}', "");
    Expect(0, 72767, '\p{^Is_InSC=	VIRAMA}', "");
    Expect(0, 72767, '\P{Is_InSC=	VIRAMA}', "");
    Expect(1, 72767, '\P{^Is_InSC=	VIRAMA}', "");
    Expect(0, 72768, '\p{Is_InSC=	VIRAMA}', "");
    Expect(1, 72768, '\p{^Is_InSC=	VIRAMA}', "");
    Expect(1, 72768, '\P{Is_InSC=	VIRAMA}', "");
    Expect(0, 72768, '\P{^Is_InSC=	VIRAMA}', "");
    Error('\p{Indic_Syllabic_Category=	VISARGA:=}');
    Error('\P{Indic_Syllabic_Category=	VISARGA:=}');
    Expect(1, 73110, '\p{Indic_Syllabic_Category=:\AVisarga\z:}', "");;
    Expect(0, 73111, '\p{Indic_Syllabic_Category=:\AVisarga\z:}', "");;
    Expect(1, 73110, '\p{Indic_Syllabic_Category=visarga}', "");
    Expect(0, 73110, '\p{^Indic_Syllabic_Category=visarga}', "");
    Expect(0, 73110, '\P{Indic_Syllabic_Category=visarga}', "");
    Expect(1, 73110, '\P{^Indic_Syllabic_Category=visarga}', "");
    Expect(0, 73111, '\p{Indic_Syllabic_Category=visarga}', "");
    Expect(1, 73111, '\p{^Indic_Syllabic_Category=visarga}', "");
    Expect(1, 73111, '\P{Indic_Syllabic_Category=visarga}', "");
    Expect(0, 73111, '\P{^Indic_Syllabic_Category=visarga}', "");
    Expect(1, 73110, '\p{Indic_Syllabic_Category=:\Avisarga\z:}', "");;
    Expect(0, 73111, '\p{Indic_Syllabic_Category=:\Avisarga\z:}', "");;
    Expect(1, 73110, '\p{Indic_Syllabic_Category=  visarga}', "");
    Expect(0, 73110, '\p{^Indic_Syllabic_Category=  visarga}', "");
    Expect(0, 73110, '\P{Indic_Syllabic_Category=  visarga}', "");
    Expect(1, 73110, '\P{^Indic_Syllabic_Category=  visarga}', "");
    Expect(0, 73111, '\p{Indic_Syllabic_Category=  visarga}', "");
    Expect(1, 73111, '\p{^Indic_Syllabic_Category=  visarga}', "");
    Expect(1, 73111, '\P{Indic_Syllabic_Category=  visarga}', "");
    Expect(0, 73111, '\P{^Indic_Syllabic_Category=  visarga}', "");
    Error('\p{InSC=-	visarga:=}');
    Error('\P{InSC=-	visarga:=}');
    Expect(1, 73110, '\p{InSC=:\AVisarga\z:}', "");;
    Expect(0, 73111, '\p{InSC=:\AVisarga\z:}', "");;
    Expect(1, 73110, '\p{InSC=visarga}', "");
    Expect(0, 73110, '\p{^InSC=visarga}', "");
    Expect(0, 73110, '\P{InSC=visarga}', "");
    Expect(1, 73110, '\P{^InSC=visarga}', "");
    Expect(0, 73111, '\p{InSC=visarga}', "");
    Expect(1, 73111, '\p{^InSC=visarga}', "");
    Expect(1, 73111, '\P{InSC=visarga}', "");
    Expect(0, 73111, '\P{^InSC=visarga}', "");
    Expect(1, 73110, '\p{InSC=:\Avisarga\z:}', "");;
    Expect(0, 73111, '\p{InSC=:\Avisarga\z:}', "");;
    Expect(1, 73110, '\p{InSC:	 -Visarga}', "");
    Expect(0, 73110, '\p{^InSC:	 -Visarga}', "");
    Expect(0, 73110, '\P{InSC:	 -Visarga}', "");
    Expect(1, 73110, '\P{^InSC:	 -Visarga}', "");
    Expect(0, 73111, '\p{InSC:	 -Visarga}', "");
    Expect(1, 73111, '\p{^InSC:	 -Visarga}', "");
    Expect(1, 73111, '\P{InSC:	 -Visarga}', "");
    Expect(0, 73111, '\P{^InSC:	 -Visarga}', "");
    Error('\p{Is_Indic_Syllabic_Category= :=Visarga}');
    Error('\P{Is_Indic_Syllabic_Category= :=Visarga}');
    Expect(1, 73110, '\p{Is_Indic_Syllabic_Category=visarga}', "");
    Expect(0, 73110, '\p{^Is_Indic_Syllabic_Category=visarga}', "");
    Expect(0, 73110, '\P{Is_Indic_Syllabic_Category=visarga}', "");
    Expect(1, 73110, '\P{^Is_Indic_Syllabic_Category=visarga}', "");
    Expect(0, 73111, '\p{Is_Indic_Syllabic_Category=visarga}', "");
    Expect(1, 73111, '\p{^Is_Indic_Syllabic_Category=visarga}', "");
    Expect(1, 73111, '\P{Is_Indic_Syllabic_Category=visarga}', "");
    Expect(0, 73111, '\P{^Is_Indic_Syllabic_Category=visarga}', "");
    Expect(1, 73110, '\p{Is_Indic_Syllabic_Category=_ VISARGA}', "");
    Expect(0, 73110, '\p{^Is_Indic_Syllabic_Category=_ VISARGA}', "");
    Expect(0, 73110, '\P{Is_Indic_Syllabic_Category=_ VISARGA}', "");
    Expect(1, 73110, '\P{^Is_Indic_Syllabic_Category=_ VISARGA}', "");
    Expect(0, 73111, '\p{Is_Indic_Syllabic_Category=_ VISARGA}', "");
    Expect(1, 73111, '\p{^Is_Indic_Syllabic_Category=_ VISARGA}', "");
    Expect(1, 73111, '\P{Is_Indic_Syllabic_Category=_ VISARGA}', "");
    Expect(0, 73111, '\P{^Is_Indic_Syllabic_Category=_ VISARGA}', "");
    Error('\p{Is_InSC=-/a/Visarga}');
    Error('\P{Is_InSC=-/a/Visarga}');
    Expect(1, 73110, '\p{Is_InSC=visarga}', "");
    Expect(0, 73110, '\p{^Is_InSC=visarga}', "");
    Expect(0, 73110, '\P{Is_InSC=visarga}', "");
    Expect(1, 73110, '\P{^Is_InSC=visarga}', "");
    Expect(0, 73111, '\p{Is_InSC=visarga}', "");
    Expect(1, 73111, '\p{^Is_InSC=visarga}', "");
    Expect(1, 73111, '\P{Is_InSC=visarga}', "");
    Expect(0, 73111, '\P{^Is_InSC=visarga}', "");
    Expect(1, 73110, '\p{Is_InSC=_visarga}', "");
    Expect(0, 73110, '\p{^Is_InSC=_visarga}', "");
    Expect(0, 73110, '\P{Is_InSC=_visarga}', "");
    Expect(1, 73110, '\P{^Is_InSC=_visarga}', "");
    Expect(0, 73111, '\p{Is_InSC=_visarga}', "");
    Expect(1, 73111, '\p{^Is_InSC=_visarga}', "");
    Expect(1, 73111, '\P{Is_InSC=_visarga}', "");
    Expect(0, 73111, '\P{^Is_InSC=_visarga}', "");
    Error('\p{Indic_Syllabic_Category= /a/Vowel}');
    Error('\P{Indic_Syllabic_Category= /a/Vowel}');
    Expect(1, 69972, '\p{Indic_Syllabic_Category=:\AVowel\z:}', "");;
    Expect(0, 69973, '\p{Indic_Syllabic_Category=:\AVowel\z:}', "");;
    Expect(1, 69972, '\p{Indic_Syllabic_Category=vowel}', "");
    Expect(0, 69972, '\p{^Indic_Syllabic_Category=vowel}', "");
    Expect(0, 69972, '\P{Indic_Syllabic_Category=vowel}', "");
    Expect(1, 69972, '\P{^Indic_Syllabic_Category=vowel}', "");
    Expect(0, 69973, '\p{Indic_Syllabic_Category=vowel}', "");
    Expect(1, 69973, '\p{^Indic_Syllabic_Category=vowel}', "");
    Expect(1, 69973, '\P{Indic_Syllabic_Category=vowel}', "");
    Expect(0, 69973, '\P{^Indic_Syllabic_Category=vowel}', "");
    Expect(1, 69972, '\p{Indic_Syllabic_Category=:\Avowel\z:}', "");;
    Expect(0, 69973, '\p{Indic_Syllabic_Category=:\Avowel\z:}', "");;
    Expect(1, 69972, '\p{Indic_Syllabic_Category= Vowel}', "");
    Expect(0, 69972, '\p{^Indic_Syllabic_Category= Vowel}', "");
    Expect(0, 69972, '\P{Indic_Syllabic_Category= Vowel}', "");
    Expect(1, 69972, '\P{^Indic_Syllabic_Category= Vowel}', "");
    Expect(0, 69973, '\p{Indic_Syllabic_Category= Vowel}', "");
    Expect(1, 69973, '\p{^Indic_Syllabic_Category= Vowel}', "");
    Expect(1, 69973, '\P{Indic_Syllabic_Category= Vowel}', "");
    Expect(0, 69973, '\P{^Indic_Syllabic_Category= Vowel}', "");
    Error('\p{InSC=-	Vowel/a/}');
    Error('\P{InSC=-	Vowel/a/}');
    Expect(1, 69972, '\p{InSC=:\AVowel\z:}', "");;
    Expect(0, 69973, '\p{InSC=:\AVowel\z:}', "");;
    Expect(1, 69972, '\p{InSC=vowel}', "");
    Expect(0, 69972, '\p{^InSC=vowel}', "");
    Expect(0, 69972, '\P{InSC=vowel}', "");
    Expect(1, 69972, '\P{^InSC=vowel}', "");
    Expect(0, 69973, '\p{InSC=vowel}', "");
    Expect(1, 69973, '\p{^InSC=vowel}', "");
    Expect(1, 69973, '\P{InSC=vowel}', "");
    Expect(0, 69973, '\P{^InSC=vowel}', "");
    Expect(1, 69972, '\p{InSC=:\Avowel\z:}', "");;
    Expect(0, 69973, '\p{InSC=:\Avowel\z:}', "");;
    Expect(1, 69972, '\p{InSC=- VOWEL}', "");
    Expect(0, 69972, '\p{^InSC=- VOWEL}', "");
    Expect(0, 69972, '\P{InSC=- VOWEL}', "");
    Expect(1, 69972, '\P{^InSC=- VOWEL}', "");
    Expect(0, 69973, '\p{InSC=- VOWEL}', "");
    Expect(1, 69973, '\p{^InSC=- VOWEL}', "");
    Expect(1, 69973, '\P{InSC=- VOWEL}', "");
    Expect(0, 69973, '\P{^InSC=- VOWEL}', "");
    Error('\p{Is_Indic_Syllabic_Category:  -Vowel:=}');
    Error('\P{Is_Indic_Syllabic_Category:  -Vowel:=}');
    Expect(1, 69972, '\p{Is_Indic_Syllabic_Category=vowel}', "");
    Expect(0, 69972, '\p{^Is_Indic_Syllabic_Category=vowel}', "");
    Expect(0, 69972, '\P{Is_Indic_Syllabic_Category=vowel}', "");
    Expect(1, 69972, '\P{^Is_Indic_Syllabic_Category=vowel}', "");
    Expect(0, 69973, '\p{Is_Indic_Syllabic_Category=vowel}', "");
    Expect(1, 69973, '\p{^Is_Indic_Syllabic_Category=vowel}', "");
    Expect(1, 69973, '\P{Is_Indic_Syllabic_Category=vowel}', "");
    Expect(0, 69973, '\P{^Is_Indic_Syllabic_Category=vowel}', "");
    Expect(1, 69972, '\p{Is_Indic_Syllabic_Category= -Vowel}', "");
    Expect(0, 69972, '\p{^Is_Indic_Syllabic_Category= -Vowel}', "");
    Expect(0, 69972, '\P{Is_Indic_Syllabic_Category= -Vowel}', "");
    Expect(1, 69972, '\P{^Is_Indic_Syllabic_Category= -Vowel}', "");
    Expect(0, 69973, '\p{Is_Indic_Syllabic_Category= -Vowel}', "");
    Expect(1, 69973, '\p{^Is_Indic_Syllabic_Category= -Vowel}', "");
    Expect(1, 69973, '\P{Is_Indic_Syllabic_Category= -Vowel}', "");
    Expect(0, 69973, '\P{^Is_Indic_Syllabic_Category= -Vowel}', "");
    Error('\p{Is_InSC=/a/		Vowel}');
    Error('\P{Is_InSC=/a/		Vowel}');
    Expect(1, 69972, '\p{Is_InSC=vowel}', "");
    Expect(0, 69972, '\p{^Is_InSC=vowel}', "");
    Expect(0, 69972, '\P{Is_InSC=vowel}', "");
    Expect(1, 69972, '\P{^Is_InSC=vowel}', "");
    Expect(0, 69973, '\p{Is_InSC=vowel}', "");
    Expect(1, 69973, '\p{^Is_InSC=vowel}', "");
    Expect(1, 69973, '\P{Is_InSC=vowel}', "");
    Expect(0, 69973, '\P{^Is_InSC=vowel}', "");
    Expect(1, 69972, '\p{Is_InSC=VOWEL}', "");
    Expect(0, 69972, '\p{^Is_InSC=VOWEL}', "");
    Expect(0, 69972, '\P{Is_InSC=VOWEL}', "");
    Expect(1, 69972, '\P{^Is_InSC=VOWEL}', "");
    Expect(0, 69973, '\p{Is_InSC=VOWEL}', "");
    Expect(1, 69973, '\p{^Is_InSC=VOWEL}', "");
    Expect(1, 69973, '\P{Is_InSC=VOWEL}', "");
    Expect(0, 69973, '\P{^Is_InSC=VOWEL}', "");
    Error('\p{Indic_Syllabic_Category=	_Vowel_Dependent/a/}');
    Error('\P{Indic_Syllabic_Category=	_Vowel_Dependent/a/}');
    Expect(1, 73462, '\p{Indic_Syllabic_Category=:\AVowel_Dependent\z:}', "");;
    Expect(0, 73463, '\p{Indic_Syllabic_Category=:\AVowel_Dependent\z:}', "");;
    Expect(1, 73462, '\p{Indic_Syllabic_Category=voweldependent}', "");
    Expect(0, 73462, '\p{^Indic_Syllabic_Category=voweldependent}', "");
    Expect(0, 73462, '\P{Indic_Syllabic_Category=voweldependent}', "");
    Expect(1, 73462, '\P{^Indic_Syllabic_Category=voweldependent}', "");
    Expect(0, 73463, '\p{Indic_Syllabic_Category=voweldependent}', "");
    Expect(1, 73463, '\p{^Indic_Syllabic_Category=voweldependent}', "");
    Expect(1, 73463, '\P{Indic_Syllabic_Category=voweldependent}', "");
    Expect(0, 73463, '\P{^Indic_Syllabic_Category=voweldependent}', "");
    Expect(1, 73462, '\p{Indic_Syllabic_Category=:\Avoweldependent\z:}', "");;
    Expect(0, 73463, '\p{Indic_Syllabic_Category=:\Avoweldependent\z:}', "");;
    Expect(1, 73462, '\p{Indic_Syllabic_Category=--Vowel_dependent}', "");
    Expect(0, 73462, '\p{^Indic_Syllabic_Category=--Vowel_dependent}', "");
    Expect(0, 73462, '\P{Indic_Syllabic_Category=--Vowel_dependent}', "");
    Expect(1, 73462, '\P{^Indic_Syllabic_Category=--Vowel_dependent}', "");
    Expect(0, 73463, '\p{Indic_Syllabic_Category=--Vowel_dependent}', "");
    Expect(1, 73463, '\p{^Indic_Syllabic_Category=--Vowel_dependent}', "");
    Expect(1, 73463, '\P{Indic_Syllabic_Category=--Vowel_dependent}', "");
    Expect(0, 73463, '\P{^Indic_Syllabic_Category=--Vowel_dependent}', "");
    Error('\p{InSC=:=	Vowel_dependent}');
    Error('\P{InSC=:=	Vowel_dependent}');
    Expect(1, 73462, '\p{InSC=:\AVowel_Dependent\z:}', "");;
    Expect(0, 73463, '\p{InSC=:\AVowel_Dependent\z:}', "");;
    Expect(1, 73462, '\p{InSC=voweldependent}', "");
    Expect(0, 73462, '\p{^InSC=voweldependent}', "");
    Expect(0, 73462, '\P{InSC=voweldependent}', "");
    Expect(1, 73462, '\P{^InSC=voweldependent}', "");
    Expect(0, 73463, '\p{InSC=voweldependent}', "");
    Expect(1, 73463, '\p{^InSC=voweldependent}', "");
    Expect(1, 73463, '\P{InSC=voweldependent}', "");
    Expect(0, 73463, '\P{^InSC=voweldependent}', "");
    Expect(1, 73462, '\p{InSC=:\Avoweldependent\z:}', "");;
    Expect(0, 73463, '\p{InSC=:\Avoweldependent\z:}', "");;
    Expect(1, 73462, '\p{InSC=	 Vowel_Dependent}', "");
    Expect(0, 73462, '\p{^InSC=	 Vowel_Dependent}', "");
    Expect(0, 73462, '\P{InSC=	 Vowel_Dependent}', "");
    Expect(1, 73462, '\P{^InSC=	 Vowel_Dependent}', "");
    Expect(0, 73463, '\p{InSC=	 Vowel_Dependent}', "");
    Expect(1, 73463, '\p{^InSC=	 Vowel_Dependent}', "");
    Expect(1, 73463, '\P{InSC=	 Vowel_Dependent}', "");
    Expect(0, 73463, '\P{^InSC=	 Vowel_Dependent}', "");
    Error('\p{Is_Indic_Syllabic_Category=	Vowel_Dependent:=}');
    Error('\P{Is_Indic_Syllabic_Category=	Vowel_Dependent:=}');
    Expect(1, 73462, '\p{Is_Indic_Syllabic_Category=voweldependent}', "");
    Expect(0, 73462, '\p{^Is_Indic_Syllabic_Category=voweldependent}', "");
    Expect(0, 73462, '\P{Is_Indic_Syllabic_Category=voweldependent}', "");
    Expect(1, 73462, '\P{^Is_Indic_Syllabic_Category=voweldependent}', "");
    Expect(0, 73463, '\p{Is_Indic_Syllabic_Category=voweldependent}', "");
    Expect(1, 73463, '\p{^Is_Indic_Syllabic_Category=voweldependent}', "");
    Expect(1, 73463, '\P{Is_Indic_Syllabic_Category=voweldependent}', "");
    Expect(0, 73463, '\P{^Is_Indic_Syllabic_Category=voweldependent}', "");
    Expect(1, 73462, '\p{Is_Indic_Syllabic_Category= _vowel_Dependent}', "");
    Expect(0, 73462, '\p{^Is_Indic_Syllabic_Category= _vowel_Dependent}', "");
    Expect(0, 73462, '\P{Is_Indic_Syllabic_Category= _vowel_Dependent}', "");
    Expect(1, 73462, '\P{^Is_Indic_Syllabic_Category= _vowel_Dependent}', "");
    Expect(0, 73463, '\p{Is_Indic_Syllabic_Category= _vowel_Dependent}', "");
    Expect(1, 73463, '\p{^Is_Indic_Syllabic_Category= _vowel_Dependent}', "");
    Expect(1, 73463, '\P{Is_Indic_Syllabic_Category= _vowel_Dependent}', "");
    Expect(0, 73463, '\P{^Is_Indic_Syllabic_Category= _vowel_Dependent}', "");
    Error('\p{Is_InSC=	:=Vowel_dependent}');
    Error('\P{Is_InSC=	:=Vowel_dependent}');
    Expect(1, 73462, '\p{Is_InSC=voweldependent}', "");
    Expect(0, 73462, '\p{^Is_InSC=voweldependent}', "");
    Expect(0, 73462, '\P{Is_InSC=voweldependent}', "");
    Expect(1, 73462, '\P{^Is_InSC=voweldependent}', "");
    Expect(0, 73463, '\p{Is_InSC=voweldependent}', "");
    Expect(1, 73463, '\p{^Is_InSC=voweldependent}', "");
    Expect(1, 73463, '\P{Is_InSC=voweldependent}', "");
    Expect(0, 73463, '\P{^Is_InSC=voweldependent}', "");
    Expect(1, 73462, '\p{Is_InSC=		Vowel_DEPENDENT}', "");
    Expect(0, 73462, '\p{^Is_InSC=		Vowel_DEPENDENT}', "");
    Expect(0, 73462, '\P{Is_InSC=		Vowel_DEPENDENT}', "");
    Expect(1, 73462, '\P{^Is_InSC=		Vowel_DEPENDENT}', "");
    Expect(0, 73463, '\p{Is_InSC=		Vowel_DEPENDENT}', "");
    Expect(1, 73463, '\p{^Is_InSC=		Vowel_DEPENDENT}', "");
    Expect(1, 73463, '\P{Is_InSC=		Vowel_DEPENDENT}', "");
    Expect(0, 73463, '\P{^Is_InSC=		Vowel_DEPENDENT}', "");
    Error('\p{Indic_Syllabic_Category= /a/Vowel_Independent}');
    Error('\P{Indic_Syllabic_Category= /a/Vowel_Independent}');
    Expect(1, 73067, '\p{Indic_Syllabic_Category=:\AVowel_Independent\z:}', "");;
    Expect(0, 73068, '\p{Indic_Syllabic_Category=:\AVowel_Independent\z:}', "");;
    Expect(1, 73067, '\p{Indic_Syllabic_Category:vowelindependent}', "");
    Expect(0, 73067, '\p{^Indic_Syllabic_Category:vowelindependent}', "");
    Expect(0, 73067, '\P{Indic_Syllabic_Category:vowelindependent}', "");
    Expect(1, 73067, '\P{^Indic_Syllabic_Category:vowelindependent}', "");
    Expect(0, 73068, '\p{Indic_Syllabic_Category:vowelindependent}', "");
    Expect(1, 73068, '\p{^Indic_Syllabic_Category:vowelindependent}', "");
    Expect(1, 73068, '\P{Indic_Syllabic_Category:vowelindependent}', "");
    Expect(0, 73068, '\P{^Indic_Syllabic_Category:vowelindependent}', "");
    Expect(1, 73067, '\p{Indic_Syllabic_Category=:\Avowelindependent\z:}', "");;
    Expect(0, 73068, '\p{Indic_Syllabic_Category=:\Avowelindependent\z:}', "");;
    Expect(1, 73067, '\p{Indic_Syllabic_Category=_-Vowel_INDEPENDENT}', "");
    Expect(0, 73067, '\p{^Indic_Syllabic_Category=_-Vowel_INDEPENDENT}', "");
    Expect(0, 73067, '\P{Indic_Syllabic_Category=_-Vowel_INDEPENDENT}', "");
    Expect(1, 73067, '\P{^Indic_Syllabic_Category=_-Vowel_INDEPENDENT}', "");
    Expect(0, 73068, '\p{Indic_Syllabic_Category=_-Vowel_INDEPENDENT}', "");
    Expect(1, 73068, '\p{^Indic_Syllabic_Category=_-Vowel_INDEPENDENT}', "");
    Expect(1, 73068, '\P{Indic_Syllabic_Category=_-Vowel_INDEPENDENT}', "");
    Expect(0, 73068, '\P{^Indic_Syllabic_Category=_-Vowel_INDEPENDENT}', "");
    Error('\p{InSC= :=Vowel_Independent}');
    Error('\P{InSC= :=Vowel_Independent}');
    Expect(1, 73067, '\p{InSC=:\AVowel_Independent\z:}', "");;
    Expect(0, 73068, '\p{InSC=:\AVowel_Independent\z:}', "");;
    Expect(1, 73067, '\p{InSC=vowelindependent}', "");
    Expect(0, 73067, '\p{^InSC=vowelindependent}', "");
    Expect(0, 73067, '\P{InSC=vowelindependent}', "");
    Expect(1, 73067, '\P{^InSC=vowelindependent}', "");
    Expect(0, 73068, '\p{InSC=vowelindependent}', "");
    Expect(1, 73068, '\p{^InSC=vowelindependent}', "");
    Expect(1, 73068, '\P{InSC=vowelindependent}', "");
    Expect(0, 73068, '\P{^InSC=vowelindependent}', "");
    Expect(1, 73067, '\p{InSC=:\Avowelindependent\z:}', "");;
    Expect(0, 73068, '\p{InSC=:\Avowelindependent\z:}', "");;
    Expect(1, 73067, '\p{InSC:		_Vowel_independent}', "");
    Expect(0, 73067, '\p{^InSC:		_Vowel_independent}', "");
    Expect(0, 73067, '\P{InSC:		_Vowel_independent}', "");
    Expect(1, 73067, '\P{^InSC:		_Vowel_independent}', "");
    Expect(0, 73068, '\p{InSC:		_Vowel_independent}', "");
    Expect(1, 73068, '\p{^InSC:		_Vowel_independent}', "");
    Expect(1, 73068, '\P{InSC:		_Vowel_independent}', "");
    Expect(0, 73068, '\P{^InSC:		_Vowel_independent}', "");
    Error('\p{Is_Indic_Syllabic_Category=	_vowel_INDEPENDENT/a/}');
    Error('\P{Is_Indic_Syllabic_Category=	_vowel_INDEPENDENT/a/}');
    Expect(1, 73067, '\p{Is_Indic_Syllabic_Category=vowelindependent}', "");
    Expect(0, 73067, '\p{^Is_Indic_Syllabic_Category=vowelindependent}', "");
    Expect(0, 73067, '\P{Is_Indic_Syllabic_Category=vowelindependent}', "");
    Expect(1, 73067, '\P{^Is_Indic_Syllabic_Category=vowelindependent}', "");
    Expect(0, 73068, '\p{Is_Indic_Syllabic_Category=vowelindependent}', "");
    Expect(1, 73068, '\p{^Is_Indic_Syllabic_Category=vowelindependent}', "");
    Expect(1, 73068, '\P{Is_Indic_Syllabic_Category=vowelindependent}', "");
    Expect(0, 73068, '\P{^Is_Indic_Syllabic_Category=vowelindependent}', "");
    Expect(1, 73067, '\p{Is_Indic_Syllabic_Category=		Vowel_Independent}', "");
    Expect(0, 73067, '\p{^Is_Indic_Syllabic_Category=		Vowel_Independent}', "");
    Expect(0, 73067, '\P{Is_Indic_Syllabic_Category=		Vowel_Independent}', "");
    Expect(1, 73067, '\P{^Is_Indic_Syllabic_Category=		Vowel_Independent}', "");
    Expect(0, 73068, '\p{Is_Indic_Syllabic_Category=		Vowel_Independent}', "");
    Expect(1, 73068, '\p{^Is_Indic_Syllabic_Category=		Vowel_Independent}', "");
    Expect(1, 73068, '\P{Is_Indic_Syllabic_Category=		Vowel_Independent}', "");
    Expect(0, 73068, '\P{^Is_Indic_Syllabic_Category=		Vowel_Independent}', "");
    Error('\p{Is_InSC=-/a/VOWEL_independent}');
    Error('\P{Is_InSC=-/a/VOWEL_independent}');
    Expect(1, 73067, '\p{Is_InSC=vowelindependent}', "");
    Expect(0, 73067, '\p{^Is_InSC=vowelindependent}', "");
    Expect(0, 73067, '\P{Is_InSC=vowelindependent}', "");
    Expect(1, 73067, '\P{^Is_InSC=vowelindependent}', "");
    Expect(0, 73068, '\p{Is_InSC=vowelindependent}', "");
    Expect(1, 73068, '\p{^Is_InSC=vowelindependent}', "");
    Expect(1, 73068, '\P{Is_InSC=vowelindependent}', "");
    Expect(0, 73068, '\P{^Is_InSC=vowelindependent}', "");
    Expect(1, 73067, '\p{Is_InSC= 	vowel_Independent}', "");
    Expect(0, 73067, '\p{^Is_InSC= 	vowel_Independent}', "");
    Expect(0, 73067, '\P{Is_InSC= 	vowel_Independent}', "");
    Expect(1, 73067, '\P{^Is_InSC= 	vowel_Independent}', "");
    Expect(0, 73068, '\p{Is_InSC= 	vowel_Independent}', "");
    Expect(1, 73068, '\p{^Is_InSC= 	vowel_Independent}', "");
    Expect(1, 73068, '\P{Is_InSC= 	vowel_Independent}', "");
    Expect(0, 73068, '\P{^Is_InSC= 	vowel_Independent}', "");
    Error('\p{isocomment}');
    Error('\P{isocomment}');
    Error('\p{joininggroup}');
    Error('\P{joininggroup}');
    Error('\p{jg}');
    Error('\P{jg}');
    Error('\p{Joining_Group=	:=AFRICAN_feh}');
    Error('\P{Joining_Group=	:=AFRICAN_feh}');
    Expect(1, 2235, '\p{Joining_Group=:\AAfrican_Feh\z:}', "");;
    Expect(0, 2236, '\p{Joining_Group=:\AAfrican_Feh\z:}', "");;
    Expect(1, 2235, '\p{Joining_Group=africanfeh}', "");
    Expect(0, 2235, '\p{^Joining_Group=africanfeh}', "");
    Expect(0, 2235, '\P{Joining_Group=africanfeh}', "");
    Expect(1, 2235, '\P{^Joining_Group=africanfeh}', "");
    Expect(0, 2236, '\p{Joining_Group=africanfeh}', "");
    Expect(1, 2236, '\p{^Joining_Group=africanfeh}', "");
    Expect(1, 2236, '\P{Joining_Group=africanfeh}', "");
    Expect(0, 2236, '\P{^Joining_Group=africanfeh}', "");
    Expect(1, 2235, '\p{Joining_Group=:\Aafricanfeh\z:}', "");;
    Expect(0, 2236, '\p{Joining_Group=:\Aafricanfeh\z:}', "");;
    Expect(1, 2235, '\p{Joining_Group=__AFRICAN_Feh}', "");
    Expect(0, 2235, '\p{^Joining_Group=__AFRICAN_Feh}', "");
    Expect(0, 2235, '\P{Joining_Group=__AFRICAN_Feh}', "");
    Expect(1, 2235, '\P{^Joining_Group=__AFRICAN_Feh}', "");
    Expect(0, 2236, '\p{Joining_Group=__AFRICAN_Feh}', "");
    Expect(1, 2236, '\p{^Joining_Group=__AFRICAN_Feh}', "");
    Expect(1, 2236, '\P{Joining_Group=__AFRICAN_Feh}', "");
    Expect(0, 2236, '\P{^Joining_Group=__AFRICAN_Feh}', "");
    Error('\p{Jg=-african_Feh/a/}');
    Error('\P{Jg=-african_Feh/a/}');
    Expect(1, 2235, '\p{Jg=:\AAfrican_Feh\z:}', "");;
    Expect(0, 2236, '\p{Jg=:\AAfrican_Feh\z:}', "");;
    Expect(1, 2235, '\p{Jg=africanfeh}', "");
    Expect(0, 2235, '\p{^Jg=africanfeh}', "");
    Expect(0, 2235, '\P{Jg=africanfeh}', "");
    Expect(1, 2235, '\P{^Jg=africanfeh}', "");
    Expect(0, 2236, '\p{Jg=africanfeh}', "");
    Expect(1, 2236, '\p{^Jg=africanfeh}', "");
    Expect(1, 2236, '\P{Jg=africanfeh}', "");
    Expect(0, 2236, '\P{^Jg=africanfeh}', "");
    Expect(1, 2235, '\p{Jg=:\Aafricanfeh\z:}', "");;
    Expect(0, 2236, '\p{Jg=:\Aafricanfeh\z:}', "");;
    Expect(1, 2235, '\p{Jg:  	African_Feh}', "");
    Expect(0, 2235, '\p{^Jg:  	African_Feh}', "");
    Expect(0, 2235, '\P{Jg:  	African_Feh}', "");
    Expect(1, 2235, '\P{^Jg:  	African_Feh}', "");
    Expect(0, 2236, '\p{Jg:  	African_Feh}', "");
    Expect(1, 2236, '\p{^Jg:  	African_Feh}', "");
    Expect(1, 2236, '\P{Jg:  	African_Feh}', "");
    Expect(0, 2236, '\P{^Jg:  	African_Feh}', "");
    Error('\p{Is_Joining_Group=_:=AFRICAN_Feh}');
    Error('\P{Is_Joining_Group=_:=AFRICAN_Feh}');
    Expect(1, 2235, '\p{Is_Joining_Group=africanfeh}', "");
    Expect(0, 2235, '\p{^Is_Joining_Group=africanfeh}', "");
    Expect(0, 2235, '\P{Is_Joining_Group=africanfeh}', "");
    Expect(1, 2235, '\P{^Is_Joining_Group=africanfeh}', "");
    Expect(0, 2236, '\p{Is_Joining_Group=africanfeh}', "");
    Expect(1, 2236, '\p{^Is_Joining_Group=africanfeh}', "");
    Expect(1, 2236, '\P{Is_Joining_Group=africanfeh}', "");
    Expect(0, 2236, '\P{^Is_Joining_Group=africanfeh}', "");
    Expect(1, 2235, '\p{Is_Joining_Group= African_FEH}', "");
    Expect(0, 2235, '\p{^Is_Joining_Group= African_FEH}', "");
    Expect(0, 2235, '\P{Is_Joining_Group= African_FEH}', "");
    Expect(1, 2235, '\P{^Is_Joining_Group= African_FEH}', "");
    Expect(0, 2236, '\p{Is_Joining_Group= African_FEH}', "");
    Expect(1, 2236, '\p{^Is_Joining_Group= African_FEH}', "");
    Expect(1, 2236, '\P{Is_Joining_Group= African_FEH}', "");
    Expect(0, 2236, '\P{^Is_Joining_Group= African_FEH}', "");
    Error('\p{Is_Jg= :=African_feh}');
    Error('\P{Is_Jg= :=African_feh}');
    Expect(1, 2235, '\p{Is_Jg=africanfeh}', "");
    Expect(0, 2235, '\p{^Is_Jg=africanfeh}', "");
    Expect(0, 2235, '\P{Is_Jg=africanfeh}', "");
    Expect(1, 2235, '\P{^Is_Jg=africanfeh}', "");
    Expect(0, 2236, '\p{Is_Jg=africanfeh}', "");
    Expect(1, 2236, '\p{^Is_Jg=africanfeh}', "");
    Expect(1, 2236, '\P{Is_Jg=africanfeh}', "");
    Expect(0, 2236, '\P{^Is_Jg=africanfeh}', "");
    Expect(1, 2235, '\p{Is_Jg=African_feh}', "");
    Expect(0, 2235, '\p{^Is_Jg=African_feh}', "");
    Expect(0, 2235, '\P{Is_Jg=African_feh}', "");
    Expect(1, 2235, '\P{^Is_Jg=African_feh}', "");
    Expect(0, 2236, '\p{Is_Jg=African_feh}', "");
    Expect(1, 2236, '\p{^Is_Jg=African_feh}', "");
    Expect(1, 2236, '\P{Is_Jg=African_feh}', "");
    Expect(0, 2236, '\P{^Is_Jg=African_feh}', "");
    Error('\p{Joining_Group= :=African_Noon}');
    Error('\P{Joining_Group= :=African_Noon}');
    Expect(1, 2237, '\p{Joining_Group=:\AAfrican_Noon\z:}', "");;
    Expect(0, 2238, '\p{Joining_Group=:\AAfrican_Noon\z:}', "");;
    Expect(1, 2237, '\p{Joining_Group=africannoon}', "");
    Expect(0, 2237, '\p{^Joining_Group=africannoon}', "");
    Expect(0, 2237, '\P{Joining_Group=africannoon}', "");
    Expect(1, 2237, '\P{^Joining_Group=africannoon}', "");
    Expect(0, 2238, '\p{Joining_Group=africannoon}', "");
    Expect(1, 2238, '\p{^Joining_Group=africannoon}', "");
    Expect(1, 2238, '\P{Joining_Group=africannoon}', "");
    Expect(0, 2238, '\P{^Joining_Group=africannoon}', "");
    Expect(1, 2237, '\p{Joining_Group=:\Aafricannoon\z:}', "");;
    Expect(0, 2238, '\p{Joining_Group=:\Aafricannoon\z:}', "");;
    Expect(1, 2237, '\p{Joining_Group=_african_Noon}', "");
    Expect(0, 2237, '\p{^Joining_Group=_african_Noon}', "");
    Expect(0, 2237, '\P{Joining_Group=_african_Noon}', "");
    Expect(1, 2237, '\P{^Joining_Group=_african_Noon}', "");
    Expect(0, 2238, '\p{Joining_Group=_african_Noon}', "");
    Expect(1, 2238, '\p{^Joining_Group=_african_Noon}', "");
    Expect(1, 2238, '\P{Joining_Group=_african_Noon}', "");
    Expect(0, 2238, '\P{^Joining_Group=_african_Noon}', "");
    Error('\p{Jg=/a/ African_Noon}');
    Error('\P{Jg=/a/ African_Noon}');
    Expect(1, 2237, '\p{Jg=:\AAfrican_Noon\z:}', "");;
    Expect(0, 2238, '\p{Jg=:\AAfrican_Noon\z:}', "");;
    Expect(1, 2237, '\p{Jg=africannoon}', "");
    Expect(0, 2237, '\p{^Jg=africannoon}', "");
    Expect(0, 2237, '\P{Jg=africannoon}', "");
    Expect(1, 2237, '\P{^Jg=africannoon}', "");
    Expect(0, 2238, '\p{Jg=africannoon}', "");
    Expect(1, 2238, '\p{^Jg=africannoon}', "");
    Expect(1, 2238, '\P{Jg=africannoon}', "");
    Expect(0, 2238, '\P{^Jg=africannoon}', "");
    Expect(1, 2237, '\p{Jg=:\Aafricannoon\z:}', "");;
    Expect(0, 2238, '\p{Jg=:\Aafricannoon\z:}', "");;
    Expect(1, 2237, '\p{Jg= African_Noon}', "");
    Expect(0, 2237, '\p{^Jg= African_Noon}', "");
    Expect(0, 2237, '\P{Jg= African_Noon}', "");
    Expect(1, 2237, '\P{^Jg= African_Noon}', "");
    Expect(0, 2238, '\p{Jg= African_Noon}', "");
    Expect(1, 2238, '\p{^Jg= African_Noon}', "");
    Expect(1, 2238, '\P{Jg= African_Noon}', "");
    Expect(0, 2238, '\P{^Jg= African_Noon}', "");
    Error('\p{Is_Joining_Group: :=-	AFRICAN_NOON}');
    Error('\P{Is_Joining_Group: :=-	AFRICAN_NOON}');
    Expect(1, 2237, '\p{Is_Joining_Group=africannoon}', "");
    Expect(0, 2237, '\p{^Is_Joining_Group=africannoon}', "");
    Expect(0, 2237, '\P{Is_Joining_Group=africannoon}', "");
    Expect(1, 2237, '\P{^Is_Joining_Group=africannoon}', "");
    Expect(0, 2238, '\p{Is_Joining_Group=africannoon}', "");
    Expect(1, 2238, '\p{^Is_Joining_Group=africannoon}', "");
    Expect(1, 2238, '\P{Is_Joining_Group=africannoon}', "");
    Expect(0, 2238, '\P{^Is_Joining_Group=africannoon}', "");
    Expect(1, 2237, '\p{Is_Joining_Group: 	African_noon}', "");
    Expect(0, 2237, '\p{^Is_Joining_Group: 	African_noon}', "");
    Expect(0, 2237, '\P{Is_Joining_Group: 	African_noon}', "");
    Expect(1, 2237, '\P{^Is_Joining_Group: 	African_noon}', "");
    Expect(0, 2238, '\p{Is_Joining_Group: 	African_noon}', "");
    Expect(1, 2238, '\p{^Is_Joining_Group: 	African_noon}', "");
    Expect(1, 2238, '\P{Is_Joining_Group: 	African_noon}', "");
    Expect(0, 2238, '\P{^Is_Joining_Group: 	African_noon}', "");
    Error('\p{Is_Jg=-African_Noon:=}');
    Error('\P{Is_Jg=-African_Noon:=}');
    Expect(1, 2237, '\p{Is_Jg=africannoon}', "");
    Expect(0, 2237, '\p{^Is_Jg=africannoon}', "");
    Expect(0, 2237, '\P{Is_Jg=africannoon}', "");
    Expect(1, 2237, '\P{^Is_Jg=africannoon}', "");
    Expect(0, 2238, '\p{Is_Jg=africannoon}', "");
    Expect(1, 2238, '\p{^Is_Jg=africannoon}', "");
    Expect(1, 2238, '\P{Is_Jg=africannoon}', "");
    Expect(0, 2238, '\P{^Is_Jg=africannoon}', "");
    Expect(1, 2237, '\p{Is_Jg=__African_NOON}', "");
    Expect(0, 2237, '\p{^Is_Jg=__African_NOON}', "");
    Expect(0, 2237, '\P{Is_Jg=__African_NOON}', "");
    Expect(1, 2237, '\P{^Is_Jg=__African_NOON}', "");
    Expect(0, 2238, '\p{Is_Jg=__African_NOON}', "");
    Expect(1, 2238, '\p{^Is_Jg=__African_NOON}', "");
    Expect(1, 2238, '\P{Is_Jg=__African_NOON}', "");
    Expect(0, 2238, '\P{^Is_Jg=__African_NOON}', "");
    Error('\p{Joining_Group=	-African_Qaf:=}');
    Error('\P{Joining_Group=	-African_Qaf:=}');
    Expect(1, 2244, '\p{Joining_Group=:\AAfrican_Qaf\z:}', "");;
    Expect(0, 2245, '\p{Joining_Group=:\AAfrican_Qaf\z:}', "");;
    Expect(1, 2244, '\p{Joining_Group=africanqaf}', "");
    Expect(0, 2244, '\p{^Joining_Group=africanqaf}', "");
    Expect(0, 2244, '\P{Joining_Group=africanqaf}', "");
    Expect(1, 2244, '\P{^Joining_Group=africanqaf}', "");
    Expect(0, 2245, '\p{Joining_Group=africanqaf}', "");
    Expect(1, 2245, '\p{^Joining_Group=africanqaf}', "");
    Expect(1, 2245, '\P{Joining_Group=africanqaf}', "");
    Expect(0, 2245, '\P{^Joining_Group=africanqaf}', "");
    Expect(1, 2244, '\p{Joining_Group=:\Aafricanqaf\z:}', "");;
    Expect(0, 2245, '\p{Joining_Group=:\Aafricanqaf\z:}', "");;
    Expect(1, 2244, '\p{Joining_Group:	African_QAF}', "");
    Expect(0, 2244, '\p{^Joining_Group:	African_QAF}', "");
    Expect(0, 2244, '\P{Joining_Group:	African_QAF}', "");
    Expect(1, 2244, '\P{^Joining_Group:	African_QAF}', "");
    Expect(0, 2245, '\p{Joining_Group:	African_QAF}', "");
    Expect(1, 2245, '\p{^Joining_Group:	African_QAF}', "");
    Expect(1, 2245, '\P{Joining_Group:	African_QAF}', "");
    Expect(0, 2245, '\P{^Joining_Group:	African_QAF}', "");
    Error('\p{Jg=African_Qaf/a/}');
    Error('\P{Jg=African_Qaf/a/}');
    Expect(1, 2244, '\p{Jg=:\AAfrican_Qaf\z:}', "");;
    Expect(0, 2245, '\p{Jg=:\AAfrican_Qaf\z:}', "");;
    Expect(1, 2244, '\p{Jg=africanqaf}', "");
    Expect(0, 2244, '\p{^Jg=africanqaf}', "");
    Expect(0, 2244, '\P{Jg=africanqaf}', "");
    Expect(1, 2244, '\P{^Jg=africanqaf}', "");
    Expect(0, 2245, '\p{Jg=africanqaf}', "");
    Expect(1, 2245, '\p{^Jg=africanqaf}', "");
    Expect(1, 2245, '\P{Jg=africanqaf}', "");
    Expect(0, 2245, '\P{^Jg=africanqaf}', "");
    Expect(1, 2244, '\p{Jg=:\Aafricanqaf\z:}', "");;
    Expect(0, 2245, '\p{Jg=:\Aafricanqaf\z:}', "");;
    Expect(1, 2244, '\p{Jg=African_Qaf}', "");
    Expect(0, 2244, '\p{^Jg=African_Qaf}', "");
    Expect(0, 2244, '\P{Jg=African_Qaf}', "");
    Expect(1, 2244, '\P{^Jg=African_Qaf}', "");
    Expect(0, 2245, '\p{Jg=African_Qaf}', "");
    Expect(1, 2245, '\p{^Jg=African_Qaf}', "");
    Expect(1, 2245, '\P{Jg=African_Qaf}', "");
    Expect(0, 2245, '\P{^Jg=African_Qaf}', "");
    Error('\p{Is_Joining_Group=_African_qaf/a/}');
    Error('\P{Is_Joining_Group=_African_qaf/a/}');
    Expect(1, 2244, '\p{Is_Joining_Group=africanqaf}', "");
    Expect(0, 2244, '\p{^Is_Joining_Group=africanqaf}', "");
    Expect(0, 2244, '\P{Is_Joining_Group=africanqaf}', "");
    Expect(1, 2244, '\P{^Is_Joining_Group=africanqaf}', "");
    Expect(0, 2245, '\p{Is_Joining_Group=africanqaf}', "");
    Expect(1, 2245, '\p{^Is_Joining_Group=africanqaf}', "");
    Expect(1, 2245, '\P{Is_Joining_Group=africanqaf}', "");
    Expect(0, 2245, '\P{^Is_Joining_Group=africanqaf}', "");
    Expect(1, 2244, '\p{Is_Joining_Group=- african_qaf}', "");
    Expect(0, 2244, '\p{^Is_Joining_Group=- african_qaf}', "");
    Expect(0, 2244, '\P{Is_Joining_Group=- african_qaf}', "");
    Expect(1, 2244, '\P{^Is_Joining_Group=- african_qaf}', "");
    Expect(0, 2245, '\p{Is_Joining_Group=- african_qaf}', "");
    Expect(1, 2245, '\p{^Is_Joining_Group=- african_qaf}', "");
    Expect(1, 2245, '\P{Is_Joining_Group=- african_qaf}', "");
    Expect(0, 2245, '\P{^Is_Joining_Group=- african_qaf}', "");
    Error('\p{Is_Jg=/a/African_qaf}');
    Error('\P{Is_Jg=/a/African_qaf}');
    Expect(1, 2244, '\p{Is_Jg=africanqaf}', "");
    Expect(0, 2244, '\p{^Is_Jg=africanqaf}', "");
    Expect(0, 2244, '\P{Is_Jg=africanqaf}', "");
    Expect(1, 2244, '\P{^Is_Jg=africanqaf}', "");
    Expect(0, 2245, '\p{Is_Jg=africanqaf}', "");
    Expect(1, 2245, '\p{^Is_Jg=africanqaf}', "");
    Expect(1, 2245, '\P{Is_Jg=africanqaf}', "");
    Expect(0, 2245, '\P{^Is_Jg=africanqaf}', "");
    Expect(1, 2244, '\p{Is_Jg:		African_Qaf}', "");
    Expect(0, 2244, '\p{^Is_Jg:		African_Qaf}', "");
    Expect(0, 2244, '\P{Is_Jg:		African_Qaf}', "");
    Expect(1, 2244, '\P{^Is_Jg:		African_Qaf}', "");
    Expect(0, 2245, '\p{Is_Jg:		African_Qaf}', "");
    Expect(1, 2245, '\p{^Is_Jg:		African_Qaf}', "");
    Expect(1, 2245, '\P{Is_Jg:		African_Qaf}', "");
    Expect(0, 2245, '\P{^Is_Jg:		African_Qaf}', "");
    Error('\p{Joining_Group=/a/ ain}');
    Error('\P{Joining_Group=/a/ ain}');
    Expect(1, 2243, '\p{Joining_Group=:\AAin\z:}', "");;
    Expect(0, 2244, '\p{Joining_Group=:\AAin\z:}', "");;
    Expect(1, 2243, '\p{Joining_Group=ain}', "");
    Expect(0, 2243, '\p{^Joining_Group=ain}', "");
    Expect(0, 2243, '\P{Joining_Group=ain}', "");
    Expect(1, 2243, '\P{^Joining_Group=ain}', "");
    Expect(0, 2244, '\p{Joining_Group=ain}', "");
    Expect(1, 2244, '\p{^Joining_Group=ain}', "");
    Expect(1, 2244, '\P{Joining_Group=ain}', "");
    Expect(0, 2244, '\P{^Joining_Group=ain}', "");
    Expect(1, 2243, '\p{Joining_Group=:\Aain\z:}', "");;
    Expect(0, 2244, '\p{Joining_Group=:\Aain\z:}', "");;
    Expect(1, 2243, '\p{Joining_Group= Ain}', "");
    Expect(0, 2243, '\p{^Joining_Group= Ain}', "");
    Expect(0, 2243, '\P{Joining_Group= Ain}', "");
    Expect(1, 2243, '\P{^Joining_Group= Ain}', "");
    Expect(0, 2244, '\p{Joining_Group= Ain}', "");
    Expect(1, 2244, '\p{^Joining_Group= Ain}', "");
    Expect(1, 2244, '\P{Joining_Group= Ain}', "");
    Expect(0, 2244, '\P{^Joining_Group= Ain}', "");
    Error('\p{Jg= -AIN:=}');
    Error('\P{Jg= -AIN:=}');
    Expect(1, 2243, '\p{Jg=:\AAin\z:}', "");;
    Expect(0, 2244, '\p{Jg=:\AAin\z:}', "");;
    Expect(1, 2243, '\p{Jg=ain}', "");
    Expect(0, 2243, '\p{^Jg=ain}', "");
    Expect(0, 2243, '\P{Jg=ain}', "");
    Expect(1, 2243, '\P{^Jg=ain}', "");
    Expect(0, 2244, '\p{Jg=ain}', "");
    Expect(1, 2244, '\p{^Jg=ain}', "");
    Expect(1, 2244, '\P{Jg=ain}', "");
    Expect(0, 2244, '\P{^Jg=ain}', "");
    Expect(1, 2243, '\p{Jg=:\Aain\z:}', "");;
    Expect(0, 2244, '\p{Jg=:\Aain\z:}', "");;
    Expect(1, 2243, '\p{Jg:   	_ain}', "");
    Expect(0, 2243, '\p{^Jg:   	_ain}', "");
    Expect(0, 2243, '\P{Jg:   	_ain}', "");
    Expect(1, 2243, '\P{^Jg:   	_ain}', "");
    Expect(0, 2244, '\p{Jg:   	_ain}', "");
    Expect(1, 2244, '\p{^Jg:   	_ain}', "");
    Expect(1, 2244, '\P{Jg:   	_ain}', "");
    Expect(0, 2244, '\P{^Jg:   	_ain}', "");
    Error('\p{Is_Joining_Group:	 Ain:=}');
    Error('\P{Is_Joining_Group:	 Ain:=}');
    Expect(1, 2243, '\p{Is_Joining_Group=ain}', "");
    Expect(0, 2243, '\p{^Is_Joining_Group=ain}', "");
    Expect(0, 2243, '\P{Is_Joining_Group=ain}', "");
    Expect(1, 2243, '\P{^Is_Joining_Group=ain}', "");
    Expect(0, 2244, '\p{Is_Joining_Group=ain}', "");
    Expect(1, 2244, '\p{^Is_Joining_Group=ain}', "");
    Expect(1, 2244, '\P{Is_Joining_Group=ain}', "");
    Expect(0, 2244, '\P{^Is_Joining_Group=ain}', "");
    Expect(1, 2243, '\p{Is_Joining_Group=__ain}', "");
    Expect(0, 2243, '\p{^Is_Joining_Group=__ain}', "");
    Expect(0, 2243, '\P{Is_Joining_Group=__ain}', "");
    Expect(1, 2243, '\P{^Is_Joining_Group=__ain}', "");
    Expect(0, 2244, '\p{Is_Joining_Group=__ain}', "");
    Expect(1, 2244, '\p{^Is_Joining_Group=__ain}', "");
    Expect(1, 2244, '\P{Is_Joining_Group=__ain}', "");
    Expect(0, 2244, '\P{^Is_Joining_Group=__ain}', "");
    Error('\p{Is_Jg= Ain:=}');
    Error('\P{Is_Jg= Ain:=}');
    Expect(1, 2243, '\p{Is_Jg=ain}', "");
    Expect(0, 2243, '\p{^Is_Jg=ain}', "");
    Expect(0, 2243, '\P{Is_Jg=ain}', "");
    Expect(1, 2243, '\P{^Is_Jg=ain}', "");
    Expect(0, 2244, '\p{Is_Jg=ain}', "");
    Expect(1, 2244, '\p{^Is_Jg=ain}', "");
    Expect(1, 2244, '\P{Is_Jg=ain}', "");
    Expect(0, 2244, '\P{^Is_Jg=ain}', "");
    Expect(1, 2243, '\p{Is_Jg=-AIN}', "");
    Expect(0, 2243, '\p{^Is_Jg=-AIN}', "");
    Expect(0, 2243, '\P{Is_Jg=-AIN}', "");
    Expect(1, 2243, '\P{^Is_Jg=-AIN}', "");
    Expect(0, 2244, '\p{Is_Jg=-AIN}', "");
    Expect(1, 2244, '\p{^Is_Jg=-AIN}', "");
    Expect(1, 2244, '\P{Is_Jg=-AIN}', "");
    Expect(0, 2244, '\P{^Is_Jg=-AIN}', "");
    Error('\p{Joining_Group=/a/	alaph}');
    Error('\P{Joining_Group=/a/	alaph}');
    Expect(1, 1808, '\p{Joining_Group=:\AAlaph\z:}', "");;
    Expect(0, 1809, '\p{Joining_Group=:\AAlaph\z:}', "");;
    Expect(1, 1808, '\p{Joining_Group=alaph}', "");
    Expect(0, 1808, '\p{^Joining_Group=alaph}', "");
    Expect(0, 1808, '\P{Joining_Group=alaph}', "");
    Expect(1, 1808, '\P{^Joining_Group=alaph}', "");
    Expect(0, 1809, '\p{Joining_Group=alaph}', "");
    Expect(1, 1809, '\p{^Joining_Group=alaph}', "");
    Expect(1, 1809, '\P{Joining_Group=alaph}', "");
    Expect(0, 1809, '\P{^Joining_Group=alaph}', "");
    Expect(1, 1808, '\p{Joining_Group=:\Aalaph\z:}', "");;
    Expect(0, 1809, '\p{Joining_Group=:\Aalaph\z:}', "");;
    Expect(1, 1808, '\p{Joining_Group=_ALAPH}', "");
    Expect(0, 1808, '\p{^Joining_Group=_ALAPH}', "");
    Expect(0, 1808, '\P{Joining_Group=_ALAPH}', "");
    Expect(1, 1808, '\P{^Joining_Group=_ALAPH}', "");
    Expect(0, 1809, '\p{Joining_Group=_ALAPH}', "");
    Expect(1, 1809, '\p{^Joining_Group=_ALAPH}', "");
    Expect(1, 1809, '\P{Joining_Group=_ALAPH}', "");
    Expect(0, 1809, '\P{^Joining_Group=_ALAPH}', "");
    Error('\p{Jg=/a/	_Alaph}');
    Error('\P{Jg=/a/	_Alaph}');
    Expect(1, 1808, '\p{Jg=:\AAlaph\z:}', "");;
    Expect(0, 1809, '\p{Jg=:\AAlaph\z:}', "");;
    Expect(1, 1808, '\p{Jg=alaph}', "");
    Expect(0, 1808, '\p{^Jg=alaph}', "");
    Expect(0, 1808, '\P{Jg=alaph}', "");
    Expect(1, 1808, '\P{^Jg=alaph}', "");
    Expect(0, 1809, '\p{Jg=alaph}', "");
    Expect(1, 1809, '\p{^Jg=alaph}', "");
    Expect(1, 1809, '\P{Jg=alaph}', "");
    Expect(0, 1809, '\P{^Jg=alaph}', "");
    Expect(1, 1808, '\p{Jg=:\Aalaph\z:}', "");;
    Expect(0, 1809, '\p{Jg=:\Aalaph\z:}', "");;
    Expect(1, 1808, '\p{Jg=_alaph}', "");
    Expect(0, 1808, '\p{^Jg=_alaph}', "");
    Expect(0, 1808, '\P{Jg=_alaph}', "");
    Expect(1, 1808, '\P{^Jg=_alaph}', "");
    Expect(0, 1809, '\p{Jg=_alaph}', "");
    Expect(1, 1809, '\p{^Jg=_alaph}', "");
    Expect(1, 1809, '\P{Jg=_alaph}', "");
    Expect(0, 1809, '\P{^Jg=_alaph}', "");
    Error('\p{Is_Joining_Group::=_	Alaph}');
    Error('\P{Is_Joining_Group::=_	Alaph}');
    Expect(1, 1808, '\p{Is_Joining_Group=alaph}', "");
    Expect(0, 1808, '\p{^Is_Joining_Group=alaph}', "");
    Expect(0, 1808, '\P{Is_Joining_Group=alaph}', "");
    Expect(1, 1808, '\P{^Is_Joining_Group=alaph}', "");
    Expect(0, 1809, '\p{Is_Joining_Group=alaph}', "");
    Expect(1, 1809, '\p{^Is_Joining_Group=alaph}', "");
    Expect(1, 1809, '\P{Is_Joining_Group=alaph}', "");
    Expect(0, 1809, '\P{^Is_Joining_Group=alaph}', "");
    Expect(1, 1808, '\p{Is_Joining_Group=-Alaph}', "");
    Expect(0, 1808, '\p{^Is_Joining_Group=-Alaph}', "");
    Expect(0, 1808, '\P{Is_Joining_Group=-Alaph}', "");
    Expect(1, 1808, '\P{^Is_Joining_Group=-Alaph}', "");
    Expect(0, 1809, '\p{Is_Joining_Group=-Alaph}', "");
    Expect(1, 1809, '\p{^Is_Joining_Group=-Alaph}', "");
    Expect(1, 1809, '\P{Is_Joining_Group=-Alaph}', "");
    Expect(0, 1809, '\P{^Is_Joining_Group=-Alaph}', "");
    Error('\p{Is_Jg=	 alaph:=}');
    Error('\P{Is_Jg=	 alaph:=}');
    Expect(1, 1808, '\p{Is_Jg=alaph}', "");
    Expect(0, 1808, '\p{^Is_Jg=alaph}', "");
    Expect(0, 1808, '\P{Is_Jg=alaph}', "");
    Expect(1, 1808, '\P{^Is_Jg=alaph}', "");
    Expect(0, 1809, '\p{Is_Jg=alaph}', "");
    Expect(1, 1809, '\p{^Is_Jg=alaph}', "");
    Expect(1, 1809, '\P{Is_Jg=alaph}', "");
    Expect(0, 1809, '\P{^Is_Jg=alaph}', "");
    Expect(1, 1808, '\p{Is_Jg=_	Alaph}', "");
    Expect(0, 1808, '\p{^Is_Jg=_	Alaph}', "");
    Expect(0, 1808, '\P{Is_Jg=_	Alaph}', "");
    Expect(1, 1808, '\P{^Is_Jg=_	Alaph}', "");
    Expect(0, 1809, '\p{Is_Jg=_	Alaph}', "");
    Expect(1, 1809, '\p{^Is_Jg=_	Alaph}', "");
    Expect(1, 1809, '\P{Is_Jg=_	Alaph}', "");
    Expect(0, 1809, '\P{^Is_Jg=_	Alaph}', "");
    Error('\p{Joining_Group: /a/	alef}');
    Error('\P{Joining_Group: /a/	alef}');
    Expect(1, 1908, '\p{Joining_Group=:\AAlef\z:}', "");;
    Expect(0, 1909, '\p{Joining_Group=:\AAlef\z:}', "");;
    Expect(1, 1908, '\p{Joining_Group=alef}', "");
    Expect(0, 1908, '\p{^Joining_Group=alef}', "");
    Expect(0, 1908, '\P{Joining_Group=alef}', "");
    Expect(1, 1908, '\P{^Joining_Group=alef}', "");
    Expect(0, 1909, '\p{Joining_Group=alef}', "");
    Expect(1, 1909, '\p{^Joining_Group=alef}', "");
    Expect(1, 1909, '\P{Joining_Group=alef}', "");
    Expect(0, 1909, '\P{^Joining_Group=alef}', "");
    Expect(1, 1908, '\p{Joining_Group=:\Aalef\z:}', "");;
    Expect(0, 1909, '\p{Joining_Group=:\Aalef\z:}', "");;
    Expect(1, 1908, '\p{Joining_Group=-Alef}', "");
    Expect(0, 1908, '\p{^Joining_Group=-Alef}', "");
    Expect(0, 1908, '\P{Joining_Group=-Alef}', "");
    Expect(1, 1908, '\P{^Joining_Group=-Alef}', "");
    Expect(0, 1909, '\p{Joining_Group=-Alef}', "");
    Expect(1, 1909, '\p{^Joining_Group=-Alef}', "");
    Expect(1, 1909, '\P{Joining_Group=-Alef}', "");
    Expect(0, 1909, '\P{^Joining_Group=-Alef}', "");
    Error('\p{Jg=/a/ALEF}');
    Error('\P{Jg=/a/ALEF}');
    Expect(1, 1908, '\p{Jg=:\AAlef\z:}', "");;
    Expect(0, 1909, '\p{Jg=:\AAlef\z:}', "");;
    Expect(1, 1908, '\p{Jg=alef}', "");
    Expect(0, 1908, '\p{^Jg=alef}', "");
    Expect(0, 1908, '\P{Jg=alef}', "");
    Expect(1, 1908, '\P{^Jg=alef}', "");
    Expect(0, 1909, '\p{Jg=alef}', "");
    Expect(1, 1909, '\p{^Jg=alef}', "");
    Expect(1, 1909, '\P{Jg=alef}', "");
    Expect(0, 1909, '\P{^Jg=alef}', "");
    Expect(1, 1908, '\p{Jg=:\Aalef\z:}', "");;
    Expect(0, 1909, '\p{Jg=:\Aalef\z:}', "");;
    Expect(1, 1908, '\p{Jg=--alef}', "");
    Expect(0, 1908, '\p{^Jg=--alef}', "");
    Expect(0, 1908, '\P{Jg=--alef}', "");
    Expect(1, 1908, '\P{^Jg=--alef}', "");
    Expect(0, 1909, '\p{Jg=--alef}', "");
    Expect(1, 1909, '\p{^Jg=--alef}', "");
    Expect(1, 1909, '\P{Jg=--alef}', "");
    Expect(0, 1909, '\P{^Jg=--alef}', "");
    Error('\p{Is_Joining_Group= Alef/a/}');
    Error('\P{Is_Joining_Group= Alef/a/}');
    Expect(1, 1908, '\p{Is_Joining_Group=alef}', "");
    Expect(0, 1908, '\p{^Is_Joining_Group=alef}', "");
    Expect(0, 1908, '\P{Is_Joining_Group=alef}', "");
    Expect(1, 1908, '\P{^Is_Joining_Group=alef}', "");
    Expect(0, 1909, '\p{Is_Joining_Group=alef}', "");
    Expect(1, 1909, '\p{^Is_Joining_Group=alef}', "");
    Expect(1, 1909, '\P{Is_Joining_Group=alef}', "");
    Expect(0, 1909, '\P{^Is_Joining_Group=alef}', "");
    Expect(1, 1908, '\p{Is_Joining_Group=-	ALEF}', "");
    Expect(0, 1908, '\p{^Is_Joining_Group=-	ALEF}', "");
    Expect(0, 1908, '\P{Is_Joining_Group=-	ALEF}', "");
    Expect(1, 1908, '\P{^Is_Joining_Group=-	ALEF}', "");
    Expect(0, 1909, '\p{Is_Joining_Group=-	ALEF}', "");
    Expect(1, 1909, '\p{^Is_Joining_Group=-	ALEF}', "");
    Expect(1, 1909, '\P{Is_Joining_Group=-	ALEF}', "");
    Expect(0, 1909, '\P{^Is_Joining_Group=-	ALEF}', "");
    Error('\p{Is_Jg=:=alef}');
    Error('\P{Is_Jg=:=alef}');
    Expect(1, 1908, '\p{Is_Jg=alef}', "");
    Expect(0, 1908, '\p{^Is_Jg=alef}', "");
    Expect(0, 1908, '\P{Is_Jg=alef}', "");
    Expect(1, 1908, '\P{^Is_Jg=alef}', "");
    Expect(0, 1909, '\p{Is_Jg=alef}', "");
    Expect(1, 1909, '\p{^Is_Jg=alef}', "");
    Expect(1, 1909, '\P{Is_Jg=alef}', "");
    Expect(0, 1909, '\P{^Is_Jg=alef}', "");
    Expect(1, 1908, '\p{Is_Jg=- ALEF}', "");
    Expect(0, 1908, '\p{^Is_Jg=- ALEF}', "");
    Expect(0, 1908, '\P{Is_Jg=- ALEF}', "");
    Expect(1, 1908, '\P{^Is_Jg=- ALEF}', "");
    Expect(0, 1909, '\p{Is_Jg=- ALEF}', "");
    Expect(1, 1909, '\p{^Is_Jg=- ALEF}', "");
    Expect(1, 1909, '\P{Is_Jg=- ALEF}', "");
    Expect(0, 1909, '\P{^Is_Jg=- ALEF}', "");
    Error('\p{Joining_Group=/a/- Beh}');
    Error('\P{Joining_Group=/a/- Beh}');
    Expect(1, 2240, '\p{Joining_Group=:\ABeh\z:}', "");;
    Expect(0, 2241, '\p{Joining_Group=:\ABeh\z:}', "");;
    Expect(1, 2240, '\p{Joining_Group=beh}', "");
    Expect(0, 2240, '\p{^Joining_Group=beh}', "");
    Expect(0, 2240, '\P{Joining_Group=beh}', "");
    Expect(1, 2240, '\P{^Joining_Group=beh}', "");
    Expect(0, 2241, '\p{Joining_Group=beh}', "");
    Expect(1, 2241, '\p{^Joining_Group=beh}', "");
    Expect(1, 2241, '\P{Joining_Group=beh}', "");
    Expect(0, 2241, '\P{^Joining_Group=beh}', "");
    Expect(1, 2240, '\p{Joining_Group=:\Abeh\z:}', "");;
    Expect(0, 2241, '\p{Joining_Group=:\Abeh\z:}', "");;
    Expect(1, 2240, '\p{Joining_Group=-	Beh}', "");
    Expect(0, 2240, '\p{^Joining_Group=-	Beh}', "");
    Expect(0, 2240, '\P{Joining_Group=-	Beh}', "");
    Expect(1, 2240, '\P{^Joining_Group=-	Beh}', "");
    Expect(0, 2241, '\p{Joining_Group=-	Beh}', "");
    Expect(1, 2241, '\p{^Joining_Group=-	Beh}', "");
    Expect(1, 2241, '\P{Joining_Group=-	Beh}', "");
    Expect(0, 2241, '\P{^Joining_Group=-	Beh}', "");
    Error('\p{Jg=_	Beh:=}');
    Error('\P{Jg=_	Beh:=}');
    Expect(1, 2240, '\p{Jg=:\ABeh\z:}', "");;
    Expect(0, 2241, '\p{Jg=:\ABeh\z:}', "");;
    Expect(1, 2240, '\p{Jg=beh}', "");
    Expect(0, 2240, '\p{^Jg=beh}', "");
    Expect(0, 2240, '\P{Jg=beh}', "");
    Expect(1, 2240, '\P{^Jg=beh}', "");
    Expect(0, 2241, '\p{Jg=beh}', "");
    Expect(1, 2241, '\p{^Jg=beh}', "");
    Expect(1, 2241, '\P{Jg=beh}', "");
    Expect(0, 2241, '\P{^Jg=beh}', "");
    Expect(1, 2240, '\p{Jg=:\Abeh\z:}', "");;
    Expect(0, 2241, '\p{Jg=:\Abeh\z:}', "");;
    Expect(1, 2240, '\p{Jg= _beh}', "");
    Expect(0, 2240, '\p{^Jg= _beh}', "");
    Expect(0, 2240, '\P{Jg= _beh}', "");
    Expect(1, 2240, '\P{^Jg= _beh}', "");
    Expect(0, 2241, '\p{Jg= _beh}', "");
    Expect(1, 2241, '\p{^Jg= _beh}', "");
    Expect(1, 2241, '\P{Jg= _beh}', "");
    Expect(0, 2241, '\P{^Jg= _beh}', "");
    Error('\p{Is_Joining_Group= :=beh}');
    Error('\P{Is_Joining_Group= :=beh}');
    Expect(1, 2240, '\p{Is_Joining_Group=beh}', "");
    Expect(0, 2240, '\p{^Is_Joining_Group=beh}', "");
    Expect(0, 2240, '\P{Is_Joining_Group=beh}', "");
    Expect(1, 2240, '\P{^Is_Joining_Group=beh}', "");
    Expect(0, 2241, '\p{Is_Joining_Group=beh}', "");
    Expect(1, 2241, '\p{^Is_Joining_Group=beh}', "");
    Expect(1, 2241, '\P{Is_Joining_Group=beh}', "");
    Expect(0, 2241, '\P{^Is_Joining_Group=beh}', "");
    Expect(1, 2240, '\p{Is_Joining_Group= -Beh}', "");
    Expect(0, 2240, '\p{^Is_Joining_Group= -Beh}', "");
    Expect(0, 2240, '\P{Is_Joining_Group= -Beh}', "");
    Expect(1, 2240, '\P{^Is_Joining_Group= -Beh}', "");
    Expect(0, 2241, '\p{Is_Joining_Group= -Beh}', "");
    Expect(1, 2241, '\p{^Is_Joining_Group= -Beh}', "");
    Expect(1, 2241, '\P{Is_Joining_Group= -Beh}', "");
    Expect(0, 2241, '\P{^Is_Joining_Group= -Beh}', "");
    Error('\p{Is_Jg=/a/- beh}');
    Error('\P{Is_Jg=/a/- beh}');
    Expect(1, 2240, '\p{Is_Jg=beh}', "");
    Expect(0, 2240, '\p{^Is_Jg=beh}', "");
    Expect(0, 2240, '\P{Is_Jg=beh}', "");
    Expect(1, 2240, '\P{^Is_Jg=beh}', "");
    Expect(0, 2241, '\p{Is_Jg=beh}', "");
    Expect(1, 2241, '\p{^Is_Jg=beh}', "");
    Expect(1, 2241, '\P{Is_Jg=beh}', "");
    Expect(0, 2241, '\P{^Is_Jg=beh}', "");
    Expect(1, 2240, '\p{Is_Jg=_-BEH}', "");
    Expect(0, 2240, '\p{^Is_Jg=_-BEH}', "");
    Expect(0, 2240, '\P{Is_Jg=_-BEH}', "");
    Expect(1, 2240, '\P{^Is_Jg=_-BEH}', "");
    Expect(0, 2241, '\p{Is_Jg=_-BEH}', "");
    Expect(1, 2241, '\p{^Is_Jg=_-BEH}', "");
    Expect(1, 2241, '\P{Is_Jg=_-BEH}', "");
    Expect(0, 2241, '\P{^Is_Jg=_-BEH}', "");
    Error('\p{Joining_Group=:=BETH}');
    Error('\P{Joining_Group=:=BETH}');
    Expect(1, 1837, '\p{Joining_Group=:\ABeth\z:}', "");;
    Expect(0, 1838, '\p{Joining_Group=:\ABeth\z:}', "");;
    Expect(1, 1837, '\p{Joining_Group=beth}', "");
    Expect(0, 1837, '\p{^Joining_Group=beth}', "");
    Expect(0, 1837, '\P{Joining_Group=beth}', "");
    Expect(1, 1837, '\P{^Joining_Group=beth}', "");
    Expect(0, 1838, '\p{Joining_Group=beth}', "");
    Expect(1, 1838, '\p{^Joining_Group=beth}', "");
    Expect(1, 1838, '\P{Joining_Group=beth}', "");
    Expect(0, 1838, '\P{^Joining_Group=beth}', "");
    Expect(1, 1837, '\p{Joining_Group=:\Abeth\z:}', "");;
    Expect(0, 1838, '\p{Joining_Group=:\Abeth\z:}', "");;
    Expect(1, 1837, '\p{Joining_Group=	_Beth}', "");
    Expect(0, 1837, '\p{^Joining_Group=	_Beth}', "");
    Expect(0, 1837, '\P{Joining_Group=	_Beth}', "");
    Expect(1, 1837, '\P{^Joining_Group=	_Beth}', "");
    Expect(0, 1838, '\p{Joining_Group=	_Beth}', "");
    Expect(1, 1838, '\p{^Joining_Group=	_Beth}', "");
    Expect(1, 1838, '\P{Joining_Group=	_Beth}', "");
    Expect(0, 1838, '\P{^Joining_Group=	_Beth}', "");
    Error('\p{Jg=/a/__BETH}');
    Error('\P{Jg=/a/__BETH}');
    Expect(1, 1837, '\p{Jg=:\ABeth\z:}', "");;
    Expect(0, 1838, '\p{Jg=:\ABeth\z:}', "");;
    Expect(1, 1837, '\p{Jg=beth}', "");
    Expect(0, 1837, '\p{^Jg=beth}', "");
    Expect(0, 1837, '\P{Jg=beth}', "");
    Expect(1, 1837, '\P{^Jg=beth}', "");
    Expect(0, 1838, '\p{Jg=beth}', "");
    Expect(1, 1838, '\p{^Jg=beth}', "");
    Expect(1, 1838, '\P{Jg=beth}', "");
    Expect(0, 1838, '\P{^Jg=beth}', "");
    Expect(1, 1837, '\p{Jg=:\Abeth\z:}', "");;
    Expect(0, 1838, '\p{Jg=:\Abeth\z:}', "");;
    Expect(1, 1837, '\p{Jg=- BETH}', "");
    Expect(0, 1837, '\p{^Jg=- BETH}', "");
    Expect(0, 1837, '\P{Jg=- BETH}', "");
    Expect(1, 1837, '\P{^Jg=- BETH}', "");
    Expect(0, 1838, '\p{Jg=- BETH}', "");
    Expect(1, 1838, '\p{^Jg=- BETH}', "");
    Expect(1, 1838, '\P{Jg=- BETH}', "");
    Expect(0, 1838, '\P{^Jg=- BETH}', "");
    Error('\p{Is_Joining_Group=-_BETH/a/}');
    Error('\P{Is_Joining_Group=-_BETH/a/}');
    Expect(1, 1837, '\p{Is_Joining_Group=beth}', "");
    Expect(0, 1837, '\p{^Is_Joining_Group=beth}', "");
    Expect(0, 1837, '\P{Is_Joining_Group=beth}', "");
    Expect(1, 1837, '\P{^Is_Joining_Group=beth}', "");
    Expect(0, 1838, '\p{Is_Joining_Group=beth}', "");
    Expect(1, 1838, '\p{^Is_Joining_Group=beth}', "");
    Expect(1, 1838, '\P{Is_Joining_Group=beth}', "");
    Expect(0, 1838, '\P{^Is_Joining_Group=beth}', "");
    Expect(1, 1837, '\p{Is_Joining_Group=  BETH}', "");
    Expect(0, 1837, '\p{^Is_Joining_Group=  BETH}', "");
    Expect(0, 1837, '\P{Is_Joining_Group=  BETH}', "");
    Expect(1, 1837, '\P{^Is_Joining_Group=  BETH}', "");
    Expect(0, 1838, '\p{Is_Joining_Group=  BETH}', "");
    Expect(1, 1838, '\p{^Is_Joining_Group=  BETH}', "");
    Expect(1, 1838, '\P{Is_Joining_Group=  BETH}', "");
    Expect(0, 1838, '\P{^Is_Joining_Group=  BETH}', "");
    Error('\p{Is_Jg=/a/-	BETH}');
    Error('\P{Is_Jg=/a/-	BETH}');
    Expect(1, 1837, '\p{Is_Jg=beth}', "");
    Expect(0, 1837, '\p{^Is_Jg=beth}', "");
    Expect(0, 1837, '\P{Is_Jg=beth}', "");
    Expect(1, 1837, '\P{^Is_Jg=beth}', "");
    Expect(0, 1838, '\p{Is_Jg=beth}', "");
    Expect(1, 1838, '\p{^Is_Jg=beth}', "");
    Expect(1, 1838, '\P{Is_Jg=beth}', "");
    Expect(0, 1838, '\P{^Is_Jg=beth}', "");
    Expect(1, 1837, '\p{Is_Jg=	-Beth}', "");
    Expect(0, 1837, '\p{^Is_Jg=	-Beth}', "");
    Expect(0, 1837, '\P{Is_Jg=	-Beth}', "");
    Expect(1, 1837, '\P{^Is_Jg=	-Beth}', "");
    Expect(0, 1838, '\p{Is_Jg=	-Beth}', "");
    Expect(1, 1838, '\p{^Is_Jg=	-Beth}', "");
    Expect(1, 1838, '\P{Is_Jg=	-Beth}', "");
    Expect(0, 1838, '\P{^Is_Jg=	-Beth}', "");
    Error('\p{Joining_Group=:=BURUSHASKI_Yeh_Barree}');
    Error('\P{Joining_Group=:=BURUSHASKI_Yeh_Barree}');
    Expect(1, 1915, '\p{Joining_Group=:\ABurushaski_Yeh_Barree\z:}', "");;
    Expect(0, 1916, '\p{Joining_Group=:\ABurushaski_Yeh_Barree\z:}', "");;
    Expect(1, 1915, '\p{Joining_Group:burushaskiyehbarree}', "");
    Expect(0, 1915, '\p{^Joining_Group:burushaskiyehbarree}', "");
    Expect(0, 1915, '\P{Joining_Group:burushaskiyehbarree}', "");
    Expect(1, 1915, '\P{^Joining_Group:burushaskiyehbarree}', "");
    Expect(0, 1916, '\p{Joining_Group:burushaskiyehbarree}', "");
    Expect(1, 1916, '\p{^Joining_Group:burushaskiyehbarree}', "");
    Expect(1, 1916, '\P{Joining_Group:burushaskiyehbarree}', "");
    Expect(0, 1916, '\P{^Joining_Group:burushaskiyehbarree}', "");
    Expect(1, 1915, '\p{Joining_Group=:\Aburushaskiyehbarree\z:}', "");;
    Expect(0, 1916, '\p{Joining_Group=:\Aburushaskiyehbarree\z:}', "");;
    Expect(1, 1915, '\p{Joining_Group=	Burushaski_YEH_BARREE}', "");
    Expect(0, 1915, '\p{^Joining_Group=	Burushaski_YEH_BARREE}', "");
    Expect(0, 1915, '\P{Joining_Group=	Burushaski_YEH_BARREE}', "");
    Expect(1, 1915, '\P{^Joining_Group=	Burushaski_YEH_BARREE}', "");
    Expect(0, 1916, '\p{Joining_Group=	Burushaski_YEH_BARREE}', "");
    Expect(1, 1916, '\p{^Joining_Group=	Burushaski_YEH_BARREE}', "");
    Expect(1, 1916, '\P{Joining_Group=	Burushaski_YEH_BARREE}', "");
    Expect(0, 1916, '\P{^Joining_Group=	Burushaski_YEH_BARREE}', "");
    Error('\p{Jg=:=		BURUSHASKI_Yeh_BARREE}');
    Error('\P{Jg=:=		BURUSHASKI_Yeh_BARREE}');
    Expect(1, 1915, '\p{Jg=:\ABurushaski_Yeh_Barree\z:}', "");;
    Expect(0, 1916, '\p{Jg=:\ABurushaski_Yeh_Barree\z:}', "");;
    Expect(1, 1915, '\p{Jg=burushaskiyehbarree}', "");
    Expect(0, 1915, '\p{^Jg=burushaskiyehbarree}', "");
    Expect(0, 1915, '\P{Jg=burushaskiyehbarree}', "");
    Expect(1, 1915, '\P{^Jg=burushaskiyehbarree}', "");
    Expect(0, 1916, '\p{Jg=burushaskiyehbarree}', "");
    Expect(1, 1916, '\p{^Jg=burushaskiyehbarree}', "");
    Expect(1, 1916, '\P{Jg=burushaskiyehbarree}', "");
    Expect(0, 1916, '\P{^Jg=burushaskiyehbarree}', "");
    Expect(1, 1915, '\p{Jg=:\Aburushaskiyehbarree\z:}', "");;
    Expect(0, 1916, '\p{Jg=:\Aburushaskiyehbarree\z:}', "");;
    Expect(1, 1915, '\p{Jg=  Burushaski_Yeh_Barree}', "");
    Expect(0, 1915, '\p{^Jg=  Burushaski_Yeh_Barree}', "");
    Expect(0, 1915, '\P{Jg=  Burushaski_Yeh_Barree}', "");
    Expect(1, 1915, '\P{^Jg=  Burushaski_Yeh_Barree}', "");
    Expect(0, 1916, '\p{Jg=  Burushaski_Yeh_Barree}', "");
    Expect(1, 1916, '\p{^Jg=  Burushaski_Yeh_Barree}', "");
    Expect(1, 1916, '\P{Jg=  Burushaski_Yeh_Barree}', "");
    Expect(0, 1916, '\P{^Jg=  Burushaski_Yeh_Barree}', "");
    Error('\p{Is_Joining_Group=/a/_burushaski_yeh_Barree}');
    Error('\P{Is_Joining_Group=/a/_burushaski_yeh_Barree}');
    Expect(1, 1915, '\p{Is_Joining_Group=burushaskiyehbarree}', "");
    Expect(0, 1915, '\p{^Is_Joining_Group=burushaskiyehbarree}', "");
    Expect(0, 1915, '\P{Is_Joining_Group=burushaskiyehbarree}', "");
    Expect(1, 1915, '\P{^Is_Joining_Group=burushaskiyehbarree}', "");
    Expect(0, 1916, '\p{Is_Joining_Group=burushaskiyehbarree}', "");
    Expect(1, 1916, '\p{^Is_Joining_Group=burushaskiyehbarree}', "");
    Expect(1, 1916, '\P{Is_Joining_Group=burushaskiyehbarree}', "");
    Expect(0, 1916, '\P{^Is_Joining_Group=burushaskiyehbarree}', "");
    Expect(1, 1915, '\p{Is_Joining_Group=_	BURUSHASKI_yeh_BARREE}', "");
    Expect(0, 1915, '\p{^Is_Joining_Group=_	BURUSHASKI_yeh_BARREE}', "");
    Expect(0, 1915, '\P{Is_Joining_Group=_	BURUSHASKI_yeh_BARREE}', "");
    Expect(1, 1915, '\P{^Is_Joining_Group=_	BURUSHASKI_yeh_BARREE}', "");
    Expect(0, 1916, '\p{Is_Joining_Group=_	BURUSHASKI_yeh_BARREE}', "");
    Expect(1, 1916, '\p{^Is_Joining_Group=_	BURUSHASKI_yeh_BARREE}', "");
    Expect(1, 1916, '\P{Is_Joining_Group=_	BURUSHASKI_yeh_BARREE}', "");
    Expect(0, 1916, '\P{^Is_Joining_Group=_	BURUSHASKI_yeh_BARREE}', "");
    Error('\p{Is_Jg: :=-BURUSHASKI_Yeh_Barree}');
    Error('\P{Is_Jg: :=-BURUSHASKI_Yeh_Barree}');
    Expect(1, 1915, '\p{Is_Jg=burushaskiyehbarree}', "");
    Expect(0, 1915, '\p{^Is_Jg=burushaskiyehbarree}', "");
    Expect(0, 1915, '\P{Is_Jg=burushaskiyehbarree}', "");
    Expect(1, 1915, '\P{^Is_Jg=burushaskiyehbarree}', "");
    Expect(0, 1916, '\p{Is_Jg=burushaskiyehbarree}', "");
    Expect(1, 1916, '\p{^Is_Jg=burushaskiyehbarree}', "");
    Expect(1, 1916, '\P{Is_Jg=burushaskiyehbarree}', "");
    Expect(0, 1916, '\P{^Is_Jg=burushaskiyehbarree}', "");
    Expect(1, 1915, '\p{Is_Jg=-_burushaski_YEH_barree}', "");
    Expect(0, 1915, '\p{^Is_Jg=-_burushaski_YEH_barree}', "");
    Expect(0, 1915, '\P{Is_Jg=-_burushaski_YEH_barree}', "");
    Expect(1, 1915, '\P{^Is_Jg=-_burushaski_YEH_barree}', "");
    Expect(0, 1916, '\p{Is_Jg=-_burushaski_YEH_barree}', "");
    Expect(1, 1916, '\p{^Is_Jg=-_burushaski_YEH_barree}', "");
    Expect(1, 1916, '\P{Is_Jg=-_burushaski_YEH_barree}', "");
    Expect(0, 1916, '\P{^Is_Jg=-_burushaski_YEH_barree}', "");
    Error('\p{Joining_Group=_/a/DAL}');
    Error('\P{Joining_Group=_/a/DAL}');
    Expect(1, 2222, '\p{Joining_Group=:\ADal\z:}', "");;
    Expect(0, 2223, '\p{Joining_Group=:\ADal\z:}', "");;
    Expect(1, 2222, '\p{Joining_Group=dal}', "");
    Expect(0, 2222, '\p{^Joining_Group=dal}', "");
    Expect(0, 2222, '\P{Joining_Group=dal}', "");
    Expect(1, 2222, '\P{^Joining_Group=dal}', "");
    Expect(0, 2223, '\p{Joining_Group=dal}', "");
    Expect(1, 2223, '\p{^Joining_Group=dal}', "");
    Expect(1, 2223, '\P{Joining_Group=dal}', "");
    Expect(0, 2223, '\P{^Joining_Group=dal}', "");
    Expect(1, 2222, '\p{Joining_Group=:\Adal\z:}', "");;
    Expect(0, 2223, '\p{Joining_Group=:\Adal\z:}', "");;
    Expect(1, 2222, '\p{Joining_Group=	Dal}', "");
    Expect(0, 2222, '\p{^Joining_Group=	Dal}', "");
    Expect(0, 2222, '\P{Joining_Group=	Dal}', "");
    Expect(1, 2222, '\P{^Joining_Group=	Dal}', "");
    Expect(0, 2223, '\p{Joining_Group=	Dal}', "");
    Expect(1, 2223, '\p{^Joining_Group=	Dal}', "");
    Expect(1, 2223, '\P{Joining_Group=	Dal}', "");
    Expect(0, 2223, '\P{^Joining_Group=	Dal}', "");
    Error('\p{Jg= 	Dal:=}');
    Error('\P{Jg= 	Dal:=}');
    Expect(1, 2222, '\p{Jg=:\ADal\z:}', "");;
    Expect(0, 2223, '\p{Jg=:\ADal\z:}', "");;
    Expect(1, 2222, '\p{Jg=dal}', "");
    Expect(0, 2222, '\p{^Jg=dal}', "");
    Expect(0, 2222, '\P{Jg=dal}', "");
    Expect(1, 2222, '\P{^Jg=dal}', "");
    Expect(0, 2223, '\p{Jg=dal}', "");
    Expect(1, 2223, '\p{^Jg=dal}', "");
    Expect(1, 2223, '\P{Jg=dal}', "");
    Expect(0, 2223, '\P{^Jg=dal}', "");
    Expect(1, 2222, '\p{Jg=:\Adal\z:}', "");;
    Expect(0, 2223, '\p{Jg=:\Adal\z:}', "");;
    Expect(1, 2222, '\p{Jg=	Dal}', "");
    Expect(0, 2222, '\p{^Jg=	Dal}', "");
    Expect(0, 2222, '\P{Jg=	Dal}', "");
    Expect(1, 2222, '\P{^Jg=	Dal}', "");
    Expect(0, 2223, '\p{Jg=	Dal}', "");
    Expect(1, 2223, '\p{^Jg=	Dal}', "");
    Expect(1, 2223, '\P{Jg=	Dal}', "");
    Expect(0, 2223, '\P{^Jg=	Dal}', "");
    Error('\p{Is_Joining_Group=	-dal:=}');
    Error('\P{Is_Joining_Group=	-dal:=}');
    Expect(1, 2222, '\p{Is_Joining_Group=dal}', "");
    Expect(0, 2222, '\p{^Is_Joining_Group=dal}', "");
    Expect(0, 2222, '\P{Is_Joining_Group=dal}', "");
    Expect(1, 2222, '\P{^Is_Joining_Group=dal}', "");
    Expect(0, 2223, '\p{Is_Joining_Group=dal}', "");
    Expect(1, 2223, '\p{^Is_Joining_Group=dal}', "");
    Expect(1, 2223, '\P{Is_Joining_Group=dal}', "");
    Expect(0, 2223, '\P{^Is_Joining_Group=dal}', "");
    Expect(1, 2222, '\p{Is_Joining_Group=	_DAL}', "");
    Expect(0, 2222, '\p{^Is_Joining_Group=	_DAL}', "");
    Expect(0, 2222, '\P{Is_Joining_Group=	_DAL}', "");
    Expect(1, 2222, '\P{^Is_Joining_Group=	_DAL}', "");
    Expect(0, 2223, '\p{Is_Joining_Group=	_DAL}', "");
    Expect(1, 2223, '\p{^Is_Joining_Group=	_DAL}', "");
    Expect(1, 2223, '\P{Is_Joining_Group=	_DAL}', "");
    Expect(0, 2223, '\P{^Is_Joining_Group=	_DAL}', "");
    Error('\p{Is_Jg=	_Dal:=}');
    Error('\P{Is_Jg=	_Dal:=}');
    Expect(1, 2222, '\p{Is_Jg:dal}', "");
    Expect(0, 2222, '\p{^Is_Jg:dal}', "");
    Expect(0, 2222, '\P{Is_Jg:dal}', "");
    Expect(1, 2222, '\P{^Is_Jg:dal}', "");
    Expect(0, 2223, '\p{Is_Jg:dal}', "");
    Expect(1, 2223, '\p{^Is_Jg:dal}', "");
    Expect(1, 2223, '\P{Is_Jg:dal}', "");
    Expect(0, 2223, '\P{^Is_Jg:dal}', "");
    Expect(1, 2222, '\p{Is_Jg=_dal}', "");
    Expect(0, 2222, '\p{^Is_Jg=_dal}', "");
    Expect(0, 2222, '\P{Is_Jg=_dal}', "");
    Expect(1, 2222, '\P{^Is_Jg=_dal}', "");
    Expect(0, 2223, '\p{Is_Jg=_dal}', "");
    Expect(1, 2223, '\p{^Is_Jg=_dal}', "");
    Expect(1, 2223, '\P{Is_Jg=_dal}', "");
    Expect(0, 2223, '\P{^Is_Jg=_dal}', "");
    Error('\p{Joining_Group=:= _Dalath_RISH}');
    Error('\P{Joining_Group=:= _Dalath_RISH}');
    Expect(1, 1839, '\p{Joining_Group=:\ADalath_Rish\z:}', "");;
    Expect(0, 1840, '\p{Joining_Group=:\ADalath_Rish\z:}', "");;
    Expect(1, 1839, '\p{Joining_Group=dalathrish}', "");
    Expect(0, 1839, '\p{^Joining_Group=dalathrish}', "");
    Expect(0, 1839, '\P{Joining_Group=dalathrish}', "");
    Expect(1, 1839, '\P{^Joining_Group=dalathrish}', "");
    Expect(0, 1840, '\p{Joining_Group=dalathrish}', "");
    Expect(1, 1840, '\p{^Joining_Group=dalathrish}', "");
    Expect(1, 1840, '\P{Joining_Group=dalathrish}', "");
    Expect(0, 1840, '\P{^Joining_Group=dalathrish}', "");
    Expect(1, 1839, '\p{Joining_Group=:\Adalathrish\z:}', "");;
    Expect(0, 1840, '\p{Joining_Group=:\Adalathrish\z:}', "");;
    Expect(1, 1839, '\p{Joining_Group=dalath_RISH}', "");
    Expect(0, 1839, '\p{^Joining_Group=dalath_RISH}', "");
    Expect(0, 1839, '\P{Joining_Group=dalath_RISH}', "");
    Expect(1, 1839, '\P{^Joining_Group=dalath_RISH}', "");
    Expect(0, 1840, '\p{Joining_Group=dalath_RISH}', "");
    Expect(1, 1840, '\p{^Joining_Group=dalath_RISH}', "");
    Expect(1, 1840, '\P{Joining_Group=dalath_RISH}', "");
    Expect(0, 1840, '\P{^Joining_Group=dalath_RISH}', "");
    Error('\p{Jg=_	Dalath_rish:=}');
    Error('\P{Jg=_	Dalath_rish:=}');
    Expect(1, 1839, '\p{Jg=:\ADalath_Rish\z:}', "");;
    Expect(0, 1840, '\p{Jg=:\ADalath_Rish\z:}', "");;
    Expect(1, 1839, '\p{Jg=dalathrish}', "");
    Expect(0, 1839, '\p{^Jg=dalathrish}', "");
    Expect(0, 1839, '\P{Jg=dalathrish}', "");
    Expect(1, 1839, '\P{^Jg=dalathrish}', "");
    Expect(0, 1840, '\p{Jg=dalathrish}', "");
    Expect(1, 1840, '\p{^Jg=dalathrish}', "");
    Expect(1, 1840, '\P{Jg=dalathrish}', "");
    Expect(0, 1840, '\P{^Jg=dalathrish}', "");
    Expect(1, 1839, '\p{Jg=:\Adalathrish\z:}', "");;
    Expect(0, 1840, '\p{Jg=:\Adalathrish\z:}', "");;
    Expect(1, 1839, '\p{Jg=	_Dalath_Rish}', "");
    Expect(0, 1839, '\p{^Jg=	_Dalath_Rish}', "");
    Expect(0, 1839, '\P{Jg=	_Dalath_Rish}', "");
    Expect(1, 1839, '\P{^Jg=	_Dalath_Rish}', "");
    Expect(0, 1840, '\p{Jg=	_Dalath_Rish}', "");
    Expect(1, 1840, '\p{^Jg=	_Dalath_Rish}', "");
    Expect(1, 1840, '\P{Jg=	_Dalath_Rish}', "");
    Expect(0, 1840, '\P{^Jg=	_Dalath_Rish}', "");
    Error('\p{Is_Joining_Group=-_dalath_Rish:=}');
    Error('\P{Is_Joining_Group=-_dalath_Rish:=}');
    Expect(1, 1839, '\p{Is_Joining_Group=dalathrish}', "");
    Expect(0, 1839, '\p{^Is_Joining_Group=dalathrish}', "");
    Expect(0, 1839, '\P{Is_Joining_Group=dalathrish}', "");
    Expect(1, 1839, '\P{^Is_Joining_Group=dalathrish}', "");
    Expect(0, 1840, '\p{Is_Joining_Group=dalathrish}', "");
    Expect(1, 1840, '\p{^Is_Joining_Group=dalathrish}', "");
    Expect(1, 1840, '\P{Is_Joining_Group=dalathrish}', "");
    Expect(0, 1840, '\P{^Is_Joining_Group=dalathrish}', "");
    Expect(1, 1839, '\p{Is_Joining_Group:	_DALATH_Rish}', "");
    Expect(0, 1839, '\p{^Is_Joining_Group:	_DALATH_Rish}', "");
    Expect(0, 1839, '\P{Is_Joining_Group:	_DALATH_Rish}', "");
    Expect(1, 1839, '\P{^Is_Joining_Group:	_DALATH_Rish}', "");
    Expect(0, 1840, '\p{Is_Joining_Group:	_DALATH_Rish}', "");
    Expect(1, 1840, '\p{^Is_Joining_Group:	_DALATH_Rish}', "");
    Expect(1, 1840, '\P{Is_Joining_Group:	_DALATH_Rish}', "");
    Expect(0, 1840, '\P{^Is_Joining_Group:	_DALATH_Rish}', "");
    Error('\p{Is_Jg=-Dalath_RISH/a/}');
    Error('\P{Is_Jg=-Dalath_RISH/a/}');
    Expect(1, 1839, '\p{Is_Jg:dalathrish}', "");
    Expect(0, 1839, '\p{^Is_Jg:dalathrish}', "");
    Expect(0, 1839, '\P{Is_Jg:dalathrish}', "");
    Expect(1, 1839, '\P{^Is_Jg:dalathrish}', "");
    Expect(0, 1840, '\p{Is_Jg:dalathrish}', "");
    Expect(1, 1840, '\p{^Is_Jg:dalathrish}', "");
    Expect(1, 1840, '\P{Is_Jg:dalathrish}', "");
    Expect(0, 1840, '\P{^Is_Jg:dalathrish}', "");
    Expect(1, 1839, '\p{Is_Jg=-	Dalath_Rish}', "");
    Expect(0, 1839, '\p{^Is_Jg=-	Dalath_Rish}', "");
    Expect(0, 1839, '\P{Is_Jg=-	Dalath_Rish}', "");
    Expect(1, 1839, '\P{^Is_Jg=-	Dalath_Rish}', "");
    Expect(0, 1840, '\p{Is_Jg=-	Dalath_Rish}', "");
    Expect(1, 1840, '\p{^Is_Jg=-	Dalath_Rish}', "");
    Expect(1, 1840, '\P{Is_Jg=-	Dalath_Rish}', "");
    Expect(0, 1840, '\P{^Is_Jg=-	Dalath_Rish}', "");
    Error('\p{Joining_Group=/a/E}');
    Error('\P{Joining_Group=/a/E}');
    Expect(1, 1829, '\p{Joining_Group=:\AE\z:}', "");;
    Expect(0, 1830, '\p{Joining_Group=:\AE\z:}', "");;
    Expect(1, 1829, '\p{Joining_Group=e}', "");
    Expect(0, 1829, '\p{^Joining_Group=e}', "");
    Expect(0, 1829, '\P{Joining_Group=e}', "");
    Expect(1, 1829, '\P{^Joining_Group=e}', "");
    Expect(0, 1830, '\p{Joining_Group=e}', "");
    Expect(1, 1830, '\p{^Joining_Group=e}', "");
    Expect(1, 1830, '\P{Joining_Group=e}', "");
    Expect(0, 1830, '\P{^Joining_Group=e}', "");
    Expect(1, 1829, '\p{Joining_Group=:\Ae\z:}', "");;
    Expect(0, 1830, '\p{Joining_Group=:\Ae\z:}', "");;
    Expect(1, 1829, '\p{Joining_Group=_E}', "");
    Expect(0, 1829, '\p{^Joining_Group=_E}', "");
    Expect(0, 1829, '\P{Joining_Group=_E}', "");
    Expect(1, 1829, '\P{^Joining_Group=_E}', "");
    Expect(0, 1830, '\p{Joining_Group=_E}', "");
    Expect(1, 1830, '\p{^Joining_Group=_E}', "");
    Expect(1, 1830, '\P{Joining_Group=_E}', "");
    Expect(0, 1830, '\P{^Joining_Group=_E}', "");
    Error('\p{Jg=:= 	E}');
    Error('\P{Jg=:= 	E}');
    Expect(1, 1829, '\p{Jg=:\AE\z:}', "");;
    Expect(0, 1830, '\p{Jg=:\AE\z:}', "");;
    Expect(1, 1829, '\p{Jg=e}', "");
    Expect(0, 1829, '\p{^Jg=e}', "");
    Expect(0, 1829, '\P{Jg=e}', "");
    Expect(1, 1829, '\P{^Jg=e}', "");
    Expect(0, 1830, '\p{Jg=e}', "");
    Expect(1, 1830, '\p{^Jg=e}', "");
    Expect(1, 1830, '\P{Jg=e}', "");
    Expect(0, 1830, '\P{^Jg=e}', "");
    Expect(1, 1829, '\p{Jg=:\Ae\z:}', "");;
    Expect(0, 1830, '\p{Jg=:\Ae\z:}', "");;
    Expect(1, 1829, '\p{Jg=--e}', "");
    Expect(0, 1829, '\p{^Jg=--e}', "");
    Expect(0, 1829, '\P{Jg=--e}', "");
    Expect(1, 1829, '\P{^Jg=--e}', "");
    Expect(0, 1830, '\p{Jg=--e}', "");
    Expect(1, 1830, '\p{^Jg=--e}', "");
    Expect(1, 1830, '\P{Jg=--e}', "");
    Expect(0, 1830, '\P{^Jg=--e}', "");
    Error('\p{Is_Joining_Group=	 e:=}');
    Error('\P{Is_Joining_Group=	 e:=}');
    Expect(1, 1829, '\p{Is_Joining_Group:e}', "");
    Expect(0, 1829, '\p{^Is_Joining_Group:e}', "");
    Expect(0, 1829, '\P{Is_Joining_Group:e}', "");
    Expect(1, 1829, '\P{^Is_Joining_Group:e}', "");
    Expect(0, 1830, '\p{Is_Joining_Group:e}', "");
    Expect(1, 1830, '\p{^Is_Joining_Group:e}', "");
    Expect(1, 1830, '\P{Is_Joining_Group:e}', "");
    Expect(0, 1830, '\P{^Is_Joining_Group:e}', "");
    Expect(1, 1829, '\p{Is_Joining_Group= E}', "");
    Expect(0, 1829, '\p{^Is_Joining_Group= E}', "");
    Expect(0, 1829, '\P{Is_Joining_Group= E}', "");
    Expect(1, 1829, '\P{^Is_Joining_Group= E}', "");
    Expect(0, 1830, '\p{Is_Joining_Group= E}', "");
    Expect(1, 1830, '\p{^Is_Joining_Group= E}', "");
    Expect(1, 1830, '\P{Is_Joining_Group= E}', "");
    Expect(0, 1830, '\P{^Is_Joining_Group= E}', "");
    Error('\p{Is_Jg=:=	-E}');
    Error('\P{Is_Jg=:=	-E}');
    Expect(1, 1829, '\p{Is_Jg=e}', "");
    Expect(0, 1829, '\p{^Is_Jg=e}', "");
    Expect(0, 1829, '\P{Is_Jg=e}', "");
    Expect(1, 1829, '\P{^Is_Jg=e}', "");
    Expect(0, 1830, '\p{Is_Jg=e}', "");
    Expect(1, 1830, '\p{^Is_Jg=e}', "");
    Expect(1, 1830, '\P{Is_Jg=e}', "");
    Expect(0, 1830, '\P{^Is_Jg=e}', "");
    Expect(1, 1829, '\p{Is_Jg=  e}', "");
    Expect(0, 1829, '\p{^Is_Jg=  e}', "");
    Expect(0, 1829, '\P{Is_Jg=  e}', "");
    Expect(1, 1829, '\P{^Is_Jg=  e}', "");
    Expect(0, 1830, '\p{Is_Jg=  e}', "");
    Expect(1, 1830, '\p{^Is_Jg=  e}', "");
    Expect(1, 1830, '\P{Is_Jg=  e}', "");
    Expect(0, 1830, '\P{^Is_Jg=  e}', "");
    Error('\p{Joining_Group: -/a/Farsi_yeh}');
    Error('\P{Joining_Group: -/a/Farsi_yeh}');
    Expect(1, 1910, '\p{Joining_Group=:\AFarsi_Yeh\z:}', "");;
    Expect(0, 1911, '\p{Joining_Group=:\AFarsi_Yeh\z:}', "");;
    Expect(1, 1910, '\p{Joining_Group=farsiyeh}', "");
    Expect(0, 1910, '\p{^Joining_Group=farsiyeh}', "");
    Expect(0, 1910, '\P{Joining_Group=farsiyeh}', "");
    Expect(1, 1910, '\P{^Joining_Group=farsiyeh}', "");
    Expect(0, 1911, '\p{Joining_Group=farsiyeh}', "");
    Expect(1, 1911, '\p{^Joining_Group=farsiyeh}', "");
    Expect(1, 1911, '\P{Joining_Group=farsiyeh}', "");
    Expect(0, 1911, '\P{^Joining_Group=farsiyeh}', "");
    Expect(1, 1910, '\p{Joining_Group=:\Afarsiyeh\z:}', "");;
    Expect(0, 1911, '\p{Joining_Group=:\Afarsiyeh\z:}', "");;
    Expect(1, 1910, '\p{Joining_Group= -Farsi_Yeh}', "");
    Expect(0, 1910, '\p{^Joining_Group= -Farsi_Yeh}', "");
    Expect(0, 1910, '\P{Joining_Group= -Farsi_Yeh}', "");
    Expect(1, 1910, '\P{^Joining_Group= -Farsi_Yeh}', "");
    Expect(0, 1911, '\p{Joining_Group= -Farsi_Yeh}', "");
    Expect(1, 1911, '\p{^Joining_Group= -Farsi_Yeh}', "");
    Expect(1, 1911, '\P{Joining_Group= -Farsi_Yeh}', "");
    Expect(0, 1911, '\P{^Joining_Group= -Farsi_Yeh}', "");
    Error('\p{Jg=_:=farsi_yeh}');
    Error('\P{Jg=_:=farsi_yeh}');
    Expect(1, 1910, '\p{Jg=:\AFarsi_Yeh\z:}', "");;
    Expect(0, 1911, '\p{Jg=:\AFarsi_Yeh\z:}', "");;
    Expect(1, 1910, '\p{Jg:   farsiyeh}', "");
    Expect(0, 1910, '\p{^Jg:   farsiyeh}', "");
    Expect(0, 1910, '\P{Jg:   farsiyeh}', "");
    Expect(1, 1910, '\P{^Jg:   farsiyeh}', "");
    Expect(0, 1911, '\p{Jg:   farsiyeh}', "");
    Expect(1, 1911, '\p{^Jg:   farsiyeh}', "");
    Expect(1, 1911, '\P{Jg:   farsiyeh}', "");
    Expect(0, 1911, '\P{^Jg:   farsiyeh}', "");
    Expect(1, 1910, '\p{Jg=:\Afarsiyeh\z:}', "");;
    Expect(0, 1911, '\p{Jg=:\Afarsiyeh\z:}', "");;
    Expect(1, 1910, '\p{Jg=--FARSI_Yeh}', "");
    Expect(0, 1910, '\p{^Jg=--FARSI_Yeh}', "");
    Expect(0, 1910, '\P{Jg=--FARSI_Yeh}', "");
    Expect(1, 1910, '\P{^Jg=--FARSI_Yeh}', "");
    Expect(0, 1911, '\p{Jg=--FARSI_Yeh}', "");
    Expect(1, 1911, '\p{^Jg=--FARSI_Yeh}', "");
    Expect(1, 1911, '\P{Jg=--FARSI_Yeh}', "");
    Expect(0, 1911, '\P{^Jg=--FARSI_Yeh}', "");
    Error('\p{Is_Joining_Group=:=- Farsi_yeh}');
    Error('\P{Is_Joining_Group=:=- Farsi_yeh}');
    Expect(1, 1910, '\p{Is_Joining_Group=farsiyeh}', "");
    Expect(0, 1910, '\p{^Is_Joining_Group=farsiyeh}', "");
    Expect(0, 1910, '\P{Is_Joining_Group=farsiyeh}', "");
    Expect(1, 1910, '\P{^Is_Joining_Group=farsiyeh}', "");
    Expect(0, 1911, '\p{Is_Joining_Group=farsiyeh}', "");
    Expect(1, 1911, '\p{^Is_Joining_Group=farsiyeh}', "");
    Expect(1, 1911, '\P{Is_Joining_Group=farsiyeh}', "");
    Expect(0, 1911, '\P{^Is_Joining_Group=farsiyeh}', "");
    Expect(1, 1910, '\p{Is_Joining_Group=	Farsi_Yeh}', "");
    Expect(0, 1910, '\p{^Is_Joining_Group=	Farsi_Yeh}', "");
    Expect(0, 1910, '\P{Is_Joining_Group=	Farsi_Yeh}', "");
    Expect(1, 1910, '\P{^Is_Joining_Group=	Farsi_Yeh}', "");
    Expect(0, 1911, '\p{Is_Joining_Group=	Farsi_Yeh}', "");
    Expect(1, 1911, '\p{^Is_Joining_Group=	Farsi_Yeh}', "");
    Expect(1, 1911, '\P{Is_Joining_Group=	Farsi_Yeh}', "");
    Expect(0, 1911, '\P{^Is_Joining_Group=	Farsi_Yeh}', "");
    Error('\p{Is_Jg=	:=Farsi_Yeh}');
    Error('\P{Is_Jg=	:=Farsi_Yeh}');
    Expect(1, 1910, '\p{Is_Jg=farsiyeh}', "");
    Expect(0, 1910, '\p{^Is_Jg=farsiyeh}', "");
    Expect(0, 1910, '\P{Is_Jg=farsiyeh}', "");
    Expect(1, 1910, '\P{^Is_Jg=farsiyeh}', "");
    Expect(0, 1911, '\p{Is_Jg=farsiyeh}', "");
    Expect(1, 1911, '\p{^Is_Jg=farsiyeh}', "");
    Expect(1, 1911, '\P{Is_Jg=farsiyeh}', "");
    Expect(0, 1911, '\P{^Is_Jg=farsiyeh}', "");
    Expect(1, 1910, '\p{Is_Jg=-Farsi_YEH}', "");
    Expect(0, 1910, '\p{^Is_Jg=-Farsi_YEH}', "");
    Expect(0, 1910, '\P{Is_Jg=-Farsi_YEH}', "");
    Expect(1, 1910, '\P{^Is_Jg=-Farsi_YEH}', "");
    Expect(0, 1911, '\p{Is_Jg=-Farsi_YEH}', "");
    Expect(1, 1911, '\p{^Is_Jg=-Farsi_YEH}', "");
    Expect(1, 1911, '\P{Is_Jg=-Farsi_YEH}', "");
    Expect(0, 1911, '\P{^Is_Jg=-Farsi_YEH}', "");
    Error('\p{Joining_Group:		Fe:=}');
    Error('\P{Joining_Group:		Fe:=}');
    Expect(1, 1871, '\p{Joining_Group=:\AFe\z:}', "");;
    Expect(0, 1872, '\p{Joining_Group=:\AFe\z:}', "");;
    Expect(1, 1871, '\p{Joining_Group=fe}', "");
    Expect(0, 1871, '\p{^Joining_Group=fe}', "");
    Expect(0, 1871, '\P{Joining_Group=fe}', "");
    Expect(1, 1871, '\P{^Joining_Group=fe}', "");
    Expect(0, 1872, '\p{Joining_Group=fe}', "");
    Expect(1, 1872, '\p{^Joining_Group=fe}', "");
    Expect(1, 1872, '\P{Joining_Group=fe}', "");
    Expect(0, 1872, '\P{^Joining_Group=fe}', "");
    Expect(1, 1871, '\p{Joining_Group=:\Afe\z:}', "");;
    Expect(0, 1872, '\p{Joining_Group=:\Afe\z:}', "");;
    Expect(1, 1871, '\p{Joining_Group=__Fe}', "");
    Expect(0, 1871, '\p{^Joining_Group=__Fe}', "");
    Expect(0, 1871, '\P{Joining_Group=__Fe}', "");
    Expect(1, 1871, '\P{^Joining_Group=__Fe}', "");
    Expect(0, 1872, '\p{Joining_Group=__Fe}', "");
    Expect(1, 1872, '\p{^Joining_Group=__Fe}', "");
    Expect(1, 1872, '\P{Joining_Group=__Fe}', "");
    Expect(0, 1872, '\P{^Joining_Group=__Fe}', "");
    Error('\p{Jg=:=_	Fe}');
    Error('\P{Jg=:=_	Fe}');
    Expect(1, 1871, '\p{Jg=:\AFe\z:}', "");;
    Expect(0, 1872, '\p{Jg=:\AFe\z:}', "");;
    Expect(1, 1871, '\p{Jg=fe}', "");
    Expect(0, 1871, '\p{^Jg=fe}', "");
    Expect(0, 1871, '\P{Jg=fe}', "");
    Expect(1, 1871, '\P{^Jg=fe}', "");
    Expect(0, 1872, '\p{Jg=fe}', "");
    Expect(1, 1872, '\p{^Jg=fe}', "");
    Expect(1, 1872, '\P{Jg=fe}', "");
    Expect(0, 1872, '\P{^Jg=fe}', "");
    Expect(1, 1871, '\p{Jg=:\Afe\z:}', "");;
    Expect(0, 1872, '\p{Jg=:\Afe\z:}', "");;
    Expect(1, 1871, '\p{Jg=_-fe}', "");
    Expect(0, 1871, '\p{^Jg=_-fe}', "");
    Expect(0, 1871, '\P{Jg=_-fe}', "");
    Expect(1, 1871, '\P{^Jg=_-fe}', "");
    Expect(0, 1872, '\p{Jg=_-fe}', "");
    Expect(1, 1872, '\p{^Jg=_-fe}', "");
    Expect(1, 1872, '\P{Jg=_-fe}', "");
    Expect(0, 1872, '\P{^Jg=_-fe}', "");
    Error('\p{Is_Joining_Group=_:=Fe}');
    Error('\P{Is_Joining_Group=_:=Fe}');
    Expect(1, 1871, '\p{Is_Joining_Group=fe}', "");
    Expect(0, 1871, '\p{^Is_Joining_Group=fe}', "");
    Expect(0, 1871, '\P{Is_Joining_Group=fe}', "");
    Expect(1, 1871, '\P{^Is_Joining_Group=fe}', "");
    Expect(0, 1872, '\p{Is_Joining_Group=fe}', "");
    Expect(1, 1872, '\p{^Is_Joining_Group=fe}', "");
    Expect(1, 1872, '\P{Is_Joining_Group=fe}', "");
    Expect(0, 1872, '\P{^Is_Joining_Group=fe}', "");
    Expect(1, 1871, '\p{Is_Joining_Group=-	fe}', "");
    Expect(0, 1871, '\p{^Is_Joining_Group=-	fe}', "");
    Expect(0, 1871, '\P{Is_Joining_Group=-	fe}', "");
    Expect(1, 1871, '\P{^Is_Joining_Group=-	fe}', "");
    Expect(0, 1872, '\p{Is_Joining_Group=-	fe}', "");
    Expect(1, 1872, '\p{^Is_Joining_Group=-	fe}', "");
    Expect(1, 1872, '\P{Is_Joining_Group=-	fe}', "");
    Expect(0, 1872, '\P{^Is_Joining_Group=-	fe}', "");
    Error('\p{Is_Jg:	 fe/a/}');
    Error('\P{Is_Jg:	 fe/a/}');
    Expect(1, 1871, '\p{Is_Jg=fe}', "");
    Expect(0, 1871, '\p{^Is_Jg=fe}', "");
    Expect(0, 1871, '\P{Is_Jg=fe}', "");
    Expect(1, 1871, '\P{^Is_Jg=fe}', "");
    Expect(0, 1872, '\p{Is_Jg=fe}', "");
    Expect(1, 1872, '\p{^Is_Jg=fe}', "");
    Expect(1, 1872, '\P{Is_Jg=fe}', "");
    Expect(0, 1872, '\P{^Is_Jg=fe}', "");
    Expect(1, 1871, '\p{Is_Jg=_	Fe}', "");
    Expect(0, 1871, '\p{^Is_Jg=_	Fe}', "");
    Expect(0, 1871, '\P{Is_Jg=_	Fe}', "");
    Expect(1, 1871, '\P{^Is_Jg=_	Fe}', "");
    Expect(0, 1872, '\p{Is_Jg=_	Fe}', "");
    Expect(1, 1872, '\p{^Is_Jg=_	Fe}', "");
    Expect(1, 1872, '\P{Is_Jg=_	Fe}', "");
    Expect(0, 1872, '\P{^Is_Jg=_	Fe}', "");
    Error('\p{Joining_Group= :=FEH}');
    Error('\P{Joining_Group= :=FEH}');
    Expect(1, 2212, '\p{Joining_Group=:\AFeh\z:}', "");;
    Expect(0, 2213, '\p{Joining_Group=:\AFeh\z:}', "");;
    Expect(1, 2212, '\p{Joining_Group=feh}', "");
    Expect(0, 2212, '\p{^Joining_Group=feh}', "");
    Expect(0, 2212, '\P{Joining_Group=feh}', "");
    Expect(1, 2212, '\P{^Joining_Group=feh}', "");
    Expect(0, 2213, '\p{Joining_Group=feh}', "");
    Expect(1, 2213, '\p{^Joining_Group=feh}', "");
    Expect(1, 2213, '\P{Joining_Group=feh}', "");
    Expect(0, 2213, '\P{^Joining_Group=feh}', "");
    Expect(1, 2212, '\p{Joining_Group=:\Afeh\z:}', "");;
    Expect(0, 2213, '\p{Joining_Group=:\Afeh\z:}', "");;
    Expect(1, 2212, '\p{Joining_Group=__FEH}', "");
    Expect(0, 2212, '\p{^Joining_Group=__FEH}', "");
    Expect(0, 2212, '\P{Joining_Group=__FEH}', "");
    Expect(1, 2212, '\P{^Joining_Group=__FEH}', "");
    Expect(0, 2213, '\p{Joining_Group=__FEH}', "");
    Expect(1, 2213, '\p{^Joining_Group=__FEH}', "");
    Expect(1, 2213, '\P{Joining_Group=__FEH}', "");
    Expect(0, 2213, '\P{^Joining_Group=__FEH}', "");
    Error('\p{Jg:   -:=FEH}');
    Error('\P{Jg:   -:=FEH}');
    Expect(1, 2212, '\p{Jg=:\AFeh\z:}', "");;
    Expect(0, 2213, '\p{Jg=:\AFeh\z:}', "");;
    Expect(1, 2212, '\p{Jg=feh}', "");
    Expect(0, 2212, '\p{^Jg=feh}', "");
    Expect(0, 2212, '\P{Jg=feh}', "");
    Expect(1, 2212, '\P{^Jg=feh}', "");
    Expect(0, 2213, '\p{Jg=feh}', "");
    Expect(1, 2213, '\p{^Jg=feh}', "");
    Expect(1, 2213, '\P{Jg=feh}', "");
    Expect(0, 2213, '\P{^Jg=feh}', "");
    Expect(1, 2212, '\p{Jg=:\Afeh\z:}', "");;
    Expect(0, 2213, '\p{Jg=:\Afeh\z:}', "");;
    Expect(1, 2212, '\p{Jg:    FEH}', "");
    Expect(0, 2212, '\p{^Jg:    FEH}', "");
    Expect(0, 2212, '\P{Jg:    FEH}', "");
    Expect(1, 2212, '\P{^Jg:    FEH}', "");
    Expect(0, 2213, '\p{Jg:    FEH}', "");
    Expect(1, 2213, '\p{^Jg:    FEH}', "");
    Expect(1, 2213, '\P{Jg:    FEH}', "");
    Expect(0, 2213, '\P{^Jg:    FEH}', "");
    Error('\p{Is_Joining_Group=  feh/a/}');
    Error('\P{Is_Joining_Group=  feh/a/}');
    Expect(1, 2212, '\p{Is_Joining_Group=feh}', "");
    Expect(0, 2212, '\p{^Is_Joining_Group=feh}', "");
    Expect(0, 2212, '\P{Is_Joining_Group=feh}', "");
    Expect(1, 2212, '\P{^Is_Joining_Group=feh}', "");
    Expect(0, 2213, '\p{Is_Joining_Group=feh}', "");
    Expect(1, 2213, '\p{^Is_Joining_Group=feh}', "");
    Expect(1, 2213, '\P{Is_Joining_Group=feh}', "");
    Expect(0, 2213, '\P{^Is_Joining_Group=feh}', "");
    Expect(1, 2212, '\p{Is_Joining_Group=	-feh}', "");
    Expect(0, 2212, '\p{^Is_Joining_Group=	-feh}', "");
    Expect(0, 2212, '\P{Is_Joining_Group=	-feh}', "");
    Expect(1, 2212, '\P{^Is_Joining_Group=	-feh}', "");
    Expect(0, 2213, '\p{Is_Joining_Group=	-feh}', "");
    Expect(1, 2213, '\p{^Is_Joining_Group=	-feh}', "");
    Expect(1, 2213, '\P{Is_Joining_Group=	-feh}', "");
    Expect(0, 2213, '\P{^Is_Joining_Group=	-feh}', "");
    Error('\p{Is_Jg=/a/	feh}');
    Error('\P{Is_Jg=/a/	feh}');
    Expect(1, 2212, '\p{Is_Jg=feh}', "");
    Expect(0, 2212, '\p{^Is_Jg=feh}', "");
    Expect(0, 2212, '\P{Is_Jg=feh}', "");
    Expect(1, 2212, '\P{^Is_Jg=feh}', "");
    Expect(0, 2213, '\p{Is_Jg=feh}', "");
    Expect(1, 2213, '\p{^Is_Jg=feh}', "");
    Expect(1, 2213, '\P{Is_Jg=feh}', "");
    Expect(0, 2213, '\P{^Is_Jg=feh}', "");
    Expect(1, 2212, '\p{Is_Jg:-FEH}', "");
    Expect(0, 2212, '\p{^Is_Jg:-FEH}', "");
    Expect(0, 2212, '\P{Is_Jg:-FEH}', "");
    Expect(1, 2212, '\P{^Is_Jg:-FEH}', "");
    Expect(0, 2213, '\p{Is_Jg:-FEH}', "");
    Expect(1, 2213, '\p{^Is_Jg:-FEH}', "");
    Expect(1, 2213, '\P{Is_Jg:-FEH}', "");
    Expect(0, 2213, '\P{^Is_Jg:-FEH}', "");
    Error('\p{Joining_Group=/a/final_Semkath}');
    Error('\P{Joining_Group=/a/final_Semkath}');
    Expect(1, 1828, '\p{Joining_Group=:\AFinal_Semkath\z:}', "");;
    Expect(0, 1829, '\p{Joining_Group=:\AFinal_Semkath\z:}', "");;
    Expect(1, 1828, '\p{Joining_Group=finalsemkath}', "");
    Expect(0, 1828, '\p{^Joining_Group=finalsemkath}', "");
    Expect(0, 1828, '\P{Joining_Group=finalsemkath}', "");
    Expect(1, 1828, '\P{^Joining_Group=finalsemkath}', "");
    Expect(0, 1829, '\p{Joining_Group=finalsemkath}', "");
    Expect(1, 1829, '\p{^Joining_Group=finalsemkath}', "");
    Expect(1, 1829, '\P{Joining_Group=finalsemkath}', "");
    Expect(0, 1829, '\P{^Joining_Group=finalsemkath}', "");
    Expect(1, 1828, '\p{Joining_Group=:\Afinalsemkath\z:}', "");;
    Expect(0, 1829, '\p{Joining_Group=:\Afinalsemkath\z:}', "");;
    Expect(1, 1828, '\p{Joining_Group= Final_SEMKATH}', "");
    Expect(0, 1828, '\p{^Joining_Group= Final_SEMKATH}', "");
    Expect(0, 1828, '\P{Joining_Group= Final_SEMKATH}', "");
    Expect(1, 1828, '\P{^Joining_Group= Final_SEMKATH}', "");
    Expect(0, 1829, '\p{Joining_Group= Final_SEMKATH}', "");
    Expect(1, 1829, '\p{^Joining_Group= Final_SEMKATH}', "");
    Expect(1, 1829, '\P{Joining_Group= Final_SEMKATH}', "");
    Expect(0, 1829, '\P{^Joining_Group= Final_SEMKATH}', "");
    Error('\p{Jg=-/a/Final_Semkath}');
    Error('\P{Jg=-/a/Final_Semkath}');
    Expect(1, 1828, '\p{Jg=:\AFinal_Semkath\z:}', "");;
    Expect(0, 1829, '\p{Jg=:\AFinal_Semkath\z:}', "");;
    Expect(1, 1828, '\p{Jg=finalsemkath}', "");
    Expect(0, 1828, '\p{^Jg=finalsemkath}', "");
    Expect(0, 1828, '\P{Jg=finalsemkath}', "");
    Expect(1, 1828, '\P{^Jg=finalsemkath}', "");
    Expect(0, 1829, '\p{Jg=finalsemkath}', "");
    Expect(1, 1829, '\p{^Jg=finalsemkath}', "");
    Expect(1, 1829, '\P{Jg=finalsemkath}', "");
    Expect(0, 1829, '\P{^Jg=finalsemkath}', "");
    Expect(1, 1828, '\p{Jg=:\Afinalsemkath\z:}', "");;
    Expect(0, 1829, '\p{Jg=:\Afinalsemkath\z:}', "");;
    Expect(1, 1828, '\p{Jg=-	Final_Semkath}', "");
    Expect(0, 1828, '\p{^Jg=-	Final_Semkath}', "");
    Expect(0, 1828, '\P{Jg=-	Final_Semkath}', "");
    Expect(1, 1828, '\P{^Jg=-	Final_Semkath}', "");
    Expect(0, 1829, '\p{Jg=-	Final_Semkath}', "");
    Expect(1, 1829, '\p{^Jg=-	Final_Semkath}', "");
    Expect(1, 1829, '\P{Jg=-	Final_Semkath}', "");
    Expect(0, 1829, '\P{^Jg=-	Final_Semkath}', "");
    Error('\p{Is_Joining_Group:     final_semkath:=}');
    Error('\P{Is_Joining_Group:     final_semkath:=}');
    Expect(1, 1828, '\p{Is_Joining_Group=finalsemkath}', "");
    Expect(0, 1828, '\p{^Is_Joining_Group=finalsemkath}', "");
    Expect(0, 1828, '\P{Is_Joining_Group=finalsemkath}', "");
    Expect(1, 1828, '\P{^Is_Joining_Group=finalsemkath}', "");
    Expect(0, 1829, '\p{Is_Joining_Group=finalsemkath}', "");
    Expect(1, 1829, '\p{^Is_Joining_Group=finalsemkath}', "");
    Expect(1, 1829, '\P{Is_Joining_Group=finalsemkath}', "");
    Expect(0, 1829, '\P{^Is_Joining_Group=finalsemkath}', "");
    Expect(1, 1828, '\p{Is_Joining_Group= -Final_semkath}', "");
    Expect(0, 1828, '\p{^Is_Joining_Group= -Final_semkath}', "");
    Expect(0, 1828, '\P{Is_Joining_Group= -Final_semkath}', "");
    Expect(1, 1828, '\P{^Is_Joining_Group= -Final_semkath}', "");
    Expect(0, 1829, '\p{Is_Joining_Group= -Final_semkath}', "");
    Expect(1, 1829, '\p{^Is_Joining_Group= -Final_semkath}', "");
    Expect(1, 1829, '\P{Is_Joining_Group= -Final_semkath}', "");
    Expect(0, 1829, '\P{^Is_Joining_Group= -Final_semkath}', "");
    Error('\p{Is_Jg=/a/ _FINAL_semkath}');
    Error('\P{Is_Jg=/a/ _FINAL_semkath}');
    Expect(1, 1828, '\p{Is_Jg=finalsemkath}', "");
    Expect(0, 1828, '\p{^Is_Jg=finalsemkath}', "");
    Expect(0, 1828, '\P{Is_Jg=finalsemkath}', "");
    Expect(1, 1828, '\P{^Is_Jg=finalsemkath}', "");
    Expect(0, 1829, '\p{Is_Jg=finalsemkath}', "");
    Expect(1, 1829, '\p{^Is_Jg=finalsemkath}', "");
    Expect(1, 1829, '\P{Is_Jg=finalsemkath}', "");
    Expect(0, 1829, '\P{^Is_Jg=finalsemkath}', "");
    Expect(1, 1828, '\p{Is_Jg=-Final_Semkath}', "");
    Expect(0, 1828, '\p{^Is_Jg=-Final_Semkath}', "");
    Expect(0, 1828, '\P{Is_Jg=-Final_Semkath}', "");
    Expect(1, 1828, '\P{^Is_Jg=-Final_Semkath}', "");
    Expect(0, 1829, '\p{Is_Jg=-Final_Semkath}', "");
    Expect(1, 1829, '\p{^Is_Jg=-Final_Semkath}', "");
    Expect(1, 1829, '\P{Is_Jg=-Final_Semkath}', "");
    Expect(0, 1829, '\P{^Is_Jg=-Final_Semkath}', "");
    Error('\p{Joining_Group=-/a/Gaf}');
    Error('\P{Joining_Group=-/a/Gaf}');
    Expect(1, 2242, '\p{Joining_Group=:\AGaf\z:}', "");;
    Expect(0, 2243, '\p{Joining_Group=:\AGaf\z:}', "");;
    Expect(1, 2242, '\p{Joining_Group=gaf}', "");
    Expect(0, 2242, '\p{^Joining_Group=gaf}', "");
    Expect(0, 2242, '\P{Joining_Group=gaf}', "");
    Expect(1, 2242, '\P{^Joining_Group=gaf}', "");
    Expect(0, 2243, '\p{Joining_Group=gaf}', "");
    Expect(1, 2243, '\p{^Joining_Group=gaf}', "");
    Expect(1, 2243, '\P{Joining_Group=gaf}', "");
    Expect(0, 2243, '\P{^Joining_Group=gaf}', "");
    Expect(1, 2242, '\p{Joining_Group=:\Agaf\z:}', "");;
    Expect(0, 2243, '\p{Joining_Group=:\Agaf\z:}', "");;
    Expect(1, 2242, '\p{Joining_Group=--gaf}', "");
    Expect(0, 2242, '\p{^Joining_Group=--gaf}', "");
    Expect(0, 2242, '\P{Joining_Group=--gaf}', "");
    Expect(1, 2242, '\P{^Joining_Group=--gaf}', "");
    Expect(0, 2243, '\p{Joining_Group=--gaf}', "");
    Expect(1, 2243, '\p{^Joining_Group=--gaf}', "");
    Expect(1, 2243, '\P{Joining_Group=--gaf}', "");
    Expect(0, 2243, '\P{^Joining_Group=--gaf}', "");
    Error('\p{Jg=/a/	Gaf}');
    Error('\P{Jg=/a/	Gaf}');
    Expect(1, 2242, '\p{Jg=:\AGaf\z:}', "");;
    Expect(0, 2243, '\p{Jg=:\AGaf\z:}', "");;
    Expect(1, 2242, '\p{Jg=gaf}', "");
    Expect(0, 2242, '\p{^Jg=gaf}', "");
    Expect(0, 2242, '\P{Jg=gaf}', "");
    Expect(1, 2242, '\P{^Jg=gaf}', "");
    Expect(0, 2243, '\p{Jg=gaf}', "");
    Expect(1, 2243, '\p{^Jg=gaf}', "");
    Expect(1, 2243, '\P{Jg=gaf}', "");
    Expect(0, 2243, '\P{^Jg=gaf}', "");
    Expect(1, 2242, '\p{Jg=:\Agaf\z:}', "");;
    Expect(0, 2243, '\p{Jg=:\Agaf\z:}', "");;
    Expect(1, 2242, '\p{Jg=	_Gaf}', "");
    Expect(0, 2242, '\p{^Jg=	_Gaf}', "");
    Expect(0, 2242, '\P{Jg=	_Gaf}', "");
    Expect(1, 2242, '\P{^Jg=	_Gaf}', "");
    Expect(0, 2243, '\p{Jg=	_Gaf}', "");
    Expect(1, 2243, '\p{^Jg=	_Gaf}', "");
    Expect(1, 2243, '\P{Jg=	_Gaf}', "");
    Expect(0, 2243, '\P{^Jg=	_Gaf}', "");
    Error('\p{Is_Joining_Group=-/a/GAF}');
    Error('\P{Is_Joining_Group=-/a/GAF}');
    Expect(1, 2242, '\p{Is_Joining_Group=gaf}', "");
    Expect(0, 2242, '\p{^Is_Joining_Group=gaf}', "");
    Expect(0, 2242, '\P{Is_Joining_Group=gaf}', "");
    Expect(1, 2242, '\P{^Is_Joining_Group=gaf}', "");
    Expect(0, 2243, '\p{Is_Joining_Group=gaf}', "");
    Expect(1, 2243, '\p{^Is_Joining_Group=gaf}', "");
    Expect(1, 2243, '\P{Is_Joining_Group=gaf}', "");
    Expect(0, 2243, '\P{^Is_Joining_Group=gaf}', "");
    Expect(1, 2242, '\p{Is_Joining_Group=Gaf}', "");
    Expect(0, 2242, '\p{^Is_Joining_Group=Gaf}', "");
    Expect(0, 2242, '\P{Is_Joining_Group=Gaf}', "");
    Expect(1, 2242, '\P{^Is_Joining_Group=Gaf}', "");
    Expect(0, 2243, '\p{Is_Joining_Group=Gaf}', "");
    Expect(1, 2243, '\p{^Is_Joining_Group=Gaf}', "");
    Expect(1, 2243, '\P{Is_Joining_Group=Gaf}', "");
    Expect(0, 2243, '\P{^Is_Joining_Group=Gaf}', "");
    Error('\p{Is_Jg=_:=Gaf}');
    Error('\P{Is_Jg=_:=Gaf}');
    Expect(1, 2242, '\p{Is_Jg=gaf}', "");
    Expect(0, 2242, '\p{^Is_Jg=gaf}', "");
    Expect(0, 2242, '\P{Is_Jg=gaf}', "");
    Expect(1, 2242, '\P{^Is_Jg=gaf}', "");
    Expect(0, 2243, '\p{Is_Jg=gaf}', "");
    Expect(1, 2243, '\p{^Is_Jg=gaf}', "");
    Expect(1, 2243, '\P{Is_Jg=gaf}', "");
    Expect(0, 2243, '\P{^Is_Jg=gaf}', "");
    Expect(1, 2242, '\p{Is_Jg=-_GAF}', "");
    Expect(0, 2242, '\p{^Is_Jg=-_GAF}', "");
    Expect(0, 2242, '\P{Is_Jg=-_GAF}', "");
    Expect(1, 2242, '\P{^Is_Jg=-_GAF}', "");
    Expect(0, 2243, '\p{Is_Jg=-_GAF}', "");
    Expect(1, 2243, '\p{^Is_Jg=-_GAF}', "");
    Expect(1, 2243, '\P{Is_Jg=-_GAF}', "");
    Expect(0, 2243, '\P{^Is_Jg=-_GAF}', "");
    Error('\p{Joining_Group=	_Gamal/a/}');
    Error('\P{Joining_Group=	_Gamal/a/}');
    Expect(1, 1838, '\p{Joining_Group=:\AGamal\z:}', "");;
    Expect(0, 1839, '\p{Joining_Group=:\AGamal\z:}', "");;
    Expect(1, 1838, '\p{Joining_Group=gamal}', "");
    Expect(0, 1838, '\p{^Joining_Group=gamal}', "");
    Expect(0, 1838, '\P{Joining_Group=gamal}', "");
    Expect(1, 1838, '\P{^Joining_Group=gamal}', "");
    Expect(0, 1839, '\p{Joining_Group=gamal}', "");
    Expect(1, 1839, '\p{^Joining_Group=gamal}', "");
    Expect(1, 1839, '\P{Joining_Group=gamal}', "");
    Expect(0, 1839, '\P{^Joining_Group=gamal}', "");
    Expect(1, 1838, '\p{Joining_Group=:\Agamal\z:}', "");;
    Expect(0, 1839, '\p{Joining_Group=:\Agamal\z:}', "");;
    Expect(1, 1838, '\p{Joining_Group=_-Gamal}', "");
    Expect(0, 1838, '\p{^Joining_Group=_-Gamal}', "");
    Expect(0, 1838, '\P{Joining_Group=_-Gamal}', "");
    Expect(1, 1838, '\P{^Joining_Group=_-Gamal}', "");
    Expect(0, 1839, '\p{Joining_Group=_-Gamal}', "");
    Expect(1, 1839, '\p{^Joining_Group=_-Gamal}', "");
    Expect(1, 1839, '\P{Joining_Group=_-Gamal}', "");
    Expect(0, 1839, '\P{^Joining_Group=_-Gamal}', "");
    Error('\p{Jg=-GAMAL:=}');
    Error('\P{Jg=-GAMAL:=}');
    Expect(1, 1838, '\p{Jg=:\AGamal\z:}', "");;
    Expect(0, 1839, '\p{Jg=:\AGamal\z:}', "");;
    Expect(1, 1838, '\p{Jg=gamal}', "");
    Expect(0, 1838, '\p{^Jg=gamal}', "");
    Expect(0, 1838, '\P{Jg=gamal}', "");
    Expect(1, 1838, '\P{^Jg=gamal}', "");
    Expect(0, 1839, '\p{Jg=gamal}', "");
    Expect(1, 1839, '\p{^Jg=gamal}', "");
    Expect(1, 1839, '\P{Jg=gamal}', "");
    Expect(0, 1839, '\P{^Jg=gamal}', "");
    Expect(1, 1838, '\p{Jg=:\Agamal\z:}', "");;
    Expect(0, 1839, '\p{Jg=:\Agamal\z:}', "");;
    Expect(1, 1838, '\p{Jg= GAMAL}', "");
    Expect(0, 1838, '\p{^Jg= GAMAL}', "");
    Expect(0, 1838, '\P{Jg= GAMAL}', "");
    Expect(1, 1838, '\P{^Jg= GAMAL}', "");
    Expect(0, 1839, '\p{Jg= GAMAL}', "");
    Expect(1, 1839, '\p{^Jg= GAMAL}', "");
    Expect(1, 1839, '\P{Jg= GAMAL}', "");
    Expect(0, 1839, '\P{^Jg= GAMAL}', "");
    Error('\p{Is_Joining_Group=	Gamal/a/}');
    Error('\P{Is_Joining_Group=	Gamal/a/}');
    Expect(1, 1838, '\p{Is_Joining_Group=gamal}', "");
    Expect(0, 1838, '\p{^Is_Joining_Group=gamal}', "");
    Expect(0, 1838, '\P{Is_Joining_Group=gamal}', "");
    Expect(1, 1838, '\P{^Is_Joining_Group=gamal}', "");
    Expect(0, 1839, '\p{Is_Joining_Group=gamal}', "");
    Expect(1, 1839, '\p{^Is_Joining_Group=gamal}', "");
    Expect(1, 1839, '\P{Is_Joining_Group=gamal}', "");
    Expect(0, 1839, '\P{^Is_Joining_Group=gamal}', "");
    Expect(1, 1838, '\p{Is_Joining_Group=_Gamal}', "");
    Expect(0, 1838, '\p{^Is_Joining_Group=_Gamal}', "");
    Expect(0, 1838, '\P{Is_Joining_Group=_Gamal}', "");
    Expect(1, 1838, '\P{^Is_Joining_Group=_Gamal}', "");
    Expect(0, 1839, '\p{Is_Joining_Group=_Gamal}', "");
    Expect(1, 1839, '\p{^Is_Joining_Group=_Gamal}', "");
    Expect(1, 1839, '\P{Is_Joining_Group=_Gamal}', "");
    Expect(0, 1839, '\P{^Is_Joining_Group=_Gamal}', "");
    Error('\p{Is_Jg=:=GAMAL}');
    Error('\P{Is_Jg=:=GAMAL}');
    Expect(1, 1838, '\p{Is_Jg=gamal}', "");
    Expect(0, 1838, '\p{^Is_Jg=gamal}', "");
    Expect(0, 1838, '\P{Is_Jg=gamal}', "");
    Expect(1, 1838, '\P{^Is_Jg=gamal}', "");
    Expect(0, 1839, '\p{Is_Jg=gamal}', "");
    Expect(1, 1839, '\p{^Is_Jg=gamal}', "");
    Expect(1, 1839, '\P{Is_Jg=gamal}', "");
    Expect(0, 1839, '\P{^Is_Jg=gamal}', "");
    Expect(1, 1838, '\p{Is_Jg: -_Gamal}', "");
    Expect(0, 1838, '\p{^Is_Jg: -_Gamal}', "");
    Expect(0, 1838, '\P{Is_Jg: -_Gamal}', "");
    Expect(1, 1838, '\P{^Is_Jg: -_Gamal}', "");
    Expect(0, 1839, '\p{Is_Jg: -_Gamal}', "");
    Expect(1, 1839, '\p{^Is_Jg: -_Gamal}', "");
    Expect(1, 1839, '\P{Is_Jg: -_Gamal}', "");
    Expect(0, 1839, '\P{^Is_Jg: -_Gamal}', "");
    Error('\p{Joining_Group=_Hah:=}');
    Error('\P{Joining_Group=_Hah:=}');
    Expect(1, 2246, '\p{Joining_Group=:\AHah\z:}', "");;
    Expect(0, 2247, '\p{Joining_Group=:\AHah\z:}', "");;
    Expect(1, 2246, '\p{Joining_Group=hah}', "");
    Expect(0, 2246, '\p{^Joining_Group=hah}', "");
    Expect(0, 2246, '\P{Joining_Group=hah}', "");
    Expect(1, 2246, '\P{^Joining_Group=hah}', "");
    Expect(0, 2247, '\p{Joining_Group=hah}', "");
    Expect(1, 2247, '\p{^Joining_Group=hah}', "");
    Expect(1, 2247, '\P{Joining_Group=hah}', "");
    Expect(0, 2247, '\P{^Joining_Group=hah}', "");
    Expect(1, 2246, '\p{Joining_Group=:\Ahah\z:}', "");;
    Expect(0, 2247, '\p{Joining_Group=:\Ahah\z:}', "");;
    Expect(1, 2246, '\p{Joining_Group=-Hah}', "");
    Expect(0, 2246, '\p{^Joining_Group=-Hah}', "");
    Expect(0, 2246, '\P{Joining_Group=-Hah}', "");
    Expect(1, 2246, '\P{^Joining_Group=-Hah}', "");
    Expect(0, 2247, '\p{Joining_Group=-Hah}', "");
    Expect(1, 2247, '\p{^Joining_Group=-Hah}', "");
    Expect(1, 2247, '\P{Joining_Group=-Hah}', "");
    Expect(0, 2247, '\P{^Joining_Group=-Hah}', "");
    Error('\p{Jg= /a/Hah}');
    Error('\P{Jg= /a/Hah}');
    Expect(1, 2246, '\p{Jg=:\AHah\z:}', "");;
    Expect(0, 2247, '\p{Jg=:\AHah\z:}', "");;
    Expect(1, 2246, '\p{Jg=hah}', "");
    Expect(0, 2246, '\p{^Jg=hah}', "");
    Expect(0, 2246, '\P{Jg=hah}', "");
    Expect(1, 2246, '\P{^Jg=hah}', "");
    Expect(0, 2247, '\p{Jg=hah}', "");
    Expect(1, 2247, '\p{^Jg=hah}', "");
    Expect(1, 2247, '\P{Jg=hah}', "");
    Expect(0, 2247, '\P{^Jg=hah}', "");
    Expect(1, 2246, '\p{Jg=:\Ahah\z:}', "");;
    Expect(0, 2247, '\p{Jg=:\Ahah\z:}', "");;
    Expect(1, 2246, '\p{Jg:	-HAH}', "");
    Expect(0, 2246, '\p{^Jg:	-HAH}', "");
    Expect(0, 2246, '\P{Jg:	-HAH}', "");
    Expect(1, 2246, '\P{^Jg:	-HAH}', "");
    Expect(0, 2247, '\p{Jg:	-HAH}', "");
    Expect(1, 2247, '\p{^Jg:	-HAH}', "");
    Expect(1, 2247, '\P{Jg:	-HAH}', "");
    Expect(0, 2247, '\P{^Jg:	-HAH}', "");
    Error('\p{Is_Joining_Group=_/a/hah}');
    Error('\P{Is_Joining_Group=_/a/hah}');
    Expect(1, 2246, '\p{Is_Joining_Group=hah}', "");
    Expect(0, 2246, '\p{^Is_Joining_Group=hah}', "");
    Expect(0, 2246, '\P{Is_Joining_Group=hah}', "");
    Expect(1, 2246, '\P{^Is_Joining_Group=hah}', "");
    Expect(0, 2247, '\p{Is_Joining_Group=hah}', "");
    Expect(1, 2247, '\p{^Is_Joining_Group=hah}', "");
    Expect(1, 2247, '\P{Is_Joining_Group=hah}', "");
    Expect(0, 2247, '\P{^Is_Joining_Group=hah}', "");
    Expect(1, 2246, '\p{Is_Joining_Group=	Hah}', "");
    Expect(0, 2246, '\p{^Is_Joining_Group=	Hah}', "");
    Expect(0, 2246, '\P{Is_Joining_Group=	Hah}', "");
    Expect(1, 2246, '\P{^Is_Joining_Group=	Hah}', "");
    Expect(0, 2247, '\p{Is_Joining_Group=	Hah}', "");
    Expect(1, 2247, '\p{^Is_Joining_Group=	Hah}', "");
    Expect(1, 2247, '\P{Is_Joining_Group=	Hah}', "");
    Expect(0, 2247, '\P{^Is_Joining_Group=	Hah}', "");
    Error('\p{Is_Jg=  Hah:=}');
    Error('\P{Is_Jg=  Hah:=}');
    Expect(1, 2246, '\p{Is_Jg=hah}', "");
    Expect(0, 2246, '\p{^Is_Jg=hah}', "");
    Expect(0, 2246, '\P{Is_Jg=hah}', "");
    Expect(1, 2246, '\P{^Is_Jg=hah}', "");
    Expect(0, 2247, '\p{Is_Jg=hah}', "");
    Expect(1, 2247, '\p{^Is_Jg=hah}', "");
    Expect(1, 2247, '\P{Is_Jg=hah}', "");
    Expect(0, 2247, '\P{^Is_Jg=hah}', "");
    Expect(1, 2246, '\p{Is_Jg=__Hah}', "");
    Expect(0, 2246, '\p{^Is_Jg=__Hah}', "");
    Expect(0, 2246, '\P{Is_Jg=__Hah}', "");
    Expect(1, 2246, '\P{^Is_Jg=__Hah}', "");
    Expect(0, 2247, '\p{Is_Jg=__Hah}', "");
    Expect(1, 2247, '\p{^Is_Jg=__Hah}', "");
    Expect(1, 2247, '\P{Is_Jg=__Hah}', "");
    Expect(0, 2247, '\P{^Is_Jg=__Hah}', "");
    Error('\p{Joining_Group=-/a/hanifi_rohingya_kinna_ya}');
    Error('\P{Joining_Group=-/a/hanifi_rohingya_kinna_ya}');
    Expect(1, 68899, '\p{Joining_Group=:\AHanifi_Rohingya_Kinna_Ya\z:}', "");;
    Expect(0, 68900, '\p{Joining_Group=:\AHanifi_Rohingya_Kinna_Ya\z:}', "");;
    Expect(1, 68899, '\p{Joining_Group: hanifirohingyakinnaya}', "");
    Expect(0, 68899, '\p{^Joining_Group: hanifirohingyakinnaya}', "");
    Expect(0, 68899, '\P{Joining_Group: hanifirohingyakinnaya}', "");
    Expect(1, 68899, '\P{^Joining_Group: hanifirohingyakinnaya}', "");
    Expect(0, 68900, '\p{Joining_Group: hanifirohingyakinnaya}', "");
    Expect(1, 68900, '\p{^Joining_Group: hanifirohingyakinnaya}', "");
    Expect(1, 68900, '\P{Joining_Group: hanifirohingyakinnaya}', "");
    Expect(0, 68900, '\P{^Joining_Group: hanifirohingyakinnaya}', "");
    Expect(1, 68899, '\p{Joining_Group=:\Ahanifirohingyakinnaya\z:}', "");;
    Expect(0, 68900, '\p{Joining_Group=:\Ahanifirohingyakinnaya\z:}', "");;
    Expect(1, 68899, '\p{Joining_Group=	HANIFI_Rohingya_kinna_Ya}', "");
    Expect(0, 68899, '\p{^Joining_Group=	HANIFI_Rohingya_kinna_Ya}', "");
    Expect(0, 68899, '\P{Joining_Group=	HANIFI_Rohingya_kinna_Ya}', "");
    Expect(1, 68899, '\P{^Joining_Group=	HANIFI_Rohingya_kinna_Ya}', "");
    Expect(0, 68900, '\p{Joining_Group=	HANIFI_Rohingya_kinna_Ya}', "");
    Expect(1, 68900, '\p{^Joining_Group=	HANIFI_Rohingya_kinna_Ya}', "");
    Expect(1, 68900, '\P{Joining_Group=	HANIFI_Rohingya_kinna_Ya}', "");
    Expect(0, 68900, '\P{^Joining_Group=	HANIFI_Rohingya_kinna_Ya}', "");
    Error('\p{Jg=/a/ Hanifi_ROHINGYA_kinna_YA}');
    Error('\P{Jg=/a/ Hanifi_ROHINGYA_kinna_YA}');
    Expect(1, 68899, '\p{Jg=:\AHanifi_Rohingya_Kinna_Ya\z:}', "");;
    Expect(0, 68900, '\p{Jg=:\AHanifi_Rohingya_Kinna_Ya\z:}', "");;
    Expect(1, 68899, '\p{Jg=hanifirohingyakinnaya}', "");
    Expect(0, 68899, '\p{^Jg=hanifirohingyakinnaya}', "");
    Expect(0, 68899, '\P{Jg=hanifirohingyakinnaya}', "");
    Expect(1, 68899, '\P{^Jg=hanifirohingyakinnaya}', "");
    Expect(0, 68900, '\p{Jg=hanifirohingyakinnaya}', "");
    Expect(1, 68900, '\p{^Jg=hanifirohingyakinnaya}', "");
    Expect(1, 68900, '\P{Jg=hanifirohingyakinnaya}', "");
    Expect(0, 68900, '\P{^Jg=hanifirohingyakinnaya}', "");
    Expect(1, 68899, '\p{Jg=:\Ahanifirohingyakinnaya\z:}', "");;
    Expect(0, 68900, '\p{Jg=:\Ahanifirohingyakinnaya\z:}', "");;
    Expect(1, 68899, '\p{Jg:  Hanifi_rohingya_KINNA_ya}', "");
    Expect(0, 68899, '\p{^Jg:  Hanifi_rohingya_KINNA_ya}', "");
    Expect(0, 68899, '\P{Jg:  Hanifi_rohingya_KINNA_ya}', "");
    Expect(1, 68899, '\P{^Jg:  Hanifi_rohingya_KINNA_ya}', "");
    Expect(0, 68900, '\p{Jg:  Hanifi_rohingya_KINNA_ya}', "");
    Expect(1, 68900, '\p{^Jg:  Hanifi_rohingya_KINNA_ya}', "");
    Expect(1, 68900, '\P{Jg:  Hanifi_rohingya_KINNA_ya}', "");
    Expect(0, 68900, '\P{^Jg:  Hanifi_rohingya_KINNA_ya}', "");
    Error('\p{Is_Joining_Group=- HANIFI_ROHINGYA_Kinna_Ya/a/}');
    Error('\P{Is_Joining_Group=- HANIFI_ROHINGYA_Kinna_Ya/a/}');
    Expect(1, 68899, '\p{Is_Joining_Group: hanifirohingyakinnaya}', "");
    Expect(0, 68899, '\p{^Is_Joining_Group: hanifirohingyakinnaya}', "");
    Expect(0, 68899, '\P{Is_Joining_Group: hanifirohingyakinnaya}', "");
    Expect(1, 68899, '\P{^Is_Joining_Group: hanifirohingyakinnaya}', "");
    Expect(0, 68900, '\p{Is_Joining_Group: hanifirohingyakinnaya}', "");
    Expect(1, 68900, '\p{^Is_Joining_Group: hanifirohingyakinnaya}', "");
    Expect(1, 68900, '\P{Is_Joining_Group: hanifirohingyakinnaya}', "");
    Expect(0, 68900, '\P{^Is_Joining_Group: hanifirohingyakinnaya}', "");
    Expect(1, 68899, '\p{Is_Joining_Group:   Hanifi_Rohingya_Kinna_Ya}', "");
    Expect(0, 68899, '\p{^Is_Joining_Group:   Hanifi_Rohingya_Kinna_Ya}', "");
    Expect(0, 68899, '\P{Is_Joining_Group:   Hanifi_Rohingya_Kinna_Ya}', "");
    Expect(1, 68899, '\P{^Is_Joining_Group:   Hanifi_Rohingya_Kinna_Ya}', "");
    Expect(0, 68900, '\p{Is_Joining_Group:   Hanifi_Rohingya_Kinna_Ya}', "");
    Expect(1, 68900, '\p{^Is_Joining_Group:   Hanifi_Rohingya_Kinna_Ya}', "");
    Expect(1, 68900, '\P{Is_Joining_Group:   Hanifi_Rohingya_Kinna_Ya}', "");
    Expect(0, 68900, '\P{^Is_Joining_Group:   Hanifi_Rohingya_Kinna_Ya}', "");
    Error('\p{Is_Jg=- HANIFI_ROHINGYA_kinna_Ya:=}');
    Error('\P{Is_Jg=- HANIFI_ROHINGYA_kinna_Ya:=}');
    Expect(1, 68899, '\p{Is_Jg:   hanifirohingyakinnaya}', "");
    Expect(0, 68899, '\p{^Is_Jg:   hanifirohingyakinnaya}', "");
    Expect(0, 68899, '\P{Is_Jg:   hanifirohingyakinnaya}', "");
    Expect(1, 68899, '\P{^Is_Jg:   hanifirohingyakinnaya}', "");
    Expect(0, 68900, '\p{Is_Jg:   hanifirohingyakinnaya}', "");
    Expect(1, 68900, '\p{^Is_Jg:   hanifirohingyakinnaya}', "");
    Expect(1, 68900, '\P{Is_Jg:   hanifirohingyakinnaya}', "");
    Expect(0, 68900, '\P{^Is_Jg:   hanifirohingyakinnaya}', "");
    Expect(1, 68899, '\p{Is_Jg=__Hanifi_rohingya_Kinna_YA}', "");
    Expect(0, 68899, '\p{^Is_Jg=__Hanifi_rohingya_Kinna_YA}', "");
    Expect(0, 68899, '\P{Is_Jg=__Hanifi_rohingya_Kinna_YA}', "");
    Expect(1, 68899, '\P{^Is_Jg=__Hanifi_rohingya_Kinna_YA}', "");
    Expect(0, 68900, '\p{Is_Jg=__Hanifi_rohingya_Kinna_YA}', "");
    Expect(1, 68900, '\p{^Is_Jg=__Hanifi_rohingya_Kinna_YA}', "");
    Expect(1, 68900, '\P{Is_Jg=__Hanifi_rohingya_Kinna_YA}', "");
    Expect(0, 68900, '\P{^Is_Jg=__Hanifi_rohingya_Kinna_YA}', "");
    Error('\p{Joining_Group=/a/Hanifi_Rohingya_pa}');
    Error('\P{Joining_Group=/a/Hanifi_Rohingya_pa}');
    Expect(1, 68892, '\p{Joining_Group=:\AHanifi_Rohingya_Pa\z:}', "");;
    Expect(0, 68893, '\p{Joining_Group=:\AHanifi_Rohingya_Pa\z:}', "");;
    Expect(1, 68892, '\p{Joining_Group=hanifirohingyapa}', "");
    Expect(0, 68892, '\p{^Joining_Group=hanifirohingyapa}', "");
    Expect(0, 68892, '\P{Joining_Group=hanifirohingyapa}', "");
    Expect(1, 68892, '\P{^Joining_Group=hanifirohingyapa}', "");
    Expect(0, 68893, '\p{Joining_Group=hanifirohingyapa}', "");
    Expect(1, 68893, '\p{^Joining_Group=hanifirohingyapa}', "");
    Expect(1, 68893, '\P{Joining_Group=hanifirohingyapa}', "");
    Expect(0, 68893, '\P{^Joining_Group=hanifirohingyapa}', "");
    Expect(1, 68892, '\p{Joining_Group=:\Ahanifirohingyapa\z:}', "");;
    Expect(0, 68893, '\p{Joining_Group=:\Ahanifirohingyapa\z:}', "");;
    Expect(1, 68892, '\p{Joining_Group=_	Hanifi_Rohingya_Pa}', "");
    Expect(0, 68892, '\p{^Joining_Group=_	Hanifi_Rohingya_Pa}', "");
    Expect(0, 68892, '\P{Joining_Group=_	Hanifi_Rohingya_Pa}', "");
    Expect(1, 68892, '\P{^Joining_Group=_	Hanifi_Rohingya_Pa}', "");
    Expect(0, 68893, '\p{Joining_Group=_	Hanifi_Rohingya_Pa}', "");
    Expect(1, 68893, '\p{^Joining_Group=_	Hanifi_Rohingya_Pa}', "");
    Expect(1, 68893, '\P{Joining_Group=_	Hanifi_Rohingya_Pa}', "");
    Expect(0, 68893, '\P{^Joining_Group=_	Hanifi_Rohingya_Pa}', "");
    Error('\p{Jg=/a/-Hanifi_Rohingya_Pa}');
    Error('\P{Jg=/a/-Hanifi_Rohingya_Pa}');
    Expect(1, 68892, '\p{Jg=:\AHanifi_Rohingya_Pa\z:}', "");;
    Expect(0, 68893, '\p{Jg=:\AHanifi_Rohingya_Pa\z:}', "");;
    Expect(1, 68892, '\p{Jg=hanifirohingyapa}', "");
    Expect(0, 68892, '\p{^Jg=hanifirohingyapa}', "");
    Expect(0, 68892, '\P{Jg=hanifirohingyapa}', "");
    Expect(1, 68892, '\P{^Jg=hanifirohingyapa}', "");
    Expect(0, 68893, '\p{Jg=hanifirohingyapa}', "");
    Expect(1, 68893, '\p{^Jg=hanifirohingyapa}', "");
    Expect(1, 68893, '\P{Jg=hanifirohingyapa}', "");
    Expect(0, 68893, '\P{^Jg=hanifirohingyapa}', "");
    Expect(1, 68892, '\p{Jg=:\Ahanifirohingyapa\z:}', "");;
    Expect(0, 68893, '\p{Jg=:\Ahanifirohingyapa\z:}', "");;
    Expect(1, 68892, '\p{Jg= Hanifi_ROHINGYA_Pa}', "");
    Expect(0, 68892, '\p{^Jg= Hanifi_ROHINGYA_Pa}', "");
    Expect(0, 68892, '\P{Jg= Hanifi_ROHINGYA_Pa}', "");
    Expect(1, 68892, '\P{^Jg= Hanifi_ROHINGYA_Pa}', "");
    Expect(0, 68893, '\p{Jg= Hanifi_ROHINGYA_Pa}', "");
    Expect(1, 68893, '\p{^Jg= Hanifi_ROHINGYA_Pa}', "");
    Expect(1, 68893, '\P{Jg= Hanifi_ROHINGYA_Pa}', "");
    Expect(0, 68893, '\P{^Jg= Hanifi_ROHINGYA_Pa}', "");
    Error('\p{Is_Joining_Group=:=_Hanifi_rohingya_pa}');
    Error('\P{Is_Joining_Group=:=_Hanifi_rohingya_pa}');
    Expect(1, 68892, '\p{Is_Joining_Group=hanifirohingyapa}', "");
    Expect(0, 68892, '\p{^Is_Joining_Group=hanifirohingyapa}', "");
    Expect(0, 68892, '\P{Is_Joining_Group=hanifirohingyapa}', "");
    Expect(1, 68892, '\P{^Is_Joining_Group=hanifirohingyapa}', "");
    Expect(0, 68893, '\p{Is_Joining_Group=hanifirohingyapa}', "");
    Expect(1, 68893, '\p{^Is_Joining_Group=hanifirohingyapa}', "");
    Expect(1, 68893, '\P{Is_Joining_Group=hanifirohingyapa}', "");
    Expect(0, 68893, '\P{^Is_Joining_Group=hanifirohingyapa}', "");
    Expect(1, 68892, '\p{Is_Joining_Group=--Hanifi_rohingya_pa}', "");
    Expect(0, 68892, '\p{^Is_Joining_Group=--Hanifi_rohingya_pa}', "");
    Expect(0, 68892, '\P{Is_Joining_Group=--Hanifi_rohingya_pa}', "");
    Expect(1, 68892, '\P{^Is_Joining_Group=--Hanifi_rohingya_pa}', "");
    Expect(0, 68893, '\p{Is_Joining_Group=--Hanifi_rohingya_pa}', "");
    Expect(1, 68893, '\p{^Is_Joining_Group=--Hanifi_rohingya_pa}', "");
    Expect(1, 68893, '\P{Is_Joining_Group=--Hanifi_rohingya_pa}', "");
    Expect(0, 68893, '\P{^Is_Joining_Group=--Hanifi_rohingya_pa}', "");
    Error('\p{Is_Jg=:=_Hanifi_ROHINGYA_PA}');
    Error('\P{Is_Jg=:=_Hanifi_ROHINGYA_PA}');
    Expect(1, 68892, '\p{Is_Jg:   hanifirohingyapa}', "");
    Expect(0, 68892, '\p{^Is_Jg:   hanifirohingyapa}', "");
    Expect(0, 68892, '\P{Is_Jg:   hanifirohingyapa}', "");
    Expect(1, 68892, '\P{^Is_Jg:   hanifirohingyapa}', "");
    Expect(0, 68893, '\p{Is_Jg:   hanifirohingyapa}', "");
    Expect(1, 68893, '\p{^Is_Jg:   hanifirohingyapa}', "");
    Expect(1, 68893, '\P{Is_Jg:   hanifirohingyapa}', "");
    Expect(0, 68893, '\P{^Is_Jg:   hanifirohingyapa}', "");
    Expect(1, 68892, '\p{Is_Jg=  hanifi_rohingya_PA}', "");
    Expect(0, 68892, '\p{^Is_Jg=  hanifi_rohingya_PA}', "");
    Expect(0, 68892, '\P{Is_Jg=  hanifi_rohingya_PA}', "");
    Expect(1, 68892, '\P{^Is_Jg=  hanifi_rohingya_PA}', "");
    Expect(0, 68893, '\p{Is_Jg=  hanifi_rohingya_PA}', "");
    Expect(1, 68893, '\p{^Is_Jg=  hanifi_rohingya_PA}', "");
    Expect(1, 68893, '\P{Is_Jg=  hanifi_rohingya_PA}', "");
    Expect(0, 68893, '\P{^Is_Jg=  hanifi_rohingya_PA}', "");
    Error('\p{Joining_Group=/a/	HE}');
    Error('\P{Joining_Group=/a/	HE}');
    Expect(1, 1815, '\p{Joining_Group=:\AHe\z:}', "");;
    Expect(0, 1816, '\p{Joining_Group=:\AHe\z:}', "");;
    Expect(1, 1815, '\p{Joining_Group=he}', "");
    Expect(0, 1815, '\p{^Joining_Group=he}', "");
    Expect(0, 1815, '\P{Joining_Group=he}', "");
    Expect(1, 1815, '\P{^Joining_Group=he}', "");
    Expect(0, 1816, '\p{Joining_Group=he}', "");
    Expect(1, 1816, '\p{^Joining_Group=he}', "");
    Expect(1, 1816, '\P{Joining_Group=he}', "");
    Expect(0, 1816, '\P{^Joining_Group=he}', "");
    Expect(1, 1815, '\p{Joining_Group=:\Ahe\z:}', "");;
    Expect(0, 1816, '\p{Joining_Group=:\Ahe\z:}', "");;
    Expect(1, 1815, '\p{Joining_Group=__He}', "");
    Expect(0, 1815, '\p{^Joining_Group=__He}', "");
    Expect(0, 1815, '\P{Joining_Group=__He}', "");
    Expect(1, 1815, '\P{^Joining_Group=__He}', "");
    Expect(0, 1816, '\p{Joining_Group=__He}', "");
    Expect(1, 1816, '\p{^Joining_Group=__He}', "");
    Expect(1, 1816, '\P{Joining_Group=__He}', "");
    Expect(0, 1816, '\P{^Joining_Group=__He}', "");
    Error('\p{Jg=_He:=}');
    Error('\P{Jg=_He:=}');
    Expect(1, 1815, '\p{Jg=:\AHe\z:}', "");;
    Expect(0, 1816, '\p{Jg=:\AHe\z:}', "");;
    Expect(1, 1815, '\p{Jg=he}', "");
    Expect(0, 1815, '\p{^Jg=he}', "");
    Expect(0, 1815, '\P{Jg=he}', "");
    Expect(1, 1815, '\P{^Jg=he}', "");
    Expect(0, 1816, '\p{Jg=he}', "");
    Expect(1, 1816, '\p{^Jg=he}', "");
    Expect(1, 1816, '\P{Jg=he}', "");
    Expect(0, 1816, '\P{^Jg=he}', "");
    Expect(1, 1815, '\p{Jg=:\Ahe\z:}', "");;
    Expect(0, 1816, '\p{Jg=:\Ahe\z:}', "");;
    Expect(1, 1815, '\p{Jg= He}', "");
    Expect(0, 1815, '\p{^Jg= He}', "");
    Expect(0, 1815, '\P{Jg= He}', "");
    Expect(1, 1815, '\P{^Jg= He}', "");
    Expect(0, 1816, '\p{Jg= He}', "");
    Expect(1, 1816, '\p{^Jg= He}', "");
    Expect(1, 1816, '\P{Jg= He}', "");
    Expect(0, 1816, '\P{^Jg= He}', "");
    Error('\p{Is_Joining_Group= /a/He}');
    Error('\P{Is_Joining_Group= /a/He}');
    Expect(1, 1815, '\p{Is_Joining_Group=he}', "");
    Expect(0, 1815, '\p{^Is_Joining_Group=he}', "");
    Expect(0, 1815, '\P{Is_Joining_Group=he}', "");
    Expect(1, 1815, '\P{^Is_Joining_Group=he}', "");
    Expect(0, 1816, '\p{Is_Joining_Group=he}', "");
    Expect(1, 1816, '\p{^Is_Joining_Group=he}', "");
    Expect(1, 1816, '\P{Is_Joining_Group=he}', "");
    Expect(0, 1816, '\P{^Is_Joining_Group=he}', "");
    Expect(1, 1815, '\p{Is_Joining_Group= He}', "");
    Expect(0, 1815, '\p{^Is_Joining_Group= He}', "");
    Expect(0, 1815, '\P{Is_Joining_Group= He}', "");
    Expect(1, 1815, '\P{^Is_Joining_Group= He}', "");
    Expect(0, 1816, '\p{Is_Joining_Group= He}', "");
    Expect(1, 1816, '\p{^Is_Joining_Group= He}', "");
    Expect(1, 1816, '\P{Is_Joining_Group= He}', "");
    Expect(0, 1816, '\P{^Is_Joining_Group= He}', "");
    Error('\p{Is_Jg: _/a/HE}');
    Error('\P{Is_Jg: _/a/HE}');
    Expect(1, 1815, '\p{Is_Jg=he}', "");
    Expect(0, 1815, '\p{^Is_Jg=he}', "");
    Expect(0, 1815, '\P{Is_Jg=he}', "");
    Expect(1, 1815, '\P{^Is_Jg=he}', "");
    Expect(0, 1816, '\p{Is_Jg=he}', "");
    Expect(1, 1816, '\p{^Is_Jg=he}', "");
    Expect(1, 1816, '\P{Is_Jg=he}', "");
    Expect(0, 1816, '\P{^Is_Jg=he}', "");
    Expect(1, 1815, '\p{Is_Jg: 	 He}', "");
    Expect(0, 1815, '\p{^Is_Jg: 	 He}', "");
    Expect(0, 1815, '\P{Is_Jg: 	 He}', "");
    Expect(1, 1815, '\P{^Is_Jg: 	 He}', "");
    Expect(0, 1816, '\p{Is_Jg: 	 He}', "");
    Expect(1, 1816, '\p{^Is_Jg: 	 He}', "");
    Expect(1, 1816, '\P{Is_Jg: 	 He}', "");
    Expect(0, 1816, '\P{^Is_Jg: 	 He}', "");
    Error('\p{Joining_Group:_	heh:=}');
    Error('\P{Joining_Group:_	heh:=}');
    Expect(1, 1607, '\p{Joining_Group=:\AHeh\z:}', "");;
    Expect(0, 1608, '\p{Joining_Group=:\AHeh\z:}', "");;
    Expect(1, 1607, '\p{Joining_Group=heh}', "");
    Expect(0, 1607, '\p{^Joining_Group=heh}', "");
    Expect(0, 1607, '\P{Joining_Group=heh}', "");
    Expect(1, 1607, '\P{^Joining_Group=heh}', "");
    Expect(0, 1608, '\p{Joining_Group=heh}', "");
    Expect(1, 1608, '\p{^Joining_Group=heh}', "");
    Expect(1, 1608, '\P{Joining_Group=heh}', "");
    Expect(0, 1608, '\P{^Joining_Group=heh}', "");
    Expect(1, 1607, '\p{Joining_Group=:\Aheh\z:}', "");;
    Expect(0, 1608, '\p{Joining_Group=:\Aheh\z:}', "");;
    Expect(1, 1607, '\p{Joining_Group= -heh}', "");
    Expect(0, 1607, '\p{^Joining_Group= -heh}', "");
    Expect(0, 1607, '\P{Joining_Group= -heh}', "");
    Expect(1, 1607, '\P{^Joining_Group= -heh}', "");
    Expect(0, 1608, '\p{Joining_Group= -heh}', "");
    Expect(1, 1608, '\p{^Joining_Group= -heh}', "");
    Expect(1, 1608, '\P{Joining_Group= -heh}', "");
    Expect(0, 1608, '\P{^Joining_Group= -heh}', "");
    Error('\p{Jg=:=Heh}');
    Error('\P{Jg=:=Heh}');
    Expect(1, 1607, '\p{Jg=:\AHeh\z:}', "");;
    Expect(0, 1608, '\p{Jg=:\AHeh\z:}', "");;
    Expect(1, 1607, '\p{Jg: heh}', "");
    Expect(0, 1607, '\p{^Jg: heh}', "");
    Expect(0, 1607, '\P{Jg: heh}', "");
    Expect(1, 1607, '\P{^Jg: heh}', "");
    Expect(0, 1608, '\p{Jg: heh}', "");
    Expect(1, 1608, '\p{^Jg: heh}', "");
    Expect(1, 1608, '\P{Jg: heh}', "");
    Expect(0, 1608, '\P{^Jg: heh}', "");
    Expect(1, 1607, '\p{Jg=:\Aheh\z:}', "");;
    Expect(0, 1608, '\p{Jg=:\Aheh\z:}', "");;
    Expect(1, 1607, '\p{Jg=	heh}', "");
    Expect(0, 1607, '\p{^Jg=	heh}', "");
    Expect(0, 1607, '\P{Jg=	heh}', "");
    Expect(1, 1607, '\P{^Jg=	heh}', "");
    Expect(0, 1608, '\p{Jg=	heh}', "");
    Expect(1, 1608, '\p{^Jg=	heh}', "");
    Expect(1, 1608, '\P{Jg=	heh}', "");
    Expect(0, 1608, '\P{^Jg=	heh}', "");
    Error('\p{Is_Joining_Group:   _	Heh/a/}');
    Error('\P{Is_Joining_Group:   _	Heh/a/}');
    Expect(1, 1607, '\p{Is_Joining_Group=heh}', "");
    Expect(0, 1607, '\p{^Is_Joining_Group=heh}', "");
    Expect(0, 1607, '\P{Is_Joining_Group=heh}', "");
    Expect(1, 1607, '\P{^Is_Joining_Group=heh}', "");
    Expect(0, 1608, '\p{Is_Joining_Group=heh}', "");
    Expect(1, 1608, '\p{^Is_Joining_Group=heh}', "");
    Expect(1, 1608, '\P{Is_Joining_Group=heh}', "");
    Expect(0, 1608, '\P{^Is_Joining_Group=heh}', "");
    Expect(1, 1607, '\p{Is_Joining_Group=_-Heh}', "");
    Expect(0, 1607, '\p{^Is_Joining_Group=_-Heh}', "");
    Expect(0, 1607, '\P{Is_Joining_Group=_-Heh}', "");
    Expect(1, 1607, '\P{^Is_Joining_Group=_-Heh}', "");
    Expect(0, 1608, '\p{Is_Joining_Group=_-Heh}', "");
    Expect(1, 1608, '\p{^Is_Joining_Group=_-Heh}', "");
    Expect(1, 1608, '\P{Is_Joining_Group=_-Heh}', "");
    Expect(0, 1608, '\P{^Is_Joining_Group=_-Heh}', "");
    Error('\p{Is_Jg=-:=Heh}');
    Error('\P{Is_Jg=-:=Heh}');
    Expect(1, 1607, '\p{Is_Jg=heh}', "");
    Expect(0, 1607, '\p{^Is_Jg=heh}', "");
    Expect(0, 1607, '\P{Is_Jg=heh}', "");
    Expect(1, 1607, '\P{^Is_Jg=heh}', "");
    Expect(0, 1608, '\p{Is_Jg=heh}', "");
    Expect(1, 1608, '\p{^Is_Jg=heh}', "");
    Expect(1, 1608, '\P{Is_Jg=heh}', "");
    Expect(0, 1608, '\P{^Is_Jg=heh}', "");
    Expect(1, 1607, '\p{Is_Jg=-Heh}', "");
    Expect(0, 1607, '\p{^Is_Jg=-Heh}', "");
    Expect(0, 1607, '\P{Is_Jg=-Heh}', "");
    Expect(1, 1607, '\P{^Is_Jg=-Heh}', "");
    Expect(0, 1608, '\p{Is_Jg=-Heh}', "");
    Expect(1, 1608, '\p{^Is_Jg=-Heh}', "");
    Expect(1, 1608, '\P{Is_Jg=-Heh}', "");
    Expect(0, 1608, '\P{^Is_Jg=-Heh}', "");
    Error('\p{Joining_Group=/a/_HEH_goal}');
    Error('\P{Joining_Group=/a/_HEH_goal}');
    Expect(1, 1730, '\p{Joining_Group=:\AHeh_Goal\z:}', "");;
    Expect(0, 1731, '\p{Joining_Group=:\AHeh_Goal\z:}', "");;
    Expect(1, 1730, '\p{Joining_Group:   hehgoal}', "");
    Expect(0, 1730, '\p{^Joining_Group:   hehgoal}', "");
    Expect(0, 1730, '\P{Joining_Group:   hehgoal}', "");
    Expect(1, 1730, '\P{^Joining_Group:   hehgoal}', "");
    Expect(0, 1731, '\p{Joining_Group:   hehgoal}', "");
    Expect(1, 1731, '\p{^Joining_Group:   hehgoal}', "");
    Expect(1, 1731, '\P{Joining_Group:   hehgoal}', "");
    Expect(0, 1731, '\P{^Joining_Group:   hehgoal}', "");
    Expect(1, 1730, '\p{Joining_Group=:\Ahehgoal\z:}', "");;
    Expect(0, 1731, '\p{Joining_Group=:\Ahehgoal\z:}', "");;
    Expect(1, 1730, '\p{Joining_Group=_	HEH_GOAL}', "");
    Expect(0, 1730, '\p{^Joining_Group=_	HEH_GOAL}', "");
    Expect(0, 1730, '\P{Joining_Group=_	HEH_GOAL}', "");
    Expect(1, 1730, '\P{^Joining_Group=_	HEH_GOAL}', "");
    Expect(0, 1731, '\p{Joining_Group=_	HEH_GOAL}', "");
    Expect(1, 1731, '\p{^Joining_Group=_	HEH_GOAL}', "");
    Expect(1, 1731, '\P{Joining_Group=_	HEH_GOAL}', "");
    Expect(0, 1731, '\P{^Joining_Group=_	HEH_GOAL}', "");
    Error('\p{Jg=  Heh_GOAL/a/}');
    Error('\P{Jg=  Heh_GOAL/a/}');
    Expect(1, 1730, '\p{Jg=:\AHeh_Goal\z:}', "");;
    Expect(0, 1731, '\p{Jg=:\AHeh_Goal\z:}', "");;
    Expect(1, 1730, '\p{Jg=hehgoal}', "");
    Expect(0, 1730, '\p{^Jg=hehgoal}', "");
    Expect(0, 1730, '\P{Jg=hehgoal}', "");
    Expect(1, 1730, '\P{^Jg=hehgoal}', "");
    Expect(0, 1731, '\p{Jg=hehgoal}', "");
    Expect(1, 1731, '\p{^Jg=hehgoal}', "");
    Expect(1, 1731, '\P{Jg=hehgoal}', "");
    Expect(0, 1731, '\P{^Jg=hehgoal}', "");
    Expect(1, 1730, '\p{Jg=:\Ahehgoal\z:}', "");;
    Expect(0, 1731, '\p{Jg=:\Ahehgoal\z:}', "");;
    Expect(1, 1730, '\p{Jg=	 HEH_GOAL}', "");
    Expect(0, 1730, '\p{^Jg=	 HEH_GOAL}', "");
    Expect(0, 1730, '\P{Jg=	 HEH_GOAL}', "");
    Expect(1, 1730, '\P{^Jg=	 HEH_GOAL}', "");
    Expect(0, 1731, '\p{Jg=	 HEH_GOAL}', "");
    Expect(1, 1731, '\p{^Jg=	 HEH_GOAL}', "");
    Expect(1, 1731, '\P{Jg=	 HEH_GOAL}', "");
    Expect(0, 1731, '\P{^Jg=	 HEH_GOAL}', "");
    Error('\p{Is_Joining_Group=_Heh_goal:=}');
    Error('\P{Is_Joining_Group=_Heh_goal:=}');
    Expect(1, 1730, '\p{Is_Joining_Group=hehgoal}', "");
    Expect(0, 1730, '\p{^Is_Joining_Group=hehgoal}', "");
    Expect(0, 1730, '\P{Is_Joining_Group=hehgoal}', "");
    Expect(1, 1730, '\P{^Is_Joining_Group=hehgoal}', "");
    Expect(0, 1731, '\p{Is_Joining_Group=hehgoal}', "");
    Expect(1, 1731, '\p{^Is_Joining_Group=hehgoal}', "");
    Expect(1, 1731, '\P{Is_Joining_Group=hehgoal}', "");
    Expect(0, 1731, '\P{^Is_Joining_Group=hehgoal}', "");
    Expect(1, 1730, '\p{Is_Joining_Group:   _-Heh_GOAL}', "");
    Expect(0, 1730, '\p{^Is_Joining_Group:   _-Heh_GOAL}', "");
    Expect(0, 1730, '\P{Is_Joining_Group:   _-Heh_GOAL}', "");
    Expect(1, 1730, '\P{^Is_Joining_Group:   _-Heh_GOAL}', "");
    Expect(0, 1731, '\p{Is_Joining_Group:   _-Heh_GOAL}', "");
    Expect(1, 1731, '\p{^Is_Joining_Group:   _-Heh_GOAL}', "");
    Expect(1, 1731, '\P{Is_Joining_Group:   _-Heh_GOAL}', "");
    Expect(0, 1731, '\P{^Is_Joining_Group:   _-Heh_GOAL}', "");
    Error('\p{Is_Jg=/a/ _Heh_Goal}');
    Error('\P{Is_Jg=/a/ _Heh_Goal}');
    Expect(1, 1730, '\p{Is_Jg:	hehgoal}', "");
    Expect(0, 1730, '\p{^Is_Jg:	hehgoal}', "");
    Expect(0, 1730, '\P{Is_Jg:	hehgoal}', "");
    Expect(1, 1730, '\P{^Is_Jg:	hehgoal}', "");
    Expect(0, 1731, '\p{Is_Jg:	hehgoal}', "");
    Expect(1, 1731, '\p{^Is_Jg:	hehgoal}', "");
    Expect(1, 1731, '\P{Is_Jg:	hehgoal}', "");
    Expect(0, 1731, '\P{^Is_Jg:	hehgoal}', "");
    Expect(1, 1730, '\p{Is_Jg= Heh_goal}', "");
    Expect(0, 1730, '\p{^Is_Jg= Heh_goal}', "");
    Expect(0, 1730, '\P{Is_Jg= Heh_goal}', "");
    Expect(1, 1730, '\P{^Is_Jg= Heh_goal}', "");
    Expect(0, 1731, '\p{Is_Jg= Heh_goal}', "");
    Expect(1, 1731, '\p{^Is_Jg= Heh_goal}', "");
    Expect(1, 1731, '\P{Is_Jg= Heh_goal}', "");
    Expect(0, 1731, '\P{^Is_Jg= Heh_goal}', "");
    Error('\p{Joining_Group=/a/heth}');
    Error('\P{Joining_Group=/a/heth}');
    Expect(1, 1818, '\p{Joining_Group=:\AHeth\z:}', "");;
    Expect(0, 1819, '\p{Joining_Group=:\AHeth\z:}', "");;
    Expect(1, 1818, '\p{Joining_Group=heth}', "");
    Expect(0, 1818, '\p{^Joining_Group=heth}', "");
    Expect(0, 1818, '\P{Joining_Group=heth}', "");
    Expect(1, 1818, '\P{^Joining_Group=heth}', "");
    Expect(0, 1819, '\p{Joining_Group=heth}', "");
    Expect(1, 1819, '\p{^Joining_Group=heth}', "");
    Expect(1, 1819, '\P{Joining_Group=heth}', "");
    Expect(0, 1819, '\P{^Joining_Group=heth}', "");
    Expect(1, 1818, '\p{Joining_Group=:\Aheth\z:}', "");;
    Expect(0, 1819, '\p{Joining_Group=:\Aheth\z:}', "");;
    Expect(1, 1818, '\p{Joining_Group= -heth}', "");
    Expect(0, 1818, '\p{^Joining_Group= -heth}', "");
    Expect(0, 1818, '\P{Joining_Group= -heth}', "");
    Expect(1, 1818, '\P{^Joining_Group= -heth}', "");
    Expect(0, 1819, '\p{Joining_Group= -heth}', "");
    Expect(1, 1819, '\p{^Joining_Group= -heth}', "");
    Expect(1, 1819, '\P{Joining_Group= -heth}', "");
    Expect(0, 1819, '\P{^Joining_Group= -heth}', "");
    Error('\p{Jg=- Heth:=}');
    Error('\P{Jg=- Heth:=}');
    Expect(1, 1818, '\p{Jg=:\AHeth\z:}', "");;
    Expect(0, 1819, '\p{Jg=:\AHeth\z:}', "");;
    Expect(1, 1818, '\p{Jg=heth}', "");
    Expect(0, 1818, '\p{^Jg=heth}', "");
    Expect(0, 1818, '\P{Jg=heth}', "");
    Expect(1, 1818, '\P{^Jg=heth}', "");
    Expect(0, 1819, '\p{Jg=heth}', "");
    Expect(1, 1819, '\p{^Jg=heth}', "");
    Expect(1, 1819, '\P{Jg=heth}', "");
    Expect(0, 1819, '\P{^Jg=heth}', "");
    Expect(1, 1818, '\p{Jg=:\Aheth\z:}', "");;
    Expect(0, 1819, '\p{Jg=:\Aheth\z:}', "");;
    Expect(1, 1818, '\p{Jg=_	Heth}', "");
    Expect(0, 1818, '\p{^Jg=_	Heth}', "");
    Expect(0, 1818, '\P{Jg=_	Heth}', "");
    Expect(1, 1818, '\P{^Jg=_	Heth}', "");
    Expect(0, 1819, '\p{Jg=_	Heth}', "");
    Expect(1, 1819, '\p{^Jg=_	Heth}', "");
    Expect(1, 1819, '\P{Jg=_	Heth}', "");
    Expect(0, 1819, '\P{^Jg=_	Heth}', "");
    Error('\p{Is_Joining_Group:   /a/Heth}');
    Error('\P{Is_Joining_Group:   /a/Heth}');
    Expect(1, 1818, '\p{Is_Joining_Group:heth}', "");
    Expect(0, 1818, '\p{^Is_Joining_Group:heth}', "");
    Expect(0, 1818, '\P{Is_Joining_Group:heth}', "");
    Expect(1, 1818, '\P{^Is_Joining_Group:heth}', "");
    Expect(0, 1819, '\p{Is_Joining_Group:heth}', "");
    Expect(1, 1819, '\p{^Is_Joining_Group:heth}', "");
    Expect(1, 1819, '\P{Is_Joining_Group:heth}', "");
    Expect(0, 1819, '\P{^Is_Joining_Group:heth}', "");
    Expect(1, 1818, '\p{Is_Joining_Group= -HETH}', "");
    Expect(0, 1818, '\p{^Is_Joining_Group= -HETH}', "");
    Expect(0, 1818, '\P{Is_Joining_Group= -HETH}', "");
    Expect(1, 1818, '\P{^Is_Joining_Group= -HETH}', "");
    Expect(0, 1819, '\p{Is_Joining_Group= -HETH}', "");
    Expect(1, 1819, '\p{^Is_Joining_Group= -HETH}', "");
    Expect(1, 1819, '\P{Is_Joining_Group= -HETH}', "");
    Expect(0, 1819, '\P{^Is_Joining_Group= -HETH}', "");
    Error('\p{Is_Jg= Heth:=}');
    Error('\P{Is_Jg= Heth:=}');
    Expect(1, 1818, '\p{Is_Jg=heth}', "");
    Expect(0, 1818, '\p{^Is_Jg=heth}', "");
    Expect(0, 1818, '\P{Is_Jg=heth}', "");
    Expect(1, 1818, '\P{^Is_Jg=heth}', "");
    Expect(0, 1819, '\p{Is_Jg=heth}', "");
    Expect(1, 1819, '\p{^Is_Jg=heth}', "");
    Expect(1, 1819, '\P{Is_Jg=heth}', "");
    Expect(0, 1819, '\P{^Is_Jg=heth}', "");
    Expect(1, 1818, '\p{Is_Jg=	Heth}', "");
    Expect(0, 1818, '\p{^Is_Jg=	Heth}', "");
    Expect(0, 1818, '\P{Is_Jg=	Heth}', "");
    Expect(1, 1818, '\P{^Is_Jg=	Heth}', "");
    Expect(0, 1819, '\p{Is_Jg=	Heth}', "");
    Expect(1, 1819, '\p{^Is_Jg=	Heth}', "");
    Expect(1, 1819, '\P{Is_Jg=	Heth}', "");
    Expect(0, 1819, '\P{^Is_Jg=	Heth}', "");
    Error('\p{Joining_Group=	:=KAF}');
    Error('\P{Joining_Group=	:=KAF}');
    Expect(1, 2228, '\p{Joining_Group=:\AKaf\z:}', "");;
    Expect(0, 2229, '\p{Joining_Group=:\AKaf\z:}', "");;
    Expect(1, 2228, '\p{Joining_Group=kaf}', "");
    Expect(0, 2228, '\p{^Joining_Group=kaf}', "");
    Expect(0, 2228, '\P{Joining_Group=kaf}', "");
    Expect(1, 2228, '\P{^Joining_Group=kaf}', "");
    Expect(0, 2229, '\p{Joining_Group=kaf}', "");
    Expect(1, 2229, '\p{^Joining_Group=kaf}', "");
    Expect(1, 2229, '\P{Joining_Group=kaf}', "");
    Expect(0, 2229, '\P{^Joining_Group=kaf}', "");
    Expect(1, 2228, '\p{Joining_Group=:\Akaf\z:}', "");;
    Expect(0, 2229, '\p{Joining_Group=:\Akaf\z:}', "");;
    Expect(1, 2228, '\p{Joining_Group:  kaf}', "");
    Expect(0, 2228, '\p{^Joining_Group:  kaf}', "");
    Expect(0, 2228, '\P{Joining_Group:  kaf}', "");
    Expect(1, 2228, '\P{^Joining_Group:  kaf}', "");
    Expect(0, 2229, '\p{Joining_Group:  kaf}', "");
    Expect(1, 2229, '\p{^Joining_Group:  kaf}', "");
    Expect(1, 2229, '\P{Joining_Group:  kaf}', "");
    Expect(0, 2229, '\P{^Joining_Group:  kaf}', "");
    Error('\p{Jg=		KAF:=}');
    Error('\P{Jg=		KAF:=}');
    Expect(1, 2228, '\p{Jg=:\AKaf\z:}', "");;
    Expect(0, 2229, '\p{Jg=:\AKaf\z:}', "");;
    Expect(1, 2228, '\p{Jg=kaf}', "");
    Expect(0, 2228, '\p{^Jg=kaf}', "");
    Expect(0, 2228, '\P{Jg=kaf}', "");
    Expect(1, 2228, '\P{^Jg=kaf}', "");
    Expect(0, 2229, '\p{Jg=kaf}', "");
    Expect(1, 2229, '\p{^Jg=kaf}', "");
    Expect(1, 2229, '\P{Jg=kaf}', "");
    Expect(0, 2229, '\P{^Jg=kaf}', "");
    Expect(1, 2228, '\p{Jg=:\Akaf\z:}', "");;
    Expect(0, 2229, '\p{Jg=:\Akaf\z:}', "");;
    Expect(1, 2228, '\p{Jg=-Kaf}', "");
    Expect(0, 2228, '\p{^Jg=-Kaf}', "");
    Expect(0, 2228, '\P{Jg=-Kaf}', "");
    Expect(1, 2228, '\P{^Jg=-Kaf}', "");
    Expect(0, 2229, '\p{Jg=-Kaf}', "");
    Expect(1, 2229, '\p{^Jg=-Kaf}', "");
    Expect(1, 2229, '\P{Jg=-Kaf}', "");
    Expect(0, 2229, '\P{^Jg=-Kaf}', "");
    Error('\p{Is_Joining_Group= /a/kaf}');
    Error('\P{Is_Joining_Group= /a/kaf}');
    Expect(1, 2228, '\p{Is_Joining_Group=kaf}', "");
    Expect(0, 2228, '\p{^Is_Joining_Group=kaf}', "");
    Expect(0, 2228, '\P{Is_Joining_Group=kaf}', "");
    Expect(1, 2228, '\P{^Is_Joining_Group=kaf}', "");
    Expect(0, 2229, '\p{Is_Joining_Group=kaf}', "");
    Expect(1, 2229, '\p{^Is_Joining_Group=kaf}', "");
    Expect(1, 2229, '\P{Is_Joining_Group=kaf}', "");
    Expect(0, 2229, '\P{^Is_Joining_Group=kaf}', "");
    Expect(1, 2228, '\p{Is_Joining_Group=	_kaf}', "");
    Expect(0, 2228, '\p{^Is_Joining_Group=	_kaf}', "");
    Expect(0, 2228, '\P{Is_Joining_Group=	_kaf}', "");
    Expect(1, 2228, '\P{^Is_Joining_Group=	_kaf}', "");
    Expect(0, 2229, '\p{Is_Joining_Group=	_kaf}', "");
    Expect(1, 2229, '\p{^Is_Joining_Group=	_kaf}', "");
    Expect(1, 2229, '\P{Is_Joining_Group=	_kaf}', "");
    Expect(0, 2229, '\P{^Is_Joining_Group=	_kaf}', "");
    Error('\p{Is_Jg=_/a/KAF}');
    Error('\P{Is_Jg=_/a/KAF}');
    Expect(1, 2228, '\p{Is_Jg=kaf}', "");
    Expect(0, 2228, '\p{^Is_Jg=kaf}', "");
    Expect(0, 2228, '\P{Is_Jg=kaf}', "");
    Expect(1, 2228, '\P{^Is_Jg=kaf}', "");
    Expect(0, 2229, '\p{Is_Jg=kaf}', "");
    Expect(1, 2229, '\p{^Is_Jg=kaf}', "");
    Expect(1, 2229, '\P{Is_Jg=kaf}', "");
    Expect(0, 2229, '\P{^Is_Jg=kaf}', "");
    Expect(1, 2228, '\p{Is_Jg=	-kaf}', "");
    Expect(0, 2228, '\p{^Is_Jg=	-kaf}', "");
    Expect(0, 2228, '\P{Is_Jg=	-kaf}', "");
    Expect(1, 2228, '\P{^Is_Jg=	-kaf}', "");
    Expect(0, 2229, '\p{Is_Jg=	-kaf}', "");
    Expect(1, 2229, '\p{^Is_Jg=	-kaf}', "");
    Expect(1, 2229, '\P{Is_Jg=	-kaf}', "");
    Expect(0, 2229, '\P{^Is_Jg=	-kaf}', "");
    Error('\p{Joining_Group:   _:=KAPH}');
    Error('\P{Joining_Group:   _:=KAPH}');
    Expect(1, 1823, '\p{Joining_Group=:\AKaph\z:}', "");;
    Expect(0, 1824, '\p{Joining_Group=:\AKaph\z:}', "");;
    Expect(1, 1823, '\p{Joining_Group=kaph}', "");
    Expect(0, 1823, '\p{^Joining_Group=kaph}', "");
    Expect(0, 1823, '\P{Joining_Group=kaph}', "");
    Expect(1, 1823, '\P{^Joining_Group=kaph}', "");
    Expect(0, 1824, '\p{Joining_Group=kaph}', "");
    Expect(1, 1824, '\p{^Joining_Group=kaph}', "");
    Expect(1, 1824, '\P{Joining_Group=kaph}', "");
    Expect(0, 1824, '\P{^Joining_Group=kaph}', "");
    Expect(1, 1823, '\p{Joining_Group=:\Akaph\z:}', "");;
    Expect(0, 1824, '\p{Joining_Group=:\Akaph\z:}', "");;
    Expect(1, 1823, '\p{Joining_Group=-_KAPH}', "");
    Expect(0, 1823, '\p{^Joining_Group=-_KAPH}', "");
    Expect(0, 1823, '\P{Joining_Group=-_KAPH}', "");
    Expect(1, 1823, '\P{^Joining_Group=-_KAPH}', "");
    Expect(0, 1824, '\p{Joining_Group=-_KAPH}', "");
    Expect(1, 1824, '\p{^Joining_Group=-_KAPH}', "");
    Expect(1, 1824, '\P{Joining_Group=-_KAPH}', "");
    Expect(0, 1824, '\P{^Joining_Group=-_KAPH}', "");
    Error('\p{Jg=:=KAPH}');
    Error('\P{Jg=:=KAPH}');
    Expect(1, 1823, '\p{Jg=:\AKaph\z:}', "");;
    Expect(0, 1824, '\p{Jg=:\AKaph\z:}', "");;
    Expect(1, 1823, '\p{Jg=kaph}', "");
    Expect(0, 1823, '\p{^Jg=kaph}', "");
    Expect(0, 1823, '\P{Jg=kaph}', "");
    Expect(1, 1823, '\P{^Jg=kaph}', "");
    Expect(0, 1824, '\p{Jg=kaph}', "");
    Expect(1, 1824, '\p{^Jg=kaph}', "");
    Expect(1, 1824, '\P{Jg=kaph}', "");
    Expect(0, 1824, '\P{^Jg=kaph}', "");
    Expect(1, 1823, '\p{Jg=:\Akaph\z:}', "");;
    Expect(0, 1824, '\p{Jg=:\Akaph\z:}', "");;
    Expect(1, 1823, '\p{Jg= kaph}', "");
    Expect(0, 1823, '\p{^Jg= kaph}', "");
    Expect(0, 1823, '\P{Jg= kaph}', "");
    Expect(1, 1823, '\P{^Jg= kaph}', "");
    Expect(0, 1824, '\p{Jg= kaph}', "");
    Expect(1, 1824, '\p{^Jg= kaph}', "");
    Expect(1, 1824, '\P{Jg= kaph}', "");
    Expect(0, 1824, '\P{^Jg= kaph}', "");
    Error('\p{Is_Joining_Group=	 kaph:=}');
    Error('\P{Is_Joining_Group=	 kaph:=}');
    Expect(1, 1823, '\p{Is_Joining_Group=kaph}', "");
    Expect(0, 1823, '\p{^Is_Joining_Group=kaph}', "");
    Expect(0, 1823, '\P{Is_Joining_Group=kaph}', "");
    Expect(1, 1823, '\P{^Is_Joining_Group=kaph}', "");
    Expect(0, 1824, '\p{Is_Joining_Group=kaph}', "");
    Expect(1, 1824, '\p{^Is_Joining_Group=kaph}', "");
    Expect(1, 1824, '\P{Is_Joining_Group=kaph}', "");
    Expect(0, 1824, '\P{^Is_Joining_Group=kaph}', "");
    Expect(1, 1823, '\p{Is_Joining_Group=	-KAPH}', "");
    Expect(0, 1823, '\p{^Is_Joining_Group=	-KAPH}', "");
    Expect(0, 1823, '\P{Is_Joining_Group=	-KAPH}', "");
    Expect(1, 1823, '\P{^Is_Joining_Group=	-KAPH}', "");
    Expect(0, 1824, '\p{Is_Joining_Group=	-KAPH}', "");
    Expect(1, 1824, '\p{^Is_Joining_Group=	-KAPH}', "");
    Expect(1, 1824, '\P{Is_Joining_Group=	-KAPH}', "");
    Expect(0, 1824, '\P{^Is_Joining_Group=	-KAPH}', "");
    Error('\p{Is_Jg:	/a/	 Kaph}');
    Error('\P{Is_Jg:	/a/	 Kaph}');
    Expect(1, 1823, '\p{Is_Jg=kaph}', "");
    Expect(0, 1823, '\p{^Is_Jg=kaph}', "");
    Expect(0, 1823, '\P{Is_Jg=kaph}', "");
    Expect(1, 1823, '\P{^Is_Jg=kaph}', "");
    Expect(0, 1824, '\p{Is_Jg=kaph}', "");
    Expect(1, 1824, '\p{^Is_Jg=kaph}', "");
    Expect(1, 1824, '\P{Is_Jg=kaph}', "");
    Expect(0, 1824, '\P{^Is_Jg=kaph}', "");
    Expect(1, 1823, '\p{Is_Jg=- Kaph}', "");
    Expect(0, 1823, '\p{^Is_Jg=- Kaph}', "");
    Expect(0, 1823, '\P{Is_Jg=- Kaph}', "");
    Expect(1, 1823, '\P{^Is_Jg=- Kaph}', "");
    Expect(0, 1824, '\p{Is_Jg=- Kaph}', "");
    Expect(1, 1824, '\p{^Is_Jg=- Kaph}', "");
    Expect(1, 1824, '\P{Is_Jg=- Kaph}', "");
    Expect(0, 1824, '\P{^Is_Jg=- Kaph}', "");
    Error('\p{Joining_Group:_/a/KHAPH}');
    Error('\P{Joining_Group:_/a/KHAPH}');
    Expect(1, 1870, '\p{Joining_Group=:\AKhaph\z:}', "");;
    Expect(0, 1871, '\p{Joining_Group=:\AKhaph\z:}', "");;
    Expect(1, 1870, '\p{Joining_Group=khaph}', "");
    Expect(0, 1870, '\p{^Joining_Group=khaph}', "");
    Expect(0, 1870, '\P{Joining_Group=khaph}', "");
    Expect(1, 1870, '\P{^Joining_Group=khaph}', "");
    Expect(0, 1871, '\p{Joining_Group=khaph}', "");
    Expect(1, 1871, '\p{^Joining_Group=khaph}', "");
    Expect(1, 1871, '\P{Joining_Group=khaph}', "");
    Expect(0, 1871, '\P{^Joining_Group=khaph}', "");
    Expect(1, 1870, '\p{Joining_Group=:\Akhaph\z:}', "");;
    Expect(0, 1871, '\p{Joining_Group=:\Akhaph\z:}', "");;
    Expect(1, 1870, '\p{Joining_Group=_	khaph}', "");
    Expect(0, 1870, '\p{^Joining_Group=_	khaph}', "");
    Expect(0, 1870, '\P{Joining_Group=_	khaph}', "");
    Expect(1, 1870, '\P{^Joining_Group=_	khaph}', "");
    Expect(0, 1871, '\p{Joining_Group=_	khaph}', "");
    Expect(1, 1871, '\p{^Joining_Group=_	khaph}', "");
    Expect(1, 1871, '\P{Joining_Group=_	khaph}', "");
    Expect(0, 1871, '\P{^Joining_Group=_	khaph}', "");
    Error('\p{Jg=_:=KHAPH}');
    Error('\P{Jg=_:=KHAPH}');
    Expect(1, 1870, '\p{Jg=:\AKhaph\z:}', "");;
    Expect(0, 1871, '\p{Jg=:\AKhaph\z:}', "");;
    Expect(1, 1870, '\p{Jg=khaph}', "");
    Expect(0, 1870, '\p{^Jg=khaph}', "");
    Expect(0, 1870, '\P{Jg=khaph}', "");
    Expect(1, 1870, '\P{^Jg=khaph}', "");
    Expect(0, 1871, '\p{Jg=khaph}', "");
    Expect(1, 1871, '\p{^Jg=khaph}', "");
    Expect(1, 1871, '\P{Jg=khaph}', "");
    Expect(0, 1871, '\P{^Jg=khaph}', "");
    Expect(1, 1870, '\p{Jg=:\Akhaph\z:}', "");;
    Expect(0, 1871, '\p{Jg=:\Akhaph\z:}', "");;
    Expect(1, 1870, '\p{Jg: _ Khaph}', "");
    Expect(0, 1870, '\p{^Jg: _ Khaph}', "");
    Expect(0, 1870, '\P{Jg: _ Khaph}', "");
    Expect(1, 1870, '\P{^Jg: _ Khaph}', "");
    Expect(0, 1871, '\p{Jg: _ Khaph}', "");
    Expect(1, 1871, '\p{^Jg: _ Khaph}', "");
    Expect(1, 1871, '\P{Jg: _ Khaph}', "");
    Expect(0, 1871, '\P{^Jg: _ Khaph}', "");
    Error('\p{Is_Joining_Group= :=KHAPH}');
    Error('\P{Is_Joining_Group= :=KHAPH}');
    Expect(1, 1870, '\p{Is_Joining_Group=khaph}', "");
    Expect(0, 1870, '\p{^Is_Joining_Group=khaph}', "");
    Expect(0, 1870, '\P{Is_Joining_Group=khaph}', "");
    Expect(1, 1870, '\P{^Is_Joining_Group=khaph}', "");
    Expect(0, 1871, '\p{Is_Joining_Group=khaph}', "");
    Expect(1, 1871, '\p{^Is_Joining_Group=khaph}', "");
    Expect(1, 1871, '\P{Is_Joining_Group=khaph}', "");
    Expect(0, 1871, '\P{^Is_Joining_Group=khaph}', "");
    Expect(1, 1870, '\p{Is_Joining_Group=-KHAPH}', "");
    Expect(0, 1870, '\p{^Is_Joining_Group=-KHAPH}', "");
    Expect(0, 1870, '\P{Is_Joining_Group=-KHAPH}', "");
    Expect(1, 1870, '\P{^Is_Joining_Group=-KHAPH}', "");
    Expect(0, 1871, '\p{Is_Joining_Group=-KHAPH}', "");
    Expect(1, 1871, '\p{^Is_Joining_Group=-KHAPH}', "");
    Expect(1, 1871, '\P{Is_Joining_Group=-KHAPH}', "");
    Expect(0, 1871, '\P{^Is_Joining_Group=-KHAPH}', "");
    Error('\p{Is_Jg=/a/__Khaph}');
    Error('\P{Is_Jg=/a/__Khaph}');
    Expect(1, 1870, '\p{Is_Jg=khaph}', "");
    Expect(0, 1870, '\p{^Is_Jg=khaph}', "");
    Expect(0, 1870, '\P{Is_Jg=khaph}', "");
    Expect(1, 1870, '\P{^Is_Jg=khaph}', "");
    Expect(0, 1871, '\p{Is_Jg=khaph}', "");
    Expect(1, 1871, '\p{^Is_Jg=khaph}', "");
    Expect(1, 1871, '\P{Is_Jg=khaph}', "");
    Expect(0, 1871, '\P{^Is_Jg=khaph}', "");
    Expect(1, 1870, '\p{Is_Jg=_Khaph}', "");
    Expect(0, 1870, '\p{^Is_Jg=_Khaph}', "");
    Expect(0, 1870, '\P{Is_Jg=_Khaph}', "");
    Expect(1, 1870, '\P{^Is_Jg=_Khaph}', "");
    Expect(0, 1871, '\p{Is_Jg=_Khaph}', "");
    Expect(1, 1871, '\p{^Is_Jg=_Khaph}', "");
    Expect(1, 1871, '\P{Is_Jg=_Khaph}', "");
    Expect(0, 1871, '\P{^Is_Jg=_Khaph}', "");
    Error('\p{Joining_Group=:=knotted_Heh}');
    Error('\P{Joining_Group=:=knotted_Heh}');
    Expect(1, 1791, '\p{Joining_Group=:\AKnotted_Heh\z:}', "");;
    Expect(0, 1792, '\p{Joining_Group=:\AKnotted_Heh\z:}', "");;
    Expect(1, 1791, '\p{Joining_Group: knottedheh}', "");
    Expect(0, 1791, '\p{^Joining_Group: knottedheh}', "");
    Expect(0, 1791, '\P{Joining_Group: knottedheh}', "");
    Expect(1, 1791, '\P{^Joining_Group: knottedheh}', "");
    Expect(0, 1792, '\p{Joining_Group: knottedheh}', "");
    Expect(1, 1792, '\p{^Joining_Group: knottedheh}', "");
    Expect(1, 1792, '\P{Joining_Group: knottedheh}', "");
    Expect(0, 1792, '\P{^Joining_Group: knottedheh}', "");
    Expect(1, 1791, '\p{Joining_Group=:\Aknottedheh\z:}', "");;
    Expect(0, 1792, '\p{Joining_Group=:\Aknottedheh\z:}', "");;
    Expect(1, 1791, '\p{Joining_Group=	Knotted_heh}', "");
    Expect(0, 1791, '\p{^Joining_Group=	Knotted_heh}', "");
    Expect(0, 1791, '\P{Joining_Group=	Knotted_heh}', "");
    Expect(1, 1791, '\P{^Joining_Group=	Knotted_heh}', "");
    Expect(0, 1792, '\p{Joining_Group=	Knotted_heh}', "");
    Expect(1, 1792, '\p{^Joining_Group=	Knotted_heh}', "");
    Expect(1, 1792, '\P{Joining_Group=	Knotted_heh}', "");
    Expect(0, 1792, '\P{^Joining_Group=	Knotted_heh}', "");
    Error('\p{Jg= /a/knotted_HEH}');
    Error('\P{Jg= /a/knotted_HEH}');
    Expect(1, 1791, '\p{Jg=:\AKnotted_Heh\z:}', "");;
    Expect(0, 1792, '\p{Jg=:\AKnotted_Heh\z:}', "");;
    Expect(1, 1791, '\p{Jg=knottedheh}', "");
    Expect(0, 1791, '\p{^Jg=knottedheh}', "");
    Expect(0, 1791, '\P{Jg=knottedheh}', "");
    Expect(1, 1791, '\P{^Jg=knottedheh}', "");
    Expect(0, 1792, '\p{Jg=knottedheh}', "");
    Expect(1, 1792, '\p{^Jg=knottedheh}', "");
    Expect(1, 1792, '\P{Jg=knottedheh}', "");
    Expect(0, 1792, '\P{^Jg=knottedheh}', "");
    Expect(1, 1791, '\p{Jg=:\Aknottedheh\z:}', "");;
    Expect(0, 1792, '\p{Jg=:\Aknottedheh\z:}', "");;
    Expect(1, 1791, '\p{Jg:	 KNOTTED_heh}', "");
    Expect(0, 1791, '\p{^Jg:	 KNOTTED_heh}', "");
    Expect(0, 1791, '\P{Jg:	 KNOTTED_heh}', "");
    Expect(1, 1791, '\P{^Jg:	 KNOTTED_heh}', "");
    Expect(0, 1792, '\p{Jg:	 KNOTTED_heh}', "");
    Expect(1, 1792, '\p{^Jg:	 KNOTTED_heh}', "");
    Expect(1, 1792, '\P{Jg:	 KNOTTED_heh}', "");
    Expect(0, 1792, '\P{^Jg:	 KNOTTED_heh}', "");
    Error('\p{Is_Joining_Group=-Knotted_heh:=}');
    Error('\P{Is_Joining_Group=-Knotted_heh:=}');
    Expect(1, 1791, '\p{Is_Joining_Group=knottedheh}', "");
    Expect(0, 1791, '\p{^Is_Joining_Group=knottedheh}', "");
    Expect(0, 1791, '\P{Is_Joining_Group=knottedheh}', "");
    Expect(1, 1791, '\P{^Is_Joining_Group=knottedheh}', "");
    Expect(0, 1792, '\p{Is_Joining_Group=knottedheh}', "");
    Expect(1, 1792, '\p{^Is_Joining_Group=knottedheh}', "");
    Expect(1, 1792, '\P{Is_Joining_Group=knottedheh}', "");
    Expect(0, 1792, '\P{^Is_Joining_Group=knottedheh}', "");
    Expect(1, 1791, '\p{Is_Joining_Group=	 Knotted_HEH}', "");
    Expect(0, 1791, '\p{^Is_Joining_Group=	 Knotted_HEH}', "");
    Expect(0, 1791, '\P{Is_Joining_Group=	 Knotted_HEH}', "");
    Expect(1, 1791, '\P{^Is_Joining_Group=	 Knotted_HEH}', "");
    Expect(0, 1792, '\p{Is_Joining_Group=	 Knotted_HEH}', "");
    Expect(1, 1792, '\p{^Is_Joining_Group=	 Knotted_HEH}', "");
    Expect(1, 1792, '\P{Is_Joining_Group=	 Knotted_HEH}', "");
    Expect(0, 1792, '\P{^Is_Joining_Group=	 Knotted_HEH}', "");
    Error('\p{Is_Jg=	knotted_Heh:=}');
    Error('\P{Is_Jg=	knotted_Heh:=}');
    Expect(1, 1791, '\p{Is_Jg=knottedheh}', "");
    Expect(0, 1791, '\p{^Is_Jg=knottedheh}', "");
    Expect(0, 1791, '\P{Is_Jg=knottedheh}', "");
    Expect(1, 1791, '\P{^Is_Jg=knottedheh}', "");
    Expect(0, 1792, '\p{Is_Jg=knottedheh}', "");
    Expect(1, 1792, '\p{^Is_Jg=knottedheh}', "");
    Expect(1, 1792, '\P{Is_Jg=knottedheh}', "");
    Expect(0, 1792, '\P{^Is_Jg=knottedheh}', "");
    Expect(1, 1791, '\p{Is_Jg=	 Knotted_Heh}', "");
    Expect(0, 1791, '\p{^Is_Jg=	 Knotted_Heh}', "");
    Expect(0, 1791, '\P{Is_Jg=	 Knotted_Heh}', "");
    Expect(1, 1791, '\P{^Is_Jg=	 Knotted_Heh}', "");
    Expect(0, 1792, '\p{Is_Jg=	 Knotted_Heh}', "");
    Expect(1, 1792, '\p{^Is_Jg=	 Knotted_Heh}', "");
    Expect(1, 1792, '\P{Is_Jg=	 Knotted_Heh}', "");
    Expect(0, 1792, '\P{^Is_Jg=	 Knotted_Heh}', "");
    Error('\p{Joining_Group=:=LAM}');
    Error('\P{Joining_Group=:=LAM}');
    Expect(1, 2247, '\p{Joining_Group=:\ALam\z:}', "");;
    Expect(0, 2248, '\p{Joining_Group=:\ALam\z:}', "");;
    Expect(1, 2247, '\p{Joining_Group=lam}', "");
    Expect(0, 2247, '\p{^Joining_Group=lam}', "");
    Expect(0, 2247, '\P{Joining_Group=lam}', "");
    Expect(1, 2247, '\P{^Joining_Group=lam}', "");
    Expect(0, 2248, '\p{Joining_Group=lam}', "");
    Expect(1, 2248, '\p{^Joining_Group=lam}', "");
    Expect(1, 2248, '\P{Joining_Group=lam}', "");
    Expect(0, 2248, '\P{^Joining_Group=lam}', "");
    Expect(1, 2247, '\p{Joining_Group=:\Alam\z:}', "");;
    Expect(0, 2248, '\p{Joining_Group=:\Alam\z:}', "");;
    Expect(1, 2247, '\p{Joining_Group=_ Lam}', "");
    Expect(0, 2247, '\p{^Joining_Group=_ Lam}', "");
    Expect(0, 2247, '\P{Joining_Group=_ Lam}', "");
    Expect(1, 2247, '\P{^Joining_Group=_ Lam}', "");
    Expect(0, 2248, '\p{Joining_Group=_ Lam}', "");
    Expect(1, 2248, '\p{^Joining_Group=_ Lam}', "");
    Expect(1, 2248, '\P{Joining_Group=_ Lam}', "");
    Expect(0, 2248, '\P{^Joining_Group=_ Lam}', "");
    Error('\p{Jg:   -:=Lam}');
    Error('\P{Jg:   -:=Lam}');
    Expect(1, 2247, '\p{Jg=:\ALam\z:}', "");;
    Expect(0, 2248, '\p{Jg=:\ALam\z:}', "");;
    Expect(1, 2247, '\p{Jg=lam}', "");
    Expect(0, 2247, '\p{^Jg=lam}', "");
    Expect(0, 2247, '\P{Jg=lam}', "");
    Expect(1, 2247, '\P{^Jg=lam}', "");
    Expect(0, 2248, '\p{Jg=lam}', "");
    Expect(1, 2248, '\p{^Jg=lam}', "");
    Expect(1, 2248, '\P{Jg=lam}', "");
    Expect(0, 2248, '\P{^Jg=lam}', "");
    Expect(1, 2247, '\p{Jg=:\Alam\z:}', "");;
    Expect(0, 2248, '\p{Jg=:\Alam\z:}', "");;
    Expect(1, 2247, '\p{Jg=	LAM}', "");
    Expect(0, 2247, '\p{^Jg=	LAM}', "");
    Expect(0, 2247, '\P{Jg=	LAM}', "");
    Expect(1, 2247, '\P{^Jg=	LAM}', "");
    Expect(0, 2248, '\p{Jg=	LAM}', "");
    Expect(1, 2248, '\p{^Jg=	LAM}', "");
    Expect(1, 2248, '\P{Jg=	LAM}', "");
    Expect(0, 2248, '\P{^Jg=	LAM}', "");
    Error('\p{Is_Joining_Group=  LAM/a/}');
    Error('\P{Is_Joining_Group=  LAM/a/}');
    Expect(1, 2247, '\p{Is_Joining_Group=lam}', "");
    Expect(0, 2247, '\p{^Is_Joining_Group=lam}', "");
    Expect(0, 2247, '\P{Is_Joining_Group=lam}', "");
    Expect(1, 2247, '\P{^Is_Joining_Group=lam}', "");
    Expect(0, 2248, '\p{Is_Joining_Group=lam}', "");
    Expect(1, 2248, '\p{^Is_Joining_Group=lam}', "");
    Expect(1, 2248, '\P{Is_Joining_Group=lam}', "");
    Expect(0, 2248, '\P{^Is_Joining_Group=lam}', "");
    Expect(1, 2247, '\p{Is_Joining_Group=-	Lam}', "");
    Expect(0, 2247, '\p{^Is_Joining_Group=-	Lam}', "");
    Expect(0, 2247, '\P{Is_Joining_Group=-	Lam}', "");
    Expect(1, 2247, '\P{^Is_Joining_Group=-	Lam}', "");
    Expect(0, 2248, '\p{Is_Joining_Group=-	Lam}', "");
    Expect(1, 2248, '\p{^Is_Joining_Group=-	Lam}', "");
    Expect(1, 2248, '\P{Is_Joining_Group=-	Lam}', "");
    Expect(0, 2248, '\P{^Is_Joining_Group=-	Lam}', "");
    Error('\p{Is_Jg=:= _LAM}');
    Error('\P{Is_Jg=:= _LAM}');
    Expect(1, 2247, '\p{Is_Jg=lam}', "");
    Expect(0, 2247, '\p{^Is_Jg=lam}', "");
    Expect(0, 2247, '\P{Is_Jg=lam}', "");
    Expect(1, 2247, '\P{^Is_Jg=lam}', "");
    Expect(0, 2248, '\p{Is_Jg=lam}', "");
    Expect(1, 2248, '\p{^Is_Jg=lam}', "");
    Expect(1, 2248, '\P{Is_Jg=lam}', "");
    Expect(0, 2248, '\P{^Is_Jg=lam}', "");
    Expect(1, 2247, '\p{Is_Jg=__lam}', "");
    Expect(0, 2247, '\p{^Is_Jg=__lam}', "");
    Expect(0, 2247, '\P{Is_Jg=__lam}', "");
    Expect(1, 2247, '\P{^Is_Jg=__lam}', "");
    Expect(0, 2248, '\p{Is_Jg=__lam}', "");
    Expect(1, 2248, '\p{^Is_Jg=__lam}', "");
    Expect(1, 2248, '\P{Is_Jg=__lam}', "");
    Expect(0, 2248, '\P{^Is_Jg=__lam}', "");
    Error('\p{Joining_Group=_/a/lamadh}');
    Error('\P{Joining_Group=_/a/lamadh}');
    Expect(1, 1824, '\p{Joining_Group=:\ALamadh\z:}', "");;
    Expect(0, 1825, '\p{Joining_Group=:\ALamadh\z:}', "");;
    Expect(1, 1824, '\p{Joining_Group=lamadh}', "");
    Expect(0, 1824, '\p{^Joining_Group=lamadh}', "");
    Expect(0, 1824, '\P{Joining_Group=lamadh}', "");
    Expect(1, 1824, '\P{^Joining_Group=lamadh}', "");
    Expect(0, 1825, '\p{Joining_Group=lamadh}', "");
    Expect(1, 1825, '\p{^Joining_Group=lamadh}', "");
    Expect(1, 1825, '\P{Joining_Group=lamadh}', "");
    Expect(0, 1825, '\P{^Joining_Group=lamadh}', "");
    Expect(1, 1824, '\p{Joining_Group=:\Alamadh\z:}', "");;
    Expect(0, 1825, '\p{Joining_Group=:\Alamadh\z:}', "");;
    Expect(1, 1824, '\p{Joining_Group: - Lamadh}', "");
    Expect(0, 1824, '\p{^Joining_Group: - Lamadh}', "");
    Expect(0, 1824, '\P{Joining_Group: - Lamadh}', "");
    Expect(1, 1824, '\P{^Joining_Group: - Lamadh}', "");
    Expect(0, 1825, '\p{Joining_Group: - Lamadh}', "");
    Expect(1, 1825, '\p{^Joining_Group: - Lamadh}', "");
    Expect(1, 1825, '\P{Joining_Group: - Lamadh}', "");
    Expect(0, 1825, '\P{^Joining_Group: - Lamadh}', "");
    Error('\p{Jg= LAMADH:=}');
    Error('\P{Jg= LAMADH:=}');
    Expect(1, 1824, '\p{Jg=:\ALamadh\z:}', "");;
    Expect(0, 1825, '\p{Jg=:\ALamadh\z:}', "");;
    Expect(1, 1824, '\p{Jg=lamadh}', "");
    Expect(0, 1824, '\p{^Jg=lamadh}', "");
    Expect(0, 1824, '\P{Jg=lamadh}', "");
    Expect(1, 1824, '\P{^Jg=lamadh}', "");
    Expect(0, 1825, '\p{Jg=lamadh}', "");
    Expect(1, 1825, '\p{^Jg=lamadh}', "");
    Expect(1, 1825, '\P{Jg=lamadh}', "");
    Expect(0, 1825, '\P{^Jg=lamadh}', "");
    Expect(1, 1824, '\p{Jg=:\Alamadh\z:}', "");;
    Expect(0, 1825, '\p{Jg=:\Alamadh\z:}', "");;
    Expect(1, 1824, '\p{Jg=__Lamadh}', "");
    Expect(0, 1824, '\p{^Jg=__Lamadh}', "");
    Expect(0, 1824, '\P{Jg=__Lamadh}', "");
    Expect(1, 1824, '\P{^Jg=__Lamadh}', "");
    Expect(0, 1825, '\p{Jg=__Lamadh}', "");
    Expect(1, 1825, '\p{^Jg=__Lamadh}', "");
    Expect(1, 1825, '\P{Jg=__Lamadh}', "");
    Expect(0, 1825, '\P{^Jg=__Lamadh}', "");
    Error('\p{Is_Joining_Group=	 LAMADH:=}');
    Error('\P{Is_Joining_Group=	 LAMADH:=}');
    Expect(1, 1824, '\p{Is_Joining_Group=lamadh}', "");
    Expect(0, 1824, '\p{^Is_Joining_Group=lamadh}', "");
    Expect(0, 1824, '\P{Is_Joining_Group=lamadh}', "");
    Expect(1, 1824, '\P{^Is_Joining_Group=lamadh}', "");
    Expect(0, 1825, '\p{Is_Joining_Group=lamadh}', "");
    Expect(1, 1825, '\p{^Is_Joining_Group=lamadh}', "");
    Expect(1, 1825, '\P{Is_Joining_Group=lamadh}', "");
    Expect(0, 1825, '\P{^Is_Joining_Group=lamadh}', "");
    Expect(1, 1824, '\p{Is_Joining_Group=-	Lamadh}', "");
    Expect(0, 1824, '\p{^Is_Joining_Group=-	Lamadh}', "");
    Expect(0, 1824, '\P{Is_Joining_Group=-	Lamadh}', "");
    Expect(1, 1824, '\P{^Is_Joining_Group=-	Lamadh}', "");
    Expect(0, 1825, '\p{Is_Joining_Group=-	Lamadh}', "");
    Expect(1, 1825, '\p{^Is_Joining_Group=-	Lamadh}', "");
    Expect(1, 1825, '\P{Is_Joining_Group=-	Lamadh}', "");
    Expect(0, 1825, '\P{^Is_Joining_Group=-	Lamadh}', "");
    Error('\p{Is_Jg=:=lamadh}');
    Error('\P{Is_Jg=:=lamadh}');
    Expect(1, 1824, '\p{Is_Jg=lamadh}', "");
    Expect(0, 1824, '\p{^Is_Jg=lamadh}', "");
    Expect(0, 1824, '\P{Is_Jg=lamadh}', "");
    Expect(1, 1824, '\P{^Is_Jg=lamadh}', "");
    Expect(0, 1825, '\p{Is_Jg=lamadh}', "");
    Expect(1, 1825, '\p{^Is_Jg=lamadh}', "");
    Expect(1, 1825, '\P{Is_Jg=lamadh}', "");
    Expect(0, 1825, '\P{^Is_Jg=lamadh}', "");
    Expect(1, 1824, '\p{Is_Jg=	 LAMADH}', "");
    Expect(0, 1824, '\p{^Is_Jg=	 LAMADH}', "");
    Expect(0, 1824, '\P{Is_Jg=	 LAMADH}', "");
    Expect(1, 1824, '\P{^Is_Jg=	 LAMADH}', "");
    Expect(0, 1825, '\p{Is_Jg=	 LAMADH}', "");
    Expect(1, 1825, '\p{^Is_Jg=	 LAMADH}', "");
    Expect(1, 1825, '\P{Is_Jg=	 LAMADH}', "");
    Expect(0, 1825, '\P{^Is_Jg=	 LAMADH}', "");
    Error('\p{Joining_Group= MALAYALAM_Bha:=}');
    Error('\P{Joining_Group= MALAYALAM_Bha:=}');
    Expect(1, 2150, '\p{Joining_Group=:\AMalayalam_Bha\z:}', "");;
    Expect(0, 2151, '\p{Joining_Group=:\AMalayalam_Bha\z:}', "");;
    Expect(1, 2150, '\p{Joining_Group=malayalambha}', "");
    Expect(0, 2150, '\p{^Joining_Group=malayalambha}', "");
    Expect(0, 2150, '\P{Joining_Group=malayalambha}', "");
    Expect(1, 2150, '\P{^Joining_Group=malayalambha}', "");
    Expect(0, 2151, '\p{Joining_Group=malayalambha}', "");
    Expect(1, 2151, '\p{^Joining_Group=malayalambha}', "");
    Expect(1, 2151, '\P{Joining_Group=malayalambha}', "");
    Expect(0, 2151, '\P{^Joining_Group=malayalambha}', "");
    Expect(1, 2150, '\p{Joining_Group=:\Amalayalambha\z:}', "");;
    Expect(0, 2151, '\p{Joining_Group=:\Amalayalambha\z:}', "");;
    Expect(1, 2150, '\p{Joining_Group= malayalam_Bha}', "");
    Expect(0, 2150, '\p{^Joining_Group= malayalam_Bha}', "");
    Expect(0, 2150, '\P{Joining_Group= malayalam_Bha}', "");
    Expect(1, 2150, '\P{^Joining_Group= malayalam_Bha}', "");
    Expect(0, 2151, '\p{Joining_Group= malayalam_Bha}', "");
    Expect(1, 2151, '\p{^Joining_Group= malayalam_Bha}', "");
    Expect(1, 2151, '\P{Joining_Group= malayalam_Bha}', "");
    Expect(0, 2151, '\P{^Joining_Group= malayalam_Bha}', "");
    Error('\p{Jg:	 Malayalam_Bha/a/}');
    Error('\P{Jg:	 Malayalam_Bha/a/}');
    Expect(1, 2150, '\p{Jg=:\AMalayalam_Bha\z:}', "");;
    Expect(0, 2151, '\p{Jg=:\AMalayalam_Bha\z:}', "");;
    Expect(1, 2150, '\p{Jg=malayalambha}', "");
    Expect(0, 2150, '\p{^Jg=malayalambha}', "");
    Expect(0, 2150, '\P{Jg=malayalambha}', "");
    Expect(1, 2150, '\P{^Jg=malayalambha}', "");
    Expect(0, 2151, '\p{Jg=malayalambha}', "");
    Expect(1, 2151, '\p{^Jg=malayalambha}', "");
    Expect(1, 2151, '\P{Jg=malayalambha}', "");
    Expect(0, 2151, '\P{^Jg=malayalambha}', "");
    Expect(1, 2150, '\p{Jg=:\Amalayalambha\z:}', "");;
    Expect(0, 2151, '\p{Jg=:\Amalayalambha\z:}', "");;
    Expect(1, 2150, '\p{Jg=	 Malayalam_Bha}', "");
    Expect(0, 2150, '\p{^Jg=	 Malayalam_Bha}', "");
    Expect(0, 2150, '\P{Jg=	 Malayalam_Bha}', "");
    Expect(1, 2150, '\P{^Jg=	 Malayalam_Bha}', "");
    Expect(0, 2151, '\p{Jg=	 Malayalam_Bha}', "");
    Expect(1, 2151, '\p{^Jg=	 Malayalam_Bha}', "");
    Expect(1, 2151, '\P{Jg=	 Malayalam_Bha}', "");
    Expect(0, 2151, '\P{^Jg=	 Malayalam_Bha}', "");
    Error('\p{Is_Joining_Group=MALAYALAM_Bha:=}');
    Error('\P{Is_Joining_Group=MALAYALAM_Bha:=}');
    Expect(1, 2150, '\p{Is_Joining_Group=malayalambha}', "");
    Expect(0, 2150, '\p{^Is_Joining_Group=malayalambha}', "");
    Expect(0, 2150, '\P{Is_Joining_Group=malayalambha}', "");
    Expect(1, 2150, '\P{^Is_Joining_Group=malayalambha}', "");
    Expect(0, 2151, '\p{Is_Joining_Group=malayalambha}', "");
    Expect(1, 2151, '\p{^Is_Joining_Group=malayalambha}', "");
    Expect(1, 2151, '\P{Is_Joining_Group=malayalambha}', "");
    Expect(0, 2151, '\P{^Is_Joining_Group=malayalambha}', "");
    Expect(1, 2150, '\p{Is_Joining_Group=	_Malayalam_bha}', "");
    Expect(0, 2150, '\p{^Is_Joining_Group=	_Malayalam_bha}', "");
    Expect(0, 2150, '\P{Is_Joining_Group=	_Malayalam_bha}', "");
    Expect(1, 2150, '\P{^Is_Joining_Group=	_Malayalam_bha}', "");
    Expect(0, 2151, '\p{Is_Joining_Group=	_Malayalam_bha}', "");
    Expect(1, 2151, '\p{^Is_Joining_Group=	_Malayalam_bha}', "");
    Expect(1, 2151, '\P{Is_Joining_Group=	_Malayalam_bha}', "");
    Expect(0, 2151, '\P{^Is_Joining_Group=	_Malayalam_bha}', "");
    Error('\p{Is_Jg=	 Malayalam_bha:=}');
    Error('\P{Is_Jg=	 Malayalam_bha:=}');
    Expect(1, 2150, '\p{Is_Jg=malayalambha}', "");
    Expect(0, 2150, '\p{^Is_Jg=malayalambha}', "");
    Expect(0, 2150, '\P{Is_Jg=malayalambha}', "");
    Expect(1, 2150, '\P{^Is_Jg=malayalambha}', "");
    Expect(0, 2151, '\p{Is_Jg=malayalambha}', "");
    Expect(1, 2151, '\p{^Is_Jg=malayalambha}', "");
    Expect(1, 2151, '\P{Is_Jg=malayalambha}', "");
    Expect(0, 2151, '\P{^Is_Jg=malayalambha}', "");
    Expect(1, 2150, '\p{Is_Jg=_-MALAYALAM_bha}', "");
    Expect(0, 2150, '\p{^Is_Jg=_-MALAYALAM_bha}', "");
    Expect(0, 2150, '\P{Is_Jg=_-MALAYALAM_bha}', "");
    Expect(1, 2150, '\P{^Is_Jg=_-MALAYALAM_bha}', "");
    Expect(0, 2151, '\p{Is_Jg=_-MALAYALAM_bha}', "");
    Expect(1, 2151, '\p{^Is_Jg=_-MALAYALAM_bha}', "");
    Expect(1, 2151, '\P{Is_Jg=_-MALAYALAM_bha}', "");
    Expect(0, 2151, '\P{^Is_Jg=_-MALAYALAM_bha}', "");
    Error('\p{Joining_Group=-/a/Malayalam_Ja}');
    Error('\P{Joining_Group=-/a/Malayalam_Ja}');
    Expect(1, 2145, '\p{Joining_Group=:\AMalayalam_Ja\z:}', "");;
    Expect(0, 2146, '\p{Joining_Group=:\AMalayalam_Ja\z:}', "");;
    Expect(1, 2145, '\p{Joining_Group=malayalamja}', "");
    Expect(0, 2145, '\p{^Joining_Group=malayalamja}', "");
    Expect(0, 2145, '\P{Joining_Group=malayalamja}', "");
    Expect(1, 2145, '\P{^Joining_Group=malayalamja}', "");
    Expect(0, 2146, '\p{Joining_Group=malayalamja}', "");
    Expect(1, 2146, '\p{^Joining_Group=malayalamja}', "");
    Expect(1, 2146, '\P{Joining_Group=malayalamja}', "");
    Expect(0, 2146, '\P{^Joining_Group=malayalamja}', "");
    Expect(1, 2145, '\p{Joining_Group=:\Amalayalamja\z:}', "");;
    Expect(0, 2146, '\p{Joining_Group=:\Amalayalamja\z:}', "");;
    Expect(1, 2145, '\p{Joining_Group=_-MALAYALAM_Ja}', "");
    Expect(0, 2145, '\p{^Joining_Group=_-MALAYALAM_Ja}', "");
    Expect(0, 2145, '\P{Joining_Group=_-MALAYALAM_Ja}', "");
    Expect(1, 2145, '\P{^Joining_Group=_-MALAYALAM_Ja}', "");
    Expect(0, 2146, '\p{Joining_Group=_-MALAYALAM_Ja}', "");
    Expect(1, 2146, '\p{^Joining_Group=_-MALAYALAM_Ja}', "");
    Expect(1, 2146, '\P{Joining_Group=_-MALAYALAM_Ja}', "");
    Expect(0, 2146, '\P{^Joining_Group=_-MALAYALAM_Ja}', "");
    Error('\p{Jg=:=__Malayalam_Ja}');
    Error('\P{Jg=:=__Malayalam_Ja}');
    Expect(1, 2145, '\p{Jg=:\AMalayalam_Ja\z:}', "");;
    Expect(0, 2146, '\p{Jg=:\AMalayalam_Ja\z:}', "");;
    Expect(1, 2145, '\p{Jg=malayalamja}', "");
    Expect(0, 2145, '\p{^Jg=malayalamja}', "");
    Expect(0, 2145, '\P{Jg=malayalamja}', "");
    Expect(1, 2145, '\P{^Jg=malayalamja}', "");
    Expect(0, 2146, '\p{Jg=malayalamja}', "");
    Expect(1, 2146, '\p{^Jg=malayalamja}', "");
    Expect(1, 2146, '\P{Jg=malayalamja}', "");
    Expect(0, 2146, '\P{^Jg=malayalamja}', "");
    Expect(1, 2145, '\p{Jg=:\Amalayalamja\z:}', "");;
    Expect(0, 2146, '\p{Jg=:\Amalayalamja\z:}', "");;
    Expect(1, 2145, '\p{Jg=	 malayalam_Ja}', "");
    Expect(0, 2145, '\p{^Jg=	 malayalam_Ja}', "");
    Expect(0, 2145, '\P{Jg=	 malayalam_Ja}', "");
    Expect(1, 2145, '\P{^Jg=	 malayalam_Ja}', "");
    Expect(0, 2146, '\p{Jg=	 malayalam_Ja}', "");
    Expect(1, 2146, '\p{^Jg=	 malayalam_Ja}', "");
    Expect(1, 2146, '\P{Jg=	 malayalam_Ja}', "");
    Expect(0, 2146, '\P{^Jg=	 malayalam_Ja}', "");
    Error('\p{Is_Joining_Group=/a/-malayalam_ja}');
    Error('\P{Is_Joining_Group=/a/-malayalam_ja}');
    Expect(1, 2145, '\p{Is_Joining_Group=malayalamja}', "");
    Expect(0, 2145, '\p{^Is_Joining_Group=malayalamja}', "");
    Expect(0, 2145, '\P{Is_Joining_Group=malayalamja}', "");
    Expect(1, 2145, '\P{^Is_Joining_Group=malayalamja}', "");
    Expect(0, 2146, '\p{Is_Joining_Group=malayalamja}', "");
    Expect(1, 2146, '\p{^Is_Joining_Group=malayalamja}', "");
    Expect(1, 2146, '\P{Is_Joining_Group=malayalamja}', "");
    Expect(0, 2146, '\P{^Is_Joining_Group=malayalamja}', "");
    Expect(1, 2145, '\p{Is_Joining_Group=- Malayalam_Ja}', "");
    Expect(0, 2145, '\p{^Is_Joining_Group=- Malayalam_Ja}', "");
    Expect(0, 2145, '\P{Is_Joining_Group=- Malayalam_Ja}', "");
    Expect(1, 2145, '\P{^Is_Joining_Group=- Malayalam_Ja}', "");
    Expect(0, 2146, '\p{Is_Joining_Group=- Malayalam_Ja}', "");
    Expect(1, 2146, '\p{^Is_Joining_Group=- Malayalam_Ja}', "");
    Expect(1, 2146, '\P{Is_Joining_Group=- Malayalam_Ja}', "");
    Expect(0, 2146, '\P{^Is_Joining_Group=- Malayalam_Ja}', "");
    Error('\p{Is_Jg=/a/ 	malayalam_ja}');
    Error('\P{Is_Jg=/a/ 	malayalam_ja}');
    Expect(1, 2145, '\p{Is_Jg=malayalamja}', "");
    Expect(0, 2145, '\p{^Is_Jg=malayalamja}', "");
    Expect(0, 2145, '\P{Is_Jg=malayalamja}', "");
    Expect(1, 2145, '\P{^Is_Jg=malayalamja}', "");
    Expect(0, 2146, '\p{Is_Jg=malayalamja}', "");
    Expect(1, 2146, '\p{^Is_Jg=malayalamja}', "");
    Expect(1, 2146, '\P{Is_Jg=malayalamja}', "");
    Expect(0, 2146, '\P{^Is_Jg=malayalamja}', "");
    Expect(1, 2145, '\p{Is_Jg=-	malayalam_Ja}', "");
    Expect(0, 2145, '\p{^Is_Jg=-	malayalam_Ja}', "");
    Expect(0, 2145, '\P{Is_Jg=-	malayalam_Ja}', "");
    Expect(1, 2145, '\P{^Is_Jg=-	malayalam_Ja}', "");
    Expect(0, 2146, '\p{Is_Jg=-	malayalam_Ja}', "");
    Expect(1, 2146, '\p{^Is_Jg=-	malayalam_Ja}', "");
    Expect(1, 2146, '\P{Is_Jg=-	malayalam_Ja}', "");
    Expect(0, 2146, '\P{^Is_Jg=-	malayalam_Ja}', "");
    Error('\p{Joining_Group=	/a/Malayalam_Lla}');
    Error('\P{Joining_Group=	/a/Malayalam_Lla}');
    Expect(1, 2152, '\p{Joining_Group=:\AMalayalam_Lla\z:}', "");;
    Expect(0, 2153, '\p{Joining_Group=:\AMalayalam_Lla\z:}', "");;
    Expect(1, 2152, '\p{Joining_Group=malayalamlla}', "");
    Expect(0, 2152, '\p{^Joining_Group=malayalamlla}', "");
    Expect(0, 2152, '\P{Joining_Group=malayalamlla}', "");
    Expect(1, 2152, '\P{^Joining_Group=malayalamlla}', "");
    Expect(0, 2153, '\p{Joining_Group=malayalamlla}', "");
    Expect(1, 2153, '\p{^Joining_Group=malayalamlla}', "");
    Expect(1, 2153, '\P{Joining_Group=malayalamlla}', "");
    Expect(0, 2153, '\P{^Joining_Group=malayalamlla}', "");
    Expect(1, 2152, '\p{Joining_Group=:\Amalayalamlla\z:}', "");;
    Expect(0, 2153, '\p{Joining_Group=:\Amalayalamlla\z:}', "");;
    Expect(1, 2152, '\p{Joining_Group= _Malayalam_Lla}', "");
    Expect(0, 2152, '\p{^Joining_Group= _Malayalam_Lla}', "");
    Expect(0, 2152, '\P{Joining_Group= _Malayalam_Lla}', "");
    Expect(1, 2152, '\P{^Joining_Group= _Malayalam_Lla}', "");
    Expect(0, 2153, '\p{Joining_Group= _Malayalam_Lla}', "");
    Expect(1, 2153, '\p{^Joining_Group= _Malayalam_Lla}', "");
    Expect(1, 2153, '\P{Joining_Group= _Malayalam_Lla}', "");
    Expect(0, 2153, '\P{^Joining_Group= _Malayalam_Lla}', "");
    Error('\p{Jg= malayalam_Lla:=}');
    Error('\P{Jg= malayalam_Lla:=}');
    Expect(1, 2152, '\p{Jg=:\AMalayalam_Lla\z:}', "");;
    Expect(0, 2153, '\p{Jg=:\AMalayalam_Lla\z:}', "");;
    Expect(1, 2152, '\p{Jg=malayalamlla}', "");
    Expect(0, 2152, '\p{^Jg=malayalamlla}', "");
    Expect(0, 2152, '\P{Jg=malayalamlla}', "");
    Expect(1, 2152, '\P{^Jg=malayalamlla}', "");
    Expect(0, 2153, '\p{Jg=malayalamlla}', "");
    Expect(1, 2153, '\p{^Jg=malayalamlla}', "");
    Expect(1, 2153, '\P{Jg=malayalamlla}', "");
    Expect(0, 2153, '\P{^Jg=malayalamlla}', "");
    Expect(1, 2152, '\p{Jg=:\Amalayalamlla\z:}', "");;
    Expect(0, 2153, '\p{Jg=:\Amalayalamlla\z:}', "");;
    Expect(1, 2152, '\p{Jg= 	MALAYALAM_Lla}', "");
    Expect(0, 2152, '\p{^Jg= 	MALAYALAM_Lla}', "");
    Expect(0, 2152, '\P{Jg= 	MALAYALAM_Lla}', "");
    Expect(1, 2152, '\P{^Jg= 	MALAYALAM_Lla}', "");
    Expect(0, 2153, '\p{Jg= 	MALAYALAM_Lla}', "");
    Expect(1, 2153, '\p{^Jg= 	MALAYALAM_Lla}', "");
    Expect(1, 2153, '\P{Jg= 	MALAYALAM_Lla}', "");
    Expect(0, 2153, '\P{^Jg= 	MALAYALAM_Lla}', "");
    Error('\p{Is_Joining_Group=:= 	Malayalam_Lla}');
    Error('\P{Is_Joining_Group=:= 	Malayalam_Lla}');
    Expect(1, 2152, '\p{Is_Joining_Group=malayalamlla}', "");
    Expect(0, 2152, '\p{^Is_Joining_Group=malayalamlla}', "");
    Expect(0, 2152, '\P{Is_Joining_Group=malayalamlla}', "");
    Expect(1, 2152, '\P{^Is_Joining_Group=malayalamlla}', "");
    Expect(0, 2153, '\p{Is_Joining_Group=malayalamlla}', "");
    Expect(1, 2153, '\p{^Is_Joining_Group=malayalamlla}', "");
    Expect(1, 2153, '\P{Is_Joining_Group=malayalamlla}', "");
    Expect(0, 2153, '\P{^Is_Joining_Group=malayalamlla}', "");
    Expect(1, 2152, '\p{Is_Joining_Group=_	MALAYALAM_Lla}', "");
    Expect(0, 2152, '\p{^Is_Joining_Group=_	MALAYALAM_Lla}', "");
    Expect(0, 2152, '\P{Is_Joining_Group=_	MALAYALAM_Lla}', "");
    Expect(1, 2152, '\P{^Is_Joining_Group=_	MALAYALAM_Lla}', "");
    Expect(0, 2153, '\p{Is_Joining_Group=_	MALAYALAM_Lla}', "");
    Expect(1, 2153, '\p{^Is_Joining_Group=_	MALAYALAM_Lla}', "");
    Expect(1, 2153, '\P{Is_Joining_Group=_	MALAYALAM_Lla}', "");
    Expect(0, 2153, '\P{^Is_Joining_Group=_	MALAYALAM_Lla}', "");
    Error('\p{Is_Jg=/a/__Malayalam_lla}');
    Error('\P{Is_Jg=/a/__Malayalam_lla}');
    Expect(1, 2152, '\p{Is_Jg=malayalamlla}', "");
    Expect(0, 2152, '\p{^Is_Jg=malayalamlla}', "");
    Expect(0, 2152, '\P{Is_Jg=malayalamlla}', "");
    Expect(1, 2152, '\P{^Is_Jg=malayalamlla}', "");
    Expect(0, 2153, '\p{Is_Jg=malayalamlla}', "");
    Expect(1, 2153, '\p{^Is_Jg=malayalamlla}', "");
    Expect(1, 2153, '\P{Is_Jg=malayalamlla}', "");
    Expect(0, 2153, '\P{^Is_Jg=malayalamlla}', "");
    Expect(1, 2152, '\p{Is_Jg=	 Malayalam_LLA}', "");
    Expect(0, 2152, '\p{^Is_Jg=	 Malayalam_LLA}', "");
    Expect(0, 2152, '\P{Is_Jg=	 Malayalam_LLA}', "");
    Expect(1, 2152, '\P{^Is_Jg=	 Malayalam_LLA}', "");
    Expect(0, 2153, '\p{Is_Jg=	 Malayalam_LLA}', "");
    Expect(1, 2153, '\p{^Is_Jg=	 Malayalam_LLA}', "");
    Expect(1, 2153, '\P{Is_Jg=	 Malayalam_LLA}', "");
    Expect(0, 2153, '\P{^Is_Jg=	 Malayalam_LLA}', "");
    Error('\p{Joining_Group=	:=malayalam_Llla}');
    Error('\P{Joining_Group=	:=malayalam_Llla}');
    Expect(1, 2153, '\p{Joining_Group=:\AMalayalam_Llla\z:}', "");;
    Expect(0, 2154, '\p{Joining_Group=:\AMalayalam_Llla\z:}', "");;
    Expect(1, 2153, '\p{Joining_Group=malayalamllla}', "");
    Expect(0, 2153, '\p{^Joining_Group=malayalamllla}', "");
    Expect(0, 2153, '\P{Joining_Group=malayalamllla}', "");
    Expect(1, 2153, '\P{^Joining_Group=malayalamllla}', "");
    Expect(0, 2154, '\p{Joining_Group=malayalamllla}', "");
    Expect(1, 2154, '\p{^Joining_Group=malayalamllla}', "");
    Expect(1, 2154, '\P{Joining_Group=malayalamllla}', "");
    Expect(0, 2154, '\P{^Joining_Group=malayalamllla}', "");
    Expect(1, 2153, '\p{Joining_Group=:\Amalayalamllla\z:}', "");;
    Expect(0, 2154, '\p{Joining_Group=:\Amalayalamllla\z:}', "");;
    Expect(1, 2153, '\p{Joining_Group:		_Malayalam_Llla}', "");
    Expect(0, 2153, '\p{^Joining_Group:		_Malayalam_Llla}', "");
    Expect(0, 2153, '\P{Joining_Group:		_Malayalam_Llla}', "");
    Expect(1, 2153, '\P{^Joining_Group:		_Malayalam_Llla}', "");
    Expect(0, 2154, '\p{Joining_Group:		_Malayalam_Llla}', "");
    Expect(1, 2154, '\p{^Joining_Group:		_Malayalam_Llla}', "");
    Expect(1, 2154, '\P{Joining_Group:		_Malayalam_Llla}', "");
    Expect(0, 2154, '\P{^Joining_Group:		_Malayalam_Llla}', "");
    Error('\p{Jg=:=Malayalam_Llla}');
    Error('\P{Jg=:=Malayalam_Llla}');
    Expect(1, 2153, '\p{Jg=:\AMalayalam_Llla\z:}', "");;
    Expect(0, 2154, '\p{Jg=:\AMalayalam_Llla\z:}', "");;
    Expect(1, 2153, '\p{Jg=malayalamllla}', "");
    Expect(0, 2153, '\p{^Jg=malayalamllla}', "");
    Expect(0, 2153, '\P{Jg=malayalamllla}', "");
    Expect(1, 2153, '\P{^Jg=malayalamllla}', "");
    Expect(0, 2154, '\p{Jg=malayalamllla}', "");
    Expect(1, 2154, '\p{^Jg=malayalamllla}', "");
    Expect(1, 2154, '\P{Jg=malayalamllla}', "");
    Expect(0, 2154, '\P{^Jg=malayalamllla}', "");
    Expect(1, 2153, '\p{Jg=:\Amalayalamllla\z:}', "");;
    Expect(0, 2154, '\p{Jg=:\Amalayalamllla\z:}', "");;
    Expect(1, 2153, '\p{Jg=		Malayalam_Llla}', "");
    Expect(0, 2153, '\p{^Jg=		Malayalam_Llla}', "");
    Expect(0, 2153, '\P{Jg=		Malayalam_Llla}', "");
    Expect(1, 2153, '\P{^Jg=		Malayalam_Llla}', "");
    Expect(0, 2154, '\p{Jg=		Malayalam_Llla}', "");
    Expect(1, 2154, '\p{^Jg=		Malayalam_Llla}', "");
    Expect(1, 2154, '\P{Jg=		Malayalam_Llla}', "");
    Expect(0, 2154, '\P{^Jg=		Malayalam_Llla}', "");
    Error('\p{Is_Joining_Group=:=_ Malayalam_Llla}');
    Error('\P{Is_Joining_Group=:=_ Malayalam_Llla}');
    Expect(1, 2153, '\p{Is_Joining_Group: malayalamllla}', "");
    Expect(0, 2153, '\p{^Is_Joining_Group: malayalamllla}', "");
    Expect(0, 2153, '\P{Is_Joining_Group: malayalamllla}', "");
    Expect(1, 2153, '\P{^Is_Joining_Group: malayalamllla}', "");
    Expect(0, 2154, '\p{Is_Joining_Group: malayalamllla}', "");
    Expect(1, 2154, '\p{^Is_Joining_Group: malayalamllla}', "");
    Expect(1, 2154, '\P{Is_Joining_Group: malayalamllla}', "");
    Expect(0, 2154, '\P{^Is_Joining_Group: malayalamllla}', "");
    Expect(1, 2153, '\p{Is_Joining_Group=	Malayalam_llla}', "");
    Expect(0, 2153, '\p{^Is_Joining_Group=	Malayalam_llla}', "");
    Expect(0, 2153, '\P{Is_Joining_Group=	Malayalam_llla}', "");
    Expect(1, 2153, '\P{^Is_Joining_Group=	Malayalam_llla}', "");
    Expect(0, 2154, '\p{Is_Joining_Group=	Malayalam_llla}', "");
    Expect(1, 2154, '\p{^Is_Joining_Group=	Malayalam_llla}', "");
    Expect(1, 2154, '\P{Is_Joining_Group=	Malayalam_llla}', "");
    Expect(0, 2154, '\P{^Is_Joining_Group=	Malayalam_llla}', "");
    Error('\p{Is_Jg=:=Malayalam_llla}');
    Error('\P{Is_Jg=:=Malayalam_llla}');
    Expect(1, 2153, '\p{Is_Jg=malayalamllla}', "");
    Expect(0, 2153, '\p{^Is_Jg=malayalamllla}', "");
    Expect(0, 2153, '\P{Is_Jg=malayalamllla}', "");
    Expect(1, 2153, '\P{^Is_Jg=malayalamllla}', "");
    Expect(0, 2154, '\p{Is_Jg=malayalamllla}', "");
    Expect(1, 2154, '\p{^Is_Jg=malayalamllla}', "");
    Expect(1, 2154, '\P{Is_Jg=malayalamllla}', "");
    Expect(0, 2154, '\P{^Is_Jg=malayalamllla}', "");
    Expect(1, 2153, '\p{Is_Jg=-	malayalam_Llla}', "");
    Expect(0, 2153, '\p{^Is_Jg=-	malayalam_Llla}', "");
    Expect(0, 2153, '\P{Is_Jg=-	malayalam_Llla}', "");
    Expect(1, 2153, '\P{^Is_Jg=-	malayalam_Llla}', "");
    Expect(0, 2154, '\p{Is_Jg=-	malayalam_Llla}', "");
    Expect(1, 2154, '\p{^Is_Jg=-	malayalam_Llla}', "");
    Expect(1, 2154, '\P{Is_Jg=-	malayalam_Llla}', "");
    Expect(0, 2154, '\P{^Is_Jg=-	malayalam_Llla}', "");
    Error('\p{Joining_Group=-/a/Malayalam_Nga}');
    Error('\P{Joining_Group=-/a/Malayalam_Nga}');
    Expect(1, 2144, '\p{Joining_Group=:\AMalayalam_Nga\z:}', "");;
    Expect(0, 2145, '\p{Joining_Group=:\AMalayalam_Nga\z:}', "");;
    Expect(1, 2144, '\p{Joining_Group=malayalamnga}', "");
    Expect(0, 2144, '\p{^Joining_Group=malayalamnga}', "");
    Expect(0, 2144, '\P{Joining_Group=malayalamnga}', "");
    Expect(1, 2144, '\P{^Joining_Group=malayalamnga}', "");
    Expect(0, 2145, '\p{Joining_Group=malayalamnga}', "");
    Expect(1, 2145, '\p{^Joining_Group=malayalamnga}', "");
    Expect(1, 2145, '\P{Joining_Group=malayalamnga}', "");
    Expect(0, 2145, '\P{^Joining_Group=malayalamnga}', "");
    Expect(1, 2144, '\p{Joining_Group=:\Amalayalamnga\z:}', "");;
    Expect(0, 2145, '\p{Joining_Group=:\Amalayalamnga\z:}', "");;
    Expect(1, 2144, '\p{Joining_Group= Malayalam_NGA}', "");
    Expect(0, 2144, '\p{^Joining_Group= Malayalam_NGA}', "");
    Expect(0, 2144, '\P{Joining_Group= Malayalam_NGA}', "");
    Expect(1, 2144, '\P{^Joining_Group= Malayalam_NGA}', "");
    Expect(0, 2145, '\p{Joining_Group= Malayalam_NGA}', "");
    Expect(1, 2145, '\p{^Joining_Group= Malayalam_NGA}', "");
    Expect(1, 2145, '\P{Joining_Group= Malayalam_NGA}', "");
    Expect(0, 2145, '\P{^Joining_Group= Malayalam_NGA}', "");
    Error('\p{Jg=:=_MALAYALAM_nga}');
    Error('\P{Jg=:=_MALAYALAM_nga}');
    Expect(1, 2144, '\p{Jg=:\AMalayalam_Nga\z:}', "");;
    Expect(0, 2145, '\p{Jg=:\AMalayalam_Nga\z:}', "");;
    Expect(1, 2144, '\p{Jg:malayalamnga}', "");
    Expect(0, 2144, '\p{^Jg:malayalamnga}', "");
    Expect(0, 2144, '\P{Jg:malayalamnga}', "");
    Expect(1, 2144, '\P{^Jg:malayalamnga}', "");
    Expect(0, 2145, '\p{Jg:malayalamnga}', "");
    Expect(1, 2145, '\p{^Jg:malayalamnga}', "");
    Expect(1, 2145, '\P{Jg:malayalamnga}', "");
    Expect(0, 2145, '\P{^Jg:malayalamnga}', "");
    Expect(1, 2144, '\p{Jg=:\Amalayalamnga\z:}', "");;
    Expect(0, 2145, '\p{Jg=:\Amalayalamnga\z:}', "");;
    Expect(1, 2144, '\p{Jg=	 MALAYALAM_Nga}', "");
    Expect(0, 2144, '\p{^Jg=	 MALAYALAM_Nga}', "");
    Expect(0, 2144, '\P{Jg=	 MALAYALAM_Nga}', "");
    Expect(1, 2144, '\P{^Jg=	 MALAYALAM_Nga}', "");
    Expect(0, 2145, '\p{Jg=	 MALAYALAM_Nga}', "");
    Expect(1, 2145, '\p{^Jg=	 MALAYALAM_Nga}', "");
    Expect(1, 2145, '\P{Jg=	 MALAYALAM_Nga}', "");
    Expect(0, 2145, '\P{^Jg=	 MALAYALAM_Nga}', "");
    Error('\p{Is_Joining_Group=_/a/MALAYALAM_Nga}');
    Error('\P{Is_Joining_Group=_/a/MALAYALAM_Nga}');
    Expect(1, 2144, '\p{Is_Joining_Group=malayalamnga}', "");
    Expect(0, 2144, '\p{^Is_Joining_Group=malayalamnga}', "");
    Expect(0, 2144, '\P{Is_Joining_Group=malayalamnga}', "");
    Expect(1, 2144, '\P{^Is_Joining_Group=malayalamnga}', "");
    Expect(0, 2145, '\p{Is_Joining_Group=malayalamnga}', "");
    Expect(1, 2145, '\p{^Is_Joining_Group=malayalamnga}', "");
    Expect(1, 2145, '\P{Is_Joining_Group=malayalamnga}', "");
    Expect(0, 2145, '\P{^Is_Joining_Group=malayalamnga}', "");
    Expect(1, 2144, '\p{Is_Joining_Group: 		Malayalam_nga}', "");
    Expect(0, 2144, '\p{^Is_Joining_Group: 		Malayalam_nga}', "");
    Expect(0, 2144, '\P{Is_Joining_Group: 		Malayalam_nga}', "");
    Expect(1, 2144, '\P{^Is_Joining_Group: 		Malayalam_nga}', "");
    Expect(0, 2145, '\p{Is_Joining_Group: 		Malayalam_nga}', "");
    Expect(1, 2145, '\p{^Is_Joining_Group: 		Malayalam_nga}', "");
    Expect(1, 2145, '\P{Is_Joining_Group: 		Malayalam_nga}', "");
    Expect(0, 2145, '\P{^Is_Joining_Group: 		Malayalam_nga}', "");
    Error('\p{Is_Jg=	 Malayalam_Nga/a/}');
    Error('\P{Is_Jg=	 Malayalam_Nga/a/}');
    Expect(1, 2144, '\p{Is_Jg=malayalamnga}', "");
    Expect(0, 2144, '\p{^Is_Jg=malayalamnga}', "");
    Expect(0, 2144, '\P{Is_Jg=malayalamnga}', "");
    Expect(1, 2144, '\P{^Is_Jg=malayalamnga}', "");
    Expect(0, 2145, '\p{Is_Jg=malayalamnga}', "");
    Expect(1, 2145, '\p{^Is_Jg=malayalamnga}', "");
    Expect(1, 2145, '\P{Is_Jg=malayalamnga}', "");
    Expect(0, 2145, '\P{^Is_Jg=malayalamnga}', "");
    Expect(1, 2144, '\p{Is_Jg=__Malayalam_NGA}', "");
    Expect(0, 2144, '\p{^Is_Jg=__Malayalam_NGA}', "");
    Expect(0, 2144, '\P{Is_Jg=__Malayalam_NGA}', "");
    Expect(1, 2144, '\P{^Is_Jg=__Malayalam_NGA}', "");
    Expect(0, 2145, '\p{Is_Jg=__Malayalam_NGA}', "");
    Expect(1, 2145, '\p{^Is_Jg=__Malayalam_NGA}', "");
    Expect(1, 2145, '\P{Is_Jg=__Malayalam_NGA}', "");
    Expect(0, 2145, '\P{^Is_Jg=__Malayalam_NGA}', "");
    Error('\p{Joining_Group:   	/a/malayalam_Nna}');
    Error('\P{Joining_Group:   	/a/malayalam_Nna}');
    Expect(1, 2148, '\p{Joining_Group=:\AMalayalam_Nna\z:}', "");;
    Expect(0, 2149, '\p{Joining_Group=:\AMalayalam_Nna\z:}', "");;
    Expect(1, 2148, '\p{Joining_Group=malayalamnna}', "");
    Expect(0, 2148, '\p{^Joining_Group=malayalamnna}', "");
    Expect(0, 2148, '\P{Joining_Group=malayalamnna}', "");
    Expect(1, 2148, '\P{^Joining_Group=malayalamnna}', "");
    Expect(0, 2149, '\p{Joining_Group=malayalamnna}', "");
    Expect(1, 2149, '\p{^Joining_Group=malayalamnna}', "");
    Expect(1, 2149, '\P{Joining_Group=malayalamnna}', "");
    Expect(0, 2149, '\P{^Joining_Group=malayalamnna}', "");
    Expect(1, 2148, '\p{Joining_Group=:\Amalayalamnna\z:}', "");;
    Expect(0, 2149, '\p{Joining_Group=:\Amalayalamnna\z:}', "");;
    Expect(1, 2148, '\p{Joining_Group=_Malayalam_nna}', "");
    Expect(0, 2148, '\p{^Joining_Group=_Malayalam_nna}', "");
    Expect(0, 2148, '\P{Joining_Group=_Malayalam_nna}', "");
    Expect(1, 2148, '\P{^Joining_Group=_Malayalam_nna}', "");
    Expect(0, 2149, '\p{Joining_Group=_Malayalam_nna}', "");
    Expect(1, 2149, '\p{^Joining_Group=_Malayalam_nna}', "");
    Expect(1, 2149, '\P{Joining_Group=_Malayalam_nna}', "");
    Expect(0, 2149, '\P{^Joining_Group=_Malayalam_nna}', "");
    Error('\p{Jg=	/a/malayalam_nna}');
    Error('\P{Jg=	/a/malayalam_nna}');
    Expect(1, 2148, '\p{Jg=:\AMalayalam_Nna\z:}', "");;
    Expect(0, 2149, '\p{Jg=:\AMalayalam_Nna\z:}', "");;
    Expect(1, 2148, '\p{Jg=malayalamnna}', "");
    Expect(0, 2148, '\p{^Jg=malayalamnna}', "");
    Expect(0, 2148, '\P{Jg=malayalamnna}', "");
    Expect(1, 2148, '\P{^Jg=malayalamnna}', "");
    Expect(0, 2149, '\p{Jg=malayalamnna}', "");
    Expect(1, 2149, '\p{^Jg=malayalamnna}', "");
    Expect(1, 2149, '\P{Jg=malayalamnna}', "");
    Expect(0, 2149, '\P{^Jg=malayalamnna}', "");
    Expect(1, 2148, '\p{Jg=:\Amalayalamnna\z:}', "");;
    Expect(0, 2149, '\p{Jg=:\Amalayalamnna\z:}', "");;
    Expect(1, 2148, '\p{Jg:   --malayalam_Nna}', "");
    Expect(0, 2148, '\p{^Jg:   --malayalam_Nna}', "");
    Expect(0, 2148, '\P{Jg:   --malayalam_Nna}', "");
    Expect(1, 2148, '\P{^Jg:   --malayalam_Nna}', "");
    Expect(0, 2149, '\p{Jg:   --malayalam_Nna}', "");
    Expect(1, 2149, '\p{^Jg:   --malayalam_Nna}', "");
    Expect(1, 2149, '\P{Jg:   --malayalam_Nna}', "");
    Expect(0, 2149, '\P{^Jg:   --malayalam_Nna}', "");
    Error('\p{Is_Joining_Group=	:=malayalam_NNA}');
    Error('\P{Is_Joining_Group=	:=malayalam_NNA}');
    Expect(1, 2148, '\p{Is_Joining_Group:malayalamnna}', "");
    Expect(0, 2148, '\p{^Is_Joining_Group:malayalamnna}', "");
    Expect(0, 2148, '\P{Is_Joining_Group:malayalamnna}', "");
    Expect(1, 2148, '\P{^Is_Joining_Group:malayalamnna}', "");
    Expect(0, 2149, '\p{Is_Joining_Group:malayalamnna}', "");
    Expect(1, 2149, '\p{^Is_Joining_Group:malayalamnna}', "");
    Expect(1, 2149, '\P{Is_Joining_Group:malayalamnna}', "");
    Expect(0, 2149, '\P{^Is_Joining_Group:malayalamnna}', "");
    Expect(1, 2148, '\p{Is_Joining_Group:   -_Malayalam_nna}', "");
    Expect(0, 2148, '\p{^Is_Joining_Group:   -_Malayalam_nna}', "");
    Expect(0, 2148, '\P{Is_Joining_Group:   -_Malayalam_nna}', "");
    Expect(1, 2148, '\P{^Is_Joining_Group:   -_Malayalam_nna}', "");
    Expect(0, 2149, '\p{Is_Joining_Group:   -_Malayalam_nna}', "");
    Expect(1, 2149, '\p{^Is_Joining_Group:   -_Malayalam_nna}', "");
    Expect(1, 2149, '\P{Is_Joining_Group:   -_Malayalam_nna}', "");
    Expect(0, 2149, '\P{^Is_Joining_Group:   -_Malayalam_nna}', "");
    Error('\p{Is_Jg=_:=MALAYALAM_nna}');
    Error('\P{Is_Jg=_:=MALAYALAM_nna}');
    Expect(1, 2148, '\p{Is_Jg:   malayalamnna}', "");
    Expect(0, 2148, '\p{^Is_Jg:   malayalamnna}', "");
    Expect(0, 2148, '\P{Is_Jg:   malayalamnna}', "");
    Expect(1, 2148, '\P{^Is_Jg:   malayalamnna}', "");
    Expect(0, 2149, '\p{Is_Jg:   malayalamnna}', "");
    Expect(1, 2149, '\p{^Is_Jg:   malayalamnna}', "");
    Expect(1, 2149, '\P{Is_Jg:   malayalamnna}', "");
    Expect(0, 2149, '\P{^Is_Jg:   malayalamnna}', "");
    Expect(1, 2148, '\p{Is_Jg=-Malayalam_Nna}', "");
    Expect(0, 2148, '\p{^Is_Jg=-Malayalam_Nna}', "");
    Expect(0, 2148, '\P{Is_Jg=-Malayalam_Nna}', "");
    Expect(1, 2148, '\P{^Is_Jg=-Malayalam_Nna}', "");
    Expect(0, 2149, '\p{Is_Jg=-Malayalam_Nna}', "");
    Expect(1, 2149, '\p{^Is_Jg=-Malayalam_Nna}', "");
    Expect(1, 2149, '\P{Is_Jg=-Malayalam_Nna}', "");
    Expect(0, 2149, '\P{^Is_Jg=-Malayalam_Nna}', "");
    Error('\p{Joining_Group=:=Malayalam_Nnna}');
    Error('\P{Joining_Group=:=Malayalam_Nnna}');
    Expect(1, 2149, '\p{Joining_Group=:\AMalayalam_Nnna\z:}', "");;
    Expect(0, 2150, '\p{Joining_Group=:\AMalayalam_Nnna\z:}', "");;
    Expect(1, 2149, '\p{Joining_Group=malayalamnnna}', "");
    Expect(0, 2149, '\p{^Joining_Group=malayalamnnna}', "");
    Expect(0, 2149, '\P{Joining_Group=malayalamnnna}', "");
    Expect(1, 2149, '\P{^Joining_Group=malayalamnnna}', "");
    Expect(0, 2150, '\p{Joining_Group=malayalamnnna}', "");
    Expect(1, 2150, '\p{^Joining_Group=malayalamnnna}', "");
    Expect(1, 2150, '\P{Joining_Group=malayalamnnna}', "");
    Expect(0, 2150, '\P{^Joining_Group=malayalamnnna}', "");
    Expect(1, 2149, '\p{Joining_Group=:\Amalayalamnnna\z:}', "");;
    Expect(0, 2150, '\p{Joining_Group=:\Amalayalamnnna\z:}', "");;
    Expect(1, 2149, '\p{Joining_Group=	_malayalam_nnna}', "");
    Expect(0, 2149, '\p{^Joining_Group=	_malayalam_nnna}', "");
    Expect(0, 2149, '\P{Joining_Group=	_malayalam_nnna}', "");
    Expect(1, 2149, '\P{^Joining_Group=	_malayalam_nnna}', "");
    Expect(0, 2150, '\p{Joining_Group=	_malayalam_nnna}', "");
    Expect(1, 2150, '\p{^Joining_Group=	_malayalam_nnna}', "");
    Expect(1, 2150, '\P{Joining_Group=	_malayalam_nnna}', "");
    Expect(0, 2150, '\P{^Joining_Group=	_malayalam_nnna}', "");
    Error('\p{Jg:   /a/MALAYALAM_NNNA}');
    Error('\P{Jg:   /a/MALAYALAM_NNNA}');
    Expect(1, 2149, '\p{Jg=:\AMalayalam_Nnna\z:}', "");;
    Expect(0, 2150, '\p{Jg=:\AMalayalam_Nnna\z:}', "");;
    Expect(1, 2149, '\p{Jg=malayalamnnna}', "");
    Expect(0, 2149, '\p{^Jg=malayalamnnna}', "");
    Expect(0, 2149, '\P{Jg=malayalamnnna}', "");
    Expect(1, 2149, '\P{^Jg=malayalamnnna}', "");
    Expect(0, 2150, '\p{Jg=malayalamnnna}', "");
    Expect(1, 2150, '\p{^Jg=malayalamnnna}', "");
    Expect(1, 2150, '\P{Jg=malayalamnnna}', "");
    Expect(0, 2150, '\P{^Jg=malayalamnnna}', "");
    Expect(1, 2149, '\p{Jg=:\Amalayalamnnna\z:}', "");;
    Expect(0, 2150, '\p{Jg=:\Amalayalamnnna\z:}', "");;
    Expect(1, 2149, '\p{Jg=_	malayalam_NNNA}', "");
    Expect(0, 2149, '\p{^Jg=_	malayalam_NNNA}', "");
    Expect(0, 2149, '\P{Jg=_	malayalam_NNNA}', "");
    Expect(1, 2149, '\P{^Jg=_	malayalam_NNNA}', "");
    Expect(0, 2150, '\p{Jg=_	malayalam_NNNA}', "");
    Expect(1, 2150, '\p{^Jg=_	malayalam_NNNA}', "");
    Expect(1, 2150, '\P{Jg=_	malayalam_NNNA}', "");
    Expect(0, 2150, '\P{^Jg=_	malayalam_NNNA}', "");
    Error('\p{Is_Joining_Group=	_Malayalam_Nnna/a/}');
    Error('\P{Is_Joining_Group=	_Malayalam_Nnna/a/}');
    Expect(1, 2149, '\p{Is_Joining_Group=malayalamnnna}', "");
    Expect(0, 2149, '\p{^Is_Joining_Group=malayalamnnna}', "");
    Expect(0, 2149, '\P{Is_Joining_Group=malayalamnnna}', "");
    Expect(1, 2149, '\P{^Is_Joining_Group=malayalamnnna}', "");
    Expect(0, 2150, '\p{Is_Joining_Group=malayalamnnna}', "");
    Expect(1, 2150, '\p{^Is_Joining_Group=malayalamnnna}', "");
    Expect(1, 2150, '\P{Is_Joining_Group=malayalamnnna}', "");
    Expect(0, 2150, '\P{^Is_Joining_Group=malayalamnnna}', "");
    Expect(1, 2149, '\p{Is_Joining_Group=	Malayalam_NNNA}', "");
    Expect(0, 2149, '\p{^Is_Joining_Group=	Malayalam_NNNA}', "");
    Expect(0, 2149, '\P{Is_Joining_Group=	Malayalam_NNNA}', "");
    Expect(1, 2149, '\P{^Is_Joining_Group=	Malayalam_NNNA}', "");
    Expect(0, 2150, '\p{Is_Joining_Group=	Malayalam_NNNA}', "");
    Expect(1, 2150, '\p{^Is_Joining_Group=	Malayalam_NNNA}', "");
    Expect(1, 2150, '\P{Is_Joining_Group=	Malayalam_NNNA}', "");
    Expect(0, 2150, '\P{^Is_Joining_Group=	Malayalam_NNNA}', "");
    Error('\p{Is_Jg=_-Malayalam_Nnna/a/}');
    Error('\P{Is_Jg=_-Malayalam_Nnna/a/}');
    Expect(1, 2149, '\p{Is_Jg=malayalamnnna}', "");
    Expect(0, 2149, '\p{^Is_Jg=malayalamnnna}', "");
    Expect(0, 2149, '\P{Is_Jg=malayalamnnna}', "");
    Expect(1, 2149, '\P{^Is_Jg=malayalamnnna}', "");
    Expect(0, 2150, '\p{Is_Jg=malayalamnnna}', "");
    Expect(1, 2150, '\p{^Is_Jg=malayalamnnna}', "");
    Expect(1, 2150, '\P{Is_Jg=malayalamnnna}', "");
    Expect(0, 2150, '\P{^Is_Jg=malayalamnnna}', "");
    Expect(1, 2149, '\p{Is_Jg=--Malayalam_Nnna}', "");
    Expect(0, 2149, '\p{^Is_Jg=--Malayalam_Nnna}', "");
    Expect(0, 2149, '\P{Is_Jg=--Malayalam_Nnna}', "");
    Expect(1, 2149, '\P{^Is_Jg=--Malayalam_Nnna}', "");
    Expect(0, 2150, '\p{Is_Jg=--Malayalam_Nnna}', "");
    Expect(1, 2150, '\p{^Is_Jg=--Malayalam_Nnna}', "");
    Expect(1, 2150, '\P{Is_Jg=--Malayalam_Nnna}', "");
    Expect(0, 2150, '\P{^Is_Jg=--Malayalam_Nnna}', "");
    Error('\p{Joining_Group:	:=Malayalam_NYA}');
    Error('\P{Joining_Group:	:=Malayalam_NYA}');
    Expect(1, 2146, '\p{Joining_Group=:\AMalayalam_Nya\z:}', "");;
    Expect(0, 2147, '\p{Joining_Group=:\AMalayalam_Nya\z:}', "");;
    Expect(1, 2146, '\p{Joining_Group=malayalamnya}', "");
    Expect(0, 2146, '\p{^Joining_Group=malayalamnya}', "");
    Expect(0, 2146, '\P{Joining_Group=malayalamnya}', "");
    Expect(1, 2146, '\P{^Joining_Group=malayalamnya}', "");
    Expect(0, 2147, '\p{Joining_Group=malayalamnya}', "");
    Expect(1, 2147, '\p{^Joining_Group=malayalamnya}', "");
    Expect(1, 2147, '\P{Joining_Group=malayalamnya}', "");
    Expect(0, 2147, '\P{^Joining_Group=malayalamnya}', "");
    Expect(1, 2146, '\p{Joining_Group=:\Amalayalamnya\z:}', "");;
    Expect(0, 2147, '\p{Joining_Group=:\Amalayalamnya\z:}', "");;
    Expect(1, 2146, '\p{Joining_Group=	MALAYALAM_nya}', "");
    Expect(0, 2146, '\p{^Joining_Group=	MALAYALAM_nya}', "");
    Expect(0, 2146, '\P{Joining_Group=	MALAYALAM_nya}', "");
    Expect(1, 2146, '\P{^Joining_Group=	MALAYALAM_nya}', "");
    Expect(0, 2147, '\p{Joining_Group=	MALAYALAM_nya}', "");
    Expect(1, 2147, '\p{^Joining_Group=	MALAYALAM_nya}', "");
    Expect(1, 2147, '\P{Joining_Group=	MALAYALAM_nya}', "");
    Expect(0, 2147, '\P{^Joining_Group=	MALAYALAM_nya}', "");
    Error('\p{Jg= :=Malayalam_nya}');
    Error('\P{Jg= :=Malayalam_nya}');
    Expect(1, 2146, '\p{Jg=:\AMalayalam_Nya\z:}', "");;
    Expect(0, 2147, '\p{Jg=:\AMalayalam_Nya\z:}', "");;
    Expect(1, 2146, '\p{Jg=malayalamnya}', "");
    Expect(0, 2146, '\p{^Jg=malayalamnya}', "");
    Expect(0, 2146, '\P{Jg=malayalamnya}', "");
    Expect(1, 2146, '\P{^Jg=malayalamnya}', "");
    Expect(0, 2147, '\p{Jg=malayalamnya}', "");
    Expect(1, 2147, '\p{^Jg=malayalamnya}', "");
    Expect(1, 2147, '\P{Jg=malayalamnya}', "");
    Expect(0, 2147, '\P{^Jg=malayalamnya}', "");
    Expect(1, 2146, '\p{Jg=:\Amalayalamnya\z:}', "");;
    Expect(0, 2147, '\p{Jg=:\Amalayalamnya\z:}', "");;
    Expect(1, 2146, '\p{Jg=-MALAYALAM_NYA}', "");
    Expect(0, 2146, '\p{^Jg=-MALAYALAM_NYA}', "");
    Expect(0, 2146, '\P{Jg=-MALAYALAM_NYA}', "");
    Expect(1, 2146, '\P{^Jg=-MALAYALAM_NYA}', "");
    Expect(0, 2147, '\p{Jg=-MALAYALAM_NYA}', "");
    Expect(1, 2147, '\p{^Jg=-MALAYALAM_NYA}', "");
    Expect(1, 2147, '\P{Jg=-MALAYALAM_NYA}', "");
    Expect(0, 2147, '\P{^Jg=-MALAYALAM_NYA}', "");
    Error('\p{Is_Joining_Group=_-malayalam_Nya:=}');
    Error('\P{Is_Joining_Group=_-malayalam_Nya:=}');
    Expect(1, 2146, '\p{Is_Joining_Group=malayalamnya}', "");
    Expect(0, 2146, '\p{^Is_Joining_Group=malayalamnya}', "");
    Expect(0, 2146, '\P{Is_Joining_Group=malayalamnya}', "");
    Expect(1, 2146, '\P{^Is_Joining_Group=malayalamnya}', "");
    Expect(0, 2147, '\p{Is_Joining_Group=malayalamnya}', "");
    Expect(1, 2147, '\p{^Is_Joining_Group=malayalamnya}', "");
    Expect(1, 2147, '\P{Is_Joining_Group=malayalamnya}', "");
    Expect(0, 2147, '\P{^Is_Joining_Group=malayalamnya}', "");
    Expect(1, 2146, '\p{Is_Joining_Group=-malayalam_Nya}', "");
    Expect(0, 2146, '\p{^Is_Joining_Group=-malayalam_Nya}', "");
    Expect(0, 2146, '\P{Is_Joining_Group=-malayalam_Nya}', "");
    Expect(1, 2146, '\P{^Is_Joining_Group=-malayalam_Nya}', "");
    Expect(0, 2147, '\p{Is_Joining_Group=-malayalam_Nya}', "");
    Expect(1, 2147, '\p{^Is_Joining_Group=-malayalam_Nya}', "");
    Expect(1, 2147, '\P{Is_Joining_Group=-malayalam_Nya}', "");
    Expect(0, 2147, '\P{^Is_Joining_Group=-malayalam_Nya}', "");
    Error('\p{Is_Jg=	 Malayalam_NYA:=}');
    Error('\P{Is_Jg=	 Malayalam_NYA:=}');
    Expect(1, 2146, '\p{Is_Jg=malayalamnya}', "");
    Expect(0, 2146, '\p{^Is_Jg=malayalamnya}', "");
    Expect(0, 2146, '\P{Is_Jg=malayalamnya}', "");
    Expect(1, 2146, '\P{^Is_Jg=malayalamnya}', "");
    Expect(0, 2147, '\p{Is_Jg=malayalamnya}', "");
    Expect(1, 2147, '\p{^Is_Jg=malayalamnya}', "");
    Expect(1, 2147, '\P{Is_Jg=malayalamnya}', "");
    Expect(0, 2147, '\P{^Is_Jg=malayalamnya}', "");
    Expect(1, 2146, '\p{Is_Jg=	 MALAYALAM_Nya}', "");
    Expect(0, 2146, '\p{^Is_Jg=	 MALAYALAM_Nya}', "");
    Expect(0, 2146, '\P{Is_Jg=	 MALAYALAM_Nya}', "");
    Expect(1, 2146, '\P{^Is_Jg=	 MALAYALAM_Nya}', "");
    Expect(0, 2147, '\p{Is_Jg=	 MALAYALAM_Nya}', "");
    Expect(1, 2147, '\p{^Is_Jg=	 MALAYALAM_Nya}', "");
    Expect(1, 2147, '\P{Is_Jg=	 MALAYALAM_Nya}', "");
    Expect(0, 2147, '\P{^Is_Jg=	 MALAYALAM_Nya}', "");
    Error('\p{Joining_Group=:=	malayalam_Ra}');
    Error('\P{Joining_Group=:=	malayalam_Ra}');
    Expect(1, 2151, '\p{Joining_Group=:\AMalayalam_Ra\z:}', "");;
    Expect(0, 2152, '\p{Joining_Group=:\AMalayalam_Ra\z:}', "");;
    Expect(1, 2151, '\p{Joining_Group=malayalamra}', "");
    Expect(0, 2151, '\p{^Joining_Group=malayalamra}', "");
    Expect(0, 2151, '\P{Joining_Group=malayalamra}', "");
    Expect(1, 2151, '\P{^Joining_Group=malayalamra}', "");
    Expect(0, 2152, '\p{Joining_Group=malayalamra}', "");
    Expect(1, 2152, '\p{^Joining_Group=malayalamra}', "");
    Expect(1, 2152, '\P{Joining_Group=malayalamra}', "");
    Expect(0, 2152, '\P{^Joining_Group=malayalamra}', "");
    Expect(1, 2151, '\p{Joining_Group=:\Amalayalamra\z:}', "");;
    Expect(0, 2152, '\p{Joining_Group=:\Amalayalamra\z:}', "");;
    Expect(1, 2151, '\p{Joining_Group=_ malayalam_ra}', "");
    Expect(0, 2151, '\p{^Joining_Group=_ malayalam_ra}', "");
    Expect(0, 2151, '\P{Joining_Group=_ malayalam_ra}', "");
    Expect(1, 2151, '\P{^Joining_Group=_ malayalam_ra}', "");
    Expect(0, 2152, '\p{Joining_Group=_ malayalam_ra}', "");
    Expect(1, 2152, '\p{^Joining_Group=_ malayalam_ra}', "");
    Expect(1, 2152, '\P{Joining_Group=_ malayalam_ra}', "");
    Expect(0, 2152, '\P{^Joining_Group=_ malayalam_ra}', "");
    Error('\p{Jg=/a/	-Malayalam_RA}');
    Error('\P{Jg=/a/	-Malayalam_RA}');
    Expect(1, 2151, '\p{Jg=:\AMalayalam_Ra\z:}', "");;
    Expect(0, 2152, '\p{Jg=:\AMalayalam_Ra\z:}', "");;
    Expect(1, 2151, '\p{Jg=malayalamra}', "");
    Expect(0, 2151, '\p{^Jg=malayalamra}', "");
    Expect(0, 2151, '\P{Jg=malayalamra}', "");
    Expect(1, 2151, '\P{^Jg=malayalamra}', "");
    Expect(0, 2152, '\p{Jg=malayalamra}', "");
    Expect(1, 2152, '\p{^Jg=malayalamra}', "");
    Expect(1, 2152, '\P{Jg=malayalamra}', "");
    Expect(0, 2152, '\P{^Jg=malayalamra}', "");
    Expect(1, 2151, '\p{Jg=:\Amalayalamra\z:}', "");;
    Expect(0, 2152, '\p{Jg=:\Amalayalamra\z:}', "");;
    Expect(1, 2151, '\p{Jg:		_malayalam_RA}', "");
    Expect(0, 2151, '\p{^Jg:		_malayalam_RA}', "");
    Expect(0, 2151, '\P{Jg:		_malayalam_RA}', "");
    Expect(1, 2151, '\P{^Jg:		_malayalam_RA}', "");
    Expect(0, 2152, '\p{Jg:		_malayalam_RA}', "");
    Expect(1, 2152, '\p{^Jg:		_malayalam_RA}', "");
    Expect(1, 2152, '\P{Jg:		_malayalam_RA}', "");
    Expect(0, 2152, '\P{^Jg:		_malayalam_RA}', "");
    Error('\p{Is_Joining_Group=/a/malayalam_ra}');
    Error('\P{Is_Joining_Group=/a/malayalam_ra}');
    Expect(1, 2151, '\p{Is_Joining_Group=malayalamra}', "");
    Expect(0, 2151, '\p{^Is_Joining_Group=malayalamra}', "");
    Expect(0, 2151, '\P{Is_Joining_Group=malayalamra}', "");
    Expect(1, 2151, '\P{^Is_Joining_Group=malayalamra}', "");
    Expect(0, 2152, '\p{Is_Joining_Group=malayalamra}', "");
    Expect(1, 2152, '\p{^Is_Joining_Group=malayalamra}', "");
    Expect(1, 2152, '\P{Is_Joining_Group=malayalamra}', "");
    Expect(0, 2152, '\P{^Is_Joining_Group=malayalamra}', "");
    Expect(1, 2151, '\p{Is_Joining_Group=-_MALAYALAM_RA}', "");
    Expect(0, 2151, '\p{^Is_Joining_Group=-_MALAYALAM_RA}', "");
    Expect(0, 2151, '\P{Is_Joining_Group=-_MALAYALAM_RA}', "");
    Expect(1, 2151, '\P{^Is_Joining_Group=-_MALAYALAM_RA}', "");
    Expect(0, 2152, '\p{Is_Joining_Group=-_MALAYALAM_RA}', "");
    Expect(1, 2152, '\p{^Is_Joining_Group=-_MALAYALAM_RA}', "");
    Expect(1, 2152, '\P{Is_Joining_Group=-_MALAYALAM_RA}', "");
    Expect(0, 2152, '\P{^Is_Joining_Group=-_MALAYALAM_RA}', "");
    Error('\p{Is_Jg=:=MALAYALAM_ra}');
    Error('\P{Is_Jg=:=MALAYALAM_ra}');
    Expect(1, 2151, '\p{Is_Jg: malayalamra}', "");
    Expect(0, 2151, '\p{^Is_Jg: malayalamra}', "");
    Expect(0, 2151, '\P{Is_Jg: malayalamra}', "");
    Expect(1, 2151, '\P{^Is_Jg: malayalamra}', "");
    Expect(0, 2152, '\p{Is_Jg: malayalamra}', "");
    Expect(1, 2152, '\p{^Is_Jg: malayalamra}', "");
    Expect(1, 2152, '\P{Is_Jg: malayalamra}', "");
    Expect(0, 2152, '\P{^Is_Jg: malayalamra}', "");
    Expect(1, 2151, '\p{Is_Jg=--malayalam_RA}', "");
    Expect(0, 2151, '\p{^Is_Jg=--malayalam_RA}', "");
    Expect(0, 2151, '\P{Is_Jg=--malayalam_RA}', "");
    Expect(1, 2151, '\P{^Is_Jg=--malayalam_RA}', "");
    Expect(0, 2152, '\p{Is_Jg=--malayalam_RA}', "");
    Expect(1, 2152, '\p{^Is_Jg=--malayalam_RA}', "");
    Expect(1, 2152, '\P{Is_Jg=--malayalam_RA}', "");
    Expect(0, 2152, '\P{^Is_Jg=--malayalam_RA}', "");
    Error('\p{Joining_Group: __Malayalam_ssa:=}');
    Error('\P{Joining_Group: __Malayalam_ssa:=}');
    Expect(1, 2154, '\p{Joining_Group=:\AMalayalam_Ssa\z:}', "");;
    Expect(0, 2155, '\p{Joining_Group=:\AMalayalam_Ssa\z:}', "");;
    Expect(1, 2154, '\p{Joining_Group=malayalamssa}', "");
    Expect(0, 2154, '\p{^Joining_Group=malayalamssa}', "");
    Expect(0, 2154, '\P{Joining_Group=malayalamssa}', "");
    Expect(1, 2154, '\P{^Joining_Group=malayalamssa}', "");
    Expect(0, 2155, '\p{Joining_Group=malayalamssa}', "");
    Expect(1, 2155, '\p{^Joining_Group=malayalamssa}', "");
    Expect(1, 2155, '\P{Joining_Group=malayalamssa}', "");
    Expect(0, 2155, '\P{^Joining_Group=malayalamssa}', "");
    Expect(1, 2154, '\p{Joining_Group=:\Amalayalamssa\z:}', "");;
    Expect(0, 2155, '\p{Joining_Group=:\Amalayalamssa\z:}', "");;
    Expect(1, 2154, '\p{Joining_Group:- malayalam_ssa}', "");
    Expect(0, 2154, '\p{^Joining_Group:- malayalam_ssa}', "");
    Expect(0, 2154, '\P{Joining_Group:- malayalam_ssa}', "");
    Expect(1, 2154, '\P{^Joining_Group:- malayalam_ssa}', "");
    Expect(0, 2155, '\p{Joining_Group:- malayalam_ssa}', "");
    Expect(1, 2155, '\p{^Joining_Group:- malayalam_ssa}', "");
    Expect(1, 2155, '\P{Joining_Group:- malayalam_ssa}', "");
    Expect(0, 2155, '\P{^Joining_Group:- malayalam_ssa}', "");
    Error('\p{Jg=_:=Malayalam_Ssa}');
    Error('\P{Jg=_:=Malayalam_Ssa}');
    Expect(1, 2154, '\p{Jg=:\AMalayalam_Ssa\z:}', "");;
    Expect(0, 2155, '\p{Jg=:\AMalayalam_Ssa\z:}', "");;
    Expect(1, 2154, '\p{Jg:malayalamssa}', "");
    Expect(0, 2154, '\p{^Jg:malayalamssa}', "");
    Expect(0, 2154, '\P{Jg:malayalamssa}', "");
    Expect(1, 2154, '\P{^Jg:malayalamssa}', "");
    Expect(0, 2155, '\p{Jg:malayalamssa}', "");
    Expect(1, 2155, '\p{^Jg:malayalamssa}', "");
    Expect(1, 2155, '\P{Jg:malayalamssa}', "");
    Expect(0, 2155, '\P{^Jg:malayalamssa}', "");
    Expect(1, 2154, '\p{Jg=:\Amalayalamssa\z:}', "");;
    Expect(0, 2155, '\p{Jg=:\Amalayalamssa\z:}', "");;
    Expect(1, 2154, '\p{Jg=_ MALAYALAM_Ssa}', "");
    Expect(0, 2154, '\p{^Jg=_ MALAYALAM_Ssa}', "");
    Expect(0, 2154, '\P{Jg=_ MALAYALAM_Ssa}', "");
    Expect(1, 2154, '\P{^Jg=_ MALAYALAM_Ssa}', "");
    Expect(0, 2155, '\p{Jg=_ MALAYALAM_Ssa}', "");
    Expect(1, 2155, '\p{^Jg=_ MALAYALAM_Ssa}', "");
    Expect(1, 2155, '\P{Jg=_ MALAYALAM_Ssa}', "");
    Expect(0, 2155, '\P{^Jg=_ MALAYALAM_Ssa}', "");
    Error('\p{Is_Joining_Group=	 Malayalam_ssa:=}');
    Error('\P{Is_Joining_Group=	 Malayalam_ssa:=}');
    Expect(1, 2154, '\p{Is_Joining_Group=malayalamssa}', "");
    Expect(0, 2154, '\p{^Is_Joining_Group=malayalamssa}', "");
    Expect(0, 2154, '\P{Is_Joining_Group=malayalamssa}', "");
    Expect(1, 2154, '\P{^Is_Joining_Group=malayalamssa}', "");
    Expect(0, 2155, '\p{Is_Joining_Group=malayalamssa}', "");
    Expect(1, 2155, '\p{^Is_Joining_Group=malayalamssa}', "");
    Expect(1, 2155, '\P{Is_Joining_Group=malayalamssa}', "");
    Expect(0, 2155, '\P{^Is_Joining_Group=malayalamssa}', "");
    Expect(1, 2154, '\p{Is_Joining_Group=_MALAYALAM_SSA}', "");
    Expect(0, 2154, '\p{^Is_Joining_Group=_MALAYALAM_SSA}', "");
    Expect(0, 2154, '\P{Is_Joining_Group=_MALAYALAM_SSA}', "");
    Expect(1, 2154, '\P{^Is_Joining_Group=_MALAYALAM_SSA}', "");
    Expect(0, 2155, '\p{Is_Joining_Group=_MALAYALAM_SSA}', "");
    Expect(1, 2155, '\p{^Is_Joining_Group=_MALAYALAM_SSA}', "");
    Expect(1, 2155, '\P{Is_Joining_Group=_MALAYALAM_SSA}', "");
    Expect(0, 2155, '\P{^Is_Joining_Group=_MALAYALAM_SSA}', "");
    Error('\p{Is_Jg=  MALAYALAM_Ssa:=}');
    Error('\P{Is_Jg=  MALAYALAM_Ssa:=}');
    Expect(1, 2154, '\p{Is_Jg=malayalamssa}', "");
    Expect(0, 2154, '\p{^Is_Jg=malayalamssa}', "");
    Expect(0, 2154, '\P{Is_Jg=malayalamssa}', "");
    Expect(1, 2154, '\P{^Is_Jg=malayalamssa}', "");
    Expect(0, 2155, '\p{Is_Jg=malayalamssa}', "");
    Expect(1, 2155, '\p{^Is_Jg=malayalamssa}', "");
    Expect(1, 2155, '\P{Is_Jg=malayalamssa}', "");
    Expect(0, 2155, '\P{^Is_Jg=malayalamssa}', "");
    Expect(1, 2154, '\p{Is_Jg: _Malayalam_Ssa}', "");
    Expect(0, 2154, '\p{^Is_Jg: _Malayalam_Ssa}', "");
    Expect(0, 2154, '\P{Is_Jg: _Malayalam_Ssa}', "");
    Expect(1, 2154, '\P{^Is_Jg: _Malayalam_Ssa}', "");
    Expect(0, 2155, '\p{Is_Jg: _Malayalam_Ssa}', "");
    Expect(1, 2155, '\p{^Is_Jg: _Malayalam_Ssa}', "");
    Expect(1, 2155, '\P{Is_Jg: _Malayalam_Ssa}', "");
    Expect(0, 2155, '\P{^Is_Jg: _Malayalam_Ssa}', "");
    Error('\p{Joining_Group=_-MALAYALAM_Tta:=}');
    Error('\P{Joining_Group=_-MALAYALAM_Tta:=}');
    Expect(1, 2147, '\p{Joining_Group=:\AMalayalam_Tta\z:}', "");;
    Expect(0, 2148, '\p{Joining_Group=:\AMalayalam_Tta\z:}', "");;
    Expect(1, 2147, '\p{Joining_Group=malayalamtta}', "");
    Expect(0, 2147, '\p{^Joining_Group=malayalamtta}', "");
    Expect(0, 2147, '\P{Joining_Group=malayalamtta}', "");
    Expect(1, 2147, '\P{^Joining_Group=malayalamtta}', "");
    Expect(0, 2148, '\p{Joining_Group=malayalamtta}', "");
    Expect(1, 2148, '\p{^Joining_Group=malayalamtta}', "");
    Expect(1, 2148, '\P{Joining_Group=malayalamtta}', "");
    Expect(0, 2148, '\P{^Joining_Group=malayalamtta}', "");
    Expect(1, 2147, '\p{Joining_Group=:\Amalayalamtta\z:}', "");;
    Expect(0, 2148, '\p{Joining_Group=:\Amalayalamtta\z:}', "");;
    Expect(1, 2147, '\p{Joining_Group=	MALAYALAM_Tta}', "");
    Expect(0, 2147, '\p{^Joining_Group=	MALAYALAM_Tta}', "");
    Expect(0, 2147, '\P{Joining_Group=	MALAYALAM_Tta}', "");
    Expect(1, 2147, '\P{^Joining_Group=	MALAYALAM_Tta}', "");
    Expect(0, 2148, '\p{Joining_Group=	MALAYALAM_Tta}', "");
    Expect(1, 2148, '\p{^Joining_Group=	MALAYALAM_Tta}', "");
    Expect(1, 2148, '\P{Joining_Group=	MALAYALAM_Tta}', "");
    Expect(0, 2148, '\P{^Joining_Group=	MALAYALAM_Tta}', "");
    Error('\p{Jg=_ MALAYALAM_tta/a/}');
    Error('\P{Jg=_ MALAYALAM_tta/a/}');
    Expect(1, 2147, '\p{Jg=:\AMalayalam_Tta\z:}', "");;
    Expect(0, 2148, '\p{Jg=:\AMalayalam_Tta\z:}', "");;
    Expect(1, 2147, '\p{Jg=malayalamtta}', "");
    Expect(0, 2147, '\p{^Jg=malayalamtta}', "");
    Expect(0, 2147, '\P{Jg=malayalamtta}', "");
    Expect(1, 2147, '\P{^Jg=malayalamtta}', "");
    Expect(0, 2148, '\p{Jg=malayalamtta}', "");
    Expect(1, 2148, '\p{^Jg=malayalamtta}', "");
    Expect(1, 2148, '\P{Jg=malayalamtta}', "");
    Expect(0, 2148, '\P{^Jg=malayalamtta}', "");
    Expect(1, 2147, '\p{Jg=:\Amalayalamtta\z:}', "");;
    Expect(0, 2148, '\p{Jg=:\Amalayalamtta\z:}', "");;
    Expect(1, 2147, '\p{Jg=-Malayalam_TTA}', "");
    Expect(0, 2147, '\p{^Jg=-Malayalam_TTA}', "");
    Expect(0, 2147, '\P{Jg=-Malayalam_TTA}', "");
    Expect(1, 2147, '\P{^Jg=-Malayalam_TTA}', "");
    Expect(0, 2148, '\p{Jg=-Malayalam_TTA}', "");
    Expect(1, 2148, '\p{^Jg=-Malayalam_TTA}', "");
    Expect(1, 2148, '\P{Jg=-Malayalam_TTA}', "");
    Expect(0, 2148, '\P{^Jg=-Malayalam_TTA}', "");
    Error('\p{Is_Joining_Group=/a/	Malayalam_tta}');
    Error('\P{Is_Joining_Group=/a/	Malayalam_tta}');
    Expect(1, 2147, '\p{Is_Joining_Group: malayalamtta}', "");
    Expect(0, 2147, '\p{^Is_Joining_Group: malayalamtta}', "");
    Expect(0, 2147, '\P{Is_Joining_Group: malayalamtta}', "");
    Expect(1, 2147, '\P{^Is_Joining_Group: malayalamtta}', "");
    Expect(0, 2148, '\p{Is_Joining_Group: malayalamtta}', "");
    Expect(1, 2148, '\p{^Is_Joining_Group: malayalamtta}', "");
    Expect(1, 2148, '\P{Is_Joining_Group: malayalamtta}', "");
    Expect(0, 2148, '\P{^Is_Joining_Group: malayalamtta}', "");
    Expect(1, 2147, '\p{Is_Joining_Group=_malayalam_Tta}', "");
    Expect(0, 2147, '\p{^Is_Joining_Group=_malayalam_Tta}', "");
    Expect(0, 2147, '\P{Is_Joining_Group=_malayalam_Tta}', "");
    Expect(1, 2147, '\P{^Is_Joining_Group=_malayalam_Tta}', "");
    Expect(0, 2148, '\p{Is_Joining_Group=_malayalam_Tta}', "");
    Expect(1, 2148, '\p{^Is_Joining_Group=_malayalam_Tta}', "");
    Expect(1, 2148, '\P{Is_Joining_Group=_malayalam_Tta}', "");
    Expect(0, 2148, '\P{^Is_Joining_Group=_malayalam_Tta}', "");
    Error('\p{Is_Jg:	_	Malayalam_Tta:=}');
    Error('\P{Is_Jg:	_	Malayalam_Tta:=}');
    Expect(1, 2147, '\p{Is_Jg:   malayalamtta}', "");
    Expect(0, 2147, '\p{^Is_Jg:   malayalamtta}', "");
    Expect(0, 2147, '\P{Is_Jg:   malayalamtta}', "");
    Expect(1, 2147, '\P{^Is_Jg:   malayalamtta}', "");
    Expect(0, 2148, '\p{Is_Jg:   malayalamtta}', "");
    Expect(1, 2148, '\p{^Is_Jg:   malayalamtta}', "");
    Expect(1, 2148, '\P{Is_Jg:   malayalamtta}', "");
    Expect(0, 2148, '\P{^Is_Jg:   malayalamtta}', "");
    Expect(1, 2147, '\p{Is_Jg:  	Malayalam_tta}', "");
    Expect(0, 2147, '\p{^Is_Jg:  	Malayalam_tta}', "");
    Expect(0, 2147, '\P{Is_Jg:  	Malayalam_tta}', "");
    Expect(1, 2147, '\P{^Is_Jg:  	Malayalam_tta}', "");
    Expect(0, 2148, '\p{Is_Jg:  	Malayalam_tta}', "");
    Expect(1, 2148, '\p{^Is_Jg:  	Malayalam_tta}', "");
    Expect(1, 2148, '\P{Is_Jg:  	Malayalam_tta}', "");
    Expect(0, 2148, '\P{^Is_Jg:  	Malayalam_tta}', "");
    Error('\p{Joining_Group=	Manichaean_Aleph:=}');
    Error('\P{Joining_Group=	Manichaean_Aleph:=}');
    Expect(1, 68288, '\p{Joining_Group=:\AManichaean_Aleph\z:}', "");;
    Expect(0, 68289, '\p{Joining_Group=:\AManichaean_Aleph\z:}', "");;
    Expect(1, 68288, '\p{Joining_Group=manichaeanaleph}', "");
    Expect(0, 68288, '\p{^Joining_Group=manichaeanaleph}', "");
    Expect(0, 68288, '\P{Joining_Group=manichaeanaleph}', "");
    Expect(1, 68288, '\P{^Joining_Group=manichaeanaleph}', "");
    Expect(0, 68289, '\p{Joining_Group=manichaeanaleph}', "");
    Expect(1, 68289, '\p{^Joining_Group=manichaeanaleph}', "");
    Expect(1, 68289, '\P{Joining_Group=manichaeanaleph}', "");
    Expect(0, 68289, '\P{^Joining_Group=manichaeanaleph}', "");
    Expect(1, 68288, '\p{Joining_Group=:\Amanichaeanaleph\z:}', "");;
    Expect(0, 68289, '\p{Joining_Group=:\Amanichaeanaleph\z:}', "");;
    Expect(1, 68288, '\p{Joining_Group= _manichaean_ALEPH}', "");
    Expect(0, 68288, '\p{^Joining_Group= _manichaean_ALEPH}', "");
    Expect(0, 68288, '\P{Joining_Group= _manichaean_ALEPH}', "");
    Expect(1, 68288, '\P{^Joining_Group= _manichaean_ALEPH}', "");
    Expect(0, 68289, '\p{Joining_Group= _manichaean_ALEPH}', "");
    Expect(1, 68289, '\p{^Joining_Group= _manichaean_ALEPH}', "");
    Expect(1, 68289, '\P{Joining_Group= _manichaean_ALEPH}', "");
    Expect(0, 68289, '\P{^Joining_Group= _manichaean_ALEPH}', "");
    Error('\p{Jg= -manichaean_Aleph/a/}');
    Error('\P{Jg= -manichaean_Aleph/a/}');
    Expect(1, 68288, '\p{Jg=:\AManichaean_Aleph\z:}', "");;
    Expect(0, 68289, '\p{Jg=:\AManichaean_Aleph\z:}', "");;
    Expect(1, 68288, '\p{Jg=manichaeanaleph}', "");
    Expect(0, 68288, '\p{^Jg=manichaeanaleph}', "");
    Expect(0, 68288, '\P{Jg=manichaeanaleph}', "");
    Expect(1, 68288, '\P{^Jg=manichaeanaleph}', "");
    Expect(0, 68289, '\p{Jg=manichaeanaleph}', "");
    Expect(1, 68289, '\p{^Jg=manichaeanaleph}', "");
    Expect(1, 68289, '\P{Jg=manichaeanaleph}', "");
    Expect(0, 68289, '\P{^Jg=manichaeanaleph}', "");
    Expect(1, 68288, '\p{Jg=:\Amanichaeanaleph\z:}', "");;
    Expect(0, 68289, '\p{Jg=:\Amanichaeanaleph\z:}', "");;
    Expect(1, 68288, '\p{Jg=	MANICHAEAN_aleph}', "");
    Expect(0, 68288, '\p{^Jg=	MANICHAEAN_aleph}', "");
    Expect(0, 68288, '\P{Jg=	MANICHAEAN_aleph}', "");
    Expect(1, 68288, '\P{^Jg=	MANICHAEAN_aleph}', "");
    Expect(0, 68289, '\p{Jg=	MANICHAEAN_aleph}', "");
    Expect(1, 68289, '\p{^Jg=	MANICHAEAN_aleph}', "");
    Expect(1, 68289, '\P{Jg=	MANICHAEAN_aleph}', "");
    Expect(0, 68289, '\P{^Jg=	MANICHAEAN_aleph}', "");
    Error('\p{Is_Joining_Group=/a/		Manichaean_Aleph}');
    Error('\P{Is_Joining_Group=/a/		Manichaean_Aleph}');
    Expect(1, 68288, '\p{Is_Joining_Group: manichaeanaleph}', "");
    Expect(0, 68288, '\p{^Is_Joining_Group: manichaeanaleph}', "");
    Expect(0, 68288, '\P{Is_Joining_Group: manichaeanaleph}', "");
    Expect(1, 68288, '\P{^Is_Joining_Group: manichaeanaleph}', "");
    Expect(0, 68289, '\p{Is_Joining_Group: manichaeanaleph}', "");
    Expect(1, 68289, '\p{^Is_Joining_Group: manichaeanaleph}', "");
    Expect(1, 68289, '\P{Is_Joining_Group: manichaeanaleph}', "");
    Expect(0, 68289, '\P{^Is_Joining_Group: manichaeanaleph}', "");
    Expect(1, 68288, '\p{Is_Joining_Group=	Manichaean_Aleph}', "");
    Expect(0, 68288, '\p{^Is_Joining_Group=	Manichaean_Aleph}', "");
    Expect(0, 68288, '\P{Is_Joining_Group=	Manichaean_Aleph}', "");
    Expect(1, 68288, '\P{^Is_Joining_Group=	Manichaean_Aleph}', "");
    Expect(0, 68289, '\p{Is_Joining_Group=	Manichaean_Aleph}', "");
    Expect(1, 68289, '\p{^Is_Joining_Group=	Manichaean_Aleph}', "");
    Expect(1, 68289, '\P{Is_Joining_Group=	Manichaean_Aleph}', "");
    Expect(0, 68289, '\P{^Is_Joining_Group=	Manichaean_Aleph}', "");
    Error('\p{Is_Jg=:=	_MANICHAEAN_aleph}');
    Error('\P{Is_Jg=:=	_MANICHAEAN_aleph}');
    Expect(1, 68288, '\p{Is_Jg=manichaeanaleph}', "");
    Expect(0, 68288, '\p{^Is_Jg=manichaeanaleph}', "");
    Expect(0, 68288, '\P{Is_Jg=manichaeanaleph}', "");
    Expect(1, 68288, '\P{^Is_Jg=manichaeanaleph}', "");
    Expect(0, 68289, '\p{Is_Jg=manichaeanaleph}', "");
    Expect(1, 68289, '\p{^Is_Jg=manichaeanaleph}', "");
    Expect(1, 68289, '\P{Is_Jg=manichaeanaleph}', "");
    Expect(0, 68289, '\P{^Is_Jg=manichaeanaleph}', "");
    Expect(1, 68288, '\p{Is_Jg=	 MANICHAEAN_Aleph}', "");
    Expect(0, 68288, '\p{^Is_Jg=	 MANICHAEAN_Aleph}', "");
    Expect(0, 68288, '\P{Is_Jg=	 MANICHAEAN_Aleph}', "");
    Expect(1, 68288, '\P{^Is_Jg=	 MANICHAEAN_Aleph}', "");
    Expect(0, 68289, '\p{Is_Jg=	 MANICHAEAN_Aleph}', "");
    Expect(1, 68289, '\p{^Is_Jg=	 MANICHAEAN_Aleph}', "");
    Expect(1, 68289, '\P{Is_Jg=	 MANICHAEAN_Aleph}', "");
    Expect(0, 68289, '\P{^Is_Jg=	 MANICHAEAN_Aleph}', "");
    Error('\p{Joining_Group:   	/a/manichaean_AYIN}');
    Error('\P{Joining_Group:   	/a/manichaean_AYIN}');
    Expect(1, 68314, '\p{Joining_Group=:\AManichaean_Ayin\z:}', "");;
    Expect(0, 68315, '\p{Joining_Group=:\AManichaean_Ayin\z:}', "");;
    Expect(1, 68314, '\p{Joining_Group=manichaeanayin}', "");
    Expect(0, 68314, '\p{^Joining_Group=manichaeanayin}', "");
    Expect(0, 68314, '\P{Joining_Group=manichaeanayin}', "");
    Expect(1, 68314, '\P{^Joining_Group=manichaeanayin}', "");
    Expect(0, 68315, '\p{Joining_Group=manichaeanayin}', "");
    Expect(1, 68315, '\p{^Joining_Group=manichaeanayin}', "");
    Expect(1, 68315, '\P{Joining_Group=manichaeanayin}', "");
    Expect(0, 68315, '\P{^Joining_Group=manichaeanayin}', "");
    Expect(1, 68314, '\p{Joining_Group=:\Amanichaeanayin\z:}', "");;
    Expect(0, 68315, '\p{Joining_Group=:\Amanichaeanayin\z:}', "");;
    Expect(1, 68314, '\p{Joining_Group= Manichaean_ayin}', "");
    Expect(0, 68314, '\p{^Joining_Group= Manichaean_ayin}', "");
    Expect(0, 68314, '\P{Joining_Group= Manichaean_ayin}', "");
    Expect(1, 68314, '\P{^Joining_Group= Manichaean_ayin}', "");
    Expect(0, 68315, '\p{Joining_Group= Manichaean_ayin}', "");
    Expect(1, 68315, '\p{^Joining_Group= Manichaean_ayin}', "");
    Expect(1, 68315, '\P{Joining_Group= Manichaean_ayin}', "");
    Expect(0, 68315, '\P{^Joining_Group= Manichaean_ayin}', "");
    Error('\p{Jg:   _-manichaean_Ayin/a/}');
    Error('\P{Jg:   _-manichaean_Ayin/a/}');
    Expect(1, 68314, '\p{Jg=:\AManichaean_Ayin\z:}', "");;
    Expect(0, 68315, '\p{Jg=:\AManichaean_Ayin\z:}', "");;
    Expect(1, 68314, '\p{Jg=manichaeanayin}', "");
    Expect(0, 68314, '\p{^Jg=manichaeanayin}', "");
    Expect(0, 68314, '\P{Jg=manichaeanayin}', "");
    Expect(1, 68314, '\P{^Jg=manichaeanayin}', "");
    Expect(0, 68315, '\p{Jg=manichaeanayin}', "");
    Expect(1, 68315, '\p{^Jg=manichaeanayin}', "");
    Expect(1, 68315, '\P{Jg=manichaeanayin}', "");
    Expect(0, 68315, '\P{^Jg=manichaeanayin}', "");
    Expect(1, 68314, '\p{Jg=:\Amanichaeanayin\z:}', "");;
    Expect(0, 68315, '\p{Jg=:\Amanichaeanayin\z:}', "");;
    Expect(1, 68314, '\p{Jg= manichaean_AYIN}', "");
    Expect(0, 68314, '\p{^Jg= manichaean_AYIN}', "");
    Expect(0, 68314, '\P{Jg= manichaean_AYIN}', "");
    Expect(1, 68314, '\P{^Jg= manichaean_AYIN}', "");
    Expect(0, 68315, '\p{Jg= manichaean_AYIN}', "");
    Expect(1, 68315, '\p{^Jg= manichaean_AYIN}', "");
    Expect(1, 68315, '\P{Jg= manichaean_AYIN}', "");
    Expect(0, 68315, '\P{^Jg= manichaean_AYIN}', "");
    Error('\p{Is_Joining_Group:   /a/MANICHAEAN_AYIN}');
    Error('\P{Is_Joining_Group:   /a/MANICHAEAN_AYIN}');
    Expect(1, 68314, '\p{Is_Joining_Group=manichaeanayin}', "");
    Expect(0, 68314, '\p{^Is_Joining_Group=manichaeanayin}', "");
    Expect(0, 68314, '\P{Is_Joining_Group=manichaeanayin}', "");
    Expect(1, 68314, '\P{^Is_Joining_Group=manichaeanayin}', "");
    Expect(0, 68315, '\p{Is_Joining_Group=manichaeanayin}', "");
    Expect(1, 68315, '\p{^Is_Joining_Group=manichaeanayin}', "");
    Expect(1, 68315, '\P{Is_Joining_Group=manichaeanayin}', "");
    Expect(0, 68315, '\P{^Is_Joining_Group=manichaeanayin}', "");
    Expect(1, 68314, '\p{Is_Joining_Group= Manichaean_Ayin}', "");
    Expect(0, 68314, '\p{^Is_Joining_Group= Manichaean_Ayin}', "");
    Expect(0, 68314, '\P{Is_Joining_Group= Manichaean_Ayin}', "");
    Expect(1, 68314, '\P{^Is_Joining_Group= Manichaean_Ayin}', "");
    Expect(0, 68315, '\p{Is_Joining_Group= Manichaean_Ayin}', "");
    Expect(1, 68315, '\p{^Is_Joining_Group= Manichaean_Ayin}', "");
    Expect(1, 68315, '\P{Is_Joining_Group= Manichaean_Ayin}', "");
    Expect(0, 68315, '\P{^Is_Joining_Group= Manichaean_Ayin}', "");
    Error('\p{Is_Jg=-_Manichaean_ayin:=}');
    Error('\P{Is_Jg=-_Manichaean_ayin:=}');
    Expect(1, 68314, '\p{Is_Jg:   manichaeanayin}', "");
    Expect(0, 68314, '\p{^Is_Jg:   manichaeanayin}', "");
    Expect(0, 68314, '\P{Is_Jg:   manichaeanayin}', "");
    Expect(1, 68314, '\P{^Is_Jg:   manichaeanayin}', "");
    Expect(0, 68315, '\p{Is_Jg:   manichaeanayin}', "");
    Expect(1, 68315, '\p{^Is_Jg:   manichaeanayin}', "");
    Expect(1, 68315, '\P{Is_Jg:   manichaeanayin}', "");
    Expect(0, 68315, '\P{^Is_Jg:   manichaeanayin}', "");
    Expect(1, 68314, '\p{Is_Jg=_ manichaean_Ayin}', "");
    Expect(0, 68314, '\p{^Is_Jg=_ manichaean_Ayin}', "");
    Expect(0, 68314, '\P{Is_Jg=_ manichaean_Ayin}', "");
    Expect(1, 68314, '\P{^Is_Jg=_ manichaean_Ayin}', "");
    Expect(0, 68315, '\p{Is_Jg=_ manichaean_Ayin}', "");
    Expect(1, 68315, '\p{^Is_Jg=_ manichaean_Ayin}', "");
    Expect(1, 68315, '\P{Is_Jg=_ manichaean_Ayin}', "");
    Expect(0, 68315, '\P{^Is_Jg=_ manichaean_Ayin}', "");
    Error('\p{Joining_Group=-	manichaean_Beth:=}');
    Error('\P{Joining_Group=-	manichaean_Beth:=}');
    Expect(1, 68290, '\p{Joining_Group=:\AManichaean_Beth\z:}', "");;
    Expect(0, 68291, '\p{Joining_Group=:\AManichaean_Beth\z:}', "");;
    Expect(1, 68290, '\p{Joining_Group=manichaeanbeth}', "");
    Expect(0, 68290, '\p{^Joining_Group=manichaeanbeth}', "");
    Expect(0, 68290, '\P{Joining_Group=manichaeanbeth}', "");
    Expect(1, 68290, '\P{^Joining_Group=manichaeanbeth}', "");
    Expect(0, 68291, '\p{Joining_Group=manichaeanbeth}', "");
    Expect(1, 68291, '\p{^Joining_Group=manichaeanbeth}', "");
    Expect(1, 68291, '\P{Joining_Group=manichaeanbeth}', "");
    Expect(0, 68291, '\P{^Joining_Group=manichaeanbeth}', "");
    Expect(1, 68290, '\p{Joining_Group=:\Amanichaeanbeth\z:}', "");;
    Expect(0, 68291, '\p{Joining_Group=:\Amanichaeanbeth\z:}', "");;
    Expect(1, 68290, '\p{Joining_Group=--Manichaean_BETH}', "");
    Expect(0, 68290, '\p{^Joining_Group=--Manichaean_BETH}', "");
    Expect(0, 68290, '\P{Joining_Group=--Manichaean_BETH}', "");
    Expect(1, 68290, '\P{^Joining_Group=--Manichaean_BETH}', "");
    Expect(0, 68291, '\p{Joining_Group=--Manichaean_BETH}', "");
    Expect(1, 68291, '\p{^Joining_Group=--Manichaean_BETH}', "");
    Expect(1, 68291, '\P{Joining_Group=--Manichaean_BETH}', "");
    Expect(0, 68291, '\P{^Joining_Group=--Manichaean_BETH}', "");
    Error('\p{Jg=	:=Manichaean_BETH}');
    Error('\P{Jg=	:=Manichaean_BETH}');
    Expect(1, 68290, '\p{Jg=:\AManichaean_Beth\z:}', "");;
    Expect(0, 68291, '\p{Jg=:\AManichaean_Beth\z:}', "");;
    Expect(1, 68290, '\p{Jg=manichaeanbeth}', "");
    Expect(0, 68290, '\p{^Jg=manichaeanbeth}', "");
    Expect(0, 68290, '\P{Jg=manichaeanbeth}', "");
    Expect(1, 68290, '\P{^Jg=manichaeanbeth}', "");
    Expect(0, 68291, '\p{Jg=manichaeanbeth}', "");
    Expect(1, 68291, '\p{^Jg=manichaeanbeth}', "");
    Expect(1, 68291, '\P{Jg=manichaeanbeth}', "");
    Expect(0, 68291, '\P{^Jg=manichaeanbeth}', "");
    Expect(1, 68290, '\p{Jg=:\Amanichaeanbeth\z:}', "");;
    Expect(0, 68291, '\p{Jg=:\Amanichaeanbeth\z:}', "");;
    Expect(1, 68290, '\p{Jg=_MANICHAEAN_BETH}', "");
    Expect(0, 68290, '\p{^Jg=_MANICHAEAN_BETH}', "");
    Expect(0, 68290, '\P{Jg=_MANICHAEAN_BETH}', "");
    Expect(1, 68290, '\P{^Jg=_MANICHAEAN_BETH}', "");
    Expect(0, 68291, '\p{Jg=_MANICHAEAN_BETH}', "");
    Expect(1, 68291, '\p{^Jg=_MANICHAEAN_BETH}', "");
    Expect(1, 68291, '\P{Jg=_MANICHAEAN_BETH}', "");
    Expect(0, 68291, '\P{^Jg=_MANICHAEAN_BETH}', "");
    Error('\p{Is_Joining_Group=/a/Manichaean_beth}');
    Error('\P{Is_Joining_Group=/a/Manichaean_beth}');
    Expect(1, 68290, '\p{Is_Joining_Group=manichaeanbeth}', "");
    Expect(0, 68290, '\p{^Is_Joining_Group=manichaeanbeth}', "");
    Expect(0, 68290, '\P{Is_Joining_Group=manichaeanbeth}', "");
    Expect(1, 68290, '\P{^Is_Joining_Group=manichaeanbeth}', "");
    Expect(0, 68291, '\p{Is_Joining_Group=manichaeanbeth}', "");
    Expect(1, 68291, '\p{^Is_Joining_Group=manichaeanbeth}', "");
    Expect(1, 68291, '\P{Is_Joining_Group=manichaeanbeth}', "");
    Expect(0, 68291, '\P{^Is_Joining_Group=manichaeanbeth}', "");
    Expect(1, 68290, '\p{Is_Joining_Group= Manichaean_BETH}', "");
    Expect(0, 68290, '\p{^Is_Joining_Group= Manichaean_BETH}', "");
    Expect(0, 68290, '\P{Is_Joining_Group= Manichaean_BETH}', "");
    Expect(1, 68290, '\P{^Is_Joining_Group= Manichaean_BETH}', "");
    Expect(0, 68291, '\p{Is_Joining_Group= Manichaean_BETH}', "");
    Expect(1, 68291, '\p{^Is_Joining_Group= Manichaean_BETH}', "");
    Expect(1, 68291, '\P{Is_Joining_Group= Manichaean_BETH}', "");
    Expect(0, 68291, '\P{^Is_Joining_Group= Manichaean_BETH}', "");
    Error('\p{Is_Jg=:=	MANICHAEAN_Beth}');
    Error('\P{Is_Jg=:=	MANICHAEAN_Beth}');
    Expect(1, 68290, '\p{Is_Jg=manichaeanbeth}', "");
    Expect(0, 68290, '\p{^Is_Jg=manichaeanbeth}', "");
    Expect(0, 68290, '\P{Is_Jg=manichaeanbeth}', "");
    Expect(1, 68290, '\P{^Is_Jg=manichaeanbeth}', "");
    Expect(0, 68291, '\p{Is_Jg=manichaeanbeth}', "");
    Expect(1, 68291, '\p{^Is_Jg=manichaeanbeth}', "");
    Expect(1, 68291, '\P{Is_Jg=manichaeanbeth}', "");
    Expect(0, 68291, '\P{^Is_Jg=manichaeanbeth}', "");
    Expect(1, 68290, '\p{Is_Jg=-_manichaean_beth}', "");
    Expect(0, 68290, '\p{^Is_Jg=-_manichaean_beth}', "");
    Expect(0, 68290, '\P{Is_Jg=-_manichaean_beth}', "");
    Expect(1, 68290, '\P{^Is_Jg=-_manichaean_beth}', "");
    Expect(0, 68291, '\p{Is_Jg=-_manichaean_beth}', "");
    Expect(1, 68291, '\p{^Is_Jg=-_manichaean_beth}', "");
    Expect(1, 68291, '\P{Is_Jg=-_manichaean_beth}', "");
    Expect(0, 68291, '\P{^Is_Jg=-_manichaean_beth}', "");
    Error('\p{Joining_Group=_/a/Manichaean_DALETH}');
    Error('\P{Joining_Group=_/a/Manichaean_DALETH}');
    Expect(1, 68293, '\p{Joining_Group=:\AManichaean_Daleth\z:}', "");;
    Expect(0, 68294, '\p{Joining_Group=:\AManichaean_Daleth\z:}', "");;
    Expect(1, 68293, '\p{Joining_Group=manichaeandaleth}', "");
    Expect(0, 68293, '\p{^Joining_Group=manichaeandaleth}', "");
    Expect(0, 68293, '\P{Joining_Group=manichaeandaleth}', "");
    Expect(1, 68293, '\P{^Joining_Group=manichaeandaleth}', "");
    Expect(0, 68294, '\p{Joining_Group=manichaeandaleth}', "");
    Expect(1, 68294, '\p{^Joining_Group=manichaeandaleth}', "");
    Expect(1, 68294, '\P{Joining_Group=manichaeandaleth}', "");
    Expect(0, 68294, '\P{^Joining_Group=manichaeandaleth}', "");
    Expect(1, 68293, '\p{Joining_Group=:\Amanichaeandaleth\z:}', "");;
    Expect(0, 68294, '\p{Joining_Group=:\Amanichaeandaleth\z:}', "");;
    Expect(1, 68293, '\p{Joining_Group=-manichaean_DALETH}', "");
    Expect(0, 68293, '\p{^Joining_Group=-manichaean_DALETH}', "");
    Expect(0, 68293, '\P{Joining_Group=-manichaean_DALETH}', "");
    Expect(1, 68293, '\P{^Joining_Group=-manichaean_DALETH}', "");
    Expect(0, 68294, '\p{Joining_Group=-manichaean_DALETH}', "");
    Expect(1, 68294, '\p{^Joining_Group=-manichaean_DALETH}', "");
    Expect(1, 68294, '\P{Joining_Group=-manichaean_DALETH}', "");
    Expect(0, 68294, '\P{^Joining_Group=-manichaean_DALETH}', "");
    Error('\p{Jg=:=-	manichaean_Daleth}');
    Error('\P{Jg=:=-	manichaean_Daleth}');
    Expect(1, 68293, '\p{Jg=:\AManichaean_Daleth\z:}', "");;
    Expect(0, 68294, '\p{Jg=:\AManichaean_Daleth\z:}', "");;
    Expect(1, 68293, '\p{Jg:manichaeandaleth}', "");
    Expect(0, 68293, '\p{^Jg:manichaeandaleth}', "");
    Expect(0, 68293, '\P{Jg:manichaeandaleth}', "");
    Expect(1, 68293, '\P{^Jg:manichaeandaleth}', "");
    Expect(0, 68294, '\p{Jg:manichaeandaleth}', "");
    Expect(1, 68294, '\p{^Jg:manichaeandaleth}', "");
    Expect(1, 68294, '\P{Jg:manichaeandaleth}', "");
    Expect(0, 68294, '\P{^Jg:manichaeandaleth}', "");
    Expect(1, 68293, '\p{Jg=:\Amanichaeandaleth\z:}', "");;
    Expect(0, 68294, '\p{Jg=:\Amanichaeandaleth\z:}', "");;
    Expect(1, 68293, '\p{Jg=_	MANICHAEAN_daleth}', "");
    Expect(0, 68293, '\p{^Jg=_	MANICHAEAN_daleth}', "");
    Expect(0, 68293, '\P{Jg=_	MANICHAEAN_daleth}', "");
    Expect(1, 68293, '\P{^Jg=_	MANICHAEAN_daleth}', "");
    Expect(0, 68294, '\p{Jg=_	MANICHAEAN_daleth}', "");
    Expect(1, 68294, '\p{^Jg=_	MANICHAEAN_daleth}', "");
    Expect(1, 68294, '\P{Jg=_	MANICHAEAN_daleth}', "");
    Expect(0, 68294, '\P{^Jg=_	MANICHAEAN_daleth}', "");
    Error('\p{Is_Joining_Group=_/a/manichaean_daleth}');
    Error('\P{Is_Joining_Group=_/a/manichaean_daleth}');
    Expect(1, 68293, '\p{Is_Joining_Group=manichaeandaleth}', "");
    Expect(0, 68293, '\p{^Is_Joining_Group=manichaeandaleth}', "");
    Expect(0, 68293, '\P{Is_Joining_Group=manichaeandaleth}', "");
    Expect(1, 68293, '\P{^Is_Joining_Group=manichaeandaleth}', "");
    Expect(0, 68294, '\p{Is_Joining_Group=manichaeandaleth}', "");
    Expect(1, 68294, '\p{^Is_Joining_Group=manichaeandaleth}', "");
    Expect(1, 68294, '\P{Is_Joining_Group=manichaeandaleth}', "");
    Expect(0, 68294, '\P{^Is_Joining_Group=manichaeandaleth}', "");
    Expect(1, 68293, '\p{Is_Joining_Group=MANICHAEAN_DALETH}', "");
    Expect(0, 68293, '\p{^Is_Joining_Group=MANICHAEAN_DALETH}', "");
    Expect(0, 68293, '\P{Is_Joining_Group=MANICHAEAN_DALETH}', "");
    Expect(1, 68293, '\P{^Is_Joining_Group=MANICHAEAN_DALETH}', "");
    Expect(0, 68294, '\p{Is_Joining_Group=MANICHAEAN_DALETH}', "");
    Expect(1, 68294, '\p{^Is_Joining_Group=MANICHAEAN_DALETH}', "");
    Expect(1, 68294, '\P{Is_Joining_Group=MANICHAEAN_DALETH}', "");
    Expect(0, 68294, '\P{^Is_Joining_Group=MANICHAEAN_DALETH}', "");
    Error('\p{Is_Jg: :=manichaean_Daleth}');
    Error('\P{Is_Jg: :=manichaean_Daleth}');
    Expect(1, 68293, '\p{Is_Jg=manichaeandaleth}', "");
    Expect(0, 68293, '\p{^Is_Jg=manichaeandaleth}', "");
    Expect(0, 68293, '\P{Is_Jg=manichaeandaleth}', "");
    Expect(1, 68293, '\P{^Is_Jg=manichaeandaleth}', "");
    Expect(0, 68294, '\p{Is_Jg=manichaeandaleth}', "");
    Expect(1, 68294, '\p{^Is_Jg=manichaeandaleth}', "");
    Expect(1, 68294, '\P{Is_Jg=manichaeandaleth}', "");
    Expect(0, 68294, '\P{^Is_Jg=manichaeandaleth}', "");
    Expect(1, 68293, '\p{Is_Jg= _manichaean_Daleth}', "");
    Expect(0, 68293, '\p{^Is_Jg= _manichaean_Daleth}', "");
    Expect(0, 68293, '\P{Is_Jg= _manichaean_Daleth}', "");
    Expect(1, 68293, '\P{^Is_Jg= _manichaean_Daleth}', "");
    Expect(0, 68294, '\p{Is_Jg= _manichaean_Daleth}', "");
    Expect(1, 68294, '\p{^Is_Jg= _manichaean_Daleth}', "");
    Expect(1, 68294, '\P{Is_Jg= _manichaean_Daleth}', "");
    Expect(0, 68294, '\P{^Is_Jg= _manichaean_Daleth}', "");
    Error('\p{Joining_Group=_-MANICHAEAN_DHAMEDH:=}');
    Error('\P{Joining_Group=_-MANICHAEAN_DHAMEDH:=}');
    Expect(1, 68308, '\p{Joining_Group=:\AManichaean_Dhamedh\z:}', "");;
    Expect(0, 68309, '\p{Joining_Group=:\AManichaean_Dhamedh\z:}', "");;
    Expect(1, 68308, '\p{Joining_Group=manichaeandhamedh}', "");
    Expect(0, 68308, '\p{^Joining_Group=manichaeandhamedh}', "");
    Expect(0, 68308, '\P{Joining_Group=manichaeandhamedh}', "");
    Expect(1, 68308, '\P{^Joining_Group=manichaeandhamedh}', "");
    Expect(0, 68309, '\p{Joining_Group=manichaeandhamedh}', "");
    Expect(1, 68309, '\p{^Joining_Group=manichaeandhamedh}', "");
    Expect(1, 68309, '\P{Joining_Group=manichaeandhamedh}', "");
    Expect(0, 68309, '\P{^Joining_Group=manichaeandhamedh}', "");
    Expect(1, 68308, '\p{Joining_Group=:\Amanichaeandhamedh\z:}', "");;
    Expect(0, 68309, '\p{Joining_Group=:\Amanichaeandhamedh\z:}', "");;
    Expect(1, 68308, '\p{Joining_Group=- Manichaean_dhamedh}', "");
    Expect(0, 68308, '\p{^Joining_Group=- Manichaean_dhamedh}', "");
    Expect(0, 68308, '\P{Joining_Group=- Manichaean_dhamedh}', "");
    Expect(1, 68308, '\P{^Joining_Group=- Manichaean_dhamedh}', "");
    Expect(0, 68309, '\p{Joining_Group=- Manichaean_dhamedh}', "");
    Expect(1, 68309, '\p{^Joining_Group=- Manichaean_dhamedh}', "");
    Expect(1, 68309, '\P{Joining_Group=- Manichaean_dhamedh}', "");
    Expect(0, 68309, '\P{^Joining_Group=- Manichaean_dhamedh}', "");
    Error('\p{Jg= manichaean_Dhamedh:=}');
    Error('\P{Jg= manichaean_Dhamedh:=}');
    Expect(1, 68308, '\p{Jg=:\AManichaean_Dhamedh\z:}', "");;
    Expect(0, 68309, '\p{Jg=:\AManichaean_Dhamedh\z:}', "");;
    Expect(1, 68308, '\p{Jg=manichaeandhamedh}', "");
    Expect(0, 68308, '\p{^Jg=manichaeandhamedh}', "");
    Expect(0, 68308, '\P{Jg=manichaeandhamedh}', "");
    Expect(1, 68308, '\P{^Jg=manichaeandhamedh}', "");
    Expect(0, 68309, '\p{Jg=manichaeandhamedh}', "");
    Expect(1, 68309, '\p{^Jg=manichaeandhamedh}', "");
    Expect(1, 68309, '\P{Jg=manichaeandhamedh}', "");
    Expect(0, 68309, '\P{^Jg=manichaeandhamedh}', "");
    Expect(1, 68308, '\p{Jg=:\Amanichaeandhamedh\z:}', "");;
    Expect(0, 68309, '\p{Jg=:\Amanichaeandhamedh\z:}', "");;
    Expect(1, 68308, '\p{Jg=__Manichaean_Dhamedh}', "");
    Expect(0, 68308, '\p{^Jg=__Manichaean_Dhamedh}', "");
    Expect(0, 68308, '\P{Jg=__Manichaean_Dhamedh}', "");
    Expect(1, 68308, '\P{^Jg=__Manichaean_Dhamedh}', "");
    Expect(0, 68309, '\p{Jg=__Manichaean_Dhamedh}', "");
    Expect(1, 68309, '\p{^Jg=__Manichaean_Dhamedh}', "");
    Expect(1, 68309, '\P{Jg=__Manichaean_Dhamedh}', "");
    Expect(0, 68309, '\P{^Jg=__Manichaean_Dhamedh}', "");
    Error('\p{Is_Joining_Group=--Manichaean_Dhamedh/a/}');
    Error('\P{Is_Joining_Group=--Manichaean_Dhamedh/a/}');
    Expect(1, 68308, '\p{Is_Joining_Group:	manichaeandhamedh}', "");
    Expect(0, 68308, '\p{^Is_Joining_Group:	manichaeandhamedh}', "");
    Expect(0, 68308, '\P{Is_Joining_Group:	manichaeandhamedh}', "");
    Expect(1, 68308, '\P{^Is_Joining_Group:	manichaeandhamedh}', "");
    Expect(0, 68309, '\p{Is_Joining_Group:	manichaeandhamedh}', "");
    Expect(1, 68309, '\p{^Is_Joining_Group:	manichaeandhamedh}', "");
    Expect(1, 68309, '\P{Is_Joining_Group:	manichaeandhamedh}', "");
    Expect(0, 68309, '\P{^Is_Joining_Group:	manichaeandhamedh}', "");
    Expect(1, 68308, '\p{Is_Joining_Group=	manichaean_Dhamedh}', "");
    Expect(0, 68308, '\p{^Is_Joining_Group=	manichaean_Dhamedh}', "");
    Expect(0, 68308, '\P{Is_Joining_Group=	manichaean_Dhamedh}', "");
    Expect(1, 68308, '\P{^Is_Joining_Group=	manichaean_Dhamedh}', "");
    Expect(0, 68309, '\p{Is_Joining_Group=	manichaean_Dhamedh}', "");
    Expect(1, 68309, '\p{^Is_Joining_Group=	manichaean_Dhamedh}', "");
    Expect(1, 68309, '\P{Is_Joining_Group=	manichaean_Dhamedh}', "");
    Expect(0, 68309, '\P{^Is_Joining_Group=	manichaean_Dhamedh}', "");
    Error('\p{Is_Jg=-_manichaean_DHAMEDH/a/}');
    Error('\P{Is_Jg=-_manichaean_DHAMEDH/a/}');
    Expect(1, 68308, '\p{Is_Jg=manichaeandhamedh}', "");
    Expect(0, 68308, '\p{^Is_Jg=manichaeandhamedh}', "");
    Expect(0, 68308, '\P{Is_Jg=manichaeandhamedh}', "");
    Expect(1, 68308, '\P{^Is_Jg=manichaeandhamedh}', "");
    Expect(0, 68309, '\p{Is_Jg=manichaeandhamedh}', "");
    Expect(1, 68309, '\p{^Is_Jg=manichaeandhamedh}', "");
    Expect(1, 68309, '\P{Is_Jg=manichaeandhamedh}', "");
    Expect(0, 68309, '\P{^Is_Jg=manichaeandhamedh}', "");
    Expect(1, 68308, '\p{Is_Jg:   -	manichaean_Dhamedh}', "");
    Expect(0, 68308, '\p{^Is_Jg:   -	manichaean_Dhamedh}', "");
    Expect(0, 68308, '\P{Is_Jg:   -	manichaean_Dhamedh}', "");
    Expect(1, 68308, '\P{^Is_Jg:   -	manichaean_Dhamedh}', "");
    Expect(0, 68309, '\p{Is_Jg:   -	manichaean_Dhamedh}', "");
    Expect(1, 68309, '\p{^Is_Jg:   -	manichaean_Dhamedh}', "");
    Expect(1, 68309, '\P{Is_Jg:   -	manichaean_Dhamedh}', "");
    Expect(0, 68309, '\P{^Is_Jg:   -	manichaean_Dhamedh}', "");
    Error('\p{Joining_Group=- manichaean_Five:=}');
    Error('\P{Joining_Group=- manichaean_Five:=}');
    Expect(1, 68332, '\p{Joining_Group=:\AManichaean_Five\z:}', "");;
    Expect(0, 68333, '\p{Joining_Group=:\AManichaean_Five\z:}', "");;
    Expect(1, 68332, '\p{Joining_Group=manichaeanfive}', "");
    Expect(0, 68332, '\p{^Joining_Group=manichaeanfive}', "");
    Expect(0, 68332, '\P{Joining_Group=manichaeanfive}', "");
    Expect(1, 68332, '\P{^Joining_Group=manichaeanfive}', "");
    Expect(0, 68333, '\p{Joining_Group=manichaeanfive}', "");
    Expect(1, 68333, '\p{^Joining_Group=manichaeanfive}', "");
    Expect(1, 68333, '\P{Joining_Group=manichaeanfive}', "");
    Expect(0, 68333, '\P{^Joining_Group=manichaeanfive}', "");
    Expect(1, 68332, '\p{Joining_Group=:\Amanichaeanfive\z:}', "");;
    Expect(0, 68333, '\p{Joining_Group=:\Amanichaeanfive\z:}', "");;
    Expect(1, 68332, '\p{Joining_Group=_Manichaean_Five}', "");
    Expect(0, 68332, '\p{^Joining_Group=_Manichaean_Five}', "");
    Expect(0, 68332, '\P{Joining_Group=_Manichaean_Five}', "");
    Expect(1, 68332, '\P{^Joining_Group=_Manichaean_Five}', "");
    Expect(0, 68333, '\p{Joining_Group=_Manichaean_Five}', "");
    Expect(1, 68333, '\p{^Joining_Group=_Manichaean_Five}', "");
    Expect(1, 68333, '\P{Joining_Group=_Manichaean_Five}', "");
    Expect(0, 68333, '\P{^Joining_Group=_Manichaean_Five}', "");
    Error('\p{Jg=_ Manichaean_five/a/}');
    Error('\P{Jg=_ Manichaean_five/a/}');
    Expect(1, 68332, '\p{Jg=:\AManichaean_Five\z:}', "");;
    Expect(0, 68333, '\p{Jg=:\AManichaean_Five\z:}', "");;
    Expect(1, 68332, '\p{Jg=manichaeanfive}', "");
    Expect(0, 68332, '\p{^Jg=manichaeanfive}', "");
    Expect(0, 68332, '\P{Jg=manichaeanfive}', "");
    Expect(1, 68332, '\P{^Jg=manichaeanfive}', "");
    Expect(0, 68333, '\p{Jg=manichaeanfive}', "");
    Expect(1, 68333, '\p{^Jg=manichaeanfive}', "");
    Expect(1, 68333, '\P{Jg=manichaeanfive}', "");
    Expect(0, 68333, '\P{^Jg=manichaeanfive}', "");
    Expect(1, 68332, '\p{Jg=:\Amanichaeanfive\z:}', "");;
    Expect(0, 68333, '\p{Jg=:\Amanichaeanfive\z:}', "");;
    Expect(1, 68332, '\p{Jg=-_Manichaean_five}', "");
    Expect(0, 68332, '\p{^Jg=-_Manichaean_five}', "");
    Expect(0, 68332, '\P{Jg=-_Manichaean_five}', "");
    Expect(1, 68332, '\P{^Jg=-_Manichaean_five}', "");
    Expect(0, 68333, '\p{Jg=-_Manichaean_five}', "");
    Expect(1, 68333, '\p{^Jg=-_Manichaean_five}', "");
    Expect(1, 68333, '\P{Jg=-_Manichaean_five}', "");
    Expect(0, 68333, '\P{^Jg=-_Manichaean_five}', "");
    Error('\p{Is_Joining_Group= :=MANICHAEAN_FIVE}');
    Error('\P{Is_Joining_Group= :=MANICHAEAN_FIVE}');
    Expect(1, 68332, '\p{Is_Joining_Group=manichaeanfive}', "");
    Expect(0, 68332, '\p{^Is_Joining_Group=manichaeanfive}', "");
    Expect(0, 68332, '\P{Is_Joining_Group=manichaeanfive}', "");
    Expect(1, 68332, '\P{^Is_Joining_Group=manichaeanfive}', "");
    Expect(0, 68333, '\p{Is_Joining_Group=manichaeanfive}', "");
    Expect(1, 68333, '\p{^Is_Joining_Group=manichaeanfive}', "");
    Expect(1, 68333, '\P{Is_Joining_Group=manichaeanfive}', "");
    Expect(0, 68333, '\P{^Is_Joining_Group=manichaeanfive}', "");
    Expect(1, 68332, '\p{Is_Joining_Group=--Manichaean_Five}', "");
    Expect(0, 68332, '\p{^Is_Joining_Group=--Manichaean_Five}', "");
    Expect(0, 68332, '\P{Is_Joining_Group=--Manichaean_Five}', "");
    Expect(1, 68332, '\P{^Is_Joining_Group=--Manichaean_Five}', "");
    Expect(0, 68333, '\p{Is_Joining_Group=--Manichaean_Five}', "");
    Expect(1, 68333, '\p{^Is_Joining_Group=--Manichaean_Five}', "");
    Expect(1, 68333, '\P{Is_Joining_Group=--Manichaean_Five}', "");
    Expect(0, 68333, '\P{^Is_Joining_Group=--Manichaean_Five}', "");
    Error('\p{Is_Jg=/a/	Manichaean_five}');
    Error('\P{Is_Jg=/a/	Manichaean_five}');
    Expect(1, 68332, '\p{Is_Jg=manichaeanfive}', "");
    Expect(0, 68332, '\p{^Is_Jg=manichaeanfive}', "");
    Expect(0, 68332, '\P{Is_Jg=manichaeanfive}', "");
    Expect(1, 68332, '\P{^Is_Jg=manichaeanfive}', "");
    Expect(0, 68333, '\p{Is_Jg=manichaeanfive}', "");
    Expect(1, 68333, '\p{^Is_Jg=manichaeanfive}', "");
    Expect(1, 68333, '\P{Is_Jg=manichaeanfive}', "");
    Expect(0, 68333, '\P{^Is_Jg=manichaeanfive}', "");
    Expect(1, 68332, '\p{Is_Jg= _manichaean_Five}', "");
    Expect(0, 68332, '\p{^Is_Jg= _manichaean_Five}', "");
    Expect(0, 68332, '\P{Is_Jg= _manichaean_Five}', "");
    Expect(1, 68332, '\P{^Is_Jg= _manichaean_Five}', "");
    Expect(0, 68333, '\p{Is_Jg= _manichaean_Five}', "");
    Expect(1, 68333, '\p{^Is_Jg= _manichaean_Five}', "");
    Expect(1, 68333, '\P{Is_Jg= _manichaean_Five}', "");
    Expect(0, 68333, '\P{^Is_Jg= _manichaean_Five}', "");
    Error('\p{Joining_Group=- Manichaean_gimel/a/}');
    Error('\P{Joining_Group=- Manichaean_gimel/a/}');
    Expect(1, 68292, '\p{Joining_Group=:\AManichaean_Gimel\z:}', "");;
    Expect(0, 68293, '\p{Joining_Group=:\AManichaean_Gimel\z:}', "");;
    Expect(1, 68292, '\p{Joining_Group:   manichaeangimel}', "");
    Expect(0, 68292, '\p{^Joining_Group:   manichaeangimel}', "");
    Expect(0, 68292, '\P{Joining_Group:   manichaeangimel}', "");
    Expect(1, 68292, '\P{^Joining_Group:   manichaeangimel}', "");
    Expect(0, 68293, '\p{Joining_Group:   manichaeangimel}', "");
    Expect(1, 68293, '\p{^Joining_Group:   manichaeangimel}', "");
    Expect(1, 68293, '\P{Joining_Group:   manichaeangimel}', "");
    Expect(0, 68293, '\P{^Joining_Group:   manichaeangimel}', "");
    Expect(1, 68292, '\p{Joining_Group=:\Amanichaeangimel\z:}', "");;
    Expect(0, 68293, '\p{Joining_Group=:\Amanichaeangimel\z:}', "");;
    Expect(1, 68292, '\p{Joining_Group=	MANICHAEAN_Gimel}', "");
    Expect(0, 68292, '\p{^Joining_Group=	MANICHAEAN_Gimel}', "");
    Expect(0, 68292, '\P{Joining_Group=	MANICHAEAN_Gimel}', "");
    Expect(1, 68292, '\P{^Joining_Group=	MANICHAEAN_Gimel}', "");
    Expect(0, 68293, '\p{Joining_Group=	MANICHAEAN_Gimel}', "");
    Expect(1, 68293, '\p{^Joining_Group=	MANICHAEAN_Gimel}', "");
    Expect(1, 68293, '\P{Joining_Group=	MANICHAEAN_Gimel}', "");
    Expect(0, 68293, '\P{^Joining_Group=	MANICHAEAN_Gimel}', "");
    Error('\p{Jg=_/a/Manichaean_GIMEL}');
    Error('\P{Jg=_/a/Manichaean_GIMEL}');
    Expect(1, 68292, '\p{Jg=:\AManichaean_Gimel\z:}', "");;
    Expect(0, 68293, '\p{Jg=:\AManichaean_Gimel\z:}', "");;
    Expect(1, 68292, '\p{Jg=manichaeangimel}', "");
    Expect(0, 68292, '\p{^Jg=manichaeangimel}', "");
    Expect(0, 68292, '\P{Jg=manichaeangimel}', "");
    Expect(1, 68292, '\P{^Jg=manichaeangimel}', "");
    Expect(0, 68293, '\p{Jg=manichaeangimel}', "");
    Expect(1, 68293, '\p{^Jg=manichaeangimel}', "");
    Expect(1, 68293, '\P{Jg=manichaeangimel}', "");
    Expect(0, 68293, '\P{^Jg=manichaeangimel}', "");
    Expect(1, 68292, '\p{Jg=:\Amanichaeangimel\z:}', "");;
    Expect(0, 68293, '\p{Jg=:\Amanichaeangimel\z:}', "");;
    Expect(1, 68292, '\p{Jg=_Manichaean_gimel}', "");
    Expect(0, 68292, '\p{^Jg=_Manichaean_gimel}', "");
    Expect(0, 68292, '\P{Jg=_Manichaean_gimel}', "");
    Expect(1, 68292, '\P{^Jg=_Manichaean_gimel}', "");
    Expect(0, 68293, '\p{Jg=_Manichaean_gimel}', "");
    Expect(1, 68293, '\p{^Jg=_Manichaean_gimel}', "");
    Expect(1, 68293, '\P{Jg=_Manichaean_gimel}', "");
    Expect(0, 68293, '\P{^Jg=_Manichaean_gimel}', "");
    Error('\p{Is_Joining_Group=	_manichaean_GIMEL:=}');
    Error('\P{Is_Joining_Group=	_manichaean_GIMEL:=}');
    Expect(1, 68292, '\p{Is_Joining_Group=manichaeangimel}', "");
    Expect(0, 68292, '\p{^Is_Joining_Group=manichaeangimel}', "");
    Expect(0, 68292, '\P{Is_Joining_Group=manichaeangimel}', "");
    Expect(1, 68292, '\P{^Is_Joining_Group=manichaeangimel}', "");
    Expect(0, 68293, '\p{Is_Joining_Group=manichaeangimel}', "");
    Expect(1, 68293, '\p{^Is_Joining_Group=manichaeangimel}', "");
    Expect(1, 68293, '\P{Is_Joining_Group=manichaeangimel}', "");
    Expect(0, 68293, '\P{^Is_Joining_Group=manichaeangimel}', "");
    Expect(1, 68292, '\p{Is_Joining_Group= -Manichaean_Gimel}', "");
    Expect(0, 68292, '\p{^Is_Joining_Group= -Manichaean_Gimel}', "");
    Expect(0, 68292, '\P{Is_Joining_Group= -Manichaean_Gimel}', "");
    Expect(1, 68292, '\P{^Is_Joining_Group= -Manichaean_Gimel}', "");
    Expect(0, 68293, '\p{Is_Joining_Group= -Manichaean_Gimel}', "");
    Expect(1, 68293, '\p{^Is_Joining_Group= -Manichaean_Gimel}', "");
    Expect(1, 68293, '\P{Is_Joining_Group= -Manichaean_Gimel}', "");
    Expect(0, 68293, '\P{^Is_Joining_Group= -Manichaean_Gimel}', "");
    Error('\p{Is_Jg=		MANICHAEAN_Gimel/a/}');
    Error('\P{Is_Jg=		MANICHAEAN_Gimel/a/}');
    Expect(1, 68292, '\p{Is_Jg=manichaeangimel}', "");
    Expect(0, 68292, '\p{^Is_Jg=manichaeangimel}', "");
    Expect(0, 68292, '\P{Is_Jg=manichaeangimel}', "");
    Expect(1, 68292, '\P{^Is_Jg=manichaeangimel}', "");
    Expect(0, 68293, '\p{Is_Jg=manichaeangimel}', "");
    Expect(1, 68293, '\p{^Is_Jg=manichaeangimel}', "");
    Expect(1, 68293, '\P{Is_Jg=manichaeangimel}', "");
    Expect(0, 68293, '\P{^Is_Jg=manichaeangimel}', "");
    Expect(1, 68292, '\p{Is_Jg=	-Manichaean_GIMEL}', "");
    Expect(0, 68292, '\p{^Is_Jg=	-Manichaean_GIMEL}', "");
    Expect(0, 68292, '\P{Is_Jg=	-Manichaean_GIMEL}', "");
    Expect(1, 68292, '\P{^Is_Jg=	-Manichaean_GIMEL}', "");
    Expect(0, 68293, '\p{Is_Jg=	-Manichaean_GIMEL}', "");
    Expect(1, 68293, '\p{^Is_Jg=	-Manichaean_GIMEL}', "");
    Expect(1, 68293, '\P{Is_Jg=	-Manichaean_GIMEL}', "");
    Expect(0, 68293, '\P{^Is_Jg=	-Manichaean_GIMEL}', "");
    Error('\p{Joining_Group=/a/--MANICHAEAN_Heth}');
    Error('\P{Joining_Group=/a/--MANICHAEAN_Heth}');
    Expect(1, 68301, '\p{Joining_Group=:\AManichaean_Heth\z:}', "");;
    Expect(0, 68302, '\p{Joining_Group=:\AManichaean_Heth\z:}', "");;
    Expect(1, 68301, '\p{Joining_Group=manichaeanheth}', "");
    Expect(0, 68301, '\p{^Joining_Group=manichaeanheth}', "");
    Expect(0, 68301, '\P{Joining_Group=manichaeanheth}', "");
    Expect(1, 68301, '\P{^Joining_Group=manichaeanheth}', "");
    Expect(0, 68302, '\p{Joining_Group=manichaeanheth}', "");
    Expect(1, 68302, '\p{^Joining_Group=manichaeanheth}', "");
    Expect(1, 68302, '\P{Joining_Group=manichaeanheth}', "");
    Expect(0, 68302, '\P{^Joining_Group=manichaeanheth}', "");
    Expect(1, 68301, '\p{Joining_Group=:\Amanichaeanheth\z:}', "");;
    Expect(0, 68302, '\p{Joining_Group=:\Amanichaeanheth\z:}', "");;
    Expect(1, 68301, '\p{Joining_Group=Manichaean_HETH}', "");
    Expect(0, 68301, '\p{^Joining_Group=Manichaean_HETH}', "");
    Expect(0, 68301, '\P{Joining_Group=Manichaean_HETH}', "");
    Expect(1, 68301, '\P{^Joining_Group=Manichaean_HETH}', "");
    Expect(0, 68302, '\p{Joining_Group=Manichaean_HETH}', "");
    Expect(1, 68302, '\p{^Joining_Group=Manichaean_HETH}', "");
    Expect(1, 68302, '\P{Joining_Group=Manichaean_HETH}', "");
    Expect(0, 68302, '\P{^Joining_Group=Manichaean_HETH}', "");
    Error('\p{Jg=_ MANICHAEAN_Heth:=}');
    Error('\P{Jg=_ MANICHAEAN_Heth:=}');
    Expect(1, 68301, '\p{Jg=:\AManichaean_Heth\z:}', "");;
    Expect(0, 68302, '\p{Jg=:\AManichaean_Heth\z:}', "");;
    Expect(1, 68301, '\p{Jg=manichaeanheth}', "");
    Expect(0, 68301, '\p{^Jg=manichaeanheth}', "");
    Expect(0, 68301, '\P{Jg=manichaeanheth}', "");
    Expect(1, 68301, '\P{^Jg=manichaeanheth}', "");
    Expect(0, 68302, '\p{Jg=manichaeanheth}', "");
    Expect(1, 68302, '\p{^Jg=manichaeanheth}', "");
    Expect(1, 68302, '\P{Jg=manichaeanheth}', "");
    Expect(0, 68302, '\P{^Jg=manichaeanheth}', "");
    Expect(1, 68301, '\p{Jg=:\Amanichaeanheth\z:}', "");;
    Expect(0, 68302, '\p{Jg=:\Amanichaeanheth\z:}', "");;
    Expect(1, 68301, '\p{Jg=-_Manichaean_Heth}', "");
    Expect(0, 68301, '\p{^Jg=-_Manichaean_Heth}', "");
    Expect(0, 68301, '\P{Jg=-_Manichaean_Heth}', "");
    Expect(1, 68301, '\P{^Jg=-_Manichaean_Heth}', "");
    Expect(0, 68302, '\p{Jg=-_Manichaean_Heth}', "");
    Expect(1, 68302, '\p{^Jg=-_Manichaean_Heth}', "");
    Expect(1, 68302, '\P{Jg=-_Manichaean_Heth}', "");
    Expect(0, 68302, '\P{^Jg=-_Manichaean_Heth}', "");
    Error('\p{Is_Joining_Group=/a/-_Manichaean_HETH}');
    Error('\P{Is_Joining_Group=/a/-_Manichaean_HETH}');
    Expect(1, 68301, '\p{Is_Joining_Group=manichaeanheth}', "");
    Expect(0, 68301, '\p{^Is_Joining_Group=manichaeanheth}', "");
    Expect(0, 68301, '\P{Is_Joining_Group=manichaeanheth}', "");
    Expect(1, 68301, '\P{^Is_Joining_Group=manichaeanheth}', "");
    Expect(0, 68302, '\p{Is_Joining_Group=manichaeanheth}', "");
    Expect(1, 68302, '\p{^Is_Joining_Group=manichaeanheth}', "");
    Expect(1, 68302, '\P{Is_Joining_Group=manichaeanheth}', "");
    Expect(0, 68302, '\P{^Is_Joining_Group=manichaeanheth}', "");
    Expect(1, 68301, '\p{Is_Joining_Group:   	manichaean_Heth}', "");
    Expect(0, 68301, '\p{^Is_Joining_Group:   	manichaean_Heth}', "");
    Expect(0, 68301, '\P{Is_Joining_Group:   	manichaean_Heth}', "");
    Expect(1, 68301, '\P{^Is_Joining_Group:   	manichaean_Heth}', "");
    Expect(0, 68302, '\p{Is_Joining_Group:   	manichaean_Heth}', "");
    Expect(1, 68302, '\p{^Is_Joining_Group:   	manichaean_Heth}', "");
    Expect(1, 68302, '\P{Is_Joining_Group:   	manichaean_Heth}', "");
    Expect(0, 68302, '\P{^Is_Joining_Group:   	manichaean_Heth}', "");
    Error('\p{Is_Jg=:=	Manichaean_HETH}');
    Error('\P{Is_Jg=:=	Manichaean_HETH}');
    Expect(1, 68301, '\p{Is_Jg=manichaeanheth}', "");
    Expect(0, 68301, '\p{^Is_Jg=manichaeanheth}', "");
    Expect(0, 68301, '\P{Is_Jg=manichaeanheth}', "");
    Expect(1, 68301, '\P{^Is_Jg=manichaeanheth}', "");
    Expect(0, 68302, '\p{Is_Jg=manichaeanheth}', "");
    Expect(1, 68302, '\p{^Is_Jg=manichaeanheth}', "");
    Expect(1, 68302, '\P{Is_Jg=manichaeanheth}', "");
    Expect(0, 68302, '\P{^Is_Jg=manichaeanheth}', "");
    Expect(1, 68301, '\p{Is_Jg=  Manichaean_HETH}', "");
    Expect(0, 68301, '\p{^Is_Jg=  Manichaean_HETH}', "");
    Expect(0, 68301, '\P{Is_Jg=  Manichaean_HETH}', "");
    Expect(1, 68301, '\P{^Is_Jg=  Manichaean_HETH}', "");
    Expect(0, 68302, '\p{Is_Jg=  Manichaean_HETH}', "");
    Expect(1, 68302, '\p{^Is_Jg=  Manichaean_HETH}', "");
    Expect(1, 68302, '\P{Is_Jg=  Manichaean_HETH}', "");
    Expect(0, 68302, '\P{^Is_Jg=  Manichaean_HETH}', "");
    Error('\p{Joining_Group=-	manichaean_hundred:=}');
    Error('\P{Joining_Group=-	manichaean_hundred:=}');
    Expect(1, 68335, '\p{Joining_Group=:\AManichaean_Hundred\z:}', "");;
    Expect(0, 68336, '\p{Joining_Group=:\AManichaean_Hundred\z:}', "");;
    Expect(1, 68335, '\p{Joining_Group=manichaeanhundred}', "");
    Expect(0, 68335, '\p{^Joining_Group=manichaeanhundred}', "");
    Expect(0, 68335, '\P{Joining_Group=manichaeanhundred}', "");
    Expect(1, 68335, '\P{^Joining_Group=manichaeanhundred}', "");
    Expect(0, 68336, '\p{Joining_Group=manichaeanhundred}', "");
    Expect(1, 68336, '\p{^Joining_Group=manichaeanhundred}', "");
    Expect(1, 68336, '\P{Joining_Group=manichaeanhundred}', "");
    Expect(0, 68336, '\P{^Joining_Group=manichaeanhundred}', "");
    Expect(1, 68335, '\p{Joining_Group=:\Amanichaeanhundred\z:}', "");;
    Expect(0, 68336, '\p{Joining_Group=:\Amanichaeanhundred\z:}', "");;
    Expect(1, 68335, '\p{Joining_Group=-MANICHAEAN_Hundred}', "");
    Expect(0, 68335, '\p{^Joining_Group=-MANICHAEAN_Hundred}', "");
    Expect(0, 68335, '\P{Joining_Group=-MANICHAEAN_Hundred}', "");
    Expect(1, 68335, '\P{^Joining_Group=-MANICHAEAN_Hundred}', "");
    Expect(0, 68336, '\p{Joining_Group=-MANICHAEAN_Hundred}', "");
    Expect(1, 68336, '\p{^Joining_Group=-MANICHAEAN_Hundred}', "");
    Expect(1, 68336, '\P{Joining_Group=-MANICHAEAN_Hundred}', "");
    Expect(0, 68336, '\P{^Joining_Group=-MANICHAEAN_Hundred}', "");
    Error('\p{Jg=	manichaean_HUNDRED:=}');
    Error('\P{Jg=	manichaean_HUNDRED:=}');
    Expect(1, 68335, '\p{Jg=:\AManichaean_Hundred\z:}', "");;
    Expect(0, 68336, '\p{Jg=:\AManichaean_Hundred\z:}', "");;
    Expect(1, 68335, '\p{Jg=manichaeanhundred}', "");
    Expect(0, 68335, '\p{^Jg=manichaeanhundred}', "");
    Expect(0, 68335, '\P{Jg=manichaeanhundred}', "");
    Expect(1, 68335, '\P{^Jg=manichaeanhundred}', "");
    Expect(0, 68336, '\p{Jg=manichaeanhundred}', "");
    Expect(1, 68336, '\p{^Jg=manichaeanhundred}', "");
    Expect(1, 68336, '\P{Jg=manichaeanhundred}', "");
    Expect(0, 68336, '\P{^Jg=manichaeanhundred}', "");
    Expect(1, 68335, '\p{Jg=:\Amanichaeanhundred\z:}', "");;
    Expect(0, 68336, '\p{Jg=:\Amanichaeanhundred\z:}', "");;
    Expect(1, 68335, '\p{Jg=  MANICHAEAN_hundred}', "");
    Expect(0, 68335, '\p{^Jg=  MANICHAEAN_hundred}', "");
    Expect(0, 68335, '\P{Jg=  MANICHAEAN_hundred}', "");
    Expect(1, 68335, '\P{^Jg=  MANICHAEAN_hundred}', "");
    Expect(0, 68336, '\p{Jg=  MANICHAEAN_hundred}', "");
    Expect(1, 68336, '\p{^Jg=  MANICHAEAN_hundred}', "");
    Expect(1, 68336, '\P{Jg=  MANICHAEAN_hundred}', "");
    Expect(0, 68336, '\P{^Jg=  MANICHAEAN_hundred}', "");
    Error('\p{Is_Joining_Group=/a/	_Manichaean_HUNDRED}');
    Error('\P{Is_Joining_Group=/a/	_Manichaean_HUNDRED}');
    Expect(1, 68335, '\p{Is_Joining_Group=manichaeanhundred}', "");
    Expect(0, 68335, '\p{^Is_Joining_Group=manichaeanhundred}', "");
    Expect(0, 68335, '\P{Is_Joining_Group=manichaeanhundred}', "");
    Expect(1, 68335, '\P{^Is_Joining_Group=manichaeanhundred}', "");
    Expect(0, 68336, '\p{Is_Joining_Group=manichaeanhundred}', "");
    Expect(1, 68336, '\p{^Is_Joining_Group=manichaeanhundred}', "");
    Expect(1, 68336, '\P{Is_Joining_Group=manichaeanhundred}', "");
    Expect(0, 68336, '\P{^Is_Joining_Group=manichaeanhundred}', "");
    Expect(1, 68335, '\p{Is_Joining_Group=--Manichaean_Hundred}', "");
    Expect(0, 68335, '\p{^Is_Joining_Group=--Manichaean_Hundred}', "");
    Expect(0, 68335, '\P{Is_Joining_Group=--Manichaean_Hundred}', "");
    Expect(1, 68335, '\P{^Is_Joining_Group=--Manichaean_Hundred}', "");
    Expect(0, 68336, '\p{Is_Joining_Group=--Manichaean_Hundred}', "");
    Expect(1, 68336, '\p{^Is_Joining_Group=--Manichaean_Hundred}', "");
    Expect(1, 68336, '\P{Is_Joining_Group=--Manichaean_Hundred}', "");
    Expect(0, 68336, '\P{^Is_Joining_Group=--Manichaean_Hundred}', "");
    Error('\p{Is_Jg=/a/_manichaean_HUNDRED}');
    Error('\P{Is_Jg=/a/_manichaean_HUNDRED}');
    Expect(1, 68335, '\p{Is_Jg=manichaeanhundred}', "");
    Expect(0, 68335, '\p{^Is_Jg=manichaeanhundred}', "");
    Expect(0, 68335, '\P{Is_Jg=manichaeanhundred}', "");
    Expect(1, 68335, '\P{^Is_Jg=manichaeanhundred}', "");
    Expect(0, 68336, '\p{Is_Jg=manichaeanhundred}', "");
    Expect(1, 68336, '\p{^Is_Jg=manichaeanhundred}', "");
    Expect(1, 68336, '\P{Is_Jg=manichaeanhundred}', "");
    Expect(0, 68336, '\P{^Is_Jg=manichaeanhundred}', "");
    Expect(1, 68335, '\p{Is_Jg= manichaean_HUNDRED}', "");
    Expect(0, 68335, '\p{^Is_Jg= manichaean_HUNDRED}', "");
    Expect(0, 68335, '\P{Is_Jg= manichaean_HUNDRED}', "");
    Expect(1, 68335, '\P{^Is_Jg= manichaean_HUNDRED}', "");
    Expect(0, 68336, '\p{Is_Jg= manichaean_HUNDRED}', "");
    Expect(1, 68336, '\p{^Is_Jg= manichaean_HUNDRED}', "");
    Expect(1, 68336, '\P{Is_Jg= manichaean_HUNDRED}', "");
    Expect(0, 68336, '\P{^Is_Jg= manichaean_HUNDRED}', "");
    Error('\p{Joining_Group=manichaean_Kaph:=}');
    Error('\P{Joining_Group=manichaean_Kaph:=}');
    Expect(1, 68306, '\p{Joining_Group=:\AManichaean_Kaph\z:}', "");;
    Expect(0, 68307, '\p{Joining_Group=:\AManichaean_Kaph\z:}', "");;
    Expect(1, 68306, '\p{Joining_Group: manichaeankaph}', "");
    Expect(0, 68306, '\p{^Joining_Group: manichaeankaph}', "");
    Expect(0, 68306, '\P{Joining_Group: manichaeankaph}', "");
    Expect(1, 68306, '\P{^Joining_Group: manichaeankaph}', "");
    Expect(0, 68307, '\p{Joining_Group: manichaeankaph}', "");
    Expect(1, 68307, '\p{^Joining_Group: manichaeankaph}', "");
    Expect(1, 68307, '\P{Joining_Group: manichaeankaph}', "");
    Expect(0, 68307, '\P{^Joining_Group: manichaeankaph}', "");
    Expect(1, 68306, '\p{Joining_Group=:\Amanichaeankaph\z:}', "");;
    Expect(0, 68307, '\p{Joining_Group=:\Amanichaeankaph\z:}', "");;
    Expect(1, 68306, '\p{Joining_Group=- Manichaean_KAPH}', "");
    Expect(0, 68306, '\p{^Joining_Group=- Manichaean_KAPH}', "");
    Expect(0, 68306, '\P{Joining_Group=- Manichaean_KAPH}', "");
    Expect(1, 68306, '\P{^Joining_Group=- Manichaean_KAPH}', "");
    Expect(0, 68307, '\p{Joining_Group=- Manichaean_KAPH}', "");
    Expect(1, 68307, '\p{^Joining_Group=- Manichaean_KAPH}', "");
    Expect(1, 68307, '\P{Joining_Group=- Manichaean_KAPH}', "");
    Expect(0, 68307, '\P{^Joining_Group=- Manichaean_KAPH}', "");
    Error('\p{Jg=:=- manichaean_Kaph}');
    Error('\P{Jg=:=- manichaean_Kaph}');
    Expect(1, 68306, '\p{Jg=:\AManichaean_Kaph\z:}', "");;
    Expect(0, 68307, '\p{Jg=:\AManichaean_Kaph\z:}', "");;
    Expect(1, 68306, '\p{Jg=manichaeankaph}', "");
    Expect(0, 68306, '\p{^Jg=manichaeankaph}', "");
    Expect(0, 68306, '\P{Jg=manichaeankaph}', "");
    Expect(1, 68306, '\P{^Jg=manichaeankaph}', "");
    Expect(0, 68307, '\p{Jg=manichaeankaph}', "");
    Expect(1, 68307, '\p{^Jg=manichaeankaph}', "");
    Expect(1, 68307, '\P{Jg=manichaeankaph}', "");
    Expect(0, 68307, '\P{^Jg=manichaeankaph}', "");
    Expect(1, 68306, '\p{Jg=:\Amanichaeankaph\z:}', "");;
    Expect(0, 68307, '\p{Jg=:\Amanichaeankaph\z:}', "");;
    Expect(1, 68306, '\p{Jg: __Manichaean_kaph}', "");
    Expect(0, 68306, '\p{^Jg: __Manichaean_kaph}', "");
    Expect(0, 68306, '\P{Jg: __Manichaean_kaph}', "");
    Expect(1, 68306, '\P{^Jg: __Manichaean_kaph}', "");
    Expect(0, 68307, '\p{Jg: __Manichaean_kaph}', "");
    Expect(1, 68307, '\p{^Jg: __Manichaean_kaph}', "");
    Expect(1, 68307, '\P{Jg: __Manichaean_kaph}', "");
    Expect(0, 68307, '\P{^Jg: __Manichaean_kaph}', "");
    Error('\p{Is_Joining_Group=-_Manichaean_kaph:=}');
    Error('\P{Is_Joining_Group=-_Manichaean_kaph:=}');
    Expect(1, 68306, '\p{Is_Joining_Group=manichaeankaph}', "");
    Expect(0, 68306, '\p{^Is_Joining_Group=manichaeankaph}', "");
    Expect(0, 68306, '\P{Is_Joining_Group=manichaeankaph}', "");
    Expect(1, 68306, '\P{^Is_Joining_Group=manichaeankaph}', "");
    Expect(0, 68307, '\p{Is_Joining_Group=manichaeankaph}', "");
    Expect(1, 68307, '\p{^Is_Joining_Group=manichaeankaph}', "");
    Expect(1, 68307, '\P{Is_Joining_Group=manichaeankaph}', "");
    Expect(0, 68307, '\P{^Is_Joining_Group=manichaeankaph}', "");
    Expect(1, 68306, '\p{Is_Joining_Group=-	manichaean_kaph}', "");
    Expect(0, 68306, '\p{^Is_Joining_Group=-	manichaean_kaph}', "");
    Expect(0, 68306, '\P{Is_Joining_Group=-	manichaean_kaph}', "");
    Expect(1, 68306, '\P{^Is_Joining_Group=-	manichaean_kaph}', "");
    Expect(0, 68307, '\p{Is_Joining_Group=-	manichaean_kaph}', "");
    Expect(1, 68307, '\p{^Is_Joining_Group=-	manichaean_kaph}', "");
    Expect(1, 68307, '\P{Is_Joining_Group=-	manichaean_kaph}', "");
    Expect(0, 68307, '\P{^Is_Joining_Group=-	manichaean_kaph}', "");
    Error('\p{Is_Jg=_	manichaean_kaph:=}');
    Error('\P{Is_Jg=_	manichaean_kaph:=}');
    Expect(1, 68306, '\p{Is_Jg=manichaeankaph}', "");
    Expect(0, 68306, '\p{^Is_Jg=manichaeankaph}', "");
    Expect(0, 68306, '\P{Is_Jg=manichaeankaph}', "");
    Expect(1, 68306, '\P{^Is_Jg=manichaeankaph}', "");
    Expect(0, 68307, '\p{Is_Jg=manichaeankaph}', "");
    Expect(1, 68307, '\p{^Is_Jg=manichaeankaph}', "");
    Expect(1, 68307, '\P{Is_Jg=manichaeankaph}', "");
    Expect(0, 68307, '\P{^Is_Jg=manichaeankaph}', "");
    Expect(1, 68306, '\p{Is_Jg= -Manichaean_KAPH}', "");
    Expect(0, 68306, '\p{^Is_Jg= -Manichaean_KAPH}', "");
    Expect(0, 68306, '\P{Is_Jg= -Manichaean_KAPH}', "");
    Expect(1, 68306, '\P{^Is_Jg= -Manichaean_KAPH}', "");
    Expect(0, 68307, '\p{Is_Jg= -Manichaean_KAPH}', "");
    Expect(1, 68307, '\p{^Is_Jg= -Manichaean_KAPH}', "");
    Expect(1, 68307, '\P{Is_Jg= -Manichaean_KAPH}', "");
    Expect(0, 68307, '\P{^Is_Jg= -Manichaean_KAPH}', "");
    Error('\p{Joining_Group= :=manichaean_lamedh}');
    Error('\P{Joining_Group= :=manichaean_lamedh}');
    Expect(1, 68307, '\p{Joining_Group=:\AManichaean_Lamedh\z:}', "");;
    Expect(0, 68308, '\p{Joining_Group=:\AManichaean_Lamedh\z:}', "");;
    Expect(1, 68307, '\p{Joining_Group=manichaeanlamedh}', "");
    Expect(0, 68307, '\p{^Joining_Group=manichaeanlamedh}', "");
    Expect(0, 68307, '\P{Joining_Group=manichaeanlamedh}', "");
    Expect(1, 68307, '\P{^Joining_Group=manichaeanlamedh}', "");
    Expect(0, 68308, '\p{Joining_Group=manichaeanlamedh}', "");
    Expect(1, 68308, '\p{^Joining_Group=manichaeanlamedh}', "");
    Expect(1, 68308, '\P{Joining_Group=manichaeanlamedh}', "");
    Expect(0, 68308, '\P{^Joining_Group=manichaeanlamedh}', "");
    Expect(1, 68307, '\p{Joining_Group=:\Amanichaeanlamedh\z:}', "");;
    Expect(0, 68308, '\p{Joining_Group=:\Amanichaeanlamedh\z:}', "");;
    Expect(1, 68307, '\p{Joining_Group=_MANICHAEAN_Lamedh}', "");
    Expect(0, 68307, '\p{^Joining_Group=_MANICHAEAN_Lamedh}', "");
    Expect(0, 68307, '\P{Joining_Group=_MANICHAEAN_Lamedh}', "");
    Expect(1, 68307, '\P{^Joining_Group=_MANICHAEAN_Lamedh}', "");
    Expect(0, 68308, '\p{Joining_Group=_MANICHAEAN_Lamedh}', "");
    Expect(1, 68308, '\p{^Joining_Group=_MANICHAEAN_Lamedh}', "");
    Expect(1, 68308, '\P{Joining_Group=_MANICHAEAN_Lamedh}', "");
    Expect(0, 68308, '\P{^Joining_Group=_MANICHAEAN_Lamedh}', "");
    Error('\p{Jg:	/a/ manichaean_Lamedh}');
    Error('\P{Jg:	/a/ manichaean_Lamedh}');
    Expect(1, 68307, '\p{Jg=:\AManichaean_Lamedh\z:}', "");;
    Expect(0, 68308, '\p{Jg=:\AManichaean_Lamedh\z:}', "");;
    Expect(1, 68307, '\p{Jg=manichaeanlamedh}', "");
    Expect(0, 68307, '\p{^Jg=manichaeanlamedh}', "");
    Expect(0, 68307, '\P{Jg=manichaeanlamedh}', "");
    Expect(1, 68307, '\P{^Jg=manichaeanlamedh}', "");
    Expect(0, 68308, '\p{Jg=manichaeanlamedh}', "");
    Expect(1, 68308, '\p{^Jg=manichaeanlamedh}', "");
    Expect(1, 68308, '\P{Jg=manichaeanlamedh}', "");
    Expect(0, 68308, '\P{^Jg=manichaeanlamedh}', "");
    Expect(1, 68307, '\p{Jg=:\Amanichaeanlamedh\z:}', "");;
    Expect(0, 68308, '\p{Jg=:\Amanichaeanlamedh\z:}', "");;
    Expect(1, 68307, '\p{Jg:		manichaean_lamedh}', "");
    Expect(0, 68307, '\p{^Jg:		manichaean_lamedh}', "");
    Expect(0, 68307, '\P{Jg:		manichaean_lamedh}', "");
    Expect(1, 68307, '\P{^Jg:		manichaean_lamedh}', "");
    Expect(0, 68308, '\p{Jg:		manichaean_lamedh}', "");
    Expect(1, 68308, '\p{^Jg:		manichaean_lamedh}', "");
    Expect(1, 68308, '\P{Jg:		manichaean_lamedh}', "");
    Expect(0, 68308, '\P{^Jg:		manichaean_lamedh}', "");
    Error('\p{Is_Joining_Group=	Manichaean_Lamedh:=}');
    Error('\P{Is_Joining_Group=	Manichaean_Lamedh:=}');
    Expect(1, 68307, '\p{Is_Joining_Group=manichaeanlamedh}', "");
    Expect(0, 68307, '\p{^Is_Joining_Group=manichaeanlamedh}', "");
    Expect(0, 68307, '\P{Is_Joining_Group=manichaeanlamedh}', "");
    Expect(1, 68307, '\P{^Is_Joining_Group=manichaeanlamedh}', "");
    Expect(0, 68308, '\p{Is_Joining_Group=manichaeanlamedh}', "");
    Expect(1, 68308, '\p{^Is_Joining_Group=manichaeanlamedh}', "");
    Expect(1, 68308, '\P{Is_Joining_Group=manichaeanlamedh}', "");
    Expect(0, 68308, '\P{^Is_Joining_Group=manichaeanlamedh}', "");
    Expect(1, 68307, '\p{Is_Joining_Group:	--Manichaean_lamedh}', "");
    Expect(0, 68307, '\p{^Is_Joining_Group:	--Manichaean_lamedh}', "");
    Expect(0, 68307, '\P{Is_Joining_Group:	--Manichaean_lamedh}', "");
    Expect(1, 68307, '\P{^Is_Joining_Group:	--Manichaean_lamedh}', "");
    Expect(0, 68308, '\p{Is_Joining_Group:	--Manichaean_lamedh}', "");
    Expect(1, 68308, '\p{^Is_Joining_Group:	--Manichaean_lamedh}', "");
    Expect(1, 68308, '\P{Is_Joining_Group:	--Manichaean_lamedh}', "");
    Expect(0, 68308, '\P{^Is_Joining_Group:	--Manichaean_lamedh}', "");
    Error('\p{Is_Jg=/a/ manichaean_lamedh}');
    Error('\P{Is_Jg=/a/ manichaean_lamedh}');
    Expect(1, 68307, '\p{Is_Jg=manichaeanlamedh}', "");
    Expect(0, 68307, '\p{^Is_Jg=manichaeanlamedh}', "");
    Expect(0, 68307, '\P{Is_Jg=manichaeanlamedh}', "");
    Expect(1, 68307, '\P{^Is_Jg=manichaeanlamedh}', "");
    Expect(0, 68308, '\p{Is_Jg=manichaeanlamedh}', "");
    Expect(1, 68308, '\p{^Is_Jg=manichaeanlamedh}', "");
    Expect(1, 68308, '\P{Is_Jg=manichaeanlamedh}', "");
    Expect(0, 68308, '\P{^Is_Jg=manichaeanlamedh}', "");
    Expect(1, 68307, '\p{Is_Jg=_Manichaean_Lamedh}', "");
    Expect(0, 68307, '\p{^Is_Jg=_Manichaean_Lamedh}', "");
    Expect(0, 68307, '\P{Is_Jg=_Manichaean_Lamedh}', "");
    Expect(1, 68307, '\P{^Is_Jg=_Manichaean_Lamedh}', "");
    Expect(0, 68308, '\p{Is_Jg=_Manichaean_Lamedh}', "");
    Expect(1, 68308, '\p{^Is_Jg=_Manichaean_Lamedh}', "");
    Expect(1, 68308, '\P{Is_Jg=_Manichaean_Lamedh}', "");
    Expect(0, 68308, '\P{^Is_Jg=_Manichaean_Lamedh}', "");
    Error('\p{Joining_Group=:=		MANICHAEAN_Mem}');
    Error('\P{Joining_Group=:=		MANICHAEAN_Mem}');
    Expect(1, 68310, '\p{Joining_Group=:\AManichaean_Mem\z:}', "");;
    Expect(0, 68311, '\p{Joining_Group=:\AManichaean_Mem\z:}', "");;
    Expect(1, 68310, '\p{Joining_Group=manichaeanmem}', "");
    Expect(0, 68310, '\p{^Joining_Group=manichaeanmem}', "");
    Expect(0, 68310, '\P{Joining_Group=manichaeanmem}', "");
    Expect(1, 68310, '\P{^Joining_Group=manichaeanmem}', "");
    Expect(0, 68311, '\p{Joining_Group=manichaeanmem}', "");
    Expect(1, 68311, '\p{^Joining_Group=manichaeanmem}', "");
    Expect(1, 68311, '\P{Joining_Group=manichaeanmem}', "");
    Expect(0, 68311, '\P{^Joining_Group=manichaeanmem}', "");
    Expect(1, 68310, '\p{Joining_Group=:\Amanichaeanmem\z:}', "");;
    Expect(0, 68311, '\p{Joining_Group=:\Amanichaeanmem\z:}', "");;
    Expect(1, 68310, '\p{Joining_Group= MANICHAEAN_mem}', "");
    Expect(0, 68310, '\p{^Joining_Group= MANICHAEAN_mem}', "");
    Expect(0, 68310, '\P{Joining_Group= MANICHAEAN_mem}', "");
    Expect(1, 68310, '\P{^Joining_Group= MANICHAEAN_mem}', "");
    Expect(0, 68311, '\p{Joining_Group= MANICHAEAN_mem}', "");
    Expect(1, 68311, '\p{^Joining_Group= MANICHAEAN_mem}', "");
    Expect(1, 68311, '\P{Joining_Group= MANICHAEAN_mem}', "");
    Expect(0, 68311, '\P{^Joining_Group= MANICHAEAN_mem}', "");
    Error('\p{Jg: :=_	Manichaean_Mem}');
    Error('\P{Jg: :=_	Manichaean_Mem}');
    Expect(1, 68310, '\p{Jg=:\AManichaean_Mem\z:}', "");;
    Expect(0, 68311, '\p{Jg=:\AManichaean_Mem\z:}', "");;
    Expect(1, 68310, '\p{Jg=manichaeanmem}', "");
    Expect(0, 68310, '\p{^Jg=manichaeanmem}', "");
    Expect(0, 68310, '\P{Jg=manichaeanmem}', "");
    Expect(1, 68310, '\P{^Jg=manichaeanmem}', "");
    Expect(0, 68311, '\p{Jg=manichaeanmem}', "");
    Expect(1, 68311, '\p{^Jg=manichaeanmem}', "");
    Expect(1, 68311, '\P{Jg=manichaeanmem}', "");
    Expect(0, 68311, '\P{^Jg=manichaeanmem}', "");
    Expect(1, 68310, '\p{Jg=:\Amanichaeanmem\z:}', "");;
    Expect(0, 68311, '\p{Jg=:\Amanichaeanmem\z:}', "");;
    Expect(1, 68310, '\p{Jg=	-manichaean_mem}', "");
    Expect(0, 68310, '\p{^Jg=	-manichaean_mem}', "");
    Expect(0, 68310, '\P{Jg=	-manichaean_mem}', "");
    Expect(1, 68310, '\P{^Jg=	-manichaean_mem}', "");
    Expect(0, 68311, '\p{Jg=	-manichaean_mem}', "");
    Expect(1, 68311, '\p{^Jg=	-manichaean_mem}', "");
    Expect(1, 68311, '\P{Jg=	-manichaean_mem}', "");
    Expect(0, 68311, '\P{^Jg=	-manichaean_mem}', "");
    Error('\p{Is_Joining_Group=:=	Manichaean_Mem}');
    Error('\P{Is_Joining_Group=:=	Manichaean_Mem}');
    Expect(1, 68310, '\p{Is_Joining_Group=manichaeanmem}', "");
    Expect(0, 68310, '\p{^Is_Joining_Group=manichaeanmem}', "");
    Expect(0, 68310, '\P{Is_Joining_Group=manichaeanmem}', "");
    Expect(1, 68310, '\P{^Is_Joining_Group=manichaeanmem}', "");
    Expect(0, 68311, '\p{Is_Joining_Group=manichaeanmem}', "");
    Expect(1, 68311, '\p{^Is_Joining_Group=manichaeanmem}', "");
    Expect(1, 68311, '\P{Is_Joining_Group=manichaeanmem}', "");
    Expect(0, 68311, '\P{^Is_Joining_Group=manichaeanmem}', "");
    Expect(1, 68310, '\p{Is_Joining_Group=manichaean_mem}', "");
    Expect(0, 68310, '\p{^Is_Joining_Group=manichaean_mem}', "");
    Expect(0, 68310, '\P{Is_Joining_Group=manichaean_mem}', "");
    Expect(1, 68310, '\P{^Is_Joining_Group=manichaean_mem}', "");
    Expect(0, 68311, '\p{Is_Joining_Group=manichaean_mem}', "");
    Expect(1, 68311, '\p{^Is_Joining_Group=manichaean_mem}', "");
    Expect(1, 68311, '\P{Is_Joining_Group=manichaean_mem}', "");
    Expect(0, 68311, '\P{^Is_Joining_Group=manichaean_mem}', "");
    Error('\p{Is_Jg=/a/MANICHAEAN_mem}');
    Error('\P{Is_Jg=/a/MANICHAEAN_mem}');
    Expect(1, 68310, '\p{Is_Jg:manichaeanmem}', "");
    Expect(0, 68310, '\p{^Is_Jg:manichaeanmem}', "");
    Expect(0, 68310, '\P{Is_Jg:manichaeanmem}', "");
    Expect(1, 68310, '\P{^Is_Jg:manichaeanmem}', "");
    Expect(0, 68311, '\p{Is_Jg:manichaeanmem}', "");
    Expect(1, 68311, '\p{^Is_Jg:manichaeanmem}', "");
    Expect(1, 68311, '\P{Is_Jg:manichaeanmem}', "");
    Expect(0, 68311, '\P{^Is_Jg:manichaeanmem}', "");
    Expect(1, 68310, '\p{Is_Jg=_ manichaean_mem}', "");
    Expect(0, 68310, '\p{^Is_Jg=_ manichaean_mem}', "");
    Expect(0, 68310, '\P{Is_Jg=_ manichaean_mem}', "");
    Expect(1, 68310, '\P{^Is_Jg=_ manichaean_mem}', "");
    Expect(0, 68311, '\p{Is_Jg=_ manichaean_mem}', "");
    Expect(1, 68311, '\p{^Is_Jg=_ manichaean_mem}', "");
    Expect(1, 68311, '\P{Is_Jg=_ manichaean_mem}', "");
    Expect(0, 68311, '\P{^Is_Jg=_ manichaean_mem}', "");
    Error('\p{Joining_Group=	:=Manichaean_nun}');
    Error('\P{Joining_Group=	:=Manichaean_nun}');
    Expect(1, 68311, '\p{Joining_Group=:\AManichaean_Nun\z:}', "");;
    Expect(0, 68312, '\p{Joining_Group=:\AManichaean_Nun\z:}', "");;
    Expect(1, 68311, '\p{Joining_Group=manichaeannun}', "");
    Expect(0, 68311, '\p{^Joining_Group=manichaeannun}', "");
    Expect(0, 68311, '\P{Joining_Group=manichaeannun}', "");
    Expect(1, 68311, '\P{^Joining_Group=manichaeannun}', "");
    Expect(0, 68312, '\p{Joining_Group=manichaeannun}', "");
    Expect(1, 68312, '\p{^Joining_Group=manichaeannun}', "");
    Expect(1, 68312, '\P{Joining_Group=manichaeannun}', "");
    Expect(0, 68312, '\P{^Joining_Group=manichaeannun}', "");
    Expect(1, 68311, '\p{Joining_Group=:\Amanichaeannun\z:}', "");;
    Expect(0, 68312, '\p{Joining_Group=:\Amanichaeannun\z:}', "");;
    Expect(1, 68311, '\p{Joining_Group= 	Manichaean_nun}', "");
    Expect(0, 68311, '\p{^Joining_Group= 	Manichaean_nun}', "");
    Expect(0, 68311, '\P{Joining_Group= 	Manichaean_nun}', "");
    Expect(1, 68311, '\P{^Joining_Group= 	Manichaean_nun}', "");
    Expect(0, 68312, '\p{Joining_Group= 	Manichaean_nun}', "");
    Expect(1, 68312, '\p{^Joining_Group= 	Manichaean_nun}', "");
    Expect(1, 68312, '\P{Joining_Group= 	Manichaean_nun}', "");
    Expect(0, 68312, '\P{^Joining_Group= 	Manichaean_nun}', "");
    Error('\p{Jg=	 manichaean_Nun/a/}');
    Error('\P{Jg=	 manichaean_Nun/a/}');
    Expect(1, 68311, '\p{Jg=:\AManichaean_Nun\z:}', "");;
    Expect(0, 68312, '\p{Jg=:\AManichaean_Nun\z:}', "");;
    Expect(1, 68311, '\p{Jg=manichaeannun}', "");
    Expect(0, 68311, '\p{^Jg=manichaeannun}', "");
    Expect(0, 68311, '\P{Jg=manichaeannun}', "");
    Expect(1, 68311, '\P{^Jg=manichaeannun}', "");
    Expect(0, 68312, '\p{Jg=manichaeannun}', "");
    Expect(1, 68312, '\p{^Jg=manichaeannun}', "");
    Expect(1, 68312, '\P{Jg=manichaeannun}', "");
    Expect(0, 68312, '\P{^Jg=manichaeannun}', "");
    Expect(1, 68311, '\p{Jg=:\Amanichaeannun\z:}', "");;
    Expect(0, 68312, '\p{Jg=:\Amanichaeannun\z:}', "");;
    Expect(1, 68311, '\p{Jg=	_manichaean_NUN}', "");
    Expect(0, 68311, '\p{^Jg=	_manichaean_NUN}', "");
    Expect(0, 68311, '\P{Jg=	_manichaean_NUN}', "");
    Expect(1, 68311, '\P{^Jg=	_manichaean_NUN}', "");
    Expect(0, 68312, '\p{Jg=	_manichaean_NUN}', "");
    Expect(1, 68312, '\p{^Jg=	_manichaean_NUN}', "");
    Expect(1, 68312, '\P{Jg=	_manichaean_NUN}', "");
    Expect(0, 68312, '\P{^Jg=	_manichaean_NUN}', "");
    Error('\p{Is_Joining_Group=/a/ _MANICHAEAN_nun}');
    Error('\P{Is_Joining_Group=/a/ _MANICHAEAN_nun}');
    Expect(1, 68311, '\p{Is_Joining_Group=manichaeannun}', "");
    Expect(0, 68311, '\p{^Is_Joining_Group=manichaeannun}', "");
    Expect(0, 68311, '\P{Is_Joining_Group=manichaeannun}', "");
    Expect(1, 68311, '\P{^Is_Joining_Group=manichaeannun}', "");
    Expect(0, 68312, '\p{Is_Joining_Group=manichaeannun}', "");
    Expect(1, 68312, '\p{^Is_Joining_Group=manichaeannun}', "");
    Expect(1, 68312, '\P{Is_Joining_Group=manichaeannun}', "");
    Expect(0, 68312, '\P{^Is_Joining_Group=manichaeannun}', "");
    Expect(1, 68311, '\p{Is_Joining_Group=-	manichaean_NUN}', "");
    Expect(0, 68311, '\p{^Is_Joining_Group=-	manichaean_NUN}', "");
    Expect(0, 68311, '\P{Is_Joining_Group=-	manichaean_NUN}', "");
    Expect(1, 68311, '\P{^Is_Joining_Group=-	manichaean_NUN}', "");
    Expect(0, 68312, '\p{Is_Joining_Group=-	manichaean_NUN}', "");
    Expect(1, 68312, '\p{^Is_Joining_Group=-	manichaean_NUN}', "");
    Expect(1, 68312, '\P{Is_Joining_Group=-	manichaean_NUN}', "");
    Expect(0, 68312, '\P{^Is_Joining_Group=-	manichaean_NUN}', "");
    Error('\p{Is_Jg:-/a/Manichaean_NUN}');
    Error('\P{Is_Jg:-/a/Manichaean_NUN}');
    Expect(1, 68311, '\p{Is_Jg: manichaeannun}', "");
    Expect(0, 68311, '\p{^Is_Jg: manichaeannun}', "");
    Expect(0, 68311, '\P{Is_Jg: manichaeannun}', "");
    Expect(1, 68311, '\P{^Is_Jg: manichaeannun}', "");
    Expect(0, 68312, '\p{Is_Jg: manichaeannun}', "");
    Expect(1, 68312, '\p{^Is_Jg: manichaeannun}', "");
    Expect(1, 68312, '\P{Is_Jg: manichaeannun}', "");
    Expect(0, 68312, '\P{^Is_Jg: manichaeannun}', "");
    Expect(1, 68311, '\p{Is_Jg:	-Manichaean_Nun}', "");
    Expect(0, 68311, '\p{^Is_Jg:	-Manichaean_Nun}', "");
    Expect(0, 68311, '\P{Is_Jg:	-Manichaean_Nun}', "");
    Expect(1, 68311, '\P{^Is_Jg:	-Manichaean_Nun}', "");
    Expect(0, 68312, '\p{Is_Jg:	-Manichaean_Nun}', "");
    Expect(1, 68312, '\p{^Is_Jg:	-Manichaean_Nun}', "");
    Expect(1, 68312, '\P{Is_Jg:	-Manichaean_Nun}', "");
    Expect(0, 68312, '\P{^Is_Jg:	-Manichaean_Nun}', "");
    Error('\p{Joining_Group=	 MANICHAEAN_ONE/a/}');
    Error('\P{Joining_Group=	 MANICHAEAN_ONE/a/}');
    Expect(1, 68331, '\p{Joining_Group=:\AManichaean_One\z:}', "");;
    Expect(0, 68332, '\p{Joining_Group=:\AManichaean_One\z:}', "");;
    Expect(1, 68331, '\p{Joining_Group:   manichaeanone}', "");
    Expect(0, 68331, '\p{^Joining_Group:   manichaeanone}', "");
    Expect(0, 68331, '\P{Joining_Group:   manichaeanone}', "");
    Expect(1, 68331, '\P{^Joining_Group:   manichaeanone}', "");
    Expect(0, 68332, '\p{Joining_Group:   manichaeanone}', "");
    Expect(1, 68332, '\p{^Joining_Group:   manichaeanone}', "");
    Expect(1, 68332, '\P{Joining_Group:   manichaeanone}', "");
    Expect(0, 68332, '\P{^Joining_Group:   manichaeanone}', "");
    Expect(1, 68331, '\p{Joining_Group=:\Amanichaeanone\z:}', "");;
    Expect(0, 68332, '\p{Joining_Group=:\Amanichaeanone\z:}', "");;
    Expect(1, 68331, '\p{Joining_Group=	manichaean_One}', "");
    Expect(0, 68331, '\p{^Joining_Group=	manichaean_One}', "");
    Expect(0, 68331, '\P{Joining_Group=	manichaean_One}', "");
    Expect(1, 68331, '\P{^Joining_Group=	manichaean_One}', "");
    Expect(0, 68332, '\p{Joining_Group=	manichaean_One}', "");
    Expect(1, 68332, '\p{^Joining_Group=	manichaean_One}', "");
    Expect(1, 68332, '\P{Joining_Group=	manichaean_One}', "");
    Expect(0, 68332, '\P{^Joining_Group=	manichaean_One}', "");
    Error('\p{Jg= -Manichaean_one:=}');
    Error('\P{Jg= -Manichaean_one:=}');
    Expect(1, 68331, '\p{Jg=:\AManichaean_One\z:}', "");;
    Expect(0, 68332, '\p{Jg=:\AManichaean_One\z:}', "");;
    Expect(1, 68331, '\p{Jg=manichaeanone}', "");
    Expect(0, 68331, '\p{^Jg=manichaeanone}', "");
    Expect(0, 68331, '\P{Jg=manichaeanone}', "");
    Expect(1, 68331, '\P{^Jg=manichaeanone}', "");
    Expect(0, 68332, '\p{Jg=manichaeanone}', "");
    Expect(1, 68332, '\p{^Jg=manichaeanone}', "");
    Expect(1, 68332, '\P{Jg=manichaeanone}', "");
    Expect(0, 68332, '\P{^Jg=manichaeanone}', "");
    Expect(1, 68331, '\p{Jg=:\Amanichaeanone\z:}', "");;
    Expect(0, 68332, '\p{Jg=:\Amanichaeanone\z:}', "");;
    Expect(1, 68331, '\p{Jg=- Manichaean_One}', "");
    Expect(0, 68331, '\p{^Jg=- Manichaean_One}', "");
    Expect(0, 68331, '\P{Jg=- Manichaean_One}', "");
    Expect(1, 68331, '\P{^Jg=- Manichaean_One}', "");
    Expect(0, 68332, '\p{Jg=- Manichaean_One}', "");
    Expect(1, 68332, '\p{^Jg=- Manichaean_One}', "");
    Expect(1, 68332, '\P{Jg=- Manichaean_One}', "");
    Expect(0, 68332, '\P{^Jg=- Manichaean_One}', "");
    Error('\p{Is_Joining_Group=		Manichaean_ONE/a/}');
    Error('\P{Is_Joining_Group=		Manichaean_ONE/a/}');
    Expect(1, 68331, '\p{Is_Joining_Group=manichaeanone}', "");
    Expect(0, 68331, '\p{^Is_Joining_Group=manichaeanone}', "");
    Expect(0, 68331, '\P{Is_Joining_Group=manichaeanone}', "");
    Expect(1, 68331, '\P{^Is_Joining_Group=manichaeanone}', "");
    Expect(0, 68332, '\p{Is_Joining_Group=manichaeanone}', "");
    Expect(1, 68332, '\p{^Is_Joining_Group=manichaeanone}', "");
    Expect(1, 68332, '\P{Is_Joining_Group=manichaeanone}', "");
    Expect(0, 68332, '\P{^Is_Joining_Group=manichaeanone}', "");
    Expect(1, 68331, '\p{Is_Joining_Group=	MANICHAEAN_ONE}', "");
    Expect(0, 68331, '\p{^Is_Joining_Group=	MANICHAEAN_ONE}', "");
    Expect(0, 68331, '\P{Is_Joining_Group=	MANICHAEAN_ONE}', "");
    Expect(1, 68331, '\P{^Is_Joining_Group=	MANICHAEAN_ONE}', "");
    Expect(0, 68332, '\p{Is_Joining_Group=	MANICHAEAN_ONE}', "");
    Expect(1, 68332, '\p{^Is_Joining_Group=	MANICHAEAN_ONE}', "");
    Expect(1, 68332, '\P{Is_Joining_Group=	MANICHAEAN_ONE}', "");
    Expect(0, 68332, '\P{^Is_Joining_Group=	MANICHAEAN_ONE}', "");
    Error('\p{Is_Jg=	_Manichaean_one/a/}');
    Error('\P{Is_Jg=	_Manichaean_one/a/}');
    Expect(1, 68331, '\p{Is_Jg=manichaeanone}', "");
    Expect(0, 68331, '\p{^Is_Jg=manichaeanone}', "");
    Expect(0, 68331, '\P{Is_Jg=manichaeanone}', "");
    Expect(1, 68331, '\P{^Is_Jg=manichaeanone}', "");
    Expect(0, 68332, '\p{Is_Jg=manichaeanone}', "");
    Expect(1, 68332, '\p{^Is_Jg=manichaeanone}', "");
    Expect(1, 68332, '\P{Is_Jg=manichaeanone}', "");
    Expect(0, 68332, '\P{^Is_Jg=manichaeanone}', "");
    Expect(1, 68331, '\p{Is_Jg=	_Manichaean_One}', "");
    Expect(0, 68331, '\p{^Is_Jg=	_Manichaean_One}', "");
    Expect(0, 68331, '\P{Is_Jg=	_Manichaean_One}', "");
    Expect(1, 68331, '\P{^Is_Jg=	_Manichaean_One}', "");
    Expect(0, 68332, '\p{Is_Jg=	_Manichaean_One}', "");
    Expect(1, 68332, '\p{^Is_Jg=	_Manichaean_One}', "");
    Expect(1, 68332, '\P{Is_Jg=	_Manichaean_One}', "");
    Expect(0, 68332, '\P{^Is_Jg=	_Manichaean_One}', "");
    Error('\p{Joining_Group=:=_ manichaean_pe}');
    Error('\P{Joining_Group=:=_ manichaean_pe}');
    Expect(1, 68316, '\p{Joining_Group=:\AManichaean_Pe\z:}', "");;
    Expect(0, 68317, '\p{Joining_Group=:\AManichaean_Pe\z:}', "");;
    Expect(1, 68316, '\p{Joining_Group=manichaeanpe}', "");
    Expect(0, 68316, '\p{^Joining_Group=manichaeanpe}', "");
    Expect(0, 68316, '\P{Joining_Group=manichaeanpe}', "");
    Expect(1, 68316, '\P{^Joining_Group=manichaeanpe}', "");
    Expect(0, 68317, '\p{Joining_Group=manichaeanpe}', "");
    Expect(1, 68317, '\p{^Joining_Group=manichaeanpe}', "");
    Expect(1, 68317, '\P{Joining_Group=manichaeanpe}', "");
    Expect(0, 68317, '\P{^Joining_Group=manichaeanpe}', "");
    Expect(1, 68316, '\p{Joining_Group=:\Amanichaeanpe\z:}', "");;
    Expect(0, 68317, '\p{Joining_Group=:\Amanichaeanpe\z:}', "");;
    Expect(1, 68316, '\p{Joining_Group:   	manichaean_pe}', "");
    Expect(0, 68316, '\p{^Joining_Group:   	manichaean_pe}', "");
    Expect(0, 68316, '\P{Joining_Group:   	manichaean_pe}', "");
    Expect(1, 68316, '\P{^Joining_Group:   	manichaean_pe}', "");
    Expect(0, 68317, '\p{Joining_Group:   	manichaean_pe}', "");
    Expect(1, 68317, '\p{^Joining_Group:   	manichaean_pe}', "");
    Expect(1, 68317, '\P{Joining_Group:   	manichaean_pe}', "");
    Expect(0, 68317, '\P{^Joining_Group:   	manichaean_pe}', "");
    Error('\p{Jg=_-Manichaean_PE/a/}');
    Error('\P{Jg=_-Manichaean_PE/a/}');
    Expect(1, 68316, '\p{Jg=:\AManichaean_Pe\z:}', "");;
    Expect(0, 68317, '\p{Jg=:\AManichaean_Pe\z:}', "");;
    Expect(1, 68316, '\p{Jg=manichaeanpe}', "");
    Expect(0, 68316, '\p{^Jg=manichaeanpe}', "");
    Expect(0, 68316, '\P{Jg=manichaeanpe}', "");
    Expect(1, 68316, '\P{^Jg=manichaeanpe}', "");
    Expect(0, 68317, '\p{Jg=manichaeanpe}', "");
    Expect(1, 68317, '\p{^Jg=manichaeanpe}', "");
    Expect(1, 68317, '\P{Jg=manichaeanpe}', "");
    Expect(0, 68317, '\P{^Jg=manichaeanpe}', "");
    Expect(1, 68316, '\p{Jg=:\Amanichaeanpe\z:}', "");;
    Expect(0, 68317, '\p{Jg=:\Amanichaeanpe\z:}', "");;
    Expect(1, 68316, '\p{Jg=	-Manichaean_Pe}', "");
    Expect(0, 68316, '\p{^Jg=	-Manichaean_Pe}', "");
    Expect(0, 68316, '\P{Jg=	-Manichaean_Pe}', "");
    Expect(1, 68316, '\P{^Jg=	-Manichaean_Pe}', "");
    Expect(0, 68317, '\p{Jg=	-Manichaean_Pe}', "");
    Expect(1, 68317, '\p{^Jg=	-Manichaean_Pe}', "");
    Expect(1, 68317, '\P{Jg=	-Manichaean_Pe}', "");
    Expect(0, 68317, '\P{^Jg=	-Manichaean_Pe}', "");
    Error('\p{Is_Joining_Group=:=	Manichaean_pe}');
    Error('\P{Is_Joining_Group=:=	Manichaean_pe}');
    Expect(1, 68316, '\p{Is_Joining_Group=manichaeanpe}', "");
    Expect(0, 68316, '\p{^Is_Joining_Group=manichaeanpe}', "");
    Expect(0, 68316, '\P{Is_Joining_Group=manichaeanpe}', "");
    Expect(1, 68316, '\P{^Is_Joining_Group=manichaeanpe}', "");
    Expect(0, 68317, '\p{Is_Joining_Group=manichaeanpe}', "");
    Expect(1, 68317, '\p{^Is_Joining_Group=manichaeanpe}', "");
    Expect(1, 68317, '\P{Is_Joining_Group=manichaeanpe}', "");
    Expect(0, 68317, '\P{^Is_Joining_Group=manichaeanpe}', "");
    Expect(1, 68316, '\p{Is_Joining_Group:   Manichaean_pe}', "");
    Expect(0, 68316, '\p{^Is_Joining_Group:   Manichaean_pe}', "");
    Expect(0, 68316, '\P{Is_Joining_Group:   Manichaean_pe}', "");
    Expect(1, 68316, '\P{^Is_Joining_Group:   Manichaean_pe}', "");
    Expect(0, 68317, '\p{Is_Joining_Group:   Manichaean_pe}', "");
    Expect(1, 68317, '\p{^Is_Joining_Group:   Manichaean_pe}', "");
    Expect(1, 68317, '\P{Is_Joining_Group:   Manichaean_pe}', "");
    Expect(0, 68317, '\P{^Is_Joining_Group:   Manichaean_pe}', "");
    Error('\p{Is_Jg:/a/-MANICHAEAN_PE}');
    Error('\P{Is_Jg:/a/-MANICHAEAN_PE}');
    Expect(1, 68316, '\p{Is_Jg=manichaeanpe}', "");
    Expect(0, 68316, '\p{^Is_Jg=manichaeanpe}', "");
    Expect(0, 68316, '\P{Is_Jg=manichaeanpe}', "");
    Expect(1, 68316, '\P{^Is_Jg=manichaeanpe}', "");
    Expect(0, 68317, '\p{Is_Jg=manichaeanpe}', "");
    Expect(1, 68317, '\p{^Is_Jg=manichaeanpe}', "");
    Expect(1, 68317, '\P{Is_Jg=manichaeanpe}', "");
    Expect(0, 68317, '\P{^Is_Jg=manichaeanpe}', "");
    Expect(1, 68316, '\p{Is_Jg=-Manichaean_PE}', "");
    Expect(0, 68316, '\p{^Is_Jg=-Manichaean_PE}', "");
    Expect(0, 68316, '\P{Is_Jg=-Manichaean_PE}', "");
    Expect(1, 68316, '\P{^Is_Jg=-Manichaean_PE}', "");
    Expect(0, 68317, '\p{Is_Jg=-Manichaean_PE}', "");
    Expect(1, 68317, '\p{^Is_Jg=-Manichaean_PE}', "");
    Expect(1, 68317, '\P{Is_Jg=-Manichaean_PE}', "");
    Expect(0, 68317, '\P{^Is_Jg=-Manichaean_PE}', "");
    Error('\p{Joining_Group=	:=manichaean_Qoph}');
    Error('\P{Joining_Group=	:=manichaean_Qoph}');
    Expect(1, 68320, '\p{Joining_Group=:\AManichaean_Qoph\z:}', "");;
    Expect(0, 68321, '\p{Joining_Group=:\AManichaean_Qoph\z:}', "");;
    Expect(1, 68320, '\p{Joining_Group=manichaeanqoph}', "");
    Expect(0, 68320, '\p{^Joining_Group=manichaeanqoph}', "");
    Expect(0, 68320, '\P{Joining_Group=manichaeanqoph}', "");
    Expect(1, 68320, '\P{^Joining_Group=manichaeanqoph}', "");
    Expect(0, 68321, '\p{Joining_Group=manichaeanqoph}', "");
    Expect(1, 68321, '\p{^Joining_Group=manichaeanqoph}', "");
    Expect(1, 68321, '\P{Joining_Group=manichaeanqoph}', "");
    Expect(0, 68321, '\P{^Joining_Group=manichaeanqoph}', "");
    Expect(1, 68320, '\p{Joining_Group=:\Amanichaeanqoph\z:}', "");;
    Expect(0, 68321, '\p{Joining_Group=:\Amanichaeanqoph\z:}', "");;
    Expect(1, 68320, '\p{Joining_Group=- Manichaean_QOPH}', "");
    Expect(0, 68320, '\p{^Joining_Group=- Manichaean_QOPH}', "");
    Expect(0, 68320, '\P{Joining_Group=- Manichaean_QOPH}', "");
    Expect(1, 68320, '\P{^Joining_Group=- Manichaean_QOPH}', "");
    Expect(0, 68321, '\p{Joining_Group=- Manichaean_QOPH}', "");
    Expect(1, 68321, '\p{^Joining_Group=- Manichaean_QOPH}', "");
    Expect(1, 68321, '\P{Joining_Group=- Manichaean_QOPH}', "");
    Expect(0, 68321, '\P{^Joining_Group=- Manichaean_QOPH}', "");
    Error('\p{Jg=	 Manichaean_qoph/a/}');
    Error('\P{Jg=	 Manichaean_qoph/a/}');
    Expect(1, 68320, '\p{Jg=:\AManichaean_Qoph\z:}', "");;
    Expect(0, 68321, '\p{Jg=:\AManichaean_Qoph\z:}', "");;
    Expect(1, 68320, '\p{Jg=manichaeanqoph}', "");
    Expect(0, 68320, '\p{^Jg=manichaeanqoph}', "");
    Expect(0, 68320, '\P{Jg=manichaeanqoph}', "");
    Expect(1, 68320, '\P{^Jg=manichaeanqoph}', "");
    Expect(0, 68321, '\p{Jg=manichaeanqoph}', "");
    Expect(1, 68321, '\p{^Jg=manichaeanqoph}', "");
    Expect(1, 68321, '\P{Jg=manichaeanqoph}', "");
    Expect(0, 68321, '\P{^Jg=manichaeanqoph}', "");
    Expect(1, 68320, '\p{Jg=:\Amanichaeanqoph\z:}', "");;
    Expect(0, 68321, '\p{Jg=:\Amanichaeanqoph\z:}', "");;
    Expect(1, 68320, '\p{Jg=_	Manichaean_Qoph}', "");
    Expect(0, 68320, '\p{^Jg=_	Manichaean_Qoph}', "");
    Expect(0, 68320, '\P{Jg=_	Manichaean_Qoph}', "");
    Expect(1, 68320, '\P{^Jg=_	Manichaean_Qoph}', "");
    Expect(0, 68321, '\p{Jg=_	Manichaean_Qoph}', "");
    Expect(1, 68321, '\p{^Jg=_	Manichaean_Qoph}', "");
    Expect(1, 68321, '\P{Jg=_	Manichaean_Qoph}', "");
    Expect(0, 68321, '\P{^Jg=_	Manichaean_Qoph}', "");
    Error('\p{Is_Joining_Group=	-manichaean_Qoph:=}');
    Error('\P{Is_Joining_Group=	-manichaean_Qoph:=}');
    Expect(1, 68320, '\p{Is_Joining_Group=manichaeanqoph}', "");
    Expect(0, 68320, '\p{^Is_Joining_Group=manichaeanqoph}', "");
    Expect(0, 68320, '\P{Is_Joining_Group=manichaeanqoph}', "");
    Expect(1, 68320, '\P{^Is_Joining_Group=manichaeanqoph}', "");
    Expect(0, 68321, '\p{Is_Joining_Group=manichaeanqoph}', "");
    Expect(1, 68321, '\p{^Is_Joining_Group=manichaeanqoph}', "");
    Expect(1, 68321, '\P{Is_Joining_Group=manichaeanqoph}', "");
    Expect(0, 68321, '\P{^Is_Joining_Group=manichaeanqoph}', "");
    Expect(1, 68320, '\p{Is_Joining_Group=MANICHAEAN_Qoph}', "");
    Expect(0, 68320, '\p{^Is_Joining_Group=MANICHAEAN_Qoph}', "");
    Expect(0, 68320, '\P{Is_Joining_Group=MANICHAEAN_Qoph}', "");
    Expect(1, 68320, '\P{^Is_Joining_Group=MANICHAEAN_Qoph}', "");
    Expect(0, 68321, '\p{Is_Joining_Group=MANICHAEAN_Qoph}', "");
    Expect(1, 68321, '\p{^Is_Joining_Group=MANICHAEAN_Qoph}', "");
    Expect(1, 68321, '\P{Is_Joining_Group=MANICHAEAN_Qoph}', "");
    Expect(0, 68321, '\P{^Is_Joining_Group=MANICHAEAN_Qoph}', "");
    Error('\p{Is_Jg:- Manichaean_qoph:=}');
    Error('\P{Is_Jg:- Manichaean_qoph:=}');
    Expect(1, 68320, '\p{Is_Jg=manichaeanqoph}', "");
    Expect(0, 68320, '\p{^Is_Jg=manichaeanqoph}', "");
    Expect(0, 68320, '\P{Is_Jg=manichaeanqoph}', "");
    Expect(1, 68320, '\P{^Is_Jg=manichaeanqoph}', "");
    Expect(0, 68321, '\p{Is_Jg=manichaeanqoph}', "");
    Expect(1, 68321, '\p{^Is_Jg=manichaeanqoph}', "");
    Expect(1, 68321, '\P{Is_Jg=manichaeanqoph}', "");
    Expect(0, 68321, '\P{^Is_Jg=manichaeanqoph}', "");
    Expect(1, 68320, '\p{Is_Jg=_-MANICHAEAN_Qoph}', "");
    Expect(0, 68320, '\p{^Is_Jg=_-MANICHAEAN_Qoph}', "");
    Expect(0, 68320, '\P{Is_Jg=_-MANICHAEAN_Qoph}', "");
    Expect(1, 68320, '\P{^Is_Jg=_-MANICHAEAN_Qoph}', "");
    Expect(0, 68321, '\p{Is_Jg=_-MANICHAEAN_Qoph}', "");
    Expect(1, 68321, '\p{^Is_Jg=_-MANICHAEAN_Qoph}', "");
    Expect(1, 68321, '\P{Is_Jg=_-MANICHAEAN_Qoph}', "");
    Expect(0, 68321, '\P{^Is_Jg=_-MANICHAEAN_Qoph}', "");
    Error('\p{Joining_Group=	/a/MANICHAEAN_Resh}');
    Error('\P{Joining_Group=	/a/MANICHAEAN_Resh}');
    Expect(1, 68321, '\p{Joining_Group=:\AManichaean_Resh\z:}', "");;
    Expect(0, 68322, '\p{Joining_Group=:\AManichaean_Resh\z:}', "");;
    Expect(1, 68321, '\p{Joining_Group=manichaeanresh}', "");
    Expect(0, 68321, '\p{^Joining_Group=manichaeanresh}', "");
    Expect(0, 68321, '\P{Joining_Group=manichaeanresh}', "");
    Expect(1, 68321, '\P{^Joining_Group=manichaeanresh}', "");
    Expect(0, 68322, '\p{Joining_Group=manichaeanresh}', "");
    Expect(1, 68322, '\p{^Joining_Group=manichaeanresh}', "");
    Expect(1, 68322, '\P{Joining_Group=manichaeanresh}', "");
    Expect(0, 68322, '\P{^Joining_Group=manichaeanresh}', "");
    Expect(1, 68321, '\p{Joining_Group=:\Amanichaeanresh\z:}', "");;
    Expect(0, 68322, '\p{Joining_Group=:\Amanichaeanresh\z:}', "");;
    Expect(1, 68321, '\p{Joining_Group=-Manichaean_RESH}', "");
    Expect(0, 68321, '\p{^Joining_Group=-Manichaean_RESH}', "");
    Expect(0, 68321, '\P{Joining_Group=-Manichaean_RESH}', "");
    Expect(1, 68321, '\P{^Joining_Group=-Manichaean_RESH}', "");
    Expect(0, 68322, '\p{Joining_Group=-Manichaean_RESH}', "");
    Expect(1, 68322, '\p{^Joining_Group=-Manichaean_RESH}', "");
    Expect(1, 68322, '\P{Joining_Group=-Manichaean_RESH}', "");
    Expect(0, 68322, '\P{^Joining_Group=-Manichaean_RESH}', "");
    Error('\p{Jg=	/a/manichaean_RESH}');
    Error('\P{Jg=	/a/manichaean_RESH}');
    Expect(1, 68321, '\p{Jg=:\AManichaean_Resh\z:}', "");;
    Expect(0, 68322, '\p{Jg=:\AManichaean_Resh\z:}', "");;
    Expect(1, 68321, '\p{Jg=manichaeanresh}', "");
    Expect(0, 68321, '\p{^Jg=manichaeanresh}', "");
    Expect(0, 68321, '\P{Jg=manichaeanresh}', "");
    Expect(1, 68321, '\P{^Jg=manichaeanresh}', "");
    Expect(0, 68322, '\p{Jg=manichaeanresh}', "");
    Expect(1, 68322, '\p{^Jg=manichaeanresh}', "");
    Expect(1, 68322, '\P{Jg=manichaeanresh}', "");
    Expect(0, 68322, '\P{^Jg=manichaeanresh}', "");
    Expect(1, 68321, '\p{Jg=:\Amanichaeanresh\z:}', "");;
    Expect(0, 68322, '\p{Jg=:\Amanichaeanresh\z:}', "");;
    Expect(1, 68321, '\p{Jg=		Manichaean_RESH}', "");
    Expect(0, 68321, '\p{^Jg=		Manichaean_RESH}', "");
    Expect(0, 68321, '\P{Jg=		Manichaean_RESH}', "");
    Expect(1, 68321, '\P{^Jg=		Manichaean_RESH}', "");
    Expect(0, 68322, '\p{Jg=		Manichaean_RESH}', "");
    Expect(1, 68322, '\p{^Jg=		Manichaean_RESH}', "");
    Expect(1, 68322, '\P{Jg=		Manichaean_RESH}', "");
    Expect(0, 68322, '\P{^Jg=		Manichaean_RESH}', "");
    Error('\p{Is_Joining_Group=:=  Manichaean_Resh}');
    Error('\P{Is_Joining_Group=:=  Manichaean_Resh}');
    Expect(1, 68321, '\p{Is_Joining_Group=manichaeanresh}', "");
    Expect(0, 68321, '\p{^Is_Joining_Group=manichaeanresh}', "");
    Expect(0, 68321, '\P{Is_Joining_Group=manichaeanresh}', "");
    Expect(1, 68321, '\P{^Is_Joining_Group=manichaeanresh}', "");
    Expect(0, 68322, '\p{Is_Joining_Group=manichaeanresh}', "");
    Expect(1, 68322, '\p{^Is_Joining_Group=manichaeanresh}', "");
    Expect(1, 68322, '\P{Is_Joining_Group=manichaeanresh}', "");
    Expect(0, 68322, '\P{^Is_Joining_Group=manichaeanresh}', "");
    Expect(1, 68321, '\p{Is_Joining_Group=Manichaean_RESH}', "");
    Expect(0, 68321, '\p{^Is_Joining_Group=Manichaean_RESH}', "");
    Expect(0, 68321, '\P{Is_Joining_Group=Manichaean_RESH}', "");
    Expect(1, 68321, '\P{^Is_Joining_Group=Manichaean_RESH}', "");
    Expect(0, 68322, '\p{Is_Joining_Group=Manichaean_RESH}', "");
    Expect(1, 68322, '\p{^Is_Joining_Group=Manichaean_RESH}', "");
    Expect(1, 68322, '\P{Is_Joining_Group=Manichaean_RESH}', "");
    Expect(0, 68322, '\P{^Is_Joining_Group=Manichaean_RESH}', "");
    Error('\p{Is_Jg=__MANICHAEAN_Resh/a/}');
    Error('\P{Is_Jg=__MANICHAEAN_Resh/a/}');
    Expect(1, 68321, '\p{Is_Jg:manichaeanresh}', "");
    Expect(0, 68321, '\p{^Is_Jg:manichaeanresh}', "");
    Expect(0, 68321, '\P{Is_Jg:manichaeanresh}', "");
    Expect(1, 68321, '\P{^Is_Jg:manichaeanresh}', "");
    Expect(0, 68322, '\p{Is_Jg:manichaeanresh}', "");
    Expect(1, 68322, '\p{^Is_Jg:manichaeanresh}', "");
    Expect(1, 68322, '\P{Is_Jg:manichaeanresh}', "");
    Expect(0, 68322, '\P{^Is_Jg:manichaeanresh}', "");
    Expect(1, 68321, '\p{Is_Jg=_manichaean_resh}', "");
    Expect(0, 68321, '\p{^Is_Jg=_manichaean_resh}', "");
    Expect(0, 68321, '\P{Is_Jg=_manichaean_resh}', "");
    Expect(1, 68321, '\P{^Is_Jg=_manichaean_resh}', "");
    Expect(0, 68322, '\p{Is_Jg=_manichaean_resh}', "");
    Expect(1, 68322, '\p{^Is_Jg=_manichaean_resh}', "");
    Expect(1, 68322, '\P{Is_Jg=_manichaean_resh}', "");
    Expect(0, 68322, '\P{^Is_Jg=_manichaean_resh}', "");
    Error('\p{Joining_Group=-/a/Manichaean_SADHE}');
    Error('\P{Joining_Group=-/a/Manichaean_SADHE}');
    Expect(1, 68317, '\p{Joining_Group=:\AManichaean_Sadhe\z:}', "");;
    Expect(0, 68318, '\p{Joining_Group=:\AManichaean_Sadhe\z:}', "");;
    Expect(1, 68317, '\p{Joining_Group=manichaeansadhe}', "");
    Expect(0, 68317, '\p{^Joining_Group=manichaeansadhe}', "");
    Expect(0, 68317, '\P{Joining_Group=manichaeansadhe}', "");
    Expect(1, 68317, '\P{^Joining_Group=manichaeansadhe}', "");
    Expect(0, 68318, '\p{Joining_Group=manichaeansadhe}', "");
    Expect(1, 68318, '\p{^Joining_Group=manichaeansadhe}', "");
    Expect(1, 68318, '\P{Joining_Group=manichaeansadhe}', "");
    Expect(0, 68318, '\P{^Joining_Group=manichaeansadhe}', "");
    Expect(1, 68317, '\p{Joining_Group=:\Amanichaeansadhe\z:}', "");;
    Expect(0, 68318, '\p{Joining_Group=:\Amanichaeansadhe\z:}', "");;
    Expect(1, 68317, '\p{Joining_Group=  Manichaean_Sadhe}', "");
    Expect(0, 68317, '\p{^Joining_Group=  Manichaean_Sadhe}', "");
    Expect(0, 68317, '\P{Joining_Group=  Manichaean_Sadhe}', "");
    Expect(1, 68317, '\P{^Joining_Group=  Manichaean_Sadhe}', "");
    Expect(0, 68318, '\p{Joining_Group=  Manichaean_Sadhe}', "");
    Expect(1, 68318, '\p{^Joining_Group=  Manichaean_Sadhe}', "");
    Expect(1, 68318, '\P{Joining_Group=  Manichaean_Sadhe}', "");
    Expect(0, 68318, '\P{^Joining_Group=  Manichaean_Sadhe}', "");
    Error('\p{Jg=:=Manichaean_Sadhe}');
    Error('\P{Jg=:=Manichaean_Sadhe}');
    Expect(1, 68317, '\p{Jg=:\AManichaean_Sadhe\z:}', "");;
    Expect(0, 68318, '\p{Jg=:\AManichaean_Sadhe\z:}', "");;
    Expect(1, 68317, '\p{Jg: manichaeansadhe}', "");
    Expect(0, 68317, '\p{^Jg: manichaeansadhe}', "");
    Expect(0, 68317, '\P{Jg: manichaeansadhe}', "");
    Expect(1, 68317, '\P{^Jg: manichaeansadhe}', "");
    Expect(0, 68318, '\p{Jg: manichaeansadhe}', "");
    Expect(1, 68318, '\p{^Jg: manichaeansadhe}', "");
    Expect(1, 68318, '\P{Jg: manichaeansadhe}', "");
    Expect(0, 68318, '\P{^Jg: manichaeansadhe}', "");
    Expect(1, 68317, '\p{Jg=:\Amanichaeansadhe\z:}', "");;
    Expect(0, 68318, '\p{Jg=:\Amanichaeansadhe\z:}', "");;
    Expect(1, 68317, '\p{Jg=_Manichaean_Sadhe}', "");
    Expect(0, 68317, '\p{^Jg=_Manichaean_Sadhe}', "");
    Expect(0, 68317, '\P{Jg=_Manichaean_Sadhe}', "");
    Expect(1, 68317, '\P{^Jg=_Manichaean_Sadhe}', "");
    Expect(0, 68318, '\p{Jg=_Manichaean_Sadhe}', "");
    Expect(1, 68318, '\p{^Jg=_Manichaean_Sadhe}', "");
    Expect(1, 68318, '\P{Jg=_Manichaean_Sadhe}', "");
    Expect(0, 68318, '\P{^Jg=_Manichaean_Sadhe}', "");
    Error('\p{Is_Joining_Group=/a/- MANICHAEAN_Sadhe}');
    Error('\P{Is_Joining_Group=/a/- MANICHAEAN_Sadhe}');
    Expect(1, 68317, '\p{Is_Joining_Group=manichaeansadhe}', "");
    Expect(0, 68317, '\p{^Is_Joining_Group=manichaeansadhe}', "");
    Expect(0, 68317, '\P{Is_Joining_Group=manichaeansadhe}', "");
    Expect(1, 68317, '\P{^Is_Joining_Group=manichaeansadhe}', "");
    Expect(0, 68318, '\p{Is_Joining_Group=manichaeansadhe}', "");
    Expect(1, 68318, '\p{^Is_Joining_Group=manichaeansadhe}', "");
    Expect(1, 68318, '\P{Is_Joining_Group=manichaeansadhe}', "");
    Expect(0, 68318, '\P{^Is_Joining_Group=manichaeansadhe}', "");
    Expect(1, 68317, '\p{Is_Joining_Group=_ manichaean_Sadhe}', "");
    Expect(0, 68317, '\p{^Is_Joining_Group=_ manichaean_Sadhe}', "");
    Expect(0, 68317, '\P{Is_Joining_Group=_ manichaean_Sadhe}', "");
    Expect(1, 68317, '\P{^Is_Joining_Group=_ manichaean_Sadhe}', "");
    Expect(0, 68318, '\p{Is_Joining_Group=_ manichaean_Sadhe}', "");
    Expect(1, 68318, '\p{^Is_Joining_Group=_ manichaean_Sadhe}', "");
    Expect(1, 68318, '\P{Is_Joining_Group=_ manichaean_Sadhe}', "");
    Expect(0, 68318, '\P{^Is_Joining_Group=_ manichaean_Sadhe}', "");
    Error('\p{Is_Jg=-_manichaean_Sadhe:=}');
    Error('\P{Is_Jg=-_manichaean_Sadhe:=}');
    Expect(1, 68317, '\p{Is_Jg=manichaeansadhe}', "");
    Expect(0, 68317, '\p{^Is_Jg=manichaeansadhe}', "");
    Expect(0, 68317, '\P{Is_Jg=manichaeansadhe}', "");
    Expect(1, 68317, '\P{^Is_Jg=manichaeansadhe}', "");
    Expect(0, 68318, '\p{Is_Jg=manichaeansadhe}', "");
    Expect(1, 68318, '\p{^Is_Jg=manichaeansadhe}', "");
    Expect(1, 68318, '\P{Is_Jg=manichaeansadhe}', "");
    Expect(0, 68318, '\P{^Is_Jg=manichaeansadhe}', "");
    Expect(1, 68317, '\p{Is_Jg=_-manichaean_Sadhe}', "");
    Expect(0, 68317, '\p{^Is_Jg=_-manichaean_Sadhe}', "");
    Expect(0, 68317, '\P{Is_Jg=_-manichaean_Sadhe}', "");
    Expect(1, 68317, '\P{^Is_Jg=_-manichaean_Sadhe}', "");
    Expect(0, 68318, '\p{Is_Jg=_-manichaean_Sadhe}', "");
    Expect(1, 68318, '\p{^Is_Jg=_-manichaean_Sadhe}', "");
    Expect(1, 68318, '\P{Is_Jg=_-manichaean_Sadhe}', "");
    Expect(0, 68318, '\P{^Is_Jg=_-manichaean_Sadhe}', "");
    Error('\p{Joining_Group=_-Manichaean_SAMEKH/a/}');
    Error('\P{Joining_Group=_-Manichaean_SAMEKH/a/}');
    Expect(1, 68312, '\p{Joining_Group=:\AManichaean_Samekh\z:}', "");;
    Expect(0, 68313, '\p{Joining_Group=:\AManichaean_Samekh\z:}', "");;
    Expect(1, 68312, '\p{Joining_Group=manichaeansamekh}', "");
    Expect(0, 68312, '\p{^Joining_Group=manichaeansamekh}', "");
    Expect(0, 68312, '\P{Joining_Group=manichaeansamekh}', "");
    Expect(1, 68312, '\P{^Joining_Group=manichaeansamekh}', "");
    Expect(0, 68313, '\p{Joining_Group=manichaeansamekh}', "");
    Expect(1, 68313, '\p{^Joining_Group=manichaeansamekh}', "");
    Expect(1, 68313, '\P{Joining_Group=manichaeansamekh}', "");
    Expect(0, 68313, '\P{^Joining_Group=manichaeansamekh}', "");
    Expect(1, 68312, '\p{Joining_Group=:\Amanichaeansamekh\z:}', "");;
    Expect(0, 68313, '\p{Joining_Group=:\Amanichaeansamekh\z:}', "");;
    Expect(1, 68312, '\p{Joining_Group=_Manichaean_Samekh}', "");
    Expect(0, 68312, '\p{^Joining_Group=_Manichaean_Samekh}', "");
    Expect(0, 68312, '\P{Joining_Group=_Manichaean_Samekh}', "");
    Expect(1, 68312, '\P{^Joining_Group=_Manichaean_Samekh}', "");
    Expect(0, 68313, '\p{Joining_Group=_Manichaean_Samekh}', "");
    Expect(1, 68313, '\p{^Joining_Group=_Manichaean_Samekh}', "");
    Expect(1, 68313, '\P{Joining_Group=_Manichaean_Samekh}', "");
    Expect(0, 68313, '\P{^Joining_Group=_Manichaean_Samekh}', "");
    Error('\p{Jg=/a/-_manichaean_samekh}');
    Error('\P{Jg=/a/-_manichaean_samekh}');
    Expect(1, 68312, '\p{Jg=:\AManichaean_Samekh\z:}', "");;
    Expect(0, 68313, '\p{Jg=:\AManichaean_Samekh\z:}', "");;
    Expect(1, 68312, '\p{Jg: manichaeansamekh}', "");
    Expect(0, 68312, '\p{^Jg: manichaeansamekh}', "");
    Expect(0, 68312, '\P{Jg: manichaeansamekh}', "");
    Expect(1, 68312, '\P{^Jg: manichaeansamekh}', "");
    Expect(0, 68313, '\p{Jg: manichaeansamekh}', "");
    Expect(1, 68313, '\p{^Jg: manichaeansamekh}', "");
    Expect(1, 68313, '\P{Jg: manichaeansamekh}', "");
    Expect(0, 68313, '\P{^Jg: manichaeansamekh}', "");
    Expect(1, 68312, '\p{Jg=:\Amanichaeansamekh\z:}', "");;
    Expect(0, 68313, '\p{Jg=:\Amanichaeansamekh\z:}', "");;
    Expect(1, 68312, '\p{Jg=--manichaean_Samekh}', "");
    Expect(0, 68312, '\p{^Jg=--manichaean_Samekh}', "");
    Expect(0, 68312, '\P{Jg=--manichaean_Samekh}', "");
    Expect(1, 68312, '\P{^Jg=--manichaean_Samekh}', "");
    Expect(0, 68313, '\p{Jg=--manichaean_Samekh}', "");
    Expect(1, 68313, '\p{^Jg=--manichaean_Samekh}', "");
    Expect(1, 68313, '\P{Jg=--manichaean_Samekh}', "");
    Expect(0, 68313, '\P{^Jg=--manichaean_Samekh}', "");
    Error('\p{Is_Joining_Group=:=-MANICHAEAN_samekh}');
    Error('\P{Is_Joining_Group=:=-MANICHAEAN_samekh}');
    Expect(1, 68312, '\p{Is_Joining_Group=manichaeansamekh}', "");
    Expect(0, 68312, '\p{^Is_Joining_Group=manichaeansamekh}', "");
    Expect(0, 68312, '\P{Is_Joining_Group=manichaeansamekh}', "");
    Expect(1, 68312, '\P{^Is_Joining_Group=manichaeansamekh}', "");
    Expect(0, 68313, '\p{Is_Joining_Group=manichaeansamekh}', "");
    Expect(1, 68313, '\p{^Is_Joining_Group=manichaeansamekh}', "");
    Expect(1, 68313, '\P{Is_Joining_Group=manichaeansamekh}', "");
    Expect(0, 68313, '\P{^Is_Joining_Group=manichaeansamekh}', "");
    Expect(1, 68312, '\p{Is_Joining_Group=- manichaean_SAMEKH}', "");
    Expect(0, 68312, '\p{^Is_Joining_Group=- manichaean_SAMEKH}', "");
    Expect(0, 68312, '\P{Is_Joining_Group=- manichaean_SAMEKH}', "");
    Expect(1, 68312, '\P{^Is_Joining_Group=- manichaean_SAMEKH}', "");
    Expect(0, 68313, '\p{Is_Joining_Group=- manichaean_SAMEKH}', "");
    Expect(1, 68313, '\p{^Is_Joining_Group=- manichaean_SAMEKH}', "");
    Expect(1, 68313, '\P{Is_Joining_Group=- manichaean_SAMEKH}', "");
    Expect(0, 68313, '\P{^Is_Joining_Group=- manichaean_SAMEKH}', "");
    Error('\p{Is_Jg=_/a/Manichaean_SAMEKH}');
    Error('\P{Is_Jg=_/a/Manichaean_SAMEKH}');
    Expect(1, 68312, '\p{Is_Jg=manichaeansamekh}', "");
    Expect(0, 68312, '\p{^Is_Jg=manichaeansamekh}', "");
    Expect(0, 68312, '\P{Is_Jg=manichaeansamekh}', "");
    Expect(1, 68312, '\P{^Is_Jg=manichaeansamekh}', "");
    Expect(0, 68313, '\p{Is_Jg=manichaeansamekh}', "");
    Expect(1, 68313, '\p{^Is_Jg=manichaeansamekh}', "");
    Expect(1, 68313, '\P{Is_Jg=manichaeansamekh}', "");
    Expect(0, 68313, '\P{^Is_Jg=manichaeansamekh}', "");
    Expect(1, 68312, '\p{Is_Jg=	_MANICHAEAN_Samekh}', "");
    Expect(0, 68312, '\p{^Is_Jg=	_MANICHAEAN_Samekh}', "");
    Expect(0, 68312, '\P{Is_Jg=	_MANICHAEAN_Samekh}', "");
    Expect(1, 68312, '\P{^Is_Jg=	_MANICHAEAN_Samekh}', "");
    Expect(0, 68313, '\p{Is_Jg=	_MANICHAEAN_Samekh}', "");
    Expect(1, 68313, '\p{^Is_Jg=	_MANICHAEAN_Samekh}', "");
    Expect(1, 68313, '\P{Is_Jg=	_MANICHAEAN_Samekh}', "");
    Expect(0, 68313, '\P{^Is_Jg=	_MANICHAEAN_Samekh}', "");
    Error('\p{Joining_Group=:=-	manichaean_taw}');
    Error('\P{Joining_Group=:=-	manichaean_taw}');
    Expect(1, 68324, '\p{Joining_Group=:\AManichaean_Taw\z:}', "");;
    Expect(0, 68325, '\p{Joining_Group=:\AManichaean_Taw\z:}', "");;
    Expect(1, 68324, '\p{Joining_Group=manichaeantaw}', "");
    Expect(0, 68324, '\p{^Joining_Group=manichaeantaw}', "");
    Expect(0, 68324, '\P{Joining_Group=manichaeantaw}', "");
    Expect(1, 68324, '\P{^Joining_Group=manichaeantaw}', "");
    Expect(0, 68325, '\p{Joining_Group=manichaeantaw}', "");
    Expect(1, 68325, '\p{^Joining_Group=manichaeantaw}', "");
    Expect(1, 68325, '\P{Joining_Group=manichaeantaw}', "");
    Expect(0, 68325, '\P{^Joining_Group=manichaeantaw}', "");
    Expect(1, 68324, '\p{Joining_Group=:\Amanichaeantaw\z:}', "");;
    Expect(0, 68325, '\p{Joining_Group=:\Amanichaeantaw\z:}', "");;
    Expect(1, 68324, '\p{Joining_Group=		MANICHAEAN_taw}', "");
    Expect(0, 68324, '\p{^Joining_Group=		MANICHAEAN_taw}', "");
    Expect(0, 68324, '\P{Joining_Group=		MANICHAEAN_taw}', "");
    Expect(1, 68324, '\P{^Joining_Group=		MANICHAEAN_taw}', "");
    Expect(0, 68325, '\p{Joining_Group=		MANICHAEAN_taw}', "");
    Expect(1, 68325, '\p{^Joining_Group=		MANICHAEAN_taw}', "");
    Expect(1, 68325, '\P{Joining_Group=		MANICHAEAN_taw}', "");
    Expect(0, 68325, '\P{^Joining_Group=		MANICHAEAN_taw}', "");
    Error('\p{Jg=/a/-MANICHAEAN_Taw}');
    Error('\P{Jg=/a/-MANICHAEAN_Taw}');
    Expect(1, 68324, '\p{Jg=:\AManichaean_Taw\z:}', "");;
    Expect(0, 68325, '\p{Jg=:\AManichaean_Taw\z:}', "");;
    Expect(1, 68324, '\p{Jg=manichaeantaw}', "");
    Expect(0, 68324, '\p{^Jg=manichaeantaw}', "");
    Expect(0, 68324, '\P{Jg=manichaeantaw}', "");
    Expect(1, 68324, '\P{^Jg=manichaeantaw}', "");
    Expect(0, 68325, '\p{Jg=manichaeantaw}', "");
    Expect(1, 68325, '\p{^Jg=manichaeantaw}', "");
    Expect(1, 68325, '\P{Jg=manichaeantaw}', "");
    Expect(0, 68325, '\P{^Jg=manichaeantaw}', "");
    Expect(1, 68324, '\p{Jg=:\Amanichaeantaw\z:}', "");;
    Expect(0, 68325, '\p{Jg=:\Amanichaeantaw\z:}', "");;
    Expect(1, 68324, '\p{Jg=	_Manichaean_taw}', "");
    Expect(0, 68324, '\p{^Jg=	_Manichaean_taw}', "");
    Expect(0, 68324, '\P{Jg=	_Manichaean_taw}', "");
    Expect(1, 68324, '\P{^Jg=	_Manichaean_taw}', "");
    Expect(0, 68325, '\p{Jg=	_Manichaean_taw}', "");
    Expect(1, 68325, '\p{^Jg=	_Manichaean_taw}', "");
    Expect(1, 68325, '\P{Jg=	_Manichaean_taw}', "");
    Expect(0, 68325, '\P{^Jg=	_Manichaean_taw}', "");
    Error('\p{Is_Joining_Group=	MANICHAEAN_taw/a/}');
    Error('\P{Is_Joining_Group=	MANICHAEAN_taw/a/}');
    Expect(1, 68324, '\p{Is_Joining_Group=manichaeantaw}', "");
    Expect(0, 68324, '\p{^Is_Joining_Group=manichaeantaw}', "");
    Expect(0, 68324, '\P{Is_Joining_Group=manichaeantaw}', "");
    Expect(1, 68324, '\P{^Is_Joining_Group=manichaeantaw}', "");
    Expect(0, 68325, '\p{Is_Joining_Group=manichaeantaw}', "");
    Expect(1, 68325, '\p{^Is_Joining_Group=manichaeantaw}', "");
    Expect(1, 68325, '\P{Is_Joining_Group=manichaeantaw}', "");
    Expect(0, 68325, '\P{^Is_Joining_Group=manichaeantaw}', "");
    Expect(1, 68324, '\p{Is_Joining_Group: _MANICHAEAN_Taw}', "");
    Expect(0, 68324, '\p{^Is_Joining_Group: _MANICHAEAN_Taw}', "");
    Expect(0, 68324, '\P{Is_Joining_Group: _MANICHAEAN_Taw}', "");
    Expect(1, 68324, '\P{^Is_Joining_Group: _MANICHAEAN_Taw}', "");
    Expect(0, 68325, '\p{Is_Joining_Group: _MANICHAEAN_Taw}', "");
    Expect(1, 68325, '\p{^Is_Joining_Group: _MANICHAEAN_Taw}', "");
    Expect(1, 68325, '\P{Is_Joining_Group: _MANICHAEAN_Taw}', "");
    Expect(0, 68325, '\P{^Is_Joining_Group: _MANICHAEAN_Taw}', "");
    Error('\p{Is_Jg:		/a/manichaean_Taw}');
    Error('\P{Is_Jg:		/a/manichaean_Taw}');
    Expect(1, 68324, '\p{Is_Jg=manichaeantaw}', "");
    Expect(0, 68324, '\p{^Is_Jg=manichaeantaw}', "");
    Expect(0, 68324, '\P{Is_Jg=manichaeantaw}', "");
    Expect(1, 68324, '\P{^Is_Jg=manichaeantaw}', "");
    Expect(0, 68325, '\p{Is_Jg=manichaeantaw}', "");
    Expect(1, 68325, '\p{^Is_Jg=manichaeantaw}', "");
    Expect(1, 68325, '\P{Is_Jg=manichaeantaw}', "");
    Expect(0, 68325, '\P{^Is_Jg=manichaeantaw}', "");
    Expect(1, 68324, '\p{Is_Jg=	manichaean_Taw}', "");
    Expect(0, 68324, '\p{^Is_Jg=	manichaean_Taw}', "");
    Expect(0, 68324, '\P{Is_Jg=	manichaean_Taw}', "");
    Expect(1, 68324, '\P{^Is_Jg=	manichaean_Taw}', "");
    Expect(0, 68325, '\p{Is_Jg=	manichaean_Taw}', "");
    Expect(1, 68325, '\p{^Is_Jg=	manichaean_Taw}', "");
    Expect(1, 68325, '\P{Is_Jg=	manichaean_Taw}', "");
    Expect(0, 68325, '\P{^Is_Jg=	manichaean_Taw}', "");
    Error('\p{Joining_Group=	:=Manichaean_TEN}');
    Error('\P{Joining_Group=	:=Manichaean_TEN}');
    Expect(1, 68333, '\p{Joining_Group=:\AManichaean_Ten\z:}', "");;
    Expect(0, 68334, '\p{Joining_Group=:\AManichaean_Ten\z:}', "");;
    Expect(1, 68333, '\p{Joining_Group=manichaeanten}', "");
    Expect(0, 68333, '\p{^Joining_Group=manichaeanten}', "");
    Expect(0, 68333, '\P{Joining_Group=manichaeanten}', "");
    Expect(1, 68333, '\P{^Joining_Group=manichaeanten}', "");
    Expect(0, 68334, '\p{Joining_Group=manichaeanten}', "");
    Expect(1, 68334, '\p{^Joining_Group=manichaeanten}', "");
    Expect(1, 68334, '\P{Joining_Group=manichaeanten}', "");
    Expect(0, 68334, '\P{^Joining_Group=manichaeanten}', "");
    Expect(1, 68333, '\p{Joining_Group=:\Amanichaeanten\z:}', "");;
    Expect(0, 68334, '\p{Joining_Group=:\Amanichaeanten\z:}', "");;
    Expect(1, 68333, '\p{Joining_Group: 	Manichaean_Ten}', "");
    Expect(0, 68333, '\p{^Joining_Group: 	Manichaean_Ten}', "");
    Expect(0, 68333, '\P{Joining_Group: 	Manichaean_Ten}', "");
    Expect(1, 68333, '\P{^Joining_Group: 	Manichaean_Ten}', "");
    Expect(0, 68334, '\p{Joining_Group: 	Manichaean_Ten}', "");
    Expect(1, 68334, '\p{^Joining_Group: 	Manichaean_Ten}', "");
    Expect(1, 68334, '\P{Joining_Group: 	Manichaean_Ten}', "");
    Expect(0, 68334, '\P{^Joining_Group: 	Manichaean_Ten}', "");
    Error('\p{Jg=:=	MANICHAEAN_Ten}');
    Error('\P{Jg=:=	MANICHAEAN_Ten}');
    Expect(1, 68333, '\p{Jg=:\AManichaean_Ten\z:}', "");;
    Expect(0, 68334, '\p{Jg=:\AManichaean_Ten\z:}', "");;
    Expect(1, 68333, '\p{Jg=manichaeanten}', "");
    Expect(0, 68333, '\p{^Jg=manichaeanten}', "");
    Expect(0, 68333, '\P{Jg=manichaeanten}', "");
    Expect(1, 68333, '\P{^Jg=manichaeanten}', "");
    Expect(0, 68334, '\p{Jg=manichaeanten}', "");
    Expect(1, 68334, '\p{^Jg=manichaeanten}', "");
    Expect(1, 68334, '\P{Jg=manichaeanten}', "");
    Expect(0, 68334, '\P{^Jg=manichaeanten}', "");
    Expect(1, 68333, '\p{Jg=:\Amanichaeanten\z:}', "");;
    Expect(0, 68334, '\p{Jg=:\Amanichaeanten\z:}', "");;
    Expect(1, 68333, '\p{Jg= MANICHAEAN_TEN}', "");
    Expect(0, 68333, '\p{^Jg= MANICHAEAN_TEN}', "");
    Expect(0, 68333, '\P{Jg= MANICHAEAN_TEN}', "");
    Expect(1, 68333, '\P{^Jg= MANICHAEAN_TEN}', "");
    Expect(0, 68334, '\p{Jg= MANICHAEAN_TEN}', "");
    Expect(1, 68334, '\p{^Jg= MANICHAEAN_TEN}', "");
    Expect(1, 68334, '\P{Jg= MANICHAEAN_TEN}', "");
    Expect(0, 68334, '\P{^Jg= MANICHAEAN_TEN}', "");
    Error('\p{Is_Joining_Group: manichaean_ten/a/}');
    Error('\P{Is_Joining_Group: manichaean_ten/a/}');
    Expect(1, 68333, '\p{Is_Joining_Group=manichaeanten}', "");
    Expect(0, 68333, '\p{^Is_Joining_Group=manichaeanten}', "");
    Expect(0, 68333, '\P{Is_Joining_Group=manichaeanten}', "");
    Expect(1, 68333, '\P{^Is_Joining_Group=manichaeanten}', "");
    Expect(0, 68334, '\p{Is_Joining_Group=manichaeanten}', "");
    Expect(1, 68334, '\p{^Is_Joining_Group=manichaeanten}', "");
    Expect(1, 68334, '\P{Is_Joining_Group=manichaeanten}', "");
    Expect(0, 68334, '\P{^Is_Joining_Group=manichaeanten}', "");
    Expect(1, 68333, '\p{Is_Joining_Group=__Manichaean_Ten}', "");
    Expect(0, 68333, '\p{^Is_Joining_Group=__Manichaean_Ten}', "");
    Expect(0, 68333, '\P{Is_Joining_Group=__Manichaean_Ten}', "");
    Expect(1, 68333, '\P{^Is_Joining_Group=__Manichaean_Ten}', "");
    Expect(0, 68334, '\p{Is_Joining_Group=__Manichaean_Ten}', "");
    Expect(1, 68334, '\p{^Is_Joining_Group=__Manichaean_Ten}', "");
    Expect(1, 68334, '\P{Is_Joining_Group=__Manichaean_Ten}', "");
    Expect(0, 68334, '\P{^Is_Joining_Group=__Manichaean_Ten}', "");
    Error('\p{Is_Jg:   _	manichaean_TEN/a/}');
    Error('\P{Is_Jg:   _	manichaean_TEN/a/}');
    Expect(1, 68333, '\p{Is_Jg=manichaeanten}', "");
    Expect(0, 68333, '\p{^Is_Jg=manichaeanten}', "");
    Expect(0, 68333, '\P{Is_Jg=manichaeanten}', "");
    Expect(1, 68333, '\P{^Is_Jg=manichaeanten}', "");
    Expect(0, 68334, '\p{Is_Jg=manichaeanten}', "");
    Expect(1, 68334, '\p{^Is_Jg=manichaeanten}', "");
    Expect(1, 68334, '\P{Is_Jg=manichaeanten}', "");
    Expect(0, 68334, '\P{^Is_Jg=manichaeanten}', "");
    Expect(1, 68333, '\p{Is_Jg=	 Manichaean_Ten}', "");
    Expect(0, 68333, '\p{^Is_Jg=	 Manichaean_Ten}', "");
    Expect(0, 68333, '\P{Is_Jg=	 Manichaean_Ten}', "");
    Expect(1, 68333, '\P{^Is_Jg=	 Manichaean_Ten}', "");
    Expect(0, 68334, '\p{Is_Jg=	 Manichaean_Ten}', "");
    Expect(1, 68334, '\p{^Is_Jg=	 Manichaean_Ten}', "");
    Expect(1, 68334, '\P{Is_Jg=	 Manichaean_Ten}', "");
    Expect(0, 68334, '\P{^Is_Jg=	 Manichaean_Ten}', "");
    Error('\p{Joining_Group=-/a/Manichaean_teth}');
    Error('\P{Joining_Group=-/a/Manichaean_teth}');
    Expect(1, 68302, '\p{Joining_Group=:\AManichaean_Teth\z:}', "");;
    Expect(0, 68303, '\p{Joining_Group=:\AManichaean_Teth\z:}', "");;
    Expect(1, 68302, '\p{Joining_Group: manichaeanteth}', "");
    Expect(0, 68302, '\p{^Joining_Group: manichaeanteth}', "");
    Expect(0, 68302, '\P{Joining_Group: manichaeanteth}', "");
    Expect(1, 68302, '\P{^Joining_Group: manichaeanteth}', "");
    Expect(0, 68303, '\p{Joining_Group: manichaeanteth}', "");
    Expect(1, 68303, '\p{^Joining_Group: manichaeanteth}', "");
    Expect(1, 68303, '\P{Joining_Group: manichaeanteth}', "");
    Expect(0, 68303, '\P{^Joining_Group: manichaeanteth}', "");
    Expect(1, 68302, '\p{Joining_Group=:\Amanichaeanteth\z:}', "");;
    Expect(0, 68303, '\p{Joining_Group=:\Amanichaeanteth\z:}', "");;
    Expect(1, 68302, '\p{Joining_Group=manichaean_TETH}', "");
    Expect(0, 68302, '\p{^Joining_Group=manichaean_TETH}', "");
    Expect(0, 68302, '\P{Joining_Group=manichaean_TETH}', "");
    Expect(1, 68302, '\P{^Joining_Group=manichaean_TETH}', "");
    Expect(0, 68303, '\p{Joining_Group=manichaean_TETH}', "");
    Expect(1, 68303, '\p{^Joining_Group=manichaean_TETH}', "");
    Expect(1, 68303, '\P{Joining_Group=manichaean_TETH}', "");
    Expect(0, 68303, '\P{^Joining_Group=manichaean_TETH}', "");
    Error('\p{Jg=	:=MANICHAEAN_teth}');
    Error('\P{Jg=	:=MANICHAEAN_teth}');
    Expect(1, 68302, '\p{Jg=:\AManichaean_Teth\z:}', "");;
    Expect(0, 68303, '\p{Jg=:\AManichaean_Teth\z:}', "");;
    Expect(1, 68302, '\p{Jg=manichaeanteth}', "");
    Expect(0, 68302, '\p{^Jg=manichaeanteth}', "");
    Expect(0, 68302, '\P{Jg=manichaeanteth}', "");
    Expect(1, 68302, '\P{^Jg=manichaeanteth}', "");
    Expect(0, 68303, '\p{Jg=manichaeanteth}', "");
    Expect(1, 68303, '\p{^Jg=manichaeanteth}', "");
    Expect(1, 68303, '\P{Jg=manichaeanteth}', "");
    Expect(0, 68303, '\P{^Jg=manichaeanteth}', "");
    Expect(1, 68302, '\p{Jg=:\Amanichaeanteth\z:}', "");;
    Expect(0, 68303, '\p{Jg=:\Amanichaeanteth\z:}', "");;
    Expect(1, 68302, '\p{Jg=	-Manichaean_TETH}', "");
    Expect(0, 68302, '\p{^Jg=	-Manichaean_TETH}', "");
    Expect(0, 68302, '\P{Jg=	-Manichaean_TETH}', "");
    Expect(1, 68302, '\P{^Jg=	-Manichaean_TETH}', "");
    Expect(0, 68303, '\p{Jg=	-Manichaean_TETH}', "");
    Expect(1, 68303, '\p{^Jg=	-Manichaean_TETH}', "");
    Expect(1, 68303, '\P{Jg=	-Manichaean_TETH}', "");
    Expect(0, 68303, '\P{^Jg=	-Manichaean_TETH}', "");
    Error('\p{Is_Joining_Group=:=_	manichaean_TETH}');
    Error('\P{Is_Joining_Group=:=_	manichaean_TETH}');
    Expect(1, 68302, '\p{Is_Joining_Group=manichaeanteth}', "");
    Expect(0, 68302, '\p{^Is_Joining_Group=manichaeanteth}', "");
    Expect(0, 68302, '\P{Is_Joining_Group=manichaeanteth}', "");
    Expect(1, 68302, '\P{^Is_Joining_Group=manichaeanteth}', "");
    Expect(0, 68303, '\p{Is_Joining_Group=manichaeanteth}', "");
    Expect(1, 68303, '\p{^Is_Joining_Group=manichaeanteth}', "");
    Expect(1, 68303, '\P{Is_Joining_Group=manichaeanteth}', "");
    Expect(0, 68303, '\P{^Is_Joining_Group=manichaeanteth}', "");
    Expect(1, 68302, '\p{Is_Joining_Group=-Manichaean_Teth}', "");
    Expect(0, 68302, '\p{^Is_Joining_Group=-Manichaean_Teth}', "");
    Expect(0, 68302, '\P{Is_Joining_Group=-Manichaean_Teth}', "");
    Expect(1, 68302, '\P{^Is_Joining_Group=-Manichaean_Teth}', "");
    Expect(0, 68303, '\p{Is_Joining_Group=-Manichaean_Teth}', "");
    Expect(1, 68303, '\p{^Is_Joining_Group=-Manichaean_Teth}', "");
    Expect(1, 68303, '\P{Is_Joining_Group=-Manichaean_Teth}', "");
    Expect(0, 68303, '\P{^Is_Joining_Group=-Manichaean_Teth}', "");
    Error('\p{Is_Jg= :=Manichaean_Teth}');
    Error('\P{Is_Jg= :=Manichaean_Teth}');
    Expect(1, 68302, '\p{Is_Jg=manichaeanteth}', "");
    Expect(0, 68302, '\p{^Is_Jg=manichaeanteth}', "");
    Expect(0, 68302, '\P{Is_Jg=manichaeanteth}', "");
    Expect(1, 68302, '\P{^Is_Jg=manichaeanteth}', "");
    Expect(0, 68303, '\p{Is_Jg=manichaeanteth}', "");
    Expect(1, 68303, '\p{^Is_Jg=manichaeanteth}', "");
    Expect(1, 68303, '\P{Is_Jg=manichaeanteth}', "");
    Expect(0, 68303, '\P{^Is_Jg=manichaeanteth}', "");
    Expect(1, 68302, '\p{Is_Jg=-manichaean_teth}', "");
    Expect(0, 68302, '\p{^Is_Jg=-manichaean_teth}', "");
    Expect(0, 68302, '\P{Is_Jg=-manichaean_teth}', "");
    Expect(1, 68302, '\P{^Is_Jg=-manichaean_teth}', "");
    Expect(0, 68303, '\p{Is_Jg=-manichaean_teth}', "");
    Expect(1, 68303, '\p{^Is_Jg=-manichaean_teth}', "");
    Expect(1, 68303, '\P{Is_Jg=-manichaean_teth}', "");
    Expect(0, 68303, '\P{^Is_Jg=-manichaean_teth}', "");
    Error('\p{Joining_Group=/a/	-manichaean_thamedh}');
    Error('\P{Joining_Group=/a/	-manichaean_thamedh}');
    Expect(1, 68309, '\p{Joining_Group=:\AManichaean_Thamedh\z:}', "");;
    Expect(0, 68310, '\p{Joining_Group=:\AManichaean_Thamedh\z:}', "");;
    Expect(1, 68309, '\p{Joining_Group=manichaeanthamedh}', "");
    Expect(0, 68309, '\p{^Joining_Group=manichaeanthamedh}', "");
    Expect(0, 68309, '\P{Joining_Group=manichaeanthamedh}', "");
    Expect(1, 68309, '\P{^Joining_Group=manichaeanthamedh}', "");
    Expect(0, 68310, '\p{Joining_Group=manichaeanthamedh}', "");
    Expect(1, 68310, '\p{^Joining_Group=manichaeanthamedh}', "");
    Expect(1, 68310, '\P{Joining_Group=manichaeanthamedh}', "");
    Expect(0, 68310, '\P{^Joining_Group=manichaeanthamedh}', "");
    Expect(1, 68309, '\p{Joining_Group=:\Amanichaeanthamedh\z:}', "");;
    Expect(0, 68310, '\p{Joining_Group=:\Amanichaeanthamedh\z:}', "");;
    Expect(1, 68309, '\p{Joining_Group=__manichaean_thamedh}', "");
    Expect(0, 68309, '\p{^Joining_Group=__manichaean_thamedh}', "");
    Expect(0, 68309, '\P{Joining_Group=__manichaean_thamedh}', "");
    Expect(1, 68309, '\P{^Joining_Group=__manichaean_thamedh}', "");
    Expect(0, 68310, '\p{Joining_Group=__manichaean_thamedh}', "");
    Expect(1, 68310, '\p{^Joining_Group=__manichaean_thamedh}', "");
    Expect(1, 68310, '\P{Joining_Group=__manichaean_thamedh}', "");
    Expect(0, 68310, '\P{^Joining_Group=__manichaean_thamedh}', "");
    Error('\p{Jg=-/a/Manichaean_Thamedh}');
    Error('\P{Jg=-/a/Manichaean_Thamedh}');
    Expect(1, 68309, '\p{Jg=:\AManichaean_Thamedh\z:}', "");;
    Expect(0, 68310, '\p{Jg=:\AManichaean_Thamedh\z:}', "");;
    Expect(1, 68309, '\p{Jg=manichaeanthamedh}', "");
    Expect(0, 68309, '\p{^Jg=manichaeanthamedh}', "");
    Expect(0, 68309, '\P{Jg=manichaeanthamedh}', "");
    Expect(1, 68309, '\P{^Jg=manichaeanthamedh}', "");
    Expect(0, 68310, '\p{Jg=manichaeanthamedh}', "");
    Expect(1, 68310, '\p{^Jg=manichaeanthamedh}', "");
    Expect(1, 68310, '\P{Jg=manichaeanthamedh}', "");
    Expect(0, 68310, '\P{^Jg=manichaeanthamedh}', "");
    Expect(1, 68309, '\p{Jg=:\Amanichaeanthamedh\z:}', "");;
    Expect(0, 68310, '\p{Jg=:\Amanichaeanthamedh\z:}', "");;
    Expect(1, 68309, '\p{Jg=- Manichaean_THAMEDH}', "");
    Expect(0, 68309, '\p{^Jg=- Manichaean_THAMEDH}', "");
    Expect(0, 68309, '\P{Jg=- Manichaean_THAMEDH}', "");
    Expect(1, 68309, '\P{^Jg=- Manichaean_THAMEDH}', "");
    Expect(0, 68310, '\p{Jg=- Manichaean_THAMEDH}', "");
    Expect(1, 68310, '\p{^Jg=- Manichaean_THAMEDH}', "");
    Expect(1, 68310, '\P{Jg=- Manichaean_THAMEDH}', "");
    Expect(0, 68310, '\P{^Jg=- Manichaean_THAMEDH}', "");
    Error('\p{Is_Joining_Group= _Manichaean_THAMEDH/a/}');
    Error('\P{Is_Joining_Group= _Manichaean_THAMEDH/a/}');
    Expect(1, 68309, '\p{Is_Joining_Group=manichaeanthamedh}', "");
    Expect(0, 68309, '\p{^Is_Joining_Group=manichaeanthamedh}', "");
    Expect(0, 68309, '\P{Is_Joining_Group=manichaeanthamedh}', "");
    Expect(1, 68309, '\P{^Is_Joining_Group=manichaeanthamedh}', "");
    Expect(0, 68310, '\p{Is_Joining_Group=manichaeanthamedh}', "");
    Expect(1, 68310, '\p{^Is_Joining_Group=manichaeanthamedh}', "");
    Expect(1, 68310, '\P{Is_Joining_Group=manichaeanthamedh}', "");
    Expect(0, 68310, '\P{^Is_Joining_Group=manichaeanthamedh}', "");
    Expect(1, 68309, '\p{Is_Joining_Group:   _manichaean_Thamedh}', "");
    Expect(0, 68309, '\p{^Is_Joining_Group:   _manichaean_Thamedh}', "");
    Expect(0, 68309, '\P{Is_Joining_Group:   _manichaean_Thamedh}', "");
    Expect(1, 68309, '\P{^Is_Joining_Group:   _manichaean_Thamedh}', "");
    Expect(0, 68310, '\p{Is_Joining_Group:   _manichaean_Thamedh}', "");
    Expect(1, 68310, '\p{^Is_Joining_Group:   _manichaean_Thamedh}', "");
    Expect(1, 68310, '\P{Is_Joining_Group:   _manichaean_Thamedh}', "");
    Expect(0, 68310, '\P{^Is_Joining_Group:   _manichaean_Thamedh}', "");
    Error('\p{Is_Jg=:=MANICHAEAN_Thamedh}');
    Error('\P{Is_Jg=:=MANICHAEAN_Thamedh}');
    Expect(1, 68309, '\p{Is_Jg=manichaeanthamedh}', "");
    Expect(0, 68309, '\p{^Is_Jg=manichaeanthamedh}', "");
    Expect(0, 68309, '\P{Is_Jg=manichaeanthamedh}', "");
    Expect(1, 68309, '\P{^Is_Jg=manichaeanthamedh}', "");
    Expect(0, 68310, '\p{Is_Jg=manichaeanthamedh}', "");
    Expect(1, 68310, '\p{^Is_Jg=manichaeanthamedh}', "");
    Expect(1, 68310, '\P{Is_Jg=manichaeanthamedh}', "");
    Expect(0, 68310, '\P{^Is_Jg=manichaeanthamedh}', "");
    Expect(1, 68309, '\p{Is_Jg= Manichaean_Thamedh}', "");
    Expect(0, 68309, '\p{^Is_Jg= Manichaean_Thamedh}', "");
    Expect(0, 68309, '\P{Is_Jg= Manichaean_Thamedh}', "");
    Expect(1, 68309, '\P{^Is_Jg= Manichaean_Thamedh}', "");
    Expect(0, 68310, '\p{Is_Jg= Manichaean_Thamedh}', "");
    Expect(1, 68310, '\p{^Is_Jg= Manichaean_Thamedh}', "");
    Expect(1, 68310, '\P{Is_Jg= Manichaean_Thamedh}', "");
    Expect(0, 68310, '\P{^Is_Jg= Manichaean_Thamedh}', "");
    Error('\p{Joining_Group=-_Manichaean_TWENTY/a/}');
    Error('\P{Joining_Group=-_Manichaean_TWENTY/a/}');
    Expect(1, 68334, '\p{Joining_Group=:\AManichaean_Twenty\z:}', "");;
    Expect(0, 68335, '\p{Joining_Group=:\AManichaean_Twenty\z:}', "");;
    Expect(1, 68334, '\p{Joining_Group=manichaeantwenty}', "");
    Expect(0, 68334, '\p{^Joining_Group=manichaeantwenty}', "");
    Expect(0, 68334, '\P{Joining_Group=manichaeantwenty}', "");
    Expect(1, 68334, '\P{^Joining_Group=manichaeantwenty}', "");
    Expect(0, 68335, '\p{Joining_Group=manichaeantwenty}', "");
    Expect(1, 68335, '\p{^Joining_Group=manichaeantwenty}', "");
    Expect(1, 68335, '\P{Joining_Group=manichaeantwenty}', "");
    Expect(0, 68335, '\P{^Joining_Group=manichaeantwenty}', "");
    Expect(1, 68334, '\p{Joining_Group=:\Amanichaeantwenty\z:}', "");;
    Expect(0, 68335, '\p{Joining_Group=:\Amanichaeantwenty\z:}', "");;
    Expect(1, 68334, '\p{Joining_Group= MANICHAEAN_twenty}', "");
    Expect(0, 68334, '\p{^Joining_Group= MANICHAEAN_twenty}', "");
    Expect(0, 68334, '\P{Joining_Group= MANICHAEAN_twenty}', "");
    Expect(1, 68334, '\P{^Joining_Group= MANICHAEAN_twenty}', "");
    Expect(0, 68335, '\p{Joining_Group= MANICHAEAN_twenty}', "");
    Expect(1, 68335, '\p{^Joining_Group= MANICHAEAN_twenty}', "");
    Expect(1, 68335, '\P{Joining_Group= MANICHAEAN_twenty}', "");
    Expect(0, 68335, '\P{^Joining_Group= MANICHAEAN_twenty}', "");
    Error('\p{Jg=-manichaean_Twenty:=}');
    Error('\P{Jg=-manichaean_Twenty:=}');
    Expect(1, 68334, '\p{Jg=:\AManichaean_Twenty\z:}', "");;
    Expect(0, 68335, '\p{Jg=:\AManichaean_Twenty\z:}', "");;
    Expect(1, 68334, '\p{Jg=manichaeantwenty}', "");
    Expect(0, 68334, '\p{^Jg=manichaeantwenty}', "");
    Expect(0, 68334, '\P{Jg=manichaeantwenty}', "");
    Expect(1, 68334, '\P{^Jg=manichaeantwenty}', "");
    Expect(0, 68335, '\p{Jg=manichaeantwenty}', "");
    Expect(1, 68335, '\p{^Jg=manichaeantwenty}', "");
    Expect(1, 68335, '\P{Jg=manichaeantwenty}', "");
    Expect(0, 68335, '\P{^Jg=manichaeantwenty}', "");
    Expect(1, 68334, '\p{Jg=:\Amanichaeantwenty\z:}', "");;
    Expect(0, 68335, '\p{Jg=:\Amanichaeantwenty\z:}', "");;
    Expect(1, 68334, '\p{Jg= 	Manichaean_Twenty}', "");
    Expect(0, 68334, '\p{^Jg= 	Manichaean_Twenty}', "");
    Expect(0, 68334, '\P{Jg= 	Manichaean_Twenty}', "");
    Expect(1, 68334, '\P{^Jg= 	Manichaean_Twenty}', "");
    Expect(0, 68335, '\p{Jg= 	Manichaean_Twenty}', "");
    Expect(1, 68335, '\p{^Jg= 	Manichaean_Twenty}', "");
    Expect(1, 68335, '\P{Jg= 	Manichaean_Twenty}', "");
    Expect(0, 68335, '\P{^Jg= 	Manichaean_Twenty}', "");
    Error('\p{Is_Joining_Group=/a/- Manichaean_TWENTY}');
    Error('\P{Is_Joining_Group=/a/- Manichaean_TWENTY}');
    Expect(1, 68334, '\p{Is_Joining_Group=manichaeantwenty}', "");
    Expect(0, 68334, '\p{^Is_Joining_Group=manichaeantwenty}', "");
    Expect(0, 68334, '\P{Is_Joining_Group=manichaeantwenty}', "");
    Expect(1, 68334, '\P{^Is_Joining_Group=manichaeantwenty}', "");
    Expect(0, 68335, '\p{Is_Joining_Group=manichaeantwenty}', "");
    Expect(1, 68335, '\p{^Is_Joining_Group=manichaeantwenty}', "");
    Expect(1, 68335, '\P{Is_Joining_Group=manichaeantwenty}', "");
    Expect(0, 68335, '\P{^Is_Joining_Group=manichaeantwenty}', "");
    Expect(1, 68334, '\p{Is_Joining_Group=	-manichaean_Twenty}', "");
    Expect(0, 68334, '\p{^Is_Joining_Group=	-manichaean_Twenty}', "");
    Expect(0, 68334, '\P{Is_Joining_Group=	-manichaean_Twenty}', "");
    Expect(1, 68334, '\P{^Is_Joining_Group=	-manichaean_Twenty}', "");
    Expect(0, 68335, '\p{Is_Joining_Group=	-manichaean_Twenty}', "");
    Expect(1, 68335, '\p{^Is_Joining_Group=	-manichaean_Twenty}', "");
    Expect(1, 68335, '\P{Is_Joining_Group=	-manichaean_Twenty}', "");
    Expect(0, 68335, '\P{^Is_Joining_Group=	-manichaean_Twenty}', "");
    Error('\p{Is_Jg=:=__Manichaean_Twenty}');
    Error('\P{Is_Jg=:=__Manichaean_Twenty}');
    Expect(1, 68334, '\p{Is_Jg=manichaeantwenty}', "");
    Expect(0, 68334, '\p{^Is_Jg=manichaeantwenty}', "");
    Expect(0, 68334, '\P{Is_Jg=manichaeantwenty}', "");
    Expect(1, 68334, '\P{^Is_Jg=manichaeantwenty}', "");
    Expect(0, 68335, '\p{Is_Jg=manichaeantwenty}', "");
    Expect(1, 68335, '\p{^Is_Jg=manichaeantwenty}', "");
    Expect(1, 68335, '\P{Is_Jg=manichaeantwenty}', "");
    Expect(0, 68335, '\P{^Is_Jg=manichaeantwenty}', "");
    Expect(1, 68334, '\p{Is_Jg=__MANICHAEAN_TWENTY}', "");
    Expect(0, 68334, '\p{^Is_Jg=__MANICHAEAN_TWENTY}', "");
    Expect(0, 68334, '\P{Is_Jg=__MANICHAEAN_TWENTY}', "");
    Expect(1, 68334, '\P{^Is_Jg=__MANICHAEAN_TWENTY}', "");
    Expect(0, 68335, '\p{Is_Jg=__MANICHAEAN_TWENTY}', "");
    Expect(1, 68335, '\p{^Is_Jg=__MANICHAEAN_TWENTY}', "");
    Expect(1, 68335, '\P{Is_Jg=__MANICHAEAN_TWENTY}', "");
    Expect(0, 68335, '\P{^Is_Jg=__MANICHAEAN_TWENTY}', "");
    Error('\p{Joining_Group= /a/Manichaean_Waw}');
    Error('\P{Joining_Group= /a/Manichaean_Waw}');
    Expect(1, 68295, '\p{Joining_Group=:\AManichaean_Waw\z:}', "");;
    Expect(0, 68296, '\p{Joining_Group=:\AManichaean_Waw\z:}', "");;
    Expect(1, 68295, '\p{Joining_Group=manichaeanwaw}', "");
    Expect(0, 68295, '\p{^Joining_Group=manichaeanwaw}', "");
    Expect(0, 68295, '\P{Joining_Group=manichaeanwaw}', "");
    Expect(1, 68295, '\P{^Joining_Group=manichaeanwaw}', "");
    Expect(0, 68296, '\p{Joining_Group=manichaeanwaw}', "");
    Expect(1, 68296, '\p{^Joining_Group=manichaeanwaw}', "");
    Expect(1, 68296, '\P{Joining_Group=manichaeanwaw}', "");
    Expect(0, 68296, '\P{^Joining_Group=manichaeanwaw}', "");
    Expect(1, 68295, '\p{Joining_Group=:\Amanichaeanwaw\z:}', "");;
    Expect(0, 68296, '\p{Joining_Group=:\Amanichaeanwaw\z:}', "");;
    Expect(1, 68295, '\p{Joining_Group=-manichaean_WAW}', "");
    Expect(0, 68295, '\p{^Joining_Group=-manichaean_WAW}', "");
    Expect(0, 68295, '\P{Joining_Group=-manichaean_WAW}', "");
    Expect(1, 68295, '\P{^Joining_Group=-manichaean_WAW}', "");
    Expect(0, 68296, '\p{Joining_Group=-manichaean_WAW}', "");
    Expect(1, 68296, '\p{^Joining_Group=-manichaean_WAW}', "");
    Expect(1, 68296, '\P{Joining_Group=-manichaean_WAW}', "");
    Expect(0, 68296, '\P{^Joining_Group=-manichaean_WAW}', "");
    Error('\p{Jg= :=MANICHAEAN_Waw}');
    Error('\P{Jg= :=MANICHAEAN_Waw}');
    Expect(1, 68295, '\p{Jg=:\AManichaean_Waw\z:}', "");;
    Expect(0, 68296, '\p{Jg=:\AManichaean_Waw\z:}', "");;
    Expect(1, 68295, '\p{Jg=manichaeanwaw}', "");
    Expect(0, 68295, '\p{^Jg=manichaeanwaw}', "");
    Expect(0, 68295, '\P{Jg=manichaeanwaw}', "");
    Expect(1, 68295, '\P{^Jg=manichaeanwaw}', "");
    Expect(0, 68296, '\p{Jg=manichaeanwaw}', "");
    Expect(1, 68296, '\p{^Jg=manichaeanwaw}', "");
    Expect(1, 68296, '\P{Jg=manichaeanwaw}', "");
    Expect(0, 68296, '\P{^Jg=manichaeanwaw}', "");
    Expect(1, 68295, '\p{Jg=:\Amanichaeanwaw\z:}', "");;
    Expect(0, 68296, '\p{Jg=:\Amanichaeanwaw\z:}', "");;
    Expect(1, 68295, '\p{Jg= MANICHAEAN_Waw}', "");
    Expect(0, 68295, '\p{^Jg= MANICHAEAN_Waw}', "");
    Expect(0, 68295, '\P{Jg= MANICHAEAN_Waw}', "");
    Expect(1, 68295, '\P{^Jg= MANICHAEAN_Waw}', "");
    Expect(0, 68296, '\p{Jg= MANICHAEAN_Waw}', "");
    Expect(1, 68296, '\p{^Jg= MANICHAEAN_Waw}', "");
    Expect(1, 68296, '\P{Jg= MANICHAEAN_Waw}', "");
    Expect(0, 68296, '\P{^Jg= MANICHAEAN_Waw}', "");
    Error('\p{Is_Joining_Group::=_-Manichaean_WAW}');
    Error('\P{Is_Joining_Group::=_-Manichaean_WAW}');
    Expect(1, 68295, '\p{Is_Joining_Group=manichaeanwaw}', "");
    Expect(0, 68295, '\p{^Is_Joining_Group=manichaeanwaw}', "");
    Expect(0, 68295, '\P{Is_Joining_Group=manichaeanwaw}', "");
    Expect(1, 68295, '\P{^Is_Joining_Group=manichaeanwaw}', "");
    Expect(0, 68296, '\p{Is_Joining_Group=manichaeanwaw}', "");
    Expect(1, 68296, '\p{^Is_Joining_Group=manichaeanwaw}', "");
    Expect(1, 68296, '\P{Is_Joining_Group=manichaeanwaw}', "");
    Expect(0, 68296, '\P{^Is_Joining_Group=manichaeanwaw}', "");
    Expect(1, 68295, '\p{Is_Joining_Group=MANICHAEAN_WAW}', "");
    Expect(0, 68295, '\p{^Is_Joining_Group=MANICHAEAN_WAW}', "");
    Expect(0, 68295, '\P{Is_Joining_Group=MANICHAEAN_WAW}', "");
    Expect(1, 68295, '\P{^Is_Joining_Group=MANICHAEAN_WAW}', "");
    Expect(0, 68296, '\p{Is_Joining_Group=MANICHAEAN_WAW}', "");
    Expect(1, 68296, '\p{^Is_Joining_Group=MANICHAEAN_WAW}', "");
    Expect(1, 68296, '\P{Is_Joining_Group=MANICHAEAN_WAW}', "");
    Expect(0, 68296, '\P{^Is_Joining_Group=MANICHAEAN_WAW}', "");
    Error('\p{Is_Jg=-/a/Manichaean_Waw}');
    Error('\P{Is_Jg=-/a/Manichaean_Waw}');
    Expect(1, 68295, '\p{Is_Jg:manichaeanwaw}', "");
    Expect(0, 68295, '\p{^Is_Jg:manichaeanwaw}', "");
    Expect(0, 68295, '\P{Is_Jg:manichaeanwaw}', "");
    Expect(1, 68295, '\P{^Is_Jg:manichaeanwaw}', "");
    Expect(0, 68296, '\p{Is_Jg:manichaeanwaw}', "");
    Expect(1, 68296, '\p{^Is_Jg:manichaeanwaw}', "");
    Expect(1, 68296, '\P{Is_Jg:manichaeanwaw}', "");
    Expect(0, 68296, '\P{^Is_Jg:manichaeanwaw}', "");
    Expect(1, 68295, '\p{Is_Jg=  Manichaean_Waw}', "");
    Expect(0, 68295, '\p{^Is_Jg=  Manichaean_Waw}', "");
    Expect(0, 68295, '\P{Is_Jg=  Manichaean_Waw}', "");
    Expect(1, 68295, '\P{^Is_Jg=  Manichaean_Waw}', "");
    Expect(0, 68296, '\p{Is_Jg=  Manichaean_Waw}', "");
    Expect(1, 68296, '\p{^Is_Jg=  Manichaean_Waw}', "");
    Expect(1, 68296, '\P{Is_Jg=  Manichaean_Waw}', "");
    Expect(0, 68296, '\P{^Is_Jg=  Manichaean_Waw}', "");
    Error('\p{Joining_Group=-/a/Manichaean_yodh}');
    Error('\P{Joining_Group=-/a/Manichaean_yodh}');
    Expect(1, 68303, '\p{Joining_Group=:\AManichaean_Yodh\z:}', "");;
    Expect(0, 68304, '\p{Joining_Group=:\AManichaean_Yodh\z:}', "");;
    Expect(1, 68303, '\p{Joining_Group=manichaeanyodh}', "");
    Expect(0, 68303, '\p{^Joining_Group=manichaeanyodh}', "");
    Expect(0, 68303, '\P{Joining_Group=manichaeanyodh}', "");
    Expect(1, 68303, '\P{^Joining_Group=manichaeanyodh}', "");
    Expect(0, 68304, '\p{Joining_Group=manichaeanyodh}', "");
    Expect(1, 68304, '\p{^Joining_Group=manichaeanyodh}', "");
    Expect(1, 68304, '\P{Joining_Group=manichaeanyodh}', "");
    Expect(0, 68304, '\P{^Joining_Group=manichaeanyodh}', "");
    Expect(1, 68303, '\p{Joining_Group=:\Amanichaeanyodh\z:}', "");;
    Expect(0, 68304, '\p{Joining_Group=:\Amanichaeanyodh\z:}', "");;
    Expect(1, 68303, '\p{Joining_Group=_-Manichaean_yodh}', "");
    Expect(0, 68303, '\p{^Joining_Group=_-Manichaean_yodh}', "");
    Expect(0, 68303, '\P{Joining_Group=_-Manichaean_yodh}', "");
    Expect(1, 68303, '\P{^Joining_Group=_-Manichaean_yodh}', "");
    Expect(0, 68304, '\p{Joining_Group=_-Manichaean_yodh}', "");
    Expect(1, 68304, '\p{^Joining_Group=_-Manichaean_yodh}', "");
    Expect(1, 68304, '\P{Joining_Group=_-Manichaean_yodh}', "");
    Expect(0, 68304, '\P{^Joining_Group=_-Manichaean_yodh}', "");
    Error('\p{Jg=/a/Manichaean_Yodh}');
    Error('\P{Jg=/a/Manichaean_Yodh}');
    Expect(1, 68303, '\p{Jg=:\AManichaean_Yodh\z:}', "");;
    Expect(0, 68304, '\p{Jg=:\AManichaean_Yodh\z:}', "");;
    Expect(1, 68303, '\p{Jg=manichaeanyodh}', "");
    Expect(0, 68303, '\p{^Jg=manichaeanyodh}', "");
    Expect(0, 68303, '\P{Jg=manichaeanyodh}', "");
    Expect(1, 68303, '\P{^Jg=manichaeanyodh}', "");
    Expect(0, 68304, '\p{Jg=manichaeanyodh}', "");
    Expect(1, 68304, '\p{^Jg=manichaeanyodh}', "");
    Expect(1, 68304, '\P{Jg=manichaeanyodh}', "");
    Expect(0, 68304, '\P{^Jg=manichaeanyodh}', "");
    Expect(1, 68303, '\p{Jg=:\Amanichaeanyodh\z:}', "");;
    Expect(0, 68304, '\p{Jg=:\Amanichaeanyodh\z:}', "");;
    Expect(1, 68303, '\p{Jg=		Manichaean_Yodh}', "");
    Expect(0, 68303, '\p{^Jg=		Manichaean_Yodh}', "");
    Expect(0, 68303, '\P{Jg=		Manichaean_Yodh}', "");
    Expect(1, 68303, '\P{^Jg=		Manichaean_Yodh}', "");
    Expect(0, 68304, '\p{Jg=		Manichaean_Yodh}', "");
    Expect(1, 68304, '\p{^Jg=		Manichaean_Yodh}', "");
    Expect(1, 68304, '\P{Jg=		Manichaean_Yodh}', "");
    Expect(0, 68304, '\P{^Jg=		Manichaean_Yodh}', "");
    Error('\p{Is_Joining_Group=	 Manichaean_Yodh/a/}');
    Error('\P{Is_Joining_Group=	 Manichaean_Yodh/a/}');
    Expect(1, 68303, '\p{Is_Joining_Group=manichaeanyodh}', "");
    Expect(0, 68303, '\p{^Is_Joining_Group=manichaeanyodh}', "");
    Expect(0, 68303, '\P{Is_Joining_Group=manichaeanyodh}', "");
    Expect(1, 68303, '\P{^Is_Joining_Group=manichaeanyodh}', "");
    Expect(0, 68304, '\p{Is_Joining_Group=manichaeanyodh}', "");
    Expect(1, 68304, '\p{^Is_Joining_Group=manichaeanyodh}', "");
    Expect(1, 68304, '\P{Is_Joining_Group=manichaeanyodh}', "");
    Expect(0, 68304, '\P{^Is_Joining_Group=manichaeanyodh}', "");
    Expect(1, 68303, '\p{Is_Joining_Group=-Manichaean_Yodh}', "");
    Expect(0, 68303, '\p{^Is_Joining_Group=-Manichaean_Yodh}', "");
    Expect(0, 68303, '\P{Is_Joining_Group=-Manichaean_Yodh}', "");
    Expect(1, 68303, '\P{^Is_Joining_Group=-Manichaean_Yodh}', "");
    Expect(0, 68304, '\p{Is_Joining_Group=-Manichaean_Yodh}', "");
    Expect(1, 68304, '\p{^Is_Joining_Group=-Manichaean_Yodh}', "");
    Expect(1, 68304, '\P{Is_Joining_Group=-Manichaean_Yodh}', "");
    Expect(0, 68304, '\P{^Is_Joining_Group=-Manichaean_Yodh}', "");
    Error('\p{Is_Jg=Manichaean_YODH:=}');
    Error('\P{Is_Jg=Manichaean_YODH:=}');
    Expect(1, 68303, '\p{Is_Jg=manichaeanyodh}', "");
    Expect(0, 68303, '\p{^Is_Jg=manichaeanyodh}', "");
    Expect(0, 68303, '\P{Is_Jg=manichaeanyodh}', "");
    Expect(1, 68303, '\P{^Is_Jg=manichaeanyodh}', "");
    Expect(0, 68304, '\p{Is_Jg=manichaeanyodh}', "");
    Expect(1, 68304, '\p{^Is_Jg=manichaeanyodh}', "");
    Expect(1, 68304, '\P{Is_Jg=manichaeanyodh}', "");
    Expect(0, 68304, '\P{^Is_Jg=manichaeanyodh}', "");
    Expect(1, 68303, '\p{Is_Jg=_Manichaean_Yodh}', "");
    Expect(0, 68303, '\p{^Is_Jg=_Manichaean_Yodh}', "");
    Expect(0, 68303, '\P{Is_Jg=_Manichaean_Yodh}', "");
    Expect(1, 68303, '\P{^Is_Jg=_Manichaean_Yodh}', "");
    Expect(0, 68304, '\p{Is_Jg=_Manichaean_Yodh}', "");
    Expect(1, 68304, '\p{^Is_Jg=_Manichaean_Yodh}', "");
    Expect(1, 68304, '\P{Is_Jg=_Manichaean_Yodh}', "");
    Expect(0, 68304, '\P{^Is_Jg=_Manichaean_Yodh}', "");
    Error('\p{Joining_Group=_/a/Manichaean_Zayin}');
    Error('\P{Joining_Group=_/a/Manichaean_Zayin}');
    Expect(1, 68298, '\p{Joining_Group=:\AManichaean_Zayin\z:}', "");;
    Expect(0, 68299, '\p{Joining_Group=:\AManichaean_Zayin\z:}', "");;
    Expect(1, 68298, '\p{Joining_Group=manichaeanzayin}', "");
    Expect(0, 68298, '\p{^Joining_Group=manichaeanzayin}', "");
    Expect(0, 68298, '\P{Joining_Group=manichaeanzayin}', "");
    Expect(1, 68298, '\P{^Joining_Group=manichaeanzayin}', "");
    Expect(0, 68299, '\p{Joining_Group=manichaeanzayin}', "");
    Expect(1, 68299, '\p{^Joining_Group=manichaeanzayin}', "");
    Expect(1, 68299, '\P{Joining_Group=manichaeanzayin}', "");
    Expect(0, 68299, '\P{^Joining_Group=manichaeanzayin}', "");
    Expect(1, 68298, '\p{Joining_Group=:\Amanichaeanzayin\z:}', "");;
    Expect(0, 68299, '\p{Joining_Group=:\Amanichaeanzayin\z:}', "");;
    Expect(1, 68298, '\p{Joining_Group=-Manichaean_Zayin}', "");
    Expect(0, 68298, '\p{^Joining_Group=-Manichaean_Zayin}', "");
    Expect(0, 68298, '\P{Joining_Group=-Manichaean_Zayin}', "");
    Expect(1, 68298, '\P{^Joining_Group=-Manichaean_Zayin}', "");
    Expect(0, 68299, '\p{Joining_Group=-Manichaean_Zayin}', "");
    Expect(1, 68299, '\p{^Joining_Group=-Manichaean_Zayin}', "");
    Expect(1, 68299, '\P{Joining_Group=-Manichaean_Zayin}', "");
    Expect(0, 68299, '\P{^Joining_Group=-Manichaean_Zayin}', "");
    Error('\p{Jg=:=_-Manichaean_Zayin}');
    Error('\P{Jg=:=_-Manichaean_Zayin}');
    Expect(1, 68298, '\p{Jg=:\AManichaean_Zayin\z:}', "");;
    Expect(0, 68299, '\p{Jg=:\AManichaean_Zayin\z:}', "");;
    Expect(1, 68298, '\p{Jg=manichaeanzayin}', "");
    Expect(0, 68298, '\p{^Jg=manichaeanzayin}', "");
    Expect(0, 68298, '\P{Jg=manichaeanzayin}', "");
    Expect(1, 68298, '\P{^Jg=manichaeanzayin}', "");
    Expect(0, 68299, '\p{Jg=manichaeanzayin}', "");
    Expect(1, 68299, '\p{^Jg=manichaeanzayin}', "");
    Expect(1, 68299, '\P{Jg=manichaeanzayin}', "");
    Expect(0, 68299, '\P{^Jg=manichaeanzayin}', "");
    Expect(1, 68298, '\p{Jg=:\Amanichaeanzayin\z:}', "");;
    Expect(0, 68299, '\p{Jg=:\Amanichaeanzayin\z:}', "");;
    Expect(1, 68298, '\p{Jg=	_Manichaean_Zayin}', "");
    Expect(0, 68298, '\p{^Jg=	_Manichaean_Zayin}', "");
    Expect(0, 68298, '\P{Jg=	_Manichaean_Zayin}', "");
    Expect(1, 68298, '\P{^Jg=	_Manichaean_Zayin}', "");
    Expect(0, 68299, '\p{Jg=	_Manichaean_Zayin}', "");
    Expect(1, 68299, '\p{^Jg=	_Manichaean_Zayin}', "");
    Expect(1, 68299, '\P{Jg=	_Manichaean_Zayin}', "");
    Expect(0, 68299, '\P{^Jg=	_Manichaean_Zayin}', "");
    Error('\p{Is_Joining_Group=-:=MANICHAEAN_ZAYIN}');
    Error('\P{Is_Joining_Group=-:=MANICHAEAN_ZAYIN}');
    Expect(1, 68298, '\p{Is_Joining_Group=manichaeanzayin}', "");
    Expect(0, 68298, '\p{^Is_Joining_Group=manichaeanzayin}', "");
    Expect(0, 68298, '\P{Is_Joining_Group=manichaeanzayin}', "");
    Expect(1, 68298, '\P{^Is_Joining_Group=manichaeanzayin}', "");
    Expect(0, 68299, '\p{Is_Joining_Group=manichaeanzayin}', "");
    Expect(1, 68299, '\p{^Is_Joining_Group=manichaeanzayin}', "");
    Expect(1, 68299, '\P{Is_Joining_Group=manichaeanzayin}', "");
    Expect(0, 68299, '\P{^Is_Joining_Group=manichaeanzayin}', "");
    Expect(1, 68298, '\p{Is_Joining_Group=-Manichaean_ZAYIN}', "");
    Expect(0, 68298, '\p{^Is_Joining_Group=-Manichaean_ZAYIN}', "");
    Expect(0, 68298, '\P{Is_Joining_Group=-Manichaean_ZAYIN}', "");
    Expect(1, 68298, '\P{^Is_Joining_Group=-Manichaean_ZAYIN}', "");
    Expect(0, 68299, '\p{Is_Joining_Group=-Manichaean_ZAYIN}', "");
    Expect(1, 68299, '\p{^Is_Joining_Group=-Manichaean_ZAYIN}', "");
    Expect(1, 68299, '\P{Is_Joining_Group=-Manichaean_ZAYIN}', "");
    Expect(0, 68299, '\P{^Is_Joining_Group=-Manichaean_ZAYIN}', "");
    Error('\p{Is_Jg=:=_MANICHAEAN_Zayin}');
    Error('\P{Is_Jg=:=_MANICHAEAN_Zayin}');
    Expect(1, 68298, '\p{Is_Jg=manichaeanzayin}', "");
    Expect(0, 68298, '\p{^Is_Jg=manichaeanzayin}', "");
    Expect(0, 68298, '\P{Is_Jg=manichaeanzayin}', "");
    Expect(1, 68298, '\P{^Is_Jg=manichaeanzayin}', "");
    Expect(0, 68299, '\p{Is_Jg=manichaeanzayin}', "");
    Expect(1, 68299, '\p{^Is_Jg=manichaeanzayin}', "");
    Expect(1, 68299, '\P{Is_Jg=manichaeanzayin}', "");
    Expect(0, 68299, '\P{^Is_Jg=manichaeanzayin}', "");
    Expect(1, 68298, '\p{Is_Jg=_Manichaean_Zayin}', "");
    Expect(0, 68298, '\p{^Is_Jg=_Manichaean_Zayin}', "");
    Expect(0, 68298, '\P{Is_Jg=_Manichaean_Zayin}', "");
    Expect(1, 68298, '\P{^Is_Jg=_Manichaean_Zayin}', "");
    Expect(0, 68299, '\p{Is_Jg=_Manichaean_Zayin}', "");
    Expect(1, 68299, '\p{^Is_Jg=_Manichaean_Zayin}', "");
    Expect(1, 68299, '\P{Is_Jg=_Manichaean_Zayin}', "");
    Expect(0, 68299, '\P{^Is_Jg=_Manichaean_Zayin}', "");
    Error('\p{Joining_Group=:=MEEM}');
    Error('\P{Joining_Group=:=MEEM}');
    Expect(1, 2215, '\p{Joining_Group=:\AMeem\z:}', "");;
    Expect(0, 2216, '\p{Joining_Group=:\AMeem\z:}', "");;
    Expect(1, 2215, '\p{Joining_Group=meem}', "");
    Expect(0, 2215, '\p{^Joining_Group=meem}', "");
    Expect(0, 2215, '\P{Joining_Group=meem}', "");
    Expect(1, 2215, '\P{^Joining_Group=meem}', "");
    Expect(0, 2216, '\p{Joining_Group=meem}', "");
    Expect(1, 2216, '\p{^Joining_Group=meem}', "");
    Expect(1, 2216, '\P{Joining_Group=meem}', "");
    Expect(0, 2216, '\P{^Joining_Group=meem}', "");
    Expect(1, 2215, '\p{Joining_Group=:\Ameem\z:}', "");;
    Expect(0, 2216, '\p{Joining_Group=:\Ameem\z:}', "");;
    Expect(1, 2215, '\p{Joining_Group= -Meem}', "");
    Expect(0, 2215, '\p{^Joining_Group= -Meem}', "");
    Expect(0, 2215, '\P{Joining_Group= -Meem}', "");
    Expect(1, 2215, '\P{^Joining_Group= -Meem}', "");
    Expect(0, 2216, '\p{Joining_Group= -Meem}', "");
    Expect(1, 2216, '\p{^Joining_Group= -Meem}', "");
    Expect(1, 2216, '\P{Joining_Group= -Meem}', "");
    Expect(0, 2216, '\P{^Joining_Group= -Meem}', "");
    Error('\p{Jg=	/a/Meem}');
    Error('\P{Jg=	/a/Meem}');
    Expect(1, 2215, '\p{Jg=:\AMeem\z:}', "");;
    Expect(0, 2216, '\p{Jg=:\AMeem\z:}', "");;
    Expect(1, 2215, '\p{Jg=meem}', "");
    Expect(0, 2215, '\p{^Jg=meem}', "");
    Expect(0, 2215, '\P{Jg=meem}', "");
    Expect(1, 2215, '\P{^Jg=meem}', "");
    Expect(0, 2216, '\p{Jg=meem}', "");
    Expect(1, 2216, '\p{^Jg=meem}', "");
    Expect(1, 2216, '\P{Jg=meem}', "");
    Expect(0, 2216, '\P{^Jg=meem}', "");
    Expect(1, 2215, '\p{Jg=:\Ameem\z:}', "");;
    Expect(0, 2216, '\p{Jg=:\Ameem\z:}', "");;
    Expect(1, 2215, '\p{Jg=	Meem}', "");
    Expect(0, 2215, '\p{^Jg=	Meem}', "");
    Expect(0, 2215, '\P{Jg=	Meem}', "");
    Expect(1, 2215, '\P{^Jg=	Meem}', "");
    Expect(0, 2216, '\p{Jg=	Meem}', "");
    Expect(1, 2216, '\p{^Jg=	Meem}', "");
    Expect(1, 2216, '\P{Jg=	Meem}', "");
    Expect(0, 2216, '\P{^Jg=	Meem}', "");
    Error('\p{Is_Joining_Group=Meem/a/}');
    Error('\P{Is_Joining_Group=Meem/a/}');
    Expect(1, 2215, '\p{Is_Joining_Group:	meem}', "");
    Expect(0, 2215, '\p{^Is_Joining_Group:	meem}', "");
    Expect(0, 2215, '\P{Is_Joining_Group:	meem}', "");
    Expect(1, 2215, '\P{^Is_Joining_Group:	meem}', "");
    Expect(0, 2216, '\p{Is_Joining_Group:	meem}', "");
    Expect(1, 2216, '\p{^Is_Joining_Group:	meem}', "");
    Expect(1, 2216, '\P{Is_Joining_Group:	meem}', "");
    Expect(0, 2216, '\P{^Is_Joining_Group:	meem}', "");
    Expect(1, 2215, '\p{Is_Joining_Group=_Meem}', "");
    Expect(0, 2215, '\p{^Is_Joining_Group=_Meem}', "");
    Expect(0, 2215, '\P{Is_Joining_Group=_Meem}', "");
    Expect(1, 2215, '\P{^Is_Joining_Group=_Meem}', "");
    Expect(0, 2216, '\p{Is_Joining_Group=_Meem}', "");
    Expect(1, 2216, '\p{^Is_Joining_Group=_Meem}', "");
    Expect(1, 2216, '\P{Is_Joining_Group=_Meem}', "");
    Expect(0, 2216, '\P{^Is_Joining_Group=_Meem}', "");
    Error('\p{Is_Jg=:=_-Meem}');
    Error('\P{Is_Jg=:=_-Meem}');
    Expect(1, 2215, '\p{Is_Jg=meem}', "");
    Expect(0, 2215, '\p{^Is_Jg=meem}', "");
    Expect(0, 2215, '\P{Is_Jg=meem}', "");
    Expect(1, 2215, '\P{^Is_Jg=meem}', "");
    Expect(0, 2216, '\p{Is_Jg=meem}', "");
    Expect(1, 2216, '\p{^Is_Jg=meem}', "");
    Expect(1, 2216, '\P{Is_Jg=meem}', "");
    Expect(0, 2216, '\P{^Is_Jg=meem}', "");
    Expect(1, 2215, '\p{Is_Jg=-	meem}', "");
    Expect(0, 2215, '\p{^Is_Jg=-	meem}', "");
    Expect(0, 2215, '\P{Is_Jg=-	meem}', "");
    Expect(1, 2215, '\P{^Is_Jg=-	meem}', "");
    Expect(0, 2216, '\p{Is_Jg=-	meem}', "");
    Expect(1, 2216, '\p{^Is_Jg=-	meem}', "");
    Expect(1, 2216, '\P{Is_Jg=-	meem}', "");
    Expect(0, 2216, '\P{^Is_Jg=-	meem}', "");
    Error('\p{Joining_Group= /a/mim}');
    Error('\P{Joining_Group= /a/mim}');
    Expect(1, 1825, '\p{Joining_Group=:\AMim\z:}', "");;
    Expect(0, 1826, '\p{Joining_Group=:\AMim\z:}', "");;
    Expect(1, 1825, '\p{Joining_Group=mim}', "");
    Expect(0, 1825, '\p{^Joining_Group=mim}', "");
    Expect(0, 1825, '\P{Joining_Group=mim}', "");
    Expect(1, 1825, '\P{^Joining_Group=mim}', "");
    Expect(0, 1826, '\p{Joining_Group=mim}', "");
    Expect(1, 1826, '\p{^Joining_Group=mim}', "");
    Expect(1, 1826, '\P{Joining_Group=mim}', "");
    Expect(0, 1826, '\P{^Joining_Group=mim}', "");
    Expect(1, 1825, '\p{Joining_Group=:\Amim\z:}', "");;
    Expect(0, 1826, '\p{Joining_Group=:\Amim\z:}', "");;
    Expect(1, 1825, '\p{Joining_Group=_MIM}', "");
    Expect(0, 1825, '\p{^Joining_Group=_MIM}', "");
    Expect(0, 1825, '\P{Joining_Group=_MIM}', "");
    Expect(1, 1825, '\P{^Joining_Group=_MIM}', "");
    Expect(0, 1826, '\p{Joining_Group=_MIM}', "");
    Expect(1, 1826, '\p{^Joining_Group=_MIM}', "");
    Expect(1, 1826, '\P{Joining_Group=_MIM}', "");
    Expect(0, 1826, '\P{^Joining_Group=_MIM}', "");
    Error('\p{Jg=:= 	MIM}');
    Error('\P{Jg=:= 	MIM}');
    Expect(1, 1825, '\p{Jg=:\AMim\z:}', "");;
    Expect(0, 1826, '\p{Jg=:\AMim\z:}', "");;
    Expect(1, 1825, '\p{Jg=mim}', "");
    Expect(0, 1825, '\p{^Jg=mim}', "");
    Expect(0, 1825, '\P{Jg=mim}', "");
    Expect(1, 1825, '\P{^Jg=mim}', "");
    Expect(0, 1826, '\p{Jg=mim}', "");
    Expect(1, 1826, '\p{^Jg=mim}', "");
    Expect(1, 1826, '\P{Jg=mim}', "");
    Expect(0, 1826, '\P{^Jg=mim}', "");
    Expect(1, 1825, '\p{Jg=:\Amim\z:}', "");;
    Expect(0, 1826, '\p{Jg=:\Amim\z:}', "");;
    Expect(1, 1825, '\p{Jg=Mim}', "");
    Expect(0, 1825, '\p{^Jg=Mim}', "");
    Expect(0, 1825, '\P{Jg=Mim}', "");
    Expect(1, 1825, '\P{^Jg=Mim}', "");
    Expect(0, 1826, '\p{Jg=Mim}', "");
    Expect(1, 1826, '\p{^Jg=Mim}', "");
    Expect(1, 1826, '\P{Jg=Mim}', "");
    Expect(0, 1826, '\P{^Jg=Mim}', "");
    Error('\p{Is_Joining_Group=/a/	mim}');
    Error('\P{Is_Joining_Group=/a/	mim}');
    Expect(1, 1825, '\p{Is_Joining_Group=mim}', "");
    Expect(0, 1825, '\p{^Is_Joining_Group=mim}', "");
    Expect(0, 1825, '\P{Is_Joining_Group=mim}', "");
    Expect(1, 1825, '\P{^Is_Joining_Group=mim}', "");
    Expect(0, 1826, '\p{Is_Joining_Group=mim}', "");
    Expect(1, 1826, '\p{^Is_Joining_Group=mim}', "");
    Expect(1, 1826, '\P{Is_Joining_Group=mim}', "");
    Expect(0, 1826, '\P{^Is_Joining_Group=mim}', "");
    Expect(1, 1825, '\p{Is_Joining_Group=-mim}', "");
    Expect(0, 1825, '\p{^Is_Joining_Group=-mim}', "");
    Expect(0, 1825, '\P{Is_Joining_Group=-mim}', "");
    Expect(1, 1825, '\P{^Is_Joining_Group=-mim}', "");
    Expect(0, 1826, '\p{Is_Joining_Group=-mim}', "");
    Expect(1, 1826, '\p{^Is_Joining_Group=-mim}', "");
    Expect(1, 1826, '\P{Is_Joining_Group=-mim}', "");
    Expect(0, 1826, '\P{^Is_Joining_Group=-mim}', "");
    Error('\p{Is_Jg=	-Mim:=}');
    Error('\P{Is_Jg=	-Mim:=}');
    Expect(1, 1825, '\p{Is_Jg=mim}', "");
    Expect(0, 1825, '\p{^Is_Jg=mim}', "");
    Expect(0, 1825, '\P{Is_Jg=mim}', "");
    Expect(1, 1825, '\P{^Is_Jg=mim}', "");
    Expect(0, 1826, '\p{Is_Jg=mim}', "");
    Expect(1, 1826, '\p{^Is_Jg=mim}', "");
    Expect(1, 1826, '\P{Is_Jg=mim}', "");
    Expect(0, 1826, '\P{^Is_Jg=mim}', "");
    Expect(1, 1825, '\p{Is_Jg= Mim}', "");
    Expect(0, 1825, '\p{^Is_Jg= Mim}', "");
    Expect(0, 1825, '\P{Is_Jg= Mim}', "");
    Expect(1, 1825, '\P{^Is_Jg= Mim}', "");
    Expect(0, 1826, '\p{Is_Jg= Mim}', "");
    Expect(1, 1826, '\p{^Is_Jg= Mim}', "");
    Expect(1, 1826, '\P{Is_Jg= Mim}', "");
    Expect(0, 1826, '\P{^Is_Jg= Mim}', "");
    Error('\p{Joining_Group=_/a/No_joining_Group}');
    Error('\P{Joining_Group=_/a/No_joining_Group}');
    Expect(1, 68900, '\p{Joining_Group=:\ANo_Joining_Group\z:}', "");;
    Expect(0, 68899, '\p{Joining_Group=:\ANo_Joining_Group\z:}', "");;
    Expect(1, 68900, '\p{Joining_Group=nojoininggroup}', "");
    Expect(0, 68900, '\p{^Joining_Group=nojoininggroup}', "");
    Expect(0, 68900, '\P{Joining_Group=nojoininggroup}', "");
    Expect(1, 68900, '\P{^Joining_Group=nojoininggroup}', "");
    Expect(0, 68899, '\p{Joining_Group=nojoininggroup}', "");
    Expect(1, 68899, '\p{^Joining_Group=nojoininggroup}', "");
    Expect(1, 68899, '\P{Joining_Group=nojoininggroup}', "");
    Expect(0, 68899, '\P{^Joining_Group=nojoininggroup}', "");
    Expect(1, 68900, '\p{Joining_Group=:\Anojoininggroup\z:}', "");;
    Expect(0, 68899, '\p{Joining_Group=:\Anojoininggroup\z:}', "");;
    Expect(1, 68900, '\p{Joining_Group=-no_JOINING_group}', "");
    Expect(0, 68900, '\p{^Joining_Group=-no_JOINING_group}', "");
    Expect(0, 68900, '\P{Joining_Group=-no_JOINING_group}', "");
    Expect(1, 68900, '\P{^Joining_Group=-no_JOINING_group}', "");
    Expect(0, 68899, '\p{Joining_Group=-no_JOINING_group}', "");
    Expect(1, 68899, '\p{^Joining_Group=-no_JOINING_group}', "");
    Expect(1, 68899, '\P{Joining_Group=-no_JOINING_group}', "");
    Expect(0, 68899, '\P{^Joining_Group=-no_JOINING_group}', "");
    Error('\p{Jg=__NO_joining_Group:=}');
    Error('\P{Jg=__NO_joining_Group:=}');
    Expect(1, 68900, '\p{Jg=:\ANo_Joining_Group\z:}', "");;
    Expect(0, 68899, '\p{Jg=:\ANo_Joining_Group\z:}', "");;
    Expect(1, 68900, '\p{Jg=nojoininggroup}', "");
    Expect(0, 68900, '\p{^Jg=nojoininggroup}', "");
    Expect(0, 68900, '\P{Jg=nojoininggroup}', "");
    Expect(1, 68900, '\P{^Jg=nojoininggroup}', "");
    Expect(0, 68899, '\p{Jg=nojoininggroup}', "");
    Expect(1, 68899, '\p{^Jg=nojoininggroup}', "");
    Expect(1, 68899, '\P{Jg=nojoininggroup}', "");
    Expect(0, 68899, '\P{^Jg=nojoininggroup}', "");
    Expect(1, 68900, '\p{Jg=:\Anojoininggroup\z:}', "");;
    Expect(0, 68899, '\p{Jg=:\Anojoininggroup\z:}', "");;
    Expect(1, 68900, '\p{Jg=-_no_Joining_group}', "");
    Expect(0, 68900, '\p{^Jg=-_no_Joining_group}', "");
    Expect(0, 68900, '\P{Jg=-_no_Joining_group}', "");
    Expect(1, 68900, '\P{^Jg=-_no_Joining_group}', "");
    Expect(0, 68899, '\p{Jg=-_no_Joining_group}', "");
    Expect(1, 68899, '\p{^Jg=-_no_Joining_group}', "");
    Expect(1, 68899, '\P{Jg=-_no_Joining_group}', "");
    Expect(0, 68899, '\P{^Jg=-_no_Joining_group}', "");
    Error('\p{Is_Joining_Group=	/a/No_joining_GROUP}');
    Error('\P{Is_Joining_Group=	/a/No_joining_GROUP}');
    Expect(1, 68900, '\p{Is_Joining_Group=nojoininggroup}', "");
    Expect(0, 68900, '\p{^Is_Joining_Group=nojoininggroup}', "");
    Expect(0, 68900, '\P{Is_Joining_Group=nojoininggroup}', "");
    Expect(1, 68900, '\P{^Is_Joining_Group=nojoininggroup}', "");
    Expect(0, 68899, '\p{Is_Joining_Group=nojoininggroup}', "");
    Expect(1, 68899, '\p{^Is_Joining_Group=nojoininggroup}', "");
    Expect(1, 68899, '\P{Is_Joining_Group=nojoininggroup}', "");
    Expect(0, 68899, '\P{^Is_Joining_Group=nojoininggroup}', "");
    Expect(1, 68900, '\p{Is_Joining_Group=_NO_JOINING_Group}', "");
    Expect(0, 68900, '\p{^Is_Joining_Group=_NO_JOINING_Group}', "");
    Expect(0, 68900, '\P{Is_Joining_Group=_NO_JOINING_Group}', "");
    Expect(1, 68900, '\P{^Is_Joining_Group=_NO_JOINING_Group}', "");
    Expect(0, 68899, '\p{Is_Joining_Group=_NO_JOINING_Group}', "");
    Expect(1, 68899, '\p{^Is_Joining_Group=_NO_JOINING_Group}', "");
    Expect(1, 68899, '\P{Is_Joining_Group=_NO_JOINING_Group}', "");
    Expect(0, 68899, '\P{^Is_Joining_Group=_NO_JOINING_Group}', "");
    Error('\p{Is_Jg=  NO_JOINING_GROUP:=}');
    Error('\P{Is_Jg=  NO_JOINING_GROUP:=}');
    Expect(1, 68900, '\p{Is_Jg=nojoininggroup}', "");
    Expect(0, 68900, '\p{^Is_Jg=nojoininggroup}', "");
    Expect(0, 68900, '\P{Is_Jg=nojoininggroup}', "");
    Expect(1, 68900, '\P{^Is_Jg=nojoininggroup}', "");
    Expect(0, 68899, '\p{Is_Jg=nojoininggroup}', "");
    Expect(1, 68899, '\p{^Is_Jg=nojoininggroup}', "");
    Expect(1, 68899, '\P{Is_Jg=nojoininggroup}', "");
    Expect(0, 68899, '\P{^Is_Jg=nojoininggroup}', "");
    Expect(1, 68900, '\p{Is_Jg= _No_joining_Group}', "");
    Expect(0, 68900, '\p{^Is_Jg= _No_joining_Group}', "");
    Expect(0, 68900, '\P{Is_Jg= _No_joining_Group}', "");
    Expect(1, 68900, '\P{^Is_Jg= _No_joining_Group}', "");
    Expect(0, 68899, '\p{Is_Jg= _No_joining_Group}', "");
    Expect(1, 68899, '\p{^Is_Jg= _No_joining_Group}', "");
    Expect(1, 68899, '\P{Is_Jg= _No_joining_Group}', "");
    Expect(0, 68899, '\P{^Is_Jg= _No_joining_Group}', "");
    Error('\p{Joining_Group=_-Noon:=}');
    Error('\P{Joining_Group=_-Noon:=}');
    Expect(1, 1897, '\p{Joining_Group=:\ANoon\z:}', "");;
    Expect(0, 1898, '\p{Joining_Group=:\ANoon\z:}', "");;
    Expect(1, 1897, '\p{Joining_Group=noon}', "");
    Expect(0, 1897, '\p{^Joining_Group=noon}', "");
    Expect(0, 1897, '\P{Joining_Group=noon}', "");
    Expect(1, 1897, '\P{^Joining_Group=noon}', "");
    Expect(0, 1898, '\p{Joining_Group=noon}', "");
    Expect(1, 1898, '\p{^Joining_Group=noon}', "");
    Expect(1, 1898, '\P{Joining_Group=noon}', "");
    Expect(0, 1898, '\P{^Joining_Group=noon}', "");
    Expect(1, 1897, '\p{Joining_Group=:\Anoon\z:}', "");;
    Expect(0, 1898, '\p{Joining_Group=:\Anoon\z:}', "");;
    Expect(1, 1897, '\p{Joining_Group=	_Noon}', "");
    Expect(0, 1897, '\p{^Joining_Group=	_Noon}', "");
    Expect(0, 1897, '\P{Joining_Group=	_Noon}', "");
    Expect(1, 1897, '\P{^Joining_Group=	_Noon}', "");
    Expect(0, 1898, '\p{Joining_Group=	_Noon}', "");
    Expect(1, 1898, '\p{^Joining_Group=	_Noon}', "");
    Expect(1, 1898, '\P{Joining_Group=	_Noon}', "");
    Expect(0, 1898, '\P{^Joining_Group=	_Noon}', "");
    Error('\p{Jg=- Noon/a/}');
    Error('\P{Jg=- Noon/a/}');
    Expect(1, 1897, '\p{Jg=:\ANoon\z:}', "");;
    Expect(0, 1898, '\p{Jg=:\ANoon\z:}', "");;
    Expect(1, 1897, '\p{Jg: noon}', "");
    Expect(0, 1897, '\p{^Jg: noon}', "");
    Expect(0, 1897, '\P{Jg: noon}', "");
    Expect(1, 1897, '\P{^Jg: noon}', "");
    Expect(0, 1898, '\p{Jg: noon}', "");
    Expect(1, 1898, '\p{^Jg: noon}', "");
    Expect(1, 1898, '\P{Jg: noon}', "");
    Expect(0, 1898, '\P{^Jg: noon}', "");
    Expect(1, 1897, '\p{Jg=:\Anoon\z:}', "");;
    Expect(0, 1898, '\p{Jg=:\Anoon\z:}', "");;
    Expect(1, 1897, '\p{Jg= Noon}', "");
    Expect(0, 1897, '\p{^Jg= Noon}', "");
    Expect(0, 1897, '\P{Jg= Noon}', "");
    Expect(1, 1897, '\P{^Jg= Noon}', "");
    Expect(0, 1898, '\p{Jg= Noon}', "");
    Expect(1, 1898, '\p{^Jg= Noon}', "");
    Expect(1, 1898, '\P{Jg= Noon}', "");
    Expect(0, 1898, '\P{^Jg= Noon}', "");
    Error('\p{Is_Joining_Group:  -NOON/a/}');
    Error('\P{Is_Joining_Group:  -NOON/a/}');
    Expect(1, 1897, '\p{Is_Joining_Group=noon}', "");
    Expect(0, 1897, '\p{^Is_Joining_Group=noon}', "");
    Expect(0, 1897, '\P{Is_Joining_Group=noon}', "");
    Expect(1, 1897, '\P{^Is_Joining_Group=noon}', "");
    Expect(0, 1898, '\p{Is_Joining_Group=noon}', "");
    Expect(1, 1898, '\p{^Is_Joining_Group=noon}', "");
    Expect(1, 1898, '\P{Is_Joining_Group=noon}', "");
    Expect(0, 1898, '\P{^Is_Joining_Group=noon}', "");
    Expect(1, 1897, '\p{Is_Joining_Group=	 Noon}', "");
    Expect(0, 1897, '\p{^Is_Joining_Group=	 Noon}', "");
    Expect(0, 1897, '\P{Is_Joining_Group=	 Noon}', "");
    Expect(1, 1897, '\P{^Is_Joining_Group=	 Noon}', "");
    Expect(0, 1898, '\p{Is_Joining_Group=	 Noon}', "");
    Expect(1, 1898, '\p{^Is_Joining_Group=	 Noon}', "");
    Expect(1, 1898, '\P{Is_Joining_Group=	 Noon}', "");
    Expect(0, 1898, '\P{^Is_Joining_Group=	 Noon}', "");
    Error('\p{Is_Jg= :=noon}');
    Error('\P{Is_Jg= :=noon}');
    Expect(1, 1897, '\p{Is_Jg=noon}', "");
    Expect(0, 1897, '\p{^Is_Jg=noon}', "");
    Expect(0, 1897, '\P{Is_Jg=noon}', "");
    Expect(1, 1897, '\P{^Is_Jg=noon}', "");
    Expect(0, 1898, '\p{Is_Jg=noon}', "");
    Expect(1, 1898, '\p{^Is_Jg=noon}', "");
    Expect(1, 1898, '\P{Is_Jg=noon}', "");
    Expect(0, 1898, '\P{^Is_Jg=noon}', "");
    Expect(1, 1897, '\p{Is_Jg=- noon}', "");
    Expect(0, 1897, '\p{^Is_Jg=- noon}', "");
    Expect(0, 1897, '\P{Is_Jg=- noon}', "");
    Expect(1, 1897, '\P{^Is_Jg=- noon}', "");
    Expect(0, 1898, '\p{Is_Jg=- noon}', "");
    Expect(1, 1898, '\p{^Is_Jg=- noon}', "");
    Expect(1, 1898, '\P{Is_Jg=- noon}', "");
    Expect(0, 1898, '\P{^Is_Jg=- noon}', "");
    Error('\p{Joining_Group=/a/-_Nun}');
    Error('\P{Joining_Group=/a/-_Nun}');
    Expect(1, 1826, '\p{Joining_Group=:\ANun\z:}', "");;
    Expect(0, 1827, '\p{Joining_Group=:\ANun\z:}', "");;
    Expect(1, 1826, '\p{Joining_Group:nun}', "");
    Expect(0, 1826, '\p{^Joining_Group:nun}', "");
    Expect(0, 1826, '\P{Joining_Group:nun}', "");
    Expect(1, 1826, '\P{^Joining_Group:nun}', "");
    Expect(0, 1827, '\p{Joining_Group:nun}', "");
    Expect(1, 1827, '\p{^Joining_Group:nun}', "");
    Expect(1, 1827, '\P{Joining_Group:nun}', "");
    Expect(0, 1827, '\P{^Joining_Group:nun}', "");
    Expect(1, 1826, '\p{Joining_Group=:\Anun\z:}', "");;
    Expect(0, 1827, '\p{Joining_Group=:\Anun\z:}', "");;
    Expect(1, 1826, '\p{Joining_Group= 	Nun}', "");
    Expect(0, 1826, '\p{^Joining_Group= 	Nun}', "");
    Expect(0, 1826, '\P{Joining_Group= 	Nun}', "");
    Expect(1, 1826, '\P{^Joining_Group= 	Nun}', "");
    Expect(0, 1827, '\p{Joining_Group= 	Nun}', "");
    Expect(1, 1827, '\p{^Joining_Group= 	Nun}', "");
    Expect(1, 1827, '\P{Joining_Group= 	Nun}', "");
    Expect(0, 1827, '\P{^Joining_Group= 	Nun}', "");
    Error('\p{Jg=_-Nun:=}');
    Error('\P{Jg=_-Nun:=}');
    Expect(1, 1826, '\p{Jg=:\ANun\z:}', "");;
    Expect(0, 1827, '\p{Jg=:\ANun\z:}', "");;
    Expect(1, 1826, '\p{Jg=nun}', "");
    Expect(0, 1826, '\p{^Jg=nun}', "");
    Expect(0, 1826, '\P{Jg=nun}', "");
    Expect(1, 1826, '\P{^Jg=nun}', "");
    Expect(0, 1827, '\p{Jg=nun}', "");
    Expect(1, 1827, '\p{^Jg=nun}', "");
    Expect(1, 1827, '\P{Jg=nun}', "");
    Expect(0, 1827, '\P{^Jg=nun}', "");
    Expect(1, 1826, '\p{Jg=:\Anun\z:}', "");;
    Expect(0, 1827, '\p{Jg=:\Anun\z:}', "");;
    Expect(1, 1826, '\p{Jg= nun}', "");
    Expect(0, 1826, '\p{^Jg= nun}', "");
    Expect(0, 1826, '\P{Jg= nun}', "");
    Expect(1, 1826, '\P{^Jg= nun}', "");
    Expect(0, 1827, '\p{Jg= nun}', "");
    Expect(1, 1827, '\p{^Jg= nun}', "");
    Expect(1, 1827, '\P{Jg= nun}', "");
    Expect(0, 1827, '\P{^Jg= nun}', "");
    Error('\p{Is_Joining_Group=_nun/a/}');
    Error('\P{Is_Joining_Group=_nun/a/}');
    Expect(1, 1826, '\p{Is_Joining_Group:   nun}', "");
    Expect(0, 1826, '\p{^Is_Joining_Group:   nun}', "");
    Expect(0, 1826, '\P{Is_Joining_Group:   nun}', "");
    Expect(1, 1826, '\P{^Is_Joining_Group:   nun}', "");
    Expect(0, 1827, '\p{Is_Joining_Group:   nun}', "");
    Expect(1, 1827, '\p{^Is_Joining_Group:   nun}', "");
    Expect(1, 1827, '\P{Is_Joining_Group:   nun}', "");
    Expect(0, 1827, '\P{^Is_Joining_Group:   nun}', "");
    Expect(1, 1826, '\p{Is_Joining_Group=_nun}', "");
    Expect(0, 1826, '\p{^Is_Joining_Group=_nun}', "");
    Expect(0, 1826, '\P{Is_Joining_Group=_nun}', "");
    Expect(1, 1826, '\P{^Is_Joining_Group=_nun}', "");
    Expect(0, 1827, '\p{Is_Joining_Group=_nun}', "");
    Expect(1, 1827, '\p{^Is_Joining_Group=_nun}', "");
    Expect(1, 1827, '\P{Is_Joining_Group=_nun}', "");
    Expect(0, 1827, '\P{^Is_Joining_Group=_nun}', "");
    Error('\p{Is_Jg=	 NUN:=}');
    Error('\P{Is_Jg=	 NUN:=}');
    Expect(1, 1826, '\p{Is_Jg: nun}', "");
    Expect(0, 1826, '\p{^Is_Jg: nun}', "");
    Expect(0, 1826, '\P{Is_Jg: nun}', "");
    Expect(1, 1826, '\P{^Is_Jg: nun}', "");
    Expect(0, 1827, '\p{Is_Jg: nun}', "");
    Expect(1, 1827, '\p{^Is_Jg: nun}', "");
    Expect(1, 1827, '\P{Is_Jg: nun}', "");
    Expect(0, 1827, '\P{^Is_Jg: nun}', "");
    Expect(1, 1826, '\p{Is_Jg=-	nun}', "");
    Expect(0, 1826, '\p{^Is_Jg=-	nun}', "");
    Expect(0, 1826, '\P{Is_Jg=-	nun}', "");
    Expect(1, 1826, '\P{^Is_Jg=-	nun}', "");
    Expect(0, 1827, '\p{Is_Jg=-	nun}', "");
    Expect(1, 1827, '\p{^Is_Jg=-	nun}', "");
    Expect(1, 1827, '\P{Is_Jg=-	nun}', "");
    Expect(0, 1827, '\P{^Is_Jg=-	nun}', "");
    Error('\p{Joining_Group=	_Nya/a/}');
    Error('\P{Joining_Group=	_Nya/a/}');
    Expect(1, 1725, '\p{Joining_Group=:\ANya\z:}', "");;
    Expect(0, 1726, '\p{Joining_Group=:\ANya\z:}', "");;
    Expect(1, 1725, '\p{Joining_Group=nya}', "");
    Expect(0, 1725, '\p{^Joining_Group=nya}', "");
    Expect(0, 1725, '\P{Joining_Group=nya}', "");
    Expect(1, 1725, '\P{^Joining_Group=nya}', "");
    Expect(0, 1726, '\p{Joining_Group=nya}', "");
    Expect(1, 1726, '\p{^Joining_Group=nya}', "");
    Expect(1, 1726, '\P{Joining_Group=nya}', "");
    Expect(0, 1726, '\P{^Joining_Group=nya}', "");
    Expect(1, 1725, '\p{Joining_Group=:\Anya\z:}', "");;
    Expect(0, 1726, '\p{Joining_Group=:\Anya\z:}', "");;
    Expect(1, 1725, '\p{Joining_Group= 	Nya}', "");
    Expect(0, 1725, '\p{^Joining_Group= 	Nya}', "");
    Expect(0, 1725, '\P{Joining_Group= 	Nya}', "");
    Expect(1, 1725, '\P{^Joining_Group= 	Nya}', "");
    Expect(0, 1726, '\p{Joining_Group= 	Nya}', "");
    Expect(1, 1726, '\p{^Joining_Group= 	Nya}', "");
    Expect(1, 1726, '\P{Joining_Group= 	Nya}', "");
    Expect(0, 1726, '\P{^Joining_Group= 	Nya}', "");
    Error('\p{Jg=/a/_Nya}');
    Error('\P{Jg=/a/_Nya}');
    Expect(1, 1725, '\p{Jg=:\ANya\z:}', "");;
    Expect(0, 1726, '\p{Jg=:\ANya\z:}', "");;
    Expect(1, 1725, '\p{Jg=nya}', "");
    Expect(0, 1725, '\p{^Jg=nya}', "");
    Expect(0, 1725, '\P{Jg=nya}', "");
    Expect(1, 1725, '\P{^Jg=nya}', "");
    Expect(0, 1726, '\p{Jg=nya}', "");
    Expect(1, 1726, '\p{^Jg=nya}', "");
    Expect(1, 1726, '\P{Jg=nya}', "");
    Expect(0, 1726, '\P{^Jg=nya}', "");
    Expect(1, 1725, '\p{Jg=:\Anya\z:}', "");;
    Expect(0, 1726, '\p{Jg=:\Anya\z:}', "");;
    Expect(1, 1725, '\p{Jg=_Nya}', "");
    Expect(0, 1725, '\p{^Jg=_Nya}', "");
    Expect(0, 1725, '\P{Jg=_Nya}', "");
    Expect(1, 1725, '\P{^Jg=_Nya}', "");
    Expect(0, 1726, '\p{Jg=_Nya}', "");
    Expect(1, 1726, '\p{^Jg=_Nya}', "");
    Expect(1, 1726, '\P{Jg=_Nya}', "");
    Expect(0, 1726, '\P{^Jg=_Nya}', "");
    Error('\p{Is_Joining_Group= :=Nya}');
    Error('\P{Is_Joining_Group= :=Nya}');
    Expect(1, 1725, '\p{Is_Joining_Group=nya}', "");
    Expect(0, 1725, '\p{^Is_Joining_Group=nya}', "");
    Expect(0, 1725, '\P{Is_Joining_Group=nya}', "");
    Expect(1, 1725, '\P{^Is_Joining_Group=nya}', "");
    Expect(0, 1726, '\p{Is_Joining_Group=nya}', "");
    Expect(1, 1726, '\p{^Is_Joining_Group=nya}', "");
    Expect(1, 1726, '\P{Is_Joining_Group=nya}', "");
    Expect(0, 1726, '\P{^Is_Joining_Group=nya}', "");
    Expect(1, 1725, '\p{Is_Joining_Group=_ Nya}', "");
    Expect(0, 1725, '\p{^Is_Joining_Group=_ Nya}', "");
    Expect(0, 1725, '\P{Is_Joining_Group=_ Nya}', "");
    Expect(1, 1725, '\P{^Is_Joining_Group=_ Nya}', "");
    Expect(0, 1726, '\p{Is_Joining_Group=_ Nya}', "");
    Expect(1, 1726, '\p{^Is_Joining_Group=_ Nya}', "");
    Expect(1, 1726, '\P{Is_Joining_Group=_ Nya}', "");
    Expect(0, 1726, '\P{^Is_Joining_Group=_ Nya}', "");
    Error('\p{Is_Jg=/a/nya}');
    Error('\P{Is_Jg=/a/nya}');
    Expect(1, 1725, '\p{Is_Jg=nya}', "");
    Expect(0, 1725, '\p{^Is_Jg=nya}', "");
    Expect(0, 1725, '\P{Is_Jg=nya}', "");
    Expect(1, 1725, '\P{^Is_Jg=nya}', "");
    Expect(0, 1726, '\p{Is_Jg=nya}', "");
    Expect(1, 1726, '\p{^Is_Jg=nya}', "");
    Expect(1, 1726, '\P{Is_Jg=nya}', "");
    Expect(0, 1726, '\P{^Is_Jg=nya}', "");
    Expect(1, 1725, '\p{Is_Jg=Nya}', "");
    Expect(0, 1725, '\p{^Is_Jg=Nya}', "");
    Expect(0, 1725, '\P{Is_Jg=Nya}', "");
    Expect(1, 1725, '\P{^Is_Jg=Nya}', "");
    Expect(0, 1726, '\p{Is_Jg=Nya}', "");
    Expect(1, 1726, '\p{^Is_Jg=Nya}', "");
    Expect(1, 1726, '\P{Is_Jg=Nya}', "");
    Expect(0, 1726, '\P{^Is_Jg=Nya}', "");
    Error('\p{Joining_Group=:=-	Pe}');
    Error('\P{Joining_Group=:=-	Pe}');
    Expect(1, 1830, '\p{Joining_Group=:\APe\z:}', "");;
    Expect(0, 1831, '\p{Joining_Group=:\APe\z:}', "");;
    Expect(1, 1830, '\p{Joining_Group=pe}', "");
    Expect(0, 1830, '\p{^Joining_Group=pe}', "");
    Expect(0, 1830, '\P{Joining_Group=pe}', "");
    Expect(1, 1830, '\P{^Joining_Group=pe}', "");
    Expect(0, 1831, '\p{Joining_Group=pe}', "");
    Expect(1, 1831, '\p{^Joining_Group=pe}', "");
    Expect(1, 1831, '\P{Joining_Group=pe}', "");
    Expect(0, 1831, '\P{^Joining_Group=pe}', "");
    Expect(1, 1830, '\p{Joining_Group=:\Ape\z:}', "");;
    Expect(0, 1831, '\p{Joining_Group=:\Ape\z:}', "");;
    Expect(1, 1830, '\p{Joining_Group=_ pe}', "");
    Expect(0, 1830, '\p{^Joining_Group=_ pe}', "");
    Expect(0, 1830, '\P{Joining_Group=_ pe}', "");
    Expect(1, 1830, '\P{^Joining_Group=_ pe}', "");
    Expect(0, 1831, '\p{Joining_Group=_ pe}', "");
    Expect(1, 1831, '\p{^Joining_Group=_ pe}', "");
    Expect(1, 1831, '\P{Joining_Group=_ pe}', "");
    Expect(0, 1831, '\P{^Joining_Group=_ pe}', "");
    Error('\p{Jg:/a/ Pe}');
    Error('\P{Jg:/a/ Pe}');
    Expect(1, 1830, '\p{Jg=:\APe\z:}', "");;
    Expect(0, 1831, '\p{Jg=:\APe\z:}', "");;
    Expect(1, 1830, '\p{Jg=pe}', "");
    Expect(0, 1830, '\p{^Jg=pe}', "");
    Expect(0, 1830, '\P{Jg=pe}', "");
    Expect(1, 1830, '\P{^Jg=pe}', "");
    Expect(0, 1831, '\p{Jg=pe}', "");
    Expect(1, 1831, '\p{^Jg=pe}', "");
    Expect(1, 1831, '\P{Jg=pe}', "");
    Expect(0, 1831, '\P{^Jg=pe}', "");
    Expect(1, 1830, '\p{Jg=:\Ape\z:}', "");;
    Expect(0, 1831, '\p{Jg=:\Ape\z:}', "");;
    Expect(1, 1830, '\p{Jg= Pe}', "");
    Expect(0, 1830, '\p{^Jg= Pe}', "");
    Expect(0, 1830, '\P{Jg= Pe}', "");
    Expect(1, 1830, '\P{^Jg= Pe}', "");
    Expect(0, 1831, '\p{Jg= Pe}', "");
    Expect(1, 1831, '\p{^Jg= Pe}', "");
    Expect(1, 1831, '\P{Jg= Pe}', "");
    Expect(0, 1831, '\P{^Jg= Pe}', "");
    Error('\p{Is_Joining_Group= -Pe/a/}');
    Error('\P{Is_Joining_Group= -Pe/a/}');
    Expect(1, 1830, '\p{Is_Joining_Group=pe}', "");
    Expect(0, 1830, '\p{^Is_Joining_Group=pe}', "");
    Expect(0, 1830, '\P{Is_Joining_Group=pe}', "");
    Expect(1, 1830, '\P{^Is_Joining_Group=pe}', "");
    Expect(0, 1831, '\p{Is_Joining_Group=pe}', "");
    Expect(1, 1831, '\p{^Is_Joining_Group=pe}', "");
    Expect(1, 1831, '\P{Is_Joining_Group=pe}', "");
    Expect(0, 1831, '\P{^Is_Joining_Group=pe}', "");
    Expect(1, 1830, '\p{Is_Joining_Group= PE}', "");
    Expect(0, 1830, '\p{^Is_Joining_Group= PE}', "");
    Expect(0, 1830, '\P{Is_Joining_Group= PE}', "");
    Expect(1, 1830, '\P{^Is_Joining_Group= PE}', "");
    Expect(0, 1831, '\p{Is_Joining_Group= PE}', "");
    Expect(1, 1831, '\p{^Is_Joining_Group= PE}', "");
    Expect(1, 1831, '\P{Is_Joining_Group= PE}', "");
    Expect(0, 1831, '\P{^Is_Joining_Group= PE}', "");
    Error('\p{Is_Jg=Pe/a/}');
    Error('\P{Is_Jg=Pe/a/}');
    Expect(1, 1830, '\p{Is_Jg=pe}', "");
    Expect(0, 1830, '\p{^Is_Jg=pe}', "");
    Expect(0, 1830, '\P{Is_Jg=pe}', "");
    Expect(1, 1830, '\P{^Is_Jg=pe}', "");
    Expect(0, 1831, '\p{Is_Jg=pe}', "");
    Expect(1, 1831, '\p{^Is_Jg=pe}', "");
    Expect(1, 1831, '\P{Is_Jg=pe}', "");
    Expect(0, 1831, '\P{^Is_Jg=pe}', "");
    Expect(1, 1830, '\p{Is_Jg=-_Pe}', "");
    Expect(0, 1830, '\p{^Is_Jg=-_Pe}', "");
    Expect(0, 1830, '\P{Is_Jg=-_Pe}', "");
    Expect(1, 1830, '\P{^Is_Jg=-_Pe}', "");
    Expect(0, 1831, '\p{Is_Jg=-_Pe}', "");
    Expect(1, 1831, '\p{^Is_Jg=-_Pe}', "");
    Expect(1, 1831, '\P{Is_Jg=-_Pe}', "");
    Expect(0, 1831, '\P{^Is_Jg=-_Pe}', "");
    Error('\p{Joining_Group=QAF/a/}');
    Error('\P{Joining_Group=QAF/a/}');
    Expect(1, 2213, '\p{Joining_Group=:\AQaf\z:}', "");;
    Expect(0, 2214, '\p{Joining_Group=:\AQaf\z:}', "");;
    Expect(1, 2213, '\p{Joining_Group=qaf}', "");
    Expect(0, 2213, '\p{^Joining_Group=qaf}', "");
    Expect(0, 2213, '\P{Joining_Group=qaf}', "");
    Expect(1, 2213, '\P{^Joining_Group=qaf}', "");
    Expect(0, 2214, '\p{Joining_Group=qaf}', "");
    Expect(1, 2214, '\p{^Joining_Group=qaf}', "");
    Expect(1, 2214, '\P{Joining_Group=qaf}', "");
    Expect(0, 2214, '\P{^Joining_Group=qaf}', "");
    Expect(1, 2213, '\p{Joining_Group=:\Aqaf\z:}', "");;
    Expect(0, 2214, '\p{Joining_Group=:\Aqaf\z:}', "");;
    Expect(1, 2213, '\p{Joining_Group=--Qaf}', "");
    Expect(0, 2213, '\p{^Joining_Group=--Qaf}', "");
    Expect(0, 2213, '\P{Joining_Group=--Qaf}', "");
    Expect(1, 2213, '\P{^Joining_Group=--Qaf}', "");
    Expect(0, 2214, '\p{Joining_Group=--Qaf}', "");
    Expect(1, 2214, '\p{^Joining_Group=--Qaf}', "");
    Expect(1, 2214, '\P{Joining_Group=--Qaf}', "");
    Expect(0, 2214, '\P{^Joining_Group=--Qaf}', "");
    Error('\p{Jg=-Qaf/a/}');
    Error('\P{Jg=-Qaf/a/}');
    Expect(1, 2213, '\p{Jg=:\AQaf\z:}', "");;
    Expect(0, 2214, '\p{Jg=:\AQaf\z:}', "");;
    Expect(1, 2213, '\p{Jg=qaf}', "");
    Expect(0, 2213, '\p{^Jg=qaf}', "");
    Expect(0, 2213, '\P{Jg=qaf}', "");
    Expect(1, 2213, '\P{^Jg=qaf}', "");
    Expect(0, 2214, '\p{Jg=qaf}', "");
    Expect(1, 2214, '\p{^Jg=qaf}', "");
    Expect(1, 2214, '\P{Jg=qaf}', "");
    Expect(0, 2214, '\P{^Jg=qaf}', "");
    Expect(1, 2213, '\p{Jg=:\Aqaf\z:}', "");;
    Expect(0, 2214, '\p{Jg=:\Aqaf\z:}', "");;
    Expect(1, 2213, '\p{Jg=-	qaf}', "");
    Expect(0, 2213, '\p{^Jg=-	qaf}', "");
    Expect(0, 2213, '\P{Jg=-	qaf}', "");
    Expect(1, 2213, '\P{^Jg=-	qaf}', "");
    Expect(0, 2214, '\p{Jg=-	qaf}', "");
    Expect(1, 2214, '\p{^Jg=-	qaf}', "");
    Expect(1, 2214, '\P{Jg=-	qaf}', "");
    Expect(0, 2214, '\P{^Jg=-	qaf}', "");
    Error('\p{Is_Joining_Group=-_qaf:=}');
    Error('\P{Is_Joining_Group=-_qaf:=}');
    Expect(1, 2213, '\p{Is_Joining_Group=qaf}', "");
    Expect(0, 2213, '\p{^Is_Joining_Group=qaf}', "");
    Expect(0, 2213, '\P{Is_Joining_Group=qaf}', "");
    Expect(1, 2213, '\P{^Is_Joining_Group=qaf}', "");
    Expect(0, 2214, '\p{Is_Joining_Group=qaf}', "");
    Expect(1, 2214, '\p{^Is_Joining_Group=qaf}', "");
    Expect(1, 2214, '\P{Is_Joining_Group=qaf}', "");
    Expect(0, 2214, '\P{^Is_Joining_Group=qaf}', "");
    Expect(1, 2213, '\p{Is_Joining_Group=__Qaf}', "");
    Expect(0, 2213, '\p{^Is_Joining_Group=__Qaf}', "");
    Expect(0, 2213, '\P{Is_Joining_Group=__Qaf}', "");
    Expect(1, 2213, '\P{^Is_Joining_Group=__Qaf}', "");
    Expect(0, 2214, '\p{Is_Joining_Group=__Qaf}', "");
    Expect(1, 2214, '\p{^Is_Joining_Group=__Qaf}', "");
    Expect(1, 2214, '\P{Is_Joining_Group=__Qaf}', "");
    Expect(0, 2214, '\P{^Is_Joining_Group=__Qaf}', "");
    Error('\p{Is_Jg=/a/		QAF}');
    Error('\P{Is_Jg=/a/		QAF}');
    Expect(1, 2213, '\p{Is_Jg=qaf}', "");
    Expect(0, 2213, '\p{^Is_Jg=qaf}', "");
    Expect(0, 2213, '\P{Is_Jg=qaf}', "");
    Expect(1, 2213, '\P{^Is_Jg=qaf}', "");
    Expect(0, 2214, '\p{Is_Jg=qaf}', "");
    Expect(1, 2214, '\p{^Is_Jg=qaf}', "");
    Expect(1, 2214, '\P{Is_Jg=qaf}', "");
    Expect(0, 2214, '\P{^Is_Jg=qaf}', "");
    Expect(1, 2213, '\p{Is_Jg=-	Qaf}', "");
    Expect(0, 2213, '\p{^Is_Jg=-	Qaf}', "");
    Expect(0, 2213, '\P{Is_Jg=-	Qaf}', "");
    Expect(1, 2213, '\P{^Is_Jg=-	Qaf}', "");
    Expect(0, 2214, '\p{Is_Jg=-	Qaf}', "");
    Expect(1, 2214, '\p{^Is_Jg=-	Qaf}', "");
    Expect(1, 2214, '\P{Is_Jg=-	Qaf}', "");
    Expect(0, 2214, '\P{^Is_Jg=-	Qaf}', "");
    Error('\p{Joining_Group=_	QAPH:=}');
    Error('\P{Joining_Group=_	QAPH:=}');
    Expect(1, 1833, '\p{Joining_Group=:\AQaph\z:}', "");;
    Expect(0, 1834, '\p{Joining_Group=:\AQaph\z:}', "");;
    Expect(1, 1833, '\p{Joining_Group=qaph}', "");
    Expect(0, 1833, '\p{^Joining_Group=qaph}', "");
    Expect(0, 1833, '\P{Joining_Group=qaph}', "");
    Expect(1, 1833, '\P{^Joining_Group=qaph}', "");
    Expect(0, 1834, '\p{Joining_Group=qaph}', "");
    Expect(1, 1834, '\p{^Joining_Group=qaph}', "");
    Expect(1, 1834, '\P{Joining_Group=qaph}', "");
    Expect(0, 1834, '\P{^Joining_Group=qaph}', "");
    Expect(1, 1833, '\p{Joining_Group=:\Aqaph\z:}', "");;
    Expect(0, 1834, '\p{Joining_Group=:\Aqaph\z:}', "");;
    Expect(1, 1833, '\p{Joining_Group= 	qaph}', "");
    Expect(0, 1833, '\p{^Joining_Group= 	qaph}', "");
    Expect(0, 1833, '\P{Joining_Group= 	qaph}', "");
    Expect(1, 1833, '\P{^Joining_Group= 	qaph}', "");
    Expect(0, 1834, '\p{Joining_Group= 	qaph}', "");
    Expect(1, 1834, '\p{^Joining_Group= 	qaph}', "");
    Expect(1, 1834, '\P{Joining_Group= 	qaph}', "");
    Expect(0, 1834, '\P{^Joining_Group= 	qaph}', "");
    Error('\p{Jg= _Qaph/a/}');
    Error('\P{Jg= _Qaph/a/}');
    Expect(1, 1833, '\p{Jg=:\AQaph\z:}', "");;
    Expect(0, 1834, '\p{Jg=:\AQaph\z:}', "");;
    Expect(1, 1833, '\p{Jg=qaph}', "");
    Expect(0, 1833, '\p{^Jg=qaph}', "");
    Expect(0, 1833, '\P{Jg=qaph}', "");
    Expect(1, 1833, '\P{^Jg=qaph}', "");
    Expect(0, 1834, '\p{Jg=qaph}', "");
    Expect(1, 1834, '\p{^Jg=qaph}', "");
    Expect(1, 1834, '\P{Jg=qaph}', "");
    Expect(0, 1834, '\P{^Jg=qaph}', "");
    Expect(1, 1833, '\p{Jg=:\Aqaph\z:}', "");;
    Expect(0, 1834, '\p{Jg=:\Aqaph\z:}', "");;
    Expect(1, 1833, '\p{Jg= Qaph}', "");
    Expect(0, 1833, '\p{^Jg= Qaph}', "");
    Expect(0, 1833, '\P{Jg= Qaph}', "");
    Expect(1, 1833, '\P{^Jg= Qaph}', "");
    Expect(0, 1834, '\p{Jg= Qaph}', "");
    Expect(1, 1834, '\p{^Jg= Qaph}', "");
    Expect(1, 1834, '\P{Jg= Qaph}', "");
    Expect(0, 1834, '\P{^Jg= Qaph}', "");
    Error('\p{Is_Joining_Group=_:=Qaph}');
    Error('\P{Is_Joining_Group=_:=Qaph}');
    Expect(1, 1833, '\p{Is_Joining_Group=qaph}', "");
    Expect(0, 1833, '\p{^Is_Joining_Group=qaph}', "");
    Expect(0, 1833, '\P{Is_Joining_Group=qaph}', "");
    Expect(1, 1833, '\P{^Is_Joining_Group=qaph}', "");
    Expect(0, 1834, '\p{Is_Joining_Group=qaph}', "");
    Expect(1, 1834, '\p{^Is_Joining_Group=qaph}', "");
    Expect(1, 1834, '\P{Is_Joining_Group=qaph}', "");
    Expect(0, 1834, '\P{^Is_Joining_Group=qaph}', "");
    Expect(1, 1833, '\p{Is_Joining_Group= qaph}', "");
    Expect(0, 1833, '\p{^Is_Joining_Group= qaph}', "");
    Expect(0, 1833, '\P{Is_Joining_Group= qaph}', "");
    Expect(1, 1833, '\P{^Is_Joining_Group= qaph}', "");
    Expect(0, 1834, '\p{Is_Joining_Group= qaph}', "");
    Expect(1, 1834, '\p{^Is_Joining_Group= qaph}', "");
    Expect(1, 1834, '\P{Is_Joining_Group= qaph}', "");
    Expect(0, 1834, '\P{^Is_Joining_Group= qaph}', "");
    Error('\p{Is_Jg=:=	-Qaph}');
    Error('\P{Is_Jg=:=	-Qaph}');
    Expect(1, 1833, '\p{Is_Jg=qaph}', "");
    Expect(0, 1833, '\p{^Is_Jg=qaph}', "");
    Expect(0, 1833, '\P{Is_Jg=qaph}', "");
    Expect(1, 1833, '\P{^Is_Jg=qaph}', "");
    Expect(0, 1834, '\p{Is_Jg=qaph}', "");
    Expect(1, 1834, '\p{^Is_Jg=qaph}', "");
    Expect(1, 1834, '\P{Is_Jg=qaph}', "");
    Expect(0, 1834, '\P{^Is_Jg=qaph}', "");
    Expect(1, 1833, '\p{Is_Jg=		qaph}', "");
    Expect(0, 1833, '\p{^Is_Jg=		qaph}', "");
    Expect(0, 1833, '\P{Is_Jg=		qaph}', "");
    Expect(1, 1833, '\P{^Is_Jg=		qaph}', "");
    Expect(0, 1834, '\p{Is_Jg=		qaph}', "");
    Expect(1, 1834, '\p{^Is_Jg=		qaph}', "");
    Expect(1, 1834, '\P{Is_Jg=		qaph}', "");
    Expect(0, 1834, '\P{^Is_Jg=		qaph}', "");
    Error('\p{Joining_Group=/a/Reh}');
    Error('\P{Joining_Group=/a/Reh}');
    Expect(1, 2233, '\p{Joining_Group=:\AReh\z:}', "");;
    Expect(0, 2234, '\p{Joining_Group=:\AReh\z:}', "");;
    Expect(1, 2233, '\p{Joining_Group=reh}', "");
    Expect(0, 2233, '\p{^Joining_Group=reh}', "");
    Expect(0, 2233, '\P{Joining_Group=reh}', "");
    Expect(1, 2233, '\P{^Joining_Group=reh}', "");
    Expect(0, 2234, '\p{Joining_Group=reh}', "");
    Expect(1, 2234, '\p{^Joining_Group=reh}', "");
    Expect(1, 2234, '\P{Joining_Group=reh}', "");
    Expect(0, 2234, '\P{^Joining_Group=reh}', "");
    Expect(1, 2233, '\p{Joining_Group=:\Areh\z:}', "");;
    Expect(0, 2234, '\p{Joining_Group=:\Areh\z:}', "");;
    Expect(1, 2233, '\p{Joining_Group=	reh}', "");
    Expect(0, 2233, '\p{^Joining_Group=	reh}', "");
    Expect(0, 2233, '\P{Joining_Group=	reh}', "");
    Expect(1, 2233, '\P{^Joining_Group=	reh}', "");
    Expect(0, 2234, '\p{Joining_Group=	reh}', "");
    Expect(1, 2234, '\p{^Joining_Group=	reh}', "");
    Expect(1, 2234, '\P{Joining_Group=	reh}', "");
    Expect(0, 2234, '\P{^Joining_Group=	reh}', "");
    Error('\p{Jg=/a/ -Reh}');
    Error('\P{Jg=/a/ -Reh}');
    Expect(1, 2233, '\p{Jg=:\AReh\z:}', "");;
    Expect(0, 2234, '\p{Jg=:\AReh\z:}', "");;
    Expect(1, 2233, '\p{Jg=reh}', "");
    Expect(0, 2233, '\p{^Jg=reh}', "");
    Expect(0, 2233, '\P{Jg=reh}', "");
    Expect(1, 2233, '\P{^Jg=reh}', "");
    Expect(0, 2234, '\p{Jg=reh}', "");
    Expect(1, 2234, '\p{^Jg=reh}', "");
    Expect(1, 2234, '\P{Jg=reh}', "");
    Expect(0, 2234, '\P{^Jg=reh}', "");
    Expect(1, 2233, '\p{Jg=:\Areh\z:}', "");;
    Expect(0, 2234, '\p{Jg=:\Areh\z:}', "");;
    Expect(1, 2233, '\p{Jg=-	Reh}', "");
    Expect(0, 2233, '\p{^Jg=-	Reh}', "");
    Expect(0, 2233, '\P{Jg=-	Reh}', "");
    Expect(1, 2233, '\P{^Jg=-	Reh}', "");
    Expect(0, 2234, '\p{Jg=-	Reh}', "");
    Expect(1, 2234, '\p{^Jg=-	Reh}', "");
    Expect(1, 2234, '\P{Jg=-	Reh}', "");
    Expect(0, 2234, '\P{^Jg=-	Reh}', "");
    Error('\p{Is_Joining_Group:	:=_ reh}');
    Error('\P{Is_Joining_Group:	:=_ reh}');
    Expect(1, 2233, '\p{Is_Joining_Group=reh}', "");
    Expect(0, 2233, '\p{^Is_Joining_Group=reh}', "");
    Expect(0, 2233, '\P{Is_Joining_Group=reh}', "");
    Expect(1, 2233, '\P{^Is_Joining_Group=reh}', "");
    Expect(0, 2234, '\p{Is_Joining_Group=reh}', "");
    Expect(1, 2234, '\p{^Is_Joining_Group=reh}', "");
    Expect(1, 2234, '\P{Is_Joining_Group=reh}', "");
    Expect(0, 2234, '\P{^Is_Joining_Group=reh}', "");
    Expect(1, 2233, '\p{Is_Joining_Group:	_Reh}', "");
    Expect(0, 2233, '\p{^Is_Joining_Group:	_Reh}', "");
    Expect(0, 2233, '\P{Is_Joining_Group:	_Reh}', "");
    Expect(1, 2233, '\P{^Is_Joining_Group:	_Reh}', "");
    Expect(0, 2234, '\p{Is_Joining_Group:	_Reh}', "");
    Expect(1, 2234, '\p{^Is_Joining_Group:	_Reh}', "");
    Expect(1, 2234, '\P{Is_Joining_Group:	_Reh}', "");
    Expect(0, 2234, '\P{^Is_Joining_Group:	_Reh}', "");
    Error('\p{Is_Jg=	Reh/a/}');
    Error('\P{Is_Jg=	Reh/a/}');
    Expect(1, 2233, '\p{Is_Jg=reh}', "");
    Expect(0, 2233, '\p{^Is_Jg=reh}', "");
    Expect(0, 2233, '\P{Is_Jg=reh}', "");
    Expect(1, 2233, '\P{^Is_Jg=reh}', "");
    Expect(0, 2234, '\p{Is_Jg=reh}', "");
    Expect(1, 2234, '\p{^Is_Jg=reh}', "");
    Expect(1, 2234, '\P{Is_Jg=reh}', "");
    Expect(0, 2234, '\P{^Is_Jg=reh}', "");
    Expect(1, 2233, '\p{Is_Jg= _Reh}', "");
    Expect(0, 2233, '\p{^Is_Jg= _Reh}', "");
    Expect(0, 2233, '\P{Is_Jg= _Reh}', "");
    Expect(1, 2233, '\P{^Is_Jg= _Reh}', "");
    Expect(0, 2234, '\p{Is_Jg= _Reh}', "");
    Expect(1, 2234, '\p{^Is_Jg= _Reh}', "");
    Expect(1, 2234, '\P{Is_Jg= _Reh}', "");
    Expect(0, 2234, '\P{^Is_Jg= _Reh}', "");
    Error('\p{Joining_Group:	-	REVERSED_PE/a/}');
    Error('\P{Joining_Group:	-	REVERSED_PE/a/}');
    Expect(1, 1831, '\p{Joining_Group=:\AReversed_Pe\z:}', "");;
    Expect(0, 1832, '\p{Joining_Group=:\AReversed_Pe\z:}', "");;
    Expect(1, 1831, '\p{Joining_Group=reversedpe}', "");
    Expect(0, 1831, '\p{^Joining_Group=reversedpe}', "");
    Expect(0, 1831, '\P{Joining_Group=reversedpe}', "");
    Expect(1, 1831, '\P{^Joining_Group=reversedpe}', "");
    Expect(0, 1832, '\p{Joining_Group=reversedpe}', "");
    Expect(1, 1832, '\p{^Joining_Group=reversedpe}', "");
    Expect(1, 1832, '\P{Joining_Group=reversedpe}', "");
    Expect(0, 1832, '\P{^Joining_Group=reversedpe}', "");
    Expect(1, 1831, '\p{Joining_Group=:\Areversedpe\z:}', "");;
    Expect(0, 1832, '\p{Joining_Group=:\Areversedpe\z:}', "");;
    Expect(1, 1831, '\p{Joining_Group: -REVERSED_PE}', "");
    Expect(0, 1831, '\p{^Joining_Group: -REVERSED_PE}', "");
    Expect(0, 1831, '\P{Joining_Group: -REVERSED_PE}', "");
    Expect(1, 1831, '\P{^Joining_Group: -REVERSED_PE}', "");
    Expect(0, 1832, '\p{Joining_Group: -REVERSED_PE}', "");
    Expect(1, 1832, '\p{^Joining_Group: -REVERSED_PE}', "");
    Expect(1, 1832, '\P{Joining_Group: -REVERSED_PE}', "");
    Expect(0, 1832, '\P{^Joining_Group: -REVERSED_PE}', "");
    Error('\p{Jg=/a/- Reversed_Pe}');
    Error('\P{Jg=/a/- Reversed_Pe}');
    Expect(1, 1831, '\p{Jg=:\AReversed_Pe\z:}', "");;
    Expect(0, 1832, '\p{Jg=:\AReversed_Pe\z:}', "");;
    Expect(1, 1831, '\p{Jg=reversedpe}', "");
    Expect(0, 1831, '\p{^Jg=reversedpe}', "");
    Expect(0, 1831, '\P{Jg=reversedpe}', "");
    Expect(1, 1831, '\P{^Jg=reversedpe}', "");
    Expect(0, 1832, '\p{Jg=reversedpe}', "");
    Expect(1, 1832, '\p{^Jg=reversedpe}', "");
    Expect(1, 1832, '\P{Jg=reversedpe}', "");
    Expect(0, 1832, '\P{^Jg=reversedpe}', "");
    Expect(1, 1831, '\p{Jg=:\Areversedpe\z:}', "");;
    Expect(0, 1832, '\p{Jg=:\Areversedpe\z:}', "");;
    Expect(1, 1831, '\p{Jg=__reversed_Pe}', "");
    Expect(0, 1831, '\p{^Jg=__reversed_Pe}', "");
    Expect(0, 1831, '\P{Jg=__reversed_Pe}', "");
    Expect(1, 1831, '\P{^Jg=__reversed_Pe}', "");
    Expect(0, 1832, '\p{Jg=__reversed_Pe}', "");
    Expect(1, 1832, '\p{^Jg=__reversed_Pe}', "");
    Expect(1, 1832, '\P{Jg=__reversed_Pe}', "");
    Expect(0, 1832, '\P{^Jg=__reversed_Pe}', "");
    Error('\p{Is_Joining_Group=-:=reversed_PE}');
    Error('\P{Is_Joining_Group=-:=reversed_PE}');
    Expect(1, 1831, '\p{Is_Joining_Group=reversedpe}', "");
    Expect(0, 1831, '\p{^Is_Joining_Group=reversedpe}', "");
    Expect(0, 1831, '\P{Is_Joining_Group=reversedpe}', "");
    Expect(1, 1831, '\P{^Is_Joining_Group=reversedpe}', "");
    Expect(0, 1832, '\p{Is_Joining_Group=reversedpe}', "");
    Expect(1, 1832, '\p{^Is_Joining_Group=reversedpe}', "");
    Expect(1, 1832, '\P{Is_Joining_Group=reversedpe}', "");
    Expect(0, 1832, '\P{^Is_Joining_Group=reversedpe}', "");
    Expect(1, 1831, '\p{Is_Joining_Group= 	reversed_Pe}', "");
    Expect(0, 1831, '\p{^Is_Joining_Group= 	reversed_Pe}', "");
    Expect(0, 1831, '\P{Is_Joining_Group= 	reversed_Pe}', "");
    Expect(1, 1831, '\P{^Is_Joining_Group= 	reversed_Pe}', "");
    Expect(0, 1832, '\p{Is_Joining_Group= 	reversed_Pe}', "");
    Expect(1, 1832, '\p{^Is_Joining_Group= 	reversed_Pe}', "");
    Expect(1, 1832, '\P{Is_Joining_Group= 	reversed_Pe}', "");
    Expect(0, 1832, '\P{^Is_Joining_Group= 	reversed_Pe}', "");
    Error('\p{Is_Jg=/a/-	Reversed_Pe}');
    Error('\P{Is_Jg=/a/-	Reversed_Pe}');
    Expect(1, 1831, '\p{Is_Jg=reversedpe}', "");
    Expect(0, 1831, '\p{^Is_Jg=reversedpe}', "");
    Expect(0, 1831, '\P{Is_Jg=reversedpe}', "");
    Expect(1, 1831, '\P{^Is_Jg=reversedpe}', "");
    Expect(0, 1832, '\p{Is_Jg=reversedpe}', "");
    Expect(1, 1832, '\p{^Is_Jg=reversedpe}', "");
    Expect(1, 1832, '\P{Is_Jg=reversedpe}', "");
    Expect(0, 1832, '\P{^Is_Jg=reversedpe}', "");
    Expect(1, 1831, '\p{Is_Jg=	REVERSED_pe}', "");
    Expect(0, 1831, '\p{^Is_Jg=	REVERSED_pe}', "");
    Expect(0, 1831, '\P{Is_Jg=	REVERSED_pe}', "");
    Expect(1, 1831, '\P{^Is_Jg=	REVERSED_pe}', "");
    Expect(0, 1832, '\p{Is_Jg=	REVERSED_pe}', "");
    Expect(1, 1832, '\p{^Is_Jg=	REVERSED_pe}', "");
    Expect(1, 1832, '\P{Is_Jg=	REVERSED_pe}', "");
    Expect(0, 1832, '\P{^Is_Jg=	REVERSED_pe}', "");
    Error('\p{Joining_Group=/a/-rohingya_Yeh}');
    Error('\P{Joining_Group=/a/-rohingya_Yeh}');
    Expect(1, 2220, '\p{Joining_Group=:\ARohingya_Yeh\z:}', "");;
    Expect(0, 2221, '\p{Joining_Group=:\ARohingya_Yeh\z:}', "");;
    Expect(1, 2220, '\p{Joining_Group=rohingyayeh}', "");
    Expect(0, 2220, '\p{^Joining_Group=rohingyayeh}', "");
    Expect(0, 2220, '\P{Joining_Group=rohingyayeh}', "");
    Expect(1, 2220, '\P{^Joining_Group=rohingyayeh}', "");
    Expect(0, 2221, '\p{Joining_Group=rohingyayeh}', "");
    Expect(1, 2221, '\p{^Joining_Group=rohingyayeh}', "");
    Expect(1, 2221, '\P{Joining_Group=rohingyayeh}', "");
    Expect(0, 2221, '\P{^Joining_Group=rohingyayeh}', "");
    Expect(1, 2220, '\p{Joining_Group=:\Arohingyayeh\z:}', "");;
    Expect(0, 2221, '\p{Joining_Group=:\Arohingyayeh\z:}', "");;
    Expect(1, 2220, '\p{Joining_Group=		rohingya_Yeh}', "");
    Expect(0, 2220, '\p{^Joining_Group=		rohingya_Yeh}', "");
    Expect(0, 2220, '\P{Joining_Group=		rohingya_Yeh}', "");
    Expect(1, 2220, '\P{^Joining_Group=		rohingya_Yeh}', "");
    Expect(0, 2221, '\p{Joining_Group=		rohingya_Yeh}', "");
    Expect(1, 2221, '\p{^Joining_Group=		rohingya_Yeh}', "");
    Expect(1, 2221, '\P{Joining_Group=		rohingya_Yeh}', "");
    Expect(0, 2221, '\P{^Joining_Group=		rohingya_Yeh}', "");
    Error('\p{Jg=/a/-_Rohingya_YEH}');
    Error('\P{Jg=/a/-_Rohingya_YEH}');
    Expect(1, 2220, '\p{Jg=:\ARohingya_Yeh\z:}', "");;
    Expect(0, 2221, '\p{Jg=:\ARohingya_Yeh\z:}', "");;
    Expect(1, 2220, '\p{Jg=rohingyayeh}', "");
    Expect(0, 2220, '\p{^Jg=rohingyayeh}', "");
    Expect(0, 2220, '\P{Jg=rohingyayeh}', "");
    Expect(1, 2220, '\P{^Jg=rohingyayeh}', "");
    Expect(0, 2221, '\p{Jg=rohingyayeh}', "");
    Expect(1, 2221, '\p{^Jg=rohingyayeh}', "");
    Expect(1, 2221, '\P{Jg=rohingyayeh}', "");
    Expect(0, 2221, '\P{^Jg=rohingyayeh}', "");
    Expect(1, 2220, '\p{Jg=:\Arohingyayeh\z:}', "");;
    Expect(0, 2221, '\p{Jg=:\Arohingyayeh\z:}', "");;
    Expect(1, 2220, '\p{Jg=-	Rohingya_Yeh}', "");
    Expect(0, 2220, '\p{^Jg=-	Rohingya_Yeh}', "");
    Expect(0, 2220, '\P{Jg=-	Rohingya_Yeh}', "");
    Expect(1, 2220, '\P{^Jg=-	Rohingya_Yeh}', "");
    Expect(0, 2221, '\p{Jg=-	Rohingya_Yeh}', "");
    Expect(1, 2221, '\p{^Jg=-	Rohingya_Yeh}', "");
    Expect(1, 2221, '\P{Jg=-	Rohingya_Yeh}', "");
    Expect(0, 2221, '\P{^Jg=-	Rohingya_Yeh}', "");
    Error('\p{Is_Joining_Group: _Rohingya_yeh/a/}');
    Error('\P{Is_Joining_Group: _Rohingya_yeh/a/}');
    Expect(1, 2220, '\p{Is_Joining_Group=rohingyayeh}', "");
    Expect(0, 2220, '\p{^Is_Joining_Group=rohingyayeh}', "");
    Expect(0, 2220, '\P{Is_Joining_Group=rohingyayeh}', "");
    Expect(1, 2220, '\P{^Is_Joining_Group=rohingyayeh}', "");
    Expect(0, 2221, '\p{Is_Joining_Group=rohingyayeh}', "");
    Expect(1, 2221, '\p{^Is_Joining_Group=rohingyayeh}', "");
    Expect(1, 2221, '\P{Is_Joining_Group=rohingyayeh}', "");
    Expect(0, 2221, '\P{^Is_Joining_Group=rohingyayeh}', "");
    Expect(1, 2220, '\p{Is_Joining_Group= 	ROHINGYA_YEH}', "");
    Expect(0, 2220, '\p{^Is_Joining_Group= 	ROHINGYA_YEH}', "");
    Expect(0, 2220, '\P{Is_Joining_Group= 	ROHINGYA_YEH}', "");
    Expect(1, 2220, '\P{^Is_Joining_Group= 	ROHINGYA_YEH}', "");
    Expect(0, 2221, '\p{Is_Joining_Group= 	ROHINGYA_YEH}', "");
    Expect(1, 2221, '\p{^Is_Joining_Group= 	ROHINGYA_YEH}', "");
    Expect(1, 2221, '\P{Is_Joining_Group= 	ROHINGYA_YEH}', "");
    Expect(0, 2221, '\P{^Is_Joining_Group= 	ROHINGYA_YEH}', "");
    Error('\p{Is_Jg=/a/__rohingya_Yeh}');
    Error('\P{Is_Jg=/a/__rohingya_Yeh}');
    Expect(1, 2220, '\p{Is_Jg=rohingyayeh}', "");
    Expect(0, 2220, '\p{^Is_Jg=rohingyayeh}', "");
    Expect(0, 2220, '\P{Is_Jg=rohingyayeh}', "");
    Expect(1, 2220, '\P{^Is_Jg=rohingyayeh}', "");
    Expect(0, 2221, '\p{Is_Jg=rohingyayeh}', "");
    Expect(1, 2221, '\p{^Is_Jg=rohingyayeh}', "");
    Expect(1, 2221, '\P{Is_Jg=rohingyayeh}', "");
    Expect(0, 2221, '\P{^Is_Jg=rohingyayeh}', "");
    Expect(1, 2220, '\p{Is_Jg=-ROHINGYA_Yeh}', "");
    Expect(0, 2220, '\p{^Is_Jg=-ROHINGYA_Yeh}', "");
    Expect(0, 2220, '\P{Is_Jg=-ROHINGYA_Yeh}', "");
    Expect(1, 2220, '\P{^Is_Jg=-ROHINGYA_Yeh}', "");
    Expect(0, 2221, '\p{Is_Jg=-ROHINGYA_Yeh}', "");
    Expect(1, 2221, '\p{^Is_Jg=-ROHINGYA_Yeh}', "");
    Expect(1, 2221, '\P{Is_Jg=-ROHINGYA_Yeh}', "");
    Expect(0, 2221, '\P{^Is_Jg=-ROHINGYA_Yeh}', "");
    Error('\p{Joining_Group=:=_Sad}');
    Error('\P{Joining_Group=:=_Sad}');
    Expect(1, 2223, '\p{Joining_Group=:\ASad\z:}', "");;
    Expect(0, 2224, '\p{Joining_Group=:\ASad\z:}', "");;
    Expect(1, 2223, '\p{Joining_Group=sad}', "");
    Expect(0, 2223, '\p{^Joining_Group=sad}', "");
    Expect(0, 2223, '\P{Joining_Group=sad}', "");
    Expect(1, 2223, '\P{^Joining_Group=sad}', "");
    Expect(0, 2224, '\p{Joining_Group=sad}', "");
    Expect(1, 2224, '\p{^Joining_Group=sad}', "");
    Expect(1, 2224, '\P{Joining_Group=sad}', "");
    Expect(0, 2224, '\P{^Joining_Group=sad}', "");
    Expect(1, 2223, '\p{Joining_Group=:\Asad\z:}', "");;
    Expect(0, 2224, '\p{Joining_Group=:\Asad\z:}', "");;
    Expect(1, 2223, '\p{Joining_Group=	Sad}', "");
    Expect(0, 2223, '\p{^Joining_Group=	Sad}', "");
    Expect(0, 2223, '\P{Joining_Group=	Sad}', "");
    Expect(1, 2223, '\P{^Joining_Group=	Sad}', "");
    Expect(0, 2224, '\p{Joining_Group=	Sad}', "");
    Expect(1, 2224, '\p{^Joining_Group=	Sad}', "");
    Expect(1, 2224, '\P{Joining_Group=	Sad}', "");
    Expect(0, 2224, '\P{^Joining_Group=	Sad}', "");
    Error('\p{Jg= -Sad:=}');
    Error('\P{Jg= -Sad:=}');
    Expect(1, 2223, '\p{Jg=:\ASad\z:}', "");;
    Expect(0, 2224, '\p{Jg=:\ASad\z:}', "");;
    Expect(1, 2223, '\p{Jg=sad}', "");
    Expect(0, 2223, '\p{^Jg=sad}', "");
    Expect(0, 2223, '\P{Jg=sad}', "");
    Expect(1, 2223, '\P{^Jg=sad}', "");
    Expect(0, 2224, '\p{Jg=sad}', "");
    Expect(1, 2224, '\p{^Jg=sad}', "");
    Expect(1, 2224, '\P{Jg=sad}', "");
    Expect(0, 2224, '\P{^Jg=sad}', "");
    Expect(1, 2223, '\p{Jg=:\Asad\z:}', "");;
    Expect(0, 2224, '\p{Jg=:\Asad\z:}', "");;
    Expect(1, 2223, '\p{Jg: -	Sad}', "");
    Expect(0, 2223, '\p{^Jg: -	Sad}', "");
    Expect(0, 2223, '\P{Jg: -	Sad}', "");
    Expect(1, 2223, '\P{^Jg: -	Sad}', "");
    Expect(0, 2224, '\p{Jg: -	Sad}', "");
    Expect(1, 2224, '\p{^Jg: -	Sad}', "");
    Expect(1, 2224, '\P{Jg: -	Sad}', "");
    Expect(0, 2224, '\P{^Jg: -	Sad}', "");
    Error('\p{Is_Joining_Group=-/a/Sad}');
    Error('\P{Is_Joining_Group=-/a/Sad}');
    Expect(1, 2223, '\p{Is_Joining_Group: sad}', "");
    Expect(0, 2223, '\p{^Is_Joining_Group: sad}', "");
    Expect(0, 2223, '\P{Is_Joining_Group: sad}', "");
    Expect(1, 2223, '\P{^Is_Joining_Group: sad}', "");
    Expect(0, 2224, '\p{Is_Joining_Group: sad}', "");
    Expect(1, 2224, '\p{^Is_Joining_Group: sad}', "");
    Expect(1, 2224, '\P{Is_Joining_Group: sad}', "");
    Expect(0, 2224, '\P{^Is_Joining_Group: sad}', "");
    Expect(1, 2223, '\p{Is_Joining_Group:	_ Sad}', "");
    Expect(0, 2223, '\p{^Is_Joining_Group:	_ Sad}', "");
    Expect(0, 2223, '\P{Is_Joining_Group:	_ Sad}', "");
    Expect(1, 2223, '\P{^Is_Joining_Group:	_ Sad}', "");
    Expect(0, 2224, '\p{Is_Joining_Group:	_ Sad}', "");
    Expect(1, 2224, '\p{^Is_Joining_Group:	_ Sad}', "");
    Expect(1, 2224, '\P{Is_Joining_Group:	_ Sad}', "");
    Expect(0, 2224, '\P{^Is_Joining_Group:	_ Sad}', "");
    Error('\p{Is_Jg=-/a/sad}');
    Error('\P{Is_Jg=-/a/sad}');
    Expect(1, 2223, '\p{Is_Jg:   sad}', "");
    Expect(0, 2223, '\p{^Is_Jg:   sad}', "");
    Expect(0, 2223, '\P{Is_Jg:   sad}', "");
    Expect(1, 2223, '\P{^Is_Jg:   sad}', "");
    Expect(0, 2224, '\p{Is_Jg:   sad}', "");
    Expect(1, 2224, '\p{^Is_Jg:   sad}', "");
    Expect(1, 2224, '\P{Is_Jg:   sad}', "");
    Expect(0, 2224, '\P{^Is_Jg:   sad}', "");
    Expect(1, 2223, '\p{Is_Jg=-Sad}', "");
    Expect(0, 2223, '\p{^Is_Jg=-Sad}', "");
    Expect(0, 2223, '\P{Is_Jg=-Sad}', "");
    Expect(1, 2223, '\P{^Is_Jg=-Sad}', "");
    Expect(0, 2224, '\p{Is_Jg=-Sad}', "");
    Expect(1, 2224, '\p{^Is_Jg=-Sad}', "");
    Expect(1, 2224, '\P{Is_Jg=-Sad}', "");
    Expect(0, 2224, '\P{^Is_Jg=-Sad}', "");
    Error('\p{Joining_Group=_ Sadhe:=}');
    Error('\P{Joining_Group=_ Sadhe:=}');
    Expect(1, 1832, '\p{Joining_Group=:\ASadhe\z:}', "");;
    Expect(0, 1833, '\p{Joining_Group=:\ASadhe\z:}', "");;
    Expect(1, 1832, '\p{Joining_Group=sadhe}', "");
    Expect(0, 1832, '\p{^Joining_Group=sadhe}', "");
    Expect(0, 1832, '\P{Joining_Group=sadhe}', "");
    Expect(1, 1832, '\P{^Joining_Group=sadhe}', "");
    Expect(0, 1833, '\p{Joining_Group=sadhe}', "");
    Expect(1, 1833, '\p{^Joining_Group=sadhe}', "");
    Expect(1, 1833, '\P{Joining_Group=sadhe}', "");
    Expect(0, 1833, '\P{^Joining_Group=sadhe}', "");
    Expect(1, 1832, '\p{Joining_Group=:\Asadhe\z:}', "");;
    Expect(0, 1833, '\p{Joining_Group=:\Asadhe\z:}', "");;
    Expect(1, 1832, '\p{Joining_Group= _Sadhe}', "");
    Expect(0, 1832, '\p{^Joining_Group= _Sadhe}', "");
    Expect(0, 1832, '\P{Joining_Group= _Sadhe}', "");
    Expect(1, 1832, '\P{^Joining_Group= _Sadhe}', "");
    Expect(0, 1833, '\p{Joining_Group= _Sadhe}', "");
    Expect(1, 1833, '\p{^Joining_Group= _Sadhe}', "");
    Expect(1, 1833, '\P{Joining_Group= _Sadhe}', "");
    Expect(0, 1833, '\P{^Joining_Group= _Sadhe}', "");
    Error('\p{Jg=_:=sadhe}');
    Error('\P{Jg=_:=sadhe}');
    Expect(1, 1832, '\p{Jg=:\ASadhe\z:}', "");;
    Expect(0, 1833, '\p{Jg=:\ASadhe\z:}', "");;
    Expect(1, 1832, '\p{Jg=sadhe}', "");
    Expect(0, 1832, '\p{^Jg=sadhe}', "");
    Expect(0, 1832, '\P{Jg=sadhe}', "");
    Expect(1, 1832, '\P{^Jg=sadhe}', "");
    Expect(0, 1833, '\p{Jg=sadhe}', "");
    Expect(1, 1833, '\p{^Jg=sadhe}', "");
    Expect(1, 1833, '\P{Jg=sadhe}', "");
    Expect(0, 1833, '\P{^Jg=sadhe}', "");
    Expect(1, 1832, '\p{Jg=:\Asadhe\z:}', "");;
    Expect(0, 1833, '\p{Jg=:\Asadhe\z:}', "");;
    Expect(1, 1832, '\p{Jg= -sadhe}', "");
    Expect(0, 1832, '\p{^Jg= -sadhe}', "");
    Expect(0, 1832, '\P{Jg= -sadhe}', "");
    Expect(1, 1832, '\P{^Jg= -sadhe}', "");
    Expect(0, 1833, '\p{Jg= -sadhe}', "");
    Expect(1, 1833, '\p{^Jg= -sadhe}', "");
    Expect(1, 1833, '\P{Jg= -sadhe}', "");
    Expect(0, 1833, '\P{^Jg= -sadhe}', "");
    Error('\p{Is_Joining_Group=/a/_SADHE}');
    Error('\P{Is_Joining_Group=/a/_SADHE}');
    Expect(1, 1832, '\p{Is_Joining_Group=sadhe}', "");
    Expect(0, 1832, '\p{^Is_Joining_Group=sadhe}', "");
    Expect(0, 1832, '\P{Is_Joining_Group=sadhe}', "");
    Expect(1, 1832, '\P{^Is_Joining_Group=sadhe}', "");
    Expect(0, 1833, '\p{Is_Joining_Group=sadhe}', "");
    Expect(1, 1833, '\p{^Is_Joining_Group=sadhe}', "");
    Expect(1, 1833, '\P{Is_Joining_Group=sadhe}', "");
    Expect(0, 1833, '\P{^Is_Joining_Group=sadhe}', "");
    Expect(1, 1832, '\p{Is_Joining_Group=	_Sadhe}', "");
    Expect(0, 1832, '\p{^Is_Joining_Group=	_Sadhe}', "");
    Expect(0, 1832, '\P{Is_Joining_Group=	_Sadhe}', "");
    Expect(1, 1832, '\P{^Is_Joining_Group=	_Sadhe}', "");
    Expect(0, 1833, '\p{Is_Joining_Group=	_Sadhe}', "");
    Expect(1, 1833, '\p{^Is_Joining_Group=	_Sadhe}', "");
    Expect(1, 1833, '\P{Is_Joining_Group=	_Sadhe}', "");
    Expect(0, 1833, '\P{^Is_Joining_Group=	_Sadhe}', "");
    Error('\p{Is_Jg=-sadhe:=}');
    Error('\P{Is_Jg=-sadhe:=}');
    Expect(1, 1832, '\p{Is_Jg:sadhe}', "");
    Expect(0, 1832, '\p{^Is_Jg:sadhe}', "");
    Expect(0, 1832, '\P{Is_Jg:sadhe}', "");
    Expect(1, 1832, '\P{^Is_Jg:sadhe}', "");
    Expect(0, 1833, '\p{Is_Jg:sadhe}', "");
    Expect(1, 1833, '\p{^Is_Jg:sadhe}', "");
    Expect(1, 1833, '\P{Is_Jg:sadhe}', "");
    Expect(0, 1833, '\P{^Is_Jg:sadhe}', "");
    Expect(1, 1832, '\p{Is_Jg:-sadhe}', "");
    Expect(0, 1832, '\p{^Is_Jg:-sadhe}', "");
    Expect(0, 1832, '\P{Is_Jg:-sadhe}', "");
    Expect(1, 1832, '\P{^Is_Jg:-sadhe}', "");
    Expect(0, 1833, '\p{Is_Jg:-sadhe}', "");
    Expect(1, 1833, '\p{^Is_Jg:-sadhe}', "");
    Expect(1, 1833, '\P{Is_Jg:-sadhe}', "");
    Expect(0, 1833, '\P{^Is_Jg:-sadhe}', "");
    Error('\p{Joining_Group= :=Seen}');
    Error('\P{Joining_Group= :=Seen}');
    Expect(1, 1918, '\p{Joining_Group=:\ASeen\z:}', "");;
    Expect(0, 1919, '\p{Joining_Group=:\ASeen\z:}', "");;
    Expect(1, 1918, '\p{Joining_Group=seen}', "");
    Expect(0, 1918, '\p{^Joining_Group=seen}', "");
    Expect(0, 1918, '\P{Joining_Group=seen}', "");
    Expect(1, 1918, '\P{^Joining_Group=seen}', "");
    Expect(0, 1919, '\p{Joining_Group=seen}', "");
    Expect(1, 1919, '\p{^Joining_Group=seen}', "");
    Expect(1, 1919, '\P{Joining_Group=seen}', "");
    Expect(0, 1919, '\P{^Joining_Group=seen}', "");
    Expect(1, 1918, '\p{Joining_Group=:\Aseen\z:}', "");;
    Expect(0, 1919, '\p{Joining_Group=:\Aseen\z:}', "");;
    Expect(1, 1918, '\p{Joining_Group=- seen}', "");
    Expect(0, 1918, '\p{^Joining_Group=- seen}', "");
    Expect(0, 1918, '\P{Joining_Group=- seen}', "");
    Expect(1, 1918, '\P{^Joining_Group=- seen}', "");
    Expect(0, 1919, '\p{Joining_Group=- seen}', "");
    Expect(1, 1919, '\p{^Joining_Group=- seen}', "");
    Expect(1, 1919, '\P{Joining_Group=- seen}', "");
    Expect(0, 1919, '\P{^Joining_Group=- seen}', "");
    Error('\p{Jg=-_seen/a/}');
    Error('\P{Jg=-_seen/a/}');
    Expect(1, 1918, '\p{Jg=:\ASeen\z:}', "");;
    Expect(0, 1919, '\p{Jg=:\ASeen\z:}', "");;
    Expect(1, 1918, '\p{Jg=seen}', "");
    Expect(0, 1918, '\p{^Jg=seen}', "");
    Expect(0, 1918, '\P{Jg=seen}', "");
    Expect(1, 1918, '\P{^Jg=seen}', "");
    Expect(0, 1919, '\p{Jg=seen}', "");
    Expect(1, 1919, '\p{^Jg=seen}', "");
    Expect(1, 1919, '\P{Jg=seen}', "");
    Expect(0, 1919, '\P{^Jg=seen}', "");
    Expect(1, 1918, '\p{Jg=:\Aseen\z:}', "");;
    Expect(0, 1919, '\p{Jg=:\Aseen\z:}', "");;
    Expect(1, 1918, '\p{Jg= _SEEN}', "");
    Expect(0, 1918, '\p{^Jg= _SEEN}', "");
    Expect(0, 1918, '\P{Jg= _SEEN}', "");
    Expect(1, 1918, '\P{^Jg= _SEEN}', "");
    Expect(0, 1919, '\p{Jg= _SEEN}', "");
    Expect(1, 1919, '\p{^Jg= _SEEN}', "");
    Expect(1, 1919, '\P{Jg= _SEEN}', "");
    Expect(0, 1919, '\P{^Jg= _SEEN}', "");
    Error('\p{Is_Joining_Group=_/a/Seen}');
    Error('\P{Is_Joining_Group=_/a/Seen}');
    Expect(1, 1918, '\p{Is_Joining_Group=seen}', "");
    Expect(0, 1918, '\p{^Is_Joining_Group=seen}', "");
    Expect(0, 1918, '\P{Is_Joining_Group=seen}', "");
    Expect(1, 1918, '\P{^Is_Joining_Group=seen}', "");
    Expect(0, 1919, '\p{Is_Joining_Group=seen}', "");
    Expect(1, 1919, '\p{^Is_Joining_Group=seen}', "");
    Expect(1, 1919, '\P{Is_Joining_Group=seen}', "");
    Expect(0, 1919, '\P{^Is_Joining_Group=seen}', "");
    Expect(1, 1918, '\p{Is_Joining_Group=	_Seen}', "");
    Expect(0, 1918, '\p{^Is_Joining_Group=	_Seen}', "");
    Expect(0, 1918, '\P{Is_Joining_Group=	_Seen}', "");
    Expect(1, 1918, '\P{^Is_Joining_Group=	_Seen}', "");
    Expect(0, 1919, '\p{Is_Joining_Group=	_Seen}', "");
    Expect(1, 1919, '\p{^Is_Joining_Group=	_Seen}', "");
    Expect(1, 1919, '\P{Is_Joining_Group=	_Seen}', "");
    Expect(0, 1919, '\P{^Is_Joining_Group=	_Seen}', "");
    Error('\p{Is_Jg=/a/ _Seen}');
    Error('\P{Is_Jg=/a/ _Seen}');
    Expect(1, 1918, '\p{Is_Jg=seen}', "");
    Expect(0, 1918, '\p{^Is_Jg=seen}', "");
    Expect(0, 1918, '\P{Is_Jg=seen}', "");
    Expect(1, 1918, '\P{^Is_Jg=seen}', "");
    Expect(0, 1919, '\p{Is_Jg=seen}', "");
    Expect(1, 1919, '\p{^Is_Jg=seen}', "");
    Expect(1, 1919, '\P{Is_Jg=seen}', "");
    Expect(0, 1919, '\P{^Is_Jg=seen}', "");
    Expect(1, 1918, '\p{Is_Jg=	-Seen}', "");
    Expect(0, 1918, '\p{^Is_Jg=	-Seen}', "");
    Expect(0, 1918, '\P{Is_Jg=	-Seen}', "");
    Expect(1, 1918, '\P{^Is_Jg=	-Seen}', "");
    Expect(0, 1919, '\p{Is_Jg=	-Seen}', "");
    Expect(1, 1919, '\p{^Is_Jg=	-Seen}', "");
    Expect(1, 1919, '\P{Is_Jg=	-Seen}', "");
    Expect(0, 1919, '\P{^Is_Jg=	-Seen}', "");
    Error('\p{Joining_Group=	-SEMKATH/a/}');
    Error('\P{Joining_Group=	-SEMKATH/a/}');
    Expect(1, 1827, '\p{Joining_Group=:\ASemkath\z:}', "");;
    Expect(0, 1828, '\p{Joining_Group=:\ASemkath\z:}', "");;
    Expect(1, 1827, '\p{Joining_Group=semkath}', "");
    Expect(0, 1827, '\p{^Joining_Group=semkath}', "");
    Expect(0, 1827, '\P{Joining_Group=semkath}', "");
    Expect(1, 1827, '\P{^Joining_Group=semkath}', "");
    Expect(0, 1828, '\p{Joining_Group=semkath}', "");
    Expect(1, 1828, '\p{^Joining_Group=semkath}', "");
    Expect(1, 1828, '\P{Joining_Group=semkath}', "");
    Expect(0, 1828, '\P{^Joining_Group=semkath}', "");
    Expect(1, 1827, '\p{Joining_Group=:\Asemkath\z:}', "");;
    Expect(0, 1828, '\p{Joining_Group=:\Asemkath\z:}', "");;
    Expect(1, 1827, '\p{Joining_Group=--SEMKATH}', "");
    Expect(0, 1827, '\p{^Joining_Group=--SEMKATH}', "");
    Expect(0, 1827, '\P{Joining_Group=--SEMKATH}', "");
    Expect(1, 1827, '\P{^Joining_Group=--SEMKATH}', "");
    Expect(0, 1828, '\p{Joining_Group=--SEMKATH}', "");
    Expect(1, 1828, '\p{^Joining_Group=--SEMKATH}', "");
    Expect(1, 1828, '\P{Joining_Group=--SEMKATH}', "");
    Expect(0, 1828, '\P{^Joining_Group=--SEMKATH}', "");
    Error('\p{Jg=/a/__Semkath}');
    Error('\P{Jg=/a/__Semkath}');
    Expect(1, 1827, '\p{Jg=:\ASemkath\z:}', "");;
    Expect(0, 1828, '\p{Jg=:\ASemkath\z:}', "");;
    Expect(1, 1827, '\p{Jg=semkath}', "");
    Expect(0, 1827, '\p{^Jg=semkath}', "");
    Expect(0, 1827, '\P{Jg=semkath}', "");
    Expect(1, 1827, '\P{^Jg=semkath}', "");
    Expect(0, 1828, '\p{Jg=semkath}', "");
    Expect(1, 1828, '\p{^Jg=semkath}', "");
    Expect(1, 1828, '\P{Jg=semkath}', "");
    Expect(0, 1828, '\P{^Jg=semkath}', "");
    Expect(1, 1827, '\p{Jg=:\Asemkath\z:}', "");;
    Expect(0, 1828, '\p{Jg=:\Asemkath\z:}', "");;
    Expect(1, 1827, '\p{Jg=		Semkath}', "");
    Expect(0, 1827, '\p{^Jg=		Semkath}', "");
    Expect(0, 1827, '\P{Jg=		Semkath}', "");
    Expect(1, 1827, '\P{^Jg=		Semkath}', "");
    Expect(0, 1828, '\p{Jg=		Semkath}', "");
    Expect(1, 1828, '\p{^Jg=		Semkath}', "");
    Expect(1, 1828, '\P{Jg=		Semkath}', "");
    Expect(0, 1828, '\P{^Jg=		Semkath}', "");
    Error('\p{Is_Joining_Group:		 SEMKATH/a/}');
    Error('\P{Is_Joining_Group:		 SEMKATH/a/}');
    Expect(1, 1827, '\p{Is_Joining_Group=semkath}', "");
    Expect(0, 1827, '\p{^Is_Joining_Group=semkath}', "");
    Expect(0, 1827, '\P{Is_Joining_Group=semkath}', "");
    Expect(1, 1827, '\P{^Is_Joining_Group=semkath}', "");
    Expect(0, 1828, '\p{Is_Joining_Group=semkath}', "");
    Expect(1, 1828, '\p{^Is_Joining_Group=semkath}', "");
    Expect(1, 1828, '\P{Is_Joining_Group=semkath}', "");
    Expect(0, 1828, '\P{^Is_Joining_Group=semkath}', "");
    Expect(1, 1827, '\p{Is_Joining_Group=		Semkath}', "");
    Expect(0, 1827, '\p{^Is_Joining_Group=		Semkath}', "");
    Expect(0, 1827, '\P{Is_Joining_Group=		Semkath}', "");
    Expect(1, 1827, '\P{^Is_Joining_Group=		Semkath}', "");
    Expect(0, 1828, '\p{Is_Joining_Group=		Semkath}', "");
    Expect(1, 1828, '\p{^Is_Joining_Group=		Semkath}', "");
    Expect(1, 1828, '\P{Is_Joining_Group=		Semkath}', "");
    Expect(0, 1828, '\P{^Is_Joining_Group=		Semkath}', "");
    Error('\p{Is_Jg=-_SEMKATH/a/}');
    Error('\P{Is_Jg=-_SEMKATH/a/}');
    Expect(1, 1827, '\p{Is_Jg=semkath}', "");
    Expect(0, 1827, '\p{^Is_Jg=semkath}', "");
    Expect(0, 1827, '\P{Is_Jg=semkath}', "");
    Expect(1, 1827, '\P{^Is_Jg=semkath}', "");
    Expect(0, 1828, '\p{Is_Jg=semkath}', "");
    Expect(1, 1828, '\p{^Is_Jg=semkath}', "");
    Expect(1, 1828, '\P{Is_Jg=semkath}', "");
    Expect(0, 1828, '\P{^Is_Jg=semkath}', "");
    Expect(1, 1827, '\p{Is_Jg=_ SEMKATH}', "");
    Expect(0, 1827, '\p{^Is_Jg=_ SEMKATH}', "");
    Expect(0, 1827, '\P{Is_Jg=_ SEMKATH}', "");
    Expect(1, 1827, '\P{^Is_Jg=_ SEMKATH}', "");
    Expect(0, 1828, '\p{Is_Jg=_ SEMKATH}', "");
    Expect(1, 1828, '\p{^Is_Jg=_ SEMKATH}', "");
    Expect(1, 1828, '\P{Is_Jg=_ SEMKATH}', "");
    Expect(0, 1828, '\P{^Is_Jg=_ SEMKATH}', "");
    Error('\p{Joining_Group=:=Shin}');
    Error('\P{Joining_Group=:=Shin}');
    Expect(1, 1835, '\p{Joining_Group=:\AShin\z:}', "");;
    Expect(0, 1836, '\p{Joining_Group=:\AShin\z:}', "");;
    Expect(1, 1835, '\p{Joining_Group=shin}', "");
    Expect(0, 1835, '\p{^Joining_Group=shin}', "");
    Expect(0, 1835, '\P{Joining_Group=shin}', "");
    Expect(1, 1835, '\P{^Joining_Group=shin}', "");
    Expect(0, 1836, '\p{Joining_Group=shin}', "");
    Expect(1, 1836, '\p{^Joining_Group=shin}', "");
    Expect(1, 1836, '\P{Joining_Group=shin}', "");
    Expect(0, 1836, '\P{^Joining_Group=shin}', "");
    Expect(1, 1835, '\p{Joining_Group=:\Ashin\z:}', "");;
    Expect(0, 1836, '\p{Joining_Group=:\Ashin\z:}', "");;
    Expect(1, 1835, '\p{Joining_Group=  shin}', "");
    Expect(0, 1835, '\p{^Joining_Group=  shin}', "");
    Expect(0, 1835, '\P{Joining_Group=  shin}', "");
    Expect(1, 1835, '\P{^Joining_Group=  shin}', "");
    Expect(0, 1836, '\p{Joining_Group=  shin}', "");
    Expect(1, 1836, '\p{^Joining_Group=  shin}', "");
    Expect(1, 1836, '\P{Joining_Group=  shin}', "");
    Expect(0, 1836, '\P{^Joining_Group=  shin}', "");
    Error('\p{Jg=_-SHIN/a/}');
    Error('\P{Jg=_-SHIN/a/}');
    Expect(1, 1835, '\p{Jg=:\AShin\z:}', "");;
    Expect(0, 1836, '\p{Jg=:\AShin\z:}', "");;
    Expect(1, 1835, '\p{Jg=shin}', "");
    Expect(0, 1835, '\p{^Jg=shin}', "");
    Expect(0, 1835, '\P{Jg=shin}', "");
    Expect(1, 1835, '\P{^Jg=shin}', "");
    Expect(0, 1836, '\p{Jg=shin}', "");
    Expect(1, 1836, '\p{^Jg=shin}', "");
    Expect(1, 1836, '\P{Jg=shin}', "");
    Expect(0, 1836, '\P{^Jg=shin}', "");
    Expect(1, 1835, '\p{Jg=:\Ashin\z:}', "");;
    Expect(0, 1836, '\p{Jg=:\Ashin\z:}', "");;
    Expect(1, 1835, '\p{Jg= SHIN}', "");
    Expect(0, 1835, '\p{^Jg= SHIN}', "");
    Expect(0, 1835, '\P{Jg= SHIN}', "");
    Expect(1, 1835, '\P{^Jg= SHIN}', "");
    Expect(0, 1836, '\p{Jg= SHIN}', "");
    Expect(1, 1836, '\p{^Jg= SHIN}', "");
    Expect(1, 1836, '\P{Jg= SHIN}', "");
    Expect(0, 1836, '\P{^Jg= SHIN}', "");
    Error('\p{Is_Joining_Group=SHIN:=}');
    Error('\P{Is_Joining_Group=SHIN:=}');
    Expect(1, 1835, '\p{Is_Joining_Group=shin}', "");
    Expect(0, 1835, '\p{^Is_Joining_Group=shin}', "");
    Expect(0, 1835, '\P{Is_Joining_Group=shin}', "");
    Expect(1, 1835, '\P{^Is_Joining_Group=shin}', "");
    Expect(0, 1836, '\p{Is_Joining_Group=shin}', "");
    Expect(1, 1836, '\p{^Is_Joining_Group=shin}', "");
    Expect(1, 1836, '\P{Is_Joining_Group=shin}', "");
    Expect(0, 1836, '\P{^Is_Joining_Group=shin}', "");
    Expect(1, 1835, '\p{Is_Joining_Group=_Shin}', "");
    Expect(0, 1835, '\p{^Is_Joining_Group=_Shin}', "");
    Expect(0, 1835, '\P{Is_Joining_Group=_Shin}', "");
    Expect(1, 1835, '\P{^Is_Joining_Group=_Shin}', "");
    Expect(0, 1836, '\p{Is_Joining_Group=_Shin}', "");
    Expect(1, 1836, '\p{^Is_Joining_Group=_Shin}', "");
    Expect(1, 1836, '\P{Is_Joining_Group=_Shin}', "");
    Expect(0, 1836, '\P{^Is_Joining_Group=_Shin}', "");
    Error('\p{Is_Jg=:= 	Shin}');
    Error('\P{Is_Jg=:= 	Shin}');
    Expect(1, 1835, '\p{Is_Jg:   shin}', "");
    Expect(0, 1835, '\p{^Is_Jg:   shin}', "");
    Expect(0, 1835, '\P{Is_Jg:   shin}', "");
    Expect(1, 1835, '\P{^Is_Jg:   shin}', "");
    Expect(0, 1836, '\p{Is_Jg:   shin}', "");
    Expect(1, 1836, '\p{^Is_Jg:   shin}', "");
    Expect(1, 1836, '\P{Is_Jg:   shin}', "");
    Expect(0, 1836, '\P{^Is_Jg:   shin}', "");
    Expect(1, 1835, '\p{Is_Jg:		shin}', "");
    Expect(0, 1835, '\p{^Is_Jg:		shin}', "");
    Expect(0, 1835, '\P{Is_Jg:		shin}', "");
    Expect(1, 1835, '\P{^Is_Jg:		shin}', "");
    Expect(0, 1836, '\p{Is_Jg:		shin}', "");
    Expect(1, 1836, '\p{^Is_Jg:		shin}', "");
    Expect(1, 1836, '\P{Is_Jg:		shin}', "");
    Expect(0, 1836, '\P{^Is_Jg:		shin}', "");
    Error('\p{Joining_Group=-:=STRAIGHT_Waw}');
    Error('\P{Joining_Group=-:=STRAIGHT_Waw}');
    Expect(1, 2225, '\p{Joining_Group=:\AStraight_Waw\z:}', "");;
    Expect(0, 2226, '\p{Joining_Group=:\AStraight_Waw\z:}', "");;
    Expect(1, 2225, '\p{Joining_Group=straightwaw}', "");
    Expect(0, 2225, '\p{^Joining_Group=straightwaw}', "");
    Expect(0, 2225, '\P{Joining_Group=straightwaw}', "");
    Expect(1, 2225, '\P{^Joining_Group=straightwaw}', "");
    Expect(0, 2226, '\p{Joining_Group=straightwaw}', "");
    Expect(1, 2226, '\p{^Joining_Group=straightwaw}', "");
    Expect(1, 2226, '\P{Joining_Group=straightwaw}', "");
    Expect(0, 2226, '\P{^Joining_Group=straightwaw}', "");
    Expect(1, 2225, '\p{Joining_Group=:\Astraightwaw\z:}', "");;
    Expect(0, 2226, '\p{Joining_Group=:\Astraightwaw\z:}', "");;
    Expect(1, 2225, '\p{Joining_Group=_-straight_WAW}', "");
    Expect(0, 2225, '\p{^Joining_Group=_-straight_WAW}', "");
    Expect(0, 2225, '\P{Joining_Group=_-straight_WAW}', "");
    Expect(1, 2225, '\P{^Joining_Group=_-straight_WAW}', "");
    Expect(0, 2226, '\p{Joining_Group=_-straight_WAW}', "");
    Expect(1, 2226, '\p{^Joining_Group=_-straight_WAW}', "");
    Expect(1, 2226, '\P{Joining_Group=_-straight_WAW}', "");
    Expect(0, 2226, '\P{^Joining_Group=_-straight_WAW}', "");
    Error('\p{Jg=	_straight_Waw:=}');
    Error('\P{Jg=	_straight_Waw:=}');
    Expect(1, 2225, '\p{Jg=:\AStraight_Waw\z:}', "");;
    Expect(0, 2226, '\p{Jg=:\AStraight_Waw\z:}', "");;
    Expect(1, 2225, '\p{Jg=straightwaw}', "");
    Expect(0, 2225, '\p{^Jg=straightwaw}', "");
    Expect(0, 2225, '\P{Jg=straightwaw}', "");
    Expect(1, 2225, '\P{^Jg=straightwaw}', "");
    Expect(0, 2226, '\p{Jg=straightwaw}', "");
    Expect(1, 2226, '\p{^Jg=straightwaw}', "");
    Expect(1, 2226, '\P{Jg=straightwaw}', "");
    Expect(0, 2226, '\P{^Jg=straightwaw}', "");
    Expect(1, 2225, '\p{Jg=:\Astraightwaw\z:}', "");;
    Expect(0, 2226, '\p{Jg=:\Astraightwaw\z:}', "");;
    Expect(1, 2225, '\p{Jg=_straight_WAW}', "");
    Expect(0, 2225, '\p{^Jg=_straight_WAW}', "");
    Expect(0, 2225, '\P{Jg=_straight_WAW}', "");
    Expect(1, 2225, '\P{^Jg=_straight_WAW}', "");
    Expect(0, 2226, '\p{Jg=_straight_WAW}', "");
    Expect(1, 2226, '\p{^Jg=_straight_WAW}', "");
    Expect(1, 2226, '\P{Jg=_straight_WAW}', "");
    Expect(0, 2226, '\P{^Jg=_straight_WAW}', "");
    Error('\p{Is_Joining_Group=_/a/Straight_WAW}');
    Error('\P{Is_Joining_Group=_/a/Straight_WAW}');
    Expect(1, 2225, '\p{Is_Joining_Group=straightwaw}', "");
    Expect(0, 2225, '\p{^Is_Joining_Group=straightwaw}', "");
    Expect(0, 2225, '\P{Is_Joining_Group=straightwaw}', "");
    Expect(1, 2225, '\P{^Is_Joining_Group=straightwaw}', "");
    Expect(0, 2226, '\p{Is_Joining_Group=straightwaw}', "");
    Expect(1, 2226, '\p{^Is_Joining_Group=straightwaw}', "");
    Expect(1, 2226, '\P{Is_Joining_Group=straightwaw}', "");
    Expect(0, 2226, '\P{^Is_Joining_Group=straightwaw}', "");
    Expect(1, 2225, '\p{Is_Joining_Group=__Straight_Waw}', "");
    Expect(0, 2225, '\p{^Is_Joining_Group=__Straight_Waw}', "");
    Expect(0, 2225, '\P{Is_Joining_Group=__Straight_Waw}', "");
    Expect(1, 2225, '\P{^Is_Joining_Group=__Straight_Waw}', "");
    Expect(0, 2226, '\p{Is_Joining_Group=__Straight_Waw}', "");
    Expect(1, 2226, '\p{^Is_Joining_Group=__Straight_Waw}', "");
    Expect(1, 2226, '\P{Is_Joining_Group=__Straight_Waw}', "");
    Expect(0, 2226, '\P{^Is_Joining_Group=__Straight_Waw}', "");
    Error('\p{Is_Jg=	:=STRAIGHT_Waw}');
    Error('\P{Is_Jg=	:=STRAIGHT_Waw}');
    Expect(1, 2225, '\p{Is_Jg=straightwaw}', "");
    Expect(0, 2225, '\p{^Is_Jg=straightwaw}', "");
    Expect(0, 2225, '\P{Is_Jg=straightwaw}', "");
    Expect(1, 2225, '\P{^Is_Jg=straightwaw}', "");
    Expect(0, 2226, '\p{Is_Jg=straightwaw}', "");
    Expect(1, 2226, '\p{^Is_Jg=straightwaw}', "");
    Expect(1, 2226, '\P{Is_Jg=straightwaw}', "");
    Expect(0, 2226, '\P{^Is_Jg=straightwaw}', "");
    Expect(1, 2225, '\p{Is_Jg=__straight_waw}', "");
    Expect(0, 2225, '\p{^Is_Jg=__straight_waw}', "");
    Expect(0, 2225, '\P{Is_Jg=__straight_waw}', "");
    Expect(1, 2225, '\P{^Is_Jg=__straight_waw}', "");
    Expect(0, 2226, '\p{Is_Jg=__straight_waw}', "");
    Expect(1, 2226, '\p{^Is_Jg=__straight_waw}', "");
    Expect(1, 2226, '\P{Is_Jg=__straight_waw}', "");
    Expect(0, 2226, '\P{^Is_Jg=__straight_waw}', "");
    Error('\p{Joining_Group= /a/Swash_Kaf}');
    Error('\P{Joining_Group= /a/Swash_Kaf}');
    Expect(1, 1706, '\p{Joining_Group=:\ASwash_Kaf\z:}', "");;
    Expect(0, 1707, '\p{Joining_Group=:\ASwash_Kaf\z:}', "");;
    Expect(1, 1706, '\p{Joining_Group=swashkaf}', "");
    Expect(0, 1706, '\p{^Joining_Group=swashkaf}', "");
    Expect(0, 1706, '\P{Joining_Group=swashkaf}', "");
    Expect(1, 1706, '\P{^Joining_Group=swashkaf}', "");
    Expect(0, 1707, '\p{Joining_Group=swashkaf}', "");
    Expect(1, 1707, '\p{^Joining_Group=swashkaf}', "");
    Expect(1, 1707, '\P{Joining_Group=swashkaf}', "");
    Expect(0, 1707, '\P{^Joining_Group=swashkaf}', "");
    Expect(1, 1706, '\p{Joining_Group=:\Aswashkaf\z:}', "");;
    Expect(0, 1707, '\p{Joining_Group=:\Aswashkaf\z:}', "");;
    Expect(1, 1706, '\p{Joining_Group=	-SWASH_Kaf}', "");
    Expect(0, 1706, '\p{^Joining_Group=	-SWASH_Kaf}', "");
    Expect(0, 1706, '\P{Joining_Group=	-SWASH_Kaf}', "");
    Expect(1, 1706, '\P{^Joining_Group=	-SWASH_Kaf}', "");
    Expect(0, 1707, '\p{Joining_Group=	-SWASH_Kaf}', "");
    Expect(1, 1707, '\p{^Joining_Group=	-SWASH_Kaf}', "");
    Expect(1, 1707, '\P{Joining_Group=	-SWASH_Kaf}', "");
    Expect(0, 1707, '\P{^Joining_Group=	-SWASH_Kaf}', "");
    Error('\p{Jg:	 :=Swash_KAF}');
    Error('\P{Jg:	 :=Swash_KAF}');
    Expect(1, 1706, '\p{Jg=:\ASwash_Kaf\z:}', "");;
    Expect(0, 1707, '\p{Jg=:\ASwash_Kaf\z:}', "");;
    Expect(1, 1706, '\p{Jg=swashkaf}', "");
    Expect(0, 1706, '\p{^Jg=swashkaf}', "");
    Expect(0, 1706, '\P{Jg=swashkaf}', "");
    Expect(1, 1706, '\P{^Jg=swashkaf}', "");
    Expect(0, 1707, '\p{Jg=swashkaf}', "");
    Expect(1, 1707, '\p{^Jg=swashkaf}', "");
    Expect(1, 1707, '\P{Jg=swashkaf}', "");
    Expect(0, 1707, '\P{^Jg=swashkaf}', "");
    Expect(1, 1706, '\p{Jg=:\Aswashkaf\z:}', "");;
    Expect(0, 1707, '\p{Jg=:\Aswashkaf\z:}', "");;
    Expect(1, 1706, '\p{Jg=-Swash_KAF}', "");
    Expect(0, 1706, '\p{^Jg=-Swash_KAF}', "");
    Expect(0, 1706, '\P{Jg=-Swash_KAF}', "");
    Expect(1, 1706, '\P{^Jg=-Swash_KAF}', "");
    Expect(0, 1707, '\p{Jg=-Swash_KAF}', "");
    Expect(1, 1707, '\p{^Jg=-Swash_KAF}', "");
    Expect(1, 1707, '\P{Jg=-Swash_KAF}', "");
    Expect(0, 1707, '\P{^Jg=-Swash_KAF}', "");
    Error('\p{Is_Joining_Group=/a/-swash_kaf}');
    Error('\P{Is_Joining_Group=/a/-swash_kaf}');
    Expect(1, 1706, '\p{Is_Joining_Group=swashkaf}', "");
    Expect(0, 1706, '\p{^Is_Joining_Group=swashkaf}', "");
    Expect(0, 1706, '\P{Is_Joining_Group=swashkaf}', "");
    Expect(1, 1706, '\P{^Is_Joining_Group=swashkaf}', "");
    Expect(0, 1707, '\p{Is_Joining_Group=swashkaf}', "");
    Expect(1, 1707, '\p{^Is_Joining_Group=swashkaf}', "");
    Expect(1, 1707, '\P{Is_Joining_Group=swashkaf}', "");
    Expect(0, 1707, '\P{^Is_Joining_Group=swashkaf}', "");
    Expect(1, 1706, '\p{Is_Joining_Group=	SWASH_kaf}', "");
    Expect(0, 1706, '\p{^Is_Joining_Group=	SWASH_kaf}', "");
    Expect(0, 1706, '\P{Is_Joining_Group=	SWASH_kaf}', "");
    Expect(1, 1706, '\P{^Is_Joining_Group=	SWASH_kaf}', "");
    Expect(0, 1707, '\p{Is_Joining_Group=	SWASH_kaf}', "");
    Expect(1, 1707, '\p{^Is_Joining_Group=	SWASH_kaf}', "");
    Expect(1, 1707, '\P{Is_Joining_Group=	SWASH_kaf}', "");
    Expect(0, 1707, '\P{^Is_Joining_Group=	SWASH_kaf}', "");
    Error('\p{Is_Jg=/a/-swash_Kaf}');
    Error('\P{Is_Jg=/a/-swash_Kaf}');
    Expect(1, 1706, '\p{Is_Jg=swashkaf}', "");
    Expect(0, 1706, '\p{^Is_Jg=swashkaf}', "");
    Expect(0, 1706, '\P{Is_Jg=swashkaf}', "");
    Expect(1, 1706, '\P{^Is_Jg=swashkaf}', "");
    Expect(0, 1707, '\p{Is_Jg=swashkaf}', "");
    Expect(1, 1707, '\p{^Is_Jg=swashkaf}', "");
    Expect(1, 1707, '\P{Is_Jg=swashkaf}', "");
    Expect(0, 1707, '\P{^Is_Jg=swashkaf}', "");
    Expect(1, 1706, '\p{Is_Jg=-Swash_kaf}', "");
    Expect(0, 1706, '\p{^Is_Jg=-Swash_kaf}', "");
    Expect(0, 1706, '\P{Is_Jg=-Swash_kaf}', "");
    Expect(1, 1706, '\P{^Is_Jg=-Swash_kaf}', "");
    Expect(0, 1707, '\p{Is_Jg=-Swash_kaf}', "");
    Expect(1, 1707, '\p{^Is_Jg=-Swash_kaf}', "");
    Expect(1, 1707, '\P{Is_Jg=-Swash_kaf}', "");
    Expect(0, 1707, '\P{^Is_Jg=-Swash_kaf}', "");
    Error('\p{Joining_Group=/a/-Syriac_waw}');
    Error('\P{Joining_Group=/a/-Syriac_waw}');
    Expect(1, 1816, '\p{Joining_Group=:\ASyriac_Waw\z:}', "");;
    Expect(0, 1817, '\p{Joining_Group=:\ASyriac_Waw\z:}', "");;
    Expect(1, 1816, '\p{Joining_Group:	syriacwaw}', "");
    Expect(0, 1816, '\p{^Joining_Group:	syriacwaw}', "");
    Expect(0, 1816, '\P{Joining_Group:	syriacwaw}', "");
    Expect(1, 1816, '\P{^Joining_Group:	syriacwaw}', "");
    Expect(0, 1817, '\p{Joining_Group:	syriacwaw}', "");
    Expect(1, 1817, '\p{^Joining_Group:	syriacwaw}', "");
    Expect(1, 1817, '\P{Joining_Group:	syriacwaw}', "");
    Expect(0, 1817, '\P{^Joining_Group:	syriacwaw}', "");
    Expect(1, 1816, '\p{Joining_Group=:\Asyriacwaw\z:}', "");;
    Expect(0, 1817, '\p{Joining_Group=:\Asyriacwaw\z:}', "");;
    Expect(1, 1816, '\p{Joining_Group=_-Syriac_waw}', "");
    Expect(0, 1816, '\p{^Joining_Group=_-Syriac_waw}', "");
    Expect(0, 1816, '\P{Joining_Group=_-Syriac_waw}', "");
    Expect(1, 1816, '\P{^Joining_Group=_-Syriac_waw}', "");
    Expect(0, 1817, '\p{Joining_Group=_-Syriac_waw}', "");
    Expect(1, 1817, '\p{^Joining_Group=_-Syriac_waw}', "");
    Expect(1, 1817, '\P{Joining_Group=_-Syriac_waw}', "");
    Expect(0, 1817, '\P{^Joining_Group=_-Syriac_waw}', "");
    Error('\p{Jg:		/a/SYRIAC_Waw}');
    Error('\P{Jg:		/a/SYRIAC_Waw}');
    Expect(1, 1816, '\p{Jg=:\ASyriac_Waw\z:}', "");;
    Expect(0, 1817, '\p{Jg=:\ASyriac_Waw\z:}', "");;
    Expect(1, 1816, '\p{Jg:	syriacwaw}', "");
    Expect(0, 1816, '\p{^Jg:	syriacwaw}', "");
    Expect(0, 1816, '\P{Jg:	syriacwaw}', "");
    Expect(1, 1816, '\P{^Jg:	syriacwaw}', "");
    Expect(0, 1817, '\p{Jg:	syriacwaw}', "");
    Expect(1, 1817, '\p{^Jg:	syriacwaw}', "");
    Expect(1, 1817, '\P{Jg:	syriacwaw}', "");
    Expect(0, 1817, '\P{^Jg:	syriacwaw}', "");
    Expect(1, 1816, '\p{Jg=:\Asyriacwaw\z:}', "");;
    Expect(0, 1817, '\p{Jg=:\Asyriacwaw\z:}', "");;
    Expect(1, 1816, '\p{Jg=	 Syriac_waw}', "");
    Expect(0, 1816, '\p{^Jg=	 Syriac_waw}', "");
    Expect(0, 1816, '\P{Jg=	 Syriac_waw}', "");
    Expect(1, 1816, '\P{^Jg=	 Syriac_waw}', "");
    Expect(0, 1817, '\p{Jg=	 Syriac_waw}', "");
    Expect(1, 1817, '\p{^Jg=	 Syriac_waw}', "");
    Expect(1, 1817, '\P{Jg=	 Syriac_waw}', "");
    Expect(0, 1817, '\P{^Jg=	 Syriac_waw}', "");
    Error('\p{Is_Joining_Group=/a/_Syriac_waw}');
    Error('\P{Is_Joining_Group=/a/_Syriac_waw}');
    Expect(1, 1816, '\p{Is_Joining_Group=syriacwaw}', "");
    Expect(0, 1816, '\p{^Is_Joining_Group=syriacwaw}', "");
    Expect(0, 1816, '\P{Is_Joining_Group=syriacwaw}', "");
    Expect(1, 1816, '\P{^Is_Joining_Group=syriacwaw}', "");
    Expect(0, 1817, '\p{Is_Joining_Group=syriacwaw}', "");
    Expect(1, 1817, '\p{^Is_Joining_Group=syriacwaw}', "");
    Expect(1, 1817, '\P{Is_Joining_Group=syriacwaw}', "");
    Expect(0, 1817, '\P{^Is_Joining_Group=syriacwaw}', "");
    Expect(1, 1816, '\p{Is_Joining_Group=	syriac_Waw}', "");
    Expect(0, 1816, '\p{^Is_Joining_Group=	syriac_Waw}', "");
    Expect(0, 1816, '\P{Is_Joining_Group=	syriac_Waw}', "");
    Expect(1, 1816, '\P{^Is_Joining_Group=	syriac_Waw}', "");
    Expect(0, 1817, '\p{Is_Joining_Group=	syriac_Waw}', "");
    Expect(1, 1817, '\p{^Is_Joining_Group=	syriac_Waw}', "");
    Expect(1, 1817, '\P{Is_Joining_Group=	syriac_Waw}', "");
    Expect(0, 1817, '\P{^Is_Joining_Group=	syriac_Waw}', "");
    Error('\p{Is_Jg= /a/SYRIAC_Waw}');
    Error('\P{Is_Jg= /a/SYRIAC_Waw}');
    Expect(1, 1816, '\p{Is_Jg=syriacwaw}', "");
    Expect(0, 1816, '\p{^Is_Jg=syriacwaw}', "");
    Expect(0, 1816, '\P{Is_Jg=syriacwaw}', "");
    Expect(1, 1816, '\P{^Is_Jg=syriacwaw}', "");
    Expect(0, 1817, '\p{Is_Jg=syriacwaw}', "");
    Expect(1, 1817, '\p{^Is_Jg=syriacwaw}', "");
    Expect(1, 1817, '\P{Is_Jg=syriacwaw}', "");
    Expect(0, 1817, '\P{^Is_Jg=syriacwaw}', "");
    Expect(1, 1816, '\p{Is_Jg=	syriac_Waw}', "");
    Expect(0, 1816, '\p{^Is_Jg=	syriac_Waw}', "");
    Expect(0, 1816, '\P{Is_Jg=	syriac_Waw}', "");
    Expect(1, 1816, '\P{^Is_Jg=	syriac_Waw}', "");
    Expect(0, 1817, '\p{Is_Jg=	syriac_Waw}', "");
    Expect(1, 1817, '\p{^Is_Jg=	syriac_Waw}', "");
    Expect(1, 1817, '\P{Is_Jg=	syriac_Waw}', "");
    Expect(0, 1817, '\P{^Is_Jg=	syriac_Waw}', "");
    Error('\p{Joining_Group=-	tah:=}');
    Error('\P{Joining_Group=-	tah:=}');
    Expect(1, 2211, '\p{Joining_Group=:\ATah\z:}', "");;
    Expect(0, 2212, '\p{Joining_Group=:\ATah\z:}', "");;
    Expect(1, 2211, '\p{Joining_Group=tah}', "");
    Expect(0, 2211, '\p{^Joining_Group=tah}', "");
    Expect(0, 2211, '\P{Joining_Group=tah}', "");
    Expect(1, 2211, '\P{^Joining_Group=tah}', "");
    Expect(0, 2212, '\p{Joining_Group=tah}', "");
    Expect(1, 2212, '\p{^Joining_Group=tah}', "");
    Expect(1, 2212, '\P{Joining_Group=tah}', "");
    Expect(0, 2212, '\P{^Joining_Group=tah}', "");
    Expect(1, 2211, '\p{Joining_Group=:\Atah\z:}', "");;
    Expect(0, 2212, '\p{Joining_Group=:\Atah\z:}', "");;
    Expect(1, 2211, '\p{Joining_Group=_tah}', "");
    Expect(0, 2211, '\p{^Joining_Group=_tah}', "");
    Expect(0, 2211, '\P{Joining_Group=_tah}', "");
    Expect(1, 2211, '\P{^Joining_Group=_tah}', "");
    Expect(0, 2212, '\p{Joining_Group=_tah}', "");
    Expect(1, 2212, '\p{^Joining_Group=_tah}', "");
    Expect(1, 2212, '\P{Joining_Group=_tah}', "");
    Expect(0, 2212, '\P{^Joining_Group=_tah}', "");
    Error('\p{Jg=:=_	TAH}');
    Error('\P{Jg=:=_	TAH}');
    Expect(1, 2211, '\p{Jg=:\ATah\z:}', "");;
    Expect(0, 2212, '\p{Jg=:\ATah\z:}', "");;
    Expect(1, 2211, '\p{Jg=tah}', "");
    Expect(0, 2211, '\p{^Jg=tah}', "");
    Expect(0, 2211, '\P{Jg=tah}', "");
    Expect(1, 2211, '\P{^Jg=tah}', "");
    Expect(0, 2212, '\p{Jg=tah}', "");
    Expect(1, 2212, '\p{^Jg=tah}', "");
    Expect(1, 2212, '\P{Jg=tah}', "");
    Expect(0, 2212, '\P{^Jg=tah}', "");
    Expect(1, 2211, '\p{Jg=:\Atah\z:}', "");;
    Expect(0, 2212, '\p{Jg=:\Atah\z:}', "");;
    Expect(1, 2211, '\p{Jg=		Tah}', "");
    Expect(0, 2211, '\p{^Jg=		Tah}', "");
    Expect(0, 2211, '\P{Jg=		Tah}', "");
    Expect(1, 2211, '\P{^Jg=		Tah}', "");
    Expect(0, 2212, '\p{Jg=		Tah}', "");
    Expect(1, 2212, '\p{^Jg=		Tah}', "");
    Expect(1, 2212, '\P{Jg=		Tah}', "");
    Expect(0, 2212, '\P{^Jg=		Tah}', "");
    Error('\p{Is_Joining_Group=/a/--tah}');
    Error('\P{Is_Joining_Group=/a/--tah}');
    Expect(1, 2211, '\p{Is_Joining_Group=tah}', "");
    Expect(0, 2211, '\p{^Is_Joining_Group=tah}', "");
    Expect(0, 2211, '\P{Is_Joining_Group=tah}', "");
    Expect(1, 2211, '\P{^Is_Joining_Group=tah}', "");
    Expect(0, 2212, '\p{Is_Joining_Group=tah}', "");
    Expect(1, 2212, '\p{^Is_Joining_Group=tah}', "");
    Expect(1, 2212, '\P{Is_Joining_Group=tah}', "");
    Expect(0, 2212, '\P{^Is_Joining_Group=tah}', "");
    Expect(1, 2211, '\p{Is_Joining_Group=--Tah}', "");
    Expect(0, 2211, '\p{^Is_Joining_Group=--Tah}', "");
    Expect(0, 2211, '\P{Is_Joining_Group=--Tah}', "");
    Expect(1, 2211, '\P{^Is_Joining_Group=--Tah}', "");
    Expect(0, 2212, '\p{Is_Joining_Group=--Tah}', "");
    Expect(1, 2212, '\p{^Is_Joining_Group=--Tah}', "");
    Expect(1, 2212, '\P{Is_Joining_Group=--Tah}', "");
    Expect(0, 2212, '\P{^Is_Joining_Group=--Tah}', "");
    Error('\p{Is_Jg=/a/--TAH}');
    Error('\P{Is_Jg=/a/--TAH}');
    Expect(1, 2211, '\p{Is_Jg=tah}', "");
    Expect(0, 2211, '\p{^Is_Jg=tah}', "");
    Expect(0, 2211, '\P{Is_Jg=tah}', "");
    Expect(1, 2211, '\P{^Is_Jg=tah}', "");
    Expect(0, 2212, '\p{Is_Jg=tah}', "");
    Expect(1, 2212, '\p{^Is_Jg=tah}', "");
    Expect(1, 2212, '\P{Is_Jg=tah}', "");
    Expect(0, 2212, '\P{^Is_Jg=tah}', "");
    Expect(1, 2211, '\p{Is_Jg=_-TAH}', "");
    Expect(0, 2211, '\p{^Is_Jg=_-TAH}', "");
    Expect(0, 2211, '\P{Is_Jg=_-TAH}', "");
    Expect(1, 2211, '\P{^Is_Jg=_-TAH}', "");
    Expect(0, 2212, '\p{Is_Jg=_-TAH}', "");
    Expect(1, 2212, '\p{^Is_Jg=_-TAH}', "");
    Expect(1, 2212, '\P{Is_Jg=_-TAH}', "");
    Expect(0, 2212, '\P{^Is_Jg=_-TAH}', "");
    Error('\p{Joining_Group=/a/Taw}');
    Error('\P{Joining_Group=/a/Taw}');
    Expect(1, 1836, '\p{Joining_Group=:\ATaw\z:}', "");;
    Expect(0, 1837, '\p{Joining_Group=:\ATaw\z:}', "");;
    Expect(1, 1836, '\p{Joining_Group=taw}', "");
    Expect(0, 1836, '\p{^Joining_Group=taw}', "");
    Expect(0, 1836, '\P{Joining_Group=taw}', "");
    Expect(1, 1836, '\P{^Joining_Group=taw}', "");
    Expect(0, 1837, '\p{Joining_Group=taw}', "");
    Expect(1, 1837, '\p{^Joining_Group=taw}', "");
    Expect(1, 1837, '\P{Joining_Group=taw}', "");
    Expect(0, 1837, '\P{^Joining_Group=taw}', "");
    Expect(1, 1836, '\p{Joining_Group=:\Ataw\z:}', "");;
    Expect(0, 1837, '\p{Joining_Group=:\Ataw\z:}', "");;
    Expect(1, 1836, '\p{Joining_Group=__Taw}', "");
    Expect(0, 1836, '\p{^Joining_Group=__Taw}', "");
    Expect(0, 1836, '\P{Joining_Group=__Taw}', "");
    Expect(1, 1836, '\P{^Joining_Group=__Taw}', "");
    Expect(0, 1837, '\p{Joining_Group=__Taw}', "");
    Expect(1, 1837, '\p{^Joining_Group=__Taw}', "");
    Expect(1, 1837, '\P{Joining_Group=__Taw}', "");
    Expect(0, 1837, '\P{^Joining_Group=__Taw}', "");
    Error('\p{Jg= Taw/a/}');
    Error('\P{Jg= Taw/a/}');
    Expect(1, 1836, '\p{Jg=:\ATaw\z:}', "");;
    Expect(0, 1837, '\p{Jg=:\ATaw\z:}', "");;
    Expect(1, 1836, '\p{Jg=taw}', "");
    Expect(0, 1836, '\p{^Jg=taw}', "");
    Expect(0, 1836, '\P{Jg=taw}', "");
    Expect(1, 1836, '\P{^Jg=taw}', "");
    Expect(0, 1837, '\p{Jg=taw}', "");
    Expect(1, 1837, '\p{^Jg=taw}', "");
    Expect(1, 1837, '\P{Jg=taw}', "");
    Expect(0, 1837, '\P{^Jg=taw}', "");
    Expect(1, 1836, '\p{Jg=:\Ataw\z:}', "");;
    Expect(0, 1837, '\p{Jg=:\Ataw\z:}', "");;
    Expect(1, 1836, '\p{Jg=	TAW}', "");
    Expect(0, 1836, '\p{^Jg=	TAW}', "");
    Expect(0, 1836, '\P{Jg=	TAW}', "");
    Expect(1, 1836, '\P{^Jg=	TAW}', "");
    Expect(0, 1837, '\p{Jg=	TAW}', "");
    Expect(1, 1837, '\p{^Jg=	TAW}', "");
    Expect(1, 1837, '\P{Jg=	TAW}', "");
    Expect(0, 1837, '\P{^Jg=	TAW}', "");
    Error('\p{Is_Joining_Group=	/a/taw}');
    Error('\P{Is_Joining_Group=	/a/taw}');
    Expect(1, 1836, '\p{Is_Joining_Group=taw}', "");
    Expect(0, 1836, '\p{^Is_Joining_Group=taw}', "");
    Expect(0, 1836, '\P{Is_Joining_Group=taw}', "");
    Expect(1, 1836, '\P{^Is_Joining_Group=taw}', "");
    Expect(0, 1837, '\p{Is_Joining_Group=taw}', "");
    Expect(1, 1837, '\p{^Is_Joining_Group=taw}', "");
    Expect(1, 1837, '\P{Is_Joining_Group=taw}', "");
    Expect(0, 1837, '\P{^Is_Joining_Group=taw}', "");
    Expect(1, 1836, '\p{Is_Joining_Group=_ Taw}', "");
    Expect(0, 1836, '\p{^Is_Joining_Group=_ Taw}', "");
    Expect(0, 1836, '\P{Is_Joining_Group=_ Taw}', "");
    Expect(1, 1836, '\P{^Is_Joining_Group=_ Taw}', "");
    Expect(0, 1837, '\p{Is_Joining_Group=_ Taw}', "");
    Expect(1, 1837, '\p{^Is_Joining_Group=_ Taw}', "");
    Expect(1, 1837, '\P{Is_Joining_Group=_ Taw}', "");
    Expect(0, 1837, '\P{^Is_Joining_Group=_ Taw}', "");
    Error('\p{Is_Jg=/a/ 	Taw}');
    Error('\P{Is_Jg=/a/ 	Taw}');
    Expect(1, 1836, '\p{Is_Jg=taw}', "");
    Expect(0, 1836, '\p{^Is_Jg=taw}', "");
    Expect(0, 1836, '\P{Is_Jg=taw}', "");
    Expect(1, 1836, '\P{^Is_Jg=taw}', "");
    Expect(0, 1837, '\p{Is_Jg=taw}', "");
    Expect(1, 1837, '\p{^Is_Jg=taw}', "");
    Expect(1, 1837, '\P{Is_Jg=taw}', "");
    Expect(0, 1837, '\P{^Is_Jg=taw}', "");
    Expect(1, 1836, '\p{Is_Jg=_TAW}', "");
    Expect(0, 1836, '\p{^Is_Jg=_TAW}', "");
    Expect(0, 1836, '\P{Is_Jg=_TAW}', "");
    Expect(1, 1836, '\P{^Is_Jg=_TAW}', "");
    Expect(0, 1837, '\p{Is_Jg=_TAW}', "");
    Expect(1, 1837, '\p{^Is_Jg=_TAW}', "");
    Expect(1, 1837, '\P{Is_Jg=_TAW}', "");
    Expect(0, 1837, '\P{^Is_Jg=_TAW}', "");
    Error('\p{Joining_Group=:=_Teh_marbuta}');
    Error('\P{Joining_Group=:=_Teh_marbuta}');
    Expect(1, 1749, '\p{Joining_Group=:\ATeh_Marbuta\z:}', "");;
    Expect(0, 1750, '\p{Joining_Group=:\ATeh_Marbuta\z:}', "");;
    Expect(1, 1749, '\p{Joining_Group: tehmarbuta}', "");
    Expect(0, 1749, '\p{^Joining_Group: tehmarbuta}', "");
    Expect(0, 1749, '\P{Joining_Group: tehmarbuta}', "");
    Expect(1, 1749, '\P{^Joining_Group: tehmarbuta}', "");
    Expect(0, 1750, '\p{Joining_Group: tehmarbuta}', "");
    Expect(1, 1750, '\p{^Joining_Group: tehmarbuta}', "");
    Expect(1, 1750, '\P{Joining_Group: tehmarbuta}', "");
    Expect(0, 1750, '\P{^Joining_Group: tehmarbuta}', "");
    Expect(1, 1749, '\p{Joining_Group=:\Atehmarbuta\z:}', "");;
    Expect(0, 1750, '\p{Joining_Group=:\Atehmarbuta\z:}', "");;
    Expect(1, 1749, '\p{Joining_Group=-teh_Marbuta}', "");
    Expect(0, 1749, '\p{^Joining_Group=-teh_Marbuta}', "");
    Expect(0, 1749, '\P{Joining_Group=-teh_Marbuta}', "");
    Expect(1, 1749, '\P{^Joining_Group=-teh_Marbuta}', "");
    Expect(0, 1750, '\p{Joining_Group=-teh_Marbuta}', "");
    Expect(1, 1750, '\p{^Joining_Group=-teh_Marbuta}', "");
    Expect(1, 1750, '\P{Joining_Group=-teh_Marbuta}', "");
    Expect(0, 1750, '\P{^Joining_Group=-teh_Marbuta}', "");
    Error('\p{Jg=-:=teh_Marbuta}');
    Error('\P{Jg=-:=teh_Marbuta}');
    Expect(1, 1749, '\p{Jg=:\ATeh_Marbuta\z:}', "");;
    Expect(0, 1750, '\p{Jg=:\ATeh_Marbuta\z:}', "");;
    Expect(1, 1749, '\p{Jg:tehmarbuta}', "");
    Expect(0, 1749, '\p{^Jg:tehmarbuta}', "");
    Expect(0, 1749, '\P{Jg:tehmarbuta}', "");
    Expect(1, 1749, '\P{^Jg:tehmarbuta}', "");
    Expect(0, 1750, '\p{Jg:tehmarbuta}', "");
    Expect(1, 1750, '\p{^Jg:tehmarbuta}', "");
    Expect(1, 1750, '\P{Jg:tehmarbuta}', "");
    Expect(0, 1750, '\P{^Jg:tehmarbuta}', "");
    Expect(1, 1749, '\p{Jg=:\Atehmarbuta\z:}', "");;
    Expect(0, 1750, '\p{Jg=:\Atehmarbuta\z:}', "");;
    Expect(1, 1749, '\p{Jg=	 Teh_Marbuta}', "");
    Expect(0, 1749, '\p{^Jg=	 Teh_Marbuta}', "");
    Expect(0, 1749, '\P{Jg=	 Teh_Marbuta}', "");
    Expect(1, 1749, '\P{^Jg=	 Teh_Marbuta}', "");
    Expect(0, 1750, '\p{Jg=	 Teh_Marbuta}', "");
    Expect(1, 1750, '\p{^Jg=	 Teh_Marbuta}', "");
    Expect(1, 1750, '\P{Jg=	 Teh_Marbuta}', "");
    Expect(0, 1750, '\P{^Jg=	 Teh_Marbuta}', "");
    Error('\p{Is_Joining_Group=_-Teh_MARBUTA:=}');
    Error('\P{Is_Joining_Group=_-Teh_MARBUTA:=}');
    Expect(1, 1749, '\p{Is_Joining_Group=tehmarbuta}', "");
    Expect(0, 1749, '\p{^Is_Joining_Group=tehmarbuta}', "");
    Expect(0, 1749, '\P{Is_Joining_Group=tehmarbuta}', "");
    Expect(1, 1749, '\P{^Is_Joining_Group=tehmarbuta}', "");
    Expect(0, 1750, '\p{Is_Joining_Group=tehmarbuta}', "");
    Expect(1, 1750, '\p{^Is_Joining_Group=tehmarbuta}', "");
    Expect(1, 1750, '\P{Is_Joining_Group=tehmarbuta}', "");
    Expect(0, 1750, '\P{^Is_Joining_Group=tehmarbuta}', "");
    Expect(1, 1749, '\p{Is_Joining_Group=- Teh_marbuta}', "");
    Expect(0, 1749, '\p{^Is_Joining_Group=- Teh_marbuta}', "");
    Expect(0, 1749, '\P{Is_Joining_Group=- Teh_marbuta}', "");
    Expect(1, 1749, '\P{^Is_Joining_Group=- Teh_marbuta}', "");
    Expect(0, 1750, '\p{Is_Joining_Group=- Teh_marbuta}', "");
    Expect(1, 1750, '\p{^Is_Joining_Group=- Teh_marbuta}', "");
    Expect(1, 1750, '\P{Is_Joining_Group=- Teh_marbuta}', "");
    Expect(0, 1750, '\P{^Is_Joining_Group=- Teh_marbuta}', "");
    Error('\p{Is_Jg=- TEH_Marbuta:=}');
    Error('\P{Is_Jg=- TEH_Marbuta:=}');
    Expect(1, 1749, '\p{Is_Jg=tehmarbuta}', "");
    Expect(0, 1749, '\p{^Is_Jg=tehmarbuta}', "");
    Expect(0, 1749, '\P{Is_Jg=tehmarbuta}', "");
    Expect(1, 1749, '\P{^Is_Jg=tehmarbuta}', "");
    Expect(0, 1750, '\p{Is_Jg=tehmarbuta}', "");
    Expect(1, 1750, '\p{^Is_Jg=tehmarbuta}', "");
    Expect(1, 1750, '\P{Is_Jg=tehmarbuta}', "");
    Expect(0, 1750, '\P{^Is_Jg=tehmarbuta}', "");
    Expect(1, 1749, '\p{Is_Jg= 	teh_MARBUTA}', "");
    Expect(0, 1749, '\p{^Is_Jg= 	teh_MARBUTA}', "");
    Expect(0, 1749, '\P{Is_Jg= 	teh_MARBUTA}', "");
    Expect(1, 1749, '\P{^Is_Jg= 	teh_MARBUTA}', "");
    Expect(0, 1750, '\p{Is_Jg= 	teh_MARBUTA}', "");
    Expect(1, 1750, '\p{^Is_Jg= 	teh_MARBUTA}', "");
    Expect(1, 1750, '\P{Is_Jg= 	teh_MARBUTA}', "");
    Expect(0, 1750, '\P{^Is_Jg= 	teh_MARBUTA}', "");
    Error('\p{Joining_Group:   :=-	HAMZA_on_Heh_Goal}');
    Error('\P{Joining_Group:   :=-	HAMZA_on_Heh_Goal}');
    Expect(1, 1731, '\p{Joining_Group=:\AHamza_On_Heh_Goal\z:}', "");;
    Expect(0, 1732, '\p{Joining_Group=:\AHamza_On_Heh_Goal\z:}', "");;
    Expect(1, 1731, '\p{Joining_Group=hamzaonhehgoal}', "");
    Expect(0, 1731, '\p{^Joining_Group=hamzaonhehgoal}', "");
    Expect(0, 1731, '\P{Joining_Group=hamzaonhehgoal}', "");
    Expect(1, 1731, '\P{^Joining_Group=hamzaonhehgoal}', "");
    Expect(0, 1732, '\p{Joining_Group=hamzaonhehgoal}', "");
    Expect(1, 1732, '\p{^Joining_Group=hamzaonhehgoal}', "");
    Expect(1, 1732, '\P{Joining_Group=hamzaonhehgoal}', "");
    Expect(0, 1732, '\P{^Joining_Group=hamzaonhehgoal}', "");
    Expect(1, 1731, '\p{Joining_Group=:\Ahamzaonhehgoal\z:}', "");;
    Expect(0, 1732, '\p{Joining_Group=:\Ahamzaonhehgoal\z:}', "");;
    Expect(1, 1731, '\p{Joining_Group= -Hamza_ON_Heh_Goal}', "");
    Expect(0, 1731, '\p{^Joining_Group= -Hamza_ON_Heh_Goal}', "");
    Expect(0, 1731, '\P{Joining_Group= -Hamza_ON_Heh_Goal}', "");
    Expect(1, 1731, '\P{^Joining_Group= -Hamza_ON_Heh_Goal}', "");
    Expect(0, 1732, '\p{Joining_Group= -Hamza_ON_Heh_Goal}', "");
    Expect(1, 1732, '\p{^Joining_Group= -Hamza_ON_Heh_Goal}', "");
    Expect(1, 1732, '\P{Joining_Group= -Hamza_ON_Heh_Goal}', "");
    Expect(0, 1732, '\P{^Joining_Group= -Hamza_ON_Heh_Goal}', "");
    Error('\p{Jg=_Teh_marbuta_GOAL/a/}');
    Error('\P{Jg=_Teh_marbuta_GOAL/a/}');
    Expect(1, 1731, '\p{Jg=:\ATeh_Marbuta_Goal\z:}', "");;
    Expect(0, 1732, '\p{Jg=:\ATeh_Marbuta_Goal\z:}', "");;
    Expect(1, 1731, '\p{Jg=tehmarbutagoal}', "");
    Expect(0, 1731, '\p{^Jg=tehmarbutagoal}', "");
    Expect(0, 1731, '\P{Jg=tehmarbutagoal}', "");
    Expect(1, 1731, '\P{^Jg=tehmarbutagoal}', "");
    Expect(0, 1732, '\p{Jg=tehmarbutagoal}', "");
    Expect(1, 1732, '\p{^Jg=tehmarbutagoal}', "");
    Expect(1, 1732, '\P{Jg=tehmarbutagoal}', "");
    Expect(0, 1732, '\P{^Jg=tehmarbutagoal}', "");
    Expect(1, 1731, '\p{Jg=:\Atehmarbutagoal\z:}', "");;
    Expect(0, 1732, '\p{Jg=:\Atehmarbutagoal\z:}', "");;
    Expect(1, 1731, '\p{Jg=-teh_Marbuta_Goal}', "");
    Expect(0, 1731, '\p{^Jg=-teh_Marbuta_Goal}', "");
    Expect(0, 1731, '\P{Jg=-teh_Marbuta_Goal}', "");
    Expect(1, 1731, '\P{^Jg=-teh_Marbuta_Goal}', "");
    Expect(0, 1732, '\p{Jg=-teh_Marbuta_Goal}', "");
    Expect(1, 1732, '\p{^Jg=-teh_Marbuta_Goal}', "");
    Expect(1, 1732, '\P{Jg=-teh_Marbuta_Goal}', "");
    Expect(0, 1732, '\P{^Jg=-teh_Marbuta_Goal}', "");
    Error('\p{Is_Joining_Group=/a/-hamza_ON_heh_Goal}');
    Error('\P{Is_Joining_Group=/a/-hamza_ON_heh_Goal}');
    Expect(1, 1731, '\p{Is_Joining_Group=hamzaonhehgoal}', "");
    Expect(0, 1731, '\p{^Is_Joining_Group=hamzaonhehgoal}', "");
    Expect(0, 1731, '\P{Is_Joining_Group=hamzaonhehgoal}', "");
    Expect(1, 1731, '\P{^Is_Joining_Group=hamzaonhehgoal}', "");
    Expect(0, 1732, '\p{Is_Joining_Group=hamzaonhehgoal}', "");
    Expect(1, 1732, '\p{^Is_Joining_Group=hamzaonhehgoal}', "");
    Expect(1, 1732, '\P{Is_Joining_Group=hamzaonhehgoal}', "");
    Expect(0, 1732, '\P{^Is_Joining_Group=hamzaonhehgoal}', "");
    Expect(1, 1731, '\p{Is_Joining_Group= Hamza_On_heh_goal}', "");
    Expect(0, 1731, '\p{^Is_Joining_Group= Hamza_On_heh_goal}', "");
    Expect(0, 1731, '\P{Is_Joining_Group= Hamza_On_heh_goal}', "");
    Expect(1, 1731, '\P{^Is_Joining_Group= Hamza_On_heh_goal}', "");
    Expect(0, 1732, '\p{Is_Joining_Group= Hamza_On_heh_goal}', "");
    Expect(1, 1732, '\p{^Is_Joining_Group= Hamza_On_heh_goal}', "");
    Expect(1, 1732, '\P{Is_Joining_Group= Hamza_On_heh_goal}', "");
    Expect(0, 1732, '\P{^Is_Joining_Group= Hamza_On_heh_goal}', "");
    Error('\p{Is_Jg=-Teh_marbuta_GOAL:=}');
    Error('\P{Is_Jg=-Teh_marbuta_GOAL:=}');
    Expect(1, 1731, '\p{Is_Jg=tehmarbutagoal}', "");
    Expect(0, 1731, '\p{^Is_Jg=tehmarbutagoal}', "");
    Expect(0, 1731, '\P{Is_Jg=tehmarbutagoal}', "");
    Expect(1, 1731, '\P{^Is_Jg=tehmarbutagoal}', "");
    Expect(0, 1732, '\p{Is_Jg=tehmarbutagoal}', "");
    Expect(1, 1732, '\p{^Is_Jg=tehmarbutagoal}', "");
    Expect(1, 1732, '\P{Is_Jg=tehmarbutagoal}', "");
    Expect(0, 1732, '\P{^Is_Jg=tehmarbutagoal}', "");
    Expect(1, 1731, '\p{Is_Jg=-_Teh_Marbuta_goal}', "");
    Expect(0, 1731, '\p{^Is_Jg=-_Teh_Marbuta_goal}', "");
    Expect(0, 1731, '\P{Is_Jg=-_Teh_Marbuta_goal}', "");
    Expect(1, 1731, '\P{^Is_Jg=-_Teh_Marbuta_goal}', "");
    Expect(0, 1732, '\p{Is_Jg=-_Teh_Marbuta_goal}', "");
    Expect(1, 1732, '\p{^Is_Jg=-_Teh_Marbuta_goal}', "");
    Expect(1, 1732, '\P{Is_Jg=-_Teh_Marbuta_goal}', "");
    Expect(0, 1732, '\P{^Is_Jg=-_Teh_Marbuta_goal}', "");
    Error('\p{Joining_Group=	:=TETH}');
    Error('\P{Joining_Group=	:=TETH}');
    Expect(1, 1820, '\p{Joining_Group=:\ATeth\z:}', "");;
    Expect(0, 1821, '\p{Joining_Group=:\ATeth\z:}', "");;
    Expect(1, 1820, '\p{Joining_Group=teth}', "");
    Expect(0, 1820, '\p{^Joining_Group=teth}', "");
    Expect(0, 1820, '\P{Joining_Group=teth}', "");
    Expect(1, 1820, '\P{^Joining_Group=teth}', "");
    Expect(0, 1821, '\p{Joining_Group=teth}', "");
    Expect(1, 1821, '\p{^Joining_Group=teth}', "");
    Expect(1, 1821, '\P{Joining_Group=teth}', "");
    Expect(0, 1821, '\P{^Joining_Group=teth}', "");
    Expect(1, 1820, '\p{Joining_Group=:\Ateth\z:}', "");;
    Expect(0, 1821, '\p{Joining_Group=:\Ateth\z:}', "");;
    Expect(1, 1820, '\p{Joining_Group= 	Teth}', "");
    Expect(0, 1820, '\p{^Joining_Group= 	Teth}', "");
    Expect(0, 1820, '\P{Joining_Group= 	Teth}', "");
    Expect(1, 1820, '\P{^Joining_Group= 	Teth}', "");
    Expect(0, 1821, '\p{Joining_Group= 	Teth}', "");
    Expect(1, 1821, '\p{^Joining_Group= 	Teth}', "");
    Expect(1, 1821, '\P{Joining_Group= 	Teth}', "");
    Expect(0, 1821, '\P{^Joining_Group= 	Teth}', "");
    Error('\p{Jg=:=- teth}');
    Error('\P{Jg=:=- teth}');
    Expect(1, 1820, '\p{Jg=:\ATeth\z:}', "");;
    Expect(0, 1821, '\p{Jg=:\ATeth\z:}', "");;
    Expect(1, 1820, '\p{Jg=teth}', "");
    Expect(0, 1820, '\p{^Jg=teth}', "");
    Expect(0, 1820, '\P{Jg=teth}', "");
    Expect(1, 1820, '\P{^Jg=teth}', "");
    Expect(0, 1821, '\p{Jg=teth}', "");
    Expect(1, 1821, '\p{^Jg=teth}', "");
    Expect(1, 1821, '\P{Jg=teth}', "");
    Expect(0, 1821, '\P{^Jg=teth}', "");
    Expect(1, 1820, '\p{Jg=:\Ateth\z:}', "");;
    Expect(0, 1821, '\p{Jg=:\Ateth\z:}', "");;
    Expect(1, 1820, '\p{Jg=-	TETH}', "");
    Expect(0, 1820, '\p{^Jg=-	TETH}', "");
    Expect(0, 1820, '\P{Jg=-	TETH}', "");
    Expect(1, 1820, '\P{^Jg=-	TETH}', "");
    Expect(0, 1821, '\p{Jg=-	TETH}', "");
    Expect(1, 1821, '\p{^Jg=-	TETH}', "");
    Expect(1, 1821, '\P{Jg=-	TETH}', "");
    Expect(0, 1821, '\P{^Jg=-	TETH}', "");
    Error('\p{Is_Joining_Group=	:=Teth}');
    Error('\P{Is_Joining_Group=	:=Teth}');
    Expect(1, 1820, '\p{Is_Joining_Group=teth}', "");
    Expect(0, 1820, '\p{^Is_Joining_Group=teth}', "");
    Expect(0, 1820, '\P{Is_Joining_Group=teth}', "");
    Expect(1, 1820, '\P{^Is_Joining_Group=teth}', "");
    Expect(0, 1821, '\p{Is_Joining_Group=teth}', "");
    Expect(1, 1821, '\p{^Is_Joining_Group=teth}', "");
    Expect(1, 1821, '\P{Is_Joining_Group=teth}', "");
    Expect(0, 1821, '\P{^Is_Joining_Group=teth}', "");
    Expect(1, 1820, '\p{Is_Joining_Group=Teth}', "");
    Expect(0, 1820, '\p{^Is_Joining_Group=Teth}', "");
    Expect(0, 1820, '\P{Is_Joining_Group=Teth}', "");
    Expect(1, 1820, '\P{^Is_Joining_Group=Teth}', "");
    Expect(0, 1821, '\p{Is_Joining_Group=Teth}', "");
    Expect(1, 1821, '\p{^Is_Joining_Group=Teth}', "");
    Expect(1, 1821, '\P{Is_Joining_Group=Teth}', "");
    Expect(0, 1821, '\P{^Is_Joining_Group=Teth}', "");
    Error('\p{Is_Jg=/a/  Teth}');
    Error('\P{Is_Jg=/a/  Teth}');
    Expect(1, 1820, '\p{Is_Jg=teth}', "");
    Expect(0, 1820, '\p{^Is_Jg=teth}', "");
    Expect(0, 1820, '\P{Is_Jg=teth}', "");
    Expect(1, 1820, '\P{^Is_Jg=teth}', "");
    Expect(0, 1821, '\p{Is_Jg=teth}', "");
    Expect(1, 1821, '\p{^Is_Jg=teth}', "");
    Expect(1, 1821, '\P{Is_Jg=teth}', "");
    Expect(0, 1821, '\P{^Is_Jg=teth}', "");
    Expect(1, 1820, '\p{Is_Jg=_-Teth}', "");
    Expect(0, 1820, '\p{^Is_Jg=_-Teth}', "");
    Expect(0, 1820, '\P{Is_Jg=_-Teth}', "");
    Expect(1, 1820, '\P{^Is_Jg=_-Teth}', "");
    Expect(0, 1821, '\p{Is_Jg=_-Teth}', "");
    Expect(1, 1821, '\p{^Is_Jg=_-Teth}', "");
    Expect(1, 1821, '\P{Is_Jg=_-Teth}', "");
    Expect(0, 1821, '\P{^Is_Jg=_-Teth}', "");
    Error('\p{Joining_Group=	:=waw}');
    Error('\P{Joining_Group=	:=waw}');
    Expect(1, 2219, '\p{Joining_Group=:\AWaw\z:}', "");;
    Expect(0, 2220, '\p{Joining_Group=:\AWaw\z:}', "");;
    Expect(1, 2219, '\p{Joining_Group=waw}', "");
    Expect(0, 2219, '\p{^Joining_Group=waw}', "");
    Expect(0, 2219, '\P{Joining_Group=waw}', "");
    Expect(1, 2219, '\P{^Joining_Group=waw}', "");
    Expect(0, 2220, '\p{Joining_Group=waw}', "");
    Expect(1, 2220, '\p{^Joining_Group=waw}', "");
    Expect(1, 2220, '\P{Joining_Group=waw}', "");
    Expect(0, 2220, '\P{^Joining_Group=waw}', "");
    Expect(1, 2219, '\p{Joining_Group=:\Awaw\z:}', "");;
    Expect(0, 2220, '\p{Joining_Group=:\Awaw\z:}', "");;
    Expect(1, 2219, '\p{Joining_Group= Waw}', "");
    Expect(0, 2219, '\p{^Joining_Group= Waw}', "");
    Expect(0, 2219, '\P{Joining_Group= Waw}', "");
    Expect(1, 2219, '\P{^Joining_Group= Waw}', "");
    Expect(0, 2220, '\p{Joining_Group= Waw}', "");
    Expect(1, 2220, '\p{^Joining_Group= Waw}', "");
    Expect(1, 2220, '\P{Joining_Group= Waw}', "");
    Expect(0, 2220, '\P{^Joining_Group= Waw}', "");
    Error('\p{Jg=/a/WAW}');
    Error('\P{Jg=/a/WAW}');
    Expect(1, 2219, '\p{Jg=:\AWaw\z:}', "");;
    Expect(0, 2220, '\p{Jg=:\AWaw\z:}', "");;
    Expect(1, 2219, '\p{Jg=waw}', "");
    Expect(0, 2219, '\p{^Jg=waw}', "");
    Expect(0, 2219, '\P{Jg=waw}', "");
    Expect(1, 2219, '\P{^Jg=waw}', "");
    Expect(0, 2220, '\p{Jg=waw}', "");
    Expect(1, 2220, '\p{^Jg=waw}', "");
    Expect(1, 2220, '\P{Jg=waw}', "");
    Expect(0, 2220, '\P{^Jg=waw}', "");
    Expect(1, 2219, '\p{Jg=:\Awaw\z:}', "");;
    Expect(0, 2220, '\p{Jg=:\Awaw\z:}', "");;
    Expect(1, 2219, '\p{Jg=_-waw}', "");
    Expect(0, 2219, '\p{^Jg=_-waw}', "");
    Expect(0, 2219, '\P{Jg=_-waw}', "");
    Expect(1, 2219, '\P{^Jg=_-waw}', "");
    Expect(0, 2220, '\p{Jg=_-waw}', "");
    Expect(1, 2220, '\p{^Jg=_-waw}', "");
    Expect(1, 2220, '\P{Jg=_-waw}', "");
    Expect(0, 2220, '\P{^Jg=_-waw}', "");
    Error('\p{Is_Joining_Group:   	 waw/a/}');
    Error('\P{Is_Joining_Group:   	 waw/a/}');
    Expect(1, 2219, '\p{Is_Joining_Group=waw}', "");
    Expect(0, 2219, '\p{^Is_Joining_Group=waw}', "");
    Expect(0, 2219, '\P{Is_Joining_Group=waw}', "");
    Expect(1, 2219, '\P{^Is_Joining_Group=waw}', "");
    Expect(0, 2220, '\p{Is_Joining_Group=waw}', "");
    Expect(1, 2220, '\p{^Is_Joining_Group=waw}', "");
    Expect(1, 2220, '\P{Is_Joining_Group=waw}', "");
    Expect(0, 2220, '\P{^Is_Joining_Group=waw}', "");
    Expect(1, 2219, '\p{Is_Joining_Group= -WAW}', "");
    Expect(0, 2219, '\p{^Is_Joining_Group= -WAW}', "");
    Expect(0, 2219, '\P{Is_Joining_Group= -WAW}', "");
    Expect(1, 2219, '\P{^Is_Joining_Group= -WAW}', "");
    Expect(0, 2220, '\p{Is_Joining_Group= -WAW}', "");
    Expect(1, 2220, '\p{^Is_Joining_Group= -WAW}', "");
    Expect(1, 2220, '\P{Is_Joining_Group= -WAW}', "");
    Expect(0, 2220, '\P{^Is_Joining_Group= -WAW}', "");
    Error('\p{Is_Jg=/a/-waw}');
    Error('\P{Is_Jg=/a/-waw}');
    Expect(1, 2219, '\p{Is_Jg=waw}', "");
    Expect(0, 2219, '\p{^Is_Jg=waw}', "");
    Expect(0, 2219, '\P{Is_Jg=waw}', "");
    Expect(1, 2219, '\P{^Is_Jg=waw}', "");
    Expect(0, 2220, '\p{Is_Jg=waw}', "");
    Expect(1, 2220, '\p{^Is_Jg=waw}', "");
    Expect(1, 2220, '\P{Is_Jg=waw}', "");
    Expect(0, 2220, '\P{^Is_Jg=waw}', "");
    Expect(1, 2219, '\p{Is_Jg=- Waw}', "");
    Expect(0, 2219, '\p{^Is_Jg=- Waw}', "");
    Expect(0, 2219, '\P{Is_Jg=- Waw}', "");
    Expect(1, 2219, '\P{^Is_Jg=- Waw}', "");
    Expect(0, 2220, '\p{Is_Jg=- Waw}', "");
    Expect(1, 2220, '\p{^Is_Jg=- Waw}', "");
    Expect(1, 2220, '\P{Is_Jg=- Waw}', "");
    Expect(0, 2220, '\P{^Is_Jg=- Waw}', "");
    Error('\p{Joining_Group=	Yeh/a/}');
    Error('\P{Joining_Group=	Yeh/a/}');
    Expect(1, 2234, '\p{Joining_Group=:\AYeh\z:}', "");;
    Expect(0, 2235, '\p{Joining_Group=:\AYeh\z:}', "");;
    Expect(1, 2234, '\p{Joining_Group=yeh}', "");
    Expect(0, 2234, '\p{^Joining_Group=yeh}', "");
    Expect(0, 2234, '\P{Joining_Group=yeh}', "");
    Expect(1, 2234, '\P{^Joining_Group=yeh}', "");
    Expect(0, 2235, '\p{Joining_Group=yeh}', "");
    Expect(1, 2235, '\p{^Joining_Group=yeh}', "");
    Expect(1, 2235, '\P{Joining_Group=yeh}', "");
    Expect(0, 2235, '\P{^Joining_Group=yeh}', "");
    Expect(1, 2234, '\p{Joining_Group=:\Ayeh\z:}', "");;
    Expect(0, 2235, '\p{Joining_Group=:\Ayeh\z:}', "");;
    Expect(1, 2234, '\p{Joining_Group= 	yeh}', "");
    Expect(0, 2234, '\p{^Joining_Group= 	yeh}', "");
    Expect(0, 2234, '\P{Joining_Group= 	yeh}', "");
    Expect(1, 2234, '\P{^Joining_Group= 	yeh}', "");
    Expect(0, 2235, '\p{Joining_Group= 	yeh}', "");
    Expect(1, 2235, '\p{^Joining_Group= 	yeh}', "");
    Expect(1, 2235, '\P{Joining_Group= 	yeh}', "");
    Expect(0, 2235, '\P{^Joining_Group= 	yeh}', "");
    Error('\p{Jg=:=--yeh}');
    Error('\P{Jg=:=--yeh}');
    Expect(1, 2234, '\p{Jg=:\AYeh\z:}', "");;
    Expect(0, 2235, '\p{Jg=:\AYeh\z:}', "");;
    Expect(1, 2234, '\p{Jg=yeh}', "");
    Expect(0, 2234, '\p{^Jg=yeh}', "");
    Expect(0, 2234, '\P{Jg=yeh}', "");
    Expect(1, 2234, '\P{^Jg=yeh}', "");
    Expect(0, 2235, '\p{Jg=yeh}', "");
    Expect(1, 2235, '\p{^Jg=yeh}', "");
    Expect(1, 2235, '\P{Jg=yeh}', "");
    Expect(0, 2235, '\P{^Jg=yeh}', "");
    Expect(1, 2234, '\p{Jg=:\Ayeh\z:}', "");;
    Expect(0, 2235, '\p{Jg=:\Ayeh\z:}', "");;
    Expect(1, 2234, '\p{Jg=_Yeh}', "");
    Expect(0, 2234, '\p{^Jg=_Yeh}', "");
    Expect(0, 2234, '\P{Jg=_Yeh}', "");
    Expect(1, 2234, '\P{^Jg=_Yeh}', "");
    Expect(0, 2235, '\p{Jg=_Yeh}', "");
    Expect(1, 2235, '\p{^Jg=_Yeh}', "");
    Expect(1, 2235, '\P{Jg=_Yeh}', "");
    Expect(0, 2235, '\P{^Jg=_Yeh}', "");
    Error('\p{Is_Joining_Group=_/a/YEH}');
    Error('\P{Is_Joining_Group=_/a/YEH}');
    Expect(1, 2234, '\p{Is_Joining_Group=yeh}', "");
    Expect(0, 2234, '\p{^Is_Joining_Group=yeh}', "");
    Expect(0, 2234, '\P{Is_Joining_Group=yeh}', "");
    Expect(1, 2234, '\P{^Is_Joining_Group=yeh}', "");
    Expect(0, 2235, '\p{Is_Joining_Group=yeh}', "");
    Expect(1, 2235, '\p{^Is_Joining_Group=yeh}', "");
    Expect(1, 2235, '\P{Is_Joining_Group=yeh}', "");
    Expect(0, 2235, '\P{^Is_Joining_Group=yeh}', "");
    Expect(1, 2234, '\p{Is_Joining_Group=	 Yeh}', "");
    Expect(0, 2234, '\p{^Is_Joining_Group=	 Yeh}', "");
    Expect(0, 2234, '\P{Is_Joining_Group=	 Yeh}', "");
    Expect(1, 2234, '\P{^Is_Joining_Group=	 Yeh}', "");
    Expect(0, 2235, '\p{Is_Joining_Group=	 Yeh}', "");
    Expect(1, 2235, '\p{^Is_Joining_Group=	 Yeh}', "");
    Expect(1, 2235, '\P{Is_Joining_Group=	 Yeh}', "");
    Expect(0, 2235, '\P{^Is_Joining_Group=	 Yeh}', "");
    Error('\p{Is_Jg::=Yeh}');
    Error('\P{Is_Jg::=Yeh}');
    Expect(1, 2234, '\p{Is_Jg=yeh}', "");
    Expect(0, 2234, '\p{^Is_Jg=yeh}', "");
    Expect(0, 2234, '\P{Is_Jg=yeh}', "");
    Expect(1, 2234, '\P{^Is_Jg=yeh}', "");
    Expect(0, 2235, '\p{Is_Jg=yeh}', "");
    Expect(1, 2235, '\p{^Is_Jg=yeh}', "");
    Expect(1, 2235, '\P{Is_Jg=yeh}', "");
    Expect(0, 2235, '\P{^Is_Jg=yeh}', "");
    Error('\p{Joining_Group=/a/YEH_Barree}');
    Error('\P{Joining_Group=/a/YEH_Barree}');
    Expect(1, 1747, '\p{Joining_Group=:\AYeh_Barree\z:}', "");;
    Expect(0, 1748, '\p{Joining_Group=:\AYeh_Barree\z:}', "");;
    Expect(1, 1747, '\p{Joining_Group=yehbarree}', "");
    Expect(0, 1747, '\p{^Joining_Group=yehbarree}', "");
    Expect(0, 1747, '\P{Joining_Group=yehbarree}', "");
    Expect(1, 1747, '\P{^Joining_Group=yehbarree}', "");
    Expect(0, 1748, '\p{Joining_Group=yehbarree}', "");
    Expect(1, 1748, '\p{^Joining_Group=yehbarree}', "");
    Expect(1, 1748, '\P{Joining_Group=yehbarree}', "");
    Expect(0, 1748, '\P{^Joining_Group=yehbarree}', "");
    Expect(1, 1747, '\p{Joining_Group=:\Ayehbarree\z:}', "");;
    Expect(0, 1748, '\p{Joining_Group=:\Ayehbarree\z:}', "");;
    Expect(1, 1747, '\p{Joining_Group=_	Yeh_Barree}', "");
    Expect(0, 1747, '\p{^Joining_Group=_	Yeh_Barree}', "");
    Expect(0, 1747, '\P{Joining_Group=_	Yeh_Barree}', "");
    Expect(1, 1747, '\P{^Joining_Group=_	Yeh_Barree}', "");
    Expect(0, 1748, '\p{Joining_Group=_	Yeh_Barree}', "");
    Expect(1, 1748, '\p{^Joining_Group=_	Yeh_Barree}', "");
    Expect(1, 1748, '\P{Joining_Group=_	Yeh_Barree}', "");
    Expect(0, 1748, '\P{^Joining_Group=_	Yeh_Barree}', "");
    Error('\p{Jg=-	YEH_barree/a/}');
    Error('\P{Jg=-	YEH_barree/a/}');
    Expect(1, 1747, '\p{Jg=:\AYeh_Barree\z:}', "");;
    Expect(0, 1748, '\p{Jg=:\AYeh_Barree\z:}', "");;
    Expect(1, 1747, '\p{Jg: yehbarree}', "");
    Expect(0, 1747, '\p{^Jg: yehbarree}', "");
    Expect(0, 1747, '\P{Jg: yehbarree}', "");
    Expect(1, 1747, '\P{^Jg: yehbarree}', "");
    Expect(0, 1748, '\p{Jg: yehbarree}', "");
    Expect(1, 1748, '\p{^Jg: yehbarree}', "");
    Expect(1, 1748, '\P{Jg: yehbarree}', "");
    Expect(0, 1748, '\P{^Jg: yehbarree}', "");
    Expect(1, 1747, '\p{Jg=:\Ayehbarree\z:}', "");;
    Expect(0, 1748, '\p{Jg=:\Ayehbarree\z:}', "");;
    Expect(1, 1747, '\p{Jg=-YEH_Barree}', "");
    Expect(0, 1747, '\p{^Jg=-YEH_Barree}', "");
    Expect(0, 1747, '\P{Jg=-YEH_Barree}', "");
    Expect(1, 1747, '\P{^Jg=-YEH_Barree}', "");
    Expect(0, 1748, '\p{Jg=-YEH_Barree}', "");
    Expect(1, 1748, '\p{^Jg=-YEH_Barree}', "");
    Expect(1, 1748, '\P{Jg=-YEH_Barree}', "");
    Expect(0, 1748, '\P{^Jg=-YEH_Barree}', "");
    Error('\p{Is_Joining_Group:	_:=YEH_Barree}');
    Error('\P{Is_Joining_Group:	_:=YEH_Barree}');
    Expect(1, 1747, '\p{Is_Joining_Group=yehbarree}', "");
    Expect(0, 1747, '\p{^Is_Joining_Group=yehbarree}', "");
    Expect(0, 1747, '\P{Is_Joining_Group=yehbarree}', "");
    Expect(1, 1747, '\P{^Is_Joining_Group=yehbarree}', "");
    Expect(0, 1748, '\p{Is_Joining_Group=yehbarree}', "");
    Expect(1, 1748, '\p{^Is_Joining_Group=yehbarree}', "");
    Expect(1, 1748, '\P{Is_Joining_Group=yehbarree}', "");
    Expect(0, 1748, '\P{^Is_Joining_Group=yehbarree}', "");
    Expect(1, 1747, '\p{Is_Joining_Group=		Yeh_Barree}', "");
    Expect(0, 1747, '\p{^Is_Joining_Group=		Yeh_Barree}', "");
    Expect(0, 1747, '\P{Is_Joining_Group=		Yeh_Barree}', "");
    Expect(1, 1747, '\P{^Is_Joining_Group=		Yeh_Barree}', "");
    Expect(0, 1748, '\p{Is_Joining_Group=		Yeh_Barree}', "");
    Expect(1, 1748, '\p{^Is_Joining_Group=		Yeh_Barree}', "");
    Expect(1, 1748, '\P{Is_Joining_Group=		Yeh_Barree}', "");
    Expect(0, 1748, '\P{^Is_Joining_Group=		Yeh_Barree}', "");
    Error('\p{Is_Jg= YEH_barree/a/}');
    Error('\P{Is_Jg= YEH_barree/a/}');
    Expect(1, 1747, '\p{Is_Jg=yehbarree}', "");
    Expect(0, 1747, '\p{^Is_Jg=yehbarree}', "");
    Expect(0, 1747, '\P{Is_Jg=yehbarree}', "");
    Expect(1, 1747, '\P{^Is_Jg=yehbarree}', "");
    Expect(0, 1748, '\p{Is_Jg=yehbarree}', "");
    Expect(1, 1748, '\p{^Is_Jg=yehbarree}', "");
    Expect(1, 1748, '\P{Is_Jg=yehbarree}', "");
    Expect(0, 1748, '\P{^Is_Jg=yehbarree}', "");
    Expect(1, 1747, '\p{Is_Jg=	-Yeh_barree}', "");
    Expect(0, 1747, '\p{^Is_Jg=	-Yeh_barree}', "");
    Expect(0, 1747, '\P{Is_Jg=	-Yeh_barree}', "");
    Expect(1, 1747, '\P{^Is_Jg=	-Yeh_barree}', "");
    Expect(0, 1748, '\p{Is_Jg=	-Yeh_barree}', "");
    Expect(1, 1748, '\p{^Is_Jg=	-Yeh_barree}', "");
    Expect(1, 1748, '\P{Is_Jg=	-Yeh_barree}', "");
    Expect(0, 1748, '\P{^Is_Jg=	-Yeh_barree}', "");
    Error('\p{Joining_Group=	YEH_With_tail/a/}');
    Error('\P{Joining_Group=	YEH_With_tail/a/}');
    Expect(1, 1741, '\p{Joining_Group=:\AYeh_With_Tail\z:}', "");;
    Expect(0, 1742, '\p{Joining_Group=:\AYeh_With_Tail\z:}', "");;
    Expect(1, 1741, '\p{Joining_Group=yehwithtail}', "");
    Expect(0, 1741, '\p{^Joining_Group=yehwithtail}', "");
    Expect(0, 1741, '\P{Joining_Group=yehwithtail}', "");
    Expect(1, 1741, '\P{^Joining_Group=yehwithtail}', "");
    Expect(0, 1742, '\p{Joining_Group=yehwithtail}', "");
    Expect(1, 1742, '\p{^Joining_Group=yehwithtail}', "");
    Expect(1, 1742, '\P{Joining_Group=yehwithtail}', "");
    Expect(0, 1742, '\P{^Joining_Group=yehwithtail}', "");
    Expect(1, 1741, '\p{Joining_Group=:\Ayehwithtail\z:}', "");;
    Expect(0, 1742, '\p{Joining_Group=:\Ayehwithtail\z:}', "");;
    Expect(1, 1741, '\p{Joining_Group:-_YEH_With_TAIL}', "");
    Expect(0, 1741, '\p{^Joining_Group:-_YEH_With_TAIL}', "");
    Expect(0, 1741, '\P{Joining_Group:-_YEH_With_TAIL}', "");
    Expect(1, 1741, '\P{^Joining_Group:-_YEH_With_TAIL}', "");
    Expect(0, 1742, '\p{Joining_Group:-_YEH_With_TAIL}', "");
    Expect(1, 1742, '\p{^Joining_Group:-_YEH_With_TAIL}', "");
    Expect(1, 1742, '\P{Joining_Group:-_YEH_With_TAIL}', "");
    Expect(0, 1742, '\P{^Joining_Group:-_YEH_With_TAIL}', "");
    Error('\p{Jg= Yeh_WITH_Tail:=}');
    Error('\P{Jg= Yeh_WITH_Tail:=}');
    Expect(1, 1741, '\p{Jg=:\AYeh_With_Tail\z:}', "");;
    Expect(0, 1742, '\p{Jg=:\AYeh_With_Tail\z:}', "");;
    Expect(1, 1741, '\p{Jg=yehwithtail}', "");
    Expect(0, 1741, '\p{^Jg=yehwithtail}', "");
    Expect(0, 1741, '\P{Jg=yehwithtail}', "");
    Expect(1, 1741, '\P{^Jg=yehwithtail}', "");
    Expect(0, 1742, '\p{Jg=yehwithtail}', "");
    Expect(1, 1742, '\p{^Jg=yehwithtail}', "");
    Expect(1, 1742, '\P{Jg=yehwithtail}', "");
    Expect(0, 1742, '\P{^Jg=yehwithtail}', "");
    Expect(1, 1741, '\p{Jg=:\Ayehwithtail\z:}', "");;
    Expect(0, 1742, '\p{Jg=:\Ayehwithtail\z:}', "");;
    Expect(1, 1741, '\p{Jg=-_YEH_with_tail}', "");
    Expect(0, 1741, '\p{^Jg=-_YEH_with_tail}', "");
    Expect(0, 1741, '\P{Jg=-_YEH_with_tail}', "");
    Expect(1, 1741, '\P{^Jg=-_YEH_with_tail}', "");
    Expect(0, 1742, '\p{Jg=-_YEH_with_tail}', "");
    Expect(1, 1742, '\p{^Jg=-_YEH_with_tail}', "");
    Expect(1, 1742, '\P{Jg=-_YEH_with_tail}', "");
    Expect(0, 1742, '\P{^Jg=-_YEH_with_tail}', "");
    Error('\p{Is_Joining_Group=:=_ Yeh_WITH_tail}');
    Error('\P{Is_Joining_Group=:=_ Yeh_WITH_tail}');
    Expect(1, 1741, '\p{Is_Joining_Group:   yehwithtail}', "");
    Expect(0, 1741, '\p{^Is_Joining_Group:   yehwithtail}', "");
    Expect(0, 1741, '\P{Is_Joining_Group:   yehwithtail}', "");
    Expect(1, 1741, '\P{^Is_Joining_Group:   yehwithtail}', "");
    Expect(0, 1742, '\p{Is_Joining_Group:   yehwithtail}', "");
    Expect(1, 1742, '\p{^Is_Joining_Group:   yehwithtail}', "");
    Expect(1, 1742, '\P{Is_Joining_Group:   yehwithtail}', "");
    Expect(0, 1742, '\P{^Is_Joining_Group:   yehwithtail}', "");
    Expect(1, 1741, '\p{Is_Joining_Group=-	YEH_WITH_Tail}', "");
    Expect(0, 1741, '\p{^Is_Joining_Group=-	YEH_WITH_Tail}', "");
    Expect(0, 1741, '\P{Is_Joining_Group=-	YEH_WITH_Tail}', "");
    Expect(1, 1741, '\P{^Is_Joining_Group=-	YEH_WITH_Tail}', "");
    Expect(0, 1742, '\p{Is_Joining_Group=-	YEH_WITH_Tail}', "");
    Expect(1, 1742, '\p{^Is_Joining_Group=-	YEH_WITH_Tail}', "");
    Expect(1, 1742, '\P{Is_Joining_Group=-	YEH_WITH_Tail}', "");
    Expect(0, 1742, '\P{^Is_Joining_Group=-	YEH_WITH_Tail}', "");
    Error('\p{Is_Jg=	:=yeh_with_Tail}');
    Error('\P{Is_Jg=	:=yeh_with_Tail}');
    Expect(1, 1741, '\p{Is_Jg=yehwithtail}', "");
    Expect(0, 1741, '\p{^Is_Jg=yehwithtail}', "");
    Expect(0, 1741, '\P{Is_Jg=yehwithtail}', "");
    Expect(1, 1741, '\P{^Is_Jg=yehwithtail}', "");
    Expect(0, 1742, '\p{Is_Jg=yehwithtail}', "");
    Expect(1, 1742, '\p{^Is_Jg=yehwithtail}', "");
    Expect(1, 1742, '\P{Is_Jg=yehwithtail}', "");
    Expect(0, 1742, '\P{^Is_Jg=yehwithtail}', "");
    Expect(1, 1741, '\p{Is_Jg=_ YEH_With_tail}', "");
    Expect(0, 1741, '\p{^Is_Jg=_ YEH_With_tail}', "");
    Expect(0, 1741, '\P{Is_Jg=_ YEH_With_tail}', "");
    Expect(1, 1741, '\P{^Is_Jg=_ YEH_With_tail}', "");
    Expect(0, 1742, '\p{Is_Jg=_ YEH_With_tail}', "");
    Expect(1, 1742, '\p{^Is_Jg=_ YEH_With_tail}', "");
    Expect(1, 1742, '\P{Is_Jg=_ YEH_With_tail}', "");
    Expect(0, 1742, '\P{^Is_Jg=_ YEH_With_tail}', "");
    Error('\p{Joining_Group:	/a/- YUDH}');
    Error('\P{Joining_Group:	/a/- YUDH}');
    Expect(1, 1821, '\p{Joining_Group=:\AYudh\z:}', "");;
    Expect(0, 1822, '\p{Joining_Group=:\AYudh\z:}', "");;
    Expect(1, 1821, '\p{Joining_Group=yudh}', "");
    Expect(0, 1821, '\p{^Joining_Group=yudh}', "");
    Expect(0, 1821, '\P{Joining_Group=yudh}', "");
    Expect(1, 1821, '\P{^Joining_Group=yudh}', "");
    Expect(0, 1822, '\p{Joining_Group=yudh}', "");
    Expect(1, 1822, '\p{^Joining_Group=yudh}', "");
    Expect(1, 1822, '\P{Joining_Group=yudh}', "");
    Expect(0, 1822, '\P{^Joining_Group=yudh}', "");
    Expect(1, 1821, '\p{Joining_Group=:\Ayudh\z:}', "");;
    Expect(0, 1822, '\p{Joining_Group=:\Ayudh\z:}', "");;
    Expect(1, 1821, '\p{Joining_Group=_YUDH}', "");
    Expect(0, 1821, '\p{^Joining_Group=_YUDH}', "");
    Expect(0, 1821, '\P{Joining_Group=_YUDH}', "");
    Expect(1, 1821, '\P{^Joining_Group=_YUDH}', "");
    Expect(0, 1822, '\p{Joining_Group=_YUDH}', "");
    Expect(1, 1822, '\p{^Joining_Group=_YUDH}', "");
    Expect(1, 1822, '\P{Joining_Group=_YUDH}', "");
    Expect(0, 1822, '\P{^Joining_Group=_YUDH}', "");
    Error('\p{Jg= :=Yudh}');
    Error('\P{Jg= :=Yudh}');
    Expect(1, 1821, '\p{Jg=:\AYudh\z:}', "");;
    Expect(0, 1822, '\p{Jg=:\AYudh\z:}', "");;
    Expect(1, 1821, '\p{Jg=yudh}', "");
    Expect(0, 1821, '\p{^Jg=yudh}', "");
    Expect(0, 1821, '\P{Jg=yudh}', "");
    Expect(1, 1821, '\P{^Jg=yudh}', "");
    Expect(0, 1822, '\p{Jg=yudh}', "");
    Expect(1, 1822, '\p{^Jg=yudh}', "");
    Expect(1, 1822, '\P{Jg=yudh}', "");
    Expect(0, 1822, '\P{^Jg=yudh}', "");
    Expect(1, 1821, '\p{Jg=:\Ayudh\z:}', "");;
    Expect(0, 1822, '\p{Jg=:\Ayudh\z:}', "");;
    Expect(1, 1821, '\p{Jg=	Yudh}', "");
    Expect(0, 1821, '\p{^Jg=	Yudh}', "");
    Expect(0, 1821, '\P{Jg=	Yudh}', "");
    Expect(1, 1821, '\P{^Jg=	Yudh}', "");
    Expect(0, 1822, '\p{Jg=	Yudh}', "");
    Expect(1, 1822, '\p{^Jg=	Yudh}', "");
    Expect(1, 1822, '\P{Jg=	Yudh}', "");
    Expect(0, 1822, '\P{^Jg=	Yudh}', "");
    Error('\p{Is_Joining_Group=_	Yudh:=}');
    Error('\P{Is_Joining_Group=_	Yudh:=}');
    Expect(1, 1821, '\p{Is_Joining_Group:	yudh}', "");
    Expect(0, 1821, '\p{^Is_Joining_Group:	yudh}', "");
    Expect(0, 1821, '\P{Is_Joining_Group:	yudh}', "");
    Expect(1, 1821, '\P{^Is_Joining_Group:	yudh}', "");
    Expect(0, 1822, '\p{Is_Joining_Group:	yudh}', "");
    Expect(1, 1822, '\p{^Is_Joining_Group:	yudh}', "");
    Expect(1, 1822, '\P{Is_Joining_Group:	yudh}', "");
    Expect(0, 1822, '\P{^Is_Joining_Group:	yudh}', "");
    Expect(1, 1821, '\p{Is_Joining_Group=_Yudh}', "");
    Expect(0, 1821, '\p{^Is_Joining_Group=_Yudh}', "");
    Expect(0, 1821, '\P{Is_Joining_Group=_Yudh}', "");
    Expect(1, 1821, '\P{^Is_Joining_Group=_Yudh}', "");
    Expect(0, 1822, '\p{Is_Joining_Group=_Yudh}', "");
    Expect(1, 1822, '\p{^Is_Joining_Group=_Yudh}', "");
    Expect(1, 1822, '\P{Is_Joining_Group=_Yudh}', "");
    Expect(0, 1822, '\P{^Is_Joining_Group=_Yudh}', "");
    Error('\p{Is_Jg=	_YUDH/a/}');
    Error('\P{Is_Jg=	_YUDH/a/}');
    Expect(1, 1821, '\p{Is_Jg=yudh}', "");
    Expect(0, 1821, '\p{^Is_Jg=yudh}', "");
    Expect(0, 1821, '\P{Is_Jg=yudh}', "");
    Expect(1, 1821, '\P{^Is_Jg=yudh}', "");
    Expect(0, 1822, '\p{Is_Jg=yudh}', "");
    Expect(1, 1822, '\p{^Is_Jg=yudh}', "");
    Expect(1, 1822, '\P{Is_Jg=yudh}', "");
    Expect(0, 1822, '\P{^Is_Jg=yudh}', "");
    Expect(1, 1821, '\p{Is_Jg= -Yudh}', "");
    Expect(0, 1821, '\p{^Is_Jg= -Yudh}', "");
    Expect(0, 1821, '\P{Is_Jg= -Yudh}', "");
    Expect(1, 1821, '\P{^Is_Jg= -Yudh}', "");
    Expect(0, 1822, '\p{Is_Jg= -Yudh}', "");
    Expect(1, 1822, '\p{^Is_Jg= -Yudh}', "");
    Expect(1, 1822, '\P{Is_Jg= -Yudh}', "");
    Expect(0, 1822, '\P{^Is_Jg= -Yudh}', "");
    Error('\p{Joining_Group=/a/_YUDH_he}');
    Error('\P{Joining_Group=/a/_YUDH_he}');
    Expect(1, 1822, '\p{Joining_Group=:\AYudh_He\z:}', "");;
    Expect(0, 1823, '\p{Joining_Group=:\AYudh_He\z:}', "");;
    Expect(1, 1822, '\p{Joining_Group=yudhhe}', "");
    Expect(0, 1822, '\p{^Joining_Group=yudhhe}', "");
    Expect(0, 1822, '\P{Joining_Group=yudhhe}', "");
    Expect(1, 1822, '\P{^Joining_Group=yudhhe}', "");
    Expect(0, 1823, '\p{Joining_Group=yudhhe}', "");
    Expect(1, 1823, '\p{^Joining_Group=yudhhe}', "");
    Expect(1, 1823, '\P{Joining_Group=yudhhe}', "");
    Expect(0, 1823, '\P{^Joining_Group=yudhhe}', "");
    Expect(1, 1822, '\p{Joining_Group=:\Ayudhhe\z:}', "");;
    Expect(0, 1823, '\p{Joining_Group=:\Ayudhhe\z:}', "");;
    Expect(1, 1822, '\p{Joining_Group=--YUDH_HE}', "");
    Expect(0, 1822, '\p{^Joining_Group=--YUDH_HE}', "");
    Expect(0, 1822, '\P{Joining_Group=--YUDH_HE}', "");
    Expect(1, 1822, '\P{^Joining_Group=--YUDH_HE}', "");
    Expect(0, 1823, '\p{Joining_Group=--YUDH_HE}', "");
    Expect(1, 1823, '\p{^Joining_Group=--YUDH_HE}', "");
    Expect(1, 1823, '\P{Joining_Group=--YUDH_HE}', "");
    Expect(0, 1823, '\P{^Joining_Group=--YUDH_HE}', "");
    Error('\p{Jg:   :=  Yudh_HE}');
    Error('\P{Jg:   :=  Yudh_HE}');
    Expect(1, 1822, '\p{Jg=:\AYudh_He\z:}', "");;
    Expect(0, 1823, '\p{Jg=:\AYudh_He\z:}', "");;
    Expect(1, 1822, '\p{Jg=yudhhe}', "");
    Expect(0, 1822, '\p{^Jg=yudhhe}', "");
    Expect(0, 1822, '\P{Jg=yudhhe}', "");
    Expect(1, 1822, '\P{^Jg=yudhhe}', "");
    Expect(0, 1823, '\p{Jg=yudhhe}', "");
    Expect(1, 1823, '\p{^Jg=yudhhe}', "");
    Expect(1, 1823, '\P{Jg=yudhhe}', "");
    Expect(0, 1823, '\P{^Jg=yudhhe}', "");
    Expect(1, 1822, '\p{Jg=:\Ayudhhe\z:}', "");;
    Expect(0, 1823, '\p{Jg=:\Ayudhhe\z:}', "");;
    Expect(1, 1822, '\p{Jg=	_Yudh_He}', "");
    Expect(0, 1822, '\p{^Jg=	_Yudh_He}', "");
    Expect(0, 1822, '\P{Jg=	_Yudh_He}', "");
    Expect(1, 1822, '\P{^Jg=	_Yudh_He}', "");
    Expect(0, 1823, '\p{Jg=	_Yudh_He}', "");
    Expect(1, 1823, '\p{^Jg=	_Yudh_He}', "");
    Expect(1, 1823, '\P{Jg=	_Yudh_He}', "");
    Expect(0, 1823, '\P{^Jg=	_Yudh_He}', "");
    Error('\p{Is_Joining_Group=/a/	Yudh_He}');
    Error('\P{Is_Joining_Group=/a/	Yudh_He}');
    Expect(1, 1822, '\p{Is_Joining_Group=yudhhe}', "");
    Expect(0, 1822, '\p{^Is_Joining_Group=yudhhe}', "");
    Expect(0, 1822, '\P{Is_Joining_Group=yudhhe}', "");
    Expect(1, 1822, '\P{^Is_Joining_Group=yudhhe}', "");
    Expect(0, 1823, '\p{Is_Joining_Group=yudhhe}', "");
    Expect(1, 1823, '\p{^Is_Joining_Group=yudhhe}', "");
    Expect(1, 1823, '\P{Is_Joining_Group=yudhhe}', "");
    Expect(0, 1823, '\P{^Is_Joining_Group=yudhhe}', "");
    Expect(1, 1822, '\p{Is_Joining_Group=-yudh_HE}', "");
    Expect(0, 1822, '\p{^Is_Joining_Group=-yudh_HE}', "");
    Expect(0, 1822, '\P{Is_Joining_Group=-yudh_HE}', "");
    Expect(1, 1822, '\P{^Is_Joining_Group=-yudh_HE}', "");
    Expect(0, 1823, '\p{Is_Joining_Group=-yudh_HE}', "");
    Expect(1, 1823, '\p{^Is_Joining_Group=-yudh_HE}', "");
    Expect(1, 1823, '\P{Is_Joining_Group=-yudh_HE}', "");
    Expect(0, 1823, '\P{^Is_Joining_Group=-yudh_HE}', "");
    Error('\p{Is_Jg=/a/__Yudh_He}');
    Error('\P{Is_Jg=/a/__Yudh_He}');
    Expect(1, 1822, '\p{Is_Jg=yudhhe}', "");
    Expect(0, 1822, '\p{^Is_Jg=yudhhe}', "");
    Expect(0, 1822, '\P{Is_Jg=yudhhe}', "");
    Expect(1, 1822, '\P{^Is_Jg=yudhhe}', "");
    Expect(0, 1823, '\p{Is_Jg=yudhhe}', "");
    Expect(1, 1823, '\p{^Is_Jg=yudhhe}', "");
    Expect(1, 1823, '\P{Is_Jg=yudhhe}', "");
    Expect(0, 1823, '\P{^Is_Jg=yudhhe}', "");
    Expect(1, 1822, '\p{Is_Jg:    YUDH_He}', "");
    Expect(0, 1822, '\p{^Is_Jg:    YUDH_He}', "");
    Expect(0, 1822, '\P{Is_Jg:    YUDH_He}', "");
    Expect(1, 1822, '\P{^Is_Jg:    YUDH_He}', "");
    Expect(0, 1823, '\p{Is_Jg:    YUDH_He}', "");
    Expect(1, 1823, '\p{^Is_Jg:    YUDH_He}', "");
    Expect(1, 1823, '\P{Is_Jg:    YUDH_He}', "");
    Expect(0, 1823, '\P{^Is_Jg:    YUDH_He}', "");
    Error('\p{Joining_Group=	_Zain:=}');
    Error('\P{Joining_Group=	_Zain:=}');
    Expect(1, 1817, '\p{Joining_Group=:\AZain\z:}', "");;
    Expect(0, 1818, '\p{Joining_Group=:\AZain\z:}', "");;
    Expect(1, 1817, '\p{Joining_Group=zain}', "");
    Expect(0, 1817, '\p{^Joining_Group=zain}', "");
    Expect(0, 1817, '\P{Joining_Group=zain}', "");
    Expect(1, 1817, '\P{^Joining_Group=zain}', "");
    Expect(0, 1818, '\p{Joining_Group=zain}', "");
    Expect(1, 1818, '\p{^Joining_Group=zain}', "");
    Expect(1, 1818, '\P{Joining_Group=zain}', "");
    Expect(0, 1818, '\P{^Joining_Group=zain}', "");
    Expect(1, 1817, '\p{Joining_Group=:\Azain\z:}', "");;
    Expect(0, 1818, '\p{Joining_Group=:\Azain\z:}', "");;
    Expect(1, 1817, '\p{Joining_Group= zain}', "");
    Expect(0, 1817, '\p{^Joining_Group= zain}', "");
    Expect(0, 1817, '\P{Joining_Group= zain}', "");
    Expect(1, 1817, '\P{^Joining_Group= zain}', "");
    Expect(0, 1818, '\p{Joining_Group= zain}', "");
    Expect(1, 1818, '\p{^Joining_Group= zain}', "");
    Expect(1, 1818, '\P{Joining_Group= zain}', "");
    Expect(0, 1818, '\P{^Joining_Group= zain}', "");
    Error('\p{Jg=_/a/ZAIN}');
    Error('\P{Jg=_/a/ZAIN}');
    Expect(1, 1817, '\p{Jg=:\AZain\z:}', "");;
    Expect(0, 1818, '\p{Jg=:\AZain\z:}', "");;
    Expect(1, 1817, '\p{Jg=zain}', "");
    Expect(0, 1817, '\p{^Jg=zain}', "");
    Expect(0, 1817, '\P{Jg=zain}', "");
    Expect(1, 1817, '\P{^Jg=zain}', "");
    Expect(0, 1818, '\p{Jg=zain}', "");
    Expect(1, 1818, '\p{^Jg=zain}', "");
    Expect(1, 1818, '\P{Jg=zain}', "");
    Expect(0, 1818, '\P{^Jg=zain}', "");
    Expect(1, 1817, '\p{Jg=:\Azain\z:}', "");;
    Expect(0, 1818, '\p{Jg=:\Azain\z:}', "");;
    Expect(1, 1817, '\p{Jg=-_Zain}', "");
    Expect(0, 1817, '\p{^Jg=-_Zain}', "");
    Expect(0, 1817, '\P{Jg=-_Zain}', "");
    Expect(1, 1817, '\P{^Jg=-_Zain}', "");
    Expect(0, 1818, '\p{Jg=-_Zain}', "");
    Expect(1, 1818, '\p{^Jg=-_Zain}', "");
    Expect(1, 1818, '\P{Jg=-_Zain}', "");
    Expect(0, 1818, '\P{^Jg=-_Zain}', "");
    Error('\p{Is_Joining_Group=:=-	Zain}');
    Error('\P{Is_Joining_Group=:=-	Zain}');
    Expect(1, 1817, '\p{Is_Joining_Group=zain}', "");
    Expect(0, 1817, '\p{^Is_Joining_Group=zain}', "");
    Expect(0, 1817, '\P{Is_Joining_Group=zain}', "");
    Expect(1, 1817, '\P{^Is_Joining_Group=zain}', "");
    Expect(0, 1818, '\p{Is_Joining_Group=zain}', "");
    Expect(1, 1818, '\p{^Is_Joining_Group=zain}', "");
    Expect(1, 1818, '\P{Is_Joining_Group=zain}', "");
    Expect(0, 1818, '\P{^Is_Joining_Group=zain}', "");
    Expect(1, 1817, '\p{Is_Joining_Group=-ZAIN}', "");
    Expect(0, 1817, '\p{^Is_Joining_Group=-ZAIN}', "");
    Expect(0, 1817, '\P{Is_Joining_Group=-ZAIN}', "");
    Expect(1, 1817, '\P{^Is_Joining_Group=-ZAIN}', "");
    Expect(0, 1818, '\p{Is_Joining_Group=-ZAIN}', "");
    Expect(1, 1818, '\p{^Is_Joining_Group=-ZAIN}', "");
    Expect(1, 1818, '\P{Is_Joining_Group=-ZAIN}', "");
    Expect(0, 1818, '\P{^Is_Joining_Group=-ZAIN}', "");
    Error('\p{Is_Jg=_/a/Zain}');
    Error('\P{Is_Jg=_/a/Zain}');
    Expect(1, 1817, '\p{Is_Jg=zain}', "");
    Expect(0, 1817, '\p{^Is_Jg=zain}', "");
    Expect(0, 1817, '\P{Is_Jg=zain}', "");
    Expect(1, 1817, '\P{^Is_Jg=zain}', "");
    Expect(0, 1818, '\p{Is_Jg=zain}', "");
    Expect(1, 1818, '\p{^Is_Jg=zain}', "");
    Expect(1, 1818, '\P{Is_Jg=zain}', "");
    Expect(0, 1818, '\P{^Is_Jg=zain}', "");
    Expect(1, 1817, '\p{Is_Jg= -zain}', "");
    Expect(0, 1817, '\p{^Is_Jg= -zain}', "");
    Expect(0, 1817, '\P{Is_Jg= -zain}', "");
    Expect(1, 1817, '\P{^Is_Jg= -zain}', "");
    Expect(0, 1818, '\p{Is_Jg= -zain}', "");
    Expect(1, 1818, '\p{^Is_Jg= -zain}', "");
    Expect(1, 1818, '\P{Is_Jg= -zain}', "");
    Expect(0, 1818, '\P{^Is_Jg= -zain}', "");
    Error('\p{Joining_Group=/a/-_ZHAIN}');
    Error('\P{Joining_Group=/a/-_ZHAIN}');
    Expect(1, 1869, '\p{Joining_Group=:\AZhain\z:}', "");;
    Expect(0, 1870, '\p{Joining_Group=:\AZhain\z:}', "");;
    Expect(1, 1869, '\p{Joining_Group=zhain}', "");
    Expect(0, 1869, '\p{^Joining_Group=zhain}', "");
    Expect(0, 1869, '\P{Joining_Group=zhain}', "");
    Expect(1, 1869, '\P{^Joining_Group=zhain}', "");
    Expect(0, 1870, '\p{Joining_Group=zhain}', "");
    Expect(1, 1870, '\p{^Joining_Group=zhain}', "");
    Expect(1, 1870, '\P{Joining_Group=zhain}', "");
    Expect(0, 1870, '\P{^Joining_Group=zhain}', "");
    Expect(1, 1869, '\p{Joining_Group=:\Azhain\z:}', "");;
    Expect(0, 1870, '\p{Joining_Group=:\Azhain\z:}', "");;
    Expect(1, 1869, '\p{Joining_Group= _Zhain}', "");
    Expect(0, 1869, '\p{^Joining_Group= _Zhain}', "");
    Expect(0, 1869, '\P{Joining_Group= _Zhain}', "");
    Expect(1, 1869, '\P{^Joining_Group= _Zhain}', "");
    Expect(0, 1870, '\p{Joining_Group= _Zhain}', "");
    Expect(1, 1870, '\p{^Joining_Group= _Zhain}', "");
    Expect(1, 1870, '\P{Joining_Group= _Zhain}', "");
    Expect(0, 1870, '\P{^Joining_Group= _Zhain}', "");
    Error('\p{Jg: :=--zhain}');
    Error('\P{Jg: :=--zhain}');
    Expect(1, 1869, '\p{Jg=:\AZhain\z:}', "");;
    Expect(0, 1870, '\p{Jg=:\AZhain\z:}', "");;
    Expect(1, 1869, '\p{Jg=zhain}', "");
    Expect(0, 1869, '\p{^Jg=zhain}', "");
    Expect(0, 1869, '\P{Jg=zhain}', "");
    Expect(1, 1869, '\P{^Jg=zhain}', "");
    Expect(0, 1870, '\p{Jg=zhain}', "");
    Expect(1, 1870, '\p{^Jg=zhain}', "");
    Expect(1, 1870, '\P{Jg=zhain}', "");
    Expect(0, 1870, '\P{^Jg=zhain}', "");
    Expect(1, 1869, '\p{Jg=:\Azhain\z:}', "");;
    Expect(0, 1870, '\p{Jg=:\Azhain\z:}', "");;
    Expect(1, 1869, '\p{Jg= 	Zhain}', "");
    Expect(0, 1869, '\p{^Jg= 	Zhain}', "");
    Expect(0, 1869, '\P{Jg= 	Zhain}', "");
    Expect(1, 1869, '\P{^Jg= 	Zhain}', "");
    Expect(0, 1870, '\p{Jg= 	Zhain}', "");
    Expect(1, 1870, '\p{^Jg= 	Zhain}', "");
    Expect(1, 1870, '\P{Jg= 	Zhain}', "");
    Expect(0, 1870, '\P{^Jg= 	Zhain}', "");
    Error('\p{Is_Joining_Group=-/a/zhain}');
    Error('\P{Is_Joining_Group=-/a/zhain}');
    Expect(1, 1869, '\p{Is_Joining_Group=zhain}', "");
    Expect(0, 1869, '\p{^Is_Joining_Group=zhain}', "");
    Expect(0, 1869, '\P{Is_Joining_Group=zhain}', "");
    Expect(1, 1869, '\P{^Is_Joining_Group=zhain}', "");
    Expect(0, 1870, '\p{Is_Joining_Group=zhain}', "");
    Expect(1, 1870, '\p{^Is_Joining_Group=zhain}', "");
    Expect(1, 1870, '\P{Is_Joining_Group=zhain}', "");
    Expect(0, 1870, '\P{^Is_Joining_Group=zhain}', "");
    Expect(1, 1869, '\p{Is_Joining_Group=	Zhain}', "");
    Expect(0, 1869, '\p{^Is_Joining_Group=	Zhain}', "");
    Expect(0, 1869, '\P{Is_Joining_Group=	Zhain}', "");
    Expect(1, 1869, '\P{^Is_Joining_Group=	Zhain}', "");
    Expect(0, 1870, '\p{Is_Joining_Group=	Zhain}', "");
    Expect(1, 1870, '\p{^Is_Joining_Group=	Zhain}', "");
    Expect(1, 1870, '\P{Is_Joining_Group=	Zhain}', "");
    Expect(0, 1870, '\P{^Is_Joining_Group=	Zhain}', "");
    Error('\p{Is_Jg::=ZHAIN}');
    Error('\P{Is_Jg::=ZHAIN}');
    Expect(1, 1869, '\p{Is_Jg=zhain}', "");
    Expect(0, 1869, '\p{^Is_Jg=zhain}', "");
    Expect(0, 1869, '\P{Is_Jg=zhain}', "");
    Expect(1, 1869, '\P{^Is_Jg=zhain}', "");
    Expect(0, 1870, '\p{Is_Jg=zhain}', "");
    Expect(1, 1870, '\p{^Is_Jg=zhain}', "");
    Expect(1, 1870, '\P{Is_Jg=zhain}', "");
    Expect(0, 1870, '\P{^Is_Jg=zhain}', "");
    Expect(1, 1869, '\p{Is_Jg=-Zhain}', "");
    Expect(0, 1869, '\p{^Is_Jg=-Zhain}', "");
    Expect(0, 1869, '\P{Is_Jg=-Zhain}', "");
    Expect(1, 1869, '\P{^Is_Jg=-Zhain}', "");
    Expect(0, 1870, '\p{Is_Jg=-Zhain}', "");
    Expect(1, 1870, '\p{^Is_Jg=-Zhain}', "");
    Expect(1, 1870, '\P{Is_Jg=-Zhain}', "");
    Expect(0, 1870, '\P{^Is_Jg=-Zhain}', "");
    Error('\p{Join_Control=:=-No}');
    Error('\P{Join_Control=:=-No}');
    Expect(1, 8206, '\p{Join_Control=:\ANo\z:}', "");;
    Expect(0, 8205, '\p{Join_Control=:\ANo\z:}', "");;
    Expect(1, 8206, '\p{Join_Control=no}', "");
    Expect(0, 8206, '\p{^Join_Control=no}', "");
    Expect(0, 8206, '\P{Join_Control=no}', "");
    Expect(1, 8206, '\P{^Join_Control=no}', "");
    Expect(0, 8205, '\p{Join_Control=no}', "");
    Expect(1, 8205, '\p{^Join_Control=no}', "");
    Expect(1, 8205, '\P{Join_Control=no}', "");
    Expect(0, 8205, '\P{^Join_Control=no}', "");
    Expect(1, 8206, '\p{Join_Control=:\Ano\z:}', "");;
    Expect(0, 8205, '\p{Join_Control=:\Ano\z:}', "");;
    Expect(1, 8206, '\p{Join_Control=--no}', "");
    Expect(0, 8206, '\p{^Join_Control=--no}', "");
    Expect(0, 8206, '\P{Join_Control=--no}', "");
    Expect(1, 8206, '\P{^Join_Control=--no}', "");
    Expect(0, 8205, '\p{Join_Control=--no}', "");
    Expect(1, 8205, '\p{^Join_Control=--no}', "");
    Expect(1, 8205, '\P{Join_Control=--no}', "");
    Expect(0, 8205, '\P{^Join_Control=--no}', "");
    Error('\p{Join_C=_N:=}');
    Error('\P{Join_C=_N:=}');
    Expect(1, 8206, '\p{Join_C=:\AN\z:}', "");;
    Expect(0, 8205, '\p{Join_C=:\AN\z:}', "");;
    Expect(1, 8206, '\p{Join_C=n}', "");
    Expect(0, 8206, '\p{^Join_C=n}', "");
    Expect(0, 8206, '\P{Join_C=n}', "");
    Expect(1, 8206, '\P{^Join_C=n}', "");
    Expect(0, 8205, '\p{Join_C=n}', "");
    Expect(1, 8205, '\p{^Join_C=n}', "");
    Expect(1, 8205, '\P{Join_C=n}', "");
    Expect(0, 8205, '\P{^Join_C=n}', "");
    Expect(1, 8206, '\p{Join_C=:\An\z:}', "");;
    Expect(0, 8205, '\p{Join_C=:\An\z:}', "");;
    Expect(1, 8206, '\p{Join_C=- N}', "");
    Expect(0, 8206, '\p{^Join_C=- N}', "");
    Expect(0, 8206, '\P{Join_C=- N}', "");
    Expect(1, 8206, '\P{^Join_C=- N}', "");
    Expect(0, 8205, '\p{Join_C=- N}', "");
    Expect(1, 8205, '\p{^Join_C=- N}', "");
    Expect(1, 8205, '\P{Join_C=- N}', "");
    Expect(0, 8205, '\P{^Join_C=- N}', "");
    Error('\p{Is_Join_Control=:= 	F}');
    Error('\P{Is_Join_Control=:= 	F}');
    Expect(1, 8206, '\p{Is_Join_Control:f}', "");
    Expect(0, 8206, '\p{^Is_Join_Control:f}', "");
    Expect(0, 8206, '\P{Is_Join_Control:f}', "");
    Expect(1, 8206, '\P{^Is_Join_Control:f}', "");
    Expect(0, 8205, '\p{Is_Join_Control:f}', "");
    Expect(1, 8205, '\p{^Is_Join_Control:f}', "");
    Expect(1, 8205, '\P{Is_Join_Control:f}', "");
    Expect(0, 8205, '\P{^Is_Join_Control:f}', "");
    Expect(1, 8206, '\p{Is_Join_Control=		F}', "");
    Expect(0, 8206, '\p{^Is_Join_Control=		F}', "");
    Expect(0, 8206, '\P{Is_Join_Control=		F}', "");
    Expect(1, 8206, '\P{^Is_Join_Control=		F}', "");
    Expect(0, 8205, '\p{Is_Join_Control=		F}', "");
    Expect(1, 8205, '\p{^Is_Join_Control=		F}', "");
    Expect(1, 8205, '\P{Is_Join_Control=		F}', "");
    Expect(0, 8205, '\P{^Is_Join_Control=		F}', "");
    Error('\p{Is_Join_C=/a/		false}');
    Error('\P{Is_Join_C=/a/		false}');
    Expect(1, 8206, '\p{Is_Join_C=false}', "");
    Expect(0, 8206, '\p{^Is_Join_C=false}', "");
    Expect(0, 8206, '\P{Is_Join_C=false}', "");
    Expect(1, 8206, '\P{^Is_Join_C=false}', "");
    Expect(0, 8205, '\p{Is_Join_C=false}', "");
    Expect(1, 8205, '\p{^Is_Join_C=false}', "");
    Expect(1, 8205, '\P{Is_Join_C=false}', "");
    Expect(0, 8205, '\P{^Is_Join_C=false}', "");
    Expect(1, 8206, '\p{Is_Join_C=	false}', "");
    Expect(0, 8206, '\p{^Is_Join_C=	false}', "");
    Expect(0, 8206, '\P{Is_Join_C=	false}', "");
    Expect(1, 8206, '\P{^Is_Join_C=	false}', "");
    Expect(0, 8205, '\p{Is_Join_C=	false}', "");
    Expect(1, 8205, '\p{^Is_Join_C=	false}', "");
    Expect(1, 8205, '\P{Is_Join_C=	false}', "");
    Expect(0, 8205, '\P{^Is_Join_C=	false}', "");
    Error('\p{Join_Control=  Yes/a/}');
    Error('\P{Join_Control=  Yes/a/}');
    Expect(1, 8205, '\p{Join_Control=:\AYes\z:}', "");;
    Expect(0, 8206, '\p{Join_Control=:\AYes\z:}', "");;
    Expect(1, 8205, '\p{Join_Control=yes}', "");
    Expect(0, 8205, '\p{^Join_Control=yes}', "");
    Expect(0, 8205, '\P{Join_Control=yes}', "");
    Expect(1, 8205, '\P{^Join_Control=yes}', "");
    Expect(0, 8206, '\p{Join_Control=yes}', "");
    Expect(1, 8206, '\p{^Join_Control=yes}', "");
    Expect(1, 8206, '\P{Join_Control=yes}', "");
    Expect(0, 8206, '\P{^Join_Control=yes}', "");
    Expect(1, 8205, '\p{Join_Control=:\Ayes\z:}', "");;
    Expect(0, 8206, '\p{Join_Control=:\Ayes\z:}', "");;
    Expect(1, 8205, '\p{Join_Control=_-Yes}', "");
    Expect(0, 8205, '\p{^Join_Control=_-Yes}', "");
    Expect(0, 8205, '\P{Join_Control=_-Yes}', "");
    Expect(1, 8205, '\P{^Join_Control=_-Yes}', "");
    Expect(0, 8206, '\p{Join_Control=_-Yes}', "");
    Expect(1, 8206, '\p{^Join_Control=_-Yes}', "");
    Expect(1, 8206, '\P{Join_Control=_-Yes}', "");
    Expect(0, 8206, '\P{^Join_Control=_-Yes}', "");
    Error('\p{Join_C=	_Y:=}');
    Error('\P{Join_C=	_Y:=}');
    Expect(1, 8205, '\p{Join_C=:\AY\z:}', "");;
    Expect(0, 8206, '\p{Join_C=:\AY\z:}', "");;
    Expect(1, 8205, '\p{Join_C=y}', "");
    Expect(0, 8205, '\p{^Join_C=y}', "");
    Expect(0, 8205, '\P{Join_C=y}', "");
    Expect(1, 8205, '\P{^Join_C=y}', "");
    Expect(0, 8206, '\p{Join_C=y}', "");
    Expect(1, 8206, '\p{^Join_C=y}', "");
    Expect(1, 8206, '\P{Join_C=y}', "");
    Expect(0, 8206, '\P{^Join_C=y}', "");
    Expect(1, 8205, '\p{Join_C=:\Ay\z:}', "");;
    Expect(0, 8206, '\p{Join_C=:\Ay\z:}', "");;
    Expect(1, 8205, '\p{Join_C=_ Y}', "");
    Expect(0, 8205, '\p{^Join_C=_ Y}', "");
    Expect(0, 8205, '\P{Join_C=_ Y}', "");
    Expect(1, 8205, '\P{^Join_C=_ Y}', "");
    Expect(0, 8206, '\p{Join_C=_ Y}', "");
    Expect(1, 8206, '\p{^Join_C=_ Y}', "");
    Expect(1, 8206, '\P{Join_C=_ Y}', "");
    Expect(0, 8206, '\P{^Join_C=_ Y}', "");
    Error('\p{Is_Join_Control=	-T/a/}');
    Error('\P{Is_Join_Control=	-T/a/}');
    Expect(1, 8205, '\p{Is_Join_Control=t}', "");
    Expect(0, 8205, '\p{^Is_Join_Control=t}', "");
    Expect(0, 8205, '\P{Is_Join_Control=t}', "");
    Expect(1, 8205, '\P{^Is_Join_Control=t}', "");
    Expect(0, 8206, '\p{Is_Join_Control=t}', "");
    Expect(1, 8206, '\p{^Is_Join_Control=t}', "");
    Expect(1, 8206, '\P{Is_Join_Control=t}', "");
    Expect(0, 8206, '\P{^Is_Join_Control=t}', "");
    Expect(1, 8205, '\p{Is_Join_Control=_t}', "");
    Expect(0, 8205, '\p{^Is_Join_Control=_t}', "");
    Expect(0, 8205, '\P{Is_Join_Control=_t}', "");
    Expect(1, 8205, '\P{^Is_Join_Control=_t}', "");
    Expect(0, 8206, '\p{Is_Join_Control=_t}', "");
    Expect(1, 8206, '\p{^Is_Join_Control=_t}', "");
    Expect(1, 8206, '\P{Is_Join_Control=_t}', "");
    Expect(0, 8206, '\P{^Is_Join_Control=_t}', "");
    Error('\p{Is_Join_C=:=_True}');
    Error('\P{Is_Join_C=:=_True}');
    Expect(1, 8205, '\p{Is_Join_C=true}', "");
    Expect(0, 8205, '\p{^Is_Join_C=true}', "");
    Expect(0, 8205, '\P{Is_Join_C=true}', "");
    Expect(1, 8205, '\P{^Is_Join_C=true}', "");
    Expect(0, 8206, '\p{Is_Join_C=true}', "");
    Expect(1, 8206, '\p{^Is_Join_C=true}', "");
    Expect(1, 8206, '\P{Is_Join_C=true}', "");
    Expect(0, 8206, '\P{^Is_Join_C=true}', "");
    Expect(1, 8205, '\p{Is_Join_C=_	True}', "");
    Expect(0, 8205, '\p{^Is_Join_C=_	True}', "");
    Expect(0, 8205, '\P{Is_Join_C=_	True}', "");
    Expect(1, 8205, '\P{^Is_Join_C=_	True}', "");
    Expect(0, 8206, '\p{Is_Join_C=_	True}', "");
    Expect(1, 8206, '\p{^Is_Join_C=_	True}', "");
    Expect(1, 8206, '\P{Is_Join_C=_	True}', "");
    Expect(0, 8206, '\P{^Is_Join_C=_	True}', "");
    Error('\p{jamoshortname}');
    Error('\P{jamoshortname}');
    Error('\p{jsn}');
    Error('\P{jsn}');
    Error('\p{Jamo_Short_Name=A}');
    Error('\P{Jamo_Short_Name=A}');
    Error('\p{JSN=A}');
    Error('\P{JSN=A}');
    Error('\p{Is_Jamo_Short_Name=A}');
    Error('\P{Is_Jamo_Short_Name=A}');
    Error('\p{Is_JSN=A}');
    Error('\P{Is_JSN=A}');
    Error('\p{Jamo_Short_Name=AE}');
    Error('\P{Jamo_Short_Name=AE}');
    Error('\p{JSN=AE}');
    Error('\P{JSN=AE}');
    Error('\p{Is_Jamo_Short_Name=AE}');
    Error('\P{Is_Jamo_Short_Name=AE}');
    Error('\p{Is_JSN=AE}');
    Error('\P{Is_JSN=AE}');
    Error('\p{Jamo_Short_Name=B}');
    Error('\P{Jamo_Short_Name=B}');
    Error('\p{JSN:B}');
    Error('\P{JSN:B}');
    Error('\p{Is_Jamo_Short_Name=B}');
    Error('\P{Is_Jamo_Short_Name=B}');
    Error('\p{Is_JSN=B}');
    Error('\P{Is_JSN=B}');
    Error('\p{Jamo_Short_Name=BB}');
    Error('\P{Jamo_Short_Name=BB}');
    Error('\p{JSN=BB}');
    Error('\P{JSN=BB}');
    Error('\p{Is_Jamo_Short_Name=BB}');
    Error('\P{Is_Jamo_Short_Name=BB}');
    Error('\p{Is_JSN=BB}');
    Error('\P{Is_JSN=BB}');
    Error('\p{Jamo_Short_Name=BS}');
    Error('\P{Jamo_Short_Name=BS}');
    Error('\p{JSN=BS}');
    Error('\P{JSN=BS}');
    Error('\p{Is_Jamo_Short_Name=BS}');
    Error('\P{Is_Jamo_Short_Name=BS}');
    Error('\p{Is_JSN=BS}');
    Error('\P{Is_JSN=BS}');
    Error('\p{Jamo_Short_Name:	C}');
    Error('\P{Jamo_Short_Name:	C}');
    Error('\p{JSN=C}');
    Error('\P{JSN=C}');
    Error('\p{Is_Jamo_Short_Name=C}');
    Error('\P{Is_Jamo_Short_Name=C}');
    Error('\p{Is_JSN=C}');
    Error('\P{Is_JSN=C}');
    Error('\p{Jamo_Short_Name=D}');
    Error('\P{Jamo_Short_Name=D}');
    Error('\p{JSN=D}');
    Error('\P{JSN=D}');
    Error('\p{Is_Jamo_Short_Name: D}');
    Error('\P{Is_Jamo_Short_Name: D}');
    Error('\p{Is_JSN=D}');
    Error('\P{Is_JSN=D}');
    Error('\p{Jamo_Short_Name=DD}');
    Error('\P{Jamo_Short_Name=DD}');
    Error('\p{JSN=DD}');
    Error('\P{JSN=DD}');
    Error('\p{Is_Jamo_Short_Name=DD}');
    Error('\P{Is_Jamo_Short_Name=DD}');
    Error('\p{Is_JSN=DD}');
    Error('\P{Is_JSN=DD}');
    Error('\p{Jamo_Short_Name=E}');
    Error('\P{Jamo_Short_Name=E}');
    Error('\p{JSN=E}');
    Error('\P{JSN=E}');
    Error('\p{Is_Jamo_Short_Name=E}');
    Error('\P{Is_Jamo_Short_Name=E}');
    Error('\p{Is_JSN:   E}');
    Error('\P{Is_JSN:   E}');
    Error('\p{Jamo_Short_Name=EO}');
    Error('\P{Jamo_Short_Name=EO}');
    Error('\p{JSN:EO}');
    Error('\P{JSN:EO}');
    Error('\p{Is_Jamo_Short_Name=EO}');
    Error('\P{Is_Jamo_Short_Name=EO}');
    Error('\p{Is_JSN=EO}');
    Error('\P{Is_JSN=EO}');
    Error('\p{Jamo_Short_Name=EU}');
    Error('\P{Jamo_Short_Name=EU}');
    Error('\p{JSN=EU}');
    Error('\P{JSN=EU}');
    Error('\p{Is_Jamo_Short_Name=EU}');
    Error('\P{Is_Jamo_Short_Name=EU}');
    Error('\p{Is_JSN=EU}');
    Error('\P{Is_JSN=EU}');
    Error('\p{Jamo_Short_Name=G}');
    Error('\P{Jamo_Short_Name=G}');
    Error('\p{JSN=G}');
    Error('\P{JSN=G}');
    Error('\p{Is_Jamo_Short_Name=G}');
    Error('\P{Is_Jamo_Short_Name=G}');
    Error('\p{Is_JSN=G}');
    Error('\P{Is_JSN=G}');
    Error('\p{Jamo_Short_Name=GG}');
    Error('\P{Jamo_Short_Name=GG}');
    Error('\p{JSN=GG}');
    Error('\P{JSN=GG}');
    Error('\p{Is_Jamo_Short_Name=GG}');
    Error('\P{Is_Jamo_Short_Name=GG}');
    Error('\p{Is_JSN=GG}');
    Error('\P{Is_JSN=GG}');
    Error('\p{Jamo_Short_Name=GS}');
    Error('\P{Jamo_Short_Name=GS}');
    Error('\p{JSN=GS}');
    Error('\P{JSN=GS}');
    Error('\p{Is_Jamo_Short_Name=GS}');
    Error('\P{Is_Jamo_Short_Name=GS}');
    Error('\p{Is_JSN:	GS}');
    Error('\P{Is_JSN:	GS}');
    Error('\p{Jamo_Short_Name=H}');
    Error('\P{Jamo_Short_Name=H}');
    Error('\p{JSN=H}');
    Error('\P{JSN=H}');
    Error('\p{Is_Jamo_Short_Name=H}');
    Error('\P{Is_Jamo_Short_Name=H}');
    Error('\p{Is_JSN=H}');
    Error('\P{Is_JSN=H}');
    Error('\p{Jamo_Short_Name=I}');
    Error('\P{Jamo_Short_Name=I}');
    Error('\p{JSN=I}');
    Error('\P{JSN=I}');
    Error('\p{Is_Jamo_Short_Name=I}');
    Error('\P{Is_Jamo_Short_Name=I}');
    Error('\p{Is_JSN=I}');
    Error('\P{Is_JSN=I}');
    Error('\p{Jamo_Short_Name=J}');
    Error('\P{Jamo_Short_Name=J}');
    Error('\p{JSN=J}');
    Error('\P{JSN=J}');
    Error('\p{Is_Jamo_Short_Name=J}');
    Error('\P{Is_Jamo_Short_Name=J}');
    Error('\p{Is_JSN=J}');
    Error('\P{Is_JSN=J}');
    Error('\p{Jamo_Short_Name=JJ}');
    Error('\P{Jamo_Short_Name=JJ}');
    Error('\p{JSN=JJ}');
    Error('\P{JSN=JJ}');
    Error('\p{Is_Jamo_Short_Name=JJ}');
    Error('\P{Is_Jamo_Short_Name=JJ}');
    Error('\p{Is_JSN=JJ}');
    Error('\P{Is_JSN=JJ}');
    Error('\p{Jamo_Short_Name=K}');
    Error('\P{Jamo_Short_Name=K}');
    Error('\p{JSN=K}');
    Error('\P{JSN=K}');
    Error('\p{Is_Jamo_Short_Name=K}');
    Error('\P{Is_Jamo_Short_Name=K}');
    Error('\p{Is_JSN=K}');
    Error('\P{Is_JSN=K}');
    Error('\p{Jamo_Short_Name=L}');
    Error('\P{Jamo_Short_Name=L}');
    Error('\p{JSN=L}');
    Error('\P{JSN=L}');
    Error('\p{Is_Jamo_Short_Name=L}');
    Error('\P{Is_Jamo_Short_Name=L}');
    Error('\p{Is_JSN: L}');
    Error('\P{Is_JSN: L}');
    Error('\p{Jamo_Short_Name=LB}');
    Error('\P{Jamo_Short_Name=LB}');
    Error('\p{JSN:LB}');
    Error('\P{JSN:LB}');
    Error('\p{Is_Jamo_Short_Name: LB}');
    Error('\P{Is_Jamo_Short_Name: LB}');
    Error('\p{Is_JSN=LB}');
    Error('\P{Is_JSN=LB}');
    Error('\p{Jamo_Short_Name=LG}');
    Error('\P{Jamo_Short_Name=LG}');
    Error('\p{JSN=LG}');
    Error('\P{JSN=LG}');
    Error('\p{Is_Jamo_Short_Name=LG}');
    Error('\P{Is_Jamo_Short_Name=LG}');
    Error('\p{Is_JSN=LG}');
    Error('\P{Is_JSN=LG}');
    Error('\p{Jamo_Short_Name=LH}');
    Error('\P{Jamo_Short_Name=LH}');
    Error('\p{JSN=LH}');
    Error('\P{JSN=LH}');
    Error('\p{Is_Jamo_Short_Name=LH}');
    Error('\P{Is_Jamo_Short_Name=LH}');
    Error('\p{Is_JSN:LH}');
    Error('\P{Is_JSN:LH}');
    Error('\p{Jamo_Short_Name=LM}');
    Error('\P{Jamo_Short_Name=LM}');
    Error('\p{JSN=LM}');
    Error('\P{JSN=LM}');
    Error('\p{Is_Jamo_Short_Name=LM}');
    Error('\P{Is_Jamo_Short_Name=LM}');
    Error('\p{Is_JSN=LM}');
    Error('\P{Is_JSN=LM}');
    Error('\p{Jamo_Short_Name=LP}');
    Error('\P{Jamo_Short_Name=LP}');
    Error('\p{JSN=LP}');
    Error('\P{JSN=LP}');
    Error('\p{Is_Jamo_Short_Name=LP}');
    Error('\P{Is_Jamo_Short_Name=LP}');
    Error('\p{Is_JSN=LP}');
    Error('\P{Is_JSN=LP}');
    Error('\p{Jamo_Short_Name:LS}');
    Error('\P{Jamo_Short_Name:LS}');
    Error('\p{JSN=LS}');
    Error('\P{JSN=LS}');
    Error('\p{Is_Jamo_Short_Name=LS}');
    Error('\P{Is_Jamo_Short_Name=LS}');
    Error('\p{Is_JSN=LS}');
    Error('\P{Is_JSN=LS}');
    Error('\p{Jamo_Short_Name=LT}');
    Error('\P{Jamo_Short_Name=LT}');
    Error('\p{JSN=LT}');
    Error('\P{JSN=LT}');
    Error('\p{Is_Jamo_Short_Name=LT}');
    Error('\P{Is_Jamo_Short_Name=LT}');
    Error('\p{Is_JSN:	LT}');
    Error('\P{Is_JSN:	LT}');
    Error('\p{Jamo_Short_Name=M}');
    Error('\P{Jamo_Short_Name=M}');
    Error('\p{JSN=M}');
    Error('\P{JSN=M}');
    Error('\p{Is_Jamo_Short_Name=M}');
    Error('\P{Is_Jamo_Short_Name=M}');
    Error('\p{Is_JSN=M}');
    Error('\P{Is_JSN=M}');
    Error('\p{Jamo_Short_Name=N}');
    Error('\P{Jamo_Short_Name=N}');
    Error('\p{JSN:N}');
    Error('\P{JSN:N}');
    Error('\p{Is_Jamo_Short_Name:	N}');
    Error('\P{Is_Jamo_Short_Name:	N}');
    Error('\p{Is_JSN=N}');
    Error('\P{Is_JSN=N}');
    Error('\p{Jamo_Short_Name=NG}');
    Error('\P{Jamo_Short_Name=NG}');
    Error('\p{JSN=NG}');
    Error('\P{JSN=NG}');
    Error('\p{Is_Jamo_Short_Name=NG}');
    Error('\P{Is_Jamo_Short_Name=NG}');
    Error('\p{Is_JSN=NG}');
    Error('\P{Is_JSN=NG}');
    Error('\p{Jamo_Short_Name=NH}');
    Error('\P{Jamo_Short_Name=NH}');
    Error('\p{JSN=NH}');
    Error('\P{JSN=NH}');
    Error('\p{Is_Jamo_Short_Name=NH}');
    Error('\P{Is_Jamo_Short_Name=NH}');
    Error('\p{Is_JSN=NH}');
    Error('\P{Is_JSN=NH}');
    Error('\p{Jamo_Short_Name=NJ}');
    Error('\P{Jamo_Short_Name=NJ}');
    Error('\p{JSN=NJ}');
    Error('\P{JSN=NJ}');
    Error('\p{Is_Jamo_Short_Name=NJ}');
    Error('\P{Is_Jamo_Short_Name=NJ}');
    Error('\p{Is_JSN=NJ}');
    Error('\P{Is_JSN=NJ}');
    Error('\p{Jamo_Short_Name=O}');
    Error('\P{Jamo_Short_Name=O}');
    Error('\p{JSN=O}');
    Error('\P{JSN=O}');
    Error('\p{Is_Jamo_Short_Name=O}');
    Error('\P{Is_Jamo_Short_Name=O}');
    Error('\p{Is_JSN=O}');
    Error('\P{Is_JSN=O}');
    Error('\p{Jamo_Short_Name:   OE}');
    Error('\P{Jamo_Short_Name:   OE}');
    Error('\p{JSN:OE}');
    Error('\P{JSN:OE}');
    Error('\p{Is_Jamo_Short_Name=OE}');
    Error('\P{Is_Jamo_Short_Name=OE}');
    Error('\p{Is_JSN=OE}');
    Error('\P{Is_JSN=OE}');
    Error('\p{Jamo_Short_Name=P}');
    Error('\P{Jamo_Short_Name=P}');
    Error('\p{JSN=P}');
    Error('\P{JSN=P}');
    Error('\p{Is_Jamo_Short_Name:P}');
    Error('\P{Is_Jamo_Short_Name:P}');
    Error('\p{Is_JSN=P}');
    Error('\P{Is_JSN=P}');
    Error('\p{Jamo_Short_Name=R}');
    Error('\P{Jamo_Short_Name=R}');
    Error('\p{JSN=R}');
    Error('\P{JSN=R}');
    Error('\p{Is_Jamo_Short_Name=R}');
    Error('\P{Is_Jamo_Short_Name=R}');
    Error('\p{Is_JSN=R}');
    Error('\P{Is_JSN=R}');
    Error('\p{Jamo_Short_Name=S}');
    Error('\P{Jamo_Short_Name=S}');
    Error('\p{JSN=S}');
    Error('\P{JSN=S}');
    Error('\p{Is_Jamo_Short_Name=S}');
    Error('\P{Is_Jamo_Short_Name=S}');
    Error('\p{Is_JSN=S}');
    Error('\P{Is_JSN=S}');
    Error('\p{Jamo_Short_Name=SS}');
    Error('\P{Jamo_Short_Name=SS}');
    Error('\p{JSN=SS}');
    Error('\P{JSN=SS}');
    Error('\p{Is_Jamo_Short_Name=SS}');
    Error('\P{Is_Jamo_Short_Name=SS}');
    Error('\p{Is_JSN=SS}');
    Error('\P{Is_JSN=SS}');
    Error('\p{Jamo_Short_Name=T}');
    Error('\P{Jamo_Short_Name=T}');
    Error('\p{JSN:T}');
    Error('\P{JSN:T}');
    Error('\p{Is_Jamo_Short_Name=T}');
    Error('\P{Is_Jamo_Short_Name=T}');
    Error('\p{Is_JSN=T}');
    Error('\P{Is_JSN=T}');
    Error('\p{Jamo_Short_Name=U}');
    Error('\P{Jamo_Short_Name=U}');
    Error('\p{JSN=U}');
    Error('\P{JSN=U}');
    Error('\p{Is_Jamo_Short_Name=U}');
    Error('\P{Is_Jamo_Short_Name=U}');
    Error('\p{Is_JSN=U}');
    Error('\P{Is_JSN=U}');
    Error('\p{Jamo_Short_Name=WA}');
    Error('\P{Jamo_Short_Name=WA}');
    Error('\p{JSN=WA}');
    Error('\P{JSN=WA}');
    Error('\p{Is_Jamo_Short_Name=WA}');
    Error('\P{Is_Jamo_Short_Name=WA}');
    Error('\p{Is_JSN=WA}');
    Error('\P{Is_JSN=WA}');
    Error('\p{Jamo_Short_Name=WAE}');
    Error('\P{Jamo_Short_Name=WAE}');
    Error('\p{JSN=WAE}');
    Error('\P{JSN=WAE}');
    Error('\p{Is_Jamo_Short_Name=WAE}');
    Error('\P{Is_Jamo_Short_Name=WAE}');
    Error('\p{Is_JSN=WAE}');
    Error('\P{Is_JSN=WAE}');
    Error('\p{Jamo_Short_Name=WE}');
    Error('\P{Jamo_Short_Name=WE}');
    Error('\p{JSN=WE}');
    Error('\P{JSN=WE}');
    Error('\p{Is_Jamo_Short_Name=WE}');
    Error('\P{Is_Jamo_Short_Name=WE}');
    Error('\p{Is_JSN=WE}');
    Error('\P{Is_JSN=WE}');
    Error('\p{Jamo_Short_Name=WEO}');
    Error('\P{Jamo_Short_Name=WEO}');
    Error('\p{JSN:   WEO}');
    Error('\P{JSN:   WEO}');
    Error('\p{Is_Jamo_Short_Name=WEO}');
    Error('\P{Is_Jamo_Short_Name=WEO}');
    Error('\p{Is_JSN:   WEO}');
    Error('\P{Is_JSN:   WEO}');
    Error('\p{Jamo_Short_Name=WI}');
    Error('\P{Jamo_Short_Name=WI}');
    Error('\p{JSN=WI}');
    Error('\P{JSN=WI}');
    Error('\p{Is_Jamo_Short_Name=WI}');
    Error('\P{Is_Jamo_Short_Name=WI}');
    Error('\p{Is_JSN=WI}');
    Error('\P{Is_JSN=WI}');
    Error('\p{Jamo_Short_Name:   YA}');
    Error('\P{Jamo_Short_Name:   YA}');
    Error('\p{JSN=YA}');
    Error('\P{JSN=YA}');
    Error('\p{Is_Jamo_Short_Name=YA}');
    Error('\P{Is_Jamo_Short_Name=YA}');
    Error('\p{Is_JSN=YA}');
    Error('\P{Is_JSN=YA}');
    Error('\p{Jamo_Short_Name=YAE}');
    Error('\P{Jamo_Short_Name=YAE}');
    Error('\p{JSN=YAE}');
    Error('\P{JSN=YAE}');
    Error('\p{Is_Jamo_Short_Name=YAE}');
    Error('\P{Is_Jamo_Short_Name=YAE}');
    Error('\p{Is_JSN=YAE}');
    Error('\P{Is_JSN=YAE}');
    Error('\p{Jamo_Short_Name: YE}');
    Error('\P{Jamo_Short_Name: YE}');
    Error('\p{JSN=YE}');
    Error('\P{JSN=YE}');
    Error('\p{Is_Jamo_Short_Name=YE}');
    Error('\P{Is_Jamo_Short_Name=YE}');
    Error('\p{Is_JSN=YE}');
    Error('\P{Is_JSN=YE}');
    Error('\p{Jamo_Short_Name=YEO}');
    Error('\P{Jamo_Short_Name=YEO}');
    Error('\p{JSN=YEO}');
    Error('\P{JSN=YEO}');
    Error('\p{Is_Jamo_Short_Name=YEO}');
    Error('\P{Is_Jamo_Short_Name=YEO}');
    Error('\p{Is_JSN=YEO}');
    Error('\P{Is_JSN=YEO}');
    Error('\p{Jamo_Short_Name=YI}');
    Error('\P{Jamo_Short_Name=YI}');
    Error('\p{JSN=YI}');
    Error('\P{JSN=YI}');
    Error('\p{Is_Jamo_Short_Name=YI}');
    Error('\P{Is_Jamo_Short_Name=YI}');
    Error('\p{Is_JSN=YI}');
    Error('\P{Is_JSN=YI}');
    Error('\p{Jamo_Short_Name=YO}');
    Error('\P{Jamo_Short_Name=YO}');
    Error('\p{JSN=YO}');
    Error('\P{JSN=YO}');
    Error('\p{Is_Jamo_Short_Name:   YO}');
    Error('\P{Is_Jamo_Short_Name:   YO}');
    Error('\p{Is_JSN=YO}');
    Error('\P{Is_JSN=YO}');
    Error('\p{Jamo_Short_Name=YU}');
    Error('\P{Jamo_Short_Name=YU}');
    Error('\p{JSN=YU}');
    Error('\P{JSN=YU}');
    Error('\p{Is_Jamo_Short_Name=YU}');
    Error('\P{Is_Jamo_Short_Name=YU}');
    Error('\p{Is_JSN=YU}');
    Error('\P{Is_JSN=YU}');
    Error('\p{joiningtype}');
    Error('\P{joiningtype}');
    Error('\p{jt}');
    Error('\P{jt}');
    Error('\p{Joining_Type=	Join_causing/a/}');
    Error('\P{Joining_Type=	Join_causing/a/}');
    Expect(1, 8205, '\p{Joining_Type=:\AJoin_Causing\z:}', "");;
    Expect(0, 8206, '\p{Joining_Type=:\AJoin_Causing\z:}', "");;
    Expect(1, 8205, '\p{Joining_Type=joincausing}', "");
    Expect(0, 8205, '\p{^Joining_Type=joincausing}', "");
    Expect(0, 8205, '\P{Joining_Type=joincausing}', "");
    Expect(1, 8205, '\P{^Joining_Type=joincausing}', "");
    Expect(0, 8206, '\p{Joining_Type=joincausing}', "");
    Expect(1, 8206, '\p{^Joining_Type=joincausing}', "");
    Expect(1, 8206, '\P{Joining_Type=joincausing}', "");
    Expect(0, 8206, '\P{^Joining_Type=joincausing}', "");
    Expect(1, 8205, '\p{Joining_Type=:\Ajoincausing\z:}', "");;
    Expect(0, 8206, '\p{Joining_Type=:\Ajoincausing\z:}', "");;
    Expect(1, 8205, '\p{Joining_Type:	_-join_Causing}', "");
    Expect(0, 8205, '\p{^Joining_Type:	_-join_Causing}', "");
    Expect(0, 8205, '\P{Joining_Type:	_-join_Causing}', "");
    Expect(1, 8205, '\P{^Joining_Type:	_-join_Causing}', "");
    Expect(0, 8206, '\p{Joining_Type:	_-join_Causing}', "");
    Expect(1, 8206, '\p{^Joining_Type:	_-join_Causing}', "");
    Expect(1, 8206, '\P{Joining_Type:	_-join_Causing}', "");
    Expect(0, 8206, '\P{^Joining_Type:	_-join_Causing}', "");
    Error('\p{Jt=	-c/a/}');
    Error('\P{Jt=	-c/a/}');
    Expect(1, 8205, '\p{Jt=:\AC\z:}', "");;
    Expect(0, 8206, '\p{Jt=:\AC\z:}', "");;
    Expect(1, 8205, '\p{Jt=c}', "");
    Expect(0, 8205, '\p{^Jt=c}', "");
    Expect(0, 8205, '\P{Jt=c}', "");
    Expect(1, 8205, '\P{^Jt=c}', "");
    Expect(0, 8206, '\p{Jt=c}', "");
    Expect(1, 8206, '\p{^Jt=c}', "");
    Expect(1, 8206, '\P{Jt=c}', "");
    Expect(0, 8206, '\P{^Jt=c}', "");
    Expect(1, 8205, '\p{Jt=:\Ac\z:}', "");;
    Expect(0, 8206, '\p{Jt=:\Ac\z:}', "");;
    Expect(1, 8205, '\p{Jt=-C}', "");
    Expect(0, 8205, '\p{^Jt=-C}', "");
    Expect(0, 8205, '\P{Jt=-C}', "");
    Expect(1, 8205, '\P{^Jt=-C}', "");
    Expect(0, 8206, '\p{Jt=-C}', "");
    Expect(1, 8206, '\p{^Jt=-C}', "");
    Expect(1, 8206, '\P{Jt=-C}', "");
    Expect(0, 8206, '\P{^Jt=-C}', "");
    Error('\p{Is_Joining_Type=:=_-JOIN_Causing}');
    Error('\P{Is_Joining_Type=:=_-JOIN_Causing}');
    Expect(1, 8205, '\p{Is_Joining_Type=joincausing}', "");
    Expect(0, 8205, '\p{^Is_Joining_Type=joincausing}', "");
    Expect(0, 8205, '\P{Is_Joining_Type=joincausing}', "");
    Expect(1, 8205, '\P{^Is_Joining_Type=joincausing}', "");
    Expect(0, 8206, '\p{Is_Joining_Type=joincausing}', "");
    Expect(1, 8206, '\p{^Is_Joining_Type=joincausing}', "");
    Expect(1, 8206, '\P{Is_Joining_Type=joincausing}', "");
    Expect(0, 8206, '\P{^Is_Joining_Type=joincausing}', "");
    Expect(1, 8205, '\p{Is_Joining_Type= join_Causing}', "");
    Expect(0, 8205, '\p{^Is_Joining_Type= join_Causing}', "");
    Expect(0, 8205, '\P{Is_Joining_Type= join_Causing}', "");
    Expect(1, 8205, '\P{^Is_Joining_Type= join_Causing}', "");
    Expect(0, 8206, '\p{Is_Joining_Type= join_Causing}', "");
    Expect(1, 8206, '\p{^Is_Joining_Type= join_Causing}', "");
    Expect(1, 8206, '\P{Is_Joining_Type= join_Causing}', "");
    Expect(0, 8206, '\P{^Is_Joining_Type= join_Causing}', "");
    Error('\p{Is_Jt=  C:=}');
    Error('\P{Is_Jt=  C:=}');
    Expect(1, 8205, '\p{Is_Jt=c}', "");
    Expect(0, 8205, '\p{^Is_Jt=c}', "");
    Expect(0, 8205, '\P{Is_Jt=c}', "");
    Expect(1, 8205, '\P{^Is_Jt=c}', "");
    Expect(0, 8206, '\p{Is_Jt=c}', "");
    Expect(1, 8206, '\p{^Is_Jt=c}', "");
    Expect(1, 8206, '\P{Is_Jt=c}', "");
    Expect(0, 8206, '\P{^Is_Jt=c}', "");
    Expect(1, 8205, '\p{Is_Jt=C}', "");
    Expect(0, 8205, '\p{^Is_Jt=C}', "");
    Expect(0, 8205, '\P{Is_Jt=C}', "");
    Expect(1, 8205, '\P{^Is_Jt=C}', "");
    Expect(0, 8206, '\p{Is_Jt=C}', "");
    Expect(1, 8206, '\p{^Is_Jt=C}', "");
    Expect(1, 8206, '\P{Is_Jt=C}', "");
    Expect(0, 8206, '\P{^Is_Jt=C}', "");
    Error('\p{Joining_Type=/a/ Dual_Joining}');
    Error('\P{Joining_Type=/a/ Dual_Joining}');
    Expect(1, 125251, '\p{Joining_Type=:\ADual_Joining\z:}', "");;
    Expect(0, 125252, '\p{Joining_Type=:\ADual_Joining\z:}', "");;
    Expect(1, 125251, '\p{Joining_Type=dualjoining}', "");
    Expect(0, 125251, '\p{^Joining_Type=dualjoining}', "");
    Expect(0, 125251, '\P{Joining_Type=dualjoining}', "");
    Expect(1, 125251, '\P{^Joining_Type=dualjoining}', "");
    Expect(0, 125252, '\p{Joining_Type=dualjoining}', "");
    Expect(1, 125252, '\p{^Joining_Type=dualjoining}', "");
    Expect(1, 125252, '\P{Joining_Type=dualjoining}', "");
    Expect(0, 125252, '\P{^Joining_Type=dualjoining}', "");
    Expect(1, 125251, '\p{Joining_Type=:\Adualjoining\z:}', "");;
    Expect(0, 125252, '\p{Joining_Type=:\Adualjoining\z:}', "");;
    Expect(1, 125251, '\p{Joining_Type:	 Dual_JOINING}', "");
    Expect(0, 125251, '\p{^Joining_Type:	 Dual_JOINING}', "");
    Expect(0, 125251, '\P{Joining_Type:	 Dual_JOINING}', "");
    Expect(1, 125251, '\P{^Joining_Type:	 Dual_JOINING}', "");
    Expect(0, 125252, '\p{Joining_Type:	 Dual_JOINING}', "");
    Expect(1, 125252, '\p{^Joining_Type:	 Dual_JOINING}', "");
    Expect(1, 125252, '\P{Joining_Type:	 Dual_JOINING}', "");
    Expect(0, 125252, '\P{^Joining_Type:	 Dual_JOINING}', "");
    Error('\p{Jt=:=_	D}');
    Error('\P{Jt=:=_	D}');
    Expect(1, 125251, '\p{Jt=:\AD\z:}', "");;
    Expect(0, 125252, '\p{Jt=:\AD\z:}', "");;
    Expect(1, 125251, '\p{Jt:	d}', "");
    Expect(0, 125251, '\p{^Jt:	d}', "");
    Expect(0, 125251, '\P{Jt:	d}', "");
    Expect(1, 125251, '\P{^Jt:	d}', "");
    Expect(0, 125252, '\p{Jt:	d}', "");
    Expect(1, 125252, '\p{^Jt:	d}', "");
    Expect(1, 125252, '\P{Jt:	d}', "");
    Expect(0, 125252, '\P{^Jt:	d}', "");
    Expect(1, 125251, '\p{Jt=:\Ad\z:}', "");;
    Expect(0, 125252, '\p{Jt=:\Ad\z:}', "");;
    Expect(1, 125251, '\p{Jt=  D}', "");
    Expect(0, 125251, '\p{^Jt=  D}', "");
    Expect(0, 125251, '\P{Jt=  D}', "");
    Expect(1, 125251, '\P{^Jt=  D}', "");
    Expect(0, 125252, '\p{Jt=  D}', "");
    Expect(1, 125252, '\p{^Jt=  D}', "");
    Expect(1, 125252, '\P{Jt=  D}', "");
    Expect(0, 125252, '\P{^Jt=  D}', "");
    Error('\p{Is_Joining_Type=-Dual_joining:=}');
    Error('\P{Is_Joining_Type=-Dual_joining:=}');
    Expect(1, 125251, '\p{Is_Joining_Type:   dualjoining}', "");
    Expect(0, 125251, '\p{^Is_Joining_Type:   dualjoining}', "");
    Expect(0, 125251, '\P{Is_Joining_Type:   dualjoining}', "");
    Expect(1, 125251, '\P{^Is_Joining_Type:   dualjoining}', "");
    Expect(0, 125252, '\p{Is_Joining_Type:   dualjoining}', "");
    Expect(1, 125252, '\p{^Is_Joining_Type:   dualjoining}', "");
    Expect(1, 125252, '\P{Is_Joining_Type:   dualjoining}', "");
    Expect(0, 125252, '\P{^Is_Joining_Type:   dualjoining}', "");
    Expect(1, 125251, '\p{Is_Joining_Type=  Dual_JOINING}', "");
    Expect(0, 125251, '\p{^Is_Joining_Type=  Dual_JOINING}', "");
    Expect(0, 125251, '\P{Is_Joining_Type=  Dual_JOINING}', "");
    Expect(1, 125251, '\P{^Is_Joining_Type=  Dual_JOINING}', "");
    Expect(0, 125252, '\p{Is_Joining_Type=  Dual_JOINING}', "");
    Expect(1, 125252, '\p{^Is_Joining_Type=  Dual_JOINING}', "");
    Expect(1, 125252, '\P{Is_Joining_Type=  Dual_JOINING}', "");
    Expect(0, 125252, '\P{^Is_Joining_Type=  Dual_JOINING}', "");
    Error('\p{Is_Jt:   /a/-	D}');
    Error('\P{Is_Jt:   /a/-	D}');
    Expect(1, 125251, '\p{Is_Jt=d}', "");
    Expect(0, 125251, '\p{^Is_Jt=d}', "");
    Expect(0, 125251, '\P{Is_Jt=d}', "");
    Expect(1, 125251, '\P{^Is_Jt=d}', "");
    Expect(0, 125252, '\p{Is_Jt=d}', "");
    Expect(1, 125252, '\p{^Is_Jt=d}', "");
    Expect(1, 125252, '\P{Is_Jt=d}', "");
    Expect(0, 125252, '\P{^Is_Jt=d}', "");
    Expect(1, 125251, '\p{Is_Jt=_	D}', "");
    Expect(0, 125251, '\p{^Is_Jt=_	D}', "");
    Expect(0, 125251, '\P{Is_Jt=_	D}', "");
    Expect(1, 125251, '\P{^Is_Jt=_	D}', "");
    Expect(0, 125252, '\p{Is_Jt=_	D}', "");
    Expect(1, 125252, '\p{^Is_Jt=_	D}', "");
    Expect(1, 125252, '\P{Is_Jt=_	D}', "");
    Expect(0, 125252, '\P{^Is_Jt=_	D}', "");
    Error('\p{Joining_Type=_:=left_Joining}');
    Error('\P{Joining_Type=_:=left_Joining}');
    Expect(1, 69579, '\p{Joining_Type=:\ALeft_Joining\z:}', "");;
    Expect(0, 69580, '\p{Joining_Type=:\ALeft_Joining\z:}', "");;
    Expect(1, 69579, '\p{Joining_Type=leftjoining}', "");
    Expect(0, 69579, '\p{^Joining_Type=leftjoining}', "");
    Expect(0, 69579, '\P{Joining_Type=leftjoining}', "");
    Expect(1, 69579, '\P{^Joining_Type=leftjoining}', "");
    Expect(0, 69580, '\p{Joining_Type=leftjoining}', "");
    Expect(1, 69580, '\p{^Joining_Type=leftjoining}', "");
    Expect(1, 69580, '\P{Joining_Type=leftjoining}', "");
    Expect(0, 69580, '\P{^Joining_Type=leftjoining}', "");
    Expect(1, 69579, '\p{Joining_Type=:\Aleftjoining\z:}', "");;
    Expect(0, 69580, '\p{Joining_Type=:\Aleftjoining\z:}', "");;
    Expect(1, 69579, '\p{Joining_Type=-Left_joining}', "");
    Expect(0, 69579, '\p{^Joining_Type=-Left_joining}', "");
    Expect(0, 69579, '\P{Joining_Type=-Left_joining}', "");
    Expect(1, 69579, '\P{^Joining_Type=-Left_joining}', "");
    Expect(0, 69580, '\p{Joining_Type=-Left_joining}', "");
    Expect(1, 69580, '\p{^Joining_Type=-Left_joining}', "");
    Expect(1, 69580, '\P{Joining_Type=-Left_joining}', "");
    Expect(0, 69580, '\P{^Joining_Type=-Left_joining}', "");
    Error('\p{Jt=/a/-_l}');
    Error('\P{Jt=/a/-_l}');
    Expect(1, 69579, '\p{Jt=:\AL\z:}', "");;
    Expect(0, 69580, '\p{Jt=:\AL\z:}', "");;
    Expect(1, 69579, '\p{Jt:l}', "");
    Expect(0, 69579, '\p{^Jt:l}', "");
    Expect(0, 69579, '\P{Jt:l}', "");
    Expect(1, 69579, '\P{^Jt:l}', "");
    Expect(0, 69580, '\p{Jt:l}', "");
    Expect(1, 69580, '\p{^Jt:l}', "");
    Expect(1, 69580, '\P{Jt:l}', "");
    Expect(0, 69580, '\P{^Jt:l}', "");
    Expect(1, 69579, '\p{Jt=:\Al\z:}', "");;
    Expect(0, 69580, '\p{Jt=:\Al\z:}', "");;
    Expect(1, 69579, '\p{Jt=_	L}', "");
    Expect(0, 69579, '\p{^Jt=_	L}', "");
    Expect(0, 69579, '\P{Jt=_	L}', "");
    Expect(1, 69579, '\P{^Jt=_	L}', "");
    Expect(0, 69580, '\p{Jt=_	L}', "");
    Expect(1, 69580, '\p{^Jt=_	L}', "");
    Expect(1, 69580, '\P{Jt=_	L}', "");
    Expect(0, 69580, '\P{^Jt=_	L}', "");
    Error('\p{Is_Joining_Type=/a/_ Left_joining}');
    Error('\P{Is_Joining_Type=/a/_ Left_joining}');
    Expect(1, 69579, '\p{Is_Joining_Type=leftjoining}', "");
    Expect(0, 69579, '\p{^Is_Joining_Type=leftjoining}', "");
    Expect(0, 69579, '\P{Is_Joining_Type=leftjoining}', "");
    Expect(1, 69579, '\P{^Is_Joining_Type=leftjoining}', "");
    Expect(0, 69580, '\p{Is_Joining_Type=leftjoining}', "");
    Expect(1, 69580, '\p{^Is_Joining_Type=leftjoining}', "");
    Expect(1, 69580, '\P{Is_Joining_Type=leftjoining}', "");
    Expect(0, 69580, '\P{^Is_Joining_Type=leftjoining}', "");
    Expect(1, 69579, '\p{Is_Joining_Type=-LEFT_joining}', "");
    Expect(0, 69579, '\p{^Is_Joining_Type=-LEFT_joining}', "");
    Expect(0, 69579, '\P{Is_Joining_Type=-LEFT_joining}', "");
    Expect(1, 69579, '\P{^Is_Joining_Type=-LEFT_joining}', "");
    Expect(0, 69580, '\p{Is_Joining_Type=-LEFT_joining}', "");
    Expect(1, 69580, '\p{^Is_Joining_Type=-LEFT_joining}', "");
    Expect(1, 69580, '\P{Is_Joining_Type=-LEFT_joining}', "");
    Expect(0, 69580, '\P{^Is_Joining_Type=-LEFT_joining}', "");
    Error('\p{Is_Jt::=	 l}');
    Error('\P{Is_Jt::=	 l}');
    Expect(1, 69579, '\p{Is_Jt:	l}', "");
    Expect(0, 69579, '\p{^Is_Jt:	l}', "");
    Expect(0, 69579, '\P{Is_Jt:	l}', "");
    Expect(1, 69579, '\P{^Is_Jt:	l}', "");
    Expect(0, 69580, '\p{Is_Jt:	l}', "");
    Expect(1, 69580, '\p{^Is_Jt:	l}', "");
    Expect(1, 69580, '\P{Is_Jt:	l}', "");
    Expect(0, 69580, '\P{^Is_Jt:	l}', "");
    Expect(1, 69579, '\p{Is_Jt=	-L}', "");
    Expect(0, 69579, '\p{^Is_Jt=	-L}', "");
    Expect(0, 69579, '\P{Is_Jt=	-L}', "");
    Expect(1, 69579, '\P{^Is_Jt=	-L}', "");
    Expect(0, 69580, '\p{Is_Jt=	-L}', "");
    Expect(1, 69580, '\p{^Is_Jt=	-L}', "");
    Expect(1, 69580, '\P{Is_Jt=	-L}', "");
    Expect(0, 69580, '\P{^Is_Jt=	-L}', "");
    Error('\p{Joining_Type=:=	 RIGHT_Joining}');
    Error('\P{Joining_Type=:=	 RIGHT_Joining}');
    Expect(1, 69577, '\p{Joining_Type=:\ARight_Joining\z:}', "");;
    Expect(0, 69578, '\p{Joining_Type=:\ARight_Joining\z:}', "");;
    Expect(1, 69577, '\p{Joining_Type=rightjoining}', "");
    Expect(0, 69577, '\p{^Joining_Type=rightjoining}', "");
    Expect(0, 69577, '\P{Joining_Type=rightjoining}', "");
    Expect(1, 69577, '\P{^Joining_Type=rightjoining}', "");
    Expect(0, 69578, '\p{Joining_Type=rightjoining}', "");
    Expect(1, 69578, '\p{^Joining_Type=rightjoining}', "");
    Expect(1, 69578, '\P{Joining_Type=rightjoining}', "");
    Expect(0, 69578, '\P{^Joining_Type=rightjoining}', "");
    Expect(1, 69577, '\p{Joining_Type=:\Arightjoining\z:}', "");;
    Expect(0, 69578, '\p{Joining_Type=:\Arightjoining\z:}', "");;
    Expect(1, 69577, '\p{Joining_Type=_ Right_Joining}', "");
    Expect(0, 69577, '\p{^Joining_Type=_ Right_Joining}', "");
    Expect(0, 69577, '\P{Joining_Type=_ Right_Joining}', "");
    Expect(1, 69577, '\P{^Joining_Type=_ Right_Joining}', "");
    Expect(0, 69578, '\p{Joining_Type=_ Right_Joining}', "");
    Expect(1, 69578, '\p{^Joining_Type=_ Right_Joining}', "");
    Expect(1, 69578, '\P{Joining_Type=_ Right_Joining}', "");
    Expect(0, 69578, '\P{^Joining_Type=_ Right_Joining}', "");
    Error('\p{Jt=:=_r}');
    Error('\P{Jt=:=_r}');
    Expect(1, 69577, '\p{Jt=:\AR\z:}', "");;
    Expect(0, 69578, '\p{Jt=:\AR\z:}', "");;
    Expect(1, 69577, '\p{Jt=r}', "");
    Expect(0, 69577, '\p{^Jt=r}', "");
    Expect(0, 69577, '\P{Jt=r}', "");
    Expect(1, 69577, '\P{^Jt=r}', "");
    Expect(0, 69578, '\p{Jt=r}', "");
    Expect(1, 69578, '\p{^Jt=r}', "");
    Expect(1, 69578, '\P{Jt=r}', "");
    Expect(0, 69578, '\P{^Jt=r}', "");
    Expect(1, 69577, '\p{Jt=:\Ar\z:}', "");;
    Expect(0, 69578, '\p{Jt=:\Ar\z:}', "");;
    Expect(1, 69577, '\p{Jt=	 R}', "");
    Expect(0, 69577, '\p{^Jt=	 R}', "");
    Expect(0, 69577, '\P{Jt=	 R}', "");
    Expect(1, 69577, '\P{^Jt=	 R}', "");
    Expect(0, 69578, '\p{Jt=	 R}', "");
    Expect(1, 69578, '\p{^Jt=	 R}', "");
    Expect(1, 69578, '\P{Jt=	 R}', "");
    Expect(0, 69578, '\P{^Jt=	 R}', "");
    Error('\p{Is_Joining_Type=:=		RIGHT_Joining}');
    Error('\P{Is_Joining_Type=:=		RIGHT_Joining}');
    Expect(1, 69577, '\p{Is_Joining_Type=rightjoining}', "");
    Expect(0, 69577, '\p{^Is_Joining_Type=rightjoining}', "");
    Expect(0, 69577, '\P{Is_Joining_Type=rightjoining}', "");
    Expect(1, 69577, '\P{^Is_Joining_Type=rightjoining}', "");
    Expect(0, 69578, '\p{Is_Joining_Type=rightjoining}', "");
    Expect(1, 69578, '\p{^Is_Joining_Type=rightjoining}', "");
    Expect(1, 69578, '\P{Is_Joining_Type=rightjoining}', "");
    Expect(0, 69578, '\P{^Is_Joining_Type=rightjoining}', "");
    Expect(1, 69577, '\p{Is_Joining_Type=		Right_joining}', "");
    Expect(0, 69577, '\p{^Is_Joining_Type=		Right_joining}', "");
    Expect(0, 69577, '\P{Is_Joining_Type=		Right_joining}', "");
    Expect(1, 69577, '\P{^Is_Joining_Type=		Right_joining}', "");
    Expect(0, 69578, '\p{Is_Joining_Type=		Right_joining}', "");
    Expect(1, 69578, '\p{^Is_Joining_Type=		Right_joining}', "");
    Expect(1, 69578, '\P{Is_Joining_Type=		Right_joining}', "");
    Expect(0, 69578, '\P{^Is_Joining_Type=		Right_joining}', "");
    Error('\p{Is_Jt=	R:=}');
    Error('\P{Is_Jt=	R:=}');
    Expect(1, 69577, '\p{Is_Jt:   r}', "");
    Expect(0, 69577, '\p{^Is_Jt:   r}', "");
    Expect(0, 69577, '\P{Is_Jt:   r}', "");
    Expect(1, 69577, '\P{^Is_Jt:   r}', "");
    Expect(0, 69578, '\p{Is_Jt:   r}', "");
    Expect(1, 69578, '\p{^Is_Jt:   r}', "");
    Expect(1, 69578, '\P{Is_Jt:   r}', "");
    Expect(0, 69578, '\P{^Is_Jt:   r}', "");
    Expect(1, 69577, '\p{Is_Jt= -R}', "");
    Expect(0, 69577, '\p{^Is_Jt= -R}', "");
    Expect(0, 69577, '\P{Is_Jt= -R}', "");
    Expect(1, 69577, '\P{^Is_Jt= -R}', "");
    Expect(0, 69578, '\p{Is_Jt= -R}', "");
    Expect(1, 69578, '\p{^Is_Jt= -R}', "");
    Expect(1, 69578, '\P{Is_Jt= -R}', "");
    Expect(0, 69578, '\P{^Is_Jt= -R}', "");
    Error('\p{Joining_Type=  Transparent/a/}');
    Error('\P{Joining_Type=  Transparent/a/}');
    Expect(1, 917999, '\p{Joining_Type=:\ATransparent\z:}', "");;
    Expect(0, 918000, '\p{Joining_Type=:\ATransparent\z:}', "");;
    Expect(1, 917999, '\p{Joining_Type:transparent}', "");
    Expect(0, 917999, '\p{^Joining_Type:transparent}', "");
    Expect(0, 917999, '\P{Joining_Type:transparent}', "");
    Expect(1, 917999, '\P{^Joining_Type:transparent}', "");
    Expect(0, 918000, '\p{Joining_Type:transparent}', "");
    Expect(1, 918000, '\p{^Joining_Type:transparent}', "");
    Expect(1, 918000, '\P{Joining_Type:transparent}', "");
    Expect(0, 918000, '\P{^Joining_Type:transparent}', "");
    Expect(1, 917999, '\p{Joining_Type=:\Atransparent\z:}', "");;
    Expect(0, 918000, '\p{Joining_Type=:\Atransparent\z:}', "");;
    Expect(1, 917999, '\p{Joining_Type= 	transparent}', "");
    Expect(0, 917999, '\p{^Joining_Type= 	transparent}', "");
    Expect(0, 917999, '\P{Joining_Type= 	transparent}', "");
    Expect(1, 917999, '\P{^Joining_Type= 	transparent}', "");
    Expect(0, 918000, '\p{Joining_Type= 	transparent}', "");
    Expect(1, 918000, '\p{^Joining_Type= 	transparent}', "");
    Expect(1, 918000, '\P{Joining_Type= 	transparent}', "");
    Expect(0, 918000, '\P{^Joining_Type= 	transparent}', "");
    Error('\p{Jt=:=_T}');
    Error('\P{Jt=:=_T}');
    Expect(1, 917999, '\p{Jt=:\AT\z:}', "");;
    Expect(0, 918000, '\p{Jt=:\AT\z:}', "");;
    Expect(1, 917999, '\p{Jt=t}', "");
    Expect(0, 917999, '\p{^Jt=t}', "");
    Expect(0, 917999, '\P{Jt=t}', "");
    Expect(1, 917999, '\P{^Jt=t}', "");
    Expect(0, 918000, '\p{Jt=t}', "");
    Expect(1, 918000, '\p{^Jt=t}', "");
    Expect(1, 918000, '\P{Jt=t}', "");
    Expect(0, 918000, '\P{^Jt=t}', "");
    Expect(1, 917999, '\p{Jt=:\At\z:}', "");;
    Expect(0, 918000, '\p{Jt=:\At\z:}', "");;
    Expect(1, 917999, '\p{Jt=_ T}', "");
    Expect(0, 917999, '\p{^Jt=_ T}', "");
    Expect(0, 917999, '\P{Jt=_ T}', "");
    Expect(1, 917999, '\P{^Jt=_ T}', "");
    Expect(0, 918000, '\p{Jt=_ T}', "");
    Expect(1, 918000, '\p{^Jt=_ T}', "");
    Expect(1, 918000, '\P{Jt=_ T}', "");
    Expect(0, 918000, '\P{^Jt=_ T}', "");
    Error('\p{Is_Joining_Type= -TRANSPARENT/a/}');
    Error('\P{Is_Joining_Type= -TRANSPARENT/a/}');
    Expect(1, 917999, '\p{Is_Joining_Type:	transparent}', "");
    Expect(0, 917999, '\p{^Is_Joining_Type:	transparent}', "");
    Expect(0, 917999, '\P{Is_Joining_Type:	transparent}', "");
    Expect(1, 917999, '\P{^Is_Joining_Type:	transparent}', "");
    Expect(0, 918000, '\p{Is_Joining_Type:	transparent}', "");
    Expect(1, 918000, '\p{^Is_Joining_Type:	transparent}', "");
    Expect(1, 918000, '\P{Is_Joining_Type:	transparent}', "");
    Expect(0, 918000, '\P{^Is_Joining_Type:	transparent}', "");
    Expect(1, 917999, '\p{Is_Joining_Type=--Transparent}', "");
    Expect(0, 917999, '\p{^Is_Joining_Type=--Transparent}', "");
    Expect(0, 917999, '\P{Is_Joining_Type=--Transparent}', "");
    Expect(1, 917999, '\P{^Is_Joining_Type=--Transparent}', "");
    Expect(0, 918000, '\p{Is_Joining_Type=--Transparent}', "");
    Expect(1, 918000, '\p{^Is_Joining_Type=--Transparent}', "");
    Expect(1, 918000, '\P{Is_Joining_Type=--Transparent}', "");
    Expect(0, 918000, '\P{^Is_Joining_Type=--Transparent}', "");
    Error('\p{Is_Jt= /a/T}');
    Error('\P{Is_Jt= /a/T}');
    Expect(1, 917999, '\p{Is_Jt:t}', "");
    Expect(0, 917999, '\p{^Is_Jt:t}', "");
    Expect(0, 917999, '\P{Is_Jt:t}', "");
    Expect(1, 917999, '\P{^Is_Jt:t}', "");
    Expect(0, 918000, '\p{Is_Jt:t}', "");
    Expect(1, 918000, '\p{^Is_Jt:t}', "");
    Expect(1, 918000, '\P{Is_Jt:t}', "");
    Expect(0, 918000, '\P{^Is_Jt:t}', "");
    Expect(1, 917999, '\p{Is_Jt=-_T}', "");
    Expect(0, 917999, '\p{^Is_Jt=-_T}', "");
    Expect(0, 917999, '\P{Is_Jt=-_T}', "");
    Expect(1, 917999, '\P{^Is_Jt=-_T}', "");
    Expect(0, 918000, '\p{Is_Jt=-_T}', "");
    Expect(1, 918000, '\p{^Is_Jt=-_T}', "");
    Expect(1, 918000, '\P{Is_Jt=-_T}', "");
    Expect(0, 918000, '\P{^Is_Jt=-_T}', "");
    Error('\p{Joining_Type=/a/non_JOINING}');
    Error('\P{Joining_Type=/a/non_JOINING}');
    Expect(1, 918000, '\p{Joining_Type=:\ANon_Joining\z:}', "");;
    Expect(0, 917999, '\p{Joining_Type=:\ANon_Joining\z:}', "");;
    Expect(1, 918000, '\p{Joining_Type=nonjoining}', "");
    Expect(0, 918000, '\p{^Joining_Type=nonjoining}', "");
    Expect(0, 918000, '\P{Joining_Type=nonjoining}', "");
    Expect(1, 918000, '\P{^Joining_Type=nonjoining}', "");
    Expect(0, 917999, '\p{Joining_Type=nonjoining}', "");
    Expect(1, 917999, '\p{^Joining_Type=nonjoining}', "");
    Expect(1, 917999, '\P{Joining_Type=nonjoining}', "");
    Expect(0, 917999, '\P{^Joining_Type=nonjoining}', "");
    Expect(1, 918000, '\p{Joining_Type=:\Anonjoining\z:}', "");;
    Expect(0, 917999, '\p{Joining_Type=:\Anonjoining\z:}', "");;
    Expect(1, 918000, '\p{Joining_Type=	non_joining}', "");
    Expect(0, 918000, '\p{^Joining_Type=	non_joining}', "");
    Expect(0, 918000, '\P{Joining_Type=	non_joining}', "");
    Expect(1, 918000, '\P{^Joining_Type=	non_joining}', "");
    Expect(0, 917999, '\p{Joining_Type=	non_joining}', "");
    Expect(1, 917999, '\p{^Joining_Type=	non_joining}', "");
    Expect(1, 917999, '\P{Joining_Type=	non_joining}', "");
    Expect(0, 917999, '\P{^Joining_Type=	non_joining}', "");
    Error('\p{Jt=/a/_ U}');
    Error('\P{Jt=/a/_ U}');
    Expect(1, 918000, '\p{Jt=:\AU\z:}', "");;
    Expect(0, 917999, '\p{Jt=:\AU\z:}', "");;
    Expect(1, 918000, '\p{Jt=u}', "");
    Expect(0, 918000, '\p{^Jt=u}', "");
    Expect(0, 918000, '\P{Jt=u}', "");
    Expect(1, 918000, '\P{^Jt=u}', "");
    Expect(0, 917999, '\p{Jt=u}', "");
    Expect(1, 917999, '\p{^Jt=u}', "");
    Expect(1, 917999, '\P{Jt=u}', "");
    Expect(0, 917999, '\P{^Jt=u}', "");
    Expect(1, 918000, '\p{Jt=:\Au\z:}', "");;
    Expect(0, 917999, '\p{Jt=:\Au\z:}', "");;
    Expect(1, 918000, '\p{Jt= -u}', "");
    Expect(0, 918000, '\p{^Jt= -u}', "");
    Expect(0, 918000, '\P{Jt= -u}', "");
    Expect(1, 918000, '\P{^Jt= -u}', "");
    Expect(0, 917999, '\p{Jt= -u}', "");
    Expect(1, 917999, '\p{^Jt= -u}', "");
    Expect(1, 917999, '\P{Jt= -u}', "");
    Expect(0, 917999, '\P{^Jt= -u}', "");
    Error('\p{Is_Joining_Type=_/a/non_Joining}');
    Error('\P{Is_Joining_Type=_/a/non_Joining}');
    Expect(1, 918000, '\p{Is_Joining_Type=nonjoining}', "");
    Expect(0, 918000, '\p{^Is_Joining_Type=nonjoining}', "");
    Expect(0, 918000, '\P{Is_Joining_Type=nonjoining}', "");
    Expect(1, 918000, '\P{^Is_Joining_Type=nonjoining}', "");
    Expect(0, 917999, '\p{Is_Joining_Type=nonjoining}', "");
    Expect(1, 917999, '\p{^Is_Joining_Type=nonjoining}', "");
    Expect(1, 917999, '\P{Is_Joining_Type=nonjoining}', "");
    Expect(0, 917999, '\P{^Is_Joining_Type=nonjoining}', "");
    Expect(1, 918000, '\p{Is_Joining_Type=-	Non_Joining}', "");
    Expect(0, 918000, '\p{^Is_Joining_Type=-	Non_Joining}', "");
    Expect(0, 918000, '\P{Is_Joining_Type=-	Non_Joining}', "");
    Expect(1, 918000, '\P{^Is_Joining_Type=-	Non_Joining}', "");
    Expect(0, 917999, '\p{Is_Joining_Type=-	Non_Joining}', "");
    Expect(1, 917999, '\p{^Is_Joining_Type=-	Non_Joining}', "");
    Expect(1, 917999, '\P{Is_Joining_Type=-	Non_Joining}', "");
    Expect(0, 917999, '\P{^Is_Joining_Type=-	Non_Joining}', "");
    Error('\p{Is_Jt=_:=U}');
    Error('\P{Is_Jt=_:=U}');
    Expect(1, 918000, '\p{Is_Jt=u}', "");
    Expect(0, 918000, '\p{^Is_Jt=u}', "");
    Expect(0, 918000, '\P{Is_Jt=u}', "");
    Expect(1, 918000, '\P{^Is_Jt=u}', "");
    Expect(0, 917999, '\p{Is_Jt=u}', "");
    Expect(1, 917999, '\p{^Is_Jt=u}', "");
    Expect(1, 917999, '\P{Is_Jt=u}', "");
    Expect(0, 917999, '\P{^Is_Jt=u}', "");
    Expect(1, 918000, '\p{Is_Jt=__U}', "");
    Expect(0, 918000, '\p{^Is_Jt=__U}', "");
    Expect(0, 918000, '\P{Is_Jt=__U}', "");
    Expect(1, 918000, '\P{^Is_Jt=__U}', "");
    Expect(0, 917999, '\p{Is_Jt=__U}', "");
    Expect(1, 917999, '\p{^Is_Jt=__U}', "");
    Expect(1, 917999, '\P{Is_Jt=__U}', "");
    Expect(0, 917999, '\P{^Is_Jt=__U}', "");
    Error('\p{linebreak}');
    Error('\P{linebreak}');
    Error('\p{lb}');
    Error('\P{lb}');
    Error('\p{Line_Break=  Ambiguous:=}');
    Error('\P{Line_Break=  Ambiguous:=}');
    Expect(1, 127404, '\p{Line_Break=:\AAmbiguous\z:}', "");;
    Expect(0, 127405, '\p{Line_Break=:\AAmbiguous\z:}', "");;
    Expect(1, 127404, '\p{Line_Break=ambiguous}', "");
    Expect(0, 127404, '\p{^Line_Break=ambiguous}', "");
    Expect(0, 127404, '\P{Line_Break=ambiguous}', "");
    Expect(1, 127404, '\P{^Line_Break=ambiguous}', "");
    Expect(0, 127405, '\p{Line_Break=ambiguous}', "");
    Expect(1, 127405, '\p{^Line_Break=ambiguous}', "");
    Expect(1, 127405, '\P{Line_Break=ambiguous}', "");
    Expect(0, 127405, '\P{^Line_Break=ambiguous}', "");
    Expect(1, 127404, '\p{Line_Break=:\Aambiguous\z:}', "");;
    Expect(0, 127405, '\p{Line_Break=:\Aambiguous\z:}', "");;
    Expect(1, 127404, '\p{Line_Break:AMBIGUOUS}', "");
    Expect(0, 127404, '\p{^Line_Break:AMBIGUOUS}', "");
    Expect(0, 127404, '\P{Line_Break:AMBIGUOUS}', "");
    Expect(1, 127404, '\P{^Line_Break:AMBIGUOUS}', "");
    Expect(0, 127405, '\p{Line_Break:AMBIGUOUS}', "");
    Expect(1, 127405, '\p{^Line_Break:AMBIGUOUS}', "");
    Expect(1, 127405, '\P{Line_Break:AMBIGUOUS}', "");
    Expect(0, 127405, '\P{^Line_Break:AMBIGUOUS}', "");
    Error('\p{Lb=_AI/a/}');
    Error('\P{Lb=_AI/a/}');
    Expect(1, 127404, '\p{Lb=:\AAI\z:}', "");;
    Expect(0, 127405, '\p{Lb=:\AAI\z:}', "");;
    Expect(1, 127404, '\p{Lb=ai}', "");
    Expect(0, 127404, '\p{^Lb=ai}', "");
    Expect(0, 127404, '\P{Lb=ai}', "");
    Expect(1, 127404, '\P{^Lb=ai}', "");
    Expect(0, 127405, '\p{Lb=ai}', "");
    Expect(1, 127405, '\p{^Lb=ai}', "");
    Expect(1, 127405, '\P{Lb=ai}', "");
    Expect(0, 127405, '\P{^Lb=ai}', "");
    Expect(1, 127404, '\p{Lb=:\Aai\z:}', "");;
    Expect(0, 127405, '\p{Lb=:\Aai\z:}', "");;
    Expect(1, 127404, '\p{Lb=AI}', "");
    Expect(0, 127404, '\p{^Lb=AI}', "");
    Expect(0, 127404, '\P{Lb=AI}', "");
    Expect(1, 127404, '\P{^Lb=AI}', "");
    Expect(0, 127405, '\p{Lb=AI}', "");
    Expect(1, 127405, '\p{^Lb=AI}', "");
    Expect(1, 127405, '\P{Lb=AI}', "");
    Expect(0, 127405, '\P{^Lb=AI}', "");
    Error('\p{Is_Line_Break=/a/	Ambiguous}');
    Error('\P{Is_Line_Break=/a/	Ambiguous}');
    Expect(1, 127404, '\p{Is_Line_Break=ambiguous}', "");
    Expect(0, 127404, '\p{^Is_Line_Break=ambiguous}', "");
    Expect(0, 127404, '\P{Is_Line_Break=ambiguous}', "");
    Expect(1, 127404, '\P{^Is_Line_Break=ambiguous}', "");
    Expect(0, 127405, '\p{Is_Line_Break=ambiguous}', "");
    Expect(1, 127405, '\p{^Is_Line_Break=ambiguous}', "");
    Expect(1, 127405, '\P{Is_Line_Break=ambiguous}', "");
    Expect(0, 127405, '\P{^Is_Line_Break=ambiguous}', "");
    Expect(1, 127404, '\p{Is_Line_Break=	-AMBIGUOUS}', "");
    Expect(0, 127404, '\p{^Is_Line_Break=	-AMBIGUOUS}', "");
    Expect(0, 127404, '\P{Is_Line_Break=	-AMBIGUOUS}', "");
    Expect(1, 127404, '\P{^Is_Line_Break=	-AMBIGUOUS}', "");
    Expect(0, 127405, '\p{Is_Line_Break=	-AMBIGUOUS}', "");
    Expect(1, 127405, '\p{^Is_Line_Break=	-AMBIGUOUS}', "");
    Expect(1, 127405, '\P{Is_Line_Break=	-AMBIGUOUS}', "");
    Expect(0, 127405, '\P{^Is_Line_Break=	-AMBIGUOUS}', "");
    Error('\p{Is_Lb=_/a/ai}');
    Error('\P{Is_Lb=_/a/ai}');
    Expect(1, 127404, '\p{Is_Lb=ai}', "");
    Expect(0, 127404, '\p{^Is_Lb=ai}', "");
    Expect(0, 127404, '\P{Is_Lb=ai}', "");
    Expect(1, 127404, '\P{^Is_Lb=ai}', "");
    Expect(0, 127405, '\p{Is_Lb=ai}', "");
    Expect(1, 127405, '\p{^Is_Lb=ai}', "");
    Expect(1, 127405, '\P{Is_Lb=ai}', "");
    Expect(0, 127405, '\P{^Is_Lb=ai}', "");
    Expect(1, 127404, '\p{Is_Lb=	-ai}', "");
    Expect(0, 127404, '\p{^Is_Lb=	-ai}', "");
    Expect(0, 127404, '\P{Is_Lb=	-ai}', "");
    Expect(1, 127404, '\P{^Is_Lb=	-ai}', "");
    Expect(0, 127405, '\p{Is_Lb=	-ai}', "");
    Expect(1, 127405, '\p{^Is_Lb=	-ai}', "");
    Expect(1, 127405, '\P{Is_Lb=	-ai}', "");
    Expect(0, 127405, '\P{^Is_Lb=	-ai}', "");
    Error('\p{Line_Break=-:=Alphabetic}');
    Error('\P{Line_Break=-:=Alphabetic}');
    Expect(1, 129994, '\p{Line_Break=:\AAlphabetic\z:}', "");;
    Expect(0, 129995, '\p{Line_Break=:\AAlphabetic\z:}', "");;
    Expect(1, 129994, '\p{Line_Break=alphabetic}', "");
    Expect(0, 129994, '\p{^Line_Break=alphabetic}', "");
    Expect(0, 129994, '\P{Line_Break=alphabetic}', "");
    Expect(1, 129994, '\P{^Line_Break=alphabetic}', "");
    Expect(0, 129995, '\p{Line_Break=alphabetic}', "");
    Expect(1, 129995, '\p{^Line_Break=alphabetic}', "");
    Expect(1, 129995, '\P{Line_Break=alphabetic}', "");
    Expect(0, 129995, '\P{^Line_Break=alphabetic}', "");
    Expect(1, 129994, '\p{Line_Break=:\Aalphabetic\z:}', "");;
    Expect(0, 129995, '\p{Line_Break=:\Aalphabetic\z:}', "");;
    Expect(1, 129994, '\p{Line_Break= -alphabetic}', "");
    Expect(0, 129994, '\p{^Line_Break= -alphabetic}', "");
    Expect(0, 129994, '\P{Line_Break= -alphabetic}', "");
    Expect(1, 129994, '\P{^Line_Break= -alphabetic}', "");
    Expect(0, 129995, '\p{Line_Break= -alphabetic}', "");
    Expect(1, 129995, '\p{^Line_Break= -alphabetic}', "");
    Expect(1, 129995, '\P{Line_Break= -alphabetic}', "");
    Expect(0, 129995, '\P{^Line_Break= -alphabetic}', "");
    Error('\p{Lb:	_	AL/a/}');
    Error('\P{Lb:	_	AL/a/}');
    Expect(1, 129994, '\p{Lb=:\AAL\z:}', "");;
    Expect(0, 129995, '\p{Lb=:\AAL\z:}', "");;
    Expect(1, 129994, '\p{Lb=al}', "");
    Expect(0, 129994, '\p{^Lb=al}', "");
    Expect(0, 129994, '\P{Lb=al}', "");
    Expect(1, 129994, '\P{^Lb=al}', "");
    Expect(0, 129995, '\p{Lb=al}', "");
    Expect(1, 129995, '\p{^Lb=al}', "");
    Expect(1, 129995, '\P{Lb=al}', "");
    Expect(0, 129995, '\P{^Lb=al}', "");
    Expect(1, 129994, '\p{Lb=:\Aal\z:}', "");;
    Expect(0, 129995, '\p{Lb=:\Aal\z:}', "");;
    Expect(1, 129994, '\p{Lb:	 AL}', "");
    Expect(0, 129994, '\p{^Lb:	 AL}', "");
    Expect(0, 129994, '\P{Lb:	 AL}', "");
    Expect(1, 129994, '\P{^Lb:	 AL}', "");
    Expect(0, 129995, '\p{Lb:	 AL}', "");
    Expect(1, 129995, '\p{^Lb:	 AL}', "");
    Expect(1, 129995, '\P{Lb:	 AL}', "");
    Expect(0, 129995, '\P{^Lb:	 AL}', "");
    Error('\p{Is_Line_Break=	-Alphabetic:=}');
    Error('\P{Is_Line_Break=	-Alphabetic:=}');
    Expect(1, 129994, '\p{Is_Line_Break=alphabetic}', "");
    Expect(0, 129994, '\p{^Is_Line_Break=alphabetic}', "");
    Expect(0, 129994, '\P{Is_Line_Break=alphabetic}', "");
    Expect(1, 129994, '\P{^Is_Line_Break=alphabetic}', "");
    Expect(0, 129995, '\p{Is_Line_Break=alphabetic}', "");
    Expect(1, 129995, '\p{^Is_Line_Break=alphabetic}', "");
    Expect(1, 129995, '\P{Is_Line_Break=alphabetic}', "");
    Expect(0, 129995, '\P{^Is_Line_Break=alphabetic}', "");
    Expect(1, 129994, '\p{Is_Line_Break=--Alphabetic}', "");
    Expect(0, 129994, '\p{^Is_Line_Break=--Alphabetic}', "");
    Expect(0, 129994, '\P{Is_Line_Break=--Alphabetic}', "");
    Expect(1, 129994, '\P{^Is_Line_Break=--Alphabetic}', "");
    Expect(0, 129995, '\p{Is_Line_Break=--Alphabetic}', "");
    Expect(1, 129995, '\p{^Is_Line_Break=--Alphabetic}', "");
    Expect(1, 129995, '\P{Is_Line_Break=--Alphabetic}', "");
    Expect(0, 129995, '\P{^Is_Line_Break=--Alphabetic}', "");
    Error('\p{Is_Lb=/a/_ al}');
    Error('\P{Is_Lb=/a/_ al}');
    Expect(1, 129994, '\p{Is_Lb=al}', "");
    Expect(0, 129994, '\p{^Is_Lb=al}', "");
    Expect(0, 129994, '\P{Is_Lb=al}', "");
    Expect(1, 129994, '\P{^Is_Lb=al}', "");
    Expect(0, 129995, '\p{Is_Lb=al}', "");
    Expect(1, 129995, '\p{^Is_Lb=al}', "");
    Expect(1, 129995, '\P{Is_Lb=al}', "");
    Expect(0, 129995, '\P{^Is_Lb=al}', "");
    Expect(1, 129994, '\p{Is_Lb=_ al}', "");
    Expect(0, 129994, '\p{^Is_Lb=_ al}', "");
    Expect(0, 129994, '\P{Is_Lb=_ al}', "");
    Expect(1, 129994, '\P{^Is_Lb=_ al}', "");
    Expect(0, 129995, '\p{Is_Lb=_ al}', "");
    Expect(1, 129995, '\p{^Is_Lb=_ al}', "");
    Expect(1, 129995, '\P{Is_Lb=_ al}', "");
    Expect(0, 129995, '\P{^Is_Lb=_ al}', "");
    Error('\p{Line_Break=	:=BREAK_Both}');
    Error('\P{Line_Break=	:=BREAK_Both}');
    Expect(1, 11835, '\p{Line_Break=:\ABreak_Both\z:}', "");;
    Expect(0, 11836, '\p{Line_Break=:\ABreak_Both\z:}', "");;
    Expect(1, 11835, '\p{Line_Break=breakboth}', "");
    Expect(0, 11835, '\p{^Line_Break=breakboth}', "");
    Expect(0, 11835, '\P{Line_Break=breakboth}', "");
    Expect(1, 11835, '\P{^Line_Break=breakboth}', "");
    Expect(0, 11836, '\p{Line_Break=breakboth}', "");
    Expect(1, 11836, '\p{^Line_Break=breakboth}', "");
    Expect(1, 11836, '\P{Line_Break=breakboth}', "");
    Expect(0, 11836, '\P{^Line_Break=breakboth}', "");
    Expect(1, 11835, '\p{Line_Break=:\Abreakboth\z:}', "");;
    Expect(0, 11836, '\p{Line_Break=:\Abreakboth\z:}', "");;
    Expect(1, 11835, '\p{Line_Break=-_Break_Both}', "");
    Expect(0, 11835, '\p{^Line_Break=-_Break_Both}', "");
    Expect(0, 11835, '\P{Line_Break=-_Break_Both}', "");
    Expect(1, 11835, '\P{^Line_Break=-_Break_Both}', "");
    Expect(0, 11836, '\p{Line_Break=-_Break_Both}', "");
    Expect(1, 11836, '\p{^Line_Break=-_Break_Both}', "");
    Expect(1, 11836, '\P{Line_Break=-_Break_Both}', "");
    Expect(0, 11836, '\P{^Line_Break=-_Break_Both}', "");
    Error('\p{Lb=:=b2}');
    Error('\P{Lb=:=b2}');
    Expect(1, 11835, '\p{Lb=:\AB2\z:}', "");;
    Expect(0, 11836, '\p{Lb=:\AB2\z:}', "");;
    Expect(1, 11835, '\p{Lb=b2}', "");
    Expect(0, 11835, '\p{^Lb=b2}', "");
    Expect(0, 11835, '\P{Lb=b2}', "");
    Expect(1, 11835, '\P{^Lb=b2}', "");
    Expect(0, 11836, '\p{Lb=b2}', "");
    Expect(1, 11836, '\p{^Lb=b2}', "");
    Expect(1, 11836, '\P{Lb=b2}', "");
    Expect(0, 11836, '\P{^Lb=b2}', "");
    Expect(1, 11835, '\p{Lb=:\Ab2\z:}', "");;
    Expect(0, 11836, '\p{Lb=:\Ab2\z:}', "");;
    Expect(1, 11835, '\p{Lb=		b2}', "");
    Expect(0, 11835, '\p{^Lb=		b2}', "");
    Expect(0, 11835, '\P{Lb=		b2}', "");
    Expect(1, 11835, '\P{^Lb=		b2}', "");
    Expect(0, 11836, '\p{Lb=		b2}', "");
    Expect(1, 11836, '\p{^Lb=		b2}', "");
    Expect(1, 11836, '\P{Lb=		b2}', "");
    Expect(0, 11836, '\P{^Lb=		b2}', "");
    Error('\p{Is_Line_Break= break_both:=}');
    Error('\P{Is_Line_Break= break_both:=}');
    Expect(1, 11835, '\p{Is_Line_Break=breakboth}', "");
    Expect(0, 11835, '\p{^Is_Line_Break=breakboth}', "");
    Expect(0, 11835, '\P{Is_Line_Break=breakboth}', "");
    Expect(1, 11835, '\P{^Is_Line_Break=breakboth}', "");
    Expect(0, 11836, '\p{Is_Line_Break=breakboth}', "");
    Expect(1, 11836, '\p{^Is_Line_Break=breakboth}', "");
    Expect(1, 11836, '\P{Is_Line_Break=breakboth}', "");
    Expect(0, 11836, '\P{^Is_Line_Break=breakboth}', "");
    Expect(1, 11835, '\p{Is_Line_Break:   	_break_Both}', "");
    Expect(0, 11835, '\p{^Is_Line_Break:   	_break_Both}', "");
    Expect(0, 11835, '\P{Is_Line_Break:   	_break_Both}', "");
    Expect(1, 11835, '\P{^Is_Line_Break:   	_break_Both}', "");
    Expect(0, 11836, '\p{Is_Line_Break:   	_break_Both}', "");
    Expect(1, 11836, '\p{^Is_Line_Break:   	_break_Both}', "");
    Expect(1, 11836, '\P{Is_Line_Break:   	_break_Both}', "");
    Expect(0, 11836, '\P{^Is_Line_Break:   	_break_Both}', "");
    Error('\p{Is_Lb=-	B2/a/}');
    Error('\P{Is_Lb=-	B2/a/}');
    Expect(1, 11835, '\p{Is_Lb=b2}', "");
    Expect(0, 11835, '\p{^Is_Lb=b2}', "");
    Expect(0, 11835, '\P{Is_Lb=b2}', "");
    Expect(1, 11835, '\P{^Is_Lb=b2}', "");
    Expect(0, 11836, '\p{Is_Lb=b2}', "");
    Expect(1, 11836, '\p{^Is_Lb=b2}', "");
    Expect(1, 11836, '\P{Is_Lb=b2}', "");
    Expect(0, 11836, '\P{^Is_Lb=b2}', "");
    Expect(1, 11835, '\p{Is_Lb=	 B2}', "");
    Expect(0, 11835, '\p{^Is_Lb=	 B2}', "");
    Expect(0, 11835, '\P{Is_Lb=	 B2}', "");
    Expect(1, 11835, '\P{^Is_Lb=	 B2}', "");
    Expect(0, 11836, '\p{Is_Lb=	 B2}', "");
    Expect(1, 11836, '\p{^Is_Lb=	 B2}', "");
    Expect(1, 11836, '\P{Is_Lb=	 B2}', "");
    Expect(0, 11836, '\P{^Is_Lb=	 B2}', "");
    Error('\p{Line_Break=  BREAK_after:=}');
    Error('\P{Line_Break=  BREAK_after:=}');
    Expect(1, 121482, '\p{Line_Break=:\ABreak_After\z:}', "");;
    Expect(0, 121483, '\p{Line_Break=:\ABreak_After\z:}', "");;
    Expect(1, 121482, '\p{Line_Break=breakafter}', "");
    Expect(0, 121482, '\p{^Line_Break=breakafter}', "");
    Expect(0, 121482, '\P{Line_Break=breakafter}', "");
    Expect(1, 121482, '\P{^Line_Break=breakafter}', "");
    Expect(0, 121483, '\p{Line_Break=breakafter}', "");
    Expect(1, 121483, '\p{^Line_Break=breakafter}', "");
    Expect(1, 121483, '\P{Line_Break=breakafter}', "");
    Expect(0, 121483, '\P{^Line_Break=breakafter}', "");
    Expect(1, 121482, '\p{Line_Break=:\Abreakafter\z:}', "");;
    Expect(0, 121483, '\p{Line_Break=:\Abreakafter\z:}', "");;
    Expect(1, 121482, '\p{Line_Break=-	BREAK_after}', "");
    Expect(0, 121482, '\p{^Line_Break=-	BREAK_after}', "");
    Expect(0, 121482, '\P{Line_Break=-	BREAK_after}', "");
    Expect(1, 121482, '\P{^Line_Break=-	BREAK_after}', "");
    Expect(0, 121483, '\p{Line_Break=-	BREAK_after}', "");
    Expect(1, 121483, '\p{^Line_Break=-	BREAK_after}', "");
    Expect(1, 121483, '\P{Line_Break=-	BREAK_after}', "");
    Expect(0, 121483, '\P{^Line_Break=-	BREAK_after}', "");
    Error('\p{Lb=-BA/a/}');
    Error('\P{Lb=-BA/a/}');
    Expect(1, 121482, '\p{Lb=:\ABA\z:}', "");;
    Expect(0, 121483, '\p{Lb=:\ABA\z:}', "");;
    Expect(1, 121482, '\p{Lb=ba}', "");
    Expect(0, 121482, '\p{^Lb=ba}', "");
    Expect(0, 121482, '\P{Lb=ba}', "");
    Expect(1, 121482, '\P{^Lb=ba}', "");
    Expect(0, 121483, '\p{Lb=ba}', "");
    Expect(1, 121483, '\p{^Lb=ba}', "");
    Expect(1, 121483, '\P{Lb=ba}', "");
    Expect(0, 121483, '\P{^Lb=ba}', "");
    Expect(1, 121482, '\p{Lb=:\Aba\z:}', "");;
    Expect(0, 121483, '\p{Lb=:\Aba\z:}', "");;
    Expect(1, 121482, '\p{Lb= BA}', "");
    Expect(0, 121482, '\p{^Lb= BA}', "");
    Expect(0, 121482, '\P{Lb= BA}', "");
    Expect(1, 121482, '\P{^Lb= BA}', "");
    Expect(0, 121483, '\p{Lb= BA}', "");
    Expect(1, 121483, '\p{^Lb= BA}', "");
    Expect(1, 121483, '\P{Lb= BA}', "");
    Expect(0, 121483, '\P{^Lb= BA}', "");
    Error('\p{Is_Line_Break=:= -break_After}');
    Error('\P{Is_Line_Break=:= -break_After}');
    Expect(1, 121482, '\p{Is_Line_Break=breakafter}', "");
    Expect(0, 121482, '\p{^Is_Line_Break=breakafter}', "");
    Expect(0, 121482, '\P{Is_Line_Break=breakafter}', "");
    Expect(1, 121482, '\P{^Is_Line_Break=breakafter}', "");
    Expect(0, 121483, '\p{Is_Line_Break=breakafter}', "");
    Expect(1, 121483, '\p{^Is_Line_Break=breakafter}', "");
    Expect(1, 121483, '\P{Is_Line_Break=breakafter}', "");
    Expect(0, 121483, '\P{^Is_Line_Break=breakafter}', "");
    Expect(1, 121482, '\p{Is_Line_Break= Break_After}', "");
    Expect(0, 121482, '\p{^Is_Line_Break= Break_After}', "");
    Expect(0, 121482, '\P{Is_Line_Break= Break_After}', "");
    Expect(1, 121482, '\P{^Is_Line_Break= Break_After}', "");
    Expect(0, 121483, '\p{Is_Line_Break= Break_After}', "");
    Expect(1, 121483, '\p{^Is_Line_Break= Break_After}', "");
    Expect(1, 121483, '\P{Is_Line_Break= Break_After}', "");
    Expect(0, 121483, '\P{^Is_Line_Break= Break_After}', "");
    Error('\p{Is_Lb= BA:=}');
    Error('\P{Is_Lb= BA:=}');
    Expect(1, 121482, '\p{Is_Lb=ba}', "");
    Expect(0, 121482, '\p{^Is_Lb=ba}', "");
    Expect(0, 121482, '\P{Is_Lb=ba}', "");
    Expect(1, 121482, '\P{^Is_Lb=ba}', "");
    Expect(0, 121483, '\p{Is_Lb=ba}', "");
    Expect(1, 121483, '\p{^Is_Lb=ba}', "");
    Expect(1, 121483, '\P{Is_Lb=ba}', "");
    Expect(0, 121483, '\P{^Is_Lb=ba}', "");
    Expect(1, 121482, '\p{Is_Lb=	_BA}', "");
    Expect(0, 121482, '\p{^Is_Lb=	_BA}', "");
    Expect(0, 121482, '\P{Is_Lb=	_BA}', "");
    Expect(1, 121482, '\P{^Is_Lb=	_BA}', "");
    Expect(0, 121483, '\p{Is_Lb=	_BA}', "");
    Expect(1, 121483, '\p{^Is_Lb=	_BA}', "");
    Expect(1, 121483, '\P{Is_Lb=	_BA}', "");
    Expect(0, 121483, '\P{^Is_Lb=	_BA}', "");
    Error('\p{Line_Break=-	Break_before:=}');
    Error('\P{Line_Break=-	Break_before:=}');
    Expect(1, 72816, '\p{Line_Break=:\ABreak_Before\z:}', "");;
    Expect(0, 72817, '\p{Line_Break=:\ABreak_Before\z:}', "");;
    Expect(1, 72816, '\p{Line_Break=breakbefore}', "");
    Expect(0, 72816, '\p{^Line_Break=breakbefore}', "");
    Expect(0, 72816, '\P{Line_Break=breakbefore}', "");
    Expect(1, 72816, '\P{^Line_Break=breakbefore}', "");
    Expect(0, 72817, '\p{Line_Break=breakbefore}', "");
    Expect(1, 72817, '\p{^Line_Break=breakbefore}', "");
    Expect(1, 72817, '\P{Line_Break=breakbefore}', "");
    Expect(0, 72817, '\P{^Line_Break=breakbefore}', "");
    Expect(1, 72816, '\p{Line_Break=:\Abreakbefore\z:}', "");;
    Expect(0, 72817, '\p{Line_Break=:\Abreakbefore\z:}', "");;
    Expect(1, 72816, '\p{Line_Break= Break_Before}', "");
    Expect(0, 72816, '\p{^Line_Break= Break_Before}', "");
    Expect(0, 72816, '\P{Line_Break= Break_Before}', "");
    Expect(1, 72816, '\P{^Line_Break= Break_Before}', "");
    Expect(0, 72817, '\p{Line_Break= Break_Before}', "");
    Expect(1, 72817, '\p{^Line_Break= Break_Before}', "");
    Expect(1, 72817, '\P{Line_Break= Break_Before}', "");
    Expect(0, 72817, '\P{^Line_Break= Break_Before}', "");
    Error('\p{Lb=:= _BB}');
    Error('\P{Lb=:= _BB}');
    Expect(1, 72816, '\p{Lb=:\ABB\z:}', "");;
    Expect(0, 72817, '\p{Lb=:\ABB\z:}', "");;
    Expect(1, 72816, '\p{Lb=bb}', "");
    Expect(0, 72816, '\p{^Lb=bb}', "");
    Expect(0, 72816, '\P{Lb=bb}', "");
    Expect(1, 72816, '\P{^Lb=bb}', "");
    Expect(0, 72817, '\p{Lb=bb}', "");
    Expect(1, 72817, '\p{^Lb=bb}', "");
    Expect(1, 72817, '\P{Lb=bb}', "");
    Expect(0, 72817, '\P{^Lb=bb}', "");
    Expect(1, 72816, '\p{Lb=:\Abb\z:}', "");;
    Expect(0, 72817, '\p{Lb=:\Abb\z:}', "");;
    Expect(1, 72816, '\p{Lb: _-BB}', "");
    Expect(0, 72816, '\p{^Lb: _-BB}', "");
    Expect(0, 72816, '\P{Lb: _-BB}', "");
    Expect(1, 72816, '\P{^Lb: _-BB}', "");
    Expect(0, 72817, '\p{Lb: _-BB}', "");
    Expect(1, 72817, '\p{^Lb: _-BB}', "");
    Expect(1, 72817, '\P{Lb: _-BB}', "");
    Expect(0, 72817, '\P{^Lb: _-BB}', "");
    Error('\p{Is_Line_Break=/a/--break_before}');
    Error('\P{Is_Line_Break=/a/--break_before}');
    Expect(1, 72816, '\p{Is_Line_Break=breakbefore}', "");
    Expect(0, 72816, '\p{^Is_Line_Break=breakbefore}', "");
    Expect(0, 72816, '\P{Is_Line_Break=breakbefore}', "");
    Expect(1, 72816, '\P{^Is_Line_Break=breakbefore}', "");
    Expect(0, 72817, '\p{Is_Line_Break=breakbefore}', "");
    Expect(1, 72817, '\p{^Is_Line_Break=breakbefore}', "");
    Expect(1, 72817, '\P{Is_Line_Break=breakbefore}', "");
    Expect(0, 72817, '\P{^Is_Line_Break=breakbefore}', "");
    Expect(1, 72816, '\p{Is_Line_Break=_ Break_Before}', "");
    Expect(0, 72816, '\p{^Is_Line_Break=_ Break_Before}', "");
    Expect(0, 72816, '\P{Is_Line_Break=_ Break_Before}', "");
    Expect(1, 72816, '\P{^Is_Line_Break=_ Break_Before}', "");
    Expect(0, 72817, '\p{Is_Line_Break=_ Break_Before}', "");
    Expect(1, 72817, '\p{^Is_Line_Break=_ Break_Before}', "");
    Expect(1, 72817, '\P{Is_Line_Break=_ Break_Before}', "");
    Expect(0, 72817, '\P{^Is_Line_Break=_ Break_Before}', "");
    Error('\p{Is_Lb=_BB/a/}');
    Error('\P{Is_Lb=_BB/a/}');
    Expect(1, 72816, '\p{Is_Lb=bb}', "");
    Expect(0, 72816, '\p{^Is_Lb=bb}', "");
    Expect(0, 72816, '\P{Is_Lb=bb}', "");
    Expect(1, 72816, '\P{^Is_Lb=bb}', "");
    Expect(0, 72817, '\p{Is_Lb=bb}', "");
    Expect(1, 72817, '\p{^Is_Lb=bb}', "");
    Expect(1, 72817, '\P{Is_Lb=bb}', "");
    Expect(0, 72817, '\P{^Is_Lb=bb}', "");
    Expect(1, 72816, '\p{Is_Lb=BB}', "");
    Expect(0, 72816, '\p{^Is_Lb=BB}', "");
    Expect(0, 72816, '\P{Is_Lb=BB}', "");
    Expect(1, 72816, '\P{^Is_Lb=BB}', "");
    Expect(0, 72817, '\p{Is_Lb=BB}', "");
    Expect(1, 72817, '\p{^Is_Lb=BB}', "");
    Expect(1, 72817, '\P{Is_Lb=BB}', "");
    Expect(0, 72817, '\P{^Is_Lb=BB}', "");
    Error('\p{Line_Break=/a/  Mandatory_break}');
    Error('\P{Line_Break=/a/  Mandatory_break}');
    Expect(1, 8233, '\p{Line_Break=:\AMandatory_Break\z:}', "");;
    Expect(0, 8234, '\p{Line_Break=:\AMandatory_Break\z:}', "");;
    Expect(1, 8233, '\p{Line_Break=mandatorybreak}', "");
    Expect(0, 8233, '\p{^Line_Break=mandatorybreak}', "");
    Expect(0, 8233, '\P{Line_Break=mandatorybreak}', "");
    Expect(1, 8233, '\P{^Line_Break=mandatorybreak}', "");
    Expect(0, 8234, '\p{Line_Break=mandatorybreak}', "");
    Expect(1, 8234, '\p{^Line_Break=mandatorybreak}', "");
    Expect(1, 8234, '\P{Line_Break=mandatorybreak}', "");
    Expect(0, 8234, '\P{^Line_Break=mandatorybreak}', "");
    Expect(1, 8233, '\p{Line_Break=:\Amandatorybreak\z:}', "");;
    Expect(0, 8234, '\p{Line_Break=:\Amandatorybreak\z:}', "");;
    Expect(1, 8233, '\p{Line_Break=	Mandatory_Break}', "");
    Expect(0, 8233, '\p{^Line_Break=	Mandatory_Break}', "");
    Expect(0, 8233, '\P{Line_Break=	Mandatory_Break}', "");
    Expect(1, 8233, '\P{^Line_Break=	Mandatory_Break}', "");
    Expect(0, 8234, '\p{Line_Break=	Mandatory_Break}', "");
    Expect(1, 8234, '\p{^Line_Break=	Mandatory_Break}', "");
    Expect(1, 8234, '\P{Line_Break=	Mandatory_Break}', "");
    Expect(0, 8234, '\P{^Line_Break=	Mandatory_Break}', "");
    Error('\p{Lb=	:=BK}');
    Error('\P{Lb=	:=BK}');
    Expect(1, 8233, '\p{Lb=:\ABK\z:}', "");;
    Expect(0, 8234, '\p{Lb=:\ABK\z:}', "");;
    Expect(1, 8233, '\p{Lb=bk}', "");
    Expect(0, 8233, '\p{^Lb=bk}', "");
    Expect(0, 8233, '\P{Lb=bk}', "");
    Expect(1, 8233, '\P{^Lb=bk}', "");
    Expect(0, 8234, '\p{Lb=bk}', "");
    Expect(1, 8234, '\p{^Lb=bk}', "");
    Expect(1, 8234, '\P{Lb=bk}', "");
    Expect(0, 8234, '\P{^Lb=bk}', "");
    Expect(1, 8233, '\p{Lb=:\Abk\z:}', "");;
    Expect(0, 8234, '\p{Lb=:\Abk\z:}', "");;
    Expect(1, 8233, '\p{Lb: 	_BK}', "");
    Expect(0, 8233, '\p{^Lb: 	_BK}', "");
    Expect(0, 8233, '\P{Lb: 	_BK}', "");
    Expect(1, 8233, '\P{^Lb: 	_BK}', "");
    Expect(0, 8234, '\p{Lb: 	_BK}', "");
    Expect(1, 8234, '\p{^Lb: 	_BK}', "");
    Expect(1, 8234, '\P{Lb: 	_BK}', "");
    Expect(0, 8234, '\P{^Lb: 	_BK}', "");
    Error('\p{Is_Line_Break= -MANDATORY_Break/a/}');
    Error('\P{Is_Line_Break= -MANDATORY_Break/a/}');
    Expect(1, 8233, '\p{Is_Line_Break=mandatorybreak}', "");
    Expect(0, 8233, '\p{^Is_Line_Break=mandatorybreak}', "");
    Expect(0, 8233, '\P{Is_Line_Break=mandatorybreak}', "");
    Expect(1, 8233, '\P{^Is_Line_Break=mandatorybreak}', "");
    Expect(0, 8234, '\p{Is_Line_Break=mandatorybreak}', "");
    Expect(1, 8234, '\p{^Is_Line_Break=mandatorybreak}', "");
    Expect(1, 8234, '\P{Is_Line_Break=mandatorybreak}', "");
    Expect(0, 8234, '\P{^Is_Line_Break=mandatorybreak}', "");
    Expect(1, 8233, '\p{Is_Line_Break=_-Mandatory_Break}', "");
    Expect(0, 8233, '\p{^Is_Line_Break=_-Mandatory_Break}', "");
    Expect(0, 8233, '\P{Is_Line_Break=_-Mandatory_Break}', "");
    Expect(1, 8233, '\P{^Is_Line_Break=_-Mandatory_Break}', "");
    Expect(0, 8234, '\p{Is_Line_Break=_-Mandatory_Break}', "");
    Expect(1, 8234, '\p{^Is_Line_Break=_-Mandatory_Break}', "");
    Expect(1, 8234, '\P{Is_Line_Break=_-Mandatory_Break}', "");
    Expect(0, 8234, '\P{^Is_Line_Break=_-Mandatory_Break}', "");
    Error('\p{Is_Lb=	/a/BK}');
    Error('\P{Is_Lb=	/a/BK}');
    Expect(1, 8233, '\p{Is_Lb=bk}', "");
    Expect(0, 8233, '\p{^Is_Lb=bk}', "");
    Expect(0, 8233, '\P{Is_Lb=bk}', "");
    Expect(1, 8233, '\P{^Is_Lb=bk}', "");
    Expect(0, 8234, '\p{Is_Lb=bk}', "");
    Expect(1, 8234, '\p{^Is_Lb=bk}', "");
    Expect(1, 8234, '\P{Is_Lb=bk}', "");
    Expect(0, 8234, '\P{^Is_Lb=bk}', "");
    Expect(1, 8233, '\p{Is_Lb=-_BK}', "");
    Expect(0, 8233, '\p{^Is_Lb=-_BK}', "");
    Expect(0, 8233, '\P{Is_Lb=-_BK}', "");
    Expect(1, 8233, '\P{^Is_Lb=-_BK}', "");
    Expect(0, 8234, '\p{Is_Lb=-_BK}', "");
    Expect(1, 8234, '\p{^Is_Lb=-_BK}', "");
    Expect(1, 8234, '\P{Is_Lb=-_BK}', "");
    Expect(0, 8234, '\P{^Is_Lb=-_BK}', "");
    Error('\p{Line_Break:   /a/-Contingent_BREAK}');
    Error('\P{Line_Break:   /a/-Contingent_BREAK}');
    Expect(1, 65532, '\p{Line_Break=:\AContingent_Break\z:}', "");;
    Expect(0, 65533, '\p{Line_Break=:\AContingent_Break\z:}', "");;
    Expect(1, 65532, '\p{Line_Break=contingentbreak}', "");
    Expect(0, 65532, '\p{^Line_Break=contingentbreak}', "");
    Expect(0, 65532, '\P{Line_Break=contingentbreak}', "");
    Expect(1, 65532, '\P{^Line_Break=contingentbreak}', "");
    Expect(0, 65533, '\p{Line_Break=contingentbreak}', "");
    Expect(1, 65533, '\p{^Line_Break=contingentbreak}', "");
    Expect(1, 65533, '\P{Line_Break=contingentbreak}', "");
    Expect(0, 65533, '\P{^Line_Break=contingentbreak}', "");
    Expect(1, 65532, '\p{Line_Break=:\Acontingentbreak\z:}', "");;
    Expect(0, 65533, '\p{Line_Break=:\Acontingentbreak\z:}', "");;
    Expect(1, 65532, '\p{Line_Break=  contingent_BREAK}', "");
    Expect(0, 65532, '\p{^Line_Break=  contingent_BREAK}', "");
    Expect(0, 65532, '\P{Line_Break=  contingent_BREAK}', "");
    Expect(1, 65532, '\P{^Line_Break=  contingent_BREAK}', "");
    Expect(0, 65533, '\p{Line_Break=  contingent_BREAK}', "");
    Expect(1, 65533, '\p{^Line_Break=  contingent_BREAK}', "");
    Expect(1, 65533, '\P{Line_Break=  contingent_BREAK}', "");
    Expect(0, 65533, '\P{^Line_Break=  contingent_BREAK}', "");
    Error('\p{Lb=_cb:=}');
    Error('\P{Lb=_cb:=}');
    Expect(1, 65532, '\p{Lb=:\ACB\z:}', "");;
    Expect(0, 65533, '\p{Lb=:\ACB\z:}', "");;
    Expect(1, 65532, '\p{Lb=cb}', "");
    Expect(0, 65532, '\p{^Lb=cb}', "");
    Expect(0, 65532, '\P{Lb=cb}', "");
    Expect(1, 65532, '\P{^Lb=cb}', "");
    Expect(0, 65533, '\p{Lb=cb}', "");
    Expect(1, 65533, '\p{^Lb=cb}', "");
    Expect(1, 65533, '\P{Lb=cb}', "");
    Expect(0, 65533, '\P{^Lb=cb}', "");
    Expect(1, 65532, '\p{Lb=:\Acb\z:}', "");;
    Expect(0, 65533, '\p{Lb=:\Acb\z:}', "");;
    Expect(1, 65532, '\p{Lb=	-cb}', "");
    Expect(0, 65532, '\p{^Lb=	-cb}', "");
    Expect(0, 65532, '\P{Lb=	-cb}', "");
    Expect(1, 65532, '\P{^Lb=	-cb}', "");
    Expect(0, 65533, '\p{Lb=	-cb}', "");
    Expect(1, 65533, '\p{^Lb=	-cb}', "");
    Expect(1, 65533, '\P{Lb=	-cb}', "");
    Expect(0, 65533, '\P{^Lb=	-cb}', "");
    Error('\p{Is_Line_Break=	:=Contingent_break}');
    Error('\P{Is_Line_Break=	:=Contingent_break}');
    Expect(1, 65532, '\p{Is_Line_Break=contingentbreak}', "");
    Expect(0, 65532, '\p{^Is_Line_Break=contingentbreak}', "");
    Expect(0, 65532, '\P{Is_Line_Break=contingentbreak}', "");
    Expect(1, 65532, '\P{^Is_Line_Break=contingentbreak}', "");
    Expect(0, 65533, '\p{Is_Line_Break=contingentbreak}', "");
    Expect(1, 65533, '\p{^Is_Line_Break=contingentbreak}', "");
    Expect(1, 65533, '\P{Is_Line_Break=contingentbreak}', "");
    Expect(0, 65533, '\P{^Is_Line_Break=contingentbreak}', "");
    Expect(1, 65532, '\p{Is_Line_Break=_	Contingent_Break}', "");
    Expect(0, 65532, '\p{^Is_Line_Break=_	Contingent_Break}', "");
    Expect(0, 65532, '\P{Is_Line_Break=_	Contingent_Break}', "");
    Expect(1, 65532, '\P{^Is_Line_Break=_	Contingent_Break}', "");
    Expect(0, 65533, '\p{Is_Line_Break=_	Contingent_Break}', "");
    Expect(1, 65533, '\p{^Is_Line_Break=_	Contingent_Break}', "");
    Expect(1, 65533, '\P{Is_Line_Break=_	Contingent_Break}', "");
    Expect(0, 65533, '\P{^Is_Line_Break=_	Contingent_Break}', "");
    Error('\p{Is_Lb=__CB:=}');
    Error('\P{Is_Lb=__CB:=}');
    Expect(1, 65532, '\p{Is_Lb=cb}', "");
    Expect(0, 65532, '\p{^Is_Lb=cb}', "");
    Expect(0, 65532, '\P{Is_Lb=cb}', "");
    Expect(1, 65532, '\P{^Is_Lb=cb}', "");
    Expect(0, 65533, '\p{Is_Lb=cb}', "");
    Expect(1, 65533, '\p{^Is_Lb=cb}', "");
    Expect(1, 65533, '\P{Is_Lb=cb}', "");
    Expect(0, 65533, '\P{^Is_Lb=cb}', "");
    Expect(1, 65532, '\p{Is_Lb=- CB}', "");
    Expect(0, 65532, '\p{^Is_Lb=- CB}', "");
    Expect(0, 65532, '\P{Is_Lb=- CB}', "");
    Expect(1, 65532, '\P{^Is_Lb=- CB}', "");
    Expect(0, 65533, '\p{Is_Lb=- CB}', "");
    Expect(1, 65533, '\p{^Is_Lb=- CB}', "");
    Expect(1, 65533, '\P{Is_Lb=- CB}', "");
    Expect(0, 65533, '\P{^Is_Lb=- CB}', "");
    Error('\p{Line_Break=-:=conditional_Japanese_starter}');
    Error('\P{Line_Break=-:=conditional_Japanese_starter}');
    Expect(1, 110951, '\p{Line_Break=:\AConditional_Japanese_Starter\z:}', "");;
    Expect(0, 110952, '\p{Line_Break=:\AConditional_Japanese_Starter\z:}', "");;
    Expect(1, 110951, '\p{Line_Break=conditionaljapanesestarter}', "");
    Expect(0, 110951, '\p{^Line_Break=conditionaljapanesestarter}', "");
    Expect(0, 110951, '\P{Line_Break=conditionaljapanesestarter}', "");
    Expect(1, 110951, '\P{^Line_Break=conditionaljapanesestarter}', "");
    Expect(0, 110952, '\p{Line_Break=conditionaljapanesestarter}', "");
    Expect(1, 110952, '\p{^Line_Break=conditionaljapanesestarter}', "");
    Expect(1, 110952, '\P{Line_Break=conditionaljapanesestarter}', "");
    Expect(0, 110952, '\P{^Line_Break=conditionaljapanesestarter}', "");
    Expect(1, 110951, '\p{Line_Break=:\Aconditionaljapanesestarter\z:}', "");;
    Expect(0, 110952, '\p{Line_Break=:\Aconditionaljapanesestarter\z:}', "");;
    Expect(1, 110951, '\p{Line_Break=	-Conditional_JAPANESE_starter}', "");
    Expect(0, 110951, '\p{^Line_Break=	-Conditional_JAPANESE_starter}', "");
    Expect(0, 110951, '\P{Line_Break=	-Conditional_JAPANESE_starter}', "");
    Expect(1, 110951, '\P{^Line_Break=	-Conditional_JAPANESE_starter}', "");
    Expect(0, 110952, '\p{Line_Break=	-Conditional_JAPANESE_starter}', "");
    Expect(1, 110952, '\p{^Line_Break=	-Conditional_JAPANESE_starter}', "");
    Expect(1, 110952, '\P{Line_Break=	-Conditional_JAPANESE_starter}', "");
    Expect(0, 110952, '\P{^Line_Break=	-Conditional_JAPANESE_starter}', "");
    Error('\p{Lb=:=CJ}');
    Error('\P{Lb=:=CJ}');
    Expect(1, 110951, '\p{Lb=:\ACJ\z:}', "");;
    Expect(0, 110952, '\p{Lb=:\ACJ\z:}', "");;
    Expect(1, 110951, '\p{Lb=cj}', "");
    Expect(0, 110951, '\p{^Lb=cj}', "");
    Expect(0, 110951, '\P{Lb=cj}', "");
    Expect(1, 110951, '\P{^Lb=cj}', "");
    Expect(0, 110952, '\p{Lb=cj}', "");
    Expect(1, 110952, '\p{^Lb=cj}', "");
    Expect(1, 110952, '\P{Lb=cj}', "");
    Expect(0, 110952, '\P{^Lb=cj}', "");
    Expect(1, 110951, '\p{Lb=:\Acj\z:}', "");;
    Expect(0, 110952, '\p{Lb=:\Acj\z:}', "");;
    Expect(1, 110951, '\p{Lb=_CJ}', "");
    Expect(0, 110951, '\p{^Lb=_CJ}', "");
    Expect(0, 110951, '\P{Lb=_CJ}', "");
    Expect(1, 110951, '\P{^Lb=_CJ}', "");
    Expect(0, 110952, '\p{Lb=_CJ}', "");
    Expect(1, 110952, '\p{^Lb=_CJ}', "");
    Expect(1, 110952, '\P{Lb=_CJ}', "");
    Expect(0, 110952, '\P{^Lb=_CJ}', "");
    Error('\p{Is_Line_Break=-:=CONDITIONAL_Japanese_starter}');
    Error('\P{Is_Line_Break=-:=CONDITIONAL_Japanese_starter}');
    Expect(1, 110951, '\p{Is_Line_Break=conditionaljapanesestarter}', "");
    Expect(0, 110951, '\p{^Is_Line_Break=conditionaljapanesestarter}', "");
    Expect(0, 110951, '\P{Is_Line_Break=conditionaljapanesestarter}', "");
    Expect(1, 110951, '\P{^Is_Line_Break=conditionaljapanesestarter}', "");
    Expect(0, 110952, '\p{Is_Line_Break=conditionaljapanesestarter}', "");
    Expect(1, 110952, '\p{^Is_Line_Break=conditionaljapanesestarter}', "");
    Expect(1, 110952, '\P{Is_Line_Break=conditionaljapanesestarter}', "");
    Expect(0, 110952, '\P{^Is_Line_Break=conditionaljapanesestarter}', "");
    Expect(1, 110951, '\p{Is_Line_Break=-	Conditional_Japanese_Starter}', "");
    Expect(0, 110951, '\p{^Is_Line_Break=-	Conditional_Japanese_Starter}', "");
    Expect(0, 110951, '\P{Is_Line_Break=-	Conditional_Japanese_Starter}', "");
    Expect(1, 110951, '\P{^Is_Line_Break=-	Conditional_Japanese_Starter}', "");
    Expect(0, 110952, '\p{Is_Line_Break=-	Conditional_Japanese_Starter}', "");
    Expect(1, 110952, '\p{^Is_Line_Break=-	Conditional_Japanese_Starter}', "");
    Expect(1, 110952, '\P{Is_Line_Break=-	Conditional_Japanese_Starter}', "");
    Expect(0, 110952, '\P{^Is_Line_Break=-	Conditional_Japanese_Starter}', "");
    Error('\p{Is_Lb= cj/a/}');
    Error('\P{Is_Lb= cj/a/}');
    Expect(1, 110951, '\p{Is_Lb=cj}', "");
    Expect(0, 110951, '\p{^Is_Lb=cj}', "");
    Expect(0, 110951, '\P{Is_Lb=cj}', "");
    Expect(1, 110951, '\P{^Is_Lb=cj}', "");
    Expect(0, 110952, '\p{Is_Lb=cj}', "");
    Expect(1, 110952, '\p{^Is_Lb=cj}', "");
    Expect(1, 110952, '\P{Is_Lb=cj}', "");
    Expect(0, 110952, '\P{^Is_Lb=cj}', "");
    Expect(1, 110951, '\p{Is_Lb=__CJ}', "");
    Expect(0, 110951, '\p{^Is_Lb=__CJ}', "");
    Expect(0, 110951, '\P{Is_Lb=__CJ}', "");
    Expect(1, 110951, '\P{^Is_Lb=__CJ}', "");
    Expect(0, 110952, '\p{Is_Lb=__CJ}', "");
    Expect(1, 110952, '\p{^Is_Lb=__CJ}', "");
    Expect(1, 110952, '\P{Is_Lb=__CJ}', "");
    Expect(0, 110952, '\P{^Is_Lb=__CJ}', "");
    Error('\p{Line_Break=/a/__Close_PUNCTUATION}');
    Error('\P{Line_Break=/a/__Close_PUNCTUATION}');
    Expect(1, 83407, '\p{Line_Break=:\AClose_Punctuation\z:}', "");;
    Expect(0, 83408, '\p{Line_Break=:\AClose_Punctuation\z:}', "");;
    Expect(1, 83407, '\p{Line_Break=closepunctuation}', "");
    Expect(0, 83407, '\p{^Line_Break=closepunctuation}', "");
    Expect(0, 83407, '\P{Line_Break=closepunctuation}', "");
    Expect(1, 83407, '\P{^Line_Break=closepunctuation}', "");
    Expect(0, 83408, '\p{Line_Break=closepunctuation}', "");
    Expect(1, 83408, '\p{^Line_Break=closepunctuation}', "");
    Expect(1, 83408, '\P{Line_Break=closepunctuation}', "");
    Expect(0, 83408, '\P{^Line_Break=closepunctuation}', "");
    Expect(1, 83407, '\p{Line_Break=:\Aclosepunctuation\z:}', "");;
    Expect(0, 83408, '\p{Line_Break=:\Aclosepunctuation\z:}', "");;
    Expect(1, 83407, '\p{Line_Break=-	CLOSE_Punctuation}', "");
    Expect(0, 83407, '\p{^Line_Break=-	CLOSE_Punctuation}', "");
    Expect(0, 83407, '\P{Line_Break=-	CLOSE_Punctuation}', "");
    Expect(1, 83407, '\P{^Line_Break=-	CLOSE_Punctuation}', "");
    Expect(0, 83408, '\p{Line_Break=-	CLOSE_Punctuation}', "");
    Expect(1, 83408, '\p{^Line_Break=-	CLOSE_Punctuation}', "");
    Expect(1, 83408, '\P{Line_Break=-	CLOSE_Punctuation}', "");
    Expect(0, 83408, '\P{^Line_Break=-	CLOSE_Punctuation}', "");
    Error('\p{Lb=/a/	CL}');
    Error('\P{Lb=/a/	CL}');
    Expect(1, 83407, '\p{Lb=:\ACL\z:}', "");;
    Expect(0, 83408, '\p{Lb=:\ACL\z:}', "");;
    Expect(1, 83407, '\p{Lb=cl}', "");
    Expect(0, 83407, '\p{^Lb=cl}', "");
    Expect(0, 83407, '\P{Lb=cl}', "");
    Expect(1, 83407, '\P{^Lb=cl}', "");
    Expect(0, 83408, '\p{Lb=cl}', "");
    Expect(1, 83408, '\p{^Lb=cl}', "");
    Expect(1, 83408, '\P{Lb=cl}', "");
    Expect(0, 83408, '\P{^Lb=cl}', "");
    Expect(1, 83407, '\p{Lb=:\Acl\z:}', "");;
    Expect(0, 83408, '\p{Lb=:\Acl\z:}', "");;
    Expect(1, 83407, '\p{Lb:   -CL}', "");
    Expect(0, 83407, '\p{^Lb:   -CL}', "");
    Expect(0, 83407, '\P{Lb:   -CL}', "");
    Expect(1, 83407, '\P{^Lb:   -CL}', "");
    Expect(0, 83408, '\p{Lb:   -CL}', "");
    Expect(1, 83408, '\p{^Lb:   -CL}', "");
    Expect(1, 83408, '\P{Lb:   -CL}', "");
    Expect(0, 83408, '\P{^Lb:   -CL}', "");
    Error('\p{Is_Line_Break=/a/CLOSE_PUNCTUATION}');
    Error('\P{Is_Line_Break=/a/CLOSE_PUNCTUATION}');
    Expect(1, 83407, '\p{Is_Line_Break=closepunctuation}', "");
    Expect(0, 83407, '\p{^Is_Line_Break=closepunctuation}', "");
    Expect(0, 83407, '\P{Is_Line_Break=closepunctuation}', "");
    Expect(1, 83407, '\P{^Is_Line_Break=closepunctuation}', "");
    Expect(0, 83408, '\p{Is_Line_Break=closepunctuation}', "");
    Expect(1, 83408, '\p{^Is_Line_Break=closepunctuation}', "");
    Expect(1, 83408, '\P{Is_Line_Break=closepunctuation}', "");
    Expect(0, 83408, '\P{^Is_Line_Break=closepunctuation}', "");
    Expect(1, 83407, '\p{Is_Line_Break=-CLOSE_punctuation}', "");
    Expect(0, 83407, '\p{^Is_Line_Break=-CLOSE_punctuation}', "");
    Expect(0, 83407, '\P{Is_Line_Break=-CLOSE_punctuation}', "");
    Expect(1, 83407, '\P{^Is_Line_Break=-CLOSE_punctuation}', "");
    Expect(0, 83408, '\p{Is_Line_Break=-CLOSE_punctuation}', "");
    Expect(1, 83408, '\p{^Is_Line_Break=-CLOSE_punctuation}', "");
    Expect(1, 83408, '\P{Is_Line_Break=-CLOSE_punctuation}', "");
    Expect(0, 83408, '\P{^Is_Line_Break=-CLOSE_punctuation}', "");
    Error('\p{Is_Lb: 		cl:=}');
    Error('\P{Is_Lb: 		cl:=}');
    Expect(1, 83407, '\p{Is_Lb=cl}', "");
    Expect(0, 83407, '\p{^Is_Lb=cl}', "");
    Expect(0, 83407, '\P{Is_Lb=cl}', "");
    Expect(1, 83407, '\P{^Is_Lb=cl}', "");
    Expect(0, 83408, '\p{Is_Lb=cl}', "");
    Expect(1, 83408, '\p{^Is_Lb=cl}', "");
    Expect(1, 83408, '\P{Is_Lb=cl}', "");
    Expect(0, 83408, '\P{^Is_Lb=cl}', "");
    Expect(1, 83407, '\p{Is_Lb=	-CL}', "");
    Expect(0, 83407, '\p{^Is_Lb=	-CL}', "");
    Expect(0, 83407, '\P{Is_Lb=	-CL}', "");
    Expect(1, 83407, '\P{^Is_Lb=	-CL}', "");
    Expect(0, 83408, '\p{Is_Lb=	-CL}', "");
    Expect(1, 83408, '\p{^Is_Lb=	-CL}', "");
    Expect(1, 83408, '\P{Is_Lb=	-CL}', "");
    Expect(0, 83408, '\P{^Is_Lb=	-CL}', "");
    Error('\p{Line_Break=:=_-Combining_MARK}');
    Error('\P{Line_Break=:=_-Combining_MARK}');
    Expect(1, 917999, '\p{Line_Break=:\ACombining_Mark\z:}', "");;
    Expect(0, 918000, '\p{Line_Break=:\ACombining_Mark\z:}', "");;
    Expect(1, 917999, '\p{Line_Break=combiningmark}', "");
    Expect(0, 917999, '\p{^Line_Break=combiningmark}', "");
    Expect(0, 917999, '\P{Line_Break=combiningmark}', "");
    Expect(1, 917999, '\P{^Line_Break=combiningmark}', "");
    Expect(0, 918000, '\p{Line_Break=combiningmark}', "");
    Expect(1, 918000, '\p{^Line_Break=combiningmark}', "");
    Expect(1, 918000, '\P{Line_Break=combiningmark}', "");
    Expect(0, 918000, '\P{^Line_Break=combiningmark}', "");
    Expect(1, 917999, '\p{Line_Break=:\Acombiningmark\z:}', "");;
    Expect(0, 918000, '\p{Line_Break=:\Acombiningmark\z:}', "");;
    Expect(1, 917999, '\p{Line_Break= COMBINING_MARK}', "");
    Expect(0, 917999, '\p{^Line_Break= COMBINING_MARK}', "");
    Expect(0, 917999, '\P{Line_Break= COMBINING_MARK}', "");
    Expect(1, 917999, '\P{^Line_Break= COMBINING_MARK}', "");
    Expect(0, 918000, '\p{Line_Break= COMBINING_MARK}', "");
    Expect(1, 918000, '\p{^Line_Break= COMBINING_MARK}', "");
    Expect(1, 918000, '\P{Line_Break= COMBINING_MARK}', "");
    Expect(0, 918000, '\P{^Line_Break= COMBINING_MARK}', "");
    Error('\p{Lb=_ CM/a/}');
    Error('\P{Lb=_ CM/a/}');
    Expect(1, 917999, '\p{Lb=:\ACM\z:}', "");;
    Expect(0, 918000, '\p{Lb=:\ACM\z:}', "");;
    Expect(1, 917999, '\p{Lb=cm}', "");
    Expect(0, 917999, '\p{^Lb=cm}', "");
    Expect(0, 917999, '\P{Lb=cm}', "");
    Expect(1, 917999, '\P{^Lb=cm}', "");
    Expect(0, 918000, '\p{Lb=cm}', "");
    Expect(1, 918000, '\p{^Lb=cm}', "");
    Expect(1, 918000, '\P{Lb=cm}', "");
    Expect(0, 918000, '\P{^Lb=cm}', "");
    Expect(1, 917999, '\p{Lb=:\Acm\z:}', "");;
    Expect(0, 918000, '\p{Lb=:\Acm\z:}', "");;
    Expect(1, 917999, '\p{Lb= -CM}', "");
    Expect(0, 917999, '\p{^Lb= -CM}', "");
    Expect(0, 917999, '\P{Lb= -CM}', "");
    Expect(1, 917999, '\P{^Lb= -CM}', "");
    Expect(0, 918000, '\p{Lb= -CM}', "");
    Expect(1, 918000, '\p{^Lb= -CM}', "");
    Expect(1, 918000, '\P{Lb= -CM}', "");
    Expect(0, 918000, '\P{^Lb= -CM}', "");
    Error('\p{Is_Line_Break=_/a/Combining_Mark}');
    Error('\P{Is_Line_Break=_/a/Combining_Mark}');
    Expect(1, 917999, '\p{Is_Line_Break=combiningmark}', "");
    Expect(0, 917999, '\p{^Is_Line_Break=combiningmark}', "");
    Expect(0, 917999, '\P{Is_Line_Break=combiningmark}', "");
    Expect(1, 917999, '\P{^Is_Line_Break=combiningmark}', "");
    Expect(0, 918000, '\p{Is_Line_Break=combiningmark}', "");
    Expect(1, 918000, '\p{^Is_Line_Break=combiningmark}', "");
    Expect(1, 918000, '\P{Is_Line_Break=combiningmark}', "");
    Expect(0, 918000, '\P{^Is_Line_Break=combiningmark}', "");
    Expect(1, 917999, '\p{Is_Line_Break=_Combining_Mark}', "");
    Expect(0, 917999, '\p{^Is_Line_Break=_Combining_Mark}', "");
    Expect(0, 917999, '\P{Is_Line_Break=_Combining_Mark}', "");
    Expect(1, 917999, '\P{^Is_Line_Break=_Combining_Mark}', "");
    Expect(0, 918000, '\p{Is_Line_Break=_Combining_Mark}', "");
    Expect(1, 918000, '\p{^Is_Line_Break=_Combining_Mark}', "");
    Expect(1, 918000, '\P{Is_Line_Break=_Combining_Mark}', "");
    Expect(0, 918000, '\P{^Is_Line_Break=_Combining_Mark}', "");
    Error('\p{Is_Lb=/a/	CM}');
    Error('\P{Is_Lb=/a/	CM}');
    Expect(1, 917999, '\p{Is_Lb=cm}', "");
    Expect(0, 917999, '\p{^Is_Lb=cm}', "");
    Expect(0, 917999, '\P{Is_Lb=cm}', "");
    Expect(1, 917999, '\P{^Is_Lb=cm}', "");
    Expect(0, 918000, '\p{Is_Lb=cm}', "");
    Expect(1, 918000, '\p{^Is_Lb=cm}', "");
    Expect(1, 918000, '\P{Is_Lb=cm}', "");
    Expect(0, 918000, '\P{^Is_Lb=cm}', "");
    Expect(1, 917999, '\p{Is_Lb=	-CM}', "");
    Expect(0, 917999, '\p{^Is_Lb=	-CM}', "");
    Expect(0, 917999, '\P{Is_Lb=	-CM}', "");
    Expect(1, 917999, '\P{^Is_Lb=	-CM}', "");
    Expect(0, 918000, '\p{Is_Lb=	-CM}', "");
    Expect(1, 918000, '\p{^Is_Lb=	-CM}', "");
    Expect(1, 918000, '\P{Is_Lb=	-CM}', "");
    Expect(0, 918000, '\P{^Is_Lb=	-CM}', "");
    Error('\p{Line_Break:	_ Close_parenthesis/a/}');
    Error('\P{Line_Break:	_ Close_parenthesis/a/}');
    Expect(1, 93, '\p{Line_Break=:\AClose_Parenthesis\z:}', "");;
    Expect(0, 94, '\p{Line_Break=:\AClose_Parenthesis\z:}', "");;
    Expect(1, 93, '\p{Line_Break=closeparenthesis}', "");
    Expect(0, 93, '\p{^Line_Break=closeparenthesis}', "");
    Expect(0, 93, '\P{Line_Break=closeparenthesis}', "");
    Expect(1, 93, '\P{^Line_Break=closeparenthesis}', "");
    Expect(0, 94, '\p{Line_Break=closeparenthesis}', "");
    Expect(1, 94, '\p{^Line_Break=closeparenthesis}', "");
    Expect(1, 94, '\P{Line_Break=closeparenthesis}', "");
    Expect(0, 94, '\P{^Line_Break=closeparenthesis}', "");
    Expect(1, 93, '\p{Line_Break=:\Acloseparenthesis\z:}', "");;
    Expect(0, 94, '\p{Line_Break=:\Acloseparenthesis\z:}', "");;
    Expect(1, 93, '\p{Line_Break=--CLOSE_Parenthesis}', "");
    Expect(0, 93, '\p{^Line_Break=--CLOSE_Parenthesis}', "");
    Expect(0, 93, '\P{Line_Break=--CLOSE_Parenthesis}', "");
    Expect(1, 93, '\P{^Line_Break=--CLOSE_Parenthesis}', "");
    Expect(0, 94, '\p{Line_Break=--CLOSE_Parenthesis}', "");
    Expect(1, 94, '\p{^Line_Break=--CLOSE_Parenthesis}', "");
    Expect(1, 94, '\P{Line_Break=--CLOSE_Parenthesis}', "");
    Expect(0, 94, '\P{^Line_Break=--CLOSE_Parenthesis}', "");
    Error('\p{Lb=-_CP/a/}');
    Error('\P{Lb=-_CP/a/}');
    Expect(1, 93, '\p{Lb=:\ACP\z:}', "");;
    Expect(0, 94, '\p{Lb=:\ACP\z:}', "");;
    Expect(1, 93, '\p{Lb=cp}', "");
    Expect(0, 93, '\p{^Lb=cp}', "");
    Expect(0, 93, '\P{Lb=cp}', "");
    Expect(1, 93, '\P{^Lb=cp}', "");
    Expect(0, 94, '\p{Lb=cp}', "");
    Expect(1, 94, '\p{^Lb=cp}', "");
    Expect(1, 94, '\P{Lb=cp}', "");
    Expect(0, 94, '\P{^Lb=cp}', "");
    Expect(1, 93, '\p{Lb=:\Acp\z:}', "");;
    Expect(0, 94, '\p{Lb=:\Acp\z:}', "");;
    Expect(1, 93, '\p{Lb=-cp}', "");
    Expect(0, 93, '\p{^Lb=-cp}', "");
    Expect(0, 93, '\P{Lb=-cp}', "");
    Expect(1, 93, '\P{^Lb=-cp}', "");
    Expect(0, 94, '\p{Lb=-cp}', "");
    Expect(1, 94, '\p{^Lb=-cp}', "");
    Expect(1, 94, '\P{Lb=-cp}', "");
    Expect(0, 94, '\P{^Lb=-cp}', "");
    Error('\p{Is_Line_Break=_	Close_Parenthesis:=}');
    Error('\P{Is_Line_Break=_	Close_Parenthesis:=}');
    Expect(1, 93, '\p{Is_Line_Break=closeparenthesis}', "");
    Expect(0, 93, '\p{^Is_Line_Break=closeparenthesis}', "");
    Expect(0, 93, '\P{Is_Line_Break=closeparenthesis}', "");
    Expect(1, 93, '\P{^Is_Line_Break=closeparenthesis}', "");
    Expect(0, 94, '\p{Is_Line_Break=closeparenthesis}', "");
    Expect(1, 94, '\p{^Is_Line_Break=closeparenthesis}', "");
    Expect(1, 94, '\P{Is_Line_Break=closeparenthesis}', "");
    Expect(0, 94, '\P{^Is_Line_Break=closeparenthesis}', "");
    Expect(1, 93, '\p{Is_Line_Break=	 CLOSE_PARENTHESIS}', "");
    Expect(0, 93, '\p{^Is_Line_Break=	 CLOSE_PARENTHESIS}', "");
    Expect(0, 93, '\P{Is_Line_Break=	 CLOSE_PARENTHESIS}', "");
    Expect(1, 93, '\P{^Is_Line_Break=	 CLOSE_PARENTHESIS}', "");
    Expect(0, 94, '\p{Is_Line_Break=	 CLOSE_PARENTHESIS}', "");
    Expect(1, 94, '\p{^Is_Line_Break=	 CLOSE_PARENTHESIS}', "");
    Expect(1, 94, '\P{Is_Line_Break=	 CLOSE_PARENTHESIS}', "");
    Expect(0, 94, '\P{^Is_Line_Break=	 CLOSE_PARENTHESIS}', "");
    Error('\p{Is_Lb=:=-cp}');
    Error('\P{Is_Lb=:=-cp}');
    Expect(1, 93, '\p{Is_Lb=cp}', "");
    Expect(0, 93, '\p{^Is_Lb=cp}', "");
    Expect(0, 93, '\P{Is_Lb=cp}', "");
    Expect(1, 93, '\P{^Is_Lb=cp}', "");
    Expect(0, 94, '\p{Is_Lb=cp}', "");
    Expect(1, 94, '\p{^Is_Lb=cp}', "");
    Expect(1, 94, '\P{Is_Lb=cp}', "");
    Expect(0, 94, '\P{^Is_Lb=cp}', "");
    Expect(1, 93, '\p{Is_Lb=_ cp}', "");
    Expect(0, 93, '\p{^Is_Lb=_ cp}', "");
    Expect(0, 93, '\P{Is_Lb=_ cp}', "");
    Expect(1, 93, '\P{^Is_Lb=_ cp}', "");
    Expect(0, 94, '\p{Is_Lb=_ cp}', "");
    Expect(1, 94, '\p{^Is_Lb=_ cp}', "");
    Expect(1, 94, '\P{Is_Lb=_ cp}', "");
    Expect(0, 94, '\P{^Is_Lb=_ cp}', "");
    Error('\p{Line_Break=	/a/carriage_Return}');
    Error('\P{Line_Break=	/a/carriage_Return}');
    Expect(1, 13, '\p{Line_Break=:\ACarriage_Return\z:}', "");;
    Expect(0, 14, '\p{Line_Break=:\ACarriage_Return\z:}', "");;
    Expect(1, 13, '\p{Line_Break=carriagereturn}', "");
    Expect(0, 13, '\p{^Line_Break=carriagereturn}', "");
    Expect(0, 13, '\P{Line_Break=carriagereturn}', "");
    Expect(1, 13, '\P{^Line_Break=carriagereturn}', "");
    Expect(0, 14, '\p{Line_Break=carriagereturn}', "");
    Expect(1, 14, '\p{^Line_Break=carriagereturn}', "");
    Expect(1, 14, '\P{Line_Break=carriagereturn}', "");
    Expect(0, 14, '\P{^Line_Break=carriagereturn}', "");
    Expect(1, 13, '\p{Line_Break=:\Acarriagereturn\z:}', "");;
    Expect(0, 14, '\p{Line_Break=:\Acarriagereturn\z:}', "");;
    Expect(1, 13, '\p{Line_Break=	_CARRIAGE_RETURN}', "");
    Expect(0, 13, '\p{^Line_Break=	_CARRIAGE_RETURN}', "");
    Expect(0, 13, '\P{Line_Break=	_CARRIAGE_RETURN}', "");
    Expect(1, 13, '\P{^Line_Break=	_CARRIAGE_RETURN}', "");
    Expect(0, 14, '\p{Line_Break=	_CARRIAGE_RETURN}', "");
    Expect(1, 14, '\p{^Line_Break=	_CARRIAGE_RETURN}', "");
    Expect(1, 14, '\P{Line_Break=	_CARRIAGE_RETURN}', "");
    Expect(0, 14, '\P{^Line_Break=	_CARRIAGE_RETURN}', "");
    Error('\p{Lb=- CR:=}');
    Error('\P{Lb=- CR:=}');
    Expect(1, 13, '\p{Lb=:\ACR\z:}', "");;
    Expect(0, 14, '\p{Lb=:\ACR\z:}', "");;
    Expect(1, 13, '\p{Lb=cr}', "");
    Expect(0, 13, '\p{^Lb=cr}', "");
    Expect(0, 13, '\P{Lb=cr}', "");
    Expect(1, 13, '\P{^Lb=cr}', "");
    Expect(0, 14, '\p{Lb=cr}', "");
    Expect(1, 14, '\p{^Lb=cr}', "");
    Expect(1, 14, '\P{Lb=cr}', "");
    Expect(0, 14, '\P{^Lb=cr}', "");
    Expect(1, 13, '\p{Lb=:\Acr\z:}', "");;
    Expect(0, 14, '\p{Lb=:\Acr\z:}', "");;
    Expect(1, 13, '\p{Lb=  CR}', "");
    Expect(0, 13, '\p{^Lb=  CR}', "");
    Expect(0, 13, '\P{Lb=  CR}', "");
    Expect(1, 13, '\P{^Lb=  CR}', "");
    Expect(0, 14, '\p{Lb=  CR}', "");
    Expect(1, 14, '\p{^Lb=  CR}', "");
    Expect(1, 14, '\P{Lb=  CR}', "");
    Expect(0, 14, '\P{^Lb=  CR}', "");
    Error('\p{Is_Line_Break= _Carriage_Return:=}');
    Error('\P{Is_Line_Break= _Carriage_Return:=}');
    Expect(1, 13, '\p{Is_Line_Break=carriagereturn}', "");
    Expect(0, 13, '\p{^Is_Line_Break=carriagereturn}', "");
    Expect(0, 13, '\P{Is_Line_Break=carriagereturn}', "");
    Expect(1, 13, '\P{^Is_Line_Break=carriagereturn}', "");
    Expect(0, 14, '\p{Is_Line_Break=carriagereturn}', "");
    Expect(1, 14, '\p{^Is_Line_Break=carriagereturn}', "");
    Expect(1, 14, '\P{Is_Line_Break=carriagereturn}', "");
    Expect(0, 14, '\P{^Is_Line_Break=carriagereturn}', "");
    Expect(1, 13, '\p{Is_Line_Break=-	Carriage_Return}', "");
    Expect(0, 13, '\p{^Is_Line_Break=-	Carriage_Return}', "");
    Expect(0, 13, '\P{Is_Line_Break=-	Carriage_Return}', "");
    Expect(1, 13, '\P{^Is_Line_Break=-	Carriage_Return}', "");
    Expect(0, 14, '\p{Is_Line_Break=-	Carriage_Return}', "");
    Expect(1, 14, '\p{^Is_Line_Break=-	Carriage_Return}', "");
    Expect(1, 14, '\P{Is_Line_Break=-	Carriage_Return}', "");
    Expect(0, 14, '\P{^Is_Line_Break=-	Carriage_Return}', "");
    Error('\p{Is_Lb=	:=CR}');
    Error('\P{Is_Lb=	:=CR}');
    Expect(1, 13, '\p{Is_Lb=cr}', "");
    Expect(0, 13, '\p{^Is_Lb=cr}', "");
    Expect(0, 13, '\P{Is_Lb=cr}', "");
    Expect(1, 13, '\P{^Is_Lb=cr}', "");
    Expect(0, 14, '\p{Is_Lb=cr}', "");
    Expect(1, 14, '\p{^Is_Lb=cr}', "");
    Expect(1, 14, '\P{Is_Lb=cr}', "");
    Expect(0, 14, '\P{^Is_Lb=cr}', "");
    Expect(1, 13, '\p{Is_Lb= cr}', "");
    Expect(0, 13, '\p{^Is_Lb= cr}', "");
    Expect(0, 13, '\P{Is_Lb= cr}', "");
    Expect(1, 13, '\P{^Is_Lb= cr}', "");
    Expect(0, 14, '\p{Is_Lb= cr}', "");
    Expect(1, 14, '\p{^Is_Lb= cr}', "");
    Expect(1, 14, '\P{Is_Lb= cr}', "");
    Expect(0, 14, '\P{^Is_Lb= cr}', "");
    Error('\p{Line_Break:   /a/-E_Base}');
    Error('\P{Line_Break:   /a/-E_Base}');
    Expect(1, 129501, '\p{Line_Break=:\AE_Base\z:}', "");;
    Expect(0, 129502, '\p{Line_Break=:\AE_Base\z:}', "");;
    Expect(1, 129501, '\p{Line_Break=ebase}', "");
    Expect(0, 129501, '\p{^Line_Break=ebase}', "");
    Expect(0, 129501, '\P{Line_Break=ebase}', "");
    Expect(1, 129501, '\P{^Line_Break=ebase}', "");
    Expect(0, 129502, '\p{Line_Break=ebase}', "");
    Expect(1, 129502, '\p{^Line_Break=ebase}', "");
    Expect(1, 129502, '\P{Line_Break=ebase}', "");
    Expect(0, 129502, '\P{^Line_Break=ebase}', "");
    Expect(1, 129501, '\p{Line_Break=:\Aebase\z:}', "");;
    Expect(0, 129502, '\p{Line_Break=:\Aebase\z:}', "");;
    Expect(1, 129501, '\p{Line_Break=-E_Base}', "");
    Expect(0, 129501, '\p{^Line_Break=-E_Base}', "");
    Expect(0, 129501, '\P{Line_Break=-E_Base}', "");
    Expect(1, 129501, '\P{^Line_Break=-E_Base}', "");
    Expect(0, 129502, '\p{Line_Break=-E_Base}', "");
    Expect(1, 129502, '\p{^Line_Break=-E_Base}', "");
    Expect(1, 129502, '\P{Line_Break=-E_Base}', "");
    Expect(0, 129502, '\P{^Line_Break=-E_Base}', "");
    Error('\p{Lb=:=_ eb}');
    Error('\P{Lb=:=_ eb}');
    Expect(1, 129501, '\p{Lb=:\AEB\z:}', "");;
    Expect(0, 129502, '\p{Lb=:\AEB\z:}', "");;
    Expect(1, 129501, '\p{Lb=eb}', "");
    Expect(0, 129501, '\p{^Lb=eb}', "");
    Expect(0, 129501, '\P{Lb=eb}', "");
    Expect(1, 129501, '\P{^Lb=eb}', "");
    Expect(0, 129502, '\p{Lb=eb}', "");
    Expect(1, 129502, '\p{^Lb=eb}', "");
    Expect(1, 129502, '\P{Lb=eb}', "");
    Expect(0, 129502, '\P{^Lb=eb}', "");
    Expect(1, 129501, '\p{Lb=:\Aeb\z:}', "");;
    Expect(0, 129502, '\p{Lb=:\Aeb\z:}', "");;
    Expect(1, 129501, '\p{Lb=--EB}', "");
    Expect(0, 129501, '\p{^Lb=--EB}', "");
    Expect(0, 129501, '\P{Lb=--EB}', "");
    Expect(1, 129501, '\P{^Lb=--EB}', "");
    Expect(0, 129502, '\p{Lb=--EB}', "");
    Expect(1, 129502, '\p{^Lb=--EB}', "");
    Expect(1, 129502, '\P{Lb=--EB}', "");
    Expect(0, 129502, '\P{^Lb=--EB}', "");
    Error('\p{Is_Line_Break= 	e_Base/a/}');
    Error('\P{Is_Line_Break= 	e_Base/a/}');
    Expect(1, 129501, '\p{Is_Line_Break=ebase}', "");
    Expect(0, 129501, '\p{^Is_Line_Break=ebase}', "");
    Expect(0, 129501, '\P{Is_Line_Break=ebase}', "");
    Expect(1, 129501, '\P{^Is_Line_Break=ebase}', "");
    Expect(0, 129502, '\p{Is_Line_Break=ebase}', "");
    Expect(1, 129502, '\p{^Is_Line_Break=ebase}', "");
    Expect(1, 129502, '\P{Is_Line_Break=ebase}', "");
    Expect(0, 129502, '\P{^Is_Line_Break=ebase}', "");
    Expect(1, 129501, '\p{Is_Line_Break=-_E_BASE}', "");
    Expect(0, 129501, '\p{^Is_Line_Break=-_E_BASE}', "");
    Expect(0, 129501, '\P{Is_Line_Break=-_E_BASE}', "");
    Expect(1, 129501, '\P{^Is_Line_Break=-_E_BASE}', "");
    Expect(0, 129502, '\p{Is_Line_Break=-_E_BASE}', "");
    Expect(1, 129502, '\p{^Is_Line_Break=-_E_BASE}', "");
    Expect(1, 129502, '\P{Is_Line_Break=-_E_BASE}', "");
    Expect(0, 129502, '\P{^Is_Line_Break=-_E_BASE}', "");
    Error('\p{Is_Lb=/a/_	EB}');
    Error('\P{Is_Lb=/a/_	EB}');
    Expect(1, 129501, '\p{Is_Lb=eb}', "");
    Expect(0, 129501, '\p{^Is_Lb=eb}', "");
    Expect(0, 129501, '\P{Is_Lb=eb}', "");
    Expect(1, 129501, '\P{^Is_Lb=eb}', "");
    Expect(0, 129502, '\p{Is_Lb=eb}', "");
    Expect(1, 129502, '\p{^Is_Lb=eb}', "");
    Expect(1, 129502, '\P{Is_Lb=eb}', "");
    Expect(0, 129502, '\P{^Is_Lb=eb}', "");
    Expect(1, 129501, '\p{Is_Lb=--eb}', "");
    Expect(0, 129501, '\p{^Is_Lb=--eb}', "");
    Expect(0, 129501, '\P{Is_Lb=--eb}', "");
    Expect(1, 129501, '\P{^Is_Lb=--eb}', "");
    Expect(0, 129502, '\p{Is_Lb=--eb}', "");
    Expect(1, 129502, '\p{^Is_Lb=--eb}', "");
    Expect(1, 129502, '\P{Is_Lb=--eb}', "");
    Expect(0, 129502, '\P{^Is_Lb=--eb}', "");
    Error('\p{Line_Break=E_Modifier:=}');
    Error('\P{Line_Break=E_Modifier:=}');
    Expect(1, 127999, '\p{Line_Break=:\AE_Modifier\z:}', "");;
    Expect(0, 128000, '\p{Line_Break=:\AE_Modifier\z:}', "");;
    Expect(1, 127999, '\p{Line_Break=emodifier}', "");
    Expect(0, 127999, '\p{^Line_Break=emodifier}', "");
    Expect(0, 127999, '\P{Line_Break=emodifier}', "");
    Expect(1, 127999, '\P{^Line_Break=emodifier}', "");
    Expect(0, 128000, '\p{Line_Break=emodifier}', "");
    Expect(1, 128000, '\p{^Line_Break=emodifier}', "");
    Expect(1, 128000, '\P{Line_Break=emodifier}', "");
    Expect(0, 128000, '\P{^Line_Break=emodifier}', "");
    Expect(1, 127999, '\p{Line_Break=:\Aemodifier\z:}', "");;
    Expect(0, 128000, '\p{Line_Break=:\Aemodifier\z:}', "");;
    Expect(1, 127999, '\p{Line_Break: -E_Modifier}', "");
    Expect(0, 127999, '\p{^Line_Break: -E_Modifier}', "");
    Expect(0, 127999, '\P{Line_Break: -E_Modifier}', "");
    Expect(1, 127999, '\P{^Line_Break: -E_Modifier}', "");
    Expect(0, 128000, '\p{Line_Break: -E_Modifier}', "");
    Expect(1, 128000, '\p{^Line_Break: -E_Modifier}', "");
    Expect(1, 128000, '\P{Line_Break: -E_Modifier}', "");
    Expect(0, 128000, '\P{^Line_Break: -E_Modifier}', "");
    Error('\p{Lb=/a/__EM}');
    Error('\P{Lb=/a/__EM}');
    Expect(1, 127999, '\p{Lb=:\AEM\z:}', "");;
    Expect(0, 128000, '\p{Lb=:\AEM\z:}', "");;
    Expect(1, 127999, '\p{Lb=em}', "");
    Expect(0, 127999, '\p{^Lb=em}', "");
    Expect(0, 127999, '\P{Lb=em}', "");
    Expect(1, 127999, '\P{^Lb=em}', "");
    Expect(0, 128000, '\p{Lb=em}', "");
    Expect(1, 128000, '\p{^Lb=em}', "");
    Expect(1, 128000, '\P{Lb=em}', "");
    Expect(0, 128000, '\P{^Lb=em}', "");
    Expect(1, 127999, '\p{Lb=:\Aem\z:}', "");;
    Expect(0, 128000, '\p{Lb=:\Aem\z:}', "");;
    Expect(1, 127999, '\p{Lb=-EM}', "");
    Expect(0, 127999, '\p{^Lb=-EM}', "");
    Expect(0, 127999, '\P{Lb=-EM}', "");
    Expect(1, 127999, '\P{^Lb=-EM}', "");
    Expect(0, 128000, '\p{Lb=-EM}', "");
    Expect(1, 128000, '\p{^Lb=-EM}', "");
    Expect(1, 128000, '\P{Lb=-EM}', "");
    Expect(0, 128000, '\P{^Lb=-EM}', "");
    Error('\p{Is_Line_Break=_	E_MODIFIER:=}');
    Error('\P{Is_Line_Break=_	E_MODIFIER:=}');
    Expect(1, 127999, '\p{Is_Line_Break=emodifier}', "");
    Expect(0, 127999, '\p{^Is_Line_Break=emodifier}', "");
    Expect(0, 127999, '\P{Is_Line_Break=emodifier}', "");
    Expect(1, 127999, '\P{^Is_Line_Break=emodifier}', "");
    Expect(0, 128000, '\p{Is_Line_Break=emodifier}', "");
    Expect(1, 128000, '\p{^Is_Line_Break=emodifier}', "");
    Expect(1, 128000, '\P{Is_Line_Break=emodifier}', "");
    Expect(0, 128000, '\P{^Is_Line_Break=emodifier}', "");
    Expect(1, 127999, '\p{Is_Line_Break=-	e_modifier}', "");
    Expect(0, 127999, '\p{^Is_Line_Break=-	e_modifier}', "");
    Expect(0, 127999, '\P{Is_Line_Break=-	e_modifier}', "");
    Expect(1, 127999, '\P{^Is_Line_Break=-	e_modifier}', "");
    Expect(0, 128000, '\p{Is_Line_Break=-	e_modifier}', "");
    Expect(1, 128000, '\p{^Is_Line_Break=-	e_modifier}', "");
    Expect(1, 128000, '\P{Is_Line_Break=-	e_modifier}', "");
    Expect(0, 128000, '\P{^Is_Line_Break=-	e_modifier}', "");
    Error('\p{Is_Lb=/a/-EM}');
    Error('\P{Is_Lb=/a/-EM}');
    Expect(1, 127999, '\p{Is_Lb=em}', "");
    Expect(0, 127999, '\p{^Is_Lb=em}', "");
    Expect(0, 127999, '\P{Is_Lb=em}', "");
    Expect(1, 127999, '\P{^Is_Lb=em}', "");
    Expect(0, 128000, '\p{Is_Lb=em}', "");
    Expect(1, 128000, '\p{^Is_Lb=em}', "");
    Expect(1, 128000, '\P{Is_Lb=em}', "");
    Expect(0, 128000, '\P{^Is_Lb=em}', "");
    Expect(1, 127999, '\p{Is_Lb= EM}', "");
    Expect(0, 127999, '\p{^Is_Lb= EM}', "");
    Expect(0, 127999, '\P{Is_Lb= EM}', "");
    Expect(1, 127999, '\P{^Is_Lb= EM}', "");
    Expect(0, 128000, '\p{Is_Lb= EM}', "");
    Expect(1, 128000, '\p{^Is_Lb= EM}', "");
    Expect(1, 128000, '\P{Is_Lb= EM}', "");
    Expect(0, 128000, '\P{^Is_Lb= EM}', "");
    Error('\p{Line_Break=:=	EXCLAMATION}');
    Error('\P{Line_Break=:=	EXCLAMATION}');
    Expect(1, 72817, '\p{Line_Break=:\AExclamation\z:}', "");;
    Expect(0, 72818, '\p{Line_Break=:\AExclamation\z:}', "");;
    Expect(1, 72817, '\p{Line_Break:   exclamation}', "");
    Expect(0, 72817, '\p{^Line_Break:   exclamation}', "");
    Expect(0, 72817, '\P{Line_Break:   exclamation}', "");
    Expect(1, 72817, '\P{^Line_Break:   exclamation}', "");
    Expect(0, 72818, '\p{Line_Break:   exclamation}', "");
    Expect(1, 72818, '\p{^Line_Break:   exclamation}', "");
    Expect(1, 72818, '\P{Line_Break:   exclamation}', "");
    Expect(0, 72818, '\P{^Line_Break:   exclamation}', "");
    Expect(1, 72817, '\p{Line_Break=:\Aexclamation\z:}', "");;
    Expect(0, 72818, '\p{Line_Break=:\Aexclamation\z:}', "");;
    Expect(1, 72817, '\p{Line_Break:   Exclamation}', "");
    Expect(0, 72817, '\p{^Line_Break:   Exclamation}', "");
    Expect(0, 72817, '\P{Line_Break:   Exclamation}', "");
    Expect(1, 72817, '\P{^Line_Break:   Exclamation}', "");
    Expect(0, 72818, '\p{Line_Break:   Exclamation}', "");
    Expect(1, 72818, '\p{^Line_Break:   Exclamation}', "");
    Expect(1, 72818, '\P{Line_Break:   Exclamation}', "");
    Expect(0, 72818, '\P{^Line_Break:   Exclamation}', "");
    Error('\p{Lb=:=-EX}');
    Error('\P{Lb=:=-EX}');
    Expect(1, 72817, '\p{Lb=:\AEX\z:}', "");;
    Expect(0, 72818, '\p{Lb=:\AEX\z:}', "");;
    Expect(1, 72817, '\p{Lb=ex}', "");
    Expect(0, 72817, '\p{^Lb=ex}', "");
    Expect(0, 72817, '\P{Lb=ex}', "");
    Expect(1, 72817, '\P{^Lb=ex}', "");
    Expect(0, 72818, '\p{Lb=ex}', "");
    Expect(1, 72818, '\p{^Lb=ex}', "");
    Expect(1, 72818, '\P{Lb=ex}', "");
    Expect(0, 72818, '\P{^Lb=ex}', "");
    Expect(1, 72817, '\p{Lb=:\Aex\z:}', "");;
    Expect(0, 72818, '\p{Lb=:\Aex\z:}', "");;
    Expect(1, 72817, '\p{Lb=- EX}', "");
    Expect(0, 72817, '\p{^Lb=- EX}', "");
    Expect(0, 72817, '\P{Lb=- EX}', "");
    Expect(1, 72817, '\P{^Lb=- EX}', "");
    Expect(0, 72818, '\p{Lb=- EX}', "");
    Expect(1, 72818, '\p{^Lb=- EX}', "");
    Expect(1, 72818, '\P{Lb=- EX}', "");
    Expect(0, 72818, '\P{^Lb=- EX}', "");
    Error('\p{Is_Line_Break=EXCLAMATION:=}');
    Error('\P{Is_Line_Break=EXCLAMATION:=}');
    Expect(1, 72817, '\p{Is_Line_Break=exclamation}', "");
    Expect(0, 72817, '\p{^Is_Line_Break=exclamation}', "");
    Expect(0, 72817, '\P{Is_Line_Break=exclamation}', "");
    Expect(1, 72817, '\P{^Is_Line_Break=exclamation}', "");
    Expect(0, 72818, '\p{Is_Line_Break=exclamation}', "");
    Expect(1, 72818, '\p{^Is_Line_Break=exclamation}', "");
    Expect(1, 72818, '\P{Is_Line_Break=exclamation}', "");
    Expect(0, 72818, '\P{^Is_Line_Break=exclamation}', "");
    Expect(1, 72817, '\p{Is_Line_Break=	Exclamation}', "");
    Expect(0, 72817, '\p{^Is_Line_Break=	Exclamation}', "");
    Expect(0, 72817, '\P{Is_Line_Break=	Exclamation}', "");
    Expect(1, 72817, '\P{^Is_Line_Break=	Exclamation}', "");
    Expect(0, 72818, '\p{Is_Line_Break=	Exclamation}', "");
    Expect(1, 72818, '\p{^Is_Line_Break=	Exclamation}', "");
    Expect(1, 72818, '\P{Is_Line_Break=	Exclamation}', "");
    Expect(0, 72818, '\P{^Is_Line_Break=	Exclamation}', "");
    Error('\p{Is_Lb=:=EX}');
    Error('\P{Is_Lb=:=EX}');
    Expect(1, 72817, '\p{Is_Lb=ex}', "");
    Expect(0, 72817, '\p{^Is_Lb=ex}', "");
    Expect(0, 72817, '\P{Is_Lb=ex}', "");
    Expect(1, 72817, '\P{^Is_Lb=ex}', "");
    Expect(0, 72818, '\p{Is_Lb=ex}', "");
    Expect(1, 72818, '\p{^Is_Lb=ex}', "");
    Expect(1, 72818, '\P{Is_Lb=ex}', "");
    Expect(0, 72818, '\P{^Is_Lb=ex}', "");
    Expect(1, 72817, '\p{Is_Lb=_-ex}', "");
    Expect(0, 72817, '\p{^Is_Lb=_-ex}', "");
    Expect(0, 72817, '\P{Is_Lb=_-ex}', "");
    Expect(1, 72817, '\P{^Is_Lb=_-ex}', "");
    Expect(0, 72818, '\p{Is_Lb=_-ex}', "");
    Expect(1, 72818, '\p{^Is_Lb=_-ex}', "");
    Expect(1, 72818, '\P{Is_Lb=_-ex}', "");
    Expect(0, 72818, '\P{^Is_Lb=_-ex}', "");
    Error('\p{Line_Break=/a/-	Glue}');
    Error('\P{Line_Break=/a/-	Glue}');
    Expect(1, 94180, '\p{Line_Break=:\AGlue\z:}', "");;
    Expect(0, 94181, '\p{Line_Break=:\AGlue\z:}', "");;
    Expect(1, 94180, '\p{Line_Break=glue}', "");
    Expect(0, 94180, '\p{^Line_Break=glue}', "");
    Expect(0, 94180, '\P{Line_Break=glue}', "");
    Expect(1, 94180, '\P{^Line_Break=glue}', "");
    Expect(0, 94181, '\p{Line_Break=glue}', "");
    Expect(1, 94181, '\p{^Line_Break=glue}', "");
    Expect(1, 94181, '\P{Line_Break=glue}', "");
    Expect(0, 94181, '\P{^Line_Break=glue}', "");
    Expect(1, 94180, '\p{Line_Break=:\Aglue\z:}', "");;
    Expect(0, 94181, '\p{Line_Break=:\Aglue\z:}', "");;
    Expect(1, 94180, '\p{Line_Break: _GLUE}', "");
    Expect(0, 94180, '\p{^Line_Break: _GLUE}', "");
    Expect(0, 94180, '\P{Line_Break: _GLUE}', "");
    Expect(1, 94180, '\P{^Line_Break: _GLUE}', "");
    Expect(0, 94181, '\p{Line_Break: _GLUE}', "");
    Expect(1, 94181, '\p{^Line_Break: _GLUE}', "");
    Expect(1, 94181, '\P{Line_Break: _GLUE}', "");
    Expect(0, 94181, '\P{^Line_Break: _GLUE}', "");
    Error('\p{Lb=-	GL/a/}');
    Error('\P{Lb=-	GL/a/}');
    Expect(1, 94180, '\p{Lb=:\AGL\z:}', "");;
    Expect(0, 94181, '\p{Lb=:\AGL\z:}', "");;
    Expect(1, 94180, '\p{Lb:	gl}', "");
    Expect(0, 94180, '\p{^Lb:	gl}', "");
    Expect(0, 94180, '\P{Lb:	gl}', "");
    Expect(1, 94180, '\P{^Lb:	gl}', "");
    Expect(0, 94181, '\p{Lb:	gl}', "");
    Expect(1, 94181, '\p{^Lb:	gl}', "");
    Expect(1, 94181, '\P{Lb:	gl}', "");
    Expect(0, 94181, '\P{^Lb:	gl}', "");
    Expect(1, 94180, '\p{Lb=:\Agl\z:}', "");;
    Expect(0, 94181, '\p{Lb=:\Agl\z:}', "");;
    Expect(1, 94180, '\p{Lb= GL}', "");
    Expect(0, 94180, '\p{^Lb= GL}', "");
    Expect(0, 94180, '\P{Lb= GL}', "");
    Expect(1, 94180, '\P{^Lb= GL}', "");
    Expect(0, 94181, '\p{Lb= GL}', "");
    Expect(1, 94181, '\p{^Lb= GL}', "");
    Expect(1, 94181, '\P{Lb= GL}', "");
    Expect(0, 94181, '\P{^Lb= GL}', "");
    Error('\p{Is_Line_Break=	:=Glue}');
    Error('\P{Is_Line_Break=	:=Glue}');
    Expect(1, 94180, '\p{Is_Line_Break=glue}', "");
    Expect(0, 94180, '\p{^Is_Line_Break=glue}', "");
    Expect(0, 94180, '\P{Is_Line_Break=glue}', "");
    Expect(1, 94180, '\P{^Is_Line_Break=glue}', "");
    Expect(0, 94181, '\p{Is_Line_Break=glue}', "");
    Expect(1, 94181, '\p{^Is_Line_Break=glue}', "");
    Expect(1, 94181, '\P{Is_Line_Break=glue}', "");
    Expect(0, 94181, '\P{^Is_Line_Break=glue}', "");
    Expect(1, 94180, '\p{Is_Line_Break=_	Glue}', "");
    Expect(0, 94180, '\p{^Is_Line_Break=_	Glue}', "");
    Expect(0, 94180, '\P{Is_Line_Break=_	Glue}', "");
    Expect(1, 94180, '\P{^Is_Line_Break=_	Glue}', "");
    Expect(0, 94181, '\p{Is_Line_Break=_	Glue}', "");
    Expect(1, 94181, '\p{^Is_Line_Break=_	Glue}', "");
    Expect(1, 94181, '\P{Is_Line_Break=_	Glue}', "");
    Expect(0, 94181, '\P{^Is_Line_Break=_	Glue}', "");
    Error('\p{Is_Lb=:=_GL}');
    Error('\P{Is_Lb=:=_GL}');
    Expect(1, 94180, '\p{Is_Lb=gl}', "");
    Expect(0, 94180, '\p{^Is_Lb=gl}', "");
    Expect(0, 94180, '\P{Is_Lb=gl}', "");
    Expect(1, 94180, '\P{^Is_Lb=gl}', "");
    Expect(0, 94181, '\p{Is_Lb=gl}', "");
    Expect(1, 94181, '\p{^Is_Lb=gl}', "");
    Expect(1, 94181, '\P{Is_Lb=gl}', "");
    Expect(0, 94181, '\P{^Is_Lb=gl}', "");
    Expect(1, 94180, '\p{Is_Lb=-GL}', "");
    Expect(0, 94180, '\p{^Is_Lb=-GL}', "");
    Expect(0, 94180, '\P{Is_Lb=-GL}', "");
    Expect(1, 94180, '\P{^Is_Lb=-GL}', "");
    Expect(0, 94181, '\p{Is_Lb=-GL}', "");
    Expect(1, 94181, '\p{^Is_Lb=-GL}', "");
    Expect(1, 94181, '\P{Is_Lb=-GL}', "");
    Expect(0, 94181, '\P{^Is_Lb=-GL}', "");
    Error('\p{Line_Break:	/a/H2}');
    Error('\P{Line_Break:	/a/H2}');
    Expect(1, 55176, '\p{Line_Break=:\AH2\z:}', "");;
    Expect(0, 55177, '\p{Line_Break=:\AH2\z:}', "");;
    Expect(1, 55176, '\p{Line_Break=h2}', "");
    Expect(0, 55176, '\p{^Line_Break=h2}', "");
    Expect(0, 55176, '\P{Line_Break=h2}', "");
    Expect(1, 55176, '\P{^Line_Break=h2}', "");
    Expect(0, 55177, '\p{Line_Break=h2}', "");
    Expect(1, 55177, '\p{^Line_Break=h2}', "");
    Expect(1, 55177, '\P{Line_Break=h2}', "");
    Expect(0, 55177, '\P{^Line_Break=h2}', "");
    Expect(1, 55176, '\p{Line_Break=:\Ah2\z:}', "");;
    Expect(0, 55177, '\p{Line_Break=:\Ah2\z:}', "");;
    Expect(1, 55176, '\p{Line_Break=- H2}', "");
    Expect(0, 55176, '\p{^Line_Break=- H2}', "");
    Expect(0, 55176, '\P{Line_Break=- H2}', "");
    Expect(1, 55176, '\P{^Line_Break=- H2}', "");
    Expect(0, 55177, '\p{Line_Break=- H2}', "");
    Expect(1, 55177, '\p{^Line_Break=- H2}', "");
    Expect(1, 55177, '\P{Line_Break=- H2}', "");
    Expect(0, 55177, '\P{^Line_Break=- H2}', "");
    Error('\p{Lb=:=_	h2}');
    Error('\P{Lb=:=_	h2}');
    Expect(1, 55176, '\p{Lb=:\AH2\z:}', "");;
    Expect(0, 55177, '\p{Lb=:\AH2\z:}', "");;
    Expect(1, 55176, '\p{Lb=h2}', "");
    Expect(0, 55176, '\p{^Lb=h2}', "");
    Expect(0, 55176, '\P{Lb=h2}', "");
    Expect(1, 55176, '\P{^Lb=h2}', "");
    Expect(0, 55177, '\p{Lb=h2}', "");
    Expect(1, 55177, '\p{^Lb=h2}', "");
    Expect(1, 55177, '\P{Lb=h2}', "");
    Expect(0, 55177, '\P{^Lb=h2}', "");
    Expect(1, 55176, '\p{Lb=:\Ah2\z:}', "");;
    Expect(0, 55177, '\p{Lb=:\Ah2\z:}', "");;
    Expect(1, 55176, '\p{Lb=  H2}', "");
    Expect(0, 55176, '\p{^Lb=  H2}', "");
    Expect(0, 55176, '\P{Lb=  H2}', "");
    Expect(1, 55176, '\P{^Lb=  H2}', "");
    Expect(0, 55177, '\p{Lb=  H2}', "");
    Expect(1, 55177, '\p{^Lb=  H2}', "");
    Expect(1, 55177, '\P{Lb=  H2}', "");
    Expect(0, 55177, '\P{^Lb=  H2}', "");
    Error('\p{Is_Line_Break=_/a/H2}');
    Error('\P{Is_Line_Break=_/a/H2}');
    Expect(1, 55176, '\p{Is_Line_Break=h2}', "");
    Expect(0, 55176, '\p{^Is_Line_Break=h2}', "");
    Expect(0, 55176, '\P{Is_Line_Break=h2}', "");
    Expect(1, 55176, '\P{^Is_Line_Break=h2}', "");
    Expect(0, 55177, '\p{Is_Line_Break=h2}', "");
    Expect(1, 55177, '\p{^Is_Line_Break=h2}', "");
    Expect(1, 55177, '\P{Is_Line_Break=h2}', "");
    Expect(0, 55177, '\P{^Is_Line_Break=h2}', "");
    Expect(1, 55176, '\p{Is_Line_Break=	H2}', "");
    Expect(0, 55176, '\p{^Is_Line_Break=	H2}', "");
    Expect(0, 55176, '\P{Is_Line_Break=	H2}', "");
    Expect(1, 55176, '\P{^Is_Line_Break=	H2}', "");
    Expect(0, 55177, '\p{Is_Line_Break=	H2}', "");
    Expect(1, 55177, '\p{^Is_Line_Break=	H2}', "");
    Expect(1, 55177, '\P{Is_Line_Break=	H2}', "");
    Expect(0, 55177, '\P{^Is_Line_Break=	H2}', "");
    Error('\p{Is_Lb=_/a/h2}');
    Error('\P{Is_Lb=_/a/h2}');
    Expect(1, 55176, '\p{Is_Lb=h2}', "");
    Expect(0, 55176, '\p{^Is_Lb=h2}', "");
    Expect(0, 55176, '\P{Is_Lb=h2}', "");
    Expect(1, 55176, '\P{^Is_Lb=h2}', "");
    Expect(0, 55177, '\p{Is_Lb=h2}', "");
    Expect(1, 55177, '\p{^Is_Lb=h2}', "");
    Expect(1, 55177, '\P{Is_Lb=h2}', "");
    Expect(0, 55177, '\P{^Is_Lb=h2}', "");
    Expect(1, 55176, '\p{Is_Lb:   H2}', "");
    Expect(0, 55176, '\p{^Is_Lb:   H2}', "");
    Expect(0, 55176, '\P{Is_Lb:   H2}', "");
    Expect(1, 55176, '\P{^Is_Lb:   H2}', "");
    Expect(0, 55177, '\p{Is_Lb:   H2}', "");
    Expect(1, 55177, '\p{^Is_Lb:   H2}', "");
    Expect(1, 55177, '\P{Is_Lb:   H2}', "");
    Expect(0, 55177, '\P{^Is_Lb:   H2}', "");
    Error('\p{Line_Break=_ H3:=}');
    Error('\P{Line_Break=_ H3:=}');
    Expect(1, 55203, '\p{Line_Break=:\AH3\z:}', "");;
    Expect(0, 55204, '\p{Line_Break=:\AH3\z:}', "");;
    Expect(1, 55203, '\p{Line_Break=h3}', "");
    Expect(0, 55203, '\p{^Line_Break=h3}', "");
    Expect(0, 55203, '\P{Line_Break=h3}', "");
    Expect(1, 55203, '\P{^Line_Break=h3}', "");
    Expect(0, 55204, '\p{Line_Break=h3}', "");
    Expect(1, 55204, '\p{^Line_Break=h3}', "");
    Expect(1, 55204, '\P{Line_Break=h3}', "");
    Expect(0, 55204, '\P{^Line_Break=h3}', "");
    Expect(1, 55203, '\p{Line_Break=:\Ah3\z:}', "");;
    Expect(0, 55204, '\p{Line_Break=:\Ah3\z:}', "");;
    Expect(1, 55203, '\p{Line_Break=	_h3}', "");
    Expect(0, 55203, '\p{^Line_Break=	_h3}', "");
    Expect(0, 55203, '\P{Line_Break=	_h3}', "");
    Expect(1, 55203, '\P{^Line_Break=	_h3}', "");
    Expect(0, 55204, '\p{Line_Break=	_h3}', "");
    Expect(1, 55204, '\p{^Line_Break=	_h3}', "");
    Expect(1, 55204, '\P{Line_Break=	_h3}', "");
    Expect(0, 55204, '\P{^Line_Break=	_h3}', "");
    Error('\p{Lb: 	 H3:=}');
    Error('\P{Lb: 	 H3:=}');
    Expect(1, 55203, '\p{Lb=:\AH3\z:}', "");;
    Expect(0, 55204, '\p{Lb=:\AH3\z:}', "");;
    Expect(1, 55203, '\p{Lb=h3}', "");
    Expect(0, 55203, '\p{^Lb=h3}', "");
    Expect(0, 55203, '\P{Lb=h3}', "");
    Expect(1, 55203, '\P{^Lb=h3}', "");
    Expect(0, 55204, '\p{Lb=h3}', "");
    Expect(1, 55204, '\p{^Lb=h3}', "");
    Expect(1, 55204, '\P{Lb=h3}', "");
    Expect(0, 55204, '\P{^Lb=h3}', "");
    Expect(1, 55203, '\p{Lb=:\Ah3\z:}', "");;
    Expect(0, 55204, '\p{Lb=:\Ah3\z:}', "");;
    Expect(1, 55203, '\p{Lb= H3}', "");
    Expect(0, 55203, '\p{^Lb= H3}', "");
    Expect(0, 55203, '\P{Lb= H3}', "");
    Expect(1, 55203, '\P{^Lb= H3}', "");
    Expect(0, 55204, '\p{Lb= H3}', "");
    Expect(1, 55204, '\p{^Lb= H3}', "");
    Expect(1, 55204, '\P{Lb= H3}', "");
    Expect(0, 55204, '\P{^Lb= H3}', "");
    Error('\p{Is_Line_Break:   _-H3:=}');
    Error('\P{Is_Line_Break:   _-H3:=}');
    Expect(1, 55203, '\p{Is_Line_Break=h3}', "");
    Expect(0, 55203, '\p{^Is_Line_Break=h3}', "");
    Expect(0, 55203, '\P{Is_Line_Break=h3}', "");
    Expect(1, 55203, '\P{^Is_Line_Break=h3}', "");
    Expect(0, 55204, '\p{Is_Line_Break=h3}', "");
    Expect(1, 55204, '\p{^Is_Line_Break=h3}', "");
    Expect(1, 55204, '\P{Is_Line_Break=h3}', "");
    Expect(0, 55204, '\P{^Is_Line_Break=h3}', "");
    Expect(1, 55203, '\p{Is_Line_Break= _H3}', "");
    Expect(0, 55203, '\p{^Is_Line_Break= _H3}', "");
    Expect(0, 55203, '\P{Is_Line_Break= _H3}', "");
    Expect(1, 55203, '\P{^Is_Line_Break= _H3}', "");
    Expect(0, 55204, '\p{Is_Line_Break= _H3}', "");
    Expect(1, 55204, '\p{^Is_Line_Break= _H3}', "");
    Expect(1, 55204, '\P{Is_Line_Break= _H3}', "");
    Expect(0, 55204, '\P{^Is_Line_Break= _H3}', "");
    Error('\p{Is_Lb=-:=H3}');
    Error('\P{Is_Lb=-:=H3}');
    Expect(1, 55203, '\p{Is_Lb=h3}', "");
    Expect(0, 55203, '\p{^Is_Lb=h3}', "");
    Expect(0, 55203, '\P{Is_Lb=h3}', "");
    Expect(1, 55203, '\P{^Is_Lb=h3}', "");
    Expect(0, 55204, '\p{Is_Lb=h3}', "");
    Expect(1, 55204, '\p{^Is_Lb=h3}', "");
    Expect(1, 55204, '\P{Is_Lb=h3}', "");
    Expect(0, 55204, '\P{^Is_Lb=h3}', "");
    Expect(1, 55203, '\p{Is_Lb=		h3}', "");
    Expect(0, 55203, '\p{^Is_Lb=		h3}', "");
    Expect(0, 55203, '\P{Is_Lb=		h3}', "");
    Expect(1, 55203, '\P{^Is_Lb=		h3}', "");
    Expect(0, 55204, '\p{Is_Lb=		h3}', "");
    Expect(1, 55204, '\p{^Is_Lb=		h3}', "");
    Expect(1, 55204, '\P{Is_Lb=		h3}', "");
    Expect(0, 55204, '\P{^Is_Lb=		h3}', "");
    Error('\p{Line_Break:_ HEBREW_LETTER/a/}');
    Error('\P{Line_Break:_ HEBREW_LETTER/a/}');
    Expect(1, 64335, '\p{Line_Break=:\AHebrew_Letter\z:}', "");;
    Expect(0, 64336, '\p{Line_Break=:\AHebrew_Letter\z:}', "");;
    Expect(1, 64335, '\p{Line_Break=hebrewletter}', "");
    Expect(0, 64335, '\p{^Line_Break=hebrewletter}', "");
    Expect(0, 64335, '\P{Line_Break=hebrewletter}', "");
    Expect(1, 64335, '\P{^Line_Break=hebrewletter}', "");
    Expect(0, 64336, '\p{Line_Break=hebrewletter}', "");
    Expect(1, 64336, '\p{^Line_Break=hebrewletter}', "");
    Expect(1, 64336, '\P{Line_Break=hebrewletter}', "");
    Expect(0, 64336, '\P{^Line_Break=hebrewletter}', "");
    Expect(1, 64335, '\p{Line_Break=:\Ahebrewletter\z:}', "");;
    Expect(0, 64336, '\p{Line_Break=:\Ahebrewletter\z:}', "");;
    Expect(1, 64335, '\p{Line_Break=-Hebrew_Letter}', "");
    Expect(0, 64335, '\p{^Line_Break=-Hebrew_Letter}', "");
    Expect(0, 64335, '\P{Line_Break=-Hebrew_Letter}', "");
    Expect(1, 64335, '\P{^Line_Break=-Hebrew_Letter}', "");
    Expect(0, 64336, '\p{Line_Break=-Hebrew_Letter}', "");
    Expect(1, 64336, '\p{^Line_Break=-Hebrew_Letter}', "");
    Expect(1, 64336, '\P{Line_Break=-Hebrew_Letter}', "");
    Expect(0, 64336, '\P{^Line_Break=-Hebrew_Letter}', "");
    Error('\p{Lb=__HL/a/}');
    Error('\P{Lb=__HL/a/}');
    Expect(1, 64335, '\p{Lb=:\AHL\z:}', "");;
    Expect(0, 64336, '\p{Lb=:\AHL\z:}', "");;
    Expect(1, 64335, '\p{Lb=hl}', "");
    Expect(0, 64335, '\p{^Lb=hl}', "");
    Expect(0, 64335, '\P{Lb=hl}', "");
    Expect(1, 64335, '\P{^Lb=hl}', "");
    Expect(0, 64336, '\p{Lb=hl}', "");
    Expect(1, 64336, '\p{^Lb=hl}', "");
    Expect(1, 64336, '\P{Lb=hl}', "");
    Expect(0, 64336, '\P{^Lb=hl}', "");
    Expect(1, 64335, '\p{Lb=:\Ahl\z:}', "");;
    Expect(0, 64336, '\p{Lb=:\Ahl\z:}', "");;
    Expect(1, 64335, '\p{Lb=	 HL}', "");
    Expect(0, 64335, '\p{^Lb=	 HL}', "");
    Expect(0, 64335, '\P{Lb=	 HL}', "");
    Expect(1, 64335, '\P{^Lb=	 HL}', "");
    Expect(0, 64336, '\p{Lb=	 HL}', "");
    Expect(1, 64336, '\p{^Lb=	 HL}', "");
    Expect(1, 64336, '\P{Lb=	 HL}', "");
    Expect(0, 64336, '\P{^Lb=	 HL}', "");
    Error('\p{Is_Line_Break=:=	Hebrew_letter}');
    Error('\P{Is_Line_Break=:=	Hebrew_letter}');
    Expect(1, 64335, '\p{Is_Line_Break:   hebrewletter}', "");
    Expect(0, 64335, '\p{^Is_Line_Break:   hebrewletter}', "");
    Expect(0, 64335, '\P{Is_Line_Break:   hebrewletter}', "");
    Expect(1, 64335, '\P{^Is_Line_Break:   hebrewletter}', "");
    Expect(0, 64336, '\p{Is_Line_Break:   hebrewletter}', "");
    Expect(1, 64336, '\p{^Is_Line_Break:   hebrewletter}', "");
    Expect(1, 64336, '\P{Is_Line_Break:   hebrewletter}', "");
    Expect(0, 64336, '\P{^Is_Line_Break:   hebrewletter}', "");
    Expect(1, 64335, '\p{Is_Line_Break=	hebrew_LETTER}', "");
    Expect(0, 64335, '\p{^Is_Line_Break=	hebrew_LETTER}', "");
    Expect(0, 64335, '\P{Is_Line_Break=	hebrew_LETTER}', "");
    Expect(1, 64335, '\P{^Is_Line_Break=	hebrew_LETTER}', "");
    Expect(0, 64336, '\p{Is_Line_Break=	hebrew_LETTER}', "");
    Expect(1, 64336, '\p{^Is_Line_Break=	hebrew_LETTER}', "");
    Expect(1, 64336, '\P{Is_Line_Break=	hebrew_LETTER}', "");
    Expect(0, 64336, '\P{^Is_Line_Break=	hebrew_LETTER}', "");
    Error('\p{Is_Lb=_/a/HL}');
    Error('\P{Is_Lb=_/a/HL}');
    Expect(1, 64335, '\p{Is_Lb=hl}', "");
    Expect(0, 64335, '\p{^Is_Lb=hl}', "");
    Expect(0, 64335, '\P{Is_Lb=hl}', "");
    Expect(1, 64335, '\P{^Is_Lb=hl}', "");
    Expect(0, 64336, '\p{Is_Lb=hl}', "");
    Expect(1, 64336, '\p{^Is_Lb=hl}', "");
    Expect(1, 64336, '\P{Is_Lb=hl}', "");
    Expect(0, 64336, '\P{^Is_Lb=hl}', "");
    Expect(1, 64335, '\p{Is_Lb=_HL}', "");
    Expect(0, 64335, '\p{^Is_Lb=_HL}', "");
    Expect(0, 64335, '\P{Is_Lb=_HL}', "");
    Expect(1, 64335, '\P{^Is_Lb=_HL}', "");
    Expect(0, 64336, '\p{Is_Lb=_HL}', "");
    Expect(1, 64336, '\p{^Is_Lb=_HL}', "");
    Expect(1, 64336, '\P{Is_Lb=_HL}', "");
    Expect(0, 64336, '\P{^Is_Lb=_HL}', "");
    Error('\p{Line_Break: :=HYPHEN}');
    Error('\P{Line_Break: :=HYPHEN}');
    Expect(1, 45, '\p{Line_Break=:\AHyphen\z:}', "");;
    Expect(0, 46, '\p{Line_Break=:\AHyphen\z:}', "");;
    Expect(1, 45, '\p{Line_Break=hyphen}', "");
    Expect(0, 45, '\p{^Line_Break=hyphen}', "");
    Expect(0, 45, '\P{Line_Break=hyphen}', "");
    Expect(1, 45, '\P{^Line_Break=hyphen}', "");
    Expect(0, 46, '\p{Line_Break=hyphen}', "");
    Expect(1, 46, '\p{^Line_Break=hyphen}', "");
    Expect(1, 46, '\P{Line_Break=hyphen}', "");
    Expect(0, 46, '\P{^Line_Break=hyphen}', "");
    Expect(1, 45, '\p{Line_Break=:\Ahyphen\z:}', "");;
    Expect(0, 46, '\p{Line_Break=:\Ahyphen\z:}', "");;
    Expect(1, 45, '\p{Line_Break=_	hyphen}', "");
    Expect(0, 45, '\p{^Line_Break=_	hyphen}', "");
    Expect(0, 45, '\P{Line_Break=_	hyphen}', "");
    Expect(1, 45, '\P{^Line_Break=_	hyphen}', "");
    Expect(0, 46, '\p{Line_Break=_	hyphen}', "");
    Expect(1, 46, '\p{^Line_Break=_	hyphen}', "");
    Expect(1, 46, '\P{Line_Break=_	hyphen}', "");
    Expect(0, 46, '\P{^Line_Break=_	hyphen}', "");
    Error('\p{Lb=/a/_ HY}');
    Error('\P{Lb=/a/_ HY}');
    Expect(1, 45, '\p{Lb=:\AHY\z:}', "");;
    Expect(0, 46, '\p{Lb=:\AHY\z:}', "");;
    Expect(1, 45, '\p{Lb=hy}', "");
    Expect(0, 45, '\p{^Lb=hy}', "");
    Expect(0, 45, '\P{Lb=hy}', "");
    Expect(1, 45, '\P{^Lb=hy}', "");
    Expect(0, 46, '\p{Lb=hy}', "");
    Expect(1, 46, '\p{^Lb=hy}', "");
    Expect(1, 46, '\P{Lb=hy}', "");
    Expect(0, 46, '\P{^Lb=hy}', "");
    Expect(1, 45, '\p{Lb=:\Ahy\z:}', "");;
    Expect(0, 46, '\p{Lb=:\Ahy\z:}', "");;
    Expect(1, 45, '\p{Lb: 	hy}', "");
    Expect(0, 45, '\p{^Lb: 	hy}', "");
    Expect(0, 45, '\P{Lb: 	hy}', "");
    Expect(1, 45, '\P{^Lb: 	hy}', "");
    Expect(0, 46, '\p{Lb: 	hy}', "");
    Expect(1, 46, '\p{^Lb: 	hy}', "");
    Expect(1, 46, '\P{Lb: 	hy}', "");
    Expect(0, 46, '\P{^Lb: 	hy}', "");
    Error('\p{Is_Line_Break: :=_ Hyphen}');
    Error('\P{Is_Line_Break: :=_ Hyphen}');
    Expect(1, 45, '\p{Is_Line_Break=hyphen}', "");
    Expect(0, 45, '\p{^Is_Line_Break=hyphen}', "");
    Expect(0, 45, '\P{Is_Line_Break=hyphen}', "");
    Expect(1, 45, '\P{^Is_Line_Break=hyphen}', "");
    Expect(0, 46, '\p{Is_Line_Break=hyphen}', "");
    Expect(1, 46, '\p{^Is_Line_Break=hyphen}', "");
    Expect(1, 46, '\P{Is_Line_Break=hyphen}', "");
    Expect(0, 46, '\P{^Is_Line_Break=hyphen}', "");
    Expect(1, 45, '\p{Is_Line_Break=_Hyphen}', "");
    Expect(0, 45, '\p{^Is_Line_Break=_Hyphen}', "");
    Expect(0, 45, '\P{Is_Line_Break=_Hyphen}', "");
    Expect(1, 45, '\P{^Is_Line_Break=_Hyphen}', "");
    Expect(0, 46, '\p{Is_Line_Break=_Hyphen}', "");
    Expect(1, 46, '\p{^Is_Line_Break=_Hyphen}', "");
    Expect(1, 46, '\P{Is_Line_Break=_Hyphen}', "");
    Expect(0, 46, '\P{^Is_Line_Break=_Hyphen}', "");
    Error('\p{Is_Lb=:=-HY}');
    Error('\P{Is_Lb=:=-HY}');
    Expect(1, 45, '\p{Is_Lb=hy}', "");
    Expect(0, 45, '\p{^Is_Lb=hy}', "");
    Expect(0, 45, '\P{Is_Lb=hy}', "");
    Expect(1, 45, '\P{^Is_Lb=hy}', "");
    Expect(0, 46, '\p{Is_Lb=hy}', "");
    Expect(1, 46, '\p{^Is_Lb=hy}', "");
    Expect(1, 46, '\P{Is_Lb=hy}', "");
    Expect(0, 46, '\P{^Is_Lb=hy}', "");
    Expect(1, 45, '\p{Is_Lb=	 HY}', "");
    Expect(0, 45, '\p{^Is_Lb=	 HY}', "");
    Expect(0, 45, '\P{Is_Lb=	 HY}', "");
    Expect(1, 45, '\P{^Is_Lb=	 HY}', "");
    Expect(0, 46, '\p{Is_Lb=	 HY}', "");
    Expect(1, 46, '\p{^Is_Lb=	 HY}', "");
    Expect(1, 46, '\P{Is_Lb=	 HY}', "");
    Expect(0, 46, '\P{^Is_Lb=	 HY}', "");
    Error('\p{Line_Break:    /a/ideographic}');
    Error('\P{Line_Break:    /a/ideographic}');
    Expect(1, 262141, '\p{Line_Break=:\AIdeographic\z:}', "");;
    Expect(0, 262144, '\p{Line_Break=:\AIdeographic\z:}', "");;
    Expect(1, 262141, '\p{Line_Break=ideographic}', "");
    Expect(0, 262141, '\p{^Line_Break=ideographic}', "");
    Expect(0, 262141, '\P{Line_Break=ideographic}', "");
    Expect(1, 262141, '\P{^Line_Break=ideographic}', "");
    Expect(0, 262144, '\p{Line_Break=ideographic}', "");
    Expect(1, 262144, '\p{^Line_Break=ideographic}', "");
    Expect(1, 262144, '\P{Line_Break=ideographic}', "");
    Expect(0, 262144, '\P{^Line_Break=ideographic}', "");
    Expect(1, 262141, '\p{Line_Break=:\Aideographic\z:}', "");;
    Expect(0, 262144, '\p{Line_Break=:\Aideographic\z:}', "");;
    Expect(1, 262141, '\p{Line_Break=		IDEOGRAPHIC}', "");
    Expect(0, 262141, '\p{^Line_Break=		IDEOGRAPHIC}', "");
    Expect(0, 262141, '\P{Line_Break=		IDEOGRAPHIC}', "");
    Expect(1, 262141, '\P{^Line_Break=		IDEOGRAPHIC}', "");
    Expect(0, 262144, '\p{Line_Break=		IDEOGRAPHIC}', "");
    Expect(1, 262144, '\p{^Line_Break=		IDEOGRAPHIC}', "");
    Expect(1, 262144, '\P{Line_Break=		IDEOGRAPHIC}', "");
    Expect(0, 262144, '\P{^Line_Break=		IDEOGRAPHIC}', "");
    Error('\p{Lb=--ID:=}');
    Error('\P{Lb=--ID:=}');
    Expect(1, 262141, '\p{Lb=:\AID\z:}', "");;
    Expect(0, 262144, '\p{Lb=:\AID\z:}', "");;
    Expect(1, 262141, '\p{Lb:id}', "");
    Expect(0, 262141, '\p{^Lb:id}', "");
    Expect(0, 262141, '\P{Lb:id}', "");
    Expect(1, 262141, '\P{^Lb:id}', "");
    Expect(0, 262144, '\p{Lb:id}', "");
    Expect(1, 262144, '\p{^Lb:id}', "");
    Expect(1, 262144, '\P{Lb:id}', "");
    Expect(0, 262144, '\P{^Lb:id}', "");
    Expect(1, 262141, '\p{Lb=:\Aid\z:}', "");;
    Expect(0, 262144, '\p{Lb=:\Aid\z:}', "");;
    Expect(1, 262141, '\p{Lb=_-ID}', "");
    Expect(0, 262141, '\p{^Lb=_-ID}', "");
    Expect(0, 262141, '\P{Lb=_-ID}', "");
    Expect(1, 262141, '\P{^Lb=_-ID}', "");
    Expect(0, 262144, '\p{Lb=_-ID}', "");
    Expect(1, 262144, '\p{^Lb=_-ID}', "");
    Expect(1, 262144, '\P{Lb=_-ID}', "");
    Expect(0, 262144, '\P{^Lb=_-ID}', "");
    Error('\p{Is_Line_Break:		-Ideographic:=}');
    Error('\P{Is_Line_Break:		-Ideographic:=}');
    Expect(1, 262141, '\p{Is_Line_Break=ideographic}', "");
    Expect(0, 262141, '\p{^Is_Line_Break=ideographic}', "");
    Expect(0, 262141, '\P{Is_Line_Break=ideographic}', "");
    Expect(1, 262141, '\P{^Is_Line_Break=ideographic}', "");
    Expect(0, 262144, '\p{Is_Line_Break=ideographic}', "");
    Expect(1, 262144, '\p{^Is_Line_Break=ideographic}', "");
    Expect(1, 262144, '\P{Is_Line_Break=ideographic}', "");
    Expect(0, 262144, '\P{^Is_Line_Break=ideographic}', "");
    Expect(1, 262141, '\p{Is_Line_Break= ideographic}', "");
    Expect(0, 262141, '\p{^Is_Line_Break= ideographic}', "");
    Expect(0, 262141, '\P{Is_Line_Break= ideographic}', "");
    Expect(1, 262141, '\P{^Is_Line_Break= ideographic}', "");
    Expect(0, 262144, '\p{Is_Line_Break= ideographic}', "");
    Expect(1, 262144, '\p{^Is_Line_Break= ideographic}', "");
    Expect(1, 262144, '\P{Is_Line_Break= ideographic}', "");
    Expect(0, 262144, '\P{^Is_Line_Break= ideographic}', "");
    Error('\p{Is_Lb=/a/--id}');
    Error('\P{Is_Lb=/a/--id}');
    Expect(1, 262141, '\p{Is_Lb=id}', "");
    Expect(0, 262141, '\p{^Is_Lb=id}', "");
    Expect(0, 262141, '\P{Is_Lb=id}', "");
    Expect(1, 262141, '\P{^Is_Lb=id}', "");
    Expect(0, 262144, '\p{Is_Lb=id}', "");
    Expect(1, 262144, '\p{^Is_Lb=id}', "");
    Expect(1, 262144, '\P{Is_Lb=id}', "");
    Expect(0, 262144, '\P{^Is_Lb=id}', "");
    Expect(1, 262141, '\p{Is_Lb=_ID}', "");
    Expect(0, 262141, '\p{^Is_Lb=_ID}', "");
    Expect(0, 262141, '\P{Is_Lb=_ID}', "");
    Expect(1, 262141, '\P{^Is_Lb=_ID}', "");
    Expect(0, 262144, '\p{Is_Lb=_ID}', "");
    Expect(1, 262144, '\p{^Is_Lb=_ID}', "");
    Expect(1, 262144, '\P{Is_Lb=_ID}', "");
    Expect(0, 262144, '\P{^Is_Lb=_ID}', "");
    Error('\p{Line_Break=	inseparable/a/}');
    Error('\P{Line_Break=	inseparable/a/}');
    Expect(1, 68342, '\p{Line_Break=:\AInseparable\z:}', "");;
    Expect(0, 68343, '\p{Line_Break=:\AInseparable\z:}', "");;
    Expect(1, 68342, '\p{Line_Break=inseparable}', "");
    Expect(0, 68342, '\p{^Line_Break=inseparable}', "");
    Expect(0, 68342, '\P{Line_Break=inseparable}', "");
    Expect(1, 68342, '\P{^Line_Break=inseparable}', "");
    Expect(0, 68343, '\p{Line_Break=inseparable}', "");
    Expect(1, 68343, '\p{^Line_Break=inseparable}', "");
    Expect(1, 68343, '\P{Line_Break=inseparable}', "");
    Expect(0, 68343, '\P{^Line_Break=inseparable}', "");
    Expect(1, 68342, '\p{Line_Break=:\Ainseparable\z:}', "");;
    Expect(0, 68343, '\p{Line_Break=:\Ainseparable\z:}', "");;
    Expect(1, 68342, '\p{Line_Break=_INSEPARABLE}', "");
    Expect(0, 68342, '\p{^Line_Break=_INSEPARABLE}', "");
    Expect(0, 68342, '\P{Line_Break=_INSEPARABLE}', "");
    Expect(1, 68342, '\P{^Line_Break=_INSEPARABLE}', "");
    Expect(0, 68343, '\p{Line_Break=_INSEPARABLE}', "");
    Expect(1, 68343, '\p{^Line_Break=_INSEPARABLE}', "");
    Expect(1, 68343, '\P{Line_Break=_INSEPARABLE}', "");
    Expect(0, 68343, '\P{^Line_Break=_INSEPARABLE}', "");
    Error('\p{Lb=_IN:=}');
    Error('\P{Lb=_IN:=}');
    Expect(1, 68342, '\p{Lb=:\AIN\z:}', "");;
    Expect(0, 68343, '\p{Lb=:\AIN\z:}', "");;
    Expect(1, 68342, '\p{Lb=in}', "");
    Expect(0, 68342, '\p{^Lb=in}', "");
    Expect(0, 68342, '\P{Lb=in}', "");
    Expect(1, 68342, '\P{^Lb=in}', "");
    Expect(0, 68343, '\p{Lb=in}', "");
    Expect(1, 68343, '\p{^Lb=in}', "");
    Expect(1, 68343, '\P{Lb=in}', "");
    Expect(0, 68343, '\P{^Lb=in}', "");
    Expect(1, 68342, '\p{Lb=:\Ain\z:}', "");;
    Expect(0, 68343, '\p{Lb=:\Ain\z:}', "");;
    Expect(1, 68342, '\p{Lb=IN}', "");
    Expect(0, 68342, '\p{^Lb=IN}', "");
    Expect(0, 68342, '\P{Lb=IN}', "");
    Expect(1, 68342, '\P{^Lb=IN}', "");
    Expect(0, 68343, '\p{Lb=IN}', "");
    Expect(1, 68343, '\p{^Lb=IN}', "");
    Expect(1, 68343, '\P{Lb=IN}', "");
    Expect(0, 68343, '\P{^Lb=IN}', "");
    Error('\p{Is_Line_Break=-/a/Inseperable}');
    Error('\P{Is_Line_Break=-/a/Inseperable}');
    Expect(1, 68342, '\p{Is_Line_Break=inseperable}', "");
    Expect(0, 68342, '\p{^Is_Line_Break=inseperable}', "");
    Expect(0, 68342, '\P{Is_Line_Break=inseperable}', "");
    Expect(1, 68342, '\P{^Is_Line_Break=inseperable}', "");
    Expect(0, 68343, '\p{Is_Line_Break=inseperable}', "");
    Expect(1, 68343, '\p{^Is_Line_Break=inseperable}', "");
    Expect(1, 68343, '\P{Is_Line_Break=inseperable}', "");
    Expect(0, 68343, '\P{^Is_Line_Break=inseperable}', "");
    Expect(1, 68342, '\p{Is_Line_Break:	_	Inseperable}', "");
    Expect(0, 68342, '\p{^Is_Line_Break:	_	Inseperable}', "");
    Expect(0, 68342, '\P{Is_Line_Break:	_	Inseperable}', "");
    Expect(1, 68342, '\P{^Is_Line_Break:	_	Inseperable}', "");
    Expect(0, 68343, '\p{Is_Line_Break:	_	Inseperable}', "");
    Expect(1, 68343, '\p{^Is_Line_Break:	_	Inseperable}', "");
    Expect(1, 68343, '\P{Is_Line_Break:	_	Inseperable}', "");
    Expect(0, 68343, '\P{^Is_Line_Break:	_	Inseperable}', "");
    Error('\p{Is_Lb= -inseparable/a/}');
    Error('\P{Is_Lb= -inseparable/a/}');
    Expect(1, 68342, '\p{Is_Lb=inseparable}', "");
    Expect(0, 68342, '\p{^Is_Lb=inseparable}', "");
    Expect(0, 68342, '\P{Is_Lb=inseparable}', "");
    Expect(1, 68342, '\P{^Is_Lb=inseparable}', "");
    Expect(0, 68343, '\p{Is_Lb=inseparable}', "");
    Expect(1, 68343, '\p{^Is_Lb=inseparable}', "");
    Expect(1, 68343, '\P{Is_Lb=inseparable}', "");
    Expect(0, 68343, '\P{^Is_Lb=inseparable}', "");
    Expect(1, 68342, '\p{Is_Lb=-	Inseparable}', "");
    Expect(0, 68342, '\p{^Is_Lb=-	Inseparable}', "");
    Expect(0, 68342, '\P{Is_Lb=-	Inseparable}', "");
    Expect(1, 68342, '\P{^Is_Lb=-	Inseparable}', "");
    Expect(0, 68343, '\p{Is_Lb=-	Inseparable}', "");
    Expect(1, 68343, '\p{^Is_Lb=-	Inseparable}', "");
    Expect(1, 68343, '\P{Is_Lb=-	Inseparable}', "");
    Expect(0, 68343, '\P{^Is_Lb=-	Inseparable}', "");
    Error('\p{Line_Break:    	Infix_NUMERIC/a/}');
    Error('\P{Line_Break:    	Infix_NUMERIC/a/}');
    Expect(1, 65044, '\p{Line_Break=:\AInfix_Numeric\z:}', "");;
    Expect(0, 65045, '\p{Line_Break=:\AInfix_Numeric\z:}', "");;
    Expect(1, 65044, '\p{Line_Break: infixnumeric}', "");
    Expect(0, 65044, '\p{^Line_Break: infixnumeric}', "");
    Expect(0, 65044, '\P{Line_Break: infixnumeric}', "");
    Expect(1, 65044, '\P{^Line_Break: infixnumeric}', "");
    Expect(0, 65045, '\p{Line_Break: infixnumeric}', "");
    Expect(1, 65045, '\p{^Line_Break: infixnumeric}', "");
    Expect(1, 65045, '\P{Line_Break: infixnumeric}', "");
    Expect(0, 65045, '\P{^Line_Break: infixnumeric}', "");
    Expect(1, 65044, '\p{Line_Break=:\Ainfixnumeric\z:}', "");;
    Expect(0, 65045, '\p{Line_Break=:\Ainfixnumeric\z:}', "");;
    Expect(1, 65044, '\p{Line_Break=--infix_numeric}', "");
    Expect(0, 65044, '\p{^Line_Break=--infix_numeric}', "");
    Expect(0, 65044, '\P{Line_Break=--infix_numeric}', "");
    Expect(1, 65044, '\P{^Line_Break=--infix_numeric}', "");
    Expect(0, 65045, '\p{Line_Break=--infix_numeric}', "");
    Expect(1, 65045, '\p{^Line_Break=--infix_numeric}', "");
    Expect(1, 65045, '\P{Line_Break=--infix_numeric}', "");
    Expect(0, 65045, '\P{^Line_Break=--infix_numeric}', "");
    Error('\p{Lb=_/a/is}');
    Error('\P{Lb=_/a/is}');
    Expect(1, 65044, '\p{Lb=:\AIS\z:}', "");;
    Expect(0, 65045, '\p{Lb=:\AIS\z:}', "");;
    Expect(1, 65044, '\p{Lb=is}', "");
    Expect(0, 65044, '\p{^Lb=is}', "");
    Expect(0, 65044, '\P{Lb=is}', "");
    Expect(1, 65044, '\P{^Lb=is}', "");
    Expect(0, 65045, '\p{Lb=is}', "");
    Expect(1, 65045, '\p{^Lb=is}', "");
    Expect(1, 65045, '\P{Lb=is}', "");
    Expect(0, 65045, '\P{^Lb=is}', "");
    Expect(1, 65044, '\p{Lb=:\Ais\z:}', "");;
    Expect(0, 65045, '\p{Lb=:\Ais\z:}', "");;
    Expect(1, 65044, '\p{Lb=- IS}', "");
    Expect(0, 65044, '\p{^Lb=- IS}', "");
    Expect(0, 65044, '\P{Lb=- IS}', "");
    Expect(1, 65044, '\P{^Lb=- IS}', "");
    Expect(0, 65045, '\p{Lb=- IS}', "");
    Expect(1, 65045, '\p{^Lb=- IS}', "");
    Expect(1, 65045, '\P{Lb=- IS}', "");
    Expect(0, 65045, '\P{^Lb=- IS}', "");
    Error('\p{Is_Line_Break=:=		infix_Numeric}');
    Error('\P{Is_Line_Break=:=		infix_Numeric}');
    Expect(1, 65044, '\p{Is_Line_Break=infixnumeric}', "");
    Expect(0, 65044, '\p{^Is_Line_Break=infixnumeric}', "");
    Expect(0, 65044, '\P{Is_Line_Break=infixnumeric}', "");
    Expect(1, 65044, '\P{^Is_Line_Break=infixnumeric}', "");
    Expect(0, 65045, '\p{Is_Line_Break=infixnumeric}', "");
    Expect(1, 65045, '\p{^Is_Line_Break=infixnumeric}', "");
    Expect(1, 65045, '\P{Is_Line_Break=infixnumeric}', "");
    Expect(0, 65045, '\P{^Is_Line_Break=infixnumeric}', "");
    Expect(1, 65044, '\p{Is_Line_Break=- INFIX_NUMERIC}', "");
    Expect(0, 65044, '\p{^Is_Line_Break=- INFIX_NUMERIC}', "");
    Expect(0, 65044, '\P{Is_Line_Break=- INFIX_NUMERIC}', "");
    Expect(1, 65044, '\P{^Is_Line_Break=- INFIX_NUMERIC}', "");
    Expect(0, 65045, '\p{Is_Line_Break=- INFIX_NUMERIC}', "");
    Expect(1, 65045, '\p{^Is_Line_Break=- INFIX_NUMERIC}', "");
    Expect(1, 65045, '\P{Is_Line_Break=- INFIX_NUMERIC}', "");
    Expect(0, 65045, '\P{^Is_Line_Break=- INFIX_NUMERIC}', "");
    Error('\p{Is_Lb=	is/a/}');
    Error('\P{Is_Lb=	is/a/}');
    Expect(1, 65044, '\p{Is_Lb:   is}', "");
    Expect(0, 65044, '\p{^Is_Lb:   is}', "");
    Expect(0, 65044, '\P{Is_Lb:   is}', "");
    Expect(1, 65044, '\P{^Is_Lb:   is}', "");
    Expect(0, 65045, '\p{Is_Lb:   is}', "");
    Expect(1, 65045, '\p{^Is_Lb:   is}', "");
    Expect(1, 65045, '\P{Is_Lb:   is}', "");
    Expect(0, 65045, '\P{^Is_Lb:   is}', "");
    Expect(1, 65044, '\p{Is_Lb=--IS}', "");
    Expect(0, 65044, '\p{^Is_Lb=--IS}', "");
    Expect(0, 65044, '\P{Is_Lb=--IS}', "");
    Expect(1, 65044, '\P{^Is_Lb=--IS}', "");
    Expect(0, 65045, '\p{Is_Lb=--IS}', "");
    Expect(1, 65045, '\p{^Is_Lb=--IS}', "");
    Expect(1, 65045, '\P{Is_Lb=--IS}', "");
    Expect(0, 65045, '\P{^Is_Lb=--IS}', "");
    Error('\p{Line_Break=	:=jl}');
    Error('\P{Line_Break=	:=jl}');
    Expect(1, 43388, '\p{Line_Break=:\AJL\z:}', "");;
    Expect(0, 43389, '\p{Line_Break=:\AJL\z:}', "");;
    Expect(1, 43388, '\p{Line_Break=jl}', "");
    Expect(0, 43388, '\p{^Line_Break=jl}', "");
    Expect(0, 43388, '\P{Line_Break=jl}', "");
    Expect(1, 43388, '\P{^Line_Break=jl}', "");
    Expect(0, 43389, '\p{Line_Break=jl}', "");
    Expect(1, 43389, '\p{^Line_Break=jl}', "");
    Expect(1, 43389, '\P{Line_Break=jl}', "");
    Expect(0, 43389, '\P{^Line_Break=jl}', "");
    Expect(1, 43388, '\p{Line_Break=:\Ajl\z:}', "");;
    Expect(0, 43389, '\p{Line_Break=:\Ajl\z:}', "");;
    Expect(1, 43388, '\p{Line_Break=-jl}', "");
    Expect(0, 43388, '\p{^Line_Break=-jl}', "");
    Expect(0, 43388, '\P{Line_Break=-jl}', "");
    Expect(1, 43388, '\P{^Line_Break=-jl}', "");
    Expect(0, 43389, '\p{Line_Break=-jl}', "");
    Expect(1, 43389, '\p{^Line_Break=-jl}', "");
    Expect(1, 43389, '\P{Line_Break=-jl}', "");
    Expect(0, 43389, '\P{^Line_Break=-jl}', "");
    Error('\p{Lb:	- jl/a/}');
    Error('\P{Lb:	- jl/a/}');
    Expect(1, 43388, '\p{Lb=:\AJL\z:}', "");;
    Expect(0, 43389, '\p{Lb=:\AJL\z:}', "");;
    Expect(1, 43388, '\p{Lb=jl}', "");
    Expect(0, 43388, '\p{^Lb=jl}', "");
    Expect(0, 43388, '\P{Lb=jl}', "");
    Expect(1, 43388, '\P{^Lb=jl}', "");
    Expect(0, 43389, '\p{Lb=jl}', "");
    Expect(1, 43389, '\p{^Lb=jl}', "");
    Expect(1, 43389, '\P{Lb=jl}', "");
    Expect(0, 43389, '\P{^Lb=jl}', "");
    Expect(1, 43388, '\p{Lb=:\Ajl\z:}', "");;
    Expect(0, 43389, '\p{Lb=:\Ajl\z:}', "");;
    Expect(1, 43388, '\p{Lb=	-JL}', "");
    Expect(0, 43388, '\p{^Lb=	-JL}', "");
    Expect(0, 43388, '\P{Lb=	-JL}', "");
    Expect(1, 43388, '\P{^Lb=	-JL}', "");
    Expect(0, 43389, '\p{Lb=	-JL}', "");
    Expect(1, 43389, '\p{^Lb=	-JL}', "");
    Expect(1, 43389, '\P{Lb=	-JL}', "");
    Expect(0, 43389, '\P{^Lb=	-JL}', "");
    Error('\p{Is_Line_Break=:=	JL}');
    Error('\P{Is_Line_Break=:=	JL}');
    Expect(1, 43388, '\p{Is_Line_Break=jl}', "");
    Expect(0, 43388, '\p{^Is_Line_Break=jl}', "");
    Expect(0, 43388, '\P{Is_Line_Break=jl}', "");
    Expect(1, 43388, '\P{^Is_Line_Break=jl}', "");
    Expect(0, 43389, '\p{Is_Line_Break=jl}', "");
    Expect(1, 43389, '\p{^Is_Line_Break=jl}', "");
    Expect(1, 43389, '\P{Is_Line_Break=jl}', "");
    Expect(0, 43389, '\P{^Is_Line_Break=jl}', "");
    Expect(1, 43388, '\p{Is_Line_Break=-	JL}', "");
    Expect(0, 43388, '\p{^Is_Line_Break=-	JL}', "");
    Expect(0, 43388, '\P{Is_Line_Break=-	JL}', "");
    Expect(1, 43388, '\P{^Is_Line_Break=-	JL}', "");
    Expect(0, 43389, '\p{Is_Line_Break=-	JL}', "");
    Expect(1, 43389, '\p{^Is_Line_Break=-	JL}', "");
    Expect(1, 43389, '\P{Is_Line_Break=-	JL}', "");
    Expect(0, 43389, '\P{^Is_Line_Break=-	JL}', "");
    Error('\p{Is_Lb= /a/JL}');
    Error('\P{Is_Lb= /a/JL}');
    Expect(1, 43388, '\p{Is_Lb=jl}', "");
    Expect(0, 43388, '\p{^Is_Lb=jl}', "");
    Expect(0, 43388, '\P{Is_Lb=jl}', "");
    Expect(1, 43388, '\P{^Is_Lb=jl}', "");
    Expect(0, 43389, '\p{Is_Lb=jl}', "");
    Expect(1, 43389, '\p{^Is_Lb=jl}', "");
    Expect(1, 43389, '\P{Is_Lb=jl}', "");
    Expect(0, 43389, '\P{^Is_Lb=jl}', "");
    Expect(1, 43388, '\p{Is_Lb= JL}', "");
    Expect(0, 43388, '\p{^Is_Lb= JL}', "");
    Expect(0, 43388, '\P{Is_Lb= JL}', "");
    Expect(1, 43388, '\P{^Is_Lb= JL}', "");
    Expect(0, 43389, '\p{Is_Lb= JL}', "");
    Expect(1, 43389, '\p{^Is_Lb= JL}', "");
    Expect(1, 43389, '\P{Is_Lb= JL}', "");
    Expect(0, 43389, '\P{^Is_Lb= JL}', "");
    Error('\p{Line_Break=/a/ 	JT}');
    Error('\P{Line_Break=/a/ 	JT}');
    Expect(1, 55291, '\p{Line_Break=:\AJT\z:}', "");;
    Expect(0, 55292, '\p{Line_Break=:\AJT\z:}', "");;
    Expect(1, 55291, '\p{Line_Break=jt}', "");
    Expect(0, 55291, '\p{^Line_Break=jt}', "");
    Expect(0, 55291, '\P{Line_Break=jt}', "");
    Expect(1, 55291, '\P{^Line_Break=jt}', "");
    Expect(0, 55292, '\p{Line_Break=jt}', "");
    Expect(1, 55292, '\p{^Line_Break=jt}', "");
    Expect(1, 55292, '\P{Line_Break=jt}', "");
    Expect(0, 55292, '\P{^Line_Break=jt}', "");
    Expect(1, 55291, '\p{Line_Break=:\Ajt\z:}', "");;
    Expect(0, 55292, '\p{Line_Break=:\Ajt\z:}', "");;
    Expect(1, 55291, '\p{Line_Break:	 _JT}', "");
    Expect(0, 55291, '\p{^Line_Break:	 _JT}', "");
    Expect(0, 55291, '\P{Line_Break:	 _JT}', "");
    Expect(1, 55291, '\P{^Line_Break:	 _JT}', "");
    Expect(0, 55292, '\p{Line_Break:	 _JT}', "");
    Expect(1, 55292, '\p{^Line_Break:	 _JT}', "");
    Expect(1, 55292, '\P{Line_Break:	 _JT}', "");
    Expect(0, 55292, '\P{^Line_Break:	 _JT}', "");
    Error('\p{Lb=_/a/JT}');
    Error('\P{Lb=_/a/JT}');
    Expect(1, 55291, '\p{Lb=:\AJT\z:}', "");;
    Expect(0, 55292, '\p{Lb=:\AJT\z:}', "");;
    Expect(1, 55291, '\p{Lb=jt}', "");
    Expect(0, 55291, '\p{^Lb=jt}', "");
    Expect(0, 55291, '\P{Lb=jt}', "");
    Expect(1, 55291, '\P{^Lb=jt}', "");
    Expect(0, 55292, '\p{Lb=jt}', "");
    Expect(1, 55292, '\p{^Lb=jt}', "");
    Expect(1, 55292, '\P{Lb=jt}', "");
    Expect(0, 55292, '\P{^Lb=jt}', "");
    Expect(1, 55291, '\p{Lb=:\Ajt\z:}', "");;
    Expect(0, 55292, '\p{Lb=:\Ajt\z:}', "");;
    Expect(1, 55291, '\p{Lb=	jt}', "");
    Expect(0, 55291, '\p{^Lb=	jt}', "");
    Expect(0, 55291, '\P{Lb=	jt}', "");
    Expect(1, 55291, '\P{^Lb=	jt}', "");
    Expect(0, 55292, '\p{Lb=	jt}', "");
    Expect(1, 55292, '\p{^Lb=	jt}', "");
    Expect(1, 55292, '\P{Lb=	jt}', "");
    Expect(0, 55292, '\P{^Lb=	jt}', "");
    Error('\p{Is_Line_Break= :=JT}');
    Error('\P{Is_Line_Break= :=JT}');
    Expect(1, 55291, '\p{Is_Line_Break=jt}', "");
    Expect(0, 55291, '\p{^Is_Line_Break=jt}', "");
    Expect(0, 55291, '\P{Is_Line_Break=jt}', "");
    Expect(1, 55291, '\P{^Is_Line_Break=jt}', "");
    Expect(0, 55292, '\p{Is_Line_Break=jt}', "");
    Expect(1, 55292, '\p{^Is_Line_Break=jt}', "");
    Expect(1, 55292, '\P{Is_Line_Break=jt}', "");
    Expect(0, 55292, '\P{^Is_Line_Break=jt}', "");
    Expect(1, 55291, '\p{Is_Line_Break= _JT}', "");
    Expect(0, 55291, '\p{^Is_Line_Break= _JT}', "");
    Expect(0, 55291, '\P{Is_Line_Break= _JT}', "");
    Expect(1, 55291, '\P{^Is_Line_Break= _JT}', "");
    Expect(0, 55292, '\p{Is_Line_Break= _JT}', "");
    Expect(1, 55292, '\p{^Is_Line_Break= _JT}', "");
    Expect(1, 55292, '\P{Is_Line_Break= _JT}', "");
    Expect(0, 55292, '\P{^Is_Line_Break= _JT}', "");
    Error('\p{Is_Lb= /a/jt}');
    Error('\P{Is_Lb= /a/jt}');
    Expect(1, 55291, '\p{Is_Lb=jt}', "");
    Expect(0, 55291, '\p{^Is_Lb=jt}', "");
    Expect(0, 55291, '\P{Is_Lb=jt}', "");
    Expect(1, 55291, '\P{^Is_Lb=jt}', "");
    Expect(0, 55292, '\p{Is_Lb=jt}', "");
    Expect(1, 55292, '\p{^Is_Lb=jt}', "");
    Expect(1, 55292, '\P{Is_Lb=jt}', "");
    Expect(0, 55292, '\P{^Is_Lb=jt}', "");
    Expect(1, 55291, '\p{Is_Lb:   		JT}', "");
    Expect(0, 55291, '\p{^Is_Lb:   		JT}', "");
    Expect(0, 55291, '\P{Is_Lb:   		JT}', "");
    Expect(1, 55291, '\P{^Is_Lb:   		JT}', "");
    Expect(0, 55292, '\p{Is_Lb:   		JT}', "");
    Expect(1, 55292, '\p{^Is_Lb:   		JT}', "");
    Expect(1, 55292, '\P{Is_Lb:   		JT}', "");
    Expect(0, 55292, '\P{^Is_Lb:   		JT}', "");
    Error('\p{Line_Break:		-JV/a/}');
    Error('\P{Line_Break:		-JV/a/}');
    Expect(1, 55238, '\p{Line_Break=:\AJV\z:}', "");;
    Expect(0, 55239, '\p{Line_Break=:\AJV\z:}', "");;
    Expect(1, 55238, '\p{Line_Break=jv}', "");
    Expect(0, 55238, '\p{^Line_Break=jv}', "");
    Expect(0, 55238, '\P{Line_Break=jv}', "");
    Expect(1, 55238, '\P{^Line_Break=jv}', "");
    Expect(0, 55239, '\p{Line_Break=jv}', "");
    Expect(1, 55239, '\p{^Line_Break=jv}', "");
    Expect(1, 55239, '\P{Line_Break=jv}', "");
    Expect(0, 55239, '\P{^Line_Break=jv}', "");
    Expect(1, 55238, '\p{Line_Break=:\Ajv\z:}', "");;
    Expect(0, 55239, '\p{Line_Break=:\Ajv\z:}', "");;
    Expect(1, 55238, '\p{Line_Break=--JV}', "");
    Expect(0, 55238, '\p{^Line_Break=--JV}', "");
    Expect(0, 55238, '\P{Line_Break=--JV}', "");
    Expect(1, 55238, '\P{^Line_Break=--JV}', "");
    Expect(0, 55239, '\p{Line_Break=--JV}', "");
    Expect(1, 55239, '\p{^Line_Break=--JV}', "");
    Expect(1, 55239, '\P{Line_Break=--JV}', "");
    Expect(0, 55239, '\P{^Line_Break=--JV}', "");
    Error('\p{Lb=/a/_jv}');
    Error('\P{Lb=/a/_jv}');
    Expect(1, 55238, '\p{Lb=:\AJV\z:}', "");;
    Expect(0, 55239, '\p{Lb=:\AJV\z:}', "");;
    Expect(1, 55238, '\p{Lb=jv}', "");
    Expect(0, 55238, '\p{^Lb=jv}', "");
    Expect(0, 55238, '\P{Lb=jv}', "");
    Expect(1, 55238, '\P{^Lb=jv}', "");
    Expect(0, 55239, '\p{Lb=jv}', "");
    Expect(1, 55239, '\p{^Lb=jv}', "");
    Expect(1, 55239, '\P{Lb=jv}', "");
    Expect(0, 55239, '\P{^Lb=jv}', "");
    Expect(1, 55238, '\p{Lb=:\Ajv\z:}', "");;
    Expect(0, 55239, '\p{Lb=:\Ajv\z:}', "");;
    Expect(1, 55238, '\p{Lb= 	jv}', "");
    Expect(0, 55238, '\p{^Lb= 	jv}', "");
    Expect(0, 55238, '\P{Lb= 	jv}', "");
    Expect(1, 55238, '\P{^Lb= 	jv}', "");
    Expect(0, 55239, '\p{Lb= 	jv}', "");
    Expect(1, 55239, '\p{^Lb= 	jv}', "");
    Expect(1, 55239, '\P{Lb= 	jv}', "");
    Expect(0, 55239, '\P{^Lb= 	jv}', "");
    Error('\p{Is_Line_Break=-:=JV}');
    Error('\P{Is_Line_Break=-:=JV}');
    Expect(1, 55238, '\p{Is_Line_Break=jv}', "");
    Expect(0, 55238, '\p{^Is_Line_Break=jv}', "");
    Expect(0, 55238, '\P{Is_Line_Break=jv}', "");
    Expect(1, 55238, '\P{^Is_Line_Break=jv}', "");
    Expect(0, 55239, '\p{Is_Line_Break=jv}', "");
    Expect(1, 55239, '\p{^Is_Line_Break=jv}', "");
    Expect(1, 55239, '\P{Is_Line_Break=jv}', "");
    Expect(0, 55239, '\P{^Is_Line_Break=jv}', "");
    Expect(1, 55238, '\p{Is_Line_Break=-	JV}', "");
    Expect(0, 55238, '\p{^Is_Line_Break=-	JV}', "");
    Expect(0, 55238, '\P{Is_Line_Break=-	JV}', "");
    Expect(1, 55238, '\P{^Is_Line_Break=-	JV}', "");
    Expect(0, 55239, '\p{Is_Line_Break=-	JV}', "");
    Expect(1, 55239, '\p{^Is_Line_Break=-	JV}', "");
    Expect(1, 55239, '\P{Is_Line_Break=-	JV}', "");
    Expect(0, 55239, '\P{^Is_Line_Break=-	JV}', "");
    Error('\p{Is_Lb:/a/_jv}');
    Error('\P{Is_Lb:/a/_jv}');
    Expect(1, 55238, '\p{Is_Lb=jv}', "");
    Expect(0, 55238, '\p{^Is_Lb=jv}', "");
    Expect(0, 55238, '\P{Is_Lb=jv}', "");
    Expect(1, 55238, '\P{^Is_Lb=jv}', "");
    Expect(0, 55239, '\p{Is_Lb=jv}', "");
    Expect(1, 55239, '\p{^Is_Lb=jv}', "");
    Expect(1, 55239, '\P{Is_Lb=jv}', "");
    Expect(0, 55239, '\P{^Is_Lb=jv}', "");
    Expect(1, 55238, '\p{Is_Lb=-_jv}', "");
    Expect(0, 55238, '\p{^Is_Lb=-_jv}', "");
    Expect(0, 55238, '\P{Is_Lb=-_jv}', "");
    Expect(1, 55238, '\P{^Is_Lb=-_jv}', "");
    Expect(0, 55239, '\p{Is_Lb=-_jv}', "");
    Expect(1, 55239, '\p{^Is_Lb=-_jv}', "");
    Expect(1, 55239, '\P{Is_Lb=-_jv}', "");
    Expect(0, 55239, '\P{^Is_Lb=-_jv}', "");
    Error('\p{Line_Break=:=__Line_FEED}');
    Error('\P{Line_Break=:=__Line_FEED}');
    Expect(1, 10, '\p{Line_Break=:\ALine_Feed\z:}', "");;
    Expect(0, 11, '\p{Line_Break=:\ALine_Feed\z:}', "");;
    Expect(1, 10, '\p{Line_Break=linefeed}', "");
    Expect(0, 10, '\p{^Line_Break=linefeed}', "");
    Expect(0, 10, '\P{Line_Break=linefeed}', "");
    Expect(1, 10, '\P{^Line_Break=linefeed}', "");
    Expect(0, 11, '\p{Line_Break=linefeed}', "");
    Expect(1, 11, '\p{^Line_Break=linefeed}', "");
    Expect(1, 11, '\P{Line_Break=linefeed}', "");
    Expect(0, 11, '\P{^Line_Break=linefeed}', "");
    Expect(1, 10, '\p{Line_Break=:\Alinefeed\z:}', "");;
    Expect(0, 11, '\p{Line_Break=:\Alinefeed\z:}', "");;
    Expect(1, 10, '\p{Line_Break=	_Line_FEED}', "");
    Expect(0, 10, '\p{^Line_Break=	_Line_FEED}', "");
    Expect(0, 10, '\P{Line_Break=	_Line_FEED}', "");
    Expect(1, 10, '\P{^Line_Break=	_Line_FEED}', "");
    Expect(0, 11, '\p{Line_Break=	_Line_FEED}', "");
    Expect(1, 11, '\p{^Line_Break=	_Line_FEED}', "");
    Expect(1, 11, '\P{Line_Break=	_Line_FEED}', "");
    Expect(0, 11, '\P{^Line_Break=	_Line_FEED}', "");
    Error('\p{Lb=:=- LF}');
    Error('\P{Lb=:=- LF}');
    Expect(1, 10, '\p{Lb=:\ALF\z:}', "");;
    Expect(0, 11, '\p{Lb=:\ALF\z:}', "");;
    Expect(1, 10, '\p{Lb=lf}', "");
    Expect(0, 10, '\p{^Lb=lf}', "");
    Expect(0, 10, '\P{Lb=lf}', "");
    Expect(1, 10, '\P{^Lb=lf}', "");
    Expect(0, 11, '\p{Lb=lf}', "");
    Expect(1, 11, '\p{^Lb=lf}', "");
    Expect(1, 11, '\P{Lb=lf}', "");
    Expect(0, 11, '\P{^Lb=lf}', "");
    Expect(1, 10, '\p{Lb=:\Alf\z:}', "");;
    Expect(0, 11, '\p{Lb=:\Alf\z:}', "");;
    Expect(1, 10, '\p{Lb=-	LF}', "");
    Expect(0, 10, '\p{^Lb=-	LF}', "");
    Expect(0, 10, '\P{Lb=-	LF}', "");
    Expect(1, 10, '\P{^Lb=-	LF}', "");
    Expect(0, 11, '\p{Lb=-	LF}', "");
    Expect(1, 11, '\p{^Lb=-	LF}', "");
    Expect(1, 11, '\P{Lb=-	LF}', "");
    Expect(0, 11, '\P{^Lb=-	LF}', "");
    Error('\p{Is_Line_Break= line_Feed/a/}');
    Error('\P{Is_Line_Break= line_Feed/a/}');
    Expect(1, 10, '\p{Is_Line_Break=linefeed}', "");
    Expect(0, 10, '\p{^Is_Line_Break=linefeed}', "");
    Expect(0, 10, '\P{Is_Line_Break=linefeed}', "");
    Expect(1, 10, '\P{^Is_Line_Break=linefeed}', "");
    Expect(0, 11, '\p{Is_Line_Break=linefeed}', "");
    Expect(1, 11, '\p{^Is_Line_Break=linefeed}', "");
    Expect(1, 11, '\P{Is_Line_Break=linefeed}', "");
    Expect(0, 11, '\P{^Is_Line_Break=linefeed}', "");
    Expect(1, 10, '\p{Is_Line_Break=		LINE_FEED}', "");
    Expect(0, 10, '\p{^Is_Line_Break=		LINE_FEED}', "");
    Expect(0, 10, '\P{Is_Line_Break=		LINE_FEED}', "");
    Expect(1, 10, '\P{^Is_Line_Break=		LINE_FEED}', "");
    Expect(0, 11, '\p{Is_Line_Break=		LINE_FEED}', "");
    Expect(1, 11, '\p{^Is_Line_Break=		LINE_FEED}', "");
    Expect(1, 11, '\P{Is_Line_Break=		LINE_FEED}', "");
    Expect(0, 11, '\P{^Is_Line_Break=		LINE_FEED}', "");
    Error('\p{Is_Lb=LF:=}');
    Error('\P{Is_Lb=LF:=}');
    Expect(1, 10, '\p{Is_Lb=lf}', "");
    Expect(0, 10, '\p{^Is_Lb=lf}', "");
    Expect(0, 10, '\P{Is_Lb=lf}', "");
    Expect(1, 10, '\P{^Is_Lb=lf}', "");
    Expect(0, 11, '\p{Is_Lb=lf}', "");
    Expect(1, 11, '\p{^Is_Lb=lf}', "");
    Expect(1, 11, '\P{Is_Lb=lf}', "");
    Expect(0, 11, '\P{^Is_Lb=lf}', "");
    Expect(1, 10, '\p{Is_Lb= LF}', "");
    Expect(0, 10, '\p{^Is_Lb= LF}', "");
    Expect(0, 10, '\P{Is_Lb= LF}', "");
    Expect(1, 10, '\P{^Is_Lb= LF}', "");
    Expect(0, 11, '\p{Is_Lb= LF}', "");
    Expect(1, 11, '\p{^Is_Lb= LF}', "");
    Expect(1, 11, '\P{Is_Lb= LF}', "");
    Expect(0, 11, '\P{^Is_Lb= LF}', "");
    Error('\p{Line_Break=/a/  next_Line}');
    Error('\P{Line_Break=/a/  next_Line}');
    Expect(1, 133, '\p{Line_Break=:\ANext_Line\z:}', "");;
    Expect(0, 134, '\p{Line_Break=:\ANext_Line\z:}', "");;
    Expect(1, 133, '\p{Line_Break=nextline}', "");
    Expect(0, 133, '\p{^Line_Break=nextline}', "");
    Expect(0, 133, '\P{Line_Break=nextline}', "");
    Expect(1, 133, '\P{^Line_Break=nextline}', "");
    Expect(0, 134, '\p{Line_Break=nextline}', "");
    Expect(1, 134, '\p{^Line_Break=nextline}', "");
    Expect(1, 134, '\P{Line_Break=nextline}', "");
    Expect(0, 134, '\P{^Line_Break=nextline}', "");
    Expect(1, 133, '\p{Line_Break=:\Anextline\z:}', "");;
    Expect(0, 134, '\p{Line_Break=:\Anextline\z:}', "");;
    Expect(1, 133, '\p{Line_Break=	Next_LINE}', "");
    Expect(0, 133, '\p{^Line_Break=	Next_LINE}', "");
    Expect(0, 133, '\P{Line_Break=	Next_LINE}', "");
    Expect(1, 133, '\P{^Line_Break=	Next_LINE}', "");
    Expect(0, 134, '\p{Line_Break=	Next_LINE}', "");
    Expect(1, 134, '\p{^Line_Break=	Next_LINE}', "");
    Expect(1, 134, '\P{Line_Break=	Next_LINE}', "");
    Expect(0, 134, '\P{^Line_Break=	Next_LINE}', "");
    Error('\p{Lb=	:=NL}');
    Error('\P{Lb=	:=NL}');
    Expect(1, 133, '\p{Lb=:\ANL\z:}', "");;
    Expect(0, 134, '\p{Lb=:\ANL\z:}', "");;
    Expect(1, 133, '\p{Lb:   nl}', "");
    Expect(0, 133, '\p{^Lb:   nl}', "");
    Expect(0, 133, '\P{Lb:   nl}', "");
    Expect(1, 133, '\P{^Lb:   nl}', "");
    Expect(0, 134, '\p{Lb:   nl}', "");
    Expect(1, 134, '\p{^Lb:   nl}', "");
    Expect(1, 134, '\P{Lb:   nl}', "");
    Expect(0, 134, '\P{^Lb:   nl}', "");
    Expect(1, 133, '\p{Lb=:\Anl\z:}', "");;
    Expect(0, 134, '\p{Lb=:\Anl\z:}', "");;
    Expect(1, 133, '\p{Lb:	_	NL}', "");
    Expect(0, 133, '\p{^Lb:	_	NL}', "");
    Expect(0, 133, '\P{Lb:	_	NL}', "");
    Expect(1, 133, '\P{^Lb:	_	NL}', "");
    Expect(0, 134, '\p{Lb:	_	NL}', "");
    Expect(1, 134, '\p{^Lb:	_	NL}', "");
    Expect(1, 134, '\P{Lb:	_	NL}', "");
    Expect(0, 134, '\P{^Lb:	_	NL}', "");
    Error('\p{Is_Line_Break=_-Next_Line/a/}');
    Error('\P{Is_Line_Break=_-Next_Line/a/}');
    Expect(1, 133, '\p{Is_Line_Break=nextline}', "");
    Expect(0, 133, '\p{^Is_Line_Break=nextline}', "");
    Expect(0, 133, '\P{Is_Line_Break=nextline}', "");
    Expect(1, 133, '\P{^Is_Line_Break=nextline}', "");
    Expect(0, 134, '\p{Is_Line_Break=nextline}', "");
    Expect(1, 134, '\p{^Is_Line_Break=nextline}', "");
    Expect(1, 134, '\P{Is_Line_Break=nextline}', "");
    Expect(0, 134, '\P{^Is_Line_Break=nextline}', "");
    Expect(1, 133, '\p{Is_Line_Break=_-Next_Line}', "");
    Expect(0, 133, '\p{^Is_Line_Break=_-Next_Line}', "");
    Expect(0, 133, '\P{Is_Line_Break=_-Next_Line}', "");
    Expect(1, 133, '\P{^Is_Line_Break=_-Next_Line}', "");
    Expect(0, 134, '\p{Is_Line_Break=_-Next_Line}', "");
    Expect(1, 134, '\p{^Is_Line_Break=_-Next_Line}', "");
    Expect(1, 134, '\P{Is_Line_Break=_-Next_Line}', "");
    Expect(0, 134, '\P{^Is_Line_Break=_-Next_Line}', "");
    Error('\p{Is_Lb=/a/-NL}');
    Error('\P{Is_Lb=/a/-NL}');
    Expect(1, 133, '\p{Is_Lb=nl}', "");
    Expect(0, 133, '\p{^Is_Lb=nl}', "");
    Expect(0, 133, '\P{Is_Lb=nl}', "");
    Expect(1, 133, '\P{^Is_Lb=nl}', "");
    Expect(0, 134, '\p{Is_Lb=nl}', "");
    Expect(1, 134, '\p{^Is_Lb=nl}', "");
    Expect(1, 134, '\P{Is_Lb=nl}', "");
    Expect(0, 134, '\P{^Is_Lb=nl}', "");
    Error('\p{Line_Break=:=-_NONSTARTER}');
    Error('\P{Line_Break=:=-_NONSTARTER}');
    Expect(1, 128635, '\p{Line_Break=:\ANonstarter\z:}', "");;
    Expect(0, 128636, '\p{Line_Break=:\ANonstarter\z:}', "");;
    Expect(1, 128635, '\p{Line_Break=nonstarter}', "");
    Expect(0, 128635, '\p{^Line_Break=nonstarter}', "");
    Expect(0, 128635, '\P{Line_Break=nonstarter}', "");
    Expect(1, 128635, '\P{^Line_Break=nonstarter}', "");
    Expect(0, 128636, '\p{Line_Break=nonstarter}', "");
    Expect(1, 128636, '\p{^Line_Break=nonstarter}', "");
    Expect(1, 128636, '\P{Line_Break=nonstarter}', "");
    Expect(0, 128636, '\P{^Line_Break=nonstarter}', "");
    Expect(1, 128635, '\p{Line_Break=:\Anonstarter\z:}', "");;
    Expect(0, 128636, '\p{Line_Break=:\Anonstarter\z:}', "");;
    Expect(1, 128635, '\p{Line_Break:   	 Nonstarter}', "");
    Expect(0, 128635, '\p{^Line_Break:   	 Nonstarter}', "");
    Expect(0, 128635, '\P{Line_Break:   	 Nonstarter}', "");
    Expect(1, 128635, '\P{^Line_Break:   	 Nonstarter}', "");
    Expect(0, 128636, '\p{Line_Break:   	 Nonstarter}', "");
    Expect(1, 128636, '\p{^Line_Break:   	 Nonstarter}', "");
    Expect(1, 128636, '\P{Line_Break:   	 Nonstarter}', "");
    Expect(0, 128636, '\P{^Line_Break:   	 Nonstarter}', "");
    Error('\p{Lb=:=--NS}');
    Error('\P{Lb=:=--NS}');
    Expect(1, 128635, '\p{Lb=:\ANS\z:}', "");;
    Expect(0, 128636, '\p{Lb=:\ANS\z:}', "");;
    Expect(1, 128635, '\p{Lb=ns}', "");
    Expect(0, 128635, '\p{^Lb=ns}', "");
    Expect(0, 128635, '\P{Lb=ns}', "");
    Expect(1, 128635, '\P{^Lb=ns}', "");
    Expect(0, 128636, '\p{Lb=ns}', "");
    Expect(1, 128636, '\p{^Lb=ns}', "");
    Expect(1, 128636, '\P{Lb=ns}', "");
    Expect(0, 128636, '\P{^Lb=ns}', "");
    Expect(1, 128635, '\p{Lb=:\Ans\z:}', "");;
    Expect(0, 128636, '\p{Lb=:\Ans\z:}', "");;
    Expect(1, 128635, '\p{Lb=_	ns}', "");
    Expect(0, 128635, '\p{^Lb=_	ns}', "");
    Expect(0, 128635, '\P{Lb=_	ns}', "");
    Expect(1, 128635, '\P{^Lb=_	ns}', "");
    Expect(0, 128636, '\p{Lb=_	ns}', "");
    Expect(1, 128636, '\p{^Lb=_	ns}', "");
    Expect(1, 128636, '\P{Lb=_	ns}', "");
    Expect(0, 128636, '\P{^Lb=_	ns}', "");
    Error('\p{Is_Line_Break:		:=nonstarter}');
    Error('\P{Is_Line_Break:		:=nonstarter}');
    Expect(1, 128635, '\p{Is_Line_Break:	nonstarter}', "");
    Expect(0, 128635, '\p{^Is_Line_Break:	nonstarter}', "");
    Expect(0, 128635, '\P{Is_Line_Break:	nonstarter}', "");
    Expect(1, 128635, '\P{^Is_Line_Break:	nonstarter}', "");
    Expect(0, 128636, '\p{Is_Line_Break:	nonstarter}', "");
    Expect(1, 128636, '\p{^Is_Line_Break:	nonstarter}', "");
    Expect(1, 128636, '\P{Is_Line_Break:	nonstarter}', "");
    Expect(0, 128636, '\P{^Is_Line_Break:	nonstarter}', "");
    Expect(1, 128635, '\p{Is_Line_Break=-	Nonstarter}', "");
    Expect(0, 128635, '\p{^Is_Line_Break=-	Nonstarter}', "");
    Expect(0, 128635, '\P{Is_Line_Break=-	Nonstarter}', "");
    Expect(1, 128635, '\P{^Is_Line_Break=-	Nonstarter}', "");
    Expect(0, 128636, '\p{Is_Line_Break=-	Nonstarter}', "");
    Expect(1, 128636, '\p{^Is_Line_Break=-	Nonstarter}', "");
    Expect(1, 128636, '\P{Is_Line_Break=-	Nonstarter}', "");
    Expect(0, 128636, '\P{^Is_Line_Break=-	Nonstarter}', "");
    Error('\p{Is_Lb=:=_ns}');
    Error('\P{Is_Lb=:=_ns}');
    Expect(1, 128635, '\p{Is_Lb=ns}', "");
    Expect(0, 128635, '\p{^Is_Lb=ns}', "");
    Expect(0, 128635, '\P{Is_Lb=ns}', "");
    Expect(1, 128635, '\P{^Is_Lb=ns}', "");
    Expect(0, 128636, '\p{Is_Lb=ns}', "");
    Expect(1, 128636, '\p{^Is_Lb=ns}', "");
    Expect(1, 128636, '\P{Is_Lb=ns}', "");
    Expect(0, 128636, '\P{^Is_Lb=ns}', "");
    Expect(1, 128635, '\p{Is_Lb=_	ns}', "");
    Expect(0, 128635, '\p{^Is_Lb=_	ns}', "");
    Expect(0, 128635, '\P{Is_Lb=_	ns}', "");
    Expect(1, 128635, '\P{^Is_Lb=_	ns}', "");
    Expect(0, 128636, '\p{Is_Lb=_	ns}', "");
    Expect(1, 128636, '\p{^Is_Lb=_	ns}', "");
    Expect(1, 128636, '\P{Is_Lb=_	ns}', "");
    Expect(0, 128636, '\P{^Is_Lb=_	ns}', "");
    Error('\p{Line_Break=	/a/NUMERIC}');
    Error('\P{Line_Break=	/a/NUMERIC}');
    Expect(1, 130041, '\p{Line_Break=:\ANumeric\z:}', "");;
    Expect(0, 130042, '\p{Line_Break=:\ANumeric\z:}', "");;
    Expect(1, 130041, '\p{Line_Break=numeric}', "");
    Expect(0, 130041, '\p{^Line_Break=numeric}', "");
    Expect(0, 130041, '\P{Line_Break=numeric}', "");
    Expect(1, 130041, '\P{^Line_Break=numeric}', "");
    Expect(0, 130042, '\p{Line_Break=numeric}', "");
    Expect(1, 130042, '\p{^Line_Break=numeric}', "");
    Expect(1, 130042, '\P{Line_Break=numeric}', "");
    Expect(0, 130042, '\P{^Line_Break=numeric}', "");
    Expect(1, 130041, '\p{Line_Break=:\Anumeric\z:}', "");;
    Expect(0, 130042, '\p{Line_Break=:\Anumeric\z:}', "");;
    Expect(1, 130041, '\p{Line_Break=_ numeric}', "");
    Expect(0, 130041, '\p{^Line_Break=_ numeric}', "");
    Expect(0, 130041, '\P{Line_Break=_ numeric}', "");
    Expect(1, 130041, '\P{^Line_Break=_ numeric}', "");
    Expect(0, 130042, '\p{Line_Break=_ numeric}', "");
    Expect(1, 130042, '\p{^Line_Break=_ numeric}', "");
    Expect(1, 130042, '\P{Line_Break=_ numeric}', "");
    Expect(0, 130042, '\P{^Line_Break=_ numeric}', "");
    Error('\p{Lb=- NU:=}');
    Error('\P{Lb=- NU:=}');
    Expect(1, 130041, '\p{Lb=:\ANU\z:}', "");;
    Expect(0, 130042, '\p{Lb=:\ANU\z:}', "");;
    Expect(1, 130041, '\p{Lb=nu}', "");
    Expect(0, 130041, '\p{^Lb=nu}', "");
    Expect(0, 130041, '\P{Lb=nu}', "");
    Expect(1, 130041, '\P{^Lb=nu}', "");
    Expect(0, 130042, '\p{Lb=nu}', "");
    Expect(1, 130042, '\p{^Lb=nu}', "");
    Expect(1, 130042, '\P{Lb=nu}', "");
    Expect(0, 130042, '\P{^Lb=nu}', "");
    Expect(1, 130041, '\p{Lb=:\Anu\z:}', "");;
    Expect(0, 130042, '\p{Lb=:\Anu\z:}', "");;
    Expect(1, 130041, '\p{Lb=-	NU}', "");
    Expect(0, 130041, '\p{^Lb=-	NU}', "");
    Expect(0, 130041, '\P{Lb=-	NU}', "");
    Expect(1, 130041, '\P{^Lb=-	NU}', "");
    Expect(0, 130042, '\p{Lb=-	NU}', "");
    Expect(1, 130042, '\p{^Lb=-	NU}', "");
    Expect(1, 130042, '\P{Lb=-	NU}', "");
    Expect(0, 130042, '\P{^Lb=-	NU}', "");
    Error('\p{Is_Line_Break=_:=Numeric}');
    Error('\P{Is_Line_Break=_:=Numeric}');
    Expect(1, 130041, '\p{Is_Line_Break=numeric}', "");
    Expect(0, 130041, '\p{^Is_Line_Break=numeric}', "");
    Expect(0, 130041, '\P{Is_Line_Break=numeric}', "");
    Expect(1, 130041, '\P{^Is_Line_Break=numeric}', "");
    Expect(0, 130042, '\p{Is_Line_Break=numeric}', "");
    Expect(1, 130042, '\p{^Is_Line_Break=numeric}', "");
    Expect(1, 130042, '\P{Is_Line_Break=numeric}', "");
    Expect(0, 130042, '\P{^Is_Line_Break=numeric}', "");
    Expect(1, 130041, '\p{Is_Line_Break=--Numeric}', "");
    Expect(0, 130041, '\p{^Is_Line_Break=--Numeric}', "");
    Expect(0, 130041, '\P{Is_Line_Break=--Numeric}', "");
    Expect(1, 130041, '\P{^Is_Line_Break=--Numeric}', "");
    Expect(0, 130042, '\p{Is_Line_Break=--Numeric}', "");
    Expect(1, 130042, '\p{^Is_Line_Break=--Numeric}', "");
    Expect(1, 130042, '\P{Is_Line_Break=--Numeric}', "");
    Expect(0, 130042, '\P{^Is_Line_Break=--Numeric}', "");
    Error('\p{Is_Lb=--NU:=}');
    Error('\P{Is_Lb=--NU:=}');
    Expect(1, 130041, '\p{Is_Lb=nu}', "");
    Expect(0, 130041, '\p{^Is_Lb=nu}', "");
    Expect(0, 130041, '\P{Is_Lb=nu}', "");
    Expect(1, 130041, '\P{^Is_Lb=nu}', "");
    Expect(0, 130042, '\p{Is_Lb=nu}', "");
    Expect(1, 130042, '\p{^Is_Lb=nu}', "");
    Expect(1, 130042, '\P{Is_Lb=nu}', "");
    Expect(0, 130042, '\P{^Is_Lb=nu}', "");
    Expect(1, 130041, '\p{Is_Lb=-_NU}', "");
    Expect(0, 130041, '\p{^Is_Lb=-_NU}', "");
    Expect(0, 130041, '\P{Is_Lb=-_NU}', "");
    Expect(1, 130041, '\P{^Is_Lb=-_NU}', "");
    Expect(0, 130042, '\p{Is_Lb=-_NU}', "");
    Expect(1, 130042, '\p{^Is_Lb=-_NU}', "");
    Expect(1, 130042, '\P{Is_Lb=-_NU}', "");
    Expect(0, 130042, '\P{^Is_Lb=-_NU}', "");
    Error('\p{Line_Break=	/a/Open_PUNCTUATION}');
    Error('\P{Line_Break=	/a/Open_PUNCTUATION}');
    Expect(1, 125279, '\p{Line_Break=:\AOpen_Punctuation\z:}', "");;
    Expect(0, 125280, '\p{Line_Break=:\AOpen_Punctuation\z:}', "");;
    Expect(1, 125279, '\p{Line_Break=openpunctuation}', "");
    Expect(0, 125279, '\p{^Line_Break=openpunctuation}', "");
    Expect(0, 125279, '\P{Line_Break=openpunctuation}', "");
    Expect(1, 125279, '\P{^Line_Break=openpunctuation}', "");
    Expect(0, 125280, '\p{Line_Break=openpunctuation}', "");
    Expect(1, 125280, '\p{^Line_Break=openpunctuation}', "");
    Expect(1, 125280, '\P{Line_Break=openpunctuation}', "");
    Expect(0, 125280, '\P{^Line_Break=openpunctuation}', "");
    Expect(1, 125279, '\p{Line_Break=:\Aopenpunctuation\z:}', "");;
    Expect(0, 125280, '\p{Line_Break=:\Aopenpunctuation\z:}', "");;
    Expect(1, 125279, '\p{Line_Break=_Open_Punctuation}', "");
    Expect(0, 125279, '\p{^Line_Break=_Open_Punctuation}', "");
    Expect(0, 125279, '\P{Line_Break=_Open_Punctuation}', "");
    Expect(1, 125279, '\P{^Line_Break=_Open_Punctuation}', "");
    Expect(0, 125280, '\p{Line_Break=_Open_Punctuation}', "");
    Expect(1, 125280, '\p{^Line_Break=_Open_Punctuation}', "");
    Expect(1, 125280, '\P{Line_Break=_Open_Punctuation}', "");
    Expect(0, 125280, '\P{^Line_Break=_Open_Punctuation}', "");
    Error('\p{Lb=-OP:=}');
    Error('\P{Lb=-OP:=}');
    Expect(1, 125279, '\p{Lb=:\AOP\z:}', "");;
    Expect(0, 125280, '\p{Lb=:\AOP\z:}', "");;
    Expect(1, 125279, '\p{Lb=op}', "");
    Expect(0, 125279, '\p{^Lb=op}', "");
    Expect(0, 125279, '\P{Lb=op}', "");
    Expect(1, 125279, '\P{^Lb=op}', "");
    Expect(0, 125280, '\p{Lb=op}', "");
    Expect(1, 125280, '\p{^Lb=op}', "");
    Expect(1, 125280, '\P{Lb=op}', "");
    Expect(0, 125280, '\P{^Lb=op}', "");
    Expect(1, 125279, '\p{Lb=:\Aop\z:}', "");;
    Expect(0, 125280, '\p{Lb=:\Aop\z:}', "");;
    Expect(1, 125279, '\p{Lb= OP}', "");
    Expect(0, 125279, '\p{^Lb= OP}', "");
    Expect(0, 125279, '\P{Lb= OP}', "");
    Expect(1, 125279, '\P{^Lb= OP}', "");
    Expect(0, 125280, '\p{Lb= OP}', "");
    Expect(1, 125280, '\p{^Lb= OP}', "");
    Expect(1, 125280, '\P{Lb= OP}', "");
    Expect(0, 125280, '\P{^Lb= OP}', "");
    Error('\p{Is_Line_Break=:= _OPEN_punctuation}');
    Error('\P{Is_Line_Break=:= _OPEN_punctuation}');
    Expect(1, 125279, '\p{Is_Line_Break=openpunctuation}', "");
    Expect(0, 125279, '\p{^Is_Line_Break=openpunctuation}', "");
    Expect(0, 125279, '\P{Is_Line_Break=openpunctuation}', "");
    Expect(1, 125279, '\P{^Is_Line_Break=openpunctuation}', "");
    Expect(0, 125280, '\p{Is_Line_Break=openpunctuation}', "");
    Expect(1, 125280, '\p{^Is_Line_Break=openpunctuation}', "");
    Expect(1, 125280, '\P{Is_Line_Break=openpunctuation}', "");
    Expect(0, 125280, '\P{^Is_Line_Break=openpunctuation}', "");
    Expect(1, 125279, '\p{Is_Line_Break=__OPEN_punctuation}', "");
    Expect(0, 125279, '\p{^Is_Line_Break=__OPEN_punctuation}', "");
    Expect(0, 125279, '\P{Is_Line_Break=__OPEN_punctuation}', "");
    Expect(1, 125279, '\P{^Is_Line_Break=__OPEN_punctuation}', "");
    Expect(0, 125280, '\p{Is_Line_Break=__OPEN_punctuation}', "");
    Expect(1, 125280, '\p{^Is_Line_Break=__OPEN_punctuation}', "");
    Expect(1, 125280, '\P{Is_Line_Break=__OPEN_punctuation}', "");
    Expect(0, 125280, '\P{^Is_Line_Break=__OPEN_punctuation}', "");
    Error('\p{Is_Lb=_:=op}');
    Error('\P{Is_Lb=_:=op}');
    Expect(1, 125279, '\p{Is_Lb=op}', "");
    Expect(0, 125279, '\p{^Is_Lb=op}', "");
    Expect(0, 125279, '\P{Is_Lb=op}', "");
    Expect(1, 125279, '\P{^Is_Lb=op}', "");
    Expect(0, 125280, '\p{Is_Lb=op}', "");
    Expect(1, 125280, '\p{^Is_Lb=op}', "");
    Expect(1, 125280, '\P{Is_Lb=op}', "");
    Expect(0, 125280, '\P{^Is_Lb=op}', "");
    Expect(1, 125279, '\p{Is_Lb=-OP}', "");
    Expect(0, 125279, '\p{^Is_Lb=-OP}', "");
    Expect(0, 125279, '\P{Is_Lb=-OP}', "");
    Expect(1, 125279, '\P{^Is_Lb=-OP}', "");
    Expect(0, 125280, '\p{Is_Lb=-OP}', "");
    Expect(1, 125280, '\p{^Is_Lb=-OP}', "");
    Expect(1, 125280, '\P{Is_Lb=-OP}', "");
    Expect(0, 125280, '\P{^Is_Lb=-OP}', "");
    Error('\p{Line_Break:   -	Postfix_Numeric/a/}');
    Error('\P{Line_Break:   -	Postfix_Numeric/a/}');
    Expect(1, 126128, '\p{Line_Break=:\APostfix_Numeric\z:}', "");;
    Expect(0, 126129, '\p{Line_Break=:\APostfix_Numeric\z:}', "");;
    Expect(1, 126128, '\p{Line_Break=postfixnumeric}', "");
    Expect(0, 126128, '\p{^Line_Break=postfixnumeric}', "");
    Expect(0, 126128, '\P{Line_Break=postfixnumeric}', "");
    Expect(1, 126128, '\P{^Line_Break=postfixnumeric}', "");
    Expect(0, 126129, '\p{Line_Break=postfixnumeric}', "");
    Expect(1, 126129, '\p{^Line_Break=postfixnumeric}', "");
    Expect(1, 126129, '\P{Line_Break=postfixnumeric}', "");
    Expect(0, 126129, '\P{^Line_Break=postfixnumeric}', "");
    Expect(1, 126128, '\p{Line_Break=:\Apostfixnumeric\z:}', "");;
    Expect(0, 126129, '\p{Line_Break=:\Apostfixnumeric\z:}', "");;
    Expect(1, 126128, '\p{Line_Break= Postfix_NUMERIC}', "");
    Expect(0, 126128, '\p{^Line_Break= Postfix_NUMERIC}', "");
    Expect(0, 126128, '\P{Line_Break= Postfix_NUMERIC}', "");
    Expect(1, 126128, '\P{^Line_Break= Postfix_NUMERIC}', "");
    Expect(0, 126129, '\p{Line_Break= Postfix_NUMERIC}', "");
    Expect(1, 126129, '\p{^Line_Break= Postfix_NUMERIC}', "");
    Expect(1, 126129, '\P{Line_Break= Postfix_NUMERIC}', "");
    Expect(0, 126129, '\P{^Line_Break= Postfix_NUMERIC}', "");
    Error('\p{Lb=-_PO:=}');
    Error('\P{Lb=-_PO:=}');
    Expect(1, 126128, '\p{Lb=:\APO\z:}', "");;
    Expect(0, 126129, '\p{Lb=:\APO\z:}', "");;
    Expect(1, 126128, '\p{Lb=po}', "");
    Expect(0, 126128, '\p{^Lb=po}', "");
    Expect(0, 126128, '\P{Lb=po}', "");
    Expect(1, 126128, '\P{^Lb=po}', "");
    Expect(0, 126129, '\p{Lb=po}', "");
    Expect(1, 126129, '\p{^Lb=po}', "");
    Expect(1, 126129, '\P{Lb=po}', "");
    Expect(0, 126129, '\P{^Lb=po}', "");
    Expect(1, 126128, '\p{Lb=:\Apo\z:}', "");;
    Expect(0, 126129, '\p{Lb=:\Apo\z:}', "");;
    Expect(1, 126128, '\p{Lb=	PO}', "");
    Expect(0, 126128, '\p{^Lb=	PO}', "");
    Expect(0, 126128, '\P{Lb=	PO}', "");
    Expect(1, 126128, '\P{^Lb=	PO}', "");
    Expect(0, 126129, '\p{Lb=	PO}', "");
    Expect(1, 126129, '\p{^Lb=	PO}', "");
    Expect(1, 126129, '\P{Lb=	PO}', "");
    Expect(0, 126129, '\P{^Lb=	PO}', "");
    Error('\p{Is_Line_Break=:=		POSTFIX_Numeric}');
    Error('\P{Is_Line_Break=:=		POSTFIX_Numeric}');
    Expect(1, 126128, '\p{Is_Line_Break=postfixnumeric}', "");
    Expect(0, 126128, '\p{^Is_Line_Break=postfixnumeric}', "");
    Expect(0, 126128, '\P{Is_Line_Break=postfixnumeric}', "");
    Expect(1, 126128, '\P{^Is_Line_Break=postfixnumeric}', "");
    Expect(0, 126129, '\p{Is_Line_Break=postfixnumeric}', "");
    Expect(1, 126129, '\p{^Is_Line_Break=postfixnumeric}', "");
    Expect(1, 126129, '\P{Is_Line_Break=postfixnumeric}', "");
    Expect(0, 126129, '\P{^Is_Line_Break=postfixnumeric}', "");
    Expect(1, 126128, '\p{Is_Line_Break=  Postfix_Numeric}', "");
    Expect(0, 126128, '\p{^Is_Line_Break=  Postfix_Numeric}', "");
    Expect(0, 126128, '\P{Is_Line_Break=  Postfix_Numeric}', "");
    Expect(1, 126128, '\P{^Is_Line_Break=  Postfix_Numeric}', "");
    Expect(0, 126129, '\p{Is_Line_Break=  Postfix_Numeric}', "");
    Expect(1, 126129, '\p{^Is_Line_Break=  Postfix_Numeric}', "");
    Expect(1, 126129, '\P{Is_Line_Break=  Postfix_Numeric}', "");
    Expect(0, 126129, '\P{^Is_Line_Break=  Postfix_Numeric}', "");
    Error('\p{Is_Lb=_ PO/a/}');
    Error('\P{Is_Lb=_ PO/a/}');
    Expect(1, 126128, '\p{Is_Lb=po}', "");
    Expect(0, 126128, '\p{^Is_Lb=po}', "");
    Expect(0, 126128, '\P{Is_Lb=po}', "");
    Expect(1, 126128, '\P{^Is_Lb=po}', "");
    Expect(0, 126129, '\p{Is_Lb=po}', "");
    Expect(1, 126129, '\p{^Is_Lb=po}', "");
    Expect(1, 126129, '\P{Is_Lb=po}', "");
    Expect(0, 126129, '\P{^Is_Lb=po}', "");
    Expect(1, 126128, '\p{Is_Lb=_ PO}', "");
    Expect(0, 126128, '\p{^Is_Lb=_ PO}', "");
    Expect(0, 126128, '\P{Is_Lb=_ PO}', "");
    Expect(1, 126128, '\P{^Is_Lb=_ PO}', "");
    Expect(0, 126129, '\p{Is_Lb=_ PO}', "");
    Expect(1, 126129, '\p{^Is_Lb=_ PO}', "");
    Expect(1, 126129, '\P{Is_Lb=_ PO}', "");
    Expect(0, 126129, '\P{^Is_Lb=_ PO}', "");
    Error('\p{Line_Break=/a/	prefix_Numeric}');
    Error('\P{Line_Break=/a/	prefix_Numeric}');
    Expect(1, 123647, '\p{Line_Break=:\APrefix_Numeric\z:}', "");;
    Expect(0, 123648, '\p{Line_Break=:\APrefix_Numeric\z:}', "");;
    Expect(1, 123647, '\p{Line_Break=prefixnumeric}', "");
    Expect(0, 123647, '\p{^Line_Break=prefixnumeric}', "");
    Expect(0, 123647, '\P{Line_Break=prefixnumeric}', "");
    Expect(1, 123647, '\P{^Line_Break=prefixnumeric}', "");
    Expect(0, 123648, '\p{Line_Break=prefixnumeric}', "");
    Expect(1, 123648, '\p{^Line_Break=prefixnumeric}', "");
    Expect(1, 123648, '\P{Line_Break=prefixnumeric}', "");
    Expect(0, 123648, '\P{^Line_Break=prefixnumeric}', "");
    Expect(1, 123647, '\p{Line_Break=:\Aprefixnumeric\z:}', "");;
    Expect(0, 123648, '\p{Line_Break=:\Aprefixnumeric\z:}', "");;
    Expect(1, 123647, '\p{Line_Break=_-Prefix_Numeric}', "");
    Expect(0, 123647, '\p{^Line_Break=_-Prefix_Numeric}', "");
    Expect(0, 123647, '\P{Line_Break=_-Prefix_Numeric}', "");
    Expect(1, 123647, '\P{^Line_Break=_-Prefix_Numeric}', "");
    Expect(0, 123648, '\p{Line_Break=_-Prefix_Numeric}', "");
    Expect(1, 123648, '\p{^Line_Break=_-Prefix_Numeric}', "");
    Expect(1, 123648, '\P{Line_Break=_-Prefix_Numeric}', "");
    Expect(0, 123648, '\P{^Line_Break=_-Prefix_Numeric}', "");
    Error('\p{Lb=_PR/a/}');
    Error('\P{Lb=_PR/a/}');
    Expect(1, 123647, '\p{Lb=:\APR\z:}', "");;
    Expect(0, 123648, '\p{Lb=:\APR\z:}', "");;
    Expect(1, 123647, '\p{Lb=pr}', "");
    Expect(0, 123647, '\p{^Lb=pr}', "");
    Expect(0, 123647, '\P{Lb=pr}', "");
    Expect(1, 123647, '\P{^Lb=pr}', "");
    Expect(0, 123648, '\p{Lb=pr}', "");
    Expect(1, 123648, '\p{^Lb=pr}', "");
    Expect(1, 123648, '\P{Lb=pr}', "");
    Expect(0, 123648, '\P{^Lb=pr}', "");
    Expect(1, 123647, '\p{Lb=:\Apr\z:}', "");;
    Expect(0, 123648, '\p{Lb=:\Apr\z:}', "");;
    Expect(1, 123647, '\p{Lb:		 PR}', "");
    Expect(0, 123647, '\p{^Lb:		 PR}', "");
    Expect(0, 123647, '\P{Lb:		 PR}', "");
    Expect(1, 123647, '\P{^Lb:		 PR}', "");
    Expect(0, 123648, '\p{Lb:		 PR}', "");
    Expect(1, 123648, '\p{^Lb:		 PR}', "");
    Expect(1, 123648, '\P{Lb:		 PR}', "");
    Expect(0, 123648, '\P{^Lb:		 PR}', "");
    Error('\p{Is_Line_Break=prefix_Numeric:=}');
    Error('\P{Is_Line_Break=prefix_Numeric:=}');
    Expect(1, 123647, '\p{Is_Line_Break=prefixnumeric}', "");
    Expect(0, 123647, '\p{^Is_Line_Break=prefixnumeric}', "");
    Expect(0, 123647, '\P{Is_Line_Break=prefixnumeric}', "");
    Expect(1, 123647, '\P{^Is_Line_Break=prefixnumeric}', "");
    Expect(0, 123648, '\p{Is_Line_Break=prefixnumeric}', "");
    Expect(1, 123648, '\p{^Is_Line_Break=prefixnumeric}', "");
    Expect(1, 123648, '\P{Is_Line_Break=prefixnumeric}', "");
    Expect(0, 123648, '\P{^Is_Line_Break=prefixnumeric}', "");
    Expect(1, 123647, '\p{Is_Line_Break= 	Prefix_numeric}', "");
    Expect(0, 123647, '\p{^Is_Line_Break= 	Prefix_numeric}', "");
    Expect(0, 123647, '\P{Is_Line_Break= 	Prefix_numeric}', "");
    Expect(1, 123647, '\P{^Is_Line_Break= 	Prefix_numeric}', "");
    Expect(0, 123648, '\p{Is_Line_Break= 	Prefix_numeric}', "");
    Expect(1, 123648, '\p{^Is_Line_Break= 	Prefix_numeric}', "");
    Expect(1, 123648, '\P{Is_Line_Break= 	Prefix_numeric}', "");
    Expect(0, 123648, '\P{^Is_Line_Break= 	Prefix_numeric}', "");
    Error('\p{Is_Lb=	:=PR}');
    Error('\P{Is_Lb=	:=PR}');
    Expect(1, 123647, '\p{Is_Lb=pr}', "");
    Expect(0, 123647, '\p{^Is_Lb=pr}', "");
    Expect(0, 123647, '\P{Is_Lb=pr}', "");
    Expect(1, 123647, '\P{^Is_Lb=pr}', "");
    Expect(0, 123648, '\p{Is_Lb=pr}', "");
    Expect(1, 123648, '\p{^Is_Lb=pr}', "");
    Expect(1, 123648, '\P{Is_Lb=pr}', "");
    Expect(0, 123648, '\P{^Is_Lb=pr}', "");
    Expect(1, 123647, '\p{Is_Lb=PR}', "");
    Expect(0, 123647, '\p{^Is_Lb=PR}', "");
    Expect(0, 123647, '\P{Is_Lb=PR}', "");
    Expect(1, 123647, '\P{^Is_Lb=PR}', "");
    Expect(0, 123648, '\p{Is_Lb=PR}', "");
    Expect(1, 123648, '\p{^Is_Lb=PR}', "");
    Expect(1, 123648, '\P{Is_Lb=PR}', "");
    Expect(0, 123648, '\P{^Is_Lb=PR}', "");
    Error('\p{Line_Break=/a/quotation}');
    Error('\P{Line_Break=/a/quotation}');
    Expect(1, 128632, '\p{Line_Break=:\AQuotation\z:}', "");;
    Expect(0, 128633, '\p{Line_Break=:\AQuotation\z:}', "");;
    Expect(1, 128632, '\p{Line_Break=quotation}', "");
    Expect(0, 128632, '\p{^Line_Break=quotation}', "");
    Expect(0, 128632, '\P{Line_Break=quotation}', "");
    Expect(1, 128632, '\P{^Line_Break=quotation}', "");
    Expect(0, 128633, '\p{Line_Break=quotation}', "");
    Expect(1, 128633, '\p{^Line_Break=quotation}', "");
    Expect(1, 128633, '\P{Line_Break=quotation}', "");
    Expect(0, 128633, '\P{^Line_Break=quotation}', "");
    Expect(1, 128632, '\p{Line_Break=:\Aquotation\z:}', "");;
    Expect(0, 128633, '\p{Line_Break=:\Aquotation\z:}', "");;
    Expect(1, 128632, '\p{Line_Break=	Quotation}', "");
    Expect(0, 128632, '\p{^Line_Break=	Quotation}', "");
    Expect(0, 128632, '\P{Line_Break=	Quotation}', "");
    Expect(1, 128632, '\P{^Line_Break=	Quotation}', "");
    Expect(0, 128633, '\p{Line_Break=	Quotation}', "");
    Expect(1, 128633, '\p{^Line_Break=	Quotation}', "");
    Expect(1, 128633, '\P{Line_Break=	Quotation}', "");
    Expect(0, 128633, '\P{^Line_Break=	Quotation}', "");
    Error('\p{Lb=-qu:=}');
    Error('\P{Lb=-qu:=}');
    Expect(1, 128632, '\p{Lb=:\AQU\z:}', "");;
    Expect(0, 128633, '\p{Lb=:\AQU\z:}', "");;
    Expect(1, 128632, '\p{Lb=qu}', "");
    Expect(0, 128632, '\p{^Lb=qu}', "");
    Expect(0, 128632, '\P{Lb=qu}', "");
    Expect(1, 128632, '\P{^Lb=qu}', "");
    Expect(0, 128633, '\p{Lb=qu}', "");
    Expect(1, 128633, '\p{^Lb=qu}', "");
    Expect(1, 128633, '\P{Lb=qu}', "");
    Expect(0, 128633, '\P{^Lb=qu}', "");
    Expect(1, 128632, '\p{Lb=:\Aqu\z:}', "");;
    Expect(0, 128633, '\p{Lb=:\Aqu\z:}', "");;
    Expect(1, 128632, '\p{Lb=-QU}', "");
    Expect(0, 128632, '\p{^Lb=-QU}', "");
    Expect(0, 128632, '\P{Lb=-QU}', "");
    Expect(1, 128632, '\P{^Lb=-QU}', "");
    Expect(0, 128633, '\p{Lb=-QU}', "");
    Expect(1, 128633, '\p{^Lb=-QU}', "");
    Expect(1, 128633, '\P{Lb=-QU}', "");
    Expect(0, 128633, '\P{^Lb=-QU}', "");
    Error('\p{Is_Line_Break=/a/__Quotation}');
    Error('\P{Is_Line_Break=/a/__Quotation}');
    Expect(1, 128632, '\p{Is_Line_Break=quotation}', "");
    Expect(0, 128632, '\p{^Is_Line_Break=quotation}', "");
    Expect(0, 128632, '\P{Is_Line_Break=quotation}', "");
    Expect(1, 128632, '\P{^Is_Line_Break=quotation}', "");
    Expect(0, 128633, '\p{Is_Line_Break=quotation}', "");
    Expect(1, 128633, '\p{^Is_Line_Break=quotation}', "");
    Expect(1, 128633, '\P{Is_Line_Break=quotation}', "");
    Expect(0, 128633, '\P{^Is_Line_Break=quotation}', "");
    Expect(1, 128632, '\p{Is_Line_Break= quotation}', "");
    Expect(0, 128632, '\p{^Is_Line_Break= quotation}', "");
    Expect(0, 128632, '\P{Is_Line_Break= quotation}', "");
    Expect(1, 128632, '\P{^Is_Line_Break= quotation}', "");
    Expect(0, 128633, '\p{Is_Line_Break= quotation}', "");
    Expect(1, 128633, '\p{^Is_Line_Break= quotation}', "");
    Expect(1, 128633, '\P{Is_Line_Break= quotation}', "");
    Expect(0, 128633, '\P{^Is_Line_Break= quotation}', "");
    Error('\p{Is_Lb=:=	QU}');
    Error('\P{Is_Lb=:=	QU}');
    Expect(1, 128632, '\p{Is_Lb=qu}', "");
    Expect(0, 128632, '\p{^Is_Lb=qu}', "");
    Expect(0, 128632, '\P{Is_Lb=qu}', "");
    Expect(1, 128632, '\P{^Is_Lb=qu}', "");
    Expect(0, 128633, '\p{Is_Lb=qu}', "");
    Expect(1, 128633, '\p{^Is_Lb=qu}', "");
    Expect(1, 128633, '\P{Is_Lb=qu}', "");
    Expect(0, 128633, '\P{^Is_Lb=qu}', "");
    Expect(1, 128632, '\p{Is_Lb=_ QU}', "");
    Expect(0, 128632, '\p{^Is_Lb=_ QU}', "");
    Expect(0, 128632, '\P{Is_Lb=_ QU}', "");
    Expect(1, 128632, '\P{^Is_Lb=_ QU}', "");
    Expect(0, 128633, '\p{Is_Lb=_ QU}', "");
    Expect(1, 128633, '\p{^Is_Lb=_ QU}', "");
    Expect(1, 128633, '\P{Is_Lb=_ QU}', "");
    Expect(0, 128633, '\P{^Is_Lb=_ QU}', "");
    Error('\p{Line_Break=	/a/Regional_indicator}');
    Error('\P{Line_Break=	/a/Regional_indicator}');
    Expect(1, 127487, '\p{Line_Break=:\ARegional_Indicator\z:}', "");;
    Expect(0, 127488, '\p{Line_Break=:\ARegional_Indicator\z:}', "");;
    Expect(1, 127487, '\p{Line_Break=regionalindicator}', "");
    Expect(0, 127487, '\p{^Line_Break=regionalindicator}', "");
    Expect(0, 127487, '\P{Line_Break=regionalindicator}', "");
    Expect(1, 127487, '\P{^Line_Break=regionalindicator}', "");
    Expect(0, 127488, '\p{Line_Break=regionalindicator}', "");
    Expect(1, 127488, '\p{^Line_Break=regionalindicator}', "");
    Expect(1, 127488, '\P{Line_Break=regionalindicator}', "");
    Expect(0, 127488, '\P{^Line_Break=regionalindicator}', "");
    Expect(1, 127487, '\p{Line_Break=:\Aregionalindicator\z:}', "");;
    Expect(0, 127488, '\p{Line_Break=:\Aregionalindicator\z:}', "");;
    Expect(1, 127487, '\p{Line_Break= Regional_indicator}', "");
    Expect(0, 127487, '\p{^Line_Break= Regional_indicator}', "");
    Expect(0, 127487, '\P{Line_Break= Regional_indicator}', "");
    Expect(1, 127487, '\P{^Line_Break= Regional_indicator}', "");
    Expect(0, 127488, '\p{Line_Break= Regional_indicator}', "");
    Expect(1, 127488, '\p{^Line_Break= Regional_indicator}', "");
    Expect(1, 127488, '\P{Line_Break= Regional_indicator}', "");
    Expect(0, 127488, '\P{^Line_Break= Regional_indicator}', "");
    Error('\p{Lb:		_RI:=}');
    Error('\P{Lb:		_RI:=}');
    Expect(1, 127487, '\p{Lb=:\ARI\z:}', "");;
    Expect(0, 127488, '\p{Lb=:\ARI\z:}', "");;
    Expect(1, 127487, '\p{Lb:   ri}', "");
    Expect(0, 127487, '\p{^Lb:   ri}', "");
    Expect(0, 127487, '\P{Lb:   ri}', "");
    Expect(1, 127487, '\P{^Lb:   ri}', "");
    Expect(0, 127488, '\p{Lb:   ri}', "");
    Expect(1, 127488, '\p{^Lb:   ri}', "");
    Expect(1, 127488, '\P{Lb:   ri}', "");
    Expect(0, 127488, '\P{^Lb:   ri}', "");
    Expect(1, 127487, '\p{Lb=:\Ari\z:}', "");;
    Expect(0, 127488, '\p{Lb=:\Ari\z:}', "");;
    Expect(1, 127487, '\p{Lb=		RI}', "");
    Expect(0, 127487, '\p{^Lb=		RI}', "");
    Expect(0, 127487, '\P{Lb=		RI}', "");
    Expect(1, 127487, '\P{^Lb=		RI}', "");
    Expect(0, 127488, '\p{Lb=		RI}', "");
    Expect(1, 127488, '\p{^Lb=		RI}', "");
    Expect(1, 127488, '\P{Lb=		RI}', "");
    Expect(0, 127488, '\P{^Lb=		RI}', "");
    Error('\p{Is_Line_Break: :=	 Regional_INDICATOR}');
    Error('\P{Is_Line_Break: :=	 Regional_INDICATOR}');
    Expect(1, 127487, '\p{Is_Line_Break:regionalindicator}', "");
    Expect(0, 127487, '\p{^Is_Line_Break:regionalindicator}', "");
    Expect(0, 127487, '\P{Is_Line_Break:regionalindicator}', "");
    Expect(1, 127487, '\P{^Is_Line_Break:regionalindicator}', "");
    Expect(0, 127488, '\p{Is_Line_Break:regionalindicator}', "");
    Expect(1, 127488, '\p{^Is_Line_Break:regionalindicator}', "");
    Expect(1, 127488, '\P{Is_Line_Break:regionalindicator}', "");
    Expect(0, 127488, '\P{^Is_Line_Break:regionalindicator}', "");
    Expect(1, 127487, '\p{Is_Line_Break=  regional_INDICATOR}', "");
    Expect(0, 127487, '\p{^Is_Line_Break=  regional_INDICATOR}', "");
    Expect(0, 127487, '\P{Is_Line_Break=  regional_INDICATOR}', "");
    Expect(1, 127487, '\P{^Is_Line_Break=  regional_INDICATOR}', "");
    Expect(0, 127488, '\p{Is_Line_Break=  regional_INDICATOR}', "");
    Expect(1, 127488, '\p{^Is_Line_Break=  regional_INDICATOR}', "");
    Expect(1, 127488, '\P{Is_Line_Break=  regional_INDICATOR}', "");
    Expect(0, 127488, '\P{^Is_Line_Break=  regional_INDICATOR}', "");
    Error('\p{Is_Lb=	:=RI}');
    Error('\P{Is_Lb=	:=RI}');
    Expect(1, 127487, '\p{Is_Lb=ri}', "");
    Expect(0, 127487, '\p{^Is_Lb=ri}', "");
    Expect(0, 127487, '\P{Is_Lb=ri}', "");
    Expect(1, 127487, '\P{^Is_Lb=ri}', "");
    Expect(0, 127488, '\p{Is_Lb=ri}', "");
    Expect(1, 127488, '\p{^Is_Lb=ri}', "");
    Expect(1, 127488, '\P{Is_Lb=ri}', "");
    Expect(0, 127488, '\P{^Is_Lb=ri}', "");
    Expect(1, 127487, '\p{Is_Lb=  RI}', "");
    Expect(0, 127487, '\p{^Is_Lb=  RI}', "");
    Expect(0, 127487, '\P{Is_Lb=  RI}', "");
    Expect(1, 127487, '\P{^Is_Lb=  RI}', "");
    Expect(0, 127488, '\p{Is_Lb=  RI}', "");
    Expect(1, 127488, '\p{^Is_Lb=  RI}', "");
    Expect(1, 127488, '\P{Is_Lb=  RI}', "");
    Expect(0, 127488, '\P{^Is_Lb=  RI}', "");
    Error('\p{Line_Break: _/a/complex_CONTEXT}');
    Error('\P{Line_Break: _/a/complex_CONTEXT}');
    Expect(1, 71487, '\p{Line_Break=:\AComplex_Context\z:}', "");;
    Expect(0, 71488, '\p{Line_Break=:\AComplex_Context\z:}', "");;
    Expect(1, 71487, '\p{Line_Break=complexcontext}', "");
    Expect(0, 71487, '\p{^Line_Break=complexcontext}', "");
    Expect(0, 71487, '\P{Line_Break=complexcontext}', "");
    Expect(1, 71487, '\P{^Line_Break=complexcontext}', "");
    Expect(0, 71488, '\p{Line_Break=complexcontext}', "");
    Expect(1, 71488, '\p{^Line_Break=complexcontext}', "");
    Expect(1, 71488, '\P{Line_Break=complexcontext}', "");
    Expect(0, 71488, '\P{^Line_Break=complexcontext}', "");
    Expect(1, 71487, '\p{Line_Break=:\Acomplexcontext\z:}', "");;
    Expect(0, 71488, '\p{Line_Break=:\Acomplexcontext\z:}', "");;
    Expect(1, 71487, '\p{Line_Break=		Complex_Context}', "");
    Expect(0, 71487, '\p{^Line_Break=		Complex_Context}', "");
    Expect(0, 71487, '\P{Line_Break=		Complex_Context}', "");
    Expect(1, 71487, '\P{^Line_Break=		Complex_Context}', "");
    Expect(0, 71488, '\p{Line_Break=		Complex_Context}', "");
    Expect(1, 71488, '\p{^Line_Break=		Complex_Context}', "");
    Expect(1, 71488, '\P{Line_Break=		Complex_Context}', "");
    Expect(0, 71488, '\P{^Line_Break=		Complex_Context}', "");
    Error('\p{Lb=_SA:=}');
    Error('\P{Lb=_SA:=}');
    Expect(1, 71487, '\p{Lb=:\ASA\z:}', "");;
    Expect(0, 71488, '\p{Lb=:\ASA\z:}', "");;
    Expect(1, 71487, '\p{Lb=sa}', "");
    Expect(0, 71487, '\p{^Lb=sa}', "");
    Expect(0, 71487, '\P{Lb=sa}', "");
    Expect(1, 71487, '\P{^Lb=sa}', "");
    Expect(0, 71488, '\p{Lb=sa}', "");
    Expect(1, 71488, '\p{^Lb=sa}', "");
    Expect(1, 71488, '\P{Lb=sa}', "");
    Expect(0, 71488, '\P{^Lb=sa}', "");
    Expect(1, 71487, '\p{Lb=:\Asa\z:}', "");;
    Expect(0, 71488, '\p{Lb=:\Asa\z:}', "");;
    Expect(1, 71487, '\p{Lb=_ SA}', "");
    Expect(0, 71487, '\p{^Lb=_ SA}', "");
    Expect(0, 71487, '\P{Lb=_ SA}', "");
    Expect(1, 71487, '\P{^Lb=_ SA}', "");
    Expect(0, 71488, '\p{Lb=_ SA}', "");
    Expect(1, 71488, '\p{^Lb=_ SA}', "");
    Expect(1, 71488, '\P{Lb=_ SA}', "");
    Expect(0, 71488, '\P{^Lb=_ SA}', "");
    Error('\p{Is_Line_Break= Complex_context:=}');
    Error('\P{Is_Line_Break= Complex_context:=}');
    Expect(1, 71487, '\p{Is_Line_Break=complexcontext}', "");
    Expect(0, 71487, '\p{^Is_Line_Break=complexcontext}', "");
    Expect(0, 71487, '\P{Is_Line_Break=complexcontext}', "");
    Expect(1, 71487, '\P{^Is_Line_Break=complexcontext}', "");
    Expect(0, 71488, '\p{Is_Line_Break=complexcontext}', "");
    Expect(1, 71488, '\p{^Is_Line_Break=complexcontext}', "");
    Expect(1, 71488, '\P{Is_Line_Break=complexcontext}', "");
    Expect(0, 71488, '\P{^Is_Line_Break=complexcontext}', "");
    Expect(1, 71487, '\p{Is_Line_Break:   	_Complex_context}', "");
    Expect(0, 71487, '\p{^Is_Line_Break:   	_Complex_context}', "");
    Expect(0, 71487, '\P{Is_Line_Break:   	_Complex_context}', "");
    Expect(1, 71487, '\P{^Is_Line_Break:   	_Complex_context}', "");
    Expect(0, 71488, '\p{Is_Line_Break:   	_Complex_context}', "");
    Expect(1, 71488, '\p{^Is_Line_Break:   	_Complex_context}', "");
    Expect(1, 71488, '\P{Is_Line_Break:   	_Complex_context}', "");
    Expect(0, 71488, '\P{^Is_Line_Break:   	_Complex_context}', "");
    Error('\p{Is_Lb=- SA/a/}');
    Error('\P{Is_Lb=- SA/a/}');
    Expect(1, 71487, '\p{Is_Lb:sa}', "");
    Expect(0, 71487, '\p{^Is_Lb:sa}', "");
    Expect(0, 71487, '\P{Is_Lb:sa}', "");
    Expect(1, 71487, '\P{^Is_Lb:sa}', "");
    Expect(0, 71488, '\p{Is_Lb:sa}', "");
    Expect(1, 71488, '\p{^Is_Lb:sa}', "");
    Expect(1, 71488, '\P{Is_Lb:sa}', "");
    Expect(0, 71488, '\P{^Is_Lb:sa}', "");
    Error('\p{Line_Break=:=_surrogate}');
    Error('\P{Line_Break=:=_surrogate}');
    Expect(1, 57343, '\p{Line_Break=surrogate}', 'deprecated');
    Expect(0, 57343, '\p{^Line_Break=surrogate}', 'deprecated');
    Expect(0, 57343, '\P{Line_Break=surrogate}', 'deprecated');
    Expect(1, 57343, '\P{^Line_Break=surrogate}', 'deprecated');
    Expect(0, 57344, '\p{Line_Break=surrogate}', 'deprecated');
    Expect(1, 57344, '\p{^Line_Break=surrogate}', 'deprecated');
    Expect(1, 57344, '\P{Line_Break=surrogate}', 'deprecated');
    Expect(0, 57344, '\P{^Line_Break=surrogate}', 'deprecated');
    Expect(1, 57343, '\p{Line_Break:-_Surrogate}', 'deprecated');
    Expect(0, 57343, '\p{^Line_Break:-_Surrogate}', 'deprecated');
    Expect(0, 57343, '\P{Line_Break:-_Surrogate}', 'deprecated');
    Expect(1, 57343, '\P{^Line_Break:-_Surrogate}', 'deprecated');
    Expect(0, 57344, '\p{Line_Break:-_Surrogate}', 'deprecated');
    Expect(1, 57344, '\p{^Line_Break:-_Surrogate}', 'deprecated');
    Expect(1, 57344, '\P{Line_Break:-_Surrogate}', 'deprecated');
    Expect(0, 57344, '\P{^Line_Break:-_Surrogate}', 'deprecated');
    Error('\p{Lb=/a/ _sg}');
    Error('\P{Lb=/a/ _sg}');
    Expect(1, 57343, '\p{Lb: sg}', 'deprecated');
    Expect(0, 57343, '\p{^Lb: sg}', 'deprecated');
    Expect(0, 57343, '\P{Lb: sg}', 'deprecated');
    Expect(1, 57343, '\P{^Lb: sg}', 'deprecated');
    Expect(0, 57344, '\p{Lb: sg}', 'deprecated');
    Expect(1, 57344, '\p{^Lb: sg}', 'deprecated');
    Expect(1, 57344, '\P{Lb: sg}', 'deprecated');
    Expect(0, 57344, '\P{^Lb: sg}', 'deprecated');
    Expect(1, 57343, '\p{Lb=- SG}', 'deprecated');
    Expect(0, 57343, '\p{^Lb=- SG}', 'deprecated');
    Expect(0, 57343, '\P{Lb=- SG}', 'deprecated');
    Expect(1, 57343, '\P{^Lb=- SG}', 'deprecated');
    Expect(0, 57344, '\p{Lb=- SG}', 'deprecated');
    Expect(1, 57344, '\p{^Lb=- SG}', 'deprecated');
    Expect(1, 57344, '\P{Lb=- SG}', 'deprecated');
    Expect(0, 57344, '\P{^Lb=- SG}', 'deprecated');
    Error('\p{Is_Line_Break=/a/-	SURROGATE}');
    Error('\P{Is_Line_Break=/a/-	SURROGATE}');
    Expect(1, 57343, '\p{Is_Line_Break=surrogate}', 'deprecated');
    Expect(0, 57343, '\p{^Is_Line_Break=surrogate}', 'deprecated');
    Expect(0, 57343, '\P{Is_Line_Break=surrogate}', 'deprecated');
    Expect(1, 57343, '\P{^Is_Line_Break=surrogate}', 'deprecated');
    Expect(0, 57344, '\p{Is_Line_Break=surrogate}', 'deprecated');
    Expect(1, 57344, '\p{^Is_Line_Break=surrogate}', 'deprecated');
    Expect(1, 57344, '\P{Is_Line_Break=surrogate}', 'deprecated');
    Expect(0, 57344, '\P{^Is_Line_Break=surrogate}', 'deprecated');
    Expect(1, 57343, '\p{Is_Line_Break=		Surrogate}', 'deprecated');
    Expect(0, 57343, '\p{^Is_Line_Break=		Surrogate}', 'deprecated');
    Expect(0, 57343, '\P{Is_Line_Break=		Surrogate}', 'deprecated');
    Expect(1, 57343, '\P{^Is_Line_Break=		Surrogate}', 'deprecated');
    Expect(0, 57344, '\p{Is_Line_Break=		Surrogate}', 'deprecated');
    Expect(1, 57344, '\p{^Is_Line_Break=		Surrogate}', 'deprecated');
    Expect(1, 57344, '\P{Is_Line_Break=		Surrogate}', 'deprecated');
    Expect(0, 57344, '\P{^Is_Line_Break=		Surrogate}', 'deprecated');
    Error('\p{Is_Lb=_:=sg}');
    Error('\P{Is_Lb=_:=sg}');
    Expect(1, 57343, '\p{Is_Lb=sg}', 'deprecated');
    Expect(0, 57343, '\p{^Is_Lb=sg}', 'deprecated');
    Expect(0, 57343, '\P{Is_Lb=sg}', 'deprecated');
    Expect(1, 57343, '\P{^Is_Lb=sg}', 'deprecated');
    Expect(0, 57344, '\p{Is_Lb=sg}', 'deprecated');
    Expect(1, 57344, '\p{^Is_Lb=sg}', 'deprecated');
    Expect(1, 57344, '\P{Is_Lb=sg}', 'deprecated');
    Expect(0, 57344, '\P{^Is_Lb=sg}', 'deprecated');
    Expect(1, 57343, '\p{Is_Lb=- SG}', 'deprecated');
    Expect(0, 57343, '\p{^Is_Lb=- SG}', 'deprecated');
    Expect(0, 57343, '\P{Is_Lb=- SG}', 'deprecated');
    Expect(1, 57343, '\P{^Is_Lb=- SG}', 'deprecated');
    Expect(0, 57344, '\p{Is_Lb=- SG}', 'deprecated');
    Expect(1, 57344, '\p{^Is_Lb=- SG}', 'deprecated');
    Expect(1, 57344, '\P{Is_Lb=- SG}', 'deprecated');
    Expect(0, 57344, '\P{^Is_Lb=- SG}', 'deprecated');
    Error('\p{Line_Break:	 _SPACE/a/}');
    Error('\P{Line_Break:	 _SPACE/a/}');
    Expect(1, 32, '\p{Line_Break=:\ASpace\z:}', "");;
    Expect(0, 33, '\p{Line_Break=:\ASpace\z:}', "");;
    Expect(1, 32, '\p{Line_Break=space}', "");
    Expect(0, 32, '\p{^Line_Break=space}', "");
    Expect(0, 32, '\P{Line_Break=space}', "");
    Expect(1, 32, '\P{^Line_Break=space}', "");
    Expect(0, 33, '\p{Line_Break=space}', "");
    Expect(1, 33, '\p{^Line_Break=space}', "");
    Expect(1, 33, '\P{Line_Break=space}', "");
    Expect(0, 33, '\P{^Line_Break=space}', "");
    Expect(1, 32, '\p{Line_Break=:\Aspace\z:}', "");;
    Expect(0, 33, '\p{Line_Break=:\Aspace\z:}', "");;
    Expect(1, 32, '\p{Line_Break= -space}', "");
    Expect(0, 32, '\p{^Line_Break= -space}', "");
    Expect(0, 32, '\P{Line_Break= -space}', "");
    Expect(1, 32, '\P{^Line_Break= -space}', "");
    Expect(0, 33, '\p{Line_Break= -space}', "");
    Expect(1, 33, '\p{^Line_Break= -space}', "");
    Expect(1, 33, '\P{Line_Break= -space}', "");
    Expect(0, 33, '\P{^Line_Break= -space}', "");
    Error('\p{Lb=	 sp:=}');
    Error('\P{Lb=	 sp:=}');
    Expect(1, 32, '\p{Lb=:\ASP\z:}', "");;
    Expect(0, 33, '\p{Lb=:\ASP\z:}', "");;
    Expect(1, 32, '\p{Lb=sp}', "");
    Expect(0, 32, '\p{^Lb=sp}', "");
    Expect(0, 32, '\P{Lb=sp}', "");
    Expect(1, 32, '\P{^Lb=sp}', "");
    Expect(0, 33, '\p{Lb=sp}', "");
    Expect(1, 33, '\p{^Lb=sp}', "");
    Expect(1, 33, '\P{Lb=sp}', "");
    Expect(0, 33, '\P{^Lb=sp}', "");
    Expect(1, 32, '\p{Lb=:\Asp\z:}', "");;
    Expect(0, 33, '\p{Lb=:\Asp\z:}', "");;
    Expect(1, 32, '\p{Lb=_	SP}', "");
    Expect(0, 32, '\p{^Lb=_	SP}', "");
    Expect(0, 32, '\P{Lb=_	SP}', "");
    Expect(1, 32, '\P{^Lb=_	SP}', "");
    Expect(0, 33, '\p{Lb=_	SP}', "");
    Expect(1, 33, '\p{^Lb=_	SP}', "");
    Expect(1, 33, '\P{Lb=_	SP}', "");
    Expect(0, 33, '\P{^Lb=_	SP}', "");
    Error('\p{Is_Line_Break=:=  space}');
    Error('\P{Is_Line_Break=:=  space}');
    Expect(1, 32, '\p{Is_Line_Break=space}', "");
    Expect(0, 32, '\p{^Is_Line_Break=space}', "");
    Expect(0, 32, '\P{Is_Line_Break=space}', "");
    Expect(1, 32, '\P{^Is_Line_Break=space}', "");
    Expect(0, 33, '\p{Is_Line_Break=space}', "");
    Expect(1, 33, '\p{^Is_Line_Break=space}', "");
    Expect(1, 33, '\P{Is_Line_Break=space}', "");
    Expect(0, 33, '\P{^Is_Line_Break=space}', "");
    Expect(1, 32, '\p{Is_Line_Break:		-space}', "");
    Expect(0, 32, '\p{^Is_Line_Break:		-space}', "");
    Expect(0, 32, '\P{Is_Line_Break:		-space}', "");
    Expect(1, 32, '\P{^Is_Line_Break:		-space}', "");
    Expect(0, 33, '\p{Is_Line_Break:		-space}', "");
    Expect(1, 33, '\p{^Is_Line_Break:		-space}', "");
    Expect(1, 33, '\P{Is_Line_Break:		-space}', "");
    Expect(0, 33, '\P{^Is_Line_Break:		-space}', "");
    Error('\p{Is_Lb=:=-_SP}');
    Error('\P{Is_Lb=:=-_SP}');
    Expect(1, 32, '\p{Is_Lb=sp}', "");
    Expect(0, 32, '\p{^Is_Lb=sp}', "");
    Expect(0, 32, '\P{Is_Lb=sp}', "");
    Expect(1, 32, '\P{^Is_Lb=sp}', "");
    Expect(0, 33, '\p{Is_Lb=sp}', "");
    Expect(1, 33, '\p{^Is_Lb=sp}', "");
    Expect(1, 33, '\P{Is_Lb=sp}', "");
    Expect(0, 33, '\P{^Is_Lb=sp}', "");
    Expect(1, 32, '\p{Is_Lb=	 sp}', "");
    Expect(0, 32, '\p{^Is_Lb=	 sp}', "");
    Expect(0, 32, '\P{Is_Lb=	 sp}', "");
    Expect(1, 32, '\P{^Is_Lb=	 sp}', "");
    Expect(0, 33, '\p{Is_Lb=	 sp}', "");
    Expect(1, 33, '\p{^Is_Lb=	 sp}', "");
    Expect(1, 33, '\P{Is_Lb=	 sp}', "");
    Expect(0, 33, '\P{^Is_Lb=	 sp}', "");
    Error('\p{Line_Break=/a/_Break_Symbols}');
    Error('\P{Line_Break=/a/_Break_Symbols}');
    Expect(1, 47, '\p{Line_Break=:\ABreak_Symbols\z:}', "");;
    Expect(0, 48, '\p{Line_Break=:\ABreak_Symbols\z:}', "");;
    Expect(1, 47, '\p{Line_Break=breaksymbols}', "");
    Expect(0, 47, '\p{^Line_Break=breaksymbols}', "");
    Expect(0, 47, '\P{Line_Break=breaksymbols}', "");
    Expect(1, 47, '\P{^Line_Break=breaksymbols}', "");
    Expect(0, 48, '\p{Line_Break=breaksymbols}', "");
    Expect(1, 48, '\p{^Line_Break=breaksymbols}', "");
    Expect(1, 48, '\P{Line_Break=breaksymbols}', "");
    Expect(0, 48, '\P{^Line_Break=breaksymbols}', "");
    Expect(1, 47, '\p{Line_Break=:\Abreaksymbols\z:}', "");;
    Expect(0, 48, '\p{Line_Break=:\Abreaksymbols\z:}', "");;
    Expect(1, 47, '\p{Line_Break=_Break_Symbols}', "");
    Expect(0, 47, '\p{^Line_Break=_Break_Symbols}', "");
    Expect(0, 47, '\P{Line_Break=_Break_Symbols}', "");
    Expect(1, 47, '\P{^Line_Break=_Break_Symbols}', "");
    Expect(0, 48, '\p{Line_Break=_Break_Symbols}', "");
    Expect(1, 48, '\p{^Line_Break=_Break_Symbols}', "");
    Expect(1, 48, '\P{Line_Break=_Break_Symbols}', "");
    Expect(0, 48, '\P{^Line_Break=_Break_Symbols}', "");
    Error('\p{Lb=/a/ SY}');
    Error('\P{Lb=/a/ SY}');
    Expect(1, 47, '\p{Lb=:\ASY\z:}', "");;
    Expect(0, 48, '\p{Lb=:\ASY\z:}', "");;
    Expect(1, 47, '\p{Lb=sy}', "");
    Expect(0, 47, '\p{^Lb=sy}', "");
    Expect(0, 47, '\P{Lb=sy}', "");
    Expect(1, 47, '\P{^Lb=sy}', "");
    Expect(0, 48, '\p{Lb=sy}', "");
    Expect(1, 48, '\p{^Lb=sy}', "");
    Expect(1, 48, '\P{Lb=sy}', "");
    Expect(0, 48, '\P{^Lb=sy}', "");
    Expect(1, 47, '\p{Lb=:\Asy\z:}', "");;
    Expect(0, 48, '\p{Lb=:\Asy\z:}', "");;
    Expect(1, 47, '\p{Lb= SY}', "");
    Expect(0, 47, '\p{^Lb= SY}', "");
    Expect(0, 47, '\P{Lb= SY}', "");
    Expect(1, 47, '\P{^Lb= SY}', "");
    Expect(0, 48, '\p{Lb= SY}', "");
    Expect(1, 48, '\p{^Lb= SY}', "");
    Expect(1, 48, '\P{Lb= SY}', "");
    Expect(0, 48, '\P{^Lb= SY}', "");
    Error('\p{Is_Line_Break=:=Break_symbols}');
    Error('\P{Is_Line_Break=:=Break_symbols}');
    Expect(1, 47, '\p{Is_Line_Break:	breaksymbols}', "");
    Expect(0, 47, '\p{^Is_Line_Break:	breaksymbols}', "");
    Expect(0, 47, '\P{Is_Line_Break:	breaksymbols}', "");
    Expect(1, 47, '\P{^Is_Line_Break:	breaksymbols}', "");
    Expect(0, 48, '\p{Is_Line_Break:	breaksymbols}', "");
    Expect(1, 48, '\p{^Is_Line_Break:	breaksymbols}', "");
    Expect(1, 48, '\P{Is_Line_Break:	breaksymbols}', "");
    Expect(0, 48, '\P{^Is_Line_Break:	breaksymbols}', "");
    Expect(1, 47, '\p{Is_Line_Break: 	_Break_SYMBOLS}', "");
    Expect(0, 47, '\p{^Is_Line_Break: 	_Break_SYMBOLS}', "");
    Expect(0, 47, '\P{Is_Line_Break: 	_Break_SYMBOLS}', "");
    Expect(1, 47, '\P{^Is_Line_Break: 	_Break_SYMBOLS}', "");
    Expect(0, 48, '\p{Is_Line_Break: 	_Break_SYMBOLS}', "");
    Expect(1, 48, '\p{^Is_Line_Break: 	_Break_SYMBOLS}', "");
    Expect(1, 48, '\P{Is_Line_Break: 	_Break_SYMBOLS}', "");
    Expect(0, 48, '\P{^Is_Line_Break: 	_Break_SYMBOLS}', "");
    Error('\p{Is_Lb=:=_SY}');
    Error('\P{Is_Lb=:=_SY}');
    Expect(1, 47, '\p{Is_Lb=sy}', "");
    Expect(0, 47, '\p{^Is_Lb=sy}', "");
    Expect(0, 47, '\P{Is_Lb=sy}', "");
    Expect(1, 47, '\P{^Is_Lb=sy}', "");
    Expect(0, 48, '\p{Is_Lb=sy}', "");
    Expect(1, 48, '\p{^Is_Lb=sy}', "");
    Expect(1, 48, '\P{Is_Lb=sy}', "");
    Expect(0, 48, '\P{^Is_Lb=sy}', "");
    Expect(1, 47, '\p{Is_Lb= _sy}', "");
    Expect(0, 47, '\p{^Is_Lb= _sy}', "");
    Expect(0, 47, '\P{Is_Lb= _sy}', "");
    Expect(1, 47, '\P{^Is_Lb= _sy}', "");
    Expect(0, 48, '\p{Is_Lb= _sy}', "");
    Expect(1, 48, '\p{^Is_Lb= _sy}', "");
    Expect(1, 48, '\P{Is_Lb= _sy}', "");
    Expect(0, 48, '\P{^Is_Lb= _sy}', "");
    Error('\p{Line_Break=_/a/Word_Joiner}');
    Error('\P{Line_Break=_/a/Word_Joiner}');
    Expect(1, 65279, '\p{Line_Break=:\AWord_Joiner\z:}', "");;
    Expect(0, 65280, '\p{Line_Break=:\AWord_Joiner\z:}', "");;
    Expect(1, 65279, '\p{Line_Break=wordjoiner}', "");
    Expect(0, 65279, '\p{^Line_Break=wordjoiner}', "");
    Expect(0, 65279, '\P{Line_Break=wordjoiner}', "");
    Expect(1, 65279, '\P{^Line_Break=wordjoiner}', "");
    Expect(0, 65280, '\p{Line_Break=wordjoiner}', "");
    Expect(1, 65280, '\p{^Line_Break=wordjoiner}', "");
    Expect(1, 65280, '\P{Line_Break=wordjoiner}', "");
    Expect(0, 65280, '\P{^Line_Break=wordjoiner}', "");
    Expect(1, 65279, '\p{Line_Break=:\Awordjoiner\z:}', "");;
    Expect(0, 65280, '\p{Line_Break=:\Awordjoiner\z:}', "");;
    Expect(1, 65279, '\p{Line_Break=_WORD_Joiner}', "");
    Expect(0, 65279, '\p{^Line_Break=_WORD_Joiner}', "");
    Expect(0, 65279, '\P{Line_Break=_WORD_Joiner}', "");
    Expect(1, 65279, '\P{^Line_Break=_WORD_Joiner}', "");
    Expect(0, 65280, '\p{Line_Break=_WORD_Joiner}', "");
    Expect(1, 65280, '\p{^Line_Break=_WORD_Joiner}', "");
    Expect(1, 65280, '\P{Line_Break=_WORD_Joiner}', "");
    Expect(0, 65280, '\P{^Line_Break=_WORD_Joiner}', "");
    Error('\p{Lb=-_WJ:=}');
    Error('\P{Lb=-_WJ:=}');
    Expect(1, 65279, '\p{Lb=:\AWJ\z:}', "");;
    Expect(0, 65280, '\p{Lb=:\AWJ\z:}', "");;
    Expect(1, 65279, '\p{Lb=wj}', "");
    Expect(0, 65279, '\p{^Lb=wj}', "");
    Expect(0, 65279, '\P{Lb=wj}', "");
    Expect(1, 65279, '\P{^Lb=wj}', "");
    Expect(0, 65280, '\p{Lb=wj}', "");
    Expect(1, 65280, '\p{^Lb=wj}', "");
    Expect(1, 65280, '\P{Lb=wj}', "");
    Expect(0, 65280, '\P{^Lb=wj}', "");
    Expect(1, 65279, '\p{Lb=:\Awj\z:}', "");;
    Expect(0, 65280, '\p{Lb=:\Awj\z:}', "");;
    Expect(1, 65279, '\p{Lb=		WJ}', "");
    Expect(0, 65279, '\p{^Lb=		WJ}', "");
    Expect(0, 65279, '\P{Lb=		WJ}', "");
    Expect(1, 65279, '\P{^Lb=		WJ}', "");
    Expect(0, 65280, '\p{Lb=		WJ}', "");
    Expect(1, 65280, '\p{^Lb=		WJ}', "");
    Expect(1, 65280, '\P{Lb=		WJ}', "");
    Expect(0, 65280, '\P{^Lb=		WJ}', "");
    Error('\p{Is_Line_Break=/a/- Word_Joiner}');
    Error('\P{Is_Line_Break=/a/- Word_Joiner}');
    Expect(1, 65279, '\p{Is_Line_Break=wordjoiner}', "");
    Expect(0, 65279, '\p{^Is_Line_Break=wordjoiner}', "");
    Expect(0, 65279, '\P{Is_Line_Break=wordjoiner}', "");
    Expect(1, 65279, '\P{^Is_Line_Break=wordjoiner}', "");
    Expect(0, 65280, '\p{Is_Line_Break=wordjoiner}', "");
    Expect(1, 65280, '\p{^Is_Line_Break=wordjoiner}', "");
    Expect(1, 65280, '\P{Is_Line_Break=wordjoiner}', "");
    Expect(0, 65280, '\P{^Is_Line_Break=wordjoiner}', "");
    Expect(1, 65279, '\p{Is_Line_Break=__WORD_JOINER}', "");
    Expect(0, 65279, '\p{^Is_Line_Break=__WORD_JOINER}', "");
    Expect(0, 65279, '\P{Is_Line_Break=__WORD_JOINER}', "");
    Expect(1, 65279, '\P{^Is_Line_Break=__WORD_JOINER}', "");
    Expect(0, 65280, '\p{Is_Line_Break=__WORD_JOINER}', "");
    Expect(1, 65280, '\p{^Is_Line_Break=__WORD_JOINER}', "");
    Expect(1, 65280, '\P{Is_Line_Break=__WORD_JOINER}', "");
    Expect(0, 65280, '\P{^Is_Line_Break=__WORD_JOINER}', "");
    Error('\p{Is_Lb=- wj:=}');
    Error('\P{Is_Lb=- wj:=}');
    Expect(1, 65279, '\p{Is_Lb=wj}', "");
    Expect(0, 65279, '\p{^Is_Lb=wj}', "");
    Expect(0, 65279, '\P{Is_Lb=wj}', "");
    Expect(1, 65279, '\P{^Is_Lb=wj}', "");
    Expect(0, 65280, '\p{Is_Lb=wj}', "");
    Expect(1, 65280, '\p{^Is_Lb=wj}', "");
    Expect(1, 65280, '\P{Is_Lb=wj}', "");
    Expect(0, 65280, '\P{^Is_Lb=wj}', "");
    Expect(1, 65279, '\p{Is_Lb=- WJ}', "");
    Expect(0, 65279, '\p{^Is_Lb=- WJ}', "");
    Expect(0, 65279, '\P{Is_Lb=- WJ}', "");
    Expect(1, 65279, '\P{^Is_Lb=- WJ}', "");
    Expect(0, 65280, '\p{Is_Lb=- WJ}', "");
    Expect(1, 65280, '\p{^Is_Lb=- WJ}', "");
    Expect(1, 65280, '\P{Is_Lb=- WJ}', "");
    Expect(0, 65280, '\P{^Is_Lb=- WJ}', "");
    Error('\p{Line_Break=/a/-	Unknown}');
    Error('\P{Line_Break=/a/-	Unknown}');
    Expect(1, 918000, '\p{Line_Break=:\AUnknown\z:}', "");;
    Expect(0, 917999, '\p{Line_Break=:\AUnknown\z:}', "");;
    Expect(1, 918000, '\p{Line_Break=unknown}', "");
    Expect(0, 918000, '\p{^Line_Break=unknown}', "");
    Expect(0, 918000, '\P{Line_Break=unknown}', "");
    Expect(1, 918000, '\P{^Line_Break=unknown}', "");
    Expect(0, 917999, '\p{Line_Break=unknown}', "");
    Expect(1, 917999, '\p{^Line_Break=unknown}', "");
    Expect(1, 917999, '\P{Line_Break=unknown}', "");
    Expect(0, 917999, '\P{^Line_Break=unknown}', "");
    Expect(1, 918000, '\p{Line_Break=:\Aunknown\z:}', "");;
    Expect(0, 917999, '\p{Line_Break=:\Aunknown\z:}', "");;
    Expect(1, 918000, '\p{Line_Break=_	unknown}', "");
    Expect(0, 918000, '\p{^Line_Break=_	unknown}', "");
    Expect(0, 918000, '\P{Line_Break=_	unknown}', "");
    Expect(1, 918000, '\P{^Line_Break=_	unknown}', "");
    Expect(0, 917999, '\p{Line_Break=_	unknown}', "");
    Expect(1, 917999, '\p{^Line_Break=_	unknown}', "");
    Expect(1, 917999, '\P{Line_Break=_	unknown}', "");
    Expect(0, 917999, '\P{^Line_Break=_	unknown}', "");
    Error('\p{Lb=/a/__xx}');
    Error('\P{Lb=/a/__xx}');
    Expect(1, 918000, '\p{Lb=:\AXX\z:}', "");;
    Expect(0, 917999, '\p{Lb=:\AXX\z:}', "");;
    Expect(1, 918000, '\p{Lb=xx}', "");
    Expect(0, 918000, '\p{^Lb=xx}', "");
    Expect(0, 918000, '\P{Lb=xx}', "");
    Expect(1, 918000, '\P{^Lb=xx}', "");
    Expect(0, 917999, '\p{Lb=xx}', "");
    Expect(1, 917999, '\p{^Lb=xx}', "");
    Expect(1, 917999, '\P{Lb=xx}', "");
    Expect(0, 917999, '\P{^Lb=xx}', "");
    Expect(1, 918000, '\p{Lb=:\Axx\z:}', "");;
    Expect(0, 917999, '\p{Lb=:\Axx\z:}', "");;
    Expect(1, 918000, '\p{Lb=_-XX}', "");
    Expect(0, 918000, '\p{^Lb=_-XX}', "");
    Expect(0, 918000, '\P{Lb=_-XX}', "");
    Expect(1, 918000, '\P{^Lb=_-XX}', "");
    Expect(0, 917999, '\p{Lb=_-XX}', "");
    Expect(1, 917999, '\p{^Lb=_-XX}', "");
    Expect(1, 917999, '\P{Lb=_-XX}', "");
    Expect(0, 917999, '\P{^Lb=_-XX}', "");
    Error('\p{Is_Line_Break=unknown:=}');
    Error('\P{Is_Line_Break=unknown:=}');
    Expect(1, 918000, '\p{Is_Line_Break=unknown}', "");
    Expect(0, 918000, '\p{^Is_Line_Break=unknown}', "");
    Expect(0, 918000, '\P{Is_Line_Break=unknown}', "");
    Expect(1, 918000, '\P{^Is_Line_Break=unknown}', "");
    Expect(0, 917999, '\p{Is_Line_Break=unknown}', "");
    Expect(1, 917999, '\p{^Is_Line_Break=unknown}', "");
    Expect(1, 917999, '\P{Is_Line_Break=unknown}', "");
    Expect(0, 917999, '\P{^Is_Line_Break=unknown}', "");
    Expect(1, 918000, '\p{Is_Line_Break= -Unknown}', "");
    Expect(0, 918000, '\p{^Is_Line_Break= -Unknown}', "");
    Expect(0, 918000, '\P{Is_Line_Break= -Unknown}', "");
    Expect(1, 918000, '\P{^Is_Line_Break= -Unknown}', "");
    Expect(0, 917999, '\p{Is_Line_Break= -Unknown}', "");
    Expect(1, 917999, '\p{^Is_Line_Break= -Unknown}', "");
    Expect(1, 917999, '\P{Is_Line_Break= -Unknown}', "");
    Expect(0, 917999, '\P{^Is_Line_Break= -Unknown}', "");
    Error('\p{Is_Lb=/a/__xx}');
    Error('\P{Is_Lb=/a/__xx}');
    Expect(1, 918000, '\p{Is_Lb: xx}', "");
    Expect(0, 918000, '\p{^Is_Lb: xx}', "");
    Expect(0, 918000, '\P{Is_Lb: xx}', "");
    Expect(1, 918000, '\P{^Is_Lb: xx}', "");
    Expect(0, 917999, '\p{Is_Lb: xx}', "");
    Expect(1, 917999, '\p{^Is_Lb: xx}', "");
    Expect(1, 917999, '\P{Is_Lb: xx}', "");
    Expect(0, 917999, '\P{^Is_Lb: xx}', "");
    Expect(1, 918000, '\p{Is_Lb=_XX}', "");
    Expect(0, 918000, '\p{^Is_Lb=_XX}', "");
    Expect(0, 918000, '\P{Is_Lb=_XX}', "");
    Expect(1, 918000, '\P{^Is_Lb=_XX}', "");
    Expect(0, 917999, '\p{Is_Lb=_XX}', "");
    Expect(1, 917999, '\p{^Is_Lb=_XX}', "");
    Expect(1, 917999, '\P{Is_Lb=_XX}', "");
    Expect(0, 917999, '\P{^Is_Lb=_XX}', "");
    Error('\p{Line_Break=	:=zwspace}');
    Error('\P{Line_Break=	:=zwspace}');
    Expect(1, 8203, '\p{Line_Break=:\AZWSpace\z:}', "");;
    Expect(0, 8204, '\p{Line_Break=:\AZWSpace\z:}', "");;
    Expect(1, 8203, '\p{Line_Break=zwspace}', "");
    Expect(0, 8203, '\p{^Line_Break=zwspace}', "");
    Expect(0, 8203, '\P{Line_Break=zwspace}', "");
    Expect(1, 8203, '\P{^Line_Break=zwspace}', "");
    Expect(0, 8204, '\p{Line_Break=zwspace}', "");
    Expect(1, 8204, '\p{^Line_Break=zwspace}', "");
    Expect(1, 8204, '\P{Line_Break=zwspace}', "");
    Expect(0, 8204, '\P{^Line_Break=zwspace}', "");
    Expect(1, 8203, '\p{Line_Break=:\Azwspace\z:}', "");;
    Expect(0, 8204, '\p{Line_Break=:\Azwspace\z:}', "");;
    Expect(1, 8203, '\p{Line_Break=	 zwspace}', "");
    Expect(0, 8203, '\p{^Line_Break=	 zwspace}', "");
    Expect(0, 8203, '\P{Line_Break=	 zwspace}', "");
    Expect(1, 8203, '\P{^Line_Break=	 zwspace}', "");
    Expect(0, 8204, '\p{Line_Break=	 zwspace}', "");
    Expect(1, 8204, '\p{^Line_Break=	 zwspace}', "");
    Expect(1, 8204, '\P{Line_Break=	 zwspace}', "");
    Expect(0, 8204, '\P{^Line_Break=	 zwspace}', "");
    Error('\p{Lb: /a/ZW}');
    Error('\P{Lb: /a/ZW}');
    Expect(1, 8203, '\p{Lb=:\AZW\z:}', "");;
    Expect(0, 8204, '\p{Lb=:\AZW\z:}', "");;
    Expect(1, 8203, '\p{Lb=zw}', "");
    Expect(0, 8203, '\p{^Lb=zw}', "");
    Expect(0, 8203, '\P{Lb=zw}', "");
    Expect(1, 8203, '\P{^Lb=zw}', "");
    Expect(0, 8204, '\p{Lb=zw}', "");
    Expect(1, 8204, '\p{^Lb=zw}', "");
    Expect(1, 8204, '\P{Lb=zw}', "");
    Expect(0, 8204, '\P{^Lb=zw}', "");
    Expect(1, 8203, '\p{Lb=:\Azw\z:}', "");;
    Expect(0, 8204, '\p{Lb=:\Azw\z:}', "");;
    Expect(1, 8203, '\p{Lb=ZW}', "");
    Expect(0, 8203, '\p{^Lb=ZW}', "");
    Expect(0, 8203, '\P{Lb=ZW}', "");
    Expect(1, 8203, '\P{^Lb=ZW}', "");
    Expect(0, 8204, '\p{Lb=ZW}', "");
    Expect(1, 8204, '\p{^Lb=ZW}', "");
    Expect(1, 8204, '\P{Lb=ZW}', "");
    Expect(0, 8204, '\P{^Lb=ZW}', "");
    Error('\p{Is_Line_Break=/a/-_ZWSPACE}');
    Error('\P{Is_Line_Break=/a/-_ZWSPACE}');
    Expect(1, 8203, '\p{Is_Line_Break=zwspace}', "");
    Expect(0, 8203, '\p{^Is_Line_Break=zwspace}', "");
    Expect(0, 8203, '\P{Is_Line_Break=zwspace}', "");
    Expect(1, 8203, '\P{^Is_Line_Break=zwspace}', "");
    Expect(0, 8204, '\p{Is_Line_Break=zwspace}', "");
    Expect(1, 8204, '\p{^Is_Line_Break=zwspace}', "");
    Expect(1, 8204, '\P{Is_Line_Break=zwspace}', "");
    Expect(0, 8204, '\P{^Is_Line_Break=zwspace}', "");
    Expect(1, 8203, '\p{Is_Line_Break= -ZWSPACE}', "");
    Expect(0, 8203, '\p{^Is_Line_Break= -ZWSPACE}', "");
    Expect(0, 8203, '\P{Is_Line_Break= -ZWSPACE}', "");
    Expect(1, 8203, '\P{^Is_Line_Break= -ZWSPACE}', "");
    Expect(0, 8204, '\p{Is_Line_Break= -ZWSPACE}', "");
    Expect(1, 8204, '\p{^Is_Line_Break= -ZWSPACE}', "");
    Expect(1, 8204, '\P{Is_Line_Break= -ZWSPACE}', "");
    Expect(0, 8204, '\P{^Is_Line_Break= -ZWSPACE}', "");
    Error('\p{Is_Lb=/a/ZW}');
    Error('\P{Is_Lb=/a/ZW}');
    Expect(1, 8203, '\p{Is_Lb=zw}', "");
    Expect(0, 8203, '\p{^Is_Lb=zw}', "");
    Expect(0, 8203, '\P{Is_Lb=zw}', "");
    Expect(1, 8203, '\P{^Is_Lb=zw}', "");
    Expect(0, 8204, '\p{Is_Lb=zw}', "");
    Expect(1, 8204, '\p{^Is_Lb=zw}', "");
    Expect(1, 8204, '\P{Is_Lb=zw}', "");
    Expect(0, 8204, '\P{^Is_Lb=zw}', "");
    Expect(1, 8203, '\p{Is_Lb:   _ZW}', "");
    Expect(0, 8203, '\p{^Is_Lb:   _ZW}', "");
    Expect(0, 8203, '\P{Is_Lb:   _ZW}', "");
    Expect(1, 8203, '\P{^Is_Lb:   _ZW}', "");
    Expect(0, 8204, '\p{Is_Lb:   _ZW}', "");
    Expect(1, 8204, '\p{^Is_Lb:   _ZW}', "");
    Expect(1, 8204, '\P{Is_Lb:   _ZW}', "");
    Expect(0, 8204, '\P{^Is_Lb:   _ZW}', "");
    Error('\p{Line_Break=-_zwj/a/}');
    Error('\P{Line_Break=-_zwj/a/}');
    Expect(1, 8205, '\p{Line_Break=:\AZWJ\z:}', "");;
    Expect(0, 8206, '\p{Line_Break=:\AZWJ\z:}', "");;
    Expect(1, 8205, '\p{Line_Break=zwj}', "");
    Expect(0, 8205, '\p{^Line_Break=zwj}', "");
    Expect(0, 8205, '\P{Line_Break=zwj}', "");
    Expect(1, 8205, '\P{^Line_Break=zwj}', "");
    Expect(0, 8206, '\p{Line_Break=zwj}', "");
    Expect(1, 8206, '\p{^Line_Break=zwj}', "");
    Expect(1, 8206, '\P{Line_Break=zwj}', "");
    Expect(0, 8206, '\P{^Line_Break=zwj}', "");
    Expect(1, 8205, '\p{Line_Break=:\Azwj\z:}', "");;
    Expect(0, 8206, '\p{Line_Break=:\Azwj\z:}', "");;
    Expect(1, 8205, '\p{Line_Break=--ZWJ}', "");
    Expect(0, 8205, '\p{^Line_Break=--ZWJ}', "");
    Expect(0, 8205, '\P{Line_Break=--ZWJ}', "");
    Expect(1, 8205, '\P{^Line_Break=--ZWJ}', "");
    Expect(0, 8206, '\p{Line_Break=--ZWJ}', "");
    Expect(1, 8206, '\p{^Line_Break=--ZWJ}', "");
    Expect(1, 8206, '\P{Line_Break=--ZWJ}', "");
    Expect(0, 8206, '\P{^Line_Break=--ZWJ}', "");
    Error('\p{Lb=-_zwj/a/}');
    Error('\P{Lb=-_zwj/a/}');
    Expect(1, 8205, '\p{Lb=:\AZWJ\z:}', "");;
    Expect(0, 8206, '\p{Lb=:\AZWJ\z:}', "");;
    Expect(1, 8205, '\p{Lb=zwj}', "");
    Expect(0, 8205, '\p{^Lb=zwj}', "");
    Expect(0, 8205, '\P{Lb=zwj}', "");
    Expect(1, 8205, '\P{^Lb=zwj}', "");
    Expect(0, 8206, '\p{Lb=zwj}', "");
    Expect(1, 8206, '\p{^Lb=zwj}', "");
    Expect(1, 8206, '\P{Lb=zwj}', "");
    Expect(0, 8206, '\P{^Lb=zwj}', "");
    Expect(1, 8205, '\p{Lb=:\Azwj\z:}', "");;
    Expect(0, 8206, '\p{Lb=:\Azwj\z:}', "");;
    Expect(1, 8205, '\p{Lb=_-ZWJ}', "");
    Expect(0, 8205, '\p{^Lb=_-ZWJ}', "");
    Expect(0, 8205, '\P{Lb=_-ZWJ}', "");
    Expect(1, 8205, '\P{^Lb=_-ZWJ}', "");
    Expect(0, 8206, '\p{Lb=_-ZWJ}', "");
    Expect(1, 8206, '\p{^Lb=_-ZWJ}', "");
    Expect(1, 8206, '\P{Lb=_-ZWJ}', "");
    Expect(0, 8206, '\P{^Lb=_-ZWJ}', "");
    Error('\p{Is_Line_Break=_:=zwj}');
    Error('\P{Is_Line_Break=_:=zwj}');
    Expect(1, 8205, '\p{Is_Line_Break=zwj}', "");
    Expect(0, 8205, '\p{^Is_Line_Break=zwj}', "");
    Expect(0, 8205, '\P{Is_Line_Break=zwj}', "");
    Expect(1, 8205, '\P{^Is_Line_Break=zwj}', "");
    Expect(0, 8206, '\p{Is_Line_Break=zwj}', "");
    Expect(1, 8206, '\p{^Is_Line_Break=zwj}', "");
    Expect(1, 8206, '\P{Is_Line_Break=zwj}', "");
    Expect(0, 8206, '\P{^Is_Line_Break=zwj}', "");
    Expect(1, 8205, '\p{Is_Line_Break=_	ZWJ}', "");
    Expect(0, 8205, '\p{^Is_Line_Break=_	ZWJ}', "");
    Expect(0, 8205, '\P{Is_Line_Break=_	ZWJ}', "");
    Expect(1, 8205, '\P{^Is_Line_Break=_	ZWJ}', "");
    Expect(0, 8206, '\p{Is_Line_Break=_	ZWJ}', "");
    Expect(1, 8206, '\p{^Is_Line_Break=_	ZWJ}', "");
    Expect(1, 8206, '\P{Is_Line_Break=_	ZWJ}', "");
    Expect(0, 8206, '\P{^Is_Line_Break=_	ZWJ}', "");
    Error('\p{Is_Lb: _:=ZWJ}');
    Error('\P{Is_Lb: _:=ZWJ}');
    Expect(1, 8205, '\p{Is_Lb:	zwj}', "");
    Expect(0, 8205, '\p{^Is_Lb:	zwj}', "");
    Expect(0, 8205, '\P{Is_Lb:	zwj}', "");
    Expect(1, 8205, '\P{^Is_Lb:	zwj}', "");
    Expect(0, 8206, '\p{Is_Lb:	zwj}', "");
    Expect(1, 8206, '\p{^Is_Lb:	zwj}', "");
    Expect(1, 8206, '\P{Is_Lb:	zwj}', "");
    Expect(0, 8206, '\P{^Is_Lb:	zwj}', "");
    Expect(1, 8205, '\p{Is_Lb=	-ZWJ}', "");
    Expect(0, 8205, '\p{^Is_Lb=	-ZWJ}', "");
    Expect(0, 8205, '\P{Is_Lb=	-ZWJ}', "");
    Expect(1, 8205, '\P{^Is_Lb=	-ZWJ}', "");
    Expect(0, 8206, '\p{Is_Lb=	-ZWJ}', "");
    Expect(1, 8206, '\p{^Is_Lb=	-ZWJ}', "");
    Expect(1, 8206, '\P{Is_Lb=	-ZWJ}', "");
    Expect(0, 8206, '\P{^Is_Lb=	-ZWJ}', "");
    Error('\p{lowercasemapping}');
    Error('\P{lowercasemapping}');
    Error('\p{legacycasefolding}');
    Error('\P{legacycasefolding}');
    Error('\p{legacylowercasemapping}');
    Error('\P{legacylowercasemapping}');
    Error('\p{legacyperldecimaldigit}');
    Error('\P{legacyperldecimaldigit}');
    Error('\p{legacytitlecasemapping}');
    Error('\P{legacytitlecasemapping}');
    Error('\p{legacyuppercasemapping}');
    Error('\P{legacyuppercasemapping}');
    Error('\p{Logical_Order_Exception=:=		No}');
    Error('\P{Logical_Order_Exception=:=		No}');
    Expect(1, 43709, '\p{Logical_Order_Exception=:\ANo\z:}', "");;
    Expect(0, 43708, '\p{Logical_Order_Exception=:\ANo\z:}', "");;
    Expect(1, 43709, '\p{Logical_Order_Exception=no}', "");
    Expect(0, 43709, '\p{^Logical_Order_Exception=no}', "");
    Expect(0, 43709, '\P{Logical_Order_Exception=no}', "");
    Expect(1, 43709, '\P{^Logical_Order_Exception=no}', "");
    Expect(0, 43708, '\p{Logical_Order_Exception=no}', "");
    Expect(1, 43708, '\p{^Logical_Order_Exception=no}', "");
    Expect(1, 43708, '\P{Logical_Order_Exception=no}', "");
    Expect(0, 43708, '\P{^Logical_Order_Exception=no}', "");
    Expect(1, 43709, '\p{Logical_Order_Exception=:\Ano\z:}', "");;
    Expect(0, 43708, '\p{Logical_Order_Exception=:\Ano\z:}', "");;
    Expect(1, 43709, '\p{Logical_Order_Exception=-No}', "");
    Expect(0, 43709, '\p{^Logical_Order_Exception=-No}', "");
    Expect(0, 43709, '\P{Logical_Order_Exception=-No}', "");
    Expect(1, 43709, '\P{^Logical_Order_Exception=-No}', "");
    Expect(0, 43708, '\p{Logical_Order_Exception=-No}', "");
    Expect(1, 43708, '\p{^Logical_Order_Exception=-No}', "");
    Expect(1, 43708, '\P{Logical_Order_Exception=-No}', "");
    Expect(0, 43708, '\P{^Logical_Order_Exception=-No}', "");
    Error('\p{LOE:   _N:=}');
    Error('\P{LOE:   _N:=}');
    Expect(1, 43709, '\p{LOE=:\AN\z:}', "");;
    Expect(0, 43708, '\p{LOE=:\AN\z:}', "");;
    Expect(1, 43709, '\p{LOE=n}', "");
    Expect(0, 43709, '\p{^LOE=n}', "");
    Expect(0, 43709, '\P{LOE=n}', "");
    Expect(1, 43709, '\P{^LOE=n}', "");
    Expect(0, 43708, '\p{LOE=n}', "");
    Expect(1, 43708, '\p{^LOE=n}', "");
    Expect(1, 43708, '\P{LOE=n}', "");
    Expect(0, 43708, '\P{^LOE=n}', "");
    Expect(1, 43709, '\p{LOE=:\An\z:}', "");;
    Expect(0, 43708, '\p{LOE=:\An\z:}', "");;
    Expect(1, 43709, '\p{LOE=	_N}', "");
    Expect(0, 43709, '\p{^LOE=	_N}', "");
    Expect(0, 43709, '\P{LOE=	_N}', "");
    Expect(1, 43709, '\P{^LOE=	_N}', "");
    Expect(0, 43708, '\p{LOE=	_N}', "");
    Expect(1, 43708, '\p{^LOE=	_N}', "");
    Expect(1, 43708, '\P{LOE=	_N}', "");
    Expect(0, 43708, '\P{^LOE=	_N}', "");
    Error('\p{Is_Logical_Order_Exception=-/a/f}');
    Error('\P{Is_Logical_Order_Exception=-/a/f}');
    Expect(1, 43709, '\p{Is_Logical_Order_Exception=f}', "");
    Expect(0, 43709, '\p{^Is_Logical_Order_Exception=f}', "");
    Expect(0, 43709, '\P{Is_Logical_Order_Exception=f}', "");
    Expect(1, 43709, '\P{^Is_Logical_Order_Exception=f}', "");
    Expect(0, 43708, '\p{Is_Logical_Order_Exception=f}', "");
    Expect(1, 43708, '\p{^Is_Logical_Order_Exception=f}', "");
    Expect(1, 43708, '\P{Is_Logical_Order_Exception=f}', "");
    Expect(0, 43708, '\P{^Is_Logical_Order_Exception=f}', "");
    Expect(1, 43709, '\p{Is_Logical_Order_Exception= F}', "");
    Expect(0, 43709, '\p{^Is_Logical_Order_Exception= F}', "");
    Expect(0, 43709, '\P{Is_Logical_Order_Exception= F}', "");
    Expect(1, 43709, '\P{^Is_Logical_Order_Exception= F}', "");
    Expect(0, 43708, '\p{Is_Logical_Order_Exception= F}', "");
    Expect(1, 43708, '\p{^Is_Logical_Order_Exception= F}', "");
    Expect(1, 43708, '\P{Is_Logical_Order_Exception= F}', "");
    Expect(0, 43708, '\P{^Is_Logical_Order_Exception= F}', "");
    Error('\p{Is_LOE=_FALSE:=}');
    Error('\P{Is_LOE=_FALSE:=}');
    Expect(1, 43709, '\p{Is_LOE=false}', "");
    Expect(0, 43709, '\p{^Is_LOE=false}', "");
    Expect(0, 43709, '\P{Is_LOE=false}', "");
    Expect(1, 43709, '\P{^Is_LOE=false}', "");
    Expect(0, 43708, '\p{Is_LOE=false}', "");
    Expect(1, 43708, '\p{^Is_LOE=false}', "");
    Expect(1, 43708, '\P{Is_LOE=false}', "");
    Expect(0, 43708, '\P{^Is_LOE=false}', "");
    Expect(1, 43709, '\p{Is_LOE=- FALSE}', "");
    Expect(0, 43709, '\p{^Is_LOE=- FALSE}', "");
    Expect(0, 43709, '\P{Is_LOE=- FALSE}', "");
    Expect(1, 43709, '\P{^Is_LOE=- FALSE}', "");
    Expect(0, 43708, '\p{Is_LOE=- FALSE}', "");
    Expect(1, 43708, '\p{^Is_LOE=- FALSE}', "");
    Expect(1, 43708, '\P{Is_LOE=- FALSE}', "");
    Expect(0, 43708, '\P{^Is_LOE=- FALSE}', "");
    Error('\p{Logical_Order_Exception=_/a/Yes}');
    Error('\P{Logical_Order_Exception=_/a/Yes}');
    Expect(1, 43708, '\p{Logical_Order_Exception=:\AYes\z:}', "");;
    Expect(0, 43709, '\p{Logical_Order_Exception=:\AYes\z:}', "");;
    Expect(1, 43708, '\p{Logical_Order_Exception=yes}', "");
    Expect(0, 43708, '\p{^Logical_Order_Exception=yes}', "");
    Expect(0, 43708, '\P{Logical_Order_Exception=yes}', "");
    Expect(1, 43708, '\P{^Logical_Order_Exception=yes}', "");
    Expect(0, 43709, '\p{Logical_Order_Exception=yes}', "");
    Expect(1, 43709, '\p{^Logical_Order_Exception=yes}', "");
    Expect(1, 43709, '\P{Logical_Order_Exception=yes}', "");
    Expect(0, 43709, '\P{^Logical_Order_Exception=yes}', "");
    Expect(1, 43708, '\p{Logical_Order_Exception=:\Ayes\z:}', "");;
    Expect(0, 43709, '\p{Logical_Order_Exception=:\Ayes\z:}', "");;
    Expect(1, 43708, '\p{Logical_Order_Exception=_ Yes}', "");
    Expect(0, 43708, '\p{^Logical_Order_Exception=_ Yes}', "");
    Expect(0, 43708, '\P{Logical_Order_Exception=_ Yes}', "");
    Expect(1, 43708, '\P{^Logical_Order_Exception=_ Yes}', "");
    Expect(0, 43709, '\p{Logical_Order_Exception=_ Yes}', "");
    Expect(1, 43709, '\p{^Logical_Order_Exception=_ Yes}', "");
    Expect(1, 43709, '\P{Logical_Order_Exception=_ Yes}', "");
    Expect(0, 43709, '\P{^Logical_Order_Exception=_ Yes}', "");
    Error('\p{LOE=-/a/Y}');
    Error('\P{LOE=-/a/Y}');
    Expect(1, 43708, '\p{LOE=:\AY\z:}', "");;
    Expect(0, 43709, '\p{LOE=:\AY\z:}', "");;
    Expect(1, 43708, '\p{LOE=y}', "");
    Expect(0, 43708, '\p{^LOE=y}', "");
    Expect(0, 43708, '\P{LOE=y}', "");
    Expect(1, 43708, '\P{^LOE=y}', "");
    Expect(0, 43709, '\p{LOE=y}', "");
    Expect(1, 43709, '\p{^LOE=y}', "");
    Expect(1, 43709, '\P{LOE=y}', "");
    Expect(0, 43709, '\P{^LOE=y}', "");
    Expect(1, 43708, '\p{LOE=:\Ay\z:}', "");;
    Expect(0, 43709, '\p{LOE=:\Ay\z:}', "");;
    Expect(1, 43708, '\p{LOE= y}', "");
    Expect(0, 43708, '\p{^LOE= y}', "");
    Expect(0, 43708, '\P{LOE= y}', "");
    Expect(1, 43708, '\P{^LOE= y}', "");
    Expect(0, 43709, '\p{LOE= y}', "");
    Expect(1, 43709, '\p{^LOE= y}', "");
    Expect(1, 43709, '\P{LOE= y}', "");
    Expect(0, 43709, '\P{^LOE= y}', "");
    Error('\p{Is_Logical_Order_Exception=-/a/T}');
    Error('\P{Is_Logical_Order_Exception=-/a/T}');
    Expect(1, 43708, '\p{Is_Logical_Order_Exception=t}', "");
    Expect(0, 43708, '\p{^Is_Logical_Order_Exception=t}', "");
    Expect(0, 43708, '\P{Is_Logical_Order_Exception=t}', "");
    Expect(1, 43708, '\P{^Is_Logical_Order_Exception=t}', "");
    Expect(0, 43709, '\p{Is_Logical_Order_Exception=t}', "");
    Expect(1, 43709, '\p{^Is_Logical_Order_Exception=t}', "");
    Expect(1, 43709, '\P{Is_Logical_Order_Exception=t}', "");
    Expect(0, 43709, '\P{^Is_Logical_Order_Exception=t}', "");
    Expect(1, 43708, '\p{Is_Logical_Order_Exception=  T}', "");
    Expect(0, 43708, '\p{^Is_Logical_Order_Exception=  T}', "");
    Expect(0, 43708, '\P{Is_Logical_Order_Exception=  T}', "");
    Expect(1, 43708, '\P{^Is_Logical_Order_Exception=  T}', "");
    Expect(0, 43709, '\p{Is_Logical_Order_Exception=  T}', "");
    Expect(1, 43709, '\p{^Is_Logical_Order_Exception=  T}', "");
    Expect(1, 43709, '\P{Is_Logical_Order_Exception=  T}', "");
    Expect(0, 43709, '\P{^Is_Logical_Order_Exception=  T}', "");
    Error('\p{Is_LOE=:=_-TRUE}');
    Error('\P{Is_LOE=:=_-TRUE}');
    Expect(1, 43708, '\p{Is_LOE=true}', "");
    Expect(0, 43708, '\p{^Is_LOE=true}', "");
    Expect(0, 43708, '\P{Is_LOE=true}', "");
    Expect(1, 43708, '\P{^Is_LOE=true}', "");
    Expect(0, 43709, '\p{Is_LOE=true}', "");
    Expect(1, 43709, '\p{^Is_LOE=true}', "");
    Expect(1, 43709, '\P{Is_LOE=true}', "");
    Expect(0, 43709, '\P{^Is_LOE=true}', "");
    Expect(1, 43708, '\p{Is_LOE=_-TRUE}', "");
    Expect(0, 43708, '\p{^Is_LOE=_-TRUE}', "");
    Expect(0, 43708, '\P{Is_LOE=_-TRUE}', "");
    Expect(1, 43708, '\P{^Is_LOE=_-TRUE}', "");
    Expect(0, 43709, '\p{Is_LOE=_-TRUE}', "");
    Expect(1, 43709, '\p{^Is_LOE=_-TRUE}', "");
    Expect(1, 43709, '\P{Is_LOE=_-TRUE}', "");
    Expect(0, 43709, '\P{^Is_LOE=_-TRUE}', "");
    Error('\p{Lowercase=	:=No}');
    Error('\P{Lowercase=	:=No}');
    Expect(1, 125252, '\p{Lowercase=:\ANo\z:}', "");;
    Expect(0, 125251, '\p{Lowercase=:\ANo\z:}', "");;
    Expect(1, 125252, '\p{Lowercase=no}', "");
    Expect(0, 125252, '\p{^Lowercase=no}', "");
    Expect(0, 125252, '\P{Lowercase=no}', "");
    Expect(1, 125252, '\P{^Lowercase=no}', "");
    Expect(0, 125251, '\p{Lowercase=no}', "");
    Expect(1, 125251, '\p{^Lowercase=no}', "");
    Expect(1, 125251, '\P{Lowercase=no}', "");
    Expect(0, 125251, '\P{^Lowercase=no}', "");
    Expect(1, 125252, '\p{Lowercase=:\Ano\z:}', "");;
    Expect(0, 125251, '\p{Lowercase=:\Ano\z:}', "");;
    Expect(1, 125252, '\p{Lowercase=- No}', "");
    Expect(0, 125252, '\p{^Lowercase=- No}', "");
    Expect(0, 125252, '\P{Lowercase=- No}', "");
    Expect(1, 125252, '\P{^Lowercase=- No}', "");
    Expect(0, 125251, '\p{Lowercase=- No}', "");
    Expect(1, 125251, '\p{^Lowercase=- No}', "");
    Expect(1, 125251, '\P{Lowercase=- No}', "");
    Expect(0, 125251, '\P{^Lowercase=- No}', "");
    Error('\p{Lower=:=N}');
    Error('\P{Lower=:=N}');
    Expect(1, 125252, '\p{Lower=:\AN\z:}', "");;
    Expect(0, 125251, '\p{Lower=:\AN\z:}', "");;
    Expect(1, 125252, '\p{Lower=n}', "");
    Expect(0, 125252, '\p{^Lower=n}', "");
    Expect(0, 125252, '\P{Lower=n}', "");
    Expect(1, 125252, '\P{^Lower=n}', "");
    Expect(0, 125251, '\p{Lower=n}', "");
    Expect(1, 125251, '\p{^Lower=n}', "");
    Expect(1, 125251, '\P{Lower=n}', "");
    Expect(0, 125251, '\P{^Lower=n}', "");
    Expect(1, 125252, '\p{Lower=:\An\z:}', "");;
    Expect(0, 125251, '\p{Lower=:\An\z:}', "");;
    Expect(1, 125252, '\p{Lower:   -n}', "");
    Expect(0, 125252, '\p{^Lower:   -n}', "");
    Expect(0, 125252, '\P{Lower:   -n}', "");
    Expect(1, 125252, '\P{^Lower:   -n}', "");
    Expect(0, 125251, '\p{Lower:   -n}', "");
    Expect(1, 125251, '\p{^Lower:   -n}', "");
    Expect(1, 125251, '\P{Lower:   -n}', "");
    Expect(0, 125251, '\P{^Lower:   -n}', "");
    Error('\p{Is_Lowercase=  F/a/}');
    Error('\P{Is_Lowercase=  F/a/}');
    Expect(1, 125252, '\p{Is_Lowercase=f}', "");
    Expect(0, 125252, '\p{^Is_Lowercase=f}', "");
    Expect(0, 125252, '\P{Is_Lowercase=f}', "");
    Expect(1, 125252, '\P{^Is_Lowercase=f}', "");
    Expect(0, 125251, '\p{Is_Lowercase=f}', "");
    Expect(1, 125251, '\p{^Is_Lowercase=f}', "");
    Expect(1, 125251, '\P{Is_Lowercase=f}', "");
    Expect(0, 125251, '\P{^Is_Lowercase=f}', "");
    Expect(1, 125252, '\p{Is_Lowercase=F}', "");
    Expect(0, 125252, '\p{^Is_Lowercase=F}', "");
    Expect(0, 125252, '\P{Is_Lowercase=F}', "");
    Expect(1, 125252, '\P{^Is_Lowercase=F}', "");
    Expect(0, 125251, '\p{Is_Lowercase=F}', "");
    Expect(1, 125251, '\p{^Is_Lowercase=F}', "");
    Expect(1, 125251, '\P{Is_Lowercase=F}', "");
    Expect(0, 125251, '\P{^Is_Lowercase=F}', "");
    Error('\p{Is_Lower=:=False}');
    Error('\P{Is_Lower=:=False}');
    Expect(1, 125252, '\p{Is_Lower=false}', "");
    Expect(0, 125252, '\p{^Is_Lower=false}', "");
    Expect(0, 125252, '\P{Is_Lower=false}', "");
    Expect(1, 125252, '\P{^Is_Lower=false}', "");
    Expect(0, 125251, '\p{Is_Lower=false}', "");
    Expect(1, 125251, '\p{^Is_Lower=false}', "");
    Expect(1, 125251, '\P{Is_Lower=false}', "");
    Expect(0, 125251, '\P{^Is_Lower=false}', "");
    Expect(1, 125252, '\p{Is_Lower=__False}', "");
    Expect(0, 125252, '\p{^Is_Lower=__False}', "");
    Expect(0, 125252, '\P{Is_Lower=__False}', "");
    Expect(1, 125252, '\P{^Is_Lower=__False}', "");
    Expect(0, 125251, '\p{Is_Lower=__False}', "");
    Expect(1, 125251, '\p{^Is_Lower=__False}', "");
    Expect(1, 125251, '\P{Is_Lower=__False}', "");
    Expect(0, 125251, '\P{^Is_Lower=__False}', "");
    Error('\p{Lowercase=:=		Yes}');
    Error('\P{Lowercase=:=		Yes}');
    Expect(1, 125251, '\p{Lowercase=:\AYes\z:}', "");;
    Expect(0, 125252, '\p{Lowercase=:\AYes\z:}', "");;
    Expect(1, 125251, '\p{Lowercase=yes}', "");
    Expect(0, 125251, '\p{^Lowercase=yes}', "");
    Expect(0, 125251, '\P{Lowercase=yes}', "");
    Expect(1, 125251, '\P{^Lowercase=yes}', "");
    Expect(0, 125252, '\p{Lowercase=yes}', "");
    Expect(1, 125252, '\p{^Lowercase=yes}', "");
    Expect(1, 125252, '\P{Lowercase=yes}', "");
    Expect(0, 125252, '\P{^Lowercase=yes}', "");
    Expect(1, 125251, '\p{Lowercase=:\Ayes\z:}', "");;
    Expect(0, 125252, '\p{Lowercase=:\Ayes\z:}', "");;
    Expect(1, 125251, '\p{Lowercase=	 YES}', "");
    Expect(0, 125251, '\p{^Lowercase=	 YES}', "");
    Expect(0, 125251, '\P{Lowercase=	 YES}', "");
    Expect(1, 125251, '\P{^Lowercase=	 YES}', "");
    Expect(0, 125252, '\p{Lowercase=	 YES}', "");
    Expect(1, 125252, '\p{^Lowercase=	 YES}', "");
    Expect(1, 125252, '\P{Lowercase=	 YES}', "");
    Expect(0, 125252, '\P{^Lowercase=	 YES}', "");
    Error('\p{Lower=	 Y:=}');
    Error('\P{Lower=	 Y:=}');
    Expect(1, 125251, '\p{Lower=:\AY\z:}', "");;
    Expect(0, 125252, '\p{Lower=:\AY\z:}', "");;
    Expect(1, 125251, '\p{Lower=y}', "");
    Expect(0, 125251, '\p{^Lower=y}', "");
    Expect(0, 125251, '\P{Lower=y}', "");
    Expect(1, 125251, '\P{^Lower=y}', "");
    Expect(0, 125252, '\p{Lower=y}', "");
    Expect(1, 125252, '\p{^Lower=y}', "");
    Expect(1, 125252, '\P{Lower=y}', "");
    Expect(0, 125252, '\P{^Lower=y}', "");
    Expect(1, 125251, '\p{Lower=:\Ay\z:}', "");;
    Expect(0, 125252, '\p{Lower=:\Ay\z:}', "");;
    Expect(1, 125251, '\p{Lower=		Y}', "");
    Expect(0, 125251, '\p{^Lower=		Y}', "");
    Expect(0, 125251, '\P{Lower=		Y}', "");
    Expect(1, 125251, '\P{^Lower=		Y}', "");
    Expect(0, 125252, '\p{Lower=		Y}', "");
    Expect(1, 125252, '\p{^Lower=		Y}', "");
    Expect(1, 125252, '\P{Lower=		Y}', "");
    Expect(0, 125252, '\P{^Lower=		Y}', "");
    Error('\p{Is_Lowercase=:= -T}');
    Error('\P{Is_Lowercase=:= -T}');
    Expect(1, 125251, '\p{Is_Lowercase=t}', "");
    Expect(0, 125251, '\p{^Is_Lowercase=t}', "");
    Expect(0, 125251, '\P{Is_Lowercase=t}', "");
    Expect(1, 125251, '\P{^Is_Lowercase=t}', "");
    Expect(0, 125252, '\p{Is_Lowercase=t}', "");
    Expect(1, 125252, '\p{^Is_Lowercase=t}', "");
    Expect(1, 125252, '\P{Is_Lowercase=t}', "");
    Expect(0, 125252, '\P{^Is_Lowercase=t}', "");
    Expect(1, 125251, '\p{Is_Lowercase=__T}', "");
    Expect(0, 125251, '\p{^Is_Lowercase=__T}', "");
    Expect(0, 125251, '\P{Is_Lowercase=__T}', "");
    Expect(1, 125251, '\P{^Is_Lowercase=__T}', "");
    Expect(0, 125252, '\p{Is_Lowercase=__T}', "");
    Expect(1, 125252, '\p{^Is_Lowercase=__T}', "");
    Expect(1, 125252, '\P{Is_Lowercase=__T}', "");
    Expect(0, 125252, '\P{^Is_Lowercase=__T}', "");
    Error('\p{Is_Lower=:= _True}');
    Error('\P{Is_Lower=:= _True}');
    Expect(1, 125251, '\p{Is_Lower=true}', "");
    Expect(0, 125251, '\p{^Is_Lower=true}', "");
    Expect(0, 125251, '\P{Is_Lower=true}', "");
    Expect(1, 125251, '\P{^Is_Lower=true}', "");
    Expect(0, 125252, '\p{Is_Lower=true}', "");
    Expect(1, 125252, '\p{^Is_Lower=true}', "");
    Expect(1, 125252, '\P{Is_Lower=true}', "");
    Expect(0, 125252, '\P{^Is_Lower=true}', "");
    Expect(1, 125251, '\p{Is_Lower=	 True}', "");
    Expect(0, 125251, '\p{^Is_Lower=	 True}', "");
    Expect(0, 125251, '\P{Is_Lower=	 True}', "");
    Expect(1, 125251, '\P{^Is_Lower=	 True}', "");
    Expect(0, 125252, '\p{Is_Lower=	 True}', "");
    Expect(1, 125252, '\p{^Is_Lower=	 True}', "");
    Expect(1, 125252, '\P{Is_Lower=	 True}', "");
    Expect(0, 125252, '\P{^Is_Lower=	 True}', "");
    Error('\p{Math: 	NO:=}');
    Error('\P{Math: 	NO:=}');
    Expect(1, 126706, '\p{Math=:\ANo\z:}', "");;
    Expect(0, 126705, '\p{Math=:\ANo\z:}', "");;
    Expect(1, 126706, '\p{Math=no}', "");
    Expect(0, 126706, '\p{^Math=no}', "");
    Expect(0, 126706, '\P{Math=no}', "");
    Expect(1, 126706, '\P{^Math=no}', "");
    Expect(0, 126705, '\p{Math=no}', "");
    Expect(1, 126705, '\p{^Math=no}', "");
    Expect(1, 126705, '\P{Math=no}', "");
    Expect(0, 126705, '\P{^Math=no}', "");
    Expect(1, 126706, '\p{Math=:\Ano\z:}', "");;
    Expect(0, 126705, '\p{Math=:\Ano\z:}', "");;
    Expect(1, 126706, '\p{Math=NO}', "");
    Expect(0, 126706, '\p{^Math=NO}', "");
    Expect(0, 126706, '\P{Math=NO}', "");
    Expect(1, 126706, '\P{^Math=NO}', "");
    Expect(0, 126705, '\p{Math=NO}', "");
    Expect(1, 126705, '\p{^Math=NO}', "");
    Expect(1, 126705, '\P{Math=NO}', "");
    Expect(0, 126705, '\P{^Math=NO}', "");
    Error('\p{Is_Math=:= n}');
    Error('\P{Is_Math=:= n}');
    Expect(1, 126706, '\p{Is_Math=n}', "");
    Expect(0, 126706, '\p{^Is_Math=n}', "");
    Expect(0, 126706, '\P{Is_Math=n}', "");
    Expect(1, 126706, '\P{^Is_Math=n}', "");
    Expect(0, 126705, '\p{Is_Math=n}', "");
    Expect(1, 126705, '\p{^Is_Math=n}', "");
    Expect(1, 126705, '\P{Is_Math=n}', "");
    Expect(0, 126705, '\P{^Is_Math=n}', "");
    Expect(1, 126706, '\p{Is_Math:   _ N}', "");
    Expect(0, 126706, '\p{^Is_Math:   _ N}', "");
    Expect(0, 126706, '\P{Is_Math:   _ N}', "");
    Expect(1, 126706, '\P{^Is_Math:   _ N}', "");
    Expect(0, 126705, '\p{Is_Math:   _ N}', "");
    Expect(1, 126705, '\p{^Is_Math:   _ N}', "");
    Expect(1, 126705, '\P{Is_Math:   _ N}', "");
    Expect(0, 126705, '\P{^Is_Math:   _ N}', "");
    Error('\p{Math=_ F/a/}');
    Error('\P{Math=_ F/a/}');
    Expect(1, 126706, '\p{Math=:\AF\z:}', "");;
    Expect(0, 126705, '\p{Math=:\AF\z:}', "");;
    Expect(1, 126706, '\p{Math=f}', "");
    Expect(0, 126706, '\p{^Math=f}', "");
    Expect(0, 126706, '\P{Math=f}', "");
    Expect(1, 126706, '\P{^Math=f}', "");
    Expect(0, 126705, '\p{Math=f}', "");
    Expect(1, 126705, '\p{^Math=f}', "");
    Expect(1, 126705, '\P{Math=f}', "");
    Expect(0, 126705, '\P{^Math=f}', "");
    Expect(1, 126706, '\p{Math=:\Af\z:}', "");;
    Expect(0, 126705, '\p{Math=:\Af\z:}', "");;
    Expect(1, 126706, '\p{Math=	 F}', "");
    Expect(0, 126706, '\p{^Math=	 F}', "");
    Expect(0, 126706, '\P{Math=	 F}', "");
    Expect(1, 126706, '\P{^Math=	 F}', "");
    Expect(0, 126705, '\p{Math=	 F}', "");
    Expect(1, 126705, '\p{^Math=	 F}', "");
    Expect(1, 126705, '\P{Math=	 F}', "");
    Expect(0, 126705, '\P{^Math=	 F}', "");
    Error('\p{Is_Math=/a/- False}');
    Error('\P{Is_Math=/a/- False}');
    Expect(1, 126706, '\p{Is_Math=false}', "");
    Expect(0, 126706, '\p{^Is_Math=false}', "");
    Expect(0, 126706, '\P{Is_Math=false}', "");
    Expect(1, 126706, '\P{^Is_Math=false}', "");
    Expect(0, 126705, '\p{Is_Math=false}', "");
    Expect(1, 126705, '\p{^Is_Math=false}', "");
    Expect(1, 126705, '\P{Is_Math=false}', "");
    Expect(0, 126705, '\P{^Is_Math=false}', "");
    Expect(1, 126706, '\p{Is_Math=_ false}', "");
    Expect(0, 126706, '\p{^Is_Math=_ false}', "");
    Expect(0, 126706, '\P{Is_Math=_ false}', "");
    Expect(1, 126706, '\P{^Is_Math=_ false}', "");
    Expect(0, 126705, '\p{Is_Math=_ false}', "");
    Expect(1, 126705, '\p{^Is_Math=_ false}', "");
    Expect(1, 126705, '\P{Is_Math=_ false}', "");
    Expect(0, 126705, '\P{^Is_Math=_ false}', "");
    Error('\p{Math=	YES:=}');
    Error('\P{Math=	YES:=}');
    Expect(1, 126705, '\p{Math=:\AYes\z:}', "");;
    Expect(0, 126706, '\p{Math=:\AYes\z:}', "");;
    Expect(1, 126705, '\p{Math:   yes}', "");
    Expect(0, 126705, '\p{^Math:   yes}', "");
    Expect(0, 126705, '\P{Math:   yes}', "");
    Expect(1, 126705, '\P{^Math:   yes}', "");
    Expect(0, 126706, '\p{Math:   yes}', "");
    Expect(1, 126706, '\p{^Math:   yes}', "");
    Expect(1, 126706, '\P{Math:   yes}', "");
    Expect(0, 126706, '\P{^Math:   yes}', "");
    Expect(1, 126705, '\p{Math=:\Ayes\z:}', "");;
    Expect(0, 126706, '\p{Math=:\Ayes\z:}', "");;
    Expect(1, 126705, '\p{Math=		Yes}', "");
    Expect(0, 126705, '\p{^Math=		Yes}', "");
    Expect(0, 126705, '\P{Math=		Yes}', "");
    Expect(1, 126705, '\P{^Math=		Yes}', "");
    Expect(0, 126706, '\p{Math=		Yes}', "");
    Expect(1, 126706, '\p{^Math=		Yes}', "");
    Expect(1, 126706, '\P{Math=		Yes}', "");
    Expect(0, 126706, '\P{^Math=		Yes}', "");
    Error('\p{Is_Math=:= _Y}');
    Error('\P{Is_Math=:= _Y}');
    Expect(1, 126705, '\p{Is_Math=y}', "");
    Expect(0, 126705, '\p{^Is_Math=y}', "");
    Expect(0, 126705, '\P{Is_Math=y}', "");
    Expect(1, 126705, '\P{^Is_Math=y}', "");
    Expect(0, 126706, '\p{Is_Math=y}', "");
    Expect(1, 126706, '\p{^Is_Math=y}', "");
    Expect(1, 126706, '\P{Is_Math=y}', "");
    Expect(0, 126706, '\P{^Is_Math=y}', "");
    Expect(1, 126705, '\p{Is_Math:-Y}', "");
    Expect(0, 126705, '\p{^Is_Math:-Y}', "");
    Expect(0, 126705, '\P{Is_Math:-Y}', "");
    Expect(1, 126705, '\P{^Is_Math:-Y}', "");
    Expect(0, 126706, '\p{Is_Math:-Y}', "");
    Expect(1, 126706, '\p{^Is_Math:-Y}', "");
    Expect(1, 126706, '\P{Is_Math:-Y}', "");
    Expect(0, 126706, '\P{^Is_Math:-Y}', "");
    Error('\p{Math=/a/ t}');
    Error('\P{Math=/a/ t}');
    Expect(1, 126705, '\p{Math=:\AT\z:}', "");;
    Expect(0, 126706, '\p{Math=:\AT\z:}', "");;
    Expect(1, 126705, '\p{Math:   t}', "");
    Expect(0, 126705, '\p{^Math:   t}', "");
    Expect(0, 126705, '\P{Math:   t}', "");
    Expect(1, 126705, '\P{^Math:   t}', "");
    Expect(0, 126706, '\p{Math:   t}', "");
    Expect(1, 126706, '\p{^Math:   t}', "");
    Expect(1, 126706, '\P{Math:   t}', "");
    Expect(0, 126706, '\P{^Math:   t}', "");
    Expect(1, 126705, '\p{Math=:\At\z:}', "");;
    Expect(0, 126706, '\p{Math=:\At\z:}', "");;
    Expect(1, 126705, '\p{Math=		T}', "");
    Expect(0, 126705, '\p{^Math=		T}', "");
    Expect(0, 126705, '\P{Math=		T}', "");
    Expect(1, 126705, '\P{^Math=		T}', "");
    Expect(0, 126706, '\p{Math=		T}', "");
    Expect(1, 126706, '\p{^Math=		T}', "");
    Expect(1, 126706, '\P{Math=		T}', "");
    Expect(0, 126706, '\P{^Math=		T}', "");
    Error('\p{Is_Math=-TRUE:=}');
    Error('\P{Is_Math=-TRUE:=}');
    Expect(1, 126705, '\p{Is_Math=true}', "");
    Expect(0, 126705, '\p{^Is_Math=true}', "");
    Expect(0, 126705, '\P{Is_Math=true}', "");
    Expect(1, 126705, '\P{^Is_Math=true}', "");
    Expect(0, 126706, '\p{Is_Math=true}', "");
    Expect(1, 126706, '\p{^Is_Math=true}', "");
    Expect(1, 126706, '\P{Is_Math=true}', "");
    Expect(0, 126706, '\P{^Is_Math=true}', "");
    Expect(1, 126705, '\p{Is_Math=  True}', "");
    Expect(0, 126705, '\p{^Is_Math=  True}', "");
    Expect(0, 126705, '\P{Is_Math=  True}', "");
    Expect(1, 126705, '\P{^Is_Math=  True}', "");
    Expect(0, 126706, '\p{Is_Math=  True}', "");
    Expect(1, 126706, '\p{^Is_Math=  True}', "");
    Expect(1, 126706, '\P{Is_Math=  True}', "");
    Expect(0, 126706, '\P{^Is_Math=  True}', "");
    Error('\p{name}');
    Error('\P{name}');
    Error('\p{na}');
    Error('\P{na}');
    Error('\p{unicode1name}');
    Error('\P{unicode1name}');
    Error('\p{na1}');
    Error('\P{na1}');
    Error('\p{namealias}');
    Error('\P{namealias}');
    Error('\p{_perlnamealias}');
    Error('\P{_perlnamealias}');
    Error('\p{Noncharacter_Code_Point=/a/	_NO}');
    Error('\P{Noncharacter_Code_Point=/a/	_NO}');
    Expect(1, 1114109, '\p{Noncharacter_Code_Point=:\ANo\z:}', "");;
    Expect(0, 1114111, '\p{Noncharacter_Code_Point=:\ANo\z:}', "");;
    Expect(1, 1114109, '\p{Noncharacter_Code_Point=no}', "");
    Expect(0, 1114109, '\p{^Noncharacter_Code_Point=no}', "");
    Expect(0, 1114109, '\P{Noncharacter_Code_Point=no}', "");
    Expect(1, 1114109, '\P{^Noncharacter_Code_Point=no}', "");
    Expect(0, 1114111, '\p{Noncharacter_Code_Point=no}', "");
    Expect(1, 1114111, '\p{^Noncharacter_Code_Point=no}', "");
    Expect(1, 1114111, '\P{Noncharacter_Code_Point=no}', "");
    Expect(0, 1114111, '\P{^Noncharacter_Code_Point=no}', "");
    Expect(1, 1114109, '\p{Noncharacter_Code_Point=:\Ano\z:}', "");;
    Expect(0, 1114111, '\p{Noncharacter_Code_Point=:\Ano\z:}', "");;
    Expect(1, 1114109, '\p{Noncharacter_Code_Point=_-NO}', "");
    Expect(0, 1114109, '\p{^Noncharacter_Code_Point=_-NO}', "");
    Expect(0, 1114109, '\P{Noncharacter_Code_Point=_-NO}', "");
    Expect(1, 1114109, '\P{^Noncharacter_Code_Point=_-NO}', "");
    Expect(0, 1114111, '\p{Noncharacter_Code_Point=_-NO}', "");
    Expect(1, 1114111, '\p{^Noncharacter_Code_Point=_-NO}', "");
    Expect(1, 1114111, '\P{Noncharacter_Code_Point=_-NO}', "");
    Expect(0, 1114111, '\P{^Noncharacter_Code_Point=_-NO}', "");
    Error('\p{NChar=_/a/N}');
    Error('\P{NChar=_/a/N}');
    Expect(1, 1114109, '\p{NChar=:\AN\z:}', "");;
    Expect(0, 1114111, '\p{NChar=:\AN\z:}', "");;
    Expect(1, 1114109, '\p{NChar:n}', "");
    Expect(0, 1114109, '\p{^NChar:n}', "");
    Expect(0, 1114109, '\P{NChar:n}', "");
    Expect(1, 1114109, '\P{^NChar:n}', "");
    Expect(0, 1114111, '\p{NChar:n}', "");
    Expect(1, 1114111, '\p{^NChar:n}', "");
    Expect(1, 1114111, '\P{NChar:n}', "");
    Expect(0, 1114111, '\P{^NChar:n}', "");
    Expect(1, 1114109, '\p{NChar=:\An\z:}', "");;
    Expect(0, 1114111, '\p{NChar=:\An\z:}', "");;
    Expect(1, 1114109, '\p{NChar=	n}', "");
    Expect(0, 1114109, '\p{^NChar=	n}', "");
    Expect(0, 1114109, '\P{NChar=	n}', "");
    Expect(1, 1114109, '\P{^NChar=	n}', "");
    Expect(0, 1114111, '\p{NChar=	n}', "");
    Expect(1, 1114111, '\p{^NChar=	n}', "");
    Expect(1, 1114111, '\P{NChar=	n}', "");
    Expect(0, 1114111, '\P{^NChar=	n}', "");
    Error('\p{Is_Noncharacter_Code_Point:-/a/f}');
    Error('\P{Is_Noncharacter_Code_Point:-/a/f}');
    Expect(1, 1114109, '\p{Is_Noncharacter_Code_Point=f}', "");
    Expect(0, 1114109, '\p{^Is_Noncharacter_Code_Point=f}', "");
    Expect(0, 1114109, '\P{Is_Noncharacter_Code_Point=f}', "");
    Expect(1, 1114109, '\P{^Is_Noncharacter_Code_Point=f}', "");
    Expect(0, 1114111, '\p{Is_Noncharacter_Code_Point=f}', "");
    Expect(1, 1114111, '\p{^Is_Noncharacter_Code_Point=f}', "");
    Expect(1, 1114111, '\P{Is_Noncharacter_Code_Point=f}', "");
    Expect(0, 1114111, '\P{^Is_Noncharacter_Code_Point=f}', "");
    Expect(1, 1114109, '\p{Is_Noncharacter_Code_Point= -F}', "");
    Expect(0, 1114109, '\p{^Is_Noncharacter_Code_Point= -F}', "");
    Expect(0, 1114109, '\P{Is_Noncharacter_Code_Point= -F}', "");
    Expect(1, 1114109, '\P{^Is_Noncharacter_Code_Point= -F}', "");
    Expect(0, 1114111, '\p{Is_Noncharacter_Code_Point= -F}', "");
    Expect(1, 1114111, '\p{^Is_Noncharacter_Code_Point= -F}', "");
    Expect(1, 1114111, '\P{Is_Noncharacter_Code_Point= -F}', "");
    Expect(0, 1114111, '\P{^Is_Noncharacter_Code_Point= -F}', "");
    Error('\p{Is_NChar=:=-FALSE}');
    Error('\P{Is_NChar=:=-FALSE}');
    Expect(1, 1114109, '\p{Is_NChar=false}', "");
    Expect(0, 1114109, '\p{^Is_NChar=false}', "");
    Expect(0, 1114109, '\P{Is_NChar=false}', "");
    Expect(1, 1114109, '\P{^Is_NChar=false}', "");
    Expect(0, 1114111, '\p{Is_NChar=false}', "");
    Expect(1, 1114111, '\p{^Is_NChar=false}', "");
    Expect(1, 1114111, '\P{Is_NChar=false}', "");
    Expect(0, 1114111, '\P{^Is_NChar=false}', "");
    Expect(1, 1114109, '\p{Is_NChar=	 false}', "");
    Expect(0, 1114109, '\p{^Is_NChar=	 false}', "");
    Expect(0, 1114109, '\P{Is_NChar=	 false}', "");
    Expect(1, 1114109, '\P{^Is_NChar=	 false}', "");
    Expect(0, 1114111, '\p{Is_NChar=	 false}', "");
    Expect(1, 1114111, '\p{^Is_NChar=	 false}', "");
    Expect(1, 1114111, '\P{Is_NChar=	 false}', "");
    Expect(0, 1114111, '\P{^Is_NChar=	 false}', "");
    Error('\p{Noncharacter_Code_Point=:=	-Yes}');
    Error('\P{Noncharacter_Code_Point=:=	-Yes}');
    Expect(1, 1114111, '\p{Noncharacter_Code_Point=:\AYes\z:}', "");;
    Expect(0, 1114109, '\p{Noncharacter_Code_Point=:\AYes\z:}', "");;
    Expect(1, 1114111, '\p{Noncharacter_Code_Point=yes}', "");
    Expect(0, 1114111, '\p{^Noncharacter_Code_Point=yes}', "");
    Expect(0, 1114111, '\P{Noncharacter_Code_Point=yes}', "");
    Expect(1, 1114111, '\P{^Noncharacter_Code_Point=yes}', "");
    Expect(0, 1114109, '\p{Noncharacter_Code_Point=yes}', "");
    Expect(1, 1114109, '\p{^Noncharacter_Code_Point=yes}', "");
    Expect(1, 1114109, '\P{Noncharacter_Code_Point=yes}', "");
    Expect(0, 1114109, '\P{^Noncharacter_Code_Point=yes}', "");
    Expect(1, 1114111, '\p{Noncharacter_Code_Point=:\Ayes\z:}', "");;
    Expect(0, 1114109, '\p{Noncharacter_Code_Point=:\Ayes\z:}', "");;
    Expect(1, 1114111, '\p{Noncharacter_Code_Point= -YES}', "");
    Expect(0, 1114111, '\p{^Noncharacter_Code_Point= -YES}', "");
    Expect(0, 1114111, '\P{Noncharacter_Code_Point= -YES}', "");
    Expect(1, 1114111, '\P{^Noncharacter_Code_Point= -YES}', "");
    Expect(0, 1114109, '\p{Noncharacter_Code_Point= -YES}', "");
    Expect(1, 1114109, '\p{^Noncharacter_Code_Point= -YES}', "");
    Expect(1, 1114109, '\P{Noncharacter_Code_Point= -YES}', "");
    Expect(0, 1114109, '\P{^Noncharacter_Code_Point= -YES}', "");
    Error('\p{NChar=	/a/y}');
    Error('\P{NChar=	/a/y}');
    Expect(1, 1114111, '\p{NChar=:\AY\z:}', "");;
    Expect(0, 1114109, '\p{NChar=:\AY\z:}', "");;
    Expect(1, 1114111, '\p{NChar=y}', "");
    Expect(0, 1114111, '\p{^NChar=y}', "");
    Expect(0, 1114111, '\P{NChar=y}', "");
    Expect(1, 1114111, '\P{^NChar=y}', "");
    Expect(0, 1114109, '\p{NChar=y}', "");
    Expect(1, 1114109, '\p{^NChar=y}', "");
    Expect(1, 1114109, '\P{NChar=y}', "");
    Expect(0, 1114109, '\P{^NChar=y}', "");
    Expect(1, 1114111, '\p{NChar=:\Ay\z:}', "");;
    Expect(0, 1114109, '\p{NChar=:\Ay\z:}', "");;
    Expect(1, 1114111, '\p{NChar=__Y}', "");
    Expect(0, 1114111, '\p{^NChar=__Y}', "");
    Expect(0, 1114111, '\P{NChar=__Y}', "");
    Expect(1, 1114111, '\P{^NChar=__Y}', "");
    Expect(0, 1114109, '\p{NChar=__Y}', "");
    Expect(1, 1114109, '\p{^NChar=__Y}', "");
    Expect(1, 1114109, '\P{NChar=__Y}', "");
    Expect(0, 1114109, '\P{^NChar=__Y}', "");
    Error('\p{Is_Noncharacter_Code_Point=-:=t}');
    Error('\P{Is_Noncharacter_Code_Point=-:=t}');
    Expect(1, 1114111, '\p{Is_Noncharacter_Code_Point=t}', "");
    Expect(0, 1114111, '\p{^Is_Noncharacter_Code_Point=t}', "");
    Expect(0, 1114111, '\P{Is_Noncharacter_Code_Point=t}', "");
    Expect(1, 1114111, '\P{^Is_Noncharacter_Code_Point=t}', "");
    Expect(0, 1114109, '\p{Is_Noncharacter_Code_Point=t}', "");
    Expect(1, 1114109, '\p{^Is_Noncharacter_Code_Point=t}', "");
    Expect(1, 1114109, '\P{Is_Noncharacter_Code_Point=t}', "");
    Expect(0, 1114109, '\P{^Is_Noncharacter_Code_Point=t}', "");
    Expect(1, 1114111, '\p{Is_Noncharacter_Code_Point=		t}', "");
    Expect(0, 1114111, '\p{^Is_Noncharacter_Code_Point=		t}', "");
    Expect(0, 1114111, '\P{Is_Noncharacter_Code_Point=		t}', "");
    Expect(1, 1114111, '\P{^Is_Noncharacter_Code_Point=		t}', "");
    Expect(0, 1114109, '\p{Is_Noncharacter_Code_Point=		t}', "");
    Expect(1, 1114109, '\p{^Is_Noncharacter_Code_Point=		t}', "");
    Expect(1, 1114109, '\P{Is_Noncharacter_Code_Point=		t}', "");
    Expect(0, 1114109, '\P{^Is_Noncharacter_Code_Point=		t}', "");
    Error('\p{Is_NChar=:=	 True}');
    Error('\P{Is_NChar=:=	 True}');
    Expect(1, 1114111, '\p{Is_NChar=true}', "");
    Expect(0, 1114111, '\p{^Is_NChar=true}', "");
    Expect(0, 1114111, '\P{Is_NChar=true}', "");
    Expect(1, 1114111, '\P{^Is_NChar=true}', "");
    Expect(0, 1114109, '\p{Is_NChar=true}', "");
    Expect(1, 1114109, '\p{^Is_NChar=true}', "");
    Expect(1, 1114109, '\P{Is_NChar=true}', "");
    Expect(0, 1114109, '\P{^Is_NChar=true}', "");
    Expect(1, 1114111, '\p{Is_NChar=		True}', "");
    Expect(0, 1114111, '\p{^Is_NChar=		True}', "");
    Expect(0, 1114111, '\P{Is_NChar=		True}', "");
    Expect(1, 1114111, '\P{^Is_NChar=		True}', "");
    Expect(0, 1114109, '\p{Is_NChar=		True}', "");
    Expect(1, 1114109, '\p{^Is_NChar=		True}', "");
    Expect(1, 1114109, '\P{Is_NChar=		True}', "");
    Expect(0, 1114109, '\P{^Is_NChar=		True}', "");
    Error('\p{nfcquickcheck}');
    Error('\P{nfcquickcheck}');
    Error('\p{nfcqc}');
    Error('\P{nfcqc}');
    Error('\p{NFC_Quick_Check=:=__Maybe}');
    Error('\P{NFC_Quick_Check=:=__Maybe}');
    Expect(1, 71984, '\p{NFC_Quick_Check=:\AMaybe\z:}', "");;
    Expect(0, 71985, '\p{NFC_Quick_Check=:\AMaybe\z:}', "");;
    Expect(1, 71984, '\p{NFC_Quick_Check=maybe}', "");
    Expect(0, 71984, '\p{^NFC_Quick_Check=maybe}', "");
    Expect(0, 71984, '\P{NFC_Quick_Check=maybe}', "");
    Expect(1, 71984, '\P{^NFC_Quick_Check=maybe}', "");
    Expect(0, 71985, '\p{NFC_Quick_Check=maybe}', "");
    Expect(1, 71985, '\p{^NFC_Quick_Check=maybe}', "");
    Expect(1, 71985, '\P{NFC_Quick_Check=maybe}', "");
    Expect(0, 71985, '\P{^NFC_Quick_Check=maybe}', "");
    Expect(1, 71984, '\p{NFC_Quick_Check=:\Amaybe\z:}', "");;
    Expect(0, 71985, '\p{NFC_Quick_Check=:\Amaybe\z:}', "");;
    Expect(1, 71984, '\p{NFC_Quick_Check:	-	Maybe}', "");
    Expect(0, 71984, '\p{^NFC_Quick_Check:	-	Maybe}', "");
    Expect(0, 71984, '\P{NFC_Quick_Check:	-	Maybe}', "");
    Expect(1, 71984, '\P{^NFC_Quick_Check:	-	Maybe}', "");
    Expect(0, 71985, '\p{NFC_Quick_Check:	-	Maybe}', "");
    Expect(1, 71985, '\p{^NFC_Quick_Check:	-	Maybe}', "");
    Expect(1, 71985, '\P{NFC_Quick_Check:	-	Maybe}', "");
    Expect(0, 71985, '\P{^NFC_Quick_Check:	-	Maybe}', "");
    Error('\p{NFC_QC:   /a/m}');
    Error('\P{NFC_QC:   /a/m}');
    Expect(1, 71984, '\p{NFC_QC=:\AM\z:}', "");;
    Expect(0, 71985, '\p{NFC_QC=:\AM\z:}', "");;
    Expect(1, 71984, '\p{NFC_QC=m}', "");
    Expect(0, 71984, '\p{^NFC_QC=m}', "");
    Expect(0, 71984, '\P{NFC_QC=m}', "");
    Expect(1, 71984, '\P{^NFC_QC=m}', "");
    Expect(0, 71985, '\p{NFC_QC=m}', "");
    Expect(1, 71985, '\p{^NFC_QC=m}', "");
    Expect(1, 71985, '\P{NFC_QC=m}', "");
    Expect(0, 71985, '\P{^NFC_QC=m}', "");
    Expect(1, 71984, '\p{NFC_QC=:\Am\z:}', "");;
    Expect(0, 71985, '\p{NFC_QC=:\Am\z:}', "");;
    Expect(1, 71984, '\p{NFC_QC:	-M}', "");
    Expect(0, 71984, '\p{^NFC_QC:	-M}', "");
    Expect(0, 71984, '\P{NFC_QC:	-M}', "");
    Expect(1, 71984, '\P{^NFC_QC:	-M}', "");
    Expect(0, 71985, '\p{NFC_QC:	-M}', "");
    Expect(1, 71985, '\p{^NFC_QC:	-M}', "");
    Expect(1, 71985, '\P{NFC_QC:	-M}', "");
    Expect(0, 71985, '\P{^NFC_QC:	-M}', "");
    Error('\p{Is_NFC_Quick_Check= :=maybe}');
    Error('\P{Is_NFC_Quick_Check= :=maybe}');
    Expect(1, 71984, '\p{Is_NFC_Quick_Check=maybe}', "");
    Expect(0, 71984, '\p{^Is_NFC_Quick_Check=maybe}', "");
    Expect(0, 71984, '\P{Is_NFC_Quick_Check=maybe}', "");
    Expect(1, 71984, '\P{^Is_NFC_Quick_Check=maybe}', "");
    Expect(0, 71985, '\p{Is_NFC_Quick_Check=maybe}', "");
    Expect(1, 71985, '\p{^Is_NFC_Quick_Check=maybe}', "");
    Expect(1, 71985, '\P{Is_NFC_Quick_Check=maybe}', "");
    Expect(0, 71985, '\P{^Is_NFC_Quick_Check=maybe}', "");
    Expect(1, 71984, '\p{Is_NFC_Quick_Check=--Maybe}', "");
    Expect(0, 71984, '\p{^Is_NFC_Quick_Check=--Maybe}', "");
    Expect(0, 71984, '\P{Is_NFC_Quick_Check=--Maybe}', "");
    Expect(1, 71984, '\P{^Is_NFC_Quick_Check=--Maybe}', "");
    Expect(0, 71985, '\p{Is_NFC_Quick_Check=--Maybe}', "");
    Expect(1, 71985, '\p{^Is_NFC_Quick_Check=--Maybe}', "");
    Expect(1, 71985, '\P{Is_NFC_Quick_Check=--Maybe}', "");
    Expect(0, 71985, '\P{^Is_NFC_Quick_Check=--Maybe}', "");
    Error('\p{Is_NFC_QC=_	M:=}');
    Error('\P{Is_NFC_QC=_	M:=}');
    Expect(1, 71984, '\p{Is_NFC_QC=m}', "");
    Expect(0, 71984, '\p{^Is_NFC_QC=m}', "");
    Expect(0, 71984, '\P{Is_NFC_QC=m}', "");
    Expect(1, 71984, '\P{^Is_NFC_QC=m}', "");
    Expect(0, 71985, '\p{Is_NFC_QC=m}', "");
    Expect(1, 71985, '\p{^Is_NFC_QC=m}', "");
    Expect(1, 71985, '\P{Is_NFC_QC=m}', "");
    Expect(0, 71985, '\P{^Is_NFC_QC=m}', "");
    Expect(1, 71984, '\p{Is_NFC_QC=-_m}', "");
    Expect(0, 71984, '\p{^Is_NFC_QC=-_m}', "");
    Expect(0, 71984, '\P{Is_NFC_QC=-_m}', "");
    Expect(1, 71984, '\P{^Is_NFC_QC=-_m}', "");
    Expect(0, 71985, '\p{Is_NFC_QC=-_m}', "");
    Expect(1, 71985, '\p{^Is_NFC_QC=-_m}', "");
    Expect(1, 71985, '\P{Is_NFC_QC=-_m}', "");
    Expect(0, 71985, '\P{^Is_NFC_QC=-_m}', "");
    Error('\p{NFC_Quick_Check:  No:=}');
    Error('\P{NFC_Quick_Check:  No:=}');
    Expect(1, 195101, '\p{NFC_Quick_Check=:\ANo\z:}', "");;
    Expect(0, 195102, '\p{NFC_Quick_Check=:\ANo\z:}', "");;
    Expect(1, 195101, '\p{NFC_Quick_Check=no}', "");
    Expect(0, 195101, '\p{^NFC_Quick_Check=no}', "");
    Expect(0, 195101, '\P{NFC_Quick_Check=no}', "");
    Expect(1, 195101, '\P{^NFC_Quick_Check=no}', "");
    Expect(0, 195102, '\p{NFC_Quick_Check=no}', "");
    Expect(1, 195102, '\p{^NFC_Quick_Check=no}', "");
    Expect(1, 195102, '\P{NFC_Quick_Check=no}', "");
    Expect(0, 195102, '\P{^NFC_Quick_Check=no}', "");
    Expect(1, 195101, '\p{NFC_Quick_Check=:\Ano\z:}', "");;
    Expect(0, 195102, '\p{NFC_Quick_Check=:\Ano\z:}', "");;
    Expect(1, 195101, '\p{NFC_Quick_Check=	 no}', "");
    Expect(0, 195101, '\p{^NFC_Quick_Check=	 no}', "");
    Expect(0, 195101, '\P{NFC_Quick_Check=	 no}', "");
    Expect(1, 195101, '\P{^NFC_Quick_Check=	 no}', "");
    Expect(0, 195102, '\p{NFC_Quick_Check=	 no}', "");
    Expect(1, 195102, '\p{^NFC_Quick_Check=	 no}', "");
    Expect(1, 195102, '\P{NFC_Quick_Check=	 no}', "");
    Expect(0, 195102, '\P{^NFC_Quick_Check=	 no}', "");
    Error('\p{NFC_QC=/a/-	N}');
    Error('\P{NFC_QC=/a/-	N}');
    Expect(1, 195101, '\p{NFC_QC=:\AN\z:}', "");;
    Expect(0, 195102, '\p{NFC_QC=:\AN\z:}', "");;
    Expect(1, 195101, '\p{NFC_QC=n}', "");
    Expect(0, 195101, '\p{^NFC_QC=n}', "");
    Expect(0, 195101, '\P{NFC_QC=n}', "");
    Expect(1, 195101, '\P{^NFC_QC=n}', "");
    Expect(0, 195102, '\p{NFC_QC=n}', "");
    Expect(1, 195102, '\p{^NFC_QC=n}', "");
    Expect(1, 195102, '\P{NFC_QC=n}', "");
    Expect(0, 195102, '\P{^NFC_QC=n}', "");
    Expect(1, 195101, '\p{NFC_QC=:\An\z:}', "");;
    Expect(0, 195102, '\p{NFC_QC=:\An\z:}', "");;
    Expect(1, 195101, '\p{NFC_QC=--N}', "");
    Expect(0, 195101, '\p{^NFC_QC=--N}', "");
    Expect(0, 195101, '\P{NFC_QC=--N}', "");
    Expect(1, 195101, '\P{^NFC_QC=--N}', "");
    Expect(0, 195102, '\p{NFC_QC=--N}', "");
    Expect(1, 195102, '\p{^NFC_QC=--N}', "");
    Expect(1, 195102, '\P{NFC_QC=--N}', "");
    Expect(0, 195102, '\P{^NFC_QC=--N}', "");
    Error('\p{Is_NFC_Quick_Check=_-no/a/}');
    Error('\P{Is_NFC_Quick_Check=_-no/a/}');
    Expect(1, 195101, '\p{Is_NFC_Quick_Check=no}', "");
    Expect(0, 195101, '\p{^Is_NFC_Quick_Check=no}', "");
    Expect(0, 195101, '\P{Is_NFC_Quick_Check=no}', "");
    Expect(1, 195101, '\P{^Is_NFC_Quick_Check=no}', "");
    Expect(0, 195102, '\p{Is_NFC_Quick_Check=no}', "");
    Expect(1, 195102, '\p{^Is_NFC_Quick_Check=no}', "");
    Expect(1, 195102, '\P{Is_NFC_Quick_Check=no}', "");
    Expect(0, 195102, '\P{^Is_NFC_Quick_Check=no}', "");
    Expect(1, 195101, '\p{Is_NFC_Quick_Check=	 NO}', "");
    Expect(0, 195101, '\p{^Is_NFC_Quick_Check=	 NO}', "");
    Expect(0, 195101, '\P{Is_NFC_Quick_Check=	 NO}', "");
    Expect(1, 195101, '\P{^Is_NFC_Quick_Check=	 NO}', "");
    Expect(0, 195102, '\p{Is_NFC_Quick_Check=	 NO}', "");
    Expect(1, 195102, '\p{^Is_NFC_Quick_Check=	 NO}', "");
    Expect(1, 195102, '\P{Is_NFC_Quick_Check=	 NO}', "");
    Expect(0, 195102, '\P{^Is_NFC_Quick_Check=	 NO}', "");
    Error('\p{Is_NFC_QC= :=n}');
    Error('\P{Is_NFC_QC= :=n}');
    Expect(1, 195101, '\p{Is_NFC_QC=n}', "");
    Expect(0, 195101, '\p{^Is_NFC_QC=n}', "");
    Expect(0, 195101, '\P{Is_NFC_QC=n}', "");
    Expect(1, 195101, '\P{^Is_NFC_QC=n}', "");
    Expect(0, 195102, '\p{Is_NFC_QC=n}', "");
    Expect(1, 195102, '\p{^Is_NFC_QC=n}', "");
    Expect(1, 195102, '\P{Is_NFC_QC=n}', "");
    Expect(0, 195102, '\P{^Is_NFC_QC=n}', "");
    Expect(1, 195101, '\p{Is_NFC_QC=		N}', "");
    Expect(0, 195101, '\p{^Is_NFC_QC=		N}', "");
    Expect(0, 195101, '\P{Is_NFC_QC=		N}', "");
    Expect(1, 195101, '\P{^Is_NFC_QC=		N}', "");
    Expect(0, 195102, '\p{Is_NFC_QC=		N}', "");
    Expect(1, 195102, '\p{^Is_NFC_QC=		N}', "");
    Expect(1, 195102, '\P{Is_NFC_QC=		N}', "");
    Expect(0, 195102, '\P{^Is_NFC_QC=		N}', "");
    Error('\p{NFC_Quick_Check= :=Yes}');
    Error('\P{NFC_Quick_Check= :=Yes}');
    Expect(1, 195102, '\p{NFC_Quick_Check=:\AYes\z:}', "");;
    Expect(0, 195101, '\p{NFC_Quick_Check=:\AYes\z:}', "");;
    Expect(1, 195102, '\p{NFC_Quick_Check=yes}', "");
    Expect(0, 195102, '\p{^NFC_Quick_Check=yes}', "");
    Expect(0, 195102, '\P{NFC_Quick_Check=yes}', "");
    Expect(1, 195102, '\P{^NFC_Quick_Check=yes}', "");
    Expect(0, 195101, '\p{NFC_Quick_Check=yes}', "");
    Expect(1, 195101, '\p{^NFC_Quick_Check=yes}', "");
    Expect(1, 195101, '\P{NFC_Quick_Check=yes}', "");
    Expect(0, 195101, '\P{^NFC_Quick_Check=yes}', "");
    Expect(1, 195102, '\p{NFC_Quick_Check=:\Ayes\z:}', "");;
    Expect(0, 195101, '\p{NFC_Quick_Check=:\Ayes\z:}', "");;
    Expect(1, 195102, '\p{NFC_Quick_Check= 	YES}', "");
    Expect(0, 195102, '\p{^NFC_Quick_Check= 	YES}', "");
    Expect(0, 195102, '\P{NFC_Quick_Check= 	YES}', "");
    Expect(1, 195102, '\P{^NFC_Quick_Check= 	YES}', "");
    Expect(0, 195101, '\p{NFC_Quick_Check= 	YES}', "");
    Expect(1, 195101, '\p{^NFC_Quick_Check= 	YES}', "");
    Expect(1, 195101, '\P{NFC_Quick_Check= 	YES}', "");
    Expect(0, 195101, '\P{^NFC_Quick_Check= 	YES}', "");
    Error('\p{NFC_QC=	_Y/a/}');
    Error('\P{NFC_QC=	_Y/a/}');
    Expect(1, 195102, '\p{NFC_QC=:\AY\z:}', "");;
    Expect(0, 195101, '\p{NFC_QC=:\AY\z:}', "");;
    Expect(1, 195102, '\p{NFC_QC=y}', "");
    Expect(0, 195102, '\p{^NFC_QC=y}', "");
    Expect(0, 195102, '\P{NFC_QC=y}', "");
    Expect(1, 195102, '\P{^NFC_QC=y}', "");
    Expect(0, 195101, '\p{NFC_QC=y}', "");
    Expect(1, 195101, '\p{^NFC_QC=y}', "");
    Expect(1, 195101, '\P{NFC_QC=y}', "");
    Expect(0, 195101, '\P{^NFC_QC=y}', "");
    Expect(1, 195102, '\p{NFC_QC=:\Ay\z:}', "");;
    Expect(0, 195101, '\p{NFC_QC=:\Ay\z:}', "");;
    Expect(1, 195102, '\p{NFC_QC:__y}', "");
    Expect(0, 195102, '\p{^NFC_QC:__y}', "");
    Expect(0, 195102, '\P{NFC_QC:__y}', "");
    Expect(1, 195102, '\P{^NFC_QC:__y}', "");
    Expect(0, 195101, '\p{NFC_QC:__y}', "");
    Expect(1, 195101, '\p{^NFC_QC:__y}', "");
    Expect(1, 195101, '\P{NFC_QC:__y}', "");
    Expect(0, 195101, '\P{^NFC_QC:__y}', "");
    Error('\p{Is_NFC_Quick_Check=_:=Yes}');
    Error('\P{Is_NFC_Quick_Check=_:=Yes}');
    Expect(1, 195102, '\p{Is_NFC_Quick_Check=yes}', "");
    Expect(0, 195102, '\p{^Is_NFC_Quick_Check=yes}', "");
    Expect(0, 195102, '\P{Is_NFC_Quick_Check=yes}', "");
    Expect(1, 195102, '\P{^Is_NFC_Quick_Check=yes}', "");
    Expect(0, 195101, '\p{Is_NFC_Quick_Check=yes}', "");
    Expect(1, 195101, '\p{^Is_NFC_Quick_Check=yes}', "");
    Expect(1, 195101, '\P{Is_NFC_Quick_Check=yes}', "");
    Expect(0, 195101, '\P{^Is_NFC_Quick_Check=yes}', "");
    Expect(1, 195102, '\p{Is_NFC_Quick_Check= -Yes}', "");
    Expect(0, 195102, '\p{^Is_NFC_Quick_Check= -Yes}', "");
    Expect(0, 195102, '\P{Is_NFC_Quick_Check= -Yes}', "");
    Expect(1, 195102, '\P{^Is_NFC_Quick_Check= -Yes}', "");
    Expect(0, 195101, '\p{Is_NFC_Quick_Check= -Yes}', "");
    Expect(1, 195101, '\p{^Is_NFC_Quick_Check= -Yes}', "");
    Expect(1, 195101, '\P{Is_NFC_Quick_Check= -Yes}', "");
    Expect(0, 195101, '\P{^Is_NFC_Quick_Check= -Yes}', "");
    Error('\p{Is_NFC_QC= _y/a/}');
    Error('\P{Is_NFC_QC= _y/a/}');
    Expect(1, 195102, '\p{Is_NFC_QC=y}', "");
    Expect(0, 195102, '\p{^Is_NFC_QC=y}', "");
    Expect(0, 195102, '\P{Is_NFC_QC=y}', "");
    Expect(1, 195102, '\P{^Is_NFC_QC=y}', "");
    Expect(0, 195101, '\p{Is_NFC_QC=y}', "");
    Expect(1, 195101, '\p{^Is_NFC_QC=y}', "");
    Expect(1, 195101, '\P{Is_NFC_QC=y}', "");
    Expect(0, 195101, '\P{^Is_NFC_QC=y}', "");
    Expect(1, 195102, '\p{Is_NFC_QC=  y}', "");
    Expect(0, 195102, '\p{^Is_NFC_QC=  y}', "");
    Expect(0, 195102, '\P{Is_NFC_QC=  y}', "");
    Expect(1, 195102, '\P{^Is_NFC_QC=  y}', "");
    Expect(0, 195101, '\p{Is_NFC_QC=  y}', "");
    Expect(1, 195101, '\p{^Is_NFC_QC=  y}', "");
    Expect(1, 195101, '\P{Is_NFC_QC=  y}', "");
    Expect(0, 195101, '\P{^Is_NFC_QC=  y}', "");
    Error('\p{nfdquickcheck}');
    Error('\P{nfdquickcheck}');
    Error('\p{nfdqc}');
    Error('\P{nfdqc}');
    Error('\p{NFD_Quick_Check=-:=No}');
    Error('\P{NFD_Quick_Check=-:=No}');
    Expect(1, 195101, '\p{NFD_Quick_Check=:\ANo\z:}', "");;
    Expect(0, 195102, '\p{NFD_Quick_Check=:\ANo\z:}', "");;
    Expect(1, 195101, '\p{NFD_Quick_Check=no}', "");
    Expect(0, 195101, '\p{^NFD_Quick_Check=no}', "");
    Expect(0, 195101, '\P{NFD_Quick_Check=no}', "");
    Expect(1, 195101, '\P{^NFD_Quick_Check=no}', "");
    Expect(0, 195102, '\p{NFD_Quick_Check=no}', "");
    Expect(1, 195102, '\p{^NFD_Quick_Check=no}', "");
    Expect(1, 195102, '\P{NFD_Quick_Check=no}', "");
    Expect(0, 195102, '\P{^NFD_Quick_Check=no}', "");
    Expect(1, 195101, '\p{NFD_Quick_Check=:\Ano\z:}', "");;
    Expect(0, 195102, '\p{NFD_Quick_Check=:\Ano\z:}', "");;
    Expect(1, 195101, '\p{NFD_Quick_Check= 	No}', "");
    Expect(0, 195101, '\p{^NFD_Quick_Check= 	No}', "");
    Expect(0, 195101, '\P{NFD_Quick_Check= 	No}', "");
    Expect(1, 195101, '\P{^NFD_Quick_Check= 	No}', "");
    Expect(0, 195102, '\p{NFD_Quick_Check= 	No}', "");
    Expect(1, 195102, '\p{^NFD_Quick_Check= 	No}', "");
    Expect(1, 195102, '\P{NFD_Quick_Check= 	No}', "");
    Expect(0, 195102, '\P{^NFD_Quick_Check= 	No}', "");
    Error('\p{NFD_QC=:=N}');
    Error('\P{NFD_QC=:=N}');
    Expect(1, 195101, '\p{NFD_QC=:\AN\z:}', "");;
    Expect(0, 195102, '\p{NFD_QC=:\AN\z:}', "");;
    Expect(1, 195101, '\p{NFD_QC=n}', "");
    Expect(0, 195101, '\p{^NFD_QC=n}', "");
    Expect(0, 195101, '\P{NFD_QC=n}', "");
    Expect(1, 195101, '\P{^NFD_QC=n}', "");
    Expect(0, 195102, '\p{NFD_QC=n}', "");
    Expect(1, 195102, '\p{^NFD_QC=n}', "");
    Expect(1, 195102, '\P{NFD_QC=n}', "");
    Expect(0, 195102, '\P{^NFD_QC=n}', "");
    Expect(1, 195101, '\p{NFD_QC=:\An\z:}', "");;
    Expect(0, 195102, '\p{NFD_QC=:\An\z:}', "");;
    Expect(1, 195101, '\p{NFD_QC=_	n}', "");
    Expect(0, 195101, '\p{^NFD_QC=_	n}', "");
    Expect(0, 195101, '\P{NFD_QC=_	n}', "");
    Expect(1, 195101, '\P{^NFD_QC=_	n}', "");
    Expect(0, 195102, '\p{NFD_QC=_	n}', "");
    Expect(1, 195102, '\p{^NFD_QC=_	n}', "");
    Expect(1, 195102, '\P{NFD_QC=_	n}', "");
    Expect(0, 195102, '\P{^NFD_QC=_	n}', "");
    Error('\p{Is_NFD_Quick_Check=-:=No}');
    Error('\P{Is_NFD_Quick_Check=-:=No}');
    Expect(1, 195101, '\p{Is_NFD_Quick_Check=no}', "");
    Expect(0, 195101, '\p{^Is_NFD_Quick_Check=no}', "");
    Expect(0, 195101, '\P{Is_NFD_Quick_Check=no}', "");
    Expect(1, 195101, '\P{^Is_NFD_Quick_Check=no}', "");
    Expect(0, 195102, '\p{Is_NFD_Quick_Check=no}', "");
    Expect(1, 195102, '\p{^Is_NFD_Quick_Check=no}', "");
    Expect(1, 195102, '\P{Is_NFD_Quick_Check=no}', "");
    Expect(0, 195102, '\P{^Is_NFD_Quick_Check=no}', "");
    Expect(1, 195101, '\p{Is_NFD_Quick_Check=-_No}', "");
    Expect(0, 195101, '\p{^Is_NFD_Quick_Check=-_No}', "");
    Expect(0, 195101, '\P{Is_NFD_Quick_Check=-_No}', "");
    Expect(1, 195101, '\P{^Is_NFD_Quick_Check=-_No}', "");
    Expect(0, 195102, '\p{Is_NFD_Quick_Check=-_No}', "");
    Expect(1, 195102, '\p{^Is_NFD_Quick_Check=-_No}', "");
    Expect(1, 195102, '\P{Is_NFD_Quick_Check=-_No}', "");
    Expect(0, 195102, '\P{^Is_NFD_Quick_Check=-_No}', "");
    Error('\p{Is_NFD_QC=:=_ n}');
    Error('\P{Is_NFD_QC=:=_ n}');
    Expect(1, 195101, '\p{Is_NFD_QC=n}', "");
    Expect(0, 195101, '\p{^Is_NFD_QC=n}', "");
    Expect(0, 195101, '\P{Is_NFD_QC=n}', "");
    Expect(1, 195101, '\P{^Is_NFD_QC=n}', "");
    Expect(0, 195102, '\p{Is_NFD_QC=n}', "");
    Expect(1, 195102, '\p{^Is_NFD_QC=n}', "");
    Expect(1, 195102, '\P{Is_NFD_QC=n}', "");
    Expect(0, 195102, '\P{^Is_NFD_QC=n}', "");
    Expect(1, 195101, '\p{Is_NFD_QC=	N}', "");
    Expect(0, 195101, '\p{^Is_NFD_QC=	N}', "");
    Expect(0, 195101, '\P{Is_NFD_QC=	N}', "");
    Expect(1, 195101, '\P{^Is_NFD_QC=	N}', "");
    Expect(0, 195102, '\p{Is_NFD_QC=	N}', "");
    Expect(1, 195102, '\p{^Is_NFD_QC=	N}', "");
    Expect(1, 195102, '\P{Is_NFD_QC=	N}', "");
    Expect(0, 195102, '\P{^Is_NFD_QC=	N}', "");
    Error('\p{NFD_Quick_Check=/a/ -YES}');
    Error('\P{NFD_Quick_Check=/a/ -YES}');
    Expect(1, 195102, '\p{NFD_Quick_Check=:\AYes\z:}', "");;
    Expect(0, 195101, '\p{NFD_Quick_Check=:\AYes\z:}', "");;
    Expect(1, 195102, '\p{NFD_Quick_Check=yes}', "");
    Expect(0, 195102, '\p{^NFD_Quick_Check=yes}', "");
    Expect(0, 195102, '\P{NFD_Quick_Check=yes}', "");
    Expect(1, 195102, '\P{^NFD_Quick_Check=yes}', "");
    Expect(0, 195101, '\p{NFD_Quick_Check=yes}', "");
    Expect(1, 195101, '\p{^NFD_Quick_Check=yes}', "");
    Expect(1, 195101, '\P{NFD_Quick_Check=yes}', "");
    Expect(0, 195101, '\P{^NFD_Quick_Check=yes}', "");
    Expect(1, 195102, '\p{NFD_Quick_Check=:\Ayes\z:}', "");;
    Expect(0, 195101, '\p{NFD_Quick_Check=:\Ayes\z:}', "");;
    Expect(1, 195102, '\p{NFD_Quick_Check=_Yes}', "");
    Expect(0, 195102, '\p{^NFD_Quick_Check=_Yes}', "");
    Expect(0, 195102, '\P{NFD_Quick_Check=_Yes}', "");
    Expect(1, 195102, '\P{^NFD_Quick_Check=_Yes}', "");
    Expect(0, 195101, '\p{NFD_Quick_Check=_Yes}', "");
    Expect(1, 195101, '\p{^NFD_Quick_Check=_Yes}', "");
    Expect(1, 195101, '\P{NFD_Quick_Check=_Yes}', "");
    Expect(0, 195101, '\P{^NFD_Quick_Check=_Yes}', "");
    Error('\p{NFD_QC:	-Y:=}');
    Error('\P{NFD_QC:	-Y:=}');
    Expect(1, 195102, '\p{NFD_QC=:\AY\z:}', "");;
    Expect(0, 195101, '\p{NFD_QC=:\AY\z:}', "");;
    Expect(1, 195102, '\p{NFD_QC=y}', "");
    Expect(0, 195102, '\p{^NFD_QC=y}', "");
    Expect(0, 195102, '\P{NFD_QC=y}', "");
    Expect(1, 195102, '\P{^NFD_QC=y}', "");
    Expect(0, 195101, '\p{NFD_QC=y}', "");
    Expect(1, 195101, '\p{^NFD_QC=y}', "");
    Expect(1, 195101, '\P{NFD_QC=y}', "");
    Expect(0, 195101, '\P{^NFD_QC=y}', "");
    Expect(1, 195102, '\p{NFD_QC=:\Ay\z:}', "");;
    Expect(0, 195101, '\p{NFD_QC=:\Ay\z:}', "");;
    Error('\p{Is_NFD_Quick_Check=	Yes/a/}');
    Error('\P{Is_NFD_Quick_Check=	Yes/a/}');
    Expect(1, 195102, '\p{Is_NFD_Quick_Check=yes}', "");
    Expect(0, 195102, '\p{^Is_NFD_Quick_Check=yes}', "");
    Expect(0, 195102, '\P{Is_NFD_Quick_Check=yes}', "");
    Expect(1, 195102, '\P{^Is_NFD_Quick_Check=yes}', "");
    Expect(0, 195101, '\p{Is_NFD_Quick_Check=yes}', "");
    Expect(1, 195101, '\p{^Is_NFD_Quick_Check=yes}', "");
    Expect(1, 195101, '\P{Is_NFD_Quick_Check=yes}', "");
    Expect(0, 195101, '\P{^Is_NFD_Quick_Check=yes}', "");
    Expect(1, 195102, '\p{Is_NFD_Quick_Check=	_yes}', "");
    Expect(0, 195102, '\p{^Is_NFD_Quick_Check=	_yes}', "");
    Expect(0, 195102, '\P{Is_NFD_Quick_Check=	_yes}', "");
    Expect(1, 195102, '\P{^Is_NFD_Quick_Check=	_yes}', "");
    Expect(0, 195101, '\p{Is_NFD_Quick_Check=	_yes}', "");
    Expect(1, 195101, '\p{^Is_NFD_Quick_Check=	_yes}', "");
    Expect(1, 195101, '\P{Is_NFD_Quick_Check=	_yes}', "");
    Expect(0, 195101, '\P{^Is_NFD_Quick_Check=	_yes}', "");
    Error('\p{Is_NFD_QC= 	Y:=}');
    Error('\P{Is_NFD_QC= 	Y:=}');
    Expect(1, 195102, '\p{Is_NFD_QC=y}', "");
    Expect(0, 195102, '\p{^Is_NFD_QC=y}', "");
    Expect(0, 195102, '\P{Is_NFD_QC=y}', "");
    Expect(1, 195102, '\P{^Is_NFD_QC=y}', "");
    Expect(0, 195101, '\p{Is_NFD_QC=y}', "");
    Expect(1, 195101, '\p{^Is_NFD_QC=y}', "");
    Expect(1, 195101, '\P{Is_NFD_QC=y}', "");
    Expect(0, 195101, '\P{^Is_NFD_QC=y}', "");
    Expect(1, 195102, '\p{Is_NFD_QC=- Y}', "");
    Expect(0, 195102, '\p{^Is_NFD_QC=- Y}', "");
    Expect(0, 195102, '\P{Is_NFD_QC=- Y}', "");
    Expect(1, 195102, '\P{^Is_NFD_QC=- Y}', "");
    Expect(0, 195101, '\p{Is_NFD_QC=- Y}', "");
    Expect(1, 195101, '\p{^Is_NFD_QC=- Y}', "");
    Expect(1, 195101, '\P{Is_NFD_QC=- Y}', "");
    Expect(0, 195101, '\P{^Is_NFD_QC=- Y}', "");
    Error('\p{nfkccasefold}');
    Error('\P{nfkccasefold}');
    Error('\p{nfkccf}');
    Error('\P{nfkccf}');
    Error('\p{nfkcquickcheck}');
    Error('\P{nfkcquickcheck}');
    Error('\p{nfkcqc}');
    Error('\P{nfkcqc}');
    Error('\p{NFKC_Quick_Check=/a/-_Maybe}');
    Error('\P{NFKC_Quick_Check=/a/-_Maybe}');
    Expect(1, 71984, '\p{NFKC_Quick_Check=:\AMaybe\z:}', "");;
    Expect(0, 71985, '\p{NFKC_Quick_Check=:\AMaybe\z:}', "");;
    Expect(1, 71984, '\p{NFKC_Quick_Check:	maybe}', "");
    Expect(0, 71984, '\p{^NFKC_Quick_Check:	maybe}', "");
    Expect(0, 71984, '\P{NFKC_Quick_Check:	maybe}', "");
    Expect(1, 71984, '\P{^NFKC_Quick_Check:	maybe}', "");
    Expect(0, 71985, '\p{NFKC_Quick_Check:	maybe}', "");
    Expect(1, 71985, '\p{^NFKC_Quick_Check:	maybe}', "");
    Expect(1, 71985, '\P{NFKC_Quick_Check:	maybe}', "");
    Expect(0, 71985, '\P{^NFKC_Quick_Check:	maybe}', "");
    Expect(1, 71984, '\p{NFKC_Quick_Check=:\Amaybe\z:}', "");;
    Expect(0, 71985, '\p{NFKC_Quick_Check=:\Amaybe\z:}', "");;
    Expect(1, 71984, '\p{NFKC_Quick_Check:   _MAYBE}', "");
    Expect(0, 71984, '\p{^NFKC_Quick_Check:   _MAYBE}', "");
    Expect(0, 71984, '\P{NFKC_Quick_Check:   _MAYBE}', "");
    Expect(1, 71984, '\P{^NFKC_Quick_Check:   _MAYBE}', "");
    Expect(0, 71985, '\p{NFKC_Quick_Check:   _MAYBE}', "");
    Expect(1, 71985, '\p{^NFKC_Quick_Check:   _MAYBE}', "");
    Expect(1, 71985, '\P{NFKC_Quick_Check:   _MAYBE}', "");
    Expect(0, 71985, '\P{^NFKC_Quick_Check:   _MAYBE}', "");
    Error('\p{NFKC_QC=/a/M}');
    Error('\P{NFKC_QC=/a/M}');
    Expect(1, 71984, '\p{NFKC_QC=:\AM\z:}', "");;
    Expect(0, 71985, '\p{NFKC_QC=:\AM\z:}', "");;
    Expect(1, 71984, '\p{NFKC_QC=m}', "");
    Expect(0, 71984, '\p{^NFKC_QC=m}', "");
    Expect(0, 71984, '\P{NFKC_QC=m}', "");
    Expect(1, 71984, '\P{^NFKC_QC=m}', "");
    Expect(0, 71985, '\p{NFKC_QC=m}', "");
    Expect(1, 71985, '\p{^NFKC_QC=m}', "");
    Expect(1, 71985, '\P{NFKC_QC=m}', "");
    Expect(0, 71985, '\P{^NFKC_QC=m}', "");
    Expect(1, 71984, '\p{NFKC_QC=:\Am\z:}', "");;
    Expect(0, 71985, '\p{NFKC_QC=:\Am\z:}', "");;
    Expect(1, 71984, '\p{NFKC_QC=__M}', "");
    Expect(0, 71984, '\p{^NFKC_QC=__M}', "");
    Expect(0, 71984, '\P{NFKC_QC=__M}', "");
    Expect(1, 71984, '\P{^NFKC_QC=__M}', "");
    Expect(0, 71985, '\p{NFKC_QC=__M}', "");
    Expect(1, 71985, '\p{^NFKC_QC=__M}', "");
    Expect(1, 71985, '\P{NFKC_QC=__M}', "");
    Expect(0, 71985, '\P{^NFKC_QC=__M}', "");
    Error('\p{Is_NFKC_Quick_Check=	_maybe/a/}');
    Error('\P{Is_NFKC_Quick_Check=	_maybe/a/}');
    Expect(1, 71984, '\p{Is_NFKC_Quick_Check=maybe}', "");
    Expect(0, 71984, '\p{^Is_NFKC_Quick_Check=maybe}', "");
    Expect(0, 71984, '\P{Is_NFKC_Quick_Check=maybe}', "");
    Expect(1, 71984, '\P{^Is_NFKC_Quick_Check=maybe}', "");
    Expect(0, 71985, '\p{Is_NFKC_Quick_Check=maybe}', "");
    Expect(1, 71985, '\p{^Is_NFKC_Quick_Check=maybe}', "");
    Expect(1, 71985, '\P{Is_NFKC_Quick_Check=maybe}', "");
    Expect(0, 71985, '\P{^Is_NFKC_Quick_Check=maybe}', "");
    Expect(1, 71984, '\p{Is_NFKC_Quick_Check= Maybe}', "");
    Expect(0, 71984, '\p{^Is_NFKC_Quick_Check= Maybe}', "");
    Expect(0, 71984, '\P{Is_NFKC_Quick_Check= Maybe}', "");
    Expect(1, 71984, '\P{^Is_NFKC_Quick_Check= Maybe}', "");
    Expect(0, 71985, '\p{Is_NFKC_Quick_Check= Maybe}', "");
    Expect(1, 71985, '\p{^Is_NFKC_Quick_Check= Maybe}', "");
    Expect(1, 71985, '\P{Is_NFKC_Quick_Check= Maybe}', "");
    Expect(0, 71985, '\P{^Is_NFKC_Quick_Check= Maybe}', "");
    Error('\p{Is_NFKC_QC=	 M:=}');
    Error('\P{Is_NFKC_QC=	 M:=}');
    Expect(1, 71984, '\p{Is_NFKC_QC=m}', "");
    Expect(0, 71984, '\p{^Is_NFKC_QC=m}', "");
    Expect(0, 71984, '\P{Is_NFKC_QC=m}', "");
    Expect(1, 71984, '\P{^Is_NFKC_QC=m}', "");
    Expect(0, 71985, '\p{Is_NFKC_QC=m}', "");
    Expect(1, 71985, '\p{^Is_NFKC_QC=m}', "");
    Expect(1, 71985, '\P{Is_NFKC_QC=m}', "");
    Expect(0, 71985, '\P{^Is_NFKC_QC=m}', "");
    Expect(1, 71984, '\p{Is_NFKC_QC=-M}', "");
    Expect(0, 71984, '\p{^Is_NFKC_QC=-M}', "");
    Expect(0, 71984, '\P{Is_NFKC_QC=-M}', "");
    Expect(1, 71984, '\P{^Is_NFKC_QC=-M}', "");
    Expect(0, 71985, '\p{Is_NFKC_QC=-M}', "");
    Expect(1, 71985, '\p{^Is_NFKC_QC=-M}', "");
    Expect(1, 71985, '\P{Is_NFKC_QC=-M}', "");
    Expect(0, 71985, '\P{^Is_NFKC_QC=-M}', "");
    Error('\p{NFKC_Quick_Check=_/a/No}');
    Error('\P{NFKC_Quick_Check=_/a/No}');
    Expect(1, 195101, '\p{NFKC_Quick_Check=:\ANo\z:}', "");;
    Expect(0, 195102, '\p{NFKC_Quick_Check=:\ANo\z:}', "");;
    Expect(1, 195101, '\p{NFKC_Quick_Check=no}', "");
    Expect(0, 195101, '\p{^NFKC_Quick_Check=no}', "");
    Expect(0, 195101, '\P{NFKC_Quick_Check=no}', "");
    Expect(1, 195101, '\P{^NFKC_Quick_Check=no}', "");
    Expect(0, 195102, '\p{NFKC_Quick_Check=no}', "");
    Expect(1, 195102, '\p{^NFKC_Quick_Check=no}', "");
    Expect(1, 195102, '\P{NFKC_Quick_Check=no}', "");
    Expect(0, 195102, '\P{^NFKC_Quick_Check=no}', "");
    Expect(1, 195101, '\p{NFKC_Quick_Check=:\Ano\z:}', "");;
    Expect(0, 195102, '\p{NFKC_Quick_Check=:\Ano\z:}', "");;
    Expect(1, 195101, '\p{NFKC_Quick_Check=	_NO}', "");
    Expect(0, 195101, '\p{^NFKC_Quick_Check=	_NO}', "");
    Expect(0, 195101, '\P{NFKC_Quick_Check=	_NO}', "");
    Expect(1, 195101, '\P{^NFKC_Quick_Check=	_NO}', "");
    Expect(0, 195102, '\p{NFKC_Quick_Check=	_NO}', "");
    Expect(1, 195102, '\p{^NFKC_Quick_Check=	_NO}', "");
    Expect(1, 195102, '\P{NFKC_Quick_Check=	_NO}', "");
    Expect(0, 195102, '\P{^NFKC_Quick_Check=	_NO}', "");
    Error('\p{NFKC_QC=		N/a/}');
    Error('\P{NFKC_QC=		N/a/}');
    Expect(1, 195101, '\p{NFKC_QC=:\AN\z:}', "");;
    Expect(0, 195102, '\p{NFKC_QC=:\AN\z:}', "");;
    Expect(1, 195101, '\p{NFKC_QC=n}', "");
    Expect(0, 195101, '\p{^NFKC_QC=n}', "");
    Expect(0, 195101, '\P{NFKC_QC=n}', "");
    Expect(1, 195101, '\P{^NFKC_QC=n}', "");
    Expect(0, 195102, '\p{NFKC_QC=n}', "");
    Expect(1, 195102, '\p{^NFKC_QC=n}', "");
    Expect(1, 195102, '\P{NFKC_QC=n}', "");
    Expect(0, 195102, '\P{^NFKC_QC=n}', "");
    Expect(1, 195101, '\p{NFKC_QC=:\An\z:}', "");;
    Expect(0, 195102, '\p{NFKC_QC=:\An\z:}', "");;
    Expect(1, 195101, '\p{NFKC_QC=_-n}', "");
    Expect(0, 195101, '\p{^NFKC_QC=_-n}', "");
    Expect(0, 195101, '\P{NFKC_QC=_-n}', "");
    Expect(1, 195101, '\P{^NFKC_QC=_-n}', "");
    Expect(0, 195102, '\p{NFKC_QC=_-n}', "");
    Expect(1, 195102, '\p{^NFKC_QC=_-n}', "");
    Expect(1, 195102, '\P{NFKC_QC=_-n}', "");
    Expect(0, 195102, '\P{^NFKC_QC=_-n}', "");
    Error('\p{Is_NFKC_Quick_Check=:=No}');
    Error('\P{Is_NFKC_Quick_Check=:=No}');
    Expect(1, 195101, '\p{Is_NFKC_Quick_Check=no}', "");
    Expect(0, 195101, '\p{^Is_NFKC_Quick_Check=no}', "");
    Expect(0, 195101, '\P{Is_NFKC_Quick_Check=no}', "");
    Expect(1, 195101, '\P{^Is_NFKC_Quick_Check=no}', "");
    Expect(0, 195102, '\p{Is_NFKC_Quick_Check=no}', "");
    Expect(1, 195102, '\p{^Is_NFKC_Quick_Check=no}', "");
    Expect(1, 195102, '\P{Is_NFKC_Quick_Check=no}', "");
    Expect(0, 195102, '\P{^Is_NFKC_Quick_Check=no}', "");
    Expect(1, 195101, '\p{Is_NFKC_Quick_Check=	NO}', "");
    Expect(0, 195101, '\p{^Is_NFKC_Quick_Check=	NO}', "");
    Expect(0, 195101, '\P{Is_NFKC_Quick_Check=	NO}', "");
    Expect(1, 195101, '\P{^Is_NFKC_Quick_Check=	NO}', "");
    Expect(0, 195102, '\p{Is_NFKC_Quick_Check=	NO}', "");
    Expect(1, 195102, '\p{^Is_NFKC_Quick_Check=	NO}', "");
    Expect(1, 195102, '\P{Is_NFKC_Quick_Check=	NO}', "");
    Expect(0, 195102, '\P{^Is_NFKC_Quick_Check=	NO}', "");
    Error('\p{Is_NFKC_QC=_	N/a/}');
    Error('\P{Is_NFKC_QC=_	N/a/}');
    Expect(1, 195101, '\p{Is_NFKC_QC=n}', "");
    Expect(0, 195101, '\p{^Is_NFKC_QC=n}', "");
    Expect(0, 195101, '\P{Is_NFKC_QC=n}', "");
    Expect(1, 195101, '\P{^Is_NFKC_QC=n}', "");
    Expect(0, 195102, '\p{Is_NFKC_QC=n}', "");
    Expect(1, 195102, '\p{^Is_NFKC_QC=n}', "");
    Expect(1, 195102, '\P{Is_NFKC_QC=n}', "");
    Expect(0, 195102, '\P{^Is_NFKC_QC=n}', "");
    Expect(1, 195101, '\p{Is_NFKC_QC=_	N}', "");
    Expect(0, 195101, '\p{^Is_NFKC_QC=_	N}', "");
    Expect(0, 195101, '\P{Is_NFKC_QC=_	N}', "");
    Expect(1, 195101, '\P{^Is_NFKC_QC=_	N}', "");
    Expect(0, 195102, '\p{Is_NFKC_QC=_	N}', "");
    Expect(1, 195102, '\p{^Is_NFKC_QC=_	N}', "");
    Expect(1, 195102, '\P{Is_NFKC_QC=_	N}', "");
    Expect(0, 195102, '\P{^Is_NFKC_QC=_	N}', "");
    Error('\p{NFKC_Quick_Check= :=yes}');
    Error('\P{NFKC_Quick_Check= :=yes}');
    Expect(1, 195102, '\p{NFKC_Quick_Check=:\AYes\z:}', "");;
    Expect(0, 195101, '\p{NFKC_Quick_Check=:\AYes\z:}', "");;
    Expect(1, 195102, '\p{NFKC_Quick_Check=yes}', "");
    Expect(0, 195102, '\p{^NFKC_Quick_Check=yes}', "");
    Expect(0, 195102, '\P{NFKC_Quick_Check=yes}', "");
    Expect(1, 195102, '\P{^NFKC_Quick_Check=yes}', "");
    Expect(0, 195101, '\p{NFKC_Quick_Check=yes}', "");
    Expect(1, 195101, '\p{^NFKC_Quick_Check=yes}', "");
    Expect(1, 195101, '\P{NFKC_Quick_Check=yes}', "");
    Expect(0, 195101, '\P{^NFKC_Quick_Check=yes}', "");
    Expect(1, 195102, '\p{NFKC_Quick_Check=:\Ayes\z:}', "");;
    Expect(0, 195101, '\p{NFKC_Quick_Check=:\Ayes\z:}', "");;
    Expect(1, 195102, '\p{NFKC_Quick_Check= _yes}', "");
    Expect(0, 195102, '\p{^NFKC_Quick_Check= _yes}', "");
    Expect(0, 195102, '\P{NFKC_Quick_Check= _yes}', "");
    Expect(1, 195102, '\P{^NFKC_Quick_Check= _yes}', "");
    Expect(0, 195101, '\p{NFKC_Quick_Check= _yes}', "");
    Expect(1, 195101, '\p{^NFKC_Quick_Check= _yes}', "");
    Expect(1, 195101, '\P{NFKC_Quick_Check= _yes}', "");
    Expect(0, 195101, '\P{^NFKC_Quick_Check= _yes}', "");
    Error('\p{NFKC_QC=:=	Y}');
    Error('\P{NFKC_QC=:=	Y}');
    Expect(1, 195102, '\p{NFKC_QC=:\AY\z:}', "");;
    Expect(0, 195101, '\p{NFKC_QC=:\AY\z:}', "");;
    Expect(1, 195102, '\p{NFKC_QC=y}', "");
    Expect(0, 195102, '\p{^NFKC_QC=y}', "");
    Expect(0, 195102, '\P{NFKC_QC=y}', "");
    Expect(1, 195102, '\P{^NFKC_QC=y}', "");
    Expect(0, 195101, '\p{NFKC_QC=y}', "");
    Expect(1, 195101, '\p{^NFKC_QC=y}', "");
    Expect(1, 195101, '\P{NFKC_QC=y}', "");
    Expect(0, 195101, '\P{^NFKC_QC=y}', "");
    Expect(1, 195102, '\p{NFKC_QC=:\Ay\z:}', "");;
    Expect(0, 195101, '\p{NFKC_QC=:\Ay\z:}', "");;
    Expect(1, 195102, '\p{NFKC_QC=-	Y}', "");
    Expect(0, 195102, '\p{^NFKC_QC=-	Y}', "");
    Expect(0, 195102, '\P{NFKC_QC=-	Y}', "");
    Expect(1, 195102, '\P{^NFKC_QC=-	Y}', "");
    Expect(0, 195101, '\p{NFKC_QC=-	Y}', "");
    Expect(1, 195101, '\p{^NFKC_QC=-	Y}', "");
    Expect(1, 195101, '\P{NFKC_QC=-	Y}', "");
    Expect(0, 195101, '\P{^NFKC_QC=-	Y}', "");
    Error('\p{Is_NFKC_Quick_Check=		YES/a/}');
    Error('\P{Is_NFKC_Quick_Check=		YES/a/}');
    Expect(1, 195102, '\p{Is_NFKC_Quick_Check=yes}', "");
    Expect(0, 195102, '\p{^Is_NFKC_Quick_Check=yes}', "");
    Expect(0, 195102, '\P{Is_NFKC_Quick_Check=yes}', "");
    Expect(1, 195102, '\P{^Is_NFKC_Quick_Check=yes}', "");
    Expect(0, 195101, '\p{Is_NFKC_Quick_Check=yes}', "");
    Expect(1, 195101, '\p{^Is_NFKC_Quick_Check=yes}', "");
    Expect(1, 195101, '\P{Is_NFKC_Quick_Check=yes}', "");
    Expect(0, 195101, '\P{^Is_NFKC_Quick_Check=yes}', "");
    Expect(1, 195102, '\p{Is_NFKC_Quick_Check=-yes}', "");
    Expect(0, 195102, '\p{^Is_NFKC_Quick_Check=-yes}', "");
    Expect(0, 195102, '\P{Is_NFKC_Quick_Check=-yes}', "");
    Expect(1, 195102, '\P{^Is_NFKC_Quick_Check=-yes}', "");
    Expect(0, 195101, '\p{Is_NFKC_Quick_Check=-yes}', "");
    Expect(1, 195101, '\p{^Is_NFKC_Quick_Check=-yes}', "");
    Expect(1, 195101, '\P{Is_NFKC_Quick_Check=-yes}', "");
    Expect(0, 195101, '\P{^Is_NFKC_Quick_Check=-yes}', "");
    Error('\p{Is_NFKC_QC=/a/- Y}');
    Error('\P{Is_NFKC_QC=/a/- Y}');
    Expect(1, 195102, '\p{Is_NFKC_QC=y}', "");
    Expect(0, 195102, '\p{^Is_NFKC_QC=y}', "");
    Expect(0, 195102, '\P{Is_NFKC_QC=y}', "");
    Expect(1, 195102, '\P{^Is_NFKC_QC=y}', "");
    Expect(0, 195101, '\p{Is_NFKC_QC=y}', "");
    Expect(1, 195101, '\p{^Is_NFKC_QC=y}', "");
    Expect(1, 195101, '\P{Is_NFKC_QC=y}', "");
    Expect(0, 195101, '\P{^Is_NFKC_QC=y}', "");
    Expect(1, 195102, '\p{Is_NFKC_QC=_	Y}', "");
    Expect(0, 195102, '\p{^Is_NFKC_QC=_	Y}', "");
    Expect(0, 195102, '\P{Is_NFKC_QC=_	Y}', "");
    Expect(1, 195102, '\P{^Is_NFKC_QC=_	Y}', "");
    Expect(0, 195101, '\p{Is_NFKC_QC=_	Y}', "");
    Expect(1, 195101, '\p{^Is_NFKC_QC=_	Y}', "");
    Expect(1, 195101, '\P{Is_NFKC_QC=_	Y}', "");
    Expect(0, 195101, '\P{^Is_NFKC_QC=_	Y}', "");
    Error('\p{nfkdquickcheck}');
    Error('\P{nfkdquickcheck}');
    Error('\p{nfkdqc}');
    Error('\P{nfkdqc}');
    Error('\p{NFKD_Quick_Check=	:=NO}');
    Error('\P{NFKD_Quick_Check=	:=NO}');
    Expect(1, 195101, '\p{NFKD_Quick_Check=:\ANo\z:}', "");;
    Expect(0, 195102, '\p{NFKD_Quick_Check=:\ANo\z:}', "");;
    Expect(1, 195101, '\p{NFKD_Quick_Check=no}', "");
    Expect(0, 195101, '\p{^NFKD_Quick_Check=no}', "");
    Expect(0, 195101, '\P{NFKD_Quick_Check=no}', "");
    Expect(1, 195101, '\P{^NFKD_Quick_Check=no}', "");
    Expect(0, 195102, '\p{NFKD_Quick_Check=no}', "");
    Expect(1, 195102, '\p{^NFKD_Quick_Check=no}', "");
    Expect(1, 195102, '\P{NFKD_Quick_Check=no}', "");
    Expect(0, 195102, '\P{^NFKD_Quick_Check=no}', "");
    Expect(1, 195101, '\p{NFKD_Quick_Check=:\Ano\z:}', "");;
    Expect(0, 195102, '\p{NFKD_Quick_Check=:\Ano\z:}', "");;
    Expect(1, 195101, '\p{NFKD_Quick_Check=	-No}', "");
    Expect(0, 195101, '\p{^NFKD_Quick_Check=	-No}', "");
    Expect(0, 195101, '\P{NFKD_Quick_Check=	-No}', "");
    Expect(1, 195101, '\P{^NFKD_Quick_Check=	-No}', "");
    Expect(0, 195102, '\p{NFKD_Quick_Check=	-No}', "");
    Expect(1, 195102, '\p{^NFKD_Quick_Check=	-No}', "");
    Expect(1, 195102, '\P{NFKD_Quick_Check=	-No}', "");
    Expect(0, 195102, '\P{^NFKD_Quick_Check=	-No}', "");
    Error('\p{NFKD_QC= _N/a/}');
    Error('\P{NFKD_QC= _N/a/}');
    Expect(1, 195101, '\p{NFKD_QC=:\AN\z:}', "");;
    Expect(0, 195102, '\p{NFKD_QC=:\AN\z:}', "");;
    Expect(1, 195101, '\p{NFKD_QC:n}', "");
    Expect(0, 195101, '\p{^NFKD_QC:n}', "");
    Expect(0, 195101, '\P{NFKD_QC:n}', "");
    Expect(1, 195101, '\P{^NFKD_QC:n}', "");
    Expect(0, 195102, '\p{NFKD_QC:n}', "");
    Expect(1, 195102, '\p{^NFKD_QC:n}', "");
    Expect(1, 195102, '\P{NFKD_QC:n}', "");
    Expect(0, 195102, '\P{^NFKD_QC:n}', "");
    Expect(1, 195101, '\p{NFKD_QC=:\An\z:}', "");;
    Expect(0, 195102, '\p{NFKD_QC=:\An\z:}', "");;
    Expect(1, 195101, '\p{NFKD_QC= -N}', "");
    Expect(0, 195101, '\p{^NFKD_QC= -N}', "");
    Expect(0, 195101, '\P{NFKD_QC= -N}', "");
    Expect(1, 195101, '\P{^NFKD_QC= -N}', "");
    Expect(0, 195102, '\p{NFKD_QC= -N}', "");
    Expect(1, 195102, '\p{^NFKD_QC= -N}', "");
    Expect(1, 195102, '\P{NFKD_QC= -N}', "");
    Expect(0, 195102, '\P{^NFKD_QC= -N}', "");
    Error('\p{Is_NFKD_Quick_Check: 	 NO/a/}');
    Error('\P{Is_NFKD_Quick_Check: 	 NO/a/}');
    Expect(1, 195101, '\p{Is_NFKD_Quick_Check=no}', "");
    Expect(0, 195101, '\p{^Is_NFKD_Quick_Check=no}', "");
    Expect(0, 195101, '\P{Is_NFKD_Quick_Check=no}', "");
    Expect(1, 195101, '\P{^Is_NFKD_Quick_Check=no}', "");
    Expect(0, 195102, '\p{Is_NFKD_Quick_Check=no}', "");
    Expect(1, 195102, '\p{^Is_NFKD_Quick_Check=no}', "");
    Expect(1, 195102, '\P{Is_NFKD_Quick_Check=no}', "");
    Expect(0, 195102, '\P{^Is_NFKD_Quick_Check=no}', "");
    Expect(1, 195101, '\p{Is_NFKD_Quick_Check:   _ No}', "");
    Expect(0, 195101, '\p{^Is_NFKD_Quick_Check:   _ No}', "");
    Expect(0, 195101, '\P{Is_NFKD_Quick_Check:   _ No}', "");
    Expect(1, 195101, '\P{^Is_NFKD_Quick_Check:   _ No}', "");
    Expect(0, 195102, '\p{Is_NFKD_Quick_Check:   _ No}', "");
    Expect(1, 195102, '\p{^Is_NFKD_Quick_Check:   _ No}', "");
    Expect(1, 195102, '\P{Is_NFKD_Quick_Check:   _ No}', "");
    Expect(0, 195102, '\P{^Is_NFKD_Quick_Check:   _ No}', "");
    Error('\p{Is_NFKD_QC= -n/a/}');
    Error('\P{Is_NFKD_QC= -n/a/}');
    Expect(1, 195101, '\p{Is_NFKD_QC=n}', "");
    Expect(0, 195101, '\p{^Is_NFKD_QC=n}', "");
    Expect(0, 195101, '\P{Is_NFKD_QC=n}', "");
    Expect(1, 195101, '\P{^Is_NFKD_QC=n}', "");
    Expect(0, 195102, '\p{Is_NFKD_QC=n}', "");
    Expect(1, 195102, '\p{^Is_NFKD_QC=n}', "");
    Expect(1, 195102, '\P{Is_NFKD_QC=n}', "");
    Expect(0, 195102, '\P{^Is_NFKD_QC=n}', "");
    Expect(1, 195101, '\p{Is_NFKD_QC:	_n}', "");
    Expect(0, 195101, '\p{^Is_NFKD_QC:	_n}', "");
    Expect(0, 195101, '\P{Is_NFKD_QC:	_n}', "");
    Expect(1, 195101, '\P{^Is_NFKD_QC:	_n}', "");
    Expect(0, 195102, '\p{Is_NFKD_QC:	_n}', "");
    Expect(1, 195102, '\p{^Is_NFKD_QC:	_n}', "");
    Expect(1, 195102, '\P{Is_NFKD_QC:	_n}', "");
    Expect(0, 195102, '\P{^Is_NFKD_QC:	_n}', "");
    Error('\p{NFKD_Quick_Check= :=Yes}');
    Error('\P{NFKD_Quick_Check= :=Yes}');
    Expect(1, 195102, '\p{NFKD_Quick_Check=:\AYes\z:}', "");;
    Expect(0, 195101, '\p{NFKD_Quick_Check=:\AYes\z:}', "");;
    Expect(1, 195102, '\p{NFKD_Quick_Check: yes}', "");
    Expect(0, 195102, '\p{^NFKD_Quick_Check: yes}', "");
    Expect(0, 195102, '\P{NFKD_Quick_Check: yes}', "");
    Expect(1, 195102, '\P{^NFKD_Quick_Check: yes}', "");
    Expect(0, 195101, '\p{NFKD_Quick_Check: yes}', "");
    Expect(1, 195101, '\p{^NFKD_Quick_Check: yes}', "");
    Expect(1, 195101, '\P{NFKD_Quick_Check: yes}', "");
    Expect(0, 195101, '\P{^NFKD_Quick_Check: yes}', "");
    Expect(1, 195102, '\p{NFKD_Quick_Check=:\Ayes\z:}', "");;
    Expect(0, 195101, '\p{NFKD_Quick_Check=:\Ayes\z:}', "");;
    Expect(1, 195102, '\p{NFKD_Quick_Check=-Yes}', "");
    Expect(0, 195102, '\p{^NFKD_Quick_Check=-Yes}', "");
    Expect(0, 195102, '\P{NFKD_Quick_Check=-Yes}', "");
    Expect(1, 195102, '\P{^NFKD_Quick_Check=-Yes}', "");
    Expect(0, 195101, '\p{NFKD_Quick_Check=-Yes}', "");
    Expect(1, 195101, '\p{^NFKD_Quick_Check=-Yes}', "");
    Expect(1, 195101, '\P{NFKD_Quick_Check=-Yes}', "");
    Expect(0, 195101, '\P{^NFKD_Quick_Check=-Yes}', "");
    Error('\p{NFKD_QC=_-Y:=}');
    Error('\P{NFKD_QC=_-Y:=}');
    Expect(1, 195102, '\p{NFKD_QC=:\AY\z:}', "");;
    Expect(0, 195101, '\p{NFKD_QC=:\AY\z:}', "");;
    Expect(1, 195102, '\p{NFKD_QC=y}', "");
    Expect(0, 195102, '\p{^NFKD_QC=y}', "");
    Expect(0, 195102, '\P{NFKD_QC=y}', "");
    Expect(1, 195102, '\P{^NFKD_QC=y}', "");
    Expect(0, 195101, '\p{NFKD_QC=y}', "");
    Expect(1, 195101, '\p{^NFKD_QC=y}', "");
    Expect(1, 195101, '\P{NFKD_QC=y}', "");
    Expect(0, 195101, '\P{^NFKD_QC=y}', "");
    Expect(1, 195102, '\p{NFKD_QC=:\Ay\z:}', "");;
    Expect(0, 195101, '\p{NFKD_QC=:\Ay\z:}', "");;
    Expect(1, 195102, '\p{NFKD_QC= 	Y}', "");
    Expect(0, 195102, '\p{^NFKD_QC= 	Y}', "");
    Expect(0, 195102, '\P{NFKD_QC= 	Y}', "");
    Expect(1, 195102, '\P{^NFKD_QC= 	Y}', "");
    Expect(0, 195101, '\p{NFKD_QC= 	Y}', "");
    Expect(1, 195101, '\p{^NFKD_QC= 	Y}', "");
    Expect(1, 195101, '\P{NFKD_QC= 	Y}', "");
    Expect(0, 195101, '\P{^NFKD_QC= 	Y}', "");
    Error('\p{Is_NFKD_Quick_Check=-/a/YES}');
    Error('\P{Is_NFKD_Quick_Check=-/a/YES}');
    Expect(1, 195102, '\p{Is_NFKD_Quick_Check=yes}', "");
    Expect(0, 195102, '\p{^Is_NFKD_Quick_Check=yes}', "");
    Expect(0, 195102, '\P{Is_NFKD_Quick_Check=yes}', "");
    Expect(1, 195102, '\P{^Is_NFKD_Quick_Check=yes}', "");
    Expect(0, 195101, '\p{Is_NFKD_Quick_Check=yes}', "");
    Expect(1, 195101, '\p{^Is_NFKD_Quick_Check=yes}', "");
    Expect(1, 195101, '\P{Is_NFKD_Quick_Check=yes}', "");
    Expect(0, 195101, '\P{^Is_NFKD_Quick_Check=yes}', "");
    Expect(1, 195102, '\p{Is_NFKD_Quick_Check=	yes}', "");
    Expect(0, 195102, '\p{^Is_NFKD_Quick_Check=	yes}', "");
    Expect(0, 195102, '\P{Is_NFKD_Quick_Check=	yes}', "");
    Expect(1, 195102, '\P{^Is_NFKD_Quick_Check=	yes}', "");
    Expect(0, 195101, '\p{Is_NFKD_Quick_Check=	yes}', "");
    Expect(1, 195101, '\p{^Is_NFKD_Quick_Check=	yes}', "");
    Expect(1, 195101, '\P{Is_NFKD_Quick_Check=	yes}', "");
    Expect(0, 195101, '\P{^Is_NFKD_Quick_Check=	yes}', "");
    Error('\p{Is_NFKD_QC=_/a/Y}');
    Error('\P{Is_NFKD_QC=_/a/Y}');
    Expect(1, 195102, '\p{Is_NFKD_QC:   y}', "");
    Expect(0, 195102, '\p{^Is_NFKD_QC:   y}', "");
    Expect(0, 195102, '\P{Is_NFKD_QC:   y}', "");
    Expect(1, 195102, '\P{^Is_NFKD_QC:   y}', "");
    Expect(0, 195101, '\p{Is_NFKD_QC:   y}', "");
    Expect(1, 195101, '\p{^Is_NFKD_QC:   y}', "");
    Expect(1, 195101, '\P{Is_NFKD_QC:   y}', "");
    Expect(0, 195101, '\P{^Is_NFKD_QC:   y}', "");
    Expect(1, 195102, '\p{Is_NFKD_QC=_-Y}', "");
    Expect(0, 195102, '\p{^Is_NFKD_QC=_-Y}', "");
    Expect(0, 195102, '\P{Is_NFKD_QC=_-Y}', "");
    Expect(1, 195102, '\P{^Is_NFKD_QC=_-Y}', "");
    Expect(0, 195101, '\p{Is_NFKD_QC=_-Y}', "");
    Expect(1, 195101, '\p{^Is_NFKD_QC=_-Y}', "");
    Expect(1, 195101, '\P{Is_NFKD_QC=_-Y}', "");
    Expect(0, 195101, '\P{^Is_NFKD_QC=_-Y}', "");
    Error('\p{numerictype}');
    Error('\P{numerictype}');
    Error('\p{nt}');
    Error('\P{nt}');
    Error('\p{Numeric_Type=/a/	-Decimal}');
    Error('\P{Numeric_Type=/a/	-Decimal}');
    Expect(1, 130041, '\p{Numeric_Type=:\ADecimal\z:}', "");;
    Expect(0, 130042, '\p{Numeric_Type=:\ADecimal\z:}', "");;
    Expect(1, 130041, '\p{Numeric_Type=decimal}', "");
    Expect(0, 130041, '\p{^Numeric_Type=decimal}', "");
    Expect(0, 130041, '\P{Numeric_Type=decimal}', "");
    Expect(1, 130041, '\P{^Numeric_Type=decimal}', "");
    Expect(0, 130042, '\p{Numeric_Type=decimal}', "");
    Expect(1, 130042, '\p{^Numeric_Type=decimal}', "");
    Expect(1, 130042, '\P{Numeric_Type=decimal}', "");
    Expect(0, 130042, '\P{^Numeric_Type=decimal}', "");
    Expect(1, 130041, '\p{Numeric_Type=:\Adecimal\z:}', "");;
    Expect(0, 130042, '\p{Numeric_Type=:\Adecimal\z:}', "");;
    Expect(1, 130041, '\p{Numeric_Type=-Decimal}', "");
    Expect(0, 130041, '\p{^Numeric_Type=-Decimal}', "");
    Expect(0, 130041, '\P{Numeric_Type=-Decimal}', "");
    Expect(1, 130041, '\P{^Numeric_Type=-Decimal}', "");
    Expect(0, 130042, '\p{Numeric_Type=-Decimal}', "");
    Expect(1, 130042, '\p{^Numeric_Type=-Decimal}', "");
    Expect(1, 130042, '\P{Numeric_Type=-Decimal}', "");
    Expect(0, 130042, '\P{^Numeric_Type=-Decimal}', "");
    Error('\p{Nt:	:=__DE}');
    Error('\P{Nt:	:=__DE}');
    Expect(1, 130041, '\p{Nt=:\ADe\z:}', "");;
    Expect(0, 130042, '\p{Nt=:\ADe\z:}', "");;
    Expect(1, 130041, '\p{Nt=de}', "");
    Expect(0, 130041, '\p{^Nt=de}', "");
    Expect(0, 130041, '\P{Nt=de}', "");
    Expect(1, 130041, '\P{^Nt=de}', "");
    Expect(0, 130042, '\p{Nt=de}', "");
    Expect(1, 130042, '\p{^Nt=de}', "");
    Expect(1, 130042, '\P{Nt=de}', "");
    Expect(0, 130042, '\P{^Nt=de}', "");
    Expect(1, 130041, '\p{Nt=:\Ade\z:}', "");;
    Expect(0, 130042, '\p{Nt=:\Ade\z:}', "");;
    Expect(1, 130041, '\p{Nt=	De}', "");
    Expect(0, 130041, '\p{^Nt=	De}', "");
    Expect(0, 130041, '\P{Nt=	De}', "");
    Expect(1, 130041, '\P{^Nt=	De}', "");
    Expect(0, 130042, '\p{Nt=	De}', "");
    Expect(1, 130042, '\p{^Nt=	De}', "");
    Expect(1, 130042, '\P{Nt=	De}', "");
    Expect(0, 130042, '\P{^Nt=	De}', "");
    Error('\p{Is_Numeric_Type=-_DECIMAL/a/}');
    Error('\P{Is_Numeric_Type=-_DECIMAL/a/}');
    Expect(1, 130041, '\p{Is_Numeric_Type=decimal}', "");
    Expect(0, 130041, '\p{^Is_Numeric_Type=decimal}', "");
    Expect(0, 130041, '\P{Is_Numeric_Type=decimal}', "");
    Expect(1, 130041, '\P{^Is_Numeric_Type=decimal}', "");
    Expect(0, 130042, '\p{Is_Numeric_Type=decimal}', "");
    Expect(1, 130042, '\p{^Is_Numeric_Type=decimal}', "");
    Expect(1, 130042, '\P{Is_Numeric_Type=decimal}', "");
    Expect(0, 130042, '\P{^Is_Numeric_Type=decimal}', "");
    Expect(1, 130041, '\p{Is_Numeric_Type=-DECIMAL}', "");
    Expect(0, 130041, '\p{^Is_Numeric_Type=-DECIMAL}', "");
    Expect(0, 130041, '\P{Is_Numeric_Type=-DECIMAL}', "");
    Expect(1, 130041, '\P{^Is_Numeric_Type=-DECIMAL}', "");
    Expect(0, 130042, '\p{Is_Numeric_Type=-DECIMAL}', "");
    Expect(1, 130042, '\p{^Is_Numeric_Type=-DECIMAL}', "");
    Expect(1, 130042, '\P{Is_Numeric_Type=-DECIMAL}', "");
    Expect(0, 130042, '\P{^Is_Numeric_Type=-DECIMAL}', "");
    Error('\p{Is_Nt= -De/a/}');
    Error('\P{Is_Nt= -De/a/}');
    Expect(1, 130041, '\p{Is_Nt=de}', "");
    Expect(0, 130041, '\p{^Is_Nt=de}', "");
    Expect(0, 130041, '\P{Is_Nt=de}', "");
    Expect(1, 130041, '\P{^Is_Nt=de}', "");
    Expect(0, 130042, '\p{Is_Nt=de}', "");
    Expect(1, 130042, '\p{^Is_Nt=de}', "");
    Expect(1, 130042, '\P{Is_Nt=de}', "");
    Expect(0, 130042, '\P{^Is_Nt=de}', "");
    Expect(1, 130041, '\p{Is_Nt=_De}', "");
    Expect(0, 130041, '\p{^Is_Nt=_De}', "");
    Expect(0, 130041, '\P{Is_Nt=_De}', "");
    Expect(1, 130041, '\P{^Is_Nt=_De}', "");
    Expect(0, 130042, '\p{Is_Nt=_De}', "");
    Expect(1, 130042, '\p{^Is_Nt=_De}', "");
    Expect(1, 130042, '\P{Is_Nt=_De}', "");
    Expect(0, 130042, '\P{^Is_Nt=_De}', "");
    Error('\p{Numeric_Type=	:=DIGIT}');
    Error('\P{Numeric_Type=	:=DIGIT}');
    Expect(1, 127242, '\p{Numeric_Type=:\ADigit\z:}', "");;
    Expect(0, 127243, '\p{Numeric_Type=:\ADigit\z:}', "");;
    Expect(1, 127242, '\p{Numeric_Type=digit}', "");
    Expect(0, 127242, '\p{^Numeric_Type=digit}', "");
    Expect(0, 127242, '\P{Numeric_Type=digit}', "");
    Expect(1, 127242, '\P{^Numeric_Type=digit}', "");
    Expect(0, 127243, '\p{Numeric_Type=digit}', "");
    Expect(1, 127243, '\p{^Numeric_Type=digit}', "");
    Expect(1, 127243, '\P{Numeric_Type=digit}', "");
    Expect(0, 127243, '\P{^Numeric_Type=digit}', "");
    Expect(1, 127242, '\p{Numeric_Type=:\Adigit\z:}', "");;
    Expect(0, 127243, '\p{Numeric_Type=:\Adigit\z:}', "");;
    Expect(1, 127242, '\p{Numeric_Type=_digit}', "");
    Expect(0, 127242, '\p{^Numeric_Type=_digit}', "");
    Expect(0, 127242, '\P{Numeric_Type=_digit}', "");
    Expect(1, 127242, '\P{^Numeric_Type=_digit}', "");
    Expect(0, 127243, '\p{Numeric_Type=_digit}', "");
    Expect(1, 127243, '\p{^Numeric_Type=_digit}', "");
    Expect(1, 127243, '\P{Numeric_Type=_digit}', "");
    Expect(0, 127243, '\P{^Numeric_Type=_digit}', "");
    Error('\p{Nt=:=-	DI}');
    Error('\P{Nt=:=-	DI}');
    Expect(1, 127242, '\p{Nt=:\ADi\z:}', "");;
    Expect(0, 127243, '\p{Nt=:\ADi\z:}', "");;
    Expect(1, 127242, '\p{Nt=di}', "");
    Expect(0, 127242, '\p{^Nt=di}', "");
    Expect(0, 127242, '\P{Nt=di}', "");
    Expect(1, 127242, '\P{^Nt=di}', "");
    Expect(0, 127243, '\p{Nt=di}', "");
    Expect(1, 127243, '\p{^Nt=di}', "");
    Expect(1, 127243, '\P{Nt=di}', "");
    Expect(0, 127243, '\P{^Nt=di}', "");
    Expect(1, 127242, '\p{Nt=:\Adi\z:}', "");;
    Expect(0, 127243, '\p{Nt=:\Adi\z:}', "");;
    Expect(1, 127242, '\p{Nt: Di}', "");
    Expect(0, 127242, '\p{^Nt: Di}', "");
    Expect(0, 127242, '\P{Nt: Di}', "");
    Expect(1, 127242, '\P{^Nt: Di}', "");
    Expect(0, 127243, '\p{Nt: Di}', "");
    Expect(1, 127243, '\p{^Nt: Di}', "");
    Expect(1, 127243, '\P{Nt: Di}', "");
    Expect(0, 127243, '\P{^Nt: Di}', "");
    Error('\p{Is_Numeric_Type=-DIGIT:=}');
    Error('\P{Is_Numeric_Type=-DIGIT:=}');
    Expect(1, 127242, '\p{Is_Numeric_Type=digit}', "");
    Expect(0, 127242, '\p{^Is_Numeric_Type=digit}', "");
    Expect(0, 127242, '\P{Is_Numeric_Type=digit}', "");
    Expect(1, 127242, '\P{^Is_Numeric_Type=digit}', "");
    Expect(0, 127243, '\p{Is_Numeric_Type=digit}', "");
    Expect(1, 127243, '\p{^Is_Numeric_Type=digit}', "");
    Expect(1, 127243, '\P{Is_Numeric_Type=digit}', "");
    Expect(0, 127243, '\P{^Is_Numeric_Type=digit}', "");
    Expect(1, 127242, '\p{Is_Numeric_Type=  Digit}', "");
    Expect(0, 127242, '\p{^Is_Numeric_Type=  Digit}', "");
    Expect(0, 127242, '\P{Is_Numeric_Type=  Digit}', "");
    Expect(1, 127242, '\P{^Is_Numeric_Type=  Digit}', "");
    Expect(0, 127243, '\p{Is_Numeric_Type=  Digit}', "");
    Expect(1, 127243, '\p{^Is_Numeric_Type=  Digit}', "");
    Expect(1, 127243, '\P{Is_Numeric_Type=  Digit}', "");
    Expect(0, 127243, '\P{^Is_Numeric_Type=  Digit}', "");
    Error('\p{Is_Nt=-:=Di}');
    Error('\P{Is_Nt=-:=Di}');
    Expect(1, 127242, '\p{Is_Nt=di}', "");
    Expect(0, 127242, '\p{^Is_Nt=di}', "");
    Expect(0, 127242, '\P{Is_Nt=di}', "");
    Expect(1, 127242, '\P{^Is_Nt=di}', "");
    Expect(0, 127243, '\p{Is_Nt=di}', "");
    Expect(1, 127243, '\p{^Is_Nt=di}', "");
    Expect(1, 127243, '\P{Is_Nt=di}', "");
    Expect(0, 127243, '\P{^Is_Nt=di}', "");
    Expect(1, 127242, '\p{Is_Nt:	--Di}', "");
    Expect(0, 127242, '\p{^Is_Nt:	--Di}', "");
    Expect(0, 127242, '\P{Is_Nt:	--Di}', "");
    Expect(1, 127242, '\P{^Is_Nt:	--Di}', "");
    Expect(0, 127243, '\p{Is_Nt:	--Di}', "");
    Expect(1, 127243, '\p{^Is_Nt:	--Di}', "");
    Expect(1, 127243, '\P{Is_Nt:	--Di}', "");
    Expect(0, 127243, '\P{^Is_Nt:	--Di}', "");
    Error('\p{Numeric_Type=_:=none}');
    Error('\P{Numeric_Type=_:=none}');
    Expect(1, 194705, '\p{Numeric_Type=:\ANone\z:}', "");;
    Expect(0, 194704, '\p{Numeric_Type=:\ANone\z:}', "");;
    Expect(1, 194705, '\p{Numeric_Type=none}', "");
    Expect(0, 194705, '\p{^Numeric_Type=none}', "");
    Expect(0, 194705, '\P{Numeric_Type=none}', "");
    Expect(1, 194705, '\P{^Numeric_Type=none}', "");
    Expect(0, 194704, '\p{Numeric_Type=none}', "");
    Expect(1, 194704, '\p{^Numeric_Type=none}', "");
    Expect(1, 194704, '\P{Numeric_Type=none}', "");
    Expect(0, 194704, '\P{^Numeric_Type=none}', "");
    Expect(1, 194705, '\p{Numeric_Type=:\Anone\z:}', "");;
    Expect(0, 194704, '\p{Numeric_Type=:\Anone\z:}', "");;
    Expect(1, 194705, '\p{Numeric_Type=  None}', "");
    Expect(0, 194705, '\p{^Numeric_Type=  None}', "");
    Expect(0, 194705, '\P{Numeric_Type=  None}', "");
    Expect(1, 194705, '\P{^Numeric_Type=  None}', "");
    Expect(0, 194704, '\p{Numeric_Type=  None}', "");
    Expect(1, 194704, '\p{^Numeric_Type=  None}', "");
    Expect(1, 194704, '\P{Numeric_Type=  None}', "");
    Expect(0, 194704, '\P{^Numeric_Type=  None}', "");
    Error('\p{Nt= _None:=}');
    Error('\P{Nt= _None:=}');
    Expect(1, 194705, '\p{Nt=:\ANone\z:}', "");;
    Expect(0, 194704, '\p{Nt=:\ANone\z:}', "");;
    Expect(1, 194705, '\p{Nt=none}', "");
    Expect(0, 194705, '\p{^Nt=none}', "");
    Expect(0, 194705, '\P{Nt=none}', "");
    Expect(1, 194705, '\P{^Nt=none}', "");
    Expect(0, 194704, '\p{Nt=none}', "");
    Expect(1, 194704, '\p{^Nt=none}', "");
    Expect(1, 194704, '\P{Nt=none}', "");
    Expect(0, 194704, '\P{^Nt=none}', "");
    Expect(1, 194705, '\p{Nt=:\Anone\z:}', "");;
    Expect(0, 194704, '\p{Nt=:\Anone\z:}', "");;
    Expect(1, 194705, '\p{Nt=-	None}', "");
    Expect(0, 194705, '\p{^Nt=-	None}', "");
    Expect(0, 194705, '\P{Nt=-	None}', "");
    Expect(1, 194705, '\P{^Nt=-	None}', "");
    Expect(0, 194704, '\p{Nt=-	None}', "");
    Expect(1, 194704, '\p{^Nt=-	None}', "");
    Expect(1, 194704, '\P{Nt=-	None}', "");
    Expect(0, 194704, '\P{^Nt=-	None}', "");
    Error('\p{Is_Numeric_Type: /a/__None}');
    Error('\P{Is_Numeric_Type: /a/__None}');
    Expect(1, 194705, '\p{Is_Numeric_Type=none}', "");
    Expect(0, 194705, '\p{^Is_Numeric_Type=none}', "");
    Expect(0, 194705, '\P{Is_Numeric_Type=none}', "");
    Expect(1, 194705, '\P{^Is_Numeric_Type=none}', "");
    Expect(0, 194704, '\p{Is_Numeric_Type=none}', "");
    Expect(1, 194704, '\p{^Is_Numeric_Type=none}', "");
    Expect(1, 194704, '\P{Is_Numeric_Type=none}', "");
    Expect(0, 194704, '\P{^Is_Numeric_Type=none}', "");
    Expect(1, 194705, '\p{Is_Numeric_Type= 	None}', "");
    Expect(0, 194705, '\p{^Is_Numeric_Type= 	None}', "");
    Expect(0, 194705, '\P{Is_Numeric_Type= 	None}', "");
    Expect(1, 194705, '\P{^Is_Numeric_Type= 	None}', "");
    Expect(0, 194704, '\p{Is_Numeric_Type= 	None}', "");
    Expect(1, 194704, '\p{^Is_Numeric_Type= 	None}', "");
    Expect(1, 194704, '\P{Is_Numeric_Type= 	None}', "");
    Expect(0, 194704, '\P{^Is_Numeric_Type= 	None}', "");
    Error('\p{Is_Nt=/a/None}');
    Error('\P{Is_Nt=/a/None}');
    Expect(1, 194705, '\p{Is_Nt=none}', "");
    Expect(0, 194705, '\p{^Is_Nt=none}', "");
    Expect(0, 194705, '\P{Is_Nt=none}', "");
    Expect(1, 194705, '\P{^Is_Nt=none}', "");
    Expect(0, 194704, '\p{Is_Nt=none}', "");
    Expect(1, 194704, '\p{^Is_Nt=none}', "");
    Expect(1, 194704, '\P{Is_Nt=none}', "");
    Expect(0, 194704, '\P{^Is_Nt=none}', "");
    Expect(1, 194705, '\p{Is_Nt=-None}', "");
    Expect(0, 194705, '\p{^Is_Nt=-None}', "");
    Expect(0, 194705, '\P{Is_Nt=-None}', "");
    Expect(1, 194705, '\P{^Is_Nt=-None}', "");
    Expect(0, 194704, '\p{Is_Nt=-None}', "");
    Expect(1, 194704, '\p{^Is_Nt=-None}', "");
    Expect(1, 194704, '\P{Is_Nt=-None}', "");
    Expect(0, 194704, '\P{^Is_Nt=-None}', "");
    Error('\p{Numeric_Type= -Numeric/a/}');
    Error('\P{Numeric_Type= -Numeric/a/}');
    Expect(1, 194704, '\p{Numeric_Type=:\ANumeric\z:}', "");;
    Expect(0, 194705, '\p{Numeric_Type=:\ANumeric\z:}', "");;
    Expect(1, 194704, '\p{Numeric_Type=numeric}', "");
    Expect(0, 194704, '\p{^Numeric_Type=numeric}', "");
    Expect(0, 194704, '\P{Numeric_Type=numeric}', "");
    Expect(1, 194704, '\P{^Numeric_Type=numeric}', "");
    Expect(0, 194705, '\p{Numeric_Type=numeric}', "");
    Expect(1, 194705, '\p{^Numeric_Type=numeric}', "");
    Expect(1, 194705, '\P{Numeric_Type=numeric}', "");
    Expect(0, 194705, '\P{^Numeric_Type=numeric}', "");
    Expect(1, 194704, '\p{Numeric_Type=:\Anumeric\z:}', "");;
    Expect(0, 194705, '\p{Numeric_Type=:\Anumeric\z:}', "");;
    Expect(1, 194704, '\p{Numeric_Type=		NUMERIC}', "");
    Expect(0, 194704, '\p{^Numeric_Type=		NUMERIC}', "");
    Expect(0, 194704, '\P{Numeric_Type=		NUMERIC}', "");
    Expect(1, 194704, '\P{^Numeric_Type=		NUMERIC}', "");
    Expect(0, 194705, '\p{Numeric_Type=		NUMERIC}', "");
    Expect(1, 194705, '\p{^Numeric_Type=		NUMERIC}', "");
    Expect(1, 194705, '\P{Numeric_Type=		NUMERIC}', "");
    Expect(0, 194705, '\P{^Numeric_Type=		NUMERIC}', "");
    Error('\p{Nt:   	_Nu:=}');
    Error('\P{Nt:   	_Nu:=}');
    Expect(1, 194704, '\p{Nt=:\ANu\z:}', "");;
    Expect(0, 194705, '\p{Nt=:\ANu\z:}', "");;
    Expect(1, 194704, '\p{Nt=nu}', "");
    Expect(0, 194704, '\p{^Nt=nu}', "");
    Expect(0, 194704, '\P{Nt=nu}', "");
    Expect(1, 194704, '\P{^Nt=nu}', "");
    Expect(0, 194705, '\p{Nt=nu}', "");
    Expect(1, 194705, '\p{^Nt=nu}', "");
    Expect(1, 194705, '\P{Nt=nu}', "");
    Expect(0, 194705, '\P{^Nt=nu}', "");
    Expect(1, 194704, '\p{Nt=:\Anu\z:}', "");;
    Expect(0, 194705, '\p{Nt=:\Anu\z:}', "");;
    Expect(1, 194704, '\p{Nt= -Nu}', "");
    Expect(0, 194704, '\p{^Nt= -Nu}', "");
    Expect(0, 194704, '\P{Nt= -Nu}', "");
    Expect(1, 194704, '\P{^Nt= -Nu}', "");
    Expect(0, 194705, '\p{Nt= -Nu}', "");
    Expect(1, 194705, '\p{^Nt= -Nu}', "");
    Expect(1, 194705, '\P{Nt= -Nu}', "");
    Expect(0, 194705, '\P{^Nt= -Nu}', "");
    Error('\p{Is_Numeric_Type=_-Numeric:=}');
    Error('\P{Is_Numeric_Type=_-Numeric:=}');
    Expect(1, 194704, '\p{Is_Numeric_Type: numeric}', "");
    Expect(0, 194704, '\p{^Is_Numeric_Type: numeric}', "");
    Expect(0, 194704, '\P{Is_Numeric_Type: numeric}', "");
    Expect(1, 194704, '\P{^Is_Numeric_Type: numeric}', "");
    Expect(0, 194705, '\p{Is_Numeric_Type: numeric}', "");
    Expect(1, 194705, '\p{^Is_Numeric_Type: numeric}', "");
    Expect(1, 194705, '\P{Is_Numeric_Type: numeric}', "");
    Expect(0, 194705, '\P{^Is_Numeric_Type: numeric}', "");
    Expect(1, 194704, '\p{Is_Numeric_Type=_NUMERIC}', "");
    Expect(0, 194704, '\p{^Is_Numeric_Type=_NUMERIC}', "");
    Expect(0, 194704, '\P{Is_Numeric_Type=_NUMERIC}', "");
    Expect(1, 194704, '\P{^Is_Numeric_Type=_NUMERIC}', "");
    Expect(0, 194705, '\p{Is_Numeric_Type=_NUMERIC}', "");
    Expect(1, 194705, '\p{^Is_Numeric_Type=_NUMERIC}', "");
    Expect(1, 194705, '\P{Is_Numeric_Type=_NUMERIC}', "");
    Expect(0, 194705, '\P{^Is_Numeric_Type=_NUMERIC}', "");
    Error('\p{Is_Nt= /a/Nu}');
    Error('\P{Is_Nt= /a/Nu}');
    Expect(1, 194704, '\p{Is_Nt=nu}', "");
    Expect(0, 194704, '\p{^Is_Nt=nu}', "");
    Expect(0, 194704, '\P{Is_Nt=nu}', "");
    Expect(1, 194704, '\P{^Is_Nt=nu}', "");
    Expect(0, 194705, '\p{Is_Nt=nu}', "");
    Expect(1, 194705, '\p{^Is_Nt=nu}', "");
    Expect(1, 194705, '\P{Is_Nt=nu}', "");
    Expect(0, 194705, '\P{^Is_Nt=nu}', "");
    Expect(1, 194704, '\p{Is_Nt:   _ Nu}', "");
    Expect(0, 194704, '\p{^Is_Nt:   _ Nu}', "");
    Expect(0, 194704, '\P{Is_Nt:   _ Nu}', "");
    Expect(1, 194704, '\P{^Is_Nt:   _ Nu}', "");
    Expect(0, 194705, '\p{Is_Nt:   _ Nu}', "");
    Expect(1, 194705, '\p{^Is_Nt:   _ Nu}', "");
    Expect(1, 194705, '\P{Is_Nt:   _ Nu}', "");
    Expect(0, 194705, '\P{^Is_Nt:   _ Nu}', "");
    Error('\p{numericvalue}');
    Error('\P{numericvalue}');
    Error('\p{nv}');
    Error('\P{nv}');
    Error('\p{Numeric_Value=/a/_--0000000001/000002}');
    Error('\P{Numeric_Value=/a/_--0000000001/000002}');
    Expect(1, 3891, '\p{Numeric_Value=:\A-1/2\z:}', "");;
    Expect(0, 3892, '\p{Numeric_Value=:\A-1/2\z:}', "");;
    Expect(1, 3891, '\p{Numeric_Value=-001/00000002}', "");
    Expect(0, 3891, '\p{^Numeric_Value=-001/00000002}', "");
    Expect(0, 3891, '\P{Numeric_Value=-001/00000002}', "");
    Expect(1, 3891, '\P{^Numeric_Value=-001/00000002}', "");
    Expect(0, 3892, '\p{Numeric_Value=-001/00000002}', "");
    Expect(1, 3892, '\p{^Numeric_Value=-001/00000002}', "");
    Expect(1, 3892, '\P{Numeric_Value=-001/00000002}', "");
    Expect(0, 3892, '\P{^Numeric_Value=-001/00000002}', "");
    Expect(1, 3891, '\p{Numeric_Value=-60/120}', "");
    Expect(0, 3891, '\p{^Numeric_Value=-60/120}', "");
    Expect(0, 3891, '\P{Numeric_Value=-60/120}', "");
    Expect(1, 3891, '\P{^Numeric_Value=-60/120}', "");
    Expect(0, 3892, '\p{Numeric_Value=-60/120}', "");
    Expect(1, 3892, '\p{^Numeric_Value=-60/120}', "");
    Expect(1, 3892, '\P{Numeric_Value=-60/120}', "");
    Expect(0, 3892, '\P{^Numeric_Value=-60/120}', "");
    Expect(1, 3891, '\p{Numeric_Value=-5.0e-01}', "");
    Expect(0, 3891, '\p{^Numeric_Value=-5.0e-01}', "");
    Expect(0, 3891, '\P{Numeric_Value=-5.0e-01}', "");
    Expect(1, 3891, '\P{^Numeric_Value=-5.0e-01}', "");
    Expect(0, 3892, '\p{Numeric_Value=-5.0e-01}', "");
    Expect(1, 3892, '\p{^Numeric_Value=-5.0e-01}', "");
    Expect(1, 3892, '\P{Numeric_Value=-5.0e-01}', "");
    Expect(0, 3892, '\P{^Numeric_Value=-5.0e-01}', "");
    Expect(1, 3891, '\p{Numeric_Value=-0.5}', "");
    Expect(0, 3891, '\p{^Numeric_Value=-0.5}', "");
    Expect(0, 3891, '\P{Numeric_Value=-0.5}', "");
    Expect(1, 3891, '\P{^Numeric_Value=-0.5}', "");
    Expect(0, 3892, '\p{Numeric_Value=-0.5}', "");
    Expect(1, 3892, '\p{^Numeric_Value=-0.5}', "");
    Expect(1, 3892, '\P{Numeric_Value=-0.5}', "");
    Expect(0, 3892, '\P{^Numeric_Value=-0.5}', "");
    Expect(1, 3891, '\p{Numeric_Value=-5.00e-01}', "");
    Expect(0, 3891, '\p{^Numeric_Value=-5.00e-01}', "");
    Expect(0, 3891, '\P{Numeric_Value=-5.00e-01}', "");
    Expect(1, 3891, '\P{^Numeric_Value=-5.00e-01}', "");
    Expect(0, 3892, '\p{Numeric_Value=-5.00e-01}', "");
    Expect(1, 3892, '\p{^Numeric_Value=-5.00e-01}', "");
    Expect(1, 3892, '\P{Numeric_Value=-5.00e-01}', "");
    Expect(0, 3892, '\P{^Numeric_Value=-5.00e-01}', "");
    Expect(1, 3891, '\p{Numeric_Value:   -0.50}', "");
    Expect(0, 3891, '\p{^Numeric_Value:   -0.50}', "");
    Expect(0, 3891, '\P{Numeric_Value:   -0.50}', "");
    Expect(1, 3891, '\P{^Numeric_Value:   -0.50}', "");
    Expect(0, 3892, '\p{Numeric_Value:   -0.50}', "");
    Expect(1, 3892, '\p{^Numeric_Value:   -0.50}', "");
    Expect(1, 3892, '\P{Numeric_Value:   -0.50}', "");
    Expect(0, 3892, '\P{^Numeric_Value:   -0.50}', "");
    Error('\p{Nv=/a/- -0000000001/000000002}');
    Error('\P{Nv=/a/- -0000000001/000000002}');
    Expect(1, 3891, '\p{Nv=:\A-1/2\z:}', "");;
    Expect(0, 3892, '\p{Nv=:\A-1/2\z:}', "");;
    Expect(1, 3891, '\p{Nv=-0000000001/000000002}', "");
    Expect(0, 3891, '\p{^Nv=-0000000001/000000002}', "");
    Expect(0, 3891, '\P{Nv=-0000000001/000000002}', "");
    Expect(1, 3891, '\P{^Nv=-0000000001/000000002}', "");
    Expect(0, 3892, '\p{Nv=-0000000001/000000002}', "");
    Expect(1, 3892, '\p{^Nv=-0000000001/000000002}', "");
    Expect(1, 3892, '\P{Nv=-0000000001/000000002}', "");
    Expect(0, 3892, '\P{^Nv=-0000000001/000000002}', "");
    Expect(1, 3891, '\p{Nv=-60/120}', "");
    Expect(0, 3891, '\p{^Nv=-60/120}', "");
    Expect(0, 3891, '\P{Nv=-60/120}', "");
    Expect(1, 3891, '\P{^Nv=-60/120}', "");
    Expect(0, 3892, '\p{Nv=-60/120}', "");
    Expect(1, 3892, '\p{^Nv=-60/120}', "");
    Expect(1, 3892, '\P{Nv=-60/120}', "");
    Expect(0, 3892, '\P{^Nv=-60/120}', "");
    Expect(1, 3891, '\p{Nv=-5.0e-01}', "");
    Expect(0, 3891, '\p{^Nv=-5.0e-01}', "");
    Expect(0, 3891, '\P{Nv=-5.0e-01}', "");
    Expect(1, 3891, '\P{^Nv=-5.0e-01}', "");
    Expect(0, 3892, '\p{Nv=-5.0e-01}', "");
    Expect(1, 3892, '\p{^Nv=-5.0e-01}', "");
    Expect(1, 3892, '\P{Nv=-5.0e-01}', "");
    Expect(0, 3892, '\P{^Nv=-5.0e-01}', "");
    Expect(1, 3891, '\p{Nv=-0.5}', "");
    Expect(0, 3891, '\p{^Nv=-0.5}', "");
    Expect(0, 3891, '\P{Nv=-0.5}', "");
    Expect(1, 3891, '\P{^Nv=-0.5}', "");
    Expect(0, 3892, '\p{Nv=-0.5}', "");
    Expect(1, 3892, '\p{^Nv=-0.5}', "");
    Expect(1, 3892, '\P{Nv=-0.5}', "");
    Expect(0, 3892, '\P{^Nv=-0.5}', "");
    Expect(1, 3891, '\p{Nv=-5.00e-01}', "");
    Expect(0, 3891, '\p{^Nv=-5.00e-01}', "");
    Expect(0, 3891, '\P{Nv=-5.00e-01}', "");
    Expect(1, 3891, '\P{^Nv=-5.00e-01}', "");
    Expect(0, 3892, '\p{Nv=-5.00e-01}', "");
    Expect(1, 3892, '\p{^Nv=-5.00e-01}', "");
    Expect(1, 3892, '\P{Nv=-5.00e-01}', "");
    Expect(0, 3892, '\P{^Nv=-5.00e-01}', "");
    Expect(1, 3891, '\p{Nv=-0.50}', "");
    Expect(0, 3891, '\p{^Nv=-0.50}', "");
    Expect(0, 3891, '\P{Nv=-0.50}', "");
    Expect(1, 3891, '\P{^Nv=-0.50}', "");
    Expect(0, 3892, '\p{Nv=-0.50}', "");
    Expect(1, 3892, '\p{^Nv=-0.50}', "");
    Expect(1, 3892, '\P{Nv=-0.50}', "");
    Expect(0, 3892, '\P{^Nv=-0.50}', "");
    Error('\p{Is_Numeric_Value=- -00000001/0002:=}');
    Error('\P{Is_Numeric_Value=- -00000001/0002:=}');
    Expect(1, 3891, '\p{Is_Numeric_Value=-000000001/0000000002}', "");
    Expect(0, 3891, '\p{^Is_Numeric_Value=-000000001/0000000002}', "");
    Expect(0, 3891, '\P{Is_Numeric_Value=-000000001/0000000002}', "");
    Expect(1, 3891, '\P{^Is_Numeric_Value=-000000001/0000000002}', "");
    Expect(0, 3892, '\p{Is_Numeric_Value=-000000001/0000000002}', "");
    Expect(1, 3892, '\p{^Is_Numeric_Value=-000000001/0000000002}', "");
    Expect(1, 3892, '\P{Is_Numeric_Value=-000000001/0000000002}', "");
    Expect(0, 3892, '\P{^Is_Numeric_Value=-000000001/0000000002}', "");
    Expect(1, 3891, '\p{Is_Numeric_Value=-60/120}', "");
    Expect(0, 3891, '\p{^Is_Numeric_Value=-60/120}', "");
    Expect(0, 3891, '\P{Is_Numeric_Value=-60/120}', "");
    Expect(1, 3891, '\P{^Is_Numeric_Value=-60/120}', "");
    Expect(0, 3892, '\p{Is_Numeric_Value=-60/120}', "");
    Expect(1, 3892, '\p{^Is_Numeric_Value=-60/120}', "");
    Expect(1, 3892, '\P{Is_Numeric_Value=-60/120}', "");
    Expect(0, 3892, '\P{^Is_Numeric_Value=-60/120}', "");
    Expect(1, 3891, '\p{Is_Numeric_Value=-5.0e-01}', "");
    Expect(0, 3891, '\p{^Is_Numeric_Value=-5.0e-01}', "");
    Expect(0, 3891, '\P{Is_Numeric_Value=-5.0e-01}', "");
    Expect(1, 3891, '\P{^Is_Numeric_Value=-5.0e-01}', "");
    Expect(0, 3892, '\p{Is_Numeric_Value=-5.0e-01}', "");
    Expect(1, 3892, '\p{^Is_Numeric_Value=-5.0e-01}', "");
    Expect(1, 3892, '\P{Is_Numeric_Value=-5.0e-01}', "");
    Expect(0, 3892, '\P{^Is_Numeric_Value=-5.0e-01}', "");
    Expect(1, 3891, '\p{Is_Numeric_Value=-0.5}', "");
    Expect(0, 3891, '\p{^Is_Numeric_Value=-0.5}', "");
    Expect(0, 3891, '\P{Is_Numeric_Value=-0.5}', "");
    Expect(1, 3891, '\P{^Is_Numeric_Value=-0.5}', "");
    Expect(0, 3892, '\p{Is_Numeric_Value=-0.5}', "");
    Expect(1, 3892, '\p{^Is_Numeric_Value=-0.5}', "");
    Expect(1, 3892, '\P{Is_Numeric_Value=-0.5}', "");
    Expect(0, 3892, '\P{^Is_Numeric_Value=-0.5}', "");
    Expect(1, 3891, '\p{Is_Numeric_Value=-5.00e-01}', "");
    Expect(0, 3891, '\p{^Is_Numeric_Value=-5.00e-01}', "");
    Expect(0, 3891, '\P{Is_Numeric_Value=-5.00e-01}', "");
    Expect(1, 3891, '\P{^Is_Numeric_Value=-5.00e-01}', "");
    Expect(0, 3892, '\p{Is_Numeric_Value=-5.00e-01}', "");
    Expect(1, 3892, '\p{^Is_Numeric_Value=-5.00e-01}', "");
    Expect(1, 3892, '\P{Is_Numeric_Value=-5.00e-01}', "");
    Expect(0, 3892, '\P{^Is_Numeric_Value=-5.00e-01}', "");
    Expect(1, 3891, '\p{Is_Numeric_Value=-0.50}', "");
    Expect(0, 3891, '\p{^Is_Numeric_Value=-0.50}', "");
    Expect(0, 3891, '\P{Is_Numeric_Value=-0.50}', "");
    Expect(1, 3891, '\P{^Is_Numeric_Value=-0.50}', "");
    Expect(0, 3892, '\p{Is_Numeric_Value=-0.50}', "");
    Expect(1, 3892, '\p{^Is_Numeric_Value=-0.50}', "");
    Expect(1, 3892, '\P{Is_Numeric_Value=-0.50}', "");
    Expect(0, 3892, '\P{^Is_Numeric_Value=-0.50}', "");
    Error('\p{Is_Nv=_ -00001/0002:=}');
    Error('\P{Is_Nv=_ -00001/0002:=}');
    Expect(1, 3891, '\p{Is_Nv=-0000001/000002}', "");
    Expect(0, 3891, '\p{^Is_Nv=-0000001/000002}', "");
    Expect(0, 3891, '\P{Is_Nv=-0000001/000002}', "");
    Expect(1, 3891, '\P{^Is_Nv=-0000001/000002}', "");
    Expect(0, 3892, '\p{Is_Nv=-0000001/000002}', "");
    Expect(1, 3892, '\p{^Is_Nv=-0000001/000002}', "");
    Expect(1, 3892, '\P{Is_Nv=-0000001/000002}', "");
    Expect(0, 3892, '\P{^Is_Nv=-0000001/000002}', "");
    Expect(1, 3891, '\p{Is_Nv=-60/120}', "");
    Expect(0, 3891, '\p{^Is_Nv=-60/120}', "");
    Expect(0, 3891, '\P{Is_Nv=-60/120}', "");
    Expect(1, 3891, '\P{^Is_Nv=-60/120}', "");
    Expect(0, 3892, '\p{Is_Nv=-60/120}', "");
    Expect(1, 3892, '\p{^Is_Nv=-60/120}', "");
    Expect(1, 3892, '\P{Is_Nv=-60/120}', "");
    Expect(0, 3892, '\P{^Is_Nv=-60/120}', "");
    Expect(1, 3891, '\p{Is_Nv=-5.0e-01}', "");
    Expect(0, 3891, '\p{^Is_Nv=-5.0e-01}', "");
    Expect(0, 3891, '\P{Is_Nv=-5.0e-01}', "");
    Expect(1, 3891, '\P{^Is_Nv=-5.0e-01}', "");
    Expect(0, 3892, '\p{Is_Nv=-5.0e-01}', "");
    Expect(1, 3892, '\p{^Is_Nv=-5.0e-01}', "");
    Expect(1, 3892, '\P{Is_Nv=-5.0e-01}', "");
    Expect(0, 3892, '\P{^Is_Nv=-5.0e-01}', "");
    Expect(1, 3891, '\p{Is_Nv=-0.5}', "");
    Expect(0, 3891, '\p{^Is_Nv=-0.5}', "");
    Expect(0, 3891, '\P{Is_Nv=-0.5}', "");
    Expect(1, 3891, '\P{^Is_Nv=-0.5}', "");
    Expect(0, 3892, '\p{Is_Nv=-0.5}', "");
    Expect(1, 3892, '\p{^Is_Nv=-0.5}', "");
    Expect(1, 3892, '\P{Is_Nv=-0.5}', "");
    Expect(0, 3892, '\P{^Is_Nv=-0.5}', "");
    Expect(1, 3891, '\p{Is_Nv:	-5.00e-01}', "");
    Expect(0, 3891, '\p{^Is_Nv:	-5.00e-01}', "");
    Expect(0, 3891, '\P{Is_Nv:	-5.00e-01}', "");
    Expect(1, 3891, '\P{^Is_Nv:	-5.00e-01}', "");
    Expect(0, 3892, '\p{Is_Nv:	-5.00e-01}', "");
    Expect(1, 3892, '\p{^Is_Nv:	-5.00e-01}', "");
    Expect(1, 3892, '\P{Is_Nv:	-5.00e-01}', "");
    Expect(0, 3892, '\P{^Is_Nv:	-5.00e-01}', "");
    Expect(1, 3891, '\p{Is_Nv=-0.50}', "");
    Expect(0, 3891, '\p{^Is_Nv=-0.50}', "");
    Expect(0, 3891, '\P{Is_Nv=-0.50}', "");
    Expect(1, 3891, '\P{^Is_Nv=-0.50}', "");
    Expect(0, 3892, '\p{Is_Nv=-0.50}', "");
    Expect(1, 3892, '\p{^Is_Nv=-0.50}', "");
    Expect(1, 3892, '\P{Is_Nv=-0.50}', "");
    Expect(0, 3892, '\P{^Is_Nv=-0.50}', "");
    Error('\p{Numeric_Value=-000000000:=}');
    Error('\P{Numeric_Value=-000000000:=}');
    Expect(1, 130032, '\p{Numeric_Value=:\A0\z:}', "");;
    Expect(0, 130033, '\p{Numeric_Value=:\A0\z:}', "");;
    Expect(1, 130032, '\p{Numeric_Value=000}', "");
    Expect(0, 130032, '\p{^Numeric_Value=000}', "");
    Expect(0, 130032, '\P{Numeric_Value=000}', "");
    Expect(1, 130032, '\P{^Numeric_Value=000}', "");
    Expect(0, 130033, '\p{Numeric_Value=000}', "");
    Expect(1, 130033, '\p{^Numeric_Value=000}', "");
    Expect(1, 130033, '\P{Numeric_Value=000}', "");
    Expect(0, 130033, '\P{^Numeric_Value=000}', "");
    Expect(1, 130032, '\p{Numeric_Value=0.000000000000000e+00}', "");
    Expect(0, 130032, '\p{^Numeric_Value=0.000000000000000e+00}', "");
    Expect(0, 130032, '\P{Numeric_Value=0.000000000000000e+00}', "");
    Expect(1, 130032, '\P{^Numeric_Value=0.000000000000000e+00}', "");
    Expect(0, 130033, '\p{Numeric_Value=0.000000000000000e+00}', "");
    Expect(1, 130033, '\p{^Numeric_Value=0.000000000000000e+00}', "");
    Expect(1, 130033, '\P{Numeric_Value=0.000000000000000e+00}', "");
    Expect(0, 130033, '\P{^Numeric_Value=0.000000000000000e+00}', "");
    Error('\p{Nv:	_-+00_00_00_00_00:=}');
    Error('\P{Nv:	_-+00_00_00_00_00:=}');
    Expect(1, 130032, '\p{Nv=:\A0\z:}', "");;
    Expect(0, 130033, '\p{Nv=:\A0\z:}', "");;
    Expect(1, 130032, '\p{Nv=+0000}', "");
    Expect(0, 130032, '\p{^Nv=+0000}', "");
    Expect(0, 130032, '\P{Nv=+0000}', "");
    Expect(1, 130032, '\P{^Nv=+0000}', "");
    Expect(0, 130033, '\p{Nv=+0000}', "");
    Expect(1, 130033, '\p{^Nv=+0000}', "");
    Expect(1, 130033, '\P{Nv=+0000}', "");
    Expect(0, 130033, '\P{^Nv=+0000}', "");
    Expect(1, 130032, '\p{Nv=0.000000000000000e+00}', "");
    Expect(0, 130032, '\p{^Nv=0.000000000000000e+00}', "");
    Expect(0, 130032, '\P{Nv=0.000000000000000e+00}', "");
    Expect(1, 130032, '\P{^Nv=0.000000000000000e+00}', "");
    Expect(0, 130033, '\p{Nv=0.000000000000000e+00}', "");
    Expect(1, 130033, '\p{^Nv=0.000000000000000e+00}', "");
    Expect(1, 130033, '\P{Nv=0.000000000000000e+00}', "");
    Expect(0, 130033, '\P{^Nv=0.000000000000000e+00}', "");
    Error('\p{Is_Numeric_Value=_ 000_0:=}');
    Error('\P{Is_Numeric_Value=_ 000_0:=}');
    Expect(1, 130032, '\p{Is_Numeric_Value=0_0_0_0_0_0_0_000}', "");
    Expect(0, 130032, '\p{^Is_Numeric_Value=0_0_0_0_0_0_0_000}', "");
    Expect(0, 130032, '\P{Is_Numeric_Value=0_0_0_0_0_0_0_000}', "");
    Expect(1, 130032, '\P{^Is_Numeric_Value=0_0_0_0_0_0_0_000}', "");
    Expect(0, 130033, '\p{Is_Numeric_Value=0_0_0_0_0_0_0_000}', "");
    Expect(1, 130033, '\p{^Is_Numeric_Value=0_0_0_0_0_0_0_000}', "");
    Expect(1, 130033, '\P{Is_Numeric_Value=0_0_0_0_0_0_0_000}', "");
    Expect(0, 130033, '\P{^Is_Numeric_Value=0_0_0_0_0_0_0_000}', "");
    Expect(1, 130032, '\p{Is_Numeric_Value=0.000000000000000e+00}', "");
    Expect(0, 130032, '\p{^Is_Numeric_Value=0.000000000000000e+00}', "");
    Expect(0, 130032, '\P{Is_Numeric_Value=0.000000000000000e+00}', "");
    Expect(1, 130032, '\P{^Is_Numeric_Value=0.000000000000000e+00}', "");
    Expect(0, 130033, '\p{Is_Numeric_Value=0.000000000000000e+00}', "");
    Expect(1, 130033, '\p{^Is_Numeric_Value=0.000000000000000e+00}', "");
    Expect(1, 130033, '\P{Is_Numeric_Value=0.000000000000000e+00}', "");
    Expect(0, 130033, '\P{^Is_Numeric_Value=0.000000000000000e+00}', "");
    Error('\p{Is_Nv=-0000000000/a/}');
    Error('\P{Is_Nv=-0000000000/a/}');
    Expect(1, 130032, '\p{Is_Nv=+00000}', "");
    Expect(0, 130032, '\p{^Is_Nv=+00000}', "");
    Expect(0, 130032, '\P{Is_Nv=+00000}', "");
    Expect(1, 130032, '\P{^Is_Nv=+00000}', "");
    Expect(0, 130033, '\p{Is_Nv=+00000}', "");
    Expect(1, 130033, '\p{^Is_Nv=+00000}', "");
    Expect(1, 130033, '\P{Is_Nv=+00000}', "");
    Expect(0, 130033, '\P{^Is_Nv=+00000}', "");
    Expect(1, 130032, '\p{Is_Nv=0.000000000000000e+00}', "");
    Expect(0, 130032, '\p{^Is_Nv=0.000000000000000e+00}', "");
    Expect(0, 130032, '\P{Is_Nv=0.000000000000000e+00}', "");
    Expect(1, 130032, '\P{^Is_Nv=0.000000000000000e+00}', "");
    Expect(0, 130033, '\p{Is_Nv=0.000000000000000e+00}', "");
    Expect(1, 130033, '\p{^Is_Nv=0.000000000000000e+00}', "");
    Expect(1, 130033, '\P{Is_Nv=0.000000000000000e+00}', "");
    Expect(0, 130033, '\P{^Is_Nv=0.000000000000000e+00}', "");
    Error('\p{Numeric_Value=:=- 00001}');
    Error('\P{Numeric_Value=:=- 00001}');
    Expect(1, 133418, '\p{Numeric_Value=:\A1\z:}', "");;
    Expect(0, 133419, '\p{Numeric_Value=:\A1\z:}', "");;
    Expect(1, 133418, '\p{Numeric_Value=0_1}', "");
    Expect(0, 133418, '\p{^Numeric_Value=0_1}', "");
    Expect(0, 133418, '\P{Numeric_Value=0_1}', "");
    Expect(1, 133418, '\P{^Numeric_Value=0_1}', "");
    Expect(0, 133419, '\p{Numeric_Value=0_1}', "");
    Expect(1, 133419, '\p{^Numeric_Value=0_1}', "");
    Expect(1, 133419, '\P{Numeric_Value=0_1}', "");
    Expect(0, 133419, '\P{^Numeric_Value=0_1}', "");
    Expect(1, 133418, '\p{Numeric_Value=1.000000000000000e+00}', "");
    Expect(0, 133418, '\p{^Numeric_Value=1.000000000000000e+00}', "");
    Expect(0, 133418, '\P{Numeric_Value=1.000000000000000e+00}', "");
    Expect(1, 133418, '\P{^Numeric_Value=1.000000000000000e+00}', "");
    Expect(0, 133419, '\p{Numeric_Value=1.000000000000000e+00}', "");
    Expect(1, 133419, '\p{^Numeric_Value=1.000000000000000e+00}', "");
    Expect(1, 133419, '\P{Numeric_Value=1.000000000000000e+00}', "");
    Expect(0, 133419, '\P{^Numeric_Value=1.000000000000000e+00}', "");
    Error('\p{Nv=_0000000_1/a/}');
    Error('\P{Nv=_0000000_1/a/}');
    Expect(1, 133418, '\p{Nv=:\A1\z:}', "");;
    Expect(0, 133419, '\p{Nv=:\A1\z:}', "");;
    Expect(1, 133418, '\p{Nv=001}', "");
    Expect(0, 133418, '\p{^Nv=001}', "");
    Expect(0, 133418, '\P{Nv=001}', "");
    Expect(1, 133418, '\P{^Nv=001}', "");
    Expect(0, 133419, '\p{Nv=001}', "");
    Expect(1, 133419, '\p{^Nv=001}', "");
    Expect(1, 133419, '\P{Nv=001}', "");
    Expect(0, 133419, '\P{^Nv=001}', "");
    Expect(1, 133418, '\p{Nv=1.000000000000000e+00}', "");
    Expect(0, 133418, '\p{^Nv=1.000000000000000e+00}', "");
    Expect(0, 133418, '\P{Nv=1.000000000000000e+00}', "");
    Expect(1, 133418, '\P{^Nv=1.000000000000000e+00}', "");
    Expect(0, 133419, '\p{Nv=1.000000000000000e+00}', "");
    Expect(1, 133419, '\p{^Nv=1.000000000000000e+00}', "");
    Expect(1, 133419, '\P{Nv=1.000000000000000e+00}', "");
    Expect(0, 133419, '\P{^Nv=1.000000000000000e+00}', "");
    Error('\p{Is_Numeric_Value=		+000_000_01/a/}');
    Error('\P{Is_Numeric_Value=		+000_000_01/a/}');
    Expect(1, 133418, '\p{Is_Numeric_Value=1}', "");
    Expect(0, 133418, '\p{^Is_Numeric_Value=1}', "");
    Expect(0, 133418, '\P{Is_Numeric_Value=1}', "");
    Expect(1, 133418, '\P{^Is_Numeric_Value=1}', "");
    Expect(0, 133419, '\p{Is_Numeric_Value=1}', "");
    Expect(1, 133419, '\p{^Is_Numeric_Value=1}', "");
    Expect(1, 133419, '\P{Is_Numeric_Value=1}', "");
    Expect(0, 133419, '\P{^Is_Numeric_Value=1}', "");
    Expect(1, 133418, '\p{Is_Numeric_Value=1.000000000000000e+00}', "");
    Expect(0, 133418, '\p{^Is_Numeric_Value=1.000000000000000e+00}', "");
    Expect(0, 133418, '\P{Is_Numeric_Value=1.000000000000000e+00}', "");
    Expect(1, 133418, '\P{^Is_Numeric_Value=1.000000000000000e+00}', "");
    Expect(0, 133419, '\p{Is_Numeric_Value=1.000000000000000e+00}', "");
    Expect(1, 133419, '\p{^Is_Numeric_Value=1.000000000000000e+00}', "");
    Expect(1, 133419, '\P{Is_Numeric_Value=1.000000000000000e+00}', "");
    Expect(0, 133419, '\P{^Is_Numeric_Value=1.000000000000000e+00}', "");
    Error('\p{Is_Nv=_:=000001}');
    Error('\P{Is_Nv=_:=000001}');
    Expect(1, 133418, '\p{Is_Nv=00000_1}', "");
    Expect(0, 133418, '\p{^Is_Nv=00000_1}', "");
    Expect(0, 133418, '\P{Is_Nv=00000_1}', "");
    Expect(1, 133418, '\P{^Is_Nv=00000_1}', "");
    Expect(0, 133419, '\p{Is_Nv=00000_1}', "");
    Expect(1, 133419, '\p{^Is_Nv=00000_1}', "");
    Expect(1, 133419, '\P{Is_Nv=00000_1}', "");
    Expect(0, 133419, '\P{^Is_Nv=00000_1}', "");
    Expect(1, 133418, '\p{Is_Nv=1.000000000000000e+00}', "");
    Expect(0, 133418, '\p{^Is_Nv=1.000000000000000e+00}', "");
    Expect(0, 133418, '\P{Is_Nv=1.000000000000000e+00}', "");
    Expect(1, 133418, '\P{^Is_Nv=1.000000000000000e+00}', "");
    Expect(0, 133419, '\p{Is_Nv=1.000000000000000e+00}', "");
    Expect(1, 133419, '\p{^Is_Nv=1.000000000000000e+00}', "");
    Expect(1, 133419, '\P{Is_Nv=1.000000000000000e+00}', "");
    Expect(0, 133419, '\P{^Is_Nv=1.000000000000000e+00}', "");
    Error('\p{Numeric_Value=_/a/+00000001/0010}');
    Error('\P{Numeric_Value=_/a/+00000001/0010}');
    Expect(1, 73675, '\p{Numeric_Value=:\A1/10\z:}', "");;
    Expect(0, 73676, '\p{Numeric_Value=:\A1/10\z:}', "");;
    Expect(1, 73675, '\p{Numeric_Value=00000001/0010}', "");
    Expect(0, 73675, '\p{^Numeric_Value=00000001/0010}', "");
    Expect(0, 73675, '\P{Numeric_Value=00000001/0010}', "");
    Expect(1, 73675, '\P{^Numeric_Value=00000001/0010}', "");
    Expect(0, 73676, '\p{Numeric_Value=00000001/0010}', "");
    Expect(1, 73676, '\p{^Numeric_Value=00000001/0010}', "");
    Expect(1, 73676, '\P{Numeric_Value=00000001/0010}', "");
    Expect(0, 73676, '\P{^Numeric_Value=00000001/0010}', "");
    Expect(1, 73675, '\p{Numeric_Value=60/600}', "");
    Expect(0, 73675, '\p{^Numeric_Value=60/600}', "");
    Expect(0, 73675, '\P{Numeric_Value=60/600}', "");
    Expect(1, 73675, '\P{^Numeric_Value=60/600}', "");
    Expect(0, 73676, '\p{Numeric_Value=60/600}', "");
    Expect(1, 73676, '\p{^Numeric_Value=60/600}', "");
    Expect(1, 73676, '\P{Numeric_Value=60/600}', "");
    Expect(0, 73676, '\P{^Numeric_Value=60/600}', "");
    Expect(1, 73675, '\p{Numeric_Value=1.0e-01}', "");
    Expect(0, 73675, '\p{^Numeric_Value=1.0e-01}', "");
    Expect(0, 73675, '\P{Numeric_Value=1.0e-01}', "");
    Expect(1, 73675, '\P{^Numeric_Value=1.0e-01}', "");
    Expect(0, 73676, '\p{Numeric_Value=1.0e-01}', "");
    Expect(1, 73676, '\p{^Numeric_Value=1.0e-01}', "");
    Expect(1, 73676, '\P{Numeric_Value=1.0e-01}', "");
    Expect(0, 73676, '\P{^Numeric_Value=1.0e-01}', "");
    Expect(1, 73675, '\p{Numeric_Value=0.1}', "");
    Expect(0, 73675, '\p{^Numeric_Value=0.1}', "");
    Expect(0, 73675, '\P{Numeric_Value=0.1}', "");
    Expect(1, 73675, '\P{^Numeric_Value=0.1}', "");
    Expect(0, 73676, '\p{Numeric_Value=0.1}', "");
    Expect(1, 73676, '\p{^Numeric_Value=0.1}', "");
    Expect(1, 73676, '\P{Numeric_Value=0.1}', "");
    Expect(0, 73676, '\P{^Numeric_Value=0.1}', "");
    Expect(1, 73675, '\p{Numeric_Value=1.00e-01}', "");
    Expect(0, 73675, '\p{^Numeric_Value=1.00e-01}', "");
    Expect(0, 73675, '\P{Numeric_Value=1.00e-01}', "");
    Expect(1, 73675, '\P{^Numeric_Value=1.00e-01}', "");
    Expect(0, 73676, '\p{Numeric_Value=1.00e-01}', "");
    Expect(1, 73676, '\p{^Numeric_Value=1.00e-01}', "");
    Expect(1, 73676, '\P{Numeric_Value=1.00e-01}', "");
    Expect(0, 73676, '\P{^Numeric_Value=1.00e-01}', "");
    Expect(1, 73675, '\p{Numeric_Value=0.10}', "");
    Expect(0, 73675, '\p{^Numeric_Value=0.10}', "");
    Expect(0, 73675, '\P{Numeric_Value=0.10}', "");
    Expect(1, 73675, '\P{^Numeric_Value=0.10}', "");
    Expect(0, 73676, '\p{Numeric_Value=0.10}', "");
    Expect(1, 73676, '\p{^Numeric_Value=0.10}', "");
    Expect(1, 73676, '\P{Numeric_Value=0.10}', "");
    Expect(0, 73676, '\P{^Numeric_Value=0.10}', "");
    Error('\p{Nv=_00001/0000010:=}');
    Error('\P{Nv=_00001/0000010:=}');
    Expect(1, 73675, '\p{Nv=:\A1/10\z:}', "");;
    Expect(0, 73676, '\p{Nv=:\A1/10\z:}', "");;
    Expect(1, 73675, '\p{Nv=00001/10}', "");
    Expect(0, 73675, '\p{^Nv=00001/10}', "");
    Expect(0, 73675, '\P{Nv=00001/10}', "");
    Expect(1, 73675, '\P{^Nv=00001/10}', "");
    Expect(0, 73676, '\p{Nv=00001/10}', "");
    Expect(1, 73676, '\p{^Nv=00001/10}', "");
    Expect(1, 73676, '\P{Nv=00001/10}', "");
    Expect(0, 73676, '\P{^Nv=00001/10}', "");
    Expect(1, 73675, '\p{Nv=60/600}', "");
    Expect(0, 73675, '\p{^Nv=60/600}', "");
    Expect(0, 73675, '\P{Nv=60/600}', "");
    Expect(1, 73675, '\P{^Nv=60/600}', "");
    Expect(0, 73676, '\p{Nv=60/600}', "");
    Expect(1, 73676, '\p{^Nv=60/600}', "");
    Expect(1, 73676, '\P{Nv=60/600}', "");
    Expect(0, 73676, '\P{^Nv=60/600}', "");
    Expect(1, 73675, '\p{Nv=1.0e-01}', "");
    Expect(0, 73675, '\p{^Nv=1.0e-01}', "");
    Expect(0, 73675, '\P{Nv=1.0e-01}', "");
    Expect(1, 73675, '\P{^Nv=1.0e-01}', "");
    Expect(0, 73676, '\p{Nv=1.0e-01}', "");
    Expect(1, 73676, '\p{^Nv=1.0e-01}', "");
    Expect(1, 73676, '\P{Nv=1.0e-01}', "");
    Expect(0, 73676, '\P{^Nv=1.0e-01}', "");
    Expect(1, 73675, '\p{Nv=0.1}', "");
    Expect(0, 73675, '\p{^Nv=0.1}', "");
    Expect(0, 73675, '\P{Nv=0.1}', "");
    Expect(1, 73675, '\P{^Nv=0.1}', "");
    Expect(0, 73676, '\p{Nv=0.1}', "");
    Expect(1, 73676, '\p{^Nv=0.1}', "");
    Expect(1, 73676, '\P{Nv=0.1}', "");
    Expect(0, 73676, '\P{^Nv=0.1}', "");
    Expect(1, 73675, '\p{Nv=1.00e-01}', "");
    Expect(0, 73675, '\p{^Nv=1.00e-01}', "");
    Expect(0, 73675, '\P{Nv=1.00e-01}', "");
    Expect(1, 73675, '\P{^Nv=1.00e-01}', "");
    Expect(0, 73676, '\p{Nv=1.00e-01}', "");
    Expect(1, 73676, '\p{^Nv=1.00e-01}', "");
    Expect(1, 73676, '\P{Nv=1.00e-01}', "");
    Expect(0, 73676, '\P{^Nv=1.00e-01}', "");
    Expect(1, 73675, '\p{Nv=0.10}', "");
    Expect(0, 73675, '\p{^Nv=0.10}', "");
    Expect(0, 73675, '\P{Nv=0.10}', "");
    Expect(1, 73675, '\P{^Nv=0.10}', "");
    Expect(0, 73676, '\p{Nv=0.10}', "");
    Expect(1, 73676, '\p{^Nv=0.10}', "");
    Expect(1, 73676, '\P{Nv=0.10}', "");
    Expect(0, 73676, '\P{^Nv=0.10}', "");
    Error('\p{Is_Numeric_Value=	/a/0000001/0010}');
    Error('\P{Is_Numeric_Value=	/a/0000001/0010}');
    Expect(1, 73675, '\p{Is_Numeric_Value=0000000001/00010}', "");
    Expect(0, 73675, '\p{^Is_Numeric_Value=0000000001/00010}', "");
    Expect(0, 73675, '\P{Is_Numeric_Value=0000000001/00010}', "");
    Expect(1, 73675, '\P{^Is_Numeric_Value=0000000001/00010}', "");
    Expect(0, 73676, '\p{Is_Numeric_Value=0000000001/00010}', "");
    Expect(1, 73676, '\p{^Is_Numeric_Value=0000000001/00010}', "");
    Expect(1, 73676, '\P{Is_Numeric_Value=0000000001/00010}', "");
    Expect(0, 73676, '\P{^Is_Numeric_Value=0000000001/00010}', "");
    Expect(1, 73675, '\p{Is_Numeric_Value=60/600}', "");
    Expect(0, 73675, '\p{^Is_Numeric_Value=60/600}', "");
    Expect(0, 73675, '\P{Is_Numeric_Value=60/600}', "");
    Expect(1, 73675, '\P{^Is_Numeric_Value=60/600}', "");
    Expect(0, 73676, '\p{Is_Numeric_Value=60/600}', "");
    Expect(1, 73676, '\p{^Is_Numeric_Value=60/600}', "");
    Expect(1, 73676, '\P{Is_Numeric_Value=60/600}', "");
    Expect(0, 73676, '\P{^Is_Numeric_Value=60/600}', "");
    Expect(1, 73675, '\p{Is_Numeric_Value=1.0e-01}', "");
    Expect(0, 73675, '\p{^Is_Numeric_Value=1.0e-01}', "");
    Expect(0, 73675, '\P{Is_Numeric_Value=1.0e-01}', "");
    Expect(1, 73675, '\P{^Is_Numeric_Value=1.0e-01}', "");
    Expect(0, 73676, '\p{Is_Numeric_Value=1.0e-01}', "");
    Expect(1, 73676, '\p{^Is_Numeric_Value=1.0e-01}', "");
    Expect(1, 73676, '\P{Is_Numeric_Value=1.0e-01}', "");
    Expect(0, 73676, '\P{^Is_Numeric_Value=1.0e-01}', "");
    Expect(1, 73675, '\p{Is_Numeric_Value=0.1}', "");
    Expect(0, 73675, '\p{^Is_Numeric_Value=0.1}', "");
    Expect(0, 73675, '\P{Is_Numeric_Value=0.1}', "");
    Expect(1, 73675, '\P{^Is_Numeric_Value=0.1}', "");
    Expect(0, 73676, '\p{Is_Numeric_Value=0.1}', "");
    Expect(1, 73676, '\p{^Is_Numeric_Value=0.1}', "");
    Expect(1, 73676, '\P{Is_Numeric_Value=0.1}', "");
    Expect(0, 73676, '\P{^Is_Numeric_Value=0.1}', "");
    Expect(1, 73675, '\p{Is_Numeric_Value=1.00e-01}', "");
    Expect(0, 73675, '\p{^Is_Numeric_Value=1.00e-01}', "");
    Expect(0, 73675, '\P{Is_Numeric_Value=1.00e-01}', "");
    Expect(1, 73675, '\P{^Is_Numeric_Value=1.00e-01}', "");
    Expect(0, 73676, '\p{Is_Numeric_Value=1.00e-01}', "");
    Expect(1, 73676, '\p{^Is_Numeric_Value=1.00e-01}', "");
    Expect(1, 73676, '\P{Is_Numeric_Value=1.00e-01}', "");
    Expect(0, 73676, '\P{^Is_Numeric_Value=1.00e-01}', "");
    Expect(1, 73675, '\p{Is_Numeric_Value=0.10}', "");
    Expect(0, 73675, '\p{^Is_Numeric_Value=0.10}', "");
    Expect(0, 73675, '\P{Is_Numeric_Value=0.10}', "");
    Expect(1, 73675, '\P{^Is_Numeric_Value=0.10}', "");
    Expect(0, 73676, '\p{Is_Numeric_Value=0.10}', "");
    Expect(1, 73676, '\p{^Is_Numeric_Value=0.10}', "");
    Expect(1, 73676, '\P{Is_Numeric_Value=0.10}', "");
    Expect(0, 73676, '\P{^Is_Numeric_Value=0.10}', "");
    Error('\p{Is_Nv:-	00000001/0010:=}');
    Error('\P{Is_Nv:-	00000001/0010:=}');
    Expect(1, 73675, '\p{Is_Nv=001/000010}', "");
    Expect(0, 73675, '\p{^Is_Nv=001/000010}', "");
    Expect(0, 73675, '\P{Is_Nv=001/000010}', "");
    Expect(1, 73675, '\P{^Is_Nv=001/000010}', "");
    Expect(0, 73676, '\p{Is_Nv=001/000010}', "");
    Expect(1, 73676, '\p{^Is_Nv=001/000010}', "");
    Expect(1, 73676, '\P{Is_Nv=001/000010}', "");
    Expect(0, 73676, '\P{^Is_Nv=001/000010}', "");
    Expect(1, 73675, '\p{Is_Nv=60/600}', "");
    Expect(0, 73675, '\p{^Is_Nv=60/600}', "");
    Expect(0, 73675, '\P{Is_Nv=60/600}', "");
    Expect(1, 73675, '\P{^Is_Nv=60/600}', "");
    Expect(0, 73676, '\p{Is_Nv=60/600}', "");
    Expect(1, 73676, '\p{^Is_Nv=60/600}', "");
    Expect(1, 73676, '\P{Is_Nv=60/600}', "");
    Expect(0, 73676, '\P{^Is_Nv=60/600}', "");
    Expect(1, 73675, '\p{Is_Nv=1.0e-01}', "");
    Expect(0, 73675, '\p{^Is_Nv=1.0e-01}', "");
    Expect(0, 73675, '\P{Is_Nv=1.0e-01}', "");
    Expect(1, 73675, '\P{^Is_Nv=1.0e-01}', "");
    Expect(0, 73676, '\p{Is_Nv=1.0e-01}', "");
    Expect(1, 73676, '\p{^Is_Nv=1.0e-01}', "");
    Expect(1, 73676, '\P{Is_Nv=1.0e-01}', "");
    Expect(0, 73676, '\P{^Is_Nv=1.0e-01}', "");
    Expect(1, 73675, '\p{Is_Nv=0.1}', "");
    Expect(0, 73675, '\p{^Is_Nv=0.1}', "");
    Expect(0, 73675, '\P{Is_Nv=0.1}', "");
    Expect(1, 73675, '\P{^Is_Nv=0.1}', "");
    Expect(0, 73676, '\p{Is_Nv=0.1}', "");
    Expect(1, 73676, '\p{^Is_Nv=0.1}', "");
    Expect(1, 73676, '\P{Is_Nv=0.1}', "");
    Expect(0, 73676, '\P{^Is_Nv=0.1}', "");
    Expect(1, 73675, '\p{Is_Nv=1.00e-01}', "");
    Expect(0, 73675, '\p{^Is_Nv=1.00e-01}', "");
    Expect(0, 73675, '\P{Is_Nv=1.00e-01}', "");
    Expect(1, 73675, '\P{^Is_Nv=1.00e-01}', "");
    Expect(0, 73676, '\p{Is_Nv=1.00e-01}', "");
    Expect(1, 73676, '\p{^Is_Nv=1.00e-01}', "");
    Expect(1, 73676, '\P{Is_Nv=1.00e-01}', "");
    Expect(0, 73676, '\P{^Is_Nv=1.00e-01}', "");
    Expect(1, 73675, '\p{Is_Nv=0.10}', "");
    Expect(0, 73675, '\p{^Is_Nv=0.10}', "");
    Expect(0, 73675, '\P{Is_Nv=0.10}', "");
    Expect(1, 73675, '\P{^Is_Nv=0.10}', "");
    Expect(0, 73676, '\p{Is_Nv=0.10}', "");
    Expect(1, 73676, '\p{^Is_Nv=0.10}', "");
    Expect(1, 73676, '\P{Is_Nv=0.10}', "");
    Expect(0, 73676, '\P{^Is_Nv=0.10}', "");
    Error('\p{Numeric_Value=:=_00001/00000000012}');
    Error('\P{Numeric_Value=:=_00001/00000000012}');
    Expect(1, 68086, '\p{Numeric_Value=:\A1/12\z:}', "");;
    Expect(0, 68087, '\p{Numeric_Value=:\A1/12\z:}', "");;
    Expect(1, 68086, '\p{Numeric_Value=+000000001/0012}', "");
    Expect(0, 68086, '\p{^Numeric_Value=+000000001/0012}', "");
    Expect(0, 68086, '\P{Numeric_Value=+000000001/0012}', "");
    Expect(1, 68086, '\P{^Numeric_Value=+000000001/0012}', "");
    Expect(0, 68087, '\p{Numeric_Value=+000000001/0012}', "");
    Expect(1, 68087, '\p{^Numeric_Value=+000000001/0012}', "");
    Expect(1, 68087, '\P{Numeric_Value=+000000001/0012}', "");
    Expect(0, 68087, '\P{^Numeric_Value=+000000001/0012}', "");
    Expect(1, 68086, '\p{Numeric_Value=60/720}', "");
    Expect(0, 68086, '\p{^Numeric_Value=60/720}', "");
    Expect(0, 68086, '\P{Numeric_Value=60/720}', "");
    Expect(1, 68086, '\P{^Numeric_Value=60/720}', "");
    Expect(0, 68087, '\p{Numeric_Value=60/720}', "");
    Expect(1, 68087, '\p{^Numeric_Value=60/720}', "");
    Expect(1, 68087, '\P{Numeric_Value=60/720}', "");
    Expect(0, 68087, '\P{^Numeric_Value=60/720}', "");
    Error('\p{Numeric_Value=8.3e-02}');
    Error('\P{Numeric_Value=8.3e-02}');
    Expect(1, 68086, '\p{Numeric_Value=8.33e-02}', "");
    Expect(0, 68086, '\p{^Numeric_Value=8.33e-02}', "");
    Expect(0, 68086, '\P{Numeric_Value=8.33e-02}', "");
    Expect(1, 68086, '\P{^Numeric_Value=8.33e-02}', "");
    Expect(0, 68087, '\p{Numeric_Value=8.33e-02}', "");
    Expect(1, 68087, '\p{^Numeric_Value=8.33e-02}', "");
    Expect(1, 68087, '\P{Numeric_Value=8.33e-02}', "");
    Expect(0, 68087, '\P{^Numeric_Value=8.33e-02}', "");
    Error('\p{Numeric_Value=0.08}');
    Error('\P{Numeric_Value=0.08}');
    Expect(1, 68086, '\p{Numeric_Value=8.333e-02}', "");
    Expect(0, 68086, '\p{^Numeric_Value=8.333e-02}', "");
    Expect(0, 68086, '\P{Numeric_Value=8.333e-02}', "");
    Expect(1, 68086, '\P{^Numeric_Value=8.333e-02}', "");
    Expect(0, 68087, '\p{Numeric_Value=8.333e-02}', "");
    Expect(1, 68087, '\p{^Numeric_Value=8.333e-02}', "");
    Expect(1, 68087, '\P{Numeric_Value=8.333e-02}', "");
    Expect(0, 68087, '\P{^Numeric_Value=8.333e-02}', "");
    Error('\p{Numeric_Value=0.083}');
    Error('\P{Numeric_Value=0.083}');
    Expect(1, 68086, '\p{Numeric_Value=8.3333e-02}', "");
    Expect(0, 68086, '\p{^Numeric_Value=8.3333e-02}', "");
    Expect(0, 68086, '\P{Numeric_Value=8.3333e-02}', "");
    Expect(1, 68086, '\P{^Numeric_Value=8.3333e-02}', "");
    Expect(0, 68087, '\p{Numeric_Value=8.3333e-02}', "");
    Expect(1, 68087, '\p{^Numeric_Value=8.3333e-02}', "");
    Expect(1, 68087, '\P{Numeric_Value=8.3333e-02}', "");
    Expect(0, 68087, '\P{^Numeric_Value=8.3333e-02}', "");
    Expect(1, 68086, '\p{Numeric_Value=0.0833}', "");
    Expect(0, 68086, '\p{^Numeric_Value=0.0833}', "");
    Expect(0, 68086, '\P{Numeric_Value=0.0833}', "");
    Expect(1, 68086, '\P{^Numeric_Value=0.0833}', "");
    Expect(0, 68087, '\p{Numeric_Value=0.0833}', "");
    Expect(1, 68087, '\p{^Numeric_Value=0.0833}', "");
    Expect(1, 68087, '\P{Numeric_Value=0.0833}', "");
    Expect(0, 68087, '\P{^Numeric_Value=0.0833}', "");
    Expect(1, 68086, '\p{Numeric_Value=8.33333e-02}', "");
    Expect(0, 68086, '\p{^Numeric_Value=8.33333e-02}', "");
    Expect(0, 68086, '\P{Numeric_Value=8.33333e-02}', "");
    Expect(1, 68086, '\P{^Numeric_Value=8.33333e-02}', "");
    Expect(0, 68087, '\p{Numeric_Value=8.33333e-02}', "");
    Expect(1, 68087, '\p{^Numeric_Value=8.33333e-02}', "");
    Expect(1, 68087, '\P{Numeric_Value=8.33333e-02}', "");
    Expect(0, 68087, '\P{^Numeric_Value=8.33333e-02}', "");
    Expect(1, 68086, '\p{Numeric_Value=0.08333}', "");
    Expect(0, 68086, '\p{^Numeric_Value=0.08333}', "");
    Expect(0, 68086, '\P{Numeric_Value=0.08333}', "");
    Expect(1, 68086, '\P{^Numeric_Value=0.08333}', "");
    Expect(0, 68087, '\p{Numeric_Value=0.08333}', "");
    Expect(1, 68087, '\p{^Numeric_Value=0.08333}', "");
    Expect(1, 68087, '\P{Numeric_Value=0.08333}', "");
    Expect(0, 68087, '\P{^Numeric_Value=0.08333}', "");
    Error('\p{Nv:   -:=+000000001/0012}');
    Error('\P{Nv:   -:=+000000001/0012}');
    Expect(1, 68086, '\p{Nv=:\A1/12\z:}', "");;
    Expect(0, 68087, '\p{Nv=:\A1/12\z:}', "");;
    Expect(1, 68086, '\p{Nv=01/0012}', "");
    Expect(0, 68086, '\p{^Nv=01/0012}', "");
    Expect(0, 68086, '\P{Nv=01/0012}', "");
    Expect(1, 68086, '\P{^Nv=01/0012}', "");
    Expect(0, 68087, '\p{Nv=01/0012}', "");
    Expect(1, 68087, '\p{^Nv=01/0012}', "");
    Expect(1, 68087, '\P{Nv=01/0012}', "");
    Expect(0, 68087, '\P{^Nv=01/0012}', "");
    Expect(1, 68086, '\p{Nv=60/720}', "");
    Expect(0, 68086, '\p{^Nv=60/720}', "");
    Expect(0, 68086, '\P{Nv=60/720}', "");
    Expect(1, 68086, '\P{^Nv=60/720}', "");
    Expect(0, 68087, '\p{Nv=60/720}', "");
    Expect(1, 68087, '\p{^Nv=60/720}', "");
    Expect(1, 68087, '\P{Nv=60/720}', "");
    Expect(0, 68087, '\P{^Nv=60/720}', "");
    Error('\p{Nv=8.3e-02}');
    Error('\P{Nv=8.3e-02}');
    Expect(1, 68086, '\p{Nv=8.33e-02}', "");
    Expect(0, 68086, '\p{^Nv=8.33e-02}', "");
    Expect(0, 68086, '\P{Nv=8.33e-02}', "");
    Expect(1, 68086, '\P{^Nv=8.33e-02}', "");
    Expect(0, 68087, '\p{Nv=8.33e-02}', "");
    Expect(1, 68087, '\p{^Nv=8.33e-02}', "");
    Expect(1, 68087, '\P{Nv=8.33e-02}', "");
    Expect(0, 68087, '\P{^Nv=8.33e-02}', "");
    Error('\p{Nv=0.08}');
    Error('\P{Nv=0.08}');
    Expect(1, 68086, '\p{Nv=8.333e-02}', "");
    Expect(0, 68086, '\p{^Nv=8.333e-02}', "");
    Expect(0, 68086, '\P{Nv=8.333e-02}', "");
    Expect(1, 68086, '\P{^Nv=8.333e-02}', "");
    Expect(0, 68087, '\p{Nv=8.333e-02}', "");
    Expect(1, 68087, '\p{^Nv=8.333e-02}', "");
    Expect(1, 68087, '\P{Nv=8.333e-02}', "");
    Expect(0, 68087, '\P{^Nv=8.333e-02}', "");
    Error('\p{Nv=0.083}');
    Error('\P{Nv=0.083}');
    Expect(1, 68086, '\p{Nv: 8.3333e-02}', "");
    Expect(0, 68086, '\p{^Nv: 8.3333e-02}', "");
    Expect(0, 68086, '\P{Nv: 8.3333e-02}', "");
    Expect(1, 68086, '\P{^Nv: 8.3333e-02}', "");
    Expect(0, 68087, '\p{Nv: 8.3333e-02}', "");
    Expect(1, 68087, '\p{^Nv: 8.3333e-02}', "");
    Expect(1, 68087, '\P{Nv: 8.3333e-02}', "");
    Expect(0, 68087, '\P{^Nv: 8.3333e-02}', "");
    Expect(1, 68086, '\p{Nv=0.0833}', "");
    Expect(0, 68086, '\p{^Nv=0.0833}', "");
    Expect(0, 68086, '\P{Nv=0.0833}', "");
    Expect(1, 68086, '\P{^Nv=0.0833}', "");
    Expect(0, 68087, '\p{Nv=0.0833}', "");
    Expect(1, 68087, '\p{^Nv=0.0833}', "");
    Expect(1, 68087, '\P{Nv=0.0833}', "");
    Expect(0, 68087, '\P{^Nv=0.0833}', "");
    Expect(1, 68086, '\p{Nv:8.33333e-02}', "");
    Expect(0, 68086, '\p{^Nv:8.33333e-02}', "");
    Expect(0, 68086, '\P{Nv:8.33333e-02}', "");
    Expect(1, 68086, '\P{^Nv:8.33333e-02}', "");
    Expect(0, 68087, '\p{Nv:8.33333e-02}', "");
    Expect(1, 68087, '\p{^Nv:8.33333e-02}', "");
    Expect(1, 68087, '\P{Nv:8.33333e-02}', "");
    Expect(0, 68087, '\P{^Nv:8.33333e-02}', "");
    Expect(1, 68086, '\p{Nv=0.08333}', "");
    Expect(0, 68086, '\p{^Nv=0.08333}', "");
    Expect(0, 68086, '\P{Nv=0.08333}', "");
    Expect(1, 68086, '\P{^Nv=0.08333}', "");
    Expect(0, 68087, '\p{Nv=0.08333}', "");
    Expect(1, 68087, '\p{^Nv=0.08333}', "");
    Expect(1, 68087, '\P{Nv=0.08333}', "");
    Expect(0, 68087, '\P{^Nv=0.08333}', "");
    Error('\p{Is_Numeric_Value=:=_ 000001/0000012}');
    Error('\P{Is_Numeric_Value=:=_ 000001/0000012}');
    Expect(1, 68086, '\p{Is_Numeric_Value=+1/000012}', "");
    Expect(0, 68086, '\p{^Is_Numeric_Value=+1/000012}', "");
    Expect(0, 68086, '\P{Is_Numeric_Value=+1/000012}', "");
    Expect(1, 68086, '\P{^Is_Numeric_Value=+1/000012}', "");
    Expect(0, 68087, '\p{Is_Numeric_Value=+1/000012}', "");
    Expect(1, 68087, '\p{^Is_Numeric_Value=+1/000012}', "");
    Expect(1, 68087, '\P{Is_Numeric_Value=+1/000012}', "");
    Expect(0, 68087, '\P{^Is_Numeric_Value=+1/000012}', "");
    Expect(1, 68086, '\p{Is_Numeric_Value=60/720}', "");
    Expect(0, 68086, '\p{^Is_Numeric_Value=60/720}', "");
    Expect(0, 68086, '\P{Is_Numeric_Value=60/720}', "");
    Expect(1, 68086, '\P{^Is_Numeric_Value=60/720}', "");
    Expect(0, 68087, '\p{Is_Numeric_Value=60/720}', "");
    Expect(1, 68087, '\p{^Is_Numeric_Value=60/720}', "");
    Expect(1, 68087, '\P{Is_Numeric_Value=60/720}', "");
    Expect(0, 68087, '\P{^Is_Numeric_Value=60/720}', "");
    Error('\p{Is_Numeric_Value=8.3e-02}');
    Error('\P{Is_Numeric_Value=8.3e-02}');
    Expect(1, 68086, '\p{Is_Numeric_Value=8.33e-02}', "");
    Expect(0, 68086, '\p{^Is_Numeric_Value=8.33e-02}', "");
    Expect(0, 68086, '\P{Is_Numeric_Value=8.33e-02}', "");
    Expect(1, 68086, '\P{^Is_Numeric_Value=8.33e-02}', "");
    Expect(0, 68087, '\p{Is_Numeric_Value=8.33e-02}', "");
    Expect(1, 68087, '\p{^Is_Numeric_Value=8.33e-02}', "");
    Expect(1, 68087, '\P{Is_Numeric_Value=8.33e-02}', "");
    Expect(0, 68087, '\P{^Is_Numeric_Value=8.33e-02}', "");
    Error('\p{Is_Numeric_Value=0.08}');
    Error('\P{Is_Numeric_Value=0.08}');
    Expect(1, 68086, '\p{Is_Numeric_Value=8.333e-02}', "");
    Expect(0, 68086, '\p{^Is_Numeric_Value=8.333e-02}', "");
    Expect(0, 68086, '\P{Is_Numeric_Value=8.333e-02}', "");
    Expect(1, 68086, '\P{^Is_Numeric_Value=8.333e-02}', "");
    Expect(0, 68087, '\p{Is_Numeric_Value=8.333e-02}', "");
    Expect(1, 68087, '\p{^Is_Numeric_Value=8.333e-02}', "");
    Expect(1, 68087, '\P{Is_Numeric_Value=8.333e-02}', "");
    Expect(0, 68087, '\P{^Is_Numeric_Value=8.333e-02}', "");
    Error('\p{Is_Numeric_Value=0.083}');
    Error('\P{Is_Numeric_Value=0.083}');
    Expect(1, 68086, '\p{Is_Numeric_Value=8.3333e-02}', "");
    Expect(0, 68086, '\p{^Is_Numeric_Value=8.3333e-02}', "");
    Expect(0, 68086, '\P{Is_Numeric_Value=8.3333e-02}', "");
    Expect(1, 68086, '\P{^Is_Numeric_Value=8.3333e-02}', "");
    Expect(0, 68087, '\p{Is_Numeric_Value=8.3333e-02}', "");
    Expect(1, 68087, '\p{^Is_Numeric_Value=8.3333e-02}', "");
    Expect(1, 68087, '\P{Is_Numeric_Value=8.3333e-02}', "");
    Expect(0, 68087, '\P{^Is_Numeric_Value=8.3333e-02}', "");
    Expect(1, 68086, '\p{Is_Numeric_Value=0.0833}', "");
    Expect(0, 68086, '\p{^Is_Numeric_Value=0.0833}', "");
    Expect(0, 68086, '\P{Is_Numeric_Value=0.0833}', "");
    Expect(1, 68086, '\P{^Is_Numeric_Value=0.0833}', "");
    Expect(0, 68087, '\p{Is_Numeric_Value=0.0833}', "");
    Expect(1, 68087, '\p{^Is_Numeric_Value=0.0833}', "");
    Expect(1, 68087, '\P{Is_Numeric_Value=0.0833}', "");
    Expect(0, 68087, '\P{^Is_Numeric_Value=0.0833}', "");
    Expect(1, 68086, '\p{Is_Numeric_Value=8.33333e-02}', "");
    Expect(0, 68086, '\p{^Is_Numeric_Value=8.33333e-02}', "");
    Expect(0, 68086, '\P{Is_Numeric_Value=8.33333e-02}', "");
    Expect(1, 68086, '\P{^Is_Numeric_Value=8.33333e-02}', "");
    Expect(0, 68087, '\p{Is_Numeric_Value=8.33333e-02}', "");
    Expect(1, 68087, '\p{^Is_Numeric_Value=8.33333e-02}', "");
    Expect(1, 68087, '\P{Is_Numeric_Value=8.33333e-02}', "");
    Expect(0, 68087, '\P{^Is_Numeric_Value=8.33333e-02}', "");
    Expect(1, 68086, '\p{Is_Numeric_Value=0.08333}', "");
    Expect(0, 68086, '\p{^Is_Numeric_Value=0.08333}', "");
    Expect(0, 68086, '\P{Is_Numeric_Value=0.08333}', "");
    Expect(1, 68086, '\P{^Is_Numeric_Value=0.08333}', "");
    Expect(0, 68087, '\p{Is_Numeric_Value=0.08333}', "");
    Expect(1, 68087, '\p{^Is_Numeric_Value=0.08333}', "");
    Expect(1, 68087, '\P{Is_Numeric_Value=0.08333}', "");
    Expect(0, 68087, '\P{^Is_Numeric_Value=0.08333}', "");
    Error('\p{Is_Nv=:=0000000001/12}');
    Error('\P{Is_Nv=:=0000000001/12}');
    Expect(1, 68086, '\p{Is_Nv=+001/012}', "");
    Expect(0, 68086, '\p{^Is_Nv=+001/012}', "");
    Expect(0, 68086, '\P{Is_Nv=+001/012}', "");
    Expect(1, 68086, '\P{^Is_Nv=+001/012}', "");
    Expect(0, 68087, '\p{Is_Nv=+001/012}', "");
    Expect(1, 68087, '\p{^Is_Nv=+001/012}', "");
    Expect(1, 68087, '\P{Is_Nv=+001/012}', "");
    Expect(0, 68087, '\P{^Is_Nv=+001/012}', "");
    Expect(1, 68086, '\p{Is_Nv=60/720}', "");
    Expect(0, 68086, '\p{^Is_Nv=60/720}', "");
    Expect(0, 68086, '\P{Is_Nv=60/720}', "");
    Expect(1, 68086, '\P{^Is_Nv=60/720}', "");
    Expect(0, 68087, '\p{Is_Nv=60/720}', "");
    Expect(1, 68087, '\p{^Is_Nv=60/720}', "");
    Expect(1, 68087, '\P{Is_Nv=60/720}', "");
    Expect(0, 68087, '\P{^Is_Nv=60/720}', "");
    Error('\p{Is_Nv=8.3e-02}');
    Error('\P{Is_Nv=8.3e-02}');
    Expect(1, 68086, '\p{Is_Nv=8.33e-02}', "");
    Expect(0, 68086, '\p{^Is_Nv=8.33e-02}', "");
    Expect(0, 68086, '\P{Is_Nv=8.33e-02}', "");
    Expect(1, 68086, '\P{^Is_Nv=8.33e-02}', "");
    Expect(0, 68087, '\p{Is_Nv=8.33e-02}', "");
    Expect(1, 68087, '\p{^Is_Nv=8.33e-02}', "");
    Expect(1, 68087, '\P{Is_Nv=8.33e-02}', "");
    Expect(0, 68087, '\P{^Is_Nv=8.33e-02}', "");
    Error('\p{Is_Nv:	0.08}');
    Error('\P{Is_Nv:	0.08}');
    Expect(1, 68086, '\p{Is_Nv=8.333e-02}', "");
    Expect(0, 68086, '\p{^Is_Nv=8.333e-02}', "");
    Expect(0, 68086, '\P{Is_Nv=8.333e-02}', "");
    Expect(1, 68086, '\P{^Is_Nv=8.333e-02}', "");
    Expect(0, 68087, '\p{Is_Nv=8.333e-02}', "");
    Expect(1, 68087, '\p{^Is_Nv=8.333e-02}', "");
    Expect(1, 68087, '\P{Is_Nv=8.333e-02}', "");
    Expect(0, 68087, '\P{^Is_Nv=8.333e-02}', "");
    Error('\p{Is_Nv=0.083}');
    Error('\P{Is_Nv=0.083}');
    Expect(1, 68086, '\p{Is_Nv=8.3333e-02}', "");
    Expect(0, 68086, '\p{^Is_Nv=8.3333e-02}', "");
    Expect(0, 68086, '\P{Is_Nv=8.3333e-02}', "");
    Expect(1, 68086, '\P{^Is_Nv=8.3333e-02}', "");
    Expect(0, 68087, '\p{Is_Nv=8.3333e-02}', "");
    Expect(1, 68087, '\p{^Is_Nv=8.3333e-02}', "");
    Expect(1, 68087, '\P{Is_Nv=8.3333e-02}', "");
    Expect(0, 68087, '\P{^Is_Nv=8.3333e-02}', "");
    Expect(1, 68086, '\p{Is_Nv=0.0833}', "");
    Expect(0, 68086, '\p{^Is_Nv=0.0833}', "");
    Expect(0, 68086, '\P{Is_Nv=0.0833}', "");
    Expect(1, 68086, '\P{^Is_Nv=0.0833}', "");
    Expect(0, 68087, '\p{Is_Nv=0.0833}', "");
    Expect(1, 68087, '\p{^Is_Nv=0.0833}', "");
    Expect(1, 68087, '\P{Is_Nv=0.0833}', "");
    Expect(0, 68087, '\P{^Is_Nv=0.0833}', "");
    Expect(1, 68086, '\p{Is_Nv=8.33333e-02}', "");
    Expect(0, 68086, '\p{^Is_Nv=8.33333e-02}', "");
    Expect(0, 68086, '\P{Is_Nv=8.33333e-02}', "");
    Expect(1, 68086, '\P{^Is_Nv=8.33333e-02}', "");
    Expect(0, 68087, '\p{Is_Nv=8.33333e-02}', "");
    Expect(1, 68087, '\p{^Is_Nv=8.33333e-02}', "");
    Expect(1, 68087, '\P{Is_Nv=8.33333e-02}', "");
    Expect(0, 68087, '\P{^Is_Nv=8.33333e-02}', "");
    Expect(1, 68086, '\p{Is_Nv=0.08333}', "");
    Expect(0, 68086, '\p{^Is_Nv=0.08333}', "");
    Expect(0, 68086, '\P{Is_Nv=0.08333}', "");
    Expect(1, 68086, '\P{^Is_Nv=0.08333}', "");
    Expect(0, 68087, '\p{Is_Nv=0.08333}', "");
    Expect(1, 68087, '\p{^Is_Nv=0.08333}', "");
    Expect(1, 68087, '\P{Is_Nv=0.08333}', "");
    Expect(0, 68087, '\P{^Is_Nv=0.08333}', "");
    Error('\p{Numeric_Value=/a/	01/0000016}');
    Error('\P{Numeric_Value=/a/	01/0000016}');
    Expect(1, 73674, '\p{Numeric_Value=:\A1/16\z:}', "");;
    Expect(0, 73675, '\p{Numeric_Value=:\A1/16\z:}', "");;
    Expect(1, 73674, '\p{Numeric_Value=01/00000000016}', "");
    Expect(0, 73674, '\p{^Numeric_Value=01/00000000016}', "");
    Expect(0, 73674, '\P{Numeric_Value=01/00000000016}', "");
    Expect(1, 73674, '\P{^Numeric_Value=01/00000000016}', "");
    Expect(0, 73675, '\p{Numeric_Value=01/00000000016}', "");
    Expect(1, 73675, '\p{^Numeric_Value=01/00000000016}', "");
    Expect(1, 73675, '\P{Numeric_Value=01/00000000016}', "");
    Expect(0, 73675, '\P{^Numeric_Value=01/00000000016}', "");
    Expect(1, 73674, '\p{Numeric_Value=60/960}', "");
    Expect(0, 73674, '\p{^Numeric_Value=60/960}', "");
    Expect(0, 73674, '\P{Numeric_Value=60/960}', "");
    Expect(1, 73674, '\P{^Numeric_Value=60/960}', "");
    Expect(0, 73675, '\p{Numeric_Value=60/960}', "");
    Expect(1, 73675, '\p{^Numeric_Value=60/960}', "");
    Expect(1, 73675, '\P{Numeric_Value=60/960}', "");
    Expect(0, 73675, '\P{^Numeric_Value=60/960}', "");
    Error('\p{Numeric_Value=6.2e-02}');
    Error('\P{Numeric_Value=6.2e-02}');
    Expect(1, 73674, '\p{Numeric_Value=6.25e-02}', "");
    Expect(0, 73674, '\p{^Numeric_Value=6.25e-02}', "");
    Expect(0, 73674, '\P{Numeric_Value=6.25e-02}', "");
    Expect(1, 73674, '\P{^Numeric_Value=6.25e-02}', "");
    Expect(0, 73675, '\p{Numeric_Value=6.25e-02}', "");
    Expect(1, 73675, '\p{^Numeric_Value=6.25e-02}', "");
    Expect(1, 73675, '\P{Numeric_Value=6.25e-02}', "");
    Expect(0, 73675, '\P{^Numeric_Value=6.25e-02}', "");
    Error('\p{Numeric_Value=0.06}');
    Error('\P{Numeric_Value=0.06}');
    Expect(1, 73674, '\p{Numeric_Value:	6.250e-02}', "");
    Expect(0, 73674, '\p{^Numeric_Value:	6.250e-02}', "");
    Expect(0, 73674, '\P{Numeric_Value:	6.250e-02}', "");
    Expect(1, 73674, '\P{^Numeric_Value:	6.250e-02}', "");
    Expect(0, 73675, '\p{Numeric_Value:	6.250e-02}', "");
    Expect(1, 73675, '\p{^Numeric_Value:	6.250e-02}', "");
    Expect(1, 73675, '\P{Numeric_Value:	6.250e-02}', "");
    Expect(0, 73675, '\P{^Numeric_Value:	6.250e-02}', "");
    Error('\p{Numeric_Value=0.062}');
    Error('\P{Numeric_Value=0.062}');
    Expect(1, 73674, '\p{Numeric_Value:6.2500e-02}', "");
    Expect(0, 73674, '\p{^Numeric_Value:6.2500e-02}', "");
    Expect(0, 73674, '\P{Numeric_Value:6.2500e-02}', "");
    Expect(1, 73674, '\P{^Numeric_Value:6.2500e-02}', "");
    Expect(0, 73675, '\p{Numeric_Value:6.2500e-02}', "");
    Expect(1, 73675, '\p{^Numeric_Value:6.2500e-02}', "");
    Expect(1, 73675, '\P{Numeric_Value:6.2500e-02}', "");
    Expect(0, 73675, '\P{^Numeric_Value:6.2500e-02}', "");
    Expect(1, 73674, '\p{Numeric_Value=0.0625}', "");
    Expect(0, 73674, '\p{^Numeric_Value=0.0625}', "");
    Expect(0, 73674, '\P{Numeric_Value=0.0625}', "");
    Expect(1, 73674, '\P{^Numeric_Value=0.0625}', "");
    Expect(0, 73675, '\p{Numeric_Value=0.0625}', "");
    Expect(1, 73675, '\p{^Numeric_Value=0.0625}', "");
    Expect(1, 73675, '\P{Numeric_Value=0.0625}', "");
    Expect(0, 73675, '\P{^Numeric_Value=0.0625}', "");
    Expect(1, 73674, '\p{Numeric_Value=6.25000e-02}', "");
    Expect(0, 73674, '\p{^Numeric_Value=6.25000e-02}', "");
    Expect(0, 73674, '\P{Numeric_Value=6.25000e-02}', "");
    Expect(1, 73674, '\P{^Numeric_Value=6.25000e-02}', "");
    Expect(0, 73675, '\p{Numeric_Value=6.25000e-02}', "");
    Expect(1, 73675, '\p{^Numeric_Value=6.25000e-02}', "");
    Expect(1, 73675, '\P{Numeric_Value=6.25000e-02}', "");
    Expect(0, 73675, '\P{^Numeric_Value=6.25000e-02}', "");
    Expect(1, 73674, '\p{Numeric_Value=0.06250}', "");
    Expect(0, 73674, '\p{^Numeric_Value=0.06250}', "");
    Expect(0, 73674, '\P{Numeric_Value=0.06250}', "");
    Expect(1, 73674, '\P{^Numeric_Value=0.06250}', "");
    Expect(0, 73675, '\p{Numeric_Value=0.06250}', "");
    Expect(1, 73675, '\p{^Numeric_Value=0.06250}', "");
    Expect(1, 73675, '\P{Numeric_Value=0.06250}', "");
    Expect(0, 73675, '\P{^Numeric_Value=0.06250}', "");
    Error('\p{Nv= 	0000000001/000016/a/}');
    Error('\P{Nv= 	0000000001/000016/a/}');
    Expect(1, 73674, '\p{Nv=:\A1/16\z:}', "");;
    Expect(0, 73675, '\p{Nv=:\A1/16\z:}', "");;
    Expect(1, 73674, '\p{Nv=00001/0000016}', "");
    Expect(0, 73674, '\p{^Nv=00001/0000016}', "");
    Expect(0, 73674, '\P{Nv=00001/0000016}', "");
    Expect(1, 73674, '\P{^Nv=00001/0000016}', "");
    Expect(0, 73675, '\p{Nv=00001/0000016}', "");
    Expect(1, 73675, '\p{^Nv=00001/0000016}', "");
    Expect(1, 73675, '\P{Nv=00001/0000016}', "");
    Expect(0, 73675, '\P{^Nv=00001/0000016}', "");
    Expect(1, 73674, '\p{Nv=60/960}', "");
    Expect(0, 73674, '\p{^Nv=60/960}', "");
    Expect(0, 73674, '\P{Nv=60/960}', "");
    Expect(1, 73674, '\P{^Nv=60/960}', "");
    Expect(0, 73675, '\p{Nv=60/960}', "");
    Expect(1, 73675, '\p{^Nv=60/960}', "");
    Expect(1, 73675, '\P{Nv=60/960}', "");
    Expect(0, 73675, '\P{^Nv=60/960}', "");
    Error('\p{Nv:	6.2e-02}');
    Error('\P{Nv:	6.2e-02}');
    Expect(1, 73674, '\p{Nv=6.25e-02}', "");
    Expect(0, 73674, '\p{^Nv=6.25e-02}', "");
    Expect(0, 73674, '\P{Nv=6.25e-02}', "");
    Expect(1, 73674, '\P{^Nv=6.25e-02}', "");
    Expect(0, 73675, '\p{Nv=6.25e-02}', "");
    Expect(1, 73675, '\p{^Nv=6.25e-02}', "");
    Expect(1, 73675, '\P{Nv=6.25e-02}', "");
    Expect(0, 73675, '\P{^Nv=6.25e-02}', "");
    Error('\p{Nv=0.06}');
    Error('\P{Nv=0.06}');
    Expect(1, 73674, '\p{Nv=6.250e-02}', "");
    Expect(0, 73674, '\p{^Nv=6.250e-02}', "");
    Expect(0, 73674, '\P{Nv=6.250e-02}', "");
    Expect(1, 73674, '\P{^Nv=6.250e-02}', "");
    Expect(0, 73675, '\p{Nv=6.250e-02}', "");
    Expect(1, 73675, '\p{^Nv=6.250e-02}', "");
    Expect(1, 73675, '\P{Nv=6.250e-02}', "");
    Expect(0, 73675, '\P{^Nv=6.250e-02}', "");
    Error('\p{Nv=0.062}');
    Error('\P{Nv=0.062}');
    Expect(1, 73674, '\p{Nv:6.2500e-02}', "");
    Expect(0, 73674, '\p{^Nv:6.2500e-02}', "");
    Expect(0, 73674, '\P{Nv:6.2500e-02}', "");
    Expect(1, 73674, '\P{^Nv:6.2500e-02}', "");
    Expect(0, 73675, '\p{Nv:6.2500e-02}', "");
    Expect(1, 73675, '\p{^Nv:6.2500e-02}', "");
    Expect(1, 73675, '\P{Nv:6.2500e-02}', "");
    Expect(0, 73675, '\P{^Nv:6.2500e-02}', "");
    Expect(1, 73674, '\p{Nv=0.0625}', "");
    Expect(0, 73674, '\p{^Nv=0.0625}', "");
    Expect(0, 73674, '\P{Nv=0.0625}', "");
    Expect(1, 73674, '\P{^Nv=0.0625}', "");
    Expect(0, 73675, '\p{Nv=0.0625}', "");
    Expect(1, 73675, '\p{^Nv=0.0625}', "");
    Expect(1, 73675, '\P{Nv=0.0625}', "");
    Expect(0, 73675, '\P{^Nv=0.0625}', "");
    Expect(1, 73674, '\p{Nv=6.25000e-02}', "");
    Expect(0, 73674, '\p{^Nv=6.25000e-02}', "");
    Expect(0, 73674, '\P{Nv=6.25000e-02}', "");
    Expect(1, 73674, '\P{^Nv=6.25000e-02}', "");
    Expect(0, 73675, '\p{Nv=6.25000e-02}', "");
    Expect(1, 73675, '\p{^Nv=6.25000e-02}', "");
    Expect(1, 73675, '\P{Nv=6.25000e-02}', "");
    Expect(0, 73675, '\P{^Nv=6.25000e-02}', "");
    Expect(1, 73674, '\p{Nv=0.06250}', "");
    Expect(0, 73674, '\p{^Nv=0.06250}', "");
    Expect(0, 73674, '\P{Nv=0.06250}', "");
    Expect(1, 73674, '\P{^Nv=0.06250}', "");
    Expect(0, 73675, '\p{Nv=0.06250}', "");
    Expect(1, 73675, '\p{^Nv=0.06250}', "");
    Expect(1, 73675, '\P{Nv=0.06250}', "");
    Expect(0, 73675, '\P{^Nv=0.06250}', "");
    Error('\p{Is_Numeric_Value= :=0000001/00016}');
    Error('\P{Is_Numeric_Value= :=0000001/00016}');
    Expect(1, 73674, '\p{Is_Numeric_Value=+00000001/0000016}', "");
    Expect(0, 73674, '\p{^Is_Numeric_Value=+00000001/0000016}', "");
    Expect(0, 73674, '\P{Is_Numeric_Value=+00000001/0000016}', "");
    Expect(1, 73674, '\P{^Is_Numeric_Value=+00000001/0000016}', "");
    Expect(0, 73675, '\p{Is_Numeric_Value=+00000001/0000016}', "");
    Expect(1, 73675, '\p{^Is_Numeric_Value=+00000001/0000016}', "");
    Expect(1, 73675, '\P{Is_Numeric_Value=+00000001/0000016}', "");
    Expect(0, 73675, '\P{^Is_Numeric_Value=+00000001/0000016}', "");
    Expect(1, 73674, '\p{Is_Numeric_Value=60/960}', "");
    Expect(0, 73674, '\p{^Is_Numeric_Value=60/960}', "");
    Expect(0, 73674, '\P{Is_Numeric_Value=60/960}', "");
    Expect(1, 73674, '\P{^Is_Numeric_Value=60/960}', "");
    Expect(0, 73675, '\p{Is_Numeric_Value=60/960}', "");
    Expect(1, 73675, '\p{^Is_Numeric_Value=60/960}', "");
    Expect(1, 73675, '\P{Is_Numeric_Value=60/960}', "");
    Expect(0, 73675, '\P{^Is_Numeric_Value=60/960}', "");
    Error('\p{Is_Numeric_Value=6.2e-02}');
    Error('\P{Is_Numeric_Value=6.2e-02}');
    Expect(1, 73674, '\p{Is_Numeric_Value=6.25e-02}', "");
    Expect(0, 73674, '\p{^Is_Numeric_Value=6.25e-02}', "");
    Expect(0, 73674, '\P{Is_Numeric_Value=6.25e-02}', "");
    Expect(1, 73674, '\P{^Is_Numeric_Value=6.25e-02}', "");
    Expect(0, 73675, '\p{Is_Numeric_Value=6.25e-02}', "");
    Expect(1, 73675, '\p{^Is_Numeric_Value=6.25e-02}', "");
    Expect(1, 73675, '\P{Is_Numeric_Value=6.25e-02}', "");
    Expect(0, 73675, '\P{^Is_Numeric_Value=6.25e-02}', "");
    Error('\p{Is_Numeric_Value=0.06}');
    Error('\P{Is_Numeric_Value=0.06}');
    Expect(1, 73674, '\p{Is_Numeric_Value=6.250e-02}', "");
    Expect(0, 73674, '\p{^Is_Numeric_Value=6.250e-02}', "");
    Expect(0, 73674, '\P{Is_Numeric_Value=6.250e-02}', "");
    Expect(1, 73674, '\P{^Is_Numeric_Value=6.250e-02}', "");
    Expect(0, 73675, '\p{Is_Numeric_Value=6.250e-02}', "");
    Expect(1, 73675, '\p{^Is_Numeric_Value=6.250e-02}', "");
    Expect(1, 73675, '\P{Is_Numeric_Value=6.250e-02}', "");
    Expect(0, 73675, '\P{^Is_Numeric_Value=6.250e-02}', "");
    Error('\p{Is_Numeric_Value=0.062}');
    Error('\P{Is_Numeric_Value=0.062}');
    Expect(1, 73674, '\p{Is_Numeric_Value=6.2500e-02}', "");
    Expect(0, 73674, '\p{^Is_Numeric_Value=6.2500e-02}', "");
    Expect(0, 73674, '\P{Is_Numeric_Value=6.2500e-02}', "");
    Expect(1, 73674, '\P{^Is_Numeric_Value=6.2500e-02}', "");
    Expect(0, 73675, '\p{Is_Numeric_Value=6.2500e-02}', "");
    Expect(1, 73675, '\p{^Is_Numeric_Value=6.2500e-02}', "");
    Expect(1, 73675, '\P{Is_Numeric_Value=6.2500e-02}', "");
    Expect(0, 73675, '\P{^Is_Numeric_Value=6.2500e-02}', "");
    Expect(1, 73674, '\p{Is_Numeric_Value:   0.0625}', "");
    Expect(0, 73674, '\p{^Is_Numeric_Value:   0.0625}', "");
    Expect(0, 73674, '\P{Is_Numeric_Value:   0.0625}', "");
    Expect(1, 73674, '\P{^Is_Numeric_Value:   0.0625}', "");
    Expect(0, 73675, '\p{Is_Numeric_Value:   0.0625}', "");
    Expect(1, 73675, '\p{^Is_Numeric_Value:   0.0625}', "");
    Expect(1, 73675, '\P{Is_Numeric_Value:   0.0625}', "");
    Expect(0, 73675, '\P{^Is_Numeric_Value:   0.0625}', "");
    Expect(1, 73674, '\p{Is_Numeric_Value=6.25000e-02}', "");
    Expect(0, 73674, '\p{^Is_Numeric_Value=6.25000e-02}', "");
    Expect(0, 73674, '\P{Is_Numeric_Value=6.25000e-02}', "");
    Expect(1, 73674, '\P{^Is_Numeric_Value=6.25000e-02}', "");
    Expect(0, 73675, '\p{Is_Numeric_Value=6.25000e-02}', "");
    Expect(1, 73675, '\p{^Is_Numeric_Value=6.25000e-02}', "");
    Expect(1, 73675, '\P{Is_Numeric_Value=6.25000e-02}', "");
    Expect(0, 73675, '\P{^Is_Numeric_Value=6.25000e-02}', "");
    Expect(1, 73674, '\p{Is_Numeric_Value=0.06250}', "");
    Expect(0, 73674, '\p{^Is_Numeric_Value=0.06250}', "");
    Expect(0, 73674, '\P{Is_Numeric_Value=0.06250}', "");
    Expect(1, 73674, '\P{^Is_Numeric_Value=0.06250}', "");
    Expect(0, 73675, '\p{Is_Numeric_Value=0.06250}', "");
    Expect(1, 73675, '\p{^Is_Numeric_Value=0.06250}', "");
    Expect(1, 73675, '\P{Is_Numeric_Value=0.06250}', "");
    Expect(0, 73675, '\P{^Is_Numeric_Value=0.06250}', "");
    Error('\p{Is_Nv=_:=+0000001/0016}');
    Error('\P{Is_Nv=_:=+0000001/0016}');
    Expect(1, 73674, '\p{Is_Nv=1/016}', "");
    Expect(0, 73674, '\p{^Is_Nv=1/016}', "");
    Expect(0, 73674, '\P{Is_Nv=1/016}', "");
    Expect(1, 73674, '\P{^Is_Nv=1/016}', "");
    Expect(0, 73675, '\p{Is_Nv=1/016}', "");
    Expect(1, 73675, '\p{^Is_Nv=1/016}', "");
    Expect(1, 73675, '\P{Is_Nv=1/016}', "");
    Expect(0, 73675, '\P{^Is_Nv=1/016}', "");
    Expect(1, 73674, '\p{Is_Nv: 60/960}', "");
    Expect(0, 73674, '\p{^Is_Nv: 60/960}', "");
    Expect(0, 73674, '\P{Is_Nv: 60/960}', "");
    Expect(1, 73674, '\P{^Is_Nv: 60/960}', "");
    Expect(0, 73675, '\p{Is_Nv: 60/960}', "");
    Expect(1, 73675, '\p{^Is_Nv: 60/960}', "");
    Expect(1, 73675, '\P{Is_Nv: 60/960}', "");
    Expect(0, 73675, '\P{^Is_Nv: 60/960}', "");
    Error('\p{Is_Nv=6.2e-02}');
    Error('\P{Is_Nv=6.2e-02}');
    Expect(1, 73674, '\p{Is_Nv=6.25e-02}', "");
    Expect(0, 73674, '\p{^Is_Nv=6.25e-02}', "");
    Expect(0, 73674, '\P{Is_Nv=6.25e-02}', "");
    Expect(1, 73674, '\P{^Is_Nv=6.25e-02}', "");
    Expect(0, 73675, '\p{Is_Nv=6.25e-02}', "");
    Expect(1, 73675, '\p{^Is_Nv=6.25e-02}', "");
    Expect(1, 73675, '\P{Is_Nv=6.25e-02}', "");
    Expect(0, 73675, '\P{^Is_Nv=6.25e-02}', "");
    Error('\p{Is_Nv=0.06}');
    Error('\P{Is_Nv=0.06}');
    Expect(1, 73674, '\p{Is_Nv=6.250e-02}', "");
    Expect(0, 73674, '\p{^Is_Nv=6.250e-02}', "");
    Expect(0, 73674, '\P{Is_Nv=6.250e-02}', "");
    Expect(1, 73674, '\P{^Is_Nv=6.250e-02}', "");
    Expect(0, 73675, '\p{Is_Nv=6.250e-02}', "");
    Expect(1, 73675, '\p{^Is_Nv=6.250e-02}', "");
    Expect(1, 73675, '\P{Is_Nv=6.250e-02}', "");
    Expect(0, 73675, '\P{^Is_Nv=6.250e-02}', "");
    Error('\p{Is_Nv=0.062}');
    Error('\P{Is_Nv=0.062}');
    Expect(1, 73674, '\p{Is_Nv=6.2500e-02}', "");
    Expect(0, 73674, '\p{^Is_Nv=6.2500e-02}', "");
    Expect(0, 73674, '\P{Is_Nv=6.2500e-02}', "");
    Expect(1, 73674, '\P{^Is_Nv=6.2500e-02}', "");
    Expect(0, 73675, '\p{Is_Nv=6.2500e-02}', "");
    Expect(1, 73675, '\p{^Is_Nv=6.2500e-02}', "");
    Expect(1, 73675, '\P{Is_Nv=6.2500e-02}', "");
    Expect(0, 73675, '\P{^Is_Nv=6.2500e-02}', "");
    Expect(1, 73674, '\p{Is_Nv=0.0625}', "");
    Expect(0, 73674, '\p{^Is_Nv=0.0625}', "");
    Expect(0, 73674, '\P{Is_Nv=0.0625}', "");
    Expect(1, 73674, '\P{^Is_Nv=0.0625}', "");
    Expect(0, 73675, '\p{Is_Nv=0.0625}', "");
    Expect(1, 73675, '\p{^Is_Nv=0.0625}', "");
    Expect(1, 73675, '\P{Is_Nv=0.0625}', "");
    Expect(0, 73675, '\P{^Is_Nv=0.0625}', "");
    Expect(1, 73674, '\p{Is_Nv=6.25000e-02}', "");
    Expect(0, 73674, '\p{^Is_Nv=6.25000e-02}', "");
    Expect(0, 73674, '\P{Is_Nv=6.25000e-02}', "");
    Expect(1, 73674, '\P{^Is_Nv=6.25000e-02}', "");
    Expect(0, 73675, '\p{Is_Nv=6.25000e-02}', "");
    Expect(1, 73675, '\p{^Is_Nv=6.25000e-02}', "");
    Expect(1, 73675, '\P{Is_Nv=6.25000e-02}', "");
    Expect(0, 73675, '\P{^Is_Nv=6.25000e-02}', "");
    Expect(1, 73674, '\p{Is_Nv=0.06250}', "");
    Expect(0, 73674, '\p{^Is_Nv=0.06250}', "");
    Expect(0, 73674, '\P{Is_Nv=0.06250}', "");
    Expect(1, 73674, '\P{^Is_Nv=0.06250}', "");
    Expect(0, 73675, '\p{Is_Nv=0.06250}', "");
    Expect(1, 73675, '\p{^Is_Nv=0.06250}', "");
    Expect(1, 73675, '\P{Is_Nv=0.06250}', "");
    Expect(0, 73675, '\P{^Is_Nv=0.06250}', "");
    Error('\p{Numeric_Value=/a/+001/00000160}');
    Error('\P{Numeric_Value=/a/+001/00000160}');
    Expect(1, 73665, '\p{Numeric_Value=:\A1/160\z:}', "");;
    Expect(0, 73666, '\p{Numeric_Value=:\A1/160\z:}', "");;
    Expect(1, 73665, '\p{Numeric_Value=+0000001/0160}', "");
    Expect(0, 73665, '\p{^Numeric_Value=+0000001/0160}', "");
    Expect(0, 73665, '\P{Numeric_Value=+0000001/0160}', "");
    Expect(1, 73665, '\P{^Numeric_Value=+0000001/0160}', "");
    Expect(0, 73666, '\p{Numeric_Value=+0000001/0160}', "");
    Expect(1, 73666, '\p{^Numeric_Value=+0000001/0160}', "");
    Expect(1, 73666, '\P{Numeric_Value=+0000001/0160}', "");
    Expect(0, 73666, '\P{^Numeric_Value=+0000001/0160}', "");
    Expect(1, 73665, '\p{Numeric_Value=60/9600}', "");
    Expect(0, 73665, '\p{^Numeric_Value=60/9600}', "");
    Expect(0, 73665, '\P{Numeric_Value=60/9600}', "");
    Expect(1, 73665, '\P{^Numeric_Value=60/9600}', "");
    Expect(0, 73666, '\p{Numeric_Value=60/9600}', "");
    Expect(1, 73666, '\p{^Numeric_Value=60/9600}', "");
    Expect(1, 73666, '\P{Numeric_Value=60/9600}', "");
    Expect(0, 73666, '\P{^Numeric_Value=60/9600}', "");
    Error('\p{Numeric_Value=6.3e-03}');
    Error('\P{Numeric_Value=6.3e-03}');
    Expect(1, 73665, '\p{Numeric_Value=6.25e-03}', "");
    Expect(0, 73665, '\p{^Numeric_Value=6.25e-03}', "");
    Expect(0, 73665, '\P{Numeric_Value=6.25e-03}', "");
    Expect(1, 73665, '\P{^Numeric_Value=6.25e-03}', "");
    Expect(0, 73666, '\p{Numeric_Value=6.25e-03}', "");
    Expect(1, 73666, '\p{^Numeric_Value=6.25e-03}', "");
    Expect(1, 73666, '\P{Numeric_Value=6.25e-03}', "");
    Expect(0, 73666, '\P{^Numeric_Value=6.25e-03}', "");
    Error('\p{Numeric_Value=0.01}');
    Error('\P{Numeric_Value=0.01}');
    Expect(1, 73665, '\p{Numeric_Value=6.250e-03}', "");
    Expect(0, 73665, '\p{^Numeric_Value=6.250e-03}', "");
    Expect(0, 73665, '\P{Numeric_Value=6.250e-03}', "");
    Expect(1, 73665, '\P{^Numeric_Value=6.250e-03}', "");
    Expect(0, 73666, '\p{Numeric_Value=6.250e-03}', "");
    Expect(1, 73666, '\p{^Numeric_Value=6.250e-03}', "");
    Expect(1, 73666, '\P{Numeric_Value=6.250e-03}', "");
    Expect(0, 73666, '\P{^Numeric_Value=6.250e-03}', "");
    Error('\p{Numeric_Value=0.006}');
    Error('\P{Numeric_Value=0.006}');
    Expect(1, 73665, '\p{Numeric_Value=6.2500e-03}', "");
    Expect(0, 73665, '\p{^Numeric_Value=6.2500e-03}', "");
    Expect(0, 73665, '\P{Numeric_Value=6.2500e-03}', "");
    Expect(1, 73665, '\P{^Numeric_Value=6.2500e-03}', "");
    Expect(0, 73666, '\p{Numeric_Value=6.2500e-03}', "");
    Expect(1, 73666, '\p{^Numeric_Value=6.2500e-03}', "");
    Expect(1, 73666, '\P{Numeric_Value=6.2500e-03}', "");
    Expect(0, 73666, '\P{^Numeric_Value=6.2500e-03}', "");
    Error('\p{Numeric_Value=0.0063}');
    Error('\P{Numeric_Value=0.0063}');
    Expect(1, 73665, '\p{Numeric_Value=6.25000e-03}', "");
    Expect(0, 73665, '\p{^Numeric_Value=6.25000e-03}', "");
    Expect(0, 73665, '\P{Numeric_Value=6.25000e-03}', "");
    Expect(1, 73665, '\P{^Numeric_Value=6.25000e-03}', "");
    Expect(0, 73666, '\p{Numeric_Value=6.25000e-03}', "");
    Expect(1, 73666, '\p{^Numeric_Value=6.25000e-03}', "");
    Expect(1, 73666, '\P{Numeric_Value=6.25000e-03}', "");
    Expect(0, 73666, '\P{^Numeric_Value=6.25000e-03}', "");
    Expect(1, 73665, '\p{Numeric_Value:0.00625}', "");
    Expect(0, 73665, '\p{^Numeric_Value:0.00625}', "");
    Expect(0, 73665, '\P{Numeric_Value:0.00625}', "");
    Expect(1, 73665, '\P{^Numeric_Value:0.00625}', "");
    Expect(0, 73666, '\p{Numeric_Value:0.00625}', "");
    Expect(1, 73666, '\p{^Numeric_Value:0.00625}', "");
    Expect(1, 73666, '\P{Numeric_Value:0.00625}', "");
    Expect(0, 73666, '\P{^Numeric_Value:0.00625}', "");
    Expect(1, 73665, '\p{Numeric_Value:6.250000e-03}', "");
    Expect(0, 73665, '\p{^Numeric_Value:6.250000e-03}', "");
    Expect(0, 73665, '\P{Numeric_Value:6.250000e-03}', "");
    Expect(1, 73665, '\P{^Numeric_Value:6.250000e-03}', "");
    Expect(0, 73666, '\p{Numeric_Value:6.250000e-03}', "");
    Expect(1, 73666, '\p{^Numeric_Value:6.250000e-03}', "");
    Expect(1, 73666, '\P{Numeric_Value:6.250000e-03}', "");
    Expect(0, 73666, '\P{^Numeric_Value:6.250000e-03}', "");
    Expect(1, 73665, '\p{Numeric_Value=0.006250}', "");
    Expect(0, 73665, '\p{^Numeric_Value=0.006250}', "");
    Expect(0, 73665, '\P{Numeric_Value=0.006250}', "");
    Expect(1, 73665, '\P{^Numeric_Value=0.006250}', "");
    Expect(0, 73666, '\p{Numeric_Value=0.006250}', "");
    Expect(1, 73666, '\p{^Numeric_Value=0.006250}', "");
    Expect(1, 73666, '\P{Numeric_Value=0.006250}', "");
    Expect(0, 73666, '\P{^Numeric_Value=0.006250}', "");
    Error('\p{Nv=	/a/0000000001/00000160}');
    Error('\P{Nv=	/a/0000000001/00000160}');
    Expect(1, 73665, '\p{Nv=:\A1/160\z:}', "");;
    Expect(0, 73666, '\p{Nv=:\A1/160\z:}', "");;
    Expect(1, 73665, '\p{Nv=1/0160}', "");
    Expect(0, 73665, '\p{^Nv=1/0160}', "");
    Expect(0, 73665, '\P{Nv=1/0160}', "");
    Expect(1, 73665, '\P{^Nv=1/0160}', "");
    Expect(0, 73666, '\p{Nv=1/0160}', "");
    Expect(1, 73666, '\p{^Nv=1/0160}', "");
    Expect(1, 73666, '\P{Nv=1/0160}', "");
    Expect(0, 73666, '\P{^Nv=1/0160}', "");
    Expect(1, 73665, '\p{Nv=60/9600}', "");
    Expect(0, 73665, '\p{^Nv=60/9600}', "");
    Expect(0, 73665, '\P{Nv=60/9600}', "");
    Expect(1, 73665, '\P{^Nv=60/9600}', "");
    Expect(0, 73666, '\p{Nv=60/9600}', "");
    Expect(1, 73666, '\p{^Nv=60/9600}', "");
    Expect(1, 73666, '\P{Nv=60/9600}', "");
    Expect(0, 73666, '\P{^Nv=60/9600}', "");
    Error('\p{Nv=6.3e-03}');
    Error('\P{Nv=6.3e-03}');
    Expect(1, 73665, '\p{Nv=6.25e-03}', "");
    Expect(0, 73665, '\p{^Nv=6.25e-03}', "");
    Expect(0, 73665, '\P{Nv=6.25e-03}', "");
    Expect(1, 73665, '\P{^Nv=6.25e-03}', "");
    Expect(0, 73666, '\p{Nv=6.25e-03}', "");
    Expect(1, 73666, '\p{^Nv=6.25e-03}', "");
    Expect(1, 73666, '\P{Nv=6.25e-03}', "");
    Expect(0, 73666, '\P{^Nv=6.25e-03}', "");
    Error('\p{Nv=0.01}');
    Error('\P{Nv=0.01}');
    Expect(1, 73665, '\p{Nv:6.250e-03}', "");
    Expect(0, 73665, '\p{^Nv:6.250e-03}', "");
    Expect(0, 73665, '\P{Nv:6.250e-03}', "");
    Expect(1, 73665, '\P{^Nv:6.250e-03}', "");
    Expect(0, 73666, '\p{Nv:6.250e-03}', "");
    Expect(1, 73666, '\p{^Nv:6.250e-03}', "");
    Expect(1, 73666, '\P{Nv:6.250e-03}', "");
    Expect(0, 73666, '\P{^Nv:6.250e-03}', "");
    Error('\p{Nv=0.006}');
    Error('\P{Nv=0.006}');
    Expect(1, 73665, '\p{Nv=6.2500e-03}', "");
    Expect(0, 73665, '\p{^Nv=6.2500e-03}', "");
    Expect(0, 73665, '\P{Nv=6.2500e-03}', "");
    Expect(1, 73665, '\P{^Nv=6.2500e-03}', "");
    Expect(0, 73666, '\p{Nv=6.2500e-03}', "");
    Expect(1, 73666, '\p{^Nv=6.2500e-03}', "");
    Expect(1, 73666, '\P{Nv=6.2500e-03}', "");
    Expect(0, 73666, '\P{^Nv=6.2500e-03}', "");
    Error('\p{Nv=0.0063}');
    Error('\P{Nv=0.0063}');
    Expect(1, 73665, '\p{Nv:6.25000e-03}', "");
    Expect(0, 73665, '\p{^Nv:6.25000e-03}', "");
    Expect(0, 73665, '\P{Nv:6.25000e-03}', "");
    Expect(1, 73665, '\P{^Nv:6.25000e-03}', "");
    Expect(0, 73666, '\p{Nv:6.25000e-03}', "");
    Expect(1, 73666, '\p{^Nv:6.25000e-03}', "");
    Expect(1, 73666, '\P{Nv:6.25000e-03}', "");
    Expect(0, 73666, '\P{^Nv:6.25000e-03}', "");
    Expect(1, 73665, '\p{Nv=0.00625}', "");
    Expect(0, 73665, '\p{^Nv=0.00625}', "");
    Expect(0, 73665, '\P{Nv=0.00625}', "");
    Expect(1, 73665, '\P{^Nv=0.00625}', "");
    Expect(0, 73666, '\p{Nv=0.00625}', "");
    Expect(1, 73666, '\p{^Nv=0.00625}', "");
    Expect(1, 73666, '\P{Nv=0.00625}', "");
    Expect(0, 73666, '\P{^Nv=0.00625}', "");
    Expect(1, 73665, '\p{Nv=6.250000e-03}', "");
    Expect(0, 73665, '\p{^Nv=6.250000e-03}', "");
    Expect(0, 73665, '\P{Nv=6.250000e-03}', "");
    Expect(1, 73665, '\P{^Nv=6.250000e-03}', "");
    Expect(0, 73666, '\p{Nv=6.250000e-03}', "");
    Expect(1, 73666, '\p{^Nv=6.250000e-03}', "");
    Expect(1, 73666, '\P{Nv=6.250000e-03}', "");
    Expect(0, 73666, '\P{^Nv=6.250000e-03}', "");
    Expect(1, 73665, '\p{Nv=0.006250}', "");
    Expect(0, 73665, '\p{^Nv=0.006250}', "");
    Expect(0, 73665, '\P{Nv=0.006250}', "");
    Expect(1, 73665, '\P{^Nv=0.006250}', "");
    Expect(0, 73666, '\p{Nv=0.006250}', "");
    Expect(1, 73666, '\p{^Nv=0.006250}', "");
    Expect(1, 73666, '\P{Nv=0.006250}', "");
    Expect(0, 73666, '\P{^Nv=0.006250}', "");
    Error('\p{Is_Numeric_Value=/a/+1/00000160}');
    Error('\P{Is_Numeric_Value=/a/+1/00000160}');
    Expect(1, 73665, '\p{Is_Numeric_Value:	+000001/00160}', "");
    Expect(0, 73665, '\p{^Is_Numeric_Value:	+000001/00160}', "");
    Expect(0, 73665, '\P{Is_Numeric_Value:	+000001/00160}', "");
    Expect(1, 73665, '\P{^Is_Numeric_Value:	+000001/00160}', "");
    Expect(0, 73666, '\p{Is_Numeric_Value:	+000001/00160}', "");
    Expect(1, 73666, '\p{^Is_Numeric_Value:	+000001/00160}', "");
    Expect(1, 73666, '\P{Is_Numeric_Value:	+000001/00160}', "");
    Expect(0, 73666, '\P{^Is_Numeric_Value:	+000001/00160}', "");
    Expect(1, 73665, '\p{Is_Numeric_Value=60/9600}', "");
    Expect(0, 73665, '\p{^Is_Numeric_Value=60/9600}', "");
    Expect(0, 73665, '\P{Is_Numeric_Value=60/9600}', "");
    Expect(1, 73665, '\P{^Is_Numeric_Value=60/9600}', "");
    Expect(0, 73666, '\p{Is_Numeric_Value=60/9600}', "");
    Expect(1, 73666, '\p{^Is_Numeric_Value=60/9600}', "");
    Expect(1, 73666, '\P{Is_Numeric_Value=60/9600}', "");
    Expect(0, 73666, '\P{^Is_Numeric_Value=60/9600}', "");
    Error('\p{Is_Numeric_Value=6.3e-03}');
    Error('\P{Is_Numeric_Value=6.3e-03}');
    Expect(1, 73665, '\p{Is_Numeric_Value=6.25e-03}', "");
    Expect(0, 73665, '\p{^Is_Numeric_Value=6.25e-03}', "");
    Expect(0, 73665, '\P{Is_Numeric_Value=6.25e-03}', "");
    Expect(1, 73665, '\P{^Is_Numeric_Value=6.25e-03}', "");
    Expect(0, 73666, '\p{Is_Numeric_Value=6.25e-03}', "");
    Expect(1, 73666, '\p{^Is_Numeric_Value=6.25e-03}', "");
    Expect(1, 73666, '\P{Is_Numeric_Value=6.25e-03}', "");
    Expect(0, 73666, '\P{^Is_Numeric_Value=6.25e-03}', "");
    Error('\p{Is_Numeric_Value:   0.01}');
    Error('\P{Is_Numeric_Value:   0.01}');
    Expect(1, 73665, '\p{Is_Numeric_Value=6.250e-03}', "");
    Expect(0, 73665, '\p{^Is_Numeric_Value=6.250e-03}', "");
    Expect(0, 73665, '\P{Is_Numeric_Value=6.250e-03}', "");
    Expect(1, 73665, '\P{^Is_Numeric_Value=6.250e-03}', "");
    Expect(0, 73666, '\p{Is_Numeric_Value=6.250e-03}', "");
    Expect(1, 73666, '\p{^Is_Numeric_Value=6.250e-03}', "");
    Expect(1, 73666, '\P{Is_Numeric_Value=6.250e-03}', "");
    Expect(0, 73666, '\P{^Is_Numeric_Value=6.250e-03}', "");
    Error('\p{Is_Numeric_Value=0.006}');
    Error('\P{Is_Numeric_Value=0.006}');
    Expect(1, 73665, '\p{Is_Numeric_Value=6.2500e-03}', "");
    Expect(0, 73665, '\p{^Is_Numeric_Value=6.2500e-03}', "");
    Expect(0, 73665, '\P{Is_Numeric_Value=6.2500e-03}', "");
    Expect(1, 73665, '\P{^Is_Numeric_Value=6.2500e-03}', "");
    Expect(0, 73666, '\p{Is_Numeric_Value=6.2500e-03}', "");
    Expect(1, 73666, '\p{^Is_Numeric_Value=6.2500e-03}', "");
    Expect(1, 73666, '\P{Is_Numeric_Value=6.2500e-03}', "");
    Expect(0, 73666, '\P{^Is_Numeric_Value=6.2500e-03}', "");
    Error('\p{Is_Numeric_Value=0.0063}');
    Error('\P{Is_Numeric_Value=0.0063}');
    Expect(1, 73665, '\p{Is_Numeric_Value=6.25000e-03}', "");
    Expect(0, 73665, '\p{^Is_Numeric_Value=6.25000e-03}', "");
    Expect(0, 73665, '\P{Is_Numeric_Value=6.25000e-03}', "");
    Expect(1, 73665, '\P{^Is_Numeric_Value=6.25000e-03}', "");
    Expect(0, 73666, '\p{Is_Numeric_Value=6.25000e-03}', "");
    Expect(1, 73666, '\p{^Is_Numeric_Value=6.25000e-03}', "");
    Expect(1, 73666, '\P{Is_Numeric_Value=6.25000e-03}', "");
    Expect(0, 73666, '\P{^Is_Numeric_Value=6.25000e-03}', "");
    Expect(1, 73665, '\p{Is_Numeric_Value:0.00625}', "");
    Expect(0, 73665, '\p{^Is_Numeric_Value:0.00625}', "");
    Expect(0, 73665, '\P{Is_Numeric_Value:0.00625}', "");
    Expect(1, 73665, '\P{^Is_Numeric_Value:0.00625}', "");
    Expect(0, 73666, '\p{Is_Numeric_Value:0.00625}', "");
    Expect(1, 73666, '\p{^Is_Numeric_Value:0.00625}', "");
    Expect(1, 73666, '\P{Is_Numeric_Value:0.00625}', "");
    Expect(0, 73666, '\P{^Is_Numeric_Value:0.00625}', "");
    Expect(1, 73665, '\p{Is_Numeric_Value=6.250000e-03}', "");
    Expect(0, 73665, '\p{^Is_Numeric_Value=6.250000e-03}', "");
    Expect(0, 73665, '\P{Is_Numeric_Value=6.250000e-03}', "");
    Expect(1, 73665, '\P{^Is_Numeric_Value=6.250000e-03}', "");
    Expect(0, 73666, '\p{Is_Numeric_Value=6.250000e-03}', "");
    Expect(1, 73666, '\p{^Is_Numeric_Value=6.250000e-03}', "");
    Expect(1, 73666, '\P{Is_Numeric_Value=6.250000e-03}', "");
    Expect(0, 73666, '\P{^Is_Numeric_Value=6.250000e-03}', "");
    Expect(1, 73665, '\p{Is_Numeric_Value=0.006250}', "");
    Expect(0, 73665, '\p{^Is_Numeric_Value=0.006250}', "");
    Expect(0, 73665, '\P{Is_Numeric_Value=0.006250}', "");
    Expect(1, 73665, '\P{^Is_Numeric_Value=0.006250}', "");
    Expect(0, 73666, '\p{Is_Numeric_Value=0.006250}', "");
    Expect(1, 73666, '\p{^Is_Numeric_Value=0.006250}', "");
    Expect(1, 73666, '\P{Is_Numeric_Value=0.006250}', "");
    Expect(0, 73666, '\P{^Is_Numeric_Value=0.006250}', "");
    Error('\p{Is_Nv=:=000001/0000000160}');
    Error('\P{Is_Nv=:=000001/0000000160}');
    Expect(1, 73665, '\p{Is_Nv=000001/000160}', "");
    Expect(0, 73665, '\p{^Is_Nv=000001/000160}', "");
    Expect(0, 73665, '\P{Is_Nv=000001/000160}', "");
    Expect(1, 73665, '\P{^Is_Nv=000001/000160}', "");
    Expect(0, 73666, '\p{Is_Nv=000001/000160}', "");
    Expect(1, 73666, '\p{^Is_Nv=000001/000160}', "");
    Expect(1, 73666, '\P{Is_Nv=000001/000160}', "");
    Expect(0, 73666, '\P{^Is_Nv=000001/000160}', "");
    Expect(1, 73665, '\p{Is_Nv=60/9600}', "");
    Expect(0, 73665, '\p{^Is_Nv=60/9600}', "");
    Expect(0, 73665, '\P{Is_Nv=60/9600}', "");
    Expect(1, 73665, '\P{^Is_Nv=60/9600}', "");
    Expect(0, 73666, '\p{Is_Nv=60/9600}', "");
    Expect(1, 73666, '\p{^Is_Nv=60/9600}', "");
    Expect(1, 73666, '\P{Is_Nv=60/9600}', "");
    Expect(0, 73666, '\P{^Is_Nv=60/9600}', "");
    Error('\p{Is_Nv=6.3e-03}');
    Error('\P{Is_Nv=6.3e-03}');
    Expect(1, 73665, '\p{Is_Nv=6.25e-03}', "");
    Expect(0, 73665, '\p{^Is_Nv=6.25e-03}', "");
    Expect(0, 73665, '\P{Is_Nv=6.25e-03}', "");
    Expect(1, 73665, '\P{^Is_Nv=6.25e-03}', "");
    Expect(0, 73666, '\p{Is_Nv=6.25e-03}', "");
    Expect(1, 73666, '\p{^Is_Nv=6.25e-03}', "");
    Expect(1, 73666, '\P{Is_Nv=6.25e-03}', "");
    Expect(0, 73666, '\P{^Is_Nv=6.25e-03}', "");
    Error('\p{Is_Nv=0.01}');
    Error('\P{Is_Nv=0.01}');
    Expect(1, 73665, '\p{Is_Nv=6.250e-03}', "");
    Expect(0, 73665, '\p{^Is_Nv=6.250e-03}', "");
    Expect(0, 73665, '\P{Is_Nv=6.250e-03}', "");
    Expect(1, 73665, '\P{^Is_Nv=6.250e-03}', "");
    Expect(0, 73666, '\p{Is_Nv=6.250e-03}', "");
    Expect(1, 73666, '\p{^Is_Nv=6.250e-03}', "");
    Expect(1, 73666, '\P{Is_Nv=6.250e-03}', "");
    Expect(0, 73666, '\P{^Is_Nv=6.250e-03}', "");
    Error('\p{Is_Nv=0.006}');
    Error('\P{Is_Nv=0.006}');
    Expect(1, 73665, '\p{Is_Nv: 6.2500e-03}', "");
    Expect(0, 73665, '\p{^Is_Nv: 6.2500e-03}', "");
    Expect(0, 73665, '\P{Is_Nv: 6.2500e-03}', "");
    Expect(1, 73665, '\P{^Is_Nv: 6.2500e-03}', "");
    Expect(0, 73666, '\p{Is_Nv: 6.2500e-03}', "");
    Expect(1, 73666, '\p{^Is_Nv: 6.2500e-03}', "");
    Expect(1, 73666, '\P{Is_Nv: 6.2500e-03}', "");
    Expect(0, 73666, '\P{^Is_Nv: 6.2500e-03}', "");
    Error('\p{Is_Nv=0.0063}');
    Error('\P{Is_Nv=0.0063}');
    Expect(1, 73665, '\p{Is_Nv=6.25000e-03}', "");
    Expect(0, 73665, '\p{^Is_Nv=6.25000e-03}', "");
    Expect(0, 73665, '\P{Is_Nv=6.25000e-03}', "");
    Expect(1, 73665, '\P{^Is_Nv=6.25000e-03}', "");
    Expect(0, 73666, '\p{Is_Nv=6.25000e-03}', "");
    Expect(1, 73666, '\p{^Is_Nv=6.25000e-03}', "");
    Expect(1, 73666, '\P{Is_Nv=6.25000e-03}', "");
    Expect(0, 73666, '\P{^Is_Nv=6.25000e-03}', "");
    Expect(1, 73665, '\p{Is_Nv=0.00625}', "");
    Expect(0, 73665, '\p{^Is_Nv=0.00625}', "");
    Expect(0, 73665, '\P{Is_Nv=0.00625}', "");
    Expect(1, 73665, '\P{^Is_Nv=0.00625}', "");
    Expect(0, 73666, '\p{Is_Nv=0.00625}', "");
    Expect(1, 73666, '\p{^Is_Nv=0.00625}', "");
    Expect(1, 73666, '\P{Is_Nv=0.00625}', "");
    Expect(0, 73666, '\P{^Is_Nv=0.00625}', "");
    Expect(1, 73665, '\p{Is_Nv=6.250000e-03}', "");
    Expect(0, 73665, '\p{^Is_Nv=6.250000e-03}', "");
    Expect(0, 73665, '\P{Is_Nv=6.250000e-03}', "");
    Expect(1, 73665, '\P{^Is_Nv=6.250000e-03}', "");
    Expect(0, 73666, '\p{Is_Nv=6.250000e-03}', "");
    Expect(1, 73666, '\p{^Is_Nv=6.250000e-03}', "");
    Expect(1, 73666, '\P{Is_Nv=6.250000e-03}', "");
    Expect(0, 73666, '\P{^Is_Nv=6.250000e-03}', "");
    Expect(1, 73665, '\p{Is_Nv: 0.006250}', "");
    Expect(0, 73665, '\p{^Is_Nv: 0.006250}', "");
    Expect(0, 73665, '\P{Is_Nv: 0.006250}', "");
    Expect(1, 73665, '\P{^Is_Nv: 0.006250}', "");
    Expect(0, 73666, '\p{Is_Nv: 0.006250}', "");
    Expect(1, 73666, '\p{^Is_Nv: 0.006250}', "");
    Expect(1, 73666, '\P{Is_Nv: 0.006250}', "");
    Expect(0, 73666, '\P{^Is_Nv: 0.006250}', "");
    Error('\p{Numeric_Value= _+01/000000002/a/}');
    Error('\P{Numeric_Value= _+01/000000002/a/}');
    Expect(1, 126268, '\p{Numeric_Value=:\A1/2\z:}', "");;
    Expect(0, 126269, '\p{Numeric_Value=:\A1/2\z:}', "");;
    Expect(1, 126268, '\p{Numeric_Value=001/002}', "");
    Expect(0, 126268, '\p{^Numeric_Value=001/002}', "");
    Expect(0, 126268, '\P{Numeric_Value=001/002}', "");
    Expect(1, 126268, '\P{^Numeric_Value=001/002}', "");
    Expect(0, 126269, '\p{Numeric_Value=001/002}', "");
    Expect(1, 126269, '\p{^Numeric_Value=001/002}', "");
    Expect(1, 126269, '\P{Numeric_Value=001/002}', "");
    Expect(0, 126269, '\P{^Numeric_Value=001/002}', "");
    Expect(1, 126268, '\p{Numeric_Value=60/120}', "");
    Expect(0, 126268, '\p{^Numeric_Value=60/120}', "");
    Expect(0, 126268, '\P{Numeric_Value=60/120}', "");
    Expect(1, 126268, '\P{^Numeric_Value=60/120}', "");
    Expect(0, 126269, '\p{Numeric_Value=60/120}', "");
    Expect(1, 126269, '\p{^Numeric_Value=60/120}', "");
    Expect(1, 126269, '\P{Numeric_Value=60/120}', "");
    Expect(0, 126269, '\P{^Numeric_Value=60/120}', "");
    Expect(1, 126268, '\p{Numeric_Value=5.0e-01}', "");
    Expect(0, 126268, '\p{^Numeric_Value=5.0e-01}', "");
    Expect(0, 126268, '\P{Numeric_Value=5.0e-01}', "");
    Expect(1, 126268, '\P{^Numeric_Value=5.0e-01}', "");
    Expect(0, 126269, '\p{Numeric_Value=5.0e-01}', "");
    Expect(1, 126269, '\p{^Numeric_Value=5.0e-01}', "");
    Expect(1, 126269, '\P{Numeric_Value=5.0e-01}', "");
    Expect(0, 126269, '\P{^Numeric_Value=5.0e-01}', "");
    Expect(1, 126268, '\p{Numeric_Value=0.5}', "");
    Expect(0, 126268, '\p{^Numeric_Value=0.5}', "");
    Expect(0, 126268, '\P{Numeric_Value=0.5}', "");
    Expect(1, 126268, '\P{^Numeric_Value=0.5}', "");
    Expect(0, 126269, '\p{Numeric_Value=0.5}', "");
    Expect(1, 126269, '\p{^Numeric_Value=0.5}', "");
    Expect(1, 126269, '\P{Numeric_Value=0.5}', "");
    Expect(0, 126269, '\P{^Numeric_Value=0.5}', "");
    Expect(1, 126268, '\p{Numeric_Value=5.00e-01}', "");
    Expect(0, 126268, '\p{^Numeric_Value=5.00e-01}', "");
    Expect(0, 126268, '\P{Numeric_Value=5.00e-01}', "");
    Expect(1, 126268, '\P{^Numeric_Value=5.00e-01}', "");
    Expect(0, 126269, '\p{Numeric_Value=5.00e-01}', "");
    Expect(1, 126269, '\p{^Numeric_Value=5.00e-01}', "");
    Expect(1, 126269, '\P{Numeric_Value=5.00e-01}', "");
    Expect(0, 126269, '\P{^Numeric_Value=5.00e-01}', "");
    Expect(1, 126268, '\p{Numeric_Value=0.50}', "");
    Expect(0, 126268, '\p{^Numeric_Value=0.50}', "");
    Expect(0, 126268, '\P{Numeric_Value=0.50}', "");
    Expect(1, 126268, '\P{^Numeric_Value=0.50}', "");
    Expect(0, 126269, '\p{Numeric_Value=0.50}', "");
    Expect(1, 126269, '\p{^Numeric_Value=0.50}', "");
    Expect(1, 126269, '\P{Numeric_Value=0.50}', "");
    Expect(0, 126269, '\P{^Numeric_Value=0.50}', "");
    Error('\p{Nv=-:=0000001/0000000002}');
    Error('\P{Nv=-:=0000001/0000000002}');
    Expect(1, 126268, '\p{Nv=:\A1/2\z:}', "");;
    Expect(0, 126269, '\p{Nv=:\A1/2\z:}', "");;
    Expect(1, 126268, '\p{Nv=0001/0002}', "");
    Expect(0, 126268, '\p{^Nv=0001/0002}', "");
    Expect(0, 126268, '\P{Nv=0001/0002}', "");
    Expect(1, 126268, '\P{^Nv=0001/0002}', "");
    Expect(0, 126269, '\p{Nv=0001/0002}', "");
    Expect(1, 126269, '\p{^Nv=0001/0002}', "");
    Expect(1, 126269, '\P{Nv=0001/0002}', "");
    Expect(0, 126269, '\P{^Nv=0001/0002}', "");
    Expect(1, 126268, '\p{Nv:   60/120}', "");
    Expect(0, 126268, '\p{^Nv:   60/120}', "");
    Expect(0, 126268, '\P{Nv:   60/120}', "");
    Expect(1, 126268, '\P{^Nv:   60/120}', "");
    Expect(0, 126269, '\p{Nv:   60/120}', "");
    Expect(1, 126269, '\p{^Nv:   60/120}', "");
    Expect(1, 126269, '\P{Nv:   60/120}', "");
    Expect(0, 126269, '\P{^Nv:   60/120}', "");
    Expect(1, 126268, '\p{Nv=5.0e-01}', "");
    Expect(0, 126268, '\p{^Nv=5.0e-01}', "");
    Expect(0, 126268, '\P{Nv=5.0e-01}', "");
    Expect(1, 126268, '\P{^Nv=5.0e-01}', "");
    Expect(0, 126269, '\p{Nv=5.0e-01}', "");
    Expect(1, 126269, '\p{^Nv=5.0e-01}', "");
    Expect(1, 126269, '\P{Nv=5.0e-01}', "");
    Expect(0, 126269, '\P{^Nv=5.0e-01}', "");
    Expect(1, 126268, '\p{Nv=0.5}', "");
    Expect(0, 126268, '\p{^Nv=0.5}', "");
    Expect(0, 126268, '\P{Nv=0.5}', "");
    Expect(1, 126268, '\P{^Nv=0.5}', "");
    Expect(0, 126269, '\p{Nv=0.5}', "");
    Expect(1, 126269, '\p{^Nv=0.5}', "");
    Expect(1, 126269, '\P{Nv=0.5}', "");
    Expect(0, 126269, '\P{^Nv=0.5}', "");
    Expect(1, 126268, '\p{Nv=5.00e-01}', "");
    Expect(0, 126268, '\p{^Nv=5.00e-01}', "");
    Expect(0, 126268, '\P{Nv=5.00e-01}', "");
    Expect(1, 126268, '\P{^Nv=5.00e-01}', "");
    Expect(0, 126269, '\p{Nv=5.00e-01}', "");
    Expect(1, 126269, '\p{^Nv=5.00e-01}', "");
    Expect(1, 126269, '\P{Nv=5.00e-01}', "");
    Expect(0, 126269, '\P{^Nv=5.00e-01}', "");
    Expect(1, 126268, '\p{Nv=0.50}', "");
    Expect(0, 126268, '\p{^Nv=0.50}', "");
    Expect(0, 126268, '\P{Nv=0.50}', "");
    Expect(1, 126268, '\P{^Nv=0.50}', "");
    Expect(0, 126269, '\p{Nv=0.50}', "");
    Expect(1, 126269, '\p{^Nv=0.50}', "");
    Expect(1, 126269, '\P{Nv=0.50}', "");
    Expect(0, 126269, '\P{^Nv=0.50}', "");
    Error('\p{Is_Numeric_Value=_/a/0000000001/002}');
    Error('\P{Is_Numeric_Value=_/a/0000000001/002}');
    Expect(1, 126268, '\p{Is_Numeric_Value=00000001/2}', "");
    Expect(0, 126268, '\p{^Is_Numeric_Value=00000001/2}', "");
    Expect(0, 126268, '\P{Is_Numeric_Value=00000001/2}', "");
    Expect(1, 126268, '\P{^Is_Numeric_Value=00000001/2}', "");
    Expect(0, 126269, '\p{Is_Numeric_Value=00000001/2}', "");
    Expect(1, 126269, '\p{^Is_Numeric_Value=00000001/2}', "");
    Expect(1, 126269, '\P{Is_Numeric_Value=00000001/2}', "");
    Expect(0, 126269, '\P{^Is_Numeric_Value=00000001/2}', "");
    Expect(1, 126268, '\p{Is_Numeric_Value=60/120}', "");
    Expect(0, 126268, '\p{^Is_Numeric_Value=60/120}', "");
    Expect(0, 126268, '\P{Is_Numeric_Value=60/120}', "");
    Expect(1, 126268, '\P{^Is_Numeric_Value=60/120}', "");
    Expect(0, 126269, '\p{Is_Numeric_Value=60/120}', "");
    Expect(1, 126269, '\p{^Is_Numeric_Value=60/120}', "");
    Expect(1, 126269, '\P{Is_Numeric_Value=60/120}', "");
    Expect(0, 126269, '\P{^Is_Numeric_Value=60/120}', "");
    Expect(1, 126268, '\p{Is_Numeric_Value=5.0e-01}', "");
    Expect(0, 126268, '\p{^Is_Numeric_Value=5.0e-01}', "");
    Expect(0, 126268, '\P{Is_Numeric_Value=5.0e-01}', "");
    Expect(1, 126268, '\P{^Is_Numeric_Value=5.0e-01}', "");
    Expect(0, 126269, '\p{Is_Numeric_Value=5.0e-01}', "");
    Expect(1, 126269, '\p{^Is_Numeric_Value=5.0e-01}', "");
    Expect(1, 126269, '\P{Is_Numeric_Value=5.0e-01}', "");
    Expect(0, 126269, '\P{^Is_Numeric_Value=5.0e-01}', "");
    Expect(1, 126268, '\p{Is_Numeric_Value=0.5}', "");
    Expect(0, 126268, '\p{^Is_Numeric_Value=0.5}', "");
    Expect(0, 126268, '\P{Is_Numeric_Value=0.5}', "");
    Expect(1, 126268, '\P{^Is_Numeric_Value=0.5}', "");
    Expect(0, 126269, '\p{Is_Numeric_Value=0.5}', "");
    Expect(1, 126269, '\p{^Is_Numeric_Value=0.5}', "");
    Expect(1, 126269, '\P{Is_Numeric_Value=0.5}', "");
    Expect(0, 126269, '\P{^Is_Numeric_Value=0.5}', "");
    Expect(1, 126268, '\p{Is_Numeric_Value=5.00e-01}', "");
    Expect(0, 126268, '\p{^Is_Numeric_Value=5.00e-01}', "");
    Expect(0, 126268, '\P{Is_Numeric_Value=5.00e-01}', "");
    Expect(1, 126268, '\P{^Is_Numeric_Value=5.00e-01}', "");
    Expect(0, 126269, '\p{Is_Numeric_Value=5.00e-01}', "");
    Expect(1, 126269, '\p{^Is_Numeric_Value=5.00e-01}', "");
    Expect(1, 126269, '\P{Is_Numeric_Value=5.00e-01}', "");
    Expect(0, 126269, '\P{^Is_Numeric_Value=5.00e-01}', "");
    Expect(1, 126268, '\p{Is_Numeric_Value=0.50}', "");
    Expect(0, 126268, '\p{^Is_Numeric_Value=0.50}', "");
    Expect(0, 126268, '\P{Is_Numeric_Value=0.50}', "");
    Expect(1, 126268, '\P{^Is_Numeric_Value=0.50}', "");
    Expect(0, 126269, '\p{Is_Numeric_Value=0.50}', "");
    Expect(1, 126269, '\p{^Is_Numeric_Value=0.50}', "");
    Expect(1, 126269, '\P{Is_Numeric_Value=0.50}', "");
    Expect(0, 126269, '\P{^Is_Numeric_Value=0.50}', "");
    Error('\p{Is_Nv= /a/+1/0000000002}');
    Error('\P{Is_Nv= /a/+1/0000000002}');
    Expect(1, 126268, '\p{Is_Nv=+000000001/0002}', "");
    Expect(0, 126268, '\p{^Is_Nv=+000000001/0002}', "");
    Expect(0, 126268, '\P{Is_Nv=+000000001/0002}', "");
    Expect(1, 126268, '\P{^Is_Nv=+000000001/0002}', "");
    Expect(0, 126269, '\p{Is_Nv=+000000001/0002}', "");
    Expect(1, 126269, '\p{^Is_Nv=+000000001/0002}', "");
    Expect(1, 126269, '\P{Is_Nv=+000000001/0002}', "");
    Expect(0, 126269, '\P{^Is_Nv=+000000001/0002}', "");
    Expect(1, 126268, '\p{Is_Nv=60/120}', "");
    Expect(0, 126268, '\p{^Is_Nv=60/120}', "");
    Expect(0, 126268, '\P{Is_Nv=60/120}', "");
    Expect(1, 126268, '\P{^Is_Nv=60/120}', "");
    Expect(0, 126269, '\p{Is_Nv=60/120}', "");
    Expect(1, 126269, '\p{^Is_Nv=60/120}', "");
    Expect(1, 126269, '\P{Is_Nv=60/120}', "");
    Expect(0, 126269, '\P{^Is_Nv=60/120}', "");
    Expect(1, 126268, '\p{Is_Nv=5.0e-01}', "");
    Expect(0, 126268, '\p{^Is_Nv=5.0e-01}', "");
    Expect(0, 126268, '\P{Is_Nv=5.0e-01}', "");
    Expect(1, 126268, '\P{^Is_Nv=5.0e-01}', "");
    Expect(0, 126269, '\p{Is_Nv=5.0e-01}', "");
    Expect(1, 126269, '\p{^Is_Nv=5.0e-01}', "");
    Expect(1, 126269, '\P{Is_Nv=5.0e-01}', "");
    Expect(0, 126269, '\P{^Is_Nv=5.0e-01}', "");
    Expect(1, 126268, '\p{Is_Nv=0.5}', "");
    Expect(0, 126268, '\p{^Is_Nv=0.5}', "");
    Expect(0, 126268, '\P{Is_Nv=0.5}', "");
    Expect(1, 126268, '\P{^Is_Nv=0.5}', "");
    Expect(0, 126269, '\p{Is_Nv=0.5}', "");
    Expect(1, 126269, '\p{^Is_Nv=0.5}', "");
    Expect(1, 126269, '\P{Is_Nv=0.5}', "");
    Expect(0, 126269, '\P{^Is_Nv=0.5}', "");
    Expect(1, 126268, '\p{Is_Nv=5.00e-01}', "");
    Expect(0, 126268, '\p{^Is_Nv=5.00e-01}', "");
    Expect(0, 126268, '\P{Is_Nv=5.00e-01}', "");
    Expect(1, 126268, '\P{^Is_Nv=5.00e-01}', "");
    Expect(0, 126269, '\p{Is_Nv=5.00e-01}', "");
    Expect(1, 126269, '\p{^Is_Nv=5.00e-01}', "");
    Expect(1, 126269, '\P{Is_Nv=5.00e-01}', "");
    Expect(0, 126269, '\P{^Is_Nv=5.00e-01}', "");
    Expect(1, 126268, '\p{Is_Nv=0.50}', "");
    Expect(0, 126268, '\p{^Is_Nv=0.50}', "");
    Expect(0, 126268, '\P{Is_Nv=0.50}', "");
    Expect(1, 126268, '\P{^Is_Nv=0.50}', "");
    Expect(0, 126269, '\p{Is_Nv=0.50}', "");
    Expect(1, 126269, '\p{^Is_Nv=0.50}', "");
    Expect(1, 126269, '\P{Is_Nv=0.50}', "");
    Expect(0, 126269, '\P{^Is_Nv=0.50}', "");
    Error('\p{Numeric_Value=  1/0020/a/}');
    Error('\P{Numeric_Value=  1/0020/a/}');
    Expect(1, 73672, '\p{Numeric_Value=:\A1/20\z:}', "");;
    Expect(0, 73673, '\p{Numeric_Value=:\A1/20\z:}', "");;
    Expect(1, 73672, '\p{Numeric_Value=+01/000020}', "");
    Expect(0, 73672, '\p{^Numeric_Value=+01/000020}', "");
    Expect(0, 73672, '\P{Numeric_Value=+01/000020}', "");
    Expect(1, 73672, '\P{^Numeric_Value=+01/000020}', "");
    Expect(0, 73673, '\p{Numeric_Value=+01/000020}', "");
    Expect(1, 73673, '\p{^Numeric_Value=+01/000020}', "");
    Expect(1, 73673, '\P{Numeric_Value=+01/000020}', "");
    Expect(0, 73673, '\P{^Numeric_Value=+01/000020}', "");
    Expect(1, 73672, '\p{Numeric_Value:	60/1200}', "");
    Expect(0, 73672, '\p{^Numeric_Value:	60/1200}', "");
    Expect(0, 73672, '\P{Numeric_Value:	60/1200}', "");
    Expect(1, 73672, '\P{^Numeric_Value:	60/1200}', "");
    Expect(0, 73673, '\p{Numeric_Value:	60/1200}', "");
    Expect(1, 73673, '\p{^Numeric_Value:	60/1200}', "");
    Expect(1, 73673, '\P{Numeric_Value:	60/1200}', "");
    Expect(0, 73673, '\P{^Numeric_Value:	60/1200}', "");
    Expect(1, 73672, '\p{Numeric_Value=5.0e-02}', "");
    Expect(0, 73672, '\p{^Numeric_Value=5.0e-02}', "");
    Expect(0, 73672, '\P{Numeric_Value=5.0e-02}', "");
    Expect(1, 73672, '\P{^Numeric_Value=5.0e-02}', "");
    Expect(0, 73673, '\p{Numeric_Value=5.0e-02}', "");
    Expect(1, 73673, '\p{^Numeric_Value=5.0e-02}', "");
    Expect(1, 73673, '\P{Numeric_Value=5.0e-02}', "");
    Expect(0, 73673, '\P{^Numeric_Value=5.0e-02}', "");
    Expect(1, 73672, '\p{Numeric_Value=5.00e-02}', "");
    Expect(0, 73672, '\p{^Numeric_Value=5.00e-02}', "");
    Expect(0, 73672, '\P{Numeric_Value=5.00e-02}', "");
    Expect(1, 73672, '\P{^Numeric_Value=5.00e-02}', "");
    Expect(0, 73673, '\p{Numeric_Value=5.00e-02}', "");
    Expect(1, 73673, '\p{^Numeric_Value=5.00e-02}', "");
    Expect(1, 73673, '\P{Numeric_Value=5.00e-02}', "");
    Expect(0, 73673, '\P{^Numeric_Value=5.00e-02}', "");
    Expect(1, 73672, '\p{Numeric_Value:   0.05}', "");
    Expect(0, 73672, '\p{^Numeric_Value:   0.05}', "");
    Expect(0, 73672, '\P{Numeric_Value:   0.05}', "");
    Expect(1, 73672, '\P{^Numeric_Value:   0.05}', "");
    Expect(0, 73673, '\p{Numeric_Value:   0.05}', "");
    Expect(1, 73673, '\p{^Numeric_Value:   0.05}', "");
    Expect(1, 73673, '\P{Numeric_Value:   0.05}', "");
    Expect(0, 73673, '\P{^Numeric_Value:   0.05}', "");
    Expect(1, 73672, '\p{Numeric_Value=5.000e-02}', "");
    Expect(0, 73672, '\p{^Numeric_Value=5.000e-02}', "");
    Expect(0, 73672, '\P{Numeric_Value=5.000e-02}', "");
    Expect(1, 73672, '\P{^Numeric_Value=5.000e-02}', "");
    Expect(0, 73673, '\p{Numeric_Value=5.000e-02}', "");
    Expect(1, 73673, '\p{^Numeric_Value=5.000e-02}', "");
    Expect(1, 73673, '\P{Numeric_Value=5.000e-02}', "");
    Expect(0, 73673, '\P{^Numeric_Value=5.000e-02}', "");
    Expect(1, 73672, '\p{Numeric_Value=0.050}', "");
    Expect(0, 73672, '\p{^Numeric_Value=0.050}', "");
    Expect(0, 73672, '\P{Numeric_Value=0.050}', "");
    Expect(1, 73672, '\P{^Numeric_Value=0.050}', "");
    Expect(0, 73673, '\p{Numeric_Value=0.050}', "");
    Expect(1, 73673, '\p{^Numeric_Value=0.050}', "");
    Expect(1, 73673, '\P{Numeric_Value=0.050}', "");
    Expect(0, 73673, '\P{^Numeric_Value=0.050}', "");
    Error('\p{Nv=	:=+001/020}');
    Error('\P{Nv=	:=+001/020}');
    Expect(1, 73672, '\p{Nv=:\A1/20\z:}', "");;
    Expect(0, 73673, '\p{Nv=:\A1/20\z:}', "");;
    Expect(1, 73672, '\p{Nv=+000001/0000020}', "");
    Expect(0, 73672, '\p{^Nv=+000001/0000020}', "");
    Expect(0, 73672, '\P{Nv=+000001/0000020}', "");
    Expect(1, 73672, '\P{^Nv=+000001/0000020}', "");
    Expect(0, 73673, '\p{Nv=+000001/0000020}', "");
    Expect(1, 73673, '\p{^Nv=+000001/0000020}', "");
    Expect(1, 73673, '\P{Nv=+000001/0000020}', "");
    Expect(0, 73673, '\P{^Nv=+000001/0000020}', "");
    Expect(1, 73672, '\p{Nv=60/1200}', "");
    Expect(0, 73672, '\p{^Nv=60/1200}', "");
    Expect(0, 73672, '\P{Nv=60/1200}', "");
    Expect(1, 73672, '\P{^Nv=60/1200}', "");
    Expect(0, 73673, '\p{Nv=60/1200}', "");
    Expect(1, 73673, '\p{^Nv=60/1200}', "");
    Expect(1, 73673, '\P{Nv=60/1200}', "");
    Expect(0, 73673, '\P{^Nv=60/1200}', "");
    Expect(1, 73672, '\p{Nv: 5.0e-02}', "");
    Expect(0, 73672, '\p{^Nv: 5.0e-02}', "");
    Expect(0, 73672, '\P{Nv: 5.0e-02}', "");
    Expect(1, 73672, '\P{^Nv: 5.0e-02}', "");
    Expect(0, 73673, '\p{Nv: 5.0e-02}', "");
    Expect(1, 73673, '\p{^Nv: 5.0e-02}', "");
    Expect(1, 73673, '\P{Nv: 5.0e-02}', "");
    Expect(0, 73673, '\P{^Nv: 5.0e-02}', "");
    Expect(1, 73672, '\p{Nv=5.00e-02}', "");
    Expect(0, 73672, '\p{^Nv=5.00e-02}', "");
    Expect(0, 73672, '\P{Nv=5.00e-02}', "");
    Expect(1, 73672, '\P{^Nv=5.00e-02}', "");
    Expect(0, 73673, '\p{Nv=5.00e-02}', "");
    Expect(1, 73673, '\p{^Nv=5.00e-02}', "");
    Expect(1, 73673, '\P{Nv=5.00e-02}', "");
    Expect(0, 73673, '\P{^Nv=5.00e-02}', "");
    Expect(1, 73672, '\p{Nv=0.05}', "");
    Expect(0, 73672, '\p{^Nv=0.05}', "");
    Expect(0, 73672, '\P{Nv=0.05}', "");
    Expect(1, 73672, '\P{^Nv=0.05}', "");
    Expect(0, 73673, '\p{Nv=0.05}', "");
    Expect(1, 73673, '\p{^Nv=0.05}', "");
    Expect(1, 73673, '\P{Nv=0.05}', "");
    Expect(0, 73673, '\P{^Nv=0.05}', "");
    Expect(1, 73672, '\p{Nv=5.000e-02}', "");
    Expect(0, 73672, '\p{^Nv=5.000e-02}', "");
    Expect(0, 73672, '\P{Nv=5.000e-02}', "");
    Expect(1, 73672, '\P{^Nv=5.000e-02}', "");
    Expect(0, 73673, '\p{Nv=5.000e-02}', "");
    Expect(1, 73673, '\p{^Nv=5.000e-02}', "");
    Expect(1, 73673, '\P{Nv=5.000e-02}', "");
    Expect(0, 73673, '\P{^Nv=5.000e-02}', "");
    Expect(1, 73672, '\p{Nv=0.050}', "");
    Expect(0, 73672, '\p{^Nv=0.050}', "");
    Expect(0, 73672, '\P{Nv=0.050}', "");
    Expect(1, 73672, '\P{^Nv=0.050}', "");
    Expect(0, 73673, '\p{Nv=0.050}', "");
    Expect(1, 73673, '\p{^Nv=0.050}', "");
    Expect(1, 73673, '\P{Nv=0.050}', "");
    Expect(0, 73673, '\P{^Nv=0.050}', "");
    Error('\p{Is_Numeric_Value=	-001/0000000020:=}');
    Error('\P{Is_Numeric_Value=	-001/0000000020:=}');
    Expect(1, 73672, '\p{Is_Numeric_Value=00000001/0000000020}', "");
    Expect(0, 73672, '\p{^Is_Numeric_Value=00000001/0000000020}', "");
    Expect(0, 73672, '\P{Is_Numeric_Value=00000001/0000000020}', "");
    Expect(1, 73672, '\P{^Is_Numeric_Value=00000001/0000000020}', "");
    Expect(0, 73673, '\p{Is_Numeric_Value=00000001/0000000020}', "");
    Expect(1, 73673, '\p{^Is_Numeric_Value=00000001/0000000020}', "");
    Expect(1, 73673, '\P{Is_Numeric_Value=00000001/0000000020}', "");
    Expect(0, 73673, '\P{^Is_Numeric_Value=00000001/0000000020}', "");
    Expect(1, 73672, '\p{Is_Numeric_Value=60/1200}', "");
    Expect(0, 73672, '\p{^Is_Numeric_Value=60/1200}', "");
    Expect(0, 73672, '\P{Is_Numeric_Value=60/1200}', "");
    Expect(1, 73672, '\P{^Is_Numeric_Value=60/1200}', "");
    Expect(0, 73673, '\p{Is_Numeric_Value=60/1200}', "");
    Expect(1, 73673, '\p{^Is_Numeric_Value=60/1200}', "");
    Expect(1, 73673, '\P{Is_Numeric_Value=60/1200}', "");
    Expect(0, 73673, '\P{^Is_Numeric_Value=60/1200}', "");
    Expect(1, 73672, '\p{Is_Numeric_Value=5.0e-02}', "");
    Expect(0, 73672, '\p{^Is_Numeric_Value=5.0e-02}', "");
    Expect(0, 73672, '\P{Is_Numeric_Value=5.0e-02}', "");
    Expect(1, 73672, '\P{^Is_Numeric_Value=5.0e-02}', "");
    Expect(0, 73673, '\p{Is_Numeric_Value=5.0e-02}', "");
    Expect(1, 73673, '\p{^Is_Numeric_Value=5.0e-02}', "");
    Expect(1, 73673, '\P{Is_Numeric_Value=5.0e-02}', "");
    Expect(0, 73673, '\P{^Is_Numeric_Value=5.0e-02}', "");
    Expect(1, 73672, '\p{Is_Numeric_Value=5.00e-02}', "");
    Expect(0, 73672, '\p{^Is_Numeric_Value=5.00e-02}', "");
    Expect(0, 73672, '\P{Is_Numeric_Value=5.00e-02}', "");
    Expect(1, 73672, '\P{^Is_Numeric_Value=5.00e-02}', "");
    Expect(0, 73673, '\p{Is_Numeric_Value=5.00e-02}', "");
    Expect(1, 73673, '\p{^Is_Numeric_Value=5.00e-02}', "");
    Expect(1, 73673, '\P{Is_Numeric_Value=5.00e-02}', "");
    Expect(0, 73673, '\P{^Is_Numeric_Value=5.00e-02}', "");
    Expect(1, 73672, '\p{Is_Numeric_Value=0.05}', "");
    Expect(0, 73672, '\p{^Is_Numeric_Value=0.05}', "");
    Expect(0, 73672, '\P{Is_Numeric_Value=0.05}', "");
    Expect(1, 73672, '\P{^Is_Numeric_Value=0.05}', "");
    Expect(0, 73673, '\p{Is_Numeric_Value=0.05}', "");
    Expect(1, 73673, '\p{^Is_Numeric_Value=0.05}', "");
    Expect(1, 73673, '\P{Is_Numeric_Value=0.05}', "");
    Expect(0, 73673, '\P{^Is_Numeric_Value=0.05}', "");
    Expect(1, 73672, '\p{Is_Numeric_Value=5.000e-02}', "");
    Expect(0, 73672, '\p{^Is_Numeric_Value=5.000e-02}', "");
    Expect(0, 73672, '\P{Is_Numeric_Value=5.000e-02}', "");
    Expect(1, 73672, '\P{^Is_Numeric_Value=5.000e-02}', "");
    Expect(0, 73673, '\p{Is_Numeric_Value=5.000e-02}', "");
    Expect(1, 73673, '\p{^Is_Numeric_Value=5.000e-02}', "");
    Expect(1, 73673, '\P{Is_Numeric_Value=5.000e-02}', "");
    Expect(0, 73673, '\P{^Is_Numeric_Value=5.000e-02}', "");
    Expect(1, 73672, '\p{Is_Numeric_Value=0.050}', "");
    Expect(0, 73672, '\p{^Is_Numeric_Value=0.050}', "");
    Expect(0, 73672, '\P{Is_Numeric_Value=0.050}', "");
    Expect(1, 73672, '\P{^Is_Numeric_Value=0.050}', "");
    Expect(0, 73673, '\p{Is_Numeric_Value=0.050}', "");
    Expect(1, 73673, '\p{^Is_Numeric_Value=0.050}', "");
    Expect(1, 73673, '\P{Is_Numeric_Value=0.050}', "");
    Expect(0, 73673, '\P{^Is_Numeric_Value=0.050}', "");
    Error('\p{Is_Nv=_	001/000000020:=}');
    Error('\P{Is_Nv=_	001/000000020:=}');
    Expect(1, 73672, '\p{Is_Nv=00000001/000000020}', "");
    Expect(0, 73672, '\p{^Is_Nv=00000001/000000020}', "");
    Expect(0, 73672, '\P{Is_Nv=00000001/000000020}', "");
    Expect(1, 73672, '\P{^Is_Nv=00000001/000000020}', "");
    Expect(0, 73673, '\p{Is_Nv=00000001/000000020}', "");
    Expect(1, 73673, '\p{^Is_Nv=00000001/000000020}', "");
    Expect(1, 73673, '\P{Is_Nv=00000001/000000020}', "");
    Expect(0, 73673, '\P{^Is_Nv=00000001/000000020}', "");
    Expect(1, 73672, '\p{Is_Nv=60/1200}', "");
    Expect(0, 73672, '\p{^Is_Nv=60/1200}', "");
    Expect(0, 73672, '\P{Is_Nv=60/1200}', "");
    Expect(1, 73672, '\P{^Is_Nv=60/1200}', "");
    Expect(0, 73673, '\p{Is_Nv=60/1200}', "");
    Expect(1, 73673, '\p{^Is_Nv=60/1200}', "");
    Expect(1, 73673, '\P{Is_Nv=60/1200}', "");
    Expect(0, 73673, '\P{^Is_Nv=60/1200}', "");
    Expect(1, 73672, '\p{Is_Nv:5.0e-02}', "");
    Expect(0, 73672, '\p{^Is_Nv:5.0e-02}', "");
    Expect(0, 73672, '\P{Is_Nv:5.0e-02}', "");
    Expect(1, 73672, '\P{^Is_Nv:5.0e-02}', "");
    Expect(0, 73673, '\p{Is_Nv:5.0e-02}', "");
    Expect(1, 73673, '\p{^Is_Nv:5.0e-02}', "");
    Expect(1, 73673, '\P{Is_Nv:5.0e-02}', "");
    Expect(0, 73673, '\P{^Is_Nv:5.0e-02}', "");
    Expect(1, 73672, '\p{Is_Nv=5.00e-02}', "");
    Expect(0, 73672, '\p{^Is_Nv=5.00e-02}', "");
    Expect(0, 73672, '\P{Is_Nv=5.00e-02}', "");
    Expect(1, 73672, '\P{^Is_Nv=5.00e-02}', "");
    Expect(0, 73673, '\p{Is_Nv=5.00e-02}', "");
    Expect(1, 73673, '\p{^Is_Nv=5.00e-02}', "");
    Expect(1, 73673, '\P{Is_Nv=5.00e-02}', "");
    Expect(0, 73673, '\P{^Is_Nv=5.00e-02}', "");
    Expect(1, 73672, '\p{Is_Nv:	0.05}', "");
    Expect(0, 73672, '\p{^Is_Nv:	0.05}', "");
    Expect(0, 73672, '\P{Is_Nv:	0.05}', "");
    Expect(1, 73672, '\P{^Is_Nv:	0.05}', "");
    Expect(0, 73673, '\p{Is_Nv:	0.05}', "");
    Expect(1, 73673, '\p{^Is_Nv:	0.05}', "");
    Expect(1, 73673, '\P{Is_Nv:	0.05}', "");
    Expect(0, 73673, '\P{^Is_Nv:	0.05}', "");
    Expect(1, 73672, '\p{Is_Nv=5.000e-02}', "");
    Expect(0, 73672, '\p{^Is_Nv=5.000e-02}', "");
    Expect(0, 73672, '\P{Is_Nv=5.000e-02}', "");
    Expect(1, 73672, '\P{^Is_Nv=5.000e-02}', "");
    Expect(0, 73673, '\p{Is_Nv=5.000e-02}', "");
    Expect(1, 73673, '\p{^Is_Nv=5.000e-02}', "");
    Expect(1, 73673, '\P{Is_Nv=5.000e-02}', "");
    Expect(0, 73673, '\P{^Is_Nv=5.000e-02}', "");
    Expect(1, 73672, '\p{Is_Nv=0.050}', "");
    Expect(0, 73672, '\p{^Is_Nv=0.050}', "");
    Expect(0, 73672, '\P{Is_Nv=0.050}', "");
    Expect(1, 73672, '\P{^Is_Nv=0.050}', "");
    Expect(0, 73673, '\p{Is_Nv=0.050}', "");
    Expect(1, 73673, '\p{^Is_Nv=0.050}', "");
    Expect(1, 73673, '\P{Is_Nv=0.050}', "");
    Expect(0, 73673, '\P{^Is_Nv=0.050}', "");
    Error('\p{Numeric_Value:    -+000000001/03:=}');
    Error('\P{Numeric_Value:    -+000000001/03:=}');
    Expect(1, 74853, '\p{Numeric_Value=:\A1/3\z:}', "");;
    Expect(0, 74854, '\p{Numeric_Value=:\A1/3\z:}', "");;
    Expect(1, 74853, '\p{Numeric_Value=+000000001/00003}', "");
    Expect(0, 74853, '\p{^Numeric_Value=+000000001/00003}', "");
    Expect(0, 74853, '\P{Numeric_Value=+000000001/00003}', "");
    Expect(1, 74853, '\P{^Numeric_Value=+000000001/00003}', "");
    Expect(0, 74854, '\p{Numeric_Value=+000000001/00003}', "");
    Expect(1, 74854, '\p{^Numeric_Value=+000000001/00003}', "");
    Expect(1, 74854, '\P{Numeric_Value=+000000001/00003}', "");
    Expect(0, 74854, '\P{^Numeric_Value=+000000001/00003}', "");
    Expect(1, 74853, '\p{Numeric_Value=60/180}', "");
    Expect(0, 74853, '\p{^Numeric_Value=60/180}', "");
    Expect(0, 74853, '\P{Numeric_Value=60/180}', "");
    Expect(1, 74853, '\P{^Numeric_Value=60/180}', "");
    Expect(0, 74854, '\p{Numeric_Value=60/180}', "");
    Expect(1, 74854, '\p{^Numeric_Value=60/180}', "");
    Expect(1, 74854, '\P{Numeric_Value=60/180}', "");
    Expect(0, 74854, '\P{^Numeric_Value=60/180}', "");
    Error('\p{Numeric_Value=3.3e-01}');
    Error('\P{Numeric_Value=3.3e-01}');
    Error('\p{Numeric_Value=0.3}');
    Error('\P{Numeric_Value=0.3}');
    Expect(1, 74853, '\p{Numeric_Value=3.33e-01}', "");
    Expect(0, 74853, '\p{^Numeric_Value=3.33e-01}', "");
    Expect(0, 74853, '\P{Numeric_Value=3.33e-01}', "");
    Expect(1, 74853, '\P{^Numeric_Value=3.33e-01}', "");
    Expect(0, 74854, '\p{Numeric_Value=3.33e-01}', "");
    Expect(1, 74854, '\p{^Numeric_Value=3.33e-01}', "");
    Expect(1, 74854, '\P{Numeric_Value=3.33e-01}', "");
    Expect(0, 74854, '\P{^Numeric_Value=3.33e-01}', "");
    Error('\p{Numeric_Value=0.33}');
    Error('\P{Numeric_Value=0.33}');
    Expect(1, 74853, '\p{Numeric_Value=3.333e-01}', "");
    Expect(0, 74853, '\p{^Numeric_Value=3.333e-01}', "");
    Expect(0, 74853, '\P{Numeric_Value=3.333e-01}', "");
    Expect(1, 74853, '\P{^Numeric_Value=3.333e-01}', "");
    Expect(0, 74854, '\p{Numeric_Value=3.333e-01}', "");
    Expect(1, 74854, '\p{^Numeric_Value=3.333e-01}', "");
    Expect(1, 74854, '\P{Numeric_Value=3.333e-01}', "");
    Expect(0, 74854, '\P{^Numeric_Value=3.333e-01}', "");
    Expect(1, 74853, '\p{Numeric_Value=0.333}', "");
    Expect(0, 74853, '\p{^Numeric_Value=0.333}', "");
    Expect(0, 74853, '\P{Numeric_Value=0.333}', "");
    Expect(1, 74853, '\P{^Numeric_Value=0.333}', "");
    Expect(0, 74854, '\p{Numeric_Value=0.333}', "");
    Expect(1, 74854, '\p{^Numeric_Value=0.333}', "");
    Expect(1, 74854, '\P{Numeric_Value=0.333}', "");
    Expect(0, 74854, '\P{^Numeric_Value=0.333}', "");
    Expect(1, 74853, '\p{Numeric_Value=3.3333e-01}', "");
    Expect(0, 74853, '\p{^Numeric_Value=3.3333e-01}', "");
    Expect(0, 74853, '\P{Numeric_Value=3.3333e-01}', "");
    Expect(1, 74853, '\P{^Numeric_Value=3.3333e-01}', "");
    Expect(0, 74854, '\p{Numeric_Value=3.3333e-01}', "");
    Expect(1, 74854, '\p{^Numeric_Value=3.3333e-01}', "");
    Expect(1, 74854, '\P{Numeric_Value=3.3333e-01}', "");
    Expect(0, 74854, '\P{^Numeric_Value=3.3333e-01}', "");
    Expect(1, 74853, '\p{Numeric_Value=0.3333}', "");
    Expect(0, 74853, '\p{^Numeric_Value=0.3333}', "");
    Expect(0, 74853, '\P{Numeric_Value=0.3333}', "");
    Expect(1, 74853, '\P{^Numeric_Value=0.3333}', "");
    Expect(0, 74854, '\p{Numeric_Value=0.3333}', "");
    Expect(1, 74854, '\p{^Numeric_Value=0.3333}', "");
    Expect(1, 74854, '\P{Numeric_Value=0.3333}', "");
    Expect(0, 74854, '\P{^Numeric_Value=0.3333}', "");
    Error('\p{Nv=/a/-01/0003}');
    Error('\P{Nv=/a/-01/0003}');
    Expect(1, 74853, '\p{Nv=:\A1/3\z:}', "");;
    Expect(0, 74854, '\p{Nv=:\A1/3\z:}', "");;
    Expect(1, 74853, '\p{Nv=+00000001/000003}', "");
    Expect(0, 74853, '\p{^Nv=+00000001/000003}', "");
    Expect(0, 74853, '\P{Nv=+00000001/000003}', "");
    Expect(1, 74853, '\P{^Nv=+00000001/000003}', "");
    Expect(0, 74854, '\p{Nv=+00000001/000003}', "");
    Expect(1, 74854, '\p{^Nv=+00000001/000003}', "");
    Expect(1, 74854, '\P{Nv=+00000001/000003}', "");
    Expect(0, 74854, '\P{^Nv=+00000001/000003}', "");
    Expect(1, 74853, '\p{Nv=60/180}', "");
    Expect(0, 74853, '\p{^Nv=60/180}', "");
    Expect(0, 74853, '\P{Nv=60/180}', "");
    Expect(1, 74853, '\P{^Nv=60/180}', "");
    Expect(0, 74854, '\p{Nv=60/180}', "");
    Expect(1, 74854, '\p{^Nv=60/180}', "");
    Expect(1, 74854, '\P{Nv=60/180}', "");
    Expect(0, 74854, '\P{^Nv=60/180}', "");
    Error('\p{Nv=3.3e-01}');
    Error('\P{Nv=3.3e-01}');
    Error('\p{Nv=0.3}');
    Error('\P{Nv=0.3}');
    Expect(1, 74853, '\p{Nv=3.33e-01}', "");
    Expect(0, 74853, '\p{^Nv=3.33e-01}', "");
    Expect(0, 74853, '\P{Nv=3.33e-01}', "");
    Expect(1, 74853, '\P{^Nv=3.33e-01}', "");
    Expect(0, 74854, '\p{Nv=3.33e-01}', "");
    Expect(1, 74854, '\p{^Nv=3.33e-01}', "");
    Expect(1, 74854, '\P{Nv=3.33e-01}', "");
    Expect(0, 74854, '\P{^Nv=3.33e-01}', "");
    Error('\p{Nv=0.33}');
    Error('\P{Nv=0.33}');
    Expect(1, 74853, '\p{Nv=3.333e-01}', "");
    Expect(0, 74853, '\p{^Nv=3.333e-01}', "");
    Expect(0, 74853, '\P{Nv=3.333e-01}', "");
    Expect(1, 74853, '\P{^Nv=3.333e-01}', "");
    Expect(0, 74854, '\p{Nv=3.333e-01}', "");
    Expect(1, 74854, '\p{^Nv=3.333e-01}', "");
    Expect(1, 74854, '\P{Nv=3.333e-01}', "");
    Expect(0, 74854, '\P{^Nv=3.333e-01}', "");
    Expect(1, 74853, '\p{Nv=0.333}', "");
    Expect(0, 74853, '\p{^Nv=0.333}', "");
    Expect(0, 74853, '\P{Nv=0.333}', "");
    Expect(1, 74853, '\P{^Nv=0.333}', "");
    Expect(0, 74854, '\p{Nv=0.333}', "");
    Expect(1, 74854, '\p{^Nv=0.333}', "");
    Expect(1, 74854, '\P{Nv=0.333}', "");
    Expect(0, 74854, '\P{^Nv=0.333}', "");
    Expect(1, 74853, '\p{Nv=3.3333e-01}', "");
    Expect(0, 74853, '\p{^Nv=3.3333e-01}', "");
    Expect(0, 74853, '\P{Nv=3.3333e-01}', "");
    Expect(1, 74853, '\P{^Nv=3.3333e-01}', "");
    Expect(0, 74854, '\p{Nv=3.3333e-01}', "");
    Expect(1, 74854, '\p{^Nv=3.3333e-01}', "");
    Expect(1, 74854, '\P{Nv=3.3333e-01}', "");
    Expect(0, 74854, '\P{^Nv=3.3333e-01}', "");
    Expect(1, 74853, '\p{Nv=0.3333}', "");
    Expect(0, 74853, '\p{^Nv=0.3333}', "");
    Expect(0, 74853, '\P{Nv=0.3333}', "");
    Expect(1, 74853, '\P{^Nv=0.3333}', "");
    Expect(0, 74854, '\p{Nv=0.3333}', "");
    Expect(1, 74854, '\p{^Nv=0.3333}', "");
    Expect(1, 74854, '\P{Nv=0.3333}', "");
    Expect(0, 74854, '\P{^Nv=0.3333}', "");
    Error('\p{Is_Numeric_Value=  0000000001/0003/a/}');
    Error('\P{Is_Numeric_Value=  0000000001/0003/a/}');
    Expect(1, 74853, '\p{Is_Numeric_Value=+00001/003}', "");
    Expect(0, 74853, '\p{^Is_Numeric_Value=+00001/003}', "");
    Expect(0, 74853, '\P{Is_Numeric_Value=+00001/003}', "");
    Expect(1, 74853, '\P{^Is_Numeric_Value=+00001/003}', "");
    Expect(0, 74854, '\p{Is_Numeric_Value=+00001/003}', "");
    Expect(1, 74854, '\p{^Is_Numeric_Value=+00001/003}', "");
    Expect(1, 74854, '\P{Is_Numeric_Value=+00001/003}', "");
    Expect(0, 74854, '\P{^Is_Numeric_Value=+00001/003}', "");
    Expect(1, 74853, '\p{Is_Numeric_Value=60/180}', "");
    Expect(0, 74853, '\p{^Is_Numeric_Value=60/180}', "");
    Expect(0, 74853, '\P{Is_Numeric_Value=60/180}', "");
    Expect(1, 74853, '\P{^Is_Numeric_Value=60/180}', "");
    Expect(0, 74854, '\p{Is_Numeric_Value=60/180}', "");
    Expect(1, 74854, '\p{^Is_Numeric_Value=60/180}', "");
    Expect(1, 74854, '\P{Is_Numeric_Value=60/180}', "");
    Expect(0, 74854, '\P{^Is_Numeric_Value=60/180}', "");
    Error('\p{Is_Numeric_Value=3.3e-01}');
    Error('\P{Is_Numeric_Value=3.3e-01}');
    Error('\p{Is_Numeric_Value=0.3}');
    Error('\P{Is_Numeric_Value=0.3}');
    Expect(1, 74853, '\p{Is_Numeric_Value=3.33e-01}', "");
    Expect(0, 74853, '\p{^Is_Numeric_Value=3.33e-01}', "");
    Expect(0, 74853, '\P{Is_Numeric_Value=3.33e-01}', "");
    Expect(1, 74853, '\P{^Is_Numeric_Value=3.33e-01}', "");
    Expect(0, 74854, '\p{Is_Numeric_Value=3.33e-01}', "");
    Expect(1, 74854, '\p{^Is_Numeric_Value=3.33e-01}', "");
    Expect(1, 74854, '\P{Is_Numeric_Value=3.33e-01}', "");
    Expect(0, 74854, '\P{^Is_Numeric_Value=3.33e-01}', "");
    Error('\p{Is_Numeric_Value=0.33}');
    Error('\P{Is_Numeric_Value=0.33}');
    Expect(1, 74853, '\p{Is_Numeric_Value=3.333e-01}', "");
    Expect(0, 74853, '\p{^Is_Numeric_Value=3.333e-01}', "");
    Expect(0, 74853, '\P{Is_Numeric_Value=3.333e-01}', "");
    Expect(1, 74853, '\P{^Is_Numeric_Value=3.333e-01}', "");
    Expect(0, 74854, '\p{Is_Numeric_Value=3.333e-01}', "");
    Expect(1, 74854, '\p{^Is_Numeric_Value=3.333e-01}', "");
    Expect(1, 74854, '\P{Is_Numeric_Value=3.333e-01}', "");
    Expect(0, 74854, '\P{^Is_Numeric_Value=3.333e-01}', "");
    Expect(1, 74853, '\p{Is_Numeric_Value=0.333}', "");
    Expect(0, 74853, '\p{^Is_Numeric_Value=0.333}', "");
    Expect(0, 74853, '\P{Is_Numeric_Value=0.333}', "");
    Expect(1, 74853, '\P{^Is_Numeric_Value=0.333}', "");
    Expect(0, 74854, '\p{Is_Numeric_Value=0.333}', "");
    Expect(1, 74854, '\p{^Is_Numeric_Value=0.333}', "");
    Expect(1, 74854, '\P{Is_Numeric_Value=0.333}', "");
    Expect(0, 74854, '\P{^Is_Numeric_Value=0.333}', "");
    Expect(1, 74853, '\p{Is_Numeric_Value=3.3333e-01}', "");
    Expect(0, 74853, '\p{^Is_Numeric_Value=3.3333e-01}', "");
    Expect(0, 74853, '\P{Is_Numeric_Value=3.3333e-01}', "");
    Expect(1, 74853, '\P{^Is_Numeric_Value=3.3333e-01}', "");
    Expect(0, 74854, '\p{Is_Numeric_Value=3.3333e-01}', "");
    Expect(1, 74854, '\p{^Is_Numeric_Value=3.3333e-01}', "");
    Expect(1, 74854, '\P{Is_Numeric_Value=3.3333e-01}', "");
    Expect(0, 74854, '\P{^Is_Numeric_Value=3.3333e-01}', "");
    Expect(1, 74853, '\p{Is_Numeric_Value=0.3333}', "");
    Expect(0, 74853, '\p{^Is_Numeric_Value=0.3333}', "");
    Expect(0, 74853, '\P{Is_Numeric_Value=0.3333}', "");
    Expect(1, 74853, '\P{^Is_Numeric_Value=0.3333}', "");
    Expect(0, 74854, '\p{Is_Numeric_Value=0.3333}', "");
    Expect(1, 74854, '\p{^Is_Numeric_Value=0.3333}', "");
    Expect(1, 74854, '\P{Is_Numeric_Value=0.3333}', "");
    Expect(0, 74854, '\P{^Is_Numeric_Value=0.3333}', "");
    Error('\p{Is_Nv=__1/0003:=}');
    Error('\P{Is_Nv=__1/0003:=}');
    Expect(1, 74853, '\p{Is_Nv=00001/00003}', "");
    Expect(0, 74853, '\p{^Is_Nv=00001/00003}', "");
    Expect(0, 74853, '\P{Is_Nv=00001/00003}', "");
    Expect(1, 74853, '\P{^Is_Nv=00001/00003}', "");
    Expect(0, 74854, '\p{Is_Nv=00001/00003}', "");
    Expect(1, 74854, '\p{^Is_Nv=00001/00003}', "");
    Expect(1, 74854, '\P{Is_Nv=00001/00003}', "");
    Expect(0, 74854, '\P{^Is_Nv=00001/00003}', "");
    Expect(1, 74853, '\p{Is_Nv=60/180}', "");
    Expect(0, 74853, '\p{^Is_Nv=60/180}', "");
    Expect(0, 74853, '\P{Is_Nv=60/180}', "");
    Expect(1, 74853, '\P{^Is_Nv=60/180}', "");
    Expect(0, 74854, '\p{Is_Nv=60/180}', "");
    Expect(1, 74854, '\p{^Is_Nv=60/180}', "");
    Expect(1, 74854, '\P{Is_Nv=60/180}', "");
    Expect(0, 74854, '\P{^Is_Nv=60/180}', "");
    Error('\p{Is_Nv=3.3e-01}');
    Error('\P{Is_Nv=3.3e-01}');
    Error('\p{Is_Nv:0.3}');
    Error('\P{Is_Nv:0.3}');
    Expect(1, 74853, '\p{Is_Nv=3.33e-01}', "");
    Expect(0, 74853, '\p{^Is_Nv=3.33e-01}', "");
    Expect(0, 74853, '\P{Is_Nv=3.33e-01}', "");
    Expect(1, 74853, '\P{^Is_Nv=3.33e-01}', "");
    Expect(0, 74854, '\p{Is_Nv=3.33e-01}', "");
    Expect(1, 74854, '\p{^Is_Nv=3.33e-01}', "");
    Expect(1, 74854, '\P{Is_Nv=3.33e-01}', "");
    Expect(0, 74854, '\P{^Is_Nv=3.33e-01}', "");
    Error('\p{Is_Nv=0.33}');
    Error('\P{Is_Nv=0.33}');
    Expect(1, 74853, '\p{Is_Nv=3.333e-01}', "");
    Expect(0, 74853, '\p{^Is_Nv=3.333e-01}', "");
    Expect(0, 74853, '\P{Is_Nv=3.333e-01}', "");
    Expect(1, 74853, '\P{^Is_Nv=3.333e-01}', "");
    Expect(0, 74854, '\p{Is_Nv=3.333e-01}', "");
    Expect(1, 74854, '\p{^Is_Nv=3.333e-01}', "");
    Expect(1, 74854, '\P{Is_Nv=3.333e-01}', "");
    Expect(0, 74854, '\P{^Is_Nv=3.333e-01}', "");
    Expect(1, 74853, '\p{Is_Nv=0.333}', "");
    Expect(0, 74853, '\p{^Is_Nv=0.333}', "");
    Expect(0, 74853, '\P{Is_Nv=0.333}', "");
    Expect(1, 74853, '\P{^Is_Nv=0.333}', "");
    Expect(0, 74854, '\p{Is_Nv=0.333}', "");
    Expect(1, 74854, '\p{^Is_Nv=0.333}', "");
    Expect(1, 74854, '\P{Is_Nv=0.333}', "");
    Expect(0, 74854, '\P{^Is_Nv=0.333}', "");
    Expect(1, 74853, '\p{Is_Nv:	3.3333e-01}', "");
    Expect(0, 74853, '\p{^Is_Nv:	3.3333e-01}', "");
    Expect(0, 74853, '\P{Is_Nv:	3.3333e-01}', "");
    Expect(1, 74853, '\P{^Is_Nv:	3.3333e-01}', "");
    Expect(0, 74854, '\p{Is_Nv:	3.3333e-01}', "");
    Expect(1, 74854, '\p{^Is_Nv:	3.3333e-01}', "");
    Expect(1, 74854, '\P{Is_Nv:	3.3333e-01}', "");
    Expect(0, 74854, '\P{^Is_Nv:	3.3333e-01}', "");
    Expect(1, 74853, '\p{Is_Nv: 0.3333}', "");
    Expect(0, 74853, '\p{^Is_Nv: 0.3333}', "");
    Expect(0, 74853, '\P{Is_Nv: 0.3333}', "");
    Expect(1, 74853, '\P{^Is_Nv: 0.3333}', "");
    Expect(0, 74854, '\p{Is_Nv: 0.3333}', "");
    Expect(1, 74854, '\p{^Is_Nv: 0.3333}', "");
    Expect(1, 74854, '\P{Is_Nv: 0.3333}', "");
    Expect(0, 74854, '\P{^Is_Nv: 0.3333}', "");
    Error('\p{Numeric_Value:	:= 	00000001/0032}');
    Error('\P{Numeric_Value:	:= 	00000001/0032}');
    Expect(1, 73669, '\p{Numeric_Value=:\A1/32\z:}', "");;
    Expect(0, 73670, '\p{Numeric_Value=:\A1/32\z:}', "");;
    Expect(1, 73669, '\p{Numeric_Value=0000001/0032}', "");
    Expect(0, 73669, '\p{^Numeric_Value=0000001/0032}', "");
    Expect(0, 73669, '\P{Numeric_Value=0000001/0032}', "");
    Expect(1, 73669, '\P{^Numeric_Value=0000001/0032}', "");
    Expect(0, 73670, '\p{Numeric_Value=0000001/0032}', "");
    Expect(1, 73670, '\p{^Numeric_Value=0000001/0032}', "");
    Expect(1, 73670, '\P{Numeric_Value=0000001/0032}', "");
    Expect(0, 73670, '\P{^Numeric_Value=0000001/0032}', "");
    Expect(1, 73669, '\p{Numeric_Value=60/1920}', "");
    Expect(0, 73669, '\p{^Numeric_Value=60/1920}', "");
    Expect(0, 73669, '\P{Numeric_Value=60/1920}', "");
    Expect(1, 73669, '\P{^Numeric_Value=60/1920}', "");
    Expect(0, 73670, '\p{Numeric_Value=60/1920}', "");
    Expect(1, 73670, '\p{^Numeric_Value=60/1920}', "");
    Expect(1, 73670, '\P{Numeric_Value=60/1920}', "");
    Expect(0, 73670, '\P{^Numeric_Value=60/1920}', "");
    Error('\p{Numeric_Value=3.1e-02}');
    Error('\P{Numeric_Value=3.1e-02}');
    Expect(1, 73669, '\p{Numeric_Value=3.12e-02}', "");
    Expect(0, 73669, '\p{^Numeric_Value=3.12e-02}', "");
    Expect(0, 73669, '\P{Numeric_Value=3.12e-02}', "");
    Expect(1, 73669, '\P{^Numeric_Value=3.12e-02}', "");
    Expect(0, 73670, '\p{Numeric_Value=3.12e-02}', "");
    Expect(1, 73670, '\p{^Numeric_Value=3.12e-02}', "");
    Expect(1, 73670, '\P{Numeric_Value=3.12e-02}', "");
    Expect(0, 73670, '\P{^Numeric_Value=3.12e-02}', "");
    Error('\p{Numeric_Value:0.03}');
    Error('\P{Numeric_Value:0.03}');
    Expect(1, 73669, '\p{Numeric_Value=3.125e-02}', "");
    Expect(0, 73669, '\p{^Numeric_Value=3.125e-02}', "");
    Expect(0, 73669, '\P{Numeric_Value=3.125e-02}', "");
    Expect(1, 73669, '\P{^Numeric_Value=3.125e-02}', "");
    Expect(0, 73670, '\p{Numeric_Value=3.125e-02}', "");
    Expect(1, 73670, '\p{^Numeric_Value=3.125e-02}', "");
    Expect(1, 73670, '\P{Numeric_Value=3.125e-02}', "");
    Expect(0, 73670, '\P{^Numeric_Value=3.125e-02}', "");
    Error('\p{Numeric_Value=0.031}');
    Error('\P{Numeric_Value=0.031}');
    Expect(1, 73669, '\p{Numeric_Value=3.1250e-02}', "");
    Expect(0, 73669, '\p{^Numeric_Value=3.1250e-02}', "");
    Expect(0, 73669, '\P{Numeric_Value=3.1250e-02}', "");
    Expect(1, 73669, '\P{^Numeric_Value=3.1250e-02}', "");
    Expect(0, 73670, '\p{Numeric_Value=3.1250e-02}', "");
    Expect(1, 73670, '\p{^Numeric_Value=3.1250e-02}', "");
    Expect(1, 73670, '\P{Numeric_Value=3.1250e-02}', "");
    Expect(0, 73670, '\P{^Numeric_Value=3.1250e-02}', "");
    Expect(1, 73669, '\p{Numeric_Value=0.0312}', "");
    Expect(0, 73669, '\p{^Numeric_Value=0.0312}', "");
    Expect(0, 73669, '\P{Numeric_Value=0.0312}', "");
    Expect(1, 73669, '\P{^Numeric_Value=0.0312}', "");
    Expect(0, 73670, '\p{Numeric_Value=0.0312}', "");
    Expect(1, 73670, '\p{^Numeric_Value=0.0312}', "");
    Expect(1, 73670, '\P{Numeric_Value=0.0312}', "");
    Expect(0, 73670, '\P{^Numeric_Value=0.0312}', "");
    Expect(1, 73669, '\p{Numeric_Value=3.12500e-02}', "");
    Expect(0, 73669, '\p{^Numeric_Value=3.12500e-02}', "");
    Expect(0, 73669, '\P{Numeric_Value=3.12500e-02}', "");
    Expect(1, 73669, '\P{^Numeric_Value=3.12500e-02}', "");
    Expect(0, 73670, '\p{Numeric_Value=3.12500e-02}', "");
    Expect(1, 73670, '\p{^Numeric_Value=3.12500e-02}', "");
    Expect(1, 73670, '\P{Numeric_Value=3.12500e-02}', "");
    Expect(0, 73670, '\P{^Numeric_Value=3.12500e-02}', "");
    Expect(1, 73669, '\p{Numeric_Value=0.03125}', "");
    Expect(0, 73669, '\p{^Numeric_Value=0.03125}', "");
    Expect(0, 73669, '\P{Numeric_Value=0.03125}', "");
    Expect(1, 73669, '\P{^Numeric_Value=0.03125}', "");
    Expect(0, 73670, '\p{Numeric_Value=0.03125}', "");
    Expect(1, 73670, '\p{^Numeric_Value=0.03125}', "");
    Expect(1, 73670, '\P{Numeric_Value=0.03125}', "");
    Expect(0, 73670, '\P{^Numeric_Value=0.03125}', "");
    Error('\p{Nv=:=  +1/0000000032}');
    Error('\P{Nv=:=  +1/0000000032}');
    Expect(1, 73669, '\p{Nv=:\A1/32\z:}', "");;
    Expect(0, 73670, '\p{Nv=:\A1/32\z:}', "");;
    Expect(1, 73669, '\p{Nv=+0001/032}', "");
    Expect(0, 73669, '\p{^Nv=+0001/032}', "");
    Expect(0, 73669, '\P{Nv=+0001/032}', "");
    Expect(1, 73669, '\P{^Nv=+0001/032}', "");
    Expect(0, 73670, '\p{Nv=+0001/032}', "");
    Expect(1, 73670, '\p{^Nv=+0001/032}', "");
    Expect(1, 73670, '\P{Nv=+0001/032}', "");
    Expect(0, 73670, '\P{^Nv=+0001/032}', "");
    Expect(1, 73669, '\p{Nv=60/1920}', "");
    Expect(0, 73669, '\p{^Nv=60/1920}', "");
    Expect(0, 73669, '\P{Nv=60/1920}', "");
    Expect(1, 73669, '\P{^Nv=60/1920}', "");
    Expect(0, 73670, '\p{Nv=60/1920}', "");
    Expect(1, 73670, '\p{^Nv=60/1920}', "");
    Expect(1, 73670, '\P{Nv=60/1920}', "");
    Expect(0, 73670, '\P{^Nv=60/1920}', "");
    Error('\p{Nv=3.1e-02}');
    Error('\P{Nv=3.1e-02}');
    Expect(1, 73669, '\p{Nv=3.12e-02}', "");
    Expect(0, 73669, '\p{^Nv=3.12e-02}', "");
    Expect(0, 73669, '\P{Nv=3.12e-02}', "");
    Expect(1, 73669, '\P{^Nv=3.12e-02}', "");
    Expect(0, 73670, '\p{Nv=3.12e-02}', "");
    Expect(1, 73670, '\p{^Nv=3.12e-02}', "");
    Expect(1, 73670, '\P{Nv=3.12e-02}', "");
    Expect(0, 73670, '\P{^Nv=3.12e-02}', "");
    Error('\p{Nv=0.03}');
    Error('\P{Nv=0.03}');
    Expect(1, 73669, '\p{Nv=3.125e-02}', "");
    Expect(0, 73669, '\p{^Nv=3.125e-02}', "");
    Expect(0, 73669, '\P{Nv=3.125e-02}', "");
    Expect(1, 73669, '\P{^Nv=3.125e-02}', "");
    Expect(0, 73670, '\p{Nv=3.125e-02}', "");
    Expect(1, 73670, '\p{^Nv=3.125e-02}', "");
    Expect(1, 73670, '\P{Nv=3.125e-02}', "");
    Expect(0, 73670, '\P{^Nv=3.125e-02}', "");
    Error('\p{Nv=0.031}');
    Error('\P{Nv=0.031}');
    Expect(1, 73669, '\p{Nv=3.1250e-02}', "");
    Expect(0, 73669, '\p{^Nv=3.1250e-02}', "");
    Expect(0, 73669, '\P{Nv=3.1250e-02}', "");
    Expect(1, 73669, '\P{^Nv=3.1250e-02}', "");
    Expect(0, 73670, '\p{Nv=3.1250e-02}', "");
    Expect(1, 73670, '\p{^Nv=3.1250e-02}', "");
    Expect(1, 73670, '\P{Nv=3.1250e-02}', "");
    Expect(0, 73670, '\P{^Nv=3.1250e-02}', "");
    Expect(1, 73669, '\p{Nv=0.0312}', "");
    Expect(0, 73669, '\p{^Nv=0.0312}', "");
    Expect(0, 73669, '\P{Nv=0.0312}', "");
    Expect(1, 73669, '\P{^Nv=0.0312}', "");
    Expect(0, 73670, '\p{Nv=0.0312}', "");
    Expect(1, 73670, '\p{^Nv=0.0312}', "");
    Expect(1, 73670, '\P{Nv=0.0312}', "");
    Expect(0, 73670, '\P{^Nv=0.0312}', "");
    Expect(1, 73669, '\p{Nv=3.12500e-02}', "");
    Expect(0, 73669, '\p{^Nv=3.12500e-02}', "");
    Expect(0, 73669, '\P{Nv=3.12500e-02}', "");
    Expect(1, 73669, '\P{^Nv=3.12500e-02}', "");
    Expect(0, 73670, '\p{Nv=3.12500e-02}', "");
    Expect(1, 73670, '\p{^Nv=3.12500e-02}', "");
    Expect(1, 73670, '\P{Nv=3.12500e-02}', "");
    Expect(0, 73670, '\P{^Nv=3.12500e-02}', "");
    Expect(1, 73669, '\p{Nv=0.03125}', "");
    Expect(0, 73669, '\p{^Nv=0.03125}', "");
    Expect(0, 73669, '\P{Nv=0.03125}', "");
    Expect(1, 73669, '\P{^Nv=0.03125}', "");
    Expect(0, 73670, '\p{Nv=0.03125}', "");
    Expect(1, 73670, '\p{^Nv=0.03125}', "");
    Expect(1, 73670, '\P{Nv=0.03125}', "");
    Expect(0, 73670, '\P{^Nv=0.03125}', "");
    Error('\p{Is_Numeric_Value=-/a/001/032}');
    Error('\P{Is_Numeric_Value=-/a/001/032}');
    Expect(1, 73669, '\p{Is_Numeric_Value=000001/32}', "");
    Expect(0, 73669, '\p{^Is_Numeric_Value=000001/32}', "");
    Expect(0, 73669, '\P{Is_Numeric_Value=000001/32}', "");
    Expect(1, 73669, '\P{^Is_Numeric_Value=000001/32}', "");
    Expect(0, 73670, '\p{Is_Numeric_Value=000001/32}', "");
    Expect(1, 73670, '\p{^Is_Numeric_Value=000001/32}', "");
    Expect(1, 73670, '\P{Is_Numeric_Value=000001/32}', "");
    Expect(0, 73670, '\P{^Is_Numeric_Value=000001/32}', "");
    Expect(1, 73669, '\p{Is_Numeric_Value=60/1920}', "");
    Expect(0, 73669, '\p{^Is_Numeric_Value=60/1920}', "");
    Expect(0, 73669, '\P{Is_Numeric_Value=60/1920}', "");
    Expect(1, 73669, '\P{^Is_Numeric_Value=60/1920}', "");
    Expect(0, 73670, '\p{Is_Numeric_Value=60/1920}', "");
    Expect(1, 73670, '\p{^Is_Numeric_Value=60/1920}', "");
    Expect(1, 73670, '\P{Is_Numeric_Value=60/1920}', "");
    Expect(0, 73670, '\P{^Is_Numeric_Value=60/1920}', "");
    Error('\p{Is_Numeric_Value=3.1e-02}');
    Error('\P{Is_Numeric_Value=3.1e-02}');
    Expect(1, 73669, '\p{Is_Numeric_Value=3.12e-02}', "");
    Expect(0, 73669, '\p{^Is_Numeric_Value=3.12e-02}', "");
    Expect(0, 73669, '\P{Is_Numeric_Value=3.12e-02}', "");
    Expect(1, 73669, '\P{^Is_Numeric_Value=3.12e-02}', "");
    Expect(0, 73670, '\p{Is_Numeric_Value=3.12e-02}', "");
    Expect(1, 73670, '\p{^Is_Numeric_Value=3.12e-02}', "");
    Expect(1, 73670, '\P{Is_Numeric_Value=3.12e-02}', "");
    Expect(0, 73670, '\P{^Is_Numeric_Value=3.12e-02}', "");
    Error('\p{Is_Numeric_Value=0.03}');
    Error('\P{Is_Numeric_Value=0.03}');
    Expect(1, 73669, '\p{Is_Numeric_Value=3.125e-02}', "");
    Expect(0, 73669, '\p{^Is_Numeric_Value=3.125e-02}', "");
    Expect(0, 73669, '\P{Is_Numeric_Value=3.125e-02}', "");
    Expect(1, 73669, '\P{^Is_Numeric_Value=3.125e-02}', "");
    Expect(0, 73670, '\p{Is_Numeric_Value=3.125e-02}', "");
    Expect(1, 73670, '\p{^Is_Numeric_Value=3.125e-02}', "");
    Expect(1, 73670, '\P{Is_Numeric_Value=3.125e-02}', "");
    Expect(0, 73670, '\P{^Is_Numeric_Value=3.125e-02}', "");
    Error('\p{Is_Numeric_Value=0.031}');
    Error('\P{Is_Numeric_Value=0.031}');
    Expect(1, 73669, '\p{Is_Numeric_Value=3.1250e-02}', "");
    Expect(0, 73669, '\p{^Is_Numeric_Value=3.1250e-02}', "");
    Expect(0, 73669, '\P{Is_Numeric_Value=3.1250e-02}', "");
    Expect(1, 73669, '\P{^Is_Numeric_Value=3.1250e-02}', "");
    Expect(0, 73670, '\p{Is_Numeric_Value=3.1250e-02}', "");
    Expect(1, 73670, '\p{^Is_Numeric_Value=3.1250e-02}', "");
    Expect(1, 73670, '\P{Is_Numeric_Value=3.1250e-02}', "");
    Expect(0, 73670, '\P{^Is_Numeric_Value=3.1250e-02}', "");
    Expect(1, 73669, '\p{Is_Numeric_Value=0.0312}', "");
    Expect(0, 73669, '\p{^Is_Numeric_Value=0.0312}', "");
    Expect(0, 73669, '\P{Is_Numeric_Value=0.0312}', "");
    Expect(1, 73669, '\P{^Is_Numeric_Value=0.0312}', "");
    Expect(0, 73670, '\p{Is_Numeric_Value=0.0312}', "");
    Expect(1, 73670, '\p{^Is_Numeric_Value=0.0312}', "");
    Expect(1, 73670, '\P{Is_Numeric_Value=0.0312}', "");
    Expect(0, 73670, '\P{^Is_Numeric_Value=0.0312}', "");
    Expect(1, 73669, '\p{Is_Numeric_Value=3.12500e-02}', "");
    Expect(0, 73669, '\p{^Is_Numeric_Value=3.12500e-02}', "");
    Expect(0, 73669, '\P{Is_Numeric_Value=3.12500e-02}', "");
    Expect(1, 73669, '\P{^Is_Numeric_Value=3.12500e-02}', "");
    Expect(0, 73670, '\p{Is_Numeric_Value=3.12500e-02}', "");
    Expect(1, 73670, '\p{^Is_Numeric_Value=3.12500e-02}', "");
    Expect(1, 73670, '\P{Is_Numeric_Value=3.12500e-02}', "");
    Expect(0, 73670, '\P{^Is_Numeric_Value=3.12500e-02}', "");
    Expect(1, 73669, '\p{Is_Numeric_Value:0.03125}', "");
    Expect(0, 73669, '\p{^Is_Numeric_Value:0.03125}', "");
    Expect(0, 73669, '\P{Is_Numeric_Value:0.03125}', "");
    Expect(1, 73669, '\P{^Is_Numeric_Value:0.03125}', "");
    Expect(0, 73670, '\p{Is_Numeric_Value:0.03125}', "");
    Expect(1, 73670, '\p{^Is_Numeric_Value:0.03125}', "");
    Expect(1, 73670, '\P{Is_Numeric_Value:0.03125}', "");
    Expect(0, 73670, '\P{^Is_Numeric_Value:0.03125}', "");
    Error('\p{Is_Nv: _:=001/00000032}');
    Error('\P{Is_Nv: _:=001/00000032}');
    Expect(1, 73669, '\p{Is_Nv=00001/000000032}', "");
    Expect(0, 73669, '\p{^Is_Nv=00001/000000032}', "");
    Expect(0, 73669, '\P{Is_Nv=00001/000000032}', "");
    Expect(1, 73669, '\P{^Is_Nv=00001/000000032}', "");
    Expect(0, 73670, '\p{Is_Nv=00001/000000032}', "");
    Expect(1, 73670, '\p{^Is_Nv=00001/000000032}', "");
    Expect(1, 73670, '\P{Is_Nv=00001/000000032}', "");
    Expect(0, 73670, '\P{^Is_Nv=00001/000000032}', "");
    Expect(1, 73669, '\p{Is_Nv=60/1920}', "");
    Expect(0, 73669, '\p{^Is_Nv=60/1920}', "");
    Expect(0, 73669, '\P{Is_Nv=60/1920}', "");
    Expect(1, 73669, '\P{^Is_Nv=60/1920}', "");
    Expect(0, 73670, '\p{Is_Nv=60/1920}', "");
    Expect(1, 73670, '\p{^Is_Nv=60/1920}', "");
    Expect(1, 73670, '\P{Is_Nv=60/1920}', "");
    Expect(0, 73670, '\P{^Is_Nv=60/1920}', "");
    Error('\p{Is_Nv=3.1e-02}');
    Error('\P{Is_Nv=3.1e-02}');
    Expect(1, 73669, '\p{Is_Nv=3.12e-02}', "");
    Expect(0, 73669, '\p{^Is_Nv=3.12e-02}', "");
    Expect(0, 73669, '\P{Is_Nv=3.12e-02}', "");
    Expect(1, 73669, '\P{^Is_Nv=3.12e-02}', "");
    Expect(0, 73670, '\p{Is_Nv=3.12e-02}', "");
    Expect(1, 73670, '\p{^Is_Nv=3.12e-02}', "");
    Expect(1, 73670, '\P{Is_Nv=3.12e-02}', "");
    Expect(0, 73670, '\P{^Is_Nv=3.12e-02}', "");
    Error('\p{Is_Nv=0.03}');
    Error('\P{Is_Nv=0.03}');
    Expect(1, 73669, '\p{Is_Nv:3.125e-02}', "");
    Expect(0, 73669, '\p{^Is_Nv:3.125e-02}', "");
    Expect(0, 73669, '\P{Is_Nv:3.125e-02}', "");
    Expect(1, 73669, '\P{^Is_Nv:3.125e-02}', "");
    Expect(0, 73670, '\p{Is_Nv:3.125e-02}', "");
    Expect(1, 73670, '\p{^Is_Nv:3.125e-02}', "");
    Expect(1, 73670, '\P{Is_Nv:3.125e-02}', "");
    Expect(0, 73670, '\P{^Is_Nv:3.125e-02}', "");
    Error('\p{Is_Nv=0.031}');
    Error('\P{Is_Nv=0.031}');
    Expect(1, 73669, '\p{Is_Nv=3.1250e-02}', "");
    Expect(0, 73669, '\p{^Is_Nv=3.1250e-02}', "");
    Expect(0, 73669, '\P{Is_Nv=3.1250e-02}', "");
    Expect(1, 73669, '\P{^Is_Nv=3.1250e-02}', "");
    Expect(0, 73670, '\p{Is_Nv=3.1250e-02}', "");
    Expect(1, 73670, '\p{^Is_Nv=3.1250e-02}', "");
    Expect(1, 73670, '\P{Is_Nv=3.1250e-02}', "");
    Expect(0, 73670, '\P{^Is_Nv=3.1250e-02}', "");
    Expect(1, 73669, '\p{Is_Nv=0.0312}', "");
    Expect(0, 73669, '\p{^Is_Nv=0.0312}', "");
    Expect(0, 73669, '\P{Is_Nv=0.0312}', "");
    Expect(1, 73669, '\P{^Is_Nv=0.0312}', "");
    Expect(0, 73670, '\p{Is_Nv=0.0312}', "");
    Expect(1, 73670, '\p{^Is_Nv=0.0312}', "");
    Expect(1, 73670, '\P{Is_Nv=0.0312}', "");
    Expect(0, 73670, '\P{^Is_Nv=0.0312}', "");
    Expect(1, 73669, '\p{Is_Nv=3.12500e-02}', "");
    Expect(0, 73669, '\p{^Is_Nv=3.12500e-02}', "");
    Expect(0, 73669, '\P{Is_Nv=3.12500e-02}', "");
    Expect(1, 73669, '\P{^Is_Nv=3.12500e-02}', "");
    Expect(0, 73670, '\p{Is_Nv=3.12500e-02}', "");
    Expect(1, 73670, '\p{^Is_Nv=3.12500e-02}', "");
    Expect(1, 73670, '\P{Is_Nv=3.12500e-02}', "");
    Expect(0, 73670, '\P{^Is_Nv=3.12500e-02}', "");
    Expect(1, 73669, '\p{Is_Nv=0.03125}', "");
    Expect(0, 73669, '\p{^Is_Nv=0.03125}', "");
    Expect(0, 73669, '\P{Is_Nv=0.03125}', "");
    Expect(1, 73669, '\P{^Is_Nv=0.03125}', "");
    Expect(0, 73670, '\p{Is_Nv=0.03125}', "");
    Expect(1, 73670, '\p{^Is_Nv=0.03125}', "");
    Expect(1, 73670, '\P{Is_Nv=0.03125}', "");
    Expect(0, 73670, '\P{^Is_Nv=0.03125}', "");
    Error('\p{Numeric_Value=_ +00000001/320:=}');
    Error('\P{Numeric_Value=_ +00000001/320:=}');
    Expect(1, 73684, '\p{Numeric_Value=:\A1/320\z:}', "");;
    Expect(0, 73685, '\p{Numeric_Value=:\A1/320\z:}', "");;
    Expect(1, 73684, '\p{Numeric_Value=1/320}', "");
    Expect(0, 73684, '\p{^Numeric_Value=1/320}', "");
    Expect(0, 73684, '\P{Numeric_Value=1/320}', "");
    Expect(1, 73684, '\P{^Numeric_Value=1/320}', "");
    Expect(0, 73685, '\p{Numeric_Value=1/320}', "");
    Expect(1, 73685, '\p{^Numeric_Value=1/320}', "");
    Expect(1, 73685, '\P{Numeric_Value=1/320}', "");
    Expect(0, 73685, '\P{^Numeric_Value=1/320}', "");
    Expect(1, 73684, '\p{Numeric_Value=60/19200}', "");
    Expect(0, 73684, '\p{^Numeric_Value=60/19200}', "");
    Expect(0, 73684, '\P{Numeric_Value=60/19200}', "");
    Expect(1, 73684, '\P{^Numeric_Value=60/19200}', "");
    Expect(0, 73685, '\p{Numeric_Value=60/19200}', "");
    Expect(1, 73685, '\p{^Numeric_Value=60/19200}', "");
    Expect(1, 73685, '\P{Numeric_Value=60/19200}', "");
    Expect(0, 73685, '\P{^Numeric_Value=60/19200}', "");
    Error('\p{Numeric_Value=3.1e-03}');
    Error('\P{Numeric_Value=3.1e-03}');
    Expect(1, 73684, '\p{Numeric_Value=3.13e-03}', "");
    Expect(0, 73684, '\p{^Numeric_Value=3.13e-03}', "");
    Expect(0, 73684, '\P{Numeric_Value=3.13e-03}', "");
    Expect(1, 73684, '\P{^Numeric_Value=3.13e-03}', "");
    Expect(0, 73685, '\p{Numeric_Value=3.13e-03}', "");
    Expect(1, 73685, '\p{^Numeric_Value=3.13e-03}', "");
    Expect(1, 73685, '\P{Numeric_Value=3.13e-03}', "");
    Expect(0, 73685, '\P{^Numeric_Value=3.13e-03}', "");
    Expect(1, 73684, '\p{Numeric_Value=3.125e-03}', "");
    Expect(0, 73684, '\p{^Numeric_Value=3.125e-03}', "");
    Expect(0, 73684, '\P{Numeric_Value=3.125e-03}', "");
    Expect(1, 73684, '\P{^Numeric_Value=3.125e-03}', "");
    Expect(0, 73685, '\p{Numeric_Value=3.125e-03}', "");
    Expect(1, 73685, '\p{^Numeric_Value=3.125e-03}', "");
    Expect(1, 73685, '\P{Numeric_Value=3.125e-03}', "");
    Expect(0, 73685, '\P{^Numeric_Value=3.125e-03}', "");
    Error('\p{Numeric_Value=0.003}');
    Error('\P{Numeric_Value=0.003}');
    Expect(1, 73684, '\p{Numeric_Value=3.1250e-03}', "");
    Expect(0, 73684, '\p{^Numeric_Value=3.1250e-03}', "");
    Expect(0, 73684, '\P{Numeric_Value=3.1250e-03}', "");
    Expect(1, 73684, '\P{^Numeric_Value=3.1250e-03}', "");
    Expect(0, 73685, '\p{Numeric_Value=3.1250e-03}', "");
    Expect(1, 73685, '\p{^Numeric_Value=3.1250e-03}', "");
    Expect(1, 73685, '\P{Numeric_Value=3.1250e-03}', "");
    Expect(0, 73685, '\P{^Numeric_Value=3.1250e-03}', "");
    Error('\p{Numeric_Value=0.0031}');
    Error('\P{Numeric_Value=0.0031}');
    Expect(1, 73684, '\p{Numeric_Value=3.12500e-03}', "");
    Expect(0, 73684, '\p{^Numeric_Value=3.12500e-03}', "");
    Expect(0, 73684, '\P{Numeric_Value=3.12500e-03}', "");
    Expect(1, 73684, '\P{^Numeric_Value=3.12500e-03}', "");
    Expect(0, 73685, '\p{Numeric_Value=3.12500e-03}', "");
    Expect(1, 73685, '\p{^Numeric_Value=3.12500e-03}', "");
    Expect(1, 73685, '\P{Numeric_Value=3.12500e-03}', "");
    Expect(0, 73685, '\P{^Numeric_Value=3.12500e-03}', "");
    Expect(1, 73684, '\p{Numeric_Value=0.00313}', "");
    Expect(0, 73684, '\p{^Numeric_Value=0.00313}', "");
    Expect(0, 73684, '\P{Numeric_Value=0.00313}', "");
    Expect(1, 73684, '\P{^Numeric_Value=0.00313}', "");
    Expect(0, 73685, '\p{Numeric_Value=0.00313}', "");
    Expect(1, 73685, '\p{^Numeric_Value=0.00313}', "");
    Expect(1, 73685, '\P{Numeric_Value=0.00313}', "");
    Expect(0, 73685, '\P{^Numeric_Value=0.00313}', "");
    Expect(1, 73684, '\p{Numeric_Value=3.125000e-03}', "");
    Expect(0, 73684, '\p{^Numeric_Value=3.125000e-03}', "");
    Expect(0, 73684, '\P{Numeric_Value=3.125000e-03}', "");
    Expect(1, 73684, '\P{^Numeric_Value=3.125000e-03}', "");
    Expect(0, 73685, '\p{Numeric_Value=3.125000e-03}', "");
    Expect(1, 73685, '\p{^Numeric_Value=3.125000e-03}', "");
    Expect(1, 73685, '\P{Numeric_Value=3.125000e-03}', "");
    Expect(0, 73685, '\P{^Numeric_Value=3.125000e-03}', "");
    Expect(1, 73684, '\p{Numeric_Value=0.003125}', "");
    Expect(0, 73684, '\p{^Numeric_Value=0.003125}', "");
    Expect(0, 73684, '\P{Numeric_Value=0.003125}', "");
    Expect(1, 73684, '\P{^Numeric_Value=0.003125}', "");
    Expect(0, 73685, '\p{Numeric_Value=0.003125}', "");
    Expect(1, 73685, '\p{^Numeric_Value=0.003125}', "");
    Expect(1, 73685, '\P{Numeric_Value=0.003125}', "");
    Expect(0, 73685, '\P{^Numeric_Value=0.003125}', "");
    Error('\p{Nv=-_000000001/0320:=}');
    Error('\P{Nv=-_000000001/0320:=}');
    Expect(1, 73684, '\p{Nv=:\A1/320\z:}', "");;
    Expect(0, 73685, '\p{Nv=:\A1/320\z:}', "");;
    Expect(1, 73684, '\p{Nv=00001/0320}', "");
    Expect(0, 73684, '\p{^Nv=00001/0320}', "");
    Expect(0, 73684, '\P{Nv=00001/0320}', "");
    Expect(1, 73684, '\P{^Nv=00001/0320}', "");
    Expect(0, 73685, '\p{Nv=00001/0320}', "");
    Expect(1, 73685, '\p{^Nv=00001/0320}', "");
    Expect(1, 73685, '\P{Nv=00001/0320}', "");
    Expect(0, 73685, '\P{^Nv=00001/0320}', "");
    Expect(1, 73684, '\p{Nv=60/19200}', "");
    Expect(0, 73684, '\p{^Nv=60/19200}', "");
    Expect(0, 73684, '\P{Nv=60/19200}', "");
    Expect(1, 73684, '\P{^Nv=60/19200}', "");
    Expect(0, 73685, '\p{Nv=60/19200}', "");
    Expect(1, 73685, '\p{^Nv=60/19200}', "");
    Expect(1, 73685, '\P{Nv=60/19200}', "");
    Expect(0, 73685, '\P{^Nv=60/19200}', "");
    Error('\p{Nv=3.1e-03}');
    Error('\P{Nv=3.1e-03}');
    Expect(1, 73684, '\p{Nv=3.13e-03}', "");
    Expect(0, 73684, '\p{^Nv=3.13e-03}', "");
    Expect(0, 73684, '\P{Nv=3.13e-03}', "");
    Expect(1, 73684, '\P{^Nv=3.13e-03}', "");
    Expect(0, 73685, '\p{Nv=3.13e-03}', "");
    Expect(1, 73685, '\p{^Nv=3.13e-03}', "");
    Expect(1, 73685, '\P{Nv=3.13e-03}', "");
    Expect(0, 73685, '\P{^Nv=3.13e-03}', "");
    Expect(1, 73684, '\p{Nv=3.125e-03}', "");
    Expect(0, 73684, '\p{^Nv=3.125e-03}', "");
    Expect(0, 73684, '\P{Nv=3.125e-03}', "");
    Expect(1, 73684, '\P{^Nv=3.125e-03}', "");
    Expect(0, 73685, '\p{Nv=3.125e-03}', "");
    Expect(1, 73685, '\p{^Nv=3.125e-03}', "");
    Expect(1, 73685, '\P{Nv=3.125e-03}', "");
    Expect(0, 73685, '\P{^Nv=3.125e-03}', "");
    Error('\p{Nv=0.003}');
    Error('\P{Nv=0.003}');
    Expect(1, 73684, '\p{Nv=3.1250e-03}', "");
    Expect(0, 73684, '\p{^Nv=3.1250e-03}', "");
    Expect(0, 73684, '\P{Nv=3.1250e-03}', "");
    Expect(1, 73684, '\P{^Nv=3.1250e-03}', "");
    Expect(0, 73685, '\p{Nv=3.1250e-03}', "");
    Expect(1, 73685, '\p{^Nv=3.1250e-03}', "");
    Expect(1, 73685, '\P{Nv=3.1250e-03}', "");
    Expect(0, 73685, '\P{^Nv=3.1250e-03}', "");
    Error('\p{Nv=0.0031}');
    Error('\P{Nv=0.0031}');
    Expect(1, 73684, '\p{Nv=3.12500e-03}', "");
    Expect(0, 73684, '\p{^Nv=3.12500e-03}', "");
    Expect(0, 73684, '\P{Nv=3.12500e-03}', "");
    Expect(1, 73684, '\P{^Nv=3.12500e-03}', "");
    Expect(0, 73685, '\p{Nv=3.12500e-03}', "");
    Expect(1, 73685, '\p{^Nv=3.12500e-03}', "");
    Expect(1, 73685, '\P{Nv=3.12500e-03}', "");
    Expect(0, 73685, '\P{^Nv=3.12500e-03}', "");
    Expect(1, 73684, '\p{Nv=0.00313}', "");
    Expect(0, 73684, '\p{^Nv=0.00313}', "");
    Expect(0, 73684, '\P{Nv=0.00313}', "");
    Expect(1, 73684, '\P{^Nv=0.00313}', "");
    Expect(0, 73685, '\p{Nv=0.00313}', "");
    Expect(1, 73685, '\p{^Nv=0.00313}', "");
    Expect(1, 73685, '\P{Nv=0.00313}', "");
    Expect(0, 73685, '\P{^Nv=0.00313}', "");
    Expect(1, 73684, '\p{Nv=3.125000e-03}', "");
    Expect(0, 73684, '\p{^Nv=3.125000e-03}', "");
    Expect(0, 73684, '\P{Nv=3.125000e-03}', "");
    Expect(1, 73684, '\P{^Nv=3.125000e-03}', "");
    Expect(0, 73685, '\p{Nv=3.125000e-03}', "");
    Expect(1, 73685, '\p{^Nv=3.125000e-03}', "");
    Expect(1, 73685, '\P{Nv=3.125000e-03}', "");
    Expect(0, 73685, '\P{^Nv=3.125000e-03}', "");
    Expect(1, 73684, '\p{Nv=0.003125}', "");
    Expect(0, 73684, '\p{^Nv=0.003125}', "");
    Expect(0, 73684, '\P{Nv=0.003125}', "");
    Expect(1, 73684, '\P{^Nv=0.003125}', "");
    Expect(0, 73685, '\p{Nv=0.003125}', "");
    Expect(1, 73685, '\p{^Nv=0.003125}', "");
    Expect(1, 73685, '\P{Nv=0.003125}', "");
    Expect(0, 73685, '\P{^Nv=0.003125}', "");
    Error('\p{Is_Numeric_Value= /a/0000001/000000320}');
    Error('\P{Is_Numeric_Value= /a/0000001/000000320}');
    Expect(1, 73684, '\p{Is_Numeric_Value:   000000001/00320}', "");
    Expect(0, 73684, '\p{^Is_Numeric_Value:   000000001/00320}', "");
    Expect(0, 73684, '\P{Is_Numeric_Value:   000000001/00320}', "");
    Expect(1, 73684, '\P{^Is_Numeric_Value:   000000001/00320}', "");
    Expect(0, 73685, '\p{Is_Numeric_Value:   000000001/00320}', "");
    Expect(1, 73685, '\p{^Is_Numeric_Value:   000000001/00320}', "");
    Expect(1, 73685, '\P{Is_Numeric_Value:   000000001/00320}', "");
    Expect(0, 73685, '\P{^Is_Numeric_Value:   000000001/00320}', "");
    Expect(1, 73684, '\p{Is_Numeric_Value=60/19200}', "");
    Expect(0, 73684, '\p{^Is_Numeric_Value=60/19200}', "");
    Expect(0, 73684, '\P{Is_Numeric_Value=60/19200}', "");
    Expect(1, 73684, '\P{^Is_Numeric_Value=60/19200}', "");
    Expect(0, 73685, '\p{Is_Numeric_Value=60/19200}', "");
    Expect(1, 73685, '\p{^Is_Numeric_Value=60/19200}', "");
    Expect(1, 73685, '\P{Is_Numeric_Value=60/19200}', "");
    Expect(0, 73685, '\P{^Is_Numeric_Value=60/19200}', "");
    Error('\p{Is_Numeric_Value=3.1e-03}');
    Error('\P{Is_Numeric_Value=3.1e-03}');
    Expect(1, 73684, '\p{Is_Numeric_Value=3.13e-03}', "");
    Expect(0, 73684, '\p{^Is_Numeric_Value=3.13e-03}', "");
    Expect(0, 73684, '\P{Is_Numeric_Value=3.13e-03}', "");
    Expect(1, 73684, '\P{^Is_Numeric_Value=3.13e-03}', "");
    Expect(0, 73685, '\p{Is_Numeric_Value=3.13e-03}', "");
    Expect(1, 73685, '\p{^Is_Numeric_Value=3.13e-03}', "");
    Expect(1, 73685, '\P{Is_Numeric_Value=3.13e-03}', "");
    Expect(0, 73685, '\P{^Is_Numeric_Value=3.13e-03}', "");
    Expect(1, 73684, '\p{Is_Numeric_Value=3.125e-03}', "");
    Expect(0, 73684, '\p{^Is_Numeric_Value=3.125e-03}', "");
    Expect(0, 73684, '\P{Is_Numeric_Value=3.125e-03}', "");
    Expect(1, 73684, '\P{^Is_Numeric_Value=3.125e-03}', "");
    Expect(0, 73685, '\p{Is_Numeric_Value=3.125e-03}', "");
    Expect(1, 73685, '\p{^Is_Numeric_Value=3.125e-03}', "");
    Expect(1, 73685, '\P{Is_Numeric_Value=3.125e-03}', "");
    Expect(0, 73685, '\P{^Is_Numeric_Value=3.125e-03}', "");
    Error('\p{Is_Numeric_Value=0.003}');
    Error('\P{Is_Numeric_Value=0.003}');
    Expect(1, 73684, '\p{Is_Numeric_Value=3.1250e-03}', "");
    Expect(0, 73684, '\p{^Is_Numeric_Value=3.1250e-03}', "");
    Expect(0, 73684, '\P{Is_Numeric_Value=3.1250e-03}', "");
    Expect(1, 73684, '\P{^Is_Numeric_Value=3.1250e-03}', "");
    Expect(0, 73685, '\p{Is_Numeric_Value=3.1250e-03}', "");
    Expect(1, 73685, '\p{^Is_Numeric_Value=3.1250e-03}', "");
    Expect(1, 73685, '\P{Is_Numeric_Value=3.1250e-03}', "");
    Expect(0, 73685, '\P{^Is_Numeric_Value=3.1250e-03}', "");
    Error('\p{Is_Numeric_Value=0.0031}');
    Error('\P{Is_Numeric_Value=0.0031}');
    Expect(1, 73684, '\p{Is_Numeric_Value=3.12500e-03}', "");
    Expect(0, 73684, '\p{^Is_Numeric_Value=3.12500e-03}', "");
    Expect(0, 73684, '\P{Is_Numeric_Value=3.12500e-03}', "");
    Expect(1, 73684, '\P{^Is_Numeric_Value=3.12500e-03}', "");
    Expect(0, 73685, '\p{Is_Numeric_Value=3.12500e-03}', "");
    Expect(1, 73685, '\p{^Is_Numeric_Value=3.12500e-03}', "");
    Expect(1, 73685, '\P{Is_Numeric_Value=3.12500e-03}', "");
    Expect(0, 73685, '\P{^Is_Numeric_Value=3.12500e-03}', "");
    Expect(1, 73684, '\p{Is_Numeric_Value:0.00313}', "");
    Expect(0, 73684, '\p{^Is_Numeric_Value:0.00313}', "");
    Expect(0, 73684, '\P{Is_Numeric_Value:0.00313}', "");
    Expect(1, 73684, '\P{^Is_Numeric_Value:0.00313}', "");
    Expect(0, 73685, '\p{Is_Numeric_Value:0.00313}', "");
    Expect(1, 73685, '\p{^Is_Numeric_Value:0.00313}', "");
    Expect(1, 73685, '\P{Is_Numeric_Value:0.00313}', "");
    Expect(0, 73685, '\P{^Is_Numeric_Value:0.00313}', "");
    Expect(1, 73684, '\p{Is_Numeric_Value=3.125000e-03}', "");
    Expect(0, 73684, '\p{^Is_Numeric_Value=3.125000e-03}', "");
    Expect(0, 73684, '\P{Is_Numeric_Value=3.125000e-03}', "");
    Expect(1, 73684, '\P{^Is_Numeric_Value=3.125000e-03}', "");
    Expect(0, 73685, '\p{Is_Numeric_Value=3.125000e-03}', "");
    Expect(1, 73685, '\p{^Is_Numeric_Value=3.125000e-03}', "");
    Expect(1, 73685, '\P{Is_Numeric_Value=3.125000e-03}', "");
    Expect(0, 73685, '\P{^Is_Numeric_Value=3.125000e-03}', "");
    Expect(1, 73684, '\p{Is_Numeric_Value=0.003125}', "");
    Expect(0, 73684, '\p{^Is_Numeric_Value=0.003125}', "");
    Expect(0, 73684, '\P{Is_Numeric_Value=0.003125}', "");
    Expect(1, 73684, '\P{^Is_Numeric_Value=0.003125}', "");
    Expect(0, 73685, '\p{Is_Numeric_Value=0.003125}', "");
    Expect(1, 73685, '\p{^Is_Numeric_Value=0.003125}', "");
    Expect(1, 73685, '\P{Is_Numeric_Value=0.003125}', "");
    Expect(0, 73685, '\P{^Is_Numeric_Value=0.003125}', "");
    Error('\p{Is_Nv:	-0000000001/000000000320/a/}');
    Error('\P{Is_Nv:	-0000000001/000000000320/a/}');
    Expect(1, 73684, '\p{Is_Nv=000001/0000000320}', "");
    Expect(0, 73684, '\p{^Is_Nv=000001/0000000320}', "");
    Expect(0, 73684, '\P{Is_Nv=000001/0000000320}', "");
    Expect(1, 73684, '\P{^Is_Nv=000001/0000000320}', "");
    Expect(0, 73685, '\p{Is_Nv=000001/0000000320}', "");
    Expect(1, 73685, '\p{^Is_Nv=000001/0000000320}', "");
    Expect(1, 73685, '\P{Is_Nv=000001/0000000320}', "");
    Expect(0, 73685, '\P{^Is_Nv=000001/0000000320}', "");
    Expect(1, 73684, '\p{Is_Nv:   60/19200}', "");
    Expect(0, 73684, '\p{^Is_Nv:   60/19200}', "");
    Expect(0, 73684, '\P{Is_Nv:   60/19200}', "");
    Expect(1, 73684, '\P{^Is_Nv:   60/19200}', "");
    Expect(0, 73685, '\p{Is_Nv:   60/19200}', "");
    Expect(1, 73685, '\p{^Is_Nv:   60/19200}', "");
    Expect(1, 73685, '\P{Is_Nv:   60/19200}', "");
    Expect(0, 73685, '\P{^Is_Nv:   60/19200}', "");
    Error('\p{Is_Nv=3.1e-03}');
    Error('\P{Is_Nv=3.1e-03}');
    Expect(1, 73684, '\p{Is_Nv=3.13e-03}', "");
    Expect(0, 73684, '\p{^Is_Nv=3.13e-03}', "");
    Expect(0, 73684, '\P{Is_Nv=3.13e-03}', "");
    Expect(1, 73684, '\P{^Is_Nv=3.13e-03}', "");
    Expect(0, 73685, '\p{Is_Nv=3.13e-03}', "");
    Expect(1, 73685, '\p{^Is_Nv=3.13e-03}', "");
    Expect(1, 73685, '\P{Is_Nv=3.13e-03}', "");
    Expect(0, 73685, '\P{^Is_Nv=3.13e-03}', "");
    Expect(1, 73684, '\p{Is_Nv=3.125e-03}', "");
    Expect(0, 73684, '\p{^Is_Nv=3.125e-03}', "");
    Expect(0, 73684, '\P{Is_Nv=3.125e-03}', "");
    Expect(1, 73684, '\P{^Is_Nv=3.125e-03}', "");
    Expect(0, 73685, '\p{Is_Nv=3.125e-03}', "");
    Expect(1, 73685, '\p{^Is_Nv=3.125e-03}', "");
    Expect(1, 73685, '\P{Is_Nv=3.125e-03}', "");
    Expect(0, 73685, '\P{^Is_Nv=3.125e-03}', "");
    Error('\p{Is_Nv=0.003}');
    Error('\P{Is_Nv=0.003}');
    Expect(1, 73684, '\p{Is_Nv=3.1250e-03}', "");
    Expect(0, 73684, '\p{^Is_Nv=3.1250e-03}', "");
    Expect(0, 73684, '\P{Is_Nv=3.1250e-03}', "");
    Expect(1, 73684, '\P{^Is_Nv=3.1250e-03}', "");
    Expect(0, 73685, '\p{Is_Nv=3.1250e-03}', "");
    Expect(1, 73685, '\p{^Is_Nv=3.1250e-03}', "");
    Expect(1, 73685, '\P{Is_Nv=3.1250e-03}', "");
    Expect(0, 73685, '\P{^Is_Nv=3.1250e-03}', "");
    Error('\p{Is_Nv=0.0031}');
    Error('\P{Is_Nv=0.0031}');
    Expect(1, 73684, '\p{Is_Nv=3.12500e-03}', "");
    Expect(0, 73684, '\p{^Is_Nv=3.12500e-03}', "");
    Expect(0, 73684, '\P{Is_Nv=3.12500e-03}', "");
    Expect(1, 73684, '\P{^Is_Nv=3.12500e-03}', "");
    Expect(0, 73685, '\p{Is_Nv=3.12500e-03}', "");
    Expect(1, 73685, '\p{^Is_Nv=3.12500e-03}', "");
    Expect(1, 73685, '\P{Is_Nv=3.12500e-03}', "");
    Expect(0, 73685, '\P{^Is_Nv=3.12500e-03}', "");
    Expect(1, 73684, '\p{Is_Nv=0.00313}', "");
    Expect(0, 73684, '\p{^Is_Nv=0.00313}', "");
    Expect(0, 73684, '\P{Is_Nv=0.00313}', "");
    Expect(1, 73684, '\P{^Is_Nv=0.00313}', "");
    Expect(0, 73685, '\p{Is_Nv=0.00313}', "");
    Expect(1, 73685, '\p{^Is_Nv=0.00313}', "");
    Expect(1, 73685, '\P{Is_Nv=0.00313}', "");
    Expect(0, 73685, '\P{^Is_Nv=0.00313}', "");
    Expect(1, 73684, '\p{Is_Nv=3.125000e-03}', "");
    Expect(0, 73684, '\p{^Is_Nv=3.125000e-03}', "");
    Expect(0, 73684, '\P{Is_Nv=3.125000e-03}', "");
    Expect(1, 73684, '\P{^Is_Nv=3.125000e-03}', "");
    Expect(0, 73685, '\p{Is_Nv=3.125000e-03}', "");
    Expect(1, 73685, '\p{^Is_Nv=3.125000e-03}', "");
    Expect(1, 73685, '\P{Is_Nv=3.125000e-03}', "");
    Expect(0, 73685, '\P{^Is_Nv=3.125000e-03}', "");
    Expect(1, 73684, '\p{Is_Nv=0.003125}', "");
    Expect(0, 73684, '\p{^Is_Nv=0.003125}', "");
    Expect(0, 73684, '\P{Is_Nv=0.003125}', "");
    Expect(1, 73684, '\P{^Is_Nv=0.003125}', "");
    Expect(0, 73685, '\p{Is_Nv=0.003125}', "");
    Expect(1, 73685, '\p{^Is_Nv=0.003125}', "");
    Expect(1, 73685, '\P{Is_Nv=0.003125}', "");
    Expect(0, 73685, '\P{^Is_Nv=0.003125}', "");
    Error('\p{Numeric_Value= 0001/000000004/a/}');
    Error('\P{Numeric_Value= 0001/000000004/a/}');
    Expect(1, 126125, '\p{Numeric_Value=:\A1/4\z:}', "");;
    Expect(0, 126126, '\p{Numeric_Value=:\A1/4\z:}', "");;
    Expect(1, 126125, '\p{Numeric_Value:	000001/000000004}', "");
    Expect(0, 126125, '\p{^Numeric_Value:	000001/000000004}', "");
    Expect(0, 126125, '\P{Numeric_Value:	000001/000000004}', "");
    Expect(1, 126125, '\P{^Numeric_Value:	000001/000000004}', "");
    Expect(0, 126126, '\p{Numeric_Value:	000001/000000004}', "");
    Expect(1, 126126, '\p{^Numeric_Value:	000001/000000004}', "");
    Expect(1, 126126, '\P{Numeric_Value:	000001/000000004}', "");
    Expect(0, 126126, '\P{^Numeric_Value:	000001/000000004}', "");
    Expect(1, 126125, '\p{Numeric_Value=60/240}', "");
    Expect(0, 126125, '\p{^Numeric_Value=60/240}', "");
    Expect(0, 126125, '\P{Numeric_Value=60/240}', "");
    Expect(1, 126125, '\P{^Numeric_Value=60/240}', "");
    Expect(0, 126126, '\p{Numeric_Value=60/240}', "");
    Expect(1, 126126, '\p{^Numeric_Value=60/240}', "");
    Expect(1, 126126, '\P{Numeric_Value=60/240}', "");
    Expect(0, 126126, '\P{^Numeric_Value=60/240}', "");
    Expect(1, 126125, '\p{Numeric_Value=2.5e-01}', "");
    Expect(0, 126125, '\p{^Numeric_Value=2.5e-01}', "");
    Expect(0, 126125, '\P{Numeric_Value=2.5e-01}', "");
    Expect(1, 126125, '\P{^Numeric_Value=2.5e-01}', "");
    Expect(0, 126126, '\p{Numeric_Value=2.5e-01}', "");
    Expect(1, 126126, '\p{^Numeric_Value=2.5e-01}', "");
    Expect(1, 126126, '\P{Numeric_Value=2.5e-01}', "");
    Expect(0, 126126, '\P{^Numeric_Value=2.5e-01}', "");
    Expect(1, 126125, '\p{Numeric_Value=2.50e-01}', "");
    Expect(0, 126125, '\p{^Numeric_Value=2.50e-01}', "");
    Expect(0, 126125, '\P{Numeric_Value=2.50e-01}', "");
    Expect(1, 126125, '\P{^Numeric_Value=2.50e-01}', "");
    Expect(0, 126126, '\p{Numeric_Value=2.50e-01}', "");
    Expect(1, 126126, '\p{^Numeric_Value=2.50e-01}', "");
    Expect(1, 126126, '\P{Numeric_Value=2.50e-01}', "");
    Expect(0, 126126, '\P{^Numeric_Value=2.50e-01}', "");
    Expect(1, 126125, '\p{Numeric_Value=0.25}', "");
    Expect(0, 126125, '\p{^Numeric_Value=0.25}', "");
    Expect(0, 126125, '\P{Numeric_Value=0.25}', "");
    Expect(1, 126125, '\P{^Numeric_Value=0.25}', "");
    Expect(0, 126126, '\p{Numeric_Value=0.25}', "");
    Expect(1, 126126, '\p{^Numeric_Value=0.25}', "");
    Expect(1, 126126, '\P{Numeric_Value=0.25}', "");
    Expect(0, 126126, '\P{^Numeric_Value=0.25}', "");
    Expect(1, 126125, '\p{Numeric_Value=2.500e-01}', "");
    Expect(0, 126125, '\p{^Numeric_Value=2.500e-01}', "");
    Expect(0, 126125, '\P{Numeric_Value=2.500e-01}', "");
    Expect(1, 126125, '\P{^Numeric_Value=2.500e-01}', "");
    Expect(0, 126126, '\p{Numeric_Value=2.500e-01}', "");
    Expect(1, 126126, '\p{^Numeric_Value=2.500e-01}', "");
    Expect(1, 126126, '\P{Numeric_Value=2.500e-01}', "");
    Expect(0, 126126, '\P{^Numeric_Value=2.500e-01}', "");
    Expect(1, 126125, '\p{Numeric_Value=0.250}', "");
    Expect(0, 126125, '\p{^Numeric_Value=0.250}', "");
    Expect(0, 126125, '\P{Numeric_Value=0.250}', "");
    Expect(1, 126125, '\P{^Numeric_Value=0.250}', "");
    Expect(0, 126126, '\p{Numeric_Value=0.250}', "");
    Expect(1, 126126, '\p{^Numeric_Value=0.250}', "");
    Expect(1, 126126, '\P{Numeric_Value=0.250}', "");
    Expect(0, 126126, '\P{^Numeric_Value=0.250}', "");
    Error('\p{Nv=-/a/00000001/004}');
    Error('\P{Nv=-/a/00000001/004}');
    Expect(1, 126125, '\p{Nv=:\A1/4\z:}', "");;
    Expect(0, 126126, '\p{Nv=:\A1/4\z:}', "");;
    Expect(1, 126125, '\p{Nv=00000001/00000004}', "");
    Expect(0, 126125, '\p{^Nv=00000001/00000004}', "");
    Expect(0, 126125, '\P{Nv=00000001/00000004}', "");
    Expect(1, 126125, '\P{^Nv=00000001/00000004}', "");
    Expect(0, 126126, '\p{Nv=00000001/00000004}', "");
    Expect(1, 126126, '\p{^Nv=00000001/00000004}', "");
    Expect(1, 126126, '\P{Nv=00000001/00000004}', "");
    Expect(0, 126126, '\P{^Nv=00000001/00000004}', "");
    Expect(1, 126125, '\p{Nv=60/240}', "");
    Expect(0, 126125, '\p{^Nv=60/240}', "");
    Expect(0, 126125, '\P{Nv=60/240}', "");
    Expect(1, 126125, '\P{^Nv=60/240}', "");
    Expect(0, 126126, '\p{Nv=60/240}', "");
    Expect(1, 126126, '\p{^Nv=60/240}', "");
    Expect(1, 126126, '\P{Nv=60/240}', "");
    Expect(0, 126126, '\P{^Nv=60/240}', "");
    Expect(1, 126125, '\p{Nv=2.5e-01}', "");
    Expect(0, 126125, '\p{^Nv=2.5e-01}', "");
    Expect(0, 126125, '\P{Nv=2.5e-01}', "");
    Expect(1, 126125, '\P{^Nv=2.5e-01}', "");
    Expect(0, 126126, '\p{Nv=2.5e-01}', "");
    Expect(1, 126126, '\p{^Nv=2.5e-01}', "");
    Expect(1, 126126, '\P{Nv=2.5e-01}', "");
    Expect(0, 126126, '\P{^Nv=2.5e-01}', "");
    Expect(1, 126125, '\p{Nv=2.50e-01}', "");
    Expect(0, 126125, '\p{^Nv=2.50e-01}', "");
    Expect(0, 126125, '\P{Nv=2.50e-01}', "");
    Expect(1, 126125, '\P{^Nv=2.50e-01}', "");
    Expect(0, 126126, '\p{Nv=2.50e-01}', "");
    Expect(1, 126126, '\p{^Nv=2.50e-01}', "");
    Expect(1, 126126, '\P{Nv=2.50e-01}', "");
    Expect(0, 126126, '\P{^Nv=2.50e-01}', "");
    Expect(1, 126125, '\p{Nv=0.25}', "");
    Expect(0, 126125, '\p{^Nv=0.25}', "");
    Expect(0, 126125, '\P{Nv=0.25}', "");
    Expect(1, 126125, '\P{^Nv=0.25}', "");
    Expect(0, 126126, '\p{Nv=0.25}', "");
    Expect(1, 126126, '\p{^Nv=0.25}', "");
    Expect(1, 126126, '\P{Nv=0.25}', "");
    Expect(0, 126126, '\P{^Nv=0.25}', "");
    Expect(1, 126125, '\p{Nv=2.500e-01}', "");
    Expect(0, 126125, '\p{^Nv=2.500e-01}', "");
    Expect(0, 126125, '\P{Nv=2.500e-01}', "");
    Expect(1, 126125, '\P{^Nv=2.500e-01}', "");
    Expect(0, 126126, '\p{Nv=2.500e-01}', "");
    Expect(1, 126126, '\p{^Nv=2.500e-01}', "");
    Expect(1, 126126, '\P{Nv=2.500e-01}', "");
    Expect(0, 126126, '\P{^Nv=2.500e-01}', "");
    Expect(1, 126125, '\p{Nv=0.250}', "");
    Expect(0, 126125, '\p{^Nv=0.250}', "");
    Expect(0, 126125, '\P{Nv=0.250}', "");
    Expect(1, 126125, '\P{^Nv=0.250}', "");
    Expect(0, 126126, '\p{Nv=0.250}', "");
    Expect(1, 126126, '\p{^Nv=0.250}', "");
    Expect(1, 126126, '\P{Nv=0.250}', "");
    Expect(0, 126126, '\P{^Nv=0.250}', "");
    Error('\p{Is_Numeric_Value=:=_00000001/004}');
    Error('\P{Is_Numeric_Value=:=_00000001/004}');
    Expect(1, 126125, '\p{Is_Numeric_Value=1/000004}', "");
    Expect(0, 126125, '\p{^Is_Numeric_Value=1/000004}', "");
    Expect(0, 126125, '\P{Is_Numeric_Value=1/000004}', "");
    Expect(1, 126125, '\P{^Is_Numeric_Value=1/000004}', "");
    Expect(0, 126126, '\p{Is_Numeric_Value=1/000004}', "");
    Expect(1, 126126, '\p{^Is_Numeric_Value=1/000004}', "");
    Expect(1, 126126, '\P{Is_Numeric_Value=1/000004}', "");
    Expect(0, 126126, '\P{^Is_Numeric_Value=1/000004}', "");
    Expect(1, 126125, '\p{Is_Numeric_Value=60/240}', "");
    Expect(0, 126125, '\p{^Is_Numeric_Value=60/240}', "");
    Expect(0, 126125, '\P{Is_Numeric_Value=60/240}', "");
    Expect(1, 126125, '\P{^Is_Numeric_Value=60/240}', "");
    Expect(0, 126126, '\p{Is_Numeric_Value=60/240}', "");
    Expect(1, 126126, '\p{^Is_Numeric_Value=60/240}', "");
    Expect(1, 126126, '\P{Is_Numeric_Value=60/240}', "");
    Expect(0, 126126, '\P{^Is_Numeric_Value=60/240}', "");
    Expect(1, 126125, '\p{Is_Numeric_Value=2.5e-01}', "");
    Expect(0, 126125, '\p{^Is_Numeric_Value=2.5e-01}', "");
    Expect(0, 126125, '\P{Is_Numeric_Value=2.5e-01}', "");
    Expect(1, 126125, '\P{^Is_Numeric_Value=2.5e-01}', "");
    Expect(0, 126126, '\p{Is_Numeric_Value=2.5e-01}', "");
    Expect(1, 126126, '\p{^Is_Numeric_Value=2.5e-01}', "");
    Expect(1, 126126, '\P{Is_Numeric_Value=2.5e-01}', "");
    Expect(0, 126126, '\P{^Is_Numeric_Value=2.5e-01}', "");
    Expect(1, 126125, '\p{Is_Numeric_Value=2.50e-01}', "");
    Expect(0, 126125, '\p{^Is_Numeric_Value=2.50e-01}', "");
    Expect(0, 126125, '\P{Is_Numeric_Value=2.50e-01}', "");
    Expect(1, 126125, '\P{^Is_Numeric_Value=2.50e-01}', "");
    Expect(0, 126126, '\p{Is_Numeric_Value=2.50e-01}', "");
    Expect(1, 126126, '\p{^Is_Numeric_Value=2.50e-01}', "");
    Expect(1, 126126, '\P{Is_Numeric_Value=2.50e-01}', "");
    Expect(0, 126126, '\P{^Is_Numeric_Value=2.50e-01}', "");
    Expect(1, 126125, '\p{Is_Numeric_Value:   0.25}', "");
    Expect(0, 126125, '\p{^Is_Numeric_Value:   0.25}', "");
    Expect(0, 126125, '\P{Is_Numeric_Value:   0.25}', "");
    Expect(1, 126125, '\P{^Is_Numeric_Value:   0.25}', "");
    Expect(0, 126126, '\p{Is_Numeric_Value:   0.25}', "");
    Expect(1, 126126, '\p{^Is_Numeric_Value:   0.25}', "");
    Expect(1, 126126, '\P{Is_Numeric_Value:   0.25}', "");
    Expect(0, 126126, '\P{^Is_Numeric_Value:   0.25}', "");
    Expect(1, 126125, '\p{Is_Numeric_Value=2.500e-01}', "");
    Expect(0, 126125, '\p{^Is_Numeric_Value=2.500e-01}', "");
    Expect(0, 126125, '\P{Is_Numeric_Value=2.500e-01}', "");
    Expect(1, 126125, '\P{^Is_Numeric_Value=2.500e-01}', "");
    Expect(0, 126126, '\p{Is_Numeric_Value=2.500e-01}', "");
    Expect(1, 126126, '\p{^Is_Numeric_Value=2.500e-01}', "");
    Expect(1, 126126, '\P{Is_Numeric_Value=2.500e-01}', "");
    Expect(0, 126126, '\P{^Is_Numeric_Value=2.500e-01}', "");
    Expect(1, 126125, '\p{Is_Numeric_Value:   0.250}', "");
    Expect(0, 126125, '\p{^Is_Numeric_Value:   0.250}', "");
    Expect(0, 126125, '\P{Is_Numeric_Value:   0.250}', "");
    Expect(1, 126125, '\P{^Is_Numeric_Value:   0.250}', "");
    Expect(0, 126126, '\p{Is_Numeric_Value:   0.250}', "");
    Expect(1, 126126, '\p{^Is_Numeric_Value:   0.250}', "");
    Expect(1, 126126, '\P{Is_Numeric_Value:   0.250}', "");
    Expect(0, 126126, '\P{^Is_Numeric_Value:   0.250}', "");
    Error('\p{Is_Nv= -001/004/a/}');
    Error('\P{Is_Nv= -001/004/a/}');
    Expect(1, 126125, '\p{Is_Nv=000001/000004}', "");
    Expect(0, 126125, '\p{^Is_Nv=000001/000004}', "");
    Expect(0, 126125, '\P{Is_Nv=000001/000004}', "");
    Expect(1, 126125, '\P{^Is_Nv=000001/000004}', "");
    Expect(0, 126126, '\p{Is_Nv=000001/000004}', "");
    Expect(1, 126126, '\p{^Is_Nv=000001/000004}', "");
    Expect(1, 126126, '\P{Is_Nv=000001/000004}', "");
    Expect(0, 126126, '\P{^Is_Nv=000001/000004}', "");
    Expect(1, 126125, '\p{Is_Nv=60/240}', "");
    Expect(0, 126125, '\p{^Is_Nv=60/240}', "");
    Expect(0, 126125, '\P{Is_Nv=60/240}', "");
    Expect(1, 126125, '\P{^Is_Nv=60/240}', "");
    Expect(0, 126126, '\p{Is_Nv=60/240}', "");
    Expect(1, 126126, '\p{^Is_Nv=60/240}', "");
    Expect(1, 126126, '\P{Is_Nv=60/240}', "");
    Expect(0, 126126, '\P{^Is_Nv=60/240}', "");
    Expect(1, 126125, '\p{Is_Nv=2.5e-01}', "");
    Expect(0, 126125, '\p{^Is_Nv=2.5e-01}', "");
    Expect(0, 126125, '\P{Is_Nv=2.5e-01}', "");
    Expect(1, 126125, '\P{^Is_Nv=2.5e-01}', "");
    Expect(0, 126126, '\p{Is_Nv=2.5e-01}', "");
    Expect(1, 126126, '\p{^Is_Nv=2.5e-01}', "");
    Expect(1, 126126, '\P{Is_Nv=2.5e-01}', "");
    Expect(0, 126126, '\P{^Is_Nv=2.5e-01}', "");
    Expect(1, 126125, '\p{Is_Nv=2.50e-01}', "");
    Expect(0, 126125, '\p{^Is_Nv=2.50e-01}', "");
    Expect(0, 126125, '\P{Is_Nv=2.50e-01}', "");
    Expect(1, 126125, '\P{^Is_Nv=2.50e-01}', "");
    Expect(0, 126126, '\p{Is_Nv=2.50e-01}', "");
    Expect(1, 126126, '\p{^Is_Nv=2.50e-01}', "");
    Expect(1, 126126, '\P{Is_Nv=2.50e-01}', "");
    Expect(0, 126126, '\P{^Is_Nv=2.50e-01}', "");
    Expect(1, 126125, '\p{Is_Nv=0.25}', "");
    Expect(0, 126125, '\p{^Is_Nv=0.25}', "");
    Expect(0, 126125, '\P{Is_Nv=0.25}', "");
    Expect(1, 126125, '\P{^Is_Nv=0.25}', "");
    Expect(0, 126126, '\p{Is_Nv=0.25}', "");
    Expect(1, 126126, '\p{^Is_Nv=0.25}', "");
    Expect(1, 126126, '\P{Is_Nv=0.25}', "");
    Expect(0, 126126, '\P{^Is_Nv=0.25}', "");
    Expect(1, 126125, '\p{Is_Nv=2.500e-01}', "");
    Expect(0, 126125, '\p{^Is_Nv=2.500e-01}', "");
    Expect(0, 126125, '\P{Is_Nv=2.500e-01}', "");
    Expect(1, 126125, '\P{^Is_Nv=2.500e-01}', "");
    Expect(0, 126126, '\p{Is_Nv=2.500e-01}', "");
    Expect(1, 126126, '\p{^Is_Nv=2.500e-01}', "");
    Expect(1, 126126, '\P{Is_Nv=2.500e-01}', "");
    Expect(0, 126126, '\P{^Is_Nv=2.500e-01}', "");
    Expect(1, 126125, '\p{Is_Nv=0.250}', "");
    Expect(0, 126125, '\p{^Is_Nv=0.250}', "");
    Expect(0, 126125, '\P{Is_Nv=0.250}', "");
    Expect(1, 126125, '\P{^Is_Nv=0.250}', "");
    Expect(0, 126126, '\p{Is_Nv=0.250}', "");
    Expect(1, 126126, '\p{^Is_Nv=0.250}', "");
    Expect(1, 126126, '\P{Is_Nv=0.250}', "");
    Expect(0, 126126, '\P{^Is_Nv=0.250}', "");
    Error('\p{Numeric_Value:	:=	_00001/0000040}');
    Error('\P{Numeric_Value:	:=	_00001/0000040}');
    Expect(1, 73668, '\p{Numeric_Value=:\A1/40\z:}', "");;
    Expect(0, 73669, '\p{Numeric_Value=:\A1/40\z:}', "");;
    Expect(1, 73668, '\p{Numeric_Value=001/00040}', "");
    Expect(0, 73668, '\p{^Numeric_Value=001/00040}', "");
    Expect(0, 73668, '\P{Numeric_Value=001/00040}', "");
    Expect(1, 73668, '\P{^Numeric_Value=001/00040}', "");
    Expect(0, 73669, '\p{Numeric_Value=001/00040}', "");
    Expect(1, 73669, '\p{^Numeric_Value=001/00040}', "");
    Expect(1, 73669, '\P{Numeric_Value=001/00040}', "");
    Expect(0, 73669, '\P{^Numeric_Value=001/00040}', "");
    Expect(1, 73668, '\p{Numeric_Value=60/2400}', "");
    Expect(0, 73668, '\p{^Numeric_Value=60/2400}', "");
    Expect(0, 73668, '\P{Numeric_Value=60/2400}', "");
    Expect(1, 73668, '\P{^Numeric_Value=60/2400}', "");
    Expect(0, 73669, '\p{Numeric_Value=60/2400}', "");
    Expect(1, 73669, '\p{^Numeric_Value=60/2400}', "");
    Expect(1, 73669, '\P{Numeric_Value=60/2400}', "");
    Expect(0, 73669, '\P{^Numeric_Value=60/2400}', "");
    Expect(1, 73668, '\p{Numeric_Value=2.5e-02}', "");
    Expect(0, 73668, '\p{^Numeric_Value=2.5e-02}', "");
    Expect(0, 73668, '\P{Numeric_Value=2.5e-02}', "");
    Expect(1, 73668, '\P{^Numeric_Value=2.5e-02}', "");
    Expect(0, 73669, '\p{Numeric_Value=2.5e-02}', "");
    Expect(1, 73669, '\p{^Numeric_Value=2.5e-02}', "");
    Expect(1, 73669, '\P{Numeric_Value=2.5e-02}', "");
    Expect(0, 73669, '\P{^Numeric_Value=2.5e-02}', "");
    Expect(1, 73668, '\p{Numeric_Value:	2.50e-02}', "");
    Expect(0, 73668, '\p{^Numeric_Value:	2.50e-02}', "");
    Expect(0, 73668, '\P{Numeric_Value:	2.50e-02}', "");
    Expect(1, 73668, '\P{^Numeric_Value:	2.50e-02}', "");
    Expect(0, 73669, '\p{Numeric_Value:	2.50e-02}', "");
    Expect(1, 73669, '\p{^Numeric_Value:	2.50e-02}', "");
    Expect(1, 73669, '\P{Numeric_Value:	2.50e-02}', "");
    Expect(0, 73669, '\P{^Numeric_Value:	2.50e-02}', "");
    Error('\p{Numeric_Value=0.03}');
    Error('\P{Numeric_Value=0.03}');
    Expect(1, 73668, '\p{Numeric_Value=2.500e-02}', "");
    Expect(0, 73668, '\p{^Numeric_Value=2.500e-02}', "");
    Expect(0, 73668, '\P{Numeric_Value=2.500e-02}', "");
    Expect(1, 73668, '\P{^Numeric_Value=2.500e-02}', "");
    Expect(0, 73669, '\p{Numeric_Value=2.500e-02}', "");
    Expect(1, 73669, '\p{^Numeric_Value=2.500e-02}', "");
    Expect(1, 73669, '\P{Numeric_Value=2.500e-02}', "");
    Expect(0, 73669, '\P{^Numeric_Value=2.500e-02}', "");
    Expect(1, 73668, '\p{Numeric_Value=0.025}', "");
    Expect(0, 73668, '\p{^Numeric_Value=0.025}', "");
    Expect(0, 73668, '\P{Numeric_Value=0.025}', "");
    Expect(1, 73668, '\P{^Numeric_Value=0.025}', "");
    Expect(0, 73669, '\p{Numeric_Value=0.025}', "");
    Expect(1, 73669, '\p{^Numeric_Value=0.025}', "");
    Expect(1, 73669, '\P{Numeric_Value=0.025}', "");
    Expect(0, 73669, '\P{^Numeric_Value=0.025}', "");
    Expect(1, 73668, '\p{Numeric_Value=2.5000e-02}', "");
    Expect(0, 73668, '\p{^Numeric_Value=2.5000e-02}', "");
    Expect(0, 73668, '\P{Numeric_Value=2.5000e-02}', "");
    Expect(1, 73668, '\P{^Numeric_Value=2.5000e-02}', "");
    Expect(0, 73669, '\p{Numeric_Value=2.5000e-02}', "");
    Expect(1, 73669, '\p{^Numeric_Value=2.5000e-02}', "");
    Expect(1, 73669, '\P{Numeric_Value=2.5000e-02}', "");
    Expect(0, 73669, '\P{^Numeric_Value=2.5000e-02}', "");
    Expect(1, 73668, '\p{Numeric_Value=0.0250}', "");
    Expect(0, 73668, '\p{^Numeric_Value=0.0250}', "");
    Expect(0, 73668, '\P{Numeric_Value=0.0250}', "");
    Expect(1, 73668, '\P{^Numeric_Value=0.0250}', "");
    Expect(0, 73669, '\p{Numeric_Value=0.0250}', "");
    Expect(1, 73669, '\p{^Numeric_Value=0.0250}', "");
    Expect(1, 73669, '\P{Numeric_Value=0.0250}', "");
    Expect(0, 73669, '\P{^Numeric_Value=0.0250}', "");
    Error('\p{Nv=_ 000000001/40/a/}');
    Error('\P{Nv=_ 000000001/40/a/}');
    Expect(1, 73668, '\p{Nv=:\A1/40\z:}', "");;
    Expect(0, 73669, '\p{Nv=:\A1/40\z:}', "");;
    Expect(1, 73668, '\p{Nv=0000001/00000000040}', "");
    Expect(0, 73668, '\p{^Nv=0000001/00000000040}', "");
    Expect(0, 73668, '\P{Nv=0000001/00000000040}', "");
    Expect(1, 73668, '\P{^Nv=0000001/00000000040}', "");
    Expect(0, 73669, '\p{Nv=0000001/00000000040}', "");
    Expect(1, 73669, '\p{^Nv=0000001/00000000040}', "");
    Expect(1, 73669, '\P{Nv=0000001/00000000040}', "");
    Expect(0, 73669, '\P{^Nv=0000001/00000000040}', "");
    Expect(1, 73668, '\p{Nv=60/2400}', "");
    Expect(0, 73668, '\p{^Nv=60/2400}', "");
    Expect(0, 73668, '\P{Nv=60/2400}', "");
    Expect(1, 73668, '\P{^Nv=60/2400}', "");
    Expect(0, 73669, '\p{Nv=60/2400}', "");
    Expect(1, 73669, '\p{^Nv=60/2400}', "");
    Expect(1, 73669, '\P{Nv=60/2400}', "");
    Expect(0, 73669, '\P{^Nv=60/2400}', "");
    Expect(1, 73668, '\p{Nv=2.5e-02}', "");
    Expect(0, 73668, '\p{^Nv=2.5e-02}', "");
    Expect(0, 73668, '\P{Nv=2.5e-02}', "");
    Expect(1, 73668, '\P{^Nv=2.5e-02}', "");
    Expect(0, 73669, '\p{Nv=2.5e-02}', "");
    Expect(1, 73669, '\p{^Nv=2.5e-02}', "");
    Expect(1, 73669, '\P{Nv=2.5e-02}', "");
    Expect(0, 73669, '\P{^Nv=2.5e-02}', "");
    Expect(1, 73668, '\p{Nv:   2.50e-02}', "");
    Expect(0, 73668, '\p{^Nv:   2.50e-02}', "");
    Expect(0, 73668, '\P{Nv:   2.50e-02}', "");
    Expect(1, 73668, '\P{^Nv:   2.50e-02}', "");
    Expect(0, 73669, '\p{Nv:   2.50e-02}', "");
    Expect(1, 73669, '\p{^Nv:   2.50e-02}', "");
    Expect(1, 73669, '\P{Nv:   2.50e-02}', "");
    Expect(0, 73669, '\P{^Nv:   2.50e-02}', "");
    Error('\p{Nv=0.03}');
    Error('\P{Nv=0.03}');
    Expect(1, 73668, '\p{Nv=2.500e-02}', "");
    Expect(0, 73668, '\p{^Nv=2.500e-02}', "");
    Expect(0, 73668, '\P{Nv=2.500e-02}', "");
    Expect(1, 73668, '\P{^Nv=2.500e-02}', "");
    Expect(0, 73669, '\p{Nv=2.500e-02}', "");
    Expect(1, 73669, '\p{^Nv=2.500e-02}', "");
    Expect(1, 73669, '\P{Nv=2.500e-02}', "");
    Expect(0, 73669, '\P{^Nv=2.500e-02}', "");
    Expect(1, 73668, '\p{Nv: 0.025}', "");
    Expect(0, 73668, '\p{^Nv: 0.025}', "");
    Expect(0, 73668, '\P{Nv: 0.025}', "");
    Expect(1, 73668, '\P{^Nv: 0.025}', "");
    Expect(0, 73669, '\p{Nv: 0.025}', "");
    Expect(1, 73669, '\p{^Nv: 0.025}', "");
    Expect(1, 73669, '\P{Nv: 0.025}', "");
    Expect(0, 73669, '\P{^Nv: 0.025}', "");
    Expect(1, 73668, '\p{Nv: 2.5000e-02}', "");
    Expect(0, 73668, '\p{^Nv: 2.5000e-02}', "");
    Expect(0, 73668, '\P{Nv: 2.5000e-02}', "");
    Expect(1, 73668, '\P{^Nv: 2.5000e-02}', "");
    Expect(0, 73669, '\p{Nv: 2.5000e-02}', "");
    Expect(1, 73669, '\p{^Nv: 2.5000e-02}', "");
    Expect(1, 73669, '\P{Nv: 2.5000e-02}', "");
    Expect(0, 73669, '\P{^Nv: 2.5000e-02}', "");
    Expect(1, 73668, '\p{Nv=0.0250}', "");
    Expect(0, 73668, '\p{^Nv=0.0250}', "");
    Expect(0, 73668, '\P{Nv=0.0250}', "");
    Expect(1, 73668, '\P{^Nv=0.0250}', "");
    Expect(0, 73669, '\p{Nv=0.0250}', "");
    Expect(1, 73669, '\p{^Nv=0.0250}', "");
    Expect(1, 73669, '\P{Nv=0.0250}', "");
    Expect(0, 73669, '\P{^Nv=0.0250}', "");
    Error('\p{Is_Numeric_Value=/a/ +0001/00000040}');
    Error('\P{Is_Numeric_Value=/a/ +0001/00000040}');
    Expect(1, 73668, '\p{Is_Numeric_Value=001/0000000040}', "");
    Expect(0, 73668, '\p{^Is_Numeric_Value=001/0000000040}', "");
    Expect(0, 73668, '\P{Is_Numeric_Value=001/0000000040}', "");
    Expect(1, 73668, '\P{^Is_Numeric_Value=001/0000000040}', "");
    Expect(0, 73669, '\p{Is_Numeric_Value=001/0000000040}', "");
    Expect(1, 73669, '\p{^Is_Numeric_Value=001/0000000040}', "");
    Expect(1, 73669, '\P{Is_Numeric_Value=001/0000000040}', "");
    Expect(0, 73669, '\P{^Is_Numeric_Value=001/0000000040}', "");
    Expect(1, 73668, '\p{Is_Numeric_Value=60/2400}', "");
    Expect(0, 73668, '\p{^Is_Numeric_Value=60/2400}', "");
    Expect(0, 73668, '\P{Is_Numeric_Value=60/2400}', "");
    Expect(1, 73668, '\P{^Is_Numeric_Value=60/2400}', "");
    Expect(0, 73669, '\p{Is_Numeric_Value=60/2400}', "");
    Expect(1, 73669, '\p{^Is_Numeric_Value=60/2400}', "");
    Expect(1, 73669, '\P{Is_Numeric_Value=60/2400}', "");
    Expect(0, 73669, '\P{^Is_Numeric_Value=60/2400}', "");
    Expect(1, 73668, '\p{Is_Numeric_Value=2.5e-02}', "");
    Expect(0, 73668, '\p{^Is_Numeric_Value=2.5e-02}', "");
    Expect(0, 73668, '\P{Is_Numeric_Value=2.5e-02}', "");
    Expect(1, 73668, '\P{^Is_Numeric_Value=2.5e-02}', "");
    Expect(0, 73669, '\p{Is_Numeric_Value=2.5e-02}', "");
    Expect(1, 73669, '\p{^Is_Numeric_Value=2.5e-02}', "");
    Expect(1, 73669, '\P{Is_Numeric_Value=2.5e-02}', "");
    Expect(0, 73669, '\P{^Is_Numeric_Value=2.5e-02}', "");
    Expect(1, 73668, '\p{Is_Numeric_Value=2.50e-02}', "");
    Expect(0, 73668, '\p{^Is_Numeric_Value=2.50e-02}', "");
    Expect(0, 73668, '\P{Is_Numeric_Value=2.50e-02}', "");
    Expect(1, 73668, '\P{^Is_Numeric_Value=2.50e-02}', "");
    Expect(0, 73669, '\p{Is_Numeric_Value=2.50e-02}', "");
    Expect(1, 73669, '\p{^Is_Numeric_Value=2.50e-02}', "");
    Expect(1, 73669, '\P{Is_Numeric_Value=2.50e-02}', "");
    Expect(0, 73669, '\P{^Is_Numeric_Value=2.50e-02}', "");
    Error('\p{Is_Numeric_Value=0.03}');
    Error('\P{Is_Numeric_Value=0.03}');
    Expect(1, 73668, '\p{Is_Numeric_Value=2.500e-02}', "");
    Expect(0, 73668, '\p{^Is_Numeric_Value=2.500e-02}', "");
    Expect(0, 73668, '\P{Is_Numeric_Value=2.500e-02}', "");
    Expect(1, 73668, '\P{^Is_Numeric_Value=2.500e-02}', "");
    Expect(0, 73669, '\p{Is_Numeric_Value=2.500e-02}', "");
    Expect(1, 73669, '\p{^Is_Numeric_Value=2.500e-02}', "");
    Expect(1, 73669, '\P{Is_Numeric_Value=2.500e-02}', "");
    Expect(0, 73669, '\P{^Is_Numeric_Value=2.500e-02}', "");
    Expect(1, 73668, '\p{Is_Numeric_Value=0.025}', "");
    Expect(0, 73668, '\p{^Is_Numeric_Value=0.025}', "");
    Expect(0, 73668, '\P{Is_Numeric_Value=0.025}', "");
    Expect(1, 73668, '\P{^Is_Numeric_Value=0.025}', "");
    Expect(0, 73669, '\p{Is_Numeric_Value=0.025}', "");
    Expect(1, 73669, '\p{^Is_Numeric_Value=0.025}', "");
    Expect(1, 73669, '\P{Is_Numeric_Value=0.025}', "");
    Expect(0, 73669, '\P{^Is_Numeric_Value=0.025}', "");
    Expect(1, 73668, '\p{Is_Numeric_Value=2.5000e-02}', "");
    Expect(0, 73668, '\p{^Is_Numeric_Value=2.5000e-02}', "");
    Expect(0, 73668, '\P{Is_Numeric_Value=2.5000e-02}', "");
    Expect(1, 73668, '\P{^Is_Numeric_Value=2.5000e-02}', "");
    Expect(0, 73669, '\p{Is_Numeric_Value=2.5000e-02}', "");
    Expect(1, 73669, '\p{^Is_Numeric_Value=2.5000e-02}', "");
    Expect(1, 73669, '\P{Is_Numeric_Value=2.5000e-02}', "");
    Expect(0, 73669, '\P{^Is_Numeric_Value=2.5000e-02}', "");
    Expect(1, 73668, '\p{Is_Numeric_Value=0.0250}', "");
    Expect(0, 73668, '\p{^Is_Numeric_Value=0.0250}', "");
    Expect(0, 73668, '\P{Is_Numeric_Value=0.0250}', "");
    Expect(1, 73668, '\P{^Is_Numeric_Value=0.0250}', "");
    Expect(0, 73669, '\p{Is_Numeric_Value=0.0250}', "");
    Expect(1, 73669, '\p{^Is_Numeric_Value=0.0250}', "");
    Expect(1, 73669, '\P{Is_Numeric_Value=0.0250}', "");
    Expect(0, 73669, '\P{^Is_Numeric_Value=0.0250}', "");
    Error('\p{Is_Nv=_/a/+00001/0040}');
    Error('\P{Is_Nv=_/a/+00001/0040}');
    Expect(1, 73668, '\p{Is_Nv=0001/00040}', "");
    Expect(0, 73668, '\p{^Is_Nv=0001/00040}', "");
    Expect(0, 73668, '\P{Is_Nv=0001/00040}', "");
    Expect(1, 73668, '\P{^Is_Nv=0001/00040}', "");
    Expect(0, 73669, '\p{Is_Nv=0001/00040}', "");
    Expect(1, 73669, '\p{^Is_Nv=0001/00040}', "");
    Expect(1, 73669, '\P{Is_Nv=0001/00040}', "");
    Expect(0, 73669, '\P{^Is_Nv=0001/00040}', "");
    Expect(1, 73668, '\p{Is_Nv=60/2400}', "");
    Expect(0, 73668, '\p{^Is_Nv=60/2400}', "");
    Expect(0, 73668, '\P{Is_Nv=60/2400}', "");
    Expect(1, 73668, '\P{^Is_Nv=60/2400}', "");
    Expect(0, 73669, '\p{Is_Nv=60/2400}', "");
    Expect(1, 73669, '\p{^Is_Nv=60/2400}', "");
    Expect(1, 73669, '\P{Is_Nv=60/2400}', "");
    Expect(0, 73669, '\P{^Is_Nv=60/2400}', "");
    Expect(1, 73668, '\p{Is_Nv:	2.5e-02}', "");
    Expect(0, 73668, '\p{^Is_Nv:	2.5e-02}', "");
    Expect(0, 73668, '\P{Is_Nv:	2.5e-02}', "");
    Expect(1, 73668, '\P{^Is_Nv:	2.5e-02}', "");
    Expect(0, 73669, '\p{Is_Nv:	2.5e-02}', "");
    Expect(1, 73669, '\p{^Is_Nv:	2.5e-02}', "");
    Expect(1, 73669, '\P{Is_Nv:	2.5e-02}', "");
    Expect(0, 73669, '\P{^Is_Nv:	2.5e-02}', "");
    Expect(1, 73668, '\p{Is_Nv=2.50e-02}', "");
    Expect(0, 73668, '\p{^Is_Nv=2.50e-02}', "");
    Expect(0, 73668, '\P{Is_Nv=2.50e-02}', "");
    Expect(1, 73668, '\P{^Is_Nv=2.50e-02}', "");
    Expect(0, 73669, '\p{Is_Nv=2.50e-02}', "");
    Expect(1, 73669, '\p{^Is_Nv=2.50e-02}', "");
    Expect(1, 73669, '\P{Is_Nv=2.50e-02}', "");
    Expect(0, 73669, '\P{^Is_Nv=2.50e-02}', "");
    Error('\p{Is_Nv:0.03}');
    Error('\P{Is_Nv:0.03}');
    Expect(1, 73668, '\p{Is_Nv=2.500e-02}', "");
    Expect(0, 73668, '\p{^Is_Nv=2.500e-02}', "");
    Expect(0, 73668, '\P{Is_Nv=2.500e-02}', "");
    Expect(1, 73668, '\P{^Is_Nv=2.500e-02}', "");
    Expect(0, 73669, '\p{Is_Nv=2.500e-02}', "");
    Expect(1, 73669, '\p{^Is_Nv=2.500e-02}', "");
    Expect(1, 73669, '\P{Is_Nv=2.500e-02}', "");
    Expect(0, 73669, '\P{^Is_Nv=2.500e-02}', "");
    Expect(1, 73668, '\p{Is_Nv=0.025}', "");
    Expect(0, 73668, '\p{^Is_Nv=0.025}', "");
    Expect(0, 73668, '\P{Is_Nv=0.025}', "");
    Expect(1, 73668, '\P{^Is_Nv=0.025}', "");
    Expect(0, 73669, '\p{Is_Nv=0.025}', "");
    Expect(1, 73669, '\p{^Is_Nv=0.025}', "");
    Expect(1, 73669, '\P{Is_Nv=0.025}', "");
    Expect(0, 73669, '\P{^Is_Nv=0.025}', "");
    Expect(1, 73668, '\p{Is_Nv=2.5000e-02}', "");
    Expect(0, 73668, '\p{^Is_Nv=2.5000e-02}', "");
    Expect(0, 73668, '\P{Is_Nv=2.5000e-02}', "");
    Expect(1, 73668, '\P{^Is_Nv=2.5000e-02}', "");
    Expect(0, 73669, '\p{Is_Nv=2.5000e-02}', "");
    Expect(1, 73669, '\p{^Is_Nv=2.5000e-02}', "");
    Expect(1, 73669, '\P{Is_Nv=2.5000e-02}', "");
    Expect(0, 73669, '\P{^Is_Nv=2.5000e-02}', "");
    Expect(1, 73668, '\p{Is_Nv=0.0250}', "");
    Expect(0, 73668, '\p{^Is_Nv=0.0250}', "");
    Expect(0, 73668, '\P{Is_Nv=0.0250}', "");
    Expect(1, 73668, '\P{^Is_Nv=0.0250}', "");
    Expect(0, 73669, '\p{Is_Nv=0.0250}', "");
    Expect(1, 73669, '\p{^Is_Nv=0.0250}', "");
    Expect(1, 73669, '\P{Is_Nv=0.0250}', "");
    Expect(0, 73669, '\P{^Is_Nv=0.0250}', "");
    Error('\p{Numeric_Value=- 0001/000000005:=}');
    Error('\P{Numeric_Value=- 0001/000000005:=}');
    Expect(1, 73679, '\p{Numeric_Value=:\A1/5\z:}', "");;
    Expect(0, 73680, '\p{Numeric_Value=:\A1/5\z:}', "");;
    Expect(1, 73679, '\p{Numeric_Value=+0000001/0005}', "");
    Expect(0, 73679, '\p{^Numeric_Value=+0000001/0005}', "");
    Expect(0, 73679, '\P{Numeric_Value=+0000001/0005}', "");
    Expect(1, 73679, '\P{^Numeric_Value=+0000001/0005}', "");
    Expect(0, 73680, '\p{Numeric_Value=+0000001/0005}', "");
    Expect(1, 73680, '\p{^Numeric_Value=+0000001/0005}', "");
    Expect(1, 73680, '\P{Numeric_Value=+0000001/0005}', "");
    Expect(0, 73680, '\P{^Numeric_Value=+0000001/0005}', "");
    Expect(1, 73679, '\p{Numeric_Value:   60/300}', "");
    Expect(0, 73679, '\p{^Numeric_Value:   60/300}', "");
    Expect(0, 73679, '\P{Numeric_Value:   60/300}', "");
    Expect(1, 73679, '\P{^Numeric_Value:   60/300}', "");
    Expect(0, 73680, '\p{Numeric_Value:   60/300}', "");
    Expect(1, 73680, '\p{^Numeric_Value:   60/300}', "");
    Expect(1, 73680, '\P{Numeric_Value:   60/300}', "");
    Expect(0, 73680, '\P{^Numeric_Value:   60/300}', "");
    Expect(1, 73679, '\p{Numeric_Value:2.0e-01}', "");
    Expect(0, 73679, '\p{^Numeric_Value:2.0e-01}', "");
    Expect(0, 73679, '\P{Numeric_Value:2.0e-01}', "");
    Expect(1, 73679, '\P{^Numeric_Value:2.0e-01}', "");
    Expect(0, 73680, '\p{Numeric_Value:2.0e-01}', "");
    Expect(1, 73680, '\p{^Numeric_Value:2.0e-01}', "");
    Expect(1, 73680, '\P{Numeric_Value:2.0e-01}', "");
    Expect(0, 73680, '\P{^Numeric_Value:2.0e-01}', "");
    Expect(1, 73679, '\p{Numeric_Value=0.2}', "");
    Expect(0, 73679, '\p{^Numeric_Value=0.2}', "");
    Expect(0, 73679, '\P{Numeric_Value=0.2}', "");
    Expect(1, 73679, '\P{^Numeric_Value=0.2}', "");
    Expect(0, 73680, '\p{Numeric_Value=0.2}', "");
    Expect(1, 73680, '\p{^Numeric_Value=0.2}', "");
    Expect(1, 73680, '\P{Numeric_Value=0.2}', "");
    Expect(0, 73680, '\P{^Numeric_Value=0.2}', "");
    Expect(1, 73679, '\p{Numeric_Value=2.00e-01}', "");
    Expect(0, 73679, '\p{^Numeric_Value=2.00e-01}', "");
    Expect(0, 73679, '\P{Numeric_Value=2.00e-01}', "");
    Expect(1, 73679, '\P{^Numeric_Value=2.00e-01}', "");
    Expect(0, 73680, '\p{Numeric_Value=2.00e-01}', "");
    Expect(1, 73680, '\p{^Numeric_Value=2.00e-01}', "");
    Expect(1, 73680, '\P{Numeric_Value=2.00e-01}', "");
    Expect(0, 73680, '\P{^Numeric_Value=2.00e-01}', "");
    Expect(1, 73679, '\p{Numeric_Value=0.20}', "");
    Expect(0, 73679, '\p{^Numeric_Value=0.20}', "");
    Expect(0, 73679, '\P{Numeric_Value=0.20}', "");
    Expect(1, 73679, '\P{^Numeric_Value=0.20}', "");
    Expect(0, 73680, '\p{Numeric_Value=0.20}', "");
    Expect(1, 73680, '\p{^Numeric_Value=0.20}', "");
    Expect(1, 73680, '\P{Numeric_Value=0.20}', "");
    Expect(0, 73680, '\P{^Numeric_Value=0.20}', "");
    Error('\p{Nv:--0000000001/00005:=}');
    Error('\P{Nv:--0000000001/00005:=}');
    Expect(1, 73679, '\p{Nv=:\A1/5\z:}', "");;
    Expect(0, 73680, '\p{Nv=:\A1/5\z:}', "");;
    Expect(1, 73679, '\p{Nv=00000001/0005}', "");
    Expect(0, 73679, '\p{^Nv=00000001/0005}', "");
    Expect(0, 73679, '\P{Nv=00000001/0005}', "");
    Expect(1, 73679, '\P{^Nv=00000001/0005}', "");
    Expect(0, 73680, '\p{Nv=00000001/0005}', "");
    Expect(1, 73680, '\p{^Nv=00000001/0005}', "");
    Expect(1, 73680, '\P{Nv=00000001/0005}', "");
    Expect(0, 73680, '\P{^Nv=00000001/0005}', "");
    Expect(1, 73679, '\p{Nv=60/300}', "");
    Expect(0, 73679, '\p{^Nv=60/300}', "");
    Expect(0, 73679, '\P{Nv=60/300}', "");
    Expect(1, 73679, '\P{^Nv=60/300}', "");
    Expect(0, 73680, '\p{Nv=60/300}', "");
    Expect(1, 73680, '\p{^Nv=60/300}', "");
    Expect(1, 73680, '\P{Nv=60/300}', "");
    Expect(0, 73680, '\P{^Nv=60/300}', "");
    Expect(1, 73679, '\p{Nv:	2.0e-01}', "");
    Expect(0, 73679, '\p{^Nv:	2.0e-01}', "");
    Expect(0, 73679, '\P{Nv:	2.0e-01}', "");
    Expect(1, 73679, '\P{^Nv:	2.0e-01}', "");
    Expect(0, 73680, '\p{Nv:	2.0e-01}', "");
    Expect(1, 73680, '\p{^Nv:	2.0e-01}', "");
    Expect(1, 73680, '\P{Nv:	2.0e-01}', "");
    Expect(0, 73680, '\P{^Nv:	2.0e-01}', "");
    Expect(1, 73679, '\p{Nv:	0.2}', "");
    Expect(0, 73679, '\p{^Nv:	0.2}', "");
    Expect(0, 73679, '\P{Nv:	0.2}', "");
    Expect(1, 73679, '\P{^Nv:	0.2}', "");
    Expect(0, 73680, '\p{Nv:	0.2}', "");
    Expect(1, 73680, '\p{^Nv:	0.2}', "");
    Expect(1, 73680, '\P{Nv:	0.2}', "");
    Expect(0, 73680, '\P{^Nv:	0.2}', "");
    Expect(1, 73679, '\p{Nv=2.00e-01}', "");
    Expect(0, 73679, '\p{^Nv=2.00e-01}', "");
    Expect(0, 73679, '\P{Nv=2.00e-01}', "");
    Expect(1, 73679, '\P{^Nv=2.00e-01}', "");
    Expect(0, 73680, '\p{Nv=2.00e-01}', "");
    Expect(1, 73680, '\p{^Nv=2.00e-01}', "");
    Expect(1, 73680, '\P{Nv=2.00e-01}', "");
    Expect(0, 73680, '\P{^Nv=2.00e-01}', "");
    Expect(1, 73679, '\p{Nv=0.20}', "");
    Expect(0, 73679, '\p{^Nv=0.20}', "");
    Expect(0, 73679, '\P{Nv=0.20}', "");
    Expect(1, 73679, '\P{^Nv=0.20}', "");
    Expect(0, 73680, '\p{Nv=0.20}', "");
    Expect(1, 73680, '\p{^Nv=0.20}', "");
    Expect(1, 73680, '\P{Nv=0.20}', "");
    Expect(0, 73680, '\P{^Nv=0.20}', "");
    Error('\p{Is_Numeric_Value=		0000001/0005:=}');
    Error('\P{Is_Numeric_Value=		0000001/0005:=}');
    Expect(1, 73679, '\p{Is_Numeric_Value=01/000005}', "");
    Expect(0, 73679, '\p{^Is_Numeric_Value=01/000005}', "");
    Expect(0, 73679, '\P{Is_Numeric_Value=01/000005}', "");
    Expect(1, 73679, '\P{^Is_Numeric_Value=01/000005}', "");
    Expect(0, 73680, '\p{Is_Numeric_Value=01/000005}', "");
    Expect(1, 73680, '\p{^Is_Numeric_Value=01/000005}', "");
    Expect(1, 73680, '\P{Is_Numeric_Value=01/000005}', "");
    Expect(0, 73680, '\P{^Is_Numeric_Value=01/000005}', "");
    Expect(1, 73679, '\p{Is_Numeric_Value=60/300}', "");
    Expect(0, 73679, '\p{^Is_Numeric_Value=60/300}', "");
    Expect(0, 73679, '\P{Is_Numeric_Value=60/300}', "");
    Expect(1, 73679, '\P{^Is_Numeric_Value=60/300}', "");
    Expect(0, 73680, '\p{Is_Numeric_Value=60/300}', "");
    Expect(1, 73680, '\p{^Is_Numeric_Value=60/300}', "");
    Expect(1, 73680, '\P{Is_Numeric_Value=60/300}', "");
    Expect(0, 73680, '\P{^Is_Numeric_Value=60/300}', "");
    Expect(1, 73679, '\p{Is_Numeric_Value=2.0e-01}', "");
    Expect(0, 73679, '\p{^Is_Numeric_Value=2.0e-01}', "");
    Expect(0, 73679, '\P{Is_Numeric_Value=2.0e-01}', "");
    Expect(1, 73679, '\P{^Is_Numeric_Value=2.0e-01}', "");
    Expect(0, 73680, '\p{Is_Numeric_Value=2.0e-01}', "");
    Expect(1, 73680, '\p{^Is_Numeric_Value=2.0e-01}', "");
    Expect(1, 73680, '\P{Is_Numeric_Value=2.0e-01}', "");
    Expect(0, 73680, '\P{^Is_Numeric_Value=2.0e-01}', "");
    Expect(1, 73679, '\p{Is_Numeric_Value=0.2}', "");
    Expect(0, 73679, '\p{^Is_Numeric_Value=0.2}', "");
    Expect(0, 73679, '\P{Is_Numeric_Value=0.2}', "");
    Expect(1, 73679, '\P{^Is_Numeric_Value=0.2}', "");
    Expect(0, 73680, '\p{Is_Numeric_Value=0.2}', "");
    Expect(1, 73680, '\p{^Is_Numeric_Value=0.2}', "");
    Expect(1, 73680, '\P{Is_Numeric_Value=0.2}', "");
    Expect(0, 73680, '\P{^Is_Numeric_Value=0.2}', "");
    Expect(1, 73679, '\p{Is_Numeric_Value=2.00e-01}', "");
    Expect(0, 73679, '\p{^Is_Numeric_Value=2.00e-01}', "");
    Expect(0, 73679, '\P{Is_Numeric_Value=2.00e-01}', "");
    Expect(1, 73679, '\P{^Is_Numeric_Value=2.00e-01}', "");
    Expect(0, 73680, '\p{Is_Numeric_Value=2.00e-01}', "");
    Expect(1, 73680, '\p{^Is_Numeric_Value=2.00e-01}', "");
    Expect(1, 73680, '\P{Is_Numeric_Value=2.00e-01}', "");
    Expect(0, 73680, '\P{^Is_Numeric_Value=2.00e-01}', "");
    Expect(1, 73679, '\p{Is_Numeric_Value=0.20}', "");
    Expect(0, 73679, '\p{^Is_Numeric_Value=0.20}', "");
    Expect(0, 73679, '\P{Is_Numeric_Value=0.20}', "");
    Expect(1, 73679, '\P{^Is_Numeric_Value=0.20}', "");
    Expect(0, 73680, '\p{Is_Numeric_Value=0.20}', "");
    Expect(1, 73680, '\p{^Is_Numeric_Value=0.20}', "");
    Expect(1, 73680, '\P{Is_Numeric_Value=0.20}', "");
    Expect(0, 73680, '\P{^Is_Numeric_Value=0.20}', "");
    Error('\p{Is_Nv=- +1/00000005/a/}');
    Error('\P{Is_Nv=- +1/00000005/a/}');
    Expect(1, 73679, '\p{Is_Nv=0000001/000005}', "");
    Expect(0, 73679, '\p{^Is_Nv=0000001/000005}', "");
    Expect(0, 73679, '\P{Is_Nv=0000001/000005}', "");
    Expect(1, 73679, '\P{^Is_Nv=0000001/000005}', "");
    Expect(0, 73680, '\p{Is_Nv=0000001/000005}', "");
    Expect(1, 73680, '\p{^Is_Nv=0000001/000005}', "");
    Expect(1, 73680, '\P{Is_Nv=0000001/000005}', "");
    Expect(0, 73680, '\P{^Is_Nv=0000001/000005}', "");
    Expect(1, 73679, '\p{Is_Nv=60/300}', "");
    Expect(0, 73679, '\p{^Is_Nv=60/300}', "");
    Expect(0, 73679, '\P{Is_Nv=60/300}', "");
    Expect(1, 73679, '\P{^Is_Nv=60/300}', "");
    Expect(0, 73680, '\p{Is_Nv=60/300}', "");
    Expect(1, 73680, '\p{^Is_Nv=60/300}', "");
    Expect(1, 73680, '\P{Is_Nv=60/300}', "");
    Expect(0, 73680, '\P{^Is_Nv=60/300}', "");
    Expect(1, 73679, '\p{Is_Nv=2.0e-01}', "");
    Expect(0, 73679, '\p{^Is_Nv=2.0e-01}', "");
    Expect(0, 73679, '\P{Is_Nv=2.0e-01}', "");
    Expect(1, 73679, '\P{^Is_Nv=2.0e-01}', "");
    Expect(0, 73680, '\p{Is_Nv=2.0e-01}', "");
    Expect(1, 73680, '\p{^Is_Nv=2.0e-01}', "");
    Expect(1, 73680, '\P{Is_Nv=2.0e-01}', "");
    Expect(0, 73680, '\P{^Is_Nv=2.0e-01}', "");
    Expect(1, 73679, '\p{Is_Nv:   0.2}', "");
    Expect(0, 73679, '\p{^Is_Nv:   0.2}', "");
    Expect(0, 73679, '\P{Is_Nv:   0.2}', "");
    Expect(1, 73679, '\P{^Is_Nv:   0.2}', "");
    Expect(0, 73680, '\p{Is_Nv:   0.2}', "");
    Expect(1, 73680, '\p{^Is_Nv:   0.2}', "");
    Expect(1, 73680, '\P{Is_Nv:   0.2}', "");
    Expect(0, 73680, '\P{^Is_Nv:   0.2}', "");
    Expect(1, 73679, '\p{Is_Nv=2.00e-01}', "");
    Expect(0, 73679, '\p{^Is_Nv=2.00e-01}', "");
    Expect(0, 73679, '\P{Is_Nv=2.00e-01}', "");
    Expect(1, 73679, '\P{^Is_Nv=2.00e-01}', "");
    Expect(0, 73680, '\p{Is_Nv=2.00e-01}', "");
    Expect(1, 73680, '\p{^Is_Nv=2.00e-01}', "");
    Expect(1, 73680, '\P{Is_Nv=2.00e-01}', "");
    Expect(0, 73680, '\P{^Is_Nv=2.00e-01}', "");
    Expect(1, 73679, '\p{Is_Nv=0.20}', "");
    Expect(0, 73679, '\p{^Is_Nv=0.20}', "");
    Expect(0, 73679, '\P{Is_Nv=0.20}', "");
    Expect(1, 73679, '\P{^Is_Nv=0.20}', "");
    Expect(0, 73680, '\p{Is_Nv=0.20}', "");
    Expect(1, 73680, '\p{^Is_Nv=0.20}', "");
    Expect(1, 73680, '\P{Is_Nv=0.20}', "");
    Expect(0, 73680, '\P{^Is_Nv=0.20}', "");
    Error('\p{Numeric_Value=:= _000001/00000006}');
    Error('\P{Numeric_Value=:= _000001/00000006}');
    Expect(1, 126269, '\p{Numeric_Value=:\A1/6\z:}', "");;
    Expect(0, 126270, '\p{Numeric_Value=:\A1/6\z:}', "");;
    Expect(1, 126269, '\p{Numeric_Value=1/006}', "");
    Expect(0, 126269, '\p{^Numeric_Value=1/006}', "");
    Expect(0, 126269, '\P{Numeric_Value=1/006}', "");
    Expect(1, 126269, '\P{^Numeric_Value=1/006}', "");
    Expect(0, 126270, '\p{Numeric_Value=1/006}', "");
    Expect(1, 126270, '\p{^Numeric_Value=1/006}', "");
    Expect(1, 126270, '\P{Numeric_Value=1/006}', "");
    Expect(0, 126270, '\P{^Numeric_Value=1/006}', "");
    Expect(1, 126269, '\p{Numeric_Value=60/360}', "");
    Expect(0, 126269, '\p{^Numeric_Value=60/360}', "");
    Expect(0, 126269, '\P{Numeric_Value=60/360}', "");
    Expect(1, 126269, '\P{^Numeric_Value=60/360}', "");
    Expect(0, 126270, '\p{Numeric_Value=60/360}', "");
    Expect(1, 126270, '\p{^Numeric_Value=60/360}', "");
    Expect(1, 126270, '\P{Numeric_Value=60/360}', "");
    Expect(0, 126270, '\P{^Numeric_Value=60/360}', "");
    Error('\p{Numeric_Value=1.7e-01}');
    Error('\P{Numeric_Value=1.7e-01}');
    Expect(1, 126269, '\p{Numeric_Value=1.67e-01}', "");
    Expect(0, 126269, '\p{^Numeric_Value=1.67e-01}', "");
    Expect(0, 126269, '\P{Numeric_Value=1.67e-01}', "");
    Expect(1, 126269, '\P{^Numeric_Value=1.67e-01}', "");
    Expect(0, 126270, '\p{Numeric_Value=1.67e-01}', "");
    Expect(1, 126270, '\p{^Numeric_Value=1.67e-01}', "");
    Expect(1, 126270, '\P{Numeric_Value=1.67e-01}', "");
    Expect(0, 126270, '\P{^Numeric_Value=1.67e-01}', "");
    Error('\p{Numeric_Value=0.17}');
    Error('\P{Numeric_Value=0.17}');
    Expect(1, 126269, '\p{Numeric_Value=1.667e-01}', "");
    Expect(0, 126269, '\p{^Numeric_Value=1.667e-01}', "");
    Expect(0, 126269, '\P{Numeric_Value=1.667e-01}', "");
    Expect(1, 126269, '\P{^Numeric_Value=1.667e-01}', "");
    Expect(0, 126270, '\p{Numeric_Value=1.667e-01}', "");
    Expect(1, 126270, '\p{^Numeric_Value=1.667e-01}', "");
    Expect(1, 126270, '\P{Numeric_Value=1.667e-01}', "");
    Expect(0, 126270, '\P{^Numeric_Value=1.667e-01}', "");
    Expect(1, 126269, '\p{Numeric_Value=0.167}', "");
    Expect(0, 126269, '\p{^Numeric_Value=0.167}', "");
    Expect(0, 126269, '\P{Numeric_Value=0.167}', "");
    Expect(1, 126269, '\P{^Numeric_Value=0.167}', "");
    Expect(0, 126270, '\p{Numeric_Value=0.167}', "");
    Expect(1, 126270, '\p{^Numeric_Value=0.167}', "");
    Expect(1, 126270, '\P{Numeric_Value=0.167}', "");
    Expect(0, 126270, '\P{^Numeric_Value=0.167}', "");
    Expect(1, 126269, '\p{Numeric_Value=1.6667e-01}', "");
    Expect(0, 126269, '\p{^Numeric_Value=1.6667e-01}', "");
    Expect(0, 126269, '\P{Numeric_Value=1.6667e-01}', "");
    Expect(1, 126269, '\P{^Numeric_Value=1.6667e-01}', "");
    Expect(0, 126270, '\p{Numeric_Value=1.6667e-01}', "");
    Expect(1, 126270, '\p{^Numeric_Value=1.6667e-01}', "");
    Expect(1, 126270, '\P{Numeric_Value=1.6667e-01}', "");
    Expect(0, 126270, '\P{^Numeric_Value=1.6667e-01}', "");
    Expect(1, 126269, '\p{Numeric_Value=0.1667}', "");
    Expect(0, 126269, '\p{^Numeric_Value=0.1667}', "");
    Expect(0, 126269, '\P{Numeric_Value=0.1667}', "");
    Expect(1, 126269, '\P{^Numeric_Value=0.1667}', "");
    Expect(0, 126270, '\p{Numeric_Value=0.1667}', "");
    Expect(1, 126270, '\p{^Numeric_Value=0.1667}', "");
    Expect(1, 126270, '\P{Numeric_Value=0.1667}', "");
    Expect(0, 126270, '\P{^Numeric_Value=0.1667}', "");
    Error('\p{Nv=	:=01/0000006}');
    Error('\P{Nv=	:=01/0000006}');
    Expect(1, 126269, '\p{Nv=:\A1/6\z:}', "");;
    Expect(0, 126270, '\p{Nv=:\A1/6\z:}', "");;
    Expect(1, 126269, '\p{Nv=001/00006}', "");
    Expect(0, 126269, '\p{^Nv=001/00006}', "");
    Expect(0, 126269, '\P{Nv=001/00006}', "");
    Expect(1, 126269, '\P{^Nv=001/00006}', "");
    Expect(0, 126270, '\p{Nv=001/00006}', "");
    Expect(1, 126270, '\p{^Nv=001/00006}', "");
    Expect(1, 126270, '\P{Nv=001/00006}', "");
    Expect(0, 126270, '\P{^Nv=001/00006}', "");
    Expect(1, 126269, '\p{Nv: 60/360}', "");
    Expect(0, 126269, '\p{^Nv: 60/360}', "");
    Expect(0, 126269, '\P{Nv: 60/360}', "");
    Expect(1, 126269, '\P{^Nv: 60/360}', "");
    Expect(0, 126270, '\p{Nv: 60/360}', "");
    Expect(1, 126270, '\p{^Nv: 60/360}', "");
    Expect(1, 126270, '\P{Nv: 60/360}', "");
    Expect(0, 126270, '\P{^Nv: 60/360}', "");
    Error('\p{Nv=1.7e-01}');
    Error('\P{Nv=1.7e-01}');
    Expect(1, 126269, '\p{Nv=1.67e-01}', "");
    Expect(0, 126269, '\p{^Nv=1.67e-01}', "");
    Expect(0, 126269, '\P{Nv=1.67e-01}', "");
    Expect(1, 126269, '\P{^Nv=1.67e-01}', "");
    Expect(0, 126270, '\p{Nv=1.67e-01}', "");
    Expect(1, 126270, '\p{^Nv=1.67e-01}', "");
    Expect(1, 126270, '\P{Nv=1.67e-01}', "");
    Expect(0, 126270, '\P{^Nv=1.67e-01}', "");
    Error('\p{Nv=0.17}');
    Error('\P{Nv=0.17}');
    Expect(1, 126269, '\p{Nv=1.667e-01}', "");
    Expect(0, 126269, '\p{^Nv=1.667e-01}', "");
    Expect(0, 126269, '\P{Nv=1.667e-01}', "");
    Expect(1, 126269, '\P{^Nv=1.667e-01}', "");
    Expect(0, 126270, '\p{Nv=1.667e-01}', "");
    Expect(1, 126270, '\p{^Nv=1.667e-01}', "");
    Expect(1, 126270, '\P{Nv=1.667e-01}', "");
    Expect(0, 126270, '\P{^Nv=1.667e-01}', "");
    Expect(1, 126269, '\p{Nv:   0.167}', "");
    Expect(0, 126269, '\p{^Nv:   0.167}', "");
    Expect(0, 126269, '\P{Nv:   0.167}', "");
    Expect(1, 126269, '\P{^Nv:   0.167}', "");
    Expect(0, 126270, '\p{Nv:   0.167}', "");
    Expect(1, 126270, '\p{^Nv:   0.167}', "");
    Expect(1, 126270, '\P{Nv:   0.167}', "");
    Expect(0, 126270, '\P{^Nv:   0.167}', "");
    Expect(1, 126269, '\p{Nv=1.6667e-01}', "");
    Expect(0, 126269, '\p{^Nv=1.6667e-01}', "");
    Expect(0, 126269, '\P{Nv=1.6667e-01}', "");
    Expect(1, 126269, '\P{^Nv=1.6667e-01}', "");
    Expect(0, 126270, '\p{Nv=1.6667e-01}', "");
    Expect(1, 126270, '\p{^Nv=1.6667e-01}', "");
    Expect(1, 126270, '\P{Nv=1.6667e-01}', "");
    Expect(0, 126270, '\P{^Nv=1.6667e-01}', "");
    Expect(1, 126269, '\p{Nv=0.1667}', "");
    Expect(0, 126269, '\p{^Nv=0.1667}', "");
    Expect(0, 126269, '\P{Nv=0.1667}', "");
    Expect(1, 126269, '\P{^Nv=0.1667}', "");
    Expect(0, 126270, '\p{Nv=0.1667}', "");
    Expect(1, 126270, '\p{^Nv=0.1667}', "");
    Expect(1, 126270, '\P{Nv=0.1667}', "");
    Expect(0, 126270, '\P{^Nv=0.1667}', "");
    Error('\p{Is_Numeric_Value= :=0000000001/000006}');
    Error('\P{Is_Numeric_Value= :=0000000001/000006}');
    Expect(1, 126269, '\p{Is_Numeric_Value=+000001/0000000006}', "");
    Expect(0, 126269, '\p{^Is_Numeric_Value=+000001/0000000006}', "");
    Expect(0, 126269, '\P{Is_Numeric_Value=+000001/0000000006}', "");
    Expect(1, 126269, '\P{^Is_Numeric_Value=+000001/0000000006}', "");
    Expect(0, 126270, '\p{Is_Numeric_Value=+000001/0000000006}', "");
    Expect(1, 126270, '\p{^Is_Numeric_Value=+000001/0000000006}', "");
    Expect(1, 126270, '\P{Is_Numeric_Value=+000001/0000000006}', "");
    Expect(0, 126270, '\P{^Is_Numeric_Value=+000001/0000000006}', "");
    Expect(1, 126269, '\p{Is_Numeric_Value=60/360}', "");
    Expect(0, 126269, '\p{^Is_Numeric_Value=60/360}', "");
    Expect(0, 126269, '\P{Is_Numeric_Value=60/360}', "");
    Expect(1, 126269, '\P{^Is_Numeric_Value=60/360}', "");
    Expect(0, 126270, '\p{Is_Numeric_Value=60/360}', "");
    Expect(1, 126270, '\p{^Is_Numeric_Value=60/360}', "");
    Expect(1, 126270, '\P{Is_Numeric_Value=60/360}', "");
    Expect(0, 126270, '\P{^Is_Numeric_Value=60/360}', "");
    Error('\p{Is_Numeric_Value: 1.7e-01}');
    Error('\P{Is_Numeric_Value: 1.7e-01}');
    Expect(1, 126269, '\p{Is_Numeric_Value=1.67e-01}', "");
    Expect(0, 126269, '\p{^Is_Numeric_Value=1.67e-01}', "");
    Expect(0, 126269, '\P{Is_Numeric_Value=1.67e-01}', "");
    Expect(1, 126269, '\P{^Is_Numeric_Value=1.67e-01}', "");
    Expect(0, 126270, '\p{Is_Numeric_Value=1.67e-01}', "");
    Expect(1, 126270, '\p{^Is_Numeric_Value=1.67e-01}', "");
    Expect(1, 126270, '\P{Is_Numeric_Value=1.67e-01}', "");
    Expect(0, 126270, '\P{^Is_Numeric_Value=1.67e-01}', "");
    Error('\p{Is_Numeric_Value:   0.17}');
    Error('\P{Is_Numeric_Value:   0.17}');
    Expect(1, 126269, '\p{Is_Numeric_Value=1.667e-01}', "");
    Expect(0, 126269, '\p{^Is_Numeric_Value=1.667e-01}', "");
    Expect(0, 126269, '\P{Is_Numeric_Value=1.667e-01}', "");
    Expect(1, 126269, '\P{^Is_Numeric_Value=1.667e-01}', "");
    Expect(0, 126270, '\p{Is_Numeric_Value=1.667e-01}', "");
    Expect(1, 126270, '\p{^Is_Numeric_Value=1.667e-01}', "");
    Expect(1, 126270, '\P{Is_Numeric_Value=1.667e-01}', "");
    Expect(0, 126270, '\P{^Is_Numeric_Value=1.667e-01}', "");
    Expect(1, 126269, '\p{Is_Numeric_Value=0.167}', "");
    Expect(0, 126269, '\p{^Is_Numeric_Value=0.167}', "");
    Expect(0, 126269, '\P{Is_Numeric_Value=0.167}', "");
    Expect(1, 126269, '\P{^Is_Numeric_Value=0.167}', "");
    Expect(0, 126270, '\p{Is_Numeric_Value=0.167}', "");
    Expect(1, 126270, '\p{^Is_Numeric_Value=0.167}', "");
    Expect(1, 126270, '\P{Is_Numeric_Value=0.167}', "");
    Expect(0, 126270, '\P{^Is_Numeric_Value=0.167}', "");
    Expect(1, 126269, '\p{Is_Numeric_Value=1.6667e-01}', "");
    Expect(0, 126269, '\p{^Is_Numeric_Value=1.6667e-01}', "");
    Expect(0, 126269, '\P{Is_Numeric_Value=1.6667e-01}', "");
    Expect(1, 126269, '\P{^Is_Numeric_Value=1.6667e-01}', "");
    Expect(0, 126270, '\p{Is_Numeric_Value=1.6667e-01}', "");
    Expect(1, 126270, '\p{^Is_Numeric_Value=1.6667e-01}', "");
    Expect(1, 126270, '\P{Is_Numeric_Value=1.6667e-01}', "");
    Expect(0, 126270, '\P{^Is_Numeric_Value=1.6667e-01}', "");
    Expect(1, 126269, '\p{Is_Numeric_Value=0.1667}', "");
    Expect(0, 126269, '\p{^Is_Numeric_Value=0.1667}', "");
    Expect(0, 126269, '\P{Is_Numeric_Value=0.1667}', "");
    Expect(1, 126269, '\P{^Is_Numeric_Value=0.1667}', "");
    Expect(0, 126270, '\p{Is_Numeric_Value=0.1667}', "");
    Expect(1, 126270, '\p{^Is_Numeric_Value=0.1667}', "");
    Expect(1, 126270, '\P{Is_Numeric_Value=0.1667}', "");
    Expect(0, 126270, '\P{^Is_Numeric_Value=0.1667}', "");
    Error('\p{Is_Nv=_0000001/00006:=}');
    Error('\P{Is_Nv=_0000001/00006:=}');
    Expect(1, 126269, '\p{Is_Nv=+0000001/006}', "");
    Expect(0, 126269, '\p{^Is_Nv=+0000001/006}', "");
    Expect(0, 126269, '\P{Is_Nv=+0000001/006}', "");
    Expect(1, 126269, '\P{^Is_Nv=+0000001/006}', "");
    Expect(0, 126270, '\p{Is_Nv=+0000001/006}', "");
    Expect(1, 126270, '\p{^Is_Nv=+0000001/006}', "");
    Expect(1, 126270, '\P{Is_Nv=+0000001/006}', "");
    Expect(0, 126270, '\P{^Is_Nv=+0000001/006}', "");
    Expect(1, 126269, '\p{Is_Nv=60/360}', "");
    Expect(0, 126269, '\p{^Is_Nv=60/360}', "");
    Expect(0, 126269, '\P{Is_Nv=60/360}', "");
    Expect(1, 126269, '\P{^Is_Nv=60/360}', "");
    Expect(0, 126270, '\p{Is_Nv=60/360}', "");
    Expect(1, 126270, '\p{^Is_Nv=60/360}', "");
    Expect(1, 126270, '\P{Is_Nv=60/360}', "");
    Expect(0, 126270, '\P{^Is_Nv=60/360}', "");
    Error('\p{Is_Nv=1.7e-01}');
    Error('\P{Is_Nv=1.7e-01}');
    Expect(1, 126269, '\p{Is_Nv=1.67e-01}', "");
    Expect(0, 126269, '\p{^Is_Nv=1.67e-01}', "");
    Expect(0, 126269, '\P{Is_Nv=1.67e-01}', "");
    Expect(1, 126269, '\P{^Is_Nv=1.67e-01}', "");
    Expect(0, 126270, '\p{Is_Nv=1.67e-01}', "");
    Expect(1, 126270, '\p{^Is_Nv=1.67e-01}', "");
    Expect(1, 126270, '\P{Is_Nv=1.67e-01}', "");
    Expect(0, 126270, '\P{^Is_Nv=1.67e-01}', "");
    Error('\p{Is_Nv=0.17}');
    Error('\P{Is_Nv=0.17}');
    Expect(1, 126269, '\p{Is_Nv=1.667e-01}', "");
    Expect(0, 126269, '\p{^Is_Nv=1.667e-01}', "");
    Expect(0, 126269, '\P{Is_Nv=1.667e-01}', "");
    Expect(1, 126269, '\P{^Is_Nv=1.667e-01}', "");
    Expect(0, 126270, '\p{Is_Nv=1.667e-01}', "");
    Expect(1, 126270, '\p{^Is_Nv=1.667e-01}', "");
    Expect(1, 126270, '\P{Is_Nv=1.667e-01}', "");
    Expect(0, 126270, '\P{^Is_Nv=1.667e-01}', "");
    Expect(1, 126269, '\p{Is_Nv=0.167}', "");
    Expect(0, 126269, '\p{^Is_Nv=0.167}', "");
    Expect(0, 126269, '\P{Is_Nv=0.167}', "");
    Expect(1, 126269, '\P{^Is_Nv=0.167}', "");
    Expect(0, 126270, '\p{Is_Nv=0.167}', "");
    Expect(1, 126270, '\p{^Is_Nv=0.167}', "");
    Expect(1, 126270, '\P{Is_Nv=0.167}', "");
    Expect(0, 126270, '\P{^Is_Nv=0.167}', "");
    Expect(1, 126269, '\p{Is_Nv=1.6667e-01}', "");
    Expect(0, 126269, '\p{^Is_Nv=1.6667e-01}', "");
    Expect(0, 126269, '\P{Is_Nv=1.6667e-01}', "");
    Expect(1, 126269, '\P{^Is_Nv=1.6667e-01}', "");
    Expect(0, 126270, '\p{Is_Nv=1.6667e-01}', "");
    Expect(1, 126270, '\p{^Is_Nv=1.6667e-01}', "");
    Expect(1, 126270, '\P{Is_Nv=1.6667e-01}', "");
    Expect(0, 126270, '\P{^Is_Nv=1.6667e-01}', "");
    Expect(1, 126269, '\p{Is_Nv=0.1667}', "");
    Expect(0, 126269, '\p{^Is_Nv=0.1667}', "");
    Expect(0, 126269, '\P{Is_Nv=0.1667}', "");
    Expect(1, 126269, '\P{^Is_Nv=0.1667}', "");
    Expect(0, 126270, '\p{Is_Nv=0.1667}', "");
    Expect(1, 126270, '\p{^Is_Nv=0.1667}', "");
    Expect(1, 126270, '\P{Is_Nv=0.1667}', "");
    Expect(0, 126270, '\P{^Is_Nv=0.1667}', "");
    Error('\p{Numeric_Value=	+0000000001/0064:=}');
    Error('\P{Numeric_Value=	+0000000001/0064:=}');
    Expect(1, 73667, '\p{Numeric_Value=:\A1/64\z:}', "");;
    Expect(0, 73668, '\p{Numeric_Value=:\A1/64\z:}', "");;
    Expect(1, 73667, '\p{Numeric_Value=+0000000001/0000000064}', "");
    Expect(0, 73667, '\p{^Numeric_Value=+0000000001/0000000064}', "");
    Expect(0, 73667, '\P{Numeric_Value=+0000000001/0000000064}', "");
    Expect(1, 73667, '\P{^Numeric_Value=+0000000001/0000000064}', "");
    Expect(0, 73668, '\p{Numeric_Value=+0000000001/0000000064}', "");
    Expect(1, 73668, '\p{^Numeric_Value=+0000000001/0000000064}', "");
    Expect(1, 73668, '\P{Numeric_Value=+0000000001/0000000064}', "");
    Expect(0, 73668, '\P{^Numeric_Value=+0000000001/0000000064}', "");
    Expect(1, 73667, '\p{Numeric_Value=60/3840}', "");
    Expect(0, 73667, '\p{^Numeric_Value=60/3840}', "");
    Expect(0, 73667, '\P{Numeric_Value=60/3840}', "");
    Expect(1, 73667, '\P{^Numeric_Value=60/3840}', "");
    Expect(0, 73668, '\p{Numeric_Value=60/3840}', "");
    Expect(1, 73668, '\p{^Numeric_Value=60/3840}', "");
    Expect(1, 73668, '\P{Numeric_Value=60/3840}', "");
    Expect(0, 73668, '\P{^Numeric_Value=60/3840}', "");
    Error('\p{Numeric_Value=1.6e-02}');
    Error('\P{Numeric_Value=1.6e-02}');
    Expect(1, 73667, '\p{Numeric_Value=1.56e-02}', "");
    Expect(0, 73667, '\p{^Numeric_Value=1.56e-02}', "");
    Expect(0, 73667, '\P{Numeric_Value=1.56e-02}', "");
    Expect(1, 73667, '\P{^Numeric_Value=1.56e-02}', "");
    Expect(0, 73668, '\p{Numeric_Value=1.56e-02}', "");
    Expect(1, 73668, '\p{^Numeric_Value=1.56e-02}', "");
    Expect(1, 73668, '\P{Numeric_Value=1.56e-02}', "");
    Expect(0, 73668, '\P{^Numeric_Value=1.56e-02}', "");
    Error('\p{Numeric_Value=0.02}');
    Error('\P{Numeric_Value=0.02}');
    Expect(1, 73667, '\p{Numeric_Value=1.562e-02}', "");
    Expect(0, 73667, '\p{^Numeric_Value=1.562e-02}', "");
    Expect(0, 73667, '\P{Numeric_Value=1.562e-02}', "");
    Expect(1, 73667, '\P{^Numeric_Value=1.562e-02}', "");
    Expect(0, 73668, '\p{Numeric_Value=1.562e-02}', "");
    Expect(1, 73668, '\p{^Numeric_Value=1.562e-02}', "");
    Expect(1, 73668, '\P{Numeric_Value=1.562e-02}', "");
    Expect(0, 73668, '\P{^Numeric_Value=1.562e-02}', "");
    Error('\p{Numeric_Value=0.016}');
    Error('\P{Numeric_Value=0.016}');
    Expect(1, 73667, '\p{Numeric_Value=1.5625e-02}', "");
    Expect(0, 73667, '\p{^Numeric_Value=1.5625e-02}', "");
    Expect(0, 73667, '\P{Numeric_Value=1.5625e-02}', "");
    Expect(1, 73667, '\P{^Numeric_Value=1.5625e-02}', "");
    Expect(0, 73668, '\p{Numeric_Value=1.5625e-02}', "");
    Expect(1, 73668, '\p{^Numeric_Value=1.5625e-02}', "");
    Expect(1, 73668, '\P{Numeric_Value=1.5625e-02}', "");
    Expect(0, 73668, '\P{^Numeric_Value=1.5625e-02}', "");
    Expect(1, 73667, '\p{Numeric_Value=0.0156}', "");
    Expect(0, 73667, '\p{^Numeric_Value=0.0156}', "");
    Expect(0, 73667, '\P{Numeric_Value=0.0156}', "");
    Expect(1, 73667, '\P{^Numeric_Value=0.0156}', "");
    Expect(0, 73668, '\p{Numeric_Value=0.0156}', "");
    Expect(1, 73668, '\p{^Numeric_Value=0.0156}', "");
    Expect(1, 73668, '\P{Numeric_Value=0.0156}', "");
    Expect(0, 73668, '\P{^Numeric_Value=0.0156}', "");
    Expect(1, 73667, '\p{Numeric_Value=1.56250e-02}', "");
    Expect(0, 73667, '\p{^Numeric_Value=1.56250e-02}', "");
    Expect(0, 73667, '\P{Numeric_Value=1.56250e-02}', "");
    Expect(1, 73667, '\P{^Numeric_Value=1.56250e-02}', "");
    Expect(0, 73668, '\p{Numeric_Value=1.56250e-02}', "");
    Expect(1, 73668, '\p{^Numeric_Value=1.56250e-02}', "");
    Expect(1, 73668, '\P{Numeric_Value=1.56250e-02}', "");
    Expect(0, 73668, '\P{^Numeric_Value=1.56250e-02}', "");
    Expect(1, 73667, '\p{Numeric_Value:   0.01562}', "");
    Expect(0, 73667, '\p{^Numeric_Value:   0.01562}', "");
    Expect(0, 73667, '\P{Numeric_Value:   0.01562}', "");
    Expect(1, 73667, '\P{^Numeric_Value:   0.01562}', "");
    Expect(0, 73668, '\p{Numeric_Value:   0.01562}', "");
    Expect(1, 73668, '\p{^Numeric_Value:   0.01562}', "");
    Expect(1, 73668, '\P{Numeric_Value:   0.01562}', "");
    Expect(0, 73668, '\P{^Numeric_Value:   0.01562}', "");
    Error('\p{Nv=:=+0000000001/00000064}');
    Error('\P{Nv=:=+0000000001/00000064}');
    Expect(1, 73667, '\p{Nv=:\A1/64\z:}', "");;
    Expect(0, 73668, '\p{Nv=:\A1/64\z:}', "");;
    Expect(1, 73667, '\p{Nv=0000000001/00064}', "");
    Expect(0, 73667, '\p{^Nv=0000000001/00064}', "");
    Expect(0, 73667, '\P{Nv=0000000001/00064}', "");
    Expect(1, 73667, '\P{^Nv=0000000001/00064}', "");
    Expect(0, 73668, '\p{Nv=0000000001/00064}', "");
    Expect(1, 73668, '\p{^Nv=0000000001/00064}', "");
    Expect(1, 73668, '\P{Nv=0000000001/00064}', "");
    Expect(0, 73668, '\P{^Nv=0000000001/00064}', "");
    Expect(1, 73667, '\p{Nv=60/3840}', "");
    Expect(0, 73667, '\p{^Nv=60/3840}', "");
    Expect(0, 73667, '\P{Nv=60/3840}', "");
    Expect(1, 73667, '\P{^Nv=60/3840}', "");
    Expect(0, 73668, '\p{Nv=60/3840}', "");
    Expect(1, 73668, '\p{^Nv=60/3840}', "");
    Expect(1, 73668, '\P{Nv=60/3840}', "");
    Expect(0, 73668, '\P{^Nv=60/3840}', "");
    Error('\p{Nv=1.6e-02}');
    Error('\P{Nv=1.6e-02}');
    Expect(1, 73667, '\p{Nv=1.56e-02}', "");
    Expect(0, 73667, '\p{^Nv=1.56e-02}', "");
    Expect(0, 73667, '\P{Nv=1.56e-02}', "");
    Expect(1, 73667, '\P{^Nv=1.56e-02}', "");
    Expect(0, 73668, '\p{Nv=1.56e-02}', "");
    Expect(1, 73668, '\p{^Nv=1.56e-02}', "");
    Expect(1, 73668, '\P{Nv=1.56e-02}', "");
    Expect(0, 73668, '\P{^Nv=1.56e-02}', "");
    Error('\p{Nv=0.02}');
    Error('\P{Nv=0.02}');
    Expect(1, 73667, '\p{Nv=1.562e-02}', "");
    Expect(0, 73667, '\p{^Nv=1.562e-02}', "");
    Expect(0, 73667, '\P{Nv=1.562e-02}', "");
    Expect(1, 73667, '\P{^Nv=1.562e-02}', "");
    Expect(0, 73668, '\p{Nv=1.562e-02}', "");
    Expect(1, 73668, '\p{^Nv=1.562e-02}', "");
    Expect(1, 73668, '\P{Nv=1.562e-02}', "");
    Expect(0, 73668, '\P{^Nv=1.562e-02}', "");
    Error('\p{Nv=0.016}');
    Error('\P{Nv=0.016}');
    Expect(1, 73667, '\p{Nv=1.5625e-02}', "");
    Expect(0, 73667, '\p{^Nv=1.5625e-02}', "");
    Expect(0, 73667, '\P{Nv=1.5625e-02}', "");
    Expect(1, 73667, '\P{^Nv=1.5625e-02}', "");
    Expect(0, 73668, '\p{Nv=1.5625e-02}', "");
    Expect(1, 73668, '\p{^Nv=1.5625e-02}', "");
    Expect(1, 73668, '\P{Nv=1.5625e-02}', "");
    Expect(0, 73668, '\P{^Nv=1.5625e-02}', "");
    Expect(1, 73667, '\p{Nv:0.0156}', "");
    Expect(0, 73667, '\p{^Nv:0.0156}', "");
    Expect(0, 73667, '\P{Nv:0.0156}', "");
    Expect(1, 73667, '\P{^Nv:0.0156}', "");
    Expect(0, 73668, '\p{Nv:0.0156}', "");
    Expect(1, 73668, '\p{^Nv:0.0156}', "");
    Expect(1, 73668, '\P{Nv:0.0156}', "");
    Expect(0, 73668, '\P{^Nv:0.0156}', "");
    Expect(1, 73667, '\p{Nv=1.56250e-02}', "");
    Expect(0, 73667, '\p{^Nv=1.56250e-02}', "");
    Expect(0, 73667, '\P{Nv=1.56250e-02}', "");
    Expect(1, 73667, '\P{^Nv=1.56250e-02}', "");
    Expect(0, 73668, '\p{Nv=1.56250e-02}', "");
    Expect(1, 73668, '\p{^Nv=1.56250e-02}', "");
    Expect(1, 73668, '\P{Nv=1.56250e-02}', "");
    Expect(0, 73668, '\P{^Nv=1.56250e-02}', "");
    Expect(1, 73667, '\p{Nv=0.01562}', "");
    Expect(0, 73667, '\p{^Nv=0.01562}', "");
    Expect(0, 73667, '\P{Nv=0.01562}', "");
    Expect(1, 73667, '\P{^Nv=0.01562}', "");
    Expect(0, 73668, '\p{Nv=0.01562}', "");
    Expect(1, 73668, '\p{^Nv=0.01562}', "");
    Expect(1, 73668, '\P{Nv=0.01562}', "");
    Expect(0, 73668, '\P{^Nv=0.01562}', "");
    Error('\p{Is_Numeric_Value=:=	00001/0064}');
    Error('\P{Is_Numeric_Value=:=	00001/0064}');
    Expect(1, 73667, '\p{Is_Numeric_Value=+0001/00064}', "");
    Expect(0, 73667, '\p{^Is_Numeric_Value=+0001/00064}', "");
    Expect(0, 73667, '\P{Is_Numeric_Value=+0001/00064}', "");
    Expect(1, 73667, '\P{^Is_Numeric_Value=+0001/00064}', "");
    Expect(0, 73668, '\p{Is_Numeric_Value=+0001/00064}', "");
    Expect(1, 73668, '\p{^Is_Numeric_Value=+0001/00064}', "");
    Expect(1, 73668, '\P{Is_Numeric_Value=+0001/00064}', "");
    Expect(0, 73668, '\P{^Is_Numeric_Value=+0001/00064}', "");
    Expect(1, 73667, '\p{Is_Numeric_Value=60/3840}', "");
    Expect(0, 73667, '\p{^Is_Numeric_Value=60/3840}', "");
    Expect(0, 73667, '\P{Is_Numeric_Value=60/3840}', "");
    Expect(1, 73667, '\P{^Is_Numeric_Value=60/3840}', "");
    Expect(0, 73668, '\p{Is_Numeric_Value=60/3840}', "");
    Expect(1, 73668, '\p{^Is_Numeric_Value=60/3840}', "");
    Expect(1, 73668, '\P{Is_Numeric_Value=60/3840}', "");
    Expect(0, 73668, '\P{^Is_Numeric_Value=60/3840}', "");
    Error('\p{Is_Numeric_Value=1.6e-02}');
    Error('\P{Is_Numeric_Value=1.6e-02}');
    Expect(1, 73667, '\p{Is_Numeric_Value=1.56e-02}', "");
    Expect(0, 73667, '\p{^Is_Numeric_Value=1.56e-02}', "");
    Expect(0, 73667, '\P{Is_Numeric_Value=1.56e-02}', "");
    Expect(1, 73667, '\P{^Is_Numeric_Value=1.56e-02}', "");
    Expect(0, 73668, '\p{Is_Numeric_Value=1.56e-02}', "");
    Expect(1, 73668, '\p{^Is_Numeric_Value=1.56e-02}', "");
    Expect(1, 73668, '\P{Is_Numeric_Value=1.56e-02}', "");
    Expect(0, 73668, '\P{^Is_Numeric_Value=1.56e-02}', "");
    Error('\p{Is_Numeric_Value=0.02}');
    Error('\P{Is_Numeric_Value=0.02}');
    Expect(1, 73667, '\p{Is_Numeric_Value=1.562e-02}', "");
    Expect(0, 73667, '\p{^Is_Numeric_Value=1.562e-02}', "");
    Expect(0, 73667, '\P{Is_Numeric_Value=1.562e-02}', "");
    Expect(1, 73667, '\P{^Is_Numeric_Value=1.562e-02}', "");
    Expect(0, 73668, '\p{Is_Numeric_Value=1.562e-02}', "");
    Expect(1, 73668, '\p{^Is_Numeric_Value=1.562e-02}', "");
    Expect(1, 73668, '\P{Is_Numeric_Value=1.562e-02}', "");
    Expect(0, 73668, '\P{^Is_Numeric_Value=1.562e-02}', "");
    Error('\p{Is_Numeric_Value: 0.016}');
    Error('\P{Is_Numeric_Value: 0.016}');
    Expect(1, 73667, '\p{Is_Numeric_Value=1.5625e-02}', "");
    Expect(0, 73667, '\p{^Is_Numeric_Value=1.5625e-02}', "");
    Expect(0, 73667, '\P{Is_Numeric_Value=1.5625e-02}', "");
    Expect(1, 73667, '\P{^Is_Numeric_Value=1.5625e-02}', "");
    Expect(0, 73668, '\p{Is_Numeric_Value=1.5625e-02}', "");
    Expect(1, 73668, '\p{^Is_Numeric_Value=1.5625e-02}', "");
    Expect(1, 73668, '\P{Is_Numeric_Value=1.5625e-02}', "");
    Expect(0, 73668, '\P{^Is_Numeric_Value=1.5625e-02}', "");
    Expect(1, 73667, '\p{Is_Numeric_Value=0.0156}', "");
    Expect(0, 73667, '\p{^Is_Numeric_Value=0.0156}', "");
    Expect(0, 73667, '\P{Is_Numeric_Value=0.0156}', "");
    Expect(1, 73667, '\P{^Is_Numeric_Value=0.0156}', "");
    Expect(0, 73668, '\p{Is_Numeric_Value=0.0156}', "");
    Expect(1, 73668, '\p{^Is_Numeric_Value=0.0156}', "");
    Expect(1, 73668, '\P{Is_Numeric_Value=0.0156}', "");
    Expect(0, 73668, '\P{^Is_Numeric_Value=0.0156}', "");
    Expect(1, 73667, '\p{Is_Numeric_Value=1.56250e-02}', "");
    Expect(0, 73667, '\p{^Is_Numeric_Value=1.56250e-02}', "");
    Expect(0, 73667, '\P{Is_Numeric_Value=1.56250e-02}', "");
    Expect(1, 73667, '\P{^Is_Numeric_Value=1.56250e-02}', "");
    Expect(0, 73668, '\p{Is_Numeric_Value=1.56250e-02}', "");
    Expect(1, 73668, '\p{^Is_Numeric_Value=1.56250e-02}', "");
    Expect(1, 73668, '\P{Is_Numeric_Value=1.56250e-02}', "");
    Expect(0, 73668, '\P{^Is_Numeric_Value=1.56250e-02}', "");
    Expect(1, 73667, '\p{Is_Numeric_Value:	0.01562}', "");
    Expect(0, 73667, '\p{^Is_Numeric_Value:	0.01562}', "");
    Expect(0, 73667, '\P{Is_Numeric_Value:	0.01562}', "");
    Expect(1, 73667, '\P{^Is_Numeric_Value:	0.01562}', "");
    Expect(0, 73668, '\p{Is_Numeric_Value:	0.01562}', "");
    Expect(1, 73668, '\p{^Is_Numeric_Value:	0.01562}', "");
    Expect(1, 73668, '\P{Is_Numeric_Value:	0.01562}', "");
    Expect(0, 73668, '\P{^Is_Numeric_Value:	0.01562}', "");
    Error('\p{Is_Nv: 001/000064/a/}');
    Error('\P{Is_Nv: 001/000064/a/}');
    Expect(1, 73667, '\p{Is_Nv=1/64}', "");
    Expect(0, 73667, '\p{^Is_Nv=1/64}', "");
    Expect(0, 73667, '\P{Is_Nv=1/64}', "");
    Expect(1, 73667, '\P{^Is_Nv=1/64}', "");
    Expect(0, 73668, '\p{Is_Nv=1/64}', "");
    Expect(1, 73668, '\p{^Is_Nv=1/64}', "");
    Expect(1, 73668, '\P{Is_Nv=1/64}', "");
    Expect(0, 73668, '\P{^Is_Nv=1/64}', "");
    Expect(1, 73667, '\p{Is_Nv=60/3840}', "");
    Expect(0, 73667, '\p{^Is_Nv=60/3840}', "");
    Expect(0, 73667, '\P{Is_Nv=60/3840}', "");
    Expect(1, 73667, '\P{^Is_Nv=60/3840}', "");
    Expect(0, 73668, '\p{Is_Nv=60/3840}', "");
    Expect(1, 73668, '\p{^Is_Nv=60/3840}', "");
    Expect(1, 73668, '\P{Is_Nv=60/3840}', "");
    Expect(0, 73668, '\P{^Is_Nv=60/3840}', "");
    Error('\p{Is_Nv:	1.6e-02}');
    Error('\P{Is_Nv:	1.6e-02}');
    Expect(1, 73667, '\p{Is_Nv=1.56e-02}', "");
    Expect(0, 73667, '\p{^Is_Nv=1.56e-02}', "");
    Expect(0, 73667, '\P{Is_Nv=1.56e-02}', "");
    Expect(1, 73667, '\P{^Is_Nv=1.56e-02}', "");
    Expect(0, 73668, '\p{Is_Nv=1.56e-02}', "");
    Expect(1, 73668, '\p{^Is_Nv=1.56e-02}', "");
    Expect(1, 73668, '\P{Is_Nv=1.56e-02}', "");
    Expect(0, 73668, '\P{^Is_Nv=1.56e-02}', "");
    Error('\p{Is_Nv=0.02}');
    Error('\P{Is_Nv=0.02}');
    Expect(1, 73667, '\p{Is_Nv=1.562e-02}', "");
    Expect(0, 73667, '\p{^Is_Nv=1.562e-02}', "");
    Expect(0, 73667, '\P{Is_Nv=1.562e-02}', "");
    Expect(1, 73667, '\P{^Is_Nv=1.562e-02}', "");
    Expect(0, 73668, '\p{Is_Nv=1.562e-02}', "");
    Expect(1, 73668, '\p{^Is_Nv=1.562e-02}', "");
    Expect(1, 73668, '\P{Is_Nv=1.562e-02}', "");
    Expect(0, 73668, '\P{^Is_Nv=1.562e-02}', "");
    Error('\p{Is_Nv=0.016}');
    Error('\P{Is_Nv=0.016}');
    Expect(1, 73667, '\p{Is_Nv=1.5625e-02}', "");
    Expect(0, 73667, '\p{^Is_Nv=1.5625e-02}', "");
    Expect(0, 73667, '\P{Is_Nv=1.5625e-02}', "");
    Expect(1, 73667, '\P{^Is_Nv=1.5625e-02}', "");
    Expect(0, 73668, '\p{Is_Nv=1.5625e-02}', "");
    Expect(1, 73668, '\p{^Is_Nv=1.5625e-02}', "");
    Expect(1, 73668, '\P{Is_Nv=1.5625e-02}', "");
    Expect(0, 73668, '\P{^Is_Nv=1.5625e-02}', "");
    Expect(1, 73667, '\p{Is_Nv: 0.0156}', "");
    Expect(0, 73667, '\p{^Is_Nv: 0.0156}', "");
    Expect(0, 73667, '\P{Is_Nv: 0.0156}', "");
    Expect(1, 73667, '\P{^Is_Nv: 0.0156}', "");
    Expect(0, 73668, '\p{Is_Nv: 0.0156}', "");
    Expect(1, 73668, '\p{^Is_Nv: 0.0156}', "");
    Expect(1, 73668, '\P{Is_Nv: 0.0156}', "");
    Expect(0, 73668, '\P{^Is_Nv: 0.0156}', "");
    Expect(1, 73667, '\p{Is_Nv: 1.56250e-02}', "");
    Expect(0, 73667, '\p{^Is_Nv: 1.56250e-02}', "");
    Expect(0, 73667, '\P{Is_Nv: 1.56250e-02}', "");
    Expect(1, 73667, '\P{^Is_Nv: 1.56250e-02}', "");
    Expect(0, 73668, '\p{Is_Nv: 1.56250e-02}', "");
    Expect(1, 73668, '\p{^Is_Nv: 1.56250e-02}', "");
    Expect(1, 73668, '\P{Is_Nv: 1.56250e-02}', "");
    Expect(0, 73668, '\P{^Is_Nv: 1.56250e-02}', "");
    Expect(1, 73667, '\p{Is_Nv=0.01562}', "");
    Expect(0, 73667, '\p{^Is_Nv=0.01562}', "");
    Expect(0, 73667, '\P{Is_Nv=0.01562}', "");
    Expect(1, 73667, '\P{^Is_Nv=0.01562}', "");
    Expect(0, 73668, '\p{Is_Nv=0.01562}', "");
    Expect(1, 73668, '\p{^Is_Nv=0.01562}', "");
    Expect(1, 73668, '\P{Is_Nv=0.01562}', "");
    Expect(0, 73668, '\P{^Is_Nv=0.01562}', "");
    Error('\p{Numeric_Value=	/a/00001/007}');
    Error('\P{Numeric_Value=	/a/00001/007}');
    Expect(1, 8528, '\p{Numeric_Value=:\A1/7\z:}', "");;
    Expect(0, 8529, '\p{Numeric_Value=:\A1/7\z:}', "");;
    Expect(1, 8528, '\p{Numeric_Value: +0001/000007}', "");
    Expect(0, 8528, '\p{^Numeric_Value: +0001/000007}', "");
    Expect(0, 8528, '\P{Numeric_Value: +0001/000007}', "");
    Expect(1, 8528, '\P{^Numeric_Value: +0001/000007}', "");
    Expect(0, 8529, '\p{Numeric_Value: +0001/000007}', "");
    Expect(1, 8529, '\p{^Numeric_Value: +0001/000007}', "");
    Expect(1, 8529, '\P{Numeric_Value: +0001/000007}', "");
    Expect(0, 8529, '\P{^Numeric_Value: +0001/000007}', "");
    Expect(1, 8528, '\p{Numeric_Value=60/420}', "");
    Expect(0, 8528, '\p{^Numeric_Value=60/420}', "");
    Expect(0, 8528, '\P{Numeric_Value=60/420}', "");
    Expect(1, 8528, '\P{^Numeric_Value=60/420}', "");
    Expect(0, 8529, '\p{Numeric_Value=60/420}', "");
    Expect(1, 8529, '\p{^Numeric_Value=60/420}', "");
    Expect(1, 8529, '\P{Numeric_Value=60/420}', "");
    Expect(0, 8529, '\P{^Numeric_Value=60/420}', "");
    Error('\p{Numeric_Value=1.4e-01}');
    Error('\P{Numeric_Value=1.4e-01}');
    Expect(1, 8528, '\p{Numeric_Value=1.43e-01}', "");
    Expect(0, 8528, '\p{^Numeric_Value=1.43e-01}', "");
    Expect(0, 8528, '\P{Numeric_Value=1.43e-01}', "");
    Expect(1, 8528, '\P{^Numeric_Value=1.43e-01}', "");
    Expect(0, 8529, '\p{Numeric_Value=1.43e-01}', "");
    Expect(1, 8529, '\p{^Numeric_Value=1.43e-01}', "");
    Expect(1, 8529, '\P{Numeric_Value=1.43e-01}', "");
    Expect(0, 8529, '\P{^Numeric_Value=1.43e-01}', "");
    Error('\p{Numeric_Value:0.14}');
    Error('\P{Numeric_Value:0.14}');
    Expect(1, 8528, '\p{Numeric_Value:   1.429e-01}', "");
    Expect(0, 8528, '\p{^Numeric_Value:   1.429e-01}', "");
    Expect(0, 8528, '\P{Numeric_Value:   1.429e-01}', "");
    Expect(1, 8528, '\P{^Numeric_Value:   1.429e-01}', "");
    Expect(0, 8529, '\p{Numeric_Value:   1.429e-01}', "");
    Expect(1, 8529, '\p{^Numeric_Value:   1.429e-01}', "");
    Expect(1, 8529, '\P{Numeric_Value:   1.429e-01}', "");
    Expect(0, 8529, '\P{^Numeric_Value:   1.429e-01}', "");
    Expect(1, 8528, '\p{Numeric_Value=0.143}', "");
    Expect(0, 8528, '\p{^Numeric_Value=0.143}', "");
    Expect(0, 8528, '\P{Numeric_Value=0.143}', "");
    Expect(1, 8528, '\P{^Numeric_Value=0.143}', "");
    Expect(0, 8529, '\p{Numeric_Value=0.143}', "");
    Expect(1, 8529, '\p{^Numeric_Value=0.143}', "");
    Expect(1, 8529, '\P{Numeric_Value=0.143}', "");
    Expect(0, 8529, '\P{^Numeric_Value=0.143}', "");
    Expect(1, 8528, '\p{Numeric_Value:	1.4286e-01}', "");
    Expect(0, 8528, '\p{^Numeric_Value:	1.4286e-01}', "");
    Expect(0, 8528, '\P{Numeric_Value:	1.4286e-01}', "");
    Expect(1, 8528, '\P{^Numeric_Value:	1.4286e-01}', "");
    Expect(0, 8529, '\p{Numeric_Value:	1.4286e-01}', "");
    Expect(1, 8529, '\p{^Numeric_Value:	1.4286e-01}', "");
    Expect(1, 8529, '\P{Numeric_Value:	1.4286e-01}', "");
    Expect(0, 8529, '\P{^Numeric_Value:	1.4286e-01}', "");
    Expect(1, 8528, '\p{Numeric_Value=0.1429}', "");
    Expect(0, 8528, '\p{^Numeric_Value=0.1429}', "");
    Expect(0, 8528, '\P{Numeric_Value=0.1429}', "");
    Expect(1, 8528, '\P{^Numeric_Value=0.1429}', "");
    Expect(0, 8529, '\p{Numeric_Value=0.1429}', "");
    Expect(1, 8529, '\p{^Numeric_Value=0.1429}', "");
    Expect(1, 8529, '\P{Numeric_Value=0.1429}', "");
    Expect(0, 8529, '\P{^Numeric_Value=0.1429}', "");
    Error('\p{Nv=	-00000001/0000000007:=}');
    Error('\P{Nv=	-00000001/0000000007:=}');
    Expect(1, 8528, '\p{Nv=:\A1/7\z:}', "");;
    Expect(0, 8529, '\p{Nv=:\A1/7\z:}', "");;
    Expect(1, 8528, '\p{Nv=+000000001/00007}', "");
    Expect(0, 8528, '\p{^Nv=+000000001/00007}', "");
    Expect(0, 8528, '\P{Nv=+000000001/00007}', "");
    Expect(1, 8528, '\P{^Nv=+000000001/00007}', "");
    Expect(0, 8529, '\p{Nv=+000000001/00007}', "");
    Expect(1, 8529, '\p{^Nv=+000000001/00007}', "");
    Expect(1, 8529, '\P{Nv=+000000001/00007}', "");
    Expect(0, 8529, '\P{^Nv=+000000001/00007}', "");
    Expect(1, 8528, '\p{Nv=60/420}', "");
    Expect(0, 8528, '\p{^Nv=60/420}', "");
    Expect(0, 8528, '\P{Nv=60/420}', "");
    Expect(1, 8528, '\P{^Nv=60/420}', "");
    Expect(0, 8529, '\p{Nv=60/420}', "");
    Expect(1, 8529, '\p{^Nv=60/420}', "");
    Expect(1, 8529, '\P{Nv=60/420}', "");
    Expect(0, 8529, '\P{^Nv=60/420}', "");
    Error('\p{Nv=1.4e-01}');
    Error('\P{Nv=1.4e-01}');
    Expect(1, 8528, '\p{Nv=1.43e-01}', "");
    Expect(0, 8528, '\p{^Nv=1.43e-01}', "");
    Expect(0, 8528, '\P{Nv=1.43e-01}', "");
    Expect(1, 8528, '\P{^Nv=1.43e-01}', "");
    Expect(0, 8529, '\p{Nv=1.43e-01}', "");
    Expect(1, 8529, '\p{^Nv=1.43e-01}', "");
    Expect(1, 8529, '\P{Nv=1.43e-01}', "");
    Expect(0, 8529, '\P{^Nv=1.43e-01}', "");
    Error('\p{Nv:0.14}');
    Error('\P{Nv:0.14}');
    Expect(1, 8528, '\p{Nv=1.429e-01}', "");
    Expect(0, 8528, '\p{^Nv=1.429e-01}', "");
    Expect(0, 8528, '\P{Nv=1.429e-01}', "");
    Expect(1, 8528, '\P{^Nv=1.429e-01}', "");
    Expect(0, 8529, '\p{Nv=1.429e-01}', "");
    Expect(1, 8529, '\p{^Nv=1.429e-01}', "");
    Expect(1, 8529, '\P{Nv=1.429e-01}', "");
    Expect(0, 8529, '\P{^Nv=1.429e-01}', "");
    Expect(1, 8528, '\p{Nv=0.143}', "");
    Expect(0, 8528, '\p{^Nv=0.143}', "");
    Expect(0, 8528, '\P{Nv=0.143}', "");
    Expect(1, 8528, '\P{^Nv=0.143}', "");
    Expect(0, 8529, '\p{Nv=0.143}', "");
    Expect(1, 8529, '\p{^Nv=0.143}', "");
    Expect(1, 8529, '\P{Nv=0.143}', "");
    Expect(0, 8529, '\P{^Nv=0.143}', "");
    Expect(1, 8528, '\p{Nv=1.4286e-01}', "");
    Expect(0, 8528, '\p{^Nv=1.4286e-01}', "");
    Expect(0, 8528, '\P{Nv=1.4286e-01}', "");
    Expect(1, 8528, '\P{^Nv=1.4286e-01}', "");
    Expect(0, 8529, '\p{Nv=1.4286e-01}', "");
    Expect(1, 8529, '\p{^Nv=1.4286e-01}', "");
    Expect(1, 8529, '\P{Nv=1.4286e-01}', "");
    Expect(0, 8529, '\P{^Nv=1.4286e-01}', "");
    Expect(1, 8528, '\p{Nv=0.1429}', "");
    Expect(0, 8528, '\p{^Nv=0.1429}', "");
    Expect(0, 8528, '\P{Nv=0.1429}', "");
    Expect(1, 8528, '\P{^Nv=0.1429}', "");
    Expect(0, 8529, '\p{Nv=0.1429}', "");
    Expect(1, 8529, '\p{^Nv=0.1429}', "");
    Expect(1, 8529, '\P{Nv=0.1429}', "");
    Expect(0, 8529, '\P{^Nv=0.1429}', "");
    Error('\p{Is_Numeric_Value: 	+001/007/a/}');
    Error('\P{Is_Numeric_Value: 	+001/007/a/}');
    Expect(1, 8528, '\p{Is_Numeric_Value=0000000001/7}', "");
    Expect(0, 8528, '\p{^Is_Numeric_Value=0000000001/7}', "");
    Expect(0, 8528, '\P{Is_Numeric_Value=0000000001/7}', "");
    Expect(1, 8528, '\P{^Is_Numeric_Value=0000000001/7}', "");
    Expect(0, 8529, '\p{Is_Numeric_Value=0000000001/7}', "");
    Expect(1, 8529, '\p{^Is_Numeric_Value=0000000001/7}', "");
    Expect(1, 8529, '\P{Is_Numeric_Value=0000000001/7}', "");
    Expect(0, 8529, '\P{^Is_Numeric_Value=0000000001/7}', "");
    Expect(1, 8528, '\p{Is_Numeric_Value=60/420}', "");
    Expect(0, 8528, '\p{^Is_Numeric_Value=60/420}', "");
    Expect(0, 8528, '\P{Is_Numeric_Value=60/420}', "");
    Expect(1, 8528, '\P{^Is_Numeric_Value=60/420}', "");
    Expect(0, 8529, '\p{Is_Numeric_Value=60/420}', "");
    Expect(1, 8529, '\p{^Is_Numeric_Value=60/420}', "");
    Expect(1, 8529, '\P{Is_Numeric_Value=60/420}', "");
    Expect(0, 8529, '\P{^Is_Numeric_Value=60/420}', "");
    Error('\p{Is_Numeric_Value=1.4e-01}');
    Error('\P{Is_Numeric_Value=1.4e-01}');
    Expect(1, 8528, '\p{Is_Numeric_Value=1.43e-01}', "");
    Expect(0, 8528, '\p{^Is_Numeric_Value=1.43e-01}', "");
    Expect(0, 8528, '\P{Is_Numeric_Value=1.43e-01}', "");
    Expect(1, 8528, '\P{^Is_Numeric_Value=1.43e-01}', "");
    Expect(0, 8529, '\p{Is_Numeric_Value=1.43e-01}', "");
    Expect(1, 8529, '\p{^Is_Numeric_Value=1.43e-01}', "");
    Expect(1, 8529, '\P{Is_Numeric_Value=1.43e-01}', "");
    Expect(0, 8529, '\P{^Is_Numeric_Value=1.43e-01}', "");
    Error('\p{Is_Numeric_Value=0.14}');
    Error('\P{Is_Numeric_Value=0.14}');
    Expect(1, 8528, '\p{Is_Numeric_Value=1.429e-01}', "");
    Expect(0, 8528, '\p{^Is_Numeric_Value=1.429e-01}', "");
    Expect(0, 8528, '\P{Is_Numeric_Value=1.429e-01}', "");
    Expect(1, 8528, '\P{^Is_Numeric_Value=1.429e-01}', "");
    Expect(0, 8529, '\p{Is_Numeric_Value=1.429e-01}', "");
    Expect(1, 8529, '\p{^Is_Numeric_Value=1.429e-01}', "");
    Expect(1, 8529, '\P{Is_Numeric_Value=1.429e-01}', "");
    Expect(0, 8529, '\P{^Is_Numeric_Value=1.429e-01}', "");
    Expect(1, 8528, '\p{Is_Numeric_Value=0.143}', "");
    Expect(0, 8528, '\p{^Is_Numeric_Value=0.143}', "");
    Expect(0, 8528, '\P{Is_Numeric_Value=0.143}', "");
    Expect(1, 8528, '\P{^Is_Numeric_Value=0.143}', "");
    Expect(0, 8529, '\p{Is_Numeric_Value=0.143}', "");
    Expect(1, 8529, '\p{^Is_Numeric_Value=0.143}', "");
    Expect(1, 8529, '\P{Is_Numeric_Value=0.143}', "");
    Expect(0, 8529, '\P{^Is_Numeric_Value=0.143}', "");
    Expect(1, 8528, '\p{Is_Numeric_Value=1.4286e-01}', "");
    Expect(0, 8528, '\p{^Is_Numeric_Value=1.4286e-01}', "");
    Expect(0, 8528, '\P{Is_Numeric_Value=1.4286e-01}', "");
    Expect(1, 8528, '\P{^Is_Numeric_Value=1.4286e-01}', "");
    Expect(0, 8529, '\p{Is_Numeric_Value=1.4286e-01}', "");
    Expect(1, 8529, '\p{^Is_Numeric_Value=1.4286e-01}', "");
    Expect(1, 8529, '\P{Is_Numeric_Value=1.4286e-01}', "");
    Expect(0, 8529, '\P{^Is_Numeric_Value=1.4286e-01}', "");
    Expect(1, 8528, '\p{Is_Numeric_Value=0.1429}', "");
    Expect(0, 8528, '\p{^Is_Numeric_Value=0.1429}', "");
    Expect(0, 8528, '\P{Is_Numeric_Value=0.1429}', "");
    Expect(1, 8528, '\P{^Is_Numeric_Value=0.1429}', "");
    Expect(0, 8529, '\p{Is_Numeric_Value=0.1429}', "");
    Expect(1, 8529, '\p{^Is_Numeric_Value=0.1429}', "");
    Expect(1, 8529, '\P{Is_Numeric_Value=0.1429}', "");
    Expect(0, 8529, '\P{^Is_Numeric_Value=0.1429}', "");
    Error('\p{Is_Nv:	-00000001/0000007/a/}');
    Error('\P{Is_Nv:	-00000001/0000007/a/}');
    Expect(1, 8528, '\p{Is_Nv=0000001/007}', "");
    Expect(0, 8528, '\p{^Is_Nv=0000001/007}', "");
    Expect(0, 8528, '\P{Is_Nv=0000001/007}', "");
    Expect(1, 8528, '\P{^Is_Nv=0000001/007}', "");
    Expect(0, 8529, '\p{Is_Nv=0000001/007}', "");
    Expect(1, 8529, '\p{^Is_Nv=0000001/007}', "");
    Expect(1, 8529, '\P{Is_Nv=0000001/007}', "");
    Expect(0, 8529, '\P{^Is_Nv=0000001/007}', "");
    Expect(1, 8528, '\p{Is_Nv=60/420}', "");
    Expect(0, 8528, '\p{^Is_Nv=60/420}', "");
    Expect(0, 8528, '\P{Is_Nv=60/420}', "");
    Expect(1, 8528, '\P{^Is_Nv=60/420}', "");
    Expect(0, 8529, '\p{Is_Nv=60/420}', "");
    Expect(1, 8529, '\p{^Is_Nv=60/420}', "");
    Expect(1, 8529, '\P{Is_Nv=60/420}', "");
    Expect(0, 8529, '\P{^Is_Nv=60/420}', "");
    Error('\p{Is_Nv=1.4e-01}');
    Error('\P{Is_Nv=1.4e-01}');
    Expect(1, 8528, '\p{Is_Nv=1.43e-01}', "");
    Expect(0, 8528, '\p{^Is_Nv=1.43e-01}', "");
    Expect(0, 8528, '\P{Is_Nv=1.43e-01}', "");
    Expect(1, 8528, '\P{^Is_Nv=1.43e-01}', "");
    Expect(0, 8529, '\p{Is_Nv=1.43e-01}', "");
    Expect(1, 8529, '\p{^Is_Nv=1.43e-01}', "");
    Expect(1, 8529, '\P{Is_Nv=1.43e-01}', "");
    Expect(0, 8529, '\P{^Is_Nv=1.43e-01}', "");
    Error('\p{Is_Nv=0.14}');
    Error('\P{Is_Nv=0.14}');
    Expect(1, 8528, '\p{Is_Nv=1.429e-01}', "");
    Expect(0, 8528, '\p{^Is_Nv=1.429e-01}', "");
    Expect(0, 8528, '\P{Is_Nv=1.429e-01}', "");
    Expect(1, 8528, '\P{^Is_Nv=1.429e-01}', "");
    Expect(0, 8529, '\p{Is_Nv=1.429e-01}', "");
    Expect(1, 8529, '\p{^Is_Nv=1.429e-01}', "");
    Expect(1, 8529, '\P{Is_Nv=1.429e-01}', "");
    Expect(0, 8529, '\P{^Is_Nv=1.429e-01}', "");
    Expect(1, 8528, '\p{Is_Nv=0.143}', "");
    Expect(0, 8528, '\p{^Is_Nv=0.143}', "");
    Expect(0, 8528, '\P{Is_Nv=0.143}', "");
    Expect(1, 8528, '\P{^Is_Nv=0.143}', "");
    Expect(0, 8529, '\p{Is_Nv=0.143}', "");
    Expect(1, 8529, '\p{^Is_Nv=0.143}', "");
    Expect(1, 8529, '\P{Is_Nv=0.143}', "");
    Expect(0, 8529, '\P{^Is_Nv=0.143}', "");
    Expect(1, 8528, '\p{Is_Nv=1.4286e-01}', "");
    Expect(0, 8528, '\p{^Is_Nv=1.4286e-01}', "");
    Expect(0, 8528, '\P{Is_Nv=1.4286e-01}', "");
    Expect(1, 8528, '\P{^Is_Nv=1.4286e-01}', "");
    Expect(0, 8529, '\p{Is_Nv=1.4286e-01}', "");
    Expect(1, 8529, '\p{^Is_Nv=1.4286e-01}', "");
    Expect(1, 8529, '\P{Is_Nv=1.4286e-01}', "");
    Expect(0, 8529, '\P{^Is_Nv=1.4286e-01}', "");
    Expect(1, 8528, '\p{Is_Nv=0.1429}', "");
    Expect(0, 8528, '\p{^Is_Nv=0.1429}', "");
    Expect(0, 8528, '\P{Is_Nv=0.1429}', "");
    Expect(1, 8528, '\P{^Is_Nv=0.1429}', "");
    Expect(0, 8529, '\p{Is_Nv=0.1429}', "");
    Expect(1, 8529, '\p{^Is_Nv=0.1429}', "");
    Expect(1, 8529, '\P{Is_Nv=0.1429}', "");
    Expect(0, 8529, '\P{^Is_Nv=0.1429}', "");
    Error('\p{Numeric_Value=/a/ 00001/000008}');
    Error('\P{Numeric_Value=/a/ 00001/000008}');
    Expect(1, 74847, '\p{Numeric_Value=:\A1/8\z:}', "");;
    Expect(0, 74848, '\p{Numeric_Value=:\A1/8\z:}', "");;
    Expect(1, 74847, '\p{Numeric_Value=+001/0000008}', "");
    Expect(0, 74847, '\p{^Numeric_Value=+001/0000008}', "");
    Expect(0, 74847, '\P{Numeric_Value=+001/0000008}', "");
    Expect(1, 74847, '\P{^Numeric_Value=+001/0000008}', "");
    Expect(0, 74848, '\p{Numeric_Value=+001/0000008}', "");
    Expect(1, 74848, '\p{^Numeric_Value=+001/0000008}', "");
    Expect(1, 74848, '\P{Numeric_Value=+001/0000008}', "");
    Expect(0, 74848, '\P{^Numeric_Value=+001/0000008}', "");
    Expect(1, 74847, '\p{Numeric_Value=60/480}', "");
    Expect(0, 74847, '\p{^Numeric_Value=60/480}', "");
    Expect(0, 74847, '\P{Numeric_Value=60/480}', "");
    Expect(1, 74847, '\P{^Numeric_Value=60/480}', "");
    Expect(0, 74848, '\p{Numeric_Value=60/480}', "");
    Expect(1, 74848, '\p{^Numeric_Value=60/480}', "");
    Expect(1, 74848, '\P{Numeric_Value=60/480}', "");
    Expect(0, 74848, '\P{^Numeric_Value=60/480}', "");
    Error('\p{Numeric_Value=1.2e-01}');
    Error('\P{Numeric_Value=1.2e-01}');
    Expect(1, 74847, '\p{Numeric_Value=1.25e-01}', "");
    Expect(0, 74847, '\p{^Numeric_Value=1.25e-01}', "");
    Expect(0, 74847, '\P{Numeric_Value=1.25e-01}', "");
    Expect(1, 74847, '\P{^Numeric_Value=1.25e-01}', "");
    Expect(0, 74848, '\p{Numeric_Value=1.25e-01}', "");
    Expect(1, 74848, '\p{^Numeric_Value=1.25e-01}', "");
    Expect(1, 74848, '\P{Numeric_Value=1.25e-01}', "");
    Expect(0, 74848, '\P{^Numeric_Value=1.25e-01}', "");
    Error('\p{Numeric_Value=0.12}');
    Error('\P{Numeric_Value=0.12}');
    Expect(1, 74847, '\p{Numeric_Value=1.250e-01}', "");
    Expect(0, 74847, '\p{^Numeric_Value=1.250e-01}', "");
    Expect(0, 74847, '\P{Numeric_Value=1.250e-01}', "");
    Expect(1, 74847, '\P{^Numeric_Value=1.250e-01}', "");
    Expect(0, 74848, '\p{Numeric_Value=1.250e-01}', "");
    Expect(1, 74848, '\p{^Numeric_Value=1.250e-01}', "");
    Expect(1, 74848, '\P{Numeric_Value=1.250e-01}', "");
    Expect(0, 74848, '\P{^Numeric_Value=1.250e-01}', "");
    Expect(1, 74847, '\p{Numeric_Value=0.125}', "");
    Expect(0, 74847, '\p{^Numeric_Value=0.125}', "");
    Expect(0, 74847, '\P{Numeric_Value=0.125}', "");
    Expect(1, 74847, '\P{^Numeric_Value=0.125}', "");
    Expect(0, 74848, '\p{Numeric_Value=0.125}', "");
    Expect(1, 74848, '\p{^Numeric_Value=0.125}', "");
    Expect(1, 74848, '\P{Numeric_Value=0.125}', "");
    Expect(0, 74848, '\P{^Numeric_Value=0.125}', "");
    Expect(1, 74847, '\p{Numeric_Value:1.2500e-01}', "");
    Expect(0, 74847, '\p{^Numeric_Value:1.2500e-01}', "");
    Expect(0, 74847, '\P{Numeric_Value:1.2500e-01}', "");
    Expect(1, 74847, '\P{^Numeric_Value:1.2500e-01}', "");
    Expect(0, 74848, '\p{Numeric_Value:1.2500e-01}', "");
    Expect(1, 74848, '\p{^Numeric_Value:1.2500e-01}', "");
    Expect(1, 74848, '\P{Numeric_Value:1.2500e-01}', "");
    Expect(0, 74848, '\P{^Numeric_Value:1.2500e-01}', "");
    Expect(1, 74847, '\p{Numeric_Value=0.1250}', "");
    Expect(0, 74847, '\p{^Numeric_Value=0.1250}', "");
    Expect(0, 74847, '\P{Numeric_Value=0.1250}', "");
    Expect(1, 74847, '\P{^Numeric_Value=0.1250}', "");
    Expect(0, 74848, '\p{Numeric_Value=0.1250}', "");
    Expect(1, 74848, '\p{^Numeric_Value=0.1250}', "");
    Expect(1, 74848, '\P{Numeric_Value=0.1250}', "");
    Expect(0, 74848, '\P{^Numeric_Value=0.1250}', "");
    Error('\p{Nv=	:=+000000001/8}');
    Error('\P{Nv=	:=+000000001/8}');
    Expect(1, 74847, '\p{Nv=:\A1/8\z:}', "");;
    Expect(0, 74848, '\p{Nv=:\A1/8\z:}', "");;
    Expect(1, 74847, '\p{Nv=+0000001/8}', "");
    Expect(0, 74847, '\p{^Nv=+0000001/8}', "");
    Expect(0, 74847, '\P{Nv=+0000001/8}', "");
    Expect(1, 74847, '\P{^Nv=+0000001/8}', "");
    Expect(0, 74848, '\p{Nv=+0000001/8}', "");
    Expect(1, 74848, '\p{^Nv=+0000001/8}', "");
    Expect(1, 74848, '\P{Nv=+0000001/8}', "");
    Expect(0, 74848, '\P{^Nv=+0000001/8}', "");
    Expect(1, 74847, '\p{Nv: 60/480}', "");
    Expect(0, 74847, '\p{^Nv: 60/480}', "");
    Expect(0, 74847, '\P{Nv: 60/480}', "");
    Expect(1, 74847, '\P{^Nv: 60/480}', "");
    Expect(0, 74848, '\p{Nv: 60/480}', "");
    Expect(1, 74848, '\p{^Nv: 60/480}', "");
    Expect(1, 74848, '\P{Nv: 60/480}', "");
    Expect(0, 74848, '\P{^Nv: 60/480}', "");
    Error('\p{Nv=1.2e-01}');
    Error('\P{Nv=1.2e-01}');
    Expect(1, 74847, '\p{Nv=1.25e-01}', "");
    Expect(0, 74847, '\p{^Nv=1.25e-01}', "");
    Expect(0, 74847, '\P{Nv=1.25e-01}', "");
    Expect(1, 74847, '\P{^Nv=1.25e-01}', "");
    Expect(0, 74848, '\p{Nv=1.25e-01}', "");
    Expect(1, 74848, '\p{^Nv=1.25e-01}', "");
    Expect(1, 74848, '\P{Nv=1.25e-01}', "");
    Expect(0, 74848, '\P{^Nv=1.25e-01}', "");
    Error('\p{Nv=0.12}');
    Error('\P{Nv=0.12}');
    Expect(1, 74847, '\p{Nv=1.250e-01}', "");
    Expect(0, 74847, '\p{^Nv=1.250e-01}', "");
    Expect(0, 74847, '\P{Nv=1.250e-01}', "");
    Expect(1, 74847, '\P{^Nv=1.250e-01}', "");
    Expect(0, 74848, '\p{Nv=1.250e-01}', "");
    Expect(1, 74848, '\p{^Nv=1.250e-01}', "");
    Expect(1, 74848, '\P{Nv=1.250e-01}', "");
    Expect(0, 74848, '\P{^Nv=1.250e-01}', "");
    Expect(1, 74847, '\p{Nv:	0.125}', "");
    Expect(0, 74847, '\p{^Nv:	0.125}', "");
    Expect(0, 74847, '\P{Nv:	0.125}', "");
    Expect(1, 74847, '\P{^Nv:	0.125}', "");
    Expect(0, 74848, '\p{Nv:	0.125}', "");
    Expect(1, 74848, '\p{^Nv:	0.125}', "");
    Expect(1, 74848, '\P{Nv:	0.125}', "");
    Expect(0, 74848, '\P{^Nv:	0.125}', "");
    Expect(1, 74847, '\p{Nv=1.2500e-01}', "");
    Expect(0, 74847, '\p{^Nv=1.2500e-01}', "");
    Expect(0, 74847, '\P{Nv=1.2500e-01}', "");
    Expect(1, 74847, '\P{^Nv=1.2500e-01}', "");
    Expect(0, 74848, '\p{Nv=1.2500e-01}', "");
    Expect(1, 74848, '\p{^Nv=1.2500e-01}', "");
    Expect(1, 74848, '\P{Nv=1.2500e-01}', "");
    Expect(0, 74848, '\P{^Nv=1.2500e-01}', "");
    Expect(1, 74847, '\p{Nv=0.1250}', "");
    Expect(0, 74847, '\p{^Nv=0.1250}', "");
    Expect(0, 74847, '\P{Nv=0.1250}', "");
    Expect(1, 74847, '\P{^Nv=0.1250}', "");
    Expect(0, 74848, '\p{Nv=0.1250}', "");
    Expect(1, 74848, '\p{^Nv=0.1250}', "");
    Expect(1, 74848, '\P{Nv=0.1250}', "");
    Expect(0, 74848, '\P{^Nv=0.1250}', "");
    Error('\p{Is_Numeric_Value=:=__000001/8}');
    Error('\P{Is_Numeric_Value=:=__000001/8}');
    Expect(1, 74847, '\p{Is_Numeric_Value=000001/00008}', "");
    Expect(0, 74847, '\p{^Is_Numeric_Value=000001/00008}', "");
    Expect(0, 74847, '\P{Is_Numeric_Value=000001/00008}', "");
    Expect(1, 74847, '\P{^Is_Numeric_Value=000001/00008}', "");
    Expect(0, 74848, '\p{Is_Numeric_Value=000001/00008}', "");
    Expect(1, 74848, '\p{^Is_Numeric_Value=000001/00008}', "");
    Expect(1, 74848, '\P{Is_Numeric_Value=000001/00008}', "");
    Expect(0, 74848, '\P{^Is_Numeric_Value=000001/00008}', "");
    Expect(1, 74847, '\p{Is_Numeric_Value=60/480}', "");
    Expect(0, 74847, '\p{^Is_Numeric_Value=60/480}', "");
    Expect(0, 74847, '\P{Is_Numeric_Value=60/480}', "");
    Expect(1, 74847, '\P{^Is_Numeric_Value=60/480}', "");
    Expect(0, 74848, '\p{Is_Numeric_Value=60/480}', "");
    Expect(1, 74848, '\p{^Is_Numeric_Value=60/480}', "");
    Expect(1, 74848, '\P{Is_Numeric_Value=60/480}', "");
    Expect(0, 74848, '\P{^Is_Numeric_Value=60/480}', "");
    Error('\p{Is_Numeric_Value=1.2e-01}');
    Error('\P{Is_Numeric_Value=1.2e-01}');
    Expect(1, 74847, '\p{Is_Numeric_Value=1.25e-01}', "");
    Expect(0, 74847, '\p{^Is_Numeric_Value=1.25e-01}', "");
    Expect(0, 74847, '\P{Is_Numeric_Value=1.25e-01}', "");
    Expect(1, 74847, '\P{^Is_Numeric_Value=1.25e-01}', "");
    Expect(0, 74848, '\p{Is_Numeric_Value=1.25e-01}', "");
    Expect(1, 74848, '\p{^Is_Numeric_Value=1.25e-01}', "");
    Expect(1, 74848, '\P{Is_Numeric_Value=1.25e-01}', "");
    Expect(0, 74848, '\P{^Is_Numeric_Value=1.25e-01}', "");
    Error('\p{Is_Numeric_Value: 0.12}');
    Error('\P{Is_Numeric_Value: 0.12}');
    Expect(1, 74847, '\p{Is_Numeric_Value:   1.250e-01}', "");
    Expect(0, 74847, '\p{^Is_Numeric_Value:   1.250e-01}', "");
    Expect(0, 74847, '\P{Is_Numeric_Value:   1.250e-01}', "");
    Expect(1, 74847, '\P{^Is_Numeric_Value:   1.250e-01}', "");
    Expect(0, 74848, '\p{Is_Numeric_Value:   1.250e-01}', "");
    Expect(1, 74848, '\p{^Is_Numeric_Value:   1.250e-01}', "");
    Expect(1, 74848, '\P{Is_Numeric_Value:   1.250e-01}', "");
    Expect(0, 74848, '\P{^Is_Numeric_Value:   1.250e-01}', "");
    Expect(1, 74847, '\p{Is_Numeric_Value:0.125}', "");
    Expect(0, 74847, '\p{^Is_Numeric_Value:0.125}', "");
    Expect(0, 74847, '\P{Is_Numeric_Value:0.125}', "");
    Expect(1, 74847, '\P{^Is_Numeric_Value:0.125}', "");
    Expect(0, 74848, '\p{Is_Numeric_Value:0.125}', "");
    Expect(1, 74848, '\p{^Is_Numeric_Value:0.125}', "");
    Expect(1, 74848, '\P{Is_Numeric_Value:0.125}', "");
    Expect(0, 74848, '\P{^Is_Numeric_Value:0.125}', "");
    Expect(1, 74847, '\p{Is_Numeric_Value=1.2500e-01}', "");
    Expect(0, 74847, '\p{^Is_Numeric_Value=1.2500e-01}', "");
    Expect(0, 74847, '\P{Is_Numeric_Value=1.2500e-01}', "");
    Expect(1, 74847, '\P{^Is_Numeric_Value=1.2500e-01}', "");
    Expect(0, 74848, '\p{Is_Numeric_Value=1.2500e-01}', "");
    Expect(1, 74848, '\p{^Is_Numeric_Value=1.2500e-01}', "");
    Expect(1, 74848, '\P{Is_Numeric_Value=1.2500e-01}', "");
    Expect(0, 74848, '\P{^Is_Numeric_Value=1.2500e-01}', "");
    Expect(1, 74847, '\p{Is_Numeric_Value=0.1250}', "");
    Expect(0, 74847, '\p{^Is_Numeric_Value=0.1250}', "");
    Expect(0, 74847, '\P{Is_Numeric_Value=0.1250}', "");
    Expect(1, 74847, '\P{^Is_Numeric_Value=0.1250}', "");
    Expect(0, 74848, '\p{Is_Numeric_Value=0.1250}', "");
    Expect(1, 74848, '\p{^Is_Numeric_Value=0.1250}', "");
    Expect(1, 74848, '\P{Is_Numeric_Value=0.1250}', "");
    Expect(0, 74848, '\P{^Is_Numeric_Value=0.1250}', "");
    Error('\p{Is_Nv=-_1/000008/a/}');
    Error('\P{Is_Nv=-_1/000008/a/}');
    Expect(1, 74847, '\p{Is_Nv=000001/00000008}', "");
    Expect(0, 74847, '\p{^Is_Nv=000001/00000008}', "");
    Expect(0, 74847, '\P{Is_Nv=000001/00000008}', "");
    Expect(1, 74847, '\P{^Is_Nv=000001/00000008}', "");
    Expect(0, 74848, '\p{Is_Nv=000001/00000008}', "");
    Expect(1, 74848, '\p{^Is_Nv=000001/00000008}', "");
    Expect(1, 74848, '\P{Is_Nv=000001/00000008}', "");
    Expect(0, 74848, '\P{^Is_Nv=000001/00000008}', "");
    Expect(1, 74847, '\p{Is_Nv: 60/480}', "");
    Expect(0, 74847, '\p{^Is_Nv: 60/480}', "");
    Expect(0, 74847, '\P{Is_Nv: 60/480}', "");
    Expect(1, 74847, '\P{^Is_Nv: 60/480}', "");
    Expect(0, 74848, '\p{Is_Nv: 60/480}', "");
    Expect(1, 74848, '\p{^Is_Nv: 60/480}', "");
    Expect(1, 74848, '\P{Is_Nv: 60/480}', "");
    Expect(0, 74848, '\P{^Is_Nv: 60/480}', "");
    Error('\p{Is_Nv=1.2e-01}');
    Error('\P{Is_Nv=1.2e-01}');
    Expect(1, 74847, '\p{Is_Nv:	1.25e-01}', "");
    Expect(0, 74847, '\p{^Is_Nv:	1.25e-01}', "");
    Expect(0, 74847, '\P{Is_Nv:	1.25e-01}', "");
    Expect(1, 74847, '\P{^Is_Nv:	1.25e-01}', "");
    Expect(0, 74848, '\p{Is_Nv:	1.25e-01}', "");
    Expect(1, 74848, '\p{^Is_Nv:	1.25e-01}', "");
    Expect(1, 74848, '\P{Is_Nv:	1.25e-01}', "");
    Expect(0, 74848, '\P{^Is_Nv:	1.25e-01}', "");
    Error('\p{Is_Nv=0.12}');
    Error('\P{Is_Nv=0.12}');
    Expect(1, 74847, '\p{Is_Nv=1.250e-01}', "");
    Expect(0, 74847, '\p{^Is_Nv=1.250e-01}', "");
    Expect(0, 74847, '\P{Is_Nv=1.250e-01}', "");
    Expect(1, 74847, '\P{^Is_Nv=1.250e-01}', "");
    Expect(0, 74848, '\p{Is_Nv=1.250e-01}', "");
    Expect(1, 74848, '\p{^Is_Nv=1.250e-01}', "");
    Expect(1, 74848, '\P{Is_Nv=1.250e-01}', "");
    Expect(0, 74848, '\P{^Is_Nv=1.250e-01}', "");
    Expect(1, 74847, '\p{Is_Nv=0.125}', "");
    Expect(0, 74847, '\p{^Is_Nv=0.125}', "");
    Expect(0, 74847, '\P{Is_Nv=0.125}', "");
    Expect(1, 74847, '\P{^Is_Nv=0.125}', "");
    Expect(0, 74848, '\p{Is_Nv=0.125}', "");
    Expect(1, 74848, '\p{^Is_Nv=0.125}', "");
    Expect(1, 74848, '\P{Is_Nv=0.125}', "");
    Expect(0, 74848, '\P{^Is_Nv=0.125}', "");
    Expect(1, 74847, '\p{Is_Nv:	1.2500e-01}', "");
    Expect(0, 74847, '\p{^Is_Nv:	1.2500e-01}', "");
    Expect(0, 74847, '\P{Is_Nv:	1.2500e-01}', "");
    Expect(1, 74847, '\P{^Is_Nv:	1.2500e-01}', "");
    Expect(0, 74848, '\p{Is_Nv:	1.2500e-01}', "");
    Expect(1, 74848, '\p{^Is_Nv:	1.2500e-01}', "");
    Expect(1, 74848, '\P{Is_Nv:	1.2500e-01}', "");
    Expect(0, 74848, '\P{^Is_Nv:	1.2500e-01}', "");
    Expect(1, 74847, '\p{Is_Nv=0.1250}', "");
    Expect(0, 74847, '\p{^Is_Nv=0.1250}', "");
    Expect(0, 74847, '\P{Is_Nv=0.1250}', "");
    Expect(1, 74847, '\P{^Is_Nv=0.1250}', "");
    Expect(0, 74848, '\p{Is_Nv=0.1250}', "");
    Expect(1, 74848, '\p{^Is_Nv=0.1250}', "");
    Expect(1, 74848, '\P{Is_Nv=0.1250}', "");
    Expect(0, 74848, '\P{^Is_Nv=0.1250}', "");
    Error('\p{Numeric_Value:   /a/_-1/00000080}');
    Error('\P{Numeric_Value:   /a/_-1/00000080}');
    Expect(1, 73666, '\p{Numeric_Value=:\A1/80\z:}', "");;
    Expect(0, 73667, '\p{Numeric_Value=:\A1/80\z:}', "");;
    Expect(1, 73666, '\p{Numeric_Value=00000001/0080}', "");
    Expect(0, 73666, '\p{^Numeric_Value=00000001/0080}', "");
    Expect(0, 73666, '\P{Numeric_Value=00000001/0080}', "");
    Expect(1, 73666, '\P{^Numeric_Value=00000001/0080}', "");
    Expect(0, 73667, '\p{Numeric_Value=00000001/0080}', "");
    Expect(1, 73667, '\p{^Numeric_Value=00000001/0080}', "");
    Expect(1, 73667, '\P{Numeric_Value=00000001/0080}', "");
    Expect(0, 73667, '\P{^Numeric_Value=00000001/0080}', "");
    Expect(1, 73666, '\p{Numeric_Value=60/4800}', "");
    Expect(0, 73666, '\p{^Numeric_Value=60/4800}', "");
    Expect(0, 73666, '\P{Numeric_Value=60/4800}', "");
    Expect(1, 73666, '\P{^Numeric_Value=60/4800}', "");
    Expect(0, 73667, '\p{Numeric_Value=60/4800}', "");
    Expect(1, 73667, '\p{^Numeric_Value=60/4800}', "");
    Expect(1, 73667, '\P{Numeric_Value=60/4800}', "");
    Expect(0, 73667, '\P{^Numeric_Value=60/4800}', "");
    Error('\p{Numeric_Value=1.3e-02}');
    Error('\P{Numeric_Value=1.3e-02}');
    Expect(1, 73666, '\p{Numeric_Value:1.25e-02}', "");
    Expect(0, 73666, '\p{^Numeric_Value:1.25e-02}', "");
    Expect(0, 73666, '\P{Numeric_Value:1.25e-02}', "");
    Expect(1, 73666, '\P{^Numeric_Value:1.25e-02}', "");
    Expect(0, 73667, '\p{Numeric_Value:1.25e-02}', "");
    Expect(1, 73667, '\p{^Numeric_Value:1.25e-02}', "");
    Expect(1, 73667, '\P{Numeric_Value:1.25e-02}', "");
    Expect(0, 73667, '\P{^Numeric_Value:1.25e-02}', "");
    Error('\p{Numeric_Value=0.01}');
    Error('\P{Numeric_Value=0.01}');
    Expect(1, 73666, '\p{Numeric_Value=1.250e-02}', "");
    Expect(0, 73666, '\p{^Numeric_Value=1.250e-02}', "");
    Expect(0, 73666, '\P{Numeric_Value=1.250e-02}', "");
    Expect(1, 73666, '\P{^Numeric_Value=1.250e-02}', "");
    Expect(0, 73667, '\p{Numeric_Value=1.250e-02}', "");
    Expect(1, 73667, '\p{^Numeric_Value=1.250e-02}', "");
    Expect(1, 73667, '\P{Numeric_Value=1.250e-02}', "");
    Expect(0, 73667, '\P{^Numeric_Value=1.250e-02}', "");
    Error('\p{Numeric_Value=0.013}');
    Error('\P{Numeric_Value=0.013}');
    Expect(1, 73666, '\p{Numeric_Value=1.2500e-02}', "");
    Expect(0, 73666, '\p{^Numeric_Value=1.2500e-02}', "");
    Expect(0, 73666, '\P{Numeric_Value=1.2500e-02}', "");
    Expect(1, 73666, '\P{^Numeric_Value=1.2500e-02}', "");
    Expect(0, 73667, '\p{Numeric_Value=1.2500e-02}', "");
    Expect(1, 73667, '\p{^Numeric_Value=1.2500e-02}', "");
    Expect(1, 73667, '\P{Numeric_Value=1.2500e-02}', "");
    Expect(0, 73667, '\P{^Numeric_Value=1.2500e-02}', "");
    Expect(1, 73666, '\p{Numeric_Value=0.0125}', "");
    Expect(0, 73666, '\p{^Numeric_Value=0.0125}', "");
    Expect(0, 73666, '\P{Numeric_Value=0.0125}', "");
    Expect(1, 73666, '\P{^Numeric_Value=0.0125}', "");
    Expect(0, 73667, '\p{Numeric_Value=0.0125}', "");
    Expect(1, 73667, '\p{^Numeric_Value=0.0125}', "");
    Expect(1, 73667, '\P{Numeric_Value=0.0125}', "");
    Expect(0, 73667, '\P{^Numeric_Value=0.0125}', "");
    Expect(1, 73666, '\p{Numeric_Value=1.25000e-02}', "");
    Expect(0, 73666, '\p{^Numeric_Value=1.25000e-02}', "");
    Expect(0, 73666, '\P{Numeric_Value=1.25000e-02}', "");
    Expect(1, 73666, '\P{^Numeric_Value=1.25000e-02}', "");
    Expect(0, 73667, '\p{Numeric_Value=1.25000e-02}', "");
    Expect(1, 73667, '\p{^Numeric_Value=1.25000e-02}', "");
    Expect(1, 73667, '\P{Numeric_Value=1.25000e-02}', "");
    Expect(0, 73667, '\P{^Numeric_Value=1.25000e-02}', "");
    Expect(1, 73666, '\p{Numeric_Value:   0.01250}', "");
    Expect(0, 73666, '\p{^Numeric_Value:   0.01250}', "");
    Expect(0, 73666, '\P{Numeric_Value:   0.01250}', "");
    Expect(1, 73666, '\P{^Numeric_Value:   0.01250}', "");
    Expect(0, 73667, '\p{Numeric_Value:   0.01250}', "");
    Expect(1, 73667, '\p{^Numeric_Value:   0.01250}', "");
    Expect(1, 73667, '\P{Numeric_Value:   0.01250}', "");
    Expect(0, 73667, '\P{^Numeric_Value:   0.01250}', "");
    Error('\p{Nv=_:=+000001/000000080}');
    Error('\P{Nv=_:=+000001/000000080}');
    Expect(1, 73666, '\p{Nv=:\A1/80\z:}', "");;
    Expect(0, 73667, '\p{Nv=:\A1/80\z:}', "");;
    Expect(1, 73666, '\p{Nv=00000001/80}', "");
    Expect(0, 73666, '\p{^Nv=00000001/80}', "");
    Expect(0, 73666, '\P{Nv=00000001/80}', "");
    Expect(1, 73666, '\P{^Nv=00000001/80}', "");
    Expect(0, 73667, '\p{Nv=00000001/80}', "");
    Expect(1, 73667, '\p{^Nv=00000001/80}', "");
    Expect(1, 73667, '\P{Nv=00000001/80}', "");
    Expect(0, 73667, '\P{^Nv=00000001/80}', "");
    Expect(1, 73666, '\p{Nv=60/4800}', "");
    Expect(0, 73666, '\p{^Nv=60/4800}', "");
    Expect(0, 73666, '\P{Nv=60/4800}', "");
    Expect(1, 73666, '\P{^Nv=60/4800}', "");
    Expect(0, 73667, '\p{Nv=60/4800}', "");
    Expect(1, 73667, '\p{^Nv=60/4800}', "");
    Expect(1, 73667, '\P{Nv=60/4800}', "");
    Expect(0, 73667, '\P{^Nv=60/4800}', "");
    Error('\p{Nv=1.3e-02}');
    Error('\P{Nv=1.3e-02}');
    Expect(1, 73666, '\p{Nv=1.25e-02}', "");
    Expect(0, 73666, '\p{^Nv=1.25e-02}', "");
    Expect(0, 73666, '\P{Nv=1.25e-02}', "");
    Expect(1, 73666, '\P{^Nv=1.25e-02}', "");
    Expect(0, 73667, '\p{Nv=1.25e-02}', "");
    Expect(1, 73667, '\p{^Nv=1.25e-02}', "");
    Expect(1, 73667, '\P{Nv=1.25e-02}', "");
    Expect(0, 73667, '\P{^Nv=1.25e-02}', "");
    Error('\p{Nv:	0.01}');
    Error('\P{Nv:	0.01}');
    Expect(1, 73666, '\p{Nv=1.250e-02}', "");
    Expect(0, 73666, '\p{^Nv=1.250e-02}', "");
    Expect(0, 73666, '\P{Nv=1.250e-02}', "");
    Expect(1, 73666, '\P{^Nv=1.250e-02}', "");
    Expect(0, 73667, '\p{Nv=1.250e-02}', "");
    Expect(1, 73667, '\p{^Nv=1.250e-02}', "");
    Expect(1, 73667, '\P{Nv=1.250e-02}', "");
    Expect(0, 73667, '\P{^Nv=1.250e-02}', "");
    Error('\p{Nv=0.013}');
    Error('\P{Nv=0.013}');
    Expect(1, 73666, '\p{Nv=1.2500e-02}', "");
    Expect(0, 73666, '\p{^Nv=1.2500e-02}', "");
    Expect(0, 73666, '\P{Nv=1.2500e-02}', "");
    Expect(1, 73666, '\P{^Nv=1.2500e-02}', "");
    Expect(0, 73667, '\p{Nv=1.2500e-02}', "");
    Expect(1, 73667, '\p{^Nv=1.2500e-02}', "");
    Expect(1, 73667, '\P{Nv=1.2500e-02}', "");
    Expect(0, 73667, '\P{^Nv=1.2500e-02}', "");
    Expect(1, 73666, '\p{Nv=0.0125}', "");
    Expect(0, 73666, '\p{^Nv=0.0125}', "");
    Expect(0, 73666, '\P{Nv=0.0125}', "");
    Expect(1, 73666, '\P{^Nv=0.0125}', "");
    Expect(0, 73667, '\p{Nv=0.0125}', "");
    Expect(1, 73667, '\p{^Nv=0.0125}', "");
    Expect(1, 73667, '\P{Nv=0.0125}', "");
    Expect(0, 73667, '\P{^Nv=0.0125}', "");
    Expect(1, 73666, '\p{Nv=1.25000e-02}', "");
    Expect(0, 73666, '\p{^Nv=1.25000e-02}', "");
    Expect(0, 73666, '\P{Nv=1.25000e-02}', "");
    Expect(1, 73666, '\P{^Nv=1.25000e-02}', "");
    Expect(0, 73667, '\p{Nv=1.25000e-02}', "");
    Expect(1, 73667, '\p{^Nv=1.25000e-02}', "");
    Expect(1, 73667, '\P{Nv=1.25000e-02}', "");
    Expect(0, 73667, '\P{^Nv=1.25000e-02}', "");
    Expect(1, 73666, '\p{Nv=0.01250}', "");
    Expect(0, 73666, '\p{^Nv=0.01250}', "");
    Expect(0, 73666, '\P{Nv=0.01250}', "");
    Expect(1, 73666, '\P{^Nv=0.01250}', "");
    Expect(0, 73667, '\p{Nv=0.01250}', "");
    Expect(1, 73667, '\p{^Nv=0.01250}', "");
    Expect(1, 73667, '\P{Nv=0.01250}', "");
    Expect(0, 73667, '\P{^Nv=0.01250}', "");
    Error('\p{Is_Numeric_Value: /a/0001/80}');
    Error('\P{Is_Numeric_Value: /a/0001/80}');
    Expect(1, 73666, '\p{Is_Numeric_Value=1/80}', "");
    Expect(0, 73666, '\p{^Is_Numeric_Value=1/80}', "");
    Expect(0, 73666, '\P{Is_Numeric_Value=1/80}', "");
    Expect(1, 73666, '\P{^Is_Numeric_Value=1/80}', "");
    Expect(0, 73667, '\p{Is_Numeric_Value=1/80}', "");
    Expect(1, 73667, '\p{^Is_Numeric_Value=1/80}', "");
    Expect(1, 73667, '\P{Is_Numeric_Value=1/80}', "");
    Expect(0, 73667, '\P{^Is_Numeric_Value=1/80}', "");
    Expect(1, 73666, '\p{Is_Numeric_Value:	60/4800}', "");
    Expect(0, 73666, '\p{^Is_Numeric_Value:	60/4800}', "");
    Expect(0, 73666, '\P{Is_Numeric_Value:	60/4800}', "");
    Expect(1, 73666, '\P{^Is_Numeric_Value:	60/4800}', "");
    Expect(0, 73667, '\p{Is_Numeric_Value:	60/4800}', "");
    Expect(1, 73667, '\p{^Is_Numeric_Value:	60/4800}', "");
    Expect(1, 73667, '\P{Is_Numeric_Value:	60/4800}', "");
    Expect(0, 73667, '\P{^Is_Numeric_Value:	60/4800}', "");
    Error('\p{Is_Numeric_Value=1.3e-02}');
    Error('\P{Is_Numeric_Value=1.3e-02}');
    Expect(1, 73666, '\p{Is_Numeric_Value=1.25e-02}', "");
    Expect(0, 73666, '\p{^Is_Numeric_Value=1.25e-02}', "");
    Expect(0, 73666, '\P{Is_Numeric_Value=1.25e-02}', "");
    Expect(1, 73666, '\P{^Is_Numeric_Value=1.25e-02}', "");
    Expect(0, 73667, '\p{Is_Numeric_Value=1.25e-02}', "");
    Expect(1, 73667, '\p{^Is_Numeric_Value=1.25e-02}', "");
    Expect(1, 73667, '\P{Is_Numeric_Value=1.25e-02}', "");
    Expect(0, 73667, '\P{^Is_Numeric_Value=1.25e-02}', "");
    Error('\p{Is_Numeric_Value=0.01}');
    Error('\P{Is_Numeric_Value=0.01}');
    Expect(1, 73666, '\p{Is_Numeric_Value:	1.250e-02}', "");
    Expect(0, 73666, '\p{^Is_Numeric_Value:	1.250e-02}', "");
    Expect(0, 73666, '\P{Is_Numeric_Value:	1.250e-02}', "");
    Expect(1, 73666, '\P{^Is_Numeric_Value:	1.250e-02}', "");
    Expect(0, 73667, '\p{Is_Numeric_Value:	1.250e-02}', "");
    Expect(1, 73667, '\p{^Is_Numeric_Value:	1.250e-02}', "");
    Expect(1, 73667, '\P{Is_Numeric_Value:	1.250e-02}', "");
    Expect(0, 73667, '\P{^Is_Numeric_Value:	1.250e-02}', "");
    Error('\p{Is_Numeric_Value=0.013}');
    Error('\P{Is_Numeric_Value=0.013}');
    Expect(1, 73666, '\p{Is_Numeric_Value=1.2500e-02}', "");
    Expect(0, 73666, '\p{^Is_Numeric_Value=1.2500e-02}', "");
    Expect(0, 73666, '\P{Is_Numeric_Value=1.2500e-02}', "");
    Expect(1, 73666, '\P{^Is_Numeric_Value=1.2500e-02}', "");
    Expect(0, 73667, '\p{Is_Numeric_Value=1.2500e-02}', "");
    Expect(1, 73667, '\p{^Is_Numeric_Value=1.2500e-02}', "");
    Expect(1, 73667, '\P{Is_Numeric_Value=1.2500e-02}', "");
    Expect(0, 73667, '\P{^Is_Numeric_Value=1.2500e-02}', "");
    Expect(1, 73666, '\p{Is_Numeric_Value=0.0125}', "");
    Expect(0, 73666, '\p{^Is_Numeric_Value=0.0125}', "");
    Expect(0, 73666, '\P{Is_Numeric_Value=0.0125}', "");
    Expect(1, 73666, '\P{^Is_Numeric_Value=0.0125}', "");
    Expect(0, 73667, '\p{Is_Numeric_Value=0.0125}', "");
    Expect(1, 73667, '\p{^Is_Numeric_Value=0.0125}', "");
    Expect(1, 73667, '\P{Is_Numeric_Value=0.0125}', "");
    Expect(0, 73667, '\P{^Is_Numeric_Value=0.0125}', "");
    Expect(1, 73666, '\p{Is_Numeric_Value=1.25000e-02}', "");
    Expect(0, 73666, '\p{^Is_Numeric_Value=1.25000e-02}', "");
    Expect(0, 73666, '\P{Is_Numeric_Value=1.25000e-02}', "");
    Expect(1, 73666, '\P{^Is_Numeric_Value=1.25000e-02}', "");
    Expect(0, 73667, '\p{Is_Numeric_Value=1.25000e-02}', "");
    Expect(1, 73667, '\p{^Is_Numeric_Value=1.25000e-02}', "");
    Expect(1, 73667, '\P{Is_Numeric_Value=1.25000e-02}', "");
    Expect(0, 73667, '\P{^Is_Numeric_Value=1.25000e-02}', "");
    Expect(1, 73666, '\p{Is_Numeric_Value=0.01250}', "");
    Expect(0, 73666, '\p{^Is_Numeric_Value=0.01250}', "");
    Expect(0, 73666, '\P{Is_Numeric_Value=0.01250}', "");
    Expect(1, 73666, '\P{^Is_Numeric_Value=0.01250}', "");
    Expect(0, 73667, '\p{Is_Numeric_Value=0.01250}', "");
    Expect(1, 73667, '\p{^Is_Numeric_Value=0.01250}', "");
    Expect(1, 73667, '\P{Is_Numeric_Value=0.01250}', "");
    Expect(0, 73667, '\P{^Is_Numeric_Value=0.01250}', "");
    Error('\p{Is_Nv= :=0001/00000080}');
    Error('\P{Is_Nv= :=0001/00000080}');
    Expect(1, 73666, '\p{Is_Nv=001/00000000080}', "");
    Expect(0, 73666, '\p{^Is_Nv=001/00000000080}', "");
    Expect(0, 73666, '\P{Is_Nv=001/00000000080}', "");
    Expect(1, 73666, '\P{^Is_Nv=001/00000000080}', "");
    Expect(0, 73667, '\p{Is_Nv=001/00000000080}', "");
    Expect(1, 73667, '\p{^Is_Nv=001/00000000080}', "");
    Expect(1, 73667, '\P{Is_Nv=001/00000000080}', "");
    Expect(0, 73667, '\P{^Is_Nv=001/00000000080}', "");
    Expect(1, 73666, '\p{Is_Nv=60/4800}', "");
    Expect(0, 73666, '\p{^Is_Nv=60/4800}', "");
    Expect(0, 73666, '\P{Is_Nv=60/4800}', "");
    Expect(1, 73666, '\P{^Is_Nv=60/4800}', "");
    Expect(0, 73667, '\p{Is_Nv=60/4800}', "");
    Expect(1, 73667, '\p{^Is_Nv=60/4800}', "");
    Expect(1, 73667, '\P{Is_Nv=60/4800}', "");
    Expect(0, 73667, '\P{^Is_Nv=60/4800}', "");
    Error('\p{Is_Nv=1.3e-02}');
    Error('\P{Is_Nv=1.3e-02}');
    Expect(1, 73666, '\p{Is_Nv=1.25e-02}', "");
    Expect(0, 73666, '\p{^Is_Nv=1.25e-02}', "");
    Expect(0, 73666, '\P{Is_Nv=1.25e-02}', "");
    Expect(1, 73666, '\P{^Is_Nv=1.25e-02}', "");
    Expect(0, 73667, '\p{Is_Nv=1.25e-02}', "");
    Expect(1, 73667, '\p{^Is_Nv=1.25e-02}', "");
    Expect(1, 73667, '\P{Is_Nv=1.25e-02}', "");
    Expect(0, 73667, '\P{^Is_Nv=1.25e-02}', "");
    Error('\p{Is_Nv=0.01}');
    Error('\P{Is_Nv=0.01}');
    Expect(1, 73666, '\p{Is_Nv=1.250e-02}', "");
    Expect(0, 73666, '\p{^Is_Nv=1.250e-02}', "");
    Expect(0, 73666, '\P{Is_Nv=1.250e-02}', "");
    Expect(1, 73666, '\P{^Is_Nv=1.250e-02}', "");
    Expect(0, 73667, '\p{Is_Nv=1.250e-02}', "");
    Expect(1, 73667, '\p{^Is_Nv=1.250e-02}', "");
    Expect(1, 73667, '\P{Is_Nv=1.250e-02}', "");
    Expect(0, 73667, '\P{^Is_Nv=1.250e-02}', "");
    Error('\p{Is_Nv=0.013}');
    Error('\P{Is_Nv=0.013}');
    Expect(1, 73666, '\p{Is_Nv=1.2500e-02}', "");
    Expect(0, 73666, '\p{^Is_Nv=1.2500e-02}', "");
    Expect(0, 73666, '\P{Is_Nv=1.2500e-02}', "");
    Expect(1, 73666, '\P{^Is_Nv=1.2500e-02}', "");
    Expect(0, 73667, '\p{Is_Nv=1.2500e-02}', "");
    Expect(1, 73667, '\p{^Is_Nv=1.2500e-02}', "");
    Expect(1, 73667, '\P{Is_Nv=1.2500e-02}', "");
    Expect(0, 73667, '\P{^Is_Nv=1.2500e-02}', "");
    Expect(1, 73666, '\p{Is_Nv=0.0125}', "");
    Expect(0, 73666, '\p{^Is_Nv=0.0125}', "");
    Expect(0, 73666, '\P{Is_Nv=0.0125}', "");
    Expect(1, 73666, '\P{^Is_Nv=0.0125}', "");
    Expect(0, 73667, '\p{Is_Nv=0.0125}', "");
    Expect(1, 73667, '\p{^Is_Nv=0.0125}', "");
    Expect(1, 73667, '\P{Is_Nv=0.0125}', "");
    Expect(0, 73667, '\P{^Is_Nv=0.0125}', "");
    Expect(1, 73666, '\p{Is_Nv:   1.25000e-02}', "");
    Expect(0, 73666, '\p{^Is_Nv:   1.25000e-02}', "");
    Expect(0, 73666, '\P{Is_Nv:   1.25000e-02}', "");
    Expect(1, 73666, '\P{^Is_Nv:   1.25000e-02}', "");
    Expect(0, 73667, '\p{Is_Nv:   1.25000e-02}', "");
    Expect(1, 73667, '\p{^Is_Nv:   1.25000e-02}', "");
    Expect(1, 73667, '\P{Is_Nv:   1.25000e-02}', "");
    Expect(0, 73667, '\P{^Is_Nv:   1.25000e-02}', "");
    Expect(1, 73666, '\p{Is_Nv=0.01250}', "");
    Expect(0, 73666, '\p{^Is_Nv=0.01250}', "");
    Expect(0, 73666, '\P{Is_Nv=0.01250}', "");
    Expect(1, 73666, '\P{^Is_Nv=0.01250}', "");
    Expect(0, 73667, '\p{Is_Nv=0.01250}', "");
    Expect(1, 73667, '\p{^Is_Nv=0.01250}', "");
    Expect(1, 73667, '\P{Is_Nv=0.01250}', "");
    Expect(0, 73667, '\P{^Is_Nv=0.01250}', "");
    Error('\p{Numeric_Value=-_+001/9/a/}');
    Error('\P{Numeric_Value=-_+001/9/a/}');
    Expect(1, 8529, '\p{Numeric_Value=:\A1/9\z:}', "");;
    Expect(0, 8530, '\p{Numeric_Value=:\A1/9\z:}', "");;
    Expect(1, 8529, '\p{Numeric_Value:0000000001/09}', "");
    Expect(0, 8529, '\p{^Numeric_Value:0000000001/09}', "");
    Expect(0, 8529, '\P{Numeric_Value:0000000001/09}', "");
    Expect(1, 8529, '\P{^Numeric_Value:0000000001/09}', "");
    Expect(0, 8530, '\p{Numeric_Value:0000000001/09}', "");
    Expect(1, 8530, '\p{^Numeric_Value:0000000001/09}', "");
    Expect(1, 8530, '\P{Numeric_Value:0000000001/09}', "");
    Expect(0, 8530, '\P{^Numeric_Value:0000000001/09}', "");
    Expect(1, 8529, '\p{Numeric_Value=60/540}', "");
    Expect(0, 8529, '\p{^Numeric_Value=60/540}', "");
    Expect(0, 8529, '\P{Numeric_Value=60/540}', "");
    Expect(1, 8529, '\P{^Numeric_Value=60/540}', "");
    Expect(0, 8530, '\p{Numeric_Value=60/540}', "");
    Expect(1, 8530, '\p{^Numeric_Value=60/540}', "");
    Expect(1, 8530, '\P{Numeric_Value=60/540}', "");
    Expect(0, 8530, '\P{^Numeric_Value=60/540}', "");
    Error('\p{Numeric_Value=1.1e-01}');
    Error('\P{Numeric_Value=1.1e-01}');
    Expect(1, 8529, '\p{Numeric_Value=1.11e-01}', "");
    Expect(0, 8529, '\p{^Numeric_Value=1.11e-01}', "");
    Expect(0, 8529, '\P{Numeric_Value=1.11e-01}', "");
    Expect(1, 8529, '\P{^Numeric_Value=1.11e-01}', "");
    Expect(0, 8530, '\p{Numeric_Value=1.11e-01}', "");
    Expect(1, 8530, '\p{^Numeric_Value=1.11e-01}', "");
    Expect(1, 8530, '\P{Numeric_Value=1.11e-01}', "");
    Expect(0, 8530, '\P{^Numeric_Value=1.11e-01}', "");
    Error('\p{Numeric_Value:0.11}');
    Error('\P{Numeric_Value:0.11}');
    Expect(1, 8529, '\p{Numeric_Value:1.111e-01}', "");
    Expect(0, 8529, '\p{^Numeric_Value:1.111e-01}', "");
    Expect(0, 8529, '\P{Numeric_Value:1.111e-01}', "");
    Expect(1, 8529, '\P{^Numeric_Value:1.111e-01}', "");
    Expect(0, 8530, '\p{Numeric_Value:1.111e-01}', "");
    Expect(1, 8530, '\p{^Numeric_Value:1.111e-01}', "");
    Expect(1, 8530, '\P{Numeric_Value:1.111e-01}', "");
    Expect(0, 8530, '\P{^Numeric_Value:1.111e-01}', "");
    Expect(1, 8529, '\p{Numeric_Value=0.111}', "");
    Expect(0, 8529, '\p{^Numeric_Value=0.111}', "");
    Expect(0, 8529, '\P{Numeric_Value=0.111}', "");
    Expect(1, 8529, '\P{^Numeric_Value=0.111}', "");
    Expect(0, 8530, '\p{Numeric_Value=0.111}', "");
    Expect(1, 8530, '\p{^Numeric_Value=0.111}', "");
    Expect(1, 8530, '\P{Numeric_Value=0.111}', "");
    Expect(0, 8530, '\P{^Numeric_Value=0.111}', "");
    Expect(1, 8529, '\p{Numeric_Value=1.1111e-01}', "");
    Expect(0, 8529, '\p{^Numeric_Value=1.1111e-01}', "");
    Expect(0, 8529, '\P{Numeric_Value=1.1111e-01}', "");
    Expect(1, 8529, '\P{^Numeric_Value=1.1111e-01}', "");
    Expect(0, 8530, '\p{Numeric_Value=1.1111e-01}', "");
    Expect(1, 8530, '\p{^Numeric_Value=1.1111e-01}', "");
    Expect(1, 8530, '\P{Numeric_Value=1.1111e-01}', "");
    Expect(0, 8530, '\P{^Numeric_Value=1.1111e-01}', "");
    Expect(1, 8529, '\p{Numeric_Value=0.1111}', "");
    Expect(0, 8529, '\p{^Numeric_Value=0.1111}', "");
    Expect(0, 8529, '\P{Numeric_Value=0.1111}', "");
    Expect(1, 8529, '\P{^Numeric_Value=0.1111}', "");
    Expect(0, 8530, '\p{Numeric_Value=0.1111}', "");
    Expect(1, 8530, '\p{^Numeric_Value=0.1111}', "");
    Expect(1, 8530, '\P{Numeric_Value=0.1111}', "");
    Expect(0, 8530, '\P{^Numeric_Value=0.1111}', "");
    Error('\p{Nv=/a/0001/00009}');
    Error('\P{Nv=/a/0001/00009}');
    Expect(1, 8529, '\p{Nv=:\A1/9\z:}', "");;
    Expect(0, 8530, '\p{Nv=:\A1/9\z:}', "");;
    Expect(1, 8529, '\p{Nv=+000000001/009}', "");
    Expect(0, 8529, '\p{^Nv=+000000001/009}', "");
    Expect(0, 8529, '\P{Nv=+000000001/009}', "");
    Expect(1, 8529, '\P{^Nv=+000000001/009}', "");
    Expect(0, 8530, '\p{Nv=+000000001/009}', "");
    Expect(1, 8530, '\p{^Nv=+000000001/009}', "");
    Expect(1, 8530, '\P{Nv=+000000001/009}', "");
    Expect(0, 8530, '\P{^Nv=+000000001/009}', "");
    Expect(1, 8529, '\p{Nv:   60/540}', "");
    Expect(0, 8529, '\p{^Nv:   60/540}', "");
    Expect(0, 8529, '\P{Nv:   60/540}', "");
    Expect(1, 8529, '\P{^Nv:   60/540}', "");
    Expect(0, 8530, '\p{Nv:   60/540}', "");
    Expect(1, 8530, '\p{^Nv:   60/540}', "");
    Expect(1, 8530, '\P{Nv:   60/540}', "");
    Expect(0, 8530, '\P{^Nv:   60/540}', "");
    Error('\p{Nv=1.1e-01}');
    Error('\P{Nv=1.1e-01}');
    Expect(1, 8529, '\p{Nv=1.11e-01}', "");
    Expect(0, 8529, '\p{^Nv=1.11e-01}', "");
    Expect(0, 8529, '\P{Nv=1.11e-01}', "");
    Expect(1, 8529, '\P{^Nv=1.11e-01}', "");
    Expect(0, 8530, '\p{Nv=1.11e-01}', "");
    Expect(1, 8530, '\p{^Nv=1.11e-01}', "");
    Expect(1, 8530, '\P{Nv=1.11e-01}', "");
    Expect(0, 8530, '\P{^Nv=1.11e-01}', "");
    Error('\p{Nv:	0.11}');
    Error('\P{Nv:	0.11}');
    Expect(1, 8529, '\p{Nv=1.111e-01}', "");
    Expect(0, 8529, '\p{^Nv=1.111e-01}', "");
    Expect(0, 8529, '\P{Nv=1.111e-01}', "");
    Expect(1, 8529, '\P{^Nv=1.111e-01}', "");
    Expect(0, 8530, '\p{Nv=1.111e-01}', "");
    Expect(1, 8530, '\p{^Nv=1.111e-01}', "");
    Expect(1, 8530, '\P{Nv=1.111e-01}', "");
    Expect(0, 8530, '\P{^Nv=1.111e-01}', "");
    Expect(1, 8529, '\p{Nv=0.111}', "");
    Expect(0, 8529, '\p{^Nv=0.111}', "");
    Expect(0, 8529, '\P{Nv=0.111}', "");
    Expect(1, 8529, '\P{^Nv=0.111}', "");
    Expect(0, 8530, '\p{Nv=0.111}', "");
    Expect(1, 8530, '\p{^Nv=0.111}', "");
    Expect(1, 8530, '\P{Nv=0.111}', "");
    Expect(0, 8530, '\P{^Nv=0.111}', "");
    Expect(1, 8529, '\p{Nv=1.1111e-01}', "");
    Expect(0, 8529, '\p{^Nv=1.1111e-01}', "");
    Expect(0, 8529, '\P{Nv=1.1111e-01}', "");
    Expect(1, 8529, '\P{^Nv=1.1111e-01}', "");
    Expect(0, 8530, '\p{Nv=1.1111e-01}', "");
    Expect(1, 8530, '\p{^Nv=1.1111e-01}', "");
    Expect(1, 8530, '\P{Nv=1.1111e-01}', "");
    Expect(0, 8530, '\P{^Nv=1.1111e-01}', "");
    Expect(1, 8529, '\p{Nv=0.1111}', "");
    Expect(0, 8529, '\p{^Nv=0.1111}', "");
    Expect(0, 8529, '\P{Nv=0.1111}', "");
    Expect(1, 8529, '\P{^Nv=0.1111}', "");
    Expect(0, 8530, '\p{Nv=0.1111}', "");
    Expect(1, 8530, '\p{^Nv=0.1111}', "");
    Expect(1, 8530, '\P{Nv=0.1111}', "");
    Expect(0, 8530, '\P{^Nv=0.1111}', "");
    Error('\p{Is_Numeric_Value=_-1/009:=}');
    Error('\P{Is_Numeric_Value=_-1/009:=}');
    Expect(1, 8529, '\p{Is_Numeric_Value=+0000000001/009}', "");
    Expect(0, 8529, '\p{^Is_Numeric_Value=+0000000001/009}', "");
    Expect(0, 8529, '\P{Is_Numeric_Value=+0000000001/009}', "");
    Expect(1, 8529, '\P{^Is_Numeric_Value=+0000000001/009}', "");
    Expect(0, 8530, '\p{Is_Numeric_Value=+0000000001/009}', "");
    Expect(1, 8530, '\p{^Is_Numeric_Value=+0000000001/009}', "");
    Expect(1, 8530, '\P{Is_Numeric_Value=+0000000001/009}', "");
    Expect(0, 8530, '\P{^Is_Numeric_Value=+0000000001/009}', "");
    Expect(1, 8529, '\p{Is_Numeric_Value=60/540}', "");
    Expect(0, 8529, '\p{^Is_Numeric_Value=60/540}', "");
    Expect(0, 8529, '\P{Is_Numeric_Value=60/540}', "");
    Expect(1, 8529, '\P{^Is_Numeric_Value=60/540}', "");
    Expect(0, 8530, '\p{Is_Numeric_Value=60/540}', "");
    Expect(1, 8530, '\p{^Is_Numeric_Value=60/540}', "");
    Expect(1, 8530, '\P{Is_Numeric_Value=60/540}', "");
    Expect(0, 8530, '\P{^Is_Numeric_Value=60/540}', "");
    Error('\p{Is_Numeric_Value=1.1e-01}');
    Error('\P{Is_Numeric_Value=1.1e-01}');
    Expect(1, 8529, '\p{Is_Numeric_Value=1.11e-01}', "");
    Expect(0, 8529, '\p{^Is_Numeric_Value=1.11e-01}', "");
    Expect(0, 8529, '\P{Is_Numeric_Value=1.11e-01}', "");
    Expect(1, 8529, '\P{^Is_Numeric_Value=1.11e-01}', "");
    Expect(0, 8530, '\p{Is_Numeric_Value=1.11e-01}', "");
    Expect(1, 8530, '\p{^Is_Numeric_Value=1.11e-01}', "");
    Expect(1, 8530, '\P{Is_Numeric_Value=1.11e-01}', "");
    Expect(0, 8530, '\P{^Is_Numeric_Value=1.11e-01}', "");
    Error('\p{Is_Numeric_Value=0.11}');
    Error('\P{Is_Numeric_Value=0.11}');
    Expect(1, 8529, '\p{Is_Numeric_Value=1.111e-01}', "");
    Expect(0, 8529, '\p{^Is_Numeric_Value=1.111e-01}', "");
    Expect(0, 8529, '\P{Is_Numeric_Value=1.111e-01}', "");
    Expect(1, 8529, '\P{^Is_Numeric_Value=1.111e-01}', "");
    Expect(0, 8530, '\p{Is_Numeric_Value=1.111e-01}', "");
    Expect(1, 8530, '\p{^Is_Numeric_Value=1.111e-01}', "");
    Expect(1, 8530, '\P{Is_Numeric_Value=1.111e-01}', "");
    Expect(0, 8530, '\P{^Is_Numeric_Value=1.111e-01}', "");
    Expect(1, 8529, '\p{Is_Numeric_Value=0.111}', "");
    Expect(0, 8529, '\p{^Is_Numeric_Value=0.111}', "");
    Expect(0, 8529, '\P{Is_Numeric_Value=0.111}', "");
    Expect(1, 8529, '\P{^Is_Numeric_Value=0.111}', "");
    Expect(0, 8530, '\p{Is_Numeric_Value=0.111}', "");
    Expect(1, 8530, '\p{^Is_Numeric_Value=0.111}', "");
    Expect(1, 8530, '\P{Is_Numeric_Value=0.111}', "");
    Expect(0, 8530, '\P{^Is_Numeric_Value=0.111}', "");
    Expect(1, 8529, '\p{Is_Numeric_Value: 1.1111e-01}', "");
    Expect(0, 8529, '\p{^Is_Numeric_Value: 1.1111e-01}', "");
    Expect(0, 8529, '\P{Is_Numeric_Value: 1.1111e-01}', "");
    Expect(1, 8529, '\P{^Is_Numeric_Value: 1.1111e-01}', "");
    Expect(0, 8530, '\p{Is_Numeric_Value: 1.1111e-01}', "");
    Expect(1, 8530, '\p{^Is_Numeric_Value: 1.1111e-01}', "");
    Expect(1, 8530, '\P{Is_Numeric_Value: 1.1111e-01}', "");
    Expect(0, 8530, '\P{^Is_Numeric_Value: 1.1111e-01}', "");
    Expect(1, 8529, '\p{Is_Numeric_Value=0.1111}', "");
    Expect(0, 8529, '\p{^Is_Numeric_Value=0.1111}', "");
    Expect(0, 8529, '\P{Is_Numeric_Value=0.1111}', "");
    Expect(1, 8529, '\P{^Is_Numeric_Value=0.1111}', "");
    Expect(0, 8530, '\p{Is_Numeric_Value=0.1111}', "");
    Expect(1, 8530, '\p{^Is_Numeric_Value=0.1111}', "");
    Expect(1, 8530, '\P{Is_Numeric_Value=0.1111}', "");
    Expect(0, 8530, '\P{^Is_Numeric_Value=0.1111}', "");
    Error('\p{Is_Nv=/a/+000001/000000009}');
    Error('\P{Is_Nv=/a/+000001/000000009}');
    Expect(1, 8529, '\p{Is_Nv=+0000001/00009}', "");
    Expect(0, 8529, '\p{^Is_Nv=+0000001/00009}', "");
    Expect(0, 8529, '\P{Is_Nv=+0000001/00009}', "");
    Expect(1, 8529, '\P{^Is_Nv=+0000001/00009}', "");
    Expect(0, 8530, '\p{Is_Nv=+0000001/00009}', "");
    Expect(1, 8530, '\p{^Is_Nv=+0000001/00009}', "");
    Expect(1, 8530, '\P{Is_Nv=+0000001/00009}', "");
    Expect(0, 8530, '\P{^Is_Nv=+0000001/00009}', "");
    Expect(1, 8529, '\p{Is_Nv=60/540}', "");
    Expect(0, 8529, '\p{^Is_Nv=60/540}', "");
    Expect(0, 8529, '\P{Is_Nv=60/540}', "");
    Expect(1, 8529, '\P{^Is_Nv=60/540}', "");
    Expect(0, 8530, '\p{Is_Nv=60/540}', "");
    Expect(1, 8530, '\p{^Is_Nv=60/540}', "");
    Expect(1, 8530, '\P{Is_Nv=60/540}', "");
    Expect(0, 8530, '\P{^Is_Nv=60/540}', "");
    Error('\p{Is_Nv=1.1e-01}');
    Error('\P{Is_Nv=1.1e-01}');
    Expect(1, 8529, '\p{Is_Nv=1.11e-01}', "");
    Expect(0, 8529, '\p{^Is_Nv=1.11e-01}', "");
    Expect(0, 8529, '\P{Is_Nv=1.11e-01}', "");
    Expect(1, 8529, '\P{^Is_Nv=1.11e-01}', "");
    Expect(0, 8530, '\p{Is_Nv=1.11e-01}', "");
    Expect(1, 8530, '\p{^Is_Nv=1.11e-01}', "");
    Expect(1, 8530, '\P{Is_Nv=1.11e-01}', "");
    Expect(0, 8530, '\P{^Is_Nv=1.11e-01}', "");
    Error('\p{Is_Nv=0.11}');
    Error('\P{Is_Nv=0.11}');
    Expect(1, 8529, '\p{Is_Nv=1.111e-01}', "");
    Expect(0, 8529, '\p{^Is_Nv=1.111e-01}', "");
    Expect(0, 8529, '\P{Is_Nv=1.111e-01}', "");
    Expect(1, 8529, '\P{^Is_Nv=1.111e-01}', "");
    Expect(0, 8530, '\p{Is_Nv=1.111e-01}', "");
    Expect(1, 8530, '\p{^Is_Nv=1.111e-01}', "");
    Expect(1, 8530, '\P{Is_Nv=1.111e-01}', "");
    Expect(0, 8530, '\P{^Is_Nv=1.111e-01}', "");
    Expect(1, 8529, '\p{Is_Nv=0.111}', "");
    Expect(0, 8529, '\p{^Is_Nv=0.111}', "");
    Expect(0, 8529, '\P{Is_Nv=0.111}', "");
    Expect(1, 8529, '\P{^Is_Nv=0.111}', "");
    Expect(0, 8530, '\p{Is_Nv=0.111}', "");
    Expect(1, 8530, '\p{^Is_Nv=0.111}', "");
    Expect(1, 8530, '\P{Is_Nv=0.111}', "");
    Expect(0, 8530, '\P{^Is_Nv=0.111}', "");
    Expect(1, 8529, '\p{Is_Nv=1.1111e-01}', "");
    Expect(0, 8529, '\p{^Is_Nv=1.1111e-01}', "");
    Expect(0, 8529, '\P{Is_Nv=1.1111e-01}', "");
    Expect(1, 8529, '\P{^Is_Nv=1.1111e-01}', "");
    Expect(0, 8530, '\p{Is_Nv=1.1111e-01}', "");
    Expect(1, 8530, '\p{^Is_Nv=1.1111e-01}', "");
    Expect(1, 8530, '\P{Is_Nv=1.1111e-01}', "");
    Expect(0, 8530, '\P{^Is_Nv=1.1111e-01}', "");
    Expect(1, 8529, '\p{Is_Nv=0.1111}', "");
    Expect(0, 8529, '\p{^Is_Nv=0.1111}', "");
    Expect(0, 8529, '\P{Is_Nv=0.1111}', "");
    Expect(1, 8529, '\P{^Is_Nv=0.1111}', "");
    Expect(0, 8530, '\p{Is_Nv=0.1111}', "");
    Expect(1, 8530, '\p{^Is_Nv=0.1111}', "");
    Expect(1, 8530, '\P{Is_Nv=0.1111}', "");
    Expect(0, 8530, '\P{^Is_Nv=0.1111}', "");
    Error('\p{Numeric_Value:	-:=010}');
    Error('\P{Numeric_Value:	-:=010}');
    Expect(1, 126263, '\p{Numeric_Value=:\A10\z:}', "");;
    Expect(0, 126264, '\p{Numeric_Value=:\A10\z:}', "");;
    Expect(1, 126263, '\p{Numeric_Value=+001_0}', "");
    Expect(0, 126263, '\p{^Numeric_Value=+001_0}', "");
    Expect(0, 126263, '\P{Numeric_Value=+001_0}', "");
    Expect(1, 126263, '\P{^Numeric_Value=+001_0}', "");
    Expect(0, 126264, '\p{Numeric_Value=+001_0}', "");
    Expect(1, 126264, '\p{^Numeric_Value=+001_0}', "");
    Expect(1, 126264, '\P{Numeric_Value=+001_0}', "");
    Expect(0, 126264, '\P{^Numeric_Value=+001_0}', "");
    Expect(1, 126263, '\p{Numeric_Value:	1.000000000000000e+01}', "");
    Expect(0, 126263, '\p{^Numeric_Value:	1.000000000000000e+01}', "");
    Expect(0, 126263, '\P{Numeric_Value:	1.000000000000000e+01}', "");
    Expect(1, 126263, '\P{^Numeric_Value:	1.000000000000000e+01}', "");
    Expect(0, 126264, '\p{Numeric_Value:	1.000000000000000e+01}', "");
    Expect(1, 126264, '\p{^Numeric_Value:	1.000000000000000e+01}', "");
    Expect(1, 126264, '\P{Numeric_Value:	1.000000000000000e+01}', "");
    Expect(0, 126264, '\P{^Numeric_Value:	1.000000000000000e+01}', "");
    Error('\p{Nv=:= 	00000000010}');
    Error('\P{Nv=:= 	00000000010}');
    Expect(1, 126263, '\p{Nv=:\A10\z:}', "");;
    Expect(0, 126264, '\p{Nv=:\A10\z:}', "");;
    Expect(1, 126263, '\p{Nv=0000000010}', "");
    Expect(0, 126263, '\p{^Nv=0000000010}', "");
    Expect(0, 126263, '\P{Nv=0000000010}', "");
    Expect(1, 126263, '\P{^Nv=0000000010}', "");
    Expect(0, 126264, '\p{Nv=0000000010}', "");
    Expect(1, 126264, '\p{^Nv=0000000010}', "");
    Expect(1, 126264, '\P{Nv=0000000010}', "");
    Expect(0, 126264, '\P{^Nv=0000000010}', "");
    Expect(1, 126263, '\p{Nv=1.000000000000000e+01}', "");
    Expect(0, 126263, '\p{^Nv=1.000000000000000e+01}', "");
    Expect(0, 126263, '\P{Nv=1.000000000000000e+01}', "");
    Expect(1, 126263, '\P{^Nv=1.000000000000000e+01}', "");
    Expect(0, 126264, '\p{Nv=1.000000000000000e+01}', "");
    Expect(1, 126264, '\p{^Nv=1.000000000000000e+01}', "");
    Expect(1, 126264, '\P{Nv=1.000000000000000e+01}', "");
    Expect(0, 126264, '\P{^Nv=1.000000000000000e+01}', "");
    Error('\p{Is_Numeric_Value=:= 	010}');
    Error('\P{Is_Numeric_Value=:= 	010}');
    Expect(1, 126263, '\p{Is_Numeric_Value=0_0_0_0_010}', "");
    Expect(0, 126263, '\p{^Is_Numeric_Value=0_0_0_0_010}', "");
    Expect(0, 126263, '\P{Is_Numeric_Value=0_0_0_0_010}', "");
    Expect(1, 126263, '\P{^Is_Numeric_Value=0_0_0_0_010}', "");
    Expect(0, 126264, '\p{Is_Numeric_Value=0_0_0_0_010}', "");
    Expect(1, 126264, '\p{^Is_Numeric_Value=0_0_0_0_010}', "");
    Expect(1, 126264, '\P{Is_Numeric_Value=0_0_0_0_010}', "");
    Expect(0, 126264, '\P{^Is_Numeric_Value=0_0_0_0_010}', "");
    Expect(1, 126263, '\p{Is_Numeric_Value=1.000000000000000e+01}', "");
    Expect(0, 126263, '\p{^Is_Numeric_Value=1.000000000000000e+01}', "");
    Expect(0, 126263, '\P{Is_Numeric_Value=1.000000000000000e+01}', "");
    Expect(1, 126263, '\P{^Is_Numeric_Value=1.000000000000000e+01}', "");
    Expect(0, 126264, '\p{Is_Numeric_Value=1.000000000000000e+01}', "");
    Expect(1, 126264, '\p{^Is_Numeric_Value=1.000000000000000e+01}', "");
    Expect(1, 126264, '\P{Is_Numeric_Value=1.000000000000000e+01}', "");
    Expect(0, 126264, '\P{^Is_Numeric_Value=1.000000000000000e+01}', "");
    Error('\p{Is_Nv=-:=10}');
    Error('\P{Is_Nv=-:=10}');
    Expect(1, 126263, '\p{Is_Nv=001_0}', "");
    Expect(0, 126263, '\p{^Is_Nv=001_0}', "");
    Expect(0, 126263, '\P{Is_Nv=001_0}', "");
    Expect(1, 126263, '\P{^Is_Nv=001_0}', "");
    Expect(0, 126264, '\p{Is_Nv=001_0}', "");
    Expect(1, 126264, '\p{^Is_Nv=001_0}', "");
    Expect(1, 126264, '\P{Is_Nv=001_0}', "");
    Expect(0, 126264, '\P{^Is_Nv=001_0}', "");
    Expect(1, 126263, '\p{Is_Nv=1.000000000000000e+01}', "");
    Expect(0, 126263, '\p{^Is_Nv=1.000000000000000e+01}', "");
    Expect(0, 126263, '\P{Is_Nv=1.000000000000000e+01}', "");
    Expect(1, 126263, '\P{^Is_Nv=1.000000000000000e+01}', "");
    Expect(0, 126264, '\p{Is_Nv=1.000000000000000e+01}', "");
    Expect(1, 126264, '\p{^Is_Nv=1.000000000000000e+01}', "");
    Expect(1, 126264, '\P{Is_Nv=1.000000000000000e+01}', "");
    Expect(0, 126264, '\P{^Is_Nv=1.000000000000000e+01}', "");
    Error('\p{Numeric_Value::=_-10_0}');
    Error('\P{Numeric_Value::=_-10_0}');
    Expect(1, 126227, '\p{Numeric_Value=:\A100\z:}', "");;
    Expect(0, 126228, '\p{Numeric_Value=:\A100\z:}', "");;
    Expect(1, 126227, '\p{Numeric_Value=+10_0}', "");
    Expect(0, 126227, '\p{^Numeric_Value=+10_0}', "");
    Expect(0, 126227, '\P{Numeric_Value=+10_0}', "");
    Expect(1, 126227, '\P{^Numeric_Value=+10_0}', "");
    Expect(0, 126228, '\p{Numeric_Value=+10_0}', "");
    Expect(1, 126228, '\p{^Numeric_Value=+10_0}', "");
    Expect(1, 126228, '\P{Numeric_Value=+10_0}', "");
    Expect(0, 126228, '\P{^Numeric_Value=+10_0}', "");
    Expect(1, 126227, '\p{Numeric_Value=1.000000000000000e+02}', "");
    Expect(0, 126227, '\p{^Numeric_Value=1.000000000000000e+02}', "");
    Expect(0, 126227, '\P{Numeric_Value=1.000000000000000e+02}', "");
    Expect(1, 126227, '\P{^Numeric_Value=1.000000000000000e+02}', "");
    Expect(0, 126228, '\p{Numeric_Value=1.000000000000000e+02}', "");
    Expect(1, 126228, '\p{^Numeric_Value=1.000000000000000e+02}', "");
    Expect(1, 126228, '\P{Numeric_Value=1.000000000000000e+02}', "");
    Expect(0, 126228, '\P{^Numeric_Value=1.000000000000000e+02}', "");
    Error('\p{Nv=_:=100}');
    Error('\P{Nv=_:=100}');
    Expect(1, 126227, '\p{Nv=:\A100\z:}', "");;
    Expect(0, 126228, '\p{Nv=:\A100\z:}', "");;
    Expect(1, 126227, '\p{Nv:	00000000100}', "");
    Expect(0, 126227, '\p{^Nv:	00000000100}', "");
    Expect(0, 126227, '\P{Nv:	00000000100}', "");
    Expect(1, 126227, '\P{^Nv:	00000000100}', "");
    Expect(0, 126228, '\p{Nv:	00000000100}', "");
    Expect(1, 126228, '\p{^Nv:	00000000100}', "");
    Expect(1, 126228, '\P{Nv:	00000000100}', "");
    Expect(0, 126228, '\P{^Nv:	00000000100}', "");
    Expect(1, 126227, '\p{Nv=1.000000000000000e+02}', "");
    Expect(0, 126227, '\p{^Nv=1.000000000000000e+02}', "");
    Expect(0, 126227, '\P{Nv=1.000000000000000e+02}', "");
    Expect(1, 126227, '\P{^Nv=1.000000000000000e+02}', "");
    Expect(0, 126228, '\p{Nv=1.000000000000000e+02}', "");
    Expect(1, 126228, '\p{^Nv=1.000000000000000e+02}', "");
    Expect(1, 126228, '\P{Nv=1.000000000000000e+02}', "");
    Expect(0, 126228, '\P{^Nv=1.000000000000000e+02}', "");
    Error('\p{Is_Numeric_Value= :=10_0}');
    Error('\P{Is_Numeric_Value= :=10_0}');
    Expect(1, 126227, '\p{Is_Numeric_Value=00_01_00}', "");
    Expect(0, 126227, '\p{^Is_Numeric_Value=00_01_00}', "");
    Expect(0, 126227, '\P{Is_Numeric_Value=00_01_00}', "");
    Expect(1, 126227, '\P{^Is_Numeric_Value=00_01_00}', "");
    Expect(0, 126228, '\p{Is_Numeric_Value=00_01_00}', "");
    Expect(1, 126228, '\p{^Is_Numeric_Value=00_01_00}', "");
    Expect(1, 126228, '\P{Is_Numeric_Value=00_01_00}', "");
    Expect(0, 126228, '\P{^Is_Numeric_Value=00_01_00}', "");
    Expect(1, 126227, '\p{Is_Numeric_Value=1.000000000000000e+02}', "");
    Expect(0, 126227, '\p{^Is_Numeric_Value=1.000000000000000e+02}', "");
    Expect(0, 126227, '\P{Is_Numeric_Value=1.000000000000000e+02}', "");
    Expect(1, 126227, '\P{^Is_Numeric_Value=1.000000000000000e+02}', "");
    Expect(0, 126228, '\p{Is_Numeric_Value=1.000000000000000e+02}', "");
    Expect(1, 126228, '\p{^Is_Numeric_Value=1.000000000000000e+02}', "");
    Expect(1, 126228, '\P{Is_Numeric_Value=1.000000000000000e+02}', "");
    Expect(0, 126228, '\P{^Is_Numeric_Value=1.000000000000000e+02}', "");
    Error('\p{Is_Nv=:=- +0_0_0_0_0_0_0_00100}');
    Error('\P{Is_Nv=:=- +0_0_0_0_0_0_0_00100}');
    Expect(1, 126227, '\p{Is_Nv: 00000100}', "");
    Expect(0, 126227, '\p{^Is_Nv: 00000100}', "");
    Expect(0, 126227, '\P{Is_Nv: 00000100}', "");
    Expect(1, 126227, '\P{^Is_Nv: 00000100}', "");
    Expect(0, 126228, '\p{Is_Nv: 00000100}', "");
    Expect(1, 126228, '\p{^Is_Nv: 00000100}', "");
    Expect(1, 126228, '\P{Is_Nv: 00000100}', "");
    Expect(0, 126228, '\P{^Is_Nv: 00000100}', "");
    Expect(1, 126227, '\p{Is_Nv=1.000000000000000e+02}', "");
    Expect(0, 126227, '\p{^Is_Nv=1.000000000000000e+02}', "");
    Expect(0, 126227, '\P{Is_Nv=1.000000000000000e+02}', "");
    Expect(1, 126227, '\P{^Is_Nv=1.000000000000000e+02}', "");
    Expect(0, 126228, '\p{Is_Nv=1.000000000000000e+02}', "");
    Expect(1, 126228, '\p{^Is_Nv=1.000000000000000e+02}', "");
    Expect(1, 126228, '\P{Is_Nv=1.000000000000000e+02}', "");
    Expect(0, 126228, '\P{^Is_Nv=1.000000000000000e+02}', "");
    Error('\p{Numeric_Value= /a/+000001000}');
    Error('\P{Numeric_Value= /a/+000001000}');
    Expect(1, 126236, '\p{Numeric_Value=:\A1000\z:}', "");;
    Expect(0, 126237, '\p{Numeric_Value=:\A1000\z:}', "");;
    Expect(1, 126236, '\p{Numeric_Value=0001000}', "");
    Expect(0, 126236, '\p{^Numeric_Value=0001000}', "");
    Expect(0, 126236, '\P{Numeric_Value=0001000}', "");
    Expect(1, 126236, '\P{^Numeric_Value=0001000}', "");
    Expect(0, 126237, '\p{Numeric_Value=0001000}', "");
    Expect(1, 126237, '\p{^Numeric_Value=0001000}', "");
    Expect(1, 126237, '\P{Numeric_Value=0001000}', "");
    Expect(0, 126237, '\P{^Numeric_Value=0001000}', "");
    Expect(1, 126236, '\p{Numeric_Value=1.000000000000000e+03}', "");
    Expect(0, 126236, '\p{^Numeric_Value=1.000000000000000e+03}', "");
    Expect(0, 126236, '\P{Numeric_Value=1.000000000000000e+03}', "");
    Expect(1, 126236, '\P{^Numeric_Value=1.000000000000000e+03}', "");
    Expect(0, 126237, '\p{Numeric_Value=1.000000000000000e+03}', "");
    Expect(1, 126237, '\p{^Numeric_Value=1.000000000000000e+03}', "");
    Expect(1, 126237, '\P{Numeric_Value=1.000000000000000e+03}', "");
    Expect(0, 126237, '\P{^Numeric_Value=1.000000000000000e+03}', "");
    Error('\p{Nv=-0_0_0_0_0_0_0_0_0_1_0_00/a/}');
    Error('\P{Nv=-0_0_0_0_0_0_0_0_0_1_0_00/a/}');
    Expect(1, 126236, '\p{Nv=:\A1000\z:}', "");;
    Expect(0, 126237, '\p{Nv=:\A1000\z:}', "");;
    Expect(1, 126236, '\p{Nv=00_00_01_000}', "");
    Expect(0, 126236, '\p{^Nv=00_00_01_000}', "");
    Expect(0, 126236, '\P{Nv=00_00_01_000}', "");
    Expect(1, 126236, '\P{^Nv=00_00_01_000}', "");
    Expect(0, 126237, '\p{Nv=00_00_01_000}', "");
    Expect(1, 126237, '\p{^Nv=00_00_01_000}', "");
    Expect(1, 126237, '\P{Nv=00_00_01_000}', "");
    Expect(0, 126237, '\P{^Nv=00_00_01_000}', "");
    Expect(1, 126236, '\p{Nv=1.000000000000000e+03}', "");
    Expect(0, 126236, '\p{^Nv=1.000000000000000e+03}', "");
    Expect(0, 126236, '\P{Nv=1.000000000000000e+03}', "");
    Expect(1, 126236, '\P{^Nv=1.000000000000000e+03}', "");
    Expect(0, 126237, '\p{Nv=1.000000000000000e+03}', "");
    Expect(1, 126237, '\p{^Nv=1.000000000000000e+03}', "");
    Expect(1, 126237, '\P{Nv=1.000000000000000e+03}', "");
    Expect(0, 126237, '\P{^Nv=1.000000000000000e+03}', "");
    Error('\p{Is_Numeric_Value=:=0_0_1_0_00}');
    Error('\P{Is_Numeric_Value=:=0_0_1_0_00}');
    Expect(1, 126236, '\p{Is_Numeric_Value=00_00_00_00_01_00_0}', "");
    Expect(0, 126236, '\p{^Is_Numeric_Value=00_00_00_00_01_00_0}', "");
    Expect(0, 126236, '\P{Is_Numeric_Value=00_00_00_00_01_00_0}', "");
    Expect(1, 126236, '\P{^Is_Numeric_Value=00_00_00_00_01_00_0}', "");
    Expect(0, 126237, '\p{Is_Numeric_Value=00_00_00_00_01_00_0}', "");
    Expect(1, 126237, '\p{^Is_Numeric_Value=00_00_00_00_01_00_0}', "");
    Expect(1, 126237, '\P{Is_Numeric_Value=00_00_00_00_01_00_0}', "");
    Expect(0, 126237, '\P{^Is_Numeric_Value=00_00_00_00_01_00_0}', "");
    Expect(1, 126236, '\p{Is_Numeric_Value:   1.000000000000000e+03}', "");
    Expect(0, 126236, '\p{^Is_Numeric_Value:   1.000000000000000e+03}', "");
    Expect(0, 126236, '\P{Is_Numeric_Value:   1.000000000000000e+03}', "");
    Expect(1, 126236, '\P{^Is_Numeric_Value:   1.000000000000000e+03}', "");
    Expect(0, 126237, '\p{Is_Numeric_Value:   1.000000000000000e+03}', "");
    Expect(1, 126237, '\p{^Is_Numeric_Value:   1.000000000000000e+03}', "");
    Expect(1, 126237, '\P{Is_Numeric_Value:   1.000000000000000e+03}', "");
    Expect(0, 126237, '\P{^Is_Numeric_Value:   1.000000000000000e+03}', "");
    Error('\p{Is_Nv= :=000_010_00}');
    Error('\P{Is_Nv= :=000_010_00}');
    Expect(1, 126236, '\p{Is_Nv=1_0_00}', "");
    Expect(0, 126236, '\p{^Is_Nv=1_0_00}', "");
    Expect(0, 126236, '\P{Is_Nv=1_0_00}', "");
    Expect(1, 126236, '\P{^Is_Nv=1_0_00}', "");
    Expect(0, 126237, '\p{Is_Nv=1_0_00}', "");
    Expect(1, 126237, '\p{^Is_Nv=1_0_00}', "");
    Expect(1, 126237, '\P{Is_Nv=1_0_00}', "");
    Expect(0, 126237, '\P{^Is_Nv=1_0_00}', "");
    Expect(1, 126236, '\p{Is_Nv=1.000000000000000e+03}', "");
    Expect(0, 126236, '\p{^Is_Nv=1.000000000000000e+03}', "");
    Expect(0, 126236, '\P{Is_Nv=1.000000000000000e+03}', "");
    Expect(1, 126236, '\P{^Is_Nv=1.000000000000000e+03}', "");
    Expect(0, 126237, '\p{Is_Nv=1.000000000000000e+03}', "");
    Expect(1, 126237, '\p{^Is_Nv=1.000000000000000e+03}', "");
    Expect(1, 126237, '\P{Is_Nv=1.000000000000000e+03}', "");
    Expect(0, 126237, '\P{^Is_Nv=1.000000000000000e+03}', "");
    Error('\p{Numeric_Value:_0_0_0_0_1_0_000:=}');
    Error('\P{Numeric_Value:_0_0_0_0_1_0_000:=}');
    Expect(1, 126267, '\p{Numeric_Value=:\A10000\z:}', "");;
    Expect(0, 126268, '\p{Numeric_Value=:\A10000\z:}', "");;
    Expect(1, 126267, '\p{Numeric_Value=01000_0}', "");
    Expect(0, 126267, '\p{^Numeric_Value=01000_0}', "");
    Expect(0, 126267, '\P{Numeric_Value=01000_0}', "");
    Expect(1, 126267, '\P{^Numeric_Value=01000_0}', "");
    Expect(0, 126268, '\p{Numeric_Value=01000_0}', "");
    Expect(1, 126268, '\p{^Numeric_Value=01000_0}', "");
    Expect(1, 126268, '\P{Numeric_Value=01000_0}', "");
    Expect(0, 126268, '\P{^Numeric_Value=01000_0}', "");
    Expect(1, 126267, '\p{Numeric_Value=1.000000000000000e+04}', "");
    Expect(0, 126267, '\p{^Numeric_Value=1.000000000000000e+04}', "");
    Expect(0, 126267, '\P{Numeric_Value=1.000000000000000e+04}', "");
    Expect(1, 126267, '\P{^Numeric_Value=1.000000000000000e+04}', "");
    Expect(0, 126268, '\p{Numeric_Value=1.000000000000000e+04}', "");
    Expect(1, 126268, '\p{^Numeric_Value=1.000000000000000e+04}', "");
    Expect(1, 126268, '\P{Numeric_Value=1.000000000000000e+04}', "");
    Expect(0, 126268, '\P{^Numeric_Value=1.000000000000000e+04}', "");
    Error('\p{Nv=/a/	-+0_1_0_0_00}');
    Error('\P{Nv=/a/	-+0_1_0_0_00}');
    Expect(1, 126267, '\p{Nv=:\A10000\z:}', "");;
    Expect(0, 126268, '\p{Nv=:\A10000\z:}', "");;
    Expect(1, 126267, '\p{Nv=+00_00_10_00_0}', "");
    Expect(0, 126267, '\p{^Nv=+00_00_10_00_0}', "");
    Expect(0, 126267, '\P{Nv=+00_00_10_00_0}', "");
    Expect(1, 126267, '\P{^Nv=+00_00_10_00_0}', "");
    Expect(0, 126268, '\p{Nv=+00_00_10_00_0}', "");
    Expect(1, 126268, '\p{^Nv=+00_00_10_00_0}', "");
    Expect(1, 126268, '\P{Nv=+00_00_10_00_0}', "");
    Expect(0, 126268, '\P{^Nv=+00_00_10_00_0}', "");
    Expect(1, 126267, '\p{Nv=1.000000000000000e+04}', "");
    Expect(0, 126267, '\p{^Nv=1.000000000000000e+04}', "");
    Expect(0, 126267, '\P{Nv=1.000000000000000e+04}', "");
    Expect(1, 126267, '\P{^Nv=1.000000000000000e+04}', "");
    Expect(0, 126268, '\p{Nv=1.000000000000000e+04}', "");
    Expect(1, 126268, '\p{^Nv=1.000000000000000e+04}', "");
    Expect(1, 126268, '\P{Nv=1.000000000000000e+04}', "");
    Expect(0, 126268, '\P{^Nv=1.000000000000000e+04}', "");
    Error('\p{Is_Numeric_Value=/a/_	00000010000}');
    Error('\P{Is_Numeric_Value=/a/_	00000010000}');
    Expect(1, 126267, '\p{Is_Numeric_Value=00_00_00_00_10_00_0}', "");
    Expect(0, 126267, '\p{^Is_Numeric_Value=00_00_00_00_10_00_0}', "");
    Expect(0, 126267, '\P{Is_Numeric_Value=00_00_00_00_10_00_0}', "");
    Expect(1, 126267, '\P{^Is_Numeric_Value=00_00_00_00_10_00_0}', "");
    Expect(0, 126268, '\p{Is_Numeric_Value=00_00_00_00_10_00_0}', "");
    Expect(1, 126268, '\p{^Is_Numeric_Value=00_00_00_00_10_00_0}', "");
    Expect(1, 126268, '\P{Is_Numeric_Value=00_00_00_00_10_00_0}', "");
    Expect(0, 126268, '\P{^Is_Numeric_Value=00_00_00_00_10_00_0}', "");
    Expect(1, 126267, '\p{Is_Numeric_Value=1.000000000000000e+04}', "");
    Expect(0, 126267, '\p{^Is_Numeric_Value=1.000000000000000e+04}', "");
    Expect(0, 126267, '\P{Is_Numeric_Value=1.000000000000000e+04}', "");
    Expect(1, 126267, '\P{^Is_Numeric_Value=1.000000000000000e+04}', "");
    Expect(0, 126268, '\p{Is_Numeric_Value=1.000000000000000e+04}', "");
    Expect(1, 126268, '\p{^Is_Numeric_Value=1.000000000000000e+04}', "");
    Expect(1, 126268, '\P{Is_Numeric_Value=1.000000000000000e+04}', "");
    Expect(0, 126268, '\P{^Is_Numeric_Value=1.000000000000000e+04}', "");
    Error('\p{Is_Nv=_-+1_0_0_00/a/}');
    Error('\P{Is_Nv=_-+1_0_0_00/a/}');
    Expect(1, 126267, '\p{Is_Nv=000000010000}', "");
    Expect(0, 126267, '\p{^Is_Nv=000000010000}', "");
    Expect(0, 126267, '\P{Is_Nv=000000010000}', "");
    Expect(1, 126267, '\P{^Is_Nv=000000010000}', "");
    Expect(0, 126268, '\p{Is_Nv=000000010000}', "");
    Expect(1, 126268, '\p{^Is_Nv=000000010000}', "");
    Expect(1, 126268, '\P{Is_Nv=000000010000}', "");
    Expect(0, 126268, '\P{^Is_Nv=000000010000}', "");
    Expect(1, 126267, '\p{Is_Nv=1.000000000000000e+04}', "");
    Expect(0, 126267, '\p{^Is_Nv=1.000000000000000e+04}', "");
    Expect(0, 126267, '\P{Is_Nv=1.000000000000000e+04}', "");
    Expect(1, 126267, '\P{^Is_Nv=1.000000000000000e+04}', "");
    Expect(0, 126268, '\p{Is_Nv=1.000000000000000e+04}', "");
    Expect(1, 126268, '\p{^Is_Nv=1.000000000000000e+04}', "");
    Expect(1, 126268, '\P{Is_Nv=1.000000000000000e+04}', "");
    Expect(0, 126268, '\P{^Is_Nv=1.000000000000000e+04}', "");
    Error('\p{Numeric_Value=/a/	 +0000100000}');
    Error('\P{Numeric_Value=/a/	 +0000100000}');
    Expect(1, 126132, '\p{Numeric_Value=:\A100000\z:}', "");;
    Expect(0, 126133, '\p{Numeric_Value=:\A100000\z:}', "");;
    Expect(1, 126132, '\p{Numeric_Value=+1_0_0_0_00}', "");
    Expect(0, 126132, '\p{^Numeric_Value=+1_0_0_0_00}', "");
    Expect(0, 126132, '\P{Numeric_Value=+1_0_0_0_00}', "");
    Expect(1, 126132, '\P{^Numeric_Value=+1_0_0_0_00}', "");
    Expect(0, 126133, '\p{Numeric_Value=+1_0_0_0_00}', "");
    Expect(1, 126133, '\p{^Numeric_Value=+1_0_0_0_00}', "");
    Expect(1, 126133, '\P{Numeric_Value=+1_0_0_0_00}', "");
    Expect(0, 126133, '\P{^Numeric_Value=+1_0_0_0_00}', "");
    Expect(1, 126132, '\p{Numeric_Value=1.000000000000000e+05}', "");
    Expect(0, 126132, '\p{^Numeric_Value=1.000000000000000e+05}', "");
    Expect(0, 126132, '\P{Numeric_Value=1.000000000000000e+05}', "");
    Expect(1, 126132, '\P{^Numeric_Value=1.000000000000000e+05}', "");
    Expect(0, 126133, '\p{Numeric_Value=1.000000000000000e+05}', "");
    Expect(1, 126133, '\p{^Numeric_Value=1.000000000000000e+05}', "");
    Expect(1, 126133, '\P{Numeric_Value=1.000000000000000e+05}', "");
    Expect(0, 126133, '\P{^Numeric_Value=1.000000000000000e+05}', "");
    Error('\p{Nv=+00100000/a/}');
    Error('\P{Nv=+00100000/a/}');
    Expect(1, 126132, '\p{Nv=:\A100000\z:}', "");;
    Expect(0, 126133, '\p{Nv=:\A100000\z:}', "");;
    Expect(1, 126132, '\p{Nv=100000}', "");
    Expect(0, 126132, '\p{^Nv=100000}', "");
    Expect(0, 126132, '\P{Nv=100000}', "");
    Expect(1, 126132, '\P{^Nv=100000}', "");
    Expect(0, 126133, '\p{Nv=100000}', "");
    Expect(1, 126133, '\p{^Nv=100000}', "");
    Expect(1, 126133, '\P{Nv=100000}', "");
    Expect(0, 126133, '\P{^Nv=100000}', "");
    Expect(1, 126132, '\p{Nv=1.000000000000000e+05}', "");
    Expect(0, 126132, '\p{^Nv=1.000000000000000e+05}', "");
    Expect(0, 126132, '\P{Nv=1.000000000000000e+05}', "");
    Expect(1, 126132, '\P{^Nv=1.000000000000000e+05}', "");
    Expect(0, 126133, '\p{Nv=1.000000000000000e+05}', "");
    Expect(1, 126133, '\p{^Nv=1.000000000000000e+05}', "");
    Expect(1, 126133, '\P{Nv=1.000000000000000e+05}', "");
    Expect(0, 126133, '\P{^Nv=1.000000000000000e+05}', "");
    Error('\p{Is_Numeric_Value=-_0_0_0_0_0_1_0_0_000/a/}');
    Error('\P{Is_Numeric_Value=-_0_0_0_0_0_1_0_0_000/a/}');
    Expect(1, 126132, '\p{Is_Numeric_Value=0_0_0_0_0_1_0_0_000}', "");
    Expect(0, 126132, '\p{^Is_Numeric_Value=0_0_0_0_0_1_0_0_000}', "");
    Expect(0, 126132, '\P{Is_Numeric_Value=0_0_0_0_0_1_0_0_000}', "");
    Expect(1, 126132, '\P{^Is_Numeric_Value=0_0_0_0_0_1_0_0_000}', "");
    Expect(0, 126133, '\p{Is_Numeric_Value=0_0_0_0_0_1_0_0_000}', "");
    Expect(1, 126133, '\p{^Is_Numeric_Value=0_0_0_0_0_1_0_0_000}', "");
    Expect(1, 126133, '\P{Is_Numeric_Value=0_0_0_0_0_1_0_0_000}', "");
    Expect(0, 126133, '\P{^Is_Numeric_Value=0_0_0_0_0_1_0_0_000}', "");
    Expect(1, 126132, '\p{Is_Numeric_Value=1.000000000000000e+05}', "");
    Expect(0, 126132, '\p{^Is_Numeric_Value=1.000000000000000e+05}', "");
    Expect(0, 126132, '\P{Is_Numeric_Value=1.000000000000000e+05}', "");
    Expect(1, 126132, '\P{^Is_Numeric_Value=1.000000000000000e+05}', "");
    Expect(0, 126133, '\p{Is_Numeric_Value=1.000000000000000e+05}', "");
    Expect(1, 126133, '\p{^Is_Numeric_Value=1.000000000000000e+05}', "");
    Expect(1, 126133, '\P{Is_Numeric_Value=1.000000000000000e+05}', "");
    Expect(0, 126133, '\P{^Is_Numeric_Value=1.000000000000000e+05}', "");
    Error('\p{Is_Nv= /a/00_01_00_00_0}');
    Error('\P{Is_Nv= /a/00_01_00_00_0}');
    Expect(1, 126132, '\p{Is_Nv=0100000}', "");
    Expect(0, 126132, '\p{^Is_Nv=0100000}', "");
    Expect(0, 126132, '\P{Is_Nv=0100000}', "");
    Expect(1, 126132, '\P{^Is_Nv=0100000}', "");
    Expect(0, 126133, '\p{Is_Nv=0100000}', "");
    Expect(1, 126133, '\p{^Is_Nv=0100000}', "");
    Expect(1, 126133, '\P{Is_Nv=0100000}', "");
    Expect(0, 126133, '\P{^Is_Nv=0100000}', "");
    Expect(1, 126132, '\p{Is_Nv=1.000000000000000e+05}', "");
    Expect(0, 126132, '\p{^Is_Nv=1.000000000000000e+05}', "");
    Expect(0, 126132, '\P{Is_Nv=1.000000000000000e+05}', "");
    Expect(1, 126132, '\P{^Is_Nv=1.000000000000000e+05}', "");
    Expect(0, 126133, '\p{Is_Nv=1.000000000000000e+05}', "");
    Expect(1, 126133, '\p{^Is_Nv=1.000000000000000e+05}', "");
    Expect(1, 126133, '\P{Is_Nv=1.000000000000000e+05}', "");
    Expect(0, 126133, '\P{^Is_Nv=1.000000000000000e+05}', "");
    Error('\p{Numeric_Value=_:=0_0_0_0_0_1_000000}');
    Error('\P{Numeric_Value=_:=0_0_0_0_0_1_000000}');
    Expect(1, 93022, '\p{Numeric_Value=:\A1000000\z:}', "");;
    Expect(0, 93023, '\p{Numeric_Value=:\A1000000\z:}', "");;
    Expect(1, 93022, '\p{Numeric_Value=0_0_0_0_0_0_1_0_0_0_0_00}', "");
    Expect(0, 93022, '\p{^Numeric_Value=0_0_0_0_0_0_1_0_0_0_0_00}', "");
    Expect(0, 93022, '\P{Numeric_Value=0_0_0_0_0_0_1_0_0_0_0_00}', "");
    Expect(1, 93022, '\P{^Numeric_Value=0_0_0_0_0_0_1_0_0_0_0_00}', "");
    Expect(0, 93023, '\p{Numeric_Value=0_0_0_0_0_0_1_0_0_0_0_00}', "");
    Expect(1, 93023, '\p{^Numeric_Value=0_0_0_0_0_0_1_0_0_0_0_00}', "");
    Expect(1, 93023, '\P{Numeric_Value=0_0_0_0_0_0_1_0_0_0_0_00}', "");
    Expect(0, 93023, '\P{^Numeric_Value=0_0_0_0_0_0_1_0_0_0_0_00}', "");
    Expect(1, 93022, '\p{Numeric_Value=1.000000000000000e+06}', "");
    Expect(0, 93022, '\p{^Numeric_Value=1.000000000000000e+06}', "");
    Expect(0, 93022, '\P{Numeric_Value=1.000000000000000e+06}', "");
    Expect(1, 93022, '\P{^Numeric_Value=1.000000000000000e+06}', "");
    Expect(0, 93023, '\p{Numeric_Value=1.000000000000000e+06}', "");
    Expect(1, 93023, '\p{^Numeric_Value=1.000000000000000e+06}', "");
    Expect(1, 93023, '\P{Numeric_Value=1.000000000000000e+06}', "");
    Expect(0, 93023, '\P{^Numeric_Value=1.000000000000000e+06}', "");
    Error('\p{Nv::=	 000001000000}');
    Error('\P{Nv::=	 000001000000}');
    Expect(1, 93022, '\p{Nv=:\A1000000\z:}', "");;
    Expect(0, 93023, '\p{Nv=:\A1000000\z:}', "");;
    Expect(1, 93022, '\p{Nv=000001000000}', "");
    Expect(0, 93022, '\p{^Nv=000001000000}', "");
    Expect(0, 93022, '\P{Nv=000001000000}', "");
    Expect(1, 93022, '\P{^Nv=000001000000}', "");
    Expect(0, 93023, '\p{Nv=000001000000}', "");
    Expect(1, 93023, '\p{^Nv=000001000000}', "");
    Expect(1, 93023, '\P{Nv=000001000000}', "");
    Expect(0, 93023, '\P{^Nv=000001000000}', "");
    Expect(1, 93022, '\p{Nv=1.000000000000000e+06}', "");
    Expect(0, 93022, '\p{^Nv=1.000000000000000e+06}', "");
    Expect(0, 93022, '\P{Nv=1.000000000000000e+06}', "");
    Expect(1, 93022, '\P{^Nv=1.000000000000000e+06}', "");
    Expect(0, 93023, '\p{Nv=1.000000000000000e+06}', "");
    Expect(1, 93023, '\p{^Nv=1.000000000000000e+06}', "");
    Expect(1, 93023, '\P{Nv=1.000000000000000e+06}', "");
    Expect(0, 93023, '\P{^Nv=1.000000000000000e+06}', "");
    Error('\p{Is_Numeric_Value=-:=001000000}');
    Error('\P{Is_Numeric_Value=-:=001000000}');
    Expect(1, 93022, '\p{Is_Numeric_Value=000000001000000}', "");
    Expect(0, 93022, '\p{^Is_Numeric_Value=000000001000000}', "");
    Expect(0, 93022, '\P{Is_Numeric_Value=000000001000000}', "");
    Expect(1, 93022, '\P{^Is_Numeric_Value=000000001000000}', "");
    Expect(0, 93023, '\p{Is_Numeric_Value=000000001000000}', "");
    Expect(1, 93023, '\p{^Is_Numeric_Value=000000001000000}', "");
    Expect(1, 93023, '\P{Is_Numeric_Value=000000001000000}', "");
    Expect(0, 93023, '\P{^Is_Numeric_Value=000000001000000}', "");
    Expect(1, 93022, '\p{Is_Numeric_Value=1.000000000000000e+06}', "");
    Expect(0, 93022, '\p{^Is_Numeric_Value=1.000000000000000e+06}', "");
    Expect(0, 93022, '\P{Is_Numeric_Value=1.000000000000000e+06}', "");
    Expect(1, 93022, '\P{^Is_Numeric_Value=1.000000000000000e+06}', "");
    Expect(0, 93023, '\p{Is_Numeric_Value=1.000000000000000e+06}', "");
    Expect(1, 93023, '\p{^Is_Numeric_Value=1.000000000000000e+06}', "");
    Expect(1, 93023, '\P{Is_Numeric_Value=1.000000000000000e+06}', "");
    Expect(0, 93023, '\P{^Is_Numeric_Value=1.000000000000000e+06}', "");
    Error('\p{Is_Nv=/a/ _100_000_0}');
    Error('\P{Is_Nv=/a/ _100_000_0}');
    Expect(1, 93022, '\p{Is_Nv=001000000}', "");
    Expect(0, 93022, '\p{^Is_Nv=001000000}', "");
    Expect(0, 93022, '\P{Is_Nv=001000000}', "");
    Expect(1, 93022, '\P{^Is_Nv=001000000}', "");
    Expect(0, 93023, '\p{Is_Nv=001000000}', "");
    Expect(1, 93023, '\p{^Is_Nv=001000000}', "");
    Expect(1, 93023, '\P{Is_Nv=001000000}', "");
    Expect(0, 93023, '\P{^Is_Nv=001000000}', "");
    Expect(1, 93022, '\p{Is_Nv: 1.000000000000000e+06}', "");
    Expect(0, 93022, '\p{^Is_Nv: 1.000000000000000e+06}', "");
    Expect(0, 93022, '\P{Is_Nv: 1.000000000000000e+06}', "");
    Expect(1, 93022, '\P{^Is_Nv: 1.000000000000000e+06}', "");
    Expect(0, 93023, '\p{Is_Nv: 1.000000000000000e+06}', "");
    Expect(1, 93023, '\p{^Is_Nv: 1.000000000000000e+06}', "");
    Expect(1, 93023, '\P{Is_Nv: 1.000000000000000e+06}', "");
    Expect(0, 93023, '\P{^Is_Nv: 1.000000000000000e+06}', "");
    Error('\p{Numeric_Value=-:=00010000000}');
    Error('\P{Numeric_Value=-:=00010000000}');
    Expect(1, 126113, '\p{Numeric_Value=:\A10000000\z:}', "");;
    Expect(0, 126114, '\p{Numeric_Value=:\A10000000\z:}', "");;
    Expect(1, 126113, '\p{Numeric_Value=0000000010000000}', "");
    Expect(0, 126113, '\p{^Numeric_Value=0000000010000000}', "");
    Expect(0, 126113, '\P{Numeric_Value=0000000010000000}', "");
    Expect(1, 126113, '\P{^Numeric_Value=0000000010000000}', "");
    Expect(0, 126114, '\p{Numeric_Value=0000000010000000}', "");
    Expect(1, 126114, '\p{^Numeric_Value=0000000010000000}', "");
    Expect(1, 126114, '\P{Numeric_Value=0000000010000000}', "");
    Expect(0, 126114, '\P{^Numeric_Value=0000000010000000}', "");
    Expect(1, 126113, '\p{Numeric_Value=1.000000000000000e+07}', "");
    Expect(0, 126113, '\p{^Numeric_Value=1.000000000000000e+07}', "");
    Expect(0, 126113, '\P{Numeric_Value=1.000000000000000e+07}', "");
    Expect(1, 126113, '\P{^Numeric_Value=1.000000000000000e+07}', "");
    Expect(0, 126114, '\p{Numeric_Value=1.000000000000000e+07}', "");
    Expect(1, 126114, '\p{^Numeric_Value=1.000000000000000e+07}', "");
    Expect(1, 126114, '\P{Numeric_Value=1.000000000000000e+07}', "");
    Expect(0, 126114, '\P{^Numeric_Value=1.000000000000000e+07}', "");
    Error('\p{Nv=/a/- 0_0_1_0_0_0_0000}');
    Error('\P{Nv=/a/- 0_0_1_0_0_0_0000}');
    Expect(1, 126113, '\p{Nv=:\A10000000\z:}', "");;
    Expect(0, 126114, '\p{Nv=:\A10000000\z:}', "");;
    Expect(1, 126113, '\p{Nv=01_00_00_00_0}', "");
    Expect(0, 126113, '\p{^Nv=01_00_00_00_0}', "");
    Expect(0, 126113, '\P{Nv=01_00_00_00_0}', "");
    Expect(1, 126113, '\P{^Nv=01_00_00_00_0}', "");
    Expect(0, 126114, '\p{Nv=01_00_00_00_0}', "");
    Expect(1, 126114, '\p{^Nv=01_00_00_00_0}', "");
    Expect(1, 126114, '\P{Nv=01_00_00_00_0}', "");
    Expect(0, 126114, '\P{^Nv=01_00_00_00_0}', "");
    Expect(1, 126113, '\p{Nv=1.000000000000000e+07}', "");
    Expect(0, 126113, '\p{^Nv=1.000000000000000e+07}', "");
    Expect(0, 126113, '\P{Nv=1.000000000000000e+07}', "");
    Expect(1, 126113, '\P{^Nv=1.000000000000000e+07}', "");
    Expect(0, 126114, '\p{Nv=1.000000000000000e+07}', "");
    Expect(1, 126114, '\p{^Nv=1.000000000000000e+07}', "");
    Expect(1, 126114, '\P{Nv=1.000000000000000e+07}', "");
    Expect(0, 126114, '\P{^Nv=1.000000000000000e+07}', "");
    Error('\p{Is_Numeric_Value=:=--0010000000}');
    Error('\P{Is_Numeric_Value=:=--0010000000}');
    Expect(1, 126113, '\p{Is_Numeric_Value=+10000000}', "");
    Expect(0, 126113, '\p{^Is_Numeric_Value=+10000000}', "");
    Expect(0, 126113, '\P{Is_Numeric_Value=+10000000}', "");
    Expect(1, 126113, '\P{^Is_Numeric_Value=+10000000}', "");
    Expect(0, 126114, '\p{Is_Numeric_Value=+10000000}', "");
    Expect(1, 126114, '\p{^Is_Numeric_Value=+10000000}', "");
    Expect(1, 126114, '\P{Is_Numeric_Value=+10000000}', "");
    Expect(0, 126114, '\P{^Is_Numeric_Value=+10000000}', "");
    Expect(1, 126113, '\p{Is_Numeric_Value=1.000000000000000e+07}', "");
    Expect(0, 126113, '\p{^Is_Numeric_Value=1.000000000000000e+07}', "");
    Expect(0, 126113, '\P{Is_Numeric_Value=1.000000000000000e+07}', "");
    Expect(1, 126113, '\P{^Is_Numeric_Value=1.000000000000000e+07}', "");
    Expect(0, 126114, '\p{Is_Numeric_Value=1.000000000000000e+07}', "");
    Expect(1, 126114, '\p{^Is_Numeric_Value=1.000000000000000e+07}', "");
    Expect(1, 126114, '\P{Is_Numeric_Value=1.000000000000000e+07}', "");
    Expect(0, 126114, '\P{^Is_Numeric_Value=1.000000000000000e+07}', "");
    Error('\p{Is_Nv=/a/_	+00000000010000000}');
    Error('\P{Is_Nv=/a/_	+00000000010000000}');
    Expect(1, 126113, '\p{Is_Nv=000001_000000_0}', "");
    Expect(0, 126113, '\p{^Is_Nv=000001_000000_0}', "");
    Expect(0, 126113, '\P{Is_Nv=000001_000000_0}', "");
    Expect(1, 126113, '\P{^Is_Nv=000001_000000_0}', "");
    Expect(0, 126114, '\p{Is_Nv=000001_000000_0}', "");
    Expect(1, 126114, '\p{^Is_Nv=000001_000000_0}', "");
    Expect(1, 126114, '\P{Is_Nv=000001_000000_0}', "");
    Expect(0, 126114, '\P{^Is_Nv=000001_000000_0}', "");
    Expect(1, 126113, '\p{Is_Nv=1.000000000000000e+07}', "");
    Expect(0, 126113, '\p{^Is_Nv=1.000000000000000e+07}', "");
    Expect(0, 126113, '\P{Is_Nv=1.000000000000000e+07}', "");
    Expect(1, 126113, '\P{^Is_Nv=1.000000000000000e+07}', "");
    Expect(0, 126114, '\p{Is_Nv=1.000000000000000e+07}', "");
    Expect(1, 126114, '\p{^Is_Nv=1.000000000000000e+07}', "");
    Expect(1, 126114, '\P{Is_Nv=1.000000000000000e+07}', "");
    Expect(0, 126114, '\P{^Is_Nv=1.000000000000000e+07}', "");
    Error('\p{Numeric_Value=:= 	000000000100000000}');
    Error('\P{Numeric_Value=:= 	000000000100000000}');
    Expect(1, 93023, '\p{Numeric_Value=:\A100000000\z:}', "");;
    Expect(0, 93024, '\p{Numeric_Value=:\A100000000\z:}', "");;
    Expect(1, 93023, '\p{Numeric_Value=000001_000000_00}', "");
    Expect(0, 93023, '\p{^Numeric_Value=000001_000000_00}', "");
    Expect(0, 93023, '\P{Numeric_Value=000001_000000_00}', "");
    Expect(1, 93023, '\P{^Numeric_Value=000001_000000_00}', "");
    Expect(0, 93024, '\p{Numeric_Value=000001_000000_00}', "");
    Expect(1, 93024, '\p{^Numeric_Value=000001_000000_00}', "");
    Expect(1, 93024, '\P{Numeric_Value=000001_000000_00}', "");
    Expect(0, 93024, '\P{^Numeric_Value=000001_000000_00}', "");
    Expect(1, 93023, '\p{Numeric_Value=1.000000000000000e+08}', "");
    Expect(0, 93023, '\p{^Numeric_Value=1.000000000000000e+08}', "");
    Expect(0, 93023, '\P{Numeric_Value=1.000000000000000e+08}', "");
    Expect(1, 93023, '\P{^Numeric_Value=1.000000000000000e+08}', "");
    Expect(0, 93024, '\p{Numeric_Value=1.000000000000000e+08}', "");
    Expect(1, 93024, '\p{^Numeric_Value=1.000000000000000e+08}', "");
    Expect(1, 93024, '\P{Numeric_Value=1.000000000000000e+08}', "");
    Expect(0, 93024, '\P{^Numeric_Value=1.000000000000000e+08}', "");
    Error('\p{Nv=	:=0_0_0_0_1_0_0_0_00000}');
    Error('\P{Nv=	:=0_0_0_0_1_0_0_0_00000}');
    Expect(1, 93023, '\p{Nv=:\A100000000\z:}', "");;
    Expect(0, 93024, '\p{Nv=:\A100000000\z:}', "");;
    Expect(1, 93023, '\p{Nv=0_0_0_0_0_0_0_1_0_0_0_00000}', "");
    Expect(0, 93023, '\p{^Nv=0_0_0_0_0_0_0_1_0_0_0_00000}', "");
    Expect(0, 93023, '\P{Nv=0_0_0_0_0_0_0_1_0_0_0_00000}', "");
    Expect(1, 93023, '\P{^Nv=0_0_0_0_0_0_0_1_0_0_0_00000}', "");
    Expect(0, 93024, '\p{Nv=0_0_0_0_0_0_0_1_0_0_0_00000}', "");
    Expect(1, 93024, '\p{^Nv=0_0_0_0_0_0_0_1_0_0_0_00000}', "");
    Expect(1, 93024, '\P{Nv=0_0_0_0_0_0_0_1_0_0_0_00000}', "");
    Expect(0, 93024, '\P{^Nv=0_0_0_0_0_0_0_1_0_0_0_00000}', "");
    Expect(1, 93023, '\p{Nv=1.000000000000000e+08}', "");
    Expect(0, 93023, '\p{^Nv=1.000000000000000e+08}', "");
    Expect(0, 93023, '\P{Nv=1.000000000000000e+08}', "");
    Expect(1, 93023, '\P{^Nv=1.000000000000000e+08}', "");
    Expect(0, 93024, '\p{Nv=1.000000000000000e+08}', "");
    Expect(1, 93024, '\p{^Nv=1.000000000000000e+08}', "");
    Expect(1, 93024, '\P{Nv=1.000000000000000e+08}', "");
    Expect(0, 93024, '\P{^Nv=1.000000000000000e+08}', "");
    Error('\p{Is_Numeric_Value=-/a/+10_00_00_000}');
    Error('\P{Is_Numeric_Value=-/a/+10_00_00_000}');
    Expect(1, 93023, '\p{Is_Numeric_Value=0_0_0_0_1_0_0_0_0_0_0_00}', "");
    Expect(0, 93023, '\p{^Is_Numeric_Value=0_0_0_0_1_0_0_0_0_0_0_00}', "");
    Expect(0, 93023, '\P{Is_Numeric_Value=0_0_0_0_1_0_0_0_0_0_0_00}', "");
    Expect(1, 93023, '\P{^Is_Numeric_Value=0_0_0_0_1_0_0_0_0_0_0_00}', "");
    Expect(0, 93024, '\p{Is_Numeric_Value=0_0_0_0_1_0_0_0_0_0_0_00}', "");
    Expect(1, 93024, '\p{^Is_Numeric_Value=0_0_0_0_1_0_0_0_0_0_0_00}', "");
    Expect(1, 93024, '\P{Is_Numeric_Value=0_0_0_0_1_0_0_0_0_0_0_00}', "");
    Expect(0, 93024, '\P{^Is_Numeric_Value=0_0_0_0_1_0_0_0_0_0_0_00}', "");
    Expect(1, 93023, '\p{Is_Numeric_Value:1.000000000000000e+08}', "");
    Expect(0, 93023, '\p{^Is_Numeric_Value:1.000000000000000e+08}', "");
    Expect(0, 93023, '\P{Is_Numeric_Value:1.000000000000000e+08}', "");
    Expect(1, 93023, '\P{^Is_Numeric_Value:1.000000000000000e+08}', "");
    Expect(0, 93024, '\p{Is_Numeric_Value:1.000000000000000e+08}', "");
    Expect(1, 93024, '\p{^Is_Numeric_Value:1.000000000000000e+08}', "");
    Expect(1, 93024, '\P{Is_Numeric_Value:1.000000000000000e+08}', "");
    Expect(0, 93024, '\P{^Is_Numeric_Value:1.000000000000000e+08}', "");
    Error('\p{Is_Nv=-/a/+0000000100000000}');
    Error('\P{Is_Nv=-/a/+0000000100000000}');
    Expect(1, 93023, '\p{Is_Nv=00000100000000}', "");
    Expect(0, 93023, '\p{^Is_Nv=00000100000000}', "");
    Expect(0, 93023, '\P{Is_Nv=00000100000000}', "");
    Expect(1, 93023, '\P{^Is_Nv=00000100000000}', "");
    Expect(0, 93024, '\p{Is_Nv=00000100000000}', "");
    Expect(1, 93024, '\p{^Is_Nv=00000100000000}', "");
    Expect(1, 93024, '\P{Is_Nv=00000100000000}', "");
    Expect(0, 93024, '\P{^Is_Nv=00000100000000}', "");
    Expect(1, 93023, '\p{Is_Nv=1.000000000000000e+08}', "");
    Expect(0, 93023, '\p{^Is_Nv=1.000000000000000e+08}', "");
    Expect(0, 93023, '\P{Is_Nv=1.000000000000000e+08}', "");
    Expect(1, 93023, '\P{^Is_Nv=1.000000000000000e+08}', "");
    Expect(0, 93024, '\p{Is_Nv=1.000000000000000e+08}', "");
    Expect(1, 93024, '\p{^Is_Nv=1.000000000000000e+08}', "");
    Expect(1, 93024, '\P{Is_Nv=1.000000000000000e+08}', "");
    Expect(0, 93024, '\P{^Is_Nv=1.000000000000000e+08}', "");
    Error('\p{Numeric_Value=	-10000000000/a/}');
    Error('\P{Numeric_Value=	-10000000000/a/}');
    Expect(1, 93024, '\p{Numeric_Value=:\A10000000000\z:}', "");;
    Expect(0, 93025, '\p{Numeric_Value=:\A10000000000\z:}', "");;
    Expect(1, 93024, '\p{Numeric_Value=1_0_0_0_0_0_0_0_0_00}', "");
    Expect(0, 93024, '\p{^Numeric_Value=1_0_0_0_0_0_0_0_0_00}', "");
    Expect(0, 93024, '\P{Numeric_Value=1_0_0_0_0_0_0_0_0_00}', "");
    Expect(1, 93024, '\P{^Numeric_Value=1_0_0_0_0_0_0_0_0_00}', "");
    Expect(0, 93025, '\p{Numeric_Value=1_0_0_0_0_0_0_0_0_00}', "");
    Expect(1, 93025, '\p{^Numeric_Value=1_0_0_0_0_0_0_0_0_00}', "");
    Expect(1, 93025, '\P{Numeric_Value=1_0_0_0_0_0_0_0_0_00}', "");
    Expect(0, 93025, '\P{^Numeric_Value=1_0_0_0_0_0_0_0_0_00}', "");
    Expect(1, 93024, '\p{Numeric_Value=1.000000000000000e+10}', "");
    Expect(0, 93024, '\p{^Numeric_Value=1.000000000000000e+10}', "");
    Expect(0, 93024, '\P{Numeric_Value=1.000000000000000e+10}', "");
    Expect(1, 93024, '\P{^Numeric_Value=1.000000000000000e+10}', "");
    Expect(0, 93025, '\p{Numeric_Value=1.000000000000000e+10}', "");
    Expect(1, 93025, '\p{^Numeric_Value=1.000000000000000e+10}', "");
    Expect(1, 93025, '\P{Numeric_Value=1.000000000000000e+10}', "");
    Expect(0, 93025, '\P{^Numeric_Value=1.000000000000000e+10}', "");
    Error('\p{Nv=/a/-00_01_00_00_00_0000}');
    Error('\P{Nv=/a/-00_01_00_00_00_0000}');
    Expect(1, 93024, '\p{Nv=:\A10000000000\z:}', "");;
    Expect(0, 93025, '\p{Nv=:\A10000000000\z:}', "");;
    Expect(1, 93024, '\p{Nv=0_0_0_1_0_0_0_0_0_0_0_000}', "");
    Expect(0, 93024, '\p{^Nv=0_0_0_1_0_0_0_0_0_0_0_000}', "");
    Expect(0, 93024, '\P{Nv=0_0_0_1_0_0_0_0_0_0_0_000}', "");
    Expect(1, 93024, '\P{^Nv=0_0_0_1_0_0_0_0_0_0_0_000}', "");
    Expect(0, 93025, '\p{Nv=0_0_0_1_0_0_0_0_0_0_0_000}', "");
    Expect(1, 93025, '\p{^Nv=0_0_0_1_0_0_0_0_0_0_0_000}', "");
    Expect(1, 93025, '\P{Nv=0_0_0_1_0_0_0_0_0_0_0_000}', "");
    Expect(0, 93025, '\P{^Nv=0_0_0_1_0_0_0_0_0_0_0_000}', "");
    Expect(1, 93024, '\p{Nv=1.000000000000000e+10}', "");
    Expect(0, 93024, '\p{^Nv=1.000000000000000e+10}', "");
    Expect(0, 93024, '\P{Nv=1.000000000000000e+10}', "");
    Expect(1, 93024, '\P{^Nv=1.000000000000000e+10}', "");
    Expect(0, 93025, '\p{Nv=1.000000000000000e+10}', "");
    Expect(1, 93025, '\p{^Nv=1.000000000000000e+10}', "");
    Expect(1, 93025, '\P{Nv=1.000000000000000e+10}', "");
    Expect(0, 93025, '\P{^Nv=1.000000000000000e+10}', "");
    Error('\p{Is_Numeric_Value=:=+0_0_0_0_0_0_1_0_0_0_0_000000}');
    Error('\P{Is_Numeric_Value=:=+0_0_0_0_0_0_1_0_0_0_0_000000}');
    Expect(1, 93024, '\p{Is_Numeric_Value=+000100_000000_00}', "");
    Expect(0, 93024, '\p{^Is_Numeric_Value=+000100_000000_00}', "");
    Expect(0, 93024, '\P{Is_Numeric_Value=+000100_000000_00}', "");
    Expect(1, 93024, '\P{^Is_Numeric_Value=+000100_000000_00}', "");
    Expect(0, 93025, '\p{Is_Numeric_Value=+000100_000000_00}', "");
    Expect(1, 93025, '\p{^Is_Numeric_Value=+000100_000000_00}', "");
    Expect(1, 93025, '\P{Is_Numeric_Value=+000100_000000_00}', "");
    Expect(0, 93025, '\P{^Is_Numeric_Value=+000100_000000_00}', "");
    Expect(1, 93024, '\p{Is_Numeric_Value:	1.000000000000000e+10}', "");
    Expect(0, 93024, '\p{^Is_Numeric_Value:	1.000000000000000e+10}', "");
    Expect(0, 93024, '\P{Is_Numeric_Value:	1.000000000000000e+10}', "");
    Expect(1, 93024, '\P{^Is_Numeric_Value:	1.000000000000000e+10}', "");
    Expect(0, 93025, '\p{Is_Numeric_Value:	1.000000000000000e+10}', "");
    Expect(1, 93025, '\p{^Is_Numeric_Value:	1.000000000000000e+10}', "");
    Expect(1, 93025, '\P{Is_Numeric_Value:	1.000000000000000e+10}', "");
    Expect(0, 93025, '\P{^Is_Numeric_Value:	1.000000000000000e+10}', "");
    Error('\p{Is_Nv= /a/+000_001_000_000_0000}');
    Error('\P{Is_Nv= /a/+000_001_000_000_0000}');
    Expect(1, 93024, '\p{Is_Nv=0_0_0_0_0_1_0_0_00000000}', "");
    Expect(0, 93024, '\p{^Is_Nv=0_0_0_0_0_1_0_0_00000000}', "");
    Expect(0, 93024, '\P{Is_Nv=0_0_0_0_0_1_0_0_00000000}', "");
    Expect(1, 93024, '\P{^Is_Nv=0_0_0_0_0_1_0_0_00000000}', "");
    Expect(0, 93025, '\p{Is_Nv=0_0_0_0_0_1_0_0_00000000}', "");
    Expect(1, 93025, '\p{^Is_Nv=0_0_0_0_0_1_0_0_00000000}', "");
    Expect(1, 93025, '\P{Is_Nv=0_0_0_0_0_1_0_0_00000000}', "");
    Expect(0, 93025, '\P{^Is_Nv=0_0_0_0_0_1_0_0_00000000}', "");
    Expect(1, 93024, '\p{Is_Nv=1.000000000000000e+10}', "");
    Expect(0, 93024, '\p{^Is_Nv=1.000000000000000e+10}', "");
    Expect(0, 93024, '\P{Is_Nv=1.000000000000000e+10}', "");
    Expect(1, 93024, '\P{^Is_Nv=1.000000000000000e+10}', "");
    Expect(0, 93025, '\p{Is_Nv=1.000000000000000e+10}', "");
    Expect(1, 93025, '\p{^Is_Nv=1.000000000000000e+10}', "");
    Expect(1, 93025, '\P{Is_Nv=1.000000000000000e+10}', "");
    Expect(0, 93025, '\P{^Is_Nv=1.000000000000000e+10}', "");
    Error('\p{Numeric_Value=-	000001000000000000/a/}');
    Error('\P{Numeric_Value=-	000001000000000000/a/}');
    Expect(1, 93025, '\p{Numeric_Value=:\A1000000000000\z:}', "");;
    Expect(0, 93026, '\p{Numeric_Value=:\A1000000000000\z:}', "");;
    Expect(1, 93025, '\p{Numeric_Value=0000_0000_1000_0000_0000_0}', "");
    Expect(0, 93025, '\p{^Numeric_Value=0000_0000_1000_0000_0000_0}', "");
    Expect(0, 93025, '\P{Numeric_Value=0000_0000_1000_0000_0000_0}', "");
    Expect(1, 93025, '\P{^Numeric_Value=0000_0000_1000_0000_0000_0}', "");
    Expect(0, 93026, '\p{Numeric_Value=0000_0000_1000_0000_0000_0}', "");
    Expect(1, 93026, '\p{^Numeric_Value=0000_0000_1000_0000_0000_0}', "");
    Expect(1, 93026, '\P{Numeric_Value=0000_0000_1000_0000_0000_0}', "");
    Expect(0, 93026, '\P{^Numeric_Value=0000_0000_1000_0000_0000_0}', "");
    Expect(1, 93025, '\p{Numeric_Value=1.000000000000000e+12}', "");
    Expect(0, 93025, '\p{^Numeric_Value=1.000000000000000e+12}', "");
    Expect(0, 93025, '\P{Numeric_Value=1.000000000000000e+12}', "");
    Expect(1, 93025, '\P{^Numeric_Value=1.000000000000000e+12}', "");
    Expect(0, 93026, '\p{Numeric_Value=1.000000000000000e+12}', "");
    Expect(1, 93026, '\p{^Numeric_Value=1.000000000000000e+12}', "");
    Expect(1, 93026, '\P{Numeric_Value=1.000000000000000e+12}', "");
    Expect(0, 93026, '\P{^Numeric_Value=1.000000000000000e+12}', "");
    Error('\p{Nv:  0_0_0_0_0_0_1_0_0_0_0_0_0_0_00000:=}');
    Error('\P{Nv:  0_0_0_0_0_0_1_0_0_0_0_0_0_0_00000:=}');
    Expect(1, 93025, '\p{Nv=:\A1000000000000\z:}', "");;
    Expect(0, 93026, '\p{Nv=:\A1000000000000\z:}', "");;
    Expect(1, 93025, '\p{Nv=00001000000000000}', "");
    Expect(0, 93025, '\p{^Nv=00001000000000000}', "");
    Expect(0, 93025, '\P{Nv=00001000000000000}', "");
    Expect(1, 93025, '\P{^Nv=00001000000000000}', "");
    Expect(0, 93026, '\p{Nv=00001000000000000}', "");
    Expect(1, 93026, '\p{^Nv=00001000000000000}', "");
    Expect(1, 93026, '\P{Nv=00001000000000000}', "");
    Expect(0, 93026, '\P{^Nv=00001000000000000}', "");
    Expect(1, 93025, '\p{Nv=1.000000000000000e+12}', "");
    Expect(0, 93025, '\p{^Nv=1.000000000000000e+12}', "");
    Expect(0, 93025, '\P{Nv=1.000000000000000e+12}', "");
    Expect(1, 93025, '\P{^Nv=1.000000000000000e+12}', "");
    Expect(0, 93026, '\p{Nv=1.000000000000000e+12}', "");
    Expect(1, 93026, '\p{^Nv=1.000000000000000e+12}', "");
    Expect(1, 93026, '\P{Nv=1.000000000000000e+12}', "");
    Expect(0, 93026, '\P{^Nv=1.000000000000000e+12}', "");
    Error('\p{Is_Numeric_Value: /a/_000001000000000000}');
    Error('\P{Is_Numeric_Value: /a/_000001000000000000}');
    Expect(1, 93025, '\p{Is_Numeric_Value=0_1_0_0_0_0_0_0_0_0_0000}', "");
    Expect(0, 93025, '\p{^Is_Numeric_Value=0_1_0_0_0_0_0_0_0_0_0000}', "");
    Expect(0, 93025, '\P{Is_Numeric_Value=0_1_0_0_0_0_0_0_0_0_0000}', "");
    Expect(1, 93025, '\P{^Is_Numeric_Value=0_1_0_0_0_0_0_0_0_0_0000}', "");
    Expect(0, 93026, '\p{Is_Numeric_Value=0_1_0_0_0_0_0_0_0_0_0000}', "");
    Expect(1, 93026, '\p{^Is_Numeric_Value=0_1_0_0_0_0_0_0_0_0_0000}', "");
    Expect(1, 93026, '\P{Is_Numeric_Value=0_1_0_0_0_0_0_0_0_0_0000}', "");
    Expect(0, 93026, '\P{^Is_Numeric_Value=0_1_0_0_0_0_0_0_0_0_0000}', "");
    Expect(1, 93025, '\p{Is_Numeric_Value=1.000000000000000e+12}', "");
    Expect(0, 93025, '\p{^Is_Numeric_Value=1.000000000000000e+12}', "");
    Expect(0, 93025, '\P{Is_Numeric_Value=1.000000000000000e+12}', "");
    Expect(1, 93025, '\P{^Is_Numeric_Value=1.000000000000000e+12}', "");
    Expect(0, 93026, '\p{Is_Numeric_Value=1.000000000000000e+12}', "");
    Expect(1, 93026, '\p{^Is_Numeric_Value=1.000000000000000e+12}', "");
    Expect(1, 93026, '\P{Is_Numeric_Value=1.000000000000000e+12}', "");
    Expect(0, 93026, '\P{^Is_Numeric_Value=1.000000000000000e+12}', "");
    Error('\p{Is_Nv=/a/01000000000000}');
    Error('\P{Is_Nv=/a/01000000000000}');
    Expect(1, 93025, '\p{Is_Nv=000_000_001_000_000_000_000}', "");
    Expect(0, 93025, '\p{^Is_Nv=000_000_001_000_000_000_000}', "");
    Expect(0, 93025, '\P{Is_Nv=000_000_001_000_000_000_000}', "");
    Expect(1, 93025, '\P{^Is_Nv=000_000_001_000_000_000_000}', "");
    Expect(0, 93026, '\p{Is_Nv=000_000_001_000_000_000_000}', "");
    Expect(1, 93026, '\p{^Is_Nv=000_000_001_000_000_000_000}', "");
    Expect(1, 93026, '\P{Is_Nv=000_000_001_000_000_000_000}', "");
    Expect(0, 93026, '\P{^Is_Nv=000_000_001_000_000_000_000}', "");
    Expect(1, 93025, '\p{Is_Nv=1.000000000000000e+12}', "");
    Expect(0, 93025, '\p{^Is_Nv=1.000000000000000e+12}', "");
    Expect(0, 93025, '\P{Is_Nv=1.000000000000000e+12}', "");
    Expect(1, 93025, '\P{^Is_Nv=1.000000000000000e+12}', "");
    Expect(0, 93026, '\p{Is_Nv=1.000000000000000e+12}', "");
    Expect(1, 93026, '\p{^Is_Nv=1.000000000000000e+12}', "");
    Expect(1, 93026, '\P{Is_Nv=1.000000000000000e+12}', "");
    Expect(0, 93026, '\P{^Is_Nv=1.000000000000000e+12}', "");
    Error('\p{Numeric_Value=/a/-+0_0_0_0_0_0_0_011}');
    Error('\P{Numeric_Value=/a/-+0_0_0_0_0_0_0_011}');
    Expect(1, 119531, '\p{Numeric_Value=:\A11\z:}', "");;
    Expect(0, 119532, '\p{Numeric_Value=:\A11\z:}', "");;
    Expect(1, 119531, '\p{Numeric_Value=00000000011}', "");
    Expect(0, 119531, '\p{^Numeric_Value=00000000011}', "");
    Expect(0, 119531, '\P{Numeric_Value=00000000011}', "");
    Expect(1, 119531, '\P{^Numeric_Value=00000000011}', "");
    Expect(0, 119532, '\p{Numeric_Value=00000000011}', "");
    Expect(1, 119532, '\p{^Numeric_Value=00000000011}', "");
    Expect(1, 119532, '\P{Numeric_Value=00000000011}', "");
    Expect(0, 119532, '\P{^Numeric_Value=00000000011}', "");
    Expect(1, 119531, '\p{Numeric_Value:1.100000000000000e+01}', "");
    Expect(0, 119531, '\p{^Numeric_Value:1.100000000000000e+01}', "");
    Expect(0, 119531, '\P{Numeric_Value:1.100000000000000e+01}', "");
    Expect(1, 119531, '\P{^Numeric_Value:1.100000000000000e+01}', "");
    Expect(0, 119532, '\p{Numeric_Value:1.100000000000000e+01}', "");
    Expect(1, 119532, '\p{^Numeric_Value:1.100000000000000e+01}', "");
    Expect(1, 119532, '\P{Numeric_Value:1.100000000000000e+01}', "");
    Expect(0, 119532, '\P{^Numeric_Value:1.100000000000000e+01}', "");
    Error('\p{Nv=/a/		+01_1}');
    Error('\P{Nv=/a/		+01_1}');
    Expect(1, 119531, '\p{Nv=:\A11\z:}', "");;
    Expect(0, 119532, '\p{Nv=:\A11\z:}', "");;
    Expect(1, 119531, '\p{Nv=+01_1}', "");
    Expect(0, 119531, '\p{^Nv=+01_1}', "");
    Expect(0, 119531, '\P{Nv=+01_1}', "");
    Expect(1, 119531, '\P{^Nv=+01_1}', "");
    Expect(0, 119532, '\p{Nv=+01_1}', "");
    Expect(1, 119532, '\p{^Nv=+01_1}', "");
    Expect(1, 119532, '\P{Nv=+01_1}', "");
    Expect(0, 119532, '\P{^Nv=+01_1}', "");
    Expect(1, 119531, '\p{Nv=1.100000000000000e+01}', "");
    Expect(0, 119531, '\p{^Nv=1.100000000000000e+01}', "");
    Expect(0, 119531, '\P{Nv=1.100000000000000e+01}', "");
    Expect(1, 119531, '\P{^Nv=1.100000000000000e+01}', "");
    Expect(0, 119532, '\p{Nv=1.100000000000000e+01}', "");
    Expect(1, 119532, '\p{^Nv=1.100000000000000e+01}', "");
    Expect(1, 119532, '\P{Nv=1.100000000000000e+01}', "");
    Expect(0, 119532, '\P{^Nv=1.100000000000000e+01}', "");
    Error('\p{Is_Numeric_Value=:=00000001_1}');
    Error('\P{Is_Numeric_Value=:=00000001_1}');
    Expect(1, 119531, '\p{Is_Numeric_Value=00_00_11}', "");
    Expect(0, 119531, '\p{^Is_Numeric_Value=00_00_11}', "");
    Expect(0, 119531, '\P{Is_Numeric_Value=00_00_11}', "");
    Expect(1, 119531, '\P{^Is_Numeric_Value=00_00_11}', "");
    Expect(0, 119532, '\p{Is_Numeric_Value=00_00_11}', "");
    Expect(1, 119532, '\p{^Is_Numeric_Value=00_00_11}', "");
    Expect(1, 119532, '\P{Is_Numeric_Value=00_00_11}', "");
    Expect(0, 119532, '\P{^Is_Numeric_Value=00_00_11}', "");
    Expect(1, 119531, '\p{Is_Numeric_Value=1.100000000000000e+01}', "");
    Expect(0, 119531, '\p{^Is_Numeric_Value=1.100000000000000e+01}', "");
    Expect(0, 119531, '\P{Is_Numeric_Value=1.100000000000000e+01}', "");
    Expect(1, 119531, '\P{^Is_Numeric_Value=1.100000000000000e+01}', "");
    Expect(0, 119532, '\p{Is_Numeric_Value=1.100000000000000e+01}', "");
    Expect(1, 119532, '\p{^Is_Numeric_Value=1.100000000000000e+01}', "");
    Expect(1, 119532, '\P{Is_Numeric_Value=1.100000000000000e+01}', "");
    Expect(0, 119532, '\P{^Is_Numeric_Value=1.100000000000000e+01}', "");
    Error('\p{Is_Nv=-:=0_0_11}');
    Error('\P{Is_Nv=-:=0_0_11}');
    Expect(1, 119531, '\p{Is_Nv=+1_1}', "");
    Expect(0, 119531, '\p{^Is_Nv=+1_1}', "");
    Expect(0, 119531, '\P{Is_Nv=+1_1}', "");
    Expect(1, 119531, '\P{^Is_Nv=+1_1}', "");
    Expect(0, 119532, '\p{Is_Nv=+1_1}', "");
    Expect(1, 119532, '\p{^Is_Nv=+1_1}', "");
    Expect(1, 119532, '\P{Is_Nv=+1_1}', "");
    Expect(0, 119532, '\P{^Is_Nv=+1_1}', "");
    Expect(1, 119531, '\p{Is_Nv=1.100000000000000e+01}', "");
    Expect(0, 119531, '\p{^Is_Nv=1.100000000000000e+01}', "");
    Expect(0, 119531, '\P{Is_Nv=1.100000000000000e+01}', "");
    Expect(1, 119531, '\P{^Is_Nv=1.100000000000000e+01}', "");
    Expect(0, 119532, '\p{Is_Nv=1.100000000000000e+01}', "");
    Expect(1, 119532, '\p{^Is_Nv=1.100000000000000e+01}', "");
    Expect(1, 119532, '\P{Is_Nv=1.100000000000000e+01}', "");
    Expect(0, 119532, '\P{^Is_Nv=1.100000000000000e+01}', "");
    Error('\p{Numeric_Value=-/a/00000000011/000000012}');
    Error('\P{Numeric_Value=-/a/00000000011/000000012}');
    Expect(1, 68028, '\p{Numeric_Value=:\A11/12\z:}', "");;
    Expect(0, 68029, '\p{Numeric_Value=:\A11/12\z:}', "");;
    Expect(1, 68028, '\p{Numeric_Value=+000011/0000000012}', "");
    Expect(0, 68028, '\p{^Numeric_Value=+000011/0000000012}', "");
    Expect(0, 68028, '\P{Numeric_Value=+000011/0000000012}', "");
    Expect(1, 68028, '\P{^Numeric_Value=+000011/0000000012}', "");
    Expect(0, 68029, '\p{Numeric_Value=+000011/0000000012}', "");
    Expect(1, 68029, '\p{^Numeric_Value=+000011/0000000012}', "");
    Expect(1, 68029, '\P{Numeric_Value=+000011/0000000012}', "");
    Expect(0, 68029, '\P{^Numeric_Value=+000011/0000000012}', "");
    Expect(1, 68028, '\p{Numeric_Value=660/720}', "");
    Expect(0, 68028, '\p{^Numeric_Value=660/720}', "");
    Expect(0, 68028, '\P{Numeric_Value=660/720}', "");
    Expect(1, 68028, '\P{^Numeric_Value=660/720}', "");
    Expect(0, 68029, '\p{Numeric_Value=660/720}', "");
    Expect(1, 68029, '\p{^Numeric_Value=660/720}', "");
    Expect(1, 68029, '\P{Numeric_Value=660/720}', "");
    Expect(0, 68029, '\P{^Numeric_Value=660/720}', "");
    Error('\p{Numeric_Value=9.2e-01}');
    Error('\P{Numeric_Value=9.2e-01}');
    Error('\p{Numeric_Value: 0.9}');
    Error('\P{Numeric_Value: 0.9}');
    Expect(1, 68028, '\p{Numeric_Value=9.17e-01}', "");
    Expect(0, 68028, '\p{^Numeric_Value=9.17e-01}', "");
    Expect(0, 68028, '\P{Numeric_Value=9.17e-01}', "");
    Expect(1, 68028, '\P{^Numeric_Value=9.17e-01}', "");
    Expect(0, 68029, '\p{Numeric_Value=9.17e-01}', "");
    Expect(1, 68029, '\p{^Numeric_Value=9.17e-01}', "");
    Expect(1, 68029, '\P{Numeric_Value=9.17e-01}', "");
    Expect(0, 68029, '\P{^Numeric_Value=9.17e-01}', "");
    Error('\p{Numeric_Value=0.92}');
    Error('\P{Numeric_Value=0.92}');
    Expect(1, 68028, '\p{Numeric_Value=9.167e-01}', "");
    Expect(0, 68028, '\p{^Numeric_Value=9.167e-01}', "");
    Expect(0, 68028, '\P{Numeric_Value=9.167e-01}', "");
    Expect(1, 68028, '\P{^Numeric_Value=9.167e-01}', "");
    Expect(0, 68029, '\p{Numeric_Value=9.167e-01}', "");
    Expect(1, 68029, '\p{^Numeric_Value=9.167e-01}', "");
    Expect(1, 68029, '\P{Numeric_Value=9.167e-01}', "");
    Expect(0, 68029, '\P{^Numeric_Value=9.167e-01}', "");
    Expect(1, 68028, '\p{Numeric_Value=0.917}', "");
    Expect(0, 68028, '\p{^Numeric_Value=0.917}', "");
    Expect(0, 68028, '\P{Numeric_Value=0.917}', "");
    Expect(1, 68028, '\P{^Numeric_Value=0.917}', "");
    Expect(0, 68029, '\p{Numeric_Value=0.917}', "");
    Expect(1, 68029, '\p{^Numeric_Value=0.917}', "");
    Expect(1, 68029, '\P{Numeric_Value=0.917}', "");
    Expect(0, 68029, '\P{^Numeric_Value=0.917}', "");
    Expect(1, 68028, '\p{Numeric_Value=9.1667e-01}', "");
    Expect(0, 68028, '\p{^Numeric_Value=9.1667e-01}', "");
    Expect(0, 68028, '\P{Numeric_Value=9.1667e-01}', "");
    Expect(1, 68028, '\P{^Numeric_Value=9.1667e-01}', "");
    Expect(0, 68029, '\p{Numeric_Value=9.1667e-01}', "");
    Expect(1, 68029, '\p{^Numeric_Value=9.1667e-01}', "");
    Expect(1, 68029, '\P{Numeric_Value=9.1667e-01}', "");
    Expect(0, 68029, '\P{^Numeric_Value=9.1667e-01}', "");
    Expect(1, 68028, '\p{Numeric_Value=0.9167}', "");
    Expect(0, 68028, '\p{^Numeric_Value=0.9167}', "");
    Expect(0, 68028, '\P{Numeric_Value=0.9167}', "");
    Expect(1, 68028, '\P{^Numeric_Value=0.9167}', "");
    Expect(0, 68029, '\p{Numeric_Value=0.9167}', "");
    Expect(1, 68029, '\p{^Numeric_Value=0.9167}', "");
    Expect(1, 68029, '\P{Numeric_Value=0.9167}', "");
    Expect(0, 68029, '\P{^Numeric_Value=0.9167}', "");
    Error('\p{Nv= _+11/00012:=}');
    Error('\P{Nv= _+11/00012:=}');
    Expect(1, 68028, '\p{Nv=:\A11/12\z:}', "");;
    Expect(0, 68029, '\p{Nv=:\A11/12\z:}', "");;
    Expect(1, 68028, '\p{Nv=011/00000000012}', "");
    Expect(0, 68028, '\p{^Nv=011/00000000012}', "");
    Expect(0, 68028, '\P{Nv=011/00000000012}', "");
    Expect(1, 68028, '\P{^Nv=011/00000000012}', "");
    Expect(0, 68029, '\p{Nv=011/00000000012}', "");
    Expect(1, 68029, '\p{^Nv=011/00000000012}', "");
    Expect(1, 68029, '\P{Nv=011/00000000012}', "");
    Expect(0, 68029, '\P{^Nv=011/00000000012}', "");
    Expect(1, 68028, '\p{Nv=660/720}', "");
    Expect(0, 68028, '\p{^Nv=660/720}', "");
    Expect(0, 68028, '\P{Nv=660/720}', "");
    Expect(1, 68028, '\P{^Nv=660/720}', "");
    Expect(0, 68029, '\p{Nv=660/720}', "");
    Expect(1, 68029, '\p{^Nv=660/720}', "");
    Expect(1, 68029, '\P{Nv=660/720}', "");
    Expect(0, 68029, '\P{^Nv=660/720}', "");
    Error('\p{Nv=9.2e-01}');
    Error('\P{Nv=9.2e-01}');
    Error('\p{Nv=0.9}');
    Error('\P{Nv=0.9}');
    Expect(1, 68028, '\p{Nv=9.17e-01}', "");
    Expect(0, 68028, '\p{^Nv=9.17e-01}', "");
    Expect(0, 68028, '\P{Nv=9.17e-01}', "");
    Expect(1, 68028, '\P{^Nv=9.17e-01}', "");
    Expect(0, 68029, '\p{Nv=9.17e-01}', "");
    Expect(1, 68029, '\p{^Nv=9.17e-01}', "");
    Expect(1, 68029, '\P{Nv=9.17e-01}', "");
    Expect(0, 68029, '\P{^Nv=9.17e-01}', "");
    Error('\p{Nv=0.92}');
    Error('\P{Nv=0.92}');
    Expect(1, 68028, '\p{Nv=9.167e-01}', "");
    Expect(0, 68028, '\p{^Nv=9.167e-01}', "");
    Expect(0, 68028, '\P{Nv=9.167e-01}', "");
    Expect(1, 68028, '\P{^Nv=9.167e-01}', "");
    Expect(0, 68029, '\p{Nv=9.167e-01}', "");
    Expect(1, 68029, '\p{^Nv=9.167e-01}', "");
    Expect(1, 68029, '\P{Nv=9.167e-01}', "");
    Expect(0, 68029, '\P{^Nv=9.167e-01}', "");
    Expect(1, 68028, '\p{Nv=0.917}', "");
    Expect(0, 68028, '\p{^Nv=0.917}', "");
    Expect(0, 68028, '\P{Nv=0.917}', "");
    Expect(1, 68028, '\P{^Nv=0.917}', "");
    Expect(0, 68029, '\p{Nv=0.917}', "");
    Expect(1, 68029, '\p{^Nv=0.917}', "");
    Expect(1, 68029, '\P{Nv=0.917}', "");
    Expect(0, 68029, '\P{^Nv=0.917}', "");
    Expect(1, 68028, '\p{Nv=9.1667e-01}', "");
    Expect(0, 68028, '\p{^Nv=9.1667e-01}', "");
    Expect(0, 68028, '\P{Nv=9.1667e-01}', "");
    Expect(1, 68028, '\P{^Nv=9.1667e-01}', "");
    Expect(0, 68029, '\p{Nv=9.1667e-01}', "");
    Expect(1, 68029, '\p{^Nv=9.1667e-01}', "");
    Expect(1, 68029, '\P{Nv=9.1667e-01}', "");
    Expect(0, 68029, '\P{^Nv=9.1667e-01}', "");
    Expect(1, 68028, '\p{Nv=0.9167}', "");
    Expect(0, 68028, '\p{^Nv=0.9167}', "");
    Expect(0, 68028, '\P{Nv=0.9167}', "");
    Expect(1, 68028, '\P{^Nv=0.9167}', "");
    Expect(0, 68029, '\p{Nv=0.9167}', "");
    Expect(1, 68029, '\p{^Nv=0.9167}', "");
    Expect(1, 68029, '\P{Nv=0.9167}', "");
    Expect(0, 68029, '\P{^Nv=0.9167}', "");
    Error('\p{Is_Numeric_Value=/a/_00000000011/012}');
    Error('\P{Is_Numeric_Value=/a/_00000000011/012}');
    Expect(1, 68028, '\p{Is_Numeric_Value=+011/0000012}', "");
    Expect(0, 68028, '\p{^Is_Numeric_Value=+011/0000012}', "");
    Expect(0, 68028, '\P{Is_Numeric_Value=+011/0000012}', "");
    Expect(1, 68028, '\P{^Is_Numeric_Value=+011/0000012}', "");
    Expect(0, 68029, '\p{Is_Numeric_Value=+011/0000012}', "");
    Expect(1, 68029, '\p{^Is_Numeric_Value=+011/0000012}', "");
    Expect(1, 68029, '\P{Is_Numeric_Value=+011/0000012}', "");
    Expect(0, 68029, '\P{^Is_Numeric_Value=+011/0000012}', "");
    Expect(1, 68028, '\p{Is_Numeric_Value=660/720}', "");
    Expect(0, 68028, '\p{^Is_Numeric_Value=660/720}', "");
    Expect(0, 68028, '\P{Is_Numeric_Value=660/720}', "");
    Expect(1, 68028, '\P{^Is_Numeric_Value=660/720}', "");
    Expect(0, 68029, '\p{Is_Numeric_Value=660/720}', "");
    Expect(1, 68029, '\p{^Is_Numeric_Value=660/720}', "");
    Expect(1, 68029, '\P{Is_Numeric_Value=660/720}', "");
    Expect(0, 68029, '\P{^Is_Numeric_Value=660/720}', "");
    Error('\p{Is_Numeric_Value: 9.2e-01}');
    Error('\P{Is_Numeric_Value: 9.2e-01}');
    Error('\p{Is_Numeric_Value:   0.9}');
    Error('\P{Is_Numeric_Value:   0.9}');
    Expect(1, 68028, '\p{Is_Numeric_Value=9.17e-01}', "");
    Expect(0, 68028, '\p{^Is_Numeric_Value=9.17e-01}', "");
    Expect(0, 68028, '\P{Is_Numeric_Value=9.17e-01}', "");
    Expect(1, 68028, '\P{^Is_Numeric_Value=9.17e-01}', "");
    Expect(0, 68029, '\p{Is_Numeric_Value=9.17e-01}', "");
    Expect(1, 68029, '\p{^Is_Numeric_Value=9.17e-01}', "");
    Expect(1, 68029, '\P{Is_Numeric_Value=9.17e-01}', "");
    Expect(0, 68029, '\P{^Is_Numeric_Value=9.17e-01}', "");
    Error('\p{Is_Numeric_Value=0.92}');
    Error('\P{Is_Numeric_Value=0.92}');
    Expect(1, 68028, '\p{Is_Numeric_Value: 9.167e-01}', "");
    Expect(0, 68028, '\p{^Is_Numeric_Value: 9.167e-01}', "");
    Expect(0, 68028, '\P{Is_Numeric_Value: 9.167e-01}', "");
    Expect(1, 68028, '\P{^Is_Numeric_Value: 9.167e-01}', "");
    Expect(0, 68029, '\p{Is_Numeric_Value: 9.167e-01}', "");
    Expect(1, 68029, '\p{^Is_Numeric_Value: 9.167e-01}', "");
    Expect(1, 68029, '\P{Is_Numeric_Value: 9.167e-01}', "");
    Expect(0, 68029, '\P{^Is_Numeric_Value: 9.167e-01}', "");
    Expect(1, 68028, '\p{Is_Numeric_Value:0.917}', "");
    Expect(0, 68028, '\p{^Is_Numeric_Value:0.917}', "");
    Expect(0, 68028, '\P{Is_Numeric_Value:0.917}', "");
    Expect(1, 68028, '\P{^Is_Numeric_Value:0.917}', "");
    Expect(0, 68029, '\p{Is_Numeric_Value:0.917}', "");
    Expect(1, 68029, '\p{^Is_Numeric_Value:0.917}', "");
    Expect(1, 68029, '\P{Is_Numeric_Value:0.917}', "");
    Expect(0, 68029, '\P{^Is_Numeric_Value:0.917}', "");
    Expect(1, 68028, '\p{Is_Numeric_Value=9.1667e-01}', "");
    Expect(0, 68028, '\p{^Is_Numeric_Value=9.1667e-01}', "");
    Expect(0, 68028, '\P{Is_Numeric_Value=9.1667e-01}', "");
    Expect(1, 68028, '\P{^Is_Numeric_Value=9.1667e-01}', "");
    Expect(0, 68029, '\p{Is_Numeric_Value=9.1667e-01}', "");
    Expect(1, 68029, '\p{^Is_Numeric_Value=9.1667e-01}', "");
    Expect(1, 68029, '\P{Is_Numeric_Value=9.1667e-01}', "");
    Expect(0, 68029, '\P{^Is_Numeric_Value=9.1667e-01}', "");
    Expect(1, 68028, '\p{Is_Numeric_Value=0.9167}', "");
    Expect(0, 68028, '\p{^Is_Numeric_Value=0.9167}', "");
    Expect(0, 68028, '\P{Is_Numeric_Value=0.9167}', "");
    Expect(1, 68028, '\P{^Is_Numeric_Value=0.9167}', "");
    Expect(0, 68029, '\p{Is_Numeric_Value=0.9167}', "");
    Expect(1, 68029, '\p{^Is_Numeric_Value=0.9167}', "");
    Expect(1, 68029, '\P{Is_Numeric_Value=0.9167}', "");
    Expect(0, 68029, '\P{^Is_Numeric_Value=0.9167}', "");
    Error('\p{Is_Nv=	/a/+0011/00012}');
    Error('\P{Is_Nv=	/a/+0011/00012}');
    Expect(1, 68028, '\p{Is_Nv=000000011/12}', "");
    Expect(0, 68028, '\p{^Is_Nv=000000011/12}', "");
    Expect(0, 68028, '\P{Is_Nv=000000011/12}', "");
    Expect(1, 68028, '\P{^Is_Nv=000000011/12}', "");
    Expect(0, 68029, '\p{Is_Nv=000000011/12}', "");
    Expect(1, 68029, '\p{^Is_Nv=000000011/12}', "");
    Expect(1, 68029, '\P{Is_Nv=000000011/12}', "");
    Expect(0, 68029, '\P{^Is_Nv=000000011/12}', "");
    Expect(1, 68028, '\p{Is_Nv=660/720}', "");
    Expect(0, 68028, '\p{^Is_Nv=660/720}', "");
    Expect(0, 68028, '\P{Is_Nv=660/720}', "");
    Expect(1, 68028, '\P{^Is_Nv=660/720}', "");
    Expect(0, 68029, '\p{Is_Nv=660/720}', "");
    Expect(1, 68029, '\p{^Is_Nv=660/720}', "");
    Expect(1, 68029, '\P{Is_Nv=660/720}', "");
    Expect(0, 68029, '\P{^Is_Nv=660/720}', "");
    Error('\p{Is_Nv=9.2e-01}');
    Error('\P{Is_Nv=9.2e-01}');
    Error('\p{Is_Nv=0.9}');
    Error('\P{Is_Nv=0.9}');
    Expect(1, 68028, '\p{Is_Nv=9.17e-01}', "");
    Expect(0, 68028, '\p{^Is_Nv=9.17e-01}', "");
    Expect(0, 68028, '\P{Is_Nv=9.17e-01}', "");
    Expect(1, 68028, '\P{^Is_Nv=9.17e-01}', "");
    Expect(0, 68029, '\p{Is_Nv=9.17e-01}', "");
    Expect(1, 68029, '\p{^Is_Nv=9.17e-01}', "");
    Expect(1, 68029, '\P{Is_Nv=9.17e-01}', "");
    Expect(0, 68029, '\P{^Is_Nv=9.17e-01}', "");
    Error('\p{Is_Nv:0.92}');
    Error('\P{Is_Nv:0.92}');
    Expect(1, 68028, '\p{Is_Nv:9.167e-01}', "");
    Expect(0, 68028, '\p{^Is_Nv:9.167e-01}', "");
    Expect(0, 68028, '\P{Is_Nv:9.167e-01}', "");
    Expect(1, 68028, '\P{^Is_Nv:9.167e-01}', "");
    Expect(0, 68029, '\p{Is_Nv:9.167e-01}', "");
    Expect(1, 68029, '\p{^Is_Nv:9.167e-01}', "");
    Expect(1, 68029, '\P{Is_Nv:9.167e-01}', "");
    Expect(0, 68029, '\P{^Is_Nv:9.167e-01}', "");
    Expect(1, 68028, '\p{Is_Nv=0.917}', "");
    Expect(0, 68028, '\p{^Is_Nv=0.917}', "");
    Expect(0, 68028, '\P{Is_Nv=0.917}', "");
    Expect(1, 68028, '\P{^Is_Nv=0.917}', "");
    Expect(0, 68029, '\p{Is_Nv=0.917}', "");
    Expect(1, 68029, '\p{^Is_Nv=0.917}', "");
    Expect(1, 68029, '\P{Is_Nv=0.917}', "");
    Expect(0, 68029, '\P{^Is_Nv=0.917}', "");
    Expect(1, 68028, '\p{Is_Nv=9.1667e-01}', "");
    Expect(0, 68028, '\p{^Is_Nv=9.1667e-01}', "");
    Expect(0, 68028, '\P{Is_Nv=9.1667e-01}', "");
    Expect(1, 68028, '\P{^Is_Nv=9.1667e-01}', "");
    Expect(0, 68029, '\p{Is_Nv=9.1667e-01}', "");
    Expect(1, 68029, '\p{^Is_Nv=9.1667e-01}', "");
    Expect(1, 68029, '\P{Is_Nv=9.1667e-01}', "");
    Expect(0, 68029, '\P{^Is_Nv=9.1667e-01}', "");
    Expect(1, 68028, '\p{Is_Nv=0.9167}', "");
    Expect(0, 68028, '\p{^Is_Nv=0.9167}', "");
    Expect(0, 68028, '\P{Is_Nv=0.9167}', "");
    Expect(1, 68028, '\P{^Is_Nv=0.9167}', "");
    Expect(0, 68029, '\p{Is_Nv=0.9167}', "");
    Expect(1, 68029, '\p{^Is_Nv=0.9167}', "");
    Expect(1, 68029, '\P{Is_Nv=0.9167}', "");
    Expect(0, 68029, '\P{^Is_Nv=0.9167}', "");
    Error('\p{Numeric_Value= :=+0000011/00000002}');
    Error('\P{Numeric_Value= :=+0000011/00000002}');
    Expect(1, 3887, '\p{Numeric_Value=:\A11/2\z:}', "");;
    Expect(0, 3888, '\p{Numeric_Value=:\A11/2\z:}', "");;
    Expect(1, 3887, '\p{Numeric_Value=0000011/000002}', "");
    Expect(0, 3887, '\p{^Numeric_Value=0000011/000002}', "");
    Expect(0, 3887, '\P{Numeric_Value=0000011/000002}', "");
    Expect(1, 3887, '\P{^Numeric_Value=0000011/000002}', "");
    Expect(0, 3888, '\p{Numeric_Value=0000011/000002}', "");
    Expect(1, 3888, '\p{^Numeric_Value=0000011/000002}', "");
    Expect(1, 3888, '\P{Numeric_Value=0000011/000002}', "");
    Expect(0, 3888, '\P{^Numeric_Value=0000011/000002}', "");
    Expect(1, 3887, '\p{Numeric_Value=660/120}', "");
    Expect(0, 3887, '\p{^Numeric_Value=660/120}', "");
    Expect(0, 3887, '\P{Numeric_Value=660/120}', "");
    Expect(1, 3887, '\P{^Numeric_Value=660/120}', "");
    Expect(0, 3888, '\p{Numeric_Value=660/120}', "");
    Expect(1, 3888, '\p{^Numeric_Value=660/120}', "");
    Expect(1, 3888, '\P{Numeric_Value=660/120}', "");
    Expect(0, 3888, '\P{^Numeric_Value=660/120}', "");
    Expect(1, 3887, '\p{Numeric_Value=5.5e+00}', "");
    Expect(0, 3887, '\p{^Numeric_Value=5.5e+00}', "");
    Expect(0, 3887, '\P{Numeric_Value=5.5e+00}', "");
    Expect(1, 3887, '\P{^Numeric_Value=5.5e+00}', "");
    Expect(0, 3888, '\p{Numeric_Value=5.5e+00}', "");
    Expect(1, 3888, '\p{^Numeric_Value=5.5e+00}', "");
    Expect(1, 3888, '\P{Numeric_Value=5.5e+00}', "");
    Expect(0, 3888, '\P{^Numeric_Value=5.5e+00}', "");
    Expect(1, 3887, '\p{Numeric_Value=5.5}', "");
    Expect(0, 3887, '\p{^Numeric_Value=5.5}', "");
    Expect(0, 3887, '\P{Numeric_Value=5.5}', "");
    Expect(1, 3887, '\P{^Numeric_Value=5.5}', "");
    Expect(0, 3888, '\p{Numeric_Value=5.5}', "");
    Expect(1, 3888, '\p{^Numeric_Value=5.5}', "");
    Expect(1, 3888, '\P{Numeric_Value=5.5}', "");
    Expect(0, 3888, '\P{^Numeric_Value=5.5}', "");
    Expect(1, 3887, '\p{Numeric_Value=5.50e+00}', "");
    Expect(0, 3887, '\p{^Numeric_Value=5.50e+00}', "");
    Expect(0, 3887, '\P{Numeric_Value=5.50e+00}', "");
    Expect(1, 3887, '\P{^Numeric_Value=5.50e+00}', "");
    Expect(0, 3888, '\p{Numeric_Value=5.50e+00}', "");
    Expect(1, 3888, '\p{^Numeric_Value=5.50e+00}', "");
    Expect(1, 3888, '\P{Numeric_Value=5.50e+00}', "");
    Expect(0, 3888, '\P{^Numeric_Value=5.50e+00}', "");
    Expect(1, 3887, '\p{Numeric_Value=5.50}', "");
    Expect(0, 3887, '\p{^Numeric_Value=5.50}', "");
    Expect(0, 3887, '\P{Numeric_Value=5.50}', "");
    Expect(1, 3887, '\P{^Numeric_Value=5.50}', "");
    Expect(0, 3888, '\p{Numeric_Value=5.50}', "");
    Expect(1, 3888, '\p{^Numeric_Value=5.50}', "");
    Expect(1, 3888, '\P{Numeric_Value=5.50}', "");
    Expect(0, 3888, '\P{^Numeric_Value=5.50}', "");
    Error('\p{Nv=/a/__0000000011/0002}');
    Error('\P{Nv=/a/__0000000011/0002}');
    Expect(1, 3887, '\p{Nv=:\A11/2\z:}', "");;
    Expect(0, 3888, '\p{Nv=:\A11/2\z:}', "");;
    Expect(1, 3887, '\p{Nv:   0000011/2}', "");
    Expect(0, 3887, '\p{^Nv:   0000011/2}', "");
    Expect(0, 3887, '\P{Nv:   0000011/2}', "");
    Expect(1, 3887, '\P{^Nv:   0000011/2}', "");
    Expect(0, 3888, '\p{Nv:   0000011/2}', "");
    Expect(1, 3888, '\p{^Nv:   0000011/2}', "");
    Expect(1, 3888, '\P{Nv:   0000011/2}', "");
    Expect(0, 3888, '\P{^Nv:   0000011/2}', "");
    Expect(1, 3887, '\p{Nv:   660/120}', "");
    Expect(0, 3887, '\p{^Nv:   660/120}', "");
    Expect(0, 3887, '\P{Nv:   660/120}', "");
    Expect(1, 3887, '\P{^Nv:   660/120}', "");
    Expect(0, 3888, '\p{Nv:   660/120}', "");
    Expect(1, 3888, '\p{^Nv:   660/120}', "");
    Expect(1, 3888, '\P{Nv:   660/120}', "");
    Expect(0, 3888, '\P{^Nv:   660/120}', "");
    Expect(1, 3887, '\p{Nv=5.5e+00}', "");
    Expect(0, 3887, '\p{^Nv=5.5e+00}', "");
    Expect(0, 3887, '\P{Nv=5.5e+00}', "");
    Expect(1, 3887, '\P{^Nv=5.5e+00}', "");
    Expect(0, 3888, '\p{Nv=5.5e+00}', "");
    Expect(1, 3888, '\p{^Nv=5.5e+00}', "");
    Expect(1, 3888, '\P{Nv=5.5e+00}', "");
    Expect(0, 3888, '\P{^Nv=5.5e+00}', "");
    Expect(1, 3887, '\p{Nv=5.5}', "");
    Expect(0, 3887, '\p{^Nv=5.5}', "");
    Expect(0, 3887, '\P{Nv=5.5}', "");
    Expect(1, 3887, '\P{^Nv=5.5}', "");
    Expect(0, 3888, '\p{Nv=5.5}', "");
    Expect(1, 3888, '\p{^Nv=5.5}', "");
    Expect(1, 3888, '\P{Nv=5.5}', "");
    Expect(0, 3888, '\P{^Nv=5.5}', "");
    Expect(1, 3887, '\p{Nv=5.50e+00}', "");
    Expect(0, 3887, '\p{^Nv=5.50e+00}', "");
    Expect(0, 3887, '\P{Nv=5.50e+00}', "");
    Expect(1, 3887, '\P{^Nv=5.50e+00}', "");
    Expect(0, 3888, '\p{Nv=5.50e+00}', "");
    Expect(1, 3888, '\p{^Nv=5.50e+00}', "");
    Expect(1, 3888, '\P{Nv=5.50e+00}', "");
    Expect(0, 3888, '\P{^Nv=5.50e+00}', "");
    Expect(1, 3887, '\p{Nv=5.50}', "");
    Expect(0, 3887, '\p{^Nv=5.50}', "");
    Expect(0, 3887, '\P{Nv=5.50}', "");
    Expect(1, 3887, '\P{^Nv=5.50}', "");
    Expect(0, 3888, '\p{Nv=5.50}', "");
    Expect(1, 3888, '\p{^Nv=5.50}', "");
    Expect(1, 3888, '\P{Nv=5.50}', "");
    Expect(0, 3888, '\P{^Nv=5.50}', "");
    Error('\p{Is_Numeric_Value=	_11/02:=}');
    Error('\P{Is_Numeric_Value=	_11/02:=}');
    Expect(1, 3887, '\p{Is_Numeric_Value=0011/2}', "");
    Expect(0, 3887, '\p{^Is_Numeric_Value=0011/2}', "");
    Expect(0, 3887, '\P{Is_Numeric_Value=0011/2}', "");
    Expect(1, 3887, '\P{^Is_Numeric_Value=0011/2}', "");
    Expect(0, 3888, '\p{Is_Numeric_Value=0011/2}', "");
    Expect(1, 3888, '\p{^Is_Numeric_Value=0011/2}', "");
    Expect(1, 3888, '\P{Is_Numeric_Value=0011/2}', "");
    Expect(0, 3888, '\P{^Is_Numeric_Value=0011/2}', "");
    Expect(1, 3887, '\p{Is_Numeric_Value=660/120}', "");
    Expect(0, 3887, '\p{^Is_Numeric_Value=660/120}', "");
    Expect(0, 3887, '\P{Is_Numeric_Value=660/120}', "");
    Expect(1, 3887, '\P{^Is_Numeric_Value=660/120}', "");
    Expect(0, 3888, '\p{Is_Numeric_Value=660/120}', "");
    Expect(1, 3888, '\p{^Is_Numeric_Value=660/120}', "");
    Expect(1, 3888, '\P{Is_Numeric_Value=660/120}', "");
    Expect(0, 3888, '\P{^Is_Numeric_Value=660/120}', "");
    Expect(1, 3887, '\p{Is_Numeric_Value=5.5e+00}', "");
    Expect(0, 3887, '\p{^Is_Numeric_Value=5.5e+00}', "");
    Expect(0, 3887, '\P{Is_Numeric_Value=5.5e+00}', "");
    Expect(1, 3887, '\P{^Is_Numeric_Value=5.5e+00}', "");
    Expect(0, 3888, '\p{Is_Numeric_Value=5.5e+00}', "");
    Expect(1, 3888, '\p{^Is_Numeric_Value=5.5e+00}', "");
    Expect(1, 3888, '\P{Is_Numeric_Value=5.5e+00}', "");
    Expect(0, 3888, '\P{^Is_Numeric_Value=5.5e+00}', "");
    Expect(1, 3887, '\p{Is_Numeric_Value=5.5}', "");
    Expect(0, 3887, '\p{^Is_Numeric_Value=5.5}', "");
    Expect(0, 3887, '\P{Is_Numeric_Value=5.5}', "");
    Expect(1, 3887, '\P{^Is_Numeric_Value=5.5}', "");
    Expect(0, 3888, '\p{Is_Numeric_Value=5.5}', "");
    Expect(1, 3888, '\p{^Is_Numeric_Value=5.5}', "");
    Expect(1, 3888, '\P{Is_Numeric_Value=5.5}', "");
    Expect(0, 3888, '\P{^Is_Numeric_Value=5.5}', "");
    Expect(1, 3887, '\p{Is_Numeric_Value=5.50e+00}', "");
    Expect(0, 3887, '\p{^Is_Numeric_Value=5.50e+00}', "");
    Expect(0, 3887, '\P{Is_Numeric_Value=5.50e+00}', "");
    Expect(1, 3887, '\P{^Is_Numeric_Value=5.50e+00}', "");
    Expect(0, 3888, '\p{Is_Numeric_Value=5.50e+00}', "");
    Expect(1, 3888, '\p{^Is_Numeric_Value=5.50e+00}', "");
    Expect(1, 3888, '\P{Is_Numeric_Value=5.50e+00}', "");
    Expect(0, 3888, '\P{^Is_Numeric_Value=5.50e+00}', "");
    Expect(1, 3887, '\p{Is_Numeric_Value=5.50}', "");
    Expect(0, 3887, '\p{^Is_Numeric_Value=5.50}', "");
    Expect(0, 3887, '\P{Is_Numeric_Value=5.50}', "");
    Expect(1, 3887, '\P{^Is_Numeric_Value=5.50}', "");
    Expect(0, 3888, '\p{Is_Numeric_Value=5.50}', "");
    Expect(1, 3888, '\p{^Is_Numeric_Value=5.50}', "");
    Expect(1, 3888, '\P{Is_Numeric_Value=5.50}', "");
    Expect(0, 3888, '\P{^Is_Numeric_Value=5.50}', "");
    Error('\p{Is_Nv=:=+0011/02}');
    Error('\P{Is_Nv=:=+0011/02}');
    Expect(1, 3887, '\p{Is_Nv=00011/000000002}', "");
    Expect(0, 3887, '\p{^Is_Nv=00011/000000002}', "");
    Expect(0, 3887, '\P{Is_Nv=00011/000000002}', "");
    Expect(1, 3887, '\P{^Is_Nv=00011/000000002}', "");
    Expect(0, 3888, '\p{Is_Nv=00011/000000002}', "");
    Expect(1, 3888, '\p{^Is_Nv=00011/000000002}', "");
    Expect(1, 3888, '\P{Is_Nv=00011/000000002}', "");
    Expect(0, 3888, '\P{^Is_Nv=00011/000000002}', "");
    Expect(1, 3887, '\p{Is_Nv=660/120}', "");
    Expect(0, 3887, '\p{^Is_Nv=660/120}', "");
    Expect(0, 3887, '\P{Is_Nv=660/120}', "");
    Expect(1, 3887, '\P{^Is_Nv=660/120}', "");
    Expect(0, 3888, '\p{Is_Nv=660/120}', "");
    Expect(1, 3888, '\p{^Is_Nv=660/120}', "");
    Expect(1, 3888, '\P{Is_Nv=660/120}', "");
    Expect(0, 3888, '\P{^Is_Nv=660/120}', "");
    Expect(1, 3887, '\p{Is_Nv:5.5e+00}', "");
    Expect(0, 3887, '\p{^Is_Nv:5.5e+00}', "");
    Expect(0, 3887, '\P{Is_Nv:5.5e+00}', "");
    Expect(1, 3887, '\P{^Is_Nv:5.5e+00}', "");
    Expect(0, 3888, '\p{Is_Nv:5.5e+00}', "");
    Expect(1, 3888, '\p{^Is_Nv:5.5e+00}', "");
    Expect(1, 3888, '\P{Is_Nv:5.5e+00}', "");
    Expect(0, 3888, '\P{^Is_Nv:5.5e+00}', "");
    Expect(1, 3887, '\p{Is_Nv=5.5}', "");
    Expect(0, 3887, '\p{^Is_Nv=5.5}', "");
    Expect(0, 3887, '\P{Is_Nv=5.5}', "");
    Expect(1, 3887, '\P{^Is_Nv=5.5}', "");
    Expect(0, 3888, '\p{Is_Nv=5.5}', "");
    Expect(1, 3888, '\p{^Is_Nv=5.5}', "");
    Expect(1, 3888, '\P{Is_Nv=5.5}', "");
    Expect(0, 3888, '\P{^Is_Nv=5.5}', "");
    Expect(1, 3887, '\p{Is_Nv=5.50e+00}', "");
    Expect(0, 3887, '\p{^Is_Nv=5.50e+00}', "");
    Expect(0, 3887, '\P{Is_Nv=5.50e+00}', "");
    Expect(1, 3887, '\P{^Is_Nv=5.50e+00}', "");
    Expect(0, 3888, '\p{Is_Nv=5.50e+00}', "");
    Expect(1, 3888, '\p{^Is_Nv=5.50e+00}', "");
    Expect(1, 3888, '\P{Is_Nv=5.50e+00}', "");
    Expect(0, 3888, '\P{^Is_Nv=5.50e+00}', "");
    Expect(1, 3887, '\p{Is_Nv=5.50}', "");
    Expect(0, 3887, '\p{^Is_Nv=5.50}', "");
    Expect(0, 3887, '\P{Is_Nv=5.50}', "");
    Expect(1, 3887, '\P{^Is_Nv=5.50}', "");
    Expect(0, 3888, '\p{Is_Nv=5.50}', "");
    Expect(1, 3888, '\p{^Is_Nv=5.50}', "");
    Expect(1, 3888, '\P{Is_Nv=5.50}', "");
    Expect(0, 3888, '\P{^Is_Nv=5.50}', "");
    Error('\p{Numeric_Value:	:=- 0_0_0_12}');
    Error('\P{Numeric_Value:	:=- 0_0_0_12}');
    Expect(1, 119532, '\p{Numeric_Value=:\A12\z:}', "");;
    Expect(0, 119533, '\p{Numeric_Value=:\A12\z:}', "");;
    Expect(1, 119532, '\p{Numeric_Value=0000012}', "");
    Expect(0, 119532, '\p{^Numeric_Value=0000012}', "");
    Expect(0, 119532, '\P{Numeric_Value=0000012}', "");
    Expect(1, 119532, '\P{^Numeric_Value=0000012}', "");
    Expect(0, 119533, '\p{Numeric_Value=0000012}', "");
    Expect(1, 119533, '\p{^Numeric_Value=0000012}', "");
    Expect(1, 119533, '\P{Numeric_Value=0000012}', "");
    Expect(0, 119533, '\P{^Numeric_Value=0000012}', "");
    Expect(1, 119532, '\p{Numeric_Value=1.200000000000000e+01}', "");
    Expect(0, 119532, '\p{^Numeric_Value=1.200000000000000e+01}', "");
    Expect(0, 119532, '\P{Numeric_Value=1.200000000000000e+01}', "");
    Expect(1, 119532, '\P{^Numeric_Value=1.200000000000000e+01}', "");
    Expect(0, 119533, '\p{Numeric_Value=1.200000000000000e+01}', "");
    Expect(1, 119533, '\p{^Numeric_Value=1.200000000000000e+01}', "");
    Expect(1, 119533, '\P{Numeric_Value=1.200000000000000e+01}', "");
    Expect(0, 119533, '\P{^Numeric_Value=1.200000000000000e+01}', "");
    Error('\p{Nv=/a/	01_2}');
    Error('\P{Nv=/a/	01_2}');
    Expect(1, 119532, '\p{Nv=:\A12\z:}', "");;
    Expect(0, 119533, '\p{Nv=:\A12\z:}', "");;
    Expect(1, 119532, '\p{Nv=00_00_00_00_01_2}', "");
    Expect(0, 119532, '\p{^Nv=00_00_00_00_01_2}', "");
    Expect(0, 119532, '\P{Nv=00_00_00_00_01_2}', "");
    Expect(1, 119532, '\P{^Nv=00_00_00_00_01_2}', "");
    Expect(0, 119533, '\p{Nv=00_00_00_00_01_2}', "");
    Expect(1, 119533, '\p{^Nv=00_00_00_00_01_2}', "");
    Expect(1, 119533, '\P{Nv=00_00_00_00_01_2}', "");
    Expect(0, 119533, '\P{^Nv=00_00_00_00_01_2}', "");
    Expect(1, 119532, '\p{Nv=1.200000000000000e+01}', "");
    Expect(0, 119532, '\p{^Nv=1.200000000000000e+01}', "");
    Expect(0, 119532, '\P{Nv=1.200000000000000e+01}', "");
    Expect(1, 119532, '\P{^Nv=1.200000000000000e+01}', "");
    Expect(0, 119533, '\p{Nv=1.200000000000000e+01}', "");
    Expect(1, 119533, '\p{^Nv=1.200000000000000e+01}', "");
    Expect(1, 119533, '\P{Nv=1.200000000000000e+01}', "");
    Expect(0, 119533, '\P{^Nv=1.200000000000000e+01}', "");
    Error('\p{Is_Numeric_Value=- 000_000_000_12/a/}');
    Error('\P{Is_Numeric_Value=- 000_000_000_12/a/}');
    Expect(1, 119532, '\p{Is_Numeric_Value=00_00_12}', "");
    Expect(0, 119532, '\p{^Is_Numeric_Value=00_00_12}', "");
    Expect(0, 119532, '\P{Is_Numeric_Value=00_00_12}', "");
    Expect(1, 119532, '\P{^Is_Numeric_Value=00_00_12}', "");
    Expect(0, 119533, '\p{Is_Numeric_Value=00_00_12}', "");
    Expect(1, 119533, '\p{^Is_Numeric_Value=00_00_12}', "");
    Expect(1, 119533, '\P{Is_Numeric_Value=00_00_12}', "");
    Expect(0, 119533, '\P{^Is_Numeric_Value=00_00_12}', "");
    Expect(1, 119532, '\p{Is_Numeric_Value:   1.200000000000000e+01}', "");
    Expect(0, 119532, '\p{^Is_Numeric_Value:   1.200000000000000e+01}', "");
    Expect(0, 119532, '\P{Is_Numeric_Value:   1.200000000000000e+01}', "");
    Expect(1, 119532, '\P{^Is_Numeric_Value:   1.200000000000000e+01}', "");
    Expect(0, 119533, '\p{Is_Numeric_Value:   1.200000000000000e+01}', "");
    Expect(1, 119533, '\p{^Is_Numeric_Value:   1.200000000000000e+01}', "");
    Expect(1, 119533, '\P{Is_Numeric_Value:   1.200000000000000e+01}', "");
    Expect(0, 119533, '\P{^Is_Numeric_Value:   1.200000000000000e+01}', "");
    Error('\p{Is_Nv=:=_-+0001_2}');
    Error('\P{Is_Nv=:=_-+0001_2}');
    Expect(1, 119532, '\p{Is_Nv=+000000012}', "");
    Expect(0, 119532, '\p{^Is_Nv=+000000012}', "");
    Expect(0, 119532, '\P{Is_Nv=+000000012}', "");
    Expect(1, 119532, '\P{^Is_Nv=+000000012}', "");
    Expect(0, 119533, '\p{Is_Nv=+000000012}', "");
    Expect(1, 119533, '\p{^Is_Nv=+000000012}', "");
    Expect(1, 119533, '\P{Is_Nv=+000000012}', "");
    Expect(0, 119533, '\P{^Is_Nv=+000000012}', "");
    Expect(1, 119532, '\p{Is_Nv=1.200000000000000e+01}', "");
    Expect(0, 119532, '\p{^Is_Nv=1.200000000000000e+01}', "");
    Expect(0, 119532, '\P{Is_Nv=1.200000000000000e+01}', "");
    Expect(1, 119532, '\P{^Is_Nv=1.200000000000000e+01}', "");
    Expect(0, 119533, '\p{Is_Nv=1.200000000000000e+01}', "");
    Expect(1, 119533, '\p{^Is_Nv=1.200000000000000e+01}', "");
    Expect(1, 119533, '\P{Is_Nv=1.200000000000000e+01}', "");
    Expect(0, 119533, '\P{^Is_Nv=1.200000000000000e+01}', "");
    Error('\p{Numeric_Value=-0000013:=}');
    Error('\P{Numeric_Value=-0000013:=}');
    Expect(1, 119533, '\p{Numeric_Value=:\A13\z:}', "");;
    Expect(0, 119534, '\p{Numeric_Value=:\A13\z:}', "");;
    Expect(1, 119533, '\p{Numeric_Value:	00000000013}', "");
    Expect(0, 119533, '\p{^Numeric_Value:	00000000013}', "");
    Expect(0, 119533, '\P{Numeric_Value:	00000000013}', "");
    Expect(1, 119533, '\P{^Numeric_Value:	00000000013}', "");
    Expect(0, 119534, '\p{Numeric_Value:	00000000013}', "");
    Expect(1, 119534, '\p{^Numeric_Value:	00000000013}', "");
    Expect(1, 119534, '\P{Numeric_Value:	00000000013}', "");
    Expect(0, 119534, '\P{^Numeric_Value:	00000000013}', "");
    Expect(1, 119533, '\p{Numeric_Value=1.300000000000000e+01}', "");
    Expect(0, 119533, '\p{^Numeric_Value=1.300000000000000e+01}', "");
    Expect(0, 119533, '\P{Numeric_Value=1.300000000000000e+01}', "");
    Expect(1, 119533, '\P{^Numeric_Value=1.300000000000000e+01}', "");
    Expect(0, 119534, '\p{Numeric_Value=1.300000000000000e+01}', "");
    Expect(1, 119534, '\p{^Numeric_Value=1.300000000000000e+01}', "");
    Expect(1, 119534, '\P{Numeric_Value=1.300000000000000e+01}', "");
    Expect(0, 119534, '\P{^Numeric_Value=1.300000000000000e+01}', "");
    Error('\p{Nv=_-00013/a/}');
    Error('\P{Nv=_-00013/a/}');
    Expect(1, 119533, '\p{Nv=:\A13\z:}', "");;
    Expect(0, 119534, '\p{Nv=:\A13\z:}', "");;
    Expect(1, 119533, '\p{Nv=0000000013}', "");
    Expect(0, 119533, '\p{^Nv=0000000013}', "");
    Expect(0, 119533, '\P{Nv=0000000013}', "");
    Expect(1, 119533, '\P{^Nv=0000000013}', "");
    Expect(0, 119534, '\p{Nv=0000000013}', "");
    Expect(1, 119534, '\p{^Nv=0000000013}', "");
    Expect(1, 119534, '\P{Nv=0000000013}', "");
    Expect(0, 119534, '\P{^Nv=0000000013}', "");
    Expect(1, 119533, '\p{Nv=1.300000000000000e+01}', "");
    Expect(0, 119533, '\p{^Nv=1.300000000000000e+01}', "");
    Expect(0, 119533, '\P{Nv=1.300000000000000e+01}', "");
    Expect(1, 119533, '\P{^Nv=1.300000000000000e+01}', "");
    Expect(0, 119534, '\p{Nv=1.300000000000000e+01}', "");
    Expect(1, 119534, '\p{^Nv=1.300000000000000e+01}', "");
    Expect(1, 119534, '\P{Nv=1.300000000000000e+01}', "");
    Expect(0, 119534, '\P{^Nv=1.300000000000000e+01}', "");
    Error('\p{Is_Numeric_Value=	:=+0_0_0_13}');
    Error('\P{Is_Numeric_Value=	:=+0_0_0_13}');
    Expect(1, 119533, '\p{Is_Numeric_Value: 0_0_0_0_0_0_13}', "");
    Expect(0, 119533, '\p{^Is_Numeric_Value: 0_0_0_0_0_0_13}', "");
    Expect(0, 119533, '\P{Is_Numeric_Value: 0_0_0_0_0_0_13}', "");
    Expect(1, 119533, '\P{^Is_Numeric_Value: 0_0_0_0_0_0_13}', "");
    Expect(0, 119534, '\p{Is_Numeric_Value: 0_0_0_0_0_0_13}', "");
    Expect(1, 119534, '\p{^Is_Numeric_Value: 0_0_0_0_0_0_13}', "");
    Expect(1, 119534, '\P{Is_Numeric_Value: 0_0_0_0_0_0_13}', "");
    Expect(0, 119534, '\P{^Is_Numeric_Value: 0_0_0_0_0_0_13}', "");
    Expect(1, 119533, '\p{Is_Numeric_Value=1.300000000000000e+01}', "");
    Expect(0, 119533, '\p{^Is_Numeric_Value=1.300000000000000e+01}', "");
    Expect(0, 119533, '\P{Is_Numeric_Value=1.300000000000000e+01}', "");
    Expect(1, 119533, '\P{^Is_Numeric_Value=1.300000000000000e+01}', "");
    Expect(0, 119534, '\p{Is_Numeric_Value=1.300000000000000e+01}', "");
    Expect(1, 119534, '\p{^Is_Numeric_Value=1.300000000000000e+01}', "");
    Expect(1, 119534, '\P{Is_Numeric_Value=1.300000000000000e+01}', "");
    Expect(0, 119534, '\P{^Is_Numeric_Value=1.300000000000000e+01}', "");
    Error('\p{Is_Nv=/a/-0_0_0_0_0_0_0_0_013}');
    Error('\P{Is_Nv=/a/-0_0_0_0_0_0_0_0_013}');
    Expect(1, 119533, '\p{Is_Nv=+00000000013}', "");
    Expect(0, 119533, '\p{^Is_Nv=+00000000013}', "");
    Expect(0, 119533, '\P{Is_Nv=+00000000013}', "");
    Expect(1, 119533, '\P{^Is_Nv=+00000000013}', "");
    Expect(0, 119534, '\p{Is_Nv=+00000000013}', "");
    Expect(1, 119534, '\p{^Is_Nv=+00000000013}', "");
    Expect(1, 119534, '\P{Is_Nv=+00000000013}', "");
    Expect(0, 119534, '\P{^Is_Nv=+00000000013}', "");
    Expect(1, 119533, '\p{Is_Nv=1.300000000000000e+01}', "");
    Expect(0, 119533, '\p{^Is_Nv=1.300000000000000e+01}', "");
    Expect(0, 119533, '\P{Is_Nv=1.300000000000000e+01}', "");
    Expect(1, 119533, '\P{^Is_Nv=1.300000000000000e+01}', "");
    Expect(0, 119534, '\p{Is_Nv=1.300000000000000e+01}', "");
    Expect(1, 119534, '\p{^Is_Nv=1.300000000000000e+01}', "");
    Expect(1, 119534, '\P{Is_Nv=1.300000000000000e+01}', "");
    Expect(0, 119534, '\P{^Is_Nv=1.300000000000000e+01}', "");
    Error('\p{Numeric_Value=-:=00013/00002}');
    Error('\P{Numeric_Value=-:=00013/00002}');
    Expect(1, 3888, '\p{Numeric_Value=:\A13/2\z:}', "");;
    Expect(0, 3889, '\p{Numeric_Value=:\A13/2\z:}', "");;
    Expect(1, 3888, '\p{Numeric_Value=+00000013/02}', "");
    Expect(0, 3888, '\p{^Numeric_Value=+00000013/02}', "");
    Expect(0, 3888, '\P{Numeric_Value=+00000013/02}', "");
    Expect(1, 3888, '\P{^Numeric_Value=+00000013/02}', "");
    Expect(0, 3889, '\p{Numeric_Value=+00000013/02}', "");
    Expect(1, 3889, '\p{^Numeric_Value=+00000013/02}', "");
    Expect(1, 3889, '\P{Numeric_Value=+00000013/02}', "");
    Expect(0, 3889, '\P{^Numeric_Value=+00000013/02}', "");
    Expect(1, 3888, '\p{Numeric_Value=780/120}', "");
    Expect(0, 3888, '\p{^Numeric_Value=780/120}', "");
    Expect(0, 3888, '\P{Numeric_Value=780/120}', "");
    Expect(1, 3888, '\P{^Numeric_Value=780/120}', "");
    Expect(0, 3889, '\p{Numeric_Value=780/120}', "");
    Expect(1, 3889, '\p{^Numeric_Value=780/120}', "");
    Expect(1, 3889, '\P{Numeric_Value=780/120}', "");
    Expect(0, 3889, '\P{^Numeric_Value=780/120}', "");
    Expect(1, 3888, '\p{Numeric_Value=6.5e+00}', "");
    Expect(0, 3888, '\p{^Numeric_Value=6.5e+00}', "");
    Expect(0, 3888, '\P{Numeric_Value=6.5e+00}', "");
    Expect(1, 3888, '\P{^Numeric_Value=6.5e+00}', "");
    Expect(0, 3889, '\p{Numeric_Value=6.5e+00}', "");
    Expect(1, 3889, '\p{^Numeric_Value=6.5e+00}', "");
    Expect(1, 3889, '\P{Numeric_Value=6.5e+00}', "");
    Expect(0, 3889, '\P{^Numeric_Value=6.5e+00}', "");
    Expect(1, 3888, '\p{Numeric_Value=6.5}', "");
    Expect(0, 3888, '\p{^Numeric_Value=6.5}', "");
    Expect(0, 3888, '\P{Numeric_Value=6.5}', "");
    Expect(1, 3888, '\P{^Numeric_Value=6.5}', "");
    Expect(0, 3889, '\p{Numeric_Value=6.5}', "");
    Expect(1, 3889, '\p{^Numeric_Value=6.5}', "");
    Expect(1, 3889, '\P{Numeric_Value=6.5}', "");
    Expect(0, 3889, '\P{^Numeric_Value=6.5}', "");
    Expect(1, 3888, '\p{Numeric_Value=6.50e+00}', "");
    Expect(0, 3888, '\p{^Numeric_Value=6.50e+00}', "");
    Expect(0, 3888, '\P{Numeric_Value=6.50e+00}', "");
    Expect(1, 3888, '\P{^Numeric_Value=6.50e+00}', "");
    Expect(0, 3889, '\p{Numeric_Value=6.50e+00}', "");
    Expect(1, 3889, '\p{^Numeric_Value=6.50e+00}', "");
    Expect(1, 3889, '\P{Numeric_Value=6.50e+00}', "");
    Expect(0, 3889, '\P{^Numeric_Value=6.50e+00}', "");
    Expect(1, 3888, '\p{Numeric_Value=6.50}', "");
    Expect(0, 3888, '\p{^Numeric_Value=6.50}', "");
    Expect(0, 3888, '\P{Numeric_Value=6.50}', "");
    Expect(1, 3888, '\P{^Numeric_Value=6.50}', "");
    Expect(0, 3889, '\p{Numeric_Value=6.50}', "");
    Expect(1, 3889, '\p{^Numeric_Value=6.50}', "");
    Expect(1, 3889, '\P{Numeric_Value=6.50}', "");
    Expect(0, 3889, '\P{^Numeric_Value=6.50}', "");
    Error('\p{Nv=/a/		00000013/000002}');
    Error('\P{Nv=/a/		00000013/000002}');
    Expect(1, 3888, '\p{Nv=:\A13/2\z:}', "");;
    Expect(0, 3889, '\p{Nv=:\A13/2\z:}', "");;
    Expect(1, 3888, '\p{Nv=+00000000013/00000002}', "");
    Expect(0, 3888, '\p{^Nv=+00000000013/00000002}', "");
    Expect(0, 3888, '\P{Nv=+00000000013/00000002}', "");
    Expect(1, 3888, '\P{^Nv=+00000000013/00000002}', "");
    Expect(0, 3889, '\p{Nv=+00000000013/00000002}', "");
    Expect(1, 3889, '\p{^Nv=+00000000013/00000002}', "");
    Expect(1, 3889, '\P{Nv=+00000000013/00000002}', "");
    Expect(0, 3889, '\P{^Nv=+00000000013/00000002}', "");
    Expect(1, 3888, '\p{Nv=780/120}', "");
    Expect(0, 3888, '\p{^Nv=780/120}', "");
    Expect(0, 3888, '\P{Nv=780/120}', "");
    Expect(1, 3888, '\P{^Nv=780/120}', "");
    Expect(0, 3889, '\p{Nv=780/120}', "");
    Expect(1, 3889, '\p{^Nv=780/120}', "");
    Expect(1, 3889, '\P{Nv=780/120}', "");
    Expect(0, 3889, '\P{^Nv=780/120}', "");
    Expect(1, 3888, '\p{Nv=6.5e+00}', "");
    Expect(0, 3888, '\p{^Nv=6.5e+00}', "");
    Expect(0, 3888, '\P{Nv=6.5e+00}', "");
    Expect(1, 3888, '\P{^Nv=6.5e+00}', "");
    Expect(0, 3889, '\p{Nv=6.5e+00}', "");
    Expect(1, 3889, '\p{^Nv=6.5e+00}', "");
    Expect(1, 3889, '\P{Nv=6.5e+00}', "");
    Expect(0, 3889, '\P{^Nv=6.5e+00}', "");
    Expect(1, 3888, '\p{Nv=6.5}', "");
    Expect(0, 3888, '\p{^Nv=6.5}', "");
    Expect(0, 3888, '\P{Nv=6.5}', "");
    Expect(1, 3888, '\P{^Nv=6.5}', "");
    Expect(0, 3889, '\p{Nv=6.5}', "");
    Expect(1, 3889, '\p{^Nv=6.5}', "");
    Expect(1, 3889, '\P{Nv=6.5}', "");
    Expect(0, 3889, '\P{^Nv=6.5}', "");
    Expect(1, 3888, '\p{Nv=6.50e+00}', "");
    Expect(0, 3888, '\p{^Nv=6.50e+00}', "");
    Expect(0, 3888, '\P{Nv=6.50e+00}', "");
    Expect(1, 3888, '\P{^Nv=6.50e+00}', "");
    Expect(0, 3889, '\p{Nv=6.50e+00}', "");
    Expect(1, 3889, '\p{^Nv=6.50e+00}', "");
    Expect(1, 3889, '\P{Nv=6.50e+00}', "");
    Expect(0, 3889, '\P{^Nv=6.50e+00}', "");
    Expect(1, 3888, '\p{Nv=6.50}', "");
    Expect(0, 3888, '\p{^Nv=6.50}', "");
    Expect(0, 3888, '\P{Nv=6.50}', "");
    Expect(1, 3888, '\P{^Nv=6.50}', "");
    Expect(0, 3889, '\p{Nv=6.50}', "");
    Expect(1, 3889, '\p{^Nv=6.50}', "");
    Expect(1, 3889, '\P{Nv=6.50}', "");
    Expect(0, 3889, '\P{^Nv=6.50}', "");
    Error('\p{Is_Numeric_Value=:=	+000013/00002}');
    Error('\P{Is_Numeric_Value=:=	+000013/00002}');
    Expect(1, 3888, '\p{Is_Numeric_Value=0000013/0000002}', "");
    Expect(0, 3888, '\p{^Is_Numeric_Value=0000013/0000002}', "");
    Expect(0, 3888, '\P{Is_Numeric_Value=0000013/0000002}', "");
    Expect(1, 3888, '\P{^Is_Numeric_Value=0000013/0000002}', "");
    Expect(0, 3889, '\p{Is_Numeric_Value=0000013/0000002}', "");
    Expect(1, 3889, '\p{^Is_Numeric_Value=0000013/0000002}', "");
    Expect(1, 3889, '\P{Is_Numeric_Value=0000013/0000002}', "");
    Expect(0, 3889, '\P{^Is_Numeric_Value=0000013/0000002}', "");
    Expect(1, 3888, '\p{Is_Numeric_Value=780/120}', "");
    Expect(0, 3888, '\p{^Is_Numeric_Value=780/120}', "");
    Expect(0, 3888, '\P{Is_Numeric_Value=780/120}', "");
    Expect(1, 3888, '\P{^Is_Numeric_Value=780/120}', "");
    Expect(0, 3889, '\p{Is_Numeric_Value=780/120}', "");
    Expect(1, 3889, '\p{^Is_Numeric_Value=780/120}', "");
    Expect(1, 3889, '\P{Is_Numeric_Value=780/120}', "");
    Expect(0, 3889, '\P{^Is_Numeric_Value=780/120}', "");
    Expect(1, 3888, '\p{Is_Numeric_Value:   6.5e+00}', "");
    Expect(0, 3888, '\p{^Is_Numeric_Value:   6.5e+00}', "");
    Expect(0, 3888, '\P{Is_Numeric_Value:   6.5e+00}', "");
    Expect(1, 3888, '\P{^Is_Numeric_Value:   6.5e+00}', "");
    Expect(0, 3889, '\p{Is_Numeric_Value:   6.5e+00}', "");
    Expect(1, 3889, '\p{^Is_Numeric_Value:   6.5e+00}', "");
    Expect(1, 3889, '\P{Is_Numeric_Value:   6.5e+00}', "");
    Expect(0, 3889, '\P{^Is_Numeric_Value:   6.5e+00}', "");
    Expect(1, 3888, '\p{Is_Numeric_Value:6.5}', "");
    Expect(0, 3888, '\p{^Is_Numeric_Value:6.5}', "");
    Expect(0, 3888, '\P{Is_Numeric_Value:6.5}', "");
    Expect(1, 3888, '\P{^Is_Numeric_Value:6.5}', "");
    Expect(0, 3889, '\p{Is_Numeric_Value:6.5}', "");
    Expect(1, 3889, '\p{^Is_Numeric_Value:6.5}', "");
    Expect(1, 3889, '\P{Is_Numeric_Value:6.5}', "");
    Expect(0, 3889, '\P{^Is_Numeric_Value:6.5}', "");
    Expect(1, 3888, '\p{Is_Numeric_Value=6.50e+00}', "");
    Expect(0, 3888, '\p{^Is_Numeric_Value=6.50e+00}', "");
    Expect(0, 3888, '\P{Is_Numeric_Value=6.50e+00}', "");
    Expect(1, 3888, '\P{^Is_Numeric_Value=6.50e+00}', "");
    Expect(0, 3889, '\p{Is_Numeric_Value=6.50e+00}', "");
    Expect(1, 3889, '\p{^Is_Numeric_Value=6.50e+00}', "");
    Expect(1, 3889, '\P{Is_Numeric_Value=6.50e+00}', "");
    Expect(0, 3889, '\P{^Is_Numeric_Value=6.50e+00}', "");
    Expect(1, 3888, '\p{Is_Numeric_Value=6.50}', "");
    Expect(0, 3888, '\p{^Is_Numeric_Value=6.50}', "");
    Expect(0, 3888, '\P{Is_Numeric_Value=6.50}', "");
    Expect(1, 3888, '\P{^Is_Numeric_Value=6.50}', "");
    Expect(0, 3889, '\p{Is_Numeric_Value=6.50}', "");
    Expect(1, 3889, '\p{^Is_Numeric_Value=6.50}', "");
    Expect(1, 3889, '\P{Is_Numeric_Value=6.50}', "");
    Expect(0, 3889, '\P{^Is_Numeric_Value=6.50}', "");
    Error('\p{Is_Nv:   	/a/+00013/0002}');
    Error('\P{Is_Nv:   	/a/+00013/0002}');
    Expect(1, 3888, '\p{Is_Nv=0013/000000002}', "");
    Expect(0, 3888, '\p{^Is_Nv=0013/000000002}', "");
    Expect(0, 3888, '\P{Is_Nv=0013/000000002}', "");
    Expect(1, 3888, '\P{^Is_Nv=0013/000000002}', "");
    Expect(0, 3889, '\p{Is_Nv=0013/000000002}', "");
    Expect(1, 3889, '\p{^Is_Nv=0013/000000002}', "");
    Expect(1, 3889, '\P{Is_Nv=0013/000000002}', "");
    Expect(0, 3889, '\P{^Is_Nv=0013/000000002}', "");
    Expect(1, 3888, '\p{Is_Nv=780/120}', "");
    Expect(0, 3888, '\p{^Is_Nv=780/120}', "");
    Expect(0, 3888, '\P{Is_Nv=780/120}', "");
    Expect(1, 3888, '\P{^Is_Nv=780/120}', "");
    Expect(0, 3889, '\p{Is_Nv=780/120}', "");
    Expect(1, 3889, '\p{^Is_Nv=780/120}', "");
    Expect(1, 3889, '\P{Is_Nv=780/120}', "");
    Expect(0, 3889, '\P{^Is_Nv=780/120}', "");
    Expect(1, 3888, '\p{Is_Nv=6.5e+00}', "");
    Expect(0, 3888, '\p{^Is_Nv=6.5e+00}', "");
    Expect(0, 3888, '\P{Is_Nv=6.5e+00}', "");
    Expect(1, 3888, '\P{^Is_Nv=6.5e+00}', "");
    Expect(0, 3889, '\p{Is_Nv=6.5e+00}', "");
    Expect(1, 3889, '\p{^Is_Nv=6.5e+00}', "");
    Expect(1, 3889, '\P{Is_Nv=6.5e+00}', "");
    Expect(0, 3889, '\P{^Is_Nv=6.5e+00}', "");
    Expect(1, 3888, '\p{Is_Nv=6.5}', "");
    Expect(0, 3888, '\p{^Is_Nv=6.5}', "");
    Expect(0, 3888, '\P{Is_Nv=6.5}', "");
    Expect(1, 3888, '\P{^Is_Nv=6.5}', "");
    Expect(0, 3889, '\p{Is_Nv=6.5}', "");
    Expect(1, 3889, '\p{^Is_Nv=6.5}', "");
    Expect(1, 3889, '\P{Is_Nv=6.5}', "");
    Expect(0, 3889, '\P{^Is_Nv=6.5}', "");
    Expect(1, 3888, '\p{Is_Nv=6.50e+00}', "");
    Expect(0, 3888, '\p{^Is_Nv=6.50e+00}', "");
    Expect(0, 3888, '\P{Is_Nv=6.50e+00}', "");
    Expect(1, 3888, '\P{^Is_Nv=6.50e+00}', "");
    Expect(0, 3889, '\p{Is_Nv=6.50e+00}', "");
    Expect(1, 3889, '\p{^Is_Nv=6.50e+00}', "");
    Expect(1, 3889, '\P{Is_Nv=6.50e+00}', "");
    Expect(0, 3889, '\P{^Is_Nv=6.50e+00}', "");
    Expect(1, 3888, '\p{Is_Nv=6.50}', "");
    Expect(0, 3888, '\p{^Is_Nv=6.50}', "");
    Expect(0, 3888, '\P{Is_Nv=6.50}', "");
    Expect(1, 3888, '\P{^Is_Nv=6.50}', "");
    Expect(0, 3889, '\p{Is_Nv=6.50}', "");
    Expect(1, 3889, '\p{^Is_Nv=6.50}', "");
    Expect(1, 3889, '\P{Is_Nv=6.50}', "");
    Expect(0, 3889, '\P{^Is_Nv=6.50}', "");
    Error('\p{Numeric_Value=  +14/a/}');
    Error('\P{Numeric_Value=  +14/a/}');
    Expect(1, 119534, '\p{Numeric_Value=:\A14\z:}', "");;
    Expect(0, 119535, '\p{Numeric_Value=:\A14\z:}', "");;
    Expect(1, 119534, '\p{Numeric_Value=000014}', "");
    Expect(0, 119534, '\p{^Numeric_Value=000014}', "");
    Expect(0, 119534, '\P{Numeric_Value=000014}', "");
    Expect(1, 119534, '\P{^Numeric_Value=000014}', "");
    Expect(0, 119535, '\p{Numeric_Value=000014}', "");
    Expect(1, 119535, '\p{^Numeric_Value=000014}', "");
    Expect(1, 119535, '\P{Numeric_Value=000014}', "");
    Expect(0, 119535, '\P{^Numeric_Value=000014}', "");
    Expect(1, 119534, '\p{Numeric_Value=1.400000000000000e+01}', "");
    Expect(0, 119534, '\p{^Numeric_Value=1.400000000000000e+01}', "");
    Expect(0, 119534, '\P{Numeric_Value=1.400000000000000e+01}', "");
    Expect(1, 119534, '\P{^Numeric_Value=1.400000000000000e+01}', "");
    Expect(0, 119535, '\p{Numeric_Value=1.400000000000000e+01}', "");
    Expect(1, 119535, '\p{^Numeric_Value=1.400000000000000e+01}', "");
    Expect(1, 119535, '\P{Numeric_Value=1.400000000000000e+01}', "");
    Expect(0, 119535, '\P{^Numeric_Value=1.400000000000000e+01}', "");
    Error('\p{Nv=:=+0014}');
    Error('\P{Nv=:=+0014}');
    Expect(1, 119534, '\p{Nv=:\A14\z:}', "");;
    Expect(0, 119535, '\p{Nv=:\A14\z:}', "");;
    Expect(1, 119534, '\p{Nv=+0_0_0_0_0_0_0_14}', "");
    Expect(0, 119534, '\p{^Nv=+0_0_0_0_0_0_0_14}', "");
    Expect(0, 119534, '\P{Nv=+0_0_0_0_0_0_0_14}', "");
    Expect(1, 119534, '\P{^Nv=+0_0_0_0_0_0_0_14}', "");
    Expect(0, 119535, '\p{Nv=+0_0_0_0_0_0_0_14}', "");
    Expect(1, 119535, '\p{^Nv=+0_0_0_0_0_0_0_14}', "");
    Expect(1, 119535, '\P{Nv=+0_0_0_0_0_0_0_14}', "");
    Expect(0, 119535, '\P{^Nv=+0_0_0_0_0_0_0_14}', "");
    Expect(1, 119534, '\p{Nv=1.400000000000000e+01}', "");
    Expect(0, 119534, '\p{^Nv=1.400000000000000e+01}', "");
    Expect(0, 119534, '\P{Nv=1.400000000000000e+01}', "");
    Expect(1, 119534, '\P{^Nv=1.400000000000000e+01}', "");
    Expect(0, 119535, '\p{Nv=1.400000000000000e+01}', "");
    Expect(1, 119535, '\p{^Nv=1.400000000000000e+01}', "");
    Expect(1, 119535, '\P{Nv=1.400000000000000e+01}', "");
    Expect(0, 119535, '\P{^Nv=1.400000000000000e+01}', "");
    Error('\p{Is_Numeric_Value=/a/--0000014}');
    Error('\P{Is_Numeric_Value=/a/--0000014}');
    Expect(1, 119534, '\p{Is_Numeric_Value:0_0_0_0_0_0_0_14}', "");
    Expect(0, 119534, '\p{^Is_Numeric_Value:0_0_0_0_0_0_0_14}', "");
    Expect(0, 119534, '\P{Is_Numeric_Value:0_0_0_0_0_0_0_14}', "");
    Expect(1, 119534, '\P{^Is_Numeric_Value:0_0_0_0_0_0_0_14}', "");
    Expect(0, 119535, '\p{Is_Numeric_Value:0_0_0_0_0_0_0_14}', "");
    Expect(1, 119535, '\p{^Is_Numeric_Value:0_0_0_0_0_0_0_14}', "");
    Expect(1, 119535, '\P{Is_Numeric_Value:0_0_0_0_0_0_0_14}', "");
    Expect(0, 119535, '\P{^Is_Numeric_Value:0_0_0_0_0_0_0_14}', "");
    Expect(1, 119534, '\p{Is_Numeric_Value=1.400000000000000e+01}', "");
    Expect(0, 119534, '\p{^Is_Numeric_Value=1.400000000000000e+01}', "");
    Expect(0, 119534, '\P{Is_Numeric_Value=1.400000000000000e+01}', "");
    Expect(1, 119534, '\P{^Is_Numeric_Value=1.400000000000000e+01}', "");
    Expect(0, 119535, '\p{Is_Numeric_Value=1.400000000000000e+01}', "");
    Expect(1, 119535, '\p{^Is_Numeric_Value=1.400000000000000e+01}', "");
    Expect(1, 119535, '\P{Is_Numeric_Value=1.400000000000000e+01}', "");
    Expect(0, 119535, '\P{^Is_Numeric_Value=1.400000000000000e+01}', "");
    Error('\p{Is_Nv:/a/-14}');
    Error('\P{Is_Nv:/a/-14}');
    Expect(1, 119534, '\p{Is_Nv=000000001_4}', "");
    Expect(0, 119534, '\p{^Is_Nv=000000001_4}', "");
    Expect(0, 119534, '\P{Is_Nv=000000001_4}', "");
    Expect(1, 119534, '\P{^Is_Nv=000000001_4}', "");
    Expect(0, 119535, '\p{Is_Nv=000000001_4}', "");
    Expect(1, 119535, '\p{^Is_Nv=000000001_4}', "");
    Expect(1, 119535, '\P{Is_Nv=000000001_4}', "");
    Expect(0, 119535, '\P{^Is_Nv=000000001_4}', "");
    Expect(1, 119534, '\p{Is_Nv=1.400000000000000e+01}', "");
    Expect(0, 119534, '\p{^Is_Nv=1.400000000000000e+01}', "");
    Expect(0, 119534, '\P{Is_Nv=1.400000000000000e+01}', "");
    Expect(1, 119534, '\P{^Is_Nv=1.400000000000000e+01}', "");
    Expect(0, 119535, '\p{Is_Nv=1.400000000000000e+01}', "");
    Expect(1, 119535, '\p{^Is_Nv=1.400000000000000e+01}', "");
    Expect(1, 119535, '\P{Is_Nv=1.400000000000000e+01}', "");
    Expect(0, 119535, '\P{^Is_Nv=1.400000000000000e+01}', "");
    Error('\p{Numeric_Value=-_00000015:=}');
    Error('\P{Numeric_Value=-_00000015:=}');
    Expect(1, 119535, '\p{Numeric_Value=:\A15\z:}', "");;
    Expect(0, 119536, '\p{Numeric_Value=:\A15\z:}', "");;
    Expect(1, 119535, '\p{Numeric_Value=+0_0_15}', "");
    Expect(0, 119535, '\p{^Numeric_Value=+0_0_15}', "");
    Expect(0, 119535, '\P{Numeric_Value=+0_0_15}', "");
    Expect(1, 119535, '\P{^Numeric_Value=+0_0_15}', "");
    Expect(0, 119536, '\p{Numeric_Value=+0_0_15}', "");
    Expect(1, 119536, '\p{^Numeric_Value=+0_0_15}', "");
    Expect(1, 119536, '\P{Numeric_Value=+0_0_15}', "");
    Expect(0, 119536, '\P{^Numeric_Value=+0_0_15}', "");
    Expect(1, 119535, '\p{Numeric_Value:1.500000000000000e+01}', "");
    Expect(0, 119535, '\p{^Numeric_Value:1.500000000000000e+01}', "");
    Expect(0, 119535, '\P{Numeric_Value:1.500000000000000e+01}', "");
    Expect(1, 119535, '\P{^Numeric_Value:1.500000000000000e+01}', "");
    Expect(0, 119536, '\p{Numeric_Value:1.500000000000000e+01}', "");
    Expect(1, 119536, '\p{^Numeric_Value:1.500000000000000e+01}', "");
    Expect(1, 119536, '\P{Numeric_Value:1.500000000000000e+01}', "");
    Expect(0, 119536, '\P{^Numeric_Value:1.500000000000000e+01}', "");
    Error('\p{Nv=		+000_000_000_15:=}');
    Error('\P{Nv=		+000_000_000_15:=}');
    Expect(1, 119535, '\p{Nv=:\A15\z:}', "");;
    Expect(0, 119536, '\p{Nv=:\A15\z:}', "");;
    Expect(1, 119535, '\p{Nv=15}', "");
    Expect(0, 119535, '\p{^Nv=15}', "");
    Expect(0, 119535, '\P{Nv=15}', "");
    Expect(1, 119535, '\P{^Nv=15}', "");
    Expect(0, 119536, '\p{Nv=15}', "");
    Expect(1, 119536, '\p{^Nv=15}', "");
    Expect(1, 119536, '\P{Nv=15}', "");
    Expect(0, 119536, '\P{^Nv=15}', "");
    Expect(1, 119535, '\p{Nv=1.500000000000000e+01}', "");
    Expect(0, 119535, '\p{^Nv=1.500000000000000e+01}', "");
    Expect(0, 119535, '\P{Nv=1.500000000000000e+01}', "");
    Expect(1, 119535, '\P{^Nv=1.500000000000000e+01}', "");
    Expect(0, 119536, '\p{Nv=1.500000000000000e+01}', "");
    Expect(1, 119536, '\p{^Nv=1.500000000000000e+01}', "");
    Expect(1, 119536, '\P{Nv=1.500000000000000e+01}', "");
    Expect(0, 119536, '\P{^Nv=1.500000000000000e+01}', "");
    Error('\p{Is_Numeric_Value=	:=+000000015}');
    Error('\P{Is_Numeric_Value=	:=+000000015}');
    Expect(1, 119535, '\p{Is_Numeric_Value=001_5}', "");
    Expect(0, 119535, '\p{^Is_Numeric_Value=001_5}', "");
    Expect(0, 119535, '\P{Is_Numeric_Value=001_5}', "");
    Expect(1, 119535, '\P{^Is_Numeric_Value=001_5}', "");
    Expect(0, 119536, '\p{Is_Numeric_Value=001_5}', "");
    Expect(1, 119536, '\p{^Is_Numeric_Value=001_5}', "");
    Expect(1, 119536, '\P{Is_Numeric_Value=001_5}', "");
    Expect(0, 119536, '\P{^Is_Numeric_Value=001_5}', "");
    Expect(1, 119535, '\p{Is_Numeric_Value=1.500000000000000e+01}', "");
    Expect(0, 119535, '\p{^Is_Numeric_Value=1.500000000000000e+01}', "");
    Expect(0, 119535, '\P{Is_Numeric_Value=1.500000000000000e+01}', "");
    Expect(1, 119535, '\P{^Is_Numeric_Value=1.500000000000000e+01}', "");
    Expect(0, 119536, '\p{Is_Numeric_Value=1.500000000000000e+01}', "");
    Expect(1, 119536, '\p{^Is_Numeric_Value=1.500000000000000e+01}', "");
    Expect(1, 119536, '\P{Is_Numeric_Value=1.500000000000000e+01}', "");
    Expect(0, 119536, '\P{^Is_Numeric_Value=1.500000000000000e+01}', "");
    Error('\p{Is_Nv= 	+0_0_0_0_0_0_00015:=}');
    Error('\P{Is_Nv= 	+0_0_0_0_0_0_00015:=}');
    Expect(1, 119535, '\p{Is_Nv=0_0_0_0_0_0_0015}', "");
    Expect(0, 119535, '\p{^Is_Nv=0_0_0_0_0_0_0015}', "");
    Expect(0, 119535, '\P{Is_Nv=0_0_0_0_0_0_0015}', "");
    Expect(1, 119535, '\P{^Is_Nv=0_0_0_0_0_0_0015}', "");
    Expect(0, 119536, '\p{Is_Nv=0_0_0_0_0_0_0015}', "");
    Expect(1, 119536, '\p{^Is_Nv=0_0_0_0_0_0_0015}', "");
    Expect(1, 119536, '\P{Is_Nv=0_0_0_0_0_0_0015}', "");
    Expect(0, 119536, '\P{^Is_Nv=0_0_0_0_0_0_0015}', "");
    Expect(1, 119535, '\p{Is_Nv=1.500000000000000e+01}', "");
    Expect(0, 119535, '\p{^Is_Nv=1.500000000000000e+01}', "");
    Expect(0, 119535, '\P{Is_Nv=1.500000000000000e+01}', "");
    Expect(1, 119535, '\P{^Is_Nv=1.500000000000000e+01}', "");
    Expect(0, 119536, '\p{Is_Nv=1.500000000000000e+01}', "");
    Expect(1, 119536, '\p{^Is_Nv=1.500000000000000e+01}', "");
    Expect(1, 119536, '\P{Is_Nv=1.500000000000000e+01}', "");
    Expect(0, 119536, '\P{^Is_Nv=1.500000000000000e+01}', "");
    Error('\p{Numeric_Value=:= 00000000015/0000000002}');
    Error('\P{Numeric_Value=:= 00000000015/0000000002}');
    Expect(1, 3889, '\p{Numeric_Value=:\A15/2\z:}', "");;
    Expect(0, 3890, '\p{Numeric_Value=:\A15/2\z:}', "");;
    Expect(1, 3889, '\p{Numeric_Value=000015/02}', "");
    Expect(0, 3889, '\p{^Numeric_Value=000015/02}', "");
    Expect(0, 3889, '\P{Numeric_Value=000015/02}', "");
    Expect(1, 3889, '\P{^Numeric_Value=000015/02}', "");
    Expect(0, 3890, '\p{Numeric_Value=000015/02}', "");
    Expect(1, 3890, '\p{^Numeric_Value=000015/02}', "");
    Expect(1, 3890, '\P{Numeric_Value=000015/02}', "");
    Expect(0, 3890, '\P{^Numeric_Value=000015/02}', "");
    Expect(1, 3889, '\p{Numeric_Value=900/120}', "");
    Expect(0, 3889, '\p{^Numeric_Value=900/120}', "");
    Expect(0, 3889, '\P{Numeric_Value=900/120}', "");
    Expect(1, 3889, '\P{^Numeric_Value=900/120}', "");
    Expect(0, 3890, '\p{Numeric_Value=900/120}', "");
    Expect(1, 3890, '\p{^Numeric_Value=900/120}', "");
    Expect(1, 3890, '\P{Numeric_Value=900/120}', "");
    Expect(0, 3890, '\P{^Numeric_Value=900/120}', "");
    Expect(1, 3889, '\p{Numeric_Value=7.5e+00}', "");
    Expect(0, 3889, '\p{^Numeric_Value=7.5e+00}', "");
    Expect(0, 3889, '\P{Numeric_Value=7.5e+00}', "");
    Expect(1, 3889, '\P{^Numeric_Value=7.5e+00}', "");
    Expect(0, 3890, '\p{Numeric_Value=7.5e+00}', "");
    Expect(1, 3890, '\p{^Numeric_Value=7.5e+00}', "");
    Expect(1, 3890, '\P{Numeric_Value=7.5e+00}', "");
    Expect(0, 3890, '\P{^Numeric_Value=7.5e+00}', "");
    Expect(1, 3889, '\p{Numeric_Value:	7.5}', "");
    Expect(0, 3889, '\p{^Numeric_Value:	7.5}', "");
    Expect(0, 3889, '\P{Numeric_Value:	7.5}', "");
    Expect(1, 3889, '\P{^Numeric_Value:	7.5}', "");
    Expect(0, 3890, '\p{Numeric_Value:	7.5}', "");
    Expect(1, 3890, '\p{^Numeric_Value:	7.5}', "");
    Expect(1, 3890, '\P{Numeric_Value:	7.5}', "");
    Expect(0, 3890, '\P{^Numeric_Value:	7.5}', "");
    Expect(1, 3889, '\p{Numeric_Value=7.50e+00}', "");
    Expect(0, 3889, '\p{^Numeric_Value=7.50e+00}', "");
    Expect(0, 3889, '\P{Numeric_Value=7.50e+00}', "");
    Expect(1, 3889, '\P{^Numeric_Value=7.50e+00}', "");
    Expect(0, 3890, '\p{Numeric_Value=7.50e+00}', "");
    Expect(1, 3890, '\p{^Numeric_Value=7.50e+00}', "");
    Expect(1, 3890, '\P{Numeric_Value=7.50e+00}', "");
    Expect(0, 3890, '\P{^Numeric_Value=7.50e+00}', "");
    Expect(1, 3889, '\p{Numeric_Value=7.50}', "");
    Expect(0, 3889, '\p{^Numeric_Value=7.50}', "");
    Expect(0, 3889, '\P{Numeric_Value=7.50}', "");
    Expect(1, 3889, '\P{^Numeric_Value=7.50}', "");
    Expect(0, 3890, '\p{Numeric_Value=7.50}', "");
    Expect(1, 3890, '\p{^Numeric_Value=7.50}', "");
    Expect(1, 3890, '\P{Numeric_Value=7.50}', "");
    Expect(0, 3890, '\P{^Numeric_Value=7.50}', "");
    Error('\p{Nv=	+00000000015/00000002:=}');
    Error('\P{Nv=	+00000000015/00000002:=}');
    Expect(1, 3889, '\p{Nv=:\A15/2\z:}', "");;
    Expect(0, 3890, '\p{Nv=:\A15/2\z:}', "");;
    Expect(1, 3889, '\p{Nv=0000015/0002}', "");
    Expect(0, 3889, '\p{^Nv=0000015/0002}', "");
    Expect(0, 3889, '\P{Nv=0000015/0002}', "");
    Expect(1, 3889, '\P{^Nv=0000015/0002}', "");
    Expect(0, 3890, '\p{Nv=0000015/0002}', "");
    Expect(1, 3890, '\p{^Nv=0000015/0002}', "");
    Expect(1, 3890, '\P{Nv=0000015/0002}', "");
    Expect(0, 3890, '\P{^Nv=0000015/0002}', "");
    Expect(1, 3889, '\p{Nv: 900/120}', "");
    Expect(0, 3889, '\p{^Nv: 900/120}', "");
    Expect(0, 3889, '\P{Nv: 900/120}', "");
    Expect(1, 3889, '\P{^Nv: 900/120}', "");
    Expect(0, 3890, '\p{Nv: 900/120}', "");
    Expect(1, 3890, '\p{^Nv: 900/120}', "");
    Expect(1, 3890, '\P{Nv: 900/120}', "");
    Expect(0, 3890, '\P{^Nv: 900/120}', "");
    Expect(1, 3889, '\p{Nv=7.5e+00}', "");
    Expect(0, 3889, '\p{^Nv=7.5e+00}', "");
    Expect(0, 3889, '\P{Nv=7.5e+00}', "");
    Expect(1, 3889, '\P{^Nv=7.5e+00}', "");
    Expect(0, 3890, '\p{Nv=7.5e+00}', "");
    Expect(1, 3890, '\p{^Nv=7.5e+00}', "");
    Expect(1, 3890, '\P{Nv=7.5e+00}', "");
    Expect(0, 3890, '\P{^Nv=7.5e+00}', "");
    Expect(1, 3889, '\p{Nv=7.5}', "");
    Expect(0, 3889, '\p{^Nv=7.5}', "");
    Expect(0, 3889, '\P{Nv=7.5}', "");
    Expect(1, 3889, '\P{^Nv=7.5}', "");
    Expect(0, 3890, '\p{Nv=7.5}', "");
    Expect(1, 3890, '\p{^Nv=7.5}', "");
    Expect(1, 3890, '\P{Nv=7.5}', "");
    Expect(0, 3890, '\P{^Nv=7.5}', "");
    Expect(1, 3889, '\p{Nv=7.50e+00}', "");
    Expect(0, 3889, '\p{^Nv=7.50e+00}', "");
    Expect(0, 3889, '\P{Nv=7.50e+00}', "");
    Expect(1, 3889, '\P{^Nv=7.50e+00}', "");
    Expect(0, 3890, '\p{Nv=7.50e+00}', "");
    Expect(1, 3890, '\p{^Nv=7.50e+00}', "");
    Expect(1, 3890, '\P{Nv=7.50e+00}', "");
    Expect(0, 3890, '\P{^Nv=7.50e+00}', "");
    Expect(1, 3889, '\p{Nv=7.50}', "");
    Expect(0, 3889, '\p{^Nv=7.50}', "");
    Expect(0, 3889, '\P{Nv=7.50}', "");
    Expect(1, 3889, '\P{^Nv=7.50}', "");
    Expect(0, 3890, '\p{Nv=7.50}', "");
    Expect(1, 3890, '\p{^Nv=7.50}', "");
    Expect(1, 3890, '\P{Nv=7.50}', "");
    Expect(0, 3890, '\P{^Nv=7.50}', "");
    Error('\p{Is_Numeric_Value=_00015/02/a/}');
    Error('\P{Is_Numeric_Value=_00015/02/a/}');
    Expect(1, 3889, '\p{Is_Numeric_Value:00000015/002}', "");
    Expect(0, 3889, '\p{^Is_Numeric_Value:00000015/002}', "");
    Expect(0, 3889, '\P{Is_Numeric_Value:00000015/002}', "");
    Expect(1, 3889, '\P{^Is_Numeric_Value:00000015/002}', "");
    Expect(0, 3890, '\p{Is_Numeric_Value:00000015/002}', "");
    Expect(1, 3890, '\p{^Is_Numeric_Value:00000015/002}', "");
    Expect(1, 3890, '\P{Is_Numeric_Value:00000015/002}', "");
    Expect(0, 3890, '\P{^Is_Numeric_Value:00000015/002}', "");
    Expect(1, 3889, '\p{Is_Numeric_Value=900/120}', "");
    Expect(0, 3889, '\p{^Is_Numeric_Value=900/120}', "");
    Expect(0, 3889, '\P{Is_Numeric_Value=900/120}', "");
    Expect(1, 3889, '\P{^Is_Numeric_Value=900/120}', "");
    Expect(0, 3890, '\p{Is_Numeric_Value=900/120}', "");
    Expect(1, 3890, '\p{^Is_Numeric_Value=900/120}', "");
    Expect(1, 3890, '\P{Is_Numeric_Value=900/120}', "");
    Expect(0, 3890, '\P{^Is_Numeric_Value=900/120}', "");
    Expect(1, 3889, '\p{Is_Numeric_Value=7.5e+00}', "");
    Expect(0, 3889, '\p{^Is_Numeric_Value=7.5e+00}', "");
    Expect(0, 3889, '\P{Is_Numeric_Value=7.5e+00}', "");
    Expect(1, 3889, '\P{^Is_Numeric_Value=7.5e+00}', "");
    Expect(0, 3890, '\p{Is_Numeric_Value=7.5e+00}', "");
    Expect(1, 3890, '\p{^Is_Numeric_Value=7.5e+00}', "");
    Expect(1, 3890, '\P{Is_Numeric_Value=7.5e+00}', "");
    Expect(0, 3890, '\P{^Is_Numeric_Value=7.5e+00}', "");
    Expect(1, 3889, '\p{Is_Numeric_Value=7.5}', "");
    Expect(0, 3889, '\p{^Is_Numeric_Value=7.5}', "");
    Expect(0, 3889, '\P{Is_Numeric_Value=7.5}', "");
    Expect(1, 3889, '\P{^Is_Numeric_Value=7.5}', "");
    Expect(0, 3890, '\p{Is_Numeric_Value=7.5}', "");
    Expect(1, 3890, '\p{^Is_Numeric_Value=7.5}', "");
    Expect(1, 3890, '\P{Is_Numeric_Value=7.5}', "");
    Expect(0, 3890, '\P{^Is_Numeric_Value=7.5}', "");
    Expect(1, 3889, '\p{Is_Numeric_Value:7.50e+00}', "");
    Expect(0, 3889, '\p{^Is_Numeric_Value:7.50e+00}', "");
    Expect(0, 3889, '\P{Is_Numeric_Value:7.50e+00}', "");
    Expect(1, 3889, '\P{^Is_Numeric_Value:7.50e+00}', "");
    Expect(0, 3890, '\p{Is_Numeric_Value:7.50e+00}', "");
    Expect(1, 3890, '\p{^Is_Numeric_Value:7.50e+00}', "");
    Expect(1, 3890, '\P{Is_Numeric_Value:7.50e+00}', "");
    Expect(0, 3890, '\P{^Is_Numeric_Value:7.50e+00}', "");
    Expect(1, 3889, '\p{Is_Numeric_Value=7.50}', "");
    Expect(0, 3889, '\p{^Is_Numeric_Value=7.50}', "");
    Expect(0, 3889, '\P{Is_Numeric_Value=7.50}', "");
    Expect(1, 3889, '\P{^Is_Numeric_Value=7.50}', "");
    Expect(0, 3890, '\p{Is_Numeric_Value=7.50}', "");
    Expect(1, 3890, '\p{^Is_Numeric_Value=7.50}', "");
    Expect(1, 3890, '\P{Is_Numeric_Value=7.50}', "");
    Expect(0, 3890, '\P{^Is_Numeric_Value=7.50}', "");
    Error('\p{Is_Nv=:=	-+0000015/00002}');
    Error('\P{Is_Nv=:=	-+0000015/00002}');
    Expect(1, 3889, '\p{Is_Nv=000000015/00002}', "");
    Expect(0, 3889, '\p{^Is_Nv=000000015/00002}', "");
    Expect(0, 3889, '\P{Is_Nv=000000015/00002}', "");
    Expect(1, 3889, '\P{^Is_Nv=000000015/00002}', "");
    Expect(0, 3890, '\p{Is_Nv=000000015/00002}', "");
    Expect(1, 3890, '\p{^Is_Nv=000000015/00002}', "");
    Expect(1, 3890, '\P{Is_Nv=000000015/00002}', "");
    Expect(0, 3890, '\P{^Is_Nv=000000015/00002}', "");
    Expect(1, 3889, '\p{Is_Nv=900/120}', "");
    Expect(0, 3889, '\p{^Is_Nv=900/120}', "");
    Expect(0, 3889, '\P{Is_Nv=900/120}', "");
    Expect(1, 3889, '\P{^Is_Nv=900/120}', "");
    Expect(0, 3890, '\p{Is_Nv=900/120}', "");
    Expect(1, 3890, '\p{^Is_Nv=900/120}', "");
    Expect(1, 3890, '\P{Is_Nv=900/120}', "");
    Expect(0, 3890, '\P{^Is_Nv=900/120}', "");
    Expect(1, 3889, '\p{Is_Nv=7.5e+00}', "");
    Expect(0, 3889, '\p{^Is_Nv=7.5e+00}', "");
    Expect(0, 3889, '\P{Is_Nv=7.5e+00}', "");
    Expect(1, 3889, '\P{^Is_Nv=7.5e+00}', "");
    Expect(0, 3890, '\p{Is_Nv=7.5e+00}', "");
    Expect(1, 3890, '\p{^Is_Nv=7.5e+00}', "");
    Expect(1, 3890, '\P{Is_Nv=7.5e+00}', "");
    Expect(0, 3890, '\P{^Is_Nv=7.5e+00}', "");
    Expect(1, 3889, '\p{Is_Nv=7.5}', "");
    Expect(0, 3889, '\p{^Is_Nv=7.5}', "");
    Expect(0, 3889, '\P{Is_Nv=7.5}', "");
    Expect(1, 3889, '\P{^Is_Nv=7.5}', "");
    Expect(0, 3890, '\p{Is_Nv=7.5}', "");
    Expect(1, 3890, '\p{^Is_Nv=7.5}', "");
    Expect(1, 3890, '\P{Is_Nv=7.5}', "");
    Expect(0, 3890, '\P{^Is_Nv=7.5}', "");
    Expect(1, 3889, '\p{Is_Nv: 7.50e+00}', "");
    Expect(0, 3889, '\p{^Is_Nv: 7.50e+00}', "");
    Expect(0, 3889, '\P{Is_Nv: 7.50e+00}', "");
    Expect(1, 3889, '\P{^Is_Nv: 7.50e+00}', "");
    Expect(0, 3890, '\p{Is_Nv: 7.50e+00}', "");
    Expect(1, 3890, '\p{^Is_Nv: 7.50e+00}', "");
    Expect(1, 3890, '\P{Is_Nv: 7.50e+00}', "");
    Expect(0, 3890, '\P{^Is_Nv: 7.50e+00}', "");
    Expect(1, 3889, '\p{Is_Nv=7.50}', "");
    Expect(0, 3889, '\p{^Is_Nv=7.50}', "");
    Expect(0, 3889, '\P{Is_Nv=7.50}', "");
    Expect(1, 3889, '\P{^Is_Nv=7.50}', "");
    Expect(0, 3890, '\p{Is_Nv=7.50}', "");
    Expect(1, 3890, '\p{^Is_Nv=7.50}', "");
    Expect(1, 3890, '\P{Is_Nv=7.50}', "");
    Expect(0, 3890, '\P{^Is_Nv=7.50}', "");
    Error('\p{Numeric_Value=_+00016/a/}');
    Error('\P{Numeric_Value=_+00016/a/}');
    Expect(1, 119536, '\p{Numeric_Value=:\A16\z:}', "");;
    Expect(0, 119537, '\p{Numeric_Value=:\A16\z:}', "");;
    Expect(1, 119536, '\p{Numeric_Value=000016}', "");
    Expect(0, 119536, '\p{^Numeric_Value=000016}', "");
    Expect(0, 119536, '\P{Numeric_Value=000016}', "");
    Expect(1, 119536, '\P{^Numeric_Value=000016}', "");
    Expect(0, 119537, '\p{Numeric_Value=000016}', "");
    Expect(1, 119537, '\p{^Numeric_Value=000016}', "");
    Expect(1, 119537, '\P{Numeric_Value=000016}', "");
    Expect(0, 119537, '\P{^Numeric_Value=000016}', "");
    Expect(1, 119536, '\p{Numeric_Value=1.600000000000000e+01}', "");
    Expect(0, 119536, '\p{^Numeric_Value=1.600000000000000e+01}', "");
    Expect(0, 119536, '\P{Numeric_Value=1.600000000000000e+01}', "");
    Expect(1, 119536, '\P{^Numeric_Value=1.600000000000000e+01}', "");
    Expect(0, 119537, '\p{Numeric_Value=1.600000000000000e+01}', "");
    Expect(1, 119537, '\p{^Numeric_Value=1.600000000000000e+01}', "");
    Expect(1, 119537, '\P{Numeric_Value=1.600000000000000e+01}', "");
    Expect(0, 119537, '\P{^Numeric_Value=1.600000000000000e+01}', "");
    Error('\p{Nv=:=	_+0000000016}');
    Error('\P{Nv=:=	_+0000000016}');
    Expect(1, 119536, '\p{Nv=:\A16\z:}', "");;
    Expect(0, 119537, '\p{Nv=:\A16\z:}', "");;
    Expect(1, 119536, '\p{Nv=0000016}', "");
    Expect(0, 119536, '\p{^Nv=0000016}', "");
    Expect(0, 119536, '\P{Nv=0000016}', "");
    Expect(1, 119536, '\P{^Nv=0000016}', "");
    Expect(0, 119537, '\p{Nv=0000016}', "");
    Expect(1, 119537, '\p{^Nv=0000016}', "");
    Expect(1, 119537, '\P{Nv=0000016}', "");
    Expect(0, 119537, '\P{^Nv=0000016}', "");
    Expect(1, 119536, '\p{Nv=1.600000000000000e+01}', "");
    Expect(0, 119536, '\p{^Nv=1.600000000000000e+01}', "");
    Expect(0, 119536, '\P{Nv=1.600000000000000e+01}', "");
    Expect(1, 119536, '\P{^Nv=1.600000000000000e+01}', "");
    Expect(0, 119537, '\p{Nv=1.600000000000000e+01}', "");
    Expect(1, 119537, '\p{^Nv=1.600000000000000e+01}', "");
    Expect(1, 119537, '\P{Nv=1.600000000000000e+01}', "");
    Expect(0, 119537, '\P{^Nv=1.600000000000000e+01}', "");
    Error('\p{Is_Numeric_Value=:=- 0000_0000_16}');
    Error('\P{Is_Numeric_Value=:=- 0000_0000_16}');
    Expect(1, 119536, '\p{Is_Numeric_Value=00000000016}', "");
    Expect(0, 119536, '\p{^Is_Numeric_Value=00000000016}', "");
    Expect(0, 119536, '\P{Is_Numeric_Value=00000000016}', "");
    Expect(1, 119536, '\P{^Is_Numeric_Value=00000000016}', "");
    Expect(0, 119537, '\p{Is_Numeric_Value=00000000016}', "");
    Expect(1, 119537, '\p{^Is_Numeric_Value=00000000016}', "");
    Expect(1, 119537, '\P{Is_Numeric_Value=00000000016}', "");
    Expect(0, 119537, '\P{^Is_Numeric_Value=00000000016}', "");
    Expect(1, 119536, '\p{Is_Numeric_Value=1.600000000000000e+01}', "");
    Expect(0, 119536, '\p{^Is_Numeric_Value=1.600000000000000e+01}', "");
    Expect(0, 119536, '\P{Is_Numeric_Value=1.600000000000000e+01}', "");
    Expect(1, 119536, '\P{^Is_Numeric_Value=1.600000000000000e+01}', "");
    Expect(0, 119537, '\p{Is_Numeric_Value=1.600000000000000e+01}', "");
    Expect(1, 119537, '\p{^Is_Numeric_Value=1.600000000000000e+01}', "");
    Expect(1, 119537, '\P{Is_Numeric_Value=1.600000000000000e+01}', "");
    Expect(0, 119537, '\P{^Is_Numeric_Value=1.600000000000000e+01}', "");
    Error('\p{Is_Nv=-:=000000001_6}');
    Error('\P{Is_Nv=-:=000000001_6}');
    Expect(1, 119536, '\p{Is_Nv=+0_0_0_0_016}', "");
    Expect(0, 119536, '\p{^Is_Nv=+0_0_0_0_016}', "");
    Expect(0, 119536, '\P{Is_Nv=+0_0_0_0_016}', "");
    Expect(1, 119536, '\P{^Is_Nv=+0_0_0_0_016}', "");
    Expect(0, 119537, '\p{Is_Nv=+0_0_0_0_016}', "");
    Expect(1, 119537, '\p{^Is_Nv=+0_0_0_0_016}', "");
    Expect(1, 119537, '\P{Is_Nv=+0_0_0_0_016}', "");
    Expect(0, 119537, '\P{^Is_Nv=+0_0_0_0_016}', "");
    Expect(1, 119536, '\p{Is_Nv=1.600000000000000e+01}', "");
    Expect(0, 119536, '\p{^Is_Nv=1.600000000000000e+01}', "");
    Expect(0, 119536, '\P{Is_Nv=1.600000000000000e+01}', "");
    Expect(1, 119536, '\P{^Is_Nv=1.600000000000000e+01}', "");
    Expect(0, 119537, '\p{Is_Nv=1.600000000000000e+01}', "");
    Expect(1, 119537, '\p{^Is_Nv=1.600000000000000e+01}', "");
    Expect(1, 119537, '\P{Is_Nv=1.600000000000000e+01}', "");
    Expect(0, 119537, '\P{^Is_Nv=1.600000000000000e+01}', "");
    Error('\p{Numeric_Value=	 17/a/}');
    Error('\P{Numeric_Value=	 17/a/}');
    Expect(1, 119537, '\p{Numeric_Value=:\A17\z:}', "");;
    Expect(0, 119538, '\p{Numeric_Value=:\A17\z:}', "");;
    Expect(1, 119537, '\p{Numeric_Value=00000000017}', "");
    Expect(0, 119537, '\p{^Numeric_Value=00000000017}', "");
    Expect(0, 119537, '\P{Numeric_Value=00000000017}', "");
    Expect(1, 119537, '\P{^Numeric_Value=00000000017}', "");
    Expect(0, 119538, '\p{Numeric_Value=00000000017}', "");
    Expect(1, 119538, '\p{^Numeric_Value=00000000017}', "");
    Expect(1, 119538, '\P{Numeric_Value=00000000017}', "");
    Expect(0, 119538, '\P{^Numeric_Value=00000000017}', "");
    Expect(1, 119537, '\p{Numeric_Value=1.700000000000000e+01}', "");
    Expect(0, 119537, '\p{^Numeric_Value=1.700000000000000e+01}', "");
    Expect(0, 119537, '\P{Numeric_Value=1.700000000000000e+01}', "");
    Expect(1, 119537, '\P{^Numeric_Value=1.700000000000000e+01}', "");
    Expect(0, 119538, '\p{Numeric_Value=1.700000000000000e+01}', "");
    Expect(1, 119538, '\p{^Numeric_Value=1.700000000000000e+01}', "");
    Expect(1, 119538, '\P{Numeric_Value=1.700000000000000e+01}', "");
    Expect(0, 119538, '\P{^Numeric_Value=1.700000000000000e+01}', "");
    Error('\p{Nv=:=+000017}');
    Error('\P{Nv=:=+000017}');
    Expect(1, 119537, '\p{Nv=:\A17\z:}', "");;
    Expect(0, 119538, '\p{Nv=:\A17\z:}', "");;
    Expect(1, 119537, '\p{Nv=000017}', "");
    Expect(0, 119537, '\p{^Nv=000017}', "");
    Expect(0, 119537, '\P{Nv=000017}', "");
    Expect(1, 119537, '\P{^Nv=000017}', "");
    Expect(0, 119538, '\p{Nv=000017}', "");
    Expect(1, 119538, '\p{^Nv=000017}', "");
    Expect(1, 119538, '\P{Nv=000017}', "");
    Expect(0, 119538, '\P{^Nv=000017}', "");
    Expect(1, 119537, '\p{Nv=1.700000000000000e+01}', "");
    Expect(0, 119537, '\p{^Nv=1.700000000000000e+01}', "");
    Expect(0, 119537, '\P{Nv=1.700000000000000e+01}', "");
    Expect(1, 119537, '\P{^Nv=1.700000000000000e+01}', "");
    Expect(0, 119538, '\p{Nv=1.700000000000000e+01}', "");
    Expect(1, 119538, '\p{^Nv=1.700000000000000e+01}', "");
    Expect(1, 119538, '\P{Nv=1.700000000000000e+01}', "");
    Expect(0, 119538, '\P{^Nv=1.700000000000000e+01}', "");
    Error('\p{Is_Numeric_Value=-00_00_00_01_7:=}');
    Error('\P{Is_Numeric_Value=-00_00_00_01_7:=}');
    Expect(1, 119537, '\p{Is_Numeric_Value=+0000000017}', "");
    Expect(0, 119537, '\p{^Is_Numeric_Value=+0000000017}', "");
    Expect(0, 119537, '\P{Is_Numeric_Value=+0000000017}', "");
    Expect(1, 119537, '\P{^Is_Numeric_Value=+0000000017}', "");
    Expect(0, 119538, '\p{Is_Numeric_Value=+0000000017}', "");
    Expect(1, 119538, '\p{^Is_Numeric_Value=+0000000017}', "");
    Expect(1, 119538, '\P{Is_Numeric_Value=+0000000017}', "");
    Expect(0, 119538, '\P{^Is_Numeric_Value=+0000000017}', "");
    Expect(1, 119537, '\p{Is_Numeric_Value=1.700000000000000e+01}', "");
    Expect(0, 119537, '\p{^Is_Numeric_Value=1.700000000000000e+01}', "");
    Expect(0, 119537, '\P{Is_Numeric_Value=1.700000000000000e+01}', "");
    Expect(1, 119537, '\P{^Is_Numeric_Value=1.700000000000000e+01}', "");
    Expect(0, 119538, '\p{Is_Numeric_Value=1.700000000000000e+01}', "");
    Expect(1, 119538, '\p{^Is_Numeric_Value=1.700000000000000e+01}', "");
    Expect(1, 119538, '\P{Is_Numeric_Value=1.700000000000000e+01}', "");
    Expect(0, 119538, '\P{^Is_Numeric_Value=1.700000000000000e+01}', "");
    Error('\p{Is_Nv=:=_	+0000001_7}');
    Error('\P{Is_Nv=:=_	+0000001_7}');
    Expect(1, 119537, '\p{Is_Nv=+00000000017}', "");
    Expect(0, 119537, '\p{^Is_Nv=+00000000017}', "");
    Expect(0, 119537, '\P{Is_Nv=+00000000017}', "");
    Expect(1, 119537, '\P{^Is_Nv=+00000000017}', "");
    Expect(0, 119538, '\p{Is_Nv=+00000000017}', "");
    Expect(1, 119538, '\p{^Is_Nv=+00000000017}', "");
    Expect(1, 119538, '\P{Is_Nv=+00000000017}', "");
    Expect(0, 119538, '\P{^Is_Nv=+00000000017}', "");
    Expect(1, 119537, '\p{Is_Nv=1.700000000000000e+01}', "");
    Expect(0, 119537, '\p{^Is_Nv=1.700000000000000e+01}', "");
    Expect(0, 119537, '\P{Is_Nv=1.700000000000000e+01}', "");
    Expect(1, 119537, '\P{^Is_Nv=1.700000000000000e+01}', "");
    Expect(0, 119538, '\p{Is_Nv=1.700000000000000e+01}', "");
    Expect(1, 119538, '\p{^Is_Nv=1.700000000000000e+01}', "");
    Expect(1, 119538, '\P{Is_Nv=1.700000000000000e+01}', "");
    Expect(0, 119538, '\P{^Is_Nv=1.700000000000000e+01}', "");
    Error('\p{Numeric_Value= 00000017/002/a/}');
    Error('\P{Numeric_Value= 00000017/002/a/}');
    Expect(1, 3890, '\p{Numeric_Value=:\A17/2\z:}', "");;
    Expect(0, 3891, '\p{Numeric_Value=:\A17/2\z:}', "");;
    Expect(1, 3890, '\p{Numeric_Value=000017/002}', "");
    Expect(0, 3890, '\p{^Numeric_Value=000017/002}', "");
    Expect(0, 3890, '\P{Numeric_Value=000017/002}', "");
    Expect(1, 3890, '\P{^Numeric_Value=000017/002}', "");
    Expect(0, 3891, '\p{Numeric_Value=000017/002}', "");
    Expect(1, 3891, '\p{^Numeric_Value=000017/002}', "");
    Expect(1, 3891, '\P{Numeric_Value=000017/002}', "");
    Expect(0, 3891, '\P{^Numeric_Value=000017/002}', "");
    Expect(1, 3890, '\p{Numeric_Value:1020/120}', "");
    Expect(0, 3890, '\p{^Numeric_Value:1020/120}', "");
    Expect(0, 3890, '\P{Numeric_Value:1020/120}', "");
    Expect(1, 3890, '\P{^Numeric_Value:1020/120}', "");
    Expect(0, 3891, '\p{Numeric_Value:1020/120}', "");
    Expect(1, 3891, '\p{^Numeric_Value:1020/120}', "");
    Expect(1, 3891, '\P{Numeric_Value:1020/120}', "");
    Expect(0, 3891, '\P{^Numeric_Value:1020/120}', "");
    Expect(1, 3890, '\p{Numeric_Value=8.5e+00}', "");
    Expect(0, 3890, '\p{^Numeric_Value=8.5e+00}', "");
    Expect(0, 3890, '\P{Numeric_Value=8.5e+00}', "");
    Expect(1, 3890, '\P{^Numeric_Value=8.5e+00}', "");
    Expect(0, 3891, '\p{Numeric_Value=8.5e+00}', "");
    Expect(1, 3891, '\p{^Numeric_Value=8.5e+00}', "");
    Expect(1, 3891, '\P{Numeric_Value=8.5e+00}', "");
    Expect(0, 3891, '\P{^Numeric_Value=8.5e+00}', "");
    Expect(1, 3890, '\p{Numeric_Value:   8.5}', "");
    Expect(0, 3890, '\p{^Numeric_Value:   8.5}', "");
    Expect(0, 3890, '\P{Numeric_Value:   8.5}', "");
    Expect(1, 3890, '\P{^Numeric_Value:   8.5}', "");
    Expect(0, 3891, '\p{Numeric_Value:   8.5}', "");
    Expect(1, 3891, '\p{^Numeric_Value:   8.5}', "");
    Expect(1, 3891, '\P{Numeric_Value:   8.5}', "");
    Expect(0, 3891, '\P{^Numeric_Value:   8.5}', "");
    Expect(1, 3890, '\p{Numeric_Value=8.50e+00}', "");
    Expect(0, 3890, '\p{^Numeric_Value=8.50e+00}', "");
    Expect(0, 3890, '\P{Numeric_Value=8.50e+00}', "");
    Expect(1, 3890, '\P{^Numeric_Value=8.50e+00}', "");
    Expect(0, 3891, '\p{Numeric_Value=8.50e+00}', "");
    Expect(1, 3891, '\p{^Numeric_Value=8.50e+00}', "");
    Expect(1, 3891, '\P{Numeric_Value=8.50e+00}', "");
    Expect(0, 3891, '\P{^Numeric_Value=8.50e+00}', "");
    Expect(1, 3890, '\p{Numeric_Value=8.50}', "");
    Expect(0, 3890, '\p{^Numeric_Value=8.50}', "");
    Expect(0, 3890, '\P{Numeric_Value=8.50}', "");
    Expect(1, 3890, '\P{^Numeric_Value=8.50}', "");
    Expect(0, 3891, '\p{Numeric_Value=8.50}', "");
    Expect(1, 3891, '\p{^Numeric_Value=8.50}', "");
    Expect(1, 3891, '\P{Numeric_Value=8.50}', "");
    Expect(0, 3891, '\P{^Numeric_Value=8.50}', "");
    Error('\p{Nv=-/a/0000000017/000002}');
    Error('\P{Nv=-/a/0000000017/000002}');
    Expect(1, 3890, '\p{Nv=:\A17/2\z:}', "");;
    Expect(0, 3891, '\p{Nv=:\A17/2\z:}', "");;
    Expect(1, 3890, '\p{Nv=17/02}', "");
    Expect(0, 3890, '\p{^Nv=17/02}', "");
    Expect(0, 3890, '\P{Nv=17/02}', "");
    Expect(1, 3890, '\P{^Nv=17/02}', "");
    Expect(0, 3891, '\p{Nv=17/02}', "");
    Expect(1, 3891, '\p{^Nv=17/02}', "");
    Expect(1, 3891, '\P{Nv=17/02}', "");
    Expect(0, 3891, '\P{^Nv=17/02}', "");
    Expect(1, 3890, '\p{Nv=1020/120}', "");
    Expect(0, 3890, '\p{^Nv=1020/120}', "");
    Expect(0, 3890, '\P{Nv=1020/120}', "");
    Expect(1, 3890, '\P{^Nv=1020/120}', "");
    Expect(0, 3891, '\p{Nv=1020/120}', "");
    Expect(1, 3891, '\p{^Nv=1020/120}', "");
    Expect(1, 3891, '\P{Nv=1020/120}', "");
    Expect(0, 3891, '\P{^Nv=1020/120}', "");
    Expect(1, 3890, '\p{Nv=8.5e+00}', "");
    Expect(0, 3890, '\p{^Nv=8.5e+00}', "");
    Expect(0, 3890, '\P{Nv=8.5e+00}', "");
    Expect(1, 3890, '\P{^Nv=8.5e+00}', "");
    Expect(0, 3891, '\p{Nv=8.5e+00}', "");
    Expect(1, 3891, '\p{^Nv=8.5e+00}', "");
    Expect(1, 3891, '\P{Nv=8.5e+00}', "");
    Expect(0, 3891, '\P{^Nv=8.5e+00}', "");
    Expect(1, 3890, '\p{Nv=8.5}', "");
    Expect(0, 3890, '\p{^Nv=8.5}', "");
    Expect(0, 3890, '\P{Nv=8.5}', "");
    Expect(1, 3890, '\P{^Nv=8.5}', "");
    Expect(0, 3891, '\p{Nv=8.5}', "");
    Expect(1, 3891, '\p{^Nv=8.5}', "");
    Expect(1, 3891, '\P{Nv=8.5}', "");
    Expect(0, 3891, '\P{^Nv=8.5}', "");
    Expect(1, 3890, '\p{Nv=8.50e+00}', "");
    Expect(0, 3890, '\p{^Nv=8.50e+00}', "");
    Expect(0, 3890, '\P{Nv=8.50e+00}', "");
    Expect(1, 3890, '\P{^Nv=8.50e+00}', "");
    Expect(0, 3891, '\p{Nv=8.50e+00}', "");
    Expect(1, 3891, '\p{^Nv=8.50e+00}', "");
    Expect(1, 3891, '\P{Nv=8.50e+00}', "");
    Expect(0, 3891, '\P{^Nv=8.50e+00}', "");
    Expect(1, 3890, '\p{Nv=8.50}', "");
    Expect(0, 3890, '\p{^Nv=8.50}', "");
    Expect(0, 3890, '\P{Nv=8.50}', "");
    Expect(1, 3890, '\P{^Nv=8.50}', "");
    Expect(0, 3891, '\p{Nv=8.50}', "");
    Expect(1, 3891, '\p{^Nv=8.50}', "");
    Expect(1, 3891, '\P{Nv=8.50}', "");
    Expect(0, 3891, '\P{^Nv=8.50}', "");
    Error('\p{Is_Numeric_Value= /a/0000017/0002}');
    Error('\P{Is_Numeric_Value= /a/0000017/0002}');
    Expect(1, 3890, '\p{Is_Numeric_Value=0017/0000002}', "");
    Expect(0, 3890, '\p{^Is_Numeric_Value=0017/0000002}', "");
    Expect(0, 3890, '\P{Is_Numeric_Value=0017/0000002}', "");
    Expect(1, 3890, '\P{^Is_Numeric_Value=0017/0000002}', "");
    Expect(0, 3891, '\p{Is_Numeric_Value=0017/0000002}', "");
    Expect(1, 3891, '\p{^Is_Numeric_Value=0017/0000002}', "");
    Expect(1, 3891, '\P{Is_Numeric_Value=0017/0000002}', "");
    Expect(0, 3891, '\P{^Is_Numeric_Value=0017/0000002}', "");
    Expect(1, 3890, '\p{Is_Numeric_Value=1020/120}', "");
    Expect(0, 3890, '\p{^Is_Numeric_Value=1020/120}', "");
    Expect(0, 3890, '\P{Is_Numeric_Value=1020/120}', "");
    Expect(1, 3890, '\P{^Is_Numeric_Value=1020/120}', "");
    Expect(0, 3891, '\p{Is_Numeric_Value=1020/120}', "");
    Expect(1, 3891, '\p{^Is_Numeric_Value=1020/120}', "");
    Expect(1, 3891, '\P{Is_Numeric_Value=1020/120}', "");
    Expect(0, 3891, '\P{^Is_Numeric_Value=1020/120}', "");
    Expect(1, 3890, '\p{Is_Numeric_Value=8.5e+00}', "");
    Expect(0, 3890, '\p{^Is_Numeric_Value=8.5e+00}', "");
    Expect(0, 3890, '\P{Is_Numeric_Value=8.5e+00}', "");
    Expect(1, 3890, '\P{^Is_Numeric_Value=8.5e+00}', "");
    Expect(0, 3891, '\p{Is_Numeric_Value=8.5e+00}', "");
    Expect(1, 3891, '\p{^Is_Numeric_Value=8.5e+00}', "");
    Expect(1, 3891, '\P{Is_Numeric_Value=8.5e+00}', "");
    Expect(0, 3891, '\P{^Is_Numeric_Value=8.5e+00}', "");
    Expect(1, 3890, '\p{Is_Numeric_Value=8.5}', "");
    Expect(0, 3890, '\p{^Is_Numeric_Value=8.5}', "");
    Expect(0, 3890, '\P{Is_Numeric_Value=8.5}', "");
    Expect(1, 3890, '\P{^Is_Numeric_Value=8.5}', "");
    Expect(0, 3891, '\p{Is_Numeric_Value=8.5}', "");
    Expect(1, 3891, '\p{^Is_Numeric_Value=8.5}', "");
    Expect(1, 3891, '\P{Is_Numeric_Value=8.5}', "");
    Expect(0, 3891, '\P{^Is_Numeric_Value=8.5}', "");
    Expect(1, 3890, '\p{Is_Numeric_Value=8.50e+00}', "");
    Expect(0, 3890, '\p{^Is_Numeric_Value=8.50e+00}', "");
    Expect(0, 3890, '\P{Is_Numeric_Value=8.50e+00}', "");
    Expect(1, 3890, '\P{^Is_Numeric_Value=8.50e+00}', "");
    Expect(0, 3891, '\p{Is_Numeric_Value=8.50e+00}', "");
    Expect(1, 3891, '\p{^Is_Numeric_Value=8.50e+00}', "");
    Expect(1, 3891, '\P{Is_Numeric_Value=8.50e+00}', "");
    Expect(0, 3891, '\P{^Is_Numeric_Value=8.50e+00}', "");
    Expect(1, 3890, '\p{Is_Numeric_Value=8.50}', "");
    Expect(0, 3890, '\p{^Is_Numeric_Value=8.50}', "");
    Expect(0, 3890, '\P{Is_Numeric_Value=8.50}', "");
    Expect(1, 3890, '\P{^Is_Numeric_Value=8.50}', "");
    Expect(0, 3891, '\p{Is_Numeric_Value=8.50}', "");
    Expect(1, 3891, '\p{^Is_Numeric_Value=8.50}', "");
    Expect(1, 3891, '\P{Is_Numeric_Value=8.50}', "");
    Expect(0, 3891, '\P{^Is_Numeric_Value=8.50}', "");
    Error('\p{Is_Nv=	+00000000017/0000002:=}');
    Error('\P{Is_Nv=	+00000000017/0000002:=}');
    Expect(1, 3890, '\p{Is_Nv=0000000017/02}', "");
    Expect(0, 3890, '\p{^Is_Nv=0000000017/02}', "");
    Expect(0, 3890, '\P{Is_Nv=0000000017/02}', "");
    Expect(1, 3890, '\P{^Is_Nv=0000000017/02}', "");
    Expect(0, 3891, '\p{Is_Nv=0000000017/02}', "");
    Expect(1, 3891, '\p{^Is_Nv=0000000017/02}', "");
    Expect(1, 3891, '\P{Is_Nv=0000000017/02}', "");
    Expect(0, 3891, '\P{^Is_Nv=0000000017/02}', "");
    Expect(1, 3890, '\p{Is_Nv=1020/120}', "");
    Expect(0, 3890, '\p{^Is_Nv=1020/120}', "");
    Expect(0, 3890, '\P{Is_Nv=1020/120}', "");
    Expect(1, 3890, '\P{^Is_Nv=1020/120}', "");
    Expect(0, 3891, '\p{Is_Nv=1020/120}', "");
    Expect(1, 3891, '\p{^Is_Nv=1020/120}', "");
    Expect(1, 3891, '\P{Is_Nv=1020/120}', "");
    Expect(0, 3891, '\P{^Is_Nv=1020/120}', "");
    Expect(1, 3890, '\p{Is_Nv=8.5e+00}', "");
    Expect(0, 3890, '\p{^Is_Nv=8.5e+00}', "");
    Expect(0, 3890, '\P{Is_Nv=8.5e+00}', "");
    Expect(1, 3890, '\P{^Is_Nv=8.5e+00}', "");
    Expect(0, 3891, '\p{Is_Nv=8.5e+00}', "");
    Expect(1, 3891, '\p{^Is_Nv=8.5e+00}', "");
    Expect(1, 3891, '\P{Is_Nv=8.5e+00}', "");
    Expect(0, 3891, '\P{^Is_Nv=8.5e+00}', "");
    Expect(1, 3890, '\p{Is_Nv=8.5}', "");
    Expect(0, 3890, '\p{^Is_Nv=8.5}', "");
    Expect(0, 3890, '\P{Is_Nv=8.5}', "");
    Expect(1, 3890, '\P{^Is_Nv=8.5}', "");
    Expect(0, 3891, '\p{Is_Nv=8.5}', "");
    Expect(1, 3891, '\p{^Is_Nv=8.5}', "");
    Expect(1, 3891, '\P{Is_Nv=8.5}', "");
    Expect(0, 3891, '\P{^Is_Nv=8.5}', "");
    Expect(1, 3890, '\p{Is_Nv=8.50e+00}', "");
    Expect(0, 3890, '\p{^Is_Nv=8.50e+00}', "");
    Expect(0, 3890, '\P{Is_Nv=8.50e+00}', "");
    Expect(1, 3890, '\P{^Is_Nv=8.50e+00}', "");
    Expect(0, 3891, '\p{Is_Nv=8.50e+00}', "");
    Expect(1, 3891, '\p{^Is_Nv=8.50e+00}', "");
    Expect(1, 3891, '\P{Is_Nv=8.50e+00}', "");
    Expect(0, 3891, '\P{^Is_Nv=8.50e+00}', "");
    Expect(1, 3890, '\p{Is_Nv=8.50}', "");
    Expect(0, 3890, '\p{^Is_Nv=8.50}', "");
    Expect(0, 3890, '\P{Is_Nv=8.50}', "");
    Expect(1, 3890, '\P{^Is_Nv=8.50}', "");
    Expect(0, 3891, '\p{Is_Nv=8.50}', "");
    Expect(1, 3891, '\p{^Is_Nv=8.50}', "");
    Expect(1, 3891, '\P{Is_Nv=8.50}', "");
    Expect(0, 3891, '\P{^Is_Nv=8.50}', "");
    Error('\p{Numeric_Value: /a/ -00_01_8}');
    Error('\P{Numeric_Value: /a/ -00_01_8}');
    Expect(1, 119538, '\p{Numeric_Value=:\A18\z:}', "");;
    Expect(0, 119539, '\p{Numeric_Value=:\A18\z:}', "");;
    Expect(1, 119538, '\p{Numeric_Value=018}', "");
    Expect(0, 119538, '\p{^Numeric_Value=018}', "");
    Expect(0, 119538, '\P{Numeric_Value=018}', "");
    Expect(1, 119538, '\P{^Numeric_Value=018}', "");
    Expect(0, 119539, '\p{Numeric_Value=018}', "");
    Expect(1, 119539, '\p{^Numeric_Value=018}', "");
    Expect(1, 119539, '\P{Numeric_Value=018}', "");
    Expect(0, 119539, '\P{^Numeric_Value=018}', "");
    Expect(1, 119538, '\p{Numeric_Value=1.800000000000000e+01}', "");
    Expect(0, 119538, '\p{^Numeric_Value=1.800000000000000e+01}', "");
    Expect(0, 119538, '\P{Numeric_Value=1.800000000000000e+01}', "");
    Expect(1, 119538, '\P{^Numeric_Value=1.800000000000000e+01}', "");
    Expect(0, 119539, '\p{Numeric_Value=1.800000000000000e+01}', "");
    Expect(1, 119539, '\p{^Numeric_Value=1.800000000000000e+01}', "");
    Expect(1, 119539, '\P{Numeric_Value=1.800000000000000e+01}', "");
    Expect(0, 119539, '\P{^Numeric_Value=1.800000000000000e+01}', "");
    Error('\p{Nv=  00000000018:=}');
    Error('\P{Nv=  00000000018:=}');
    Expect(1, 119538, '\p{Nv=:\A18\z:}', "");;
    Expect(0, 119539, '\p{Nv=:\A18\z:}', "");;
    Expect(1, 119538, '\p{Nv=1_8}', "");
    Expect(0, 119538, '\p{^Nv=1_8}', "");
    Expect(0, 119538, '\P{Nv=1_8}', "");
    Expect(1, 119538, '\P{^Nv=1_8}', "");
    Expect(0, 119539, '\p{Nv=1_8}', "");
    Expect(1, 119539, '\p{^Nv=1_8}', "");
    Expect(1, 119539, '\P{Nv=1_8}', "");
    Expect(0, 119539, '\P{^Nv=1_8}', "");
    Expect(1, 119538, '\p{Nv=1.800000000000000e+01}', "");
    Expect(0, 119538, '\p{^Nv=1.800000000000000e+01}', "");
    Expect(0, 119538, '\P{Nv=1.800000000000000e+01}', "");
    Expect(1, 119538, '\P{^Nv=1.800000000000000e+01}', "");
    Expect(0, 119539, '\p{Nv=1.800000000000000e+01}', "");
    Expect(1, 119539, '\p{^Nv=1.800000000000000e+01}', "");
    Expect(1, 119539, '\P{Nv=1.800000000000000e+01}', "");
    Expect(0, 119539, '\P{^Nv=1.800000000000000e+01}', "");
    Error('\p{Is_Numeric_Value=--00000018:=}');
    Error('\P{Is_Numeric_Value=--00000018:=}');
    Expect(1, 119538, '\p{Is_Numeric_Value=000001_8}', "");
    Expect(0, 119538, '\p{^Is_Numeric_Value=000001_8}', "");
    Expect(0, 119538, '\P{Is_Numeric_Value=000001_8}', "");
    Expect(1, 119538, '\P{^Is_Numeric_Value=000001_8}', "");
    Expect(0, 119539, '\p{Is_Numeric_Value=000001_8}', "");
    Expect(1, 119539, '\p{^Is_Numeric_Value=000001_8}', "");
    Expect(1, 119539, '\P{Is_Numeric_Value=000001_8}', "");
    Expect(0, 119539, '\P{^Is_Numeric_Value=000001_8}', "");
    Expect(1, 119538, '\p{Is_Numeric_Value=1.800000000000000e+01}', "");
    Expect(0, 119538, '\p{^Is_Numeric_Value=1.800000000000000e+01}', "");
    Expect(0, 119538, '\P{Is_Numeric_Value=1.800000000000000e+01}', "");
    Expect(1, 119538, '\P{^Is_Numeric_Value=1.800000000000000e+01}', "");
    Expect(0, 119539, '\p{Is_Numeric_Value=1.800000000000000e+01}', "");
    Expect(1, 119539, '\p{^Is_Numeric_Value=1.800000000000000e+01}', "");
    Expect(1, 119539, '\P{Is_Numeric_Value=1.800000000000000e+01}', "");
    Expect(0, 119539, '\P{^Is_Numeric_Value=1.800000000000000e+01}', "");
    Error('\p{Is_Nv=:= _018}');
    Error('\P{Is_Nv=:= _018}');
    Expect(1, 119538, '\p{Is_Nv=+000000018}', "");
    Expect(0, 119538, '\p{^Is_Nv=+000000018}', "");
    Expect(0, 119538, '\P{Is_Nv=+000000018}', "");
    Expect(1, 119538, '\P{^Is_Nv=+000000018}', "");
    Expect(0, 119539, '\p{Is_Nv=+000000018}', "");
    Expect(1, 119539, '\p{^Is_Nv=+000000018}', "");
    Expect(1, 119539, '\P{Is_Nv=+000000018}', "");
    Expect(0, 119539, '\P{^Is_Nv=+000000018}', "");
    Expect(1, 119538, '\p{Is_Nv=1.800000000000000e+01}', "");
    Expect(0, 119538, '\p{^Is_Nv=1.800000000000000e+01}', "");
    Expect(0, 119538, '\P{Is_Nv=1.800000000000000e+01}', "");
    Expect(1, 119538, '\P{^Is_Nv=1.800000000000000e+01}', "");
    Expect(0, 119539, '\p{Is_Nv=1.800000000000000e+01}', "");
    Expect(1, 119539, '\p{^Is_Nv=1.800000000000000e+01}', "");
    Expect(1, 119539, '\P{Is_Nv=1.800000000000000e+01}', "");
    Expect(0, 119539, '\P{^Is_Nv=1.800000000000000e+01}', "");
    Error('\p{Numeric_Value=:=	-+000000019}');
    Error('\P{Numeric_Value=:=	-+000000019}');
    Expect(1, 119539, '\p{Numeric_Value=:\A19\z:}', "");;
    Expect(0, 119540, '\p{Numeric_Value=:\A19\z:}', "");;
    Expect(1, 119539, '\p{Numeric_Value:+19}', "");
    Expect(0, 119539, '\p{^Numeric_Value:+19}', "");
    Expect(0, 119539, '\P{Numeric_Value:+19}', "");
    Expect(1, 119539, '\P{^Numeric_Value:+19}', "");
    Expect(0, 119540, '\p{Numeric_Value:+19}', "");
    Expect(1, 119540, '\p{^Numeric_Value:+19}', "");
    Expect(1, 119540, '\P{Numeric_Value:+19}', "");
    Expect(0, 119540, '\P{^Numeric_Value:+19}', "");
    Expect(1, 119539, '\p{Numeric_Value=1.900000000000000e+01}', "");
    Expect(0, 119539, '\p{^Numeric_Value=1.900000000000000e+01}', "");
    Expect(0, 119539, '\P{Numeric_Value=1.900000000000000e+01}', "");
    Expect(1, 119539, '\P{^Numeric_Value=1.900000000000000e+01}', "");
    Expect(0, 119540, '\p{Numeric_Value=1.900000000000000e+01}', "");
    Expect(1, 119540, '\p{^Numeric_Value=1.900000000000000e+01}', "");
    Expect(1, 119540, '\P{Numeric_Value=1.900000000000000e+01}', "");
    Expect(0, 119540, '\P{^Numeric_Value=1.900000000000000e+01}', "");
    Error('\p{Nv= _000019:=}');
    Error('\P{Nv= _000019:=}');
    Expect(1, 119539, '\p{Nv=:\A19\z:}', "");;
    Expect(0, 119540, '\p{Nv=:\A19\z:}', "");;
    Expect(1, 119539, '\p{Nv=00_00_00_00_19}', "");
    Expect(0, 119539, '\p{^Nv=00_00_00_00_19}', "");
    Expect(0, 119539, '\P{Nv=00_00_00_00_19}', "");
    Expect(1, 119539, '\P{^Nv=00_00_00_00_19}', "");
    Expect(0, 119540, '\p{Nv=00_00_00_00_19}', "");
    Expect(1, 119540, '\p{^Nv=00_00_00_00_19}', "");
    Expect(1, 119540, '\P{Nv=00_00_00_00_19}', "");
    Expect(0, 119540, '\P{^Nv=00_00_00_00_19}', "");
    Expect(1, 119539, '\p{Nv=1.900000000000000e+01}', "");
    Expect(0, 119539, '\p{^Nv=1.900000000000000e+01}', "");
    Expect(0, 119539, '\P{Nv=1.900000000000000e+01}', "");
    Expect(1, 119539, '\P{^Nv=1.900000000000000e+01}', "");
    Expect(0, 119540, '\p{Nv=1.900000000000000e+01}', "");
    Expect(1, 119540, '\p{^Nv=1.900000000000000e+01}', "");
    Expect(1, 119540, '\P{Nv=1.900000000000000e+01}', "");
    Expect(0, 119540, '\P{^Nv=1.900000000000000e+01}', "");
    Error('\p{Is_Numeric_Value=:=		+000019}');
    Error('\P{Is_Numeric_Value=:=		+000019}');
    Expect(1, 119539, '\p{Is_Numeric_Value=00_00_19}', "");
    Expect(0, 119539, '\p{^Is_Numeric_Value=00_00_19}', "");
    Expect(0, 119539, '\P{Is_Numeric_Value=00_00_19}', "");
    Expect(1, 119539, '\P{^Is_Numeric_Value=00_00_19}', "");
    Expect(0, 119540, '\p{Is_Numeric_Value=00_00_19}', "");
    Expect(1, 119540, '\p{^Is_Numeric_Value=00_00_19}', "");
    Expect(1, 119540, '\P{Is_Numeric_Value=00_00_19}', "");
    Expect(0, 119540, '\P{^Is_Numeric_Value=00_00_19}', "");
    Expect(1, 119539, '\p{Is_Numeric_Value=1.900000000000000e+01}', "");
    Expect(0, 119539, '\p{^Is_Numeric_Value=1.900000000000000e+01}', "");
    Expect(0, 119539, '\P{Is_Numeric_Value=1.900000000000000e+01}', "");
    Expect(1, 119539, '\P{^Is_Numeric_Value=1.900000000000000e+01}', "");
    Expect(0, 119540, '\p{Is_Numeric_Value=1.900000000000000e+01}', "");
    Expect(1, 119540, '\p{^Is_Numeric_Value=1.900000000000000e+01}', "");
    Expect(1, 119540, '\P{Is_Numeric_Value=1.900000000000000e+01}', "");
    Expect(0, 119540, '\P{^Is_Numeric_Value=1.900000000000000e+01}', "");
    Error('\p{Is_Nv=:=_ 00001_9}');
    Error('\P{Is_Nv=:=_ 00001_9}');
    Expect(1, 119539, '\p{Is_Nv=+000000019}', "");
    Expect(0, 119539, '\p{^Is_Nv=+000000019}', "");
    Expect(0, 119539, '\P{Is_Nv=+000000019}', "");
    Expect(1, 119539, '\P{^Is_Nv=+000000019}', "");
    Expect(0, 119540, '\p{Is_Nv=+000000019}', "");
    Expect(1, 119540, '\p{^Is_Nv=+000000019}', "");
    Expect(1, 119540, '\P{Is_Nv=+000000019}', "");
    Expect(0, 119540, '\P{^Is_Nv=+000000019}', "");
    Expect(1, 119539, '\p{Is_Nv=1.900000000000000e+01}', "");
    Expect(0, 119539, '\p{^Is_Nv=1.900000000000000e+01}', "");
    Expect(0, 119539, '\P{Is_Nv=1.900000000000000e+01}', "");
    Expect(1, 119539, '\P{^Is_Nv=1.900000000000000e+01}', "");
    Expect(0, 119540, '\p{Is_Nv=1.900000000000000e+01}', "");
    Expect(1, 119540, '\p{^Is_Nv=1.900000000000000e+01}', "");
    Expect(1, 119540, '\P{Is_Nv=1.900000000000000e+01}', "");
    Expect(0, 119540, '\P{^Is_Nv=1.900000000000000e+01}', "");
    Error('\p{Numeric_Value=-+2/a/}');
    Error('\P{Numeric_Value=-+2/a/}');
    Expect(1, 140176, '\p{Numeric_Value=:\A2\z:}', "");;
    Expect(0, 140177, '\p{Numeric_Value=:\A2\z:}', "");;
    Expect(1, 140176, '\p{Numeric_Value=0_0_02}', "");
    Expect(0, 140176, '\p{^Numeric_Value=0_0_02}', "");
    Expect(0, 140176, '\P{Numeric_Value=0_0_02}', "");
    Expect(1, 140176, '\P{^Numeric_Value=0_0_02}', "");
    Expect(0, 140177, '\p{Numeric_Value=0_0_02}', "");
    Expect(1, 140177, '\p{^Numeric_Value=0_0_02}', "");
    Expect(1, 140177, '\P{Numeric_Value=0_0_02}', "");
    Expect(0, 140177, '\P{^Numeric_Value=0_0_02}', "");
    Expect(1, 140176, '\p{Numeric_Value=2.000000000000000e+00}', "");
    Expect(0, 140176, '\p{^Numeric_Value=2.000000000000000e+00}', "");
    Expect(0, 140176, '\P{Numeric_Value=2.000000000000000e+00}', "");
    Expect(1, 140176, '\P{^Numeric_Value=2.000000000000000e+00}', "");
    Expect(0, 140177, '\p{Numeric_Value=2.000000000000000e+00}', "");
    Expect(1, 140177, '\p{^Numeric_Value=2.000000000000000e+00}', "");
    Expect(1, 140177, '\P{Numeric_Value=2.000000000000000e+00}', "");
    Expect(0, 140177, '\P{^Numeric_Value=2.000000000000000e+00}', "");
    Error('\p{Nv=:=_ 0002}');
    Error('\P{Nv=:=_ 0002}');
    Expect(1, 140176, '\p{Nv=:\A2\z:}', "");;
    Expect(0, 140177, '\p{Nv=:\A2\z:}', "");;
    Expect(1, 140176, '\p{Nv=2}', "");
    Expect(0, 140176, '\p{^Nv=2}', "");
    Expect(0, 140176, '\P{Nv=2}', "");
    Expect(1, 140176, '\P{^Nv=2}', "");
    Expect(0, 140177, '\p{Nv=2}', "");
    Expect(1, 140177, '\p{^Nv=2}', "");
    Expect(1, 140177, '\P{Nv=2}', "");
    Expect(0, 140177, '\P{^Nv=2}', "");
    Expect(1, 140176, '\p{Nv:	2.000000000000000e+00}', "");
    Expect(0, 140176, '\p{^Nv:	2.000000000000000e+00}', "");
    Expect(0, 140176, '\P{Nv:	2.000000000000000e+00}', "");
    Expect(1, 140176, '\P{^Nv:	2.000000000000000e+00}', "");
    Expect(0, 140177, '\p{Nv:	2.000000000000000e+00}', "");
    Expect(1, 140177, '\p{^Nv:	2.000000000000000e+00}', "");
    Expect(1, 140177, '\P{Nv:	2.000000000000000e+00}', "");
    Expect(0, 140177, '\P{^Nv:	2.000000000000000e+00}', "");
    Error('\p{Is_Numeric_Value=:=+000000002}');
    Error('\P{Is_Numeric_Value=:=+000000002}');
    Expect(1, 140176, '\p{Is_Numeric_Value=000_2}', "");
    Expect(0, 140176, '\p{^Is_Numeric_Value=000_2}', "");
    Expect(0, 140176, '\P{Is_Numeric_Value=000_2}', "");
    Expect(1, 140176, '\P{^Is_Numeric_Value=000_2}', "");
    Expect(0, 140177, '\p{Is_Numeric_Value=000_2}', "");
    Expect(1, 140177, '\p{^Is_Numeric_Value=000_2}', "");
    Expect(1, 140177, '\P{Is_Numeric_Value=000_2}', "");
    Expect(0, 140177, '\P{^Is_Numeric_Value=000_2}', "");
    Expect(1, 140176, '\p{Is_Numeric_Value=2.000000000000000e+00}', "");
    Expect(0, 140176, '\p{^Is_Numeric_Value=2.000000000000000e+00}', "");
    Expect(0, 140176, '\P{Is_Numeric_Value=2.000000000000000e+00}', "");
    Expect(1, 140176, '\P{^Is_Numeric_Value=2.000000000000000e+00}', "");
    Expect(0, 140177, '\p{Is_Numeric_Value=2.000000000000000e+00}', "");
    Expect(1, 140177, '\p{^Is_Numeric_Value=2.000000000000000e+00}', "");
    Expect(1, 140177, '\P{Is_Numeric_Value=2.000000000000000e+00}', "");
    Expect(0, 140177, '\P{^Is_Numeric_Value=2.000000000000000e+00}', "");
    Error('\p{Is_Nv=- +00_2:=}');
    Error('\P{Is_Nv=- +00_2:=}');
    Expect(1, 140176, '\p{Is_Nv=0000002}', "");
    Expect(0, 140176, '\p{^Is_Nv=0000002}', "");
    Expect(0, 140176, '\P{Is_Nv=0000002}', "");
    Expect(1, 140176, '\P{^Is_Nv=0000002}', "");
    Expect(0, 140177, '\p{Is_Nv=0000002}', "");
    Expect(1, 140177, '\p{^Is_Nv=0000002}', "");
    Expect(1, 140177, '\P{Is_Nv=0000002}', "");
    Expect(0, 140177, '\P{^Is_Nv=0000002}', "");
    Expect(1, 140176, '\p{Is_Nv=2.000000000000000e+00}', "");
    Expect(0, 140176, '\p{^Is_Nv=2.000000000000000e+00}', "");
    Expect(0, 140176, '\P{Is_Nv=2.000000000000000e+00}', "");
    Expect(1, 140176, '\P{^Is_Nv=2.000000000000000e+00}', "");
    Expect(0, 140177, '\p{Is_Nv=2.000000000000000e+00}', "");
    Expect(1, 140177, '\p{^Is_Nv=2.000000000000000e+00}', "");
    Expect(1, 140177, '\P{Is_Nv=2.000000000000000e+00}', "");
    Expect(0, 140177, '\P{^Is_Nv=2.000000000000000e+00}', "");
    Error('\p{Numeric_Value=-+000000002/000000003/a/}');
    Error('\P{Numeric_Value=-+000000002/000000003/a/}');
    Expect(1, 74854, '\p{Numeric_Value=:\A2/3\z:}', "");;
    Expect(0, 74855, '\p{Numeric_Value=:\A2/3\z:}', "");;
    Expect(1, 74854, '\p{Numeric_Value:000000002/003}', "");
    Expect(0, 74854, '\p{^Numeric_Value:000000002/003}', "");
    Expect(0, 74854, '\P{Numeric_Value:000000002/003}', "");
    Expect(1, 74854, '\P{^Numeric_Value:000000002/003}', "");
    Expect(0, 74855, '\p{Numeric_Value:000000002/003}', "");
    Expect(1, 74855, '\p{^Numeric_Value:000000002/003}', "");
    Expect(1, 74855, '\P{Numeric_Value:000000002/003}', "");
    Expect(0, 74855, '\P{^Numeric_Value:000000002/003}', "");
    Expect(1, 74854, '\p{Numeric_Value=120/180}', "");
    Expect(0, 74854, '\p{^Numeric_Value=120/180}', "");
    Expect(0, 74854, '\P{Numeric_Value=120/180}', "");
    Expect(1, 74854, '\P{^Numeric_Value=120/180}', "");
    Expect(0, 74855, '\p{Numeric_Value=120/180}', "");
    Expect(1, 74855, '\p{^Numeric_Value=120/180}', "");
    Expect(1, 74855, '\P{Numeric_Value=120/180}', "");
    Expect(0, 74855, '\P{^Numeric_Value=120/180}', "");
    Error('\p{Numeric_Value=6.7e-01}');
    Error('\P{Numeric_Value=6.7e-01}');
    Error('\p{Numeric_Value=0.7}');
    Error('\P{Numeric_Value=0.7}');
    Expect(1, 74854, '\p{Numeric_Value=6.67e-01}', "");
    Expect(0, 74854, '\p{^Numeric_Value=6.67e-01}', "");
    Expect(0, 74854, '\P{Numeric_Value=6.67e-01}', "");
    Expect(1, 74854, '\P{^Numeric_Value=6.67e-01}', "");
    Expect(0, 74855, '\p{Numeric_Value=6.67e-01}', "");
    Expect(1, 74855, '\p{^Numeric_Value=6.67e-01}', "");
    Expect(1, 74855, '\P{Numeric_Value=6.67e-01}', "");
    Expect(0, 74855, '\P{^Numeric_Value=6.67e-01}', "");
    Error('\p{Numeric_Value=0.67}');
    Error('\P{Numeric_Value=0.67}');
    Expect(1, 74854, '\p{Numeric_Value=6.667e-01}', "");
    Expect(0, 74854, '\p{^Numeric_Value=6.667e-01}', "");
    Expect(0, 74854, '\P{Numeric_Value=6.667e-01}', "");
    Expect(1, 74854, '\P{^Numeric_Value=6.667e-01}', "");
    Expect(0, 74855, '\p{Numeric_Value=6.667e-01}', "");
    Expect(1, 74855, '\p{^Numeric_Value=6.667e-01}', "");
    Expect(1, 74855, '\P{Numeric_Value=6.667e-01}', "");
    Expect(0, 74855, '\P{^Numeric_Value=6.667e-01}', "");
    Expect(1, 74854, '\p{Numeric_Value=0.667}', "");
    Expect(0, 74854, '\p{^Numeric_Value=0.667}', "");
    Expect(0, 74854, '\P{Numeric_Value=0.667}', "");
    Expect(1, 74854, '\P{^Numeric_Value=0.667}', "");
    Expect(0, 74855, '\p{Numeric_Value=0.667}', "");
    Expect(1, 74855, '\p{^Numeric_Value=0.667}', "");
    Expect(1, 74855, '\P{Numeric_Value=0.667}', "");
    Expect(0, 74855, '\P{^Numeric_Value=0.667}', "");
    Expect(1, 74854, '\p{Numeric_Value=6.6667e-01}', "");
    Expect(0, 74854, '\p{^Numeric_Value=6.6667e-01}', "");
    Expect(0, 74854, '\P{Numeric_Value=6.6667e-01}', "");
    Expect(1, 74854, '\P{^Numeric_Value=6.6667e-01}', "");
    Expect(0, 74855, '\p{Numeric_Value=6.6667e-01}', "");
    Expect(1, 74855, '\p{^Numeric_Value=6.6667e-01}', "");
    Expect(1, 74855, '\P{Numeric_Value=6.6667e-01}', "");
    Expect(0, 74855, '\P{^Numeric_Value=6.6667e-01}', "");
    Expect(1, 74854, '\p{Numeric_Value=0.6667}', "");
    Expect(0, 74854, '\p{^Numeric_Value=0.6667}', "");
    Expect(0, 74854, '\P{Numeric_Value=0.6667}', "");
    Expect(1, 74854, '\P{^Numeric_Value=0.6667}', "");
    Expect(0, 74855, '\p{Numeric_Value=0.6667}', "");
    Expect(1, 74855, '\p{^Numeric_Value=0.6667}', "");
    Expect(1, 74855, '\P{Numeric_Value=0.6667}', "");
    Expect(0, 74855, '\P{^Numeric_Value=0.6667}', "");
    Error('\p{Nv=:= 00002/003}');
    Error('\P{Nv=:= 00002/003}');
    Expect(1, 74854, '\p{Nv=:\A2/3\z:}', "");;
    Expect(0, 74855, '\p{Nv=:\A2/3\z:}', "");;
    Expect(1, 74854, '\p{Nv=02/0000000003}', "");
    Expect(0, 74854, '\p{^Nv=02/0000000003}', "");
    Expect(0, 74854, '\P{Nv=02/0000000003}', "");
    Expect(1, 74854, '\P{^Nv=02/0000000003}', "");
    Expect(0, 74855, '\p{Nv=02/0000000003}', "");
    Expect(1, 74855, '\p{^Nv=02/0000000003}', "");
    Expect(1, 74855, '\P{Nv=02/0000000003}', "");
    Expect(0, 74855, '\P{^Nv=02/0000000003}', "");
    Expect(1, 74854, '\p{Nv=120/180}', "");
    Expect(0, 74854, '\p{^Nv=120/180}', "");
    Expect(0, 74854, '\P{Nv=120/180}', "");
    Expect(1, 74854, '\P{^Nv=120/180}', "");
    Expect(0, 74855, '\p{Nv=120/180}', "");
    Expect(1, 74855, '\p{^Nv=120/180}', "");
    Expect(1, 74855, '\P{Nv=120/180}', "");
    Expect(0, 74855, '\P{^Nv=120/180}', "");
    Error('\p{Nv=6.7e-01}');
    Error('\P{Nv=6.7e-01}');
    Error('\p{Nv: 0.7}');
    Error('\P{Nv: 0.7}');
    Expect(1, 74854, '\p{Nv=6.67e-01}', "");
    Expect(0, 74854, '\p{^Nv=6.67e-01}', "");
    Expect(0, 74854, '\P{Nv=6.67e-01}', "");
    Expect(1, 74854, '\P{^Nv=6.67e-01}', "");
    Expect(0, 74855, '\p{Nv=6.67e-01}', "");
    Expect(1, 74855, '\p{^Nv=6.67e-01}', "");
    Expect(1, 74855, '\P{Nv=6.67e-01}', "");
    Expect(0, 74855, '\P{^Nv=6.67e-01}', "");
    Error('\p{Nv=0.67}');
    Error('\P{Nv=0.67}');
    Expect(1, 74854, '\p{Nv=6.667e-01}', "");
    Expect(0, 74854, '\p{^Nv=6.667e-01}', "");
    Expect(0, 74854, '\P{Nv=6.667e-01}', "");
    Expect(1, 74854, '\P{^Nv=6.667e-01}', "");
    Expect(0, 74855, '\p{Nv=6.667e-01}', "");
    Expect(1, 74855, '\p{^Nv=6.667e-01}', "");
    Expect(1, 74855, '\P{Nv=6.667e-01}', "");
    Expect(0, 74855, '\P{^Nv=6.667e-01}', "");
    Expect(1, 74854, '\p{Nv=0.667}', "");
    Expect(0, 74854, '\p{^Nv=0.667}', "");
    Expect(0, 74854, '\P{Nv=0.667}', "");
    Expect(1, 74854, '\P{^Nv=0.667}', "");
    Expect(0, 74855, '\p{Nv=0.667}', "");
    Expect(1, 74855, '\p{^Nv=0.667}', "");
    Expect(1, 74855, '\P{Nv=0.667}', "");
    Expect(0, 74855, '\P{^Nv=0.667}', "");
    Expect(1, 74854, '\p{Nv=6.6667e-01}', "");
    Expect(0, 74854, '\p{^Nv=6.6667e-01}', "");
    Expect(0, 74854, '\P{Nv=6.6667e-01}', "");
    Expect(1, 74854, '\P{^Nv=6.6667e-01}', "");
    Expect(0, 74855, '\p{Nv=6.6667e-01}', "");
    Expect(1, 74855, '\p{^Nv=6.6667e-01}', "");
    Expect(1, 74855, '\P{Nv=6.6667e-01}', "");
    Expect(0, 74855, '\P{^Nv=6.6667e-01}', "");
    Expect(1, 74854, '\p{Nv:	0.6667}', "");
    Expect(0, 74854, '\p{^Nv:	0.6667}', "");
    Expect(0, 74854, '\P{Nv:	0.6667}', "");
    Expect(1, 74854, '\P{^Nv:	0.6667}', "");
    Expect(0, 74855, '\p{Nv:	0.6667}', "");
    Expect(1, 74855, '\p{^Nv:	0.6667}', "");
    Expect(1, 74855, '\P{Nv:	0.6667}', "");
    Expect(0, 74855, '\P{^Nv:	0.6667}', "");
    Error('\p{Is_Numeric_Value=:=_0000000002/0000000003}');
    Error('\P{Is_Numeric_Value=:=_0000000002/0000000003}');
    Expect(1, 74854, '\p{Is_Numeric_Value:+000002/03}', "");
    Expect(0, 74854, '\p{^Is_Numeric_Value:+000002/03}', "");
    Expect(0, 74854, '\P{Is_Numeric_Value:+000002/03}', "");
    Expect(1, 74854, '\P{^Is_Numeric_Value:+000002/03}', "");
    Expect(0, 74855, '\p{Is_Numeric_Value:+000002/03}', "");
    Expect(1, 74855, '\p{^Is_Numeric_Value:+000002/03}', "");
    Expect(1, 74855, '\P{Is_Numeric_Value:+000002/03}', "");
    Expect(0, 74855, '\P{^Is_Numeric_Value:+000002/03}', "");
    Expect(1, 74854, '\p{Is_Numeric_Value=120/180}', "");
    Expect(0, 74854, '\p{^Is_Numeric_Value=120/180}', "");
    Expect(0, 74854, '\P{Is_Numeric_Value=120/180}', "");
    Expect(1, 74854, '\P{^Is_Numeric_Value=120/180}', "");
    Expect(0, 74855, '\p{Is_Numeric_Value=120/180}', "");
    Expect(1, 74855, '\p{^Is_Numeric_Value=120/180}', "");
    Expect(1, 74855, '\P{Is_Numeric_Value=120/180}', "");
    Expect(0, 74855, '\P{^Is_Numeric_Value=120/180}', "");
    Error('\p{Is_Numeric_Value:6.7e-01}');
    Error('\P{Is_Numeric_Value:6.7e-01}');
    Error('\p{Is_Numeric_Value=0.7}');
    Error('\P{Is_Numeric_Value=0.7}');
    Expect(1, 74854, '\p{Is_Numeric_Value=6.67e-01}', "");
    Expect(0, 74854, '\p{^Is_Numeric_Value=6.67e-01}', "");
    Expect(0, 74854, '\P{Is_Numeric_Value=6.67e-01}', "");
    Expect(1, 74854, '\P{^Is_Numeric_Value=6.67e-01}', "");
    Expect(0, 74855, '\p{Is_Numeric_Value=6.67e-01}', "");
    Expect(1, 74855, '\p{^Is_Numeric_Value=6.67e-01}', "");
    Expect(1, 74855, '\P{Is_Numeric_Value=6.67e-01}', "");
    Expect(0, 74855, '\P{^Is_Numeric_Value=6.67e-01}', "");
    Error('\p{Is_Numeric_Value=0.67}');
    Error('\P{Is_Numeric_Value=0.67}');
    Expect(1, 74854, '\p{Is_Numeric_Value=6.667e-01}', "");
    Expect(0, 74854, '\p{^Is_Numeric_Value=6.667e-01}', "");
    Expect(0, 74854, '\P{Is_Numeric_Value=6.667e-01}', "");
    Expect(1, 74854, '\P{^Is_Numeric_Value=6.667e-01}', "");
    Expect(0, 74855, '\p{Is_Numeric_Value=6.667e-01}', "");
    Expect(1, 74855, '\p{^Is_Numeric_Value=6.667e-01}', "");
    Expect(1, 74855, '\P{Is_Numeric_Value=6.667e-01}', "");
    Expect(0, 74855, '\P{^Is_Numeric_Value=6.667e-01}', "");
    Expect(1, 74854, '\p{Is_Numeric_Value=0.667}', "");
    Expect(0, 74854, '\p{^Is_Numeric_Value=0.667}', "");
    Expect(0, 74854, '\P{Is_Numeric_Value=0.667}', "");
    Expect(1, 74854, '\P{^Is_Numeric_Value=0.667}', "");
    Expect(0, 74855, '\p{Is_Numeric_Value=0.667}', "");
    Expect(1, 74855, '\p{^Is_Numeric_Value=0.667}', "");
    Expect(1, 74855, '\P{Is_Numeric_Value=0.667}', "");
    Expect(0, 74855, '\P{^Is_Numeric_Value=0.667}', "");
    Expect(1, 74854, '\p{Is_Numeric_Value=6.6667e-01}', "");
    Expect(0, 74854, '\p{^Is_Numeric_Value=6.6667e-01}', "");
    Expect(0, 74854, '\P{Is_Numeric_Value=6.6667e-01}', "");
    Expect(1, 74854, '\P{^Is_Numeric_Value=6.6667e-01}', "");
    Expect(0, 74855, '\p{Is_Numeric_Value=6.6667e-01}', "");
    Expect(1, 74855, '\p{^Is_Numeric_Value=6.6667e-01}', "");
    Expect(1, 74855, '\P{Is_Numeric_Value=6.6667e-01}', "");
    Expect(0, 74855, '\P{^Is_Numeric_Value=6.6667e-01}', "");
    Expect(1, 74854, '\p{Is_Numeric_Value=0.6667}', "");
    Expect(0, 74854, '\p{^Is_Numeric_Value=0.6667}', "");
    Expect(0, 74854, '\P{Is_Numeric_Value=0.6667}', "");
    Expect(1, 74854, '\P{^Is_Numeric_Value=0.6667}', "");
    Expect(0, 74855, '\p{Is_Numeric_Value=0.6667}', "");
    Expect(1, 74855, '\p{^Is_Numeric_Value=0.6667}', "");
    Expect(1, 74855, '\P{Is_Numeric_Value=0.6667}', "");
    Expect(0, 74855, '\P{^Is_Numeric_Value=0.6667}', "");
    Error('\p{Is_Nv=/a/		2/00003}');
    Error('\P{Is_Nv=/a/		2/00003}');
    Expect(1, 74854, '\p{Is_Nv=0000002/0000003}', "");
    Expect(0, 74854, '\p{^Is_Nv=0000002/0000003}', "");
    Expect(0, 74854, '\P{Is_Nv=0000002/0000003}', "");
    Expect(1, 74854, '\P{^Is_Nv=0000002/0000003}', "");
    Expect(0, 74855, '\p{Is_Nv=0000002/0000003}', "");
    Expect(1, 74855, '\p{^Is_Nv=0000002/0000003}', "");
    Expect(1, 74855, '\P{Is_Nv=0000002/0000003}', "");
    Expect(0, 74855, '\P{^Is_Nv=0000002/0000003}', "");
    Expect(1, 74854, '\p{Is_Nv=120/180}', "");
    Expect(0, 74854, '\p{^Is_Nv=120/180}', "");
    Expect(0, 74854, '\P{Is_Nv=120/180}', "");
    Expect(1, 74854, '\P{^Is_Nv=120/180}', "");
    Expect(0, 74855, '\p{Is_Nv=120/180}', "");
    Expect(1, 74855, '\p{^Is_Nv=120/180}', "");
    Expect(1, 74855, '\P{Is_Nv=120/180}', "");
    Expect(0, 74855, '\P{^Is_Nv=120/180}', "");
    Error('\p{Is_Nv=6.7e-01}');
    Error('\P{Is_Nv=6.7e-01}');
    Error('\p{Is_Nv=0.7}');
    Error('\P{Is_Nv=0.7}');
    Expect(1, 74854, '\p{Is_Nv=6.67e-01}', "");
    Expect(0, 74854, '\p{^Is_Nv=6.67e-01}', "");
    Expect(0, 74854, '\P{Is_Nv=6.67e-01}', "");
    Expect(1, 74854, '\P{^Is_Nv=6.67e-01}', "");
    Expect(0, 74855, '\p{Is_Nv=6.67e-01}', "");
    Expect(1, 74855, '\p{^Is_Nv=6.67e-01}', "");
    Expect(1, 74855, '\P{Is_Nv=6.67e-01}', "");
    Expect(0, 74855, '\P{^Is_Nv=6.67e-01}', "");
    Error('\p{Is_Nv=0.67}');
    Error('\P{Is_Nv=0.67}');
    Expect(1, 74854, '\p{Is_Nv=6.667e-01}', "");
    Expect(0, 74854, '\p{^Is_Nv=6.667e-01}', "");
    Expect(0, 74854, '\P{Is_Nv=6.667e-01}', "");
    Expect(1, 74854, '\P{^Is_Nv=6.667e-01}', "");
    Expect(0, 74855, '\p{Is_Nv=6.667e-01}', "");
    Expect(1, 74855, '\p{^Is_Nv=6.667e-01}', "");
    Expect(1, 74855, '\P{Is_Nv=6.667e-01}', "");
    Expect(0, 74855, '\P{^Is_Nv=6.667e-01}', "");
    Expect(1, 74854, '\p{Is_Nv=0.667}', "");
    Expect(0, 74854, '\p{^Is_Nv=0.667}', "");
    Expect(0, 74854, '\P{Is_Nv=0.667}', "");
    Expect(1, 74854, '\P{^Is_Nv=0.667}', "");
    Expect(0, 74855, '\p{Is_Nv=0.667}', "");
    Expect(1, 74855, '\p{^Is_Nv=0.667}', "");
    Expect(1, 74855, '\P{Is_Nv=0.667}', "");
    Expect(0, 74855, '\P{^Is_Nv=0.667}', "");
    Expect(1, 74854, '\p{Is_Nv=6.6667e-01}', "");
    Expect(0, 74854, '\p{^Is_Nv=6.6667e-01}', "");
    Expect(0, 74854, '\P{Is_Nv=6.6667e-01}', "");
    Expect(1, 74854, '\P{^Is_Nv=6.6667e-01}', "");
    Expect(0, 74855, '\p{Is_Nv=6.6667e-01}', "");
    Expect(1, 74855, '\p{^Is_Nv=6.6667e-01}', "");
    Expect(1, 74855, '\P{Is_Nv=6.6667e-01}', "");
    Expect(0, 74855, '\P{^Is_Nv=6.6667e-01}', "");
    Expect(1, 74854, '\p{Is_Nv=0.6667}', "");
    Expect(0, 74854, '\p{^Is_Nv=0.6667}', "");
    Expect(0, 74854, '\P{Is_Nv=0.6667}', "");
    Expect(1, 74854, '\P{^Is_Nv=0.6667}', "");
    Expect(0, 74855, '\p{Is_Nv=0.6667}', "");
    Expect(1, 74855, '\p{^Is_Nv=0.6667}', "");
    Expect(1, 74855, '\P{Is_Nv=0.6667}', "");
    Expect(0, 74855, '\P{^Is_Nv=0.6667}', "");
    Error('\p{Numeric_Value=_	000002/005:=}');
    Error('\P{Numeric_Value=_	000002/005:=}');
    Expect(1, 8534, '\p{Numeric_Value=:\A2/5\z:}', "");;
    Expect(0, 8535, '\p{Numeric_Value=:\A2/5\z:}', "");;
    Expect(1, 8534, '\p{Numeric_Value=02/05}', "");
    Expect(0, 8534, '\p{^Numeric_Value=02/05}', "");
    Expect(0, 8534, '\P{Numeric_Value=02/05}', "");
    Expect(1, 8534, '\P{^Numeric_Value=02/05}', "");
    Expect(0, 8535, '\p{Numeric_Value=02/05}', "");
    Expect(1, 8535, '\p{^Numeric_Value=02/05}', "");
    Expect(1, 8535, '\P{Numeric_Value=02/05}', "");
    Expect(0, 8535, '\P{^Numeric_Value=02/05}', "");
    Expect(1, 8534, '\p{Numeric_Value=120/300}', "");
    Expect(0, 8534, '\p{^Numeric_Value=120/300}', "");
    Expect(0, 8534, '\P{Numeric_Value=120/300}', "");
    Expect(1, 8534, '\P{^Numeric_Value=120/300}', "");
    Expect(0, 8535, '\p{Numeric_Value=120/300}', "");
    Expect(1, 8535, '\p{^Numeric_Value=120/300}', "");
    Expect(1, 8535, '\P{Numeric_Value=120/300}', "");
    Expect(0, 8535, '\P{^Numeric_Value=120/300}', "");
    Expect(1, 8534, '\p{Numeric_Value=4.0e-01}', "");
    Expect(0, 8534, '\p{^Numeric_Value=4.0e-01}', "");
    Expect(0, 8534, '\P{Numeric_Value=4.0e-01}', "");
    Expect(1, 8534, '\P{^Numeric_Value=4.0e-01}', "");
    Expect(0, 8535, '\p{Numeric_Value=4.0e-01}', "");
    Expect(1, 8535, '\p{^Numeric_Value=4.0e-01}', "");
    Expect(1, 8535, '\P{Numeric_Value=4.0e-01}', "");
    Expect(0, 8535, '\P{^Numeric_Value=4.0e-01}', "");
    Expect(1, 8534, '\p{Numeric_Value:	0.4}', "");
    Expect(0, 8534, '\p{^Numeric_Value:	0.4}', "");
    Expect(0, 8534, '\P{Numeric_Value:	0.4}', "");
    Expect(1, 8534, '\P{^Numeric_Value:	0.4}', "");
    Expect(0, 8535, '\p{Numeric_Value:	0.4}', "");
    Expect(1, 8535, '\p{^Numeric_Value:	0.4}', "");
    Expect(1, 8535, '\P{Numeric_Value:	0.4}', "");
    Expect(0, 8535, '\P{^Numeric_Value:	0.4}', "");
    Expect(1, 8534, '\p{Numeric_Value=4.00e-01}', "");
    Expect(0, 8534, '\p{^Numeric_Value=4.00e-01}', "");
    Expect(0, 8534, '\P{Numeric_Value=4.00e-01}', "");
    Expect(1, 8534, '\P{^Numeric_Value=4.00e-01}', "");
    Expect(0, 8535, '\p{Numeric_Value=4.00e-01}', "");
    Expect(1, 8535, '\p{^Numeric_Value=4.00e-01}', "");
    Expect(1, 8535, '\P{Numeric_Value=4.00e-01}', "");
    Expect(0, 8535, '\P{^Numeric_Value=4.00e-01}', "");
    Expect(1, 8534, '\p{Numeric_Value:   0.40}', "");
    Expect(0, 8534, '\p{^Numeric_Value:   0.40}', "");
    Expect(0, 8534, '\P{Numeric_Value:   0.40}', "");
    Expect(1, 8534, '\P{^Numeric_Value:   0.40}', "");
    Expect(0, 8535, '\p{Numeric_Value:   0.40}', "");
    Expect(1, 8535, '\p{^Numeric_Value:   0.40}', "");
    Expect(1, 8535, '\P{Numeric_Value:   0.40}', "");
    Expect(0, 8535, '\P{^Numeric_Value:   0.40}', "");
    Error('\p{Nv=:=-0000002/05}');
    Error('\P{Nv=:=-0000002/05}');
    Expect(1, 8534, '\p{Nv=:\A2/5\z:}', "");;
    Expect(0, 8535, '\p{Nv=:\A2/5\z:}', "");;
    Expect(1, 8534, '\p{Nv=0002/000000005}', "");
    Expect(0, 8534, '\p{^Nv=0002/000000005}', "");
    Expect(0, 8534, '\P{Nv=0002/000000005}', "");
    Expect(1, 8534, '\P{^Nv=0002/000000005}', "");
    Expect(0, 8535, '\p{Nv=0002/000000005}', "");
    Expect(1, 8535, '\p{^Nv=0002/000000005}', "");
    Expect(1, 8535, '\P{Nv=0002/000000005}', "");
    Expect(0, 8535, '\P{^Nv=0002/000000005}', "");
    Expect(1, 8534, '\p{Nv=120/300}', "");
    Expect(0, 8534, '\p{^Nv=120/300}', "");
    Expect(0, 8534, '\P{Nv=120/300}', "");
    Expect(1, 8534, '\P{^Nv=120/300}', "");
    Expect(0, 8535, '\p{Nv=120/300}', "");
    Expect(1, 8535, '\p{^Nv=120/300}', "");
    Expect(1, 8535, '\P{Nv=120/300}', "");
    Expect(0, 8535, '\P{^Nv=120/300}', "");
    Expect(1, 8534, '\p{Nv: 4.0e-01}', "");
    Expect(0, 8534, '\p{^Nv: 4.0e-01}', "");
    Expect(0, 8534, '\P{Nv: 4.0e-01}', "");
    Expect(1, 8534, '\P{^Nv: 4.0e-01}', "");
    Expect(0, 8535, '\p{Nv: 4.0e-01}', "");
    Expect(1, 8535, '\p{^Nv: 4.0e-01}', "");
    Expect(1, 8535, '\P{Nv: 4.0e-01}', "");
    Expect(0, 8535, '\P{^Nv: 4.0e-01}', "");
    Expect(1, 8534, '\p{Nv=0.4}', "");
    Expect(0, 8534, '\p{^Nv=0.4}', "");
    Expect(0, 8534, '\P{Nv=0.4}', "");
    Expect(1, 8534, '\P{^Nv=0.4}', "");
    Expect(0, 8535, '\p{Nv=0.4}', "");
    Expect(1, 8535, '\p{^Nv=0.4}', "");
    Expect(1, 8535, '\P{Nv=0.4}', "");
    Expect(0, 8535, '\P{^Nv=0.4}', "");
    Expect(1, 8534, '\p{Nv=4.00e-01}', "");
    Expect(0, 8534, '\p{^Nv=4.00e-01}', "");
    Expect(0, 8534, '\P{Nv=4.00e-01}', "");
    Expect(1, 8534, '\P{^Nv=4.00e-01}', "");
    Expect(0, 8535, '\p{Nv=4.00e-01}', "");
    Expect(1, 8535, '\p{^Nv=4.00e-01}', "");
    Expect(1, 8535, '\P{Nv=4.00e-01}', "");
    Expect(0, 8535, '\P{^Nv=4.00e-01}', "");
    Expect(1, 8534, '\p{Nv:	0.40}', "");
    Expect(0, 8534, '\p{^Nv:	0.40}', "");
    Expect(0, 8534, '\P{Nv:	0.40}', "");
    Expect(1, 8534, '\P{^Nv:	0.40}', "");
    Expect(0, 8535, '\p{Nv:	0.40}', "");
    Expect(1, 8535, '\p{^Nv:	0.40}', "");
    Expect(1, 8535, '\P{Nv:	0.40}', "");
    Expect(0, 8535, '\P{^Nv:	0.40}', "");
    Error('\p{Is_Numeric_Value=	-00000002/000005/a/}');
    Error('\P{Is_Numeric_Value=	-00000002/000005/a/}');
    Expect(1, 8534, '\p{Is_Numeric_Value=+0002/005}', "");
    Expect(0, 8534, '\p{^Is_Numeric_Value=+0002/005}', "");
    Expect(0, 8534, '\P{Is_Numeric_Value=+0002/005}', "");
    Expect(1, 8534, '\P{^Is_Numeric_Value=+0002/005}', "");
    Expect(0, 8535, '\p{Is_Numeric_Value=+0002/005}', "");
    Expect(1, 8535, '\p{^Is_Numeric_Value=+0002/005}', "");
    Expect(1, 8535, '\P{Is_Numeric_Value=+0002/005}', "");
    Expect(0, 8535, '\P{^Is_Numeric_Value=+0002/005}', "");
    Expect(1, 8534, '\p{Is_Numeric_Value:   120/300}', "");
    Expect(0, 8534, '\p{^Is_Numeric_Value:   120/300}', "");
    Expect(0, 8534, '\P{Is_Numeric_Value:   120/300}', "");
    Expect(1, 8534, '\P{^Is_Numeric_Value:   120/300}', "");
    Expect(0, 8535, '\p{Is_Numeric_Value:   120/300}', "");
    Expect(1, 8535, '\p{^Is_Numeric_Value:   120/300}', "");
    Expect(1, 8535, '\P{Is_Numeric_Value:   120/300}', "");
    Expect(0, 8535, '\P{^Is_Numeric_Value:   120/300}', "");
    Expect(1, 8534, '\p{Is_Numeric_Value=4.0e-01}', "");
    Expect(0, 8534, '\p{^Is_Numeric_Value=4.0e-01}', "");
    Expect(0, 8534, '\P{Is_Numeric_Value=4.0e-01}', "");
    Expect(1, 8534, '\P{^Is_Numeric_Value=4.0e-01}', "");
    Expect(0, 8535, '\p{Is_Numeric_Value=4.0e-01}', "");
    Expect(1, 8535, '\p{^Is_Numeric_Value=4.0e-01}', "");
    Expect(1, 8535, '\P{Is_Numeric_Value=4.0e-01}', "");
    Expect(0, 8535, '\P{^Is_Numeric_Value=4.0e-01}', "");
    Expect(1, 8534, '\p{Is_Numeric_Value=0.4}', "");
    Expect(0, 8534, '\p{^Is_Numeric_Value=0.4}', "");
    Expect(0, 8534, '\P{Is_Numeric_Value=0.4}', "");
    Expect(1, 8534, '\P{^Is_Numeric_Value=0.4}', "");
    Expect(0, 8535, '\p{Is_Numeric_Value=0.4}', "");
    Expect(1, 8535, '\p{^Is_Numeric_Value=0.4}', "");
    Expect(1, 8535, '\P{Is_Numeric_Value=0.4}', "");
    Expect(0, 8535, '\P{^Is_Numeric_Value=0.4}', "");
    Expect(1, 8534, '\p{Is_Numeric_Value=4.00e-01}', "");
    Expect(0, 8534, '\p{^Is_Numeric_Value=4.00e-01}', "");
    Expect(0, 8534, '\P{Is_Numeric_Value=4.00e-01}', "");
    Expect(1, 8534, '\P{^Is_Numeric_Value=4.00e-01}', "");
    Expect(0, 8535, '\p{Is_Numeric_Value=4.00e-01}', "");
    Expect(1, 8535, '\p{^Is_Numeric_Value=4.00e-01}', "");
    Expect(1, 8535, '\P{Is_Numeric_Value=4.00e-01}', "");
    Expect(0, 8535, '\P{^Is_Numeric_Value=4.00e-01}', "");
    Expect(1, 8534, '\p{Is_Numeric_Value=0.40}', "");
    Expect(0, 8534, '\p{^Is_Numeric_Value=0.40}', "");
    Expect(0, 8534, '\P{Is_Numeric_Value=0.40}', "");
    Expect(1, 8534, '\P{^Is_Numeric_Value=0.40}', "");
    Expect(0, 8535, '\p{Is_Numeric_Value=0.40}', "");
    Expect(1, 8535, '\p{^Is_Numeric_Value=0.40}', "");
    Expect(1, 8535, '\P{Is_Numeric_Value=0.40}', "");
    Expect(0, 8535, '\P{^Is_Numeric_Value=0.40}', "");
    Error('\p{Is_Nv=:=  +02/00005}');
    Error('\P{Is_Nv=:=  +02/00005}');
    Expect(1, 8534, '\p{Is_Nv=+0002/00000005}', "");
    Expect(0, 8534, '\p{^Is_Nv=+0002/00000005}', "");
    Expect(0, 8534, '\P{Is_Nv=+0002/00000005}', "");
    Expect(1, 8534, '\P{^Is_Nv=+0002/00000005}', "");
    Expect(0, 8535, '\p{Is_Nv=+0002/00000005}', "");
    Expect(1, 8535, '\p{^Is_Nv=+0002/00000005}', "");
    Expect(1, 8535, '\P{Is_Nv=+0002/00000005}', "");
    Expect(0, 8535, '\P{^Is_Nv=+0002/00000005}', "");
    Expect(1, 8534, '\p{Is_Nv: 120/300}', "");
    Expect(0, 8534, '\p{^Is_Nv: 120/300}', "");
    Expect(0, 8534, '\P{Is_Nv: 120/300}', "");
    Expect(1, 8534, '\P{^Is_Nv: 120/300}', "");
    Expect(0, 8535, '\p{Is_Nv: 120/300}', "");
    Expect(1, 8535, '\p{^Is_Nv: 120/300}', "");
    Expect(1, 8535, '\P{Is_Nv: 120/300}', "");
    Expect(0, 8535, '\P{^Is_Nv: 120/300}', "");
    Expect(1, 8534, '\p{Is_Nv=4.0e-01}', "");
    Expect(0, 8534, '\p{^Is_Nv=4.0e-01}', "");
    Expect(0, 8534, '\P{Is_Nv=4.0e-01}', "");
    Expect(1, 8534, '\P{^Is_Nv=4.0e-01}', "");
    Expect(0, 8535, '\p{Is_Nv=4.0e-01}', "");
    Expect(1, 8535, '\p{^Is_Nv=4.0e-01}', "");
    Expect(1, 8535, '\P{Is_Nv=4.0e-01}', "");
    Expect(0, 8535, '\P{^Is_Nv=4.0e-01}', "");
    Expect(1, 8534, '\p{Is_Nv=0.4}', "");
    Expect(0, 8534, '\p{^Is_Nv=0.4}', "");
    Expect(0, 8534, '\P{Is_Nv=0.4}', "");
    Expect(1, 8534, '\P{^Is_Nv=0.4}', "");
    Expect(0, 8535, '\p{Is_Nv=0.4}', "");
    Expect(1, 8535, '\p{^Is_Nv=0.4}', "");
    Expect(1, 8535, '\P{Is_Nv=0.4}', "");
    Expect(0, 8535, '\P{^Is_Nv=0.4}', "");
    Expect(1, 8534, '\p{Is_Nv=4.00e-01}', "");
    Expect(0, 8534, '\p{^Is_Nv=4.00e-01}', "");
    Expect(0, 8534, '\P{Is_Nv=4.00e-01}', "");
    Expect(1, 8534, '\P{^Is_Nv=4.00e-01}', "");
    Expect(0, 8535, '\p{Is_Nv=4.00e-01}', "");
    Expect(1, 8535, '\p{^Is_Nv=4.00e-01}', "");
    Expect(1, 8535, '\P{Is_Nv=4.00e-01}', "");
    Expect(0, 8535, '\P{^Is_Nv=4.00e-01}', "");
    Expect(1, 8534, '\p{Is_Nv=0.40}', "");
    Expect(0, 8534, '\p{^Is_Nv=0.40}', "");
    Expect(0, 8534, '\P{Is_Nv=0.40}', "");
    Expect(1, 8534, '\P{^Is_Nv=0.40}', "");
    Expect(0, 8535, '\p{Is_Nv=0.40}', "");
    Expect(1, 8535, '\p{^Is_Nv=0.40}', "");
    Expect(1, 8535, '\P{Is_Nv=0.40}', "");
    Expect(0, 8535, '\P{^Is_Nv=0.40}', "");
    Error('\p{Numeric_Value=-/a/+000020}');
    Error('\P{Numeric_Value=-/a/+000020}');
    Expect(1, 126219, '\p{Numeric_Value=:\A20\z:}', "");;
    Expect(0, 126220, '\p{Numeric_Value=:\A20\z:}', "");;
    Expect(1, 126219, '\p{Numeric_Value=0000000020}', "");
    Expect(0, 126219, '\p{^Numeric_Value=0000000020}', "");
    Expect(0, 126219, '\P{Numeric_Value=0000000020}', "");
    Expect(1, 126219, '\P{^Numeric_Value=0000000020}', "");
    Expect(0, 126220, '\p{Numeric_Value=0000000020}', "");
    Expect(1, 126220, '\p{^Numeric_Value=0000000020}', "");
    Expect(1, 126220, '\P{Numeric_Value=0000000020}', "");
    Expect(0, 126220, '\P{^Numeric_Value=0000000020}', "");
    Expect(1, 126219, '\p{Numeric_Value=2.000000000000000e+01}', "");
    Expect(0, 126219, '\p{^Numeric_Value=2.000000000000000e+01}', "");
    Expect(0, 126219, '\P{Numeric_Value=2.000000000000000e+01}', "");
    Expect(1, 126219, '\P{^Numeric_Value=2.000000000000000e+01}', "");
    Expect(0, 126220, '\p{Numeric_Value=2.000000000000000e+01}', "");
    Expect(1, 126220, '\p{^Numeric_Value=2.000000000000000e+01}', "");
    Expect(1, 126220, '\P{Numeric_Value=2.000000000000000e+01}', "");
    Expect(0, 126220, '\P{^Numeric_Value=2.000000000000000e+01}', "");
    Error('\p{Nv:	_00020/a/}');
    Error('\P{Nv:	_00020/a/}');
    Expect(1, 126219, '\p{Nv=:\A20\z:}', "");;
    Expect(0, 126220, '\p{Nv=:\A20\z:}', "");;
    Expect(1, 126219, '\p{Nv=0_0_0_0_0_020}', "");
    Expect(0, 126219, '\p{^Nv=0_0_0_0_0_020}', "");
    Expect(0, 126219, '\P{Nv=0_0_0_0_0_020}', "");
    Expect(1, 126219, '\P{^Nv=0_0_0_0_0_020}', "");
    Expect(0, 126220, '\p{Nv=0_0_0_0_0_020}', "");
    Expect(1, 126220, '\p{^Nv=0_0_0_0_0_020}', "");
    Expect(1, 126220, '\P{Nv=0_0_0_0_0_020}', "");
    Expect(0, 126220, '\P{^Nv=0_0_0_0_0_020}', "");
    Expect(1, 126219, '\p{Nv=2.000000000000000e+01}', "");
    Expect(0, 126219, '\p{^Nv=2.000000000000000e+01}', "");
    Expect(0, 126219, '\P{Nv=2.000000000000000e+01}', "");
    Expect(1, 126219, '\P{^Nv=2.000000000000000e+01}', "");
    Expect(0, 126220, '\p{Nv=2.000000000000000e+01}', "");
    Expect(1, 126220, '\p{^Nv=2.000000000000000e+01}', "");
    Expect(1, 126220, '\P{Nv=2.000000000000000e+01}', "");
    Expect(0, 126220, '\P{^Nv=2.000000000000000e+01}', "");
    Error('\p{Is_Numeric_Value=_/a/+0_0_20}');
    Error('\P{Is_Numeric_Value=_/a/+0_0_20}');
    Expect(1, 126219, '\p{Is_Numeric_Value:   020}', "");
    Expect(0, 126219, '\p{^Is_Numeric_Value:   020}', "");
    Expect(0, 126219, '\P{Is_Numeric_Value:   020}', "");
    Expect(1, 126219, '\P{^Is_Numeric_Value:   020}', "");
    Expect(0, 126220, '\p{Is_Numeric_Value:   020}', "");
    Expect(1, 126220, '\p{^Is_Numeric_Value:   020}', "");
    Expect(1, 126220, '\P{Is_Numeric_Value:   020}', "");
    Expect(0, 126220, '\P{^Is_Numeric_Value:   020}', "");
    Expect(1, 126219, '\p{Is_Numeric_Value=2.000000000000000e+01}', "");
    Expect(0, 126219, '\p{^Is_Numeric_Value=2.000000000000000e+01}', "");
    Expect(0, 126219, '\P{Is_Numeric_Value=2.000000000000000e+01}', "");
    Expect(1, 126219, '\P{^Is_Numeric_Value=2.000000000000000e+01}', "");
    Expect(0, 126220, '\p{Is_Numeric_Value=2.000000000000000e+01}', "");
    Expect(1, 126220, '\p{^Is_Numeric_Value=2.000000000000000e+01}', "");
    Expect(1, 126220, '\P{Is_Numeric_Value=2.000000000000000e+01}', "");
    Expect(0, 126220, '\P{^Is_Numeric_Value=2.000000000000000e+01}', "");
    Error('\p{Is_Nv=:=_ 0_0_20}');
    Error('\P{Is_Nv=:=_ 0_0_20}');
    Expect(1, 126219, '\p{Is_Nv=+0_0_0_0_20}', "");
    Expect(0, 126219, '\p{^Is_Nv=+0_0_0_0_20}', "");
    Expect(0, 126219, '\P{Is_Nv=+0_0_0_0_20}', "");
    Expect(1, 126219, '\P{^Is_Nv=+0_0_0_0_20}', "");
    Expect(0, 126220, '\p{Is_Nv=+0_0_0_0_20}', "");
    Expect(1, 126220, '\p{^Is_Nv=+0_0_0_0_20}', "");
    Expect(1, 126220, '\P{Is_Nv=+0_0_0_0_20}', "");
    Expect(0, 126220, '\P{^Is_Nv=+0_0_0_0_20}', "");
    Expect(1, 126219, '\p{Is_Nv=2.000000000000000e+01}', "");
    Expect(0, 126219, '\p{^Is_Nv=2.000000000000000e+01}', "");
    Expect(0, 126219, '\P{Is_Nv=2.000000000000000e+01}', "");
    Expect(1, 126219, '\P{^Is_Nv=2.000000000000000e+01}', "");
    Expect(0, 126220, '\p{Is_Nv=2.000000000000000e+01}', "");
    Expect(1, 126220, '\p{^Is_Nv=2.000000000000000e+01}', "");
    Expect(1, 126220, '\P{Is_Nv=2.000000000000000e+01}', "");
    Expect(0, 126220, '\P{^Is_Nv=2.000000000000000e+01}', "");
    Error('\p{Numeric_Value=:=_0020_0}');
    Error('\P{Numeric_Value=:=_0020_0}');
    Expect(1, 126228, '\p{Numeric_Value=:\A200\z:}', "");;
    Expect(0, 126229, '\p{Numeric_Value=:\A200\z:}', "");;
    Expect(1, 126228, '\p{Numeric_Value:	0000000200}', "");
    Expect(0, 126228, '\p{^Numeric_Value:	0000000200}', "");
    Expect(0, 126228, '\P{Numeric_Value:	0000000200}', "");
    Expect(1, 126228, '\P{^Numeric_Value:	0000000200}', "");
    Expect(0, 126229, '\p{Numeric_Value:	0000000200}', "");
    Expect(1, 126229, '\p{^Numeric_Value:	0000000200}', "");
    Expect(1, 126229, '\P{Numeric_Value:	0000000200}', "");
    Expect(0, 126229, '\P{^Numeric_Value:	0000000200}', "");
    Expect(1, 126228, '\p{Numeric_Value=2.000000000000000e+02}', "");
    Expect(0, 126228, '\p{^Numeric_Value=2.000000000000000e+02}', "");
    Expect(0, 126228, '\P{Numeric_Value=2.000000000000000e+02}', "");
    Expect(1, 126228, '\P{^Numeric_Value=2.000000000000000e+02}', "");
    Expect(0, 126229, '\p{Numeric_Value=2.000000000000000e+02}', "");
    Expect(1, 126229, '\p{^Numeric_Value=2.000000000000000e+02}', "");
    Expect(1, 126229, '\P{Numeric_Value=2.000000000000000e+02}', "");
    Expect(0, 126229, '\P{^Numeric_Value=2.000000000000000e+02}', "");
    Error('\p{Nv=-/a/+000200}');
    Error('\P{Nv=-/a/+000200}');
    Expect(1, 126228, '\p{Nv=:\A200\z:}', "");;
    Expect(0, 126229, '\p{Nv=:\A200\z:}', "");;
    Expect(1, 126228, '\p{Nv=020_0}', "");
    Expect(0, 126228, '\p{^Nv=020_0}', "");
    Expect(0, 126228, '\P{Nv=020_0}', "");
    Expect(1, 126228, '\P{^Nv=020_0}', "");
    Expect(0, 126229, '\p{Nv=020_0}', "");
    Expect(1, 126229, '\p{^Nv=020_0}', "");
    Expect(1, 126229, '\P{Nv=020_0}', "");
    Expect(0, 126229, '\P{^Nv=020_0}', "");
    Expect(1, 126228, '\p{Nv:   2.000000000000000e+02}', "");
    Expect(0, 126228, '\p{^Nv:   2.000000000000000e+02}', "");
    Expect(0, 126228, '\P{Nv:   2.000000000000000e+02}', "");
    Expect(1, 126228, '\P{^Nv:   2.000000000000000e+02}', "");
    Expect(0, 126229, '\p{Nv:   2.000000000000000e+02}', "");
    Expect(1, 126229, '\p{^Nv:   2.000000000000000e+02}', "");
    Expect(1, 126229, '\P{Nv:   2.000000000000000e+02}', "");
    Expect(0, 126229, '\P{^Nv:   2.000000000000000e+02}', "");
    Error('\p{Is_Numeric_Value=_00_00_00_200:=}');
    Error('\P{Is_Numeric_Value=_00_00_00_200:=}');
    Expect(1, 126228, '\p{Is_Numeric_Value=000_020_0}', "");
    Expect(0, 126228, '\p{^Is_Numeric_Value=000_020_0}', "");
    Expect(0, 126228, '\P{Is_Numeric_Value=000_020_0}', "");
    Expect(1, 126228, '\P{^Is_Numeric_Value=000_020_0}', "");
    Expect(0, 126229, '\p{Is_Numeric_Value=000_020_0}', "");
    Expect(1, 126229, '\p{^Is_Numeric_Value=000_020_0}', "");
    Expect(1, 126229, '\P{Is_Numeric_Value=000_020_0}', "");
    Expect(0, 126229, '\P{^Is_Numeric_Value=000_020_0}', "");
    Expect(1, 126228, '\p{Is_Numeric_Value: 2.000000000000000e+02}', "");
    Expect(0, 126228, '\p{^Is_Numeric_Value: 2.000000000000000e+02}', "");
    Expect(0, 126228, '\P{Is_Numeric_Value: 2.000000000000000e+02}', "");
    Expect(1, 126228, '\P{^Is_Numeric_Value: 2.000000000000000e+02}', "");
    Expect(0, 126229, '\p{Is_Numeric_Value: 2.000000000000000e+02}', "");
    Expect(1, 126229, '\p{^Is_Numeric_Value: 2.000000000000000e+02}', "");
    Expect(1, 126229, '\P{Is_Numeric_Value: 2.000000000000000e+02}', "");
    Expect(0, 126229, '\P{^Is_Numeric_Value: 2.000000000000000e+02}', "");
    Error('\p{Is_Nv=/a/_00200}');
    Error('\P{Is_Nv=/a/_00200}');
    Expect(1, 126228, '\p{Is_Nv=00000020_0}', "");
    Expect(0, 126228, '\p{^Is_Nv=00000020_0}', "");
    Expect(0, 126228, '\P{Is_Nv=00000020_0}', "");
    Expect(1, 126228, '\P{^Is_Nv=00000020_0}', "");
    Expect(0, 126229, '\p{Is_Nv=00000020_0}', "");
    Expect(1, 126229, '\p{^Is_Nv=00000020_0}', "");
    Expect(1, 126229, '\P{Is_Nv=00000020_0}', "");
    Expect(0, 126229, '\P{^Is_Nv=00000020_0}', "");
    Expect(1, 126228, '\p{Is_Nv=2.000000000000000e+02}', "");
    Expect(0, 126228, '\p{^Is_Nv=2.000000000000000e+02}', "");
    Expect(0, 126228, '\P{Is_Nv=2.000000000000000e+02}', "");
    Expect(1, 126228, '\P{^Is_Nv=2.000000000000000e+02}', "");
    Expect(0, 126229, '\p{Is_Nv=2.000000000000000e+02}', "");
    Expect(1, 126229, '\p{^Is_Nv=2.000000000000000e+02}', "");
    Expect(1, 126229, '\P{Is_Nv=2.000000000000000e+02}', "");
    Expect(0, 126229, '\P{^Is_Nv=2.000000000000000e+02}', "");
    Error('\p{Numeric_Value=/a/0_0_0_0_0_0_2_0_00}');
    Error('\P{Numeric_Value=/a/0_0_0_0_0_0_2_0_00}');
    Expect(1, 126266, '\p{Numeric_Value=:\A2000\z:}', "");;
    Expect(0, 126267, '\p{Numeric_Value=:\A2000\z:}', "");;
    Expect(1, 126266, '\p{Numeric_Value=+0_0_0_0_2000}', "");
    Expect(0, 126266, '\p{^Numeric_Value=+0_0_0_0_2000}', "");
    Expect(0, 126266, '\P{Numeric_Value=+0_0_0_0_2000}', "");
    Expect(1, 126266, '\P{^Numeric_Value=+0_0_0_0_2000}', "");
    Expect(0, 126267, '\p{Numeric_Value=+0_0_0_0_2000}', "");
    Expect(1, 126267, '\p{^Numeric_Value=+0_0_0_0_2000}', "");
    Expect(1, 126267, '\P{Numeric_Value=+0_0_0_0_2000}', "");
    Expect(0, 126267, '\P{^Numeric_Value=+0_0_0_0_2000}', "");
    Expect(1, 126266, '\p{Numeric_Value=2.000000000000000e+03}', "");
    Expect(0, 126266, '\p{^Numeric_Value=2.000000000000000e+03}', "");
    Expect(0, 126266, '\P{Numeric_Value=2.000000000000000e+03}', "");
    Expect(1, 126266, '\P{^Numeric_Value=2.000000000000000e+03}', "");
    Expect(0, 126267, '\p{Numeric_Value=2.000000000000000e+03}', "");
    Expect(1, 126267, '\p{^Numeric_Value=2.000000000000000e+03}', "");
    Expect(1, 126267, '\P{Numeric_Value=2.000000000000000e+03}', "");
    Expect(0, 126267, '\P{^Numeric_Value=2.000000000000000e+03}', "");
    Error('\p{Nv=/a/ -+0000002000}');
    Error('\P{Nv=/a/ -+0000002000}');
    Expect(1, 126266, '\p{Nv=:\A2000\z:}', "");;
    Expect(0, 126267, '\p{Nv=:\A2000\z:}', "");;
    Expect(1, 126266, '\p{Nv=2000}', "");
    Expect(0, 126266, '\p{^Nv=2000}', "");
    Expect(0, 126266, '\P{Nv=2000}', "");
    Expect(1, 126266, '\P{^Nv=2000}', "");
    Expect(0, 126267, '\p{Nv=2000}', "");
    Expect(1, 126267, '\p{^Nv=2000}', "");
    Expect(1, 126267, '\P{Nv=2000}', "");
    Expect(0, 126267, '\P{^Nv=2000}', "");
    Expect(1, 126266, '\p{Nv=2.000000000000000e+03}', "");
    Expect(0, 126266, '\p{^Nv=2.000000000000000e+03}', "");
    Expect(0, 126266, '\P{Nv=2.000000000000000e+03}', "");
    Expect(1, 126266, '\P{^Nv=2.000000000000000e+03}', "");
    Expect(0, 126267, '\p{Nv=2.000000000000000e+03}', "");
    Expect(1, 126267, '\p{^Nv=2.000000000000000e+03}', "");
    Expect(1, 126267, '\P{Nv=2.000000000000000e+03}', "");
    Expect(0, 126267, '\P{^Nv=2.000000000000000e+03}', "");
    Error('\p{Is_Numeric_Value=/a/000002000}');
    Error('\P{Is_Numeric_Value=/a/000002000}');
    Expect(1, 126266, '\p{Is_Numeric_Value:   02000}', "");
    Expect(0, 126266, '\p{^Is_Numeric_Value:   02000}', "");
    Expect(0, 126266, '\P{Is_Numeric_Value:   02000}', "");
    Expect(1, 126266, '\P{^Is_Numeric_Value:   02000}', "");
    Expect(0, 126267, '\p{Is_Numeric_Value:   02000}', "");
    Expect(1, 126267, '\p{^Is_Numeric_Value:   02000}', "");
    Expect(1, 126267, '\P{Is_Numeric_Value:   02000}', "");
    Expect(0, 126267, '\P{^Is_Numeric_Value:   02000}', "");
    Expect(1, 126266, '\p{Is_Numeric_Value=2.000000000000000e+03}', "");
    Expect(0, 126266, '\p{^Is_Numeric_Value=2.000000000000000e+03}', "");
    Expect(0, 126266, '\P{Is_Numeric_Value=2.000000000000000e+03}', "");
    Expect(1, 126266, '\P{^Is_Numeric_Value=2.000000000000000e+03}', "");
    Expect(0, 126267, '\p{Is_Numeric_Value=2.000000000000000e+03}', "");
    Expect(1, 126267, '\p{^Is_Numeric_Value=2.000000000000000e+03}', "");
    Expect(1, 126267, '\P{Is_Numeric_Value=2.000000000000000e+03}', "");
    Expect(0, 126267, '\P{^Is_Numeric_Value=2.000000000000000e+03}', "");
    Error('\p{Is_Nv=_/a/+000000002000}');
    Error('\P{Is_Nv=_/a/+000000002000}');
    Expect(1, 126266, '\p{Is_Nv=000_000_000_200_0}', "");
    Expect(0, 126266, '\p{^Is_Nv=000_000_000_200_0}', "");
    Expect(0, 126266, '\P{Is_Nv=000_000_000_200_0}', "");
    Expect(1, 126266, '\P{^Is_Nv=000_000_000_200_0}', "");
    Expect(0, 126267, '\p{Is_Nv=000_000_000_200_0}', "");
    Expect(1, 126267, '\p{^Is_Nv=000_000_000_200_0}', "");
    Expect(1, 126267, '\P{Is_Nv=000_000_000_200_0}', "");
    Expect(0, 126267, '\P{^Is_Nv=000_000_000_200_0}', "");
    Expect(1, 126266, '\p{Is_Nv=2.000000000000000e+03}', "");
    Expect(0, 126266, '\p{^Is_Nv=2.000000000000000e+03}', "");
    Expect(0, 126266, '\P{Is_Nv=2.000000000000000e+03}', "");
    Expect(1, 126266, '\P{^Is_Nv=2.000000000000000e+03}', "");
    Expect(0, 126267, '\p{Is_Nv=2.000000000000000e+03}', "");
    Expect(1, 126267, '\p{^Is_Nv=2.000000000000000e+03}', "");
    Expect(1, 126267, '\P{Is_Nv=2.000000000000000e+03}', "");
    Expect(0, 126267, '\P{^Is_Nv=2.000000000000000e+03}', "");
    Error('\p{Numeric_Value:	-00000020000:=}');
    Error('\P{Numeric_Value:	-00000020000:=}');
    Expect(1, 126246, '\p{Numeric_Value=:\A20000\z:}', "");;
    Expect(0, 126247, '\p{Numeric_Value=:\A20000\z:}', "");;
    Expect(1, 126246, '\p{Numeric_Value=+00020000}', "");
    Expect(0, 126246, '\p{^Numeric_Value=+00020000}', "");
    Expect(0, 126246, '\P{Numeric_Value=+00020000}', "");
    Expect(1, 126246, '\P{^Numeric_Value=+00020000}', "");
    Expect(0, 126247, '\p{Numeric_Value=+00020000}', "");
    Expect(1, 126247, '\p{^Numeric_Value=+00020000}', "");
    Expect(1, 126247, '\P{Numeric_Value=+00020000}', "");
    Expect(0, 126247, '\P{^Numeric_Value=+00020000}', "");
    Expect(1, 126246, '\p{Numeric_Value=2.000000000000000e+04}', "");
    Expect(0, 126246, '\p{^Numeric_Value=2.000000000000000e+04}', "");
    Expect(0, 126246, '\P{Numeric_Value=2.000000000000000e+04}', "");
    Expect(1, 126246, '\P{^Numeric_Value=2.000000000000000e+04}', "");
    Expect(0, 126247, '\p{Numeric_Value=2.000000000000000e+04}', "");
    Expect(1, 126247, '\p{^Numeric_Value=2.000000000000000e+04}', "");
    Expect(1, 126247, '\P{Numeric_Value=2.000000000000000e+04}', "");
    Expect(0, 126247, '\P{^Numeric_Value=2.000000000000000e+04}', "");
    Error('\p{Nv:	-	0_0_0_0_0_0_2_0_0_00/a/}');
    Error('\P{Nv:	-	0_0_0_0_0_0_2_0_0_00/a/}');
    Expect(1, 126246, '\p{Nv=:\A20000\z:}', "");;
    Expect(0, 126247, '\p{Nv=:\A20000\z:}', "");;
    Expect(1, 126246, '\p{Nv=000020000}', "");
    Expect(0, 126246, '\p{^Nv=000020000}', "");
    Expect(0, 126246, '\P{Nv=000020000}', "");
    Expect(1, 126246, '\P{^Nv=000020000}', "");
    Expect(0, 126247, '\p{Nv=000020000}', "");
    Expect(1, 126247, '\p{^Nv=000020000}', "");
    Expect(1, 126247, '\P{Nv=000020000}', "");
    Expect(0, 126247, '\P{^Nv=000020000}', "");
    Expect(1, 126246, '\p{Nv=2.000000000000000e+04}', "");
    Expect(0, 126246, '\p{^Nv=2.000000000000000e+04}', "");
    Expect(0, 126246, '\P{Nv=2.000000000000000e+04}', "");
    Expect(1, 126246, '\P{^Nv=2.000000000000000e+04}', "");
    Expect(0, 126247, '\p{Nv=2.000000000000000e+04}', "");
    Expect(1, 126247, '\p{^Nv=2.000000000000000e+04}', "");
    Expect(1, 126247, '\P{Nv=2.000000000000000e+04}', "");
    Expect(0, 126247, '\P{^Nv=2.000000000000000e+04}', "");
    Error('\p{Is_Numeric_Value=:=+0000020000}');
    Error('\P{Is_Numeric_Value=:=+0000020000}');
    Expect(1, 126246, '\p{Is_Numeric_Value=00000020000}', "");
    Expect(0, 126246, '\p{^Is_Numeric_Value=00000020000}', "");
    Expect(0, 126246, '\P{Is_Numeric_Value=00000020000}', "");
    Expect(1, 126246, '\P{^Is_Numeric_Value=00000020000}', "");
    Expect(0, 126247, '\p{Is_Numeric_Value=00000020000}', "");
    Expect(1, 126247, '\p{^Is_Numeric_Value=00000020000}', "");
    Expect(1, 126247, '\P{Is_Numeric_Value=00000020000}', "");
    Expect(0, 126247, '\P{^Is_Numeric_Value=00000020000}', "");
    Expect(1, 126246, '\p{Is_Numeric_Value=2.000000000000000e+04}', "");
    Expect(0, 126246, '\p{^Is_Numeric_Value=2.000000000000000e+04}', "");
    Expect(0, 126246, '\P{Is_Numeric_Value=2.000000000000000e+04}', "");
    Expect(1, 126246, '\P{^Is_Numeric_Value=2.000000000000000e+04}', "");
    Expect(0, 126247, '\p{Is_Numeric_Value=2.000000000000000e+04}', "");
    Expect(1, 126247, '\p{^Is_Numeric_Value=2.000000000000000e+04}', "");
    Expect(1, 126247, '\P{Is_Numeric_Value=2.000000000000000e+04}', "");
    Expect(0, 126247, '\P{^Is_Numeric_Value=2.000000000000000e+04}', "");
    Error('\p{Is_Nv:		:=+2_0_0_00}');
    Error('\P{Is_Nv:		:=+2_0_0_00}');
    Expect(1, 126246, '\p{Is_Nv=00_20_00_0}', "");
    Expect(0, 126246, '\p{^Is_Nv=00_20_00_0}', "");
    Expect(0, 126246, '\P{Is_Nv=00_20_00_0}', "");
    Expect(1, 126246, '\P{^Is_Nv=00_20_00_0}', "");
    Expect(0, 126247, '\p{Is_Nv=00_20_00_0}', "");
    Expect(1, 126247, '\p{^Is_Nv=00_20_00_0}', "");
    Expect(1, 126247, '\P{Is_Nv=00_20_00_0}', "");
    Expect(0, 126247, '\P{^Is_Nv=00_20_00_0}', "");
    Expect(1, 126246, '\p{Is_Nv=2.000000000000000e+04}', "");
    Expect(0, 126246, '\p{^Is_Nv=2.000000000000000e+04}', "");
    Expect(0, 126246, '\P{Is_Nv=2.000000000000000e+04}', "");
    Expect(1, 126246, '\P{^Is_Nv=2.000000000000000e+04}', "");
    Expect(0, 126247, '\p{Is_Nv=2.000000000000000e+04}', "");
    Expect(1, 126247, '\p{^Is_Nv=2.000000000000000e+04}', "");
    Expect(1, 126247, '\P{Is_Nv=2.000000000000000e+04}', "");
    Expect(0, 126247, '\P{^Is_Nv=2.000000000000000e+04}', "");
    Error('\p{Numeric_Value=:= 0000200000}');
    Error('\P{Numeric_Value=:= 0000200000}');
    Expect(1, 126111, '\p{Numeric_Value=:\A200000\z:}', "");;
    Expect(0, 126112, '\p{Numeric_Value=:\A200000\z:}', "");;
    Expect(1, 126111, '\p{Numeric_Value=00000000200000}', "");
    Expect(0, 126111, '\p{^Numeric_Value=00000000200000}', "");
    Expect(0, 126111, '\P{Numeric_Value=00000000200000}', "");
    Expect(1, 126111, '\P{^Numeric_Value=00000000200000}', "");
    Expect(0, 126112, '\p{Numeric_Value=00000000200000}', "");
    Expect(1, 126112, '\p{^Numeric_Value=00000000200000}', "");
    Expect(1, 126112, '\P{Numeric_Value=00000000200000}', "");
    Expect(0, 126112, '\P{^Numeric_Value=00000000200000}', "");
    Expect(1, 126111, '\p{Numeric_Value=2.000000000000000e+05}', "");
    Expect(0, 126111, '\p{^Numeric_Value=2.000000000000000e+05}', "");
    Expect(0, 126111, '\P{Numeric_Value=2.000000000000000e+05}', "");
    Expect(1, 126111, '\P{^Numeric_Value=2.000000000000000e+05}', "");
    Expect(0, 126112, '\p{Numeric_Value=2.000000000000000e+05}', "");
    Expect(1, 126112, '\p{^Numeric_Value=2.000000000000000e+05}', "");
    Expect(1, 126112, '\P{Numeric_Value=2.000000000000000e+05}', "");
    Expect(0, 126112, '\P{^Numeric_Value=2.000000000000000e+05}', "");
    Error('\p{Nv=		00_00_02_00_000/a/}');
    Error('\P{Nv=		00_00_02_00_000/a/}');
    Expect(1, 126111, '\p{Nv=:\A200000\z:}', "");;
    Expect(0, 126112, '\p{Nv=:\A200000\z:}', "");;
    Expect(1, 126111, '\p{Nv=00000200000}', "");
    Expect(0, 126111, '\p{^Nv=00000200000}', "");
    Expect(0, 126111, '\P{Nv=00000200000}', "");
    Expect(1, 126111, '\P{^Nv=00000200000}', "");
    Expect(0, 126112, '\p{Nv=00000200000}', "");
    Expect(1, 126112, '\p{^Nv=00000200000}', "");
    Expect(1, 126112, '\P{Nv=00000200000}', "");
    Expect(0, 126112, '\P{^Nv=00000200000}', "");
    Expect(1, 126111, '\p{Nv=2.000000000000000e+05}', "");
    Expect(0, 126111, '\p{^Nv=2.000000000000000e+05}', "");
    Expect(0, 126111, '\P{Nv=2.000000000000000e+05}', "");
    Expect(1, 126111, '\P{^Nv=2.000000000000000e+05}', "");
    Expect(0, 126112, '\p{Nv=2.000000000000000e+05}', "");
    Expect(1, 126112, '\p{^Nv=2.000000000000000e+05}', "");
    Expect(1, 126112, '\P{Nv=2.000000000000000e+05}', "");
    Expect(0, 126112, '\P{^Nv=2.000000000000000e+05}', "");
    Error('\p{Is_Numeric_Value: /a/	 0000200000}');
    Error('\P{Is_Numeric_Value: /a/	 0000200000}');
    Expect(1, 126111, '\p{Is_Numeric_Value=+0000000_0020000_0}', "");
    Expect(0, 126111, '\p{^Is_Numeric_Value=+0000000_0020000_0}', "");
    Expect(0, 126111, '\P{Is_Numeric_Value=+0000000_0020000_0}', "");
    Expect(1, 126111, '\P{^Is_Numeric_Value=+0000000_0020000_0}', "");
    Expect(0, 126112, '\p{Is_Numeric_Value=+0000000_0020000_0}', "");
    Expect(1, 126112, '\p{^Is_Numeric_Value=+0000000_0020000_0}', "");
    Expect(1, 126112, '\P{Is_Numeric_Value=+0000000_0020000_0}', "");
    Expect(0, 126112, '\P{^Is_Numeric_Value=+0000000_0020000_0}', "");
    Expect(1, 126111, '\p{Is_Numeric_Value=2.000000000000000e+05}', "");
    Expect(0, 126111, '\p{^Is_Numeric_Value=2.000000000000000e+05}', "");
    Expect(0, 126111, '\P{Is_Numeric_Value=2.000000000000000e+05}', "");
    Expect(1, 126111, '\P{^Is_Numeric_Value=2.000000000000000e+05}', "");
    Expect(0, 126112, '\p{Is_Numeric_Value=2.000000000000000e+05}', "");
    Expect(1, 126112, '\p{^Is_Numeric_Value=2.000000000000000e+05}', "");
    Expect(1, 126112, '\P{Is_Numeric_Value=2.000000000000000e+05}', "");
    Expect(0, 126112, '\P{^Is_Numeric_Value=2.000000000000000e+05}', "");
    Error('\p{Is_Nv=		00000200000:=}');
    Error('\P{Is_Nv=		00000200000:=}');
    Expect(1, 126111, '\p{Is_Nv=0_0_0_0_0_0_0_0_2_00000}', "");
    Expect(0, 126111, '\p{^Is_Nv=0_0_0_0_0_0_0_0_2_00000}', "");
    Expect(0, 126111, '\P{Is_Nv=0_0_0_0_0_0_0_0_2_00000}', "");
    Expect(1, 126111, '\P{^Is_Nv=0_0_0_0_0_0_0_0_2_00000}', "");
    Expect(0, 126112, '\p{Is_Nv=0_0_0_0_0_0_0_0_2_00000}', "");
    Expect(1, 126112, '\p{^Is_Nv=0_0_0_0_0_0_0_0_2_00000}', "");
    Expect(1, 126112, '\P{Is_Nv=0_0_0_0_0_0_0_0_2_00000}', "");
    Expect(0, 126112, '\P{^Is_Nv=0_0_0_0_0_0_0_0_2_00000}', "");
    Expect(1, 126111, '\p{Is_Nv=2.000000000000000e+05}', "");
    Expect(0, 126111, '\p{^Is_Nv=2.000000000000000e+05}', "");
    Expect(0, 126111, '\P{Is_Nv=2.000000000000000e+05}', "");
    Expect(1, 126111, '\P{^Is_Nv=2.000000000000000e+05}', "");
    Expect(0, 126112, '\p{Is_Nv=2.000000000000000e+05}', "");
    Expect(1, 126112, '\p{^Is_Nv=2.000000000000000e+05}', "");
    Expect(1, 126112, '\P{Is_Nv=2.000000000000000e+05}', "");
    Expect(0, 126112, '\P{^Is_Nv=2.000000000000000e+05}', "");
    Error('\p{Numeric_Value:   -	000020000000:=}');
    Error('\P{Numeric_Value:   -	000020000000:=}');
    Expect(1, 126114, '\p{Numeric_Value=:\A20000000\z:}', "");;
    Expect(0, 126115, '\p{Numeric_Value=:\A20000000\z:}', "");;
    Expect(1, 126114, '\p{Numeric_Value=20000000}', "");
    Expect(0, 126114, '\p{^Numeric_Value=20000000}', "");
    Expect(0, 126114, '\P{Numeric_Value=20000000}', "");
    Expect(1, 126114, '\P{^Numeric_Value=20000000}', "");
    Expect(0, 126115, '\p{Numeric_Value=20000000}', "");
    Expect(1, 126115, '\p{^Numeric_Value=20000000}', "");
    Expect(1, 126115, '\P{Numeric_Value=20000000}', "");
    Expect(0, 126115, '\P{^Numeric_Value=20000000}', "");
    Expect(1, 126114, '\p{Numeric_Value=2.000000000000000e+07}', "");
    Expect(0, 126114, '\p{^Numeric_Value=2.000000000000000e+07}', "");
    Expect(0, 126114, '\P{Numeric_Value=2.000000000000000e+07}', "");
    Expect(1, 126114, '\P{^Numeric_Value=2.000000000000000e+07}', "");
    Expect(0, 126115, '\p{Numeric_Value=2.000000000000000e+07}', "");
    Expect(1, 126115, '\p{^Numeric_Value=2.000000000000000e+07}', "");
    Expect(1, 126115, '\P{Numeric_Value=2.000000000000000e+07}', "");
    Expect(0, 126115, '\P{^Numeric_Value=2.000000000000000e+07}', "");
    Error('\p{Nv=-00_00_20_00_0000/a/}');
    Error('\P{Nv=-00_00_20_00_0000/a/}');
    Expect(1, 126114, '\p{Nv=:\A20000000\z:}', "");;
    Expect(0, 126115, '\p{Nv=:\A20000000\z:}', "");;
    Expect(1, 126114, '\p{Nv=0_0_0_0_0_0_0_2_0_0_0_0_000}', "");
    Expect(0, 126114, '\p{^Nv=0_0_0_0_0_0_0_2_0_0_0_0_000}', "");
    Expect(0, 126114, '\P{Nv=0_0_0_0_0_0_0_2_0_0_0_0_000}', "");
    Expect(1, 126114, '\P{^Nv=0_0_0_0_0_0_0_2_0_0_0_0_000}', "");
    Expect(0, 126115, '\p{Nv=0_0_0_0_0_0_0_2_0_0_0_0_000}', "");
    Expect(1, 126115, '\p{^Nv=0_0_0_0_0_0_0_2_0_0_0_0_000}', "");
    Expect(1, 126115, '\P{Nv=0_0_0_0_0_0_0_2_0_0_0_0_000}', "");
    Expect(0, 126115, '\P{^Nv=0_0_0_0_0_0_0_2_0_0_0_0_000}', "");
    Expect(1, 126114, '\p{Nv=2.000000000000000e+07}', "");
    Expect(0, 126114, '\p{^Nv=2.000000000000000e+07}', "");
    Expect(0, 126114, '\P{Nv=2.000000000000000e+07}', "");
    Expect(1, 126114, '\P{^Nv=2.000000000000000e+07}', "");
    Expect(0, 126115, '\p{Nv=2.000000000000000e+07}', "");
    Expect(1, 126115, '\p{^Nv=2.000000000000000e+07}', "");
    Expect(1, 126115, '\P{Nv=2.000000000000000e+07}', "");
    Expect(0, 126115, '\P{^Nv=2.000000000000000e+07}', "");
    Error('\p{Is_Numeric_Value= -+00_00_00_00_02_00_00_00_0/a/}');
    Error('\P{Is_Numeric_Value= -+00_00_00_00_02_00_00_00_0/a/}');
    Expect(1, 126114, '\p{Is_Numeric_Value=+00000020000000}', "");
    Expect(0, 126114, '\p{^Is_Numeric_Value=+00000020000000}', "");
    Expect(0, 126114, '\P{Is_Numeric_Value=+00000020000000}', "");
    Expect(1, 126114, '\P{^Is_Numeric_Value=+00000020000000}', "");
    Expect(0, 126115, '\p{Is_Numeric_Value=+00000020000000}', "");
    Expect(1, 126115, '\p{^Is_Numeric_Value=+00000020000000}', "");
    Expect(1, 126115, '\P{Is_Numeric_Value=+00000020000000}', "");
    Expect(0, 126115, '\P{^Is_Numeric_Value=+00000020000000}', "");
    Expect(1, 126114, '\p{Is_Numeric_Value=2.000000000000000e+07}', "");
    Expect(0, 126114, '\p{^Is_Numeric_Value=2.000000000000000e+07}', "");
    Expect(0, 126114, '\P{Is_Numeric_Value=2.000000000000000e+07}', "");
    Expect(1, 126114, '\P{^Is_Numeric_Value=2.000000000000000e+07}', "");
    Expect(0, 126115, '\p{Is_Numeric_Value=2.000000000000000e+07}', "");
    Expect(1, 126115, '\p{^Is_Numeric_Value=2.000000000000000e+07}', "");
    Expect(1, 126115, '\P{Is_Numeric_Value=2.000000000000000e+07}', "");
    Expect(0, 126115, '\P{^Is_Numeric_Value=2.000000000000000e+07}', "");
    Error('\p{Is_Nv=/a/ 	000000020000000}');
    Error('\P{Is_Nv=/a/ 	000000020000000}');
    Expect(1, 126114, '\p{Is_Nv=00_00_02_00_00_00_0}', "");
    Expect(0, 126114, '\p{^Is_Nv=00_00_02_00_00_00_0}', "");
    Expect(0, 126114, '\P{Is_Nv=00_00_02_00_00_00_0}', "");
    Expect(1, 126114, '\P{^Is_Nv=00_00_02_00_00_00_0}', "");
    Expect(0, 126115, '\p{Is_Nv=00_00_02_00_00_00_0}', "");
    Expect(1, 126115, '\p{^Is_Nv=00_00_02_00_00_00_0}', "");
    Expect(1, 126115, '\P{Is_Nv=00_00_02_00_00_00_0}', "");
    Expect(0, 126115, '\P{^Is_Nv=00_00_02_00_00_00_0}', "");
    Expect(1, 126114, '\p{Is_Nv=2.000000000000000e+07}', "");
    Expect(0, 126114, '\p{^Is_Nv=2.000000000000000e+07}', "");
    Expect(0, 126114, '\P{Is_Nv=2.000000000000000e+07}', "");
    Expect(1, 126114, '\P{^Is_Nv=2.000000000000000e+07}', "");
    Expect(0, 126115, '\p{Is_Nv=2.000000000000000e+07}', "");
    Expect(1, 126115, '\p{^Is_Nv=2.000000000000000e+07}', "");
    Expect(1, 126115, '\P{Is_Nv=2.000000000000000e+07}', "");
    Expect(0, 126115, '\P{^Is_Nv=2.000000000000000e+07}', "");
    Error('\p{Numeric_Value=/a/_-00_00_21}');
    Error('\P{Numeric_Value=/a/_-00_00_21}');
    Expect(1, 12881, '\p{Numeric_Value=:\A21\z:}', "");;
    Expect(0, 12882, '\p{Numeric_Value=:\A21\z:}', "");;
    Expect(1, 12881, '\p{Numeric_Value=021}', "");
    Expect(0, 12881, '\p{^Numeric_Value=021}', "");
    Expect(0, 12881, '\P{Numeric_Value=021}', "");
    Expect(1, 12881, '\P{^Numeric_Value=021}', "");
    Expect(0, 12882, '\p{Numeric_Value=021}', "");
    Expect(1, 12882, '\p{^Numeric_Value=021}', "");
    Expect(1, 12882, '\P{Numeric_Value=021}', "");
    Expect(0, 12882, '\P{^Numeric_Value=021}', "");
    Expect(1, 12881, '\p{Numeric_Value=2.100000000000000e+01}', "");
    Expect(0, 12881, '\p{^Numeric_Value=2.100000000000000e+01}', "");
    Expect(0, 12881, '\P{Numeric_Value=2.100000000000000e+01}', "");
    Expect(1, 12881, '\P{^Numeric_Value=2.100000000000000e+01}', "");
    Expect(0, 12882, '\p{Numeric_Value=2.100000000000000e+01}', "");
    Expect(1, 12882, '\p{^Numeric_Value=2.100000000000000e+01}', "");
    Expect(1, 12882, '\P{Numeric_Value=2.100000000000000e+01}', "");
    Expect(0, 12882, '\P{^Numeric_Value=2.100000000000000e+01}', "");
    Error('\p{Nv= +0_0_0_0_0_0_021/a/}');
    Error('\P{Nv= +0_0_0_0_0_0_021/a/}');
    Expect(1, 12881, '\p{Nv=:\A21\z:}', "");;
    Expect(0, 12882, '\p{Nv=:\A21\z:}', "");;
    Expect(1, 12881, '\p{Nv:	+21}', "");
    Expect(0, 12881, '\p{^Nv:	+21}', "");
    Expect(0, 12881, '\P{Nv:	+21}', "");
    Expect(1, 12881, '\P{^Nv:	+21}', "");
    Expect(0, 12882, '\p{Nv:	+21}', "");
    Expect(1, 12882, '\p{^Nv:	+21}', "");
    Expect(1, 12882, '\P{Nv:	+21}', "");
    Expect(0, 12882, '\P{^Nv:	+21}', "");
    Expect(1, 12881, '\p{Nv=2.100000000000000e+01}', "");
    Expect(0, 12881, '\p{^Nv=2.100000000000000e+01}', "");
    Expect(0, 12881, '\P{Nv=2.100000000000000e+01}', "");
    Expect(1, 12881, '\P{^Nv=2.100000000000000e+01}', "");
    Expect(0, 12882, '\p{Nv=2.100000000000000e+01}', "");
    Expect(1, 12882, '\p{^Nv=2.100000000000000e+01}', "");
    Expect(1, 12882, '\P{Nv=2.100000000000000e+01}', "");
    Expect(0, 12882, '\P{^Nv=2.100000000000000e+01}', "");
    Error('\p{Is_Numeric_Value=-/a/+0000000021}');
    Error('\P{Is_Numeric_Value=-/a/+0000000021}');
    Expect(1, 12881, '\p{Is_Numeric_Value=0000021}', "");
    Expect(0, 12881, '\p{^Is_Numeric_Value=0000021}', "");
    Expect(0, 12881, '\P{Is_Numeric_Value=0000021}', "");
    Expect(1, 12881, '\P{^Is_Numeric_Value=0000021}', "");
    Expect(0, 12882, '\p{Is_Numeric_Value=0000021}', "");
    Expect(1, 12882, '\p{^Is_Numeric_Value=0000021}', "");
    Expect(1, 12882, '\P{Is_Numeric_Value=0000021}', "");
    Expect(0, 12882, '\P{^Is_Numeric_Value=0000021}', "");
    Expect(1, 12881, '\p{Is_Numeric_Value=2.100000000000000e+01}', "");
    Expect(0, 12881, '\p{^Is_Numeric_Value=2.100000000000000e+01}', "");
    Expect(0, 12881, '\P{Is_Numeric_Value=2.100000000000000e+01}', "");
    Expect(1, 12881, '\P{^Is_Numeric_Value=2.100000000000000e+01}', "");
    Expect(0, 12882, '\p{Is_Numeric_Value=2.100000000000000e+01}', "");
    Expect(1, 12882, '\p{^Is_Numeric_Value=2.100000000000000e+01}', "");
    Expect(1, 12882, '\P{Is_Numeric_Value=2.100000000000000e+01}', "");
    Expect(0, 12882, '\P{^Is_Numeric_Value=2.100000000000000e+01}', "");
    Error('\p{Is_Nv:	 /a/+00_00_00_21}');
    Error('\P{Is_Nv:	 /a/+00_00_00_21}');
    Expect(1, 12881, '\p{Is_Nv=002_1}', "");
    Expect(0, 12881, '\p{^Is_Nv=002_1}', "");
    Expect(0, 12881, '\P{Is_Nv=002_1}', "");
    Expect(1, 12881, '\P{^Is_Nv=002_1}', "");
    Expect(0, 12882, '\p{Is_Nv=002_1}', "");
    Expect(1, 12882, '\p{^Is_Nv=002_1}', "");
    Expect(1, 12882, '\P{Is_Nv=002_1}', "");
    Expect(0, 12882, '\P{^Is_Nv=002_1}', "");
    Expect(1, 12881, '\p{Is_Nv=2.100000000000000e+01}', "");
    Expect(0, 12881, '\p{^Is_Nv=2.100000000000000e+01}', "");
    Expect(0, 12881, '\P{Is_Nv=2.100000000000000e+01}', "");
    Expect(1, 12881, '\P{^Is_Nv=2.100000000000000e+01}', "");
    Expect(0, 12882, '\p{Is_Nv=2.100000000000000e+01}', "");
    Expect(1, 12882, '\p{^Is_Nv=2.100000000000000e+01}', "");
    Expect(1, 12882, '\P{Is_Nv=2.100000000000000e+01}', "");
    Expect(0, 12882, '\P{^Is_Nv=2.100000000000000e+01}', "");
    Error('\p{Numeric_Value=:=-+0021600_0}');
    Error('\P{Numeric_Value=:=-+0021600_0}');
    Expect(1, 74802, '\p{Numeric_Value=:\A216000\z:}', "");;
    Expect(0, 74803, '\p{Numeric_Value=:\A216000\z:}', "");;
    Expect(1, 74802, '\p{Numeric_Value=216000}', "");
    Expect(0, 74802, '\p{^Numeric_Value=216000}', "");
    Expect(0, 74802, '\P{Numeric_Value=216000}', "");
    Expect(1, 74802, '\P{^Numeric_Value=216000}', "");
    Expect(0, 74803, '\p{Numeric_Value=216000}', "");
    Expect(1, 74803, '\p{^Numeric_Value=216000}', "");
    Expect(1, 74803, '\P{Numeric_Value=216000}', "");
    Expect(0, 74803, '\P{^Numeric_Value=216000}', "");
    Expect(1, 74802, '\p{Numeric_Value=2.160000000000000e+05}', "");
    Expect(0, 74802, '\p{^Numeric_Value=2.160000000000000e+05}', "");
    Expect(0, 74802, '\P{Numeric_Value=2.160000000000000e+05}', "");
    Expect(1, 74802, '\P{^Numeric_Value=2.160000000000000e+05}', "");
    Expect(0, 74803, '\p{Numeric_Value=2.160000000000000e+05}', "");
    Expect(1, 74803, '\p{^Numeric_Value=2.160000000000000e+05}', "");
    Expect(1, 74803, '\P{Numeric_Value=2.160000000000000e+05}', "");
    Expect(0, 74803, '\P{^Numeric_Value=2.160000000000000e+05}', "");
    Error('\p{Nv=:= -000216000}');
    Error('\P{Nv=:= -000216000}');
    Expect(1, 74802, '\p{Nv=:\A216000\z:}', "");;
    Expect(0, 74803, '\p{Nv=:\A216000\z:}', "");;
    Expect(1, 74802, '\p{Nv=0216000}', "");
    Expect(0, 74802, '\p{^Nv=0216000}', "");
    Expect(0, 74802, '\P{Nv=0216000}', "");
    Expect(1, 74802, '\P{^Nv=0216000}', "");
    Expect(0, 74803, '\p{Nv=0216000}', "");
    Expect(1, 74803, '\p{^Nv=0216000}', "");
    Expect(1, 74803, '\P{Nv=0216000}', "");
    Expect(0, 74803, '\P{^Nv=0216000}', "");
    Expect(1, 74802, '\p{Nv=2.160000000000000e+05}', "");
    Expect(0, 74802, '\p{^Nv=2.160000000000000e+05}', "");
    Expect(0, 74802, '\P{Nv=2.160000000000000e+05}', "");
    Expect(1, 74802, '\P{^Nv=2.160000000000000e+05}', "");
    Expect(0, 74803, '\p{Nv=2.160000000000000e+05}', "");
    Expect(1, 74803, '\p{^Nv=2.160000000000000e+05}', "");
    Expect(1, 74803, '\P{Nv=2.160000000000000e+05}', "");
    Expect(0, 74803, '\P{^Nv=2.160000000000000e+05}', "");
    Error('\p{Is_Numeric_Value=	/a/00000_02160_00}');
    Error('\P{Is_Numeric_Value=	/a/00000_02160_00}');
    Expect(1, 74802, '\p{Is_Numeric_Value=000000_002160_00}', "");
    Expect(0, 74802, '\p{^Is_Numeric_Value=000000_002160_00}', "");
    Expect(0, 74802, '\P{Is_Numeric_Value=000000_002160_00}', "");
    Expect(1, 74802, '\P{^Is_Numeric_Value=000000_002160_00}', "");
    Expect(0, 74803, '\p{Is_Numeric_Value=000000_002160_00}', "");
    Expect(1, 74803, '\p{^Is_Numeric_Value=000000_002160_00}', "");
    Expect(1, 74803, '\P{Is_Numeric_Value=000000_002160_00}', "");
    Expect(0, 74803, '\P{^Is_Numeric_Value=000000_002160_00}', "");
    Expect(1, 74802, '\p{Is_Numeric_Value=2.160000000000000e+05}', "");
    Expect(0, 74802, '\p{^Is_Numeric_Value=2.160000000000000e+05}', "");
    Expect(0, 74802, '\P{Is_Numeric_Value=2.160000000000000e+05}', "");
    Expect(1, 74802, '\P{^Is_Numeric_Value=2.160000000000000e+05}', "");
    Expect(0, 74803, '\p{Is_Numeric_Value=2.160000000000000e+05}', "");
    Expect(1, 74803, '\p{^Is_Numeric_Value=2.160000000000000e+05}', "");
    Expect(1, 74803, '\P{Is_Numeric_Value=2.160000000000000e+05}', "");
    Expect(0, 74803, '\P{^Is_Numeric_Value=2.160000000000000e+05}', "");
    Error('\p{Is_Nv=_0021600_0/a/}');
    Error('\P{Is_Nv=_0021600_0/a/}');
    Expect(1, 74802, '\p{Is_Nv: +0_0_0_0_2_1_6_000}', "");
    Expect(0, 74802, '\p{^Is_Nv: +0_0_0_0_2_1_6_000}', "");
    Expect(0, 74802, '\P{Is_Nv: +0_0_0_0_2_1_6_000}', "");
    Expect(1, 74802, '\P{^Is_Nv: +0_0_0_0_2_1_6_000}', "");
    Expect(0, 74803, '\p{Is_Nv: +0_0_0_0_2_1_6_000}', "");
    Expect(1, 74803, '\p{^Is_Nv: +0_0_0_0_2_1_6_000}', "");
    Expect(1, 74803, '\P{Is_Nv: +0_0_0_0_2_1_6_000}', "");
    Expect(0, 74803, '\P{^Is_Nv: +0_0_0_0_2_1_6_000}', "");
    Expect(1, 74802, '\p{Is_Nv=2.160000000000000e+05}', "");
    Expect(0, 74802, '\p{^Is_Nv=2.160000000000000e+05}', "");
    Expect(0, 74802, '\P{Is_Nv=2.160000000000000e+05}', "");
    Expect(1, 74802, '\P{^Is_Nv=2.160000000000000e+05}', "");
    Expect(0, 74803, '\p{Is_Nv=2.160000000000000e+05}', "");
    Expect(1, 74803, '\p{^Is_Nv=2.160000000000000e+05}', "");
    Expect(1, 74803, '\P{Is_Nv=2.160000000000000e+05}', "");
    Expect(0, 74803, '\P{^Is_Nv=2.160000000000000e+05}', "");
    Error('\p{Numeric_Value=:= 	0000000022}');
    Error('\P{Numeric_Value=:= 	0000000022}');
    Expect(1, 12882, '\p{Numeric_Value=:\A22\z:}', "");;
    Expect(0, 12883, '\p{Numeric_Value=:\A22\z:}', "");;
    Expect(1, 12882, '\p{Numeric_Value:	22}', "");
    Expect(0, 12882, '\p{^Numeric_Value:	22}', "");
    Expect(0, 12882, '\P{Numeric_Value:	22}', "");
    Expect(1, 12882, '\P{^Numeric_Value:	22}', "");
    Expect(0, 12883, '\p{Numeric_Value:	22}', "");
    Expect(1, 12883, '\p{^Numeric_Value:	22}', "");
    Expect(1, 12883, '\P{Numeric_Value:	22}', "");
    Expect(0, 12883, '\P{^Numeric_Value:	22}', "");
    Expect(1, 12882, '\p{Numeric_Value=2.200000000000000e+01}', "");
    Expect(0, 12882, '\p{^Numeric_Value=2.200000000000000e+01}', "");
    Expect(0, 12882, '\P{Numeric_Value=2.200000000000000e+01}', "");
    Expect(1, 12882, '\P{^Numeric_Value=2.200000000000000e+01}', "");
    Expect(0, 12883, '\p{Numeric_Value=2.200000000000000e+01}', "");
    Expect(1, 12883, '\p{^Numeric_Value=2.200000000000000e+01}', "");
    Expect(1, 12883, '\P{Numeric_Value=2.200000000000000e+01}', "");
    Expect(0, 12883, '\P{^Numeric_Value=2.200000000000000e+01}', "");
    Error('\p{Nv= -00022:=}');
    Error('\P{Nv= -00022:=}');
    Expect(1, 12882, '\p{Nv=:\A22\z:}', "");;
    Expect(0, 12883, '\p{Nv=:\A22\z:}', "");;
    Expect(1, 12882, '\p{Nv=+0_0_0_0_22}', "");
    Expect(0, 12882, '\p{^Nv=+0_0_0_0_22}', "");
    Expect(0, 12882, '\P{Nv=+0_0_0_0_22}', "");
    Expect(1, 12882, '\P{^Nv=+0_0_0_0_22}', "");
    Expect(0, 12883, '\p{Nv=+0_0_0_0_22}', "");
    Expect(1, 12883, '\p{^Nv=+0_0_0_0_22}', "");
    Expect(1, 12883, '\P{Nv=+0_0_0_0_22}', "");
    Expect(0, 12883, '\P{^Nv=+0_0_0_0_22}', "");
    Expect(1, 12882, '\p{Nv=2.200000000000000e+01}', "");
    Expect(0, 12882, '\p{^Nv=2.200000000000000e+01}', "");
    Expect(0, 12882, '\P{Nv=2.200000000000000e+01}', "");
    Expect(1, 12882, '\P{^Nv=2.200000000000000e+01}', "");
    Expect(0, 12883, '\p{Nv=2.200000000000000e+01}', "");
    Expect(1, 12883, '\p{^Nv=2.200000000000000e+01}', "");
    Expect(1, 12883, '\P{Nv=2.200000000000000e+01}', "");
    Expect(0, 12883, '\P{^Nv=2.200000000000000e+01}', "");
    Error('\p{Is_Numeric_Value=:=_+2_2}');
    Error('\P{Is_Numeric_Value=:=_+2_2}');
    Expect(1, 12882, '\p{Is_Numeric_Value=+00000000022}', "");
    Expect(0, 12882, '\p{^Is_Numeric_Value=+00000000022}', "");
    Expect(0, 12882, '\P{Is_Numeric_Value=+00000000022}', "");
    Expect(1, 12882, '\P{^Is_Numeric_Value=+00000000022}', "");
    Expect(0, 12883, '\p{Is_Numeric_Value=+00000000022}', "");
    Expect(1, 12883, '\p{^Is_Numeric_Value=+00000000022}', "");
    Expect(1, 12883, '\P{Is_Numeric_Value=+00000000022}', "");
    Expect(0, 12883, '\P{^Is_Numeric_Value=+00000000022}', "");
    Expect(1, 12882, '\p{Is_Numeric_Value=2.200000000000000e+01}', "");
    Expect(0, 12882, '\p{^Is_Numeric_Value=2.200000000000000e+01}', "");
    Expect(0, 12882, '\P{Is_Numeric_Value=2.200000000000000e+01}', "");
    Expect(1, 12882, '\P{^Is_Numeric_Value=2.200000000000000e+01}', "");
    Expect(0, 12883, '\p{Is_Numeric_Value=2.200000000000000e+01}', "");
    Expect(1, 12883, '\p{^Is_Numeric_Value=2.200000000000000e+01}', "");
    Expect(1, 12883, '\P{Is_Numeric_Value=2.200000000000000e+01}', "");
    Expect(0, 12883, '\P{^Is_Numeric_Value=2.200000000000000e+01}', "");
    Error('\p{Is_Nv=-:=+0000000022}');
    Error('\P{Is_Nv=-:=+0000000022}');
    Expect(1, 12882, '\p{Is_Nv: +0000022}', "");
    Expect(0, 12882, '\p{^Is_Nv: +0000022}', "");
    Expect(0, 12882, '\P{Is_Nv: +0000022}', "");
    Expect(1, 12882, '\P{^Is_Nv: +0000022}', "");
    Expect(0, 12883, '\p{Is_Nv: +0000022}', "");
    Expect(1, 12883, '\p{^Is_Nv: +0000022}', "");
    Expect(1, 12883, '\P{Is_Nv: +0000022}', "");
    Expect(0, 12883, '\P{^Is_Nv: +0000022}', "");
    Expect(1, 12882, '\p{Is_Nv=2.200000000000000e+01}', "");
    Expect(0, 12882, '\p{^Is_Nv=2.200000000000000e+01}', "");
    Expect(0, 12882, '\P{Is_Nv=2.200000000000000e+01}', "");
    Expect(1, 12882, '\P{^Is_Nv=2.200000000000000e+01}', "");
    Expect(0, 12883, '\p{Is_Nv=2.200000000000000e+01}', "");
    Expect(1, 12883, '\p{^Is_Nv=2.200000000000000e+01}', "");
    Expect(1, 12883, '\P{Is_Nv=2.200000000000000e+01}', "");
    Expect(0, 12883, '\P{^Is_Nv=2.200000000000000e+01}', "");
    Error('\p{Numeric_Value=-/a/+0_0_0_0_0_0_0_023}');
    Error('\P{Numeric_Value=-/a/+0_0_0_0_0_0_0_023}');
    Expect(1, 12883, '\p{Numeric_Value=:\A23\z:}', "");;
    Expect(0, 12884, '\p{Numeric_Value=:\A23\z:}', "");;
    Expect(1, 12883, '\p{Numeric_Value=2_3}', "");
    Expect(0, 12883, '\p{^Numeric_Value=2_3}', "");
    Expect(0, 12883, '\P{Numeric_Value=2_3}', "");
    Expect(1, 12883, '\P{^Numeric_Value=2_3}', "");
    Expect(0, 12884, '\p{Numeric_Value=2_3}', "");
    Expect(1, 12884, '\p{^Numeric_Value=2_3}', "");
    Expect(1, 12884, '\P{Numeric_Value=2_3}', "");
    Expect(0, 12884, '\P{^Numeric_Value=2_3}', "");
    Expect(1, 12883, '\p{Numeric_Value=2.300000000000000e+01}', "");
    Expect(0, 12883, '\p{^Numeric_Value=2.300000000000000e+01}', "");
    Expect(0, 12883, '\P{Numeric_Value=2.300000000000000e+01}', "");
    Expect(1, 12883, '\P{^Numeric_Value=2.300000000000000e+01}', "");
    Expect(0, 12884, '\p{Numeric_Value=2.300000000000000e+01}', "");
    Expect(1, 12884, '\p{^Numeric_Value=2.300000000000000e+01}', "");
    Expect(1, 12884, '\P{Numeric_Value=2.300000000000000e+01}', "");
    Expect(0, 12884, '\P{^Numeric_Value=2.300000000000000e+01}', "");
    Error('\p{Nv=:=+00023}');
    Error('\P{Nv=:=+00023}');
    Expect(1, 12883, '\p{Nv=:\A23\z:}', "");;
    Expect(0, 12884, '\p{Nv=:\A23\z:}', "");;
    Expect(1, 12883, '\p{Nv=02_3}', "");
    Expect(0, 12883, '\p{^Nv=02_3}', "");
    Expect(0, 12883, '\P{Nv=02_3}', "");
    Expect(1, 12883, '\P{^Nv=02_3}', "");
    Expect(0, 12884, '\p{Nv=02_3}', "");
    Expect(1, 12884, '\p{^Nv=02_3}', "");
    Expect(1, 12884, '\P{Nv=02_3}', "");
    Expect(0, 12884, '\P{^Nv=02_3}', "");
    Expect(1, 12883, '\p{Nv:2.300000000000000e+01}', "");
    Expect(0, 12883, '\p{^Nv:2.300000000000000e+01}', "");
    Expect(0, 12883, '\P{Nv:2.300000000000000e+01}', "");
    Expect(1, 12883, '\P{^Nv:2.300000000000000e+01}', "");
    Expect(0, 12884, '\p{Nv:2.300000000000000e+01}', "");
    Expect(1, 12884, '\p{^Nv:2.300000000000000e+01}', "");
    Expect(1, 12884, '\P{Nv:2.300000000000000e+01}', "");
    Expect(0, 12884, '\P{^Nv:2.300000000000000e+01}', "");
    Error('\p{Is_Numeric_Value=	:=2_3}');
    Error('\P{Is_Numeric_Value=	:=2_3}');
    Expect(1, 12883, '\p{Is_Numeric_Value=002_3}', "");
    Expect(0, 12883, '\p{^Is_Numeric_Value=002_3}', "");
    Expect(0, 12883, '\P{Is_Numeric_Value=002_3}', "");
    Expect(1, 12883, '\P{^Is_Numeric_Value=002_3}', "");
    Expect(0, 12884, '\p{Is_Numeric_Value=002_3}', "");
    Expect(1, 12884, '\p{^Is_Numeric_Value=002_3}', "");
    Expect(1, 12884, '\P{Is_Numeric_Value=002_3}', "");
    Expect(0, 12884, '\P{^Is_Numeric_Value=002_3}', "");
    Expect(1, 12883, '\p{Is_Numeric_Value=2.300000000000000e+01}', "");
    Expect(0, 12883, '\p{^Is_Numeric_Value=2.300000000000000e+01}', "");
    Expect(0, 12883, '\P{Is_Numeric_Value=2.300000000000000e+01}', "");
    Expect(1, 12883, '\P{^Is_Numeric_Value=2.300000000000000e+01}', "");
    Expect(0, 12884, '\p{Is_Numeric_Value=2.300000000000000e+01}', "");
    Expect(1, 12884, '\p{^Is_Numeric_Value=2.300000000000000e+01}', "");
    Expect(1, 12884, '\P{Is_Numeric_Value=2.300000000000000e+01}', "");
    Expect(0, 12884, '\P{^Is_Numeric_Value=2.300000000000000e+01}', "");
    Error('\p{Is_Nv=:=-023}');
    Error('\P{Is_Nv=:=-023}');
    Expect(1, 12883, '\p{Is_Nv=2_3}', "");
    Expect(0, 12883, '\p{^Is_Nv=2_3}', "");
    Expect(0, 12883, '\P{Is_Nv=2_3}', "");
    Expect(1, 12883, '\P{^Is_Nv=2_3}', "");
    Expect(0, 12884, '\p{Is_Nv=2_3}', "");
    Expect(1, 12884, '\p{^Is_Nv=2_3}', "");
    Expect(1, 12884, '\P{Is_Nv=2_3}', "");
    Expect(0, 12884, '\P{^Is_Nv=2_3}', "");
    Expect(1, 12883, '\p{Is_Nv=2.300000000000000e+01}', "");
    Expect(0, 12883, '\p{^Is_Nv=2.300000000000000e+01}', "");
    Expect(0, 12883, '\P{Is_Nv=2.300000000000000e+01}', "");
    Expect(1, 12883, '\P{^Is_Nv=2.300000000000000e+01}', "");
    Expect(0, 12884, '\p{Is_Nv=2.300000000000000e+01}', "");
    Expect(1, 12884, '\p{^Is_Nv=2.300000000000000e+01}', "");
    Expect(1, 12884, '\P{Is_Nv=2.300000000000000e+01}', "");
    Expect(0, 12884, '\P{^Is_Nv=2.300000000000000e+01}', "");
    Error('\p{Numeric_Value:		_2_4:=}');
    Error('\P{Numeric_Value:		_2_4:=}');
    Expect(1, 12884, '\p{Numeric_Value=:\A24\z:}', "");;
    Expect(0, 12885, '\p{Numeric_Value=:\A24\z:}', "");;
    Expect(1, 12884, '\p{Numeric_Value:   +000024}', "");
    Expect(0, 12884, '\p{^Numeric_Value:   +000024}', "");
    Expect(0, 12884, '\P{Numeric_Value:   +000024}', "");
    Expect(1, 12884, '\P{^Numeric_Value:   +000024}', "");
    Expect(0, 12885, '\p{Numeric_Value:   +000024}', "");
    Expect(1, 12885, '\p{^Numeric_Value:   +000024}', "");
    Expect(1, 12885, '\P{Numeric_Value:   +000024}', "");
    Expect(0, 12885, '\P{^Numeric_Value:   +000024}', "");
    Expect(1, 12884, '\p{Numeric_Value=2.400000000000000e+01}', "");
    Expect(0, 12884, '\p{^Numeric_Value=2.400000000000000e+01}', "");
    Expect(0, 12884, '\P{Numeric_Value=2.400000000000000e+01}', "");
    Expect(1, 12884, '\P{^Numeric_Value=2.400000000000000e+01}', "");
    Expect(0, 12885, '\p{Numeric_Value=2.400000000000000e+01}', "");
    Expect(1, 12885, '\p{^Numeric_Value=2.400000000000000e+01}', "");
    Expect(1, 12885, '\P{Numeric_Value=2.400000000000000e+01}', "");
    Expect(0, 12885, '\P{^Numeric_Value=2.400000000000000e+01}', "");
    Error('\p{Nv=--0000000024:=}');
    Error('\P{Nv=--0000000024:=}');
    Expect(1, 12884, '\p{Nv=:\A24\z:}', "");;
    Expect(0, 12885, '\p{Nv=:\A24\z:}', "");;
    Expect(1, 12884, '\p{Nv=2_4}', "");
    Expect(0, 12884, '\p{^Nv=2_4}', "");
    Expect(0, 12884, '\P{Nv=2_4}', "");
    Expect(1, 12884, '\P{^Nv=2_4}', "");
    Expect(0, 12885, '\p{Nv=2_4}', "");
    Expect(1, 12885, '\p{^Nv=2_4}', "");
    Expect(1, 12885, '\P{Nv=2_4}', "");
    Expect(0, 12885, '\P{^Nv=2_4}', "");
    Expect(1, 12884, '\p{Nv=2.400000000000000e+01}', "");
    Expect(0, 12884, '\p{^Nv=2.400000000000000e+01}', "");
    Expect(0, 12884, '\P{Nv=2.400000000000000e+01}', "");
    Expect(1, 12884, '\P{^Nv=2.400000000000000e+01}', "");
    Expect(0, 12885, '\p{Nv=2.400000000000000e+01}', "");
    Expect(1, 12885, '\p{^Nv=2.400000000000000e+01}', "");
    Expect(1, 12885, '\P{Nv=2.400000000000000e+01}', "");
    Expect(0, 12885, '\P{^Nv=2.400000000000000e+01}', "");
    Error('\p{Is_Numeric_Value=	/a/+0000024}');
    Error('\P{Is_Numeric_Value=	/a/+0000024}');
    Expect(1, 12884, '\p{Is_Numeric_Value=+2_4}', "");
    Expect(0, 12884, '\p{^Is_Numeric_Value=+2_4}', "");
    Expect(0, 12884, '\P{Is_Numeric_Value=+2_4}', "");
    Expect(1, 12884, '\P{^Is_Numeric_Value=+2_4}', "");
    Expect(0, 12885, '\p{Is_Numeric_Value=+2_4}', "");
    Expect(1, 12885, '\p{^Is_Numeric_Value=+2_4}', "");
    Expect(1, 12885, '\P{Is_Numeric_Value=+2_4}', "");
    Expect(0, 12885, '\P{^Is_Numeric_Value=+2_4}', "");
    Expect(1, 12884, '\p{Is_Numeric_Value=2.400000000000000e+01}', "");
    Expect(0, 12884, '\p{^Is_Numeric_Value=2.400000000000000e+01}', "");
    Expect(0, 12884, '\P{Is_Numeric_Value=2.400000000000000e+01}', "");
    Expect(1, 12884, '\P{^Is_Numeric_Value=2.400000000000000e+01}', "");
    Expect(0, 12885, '\p{Is_Numeric_Value=2.400000000000000e+01}', "");
    Expect(1, 12885, '\p{^Is_Numeric_Value=2.400000000000000e+01}', "");
    Expect(1, 12885, '\P{Is_Numeric_Value=2.400000000000000e+01}', "");
    Expect(0, 12885, '\P{^Is_Numeric_Value=2.400000000000000e+01}', "");
    Error('\p{Is_Nv=:=	_+00000000024}');
    Error('\P{Is_Nv=:=	_+00000000024}');
    Expect(1, 12884, '\p{Is_Nv=00002_4}', "");
    Expect(0, 12884, '\p{^Is_Nv=00002_4}', "");
    Expect(0, 12884, '\P{Is_Nv=00002_4}', "");
    Expect(1, 12884, '\P{^Is_Nv=00002_4}', "");
    Expect(0, 12885, '\p{Is_Nv=00002_4}', "");
    Expect(1, 12885, '\p{^Is_Nv=00002_4}', "");
    Expect(1, 12885, '\P{Is_Nv=00002_4}', "");
    Expect(0, 12885, '\P{^Is_Nv=00002_4}', "");
    Expect(1, 12884, '\p{Is_Nv=2.400000000000000e+01}', "");
    Expect(0, 12884, '\p{^Is_Nv=2.400000000000000e+01}', "");
    Expect(0, 12884, '\P{Is_Nv=2.400000000000000e+01}', "");
    Expect(1, 12884, '\P{^Is_Nv=2.400000000000000e+01}', "");
    Expect(0, 12885, '\p{Is_Nv=2.400000000000000e+01}', "");
    Expect(1, 12885, '\p{^Is_Nv=2.400000000000000e+01}', "");
    Expect(1, 12885, '\P{Is_Nv=2.400000000000000e+01}', "");
    Expect(0, 12885, '\P{^Is_Nv=2.400000000000000e+01}', "");
    Error('\p{Numeric_Value=:=		0000_0002_5}');
    Error('\P{Numeric_Value=:=		0000_0002_5}');
    Expect(1, 12885, '\p{Numeric_Value=:\A25\z:}', "");;
    Expect(0, 12886, '\p{Numeric_Value=:\A25\z:}', "");;
    Expect(1, 12885, '\p{Numeric_Value: 00025}', "");
    Expect(0, 12885, '\p{^Numeric_Value: 00025}', "");
    Expect(0, 12885, '\P{Numeric_Value: 00025}', "");
    Expect(1, 12885, '\P{^Numeric_Value: 00025}', "");
    Expect(0, 12886, '\p{Numeric_Value: 00025}', "");
    Expect(1, 12886, '\p{^Numeric_Value: 00025}', "");
    Expect(1, 12886, '\P{Numeric_Value: 00025}', "");
    Expect(0, 12886, '\P{^Numeric_Value: 00025}', "");
    Expect(1, 12885, '\p{Numeric_Value=2.500000000000000e+01}', "");
    Expect(0, 12885, '\p{^Numeric_Value=2.500000000000000e+01}', "");
    Expect(0, 12885, '\P{Numeric_Value=2.500000000000000e+01}', "");
    Expect(1, 12885, '\P{^Numeric_Value=2.500000000000000e+01}', "");
    Expect(0, 12886, '\p{Numeric_Value=2.500000000000000e+01}', "");
    Expect(1, 12886, '\p{^Numeric_Value=2.500000000000000e+01}', "");
    Expect(1, 12886, '\P{Numeric_Value=2.500000000000000e+01}', "");
    Expect(0, 12886, '\P{^Numeric_Value=2.500000000000000e+01}', "");
    Error('\p{Nv=/a/	+0_0_0_0_0025}');
    Error('\P{Nv=/a/	+0_0_0_0_0025}');
    Expect(1, 12885, '\p{Nv=:\A25\z:}', "");;
    Expect(0, 12886, '\p{Nv=:\A25\z:}', "");;
    Expect(1, 12885, '\p{Nv=+0025}', "");
    Expect(0, 12885, '\p{^Nv=+0025}', "");
    Expect(0, 12885, '\P{Nv=+0025}', "");
    Expect(1, 12885, '\P{^Nv=+0025}', "");
    Expect(0, 12886, '\p{Nv=+0025}', "");
    Expect(1, 12886, '\p{^Nv=+0025}', "");
    Expect(1, 12886, '\P{Nv=+0025}', "");
    Expect(0, 12886, '\P{^Nv=+0025}', "");
    Expect(1, 12885, '\p{Nv=2.500000000000000e+01}', "");
    Expect(0, 12885, '\p{^Nv=2.500000000000000e+01}', "");
    Expect(0, 12885, '\P{Nv=2.500000000000000e+01}', "");
    Expect(1, 12885, '\P{^Nv=2.500000000000000e+01}', "");
    Expect(0, 12886, '\p{Nv=2.500000000000000e+01}', "");
    Expect(1, 12886, '\p{^Nv=2.500000000000000e+01}', "");
    Expect(1, 12886, '\P{Nv=2.500000000000000e+01}', "");
    Expect(0, 12886, '\P{^Nv=2.500000000000000e+01}', "");
    Error('\p{Is_Numeric_Value: :=  000000025}');
    Error('\P{Is_Numeric_Value: :=  000000025}');
    Expect(1, 12885, '\p{Is_Numeric_Value=+0002_5}', "");
    Expect(0, 12885, '\p{^Is_Numeric_Value=+0002_5}', "");
    Expect(0, 12885, '\P{Is_Numeric_Value=+0002_5}', "");
    Expect(1, 12885, '\P{^Is_Numeric_Value=+0002_5}', "");
    Expect(0, 12886, '\p{Is_Numeric_Value=+0002_5}', "");
    Expect(1, 12886, '\p{^Is_Numeric_Value=+0002_5}', "");
    Expect(1, 12886, '\P{Is_Numeric_Value=+0002_5}', "");
    Expect(0, 12886, '\P{^Is_Numeric_Value=+0002_5}', "");
    Expect(1, 12885, '\p{Is_Numeric_Value=2.500000000000000e+01}', "");
    Expect(0, 12885, '\p{^Is_Numeric_Value=2.500000000000000e+01}', "");
    Expect(0, 12885, '\P{Is_Numeric_Value=2.500000000000000e+01}', "");
    Expect(1, 12885, '\P{^Is_Numeric_Value=2.500000000000000e+01}', "");
    Expect(0, 12886, '\p{Is_Numeric_Value=2.500000000000000e+01}', "");
    Expect(1, 12886, '\p{^Is_Numeric_Value=2.500000000000000e+01}', "");
    Expect(1, 12886, '\P{Is_Numeric_Value=2.500000000000000e+01}', "");
    Expect(0, 12886, '\P{^Is_Numeric_Value=2.500000000000000e+01}', "");
    Error('\p{Is_Nv=/a/000000002_5}');
    Error('\P{Is_Nv=/a/000000002_5}');
    Expect(1, 12885, '\p{Is_Nv=00002_5}', "");
    Expect(0, 12885, '\p{^Is_Nv=00002_5}', "");
    Expect(0, 12885, '\P{Is_Nv=00002_5}', "");
    Expect(1, 12885, '\P{^Is_Nv=00002_5}', "");
    Expect(0, 12886, '\p{Is_Nv=00002_5}', "");
    Expect(1, 12886, '\p{^Is_Nv=00002_5}', "");
    Expect(1, 12886, '\P{Is_Nv=00002_5}', "");
    Expect(0, 12886, '\P{^Is_Nv=00002_5}', "");
    Expect(1, 12885, '\p{Is_Nv=2.500000000000000e+01}', "");
    Expect(0, 12885, '\p{^Is_Nv=2.500000000000000e+01}', "");
    Expect(0, 12885, '\P{Is_Nv=2.500000000000000e+01}', "");
    Expect(1, 12885, '\P{^Is_Nv=2.500000000000000e+01}', "");
    Expect(0, 12886, '\p{Is_Nv=2.500000000000000e+01}', "");
    Expect(1, 12886, '\p{^Is_Nv=2.500000000000000e+01}', "");
    Expect(1, 12886, '\P{Is_Nv=2.500000000000000e+01}', "");
    Expect(0, 12886, '\P{^Is_Nv=2.500000000000000e+01}', "");
    Error('\p{Numeric_Value=:=-	+026}');
    Error('\P{Numeric_Value=:=-	+026}');
    Expect(1, 12886, '\p{Numeric_Value=:\A26\z:}', "");;
    Expect(0, 12887, '\p{Numeric_Value=:\A26\z:}', "");;
    Expect(1, 12886, '\p{Numeric_Value=+2_6}', "");
    Expect(0, 12886, '\p{^Numeric_Value=+2_6}', "");
    Expect(0, 12886, '\P{Numeric_Value=+2_6}', "");
    Expect(1, 12886, '\P{^Numeric_Value=+2_6}', "");
    Expect(0, 12887, '\p{Numeric_Value=+2_6}', "");
    Expect(1, 12887, '\p{^Numeric_Value=+2_6}', "");
    Expect(1, 12887, '\P{Numeric_Value=+2_6}', "");
    Expect(0, 12887, '\P{^Numeric_Value=+2_6}', "");
    Expect(1, 12886, '\p{Numeric_Value=2.600000000000000e+01}', "");
    Expect(0, 12886, '\p{^Numeric_Value=2.600000000000000e+01}', "");
    Expect(0, 12886, '\P{Numeric_Value=2.600000000000000e+01}', "");
    Expect(1, 12886, '\P{^Numeric_Value=2.600000000000000e+01}', "");
    Expect(0, 12887, '\p{Numeric_Value=2.600000000000000e+01}', "");
    Expect(1, 12887, '\p{^Numeric_Value=2.600000000000000e+01}', "");
    Expect(1, 12887, '\P{Numeric_Value=2.600000000000000e+01}', "");
    Expect(0, 12887, '\P{^Numeric_Value=2.600000000000000e+01}', "");
    Error('\p{Nv=/a/	_+0002_6}');
    Error('\P{Nv=/a/	_+0002_6}');
    Expect(1, 12886, '\p{Nv=:\A26\z:}', "");;
    Expect(0, 12887, '\p{Nv=:\A26\z:}', "");;
    Expect(1, 12886, '\p{Nv:00_02_6}', "");
    Expect(0, 12886, '\p{^Nv:00_02_6}', "");
    Expect(0, 12886, '\P{Nv:00_02_6}', "");
    Expect(1, 12886, '\P{^Nv:00_02_6}', "");
    Expect(0, 12887, '\p{Nv:00_02_6}', "");
    Expect(1, 12887, '\p{^Nv:00_02_6}', "");
    Expect(1, 12887, '\P{Nv:00_02_6}', "");
    Expect(0, 12887, '\P{^Nv:00_02_6}', "");
    Expect(1, 12886, '\p{Nv=2.600000000000000e+01}', "");
    Expect(0, 12886, '\p{^Nv=2.600000000000000e+01}', "");
    Expect(0, 12886, '\P{Nv=2.600000000000000e+01}', "");
    Expect(1, 12886, '\P{^Nv=2.600000000000000e+01}', "");
    Expect(0, 12887, '\p{Nv=2.600000000000000e+01}', "");
    Expect(1, 12887, '\p{^Nv=2.600000000000000e+01}', "");
    Expect(1, 12887, '\P{Nv=2.600000000000000e+01}', "");
    Expect(0, 12887, '\P{^Nv=2.600000000000000e+01}', "");
    Error('\p{Is_Numeric_Value= /a/026}');
    Error('\P{Is_Numeric_Value= /a/026}');
    Expect(1, 12886, '\p{Is_Numeric_Value:   +0000000026}', "");
    Expect(0, 12886, '\p{^Is_Numeric_Value:   +0000000026}', "");
    Expect(0, 12886, '\P{Is_Numeric_Value:   +0000000026}', "");
    Expect(1, 12886, '\P{^Is_Numeric_Value:   +0000000026}', "");
    Expect(0, 12887, '\p{Is_Numeric_Value:   +0000000026}', "");
    Expect(1, 12887, '\p{^Is_Numeric_Value:   +0000000026}', "");
    Expect(1, 12887, '\P{Is_Numeric_Value:   +0000000026}', "");
    Expect(0, 12887, '\P{^Is_Numeric_Value:   +0000000026}', "");
    Expect(1, 12886, '\p{Is_Numeric_Value=2.600000000000000e+01}', "");
    Expect(0, 12886, '\p{^Is_Numeric_Value=2.600000000000000e+01}', "");
    Expect(0, 12886, '\P{Is_Numeric_Value=2.600000000000000e+01}', "");
    Expect(1, 12886, '\P{^Is_Numeric_Value=2.600000000000000e+01}', "");
    Expect(0, 12887, '\p{Is_Numeric_Value=2.600000000000000e+01}', "");
    Expect(1, 12887, '\p{^Is_Numeric_Value=2.600000000000000e+01}', "");
    Expect(1, 12887, '\P{Is_Numeric_Value=2.600000000000000e+01}', "");
    Expect(0, 12887, '\P{^Is_Numeric_Value=2.600000000000000e+01}', "");
    Error('\p{Is_Nv= /a/026}');
    Error('\P{Is_Nv= /a/026}');
    Expect(1, 12886, '\p{Is_Nv=00000000026}', "");
    Expect(0, 12886, '\p{^Is_Nv=00000000026}', "");
    Expect(0, 12886, '\P{Is_Nv=00000000026}', "");
    Expect(1, 12886, '\P{^Is_Nv=00000000026}', "");
    Expect(0, 12887, '\p{Is_Nv=00000000026}', "");
    Expect(1, 12887, '\p{^Is_Nv=00000000026}', "");
    Expect(1, 12887, '\P{Is_Nv=00000000026}', "");
    Expect(0, 12887, '\P{^Is_Nv=00000000026}', "");
    Expect(1, 12886, '\p{Is_Nv=2.600000000000000e+01}', "");
    Expect(0, 12886, '\p{^Is_Nv=2.600000000000000e+01}', "");
    Expect(0, 12886, '\P{Is_Nv=2.600000000000000e+01}', "");
    Expect(1, 12886, '\P{^Is_Nv=2.600000000000000e+01}', "");
    Expect(0, 12887, '\p{Is_Nv=2.600000000000000e+01}', "");
    Expect(1, 12887, '\p{^Is_Nv=2.600000000000000e+01}', "");
    Expect(1, 12887, '\P{Is_Nv=2.600000000000000e+01}', "");
    Expect(0, 12887, '\P{^Is_Nv=2.600000000000000e+01}', "");
    Error('\p{Numeric_Value=	0027/a/}');
    Error('\P{Numeric_Value=	0027/a/}');
    Expect(1, 12887, '\p{Numeric_Value=:\A27\z:}', "");;
    Expect(0, 12888, '\p{Numeric_Value=:\A27\z:}', "");;
    Expect(1, 12887, '\p{Numeric_Value=00000027}', "");
    Expect(0, 12887, '\p{^Numeric_Value=00000027}', "");
    Expect(0, 12887, '\P{Numeric_Value=00000027}', "");
    Expect(1, 12887, '\P{^Numeric_Value=00000027}', "");
    Expect(0, 12888, '\p{Numeric_Value=00000027}', "");
    Expect(1, 12888, '\p{^Numeric_Value=00000027}', "");
    Expect(1, 12888, '\P{Numeric_Value=00000027}', "");
    Expect(0, 12888, '\P{^Numeric_Value=00000027}', "");
    Expect(1, 12887, '\p{Numeric_Value=2.700000000000000e+01}', "");
    Expect(0, 12887, '\p{^Numeric_Value=2.700000000000000e+01}', "");
    Expect(0, 12887, '\P{Numeric_Value=2.700000000000000e+01}', "");
    Expect(1, 12887, '\P{^Numeric_Value=2.700000000000000e+01}', "");
    Expect(0, 12888, '\p{Numeric_Value=2.700000000000000e+01}', "");
    Expect(1, 12888, '\p{^Numeric_Value=2.700000000000000e+01}', "");
    Expect(1, 12888, '\P{Numeric_Value=2.700000000000000e+01}', "");
    Expect(0, 12888, '\P{^Numeric_Value=2.700000000000000e+01}', "");
    Error('\p{Nv=-00_00_27:=}');
    Error('\P{Nv=-00_00_27:=}');
    Expect(1, 12887, '\p{Nv=:\A27\z:}', "");;
    Expect(0, 12888, '\p{Nv=:\A27\z:}', "");;
    Expect(1, 12887, '\p{Nv=+0027}', "");
    Expect(0, 12887, '\p{^Nv=+0027}', "");
    Expect(0, 12887, '\P{Nv=+0027}', "");
    Expect(1, 12887, '\P{^Nv=+0027}', "");
    Expect(0, 12888, '\p{Nv=+0027}', "");
    Expect(1, 12888, '\p{^Nv=+0027}', "");
    Expect(1, 12888, '\P{Nv=+0027}', "");
    Expect(0, 12888, '\P{^Nv=+0027}', "");
    Expect(1, 12887, '\p{Nv=2.700000000000000e+01}', "");
    Expect(0, 12887, '\p{^Nv=2.700000000000000e+01}', "");
    Expect(0, 12887, '\P{Nv=2.700000000000000e+01}', "");
    Expect(1, 12887, '\P{^Nv=2.700000000000000e+01}', "");
    Expect(0, 12888, '\p{Nv=2.700000000000000e+01}', "");
    Expect(1, 12888, '\p{^Nv=2.700000000000000e+01}', "");
    Expect(1, 12888, '\P{Nv=2.700000000000000e+01}', "");
    Expect(0, 12888, '\P{^Nv=2.700000000000000e+01}', "");
    Error('\p{Is_Numeric_Value=-:=0000000027}');
    Error('\P{Is_Numeric_Value=-:=0000000027}');
    Expect(1, 12887, '\p{Is_Numeric_Value=0000000027}', "");
    Expect(0, 12887, '\p{^Is_Numeric_Value=0000000027}', "");
    Expect(0, 12887, '\P{Is_Numeric_Value=0000000027}', "");
    Expect(1, 12887, '\P{^Is_Numeric_Value=0000000027}', "");
    Expect(0, 12888, '\p{Is_Numeric_Value=0000000027}', "");
    Expect(1, 12888, '\p{^Is_Numeric_Value=0000000027}', "");
    Expect(1, 12888, '\P{Is_Numeric_Value=0000000027}', "");
    Expect(0, 12888, '\P{^Is_Numeric_Value=0000000027}', "");
    Expect(1, 12887, '\p{Is_Numeric_Value=2.700000000000000e+01}', "");
    Expect(0, 12887, '\p{^Is_Numeric_Value=2.700000000000000e+01}', "");
    Expect(0, 12887, '\P{Is_Numeric_Value=2.700000000000000e+01}', "");
    Expect(1, 12887, '\P{^Is_Numeric_Value=2.700000000000000e+01}', "");
    Expect(0, 12888, '\p{Is_Numeric_Value=2.700000000000000e+01}', "");
    Expect(1, 12888, '\p{^Is_Numeric_Value=2.700000000000000e+01}', "");
    Expect(1, 12888, '\P{Is_Numeric_Value=2.700000000000000e+01}', "");
    Expect(0, 12888, '\P{^Is_Numeric_Value=2.700000000000000e+01}', "");
    Error('\p{Is_Nv=		+02_7:=}');
    Error('\P{Is_Nv=		+02_7:=}');
    Expect(1, 12887, '\p{Is_Nv=+00000000027}', "");
    Expect(0, 12887, '\p{^Is_Nv=+00000000027}', "");
    Expect(0, 12887, '\P{Is_Nv=+00000000027}', "");
    Expect(1, 12887, '\P{^Is_Nv=+00000000027}', "");
    Expect(0, 12888, '\p{Is_Nv=+00000000027}', "");
    Expect(1, 12888, '\p{^Is_Nv=+00000000027}', "");
    Expect(1, 12888, '\P{Is_Nv=+00000000027}', "");
    Expect(0, 12888, '\P{^Is_Nv=+00000000027}', "");
    Expect(1, 12887, '\p{Is_Nv=2.700000000000000e+01}', "");
    Expect(0, 12887, '\p{^Is_Nv=2.700000000000000e+01}', "");
    Expect(0, 12887, '\P{Is_Nv=2.700000000000000e+01}', "");
    Expect(1, 12887, '\P{^Is_Nv=2.700000000000000e+01}', "");
    Expect(0, 12888, '\p{Is_Nv=2.700000000000000e+01}', "");
    Expect(1, 12888, '\p{^Is_Nv=2.700000000000000e+01}', "");
    Expect(1, 12888, '\P{Is_Nv=2.700000000000000e+01}', "");
    Expect(0, 12888, '\P{^Is_Nv=2.700000000000000e+01}', "");
    Error('\p{Numeric_Value:		0_0_0_028/a/}');
    Error('\P{Numeric_Value:		0_0_0_028/a/}');
    Expect(1, 12888, '\p{Numeric_Value=:\A28\z:}', "");;
    Expect(0, 12889, '\p{Numeric_Value=:\A28\z:}', "");;
    Expect(1, 12888, '\p{Numeric_Value=0_0_0_0_0_00028}', "");
    Expect(0, 12888, '\p{^Numeric_Value=0_0_0_0_0_00028}', "");
    Expect(0, 12888, '\P{Numeric_Value=0_0_0_0_0_00028}', "");
    Expect(1, 12888, '\P{^Numeric_Value=0_0_0_0_0_00028}', "");
    Expect(0, 12889, '\p{Numeric_Value=0_0_0_0_0_00028}', "");
    Expect(1, 12889, '\p{^Numeric_Value=0_0_0_0_0_00028}', "");
    Expect(1, 12889, '\P{Numeric_Value=0_0_0_0_0_00028}', "");
    Expect(0, 12889, '\P{^Numeric_Value=0_0_0_0_0_00028}', "");
    Expect(1, 12888, '\p{Numeric_Value=2.800000000000000e+01}', "");
    Expect(0, 12888, '\p{^Numeric_Value=2.800000000000000e+01}', "");
    Expect(0, 12888, '\P{Numeric_Value=2.800000000000000e+01}', "");
    Expect(1, 12888, '\P{^Numeric_Value=2.800000000000000e+01}', "");
    Expect(0, 12889, '\p{Numeric_Value=2.800000000000000e+01}', "");
    Expect(1, 12889, '\p{^Numeric_Value=2.800000000000000e+01}', "");
    Expect(1, 12889, '\P{Numeric_Value=2.800000000000000e+01}', "");
    Expect(0, 12889, '\P{^Numeric_Value=2.800000000000000e+01}', "");
    Error('\p{Nv:   -_2_8:=}');
    Error('\P{Nv:   -_2_8:=}');
    Expect(1, 12888, '\p{Nv=:\A28\z:}', "");;
    Expect(0, 12889, '\p{Nv=:\A28\z:}', "");;
    Expect(1, 12888, '\p{Nv=+0028}', "");
    Expect(0, 12888, '\p{^Nv=+0028}', "");
    Expect(0, 12888, '\P{Nv=+0028}', "");
    Expect(1, 12888, '\P{^Nv=+0028}', "");
    Expect(0, 12889, '\p{Nv=+0028}', "");
    Expect(1, 12889, '\p{^Nv=+0028}', "");
    Expect(1, 12889, '\P{Nv=+0028}', "");
    Expect(0, 12889, '\P{^Nv=+0028}', "");
    Expect(1, 12888, '\p{Nv=2.800000000000000e+01}', "");
    Expect(0, 12888, '\p{^Nv=2.800000000000000e+01}', "");
    Expect(0, 12888, '\P{Nv=2.800000000000000e+01}', "");
    Expect(1, 12888, '\P{^Nv=2.800000000000000e+01}', "");
    Expect(0, 12889, '\p{Nv=2.800000000000000e+01}', "");
    Expect(1, 12889, '\p{^Nv=2.800000000000000e+01}', "");
    Expect(1, 12889, '\P{Nv=2.800000000000000e+01}', "");
    Expect(0, 12889, '\P{^Nv=2.800000000000000e+01}', "");
    Error('\p{Is_Numeric_Value:		:=00_00_28}');
    Error('\P{Is_Numeric_Value:		:=00_00_28}');
    Expect(1, 12888, '\p{Is_Numeric_Value=+00_00_02_8}', "");
    Expect(0, 12888, '\p{^Is_Numeric_Value=+00_00_02_8}', "");
    Expect(0, 12888, '\P{Is_Numeric_Value=+00_00_02_8}', "");
    Expect(1, 12888, '\P{^Is_Numeric_Value=+00_00_02_8}', "");
    Expect(0, 12889, '\p{Is_Numeric_Value=+00_00_02_8}', "");
    Expect(1, 12889, '\p{^Is_Numeric_Value=+00_00_02_8}', "");
    Expect(1, 12889, '\P{Is_Numeric_Value=+00_00_02_8}', "");
    Expect(0, 12889, '\P{^Is_Numeric_Value=+00_00_02_8}', "");
    Expect(1, 12888, '\p{Is_Numeric_Value=2.800000000000000e+01}', "");
    Expect(0, 12888, '\p{^Is_Numeric_Value=2.800000000000000e+01}', "");
    Expect(0, 12888, '\P{Is_Numeric_Value=2.800000000000000e+01}', "");
    Expect(1, 12888, '\P{^Is_Numeric_Value=2.800000000000000e+01}', "");
    Expect(0, 12889, '\p{Is_Numeric_Value=2.800000000000000e+01}', "");
    Expect(1, 12889, '\p{^Is_Numeric_Value=2.800000000000000e+01}', "");
    Expect(1, 12889, '\P{Is_Numeric_Value=2.800000000000000e+01}', "");
    Expect(0, 12889, '\P{^Is_Numeric_Value=2.800000000000000e+01}', "");
    Error('\p{Is_Nv=:=_-+0028}');
    Error('\P{Is_Nv=:=_-+0028}');
    Expect(1, 12888, '\p{Is_Nv=02_8}', "");
    Expect(0, 12888, '\p{^Is_Nv=02_8}', "");
    Expect(0, 12888, '\P{Is_Nv=02_8}', "");
    Expect(1, 12888, '\P{^Is_Nv=02_8}', "");
    Expect(0, 12889, '\p{Is_Nv=02_8}', "");
    Expect(1, 12889, '\p{^Is_Nv=02_8}', "");
    Expect(1, 12889, '\P{Is_Nv=02_8}', "");
    Expect(0, 12889, '\P{^Is_Nv=02_8}', "");
    Expect(1, 12888, '\p{Is_Nv=2.800000000000000e+01}', "");
    Expect(0, 12888, '\p{^Is_Nv=2.800000000000000e+01}', "");
    Expect(0, 12888, '\P{Is_Nv=2.800000000000000e+01}', "");
    Expect(1, 12888, '\P{^Is_Nv=2.800000000000000e+01}', "");
    Expect(0, 12889, '\p{Is_Nv=2.800000000000000e+01}', "");
    Expect(1, 12889, '\p{^Is_Nv=2.800000000000000e+01}', "");
    Expect(1, 12889, '\P{Is_Nv=2.800000000000000e+01}', "");
    Expect(0, 12889, '\P{^Is_Nv=2.800000000000000e+01}', "");
    Error('\p{Numeric_Value=	0000000029:=}');
    Error('\P{Numeric_Value=	0000000029:=}');
    Expect(1, 12889, '\p{Numeric_Value=:\A29\z:}', "");;
    Expect(0, 12890, '\p{Numeric_Value=:\A29\z:}', "");;
    Expect(1, 12889, '\p{Numeric_Value=0_0_0_0_0_00029}', "");
    Expect(0, 12889, '\p{^Numeric_Value=0_0_0_0_0_00029}', "");
    Expect(0, 12889, '\P{Numeric_Value=0_0_0_0_0_00029}', "");
    Expect(1, 12889, '\P{^Numeric_Value=0_0_0_0_0_00029}', "");
    Expect(0, 12890, '\p{Numeric_Value=0_0_0_0_0_00029}', "");
    Expect(1, 12890, '\p{^Numeric_Value=0_0_0_0_0_00029}', "");
    Expect(1, 12890, '\P{Numeric_Value=0_0_0_0_0_00029}', "");
    Expect(0, 12890, '\P{^Numeric_Value=0_0_0_0_0_00029}', "");
    Expect(1, 12889, '\p{Numeric_Value=2.900000000000000e+01}', "");
    Expect(0, 12889, '\p{^Numeric_Value=2.900000000000000e+01}', "");
    Expect(0, 12889, '\P{Numeric_Value=2.900000000000000e+01}', "");
    Expect(1, 12889, '\P{^Numeric_Value=2.900000000000000e+01}', "");
    Expect(0, 12890, '\p{Numeric_Value=2.900000000000000e+01}', "");
    Expect(1, 12890, '\p{^Numeric_Value=2.900000000000000e+01}', "");
    Expect(1, 12890, '\P{Numeric_Value=2.900000000000000e+01}', "");
    Expect(0, 12890, '\P{^Numeric_Value=2.900000000000000e+01}', "");
    Error('\p{Nv:	 :=0000000029}');
    Error('\P{Nv:	 :=0000000029}');
    Expect(1, 12889, '\p{Nv=:\A29\z:}', "");;
    Expect(0, 12890, '\p{Nv=:\A29\z:}', "");;
    Expect(1, 12889, '\p{Nv=0_0_0_0_0_0_29}', "");
    Expect(0, 12889, '\p{^Nv=0_0_0_0_0_0_29}', "");
    Expect(0, 12889, '\P{Nv=0_0_0_0_0_0_29}', "");
    Expect(1, 12889, '\P{^Nv=0_0_0_0_0_0_29}', "");
    Expect(0, 12890, '\p{Nv=0_0_0_0_0_0_29}', "");
    Expect(1, 12890, '\p{^Nv=0_0_0_0_0_0_29}', "");
    Expect(1, 12890, '\P{Nv=0_0_0_0_0_0_29}', "");
    Expect(0, 12890, '\P{^Nv=0_0_0_0_0_0_29}', "");
    Expect(1, 12889, '\p{Nv=2.900000000000000e+01}', "");
    Expect(0, 12889, '\p{^Nv=2.900000000000000e+01}', "");
    Expect(0, 12889, '\P{Nv=2.900000000000000e+01}', "");
    Expect(1, 12889, '\P{^Nv=2.900000000000000e+01}', "");
    Expect(0, 12890, '\p{Nv=2.900000000000000e+01}', "");
    Expect(1, 12890, '\p{^Nv=2.900000000000000e+01}', "");
    Expect(1, 12890, '\P{Nv=2.900000000000000e+01}', "");
    Expect(0, 12890, '\P{^Nv=2.900000000000000e+01}', "");
    Error('\p{Is_Numeric_Value=	:=02_9}');
    Error('\P{Is_Numeric_Value=	:=02_9}');
    Expect(1, 12889, '\p{Is_Numeric_Value=029}', "");
    Expect(0, 12889, '\p{^Is_Numeric_Value=029}', "");
    Expect(0, 12889, '\P{Is_Numeric_Value=029}', "");
    Expect(1, 12889, '\P{^Is_Numeric_Value=029}', "");
    Expect(0, 12890, '\p{Is_Numeric_Value=029}', "");
    Expect(1, 12890, '\p{^Is_Numeric_Value=029}', "");
    Expect(1, 12890, '\P{Is_Numeric_Value=029}', "");
    Expect(0, 12890, '\P{^Is_Numeric_Value=029}', "");
    Expect(1, 12889, '\p{Is_Numeric_Value=2.900000000000000e+01}', "");
    Expect(0, 12889, '\p{^Is_Numeric_Value=2.900000000000000e+01}', "");
    Expect(0, 12889, '\P{Is_Numeric_Value=2.900000000000000e+01}', "");
    Expect(1, 12889, '\P{^Is_Numeric_Value=2.900000000000000e+01}', "");
    Expect(0, 12890, '\p{Is_Numeric_Value=2.900000000000000e+01}', "");
    Expect(1, 12890, '\p{^Is_Numeric_Value=2.900000000000000e+01}', "");
    Expect(1, 12890, '\P{Is_Numeric_Value=2.900000000000000e+01}', "");
    Expect(0, 12890, '\P{^Is_Numeric_Value=2.900000000000000e+01}', "");
    Error('\p{Is_Nv=  0_0_0_0_0_0_0_0_29/a/}');
    Error('\P{Is_Nv=  0_0_0_0_0_0_0_0_29/a/}');
    Expect(1, 12889, '\p{Is_Nv=00_00_00_00_29}', "");
    Expect(0, 12889, '\p{^Is_Nv=00_00_00_00_29}', "");
    Expect(0, 12889, '\P{Is_Nv=00_00_00_00_29}', "");
    Expect(1, 12889, '\P{^Is_Nv=00_00_00_00_29}', "");
    Expect(0, 12890, '\p{Is_Nv=00_00_00_00_29}', "");
    Expect(1, 12890, '\p{^Is_Nv=00_00_00_00_29}', "");
    Expect(1, 12890, '\P{Is_Nv=00_00_00_00_29}', "");
    Expect(0, 12890, '\P{^Is_Nv=00_00_00_00_29}', "");
    Expect(1, 12889, '\p{Is_Nv=2.900000000000000e+01}', "");
    Expect(0, 12889, '\p{^Is_Nv=2.900000000000000e+01}', "");
    Expect(0, 12889, '\P{Is_Nv=2.900000000000000e+01}', "");
    Expect(1, 12889, '\P{^Is_Nv=2.900000000000000e+01}', "");
    Expect(0, 12890, '\p{Is_Nv=2.900000000000000e+01}', "");
    Expect(1, 12890, '\p{^Is_Nv=2.900000000000000e+01}', "");
    Expect(1, 12890, '\P{Is_Nv=2.900000000000000e+01}', "");
    Expect(0, 12890, '\P{^Is_Nv=2.900000000000000e+01}', "");
    Error('\p{Numeric_Value=	_0_0_0_0_0003:=}');
    Error('\P{Numeric_Value=	_0_0_0_0_0003:=}');
    Expect(1, 146203, '\p{Numeric_Value=:\A3\z:}', "");;
    Expect(0, 146204, '\p{Numeric_Value=:\A3\z:}', "");;
    Expect(1, 146203, '\p{Numeric_Value=00003}', "");
    Expect(0, 146203, '\p{^Numeric_Value=00003}', "");
    Expect(0, 146203, '\P{Numeric_Value=00003}', "");
    Expect(1, 146203, '\P{^Numeric_Value=00003}', "");
    Expect(0, 146204, '\p{Numeric_Value=00003}', "");
    Expect(1, 146204, '\p{^Numeric_Value=00003}', "");
    Expect(1, 146204, '\P{Numeric_Value=00003}', "");
    Expect(0, 146204, '\P{^Numeric_Value=00003}', "");
    Expect(1, 146203, '\p{Numeric_Value=3.000000000000000e+00}', "");
    Expect(0, 146203, '\p{^Numeric_Value=3.000000000000000e+00}', "");
    Expect(0, 146203, '\P{Numeric_Value=3.000000000000000e+00}', "");
    Expect(1, 146203, '\P{^Numeric_Value=3.000000000000000e+00}', "");
    Expect(0, 146204, '\p{Numeric_Value=3.000000000000000e+00}', "");
    Expect(1, 146204, '\p{^Numeric_Value=3.000000000000000e+00}', "");
    Expect(1, 146204, '\P{Numeric_Value=3.000000000000000e+00}', "");
    Expect(0, 146204, '\P{^Numeric_Value=3.000000000000000e+00}', "");
    Error('\p{Nv=:=_ 3}');
    Error('\P{Nv=:=_ 3}');
    Expect(1, 146203, '\p{Nv=:\A3\z:}', "");;
    Expect(0, 146204, '\p{Nv=:\A3\z:}', "");;
    Expect(1, 146203, '\p{Nv:03}', "");
    Expect(0, 146203, '\p{^Nv:03}', "");
    Expect(0, 146203, '\P{Nv:03}', "");
    Expect(1, 146203, '\P{^Nv:03}', "");
    Expect(0, 146204, '\p{Nv:03}', "");
    Expect(1, 146204, '\p{^Nv:03}', "");
    Expect(1, 146204, '\P{Nv:03}', "");
    Expect(0, 146204, '\P{^Nv:03}', "");
    Expect(1, 146203, '\p{Nv=3.000000000000000e+00}', "");
    Expect(0, 146203, '\p{^Nv=3.000000000000000e+00}', "");
    Expect(0, 146203, '\P{Nv=3.000000000000000e+00}', "");
    Expect(1, 146203, '\P{^Nv=3.000000000000000e+00}', "");
    Expect(0, 146204, '\p{Nv=3.000000000000000e+00}', "");
    Expect(1, 146204, '\p{^Nv=3.000000000000000e+00}', "");
    Expect(1, 146204, '\P{Nv=3.000000000000000e+00}', "");
    Expect(0, 146204, '\P{^Nv=3.000000000000000e+00}', "");
    Error('\p{Is_Numeric_Value=_/a/+0000000_3}');
    Error('\P{Is_Numeric_Value=_/a/+0000000_3}');
    Expect(1, 146203, '\p{Is_Numeric_Value=+3}', "");
    Expect(0, 146203, '\p{^Is_Numeric_Value=+3}', "");
    Expect(0, 146203, '\P{Is_Numeric_Value=+3}', "");
    Expect(1, 146203, '\P{^Is_Numeric_Value=+3}', "");
    Expect(0, 146204, '\p{Is_Numeric_Value=+3}', "");
    Expect(1, 146204, '\p{^Is_Numeric_Value=+3}', "");
    Expect(1, 146204, '\P{Is_Numeric_Value=+3}', "");
    Expect(0, 146204, '\P{^Is_Numeric_Value=+3}', "");
    Expect(1, 146203, '\p{Is_Numeric_Value=3.000000000000000e+00}', "");
    Expect(0, 146203, '\p{^Is_Numeric_Value=3.000000000000000e+00}', "");
    Expect(0, 146203, '\P{Is_Numeric_Value=3.000000000000000e+00}', "");
    Expect(1, 146203, '\P{^Is_Numeric_Value=3.000000000000000e+00}', "");
    Expect(0, 146204, '\p{Is_Numeric_Value=3.000000000000000e+00}', "");
    Expect(1, 146204, '\p{^Is_Numeric_Value=3.000000000000000e+00}', "");
    Expect(1, 146204, '\P{Is_Numeric_Value=3.000000000000000e+00}', "");
    Expect(0, 146204, '\P{^Is_Numeric_Value=3.000000000000000e+00}', "");
    Error('\p{Is_Nv=/a/-_000_3}');
    Error('\P{Is_Nv=/a/-_000_3}');
    Expect(1, 146203, '\p{Is_Nv=00003}', "");
    Expect(0, 146203, '\p{^Is_Nv=00003}', "");
    Expect(0, 146203, '\P{Is_Nv=00003}', "");
    Expect(1, 146203, '\P{^Is_Nv=00003}', "");
    Expect(0, 146204, '\p{Is_Nv=00003}', "");
    Expect(1, 146204, '\p{^Is_Nv=00003}', "");
    Expect(1, 146204, '\P{Is_Nv=00003}', "");
    Expect(0, 146204, '\P{^Is_Nv=00003}', "");
    Expect(1, 146203, '\p{Is_Nv:	3.000000000000000e+00}', "");
    Expect(0, 146203, '\p{^Is_Nv:	3.000000000000000e+00}', "");
    Expect(0, 146203, '\P{Is_Nv:	3.000000000000000e+00}', "");
    Expect(1, 146203, '\P{^Is_Nv:	3.000000000000000e+00}', "");
    Expect(0, 146204, '\p{Is_Nv:	3.000000000000000e+00}', "");
    Expect(1, 146204, '\p{^Is_Nv:	3.000000000000000e+00}', "");
    Expect(1, 146204, '\P{Is_Nv:	3.000000000000000e+00}', "");
    Expect(0, 146204, '\P{^Is_Nv:	3.000000000000000e+00}', "");
    Error('\p{Numeric_Value=	 0000000003/00000016:=}');
    Error('\P{Numeric_Value=	 0000000003/00000016:=}');
    Expect(1, 73678, '\p{Numeric_Value=:\A3/16\z:}', "");;
    Expect(0, 73679, '\p{Numeric_Value=:\A3/16\z:}', "");;
    Expect(1, 73678, '\p{Numeric_Value=+0003/00016}', "");
    Expect(0, 73678, '\p{^Numeric_Value=+0003/00016}', "");
    Expect(0, 73678, '\P{Numeric_Value=+0003/00016}', "");
    Expect(1, 73678, '\P{^Numeric_Value=+0003/00016}', "");
    Expect(0, 73679, '\p{Numeric_Value=+0003/00016}', "");
    Expect(1, 73679, '\p{^Numeric_Value=+0003/00016}', "");
    Expect(1, 73679, '\P{Numeric_Value=+0003/00016}', "");
    Expect(0, 73679, '\P{^Numeric_Value=+0003/00016}', "");
    Expect(1, 73678, '\p{Numeric_Value=180/960}', "");
    Expect(0, 73678, '\p{^Numeric_Value=180/960}', "");
    Expect(0, 73678, '\P{Numeric_Value=180/960}', "");
    Expect(1, 73678, '\P{^Numeric_Value=180/960}', "");
    Expect(0, 73679, '\p{Numeric_Value=180/960}', "");
    Expect(1, 73679, '\p{^Numeric_Value=180/960}', "");
    Expect(1, 73679, '\P{Numeric_Value=180/960}', "");
    Expect(0, 73679, '\P{^Numeric_Value=180/960}', "");
    Error('\p{Numeric_Value=1.9e-01}');
    Error('\P{Numeric_Value=1.9e-01}');
    Expect(1, 73678, '\p{Numeric_Value=1.88e-01}', "");
    Expect(0, 73678, '\p{^Numeric_Value=1.88e-01}', "");
    Expect(0, 73678, '\P{Numeric_Value=1.88e-01}', "");
    Expect(1, 73678, '\P{^Numeric_Value=1.88e-01}', "");
    Expect(0, 73679, '\p{Numeric_Value=1.88e-01}', "");
    Expect(1, 73679, '\p{^Numeric_Value=1.88e-01}', "");
    Expect(1, 73679, '\P{Numeric_Value=1.88e-01}', "");
    Expect(0, 73679, '\P{^Numeric_Value=1.88e-01}', "");
    Error('\p{Numeric_Value=0.19}');
    Error('\P{Numeric_Value=0.19}');
    Expect(1, 73678, '\p{Numeric_Value=1.875e-01}', "");
    Expect(0, 73678, '\p{^Numeric_Value=1.875e-01}', "");
    Expect(0, 73678, '\P{Numeric_Value=1.875e-01}', "");
    Expect(1, 73678, '\P{^Numeric_Value=1.875e-01}', "");
    Expect(0, 73679, '\p{Numeric_Value=1.875e-01}', "");
    Expect(1, 73679, '\p{^Numeric_Value=1.875e-01}', "");
    Expect(1, 73679, '\P{Numeric_Value=1.875e-01}', "");
    Expect(0, 73679, '\P{^Numeric_Value=1.875e-01}', "");
    Expect(1, 73678, '\p{Numeric_Value=0.188}', "");
    Expect(0, 73678, '\p{^Numeric_Value=0.188}', "");
    Expect(0, 73678, '\P{Numeric_Value=0.188}', "");
    Expect(1, 73678, '\P{^Numeric_Value=0.188}', "");
    Expect(0, 73679, '\p{Numeric_Value=0.188}', "");
    Expect(1, 73679, '\p{^Numeric_Value=0.188}', "");
    Expect(1, 73679, '\P{Numeric_Value=0.188}', "");
    Expect(0, 73679, '\P{^Numeric_Value=0.188}', "");
    Expect(1, 73678, '\p{Numeric_Value=1.8750e-01}', "");
    Expect(0, 73678, '\p{^Numeric_Value=1.8750e-01}', "");
    Expect(0, 73678, '\P{Numeric_Value=1.8750e-01}', "");
    Expect(1, 73678, '\P{^Numeric_Value=1.8750e-01}', "");
    Expect(0, 73679, '\p{Numeric_Value=1.8750e-01}', "");
    Expect(1, 73679, '\p{^Numeric_Value=1.8750e-01}', "");
    Expect(1, 73679, '\P{Numeric_Value=1.8750e-01}', "");
    Expect(0, 73679, '\P{^Numeric_Value=1.8750e-01}', "");
    Expect(1, 73678, '\p{Numeric_Value=0.1875}', "");
    Expect(0, 73678, '\p{^Numeric_Value=0.1875}', "");
    Expect(0, 73678, '\P{Numeric_Value=0.1875}', "");
    Expect(1, 73678, '\P{^Numeric_Value=0.1875}', "");
    Expect(0, 73679, '\p{Numeric_Value=0.1875}', "");
    Expect(1, 73679, '\p{^Numeric_Value=0.1875}', "");
    Expect(1, 73679, '\P{Numeric_Value=0.1875}', "");
    Expect(0, 73679, '\P{^Numeric_Value=0.1875}', "");
    Error('\p{Nv=_ 0000000003/00000000016:=}');
    Error('\P{Nv=_ 0000000003/00000000016:=}');
    Expect(1, 73678, '\p{Nv=:\A3/16\z:}', "");;
    Expect(0, 73679, '\p{Nv=:\A3/16\z:}', "");;
    Expect(1, 73678, '\p{Nv=000003/16}', "");
    Expect(0, 73678, '\p{^Nv=000003/16}', "");
    Expect(0, 73678, '\P{Nv=000003/16}', "");
    Expect(1, 73678, '\P{^Nv=000003/16}', "");
    Expect(0, 73679, '\p{Nv=000003/16}', "");
    Expect(1, 73679, '\p{^Nv=000003/16}', "");
    Expect(1, 73679, '\P{Nv=000003/16}', "");
    Expect(0, 73679, '\P{^Nv=000003/16}', "");
    Expect(1, 73678, '\p{Nv=180/960}', "");
    Expect(0, 73678, '\p{^Nv=180/960}', "");
    Expect(0, 73678, '\P{Nv=180/960}', "");
    Expect(1, 73678, '\P{^Nv=180/960}', "");
    Expect(0, 73679, '\p{Nv=180/960}', "");
    Expect(1, 73679, '\p{^Nv=180/960}', "");
    Expect(1, 73679, '\P{Nv=180/960}', "");
    Expect(0, 73679, '\P{^Nv=180/960}', "");
    Error('\p{Nv=1.9e-01}');
    Error('\P{Nv=1.9e-01}');
    Expect(1, 73678, '\p{Nv=1.88e-01}', "");
    Expect(0, 73678, '\p{^Nv=1.88e-01}', "");
    Expect(0, 73678, '\P{Nv=1.88e-01}', "");
    Expect(1, 73678, '\P{^Nv=1.88e-01}', "");
    Expect(0, 73679, '\p{Nv=1.88e-01}', "");
    Expect(1, 73679, '\p{^Nv=1.88e-01}', "");
    Expect(1, 73679, '\P{Nv=1.88e-01}', "");
    Expect(0, 73679, '\P{^Nv=1.88e-01}', "");
    Error('\p{Nv=0.19}');
    Error('\P{Nv=0.19}');
    Expect(1, 73678, '\p{Nv=1.875e-01}', "");
    Expect(0, 73678, '\p{^Nv=1.875e-01}', "");
    Expect(0, 73678, '\P{Nv=1.875e-01}', "");
    Expect(1, 73678, '\P{^Nv=1.875e-01}', "");
    Expect(0, 73679, '\p{Nv=1.875e-01}', "");
    Expect(1, 73679, '\p{^Nv=1.875e-01}', "");
    Expect(1, 73679, '\P{Nv=1.875e-01}', "");
    Expect(0, 73679, '\P{^Nv=1.875e-01}', "");
    Expect(1, 73678, '\p{Nv=0.188}', "");
    Expect(0, 73678, '\p{^Nv=0.188}', "");
    Expect(0, 73678, '\P{Nv=0.188}', "");
    Expect(1, 73678, '\P{^Nv=0.188}', "");
    Expect(0, 73679, '\p{Nv=0.188}', "");
    Expect(1, 73679, '\p{^Nv=0.188}', "");
    Expect(1, 73679, '\P{Nv=0.188}', "");
    Expect(0, 73679, '\P{^Nv=0.188}', "");
    Expect(1, 73678, '\p{Nv=1.8750e-01}', "");
    Expect(0, 73678, '\p{^Nv=1.8750e-01}', "");
    Expect(0, 73678, '\P{Nv=1.8750e-01}', "");
    Expect(1, 73678, '\P{^Nv=1.8750e-01}', "");
    Expect(0, 73679, '\p{Nv=1.8750e-01}', "");
    Expect(1, 73679, '\p{^Nv=1.8750e-01}', "");
    Expect(1, 73679, '\P{Nv=1.8750e-01}', "");
    Expect(0, 73679, '\P{^Nv=1.8750e-01}', "");
    Expect(1, 73678, '\p{Nv=0.1875}', "");
    Expect(0, 73678, '\p{^Nv=0.1875}', "");
    Expect(0, 73678, '\P{Nv=0.1875}', "");
    Expect(1, 73678, '\P{^Nv=0.1875}', "");
    Expect(0, 73679, '\p{Nv=0.1875}', "");
    Expect(1, 73679, '\p{^Nv=0.1875}', "");
    Expect(1, 73679, '\P{Nv=0.1875}', "");
    Expect(0, 73679, '\P{^Nv=0.1875}', "");
    Error('\p{Is_Numeric_Value= _+3/00000016:=}');
    Error('\P{Is_Numeric_Value= _+3/00000016:=}');
    Expect(1, 73678, '\p{Is_Numeric_Value: +0000000003/16}', "");
    Expect(0, 73678, '\p{^Is_Numeric_Value: +0000000003/16}', "");
    Expect(0, 73678, '\P{Is_Numeric_Value: +0000000003/16}', "");
    Expect(1, 73678, '\P{^Is_Numeric_Value: +0000000003/16}', "");
    Expect(0, 73679, '\p{Is_Numeric_Value: +0000000003/16}', "");
    Expect(1, 73679, '\p{^Is_Numeric_Value: +0000000003/16}', "");
    Expect(1, 73679, '\P{Is_Numeric_Value: +0000000003/16}', "");
    Expect(0, 73679, '\P{^Is_Numeric_Value: +0000000003/16}', "");
    Expect(1, 73678, '\p{Is_Numeric_Value=180/960}', "");
    Expect(0, 73678, '\p{^Is_Numeric_Value=180/960}', "");
    Expect(0, 73678, '\P{Is_Numeric_Value=180/960}', "");
    Expect(1, 73678, '\P{^Is_Numeric_Value=180/960}', "");
    Expect(0, 73679, '\p{Is_Numeric_Value=180/960}', "");
    Expect(1, 73679, '\p{^Is_Numeric_Value=180/960}', "");
    Expect(1, 73679, '\P{Is_Numeric_Value=180/960}', "");
    Expect(0, 73679, '\P{^Is_Numeric_Value=180/960}', "");
    Error('\p{Is_Numeric_Value=1.9e-01}');
    Error('\P{Is_Numeric_Value=1.9e-01}');
    Expect(1, 73678, '\p{Is_Numeric_Value:	1.88e-01}', "");
    Expect(0, 73678, '\p{^Is_Numeric_Value:	1.88e-01}', "");
    Expect(0, 73678, '\P{Is_Numeric_Value:	1.88e-01}', "");
    Expect(1, 73678, '\P{^Is_Numeric_Value:	1.88e-01}', "");
    Expect(0, 73679, '\p{Is_Numeric_Value:	1.88e-01}', "");
    Expect(1, 73679, '\p{^Is_Numeric_Value:	1.88e-01}', "");
    Expect(1, 73679, '\P{Is_Numeric_Value:	1.88e-01}', "");
    Expect(0, 73679, '\P{^Is_Numeric_Value:	1.88e-01}', "");
    Error('\p{Is_Numeric_Value: 0.19}');
    Error('\P{Is_Numeric_Value: 0.19}');
    Expect(1, 73678, '\p{Is_Numeric_Value=1.875e-01}', "");
    Expect(0, 73678, '\p{^Is_Numeric_Value=1.875e-01}', "");
    Expect(0, 73678, '\P{Is_Numeric_Value=1.875e-01}', "");
    Expect(1, 73678, '\P{^Is_Numeric_Value=1.875e-01}', "");
    Expect(0, 73679, '\p{Is_Numeric_Value=1.875e-01}', "");
    Expect(1, 73679, '\p{^Is_Numeric_Value=1.875e-01}', "");
    Expect(1, 73679, '\P{Is_Numeric_Value=1.875e-01}', "");
    Expect(0, 73679, '\P{^Is_Numeric_Value=1.875e-01}', "");
    Expect(1, 73678, '\p{Is_Numeric_Value=0.188}', "");
    Expect(0, 73678, '\p{^Is_Numeric_Value=0.188}', "");
    Expect(0, 73678, '\P{Is_Numeric_Value=0.188}', "");
    Expect(1, 73678, '\P{^Is_Numeric_Value=0.188}', "");
    Expect(0, 73679, '\p{Is_Numeric_Value=0.188}', "");
    Expect(1, 73679, '\p{^Is_Numeric_Value=0.188}', "");
    Expect(1, 73679, '\P{Is_Numeric_Value=0.188}', "");
    Expect(0, 73679, '\P{^Is_Numeric_Value=0.188}', "");
    Expect(1, 73678, '\p{Is_Numeric_Value: 1.8750e-01}', "");
    Expect(0, 73678, '\p{^Is_Numeric_Value: 1.8750e-01}', "");
    Expect(0, 73678, '\P{Is_Numeric_Value: 1.8750e-01}', "");
    Expect(1, 73678, '\P{^Is_Numeric_Value: 1.8750e-01}', "");
    Expect(0, 73679, '\p{Is_Numeric_Value: 1.8750e-01}', "");
    Expect(1, 73679, '\p{^Is_Numeric_Value: 1.8750e-01}', "");
    Expect(1, 73679, '\P{Is_Numeric_Value: 1.8750e-01}', "");
    Expect(0, 73679, '\P{^Is_Numeric_Value: 1.8750e-01}', "");
    Expect(1, 73678, '\p{Is_Numeric_Value=0.1875}', "");
    Expect(0, 73678, '\p{^Is_Numeric_Value=0.1875}', "");
    Expect(0, 73678, '\P{Is_Numeric_Value=0.1875}', "");
    Expect(1, 73678, '\P{^Is_Numeric_Value=0.1875}', "");
    Expect(0, 73679, '\p{Is_Numeric_Value=0.1875}', "");
    Expect(1, 73679, '\p{^Is_Numeric_Value=0.1875}', "");
    Expect(1, 73679, '\P{Is_Numeric_Value=0.1875}', "");
    Expect(0, 73679, '\P{^Is_Numeric_Value=0.1875}', "");
    Error('\p{Is_Nv=-:=0003/0000016}');
    Error('\P{Is_Nv=-:=0003/0000016}');
    Expect(1, 73678, '\p{Is_Nv=00000003/16}', "");
    Expect(0, 73678, '\p{^Is_Nv=00000003/16}', "");
    Expect(0, 73678, '\P{Is_Nv=00000003/16}', "");
    Expect(1, 73678, '\P{^Is_Nv=00000003/16}', "");
    Expect(0, 73679, '\p{Is_Nv=00000003/16}', "");
    Expect(1, 73679, '\p{^Is_Nv=00000003/16}', "");
    Expect(1, 73679, '\P{Is_Nv=00000003/16}', "");
    Expect(0, 73679, '\P{^Is_Nv=00000003/16}', "");
    Expect(1, 73678, '\p{Is_Nv=180/960}', "");
    Expect(0, 73678, '\p{^Is_Nv=180/960}', "");
    Expect(0, 73678, '\P{Is_Nv=180/960}', "");
    Expect(1, 73678, '\P{^Is_Nv=180/960}', "");
    Expect(0, 73679, '\p{Is_Nv=180/960}', "");
    Expect(1, 73679, '\p{^Is_Nv=180/960}', "");
    Expect(1, 73679, '\P{Is_Nv=180/960}', "");
    Expect(0, 73679, '\P{^Is_Nv=180/960}', "");
    Error('\p{Is_Nv=1.9e-01}');
    Error('\P{Is_Nv=1.9e-01}');
    Expect(1, 73678, '\p{Is_Nv=1.88e-01}', "");
    Expect(0, 73678, '\p{^Is_Nv=1.88e-01}', "");
    Expect(0, 73678, '\P{Is_Nv=1.88e-01}', "");
    Expect(1, 73678, '\P{^Is_Nv=1.88e-01}', "");
    Expect(0, 73679, '\p{Is_Nv=1.88e-01}', "");
    Expect(1, 73679, '\p{^Is_Nv=1.88e-01}', "");
    Expect(1, 73679, '\P{Is_Nv=1.88e-01}', "");
    Expect(0, 73679, '\P{^Is_Nv=1.88e-01}', "");
    Error('\p{Is_Nv=0.19}');
    Error('\P{Is_Nv=0.19}');
    Expect(1, 73678, '\p{Is_Nv=1.875e-01}', "");
    Expect(0, 73678, '\p{^Is_Nv=1.875e-01}', "");
    Expect(0, 73678, '\P{Is_Nv=1.875e-01}', "");
    Expect(1, 73678, '\P{^Is_Nv=1.875e-01}', "");
    Expect(0, 73679, '\p{Is_Nv=1.875e-01}', "");
    Expect(1, 73679, '\p{^Is_Nv=1.875e-01}', "");
    Expect(1, 73679, '\P{Is_Nv=1.875e-01}', "");
    Expect(0, 73679, '\P{^Is_Nv=1.875e-01}', "");
    Expect(1, 73678, '\p{Is_Nv=0.188}', "");
    Expect(0, 73678, '\p{^Is_Nv=0.188}', "");
    Expect(0, 73678, '\P{Is_Nv=0.188}', "");
    Expect(1, 73678, '\P{^Is_Nv=0.188}', "");
    Expect(0, 73679, '\p{Is_Nv=0.188}', "");
    Expect(1, 73679, '\p{^Is_Nv=0.188}', "");
    Expect(1, 73679, '\P{Is_Nv=0.188}', "");
    Expect(0, 73679, '\P{^Is_Nv=0.188}', "");
    Expect(1, 73678, '\p{Is_Nv:1.8750e-01}', "");
    Expect(0, 73678, '\p{^Is_Nv:1.8750e-01}', "");
    Expect(0, 73678, '\P{Is_Nv:1.8750e-01}', "");
    Expect(1, 73678, '\P{^Is_Nv:1.8750e-01}', "");
    Expect(0, 73679, '\p{Is_Nv:1.8750e-01}', "");
    Expect(1, 73679, '\p{^Is_Nv:1.8750e-01}', "");
    Expect(1, 73679, '\P{Is_Nv:1.8750e-01}', "");
    Expect(0, 73679, '\P{^Is_Nv:1.8750e-01}', "");
    Expect(1, 73678, '\p{Is_Nv:   0.1875}', "");
    Expect(0, 73678, '\p{^Is_Nv:   0.1875}', "");
    Expect(0, 73678, '\P{Is_Nv:   0.1875}', "");
    Expect(1, 73678, '\P{^Is_Nv:   0.1875}', "");
    Expect(0, 73679, '\p{Is_Nv:   0.1875}', "");
    Expect(1, 73679, '\p{^Is_Nv:   0.1875}', "");
    Expect(1, 73679, '\P{Is_Nv:   0.1875}', "");
    Expect(0, 73679, '\P{^Is_Nv:   0.1875}', "");
    Error('\p{Numeric_Value=:=	000003/0000002}');
    Error('\P{Numeric_Value=:=	000003/0000002}');
    Expect(1, 3883, '\p{Numeric_Value=:\A3/2\z:}', "");;
    Expect(0, 3884, '\p{Numeric_Value=:\A3/2\z:}', "");;
    Expect(1, 3883, '\p{Numeric_Value=+0000000003/2}', "");
    Expect(0, 3883, '\p{^Numeric_Value=+0000000003/2}', "");
    Expect(0, 3883, '\P{Numeric_Value=+0000000003/2}', "");
    Expect(1, 3883, '\P{^Numeric_Value=+0000000003/2}', "");
    Expect(0, 3884, '\p{Numeric_Value=+0000000003/2}', "");
    Expect(1, 3884, '\p{^Numeric_Value=+0000000003/2}', "");
    Expect(1, 3884, '\P{Numeric_Value=+0000000003/2}', "");
    Expect(0, 3884, '\P{^Numeric_Value=+0000000003/2}', "");
    Expect(1, 3883, '\p{Numeric_Value=180/120}', "");
    Expect(0, 3883, '\p{^Numeric_Value=180/120}', "");
    Expect(0, 3883, '\P{Numeric_Value=180/120}', "");
    Expect(1, 3883, '\P{^Numeric_Value=180/120}', "");
    Expect(0, 3884, '\p{Numeric_Value=180/120}', "");
    Expect(1, 3884, '\p{^Numeric_Value=180/120}', "");
    Expect(1, 3884, '\P{Numeric_Value=180/120}', "");
    Expect(0, 3884, '\P{^Numeric_Value=180/120}', "");
    Expect(1, 3883, '\p{Numeric_Value=1.5e+00}', "");
    Expect(0, 3883, '\p{^Numeric_Value=1.5e+00}', "");
    Expect(0, 3883, '\P{Numeric_Value=1.5e+00}', "");
    Expect(1, 3883, '\P{^Numeric_Value=1.5e+00}', "");
    Expect(0, 3884, '\p{Numeric_Value=1.5e+00}', "");
    Expect(1, 3884, '\p{^Numeric_Value=1.5e+00}', "");
    Expect(1, 3884, '\P{Numeric_Value=1.5e+00}', "");
    Expect(0, 3884, '\P{^Numeric_Value=1.5e+00}', "");
    Expect(1, 3883, '\p{Numeric_Value=1.5}', "");
    Expect(0, 3883, '\p{^Numeric_Value=1.5}', "");
    Expect(0, 3883, '\P{Numeric_Value=1.5}', "");
    Expect(1, 3883, '\P{^Numeric_Value=1.5}', "");
    Expect(0, 3884, '\p{Numeric_Value=1.5}', "");
    Expect(1, 3884, '\p{^Numeric_Value=1.5}', "");
    Expect(1, 3884, '\P{Numeric_Value=1.5}', "");
    Expect(0, 3884, '\P{^Numeric_Value=1.5}', "");
    Expect(1, 3883, '\p{Numeric_Value=1.50e+00}', "");
    Expect(0, 3883, '\p{^Numeric_Value=1.50e+00}', "");
    Expect(0, 3883, '\P{Numeric_Value=1.50e+00}', "");
    Expect(1, 3883, '\P{^Numeric_Value=1.50e+00}', "");
    Expect(0, 3884, '\p{Numeric_Value=1.50e+00}', "");
    Expect(1, 3884, '\p{^Numeric_Value=1.50e+00}', "");
    Expect(1, 3884, '\P{Numeric_Value=1.50e+00}', "");
    Expect(0, 3884, '\P{^Numeric_Value=1.50e+00}', "");
    Expect(1, 3883, '\p{Numeric_Value=1.50}', "");
    Expect(0, 3883, '\p{^Numeric_Value=1.50}', "");
    Expect(0, 3883, '\P{Numeric_Value=1.50}', "");
    Expect(1, 3883, '\P{^Numeric_Value=1.50}', "");
    Expect(0, 3884, '\p{Numeric_Value=1.50}', "");
    Expect(1, 3884, '\p{^Numeric_Value=1.50}', "");
    Expect(1, 3884, '\P{Numeric_Value=1.50}', "");
    Expect(0, 3884, '\P{^Numeric_Value=1.50}', "");
    Error('\p{Nv=	_00000003/00000002:=}');
    Error('\P{Nv=	_00000003/00000002:=}');
    Expect(1, 3883, '\p{Nv=:\A3/2\z:}', "");;
    Expect(0, 3884, '\p{Nv=:\A3/2\z:}', "");;
    Expect(1, 3883, '\p{Nv=+00003/000000002}', "");
    Expect(0, 3883, '\p{^Nv=+00003/000000002}', "");
    Expect(0, 3883, '\P{Nv=+00003/000000002}', "");
    Expect(1, 3883, '\P{^Nv=+00003/000000002}', "");
    Expect(0, 3884, '\p{Nv=+00003/000000002}', "");
    Expect(1, 3884, '\p{^Nv=+00003/000000002}', "");
    Expect(1, 3884, '\P{Nv=+00003/000000002}', "");
    Expect(0, 3884, '\P{^Nv=+00003/000000002}', "");
    Expect(1, 3883, '\p{Nv=180/120}', "");
    Expect(0, 3883, '\p{^Nv=180/120}', "");
    Expect(0, 3883, '\P{Nv=180/120}', "");
    Expect(1, 3883, '\P{^Nv=180/120}', "");
    Expect(0, 3884, '\p{Nv=180/120}', "");
    Expect(1, 3884, '\p{^Nv=180/120}', "");
    Expect(1, 3884, '\P{Nv=180/120}', "");
    Expect(0, 3884, '\P{^Nv=180/120}', "");
    Expect(1, 3883, '\p{Nv=1.5e+00}', "");
    Expect(0, 3883, '\p{^Nv=1.5e+00}', "");
    Expect(0, 3883, '\P{Nv=1.5e+00}', "");
    Expect(1, 3883, '\P{^Nv=1.5e+00}', "");
    Expect(0, 3884, '\p{Nv=1.5e+00}', "");
    Expect(1, 3884, '\p{^Nv=1.5e+00}', "");
    Expect(1, 3884, '\P{Nv=1.5e+00}', "");
    Expect(0, 3884, '\P{^Nv=1.5e+00}', "");
    Expect(1, 3883, '\p{Nv=1.5}', "");
    Expect(0, 3883, '\p{^Nv=1.5}', "");
    Expect(0, 3883, '\P{Nv=1.5}', "");
    Expect(1, 3883, '\P{^Nv=1.5}', "");
    Expect(0, 3884, '\p{Nv=1.5}', "");
    Expect(1, 3884, '\p{^Nv=1.5}', "");
    Expect(1, 3884, '\P{Nv=1.5}', "");
    Expect(0, 3884, '\P{^Nv=1.5}', "");
    Expect(1, 3883, '\p{Nv=1.50e+00}', "");
    Expect(0, 3883, '\p{^Nv=1.50e+00}', "");
    Expect(0, 3883, '\P{Nv=1.50e+00}', "");
    Expect(1, 3883, '\P{^Nv=1.50e+00}', "");
    Expect(0, 3884, '\p{Nv=1.50e+00}', "");
    Expect(1, 3884, '\p{^Nv=1.50e+00}', "");
    Expect(1, 3884, '\P{Nv=1.50e+00}', "");
    Expect(0, 3884, '\P{^Nv=1.50e+00}', "");
    Expect(1, 3883, '\p{Nv=1.50}', "");
    Expect(0, 3883, '\p{^Nv=1.50}', "");
    Expect(0, 3883, '\P{Nv=1.50}', "");
    Expect(1, 3883, '\P{^Nv=1.50}', "");
    Expect(0, 3884, '\p{Nv=1.50}', "");
    Expect(1, 3884, '\p{^Nv=1.50}', "");
    Expect(1, 3884, '\P{Nv=1.50}', "");
    Expect(0, 3884, '\P{^Nv=1.50}', "");
    Error('\p{Is_Numeric_Value=:=_ +0000003/0000002}');
    Error('\P{Is_Numeric_Value=:=_ +0000003/0000002}');
    Expect(1, 3883, '\p{Is_Numeric_Value=00003/000000002}', "");
    Expect(0, 3883, '\p{^Is_Numeric_Value=00003/000000002}', "");
    Expect(0, 3883, '\P{Is_Numeric_Value=00003/000000002}', "");
    Expect(1, 3883, '\P{^Is_Numeric_Value=00003/000000002}', "");
    Expect(0, 3884, '\p{Is_Numeric_Value=00003/000000002}', "");
    Expect(1, 3884, '\p{^Is_Numeric_Value=00003/000000002}', "");
    Expect(1, 3884, '\P{Is_Numeric_Value=00003/000000002}', "");
    Expect(0, 3884, '\P{^Is_Numeric_Value=00003/000000002}', "");
    Expect(1, 3883, '\p{Is_Numeric_Value=180/120}', "");
    Expect(0, 3883, '\p{^Is_Numeric_Value=180/120}', "");
    Expect(0, 3883, '\P{Is_Numeric_Value=180/120}', "");
    Expect(1, 3883, '\P{^Is_Numeric_Value=180/120}', "");
    Expect(0, 3884, '\p{Is_Numeric_Value=180/120}', "");
    Expect(1, 3884, '\p{^Is_Numeric_Value=180/120}', "");
    Expect(1, 3884, '\P{Is_Numeric_Value=180/120}', "");
    Expect(0, 3884, '\P{^Is_Numeric_Value=180/120}', "");
    Expect(1, 3883, '\p{Is_Numeric_Value=1.5e+00}', "");
    Expect(0, 3883, '\p{^Is_Numeric_Value=1.5e+00}', "");
    Expect(0, 3883, '\P{Is_Numeric_Value=1.5e+00}', "");
    Expect(1, 3883, '\P{^Is_Numeric_Value=1.5e+00}', "");
    Expect(0, 3884, '\p{Is_Numeric_Value=1.5e+00}', "");
    Expect(1, 3884, '\p{^Is_Numeric_Value=1.5e+00}', "");
    Expect(1, 3884, '\P{Is_Numeric_Value=1.5e+00}', "");
    Expect(0, 3884, '\P{^Is_Numeric_Value=1.5e+00}', "");
    Expect(1, 3883, '\p{Is_Numeric_Value:   1.5}', "");
    Expect(0, 3883, '\p{^Is_Numeric_Value:   1.5}', "");
    Expect(0, 3883, '\P{Is_Numeric_Value:   1.5}', "");
    Expect(1, 3883, '\P{^Is_Numeric_Value:   1.5}', "");
    Expect(0, 3884, '\p{Is_Numeric_Value:   1.5}', "");
    Expect(1, 3884, '\p{^Is_Numeric_Value:   1.5}', "");
    Expect(1, 3884, '\P{Is_Numeric_Value:   1.5}', "");
    Expect(0, 3884, '\P{^Is_Numeric_Value:   1.5}', "");
    Expect(1, 3883, '\p{Is_Numeric_Value=1.50e+00}', "");
    Expect(0, 3883, '\p{^Is_Numeric_Value=1.50e+00}', "");
    Expect(0, 3883, '\P{Is_Numeric_Value=1.50e+00}', "");
    Expect(1, 3883, '\P{^Is_Numeric_Value=1.50e+00}', "");
    Expect(0, 3884, '\p{Is_Numeric_Value=1.50e+00}', "");
    Expect(1, 3884, '\p{^Is_Numeric_Value=1.50e+00}', "");
    Expect(1, 3884, '\P{Is_Numeric_Value=1.50e+00}', "");
    Expect(0, 3884, '\P{^Is_Numeric_Value=1.50e+00}', "");
    Expect(1, 3883, '\p{Is_Numeric_Value=1.50}', "");
    Expect(0, 3883, '\p{^Is_Numeric_Value=1.50}', "");
    Expect(0, 3883, '\P{Is_Numeric_Value=1.50}', "");
    Expect(1, 3883, '\P{^Is_Numeric_Value=1.50}', "");
    Expect(0, 3884, '\p{Is_Numeric_Value=1.50}', "");
    Expect(1, 3884, '\p{^Is_Numeric_Value=1.50}', "");
    Expect(1, 3884, '\P{Is_Numeric_Value=1.50}', "");
    Expect(0, 3884, '\P{^Is_Numeric_Value=1.50}', "");
    Error('\p{Is_Nv=:=	+000000003/00002}');
    Error('\P{Is_Nv=:=	+000000003/00002}');
    Expect(1, 3883, '\p{Is_Nv=0003/00002}', "");
    Expect(0, 3883, '\p{^Is_Nv=0003/00002}', "");
    Expect(0, 3883, '\P{Is_Nv=0003/00002}', "");
    Expect(1, 3883, '\P{^Is_Nv=0003/00002}', "");
    Expect(0, 3884, '\p{Is_Nv=0003/00002}', "");
    Expect(1, 3884, '\p{^Is_Nv=0003/00002}', "");
    Expect(1, 3884, '\P{Is_Nv=0003/00002}', "");
    Expect(0, 3884, '\P{^Is_Nv=0003/00002}', "");
    Expect(1, 3883, '\p{Is_Nv=180/120}', "");
    Expect(0, 3883, '\p{^Is_Nv=180/120}', "");
    Expect(0, 3883, '\P{Is_Nv=180/120}', "");
    Expect(1, 3883, '\P{^Is_Nv=180/120}', "");
    Expect(0, 3884, '\p{Is_Nv=180/120}', "");
    Expect(1, 3884, '\p{^Is_Nv=180/120}', "");
    Expect(1, 3884, '\P{Is_Nv=180/120}', "");
    Expect(0, 3884, '\P{^Is_Nv=180/120}', "");
    Expect(1, 3883, '\p{Is_Nv=1.5e+00}', "");
    Expect(0, 3883, '\p{^Is_Nv=1.5e+00}', "");
    Expect(0, 3883, '\P{Is_Nv=1.5e+00}', "");
    Expect(1, 3883, '\P{^Is_Nv=1.5e+00}', "");
    Expect(0, 3884, '\p{Is_Nv=1.5e+00}', "");
    Expect(1, 3884, '\p{^Is_Nv=1.5e+00}', "");
    Expect(1, 3884, '\P{Is_Nv=1.5e+00}', "");
    Expect(0, 3884, '\P{^Is_Nv=1.5e+00}', "");
    Expect(1, 3883, '\p{Is_Nv=1.5}', "");
    Expect(0, 3883, '\p{^Is_Nv=1.5}', "");
    Expect(0, 3883, '\P{Is_Nv=1.5}', "");
    Expect(1, 3883, '\P{^Is_Nv=1.5}', "");
    Expect(0, 3884, '\p{Is_Nv=1.5}', "");
    Expect(1, 3884, '\p{^Is_Nv=1.5}', "");
    Expect(1, 3884, '\P{Is_Nv=1.5}', "");
    Expect(0, 3884, '\P{^Is_Nv=1.5}', "");
    Expect(1, 3883, '\p{Is_Nv=1.50e+00}', "");
    Expect(0, 3883, '\p{^Is_Nv=1.50e+00}', "");
    Expect(0, 3883, '\P{Is_Nv=1.50e+00}', "");
    Expect(1, 3883, '\P{^Is_Nv=1.50e+00}', "");
    Expect(0, 3884, '\p{Is_Nv=1.50e+00}', "");
    Expect(1, 3884, '\p{^Is_Nv=1.50e+00}', "");
    Expect(1, 3884, '\P{Is_Nv=1.50e+00}', "");
    Expect(0, 3884, '\P{^Is_Nv=1.50e+00}', "");
    Expect(1, 3883, '\p{Is_Nv=1.50}', "");
    Expect(0, 3883, '\p{^Is_Nv=1.50}', "");
    Expect(0, 3883, '\P{Is_Nv=1.50}', "");
    Expect(1, 3883, '\P{^Is_Nv=1.50}', "");
    Expect(0, 3884, '\p{Is_Nv=1.50}', "");
    Expect(1, 3884, '\p{^Is_Nv=1.50}', "");
    Expect(1, 3884, '\P{Is_Nv=1.50}', "");
    Expect(0, 3884, '\P{^Is_Nv=1.50}', "");
    Error('\p{Numeric_Value=+003/0000000020/a/}');
    Error('\P{Numeric_Value=+003/0000000020/a/}');
    Expect(1, 73677, '\p{Numeric_Value=:\A3/20\z:}', "");;
    Expect(0, 73678, '\p{Numeric_Value=:\A3/20\z:}', "");;
    Expect(1, 73677, '\p{Numeric_Value=0000000003/0000020}', "");
    Expect(0, 73677, '\p{^Numeric_Value=0000000003/0000020}', "");
    Expect(0, 73677, '\P{Numeric_Value=0000000003/0000020}', "");
    Expect(1, 73677, '\P{^Numeric_Value=0000000003/0000020}', "");
    Expect(0, 73678, '\p{Numeric_Value=0000000003/0000020}', "");
    Expect(1, 73678, '\p{^Numeric_Value=0000000003/0000020}', "");
    Expect(1, 73678, '\P{Numeric_Value=0000000003/0000020}', "");
    Expect(0, 73678, '\P{^Numeric_Value=0000000003/0000020}', "");
    Expect(1, 73677, '\p{Numeric_Value=180/1200}', "");
    Expect(0, 73677, '\p{^Numeric_Value=180/1200}', "");
    Expect(0, 73677, '\P{Numeric_Value=180/1200}', "");
    Expect(1, 73677, '\P{^Numeric_Value=180/1200}', "");
    Expect(0, 73678, '\p{Numeric_Value=180/1200}', "");
    Expect(1, 73678, '\p{^Numeric_Value=180/1200}', "");
    Expect(1, 73678, '\P{Numeric_Value=180/1200}', "");
    Expect(0, 73678, '\P{^Numeric_Value=180/1200}', "");
    Expect(1, 73677, '\p{Numeric_Value=1.5e-01}', "");
    Expect(0, 73677, '\p{^Numeric_Value=1.5e-01}', "");
    Expect(0, 73677, '\P{Numeric_Value=1.5e-01}', "");
    Expect(1, 73677, '\P{^Numeric_Value=1.5e-01}', "");
    Expect(0, 73678, '\p{Numeric_Value=1.5e-01}', "");
    Expect(1, 73678, '\p{^Numeric_Value=1.5e-01}', "");
    Expect(1, 73678, '\P{Numeric_Value=1.5e-01}', "");
    Expect(0, 73678, '\P{^Numeric_Value=1.5e-01}', "");
    Expect(1, 73677, '\p{Numeric_Value=1.50e-01}', "");
    Expect(0, 73677, '\p{^Numeric_Value=1.50e-01}', "");
    Expect(0, 73677, '\P{Numeric_Value=1.50e-01}', "");
    Expect(1, 73677, '\P{^Numeric_Value=1.50e-01}', "");
    Expect(0, 73678, '\p{Numeric_Value=1.50e-01}', "");
    Expect(1, 73678, '\p{^Numeric_Value=1.50e-01}', "");
    Expect(1, 73678, '\P{Numeric_Value=1.50e-01}', "");
    Expect(0, 73678, '\P{^Numeric_Value=1.50e-01}', "");
    Expect(1, 73677, '\p{Numeric_Value=0.15}', "");
    Expect(0, 73677, '\p{^Numeric_Value=0.15}', "");
    Expect(0, 73677, '\P{Numeric_Value=0.15}', "");
    Expect(1, 73677, '\P{^Numeric_Value=0.15}', "");
    Expect(0, 73678, '\p{Numeric_Value=0.15}', "");
    Expect(1, 73678, '\p{^Numeric_Value=0.15}', "");
    Expect(1, 73678, '\P{Numeric_Value=0.15}', "");
    Expect(0, 73678, '\P{^Numeric_Value=0.15}', "");
    Expect(1, 73677, '\p{Numeric_Value=1.500e-01}', "");
    Expect(0, 73677, '\p{^Numeric_Value=1.500e-01}', "");
    Expect(0, 73677, '\P{Numeric_Value=1.500e-01}', "");
    Expect(1, 73677, '\P{^Numeric_Value=1.500e-01}', "");
    Expect(0, 73678, '\p{Numeric_Value=1.500e-01}', "");
    Expect(1, 73678, '\p{^Numeric_Value=1.500e-01}', "");
    Expect(1, 73678, '\P{Numeric_Value=1.500e-01}', "");
    Expect(0, 73678, '\P{^Numeric_Value=1.500e-01}', "");
    Expect(1, 73677, '\p{Numeric_Value=0.150}', "");
    Expect(0, 73677, '\p{^Numeric_Value=0.150}', "");
    Expect(0, 73677, '\P{Numeric_Value=0.150}', "");
    Expect(1, 73677, '\P{^Numeric_Value=0.150}', "");
    Expect(0, 73678, '\p{Numeric_Value=0.150}', "");
    Expect(1, 73678, '\p{^Numeric_Value=0.150}', "");
    Expect(1, 73678, '\P{Numeric_Value=0.150}', "");
    Expect(0, 73678, '\P{^Numeric_Value=0.150}', "");
    Error('\p{Nv=:=03/00020}');
    Error('\P{Nv=:=03/00020}');
    Expect(1, 73677, '\p{Nv=:\A3/20\z:}', "");;
    Expect(0, 73678, '\p{Nv=:\A3/20\z:}', "");;
    Expect(1, 73677, '\p{Nv=0003/00000000020}', "");
    Expect(0, 73677, '\p{^Nv=0003/00000000020}', "");
    Expect(0, 73677, '\P{Nv=0003/00000000020}', "");
    Expect(1, 73677, '\P{^Nv=0003/00000000020}', "");
    Expect(0, 73678, '\p{Nv=0003/00000000020}', "");
    Expect(1, 73678, '\p{^Nv=0003/00000000020}', "");
    Expect(1, 73678, '\P{Nv=0003/00000000020}', "");
    Expect(0, 73678, '\P{^Nv=0003/00000000020}', "");
    Expect(1, 73677, '\p{Nv:	180/1200}', "");
    Expect(0, 73677, '\p{^Nv:	180/1200}', "");
    Expect(0, 73677, '\P{Nv:	180/1200}', "");
    Expect(1, 73677, '\P{^Nv:	180/1200}', "");
    Expect(0, 73678, '\p{Nv:	180/1200}', "");
    Expect(1, 73678, '\p{^Nv:	180/1200}', "");
    Expect(1, 73678, '\P{Nv:	180/1200}', "");
    Expect(0, 73678, '\P{^Nv:	180/1200}', "");
    Expect(1, 73677, '\p{Nv=1.5e-01}', "");
    Expect(0, 73677, '\p{^Nv=1.5e-01}', "");
    Expect(0, 73677, '\P{Nv=1.5e-01}', "");
    Expect(1, 73677, '\P{^Nv=1.5e-01}', "");
    Expect(0, 73678, '\p{Nv=1.5e-01}', "");
    Expect(1, 73678, '\p{^Nv=1.5e-01}', "");
    Expect(1, 73678, '\P{Nv=1.5e-01}', "");
    Expect(0, 73678, '\P{^Nv=1.5e-01}', "");
    Expect(1, 73677, '\p{Nv=1.50e-01}', "");
    Expect(0, 73677, '\p{^Nv=1.50e-01}', "");
    Expect(0, 73677, '\P{Nv=1.50e-01}', "");
    Expect(1, 73677, '\P{^Nv=1.50e-01}', "");
    Expect(0, 73678, '\p{Nv=1.50e-01}', "");
    Expect(1, 73678, '\p{^Nv=1.50e-01}', "");
    Expect(1, 73678, '\P{Nv=1.50e-01}', "");
    Expect(0, 73678, '\P{^Nv=1.50e-01}', "");
    Expect(1, 73677, '\p{Nv=0.15}', "");
    Expect(0, 73677, '\p{^Nv=0.15}', "");
    Expect(0, 73677, '\P{Nv=0.15}', "");
    Expect(1, 73677, '\P{^Nv=0.15}', "");
    Expect(0, 73678, '\p{Nv=0.15}', "");
    Expect(1, 73678, '\p{^Nv=0.15}', "");
    Expect(1, 73678, '\P{Nv=0.15}', "");
    Expect(0, 73678, '\P{^Nv=0.15}', "");
    Expect(1, 73677, '\p{Nv:   1.500e-01}', "");
    Expect(0, 73677, '\p{^Nv:   1.500e-01}', "");
    Expect(0, 73677, '\P{Nv:   1.500e-01}', "");
    Expect(1, 73677, '\P{^Nv:   1.500e-01}', "");
    Expect(0, 73678, '\p{Nv:   1.500e-01}', "");
    Expect(1, 73678, '\p{^Nv:   1.500e-01}', "");
    Expect(1, 73678, '\P{Nv:   1.500e-01}', "");
    Expect(0, 73678, '\P{^Nv:   1.500e-01}', "");
    Expect(1, 73677, '\p{Nv=0.150}', "");
    Expect(0, 73677, '\p{^Nv=0.150}', "");
    Expect(0, 73677, '\P{Nv=0.150}', "");
    Expect(1, 73677, '\P{^Nv=0.150}', "");
    Expect(0, 73678, '\p{Nv=0.150}', "");
    Expect(1, 73678, '\p{^Nv=0.150}', "");
    Expect(1, 73678, '\P{Nv=0.150}', "");
    Expect(0, 73678, '\P{^Nv=0.150}', "");
    Error('\p{Is_Numeric_Value= :=+0000000003/0000000020}');
    Error('\P{Is_Numeric_Value= :=+0000000003/0000000020}');
    Expect(1, 73677, '\p{Is_Numeric_Value=3/000020}', "");
    Expect(0, 73677, '\p{^Is_Numeric_Value=3/000020}', "");
    Expect(0, 73677, '\P{Is_Numeric_Value=3/000020}', "");
    Expect(1, 73677, '\P{^Is_Numeric_Value=3/000020}', "");
    Expect(0, 73678, '\p{Is_Numeric_Value=3/000020}', "");
    Expect(1, 73678, '\p{^Is_Numeric_Value=3/000020}', "");
    Expect(1, 73678, '\P{Is_Numeric_Value=3/000020}', "");
    Expect(0, 73678, '\P{^Is_Numeric_Value=3/000020}', "");
    Expect(1, 73677, '\p{Is_Numeric_Value=180/1200}', "");
    Expect(0, 73677, '\p{^Is_Numeric_Value=180/1200}', "");
    Expect(0, 73677, '\P{Is_Numeric_Value=180/1200}', "");
    Expect(1, 73677, '\P{^Is_Numeric_Value=180/1200}', "");
    Expect(0, 73678, '\p{Is_Numeric_Value=180/1200}', "");
    Expect(1, 73678, '\p{^Is_Numeric_Value=180/1200}', "");
    Expect(1, 73678, '\P{Is_Numeric_Value=180/1200}', "");
    Expect(0, 73678, '\P{^Is_Numeric_Value=180/1200}', "");
    Expect(1, 73677, '\p{Is_Numeric_Value=1.5e-01}', "");
    Expect(0, 73677, '\p{^Is_Numeric_Value=1.5e-01}', "");
    Expect(0, 73677, '\P{Is_Numeric_Value=1.5e-01}', "");
    Expect(1, 73677, '\P{^Is_Numeric_Value=1.5e-01}', "");
    Expect(0, 73678, '\p{Is_Numeric_Value=1.5e-01}', "");
    Expect(1, 73678, '\p{^Is_Numeric_Value=1.5e-01}', "");
    Expect(1, 73678, '\P{Is_Numeric_Value=1.5e-01}', "");
    Expect(0, 73678, '\P{^Is_Numeric_Value=1.5e-01}', "");
    Expect(1, 73677, '\p{Is_Numeric_Value=1.50e-01}', "");
    Expect(0, 73677, '\p{^Is_Numeric_Value=1.50e-01}', "");
    Expect(0, 73677, '\P{Is_Numeric_Value=1.50e-01}', "");
    Expect(1, 73677, '\P{^Is_Numeric_Value=1.50e-01}', "");
    Expect(0, 73678, '\p{Is_Numeric_Value=1.50e-01}', "");
    Expect(1, 73678, '\p{^Is_Numeric_Value=1.50e-01}', "");
    Expect(1, 73678, '\P{Is_Numeric_Value=1.50e-01}', "");
    Expect(0, 73678, '\P{^Is_Numeric_Value=1.50e-01}', "");
    Expect(1, 73677, '\p{Is_Numeric_Value=0.15}', "");
    Expect(0, 73677, '\p{^Is_Numeric_Value=0.15}', "");
    Expect(0, 73677, '\P{Is_Numeric_Value=0.15}', "");
    Expect(1, 73677, '\P{^Is_Numeric_Value=0.15}', "");
    Expect(0, 73678, '\p{Is_Numeric_Value=0.15}', "");
    Expect(1, 73678, '\p{^Is_Numeric_Value=0.15}', "");
    Expect(1, 73678, '\P{Is_Numeric_Value=0.15}', "");
    Expect(0, 73678, '\P{^Is_Numeric_Value=0.15}', "");
    Expect(1, 73677, '\p{Is_Numeric_Value=1.500e-01}', "");
    Expect(0, 73677, '\p{^Is_Numeric_Value=1.500e-01}', "");
    Expect(0, 73677, '\P{Is_Numeric_Value=1.500e-01}', "");
    Expect(1, 73677, '\P{^Is_Numeric_Value=1.500e-01}', "");
    Expect(0, 73678, '\p{Is_Numeric_Value=1.500e-01}', "");
    Expect(1, 73678, '\p{^Is_Numeric_Value=1.500e-01}', "");
    Expect(1, 73678, '\P{Is_Numeric_Value=1.500e-01}', "");
    Expect(0, 73678, '\P{^Is_Numeric_Value=1.500e-01}', "");
    Expect(1, 73677, '\p{Is_Numeric_Value=0.150}', "");
    Expect(0, 73677, '\p{^Is_Numeric_Value=0.150}', "");
    Expect(0, 73677, '\P{Is_Numeric_Value=0.150}', "");
    Expect(1, 73677, '\P{^Is_Numeric_Value=0.150}', "");
    Expect(0, 73678, '\p{Is_Numeric_Value=0.150}', "");
    Expect(1, 73678, '\p{^Is_Numeric_Value=0.150}', "");
    Expect(1, 73678, '\P{Is_Numeric_Value=0.150}', "");
    Expect(0, 73678, '\P{^Is_Numeric_Value=0.150}', "");
    Error('\p{Is_Nv=_+000000003/0000020/a/}');
    Error('\P{Is_Nv=_+000000003/0000020/a/}');
    Expect(1, 73677, '\p{Is_Nv=00003/20}', "");
    Expect(0, 73677, '\p{^Is_Nv=00003/20}', "");
    Expect(0, 73677, '\P{Is_Nv=00003/20}', "");
    Expect(1, 73677, '\P{^Is_Nv=00003/20}', "");
    Expect(0, 73678, '\p{Is_Nv=00003/20}', "");
    Expect(1, 73678, '\p{^Is_Nv=00003/20}', "");
    Expect(1, 73678, '\P{Is_Nv=00003/20}', "");
    Expect(0, 73678, '\P{^Is_Nv=00003/20}', "");
    Expect(1, 73677, '\p{Is_Nv=180/1200}', "");
    Expect(0, 73677, '\p{^Is_Nv=180/1200}', "");
    Expect(0, 73677, '\P{Is_Nv=180/1200}', "");
    Expect(1, 73677, '\P{^Is_Nv=180/1200}', "");
    Expect(0, 73678, '\p{Is_Nv=180/1200}', "");
    Expect(1, 73678, '\p{^Is_Nv=180/1200}', "");
    Expect(1, 73678, '\P{Is_Nv=180/1200}', "");
    Expect(0, 73678, '\P{^Is_Nv=180/1200}', "");
    Expect(1, 73677, '\p{Is_Nv=1.5e-01}', "");
    Expect(0, 73677, '\p{^Is_Nv=1.5e-01}', "");
    Expect(0, 73677, '\P{Is_Nv=1.5e-01}', "");
    Expect(1, 73677, '\P{^Is_Nv=1.5e-01}', "");
    Expect(0, 73678, '\p{Is_Nv=1.5e-01}', "");
    Expect(1, 73678, '\p{^Is_Nv=1.5e-01}', "");
    Expect(1, 73678, '\P{Is_Nv=1.5e-01}', "");
    Expect(0, 73678, '\P{^Is_Nv=1.5e-01}', "");
    Expect(1, 73677, '\p{Is_Nv=1.50e-01}', "");
    Expect(0, 73677, '\p{^Is_Nv=1.50e-01}', "");
    Expect(0, 73677, '\P{Is_Nv=1.50e-01}', "");
    Expect(1, 73677, '\P{^Is_Nv=1.50e-01}', "");
    Expect(0, 73678, '\p{Is_Nv=1.50e-01}', "");
    Expect(1, 73678, '\p{^Is_Nv=1.50e-01}', "");
    Expect(1, 73678, '\P{Is_Nv=1.50e-01}', "");
    Expect(0, 73678, '\P{^Is_Nv=1.50e-01}', "");
    Expect(1, 73677, '\p{Is_Nv=0.15}', "");
    Expect(0, 73677, '\p{^Is_Nv=0.15}', "");
    Expect(0, 73677, '\P{Is_Nv=0.15}', "");
    Expect(1, 73677, '\P{^Is_Nv=0.15}', "");
    Expect(0, 73678, '\p{Is_Nv=0.15}', "");
    Expect(1, 73678, '\p{^Is_Nv=0.15}', "");
    Expect(1, 73678, '\P{Is_Nv=0.15}', "");
    Expect(0, 73678, '\P{^Is_Nv=0.15}', "");
    Expect(1, 73677, '\p{Is_Nv=1.500e-01}', "");
    Expect(0, 73677, '\p{^Is_Nv=1.500e-01}', "");
    Expect(0, 73677, '\P{Is_Nv=1.500e-01}', "");
    Expect(1, 73677, '\P{^Is_Nv=1.500e-01}', "");
    Expect(0, 73678, '\p{Is_Nv=1.500e-01}', "");
    Expect(1, 73678, '\p{^Is_Nv=1.500e-01}', "");
    Expect(1, 73678, '\P{Is_Nv=1.500e-01}', "");
    Expect(0, 73678, '\P{^Is_Nv=1.500e-01}', "");
    Expect(1, 73677, '\p{Is_Nv=0.150}', "");
    Expect(0, 73677, '\p{^Is_Nv=0.150}', "");
    Expect(0, 73677, '\P{Is_Nv=0.150}', "");
    Expect(1, 73677, '\P{^Is_Nv=0.150}', "");
    Expect(0, 73678, '\p{Is_Nv=0.150}', "");
    Expect(1, 73678, '\p{^Is_Nv=0.150}', "");
    Expect(1, 73678, '\P{Is_Nv=0.150}', "");
    Expect(0, 73678, '\P{^Is_Nv=0.150}', "");
    Error('\p{Numeric_Value=  0000003/4:=}');
    Error('\P{Numeric_Value=  0000003/4:=}');
    Expect(1, 126127, '\p{Numeric_Value=:\A3/4\z:}', "");;
    Expect(0, 126128, '\p{Numeric_Value=:\A3/4\z:}', "");;
    Expect(1, 126127, '\p{Numeric_Value=0000003/00000004}', "");
    Expect(0, 126127, '\p{^Numeric_Value=0000003/00000004}', "");
    Expect(0, 126127, '\P{Numeric_Value=0000003/00000004}', "");
    Expect(1, 126127, '\P{^Numeric_Value=0000003/00000004}', "");
    Expect(0, 126128, '\p{Numeric_Value=0000003/00000004}', "");
    Expect(1, 126128, '\p{^Numeric_Value=0000003/00000004}', "");
    Expect(1, 126128, '\P{Numeric_Value=0000003/00000004}', "");
    Expect(0, 126128, '\P{^Numeric_Value=0000003/00000004}', "");
    Expect(1, 126127, '\p{Numeric_Value=180/240}', "");
    Expect(0, 126127, '\p{^Numeric_Value=180/240}', "");
    Expect(0, 126127, '\P{Numeric_Value=180/240}', "");
    Expect(1, 126127, '\P{^Numeric_Value=180/240}', "");
    Expect(0, 126128, '\p{Numeric_Value=180/240}', "");
    Expect(1, 126128, '\p{^Numeric_Value=180/240}', "");
    Expect(1, 126128, '\P{Numeric_Value=180/240}', "");
    Expect(0, 126128, '\P{^Numeric_Value=180/240}', "");
    Expect(1, 126127, '\p{Numeric_Value=7.5e-01}', "");
    Expect(0, 126127, '\p{^Numeric_Value=7.5e-01}', "");
    Expect(0, 126127, '\P{Numeric_Value=7.5e-01}', "");
    Expect(1, 126127, '\P{^Numeric_Value=7.5e-01}', "");
    Expect(0, 126128, '\p{Numeric_Value=7.5e-01}', "");
    Expect(1, 126128, '\p{^Numeric_Value=7.5e-01}', "");
    Expect(1, 126128, '\P{Numeric_Value=7.5e-01}', "");
    Expect(0, 126128, '\P{^Numeric_Value=7.5e-01}', "");
    Expect(1, 126127, '\p{Numeric_Value=7.50e-01}', "");
    Expect(0, 126127, '\p{^Numeric_Value=7.50e-01}', "");
    Expect(0, 126127, '\P{Numeric_Value=7.50e-01}', "");
    Expect(1, 126127, '\P{^Numeric_Value=7.50e-01}', "");
    Expect(0, 126128, '\p{Numeric_Value=7.50e-01}', "");
    Expect(1, 126128, '\p{^Numeric_Value=7.50e-01}', "");
    Expect(1, 126128, '\P{Numeric_Value=7.50e-01}', "");
    Expect(0, 126128, '\P{^Numeric_Value=7.50e-01}', "");
    Expect(1, 126127, '\p{Numeric_Value=0.75}', "");
    Expect(0, 126127, '\p{^Numeric_Value=0.75}', "");
    Expect(0, 126127, '\P{Numeric_Value=0.75}', "");
    Expect(1, 126127, '\P{^Numeric_Value=0.75}', "");
    Expect(0, 126128, '\p{Numeric_Value=0.75}', "");
    Expect(1, 126128, '\p{^Numeric_Value=0.75}', "");
    Expect(1, 126128, '\P{Numeric_Value=0.75}', "");
    Expect(0, 126128, '\P{^Numeric_Value=0.75}', "");
    Expect(1, 126127, '\p{Numeric_Value=7.500e-01}', "");
    Expect(0, 126127, '\p{^Numeric_Value=7.500e-01}', "");
    Expect(0, 126127, '\P{Numeric_Value=7.500e-01}', "");
    Expect(1, 126127, '\P{^Numeric_Value=7.500e-01}', "");
    Expect(0, 126128, '\p{Numeric_Value=7.500e-01}', "");
    Expect(1, 126128, '\p{^Numeric_Value=7.500e-01}', "");
    Expect(1, 126128, '\P{Numeric_Value=7.500e-01}', "");
    Expect(0, 126128, '\P{^Numeric_Value=7.500e-01}', "");
    Expect(1, 126127, '\p{Numeric_Value=0.750}', "");
    Expect(0, 126127, '\p{^Numeric_Value=0.750}', "");
    Expect(0, 126127, '\P{Numeric_Value=0.750}', "");
    Expect(1, 126127, '\P{^Numeric_Value=0.750}', "");
    Expect(0, 126128, '\p{Numeric_Value=0.750}', "");
    Expect(1, 126128, '\p{^Numeric_Value=0.750}', "");
    Expect(1, 126128, '\P{Numeric_Value=0.750}', "");
    Expect(0, 126128, '\P{^Numeric_Value=0.750}', "");
    Error('\p{Nv=_/a/00003/00000004}');
    Error('\P{Nv=_/a/00003/00000004}');
    Expect(1, 126127, '\p{Nv=:\A3/4\z:}', "");;
    Expect(0, 126128, '\p{Nv=:\A3/4\z:}', "");;
    Expect(1, 126127, '\p{Nv=0000003/4}', "");
    Expect(0, 126127, '\p{^Nv=0000003/4}', "");
    Expect(0, 126127, '\P{Nv=0000003/4}', "");
    Expect(1, 126127, '\P{^Nv=0000003/4}', "");
    Expect(0, 126128, '\p{Nv=0000003/4}', "");
    Expect(1, 126128, '\p{^Nv=0000003/4}', "");
    Expect(1, 126128, '\P{Nv=0000003/4}', "");
    Expect(0, 126128, '\P{^Nv=0000003/4}', "");
    Expect(1, 126127, '\p{Nv=180/240}', "");
    Expect(0, 126127, '\p{^Nv=180/240}', "");
    Expect(0, 126127, '\P{Nv=180/240}', "");
    Expect(1, 126127, '\P{^Nv=180/240}', "");
    Expect(0, 126128, '\p{Nv=180/240}', "");
    Expect(1, 126128, '\p{^Nv=180/240}', "");
    Expect(1, 126128, '\P{Nv=180/240}', "");
    Expect(0, 126128, '\P{^Nv=180/240}', "");
    Expect(1, 126127, '\p{Nv=7.5e-01}', "");
    Expect(0, 126127, '\p{^Nv=7.5e-01}', "");
    Expect(0, 126127, '\P{Nv=7.5e-01}', "");
    Expect(1, 126127, '\P{^Nv=7.5e-01}', "");
    Expect(0, 126128, '\p{Nv=7.5e-01}', "");
    Expect(1, 126128, '\p{^Nv=7.5e-01}', "");
    Expect(1, 126128, '\P{Nv=7.5e-01}', "");
    Expect(0, 126128, '\P{^Nv=7.5e-01}', "");
    Expect(1, 126127, '\p{Nv=7.50e-01}', "");
    Expect(0, 126127, '\p{^Nv=7.50e-01}', "");
    Expect(0, 126127, '\P{Nv=7.50e-01}', "");
    Expect(1, 126127, '\P{^Nv=7.50e-01}', "");
    Expect(0, 126128, '\p{Nv=7.50e-01}', "");
    Expect(1, 126128, '\p{^Nv=7.50e-01}', "");
    Expect(1, 126128, '\P{Nv=7.50e-01}', "");
    Expect(0, 126128, '\P{^Nv=7.50e-01}', "");
    Expect(1, 126127, '\p{Nv:	0.75}', "");
    Expect(0, 126127, '\p{^Nv:	0.75}', "");
    Expect(0, 126127, '\P{Nv:	0.75}', "");
    Expect(1, 126127, '\P{^Nv:	0.75}', "");
    Expect(0, 126128, '\p{Nv:	0.75}', "");
    Expect(1, 126128, '\p{^Nv:	0.75}', "");
    Expect(1, 126128, '\P{Nv:	0.75}', "");
    Expect(0, 126128, '\P{^Nv:	0.75}', "");
    Expect(1, 126127, '\p{Nv=7.500e-01}', "");
    Expect(0, 126127, '\p{^Nv=7.500e-01}', "");
    Expect(0, 126127, '\P{Nv=7.500e-01}', "");
    Expect(1, 126127, '\P{^Nv=7.500e-01}', "");
    Expect(0, 126128, '\p{Nv=7.500e-01}', "");
    Expect(1, 126128, '\p{^Nv=7.500e-01}', "");
    Expect(1, 126128, '\P{Nv=7.500e-01}', "");
    Expect(0, 126128, '\P{^Nv=7.500e-01}', "");
    Expect(1, 126127, '\p{Nv:   0.750}', "");
    Expect(0, 126127, '\p{^Nv:   0.750}', "");
    Expect(0, 126127, '\P{Nv:   0.750}', "");
    Expect(1, 126127, '\P{^Nv:   0.750}', "");
    Expect(0, 126128, '\p{Nv:   0.750}', "");
    Expect(1, 126128, '\p{^Nv:   0.750}', "");
    Expect(1, 126128, '\P{Nv:   0.750}', "");
    Expect(0, 126128, '\P{^Nv:   0.750}', "");
    Error('\p{Is_Numeric_Value= :=+003/0000004}');
    Error('\P{Is_Numeric_Value= :=+003/0000004}');
    Expect(1, 126127, '\p{Is_Numeric_Value=00000003/000000004}', "");
    Expect(0, 126127, '\p{^Is_Numeric_Value=00000003/000000004}', "");
    Expect(0, 126127, '\P{Is_Numeric_Value=00000003/000000004}', "");
    Expect(1, 126127, '\P{^Is_Numeric_Value=00000003/000000004}', "");
    Expect(0, 126128, '\p{Is_Numeric_Value=00000003/000000004}', "");
    Expect(1, 126128, '\p{^Is_Numeric_Value=00000003/000000004}', "");
    Expect(1, 126128, '\P{Is_Numeric_Value=00000003/000000004}', "");
    Expect(0, 126128, '\P{^Is_Numeric_Value=00000003/000000004}', "");
    Expect(1, 126127, '\p{Is_Numeric_Value=180/240}', "");
    Expect(0, 126127, '\p{^Is_Numeric_Value=180/240}', "");
    Expect(0, 126127, '\P{Is_Numeric_Value=180/240}', "");
    Expect(1, 126127, '\P{^Is_Numeric_Value=180/240}', "");
    Expect(0, 126128, '\p{Is_Numeric_Value=180/240}', "");
    Expect(1, 126128, '\p{^Is_Numeric_Value=180/240}', "");
    Expect(1, 126128, '\P{Is_Numeric_Value=180/240}', "");
    Expect(0, 126128, '\P{^Is_Numeric_Value=180/240}', "");
    Expect(1, 126127, '\p{Is_Numeric_Value=7.5e-01}', "");
    Expect(0, 126127, '\p{^Is_Numeric_Value=7.5e-01}', "");
    Expect(0, 126127, '\P{Is_Numeric_Value=7.5e-01}', "");
    Expect(1, 126127, '\P{^Is_Numeric_Value=7.5e-01}', "");
    Expect(0, 126128, '\p{Is_Numeric_Value=7.5e-01}', "");
    Expect(1, 126128, '\p{^Is_Numeric_Value=7.5e-01}', "");
    Expect(1, 126128, '\P{Is_Numeric_Value=7.5e-01}', "");
    Expect(0, 126128, '\P{^Is_Numeric_Value=7.5e-01}', "");
    Expect(1, 126127, '\p{Is_Numeric_Value=7.50e-01}', "");
    Expect(0, 126127, '\p{^Is_Numeric_Value=7.50e-01}', "");
    Expect(0, 126127, '\P{Is_Numeric_Value=7.50e-01}', "");
    Expect(1, 126127, '\P{^Is_Numeric_Value=7.50e-01}', "");
    Expect(0, 126128, '\p{Is_Numeric_Value=7.50e-01}', "");
    Expect(1, 126128, '\p{^Is_Numeric_Value=7.50e-01}', "");
    Expect(1, 126128, '\P{Is_Numeric_Value=7.50e-01}', "");
    Expect(0, 126128, '\P{^Is_Numeric_Value=7.50e-01}', "");
    Expect(1, 126127, '\p{Is_Numeric_Value=0.75}', "");
    Expect(0, 126127, '\p{^Is_Numeric_Value=0.75}', "");
    Expect(0, 126127, '\P{Is_Numeric_Value=0.75}', "");
    Expect(1, 126127, '\P{^Is_Numeric_Value=0.75}', "");
    Expect(0, 126128, '\p{Is_Numeric_Value=0.75}', "");
    Expect(1, 126128, '\p{^Is_Numeric_Value=0.75}', "");
    Expect(1, 126128, '\P{Is_Numeric_Value=0.75}', "");
    Expect(0, 126128, '\P{^Is_Numeric_Value=0.75}', "");
    Expect(1, 126127, '\p{Is_Numeric_Value=7.500e-01}', "");
    Expect(0, 126127, '\p{^Is_Numeric_Value=7.500e-01}', "");
    Expect(0, 126127, '\P{Is_Numeric_Value=7.500e-01}', "");
    Expect(1, 126127, '\P{^Is_Numeric_Value=7.500e-01}', "");
    Expect(0, 126128, '\p{Is_Numeric_Value=7.500e-01}', "");
    Expect(1, 126128, '\p{^Is_Numeric_Value=7.500e-01}', "");
    Expect(1, 126128, '\P{Is_Numeric_Value=7.500e-01}', "");
    Expect(0, 126128, '\P{^Is_Numeric_Value=7.500e-01}', "");
    Expect(1, 126127, '\p{Is_Numeric_Value=0.750}', "");
    Expect(0, 126127, '\p{^Is_Numeric_Value=0.750}', "");
    Expect(0, 126127, '\P{Is_Numeric_Value=0.750}', "");
    Expect(1, 126127, '\P{^Is_Numeric_Value=0.750}', "");
    Expect(0, 126128, '\p{Is_Numeric_Value=0.750}', "");
    Expect(1, 126128, '\p{^Is_Numeric_Value=0.750}', "");
    Expect(1, 126128, '\P{Is_Numeric_Value=0.750}', "");
    Expect(0, 126128, '\P{^Is_Numeric_Value=0.750}', "");
    Error('\p{Is_Nv=:= +0003/00004}');
    Error('\P{Is_Nv=:= +0003/00004}');
    Expect(1, 126127, '\p{Is_Nv=00003/00004}', "");
    Expect(0, 126127, '\p{^Is_Nv=00003/00004}', "");
    Expect(0, 126127, '\P{Is_Nv=00003/00004}', "");
    Expect(1, 126127, '\P{^Is_Nv=00003/00004}', "");
    Expect(0, 126128, '\p{Is_Nv=00003/00004}', "");
    Expect(1, 126128, '\p{^Is_Nv=00003/00004}', "");
    Expect(1, 126128, '\P{Is_Nv=00003/00004}', "");
    Expect(0, 126128, '\P{^Is_Nv=00003/00004}', "");
    Expect(1, 126127, '\p{Is_Nv=180/240}', "");
    Expect(0, 126127, '\p{^Is_Nv=180/240}', "");
    Expect(0, 126127, '\P{Is_Nv=180/240}', "");
    Expect(1, 126127, '\P{^Is_Nv=180/240}', "");
    Expect(0, 126128, '\p{Is_Nv=180/240}', "");
    Expect(1, 126128, '\p{^Is_Nv=180/240}', "");
    Expect(1, 126128, '\P{Is_Nv=180/240}', "");
    Expect(0, 126128, '\P{^Is_Nv=180/240}', "");
    Expect(1, 126127, '\p{Is_Nv=7.5e-01}', "");
    Expect(0, 126127, '\p{^Is_Nv=7.5e-01}', "");
    Expect(0, 126127, '\P{Is_Nv=7.5e-01}', "");
    Expect(1, 126127, '\P{^Is_Nv=7.5e-01}', "");
    Expect(0, 126128, '\p{Is_Nv=7.5e-01}', "");
    Expect(1, 126128, '\p{^Is_Nv=7.5e-01}', "");
    Expect(1, 126128, '\P{Is_Nv=7.5e-01}', "");
    Expect(0, 126128, '\P{^Is_Nv=7.5e-01}', "");
    Expect(1, 126127, '\p{Is_Nv=7.50e-01}', "");
    Expect(0, 126127, '\p{^Is_Nv=7.50e-01}', "");
    Expect(0, 126127, '\P{Is_Nv=7.50e-01}', "");
    Expect(1, 126127, '\P{^Is_Nv=7.50e-01}', "");
    Expect(0, 126128, '\p{Is_Nv=7.50e-01}', "");
    Expect(1, 126128, '\p{^Is_Nv=7.50e-01}', "");
    Expect(1, 126128, '\P{Is_Nv=7.50e-01}', "");
    Expect(0, 126128, '\P{^Is_Nv=7.50e-01}', "");
    Expect(1, 126127, '\p{Is_Nv=0.75}', "");
    Expect(0, 126127, '\p{^Is_Nv=0.75}', "");
    Expect(0, 126127, '\P{Is_Nv=0.75}', "");
    Expect(1, 126127, '\P{^Is_Nv=0.75}', "");
    Expect(0, 126128, '\p{Is_Nv=0.75}', "");
    Expect(1, 126128, '\p{^Is_Nv=0.75}', "");
    Expect(1, 126128, '\P{Is_Nv=0.75}', "");
    Expect(0, 126128, '\P{^Is_Nv=0.75}', "");
    Expect(1, 126127, '\p{Is_Nv=7.500e-01}', "");
    Expect(0, 126127, '\p{^Is_Nv=7.500e-01}', "");
    Expect(0, 126127, '\P{Is_Nv=7.500e-01}', "");
    Expect(1, 126127, '\P{^Is_Nv=7.500e-01}', "");
    Expect(0, 126128, '\p{Is_Nv=7.500e-01}', "");
    Expect(1, 126128, '\p{^Is_Nv=7.500e-01}', "");
    Expect(1, 126128, '\P{Is_Nv=7.500e-01}', "");
    Expect(0, 126128, '\P{^Is_Nv=7.500e-01}', "");
    Expect(1, 126127, '\p{Is_Nv:	0.750}', "");
    Expect(0, 126127, '\p{^Is_Nv:	0.750}', "");
    Expect(0, 126127, '\P{Is_Nv:	0.750}', "");
    Expect(1, 126127, '\P{^Is_Nv:	0.750}', "");
    Expect(0, 126128, '\p{Is_Nv:	0.750}', "");
    Expect(1, 126128, '\p{^Is_Nv:	0.750}', "");
    Expect(1, 126128, '\P{Is_Nv:	0.750}', "");
    Expect(0, 126128, '\P{^Is_Nv:	0.750}', "");
    Error('\p{Numeric_Value:	_	+003/00000005/a/}');
    Error('\P{Numeric_Value:	_	+003/00000005/a/}');
    Expect(1, 8535, '\p{Numeric_Value=:\A3/5\z:}', "");;
    Expect(0, 8536, '\p{Numeric_Value=:\A3/5\z:}', "");;
    Expect(1, 8535, '\p{Numeric_Value=000000003/00000005}', "");
    Expect(0, 8535, '\p{^Numeric_Value=000000003/00000005}', "");
    Expect(0, 8535, '\P{Numeric_Value=000000003/00000005}', "");
    Expect(1, 8535, '\P{^Numeric_Value=000000003/00000005}', "");
    Expect(0, 8536, '\p{Numeric_Value=000000003/00000005}', "");
    Expect(1, 8536, '\p{^Numeric_Value=000000003/00000005}', "");
    Expect(1, 8536, '\P{Numeric_Value=000000003/00000005}', "");
    Expect(0, 8536, '\P{^Numeric_Value=000000003/00000005}', "");
    Expect(1, 8535, '\p{Numeric_Value=180/300}', "");
    Expect(0, 8535, '\p{^Numeric_Value=180/300}', "");
    Expect(0, 8535, '\P{Numeric_Value=180/300}', "");
    Expect(1, 8535, '\P{^Numeric_Value=180/300}', "");
    Expect(0, 8536, '\p{Numeric_Value=180/300}', "");
    Expect(1, 8536, '\p{^Numeric_Value=180/300}', "");
    Expect(1, 8536, '\P{Numeric_Value=180/300}', "");
    Expect(0, 8536, '\P{^Numeric_Value=180/300}', "");
    Expect(1, 8535, '\p{Numeric_Value=6.0e-01}', "");
    Expect(0, 8535, '\p{^Numeric_Value=6.0e-01}', "");
    Expect(0, 8535, '\P{Numeric_Value=6.0e-01}', "");
    Expect(1, 8535, '\P{^Numeric_Value=6.0e-01}', "");
    Expect(0, 8536, '\p{Numeric_Value=6.0e-01}', "");
    Expect(1, 8536, '\p{^Numeric_Value=6.0e-01}', "");
    Expect(1, 8536, '\P{Numeric_Value=6.0e-01}', "");
    Expect(0, 8536, '\P{^Numeric_Value=6.0e-01}', "");
    Expect(1, 8535, '\p{Numeric_Value:0.6}', "");
    Expect(0, 8535, '\p{^Numeric_Value:0.6}', "");
    Expect(0, 8535, '\P{Numeric_Value:0.6}', "");
    Expect(1, 8535, '\P{^Numeric_Value:0.6}', "");
    Expect(0, 8536, '\p{Numeric_Value:0.6}', "");
    Expect(1, 8536, '\p{^Numeric_Value:0.6}', "");
    Expect(1, 8536, '\P{Numeric_Value:0.6}', "");
    Expect(0, 8536, '\P{^Numeric_Value:0.6}', "");
    Expect(1, 8535, '\p{Numeric_Value=6.00e-01}', "");
    Expect(0, 8535, '\p{^Numeric_Value=6.00e-01}', "");
    Expect(0, 8535, '\P{Numeric_Value=6.00e-01}', "");
    Expect(1, 8535, '\P{^Numeric_Value=6.00e-01}', "");
    Expect(0, 8536, '\p{Numeric_Value=6.00e-01}', "");
    Expect(1, 8536, '\p{^Numeric_Value=6.00e-01}', "");
    Expect(1, 8536, '\P{Numeric_Value=6.00e-01}', "");
    Expect(0, 8536, '\P{^Numeric_Value=6.00e-01}', "");
    Expect(1, 8535, '\p{Numeric_Value=0.60}', "");
    Expect(0, 8535, '\p{^Numeric_Value=0.60}', "");
    Expect(0, 8535, '\P{Numeric_Value=0.60}', "");
    Expect(1, 8535, '\P{^Numeric_Value=0.60}', "");
    Expect(0, 8536, '\p{Numeric_Value=0.60}', "");
    Expect(1, 8536, '\p{^Numeric_Value=0.60}', "");
    Expect(1, 8536, '\P{Numeric_Value=0.60}', "");
    Expect(0, 8536, '\P{^Numeric_Value=0.60}', "");
    Error('\p{Nv=-:=+00003/05}');
    Error('\P{Nv=-:=+00003/05}');
    Expect(1, 8535, '\p{Nv=:\A3/5\z:}', "");;
    Expect(0, 8536, '\p{Nv=:\A3/5\z:}', "");;
    Expect(1, 8535, '\p{Nv=00003/005}', "");
    Expect(0, 8535, '\p{^Nv=00003/005}', "");
    Expect(0, 8535, '\P{Nv=00003/005}', "");
    Expect(1, 8535, '\P{^Nv=00003/005}', "");
    Expect(0, 8536, '\p{Nv=00003/005}', "");
    Expect(1, 8536, '\p{^Nv=00003/005}', "");
    Expect(1, 8536, '\P{Nv=00003/005}', "");
    Expect(0, 8536, '\P{^Nv=00003/005}', "");
    Expect(1, 8535, '\p{Nv=180/300}', "");
    Expect(0, 8535, '\p{^Nv=180/300}', "");
    Expect(0, 8535, '\P{Nv=180/300}', "");
    Expect(1, 8535, '\P{^Nv=180/300}', "");
    Expect(0, 8536, '\p{Nv=180/300}', "");
    Expect(1, 8536, '\p{^Nv=180/300}', "");
    Expect(1, 8536, '\P{Nv=180/300}', "");
    Expect(0, 8536, '\P{^Nv=180/300}', "");
    Expect(1, 8535, '\p{Nv=6.0e-01}', "");
    Expect(0, 8535, '\p{^Nv=6.0e-01}', "");
    Expect(0, 8535, '\P{Nv=6.0e-01}', "");
    Expect(1, 8535, '\P{^Nv=6.0e-01}', "");
    Expect(0, 8536, '\p{Nv=6.0e-01}', "");
    Expect(1, 8536, '\p{^Nv=6.0e-01}', "");
    Expect(1, 8536, '\P{Nv=6.0e-01}', "");
    Expect(0, 8536, '\P{^Nv=6.0e-01}', "");
    Expect(1, 8535, '\p{Nv=0.6}', "");
    Expect(0, 8535, '\p{^Nv=0.6}', "");
    Expect(0, 8535, '\P{Nv=0.6}', "");
    Expect(1, 8535, '\P{^Nv=0.6}', "");
    Expect(0, 8536, '\p{Nv=0.6}', "");
    Expect(1, 8536, '\p{^Nv=0.6}', "");
    Expect(1, 8536, '\P{Nv=0.6}', "");
    Expect(0, 8536, '\P{^Nv=0.6}', "");
    Expect(1, 8535, '\p{Nv=6.00e-01}', "");
    Expect(0, 8535, '\p{^Nv=6.00e-01}', "");
    Expect(0, 8535, '\P{Nv=6.00e-01}', "");
    Expect(1, 8535, '\P{^Nv=6.00e-01}', "");
    Expect(0, 8536, '\p{Nv=6.00e-01}', "");
    Expect(1, 8536, '\p{^Nv=6.00e-01}', "");
    Expect(1, 8536, '\P{Nv=6.00e-01}', "");
    Expect(0, 8536, '\P{^Nv=6.00e-01}', "");
    Expect(1, 8535, '\p{Nv=0.60}', "");
    Expect(0, 8535, '\p{^Nv=0.60}', "");
    Expect(0, 8535, '\P{Nv=0.60}', "");
    Expect(1, 8535, '\P{^Nv=0.60}', "");
    Expect(0, 8536, '\p{Nv=0.60}', "");
    Expect(1, 8536, '\p{^Nv=0.60}', "");
    Expect(1, 8536, '\P{Nv=0.60}', "");
    Expect(0, 8536, '\P{^Nv=0.60}', "");
    Error('\p{Is_Numeric_Value=_-003/000000005/a/}');
    Error('\P{Is_Numeric_Value=_-003/000000005/a/}');
    Expect(1, 8535, '\p{Is_Numeric_Value=0000000003/0005}', "");
    Expect(0, 8535, '\p{^Is_Numeric_Value=0000000003/0005}', "");
    Expect(0, 8535, '\P{Is_Numeric_Value=0000000003/0005}', "");
    Expect(1, 8535, '\P{^Is_Numeric_Value=0000000003/0005}', "");
    Expect(0, 8536, '\p{Is_Numeric_Value=0000000003/0005}', "");
    Expect(1, 8536, '\p{^Is_Numeric_Value=0000000003/0005}', "");
    Expect(1, 8536, '\P{Is_Numeric_Value=0000000003/0005}', "");
    Expect(0, 8536, '\P{^Is_Numeric_Value=0000000003/0005}', "");
    Expect(1, 8535, '\p{Is_Numeric_Value=180/300}', "");
    Expect(0, 8535, '\p{^Is_Numeric_Value=180/300}', "");
    Expect(0, 8535, '\P{Is_Numeric_Value=180/300}', "");
    Expect(1, 8535, '\P{^Is_Numeric_Value=180/300}', "");
    Expect(0, 8536, '\p{Is_Numeric_Value=180/300}', "");
    Expect(1, 8536, '\p{^Is_Numeric_Value=180/300}', "");
    Expect(1, 8536, '\P{Is_Numeric_Value=180/300}', "");
    Expect(0, 8536, '\P{^Is_Numeric_Value=180/300}', "");
    Expect(1, 8535, '\p{Is_Numeric_Value=6.0e-01}', "");
    Expect(0, 8535, '\p{^Is_Numeric_Value=6.0e-01}', "");
    Expect(0, 8535, '\P{Is_Numeric_Value=6.0e-01}', "");
    Expect(1, 8535, '\P{^Is_Numeric_Value=6.0e-01}', "");
    Expect(0, 8536, '\p{Is_Numeric_Value=6.0e-01}', "");
    Expect(1, 8536, '\p{^Is_Numeric_Value=6.0e-01}', "");
    Expect(1, 8536, '\P{Is_Numeric_Value=6.0e-01}', "");
    Expect(0, 8536, '\P{^Is_Numeric_Value=6.0e-01}', "");
    Expect(1, 8535, '\p{Is_Numeric_Value=0.6}', "");
    Expect(0, 8535, '\p{^Is_Numeric_Value=0.6}', "");
    Expect(0, 8535, '\P{Is_Numeric_Value=0.6}', "");
    Expect(1, 8535, '\P{^Is_Numeric_Value=0.6}', "");
    Expect(0, 8536, '\p{Is_Numeric_Value=0.6}', "");
    Expect(1, 8536, '\p{^Is_Numeric_Value=0.6}', "");
    Expect(1, 8536, '\P{Is_Numeric_Value=0.6}', "");
    Expect(0, 8536, '\P{^Is_Numeric_Value=0.6}', "");
    Expect(1, 8535, '\p{Is_Numeric_Value=6.00e-01}', "");
    Expect(0, 8535, '\p{^Is_Numeric_Value=6.00e-01}', "");
    Expect(0, 8535, '\P{Is_Numeric_Value=6.00e-01}', "");
    Expect(1, 8535, '\P{^Is_Numeric_Value=6.00e-01}', "");
    Expect(0, 8536, '\p{Is_Numeric_Value=6.00e-01}', "");
    Expect(1, 8536, '\p{^Is_Numeric_Value=6.00e-01}', "");
    Expect(1, 8536, '\P{Is_Numeric_Value=6.00e-01}', "");
    Expect(0, 8536, '\P{^Is_Numeric_Value=6.00e-01}', "");
    Expect(1, 8535, '\p{Is_Numeric_Value:	0.60}', "");
    Expect(0, 8535, '\p{^Is_Numeric_Value:	0.60}', "");
    Expect(0, 8535, '\P{Is_Numeric_Value:	0.60}', "");
    Expect(1, 8535, '\P{^Is_Numeric_Value:	0.60}', "");
    Expect(0, 8536, '\p{Is_Numeric_Value:	0.60}', "");
    Expect(1, 8536, '\p{^Is_Numeric_Value:	0.60}', "");
    Expect(1, 8536, '\P{Is_Numeric_Value:	0.60}', "");
    Expect(0, 8536, '\P{^Is_Numeric_Value:	0.60}', "");
    Error('\p{Is_Nv= :=0003/0005}');
    Error('\P{Is_Nv= :=0003/0005}');
    Expect(1, 8535, '\p{Is_Nv=003/5}', "");
    Expect(0, 8535, '\p{^Is_Nv=003/5}', "");
    Expect(0, 8535, '\P{Is_Nv=003/5}', "");
    Expect(1, 8535, '\P{^Is_Nv=003/5}', "");
    Expect(0, 8536, '\p{Is_Nv=003/5}', "");
    Expect(1, 8536, '\p{^Is_Nv=003/5}', "");
    Expect(1, 8536, '\P{Is_Nv=003/5}', "");
    Expect(0, 8536, '\P{^Is_Nv=003/5}', "");
    Expect(1, 8535, '\p{Is_Nv=180/300}', "");
    Expect(0, 8535, '\p{^Is_Nv=180/300}', "");
    Expect(0, 8535, '\P{Is_Nv=180/300}', "");
    Expect(1, 8535, '\P{^Is_Nv=180/300}', "");
    Expect(0, 8536, '\p{Is_Nv=180/300}', "");
    Expect(1, 8536, '\p{^Is_Nv=180/300}', "");
    Expect(1, 8536, '\P{Is_Nv=180/300}', "");
    Expect(0, 8536, '\P{^Is_Nv=180/300}', "");
    Expect(1, 8535, '\p{Is_Nv=6.0e-01}', "");
    Expect(0, 8535, '\p{^Is_Nv=6.0e-01}', "");
    Expect(0, 8535, '\P{Is_Nv=6.0e-01}', "");
    Expect(1, 8535, '\P{^Is_Nv=6.0e-01}', "");
    Expect(0, 8536, '\p{Is_Nv=6.0e-01}', "");
    Expect(1, 8536, '\p{^Is_Nv=6.0e-01}', "");
    Expect(1, 8536, '\P{Is_Nv=6.0e-01}', "");
    Expect(0, 8536, '\P{^Is_Nv=6.0e-01}', "");
    Expect(1, 8535, '\p{Is_Nv=0.6}', "");
    Expect(0, 8535, '\p{^Is_Nv=0.6}', "");
    Expect(0, 8535, '\P{Is_Nv=0.6}', "");
    Expect(1, 8535, '\P{^Is_Nv=0.6}', "");
    Expect(0, 8536, '\p{Is_Nv=0.6}', "");
    Expect(1, 8536, '\p{^Is_Nv=0.6}', "");
    Expect(1, 8536, '\P{Is_Nv=0.6}', "");
    Expect(0, 8536, '\P{^Is_Nv=0.6}', "");
    Expect(1, 8535, '\p{Is_Nv:6.00e-01}', "");
    Expect(0, 8535, '\p{^Is_Nv:6.00e-01}', "");
    Expect(0, 8535, '\P{Is_Nv:6.00e-01}', "");
    Expect(1, 8535, '\P{^Is_Nv:6.00e-01}', "");
    Expect(0, 8536, '\p{Is_Nv:6.00e-01}', "");
    Expect(1, 8536, '\p{^Is_Nv:6.00e-01}', "");
    Expect(1, 8536, '\P{Is_Nv:6.00e-01}', "");
    Expect(0, 8536, '\P{^Is_Nv:6.00e-01}', "");
    Expect(1, 8535, '\p{Is_Nv=0.60}', "");
    Expect(0, 8535, '\p{^Is_Nv=0.60}', "");
    Expect(0, 8535, '\P{Is_Nv=0.60}', "");
    Expect(1, 8535, '\P{^Is_Nv=0.60}', "");
    Expect(0, 8536, '\p{Is_Nv=0.60}', "");
    Expect(1, 8536, '\p{^Is_Nv=0.60}', "");
    Expect(1, 8536, '\P{Is_Nv=0.60}', "");
    Expect(0, 8536, '\P{^Is_Nv=0.60}', "");
    Error('\p{Numeric_Value: /a/000003/0000000064}');
    Error('\P{Numeric_Value: /a/000003/0000000064}');
    Expect(1, 73671, '\p{Numeric_Value=:\A3/64\z:}', "");;
    Expect(0, 73672, '\p{Numeric_Value=:\A3/64\z:}', "");;
    Expect(1, 73671, '\p{Numeric_Value=0000003/00000064}', "");
    Expect(0, 73671, '\p{^Numeric_Value=0000003/00000064}', "");
    Expect(0, 73671, '\P{Numeric_Value=0000003/00000064}', "");
    Expect(1, 73671, '\P{^Numeric_Value=0000003/00000064}', "");
    Expect(0, 73672, '\p{Numeric_Value=0000003/00000064}', "");
    Expect(1, 73672, '\p{^Numeric_Value=0000003/00000064}', "");
    Expect(1, 73672, '\P{Numeric_Value=0000003/00000064}', "");
    Expect(0, 73672, '\P{^Numeric_Value=0000003/00000064}', "");
    Expect(1, 73671, '\p{Numeric_Value=180/3840}', "");
    Expect(0, 73671, '\p{^Numeric_Value=180/3840}', "");
    Expect(0, 73671, '\P{Numeric_Value=180/3840}', "");
    Expect(1, 73671, '\P{^Numeric_Value=180/3840}', "");
    Expect(0, 73672, '\p{Numeric_Value=180/3840}', "");
    Expect(1, 73672, '\p{^Numeric_Value=180/3840}', "");
    Expect(1, 73672, '\P{Numeric_Value=180/3840}', "");
    Expect(0, 73672, '\P{^Numeric_Value=180/3840}', "");
    Error('\p{Numeric_Value=4.7e-02}');
    Error('\P{Numeric_Value=4.7e-02}');
    Expect(1, 73671, '\p{Numeric_Value: 4.69e-02}', "");
    Expect(0, 73671, '\p{^Numeric_Value: 4.69e-02}', "");
    Expect(0, 73671, '\P{Numeric_Value: 4.69e-02}', "");
    Expect(1, 73671, '\P{^Numeric_Value: 4.69e-02}', "");
    Expect(0, 73672, '\p{Numeric_Value: 4.69e-02}', "");
    Expect(1, 73672, '\p{^Numeric_Value: 4.69e-02}', "");
    Expect(1, 73672, '\P{Numeric_Value: 4.69e-02}', "");
    Expect(0, 73672, '\P{^Numeric_Value: 4.69e-02}', "");
    Expect(1, 73671, '\p{Numeric_Value:	4.688e-02}', "");
    Expect(0, 73671, '\p{^Numeric_Value:	4.688e-02}', "");
    Expect(0, 73671, '\P{Numeric_Value:	4.688e-02}', "");
    Expect(1, 73671, '\P{^Numeric_Value:	4.688e-02}', "");
    Expect(0, 73672, '\p{Numeric_Value:	4.688e-02}', "");
    Expect(1, 73672, '\p{^Numeric_Value:	4.688e-02}', "");
    Expect(1, 73672, '\P{Numeric_Value:	4.688e-02}', "");
    Expect(0, 73672, '\P{^Numeric_Value:	4.688e-02}', "");
    Error('\p{Numeric_Value=0.047}');
    Error('\P{Numeric_Value=0.047}');
    Expect(1, 73671, '\p{Numeric_Value=4.6875e-02}', "");
    Expect(0, 73671, '\p{^Numeric_Value=4.6875e-02}', "");
    Expect(0, 73671, '\P{Numeric_Value=4.6875e-02}', "");
    Expect(1, 73671, '\P{^Numeric_Value=4.6875e-02}', "");
    Expect(0, 73672, '\p{Numeric_Value=4.6875e-02}', "");
    Expect(1, 73672, '\p{^Numeric_Value=4.6875e-02}', "");
    Expect(1, 73672, '\P{Numeric_Value=4.6875e-02}', "");
    Expect(0, 73672, '\P{^Numeric_Value=4.6875e-02}', "");
    Expect(1, 73671, '\p{Numeric_Value=0.0469}', "");
    Expect(0, 73671, '\p{^Numeric_Value=0.0469}', "");
    Expect(0, 73671, '\P{Numeric_Value=0.0469}', "");
    Expect(1, 73671, '\P{^Numeric_Value=0.0469}', "");
    Expect(0, 73672, '\p{Numeric_Value=0.0469}', "");
    Expect(1, 73672, '\p{^Numeric_Value=0.0469}', "");
    Expect(1, 73672, '\P{Numeric_Value=0.0469}', "");
    Expect(0, 73672, '\P{^Numeric_Value=0.0469}', "");
    Expect(1, 73671, '\p{Numeric_Value=4.68750e-02}', "");
    Expect(0, 73671, '\p{^Numeric_Value=4.68750e-02}', "");
    Expect(0, 73671, '\P{Numeric_Value=4.68750e-02}', "");
    Expect(1, 73671, '\P{^Numeric_Value=4.68750e-02}', "");
    Expect(0, 73672, '\p{Numeric_Value=4.68750e-02}', "");
    Expect(1, 73672, '\p{^Numeric_Value=4.68750e-02}', "");
    Expect(1, 73672, '\P{Numeric_Value=4.68750e-02}', "");
    Expect(0, 73672, '\P{^Numeric_Value=4.68750e-02}', "");
    Expect(1, 73671, '\p{Numeric_Value=0.04688}', "");
    Expect(0, 73671, '\p{^Numeric_Value=0.04688}', "");
    Expect(0, 73671, '\P{Numeric_Value=0.04688}', "");
    Expect(1, 73671, '\P{^Numeric_Value=0.04688}', "");
    Expect(0, 73672, '\p{Numeric_Value=0.04688}', "");
    Expect(1, 73672, '\p{^Numeric_Value=0.04688}', "");
    Expect(1, 73672, '\P{Numeric_Value=0.04688}', "");
    Expect(0, 73672, '\P{^Numeric_Value=0.04688}', "");
    Error('\p{Nv=  +0000003/00064/a/}');
    Error('\P{Nv=  +0000003/00064/a/}');
    Expect(1, 73671, '\p{Nv=:\A3/64\z:}', "");;
    Expect(0, 73672, '\p{Nv=:\A3/64\z:}', "");;
    Expect(1, 73671, '\p{Nv=0000003/00000000064}', "");
    Expect(0, 73671, '\p{^Nv=0000003/00000000064}', "");
    Expect(0, 73671, '\P{Nv=0000003/00000000064}', "");
    Expect(1, 73671, '\P{^Nv=0000003/00000000064}', "");
    Expect(0, 73672, '\p{Nv=0000003/00000000064}', "");
    Expect(1, 73672, '\p{^Nv=0000003/00000000064}', "");
    Expect(1, 73672, '\P{Nv=0000003/00000000064}', "");
    Expect(0, 73672, '\P{^Nv=0000003/00000000064}', "");
    Expect(1, 73671, '\p{Nv=180/3840}', "");
    Expect(0, 73671, '\p{^Nv=180/3840}', "");
    Expect(0, 73671, '\P{Nv=180/3840}', "");
    Expect(1, 73671, '\P{^Nv=180/3840}', "");
    Expect(0, 73672, '\p{Nv=180/3840}', "");
    Expect(1, 73672, '\p{^Nv=180/3840}', "");
    Expect(1, 73672, '\P{Nv=180/3840}', "");
    Expect(0, 73672, '\P{^Nv=180/3840}', "");
    Error('\p{Nv:   4.7e-02}');
    Error('\P{Nv:   4.7e-02}');
    Expect(1, 73671, '\p{Nv=4.69e-02}', "");
    Expect(0, 73671, '\p{^Nv=4.69e-02}', "");
    Expect(0, 73671, '\P{Nv=4.69e-02}', "");
    Expect(1, 73671, '\P{^Nv=4.69e-02}', "");
    Expect(0, 73672, '\p{Nv=4.69e-02}', "");
    Expect(1, 73672, '\p{^Nv=4.69e-02}', "");
    Expect(1, 73672, '\P{Nv=4.69e-02}', "");
    Expect(0, 73672, '\P{^Nv=4.69e-02}', "");
    Expect(1, 73671, '\p{Nv=4.688e-02}', "");
    Expect(0, 73671, '\p{^Nv=4.688e-02}', "");
    Expect(0, 73671, '\P{Nv=4.688e-02}', "");
    Expect(1, 73671, '\P{^Nv=4.688e-02}', "");
    Expect(0, 73672, '\p{Nv=4.688e-02}', "");
    Expect(1, 73672, '\p{^Nv=4.688e-02}', "");
    Expect(1, 73672, '\P{Nv=4.688e-02}', "");
    Expect(0, 73672, '\P{^Nv=4.688e-02}', "");
    Error('\p{Nv=0.047}');
    Error('\P{Nv=0.047}');
    Expect(1, 73671, '\p{Nv=4.6875e-02}', "");
    Expect(0, 73671, '\p{^Nv=4.6875e-02}', "");
    Expect(0, 73671, '\P{Nv=4.6875e-02}', "");
    Expect(1, 73671, '\P{^Nv=4.6875e-02}', "");
    Expect(0, 73672, '\p{Nv=4.6875e-02}', "");
    Expect(1, 73672, '\p{^Nv=4.6875e-02}', "");
    Expect(1, 73672, '\P{Nv=4.6875e-02}', "");
    Expect(0, 73672, '\P{^Nv=4.6875e-02}', "");
    Expect(1, 73671, '\p{Nv: 0.0469}', "");
    Expect(0, 73671, '\p{^Nv: 0.0469}', "");
    Expect(0, 73671, '\P{Nv: 0.0469}', "");
    Expect(1, 73671, '\P{^Nv: 0.0469}', "");
    Expect(0, 73672, '\p{Nv: 0.0469}', "");
    Expect(1, 73672, '\p{^Nv: 0.0469}', "");
    Expect(1, 73672, '\P{Nv: 0.0469}', "");
    Expect(0, 73672, '\P{^Nv: 0.0469}', "");
    Expect(1, 73671, '\p{Nv: 4.68750e-02}', "");
    Expect(0, 73671, '\p{^Nv: 4.68750e-02}', "");
    Expect(0, 73671, '\P{Nv: 4.68750e-02}', "");
    Expect(1, 73671, '\P{^Nv: 4.68750e-02}', "");
    Expect(0, 73672, '\p{Nv: 4.68750e-02}', "");
    Expect(1, 73672, '\p{^Nv: 4.68750e-02}', "");
    Expect(1, 73672, '\P{Nv: 4.68750e-02}', "");
    Expect(0, 73672, '\P{^Nv: 4.68750e-02}', "");
    Expect(1, 73671, '\p{Nv=0.04688}', "");
    Expect(0, 73671, '\p{^Nv=0.04688}', "");
    Expect(0, 73671, '\P{Nv=0.04688}', "");
    Expect(1, 73671, '\P{^Nv=0.04688}', "");
    Expect(0, 73672, '\p{Nv=0.04688}', "");
    Expect(1, 73672, '\p{^Nv=0.04688}', "");
    Expect(1, 73672, '\P{Nv=0.04688}', "");
    Expect(0, 73672, '\P{^Nv=0.04688}', "");
    Error('\p{Is_Numeric_Value=-+000003/0000064:=}');
    Error('\P{Is_Numeric_Value=-+000003/0000064:=}');
    Expect(1, 73671, '\p{Is_Numeric_Value=3/0000064}', "");
    Expect(0, 73671, '\p{^Is_Numeric_Value=3/0000064}', "");
    Expect(0, 73671, '\P{Is_Numeric_Value=3/0000064}', "");
    Expect(1, 73671, '\P{^Is_Numeric_Value=3/0000064}', "");
    Expect(0, 73672, '\p{Is_Numeric_Value=3/0000064}', "");
    Expect(1, 73672, '\p{^Is_Numeric_Value=3/0000064}', "");
    Expect(1, 73672, '\P{Is_Numeric_Value=3/0000064}', "");
    Expect(0, 73672, '\P{^Is_Numeric_Value=3/0000064}', "");
    Expect(1, 73671, '\p{Is_Numeric_Value=180/3840}', "");
    Expect(0, 73671, '\p{^Is_Numeric_Value=180/3840}', "");
    Expect(0, 73671, '\P{Is_Numeric_Value=180/3840}', "");
    Expect(1, 73671, '\P{^Is_Numeric_Value=180/3840}', "");
    Expect(0, 73672, '\p{Is_Numeric_Value=180/3840}', "");
    Expect(1, 73672, '\p{^Is_Numeric_Value=180/3840}', "");
    Expect(1, 73672, '\P{Is_Numeric_Value=180/3840}', "");
    Expect(0, 73672, '\P{^Is_Numeric_Value=180/3840}', "");
    Error('\p{Is_Numeric_Value=4.7e-02}');
    Error('\P{Is_Numeric_Value=4.7e-02}');
    Expect(1, 73671, '\p{Is_Numeric_Value=4.69e-02}', "");
    Expect(0, 73671, '\p{^Is_Numeric_Value=4.69e-02}', "");
    Expect(0, 73671, '\P{Is_Numeric_Value=4.69e-02}', "");
    Expect(1, 73671, '\P{^Is_Numeric_Value=4.69e-02}', "");
    Expect(0, 73672, '\p{Is_Numeric_Value=4.69e-02}', "");
    Expect(1, 73672, '\p{^Is_Numeric_Value=4.69e-02}', "");
    Expect(1, 73672, '\P{Is_Numeric_Value=4.69e-02}', "");
    Expect(0, 73672, '\P{^Is_Numeric_Value=4.69e-02}', "");
    Expect(1, 73671, '\p{Is_Numeric_Value=4.688e-02}', "");
    Expect(0, 73671, '\p{^Is_Numeric_Value=4.688e-02}', "");
    Expect(0, 73671, '\P{Is_Numeric_Value=4.688e-02}', "");
    Expect(1, 73671, '\P{^Is_Numeric_Value=4.688e-02}', "");
    Expect(0, 73672, '\p{Is_Numeric_Value=4.688e-02}', "");
    Expect(1, 73672, '\p{^Is_Numeric_Value=4.688e-02}', "");
    Expect(1, 73672, '\P{Is_Numeric_Value=4.688e-02}', "");
    Expect(0, 73672, '\P{^Is_Numeric_Value=4.688e-02}', "");
    Error('\p{Is_Numeric_Value=0.047}');
    Error('\P{Is_Numeric_Value=0.047}');
    Expect(1, 73671, '\p{Is_Numeric_Value=4.6875e-02}', "");
    Expect(0, 73671, '\p{^Is_Numeric_Value=4.6875e-02}', "");
    Expect(0, 73671, '\P{Is_Numeric_Value=4.6875e-02}', "");
    Expect(1, 73671, '\P{^Is_Numeric_Value=4.6875e-02}', "");
    Expect(0, 73672, '\p{Is_Numeric_Value=4.6875e-02}', "");
    Expect(1, 73672, '\p{^Is_Numeric_Value=4.6875e-02}', "");
    Expect(1, 73672, '\P{Is_Numeric_Value=4.6875e-02}', "");
    Expect(0, 73672, '\P{^Is_Numeric_Value=4.6875e-02}', "");
    Expect(1, 73671, '\p{Is_Numeric_Value:   0.0469}', "");
    Expect(0, 73671, '\p{^Is_Numeric_Value:   0.0469}', "");
    Expect(0, 73671, '\P{Is_Numeric_Value:   0.0469}', "");
    Expect(1, 73671, '\P{^Is_Numeric_Value:   0.0469}', "");
    Expect(0, 73672, '\p{Is_Numeric_Value:   0.0469}', "");
    Expect(1, 73672, '\p{^Is_Numeric_Value:   0.0469}', "");
    Expect(1, 73672, '\P{Is_Numeric_Value:   0.0469}', "");
    Expect(0, 73672, '\P{^Is_Numeric_Value:   0.0469}', "");
    Expect(1, 73671, '\p{Is_Numeric_Value=4.68750e-02}', "");
    Expect(0, 73671, '\p{^Is_Numeric_Value=4.68750e-02}', "");
    Expect(0, 73671, '\P{Is_Numeric_Value=4.68750e-02}', "");
    Expect(1, 73671, '\P{^Is_Numeric_Value=4.68750e-02}', "");
    Expect(0, 73672, '\p{Is_Numeric_Value=4.68750e-02}', "");
    Expect(1, 73672, '\p{^Is_Numeric_Value=4.68750e-02}', "");
    Expect(1, 73672, '\P{Is_Numeric_Value=4.68750e-02}', "");
    Expect(0, 73672, '\P{^Is_Numeric_Value=4.68750e-02}', "");
    Expect(1, 73671, '\p{Is_Numeric_Value=0.04688}', "");
    Expect(0, 73671, '\p{^Is_Numeric_Value=0.04688}', "");
    Expect(0, 73671, '\P{Is_Numeric_Value=0.04688}', "");
    Expect(1, 73671, '\P{^Is_Numeric_Value=0.04688}', "");
    Expect(0, 73672, '\p{Is_Numeric_Value=0.04688}', "");
    Expect(1, 73672, '\p{^Is_Numeric_Value=0.04688}', "");
    Expect(1, 73672, '\P{Is_Numeric_Value=0.04688}', "");
    Expect(0, 73672, '\P{^Is_Numeric_Value=0.04688}', "");
    Error('\p{Is_Nv=/a/_	0000000003/000000064}');
    Error('\P{Is_Nv=/a/_	0000000003/000000064}');
    Expect(1, 73671, '\p{Is_Nv=0000000003/0000000064}', "");
    Expect(0, 73671, '\p{^Is_Nv=0000000003/0000000064}', "");
    Expect(0, 73671, '\P{Is_Nv=0000000003/0000000064}', "");
    Expect(1, 73671, '\P{^Is_Nv=0000000003/0000000064}', "");
    Expect(0, 73672, '\p{Is_Nv=0000000003/0000000064}', "");
    Expect(1, 73672, '\p{^Is_Nv=0000000003/0000000064}', "");
    Expect(1, 73672, '\P{Is_Nv=0000000003/0000000064}', "");
    Expect(0, 73672, '\P{^Is_Nv=0000000003/0000000064}', "");
    Expect(1, 73671, '\p{Is_Nv=180/3840}', "");
    Expect(0, 73671, '\p{^Is_Nv=180/3840}', "");
    Expect(0, 73671, '\P{Is_Nv=180/3840}', "");
    Expect(1, 73671, '\P{^Is_Nv=180/3840}', "");
    Expect(0, 73672, '\p{Is_Nv=180/3840}', "");
    Expect(1, 73672, '\p{^Is_Nv=180/3840}', "");
    Expect(1, 73672, '\P{Is_Nv=180/3840}', "");
    Expect(0, 73672, '\P{^Is_Nv=180/3840}', "");
    Error('\p{Is_Nv:	4.7e-02}');
    Error('\P{Is_Nv:	4.7e-02}');
    Expect(1, 73671, '\p{Is_Nv=4.69e-02}', "");
    Expect(0, 73671, '\p{^Is_Nv=4.69e-02}', "");
    Expect(0, 73671, '\P{Is_Nv=4.69e-02}', "");
    Expect(1, 73671, '\P{^Is_Nv=4.69e-02}', "");
    Expect(0, 73672, '\p{Is_Nv=4.69e-02}', "");
    Expect(1, 73672, '\p{^Is_Nv=4.69e-02}', "");
    Expect(1, 73672, '\P{Is_Nv=4.69e-02}', "");
    Expect(0, 73672, '\P{^Is_Nv=4.69e-02}', "");
    Expect(1, 73671, '\p{Is_Nv:4.688e-02}', "");
    Expect(0, 73671, '\p{^Is_Nv:4.688e-02}', "");
    Expect(0, 73671, '\P{Is_Nv:4.688e-02}', "");
    Expect(1, 73671, '\P{^Is_Nv:4.688e-02}', "");
    Expect(0, 73672, '\p{Is_Nv:4.688e-02}', "");
    Expect(1, 73672, '\p{^Is_Nv:4.688e-02}', "");
    Expect(1, 73672, '\P{Is_Nv:4.688e-02}', "");
    Expect(0, 73672, '\P{^Is_Nv:4.688e-02}', "");
    Error('\p{Is_Nv=0.047}');
    Error('\P{Is_Nv=0.047}');
    Expect(1, 73671, '\p{Is_Nv=4.6875e-02}', "");
    Expect(0, 73671, '\p{^Is_Nv=4.6875e-02}', "");
    Expect(0, 73671, '\P{Is_Nv=4.6875e-02}', "");
    Expect(1, 73671, '\P{^Is_Nv=4.6875e-02}', "");
    Expect(0, 73672, '\p{Is_Nv=4.6875e-02}', "");
    Expect(1, 73672, '\p{^Is_Nv=4.6875e-02}', "");
    Expect(1, 73672, '\P{Is_Nv=4.6875e-02}', "");
    Expect(0, 73672, '\P{^Is_Nv=4.6875e-02}', "");
    Expect(1, 73671, '\p{Is_Nv=0.0469}', "");
    Expect(0, 73671, '\p{^Is_Nv=0.0469}', "");
    Expect(0, 73671, '\P{Is_Nv=0.0469}', "");
    Expect(1, 73671, '\P{^Is_Nv=0.0469}', "");
    Expect(0, 73672, '\p{Is_Nv=0.0469}', "");
    Expect(1, 73672, '\p{^Is_Nv=0.0469}', "");
    Expect(1, 73672, '\P{Is_Nv=0.0469}', "");
    Expect(0, 73672, '\P{^Is_Nv=0.0469}', "");
    Expect(1, 73671, '\p{Is_Nv=4.68750e-02}', "");
    Expect(0, 73671, '\p{^Is_Nv=4.68750e-02}', "");
    Expect(0, 73671, '\P{Is_Nv=4.68750e-02}', "");
    Expect(1, 73671, '\P{^Is_Nv=4.68750e-02}', "");
    Expect(0, 73672, '\p{Is_Nv=4.68750e-02}', "");
    Expect(1, 73672, '\p{^Is_Nv=4.68750e-02}', "");
    Expect(1, 73672, '\P{Is_Nv=4.68750e-02}', "");
    Expect(0, 73672, '\P{^Is_Nv=4.68750e-02}', "");
    Expect(1, 73671, '\p{Is_Nv:	0.04688}', "");
    Expect(0, 73671, '\p{^Is_Nv:	0.04688}', "");
    Expect(0, 73671, '\P{Is_Nv:	0.04688}', "");
    Expect(1, 73671, '\P{^Is_Nv:	0.04688}', "");
    Expect(0, 73672, '\p{Is_Nv:	0.04688}', "");
    Expect(1, 73672, '\p{^Is_Nv:	0.04688}', "");
    Expect(1, 73672, '\P{Is_Nv:	0.04688}', "");
    Expect(0, 73672, '\P{^Is_Nv:	0.04688}', "");
    Error('\p{Numeric_Value= +000003/0000000008:=}');
    Error('\P{Numeric_Value= +000003/0000000008:=}');
    Expect(1, 8540, '\p{Numeric_Value=:\A3/8\z:}', "");;
    Expect(0, 8541, '\p{Numeric_Value=:\A3/8\z:}', "");;
    Expect(1, 8540, '\p{Numeric_Value=0000003/0000000008}', "");
    Expect(0, 8540, '\p{^Numeric_Value=0000003/0000000008}', "");
    Expect(0, 8540, '\P{Numeric_Value=0000003/0000000008}', "");
    Expect(1, 8540, '\P{^Numeric_Value=0000003/0000000008}', "");
    Expect(0, 8541, '\p{Numeric_Value=0000003/0000000008}', "");
    Expect(1, 8541, '\p{^Numeric_Value=0000003/0000000008}', "");
    Expect(1, 8541, '\P{Numeric_Value=0000003/0000000008}', "");
    Expect(0, 8541, '\P{^Numeric_Value=0000003/0000000008}', "");
    Expect(1, 8540, '\p{Numeric_Value=180/480}', "");
    Expect(0, 8540, '\p{^Numeric_Value=180/480}', "");
    Expect(0, 8540, '\P{Numeric_Value=180/480}', "");
    Expect(1, 8540, '\P{^Numeric_Value=180/480}', "");
    Expect(0, 8541, '\p{Numeric_Value=180/480}', "");
    Expect(1, 8541, '\p{^Numeric_Value=180/480}', "");
    Expect(1, 8541, '\P{Numeric_Value=180/480}', "");
    Expect(0, 8541, '\P{^Numeric_Value=180/480}', "");
    Error('\p{Numeric_Value=3.8e-01}');
    Error('\P{Numeric_Value=3.8e-01}');
    Expect(1, 8540, '\p{Numeric_Value=3.75e-01}', "");
    Expect(0, 8540, '\p{^Numeric_Value=3.75e-01}', "");
    Expect(0, 8540, '\P{Numeric_Value=3.75e-01}', "");
    Expect(1, 8540, '\P{^Numeric_Value=3.75e-01}', "");
    Expect(0, 8541, '\p{Numeric_Value=3.75e-01}', "");
    Expect(1, 8541, '\p{^Numeric_Value=3.75e-01}', "");
    Expect(1, 8541, '\P{Numeric_Value=3.75e-01}', "");
    Expect(0, 8541, '\P{^Numeric_Value=3.75e-01}', "");
    Error('\p{Numeric_Value=0.38}');
    Error('\P{Numeric_Value=0.38}');
    Expect(1, 8540, '\p{Numeric_Value: 3.750e-01}', "");
    Expect(0, 8540, '\p{^Numeric_Value: 3.750e-01}', "");
    Expect(0, 8540, '\P{Numeric_Value: 3.750e-01}', "");
    Expect(1, 8540, '\P{^Numeric_Value: 3.750e-01}', "");
    Expect(0, 8541, '\p{Numeric_Value: 3.750e-01}', "");
    Expect(1, 8541, '\p{^Numeric_Value: 3.750e-01}', "");
    Expect(1, 8541, '\P{Numeric_Value: 3.750e-01}', "");
    Expect(0, 8541, '\P{^Numeric_Value: 3.750e-01}', "");
    Expect(1, 8540, '\p{Numeric_Value=0.375}', "");
    Expect(0, 8540, '\p{^Numeric_Value=0.375}', "");
    Expect(0, 8540, '\P{Numeric_Value=0.375}', "");
    Expect(1, 8540, '\P{^Numeric_Value=0.375}', "");
    Expect(0, 8541, '\p{Numeric_Value=0.375}', "");
    Expect(1, 8541, '\p{^Numeric_Value=0.375}', "");
    Expect(1, 8541, '\P{Numeric_Value=0.375}', "");
    Expect(0, 8541, '\P{^Numeric_Value=0.375}', "");
    Expect(1, 8540, '\p{Numeric_Value=3.7500e-01}', "");
    Expect(0, 8540, '\p{^Numeric_Value=3.7500e-01}', "");
    Expect(0, 8540, '\P{Numeric_Value=3.7500e-01}', "");
    Expect(1, 8540, '\P{^Numeric_Value=3.7500e-01}', "");
    Expect(0, 8541, '\p{Numeric_Value=3.7500e-01}', "");
    Expect(1, 8541, '\p{^Numeric_Value=3.7500e-01}', "");
    Expect(1, 8541, '\P{Numeric_Value=3.7500e-01}', "");
    Expect(0, 8541, '\P{^Numeric_Value=3.7500e-01}', "");
    Expect(1, 8540, '\p{Numeric_Value=0.3750}', "");
    Expect(0, 8540, '\p{^Numeric_Value=0.3750}', "");
    Expect(0, 8540, '\P{Numeric_Value=0.3750}', "");
    Expect(1, 8540, '\P{^Numeric_Value=0.3750}', "");
    Expect(0, 8541, '\p{Numeric_Value=0.3750}', "");
    Expect(1, 8541, '\p{^Numeric_Value=0.3750}', "");
    Expect(1, 8541, '\P{Numeric_Value=0.3750}', "");
    Expect(0, 8541, '\P{^Numeric_Value=0.3750}', "");
    Error('\p{Nv=/a/ +03/8}');
    Error('\P{Nv=/a/ +03/8}');
    Expect(1, 8540, '\p{Nv=:\A3/8\z:}', "");;
    Expect(0, 8541, '\p{Nv=:\A3/8\z:}', "");;
    Expect(1, 8540, '\p{Nv=+00000003/008}', "");
    Expect(0, 8540, '\p{^Nv=+00000003/008}', "");
    Expect(0, 8540, '\P{Nv=+00000003/008}', "");
    Expect(1, 8540, '\P{^Nv=+00000003/008}', "");
    Expect(0, 8541, '\p{Nv=+00000003/008}', "");
    Expect(1, 8541, '\p{^Nv=+00000003/008}', "");
    Expect(1, 8541, '\P{Nv=+00000003/008}', "");
    Expect(0, 8541, '\P{^Nv=+00000003/008}', "");
    Expect(1, 8540, '\p{Nv=180/480}', "");
    Expect(0, 8540, '\p{^Nv=180/480}', "");
    Expect(0, 8540, '\P{Nv=180/480}', "");
    Expect(1, 8540, '\P{^Nv=180/480}', "");
    Expect(0, 8541, '\p{Nv=180/480}', "");
    Expect(1, 8541, '\p{^Nv=180/480}', "");
    Expect(1, 8541, '\P{Nv=180/480}', "");
    Expect(0, 8541, '\P{^Nv=180/480}', "");
    Error('\p{Nv=3.8e-01}');
    Error('\P{Nv=3.8e-01}');
    Expect(1, 8540, '\p{Nv:	3.75e-01}', "");
    Expect(0, 8540, '\p{^Nv:	3.75e-01}', "");
    Expect(0, 8540, '\P{Nv:	3.75e-01}', "");
    Expect(1, 8540, '\P{^Nv:	3.75e-01}', "");
    Expect(0, 8541, '\p{Nv:	3.75e-01}', "");
    Expect(1, 8541, '\p{^Nv:	3.75e-01}', "");
    Expect(1, 8541, '\P{Nv:	3.75e-01}', "");
    Expect(0, 8541, '\P{^Nv:	3.75e-01}', "");
    Error('\p{Nv=0.38}');
    Error('\P{Nv=0.38}');
    Expect(1, 8540, '\p{Nv=3.750e-01}', "");
    Expect(0, 8540, '\p{^Nv=3.750e-01}', "");
    Expect(0, 8540, '\P{Nv=3.750e-01}', "");
    Expect(1, 8540, '\P{^Nv=3.750e-01}', "");
    Expect(0, 8541, '\p{Nv=3.750e-01}', "");
    Expect(1, 8541, '\p{^Nv=3.750e-01}', "");
    Expect(1, 8541, '\P{Nv=3.750e-01}', "");
    Expect(0, 8541, '\P{^Nv=3.750e-01}', "");
    Expect(1, 8540, '\p{Nv=0.375}', "");
    Expect(0, 8540, '\p{^Nv=0.375}', "");
    Expect(0, 8540, '\P{Nv=0.375}', "");
    Expect(1, 8540, '\P{^Nv=0.375}', "");
    Expect(0, 8541, '\p{Nv=0.375}', "");
    Expect(1, 8541, '\p{^Nv=0.375}', "");
    Expect(1, 8541, '\P{Nv=0.375}', "");
    Expect(0, 8541, '\P{^Nv=0.375}', "");
    Expect(1, 8540, '\p{Nv=3.7500e-01}', "");
    Expect(0, 8540, '\p{^Nv=3.7500e-01}', "");
    Expect(0, 8540, '\P{Nv=3.7500e-01}', "");
    Expect(1, 8540, '\P{^Nv=3.7500e-01}', "");
    Expect(0, 8541, '\p{Nv=3.7500e-01}', "");
    Expect(1, 8541, '\p{^Nv=3.7500e-01}', "");
    Expect(1, 8541, '\P{Nv=3.7500e-01}', "");
    Expect(0, 8541, '\P{^Nv=3.7500e-01}', "");
    Expect(1, 8540, '\p{Nv=0.3750}', "");
    Expect(0, 8540, '\p{^Nv=0.3750}', "");
    Expect(0, 8540, '\P{Nv=0.3750}', "");
    Expect(1, 8540, '\P{^Nv=0.3750}', "");
    Expect(0, 8541, '\p{Nv=0.3750}', "");
    Expect(1, 8541, '\p{^Nv=0.3750}', "");
    Expect(1, 8541, '\P{Nv=0.3750}', "");
    Expect(0, 8541, '\P{^Nv=0.3750}', "");
    Error('\p{Is_Numeric_Value=	:=+0003/00000008}');
    Error('\P{Is_Numeric_Value=	:=+0003/00000008}');
    Expect(1, 8540, '\p{Is_Numeric_Value=+0000000003/0000008}', "");
    Expect(0, 8540, '\p{^Is_Numeric_Value=+0000000003/0000008}', "");
    Expect(0, 8540, '\P{Is_Numeric_Value=+0000000003/0000008}', "");
    Expect(1, 8540, '\P{^Is_Numeric_Value=+0000000003/0000008}', "");
    Expect(0, 8541, '\p{Is_Numeric_Value=+0000000003/0000008}', "");
    Expect(1, 8541, '\p{^Is_Numeric_Value=+0000000003/0000008}', "");
    Expect(1, 8541, '\P{Is_Numeric_Value=+0000000003/0000008}', "");
    Expect(0, 8541, '\P{^Is_Numeric_Value=+0000000003/0000008}', "");
    Expect(1, 8540, '\p{Is_Numeric_Value=180/480}', "");
    Expect(0, 8540, '\p{^Is_Numeric_Value=180/480}', "");
    Expect(0, 8540, '\P{Is_Numeric_Value=180/480}', "");
    Expect(1, 8540, '\P{^Is_Numeric_Value=180/480}', "");
    Expect(0, 8541, '\p{Is_Numeric_Value=180/480}', "");
    Expect(1, 8541, '\p{^Is_Numeric_Value=180/480}', "");
    Expect(1, 8541, '\P{Is_Numeric_Value=180/480}', "");
    Expect(0, 8541, '\P{^Is_Numeric_Value=180/480}', "");
    Error('\p{Is_Numeric_Value=3.8e-01}');
    Error('\P{Is_Numeric_Value=3.8e-01}');
    Expect(1, 8540, '\p{Is_Numeric_Value=3.75e-01}', "");
    Expect(0, 8540, '\p{^Is_Numeric_Value=3.75e-01}', "");
    Expect(0, 8540, '\P{Is_Numeric_Value=3.75e-01}', "");
    Expect(1, 8540, '\P{^Is_Numeric_Value=3.75e-01}', "");
    Expect(0, 8541, '\p{Is_Numeric_Value=3.75e-01}', "");
    Expect(1, 8541, '\p{^Is_Numeric_Value=3.75e-01}', "");
    Expect(1, 8541, '\P{Is_Numeric_Value=3.75e-01}', "");
    Expect(0, 8541, '\P{^Is_Numeric_Value=3.75e-01}', "");
    Error('\p{Is_Numeric_Value=0.38}');
    Error('\P{Is_Numeric_Value=0.38}');
    Expect(1, 8540, '\p{Is_Numeric_Value=3.750e-01}', "");
    Expect(0, 8540, '\p{^Is_Numeric_Value=3.750e-01}', "");
    Expect(0, 8540, '\P{Is_Numeric_Value=3.750e-01}', "");
    Expect(1, 8540, '\P{^Is_Numeric_Value=3.750e-01}', "");
    Expect(0, 8541, '\p{Is_Numeric_Value=3.750e-01}', "");
    Expect(1, 8541, '\p{^Is_Numeric_Value=3.750e-01}', "");
    Expect(1, 8541, '\P{Is_Numeric_Value=3.750e-01}', "");
    Expect(0, 8541, '\P{^Is_Numeric_Value=3.750e-01}', "");
    Expect(1, 8540, '\p{Is_Numeric_Value=0.375}', "");
    Expect(0, 8540, '\p{^Is_Numeric_Value=0.375}', "");
    Expect(0, 8540, '\P{Is_Numeric_Value=0.375}', "");
    Expect(1, 8540, '\P{^Is_Numeric_Value=0.375}', "");
    Expect(0, 8541, '\p{Is_Numeric_Value=0.375}', "");
    Expect(1, 8541, '\p{^Is_Numeric_Value=0.375}', "");
    Expect(1, 8541, '\P{Is_Numeric_Value=0.375}', "");
    Expect(0, 8541, '\P{^Is_Numeric_Value=0.375}', "");
    Expect(1, 8540, '\p{Is_Numeric_Value=3.7500e-01}', "");
    Expect(0, 8540, '\p{^Is_Numeric_Value=3.7500e-01}', "");
    Expect(0, 8540, '\P{Is_Numeric_Value=3.7500e-01}', "");
    Expect(1, 8540, '\P{^Is_Numeric_Value=3.7500e-01}', "");
    Expect(0, 8541, '\p{Is_Numeric_Value=3.7500e-01}', "");
    Expect(1, 8541, '\p{^Is_Numeric_Value=3.7500e-01}', "");
    Expect(1, 8541, '\P{Is_Numeric_Value=3.7500e-01}', "");
    Expect(0, 8541, '\P{^Is_Numeric_Value=3.7500e-01}', "");
    Expect(1, 8540, '\p{Is_Numeric_Value=0.3750}', "");
    Expect(0, 8540, '\p{^Is_Numeric_Value=0.3750}', "");
    Expect(0, 8540, '\P{Is_Numeric_Value=0.3750}', "");
    Expect(1, 8540, '\P{^Is_Numeric_Value=0.3750}', "");
    Expect(0, 8541, '\p{Is_Numeric_Value=0.3750}', "");
    Expect(1, 8541, '\p{^Is_Numeric_Value=0.3750}', "");
    Expect(1, 8541, '\P{Is_Numeric_Value=0.3750}', "");
    Expect(0, 8541, '\P{^Is_Numeric_Value=0.3750}', "");
    Error('\p{Is_Nv=_-+0000000003/0008:=}');
    Error('\P{Is_Nv=_-+0000000003/0008:=}');
    Expect(1, 8540, '\p{Is_Nv:03/0008}', "");
    Expect(0, 8540, '\p{^Is_Nv:03/0008}', "");
    Expect(0, 8540, '\P{Is_Nv:03/0008}', "");
    Expect(1, 8540, '\P{^Is_Nv:03/0008}', "");
    Expect(0, 8541, '\p{Is_Nv:03/0008}', "");
    Expect(1, 8541, '\p{^Is_Nv:03/0008}', "");
    Expect(1, 8541, '\P{Is_Nv:03/0008}', "");
    Expect(0, 8541, '\P{^Is_Nv:03/0008}', "");
    Expect(1, 8540, '\p{Is_Nv=180/480}', "");
    Expect(0, 8540, '\p{^Is_Nv=180/480}', "");
    Expect(0, 8540, '\P{Is_Nv=180/480}', "");
    Expect(1, 8540, '\P{^Is_Nv=180/480}', "");
    Expect(0, 8541, '\p{Is_Nv=180/480}', "");
    Expect(1, 8541, '\p{^Is_Nv=180/480}', "");
    Expect(1, 8541, '\P{Is_Nv=180/480}', "");
    Expect(0, 8541, '\P{^Is_Nv=180/480}', "");
    Error('\p{Is_Nv=3.8e-01}');
    Error('\P{Is_Nv=3.8e-01}');
    Expect(1, 8540, '\p{Is_Nv=3.75e-01}', "");
    Expect(0, 8540, '\p{^Is_Nv=3.75e-01}', "");
    Expect(0, 8540, '\P{Is_Nv=3.75e-01}', "");
    Expect(1, 8540, '\P{^Is_Nv=3.75e-01}', "");
    Expect(0, 8541, '\p{Is_Nv=3.75e-01}', "");
    Expect(1, 8541, '\p{^Is_Nv=3.75e-01}', "");
    Expect(1, 8541, '\P{Is_Nv=3.75e-01}', "");
    Expect(0, 8541, '\P{^Is_Nv=3.75e-01}', "");
    Error('\p{Is_Nv=0.38}');
    Error('\P{Is_Nv=0.38}');
    Expect(1, 8540, '\p{Is_Nv:	3.750e-01}', "");
    Expect(0, 8540, '\p{^Is_Nv:	3.750e-01}', "");
    Expect(0, 8540, '\P{Is_Nv:	3.750e-01}', "");
    Expect(1, 8540, '\P{^Is_Nv:	3.750e-01}', "");
    Expect(0, 8541, '\p{Is_Nv:	3.750e-01}', "");
    Expect(1, 8541, '\p{^Is_Nv:	3.750e-01}', "");
    Expect(1, 8541, '\P{Is_Nv:	3.750e-01}', "");
    Expect(0, 8541, '\P{^Is_Nv:	3.750e-01}', "");
    Expect(1, 8540, '\p{Is_Nv=0.375}', "");
    Expect(0, 8540, '\p{^Is_Nv=0.375}', "");
    Expect(0, 8540, '\P{Is_Nv=0.375}', "");
    Expect(1, 8540, '\P{^Is_Nv=0.375}', "");
    Expect(0, 8541, '\p{Is_Nv=0.375}', "");
    Expect(1, 8541, '\p{^Is_Nv=0.375}', "");
    Expect(1, 8541, '\P{Is_Nv=0.375}', "");
    Expect(0, 8541, '\P{^Is_Nv=0.375}', "");
    Expect(1, 8540, '\p{Is_Nv=3.7500e-01}', "");
    Expect(0, 8540, '\p{^Is_Nv=3.7500e-01}', "");
    Expect(0, 8540, '\P{Is_Nv=3.7500e-01}', "");
    Expect(1, 8540, '\P{^Is_Nv=3.7500e-01}', "");
    Expect(0, 8541, '\p{Is_Nv=3.7500e-01}', "");
    Expect(1, 8541, '\p{^Is_Nv=3.7500e-01}', "");
    Expect(1, 8541, '\P{Is_Nv=3.7500e-01}', "");
    Expect(0, 8541, '\P{^Is_Nv=3.7500e-01}', "");
    Expect(1, 8540, '\p{Is_Nv=0.3750}', "");
    Expect(0, 8540, '\p{^Is_Nv=0.3750}', "");
    Expect(0, 8540, '\P{Is_Nv=0.3750}', "");
    Expect(1, 8540, '\P{^Is_Nv=0.3750}', "");
    Expect(0, 8541, '\p{Is_Nv=0.3750}', "");
    Expect(1, 8541, '\p{^Is_Nv=0.3750}', "");
    Expect(1, 8541, '\P{Is_Nv=0.3750}', "");
    Expect(0, 8541, '\P{^Is_Nv=0.3750}', "");
    Error('\p{Numeric_Value=_	0000003/080/a/}');
    Error('\P{Numeric_Value=_	0000003/080/a/}');
    Expect(1, 73670, '\p{Numeric_Value=:\A3/80\z:}', "");;
    Expect(0, 73671, '\p{Numeric_Value=:\A3/80\z:}', "");;
    Expect(1, 73670, '\p{Numeric_Value: 00003/00080}', "");
    Expect(0, 73670, '\p{^Numeric_Value: 00003/00080}', "");
    Expect(0, 73670, '\P{Numeric_Value: 00003/00080}', "");
    Expect(1, 73670, '\P{^Numeric_Value: 00003/00080}', "");
    Expect(0, 73671, '\p{Numeric_Value: 00003/00080}', "");
    Expect(1, 73671, '\p{^Numeric_Value: 00003/00080}', "");
    Expect(1, 73671, '\P{Numeric_Value: 00003/00080}', "");
    Expect(0, 73671, '\P{^Numeric_Value: 00003/00080}', "");
    Expect(1, 73670, '\p{Numeric_Value=180/4800}', "");
    Expect(0, 73670, '\p{^Numeric_Value=180/4800}', "");
    Expect(0, 73670, '\P{Numeric_Value=180/4800}', "");
    Expect(1, 73670, '\P{^Numeric_Value=180/4800}', "");
    Expect(0, 73671, '\p{Numeric_Value=180/4800}', "");
    Expect(1, 73671, '\p{^Numeric_Value=180/4800}', "");
    Expect(1, 73671, '\P{Numeric_Value=180/4800}', "");
    Expect(0, 73671, '\P{^Numeric_Value=180/4800}', "");
    Error('\p{Numeric_Value:	3.7e-02}');
    Error('\P{Numeric_Value:	3.7e-02}');
    Expect(1, 73670, '\p{Numeric_Value=3.75e-02}', "");
    Expect(0, 73670, '\p{^Numeric_Value=3.75e-02}', "");
    Expect(0, 73670, '\P{Numeric_Value=3.75e-02}', "");
    Expect(1, 73670, '\P{^Numeric_Value=3.75e-02}', "");
    Expect(0, 73671, '\p{Numeric_Value=3.75e-02}', "");
    Expect(1, 73671, '\p{^Numeric_Value=3.75e-02}', "");
    Expect(1, 73671, '\P{Numeric_Value=3.75e-02}', "");
    Expect(0, 73671, '\P{^Numeric_Value=3.75e-02}', "");
    Error('\p{Numeric_Value=0.04}');
    Error('\P{Numeric_Value=0.04}');
    Expect(1, 73670, '\p{Numeric_Value=3.750e-02}', "");
    Expect(0, 73670, '\p{^Numeric_Value=3.750e-02}', "");
    Expect(0, 73670, '\P{Numeric_Value=3.750e-02}', "");
    Expect(1, 73670, '\P{^Numeric_Value=3.750e-02}', "");
    Expect(0, 73671, '\p{Numeric_Value=3.750e-02}', "");
    Expect(1, 73671, '\p{^Numeric_Value=3.750e-02}', "");
    Expect(1, 73671, '\P{Numeric_Value=3.750e-02}', "");
    Expect(0, 73671, '\P{^Numeric_Value=3.750e-02}', "");
    Error('\p{Numeric_Value=0.037}');
    Error('\P{Numeric_Value=0.037}');
    Expect(1, 73670, '\p{Numeric_Value=3.7500e-02}', "");
    Expect(0, 73670, '\p{^Numeric_Value=3.7500e-02}', "");
    Expect(0, 73670, '\P{Numeric_Value=3.7500e-02}', "");
    Expect(1, 73670, '\P{^Numeric_Value=3.7500e-02}', "");
    Expect(0, 73671, '\p{Numeric_Value=3.7500e-02}', "");
    Expect(1, 73671, '\p{^Numeric_Value=3.7500e-02}', "");
    Expect(1, 73671, '\P{Numeric_Value=3.7500e-02}', "");
    Expect(0, 73671, '\P{^Numeric_Value=3.7500e-02}', "");
    Expect(1, 73670, '\p{Numeric_Value=0.0375}', "");
    Expect(0, 73670, '\p{^Numeric_Value=0.0375}', "");
    Expect(0, 73670, '\P{Numeric_Value=0.0375}', "");
    Expect(1, 73670, '\P{^Numeric_Value=0.0375}', "");
    Expect(0, 73671, '\p{Numeric_Value=0.0375}', "");
    Expect(1, 73671, '\p{^Numeric_Value=0.0375}', "");
    Expect(1, 73671, '\P{Numeric_Value=0.0375}', "");
    Expect(0, 73671, '\P{^Numeric_Value=0.0375}', "");
    Expect(1, 73670, '\p{Numeric_Value=3.75000e-02}', "");
    Expect(0, 73670, '\p{^Numeric_Value=3.75000e-02}', "");
    Expect(0, 73670, '\P{Numeric_Value=3.75000e-02}', "");
    Expect(1, 73670, '\P{^Numeric_Value=3.75000e-02}', "");
    Expect(0, 73671, '\p{Numeric_Value=3.75000e-02}', "");
    Expect(1, 73671, '\p{^Numeric_Value=3.75000e-02}', "");
    Expect(1, 73671, '\P{Numeric_Value=3.75000e-02}', "");
    Expect(0, 73671, '\P{^Numeric_Value=3.75000e-02}', "");
    Expect(1, 73670, '\p{Numeric_Value=0.03750}', "");
    Expect(0, 73670, '\p{^Numeric_Value=0.03750}', "");
    Expect(0, 73670, '\P{Numeric_Value=0.03750}', "");
    Expect(1, 73670, '\P{^Numeric_Value=0.03750}', "");
    Expect(0, 73671, '\p{Numeric_Value=0.03750}', "");
    Expect(1, 73671, '\p{^Numeric_Value=0.03750}', "");
    Expect(1, 73671, '\P{Numeric_Value=0.03750}', "");
    Expect(0, 73671, '\P{^Numeric_Value=0.03750}', "");
    Error('\p{Nv=- +3/00000080/a/}');
    Error('\P{Nv=- +3/00000080/a/}');
    Expect(1, 73670, '\p{Nv=:\A3/80\z:}', "");;
    Expect(0, 73671, '\p{Nv=:\A3/80\z:}', "");;
    Expect(1, 73670, '\p{Nv=+003/0080}', "");
    Expect(0, 73670, '\p{^Nv=+003/0080}', "");
    Expect(0, 73670, '\P{Nv=+003/0080}', "");
    Expect(1, 73670, '\P{^Nv=+003/0080}', "");
    Expect(0, 73671, '\p{Nv=+003/0080}', "");
    Expect(1, 73671, '\p{^Nv=+003/0080}', "");
    Expect(1, 73671, '\P{Nv=+003/0080}', "");
    Expect(0, 73671, '\P{^Nv=+003/0080}', "");
    Expect(1, 73670, '\p{Nv=180/4800}', "");
    Expect(0, 73670, '\p{^Nv=180/4800}', "");
    Expect(0, 73670, '\P{Nv=180/4800}', "");
    Expect(1, 73670, '\P{^Nv=180/4800}', "");
    Expect(0, 73671, '\p{Nv=180/4800}', "");
    Expect(1, 73671, '\p{^Nv=180/4800}', "");
    Expect(1, 73671, '\P{Nv=180/4800}', "");
    Expect(0, 73671, '\P{^Nv=180/4800}', "");
    Error('\p{Nv=3.7e-02}');
    Error('\P{Nv=3.7e-02}');
    Expect(1, 73670, '\p{Nv=3.75e-02}', "");
    Expect(0, 73670, '\p{^Nv=3.75e-02}', "");
    Expect(0, 73670, '\P{Nv=3.75e-02}', "");
    Expect(1, 73670, '\P{^Nv=3.75e-02}', "");
    Expect(0, 73671, '\p{Nv=3.75e-02}', "");
    Expect(1, 73671, '\p{^Nv=3.75e-02}', "");
    Expect(1, 73671, '\P{Nv=3.75e-02}', "");
    Expect(0, 73671, '\P{^Nv=3.75e-02}', "");
}
if (!$::TESTCHUNK or $::TESTCHUNK == 3) {
    Error('\p{Nv=0.04}');
    Error('\P{Nv=0.04}');
    Expect(1, 73670, '\p{Nv:   3.750e-02}', "");
    Expect(0, 73670, '\p{^Nv:   3.750e-02}', "");
    Expect(0, 73670, '\P{Nv:   3.750e-02}', "");
    Expect(1, 73670, '\P{^Nv:   3.750e-02}', "");
    Expect(0, 73671, '\p{Nv:   3.750e-02}', "");
    Expect(1, 73671, '\p{^Nv:   3.750e-02}', "");
    Expect(1, 73671, '\P{Nv:   3.750e-02}', "");
    Expect(0, 73671, '\P{^Nv:   3.750e-02}', "");
    Error('\p{Nv=0.037}');
    Error('\P{Nv=0.037}');
    Expect(1, 73670, '\p{Nv=3.7500e-02}', "");
    Expect(0, 73670, '\p{^Nv=3.7500e-02}', "");
    Expect(0, 73670, '\P{Nv=3.7500e-02}', "");
    Expect(1, 73670, '\P{^Nv=3.7500e-02}', "");
    Expect(0, 73671, '\p{Nv=3.7500e-02}', "");
    Expect(1, 73671, '\p{^Nv=3.7500e-02}', "");
    Expect(1, 73671, '\P{Nv=3.7500e-02}', "");
    Expect(0, 73671, '\P{^Nv=3.7500e-02}', "");
    Expect(1, 73670, '\p{Nv=0.0375}', "");
    Expect(0, 73670, '\p{^Nv=0.0375}', "");
    Expect(0, 73670, '\P{Nv=0.0375}', "");
    Expect(1, 73670, '\P{^Nv=0.0375}', "");
    Expect(0, 73671, '\p{Nv=0.0375}', "");
    Expect(1, 73671, '\p{^Nv=0.0375}', "");
    Expect(1, 73671, '\P{Nv=0.0375}', "");
    Expect(0, 73671, '\P{^Nv=0.0375}', "");
    Expect(1, 73670, '\p{Nv=3.75000e-02}', "");
    Expect(0, 73670, '\p{^Nv=3.75000e-02}', "");
    Expect(0, 73670, '\P{Nv=3.75000e-02}', "");
    Expect(1, 73670, '\P{^Nv=3.75000e-02}', "");
    Expect(0, 73671, '\p{Nv=3.75000e-02}', "");
    Expect(1, 73671, '\p{^Nv=3.75000e-02}', "");
    Expect(1, 73671, '\P{Nv=3.75000e-02}', "");
    Expect(0, 73671, '\P{^Nv=3.75000e-02}', "");
    Expect(1, 73670, '\p{Nv=0.03750}', "");
    Expect(0, 73670, '\p{^Nv=0.03750}', "");
    Expect(0, 73670, '\P{Nv=0.03750}', "");
    Expect(1, 73670, '\P{^Nv=0.03750}', "");
    Expect(0, 73671, '\p{Nv=0.03750}', "");
    Expect(1, 73671, '\p{^Nv=0.03750}', "");
    Expect(1, 73671, '\P{Nv=0.03750}', "");
    Expect(0, 73671, '\P{^Nv=0.03750}', "");
    Error('\p{Is_Numeric_Value= -000000003/00080:=}');
    Error('\P{Is_Numeric_Value= -000000003/00080:=}');
    Expect(1, 73670, '\p{Is_Numeric_Value=+00000003/000080}', "");
    Expect(0, 73670, '\p{^Is_Numeric_Value=+00000003/000080}', "");
    Expect(0, 73670, '\P{Is_Numeric_Value=+00000003/000080}', "");
    Expect(1, 73670, '\P{^Is_Numeric_Value=+00000003/000080}', "");
    Expect(0, 73671, '\p{Is_Numeric_Value=+00000003/000080}', "");
    Expect(1, 73671, '\p{^Is_Numeric_Value=+00000003/000080}', "");
    Expect(1, 73671, '\P{Is_Numeric_Value=+00000003/000080}', "");
    Expect(0, 73671, '\P{^Is_Numeric_Value=+00000003/000080}', "");
    Expect(1, 73670, '\p{Is_Numeric_Value=180/4800}', "");
    Expect(0, 73670, '\p{^Is_Numeric_Value=180/4800}', "");
    Expect(0, 73670, '\P{Is_Numeric_Value=180/4800}', "");
    Expect(1, 73670, '\P{^Is_Numeric_Value=180/4800}', "");
    Expect(0, 73671, '\p{Is_Numeric_Value=180/4800}', "");
    Expect(1, 73671, '\p{^Is_Numeric_Value=180/4800}', "");
    Expect(1, 73671, '\P{Is_Numeric_Value=180/4800}', "");
    Expect(0, 73671, '\P{^Is_Numeric_Value=180/4800}', "");
    Error('\p{Is_Numeric_Value=3.7e-02}');
    Error('\P{Is_Numeric_Value=3.7e-02}');
    Expect(1, 73670, '\p{Is_Numeric_Value=3.75e-02}', "");
    Expect(0, 73670, '\p{^Is_Numeric_Value=3.75e-02}', "");
    Expect(0, 73670, '\P{Is_Numeric_Value=3.75e-02}', "");
    Expect(1, 73670, '\P{^Is_Numeric_Value=3.75e-02}', "");
    Expect(0, 73671, '\p{Is_Numeric_Value=3.75e-02}', "");
    Expect(1, 73671, '\p{^Is_Numeric_Value=3.75e-02}', "");
    Expect(1, 73671, '\P{Is_Numeric_Value=3.75e-02}', "");
    Expect(0, 73671, '\P{^Is_Numeric_Value=3.75e-02}', "");
    Error('\p{Is_Numeric_Value=0.04}');
    Error('\P{Is_Numeric_Value=0.04}');
    Expect(1, 73670, '\p{Is_Numeric_Value:   3.750e-02}', "");
    Expect(0, 73670, '\p{^Is_Numeric_Value:   3.750e-02}', "");
    Expect(0, 73670, '\P{Is_Numeric_Value:   3.750e-02}', "");
    Expect(1, 73670, '\P{^Is_Numeric_Value:   3.750e-02}', "");
    Expect(0, 73671, '\p{Is_Numeric_Value:   3.750e-02}', "");
    Expect(1, 73671, '\p{^Is_Numeric_Value:   3.750e-02}', "");
    Expect(1, 73671, '\P{Is_Numeric_Value:   3.750e-02}', "");
    Expect(0, 73671, '\P{^Is_Numeric_Value:   3.750e-02}', "");
    Error('\p{Is_Numeric_Value=0.037}');
    Error('\P{Is_Numeric_Value=0.037}');
    Expect(1, 73670, '\p{Is_Numeric_Value=3.7500e-02}', "");
    Expect(0, 73670, '\p{^Is_Numeric_Value=3.7500e-02}', "");
    Expect(0, 73670, '\P{Is_Numeric_Value=3.7500e-02}', "");
    Expect(1, 73670, '\P{^Is_Numeric_Value=3.7500e-02}', "");
    Expect(0, 73671, '\p{Is_Numeric_Value=3.7500e-02}', "");
    Expect(1, 73671, '\p{^Is_Numeric_Value=3.7500e-02}', "");
    Expect(1, 73671, '\P{Is_Numeric_Value=3.7500e-02}', "");
    Expect(0, 73671, '\P{^Is_Numeric_Value=3.7500e-02}', "");
    Expect(1, 73670, '\p{Is_Numeric_Value=0.0375}', "");
    Expect(0, 73670, '\p{^Is_Numeric_Value=0.0375}', "");
    Expect(0, 73670, '\P{Is_Numeric_Value=0.0375}', "");
    Expect(1, 73670, '\P{^Is_Numeric_Value=0.0375}', "");
    Expect(0, 73671, '\p{Is_Numeric_Value=0.0375}', "");
    Expect(1, 73671, '\p{^Is_Numeric_Value=0.0375}', "");
    Expect(1, 73671, '\P{Is_Numeric_Value=0.0375}', "");
    Expect(0, 73671, '\P{^Is_Numeric_Value=0.0375}', "");
    Expect(1, 73670, '\p{Is_Numeric_Value=3.75000e-02}', "");
    Expect(0, 73670, '\p{^Is_Numeric_Value=3.75000e-02}', "");
    Expect(0, 73670, '\P{Is_Numeric_Value=3.75000e-02}', "");
    Expect(1, 73670, '\P{^Is_Numeric_Value=3.75000e-02}', "");
    Expect(0, 73671, '\p{Is_Numeric_Value=3.75000e-02}', "");
    Expect(1, 73671, '\p{^Is_Numeric_Value=3.75000e-02}', "");
    Expect(1, 73671, '\P{Is_Numeric_Value=3.75000e-02}', "");
    Expect(0, 73671, '\P{^Is_Numeric_Value=3.75000e-02}', "");
    Expect(1, 73670, '\p{Is_Numeric_Value=0.03750}', "");
    Expect(0, 73670, '\p{^Is_Numeric_Value=0.03750}', "");
    Expect(0, 73670, '\P{Is_Numeric_Value=0.03750}', "");
    Expect(1, 73670, '\P{^Is_Numeric_Value=0.03750}', "");
    Expect(0, 73671, '\p{Is_Numeric_Value=0.03750}', "");
    Expect(1, 73671, '\p{^Is_Numeric_Value=0.03750}', "");
    Expect(1, 73671, '\P{Is_Numeric_Value=0.03750}', "");
    Expect(0, 73671, '\P{^Is_Numeric_Value=0.03750}', "");
    Error('\p{Is_Nv=_ +000000003/0000080:=}');
    Error('\P{Is_Nv=_ +000000003/0000080:=}');
    Expect(1, 73670, '\p{Is_Nv=000000003/80}', "");
    Expect(0, 73670, '\p{^Is_Nv=000000003/80}', "");
    Expect(0, 73670, '\P{Is_Nv=000000003/80}', "");
    Expect(1, 73670, '\P{^Is_Nv=000000003/80}', "");
    Expect(0, 73671, '\p{Is_Nv=000000003/80}', "");
    Expect(1, 73671, '\p{^Is_Nv=000000003/80}', "");
    Expect(1, 73671, '\P{Is_Nv=000000003/80}', "");
    Expect(0, 73671, '\P{^Is_Nv=000000003/80}', "");
    Expect(1, 73670, '\p{Is_Nv=180/4800}', "");
    Expect(0, 73670, '\p{^Is_Nv=180/4800}', "");
    Expect(0, 73670, '\P{Is_Nv=180/4800}', "");
    Expect(1, 73670, '\P{^Is_Nv=180/4800}', "");
    Expect(0, 73671, '\p{Is_Nv=180/4800}', "");
    Expect(1, 73671, '\p{^Is_Nv=180/4800}', "");
    Expect(1, 73671, '\P{Is_Nv=180/4800}', "");
    Expect(0, 73671, '\P{^Is_Nv=180/4800}', "");
    Error('\p{Is_Nv=3.7e-02}');
    Error('\P{Is_Nv=3.7e-02}');
    Expect(1, 73670, '\p{Is_Nv=3.75e-02}', "");
    Expect(0, 73670, '\p{^Is_Nv=3.75e-02}', "");
    Expect(0, 73670, '\P{Is_Nv=3.75e-02}', "");
    Expect(1, 73670, '\P{^Is_Nv=3.75e-02}', "");
    Expect(0, 73671, '\p{Is_Nv=3.75e-02}', "");
    Expect(1, 73671, '\p{^Is_Nv=3.75e-02}', "");
    Expect(1, 73671, '\P{Is_Nv=3.75e-02}', "");
    Expect(0, 73671, '\P{^Is_Nv=3.75e-02}', "");
    Error('\p{Is_Nv=0.04}');
    Error('\P{Is_Nv=0.04}');
    Expect(1, 73670, '\p{Is_Nv=3.750e-02}', "");
    Expect(0, 73670, '\p{^Is_Nv=3.750e-02}', "");
    Expect(0, 73670, '\P{Is_Nv=3.750e-02}', "");
    Expect(1, 73670, '\P{^Is_Nv=3.750e-02}', "");
    Expect(0, 73671, '\p{Is_Nv=3.750e-02}', "");
    Expect(1, 73671, '\p{^Is_Nv=3.750e-02}', "");
    Expect(1, 73671, '\P{Is_Nv=3.750e-02}', "");
    Expect(0, 73671, '\P{^Is_Nv=3.750e-02}', "");
    Error('\p{Is_Nv=0.037}');
    Error('\P{Is_Nv=0.037}');
    Expect(1, 73670, '\p{Is_Nv:   3.7500e-02}', "");
    Expect(0, 73670, '\p{^Is_Nv:   3.7500e-02}', "");
    Expect(0, 73670, '\P{Is_Nv:   3.7500e-02}', "");
    Expect(1, 73670, '\P{^Is_Nv:   3.7500e-02}', "");
    Expect(0, 73671, '\p{Is_Nv:   3.7500e-02}', "");
    Expect(1, 73671, '\p{^Is_Nv:   3.7500e-02}', "");
    Expect(1, 73671, '\P{Is_Nv:   3.7500e-02}', "");
    Expect(0, 73671, '\P{^Is_Nv:   3.7500e-02}', "");
    Expect(1, 73670, '\p{Is_Nv=0.0375}', "");
    Expect(0, 73670, '\p{^Is_Nv=0.0375}', "");
    Expect(0, 73670, '\P{Is_Nv=0.0375}', "");
    Expect(1, 73670, '\P{^Is_Nv=0.0375}', "");
    Expect(0, 73671, '\p{Is_Nv=0.0375}', "");
    Expect(1, 73671, '\p{^Is_Nv=0.0375}', "");
    Expect(1, 73671, '\P{Is_Nv=0.0375}', "");
    Expect(0, 73671, '\P{^Is_Nv=0.0375}', "");
    Expect(1, 73670, '\p{Is_Nv=3.75000e-02}', "");
    Expect(0, 73670, '\p{^Is_Nv=3.75000e-02}', "");
    Expect(0, 73670, '\P{Is_Nv=3.75000e-02}', "");
    Expect(1, 73670, '\P{^Is_Nv=3.75000e-02}', "");
    Expect(0, 73671, '\p{Is_Nv=3.75000e-02}', "");
    Expect(1, 73671, '\p{^Is_Nv=3.75000e-02}', "");
    Expect(1, 73671, '\P{Is_Nv=3.75000e-02}', "");
    Expect(0, 73671, '\P{^Is_Nv=3.75000e-02}', "");
    Expect(1, 73670, '\p{Is_Nv=0.03750}', "");
    Expect(0, 73670, '\p{^Is_Nv=0.03750}', "");
    Expect(0, 73670, '\P{Is_Nv=0.03750}', "");
    Expect(1, 73670, '\P{^Is_Nv=0.03750}', "");
    Expect(0, 73671, '\p{Is_Nv=0.03750}', "");
    Expect(1, 73671, '\p{^Is_Nv=0.03750}', "");
    Expect(1, 73671, '\P{Is_Nv=0.03750}', "");
    Expect(0, 73671, '\P{^Is_Nv=0.03750}', "");
    Error('\p{Numeric_Value=_/a/+00030}');
    Error('\P{Numeric_Value=_/a/+00030}');
    Expect(1, 133507, '\p{Numeric_Value=:\A30\z:}', "");;
    Expect(0, 133508, '\p{Numeric_Value=:\A30\z:}', "");;
    Expect(1, 133507, '\p{Numeric_Value=0_0_0_0_0_030}', "");
    Expect(0, 133507, '\p{^Numeric_Value=0_0_0_0_0_030}', "");
    Expect(0, 133507, '\P{Numeric_Value=0_0_0_0_0_030}', "");
    Expect(1, 133507, '\P{^Numeric_Value=0_0_0_0_0_030}', "");
    Expect(0, 133508, '\p{Numeric_Value=0_0_0_0_0_030}', "");
    Expect(1, 133508, '\p{^Numeric_Value=0_0_0_0_0_030}', "");
    Expect(1, 133508, '\P{Numeric_Value=0_0_0_0_0_030}', "");
    Expect(0, 133508, '\P{^Numeric_Value=0_0_0_0_0_030}', "");
    Expect(1, 133507, '\p{Numeric_Value=3.000000000000000e+01}', "");
    Expect(0, 133507, '\p{^Numeric_Value=3.000000000000000e+01}', "");
    Expect(0, 133507, '\P{Numeric_Value=3.000000000000000e+01}', "");
    Expect(1, 133507, '\P{^Numeric_Value=3.000000000000000e+01}', "");
    Expect(0, 133508, '\p{Numeric_Value=3.000000000000000e+01}', "");
    Expect(1, 133508, '\p{^Numeric_Value=3.000000000000000e+01}', "");
    Expect(1, 133508, '\P{Numeric_Value=3.000000000000000e+01}', "");
    Expect(0, 133508, '\P{^Numeric_Value=3.000000000000000e+01}', "");
    Error('\p{Nv=--+00_00_03_0/a/}');
    Error('\P{Nv=--+00_00_03_0/a/}');
    Expect(1, 133507, '\p{Nv=:\A30\z:}', "");;
    Expect(0, 133508, '\p{Nv=:\A30\z:}', "");;
    Expect(1, 133507, '\p{Nv=000000030}', "");
    Expect(0, 133507, '\p{^Nv=000000030}', "");
    Expect(0, 133507, '\P{Nv=000000030}', "");
    Expect(1, 133507, '\P{^Nv=000000030}', "");
    Expect(0, 133508, '\p{Nv=000000030}', "");
    Expect(1, 133508, '\p{^Nv=000000030}', "");
    Expect(1, 133508, '\P{Nv=000000030}', "");
    Expect(0, 133508, '\P{^Nv=000000030}', "");
    Expect(1, 133507, '\p{Nv=3.000000000000000e+01}', "");
    Expect(0, 133507, '\p{^Nv=3.000000000000000e+01}', "");
    Expect(0, 133507, '\P{Nv=3.000000000000000e+01}', "");
    Expect(1, 133507, '\P{^Nv=3.000000000000000e+01}', "");
    Expect(0, 133508, '\p{Nv=3.000000000000000e+01}', "");
    Expect(1, 133508, '\p{^Nv=3.000000000000000e+01}', "");
    Expect(1, 133508, '\P{Nv=3.000000000000000e+01}', "");
    Expect(0, 133508, '\P{^Nv=3.000000000000000e+01}', "");
    Error('\p{Is_Numeric_Value=_	00030:=}');
    Error('\P{Is_Numeric_Value=_	00030:=}');
    Expect(1, 133507, '\p{Is_Numeric_Value=+0030}', "");
    Expect(0, 133507, '\p{^Is_Numeric_Value=+0030}', "");
    Expect(0, 133507, '\P{Is_Numeric_Value=+0030}', "");
    Expect(1, 133507, '\P{^Is_Numeric_Value=+0030}', "");
    Expect(0, 133508, '\p{Is_Numeric_Value=+0030}', "");
    Expect(1, 133508, '\p{^Is_Numeric_Value=+0030}', "");
    Expect(1, 133508, '\P{Is_Numeric_Value=+0030}', "");
    Expect(0, 133508, '\P{^Is_Numeric_Value=+0030}', "");
    Expect(1, 133507, '\p{Is_Numeric_Value=3.000000000000000e+01}', "");
    Expect(0, 133507, '\p{^Is_Numeric_Value=3.000000000000000e+01}', "");
    Expect(0, 133507, '\P{Is_Numeric_Value=3.000000000000000e+01}', "");
    Expect(1, 133507, '\P{^Is_Numeric_Value=3.000000000000000e+01}', "");
    Expect(0, 133508, '\p{Is_Numeric_Value=3.000000000000000e+01}', "");
    Expect(1, 133508, '\p{^Is_Numeric_Value=3.000000000000000e+01}', "");
    Expect(1, 133508, '\P{Is_Numeric_Value=3.000000000000000e+01}', "");
    Expect(0, 133508, '\P{^Is_Numeric_Value=3.000000000000000e+01}', "");
    Error('\p{Is_Nv= _0_0_0_0_0_30/a/}');
    Error('\P{Is_Nv= _0_0_0_0_0_30/a/}');
    Expect(1, 133507, '\p{Is_Nv=0030}', "");
    Expect(0, 133507, '\p{^Is_Nv=0030}', "");
    Expect(0, 133507, '\P{Is_Nv=0030}', "");
    Expect(1, 133507, '\P{^Is_Nv=0030}', "");
    Expect(0, 133508, '\p{Is_Nv=0030}', "");
    Expect(1, 133508, '\p{^Is_Nv=0030}', "");
    Expect(1, 133508, '\P{Is_Nv=0030}', "");
    Expect(0, 133508, '\P{^Is_Nv=0030}', "");
    Expect(1, 133507, '\p{Is_Nv=3.000000000000000e+01}', "");
    Expect(0, 133507, '\p{^Is_Nv=3.000000000000000e+01}', "");
    Expect(0, 133507, '\P{Is_Nv=3.000000000000000e+01}', "");
    Expect(1, 133507, '\P{^Is_Nv=3.000000000000000e+01}', "");
    Expect(0, 133508, '\p{Is_Nv=3.000000000000000e+01}', "");
    Expect(1, 133508, '\p{^Is_Nv=3.000000000000000e+01}', "");
    Expect(1, 133508, '\P{Is_Nv=3.000000000000000e+01}', "");
    Expect(0, 133508, '\P{^Is_Nv=3.000000000000000e+01}', "");
    Error('\p{Numeric_Value=/a/+300}');
    Error('\P{Numeric_Value=/a/+300}');
    Expect(1, 126229, '\p{Numeric_Value=:\A300\z:}', "");;
    Expect(0, 126230, '\p{Numeric_Value=:\A300\z:}', "");;
    Expect(1, 126229, '\p{Numeric_Value=0000000300}', "");
    Expect(0, 126229, '\p{^Numeric_Value=0000000300}', "");
    Expect(0, 126229, '\P{Numeric_Value=0000000300}', "");
    Expect(1, 126229, '\P{^Numeric_Value=0000000300}', "");
    Expect(0, 126230, '\p{Numeric_Value=0000000300}', "");
    Expect(1, 126230, '\p{^Numeric_Value=0000000300}', "");
    Expect(1, 126230, '\P{Numeric_Value=0000000300}', "");
    Expect(0, 126230, '\P{^Numeric_Value=0000000300}', "");
    Expect(1, 126229, '\p{Numeric_Value=3.000000000000000e+02}', "");
    Expect(0, 126229, '\p{^Numeric_Value=3.000000000000000e+02}', "");
    Expect(0, 126229, '\P{Numeric_Value=3.000000000000000e+02}', "");
    Expect(1, 126229, '\P{^Numeric_Value=3.000000000000000e+02}', "");
    Expect(0, 126230, '\p{Numeric_Value=3.000000000000000e+02}', "");
    Expect(1, 126230, '\p{^Numeric_Value=3.000000000000000e+02}', "");
    Expect(1, 126230, '\P{Numeric_Value=3.000000000000000e+02}', "");
    Expect(0, 126230, '\P{^Numeric_Value=3.000000000000000e+02}', "");
    Error('\p{Nv=:=_	0030_0}');
    Error('\P{Nv=:=_	0030_0}');
    Expect(1, 126229, '\p{Nv=:\A300\z:}', "");;
    Expect(0, 126230, '\p{Nv=:\A300\z:}', "");;
    Expect(1, 126229, '\p{Nv=00000300}', "");
    Expect(0, 126229, '\p{^Nv=00000300}', "");
    Expect(0, 126229, '\P{Nv=00000300}', "");
    Expect(1, 126229, '\P{^Nv=00000300}', "");
    Expect(0, 126230, '\p{Nv=00000300}', "");
    Expect(1, 126230, '\p{^Nv=00000300}', "");
    Expect(1, 126230, '\P{Nv=00000300}', "");
    Expect(0, 126230, '\P{^Nv=00000300}', "");
    Expect(1, 126229, '\p{Nv=3.000000000000000e+02}', "");
    Expect(0, 126229, '\p{^Nv=3.000000000000000e+02}', "");
    Expect(0, 126229, '\P{Nv=3.000000000000000e+02}', "");
    Expect(1, 126229, '\P{^Nv=3.000000000000000e+02}', "");
    Expect(0, 126230, '\p{Nv=3.000000000000000e+02}', "");
    Expect(1, 126230, '\p{^Nv=3.000000000000000e+02}', "");
    Expect(1, 126230, '\P{Nv=3.000000000000000e+02}', "");
    Expect(0, 126230, '\P{^Nv=3.000000000000000e+02}', "");
    Error('\p{Is_Numeric_Value=:=000_003_00}');
    Error('\P{Is_Numeric_Value=:=000_003_00}');
    Expect(1, 126229, '\p{Is_Numeric_Value=000300}', "");
    Expect(0, 126229, '\p{^Is_Numeric_Value=000300}', "");
    Expect(0, 126229, '\P{Is_Numeric_Value=000300}', "");
    Expect(1, 126229, '\P{^Is_Numeric_Value=000300}', "");
    Expect(0, 126230, '\p{Is_Numeric_Value=000300}', "");
    Expect(1, 126230, '\p{^Is_Numeric_Value=000300}', "");
    Expect(1, 126230, '\P{Is_Numeric_Value=000300}', "");
    Expect(0, 126230, '\P{^Is_Numeric_Value=000300}', "");
    Expect(1, 126229, '\p{Is_Numeric_Value=3.000000000000000e+02}', "");
    Expect(0, 126229, '\p{^Is_Numeric_Value=3.000000000000000e+02}', "");
    Expect(0, 126229, '\P{Is_Numeric_Value=3.000000000000000e+02}', "");
    Expect(1, 126229, '\P{^Is_Numeric_Value=3.000000000000000e+02}', "");
    Expect(0, 126230, '\p{Is_Numeric_Value=3.000000000000000e+02}', "");
    Expect(1, 126230, '\p{^Is_Numeric_Value=3.000000000000000e+02}', "");
    Expect(1, 126230, '\P{Is_Numeric_Value=3.000000000000000e+02}', "");
    Expect(0, 126230, '\P{^Is_Numeric_Value=3.000000000000000e+02}', "");
    Error('\p{Is_Nv=__+0300:=}');
    Error('\P{Is_Nv=__+0300:=}');
    Expect(1, 126229, '\p{Is_Nv=+000000300}', "");
    Expect(0, 126229, '\p{^Is_Nv=+000000300}', "");
    Expect(0, 126229, '\P{Is_Nv=+000000300}', "");
    Expect(1, 126229, '\P{^Is_Nv=+000000300}', "");
    Expect(0, 126230, '\p{Is_Nv=+000000300}', "");
    Expect(1, 126230, '\p{^Is_Nv=+000000300}', "");
    Expect(1, 126230, '\P{Is_Nv=+000000300}', "");
    Expect(0, 126230, '\P{^Is_Nv=+000000300}', "");
    Expect(1, 126229, '\p{Is_Nv=3.000000000000000e+02}', "");
    Expect(0, 126229, '\p{^Is_Nv=3.000000000000000e+02}', "");
    Expect(0, 126229, '\P{Is_Nv=3.000000000000000e+02}', "");
    Expect(1, 126229, '\P{^Is_Nv=3.000000000000000e+02}', "");
    Expect(0, 126230, '\p{Is_Nv=3.000000000000000e+02}', "");
    Expect(1, 126230, '\p{^Is_Nv=3.000000000000000e+02}', "");
    Expect(1, 126230, '\P{Is_Nv=3.000000000000000e+02}', "");
    Expect(0, 126230, '\P{^Is_Nv=3.000000000000000e+02}', "");
    Error('\p{Numeric_Value=-:=03000}');
    Error('\P{Numeric_Value=-:=03000}');
    Expect(1, 126238, '\p{Numeric_Value=:\A3000\z:}', "");;
    Expect(0, 126239, '\p{Numeric_Value=:\A3000\z:}', "");;
    Expect(1, 126238, '\p{Numeric_Value=00003000}', "");
    Expect(0, 126238, '\p{^Numeric_Value=00003000}', "");
    Expect(0, 126238, '\P{Numeric_Value=00003000}', "");
    Expect(1, 126238, '\P{^Numeric_Value=00003000}', "");
    Expect(0, 126239, '\p{Numeric_Value=00003000}', "");
    Expect(1, 126239, '\p{^Numeric_Value=00003000}', "");
    Expect(1, 126239, '\P{Numeric_Value=00003000}', "");
    Expect(0, 126239, '\P{^Numeric_Value=00003000}', "");
    Expect(1, 126238, '\p{Numeric_Value:	3.000000000000000e+03}', "");
    Expect(0, 126238, '\p{^Numeric_Value:	3.000000000000000e+03}', "");
    Expect(0, 126238, '\P{Numeric_Value:	3.000000000000000e+03}', "");
    Expect(1, 126238, '\P{^Numeric_Value:	3.000000000000000e+03}', "");
    Expect(0, 126239, '\p{Numeric_Value:	3.000000000000000e+03}', "");
    Expect(1, 126239, '\p{^Numeric_Value:	3.000000000000000e+03}', "");
    Expect(1, 126239, '\P{Numeric_Value:	3.000000000000000e+03}', "");
    Expect(0, 126239, '\P{^Numeric_Value:	3.000000000000000e+03}', "");
    Error('\p{Nv=-:=00000003000}');
    Error('\P{Nv=-:=00000003000}');
    Expect(1, 126238, '\p{Nv=:\A3000\z:}', "");;
    Expect(0, 126239, '\p{Nv=:\A3000\z:}', "");;
    Expect(1, 126238, '\p{Nv=00003000}', "");
    Expect(0, 126238, '\p{^Nv=00003000}', "");
    Expect(0, 126238, '\P{Nv=00003000}', "");
    Expect(1, 126238, '\P{^Nv=00003000}', "");
    Expect(0, 126239, '\p{Nv=00003000}', "");
    Expect(1, 126239, '\p{^Nv=00003000}', "");
    Expect(1, 126239, '\P{Nv=00003000}', "");
    Expect(0, 126239, '\P{^Nv=00003000}', "");
    Expect(1, 126238, '\p{Nv=3.000000000000000e+03}', "");
    Expect(0, 126238, '\p{^Nv=3.000000000000000e+03}', "");
    Expect(0, 126238, '\P{Nv=3.000000000000000e+03}', "");
    Expect(1, 126238, '\P{^Nv=3.000000000000000e+03}', "");
    Expect(0, 126239, '\p{Nv=3.000000000000000e+03}', "");
    Expect(1, 126239, '\p{^Nv=3.000000000000000e+03}', "");
    Expect(1, 126239, '\P{Nv=3.000000000000000e+03}', "");
    Expect(0, 126239, '\P{^Nv=3.000000000000000e+03}', "");
    Error('\p{Is_Numeric_Value=-+0000000003000/a/}');
    Error('\P{Is_Numeric_Value=-+0000000003000/a/}');
    Expect(1, 126238, '\p{Is_Numeric_Value=+0300_0}', "");
    Expect(0, 126238, '\p{^Is_Numeric_Value=+0300_0}', "");
    Expect(0, 126238, '\P{Is_Numeric_Value=+0300_0}', "");
    Expect(1, 126238, '\P{^Is_Numeric_Value=+0300_0}', "");
    Expect(0, 126239, '\p{Is_Numeric_Value=+0300_0}', "");
    Expect(1, 126239, '\p{^Is_Numeric_Value=+0300_0}', "");
    Expect(1, 126239, '\P{Is_Numeric_Value=+0300_0}', "");
    Expect(0, 126239, '\P{^Is_Numeric_Value=+0300_0}', "");
    Expect(1, 126238, '\p{Is_Numeric_Value=3.000000000000000e+03}', "");
    Expect(0, 126238, '\p{^Is_Numeric_Value=3.000000000000000e+03}', "");
    Expect(0, 126238, '\P{Is_Numeric_Value=3.000000000000000e+03}', "");
    Expect(1, 126238, '\P{^Is_Numeric_Value=3.000000000000000e+03}', "");
    Expect(0, 126239, '\p{Is_Numeric_Value=3.000000000000000e+03}', "");
    Expect(1, 126239, '\p{^Is_Numeric_Value=3.000000000000000e+03}', "");
    Expect(1, 126239, '\P{Is_Numeric_Value=3.000000000000000e+03}', "");
    Expect(0, 126239, '\P{^Is_Numeric_Value=3.000000000000000e+03}', "");
    Error('\p{Is_Nv=		3000/a/}');
    Error('\P{Is_Nv=		3000/a/}');
    Expect(1, 126238, '\p{Is_Nv=+000000003000}', "");
    Expect(0, 126238, '\p{^Is_Nv=+000000003000}', "");
    Expect(0, 126238, '\P{Is_Nv=+000000003000}', "");
    Expect(1, 126238, '\P{^Is_Nv=+000000003000}', "");
    Expect(0, 126239, '\p{Is_Nv=+000000003000}', "");
    Expect(1, 126239, '\p{^Is_Nv=+000000003000}', "");
    Expect(1, 126239, '\P{Is_Nv=+000000003000}', "");
    Expect(0, 126239, '\P{^Is_Nv=+000000003000}', "");
    Expect(1, 126238, '\p{Is_Nv=3.000000000000000e+03}', "");
    Expect(0, 126238, '\p{^Is_Nv=3.000000000000000e+03}', "");
    Expect(0, 126238, '\P{Is_Nv=3.000000000000000e+03}', "");
    Expect(1, 126238, '\P{^Is_Nv=3.000000000000000e+03}', "");
    Expect(0, 126239, '\p{Is_Nv=3.000000000000000e+03}', "");
    Expect(1, 126239, '\p{^Is_Nv=3.000000000000000e+03}', "");
    Expect(1, 126239, '\P{Is_Nv=3.000000000000000e+03}', "");
    Expect(0, 126239, '\P{^Is_Nv=3.000000000000000e+03}', "");
    Error('\p{Numeric_Value=/a/ 	+30000}');
    Error('\P{Numeric_Value=/a/ 	+30000}');
    Expect(1, 126247, '\p{Numeric_Value=:\A30000\z:}', "");;
    Expect(0, 126248, '\p{Numeric_Value=:\A30000\z:}', "");;
    Expect(1, 126247, '\p{Numeric_Value=00030000}', "");
    Expect(0, 126247, '\p{^Numeric_Value=00030000}', "");
    Expect(0, 126247, '\P{Numeric_Value=00030000}', "");
    Expect(1, 126247, '\P{^Numeric_Value=00030000}', "");
    Expect(0, 126248, '\p{Numeric_Value=00030000}', "");
    Expect(1, 126248, '\p{^Numeric_Value=00030000}', "");
    Expect(1, 126248, '\P{Numeric_Value=00030000}', "");
    Expect(0, 126248, '\P{^Numeric_Value=00030000}', "");
    Expect(1, 126247, '\p{Numeric_Value=3.000000000000000e+04}', "");
    Expect(0, 126247, '\p{^Numeric_Value=3.000000000000000e+04}', "");
    Expect(0, 126247, '\P{Numeric_Value=3.000000000000000e+04}', "");
    Expect(1, 126247, '\P{^Numeric_Value=3.000000000000000e+04}', "");
    Expect(0, 126248, '\p{Numeric_Value=3.000000000000000e+04}', "");
    Expect(1, 126248, '\p{^Numeric_Value=3.000000000000000e+04}', "");
    Expect(1, 126248, '\P{Numeric_Value=3.000000000000000e+04}', "");
    Expect(0, 126248, '\P{^Numeric_Value=3.000000000000000e+04}', "");
    Error('\p{Nv:		+0000_0300_00/a/}');
    Error('\P{Nv:		+0000_0300_00/a/}');
    Expect(1, 126247, '\p{Nv=:\A30000\z:}', "");;
    Expect(0, 126248, '\p{Nv=:\A30000\z:}', "");;
    Expect(1, 126247, '\p{Nv=0000_3000_0}', "");
    Expect(0, 126247, '\p{^Nv=0000_3000_0}', "");
    Expect(0, 126247, '\P{Nv=0000_3000_0}', "");
    Expect(1, 126247, '\P{^Nv=0000_3000_0}', "");
    Expect(0, 126248, '\p{Nv=0000_3000_0}', "");
    Expect(1, 126248, '\p{^Nv=0000_3000_0}', "");
    Expect(1, 126248, '\P{Nv=0000_3000_0}', "");
    Expect(0, 126248, '\P{^Nv=0000_3000_0}', "");
    Expect(1, 126247, '\p{Nv=3.000000000000000e+04}', "");
    Expect(0, 126247, '\p{^Nv=3.000000000000000e+04}', "");
    Expect(0, 126247, '\P{Nv=3.000000000000000e+04}', "");
    Expect(1, 126247, '\P{^Nv=3.000000000000000e+04}', "");
    Expect(0, 126248, '\p{Nv=3.000000000000000e+04}', "");
    Expect(1, 126248, '\p{^Nv=3.000000000000000e+04}', "");
    Expect(1, 126248, '\P{Nv=3.000000000000000e+04}', "");
    Expect(0, 126248, '\P{^Nv=3.000000000000000e+04}', "");
    Error('\p{Is_Numeric_Value=/a/		0_0_0_0_0_3_0000}');
    Error('\P{Is_Numeric_Value=/a/		0_0_0_0_0_3_0000}');
    Expect(1, 126247, '\p{Is_Numeric_Value=00000000030000}', "");
    Expect(0, 126247, '\p{^Is_Numeric_Value=00000000030000}', "");
    Expect(0, 126247, '\P{Is_Numeric_Value=00000000030000}', "");
    Expect(1, 126247, '\P{^Is_Numeric_Value=00000000030000}', "");
    Expect(0, 126248, '\p{Is_Numeric_Value=00000000030000}', "");
    Expect(1, 126248, '\p{^Is_Numeric_Value=00000000030000}', "");
    Expect(1, 126248, '\P{Is_Numeric_Value=00000000030000}', "");
    Expect(0, 126248, '\P{^Is_Numeric_Value=00000000030000}', "");
    Expect(1, 126247, '\p{Is_Numeric_Value:   3.000000000000000e+04}', "");
    Expect(0, 126247, '\p{^Is_Numeric_Value:   3.000000000000000e+04}', "");
    Expect(0, 126247, '\P{Is_Numeric_Value:   3.000000000000000e+04}', "");
    Expect(1, 126247, '\P{^Is_Numeric_Value:   3.000000000000000e+04}', "");
    Expect(0, 126248, '\p{Is_Numeric_Value:   3.000000000000000e+04}', "");
    Expect(1, 126248, '\p{^Is_Numeric_Value:   3.000000000000000e+04}', "");
    Expect(1, 126248, '\P{Is_Numeric_Value:   3.000000000000000e+04}', "");
    Expect(0, 126248, '\P{^Is_Numeric_Value:   3.000000000000000e+04}', "");
    Error('\p{Is_Nv::=_ 030000}');
    Error('\P{Is_Nv::=_ 030000}');
    Expect(1, 126247, '\p{Is_Nv=+30_00_0}', "");
    Expect(0, 126247, '\p{^Is_Nv=+30_00_0}', "");
    Expect(0, 126247, '\P{Is_Nv=+30_00_0}', "");
    Expect(1, 126247, '\P{^Is_Nv=+30_00_0}', "");
    Expect(0, 126248, '\p{Is_Nv=+30_00_0}', "");
    Expect(1, 126248, '\p{^Is_Nv=+30_00_0}', "");
    Expect(1, 126248, '\P{Is_Nv=+30_00_0}', "");
    Expect(0, 126248, '\P{^Is_Nv=+30_00_0}', "");
    Expect(1, 126247, '\p{Is_Nv=3.000000000000000e+04}', "");
    Expect(0, 126247, '\p{^Is_Nv=3.000000000000000e+04}', "");
    Expect(0, 126247, '\P{Is_Nv=3.000000000000000e+04}', "");
    Expect(1, 126247, '\P{^Is_Nv=3.000000000000000e+04}', "");
    Expect(0, 126248, '\p{Is_Nv=3.000000000000000e+04}', "");
    Expect(1, 126248, '\p{^Is_Nv=3.000000000000000e+04}', "");
    Expect(1, 126248, '\P{Is_Nv=3.000000000000000e+04}', "");
    Expect(0, 126248, '\P{^Is_Nv=3.000000000000000e+04}', "");
    Error('\p{Numeric_Value=/a/	-3_0_0_000}');
    Error('\P{Numeric_Value=/a/	-3_0_0_000}');
    Expect(1, 68079, '\p{Numeric_Value=:\A300000\z:}', "");;
    Expect(0, 68080, '\p{Numeric_Value=:\A300000\z:}', "");;
    Expect(1, 68079, '\p{Numeric_Value=+00000000300000}', "");
    Expect(0, 68079, '\p{^Numeric_Value=+00000000300000}', "");
    Expect(0, 68079, '\P{Numeric_Value=+00000000300000}', "");
    Expect(1, 68079, '\P{^Numeric_Value=+00000000300000}', "");
    Expect(0, 68080, '\p{Numeric_Value=+00000000300000}', "");
    Expect(1, 68080, '\p{^Numeric_Value=+00000000300000}', "");
    Expect(1, 68080, '\P{Numeric_Value=+00000000300000}', "");
    Expect(0, 68080, '\P{^Numeric_Value=+00000000300000}', "");
    Expect(1, 68079, '\p{Numeric_Value=3.000000000000000e+05}', "");
    Expect(0, 68079, '\p{^Numeric_Value=3.000000000000000e+05}', "");
    Expect(0, 68079, '\P{Numeric_Value=3.000000000000000e+05}', "");
    Expect(1, 68079, '\P{^Numeric_Value=3.000000000000000e+05}', "");
    Expect(0, 68080, '\p{Numeric_Value=3.000000000000000e+05}', "");
    Expect(1, 68080, '\p{^Numeric_Value=3.000000000000000e+05}', "");
    Expect(1, 68080, '\P{Numeric_Value=3.000000000000000e+05}', "");
    Expect(0, 68080, '\P{^Numeric_Value=3.000000000000000e+05}', "");
    Error('\p{Nv=/a/	_0300000}');
    Error('\P{Nv=/a/	_0300000}');
    Expect(1, 68079, '\p{Nv=:\A300000\z:}', "");;
    Expect(0, 68080, '\p{Nv=:\A300000\z:}', "");;
    Expect(1, 68079, '\p{Nv=0_0_0_0_0_0_0_0_300000}', "");
    Expect(0, 68079, '\p{^Nv=0_0_0_0_0_0_0_0_300000}', "");
    Expect(0, 68079, '\P{Nv=0_0_0_0_0_0_0_0_300000}', "");
    Expect(1, 68079, '\P{^Nv=0_0_0_0_0_0_0_0_300000}', "");
    Expect(0, 68080, '\p{Nv=0_0_0_0_0_0_0_0_300000}', "");
    Expect(1, 68080, '\p{^Nv=0_0_0_0_0_0_0_0_300000}', "");
    Expect(1, 68080, '\P{Nv=0_0_0_0_0_0_0_0_300000}', "");
    Expect(0, 68080, '\P{^Nv=0_0_0_0_0_0_0_0_300000}', "");
    Expect(1, 68079, '\p{Nv=3.000000000000000e+05}', "");
    Expect(0, 68079, '\p{^Nv=3.000000000000000e+05}', "");
    Expect(0, 68079, '\P{Nv=3.000000000000000e+05}', "");
    Expect(1, 68079, '\P{^Nv=3.000000000000000e+05}', "");
    Expect(0, 68080, '\p{Nv=3.000000000000000e+05}', "");
    Expect(1, 68080, '\p{^Nv=3.000000000000000e+05}', "");
    Expect(1, 68080, '\P{Nv=3.000000000000000e+05}', "");
    Expect(0, 68080, '\P{^Nv=3.000000000000000e+05}', "");
    Error('\p{Is_Numeric_Value=/a/ 00030000_0}');
    Error('\P{Is_Numeric_Value=/a/ 00030000_0}');
    Expect(1, 68079, '\p{Is_Numeric_Value=000300000}', "");
    Expect(0, 68079, '\p{^Is_Numeric_Value=000300000}', "");
    Expect(0, 68079, '\P{Is_Numeric_Value=000300000}', "");
    Expect(1, 68079, '\P{^Is_Numeric_Value=000300000}', "");
    Expect(0, 68080, '\p{Is_Numeric_Value=000300000}', "");
    Expect(1, 68080, '\p{^Is_Numeric_Value=000300000}', "");
    Expect(1, 68080, '\P{Is_Numeric_Value=000300000}', "");
    Expect(0, 68080, '\P{^Is_Numeric_Value=000300000}', "");
    Expect(1, 68079, '\p{Is_Numeric_Value=3.000000000000000e+05}', "");
    Expect(0, 68079, '\p{^Is_Numeric_Value=3.000000000000000e+05}', "");
    Expect(0, 68079, '\P{Is_Numeric_Value=3.000000000000000e+05}', "");
    Expect(1, 68079, '\P{^Is_Numeric_Value=3.000000000000000e+05}', "");
    Expect(0, 68080, '\p{Is_Numeric_Value=3.000000000000000e+05}', "");
    Expect(1, 68080, '\p{^Is_Numeric_Value=3.000000000000000e+05}', "");
    Expect(1, 68080, '\P{Is_Numeric_Value=3.000000000000000e+05}', "");
    Expect(0, 68080, '\P{^Is_Numeric_Value=3.000000000000000e+05}', "");
    Error('\p{Is_Nv= /a/+0_0_0_0_3_0_0_0_00}');
    Error('\P{Is_Nv= /a/+0_0_0_0_3_0_0_0_00}');
    Expect(1, 68079, '\p{Is_Nv=0_0_0_0_0_0_3_0_0_000}', "");
    Expect(0, 68079, '\p{^Is_Nv=0_0_0_0_0_0_3_0_0_000}', "");
    Expect(0, 68079, '\P{Is_Nv=0_0_0_0_0_0_3_0_0_000}', "");
    Expect(1, 68079, '\P{^Is_Nv=0_0_0_0_0_0_3_0_0_000}', "");
    Expect(0, 68080, '\p{Is_Nv=0_0_0_0_0_0_3_0_0_000}', "");
    Expect(1, 68080, '\p{^Is_Nv=0_0_0_0_0_0_3_0_0_000}', "");
    Expect(1, 68080, '\P{Is_Nv=0_0_0_0_0_0_3_0_0_000}', "");
    Expect(0, 68080, '\P{^Is_Nv=0_0_0_0_0_0_3_0_0_000}', "");
    Expect(1, 68079, '\p{Is_Nv=3.000000000000000e+05}', "");
    Expect(0, 68079, '\p{^Is_Nv=3.000000000000000e+05}', "");
    Expect(0, 68079, '\P{Is_Nv=3.000000000000000e+05}', "");
    Expect(1, 68079, '\P{^Is_Nv=3.000000000000000e+05}', "");
    Expect(0, 68080, '\p{Is_Nv=3.000000000000000e+05}', "");
    Expect(1, 68080, '\p{^Is_Nv=3.000000000000000e+05}', "");
    Expect(1, 68080, '\P{Is_Nv=3.000000000000000e+05}', "");
    Expect(0, 68080, '\P{^Is_Nv=3.000000000000000e+05}', "");
    Error('\p{Numeric_Value=:= _0000031}');
    Error('\P{Numeric_Value=:= _0000031}');
    Expect(1, 12891, '\p{Numeric_Value=:\A31\z:}', "");;
    Expect(0, 12892, '\p{Numeric_Value=:\A31\z:}', "");;
    Expect(1, 12891, '\p{Numeric_Value:+0031}', "");
    Expect(0, 12891, '\p{^Numeric_Value:+0031}', "");
    Expect(0, 12891, '\P{Numeric_Value:+0031}', "");
    Expect(1, 12891, '\P{^Numeric_Value:+0031}', "");
    Expect(0, 12892, '\p{Numeric_Value:+0031}', "");
    Expect(1, 12892, '\p{^Numeric_Value:+0031}', "");
    Expect(1, 12892, '\P{Numeric_Value:+0031}', "");
    Expect(0, 12892, '\P{^Numeric_Value:+0031}', "");
    Expect(1, 12891, '\p{Numeric_Value:   3.100000000000000e+01}', "");
    Expect(0, 12891, '\p{^Numeric_Value:   3.100000000000000e+01}', "");
    Expect(0, 12891, '\P{Numeric_Value:   3.100000000000000e+01}', "");
    Expect(1, 12891, '\P{^Numeric_Value:   3.100000000000000e+01}', "");
    Expect(0, 12892, '\p{Numeric_Value:   3.100000000000000e+01}', "");
    Expect(1, 12892, '\p{^Numeric_Value:   3.100000000000000e+01}', "");
    Expect(1, 12892, '\P{Numeric_Value:   3.100000000000000e+01}', "");
    Expect(0, 12892, '\P{^Numeric_Value:   3.100000000000000e+01}', "");
    Error('\p{Nv=	:=+000000003_1}');
    Error('\P{Nv=	:=+000000003_1}');
    Expect(1, 12891, '\p{Nv=:\A31\z:}', "");;
    Expect(0, 12892, '\p{Nv=:\A31\z:}', "");;
    Expect(1, 12891, '\p{Nv=0_0_0_0_0_00031}', "");
    Expect(0, 12891, '\p{^Nv=0_0_0_0_0_00031}', "");
    Expect(0, 12891, '\P{Nv=0_0_0_0_0_00031}', "");
    Expect(1, 12891, '\P{^Nv=0_0_0_0_0_00031}', "");
    Expect(0, 12892, '\p{Nv=0_0_0_0_0_00031}', "");
    Expect(1, 12892, '\p{^Nv=0_0_0_0_0_00031}', "");
    Expect(1, 12892, '\P{Nv=0_0_0_0_0_00031}', "");
    Expect(0, 12892, '\P{^Nv=0_0_0_0_0_00031}', "");
    Expect(1, 12891, '\p{Nv=3.100000000000000e+01}', "");
    Expect(0, 12891, '\p{^Nv=3.100000000000000e+01}', "");
    Expect(0, 12891, '\P{Nv=3.100000000000000e+01}', "");
    Expect(1, 12891, '\P{^Nv=3.100000000000000e+01}', "");
    Expect(0, 12892, '\p{Nv=3.100000000000000e+01}', "");
    Expect(1, 12892, '\p{^Nv=3.100000000000000e+01}', "");
    Expect(1, 12892, '\P{Nv=3.100000000000000e+01}', "");
    Expect(0, 12892, '\P{^Nv=3.100000000000000e+01}', "");
    Error('\p{Is_Numeric_Value=_/a/000_000_000_31}');
    Error('\P{Is_Numeric_Value=_/a/000_000_000_31}');
    Expect(1, 12891, '\p{Is_Numeric_Value=+0031}', "");
    Expect(0, 12891, '\p{^Is_Numeric_Value=+0031}', "");
    Expect(0, 12891, '\P{Is_Numeric_Value=+0031}', "");
    Expect(1, 12891, '\P{^Is_Numeric_Value=+0031}', "");
    Expect(0, 12892, '\p{Is_Numeric_Value=+0031}', "");
    Expect(1, 12892, '\p{^Is_Numeric_Value=+0031}', "");
    Expect(1, 12892, '\P{Is_Numeric_Value=+0031}', "");
    Expect(0, 12892, '\P{^Is_Numeric_Value=+0031}', "");
    Expect(1, 12891, '\p{Is_Numeric_Value=3.100000000000000e+01}', "");
    Expect(0, 12891, '\p{^Is_Numeric_Value=3.100000000000000e+01}', "");
    Expect(0, 12891, '\P{Is_Numeric_Value=3.100000000000000e+01}', "");
    Expect(1, 12891, '\P{^Is_Numeric_Value=3.100000000000000e+01}', "");
    Expect(0, 12892, '\p{Is_Numeric_Value=3.100000000000000e+01}', "");
    Expect(1, 12892, '\p{^Is_Numeric_Value=3.100000000000000e+01}', "");
    Expect(1, 12892, '\P{Is_Numeric_Value=3.100000000000000e+01}', "");
    Expect(0, 12892, '\P{^Is_Numeric_Value=3.100000000000000e+01}', "");
    Error('\p{Is_Nv=:=	-000031}');
    Error('\P{Is_Nv=:=	-000031}');
    Expect(1, 12891, '\p{Is_Nv=0_0_0_0_0_0_0_0_31}', "");
    Expect(0, 12891, '\p{^Is_Nv=0_0_0_0_0_0_0_0_31}', "");
    Expect(0, 12891, '\P{Is_Nv=0_0_0_0_0_0_0_0_31}', "");
    Expect(1, 12891, '\P{^Is_Nv=0_0_0_0_0_0_0_0_31}', "");
    Expect(0, 12892, '\p{Is_Nv=0_0_0_0_0_0_0_0_31}', "");
    Expect(1, 12892, '\p{^Is_Nv=0_0_0_0_0_0_0_0_31}', "");
    Expect(1, 12892, '\P{Is_Nv=0_0_0_0_0_0_0_0_31}', "");
    Expect(0, 12892, '\P{^Is_Nv=0_0_0_0_0_0_0_0_31}', "");
    Expect(1, 12891, '\p{Is_Nv=3.100000000000000e+01}', "");
    Expect(0, 12891, '\p{^Is_Nv=3.100000000000000e+01}', "");
    Expect(0, 12891, '\P{Is_Nv=3.100000000000000e+01}', "");
    Expect(1, 12891, '\P{^Is_Nv=3.100000000000000e+01}', "");
    Expect(0, 12892, '\p{Is_Nv=3.100000000000000e+01}', "");
    Expect(1, 12892, '\p{^Is_Nv=3.100000000000000e+01}', "");
    Expect(1, 12892, '\P{Is_Nv=3.100000000000000e+01}', "");
    Expect(0, 12892, '\P{^Is_Nv=3.100000000000000e+01}', "");
    Error('\p{Numeric_Value=:=--00000000032}');
    Error('\P{Numeric_Value=:=--00000000032}');
    Expect(1, 12892, '\p{Numeric_Value=:\A32\z:}', "");;
    Expect(0, 12893, '\p{Numeric_Value=:\A32\z:}', "");;
    Expect(1, 12892, '\p{Numeric_Value=032}', "");
    Expect(0, 12892, '\p{^Numeric_Value=032}', "");
    Expect(0, 12892, '\P{Numeric_Value=032}', "");
    Expect(1, 12892, '\P{^Numeric_Value=032}', "");
    Expect(0, 12893, '\p{Numeric_Value=032}', "");
    Expect(1, 12893, '\p{^Numeric_Value=032}', "");
    Expect(1, 12893, '\P{Numeric_Value=032}', "");
    Expect(0, 12893, '\P{^Numeric_Value=032}', "");
    Expect(1, 12892, '\p{Numeric_Value:	3.200000000000000e+01}', "");
    Expect(0, 12892, '\p{^Numeric_Value:	3.200000000000000e+01}', "");
    Expect(0, 12892, '\P{Numeric_Value:	3.200000000000000e+01}', "");
    Expect(1, 12892, '\P{^Numeric_Value:	3.200000000000000e+01}', "");
    Expect(0, 12893, '\p{Numeric_Value:	3.200000000000000e+01}', "");
    Expect(1, 12893, '\p{^Numeric_Value:	3.200000000000000e+01}', "");
    Expect(1, 12893, '\P{Numeric_Value:	3.200000000000000e+01}', "");
    Expect(0, 12893, '\P{^Numeric_Value:	3.200000000000000e+01}', "");
    Error('\p{Nv=/a/ _+00_00_03_2}');
    Error('\P{Nv=/a/ _+00_00_03_2}');
    Expect(1, 12892, '\p{Nv=:\A32\z:}', "");;
    Expect(0, 12893, '\p{Nv=:\A32\z:}', "");;
    Expect(1, 12892, '\p{Nv=00032}', "");
    Expect(0, 12892, '\p{^Nv=00032}', "");
    Expect(0, 12892, '\P{Nv=00032}', "");
    Expect(1, 12892, '\P{^Nv=00032}', "");
    Expect(0, 12893, '\p{Nv=00032}', "");
    Expect(1, 12893, '\p{^Nv=00032}', "");
    Expect(1, 12893, '\P{Nv=00032}', "");
    Expect(0, 12893, '\P{^Nv=00032}', "");
    Expect(1, 12892, '\p{Nv=3.200000000000000e+01}', "");
    Expect(0, 12892, '\p{^Nv=3.200000000000000e+01}', "");
    Expect(0, 12892, '\P{Nv=3.200000000000000e+01}', "");
    Expect(1, 12892, '\P{^Nv=3.200000000000000e+01}', "");
    Expect(0, 12893, '\p{Nv=3.200000000000000e+01}', "");
    Expect(1, 12893, '\p{^Nv=3.200000000000000e+01}', "");
    Expect(1, 12893, '\P{Nv=3.200000000000000e+01}', "");
    Expect(0, 12893, '\P{^Nv=3.200000000000000e+01}', "");
    Error('\p{Is_Numeric_Value=/a/00000_00003_2}');
    Error('\P{Is_Numeric_Value=/a/00000_00003_2}');
    Expect(1, 12892, '\p{Is_Numeric_Value:+000000032}', "");
    Expect(0, 12892, '\p{^Is_Numeric_Value:+000000032}', "");
    Expect(0, 12892, '\P{Is_Numeric_Value:+000000032}', "");
    Expect(1, 12892, '\P{^Is_Numeric_Value:+000000032}', "");
    Expect(0, 12893, '\p{Is_Numeric_Value:+000000032}', "");
    Expect(1, 12893, '\p{^Is_Numeric_Value:+000000032}', "");
    Expect(1, 12893, '\P{Is_Numeric_Value:+000000032}', "");
    Expect(0, 12893, '\P{^Is_Numeric_Value:+000000032}', "");
    Expect(1, 12892, '\p{Is_Numeric_Value=3.200000000000000e+01}', "");
    Expect(0, 12892, '\p{^Is_Numeric_Value=3.200000000000000e+01}', "");
    Expect(0, 12892, '\P{Is_Numeric_Value=3.200000000000000e+01}', "");
    Expect(1, 12892, '\P{^Is_Numeric_Value=3.200000000000000e+01}', "");
    Expect(0, 12893, '\p{Is_Numeric_Value=3.200000000000000e+01}', "");
    Expect(1, 12893, '\p{^Is_Numeric_Value=3.200000000000000e+01}', "");
    Expect(1, 12893, '\P{Is_Numeric_Value=3.200000000000000e+01}', "");
    Expect(0, 12893, '\P{^Is_Numeric_Value=3.200000000000000e+01}', "");
    Error('\p{Is_Nv=/a/+003_2}');
    Error('\P{Is_Nv=/a/+003_2}');
    Expect(1, 12892, '\p{Is_Nv=00000032}', "");
    Expect(0, 12892, '\p{^Is_Nv=00000032}', "");
    Expect(0, 12892, '\P{Is_Nv=00000032}', "");
    Expect(1, 12892, '\P{^Is_Nv=00000032}', "");
    Expect(0, 12893, '\p{Is_Nv=00000032}', "");
    Expect(1, 12893, '\p{^Is_Nv=00000032}', "");
    Expect(1, 12893, '\P{Is_Nv=00000032}', "");
    Expect(0, 12893, '\P{^Is_Nv=00000032}', "");
    Expect(1, 12892, '\p{Is_Nv=3.200000000000000e+01}', "");
    Expect(0, 12892, '\p{^Is_Nv=3.200000000000000e+01}', "");
    Expect(0, 12892, '\P{Is_Nv=3.200000000000000e+01}', "");
    Expect(1, 12892, '\P{^Is_Nv=3.200000000000000e+01}', "");
    Expect(0, 12893, '\p{Is_Nv=3.200000000000000e+01}', "");
    Expect(1, 12893, '\p{^Is_Nv=3.200000000000000e+01}', "");
    Expect(1, 12893, '\P{Is_Nv=3.200000000000000e+01}', "");
    Expect(0, 12893, '\P{^Is_Nv=3.200000000000000e+01}', "");
    Error('\p{Numeric_Value=-:=0000033}');
    Error('\P{Numeric_Value=-:=0000033}');
    Expect(1, 12893, '\p{Numeric_Value=:\A33\z:}', "");;
    Expect(0, 12894, '\p{Numeric_Value=:\A33\z:}', "");;
    Expect(1, 12893, '\p{Numeric_Value=00033}', "");
    Expect(0, 12893, '\p{^Numeric_Value=00033}', "");
    Expect(0, 12893, '\P{Numeric_Value=00033}', "");
    Expect(1, 12893, '\P{^Numeric_Value=00033}', "");
    Expect(0, 12894, '\p{Numeric_Value=00033}', "");
    Expect(1, 12894, '\p{^Numeric_Value=00033}', "");
    Expect(1, 12894, '\P{Numeric_Value=00033}', "");
    Expect(0, 12894, '\P{^Numeric_Value=00033}', "");
    Expect(1, 12893, '\p{Numeric_Value:3.300000000000000e+01}', "");
    Expect(0, 12893, '\p{^Numeric_Value:3.300000000000000e+01}', "");
    Expect(0, 12893, '\P{Numeric_Value:3.300000000000000e+01}', "");
    Expect(1, 12893, '\P{^Numeric_Value:3.300000000000000e+01}', "");
    Expect(0, 12894, '\p{Numeric_Value:3.300000000000000e+01}', "");
    Expect(1, 12894, '\p{^Numeric_Value:3.300000000000000e+01}', "");
    Expect(1, 12894, '\P{Numeric_Value:3.300000000000000e+01}', "");
    Expect(0, 12894, '\P{^Numeric_Value:3.300000000000000e+01}', "");
    Error('\p{Nv=	-0_0_0_0_0033:=}');
    Error('\P{Nv=	-0_0_0_0_0033:=}');
    Expect(1, 12893, '\p{Nv=:\A33\z:}', "");;
    Expect(0, 12894, '\p{Nv=:\A33\z:}', "");;
    Expect(1, 12893, '\p{Nv=+00_03_3}', "");
    Expect(0, 12893, '\p{^Nv=+00_03_3}', "");
    Expect(0, 12893, '\P{Nv=+00_03_3}', "");
    Expect(1, 12893, '\P{^Nv=+00_03_3}', "");
    Expect(0, 12894, '\p{Nv=+00_03_3}', "");
    Expect(1, 12894, '\p{^Nv=+00_03_3}', "");
    Expect(1, 12894, '\P{Nv=+00_03_3}', "");
    Expect(0, 12894, '\P{^Nv=+00_03_3}', "");
    Expect(1, 12893, '\p{Nv=3.300000000000000e+01}', "");
    Expect(0, 12893, '\p{^Nv=3.300000000000000e+01}', "");
    Expect(0, 12893, '\P{Nv=3.300000000000000e+01}', "");
    Expect(1, 12893, '\P{^Nv=3.300000000000000e+01}', "");
    Expect(0, 12894, '\p{Nv=3.300000000000000e+01}', "");
    Expect(1, 12894, '\p{^Nv=3.300000000000000e+01}', "");
    Expect(1, 12894, '\P{Nv=3.300000000000000e+01}', "");
    Expect(0, 12894, '\P{^Nv=3.300000000000000e+01}', "");
    Error('\p{Is_Numeric_Value=-0_0_0_0_0_0_0_33:=}');
    Error('\P{Is_Numeric_Value=-0_0_0_0_0_0_0_33:=}');
    Expect(1, 12893, '\p{Is_Numeric_Value=000033}', "");
    Expect(0, 12893, '\p{^Is_Numeric_Value=000033}', "");
    Expect(0, 12893, '\P{Is_Numeric_Value=000033}', "");
    Expect(1, 12893, '\P{^Is_Numeric_Value=000033}', "");
    Expect(0, 12894, '\p{Is_Numeric_Value=000033}', "");
    Expect(1, 12894, '\p{^Is_Numeric_Value=000033}', "");
    Expect(1, 12894, '\P{Is_Numeric_Value=000033}', "");
    Expect(0, 12894, '\P{^Is_Numeric_Value=000033}', "");
    Expect(1, 12893, '\p{Is_Numeric_Value=3.300000000000000e+01}', "");
    Expect(0, 12893, '\p{^Is_Numeric_Value=3.300000000000000e+01}', "");
    Expect(0, 12893, '\P{Is_Numeric_Value=3.300000000000000e+01}', "");
    Expect(1, 12893, '\P{^Is_Numeric_Value=3.300000000000000e+01}', "");
    Expect(0, 12894, '\p{Is_Numeric_Value=3.300000000000000e+01}', "");
    Expect(1, 12894, '\p{^Is_Numeric_Value=3.300000000000000e+01}', "");
    Expect(1, 12894, '\P{Is_Numeric_Value=3.300000000000000e+01}', "");
    Expect(0, 12894, '\P{^Is_Numeric_Value=3.300000000000000e+01}', "");
    Error('\p{Is_Nv: /a/-0_0_0_0_0_0_00033}');
    Error('\P{Is_Nv: /a/-0_0_0_0_0_0_00033}');
    Expect(1, 12893, '\p{Is_Nv=+000_000_33}', "");
    Expect(0, 12893, '\p{^Is_Nv=+000_000_33}', "");
    Expect(0, 12893, '\P{Is_Nv=+000_000_33}', "");
    Expect(1, 12893, '\P{^Is_Nv=+000_000_33}', "");
    Expect(0, 12894, '\p{Is_Nv=+000_000_33}', "");
    Expect(1, 12894, '\p{^Is_Nv=+000_000_33}', "");
    Expect(1, 12894, '\P{Is_Nv=+000_000_33}', "");
    Expect(0, 12894, '\P{^Is_Nv=+000_000_33}', "");
    Expect(1, 12893, '\p{Is_Nv: 3.300000000000000e+01}', "");
    Expect(0, 12893, '\p{^Is_Nv: 3.300000000000000e+01}', "");
    Expect(0, 12893, '\P{Is_Nv: 3.300000000000000e+01}', "");
    Expect(1, 12893, '\P{^Is_Nv: 3.300000000000000e+01}', "");
    Expect(0, 12894, '\p{Is_Nv: 3.300000000000000e+01}', "");
    Expect(1, 12894, '\p{^Is_Nv: 3.300000000000000e+01}', "");
    Expect(1, 12894, '\P{Is_Nv: 3.300000000000000e+01}', "");
    Expect(0, 12894, '\P{^Is_Nv: 3.300000000000000e+01}', "");
    Error('\p{Numeric_Value= _03_4/a/}');
    Error('\P{Numeric_Value= _03_4/a/}');
    Expect(1, 12894, '\p{Numeric_Value=:\A34\z:}', "");;
    Expect(0, 12895, '\p{Numeric_Value=:\A34\z:}', "");;
    Expect(1, 12894, '\p{Numeric_Value=00000003_4}', "");
    Expect(0, 12894, '\p{^Numeric_Value=00000003_4}', "");
    Expect(0, 12894, '\P{Numeric_Value=00000003_4}', "");
    Expect(1, 12894, '\P{^Numeric_Value=00000003_4}', "");
    Expect(0, 12895, '\p{Numeric_Value=00000003_4}', "");
    Expect(1, 12895, '\p{^Numeric_Value=00000003_4}', "");
    Expect(1, 12895, '\P{Numeric_Value=00000003_4}', "");
    Expect(0, 12895, '\P{^Numeric_Value=00000003_4}', "");
    Expect(1, 12894, '\p{Numeric_Value=3.400000000000000e+01}', "");
    Expect(0, 12894, '\p{^Numeric_Value=3.400000000000000e+01}', "");
    Expect(0, 12894, '\P{Numeric_Value=3.400000000000000e+01}', "");
    Expect(1, 12894, '\P{^Numeric_Value=3.400000000000000e+01}', "");
    Expect(0, 12895, '\p{Numeric_Value=3.400000000000000e+01}', "");
    Expect(1, 12895, '\p{^Numeric_Value=3.400000000000000e+01}', "");
    Expect(1, 12895, '\P{Numeric_Value=3.400000000000000e+01}', "");
    Expect(0, 12895, '\P{^Numeric_Value=3.400000000000000e+01}', "");
    Error('\p{Nv=-_0_0_0_034:=}');
    Error('\P{Nv=-_0_0_0_034:=}');
    Expect(1, 12894, '\p{Nv=:\A34\z:}', "");;
    Expect(0, 12895, '\p{Nv=:\A34\z:}', "");;
    Expect(1, 12894, '\p{Nv=3_4}', "");
    Expect(0, 12894, '\p{^Nv=3_4}', "");
    Expect(0, 12894, '\P{Nv=3_4}', "");
    Expect(1, 12894, '\P{^Nv=3_4}', "");
    Expect(0, 12895, '\p{Nv=3_4}', "");
    Expect(1, 12895, '\p{^Nv=3_4}', "");
    Expect(1, 12895, '\P{Nv=3_4}', "");
    Expect(0, 12895, '\P{^Nv=3_4}', "");
    Expect(1, 12894, '\p{Nv=3.400000000000000e+01}', "");
    Expect(0, 12894, '\p{^Nv=3.400000000000000e+01}', "");
    Expect(0, 12894, '\P{Nv=3.400000000000000e+01}', "");
    Expect(1, 12894, '\P{^Nv=3.400000000000000e+01}', "");
    Expect(0, 12895, '\p{Nv=3.400000000000000e+01}', "");
    Expect(1, 12895, '\p{^Nv=3.400000000000000e+01}', "");
    Expect(1, 12895, '\P{Nv=3.400000000000000e+01}', "");
    Expect(0, 12895, '\P{^Nv=3.400000000000000e+01}', "");
    Error('\p{Is_Numeric_Value=:=_+0_0_0_0_034}');
    Error('\P{Is_Numeric_Value=:=_+0_0_0_0_034}');
    Expect(1, 12894, '\p{Is_Numeric_Value=000000034}', "");
    Expect(0, 12894, '\p{^Is_Numeric_Value=000000034}', "");
    Expect(0, 12894, '\P{Is_Numeric_Value=000000034}', "");
    Expect(1, 12894, '\P{^Is_Numeric_Value=000000034}', "");
    Expect(0, 12895, '\p{Is_Numeric_Value=000000034}', "");
    Expect(1, 12895, '\p{^Is_Numeric_Value=000000034}', "");
    Expect(1, 12895, '\P{Is_Numeric_Value=000000034}', "");
    Expect(0, 12895, '\P{^Is_Numeric_Value=000000034}', "");
    Expect(1, 12894, '\p{Is_Numeric_Value: 3.400000000000000e+01}', "");
    Expect(0, 12894, '\p{^Is_Numeric_Value: 3.400000000000000e+01}', "");
    Expect(0, 12894, '\P{Is_Numeric_Value: 3.400000000000000e+01}', "");
    Expect(1, 12894, '\P{^Is_Numeric_Value: 3.400000000000000e+01}', "");
    Expect(0, 12895, '\p{Is_Numeric_Value: 3.400000000000000e+01}', "");
    Expect(1, 12895, '\p{^Is_Numeric_Value: 3.400000000000000e+01}', "");
    Expect(1, 12895, '\P{Is_Numeric_Value: 3.400000000000000e+01}', "");
    Expect(0, 12895, '\P{^Is_Numeric_Value: 3.400000000000000e+01}', "");
    Error('\p{Is_Nv=_ +00000034:=}');
    Error('\P{Is_Nv=_ +00000034:=}');
    Expect(1, 12894, '\p{Is_Nv=+034}', "");
    Expect(0, 12894, '\p{^Is_Nv=+034}', "");
    Expect(0, 12894, '\P{Is_Nv=+034}', "");
    Expect(1, 12894, '\P{^Is_Nv=+034}', "");
    Expect(0, 12895, '\p{Is_Nv=+034}', "");
    Expect(1, 12895, '\p{^Is_Nv=+034}', "");
    Expect(1, 12895, '\P{Is_Nv=+034}', "");
    Expect(0, 12895, '\P{^Is_Nv=+034}', "");
    Expect(1, 12894, '\p{Is_Nv=3.400000000000000e+01}', "");
    Expect(0, 12894, '\p{^Is_Nv=3.400000000000000e+01}', "");
    Expect(0, 12894, '\P{Is_Nv=3.400000000000000e+01}', "");
    Expect(1, 12894, '\P{^Is_Nv=3.400000000000000e+01}', "");
    Expect(0, 12895, '\p{Is_Nv=3.400000000000000e+01}', "");
    Expect(1, 12895, '\p{^Is_Nv=3.400000000000000e+01}', "");
    Expect(1, 12895, '\P{Is_Nv=3.400000000000000e+01}', "");
    Expect(0, 12895, '\P{^Is_Nv=3.400000000000000e+01}', "");
    Error('\p{Numeric_Value=_/a/00000000035}');
    Error('\P{Numeric_Value=_/a/00000000035}');
    Expect(1, 12895, '\p{Numeric_Value=:\A35\z:}', "");;
    Expect(0, 12896, '\p{Numeric_Value=:\A35\z:}', "");;
    Expect(1, 12895, '\p{Numeric_Value=035}', "");
    Expect(0, 12895, '\p{^Numeric_Value=035}', "");
    Expect(0, 12895, '\P{Numeric_Value=035}', "");
    Expect(1, 12895, '\P{^Numeric_Value=035}', "");
    Expect(0, 12896, '\p{Numeric_Value=035}', "");
    Expect(1, 12896, '\p{^Numeric_Value=035}', "");
    Expect(1, 12896, '\P{Numeric_Value=035}', "");
    Expect(0, 12896, '\P{^Numeric_Value=035}', "");
    Expect(1, 12895, '\p{Numeric_Value=3.500000000000000e+01}', "");
    Expect(0, 12895, '\p{^Numeric_Value=3.500000000000000e+01}', "");
    Expect(0, 12895, '\P{Numeric_Value=3.500000000000000e+01}', "");
    Expect(1, 12895, '\P{^Numeric_Value=3.500000000000000e+01}', "");
    Expect(0, 12896, '\p{Numeric_Value=3.500000000000000e+01}', "");
    Expect(1, 12896, '\p{^Numeric_Value=3.500000000000000e+01}', "");
    Expect(1, 12896, '\P{Numeric_Value=3.500000000000000e+01}', "");
    Expect(0, 12896, '\P{^Numeric_Value=3.500000000000000e+01}', "");
    Error('\p{Nv=__35:=}');
    Error('\P{Nv=__35:=}');
    Expect(1, 12895, '\p{Nv=:\A35\z:}', "");;
    Expect(0, 12896, '\p{Nv=:\A35\z:}', "");;
    Expect(1, 12895, '\p{Nv:   00_00_00_00_035}', "");
    Expect(0, 12895, '\p{^Nv:   00_00_00_00_035}', "");
    Expect(0, 12895, '\P{Nv:   00_00_00_00_035}', "");
    Expect(1, 12895, '\P{^Nv:   00_00_00_00_035}', "");
    Expect(0, 12896, '\p{Nv:   00_00_00_00_035}', "");
    Expect(1, 12896, '\p{^Nv:   00_00_00_00_035}', "");
    Expect(1, 12896, '\P{Nv:   00_00_00_00_035}', "");
    Expect(0, 12896, '\P{^Nv:   00_00_00_00_035}', "");
    Expect(1, 12895, '\p{Nv=3.500000000000000e+01}', "");
    Expect(0, 12895, '\p{^Nv=3.500000000000000e+01}', "");
    Expect(0, 12895, '\P{Nv=3.500000000000000e+01}', "");
    Expect(1, 12895, '\P{^Nv=3.500000000000000e+01}', "");
    Expect(0, 12896, '\p{Nv=3.500000000000000e+01}', "");
    Expect(1, 12896, '\p{^Nv=3.500000000000000e+01}', "");
    Expect(1, 12896, '\P{Nv=3.500000000000000e+01}', "");
    Expect(0, 12896, '\P{^Nv=3.500000000000000e+01}', "");
    Error('\p{Is_Numeric_Value=/a/-+0_0_0_35}');
    Error('\P{Is_Numeric_Value=/a/-+0_0_0_35}');
    Expect(1, 12895, '\p{Is_Numeric_Value=000000035}', "");
    Expect(0, 12895, '\p{^Is_Numeric_Value=000000035}', "");
    Expect(0, 12895, '\P{Is_Numeric_Value=000000035}', "");
    Expect(1, 12895, '\P{^Is_Numeric_Value=000000035}', "");
    Expect(0, 12896, '\p{Is_Numeric_Value=000000035}', "");
    Expect(1, 12896, '\p{^Is_Numeric_Value=000000035}', "");
    Expect(1, 12896, '\P{Is_Numeric_Value=000000035}', "");
    Expect(0, 12896, '\P{^Is_Numeric_Value=000000035}', "");
    Expect(1, 12895, '\p{Is_Numeric_Value:3.500000000000000e+01}', "");
    Expect(0, 12895, '\p{^Is_Numeric_Value:3.500000000000000e+01}', "");
    Expect(0, 12895, '\P{Is_Numeric_Value:3.500000000000000e+01}', "");
    Expect(1, 12895, '\P{^Is_Numeric_Value:3.500000000000000e+01}', "");
    Expect(0, 12896, '\p{Is_Numeric_Value:3.500000000000000e+01}', "");
    Expect(1, 12896, '\p{^Is_Numeric_Value:3.500000000000000e+01}', "");
    Expect(1, 12896, '\P{Is_Numeric_Value:3.500000000000000e+01}', "");
    Expect(0, 12896, '\P{^Is_Numeric_Value:3.500000000000000e+01}', "");
    Error('\p{Is_Nv=	 +00000035/a/}');
    Error('\P{Is_Nv=	 +00000035/a/}');
    Expect(1, 12895, '\p{Is_Nv=+00000035}', "");
    Expect(0, 12895, '\p{^Is_Nv=+00000035}', "");
    Expect(0, 12895, '\P{Is_Nv=+00000035}', "");
    Expect(1, 12895, '\P{^Is_Nv=+00000035}', "");
    Expect(0, 12896, '\p{Is_Nv=+00000035}', "");
    Expect(1, 12896, '\p{^Is_Nv=+00000035}', "");
    Expect(1, 12896, '\P{Is_Nv=+00000035}', "");
    Expect(0, 12896, '\P{^Is_Nv=+00000035}', "");
    Expect(1, 12895, '\p{Is_Nv=3.500000000000000e+01}', "");
    Expect(0, 12895, '\p{^Is_Nv=3.500000000000000e+01}', "");
    Expect(0, 12895, '\P{Is_Nv=3.500000000000000e+01}', "");
    Expect(1, 12895, '\P{^Is_Nv=3.500000000000000e+01}', "");
    Expect(0, 12896, '\p{Is_Nv=3.500000000000000e+01}', "");
    Expect(1, 12896, '\p{^Is_Nv=3.500000000000000e+01}', "");
    Expect(1, 12896, '\P{Is_Nv=3.500000000000000e+01}', "");
    Expect(0, 12896, '\P{^Is_Nv=3.500000000000000e+01}', "");
    Error('\p{Numeric_Value=:=	-0_0_0_0_0_036}');
    Error('\P{Numeric_Value=:=	-0_0_0_0_0_036}');
    Expect(1, 12977, '\p{Numeric_Value=:\A36\z:}', "");;
    Expect(0, 12978, '\p{Numeric_Value=:\A36\z:}', "");;
    Expect(1, 12977, '\p{Numeric_Value=3_6}', "");
    Expect(0, 12977, '\p{^Numeric_Value=3_6}', "");
    Expect(0, 12977, '\P{Numeric_Value=3_6}', "");
    Expect(1, 12977, '\P{^Numeric_Value=3_6}', "");
    Expect(0, 12978, '\p{Numeric_Value=3_6}', "");
    Expect(1, 12978, '\p{^Numeric_Value=3_6}', "");
    Expect(1, 12978, '\P{Numeric_Value=3_6}', "");
    Expect(0, 12978, '\P{^Numeric_Value=3_6}', "");
    Expect(1, 12977, '\p{Numeric_Value=3.600000000000000e+01}', "");
    Expect(0, 12977, '\p{^Numeric_Value=3.600000000000000e+01}', "");
    Expect(0, 12977, '\P{Numeric_Value=3.600000000000000e+01}', "");
    Expect(1, 12977, '\P{^Numeric_Value=3.600000000000000e+01}', "");
    Expect(0, 12978, '\p{Numeric_Value=3.600000000000000e+01}', "");
    Expect(1, 12978, '\p{^Numeric_Value=3.600000000000000e+01}', "");
    Expect(1, 12978, '\P{Numeric_Value=3.600000000000000e+01}', "");
    Expect(0, 12978, '\P{^Numeric_Value=3.600000000000000e+01}', "");
    Error('\p{Nv= _000_000_003_6/a/}');
    Error('\P{Nv= _000_000_003_6/a/}');
    Expect(1, 12977, '\p{Nv=:\A36\z:}', "");;
    Expect(0, 12978, '\p{Nv=:\A36\z:}', "");;
    Expect(1, 12977, '\p{Nv=036}', "");
    Expect(0, 12977, '\p{^Nv=036}', "");
    Expect(0, 12977, '\P{Nv=036}', "");
    Expect(1, 12977, '\P{^Nv=036}', "");
    Expect(0, 12978, '\p{Nv=036}', "");
    Expect(1, 12978, '\p{^Nv=036}', "");
    Expect(1, 12978, '\P{Nv=036}', "");
    Expect(0, 12978, '\P{^Nv=036}', "");
    Expect(1, 12977, '\p{Nv=3.600000000000000e+01}', "");
    Expect(0, 12977, '\p{^Nv=3.600000000000000e+01}', "");
    Expect(0, 12977, '\P{Nv=3.600000000000000e+01}', "");
    Expect(1, 12977, '\P{^Nv=3.600000000000000e+01}', "");
    Expect(0, 12978, '\p{Nv=3.600000000000000e+01}', "");
    Expect(1, 12978, '\p{^Nv=3.600000000000000e+01}', "");
    Expect(1, 12978, '\P{Nv=3.600000000000000e+01}', "");
    Expect(0, 12978, '\P{^Nv=3.600000000000000e+01}', "");
    Error('\p{Is_Numeric_Value=:=_-003_6}');
    Error('\P{Is_Numeric_Value=:=_-003_6}');
    Expect(1, 12977, '\p{Is_Numeric_Value=0003_6}', "");
    Expect(0, 12977, '\p{^Is_Numeric_Value=0003_6}', "");
    Expect(0, 12977, '\P{Is_Numeric_Value=0003_6}', "");
    Expect(1, 12977, '\P{^Is_Numeric_Value=0003_6}', "");
    Expect(0, 12978, '\p{Is_Numeric_Value=0003_6}', "");
    Expect(1, 12978, '\p{^Is_Numeric_Value=0003_6}', "");
    Expect(1, 12978, '\P{Is_Numeric_Value=0003_6}', "");
    Expect(0, 12978, '\P{^Is_Numeric_Value=0003_6}', "");
    Expect(1, 12977, '\p{Is_Numeric_Value=3.600000000000000e+01}', "");
    Expect(0, 12977, '\p{^Is_Numeric_Value=3.600000000000000e+01}', "");
    Expect(0, 12977, '\P{Is_Numeric_Value=3.600000000000000e+01}', "");
    Expect(1, 12977, '\P{^Is_Numeric_Value=3.600000000000000e+01}', "");
    Expect(0, 12978, '\p{Is_Numeric_Value=3.600000000000000e+01}', "");
    Expect(1, 12978, '\p{^Is_Numeric_Value=3.600000000000000e+01}', "");
    Expect(1, 12978, '\P{Is_Numeric_Value=3.600000000000000e+01}', "");
    Expect(0, 12978, '\P{^Is_Numeric_Value=3.600000000000000e+01}', "");
    Error('\p{Is_Nv=-3_6/a/}');
    Error('\P{Is_Nv=-3_6/a/}');
    Expect(1, 12977, '\p{Is_Nv=+0_0_0_036}', "");
    Expect(0, 12977, '\p{^Is_Nv=+0_0_0_036}', "");
    Expect(0, 12977, '\P{Is_Nv=+0_0_0_036}', "");
    Expect(1, 12977, '\P{^Is_Nv=+0_0_0_036}', "");
    Expect(0, 12978, '\p{Is_Nv=+0_0_0_036}', "");
    Expect(1, 12978, '\p{^Is_Nv=+0_0_0_036}', "");
    Expect(1, 12978, '\P{Is_Nv=+0_0_0_036}', "");
    Expect(0, 12978, '\P{^Is_Nv=+0_0_0_036}', "");
    Expect(1, 12977, '\p{Is_Nv=3.600000000000000e+01}', "");
    Expect(0, 12977, '\p{^Is_Nv=3.600000000000000e+01}', "");
    Expect(0, 12977, '\P{Is_Nv=3.600000000000000e+01}', "");
    Expect(1, 12977, '\P{^Is_Nv=3.600000000000000e+01}', "");
    Expect(0, 12978, '\p{Is_Nv=3.600000000000000e+01}', "");
    Expect(1, 12978, '\p{^Is_Nv=3.600000000000000e+01}', "");
    Expect(1, 12978, '\P{Is_Nv=3.600000000000000e+01}', "");
    Expect(0, 12978, '\P{^Is_Nv=3.600000000000000e+01}', "");
    Error('\p{Numeric_Value=/a/00000037}');
    Error('\P{Numeric_Value=/a/00000037}');
    Expect(1, 12978, '\p{Numeric_Value=:\A37\z:}', "");;
    Expect(0, 12979, '\p{Numeric_Value=:\A37\z:}', "");;
    Expect(1, 12978, '\p{Numeric_Value=0_0_0_0_037}', "");
    Expect(0, 12978, '\p{^Numeric_Value=0_0_0_0_037}', "");
    Expect(0, 12978, '\P{Numeric_Value=0_0_0_0_037}', "");
    Expect(1, 12978, '\P{^Numeric_Value=0_0_0_0_037}', "");
    Expect(0, 12979, '\p{Numeric_Value=0_0_0_0_037}', "");
    Expect(1, 12979, '\p{^Numeric_Value=0_0_0_0_037}', "");
    Expect(1, 12979, '\P{Numeric_Value=0_0_0_0_037}', "");
    Expect(0, 12979, '\P{^Numeric_Value=0_0_0_0_037}', "");
    Expect(1, 12978, '\p{Numeric_Value=3.700000000000000e+01}', "");
    Expect(0, 12978, '\p{^Numeric_Value=3.700000000000000e+01}', "");
    Expect(0, 12978, '\P{Numeric_Value=3.700000000000000e+01}', "");
    Expect(1, 12978, '\P{^Numeric_Value=3.700000000000000e+01}', "");
    Expect(0, 12979, '\p{Numeric_Value=3.700000000000000e+01}', "");
    Expect(1, 12979, '\p{^Numeric_Value=3.700000000000000e+01}', "");
    Expect(1, 12979, '\P{Numeric_Value=3.700000000000000e+01}', "");
    Expect(0, 12979, '\P{^Numeric_Value=3.700000000000000e+01}', "");
    Error('\p{Nv=:=_000_003_7}');
    Error('\P{Nv=:=_000_003_7}');
    Expect(1, 12978, '\p{Nv=:\A37\z:}', "");;
    Expect(0, 12979, '\p{Nv=:\A37\z:}', "");;
    Expect(1, 12978, '\p{Nv=00000000037}', "");
    Expect(0, 12978, '\p{^Nv=00000000037}', "");
    Expect(0, 12978, '\P{Nv=00000000037}', "");
    Expect(1, 12978, '\P{^Nv=00000000037}', "");
    Expect(0, 12979, '\p{Nv=00000000037}', "");
    Expect(1, 12979, '\p{^Nv=00000000037}', "");
    Expect(1, 12979, '\P{Nv=00000000037}', "");
    Expect(0, 12979, '\P{^Nv=00000000037}', "");
    Expect(1, 12978, '\p{Nv=3.700000000000000e+01}', "");
    Expect(0, 12978, '\p{^Nv=3.700000000000000e+01}', "");
    Expect(0, 12978, '\P{Nv=3.700000000000000e+01}', "");
    Expect(1, 12978, '\P{^Nv=3.700000000000000e+01}', "");
    Expect(0, 12979, '\p{Nv=3.700000000000000e+01}', "");
    Expect(1, 12979, '\p{^Nv=3.700000000000000e+01}', "");
    Expect(1, 12979, '\P{Nv=3.700000000000000e+01}', "");
    Expect(0, 12979, '\P{^Nv=3.700000000000000e+01}', "");
    Error('\p{Is_Numeric_Value=	:=00000_00003_7}');
    Error('\P{Is_Numeric_Value=	:=00000_00003_7}');
    Expect(1, 12978, '\p{Is_Numeric_Value:   00000037}', "");
    Expect(0, 12978, '\p{^Is_Numeric_Value:   00000037}', "");
    Expect(0, 12978, '\P{Is_Numeric_Value:   00000037}', "");
    Expect(1, 12978, '\P{^Is_Numeric_Value:   00000037}', "");
    Expect(0, 12979, '\p{Is_Numeric_Value:   00000037}', "");
    Expect(1, 12979, '\p{^Is_Numeric_Value:   00000037}', "");
    Expect(1, 12979, '\P{Is_Numeric_Value:   00000037}', "");
    Expect(0, 12979, '\P{^Is_Numeric_Value:   00000037}', "");
    Expect(1, 12978, '\p{Is_Numeric_Value=3.700000000000000e+01}', "");
    Expect(0, 12978, '\p{^Is_Numeric_Value=3.700000000000000e+01}', "");
    Expect(0, 12978, '\P{Is_Numeric_Value=3.700000000000000e+01}', "");
    Expect(1, 12978, '\P{^Is_Numeric_Value=3.700000000000000e+01}', "");
    Expect(0, 12979, '\p{Is_Numeric_Value=3.700000000000000e+01}', "");
    Expect(1, 12979, '\p{^Is_Numeric_Value=3.700000000000000e+01}', "");
    Expect(1, 12979, '\P{Is_Numeric_Value=3.700000000000000e+01}', "");
    Expect(0, 12979, '\P{^Is_Numeric_Value=3.700000000000000e+01}', "");
    Error('\p{Is_Nv=/a/_000000037}');
    Error('\P{Is_Nv=/a/_000000037}');
    Expect(1, 12978, '\p{Is_Nv=+0037}', "");
    Expect(0, 12978, '\p{^Is_Nv=+0037}', "");
    Expect(0, 12978, '\P{Is_Nv=+0037}', "");
    Expect(1, 12978, '\P{^Is_Nv=+0037}', "");
    Expect(0, 12979, '\p{Is_Nv=+0037}', "");
    Expect(1, 12979, '\p{^Is_Nv=+0037}', "");
    Expect(1, 12979, '\P{Is_Nv=+0037}', "");
    Expect(0, 12979, '\P{^Is_Nv=+0037}', "");
    Expect(1, 12978, '\p{Is_Nv=3.700000000000000e+01}', "");
    Expect(0, 12978, '\p{^Is_Nv=3.700000000000000e+01}', "");
    Expect(0, 12978, '\P{Is_Nv=3.700000000000000e+01}', "");
    Expect(1, 12978, '\P{^Is_Nv=3.700000000000000e+01}', "");
    Expect(0, 12979, '\p{Is_Nv=3.700000000000000e+01}', "");
    Expect(1, 12979, '\p{^Is_Nv=3.700000000000000e+01}', "");
    Expect(1, 12979, '\P{Is_Nv=3.700000000000000e+01}', "");
    Expect(0, 12979, '\P{^Is_Nv=3.700000000000000e+01}', "");
    Error('\p{Numeric_Value= _+38:=}');
    Error('\P{Numeric_Value= _+38:=}');
    Expect(1, 12979, '\p{Numeric_Value=:\A38\z:}', "");;
    Expect(0, 12980, '\p{Numeric_Value=:\A38\z:}', "");;
    Expect(1, 12979, '\p{Numeric_Value:	+38}', "");
    Expect(0, 12979, '\p{^Numeric_Value:	+38}', "");
    Expect(0, 12979, '\P{Numeric_Value:	+38}', "");
    Expect(1, 12979, '\P{^Numeric_Value:	+38}', "");
    Expect(0, 12980, '\p{Numeric_Value:	+38}', "");
    Expect(1, 12980, '\p{^Numeric_Value:	+38}', "");
    Expect(1, 12980, '\P{Numeric_Value:	+38}', "");
    Expect(0, 12980, '\P{^Numeric_Value:	+38}', "");
    Expect(1, 12979, '\p{Numeric_Value=3.800000000000000e+01}', "");
    Expect(0, 12979, '\p{^Numeric_Value=3.800000000000000e+01}', "");
    Expect(0, 12979, '\P{Numeric_Value=3.800000000000000e+01}', "");
    Expect(1, 12979, '\P{^Numeric_Value=3.800000000000000e+01}', "");
    Expect(0, 12980, '\p{Numeric_Value=3.800000000000000e+01}', "");
    Expect(1, 12980, '\p{^Numeric_Value=3.800000000000000e+01}', "");
    Expect(1, 12980, '\P{Numeric_Value=3.800000000000000e+01}', "");
    Expect(0, 12980, '\P{^Numeric_Value=3.800000000000000e+01}', "");
    Error('\p{Nv=:=--0_0_0_0_0_0038}');
    Error('\P{Nv=:=--0_0_0_0_0_0038}');
    Expect(1, 12979, '\p{Nv=:\A38\z:}', "");;
    Expect(0, 12980, '\p{Nv=:\A38\z:}', "");;
    Expect(1, 12979, '\p{Nv=000_003_8}', "");
    Expect(0, 12979, '\p{^Nv=000_003_8}', "");
    Expect(0, 12979, '\P{Nv=000_003_8}', "");
    Expect(1, 12979, '\P{^Nv=000_003_8}', "");
    Expect(0, 12980, '\p{Nv=000_003_8}', "");
    Expect(1, 12980, '\p{^Nv=000_003_8}', "");
    Expect(1, 12980, '\P{Nv=000_003_8}', "");
    Expect(0, 12980, '\P{^Nv=000_003_8}', "");
    Expect(1, 12979, '\p{Nv:	3.800000000000000e+01}', "");
    Expect(0, 12979, '\p{^Nv:	3.800000000000000e+01}', "");
    Expect(0, 12979, '\P{Nv:	3.800000000000000e+01}', "");
    Expect(1, 12979, '\P{^Nv:	3.800000000000000e+01}', "");
    Expect(0, 12980, '\p{Nv:	3.800000000000000e+01}', "");
    Expect(1, 12980, '\p{^Nv:	3.800000000000000e+01}', "");
    Expect(1, 12980, '\P{Nv:	3.800000000000000e+01}', "");
    Expect(0, 12980, '\P{^Nv:	3.800000000000000e+01}', "");
    Error('\p{Is_Numeric_Value:    _3_8/a/}');
    Error('\P{Is_Numeric_Value:    _3_8/a/}');
    Expect(1, 12979, '\p{Is_Numeric_Value=0_0_0_0_0_0_0_0_0_38}', "");
    Expect(0, 12979, '\p{^Is_Numeric_Value=0_0_0_0_0_0_0_0_0_38}', "");
    Expect(0, 12979, '\P{Is_Numeric_Value=0_0_0_0_0_0_0_0_0_38}', "");
    Expect(1, 12979, '\P{^Is_Numeric_Value=0_0_0_0_0_0_0_0_0_38}', "");
    Expect(0, 12980, '\p{Is_Numeric_Value=0_0_0_0_0_0_0_0_0_38}', "");
    Expect(1, 12980, '\p{^Is_Numeric_Value=0_0_0_0_0_0_0_0_0_38}', "");
    Expect(1, 12980, '\P{Is_Numeric_Value=0_0_0_0_0_0_0_0_0_38}', "");
    Expect(0, 12980, '\P{^Is_Numeric_Value=0_0_0_0_0_0_0_0_0_38}', "");
    Expect(1, 12979, '\p{Is_Numeric_Value=3.800000000000000e+01}', "");
    Expect(0, 12979, '\p{^Is_Numeric_Value=3.800000000000000e+01}', "");
    Expect(0, 12979, '\P{Is_Numeric_Value=3.800000000000000e+01}', "");
    Expect(1, 12979, '\P{^Is_Numeric_Value=3.800000000000000e+01}', "");
    Expect(0, 12980, '\p{Is_Numeric_Value=3.800000000000000e+01}', "");
    Expect(1, 12980, '\p{^Is_Numeric_Value=3.800000000000000e+01}', "");
    Expect(1, 12980, '\P{Is_Numeric_Value=3.800000000000000e+01}', "");
    Expect(0, 12980, '\P{^Is_Numeric_Value=3.800000000000000e+01}', "");
    Error('\p{Is_Nv=/a/ 03_8}');
    Error('\P{Is_Nv=/a/ 03_8}');
    Expect(1, 12979, '\p{Is_Nv=+0000003_8}', "");
    Expect(0, 12979, '\p{^Is_Nv=+0000003_8}', "");
    Expect(0, 12979, '\P{Is_Nv=+0000003_8}', "");
    Expect(1, 12979, '\P{^Is_Nv=+0000003_8}', "");
    Expect(0, 12980, '\p{Is_Nv=+0000003_8}', "");
    Expect(1, 12980, '\p{^Is_Nv=+0000003_8}', "");
    Expect(1, 12980, '\P{Is_Nv=+0000003_8}', "");
    Expect(0, 12980, '\P{^Is_Nv=+0000003_8}', "");
    Expect(1, 12979, '\p{Is_Nv=3.800000000000000e+01}', "");
    Expect(0, 12979, '\p{^Is_Nv=3.800000000000000e+01}', "");
    Expect(0, 12979, '\P{Is_Nv=3.800000000000000e+01}', "");
    Expect(1, 12979, '\P{^Is_Nv=3.800000000000000e+01}', "");
    Expect(0, 12980, '\p{Is_Nv=3.800000000000000e+01}', "");
    Expect(1, 12980, '\p{^Is_Nv=3.800000000000000e+01}', "");
    Expect(1, 12980, '\P{Is_Nv=3.800000000000000e+01}', "");
    Expect(0, 12980, '\P{^Is_Nv=3.800000000000000e+01}', "");
    Error('\p{Numeric_Value=:=  +00000000039}');
    Error('\P{Numeric_Value=:=  +00000000039}');
    Expect(1, 12980, '\p{Numeric_Value=:\A39\z:}', "");;
    Expect(0, 12981, '\p{Numeric_Value=:\A39\z:}', "");;
    Expect(1, 12980, '\p{Numeric_Value=0_0_39}', "");
    Expect(0, 12980, '\p{^Numeric_Value=0_0_39}', "");
    Expect(0, 12980, '\P{Numeric_Value=0_0_39}', "");
    Expect(1, 12980, '\P{^Numeric_Value=0_0_39}', "");
    Expect(0, 12981, '\p{Numeric_Value=0_0_39}', "");
    Expect(1, 12981, '\p{^Numeric_Value=0_0_39}', "");
    Expect(1, 12981, '\P{Numeric_Value=0_0_39}', "");
    Expect(0, 12981, '\P{^Numeric_Value=0_0_39}', "");
    Expect(1, 12980, '\p{Numeric_Value=3.900000000000000e+01}', "");
    Expect(0, 12980, '\p{^Numeric_Value=3.900000000000000e+01}', "");
    Expect(0, 12980, '\P{Numeric_Value=3.900000000000000e+01}', "");
    Expect(1, 12980, '\P{^Numeric_Value=3.900000000000000e+01}', "");
    Expect(0, 12981, '\p{Numeric_Value=3.900000000000000e+01}', "");
    Expect(1, 12981, '\p{^Numeric_Value=3.900000000000000e+01}', "");
    Expect(1, 12981, '\P{Numeric_Value=3.900000000000000e+01}', "");
    Expect(0, 12981, '\P{^Numeric_Value=3.900000000000000e+01}', "");
    Error('\p{Nv=	/a/39}');
    Error('\P{Nv=	/a/39}');
    Expect(1, 12980, '\p{Nv=:\A39\z:}', "");;
    Expect(0, 12981, '\p{Nv=:\A39\z:}', "");;
    Expect(1, 12980, '\p{Nv=+0000000039}', "");
    Expect(0, 12980, '\p{^Nv=+0000000039}', "");
    Expect(0, 12980, '\P{Nv=+0000000039}', "");
    Expect(1, 12980, '\P{^Nv=+0000000039}', "");
    Expect(0, 12981, '\p{Nv=+0000000039}', "");
    Expect(1, 12981, '\p{^Nv=+0000000039}', "");
    Expect(1, 12981, '\P{Nv=+0000000039}', "");
    Expect(0, 12981, '\P{^Nv=+0000000039}', "");
    Expect(1, 12980, '\p{Nv=3.900000000000000e+01}', "");
    Expect(0, 12980, '\p{^Nv=3.900000000000000e+01}', "");
    Expect(0, 12980, '\P{Nv=3.900000000000000e+01}', "");
    Expect(1, 12980, '\P{^Nv=3.900000000000000e+01}', "");
    Expect(0, 12981, '\p{Nv=3.900000000000000e+01}', "");
    Expect(1, 12981, '\p{^Nv=3.900000000000000e+01}', "");
    Expect(1, 12981, '\P{Nv=3.900000000000000e+01}', "");
    Expect(0, 12981, '\P{^Nv=3.900000000000000e+01}', "");
    Error('\p{Is_Numeric_Value=_000_003_9:=}');
    Error('\P{Is_Numeric_Value=_000_003_9:=}');
    Expect(1, 12980, '\p{Is_Numeric_Value=+0_0_0_039}', "");
    Expect(0, 12980, '\p{^Is_Numeric_Value=+0_0_0_039}', "");
    Expect(0, 12980, '\P{Is_Numeric_Value=+0_0_0_039}', "");
    Expect(1, 12980, '\P{^Is_Numeric_Value=+0_0_0_039}', "");
    Expect(0, 12981, '\p{Is_Numeric_Value=+0_0_0_039}', "");
    Expect(1, 12981, '\p{^Is_Numeric_Value=+0_0_0_039}', "");
    Expect(1, 12981, '\P{Is_Numeric_Value=+0_0_0_039}', "");
    Expect(0, 12981, '\P{^Is_Numeric_Value=+0_0_0_039}', "");
    Expect(1, 12980, '\p{Is_Numeric_Value=3.900000000000000e+01}', "");
    Expect(0, 12980, '\p{^Is_Numeric_Value=3.900000000000000e+01}', "");
    Expect(0, 12980, '\P{Is_Numeric_Value=3.900000000000000e+01}', "");
    Expect(1, 12980, '\P{^Is_Numeric_Value=3.900000000000000e+01}', "");
    Expect(0, 12981, '\p{Is_Numeric_Value=3.900000000000000e+01}', "");
    Expect(1, 12981, '\p{^Is_Numeric_Value=3.900000000000000e+01}', "");
    Expect(1, 12981, '\P{Is_Numeric_Value=3.900000000000000e+01}', "");
    Expect(0, 12981, '\P{^Is_Numeric_Value=3.900000000000000e+01}', "");
    Error('\p{Is_Nv=/a/	-0000039}');
    Error('\P{Is_Nv=/a/	-0000039}');
    Expect(1, 12980, '\p{Is_Nv=+0000039}', "");
    Expect(0, 12980, '\p{^Is_Nv=+0000039}', "");
    Expect(0, 12980, '\P{Is_Nv=+0000039}', "");
    Expect(1, 12980, '\P{^Is_Nv=+0000039}', "");
    Expect(0, 12981, '\p{Is_Nv=+0000039}', "");
    Expect(1, 12981, '\p{^Is_Nv=+0000039}', "");
    Expect(1, 12981, '\P{Is_Nv=+0000039}', "");
    Expect(0, 12981, '\P{^Is_Nv=+0000039}', "");
    Expect(1, 12980, '\p{Is_Nv=3.900000000000000e+01}', "");
    Expect(0, 12980, '\p{^Is_Nv=3.900000000000000e+01}', "");
    Expect(0, 12980, '\P{Is_Nv=3.900000000000000e+01}', "");
    Expect(1, 12980, '\P{^Is_Nv=3.900000000000000e+01}', "");
    Expect(0, 12981, '\p{Is_Nv=3.900000000000000e+01}', "");
    Expect(1, 12981, '\p{^Is_Nv=3.900000000000000e+01}', "");
    Expect(1, 12981, '\P{Is_Nv=3.900000000000000e+01}', "");
    Expect(0, 12981, '\P{^Is_Nv=3.900000000000000e+01}', "");
    Error('\p{Numeric_Value=-/a/0_0_0_004}');
    Error('\P{Numeric_Value=-/a/0_0_0_004}');
    Expect(1, 156269, '\p{Numeric_Value=:\A4\z:}', "");;
    Expect(0, 156270, '\p{Numeric_Value=:\A4\z:}', "");;
    Expect(1, 156269, '\p{Numeric_Value=+00000004}', "");
    Expect(0, 156269, '\p{^Numeric_Value=+00000004}', "");
    Expect(0, 156269, '\P{Numeric_Value=+00000004}', "");
    Expect(1, 156269, '\P{^Numeric_Value=+00000004}', "");
    Expect(0, 156270, '\p{Numeric_Value=+00000004}', "");
    Expect(1, 156270, '\p{^Numeric_Value=+00000004}', "");
    Expect(1, 156270, '\P{Numeric_Value=+00000004}', "");
    Expect(0, 156270, '\P{^Numeric_Value=+00000004}', "");
    Expect(1, 156269, '\p{Numeric_Value=4.000000000000000e+00}', "");
    Expect(0, 156269, '\p{^Numeric_Value=4.000000000000000e+00}', "");
    Expect(0, 156269, '\P{Numeric_Value=4.000000000000000e+00}', "");
    Expect(1, 156269, '\P{^Numeric_Value=4.000000000000000e+00}', "");
    Expect(0, 156270, '\p{Numeric_Value=4.000000000000000e+00}', "");
    Expect(1, 156270, '\p{^Numeric_Value=4.000000000000000e+00}', "");
    Expect(1, 156270, '\P{Numeric_Value=4.000000000000000e+00}', "");
    Expect(0, 156270, '\P{^Numeric_Value=4.000000000000000e+00}', "");
    Error('\p{Nv= _+0_0_0_0_0004:=}');
    Error('\P{Nv= _+0_0_0_0_0004:=}');
    Expect(1, 156269, '\p{Nv=:\A4\z:}', "");;
    Expect(0, 156270, '\p{Nv=:\A4\z:}', "");;
    Expect(1, 156269, '\p{Nv=0000004}', "");
    Expect(0, 156269, '\p{^Nv=0000004}', "");
    Expect(0, 156269, '\P{Nv=0000004}', "");
    Expect(1, 156269, '\P{^Nv=0000004}', "");
    Expect(0, 156270, '\p{Nv=0000004}', "");
    Expect(1, 156270, '\p{^Nv=0000004}', "");
    Expect(1, 156270, '\P{Nv=0000004}', "");
    Expect(0, 156270, '\P{^Nv=0000004}', "");
    Expect(1, 156269, '\p{Nv=4.000000000000000e+00}', "");
    Expect(0, 156269, '\p{^Nv=4.000000000000000e+00}', "");
    Expect(0, 156269, '\P{Nv=4.000000000000000e+00}', "");
    Expect(1, 156269, '\P{^Nv=4.000000000000000e+00}', "");
    Expect(0, 156270, '\p{Nv=4.000000000000000e+00}', "");
    Expect(1, 156270, '\p{^Nv=4.000000000000000e+00}', "");
    Expect(1, 156270, '\P{Nv=4.000000000000000e+00}', "");
    Expect(0, 156270, '\P{^Nv=4.000000000000000e+00}', "");
    Error('\p{Is_Numeric_Value=:=__0000000004}');
    Error('\P{Is_Numeric_Value=:=__0000000004}');
    Expect(1, 156269, '\p{Is_Numeric_Value=+4}', "");
    Expect(0, 156269, '\p{^Is_Numeric_Value=+4}', "");
    Expect(0, 156269, '\P{Is_Numeric_Value=+4}', "");
    Expect(1, 156269, '\P{^Is_Numeric_Value=+4}', "");
    Expect(0, 156270, '\p{Is_Numeric_Value=+4}', "");
    Expect(1, 156270, '\p{^Is_Numeric_Value=+4}', "");
    Expect(1, 156270, '\P{Is_Numeric_Value=+4}', "");
    Expect(0, 156270, '\P{^Is_Numeric_Value=+4}', "");
    Expect(1, 156269, '\p{Is_Numeric_Value=4.000000000000000e+00}', "");
    Expect(0, 156269, '\p{^Is_Numeric_Value=4.000000000000000e+00}', "");
    Expect(0, 156269, '\P{Is_Numeric_Value=4.000000000000000e+00}', "");
    Expect(1, 156269, '\P{^Is_Numeric_Value=4.000000000000000e+00}', "");
    Expect(0, 156270, '\p{Is_Numeric_Value=4.000000000000000e+00}', "");
    Expect(1, 156270, '\p{^Is_Numeric_Value=4.000000000000000e+00}', "");
    Expect(1, 156270, '\P{Is_Numeric_Value=4.000000000000000e+00}', "");
    Expect(0, 156270, '\P{^Is_Numeric_Value=4.000000000000000e+00}', "");
    Error('\p{Is_Nv=:=-+0_0_0_0_0_0_0_004}');
    Error('\P{Is_Nv=:=-+0_0_0_0_0_0_0_004}');
    Expect(1, 156269, '\p{Is_Nv=004}', "");
    Expect(0, 156269, '\p{^Is_Nv=004}', "");
    Expect(0, 156269, '\P{Is_Nv=004}', "");
    Expect(1, 156269, '\P{^Is_Nv=004}', "");
    Expect(0, 156270, '\p{Is_Nv=004}', "");
    Expect(1, 156270, '\p{^Is_Nv=004}', "");
    Expect(1, 156270, '\P{Is_Nv=004}', "");
    Expect(0, 156270, '\P{^Is_Nv=004}', "");
    Expect(1, 156269, '\p{Is_Nv=4.000000000000000e+00}', "");
    Expect(0, 156269, '\p{^Is_Nv=4.000000000000000e+00}', "");
    Expect(0, 156269, '\P{Is_Nv=4.000000000000000e+00}', "");
    Expect(1, 156269, '\P{^Is_Nv=4.000000000000000e+00}', "");
    Expect(0, 156270, '\p{Is_Nv=4.000000000000000e+00}', "");
    Expect(1, 156270, '\p{^Is_Nv=4.000000000000000e+00}', "");
    Expect(1, 156270, '\P{Is_Nv=4.000000000000000e+00}', "");
    Expect(0, 156270, '\P{^Is_Nv=4.000000000000000e+00}', "");
    Error('\p{Numeric_Value:_/a/+4/0000000005}');
    Error('\P{Numeric_Value:_/a/+4/0000000005}');
    Expect(1, 8536, '\p{Numeric_Value=:\A4/5\z:}', "");;
    Expect(0, 8537, '\p{Numeric_Value=:\A4/5\z:}', "");;
    Expect(1, 8536, '\p{Numeric_Value:	000000004/00000005}', "");
    Expect(0, 8536, '\p{^Numeric_Value:	000000004/00000005}', "");
    Expect(0, 8536, '\P{Numeric_Value:	000000004/00000005}', "");
    Expect(1, 8536, '\P{^Numeric_Value:	000000004/00000005}', "");
    Expect(0, 8537, '\p{Numeric_Value:	000000004/00000005}', "");
    Expect(1, 8537, '\p{^Numeric_Value:	000000004/00000005}', "");
    Expect(1, 8537, '\P{Numeric_Value:	000000004/00000005}', "");
    Expect(0, 8537, '\P{^Numeric_Value:	000000004/00000005}', "");
    Expect(1, 8536, '\p{Numeric_Value:   240/300}', "");
    Expect(0, 8536, '\p{^Numeric_Value:   240/300}', "");
    Expect(0, 8536, '\P{Numeric_Value:   240/300}', "");
    Expect(1, 8536, '\P{^Numeric_Value:   240/300}', "");
    Expect(0, 8537, '\p{Numeric_Value:   240/300}', "");
    Expect(1, 8537, '\p{^Numeric_Value:   240/300}', "");
    Expect(1, 8537, '\P{Numeric_Value:   240/300}', "");
    Expect(0, 8537, '\P{^Numeric_Value:   240/300}', "");
    Expect(1, 8536, '\p{Numeric_Value=8.0e-01}', "");
    Expect(0, 8536, '\p{^Numeric_Value=8.0e-01}', "");
    Expect(0, 8536, '\P{Numeric_Value=8.0e-01}', "");
    Expect(1, 8536, '\P{^Numeric_Value=8.0e-01}', "");
    Expect(0, 8537, '\p{Numeric_Value=8.0e-01}', "");
    Expect(1, 8537, '\p{^Numeric_Value=8.0e-01}', "");
    Expect(1, 8537, '\P{Numeric_Value=8.0e-01}', "");
    Expect(0, 8537, '\P{^Numeric_Value=8.0e-01}', "");
    Expect(1, 8536, '\p{Numeric_Value=0.8}', "");
    Expect(0, 8536, '\p{^Numeric_Value=0.8}', "");
    Expect(0, 8536, '\P{Numeric_Value=0.8}', "");
    Expect(1, 8536, '\P{^Numeric_Value=0.8}', "");
    Expect(0, 8537, '\p{Numeric_Value=0.8}', "");
    Expect(1, 8537, '\p{^Numeric_Value=0.8}', "");
    Expect(1, 8537, '\P{Numeric_Value=0.8}', "");
    Expect(0, 8537, '\P{^Numeric_Value=0.8}', "");
    Expect(1, 8536, '\p{Numeric_Value=8.00e-01}', "");
    Expect(0, 8536, '\p{^Numeric_Value=8.00e-01}', "");
    Expect(0, 8536, '\P{Numeric_Value=8.00e-01}', "");
    Expect(1, 8536, '\P{^Numeric_Value=8.00e-01}', "");
    Expect(0, 8537, '\p{Numeric_Value=8.00e-01}', "");
    Expect(1, 8537, '\p{^Numeric_Value=8.00e-01}', "");
    Expect(1, 8537, '\P{Numeric_Value=8.00e-01}', "");
    Expect(0, 8537, '\P{^Numeric_Value=8.00e-01}', "");
    Expect(1, 8536, '\p{Numeric_Value=0.80}', "");
    Expect(0, 8536, '\p{^Numeric_Value=0.80}', "");
    Expect(0, 8536, '\P{Numeric_Value=0.80}', "");
    Expect(1, 8536, '\P{^Numeric_Value=0.80}', "");
    Expect(0, 8537, '\p{Numeric_Value=0.80}', "");
    Expect(1, 8537, '\p{^Numeric_Value=0.80}', "");
    Expect(1, 8537, '\P{Numeric_Value=0.80}', "");
    Expect(0, 8537, '\P{^Numeric_Value=0.80}', "");
    Error('\p{Nv=/a/	_4/5}');
    Error('\P{Nv=/a/	_4/5}');
    Expect(1, 8536, '\p{Nv=:\A4/5\z:}', "");;
    Expect(0, 8537, '\p{Nv=:\A4/5\z:}', "");;
    Expect(1, 8536, '\p{Nv=+000004/0000000005}', "");
    Expect(0, 8536, '\p{^Nv=+000004/0000000005}', "");
    Expect(0, 8536, '\P{Nv=+000004/0000000005}', "");
    Expect(1, 8536, '\P{^Nv=+000004/0000000005}', "");
    Expect(0, 8537, '\p{Nv=+000004/0000000005}', "");
    Expect(1, 8537, '\p{^Nv=+000004/0000000005}', "");
    Expect(1, 8537, '\P{Nv=+000004/0000000005}', "");
    Expect(0, 8537, '\P{^Nv=+000004/0000000005}', "");
    Expect(1, 8536, '\p{Nv=240/300}', "");
    Expect(0, 8536, '\p{^Nv=240/300}', "");
    Expect(0, 8536, '\P{Nv=240/300}', "");
    Expect(1, 8536, '\P{^Nv=240/300}', "");
    Expect(0, 8537, '\p{Nv=240/300}', "");
    Expect(1, 8537, '\p{^Nv=240/300}', "");
    Expect(1, 8537, '\P{Nv=240/300}', "");
    Expect(0, 8537, '\P{^Nv=240/300}', "");
    Expect(1, 8536, '\p{Nv=8.0e-01}', "");
    Expect(0, 8536, '\p{^Nv=8.0e-01}', "");
    Expect(0, 8536, '\P{Nv=8.0e-01}', "");
    Expect(1, 8536, '\P{^Nv=8.0e-01}', "");
    Expect(0, 8537, '\p{Nv=8.0e-01}', "");
    Expect(1, 8537, '\p{^Nv=8.0e-01}', "");
    Expect(1, 8537, '\P{Nv=8.0e-01}', "");
    Expect(0, 8537, '\P{^Nv=8.0e-01}', "");
    Expect(1, 8536, '\p{Nv=0.8}', "");
    Expect(0, 8536, '\p{^Nv=0.8}', "");
    Expect(0, 8536, '\P{Nv=0.8}', "");
    Expect(1, 8536, '\P{^Nv=0.8}', "");
    Expect(0, 8537, '\p{Nv=0.8}', "");
    Expect(1, 8537, '\p{^Nv=0.8}', "");
    Expect(1, 8537, '\P{Nv=0.8}', "");
    Expect(0, 8537, '\P{^Nv=0.8}', "");
    Expect(1, 8536, '\p{Nv=8.00e-01}', "");
    Expect(0, 8536, '\p{^Nv=8.00e-01}', "");
    Expect(0, 8536, '\P{Nv=8.00e-01}', "");
    Expect(1, 8536, '\P{^Nv=8.00e-01}', "");
    Expect(0, 8537, '\p{Nv=8.00e-01}', "");
    Expect(1, 8537, '\p{^Nv=8.00e-01}', "");
    Expect(1, 8537, '\P{Nv=8.00e-01}', "");
    Expect(0, 8537, '\P{^Nv=8.00e-01}', "");
    Expect(1, 8536, '\p{Nv=0.80}', "");
    Expect(0, 8536, '\p{^Nv=0.80}', "");
    Expect(0, 8536, '\P{Nv=0.80}', "");
    Expect(1, 8536, '\P{^Nv=0.80}', "");
    Expect(0, 8537, '\p{Nv=0.80}', "");
    Expect(1, 8537, '\p{^Nv=0.80}', "");
    Expect(1, 8537, '\P{Nv=0.80}', "");
    Expect(0, 8537, '\P{^Nv=0.80}', "");
    Error('\p{Is_Numeric_Value=_	00004/005:=}');
    Error('\P{Is_Numeric_Value=_	00004/005:=}');
    Expect(1, 8536, '\p{Is_Numeric_Value=+0000000004/000005}', "");
    Expect(0, 8536, '\p{^Is_Numeric_Value=+0000000004/000005}', "");
    Expect(0, 8536, '\P{Is_Numeric_Value=+0000000004/000005}', "");
    Expect(1, 8536, '\P{^Is_Numeric_Value=+0000000004/000005}', "");
    Expect(0, 8537, '\p{Is_Numeric_Value=+0000000004/000005}', "");
    Expect(1, 8537, '\p{^Is_Numeric_Value=+0000000004/000005}', "");
    Expect(1, 8537, '\P{Is_Numeric_Value=+0000000004/000005}', "");
    Expect(0, 8537, '\P{^Is_Numeric_Value=+0000000004/000005}', "");
    Expect(1, 8536, '\p{Is_Numeric_Value=240/300}', "");
    Expect(0, 8536, '\p{^Is_Numeric_Value=240/300}', "");
    Expect(0, 8536, '\P{Is_Numeric_Value=240/300}', "");
    Expect(1, 8536, '\P{^Is_Numeric_Value=240/300}', "");
    Expect(0, 8537, '\p{Is_Numeric_Value=240/300}', "");
    Expect(1, 8537, '\p{^Is_Numeric_Value=240/300}', "");
    Expect(1, 8537, '\P{Is_Numeric_Value=240/300}', "");
    Expect(0, 8537, '\P{^Is_Numeric_Value=240/300}', "");
    Expect(1, 8536, '\p{Is_Numeric_Value=8.0e-01}', "");
    Expect(0, 8536, '\p{^Is_Numeric_Value=8.0e-01}', "");
    Expect(0, 8536, '\P{Is_Numeric_Value=8.0e-01}', "");
    Expect(1, 8536, '\P{^Is_Numeric_Value=8.0e-01}', "");
    Expect(0, 8537, '\p{Is_Numeric_Value=8.0e-01}', "");
    Expect(1, 8537, '\p{^Is_Numeric_Value=8.0e-01}', "");
    Expect(1, 8537, '\P{Is_Numeric_Value=8.0e-01}', "");
    Expect(0, 8537, '\P{^Is_Numeric_Value=8.0e-01}', "");
    Expect(1, 8536, '\p{Is_Numeric_Value=0.8}', "");
    Expect(0, 8536, '\p{^Is_Numeric_Value=0.8}', "");
    Expect(0, 8536, '\P{Is_Numeric_Value=0.8}', "");
    Expect(1, 8536, '\P{^Is_Numeric_Value=0.8}', "");
    Expect(0, 8537, '\p{Is_Numeric_Value=0.8}', "");
    Expect(1, 8537, '\p{^Is_Numeric_Value=0.8}', "");
    Expect(1, 8537, '\P{Is_Numeric_Value=0.8}', "");
    Expect(0, 8537, '\P{^Is_Numeric_Value=0.8}', "");
    Expect(1, 8536, '\p{Is_Numeric_Value=8.00e-01}', "");
    Expect(0, 8536, '\p{^Is_Numeric_Value=8.00e-01}', "");
    Expect(0, 8536, '\P{Is_Numeric_Value=8.00e-01}', "");
    Expect(1, 8536, '\P{^Is_Numeric_Value=8.00e-01}', "");
    Expect(0, 8537, '\p{Is_Numeric_Value=8.00e-01}', "");
    Expect(1, 8537, '\p{^Is_Numeric_Value=8.00e-01}', "");
    Expect(1, 8537, '\P{Is_Numeric_Value=8.00e-01}', "");
    Expect(0, 8537, '\P{^Is_Numeric_Value=8.00e-01}', "");
    Expect(1, 8536, '\p{Is_Numeric_Value=0.80}', "");
    Expect(0, 8536, '\p{^Is_Numeric_Value=0.80}', "");
    Expect(0, 8536, '\P{Is_Numeric_Value=0.80}', "");
    Expect(1, 8536, '\P{^Is_Numeric_Value=0.80}', "");
    Expect(0, 8537, '\p{Is_Numeric_Value=0.80}', "");
    Expect(1, 8537, '\p{^Is_Numeric_Value=0.80}', "");
    Expect(1, 8537, '\P{Is_Numeric_Value=0.80}', "");
    Expect(0, 8537, '\P{^Is_Numeric_Value=0.80}', "");
    Error('\p{Is_Nv=-:=004/005}');
    Error('\P{Is_Nv=-:=004/005}');
    Expect(1, 8536, '\p{Is_Nv:   +00000004/00000005}', "");
    Expect(0, 8536, '\p{^Is_Nv:   +00000004/00000005}', "");
    Expect(0, 8536, '\P{Is_Nv:   +00000004/00000005}', "");
    Expect(1, 8536, '\P{^Is_Nv:   +00000004/00000005}', "");
    Expect(0, 8537, '\p{Is_Nv:   +00000004/00000005}', "");
    Expect(1, 8537, '\p{^Is_Nv:   +00000004/00000005}', "");
    Expect(1, 8537, '\P{Is_Nv:   +00000004/00000005}', "");
    Expect(0, 8537, '\P{^Is_Nv:   +00000004/00000005}', "");
    Expect(1, 8536, '\p{Is_Nv=240/300}', "");
    Expect(0, 8536, '\p{^Is_Nv=240/300}', "");
    Expect(0, 8536, '\P{Is_Nv=240/300}', "");
    Expect(1, 8536, '\P{^Is_Nv=240/300}', "");
    Expect(0, 8537, '\p{Is_Nv=240/300}', "");
    Expect(1, 8537, '\p{^Is_Nv=240/300}', "");
    Expect(1, 8537, '\P{Is_Nv=240/300}', "");
    Expect(0, 8537, '\P{^Is_Nv=240/300}', "");
    Expect(1, 8536, '\p{Is_Nv=8.0e-01}', "");
    Expect(0, 8536, '\p{^Is_Nv=8.0e-01}', "");
    Expect(0, 8536, '\P{Is_Nv=8.0e-01}', "");
    Expect(1, 8536, '\P{^Is_Nv=8.0e-01}', "");
    Expect(0, 8537, '\p{Is_Nv=8.0e-01}', "");
    Expect(1, 8537, '\p{^Is_Nv=8.0e-01}', "");
    Expect(1, 8537, '\P{Is_Nv=8.0e-01}', "");
    Expect(0, 8537, '\P{^Is_Nv=8.0e-01}', "");
    Expect(1, 8536, '\p{Is_Nv=0.8}', "");
    Expect(0, 8536, '\p{^Is_Nv=0.8}', "");
    Expect(0, 8536, '\P{Is_Nv=0.8}', "");
    Expect(1, 8536, '\P{^Is_Nv=0.8}', "");
    Expect(0, 8537, '\p{Is_Nv=0.8}', "");
    Expect(1, 8537, '\p{^Is_Nv=0.8}', "");
    Expect(1, 8537, '\P{Is_Nv=0.8}', "");
    Expect(0, 8537, '\P{^Is_Nv=0.8}', "");
    Expect(1, 8536, '\p{Is_Nv=8.00e-01}', "");
    Expect(0, 8536, '\p{^Is_Nv=8.00e-01}', "");
    Expect(0, 8536, '\P{Is_Nv=8.00e-01}', "");
    Expect(1, 8536, '\P{^Is_Nv=8.00e-01}', "");
    Expect(0, 8537, '\p{Is_Nv=8.00e-01}', "");
    Expect(1, 8537, '\p{^Is_Nv=8.00e-01}', "");
    Expect(1, 8537, '\P{Is_Nv=8.00e-01}', "");
    Expect(0, 8537, '\P{^Is_Nv=8.00e-01}', "");
    Expect(1, 8536, '\p{Is_Nv=0.80}', "");
    Expect(0, 8536, '\p{^Is_Nv=0.80}', "");
    Expect(0, 8536, '\P{Is_Nv=0.80}', "");
    Expect(1, 8536, '\P{^Is_Nv=0.80}', "");
    Expect(0, 8537, '\p{Is_Nv=0.80}', "");
    Expect(1, 8537, '\p{^Is_Nv=0.80}', "");
    Expect(1, 8537, '\P{Is_Nv=0.80}', "");
    Expect(0, 8537, '\P{^Is_Nv=0.80}', "");
    Error('\p{Numeric_Value=:=- +000040}');
    Error('\P{Numeric_Value=:=- +000040}');
    Expect(1, 133532, '\p{Numeric_Value=:\A40\z:}', "");;
    Expect(0, 133533, '\p{Numeric_Value=:\A40\z:}', "");;
    Expect(1, 133532, '\p{Numeric_Value=00000000040}', "");
    Expect(0, 133532, '\p{^Numeric_Value=00000000040}', "");
    Expect(0, 133532, '\P{Numeric_Value=00000000040}', "");
    Expect(1, 133532, '\P{^Numeric_Value=00000000040}', "");
    Expect(0, 133533, '\p{Numeric_Value=00000000040}', "");
    Expect(1, 133533, '\p{^Numeric_Value=00000000040}', "");
    Expect(1, 133533, '\P{Numeric_Value=00000000040}', "");
    Expect(0, 133533, '\P{^Numeric_Value=00000000040}', "");
    Expect(1, 133532, '\p{Numeric_Value=4.000000000000000e+01}', "");
    Expect(0, 133532, '\p{^Numeric_Value=4.000000000000000e+01}', "");
    Expect(0, 133532, '\P{Numeric_Value=4.000000000000000e+01}', "");
    Expect(1, 133532, '\P{^Numeric_Value=4.000000000000000e+01}', "");
    Expect(0, 133533, '\p{Numeric_Value=4.000000000000000e+01}', "");
    Expect(1, 133533, '\p{^Numeric_Value=4.000000000000000e+01}', "");
    Expect(1, 133533, '\P{Numeric_Value=4.000000000000000e+01}', "");
    Expect(0, 133533, '\P{^Numeric_Value=4.000000000000000e+01}', "");
    Error('\p{Nv=/a/ _+00_04_0}');
    Error('\P{Nv=/a/ _+00_04_0}');
    Expect(1, 133532, '\p{Nv=:\A40\z:}', "");;
    Expect(0, 133533, '\p{Nv=:\A40\z:}', "");;
    Expect(1, 133532, '\p{Nv=000004_0}', "");
    Expect(0, 133532, '\p{^Nv=000004_0}', "");
    Expect(0, 133532, '\P{Nv=000004_0}', "");
    Expect(1, 133532, '\P{^Nv=000004_0}', "");
    Expect(0, 133533, '\p{Nv=000004_0}', "");
    Expect(1, 133533, '\p{^Nv=000004_0}', "");
    Expect(1, 133533, '\P{Nv=000004_0}', "");
    Expect(0, 133533, '\P{^Nv=000004_0}', "");
    Expect(1, 133532, '\p{Nv=4.000000000000000e+01}', "");
    Expect(0, 133532, '\p{^Nv=4.000000000000000e+01}', "");
    Expect(0, 133532, '\P{Nv=4.000000000000000e+01}', "");
    Expect(1, 133532, '\P{^Nv=4.000000000000000e+01}', "");
    Expect(0, 133533, '\p{Nv=4.000000000000000e+01}', "");
    Expect(1, 133533, '\p{^Nv=4.000000000000000e+01}', "");
    Expect(1, 133533, '\P{Nv=4.000000000000000e+01}', "");
    Expect(0, 133533, '\P{^Nv=4.000000000000000e+01}', "");
    Error('\p{Is_Numeric_Value=:=40}');
    Error('\P{Is_Numeric_Value=:=40}');
    Expect(1, 133532, '\p{Is_Numeric_Value=0040}', "");
    Expect(0, 133532, '\p{^Is_Numeric_Value=0040}', "");
    Expect(0, 133532, '\P{Is_Numeric_Value=0040}', "");
    Expect(1, 133532, '\P{^Is_Numeric_Value=0040}', "");
    Expect(0, 133533, '\p{Is_Numeric_Value=0040}', "");
    Expect(1, 133533, '\p{^Is_Numeric_Value=0040}', "");
    Expect(1, 133533, '\P{Is_Numeric_Value=0040}', "");
    Expect(0, 133533, '\P{^Is_Numeric_Value=0040}', "");
    Expect(1, 133532, '\p{Is_Numeric_Value=4.000000000000000e+01}', "");
    Expect(0, 133532, '\p{^Is_Numeric_Value=4.000000000000000e+01}', "");
    Expect(0, 133532, '\P{Is_Numeric_Value=4.000000000000000e+01}', "");
    Expect(1, 133532, '\P{^Is_Numeric_Value=4.000000000000000e+01}', "");
    Expect(0, 133533, '\p{Is_Numeric_Value=4.000000000000000e+01}', "");
    Expect(1, 133533, '\p{^Is_Numeric_Value=4.000000000000000e+01}', "");
    Expect(1, 133533, '\P{Is_Numeric_Value=4.000000000000000e+01}', "");
    Expect(0, 133533, '\P{^Is_Numeric_Value=4.000000000000000e+01}', "");
    Error('\p{Is_Nv=:=	 +40}');
    Error('\P{Is_Nv=:=	 +40}');
    Expect(1, 133532, '\p{Is_Nv:	040}', "");
    Expect(0, 133532, '\p{^Is_Nv:	040}', "");
    Expect(0, 133532, '\P{Is_Nv:	040}', "");
    Expect(1, 133532, '\P{^Is_Nv:	040}', "");
    Expect(0, 133533, '\p{Is_Nv:	040}', "");
    Expect(1, 133533, '\p{^Is_Nv:	040}', "");
    Expect(1, 133533, '\P{Is_Nv:	040}', "");
    Expect(0, 133533, '\P{^Is_Nv:	040}', "");
    Expect(1, 133532, '\p{Is_Nv=4.000000000000000e+01}', "");
    Expect(0, 133532, '\p{^Is_Nv=4.000000000000000e+01}', "");
    Expect(0, 133532, '\P{Is_Nv=4.000000000000000e+01}', "");
    Expect(1, 133532, '\P{^Is_Nv=4.000000000000000e+01}', "");
    Expect(0, 133533, '\p{Is_Nv=4.000000000000000e+01}', "");
    Expect(1, 133533, '\p{^Is_Nv=4.000000000000000e+01}', "");
    Expect(1, 133533, '\P{Is_Nv=4.000000000000000e+01}', "");
    Expect(0, 133533, '\P{^Is_Nv=4.000000000000000e+01}', "");
    Error('\p{Numeric_Value=/a/ -0_0_0_0_0_400}');
    Error('\P{Numeric_Value=/a/ -0_0_0_0_0_400}');
    Expect(1, 126264, '\p{Numeric_Value=:\A400\z:}', "");;
    Expect(0, 126265, '\p{Numeric_Value=:\A400\z:}', "");;
    Expect(1, 126264, '\p{Numeric_Value=00000000400}', "");
    Expect(0, 126264, '\p{^Numeric_Value=00000000400}', "");
    Expect(0, 126264, '\P{Numeric_Value=00000000400}', "");
    Expect(1, 126264, '\P{^Numeric_Value=00000000400}', "");
    Expect(0, 126265, '\p{Numeric_Value=00000000400}', "");
    Expect(1, 126265, '\p{^Numeric_Value=00000000400}', "");
    Expect(1, 126265, '\P{Numeric_Value=00000000400}', "");
    Expect(0, 126265, '\P{^Numeric_Value=00000000400}', "");
    Expect(1, 126264, '\p{Numeric_Value=4.000000000000000e+02}', "");
    Expect(0, 126264, '\p{^Numeric_Value=4.000000000000000e+02}', "");
    Expect(0, 126264, '\P{Numeric_Value=4.000000000000000e+02}', "");
    Expect(1, 126264, '\P{^Numeric_Value=4.000000000000000e+02}', "");
    Expect(0, 126265, '\p{Numeric_Value=4.000000000000000e+02}', "");
    Expect(1, 126265, '\p{^Numeric_Value=4.000000000000000e+02}', "");
    Expect(1, 126265, '\P{Numeric_Value=4.000000000000000e+02}', "");
    Expect(0, 126265, '\P{^Numeric_Value=4.000000000000000e+02}', "");
    Error('\p{Nv:/a/+0000400}');
    Error('\P{Nv:/a/+0000400}');
    Expect(1, 126264, '\p{Nv=:\A400\z:}', "");;
    Expect(0, 126265, '\p{Nv=:\A400\z:}', "");;
    Expect(1, 126264, '\p{Nv=0000400}', "");
    Expect(0, 126264, '\p{^Nv=0000400}', "");
    Expect(0, 126264, '\P{Nv=0000400}', "");
    Expect(1, 126264, '\P{^Nv=0000400}', "");
    Expect(0, 126265, '\p{Nv=0000400}', "");
    Expect(1, 126265, '\p{^Nv=0000400}', "");
    Expect(1, 126265, '\P{Nv=0000400}', "");
    Expect(0, 126265, '\P{^Nv=0000400}', "");
    Expect(1, 126264, '\p{Nv=4.000000000000000e+02}', "");
    Expect(0, 126264, '\p{^Nv=4.000000000000000e+02}', "");
    Expect(0, 126264, '\P{Nv=4.000000000000000e+02}', "");
    Expect(1, 126264, '\P{^Nv=4.000000000000000e+02}', "");
    Expect(0, 126265, '\p{Nv=4.000000000000000e+02}', "");
    Expect(1, 126265, '\p{^Nv=4.000000000000000e+02}', "");
    Expect(1, 126265, '\P{Nv=4.000000000000000e+02}', "");
    Expect(0, 126265, '\P{^Nv=4.000000000000000e+02}', "");
    Error('\p{Is_Numeric_Value=/a/	_400}');
    Error('\P{Is_Numeric_Value=/a/	_400}');
    Expect(1, 126264, '\p{Is_Numeric_Value=+0400}', "");
    Expect(0, 126264, '\p{^Is_Numeric_Value=+0400}', "");
    Expect(0, 126264, '\P{Is_Numeric_Value=+0400}', "");
    Expect(1, 126264, '\P{^Is_Numeric_Value=+0400}', "");
    Expect(0, 126265, '\p{Is_Numeric_Value=+0400}', "");
    Expect(1, 126265, '\p{^Is_Numeric_Value=+0400}', "");
    Expect(1, 126265, '\P{Is_Numeric_Value=+0400}', "");
    Expect(0, 126265, '\P{^Is_Numeric_Value=+0400}', "");
    Expect(1, 126264, '\p{Is_Numeric_Value=4.000000000000000e+02}', "");
    Expect(0, 126264, '\p{^Is_Numeric_Value=4.000000000000000e+02}', "");
    Expect(0, 126264, '\P{Is_Numeric_Value=4.000000000000000e+02}', "");
    Expect(1, 126264, '\P{^Is_Numeric_Value=4.000000000000000e+02}', "");
    Expect(0, 126265, '\p{Is_Numeric_Value=4.000000000000000e+02}', "");
    Expect(1, 126265, '\p{^Is_Numeric_Value=4.000000000000000e+02}', "");
    Expect(1, 126265, '\P{Is_Numeric_Value=4.000000000000000e+02}', "");
    Expect(0, 126265, '\P{^Is_Numeric_Value=4.000000000000000e+02}', "");
    Error('\p{Is_Nv=	/a/+0000000400}');
    Error('\P{Is_Nv=	/a/+0000000400}');
    Expect(1, 126264, '\p{Is_Nv=+0400}', "");
    Expect(0, 126264, '\p{^Is_Nv=+0400}', "");
    Expect(0, 126264, '\P{Is_Nv=+0400}', "");
    Expect(1, 126264, '\P{^Is_Nv=+0400}', "");
    Expect(0, 126265, '\p{Is_Nv=+0400}', "");
    Expect(1, 126265, '\p{^Is_Nv=+0400}', "");
    Expect(1, 126265, '\P{Is_Nv=+0400}', "");
    Expect(0, 126265, '\P{^Is_Nv=+0400}', "");
    Expect(1, 126264, '\p{Is_Nv=4.000000000000000e+02}', "");
    Expect(0, 126264, '\p{^Is_Nv=4.000000000000000e+02}', "");
    Expect(0, 126264, '\P{Is_Nv=4.000000000000000e+02}', "");
    Expect(1, 126264, '\P{^Is_Nv=4.000000000000000e+02}', "");
    Expect(0, 126265, '\p{Is_Nv=4.000000000000000e+02}', "");
    Expect(1, 126265, '\p{^Is_Nv=4.000000000000000e+02}', "");
    Expect(1, 126265, '\P{Is_Nv=4.000000000000000e+02}', "");
    Expect(0, 126265, '\P{^Is_Nv=4.000000000000000e+02}', "");
    Error('\p{Numeric_Value=-_000000004000:=}');
    Error('\P{Numeric_Value=-_000000004000:=}');
    Expect(1, 126239, '\p{Numeric_Value=:\A4000\z:}', "");;
    Expect(0, 126240, '\p{Numeric_Value=:\A4000\z:}', "");;
    Expect(1, 126239, '\p{Numeric_Value:   +00400_0}', "");
    Expect(0, 126239, '\p{^Numeric_Value:   +00400_0}', "");
    Expect(0, 126239, '\P{Numeric_Value:   +00400_0}', "");
    Expect(1, 126239, '\P{^Numeric_Value:   +00400_0}', "");
    Expect(0, 126240, '\p{Numeric_Value:   +00400_0}', "");
    Expect(1, 126240, '\p{^Numeric_Value:   +00400_0}', "");
    Expect(1, 126240, '\P{Numeric_Value:   +00400_0}', "");
    Expect(0, 126240, '\P{^Numeric_Value:   +00400_0}', "");
    Expect(1, 126239, '\p{Numeric_Value:   4.000000000000000e+03}', "");
    Expect(0, 126239, '\p{^Numeric_Value:   4.000000000000000e+03}', "");
    Expect(0, 126239, '\P{Numeric_Value:   4.000000000000000e+03}', "");
    Expect(1, 126239, '\P{^Numeric_Value:   4.000000000000000e+03}', "");
    Expect(0, 126240, '\p{Numeric_Value:   4.000000000000000e+03}', "");
    Expect(1, 126240, '\p{^Numeric_Value:   4.000000000000000e+03}', "");
    Expect(1, 126240, '\P{Numeric_Value:   4.000000000000000e+03}', "");
    Expect(0, 126240, '\P{^Numeric_Value:   4.000000000000000e+03}', "");
    Error('\p{Nv=-000000004000:=}');
    Error('\P{Nv=-000000004000:=}');
    Expect(1, 126239, '\p{Nv=:\A4000\z:}', "");;
    Expect(0, 126240, '\p{Nv=:\A4000\z:}', "");;
    Expect(1, 126239, '\p{Nv=+400_0}', "");
    Expect(0, 126239, '\p{^Nv=+400_0}', "");
    Expect(0, 126239, '\P{Nv=+400_0}', "");
    Expect(1, 126239, '\P{^Nv=+400_0}', "");
    Expect(0, 126240, '\p{Nv=+400_0}', "");
    Expect(1, 126240, '\p{^Nv=+400_0}', "");
    Expect(1, 126240, '\P{Nv=+400_0}', "");
    Expect(0, 126240, '\P{^Nv=+400_0}', "");
    Expect(1, 126239, '\p{Nv=4.000000000000000e+03}', "");
    Expect(0, 126239, '\p{^Nv=4.000000000000000e+03}', "");
    Expect(0, 126239, '\P{Nv=4.000000000000000e+03}', "");
    Expect(1, 126239, '\P{^Nv=4.000000000000000e+03}', "");
    Expect(0, 126240, '\p{Nv=4.000000000000000e+03}', "");
    Expect(1, 126240, '\p{^Nv=4.000000000000000e+03}', "");
    Expect(1, 126240, '\P{Nv=4.000000000000000e+03}', "");
    Expect(0, 126240, '\P{^Nv=4.000000000000000e+03}', "");
    Error('\p{Is_Numeric_Value=		000000_000400_0:=}');
    Error('\P{Is_Numeric_Value=		000000_000400_0:=}');
    Expect(1, 126239, '\p{Is_Numeric_Value=+400_0}', "");
    Expect(0, 126239, '\p{^Is_Numeric_Value=+400_0}', "");
    Expect(0, 126239, '\P{Is_Numeric_Value=+400_0}', "");
    Expect(1, 126239, '\P{^Is_Numeric_Value=+400_0}', "");
    Expect(0, 126240, '\p{Is_Numeric_Value=+400_0}', "");
    Expect(1, 126240, '\p{^Is_Numeric_Value=+400_0}', "");
    Expect(1, 126240, '\P{Is_Numeric_Value=+400_0}', "");
    Expect(0, 126240, '\P{^Is_Numeric_Value=+400_0}', "");
    Expect(1, 126239, '\p{Is_Numeric_Value=4.000000000000000e+03}', "");
    Expect(0, 126239, '\p{^Is_Numeric_Value=4.000000000000000e+03}', "");
    Expect(0, 126239, '\P{Is_Numeric_Value=4.000000000000000e+03}', "");
    Expect(1, 126239, '\P{^Is_Numeric_Value=4.000000000000000e+03}', "");
    Expect(0, 126240, '\p{Is_Numeric_Value=4.000000000000000e+03}', "");
    Expect(1, 126240, '\p{^Is_Numeric_Value=4.000000000000000e+03}', "");
    Expect(1, 126240, '\P{Is_Numeric_Value=4.000000000000000e+03}', "");
    Expect(0, 126240, '\P{^Is_Numeric_Value=4.000000000000000e+03}', "");
    Error('\p{Is_Nv:		/a/00000004000}');
    Error('\P{Is_Nv:		/a/00000004000}');
    Expect(1, 126239, '\p{Is_Nv=000000004000}', "");
    Expect(0, 126239, '\p{^Is_Nv=000000004000}', "");
    Expect(0, 126239, '\P{Is_Nv=000000004000}', "");
    Expect(1, 126239, '\P{^Is_Nv=000000004000}', "");
    Expect(0, 126240, '\p{Is_Nv=000000004000}', "");
    Expect(1, 126240, '\p{^Is_Nv=000000004000}', "");
    Expect(1, 126240, '\P{Is_Nv=000000004000}', "");
    Expect(0, 126240, '\P{^Is_Nv=000000004000}', "");
    Expect(1, 126239, '\p{Is_Nv=4.000000000000000e+03}', "");
    Expect(0, 126239, '\p{^Is_Nv=4.000000000000000e+03}', "");
    Expect(0, 126239, '\P{Is_Nv=4.000000000000000e+03}', "");
    Expect(1, 126239, '\P{^Is_Nv=4.000000000000000e+03}', "");
    Expect(0, 126240, '\p{Is_Nv=4.000000000000000e+03}', "");
    Expect(1, 126240, '\p{^Is_Nv=4.000000000000000e+03}', "");
    Expect(1, 126240, '\P{Is_Nv=4.000000000000000e+03}', "");
    Expect(0, 126240, '\P{^Is_Nv=4.000000000000000e+03}', "");
    Error('\p{Numeric_Value:_:=000_000_400_00}');
    Error('\P{Numeric_Value:_:=000_000_400_00}');
    Expect(1, 126248, '\p{Numeric_Value=:\A40000\z:}', "");;
    Expect(0, 126249, '\p{Numeric_Value=:\A40000\z:}', "");;
    Expect(1, 126248, '\p{Numeric_Value=0_0_4_0_000}', "");
    Expect(0, 126248, '\p{^Numeric_Value=0_0_4_0_000}', "");
    Expect(0, 126248, '\P{Numeric_Value=0_0_4_0_000}', "");
    Expect(1, 126248, '\P{^Numeric_Value=0_0_4_0_000}', "");
    Expect(0, 126249, '\p{Numeric_Value=0_0_4_0_000}', "");
    Expect(1, 126249, '\p{^Numeric_Value=0_0_4_0_000}', "");
    Expect(1, 126249, '\P{Numeric_Value=0_0_4_0_000}', "");
    Expect(0, 126249, '\P{^Numeric_Value=0_0_4_0_000}', "");
    Expect(1, 126248, '\p{Numeric_Value=4.000000000000000e+04}', "");
    Expect(0, 126248, '\p{^Numeric_Value=4.000000000000000e+04}', "");
    Expect(0, 126248, '\P{Numeric_Value=4.000000000000000e+04}', "");
    Expect(1, 126248, '\P{^Numeric_Value=4.000000000000000e+04}', "");
    Expect(0, 126249, '\p{Numeric_Value=4.000000000000000e+04}', "");
    Expect(1, 126249, '\p{^Numeric_Value=4.000000000000000e+04}', "");
    Expect(1, 126249, '\P{Numeric_Value=4.000000000000000e+04}', "");
    Expect(0, 126249, '\P{^Numeric_Value=4.000000000000000e+04}', "");
    Error('\p{Nv=	-0_0_4_0_000:=}');
    Error('\P{Nv=	-0_0_4_0_000:=}');
    Expect(1, 126248, '\p{Nv=:\A40000\z:}', "");;
    Expect(0, 126249, '\p{Nv=:\A40000\z:}', "");;
    Expect(1, 126248, '\p{Nv=0000040000}', "");
    Expect(0, 126248, '\p{^Nv=0000040000}', "");
    Expect(0, 126248, '\P{Nv=0000040000}', "");
    Expect(1, 126248, '\P{^Nv=0000040000}', "");
    Expect(0, 126249, '\p{Nv=0000040000}', "");
    Expect(1, 126249, '\p{^Nv=0000040000}', "");
    Expect(1, 126249, '\P{Nv=0000040000}', "");
    Expect(0, 126249, '\P{^Nv=0000040000}', "");
    Expect(1, 126248, '\p{Nv=4.000000000000000e+04}', "");
    Expect(0, 126248, '\p{^Nv=4.000000000000000e+04}', "");
    Expect(0, 126248, '\P{Nv=4.000000000000000e+04}', "");
    Expect(1, 126248, '\P{^Nv=4.000000000000000e+04}', "");
    Expect(0, 126249, '\p{Nv=4.000000000000000e+04}', "");
    Expect(1, 126249, '\p{^Nv=4.000000000000000e+04}', "");
    Expect(1, 126249, '\P{Nv=4.000000000000000e+04}', "");
    Expect(0, 126249, '\P{^Nv=4.000000000000000e+04}', "");
    Error('\p{Is_Numeric_Value:   _ 0040000:=}');
    Error('\P{Is_Numeric_Value:   _ 0040000:=}');
    Expect(1, 126248, '\p{Is_Numeric_Value=00_00_00_04_00_00}', "");
    Expect(0, 126248, '\p{^Is_Numeric_Value=00_00_00_04_00_00}', "");
    Expect(0, 126248, '\P{Is_Numeric_Value=00_00_00_04_00_00}', "");
    Expect(1, 126248, '\P{^Is_Numeric_Value=00_00_00_04_00_00}', "");
    Expect(0, 126249, '\p{Is_Numeric_Value=00_00_00_04_00_00}', "");
    Expect(1, 126249, '\p{^Is_Numeric_Value=00_00_00_04_00_00}', "");
    Expect(1, 126249, '\P{Is_Numeric_Value=00_00_00_04_00_00}', "");
    Expect(0, 126249, '\P{^Is_Numeric_Value=00_00_00_04_00_00}', "");
    Expect(1, 126248, '\p{Is_Numeric_Value=4.000000000000000e+04}', "");
    Expect(0, 126248, '\p{^Is_Numeric_Value=4.000000000000000e+04}', "");
    Expect(0, 126248, '\P{Is_Numeric_Value=4.000000000000000e+04}', "");
    Expect(1, 126248, '\P{^Is_Numeric_Value=4.000000000000000e+04}', "");
    Expect(0, 126249, '\p{Is_Numeric_Value=4.000000000000000e+04}', "");
    Expect(1, 126249, '\p{^Is_Numeric_Value=4.000000000000000e+04}', "");
    Expect(1, 126249, '\P{Is_Numeric_Value=4.000000000000000e+04}', "");
    Expect(0, 126249, '\P{^Is_Numeric_Value=4.000000000000000e+04}', "");
    Error('\p{Is_Nv=-	+40000/a/}');
    Error('\P{Is_Nv=-	+40000/a/}');
    Expect(1, 126248, '\p{Is_Nv=0_0_0_0_0_0_40000}', "");
    Expect(0, 126248, '\p{^Is_Nv=0_0_0_0_0_0_40000}', "");
    Expect(0, 126248, '\P{Is_Nv=0_0_0_0_0_0_40000}', "");
    Expect(1, 126248, '\P{^Is_Nv=0_0_0_0_0_0_40000}', "");
    Expect(0, 126249, '\p{Is_Nv=0_0_0_0_0_0_40000}', "");
    Expect(1, 126249, '\p{^Is_Nv=0_0_0_0_0_0_40000}', "");
    Expect(1, 126249, '\P{Is_Nv=0_0_0_0_0_0_40000}', "");
    Expect(0, 126249, '\P{^Is_Nv=0_0_0_0_0_0_40000}', "");
    Expect(1, 126248, '\p{Is_Nv=4.000000000000000e+04}', "");
    Expect(0, 126248, '\p{^Is_Nv=4.000000000000000e+04}', "");
    Expect(0, 126248, '\P{Is_Nv=4.000000000000000e+04}', "");
    Expect(1, 126248, '\P{^Is_Nv=4.000000000000000e+04}', "");
    Expect(0, 126249, '\p{Is_Nv=4.000000000000000e+04}', "");
    Expect(1, 126249, '\p{^Is_Nv=4.000000000000000e+04}', "");
    Expect(1, 126249, '\P{Is_Nv=4.000000000000000e+04}', "");
    Expect(0, 126249, '\P{^Is_Nv=4.000000000000000e+04}', "");
    Error('\p{Numeric_Value= +00_00_00_00_04_00_000/a/}');
    Error('\P{Numeric_Value= +00_00_00_00_04_00_000/a/}');
    Expect(1, 68080, '\p{Numeric_Value=:\A400000\z:}', "");;
    Expect(0, 68081, '\p{Numeric_Value=:\A400000\z:}', "");;
    Expect(1, 68080, '\p{Numeric_Value=+0000000400000}', "");
    Expect(0, 68080, '\p{^Numeric_Value=+0000000400000}', "");
    Expect(0, 68080, '\P{Numeric_Value=+0000000400000}', "");
    Expect(1, 68080, '\P{^Numeric_Value=+0000000400000}', "");
    Expect(0, 68081, '\p{Numeric_Value=+0000000400000}', "");
    Expect(1, 68081, '\p{^Numeric_Value=+0000000400000}', "");
    Expect(1, 68081, '\P{Numeric_Value=+0000000400000}', "");
    Expect(0, 68081, '\P{^Numeric_Value=+0000000400000}', "");
    Expect(1, 68080, '\p{Numeric_Value=4.000000000000000e+05}', "");
    Expect(0, 68080, '\p{^Numeric_Value=4.000000000000000e+05}', "");
    Expect(0, 68080, '\P{Numeric_Value=4.000000000000000e+05}', "");
    Expect(1, 68080, '\P{^Numeric_Value=4.000000000000000e+05}', "");
    Expect(0, 68081, '\p{Numeric_Value=4.000000000000000e+05}', "");
    Expect(1, 68081, '\p{^Numeric_Value=4.000000000000000e+05}', "");
    Expect(1, 68081, '\P{Numeric_Value=4.000000000000000e+05}', "");
    Expect(0, 68081, '\P{^Numeric_Value=4.000000000000000e+05}', "");
    Error('\p{Nv: 	:=0_0_0_0_0_0_0_0_0_4_0_0_000}');
    Error('\P{Nv: 	:=0_0_0_0_0_0_0_0_0_4_0_0_000}');
    Expect(1, 68080, '\p{Nv=:\A400000\z:}', "");;
    Expect(0, 68081, '\p{Nv=:\A400000\z:}', "");;
    Expect(1, 68080, '\p{Nv=+000000000400000}', "");
    Expect(0, 68080, '\p{^Nv=+000000000400000}', "");
    Expect(0, 68080, '\P{Nv=+000000000400000}', "");
    Expect(1, 68080, '\P{^Nv=+000000000400000}', "");
    Expect(0, 68081, '\p{Nv=+000000000400000}', "");
    Expect(1, 68081, '\p{^Nv=+000000000400000}', "");
    Expect(1, 68081, '\P{Nv=+000000000400000}', "");
    Expect(0, 68081, '\P{^Nv=+000000000400000}', "");
    Expect(1, 68080, '\p{Nv=4.000000000000000e+05}', "");
    Expect(0, 68080, '\p{^Nv=4.000000000000000e+05}', "");
    Expect(0, 68080, '\P{Nv=4.000000000000000e+05}', "");
    Expect(1, 68080, '\P{^Nv=4.000000000000000e+05}', "");
    Expect(0, 68081, '\p{Nv=4.000000000000000e+05}', "");
    Expect(1, 68081, '\p{^Nv=4.000000000000000e+05}', "");
    Expect(1, 68081, '\P{Nv=4.000000000000000e+05}', "");
    Expect(0, 68081, '\P{^Nv=4.000000000000000e+05}', "");
    Error('\p{Is_Numeric_Value=/a/_400000}');
    Error('\P{Is_Numeric_Value=/a/_400000}');
    Expect(1, 68080, '\p{Is_Numeric_Value=0400000}', "");
    Expect(0, 68080, '\p{^Is_Numeric_Value=0400000}', "");
    Expect(0, 68080, '\P{Is_Numeric_Value=0400000}', "");
    Expect(1, 68080, '\P{^Is_Numeric_Value=0400000}', "");
    Expect(0, 68081, '\p{Is_Numeric_Value=0400000}', "");
    Expect(1, 68081, '\p{^Is_Numeric_Value=0400000}', "");
    Expect(1, 68081, '\P{Is_Numeric_Value=0400000}', "");
    Expect(0, 68081, '\P{^Is_Numeric_Value=0400000}', "");
    Expect(1, 68080, '\p{Is_Numeric_Value=4.000000000000000e+05}', "");
    Expect(0, 68080, '\p{^Is_Numeric_Value=4.000000000000000e+05}', "");
    Expect(0, 68080, '\P{Is_Numeric_Value=4.000000000000000e+05}', "");
    Expect(1, 68080, '\P{^Is_Numeric_Value=4.000000000000000e+05}', "");
    Expect(0, 68081, '\p{Is_Numeric_Value=4.000000000000000e+05}', "");
    Expect(1, 68081, '\p{^Is_Numeric_Value=4.000000000000000e+05}', "");
    Expect(1, 68081, '\P{Is_Numeric_Value=4.000000000000000e+05}', "");
    Expect(0, 68081, '\P{^Is_Numeric_Value=4.000000000000000e+05}', "");
    Error('\p{Is_Nv=	/a/0400000}');
    Error('\P{Is_Nv=	/a/0400000}');
    Expect(1, 68080, '\p{Is_Nv=+400000}', "");
    Expect(0, 68080, '\p{^Is_Nv=+400000}', "");
    Expect(0, 68080, '\P{Is_Nv=+400000}', "");
    Expect(1, 68080, '\P{^Is_Nv=+400000}', "");
    Expect(0, 68081, '\p{Is_Nv=+400000}', "");
    Expect(1, 68081, '\p{^Is_Nv=+400000}', "");
    Expect(1, 68081, '\P{Is_Nv=+400000}', "");
    Expect(0, 68081, '\P{^Is_Nv=+400000}', "");
    Expect(1, 68080, '\p{Is_Nv:4.000000000000000e+05}', "");
    Expect(0, 68080, '\p{^Is_Nv:4.000000000000000e+05}', "");
    Expect(0, 68080, '\P{Is_Nv:4.000000000000000e+05}', "");
    Expect(1, 68080, '\P{^Is_Nv:4.000000000000000e+05}', "");
    Expect(0, 68081, '\p{Is_Nv:4.000000000000000e+05}', "");
    Expect(1, 68081, '\p{^Is_Nv:4.000000000000000e+05}', "");
    Expect(1, 68081, '\P{Is_Nv:4.000000000000000e+05}', "");
    Expect(0, 68081, '\P{^Is_Nv:4.000000000000000e+05}', "");
    Error('\p{Numeric_Value=_00_00_41:=}');
    Error('\P{Numeric_Value=_00_00_41:=}');
    Expect(1, 12982, '\p{Numeric_Value=:\A41\z:}', "");;
    Expect(0, 12983, '\p{Numeric_Value=:\A41\z:}', "");;
    Expect(1, 12982, '\p{Numeric_Value=000000041}', "");
    Expect(0, 12982, '\p{^Numeric_Value=000000041}', "");
    Expect(0, 12982, '\P{Numeric_Value=000000041}', "");
    Expect(1, 12982, '\P{^Numeric_Value=000000041}', "");
    Expect(0, 12983, '\p{Numeric_Value=000000041}', "");
    Expect(1, 12983, '\p{^Numeric_Value=000000041}', "");
    Expect(1, 12983, '\P{Numeric_Value=000000041}', "");
    Expect(0, 12983, '\P{^Numeric_Value=000000041}', "");
    Expect(1, 12982, '\p{Numeric_Value=4.100000000000000e+01}', "");
    Expect(0, 12982, '\p{^Numeric_Value=4.100000000000000e+01}', "");
    Expect(0, 12982, '\P{Numeric_Value=4.100000000000000e+01}', "");
    Expect(1, 12982, '\P{^Numeric_Value=4.100000000000000e+01}', "");
    Expect(0, 12983, '\p{Numeric_Value=4.100000000000000e+01}', "");
    Expect(1, 12983, '\p{^Numeric_Value=4.100000000000000e+01}', "");
    Expect(1, 12983, '\P{Numeric_Value=4.100000000000000e+01}', "");
    Expect(0, 12983, '\P{^Numeric_Value=4.100000000000000e+01}', "");
    Error('\p{Nv=/a/__+000000041}');
    Error('\P{Nv=/a/__+000000041}');
    Expect(1, 12982, '\p{Nv=:\A41\z:}', "");;
    Expect(0, 12983, '\p{Nv=:\A41\z:}', "");;
    Expect(1, 12982, '\p{Nv=+0_0_0_0_0_0_0_041}', "");
    Expect(0, 12982, '\p{^Nv=+0_0_0_0_0_0_0_041}', "");
    Expect(0, 12982, '\P{Nv=+0_0_0_0_0_0_0_041}', "");
    Expect(1, 12982, '\P{^Nv=+0_0_0_0_0_0_0_041}', "");
    Expect(0, 12983, '\p{Nv=+0_0_0_0_0_0_0_041}', "");
    Expect(1, 12983, '\p{^Nv=+0_0_0_0_0_0_0_041}', "");
    Expect(1, 12983, '\P{Nv=+0_0_0_0_0_0_0_041}', "");
    Expect(0, 12983, '\P{^Nv=+0_0_0_0_0_0_0_041}', "");
    Expect(1, 12982, '\p{Nv=4.100000000000000e+01}', "");
    Expect(0, 12982, '\p{^Nv=4.100000000000000e+01}', "");
    Expect(0, 12982, '\P{Nv=4.100000000000000e+01}', "");
    Expect(1, 12982, '\P{^Nv=4.100000000000000e+01}', "");
    Expect(0, 12983, '\p{Nv=4.100000000000000e+01}', "");
    Expect(1, 12983, '\p{^Nv=4.100000000000000e+01}', "");
    Expect(1, 12983, '\P{Nv=4.100000000000000e+01}', "");
    Expect(0, 12983, '\P{^Nv=4.100000000000000e+01}', "");
    Error('\p{Is_Numeric_Value=	 00041/a/}');
    Error('\P{Is_Numeric_Value=	 00041/a/}');
    Expect(1, 12982, '\p{Is_Numeric_Value=+0041}', "");
    Expect(0, 12982, '\p{^Is_Numeric_Value=+0041}', "");
    Expect(0, 12982, '\P{Is_Numeric_Value=+0041}', "");
    Expect(1, 12982, '\P{^Is_Numeric_Value=+0041}', "");
    Expect(0, 12983, '\p{Is_Numeric_Value=+0041}', "");
    Expect(1, 12983, '\p{^Is_Numeric_Value=+0041}', "");
    Expect(1, 12983, '\P{Is_Numeric_Value=+0041}', "");
    Expect(0, 12983, '\P{^Is_Numeric_Value=+0041}', "");
    Expect(1, 12982, '\p{Is_Numeric_Value=4.100000000000000e+01}', "");
    Expect(0, 12982, '\p{^Is_Numeric_Value=4.100000000000000e+01}', "");
    Expect(0, 12982, '\P{Is_Numeric_Value=4.100000000000000e+01}', "");
    Expect(1, 12982, '\P{^Is_Numeric_Value=4.100000000000000e+01}', "");
    Expect(0, 12983, '\p{Is_Numeric_Value=4.100000000000000e+01}', "");
    Expect(1, 12983, '\p{^Is_Numeric_Value=4.100000000000000e+01}', "");
    Expect(1, 12983, '\P{Is_Numeric_Value=4.100000000000000e+01}', "");
    Expect(0, 12983, '\P{^Is_Numeric_Value=4.100000000000000e+01}', "");
    Error('\p{Is_Nv=-/a/00041}');
    Error('\P{Is_Nv=-/a/00041}');
    Expect(1, 12982, '\p{Is_Nv:	41}', "");
    Expect(0, 12982, '\p{^Is_Nv:	41}', "");
    Expect(0, 12982, '\P{Is_Nv:	41}', "");
    Expect(1, 12982, '\P{^Is_Nv:	41}', "");
    Expect(0, 12983, '\p{Is_Nv:	41}', "");
    Expect(1, 12983, '\p{^Is_Nv:	41}', "");
    Expect(1, 12983, '\P{Is_Nv:	41}', "");
    Expect(0, 12983, '\P{^Is_Nv:	41}', "");
    Expect(1, 12982, '\p{Is_Nv=4.100000000000000e+01}', "");
    Expect(0, 12982, '\p{^Is_Nv=4.100000000000000e+01}', "");
    Expect(0, 12982, '\P{Is_Nv=4.100000000000000e+01}', "");
    Expect(1, 12982, '\P{^Is_Nv=4.100000000000000e+01}', "");
    Expect(0, 12983, '\p{Is_Nv=4.100000000000000e+01}', "");
    Expect(1, 12983, '\p{^Is_Nv=4.100000000000000e+01}', "");
    Expect(1, 12983, '\P{Is_Nv=4.100000000000000e+01}', "");
    Expect(0, 12983, '\P{^Is_Nv=4.100000000000000e+01}', "");
    Error('\p{Numeric_Value:			00000042:=}');
    Error('\P{Numeric_Value:			00000042:=}');
    Expect(1, 12983, '\p{Numeric_Value=:\A42\z:}', "");;
    Expect(0, 12984, '\p{Numeric_Value=:\A42\z:}', "");;
    Expect(1, 12983, '\p{Numeric_Value=+0042}', "");
    Expect(0, 12983, '\p{^Numeric_Value=+0042}', "");
    Expect(0, 12983, '\P{Numeric_Value=+0042}', "");
    Expect(1, 12983, '\P{^Numeric_Value=+0042}', "");
    Expect(0, 12984, '\p{Numeric_Value=+0042}', "");
    Expect(1, 12984, '\p{^Numeric_Value=+0042}', "");
    Expect(1, 12984, '\P{Numeric_Value=+0042}', "");
    Expect(0, 12984, '\P{^Numeric_Value=+0042}', "");
    Expect(1, 12983, '\p{Numeric_Value=4.200000000000000e+01}', "");
    Expect(0, 12983, '\p{^Numeric_Value=4.200000000000000e+01}', "");
    Expect(0, 12983, '\P{Numeric_Value=4.200000000000000e+01}', "");
    Expect(1, 12983, '\P{^Numeric_Value=4.200000000000000e+01}', "");
    Expect(0, 12984, '\p{Numeric_Value=4.200000000000000e+01}', "");
    Expect(1, 12984, '\p{^Numeric_Value=4.200000000000000e+01}', "");
    Expect(1, 12984, '\P{Numeric_Value=4.200000000000000e+01}', "");
    Expect(0, 12984, '\P{^Numeric_Value=4.200000000000000e+01}', "");
    Error('\p{Nv=_042:=}');
    Error('\P{Nv=_042:=}');
    Expect(1, 12983, '\p{Nv=:\A42\z:}', "");;
    Expect(0, 12984, '\p{Nv=:\A42\z:}', "");;
    Expect(1, 12983, '\p{Nv=00042}', "");
    Expect(0, 12983, '\p{^Nv=00042}', "");
    Expect(0, 12983, '\P{Nv=00042}', "");
    Expect(1, 12983, '\P{^Nv=00042}', "");
    Expect(0, 12984, '\p{Nv=00042}', "");
    Expect(1, 12984, '\p{^Nv=00042}', "");
    Expect(1, 12984, '\P{Nv=00042}', "");
    Expect(0, 12984, '\P{^Nv=00042}', "");
    Expect(1, 12983, '\p{Nv=4.200000000000000e+01}', "");
    Expect(0, 12983, '\p{^Nv=4.200000000000000e+01}', "");
    Expect(0, 12983, '\P{Nv=4.200000000000000e+01}', "");
    Expect(1, 12983, '\P{^Nv=4.200000000000000e+01}', "");
    Expect(0, 12984, '\p{Nv=4.200000000000000e+01}', "");
    Expect(1, 12984, '\p{^Nv=4.200000000000000e+01}', "");
    Expect(1, 12984, '\P{Nv=4.200000000000000e+01}', "");
    Expect(0, 12984, '\P{^Nv=4.200000000000000e+01}', "");
    Error('\p{Is_Numeric_Value= 004_2/a/}');
    Error('\P{Is_Numeric_Value= 004_2/a/}');
    Expect(1, 12983, '\p{Is_Numeric_Value=00042}', "");
    Expect(0, 12983, '\p{^Is_Numeric_Value=00042}', "");
    Expect(0, 12983, '\P{Is_Numeric_Value=00042}', "");
    Expect(1, 12983, '\P{^Is_Numeric_Value=00042}', "");
    Expect(0, 12984, '\p{Is_Numeric_Value=00042}', "");
    Expect(1, 12984, '\p{^Is_Numeric_Value=00042}', "");
    Expect(1, 12984, '\P{Is_Numeric_Value=00042}', "");
    Expect(0, 12984, '\P{^Is_Numeric_Value=00042}', "");
    Expect(1, 12983, '\p{Is_Numeric_Value=4.200000000000000e+01}', "");
    Expect(0, 12983, '\p{^Is_Numeric_Value=4.200000000000000e+01}', "");
    Expect(0, 12983, '\P{Is_Numeric_Value=4.200000000000000e+01}', "");
    Expect(1, 12983, '\P{^Is_Numeric_Value=4.200000000000000e+01}', "");
    Expect(0, 12984, '\p{Is_Numeric_Value=4.200000000000000e+01}', "");
    Expect(1, 12984, '\p{^Is_Numeric_Value=4.200000000000000e+01}', "");
    Expect(1, 12984, '\P{Is_Numeric_Value=4.200000000000000e+01}', "");
    Expect(0, 12984, '\P{^Is_Numeric_Value=4.200000000000000e+01}', "");
    Error('\p{Is_Nv=:=-0_0_0_0_0042}');
    Error('\P{Is_Nv=:=-0_0_0_0_0042}');
    Expect(1, 12983, '\p{Is_Nv=00_04_2}', "");
    Expect(0, 12983, '\p{^Is_Nv=00_04_2}', "");
    Expect(0, 12983, '\P{Is_Nv=00_04_2}', "");
    Expect(1, 12983, '\P{^Is_Nv=00_04_2}', "");
    Expect(0, 12984, '\p{Is_Nv=00_04_2}', "");
    Expect(1, 12984, '\p{^Is_Nv=00_04_2}', "");
    Expect(1, 12984, '\P{Is_Nv=00_04_2}', "");
    Expect(0, 12984, '\P{^Is_Nv=00_04_2}', "");
    Expect(1, 12983, '\p{Is_Nv=4.200000000000000e+01}', "");
    Expect(0, 12983, '\p{^Is_Nv=4.200000000000000e+01}', "");
    Expect(0, 12983, '\P{Is_Nv=4.200000000000000e+01}', "");
    Expect(1, 12983, '\P{^Is_Nv=4.200000000000000e+01}', "");
    Expect(0, 12984, '\p{Is_Nv=4.200000000000000e+01}', "");
    Expect(1, 12984, '\p{^Is_Nv=4.200000000000000e+01}', "");
    Expect(1, 12984, '\P{Is_Nv=4.200000000000000e+01}', "");
    Expect(0, 12984, '\P{^Is_Nv=4.200000000000000e+01}', "");
    Error('\p{Numeric_Value=	/a/+00000043}');
    Error('\P{Numeric_Value=	/a/+00000043}');
    Expect(1, 12984, '\p{Numeric_Value=:\A43\z:}', "");;
    Expect(0, 12985, '\p{Numeric_Value=:\A43\z:}', "");;
    Expect(1, 12984, '\p{Numeric_Value=0000043}', "");
    Expect(0, 12984, '\p{^Numeric_Value=0000043}', "");
    Expect(0, 12984, '\P{Numeric_Value=0000043}', "");
    Expect(1, 12984, '\P{^Numeric_Value=0000043}', "");
    Expect(0, 12985, '\p{Numeric_Value=0000043}', "");
    Expect(1, 12985, '\p{^Numeric_Value=0000043}', "");
    Expect(1, 12985, '\P{Numeric_Value=0000043}', "");
    Expect(0, 12985, '\P{^Numeric_Value=0000043}', "");
    Expect(1, 12984, '\p{Numeric_Value=4.300000000000000e+01}', "");
    Expect(0, 12984, '\p{^Numeric_Value=4.300000000000000e+01}', "");
    Expect(0, 12984, '\P{Numeric_Value=4.300000000000000e+01}', "");
    Expect(1, 12984, '\P{^Numeric_Value=4.300000000000000e+01}', "");
    Expect(0, 12985, '\p{Numeric_Value=4.300000000000000e+01}', "");
    Expect(1, 12985, '\p{^Numeric_Value=4.300000000000000e+01}', "");
    Expect(1, 12985, '\P{Numeric_Value=4.300000000000000e+01}', "");
    Expect(0, 12985, '\P{^Numeric_Value=4.300000000000000e+01}', "");
    Error('\p{Nv=  00000043/a/}');
    Error('\P{Nv=  00000043/a/}');
    Expect(1, 12984, '\p{Nv=:\A43\z:}', "");;
    Expect(0, 12985, '\p{Nv=:\A43\z:}', "");;
    Expect(1, 12984, '\p{Nv=00000000043}', "");
    Expect(0, 12984, '\p{^Nv=00000000043}', "");
    Expect(0, 12984, '\P{Nv=00000000043}', "");
    Expect(1, 12984, '\P{^Nv=00000000043}', "");
    Expect(0, 12985, '\p{Nv=00000000043}', "");
    Expect(1, 12985, '\p{^Nv=00000000043}', "");
    Expect(1, 12985, '\P{Nv=00000000043}', "");
    Expect(0, 12985, '\P{^Nv=00000000043}', "");
    Expect(1, 12984, '\p{Nv=4.300000000000000e+01}', "");
    Expect(0, 12984, '\p{^Nv=4.300000000000000e+01}', "");
    Expect(0, 12984, '\P{Nv=4.300000000000000e+01}', "");
    Expect(1, 12984, '\P{^Nv=4.300000000000000e+01}', "");
    Expect(0, 12985, '\p{Nv=4.300000000000000e+01}', "");
    Expect(1, 12985, '\p{^Nv=4.300000000000000e+01}', "");
    Expect(1, 12985, '\P{Nv=4.300000000000000e+01}', "");
    Expect(0, 12985, '\P{^Nv=4.300000000000000e+01}', "");
    Error('\p{Is_Numeric_Value= /a/00000000043}');
    Error('\P{Is_Numeric_Value= /a/00000000043}');
    Expect(1, 12984, '\p{Is_Numeric_Value=00043}', "");
    Expect(0, 12984, '\p{^Is_Numeric_Value=00043}', "");
    Expect(0, 12984, '\P{Is_Numeric_Value=00043}', "");
    Expect(1, 12984, '\P{^Is_Numeric_Value=00043}', "");
    Expect(0, 12985, '\p{Is_Numeric_Value=00043}', "");
    Expect(1, 12985, '\p{^Is_Numeric_Value=00043}', "");
    Expect(1, 12985, '\P{Is_Numeric_Value=00043}', "");
    Expect(0, 12985, '\P{^Is_Numeric_Value=00043}', "");
    Expect(1, 12984, '\p{Is_Numeric_Value=4.300000000000000e+01}', "");
    Expect(0, 12984, '\p{^Is_Numeric_Value=4.300000000000000e+01}', "");
    Expect(0, 12984, '\P{Is_Numeric_Value=4.300000000000000e+01}', "");
    Expect(1, 12984, '\P{^Is_Numeric_Value=4.300000000000000e+01}', "");
    Expect(0, 12985, '\p{Is_Numeric_Value=4.300000000000000e+01}', "");
    Expect(1, 12985, '\p{^Is_Numeric_Value=4.300000000000000e+01}', "");
    Expect(1, 12985, '\P{Is_Numeric_Value=4.300000000000000e+01}', "");
    Expect(0, 12985, '\P{^Is_Numeric_Value=4.300000000000000e+01}', "");
    Error('\p{Is_Nv=:=0_0_0_0_0_043}');
    Error('\P{Is_Nv=:=0_0_0_0_0_043}');
    Expect(1, 12984, '\p{Is_Nv: +043}', "");
    Expect(0, 12984, '\p{^Is_Nv: +043}', "");
    Expect(0, 12984, '\P{Is_Nv: +043}', "");
    Expect(1, 12984, '\P{^Is_Nv: +043}', "");
    Expect(0, 12985, '\p{Is_Nv: +043}', "");
    Expect(1, 12985, '\p{^Is_Nv: +043}', "");
    Expect(1, 12985, '\P{Is_Nv: +043}', "");
    Expect(0, 12985, '\P{^Is_Nv: +043}', "");
    Expect(1, 12984, '\p{Is_Nv=4.300000000000000e+01}', "");
    Expect(0, 12984, '\p{^Is_Nv=4.300000000000000e+01}', "");
    Expect(0, 12984, '\P{Is_Nv=4.300000000000000e+01}', "");
    Expect(1, 12984, '\P{^Is_Nv=4.300000000000000e+01}', "");
    Expect(0, 12985, '\p{Is_Nv=4.300000000000000e+01}', "");
    Expect(1, 12985, '\p{^Is_Nv=4.300000000000000e+01}', "");
    Expect(1, 12985, '\P{Is_Nv=4.300000000000000e+01}', "");
    Expect(0, 12985, '\P{^Is_Nv=4.300000000000000e+01}', "");
    Error('\p{Numeric_Value=	/a/00_00_00_00_04_32000}');
    Error('\P{Numeric_Value=	/a/00_00_00_00_04_32000}');
    Expect(1, 74803, '\p{Numeric_Value=:\A432000\z:}', "");;
    Expect(0, 74804, '\p{Numeric_Value=:\A432000\z:}', "");;
    Expect(1, 74803, '\p{Numeric_Value=+0_0_0_0_4_3_2_0_00}', "");
    Expect(0, 74803, '\p{^Numeric_Value=+0_0_0_0_4_3_2_0_00}', "");
    Expect(0, 74803, '\P{Numeric_Value=+0_0_0_0_4_3_2_0_00}', "");
    Expect(1, 74803, '\P{^Numeric_Value=+0_0_0_0_4_3_2_0_00}', "");
    Expect(0, 74804, '\p{Numeric_Value=+0_0_0_0_4_3_2_0_00}', "");
    Expect(1, 74804, '\p{^Numeric_Value=+0_0_0_0_4_3_2_0_00}', "");
    Expect(1, 74804, '\P{Numeric_Value=+0_0_0_0_4_3_2_0_00}', "");
    Expect(0, 74804, '\P{^Numeric_Value=+0_0_0_0_4_3_2_0_00}', "");
    Expect(1, 74803, '\p{Numeric_Value=4.320000000000000e+05}', "");
    Expect(0, 74803, '\p{^Numeric_Value=4.320000000000000e+05}', "");
    Expect(0, 74803, '\P{Numeric_Value=4.320000000000000e+05}', "");
    Expect(1, 74803, '\P{^Numeric_Value=4.320000000000000e+05}', "");
    Expect(0, 74804, '\p{Numeric_Value=4.320000000000000e+05}', "");
    Expect(1, 74804, '\p{^Numeric_Value=4.320000000000000e+05}', "");
    Expect(1, 74804, '\P{Numeric_Value=4.320000000000000e+05}', "");
    Expect(0, 74804, '\P{^Numeric_Value=4.320000000000000e+05}', "");
    Error('\p{Nv=/a/		43_20_00}');
    Error('\P{Nv=/a/		43_20_00}');
    Expect(1, 74803, '\p{Nv=:\A432000\z:}', "");;
    Expect(0, 74804, '\p{Nv=:\A432000\z:}', "");;
    Expect(1, 74803, '\p{Nv=43200_0}', "");
    Expect(0, 74803, '\p{^Nv=43200_0}', "");
    Expect(0, 74803, '\P{Nv=43200_0}', "");
    Expect(1, 74803, '\P{^Nv=43200_0}', "");
    Expect(0, 74804, '\p{Nv=43200_0}', "");
    Expect(1, 74804, '\p{^Nv=43200_0}', "");
    Expect(1, 74804, '\P{Nv=43200_0}', "");
    Expect(0, 74804, '\P{^Nv=43200_0}', "");
    Expect(1, 74803, '\p{Nv=4.320000000000000e+05}', "");
    Expect(0, 74803, '\p{^Nv=4.320000000000000e+05}', "");
    Expect(0, 74803, '\P{Nv=4.320000000000000e+05}', "");
    Expect(1, 74803, '\P{^Nv=4.320000000000000e+05}', "");
    Expect(0, 74804, '\p{Nv=4.320000000000000e+05}', "");
    Expect(1, 74804, '\p{^Nv=4.320000000000000e+05}', "");
    Expect(1, 74804, '\P{Nv=4.320000000000000e+05}', "");
    Expect(0, 74804, '\P{^Nv=4.320000000000000e+05}', "");
    Error('\p{Is_Numeric_Value=/a/	+0_0_0_0_0_0_4_3_2_000}');
    Error('\P{Is_Numeric_Value=/a/	+0_0_0_0_0_0_4_3_2_000}');
    Expect(1, 74803, '\p{Is_Numeric_Value=000000432000}', "");
    Expect(0, 74803, '\p{^Is_Numeric_Value=000000432000}', "");
    Expect(0, 74803, '\P{Is_Numeric_Value=000000432000}', "");
    Expect(1, 74803, '\P{^Is_Numeric_Value=000000432000}', "");
    Expect(0, 74804, '\p{Is_Numeric_Value=000000432000}', "");
    Expect(1, 74804, '\p{^Is_Numeric_Value=000000432000}', "");
    Expect(1, 74804, '\P{Is_Numeric_Value=000000432000}', "");
    Expect(0, 74804, '\P{^Is_Numeric_Value=000000432000}', "");
    Expect(1, 74803, '\p{Is_Numeric_Value=4.320000000000000e+05}', "");
    Expect(0, 74803, '\p{^Is_Numeric_Value=4.320000000000000e+05}', "");
    Expect(0, 74803, '\P{Is_Numeric_Value=4.320000000000000e+05}', "");
    Expect(1, 74803, '\P{^Is_Numeric_Value=4.320000000000000e+05}', "");
    Expect(0, 74804, '\p{Is_Numeric_Value=4.320000000000000e+05}', "");
    Expect(1, 74804, '\p{^Is_Numeric_Value=4.320000000000000e+05}', "");
    Expect(1, 74804, '\P{Is_Numeric_Value=4.320000000000000e+05}', "");
    Expect(0, 74804, '\P{^Is_Numeric_Value=4.320000000000000e+05}', "");
    Error('\p{Is_Nv=--0432000/a/}');
    Error('\P{Is_Nv=--0432000/a/}');
    Expect(1, 74803, '\p{Is_Nv=0432000}', "");
    Expect(0, 74803, '\p{^Is_Nv=0432000}', "");
    Expect(0, 74803, '\P{Is_Nv=0432000}', "");
    Expect(1, 74803, '\P{^Is_Nv=0432000}', "");
    Expect(0, 74804, '\p{Is_Nv=0432000}', "");
    Expect(1, 74804, '\p{^Is_Nv=0432000}', "");
    Expect(1, 74804, '\P{Is_Nv=0432000}', "");
    Expect(0, 74804, '\P{^Is_Nv=0432000}', "");
    Expect(1, 74803, '\p{Is_Nv=4.320000000000000e+05}', "");
    Expect(0, 74803, '\p{^Is_Nv=4.320000000000000e+05}', "");
    Expect(0, 74803, '\P{Is_Nv=4.320000000000000e+05}', "");
    Expect(1, 74803, '\P{^Is_Nv=4.320000000000000e+05}', "");
    Expect(0, 74804, '\p{Is_Nv=4.320000000000000e+05}', "");
    Expect(1, 74804, '\p{^Is_Nv=4.320000000000000e+05}', "");
    Expect(1, 74804, '\P{Is_Nv=4.320000000000000e+05}', "");
    Expect(0, 74804, '\P{^Is_Nv=4.320000000000000e+05}', "");
    Error('\p{Numeric_Value=:=	+4_4}');
    Error('\P{Numeric_Value=:=	+4_4}');
    Expect(1, 12985, '\p{Numeric_Value=:\A44\z:}', "");;
    Expect(0, 12986, '\p{Numeric_Value=:\A44\z:}', "");;
    Expect(1, 12985, '\p{Numeric_Value=+00044}', "");
    Expect(0, 12985, '\p{^Numeric_Value=+00044}', "");
    Expect(0, 12985, '\P{Numeric_Value=+00044}', "");
    Expect(1, 12985, '\P{^Numeric_Value=+00044}', "");
    Expect(0, 12986, '\p{Numeric_Value=+00044}', "");
    Expect(1, 12986, '\p{^Numeric_Value=+00044}', "");
    Expect(1, 12986, '\P{Numeric_Value=+00044}', "");
    Expect(0, 12986, '\P{^Numeric_Value=+00044}', "");
    Expect(1, 12985, '\p{Numeric_Value=4.400000000000000e+01}', "");
    Expect(0, 12985, '\p{^Numeric_Value=4.400000000000000e+01}', "");
    Expect(0, 12985, '\P{Numeric_Value=4.400000000000000e+01}', "");
    Expect(1, 12985, '\P{^Numeric_Value=4.400000000000000e+01}', "");
    Expect(0, 12986, '\p{Numeric_Value=4.400000000000000e+01}', "");
    Expect(1, 12986, '\p{^Numeric_Value=4.400000000000000e+01}', "");
    Expect(1, 12986, '\P{Numeric_Value=4.400000000000000e+01}', "");
    Expect(0, 12986, '\P{^Numeric_Value=4.400000000000000e+01}', "");
    Error('\p{Nv=/a/0_0_0_0_0_0_0_0_44}');
    Error('\P{Nv=/a/0_0_0_0_0_0_0_0_44}');
    Expect(1, 12985, '\p{Nv=:\A44\z:}', "");;
    Expect(0, 12986, '\p{Nv=:\A44\z:}', "");;
    Expect(1, 12985, '\p{Nv=04_4}', "");
    Expect(0, 12985, '\p{^Nv=04_4}', "");
    Expect(0, 12985, '\P{Nv=04_4}', "");
    Expect(1, 12985, '\P{^Nv=04_4}', "");
    Expect(0, 12986, '\p{Nv=04_4}', "");
    Expect(1, 12986, '\p{^Nv=04_4}', "");
    Expect(1, 12986, '\P{Nv=04_4}', "");
    Expect(0, 12986, '\P{^Nv=04_4}', "");
    Expect(1, 12985, '\p{Nv=4.400000000000000e+01}', "");
    Expect(0, 12985, '\p{^Nv=4.400000000000000e+01}', "");
    Expect(0, 12985, '\P{Nv=4.400000000000000e+01}', "");
    Expect(1, 12985, '\P{^Nv=4.400000000000000e+01}', "");
    Expect(0, 12986, '\p{Nv=4.400000000000000e+01}', "");
    Expect(1, 12986, '\p{^Nv=4.400000000000000e+01}', "");
    Expect(1, 12986, '\P{Nv=4.400000000000000e+01}', "");
    Expect(0, 12986, '\P{^Nv=4.400000000000000e+01}', "");
    Error('\p{Is_Numeric_Value:	0000000004_4:=}');
    Error('\P{Is_Numeric_Value:	0000000004_4:=}');
    Expect(1, 12985, '\p{Is_Numeric_Value=+0_0_0_44}', "");
    Expect(0, 12985, '\p{^Is_Numeric_Value=+0_0_0_44}', "");
    Expect(0, 12985, '\P{Is_Numeric_Value=+0_0_0_44}', "");
    Expect(1, 12985, '\P{^Is_Numeric_Value=+0_0_0_44}', "");
    Expect(0, 12986, '\p{Is_Numeric_Value=+0_0_0_44}', "");
    Expect(1, 12986, '\p{^Is_Numeric_Value=+0_0_0_44}', "");
    Expect(1, 12986, '\P{Is_Numeric_Value=+0_0_0_44}', "");
    Expect(0, 12986, '\P{^Is_Numeric_Value=+0_0_0_44}', "");
    Expect(1, 12985, '\p{Is_Numeric_Value=4.400000000000000e+01}', "");
    Expect(0, 12985, '\p{^Is_Numeric_Value=4.400000000000000e+01}', "");
    Expect(0, 12985, '\P{Is_Numeric_Value=4.400000000000000e+01}', "");
    Expect(1, 12985, '\P{^Is_Numeric_Value=4.400000000000000e+01}', "");
    Expect(0, 12986, '\p{Is_Numeric_Value=4.400000000000000e+01}', "");
    Expect(1, 12986, '\p{^Is_Numeric_Value=4.400000000000000e+01}', "");
    Expect(1, 12986, '\P{Is_Numeric_Value=4.400000000000000e+01}', "");
    Expect(0, 12986, '\P{^Is_Numeric_Value=4.400000000000000e+01}', "");
    Error('\p{Is_Nv=_/a/44}');
    Error('\P{Is_Nv=_/a/44}');
    Expect(1, 12985, '\p{Is_Nv=0000044}', "");
    Expect(0, 12985, '\p{^Is_Nv=0000044}', "");
    Expect(0, 12985, '\P{Is_Nv=0000044}', "");
    Expect(1, 12985, '\P{^Is_Nv=0000044}', "");
    Expect(0, 12986, '\p{Is_Nv=0000044}', "");
    Expect(1, 12986, '\p{^Is_Nv=0000044}', "");
    Expect(1, 12986, '\P{Is_Nv=0000044}', "");
    Expect(0, 12986, '\P{^Is_Nv=0000044}', "");
    Expect(1, 12985, '\p{Is_Nv: 4.400000000000000e+01}', "");
    Expect(0, 12985, '\p{^Is_Nv: 4.400000000000000e+01}', "");
    Expect(0, 12985, '\P{Is_Nv: 4.400000000000000e+01}', "");
    Expect(1, 12985, '\P{^Is_Nv: 4.400000000000000e+01}', "");
    Expect(0, 12986, '\p{Is_Nv: 4.400000000000000e+01}', "");
    Expect(1, 12986, '\p{^Is_Nv: 4.400000000000000e+01}', "");
    Expect(1, 12986, '\P{Is_Nv: 4.400000000000000e+01}', "");
    Expect(0, 12986, '\P{^Is_Nv: 4.400000000000000e+01}', "");
    Error('\p{Numeric_Value=	_0_0_0_0_0_0_45:=}');
    Error('\P{Numeric_Value=	_0_0_0_0_0_0_45:=}');
    Expect(1, 12986, '\p{Numeric_Value=:\A45\z:}', "");;
    Expect(0, 12987, '\p{Numeric_Value=:\A45\z:}', "");;
    Expect(1, 12986, '\p{Numeric_Value=0000_0000_45}', "");
    Expect(0, 12986, '\p{^Numeric_Value=0000_0000_45}', "");
    Expect(0, 12986, '\P{Numeric_Value=0000_0000_45}', "");
    Expect(1, 12986, '\P{^Numeric_Value=0000_0000_45}', "");
    Expect(0, 12987, '\p{Numeric_Value=0000_0000_45}', "");
    Expect(1, 12987, '\p{^Numeric_Value=0000_0000_45}', "");
    Expect(1, 12987, '\P{Numeric_Value=0000_0000_45}', "");
    Expect(0, 12987, '\P{^Numeric_Value=0000_0000_45}', "");
    Expect(1, 12986, '\p{Numeric_Value:	4.500000000000000e+01}', "");
    Expect(0, 12986, '\p{^Numeric_Value:	4.500000000000000e+01}', "");
    Expect(0, 12986, '\P{Numeric_Value:	4.500000000000000e+01}', "");
    Expect(1, 12986, '\P{^Numeric_Value:	4.500000000000000e+01}', "");
    Expect(0, 12987, '\p{Numeric_Value:	4.500000000000000e+01}', "");
    Expect(1, 12987, '\p{^Numeric_Value:	4.500000000000000e+01}', "");
    Expect(1, 12987, '\P{Numeric_Value:	4.500000000000000e+01}', "");
    Expect(0, 12987, '\P{^Numeric_Value:	4.500000000000000e+01}', "");
    Error('\p{Nv=	 0045:=}');
    Error('\P{Nv=	 0045:=}');
    Expect(1, 12986, '\p{Nv=:\A45\z:}', "");;
    Expect(0, 12987, '\p{Nv=:\A45\z:}', "");;
    Expect(1, 12986, '\p{Nv=00_00_00_00_45}', "");
    Expect(0, 12986, '\p{^Nv=00_00_00_00_45}', "");
    Expect(0, 12986, '\P{Nv=00_00_00_00_45}', "");
    Expect(1, 12986, '\P{^Nv=00_00_00_00_45}', "");
    Expect(0, 12987, '\p{Nv=00_00_00_00_45}', "");
    Expect(1, 12987, '\p{^Nv=00_00_00_00_45}', "");
    Expect(1, 12987, '\P{Nv=00_00_00_00_45}', "");
    Expect(0, 12987, '\P{^Nv=00_00_00_00_45}', "");
    Expect(1, 12986, '\p{Nv=4.500000000000000e+01}', "");
    Expect(0, 12986, '\p{^Nv=4.500000000000000e+01}', "");
    Expect(0, 12986, '\P{Nv=4.500000000000000e+01}', "");
    Expect(1, 12986, '\P{^Nv=4.500000000000000e+01}', "");
    Expect(0, 12987, '\p{Nv=4.500000000000000e+01}', "");
    Expect(1, 12987, '\p{^Nv=4.500000000000000e+01}', "");
    Expect(1, 12987, '\P{Nv=4.500000000000000e+01}', "");
    Expect(0, 12987, '\P{^Nv=4.500000000000000e+01}', "");
    Error('\p{Is_Numeric_Value=:=- +0_0_0_0_0_0_45}');
    Error('\P{Is_Numeric_Value=:=- +0_0_0_0_0_0_45}');
    Expect(1, 12986, '\p{Is_Numeric_Value=+00045}', "");
    Expect(0, 12986, '\p{^Is_Numeric_Value=+00045}', "");
    Expect(0, 12986, '\P{Is_Numeric_Value=+00045}', "");
    Expect(1, 12986, '\P{^Is_Numeric_Value=+00045}', "");
    Expect(0, 12987, '\p{Is_Numeric_Value=+00045}', "");
    Expect(1, 12987, '\p{^Is_Numeric_Value=+00045}', "");
    Expect(1, 12987, '\P{Is_Numeric_Value=+00045}', "");
    Expect(0, 12987, '\P{^Is_Numeric_Value=+00045}', "");
    Expect(1, 12986, '\p{Is_Numeric_Value=4.500000000000000e+01}', "");
    Expect(0, 12986, '\p{^Is_Numeric_Value=4.500000000000000e+01}', "");
    Expect(0, 12986, '\P{Is_Numeric_Value=4.500000000000000e+01}', "");
    Expect(1, 12986, '\P{^Is_Numeric_Value=4.500000000000000e+01}', "");
    Expect(0, 12987, '\p{Is_Numeric_Value=4.500000000000000e+01}', "");
    Expect(1, 12987, '\p{^Is_Numeric_Value=4.500000000000000e+01}', "");
    Expect(1, 12987, '\P{Is_Numeric_Value=4.500000000000000e+01}', "");
    Expect(0, 12987, '\P{^Is_Numeric_Value=4.500000000000000e+01}', "");
    Error('\p{Is_Nv= :=+00_00_00_45}');
    Error('\P{Is_Nv= :=+00_00_00_45}');
    Expect(1, 12986, '\p{Is_Nv=000045}', "");
    Expect(0, 12986, '\p{^Is_Nv=000045}', "");
    Expect(0, 12986, '\P{Is_Nv=000045}', "");
    Expect(1, 12986, '\P{^Is_Nv=000045}', "");
    Expect(0, 12987, '\p{Is_Nv=000045}', "");
    Expect(1, 12987, '\p{^Is_Nv=000045}', "");
    Expect(1, 12987, '\P{Is_Nv=000045}', "");
    Expect(0, 12987, '\P{^Is_Nv=000045}', "");
    Expect(1, 12986, '\p{Is_Nv=4.500000000000000e+01}', "");
    Expect(0, 12986, '\p{^Is_Nv=4.500000000000000e+01}', "");
    Expect(0, 12986, '\P{Is_Nv=4.500000000000000e+01}', "");
    Expect(1, 12986, '\P{^Is_Nv=4.500000000000000e+01}', "");
    Expect(0, 12987, '\p{Is_Nv=4.500000000000000e+01}', "");
    Expect(1, 12987, '\p{^Is_Nv=4.500000000000000e+01}', "");
    Expect(1, 12987, '\P{Is_Nv=4.500000000000000e+01}', "");
    Expect(0, 12987, '\P{^Is_Nv=4.500000000000000e+01}', "");
    Error('\p{Numeric_Value= _00_00_46:=}');
    Error('\P{Numeric_Value= _00_00_46:=}');
    Expect(1, 12987, '\p{Numeric_Value=:\A46\z:}', "");;
    Expect(0, 12988, '\p{Numeric_Value=:\A46\z:}', "");;
    Expect(1, 12987, '\p{Numeric_Value=0_0_0_0_0_46}', "");
    Expect(0, 12987, '\p{^Numeric_Value=0_0_0_0_0_46}', "");
    Expect(0, 12987, '\P{Numeric_Value=0_0_0_0_0_46}', "");
    Expect(1, 12987, '\P{^Numeric_Value=0_0_0_0_0_46}', "");
    Expect(0, 12988, '\p{Numeric_Value=0_0_0_0_0_46}', "");
    Expect(1, 12988, '\p{^Numeric_Value=0_0_0_0_0_46}', "");
    Expect(1, 12988, '\P{Numeric_Value=0_0_0_0_0_46}', "");
    Expect(0, 12988, '\P{^Numeric_Value=0_0_0_0_0_46}', "");
    Expect(1, 12987, '\p{Numeric_Value=4.600000000000000e+01}', "");
    Expect(0, 12987, '\p{^Numeric_Value=4.600000000000000e+01}', "");
    Expect(0, 12987, '\P{Numeric_Value=4.600000000000000e+01}', "");
    Expect(1, 12987, '\P{^Numeric_Value=4.600000000000000e+01}', "");
    Expect(0, 12988, '\p{Numeric_Value=4.600000000000000e+01}', "");
    Expect(1, 12988, '\p{^Numeric_Value=4.600000000000000e+01}', "");
    Expect(1, 12988, '\P{Numeric_Value=4.600000000000000e+01}', "");
    Expect(0, 12988, '\P{^Numeric_Value=4.600000000000000e+01}', "");
    Error('\p{Nv=	 0_0_0_0_0_0_046/a/}');
    Error('\P{Nv=	 0_0_0_0_0_0_046/a/}');
    Expect(1, 12987, '\p{Nv=:\A46\z:}', "");;
    Expect(0, 12988, '\p{Nv=:\A46\z:}', "");;
    Expect(1, 12987, '\p{Nv=0_0_0_46}', "");
    Expect(0, 12987, '\p{^Nv=0_0_0_46}', "");
    Expect(0, 12987, '\P{Nv=0_0_0_46}', "");
    Expect(1, 12987, '\P{^Nv=0_0_0_46}', "");
    Expect(0, 12988, '\p{Nv=0_0_0_46}', "");
    Expect(1, 12988, '\p{^Nv=0_0_0_46}', "");
    Expect(1, 12988, '\P{Nv=0_0_0_46}', "");
    Expect(0, 12988, '\P{^Nv=0_0_0_46}', "");
    Expect(1, 12987, '\p{Nv=4.600000000000000e+01}', "");
    Expect(0, 12987, '\p{^Nv=4.600000000000000e+01}', "");
    Expect(0, 12987, '\P{Nv=4.600000000000000e+01}', "");
    Expect(1, 12987, '\P{^Nv=4.600000000000000e+01}', "");
    Expect(0, 12988, '\p{Nv=4.600000000000000e+01}', "");
    Expect(1, 12988, '\p{^Nv=4.600000000000000e+01}', "");
    Expect(1, 12988, '\P{Nv=4.600000000000000e+01}', "");
    Expect(0, 12988, '\P{^Nv=4.600000000000000e+01}', "");
    Error('\p{Is_Numeric_Value=:=-_00_00_00_00_04_6}');
    Error('\P{Is_Numeric_Value=:=-_00_00_00_00_04_6}');
    Expect(1, 12987, '\p{Is_Numeric_Value=+0_0_0_0_0_00046}', "");
    Expect(0, 12987, '\p{^Is_Numeric_Value=+0_0_0_0_0_00046}', "");
    Expect(0, 12987, '\P{Is_Numeric_Value=+0_0_0_0_0_00046}', "");
    Expect(1, 12987, '\P{^Is_Numeric_Value=+0_0_0_0_0_00046}', "");
    Expect(0, 12988, '\p{Is_Numeric_Value=+0_0_0_0_0_00046}', "");
    Expect(1, 12988, '\p{^Is_Numeric_Value=+0_0_0_0_0_00046}', "");
    Expect(1, 12988, '\P{Is_Numeric_Value=+0_0_0_0_0_00046}', "");
    Expect(0, 12988, '\P{^Is_Numeric_Value=+0_0_0_0_0_00046}', "");
    Expect(1, 12987, '\p{Is_Numeric_Value=4.600000000000000e+01}', "");
    Expect(0, 12987, '\p{^Is_Numeric_Value=4.600000000000000e+01}', "");
    Expect(0, 12987, '\P{Is_Numeric_Value=4.600000000000000e+01}', "");
    Expect(1, 12987, '\P{^Is_Numeric_Value=4.600000000000000e+01}', "");
    Expect(0, 12988, '\p{Is_Numeric_Value=4.600000000000000e+01}', "");
    Expect(1, 12988, '\p{^Is_Numeric_Value=4.600000000000000e+01}', "");
    Expect(1, 12988, '\P{Is_Numeric_Value=4.600000000000000e+01}', "");
    Expect(0, 12988, '\P{^Is_Numeric_Value=4.600000000000000e+01}', "");
    Error('\p{Is_Nv=	-+0000_0000_46/a/}');
    Error('\P{Is_Nv=	-+0000_0000_46/a/}');
    Expect(1, 12987, '\p{Is_Nv:   0_0_0_0_0_0_0_0_0_46}', "");
    Expect(0, 12987, '\p{^Is_Nv:   0_0_0_0_0_0_0_0_0_46}', "");
    Expect(0, 12987, '\P{Is_Nv:   0_0_0_0_0_0_0_0_0_46}', "");
    Expect(1, 12987, '\P{^Is_Nv:   0_0_0_0_0_0_0_0_0_46}', "");
    Expect(0, 12988, '\p{Is_Nv:   0_0_0_0_0_0_0_0_0_46}', "");
    Expect(1, 12988, '\p{^Is_Nv:   0_0_0_0_0_0_0_0_0_46}', "");
    Expect(1, 12988, '\P{Is_Nv:   0_0_0_0_0_0_0_0_0_46}', "");
    Expect(0, 12988, '\P{^Is_Nv:   0_0_0_0_0_0_0_0_0_46}', "");
    Expect(1, 12987, '\p{Is_Nv: 4.600000000000000e+01}', "");
    Expect(0, 12987, '\p{^Is_Nv: 4.600000000000000e+01}', "");
    Expect(0, 12987, '\P{Is_Nv: 4.600000000000000e+01}', "");
    Expect(1, 12987, '\P{^Is_Nv: 4.600000000000000e+01}', "");
    Expect(0, 12988, '\p{Is_Nv: 4.600000000000000e+01}', "");
    Expect(1, 12988, '\p{^Is_Nv: 4.600000000000000e+01}', "");
    Expect(1, 12988, '\P{Is_Nv: 4.600000000000000e+01}', "");
    Expect(0, 12988, '\P{^Is_Nv: 4.600000000000000e+01}', "");
    Error('\p{Numeric_Value= 00000047/a/}');
    Error('\P{Numeric_Value= 00000047/a/}');
    Expect(1, 12988, '\p{Numeric_Value=:\A47\z:}', "");;
    Expect(0, 12989, '\p{Numeric_Value=:\A47\z:}', "");;
    Expect(1, 12988, '\p{Numeric_Value=0_0_0_0_0_0_0_0_47}', "");
    Expect(0, 12988, '\p{^Numeric_Value=0_0_0_0_0_0_0_0_47}', "");
    Expect(0, 12988, '\P{Numeric_Value=0_0_0_0_0_0_0_0_47}', "");
    Expect(1, 12988, '\P{^Numeric_Value=0_0_0_0_0_0_0_0_47}', "");
    Expect(0, 12989, '\p{Numeric_Value=0_0_0_0_0_0_0_0_47}', "");
    Expect(1, 12989, '\p{^Numeric_Value=0_0_0_0_0_0_0_0_47}', "");
    Expect(1, 12989, '\P{Numeric_Value=0_0_0_0_0_0_0_0_47}', "");
    Expect(0, 12989, '\P{^Numeric_Value=0_0_0_0_0_0_0_0_47}', "");
    Expect(1, 12988, '\p{Numeric_Value=4.700000000000000e+01}', "");
    Expect(0, 12988, '\p{^Numeric_Value=4.700000000000000e+01}', "");
    Expect(0, 12988, '\P{Numeric_Value=4.700000000000000e+01}', "");
    Expect(1, 12988, '\P{^Numeric_Value=4.700000000000000e+01}', "");
    Expect(0, 12989, '\p{Numeric_Value=4.700000000000000e+01}', "");
    Expect(1, 12989, '\p{^Numeric_Value=4.700000000000000e+01}', "");
    Expect(1, 12989, '\P{Numeric_Value=4.700000000000000e+01}', "");
    Expect(0, 12989, '\P{^Numeric_Value=4.700000000000000e+01}', "");
    Error('\p{Nv=/a/  +04_7}');
    Error('\P{Nv=/a/  +04_7}');
    Expect(1, 12988, '\p{Nv=:\A47\z:}', "");;
    Expect(0, 12989, '\p{Nv=:\A47\z:}', "");;
    Expect(1, 12988, '\p{Nv=000000047}', "");
    Expect(0, 12988, '\p{^Nv=000000047}', "");
    Expect(0, 12988, '\P{Nv=000000047}', "");
    Expect(1, 12988, '\P{^Nv=000000047}', "");
    Expect(0, 12989, '\p{Nv=000000047}', "");
    Expect(1, 12989, '\p{^Nv=000000047}', "");
    Expect(1, 12989, '\P{Nv=000000047}', "");
    Expect(0, 12989, '\P{^Nv=000000047}', "");
    Expect(1, 12988, '\p{Nv=4.700000000000000e+01}', "");
    Expect(0, 12988, '\p{^Nv=4.700000000000000e+01}', "");
    Expect(0, 12988, '\P{Nv=4.700000000000000e+01}', "");
    Expect(1, 12988, '\P{^Nv=4.700000000000000e+01}', "");
    Expect(0, 12989, '\p{Nv=4.700000000000000e+01}', "");
    Expect(1, 12989, '\p{^Nv=4.700000000000000e+01}', "");
    Expect(1, 12989, '\P{Nv=4.700000000000000e+01}', "");
    Expect(0, 12989, '\P{^Nv=4.700000000000000e+01}', "");
    Error('\p{Is_Numeric_Value=_ 000000047/a/}');
    Error('\P{Is_Numeric_Value=_ 000000047/a/}');
    Expect(1, 12988, '\p{Is_Numeric_Value=000004_7}', "");
    Expect(0, 12988, '\p{^Is_Numeric_Value=000004_7}', "");
    Expect(0, 12988, '\P{Is_Numeric_Value=000004_7}', "");
    Expect(1, 12988, '\P{^Is_Numeric_Value=000004_7}', "");
    Expect(0, 12989, '\p{Is_Numeric_Value=000004_7}', "");
    Expect(1, 12989, '\p{^Is_Numeric_Value=000004_7}', "");
    Expect(1, 12989, '\P{Is_Numeric_Value=000004_7}', "");
    Expect(0, 12989, '\P{^Is_Numeric_Value=000004_7}', "");
    Expect(1, 12988, '\p{Is_Numeric_Value=4.700000000000000e+01}', "");
    Expect(0, 12988, '\p{^Is_Numeric_Value=4.700000000000000e+01}', "");
    Expect(0, 12988, '\P{Is_Numeric_Value=4.700000000000000e+01}', "");
    Expect(1, 12988, '\P{^Is_Numeric_Value=4.700000000000000e+01}', "");
    Expect(0, 12989, '\p{Is_Numeric_Value=4.700000000000000e+01}', "");
    Expect(1, 12989, '\p{^Is_Numeric_Value=4.700000000000000e+01}', "");
    Expect(1, 12989, '\P{Is_Numeric_Value=4.700000000000000e+01}', "");
    Expect(0, 12989, '\P{^Is_Numeric_Value=4.700000000000000e+01}', "");
    Error('\p{Is_Nv:   	:=47}');
    Error('\P{Is_Nv:   	:=47}');
    Expect(1, 12988, '\p{Is_Nv=000047}', "");
    Expect(0, 12988, '\p{^Is_Nv=000047}', "");
    Expect(0, 12988, '\P{Is_Nv=000047}', "");
    Expect(1, 12988, '\P{^Is_Nv=000047}', "");
    Expect(0, 12989, '\p{Is_Nv=000047}', "");
    Expect(1, 12989, '\p{^Is_Nv=000047}', "");
    Expect(1, 12989, '\P{Is_Nv=000047}', "");
    Expect(0, 12989, '\P{^Is_Nv=000047}', "");
    Expect(1, 12988, '\p{Is_Nv:   4.700000000000000e+01}', "");
    Expect(0, 12988, '\p{^Is_Nv:   4.700000000000000e+01}', "");
    Expect(0, 12988, '\P{Is_Nv:   4.700000000000000e+01}', "");
    Expect(1, 12988, '\P{^Is_Nv:   4.700000000000000e+01}', "");
    Expect(0, 12989, '\p{Is_Nv:   4.700000000000000e+01}', "");
    Expect(1, 12989, '\p{^Is_Nv:   4.700000000000000e+01}', "");
    Expect(1, 12989, '\P{Is_Nv:   4.700000000000000e+01}', "");
    Expect(0, 12989, '\P{^Is_Nv:   4.700000000000000e+01}', "");
    Error('\p{Numeric_Value: /a/ _48}');
    Error('\P{Numeric_Value: /a/ _48}');
    Expect(1, 12989, '\p{Numeric_Value=:\A48\z:}', "");;
    Expect(0, 12990, '\p{Numeric_Value=:\A48\z:}', "");;
    Expect(1, 12989, '\p{Numeric_Value=004_8}', "");
    Expect(0, 12989, '\p{^Numeric_Value=004_8}', "");
    Expect(0, 12989, '\P{Numeric_Value=004_8}', "");
    Expect(1, 12989, '\P{^Numeric_Value=004_8}', "");
    Expect(0, 12990, '\p{Numeric_Value=004_8}', "");
    Expect(1, 12990, '\p{^Numeric_Value=004_8}', "");
    Expect(1, 12990, '\P{Numeric_Value=004_8}', "");
    Expect(0, 12990, '\P{^Numeric_Value=004_8}', "");
    Expect(1, 12989, '\p{Numeric_Value=4.800000000000000e+01}', "");
    Expect(0, 12989, '\p{^Numeric_Value=4.800000000000000e+01}', "");
    Expect(0, 12989, '\P{Numeric_Value=4.800000000000000e+01}', "");
    Expect(1, 12989, '\P{^Numeric_Value=4.800000000000000e+01}', "");
    Expect(0, 12990, '\p{Numeric_Value=4.800000000000000e+01}', "");
    Expect(1, 12990, '\p{^Numeric_Value=4.800000000000000e+01}', "");
    Expect(1, 12990, '\P{Numeric_Value=4.800000000000000e+01}', "");
    Expect(0, 12990, '\P{^Numeric_Value=4.800000000000000e+01}', "");
    Error('\p{Nv=	:=00000048}');
    Error('\P{Nv=	:=00000048}');
    Expect(1, 12989, '\p{Nv=:\A48\z:}', "");;
    Expect(0, 12990, '\p{Nv=:\A48\z:}', "");;
    Expect(1, 12989, '\p{Nv=+00048}', "");
    Expect(0, 12989, '\p{^Nv=+00048}', "");
    Expect(0, 12989, '\P{Nv=+00048}', "");
    Expect(1, 12989, '\P{^Nv=+00048}', "");
    Expect(0, 12990, '\p{Nv=+00048}', "");
    Expect(1, 12990, '\p{^Nv=+00048}', "");
    Expect(1, 12990, '\P{Nv=+00048}', "");
    Expect(0, 12990, '\P{^Nv=+00048}', "");
    Expect(1, 12989, '\p{Nv:   4.800000000000000e+01}', "");
    Expect(0, 12989, '\p{^Nv:   4.800000000000000e+01}', "");
    Expect(0, 12989, '\P{Nv:   4.800000000000000e+01}', "");
    Expect(1, 12989, '\P{^Nv:   4.800000000000000e+01}', "");
    Expect(0, 12990, '\p{Nv:   4.800000000000000e+01}', "");
    Expect(1, 12990, '\p{^Nv:   4.800000000000000e+01}', "");
    Expect(1, 12990, '\P{Nv:   4.800000000000000e+01}', "");
    Expect(0, 12990, '\P{^Nv:   4.800000000000000e+01}', "");
    Error('\p{Is_Numeric_Value=	:=0048}');
    Error('\P{Is_Numeric_Value=	:=0048}');
    Expect(1, 12989, '\p{Is_Numeric_Value=+0_0_0_0_0048}', "");
    Expect(0, 12989, '\p{^Is_Numeric_Value=+0_0_0_0_0048}', "");
    Expect(0, 12989, '\P{Is_Numeric_Value=+0_0_0_0_0048}', "");
    Expect(1, 12989, '\P{^Is_Numeric_Value=+0_0_0_0_0048}', "");
    Expect(0, 12990, '\p{Is_Numeric_Value=+0_0_0_0_0048}', "");
    Expect(1, 12990, '\p{^Is_Numeric_Value=+0_0_0_0_0048}', "");
    Expect(1, 12990, '\P{Is_Numeric_Value=+0_0_0_0_0048}', "");
    Expect(0, 12990, '\P{^Is_Numeric_Value=+0_0_0_0_0048}', "");
    Expect(1, 12989, '\p{Is_Numeric_Value=4.800000000000000e+01}', "");
    Expect(0, 12989, '\p{^Is_Numeric_Value=4.800000000000000e+01}', "");
    Expect(0, 12989, '\P{Is_Numeric_Value=4.800000000000000e+01}', "");
    Expect(1, 12989, '\P{^Is_Numeric_Value=4.800000000000000e+01}', "");
    Expect(0, 12990, '\p{Is_Numeric_Value=4.800000000000000e+01}', "");
    Expect(1, 12990, '\p{^Is_Numeric_Value=4.800000000000000e+01}', "");
    Expect(1, 12990, '\P{Is_Numeric_Value=4.800000000000000e+01}', "");
    Expect(0, 12990, '\P{^Is_Numeric_Value=4.800000000000000e+01}', "");
    Error('\p{Is_Nv=:=_-00000048}');
    Error('\P{Is_Nv=:=_-00000048}');
    Expect(1, 12989, '\p{Is_Nv:   +00048}', "");
    Expect(0, 12989, '\p{^Is_Nv:   +00048}', "");
    Expect(0, 12989, '\P{Is_Nv:   +00048}', "");
    Expect(1, 12989, '\P{^Is_Nv:   +00048}', "");
    Expect(0, 12990, '\p{Is_Nv:   +00048}', "");
    Expect(1, 12990, '\p{^Is_Nv:   +00048}', "");
    Expect(1, 12990, '\P{Is_Nv:   +00048}', "");
    Expect(0, 12990, '\P{^Is_Nv:   +00048}', "");
    Expect(1, 12989, '\p{Is_Nv=4.800000000000000e+01}', "");
    Expect(0, 12989, '\p{^Is_Nv=4.800000000000000e+01}', "");
    Expect(0, 12989, '\P{Is_Nv=4.800000000000000e+01}', "");
    Expect(1, 12989, '\P{^Is_Nv=4.800000000000000e+01}', "");
    Expect(0, 12990, '\p{Is_Nv=4.800000000000000e+01}', "");
    Expect(1, 12990, '\p{^Is_Nv=4.800000000000000e+01}', "");
    Expect(1, 12990, '\P{Is_Nv=4.800000000000000e+01}', "");
    Expect(0, 12990, '\P{^Is_Nv=4.800000000000000e+01}', "");
    Error('\p{Numeric_Value=_+00000_00004_9/a/}');
    Error('\P{Numeric_Value=_+00000_00004_9/a/}');
    Expect(1, 12990, '\p{Numeric_Value=:\A49\z:}', "");;
    Expect(0, 12991, '\p{Numeric_Value=:\A49\z:}', "");;
    Expect(1, 12990, '\p{Numeric_Value=00000000049}', "");
    Expect(0, 12990, '\p{^Numeric_Value=00000000049}', "");
    Expect(0, 12990, '\P{Numeric_Value=00000000049}', "");
    Expect(1, 12990, '\P{^Numeric_Value=00000000049}', "");
    Expect(0, 12991, '\p{Numeric_Value=00000000049}', "");
    Expect(1, 12991, '\p{^Numeric_Value=00000000049}', "");
    Expect(1, 12991, '\P{Numeric_Value=00000000049}', "");
    Expect(0, 12991, '\P{^Numeric_Value=00000000049}', "");
    Expect(1, 12990, '\p{Numeric_Value=4.900000000000000e+01}', "");
    Expect(0, 12990, '\p{^Numeric_Value=4.900000000000000e+01}', "");
    Expect(0, 12990, '\P{Numeric_Value=4.900000000000000e+01}', "");
    Expect(1, 12990, '\P{^Numeric_Value=4.900000000000000e+01}', "");
    Expect(0, 12991, '\p{Numeric_Value=4.900000000000000e+01}', "");
    Expect(1, 12991, '\p{^Numeric_Value=4.900000000000000e+01}', "");
    Expect(1, 12991, '\P{Numeric_Value=4.900000000000000e+01}', "");
    Expect(0, 12991, '\P{^Numeric_Value=4.900000000000000e+01}', "");
    Error('\p{Nv=/a/	-049}');
    Error('\P{Nv=/a/	-049}');
    Expect(1, 12990, '\p{Nv=:\A49\z:}', "");;
    Expect(0, 12991, '\p{Nv=:\A49\z:}', "");;
    Expect(1, 12990, '\p{Nv=0049}', "");
    Expect(0, 12990, '\p{^Nv=0049}', "");
    Expect(0, 12990, '\P{Nv=0049}', "");
    Expect(1, 12990, '\P{^Nv=0049}', "");
    Expect(0, 12991, '\p{Nv=0049}', "");
    Expect(1, 12991, '\p{^Nv=0049}', "");
    Expect(1, 12991, '\P{Nv=0049}', "");
    Expect(0, 12991, '\P{^Nv=0049}', "");
    Expect(1, 12990, '\p{Nv=4.900000000000000e+01}', "");
    Expect(0, 12990, '\p{^Nv=4.900000000000000e+01}', "");
    Expect(0, 12990, '\P{Nv=4.900000000000000e+01}', "");
    Expect(1, 12990, '\P{^Nv=4.900000000000000e+01}', "");
    Expect(0, 12991, '\p{Nv=4.900000000000000e+01}', "");
    Expect(1, 12991, '\p{^Nv=4.900000000000000e+01}', "");
    Expect(1, 12991, '\P{Nv=4.900000000000000e+01}', "");
    Expect(0, 12991, '\P{^Nv=4.900000000000000e+01}', "");
    Error('\p{Is_Numeric_Value=-000000049/a/}');
    Error('\P{Is_Numeric_Value=-000000049/a/}');
    Expect(1, 12990, '\p{Is_Numeric_Value=+4_9}', "");
    Expect(0, 12990, '\p{^Is_Numeric_Value=+4_9}', "");
    Expect(0, 12990, '\P{Is_Numeric_Value=+4_9}', "");
    Expect(1, 12990, '\P{^Is_Numeric_Value=+4_9}', "");
    Expect(0, 12991, '\p{Is_Numeric_Value=+4_9}', "");
    Expect(1, 12991, '\p{^Is_Numeric_Value=+4_9}', "");
    Expect(1, 12991, '\P{Is_Numeric_Value=+4_9}', "");
    Expect(0, 12991, '\P{^Is_Numeric_Value=+4_9}', "");
    Expect(1, 12990, '\p{Is_Numeric_Value=4.900000000000000e+01}', "");
    Expect(0, 12990, '\p{^Is_Numeric_Value=4.900000000000000e+01}', "");
    Expect(0, 12990, '\P{Is_Numeric_Value=4.900000000000000e+01}', "");
    Expect(1, 12990, '\P{^Is_Numeric_Value=4.900000000000000e+01}', "");
    Expect(0, 12991, '\p{Is_Numeric_Value=4.900000000000000e+01}', "");
    Expect(1, 12991, '\p{^Is_Numeric_Value=4.900000000000000e+01}', "");
    Expect(1, 12991, '\P{Is_Numeric_Value=4.900000000000000e+01}', "");
    Expect(0, 12991, '\P{^Is_Numeric_Value=4.900000000000000e+01}', "");
    Error('\p{Is_Nv=_:=0049}');
    Error('\P{Is_Nv=_:=0049}');
    Expect(1, 12990, '\p{Is_Nv=0000049}', "");
    Expect(0, 12990, '\p{^Is_Nv=0000049}', "");
    Expect(0, 12990, '\P{Is_Nv=0000049}', "");
    Expect(1, 12990, '\P{^Is_Nv=0000049}', "");
    Expect(0, 12991, '\p{Is_Nv=0000049}', "");
    Expect(1, 12991, '\p{^Is_Nv=0000049}', "");
    Expect(1, 12991, '\P{Is_Nv=0000049}', "");
    Expect(0, 12991, '\P{^Is_Nv=0000049}', "");
    Expect(1, 12990, '\p{Is_Nv=4.900000000000000e+01}', "");
    Expect(0, 12990, '\p{^Is_Nv=4.900000000000000e+01}', "");
    Expect(0, 12990, '\P{Is_Nv=4.900000000000000e+01}', "");
    Expect(1, 12990, '\P{^Is_Nv=4.900000000000000e+01}', "");
    Expect(0, 12991, '\p{Is_Nv=4.900000000000000e+01}', "");
    Expect(1, 12991, '\p{^Is_Nv=4.900000000000000e+01}', "");
    Expect(1, 12991, '\P{Is_Nv=4.900000000000000e+01}', "");
    Expect(0, 12991, '\P{^Is_Nv=4.900000000000000e+01}', "");
    Error('\p{Numeric_Value:   _:=0_0_0_0_0_0_0_0_05}');
    Error('\P{Numeric_Value:   _:=0_0_0_0_0_0_0_0_05}');
    Expect(1, 131361, '\p{Numeric_Value=:\A5\z:}', "");;
    Expect(0, 131362, '\p{Numeric_Value=:\A5\z:}', "");;
    Expect(1, 131361, '\p{Numeric_Value=0_5}', "");
    Expect(0, 131361, '\p{^Numeric_Value=0_5}', "");
    Expect(0, 131361, '\P{Numeric_Value=0_5}', "");
    Expect(1, 131361, '\P{^Numeric_Value=0_5}', "");
    Expect(0, 131362, '\p{Numeric_Value=0_5}', "");
    Expect(1, 131362, '\p{^Numeric_Value=0_5}', "");
    Expect(1, 131362, '\P{Numeric_Value=0_5}', "");
    Expect(0, 131362, '\P{^Numeric_Value=0_5}', "");
    Expect(1, 131361, '\p{Numeric_Value=5.000000000000000e+00}', "");
    Expect(0, 131361, '\p{^Numeric_Value=5.000000000000000e+00}', "");
    Expect(0, 131361, '\P{Numeric_Value=5.000000000000000e+00}', "");
    Expect(1, 131361, '\P{^Numeric_Value=5.000000000000000e+00}', "");
    Expect(0, 131362, '\p{Numeric_Value=5.000000000000000e+00}', "");
    Expect(1, 131362, '\p{^Numeric_Value=5.000000000000000e+00}', "");
    Expect(1, 131362, '\P{Numeric_Value=5.000000000000000e+00}', "");
    Expect(0, 131362, '\P{^Numeric_Value=5.000000000000000e+00}', "");
    Error('\p{Nv: 	:=00_00_5}');
    Error('\P{Nv: 	:=00_00_5}');
    Expect(1, 131361, '\p{Nv=:\A5\z:}', "");;
    Expect(0, 131362, '\p{Nv=:\A5\z:}', "");;
    Expect(1, 131361, '\p{Nv=005}', "");
    Expect(0, 131361, '\p{^Nv=005}', "");
    Expect(0, 131361, '\P{Nv=005}', "");
    Expect(1, 131361, '\P{^Nv=005}', "");
    Expect(0, 131362, '\p{Nv=005}', "");
    Expect(1, 131362, '\p{^Nv=005}', "");
    Expect(1, 131362, '\P{Nv=005}', "");
    Expect(0, 131362, '\P{^Nv=005}', "");
    Expect(1, 131361, '\p{Nv=5.000000000000000e+00}', "");
    Expect(0, 131361, '\p{^Nv=5.000000000000000e+00}', "");
    Expect(0, 131361, '\P{Nv=5.000000000000000e+00}', "");
    Expect(1, 131361, '\P{^Nv=5.000000000000000e+00}', "");
    Expect(0, 131362, '\p{Nv=5.000000000000000e+00}', "");
    Expect(1, 131362, '\p{^Nv=5.000000000000000e+00}', "");
    Expect(1, 131362, '\P{Nv=5.000000000000000e+00}', "");
    Expect(0, 131362, '\P{^Nv=5.000000000000000e+00}', "");
    Error('\p{Is_Numeric_Value:   -_000005/a/}');
    Error('\P{Is_Numeric_Value:   -_000005/a/}');
    Expect(1, 131361, '\p{Is_Numeric_Value:   +0000000005}', "");
    Expect(0, 131361, '\p{^Is_Numeric_Value:   +0000000005}', "");
    Expect(0, 131361, '\P{Is_Numeric_Value:   +0000000005}', "");
    Expect(1, 131361, '\P{^Is_Numeric_Value:   +0000000005}', "");
    Expect(0, 131362, '\p{Is_Numeric_Value:   +0000000005}', "");
    Expect(1, 131362, '\p{^Is_Numeric_Value:   +0000000005}', "");
    Expect(1, 131362, '\P{Is_Numeric_Value:   +0000000005}', "");
    Expect(0, 131362, '\P{^Is_Numeric_Value:   +0000000005}', "");
    Expect(1, 131361, '\p{Is_Numeric_Value=5.000000000000000e+00}', "");
    Expect(0, 131361, '\p{^Is_Numeric_Value=5.000000000000000e+00}', "");
    Expect(0, 131361, '\P{Is_Numeric_Value=5.000000000000000e+00}', "");
    Expect(1, 131361, '\P{^Is_Numeric_Value=5.000000000000000e+00}', "");
    Expect(0, 131362, '\p{Is_Numeric_Value=5.000000000000000e+00}', "");
    Expect(1, 131362, '\p{^Is_Numeric_Value=5.000000000000000e+00}', "");
    Expect(1, 131362, '\P{Is_Numeric_Value=5.000000000000000e+00}', "");
    Expect(0, 131362, '\P{^Is_Numeric_Value=5.000000000000000e+00}', "");
    Error('\p{Is_Nv=/a/  00_00_5}');
    Error('\P{Is_Nv=/a/  00_00_5}');
    Expect(1, 131361, '\p{Is_Nv=000000005}', "");
    Expect(0, 131361, '\p{^Is_Nv=000000005}', "");
    Expect(0, 131361, '\P{Is_Nv=000000005}', "");
    Expect(1, 131361, '\P{^Is_Nv=000000005}', "");
    Expect(0, 131362, '\p{Is_Nv=000000005}', "");
    Expect(1, 131362, '\p{^Is_Nv=000000005}', "");
    Expect(1, 131362, '\P{Is_Nv=000000005}', "");
    Expect(0, 131362, '\P{^Is_Nv=000000005}', "");
    Expect(1, 131361, '\p{Is_Nv=5.000000000000000e+00}', "");
    Expect(0, 131361, '\p{^Is_Nv=5.000000000000000e+00}', "");
    Expect(0, 131361, '\P{Is_Nv=5.000000000000000e+00}', "");
    Expect(1, 131361, '\P{^Is_Nv=5.000000000000000e+00}', "");
    Expect(0, 131362, '\p{Is_Nv=5.000000000000000e+00}', "");
    Expect(1, 131362, '\p{^Is_Nv=5.000000000000000e+00}', "");
    Expect(1, 131362, '\P{Is_Nv=5.000000000000000e+00}', "");
    Expect(0, 131362, '\P{^Is_Nv=5.000000000000000e+00}', "");
    Error('\p{Numeric_Value: /a/_-0005/000000012}');
    Error('\P{Numeric_Value: /a/_-0005/000000012}');
    Expect(1, 68090, '\p{Numeric_Value=:\A5/12\z:}', "");;
    Expect(0, 68091, '\p{Numeric_Value=:\A5/12\z:}', "");;
    Expect(1, 68090, '\p{Numeric_Value=0005/0012}', "");
    Expect(0, 68090, '\p{^Numeric_Value=0005/0012}', "");
    Expect(0, 68090, '\P{Numeric_Value=0005/0012}', "");
    Expect(1, 68090, '\P{^Numeric_Value=0005/0012}', "");
    Expect(0, 68091, '\p{Numeric_Value=0005/0012}', "");
    Expect(1, 68091, '\p{^Numeric_Value=0005/0012}', "");
    Expect(1, 68091, '\P{Numeric_Value=0005/0012}', "");
    Expect(0, 68091, '\P{^Numeric_Value=0005/0012}', "");
    Expect(1, 68090, '\p{Numeric_Value=300/720}', "");
    Expect(0, 68090, '\p{^Numeric_Value=300/720}', "");
    Expect(0, 68090, '\P{Numeric_Value=300/720}', "");
    Expect(1, 68090, '\P{^Numeric_Value=300/720}', "");
    Expect(0, 68091, '\p{Numeric_Value=300/720}', "");
    Expect(1, 68091, '\p{^Numeric_Value=300/720}', "");
    Expect(1, 68091, '\P{Numeric_Value=300/720}', "");
    Expect(0, 68091, '\P{^Numeric_Value=300/720}', "");
    Error('\p{Numeric_Value=4.2e-01}');
    Error('\P{Numeric_Value=4.2e-01}');
    Expect(1, 68090, '\p{Numeric_Value=4.17e-01}', "");
    Expect(0, 68090, '\p{^Numeric_Value=4.17e-01}', "");
    Expect(0, 68090, '\P{Numeric_Value=4.17e-01}', "");
    Expect(1, 68090, '\P{^Numeric_Value=4.17e-01}', "");
    Expect(0, 68091, '\p{Numeric_Value=4.17e-01}', "");
    Expect(1, 68091, '\p{^Numeric_Value=4.17e-01}', "");
    Expect(1, 68091, '\P{Numeric_Value=4.17e-01}', "");
    Expect(0, 68091, '\P{^Numeric_Value=4.17e-01}', "");
    Error('\p{Numeric_Value=0.42}');
    Error('\P{Numeric_Value=0.42}');
    Expect(1, 68090, '\p{Numeric_Value=4.167e-01}', "");
    Expect(0, 68090, '\p{^Numeric_Value=4.167e-01}', "");
    Expect(0, 68090, '\P{Numeric_Value=4.167e-01}', "");
    Expect(1, 68090, '\P{^Numeric_Value=4.167e-01}', "");
    Expect(0, 68091, '\p{Numeric_Value=4.167e-01}', "");
    Expect(1, 68091, '\p{^Numeric_Value=4.167e-01}', "");
    Expect(1, 68091, '\P{Numeric_Value=4.167e-01}', "");
    Expect(0, 68091, '\P{^Numeric_Value=4.167e-01}', "");
    Expect(1, 68090, '\p{Numeric_Value=0.417}', "");
    Expect(0, 68090, '\p{^Numeric_Value=0.417}', "");
    Expect(0, 68090, '\P{Numeric_Value=0.417}', "");
    Expect(1, 68090, '\P{^Numeric_Value=0.417}', "");
    Expect(0, 68091, '\p{Numeric_Value=0.417}', "");
    Expect(1, 68091, '\p{^Numeric_Value=0.417}', "");
    Expect(1, 68091, '\P{Numeric_Value=0.417}', "");
    Expect(0, 68091, '\P{^Numeric_Value=0.417}', "");
    Expect(1, 68090, '\p{Numeric_Value=4.1667e-01}', "");
    Expect(0, 68090, '\p{^Numeric_Value=4.1667e-01}', "");
    Expect(0, 68090, '\P{Numeric_Value=4.1667e-01}', "");
    Expect(1, 68090, '\P{^Numeric_Value=4.1667e-01}', "");
    Expect(0, 68091, '\p{Numeric_Value=4.1667e-01}', "");
    Expect(1, 68091, '\p{^Numeric_Value=4.1667e-01}', "");
    Expect(1, 68091, '\P{Numeric_Value=4.1667e-01}', "");
    Expect(0, 68091, '\P{^Numeric_Value=4.1667e-01}', "");
    Expect(1, 68090, '\p{Numeric_Value=0.4167}', "");
    Expect(0, 68090, '\p{^Numeric_Value=0.4167}', "");
    Expect(0, 68090, '\P{Numeric_Value=0.4167}', "");
    Expect(1, 68090, '\P{^Numeric_Value=0.4167}', "");
    Expect(0, 68091, '\p{Numeric_Value=0.4167}', "");
    Expect(1, 68091, '\p{^Numeric_Value=0.4167}', "");
    Expect(1, 68091, '\P{Numeric_Value=0.4167}', "");
    Expect(0, 68091, '\P{^Numeric_Value=0.4167}', "");
    Error('\p{Nv=/a/ 	0000000005/00000012}');
    Error('\P{Nv=/a/ 	0000000005/00000012}');
    Expect(1, 68090, '\p{Nv=:\A5/12\z:}', "");;
    Expect(0, 68091, '\p{Nv=:\A5/12\z:}', "");;
    Expect(1, 68090, '\p{Nv=005/00000012}', "");
    Expect(0, 68090, '\p{^Nv=005/00000012}', "");
    Expect(0, 68090, '\P{Nv=005/00000012}', "");
    Expect(1, 68090, '\P{^Nv=005/00000012}', "");
    Expect(0, 68091, '\p{Nv=005/00000012}', "");
    Expect(1, 68091, '\p{^Nv=005/00000012}', "");
    Expect(1, 68091, '\P{Nv=005/00000012}', "");
    Expect(0, 68091, '\P{^Nv=005/00000012}', "");
    Expect(1, 68090, '\p{Nv=300/720}', "");
    Expect(0, 68090, '\p{^Nv=300/720}', "");
    Expect(0, 68090, '\P{Nv=300/720}', "");
    Expect(1, 68090, '\P{^Nv=300/720}', "");
    Expect(0, 68091, '\p{Nv=300/720}', "");
    Expect(1, 68091, '\p{^Nv=300/720}', "");
    Expect(1, 68091, '\P{Nv=300/720}', "");
    Expect(0, 68091, '\P{^Nv=300/720}', "");
    Error('\p{Nv=4.2e-01}');
    Error('\P{Nv=4.2e-01}');
    Expect(1, 68090, '\p{Nv:4.17e-01}', "");
    Expect(0, 68090, '\p{^Nv:4.17e-01}', "");
    Expect(0, 68090, '\P{Nv:4.17e-01}', "");
    Expect(1, 68090, '\P{^Nv:4.17e-01}', "");
    Expect(0, 68091, '\p{Nv:4.17e-01}', "");
    Expect(1, 68091, '\p{^Nv:4.17e-01}', "");
    Expect(1, 68091, '\P{Nv:4.17e-01}', "");
    Expect(0, 68091, '\P{^Nv:4.17e-01}', "");
    Error('\p{Nv=0.42}');
    Error('\P{Nv=0.42}');
    Expect(1, 68090, '\p{Nv=4.167e-01}', "");
    Expect(0, 68090, '\p{^Nv=4.167e-01}', "");
    Expect(0, 68090, '\P{Nv=4.167e-01}', "");
    Expect(1, 68090, '\P{^Nv=4.167e-01}', "");
    Expect(0, 68091, '\p{Nv=4.167e-01}', "");
    Expect(1, 68091, '\p{^Nv=4.167e-01}', "");
    Expect(1, 68091, '\P{Nv=4.167e-01}', "");
    Expect(0, 68091, '\P{^Nv=4.167e-01}', "");
    Expect(1, 68090, '\p{Nv=0.417}', "");
    Expect(0, 68090, '\p{^Nv=0.417}', "");
    Expect(0, 68090, '\P{Nv=0.417}', "");
    Expect(1, 68090, '\P{^Nv=0.417}', "");
    Expect(0, 68091, '\p{Nv=0.417}', "");
    Expect(1, 68091, '\p{^Nv=0.417}', "");
    Expect(1, 68091, '\P{Nv=0.417}', "");
    Expect(0, 68091, '\P{^Nv=0.417}', "");
    Expect(1, 68090, '\p{Nv=4.1667e-01}', "");
    Expect(0, 68090, '\p{^Nv=4.1667e-01}', "");
    Expect(0, 68090, '\P{Nv=4.1667e-01}', "");
    Expect(1, 68090, '\P{^Nv=4.1667e-01}', "");
    Expect(0, 68091, '\p{Nv=4.1667e-01}', "");
    Expect(1, 68091, '\p{^Nv=4.1667e-01}', "");
    Expect(1, 68091, '\P{Nv=4.1667e-01}', "");
    Expect(0, 68091, '\P{^Nv=4.1667e-01}', "");
    Expect(1, 68090, '\p{Nv=0.4167}', "");
    Expect(0, 68090, '\p{^Nv=0.4167}', "");
    Expect(0, 68090, '\P{Nv=0.4167}', "");
    Expect(1, 68090, '\P{^Nv=0.4167}', "");
    Expect(0, 68091, '\p{Nv=0.4167}', "");
    Expect(1, 68091, '\p{^Nv=0.4167}', "");
    Expect(1, 68091, '\P{Nv=0.4167}', "");
    Expect(0, 68091, '\P{^Nv=0.4167}', "");
    Error('\p{Is_Numeric_Value=/a/	-000000005/0012}');
    Error('\P{Is_Numeric_Value=/a/	-000000005/0012}');
    Expect(1, 68090, '\p{Is_Numeric_Value=00005/00012}', "");
    Expect(0, 68090, '\p{^Is_Numeric_Value=00005/00012}', "");
    Expect(0, 68090, '\P{Is_Numeric_Value=00005/00012}', "");
    Expect(1, 68090, '\P{^Is_Numeric_Value=00005/00012}', "");
    Expect(0, 68091, '\p{Is_Numeric_Value=00005/00012}', "");
    Expect(1, 68091, '\p{^Is_Numeric_Value=00005/00012}', "");
    Expect(1, 68091, '\P{Is_Numeric_Value=00005/00012}', "");
    Expect(0, 68091, '\P{^Is_Numeric_Value=00005/00012}', "");
    Expect(1, 68090, '\p{Is_Numeric_Value=300/720}', "");
    Expect(0, 68090, '\p{^Is_Numeric_Value=300/720}', "");
    Expect(0, 68090, '\P{Is_Numeric_Value=300/720}', "");
    Expect(1, 68090, '\P{^Is_Numeric_Value=300/720}', "");
    Expect(0, 68091, '\p{Is_Numeric_Value=300/720}', "");
    Expect(1, 68091, '\p{^Is_Numeric_Value=300/720}', "");
    Expect(1, 68091, '\P{Is_Numeric_Value=300/720}', "");
    Expect(0, 68091, '\P{^Is_Numeric_Value=300/720}', "");
    Error('\p{Is_Numeric_Value=4.2e-01}');
    Error('\P{Is_Numeric_Value=4.2e-01}');
    Expect(1, 68090, '\p{Is_Numeric_Value=4.17e-01}', "");
    Expect(0, 68090, '\p{^Is_Numeric_Value=4.17e-01}', "");
    Expect(0, 68090, '\P{Is_Numeric_Value=4.17e-01}', "");
    Expect(1, 68090, '\P{^Is_Numeric_Value=4.17e-01}', "");
    Expect(0, 68091, '\p{Is_Numeric_Value=4.17e-01}', "");
    Expect(1, 68091, '\p{^Is_Numeric_Value=4.17e-01}', "");
    Expect(1, 68091, '\P{Is_Numeric_Value=4.17e-01}', "");
    Expect(0, 68091, '\P{^Is_Numeric_Value=4.17e-01}', "");
    Error('\p{Is_Numeric_Value=0.42}');
    Error('\P{Is_Numeric_Value=0.42}');
    Expect(1, 68090, '\p{Is_Numeric_Value:   4.167e-01}', "");
    Expect(0, 68090, '\p{^Is_Numeric_Value:   4.167e-01}', "");
    Expect(0, 68090, '\P{Is_Numeric_Value:   4.167e-01}', "");
    Expect(1, 68090, '\P{^Is_Numeric_Value:   4.167e-01}', "");
    Expect(0, 68091, '\p{Is_Numeric_Value:   4.167e-01}', "");
    Expect(1, 68091, '\p{^Is_Numeric_Value:   4.167e-01}', "");
    Expect(1, 68091, '\P{Is_Numeric_Value:   4.167e-01}', "");
    Expect(0, 68091, '\P{^Is_Numeric_Value:   4.167e-01}', "");
    Expect(1, 68090, '\p{Is_Numeric_Value=0.417}', "");
    Expect(0, 68090, '\p{^Is_Numeric_Value=0.417}', "");
    Expect(0, 68090, '\P{Is_Numeric_Value=0.417}', "");
    Expect(1, 68090, '\P{^Is_Numeric_Value=0.417}', "");
    Expect(0, 68091, '\p{Is_Numeric_Value=0.417}', "");
    Expect(1, 68091, '\p{^Is_Numeric_Value=0.417}', "");
    Expect(1, 68091, '\P{Is_Numeric_Value=0.417}', "");
    Expect(0, 68091, '\P{^Is_Numeric_Value=0.417}', "");
    Expect(1, 68090, '\p{Is_Numeric_Value=4.1667e-01}', "");
    Expect(0, 68090, '\p{^Is_Numeric_Value=4.1667e-01}', "");
    Expect(0, 68090, '\P{Is_Numeric_Value=4.1667e-01}', "");
    Expect(1, 68090, '\P{^Is_Numeric_Value=4.1667e-01}', "");
    Expect(0, 68091, '\p{Is_Numeric_Value=4.1667e-01}', "");
    Expect(1, 68091, '\p{^Is_Numeric_Value=4.1667e-01}', "");
    Expect(1, 68091, '\P{Is_Numeric_Value=4.1667e-01}', "");
    Expect(0, 68091, '\P{^Is_Numeric_Value=4.1667e-01}', "");
    Expect(1, 68090, '\p{Is_Numeric_Value=0.4167}', "");
    Expect(0, 68090, '\p{^Is_Numeric_Value=0.4167}', "");
    Expect(0, 68090, '\P{Is_Numeric_Value=0.4167}', "");
    Expect(1, 68090, '\P{^Is_Numeric_Value=0.4167}', "");
    Expect(0, 68091, '\p{Is_Numeric_Value=0.4167}', "");
    Expect(1, 68091, '\p{^Is_Numeric_Value=0.4167}', "");
    Expect(1, 68091, '\P{Is_Numeric_Value=0.4167}', "");
    Expect(0, 68091, '\P{^Is_Numeric_Value=0.4167}', "");
    Error('\p{Is_Nv=	0000000005/0000012:=}');
    Error('\P{Is_Nv=	0000000005/0000012:=}');
    Expect(1, 68090, '\p{Is_Nv:   000005/0012}', "");
    Expect(0, 68090, '\p{^Is_Nv:   000005/0012}', "");
    Expect(0, 68090, '\P{Is_Nv:   000005/0012}', "");
    Expect(1, 68090, '\P{^Is_Nv:   000005/0012}', "");
    Expect(0, 68091, '\p{Is_Nv:   000005/0012}', "");
    Expect(1, 68091, '\p{^Is_Nv:   000005/0012}', "");
    Expect(1, 68091, '\P{Is_Nv:   000005/0012}', "");
    Expect(0, 68091, '\P{^Is_Nv:   000005/0012}', "");
    Expect(1, 68090, '\p{Is_Nv=300/720}', "");
    Expect(0, 68090, '\p{^Is_Nv=300/720}', "");
    Expect(0, 68090, '\P{Is_Nv=300/720}', "");
    Expect(1, 68090, '\P{^Is_Nv=300/720}', "");
    Expect(0, 68091, '\p{Is_Nv=300/720}', "");
    Expect(1, 68091, '\p{^Is_Nv=300/720}', "");
    Expect(1, 68091, '\P{Is_Nv=300/720}', "");
    Expect(0, 68091, '\P{^Is_Nv=300/720}', "");
    Error('\p{Is_Nv=4.2e-01}');
    Error('\P{Is_Nv=4.2e-01}');
    Expect(1, 68090, '\p{Is_Nv=4.17e-01}', "");
    Expect(0, 68090, '\p{^Is_Nv=4.17e-01}', "");
    Expect(0, 68090, '\P{Is_Nv=4.17e-01}', "");
    Expect(1, 68090, '\P{^Is_Nv=4.17e-01}', "");
    Expect(0, 68091, '\p{Is_Nv=4.17e-01}', "");
    Expect(1, 68091, '\p{^Is_Nv=4.17e-01}', "");
    Expect(1, 68091, '\P{Is_Nv=4.17e-01}', "");
    Expect(0, 68091, '\P{^Is_Nv=4.17e-01}', "");
    Error('\p{Is_Nv=0.42}');
    Error('\P{Is_Nv=0.42}');
    Expect(1, 68090, '\p{Is_Nv=4.167e-01}', "");
    Expect(0, 68090, '\p{^Is_Nv=4.167e-01}', "");
    Expect(0, 68090, '\P{Is_Nv=4.167e-01}', "");
    Expect(1, 68090, '\P{^Is_Nv=4.167e-01}', "");
    Expect(0, 68091, '\p{Is_Nv=4.167e-01}', "");
    Expect(1, 68091, '\p{^Is_Nv=4.167e-01}', "");
    Expect(1, 68091, '\P{Is_Nv=4.167e-01}', "");
    Expect(0, 68091, '\P{^Is_Nv=4.167e-01}', "");
    Expect(1, 68090, '\p{Is_Nv=0.417}', "");
    Expect(0, 68090, '\p{^Is_Nv=0.417}', "");
    Expect(0, 68090, '\P{Is_Nv=0.417}', "");
    Expect(1, 68090, '\P{^Is_Nv=0.417}', "");
    Expect(0, 68091, '\p{Is_Nv=0.417}', "");
    Expect(1, 68091, '\p{^Is_Nv=0.417}', "");
    Expect(1, 68091, '\P{Is_Nv=0.417}', "");
    Expect(0, 68091, '\P{^Is_Nv=0.417}', "");
    Expect(1, 68090, '\p{Is_Nv=4.1667e-01}', "");
    Expect(0, 68090, '\p{^Is_Nv=4.1667e-01}', "");
    Expect(0, 68090, '\P{Is_Nv=4.1667e-01}', "");
    Expect(1, 68090, '\P{^Is_Nv=4.1667e-01}', "");
    Expect(0, 68091, '\p{Is_Nv=4.1667e-01}', "");
    Expect(1, 68091, '\p{^Is_Nv=4.1667e-01}', "");
    Expect(1, 68091, '\P{Is_Nv=4.1667e-01}', "");
    Expect(0, 68091, '\P{^Is_Nv=4.1667e-01}', "");
    Expect(1, 68090, '\p{Is_Nv=0.4167}', "");
    Expect(0, 68090, '\p{^Is_Nv=0.4167}', "");
    Expect(0, 68090, '\P{Is_Nv=0.4167}', "");
    Expect(1, 68090, '\P{^Is_Nv=0.4167}', "");
    Expect(0, 68091, '\p{Is_Nv=0.4167}', "");
    Expect(1, 68091, '\p{^Is_Nv=0.4167}', "");
    Expect(1, 68091, '\P{Is_Nv=0.4167}', "");
    Expect(0, 68091, '\P{^Is_Nv=0.4167}', "");
    Error('\p{Numeric_Value=-/a/05/000002}');
    Error('\P{Numeric_Value=-/a/05/000002}');
    Expect(1, 3884, '\p{Numeric_Value=:\A5/2\z:}', "");;
    Expect(0, 3885, '\p{Numeric_Value=:\A5/2\z:}', "");;
    Expect(1, 3884, '\p{Numeric_Value:	5/02}', "");
    Expect(0, 3884, '\p{^Numeric_Value:	5/02}', "");
    Expect(0, 3884, '\P{Numeric_Value:	5/02}', "");
    Expect(1, 3884, '\P{^Numeric_Value:	5/02}', "");
    Expect(0, 3885, '\p{Numeric_Value:	5/02}', "");
    Expect(1, 3885, '\p{^Numeric_Value:	5/02}', "");
    Expect(1, 3885, '\P{Numeric_Value:	5/02}', "");
    Expect(0, 3885, '\P{^Numeric_Value:	5/02}', "");
    Expect(1, 3884, '\p{Numeric_Value=300/120}', "");
    Expect(0, 3884, '\p{^Numeric_Value=300/120}', "");
    Expect(0, 3884, '\P{Numeric_Value=300/120}', "");
    Expect(1, 3884, '\P{^Numeric_Value=300/120}', "");
    Expect(0, 3885, '\p{Numeric_Value=300/120}', "");
    Expect(1, 3885, '\p{^Numeric_Value=300/120}', "");
    Expect(1, 3885, '\P{Numeric_Value=300/120}', "");
    Expect(0, 3885, '\P{^Numeric_Value=300/120}', "");
    Expect(1, 3884, '\p{Numeric_Value=2.5e+00}', "");
    Expect(0, 3884, '\p{^Numeric_Value=2.5e+00}', "");
    Expect(0, 3884, '\P{Numeric_Value=2.5e+00}', "");
    Expect(1, 3884, '\P{^Numeric_Value=2.5e+00}', "");
    Expect(0, 3885, '\p{Numeric_Value=2.5e+00}', "");
    Expect(1, 3885, '\p{^Numeric_Value=2.5e+00}', "");
    Expect(1, 3885, '\P{Numeric_Value=2.5e+00}', "");
    Expect(0, 3885, '\P{^Numeric_Value=2.5e+00}', "");
    Expect(1, 3884, '\p{Numeric_Value=2.5}', "");
    Expect(0, 3884, '\p{^Numeric_Value=2.5}', "");
    Expect(0, 3884, '\P{Numeric_Value=2.5}', "");
    Expect(1, 3884, '\P{^Numeric_Value=2.5}', "");
    Expect(0, 3885, '\p{Numeric_Value=2.5}', "");
    Expect(1, 3885, '\p{^Numeric_Value=2.5}', "");
    Expect(1, 3885, '\P{Numeric_Value=2.5}', "");
    Expect(0, 3885, '\P{^Numeric_Value=2.5}', "");
    Expect(1, 3884, '\p{Numeric_Value=2.50e+00}', "");
    Expect(0, 3884, '\p{^Numeric_Value=2.50e+00}', "");
    Expect(0, 3884, '\P{Numeric_Value=2.50e+00}', "");
    Expect(1, 3884, '\P{^Numeric_Value=2.50e+00}', "");
    Expect(0, 3885, '\p{Numeric_Value=2.50e+00}', "");
    Expect(1, 3885, '\p{^Numeric_Value=2.50e+00}', "");
    Expect(1, 3885, '\P{Numeric_Value=2.50e+00}', "");
    Expect(0, 3885, '\P{^Numeric_Value=2.50e+00}', "");
    Expect(1, 3884, '\p{Numeric_Value=2.50}', "");
    Expect(0, 3884, '\p{^Numeric_Value=2.50}', "");
    Expect(0, 3884, '\P{Numeric_Value=2.50}', "");
    Expect(1, 3884, '\P{^Numeric_Value=2.50}', "");
    Expect(0, 3885, '\p{Numeric_Value=2.50}', "");
    Expect(1, 3885, '\p{^Numeric_Value=2.50}', "");
    Expect(1, 3885, '\P{Numeric_Value=2.50}', "");
    Expect(0, 3885, '\P{^Numeric_Value=2.50}', "");
    Error('\p{Nv=	+0000000005/2:=}');
    Error('\P{Nv=	+0000000005/2:=}');
    Expect(1, 3884, '\p{Nv=:\A5/2\z:}', "");;
    Expect(0, 3885, '\p{Nv=:\A5/2\z:}', "");;
    Expect(1, 3884, '\p{Nv=+005/0000002}', "");
    Expect(0, 3884, '\p{^Nv=+005/0000002}', "");
    Expect(0, 3884, '\P{Nv=+005/0000002}', "");
    Expect(1, 3884, '\P{^Nv=+005/0000002}', "");
    Expect(0, 3885, '\p{Nv=+005/0000002}', "");
    Expect(1, 3885, '\p{^Nv=+005/0000002}', "");
    Expect(1, 3885, '\P{Nv=+005/0000002}', "");
    Expect(0, 3885, '\P{^Nv=+005/0000002}', "");
    Expect(1, 3884, '\p{Nv=300/120}', "");
    Expect(0, 3884, '\p{^Nv=300/120}', "");
    Expect(0, 3884, '\P{Nv=300/120}', "");
    Expect(1, 3884, '\P{^Nv=300/120}', "");
    Expect(0, 3885, '\p{Nv=300/120}', "");
    Expect(1, 3885, '\p{^Nv=300/120}', "");
    Expect(1, 3885, '\P{Nv=300/120}', "");
    Expect(0, 3885, '\P{^Nv=300/120}', "");
    Expect(1, 3884, '\p{Nv=2.5e+00}', "");
    Expect(0, 3884, '\p{^Nv=2.5e+00}', "");
    Expect(0, 3884, '\P{Nv=2.5e+00}', "");
    Expect(1, 3884, '\P{^Nv=2.5e+00}', "");
    Expect(0, 3885, '\p{Nv=2.5e+00}', "");
    Expect(1, 3885, '\p{^Nv=2.5e+00}', "");
    Expect(1, 3885, '\P{Nv=2.5e+00}', "");
    Expect(0, 3885, '\P{^Nv=2.5e+00}', "");
    Expect(1, 3884, '\p{Nv=2.5}', "");
    Expect(0, 3884, '\p{^Nv=2.5}', "");
    Expect(0, 3884, '\P{Nv=2.5}', "");
    Expect(1, 3884, '\P{^Nv=2.5}', "");
    Expect(0, 3885, '\p{Nv=2.5}', "");
    Expect(1, 3885, '\p{^Nv=2.5}', "");
    Expect(1, 3885, '\P{Nv=2.5}', "");
    Expect(0, 3885, '\P{^Nv=2.5}', "");
    Expect(1, 3884, '\p{Nv=2.50e+00}', "");
    Expect(0, 3884, '\p{^Nv=2.50e+00}', "");
    Expect(0, 3884, '\P{Nv=2.50e+00}', "");
    Expect(1, 3884, '\P{^Nv=2.50e+00}', "");
    Expect(0, 3885, '\p{Nv=2.50e+00}', "");
    Expect(1, 3885, '\p{^Nv=2.50e+00}', "");
    Expect(1, 3885, '\P{Nv=2.50e+00}', "");
    Expect(0, 3885, '\P{^Nv=2.50e+00}', "");
    Expect(1, 3884, '\p{Nv=2.50}', "");
    Expect(0, 3884, '\p{^Nv=2.50}', "");
    Expect(0, 3884, '\P{Nv=2.50}', "");
    Expect(1, 3884, '\P{^Nv=2.50}', "");
    Expect(0, 3885, '\p{Nv=2.50}', "");
    Expect(1, 3885, '\p{^Nv=2.50}', "");
    Expect(1, 3885, '\P{Nv=2.50}', "");
    Expect(0, 3885, '\P{^Nv=2.50}', "");
    Error('\p{Is_Numeric_Value=	/a/0000000005/0000002}');
    Error('\P{Is_Numeric_Value=	/a/0000000005/0000002}');
    Expect(1, 3884, '\p{Is_Numeric_Value=00005/00002}', "");
    Expect(0, 3884, '\p{^Is_Numeric_Value=00005/00002}', "");
    Expect(0, 3884, '\P{Is_Numeric_Value=00005/00002}', "");
    Expect(1, 3884, '\P{^Is_Numeric_Value=00005/00002}', "");
    Expect(0, 3885, '\p{Is_Numeric_Value=00005/00002}', "");
    Expect(1, 3885, '\p{^Is_Numeric_Value=00005/00002}', "");
    Expect(1, 3885, '\P{Is_Numeric_Value=00005/00002}', "");
    Expect(0, 3885, '\P{^Is_Numeric_Value=00005/00002}', "");
    Expect(1, 3884, '\p{Is_Numeric_Value=300/120}', "");
    Expect(0, 3884, '\p{^Is_Numeric_Value=300/120}', "");
    Expect(0, 3884, '\P{Is_Numeric_Value=300/120}', "");
    Expect(1, 3884, '\P{^Is_Numeric_Value=300/120}', "");
    Expect(0, 3885, '\p{Is_Numeric_Value=300/120}', "");
    Expect(1, 3885, '\p{^Is_Numeric_Value=300/120}', "");
    Expect(1, 3885, '\P{Is_Numeric_Value=300/120}', "");
    Expect(0, 3885, '\P{^Is_Numeric_Value=300/120}', "");
    Expect(1, 3884, '\p{Is_Numeric_Value=2.5e+00}', "");
    Expect(0, 3884, '\p{^Is_Numeric_Value=2.5e+00}', "");
    Expect(0, 3884, '\P{Is_Numeric_Value=2.5e+00}', "");
    Expect(1, 3884, '\P{^Is_Numeric_Value=2.5e+00}', "");
    Expect(0, 3885, '\p{Is_Numeric_Value=2.5e+00}', "");
    Expect(1, 3885, '\p{^Is_Numeric_Value=2.5e+00}', "");
    Expect(1, 3885, '\P{Is_Numeric_Value=2.5e+00}', "");
    Expect(0, 3885, '\P{^Is_Numeric_Value=2.5e+00}', "");
    Expect(1, 3884, '\p{Is_Numeric_Value=2.5}', "");
    Expect(0, 3884, '\p{^Is_Numeric_Value=2.5}', "");
    Expect(0, 3884, '\P{Is_Numeric_Value=2.5}', "");
    Expect(1, 3884, '\P{^Is_Numeric_Value=2.5}', "");
    Expect(0, 3885, '\p{Is_Numeric_Value=2.5}', "");
    Expect(1, 3885, '\p{^Is_Numeric_Value=2.5}', "");
    Expect(1, 3885, '\P{Is_Numeric_Value=2.5}', "");
    Expect(0, 3885, '\P{^Is_Numeric_Value=2.5}', "");
    Expect(1, 3884, '\p{Is_Numeric_Value=2.50e+00}', "");
    Expect(0, 3884, '\p{^Is_Numeric_Value=2.50e+00}', "");
    Expect(0, 3884, '\P{Is_Numeric_Value=2.50e+00}', "");
    Expect(1, 3884, '\P{^Is_Numeric_Value=2.50e+00}', "");
    Expect(0, 3885, '\p{Is_Numeric_Value=2.50e+00}', "");
    Expect(1, 3885, '\p{^Is_Numeric_Value=2.50e+00}', "");
    Expect(1, 3885, '\P{Is_Numeric_Value=2.50e+00}', "");
    Expect(0, 3885, '\P{^Is_Numeric_Value=2.50e+00}', "");
    Expect(1, 3884, '\p{Is_Numeric_Value=2.50}', "");
    Expect(0, 3884, '\p{^Is_Numeric_Value=2.50}', "");
    Expect(0, 3884, '\P{Is_Numeric_Value=2.50}', "");
    Expect(1, 3884, '\P{^Is_Numeric_Value=2.50}', "");
    Expect(0, 3885, '\p{Is_Numeric_Value=2.50}', "");
    Expect(1, 3885, '\p{^Is_Numeric_Value=2.50}', "");
    Expect(1, 3885, '\P{Is_Numeric_Value=2.50}', "");
    Expect(0, 3885, '\P{^Is_Numeric_Value=2.50}', "");
    Error('\p{Is_Nv=:=- 5/0000002}');
    Error('\P{Is_Nv=:=- 5/0000002}');
    Expect(1, 3884, '\p{Is_Nv=+005/2}', "");
    Expect(0, 3884, '\p{^Is_Nv=+005/2}', "");
    Expect(0, 3884, '\P{Is_Nv=+005/2}', "");
    Expect(1, 3884, '\P{^Is_Nv=+005/2}', "");
    Expect(0, 3885, '\p{Is_Nv=+005/2}', "");
    Expect(1, 3885, '\p{^Is_Nv=+005/2}', "");
    Expect(1, 3885, '\P{Is_Nv=+005/2}', "");
    Expect(0, 3885, '\P{^Is_Nv=+005/2}', "");
    Expect(1, 3884, '\p{Is_Nv=300/120}', "");
    Expect(0, 3884, '\p{^Is_Nv=300/120}', "");
    Expect(0, 3884, '\P{Is_Nv=300/120}', "");
    Expect(1, 3884, '\P{^Is_Nv=300/120}', "");
    Expect(0, 3885, '\p{Is_Nv=300/120}', "");
    Expect(1, 3885, '\p{^Is_Nv=300/120}', "");
    Expect(1, 3885, '\P{Is_Nv=300/120}', "");
    Expect(0, 3885, '\P{^Is_Nv=300/120}', "");
    Expect(1, 3884, '\p{Is_Nv=2.5e+00}', "");
    Expect(0, 3884, '\p{^Is_Nv=2.5e+00}', "");
    Expect(0, 3884, '\P{Is_Nv=2.5e+00}', "");
    Expect(1, 3884, '\P{^Is_Nv=2.5e+00}', "");
    Expect(0, 3885, '\p{Is_Nv=2.5e+00}', "");
    Expect(1, 3885, '\p{^Is_Nv=2.5e+00}', "");
    Expect(1, 3885, '\P{Is_Nv=2.5e+00}', "");
    Expect(0, 3885, '\P{^Is_Nv=2.5e+00}', "");
    Expect(1, 3884, '\p{Is_Nv=2.5}', "");
    Expect(0, 3884, '\p{^Is_Nv=2.5}', "");
    Expect(0, 3884, '\P{Is_Nv=2.5}', "");
    Expect(1, 3884, '\P{^Is_Nv=2.5}', "");
    Expect(0, 3885, '\p{Is_Nv=2.5}', "");
    Expect(1, 3885, '\p{^Is_Nv=2.5}', "");
    Expect(1, 3885, '\P{Is_Nv=2.5}', "");
    Expect(0, 3885, '\P{^Is_Nv=2.5}', "");
    Expect(1, 3884, '\p{Is_Nv=2.50e+00}', "");
    Expect(0, 3884, '\p{^Is_Nv=2.50e+00}', "");
    Expect(0, 3884, '\P{Is_Nv=2.50e+00}', "");
    Expect(1, 3884, '\P{^Is_Nv=2.50e+00}', "");
    Expect(0, 3885, '\p{Is_Nv=2.50e+00}', "");
    Expect(1, 3885, '\p{^Is_Nv=2.50e+00}', "");
    Expect(1, 3885, '\P{Is_Nv=2.50e+00}', "");
    Expect(0, 3885, '\P{^Is_Nv=2.50e+00}', "");
    Expect(1, 3884, '\p{Is_Nv=2.50}', "");
    Expect(0, 3884, '\p{^Is_Nv=2.50}', "");
    Expect(0, 3884, '\P{Is_Nv=2.50}', "");
    Expect(1, 3884, '\P{^Is_Nv=2.50}', "");
    Expect(0, 3885, '\p{Is_Nv=2.50}', "");
    Expect(1, 3885, '\p{^Is_Nv=2.50}', "");
    Expect(1, 3885, '\P{Is_Nv=2.50}', "");
    Expect(0, 3885, '\P{^Is_Nv=2.50}', "");
    Error('\p{Numeric_Value= 05/000000006:=}');
    Error('\P{Numeric_Value= 05/000000006:=}');
    Expect(1, 74844, '\p{Numeric_Value=:\A5/6\z:}', "");;
    Expect(0, 74845, '\p{Numeric_Value=:\A5/6\z:}', "");;
    Expect(1, 74844, '\p{Numeric_Value:	+005/000006}', "");
    Expect(0, 74844, '\p{^Numeric_Value:	+005/000006}', "");
    Expect(0, 74844, '\P{Numeric_Value:	+005/000006}', "");
    Expect(1, 74844, '\P{^Numeric_Value:	+005/000006}', "");
    Expect(0, 74845, '\p{Numeric_Value:	+005/000006}', "");
    Expect(1, 74845, '\p{^Numeric_Value:	+005/000006}', "");
    Expect(1, 74845, '\P{Numeric_Value:	+005/000006}', "");
    Expect(0, 74845, '\P{^Numeric_Value:	+005/000006}', "");
    Expect(1, 74844, '\p{Numeric_Value=300/360}', "");
    Expect(0, 74844, '\p{^Numeric_Value=300/360}', "");
    Expect(0, 74844, '\P{Numeric_Value=300/360}', "");
    Expect(1, 74844, '\P{^Numeric_Value=300/360}', "");
    Expect(0, 74845, '\p{Numeric_Value=300/360}', "");
    Expect(1, 74845, '\p{^Numeric_Value=300/360}', "");
    Expect(1, 74845, '\P{Numeric_Value=300/360}', "");
    Expect(0, 74845, '\P{^Numeric_Value=300/360}', "");
    Error('\p{Numeric_Value=8.3e-01}');
    Error('\P{Numeric_Value=8.3e-01}');
    Expect(1, 74844, '\p{Numeric_Value: 8.33e-01}', "");
    Expect(0, 74844, '\p{^Numeric_Value: 8.33e-01}', "");
    Expect(0, 74844, '\P{Numeric_Value: 8.33e-01}', "");
    Expect(1, 74844, '\P{^Numeric_Value: 8.33e-01}', "");
    Expect(0, 74845, '\p{Numeric_Value: 8.33e-01}', "");
    Expect(1, 74845, '\p{^Numeric_Value: 8.33e-01}', "");
    Expect(1, 74845, '\P{Numeric_Value: 8.33e-01}', "");
    Expect(0, 74845, '\P{^Numeric_Value: 8.33e-01}', "");
    Error('\p{Numeric_Value=0.83}');
    Error('\P{Numeric_Value=0.83}');
    Expect(1, 74844, '\p{Numeric_Value=8.333e-01}', "");
    Expect(0, 74844, '\p{^Numeric_Value=8.333e-01}', "");
    Expect(0, 74844, '\P{Numeric_Value=8.333e-01}', "");
    Expect(1, 74844, '\P{^Numeric_Value=8.333e-01}', "");
    Expect(0, 74845, '\p{Numeric_Value=8.333e-01}', "");
    Expect(1, 74845, '\p{^Numeric_Value=8.333e-01}', "");
    Expect(1, 74845, '\P{Numeric_Value=8.333e-01}', "");
    Expect(0, 74845, '\P{^Numeric_Value=8.333e-01}', "");
    Expect(1, 74844, '\p{Numeric_Value=0.833}', "");
    Expect(0, 74844, '\p{^Numeric_Value=0.833}', "");
    Expect(0, 74844, '\P{Numeric_Value=0.833}', "");
    Expect(1, 74844, '\P{^Numeric_Value=0.833}', "");
    Expect(0, 74845, '\p{Numeric_Value=0.833}', "");
    Expect(1, 74845, '\p{^Numeric_Value=0.833}', "");
    Expect(1, 74845, '\P{Numeric_Value=0.833}', "");
    Expect(0, 74845, '\P{^Numeric_Value=0.833}', "");
    Expect(1, 74844, '\p{Numeric_Value=8.3333e-01}', "");
    Expect(0, 74844, '\p{^Numeric_Value=8.3333e-01}', "");
    Expect(0, 74844, '\P{Numeric_Value=8.3333e-01}', "");
    Expect(1, 74844, '\P{^Numeric_Value=8.3333e-01}', "");
    Expect(0, 74845, '\p{Numeric_Value=8.3333e-01}', "");
    Expect(1, 74845, '\p{^Numeric_Value=8.3333e-01}', "");
    Expect(1, 74845, '\P{Numeric_Value=8.3333e-01}', "");
    Expect(0, 74845, '\P{^Numeric_Value=8.3333e-01}', "");
    Expect(1, 74844, '\p{Numeric_Value=0.8333}', "");
    Expect(0, 74844, '\p{^Numeric_Value=0.8333}', "");
    Expect(0, 74844, '\P{Numeric_Value=0.8333}', "");
    Expect(1, 74844, '\P{^Numeric_Value=0.8333}', "");
    Expect(0, 74845, '\p{Numeric_Value=0.8333}', "");
    Expect(1, 74845, '\p{^Numeric_Value=0.8333}', "");
    Expect(1, 74845, '\P{Numeric_Value=0.8333}', "");
    Expect(0, 74845, '\P{^Numeric_Value=0.8333}', "");
    Error('\p{Nv=/a/	 000000005/0000000006}');
    Error('\P{Nv=/a/	 000000005/0000000006}');
    Expect(1, 74844, '\p{Nv=:\A5/6\z:}', "");;
    Expect(0, 74845, '\p{Nv=:\A5/6\z:}', "");;
    Expect(1, 74844, '\p{Nv=005/0006}', "");
    Expect(0, 74844, '\p{^Nv=005/0006}', "");
    Expect(0, 74844, '\P{Nv=005/0006}', "");
    Expect(1, 74844, '\P{^Nv=005/0006}', "");
    Expect(0, 74845, '\p{Nv=005/0006}', "");
    Expect(1, 74845, '\p{^Nv=005/0006}', "");
    Expect(1, 74845, '\P{Nv=005/0006}', "");
    Expect(0, 74845, '\P{^Nv=005/0006}', "");
    Expect(1, 74844, '\p{Nv:   300/360}', "");
    Expect(0, 74844, '\p{^Nv:   300/360}', "");
    Expect(0, 74844, '\P{Nv:   300/360}', "");
    Expect(1, 74844, '\P{^Nv:   300/360}', "");
    Expect(0, 74845, '\p{Nv:   300/360}', "");
    Expect(1, 74845, '\p{^Nv:   300/360}', "");
    Expect(1, 74845, '\P{Nv:   300/360}', "");
    Expect(0, 74845, '\P{^Nv:   300/360}', "");
    Error('\p{Nv:	8.3e-01}');
    Error('\P{Nv:	8.3e-01}');
    Expect(1, 74844, '\p{Nv=8.33e-01}', "");
    Expect(0, 74844, '\p{^Nv=8.33e-01}', "");
    Expect(0, 74844, '\P{Nv=8.33e-01}', "");
    Expect(1, 74844, '\P{^Nv=8.33e-01}', "");
    Expect(0, 74845, '\p{Nv=8.33e-01}', "");
    Expect(1, 74845, '\p{^Nv=8.33e-01}', "");
    Expect(1, 74845, '\P{Nv=8.33e-01}', "");
    Expect(0, 74845, '\P{^Nv=8.33e-01}', "");
    Error('\p{Nv=0.83}');
    Error('\P{Nv=0.83}');
    Expect(1, 74844, '\p{Nv: 8.333e-01}', "");
    Expect(0, 74844, '\p{^Nv: 8.333e-01}', "");
    Expect(0, 74844, '\P{Nv: 8.333e-01}', "");
    Expect(1, 74844, '\P{^Nv: 8.333e-01}', "");
    Expect(0, 74845, '\p{Nv: 8.333e-01}', "");
    Expect(1, 74845, '\p{^Nv: 8.333e-01}', "");
    Expect(1, 74845, '\P{Nv: 8.333e-01}', "");
    Expect(0, 74845, '\P{^Nv: 8.333e-01}', "");
    Expect(1, 74844, '\p{Nv=0.833}', "");
    Expect(0, 74844, '\p{^Nv=0.833}', "");
    Expect(0, 74844, '\P{Nv=0.833}', "");
    Expect(1, 74844, '\P{^Nv=0.833}', "");
    Expect(0, 74845, '\p{Nv=0.833}', "");
    Expect(1, 74845, '\p{^Nv=0.833}', "");
    Expect(1, 74845, '\P{Nv=0.833}', "");
    Expect(0, 74845, '\P{^Nv=0.833}', "");
    Expect(1, 74844, '\p{Nv=8.3333e-01}', "");
    Expect(0, 74844, '\p{^Nv=8.3333e-01}', "");
    Expect(0, 74844, '\P{Nv=8.3333e-01}', "");
    Expect(1, 74844, '\P{^Nv=8.3333e-01}', "");
    Expect(0, 74845, '\p{Nv=8.3333e-01}', "");
    Expect(1, 74845, '\p{^Nv=8.3333e-01}', "");
    Expect(1, 74845, '\P{Nv=8.3333e-01}', "");
    Expect(0, 74845, '\P{^Nv=8.3333e-01}', "");
    Expect(1, 74844, '\p{Nv=0.8333}', "");
    Expect(0, 74844, '\p{^Nv=0.8333}', "");
    Expect(0, 74844, '\P{Nv=0.8333}', "");
    Expect(1, 74844, '\P{^Nv=0.8333}', "");
    Expect(0, 74845, '\p{Nv=0.8333}', "");
    Expect(1, 74845, '\p{^Nv=0.8333}', "");
    Expect(1, 74845, '\P{Nv=0.8333}', "");
    Expect(0, 74845, '\P{^Nv=0.8333}', "");
    Error('\p{Is_Numeric_Value=:=	_000000005/0000000006}');
    Error('\P{Is_Numeric_Value=:=	_000000005/0000000006}');
    Expect(1, 74844, '\p{Is_Numeric_Value=0000005/00006}', "");
    Expect(0, 74844, '\p{^Is_Numeric_Value=0000005/00006}', "");
    Expect(0, 74844, '\P{Is_Numeric_Value=0000005/00006}', "");
    Expect(1, 74844, '\P{^Is_Numeric_Value=0000005/00006}', "");
    Expect(0, 74845, '\p{Is_Numeric_Value=0000005/00006}', "");
    Expect(1, 74845, '\p{^Is_Numeric_Value=0000005/00006}', "");
    Expect(1, 74845, '\P{Is_Numeric_Value=0000005/00006}', "");
    Expect(0, 74845, '\P{^Is_Numeric_Value=0000005/00006}', "");
    Expect(1, 74844, '\p{Is_Numeric_Value: 300/360}', "");
    Expect(0, 74844, '\p{^Is_Numeric_Value: 300/360}', "");
    Expect(0, 74844, '\P{Is_Numeric_Value: 300/360}', "");
    Expect(1, 74844, '\P{^Is_Numeric_Value: 300/360}', "");
    Expect(0, 74845, '\p{Is_Numeric_Value: 300/360}', "");
    Expect(1, 74845, '\p{^Is_Numeric_Value: 300/360}', "");
    Expect(1, 74845, '\P{Is_Numeric_Value: 300/360}', "");
    Expect(0, 74845, '\P{^Is_Numeric_Value: 300/360}', "");
    Error('\p{Is_Numeric_Value=8.3e-01}');
    Error('\P{Is_Numeric_Value=8.3e-01}');
    Expect(1, 74844, '\p{Is_Numeric_Value=8.33e-01}', "");
    Expect(0, 74844, '\p{^Is_Numeric_Value=8.33e-01}', "");
    Expect(0, 74844, '\P{Is_Numeric_Value=8.33e-01}', "");
    Expect(1, 74844, '\P{^Is_Numeric_Value=8.33e-01}', "");
    Expect(0, 74845, '\p{Is_Numeric_Value=8.33e-01}', "");
    Expect(1, 74845, '\p{^Is_Numeric_Value=8.33e-01}', "");
    Expect(1, 74845, '\P{Is_Numeric_Value=8.33e-01}', "");
    Expect(0, 74845, '\P{^Is_Numeric_Value=8.33e-01}', "");
    Error('\p{Is_Numeric_Value=0.83}');
    Error('\P{Is_Numeric_Value=0.83}');
    Expect(1, 74844, '\p{Is_Numeric_Value=8.333e-01}', "");
    Expect(0, 74844, '\p{^Is_Numeric_Value=8.333e-01}', "");
    Expect(0, 74844, '\P{Is_Numeric_Value=8.333e-01}', "");
    Expect(1, 74844, '\P{^Is_Numeric_Value=8.333e-01}', "");
    Expect(0, 74845, '\p{Is_Numeric_Value=8.333e-01}', "");
    Expect(1, 74845, '\p{^Is_Numeric_Value=8.333e-01}', "");
    Expect(1, 74845, '\P{Is_Numeric_Value=8.333e-01}', "");
    Expect(0, 74845, '\P{^Is_Numeric_Value=8.333e-01}', "");
    Expect(1, 74844, '\p{Is_Numeric_Value=0.833}', "");
    Expect(0, 74844, '\p{^Is_Numeric_Value=0.833}', "");
    Expect(0, 74844, '\P{Is_Numeric_Value=0.833}', "");
    Expect(1, 74844, '\P{^Is_Numeric_Value=0.833}', "");
    Expect(0, 74845, '\p{Is_Numeric_Value=0.833}', "");
    Expect(1, 74845, '\p{^Is_Numeric_Value=0.833}', "");
    Expect(1, 74845, '\P{Is_Numeric_Value=0.833}', "");
    Expect(0, 74845, '\P{^Is_Numeric_Value=0.833}', "");
    Expect(1, 74844, '\p{Is_Numeric_Value=8.3333e-01}', "");
    Expect(0, 74844, '\p{^Is_Numeric_Value=8.3333e-01}', "");
    Expect(0, 74844, '\P{Is_Numeric_Value=8.3333e-01}', "");
    Expect(1, 74844, '\P{^Is_Numeric_Value=8.3333e-01}', "");
    Expect(0, 74845, '\p{Is_Numeric_Value=8.3333e-01}', "");
    Expect(1, 74845, '\p{^Is_Numeric_Value=8.3333e-01}', "");
    Expect(1, 74845, '\P{Is_Numeric_Value=8.3333e-01}', "");
    Expect(0, 74845, '\P{^Is_Numeric_Value=8.3333e-01}', "");
    Expect(1, 74844, '\p{Is_Numeric_Value=0.8333}', "");
    Expect(0, 74844, '\p{^Is_Numeric_Value=0.8333}', "");
    Expect(0, 74844, '\P{Is_Numeric_Value=0.8333}', "");
    Expect(1, 74844, '\P{^Is_Numeric_Value=0.8333}', "");
    Expect(0, 74845, '\p{Is_Numeric_Value=0.8333}', "");
    Expect(1, 74845, '\p{^Is_Numeric_Value=0.8333}', "");
    Expect(1, 74845, '\P{Is_Numeric_Value=0.8333}', "");
    Expect(0, 74845, '\P{^Is_Numeric_Value=0.8333}', "");
    Error('\p{Is_Nv=/a/+005/0006}');
    Error('\P{Is_Nv=/a/+005/0006}');
    Expect(1, 74844, '\p{Is_Nv=000000005/0006}', "");
    Expect(0, 74844, '\p{^Is_Nv=000000005/0006}', "");
    Expect(0, 74844, '\P{Is_Nv=000000005/0006}', "");
    Expect(1, 74844, '\P{^Is_Nv=000000005/0006}', "");
    Expect(0, 74845, '\p{Is_Nv=000000005/0006}', "");
    Expect(1, 74845, '\p{^Is_Nv=000000005/0006}', "");
    Expect(1, 74845, '\P{Is_Nv=000000005/0006}', "");
    Expect(0, 74845, '\P{^Is_Nv=000000005/0006}', "");
    Expect(1, 74844, '\p{Is_Nv=300/360}', "");
    Expect(0, 74844, '\p{^Is_Nv=300/360}', "");
    Expect(0, 74844, '\P{Is_Nv=300/360}', "");
    Expect(1, 74844, '\P{^Is_Nv=300/360}', "");
    Expect(0, 74845, '\p{Is_Nv=300/360}', "");
    Expect(1, 74845, '\p{^Is_Nv=300/360}', "");
    Expect(1, 74845, '\P{Is_Nv=300/360}', "");
    Expect(0, 74845, '\P{^Is_Nv=300/360}', "");
    Error('\p{Is_Nv=8.3e-01}');
    Error('\P{Is_Nv=8.3e-01}');
    Expect(1, 74844, '\p{Is_Nv=8.33e-01}', "");
    Expect(0, 74844, '\p{^Is_Nv=8.33e-01}', "");
    Expect(0, 74844, '\P{Is_Nv=8.33e-01}', "");
    Expect(1, 74844, '\P{^Is_Nv=8.33e-01}', "");
    Expect(0, 74845, '\p{Is_Nv=8.33e-01}', "");
    Expect(1, 74845, '\p{^Is_Nv=8.33e-01}', "");
    Expect(1, 74845, '\P{Is_Nv=8.33e-01}', "");
    Expect(0, 74845, '\P{^Is_Nv=8.33e-01}', "");
    Error('\p{Is_Nv=0.83}');
    Error('\P{Is_Nv=0.83}');
    Expect(1, 74844, '\p{Is_Nv=8.333e-01}', "");
    Expect(0, 74844, '\p{^Is_Nv=8.333e-01}', "");
    Expect(0, 74844, '\P{Is_Nv=8.333e-01}', "");
    Expect(1, 74844, '\P{^Is_Nv=8.333e-01}', "");
    Expect(0, 74845, '\p{Is_Nv=8.333e-01}', "");
    Expect(1, 74845, '\p{^Is_Nv=8.333e-01}', "");
    Expect(1, 74845, '\P{Is_Nv=8.333e-01}', "");
    Expect(0, 74845, '\P{^Is_Nv=8.333e-01}', "");
    Expect(1, 74844, '\p{Is_Nv:   0.833}', "");
    Expect(0, 74844, '\p{^Is_Nv:   0.833}', "");
    Expect(0, 74844, '\P{Is_Nv:   0.833}', "");
    Expect(1, 74844, '\P{^Is_Nv:   0.833}', "");
    Expect(0, 74845, '\p{Is_Nv:   0.833}', "");
    Expect(1, 74845, '\p{^Is_Nv:   0.833}', "");
    Expect(1, 74845, '\P{Is_Nv:   0.833}', "");
    Expect(0, 74845, '\P{^Is_Nv:   0.833}', "");
    Expect(1, 74844, '\p{Is_Nv=8.3333e-01}', "");
    Expect(0, 74844, '\p{^Is_Nv=8.3333e-01}', "");
    Expect(0, 74844, '\P{Is_Nv=8.3333e-01}', "");
    Expect(1, 74844, '\P{^Is_Nv=8.3333e-01}', "");
    Expect(0, 74845, '\p{Is_Nv=8.3333e-01}', "");
    Expect(1, 74845, '\p{^Is_Nv=8.3333e-01}', "");
    Expect(1, 74845, '\P{Is_Nv=8.3333e-01}', "");
    Expect(0, 74845, '\P{^Is_Nv=8.3333e-01}', "");
    Expect(1, 74844, '\p{Is_Nv=0.8333}', "");
    Expect(0, 74844, '\p{^Is_Nv=0.8333}', "");
    Expect(0, 74844, '\P{Is_Nv=0.8333}', "");
    Expect(1, 74844, '\P{^Is_Nv=0.8333}', "");
    Expect(0, 74845, '\p{Is_Nv=0.8333}', "");
    Expect(1, 74845, '\p{^Is_Nv=0.8333}', "");
    Expect(1, 74845, '\P{Is_Nv=0.8333}', "");
    Expect(0, 74845, '\P{^Is_Nv=0.8333}', "");
    Error('\p{Numeric_Value=		+00005/008:=}');
    Error('\P{Numeric_Value=		+00005/008:=}');
    Expect(1, 8541, '\p{Numeric_Value=:\A5/8\z:}', "");;
    Expect(0, 8542, '\p{Numeric_Value=:\A5/8\z:}', "");;
    Expect(1, 8541, '\p{Numeric_Value:+05/00008}', "");
    Expect(0, 8541, '\p{^Numeric_Value:+05/00008}', "");
    Expect(0, 8541, '\P{Numeric_Value:+05/00008}', "");
    Expect(1, 8541, '\P{^Numeric_Value:+05/00008}', "");
    Expect(0, 8542, '\p{Numeric_Value:+05/00008}', "");
    Expect(1, 8542, '\p{^Numeric_Value:+05/00008}', "");
    Expect(1, 8542, '\P{Numeric_Value:+05/00008}', "");
    Expect(0, 8542, '\P{^Numeric_Value:+05/00008}', "");
    Expect(1, 8541, '\p{Numeric_Value:   300/480}', "");
    Expect(0, 8541, '\p{^Numeric_Value:   300/480}', "");
    Expect(0, 8541, '\P{Numeric_Value:   300/480}', "");
    Expect(1, 8541, '\P{^Numeric_Value:   300/480}', "");
    Expect(0, 8542, '\p{Numeric_Value:   300/480}', "");
    Expect(1, 8542, '\p{^Numeric_Value:   300/480}', "");
    Expect(1, 8542, '\P{Numeric_Value:   300/480}', "");
    Expect(0, 8542, '\P{^Numeric_Value:   300/480}', "");
    Error('\p{Numeric_Value=6.2e-01}');
    Error('\P{Numeric_Value=6.2e-01}');
    Expect(1, 8541, '\p{Numeric_Value=6.25e-01}', "");
    Expect(0, 8541, '\p{^Numeric_Value=6.25e-01}', "");
    Expect(0, 8541, '\P{Numeric_Value=6.25e-01}', "");
    Expect(1, 8541, '\P{^Numeric_Value=6.25e-01}', "");
    Expect(0, 8542, '\p{Numeric_Value=6.25e-01}', "");
    Expect(1, 8542, '\p{^Numeric_Value=6.25e-01}', "");
    Expect(1, 8542, '\P{Numeric_Value=6.25e-01}', "");
    Expect(0, 8542, '\P{^Numeric_Value=6.25e-01}', "");
    Error('\p{Numeric_Value=0.62}');
    Error('\P{Numeric_Value=0.62}');
    Expect(1, 8541, '\p{Numeric_Value=6.250e-01}', "");
    Expect(0, 8541, '\p{^Numeric_Value=6.250e-01}', "");
    Expect(0, 8541, '\P{Numeric_Value=6.250e-01}', "");
    Expect(1, 8541, '\P{^Numeric_Value=6.250e-01}', "");
    Expect(0, 8542, '\p{Numeric_Value=6.250e-01}', "");
    Expect(1, 8542, '\p{^Numeric_Value=6.250e-01}', "");
    Expect(1, 8542, '\P{Numeric_Value=6.250e-01}', "");
    Expect(0, 8542, '\P{^Numeric_Value=6.250e-01}', "");
    Expect(1, 8541, '\p{Numeric_Value=0.625}', "");
    Expect(0, 8541, '\p{^Numeric_Value=0.625}', "");
    Expect(0, 8541, '\P{Numeric_Value=0.625}', "");
    Expect(1, 8541, '\P{^Numeric_Value=0.625}', "");
    Expect(0, 8542, '\p{Numeric_Value=0.625}', "");
    Expect(1, 8542, '\p{^Numeric_Value=0.625}', "");
    Expect(1, 8542, '\P{Numeric_Value=0.625}', "");
    Expect(0, 8542, '\P{^Numeric_Value=0.625}', "");
    Expect(1, 8541, '\p{Numeric_Value=6.2500e-01}', "");
    Expect(0, 8541, '\p{^Numeric_Value=6.2500e-01}', "");
    Expect(0, 8541, '\P{Numeric_Value=6.2500e-01}', "");
    Expect(1, 8541, '\P{^Numeric_Value=6.2500e-01}', "");
    Expect(0, 8542, '\p{Numeric_Value=6.2500e-01}', "");
    Expect(1, 8542, '\p{^Numeric_Value=6.2500e-01}', "");
    Expect(1, 8542, '\P{Numeric_Value=6.2500e-01}', "");
    Expect(0, 8542, '\P{^Numeric_Value=6.2500e-01}', "");
    Expect(1, 8541, '\p{Numeric_Value=0.6250}', "");
    Expect(0, 8541, '\p{^Numeric_Value=0.6250}', "");
    Expect(0, 8541, '\P{Numeric_Value=0.6250}', "");
    Expect(1, 8541, '\P{^Numeric_Value=0.6250}', "");
    Expect(0, 8542, '\p{Numeric_Value=0.6250}', "");
    Expect(1, 8542, '\p{^Numeric_Value=0.6250}', "");
    Expect(1, 8542, '\P{Numeric_Value=0.6250}', "");
    Expect(0, 8542, '\P{^Numeric_Value=0.6250}', "");
    Error('\p{Nv= +0000000005/008:=}');
    Error('\P{Nv= +0000000005/008:=}');
    Expect(1, 8541, '\p{Nv=:\A5/8\z:}', "");;
    Expect(0, 8542, '\p{Nv=:\A5/8\z:}', "");;
    Expect(1, 8541, '\p{Nv:00000005/0000008}', "");
    Expect(0, 8541, '\p{^Nv:00000005/0000008}', "");
    Expect(0, 8541, '\P{Nv:00000005/0000008}', "");
    Expect(1, 8541, '\P{^Nv:00000005/0000008}', "");
    Expect(0, 8542, '\p{Nv:00000005/0000008}', "");
    Expect(1, 8542, '\p{^Nv:00000005/0000008}', "");
    Expect(1, 8542, '\P{Nv:00000005/0000008}', "");
    Expect(0, 8542, '\P{^Nv:00000005/0000008}', "");
    Expect(1, 8541, '\p{Nv=300/480}', "");
    Expect(0, 8541, '\p{^Nv=300/480}', "");
    Expect(0, 8541, '\P{Nv=300/480}', "");
    Expect(1, 8541, '\P{^Nv=300/480}', "");
    Expect(0, 8542, '\p{Nv=300/480}', "");
    Expect(1, 8542, '\p{^Nv=300/480}', "");
    Expect(1, 8542, '\P{Nv=300/480}', "");
    Expect(0, 8542, '\P{^Nv=300/480}', "");
    Error('\p{Nv=6.2e-01}');
    Error('\P{Nv=6.2e-01}');
    Expect(1, 8541, '\p{Nv=6.25e-01}', "");
    Expect(0, 8541, '\p{^Nv=6.25e-01}', "");
    Expect(0, 8541, '\P{Nv=6.25e-01}', "");
    Expect(1, 8541, '\P{^Nv=6.25e-01}', "");
    Expect(0, 8542, '\p{Nv=6.25e-01}', "");
    Expect(1, 8542, '\p{^Nv=6.25e-01}', "");
    Expect(1, 8542, '\P{Nv=6.25e-01}', "");
    Expect(0, 8542, '\P{^Nv=6.25e-01}', "");
    Error('\p{Nv=0.62}');
    Error('\P{Nv=0.62}');
    Expect(1, 8541, '\p{Nv=6.250e-01}', "");
    Expect(0, 8541, '\p{^Nv=6.250e-01}', "");
    Expect(0, 8541, '\P{Nv=6.250e-01}', "");
    Expect(1, 8541, '\P{^Nv=6.250e-01}', "");
    Expect(0, 8542, '\p{Nv=6.250e-01}', "");
    Expect(1, 8542, '\p{^Nv=6.250e-01}', "");
    Expect(1, 8542, '\P{Nv=6.250e-01}', "");
    Expect(0, 8542, '\P{^Nv=6.250e-01}', "");
    Expect(1, 8541, '\p{Nv=0.625}', "");
    Expect(0, 8541, '\p{^Nv=0.625}', "");
    Expect(0, 8541, '\P{Nv=0.625}', "");
    Expect(1, 8541, '\P{^Nv=0.625}', "");
    Expect(0, 8542, '\p{Nv=0.625}', "");
    Expect(1, 8542, '\p{^Nv=0.625}', "");
    Expect(1, 8542, '\P{Nv=0.625}', "");
    Expect(0, 8542, '\P{^Nv=0.625}', "");
    Expect(1, 8541, '\p{Nv=6.2500e-01}', "");
    Expect(0, 8541, '\p{^Nv=6.2500e-01}', "");
    Expect(0, 8541, '\P{Nv=6.2500e-01}', "");
    Expect(1, 8541, '\P{^Nv=6.2500e-01}', "");
    Expect(0, 8542, '\p{Nv=6.2500e-01}', "");
    Expect(1, 8542, '\p{^Nv=6.2500e-01}', "");
    Expect(1, 8542, '\P{Nv=6.2500e-01}', "");
    Expect(0, 8542, '\P{^Nv=6.2500e-01}', "");
    Expect(1, 8541, '\p{Nv=0.6250}', "");
    Expect(0, 8541, '\p{^Nv=0.6250}', "");
    Expect(0, 8541, '\P{Nv=0.6250}', "");
    Expect(1, 8541, '\P{^Nv=0.6250}', "");
    Expect(0, 8542, '\p{Nv=0.6250}', "");
    Expect(1, 8542, '\p{^Nv=0.6250}', "");
    Expect(1, 8542, '\P{Nv=0.6250}', "");
    Expect(0, 8542, '\P{^Nv=0.6250}', "");
    Error('\p{Is_Numeric_Value=	:=00000005/0000000008}');
    Error('\P{Is_Numeric_Value=	:=00000005/0000000008}');
    Expect(1, 8541, '\p{Is_Numeric_Value=+0005/008}', "");
    Expect(0, 8541, '\p{^Is_Numeric_Value=+0005/008}', "");
    Expect(0, 8541, '\P{Is_Numeric_Value=+0005/008}', "");
    Expect(1, 8541, '\P{^Is_Numeric_Value=+0005/008}', "");
    Expect(0, 8542, '\p{Is_Numeric_Value=+0005/008}', "");
    Expect(1, 8542, '\p{^Is_Numeric_Value=+0005/008}', "");
    Expect(1, 8542, '\P{Is_Numeric_Value=+0005/008}', "");
    Expect(0, 8542, '\P{^Is_Numeric_Value=+0005/008}', "");
    Expect(1, 8541, '\p{Is_Numeric_Value=300/480}', "");
    Expect(0, 8541, '\p{^Is_Numeric_Value=300/480}', "");
    Expect(0, 8541, '\P{Is_Numeric_Value=300/480}', "");
    Expect(1, 8541, '\P{^Is_Numeric_Value=300/480}', "");
    Expect(0, 8542, '\p{Is_Numeric_Value=300/480}', "");
    Expect(1, 8542, '\p{^Is_Numeric_Value=300/480}', "");
    Expect(1, 8542, '\P{Is_Numeric_Value=300/480}', "");
    Expect(0, 8542, '\P{^Is_Numeric_Value=300/480}', "");
    Error('\p{Is_Numeric_Value=6.2e-01}');
    Error('\P{Is_Numeric_Value=6.2e-01}');
    Expect(1, 8541, '\p{Is_Numeric_Value=6.25e-01}', "");
    Expect(0, 8541, '\p{^Is_Numeric_Value=6.25e-01}', "");
    Expect(0, 8541, '\P{Is_Numeric_Value=6.25e-01}', "");
    Expect(1, 8541, '\P{^Is_Numeric_Value=6.25e-01}', "");
    Expect(0, 8542, '\p{Is_Numeric_Value=6.25e-01}', "");
    Expect(1, 8542, '\p{^Is_Numeric_Value=6.25e-01}', "");
    Expect(1, 8542, '\P{Is_Numeric_Value=6.25e-01}', "");
    Expect(0, 8542, '\P{^Is_Numeric_Value=6.25e-01}', "");
    Error('\p{Is_Numeric_Value: 0.62}');
    Error('\P{Is_Numeric_Value: 0.62}');
    Expect(1, 8541, '\p{Is_Numeric_Value=6.250e-01}', "");
    Expect(0, 8541, '\p{^Is_Numeric_Value=6.250e-01}', "");
    Expect(0, 8541, '\P{Is_Numeric_Value=6.250e-01}', "");
    Expect(1, 8541, '\P{^Is_Numeric_Value=6.250e-01}', "");
    Expect(0, 8542, '\p{Is_Numeric_Value=6.250e-01}', "");
    Expect(1, 8542, '\p{^Is_Numeric_Value=6.250e-01}', "");
    Expect(1, 8542, '\P{Is_Numeric_Value=6.250e-01}', "");
    Expect(0, 8542, '\P{^Is_Numeric_Value=6.250e-01}', "");
    Expect(1, 8541, '\p{Is_Numeric_Value=0.625}', "");
    Expect(0, 8541, '\p{^Is_Numeric_Value=0.625}', "");
    Expect(0, 8541, '\P{Is_Numeric_Value=0.625}', "");
    Expect(1, 8541, '\P{^Is_Numeric_Value=0.625}', "");
    Expect(0, 8542, '\p{Is_Numeric_Value=0.625}', "");
    Expect(1, 8542, '\p{^Is_Numeric_Value=0.625}', "");
    Expect(1, 8542, '\P{Is_Numeric_Value=0.625}', "");
    Expect(0, 8542, '\P{^Is_Numeric_Value=0.625}', "");
    Expect(1, 8541, '\p{Is_Numeric_Value=6.2500e-01}', "");
    Expect(0, 8541, '\p{^Is_Numeric_Value=6.2500e-01}', "");
    Expect(0, 8541, '\P{Is_Numeric_Value=6.2500e-01}', "");
    Expect(1, 8541, '\P{^Is_Numeric_Value=6.2500e-01}', "");
    Expect(0, 8542, '\p{Is_Numeric_Value=6.2500e-01}', "");
    Expect(1, 8542, '\p{^Is_Numeric_Value=6.2500e-01}', "");
    Expect(1, 8542, '\P{Is_Numeric_Value=6.2500e-01}', "");
    Expect(0, 8542, '\P{^Is_Numeric_Value=6.2500e-01}', "");
    Expect(1, 8541, '\p{Is_Numeric_Value=0.6250}', "");
    Expect(0, 8541, '\p{^Is_Numeric_Value=0.6250}', "");
    Expect(0, 8541, '\P{Is_Numeric_Value=0.6250}', "");
    Expect(1, 8541, '\P{^Is_Numeric_Value=0.6250}', "");
    Expect(0, 8542, '\p{Is_Numeric_Value=0.6250}', "");
    Expect(1, 8542, '\p{^Is_Numeric_Value=0.6250}', "");
    Expect(1, 8542, '\P{Is_Numeric_Value=0.6250}', "");
    Expect(0, 8542, '\P{^Is_Numeric_Value=0.6250}', "");
    Error('\p{Is_Nv=_:=0000005/8}');
    Error('\P{Is_Nv=_:=0000005/8}');
    Expect(1, 8541, '\p{Is_Nv:   0005/08}', "");
    Expect(0, 8541, '\p{^Is_Nv:   0005/08}', "");
    Expect(0, 8541, '\P{Is_Nv:   0005/08}', "");
    Expect(1, 8541, '\P{^Is_Nv:   0005/08}', "");
    Expect(0, 8542, '\p{Is_Nv:   0005/08}', "");
    Expect(1, 8542, '\p{^Is_Nv:   0005/08}', "");
    Expect(1, 8542, '\P{Is_Nv:   0005/08}', "");
    Expect(0, 8542, '\P{^Is_Nv:   0005/08}', "");
    Expect(1, 8541, '\p{Is_Nv=300/480}', "");
    Expect(0, 8541, '\p{^Is_Nv=300/480}', "");
    Expect(0, 8541, '\P{Is_Nv=300/480}', "");
    Expect(1, 8541, '\P{^Is_Nv=300/480}', "");
    Expect(0, 8542, '\p{Is_Nv=300/480}', "");
    Expect(1, 8542, '\p{^Is_Nv=300/480}', "");
    Expect(1, 8542, '\P{Is_Nv=300/480}', "");
    Expect(0, 8542, '\P{^Is_Nv=300/480}', "");
    Error('\p{Is_Nv=6.2e-01}');
    Error('\P{Is_Nv=6.2e-01}');
    Expect(1, 8541, '\p{Is_Nv=6.25e-01}', "");
    Expect(0, 8541, '\p{^Is_Nv=6.25e-01}', "");
    Expect(0, 8541, '\P{Is_Nv=6.25e-01}', "");
    Expect(1, 8541, '\P{^Is_Nv=6.25e-01}', "");
    Expect(0, 8542, '\p{Is_Nv=6.25e-01}', "");
    Expect(1, 8542, '\p{^Is_Nv=6.25e-01}', "");
    Expect(1, 8542, '\P{Is_Nv=6.25e-01}', "");
    Expect(0, 8542, '\P{^Is_Nv=6.25e-01}', "");
    Error('\p{Is_Nv:	0.62}');
    Error('\P{Is_Nv:	0.62}');
    Expect(1, 8541, '\p{Is_Nv=6.250e-01}', "");
    Expect(0, 8541, '\p{^Is_Nv=6.250e-01}', "");
    Expect(0, 8541, '\P{Is_Nv=6.250e-01}', "");
    Expect(1, 8541, '\P{^Is_Nv=6.250e-01}', "");
    Expect(0, 8542, '\p{Is_Nv=6.250e-01}', "");
    Expect(1, 8542, '\p{^Is_Nv=6.250e-01}', "");
    Expect(1, 8542, '\P{Is_Nv=6.250e-01}', "");
    Expect(0, 8542, '\P{^Is_Nv=6.250e-01}', "");
    Expect(1, 8541, '\p{Is_Nv=0.625}', "");
    Expect(0, 8541, '\p{^Is_Nv=0.625}', "");
    Expect(0, 8541, '\P{Is_Nv=0.625}', "");
    Expect(1, 8541, '\P{^Is_Nv=0.625}', "");
    Expect(0, 8542, '\p{Is_Nv=0.625}', "");
    Expect(1, 8542, '\p{^Is_Nv=0.625}', "");
    Expect(1, 8542, '\P{Is_Nv=0.625}', "");
    Expect(0, 8542, '\P{^Is_Nv=0.625}', "");
    Expect(1, 8541, '\p{Is_Nv=6.2500e-01}', "");
    Expect(0, 8541, '\p{^Is_Nv=6.2500e-01}', "");
    Expect(0, 8541, '\P{Is_Nv=6.2500e-01}', "");
    Expect(1, 8541, '\P{^Is_Nv=6.2500e-01}', "");
    Expect(0, 8542, '\p{Is_Nv=6.2500e-01}', "");
    Expect(1, 8542, '\p{^Is_Nv=6.2500e-01}', "");
    Expect(1, 8542, '\P{Is_Nv=6.2500e-01}', "");
    Expect(0, 8542, '\P{^Is_Nv=6.2500e-01}', "");
    Expect(1, 8541, '\p{Is_Nv=0.6250}', "");
    Expect(0, 8541, '\p{^Is_Nv=0.6250}', "");
    Expect(0, 8541, '\P{Is_Nv=0.6250}', "");
    Expect(1, 8541, '\P{^Is_Nv=0.6250}', "");
    Expect(0, 8542, '\p{Is_Nv=0.6250}', "");
    Expect(1, 8542, '\p{^Is_Nv=0.6250}', "");
    Expect(1, 8542, '\P{Is_Nv=0.6250}', "");
    Expect(0, 8542, '\P{^Is_Nv=0.6250}', "");
    Error('\p{Numeric_Value=	:=000050}');
    Error('\P{Numeric_Value=	:=000050}');
    Expect(1, 126222, '\p{Numeric_Value=:\A50\z:}', "");;
    Expect(0, 126223, '\p{Numeric_Value=:\A50\z:}', "");;
    Expect(1, 126222, '\p{Numeric_Value=0000000050}', "");
    Expect(0, 126222, '\p{^Numeric_Value=0000000050}', "");
    Expect(0, 126222, '\P{Numeric_Value=0000000050}', "");
    Expect(1, 126222, '\P{^Numeric_Value=0000000050}', "");
    Expect(0, 126223, '\p{Numeric_Value=0000000050}', "");
    Expect(1, 126223, '\p{^Numeric_Value=0000000050}', "");
    Expect(1, 126223, '\P{Numeric_Value=0000000050}', "");
    Expect(0, 126223, '\P{^Numeric_Value=0000000050}', "");
    Expect(1, 126222, '\p{Numeric_Value=5.000000000000000e+01}', "");
    Expect(0, 126222, '\p{^Numeric_Value=5.000000000000000e+01}', "");
    Expect(0, 126222, '\P{Numeric_Value=5.000000000000000e+01}', "");
    Expect(1, 126222, '\P{^Numeric_Value=5.000000000000000e+01}', "");
    Expect(0, 126223, '\p{Numeric_Value=5.000000000000000e+01}', "");
    Expect(1, 126223, '\p{^Numeric_Value=5.000000000000000e+01}', "");
    Expect(1, 126223, '\P{Numeric_Value=5.000000000000000e+01}', "");
    Expect(0, 126223, '\P{^Numeric_Value=5.000000000000000e+01}', "");
    Error('\p{Nv=		00050:=}');
    Error('\P{Nv=		00050:=}');
    Expect(1, 126222, '\p{Nv=:\A50\z:}', "");;
    Expect(0, 126223, '\p{Nv=:\A50\z:}', "");;
    Expect(1, 126222, '\p{Nv=000000050}', "");
    Expect(0, 126222, '\p{^Nv=000000050}', "");
    Expect(0, 126222, '\P{Nv=000000050}', "");
    Expect(1, 126222, '\P{^Nv=000000050}', "");
    Expect(0, 126223, '\p{Nv=000000050}', "");
    Expect(1, 126223, '\p{^Nv=000000050}', "");
    Expect(1, 126223, '\P{Nv=000000050}', "");
    Expect(0, 126223, '\P{^Nv=000000050}', "");
    Expect(1, 126222, '\p{Nv=5.000000000000000e+01}', "");
    Expect(0, 126222, '\p{^Nv=5.000000000000000e+01}', "");
    Expect(0, 126222, '\P{Nv=5.000000000000000e+01}', "");
    Expect(1, 126222, '\P{^Nv=5.000000000000000e+01}', "");
    Expect(0, 126223, '\p{Nv=5.000000000000000e+01}', "");
    Expect(1, 126223, '\p{^Nv=5.000000000000000e+01}', "");
    Expect(1, 126223, '\P{Nv=5.000000000000000e+01}', "");
    Expect(0, 126223, '\P{^Nv=5.000000000000000e+01}', "");
    Error('\p{Is_Numeric_Value=--000000050/a/}');
    Error('\P{Is_Numeric_Value=--000000050/a/}');
    Expect(1, 126222, '\p{Is_Numeric_Value=000050}', "");
    Expect(0, 126222, '\p{^Is_Numeric_Value=000050}', "");
    Expect(0, 126222, '\P{Is_Numeric_Value=000050}', "");
    Expect(1, 126222, '\P{^Is_Numeric_Value=000050}', "");
    Expect(0, 126223, '\p{Is_Numeric_Value=000050}', "");
    Expect(1, 126223, '\p{^Is_Numeric_Value=000050}', "");
    Expect(1, 126223, '\P{Is_Numeric_Value=000050}', "");
    Expect(0, 126223, '\P{^Is_Numeric_Value=000050}', "");
    Expect(1, 126222, '\p{Is_Numeric_Value=5.000000000000000e+01}', "");
    Expect(0, 126222, '\p{^Is_Numeric_Value=5.000000000000000e+01}', "");
    Expect(0, 126222, '\P{Is_Numeric_Value=5.000000000000000e+01}', "");
    Expect(1, 126222, '\P{^Is_Numeric_Value=5.000000000000000e+01}', "");
    Expect(0, 126223, '\p{Is_Numeric_Value=5.000000000000000e+01}', "");
    Expect(1, 126223, '\p{^Is_Numeric_Value=5.000000000000000e+01}', "");
    Expect(1, 126223, '\P{Is_Numeric_Value=5.000000000000000e+01}', "");
    Expect(0, 126223, '\P{^Is_Numeric_Value=5.000000000000000e+01}', "");
    Error('\p{Is_Nv= /a/00000000050}');
    Error('\P{Is_Nv= /a/00000000050}');
    Expect(1, 126222, '\p{Is_Nv=0000000050}', "");
    Expect(0, 126222, '\p{^Is_Nv=0000000050}', "");
    Expect(0, 126222, '\P{Is_Nv=0000000050}', "");
    Expect(1, 126222, '\P{^Is_Nv=0000000050}', "");
    Expect(0, 126223, '\p{Is_Nv=0000000050}', "");
    Expect(1, 126223, '\p{^Is_Nv=0000000050}', "");
    Expect(1, 126223, '\P{Is_Nv=0000000050}', "");
    Expect(0, 126223, '\P{^Is_Nv=0000000050}', "");
    Expect(1, 126222, '\p{Is_Nv:	5.000000000000000e+01}', "");
    Expect(0, 126222, '\p{^Is_Nv:	5.000000000000000e+01}', "");
    Expect(0, 126222, '\P{Is_Nv:	5.000000000000000e+01}', "");
    Expect(1, 126222, '\P{^Is_Nv:	5.000000000000000e+01}', "");
    Expect(0, 126223, '\p{Is_Nv:	5.000000000000000e+01}', "");
    Expect(1, 126223, '\p{^Is_Nv:	5.000000000000000e+01}', "");
    Expect(1, 126223, '\P{Is_Nv:	5.000000000000000e+01}', "");
    Expect(0, 126223, '\P{^Is_Nv:	5.000000000000000e+01}', "");
    Error('\p{Numeric_Value=_	00_00_00_05_00:=}');
    Error('\P{Numeric_Value=_	00_00_00_05_00:=}');
    Expect(1, 126231, '\p{Numeric_Value=:\A500\z:}', "");;
    Expect(0, 126232, '\p{Numeric_Value=:\A500\z:}', "");;
    Expect(1, 126231, '\p{Numeric_Value=+000_005_00}', "");
    Expect(0, 126231, '\p{^Numeric_Value=+000_005_00}', "");
    Expect(0, 126231, '\P{Numeric_Value=+000_005_00}', "");
    Expect(1, 126231, '\P{^Numeric_Value=+000_005_00}', "");
    Expect(0, 126232, '\p{Numeric_Value=+000_005_00}', "");
    Expect(1, 126232, '\p{^Numeric_Value=+000_005_00}', "");
    Expect(1, 126232, '\P{Numeric_Value=+000_005_00}', "");
    Expect(0, 126232, '\P{^Numeric_Value=+000_005_00}', "");
    Expect(1, 126231, '\p{Numeric_Value=5.000000000000000e+02}', "");
    Expect(0, 126231, '\p{^Numeric_Value=5.000000000000000e+02}', "");
    Expect(0, 126231, '\P{Numeric_Value=5.000000000000000e+02}', "");
    Expect(1, 126231, '\P{^Numeric_Value=5.000000000000000e+02}', "");
    Expect(0, 126232, '\p{Numeric_Value=5.000000000000000e+02}', "");
    Expect(1, 126232, '\p{^Numeric_Value=5.000000000000000e+02}', "");
    Expect(1, 126232, '\P{Numeric_Value=5.000000000000000e+02}', "");
    Expect(0, 126232, '\P{^Numeric_Value=5.000000000000000e+02}', "");
    Error('\p{Nv:	/a/+00000_00050_0}');
    Error('\P{Nv:	/a/+00000_00050_0}');
    Expect(1, 126231, '\p{Nv=:\A500\z:}', "");;
    Expect(0, 126232, '\p{Nv=:\A500\z:}', "");;
    Expect(1, 126231, '\p{Nv=00000500}', "");
    Expect(0, 126231, '\p{^Nv=00000500}', "");
    Expect(0, 126231, '\P{Nv=00000500}', "");
    Expect(1, 126231, '\P{^Nv=00000500}', "");
    Expect(0, 126232, '\p{Nv=00000500}', "");
    Expect(1, 126232, '\p{^Nv=00000500}', "");
    Expect(1, 126232, '\P{Nv=00000500}', "");
    Expect(0, 126232, '\P{^Nv=00000500}', "");
    Expect(1, 126231, '\p{Nv=5.000000000000000e+02}', "");
    Expect(0, 126231, '\p{^Nv=5.000000000000000e+02}', "");
    Expect(0, 126231, '\P{Nv=5.000000000000000e+02}', "");
    Expect(1, 126231, '\P{^Nv=5.000000000000000e+02}', "");
    Expect(0, 126232, '\p{Nv=5.000000000000000e+02}', "");
    Expect(1, 126232, '\p{^Nv=5.000000000000000e+02}', "");
    Expect(1, 126232, '\P{Nv=5.000000000000000e+02}', "");
    Expect(0, 126232, '\P{^Nv=5.000000000000000e+02}', "");
    Error('\p{Is_Numeric_Value=/a/ -0_0_0_0_5_00}');
    Error('\P{Is_Numeric_Value=/a/ -0_0_0_0_5_00}');
    Expect(1, 126231, '\p{Is_Numeric_Value=+0_5_00}', "");
    Expect(0, 126231, '\p{^Is_Numeric_Value=+0_5_00}', "");
    Expect(0, 126231, '\P{Is_Numeric_Value=+0_5_00}', "");
    Expect(1, 126231, '\P{^Is_Numeric_Value=+0_5_00}', "");
    Expect(0, 126232, '\p{Is_Numeric_Value=+0_5_00}', "");
    Expect(1, 126232, '\p{^Is_Numeric_Value=+0_5_00}', "");
    Expect(1, 126232, '\P{Is_Numeric_Value=+0_5_00}', "");
    Expect(0, 126232, '\P{^Is_Numeric_Value=+0_5_00}', "");
    Expect(1, 126231, '\p{Is_Numeric_Value=5.000000000000000e+02}', "");
    Expect(0, 126231, '\p{^Is_Numeric_Value=5.000000000000000e+02}', "");
    Expect(0, 126231, '\P{Is_Numeric_Value=5.000000000000000e+02}', "");
    Expect(1, 126231, '\P{^Is_Numeric_Value=5.000000000000000e+02}', "");
    Expect(0, 126232, '\p{Is_Numeric_Value=5.000000000000000e+02}', "");
    Expect(1, 126232, '\p{^Is_Numeric_Value=5.000000000000000e+02}', "");
    Expect(1, 126232, '\P{Is_Numeric_Value=5.000000000000000e+02}', "");
    Expect(0, 126232, '\P{^Is_Numeric_Value=5.000000000000000e+02}', "");
    Error('\p{Is_Nv=	:=+000_005_00}');
    Error('\P{Is_Nv=	:=+000_005_00}');
    Expect(1, 126231, '\p{Is_Nv=000000500}', "");
    Expect(0, 126231, '\p{^Is_Nv=000000500}', "");
    Expect(0, 126231, '\P{Is_Nv=000000500}', "");
    Expect(1, 126231, '\P{^Is_Nv=000000500}', "");
    Expect(0, 126232, '\p{Is_Nv=000000500}', "");
    Expect(1, 126232, '\p{^Is_Nv=000000500}', "");
    Expect(1, 126232, '\P{Is_Nv=000000500}', "");
    Expect(0, 126232, '\P{^Is_Nv=000000500}', "");
    Expect(1, 126231, '\p{Is_Nv=5.000000000000000e+02}', "");
    Expect(0, 126231, '\p{^Is_Nv=5.000000000000000e+02}', "");
    Expect(0, 126231, '\P{Is_Nv=5.000000000000000e+02}', "");
    Expect(1, 126231, '\P{^Is_Nv=5.000000000000000e+02}', "");
    Expect(0, 126232, '\p{Is_Nv=5.000000000000000e+02}', "");
    Expect(1, 126232, '\p{^Is_Nv=5.000000000000000e+02}', "");
    Expect(1, 126232, '\P{Is_Nv=5.000000000000000e+02}', "");
    Expect(0, 126232, '\P{^Is_Nv=5.000000000000000e+02}', "");
    Error('\p{Numeric_Value=/a/+000000005000}');
    Error('\P{Numeric_Value=/a/+000000005000}');
    Expect(1, 126240, '\p{Numeric_Value=:\A5000\z:}', "");;
    Expect(0, 126241, '\p{Numeric_Value=:\A5000\z:}', "");;
    Expect(1, 126240, '\p{Numeric_Value=00_05_00_0}', "");
    Expect(0, 126240, '\p{^Numeric_Value=00_05_00_0}', "");
    Expect(0, 126240, '\P{Numeric_Value=00_05_00_0}', "");
    Expect(1, 126240, '\P{^Numeric_Value=00_05_00_0}', "");
    Expect(0, 126241, '\p{Numeric_Value=00_05_00_0}', "");
    Expect(1, 126241, '\p{^Numeric_Value=00_05_00_0}', "");
    Expect(1, 126241, '\P{Numeric_Value=00_05_00_0}', "");
    Expect(0, 126241, '\P{^Numeric_Value=00_05_00_0}', "");
    Expect(1, 126240, '\p{Numeric_Value=5.000000000000000e+03}', "");
    Expect(0, 126240, '\p{^Numeric_Value=5.000000000000000e+03}', "");
    Expect(0, 126240, '\P{Numeric_Value=5.000000000000000e+03}', "");
    Expect(1, 126240, '\P{^Numeric_Value=5.000000000000000e+03}', "");
    Expect(0, 126241, '\p{Numeric_Value=5.000000000000000e+03}', "");
    Expect(1, 126241, '\p{^Numeric_Value=5.000000000000000e+03}', "");
    Expect(1, 126241, '\P{Numeric_Value=5.000000000000000e+03}', "");
    Expect(0, 126241, '\P{^Numeric_Value=5.000000000000000e+03}', "");
    Error('\p{Nv=	/a/0_5_0_00}');
    Error('\P{Nv=	/a/0_5_0_00}');
    Expect(1, 126240, '\p{Nv=:\A5000\z:}', "");;
    Expect(0, 126241, '\p{Nv=:\A5000\z:}', "");;
    Expect(1, 126240, '\p{Nv:	000005000}', "");
    Expect(0, 126240, '\p{^Nv:	000005000}', "");
    Expect(0, 126240, '\P{Nv:	000005000}', "");
    Expect(1, 126240, '\P{^Nv:	000005000}', "");
    Expect(0, 126241, '\p{Nv:	000005000}', "");
    Expect(1, 126241, '\p{^Nv:	000005000}', "");
    Expect(1, 126241, '\P{Nv:	000005000}', "");
    Expect(0, 126241, '\P{^Nv:	000005000}', "");
    Expect(1, 126240, '\p{Nv=5.000000000000000e+03}', "");
    Expect(0, 126240, '\p{^Nv=5.000000000000000e+03}', "");
    Expect(0, 126240, '\P{Nv=5.000000000000000e+03}', "");
    Expect(1, 126240, '\P{^Nv=5.000000000000000e+03}', "");
    Expect(0, 126241, '\p{Nv=5.000000000000000e+03}', "");
    Expect(1, 126241, '\p{^Nv=5.000000000000000e+03}', "");
    Expect(1, 126241, '\P{Nv=5.000000000000000e+03}', "");
    Expect(0, 126241, '\P{^Nv=5.000000000000000e+03}', "");
    Error('\p{Is_Numeric_Value=__000005000:=}');
    Error('\P{Is_Numeric_Value=__000005000:=}');
    Expect(1, 126240, '\p{Is_Numeric_Value: 000000005000}', "");
    Expect(0, 126240, '\p{^Is_Numeric_Value: 000000005000}', "");
    Expect(0, 126240, '\P{Is_Numeric_Value: 000000005000}', "");
    Expect(1, 126240, '\P{^Is_Numeric_Value: 000000005000}', "");
    Expect(0, 126241, '\p{Is_Numeric_Value: 000000005000}', "");
    Expect(1, 126241, '\p{^Is_Numeric_Value: 000000005000}', "");
    Expect(1, 126241, '\P{Is_Numeric_Value: 000000005000}', "");
    Expect(0, 126241, '\P{^Is_Numeric_Value: 000000005000}', "");
    Expect(1, 126240, '\p{Is_Numeric_Value=5.000000000000000e+03}', "");
    Expect(0, 126240, '\p{^Is_Numeric_Value=5.000000000000000e+03}', "");
    Expect(0, 126240, '\P{Is_Numeric_Value=5.000000000000000e+03}', "");
    Expect(1, 126240, '\P{^Is_Numeric_Value=5.000000000000000e+03}', "");
    Expect(0, 126241, '\p{Is_Numeric_Value=5.000000000000000e+03}', "");
    Expect(1, 126241, '\p{^Is_Numeric_Value=5.000000000000000e+03}', "");
    Expect(1, 126241, '\P{Is_Numeric_Value=5.000000000000000e+03}', "");
    Expect(0, 126241, '\P{^Is_Numeric_Value=5.000000000000000e+03}', "");
    Error('\p{Is_Nv: :=	0_0_0_0_0_0_5000}');
    Error('\P{Is_Nv: :=	0_0_0_0_0_0_5000}');
    Expect(1, 126240, '\p{Is_Nv=+005000}', "");
    Expect(0, 126240, '\p{^Is_Nv=+005000}', "");
    Expect(0, 126240, '\P{Is_Nv=+005000}', "");
    Expect(1, 126240, '\P{^Is_Nv=+005000}', "");
    Expect(0, 126241, '\p{Is_Nv=+005000}', "");
    Expect(1, 126241, '\p{^Is_Nv=+005000}', "");
    Expect(1, 126241, '\P{Is_Nv=+005000}', "");
    Expect(0, 126241, '\P{^Is_Nv=+005000}', "");
    Expect(1, 126240, '\p{Is_Nv=5.000000000000000e+03}', "");
    Expect(0, 126240, '\p{^Is_Nv=5.000000000000000e+03}', "");
    Expect(0, 126240, '\P{Is_Nv=5.000000000000000e+03}', "");
    Expect(1, 126240, '\P{^Is_Nv=5.000000000000000e+03}', "");
    Expect(0, 126241, '\p{Is_Nv=5.000000000000000e+03}', "");
    Expect(1, 126241, '\p{^Is_Nv=5.000000000000000e+03}', "");
    Expect(1, 126241, '\P{Is_Nv=5.000000000000000e+03}', "");
    Expect(0, 126241, '\P{^Is_Nv=5.000000000000000e+03}', "");
    Error('\p{Numeric_Value: :=	000000050000}');
    Error('\P{Numeric_Value: :=	000000050000}');
    Expect(1, 126249, '\p{Numeric_Value=:\A50000\z:}', "");;
    Expect(0, 126250, '\p{Numeric_Value=:\A50000\z:}', "");;
    Expect(1, 126249, '\p{Numeric_Value=0000000050000}', "");
    Expect(0, 126249, '\p{^Numeric_Value=0000000050000}', "");
    Expect(0, 126249, '\P{Numeric_Value=0000000050000}', "");
    Expect(1, 126249, '\P{^Numeric_Value=0000000050000}', "");
    Expect(0, 126250, '\p{Numeric_Value=0000000050000}', "");
    Expect(1, 126250, '\p{^Numeric_Value=0000000050000}', "");
    Expect(1, 126250, '\P{Numeric_Value=0000000050000}', "");
    Expect(0, 126250, '\P{^Numeric_Value=0000000050000}', "");
    Expect(1, 126249, '\p{Numeric_Value:   5.000000000000000e+04}', "");
    Expect(0, 126249, '\p{^Numeric_Value:   5.000000000000000e+04}', "");
    Expect(0, 126249, '\P{Numeric_Value:   5.000000000000000e+04}', "");
    Expect(1, 126249, '\P{^Numeric_Value:   5.000000000000000e+04}', "");
    Expect(0, 126250, '\p{Numeric_Value:   5.000000000000000e+04}', "");
    Expect(1, 126250, '\p{^Numeric_Value:   5.000000000000000e+04}', "");
    Expect(1, 126250, '\P{Numeric_Value:   5.000000000000000e+04}', "");
    Expect(0, 126250, '\P{^Numeric_Value:   5.000000000000000e+04}', "");
    Error('\p{Nv=_:=0000050000}');
    Error('\P{Nv=_:=0000050000}');
    Expect(1, 126249, '\p{Nv=:\A50000\z:}', "");;
    Expect(0, 126250, '\p{Nv=:\A50000\z:}', "");;
    Expect(1, 126249, '\p{Nv=000000050000}', "");
    Expect(0, 126249, '\p{^Nv=000000050000}', "");
    Expect(0, 126249, '\P{Nv=000000050000}', "");
    Expect(1, 126249, '\P{^Nv=000000050000}', "");
    Expect(0, 126250, '\p{Nv=000000050000}', "");
    Expect(1, 126250, '\p{^Nv=000000050000}', "");
    Expect(1, 126250, '\P{Nv=000000050000}', "");
    Expect(0, 126250, '\P{^Nv=000000050000}', "");
    Expect(1, 126249, '\p{Nv=5.000000000000000e+04}', "");
    Expect(0, 126249, '\p{^Nv=5.000000000000000e+04}', "");
    Expect(0, 126249, '\P{Nv=5.000000000000000e+04}', "");
    Expect(1, 126249, '\P{^Nv=5.000000000000000e+04}', "");
    Expect(0, 126250, '\p{Nv=5.000000000000000e+04}', "");
    Expect(1, 126250, '\p{^Nv=5.000000000000000e+04}', "");
    Expect(1, 126250, '\P{Nv=5.000000000000000e+04}', "");
    Expect(0, 126250, '\P{^Nv=5.000000000000000e+04}', "");
    Error('\p{Is_Numeric_Value=--00_05_00_00:=}');
    Error('\P{Is_Numeric_Value=--00_05_00_00:=}');
    Expect(1, 126249, '\p{Is_Numeric_Value=00050000}', "");
    Expect(0, 126249, '\p{^Is_Numeric_Value=00050000}', "");
    Expect(0, 126249, '\P{Is_Numeric_Value=00050000}', "");
    Expect(1, 126249, '\P{^Is_Numeric_Value=00050000}', "");
    Expect(0, 126250, '\p{Is_Numeric_Value=00050000}', "");
    Expect(1, 126250, '\p{^Is_Numeric_Value=00050000}', "");
    Expect(1, 126250, '\P{Is_Numeric_Value=00050000}', "");
    Expect(0, 126250, '\P{^Is_Numeric_Value=00050000}', "");
    Expect(1, 126249, '\p{Is_Numeric_Value=5.000000000000000e+04}', "");
    Expect(0, 126249, '\p{^Is_Numeric_Value=5.000000000000000e+04}', "");
    Expect(0, 126249, '\P{Is_Numeric_Value=5.000000000000000e+04}', "");
    Expect(1, 126249, '\P{^Is_Numeric_Value=5.000000000000000e+04}', "");
    Expect(0, 126250, '\p{Is_Numeric_Value=5.000000000000000e+04}', "");
    Expect(1, 126250, '\p{^Is_Numeric_Value=5.000000000000000e+04}', "");
    Expect(1, 126250, '\P{Is_Numeric_Value=5.000000000000000e+04}', "");
    Expect(0, 126250, '\P{^Is_Numeric_Value=5.000000000000000e+04}', "");
    Error('\p{Is_Nv=:=--+00000000050000}');
    Error('\P{Is_Nv=:=--+00000000050000}');
    Expect(1, 126249, '\p{Is_Nv:   00000000050000}', "");
    Expect(0, 126249, '\p{^Is_Nv:   00000000050000}', "");
    Expect(0, 126249, '\P{Is_Nv:   00000000050000}', "");
    Expect(1, 126249, '\P{^Is_Nv:   00000000050000}', "");
    Expect(0, 126250, '\p{Is_Nv:   00000000050000}', "");
    Expect(1, 126250, '\p{^Is_Nv:   00000000050000}', "");
    Expect(1, 126250, '\P{Is_Nv:   00000000050000}', "");
    Expect(0, 126250, '\P{^Is_Nv:   00000000050000}', "");
    Expect(1, 126249, '\p{Is_Nv=5.000000000000000e+04}', "");
    Expect(0, 126249, '\p{^Is_Nv=5.000000000000000e+04}', "");
    Expect(0, 126249, '\P{Is_Nv=5.000000000000000e+04}', "");
    Expect(1, 126249, '\P{^Is_Nv=5.000000000000000e+04}', "");
    Expect(0, 126250, '\p{Is_Nv=5.000000000000000e+04}', "");
    Expect(1, 126250, '\p{^Is_Nv=5.000000000000000e+04}', "");
    Expect(1, 126250, '\P{Is_Nv=5.000000000000000e+04}', "");
    Expect(0, 126250, '\P{^Is_Nv=5.000000000000000e+04}', "");
    Error('\p{Numeric_Value=	 00500000/a/}');
    Error('\P{Numeric_Value=	 00500000/a/}');
    Expect(1, 68081, '\p{Numeric_Value=:\A500000\z:}', "");;
    Expect(0, 68082, '\p{Numeric_Value=:\A500000\z:}', "");;
    Expect(1, 68081, '\p{Numeric_Value=00000500000}', "");
    Expect(0, 68081, '\p{^Numeric_Value=00000500000}', "");
    Expect(0, 68081, '\P{Numeric_Value=00000500000}', "");
    Expect(1, 68081, '\P{^Numeric_Value=00000500000}', "");
    Expect(0, 68082, '\p{Numeric_Value=00000500000}', "");
    Expect(1, 68082, '\p{^Numeric_Value=00000500000}', "");
    Expect(1, 68082, '\P{Numeric_Value=00000500000}', "");
    Expect(0, 68082, '\P{^Numeric_Value=00000500000}', "");
    Expect(1, 68081, '\p{Numeric_Value=5.000000000000000e+05}', "");
    Expect(0, 68081, '\p{^Numeric_Value=5.000000000000000e+05}', "");
    Expect(0, 68081, '\P{Numeric_Value=5.000000000000000e+05}', "");
    Expect(1, 68081, '\P{^Numeric_Value=5.000000000000000e+05}', "");
    Expect(0, 68082, '\p{Numeric_Value=5.000000000000000e+05}', "");
    Expect(1, 68082, '\p{^Numeric_Value=5.000000000000000e+05}', "");
    Expect(1, 68082, '\P{Numeric_Value=5.000000000000000e+05}', "");
    Expect(0, 68082, '\P{^Numeric_Value=5.000000000000000e+05}', "");
    Error('\p{Nv=:=_ 000000_005000_00}');
    Error('\P{Nv=:=_ 000000_005000_00}');
    Expect(1, 68081, '\p{Nv=:\A500000\z:}', "");;
    Expect(0, 68082, '\p{Nv=:\A500000\z:}', "");;
    Expect(1, 68081, '\p{Nv=+00000500000}', "");
    Expect(0, 68081, '\p{^Nv=+00000500000}', "");
    Expect(0, 68081, '\P{Nv=+00000500000}', "");
    Expect(1, 68081, '\P{^Nv=+00000500000}', "");
    Expect(0, 68082, '\p{Nv=+00000500000}', "");
    Expect(1, 68082, '\p{^Nv=+00000500000}', "");
    Expect(1, 68082, '\P{Nv=+00000500000}', "");
    Expect(0, 68082, '\P{^Nv=+00000500000}', "");
    Expect(1, 68081, '\p{Nv=5.000000000000000e+05}', "");
    Expect(0, 68081, '\p{^Nv=5.000000000000000e+05}', "");
    Expect(0, 68081, '\P{Nv=5.000000000000000e+05}', "");
    Expect(1, 68081, '\P{^Nv=5.000000000000000e+05}', "");
    Expect(0, 68082, '\p{Nv=5.000000000000000e+05}', "");
    Expect(1, 68082, '\p{^Nv=5.000000000000000e+05}', "");
    Expect(1, 68082, '\P{Nv=5.000000000000000e+05}', "");
    Expect(0, 68082, '\P{^Nv=5.000000000000000e+05}', "");
    Error('\p{Is_Numeric_Value=/a/ 500000}');
    Error('\P{Is_Numeric_Value=/a/ 500000}');
    Expect(1, 68081, '\p{Is_Numeric_Value:+000_000_005_000_00}', "");
    Expect(0, 68081, '\p{^Is_Numeric_Value:+000_000_005_000_00}', "");
    Expect(0, 68081, '\P{Is_Numeric_Value:+000_000_005_000_00}', "");
    Expect(1, 68081, '\P{^Is_Numeric_Value:+000_000_005_000_00}', "");
    Expect(0, 68082, '\p{Is_Numeric_Value:+000_000_005_000_00}', "");
    Expect(1, 68082, '\p{^Is_Numeric_Value:+000_000_005_000_00}', "");
    Expect(1, 68082, '\P{Is_Numeric_Value:+000_000_005_000_00}', "");
    Expect(0, 68082, '\P{^Is_Numeric_Value:+000_000_005_000_00}', "");
    Expect(1, 68081, '\p{Is_Numeric_Value=5.000000000000000e+05}', "");
    Expect(0, 68081, '\p{^Is_Numeric_Value=5.000000000000000e+05}', "");
    Expect(0, 68081, '\P{Is_Numeric_Value=5.000000000000000e+05}', "");
    Expect(1, 68081, '\P{^Is_Numeric_Value=5.000000000000000e+05}', "");
    Expect(0, 68082, '\p{Is_Numeric_Value=5.000000000000000e+05}', "");
    Expect(1, 68082, '\p{^Is_Numeric_Value=5.000000000000000e+05}', "");
    Expect(1, 68082, '\P{Is_Numeric_Value=5.000000000000000e+05}', "");
    Expect(0, 68082, '\P{^Is_Numeric_Value=5.000000000000000e+05}', "");
    Error('\p{Is_Nv= -500000/a/}');
    Error('\P{Is_Nv= -500000/a/}');
    Expect(1, 68081, '\p{Is_Nv=0000500000}', "");
    Expect(0, 68081, '\p{^Is_Nv=0000500000}', "");
    Expect(0, 68081, '\P{Is_Nv=0000500000}', "");
    Expect(1, 68081, '\P{^Is_Nv=0000500000}', "");
    Expect(0, 68082, '\p{Is_Nv=0000500000}', "");
    Expect(1, 68082, '\p{^Is_Nv=0000500000}', "");
    Expect(1, 68082, '\P{Is_Nv=0000500000}', "");
    Expect(0, 68082, '\P{^Is_Nv=0000500000}', "");
    Expect(1, 68081, '\p{Is_Nv:   5.000000000000000e+05}', "");
    Expect(0, 68081, '\p{^Is_Nv:   5.000000000000000e+05}', "");
    Expect(0, 68081, '\P{Is_Nv:   5.000000000000000e+05}', "");
    Expect(1, 68081, '\P{^Is_Nv:   5.000000000000000e+05}', "");
    Expect(0, 68082, '\p{Is_Nv:   5.000000000000000e+05}', "");
    Expect(1, 68082, '\p{^Is_Nv:   5.000000000000000e+05}', "");
    Expect(1, 68082, '\P{Is_Nv:   5.000000000000000e+05}', "");
    Expect(0, 68082, '\P{^Is_Nv:   5.000000000000000e+05}', "");
    Error('\p{Numeric_Value=6/a/}');
    Error('\P{Numeric_Value=6/a/}');
    Expect(1, 133866, '\p{Numeric_Value=:\A6\z:}', "");;
    Expect(0, 133867, '\p{Numeric_Value=:\A6\z:}', "");;
    Expect(1, 133866, '\p{Numeric_Value=+0_0_0_0_0_00006}', "");
    Expect(0, 133866, '\p{^Numeric_Value=+0_0_0_0_0_00006}', "");
    Expect(0, 133866, '\P{Numeric_Value=+0_0_0_0_0_00006}', "");
    Expect(1, 133866, '\P{^Numeric_Value=+0_0_0_0_0_00006}', "");
    Expect(0, 133867, '\p{Numeric_Value=+0_0_0_0_0_00006}', "");
    Expect(1, 133867, '\p{^Numeric_Value=+0_0_0_0_0_00006}', "");
    Expect(1, 133867, '\P{Numeric_Value=+0_0_0_0_0_00006}', "");
    Expect(0, 133867, '\P{^Numeric_Value=+0_0_0_0_0_00006}', "");
    Expect(1, 133866, '\p{Numeric_Value=6.000000000000000e+00}', "");
    Expect(0, 133866, '\p{^Numeric_Value=6.000000000000000e+00}', "");
    Expect(0, 133866, '\P{Numeric_Value=6.000000000000000e+00}', "");
    Expect(1, 133866, '\P{^Numeric_Value=6.000000000000000e+00}', "");
    Expect(0, 133867, '\p{Numeric_Value=6.000000000000000e+00}', "");
    Expect(1, 133867, '\p{^Numeric_Value=6.000000000000000e+00}', "");
    Expect(1, 133867, '\P{Numeric_Value=6.000000000000000e+00}', "");
    Expect(0, 133867, '\P{^Numeric_Value=6.000000000000000e+00}', "");
    Error('\p{Nv=-:=00_6}');
    Error('\P{Nv=-:=00_6}');
    Expect(1, 133866, '\p{Nv=:\A6\z:}', "");;
    Expect(0, 133867, '\p{Nv=:\A6\z:}', "");;
    Expect(1, 133866, '\p{Nv=+0_0_0_0_0006}', "");
    Expect(0, 133866, '\p{^Nv=+0_0_0_0_0006}', "");
    Expect(0, 133866, '\P{Nv=+0_0_0_0_0006}', "");
    Expect(1, 133866, '\P{^Nv=+0_0_0_0_0006}', "");
    Expect(0, 133867, '\p{Nv=+0_0_0_0_0006}', "");
    Expect(1, 133867, '\p{^Nv=+0_0_0_0_0006}', "");
    Expect(1, 133867, '\P{Nv=+0_0_0_0_0006}', "");
    Expect(0, 133867, '\P{^Nv=+0_0_0_0_0006}', "");
    Expect(1, 133866, '\p{Nv=6.000000000000000e+00}', "");
    Expect(0, 133866, '\p{^Nv=6.000000000000000e+00}', "");
    Expect(0, 133866, '\P{Nv=6.000000000000000e+00}', "");
    Expect(1, 133866, '\P{^Nv=6.000000000000000e+00}', "");
    Expect(0, 133867, '\p{Nv=6.000000000000000e+00}', "");
    Expect(1, 133867, '\p{^Nv=6.000000000000000e+00}', "");
    Expect(1, 133867, '\P{Nv=6.000000000000000e+00}', "");
    Expect(0, 133867, '\P{^Nv=6.000000000000000e+00}', "");
    Error('\p{Is_Numeric_Value=	+0_6:=}');
    Error('\P{Is_Numeric_Value=	+0_6:=}');
    Expect(1, 133866, '\p{Is_Numeric_Value=000000_6}', "");
    Expect(0, 133866, '\p{^Is_Numeric_Value=000000_6}', "");
    Expect(0, 133866, '\P{Is_Numeric_Value=000000_6}', "");
    Expect(1, 133866, '\P{^Is_Numeric_Value=000000_6}', "");
    Expect(0, 133867, '\p{Is_Numeric_Value=000000_6}', "");
    Expect(1, 133867, '\p{^Is_Numeric_Value=000000_6}', "");
    Expect(1, 133867, '\P{Is_Numeric_Value=000000_6}', "");
    Expect(0, 133867, '\P{^Is_Numeric_Value=000000_6}', "");
    Expect(1, 133866, '\p{Is_Numeric_Value=6.000000000000000e+00}', "");
    Expect(0, 133866, '\p{^Is_Numeric_Value=6.000000000000000e+00}', "");
    Expect(0, 133866, '\P{Is_Numeric_Value=6.000000000000000e+00}', "");
    Expect(1, 133866, '\P{^Is_Numeric_Value=6.000000000000000e+00}', "");
    Expect(0, 133867, '\p{Is_Numeric_Value=6.000000000000000e+00}', "");
    Expect(1, 133867, '\p{^Is_Numeric_Value=6.000000000000000e+00}', "");
    Expect(1, 133867, '\P{Is_Numeric_Value=6.000000000000000e+00}', "");
    Expect(0, 133867, '\P{^Is_Numeric_Value=6.000000000000000e+00}', "");
    Error('\p{Is_Nv=- 0_0_06/a/}');
    Error('\P{Is_Nv=- 0_0_06/a/}');
    Expect(1, 133866, '\p{Is_Nv=00_00_6}', "");
    Expect(0, 133866, '\p{^Is_Nv=00_00_6}', "");
    Expect(0, 133866, '\P{Is_Nv=00_00_6}', "");
    Expect(1, 133866, '\P{^Is_Nv=00_00_6}', "");
    Expect(0, 133867, '\p{Is_Nv=00_00_6}', "");
    Expect(1, 133867, '\p{^Is_Nv=00_00_6}', "");
    Expect(1, 133867, '\P{Is_Nv=00_00_6}', "");
    Expect(0, 133867, '\P{^Is_Nv=00_00_6}', "");
    Expect(1, 133866, '\p{Is_Nv=6.000000000000000e+00}', "");
    Expect(0, 133866, '\p{^Is_Nv=6.000000000000000e+00}', "");
    Expect(0, 133866, '\P{Is_Nv=6.000000000000000e+00}', "");
    Expect(1, 133866, '\P{^Is_Nv=6.000000000000000e+00}', "");
    Expect(0, 133867, '\p{Is_Nv=6.000000000000000e+00}', "");
    Expect(1, 133867, '\p{^Is_Nv=6.000000000000000e+00}', "");
    Expect(1, 133867, '\P{Is_Nv=6.000000000000000e+00}', "");
    Expect(0, 133867, '\P{^Is_Nv=6.000000000000000e+00}', "");
    Error('\p{Numeric_Value=	/a/00006_0}');
    Error('\P{Numeric_Value=	/a/00006_0}');
    Expect(1, 126223, '\p{Numeric_Value=:\A60\z:}', "");;
    Expect(0, 126224, '\p{Numeric_Value=:\A60\z:}', "");;
    Expect(1, 126223, '\p{Numeric_Value=00_00_60}', "");
    Expect(0, 126223, '\p{^Numeric_Value=00_00_60}', "");
    Expect(0, 126223, '\P{Numeric_Value=00_00_60}', "");
    Expect(1, 126223, '\P{^Numeric_Value=00_00_60}', "");
    Expect(0, 126224, '\p{Numeric_Value=00_00_60}', "");
    Expect(1, 126224, '\p{^Numeric_Value=00_00_60}', "");
    Expect(1, 126224, '\P{Numeric_Value=00_00_60}', "");
    Expect(0, 126224, '\P{^Numeric_Value=00_00_60}', "");
    Expect(1, 126223, '\p{Numeric_Value=6.000000000000000e+01}', "");
    Expect(0, 126223, '\p{^Numeric_Value=6.000000000000000e+01}', "");
    Expect(0, 126223, '\P{Numeric_Value=6.000000000000000e+01}', "");
    Expect(1, 126223, '\P{^Numeric_Value=6.000000000000000e+01}', "");
    Expect(0, 126224, '\p{Numeric_Value=6.000000000000000e+01}', "");
    Expect(1, 126224, '\p{^Numeric_Value=6.000000000000000e+01}', "");
    Expect(1, 126224, '\P{Numeric_Value=6.000000000000000e+01}', "");
    Expect(0, 126224, '\P{^Numeric_Value=6.000000000000000e+01}', "");
    Error('\p{Nv=	 +0000060:=}');
    Error('\P{Nv=	 +0000060:=}');
    Expect(1, 126223, '\p{Nv=:\A60\z:}', "");;
    Expect(0, 126224, '\p{Nv=:\A60\z:}', "");;
    Expect(1, 126223, '\p{Nv=0060}', "");
    Expect(0, 126223, '\p{^Nv=0060}', "");
    Expect(0, 126223, '\P{Nv=0060}', "");
    Expect(1, 126223, '\P{^Nv=0060}', "");
    Expect(0, 126224, '\p{Nv=0060}', "");
    Expect(1, 126224, '\p{^Nv=0060}', "");
    Expect(1, 126224, '\P{Nv=0060}', "");
    Expect(0, 126224, '\P{^Nv=0060}', "");
    Expect(1, 126223, '\p{Nv=6.000000000000000e+01}', "");
    Expect(0, 126223, '\p{^Nv=6.000000000000000e+01}', "");
    Expect(0, 126223, '\P{Nv=6.000000000000000e+01}', "");
    Expect(1, 126223, '\P{^Nv=6.000000000000000e+01}', "");
    Expect(0, 126224, '\p{Nv=6.000000000000000e+01}', "");
    Expect(1, 126224, '\p{^Nv=6.000000000000000e+01}', "");
    Expect(1, 126224, '\P{Nv=6.000000000000000e+01}', "");
    Expect(0, 126224, '\P{^Nv=6.000000000000000e+01}', "");
    Error('\p{Is_Numeric_Value= /a/00_00_60}');
    Error('\P{Is_Numeric_Value= /a/00_00_60}');
    Expect(1, 126223, '\p{Is_Numeric_Value=0006_0}', "");
    Expect(0, 126223, '\p{^Is_Numeric_Value=0006_0}', "");
    Expect(0, 126223, '\P{Is_Numeric_Value=0006_0}', "");
    Expect(1, 126223, '\P{^Is_Numeric_Value=0006_0}', "");
    Expect(0, 126224, '\p{Is_Numeric_Value=0006_0}', "");
    Expect(1, 126224, '\p{^Is_Numeric_Value=0006_0}', "");
    Expect(1, 126224, '\P{Is_Numeric_Value=0006_0}', "");
    Expect(0, 126224, '\P{^Is_Numeric_Value=0006_0}', "");
    Expect(1, 126223, '\p{Is_Numeric_Value=6.000000000000000e+01}', "");
    Expect(0, 126223, '\p{^Is_Numeric_Value=6.000000000000000e+01}', "");
    Expect(0, 126223, '\P{Is_Numeric_Value=6.000000000000000e+01}', "");
    Expect(1, 126223, '\P{^Is_Numeric_Value=6.000000000000000e+01}', "");
    Expect(0, 126224, '\p{Is_Numeric_Value=6.000000000000000e+01}', "");
    Expect(1, 126224, '\p{^Is_Numeric_Value=6.000000000000000e+01}', "");
    Expect(1, 126224, '\P{Is_Numeric_Value=6.000000000000000e+01}', "");
    Expect(0, 126224, '\P{^Is_Numeric_Value=6.000000000000000e+01}', "");
    Error('\p{Is_Nv=- +00_00_00_00_060/a/}');
    Error('\P{Is_Nv=- +00_00_00_00_060/a/}');
    Expect(1, 126223, '\p{Is_Nv=0_0_0_0_0_0_0_060}', "");
    Expect(0, 126223, '\p{^Is_Nv=0_0_0_0_0_0_0_060}', "");
    Expect(0, 126223, '\P{Is_Nv=0_0_0_0_0_0_0_060}', "");
    Expect(1, 126223, '\P{^Is_Nv=0_0_0_0_0_0_0_060}', "");
    Expect(0, 126224, '\p{Is_Nv=0_0_0_0_0_0_0_060}', "");
    Expect(1, 126224, '\p{^Is_Nv=0_0_0_0_0_0_0_060}', "");
    Expect(1, 126224, '\P{Is_Nv=0_0_0_0_0_0_0_060}', "");
    Expect(0, 126224, '\P{^Is_Nv=0_0_0_0_0_0_0_060}', "");
    Expect(1, 126223, '\p{Is_Nv=6.000000000000000e+01}', "");
    Expect(0, 126223, '\p{^Is_Nv=6.000000000000000e+01}', "");
    Expect(0, 126223, '\P{Is_Nv=6.000000000000000e+01}', "");
    Expect(1, 126223, '\P{^Is_Nv=6.000000000000000e+01}', "");
    Expect(0, 126224, '\p{Is_Nv=6.000000000000000e+01}', "");
    Expect(1, 126224, '\p{^Is_Nv=6.000000000000000e+01}', "");
    Expect(1, 126224, '\P{Is_Nv=6.000000000000000e+01}', "");
    Expect(0, 126224, '\P{^Is_Nv=6.000000000000000e+01}', "");
    Error('\p{Numeric_Value=--00_00_00_00_600/a/}');
    Error('\P{Numeric_Value=--00_00_00_00_600/a/}');
    Expect(1, 126265, '\p{Numeric_Value=:\A600\z:}', "");;
    Expect(0, 126266, '\p{Numeric_Value=:\A600\z:}', "");;
    Expect(1, 126265, '\p{Numeric_Value=0600}', "");
    Expect(0, 126265, '\p{^Numeric_Value=0600}', "");
    Expect(0, 126265, '\P{Numeric_Value=0600}', "");
    Expect(1, 126265, '\P{^Numeric_Value=0600}', "");
    Expect(0, 126266, '\p{Numeric_Value=0600}', "");
    Expect(1, 126266, '\p{^Numeric_Value=0600}', "");
    Expect(1, 126266, '\P{Numeric_Value=0600}', "");
    Expect(0, 126266, '\P{^Numeric_Value=0600}', "");
    Expect(1, 126265, '\p{Numeric_Value=6.000000000000000e+02}', "");
    Expect(0, 126265, '\p{^Numeric_Value=6.000000000000000e+02}', "");
    Expect(0, 126265, '\P{Numeric_Value=6.000000000000000e+02}', "");
    Expect(1, 126265, '\P{^Numeric_Value=6.000000000000000e+02}', "");
    Expect(0, 126266, '\p{Numeric_Value=6.000000000000000e+02}', "");
    Expect(1, 126266, '\p{^Numeric_Value=6.000000000000000e+02}', "");
    Expect(1, 126266, '\P{Numeric_Value=6.000000000000000e+02}', "");
    Expect(0, 126266, '\P{^Numeric_Value=6.000000000000000e+02}', "");
    Error('\p{Nv=/a/	 +0600}');
    Error('\P{Nv=/a/	 +0600}');
    Expect(1, 126265, '\p{Nv=:\A600\z:}', "");;
    Expect(0, 126266, '\p{Nv=:\A600\z:}', "");;
    Expect(1, 126265, '\p{Nv=0600}', "");
    Expect(0, 126265, '\p{^Nv=0600}', "");
    Expect(0, 126265, '\P{Nv=0600}', "");
    Expect(1, 126265, '\P{^Nv=0600}', "");
    Expect(0, 126266, '\p{Nv=0600}', "");
    Expect(1, 126266, '\p{^Nv=0600}', "");
    Expect(1, 126266, '\P{Nv=0600}', "");
    Expect(0, 126266, '\P{^Nv=0600}', "");
    Expect(1, 126265, '\p{Nv: 6.000000000000000e+02}', "");
    Expect(0, 126265, '\p{^Nv: 6.000000000000000e+02}', "");
    Expect(0, 126265, '\P{Nv: 6.000000000000000e+02}', "");
    Expect(1, 126265, '\P{^Nv: 6.000000000000000e+02}', "");
    Expect(0, 126266, '\p{Nv: 6.000000000000000e+02}', "");
    Expect(1, 126266, '\p{^Nv: 6.000000000000000e+02}', "");
    Expect(1, 126266, '\P{Nv: 6.000000000000000e+02}', "");
    Expect(0, 126266, '\P{^Nv: 6.000000000000000e+02}', "");
    Error('\p{Is_Numeric_Value=_0000600:=}');
    Error('\P{Is_Numeric_Value=_0000600:=}');
    Expect(1, 126265, '\p{Is_Numeric_Value=0000000600}', "");
    Expect(0, 126265, '\p{^Is_Numeric_Value=0000000600}', "");
    Expect(0, 126265, '\P{Is_Numeric_Value=0000000600}', "");
    Expect(1, 126265, '\P{^Is_Numeric_Value=0000000600}', "");
    Expect(0, 126266, '\p{Is_Numeric_Value=0000000600}', "");
    Expect(1, 126266, '\p{^Is_Numeric_Value=0000000600}', "");
    Expect(1, 126266, '\P{Is_Numeric_Value=0000000600}', "");
    Expect(0, 126266, '\P{^Is_Numeric_Value=0000000600}', "");
    Expect(1, 126265, '\p{Is_Numeric_Value:6.000000000000000e+02}', "");
    Expect(0, 126265, '\p{^Is_Numeric_Value:6.000000000000000e+02}', "");
    Expect(0, 126265, '\P{Is_Numeric_Value:6.000000000000000e+02}', "");
    Expect(1, 126265, '\P{^Is_Numeric_Value:6.000000000000000e+02}', "");
    Expect(0, 126266, '\p{Is_Numeric_Value:6.000000000000000e+02}', "");
    Expect(1, 126266, '\p{^Is_Numeric_Value:6.000000000000000e+02}', "");
    Expect(1, 126266, '\P{Is_Numeric_Value:6.000000000000000e+02}', "");
    Expect(0, 126266, '\P{^Is_Numeric_Value:6.000000000000000e+02}', "");
    Error('\p{Is_Nv=_:=0_0_0_6_00}');
    Error('\P{Is_Nv=_:=0_0_0_6_00}');
    Expect(1, 126265, '\p{Is_Nv=+00000600}', "");
    Expect(0, 126265, '\p{^Is_Nv=+00000600}', "");
    Expect(0, 126265, '\P{Is_Nv=+00000600}', "");
    Expect(1, 126265, '\P{^Is_Nv=+00000600}', "");
    Expect(0, 126266, '\p{Is_Nv=+00000600}', "");
    Expect(1, 126266, '\p{^Is_Nv=+00000600}', "");
    Expect(1, 126266, '\P{Is_Nv=+00000600}', "");
    Expect(0, 126266, '\P{^Is_Nv=+00000600}', "");
    Expect(1, 126265, '\p{Is_Nv=6.000000000000000e+02}', "");
    Expect(0, 126265, '\p{^Is_Nv=6.000000000000000e+02}', "");
    Expect(0, 126265, '\P{Is_Nv=6.000000000000000e+02}', "");
    Expect(1, 126265, '\P{^Is_Nv=6.000000000000000e+02}', "");
    Expect(0, 126266, '\p{Is_Nv=6.000000000000000e+02}', "");
    Expect(1, 126266, '\p{^Is_Nv=6.000000000000000e+02}', "");
    Expect(1, 126266, '\P{Is_Nv=6.000000000000000e+02}', "");
    Expect(0, 126266, '\P{^Is_Nv=6.000000000000000e+02}', "");
    Error('\p{Numeric_Value=--+0_0_0_0_0_0_0_0_0_6000:=}');
    Error('\P{Numeric_Value=--+0_0_0_0_0_0_0_0_0_6000:=}');
    Expect(1, 126241, '\p{Numeric_Value=:\A6000\z:}', "");;
    Expect(0, 126242, '\p{Numeric_Value=:\A6000\z:}', "");;
    Expect(1, 126241, '\p{Numeric_Value=0_0_0_0_6_0_00}', "");
    Expect(0, 126241, '\p{^Numeric_Value=0_0_0_0_6_0_00}', "");
    Expect(0, 126241, '\P{Numeric_Value=0_0_0_0_6_0_00}', "");
    Expect(1, 126241, '\P{^Numeric_Value=0_0_0_0_6_0_00}', "");
    Expect(0, 126242, '\p{Numeric_Value=0_0_0_0_6_0_00}', "");
    Expect(1, 126242, '\p{^Numeric_Value=0_0_0_0_6_0_00}', "");
    Expect(1, 126242, '\P{Numeric_Value=0_0_0_0_6_0_00}', "");
    Expect(0, 126242, '\P{^Numeric_Value=0_0_0_0_6_0_00}', "");
    Expect(1, 126241, '\p{Numeric_Value=6.000000000000000e+03}', "");
    Expect(0, 126241, '\p{^Numeric_Value=6.000000000000000e+03}', "");
    Expect(0, 126241, '\P{Numeric_Value=6.000000000000000e+03}', "");
    Expect(1, 126241, '\P{^Numeric_Value=6.000000000000000e+03}', "");
    Expect(0, 126242, '\p{Numeric_Value=6.000000000000000e+03}', "");
    Expect(1, 126242, '\p{^Numeric_Value=6.000000000000000e+03}', "");
    Expect(1, 126242, '\P{Numeric_Value=6.000000000000000e+03}', "");
    Expect(0, 126242, '\P{^Numeric_Value=6.000000000000000e+03}', "");
    Error('\p{Nv=/a/ -00000006000}');
    Error('\P{Nv=/a/ -00000006000}');
    Expect(1, 126241, '\p{Nv=:\A6000\z:}', "");;
    Expect(0, 126242, '\p{Nv=:\A6000\z:}', "");;
    Expect(1, 126241, '\p{Nv:	0000000006000}', "");
    Expect(0, 126241, '\p{^Nv:	0000000006000}', "");
    Expect(0, 126241, '\P{Nv:	0000000006000}', "");
    Expect(1, 126241, '\P{^Nv:	0000000006000}', "");
    Expect(0, 126242, '\p{Nv:	0000000006000}', "");
    Expect(1, 126242, '\p{^Nv:	0000000006000}', "");
    Expect(1, 126242, '\P{Nv:	0000000006000}', "");
    Expect(0, 126242, '\P{^Nv:	0000000006000}', "");
    Expect(1, 126241, '\p{Nv: 6.000000000000000e+03}', "");
    Expect(0, 126241, '\p{^Nv: 6.000000000000000e+03}', "");
    Expect(0, 126241, '\P{Nv: 6.000000000000000e+03}', "");
    Expect(1, 126241, '\P{^Nv: 6.000000000000000e+03}', "");
    Expect(0, 126242, '\p{Nv: 6.000000000000000e+03}', "");
    Expect(1, 126242, '\p{^Nv: 6.000000000000000e+03}', "");
    Expect(1, 126242, '\P{Nv: 6.000000000000000e+03}', "");
    Expect(0, 126242, '\P{^Nv: 6.000000000000000e+03}', "");
    Error('\p{Is_Numeric_Value=_	+000_000_006_000:=}');
    Error('\P{Is_Numeric_Value=_	+000_000_006_000:=}');
    Expect(1, 126241, '\p{Is_Numeric_Value=0000000006000}', "");
    Expect(0, 126241, '\p{^Is_Numeric_Value=0000000006000}', "");
    Expect(0, 126241, '\P{Is_Numeric_Value=0000000006000}', "");
    Expect(1, 126241, '\P{^Is_Numeric_Value=0000000006000}', "");
    Expect(0, 126242, '\p{Is_Numeric_Value=0000000006000}', "");
    Expect(1, 126242, '\p{^Is_Numeric_Value=0000000006000}', "");
    Expect(1, 126242, '\P{Is_Numeric_Value=0000000006000}', "");
    Expect(0, 126242, '\P{^Is_Numeric_Value=0000000006000}', "");
    Expect(1, 126241, '\p{Is_Numeric_Value=6.000000000000000e+03}', "");
    Expect(0, 126241, '\p{^Is_Numeric_Value=6.000000000000000e+03}', "");
    Expect(0, 126241, '\P{Is_Numeric_Value=6.000000000000000e+03}', "");
    Expect(1, 126241, '\P{^Is_Numeric_Value=6.000000000000000e+03}', "");
    Expect(0, 126242, '\p{Is_Numeric_Value=6.000000000000000e+03}', "");
    Expect(1, 126242, '\p{^Is_Numeric_Value=6.000000000000000e+03}', "");
    Expect(1, 126242, '\P{Is_Numeric_Value=6.000000000000000e+03}', "");
    Expect(0, 126242, '\P{^Is_Numeric_Value=6.000000000000000e+03}', "");
    Error('\p{Is_Nv=_-000000006000/a/}');
    Error('\P{Is_Nv=_-000000006000/a/}');
    Expect(1, 126241, '\p{Is_Nv=+0_0_0_0_0_0_0_0_0_6_000}', "");
    Expect(0, 126241, '\p{^Is_Nv=+0_0_0_0_0_0_0_0_0_6_000}', "");
    Expect(0, 126241, '\P{Is_Nv=+0_0_0_0_0_0_0_0_0_6_000}', "");
    Expect(1, 126241, '\P{^Is_Nv=+0_0_0_0_0_0_0_0_0_6_000}', "");
    Expect(0, 126242, '\p{Is_Nv=+0_0_0_0_0_0_0_0_0_6_000}', "");
    Expect(1, 126242, '\p{^Is_Nv=+0_0_0_0_0_0_0_0_0_6_000}', "");
    Expect(1, 126242, '\P{Is_Nv=+0_0_0_0_0_0_0_0_0_6_000}', "");
    Expect(0, 126242, '\P{^Is_Nv=+0_0_0_0_0_0_0_0_0_6_000}', "");
    Expect(1, 126241, '\p{Is_Nv=6.000000000000000e+03}', "");
    Expect(0, 126241, '\p{^Is_Nv=6.000000000000000e+03}', "");
    Expect(0, 126241, '\P{Is_Nv=6.000000000000000e+03}', "");
    Expect(1, 126241, '\P{^Is_Nv=6.000000000000000e+03}', "");
    Expect(0, 126242, '\p{Is_Nv=6.000000000000000e+03}', "");
    Expect(1, 126242, '\p{^Is_Nv=6.000000000000000e+03}', "");
    Expect(1, 126242, '\P{Is_Nv=6.000000000000000e+03}', "");
    Expect(0, 126242, '\P{^Is_Nv=6.000000000000000e+03}', "");
    Error('\p{Numeric_Value:  :=006000_0}');
    Error('\P{Numeric_Value:  :=006000_0}');
    Expect(1, 126250, '\p{Numeric_Value=:\A60000\z:}', "");;
    Expect(0, 126251, '\p{Numeric_Value=:\A60000\z:}', "");;
    Expect(1, 126250, '\p{Numeric_Value=60000}', "");
    Expect(0, 126250, '\p{^Numeric_Value=60000}', "");
    Expect(0, 126250, '\P{Numeric_Value=60000}', "");
    Expect(1, 126250, '\P{^Numeric_Value=60000}', "");
    Expect(0, 126251, '\p{Numeric_Value=60000}', "");
    Expect(1, 126251, '\p{^Numeric_Value=60000}', "");
    Expect(1, 126251, '\P{Numeric_Value=60000}', "");
    Expect(0, 126251, '\P{^Numeric_Value=60000}', "");
    Expect(1, 126250, '\p{Numeric_Value=6.000000000000000e+04}', "");
    Expect(0, 126250, '\p{^Numeric_Value=6.000000000000000e+04}', "");
    Expect(0, 126250, '\P{Numeric_Value=6.000000000000000e+04}', "");
    Expect(1, 126250, '\P{^Numeric_Value=6.000000000000000e+04}', "");
    Expect(0, 126251, '\p{Numeric_Value=6.000000000000000e+04}', "");
    Expect(1, 126251, '\p{^Numeric_Value=6.000000000000000e+04}', "");
    Expect(1, 126251, '\P{Numeric_Value=6.000000000000000e+04}', "");
    Expect(0, 126251, '\P{^Numeric_Value=6.000000000000000e+04}', "");
    Error('\p{Nv=:=	_0_0_0_6_0000}');
    Error('\P{Nv=:=	_0_0_0_6_0000}');
    Expect(1, 126250, '\p{Nv=:\A60000\z:}', "");;
    Expect(0, 126251, '\p{Nv=:\A60000\z:}', "");;
    Expect(1, 126250, '\p{Nv=6000_0}', "");
    Expect(0, 126250, '\p{^Nv=6000_0}', "");
    Expect(0, 126250, '\P{Nv=6000_0}', "");
    Expect(1, 126250, '\P{^Nv=6000_0}', "");
    Expect(0, 126251, '\p{Nv=6000_0}', "");
    Expect(1, 126251, '\p{^Nv=6000_0}', "");
    Expect(1, 126251, '\P{Nv=6000_0}', "");
    Expect(0, 126251, '\P{^Nv=6000_0}', "");
    Expect(1, 126250, '\p{Nv=6.000000000000000e+04}', "");
    Expect(0, 126250, '\p{^Nv=6.000000000000000e+04}', "");
    Expect(0, 126250, '\P{Nv=6.000000000000000e+04}', "");
    Expect(1, 126250, '\P{^Nv=6.000000000000000e+04}', "");
    Expect(0, 126251, '\p{Nv=6.000000000000000e+04}', "");
    Expect(1, 126251, '\p{^Nv=6.000000000000000e+04}', "");
    Expect(1, 126251, '\P{Nv=6.000000000000000e+04}', "");
    Expect(0, 126251, '\P{^Nv=6.000000000000000e+04}', "");
    Error('\p{Is_Numeric_Value=:=	_60000}');
    Error('\P{Is_Numeric_Value=:=	_60000}');
    Expect(1, 126250, '\p{Is_Numeric_Value=00_06_00_00}', "");
    Expect(0, 126250, '\p{^Is_Numeric_Value=00_06_00_00}', "");
    Expect(0, 126250, '\P{Is_Numeric_Value=00_06_00_00}', "");
    Expect(1, 126250, '\P{^Is_Numeric_Value=00_06_00_00}', "");
    Expect(0, 126251, '\p{Is_Numeric_Value=00_06_00_00}', "");
    Expect(1, 126251, '\p{^Is_Numeric_Value=00_06_00_00}', "");
    Expect(1, 126251, '\P{Is_Numeric_Value=00_06_00_00}', "");
    Expect(0, 126251, '\P{^Is_Numeric_Value=00_06_00_00}', "");
    Expect(1, 126250, '\p{Is_Numeric_Value=6.000000000000000e+04}', "");
    Expect(0, 126250, '\p{^Is_Numeric_Value=6.000000000000000e+04}', "");
    Expect(0, 126250, '\P{Is_Numeric_Value=6.000000000000000e+04}', "");
    Expect(1, 126250, '\P{^Is_Numeric_Value=6.000000000000000e+04}', "");
    Expect(0, 126251, '\p{Is_Numeric_Value=6.000000000000000e+04}', "");
    Expect(1, 126251, '\p{^Is_Numeric_Value=6.000000000000000e+04}', "");
    Expect(1, 126251, '\P{Is_Numeric_Value=6.000000000000000e+04}', "");
    Expect(0, 126251, '\P{^Is_Numeric_Value=6.000000000000000e+04}', "");
    Error('\p{Is_Nv=/a/_-0_0_6_0_000}');
    Error('\P{Is_Nv=/a/_-0_0_6_0_000}');
    Expect(1, 126250, '\p{Is_Nv=+000000060000}', "");
    Expect(0, 126250, '\p{^Is_Nv=+000000060000}', "");
    Expect(0, 126250, '\P{Is_Nv=+000000060000}', "");
    Expect(1, 126250, '\P{^Is_Nv=+000000060000}', "");
    Expect(0, 126251, '\p{Is_Nv=+000000060000}', "");
    Expect(1, 126251, '\p{^Is_Nv=+000000060000}', "");
    Expect(1, 126251, '\P{Is_Nv=+000000060000}', "");
    Expect(0, 126251, '\P{^Is_Nv=+000000060000}', "");
    Expect(1, 126250, '\p{Is_Nv=6.000000000000000e+04}', "");
    Expect(0, 126250, '\p{^Is_Nv=6.000000000000000e+04}', "");
    Expect(0, 126250, '\P{Is_Nv=6.000000000000000e+04}', "");
    Expect(1, 126250, '\P{^Is_Nv=6.000000000000000e+04}', "");
    Expect(0, 126251, '\p{Is_Nv=6.000000000000000e+04}', "");
    Expect(1, 126251, '\p{^Is_Nv=6.000000000000000e+04}', "");
    Expect(1, 126251, '\P{Is_Nv=6.000000000000000e+04}', "");
    Expect(0, 126251, '\P{^Is_Nv=6.000000000000000e+04}', "");
    Error('\p{Numeric_Value=-/a/00_60_00_00}');
    Error('\P{Numeric_Value=-/a/00_60_00_00}');
    Expect(1, 68082, '\p{Numeric_Value=:\A600000\z:}', "");;
    Expect(0, 68083, '\p{Numeric_Value=:\A600000\z:}', "");;
    Expect(1, 68082, '\p{Numeric_Value=00000600000}', "");
    Expect(0, 68082, '\p{^Numeric_Value=00000600000}', "");
    Expect(0, 68082, '\P{Numeric_Value=00000600000}', "");
    Expect(1, 68082, '\P{^Numeric_Value=00000600000}', "");
    Expect(0, 68083, '\p{Numeric_Value=00000600000}', "");
    Expect(1, 68083, '\p{^Numeric_Value=00000600000}', "");
    Expect(1, 68083, '\P{Numeric_Value=00000600000}', "");
    Expect(0, 68083, '\P{^Numeric_Value=00000600000}', "");
    Expect(1, 68082, '\p{Numeric_Value:6.000000000000000e+05}', "");
    Expect(0, 68082, '\p{^Numeric_Value:6.000000000000000e+05}', "");
    Expect(0, 68082, '\P{Numeric_Value:6.000000000000000e+05}', "");
    Expect(1, 68082, '\P{^Numeric_Value:6.000000000000000e+05}', "");
    Expect(0, 68083, '\p{Numeric_Value:6.000000000000000e+05}', "");
    Expect(1, 68083, '\p{^Numeric_Value:6.000000000000000e+05}', "");
    Expect(1, 68083, '\P{Numeric_Value:6.000000000000000e+05}', "");
    Expect(0, 68083, '\P{^Numeric_Value:6.000000000000000e+05}', "");
    Error('\p{Nv=:= _0000000600000}');
    Error('\P{Nv=:= _0000000600000}');
    Expect(1, 68082, '\p{Nv=:\A600000\z:}', "");;
    Expect(0, 68083, '\p{Nv=:\A600000\z:}', "");;
    Expect(1, 68082, '\p{Nv=+0000_6000_00}', "");
    Expect(0, 68082, '\p{^Nv=+0000_6000_00}', "");
    Expect(0, 68082, '\P{Nv=+0000_6000_00}', "");
    Expect(1, 68082, '\P{^Nv=+0000_6000_00}', "");
    Expect(0, 68083, '\p{Nv=+0000_6000_00}', "");
    Expect(1, 68083, '\p{^Nv=+0000_6000_00}', "");
    Expect(1, 68083, '\P{Nv=+0000_6000_00}', "");
    Expect(0, 68083, '\P{^Nv=+0000_6000_00}', "");
    Expect(1, 68082, '\p{Nv=6.000000000000000e+05}', "");
    Expect(0, 68082, '\p{^Nv=6.000000000000000e+05}', "");
    Expect(0, 68082, '\P{Nv=6.000000000000000e+05}', "");
    Expect(1, 68082, '\P{^Nv=6.000000000000000e+05}', "");
    Expect(0, 68083, '\p{Nv=6.000000000000000e+05}', "");
    Expect(1, 68083, '\p{^Nv=6.000000000000000e+05}', "");
    Expect(1, 68083, '\P{Nv=6.000000000000000e+05}', "");
    Expect(0, 68083, '\P{^Nv=6.000000000000000e+05}', "");
    Error('\p{Is_Numeric_Value=:=-+6_0_0_000}');
    Error('\P{Is_Numeric_Value=:=-+6_0_0_000}');
    Expect(1, 68082, '\p{Is_Numeric_Value:   000000600000}', "");
    Expect(0, 68082, '\p{^Is_Numeric_Value:   000000600000}', "");
    Expect(0, 68082, '\P{Is_Numeric_Value:   000000600000}', "");
    Expect(1, 68082, '\P{^Is_Numeric_Value:   000000600000}', "");
    Expect(0, 68083, '\p{Is_Numeric_Value:   000000600000}', "");
    Expect(1, 68083, '\p{^Is_Numeric_Value:   000000600000}', "");
    Expect(1, 68083, '\P{Is_Numeric_Value:   000000600000}', "");
    Expect(0, 68083, '\P{^Is_Numeric_Value:   000000600000}', "");
    Expect(1, 68082, '\p{Is_Numeric_Value=6.000000000000000e+05}', "");
    Expect(0, 68082, '\p{^Is_Numeric_Value=6.000000000000000e+05}', "");
    Expect(0, 68082, '\P{Is_Numeric_Value=6.000000000000000e+05}', "");
    Expect(1, 68082, '\P{^Is_Numeric_Value=6.000000000000000e+05}', "");
    Expect(0, 68083, '\p{Is_Numeric_Value=6.000000000000000e+05}', "");
    Expect(1, 68083, '\p{^Is_Numeric_Value=6.000000000000000e+05}', "");
    Expect(1, 68083, '\P{Is_Numeric_Value=6.000000000000000e+05}', "");
    Expect(0, 68083, '\P{^Is_Numeric_Value=6.000000000000000e+05}', "");
    Error('\p{Is_Nv=	/a/0_0_6_0_0000}');
    Error('\P{Is_Nv=	/a/0_0_6_0_0000}');
    Expect(1, 68082, '\p{Is_Nv=+000000000600000}', "");
    Expect(0, 68082, '\p{^Is_Nv=+000000000600000}', "");
    Expect(0, 68082, '\P{Is_Nv=+000000000600000}', "");
    Expect(1, 68082, '\P{^Is_Nv=+000000000600000}', "");
    Expect(0, 68083, '\p{Is_Nv=+000000000600000}', "");
    Expect(1, 68083, '\p{^Is_Nv=+000000000600000}', "");
    Expect(1, 68083, '\P{Is_Nv=+000000000600000}', "");
    Expect(0, 68083, '\P{^Is_Nv=+000000000600000}', "");
    Expect(1, 68082, '\p{Is_Nv=6.000000000000000e+05}', "");
    Expect(0, 68082, '\p{^Is_Nv=6.000000000000000e+05}', "");
    Expect(0, 68082, '\P{Is_Nv=6.000000000000000e+05}', "");
    Expect(1, 68082, '\P{^Is_Nv=6.000000000000000e+05}', "");
    Expect(0, 68083, '\p{Is_Nv=6.000000000000000e+05}', "");
    Expect(1, 68083, '\p{^Is_Nv=6.000000000000000e+05}', "");
    Expect(1, 68083, '\P{Is_Nv=6.000000000000000e+05}', "");
    Expect(0, 68083, '\P{^Is_Nv=6.000000000000000e+05}', "");
    Error('\p{Numeric_Value=/a/_	0000000007}');
    Error('\P{Numeric_Value=/a/_	0000000007}');
    Expect(1, 131073, '\p{Numeric_Value=:\A7\z:}', "");;
    Expect(0, 131074, '\p{Numeric_Value=:\A7\z:}', "");;
    Expect(1, 131073, '\p{Numeric_Value=0007}', "");
    Expect(0, 131073, '\p{^Numeric_Value=0007}', "");
    Expect(0, 131073, '\P{Numeric_Value=0007}', "");
    Expect(1, 131073, '\P{^Numeric_Value=0007}', "");
    Expect(0, 131074, '\p{Numeric_Value=0007}', "");
    Expect(1, 131074, '\p{^Numeric_Value=0007}', "");
    Expect(1, 131074, '\P{Numeric_Value=0007}', "");
    Expect(0, 131074, '\P{^Numeric_Value=0007}', "");
    Expect(1, 131073, '\p{Numeric_Value=7.000000000000000e+00}', "");
    Expect(0, 131073, '\p{^Numeric_Value=7.000000000000000e+00}', "");
    Expect(0, 131073, '\P{Numeric_Value=7.000000000000000e+00}', "");
    Expect(1, 131073, '\P{^Numeric_Value=7.000000000000000e+00}', "");
    Expect(0, 131074, '\p{Numeric_Value=7.000000000000000e+00}', "");
    Expect(1, 131074, '\p{^Numeric_Value=7.000000000000000e+00}', "");
    Expect(1, 131074, '\P{Numeric_Value=7.000000000000000e+00}', "");
    Expect(0, 131074, '\P{^Numeric_Value=7.000000000000000e+00}', "");
    Error('\p{Nv=	_0_0_0_0_07:=}');
    Error('\P{Nv=	_0_0_0_0_07:=}');
    Expect(1, 131073, '\p{Nv=:\A7\z:}', "");;
    Expect(0, 131074, '\p{Nv=:\A7\z:}', "");;
    Expect(1, 131073, '\p{Nv=0007}', "");
    Expect(0, 131073, '\p{^Nv=0007}', "");
    Expect(0, 131073, '\P{Nv=0007}', "");
    Expect(1, 131073, '\P{^Nv=0007}', "");
    Expect(0, 131074, '\p{Nv=0007}', "");
    Expect(1, 131074, '\p{^Nv=0007}', "");
    Expect(1, 131074, '\P{Nv=0007}', "");
    Expect(0, 131074, '\P{^Nv=0007}', "");
    Expect(1, 131073, '\p{Nv=7.000000000000000e+00}', "");
    Expect(0, 131073, '\p{^Nv=7.000000000000000e+00}', "");
    Expect(0, 131073, '\P{Nv=7.000000000000000e+00}', "");
    Expect(1, 131073, '\P{^Nv=7.000000000000000e+00}', "");
    Expect(0, 131074, '\p{Nv=7.000000000000000e+00}', "");
    Expect(1, 131074, '\p{^Nv=7.000000000000000e+00}', "");
    Expect(1, 131074, '\P{Nv=7.000000000000000e+00}', "");
    Expect(0, 131074, '\P{^Nv=7.000000000000000e+00}', "");
    Error('\p{Is_Numeric_Value=/a/0000007}');
    Error('\P{Is_Numeric_Value=/a/0000007}');
    Expect(1, 131073, '\p{Is_Numeric_Value=00000007}', "");
    Expect(0, 131073, '\p{^Is_Numeric_Value=00000007}', "");
    Expect(0, 131073, '\P{Is_Numeric_Value=00000007}', "");
    Expect(1, 131073, '\P{^Is_Numeric_Value=00000007}', "");
    Expect(0, 131074, '\p{Is_Numeric_Value=00000007}', "");
    Expect(1, 131074, '\p{^Is_Numeric_Value=00000007}', "");
    Expect(1, 131074, '\P{Is_Numeric_Value=00000007}', "");
    Expect(0, 131074, '\P{^Is_Numeric_Value=00000007}', "");
    Expect(1, 131073, '\p{Is_Numeric_Value=7.000000000000000e+00}', "");
    Expect(0, 131073, '\p{^Is_Numeric_Value=7.000000000000000e+00}', "");
    Expect(0, 131073, '\P{Is_Numeric_Value=7.000000000000000e+00}', "");
    Expect(1, 131073, '\P{^Is_Numeric_Value=7.000000000000000e+00}', "");
    Expect(0, 131074, '\p{Is_Numeric_Value=7.000000000000000e+00}', "");
    Expect(1, 131074, '\p{^Is_Numeric_Value=7.000000000000000e+00}', "");
    Expect(1, 131074, '\P{Is_Numeric_Value=7.000000000000000e+00}', "");
    Expect(0, 131074, '\P{^Is_Numeric_Value=7.000000000000000e+00}', "");
    Error('\p{Is_Nv=/a/- 000_000_7}');
    Error('\P{Is_Nv=/a/- 000_000_7}');
    Expect(1, 131073, '\p{Is_Nv=+000007}', "");
    Expect(0, 131073, '\p{^Is_Nv=+000007}', "");
    Expect(0, 131073, '\P{Is_Nv=+000007}', "");
    Expect(1, 131073, '\P{^Is_Nv=+000007}', "");
    Expect(0, 131074, '\p{Is_Nv=+000007}', "");
    Expect(1, 131074, '\p{^Is_Nv=+000007}', "");
    Expect(1, 131074, '\P{Is_Nv=+000007}', "");
    Expect(0, 131074, '\P{^Is_Nv=+000007}', "");
    Expect(1, 131073, '\p{Is_Nv=7.000000000000000e+00}', "");
    Expect(0, 131073, '\p{^Is_Nv=7.000000000000000e+00}', "");
    Expect(0, 131073, '\P{Is_Nv=7.000000000000000e+00}', "");
    Expect(1, 131073, '\P{^Is_Nv=7.000000000000000e+00}', "");
    Expect(0, 131074, '\p{Is_Nv=7.000000000000000e+00}', "");
    Expect(1, 131074, '\p{^Is_Nv=7.000000000000000e+00}', "");
    Expect(1, 131074, '\P{Is_Nv=7.000000000000000e+00}', "");
    Expect(0, 131074, '\P{^Is_Nv=7.000000000000000e+00}', "");
    Error('\p{Numeric_Value=:=	 +000007/0012}');
    Error('\P{Numeric_Value=:=	 +000007/0012}');
    Expect(1, 68092, '\p{Numeric_Value=:\A7/12\z:}', "");;
    Expect(0, 68093, '\p{Numeric_Value=:\A7/12\z:}', "");;
    Expect(1, 68092, '\p{Numeric_Value=0007/0000012}', "");
    Expect(0, 68092, '\p{^Numeric_Value=0007/0000012}', "");
    Expect(0, 68092, '\P{Numeric_Value=0007/0000012}', "");
    Expect(1, 68092, '\P{^Numeric_Value=0007/0000012}', "");
    Expect(0, 68093, '\p{Numeric_Value=0007/0000012}', "");
    Expect(1, 68093, '\p{^Numeric_Value=0007/0000012}', "");
    Expect(1, 68093, '\P{Numeric_Value=0007/0000012}', "");
    Expect(0, 68093, '\P{^Numeric_Value=0007/0000012}', "");
    Expect(1, 68092, '\p{Numeric_Value=420/720}', "");
    Expect(0, 68092, '\p{^Numeric_Value=420/720}', "");
    Expect(0, 68092, '\P{Numeric_Value=420/720}', "");
    Expect(1, 68092, '\P{^Numeric_Value=420/720}', "");
    Expect(0, 68093, '\p{Numeric_Value=420/720}', "");
    Expect(1, 68093, '\p{^Numeric_Value=420/720}', "");
    Expect(1, 68093, '\P{Numeric_Value=420/720}', "");
    Expect(0, 68093, '\P{^Numeric_Value=420/720}', "");
    Error('\p{Numeric_Value=5.8e-01}');
    Error('\P{Numeric_Value=5.8e-01}');
    Expect(1, 68092, '\p{Numeric_Value=5.83e-01}', "");
    Expect(0, 68092, '\p{^Numeric_Value=5.83e-01}', "");
    Expect(0, 68092, '\P{Numeric_Value=5.83e-01}', "");
    Expect(1, 68092, '\P{^Numeric_Value=5.83e-01}', "");
    Expect(0, 68093, '\p{Numeric_Value=5.83e-01}', "");
    Expect(1, 68093, '\p{^Numeric_Value=5.83e-01}', "");
    Expect(1, 68093, '\P{Numeric_Value=5.83e-01}', "");
    Expect(0, 68093, '\P{^Numeric_Value=5.83e-01}', "");
    Error('\p{Numeric_Value=0.58}');
    Error('\P{Numeric_Value=0.58}');
    Expect(1, 68092, '\p{Numeric_Value=5.833e-01}', "");
    Expect(0, 68092, '\p{^Numeric_Value=5.833e-01}', "");
    Expect(0, 68092, '\P{Numeric_Value=5.833e-01}', "");
    Expect(1, 68092, '\P{^Numeric_Value=5.833e-01}', "");
    Expect(0, 68093, '\p{Numeric_Value=5.833e-01}', "");
    Expect(1, 68093, '\p{^Numeric_Value=5.833e-01}', "");
    Expect(1, 68093, '\P{Numeric_Value=5.833e-01}', "");
    Expect(0, 68093, '\P{^Numeric_Value=5.833e-01}', "");
    Expect(1, 68092, '\p{Numeric_Value=0.583}', "");
    Expect(0, 68092, '\p{^Numeric_Value=0.583}', "");
    Expect(0, 68092, '\P{Numeric_Value=0.583}', "");
    Expect(1, 68092, '\P{^Numeric_Value=0.583}', "");
    Expect(0, 68093, '\p{Numeric_Value=0.583}', "");
    Expect(1, 68093, '\p{^Numeric_Value=0.583}', "");
    Expect(1, 68093, '\P{Numeric_Value=0.583}', "");
    Expect(0, 68093, '\P{^Numeric_Value=0.583}', "");
    Expect(1, 68092, '\p{Numeric_Value:5.8333e-01}', "");
    Expect(0, 68092, '\p{^Numeric_Value:5.8333e-01}', "");
    Expect(0, 68092, '\P{Numeric_Value:5.8333e-01}', "");
    Expect(1, 68092, '\P{^Numeric_Value:5.8333e-01}', "");
    Expect(0, 68093, '\p{Numeric_Value:5.8333e-01}', "");
    Expect(1, 68093, '\p{^Numeric_Value:5.8333e-01}', "");
    Expect(1, 68093, '\P{Numeric_Value:5.8333e-01}', "");
    Expect(0, 68093, '\P{^Numeric_Value:5.8333e-01}', "");
    Expect(1, 68092, '\p{Numeric_Value=0.5833}', "");
    Expect(0, 68092, '\p{^Numeric_Value=0.5833}', "");
    Expect(0, 68092, '\P{Numeric_Value=0.5833}', "");
    Expect(1, 68092, '\P{^Numeric_Value=0.5833}', "");
    Expect(0, 68093, '\p{Numeric_Value=0.5833}', "");
    Expect(1, 68093, '\p{^Numeric_Value=0.5833}', "");
    Expect(1, 68093, '\P{Numeric_Value=0.5833}', "");
    Expect(0, 68093, '\P{^Numeric_Value=0.5833}', "");
    Error('\p{Nv=-:=07/012}');
    Error('\P{Nv=-:=07/012}');
    Expect(1, 68092, '\p{Nv=:\A7/12\z:}', "");;
    Expect(0, 68093, '\p{Nv=:\A7/12\z:}', "");;
    Expect(1, 68092, '\p{Nv=07/00000012}', "");
    Expect(0, 68092, '\p{^Nv=07/00000012}', "");
    Expect(0, 68092, '\P{Nv=07/00000012}', "");
    Expect(1, 68092, '\P{^Nv=07/00000012}', "");
    Expect(0, 68093, '\p{Nv=07/00000012}', "");
    Expect(1, 68093, '\p{^Nv=07/00000012}', "");
    Expect(1, 68093, '\P{Nv=07/00000012}', "");
    Expect(0, 68093, '\P{^Nv=07/00000012}', "");
    Expect(1, 68092, '\p{Nv=420/720}', "");
    Expect(0, 68092, '\p{^Nv=420/720}', "");
    Expect(0, 68092, '\P{Nv=420/720}', "");
    Expect(1, 68092, '\P{^Nv=420/720}', "");
    Expect(0, 68093, '\p{Nv=420/720}', "");
    Expect(1, 68093, '\p{^Nv=420/720}', "");
    Expect(1, 68093, '\P{Nv=420/720}', "");
    Expect(0, 68093, '\P{^Nv=420/720}', "");
    Error('\p{Nv=5.8e-01}');
    Error('\P{Nv=5.8e-01}');
    Expect(1, 68092, '\p{Nv=5.83e-01}', "");
    Expect(0, 68092, '\p{^Nv=5.83e-01}', "");
    Expect(0, 68092, '\P{Nv=5.83e-01}', "");
    Expect(1, 68092, '\P{^Nv=5.83e-01}', "");
    Expect(0, 68093, '\p{Nv=5.83e-01}', "");
    Expect(1, 68093, '\p{^Nv=5.83e-01}', "");
    Expect(1, 68093, '\P{Nv=5.83e-01}', "");
    Expect(0, 68093, '\P{^Nv=5.83e-01}', "");
    Error('\p{Nv=0.58}');
    Error('\P{Nv=0.58}');
    Expect(1, 68092, '\p{Nv=5.833e-01}', "");
    Expect(0, 68092, '\p{^Nv=5.833e-01}', "");
    Expect(0, 68092, '\P{Nv=5.833e-01}', "");
    Expect(1, 68092, '\P{^Nv=5.833e-01}', "");
    Expect(0, 68093, '\p{Nv=5.833e-01}', "");
    Expect(1, 68093, '\p{^Nv=5.833e-01}', "");
    Expect(1, 68093, '\P{Nv=5.833e-01}', "");
    Expect(0, 68093, '\P{^Nv=5.833e-01}', "");
    Expect(1, 68092, '\p{Nv=0.583}', "");
    Expect(0, 68092, '\p{^Nv=0.583}', "");
    Expect(0, 68092, '\P{Nv=0.583}', "");
    Expect(1, 68092, '\P{^Nv=0.583}', "");
    Expect(0, 68093, '\p{Nv=0.583}', "");
    Expect(1, 68093, '\p{^Nv=0.583}', "");
    Expect(1, 68093, '\P{Nv=0.583}', "");
    Expect(0, 68093, '\P{^Nv=0.583}', "");
    Expect(1, 68092, '\p{Nv=5.8333e-01}', "");
    Expect(0, 68092, '\p{^Nv=5.8333e-01}', "");
    Expect(0, 68092, '\P{Nv=5.8333e-01}', "");
    Expect(1, 68092, '\P{^Nv=5.8333e-01}', "");
    Expect(0, 68093, '\p{Nv=5.8333e-01}', "");
    Expect(1, 68093, '\p{^Nv=5.8333e-01}', "");
    Expect(1, 68093, '\P{Nv=5.8333e-01}', "");
    Expect(0, 68093, '\P{^Nv=5.8333e-01}', "");
    Expect(1, 68092, '\p{Nv:   0.5833}', "");
    Expect(0, 68092, '\p{^Nv:   0.5833}', "");
    Expect(0, 68092, '\P{Nv:   0.5833}', "");
    Expect(1, 68092, '\P{^Nv:   0.5833}', "");
    Expect(0, 68093, '\p{Nv:   0.5833}', "");
    Expect(1, 68093, '\p{^Nv:   0.5833}', "");
    Expect(1, 68093, '\P{Nv:   0.5833}', "");
    Expect(0, 68093, '\P{^Nv:   0.5833}', "");
    Error('\p{Is_Numeric_Value= /a/0000000007/00000000012}');
    Error('\P{Is_Numeric_Value= /a/0000000007/00000000012}');
    Expect(1, 68092, '\p{Is_Numeric_Value=000007/000012}', "");
    Expect(0, 68092, '\p{^Is_Numeric_Value=000007/000012}', "");
    Expect(0, 68092, '\P{Is_Numeric_Value=000007/000012}', "");
    Expect(1, 68092, '\P{^Is_Numeric_Value=000007/000012}', "");
    Expect(0, 68093, '\p{Is_Numeric_Value=000007/000012}', "");
    Expect(1, 68093, '\p{^Is_Numeric_Value=000007/000012}', "");
    Expect(1, 68093, '\P{Is_Numeric_Value=000007/000012}', "");
    Expect(0, 68093, '\P{^Is_Numeric_Value=000007/000012}', "");
    Expect(1, 68092, '\p{Is_Numeric_Value=420/720}', "");
    Expect(0, 68092, '\p{^Is_Numeric_Value=420/720}', "");
    Expect(0, 68092, '\P{Is_Numeric_Value=420/720}', "");
    Expect(1, 68092, '\P{^Is_Numeric_Value=420/720}', "");
    Expect(0, 68093, '\p{Is_Numeric_Value=420/720}', "");
    Expect(1, 68093, '\p{^Is_Numeric_Value=420/720}', "");
    Expect(1, 68093, '\P{Is_Numeric_Value=420/720}', "");
    Expect(0, 68093, '\P{^Is_Numeric_Value=420/720}', "");
    Error('\p{Is_Numeric_Value=5.8e-01}');
    Error('\P{Is_Numeric_Value=5.8e-01}');
    Expect(1, 68092, '\p{Is_Numeric_Value=5.83e-01}', "");
    Expect(0, 68092, '\p{^Is_Numeric_Value=5.83e-01}', "");
    Expect(0, 68092, '\P{Is_Numeric_Value=5.83e-01}', "");
    Expect(1, 68092, '\P{^Is_Numeric_Value=5.83e-01}', "");
    Expect(0, 68093, '\p{Is_Numeric_Value=5.83e-01}', "");
    Expect(1, 68093, '\p{^Is_Numeric_Value=5.83e-01}', "");
    Expect(1, 68093, '\P{Is_Numeric_Value=5.83e-01}', "");
    Expect(0, 68093, '\P{^Is_Numeric_Value=5.83e-01}', "");
    Error('\p{Is_Numeric_Value=0.58}');
    Error('\P{Is_Numeric_Value=0.58}');
    Expect(1, 68092, '\p{Is_Numeric_Value=5.833e-01}', "");
    Expect(0, 68092, '\p{^Is_Numeric_Value=5.833e-01}', "");
    Expect(0, 68092, '\P{Is_Numeric_Value=5.833e-01}', "");
    Expect(1, 68092, '\P{^Is_Numeric_Value=5.833e-01}', "");
    Expect(0, 68093, '\p{Is_Numeric_Value=5.833e-01}', "");
    Expect(1, 68093, '\p{^Is_Numeric_Value=5.833e-01}', "");
    Expect(1, 68093, '\P{Is_Numeric_Value=5.833e-01}', "");
    Expect(0, 68093, '\P{^Is_Numeric_Value=5.833e-01}', "");
    Expect(1, 68092, '\p{Is_Numeric_Value=0.583}', "");
    Expect(0, 68092, '\p{^Is_Numeric_Value=0.583}', "");
    Expect(0, 68092, '\P{Is_Numeric_Value=0.583}', "");
    Expect(1, 68092, '\P{^Is_Numeric_Value=0.583}', "");
    Expect(0, 68093, '\p{Is_Numeric_Value=0.583}', "");
    Expect(1, 68093, '\p{^Is_Numeric_Value=0.583}', "");
    Expect(1, 68093, '\P{Is_Numeric_Value=0.583}', "");
    Expect(0, 68093, '\P{^Is_Numeric_Value=0.583}', "");
    Expect(1, 68092, '\p{Is_Numeric_Value=5.8333e-01}', "");
    Expect(0, 68092, '\p{^Is_Numeric_Value=5.8333e-01}', "");
    Expect(0, 68092, '\P{Is_Numeric_Value=5.8333e-01}', "");
    Expect(1, 68092, '\P{^Is_Numeric_Value=5.8333e-01}', "");
    Expect(0, 68093, '\p{Is_Numeric_Value=5.8333e-01}', "");
    Expect(1, 68093, '\p{^Is_Numeric_Value=5.8333e-01}', "");
    Expect(1, 68093, '\P{Is_Numeric_Value=5.8333e-01}', "");
    Expect(0, 68093, '\P{^Is_Numeric_Value=5.8333e-01}', "");
    Expect(1, 68092, '\p{Is_Numeric_Value=0.5833}', "");
    Expect(0, 68092, '\p{^Is_Numeric_Value=0.5833}', "");
    Expect(0, 68092, '\P{Is_Numeric_Value=0.5833}', "");
    Expect(1, 68092, '\P{^Is_Numeric_Value=0.5833}', "");
    Expect(0, 68093, '\p{Is_Numeric_Value=0.5833}', "");
    Expect(1, 68093, '\p{^Is_Numeric_Value=0.5833}', "");
    Expect(1, 68093, '\P{Is_Numeric_Value=0.5833}', "");
    Expect(0, 68093, '\P{^Is_Numeric_Value=0.5833}', "");
    Error('\p{Is_Nv=--00007/000000012/a/}');
    Error('\P{Is_Nv=--00007/000000012/a/}');
    Expect(1, 68092, '\p{Is_Nv=000007/00000012}', "");
    Expect(0, 68092, '\p{^Is_Nv=000007/00000012}', "");
    Expect(0, 68092, '\P{Is_Nv=000007/00000012}', "");
    Expect(1, 68092, '\P{^Is_Nv=000007/00000012}', "");
    Expect(0, 68093, '\p{Is_Nv=000007/00000012}', "");
    Expect(1, 68093, '\p{^Is_Nv=000007/00000012}', "");
    Expect(1, 68093, '\P{Is_Nv=000007/00000012}', "");
    Expect(0, 68093, '\P{^Is_Nv=000007/00000012}', "");
    Expect(1, 68092, '\p{Is_Nv=420/720}', "");
    Expect(0, 68092, '\p{^Is_Nv=420/720}', "");
    Expect(0, 68092, '\P{Is_Nv=420/720}', "");
    Expect(1, 68092, '\P{^Is_Nv=420/720}', "");
    Expect(0, 68093, '\p{Is_Nv=420/720}', "");
    Expect(1, 68093, '\p{^Is_Nv=420/720}', "");
    Expect(1, 68093, '\P{Is_Nv=420/720}', "");
    Expect(0, 68093, '\P{^Is_Nv=420/720}', "");
    Error('\p{Is_Nv=5.8e-01}');
    Error('\P{Is_Nv=5.8e-01}');
    Expect(1, 68092, '\p{Is_Nv=5.83e-01}', "");
    Expect(0, 68092, '\p{^Is_Nv=5.83e-01}', "");
    Expect(0, 68092, '\P{Is_Nv=5.83e-01}', "");
    Expect(1, 68092, '\P{^Is_Nv=5.83e-01}', "");
    Expect(0, 68093, '\p{Is_Nv=5.83e-01}', "");
    Expect(1, 68093, '\p{^Is_Nv=5.83e-01}', "");
    Expect(1, 68093, '\P{Is_Nv=5.83e-01}', "");
    Expect(0, 68093, '\P{^Is_Nv=5.83e-01}', "");
    Error('\p{Is_Nv=0.58}');
    Error('\P{Is_Nv=0.58}');
    Expect(1, 68092, '\p{Is_Nv=5.833e-01}', "");
    Expect(0, 68092, '\p{^Is_Nv=5.833e-01}', "");
    Expect(0, 68092, '\P{Is_Nv=5.833e-01}', "");
    Expect(1, 68092, '\P{^Is_Nv=5.833e-01}', "");
    Expect(0, 68093, '\p{Is_Nv=5.833e-01}', "");
    Expect(1, 68093, '\p{^Is_Nv=5.833e-01}', "");
    Expect(1, 68093, '\P{Is_Nv=5.833e-01}', "");
    Expect(0, 68093, '\P{^Is_Nv=5.833e-01}', "");
    Expect(1, 68092, '\p{Is_Nv=0.583}', "");
    Expect(0, 68092, '\p{^Is_Nv=0.583}', "");
    Expect(0, 68092, '\P{Is_Nv=0.583}', "");
    Expect(1, 68092, '\P{^Is_Nv=0.583}', "");
    Expect(0, 68093, '\p{Is_Nv=0.583}', "");
    Expect(1, 68093, '\p{^Is_Nv=0.583}', "");
    Expect(1, 68093, '\P{Is_Nv=0.583}', "");
    Expect(0, 68093, '\P{^Is_Nv=0.583}', "");
    Expect(1, 68092, '\p{Is_Nv=5.8333e-01}', "");
    Expect(0, 68092, '\p{^Is_Nv=5.8333e-01}', "");
    Expect(0, 68092, '\P{Is_Nv=5.8333e-01}', "");
    Expect(1, 68092, '\P{^Is_Nv=5.8333e-01}', "");
    Expect(0, 68093, '\p{Is_Nv=5.8333e-01}', "");
    Expect(1, 68093, '\p{^Is_Nv=5.8333e-01}', "");
    Expect(1, 68093, '\P{Is_Nv=5.8333e-01}', "");
    Expect(0, 68093, '\P{^Is_Nv=5.8333e-01}', "");
    Expect(1, 68092, '\p{Is_Nv:0.5833}', "");
    Expect(0, 68092, '\p{^Is_Nv:0.5833}', "");
    Expect(0, 68092, '\P{Is_Nv:0.5833}', "");
    Expect(1, 68092, '\P{^Is_Nv:0.5833}', "");
    Expect(0, 68093, '\p{Is_Nv:0.5833}', "");
    Expect(1, 68093, '\p{^Is_Nv:0.5833}', "");
    Expect(1, 68093, '\P{Is_Nv:0.5833}', "");
    Expect(0, 68093, '\P{^Is_Nv:0.5833}', "");
    Error('\p{Numeric_Value=:=7/02}');
    Error('\P{Numeric_Value=:=7/02}');
    Expect(1, 3885, '\p{Numeric_Value=:\A7/2\z:}', "");;
    Expect(0, 3886, '\p{Numeric_Value=:\A7/2\z:}', "");;
    Expect(1, 3885, '\p{Numeric_Value=0000007/00000002}', "");
    Expect(0, 3885, '\p{^Numeric_Value=0000007/00000002}', "");
    Expect(0, 3885, '\P{Numeric_Value=0000007/00000002}', "");
    Expect(1, 3885, '\P{^Numeric_Value=0000007/00000002}', "");
    Expect(0, 3886, '\p{Numeric_Value=0000007/00000002}', "");
    Expect(1, 3886, '\p{^Numeric_Value=0000007/00000002}', "");
    Expect(1, 3886, '\P{Numeric_Value=0000007/00000002}', "");
    Expect(0, 3886, '\P{^Numeric_Value=0000007/00000002}', "");
    Expect(1, 3885, '\p{Numeric_Value=420/120}', "");
    Expect(0, 3885, '\p{^Numeric_Value=420/120}', "");
    Expect(0, 3885, '\P{Numeric_Value=420/120}', "");
    Expect(1, 3885, '\P{^Numeric_Value=420/120}', "");
    Expect(0, 3886, '\p{Numeric_Value=420/120}', "");
    Expect(1, 3886, '\p{^Numeric_Value=420/120}', "");
    Expect(1, 3886, '\P{Numeric_Value=420/120}', "");
    Expect(0, 3886, '\P{^Numeric_Value=420/120}', "");
    Expect(1, 3885, '\p{Numeric_Value:	3.5e+00}', "");
    Expect(0, 3885, '\p{^Numeric_Value:	3.5e+00}', "");
    Expect(0, 3885, '\P{Numeric_Value:	3.5e+00}', "");
    Expect(1, 3885, '\P{^Numeric_Value:	3.5e+00}', "");
    Expect(0, 3886, '\p{Numeric_Value:	3.5e+00}', "");
    Expect(1, 3886, '\p{^Numeric_Value:	3.5e+00}', "");
    Expect(1, 3886, '\P{Numeric_Value:	3.5e+00}', "");
    Expect(0, 3886, '\P{^Numeric_Value:	3.5e+00}', "");
    Expect(1, 3885, '\p{Numeric_Value:3.5}', "");
    Expect(0, 3885, '\p{^Numeric_Value:3.5}', "");
    Expect(0, 3885, '\P{Numeric_Value:3.5}', "");
    Expect(1, 3885, '\P{^Numeric_Value:3.5}', "");
    Expect(0, 3886, '\p{Numeric_Value:3.5}', "");
    Expect(1, 3886, '\p{^Numeric_Value:3.5}', "");
    Expect(1, 3886, '\P{Numeric_Value:3.5}', "");
    Expect(0, 3886, '\P{^Numeric_Value:3.5}', "");
    Expect(1, 3885, '\p{Numeric_Value=3.50e+00}', "");
    Expect(0, 3885, '\p{^Numeric_Value=3.50e+00}', "");
    Expect(0, 3885, '\P{Numeric_Value=3.50e+00}', "");
    Expect(1, 3885, '\P{^Numeric_Value=3.50e+00}', "");
    Expect(0, 3886, '\p{Numeric_Value=3.50e+00}', "");
    Expect(1, 3886, '\p{^Numeric_Value=3.50e+00}', "");
    Expect(1, 3886, '\P{Numeric_Value=3.50e+00}', "");
    Expect(0, 3886, '\P{^Numeric_Value=3.50e+00}', "");
    Expect(1, 3885, '\p{Numeric_Value: 3.50}', "");
    Expect(0, 3885, '\p{^Numeric_Value: 3.50}', "");
    Expect(0, 3885, '\P{Numeric_Value: 3.50}', "");
    Expect(1, 3885, '\P{^Numeric_Value: 3.50}', "");
    Expect(0, 3886, '\p{Numeric_Value: 3.50}', "");
    Expect(1, 3886, '\p{^Numeric_Value: 3.50}', "");
    Expect(1, 3886, '\P{Numeric_Value: 3.50}', "");
    Expect(0, 3886, '\P{^Numeric_Value: 3.50}', "");
    Error('\p{Nv: /a/-+0000000007/00002}');
    Error('\P{Nv: /a/-+0000000007/00002}');
    Expect(1, 3885, '\p{Nv=:\A7/2\z:}', "");;
    Expect(0, 3886, '\p{Nv=:\A7/2\z:}', "");;
    Expect(1, 3885, '\p{Nv=0000007/00000002}', "");
    Expect(0, 3885, '\p{^Nv=0000007/00000002}', "");
    Expect(0, 3885, '\P{Nv=0000007/00000002}', "");
    Expect(1, 3885, '\P{^Nv=0000007/00000002}', "");
    Expect(0, 3886, '\p{Nv=0000007/00000002}', "");
    Expect(1, 3886, '\p{^Nv=0000007/00000002}', "");
    Expect(1, 3886, '\P{Nv=0000007/00000002}', "");
    Expect(0, 3886, '\P{^Nv=0000007/00000002}', "");
    Expect(1, 3885, '\p{Nv=420/120}', "");
    Expect(0, 3885, '\p{^Nv=420/120}', "");
    Expect(0, 3885, '\P{Nv=420/120}', "");
    Expect(1, 3885, '\P{^Nv=420/120}', "");
    Expect(0, 3886, '\p{Nv=420/120}', "");
    Expect(1, 3886, '\p{^Nv=420/120}', "");
    Expect(1, 3886, '\P{Nv=420/120}', "");
    Expect(0, 3886, '\P{^Nv=420/120}', "");
    Expect(1, 3885, '\p{Nv=3.5e+00}', "");
    Expect(0, 3885, '\p{^Nv=3.5e+00}', "");
    Expect(0, 3885, '\P{Nv=3.5e+00}', "");
    Expect(1, 3885, '\P{^Nv=3.5e+00}', "");
    Expect(0, 3886, '\p{Nv=3.5e+00}', "");
    Expect(1, 3886, '\p{^Nv=3.5e+00}', "");
    Expect(1, 3886, '\P{Nv=3.5e+00}', "");
    Expect(0, 3886, '\P{^Nv=3.5e+00}', "");
    Expect(1, 3885, '\p{Nv=3.5}', "");
    Expect(0, 3885, '\p{^Nv=3.5}', "");
    Expect(0, 3885, '\P{Nv=3.5}', "");
    Expect(1, 3885, '\P{^Nv=3.5}', "");
    Expect(0, 3886, '\p{Nv=3.5}', "");
    Expect(1, 3886, '\p{^Nv=3.5}', "");
    Expect(1, 3886, '\P{Nv=3.5}', "");
    Expect(0, 3886, '\P{^Nv=3.5}', "");
    Expect(1, 3885, '\p{Nv=3.50e+00}', "");
    Expect(0, 3885, '\p{^Nv=3.50e+00}', "");
    Expect(0, 3885, '\P{Nv=3.50e+00}', "");
    Expect(1, 3885, '\P{^Nv=3.50e+00}', "");
    Expect(0, 3886, '\p{Nv=3.50e+00}', "");
    Expect(1, 3886, '\p{^Nv=3.50e+00}', "");
    Expect(1, 3886, '\P{Nv=3.50e+00}', "");
    Expect(0, 3886, '\P{^Nv=3.50e+00}', "");
    Expect(1, 3885, '\p{Nv=3.50}', "");
    Expect(0, 3885, '\p{^Nv=3.50}', "");
    Expect(0, 3885, '\P{Nv=3.50}', "");
    Expect(1, 3885, '\P{^Nv=3.50}', "");
    Expect(0, 3886, '\p{Nv=3.50}', "");
    Expect(1, 3886, '\p{^Nv=3.50}', "");
    Expect(1, 3886, '\P{Nv=3.50}', "");
    Expect(0, 3886, '\P{^Nv=3.50}', "");
    Error('\p{Is_Numeric_Value=/a/-	0000000007/0000000002}');
    Error('\P{Is_Numeric_Value=/a/-	0000000007/0000000002}');
    Expect(1, 3885, '\p{Is_Numeric_Value: 07/0002}', "");
    Expect(0, 3885, '\p{^Is_Numeric_Value: 07/0002}', "");
    Expect(0, 3885, '\P{Is_Numeric_Value: 07/0002}', "");
    Expect(1, 3885, '\P{^Is_Numeric_Value: 07/0002}', "");
    Expect(0, 3886, '\p{Is_Numeric_Value: 07/0002}', "");
    Expect(1, 3886, '\p{^Is_Numeric_Value: 07/0002}', "");
    Expect(1, 3886, '\P{Is_Numeric_Value: 07/0002}', "");
    Expect(0, 3886, '\P{^Is_Numeric_Value: 07/0002}', "");
    Expect(1, 3885, '\p{Is_Numeric_Value=420/120}', "");
    Expect(0, 3885, '\p{^Is_Numeric_Value=420/120}', "");
    Expect(0, 3885, '\P{Is_Numeric_Value=420/120}', "");
    Expect(1, 3885, '\P{^Is_Numeric_Value=420/120}', "");
    Expect(0, 3886, '\p{Is_Numeric_Value=420/120}', "");
    Expect(1, 3886, '\p{^Is_Numeric_Value=420/120}', "");
    Expect(1, 3886, '\P{Is_Numeric_Value=420/120}', "");
    Expect(0, 3886, '\P{^Is_Numeric_Value=420/120}', "");
    Expect(1, 3885, '\p{Is_Numeric_Value=3.5e+00}', "");
    Expect(0, 3885, '\p{^Is_Numeric_Value=3.5e+00}', "");
    Expect(0, 3885, '\P{Is_Numeric_Value=3.5e+00}', "");
    Expect(1, 3885, '\P{^Is_Numeric_Value=3.5e+00}', "");
    Expect(0, 3886, '\p{Is_Numeric_Value=3.5e+00}', "");
    Expect(1, 3886, '\p{^Is_Numeric_Value=3.5e+00}', "");
    Expect(1, 3886, '\P{Is_Numeric_Value=3.5e+00}', "");
    Expect(0, 3886, '\P{^Is_Numeric_Value=3.5e+00}', "");
    Expect(1, 3885, '\p{Is_Numeric_Value=3.5}', "");
    Expect(0, 3885, '\p{^Is_Numeric_Value=3.5}', "");
    Expect(0, 3885, '\P{Is_Numeric_Value=3.5}', "");
    Expect(1, 3885, '\P{^Is_Numeric_Value=3.5}', "");
    Expect(0, 3886, '\p{Is_Numeric_Value=3.5}', "");
    Expect(1, 3886, '\p{^Is_Numeric_Value=3.5}', "");
    Expect(1, 3886, '\P{Is_Numeric_Value=3.5}', "");
    Expect(0, 3886, '\P{^Is_Numeric_Value=3.5}', "");
    Expect(1, 3885, '\p{Is_Numeric_Value=3.50e+00}', "");
    Expect(0, 3885, '\p{^Is_Numeric_Value=3.50e+00}', "");
    Expect(0, 3885, '\P{Is_Numeric_Value=3.50e+00}', "");
    Expect(1, 3885, '\P{^Is_Numeric_Value=3.50e+00}', "");
    Expect(0, 3886, '\p{Is_Numeric_Value=3.50e+00}', "");
    Expect(1, 3886, '\p{^Is_Numeric_Value=3.50e+00}', "");
    Expect(1, 3886, '\P{Is_Numeric_Value=3.50e+00}', "");
    Expect(0, 3886, '\P{^Is_Numeric_Value=3.50e+00}', "");
    Expect(1, 3885, '\p{Is_Numeric_Value=3.50}', "");
    Expect(0, 3885, '\p{^Is_Numeric_Value=3.50}', "");
    Expect(0, 3885, '\P{Is_Numeric_Value=3.50}', "");
    Expect(1, 3885, '\P{^Is_Numeric_Value=3.50}', "");
    Expect(0, 3886, '\p{Is_Numeric_Value=3.50}', "");
    Expect(1, 3886, '\p{^Is_Numeric_Value=3.50}', "");
    Expect(1, 3886, '\P{Is_Numeric_Value=3.50}', "");
    Expect(0, 3886, '\P{^Is_Numeric_Value=3.50}', "");
    Error('\p{Is_Nv= :=7/00002}');
    Error('\P{Is_Nv= :=7/00002}');
    Expect(1, 3885, '\p{Is_Nv=000000007/0000000002}', "");
    Expect(0, 3885, '\p{^Is_Nv=000000007/0000000002}', "");
    Expect(0, 3885, '\P{Is_Nv=000000007/0000000002}', "");
    Expect(1, 3885, '\P{^Is_Nv=000000007/0000000002}', "");
    Expect(0, 3886, '\p{Is_Nv=000000007/0000000002}', "");
    Expect(1, 3886, '\p{^Is_Nv=000000007/0000000002}', "");
    Expect(1, 3886, '\P{Is_Nv=000000007/0000000002}', "");
    Expect(0, 3886, '\P{^Is_Nv=000000007/0000000002}', "");
    Expect(1, 3885, '\p{Is_Nv:	420/120}', "");
    Expect(0, 3885, '\p{^Is_Nv:	420/120}', "");
    Expect(0, 3885, '\P{Is_Nv:	420/120}', "");
    Expect(1, 3885, '\P{^Is_Nv:	420/120}', "");
    Expect(0, 3886, '\p{Is_Nv:	420/120}', "");
    Expect(1, 3886, '\p{^Is_Nv:	420/120}', "");
    Expect(1, 3886, '\P{Is_Nv:	420/120}', "");
    Expect(0, 3886, '\P{^Is_Nv:	420/120}', "");
    Expect(1, 3885, '\p{Is_Nv=3.5e+00}', "");
    Expect(0, 3885, '\p{^Is_Nv=3.5e+00}', "");
    Expect(0, 3885, '\P{Is_Nv=3.5e+00}', "");
    Expect(1, 3885, '\P{^Is_Nv=3.5e+00}', "");
    Expect(0, 3886, '\p{Is_Nv=3.5e+00}', "");
    Expect(1, 3886, '\p{^Is_Nv=3.5e+00}', "");
    Expect(1, 3886, '\P{Is_Nv=3.5e+00}', "");
    Expect(0, 3886, '\P{^Is_Nv=3.5e+00}', "");
    Expect(1, 3885, '\p{Is_Nv=3.5}', "");
    Expect(0, 3885, '\p{^Is_Nv=3.5}', "");
    Expect(0, 3885, '\P{Is_Nv=3.5}', "");
    Expect(1, 3885, '\P{^Is_Nv=3.5}', "");
    Expect(0, 3886, '\p{Is_Nv=3.5}', "");
    Expect(1, 3886, '\p{^Is_Nv=3.5}', "");
    Expect(1, 3886, '\P{Is_Nv=3.5}', "");
    Expect(0, 3886, '\P{^Is_Nv=3.5}', "");
    Expect(1, 3885, '\p{Is_Nv=3.50e+00}', "");
    Expect(0, 3885, '\p{^Is_Nv=3.50e+00}', "");
    Expect(0, 3885, '\P{Is_Nv=3.50e+00}', "");
    Expect(1, 3885, '\P{^Is_Nv=3.50e+00}', "");
    Expect(0, 3886, '\p{Is_Nv=3.50e+00}', "");
    Expect(1, 3886, '\p{^Is_Nv=3.50e+00}', "");
    Expect(1, 3886, '\P{Is_Nv=3.50e+00}', "");
    Expect(0, 3886, '\P{^Is_Nv=3.50e+00}', "");
    Expect(1, 3885, '\p{Is_Nv=3.50}', "");
    Expect(0, 3885, '\p{^Is_Nv=3.50}', "");
    Expect(0, 3885, '\P{Is_Nv=3.50}', "");
    Expect(1, 3885, '\P{^Is_Nv=3.50}', "");
    Expect(0, 3886, '\p{Is_Nv=3.50}', "");
    Expect(1, 3886, '\p{^Is_Nv=3.50}', "");
    Expect(1, 3886, '\P{Is_Nv=3.50}', "");
    Expect(0, 3886, '\P{^Is_Nv=3.50}', "");
    Error('\p{Numeric_Value=/a/ -000000007/000000008}');
    Error('\P{Numeric_Value=/a/ -000000007/000000008}');
    Expect(1, 8542, '\p{Numeric_Value=:\A7/8\z:}', "");;
    Expect(0, 8543, '\p{Numeric_Value=:\A7/8\z:}', "");;
    Expect(1, 8542, '\p{Numeric_Value=7/08}', "");
    Expect(0, 8542, '\p{^Numeric_Value=7/08}', "");
    Expect(0, 8542, '\P{Numeric_Value=7/08}', "");
    Expect(1, 8542, '\P{^Numeric_Value=7/08}', "");
    Expect(0, 8543, '\p{Numeric_Value=7/08}', "");
    Expect(1, 8543, '\p{^Numeric_Value=7/08}', "");
    Expect(1, 8543, '\P{Numeric_Value=7/08}', "");
    Expect(0, 8543, '\P{^Numeric_Value=7/08}', "");
    Expect(1, 8542, '\p{Numeric_Value=420/480}', "");
    Expect(0, 8542, '\p{^Numeric_Value=420/480}', "");
    Expect(0, 8542, '\P{Numeric_Value=420/480}', "");
    Expect(1, 8542, '\P{^Numeric_Value=420/480}', "");
    Expect(0, 8543, '\p{Numeric_Value=420/480}', "");
    Expect(1, 8543, '\p{^Numeric_Value=420/480}', "");
    Expect(1, 8543, '\P{Numeric_Value=420/480}', "");
    Expect(0, 8543, '\P{^Numeric_Value=420/480}', "");
    Error('\p{Numeric_Value=8.8e-01}');
    Error('\P{Numeric_Value=8.8e-01}');
    Error('\p{Numeric_Value=0.9}');
    Error('\P{Numeric_Value=0.9}');
    Expect(1, 8542, '\p{Numeric_Value:8.75e-01}', "");
    Expect(0, 8542, '\p{^Numeric_Value:8.75e-01}', "");
    Expect(0, 8542, '\P{Numeric_Value:8.75e-01}', "");
    Expect(1, 8542, '\P{^Numeric_Value:8.75e-01}', "");
    Expect(0, 8543, '\p{Numeric_Value:8.75e-01}', "");
    Expect(1, 8543, '\p{^Numeric_Value:8.75e-01}', "");
    Expect(1, 8543, '\P{Numeric_Value:8.75e-01}', "");
    Expect(0, 8543, '\P{^Numeric_Value:8.75e-01}', "");
    Error('\p{Numeric_Value=0.88}');
    Error('\P{Numeric_Value=0.88}');
    Expect(1, 8542, '\p{Numeric_Value=8.750e-01}', "");
    Expect(0, 8542, '\p{^Numeric_Value=8.750e-01}', "");
    Expect(0, 8542, '\P{Numeric_Value=8.750e-01}', "");
    Expect(1, 8542, '\P{^Numeric_Value=8.750e-01}', "");
    Expect(0, 8543, '\p{Numeric_Value=8.750e-01}', "");
    Expect(1, 8543, '\p{^Numeric_Value=8.750e-01}', "");
    Expect(1, 8543, '\P{Numeric_Value=8.750e-01}', "");
    Expect(0, 8543, '\P{^Numeric_Value=8.750e-01}', "");
    Expect(1, 8542, '\p{Numeric_Value=0.875}', "");
    Expect(0, 8542, '\p{^Numeric_Value=0.875}', "");
    Expect(0, 8542, '\P{Numeric_Value=0.875}', "");
    Expect(1, 8542, '\P{^Numeric_Value=0.875}', "");
    Expect(0, 8543, '\p{Numeric_Value=0.875}', "");
    Expect(1, 8543, '\p{^Numeric_Value=0.875}', "");
    Expect(1, 8543, '\P{Numeric_Value=0.875}', "");
    Expect(0, 8543, '\P{^Numeric_Value=0.875}', "");
    Expect(1, 8542, '\p{Numeric_Value=8.7500e-01}', "");
    Expect(0, 8542, '\p{^Numeric_Value=8.7500e-01}', "");
    Expect(0, 8542, '\P{Numeric_Value=8.7500e-01}', "");
    Expect(1, 8542, '\P{^Numeric_Value=8.7500e-01}', "");
    Expect(0, 8543, '\p{Numeric_Value=8.7500e-01}', "");
    Expect(1, 8543, '\p{^Numeric_Value=8.7500e-01}', "");
    Expect(1, 8543, '\P{Numeric_Value=8.7500e-01}', "");
    Expect(0, 8543, '\P{^Numeric_Value=8.7500e-01}', "");
    Expect(1, 8542, '\p{Numeric_Value=0.8750}', "");
    Expect(0, 8542, '\p{^Numeric_Value=0.8750}', "");
    Expect(0, 8542, '\P{Numeric_Value=0.8750}', "");
    Expect(1, 8542, '\P{^Numeric_Value=0.8750}', "");
    Expect(0, 8543, '\p{Numeric_Value=0.8750}', "");
    Expect(1, 8543, '\p{^Numeric_Value=0.8750}', "");
    Expect(1, 8543, '\P{Numeric_Value=0.8750}', "");
    Expect(0, 8543, '\P{^Numeric_Value=0.8750}', "");
    Error('\p{Nv=-/a/000000007/008}');
    Error('\P{Nv=-/a/000000007/008}');
    Expect(1, 8542, '\p{Nv=:\A7/8\z:}', "");;
    Expect(0, 8543, '\p{Nv=:\A7/8\z:}', "");;
    Expect(1, 8542, '\p{Nv=+07/000008}', "");
    Expect(0, 8542, '\p{^Nv=+07/000008}', "");
    Expect(0, 8542, '\P{Nv=+07/000008}', "");
    Expect(1, 8542, '\P{^Nv=+07/000008}', "");
    Expect(0, 8543, '\p{Nv=+07/000008}', "");
    Expect(1, 8543, '\p{^Nv=+07/000008}', "");
    Expect(1, 8543, '\P{Nv=+07/000008}', "");
    Expect(0, 8543, '\P{^Nv=+07/000008}', "");
    Expect(1, 8542, '\p{Nv=420/480}', "");
    Expect(0, 8542, '\p{^Nv=420/480}', "");
    Expect(0, 8542, '\P{Nv=420/480}', "");
    Expect(1, 8542, '\P{^Nv=420/480}', "");
    Expect(0, 8543, '\p{Nv=420/480}', "");
    Expect(1, 8543, '\p{^Nv=420/480}', "");
    Expect(1, 8543, '\P{Nv=420/480}', "");
    Expect(0, 8543, '\P{^Nv=420/480}', "");
    Error('\p{Nv=8.8e-01}');
    Error('\P{Nv=8.8e-01}');
    Error('\p{Nv=0.9}');
    Error('\P{Nv=0.9}');
    Expect(1, 8542, '\p{Nv=8.75e-01}', "");
    Expect(0, 8542, '\p{^Nv=8.75e-01}', "");
    Expect(0, 8542, '\P{Nv=8.75e-01}', "");
    Expect(1, 8542, '\P{^Nv=8.75e-01}', "");
    Expect(0, 8543, '\p{Nv=8.75e-01}', "");
    Expect(1, 8543, '\p{^Nv=8.75e-01}', "");
    Expect(1, 8543, '\P{Nv=8.75e-01}', "");
    Expect(0, 8543, '\P{^Nv=8.75e-01}', "");
    Error('\p{Nv=0.88}');
    Error('\P{Nv=0.88}');
    Expect(1, 8542, '\p{Nv=8.750e-01}', "");
    Expect(0, 8542, '\p{^Nv=8.750e-01}', "");
    Expect(0, 8542, '\P{Nv=8.750e-01}', "");
    Expect(1, 8542, '\P{^Nv=8.750e-01}', "");
    Expect(0, 8543, '\p{Nv=8.750e-01}', "");
    Expect(1, 8543, '\p{^Nv=8.750e-01}', "");
    Expect(1, 8543, '\P{Nv=8.750e-01}', "");
    Expect(0, 8543, '\P{^Nv=8.750e-01}', "");
    Expect(1, 8542, '\p{Nv=0.875}', "");
    Expect(0, 8542, '\p{^Nv=0.875}', "");
    Expect(0, 8542, '\P{Nv=0.875}', "");
    Expect(1, 8542, '\P{^Nv=0.875}', "");
    Expect(0, 8543, '\p{Nv=0.875}', "");
    Expect(1, 8543, '\p{^Nv=0.875}', "");
    Expect(1, 8543, '\P{Nv=0.875}', "");
    Expect(0, 8543, '\P{^Nv=0.875}', "");
    Expect(1, 8542, '\p{Nv=8.7500e-01}', "");
    Expect(0, 8542, '\p{^Nv=8.7500e-01}', "");
    Expect(0, 8542, '\P{Nv=8.7500e-01}', "");
    Expect(1, 8542, '\P{^Nv=8.7500e-01}', "");
    Expect(0, 8543, '\p{Nv=8.7500e-01}', "");
    Expect(1, 8543, '\p{^Nv=8.7500e-01}', "");
    Expect(1, 8543, '\P{Nv=8.7500e-01}', "");
    Expect(0, 8543, '\P{^Nv=8.7500e-01}', "");
    Expect(1, 8542, '\p{Nv=0.8750}', "");
    Expect(0, 8542, '\p{^Nv=0.8750}', "");
    Expect(0, 8542, '\P{Nv=0.8750}', "");
    Expect(1, 8542, '\P{^Nv=0.8750}', "");
    Expect(0, 8543, '\p{Nv=0.8750}', "");
    Expect(1, 8543, '\p{^Nv=0.8750}', "");
    Expect(1, 8543, '\P{Nv=0.8750}', "");
    Expect(0, 8543, '\P{^Nv=0.8750}', "");
    Error('\p{Is_Numeric_Value=	/a/0007/08}');
    Error('\P{Is_Numeric_Value=	/a/0007/08}');
    Expect(1, 8542, '\p{Is_Numeric_Value=+00000007/8}', "");
    Expect(0, 8542, '\p{^Is_Numeric_Value=+00000007/8}', "");
    Expect(0, 8542, '\P{Is_Numeric_Value=+00000007/8}', "");
    Expect(1, 8542, '\P{^Is_Numeric_Value=+00000007/8}', "");
    Expect(0, 8543, '\p{Is_Numeric_Value=+00000007/8}', "");
    Expect(1, 8543, '\p{^Is_Numeric_Value=+00000007/8}', "");
    Expect(1, 8543, '\P{Is_Numeric_Value=+00000007/8}', "");
    Expect(0, 8543, '\P{^Is_Numeric_Value=+00000007/8}', "");
    Expect(1, 8542, '\p{Is_Numeric_Value=420/480}', "");
    Expect(0, 8542, '\p{^Is_Numeric_Value=420/480}', "");
    Expect(0, 8542, '\P{Is_Numeric_Value=420/480}', "");
    Expect(1, 8542, '\P{^Is_Numeric_Value=420/480}', "");
    Expect(0, 8543, '\p{Is_Numeric_Value=420/480}', "");
    Expect(1, 8543, '\p{^Is_Numeric_Value=420/480}', "");
    Expect(1, 8543, '\P{Is_Numeric_Value=420/480}', "");
    Expect(0, 8543, '\P{^Is_Numeric_Value=420/480}', "");
    Error('\p{Is_Numeric_Value=8.8e-01}');
    Error('\P{Is_Numeric_Value=8.8e-01}');
    Error('\p{Is_Numeric_Value=0.9}');
    Error('\P{Is_Numeric_Value=0.9}');
    Expect(1, 8542, '\p{Is_Numeric_Value=8.75e-01}', "");
    Expect(0, 8542, '\p{^Is_Numeric_Value=8.75e-01}', "");
    Expect(0, 8542, '\P{Is_Numeric_Value=8.75e-01}', "");
    Expect(1, 8542, '\P{^Is_Numeric_Value=8.75e-01}', "");
    Expect(0, 8543, '\p{Is_Numeric_Value=8.75e-01}', "");
    Expect(1, 8543, '\p{^Is_Numeric_Value=8.75e-01}', "");
    Expect(1, 8543, '\P{Is_Numeric_Value=8.75e-01}', "");
    Expect(0, 8543, '\P{^Is_Numeric_Value=8.75e-01}', "");
    Error('\p{Is_Numeric_Value:   0.88}');
    Error('\P{Is_Numeric_Value:   0.88}');
    Expect(1, 8542, '\p{Is_Numeric_Value: 8.750e-01}', "");
    Expect(0, 8542, '\p{^Is_Numeric_Value: 8.750e-01}', "");
    Expect(0, 8542, '\P{Is_Numeric_Value: 8.750e-01}', "");
    Expect(1, 8542, '\P{^Is_Numeric_Value: 8.750e-01}', "");
    Expect(0, 8543, '\p{Is_Numeric_Value: 8.750e-01}', "");
    Expect(1, 8543, '\p{^Is_Numeric_Value: 8.750e-01}', "");
    Expect(1, 8543, '\P{Is_Numeric_Value: 8.750e-01}', "");
    Expect(0, 8543, '\P{^Is_Numeric_Value: 8.750e-01}', "");
    Expect(1, 8542, '\p{Is_Numeric_Value=0.875}', "");
    Expect(0, 8542, '\p{^Is_Numeric_Value=0.875}', "");
    Expect(0, 8542, '\P{Is_Numeric_Value=0.875}', "");
    Expect(1, 8542, '\P{^Is_Numeric_Value=0.875}', "");
    Expect(0, 8543, '\p{Is_Numeric_Value=0.875}', "");
    Expect(1, 8543, '\p{^Is_Numeric_Value=0.875}', "");
    Expect(1, 8543, '\P{Is_Numeric_Value=0.875}', "");
    Expect(0, 8543, '\P{^Is_Numeric_Value=0.875}', "");
    Expect(1, 8542, '\p{Is_Numeric_Value=8.7500e-01}', "");
    Expect(0, 8542, '\p{^Is_Numeric_Value=8.7500e-01}', "");
    Expect(0, 8542, '\P{Is_Numeric_Value=8.7500e-01}', "");
    Expect(1, 8542, '\P{^Is_Numeric_Value=8.7500e-01}', "");
    Expect(0, 8543, '\p{Is_Numeric_Value=8.7500e-01}', "");
    Expect(1, 8543, '\p{^Is_Numeric_Value=8.7500e-01}', "");
    Expect(1, 8543, '\P{Is_Numeric_Value=8.7500e-01}', "");
    Expect(0, 8543, '\P{^Is_Numeric_Value=8.7500e-01}', "");
    Expect(1, 8542, '\p{Is_Numeric_Value=0.8750}', "");
    Expect(0, 8542, '\p{^Is_Numeric_Value=0.8750}', "");
    Expect(0, 8542, '\P{Is_Numeric_Value=0.8750}', "");
    Expect(1, 8542, '\P{^Is_Numeric_Value=0.8750}', "");
    Expect(0, 8543, '\p{Is_Numeric_Value=0.8750}', "");
    Expect(1, 8543, '\p{^Is_Numeric_Value=0.8750}', "");
    Expect(1, 8543, '\P{Is_Numeric_Value=0.8750}', "");
    Expect(0, 8543, '\P{^Is_Numeric_Value=0.8750}', "");
    Error('\p{Is_Nv=:=_+00000007/008}');
    Error('\P{Is_Nv=:=_+00000007/008}');
    Expect(1, 8542, '\p{Is_Nv=00007/00000008}', "");
    Expect(0, 8542, '\p{^Is_Nv=00007/00000008}', "");
    Expect(0, 8542, '\P{Is_Nv=00007/00000008}', "");
    Expect(1, 8542, '\P{^Is_Nv=00007/00000008}', "");
    Expect(0, 8543, '\p{Is_Nv=00007/00000008}', "");
    Expect(1, 8543, '\p{^Is_Nv=00007/00000008}', "");
    Expect(1, 8543, '\P{Is_Nv=00007/00000008}', "");
    Expect(0, 8543, '\P{^Is_Nv=00007/00000008}', "");
    Expect(1, 8542, '\p{Is_Nv=420/480}', "");
    Expect(0, 8542, '\p{^Is_Nv=420/480}', "");
    Expect(0, 8542, '\P{Is_Nv=420/480}', "");
    Expect(1, 8542, '\P{^Is_Nv=420/480}', "");
    Expect(0, 8543, '\p{Is_Nv=420/480}', "");
    Expect(1, 8543, '\p{^Is_Nv=420/480}', "");
    Expect(1, 8543, '\P{Is_Nv=420/480}', "");
    Expect(0, 8543, '\P{^Is_Nv=420/480}', "");
    Error('\p{Is_Nv=8.8e-01}');
    Error('\P{Is_Nv=8.8e-01}');
    Error('\p{Is_Nv=0.9}');
    Error('\P{Is_Nv=0.9}');
    Expect(1, 8542, '\p{Is_Nv=8.75e-01}', "");
    Expect(0, 8542, '\p{^Is_Nv=8.75e-01}', "");
    Expect(0, 8542, '\P{Is_Nv=8.75e-01}', "");
    Expect(1, 8542, '\P{^Is_Nv=8.75e-01}', "");
    Expect(0, 8543, '\p{Is_Nv=8.75e-01}', "");
    Expect(1, 8543, '\p{^Is_Nv=8.75e-01}', "");
    Expect(1, 8543, '\P{Is_Nv=8.75e-01}', "");
    Expect(0, 8543, '\P{^Is_Nv=8.75e-01}', "");
    Error('\p{Is_Nv: 0.88}');
    Error('\P{Is_Nv: 0.88}');
    Expect(1, 8542, '\p{Is_Nv: 8.750e-01}', "");
    Expect(0, 8542, '\p{^Is_Nv: 8.750e-01}', "");
    Expect(0, 8542, '\P{Is_Nv: 8.750e-01}', "");
    Expect(1, 8542, '\P{^Is_Nv: 8.750e-01}', "");
    Expect(0, 8543, '\p{Is_Nv: 8.750e-01}', "");
    Expect(1, 8543, '\p{^Is_Nv: 8.750e-01}', "");
    Expect(1, 8543, '\P{Is_Nv: 8.750e-01}', "");
    Expect(0, 8543, '\P{^Is_Nv: 8.750e-01}', "");
    Expect(1, 8542, '\p{Is_Nv=0.875}', "");
    Expect(0, 8542, '\p{^Is_Nv=0.875}', "");
    Expect(0, 8542, '\P{Is_Nv=0.875}', "");
    Expect(1, 8542, '\P{^Is_Nv=0.875}', "");
    Expect(0, 8543, '\p{Is_Nv=0.875}', "");
    Expect(1, 8543, '\p{^Is_Nv=0.875}', "");
    Expect(1, 8543, '\P{Is_Nv=0.875}', "");
    Expect(0, 8543, '\P{^Is_Nv=0.875}', "");
    Expect(1, 8542, '\p{Is_Nv=8.7500e-01}', "");
    Expect(0, 8542, '\p{^Is_Nv=8.7500e-01}', "");
    Expect(0, 8542, '\P{Is_Nv=8.7500e-01}', "");
    Expect(1, 8542, '\P{^Is_Nv=8.7500e-01}', "");
    Expect(0, 8543, '\p{Is_Nv=8.7500e-01}', "");
    Expect(1, 8543, '\p{^Is_Nv=8.7500e-01}', "");
    Expect(1, 8543, '\P{Is_Nv=8.7500e-01}', "");
    Expect(0, 8543, '\P{^Is_Nv=8.7500e-01}', "");
    Expect(1, 8542, '\p{Is_Nv:   0.8750}', "");
    Expect(0, 8542, '\p{^Is_Nv:   0.8750}', "");
    Expect(0, 8542, '\P{Is_Nv:   0.8750}', "");
    Expect(1, 8542, '\P{^Is_Nv:   0.8750}', "");
    Expect(0, 8543, '\p{Is_Nv:   0.8750}', "");
    Expect(1, 8543, '\p{^Is_Nv:   0.8750}', "");
    Expect(1, 8543, '\P{Is_Nv:   0.8750}', "");
    Expect(0, 8543, '\P{^Is_Nv:   0.8750}', "");
    Error('\p{Numeric_Value=_/a/+0_0_0_0_0_00070}');
    Error('\P{Numeric_Value=_/a/+0_0_0_0_0_00070}');
    Expect(1, 126224, '\p{Numeric_Value=:\A70\z:}', "");;
    Expect(0, 126225, '\p{Numeric_Value=:\A70\z:}', "");;
    Expect(1, 126224, '\p{Numeric_Value=70}', "");
    Expect(0, 126224, '\p{^Numeric_Value=70}', "");
    Expect(0, 126224, '\P{Numeric_Value=70}', "");
    Expect(1, 126224, '\P{^Numeric_Value=70}', "");
    Expect(0, 126225, '\p{Numeric_Value=70}', "");
    Expect(1, 126225, '\p{^Numeric_Value=70}', "");
    Expect(1, 126225, '\P{Numeric_Value=70}', "");
    Expect(0, 126225, '\P{^Numeric_Value=70}', "");
    Expect(1, 126224, '\p{Numeric_Value=7.000000000000000e+01}', "");
    Expect(0, 126224, '\p{^Numeric_Value=7.000000000000000e+01}', "");
    Expect(0, 126224, '\P{Numeric_Value=7.000000000000000e+01}', "");
    Expect(1, 126224, '\P{^Numeric_Value=7.000000000000000e+01}', "");
    Expect(0, 126225, '\p{Numeric_Value=7.000000000000000e+01}', "");
    Expect(1, 126225, '\p{^Numeric_Value=7.000000000000000e+01}', "");
    Expect(1, 126225, '\P{Numeric_Value=7.000000000000000e+01}', "");
    Expect(0, 126225, '\P{^Numeric_Value=7.000000000000000e+01}', "");
    Error('\p{Nv: :=_-+00070}');
    Error('\P{Nv: :=_-+00070}');
    Expect(1, 126224, '\p{Nv=:\A70\z:}', "");;
    Expect(0, 126225, '\p{Nv=:\A70\z:}', "");;
    Expect(1, 126224, '\p{Nv:000000070}', "");
    Expect(0, 126224, '\p{^Nv:000000070}', "");
    Expect(0, 126224, '\P{Nv:000000070}', "");
    Expect(1, 126224, '\P{^Nv:000000070}', "");
    Expect(0, 126225, '\p{Nv:000000070}', "");
    Expect(1, 126225, '\p{^Nv:000000070}', "");
    Expect(1, 126225, '\P{Nv:000000070}', "");
    Expect(0, 126225, '\P{^Nv:000000070}', "");
    Expect(1, 126224, '\p{Nv=7.000000000000000e+01}', "");
    Expect(0, 126224, '\p{^Nv=7.000000000000000e+01}', "");
    Expect(0, 126224, '\P{Nv=7.000000000000000e+01}', "");
    Expect(1, 126224, '\P{^Nv=7.000000000000000e+01}', "");
    Expect(0, 126225, '\p{Nv=7.000000000000000e+01}', "");
    Expect(1, 126225, '\p{^Nv=7.000000000000000e+01}', "");
    Expect(1, 126225, '\P{Nv=7.000000000000000e+01}', "");
    Expect(0, 126225, '\P{^Nv=7.000000000000000e+01}', "");
    Error('\p{Is_Numeric_Value=	:=0070}');
    Error('\P{Is_Numeric_Value=	:=0070}');
    Expect(1, 126224, '\p{Is_Numeric_Value=+0007_0}', "");
    Expect(0, 126224, '\p{^Is_Numeric_Value=+0007_0}', "");
    Expect(0, 126224, '\P{Is_Numeric_Value=+0007_0}', "");
    Expect(1, 126224, '\P{^Is_Numeric_Value=+0007_0}', "");
    Expect(0, 126225, '\p{Is_Numeric_Value=+0007_0}', "");
    Expect(1, 126225, '\p{^Is_Numeric_Value=+0007_0}', "");
    Expect(1, 126225, '\P{Is_Numeric_Value=+0007_0}', "");
    Expect(0, 126225, '\P{^Is_Numeric_Value=+0007_0}', "");
    Expect(1, 126224, '\p{Is_Numeric_Value:7.000000000000000e+01}', "");
    Expect(0, 126224, '\p{^Is_Numeric_Value:7.000000000000000e+01}', "");
    Expect(0, 126224, '\P{Is_Numeric_Value:7.000000000000000e+01}', "");
    Expect(1, 126224, '\P{^Is_Numeric_Value:7.000000000000000e+01}', "");
    Expect(0, 126225, '\p{Is_Numeric_Value:7.000000000000000e+01}', "");
    Expect(1, 126225, '\p{^Is_Numeric_Value:7.000000000000000e+01}', "");
    Expect(1, 126225, '\P{Is_Numeric_Value:7.000000000000000e+01}', "");
    Expect(0, 126225, '\P{^Is_Numeric_Value:7.000000000000000e+01}', "");
    Error('\p{Is_Nv= _+0007_0:=}');
    Error('\P{Is_Nv= _+0007_0:=}');
    Expect(1, 126224, '\p{Is_Nv=0000000070}', "");
    Expect(0, 126224, '\p{^Is_Nv=0000000070}', "");
    Expect(0, 126224, '\P{Is_Nv=0000000070}', "");
    Expect(1, 126224, '\P{^Is_Nv=0000000070}', "");
    Expect(0, 126225, '\p{Is_Nv=0000000070}', "");
    Expect(1, 126225, '\p{^Is_Nv=0000000070}', "");
    Expect(1, 126225, '\P{Is_Nv=0000000070}', "");
    Expect(0, 126225, '\P{^Is_Nv=0000000070}', "");
    Expect(1, 126224, '\p{Is_Nv=7.000000000000000e+01}', "");
    Expect(0, 126224, '\p{^Is_Nv=7.000000000000000e+01}', "");
    Expect(0, 126224, '\P{Is_Nv=7.000000000000000e+01}', "");
    Expect(1, 126224, '\P{^Is_Nv=7.000000000000000e+01}', "");
    Expect(0, 126225, '\p{Is_Nv=7.000000000000000e+01}', "");
    Expect(1, 126225, '\p{^Is_Nv=7.000000000000000e+01}', "");
    Expect(1, 126225, '\P{Is_Nv=7.000000000000000e+01}', "");
    Expect(0, 126225, '\P{^Is_Nv=7.000000000000000e+01}', "");
    Error('\p{Numeric_Value: _0_7_00:=}');
    Error('\P{Numeric_Value: _0_7_00:=}');
    Expect(1, 126233, '\p{Numeric_Value=:\A700\z:}', "");;
    Expect(0, 126234, '\p{Numeric_Value=:\A700\z:}', "");;
    Expect(1, 126233, '\p{Numeric_Value:	+0_0_0_0_0_0_0_7_00}', "");
    Expect(0, 126233, '\p{^Numeric_Value:	+0_0_0_0_0_0_0_7_00}', "");
    Expect(0, 126233, '\P{Numeric_Value:	+0_0_0_0_0_0_0_7_00}', "");
    Expect(1, 126233, '\P{^Numeric_Value:	+0_0_0_0_0_0_0_7_00}', "");
    Expect(0, 126234, '\p{Numeric_Value:	+0_0_0_0_0_0_0_7_00}', "");
    Expect(1, 126234, '\p{^Numeric_Value:	+0_0_0_0_0_0_0_7_00}', "");
    Expect(1, 126234, '\P{Numeric_Value:	+0_0_0_0_0_0_0_7_00}', "");
    Expect(0, 126234, '\P{^Numeric_Value:	+0_0_0_0_0_0_0_7_00}', "");
    Expect(1, 126233, '\p{Numeric_Value=7.000000000000000e+02}', "");
    Expect(0, 126233, '\p{^Numeric_Value=7.000000000000000e+02}', "");
    Expect(0, 126233, '\P{Numeric_Value=7.000000000000000e+02}', "");
    Expect(1, 126233, '\P{^Numeric_Value=7.000000000000000e+02}', "");
    Expect(0, 126234, '\p{Numeric_Value=7.000000000000000e+02}', "");
    Expect(1, 126234, '\p{^Numeric_Value=7.000000000000000e+02}', "");
    Expect(1, 126234, '\P{Numeric_Value=7.000000000000000e+02}', "");
    Expect(0, 126234, '\P{^Numeric_Value=7.000000000000000e+02}', "");
    Error('\p{Nv=-0000070_0:=}');
    Error('\P{Nv=-0000070_0:=}');
    Expect(1, 126233, '\p{Nv=:\A700\z:}', "");;
    Expect(0, 126234, '\p{Nv=:\A700\z:}', "");;
    Expect(1, 126233, '\p{Nv:	00000700}', "");
    Expect(0, 126233, '\p{^Nv:	00000700}', "");
    Expect(0, 126233, '\P{Nv:	00000700}', "");
    Expect(1, 126233, '\P{^Nv:	00000700}', "");
    Expect(0, 126234, '\p{Nv:	00000700}', "");
    Expect(1, 126234, '\p{^Nv:	00000700}', "");
    Expect(1, 126234, '\P{Nv:	00000700}', "");
    Expect(0, 126234, '\P{^Nv:	00000700}', "");
    Expect(1, 126233, '\p{Nv: 7.000000000000000e+02}', "");
    Expect(0, 126233, '\p{^Nv: 7.000000000000000e+02}', "");
    Expect(0, 126233, '\P{Nv: 7.000000000000000e+02}', "");
    Expect(1, 126233, '\P{^Nv: 7.000000000000000e+02}', "");
    Expect(0, 126234, '\p{Nv: 7.000000000000000e+02}', "");
    Expect(1, 126234, '\p{^Nv: 7.000000000000000e+02}', "");
    Expect(1, 126234, '\P{Nv: 7.000000000000000e+02}', "");
    Expect(0, 126234, '\P{^Nv: 7.000000000000000e+02}', "");
    Error('\p{Is_Numeric_Value=/a/	0_0_0_0_0_0_00700}');
    Error('\P{Is_Numeric_Value=/a/	0_0_0_0_0_0_00700}');
    Expect(1, 126233, '\p{Is_Numeric_Value=000000700}', "");
    Expect(0, 126233, '\p{^Is_Numeric_Value=000000700}', "");
    Expect(0, 126233, '\P{Is_Numeric_Value=000000700}', "");
    Expect(1, 126233, '\P{^Is_Numeric_Value=000000700}', "");
    Expect(0, 126234, '\p{Is_Numeric_Value=000000700}', "");
    Expect(1, 126234, '\p{^Is_Numeric_Value=000000700}', "");
    Expect(1, 126234, '\P{Is_Numeric_Value=000000700}', "");
    Expect(0, 126234, '\P{^Is_Numeric_Value=000000700}', "");
    Expect(1, 126233, '\p{Is_Numeric_Value:7.000000000000000e+02}', "");
    Expect(0, 126233, '\p{^Is_Numeric_Value:7.000000000000000e+02}', "");
    Expect(0, 126233, '\P{Is_Numeric_Value:7.000000000000000e+02}', "");
    Expect(1, 126233, '\P{^Is_Numeric_Value:7.000000000000000e+02}', "");
    Expect(0, 126234, '\p{Is_Numeric_Value:7.000000000000000e+02}', "");
    Expect(1, 126234, '\p{^Is_Numeric_Value:7.000000000000000e+02}', "");
    Expect(1, 126234, '\P{Is_Numeric_Value:7.000000000000000e+02}', "");
    Expect(0, 126234, '\P{^Is_Numeric_Value:7.000000000000000e+02}', "");
    Error('\p{Is_Nv=- 000700:=}');
    Error('\P{Is_Nv=- 000700:=}');
    Expect(1, 126233, '\p{Is_Nv=0700}', "");
    Expect(0, 126233, '\p{^Is_Nv=0700}', "");
    Expect(0, 126233, '\P{Is_Nv=0700}', "");
    Expect(1, 126233, '\P{^Is_Nv=0700}', "");
    Expect(0, 126234, '\p{Is_Nv=0700}', "");
    Expect(1, 126234, '\p{^Is_Nv=0700}', "");
    Expect(1, 126234, '\P{Is_Nv=0700}', "");
    Expect(0, 126234, '\P{^Is_Nv=0700}', "");
    Expect(1, 126233, '\p{Is_Nv=7.000000000000000e+02}', "");
    Expect(0, 126233, '\p{^Is_Nv=7.000000000000000e+02}', "");
    Expect(0, 126233, '\P{Is_Nv=7.000000000000000e+02}', "");
    Expect(1, 126233, '\P{^Is_Nv=7.000000000000000e+02}', "");
    Expect(0, 126234, '\p{Is_Nv=7.000000000000000e+02}', "");
    Expect(1, 126234, '\p{^Is_Nv=7.000000000000000e+02}', "");
    Expect(1, 126234, '\P{Is_Nv=7.000000000000000e+02}', "");
    Expect(0, 126234, '\P{^Is_Nv=7.000000000000000e+02}', "");
    Error('\p{Numeric_Value= 007000/a/}');
    Error('\P{Numeric_Value= 007000/a/}');
    Expect(1, 126242, '\p{Numeric_Value=:\A7000\z:}', "");;
    Expect(0, 126243, '\p{Numeric_Value=:\A7000\z:}', "");;
    Expect(1, 126242, '\p{Numeric_Value=00007000}', "");
    Expect(0, 126242, '\p{^Numeric_Value=00007000}', "");
    Expect(0, 126242, '\P{Numeric_Value=00007000}', "");
    Expect(1, 126242, '\P{^Numeric_Value=00007000}', "");
    Expect(0, 126243, '\p{Numeric_Value=00007000}', "");
    Expect(1, 126243, '\p{^Numeric_Value=00007000}', "");
    Expect(1, 126243, '\P{Numeric_Value=00007000}', "");
    Expect(0, 126243, '\P{^Numeric_Value=00007000}', "");
    Expect(1, 126242, '\p{Numeric_Value=7.000000000000000e+03}', "");
    Expect(0, 126242, '\p{^Numeric_Value=7.000000000000000e+03}', "");
    Expect(0, 126242, '\P{Numeric_Value=7.000000000000000e+03}', "");
    Expect(1, 126242, '\P{^Numeric_Value=7.000000000000000e+03}', "");
    Expect(0, 126243, '\p{Numeric_Value=7.000000000000000e+03}', "");
    Expect(1, 126243, '\p{^Numeric_Value=7.000000000000000e+03}', "");
    Expect(1, 126243, '\P{Numeric_Value=7.000000000000000e+03}', "");
    Expect(0, 126243, '\P{^Numeric_Value=7.000000000000000e+03}', "");
    Error('\p{Nv=-+00_70_00/a/}');
    Error('\P{Nv=-+00_70_00/a/}');
    Expect(1, 126242, '\p{Nv=:\A7000\z:}', "");;
    Expect(0, 126243, '\p{Nv=:\A7000\z:}', "");;
    Expect(1, 126242, '\p{Nv=00_00_00_00_07_00_0}', "");
    Expect(0, 126242, '\p{^Nv=00_00_00_00_07_00_0}', "");
    Expect(0, 126242, '\P{Nv=00_00_00_00_07_00_0}', "");
    Expect(1, 126242, '\P{^Nv=00_00_00_00_07_00_0}', "");
    Expect(0, 126243, '\p{Nv=00_00_00_00_07_00_0}', "");
    Expect(1, 126243, '\p{^Nv=00_00_00_00_07_00_0}', "");
    Expect(1, 126243, '\P{Nv=00_00_00_00_07_00_0}', "");
    Expect(0, 126243, '\P{^Nv=00_00_00_00_07_00_0}', "");
    Expect(1, 126242, '\p{Nv=7.000000000000000e+03}', "");
    Expect(0, 126242, '\p{^Nv=7.000000000000000e+03}', "");
    Expect(0, 126242, '\P{Nv=7.000000000000000e+03}', "");
    Expect(1, 126242, '\P{^Nv=7.000000000000000e+03}', "");
    Expect(0, 126243, '\p{Nv=7.000000000000000e+03}', "");
    Expect(1, 126243, '\p{^Nv=7.000000000000000e+03}', "");
    Expect(1, 126243, '\P{Nv=7.000000000000000e+03}', "");
    Expect(0, 126243, '\P{^Nv=7.000000000000000e+03}', "");
    Error('\p{Is_Numeric_Value=/a/ +700_0}');
    Error('\P{Is_Numeric_Value=/a/ +700_0}');
    Expect(1, 126242, '\p{Is_Numeric_Value:	+000007000}', "");
    Expect(0, 126242, '\p{^Is_Numeric_Value:	+000007000}', "");
    Expect(0, 126242, '\P{Is_Numeric_Value:	+000007000}', "");
    Expect(1, 126242, '\P{^Is_Numeric_Value:	+000007000}', "");
    Expect(0, 126243, '\p{Is_Numeric_Value:	+000007000}', "");
    Expect(1, 126243, '\p{^Is_Numeric_Value:	+000007000}', "");
    Expect(1, 126243, '\P{Is_Numeric_Value:	+000007000}', "");
    Expect(0, 126243, '\P{^Is_Numeric_Value:	+000007000}', "");
    Expect(1, 126242, '\p{Is_Numeric_Value=7.000000000000000e+03}', "");
    Expect(0, 126242, '\p{^Is_Numeric_Value=7.000000000000000e+03}', "");
    Expect(0, 126242, '\P{Is_Numeric_Value=7.000000000000000e+03}', "");
    Expect(1, 126242, '\P{^Is_Numeric_Value=7.000000000000000e+03}', "");
    Expect(0, 126243, '\p{Is_Numeric_Value=7.000000000000000e+03}', "");
    Expect(1, 126243, '\p{^Is_Numeric_Value=7.000000000000000e+03}', "");
    Expect(1, 126243, '\P{Is_Numeric_Value=7.000000000000000e+03}', "");
    Expect(0, 126243, '\P{^Is_Numeric_Value=7.000000000000000e+03}', "");
    Error('\p{Is_Nv=:=700_0}');
    Error('\P{Is_Nv=:=700_0}');
    Expect(1, 126242, '\p{Is_Nv=00_00_00_00_70_00}', "");
    Expect(0, 126242, '\p{^Is_Nv=00_00_00_00_70_00}', "");
    Expect(0, 126242, '\P{Is_Nv=00_00_00_00_70_00}', "");
    Expect(1, 126242, '\P{^Is_Nv=00_00_00_00_70_00}', "");
    Expect(0, 126243, '\p{Is_Nv=00_00_00_00_70_00}', "");
    Expect(1, 126243, '\p{^Is_Nv=00_00_00_00_70_00}', "");
    Expect(1, 126243, '\P{Is_Nv=00_00_00_00_70_00}', "");
    Expect(0, 126243, '\P{^Is_Nv=00_00_00_00_70_00}', "");
    Expect(1, 126242, '\p{Is_Nv=7.000000000000000e+03}', "");
    Expect(0, 126242, '\p{^Is_Nv=7.000000000000000e+03}', "");
    Expect(0, 126242, '\P{Is_Nv=7.000000000000000e+03}', "");
    Expect(1, 126242, '\P{^Is_Nv=7.000000000000000e+03}', "");
    Expect(0, 126243, '\p{Is_Nv=7.000000000000000e+03}', "");
    Expect(1, 126243, '\p{^Is_Nv=7.000000000000000e+03}', "");
    Expect(1, 126243, '\P{Is_Nv=7.000000000000000e+03}', "");
    Expect(0, 126243, '\P{^Is_Nv=7.000000000000000e+03}', "");
    Error('\p{Numeric_Value=:=000_000_007_000_0}');
    Error('\P{Numeric_Value=:=000_000_007_000_0}');
    Expect(1, 126251, '\p{Numeric_Value=:\A70000\z:}', "");;
    Expect(0, 126252, '\p{Numeric_Value=:\A70000\z:}', "");;
    Expect(1, 126251, '\p{Numeric_Value=+00070000}', "");
    Expect(0, 126251, '\p{^Numeric_Value=+00070000}', "");
    Expect(0, 126251, '\P{Numeric_Value=+00070000}', "");
    Expect(1, 126251, '\P{^Numeric_Value=+00070000}', "");
    Expect(0, 126252, '\p{Numeric_Value=+00070000}', "");
    Expect(1, 126252, '\p{^Numeric_Value=+00070000}', "");
    Expect(1, 126252, '\P{Numeric_Value=+00070000}', "");
    Expect(0, 126252, '\P{^Numeric_Value=+00070000}', "");
    Expect(1, 126251, '\p{Numeric_Value=7.000000000000000e+04}', "");
    Expect(0, 126251, '\p{^Numeric_Value=7.000000000000000e+04}', "");
    Expect(0, 126251, '\P{Numeric_Value=7.000000000000000e+04}', "");
    Expect(1, 126251, '\P{^Numeric_Value=7.000000000000000e+04}', "");
    Expect(0, 126252, '\p{Numeric_Value=7.000000000000000e+04}', "");
    Expect(1, 126252, '\p{^Numeric_Value=7.000000000000000e+04}', "");
    Expect(1, 126252, '\P{Numeric_Value=7.000000000000000e+04}', "");
    Expect(0, 126252, '\P{^Numeric_Value=7.000000000000000e+04}', "");
    Error('\p{Nv=:= 0_7_0_0_00}');
    Error('\P{Nv=:= 0_7_0_0_00}');
    Expect(1, 126251, '\p{Nv=:\A70000\z:}', "");;
    Expect(0, 126252, '\p{Nv=:\A70000\z:}', "");;
    Expect(1, 126251, '\p{Nv:0_0_0_7_0_0_00}', "");
    Expect(0, 126251, '\p{^Nv:0_0_0_7_0_0_00}', "");
    Expect(0, 126251, '\P{Nv:0_0_0_7_0_0_00}', "");
    Expect(1, 126251, '\P{^Nv:0_0_0_7_0_0_00}', "");
    Expect(0, 126252, '\p{Nv:0_0_0_7_0_0_00}', "");
    Expect(1, 126252, '\p{^Nv:0_0_0_7_0_0_00}', "");
    Expect(1, 126252, '\P{Nv:0_0_0_7_0_0_00}', "");
    Expect(0, 126252, '\P{^Nv:0_0_0_7_0_0_00}', "");
    Expect(1, 126251, '\p{Nv=7.000000000000000e+04}', "");
    Expect(0, 126251, '\p{^Nv=7.000000000000000e+04}', "");
    Expect(0, 126251, '\P{Nv=7.000000000000000e+04}', "");
    Expect(1, 126251, '\P{^Nv=7.000000000000000e+04}', "");
    Expect(0, 126252, '\p{Nv=7.000000000000000e+04}', "");
    Expect(1, 126252, '\p{^Nv=7.000000000000000e+04}', "");
    Expect(1, 126252, '\P{Nv=7.000000000000000e+04}', "");
    Expect(0, 126252, '\P{^Nv=7.000000000000000e+04}', "");
    Error('\p{Is_Numeric_Value=:= _000000070000}');
    Error('\P{Is_Numeric_Value=:= _000000070000}');
    Expect(1, 126251, '\p{Is_Numeric_Value=0000070000}', "");
    Expect(0, 126251, '\p{^Is_Numeric_Value=0000070000}', "");
    Expect(0, 126251, '\P{Is_Numeric_Value=0000070000}', "");
    Expect(1, 126251, '\P{^Is_Numeric_Value=0000070000}', "");
    Expect(0, 126252, '\p{Is_Numeric_Value=0000070000}', "");
    Expect(1, 126252, '\p{^Is_Numeric_Value=0000070000}', "");
    Expect(1, 126252, '\P{Is_Numeric_Value=0000070000}', "");
    Expect(0, 126252, '\P{^Is_Numeric_Value=0000070000}', "");
    Expect(1, 126251, '\p{Is_Numeric_Value=7.000000000000000e+04}', "");
    Expect(0, 126251, '\p{^Is_Numeric_Value=7.000000000000000e+04}', "");
    Expect(0, 126251, '\P{Is_Numeric_Value=7.000000000000000e+04}', "");
    Expect(1, 126251, '\P{^Is_Numeric_Value=7.000000000000000e+04}', "");
    Expect(0, 126252, '\p{Is_Numeric_Value=7.000000000000000e+04}', "");
    Expect(1, 126252, '\p{^Is_Numeric_Value=7.000000000000000e+04}', "");
    Expect(1, 126252, '\P{Is_Numeric_Value=7.000000000000000e+04}', "");
    Expect(0, 126252, '\P{^Is_Numeric_Value=7.000000000000000e+04}', "");
    Error('\p{Is_Nv=-/a/0_0_0_0_0_0_7_0_000}');
    Error('\P{Is_Nv=-/a/0_0_0_0_0_0_7_0_000}');
    Expect(1, 126251, '\p{Is_Nv=00000070000}', "");
    Expect(0, 126251, '\p{^Is_Nv=00000070000}', "");
    Expect(0, 126251, '\P{Is_Nv=00000070000}', "");
    Expect(1, 126251, '\P{^Is_Nv=00000070000}', "");
    Expect(0, 126252, '\p{Is_Nv=00000070000}', "");
    Expect(1, 126252, '\p{^Is_Nv=00000070000}', "");
    Expect(1, 126252, '\P{Is_Nv=00000070000}', "");
    Expect(0, 126252, '\P{^Is_Nv=00000070000}', "");
    Expect(1, 126251, '\p{Is_Nv=7.000000000000000e+04}', "");
    Expect(0, 126251, '\p{^Is_Nv=7.000000000000000e+04}', "");
    Expect(0, 126251, '\P{Is_Nv=7.000000000000000e+04}', "");
    Expect(1, 126251, '\P{^Is_Nv=7.000000000000000e+04}', "");
    Expect(0, 126252, '\p{Is_Nv=7.000000000000000e+04}', "");
    Expect(1, 126252, '\p{^Is_Nv=7.000000000000000e+04}', "");
    Expect(1, 126252, '\P{Is_Nv=7.000000000000000e+04}', "");
    Expect(0, 126252, '\P{^Is_Nv=7.000000000000000e+04}', "");
    Error('\p{Numeric_Value:	/a/- 000000070000_0}');
    Error('\P{Numeric_Value:	/a/- 000000070000_0}');
    Expect(1, 68083, '\p{Numeric_Value=:\A700000\z:}', "");;
    Expect(0, 68084, '\p{Numeric_Value=:\A700000\z:}', "");;
    Expect(1, 68083, '\p{Numeric_Value=0_0_0_7_0_0_0_00}', "");
    Expect(0, 68083, '\p{^Numeric_Value=0_0_0_7_0_0_0_00}', "");
    Expect(0, 68083, '\P{Numeric_Value=0_0_0_7_0_0_0_00}', "");
    Expect(1, 68083, '\P{^Numeric_Value=0_0_0_7_0_0_0_00}', "");
    Expect(0, 68084, '\p{Numeric_Value=0_0_0_7_0_0_0_00}', "");
    Expect(1, 68084, '\p{^Numeric_Value=0_0_0_7_0_0_0_00}', "");
    Expect(1, 68084, '\P{Numeric_Value=0_0_0_7_0_0_0_00}', "");
    Expect(0, 68084, '\P{^Numeric_Value=0_0_0_7_0_0_0_00}', "");
    Expect(1, 68083, '\p{Numeric_Value=7.000000000000000e+05}', "");
    Expect(0, 68083, '\p{^Numeric_Value=7.000000000000000e+05}', "");
    Expect(0, 68083, '\P{Numeric_Value=7.000000000000000e+05}', "");
    Expect(1, 68083, '\P{^Numeric_Value=7.000000000000000e+05}', "");
    Expect(0, 68084, '\p{Numeric_Value=7.000000000000000e+05}', "");
    Expect(1, 68084, '\p{^Numeric_Value=7.000000000000000e+05}', "");
    Expect(1, 68084, '\P{Numeric_Value=7.000000000000000e+05}', "");
    Expect(0, 68084, '\P{^Numeric_Value=7.000000000000000e+05}', "");
    Error('\p{Nv: /a/	000_000_700_000}');
    Error('\P{Nv: /a/	000_000_700_000}');
    Expect(1, 68083, '\p{Nv=:\A700000\z:}', "");;
    Expect(0, 68084, '\p{Nv=:\A700000\z:}', "");;
    Expect(1, 68083, '\p{Nv=0_0_0_0_0_0_7_0_0000}', "");
    Expect(0, 68083, '\p{^Nv=0_0_0_0_0_0_7_0_0000}', "");
    Expect(0, 68083, '\P{Nv=0_0_0_0_0_0_7_0_0000}', "");
    Expect(1, 68083, '\P{^Nv=0_0_0_0_0_0_7_0_0000}', "");
    Expect(0, 68084, '\p{Nv=0_0_0_0_0_0_7_0_0000}', "");
    Expect(1, 68084, '\p{^Nv=0_0_0_0_0_0_7_0_0000}', "");
    Expect(1, 68084, '\P{Nv=0_0_0_0_0_0_7_0_0000}', "");
    Expect(0, 68084, '\P{^Nv=0_0_0_0_0_0_7_0_0000}', "");
    Expect(1, 68083, '\p{Nv=7.000000000000000e+05}', "");
    Expect(0, 68083, '\p{^Nv=7.000000000000000e+05}', "");
    Expect(0, 68083, '\P{Nv=7.000000000000000e+05}', "");
    Expect(1, 68083, '\P{^Nv=7.000000000000000e+05}', "");
    Expect(0, 68084, '\p{Nv=7.000000000000000e+05}', "");
    Expect(1, 68084, '\p{^Nv=7.000000000000000e+05}', "");
    Expect(1, 68084, '\P{Nv=7.000000000000000e+05}', "");
    Expect(0, 68084, '\P{^Nv=7.000000000000000e+05}', "");
    Error('\p{Is_Numeric_Value= _0_0_0_7_0_0000:=}');
    Error('\P{Is_Numeric_Value= _0_0_0_7_0_0000:=}');
    Expect(1, 68083, '\p{Is_Numeric_Value=70_00_00}', "");
    Expect(0, 68083, '\p{^Is_Numeric_Value=70_00_00}', "");
    Expect(0, 68083, '\P{Is_Numeric_Value=70_00_00}', "");
    Expect(1, 68083, '\P{^Is_Numeric_Value=70_00_00}', "");
    Expect(0, 68084, '\p{Is_Numeric_Value=70_00_00}', "");
    Expect(1, 68084, '\p{^Is_Numeric_Value=70_00_00}', "");
    Expect(1, 68084, '\P{Is_Numeric_Value=70_00_00}', "");
    Expect(0, 68084, '\P{^Is_Numeric_Value=70_00_00}', "");
    Expect(1, 68083, '\p{Is_Numeric_Value=7.000000000000000e+05}', "");
    Expect(0, 68083, '\p{^Is_Numeric_Value=7.000000000000000e+05}', "");
    Expect(0, 68083, '\P{Is_Numeric_Value=7.000000000000000e+05}', "");
    Expect(1, 68083, '\P{^Is_Numeric_Value=7.000000000000000e+05}', "");
    Expect(0, 68084, '\p{Is_Numeric_Value=7.000000000000000e+05}', "");
    Expect(1, 68084, '\p{^Is_Numeric_Value=7.000000000000000e+05}', "");
    Expect(1, 68084, '\P{Is_Numeric_Value=7.000000000000000e+05}', "");
    Expect(0, 68084, '\P{^Is_Numeric_Value=7.000000000000000e+05}', "");
    Error('\p{Is_Nv=	:=00_07_00_000}');
    Error('\P{Is_Nv=	:=00_07_00_000}');
    Expect(1, 68083, '\p{Is_Nv=0_0_0_7_0_0_0_00}', "");
    Expect(0, 68083, '\p{^Is_Nv=0_0_0_7_0_0_0_00}', "");
    Expect(0, 68083, '\P{Is_Nv=0_0_0_7_0_0_0_00}', "");
    Expect(1, 68083, '\P{^Is_Nv=0_0_0_7_0_0_0_00}', "");
    Expect(0, 68084, '\p{Is_Nv=0_0_0_7_0_0_0_00}', "");
    Expect(1, 68084, '\p{^Is_Nv=0_0_0_7_0_0_0_00}', "");
    Expect(1, 68084, '\P{Is_Nv=0_0_0_7_0_0_0_00}', "");
    Expect(0, 68084, '\P{^Is_Nv=0_0_0_7_0_0_0_00}', "");
    Expect(1, 68083, '\p{Is_Nv=7.000000000000000e+05}', "");
    Expect(0, 68083, '\p{^Is_Nv=7.000000000000000e+05}', "");
    Expect(0, 68083, '\P{Is_Nv=7.000000000000000e+05}', "");
    Expect(1, 68083, '\P{^Is_Nv=7.000000000000000e+05}', "");
    Expect(0, 68084, '\p{Is_Nv=7.000000000000000e+05}', "");
    Expect(1, 68084, '\p{^Is_Nv=7.000000000000000e+05}', "");
    Expect(1, 68084, '\P{Is_Nv=7.000000000000000e+05}', "");
    Expect(0, 68084, '\P{^Is_Nv=7.000000000000000e+05}', "");
    Error('\p{Numeric_Value=	00008:=}');
    Error('\P{Numeric_Value=	00008:=}');
    Expect(1, 130040, '\p{Numeric_Value=:\A8\z:}', "");;
    Expect(0, 130041, '\p{Numeric_Value=:\A8\z:}', "");;
    Expect(1, 130040, '\p{Numeric_Value=8}', "");
    Expect(0, 130040, '\p{^Numeric_Value=8}', "");
    Expect(0, 130040, '\P{Numeric_Value=8}', "");
    Expect(1, 130040, '\P{^Numeric_Value=8}', "");
    Expect(0, 130041, '\p{Numeric_Value=8}', "");
    Expect(1, 130041, '\p{^Numeric_Value=8}', "");
    Expect(1, 130041, '\P{Numeric_Value=8}', "");
    Expect(0, 130041, '\P{^Numeric_Value=8}', "");
    Expect(1, 130040, '\p{Numeric_Value=8.000000000000000e+00}', "");
    Expect(0, 130040, '\p{^Numeric_Value=8.000000000000000e+00}', "");
    Expect(0, 130040, '\P{Numeric_Value=8.000000000000000e+00}', "");
    Expect(1, 130040, '\P{^Numeric_Value=8.000000000000000e+00}', "");
    Expect(0, 130041, '\p{Numeric_Value=8.000000000000000e+00}', "");
    Expect(1, 130041, '\p{^Numeric_Value=8.000000000000000e+00}', "");
    Expect(1, 130041, '\P{Numeric_Value=8.000000000000000e+00}', "");
    Expect(0, 130041, '\P{^Numeric_Value=8.000000000000000e+00}', "");
    Error('\p{Nv=-:=000_8}');
    Error('\P{Nv=-:=000_8}');
    Expect(1, 130040, '\p{Nv=:\A8\z:}', "");;
    Expect(0, 130041, '\p{Nv=:\A8\z:}', "");;
    Expect(1, 130040, '\p{Nv=00008}', "");
    Expect(0, 130040, '\p{^Nv=00008}', "");
    Expect(0, 130040, '\P{Nv=00008}', "");
    Expect(1, 130040, '\P{^Nv=00008}', "");
    Expect(0, 130041, '\p{Nv=00008}', "");
    Expect(1, 130041, '\p{^Nv=00008}', "");
    Expect(1, 130041, '\P{Nv=00008}', "");
    Expect(0, 130041, '\P{^Nv=00008}', "");
    Expect(1, 130040, '\p{Nv=8.000000000000000e+00}', "");
    Expect(0, 130040, '\p{^Nv=8.000000000000000e+00}', "");
    Expect(0, 130040, '\P{Nv=8.000000000000000e+00}', "");
    Expect(1, 130040, '\P{^Nv=8.000000000000000e+00}', "");
    Expect(0, 130041, '\p{Nv=8.000000000000000e+00}', "");
    Expect(1, 130041, '\p{^Nv=8.000000000000000e+00}', "");
    Expect(1, 130041, '\P{Nv=8.000000000000000e+00}', "");
    Expect(0, 130041, '\P{^Nv=8.000000000000000e+00}', "");
    Error('\p{Is_Numeric_Value:	 /a/+008}');
    Error('\P{Is_Numeric_Value:	 /a/+008}');
    Expect(1, 130040, '\p{Is_Numeric_Value=+00_00_00_00_8}', "");
    Expect(0, 130040, '\p{^Is_Numeric_Value=+00_00_00_00_8}', "");
    Expect(0, 130040, '\P{Is_Numeric_Value=+00_00_00_00_8}', "");
    Expect(1, 130040, '\P{^Is_Numeric_Value=+00_00_00_00_8}', "");
    Expect(0, 130041, '\p{Is_Numeric_Value=+00_00_00_00_8}', "");
    Expect(1, 130041, '\p{^Is_Numeric_Value=+00_00_00_00_8}', "");
    Expect(1, 130041, '\P{Is_Numeric_Value=+00_00_00_00_8}', "");
    Expect(0, 130041, '\P{^Is_Numeric_Value=+00_00_00_00_8}', "");
    Expect(1, 130040, '\p{Is_Numeric_Value=8.000000000000000e+00}', "");
    Expect(0, 130040, '\p{^Is_Numeric_Value=8.000000000000000e+00}', "");
    Expect(0, 130040, '\P{Is_Numeric_Value=8.000000000000000e+00}', "");
    Expect(1, 130040, '\P{^Is_Numeric_Value=8.000000000000000e+00}', "");
    Expect(0, 130041, '\p{Is_Numeric_Value=8.000000000000000e+00}', "");
    Expect(1, 130041, '\p{^Is_Numeric_Value=8.000000000000000e+00}', "");
    Expect(1, 130041, '\P{Is_Numeric_Value=8.000000000000000e+00}', "");
    Expect(0, 130041, '\P{^Is_Numeric_Value=8.000000000000000e+00}', "");
    Error('\p{Is_Nv=/a/-0008}');
    Error('\P{Is_Nv=/a/-0008}');
    Expect(1, 130040, '\p{Is_Nv=+8}', "");
    Expect(0, 130040, '\p{^Is_Nv=+8}', "");
    Expect(0, 130040, '\P{Is_Nv=+8}', "");
    Expect(1, 130040, '\P{^Is_Nv=+8}', "");
    Expect(0, 130041, '\p{Is_Nv=+8}', "");
    Expect(1, 130041, '\p{^Is_Nv=+8}', "");
    Expect(1, 130041, '\P{Is_Nv=+8}', "");
    Expect(0, 130041, '\P{^Is_Nv=+8}', "");
    Expect(1, 130040, '\p{Is_Nv=8.000000000000000e+00}', "");
    Expect(0, 130040, '\p{^Is_Nv=8.000000000000000e+00}', "");
    Expect(0, 130040, '\P{Is_Nv=8.000000000000000e+00}', "");
    Expect(1, 130040, '\P{^Is_Nv=8.000000000000000e+00}', "");
    Expect(0, 130041, '\p{Is_Nv=8.000000000000000e+00}', "");
    Expect(1, 130041, '\p{^Is_Nv=8.000000000000000e+00}', "");
    Expect(1, 130041, '\P{Is_Nv=8.000000000000000e+00}', "");
    Expect(0, 130041, '\P{^Is_Nv=8.000000000000000e+00}', "");
    Error('\p{Numeric_Value:	-0080/a/}');
    Error('\P{Numeric_Value:	-0080/a/}');
    Expect(1, 126225, '\p{Numeric_Value=:\A80\z:}', "");;
    Expect(0, 126226, '\p{Numeric_Value=:\A80\z:}', "");;
    Expect(1, 126225, '\p{Numeric_Value: +8_0}', "");
    Expect(0, 126225, '\p{^Numeric_Value: +8_0}', "");
    Expect(0, 126225, '\P{Numeric_Value: +8_0}', "");
    Expect(1, 126225, '\P{^Numeric_Value: +8_0}', "");
    Expect(0, 126226, '\p{Numeric_Value: +8_0}', "");
    Expect(1, 126226, '\p{^Numeric_Value: +8_0}', "");
    Expect(1, 126226, '\P{Numeric_Value: +8_0}', "");
    Expect(0, 126226, '\P{^Numeric_Value: +8_0}', "");
    Expect(1, 126225, '\p{Numeric_Value=8.000000000000000e+01}', "");
    Expect(0, 126225, '\p{^Numeric_Value=8.000000000000000e+01}', "");
    Expect(0, 126225, '\P{Numeric_Value=8.000000000000000e+01}', "");
    Expect(1, 126225, '\P{^Numeric_Value=8.000000000000000e+01}', "");
    Expect(0, 126226, '\p{Numeric_Value=8.000000000000000e+01}', "");
    Expect(1, 126226, '\p{^Numeric_Value=8.000000000000000e+01}', "");
    Expect(1, 126226, '\P{Numeric_Value=8.000000000000000e+01}', "");
    Expect(0, 126226, '\P{^Numeric_Value=8.000000000000000e+01}', "");
    Error('\p{Nv=	:=+0000000080}');
    Error('\P{Nv=	:=+0000000080}');
    Expect(1, 126225, '\p{Nv=:\A80\z:}', "");;
    Expect(0, 126226, '\p{Nv=:\A80\z:}', "");;
    Expect(1, 126225, '\p{Nv=000000080}', "");
    Expect(0, 126225, '\p{^Nv=000000080}', "");
    Expect(0, 126225, '\P{Nv=000000080}', "");
    Expect(1, 126225, '\P{^Nv=000000080}', "");
    Expect(0, 126226, '\p{Nv=000000080}', "");
    Expect(1, 126226, '\p{^Nv=000000080}', "");
    Expect(1, 126226, '\P{Nv=000000080}', "");
    Expect(0, 126226, '\P{^Nv=000000080}', "");
    Expect(1, 126225, '\p{Nv:8.000000000000000e+01}', "");
    Expect(0, 126225, '\p{^Nv:8.000000000000000e+01}', "");
    Expect(0, 126225, '\P{Nv:8.000000000000000e+01}', "");
    Expect(1, 126225, '\P{^Nv:8.000000000000000e+01}', "");
    Expect(0, 126226, '\p{Nv:8.000000000000000e+01}', "");
    Expect(1, 126226, '\p{^Nv:8.000000000000000e+01}', "");
    Expect(1, 126226, '\P{Nv:8.000000000000000e+01}', "");
    Expect(0, 126226, '\P{^Nv:8.000000000000000e+01}', "");
    Error('\p{Is_Numeric_Value:   _-00_00_00_00_080:=}');
    Error('\P{Is_Numeric_Value:   _-00_00_00_00_080:=}');
    Expect(1, 126225, '\p{Is_Numeric_Value=+0_0_0_0_0_0_00080}', "");
    Expect(0, 126225, '\p{^Is_Numeric_Value=+0_0_0_0_0_0_00080}', "");
    Expect(0, 126225, '\P{Is_Numeric_Value=+0_0_0_0_0_0_00080}', "");
    Expect(1, 126225, '\P{^Is_Numeric_Value=+0_0_0_0_0_0_00080}', "");
    Expect(0, 126226, '\p{Is_Numeric_Value=+0_0_0_0_0_0_00080}', "");
    Expect(1, 126226, '\p{^Is_Numeric_Value=+0_0_0_0_0_0_00080}', "");
    Expect(1, 126226, '\P{Is_Numeric_Value=+0_0_0_0_0_0_00080}', "");
    Expect(0, 126226, '\P{^Is_Numeric_Value=+0_0_0_0_0_0_00080}', "");
    Expect(1, 126225, '\p{Is_Numeric_Value=8.000000000000000e+01}', "");
    Expect(0, 126225, '\p{^Is_Numeric_Value=8.000000000000000e+01}', "");
    Expect(0, 126225, '\P{Is_Numeric_Value=8.000000000000000e+01}', "");
    Expect(1, 126225, '\P{^Is_Numeric_Value=8.000000000000000e+01}', "");
    Expect(0, 126226, '\p{Is_Numeric_Value=8.000000000000000e+01}', "");
    Expect(1, 126226, '\p{^Is_Numeric_Value=8.000000000000000e+01}', "");
    Expect(1, 126226, '\P{Is_Numeric_Value=8.000000000000000e+01}', "");
    Expect(0, 126226, '\P{^Is_Numeric_Value=8.000000000000000e+01}', "");
    Error('\p{Is_Nv:	:=__0_0_0_0_80}');
    Error('\P{Is_Nv:	:=__0_0_0_0_80}');
    Expect(1, 126225, '\p{Is_Nv=+8_0}', "");
    Expect(0, 126225, '\p{^Is_Nv=+8_0}', "");
    Expect(0, 126225, '\P{Is_Nv=+8_0}', "");
    Expect(1, 126225, '\P{^Is_Nv=+8_0}', "");
    Expect(0, 126226, '\p{Is_Nv=+8_0}', "");
    Expect(1, 126226, '\p{^Is_Nv=+8_0}', "");
    Expect(1, 126226, '\P{Is_Nv=+8_0}', "");
    Expect(0, 126226, '\P{^Is_Nv=+8_0}', "");
    Expect(1, 126225, '\p{Is_Nv=8.000000000000000e+01}', "");
    Expect(0, 126225, '\p{^Is_Nv=8.000000000000000e+01}', "");
    Expect(0, 126225, '\P{Is_Nv=8.000000000000000e+01}', "");
    Expect(1, 126225, '\P{^Is_Nv=8.000000000000000e+01}', "");
    Expect(0, 126226, '\p{Is_Nv=8.000000000000000e+01}', "");
    Expect(1, 126226, '\p{^Is_Nv=8.000000000000000e+01}', "");
    Expect(1, 126226, '\P{Is_Nv=8.000000000000000e+01}', "");
    Expect(0, 126226, '\P{^Is_Nv=8.000000000000000e+01}', "");
    Error('\p{Numeric_Value= :=0800}');
    Error('\P{Numeric_Value= :=0800}');
    Expect(1, 126234, '\p{Numeric_Value=:\A800\z:}', "");;
    Expect(0, 126235, '\p{Numeric_Value=:\A800\z:}', "");;
    Expect(1, 126234, '\p{Numeric_Value=+0_0_0_0_0_0_000800}', "");
    Expect(0, 126234, '\p{^Numeric_Value=+0_0_0_0_0_0_000800}', "");
    Expect(0, 126234, '\P{Numeric_Value=+0_0_0_0_0_0_000800}', "");
    Expect(1, 126234, '\P{^Numeric_Value=+0_0_0_0_0_0_000800}', "");
    Expect(0, 126235, '\p{Numeric_Value=+0_0_0_0_0_0_000800}', "");
    Expect(1, 126235, '\p{^Numeric_Value=+0_0_0_0_0_0_000800}', "");
    Expect(1, 126235, '\P{Numeric_Value=+0_0_0_0_0_0_000800}', "");
    Expect(0, 126235, '\P{^Numeric_Value=+0_0_0_0_0_0_000800}', "");
    Expect(1, 126234, '\p{Numeric_Value=8.000000000000000e+02}', "");
    Expect(0, 126234, '\p{^Numeric_Value=8.000000000000000e+02}', "");
    Expect(0, 126234, '\P{Numeric_Value=8.000000000000000e+02}', "");
    Expect(1, 126234, '\P{^Numeric_Value=8.000000000000000e+02}', "");
    Expect(0, 126235, '\p{Numeric_Value=8.000000000000000e+02}', "");
    Expect(1, 126235, '\p{^Numeric_Value=8.000000000000000e+02}', "");
    Expect(1, 126235, '\P{Numeric_Value=8.000000000000000e+02}', "");
    Expect(0, 126235, '\P{^Numeric_Value=8.000000000000000e+02}', "");
    Error('\p{Nv=/a/	0_0_0_0_0_0800}');
    Error('\P{Nv=/a/	0_0_0_0_0_0800}');
    Expect(1, 126234, '\p{Nv=:\A800\z:}', "");;
    Expect(0, 126235, '\p{Nv=:\A800\z:}', "");;
    Expect(1, 126234, '\p{Nv=+00_00_00_00_800}', "");
    Expect(0, 126234, '\p{^Nv=+00_00_00_00_800}', "");
    Expect(0, 126234, '\P{Nv=+00_00_00_00_800}', "");
    Expect(1, 126234, '\P{^Nv=+00_00_00_00_800}', "");
    Expect(0, 126235, '\p{Nv=+00_00_00_00_800}', "");
    Expect(1, 126235, '\p{^Nv=+00_00_00_00_800}', "");
    Expect(1, 126235, '\P{Nv=+00_00_00_00_800}', "");
    Expect(0, 126235, '\P{^Nv=+00_00_00_00_800}', "");
    Expect(1, 126234, '\p{Nv=8.000000000000000e+02}', "");
    Expect(0, 126234, '\p{^Nv=8.000000000000000e+02}', "");
    Expect(0, 126234, '\P{Nv=8.000000000000000e+02}', "");
    Expect(1, 126234, '\P{^Nv=8.000000000000000e+02}', "");
    Expect(0, 126235, '\p{Nv=8.000000000000000e+02}', "");
    Expect(1, 126235, '\p{^Nv=8.000000000000000e+02}', "");
    Expect(1, 126235, '\P{Nv=8.000000000000000e+02}', "");
    Expect(0, 126235, '\P{^Nv=8.000000000000000e+02}', "");
    Error('\p{Is_Numeric_Value=-	0800:=}');
    Error('\P{Is_Numeric_Value=-	0800:=}');
    Expect(1, 126234, '\p{Is_Numeric_Value=00_00_80_0}', "");
    Expect(0, 126234, '\p{^Is_Numeric_Value=00_00_80_0}', "");
    Expect(0, 126234, '\P{Is_Numeric_Value=00_00_80_0}', "");
    Expect(1, 126234, '\P{^Is_Numeric_Value=00_00_80_0}', "");
    Expect(0, 126235, '\p{Is_Numeric_Value=00_00_80_0}', "");
    Expect(1, 126235, '\p{^Is_Numeric_Value=00_00_80_0}', "");
    Expect(1, 126235, '\P{Is_Numeric_Value=00_00_80_0}', "");
    Expect(0, 126235, '\P{^Is_Numeric_Value=00_00_80_0}', "");
    Expect(1, 126234, '\p{Is_Numeric_Value=8.000000000000000e+02}', "");
    Expect(0, 126234, '\p{^Is_Numeric_Value=8.000000000000000e+02}', "");
    Expect(0, 126234, '\P{Is_Numeric_Value=8.000000000000000e+02}', "");
    Expect(1, 126234, '\P{^Is_Numeric_Value=8.000000000000000e+02}', "");
    Expect(0, 126235, '\p{Is_Numeric_Value=8.000000000000000e+02}', "");
    Expect(1, 126235, '\p{^Is_Numeric_Value=8.000000000000000e+02}', "");
    Expect(1, 126235, '\P{Is_Numeric_Value=8.000000000000000e+02}', "");
    Expect(0, 126235, '\P{^Is_Numeric_Value=8.000000000000000e+02}', "");
    Error('\p{Is_Nv=--0080_0/a/}');
    Error('\P{Is_Nv=--0080_0/a/}');
    Expect(1, 126234, '\p{Is_Nv=000000800}', "");
    Expect(0, 126234, '\p{^Is_Nv=000000800}', "");
    Expect(0, 126234, '\P{Is_Nv=000000800}', "");
    Expect(1, 126234, '\P{^Is_Nv=000000800}', "");
    Expect(0, 126235, '\p{Is_Nv=000000800}', "");
    Expect(1, 126235, '\p{^Is_Nv=000000800}', "");
    Expect(1, 126235, '\P{Is_Nv=000000800}', "");
    Expect(0, 126235, '\P{^Is_Nv=000000800}', "");
    Expect(1, 126234, '\p{Is_Nv=8.000000000000000e+02}', "");
    Expect(0, 126234, '\p{^Is_Nv=8.000000000000000e+02}', "");
    Expect(0, 126234, '\P{Is_Nv=8.000000000000000e+02}', "");
    Expect(1, 126234, '\P{^Is_Nv=8.000000000000000e+02}', "");
    Expect(0, 126235, '\p{Is_Nv=8.000000000000000e+02}', "");
    Expect(1, 126235, '\p{^Is_Nv=8.000000000000000e+02}', "");
    Expect(1, 126235, '\P{Is_Nv=8.000000000000000e+02}', "");
    Expect(0, 126235, '\P{^Is_Nv=8.000000000000000e+02}', "");
    Error('\p{Numeric_Value=_:=00000800_0}');
    Error('\P{Numeric_Value=_:=00000800_0}');
    Expect(1, 126243, '\p{Numeric_Value=:\A8000\z:}', "");;
    Expect(0, 126244, '\p{Numeric_Value=:\A8000\z:}', "");;
    Expect(1, 126243, '\p{Numeric_Value=00000000800_0}', "");
    Expect(0, 126243, '\p{^Numeric_Value=00000000800_0}', "");
    Expect(0, 126243, '\P{Numeric_Value=00000000800_0}', "");
    Expect(1, 126243, '\P{^Numeric_Value=00000000800_0}', "");
    Expect(0, 126244, '\p{Numeric_Value=00000000800_0}', "");
    Expect(1, 126244, '\p{^Numeric_Value=00000000800_0}', "");
    Expect(1, 126244, '\P{Numeric_Value=00000000800_0}', "");
    Expect(0, 126244, '\P{^Numeric_Value=00000000800_0}', "");
    Expect(1, 126243, '\p{Numeric_Value=8.000000000000000e+03}', "");
    Expect(0, 126243, '\p{^Numeric_Value=8.000000000000000e+03}', "");
    Expect(0, 126243, '\P{Numeric_Value=8.000000000000000e+03}', "");
    Expect(1, 126243, '\P{^Numeric_Value=8.000000000000000e+03}', "");
    Expect(0, 126244, '\p{Numeric_Value=8.000000000000000e+03}', "");
    Expect(1, 126244, '\p{^Numeric_Value=8.000000000000000e+03}', "");
    Expect(1, 126244, '\P{Numeric_Value=8.000000000000000e+03}', "");
    Expect(0, 126244, '\P{^Numeric_Value=8.000000000000000e+03}', "");
    Error('\p{Nv=/a/ -0000008000}');
    Error('\P{Nv=/a/ -0000008000}');
    Expect(1, 126243, '\p{Nv=:\A8000\z:}', "");;
    Expect(0, 126244, '\p{Nv=:\A8000\z:}', "");;
    Expect(1, 126243, '\p{Nv=00008000}', "");
    Expect(0, 126243, '\p{^Nv=00008000}', "");
    Expect(0, 126243, '\P{Nv=00008000}', "");
    Expect(1, 126243, '\P{^Nv=00008000}', "");
    Expect(0, 126244, '\p{Nv=00008000}', "");
    Expect(1, 126244, '\p{^Nv=00008000}', "");
    Expect(1, 126244, '\P{Nv=00008000}', "");
    Expect(0, 126244, '\P{^Nv=00008000}', "");
    Expect(1, 126243, '\p{Nv:	8.000000000000000e+03}', "");
    Expect(0, 126243, '\p{^Nv:	8.000000000000000e+03}', "");
    Expect(0, 126243, '\P{Nv:	8.000000000000000e+03}', "");
    Expect(1, 126243, '\P{^Nv:	8.000000000000000e+03}', "");
    Expect(0, 126244, '\p{Nv:	8.000000000000000e+03}', "");
    Expect(1, 126244, '\p{^Nv:	8.000000000000000e+03}', "");
    Expect(1, 126244, '\P{Nv:	8.000000000000000e+03}', "");
    Expect(0, 126244, '\P{^Nv:	8.000000000000000e+03}', "");
    Error('\p{Is_Numeric_Value=/a/ 08000}');
    Error('\P{Is_Numeric_Value=/a/ 08000}');
    Expect(1, 126243, '\p{Is_Numeric_Value=0_0_8_0_00}', "");
    Expect(0, 126243, '\p{^Is_Numeric_Value=0_0_8_0_00}', "");
    Expect(0, 126243, '\P{Is_Numeric_Value=0_0_8_0_00}', "");
    Expect(1, 126243, '\P{^Is_Numeric_Value=0_0_8_0_00}', "");
    Expect(0, 126244, '\p{Is_Numeric_Value=0_0_8_0_00}', "");
    Expect(1, 126244, '\p{^Is_Numeric_Value=0_0_8_0_00}', "");
    Expect(1, 126244, '\P{Is_Numeric_Value=0_0_8_0_00}', "");
    Expect(0, 126244, '\P{^Is_Numeric_Value=0_0_8_0_00}', "");
    Expect(1, 126243, '\p{Is_Numeric_Value=8.000000000000000e+03}', "");
    Expect(0, 126243, '\p{^Is_Numeric_Value=8.000000000000000e+03}', "");
    Expect(0, 126243, '\P{Is_Numeric_Value=8.000000000000000e+03}', "");
    Expect(1, 126243, '\P{^Is_Numeric_Value=8.000000000000000e+03}', "");
    Expect(0, 126244, '\p{Is_Numeric_Value=8.000000000000000e+03}', "");
    Expect(1, 126244, '\p{^Is_Numeric_Value=8.000000000000000e+03}', "");
    Expect(1, 126244, '\P{Is_Numeric_Value=8.000000000000000e+03}', "");
    Expect(0, 126244, '\P{^Is_Numeric_Value=8.000000000000000e+03}', "");
    Error('\p{Is_Nv=/a/__0008000}');
    Error('\P{Is_Nv=/a/__0008000}');
    Expect(1, 126243, '\p{Is_Nv=+8_0_00}', "");
    Expect(0, 126243, '\p{^Is_Nv=+8_0_00}', "");
    Expect(0, 126243, '\P{Is_Nv=+8_0_00}', "");
    Expect(1, 126243, '\P{^Is_Nv=+8_0_00}', "");
    Expect(0, 126244, '\p{Is_Nv=+8_0_00}', "");
    Expect(1, 126244, '\p{^Is_Nv=+8_0_00}', "");
    Expect(1, 126244, '\P{Is_Nv=+8_0_00}', "");
    Expect(0, 126244, '\P{^Is_Nv=+8_0_00}', "");
    Expect(1, 126243, '\p{Is_Nv=8.000000000000000e+03}', "");
    Expect(0, 126243, '\p{^Is_Nv=8.000000000000000e+03}', "");
    Expect(0, 126243, '\P{Is_Nv=8.000000000000000e+03}', "");
    Expect(1, 126243, '\P{^Is_Nv=8.000000000000000e+03}', "");
    Expect(0, 126244, '\p{Is_Nv=8.000000000000000e+03}', "");
    Expect(1, 126244, '\p{^Is_Nv=8.000000000000000e+03}', "");
    Expect(1, 126244, '\P{Is_Nv=8.000000000000000e+03}', "");
    Expect(0, 126244, '\P{^Is_Nv=8.000000000000000e+03}', "");
    Error('\p{Numeric_Value=/a/_00_00_00_00_80_00_0}');
    Error('\P{Numeric_Value=/a/_00_00_00_00_80_00_0}');
    Expect(1, 126252, '\p{Numeric_Value=:\A80000\z:}', "");;
    Expect(0, 126253, '\p{Numeric_Value=:\A80000\z:}', "");;
    Expect(1, 126252, '\p{Numeric_Value=+0_0_8_0_000}', "");
    Expect(0, 126252, '\p{^Numeric_Value=+0_0_8_0_000}', "");
    Expect(0, 126252, '\P{Numeric_Value=+0_0_8_0_000}', "");
    Expect(1, 126252, '\P{^Numeric_Value=+0_0_8_0_000}', "");
    Expect(0, 126253, '\p{Numeric_Value=+0_0_8_0_000}', "");
    Expect(1, 126253, '\p{^Numeric_Value=+0_0_8_0_000}', "");
    Expect(1, 126253, '\P{Numeric_Value=+0_0_8_0_000}', "");
    Expect(0, 126253, '\P{^Numeric_Value=+0_0_8_0_000}', "");
    Expect(1, 126252, '\p{Numeric_Value=8.000000000000000e+04}', "");
    Expect(0, 126252, '\p{^Numeric_Value=8.000000000000000e+04}', "");
    Expect(0, 126252, '\P{Numeric_Value=8.000000000000000e+04}', "");
    Expect(1, 126252, '\P{^Numeric_Value=8.000000000000000e+04}', "");
    Expect(0, 126253, '\p{Numeric_Value=8.000000000000000e+04}', "");
    Expect(1, 126253, '\p{^Numeric_Value=8.000000000000000e+04}', "");
    Expect(1, 126253, '\P{Numeric_Value=8.000000000000000e+04}', "");
    Expect(0, 126253, '\P{^Numeric_Value=8.000000000000000e+04}', "");
    Error('\p{Nv=-+0000000080000:=}');
    Error('\P{Nv=-+0000000080000:=}');
    Expect(1, 126252, '\p{Nv=:\A80000\z:}', "");;
    Expect(0, 126253, '\p{Nv=:\A80000\z:}', "");;
    Expect(1, 126252, '\p{Nv=080000}', "");
    Expect(0, 126252, '\p{^Nv=080000}', "");
    Expect(0, 126252, '\P{Nv=080000}', "");
    Expect(1, 126252, '\P{^Nv=080000}', "");
    Expect(0, 126253, '\p{Nv=080000}', "");
    Expect(1, 126253, '\p{^Nv=080000}', "");
    Expect(1, 126253, '\P{Nv=080000}', "");
    Expect(0, 126253, '\P{^Nv=080000}', "");
    Expect(1, 126252, '\p{Nv=8.000000000000000e+04}', "");
    Expect(0, 126252, '\p{^Nv=8.000000000000000e+04}', "");
    Expect(0, 126252, '\P{Nv=8.000000000000000e+04}', "");
    Expect(1, 126252, '\P{^Nv=8.000000000000000e+04}', "");
    Expect(0, 126253, '\p{Nv=8.000000000000000e+04}', "");
    Expect(1, 126253, '\p{^Nv=8.000000000000000e+04}', "");
    Expect(1, 126253, '\P{Nv=8.000000000000000e+04}', "");
    Expect(0, 126253, '\P{^Nv=8.000000000000000e+04}', "");
    Error('\p{Is_Numeric_Value= -00_80_00_0:=}');
    Error('\P{Is_Numeric_Value= -00_80_00_0:=}');
    Expect(1, 126252, '\p{Is_Numeric_Value=0_0_0_8_0000}', "");
    Expect(0, 126252, '\p{^Is_Numeric_Value=0_0_0_8_0000}', "");
    Expect(0, 126252, '\P{Is_Numeric_Value=0_0_0_8_0000}', "");
    Expect(1, 126252, '\P{^Is_Numeric_Value=0_0_0_8_0000}', "");
    Expect(0, 126253, '\p{Is_Numeric_Value=0_0_0_8_0000}', "");
    Expect(1, 126253, '\p{^Is_Numeric_Value=0_0_0_8_0000}', "");
    Expect(1, 126253, '\P{Is_Numeric_Value=0_0_0_8_0000}', "");
    Expect(0, 126253, '\P{^Is_Numeric_Value=0_0_0_8_0000}', "");
    Expect(1, 126252, '\p{Is_Numeric_Value=8.000000000000000e+04}', "");
    Expect(0, 126252, '\p{^Is_Numeric_Value=8.000000000000000e+04}', "");
    Expect(0, 126252, '\P{Is_Numeric_Value=8.000000000000000e+04}', "");
    Expect(1, 126252, '\P{^Is_Numeric_Value=8.000000000000000e+04}', "");
    Expect(0, 126253, '\p{Is_Numeric_Value=8.000000000000000e+04}', "");
    Expect(1, 126253, '\p{^Is_Numeric_Value=8.000000000000000e+04}', "");
    Expect(1, 126253, '\P{Is_Numeric_Value=8.000000000000000e+04}', "");
    Expect(0, 126253, '\P{^Is_Numeric_Value=8.000000000000000e+04}', "");
    Error('\p{Is_Nv=:= 	0_0_0_0_0_0_80000}');
    Error('\P{Is_Nv=:= 	0_0_0_0_0_0_80000}');
    Expect(1, 126252, '\p{Is_Nv=+80_00_0}', "");
    Expect(0, 126252, '\p{^Is_Nv=+80_00_0}', "");
    Expect(0, 126252, '\P{Is_Nv=+80_00_0}', "");
    Expect(1, 126252, '\P{^Is_Nv=+80_00_0}', "");
    Expect(0, 126253, '\p{Is_Nv=+80_00_0}', "");
    Expect(1, 126253, '\p{^Is_Nv=+80_00_0}', "");
    Expect(1, 126253, '\P{Is_Nv=+80_00_0}', "");
    Expect(0, 126253, '\P{^Is_Nv=+80_00_0}', "");
    Expect(1, 126252, '\p{Is_Nv:   8.000000000000000e+04}', "");
    Expect(0, 126252, '\p{^Is_Nv:   8.000000000000000e+04}', "");
    Expect(0, 126252, '\P{Is_Nv:   8.000000000000000e+04}', "");
    Expect(1, 126252, '\P{^Is_Nv:   8.000000000000000e+04}', "");
    Expect(0, 126253, '\p{Is_Nv:   8.000000000000000e+04}', "");
    Expect(1, 126253, '\p{^Is_Nv:   8.000000000000000e+04}', "");
    Expect(1, 126253, '\P{Is_Nv:   8.000000000000000e+04}', "");
    Expect(0, 126253, '\P{^Is_Nv:   8.000000000000000e+04}', "");
    Error('\p{Numeric_Value=	/a/0080000_0}');
    Error('\P{Numeric_Value=	/a/0080000_0}');
    Expect(1, 68084, '\p{Numeric_Value=:\A800000\z:}', "");;
    Expect(0, 68085, '\p{Numeric_Value=:\A800000\z:}', "");;
    Expect(1, 68084, '\p{Numeric_Value=800000}', "");
    Expect(0, 68084, '\p{^Numeric_Value=800000}', "");
    Expect(0, 68084, '\P{Numeric_Value=800000}', "");
    Expect(1, 68084, '\P{^Numeric_Value=800000}', "");
    Expect(0, 68085, '\p{Numeric_Value=800000}', "");
    Expect(1, 68085, '\p{^Numeric_Value=800000}', "");
    Expect(1, 68085, '\P{Numeric_Value=800000}', "");
    Expect(0, 68085, '\P{^Numeric_Value=800000}', "");
    Expect(1, 68084, '\p{Numeric_Value=8.000000000000000e+05}', "");
    Expect(0, 68084, '\p{^Numeric_Value=8.000000000000000e+05}', "");
    Expect(0, 68084, '\P{Numeric_Value=8.000000000000000e+05}', "");
    Expect(1, 68084, '\P{^Numeric_Value=8.000000000000000e+05}', "");
    Expect(0, 68085, '\p{Numeric_Value=8.000000000000000e+05}', "");
    Expect(1, 68085, '\p{^Numeric_Value=8.000000000000000e+05}', "");
    Expect(1, 68085, '\P{Numeric_Value=8.000000000000000e+05}', "");
    Expect(0, 68085, '\P{^Numeric_Value=8.000000000000000e+05}', "");
    Error('\p{Nv= /a/0000800000}');
    Error('\P{Nv= /a/0000800000}');
    Expect(1, 68084, '\p{Nv=:\A800000\z:}', "");;
    Expect(0, 68085, '\p{Nv=:\A800000\z:}', "");;
    Expect(1, 68084, '\p{Nv=080000_0}', "");
    Expect(0, 68084, '\p{^Nv=080000_0}', "");
    Expect(0, 68084, '\P{Nv=080000_0}', "");
    Expect(1, 68084, '\P{^Nv=080000_0}', "");
    Expect(0, 68085, '\p{Nv=080000_0}', "");
    Expect(1, 68085, '\p{^Nv=080000_0}', "");
    Expect(1, 68085, '\P{Nv=080000_0}', "");
    Expect(0, 68085, '\P{^Nv=080000_0}', "");
    Expect(1, 68084, '\p{Nv=8.000000000000000e+05}', "");
    Expect(0, 68084, '\p{^Nv=8.000000000000000e+05}', "");
    Expect(0, 68084, '\P{Nv=8.000000000000000e+05}', "");
    Expect(1, 68084, '\P{^Nv=8.000000000000000e+05}', "");
    Expect(0, 68085, '\p{Nv=8.000000000000000e+05}', "");
    Expect(1, 68085, '\p{^Nv=8.000000000000000e+05}', "");
    Expect(1, 68085, '\P{Nv=8.000000000000000e+05}', "");
    Expect(0, 68085, '\P{^Nv=8.000000000000000e+05}', "");
    Error('\p{Is_Numeric_Value=-	00000000800000/a/}');
    Error('\P{Is_Numeric_Value=-	00000000800000/a/}');
    Expect(1, 68084, '\p{Is_Numeric_Value=000000_008000_00}', "");
    Expect(0, 68084, '\p{^Is_Numeric_Value=000000_008000_00}', "");
    Expect(0, 68084, '\P{Is_Numeric_Value=000000_008000_00}', "");
    Expect(1, 68084, '\P{^Is_Numeric_Value=000000_008000_00}', "");
    Expect(0, 68085, '\p{Is_Numeric_Value=000000_008000_00}', "");
    Expect(1, 68085, '\p{^Is_Numeric_Value=000000_008000_00}', "");
    Expect(1, 68085, '\P{Is_Numeric_Value=000000_008000_00}', "");
    Expect(0, 68085, '\P{^Is_Numeric_Value=000000_008000_00}', "");
    Expect(1, 68084, '\p{Is_Numeric_Value=8.000000000000000e+05}', "");
    Expect(0, 68084, '\p{^Is_Numeric_Value=8.000000000000000e+05}', "");
    Expect(0, 68084, '\P{Is_Numeric_Value=8.000000000000000e+05}', "");
    Expect(1, 68084, '\P{^Is_Numeric_Value=8.000000000000000e+05}', "");
    Expect(0, 68085, '\p{Is_Numeric_Value=8.000000000000000e+05}', "");
    Expect(1, 68085, '\p{^Is_Numeric_Value=8.000000000000000e+05}', "");
    Expect(1, 68085, '\P{Is_Numeric_Value=8.000000000000000e+05}', "");
    Expect(0, 68085, '\P{^Is_Numeric_Value=8.000000000000000e+05}', "");
    Error('\p{Is_Nv=	 0800000:=}');
    Error('\P{Is_Nv=	 0800000:=}');
    Expect(1, 68084, '\p{Is_Nv=+00800000}', "");
    Expect(0, 68084, '\p{^Is_Nv=+00800000}', "");
    Expect(0, 68084, '\P{Is_Nv=+00800000}', "");
    Expect(1, 68084, '\P{^Is_Nv=+00800000}', "");
    Expect(0, 68085, '\p{Is_Nv=+00800000}', "");
    Expect(1, 68085, '\p{^Is_Nv=+00800000}', "");
    Expect(1, 68085, '\P{Is_Nv=+00800000}', "");
    Expect(0, 68085, '\P{^Is_Nv=+00800000}', "");
    Expect(1, 68084, '\p{Is_Nv=8.000000000000000e+05}', "");
    Expect(0, 68084, '\p{^Is_Nv=8.000000000000000e+05}', "");
    Expect(0, 68084, '\P{Is_Nv=8.000000000000000e+05}', "");
    Expect(1, 68084, '\P{^Is_Nv=8.000000000000000e+05}', "");
    Expect(0, 68085, '\p{Is_Nv=8.000000000000000e+05}', "");
    Expect(1, 68085, '\p{^Is_Nv=8.000000000000000e+05}', "");
    Expect(1, 68085, '\P{Is_Nv=8.000000000000000e+05}', "");
    Expect(0, 68085, '\P{^Is_Nv=8.000000000000000e+05}', "");
    Error('\p{Numeric_Value=_0009:=}');
    Error('\P{Numeric_Value=_0009:=}');
    Expect(1, 194704, '\p{Numeric_Value=:\A9\z:}', "");;
    Expect(0, 194705, '\p{Numeric_Value=:\A9\z:}', "");;
    Expect(1, 194704, '\p{Numeric_Value=00009}', "");
    Expect(0, 194704, '\p{^Numeric_Value=00009}', "");
    Expect(0, 194704, '\P{Numeric_Value=00009}', "");
    Expect(1, 194704, '\P{^Numeric_Value=00009}', "");
    Expect(0, 194705, '\p{Numeric_Value=00009}', "");
    Expect(1, 194705, '\p{^Numeric_Value=00009}', "");
    Expect(1, 194705, '\P{Numeric_Value=00009}', "");
    Expect(0, 194705, '\P{^Numeric_Value=00009}', "");
    Expect(1, 194704, '\p{Numeric_Value=9.000000000000000e+00}', "");
    Expect(0, 194704, '\p{^Numeric_Value=9.000000000000000e+00}', "");
    Expect(0, 194704, '\P{Numeric_Value=9.000000000000000e+00}', "");
    Expect(1, 194704, '\P{^Numeric_Value=9.000000000000000e+00}', "");
    Expect(0, 194705, '\p{Numeric_Value=9.000000000000000e+00}', "");
    Expect(1, 194705, '\p{^Numeric_Value=9.000000000000000e+00}', "");
    Expect(1, 194705, '\P{Numeric_Value=9.000000000000000e+00}', "");
    Expect(0, 194705, '\P{^Numeric_Value=9.000000000000000e+00}', "");
    Error('\p{Nv=-+009/a/}');
    Error('\P{Nv=-+009/a/}');
    Expect(1, 194704, '\p{Nv=:\A9\z:}', "");;
    Expect(0, 194705, '\p{Nv=:\A9\z:}', "");;
    Expect(1, 194704, '\p{Nv=0_0_0_0_0_0_0_0_09}', "");
    Expect(0, 194704, '\p{^Nv=0_0_0_0_0_0_0_0_09}', "");
    Expect(0, 194704, '\P{Nv=0_0_0_0_0_0_0_0_09}', "");
    Expect(1, 194704, '\P{^Nv=0_0_0_0_0_0_0_0_09}', "");
    Expect(0, 194705, '\p{Nv=0_0_0_0_0_0_0_0_09}', "");
    Expect(1, 194705, '\p{^Nv=0_0_0_0_0_0_0_0_09}', "");
    Expect(1, 194705, '\P{Nv=0_0_0_0_0_0_0_0_09}', "");
    Expect(0, 194705, '\P{^Nv=0_0_0_0_0_0_0_0_09}', "");
    Expect(1, 194704, '\p{Nv=9.000000000000000e+00}', "");
    Expect(0, 194704, '\p{^Nv=9.000000000000000e+00}', "");
    Expect(0, 194704, '\P{Nv=9.000000000000000e+00}', "");
    Expect(1, 194704, '\P{^Nv=9.000000000000000e+00}', "");
    Expect(0, 194705, '\p{Nv=9.000000000000000e+00}', "");
    Expect(1, 194705, '\p{^Nv=9.000000000000000e+00}', "");
    Expect(1, 194705, '\P{Nv=9.000000000000000e+00}', "");
    Expect(0, 194705, '\P{^Nv=9.000000000000000e+00}', "");
    Error('\p{Is_Numeric_Value=:=-	+0_9}');
    Error('\P{Is_Numeric_Value=:=-	+0_9}');
    Expect(1, 194704, '\p{Is_Numeric_Value=00_9}', "");
    Expect(0, 194704, '\p{^Is_Numeric_Value=00_9}', "");
    Expect(0, 194704, '\P{Is_Numeric_Value=00_9}', "");
    Expect(1, 194704, '\P{^Is_Numeric_Value=00_9}', "");
    Expect(0, 194705, '\p{Is_Numeric_Value=00_9}', "");
    Expect(1, 194705, '\p{^Is_Numeric_Value=00_9}', "");
    Expect(1, 194705, '\P{Is_Numeric_Value=00_9}', "");
    Expect(0, 194705, '\P{^Is_Numeric_Value=00_9}', "");
    Expect(1, 194704, '\p{Is_Numeric_Value=9.000000000000000e+00}', "");
    Expect(0, 194704, '\p{^Is_Numeric_Value=9.000000000000000e+00}', "");
    Expect(0, 194704, '\P{Is_Numeric_Value=9.000000000000000e+00}', "");
    Expect(1, 194704, '\P{^Is_Numeric_Value=9.000000000000000e+00}', "");
    Expect(0, 194705, '\p{Is_Numeric_Value=9.000000000000000e+00}', "");
    Expect(1, 194705, '\p{^Is_Numeric_Value=9.000000000000000e+00}', "");
    Expect(1, 194705, '\P{Is_Numeric_Value=9.000000000000000e+00}', "");
    Expect(0, 194705, '\P{^Is_Numeric_Value=9.000000000000000e+00}', "");
    Error('\p{Is_Nv=:=-+00009}');
    Error('\P{Is_Nv=:=-+00009}');
    Expect(1, 194704, '\p{Is_Nv=00_9}', "");
    Expect(0, 194704, '\p{^Is_Nv=00_9}', "");
    Expect(0, 194704, '\P{Is_Nv=00_9}', "");
    Expect(1, 194704, '\P{^Is_Nv=00_9}', "");
    Expect(0, 194705, '\p{Is_Nv=00_9}', "");
    Expect(1, 194705, '\p{^Is_Nv=00_9}', "");
    Expect(1, 194705, '\P{Is_Nv=00_9}', "");
    Expect(0, 194705, '\P{^Is_Nv=00_9}', "");
    Expect(1, 194704, '\p{Is_Nv=9.000000000000000e+00}', "");
    Expect(0, 194704, '\p{^Is_Nv=9.000000000000000e+00}', "");
    Expect(0, 194704, '\P{Is_Nv=9.000000000000000e+00}', "");
    Expect(1, 194704, '\P{^Is_Nv=9.000000000000000e+00}', "");
    Expect(0, 194705, '\p{Is_Nv=9.000000000000000e+00}', "");
    Expect(1, 194705, '\p{^Is_Nv=9.000000000000000e+00}', "");
    Expect(1, 194705, '\P{Is_Nv=9.000000000000000e+00}', "");
    Expect(0, 194705, '\P{^Is_Nv=9.000000000000000e+00}', "");
    Error('\p{Numeric_Value=-000009/000002:=}');
    Error('\P{Numeric_Value=-000009/000002:=}');
    Expect(1, 3886, '\p{Numeric_Value=:\A9/2\z:}', "");;
    Expect(0, 3887, '\p{Numeric_Value=:\A9/2\z:}', "");;
    Expect(1, 3886, '\p{Numeric_Value=+0009/2}', "");
    Expect(0, 3886, '\p{^Numeric_Value=+0009/2}', "");
    Expect(0, 3886, '\P{Numeric_Value=+0009/2}', "");
    Expect(1, 3886, '\P{^Numeric_Value=+0009/2}', "");
    Expect(0, 3887, '\p{Numeric_Value=+0009/2}', "");
    Expect(1, 3887, '\p{^Numeric_Value=+0009/2}', "");
    Expect(1, 3887, '\P{Numeric_Value=+0009/2}', "");
    Expect(0, 3887, '\P{^Numeric_Value=+0009/2}', "");
    Expect(1, 3886, '\p{Numeric_Value=540/120}', "");
    Expect(0, 3886, '\p{^Numeric_Value=540/120}', "");
    Expect(0, 3886, '\P{Numeric_Value=540/120}', "");
    Expect(1, 3886, '\P{^Numeric_Value=540/120}', "");
    Expect(0, 3887, '\p{Numeric_Value=540/120}', "");
    Expect(1, 3887, '\p{^Numeric_Value=540/120}', "");
    Expect(1, 3887, '\P{Numeric_Value=540/120}', "");
    Expect(0, 3887, '\P{^Numeric_Value=540/120}', "");
    Expect(1, 3886, '\p{Numeric_Value=4.5e+00}', "");
    Expect(0, 3886, '\p{^Numeric_Value=4.5e+00}', "");
    Expect(0, 3886, '\P{Numeric_Value=4.5e+00}', "");
    Expect(1, 3886, '\P{^Numeric_Value=4.5e+00}', "");
    Expect(0, 3887, '\p{Numeric_Value=4.5e+00}', "");
    Expect(1, 3887, '\p{^Numeric_Value=4.5e+00}', "");
    Expect(1, 3887, '\P{Numeric_Value=4.5e+00}', "");
    Expect(0, 3887, '\P{^Numeric_Value=4.5e+00}', "");
    Expect(1, 3886, '\p{Numeric_Value:4.5}', "");
    Expect(0, 3886, '\p{^Numeric_Value:4.5}', "");
    Expect(0, 3886, '\P{Numeric_Value:4.5}', "");
    Expect(1, 3886, '\P{^Numeric_Value:4.5}', "");
    Expect(0, 3887, '\p{Numeric_Value:4.5}', "");
    Expect(1, 3887, '\p{^Numeric_Value:4.5}', "");
    Expect(1, 3887, '\P{Numeric_Value:4.5}', "");
    Expect(0, 3887, '\P{^Numeric_Value:4.5}', "");
    Expect(1, 3886, '\p{Numeric_Value=4.50e+00}', "");
    Expect(0, 3886, '\p{^Numeric_Value=4.50e+00}', "");
    Expect(0, 3886, '\P{Numeric_Value=4.50e+00}', "");
    Expect(1, 3886, '\P{^Numeric_Value=4.50e+00}', "");
    Expect(0, 3887, '\p{Numeric_Value=4.50e+00}', "");
    Expect(1, 3887, '\p{^Numeric_Value=4.50e+00}', "");
    Expect(1, 3887, '\P{Numeric_Value=4.50e+00}', "");
    Expect(0, 3887, '\P{^Numeric_Value=4.50e+00}', "");
    Expect(1, 3886, '\p{Numeric_Value=4.50}', "");
    Expect(0, 3886, '\p{^Numeric_Value=4.50}', "");
    Expect(0, 3886, '\P{Numeric_Value=4.50}', "");
    Expect(1, 3886, '\P{^Numeric_Value=4.50}', "");
    Expect(0, 3887, '\p{Numeric_Value=4.50}', "");
    Expect(1, 3887, '\p{^Numeric_Value=4.50}', "");
    Expect(1, 3887, '\P{Numeric_Value=4.50}', "");
    Expect(0, 3887, '\P{^Numeric_Value=4.50}', "");
    Error('\p{Nv=-:=009/000002}');
    Error('\P{Nv=-:=009/000002}');
    Expect(1, 3886, '\p{Nv=:\A9/2\z:}', "");;
    Expect(0, 3887, '\p{Nv=:\A9/2\z:}', "");;
    Expect(1, 3886, '\p{Nv=+09/00002}', "");
    Expect(0, 3886, '\p{^Nv=+09/00002}', "");
    Expect(0, 3886, '\P{Nv=+09/00002}', "");
    Expect(1, 3886, '\P{^Nv=+09/00002}', "");
    Expect(0, 3887, '\p{Nv=+09/00002}', "");
    Expect(1, 3887, '\p{^Nv=+09/00002}', "");
    Expect(1, 3887, '\P{Nv=+09/00002}', "");
    Expect(0, 3887, '\P{^Nv=+09/00002}', "");
    Expect(1, 3886, '\p{Nv=540/120}', "");
    Expect(0, 3886, '\p{^Nv=540/120}', "");
    Expect(0, 3886, '\P{Nv=540/120}', "");
    Expect(1, 3886, '\P{^Nv=540/120}', "");
    Expect(0, 3887, '\p{Nv=540/120}', "");
    Expect(1, 3887, '\p{^Nv=540/120}', "");
    Expect(1, 3887, '\P{Nv=540/120}', "");
    Expect(0, 3887, '\P{^Nv=540/120}', "");
    Expect(1, 3886, '\p{Nv=4.5e+00}', "");
    Expect(0, 3886, '\p{^Nv=4.5e+00}', "");
    Expect(0, 3886, '\P{Nv=4.5e+00}', "");
    Expect(1, 3886, '\P{^Nv=4.5e+00}', "");
    Expect(0, 3887, '\p{Nv=4.5e+00}', "");
    Expect(1, 3887, '\p{^Nv=4.5e+00}', "");
    Expect(1, 3887, '\P{Nv=4.5e+00}', "");
    Expect(0, 3887, '\P{^Nv=4.5e+00}', "");
    Expect(1, 3886, '\p{Nv=4.5}', "");
    Expect(0, 3886, '\p{^Nv=4.5}', "");
    Expect(0, 3886, '\P{Nv=4.5}', "");
    Expect(1, 3886, '\P{^Nv=4.5}', "");
    Expect(0, 3887, '\p{Nv=4.5}', "");
    Expect(1, 3887, '\p{^Nv=4.5}', "");
    Expect(1, 3887, '\P{Nv=4.5}', "");
    Expect(0, 3887, '\P{^Nv=4.5}', "");
    Expect(1, 3886, '\p{Nv=4.50e+00}', "");
    Expect(0, 3886, '\p{^Nv=4.50e+00}', "");
    Expect(0, 3886, '\P{Nv=4.50e+00}', "");
    Expect(1, 3886, '\P{^Nv=4.50e+00}', "");
    Expect(0, 3887, '\p{Nv=4.50e+00}', "");
    Expect(1, 3887, '\p{^Nv=4.50e+00}', "");
    Expect(1, 3887, '\P{Nv=4.50e+00}', "");
    Expect(0, 3887, '\P{^Nv=4.50e+00}', "");
    Expect(1, 3886, '\p{Nv=4.50}', "");
    Expect(0, 3886, '\p{^Nv=4.50}', "");
    Expect(0, 3886, '\P{Nv=4.50}', "");
    Expect(1, 3886, '\P{^Nv=4.50}', "");
    Expect(0, 3887, '\p{Nv=4.50}', "");
    Expect(1, 3887, '\p{^Nv=4.50}', "");
    Expect(1, 3887, '\P{Nv=4.50}', "");
    Expect(0, 3887, '\P{^Nv=4.50}', "");
    Error('\p{Is_Numeric_Value=-000009/02/a/}');
    Error('\P{Is_Numeric_Value=-000009/02/a/}');
    Expect(1, 3886, '\p{Is_Numeric_Value=000009/000002}', "");
    Expect(0, 3886, '\p{^Is_Numeric_Value=000009/000002}', "");
    Expect(0, 3886, '\P{Is_Numeric_Value=000009/000002}', "");
    Expect(1, 3886, '\P{^Is_Numeric_Value=000009/000002}', "");
    Expect(0, 3887, '\p{Is_Numeric_Value=000009/000002}', "");
    Expect(1, 3887, '\p{^Is_Numeric_Value=000009/000002}', "");
    Expect(1, 3887, '\P{Is_Numeric_Value=000009/000002}', "");
    Expect(0, 3887, '\P{^Is_Numeric_Value=000009/000002}', "");
    Expect(1, 3886, '\p{Is_Numeric_Value=540/120}', "");
    Expect(0, 3886, '\p{^Is_Numeric_Value=540/120}', "");
    Expect(0, 3886, '\P{Is_Numeric_Value=540/120}', "");
    Expect(1, 3886, '\P{^Is_Numeric_Value=540/120}', "");
    Expect(0, 3887, '\p{Is_Numeric_Value=540/120}', "");
    Expect(1, 3887, '\p{^Is_Numeric_Value=540/120}', "");
    Expect(1, 3887, '\P{Is_Numeric_Value=540/120}', "");
    Expect(0, 3887, '\P{^Is_Numeric_Value=540/120}', "");
    Expect(1, 3886, '\p{Is_Numeric_Value=4.5e+00}', "");
    Expect(0, 3886, '\p{^Is_Numeric_Value=4.5e+00}', "");
    Expect(0, 3886, '\P{Is_Numeric_Value=4.5e+00}', "");
    Expect(1, 3886, '\P{^Is_Numeric_Value=4.5e+00}', "");
    Expect(0, 3887, '\p{Is_Numeric_Value=4.5e+00}', "");
    Expect(1, 3887, '\p{^Is_Numeric_Value=4.5e+00}', "");
    Expect(1, 3887, '\P{Is_Numeric_Value=4.5e+00}', "");
    Expect(0, 3887, '\P{^Is_Numeric_Value=4.5e+00}', "");
    Expect(1, 3886, '\p{Is_Numeric_Value=4.5}', "");
    Expect(0, 3886, '\p{^Is_Numeric_Value=4.5}', "");
    Expect(0, 3886, '\P{Is_Numeric_Value=4.5}', "");
    Expect(1, 3886, '\P{^Is_Numeric_Value=4.5}', "");
    Expect(0, 3887, '\p{Is_Numeric_Value=4.5}', "");
    Expect(1, 3887, '\p{^Is_Numeric_Value=4.5}', "");
    Expect(1, 3887, '\P{Is_Numeric_Value=4.5}', "");
    Expect(0, 3887, '\P{^Is_Numeric_Value=4.5}', "");
    Expect(1, 3886, '\p{Is_Numeric_Value=4.50e+00}', "");
    Expect(0, 3886, '\p{^Is_Numeric_Value=4.50e+00}', "");
    Expect(0, 3886, '\P{Is_Numeric_Value=4.50e+00}', "");
    Expect(1, 3886, '\P{^Is_Numeric_Value=4.50e+00}', "");
    Expect(0, 3887, '\p{Is_Numeric_Value=4.50e+00}', "");
    Expect(1, 3887, '\p{^Is_Numeric_Value=4.50e+00}', "");
    Expect(1, 3887, '\P{Is_Numeric_Value=4.50e+00}', "");
    Expect(0, 3887, '\P{^Is_Numeric_Value=4.50e+00}', "");
    Expect(1, 3886, '\p{Is_Numeric_Value:4.50}', "");
    Expect(0, 3886, '\p{^Is_Numeric_Value:4.50}', "");
    Expect(0, 3886, '\P{Is_Numeric_Value:4.50}', "");
    Expect(1, 3886, '\P{^Is_Numeric_Value:4.50}', "");
    Expect(0, 3887, '\p{Is_Numeric_Value:4.50}', "");
    Expect(1, 3887, '\p{^Is_Numeric_Value:4.50}', "");
    Expect(1, 3887, '\P{Is_Numeric_Value:4.50}', "");
    Expect(0, 3887, '\P{^Is_Numeric_Value:4.50}', "");
    Error('\p{Is_Nv=/a/- 09/000002}');
    Error('\P{Is_Nv=/a/- 09/000002}');
    Expect(1, 3886, '\p{Is_Nv=009/0000002}', "");
    Expect(0, 3886, '\p{^Is_Nv=009/0000002}', "");
    Expect(0, 3886, '\P{Is_Nv=009/0000002}', "");
    Expect(1, 3886, '\P{^Is_Nv=009/0000002}', "");
    Expect(0, 3887, '\p{Is_Nv=009/0000002}', "");
    Expect(1, 3887, '\p{^Is_Nv=009/0000002}', "");
    Expect(1, 3887, '\P{Is_Nv=009/0000002}', "");
    Expect(0, 3887, '\P{^Is_Nv=009/0000002}', "");
    Expect(1, 3886, '\p{Is_Nv=540/120}', "");
    Expect(0, 3886, '\p{^Is_Nv=540/120}', "");
    Expect(0, 3886, '\P{Is_Nv=540/120}', "");
    Expect(1, 3886, '\P{^Is_Nv=540/120}', "");
    Expect(0, 3887, '\p{Is_Nv=540/120}', "");
    Expect(1, 3887, '\p{^Is_Nv=540/120}', "");
    Expect(1, 3887, '\P{Is_Nv=540/120}', "");
    Expect(0, 3887, '\P{^Is_Nv=540/120}', "");
    Expect(1, 3886, '\p{Is_Nv=4.5e+00}', "");
    Expect(0, 3886, '\p{^Is_Nv=4.5e+00}', "");
    Expect(0, 3886, '\P{Is_Nv=4.5e+00}', "");
    Expect(1, 3886, '\P{^Is_Nv=4.5e+00}', "");
    Expect(0, 3887, '\p{Is_Nv=4.5e+00}', "");
    Expect(1, 3887, '\p{^Is_Nv=4.5e+00}', "");
    Expect(1, 3887, '\P{Is_Nv=4.5e+00}', "");
    Expect(0, 3887, '\P{^Is_Nv=4.5e+00}', "");
    Expect(1, 3886, '\p{Is_Nv=4.5}', "");
    Expect(0, 3886, '\p{^Is_Nv=4.5}', "");
    Expect(0, 3886, '\P{Is_Nv=4.5}', "");
    Expect(1, 3886, '\P{^Is_Nv=4.5}', "");
    Expect(0, 3887, '\p{Is_Nv=4.5}', "");
    Expect(1, 3887, '\p{^Is_Nv=4.5}', "");
    Expect(1, 3887, '\P{Is_Nv=4.5}', "");
    Expect(0, 3887, '\P{^Is_Nv=4.5}', "");
    Expect(1, 3886, '\p{Is_Nv=4.50e+00}', "");
    Expect(0, 3886, '\p{^Is_Nv=4.50e+00}', "");
    Expect(0, 3886, '\P{Is_Nv=4.50e+00}', "");
    Expect(1, 3886, '\P{^Is_Nv=4.50e+00}', "");
    Expect(0, 3887, '\p{Is_Nv=4.50e+00}', "");
    Expect(1, 3887, '\p{^Is_Nv=4.50e+00}', "");
    Expect(1, 3887, '\P{Is_Nv=4.50e+00}', "");
    Expect(0, 3887, '\P{^Is_Nv=4.50e+00}', "");
    Expect(1, 3886, '\p{Is_Nv=4.50}', "");
    Expect(0, 3886, '\p{^Is_Nv=4.50}', "");
    Expect(0, 3886, '\P{Is_Nv=4.50}', "");
    Expect(1, 3886, '\P{^Is_Nv=4.50}', "");
    Expect(0, 3887, '\p{Is_Nv=4.50}', "");
    Expect(1, 3887, '\p{^Is_Nv=4.50}', "");
    Expect(1, 3887, '\P{Is_Nv=4.50}', "");
    Expect(0, 3887, '\P{^Is_Nv=4.50}', "");
    Error('\p{Numeric_Value=:= 	+00000090}');
    Error('\P{Numeric_Value=:= 	+00000090}');
    Expect(1, 126226, '\p{Numeric_Value=:\A90\z:}', "");;
    Expect(0, 126227, '\p{Numeric_Value=:\A90\z:}', "");;
    Expect(1, 126226, '\p{Numeric_Value=09_0}', "");
    Expect(0, 126226, '\p{^Numeric_Value=09_0}', "");
    Expect(0, 126226, '\P{Numeric_Value=09_0}', "");
    Expect(1, 126226, '\P{^Numeric_Value=09_0}', "");
    Expect(0, 126227, '\p{Numeric_Value=09_0}', "");
    Expect(1, 126227, '\p{^Numeric_Value=09_0}', "");
    Expect(1, 126227, '\P{Numeric_Value=09_0}', "");
    Expect(0, 126227, '\P{^Numeric_Value=09_0}', "");
    Expect(1, 126226, '\p{Numeric_Value: 9.000000000000000e+01}', "");
    Expect(0, 126226, '\p{^Numeric_Value: 9.000000000000000e+01}', "");
    Expect(0, 126226, '\P{Numeric_Value: 9.000000000000000e+01}', "");
    Expect(1, 126226, '\P{^Numeric_Value: 9.000000000000000e+01}', "");
    Expect(0, 126227, '\p{Numeric_Value: 9.000000000000000e+01}', "");
    Expect(1, 126227, '\p{^Numeric_Value: 9.000000000000000e+01}', "");
    Expect(1, 126227, '\P{Numeric_Value: 9.000000000000000e+01}', "");
    Expect(0, 126227, '\P{^Numeric_Value: 9.000000000000000e+01}', "");
    Error('\p{Nv=__00000090/a/}');
    Error('\P{Nv=__00000090/a/}');
    Expect(1, 126226, '\p{Nv=:\A90\z:}', "");;
    Expect(0, 126227, '\p{Nv=:\A90\z:}', "");;
    Expect(1, 126226, '\p{Nv=+00000000090}', "");
    Expect(0, 126226, '\p{^Nv=+00000000090}', "");
    Expect(0, 126226, '\P{Nv=+00000000090}', "");
    Expect(1, 126226, '\P{^Nv=+00000000090}', "");
    Expect(0, 126227, '\p{Nv=+00000000090}', "");
    Expect(1, 126227, '\p{^Nv=+00000000090}', "");
    Expect(1, 126227, '\P{Nv=+00000000090}', "");
    Expect(0, 126227, '\P{^Nv=+00000000090}', "");
    Expect(1, 126226, '\p{Nv:9.000000000000000e+01}', "");
    Expect(0, 126226, '\p{^Nv:9.000000000000000e+01}', "");
    Expect(0, 126226, '\P{Nv:9.000000000000000e+01}', "");
    Expect(1, 126226, '\P{^Nv:9.000000000000000e+01}', "");
    Expect(0, 126227, '\p{Nv:9.000000000000000e+01}', "");
    Expect(1, 126227, '\p{^Nv:9.000000000000000e+01}', "");
    Expect(1, 126227, '\P{Nv:9.000000000000000e+01}', "");
    Expect(0, 126227, '\P{^Nv:9.000000000000000e+01}', "");
    Error('\p{Is_Numeric_Value: _00_00_00_00_090:=}');
    Error('\P{Is_Numeric_Value: _00_00_00_00_090:=}');
    Expect(1, 126226, '\p{Is_Numeric_Value=00009_0}', "");
    Expect(0, 126226, '\p{^Is_Numeric_Value=00009_0}', "");
    Expect(0, 126226, '\P{Is_Numeric_Value=00009_0}', "");
    Expect(1, 126226, '\P{^Is_Numeric_Value=00009_0}', "");
    Expect(0, 126227, '\p{Is_Numeric_Value=00009_0}', "");
    Expect(1, 126227, '\p{^Is_Numeric_Value=00009_0}', "");
    Expect(1, 126227, '\P{Is_Numeric_Value=00009_0}', "");
    Expect(0, 126227, '\P{^Is_Numeric_Value=00009_0}', "");
    Expect(1, 126226, '\p{Is_Numeric_Value=9.000000000000000e+01}', "");
    Expect(0, 126226, '\p{^Is_Numeric_Value=9.000000000000000e+01}', "");
    Expect(0, 126226, '\P{Is_Numeric_Value=9.000000000000000e+01}', "");
    Expect(1, 126226, '\P{^Is_Numeric_Value=9.000000000000000e+01}', "");
    Expect(0, 126227, '\p{Is_Numeric_Value=9.000000000000000e+01}', "");
    Expect(1, 126227, '\p{^Is_Numeric_Value=9.000000000000000e+01}', "");
    Expect(1, 126227, '\P{Is_Numeric_Value=9.000000000000000e+01}', "");
    Expect(0, 126227, '\P{^Is_Numeric_Value=9.000000000000000e+01}', "");
    Error('\p{Is_Nv: 	/a/0000090}');
    Error('\P{Is_Nv: 	/a/0000090}');
    Expect(1, 126226, '\p{Is_Nv=00000090}', "");
    Expect(0, 126226, '\p{^Is_Nv=00000090}', "");
    Expect(0, 126226, '\P{Is_Nv=00000090}', "");
    Expect(1, 126226, '\P{^Is_Nv=00000090}', "");
    Expect(0, 126227, '\p{Is_Nv=00000090}', "");
    Expect(1, 126227, '\p{^Is_Nv=00000090}', "");
    Expect(1, 126227, '\P{Is_Nv=00000090}', "");
    Expect(0, 126227, '\P{^Is_Nv=00000090}', "");
    Expect(1, 126226, '\p{Is_Nv=9.000000000000000e+01}', "");
    Expect(0, 126226, '\p{^Is_Nv=9.000000000000000e+01}', "");
    Expect(0, 126226, '\P{Is_Nv=9.000000000000000e+01}', "");
    Expect(1, 126226, '\P{^Is_Nv=9.000000000000000e+01}', "");
    Expect(0, 126227, '\p{Is_Nv=9.000000000000000e+01}', "");
    Expect(1, 126227, '\p{^Is_Nv=9.000000000000000e+01}', "");
    Expect(1, 126227, '\P{Is_Nv=9.000000000000000e+01}', "");
    Expect(0, 126227, '\P{^Is_Nv=9.000000000000000e+01}', "");
    Error('\p{Numeric_Value=/a/ 	0_0_0_0_0_0_0_0900}');
    Error('\P{Numeric_Value=/a/ 	0_0_0_0_0_0_0_0900}');
    Expect(1, 126235, '\p{Numeric_Value=:\A900\z:}', "");;
    Expect(0, 126236, '\p{Numeric_Value=:\A900\z:}', "");;
    Expect(1, 126235, '\p{Numeric_Value=000000900}', "");
    Expect(0, 126235, '\p{^Numeric_Value=000000900}', "");
    Expect(0, 126235, '\P{Numeric_Value=000000900}', "");
    Expect(1, 126235, '\P{^Numeric_Value=000000900}', "");
    Expect(0, 126236, '\p{Numeric_Value=000000900}', "");
    Expect(1, 126236, '\p{^Numeric_Value=000000900}', "");
    Expect(1, 126236, '\P{Numeric_Value=000000900}', "");
    Expect(0, 126236, '\P{^Numeric_Value=000000900}', "");
    Expect(1, 126235, '\p{Numeric_Value:	9.000000000000000e+02}', "");
    Expect(0, 126235, '\p{^Numeric_Value:	9.000000000000000e+02}', "");
    Expect(0, 126235, '\P{Numeric_Value:	9.000000000000000e+02}', "");
    Expect(1, 126235, '\P{^Numeric_Value:	9.000000000000000e+02}', "");
    Expect(0, 126236, '\p{Numeric_Value:	9.000000000000000e+02}', "");
    Expect(1, 126236, '\p{^Numeric_Value:	9.000000000000000e+02}', "");
    Expect(1, 126236, '\P{Numeric_Value:	9.000000000000000e+02}', "");
    Expect(0, 126236, '\P{^Numeric_Value:	9.000000000000000e+02}', "");
    Error('\p{Nv:   	-00000000900:=}');
    Error('\P{Nv:   	-00000000900:=}');
    Expect(1, 126235, '\p{Nv=:\A900\z:}', "");;
    Expect(0, 126236, '\p{Nv=:\A900\z:}', "");;
    Expect(1, 126235, '\p{Nv=0900}', "");
    Expect(0, 126235, '\p{^Nv=0900}', "");
    Expect(0, 126235, '\P{Nv=0900}', "");
    Expect(1, 126235, '\P{^Nv=0900}', "");
    Expect(0, 126236, '\p{Nv=0900}', "");
    Expect(1, 126236, '\p{^Nv=0900}', "");
    Expect(1, 126236, '\P{Nv=0900}', "");
    Expect(0, 126236, '\P{^Nv=0900}', "");
    Expect(1, 126235, '\p{Nv=9.000000000000000e+02}', "");
    Expect(0, 126235, '\p{^Nv=9.000000000000000e+02}', "");
    Expect(0, 126235, '\P{Nv=9.000000000000000e+02}', "");
    Expect(1, 126235, '\P{^Nv=9.000000000000000e+02}', "");
    Expect(0, 126236, '\p{Nv=9.000000000000000e+02}', "");
    Expect(1, 126236, '\p{^Nv=9.000000000000000e+02}', "");
    Expect(1, 126236, '\P{Nv=9.000000000000000e+02}', "");
    Expect(0, 126236, '\P{^Nv=9.000000000000000e+02}', "");
    Error('\p{Is_Numeric_Value=/a/- 00900}');
    Error('\P{Is_Numeric_Value=/a/- 00900}');
    Expect(1, 126235, '\p{Is_Numeric_Value=0000_0090_0}', "");
    Expect(0, 126235, '\p{^Is_Numeric_Value=0000_0090_0}', "");
    Expect(0, 126235, '\P{Is_Numeric_Value=0000_0090_0}', "");
    Expect(1, 126235, '\P{^Is_Numeric_Value=0000_0090_0}', "");
    Expect(0, 126236, '\p{Is_Numeric_Value=0000_0090_0}', "");
    Expect(1, 126236, '\p{^Is_Numeric_Value=0000_0090_0}', "");
    Expect(1, 126236, '\P{Is_Numeric_Value=0000_0090_0}', "");
    Expect(0, 126236, '\P{^Is_Numeric_Value=0000_0090_0}', "");
    Expect(1, 126235, '\p{Is_Numeric_Value=9.000000000000000e+02}', "");
    Expect(0, 126235, '\p{^Is_Numeric_Value=9.000000000000000e+02}', "");
    Expect(0, 126235, '\P{Is_Numeric_Value=9.000000000000000e+02}', "");
    Expect(1, 126235, '\P{^Is_Numeric_Value=9.000000000000000e+02}', "");
    Expect(0, 126236, '\p{Is_Numeric_Value=9.000000000000000e+02}', "");
    Expect(1, 126236, '\p{^Is_Numeric_Value=9.000000000000000e+02}', "");
    Expect(1, 126236, '\P{Is_Numeric_Value=9.000000000000000e+02}', "");
    Expect(0, 126236, '\P{^Is_Numeric_Value=9.000000000000000e+02}', "");
    Error('\p{Is_Nv=/a/-00_00_00_90_0}');
    Error('\P{Is_Nv=/a/-00_00_00_90_0}');
    Expect(1, 126235, '\p{Is_Nv=+00_90_0}', "");
    Expect(0, 126235, '\p{^Is_Nv=+00_90_0}', "");
    Expect(0, 126235, '\P{Is_Nv=+00_90_0}', "");
    Expect(1, 126235, '\P{^Is_Nv=+00_90_0}', "");
    Expect(0, 126236, '\p{Is_Nv=+00_90_0}', "");
    Expect(1, 126236, '\p{^Is_Nv=+00_90_0}', "");
    Expect(1, 126236, '\P{Is_Nv=+00_90_0}', "");
    Expect(0, 126236, '\P{^Is_Nv=+00_90_0}', "");
    Expect(1, 126235, '\p{Is_Nv=9.000000000000000e+02}', "");
    Expect(0, 126235, '\p{^Is_Nv=9.000000000000000e+02}', "");
    Expect(0, 126235, '\P{Is_Nv=9.000000000000000e+02}', "");
    Expect(1, 126235, '\P{^Is_Nv=9.000000000000000e+02}', "");
    Expect(0, 126236, '\p{Is_Nv=9.000000000000000e+02}', "");
    Expect(1, 126236, '\p{^Is_Nv=9.000000000000000e+02}', "");
    Expect(1, 126236, '\P{Is_Nv=9.000000000000000e+02}', "");
    Expect(0, 126236, '\P{^Is_Nv=9.000000000000000e+02}', "");
    Error('\p{Numeric_Value=_:=09000}');
    Error('\P{Numeric_Value=_:=09000}');
    Expect(1, 126244, '\p{Numeric_Value=:\A9000\z:}', "");;
    Expect(0, 126245, '\p{Numeric_Value=:\A9000\z:}', "");;
    Expect(1, 126244, '\p{Numeric_Value=+00_90_00}', "");
    Expect(0, 126244, '\p{^Numeric_Value=+00_90_00}', "");
    Expect(0, 126244, '\P{Numeric_Value=+00_90_00}', "");
    Expect(1, 126244, '\P{^Numeric_Value=+00_90_00}', "");
    Expect(0, 126245, '\p{Numeric_Value=+00_90_00}', "");
    Expect(1, 126245, '\p{^Numeric_Value=+00_90_00}', "");
    Expect(1, 126245, '\P{Numeric_Value=+00_90_00}', "");
    Expect(0, 126245, '\P{^Numeric_Value=+00_90_00}', "");
    Expect(1, 126244, '\p{Numeric_Value=9.000000000000000e+03}', "");
    Expect(0, 126244, '\p{^Numeric_Value=9.000000000000000e+03}', "");
    Expect(0, 126244, '\P{Numeric_Value=9.000000000000000e+03}', "");
    Expect(1, 126244, '\P{^Numeric_Value=9.000000000000000e+03}', "");
    Expect(0, 126245, '\p{Numeric_Value=9.000000000000000e+03}', "");
    Expect(1, 126245, '\p{^Numeric_Value=9.000000000000000e+03}', "");
    Expect(1, 126245, '\P{Numeric_Value=9.000000000000000e+03}', "");
    Expect(0, 126245, '\P{^Numeric_Value=9.000000000000000e+03}', "");
    Error('\p{Nv=:=0_0_0_0_0_0_0_9000}');
    Error('\P{Nv=:=0_0_0_0_0_0_0_9000}');
    Expect(1, 126244, '\p{Nv=:\A9000\z:}', "");;
    Expect(0, 126245, '\p{Nv=:\A9000\z:}', "");;
    Expect(1, 126244, '\p{Nv=+0000009000}', "");
    Expect(0, 126244, '\p{^Nv=+0000009000}', "");
    Expect(0, 126244, '\P{Nv=+0000009000}', "");
    Expect(1, 126244, '\P{^Nv=+0000009000}', "");
    Expect(0, 126245, '\p{Nv=+0000009000}', "");
    Expect(1, 126245, '\p{^Nv=+0000009000}', "");
    Expect(1, 126245, '\P{Nv=+0000009000}', "");
    Expect(0, 126245, '\P{^Nv=+0000009000}', "");
    Expect(1, 126244, '\p{Nv=9.000000000000000e+03}', "");
    Expect(0, 126244, '\p{^Nv=9.000000000000000e+03}', "");
    Expect(0, 126244, '\P{Nv=9.000000000000000e+03}', "");
    Expect(1, 126244, '\P{^Nv=9.000000000000000e+03}', "");
    Expect(0, 126245, '\p{Nv=9.000000000000000e+03}', "");
    Expect(1, 126245, '\p{^Nv=9.000000000000000e+03}', "");
    Expect(1, 126245, '\P{Nv=9.000000000000000e+03}', "");
    Expect(0, 126245, '\P{^Nv=9.000000000000000e+03}', "");
    Error('\p{Is_Numeric_Value=/a/+009000}');
    Error('\P{Is_Numeric_Value=/a/+009000}');
    Expect(1, 126244, '\p{Is_Numeric_Value=0000009000}', "");
    Expect(0, 126244, '\p{^Is_Numeric_Value=0000009000}', "");
    Expect(0, 126244, '\P{Is_Numeric_Value=0000009000}', "");
    Expect(1, 126244, '\P{^Is_Numeric_Value=0000009000}', "");
    Expect(0, 126245, '\p{Is_Numeric_Value=0000009000}', "");
    Expect(1, 126245, '\p{^Is_Numeric_Value=0000009000}', "");
    Expect(1, 126245, '\P{Is_Numeric_Value=0000009000}', "");
    Expect(0, 126245, '\P{^Is_Numeric_Value=0000009000}', "");
    Expect(1, 126244, '\p{Is_Numeric_Value=9.000000000000000e+03}', "");
    Expect(0, 126244, '\p{^Is_Numeric_Value=9.000000000000000e+03}', "");
    Expect(0, 126244, '\P{Is_Numeric_Value=9.000000000000000e+03}', "");
    Expect(1, 126244, '\P{^Is_Numeric_Value=9.000000000000000e+03}', "");
    Expect(0, 126245, '\p{Is_Numeric_Value=9.000000000000000e+03}', "");
    Expect(1, 126245, '\p{^Is_Numeric_Value=9.000000000000000e+03}', "");
    Expect(1, 126245, '\P{Is_Numeric_Value=9.000000000000000e+03}', "");
    Expect(0, 126245, '\P{^Is_Numeric_Value=9.000000000000000e+03}', "");
    Error('\p{Is_Nv=:=__09000}');
    Error('\P{Is_Nv=:=__09000}');
    Expect(1, 126244, '\p{Is_Nv:00900_0}', "");
    Expect(0, 126244, '\p{^Is_Nv:00900_0}', "");
    Expect(0, 126244, '\P{Is_Nv:00900_0}', "");
    Expect(1, 126244, '\P{^Is_Nv:00900_0}', "");
    Expect(0, 126245, '\p{Is_Nv:00900_0}', "");
    Expect(1, 126245, '\p{^Is_Nv:00900_0}', "");
    Expect(1, 126245, '\P{Is_Nv:00900_0}', "");
    Expect(0, 126245, '\P{^Is_Nv:00900_0}', "");
    Expect(1, 126244, '\p{Is_Nv=9.000000000000000e+03}', "");
    Expect(0, 126244, '\p{^Is_Nv=9.000000000000000e+03}', "");
    Expect(0, 126244, '\P{Is_Nv=9.000000000000000e+03}', "");
    Expect(1, 126244, '\P{^Is_Nv=9.000000000000000e+03}', "");
    Expect(0, 126245, '\p{Is_Nv=9.000000000000000e+03}', "");
    Expect(1, 126245, '\p{^Is_Nv=9.000000000000000e+03}', "");
    Expect(1, 126245, '\P{Is_Nv=9.000000000000000e+03}', "");
    Expect(0, 126245, '\P{^Is_Nv=9.000000000000000e+03}', "");
    Error('\p{Numeric_Value=-/a/+0_0_0_9_0_0_00}');
    Error('\P{Numeric_Value=-/a/+0_0_0_9_0_0_00}');
    Expect(1, 126253, '\p{Numeric_Value=:\A90000\z:}', "");;
    Expect(0, 126254, '\p{Numeric_Value=:\A90000\z:}', "");;
    Expect(1, 126253, '\p{Numeric_Value=0_0_0_0_0_0_0_090000}', "");
    Expect(0, 126253, '\p{^Numeric_Value=0_0_0_0_0_0_0_090000}', "");
    Expect(0, 126253, '\P{Numeric_Value=0_0_0_0_0_0_0_090000}', "");
    Expect(1, 126253, '\P{^Numeric_Value=0_0_0_0_0_0_0_090000}', "");
    Expect(0, 126254, '\p{Numeric_Value=0_0_0_0_0_0_0_090000}', "");
    Expect(1, 126254, '\p{^Numeric_Value=0_0_0_0_0_0_0_090000}', "");
    Expect(1, 126254, '\P{Numeric_Value=0_0_0_0_0_0_0_090000}', "");
    Expect(0, 126254, '\P{^Numeric_Value=0_0_0_0_0_0_0_090000}', "");
    Expect(1, 126253, '\p{Numeric_Value:	9.000000000000000e+04}', "");
    Expect(0, 126253, '\p{^Numeric_Value:	9.000000000000000e+04}', "");
    Expect(0, 126253, '\P{Numeric_Value:	9.000000000000000e+04}', "");
    Expect(1, 126253, '\P{^Numeric_Value:	9.000000000000000e+04}', "");
    Expect(0, 126254, '\p{Numeric_Value:	9.000000000000000e+04}', "");
    Expect(1, 126254, '\p{^Numeric_Value:	9.000000000000000e+04}', "");
    Expect(1, 126254, '\P{Numeric_Value:	9.000000000000000e+04}', "");
    Expect(0, 126254, '\P{^Numeric_Value:	9.000000000000000e+04}', "");
    Error('\p{Nv=:=-	000_000_000_900_00}');
    Error('\P{Nv=:=-	000_000_000_900_00}');
    Expect(1, 126253, '\p{Nv=:\A90000\z:}', "");;
    Expect(0, 126254, '\p{Nv=:\A90000\z:}', "");;
    Expect(1, 126253, '\p{Nv=00_00_90_00_0}', "");
    Expect(0, 126253, '\p{^Nv=00_00_90_00_0}', "");
    Expect(0, 126253, '\P{Nv=00_00_90_00_0}', "");
    Expect(1, 126253, '\P{^Nv=00_00_90_00_0}', "");
    Expect(0, 126254, '\p{Nv=00_00_90_00_0}', "");
    Expect(1, 126254, '\p{^Nv=00_00_90_00_0}', "");
    Expect(1, 126254, '\P{Nv=00_00_90_00_0}', "");
    Expect(0, 126254, '\P{^Nv=00_00_90_00_0}', "");
    Expect(1, 126253, '\p{Nv=9.000000000000000e+04}', "");
    Expect(0, 126253, '\p{^Nv=9.000000000000000e+04}', "");
    Expect(0, 126253, '\P{Nv=9.000000000000000e+04}', "");
    Expect(1, 126253, '\P{^Nv=9.000000000000000e+04}', "");
    Expect(0, 126254, '\p{Nv=9.000000000000000e+04}', "");
    Expect(1, 126254, '\p{^Nv=9.000000000000000e+04}', "");
    Expect(1, 126254, '\P{Nv=9.000000000000000e+04}', "");
    Expect(0, 126254, '\P{^Nv=9.000000000000000e+04}', "");
    Error('\p{Is_Numeric_Value=_	+0_0_0_0_0_0_0_90000/a/}');
    Error('\P{Is_Numeric_Value=_	+0_0_0_0_0_0_0_90000/a/}');
    Expect(1, 126253, '\p{Is_Numeric_Value:   0_0_0_9_0_000}', "");
    Expect(0, 126253, '\p{^Is_Numeric_Value:   0_0_0_9_0_000}', "");
    Expect(0, 126253, '\P{Is_Numeric_Value:   0_0_0_9_0_000}', "");
    Expect(1, 126253, '\P{^Is_Numeric_Value:   0_0_0_9_0_000}', "");
    Expect(0, 126254, '\p{Is_Numeric_Value:   0_0_0_9_0_000}', "");
    Expect(1, 126254, '\p{^Is_Numeric_Value:   0_0_0_9_0_000}', "");
    Expect(1, 126254, '\P{Is_Numeric_Value:   0_0_0_9_0_000}', "");
    Expect(0, 126254, '\P{^Is_Numeric_Value:   0_0_0_9_0_000}', "");
    Expect(1, 126253, '\p{Is_Numeric_Value=9.000000000000000e+04}', "");
    Expect(0, 126253, '\p{^Is_Numeric_Value=9.000000000000000e+04}', "");
    Expect(0, 126253, '\P{Is_Numeric_Value=9.000000000000000e+04}', "");
    Expect(1, 126253, '\P{^Is_Numeric_Value=9.000000000000000e+04}', "");
    Expect(0, 126254, '\p{Is_Numeric_Value=9.000000000000000e+04}', "");
    Expect(1, 126254, '\p{^Is_Numeric_Value=9.000000000000000e+04}', "");
    Expect(1, 126254, '\P{Is_Numeric_Value=9.000000000000000e+04}', "");
    Expect(0, 126254, '\P{^Is_Numeric_Value=9.000000000000000e+04}', "");
    Error('\p{Is_Nv:/a/__+0000000090000}');
    Error('\P{Is_Nv:/a/__+0000000090000}');
    Expect(1, 126253, '\p{Is_Nv=+00000090000}', "");
    Expect(0, 126253, '\p{^Is_Nv=+00000090000}', "");
    Expect(0, 126253, '\P{Is_Nv=+00000090000}', "");
    Expect(1, 126253, '\P{^Is_Nv=+00000090000}', "");
    Expect(0, 126254, '\p{Is_Nv=+00000090000}', "");
    Expect(1, 126254, '\p{^Is_Nv=+00000090000}', "");
    Expect(1, 126254, '\P{Is_Nv=+00000090000}', "");
    Expect(0, 126254, '\P{^Is_Nv=+00000090000}', "");
    Expect(1, 126253, '\p{Is_Nv=9.000000000000000e+04}', "");
    Expect(0, 126253, '\p{^Is_Nv=9.000000000000000e+04}', "");
    Expect(0, 126253, '\P{Is_Nv=9.000000000000000e+04}', "");
    Expect(1, 126253, '\P{^Is_Nv=9.000000000000000e+04}', "");
    Expect(0, 126254, '\p{Is_Nv=9.000000000000000e+04}', "");
    Expect(1, 126254, '\p{^Is_Nv=9.000000000000000e+04}', "");
    Expect(1, 126254, '\P{Is_Nv=9.000000000000000e+04}', "");
    Expect(0, 126254, '\P{^Is_Nv=9.000000000000000e+04}', "");
    Error('\p{Numeric_Value= /a/+0_0_0_0_0_0_0_0_9_0_0_000}');
    Error('\P{Numeric_Value= /a/+0_0_0_0_0_0_0_0_9_0_0_000}');
    Expect(1, 68085, '\p{Numeric_Value=:\A900000\z:}', "");;
    Expect(0, 68086, '\p{Numeric_Value=:\A900000\z:}', "");;
    Expect(1, 68085, '\p{Numeric_Value=+0000900000}', "");
    Expect(0, 68085, '\p{^Numeric_Value=+0000900000}', "");
    Expect(0, 68085, '\P{Numeric_Value=+0000900000}', "");
    Expect(1, 68085, '\P{^Numeric_Value=+0000900000}', "");
    Expect(0, 68086, '\p{Numeric_Value=+0000900000}', "");
    Expect(1, 68086, '\p{^Numeric_Value=+0000900000}', "");
    Expect(1, 68086, '\P{Numeric_Value=+0000900000}', "");
    Expect(0, 68086, '\P{^Numeric_Value=+0000900000}', "");
    Expect(1, 68085, '\p{Numeric_Value=9.000000000000000e+05}', "");
    Expect(0, 68085, '\p{^Numeric_Value=9.000000000000000e+05}', "");
    Expect(0, 68085, '\P{Numeric_Value=9.000000000000000e+05}', "");
    Expect(1, 68085, '\P{^Numeric_Value=9.000000000000000e+05}', "");
    Expect(0, 68086, '\p{Numeric_Value=9.000000000000000e+05}', "");
    Expect(1, 68086, '\p{^Numeric_Value=9.000000000000000e+05}', "");
    Expect(1, 68086, '\P{Numeric_Value=9.000000000000000e+05}', "");
    Expect(0, 68086, '\P{^Numeric_Value=9.000000000000000e+05}', "");
    Error('\p{Nv=/a/00900000}');
    Error('\P{Nv=/a/00900000}');
    Expect(1, 68085, '\p{Nv=:\A900000\z:}', "");;
    Expect(0, 68086, '\p{Nv=:\A900000\z:}', "");;
    Expect(1, 68085, '\p{Nv=+900000}', "");
    Expect(0, 68085, '\p{^Nv=+900000}', "");
    Expect(0, 68085, '\P{Nv=+900000}', "");
    Expect(1, 68085, '\P{^Nv=+900000}', "");
    Expect(0, 68086, '\p{Nv=+900000}', "");
    Expect(1, 68086, '\p{^Nv=+900000}', "");
    Expect(1, 68086, '\P{Nv=+900000}', "");
    Expect(0, 68086, '\P{^Nv=+900000}', "");
    Expect(1, 68085, '\p{Nv=9.000000000000000e+05}', "");
    Expect(0, 68085, '\p{^Nv=9.000000000000000e+05}', "");
    Expect(0, 68085, '\P{Nv=9.000000000000000e+05}', "");
    Expect(1, 68085, '\P{^Nv=9.000000000000000e+05}', "");
    Expect(0, 68086, '\p{Nv=9.000000000000000e+05}', "");
    Expect(1, 68086, '\p{^Nv=9.000000000000000e+05}', "");
    Expect(1, 68086, '\P{Nv=9.000000000000000e+05}', "");
    Expect(0, 68086, '\P{^Nv=9.000000000000000e+05}', "");
    Error('\p{Is_Numeric_Value::=0_0_9_0_0_000}');
    Error('\P{Is_Numeric_Value::=0_0_9_0_0_000}');
    Expect(1, 68085, '\p{Is_Numeric_Value:00000900000}', "");
    Expect(0, 68085, '\p{^Is_Numeric_Value:00000900000}', "");
    Expect(0, 68085, '\P{Is_Numeric_Value:00000900000}', "");
    Expect(1, 68085, '\P{^Is_Numeric_Value:00000900000}', "");
    Expect(0, 68086, '\p{Is_Numeric_Value:00000900000}', "");
    Expect(1, 68086, '\p{^Is_Numeric_Value:00000900000}', "");
    Expect(1, 68086, '\P{Is_Numeric_Value:00000900000}', "");
    Expect(0, 68086, '\P{^Is_Numeric_Value:00000900000}', "");
    Expect(1, 68085, '\p{Is_Numeric_Value=9.000000000000000e+05}', "");
    Expect(0, 68085, '\p{^Is_Numeric_Value=9.000000000000000e+05}', "");
    Expect(0, 68085, '\P{Is_Numeric_Value=9.000000000000000e+05}', "");
    Expect(1, 68085, '\P{^Is_Numeric_Value=9.000000000000000e+05}', "");
    Expect(0, 68086, '\p{Is_Numeric_Value=9.000000000000000e+05}', "");
    Expect(1, 68086, '\p{^Is_Numeric_Value=9.000000000000000e+05}', "");
    Expect(1, 68086, '\P{Is_Numeric_Value=9.000000000000000e+05}', "");
    Expect(0, 68086, '\P{^Is_Numeric_Value=9.000000000000000e+05}', "");
    Error('\p{Is_Nv=:= 	+0900000}');
    Error('\P{Is_Nv=:= 	+0900000}');
    Expect(1, 68085, '\p{Is_Nv: 90000_0}', "");
    Expect(0, 68085, '\p{^Is_Nv: 90000_0}', "");
    Expect(0, 68085, '\P{Is_Nv: 90000_0}', "");
    Expect(1, 68085, '\P{^Is_Nv: 90000_0}', "");
    Expect(0, 68086, '\p{Is_Nv: 90000_0}', "");
    Expect(1, 68086, '\p{^Is_Nv: 90000_0}', "");
    Expect(1, 68086, '\P{Is_Nv: 90000_0}', "");
    Expect(0, 68086, '\P{^Is_Nv: 90000_0}', "");
    Expect(1, 68085, '\p{Is_Nv=9.000000000000000e+05}', "");
    Expect(0, 68085, '\p{^Is_Nv=9.000000000000000e+05}', "");
    Expect(0, 68085, '\P{Is_Nv=9.000000000000000e+05}', "");
    Expect(1, 68085, '\P{^Is_Nv=9.000000000000000e+05}', "");
    Expect(0, 68086, '\p{Is_Nv=9.000000000000000e+05}', "");
    Expect(1, 68086, '\p{^Is_Nv=9.000000000000000e+05}', "");
    Expect(1, 68086, '\P{Is_Nv=9.000000000000000e+05}', "");
    Expect(0, 68086, '\P{^Is_Nv=9.000000000000000e+05}', "");
    Error('\p{Numeric_Value=:=-nan}');
    Error('\P{Numeric_Value=:=-nan}');
    Expect(1, 194705, '\p{Numeric_Value=:\ANaN\z:}', "");;
    Expect(0, 194704, '\p{Numeric_Value=:\ANaN\z:}', "");;
    Expect(1, 194705, '\p{Numeric_Value=nan}', "");
    Expect(0, 194705, '\p{^Numeric_Value=nan}', "");
    Expect(0, 194705, '\P{Numeric_Value=nan}', "");
    Expect(1, 194705, '\P{^Numeric_Value=nan}', "");
    Expect(0, 194704, '\p{Numeric_Value=nan}', "");
    Expect(1, 194704, '\p{^Numeric_Value=nan}', "");
    Expect(1, 194704, '\P{Numeric_Value=nan}', "");
    Expect(0, 194704, '\P{^Numeric_Value=nan}', "");
    Expect(1, 194705, '\p{Numeric_Value=:\Anan\z:}', "");;
    Expect(0, 194704, '\p{Numeric_Value=:\Anan\z:}', "");;
    Expect(1, 194705, '\p{Numeric_Value=  NaN}', "");
    Expect(0, 194705, '\p{^Numeric_Value=  NaN}', "");
    Expect(0, 194705, '\P{Numeric_Value=  NaN}', "");
    Expect(1, 194705, '\P{^Numeric_Value=  NaN}', "");
    Expect(0, 194704, '\p{Numeric_Value=  NaN}', "");
    Expect(1, 194704, '\p{^Numeric_Value=  NaN}', "");
    Expect(1, 194704, '\P{Numeric_Value=  NaN}', "");
    Expect(0, 194704, '\P{^Numeric_Value=  NaN}', "");
    Expect(1, 194705, '\p{Numeric_Value=NaN}', "");
    Expect(0, 194705, '\p{^Numeric_Value=NaN}', "");
    Expect(0, 194705, '\P{Numeric_Value=NaN}', "");
    Expect(1, 194705, '\P{^Numeric_Value=NaN}', "");
    Expect(0, 194704, '\p{Numeric_Value=NaN}', "");
    Expect(1, 194704, '\p{^Numeric_Value=NaN}', "");
    Expect(1, 194704, '\P{Numeric_Value=NaN}', "");
    Expect(0, 194704, '\P{^Numeric_Value=NaN}', "");
    Error('\p{Nv=_/a/nan}');
    Error('\P{Nv=_/a/nan}');
    Expect(1, 194705, '\p{Nv=:\ANaN\z:}', "");;
    Expect(0, 194704, '\p{Nv=:\ANaN\z:}', "");;
    Expect(1, 194705, '\p{Nv=nan}', "");
    Expect(0, 194705, '\p{^Nv=nan}', "");
    Expect(0, 194705, '\P{Nv=nan}', "");
    Expect(1, 194705, '\P{^Nv=nan}', "");
    Expect(0, 194704, '\p{Nv=nan}', "");
    Expect(1, 194704, '\p{^Nv=nan}', "");
    Expect(1, 194704, '\P{Nv=nan}', "");
    Expect(0, 194704, '\P{^Nv=nan}', "");
    Expect(1, 194705, '\p{Nv=:\Anan\z:}', "");;
    Expect(0, 194704, '\p{Nv=:\Anan\z:}', "");;
    Expect(1, 194705, '\p{Nv:_nan}', "");
    Expect(0, 194705, '\p{^Nv:_nan}', "");
    Expect(0, 194705, '\P{Nv:_nan}', "");
    Expect(1, 194705, '\P{^Nv:_nan}', "");
    Expect(0, 194704, '\p{Nv:_nan}', "");
    Expect(1, 194704, '\p{^Nv:_nan}', "");
    Expect(1, 194704, '\P{Nv:_nan}', "");
    Expect(0, 194704, '\P{^Nv:_nan}', "");
    Expect(1, 194705, '\p{Nv=NaN}', "");
    Expect(0, 194705, '\p{^Nv=NaN}', "");
    Expect(0, 194705, '\P{Nv=NaN}', "");
    Expect(1, 194705, '\P{^Nv=NaN}', "");
    Expect(0, 194704, '\p{Nv=NaN}', "");
    Expect(1, 194704, '\p{^Nv=NaN}', "");
    Expect(1, 194704, '\P{Nv=NaN}', "");
    Expect(0, 194704, '\P{^Nv=NaN}', "");
    Error('\p{Is_Numeric_Value=/a/		NAN}');
    Error('\P{Is_Numeric_Value=/a/		NAN}');
    Expect(1, 194705, '\p{Is_Numeric_Value=nan}', "");
    Expect(0, 194705, '\p{^Is_Numeric_Value=nan}', "");
    Expect(0, 194705, '\P{Is_Numeric_Value=nan}', "");
    Expect(1, 194705, '\P{^Is_Numeric_Value=nan}', "");
    Expect(0, 194704, '\p{Is_Numeric_Value=nan}', "");
    Expect(1, 194704, '\p{^Is_Numeric_Value=nan}', "");
    Expect(1, 194704, '\P{Is_Numeric_Value=nan}', "");
    Expect(0, 194704, '\P{^Is_Numeric_Value=nan}', "");
    Error('\p{Is_Nv= nan/a/}');
    Error('\P{Is_Nv= nan/a/}');
    Expect(1, 194705, '\p{Is_Nv=nan}', "");
    Expect(0, 194705, '\p{^Is_Nv=nan}', "");
    Expect(0, 194705, '\P{Is_Nv=nan}', "");
    Expect(1, 194705, '\P{^Is_Nv=nan}', "");
    Expect(0, 194704, '\p{Is_Nv=nan}', "");
    Expect(1, 194704, '\p{^Is_Nv=nan}', "");
    Expect(1, 194704, '\P{Is_Nv=nan}', "");
    Expect(0, 194704, '\P{^Is_Nv=nan}', "");
    Expect(1, 194705, '\p{Is_Nv=-_NaN}', "");
    Expect(0, 194705, '\p{^Is_Nv=-_NaN}', "");
    Expect(0, 194705, '\P{Is_Nv=-_NaN}', "");
    Expect(1, 194705, '\P{^Is_Nv=-_NaN}', "");
    Expect(0, 194704, '\p{Is_Nv=-_NaN}', "");
    Expect(1, 194704, '\p{^Is_Nv=-_NaN}', "");
    Expect(1, 194704, '\P{Is_Nv=-_NaN}', "");
    Expect(0, 194704, '\P{^Is_Nv=-_NaN}', "");
    Expect(1, 194705, '\p{Is_Nv=NaN}', "");
    Expect(0, 194705, '\p{^Is_Nv=NaN}', "");
    Expect(0, 194705, '\P{Is_Nv=NaN}', "");
    Expect(1, 194705, '\P{^Is_Nv=NaN}', "");
    Expect(0, 194704, '\p{Is_Nv=NaN}', "");
    Expect(1, 194704, '\p{^Is_Nv=NaN}', "");
    Expect(1, 194704, '\P{Is_Nv=NaN}', "");
    Expect(0, 194704, '\P{^Is_Nv=NaN}', "");
    Error('\p{Other_Alphabetic=No}');
    Error('\P{Other_Alphabetic=No}');
    Error('\p{OAlpha=N}');
    Error('\P{OAlpha=N}');
    Error('\p{Is_Other_Alphabetic=F}');
    Error('\P{Is_Other_Alphabetic=F}');
    Error('\p{Is_OAlpha=False}');
    Error('\P{Is_OAlpha=False}');
    Error('\p{Other_Alphabetic:Yes}');
    Error('\P{Other_Alphabetic:Yes}');
    Error('\p{OAlpha: Y}');
    Error('\P{OAlpha: Y}');
    Error('\p{Is_Other_Alphabetic=T}');
    Error('\P{Is_Other_Alphabetic=T}');
    Error('\p{Is_OAlpha=True}');
    Error('\P{Is_OAlpha=True}');
    Error('\p{Other_Default_Ignorable_Code_Point=No}');
    Error('\P{Other_Default_Ignorable_Code_Point=No}');
    Error('\p{ODI=N}');
    Error('\P{ODI=N}');
    Error('\p{Is_Other_Default_Ignorable_Code_Point=F}');
    Error('\P{Is_Other_Default_Ignorable_Code_Point=F}');
    Error('\p{Is_ODI=False}');
    Error('\P{Is_ODI=False}');
    Error('\p{Other_Default_Ignorable_Code_Point=Yes}');
    Error('\P{Other_Default_Ignorable_Code_Point=Yes}');
    Error('\p{ODI=Y}');
    Error('\P{ODI=Y}');
    Error('\p{Is_Other_Default_Ignorable_Code_Point=T}');
    Error('\P{Is_Other_Default_Ignorable_Code_Point=T}');
    Error('\p{Is_ODI=True}');
    Error('\P{Is_ODI=True}');
    Error('\p{Other_Grapheme_Extend=No}');
    Error('\P{Other_Grapheme_Extend=No}');
    Error('\p{OGr_Ext=N}');
    Error('\P{OGr_Ext=N}');
    Error('\p{Is_Other_Grapheme_Extend=F}');
    Error('\P{Is_Other_Grapheme_Extend=F}');
    Error('\p{Is_OGr_Ext=False}');
    Error('\P{Is_OGr_Ext=False}');
    Error('\p{Other_Grapheme_Extend=Yes}');
    Error('\P{Other_Grapheme_Extend=Yes}');
    Error('\p{OGr_Ext=Y}');
    Error('\P{OGr_Ext=Y}');
    Error('\p{Is_Other_Grapheme_Extend:   T}');
    Error('\P{Is_Other_Grapheme_Extend:   T}');
    Error('\p{Is_OGr_Ext=True}');
    Error('\P{Is_OGr_Ext=True}');
    Error('\p{Other_ID_Continue=No}');
    Error('\P{Other_ID_Continue=No}');
    Error('\p{OIDC=N}');
    Error('\P{OIDC=N}');
    Error('\p{Is_Other_ID_Continue=F}');
    Error('\P{Is_Other_ID_Continue=F}');
    Error('\p{Is_OIDC=False}');
    Error('\P{Is_OIDC=False}');
    Error('\p{Other_ID_Continue=Yes}');
    Error('\P{Other_ID_Continue=Yes}');
    Error('\p{OIDC=Y}');
    Error('\P{OIDC=Y}');
    Error('\p{Is_Other_ID_Continue:T}');
    Error('\P{Is_Other_ID_Continue:T}');
    Error('\p{Is_OIDC=True}');
    Error('\P{Is_OIDC=True}');
    Error('\p{Other_ID_Start=No}');
    Error('\P{Other_ID_Start=No}');
    Error('\p{OIDS=N}');
    Error('\P{OIDS=N}');
    Error('\p{Is_Other_ID_Start:F}');
    Error('\P{Is_Other_ID_Start:F}');
    Error('\p{Is_OIDS=False}');
    Error('\P{Is_OIDS=False}');
    Error('\p{Other_ID_Start=Yes}');
    Error('\P{Other_ID_Start=Yes}');
    Error('\p{OIDS:   Y}');
    Error('\P{OIDS:   Y}');
    Error('\p{Is_Other_ID_Start=T}');
    Error('\P{Is_Other_ID_Start=T}');
    Error('\p{Is_OIDS=True}');
    Error('\P{Is_OIDS=True}');
    Error('\p{Other_Lowercase=No}');
    Error('\P{Other_Lowercase=No}');
    Error('\p{OLower=N}');
    Error('\P{OLower=N}');
    Error('\p{Is_Other_Lowercase=F}');
    Error('\P{Is_Other_Lowercase=F}');
    Error('\p{Is_OLower:False}');
    Error('\P{Is_OLower:False}');
    Error('\p{Other_Lowercase=Yes}');
    Error('\P{Other_Lowercase=Yes}');
    Error('\p{OLower=Y}');
    Error('\P{OLower=Y}');
    Error('\p{Is_Other_Lowercase:	T}');
    Error('\P{Is_Other_Lowercase:	T}');
    Error('\p{Is_OLower:	True}');
    Error('\P{Is_OLower:	True}');
    Error('\p{Other_Math=No}');
    Error('\P{Other_Math=No}');
    Error('\p{OMath=N}');
    Error('\P{OMath=N}');
    Error('\p{Is_Other_Math=F}');
    Error('\P{Is_Other_Math=F}');
    Error('\p{Is_OMath=False}');
    Error('\P{Is_OMath=False}');
    Error('\p{Other_Math=Yes}');
    Error('\P{Other_Math=Yes}');
    Error('\p{OMath=Y}');
    Error('\P{OMath=Y}');
    Error('\p{Is_Other_Math=T}');
    Error('\P{Is_Other_Math=T}');
    Error('\p{Is_OMath=True}');
    Error('\P{Is_OMath=True}');
    Error('\p{Other_Uppercase=No}');
    Error('\P{Other_Uppercase=No}');
    Error('\p{OUpper=N}');
    Error('\P{OUpper=N}');
    Error('\p{Is_Other_Uppercase=F}');
    Error('\P{Is_Other_Uppercase=F}');
    Error('\p{Is_OUpper=False}');
    Error('\P{Is_OUpper=False}');
    Error('\p{Other_Uppercase=Yes}');
    Error('\P{Other_Uppercase=Yes}');
    Error('\p{OUpper=Y}');
    Error('\P{OUpper=Y}');
    Error('\p{Is_Other_Uppercase=T}');
    Error('\P{Is_Other_Uppercase=T}');
    Error('\p{Is_OUpper=True}');
    Error('\P{Is_OUpper=True}');
    Error('\p{Pattern_Syntax=/a/  no}');
    Error('\P{Pattern_Syntax=/a/  no}');
    Expect(1, 65095, '\p{Pattern_Syntax=:\ANo\z:}', "");;
    Expect(0, 65094, '\p{Pattern_Syntax=:\ANo\z:}', "");;
    Expect(1, 65095, '\p{Pattern_Syntax:	no}', "");
    Expect(0, 65095, '\p{^Pattern_Syntax:	no}', "");
    Expect(0, 65095, '\P{Pattern_Syntax:	no}', "");
    Expect(1, 65095, '\P{^Pattern_Syntax:	no}', "");
    Expect(0, 65094, '\p{Pattern_Syntax:	no}', "");
    Expect(1, 65094, '\p{^Pattern_Syntax:	no}', "");
    Expect(1, 65094, '\P{Pattern_Syntax:	no}', "");
    Expect(0, 65094, '\P{^Pattern_Syntax:	no}', "");
    Expect(1, 65095, '\p{Pattern_Syntax=:\Ano\z:}', "");;
    Expect(0, 65094, '\p{Pattern_Syntax=:\Ano\z:}', "");;
    Expect(1, 65095, '\p{Pattern_Syntax=		No}', "");
    Expect(0, 65095, '\p{^Pattern_Syntax=		No}', "");
    Expect(0, 65095, '\P{Pattern_Syntax=		No}', "");
    Expect(1, 65095, '\P{^Pattern_Syntax=		No}', "");
    Expect(0, 65094, '\p{Pattern_Syntax=		No}', "");
    Expect(1, 65094, '\p{^Pattern_Syntax=		No}', "");
    Expect(1, 65094, '\P{Pattern_Syntax=		No}', "");
    Expect(0, 65094, '\P{^Pattern_Syntax=		No}', "");
    Error('\p{Pat_Syn=/a/	N}');
    Error('\P{Pat_Syn=/a/	N}');
    Expect(1, 65095, '\p{Pat_Syn=:\AN\z:}', "");;
    Expect(0, 65094, '\p{Pat_Syn=:\AN\z:}', "");;
    Expect(1, 65095, '\p{Pat_Syn=n}', "");
    Expect(0, 65095, '\p{^Pat_Syn=n}', "");
    Expect(0, 65095, '\P{Pat_Syn=n}', "");
    Expect(1, 65095, '\P{^Pat_Syn=n}', "");
    Expect(0, 65094, '\p{Pat_Syn=n}', "");
    Expect(1, 65094, '\p{^Pat_Syn=n}', "");
    Expect(1, 65094, '\P{Pat_Syn=n}', "");
    Expect(0, 65094, '\P{^Pat_Syn=n}', "");
    Expect(1, 65095, '\p{Pat_Syn=:\An\z:}', "");;
    Expect(0, 65094, '\p{Pat_Syn=:\An\z:}', "");;
    Expect(1, 65095, '\p{Pat_Syn= -n}', "");
    Expect(0, 65095, '\p{^Pat_Syn= -n}', "");
    Expect(0, 65095, '\P{Pat_Syn= -n}', "");
    Expect(1, 65095, '\P{^Pat_Syn= -n}', "");
    Expect(0, 65094, '\p{Pat_Syn= -n}', "");
    Expect(1, 65094, '\p{^Pat_Syn= -n}', "");
    Expect(1, 65094, '\P{Pat_Syn= -n}', "");
    Expect(0, 65094, '\P{^Pat_Syn= -n}', "");
    Error('\p{Is_Pattern_Syntax=-_F:=}');
    Error('\P{Is_Pattern_Syntax=-_F:=}');
    Expect(1, 65095, '\p{Is_Pattern_Syntax=f}', "");
    Expect(0, 65095, '\p{^Is_Pattern_Syntax=f}', "");
    Expect(0, 65095, '\P{Is_Pattern_Syntax=f}', "");
    Expect(1, 65095, '\P{^Is_Pattern_Syntax=f}', "");
    Expect(0, 65094, '\p{Is_Pattern_Syntax=f}', "");
    Expect(1, 65094, '\p{^Is_Pattern_Syntax=f}', "");
    Expect(1, 65094, '\P{Is_Pattern_Syntax=f}', "");
    Expect(0, 65094, '\P{^Is_Pattern_Syntax=f}', "");
    Expect(1, 65095, '\p{Is_Pattern_Syntax=-	F}', "");
    Expect(0, 65095, '\p{^Is_Pattern_Syntax=-	F}', "");
    Expect(0, 65095, '\P{Is_Pattern_Syntax=-	F}', "");
    Expect(1, 65095, '\P{^Is_Pattern_Syntax=-	F}', "");
    Expect(0, 65094, '\p{Is_Pattern_Syntax=-	F}', "");
    Expect(1, 65094, '\p{^Is_Pattern_Syntax=-	F}', "");
    Expect(1, 65094, '\P{Is_Pattern_Syntax=-	F}', "");
    Expect(0, 65094, '\P{^Is_Pattern_Syntax=-	F}', "");
    Error('\p{Is_Pat_Syn=-False/a/}');
    Error('\P{Is_Pat_Syn=-False/a/}');
    Expect(1, 65095, '\p{Is_Pat_Syn=false}', "");
    Expect(0, 65095, '\p{^Is_Pat_Syn=false}', "");
    Expect(0, 65095, '\P{Is_Pat_Syn=false}', "");
    Expect(1, 65095, '\P{^Is_Pat_Syn=false}', "");
    Expect(0, 65094, '\p{Is_Pat_Syn=false}', "");
    Expect(1, 65094, '\p{^Is_Pat_Syn=false}', "");
    Expect(1, 65094, '\P{Is_Pat_Syn=false}', "");
    Expect(0, 65094, '\P{^Is_Pat_Syn=false}', "");
    Expect(1, 65095, '\p{Is_Pat_Syn=--False}', "");
    Expect(0, 65095, '\p{^Is_Pat_Syn=--False}', "");
    Expect(0, 65095, '\P{Is_Pat_Syn=--False}', "");
    Expect(1, 65095, '\P{^Is_Pat_Syn=--False}', "");
    Expect(0, 65094, '\p{Is_Pat_Syn=--False}', "");
    Expect(1, 65094, '\p{^Is_Pat_Syn=--False}', "");
    Expect(1, 65094, '\P{Is_Pat_Syn=--False}', "");
    Expect(0, 65094, '\P{^Is_Pat_Syn=--False}', "");
    Error('\p{Pattern_Syntax=	Yes/a/}');
    Error('\P{Pattern_Syntax=	Yes/a/}');
    Expect(1, 65094, '\p{Pattern_Syntax=:\AYes\z:}', "");;
    Expect(0, 65095, '\p{Pattern_Syntax=:\AYes\z:}', "");;
    Expect(1, 65094, '\p{Pattern_Syntax:	yes}', "");
    Expect(0, 65094, '\p{^Pattern_Syntax:	yes}', "");
    Expect(0, 65094, '\P{Pattern_Syntax:	yes}', "");
    Expect(1, 65094, '\P{^Pattern_Syntax:	yes}', "");
    Expect(0, 65095, '\p{Pattern_Syntax:	yes}', "");
    Expect(1, 65095, '\p{^Pattern_Syntax:	yes}', "");
    Expect(1, 65095, '\P{Pattern_Syntax:	yes}', "");
    Expect(0, 65095, '\P{^Pattern_Syntax:	yes}', "");
    Expect(1, 65094, '\p{Pattern_Syntax=:\Ayes\z:}', "");;
    Expect(0, 65095, '\p{Pattern_Syntax=:\Ayes\z:}', "");;
    Expect(1, 65094, '\p{Pattern_Syntax=__YES}', "");
    Expect(0, 65094, '\p{^Pattern_Syntax=__YES}', "");
    Expect(0, 65094, '\P{Pattern_Syntax=__YES}', "");
    Expect(1, 65094, '\P{^Pattern_Syntax=__YES}', "");
    Expect(0, 65095, '\p{Pattern_Syntax=__YES}', "");
    Expect(1, 65095, '\p{^Pattern_Syntax=__YES}', "");
    Expect(1, 65095, '\P{Pattern_Syntax=__YES}', "");
    Expect(0, 65095, '\P{^Pattern_Syntax=__YES}', "");
    Error('\p{Pat_Syn=-:=Y}');
    Error('\P{Pat_Syn=-:=Y}');
    Expect(1, 65094, '\p{Pat_Syn=:\AY\z:}', "");;
    Expect(0, 65095, '\p{Pat_Syn=:\AY\z:}', "");;
    Expect(1, 65094, '\p{Pat_Syn=y}', "");
    Expect(0, 65094, '\p{^Pat_Syn=y}', "");
    Expect(0, 65094, '\P{Pat_Syn=y}', "");
    Expect(1, 65094, '\P{^Pat_Syn=y}', "");
    Expect(0, 65095, '\p{Pat_Syn=y}', "");
    Expect(1, 65095, '\p{^Pat_Syn=y}', "");
    Expect(1, 65095, '\P{Pat_Syn=y}', "");
    Expect(0, 65095, '\P{^Pat_Syn=y}', "");
    Expect(1, 65094, '\p{Pat_Syn=:\Ay\z:}', "");;
    Expect(0, 65095, '\p{Pat_Syn=:\Ay\z:}', "");;
    Expect(1, 65094, '\p{Pat_Syn=	Y}', "");
    Expect(0, 65094, '\p{^Pat_Syn=	Y}', "");
    Expect(0, 65094, '\P{Pat_Syn=	Y}', "");
    Expect(1, 65094, '\P{^Pat_Syn=	Y}', "");
    Expect(0, 65095, '\p{Pat_Syn=	Y}', "");
    Expect(1, 65095, '\p{^Pat_Syn=	Y}', "");
    Expect(1, 65095, '\P{Pat_Syn=	Y}', "");
    Expect(0, 65095, '\P{^Pat_Syn=	Y}', "");
    Error('\p{Is_Pattern_Syntax=/a/ 	t}');
    Error('\P{Is_Pattern_Syntax=/a/ 	t}');
    Expect(1, 65094, '\p{Is_Pattern_Syntax=t}', "");
    Expect(0, 65094, '\p{^Is_Pattern_Syntax=t}', "");
    Expect(0, 65094, '\P{Is_Pattern_Syntax=t}', "");
    Expect(1, 65094, '\P{^Is_Pattern_Syntax=t}', "");
    Expect(0, 65095, '\p{Is_Pattern_Syntax=t}', "");
    Expect(1, 65095, '\p{^Is_Pattern_Syntax=t}', "");
    Expect(1, 65095, '\P{Is_Pattern_Syntax=t}', "");
    Expect(0, 65095, '\P{^Is_Pattern_Syntax=t}', "");
    Expect(1, 65094, '\p{Is_Pattern_Syntax=	-T}', "");
    Expect(0, 65094, '\p{^Is_Pattern_Syntax=	-T}', "");
    Expect(0, 65094, '\P{Is_Pattern_Syntax=	-T}', "");
    Expect(1, 65094, '\P{^Is_Pattern_Syntax=	-T}', "");
    Expect(0, 65095, '\p{Is_Pattern_Syntax=	-T}', "");
    Expect(1, 65095, '\p{^Is_Pattern_Syntax=	-T}', "");
    Expect(1, 65095, '\P{Is_Pattern_Syntax=	-T}', "");
    Expect(0, 65095, '\P{^Is_Pattern_Syntax=	-T}', "");
    Error('\p{Is_Pat_Syn:/a/-_TRUE}');
    Error('\P{Is_Pat_Syn:/a/-_TRUE}');
    Expect(1, 65094, '\p{Is_Pat_Syn: true}', "");
    Expect(0, 65094, '\p{^Is_Pat_Syn: true}', "");
    Expect(0, 65094, '\P{Is_Pat_Syn: true}', "");
    Expect(1, 65094, '\P{^Is_Pat_Syn: true}', "");
    Expect(0, 65095, '\p{Is_Pat_Syn: true}', "");
    Expect(1, 65095, '\p{^Is_Pat_Syn: true}', "");
    Expect(1, 65095, '\P{Is_Pat_Syn: true}', "");
    Expect(0, 65095, '\P{^Is_Pat_Syn: true}', "");
    Expect(1, 65094, '\p{Is_Pat_Syn=True}', "");
    Expect(0, 65094, '\p{^Is_Pat_Syn=True}', "");
    Expect(0, 65094, '\P{Is_Pat_Syn=True}', "");
    Expect(1, 65094, '\P{^Is_Pat_Syn=True}', "");
    Expect(0, 65095, '\p{Is_Pat_Syn=True}', "");
    Expect(1, 65095, '\p{^Is_Pat_Syn=True}', "");
    Expect(1, 65095, '\P{Is_Pat_Syn=True}', "");
    Expect(0, 65095, '\P{^Is_Pat_Syn=True}', "");
    Error('\p{Pattern_White_Space=_:=NO}');
    Error('\P{Pattern_White_Space=_:=NO}');
    Expect(1, 8234, '\p{Pattern_White_Space=:\ANo\z:}', "");;
    Expect(0, 8233, '\p{Pattern_White_Space=:\ANo\z:}', "");;
    Expect(1, 8234, '\p{Pattern_White_Space=no}', "");
    Expect(0, 8234, '\p{^Pattern_White_Space=no}', "");
    Expect(0, 8234, '\P{Pattern_White_Space=no}', "");
    Expect(1, 8234, '\P{^Pattern_White_Space=no}', "");
    Expect(0, 8233, '\p{Pattern_White_Space=no}', "");
    Expect(1, 8233, '\p{^Pattern_White_Space=no}', "");
    Expect(1, 8233, '\P{Pattern_White_Space=no}', "");
    Expect(0, 8233, '\P{^Pattern_White_Space=no}', "");
    Expect(1, 8234, '\p{Pattern_White_Space=:\Ano\z:}', "");;
    Expect(0, 8233, '\p{Pattern_White_Space=:\Ano\z:}', "");;
    Expect(1, 8234, '\p{Pattern_White_Space=_	NO}', "");
    Expect(0, 8234, '\p{^Pattern_White_Space=_	NO}', "");
    Expect(0, 8234, '\P{Pattern_White_Space=_	NO}', "");
    Expect(1, 8234, '\P{^Pattern_White_Space=_	NO}', "");
    Expect(0, 8233, '\p{Pattern_White_Space=_	NO}', "");
    Expect(1, 8233, '\p{^Pattern_White_Space=_	NO}', "");
    Expect(1, 8233, '\P{Pattern_White_Space=_	NO}', "");
    Expect(0, 8233, '\P{^Pattern_White_Space=_	NO}', "");
    Error('\p{Pat_WS=_n/a/}');
    Error('\P{Pat_WS=_n/a/}');
    Expect(1, 8234, '\p{Pat_WS=:\AN\z:}', "");;
    Expect(0, 8233, '\p{Pat_WS=:\AN\z:}', "");;
    Expect(1, 8234, '\p{Pat_WS=n}', "");
    Expect(0, 8234, '\p{^Pat_WS=n}', "");
    Expect(0, 8234, '\P{Pat_WS=n}', "");
    Expect(1, 8234, '\P{^Pat_WS=n}', "");
    Expect(0, 8233, '\p{Pat_WS=n}', "");
    Expect(1, 8233, '\p{^Pat_WS=n}', "");
    Expect(1, 8233, '\P{Pat_WS=n}', "");
    Expect(0, 8233, '\P{^Pat_WS=n}', "");
    Expect(1, 8234, '\p{Pat_WS=:\An\z:}', "");;
    Expect(0, 8233, '\p{Pat_WS=:\An\z:}', "");;
    Expect(1, 8234, '\p{Pat_WS= _N}', "");
    Expect(0, 8234, '\p{^Pat_WS= _N}', "");
    Expect(0, 8234, '\P{Pat_WS= _N}', "");
    Expect(1, 8234, '\P{^Pat_WS= _N}', "");
    Expect(0, 8233, '\p{Pat_WS= _N}', "");
    Expect(1, 8233, '\p{^Pat_WS= _N}', "");
    Expect(1, 8233, '\P{Pat_WS= _N}', "");
    Expect(0, 8233, '\P{^Pat_WS= _N}', "");
    Error('\p{Is_Pattern_White_Space=:=F}');
    Error('\P{Is_Pattern_White_Space=:=F}');
    Expect(1, 8234, '\p{Is_Pattern_White_Space=f}', "");
    Expect(0, 8234, '\p{^Is_Pattern_White_Space=f}', "");
    Expect(0, 8234, '\P{Is_Pattern_White_Space=f}', "");
    Expect(1, 8234, '\P{^Is_Pattern_White_Space=f}', "");
    Expect(0, 8233, '\p{Is_Pattern_White_Space=f}', "");
    Expect(1, 8233, '\p{^Is_Pattern_White_Space=f}', "");
    Expect(1, 8233, '\P{Is_Pattern_White_Space=f}', "");
    Expect(0, 8233, '\P{^Is_Pattern_White_Space=f}', "");
    Expect(1, 8234, '\p{Is_Pattern_White_Space=-_F}', "");
    Expect(0, 8234, '\p{^Is_Pattern_White_Space=-_F}', "");
    Expect(0, 8234, '\P{Is_Pattern_White_Space=-_F}', "");
    Expect(1, 8234, '\P{^Is_Pattern_White_Space=-_F}', "");
    Expect(0, 8233, '\p{Is_Pattern_White_Space=-_F}', "");
    Expect(1, 8233, '\p{^Is_Pattern_White_Space=-_F}', "");
    Expect(1, 8233, '\P{Is_Pattern_White_Space=-_F}', "");
    Expect(0, 8233, '\P{^Is_Pattern_White_Space=-_F}', "");
    Error('\p{Is_Pat_WS=:=False}');
    Error('\P{Is_Pat_WS=:=False}');
    Expect(1, 8234, '\p{Is_Pat_WS=false}', "");
    Expect(0, 8234, '\p{^Is_Pat_WS=false}', "");
    Expect(0, 8234, '\P{Is_Pat_WS=false}', "");
    Expect(1, 8234, '\P{^Is_Pat_WS=false}', "");
    Expect(0, 8233, '\p{Is_Pat_WS=false}', "");
    Expect(1, 8233, '\p{^Is_Pat_WS=false}', "");
    Expect(1, 8233, '\P{Is_Pat_WS=false}', "");
    Expect(0, 8233, '\P{^Is_Pat_WS=false}', "");
    Expect(1, 8234, '\p{Is_Pat_WS= 	false}', "");
    Expect(0, 8234, '\p{^Is_Pat_WS= 	false}', "");
    Expect(0, 8234, '\P{Is_Pat_WS= 	false}', "");
    Expect(1, 8234, '\P{^Is_Pat_WS= 	false}', "");
    Expect(0, 8233, '\p{Is_Pat_WS= 	false}', "");
    Expect(1, 8233, '\p{^Is_Pat_WS= 	false}', "");
    Expect(1, 8233, '\P{Is_Pat_WS= 	false}', "");
    Expect(0, 8233, '\P{^Is_Pat_WS= 	false}', "");
    Error('\p{Pattern_White_Space=/a/Yes}');
    Error('\P{Pattern_White_Space=/a/Yes}');
    Expect(1, 8233, '\p{Pattern_White_Space=:\AYes\z:}', "");;
    Expect(0, 8234, '\p{Pattern_White_Space=:\AYes\z:}', "");;
    Expect(1, 8233, '\p{Pattern_White_Space=yes}', "");
    Expect(0, 8233, '\p{^Pattern_White_Space=yes}', "");
    Expect(0, 8233, '\P{Pattern_White_Space=yes}', "");
    Expect(1, 8233, '\P{^Pattern_White_Space=yes}', "");
    Expect(0, 8234, '\p{Pattern_White_Space=yes}', "");
    Expect(1, 8234, '\p{^Pattern_White_Space=yes}', "");
    Expect(1, 8234, '\P{Pattern_White_Space=yes}', "");
    Expect(0, 8234, '\P{^Pattern_White_Space=yes}', "");
    Expect(1, 8233, '\p{Pattern_White_Space=:\Ayes\z:}', "");;
    Expect(0, 8234, '\p{Pattern_White_Space=:\Ayes\z:}', "");;
    Expect(1, 8233, '\p{Pattern_White_Space:--YES}', "");
    Expect(0, 8233, '\p{^Pattern_White_Space:--YES}', "");
    Expect(0, 8233, '\P{Pattern_White_Space:--YES}', "");
    Expect(1, 8233, '\P{^Pattern_White_Space:--YES}', "");
    Expect(0, 8234, '\p{Pattern_White_Space:--YES}', "");
    Expect(1, 8234, '\p{^Pattern_White_Space:--YES}', "");
    Expect(1, 8234, '\P{Pattern_White_Space:--YES}', "");
    Expect(0, 8234, '\P{^Pattern_White_Space:--YES}', "");
    Error('\p{Pat_WS: /a/ Y}');
    Error('\P{Pat_WS: /a/ Y}');
    Expect(1, 8233, '\p{Pat_WS=:\AY\z:}', "");;
    Expect(0, 8234, '\p{Pat_WS=:\AY\z:}', "");;
    Expect(1, 8233, '\p{Pat_WS=y}', "");
    Expect(0, 8233, '\p{^Pat_WS=y}', "");
    Expect(0, 8233, '\P{Pat_WS=y}', "");
    Expect(1, 8233, '\P{^Pat_WS=y}', "");
    Expect(0, 8234, '\p{Pat_WS=y}', "");
    Expect(1, 8234, '\p{^Pat_WS=y}', "");
    Expect(1, 8234, '\P{Pat_WS=y}', "");
    Expect(0, 8234, '\P{^Pat_WS=y}', "");
    Expect(1, 8233, '\p{Pat_WS=:\Ay\z:}', "");;
    Expect(0, 8234, '\p{Pat_WS=:\Ay\z:}', "");;
    Expect(1, 8233, '\p{Pat_WS=  Y}', "");
    Expect(0, 8233, '\p{^Pat_WS=  Y}', "");
    Expect(0, 8233, '\P{Pat_WS=  Y}', "");
    Expect(1, 8233, '\P{^Pat_WS=  Y}', "");
    Expect(0, 8234, '\p{Pat_WS=  Y}', "");
    Expect(1, 8234, '\p{^Pat_WS=  Y}', "");
    Expect(1, 8234, '\P{Pat_WS=  Y}', "");
    Expect(0, 8234, '\P{^Pat_WS=  Y}', "");
    Error('\p{Is_Pattern_White_Space=-_T:=}');
    Error('\P{Is_Pattern_White_Space=-_T:=}');
    Expect(1, 8233, '\p{Is_Pattern_White_Space=t}', "");
    Expect(0, 8233, '\p{^Is_Pattern_White_Space=t}', "");
    Expect(0, 8233, '\P{Is_Pattern_White_Space=t}', "");
    Expect(1, 8233, '\P{^Is_Pattern_White_Space=t}', "");
    Expect(0, 8234, '\p{Is_Pattern_White_Space=t}', "");
    Expect(1, 8234, '\p{^Is_Pattern_White_Space=t}', "");
    Expect(1, 8234, '\P{Is_Pattern_White_Space=t}', "");
    Expect(0, 8234, '\P{^Is_Pattern_White_Space=t}', "");
    Expect(1, 8233, '\p{Is_Pattern_White_Space= _T}', "");
    Expect(0, 8233, '\p{^Is_Pattern_White_Space= _T}', "");
    Expect(0, 8233, '\P{Is_Pattern_White_Space= _T}', "");
    Expect(1, 8233, '\P{^Is_Pattern_White_Space= _T}', "");
    Expect(0, 8234, '\p{Is_Pattern_White_Space= _T}', "");
    Expect(1, 8234, '\p{^Is_Pattern_White_Space= _T}', "");
    Expect(1, 8234, '\P{Is_Pattern_White_Space= _T}', "");
    Expect(0, 8234, '\P{^Is_Pattern_White_Space= _T}', "");
    Error('\p{Is_Pat_WS=	:=True}');
    Error('\P{Is_Pat_WS=	:=True}');
    Expect(1, 8233, '\p{Is_Pat_WS:   true}', "");
    Expect(0, 8233, '\p{^Is_Pat_WS:   true}', "");
    Expect(0, 8233, '\P{Is_Pat_WS:   true}', "");
    Expect(1, 8233, '\P{^Is_Pat_WS:   true}', "");
    Expect(0, 8234, '\p{Is_Pat_WS:   true}', "");
    Expect(1, 8234, '\p{^Is_Pat_WS:   true}', "");
    Expect(1, 8234, '\P{Is_Pat_WS:   true}', "");
    Expect(0, 8234, '\P{^Is_Pat_WS:   true}', "");
    Expect(1, 8233, '\p{Is_Pat_WS=  True}', "");
    Expect(0, 8233, '\p{^Is_Pat_WS=  True}', "");
    Expect(0, 8233, '\P{Is_Pat_WS=  True}', "");
    Expect(1, 8233, '\P{^Is_Pat_WS=  True}', "");
    Expect(0, 8234, '\p{Is_Pat_WS=  True}', "");
    Expect(1, 8234, '\p{^Is_Pat_WS=  True}', "");
    Expect(1, 8234, '\P{Is_Pat_WS=  True}', "");
    Expect(0, 8234, '\P{^Is_Pat_WS=  True}', "");
    Error('\p{Prepended_Concatenation_Mark=:= no}');
    Error('\P{Prepended_Concatenation_Mark=:= no}');
    Expect(1, 69838, '\p{Prepended_Concatenation_Mark=:\ANo\z:}', "");;
    Expect(0, 69837, '\p{Prepended_Concatenation_Mark=:\ANo\z:}', "");;
    Expect(1, 69838, '\p{Prepended_Concatenation_Mark=no}', "");
    Expect(0, 69838, '\p{^Prepended_Concatenation_Mark=no}', "");
    Expect(0, 69838, '\P{Prepended_Concatenation_Mark=no}', "");
    Expect(1, 69838, '\P{^Prepended_Concatenation_Mark=no}', "");
    Expect(0, 69837, '\p{Prepended_Concatenation_Mark=no}', "");
    Expect(1, 69837, '\p{^Prepended_Concatenation_Mark=no}', "");
    Expect(1, 69837, '\P{Prepended_Concatenation_Mark=no}', "");
    Expect(0, 69837, '\P{^Prepended_Concatenation_Mark=no}', "");
    Expect(1, 69838, '\p{Prepended_Concatenation_Mark=:\Ano\z:}', "");;
    Expect(0, 69837, '\p{Prepended_Concatenation_Mark=:\Ano\z:}', "");;
    Expect(1, 69838, '\p{Prepended_Concatenation_Mark= 	No}', "");
    Expect(0, 69838, '\p{^Prepended_Concatenation_Mark= 	No}', "");
    Expect(0, 69838, '\P{Prepended_Concatenation_Mark= 	No}', "");
    Expect(1, 69838, '\P{^Prepended_Concatenation_Mark= 	No}', "");
    Expect(0, 69837, '\p{Prepended_Concatenation_Mark= 	No}', "");
    Expect(1, 69837, '\p{^Prepended_Concatenation_Mark= 	No}', "");
    Expect(1, 69837, '\P{Prepended_Concatenation_Mark= 	No}', "");
    Expect(0, 69837, '\P{^Prepended_Concatenation_Mark= 	No}', "");
    Error('\p{PCM=/a/--n}');
    Error('\P{PCM=/a/--n}');
    Expect(1, 69838, '\p{PCM=:\AN\z:}', "");;
    Expect(0, 69837, '\p{PCM=:\AN\z:}', "");;
    Expect(1, 69838, '\p{PCM=n}', "");
    Expect(0, 69838, '\p{^PCM=n}', "");
    Expect(0, 69838, '\P{PCM=n}', "");
    Expect(1, 69838, '\P{^PCM=n}', "");
    Expect(0, 69837, '\p{PCM=n}', "");
    Expect(1, 69837, '\p{^PCM=n}', "");
    Expect(1, 69837, '\P{PCM=n}', "");
    Expect(0, 69837, '\P{^PCM=n}', "");
    Expect(1, 69838, '\p{PCM=:\An\z:}', "");;
    Expect(0, 69837, '\p{PCM=:\An\z:}', "");;
    Expect(1, 69838, '\p{PCM=	-N}', "");
    Expect(0, 69838, '\p{^PCM=	-N}', "");
    Expect(0, 69838, '\P{PCM=	-N}', "");
    Expect(1, 69838, '\P{^PCM=	-N}', "");
    Expect(0, 69837, '\p{PCM=	-N}', "");
    Expect(1, 69837, '\p{^PCM=	-N}', "");
    Expect(1, 69837, '\P{PCM=	-N}', "");
    Expect(0, 69837, '\P{^PCM=	-N}', "");
    Error('\p{Is_Prepended_Concatenation_Mark=-	f/a/}');
    Error('\P{Is_Prepended_Concatenation_Mark=-	f/a/}');
    Expect(1, 69838, '\p{Is_Prepended_Concatenation_Mark:f}', "");
    Expect(0, 69838, '\p{^Is_Prepended_Concatenation_Mark:f}', "");
    Expect(0, 69838, '\P{Is_Prepended_Concatenation_Mark:f}', "");
    Expect(1, 69838, '\P{^Is_Prepended_Concatenation_Mark:f}', "");
    Expect(0, 69837, '\p{Is_Prepended_Concatenation_Mark:f}', "");
    Expect(1, 69837, '\p{^Is_Prepended_Concatenation_Mark:f}', "");
    Expect(1, 69837, '\P{Is_Prepended_Concatenation_Mark:f}', "");
    Expect(0, 69837, '\P{^Is_Prepended_Concatenation_Mark:f}', "");
    Expect(1, 69838, '\p{Is_Prepended_Concatenation_Mark=F}', "");
    Expect(0, 69838, '\p{^Is_Prepended_Concatenation_Mark=F}', "");
    Expect(0, 69838, '\P{Is_Prepended_Concatenation_Mark=F}', "");
    Expect(1, 69838, '\P{^Is_Prepended_Concatenation_Mark=F}', "");
    Expect(0, 69837, '\p{Is_Prepended_Concatenation_Mark=F}', "");
    Expect(1, 69837, '\p{^Is_Prepended_Concatenation_Mark=F}', "");
    Expect(1, 69837, '\P{Is_Prepended_Concatenation_Mark=F}', "");
    Expect(0, 69837, '\P{^Is_Prepended_Concatenation_Mark=F}', "");
    Error('\p{Is_PCM=_-False:=}');
    Error('\P{Is_PCM=_-False:=}');
    Expect(1, 69838, '\p{Is_PCM=false}', "");
    Expect(0, 69838, '\p{^Is_PCM=false}', "");
    Expect(0, 69838, '\P{Is_PCM=false}', "");
    Expect(1, 69838, '\P{^Is_PCM=false}', "");
    Expect(0, 69837, '\p{Is_PCM=false}', "");
    Expect(1, 69837, '\p{^Is_PCM=false}', "");
    Expect(1, 69837, '\P{Is_PCM=false}', "");
    Expect(0, 69837, '\P{^Is_PCM=false}', "");
    Expect(1, 69838, '\p{Is_PCM=_ False}', "");
    Expect(0, 69838, '\p{^Is_PCM=_ False}', "");
    Expect(0, 69838, '\P{Is_PCM=_ False}', "");
    Expect(1, 69838, '\P{^Is_PCM=_ False}', "");
    Expect(0, 69837, '\p{Is_PCM=_ False}', "");
    Expect(1, 69837, '\p{^Is_PCM=_ False}', "");
    Expect(1, 69837, '\P{Is_PCM=_ False}', "");
    Expect(0, 69837, '\P{^Is_PCM=_ False}', "");
    Error('\p{Prepended_Concatenation_Mark=:=--Yes}');
    Error('\P{Prepended_Concatenation_Mark=:=--Yes}');
    Expect(1, 69837, '\p{Prepended_Concatenation_Mark=:\AYes\z:}', "");;
    Expect(0, 69838, '\p{Prepended_Concatenation_Mark=:\AYes\z:}', "");;
    Expect(1, 69837, '\p{Prepended_Concatenation_Mark=yes}', "");
    Expect(0, 69837, '\p{^Prepended_Concatenation_Mark=yes}', "");
    Expect(0, 69837, '\P{Prepended_Concatenation_Mark=yes}', "");
    Expect(1, 69837, '\P{^Prepended_Concatenation_Mark=yes}', "");
    Expect(0, 69838, '\p{Prepended_Concatenation_Mark=yes}', "");
    Expect(1, 69838, '\p{^Prepended_Concatenation_Mark=yes}', "");
    Expect(1, 69838, '\P{Prepended_Concatenation_Mark=yes}', "");
    Expect(0, 69838, '\P{^Prepended_Concatenation_Mark=yes}', "");
    Expect(1, 69837, '\p{Prepended_Concatenation_Mark=:\Ayes\z:}', "");;
    Expect(0, 69838, '\p{Prepended_Concatenation_Mark=:\Ayes\z:}', "");;
    Expect(1, 69837, '\p{Prepended_Concatenation_Mark:Yes}', "");
    Expect(0, 69837, '\p{^Prepended_Concatenation_Mark:Yes}', "");
    Expect(0, 69837, '\P{Prepended_Concatenation_Mark:Yes}', "");
    Expect(1, 69837, '\P{^Prepended_Concatenation_Mark:Yes}', "");
    Expect(0, 69838, '\p{Prepended_Concatenation_Mark:Yes}', "");
    Expect(1, 69838, '\p{^Prepended_Concatenation_Mark:Yes}', "");
    Expect(1, 69838, '\P{Prepended_Concatenation_Mark:Yes}', "");
    Expect(0, 69838, '\P{^Prepended_Concatenation_Mark:Yes}', "");
    Error('\p{PCM=_:=y}');
    Error('\P{PCM=_:=y}');
    Expect(1, 69837, '\p{PCM=:\AY\z:}', "");;
    Expect(0, 69838, '\p{PCM=:\AY\z:}', "");;
    Expect(1, 69837, '\p{PCM=y}', "");
    Expect(0, 69837, '\p{^PCM=y}', "");
    Expect(0, 69837, '\P{PCM=y}', "");
    Expect(1, 69837, '\P{^PCM=y}', "");
    Expect(0, 69838, '\p{PCM=y}', "");
    Expect(1, 69838, '\p{^PCM=y}', "");
    Expect(1, 69838, '\P{PCM=y}', "");
    Expect(0, 69838, '\P{^PCM=y}', "");
    Expect(1, 69837, '\p{PCM=:\Ay\z:}', "");;
    Expect(0, 69838, '\p{PCM=:\Ay\z:}', "");;
    Expect(1, 69837, '\p{PCM=_Y}', "");
    Expect(0, 69837, '\p{^PCM=_Y}', "");
    Expect(0, 69837, '\P{PCM=_Y}', "");
    Expect(1, 69837, '\P{^PCM=_Y}', "");
    Expect(0, 69838, '\p{PCM=_Y}', "");
    Expect(1, 69838, '\p{^PCM=_Y}', "");
    Expect(1, 69838, '\P{PCM=_Y}', "");
    Expect(0, 69838, '\P{^PCM=_Y}', "");
    Error('\p{Is_Prepended_Concatenation_Mark=- T:=}');
    Error('\P{Is_Prepended_Concatenation_Mark=- T:=}');
    Expect(1, 69837, '\p{Is_Prepended_Concatenation_Mark:   t}', "");
    Expect(0, 69837, '\p{^Is_Prepended_Concatenation_Mark:   t}', "");
    Expect(0, 69837, '\P{Is_Prepended_Concatenation_Mark:   t}', "");
    Expect(1, 69837, '\P{^Is_Prepended_Concatenation_Mark:   t}', "");
    Expect(0, 69838, '\p{Is_Prepended_Concatenation_Mark:   t}', "");
    Expect(1, 69838, '\p{^Is_Prepended_Concatenation_Mark:   t}', "");
    Expect(1, 69838, '\P{Is_Prepended_Concatenation_Mark:   t}', "");
    Expect(0, 69838, '\P{^Is_Prepended_Concatenation_Mark:   t}', "");
    Expect(1, 69837, '\p{Is_Prepended_Concatenation_Mark= 	t}', "");
    Expect(0, 69837, '\p{^Is_Prepended_Concatenation_Mark= 	t}', "");
    Expect(0, 69837, '\P{Is_Prepended_Concatenation_Mark= 	t}', "");
    Expect(1, 69837, '\P{^Is_Prepended_Concatenation_Mark= 	t}', "");
    Expect(0, 69838, '\p{Is_Prepended_Concatenation_Mark= 	t}', "");
    Expect(1, 69838, '\p{^Is_Prepended_Concatenation_Mark= 	t}', "");
    Expect(1, 69838, '\P{Is_Prepended_Concatenation_Mark= 	t}', "");
    Expect(0, 69838, '\P{^Is_Prepended_Concatenation_Mark= 	t}', "");
    Error('\p{Is_PCM= TRUE/a/}');
    Error('\P{Is_PCM= TRUE/a/}');
    Expect(1, 69837, '\p{Is_PCM:   true}', "");
    Expect(0, 69837, '\p{^Is_PCM:   true}', "");
    Expect(0, 69837, '\P{Is_PCM:   true}', "");
    Expect(1, 69837, '\P{^Is_PCM:   true}', "");
    Expect(0, 69838, '\p{Is_PCM:   true}', "");
    Expect(1, 69838, '\p{^Is_PCM:   true}', "");
    Expect(1, 69838, '\P{Is_PCM:   true}', "");
    Expect(0, 69838, '\P{^Is_PCM:   true}', "");
    Expect(1, 69837, '\p{Is_PCM=_	True}', "");
    Expect(0, 69837, '\p{^Is_PCM=_	True}', "");
    Expect(0, 69837, '\P{Is_PCM=_	True}', "");
    Expect(1, 69837, '\P{^Is_PCM=_	True}', "");
    Expect(0, 69838, '\p{Is_PCM=_	True}', "");
    Expect(1, 69838, '\p{^Is_PCM=_	True}', "");
    Expect(1, 69838, '\P{Is_PCM=_	True}', "");
    Expect(0, 69838, '\P{^Is_PCM=_	True}', "");
    Error('\p{perl}');
    Error('\P{perl}');
    Error('\p{-	Adlam/a/}');
    Error('\P{-	Adlam/a/}');
    Expect(1, 125279, '\p{adlam}', "");
    Expect(0, 125279, '\p{^adlam}', "");
    Expect(0, 125279, '\P{adlam}', "");
    Expect(1, 125279, '\P{^adlam}', "");
    Expect(0, 125280, '\p{adlam}', "");
    Expect(1, 125280, '\p{^adlam}', "");
    Expect(1, 125280, '\P{adlam}', "");
    Expect(0, 125280, '\P{^adlam}', "");
    Expect(1, 125279, '\p{	adlam}', "");
    Expect(0, 125279, '\p{^	adlam}', "");
    Expect(0, 125279, '\P{	adlam}', "");
    Expect(1, 125279, '\P{^	adlam}', "");
    Expect(0, 125280, '\p{	adlam}', "");
    Expect(1, 125280, '\p{^	adlam}', "");
    Expect(1, 125280, '\P{	adlam}', "");
    Expect(0, 125280, '\P{^	adlam}', "");
    Error('\p{/a/-is_adlam}');
    Error('\P{/a/-is_adlam}');
    Expect(1, 125279, '\p{isadlam}', "");
    Expect(0, 125279, '\p{^isadlam}', "");
    Expect(0, 125279, '\P{isadlam}', "");
    Expect(1, 125279, '\P{^isadlam}', "");
    Expect(0, 125280, '\p{isadlam}', "");
    Expect(1, 125280, '\p{^isadlam}', "");
    Expect(1, 125280, '\P{isadlam}', "");
    Expect(0, 125280, '\P{^isadlam}', "");
    Expect(1, 125279, '\p{_	Is_adlam}', "");
    Expect(0, 125279, '\p{^_	Is_adlam}', "");
    Expect(0, 125279, '\P{_	Is_adlam}', "");
    Expect(1, 125279, '\P{^_	Is_adlam}', "");
    Expect(0, 125280, '\p{_	Is_adlam}', "");
    Expect(1, 125280, '\p{^_	Is_adlam}', "");
    Expect(1, 125280, '\P{_	Is_adlam}', "");
    Expect(0, 125280, '\P{^_	Is_adlam}', "");
    Error('\p{:= adlm}');
    Error('\P{:= adlm}');
    Expect(1, 125279, '\p{adlm}', "");
    Expect(0, 125279, '\p{^adlm}', "");
    Expect(0, 125279, '\P{adlm}', "");
    Expect(1, 125279, '\P{^adlm}', "");
    Expect(0, 125280, '\p{adlm}', "");
    Expect(1, 125280, '\p{^adlm}', "");
    Expect(1, 125280, '\P{adlm}', "");
    Expect(0, 125280, '\P{^adlm}', "");
    Expect(1, 125279, '\p{-Adlm}', "");
    Expect(0, 125279, '\p{^-Adlm}', "");
    Expect(0, 125279, '\P{-Adlm}', "");
    Expect(1, 125279, '\P{^-Adlm}', "");
    Expect(0, 125280, '\p{-Adlm}', "");
    Expect(1, 125280, '\p{^-Adlm}', "");
    Expect(1, 125280, '\P{-Adlm}', "");
    Expect(0, 125280, '\P{^-Adlm}', "");
    Error('\p{	:=Is_adlm}');
    Error('\P{	:=Is_adlm}');
    Expect(1, 125279, '\p{isadlm}', "");
    Expect(0, 125279, '\p{^isadlm}', "");
    Expect(0, 125279, '\P{isadlm}', "");
    Expect(1, 125279, '\P{^isadlm}', "");
    Expect(0, 125280, '\p{isadlm}', "");
    Expect(1, 125280, '\p{^isadlm}', "");
    Expect(1, 125280, '\P{isadlm}', "");
    Expect(0, 125280, '\P{^isadlm}', "");
    Expect(1, 125279, '\p{__Is_Adlm}', "");
    Expect(0, 125279, '\p{^__Is_Adlm}', "");
    Expect(0, 125279, '\P{__Is_Adlm}', "");
    Expect(1, 125279, '\P{^__Is_Adlm}', "");
    Expect(0, 125280, '\p{__Is_Adlm}', "");
    Expect(1, 125280, '\p{^__Is_Adlm}', "");
    Expect(1, 125280, '\P{__Is_Adlm}', "");
    Expect(0, 125280, '\P{^__Is_Adlm}', "");
    Error('\p{_Aegean_Numbers/a/}');
    Error('\P{_Aegean_Numbers/a/}');
    Expect(1, 65855, '\p{aegeannumbers}', "");
    Expect(0, 65855, '\p{^aegeannumbers}', "");
    Expect(0, 65855, '\P{aegeannumbers}', "");
    Expect(1, 65855, '\P{^aegeannumbers}', "");
    Expect(0, 65856, '\p{aegeannumbers}', "");
    Expect(1, 65856, '\p{^aegeannumbers}', "");
    Expect(1, 65856, '\P{aegeannumbers}', "");
    Expect(0, 65856, '\P{^aegeannumbers}', "");
    Expect(1, 65855, '\p{	-Aegean_numbers}', "");
    Expect(0, 65855, '\p{^	-Aegean_numbers}', "");
    Expect(0, 65855, '\P{	-Aegean_numbers}', "");
    Expect(1, 65855, '\P{^	-Aegean_numbers}', "");
    Expect(0, 65856, '\p{	-Aegean_numbers}', "");
    Expect(1, 65856, '\p{^	-Aegean_numbers}', "");
    Expect(1, 65856, '\P{	-Aegean_numbers}', "");
    Expect(0, 65856, '\P{^	-Aegean_numbers}', "");
    Error('\p{:=__is_Aegean_Numbers}');
    Error('\P{:=__is_Aegean_Numbers}');
    Expect(1, 65855, '\p{isaegeannumbers}', "");
    Expect(0, 65855, '\p{^isaegeannumbers}', "");
    Expect(0, 65855, '\P{isaegeannumbers}', "");
    Expect(1, 65855, '\P{^isaegeannumbers}', "");
    Expect(0, 65856, '\p{isaegeannumbers}', "");
    Expect(1, 65856, '\p{^isaegeannumbers}', "");
    Expect(1, 65856, '\P{isaegeannumbers}', "");
    Expect(0, 65856, '\P{^isaegeannumbers}', "");
    Expect(1, 65855, '\p{	Is_Aegean_Numbers}', "");
    Expect(0, 65855, '\p{^	Is_Aegean_Numbers}', "");
    Expect(0, 65855, '\P{	Is_Aegean_Numbers}', "");
    Expect(1, 65855, '\P{^	Is_Aegean_Numbers}', "");
    Expect(0, 65856, '\p{	Is_Aegean_Numbers}', "");
    Expect(1, 65856, '\p{^	Is_Aegean_Numbers}', "");
    Expect(1, 65856, '\P{	Is_Aegean_Numbers}', "");
    Expect(0, 65856, '\P{^	Is_Aegean_Numbers}', "");
    Error('\p{_	in_aegean_Numbers/a/}');
    Error('\P{_	in_aegean_Numbers/a/}');
    Expect(1, 65855, '\p{inaegeannumbers}', "");
    Expect(0, 65855, '\p{^inaegeannumbers}', "");
    Expect(0, 65855, '\P{inaegeannumbers}', "");
    Expect(1, 65855, '\P{^inaegeannumbers}', "");
    Expect(0, 65856, '\p{inaegeannumbers}', "");
    Expect(1, 65856, '\p{^inaegeannumbers}', "");
    Expect(1, 65856, '\P{inaegeannumbers}', "");
    Expect(0, 65856, '\P{^inaegeannumbers}', "");
    Expect(1, 65855, '\p{ 	In_Aegean_numbers}', "");
    Expect(0, 65855, '\p{^ 	In_Aegean_numbers}', "");
    Expect(0, 65855, '\P{ 	In_Aegean_numbers}', "");
    Expect(1, 65855, '\P{^ 	In_Aegean_numbers}', "");
    Expect(0, 65856, '\p{ 	In_Aegean_numbers}', "");
    Expect(1, 65856, '\p{^ 	In_Aegean_numbers}', "");
    Expect(1, 65856, '\P{ 	In_Aegean_numbers}', "");
    Expect(0, 65856, '\P{^ 	In_Aegean_numbers}', "");
    Error('\p{:=-_Ahom}');
    Error('\P{:=-_Ahom}');
    Expect(1, 71487, '\p{ahom}', "");
    Expect(0, 71487, '\p{^ahom}', "");
    Expect(0, 71487, '\P{ahom}', "");
    Expect(1, 71487, '\P{^ahom}', "");
    Expect(0, 71488, '\p{ahom}', "");
    Expect(1, 71488, '\p{^ahom}', "");
    Expect(1, 71488, '\P{ahom}', "");
    Expect(0, 71488, '\P{^ahom}', "");
    Expect(1, 71487, '\p{_ ahom}', "");
    Expect(0, 71487, '\p{^_ ahom}', "");
    Expect(0, 71487, '\P{_ ahom}', "");
    Expect(1, 71487, '\P{^_ ahom}', "");
    Expect(0, 71488, '\p{_ ahom}', "");
    Expect(1, 71488, '\p{^_ ahom}', "");
    Expect(1, 71488, '\P{_ ahom}', "");
    Expect(0, 71488, '\P{^_ ahom}', "");
    Error('\p{ is_AHOM:=}');
    Error('\P{ is_AHOM:=}');
    Expect(1, 71487, '\p{isahom}', "");
    Expect(0, 71487, '\p{^isahom}', "");
    Expect(0, 71487, '\P{isahom}', "");
    Expect(1, 71487, '\P{^isahom}', "");
    Expect(0, 71488, '\p{isahom}', "");
    Expect(1, 71488, '\p{^isahom}', "");
    Expect(1, 71488, '\P{isahom}', "");
    Expect(0, 71488, '\P{^isahom}', "");
    Expect(1, 71487, '\p{-	Is_AHOM}', "");
    Expect(0, 71487, '\p{^-	Is_AHOM}', "");
    Expect(0, 71487, '\P{-	Is_AHOM}', "");
    Expect(1, 71487, '\P{^-	Is_AHOM}', "");
    Expect(0, 71488, '\p{-	Is_AHOM}', "");
    Expect(1, 71488, '\p{^-	Is_AHOM}', "");
    Expect(1, 71488, '\P{-	Is_AHOM}', "");
    Expect(0, 71488, '\P{^-	Is_AHOM}', "");
    Error('\p{ /a/Alchemical_Symbols}');
    Error('\P{ /a/Alchemical_Symbols}');
    Expect(1, 128895, '\p{alchemicalsymbols}', "");
    Expect(0, 128895, '\p{^alchemicalsymbols}', "");
    Expect(0, 128895, '\P{alchemicalsymbols}', "");
    Expect(1, 128895, '\P{^alchemicalsymbols}', "");
    Expect(0, 128896, '\p{alchemicalsymbols}', "");
    Expect(1, 128896, '\p{^alchemicalsymbols}', "");
    Expect(1, 128896, '\P{alchemicalsymbols}', "");
    Expect(0, 128896, '\P{^alchemicalsymbols}', "");
    Expect(1, 128895, '\p{-	alchemical_symbols}', "");
    Expect(0, 128895, '\p{^-	alchemical_symbols}', "");
    Expect(0, 128895, '\P{-	alchemical_symbols}', "");
    Expect(1, 128895, '\P{^-	alchemical_symbols}', "");
    Expect(0, 128896, '\p{-	alchemical_symbols}', "");
    Expect(1, 128896, '\p{^-	alchemical_symbols}', "");
    Expect(1, 128896, '\P{-	alchemical_symbols}', "");
    Expect(0, 128896, '\P{^-	alchemical_symbols}', "");
    Error('\p{-is_Alchemical_SYMBOLS:=}');
    Error('\P{-is_Alchemical_SYMBOLS:=}');
    Expect(1, 128895, '\p{isalchemicalsymbols}', "");
    Expect(0, 128895, '\p{^isalchemicalsymbols}', "");
    Expect(0, 128895, '\P{isalchemicalsymbols}', "");
    Expect(1, 128895, '\P{^isalchemicalsymbols}', "");
    Expect(0, 128896, '\p{isalchemicalsymbols}', "");
    Expect(1, 128896, '\p{^isalchemicalsymbols}', "");
    Expect(1, 128896, '\P{isalchemicalsymbols}', "");
    Expect(0, 128896, '\P{^isalchemicalsymbols}', "");
    Expect(1, 128895, '\p{ 	Is_alchemical_Symbols}', "");
    Expect(0, 128895, '\p{^ 	Is_alchemical_Symbols}', "");
    Expect(0, 128895, '\P{ 	Is_alchemical_Symbols}', "");
    Expect(1, 128895, '\P{^ 	Is_alchemical_Symbols}', "");
    Expect(0, 128896, '\p{ 	Is_alchemical_Symbols}', "");
    Expect(1, 128896, '\p{^ 	Is_alchemical_Symbols}', "");
    Expect(1, 128896, '\P{ 	Is_alchemical_Symbols}', "");
    Expect(0, 128896, '\P{^ 	Is_alchemical_Symbols}', "");
    Error('\p{_In_Alchemical_Symbols:=}');
    Error('\P{_In_Alchemical_Symbols:=}');
    Expect(1, 128895, '\p{inalchemicalsymbols}', "");
    Expect(0, 128895, '\p{^inalchemicalsymbols}', "");
    Expect(0, 128895, '\P{inalchemicalsymbols}', "");
    Expect(1, 128895, '\P{^inalchemicalsymbols}', "");
    Expect(0, 128896, '\p{inalchemicalsymbols}', "");
    Expect(1, 128896, '\p{^inalchemicalsymbols}', "");
    Expect(1, 128896, '\P{inalchemicalsymbols}', "");
    Expect(0, 128896, '\P{^inalchemicalsymbols}', "");
    Expect(1, 128895, '\p{ -in_alchemical_SYMBOLS}', "");
    Expect(0, 128895, '\p{^ -in_alchemical_SYMBOLS}', "");
    Expect(0, 128895, '\P{ -in_alchemical_SYMBOLS}', "");
    Expect(1, 128895, '\P{^ -in_alchemical_SYMBOLS}', "");
    Expect(0, 128896, '\p{ -in_alchemical_SYMBOLS}', "");
    Expect(1, 128896, '\p{^ -in_alchemical_SYMBOLS}', "");
    Expect(1, 128896, '\P{ -in_alchemical_SYMBOLS}', "");
    Expect(0, 128896, '\P{^ -in_alchemical_SYMBOLS}', "");
    Error('\p{/a/--alchemical}');
    Error('\P{/a/--alchemical}');
    Expect(1, 128895, '\p{alchemical}', "");
    Expect(0, 128895, '\p{^alchemical}', "");
    Expect(0, 128895, '\P{alchemical}', "");
    Expect(1, 128895, '\P{^alchemical}', "");
    Expect(0, 128896, '\p{alchemical}', "");
    Expect(1, 128896, '\p{^alchemical}', "");
    Expect(1, 128896, '\P{alchemical}', "");
    Expect(0, 128896, '\P{^alchemical}', "");
    Expect(1, 128895, '\p{ Alchemical}', "");
    Expect(0, 128895, '\p{^ Alchemical}', "");
    Expect(0, 128895, '\P{ Alchemical}', "");
    Expect(1, 128895, '\P{^ Alchemical}', "");
    Expect(0, 128896, '\p{ Alchemical}', "");
    Expect(1, 128896, '\p{^ Alchemical}', "");
    Expect(1, 128896, '\P{ Alchemical}', "");
    Expect(0, 128896, '\P{^ Alchemical}', "");
    Error('\p{	/a/IS_Alchemical}');
    Error('\P{	/a/IS_Alchemical}');
    Expect(1, 128895, '\p{isalchemical}', "");
    Expect(0, 128895, '\p{^isalchemical}', "");
    Expect(0, 128895, '\P{isalchemical}', "");
    Expect(1, 128895, '\P{^isalchemical}', "");
    Expect(0, 128896, '\p{isalchemical}', "");
    Expect(1, 128896, '\p{^isalchemical}', "");
    Expect(1, 128896, '\P{isalchemical}', "");
    Expect(0, 128896, '\P{^isalchemical}', "");
    Expect(1, 128895, '\p{-Is_Alchemical}', "");
    Expect(0, 128895, '\p{^-Is_Alchemical}', "");
    Expect(0, 128895, '\P{-Is_Alchemical}', "");
    Expect(1, 128895, '\P{^-Is_Alchemical}', "");
    Expect(0, 128896, '\p{-Is_Alchemical}', "");
    Expect(1, 128896, '\p{^-Is_Alchemical}', "");
    Expect(1, 128896, '\P{-Is_Alchemical}', "");
    Expect(0, 128896, '\P{^-Is_Alchemical}', "");
    Error('\p{:=In_Alchemical}');
    Error('\P{:=In_Alchemical}');
    Expect(1, 128895, '\p{inalchemical}', "");
    Expect(0, 128895, '\p{^inalchemical}', "");
    Expect(0, 128895, '\P{inalchemical}', "");
    Expect(1, 128895, '\P{^inalchemical}', "");
    Expect(0, 128896, '\p{inalchemical}', "");
    Expect(1, 128896, '\p{^inalchemical}', "");
    Expect(1, 128896, '\P{inalchemical}', "");
    Expect(0, 128896, '\P{^inalchemical}', "");
    Expect(1, 128895, '\p{ IN_Alchemical}', "");
    Expect(0, 128895, '\p{^ IN_Alchemical}', "");
    Expect(0, 128895, '\P{ IN_Alchemical}', "");
    Expect(1, 128895, '\P{^ IN_Alchemical}', "");
    Expect(0, 128896, '\p{ IN_Alchemical}', "");
    Expect(1, 128896, '\p{^ IN_Alchemical}', "");
    Expect(1, 128896, '\P{ IN_Alchemical}', "");
    Expect(0, 128896, '\P{^ IN_Alchemical}', "");
    Error('\p{ 	all:=}');
    Error('\P{ 	all:=}');
    Expect(1, 1, '\p{all}', "");
    Expect(0, 1, '\p{^all}', "");
    Expect(0, 1, '\P{all}', "");
    Expect(1, 1, '\P{^all}', "");
    Expect(1, 1, '\p{--ALL}', "");
    Expect(0, 1, '\p{^--ALL}', "");
    Expect(0, 1, '\P{--ALL}', "");
    Expect(1, 1, '\P{^--ALL}', "");
    Error('\p{ -Is_All/a/}');
    Error('\P{ -Is_All/a/}');
    Expect(1, 1, '\p{isall}', "");
    Expect(0, 1, '\p{^isall}', "");
    Expect(0, 1, '\P{isall}', "");
    Expect(1, 1, '\P{^isall}', "");
    Expect(1, 1, '\p{	 IS_all}', "");
    Expect(0, 1, '\p{^	 IS_all}', "");
    Expect(0, 1, '\P{	 IS_all}', "");
    Expect(1, 1, '\P{^	 IS_all}', "");
    Error('\p{ :=XPOSIXALNUM}');
    Error('\P{ :=XPOSIXALNUM}');
    Expect(1, 201546, '\p{xposixalnum}', "");
    Expect(0, 201546, '\p{^xposixalnum}', "");
    Expect(0, 201546, '\P{xposixalnum}', "");
    Expect(1, 201546, '\P{^xposixalnum}', "");
    Expect(0, 201547, '\p{xposixalnum}', "");
    Expect(1, 201547, '\p{^xposixalnum}', "");
    Expect(1, 201547, '\P{xposixalnum}', "");
    Expect(0, 201547, '\P{^xposixalnum}', "");
    Expect(1, 201546, '\p{		XPOSIXALNUM}', "");
    Expect(0, 201546, '\p{^		XPOSIXALNUM}', "");
    Expect(0, 201546, '\P{		XPOSIXALNUM}', "");
    Expect(1, 201546, '\P{^		XPOSIXALNUM}', "");
    Expect(0, 201547, '\p{		XPOSIXALNUM}', "");
    Expect(1, 201547, '\p{^		XPOSIXALNUM}', "");
    Expect(1, 201547, '\P{		XPOSIXALNUM}', "");
    Expect(0, 201547, '\P{^		XPOSIXALNUM}', "");
    Error('\p{ :=Alnum}');
    Error('\P{ :=Alnum}');
    Expect(1, 201546, '\p{alnum}', "");
    Expect(0, 201546, '\p{^alnum}', "");
    Expect(0, 201546, '\P{alnum}', "");
    Expect(1, 201546, '\P{^alnum}', "");
    Expect(0, 201547, '\p{alnum}', "");
    Expect(1, 201547, '\p{^alnum}', "");
    Expect(1, 201547, '\P{alnum}', "");
    Expect(0, 201547, '\P{^alnum}', "");
    Expect(1, 201546, '\p{ -alnum}', "");
    Expect(0, 201546, '\p{^ -alnum}', "");
    Expect(0, 201546, '\P{ -alnum}', "");
    Expect(1, 201546, '\P{^ -alnum}', "");
    Expect(0, 201547, '\p{ -alnum}', "");
    Expect(1, 201547, '\p{^ -alnum}', "");
    Expect(1, 201547, '\P{ -alnum}', "");
    Expect(0, 201547, '\P{^ -alnum}', "");
    Error('\p{	_Is_XPosixAlnum:=}');
    Error('\P{	_Is_XPosixAlnum:=}');
    Expect(1, 201546, '\p{isxposixalnum}', "");
    Expect(0, 201546, '\p{^isxposixalnum}', "");
    Expect(0, 201546, '\P{isxposixalnum}', "");
    Expect(1, 201546, '\P{^isxposixalnum}', "");
    Expect(0, 201547, '\p{isxposixalnum}', "");
    Expect(1, 201547, '\p{^isxposixalnum}', "");
    Expect(1, 201547, '\P{isxposixalnum}', "");
    Expect(0, 201547, '\P{^isxposixalnum}', "");
    Expect(1, 201546, '\p{Is_XPosixAlnum}', "");
    Expect(0, 201546, '\p{^Is_XPosixAlnum}', "");
    Expect(0, 201546, '\P{Is_XPosixAlnum}', "");
    Expect(1, 201546, '\P{^Is_XPosixAlnum}', "");
    Expect(0, 201547, '\p{Is_XPosixAlnum}', "");
    Expect(1, 201547, '\p{^Is_XPosixAlnum}', "");
    Expect(1, 201547, '\P{Is_XPosixAlnum}', "");
    Expect(0, 201547, '\P{^Is_XPosixAlnum}', "");
    Error('\p{-is_Alnum:=}');
    Error('\P{-is_Alnum:=}');
    Expect(1, 201546, '\p{isalnum}', "");
    Expect(0, 201546, '\p{^isalnum}', "");
    Expect(0, 201546, '\P{isalnum}', "");
    Expect(1, 201546, '\P{^isalnum}', "");
    Expect(0, 201547, '\p{isalnum}', "");
    Expect(1, 201547, '\p{^isalnum}', "");
    Expect(1, 201547, '\P{isalnum}', "");
    Expect(0, 201547, '\P{^isalnum}', "");
    Expect(1, 201546, '\p{	-IS_Alnum}', "");
    Expect(0, 201546, '\p{^	-IS_Alnum}', "");
    Expect(0, 201546, '\P{	-IS_Alnum}', "");
    Expect(1, 201546, '\P{^	-IS_Alnum}', "");
    Expect(0, 201547, '\p{	-IS_Alnum}', "");
    Expect(1, 201547, '\p{^	-IS_Alnum}', "");
    Expect(1, 201547, '\P{	-IS_Alnum}', "");
    Expect(0, 201547, '\P{^	-IS_Alnum}', "");
    Error('\p{_/a/alphabetic_Presentation_Forms}');
    Error('\P{_/a/alphabetic_Presentation_Forms}');
    Expect(1, 64335, '\p{alphabeticpresentationforms}', "");
    Expect(0, 64335, '\p{^alphabeticpresentationforms}', "");
    Expect(0, 64335, '\P{alphabeticpresentationforms}', "");
    Expect(1, 64335, '\P{^alphabeticpresentationforms}', "");
    Expect(0, 64336, '\p{alphabeticpresentationforms}', "");
    Expect(1, 64336, '\p{^alphabeticpresentationforms}', "");
    Expect(1, 64336, '\P{alphabeticpresentationforms}', "");
    Expect(0, 64336, '\P{^alphabeticpresentationforms}', "");
    Expect(1, 64335, '\p{-ALPHABETIC_Presentation_FORMS}', "");
    Expect(0, 64335, '\p{^-ALPHABETIC_Presentation_FORMS}', "");
    Expect(0, 64335, '\P{-ALPHABETIC_Presentation_FORMS}', "");
    Expect(1, 64335, '\P{^-ALPHABETIC_Presentation_FORMS}', "");
    Expect(0, 64336, '\p{-ALPHABETIC_Presentation_FORMS}', "");
    Expect(1, 64336, '\p{^-ALPHABETIC_Presentation_FORMS}', "");
    Expect(1, 64336, '\P{-ALPHABETIC_Presentation_FORMS}', "");
    Expect(0, 64336, '\P{^-ALPHABETIC_Presentation_FORMS}', "");
    Error('\p{:= Is_alphabetic_Presentation_forms}');
    Error('\P{:= Is_alphabetic_Presentation_forms}');
    Expect(1, 64335, '\p{isalphabeticpresentationforms}', "");
    Expect(0, 64335, '\p{^isalphabeticpresentationforms}', "");
    Expect(0, 64335, '\P{isalphabeticpresentationforms}', "");
    Expect(1, 64335, '\P{^isalphabeticpresentationforms}', "");
    Expect(0, 64336, '\p{isalphabeticpresentationforms}', "");
    Expect(1, 64336, '\p{^isalphabeticpresentationforms}', "");
    Expect(1, 64336, '\P{isalphabeticpresentationforms}', "");
    Expect(0, 64336, '\P{^isalphabeticpresentationforms}', "");
    Expect(1, 64335, '\p{	Is_Alphabetic_Presentation_forms}', "");
    Expect(0, 64335, '\p{^	Is_Alphabetic_Presentation_forms}', "");
    Expect(0, 64335, '\P{	Is_Alphabetic_Presentation_forms}', "");
    Expect(1, 64335, '\P{^	Is_Alphabetic_Presentation_forms}', "");
    Expect(0, 64336, '\p{	Is_Alphabetic_Presentation_forms}', "");
    Expect(1, 64336, '\p{^	Is_Alphabetic_Presentation_forms}', "");
    Expect(1, 64336, '\P{	Is_Alphabetic_Presentation_forms}', "");
    Expect(0, 64336, '\P{^	Is_Alphabetic_Presentation_forms}', "");
    Error('\p{ in_ALPHABETIC_presentation_FORMS/a/}');
    Error('\P{ in_ALPHABETIC_presentation_FORMS/a/}');
    Expect(1, 64335, '\p{inalphabeticpresentationforms}', "");
    Expect(0, 64335, '\p{^inalphabeticpresentationforms}', "");
    Expect(0, 64335, '\P{inalphabeticpresentationforms}', "");
    Expect(1, 64335, '\P{^inalphabeticpresentationforms}', "");
    Expect(0, 64336, '\p{inalphabeticpresentationforms}', "");
    Expect(1, 64336, '\p{^inalphabeticpresentationforms}', "");
    Expect(1, 64336, '\P{inalphabeticpresentationforms}', "");
    Expect(0, 64336, '\P{^inalphabeticpresentationforms}', "");
    Expect(1, 64335, '\p{	 IN_Alphabetic_presentation_Forms}', "");
    Expect(0, 64335, '\p{^	 IN_Alphabetic_presentation_Forms}', "");
    Expect(0, 64335, '\P{	 IN_Alphabetic_presentation_Forms}', "");
    Expect(1, 64335, '\P{^	 IN_Alphabetic_presentation_Forms}', "");
    Expect(0, 64336, '\p{	 IN_Alphabetic_presentation_Forms}', "");
    Expect(1, 64336, '\p{^	 IN_Alphabetic_presentation_Forms}', "");
    Expect(1, 64336, '\P{	 IN_Alphabetic_presentation_Forms}', "");
    Expect(0, 64336, '\P{^	 IN_Alphabetic_presentation_Forms}', "");
    Error('\p{ :=alphabetic_PF}');
    Error('\P{ :=alphabetic_PF}');
    Expect(1, 64335, '\p{alphabeticpf}', "");
    Expect(0, 64335, '\p{^alphabeticpf}', "");
    Expect(0, 64335, '\P{alphabeticpf}', "");
    Expect(1, 64335, '\P{^alphabeticpf}', "");
    Expect(0, 64336, '\p{alphabeticpf}', "");
    Expect(1, 64336, '\p{^alphabeticpf}', "");
    Expect(1, 64336, '\P{alphabeticpf}', "");
    Expect(0, 64336, '\P{^alphabeticpf}', "");
    Expect(1, 64335, '\p{	alphabetic_PF}', "");
    Expect(0, 64335, '\p{^	alphabetic_PF}', "");
    Expect(0, 64335, '\P{	alphabetic_PF}', "");
    Expect(1, 64335, '\P{^	alphabetic_PF}', "");
    Expect(0, 64336, '\p{	alphabetic_PF}', "");
    Expect(1, 64336, '\p{^	alphabetic_PF}', "");
    Expect(1, 64336, '\P{	alphabetic_PF}', "");
    Expect(0, 64336, '\P{^	alphabetic_PF}', "");
    Error('\p{- Is_Alphabetic_PF/a/}');
    Error('\P{- Is_Alphabetic_PF/a/}');
    Expect(1, 64335, '\p{isalphabeticpf}', "");
    Expect(0, 64335, '\p{^isalphabeticpf}', "");
    Expect(0, 64335, '\P{isalphabeticpf}', "");
    Expect(1, 64335, '\P{^isalphabeticpf}', "");
    Expect(0, 64336, '\p{isalphabeticpf}', "");
    Expect(1, 64336, '\p{^isalphabeticpf}', "");
    Expect(1, 64336, '\P{isalphabeticpf}', "");
    Expect(0, 64336, '\P{^isalphabeticpf}', "");
    Expect(1, 64335, '\p{	is_ALPHABETIC_PF}', "");
    Expect(0, 64335, '\p{^	is_ALPHABETIC_PF}', "");
    Expect(0, 64335, '\P{	is_ALPHABETIC_PF}', "");
    Expect(1, 64335, '\P{^	is_ALPHABETIC_PF}', "");
    Expect(0, 64336, '\p{	is_ALPHABETIC_PF}', "");
    Expect(1, 64336, '\p{^	is_ALPHABETIC_PF}', "");
    Expect(1, 64336, '\P{	is_ALPHABETIC_PF}', "");
    Expect(0, 64336, '\P{^	is_ALPHABETIC_PF}', "");
    Error('\p{_in_ALPHABETIC_PF/a/}');
    Error('\P{_in_ALPHABETIC_PF/a/}');
    Expect(1, 64335, '\p{inalphabeticpf}', "");
    Expect(0, 64335, '\p{^inalphabeticpf}', "");
    Expect(0, 64335, '\P{inalphabeticpf}', "");
    Expect(1, 64335, '\P{^inalphabeticpf}', "");
    Expect(0, 64336, '\p{inalphabeticpf}', "");
    Expect(1, 64336, '\p{^inalphabeticpf}', "");
    Expect(1, 64336, '\P{inalphabeticpf}', "");
    Expect(0, 64336, '\P{^inalphabeticpf}', "");
    Expect(1, 64335, '\p{- IN_ALPHABETIC_pf}', "");
    Expect(0, 64335, '\p{^- IN_ALPHABETIC_pf}', "");
    Expect(0, 64335, '\P{- IN_ALPHABETIC_pf}', "");
    Expect(1, 64335, '\P{^- IN_ALPHABETIC_pf}', "");
    Expect(0, 64336, '\p{- IN_ALPHABETIC_pf}', "");
    Expect(1, 64336, '\p{^- IN_ALPHABETIC_pf}', "");
    Expect(1, 64336, '\P{- IN_ALPHABETIC_pf}', "");
    Expect(0, 64336, '\P{^- IN_ALPHABETIC_pf}', "");
    Error('\p{-Anatolian_Hieroglyphs:=}');
    Error('\P{-Anatolian_Hieroglyphs:=}');
    Expect(1, 83526, '\p{anatolianhieroglyphs}', "");
    Expect(0, 83526, '\p{^anatolianhieroglyphs}', "");
    Expect(0, 83526, '\P{anatolianhieroglyphs}', "");
    Expect(1, 83526, '\P{^anatolianhieroglyphs}', "");
    Expect(0, 83527, '\p{anatolianhieroglyphs}', "");
    Expect(1, 83527, '\p{^anatolianhieroglyphs}', "");
    Expect(1, 83527, '\P{anatolianhieroglyphs}', "");
    Expect(0, 83527, '\P{^anatolianhieroglyphs}', "");
    Expect(1, 83526, '\p{- Anatolian_hieroglyphs}', "");
    Expect(0, 83526, '\p{^- Anatolian_hieroglyphs}', "");
    Expect(0, 83526, '\P{- Anatolian_hieroglyphs}', "");
    Expect(1, 83526, '\P{^- Anatolian_hieroglyphs}', "");
    Expect(0, 83527, '\p{- Anatolian_hieroglyphs}', "");
    Expect(1, 83527, '\p{^- Anatolian_hieroglyphs}', "");
    Expect(1, 83527, '\P{- Anatolian_hieroglyphs}', "");
    Expect(0, 83527, '\P{^- Anatolian_hieroglyphs}', "");
    Error('\p{/a/_ Is_Anatolian_HIEROGLYPHS}');
    Error('\P{/a/_ Is_Anatolian_HIEROGLYPHS}');
    Expect(1, 83526, '\p{isanatolianhieroglyphs}', "");
    Expect(0, 83526, '\p{^isanatolianhieroglyphs}', "");
    Expect(0, 83526, '\P{isanatolianhieroglyphs}', "");
    Expect(1, 83526, '\P{^isanatolianhieroglyphs}', "");
    Expect(0, 83527, '\p{isanatolianhieroglyphs}', "");
    Expect(1, 83527, '\p{^isanatolianhieroglyphs}', "");
    Expect(1, 83527, '\P{isanatolianhieroglyphs}', "");
    Expect(0, 83527, '\P{^isanatolianhieroglyphs}', "");
    Expect(1, 83526, '\p{__Is_ANATOLIAN_hieroglyphs}', "");
    Expect(0, 83526, '\p{^__Is_ANATOLIAN_hieroglyphs}', "");
    Expect(0, 83526, '\P{__Is_ANATOLIAN_hieroglyphs}', "");
    Expect(1, 83526, '\P{^__Is_ANATOLIAN_hieroglyphs}', "");
    Expect(0, 83527, '\p{__Is_ANATOLIAN_hieroglyphs}', "");
    Expect(1, 83527, '\p{^__Is_ANATOLIAN_hieroglyphs}', "");
    Expect(1, 83527, '\P{__Is_ANATOLIAN_hieroglyphs}', "");
    Expect(0, 83527, '\P{^__Is_ANATOLIAN_hieroglyphs}', "");
    Error('\p{ /a/Hluw}');
    Error('\P{ /a/Hluw}');
    Expect(1, 83526, '\p{hluw}', "");
    Expect(0, 83526, '\p{^hluw}', "");
    Expect(0, 83526, '\P{hluw}', "");
    Expect(1, 83526, '\P{^hluw}', "");
    Expect(0, 83527, '\p{hluw}', "");
    Expect(1, 83527, '\p{^hluw}', "");
    Expect(1, 83527, '\P{hluw}', "");
    Expect(0, 83527, '\P{^hluw}', "");
    Expect(1, 83526, '\p{	_Hluw}', "");
    Expect(0, 83526, '\p{^	_Hluw}', "");
    Expect(0, 83526, '\P{	_Hluw}', "");
    Expect(1, 83526, '\P{^	_Hluw}', "");
    Expect(0, 83527, '\p{	_Hluw}', "");
    Expect(1, 83527, '\p{^	_Hluw}', "");
    Expect(1, 83527, '\P{	_Hluw}', "");
    Expect(0, 83527, '\P{^	_Hluw}', "");
    Error('\p{:=-	Is_Hluw}');
    Error('\P{:=-	Is_Hluw}');
    Expect(1, 83526, '\p{ishluw}', "");
    Expect(0, 83526, '\p{^ishluw}', "");
    Expect(0, 83526, '\P{ishluw}', "");
    Expect(1, 83526, '\P{^ishluw}', "");
    Expect(0, 83527, '\p{ishluw}', "");
    Expect(1, 83527, '\p{^ishluw}', "");
    Expect(1, 83527, '\P{ishluw}', "");
    Expect(0, 83527, '\P{^ishluw}', "");
    Expect(1, 83526, '\p{- is_Hluw}', "");
    Expect(0, 83526, '\p{^- is_Hluw}', "");
    Expect(0, 83526, '\P{- is_Hluw}', "");
    Expect(1, 83526, '\P{^- is_Hluw}', "");
    Expect(0, 83527, '\p{- is_Hluw}', "");
    Expect(1, 83527, '\p{^- is_Hluw}', "");
    Expect(1, 83527, '\P{- is_Hluw}', "");
    Expect(0, 83527, '\P{^- is_Hluw}', "");
    Error('\p{_/a/ANCIENT_GREEK_MUSICAL_NOTATION}');
    Error('\P{_/a/ANCIENT_GREEK_MUSICAL_NOTATION}');
    Expect(1, 119375, '\p{ancientgreekmusicalnotation}', "");
    Expect(0, 119375, '\p{^ancientgreekmusicalnotation}', "");
    Expect(0, 119375, '\P{ancientgreekmusicalnotation}', "");
    Expect(1, 119375, '\P{^ancientgreekmusicalnotation}', "");
    Expect(0, 119376, '\p{ancientgreekmusicalnotation}', "");
    Expect(1, 119376, '\p{^ancientgreekmusicalnotation}', "");
    Expect(1, 119376, '\P{ancientgreekmusicalnotation}', "");
    Expect(0, 119376, '\P{^ancientgreekmusicalnotation}', "");
    Expect(1, 119375, '\p{-ancient_Greek_musical_notation}', "");
    Expect(0, 119375, '\p{^-ancient_Greek_musical_notation}', "");
    Expect(0, 119375, '\P{-ancient_Greek_musical_notation}', "");
    Expect(1, 119375, '\P{^-ancient_Greek_musical_notation}', "");
    Expect(0, 119376, '\p{-ancient_Greek_musical_notation}', "");
    Expect(1, 119376, '\p{^-ancient_Greek_musical_notation}', "");
    Expect(1, 119376, '\P{-ancient_Greek_musical_notation}', "");
    Expect(0, 119376, '\P{^-ancient_Greek_musical_notation}', "");
    Error('\p{-/a/Is_ancient_greek_Musical_notation}');
    Error('\P{-/a/Is_ancient_greek_Musical_notation}');
    Expect(1, 119375, '\p{isancientgreekmusicalnotation}', "");
    Expect(0, 119375, '\p{^isancientgreekmusicalnotation}', "");
    Expect(0, 119375, '\P{isancientgreekmusicalnotation}', "");
    Expect(1, 119375, '\P{^isancientgreekmusicalnotation}', "");
    Expect(0, 119376, '\p{isancientgreekmusicalnotation}', "");
    Expect(1, 119376, '\p{^isancientgreekmusicalnotation}', "");
    Expect(1, 119376, '\P{isancientgreekmusicalnotation}', "");
    Expect(0, 119376, '\P{^isancientgreekmusicalnotation}', "");
    Expect(1, 119375, '\p{	_Is_ancient_GREEK_Musical_Notation}', "");
    Expect(0, 119375, '\p{^	_Is_ancient_GREEK_Musical_Notation}', "");
    Expect(0, 119375, '\P{	_Is_ancient_GREEK_Musical_Notation}', "");
    Expect(1, 119375, '\P{^	_Is_ancient_GREEK_Musical_Notation}', "");
    Expect(0, 119376, '\p{	_Is_ancient_GREEK_Musical_Notation}', "");
    Expect(1, 119376, '\p{^	_Is_ancient_GREEK_Musical_Notation}', "");
    Expect(1, 119376, '\P{	_Is_ancient_GREEK_Musical_Notation}', "");
    Expect(0, 119376, '\P{^	_Is_ancient_GREEK_Musical_Notation}', "");
    Error('\p{		IN_Ancient_greek_Musical_NOTATION/a/}');
    Error('\P{		IN_Ancient_greek_Musical_NOTATION/a/}');
    Expect(1, 119375, '\p{inancientgreekmusicalnotation}', "");
    Expect(0, 119375, '\p{^inancientgreekmusicalnotation}', "");
    Expect(0, 119375, '\P{inancientgreekmusicalnotation}', "");
    Expect(1, 119375, '\P{^inancientgreekmusicalnotation}', "");
    Expect(0, 119376, '\p{inancientgreekmusicalnotation}', "");
    Expect(1, 119376, '\p{^inancientgreekmusicalnotation}', "");
    Expect(1, 119376, '\P{inancientgreekmusicalnotation}', "");
    Expect(0, 119376, '\P{^inancientgreekmusicalnotation}', "");
    Expect(1, 119375, '\p{IN_Ancient_Greek_MUSICAL_notation}', "");
    Expect(0, 119375, '\p{^IN_Ancient_Greek_MUSICAL_notation}', "");
    Expect(0, 119375, '\P{IN_Ancient_Greek_MUSICAL_notation}', "");
    Expect(1, 119375, '\P{^IN_Ancient_Greek_MUSICAL_notation}', "");
    Expect(0, 119376, '\p{IN_Ancient_Greek_MUSICAL_notation}', "");
    Expect(1, 119376, '\p{^IN_Ancient_Greek_MUSICAL_notation}', "");
    Expect(1, 119376, '\P{IN_Ancient_Greek_MUSICAL_notation}', "");
    Expect(0, 119376, '\P{^IN_Ancient_Greek_MUSICAL_notation}', "");
    Error('\p{_/a/Ancient_Greek_music}');
    Error('\P{_/a/Ancient_Greek_music}');
    Expect(1, 119375, '\p{ancientgreekmusic}', "");
    Expect(0, 119375, '\p{^ancientgreekmusic}', "");
    Expect(0, 119375, '\P{ancientgreekmusic}', "");
    Expect(1, 119375, '\P{^ancientgreekmusic}', "");
    Expect(0, 119376, '\p{ancientgreekmusic}', "");
    Expect(1, 119376, '\p{^ancientgreekmusic}', "");
    Expect(1, 119376, '\P{ancientgreekmusic}', "");
    Expect(0, 119376, '\P{^ancientgreekmusic}', "");
    Expect(1, 119375, '\p{_ancient_GREEK_Music}', "");
    Expect(0, 119375, '\p{^_ancient_GREEK_Music}', "");
    Expect(0, 119375, '\P{_ancient_GREEK_Music}', "");
    Expect(1, 119375, '\P{^_ancient_GREEK_Music}', "");
    Expect(0, 119376, '\p{_ancient_GREEK_Music}', "");
    Expect(1, 119376, '\p{^_ancient_GREEK_Music}', "");
    Expect(1, 119376, '\P{_ancient_GREEK_Music}', "");
    Expect(0, 119376, '\P{^_ancient_GREEK_Music}', "");
    Error('\p{/a/	_Is_Ancient_greek_Music}');
    Error('\P{/a/	_Is_Ancient_greek_Music}');
    Expect(1, 119375, '\p{isancientgreekmusic}', "");
    Expect(0, 119375, '\p{^isancientgreekmusic}', "");
    Expect(0, 119375, '\P{isancientgreekmusic}', "");
    Expect(1, 119375, '\P{^isancientgreekmusic}', "");
    Expect(0, 119376, '\p{isancientgreekmusic}', "");
    Expect(1, 119376, '\p{^isancientgreekmusic}', "");
    Expect(1, 119376, '\P{isancientgreekmusic}', "");
    Expect(0, 119376, '\P{^isancientgreekmusic}', "");
    Expect(1, 119375, '\p{	-is_ancient_greek_Music}', "");
    Expect(0, 119375, '\p{^	-is_ancient_greek_Music}', "");
    Expect(0, 119375, '\P{	-is_ancient_greek_Music}', "");
    Expect(1, 119375, '\P{^	-is_ancient_greek_Music}', "");
    Expect(0, 119376, '\p{	-is_ancient_greek_Music}', "");
    Expect(1, 119376, '\p{^	-is_ancient_greek_Music}', "");
    Expect(1, 119376, '\P{	-is_ancient_greek_Music}', "");
    Expect(0, 119376, '\P{^	-is_ancient_greek_Music}', "");
    Error('\p{ _In_ANCIENT_GREEK_Music:=}');
    Error('\P{ _In_ANCIENT_GREEK_Music:=}');
    Expect(1, 119375, '\p{inancientgreekmusic}', "");
    Expect(0, 119375, '\p{^inancientgreekmusic}', "");
    Expect(0, 119375, '\P{inancientgreekmusic}', "");
    Expect(1, 119375, '\P{^inancientgreekmusic}', "");
    Expect(0, 119376, '\p{inancientgreekmusic}', "");
    Expect(1, 119376, '\p{^inancientgreekmusic}', "");
    Expect(1, 119376, '\P{inancientgreekmusic}', "");
    Expect(0, 119376, '\P{^inancientgreekmusic}', "");
    Expect(1, 119375, '\p{__In_Ancient_GREEK_Music}', "");
    Expect(0, 119375, '\p{^__In_Ancient_GREEK_Music}', "");
    Expect(0, 119375, '\P{__In_Ancient_GREEK_Music}', "");
    Expect(1, 119375, '\P{^__In_Ancient_GREEK_Music}', "");
    Expect(0, 119376, '\p{__In_Ancient_GREEK_Music}', "");
    Expect(1, 119376, '\p{^__In_Ancient_GREEK_Music}', "");
    Expect(1, 119376, '\P{__In_Ancient_GREEK_Music}', "");
    Expect(0, 119376, '\P{^__In_Ancient_GREEK_Music}', "");
    Error('\p{ /a/Ancient_GREEK_numbers}');
    Error('\P{ /a/Ancient_GREEK_numbers}');
    Expect(1, 65935, '\p{ancientgreeknumbers}', "");
    Expect(0, 65935, '\p{^ancientgreeknumbers}', "");
    Expect(0, 65935, '\P{ancientgreeknumbers}', "");
    Expect(1, 65935, '\P{^ancientgreeknumbers}', "");
    Expect(0, 65936, '\p{ancientgreeknumbers}', "");
    Expect(1, 65936, '\p{^ancientgreeknumbers}', "");
    Expect(1, 65936, '\P{ancientgreeknumbers}', "");
    Expect(0, 65936, '\P{^ancientgreeknumbers}', "");
    Expect(1, 65935, '\p{	-ANCIENT_Greek_NUMBERS}', "");
    Expect(0, 65935, '\p{^	-ANCIENT_Greek_NUMBERS}', "");
    Expect(0, 65935, '\P{	-ANCIENT_Greek_NUMBERS}', "");
    Expect(1, 65935, '\P{^	-ANCIENT_Greek_NUMBERS}', "");
    Expect(0, 65936, '\p{	-ANCIENT_Greek_NUMBERS}', "");
    Expect(1, 65936, '\p{^	-ANCIENT_Greek_NUMBERS}', "");
    Expect(1, 65936, '\P{	-ANCIENT_Greek_NUMBERS}', "");
    Expect(0, 65936, '\P{^	-ANCIENT_Greek_NUMBERS}', "");
    Error('\p{ -IS_Ancient_Greek_Numbers:=}');
    Error('\P{ -IS_Ancient_Greek_Numbers:=}');
    Expect(1, 65935, '\p{isancientgreeknumbers}', "");
    Expect(0, 65935, '\p{^isancientgreeknumbers}', "");
    Expect(0, 65935, '\P{isancientgreeknumbers}', "");
    Expect(1, 65935, '\P{^isancientgreeknumbers}', "");
    Expect(0, 65936, '\p{isancientgreeknumbers}', "");
    Expect(1, 65936, '\p{^isancientgreeknumbers}', "");
    Expect(1, 65936, '\P{isancientgreeknumbers}', "");
    Expect(0, 65936, '\P{^isancientgreeknumbers}', "");
    Expect(1, 65935, '\p{	IS_ancient_greek_Numbers}', "");
    Expect(0, 65935, '\p{^	IS_ancient_greek_Numbers}', "");
    Expect(0, 65935, '\P{	IS_ancient_greek_Numbers}', "");
    Expect(1, 65935, '\P{^	IS_ancient_greek_Numbers}', "");
    Expect(0, 65936, '\p{	IS_ancient_greek_Numbers}', "");
    Expect(1, 65936, '\p{^	IS_ancient_greek_Numbers}', "");
    Expect(1, 65936, '\P{	IS_ancient_greek_Numbers}', "");
    Expect(0, 65936, '\P{^	IS_ancient_greek_Numbers}', "");
    Error('\p{	in_Ancient_GREEK_NUMBERS:=}');
    Error('\P{	in_Ancient_GREEK_NUMBERS:=}');
    Expect(1, 65935, '\p{inancientgreeknumbers}', "");
    Expect(0, 65935, '\p{^inancientgreeknumbers}', "");
    Expect(0, 65935, '\P{inancientgreeknumbers}', "");
    Expect(1, 65935, '\P{^inancientgreeknumbers}', "");
    Expect(0, 65936, '\p{inancientgreeknumbers}', "");
    Expect(1, 65936, '\p{^inancientgreeknumbers}', "");
    Expect(1, 65936, '\P{inancientgreeknumbers}', "");
    Expect(0, 65936, '\P{^inancientgreeknumbers}', "");
    Expect(1, 65935, '\p{	-in_Ancient_Greek_NUMBERS}', "");
    Expect(0, 65935, '\p{^	-in_Ancient_Greek_NUMBERS}', "");
    Expect(0, 65935, '\P{	-in_Ancient_Greek_NUMBERS}', "");
    Expect(1, 65935, '\P{^	-in_Ancient_Greek_NUMBERS}', "");
    Expect(0, 65936, '\p{	-in_Ancient_Greek_NUMBERS}', "");
    Expect(1, 65936, '\p{^	-in_Ancient_Greek_NUMBERS}', "");
    Expect(1, 65936, '\P{	-in_Ancient_Greek_NUMBERS}', "");
    Expect(0, 65936, '\P{^	-in_Ancient_Greek_NUMBERS}', "");
    Error('\p{-/a/ANCIENT_Symbols}');
    Error('\P{-/a/ANCIENT_Symbols}');
    Expect(1, 65999, '\p{ancientsymbols}', "");
    Expect(0, 65999, '\p{^ancientsymbols}', "");
    Expect(0, 65999, '\P{ancientsymbols}', "");
    Expect(1, 65999, '\P{^ancientsymbols}', "");
    Expect(0, 66000, '\p{ancientsymbols}', "");
    Expect(1, 66000, '\p{^ancientsymbols}', "");
    Expect(1, 66000, '\P{ancientsymbols}', "");
    Expect(0, 66000, '\P{^ancientsymbols}', "");
    Expect(1, 65999, '\p{_ Ancient_Symbols}', "");
    Expect(0, 65999, '\p{^_ Ancient_Symbols}', "");
    Expect(0, 65999, '\P{_ Ancient_Symbols}', "");
    Expect(1, 65999, '\P{^_ Ancient_Symbols}', "");
    Expect(0, 66000, '\p{_ Ancient_Symbols}', "");
    Expect(1, 66000, '\p{^_ Ancient_Symbols}', "");
    Expect(1, 66000, '\P{_ Ancient_Symbols}', "");
    Expect(0, 66000, '\P{^_ Ancient_Symbols}', "");
    Error('\p{	-Is_ANCIENT_Symbols/a/}');
    Error('\P{	-Is_ANCIENT_Symbols/a/}');
    Expect(1, 65999, '\p{isancientsymbols}', "");
    Expect(0, 65999, '\p{^isancientsymbols}', "");
    Expect(0, 65999, '\P{isancientsymbols}', "");
    Expect(1, 65999, '\P{^isancientsymbols}', "");
    Expect(0, 66000, '\p{isancientsymbols}', "");
    Expect(1, 66000, '\p{^isancientsymbols}', "");
    Expect(1, 66000, '\P{isancientsymbols}', "");
    Expect(0, 66000, '\P{^isancientsymbols}', "");
    Expect(1, 65999, '\p{ is_ancient_Symbols}', "");
    Expect(0, 65999, '\p{^ is_ancient_Symbols}', "");
    Expect(0, 65999, '\P{ is_ancient_Symbols}', "");
    Expect(1, 65999, '\P{^ is_ancient_Symbols}', "");
    Expect(0, 66000, '\p{ is_ancient_Symbols}', "");
    Expect(1, 66000, '\p{^ is_ancient_Symbols}', "");
    Expect(1, 66000, '\P{ is_ancient_Symbols}', "");
    Expect(0, 66000, '\P{^ is_ancient_Symbols}', "");
    Error('\p{	:=IN_Ancient_symbols}');
    Error('\P{	:=IN_Ancient_symbols}');
    Expect(1, 65999, '\p{inancientsymbols}', "");
    Expect(0, 65999, '\p{^inancientsymbols}', "");
    Expect(0, 65999, '\P{inancientsymbols}', "");
    Expect(1, 65999, '\P{^inancientsymbols}', "");
    Expect(0, 66000, '\p{inancientsymbols}', "");
    Expect(1, 66000, '\p{^inancientsymbols}', "");
    Expect(1, 66000, '\P{inancientsymbols}', "");
    Expect(0, 66000, '\P{^inancientsymbols}', "");
    Expect(1, 65999, '\p{	-In_Ancient_symbols}', "");
    Expect(0, 65999, '\p{^	-In_Ancient_symbols}', "");
    Expect(0, 65999, '\P{	-In_Ancient_symbols}', "");
    Expect(1, 65999, '\P{^	-In_Ancient_symbols}', "");
    Expect(0, 66000, '\p{	-In_Ancient_symbols}', "");
    Expect(1, 66000, '\p{^	-In_Ancient_symbols}', "");
    Expect(1, 66000, '\P{	-In_Ancient_symbols}', "");
    Expect(0, 66000, '\P{^	-In_Ancient_symbols}', "");
    Error('\p{/a/	ANY}');
    Error('\P{/a/	ANY}');
    Expect(1, 1, '\p{any}', "");
    Expect(0, 1, '\p{^any}', "");
    Expect(0, 1, '\P{any}', "");
    Expect(1, 1, '\P{^any}', "");
    Expect(0, 8912887, '\p{any}', "");
    Expect(1, 8912887, '\p{^any}', "");
    Expect(1, 8912887, '\P{any}', "");
    Expect(0, 8912887, '\P{^any}', "");
    Expect(1, 1, '\p{	 ANY}', "");
    Expect(0, 1, '\p{^	 ANY}', "");
    Expect(0, 1, '\P{	 ANY}', "");
    Expect(1, 1, '\P{^	 ANY}', "");
    Expect(0, 8912887, '\p{	 ANY}', "");
    Expect(1, 8912887, '\p{^	 ANY}', "");
    Expect(1, 8912887, '\P{	 ANY}', "");
    Expect(0, 8912887, '\P{^	 ANY}', "");
    Error('\p{_:=Unicode}');
    Error('\P{_:=Unicode}');
    Expect(1, 1, '\p{unicode}', "");
    Expect(0, 1, '\p{^unicode}', "");
    Expect(0, 1, '\P{unicode}', "");
    Expect(1, 1, '\P{^unicode}', "");
    Expect(0, 8912887, '\p{unicode}', "");
    Expect(1, 8912887, '\p{^unicode}', "");
    Expect(1, 8912887, '\P{unicode}', "");
    Expect(0, 8912887, '\P{^unicode}', "");
    Expect(1, 1, '\p{- UNICODE}', "");
    Expect(0, 1, '\p{^- UNICODE}', "");
    Expect(0, 1, '\P{- UNICODE}', "");
    Expect(1, 1, '\P{^- UNICODE}', "");
    Expect(0, 8912887, '\p{- UNICODE}', "");
    Expect(1, 8912887, '\p{^- UNICODE}', "");
    Expect(1, 8912887, '\P{- UNICODE}', "");
    Expect(0, 8912887, '\P{^- UNICODE}', "");
    Error('\p{:= IS_Any}');
    Error('\P{:= IS_Any}');
    Expect(1, 1, '\p{isany}', "");
    Expect(0, 1, '\p{^isany}', "");
    Expect(0, 1, '\P{isany}', "");
    Expect(1, 1, '\P{^isany}', "");
    Expect(0, 8912887, '\p{isany}', "");
    Expect(1, 8912887, '\p{^isany}', "");
    Expect(1, 8912887, '\P{isany}', "");
    Expect(0, 8912887, '\P{^isany}', "");
    Expect(1, 1, '\p{		is_Any}', "");
    Expect(0, 1, '\p{^		is_Any}', "");
    Expect(0, 1, '\P{		is_Any}', "");
    Expect(1, 1, '\P{^		is_Any}', "");
    Expect(0, 8912887, '\p{		is_Any}', "");
    Expect(1, 8912887, '\p{^		is_Any}', "");
    Expect(1, 8912887, '\P{		is_Any}', "");
    Expect(0, 8912887, '\P{^		is_Any}', "");
    Error('\p{/a/	Is_Unicode}');
    Error('\P{/a/	Is_Unicode}');
    Expect(1, 1, '\p{isunicode}', "");
    Expect(0, 1, '\p{^isunicode}', "");
    Expect(0, 1, '\P{isunicode}', "");
    Expect(1, 1, '\P{^isunicode}', "");
    Expect(0, 8912887, '\p{isunicode}', "");
    Expect(1, 8912887, '\p{^isunicode}', "");
    Expect(1, 8912887, '\P{isunicode}', "");
    Expect(0, 8912887, '\P{^isunicode}', "");
    Expect(1, 1, '\p{ -Is_UNICODE}', "");
    Expect(0, 1, '\p{^ -Is_UNICODE}', "");
    Expect(0, 1, '\P{ -Is_UNICODE}', "");
    Expect(1, 1, '\P{^ -Is_UNICODE}', "");
    Expect(0, 8912887, '\p{ -Is_UNICODE}', "");
    Expect(1, 8912887, '\p{^ -Is_UNICODE}', "");
    Expect(1, 8912887, '\P{ -Is_UNICODE}', "");
    Expect(0, 8912887, '\P{^ -Is_UNICODE}', "");
    Error('\p{	:=ARABIC}');
    Error('\P{	:=ARABIC}');
    Expect(1, 126705, '\p{arabic}', "");
    Expect(0, 126705, '\p{^arabic}', "");
    Expect(0, 126705, '\P{arabic}', "");
    Expect(1, 126705, '\P{^arabic}', "");
    Expect(0, 126706, '\p{arabic}', "");
    Expect(1, 126706, '\p{^arabic}', "");
    Expect(1, 126706, '\P{arabic}', "");
    Expect(0, 126706, '\P{^arabic}', "");
    Expect(1, 126705, '\p{-Arabic}', "");
    Expect(0, 126705, '\p{^-Arabic}', "");
    Expect(0, 126705, '\P{-Arabic}', "");
    Expect(1, 126705, '\P{^-Arabic}', "");
    Expect(0, 126706, '\p{-Arabic}', "");
    Expect(1, 126706, '\p{^-Arabic}', "");
    Expect(1, 126706, '\P{-Arabic}', "");
    Expect(0, 126706, '\P{^-Arabic}', "");
    Error('\p{ -Is_ARABIC:=}');
    Error('\P{ -Is_ARABIC:=}');
    Expect(1, 126705, '\p{isarabic}', "");
    Expect(0, 126705, '\p{^isarabic}', "");
    Expect(0, 126705, '\P{isarabic}', "");
    Expect(1, 126705, '\P{^isarabic}', "");
    Expect(0, 126706, '\p{isarabic}', "");
    Expect(1, 126706, '\p{^isarabic}', "");
    Expect(1, 126706, '\P{isarabic}', "");
    Expect(0, 126706, '\P{^isarabic}', "");
    Expect(1, 126705, '\p{	 Is_ARABIC}', "");
    Expect(0, 126705, '\p{^	 Is_ARABIC}', "");
    Expect(0, 126705, '\P{	 Is_ARABIC}', "");
    Expect(1, 126705, '\P{^	 Is_ARABIC}', "");
    Expect(0, 126706, '\p{	 Is_ARABIC}', "");
    Expect(1, 126706, '\p{^	 Is_ARABIC}', "");
    Expect(1, 126706, '\P{	 Is_ARABIC}', "");
    Expect(0, 126706, '\P{^	 Is_ARABIC}', "");
    Error('\p{		arab/a/}');
    Error('\P{		arab/a/}');
    Expect(1, 126705, '\p{arab}', "");
    Expect(0, 126705, '\p{^arab}', "");
    Expect(0, 126705, '\P{arab}', "");
    Expect(1, 126705, '\P{^arab}', "");
    Expect(0, 126706, '\p{arab}', "");
    Expect(1, 126706, '\p{^arab}', "");
    Expect(1, 126706, '\P{arab}', "");
    Expect(0, 126706, '\P{^arab}', "");
    Expect(1, 126705, '\p{--Arab}', "");
    Expect(0, 126705, '\p{^--Arab}', "");
    Expect(0, 126705, '\P{--Arab}', "");
    Expect(1, 126705, '\P{^--Arab}', "");
    Expect(0, 126706, '\p{--Arab}', "");
    Expect(1, 126706, '\p{^--Arab}', "");
    Expect(1, 126706, '\P{--Arab}', "");
    Expect(0, 126706, '\P{^--Arab}', "");
    Error('\p{Is_arab:=}');
    Error('\P{Is_arab:=}');
    Expect(1, 126705, '\p{isarab}', "");
    Expect(0, 126705, '\p{^isarab}', "");
    Expect(0, 126705, '\P{isarab}', "");
    Expect(1, 126705, '\P{^isarab}', "");
    Expect(0, 126706, '\p{isarab}', "");
    Expect(1, 126706, '\p{^isarab}', "");
    Expect(1, 126706, '\P{isarab}', "");
    Expect(0, 126706, '\P{^isarab}', "");
    Expect(1, 126705, '\p{-Is_arab}', "");
    Expect(0, 126705, '\p{^-Is_arab}', "");
    Expect(0, 126705, '\P{-Is_arab}', "");
    Expect(1, 126705, '\P{^-Is_arab}', "");
    Expect(0, 126706, '\p{-Is_arab}', "");
    Expect(1, 126706, '\p{^-Is_arab}', "");
    Expect(1, 126706, '\P{-Is_arab}', "");
    Expect(0, 126706, '\P{^-Is_arab}', "");
    Error('\p{-_arabic_Extended_a:=}');
    Error('\P{-_arabic_Extended_a:=}');
    Expect(1, 2303, '\p{arabicextendeda}', "");
    Expect(0, 2303, '\p{^arabicextendeda}', "");
    Expect(0, 2303, '\P{arabicextendeda}', "");
    Expect(1, 2303, '\P{^arabicextendeda}', "");
    Expect(0, 2304, '\p{arabicextendeda}', "");
    Expect(1, 2304, '\p{^arabicextendeda}', "");
    Expect(1, 2304, '\P{arabicextendeda}', "");
    Expect(0, 2304, '\P{^arabicextendeda}', "");
    Expect(1, 2303, '\p{_-Arabic_Extended_A}', "");
    Expect(0, 2303, '\p{^_-Arabic_Extended_A}', "");
    Expect(0, 2303, '\P{_-Arabic_Extended_A}', "");
    Expect(1, 2303, '\P{^_-Arabic_Extended_A}', "");
    Expect(0, 2304, '\p{_-Arabic_Extended_A}', "");
    Expect(1, 2304, '\p{^_-Arabic_Extended_A}', "");
    Expect(1, 2304, '\P{_-Arabic_Extended_A}', "");
    Expect(0, 2304, '\P{^_-Arabic_Extended_A}', "");
    Error('\p{--is_Arabic_Extended_a:=}');
    Error('\P{--is_Arabic_Extended_a:=}');
    Expect(1, 2303, '\p{isarabicextendeda}', "");
    Expect(0, 2303, '\p{^isarabicextendeda}', "");
    Expect(0, 2303, '\P{isarabicextendeda}', "");
    Expect(1, 2303, '\P{^isarabicextendeda}', "");
    Expect(0, 2304, '\p{isarabicextendeda}', "");
    Expect(1, 2304, '\p{^isarabicextendeda}', "");
    Expect(1, 2304, '\P{isarabicextendeda}', "");
    Expect(0, 2304, '\P{^isarabicextendeda}', "");
    Expect(1, 2303, '\p{	IS_ARABIC_Extended_a}', "");
    Expect(0, 2303, '\p{^	IS_ARABIC_Extended_a}', "");
    Expect(0, 2303, '\P{	IS_ARABIC_Extended_a}', "");
    Expect(1, 2303, '\P{^	IS_ARABIC_Extended_a}', "");
    Expect(0, 2304, '\p{	IS_ARABIC_Extended_a}', "");
    Expect(1, 2304, '\p{^	IS_ARABIC_Extended_a}', "");
    Expect(1, 2304, '\P{	IS_ARABIC_Extended_a}', "");
    Expect(0, 2304, '\P{^	IS_ARABIC_Extended_a}', "");
    Error('\p{  In_ARABIC_EXTENDED_A/a/}');
    Error('\P{  In_ARABIC_EXTENDED_A/a/}');
    Expect(1, 2303, '\p{inarabicextendeda}', "");
    Expect(0, 2303, '\p{^inarabicextendeda}', "");
    Expect(0, 2303, '\P{inarabicextendeda}', "");
    Expect(1, 2303, '\P{^inarabicextendeda}', "");
    Expect(0, 2304, '\p{inarabicextendeda}', "");
    Expect(1, 2304, '\p{^inarabicextendeda}', "");
    Expect(1, 2304, '\P{inarabicextendeda}', "");
    Expect(0, 2304, '\P{^inarabicextendeda}', "");
    Expect(1, 2303, '\p{  In_Arabic_Extended_a}', "");
    Expect(0, 2303, '\p{^  In_Arabic_Extended_a}', "");
    Expect(0, 2303, '\P{  In_Arabic_Extended_a}', "");
    Expect(1, 2303, '\P{^  In_Arabic_Extended_a}', "");
    Expect(0, 2304, '\p{  In_Arabic_Extended_a}', "");
    Expect(1, 2304, '\p{^  In_Arabic_Extended_a}', "");
    Expect(1, 2304, '\P{  In_Arabic_Extended_a}', "");
    Expect(0, 2304, '\P{^  In_Arabic_Extended_a}', "");
    Error('\p{arabic_ext_A/a/}');
    Error('\P{arabic_ext_A/a/}');
    Expect(1, 2303, '\p{arabicexta}', "");
    Expect(0, 2303, '\p{^arabicexta}', "");
    Expect(0, 2303, '\P{arabicexta}', "");
    Expect(1, 2303, '\P{^arabicexta}', "");
    Expect(0, 2304, '\p{arabicexta}', "");
    Expect(1, 2304, '\p{^arabicexta}', "");
    Expect(1, 2304, '\P{arabicexta}', "");
    Expect(0, 2304, '\P{^arabicexta}', "");
    Expect(1, 2303, '\p{-arabic_Ext_A}', "");
    Expect(0, 2303, '\p{^-arabic_Ext_A}', "");
    Expect(0, 2303, '\P{-arabic_Ext_A}', "");
    Expect(1, 2303, '\P{^-arabic_Ext_A}', "");
    Expect(0, 2304, '\p{-arabic_Ext_A}', "");
    Expect(1, 2304, '\p{^-arabic_Ext_A}', "");
    Expect(1, 2304, '\P{-arabic_Ext_A}', "");
    Expect(0, 2304, '\P{^-arabic_Ext_A}', "");
    Error('\p{_:=IS_Arabic_Ext_a}');
    Error('\P{_:=IS_Arabic_Ext_a}');
    Expect(1, 2303, '\p{isarabicexta}', "");
    Expect(0, 2303, '\p{^isarabicexta}', "");
    Expect(0, 2303, '\P{isarabicexta}', "");
    Expect(1, 2303, '\P{^isarabicexta}', "");
    Expect(0, 2304, '\p{isarabicexta}', "");
    Expect(1, 2304, '\p{^isarabicexta}', "");
    Expect(1, 2304, '\P{isarabicexta}', "");
    Expect(0, 2304, '\P{^isarabicexta}', "");
    Expect(1, 2303, '\p{	 IS_Arabic_Ext_A}', "");
    Expect(0, 2303, '\p{^	 IS_Arabic_Ext_A}', "");
    Expect(0, 2303, '\P{	 IS_Arabic_Ext_A}', "");
    Expect(1, 2303, '\P{^	 IS_Arabic_Ext_A}', "");
    Expect(0, 2304, '\p{	 IS_Arabic_Ext_A}', "");
    Expect(1, 2304, '\p{^	 IS_Arabic_Ext_A}', "");
    Expect(1, 2304, '\P{	 IS_Arabic_Ext_A}', "");
    Expect(0, 2304, '\P{^	 IS_Arabic_Ext_A}', "");
    Error('\p{-In_ARABIC_ext_A:=}');
    Error('\P{-In_ARABIC_ext_A:=}');
    Expect(1, 2303, '\p{inarabicexta}', "");
    Expect(0, 2303, '\p{^inarabicexta}', "");
    Expect(0, 2303, '\P{inarabicexta}', "");
    Expect(1, 2303, '\P{^inarabicexta}', "");
    Expect(0, 2304, '\p{inarabicexta}', "");
    Expect(1, 2304, '\p{^inarabicexta}', "");
    Expect(1, 2304, '\P{inarabicexta}', "");
    Expect(0, 2304, '\P{^inarabicexta}', "");
    Expect(1, 2303, '\p{-	in_ARABIC_Ext_a}', "");
    Expect(0, 2303, '\p{^-	in_ARABIC_Ext_a}', "");
    Expect(0, 2303, '\P{-	in_ARABIC_Ext_a}', "");
    Expect(1, 2303, '\P{^-	in_ARABIC_Ext_a}', "");
    Expect(0, 2304, '\p{-	in_ARABIC_Ext_a}', "");
    Expect(1, 2304, '\p{^-	in_ARABIC_Ext_a}', "");
    Expect(1, 2304, '\P{-	in_ARABIC_Ext_a}', "");
    Expect(0, 2304, '\P{^-	in_ARABIC_Ext_a}', "");
    Error('\p{:=-_Arabic_Mathematical_alphabetic_Symbols}');
    Error('\P{:=-_Arabic_Mathematical_alphabetic_Symbols}');
    Expect(1, 126719, '\p{arabicmathematicalalphabeticsymbols}', "");
    Expect(0, 126719, '\p{^arabicmathematicalalphabeticsymbols}', "");
    Expect(0, 126719, '\P{arabicmathematicalalphabeticsymbols}', "");
    Expect(1, 126719, '\P{^arabicmathematicalalphabeticsymbols}', "");
    Expect(0, 126720, '\p{arabicmathematicalalphabeticsymbols}', "");
    Expect(1, 126720, '\p{^arabicmathematicalalphabeticsymbols}', "");
    Expect(1, 126720, '\P{arabicmathematicalalphabeticsymbols}', "");
    Expect(0, 126720, '\P{^arabicmathematicalalphabeticsymbols}', "");
    Expect(1, 126719, '\p{Arabic_mathematical_ALPHABETIC_Symbols}', "");
    Expect(0, 126719, '\p{^Arabic_mathematical_ALPHABETIC_Symbols}', "");
    Expect(0, 126719, '\P{Arabic_mathematical_ALPHABETIC_Symbols}', "");
    Expect(1, 126719, '\P{^Arabic_mathematical_ALPHABETIC_Symbols}', "");
    Expect(0, 126720, '\p{Arabic_mathematical_ALPHABETIC_Symbols}', "");
    Expect(1, 126720, '\p{^Arabic_mathematical_ALPHABETIC_Symbols}', "");
    Expect(1, 126720, '\P{Arabic_mathematical_ALPHABETIC_Symbols}', "");
    Expect(0, 126720, '\P{^Arabic_mathematical_ALPHABETIC_Symbols}', "");
    Error('\p{-:=Is_ARABIC_Mathematical_Alphabetic_SYMBOLS}');
    Error('\P{-:=Is_ARABIC_Mathematical_Alphabetic_SYMBOLS}');
    Expect(1, 126719, '\p{isarabicmathematicalalphabeticsymbols}', "");
    Expect(0, 126719, '\p{^isarabicmathematicalalphabeticsymbols}', "");
    Expect(0, 126719, '\P{isarabicmathematicalalphabeticsymbols}', "");
    Expect(1, 126719, '\P{^isarabicmathematicalalphabeticsymbols}', "");
    Expect(0, 126720, '\p{isarabicmathematicalalphabeticsymbols}', "");
    Expect(1, 126720, '\p{^isarabicmathematicalalphabeticsymbols}', "");
    Expect(1, 126720, '\P{isarabicmathematicalalphabeticsymbols}', "");
    Expect(0, 126720, '\P{^isarabicmathematicalalphabeticsymbols}', "");
    Expect(1, 126719, '\p{_	is_arabic_Mathematical_ALPHABETIC_Symbols}', "");
    Expect(0, 126719, '\p{^_	is_arabic_Mathematical_ALPHABETIC_Symbols}', "");
    Expect(0, 126719, '\P{_	is_arabic_Mathematical_ALPHABETIC_Symbols}', "");
    Expect(1, 126719, '\P{^_	is_arabic_Mathematical_ALPHABETIC_Symbols}', "");
    Expect(0, 126720, '\p{_	is_arabic_Mathematical_ALPHABETIC_Symbols}', "");
    Expect(1, 126720, '\p{^_	is_arabic_Mathematical_ALPHABETIC_Symbols}', "");
    Expect(1, 126720, '\P{_	is_arabic_Mathematical_ALPHABETIC_Symbols}', "");
    Expect(0, 126720, '\P{^_	is_arabic_Mathematical_ALPHABETIC_Symbols}', "");
    Error('\p{	/a/In_Arabic_mathematical_Alphabetic_SYMBOLS}');
    Error('\P{	/a/In_Arabic_mathematical_Alphabetic_SYMBOLS}');
    Expect(1, 126719, '\p{inarabicmathematicalalphabeticsymbols}', "");
    Expect(0, 126719, '\p{^inarabicmathematicalalphabeticsymbols}', "");
    Expect(0, 126719, '\P{inarabicmathematicalalphabeticsymbols}', "");
    Expect(1, 126719, '\P{^inarabicmathematicalalphabeticsymbols}', "");
    Expect(0, 126720, '\p{inarabicmathematicalalphabeticsymbols}', "");
    Expect(1, 126720, '\p{^inarabicmathematicalalphabeticsymbols}', "");
    Expect(1, 126720, '\P{inarabicmathematicalalphabeticsymbols}', "");
    Expect(0, 126720, '\P{^inarabicmathematicalalphabeticsymbols}', "");
    Expect(1, 126719, '\p{- IN_arabic_mathematical_Alphabetic_Symbols}', "");
    Expect(0, 126719, '\p{^- IN_arabic_mathematical_Alphabetic_Symbols}', "");
    Expect(0, 126719, '\P{- IN_arabic_mathematical_Alphabetic_Symbols}', "");
    Expect(1, 126719, '\P{^- IN_arabic_mathematical_Alphabetic_Symbols}', "");
    Expect(0, 126720, '\p{- IN_arabic_mathematical_Alphabetic_Symbols}', "");
    Expect(1, 126720, '\p{^- IN_arabic_mathematical_Alphabetic_Symbols}', "");
    Expect(1, 126720, '\P{- IN_arabic_mathematical_Alphabetic_Symbols}', "");
    Expect(0, 126720, '\P{^- IN_arabic_mathematical_Alphabetic_Symbols}', "");
    Error('\p{:=-arabic_MATH}');
    Error('\P{:=-arabic_MATH}');
    Expect(1, 126719, '\p{arabicmath}', "");
    Expect(0, 126719, '\p{^arabicmath}', "");
    Expect(0, 126719, '\P{arabicmath}', "");
    Expect(1, 126719, '\P{^arabicmath}', "");
    Expect(0, 126720, '\p{arabicmath}', "");
    Expect(1, 126720, '\p{^arabicmath}', "");
    Expect(1, 126720, '\P{arabicmath}', "");
    Expect(0, 126720, '\P{^arabicmath}', "");
    Expect(1, 126719, '\p{-arabic_Math}', "");
    Expect(0, 126719, '\p{^-arabic_Math}', "");
    Expect(0, 126719, '\P{-arabic_Math}', "");
    Expect(1, 126719, '\P{^-arabic_Math}', "");
    Expect(0, 126720, '\p{-arabic_Math}', "");
    Expect(1, 126720, '\p{^-arabic_Math}', "");
    Expect(1, 126720, '\P{-arabic_Math}', "");
    Expect(0, 126720, '\P{^-arabic_Math}', "");
    Error('\p{:=is_ARABIC_MATH}');
    Error('\P{:=is_ARABIC_MATH}');
    Expect(1, 126719, '\p{isarabicmath}', "");
    Expect(0, 126719, '\p{^isarabicmath}', "");
    Expect(0, 126719, '\P{isarabicmath}', "");
    Expect(1, 126719, '\P{^isarabicmath}', "");
    Expect(0, 126720, '\p{isarabicmath}', "");
    Expect(1, 126720, '\p{^isarabicmath}', "");
    Expect(1, 126720, '\P{isarabicmath}', "");
    Expect(0, 126720, '\P{^isarabicmath}', "");
    Expect(1, 126719, '\p{	 Is_Arabic_math}', "");
    Expect(0, 126719, '\p{^	 Is_Arabic_math}', "");
    Expect(0, 126719, '\P{	 Is_Arabic_math}', "");
    Expect(1, 126719, '\P{^	 Is_Arabic_math}', "");
    Expect(0, 126720, '\p{	 Is_Arabic_math}', "");
    Expect(1, 126720, '\p{^	 Is_Arabic_math}', "");
    Expect(1, 126720, '\P{	 Is_Arabic_math}', "");
    Expect(0, 126720, '\P{^	 Is_Arabic_math}', "");
    Error('\p{	_In_Arabic_Math/a/}');
    Error('\P{	_In_Arabic_Math/a/}');
    Expect(1, 126719, '\p{inarabicmath}', "");
    Expect(0, 126719, '\p{^inarabicmath}', "");
    Expect(0, 126719, '\P{inarabicmath}', "");
    Expect(1, 126719, '\P{^inarabicmath}', "");
    Expect(0, 126720, '\p{inarabicmath}', "");
    Expect(1, 126720, '\p{^inarabicmath}', "");
    Expect(1, 126720, '\P{inarabicmath}', "");
    Expect(0, 126720, '\P{^inarabicmath}', "");
    Expect(1, 126719, '\p{ -IN_ARABIC_Math}', "");
    Expect(0, 126719, '\p{^ -IN_ARABIC_Math}', "");
    Expect(0, 126719, '\P{ -IN_ARABIC_Math}', "");
    Expect(1, 126719, '\P{^ -IN_ARABIC_Math}', "");
    Expect(0, 126720, '\p{ -IN_ARABIC_Math}', "");
    Expect(1, 126720, '\p{^ -IN_ARABIC_Math}', "");
    Expect(1, 126720, '\P{ -IN_ARABIC_Math}', "");
    Expect(0, 126720, '\P{^ -IN_ARABIC_Math}', "");
    Error('\p{_Arabic_presentation_forms_A/a/}');
    Error('\P{_Arabic_presentation_forms_A/a/}');
    Expect(1, 65023, '\p{arabicpresentationformsa}', "");
    Expect(0, 65023, '\p{^arabicpresentationformsa}', "");
    Expect(0, 65023, '\P{arabicpresentationformsa}', "");
    Expect(1, 65023, '\P{^arabicpresentationformsa}', "");
    Expect(0, 65024, '\p{arabicpresentationformsa}', "");
    Expect(1, 65024, '\p{^arabicpresentationformsa}', "");
    Expect(1, 65024, '\P{arabicpresentationformsa}', "");
    Expect(0, 65024, '\P{^arabicpresentationformsa}', "");
    Expect(1, 65023, '\p{_	arabic_Presentation_FORMS_A}', "");
    Expect(0, 65023, '\p{^_	arabic_Presentation_FORMS_A}', "");
    Expect(0, 65023, '\P{_	arabic_Presentation_FORMS_A}', "");
    Expect(1, 65023, '\P{^_	arabic_Presentation_FORMS_A}', "");
    Expect(0, 65024, '\p{_	arabic_Presentation_FORMS_A}', "");
    Expect(1, 65024, '\p{^_	arabic_Presentation_FORMS_A}', "");
    Expect(1, 65024, '\P{_	arabic_Presentation_FORMS_A}', "");
    Expect(0, 65024, '\P{^_	arabic_Presentation_FORMS_A}', "");
    Error('\p{ /a/IS_ARABIC_Presentation_Forms_A}');
    Error('\P{ /a/IS_ARABIC_Presentation_Forms_A}');
    Expect(1, 65023, '\p{isarabicpresentationformsa}', "");
    Expect(0, 65023, '\p{^isarabicpresentationformsa}', "");
    Expect(0, 65023, '\P{isarabicpresentationformsa}', "");
    Expect(1, 65023, '\P{^isarabicpresentationformsa}', "");
    Expect(0, 65024, '\p{isarabicpresentationformsa}', "");
    Expect(1, 65024, '\p{^isarabicpresentationformsa}', "");
    Expect(1, 65024, '\P{isarabicpresentationformsa}', "");
    Expect(0, 65024, '\P{^isarabicpresentationformsa}', "");
    Expect(1, 65023, '\p{-	Is_arabic_presentation_Forms_A}', "");
    Expect(0, 65023, '\p{^-	Is_arabic_presentation_Forms_A}', "");
    Expect(0, 65023, '\P{-	Is_arabic_presentation_Forms_A}', "");
    Expect(1, 65023, '\P{^-	Is_arabic_presentation_Forms_A}', "");
    Expect(0, 65024, '\p{-	Is_arabic_presentation_Forms_A}', "");
    Expect(1, 65024, '\p{^-	Is_arabic_presentation_Forms_A}', "");
    Expect(1, 65024, '\P{-	Is_arabic_presentation_Forms_A}', "");
    Expect(0, 65024, '\P{^-	Is_arabic_presentation_Forms_A}', "");
    Error('\p{	:=In_arabic_Presentation_Forms_A}');
    Error('\P{	:=In_arabic_Presentation_Forms_A}');
    Expect(1, 65023, '\p{inarabicpresentationformsa}', "");
    Expect(0, 65023, '\p{^inarabicpresentationformsa}', "");
    Expect(0, 65023, '\P{inarabicpresentationformsa}', "");
    Expect(1, 65023, '\P{^inarabicpresentationformsa}', "");
    Expect(0, 65024, '\p{inarabicpresentationformsa}', "");
    Expect(1, 65024, '\p{^inarabicpresentationformsa}', "");
    Expect(1, 65024, '\P{inarabicpresentationformsa}', "");
    Expect(0, 65024, '\P{^inarabicpresentationformsa}', "");
    Expect(1, 65023, '\p{_In_Arabic_presentation_Forms_a}', "");
    Expect(0, 65023, '\p{^_In_Arabic_presentation_Forms_a}', "");
    Expect(0, 65023, '\P{_In_Arabic_presentation_Forms_a}', "");
    Expect(1, 65023, '\P{^_In_Arabic_presentation_Forms_a}', "");
    Expect(0, 65024, '\p{_In_Arabic_presentation_Forms_a}', "");
    Expect(1, 65024, '\p{^_In_Arabic_presentation_Forms_a}', "");
    Expect(1, 65024, '\P{_In_Arabic_presentation_Forms_a}', "");
    Expect(0, 65024, '\P{^_In_Arabic_presentation_Forms_a}', "");
    Error('\p{:=-Arabic_PF_A}');
    Error('\P{:=-Arabic_PF_A}');
    Expect(1, 65023, '\p{arabicpfa}', "");
    Expect(0, 65023, '\p{^arabicpfa}', "");
    Expect(0, 65023, '\P{arabicpfa}', "");
    Expect(1, 65023, '\P{^arabicpfa}', "");
    Expect(0, 65024, '\p{arabicpfa}', "");
    Expect(1, 65024, '\p{^arabicpfa}', "");
    Expect(1, 65024, '\P{arabicpfa}', "");
    Expect(0, 65024, '\P{^arabicpfa}', "");
    Expect(1, 65023, '\p{ _Arabic_PF_A}', "");
    Expect(0, 65023, '\p{^ _Arabic_PF_A}', "");
    Expect(0, 65023, '\P{ _Arabic_PF_A}', "");
    Expect(1, 65023, '\P{^ _Arabic_PF_A}', "");
    Expect(0, 65024, '\p{ _Arabic_PF_A}', "");
    Expect(1, 65024, '\p{^ _Arabic_PF_A}', "");
    Expect(1, 65024, '\P{ _Arabic_PF_A}', "");
    Expect(0, 65024, '\P{^ _Arabic_PF_A}', "");
    Error('\p{-is_Arabic_PF_A/a/}');
    Error('\P{-is_Arabic_PF_A/a/}');
    Expect(1, 65023, '\p{isarabicpfa}', "");
    Expect(0, 65023, '\p{^isarabicpfa}', "");
    Expect(0, 65023, '\P{isarabicpfa}', "");
    Expect(1, 65023, '\P{^isarabicpfa}', "");
    Expect(0, 65024, '\p{isarabicpfa}', "");
    Expect(1, 65024, '\p{^isarabicpfa}', "");
    Expect(1, 65024, '\P{isarabicpfa}', "");
    Expect(0, 65024, '\P{^isarabicpfa}', "");
    Expect(1, 65023, '\p{	-IS_Arabic_PF_A}', "");
    Expect(0, 65023, '\p{^	-IS_Arabic_PF_A}', "");
    Expect(0, 65023, '\P{	-IS_Arabic_PF_A}', "");
    Expect(1, 65023, '\P{^	-IS_Arabic_PF_A}', "");
    Expect(0, 65024, '\p{	-IS_Arabic_PF_A}', "");
    Expect(1, 65024, '\p{^	-IS_Arabic_PF_A}', "");
    Expect(1, 65024, '\P{	-IS_Arabic_PF_A}', "");
    Expect(0, 65024, '\P{^	-IS_Arabic_PF_A}', "");
    Error('\p{ _In_Arabic_pf_A:=}');
    Error('\P{ _In_Arabic_pf_A:=}');
    Expect(1, 65023, '\p{inarabicpfa}', "");
    Expect(0, 65023, '\p{^inarabicpfa}', "");
    Expect(0, 65023, '\P{inarabicpfa}', "");
    Expect(1, 65023, '\P{^inarabicpfa}', "");
    Expect(0, 65024, '\p{inarabicpfa}', "");
    Expect(1, 65024, '\p{^inarabicpfa}', "");
    Expect(1, 65024, '\P{inarabicpfa}', "");
    Expect(0, 65024, '\P{^inarabicpfa}', "");
    Expect(1, 65023, '\p{-_in_Arabic_PF_A}', "");
    Expect(0, 65023, '\p{^-_in_Arabic_PF_A}', "");
    Expect(0, 65023, '\P{-_in_Arabic_PF_A}', "");
    Expect(1, 65023, '\P{^-_in_Arabic_PF_A}', "");
    Expect(0, 65024, '\p{-_in_Arabic_PF_A}', "");
    Expect(1, 65024, '\p{^-_in_Arabic_PF_A}', "");
    Expect(1, 65024, '\P{-_in_Arabic_PF_A}', "");
    Expect(0, 65024, '\P{^-_in_Arabic_PF_A}', "");
    Error('\p{		Arabic_PRESENTATION_Forms_B/a/}');
    Error('\P{		Arabic_PRESENTATION_Forms_B/a/}');
    Expect(1, 65279, '\p{arabicpresentationformsb}', "");
    Expect(0, 65279, '\p{^arabicpresentationformsb}', "");
    Expect(0, 65279, '\P{arabicpresentationformsb}', "");
    Expect(1, 65279, '\P{^arabicpresentationformsb}', "");
    Expect(0, 65280, '\p{arabicpresentationformsb}', "");
    Expect(1, 65280, '\p{^arabicpresentationformsb}', "");
    Expect(1, 65280, '\P{arabicpresentationformsb}', "");
    Expect(0, 65280, '\P{^arabicpresentationformsb}', "");
    Expect(1, 65279, '\p{	arabic_presentation_FORMS_b}', "");
    Expect(0, 65279, '\p{^	arabic_presentation_FORMS_b}', "");
    Expect(0, 65279, '\P{	arabic_presentation_FORMS_b}', "");
    Expect(1, 65279, '\P{^	arabic_presentation_FORMS_b}', "");
    Expect(0, 65280, '\p{	arabic_presentation_FORMS_b}', "");
    Expect(1, 65280, '\p{^	arabic_presentation_FORMS_b}', "");
    Expect(1, 65280, '\P{	arabic_presentation_FORMS_b}', "");
    Expect(0, 65280, '\P{^	arabic_presentation_FORMS_b}', "");
    Error('\p{/a/_-Is_Arabic_PRESENTATION_Forms_B}');
    Error('\P{/a/_-Is_Arabic_PRESENTATION_Forms_B}');
    Expect(1, 65279, '\p{isarabicpresentationformsb}', "");
    Expect(0, 65279, '\p{^isarabicpresentationformsb}', "");
    Expect(0, 65279, '\P{isarabicpresentationformsb}', "");
    Expect(1, 65279, '\P{^isarabicpresentationformsb}', "");
    Expect(0, 65280, '\p{isarabicpresentationformsb}', "");
    Expect(1, 65280, '\p{^isarabicpresentationformsb}', "");
    Expect(1, 65280, '\P{isarabicpresentationformsb}', "");
    Expect(0, 65280, '\P{^isarabicpresentationformsb}', "");
    Expect(1, 65279, '\p{IS_Arabic_Presentation_Forms_b}', "");
    Expect(0, 65279, '\p{^IS_Arabic_Presentation_Forms_b}', "");
    Expect(0, 65279, '\P{IS_Arabic_Presentation_Forms_b}', "");
    Expect(1, 65279, '\P{^IS_Arabic_Presentation_Forms_b}', "");
    Expect(0, 65280, '\p{IS_Arabic_Presentation_Forms_b}', "");
    Expect(1, 65280, '\p{^IS_Arabic_Presentation_Forms_b}', "");
    Expect(1, 65280, '\P{IS_Arabic_Presentation_Forms_b}', "");
    Expect(0, 65280, '\P{^IS_Arabic_Presentation_Forms_b}', "");
    Error('\p{/a/_-In_arabic_PRESENTATION_Forms_B}');
    Error('\P{/a/_-In_arabic_PRESENTATION_Forms_B}');
    Expect(1, 65279, '\p{inarabicpresentationformsb}', "");
    Expect(0, 65279, '\p{^inarabicpresentationformsb}', "");
    Expect(0, 65279, '\P{inarabicpresentationformsb}', "");
    Expect(1, 65279, '\P{^inarabicpresentationformsb}', "");
    Expect(0, 65280, '\p{inarabicpresentationformsb}', "");
    Expect(1, 65280, '\p{^inarabicpresentationformsb}', "");
    Expect(1, 65280, '\P{inarabicpresentationformsb}', "");
    Expect(0, 65280, '\P{^inarabicpresentationformsb}', "");
    Expect(1, 65279, '\p{__IN_ARABIC_PRESENTATION_Forms_B}', "");
    Expect(0, 65279, '\p{^__IN_ARABIC_PRESENTATION_Forms_B}', "");
    Expect(0, 65279, '\P{__IN_ARABIC_PRESENTATION_Forms_B}', "");
    Expect(1, 65279, '\P{^__IN_ARABIC_PRESENTATION_Forms_B}', "");
    Expect(0, 65280, '\p{__IN_ARABIC_PRESENTATION_Forms_B}', "");
    Expect(1, 65280, '\p{^__IN_ARABIC_PRESENTATION_Forms_B}', "");
    Expect(1, 65280, '\P{__IN_ARABIC_PRESENTATION_Forms_B}', "");
    Expect(0, 65280, '\P{^__IN_ARABIC_PRESENTATION_Forms_B}', "");
    Error('\p{_:=ARABIC_PF_b}');
    Error('\P{_:=ARABIC_PF_b}');
    Expect(1, 65279, '\p{arabicpfb}', "");
    Expect(0, 65279, '\p{^arabicpfb}', "");
    Expect(0, 65279, '\P{arabicpfb}', "");
    Expect(1, 65279, '\P{^arabicpfb}', "");
    Expect(0, 65280, '\p{arabicpfb}', "");
    Expect(1, 65280, '\p{^arabicpfb}', "");
    Expect(1, 65280, '\P{arabicpfb}', "");
    Expect(0, 65280, '\P{^arabicpfb}', "");
    Expect(1, 65279, '\p{		Arabic_PF_b}', "");
    Expect(0, 65279, '\p{^		Arabic_PF_b}', "");
    Expect(0, 65279, '\P{		Arabic_PF_b}', "");
    Expect(1, 65279, '\P{^		Arabic_PF_b}', "");
    Expect(0, 65280, '\p{		Arabic_PF_b}', "");
    Expect(1, 65280, '\p{^		Arabic_PF_b}', "");
    Expect(1, 65280, '\P{		Arabic_PF_b}', "");
    Expect(0, 65280, '\P{^		Arabic_PF_b}', "");
    Error('\p{ :=Is_Arabic_PF_B}');
    Error('\P{ :=Is_Arabic_PF_B}');
    Expect(1, 65279, '\p{isarabicpfb}', "");
    Expect(0, 65279, '\p{^isarabicpfb}', "");
    Expect(0, 65279, '\P{isarabicpfb}', "");
    Expect(1, 65279, '\P{^isarabicpfb}', "");
    Expect(0, 65280, '\p{isarabicpfb}', "");
    Expect(1, 65280, '\p{^isarabicpfb}', "");
    Expect(1, 65280, '\P{isarabicpfb}', "");
    Expect(0, 65280, '\P{^isarabicpfb}', "");
    Expect(1, 65279, '\p{- is_Arabic_PF_b}', "");
    Expect(0, 65279, '\p{^- is_Arabic_PF_b}', "");
    Expect(0, 65279, '\P{- is_Arabic_PF_b}', "");
    Expect(1, 65279, '\P{^- is_Arabic_PF_b}', "");
    Expect(0, 65280, '\p{- is_Arabic_PF_b}', "");
    Expect(1, 65280, '\p{^- is_Arabic_PF_b}', "");
    Expect(1, 65280, '\P{- is_Arabic_PF_b}', "");
    Expect(0, 65280, '\P{^- is_Arabic_PF_b}', "");
    Error('\p{/a/In_Arabic_PF_b}');
    Error('\P{/a/In_Arabic_PF_b}');
    Expect(1, 65279, '\p{inarabicpfb}', "");
    Expect(0, 65279, '\p{^inarabicpfb}', "");
    Expect(0, 65279, '\P{inarabicpfb}', "");
    Expect(1, 65279, '\P{^inarabicpfb}', "");
    Expect(0, 65280, '\p{inarabicpfb}', "");
    Expect(1, 65280, '\p{^inarabicpfb}', "");
    Expect(1, 65280, '\P{inarabicpfb}', "");
    Expect(0, 65280, '\P{^inarabicpfb}', "");
    Expect(1, 65279, '\p{ 	In_arabic_pf_B}', "");
    Expect(0, 65279, '\p{^ 	In_arabic_pf_B}', "");
    Expect(0, 65279, '\P{ 	In_arabic_pf_B}', "");
    Expect(1, 65279, '\P{^ 	In_arabic_pf_B}', "");
    Expect(0, 65280, '\p{ 	In_arabic_pf_B}', "");
    Expect(1, 65280, '\p{^ 	In_arabic_pf_B}', "");
    Expect(1, 65280, '\P{ 	In_arabic_pf_B}', "");
    Expect(0, 65280, '\P{^ 	In_arabic_pf_B}', "");
    Error('\p{ /a/ARABIC_Supplement}');
    Error('\P{ /a/ARABIC_Supplement}');
    Expect(1, 1919, '\p{arabicsupplement}', "");
    Expect(0, 1919, '\p{^arabicsupplement}', "");
    Expect(0, 1919, '\P{arabicsupplement}', "");
    Expect(1, 1919, '\P{^arabicsupplement}', "");
    Expect(0, 1920, '\p{arabicsupplement}', "");
    Expect(1, 1920, '\p{^arabicsupplement}', "");
    Expect(1, 1920, '\P{arabicsupplement}', "");
    Expect(0, 1920, '\P{^arabicsupplement}', "");
    Expect(1, 1919, '\p{ _Arabic_SUPPLEMENT}', "");
    Expect(0, 1919, '\p{^ _Arabic_SUPPLEMENT}', "");
    Expect(0, 1919, '\P{ _Arabic_SUPPLEMENT}', "");
    Expect(1, 1919, '\P{^ _Arabic_SUPPLEMENT}', "");
    Expect(0, 1920, '\p{ _Arabic_SUPPLEMENT}', "");
    Expect(1, 1920, '\p{^ _Arabic_SUPPLEMENT}', "");
    Expect(1, 1920, '\P{ _Arabic_SUPPLEMENT}', "");
    Expect(0, 1920, '\P{^ _Arabic_SUPPLEMENT}', "");
    Error('\p{_/a/IS_Arabic_supplement}');
    Error('\P{_/a/IS_Arabic_supplement}');
    Expect(1, 1919, '\p{isarabicsupplement}', "");
    Expect(0, 1919, '\p{^isarabicsupplement}', "");
    Expect(0, 1919, '\P{isarabicsupplement}', "");
    Expect(1, 1919, '\P{^isarabicsupplement}', "");
    Expect(0, 1920, '\p{isarabicsupplement}', "");
    Expect(1, 1920, '\p{^isarabicsupplement}', "");
    Expect(1, 1920, '\P{isarabicsupplement}', "");
    Expect(0, 1920, '\P{^isarabicsupplement}', "");
    Expect(1, 1919, '\p{_	IS_Arabic_supplement}', "");
    Expect(0, 1919, '\p{^_	IS_Arabic_supplement}', "");
    Expect(0, 1919, '\P{_	IS_Arabic_supplement}', "");
    Expect(1, 1919, '\P{^_	IS_Arabic_supplement}', "");
    Expect(0, 1920, '\p{_	IS_Arabic_supplement}', "");
    Expect(1, 1920, '\p{^_	IS_Arabic_supplement}', "");
    Expect(1, 1920, '\P{_	IS_Arabic_supplement}', "");
    Expect(0, 1920, '\P{^_	IS_Arabic_supplement}', "");
    Error('\p{- in_arabic_Supplement/a/}');
    Error('\P{- in_arabic_Supplement/a/}');
    Expect(1, 1919, '\p{inarabicsupplement}', "");
    Expect(0, 1919, '\p{^inarabicsupplement}', "");
    Expect(0, 1919, '\P{inarabicsupplement}', "");
    Expect(1, 1919, '\P{^inarabicsupplement}', "");
    Expect(0, 1920, '\p{inarabicsupplement}', "");
    Expect(1, 1920, '\p{^inarabicsupplement}', "");
    Expect(1, 1920, '\P{inarabicsupplement}', "");
    Expect(0, 1920, '\P{^inarabicsupplement}', "");
    Expect(1, 1919, '\p{--IN_arabic_Supplement}', "");
    Expect(0, 1919, '\p{^--IN_arabic_Supplement}', "");
    Expect(0, 1919, '\P{--IN_arabic_Supplement}', "");
    Expect(1, 1919, '\P{^--IN_arabic_Supplement}', "");
    Expect(0, 1920, '\p{--IN_arabic_Supplement}', "");
    Expect(1, 1920, '\p{^--IN_arabic_Supplement}', "");
    Expect(1, 1920, '\P{--IN_arabic_Supplement}', "");
    Expect(0, 1920, '\P{^--IN_arabic_Supplement}', "");
    Error('\p{ /a/Arabic_Sup}');
    Error('\P{ /a/Arabic_Sup}');
    Expect(1, 1919, '\p{arabicsup}', "");
    Expect(0, 1919, '\p{^arabicsup}', "");
    Expect(0, 1919, '\P{arabicsup}', "");
    Expect(1, 1919, '\P{^arabicsup}', "");
    Expect(0, 1920, '\p{arabicsup}', "");
    Expect(1, 1920, '\p{^arabicsup}', "");
    Expect(1, 1920, '\P{arabicsup}', "");
    Expect(0, 1920, '\P{^arabicsup}', "");
    Expect(1, 1919, '\p{-arabic_SUP}', "");
    Expect(0, 1919, '\p{^-arabic_SUP}', "");
    Expect(0, 1919, '\P{-arabic_SUP}', "");
    Expect(1, 1919, '\P{^-arabic_SUP}', "");
    Expect(0, 1920, '\p{-arabic_SUP}', "");
    Expect(1, 1920, '\p{^-arabic_SUP}', "");
    Expect(1, 1920, '\P{-arabic_SUP}', "");
    Expect(0, 1920, '\P{^-arabic_SUP}', "");
    Error('\p{	/a/Is_ARABIC_sup}');
    Error('\P{	/a/Is_ARABIC_sup}');
    Expect(1, 1919, '\p{isarabicsup}', "");
    Expect(0, 1919, '\p{^isarabicsup}', "");
    Expect(0, 1919, '\P{isarabicsup}', "");
    Expect(1, 1919, '\P{^isarabicsup}', "");
    Expect(0, 1920, '\p{isarabicsup}', "");
    Expect(1, 1920, '\p{^isarabicsup}', "");
    Expect(1, 1920, '\P{isarabicsup}', "");
    Expect(0, 1920, '\P{^isarabicsup}', "");
    Expect(1, 1919, '\p{__Is_Arabic_SUP}', "");
    Expect(0, 1919, '\p{^__Is_Arabic_SUP}', "");
    Expect(0, 1919, '\P{__Is_Arabic_SUP}', "");
    Expect(1, 1919, '\P{^__Is_Arabic_SUP}', "");
    Expect(0, 1920, '\p{__Is_Arabic_SUP}', "");
    Expect(1, 1920, '\p{^__Is_Arabic_SUP}', "");
    Expect(1, 1920, '\P{__Is_Arabic_SUP}', "");
    Expect(0, 1920, '\P{^__Is_Arabic_SUP}', "");
    Error('\p{:=	-IN_arabic_SUP}');
    Error('\P{:=	-IN_arabic_SUP}');
    Expect(1, 1919, '\p{inarabicsup}', "");
    Expect(0, 1919, '\p{^inarabicsup}', "");
    Expect(0, 1919, '\P{inarabicsup}', "");
    Expect(1, 1919, '\P{^inarabicsup}', "");
    Expect(0, 1920, '\p{inarabicsup}', "");
    Expect(1, 1920, '\p{^inarabicsup}', "");
    Expect(1, 1920, '\P{inarabicsup}', "");
    Expect(0, 1920, '\P{^inarabicsup}', "");
    Expect(1, 1919, '\p{	in_ARABIC_SUP}', "");
    Expect(0, 1919, '\p{^	in_ARABIC_SUP}', "");
    Expect(0, 1919, '\P{	in_ARABIC_SUP}', "");
    Expect(1, 1919, '\P{^	in_ARABIC_SUP}', "");
    Expect(0, 1920, '\p{	in_ARABIC_SUP}', "");
    Expect(1, 1920, '\p{^	in_ARABIC_SUP}', "");
    Expect(1, 1920, '\P{	in_ARABIC_SUP}', "");
    Expect(0, 1920, '\P{^	in_ARABIC_SUP}', "");
    Error('\p{/a/Armenian}');
    Error('\P{/a/Armenian}');
    Expect(1, 64279, '\p{armenian}', "");
    Expect(0, 64279, '\p{^armenian}', "");
    Expect(0, 64279, '\P{armenian}', "");
    Expect(1, 64279, '\P{^armenian}', "");
    Expect(0, 64280, '\p{armenian}', "");
    Expect(1, 64280, '\p{^armenian}', "");
    Expect(1, 64280, '\P{armenian}', "");
    Expect(0, 64280, '\P{^armenian}', "");
    Expect(1, 64279, '\p{ 	ARMENIAN}', "");
    Expect(0, 64279, '\p{^ 	ARMENIAN}', "");
    Expect(0, 64279, '\P{ 	ARMENIAN}', "");
    Expect(1, 64279, '\P{^ 	ARMENIAN}', "");
    Expect(0, 64280, '\p{ 	ARMENIAN}', "");
    Expect(1, 64280, '\p{^ 	ARMENIAN}', "");
    Expect(1, 64280, '\P{ 	ARMENIAN}', "");
    Expect(0, 64280, '\P{^ 	ARMENIAN}', "");
    Error('\p{:=  is_ARMENIAN}');
    Error('\P{:=  is_ARMENIAN}');
    Expect(1, 64279, '\p{isarmenian}', "");
    Expect(0, 64279, '\p{^isarmenian}', "");
    Expect(0, 64279, '\P{isarmenian}', "");
    Expect(1, 64279, '\P{^isarmenian}', "");
    Expect(0, 64280, '\p{isarmenian}', "");
    Expect(1, 64280, '\p{^isarmenian}', "");
    Expect(1, 64280, '\P{isarmenian}', "");
    Expect(0, 64280, '\P{^isarmenian}', "");
    Expect(1, 64279, '\p{	 Is_Armenian}', "");
    Expect(0, 64279, '\p{^	 Is_Armenian}', "");
    Expect(0, 64279, '\P{	 Is_Armenian}', "");
    Expect(1, 64279, '\P{^	 Is_Armenian}', "");
    Expect(0, 64280, '\p{	 Is_Armenian}', "");
    Expect(1, 64280, '\p{^	 Is_Armenian}', "");
    Expect(1, 64280, '\P{	 Is_Armenian}', "");
    Expect(0, 64280, '\P{^	 Is_Armenian}', "");
    Error('\p{	/a/armn}');
    Error('\P{	/a/armn}');
    Expect(1, 64279, '\p{armn}', "");
    Expect(0, 64279, '\p{^armn}', "");
    Expect(0, 64279, '\P{armn}', "");
    Expect(1, 64279, '\P{^armn}', "");
    Expect(0, 64280, '\p{armn}', "");
    Expect(1, 64280, '\p{^armn}', "");
    Expect(1, 64280, '\P{armn}', "");
    Expect(0, 64280, '\P{^armn}', "");
    Expect(1, 64279, '\p{-	ARMN}', "");
    Expect(0, 64279, '\p{^-	ARMN}', "");
    Expect(0, 64279, '\P{-	ARMN}', "");
    Expect(1, 64279, '\P{^-	ARMN}', "");
    Expect(0, 64280, '\p{-	ARMN}', "");
    Expect(1, 64280, '\p{^-	ARMN}', "");
    Expect(1, 64280, '\P{-	ARMN}', "");
    Expect(0, 64280, '\P{^-	ARMN}', "");
    Error('\p{/a/ IS_Armn}');
    Error('\P{/a/ IS_Armn}');
    Expect(1, 64279, '\p{isarmn}', "");
    Expect(0, 64279, '\p{^isarmn}', "");
    Expect(0, 64279, '\P{isarmn}', "");
    Expect(1, 64279, '\P{^isarmn}', "");
    Expect(0, 64280, '\p{isarmn}', "");
    Expect(1, 64280, '\p{^isarmn}', "");
    Expect(1, 64280, '\P{isarmn}', "");
    Expect(0, 64280, '\P{^isarmn}', "");
    Expect(1, 64279, '\p{_IS_Armn}', "");
    Expect(0, 64279, '\p{^_IS_Armn}', "");
    Expect(0, 64279, '\P{_IS_Armn}', "");
    Expect(1, 64279, '\P{^_IS_Armn}', "");
    Expect(0, 64280, '\p{_IS_Armn}', "");
    Expect(1, 64280, '\p{^_IS_Armn}', "");
    Expect(1, 64280, '\P{_IS_Armn}', "");
    Expect(0, 64280, '\P{^_IS_Armn}', "");
    Error('\p{-Arrows:=}');
    Error('\P{-Arrows:=}');
    Expect(1, 8703, '\p{arrows}', "");
    Expect(0, 8703, '\p{^arrows}', "");
    Expect(0, 8703, '\P{arrows}', "");
    Expect(1, 8703, '\P{^arrows}', "");
    Expect(0, 8704, '\p{arrows}', "");
    Expect(1, 8704, '\p{^arrows}', "");
    Expect(1, 8704, '\P{arrows}', "");
    Expect(0, 8704, '\P{^arrows}', "");
    Expect(1, 8703, '\p{  ARROWS}', "");
    Expect(0, 8703, '\p{^  ARROWS}', "");
    Expect(0, 8703, '\P{  ARROWS}', "");
    Expect(1, 8703, '\P{^  ARROWS}', "");
    Expect(0, 8704, '\p{  ARROWS}', "");
    Expect(1, 8704, '\p{^  ARROWS}', "");
    Expect(1, 8704, '\P{  ARROWS}', "");
    Expect(0, 8704, '\P{^  ARROWS}', "");
    Error('\p{	:=Is_arrows}');
    Error('\P{	:=Is_arrows}');
    Expect(1, 8703, '\p{isarrows}', "");
    Expect(0, 8703, '\p{^isarrows}', "");
    Expect(0, 8703, '\P{isarrows}', "");
    Expect(1, 8703, '\P{^isarrows}', "");
    Expect(0, 8704, '\p{isarrows}', "");
    Expect(1, 8704, '\p{^isarrows}', "");
    Expect(1, 8704, '\P{isarrows}', "");
    Expect(0, 8704, '\P{^isarrows}', "");
    Expect(1, 8703, '\p{ 	Is_Arrows}', "");
    Expect(0, 8703, '\p{^ 	Is_Arrows}', "");
    Expect(0, 8703, '\P{ 	Is_Arrows}', "");
    Expect(1, 8703, '\P{^ 	Is_Arrows}', "");
    Expect(0, 8704, '\p{ 	Is_Arrows}', "");
    Expect(1, 8704, '\p{^ 	Is_Arrows}', "");
    Expect(1, 8704, '\P{ 	Is_Arrows}', "");
    Expect(0, 8704, '\P{^ 	Is_Arrows}', "");
    Error('\p{	_IN_Arrows/a/}');
    Error('\P{	_IN_Arrows/a/}');
    Expect(1, 8703, '\p{inarrows}', "");
    Expect(0, 8703, '\p{^inarrows}', "");
    Expect(0, 8703, '\P{inarrows}', "");
    Expect(1, 8703, '\P{^inarrows}', "");
    Expect(0, 8704, '\p{inarrows}', "");
    Expect(1, 8704, '\p{^inarrows}', "");
    Expect(1, 8704, '\P{inarrows}', "");
    Expect(0, 8704, '\P{^inarrows}', "");
    Expect(1, 8703, '\p{	 In_arrows}', "");
    Expect(0, 8703, '\p{^	 In_arrows}', "");
    Expect(0, 8703, '\P{	 In_arrows}', "");
    Expect(1, 8703, '\P{^	 In_arrows}', "");
    Expect(0, 8704, '\p{	 In_arrows}', "");
    Expect(1, 8704, '\p{^	 In_arrows}', "");
    Expect(1, 8704, '\P{	 In_arrows}', "");
    Expect(0, 8704, '\P{^	 In_arrows}', "");
    Error('\p{:=ASCII}');
    Error('\P{:=ASCII}');
    Expect(1, 127, '\p{ascii}', "");
    Expect(0, 127, '\p{^ascii}', "");
    Expect(0, 127, '\P{ascii}', "");
    Expect(1, 127, '\P{^ascii}', "");
    Expect(0, 128, '\p{ascii}', "");
    Expect(1, 128, '\p{^ascii}', "");
    Expect(1, 128, '\P{ascii}', "");
    Expect(0, 128, '\P{^ascii}', "");
    Expect(1, 127, '\p{-ASCII}', "");
    Expect(0, 127, '\p{^-ASCII}', "");
    Expect(0, 127, '\P{-ASCII}', "");
    Expect(1, 127, '\P{^-ASCII}', "");
    Expect(0, 128, '\p{-ASCII}', "");
    Expect(1, 128, '\p{^-ASCII}', "");
    Expect(1, 128, '\P{-ASCII}', "");
    Expect(0, 128, '\P{^-ASCII}', "");
    Error('\p{/a/_is_ASCII}');
    Error('\P{/a/_is_ASCII}');
    Expect(1, 127, '\p{isascii}', "");
    Expect(0, 127, '\p{^isascii}', "");
    Expect(0, 127, '\P{isascii}', "");
    Expect(1, 127, '\P{^isascii}', "");
    Expect(0, 128, '\p{isascii}', "");
    Expect(1, 128, '\p{^isascii}', "");
    Expect(1, 128, '\P{isascii}', "");
    Expect(0, 128, '\P{^isascii}', "");
    Expect(1, 127, '\p{- is_ascii}', "");
    Expect(0, 127, '\p{^- is_ascii}', "");
    Expect(0, 127, '\P{- is_ascii}', "");
    Expect(1, 127, '\P{^- is_ascii}', "");
    Expect(0, 128, '\p{- is_ascii}', "");
    Expect(1, 128, '\p{^- is_ascii}', "");
    Expect(1, 128, '\P{- is_ascii}', "");
    Expect(0, 128, '\P{^- is_ascii}', "");
    Error('\p{ /a/basic_LATIN}');
    Error('\P{ /a/basic_LATIN}');
    Expect(1, 127, '\p{basiclatin}', "");
    Expect(0, 127, '\p{^basiclatin}', "");
    Expect(0, 127, '\P{basiclatin}', "");
    Expect(1, 127, '\P{^basiclatin}', "");
    Expect(0, 128, '\p{basiclatin}', "");
    Expect(1, 128, '\p{^basiclatin}', "");
    Expect(1, 128, '\P{basiclatin}', "");
    Expect(0, 128, '\P{^basiclatin}', "");
    Expect(1, 127, '\p{ Basic_LATIN}', "");
    Expect(0, 127, '\p{^ Basic_LATIN}', "");
    Expect(0, 127, '\P{ Basic_LATIN}', "");
    Expect(1, 127, '\P{^ Basic_LATIN}', "");
    Expect(0, 128, '\p{ Basic_LATIN}', "");
    Expect(1, 128, '\p{^ Basic_LATIN}', "");
    Expect(1, 128, '\P{ Basic_LATIN}', "");
    Expect(0, 128, '\P{^ Basic_LATIN}', "");
    Error('\p{-/a/Is_basic_LATIN}');
    Error('\P{-/a/Is_basic_LATIN}');
    Expect(1, 127, '\p{isbasiclatin}', "");
    Expect(0, 127, '\p{^isbasiclatin}', "");
    Expect(0, 127, '\P{isbasiclatin}', "");
    Expect(1, 127, '\P{^isbasiclatin}', "");
    Expect(0, 128, '\p{isbasiclatin}', "");
    Expect(1, 128, '\p{^isbasiclatin}', "");
    Expect(1, 128, '\P{isbasiclatin}', "");
    Expect(0, 128, '\P{^isbasiclatin}', "");
    Expect(1, 127, '\p{	-Is_basic_Latin}', "");
    Expect(0, 127, '\p{^	-Is_basic_Latin}', "");
    Expect(0, 127, '\P{	-Is_basic_Latin}', "");
    Expect(1, 127, '\P{^	-Is_basic_Latin}', "");
    Expect(0, 128, '\p{	-Is_basic_Latin}', "");
    Expect(1, 128, '\p{^	-Is_basic_Latin}', "");
    Expect(1, 128, '\P{	-Is_basic_Latin}', "");
    Expect(0, 128, '\P{^	-Is_basic_Latin}', "");
    Error('\p{/a/ 	in_basic_LATIN}');
    Error('\P{/a/ 	in_basic_LATIN}');
    Expect(1, 127, '\p{inbasiclatin}', "");
    Expect(0, 127, '\p{^inbasiclatin}', "");
    Expect(0, 127, '\P{inbasiclatin}', "");
    Expect(1, 127, '\P{^inbasiclatin}', "");
    Expect(0, 128, '\p{inbasiclatin}', "");
    Expect(1, 128, '\p{^inbasiclatin}', "");
    Expect(1, 128, '\P{inbasiclatin}', "");
    Expect(0, 128, '\P{^inbasiclatin}', "");
    Expect(1, 127, '\p{-in_BASIC_Latin}', "");
    Expect(0, 127, '\p{^-in_BASIC_Latin}', "");
    Expect(0, 127, '\P{-in_BASIC_Latin}', "");
    Expect(1, 127, '\P{^-in_BASIC_Latin}', "");
    Expect(0, 128, '\p{-in_BASIC_Latin}', "");
    Expect(1, 128, '\p{^-in_BASIC_Latin}', "");
    Expect(1, 128, '\P{-in_BASIC_Latin}', "");
    Expect(0, 128, '\P{^-in_BASIC_Latin}', "");
    Error('\p{-_In_ASCII/a/}');
    Error('\P{-_In_ASCII/a/}');
    Expect(1, 127, '\p{inascii}', "");
    Expect(0, 127, '\p{^inascii}', "");
    Expect(0, 127, '\P{inascii}', "");
    Expect(1, 127, '\P{^inascii}', "");
    Expect(0, 128, '\p{inascii}', "");
    Expect(1, 128, '\p{^inascii}', "");
    Expect(1, 128, '\P{inascii}', "");
    Expect(0, 128, '\P{^inascii}', "");
    Expect(1, 127, '\p{--In_ASCII}', "");
    Expect(0, 127, '\p{^--In_ASCII}', "");
    Expect(0, 127, '\P{--In_ASCII}', "");
    Expect(1, 127, '\P{^--In_ASCII}', "");
    Expect(0, 128, '\p{--In_ASCII}', "");
    Expect(1, 128, '\p{^--In_ASCII}', "");
    Expect(1, 128, '\P{--In_ASCII}', "");
    Expect(0, 128, '\P{^--In_ASCII}', "");
    Error('\p{:=_	ASSIGNED}');
    Error('\P{:=_	ASSIGNED}');
    Expect(1, 1114109, '\p{assigned}', "");
    Expect(0, 1114109, '\p{^assigned}', "");
    Expect(0, 1114109, '\P{assigned}', "");
    Expect(1, 1114109, '\P{^assigned}', "");
    Expect(0, 918000, '\p{assigned}', "");
    Expect(1, 918000, '\p{^assigned}', "");
    Expect(1, 918000, '\P{assigned}', "");
    Expect(0, 918000, '\P{^assigned}', "");
    Expect(1, 1114109, '\p{	-assigned}', "");
    Expect(0, 1114109, '\p{^	-assigned}', "");
    Expect(0, 1114109, '\P{	-assigned}', "");
    Expect(1, 1114109, '\P{^	-assigned}', "");
    Expect(0, 918000, '\p{	-assigned}', "");
    Expect(1, 918000, '\p{^	-assigned}', "");
    Expect(1, 918000, '\P{	-assigned}', "");
    Expect(0, 918000, '\P{^	-assigned}', "");
    Error('\p{/a/  Is_assigned}');
    Error('\P{/a/  Is_assigned}');
    Expect(1, 1114109, '\p{isassigned}', "");
    Expect(0, 1114109, '\p{^isassigned}', "");
    Expect(0, 1114109, '\P{isassigned}', "");
    Expect(1, 1114109, '\P{^isassigned}', "");
    Expect(0, 918000, '\p{isassigned}', "");
    Expect(1, 918000, '\p{^isassigned}', "");
    Expect(1, 918000, '\P{isassigned}', "");
    Expect(0, 918000, '\P{^isassigned}', "");
    Expect(1, 1114109, '\p{_-is_assigned}', "");
    Expect(0, 1114109, '\p{^_-is_assigned}', "");
    Expect(0, 1114109, '\P{_-is_assigned}', "");
    Expect(1, 1114109, '\P{^_-is_assigned}', "");
    Expect(0, 918000, '\p{_-is_assigned}', "");
    Expect(1, 918000, '\p{^_-is_assigned}', "");
    Expect(1, 918000, '\P{_-is_assigned}', "");
    Expect(0, 918000, '\P{^_-is_assigned}', "");
    Error('\p{_:=Avestan}');
    Error('\P{_:=Avestan}');
    Expect(1, 68415, '\p{avestan}', "");
    Expect(0, 68415, '\p{^avestan}', "");
    Expect(0, 68415, '\P{avestan}', "");
    Expect(1, 68415, '\P{^avestan}', "");
    Expect(0, 68416, '\p{avestan}', "");
    Expect(1, 68416, '\p{^avestan}', "");
    Expect(1, 68416, '\P{avestan}', "");
    Expect(0, 68416, '\P{^avestan}', "");
    Expect(1, 68415, '\p{		Avestan}', "");
    Expect(0, 68415, '\p{^		Avestan}', "");
    Expect(0, 68415, '\P{		Avestan}', "");
    Expect(1, 68415, '\P{^		Avestan}', "");
    Expect(0, 68416, '\p{		Avestan}', "");
    Expect(1, 68416, '\p{^		Avestan}', "");
    Expect(1, 68416, '\P{		Avestan}', "");
    Expect(0, 68416, '\P{^		Avestan}', "");
    Error('\p{ IS_AVESTAN:=}');
    Error('\P{ IS_AVESTAN:=}');
    Expect(1, 68415, '\p{isavestan}', "");
    Expect(0, 68415, '\p{^isavestan}', "");
    Expect(0, 68415, '\P{isavestan}', "");
    Expect(1, 68415, '\P{^isavestan}', "");
    Expect(0, 68416, '\p{isavestan}', "");
    Expect(1, 68416, '\p{^isavestan}', "");
    Expect(1, 68416, '\P{isavestan}', "");
    Expect(0, 68416, '\P{^isavestan}', "");
    Expect(1, 68415, '\p{_Is_avestan}', "");
    Expect(0, 68415, '\p{^_Is_avestan}', "");
    Expect(0, 68415, '\P{_Is_avestan}', "");
    Expect(1, 68415, '\P{^_Is_avestan}', "");
    Expect(0, 68416, '\p{_Is_avestan}', "");
    Expect(1, 68416, '\p{^_Is_avestan}', "");
    Expect(1, 68416, '\P{_Is_avestan}', "");
    Expect(0, 68416, '\P{^_Is_avestan}', "");
    Error('\p{:=--avst}');
    Error('\P{:=--avst}');
    Expect(1, 68415, '\p{avst}', "");
    Expect(0, 68415, '\p{^avst}', "");
    Expect(0, 68415, '\P{avst}', "");
    Expect(1, 68415, '\P{^avst}', "");
    Expect(0, 68416, '\p{avst}', "");
    Expect(1, 68416, '\p{^avst}', "");
    Expect(1, 68416, '\P{avst}', "");
    Expect(0, 68416, '\P{^avst}', "");
    Expect(1, 68415, '\p{ _avst}', "");
    Expect(0, 68415, '\p{^ _avst}', "");
    Expect(0, 68415, '\P{ _avst}', "");
    Expect(1, 68415, '\P{^ _avst}', "");
    Expect(0, 68416, '\p{ _avst}', "");
    Expect(1, 68416, '\p{^ _avst}', "");
    Expect(1, 68416, '\P{ _avst}', "");
    Expect(0, 68416, '\P{^ _avst}', "");
    Error('\p{__is_Avst:=}');
    Error('\P{__is_Avst:=}');
    Expect(1, 68415, '\p{isavst}', "");
    Expect(0, 68415, '\p{^isavst}', "");
    Expect(0, 68415, '\P{isavst}', "");
    Expect(1, 68415, '\P{^isavst}', "");
    Expect(0, 68416, '\p{isavst}', "");
    Expect(1, 68416, '\p{^isavst}', "");
    Expect(1, 68416, '\P{isavst}', "");
    Expect(0, 68416, '\P{^isavst}', "");
    Expect(1, 68415, '\p{_IS_avst}', "");
    Expect(0, 68415, '\p{^_IS_avst}', "");
    Expect(0, 68415, '\P{_IS_avst}', "");
    Expect(1, 68415, '\P{^_IS_avst}', "");
    Expect(0, 68416, '\p{_IS_avst}', "");
    Expect(1, 68416, '\p{^_IS_avst}', "");
    Expect(1, 68416, '\P{_IS_avst}', "");
    Expect(0, 68416, '\P{^_IS_avst}', "");
    Error('\p{/a/-_Balinese}');
    Error('\P{/a/-_Balinese}');
    Expect(1, 7036, '\p{balinese}', "");
    Expect(0, 7036, '\p{^balinese}', "");
    Expect(0, 7036, '\P{balinese}', "");
    Expect(1, 7036, '\P{^balinese}', "");
    Expect(0, 7037, '\p{balinese}', "");
    Expect(1, 7037, '\p{^balinese}', "");
    Expect(1, 7037, '\P{balinese}', "");
    Expect(0, 7037, '\P{^balinese}', "");
    Expect(1, 7036, '\p{ Balinese}', "");
    Expect(0, 7036, '\p{^ Balinese}', "");
    Expect(0, 7036, '\P{ Balinese}', "");
    Expect(1, 7036, '\P{^ Balinese}', "");
    Expect(0, 7037, '\p{ Balinese}', "");
    Expect(1, 7037, '\p{^ Balinese}', "");
    Expect(1, 7037, '\P{ Balinese}', "");
    Expect(0, 7037, '\P{^ Balinese}', "");
    Error('\p{/a/ is_BALINESE}');
    Error('\P{/a/ is_BALINESE}');
    Expect(1, 7036, '\p{isbalinese}', "");
    Expect(0, 7036, '\p{^isbalinese}', "");
    Expect(0, 7036, '\P{isbalinese}', "");
    Expect(1, 7036, '\P{^isbalinese}', "");
    Expect(0, 7037, '\p{isbalinese}', "");
    Expect(1, 7037, '\p{^isbalinese}', "");
    Expect(1, 7037, '\P{isbalinese}', "");
    Expect(0, 7037, '\P{^isbalinese}', "");
    Expect(1, 7036, '\p{  Is_Balinese}', "");
    Expect(0, 7036, '\p{^  Is_Balinese}', "");
    Expect(0, 7036, '\P{  Is_Balinese}', "");
    Expect(1, 7036, '\P{^  Is_Balinese}', "");
    Expect(0, 7037, '\p{  Is_Balinese}', "");
    Expect(1, 7037, '\p{^  Is_Balinese}', "");
    Expect(1, 7037, '\P{  Is_Balinese}', "");
    Expect(0, 7037, '\P{^  Is_Balinese}', "");
    Error('\p{_:=bali}');
    Error('\P{_:=bali}');
    Expect(1, 7036, '\p{bali}', "");
    Expect(0, 7036, '\p{^bali}', "");
    Expect(0, 7036, '\P{bali}', "");
    Expect(1, 7036, '\P{^bali}', "");
    Expect(0, 7037, '\p{bali}', "");
    Expect(1, 7037, '\p{^bali}', "");
    Expect(1, 7037, '\P{bali}', "");
    Expect(0, 7037, '\P{^bali}', "");
    Expect(1, 7036, '\p{-bali}', "");
    Expect(0, 7036, '\p{^-bali}', "");
    Expect(0, 7036, '\P{-bali}', "");
    Expect(1, 7036, '\P{^-bali}', "");
    Expect(0, 7037, '\p{-bali}', "");
    Expect(1, 7037, '\p{^-bali}', "");
    Expect(1, 7037, '\P{-bali}', "");
    Expect(0, 7037, '\P{^-bali}', "");
    Error('\p{  is_bali/a/}');
    Error('\P{  is_bali/a/}');
    Expect(1, 7036, '\p{isbali}', "");
    Expect(0, 7036, '\p{^isbali}', "");
    Expect(0, 7036, '\P{isbali}', "");
    Expect(1, 7036, '\P{^isbali}', "");
    Expect(0, 7037, '\p{isbali}', "");
    Expect(1, 7037, '\p{^isbali}', "");
    Expect(1, 7037, '\P{isbali}', "");
    Expect(0, 7037, '\P{^isbali}', "");
    Expect(1, 7036, '\p{-	Is_bali}', "");
    Expect(0, 7036, '\p{^-	Is_bali}', "");
    Expect(0, 7036, '\P{-	Is_bali}', "");
    Expect(1, 7036, '\P{^-	Is_bali}', "");
    Expect(0, 7037, '\p{-	Is_bali}', "");
    Expect(1, 7037, '\p{^-	Is_bali}', "");
    Expect(1, 7037, '\P{-	Is_bali}', "");
    Expect(0, 7037, '\P{^-	Is_bali}', "");
    Error('\p{/a/- bamum}');
    Error('\P{/a/- bamum}');
    Expect(1, 92728, '\p{bamum}', "");
    Expect(0, 92728, '\p{^bamum}', "");
    Expect(0, 92728, '\P{bamum}', "");
    Expect(1, 92728, '\P{^bamum}', "");
    Expect(0, 92729, '\p{bamum}', "");
    Expect(1, 92729, '\p{^bamum}', "");
    Expect(1, 92729, '\P{bamum}', "");
    Expect(0, 92729, '\P{^bamum}', "");
    Expect(1, 92728, '\p{ _Bamum}', "");
    Expect(0, 92728, '\p{^ _Bamum}', "");
    Expect(0, 92728, '\P{ _Bamum}', "");
    Expect(1, 92728, '\P{^ _Bamum}', "");
    Expect(0, 92729, '\p{ _Bamum}', "");
    Expect(1, 92729, '\p{^ _Bamum}', "");
    Expect(1, 92729, '\P{ _Bamum}', "");
    Expect(0, 92729, '\P{^ _Bamum}', "");
    Error('\p{  Is_bamum/a/}');
    Error('\P{  Is_bamum/a/}');
    Expect(1, 92728, '\p{isbamum}', "");
    Expect(0, 92728, '\p{^isbamum}', "");
    Expect(0, 92728, '\P{isbamum}', "");
    Expect(1, 92728, '\P{^isbamum}', "");
    Expect(0, 92729, '\p{isbamum}', "");
    Expect(1, 92729, '\p{^isbamum}', "");
    Expect(1, 92729, '\P{isbamum}', "");
    Expect(0, 92729, '\P{^isbamum}', "");
    Expect(1, 92728, '\p{_Is_Bamum}', "");
    Expect(0, 92728, '\p{^_Is_Bamum}', "");
    Expect(0, 92728, '\P{_Is_Bamum}', "");
    Expect(1, 92728, '\P{^_Is_Bamum}', "");
    Expect(0, 92729, '\p{_Is_Bamum}', "");
    Expect(1, 92729, '\p{^_Is_Bamum}', "");
    Expect(1, 92729, '\P{_Is_Bamum}', "");
    Expect(0, 92729, '\P{^_Is_Bamum}', "");
    Error('\p{:= -BAMU}');
    Error('\P{:= -BAMU}');
    Expect(1, 92728, '\p{bamu}', "");
    Expect(0, 92728, '\p{^bamu}', "");
    Expect(0, 92728, '\P{bamu}', "");
    Expect(1, 92728, '\P{^bamu}', "");
    Expect(0, 92729, '\p{bamu}', "");
    Expect(1, 92729, '\p{^bamu}', "");
    Expect(1, 92729, '\P{bamu}', "");
    Expect(0, 92729, '\P{^bamu}', "");
    Expect(1, 92728, '\p{	_Bamu}', "");
    Expect(0, 92728, '\p{^	_Bamu}', "");
    Expect(0, 92728, '\P{	_Bamu}', "");
    Expect(1, 92728, '\P{^	_Bamu}', "");
    Expect(0, 92729, '\p{	_Bamu}', "");
    Expect(1, 92729, '\p{^	_Bamu}', "");
    Expect(1, 92729, '\P{	_Bamu}', "");
    Expect(0, 92729, '\P{^	_Bamu}', "");
    Error('\p{_/a/is_bamu}');
    Error('\P{_/a/is_bamu}');
    Expect(1, 92728, '\p{isbamu}', "");
    Expect(0, 92728, '\p{^isbamu}', "");
    Expect(0, 92728, '\P{isbamu}', "");
    Expect(1, 92728, '\P{^isbamu}', "");
    Expect(0, 92729, '\p{isbamu}', "");
    Expect(1, 92729, '\p{^isbamu}', "");
    Expect(1, 92729, '\P{isbamu}', "");
    Expect(0, 92729, '\P{^isbamu}', "");
    Expect(1, 92728, '\p{		Is_BAMU}', "");
    Expect(0, 92728, '\p{^		Is_BAMU}', "");
    Expect(0, 92728, '\P{		Is_BAMU}', "");
    Expect(1, 92728, '\P{^		Is_BAMU}', "");
    Expect(0, 92729, '\p{		Is_BAMU}', "");
    Expect(1, 92729, '\p{^		Is_BAMU}', "");
    Expect(1, 92729, '\P{		Is_BAMU}', "");
    Expect(0, 92729, '\P{^		Is_BAMU}', "");
    Error('\p{:=	BAMUM_SUPPLEMENT}');
    Error('\P{:=	BAMUM_SUPPLEMENT}');
    Expect(1, 92735, '\p{bamumsupplement}', "");
    Expect(0, 92735, '\p{^bamumsupplement}', "");
    Expect(0, 92735, '\P{bamumsupplement}', "");
    Expect(1, 92735, '\P{^bamumsupplement}', "");
    Expect(0, 92736, '\p{bamumsupplement}', "");
    Expect(1, 92736, '\p{^bamumsupplement}', "");
    Expect(1, 92736, '\P{bamumsupplement}', "");
    Expect(0, 92736, '\P{^bamumsupplement}', "");
    Expect(1, 92735, '\p{ 	BAMUM_Supplement}', "");
    Expect(0, 92735, '\p{^ 	BAMUM_Supplement}', "");
    Expect(0, 92735, '\P{ 	BAMUM_Supplement}', "");
    Expect(1, 92735, '\P{^ 	BAMUM_Supplement}', "");
    Expect(0, 92736, '\p{ 	BAMUM_Supplement}', "");
    Expect(1, 92736, '\p{^ 	BAMUM_Supplement}', "");
    Expect(1, 92736, '\P{ 	BAMUM_Supplement}', "");
    Expect(0, 92736, '\P{^ 	BAMUM_Supplement}', "");
    Error('\p{/a/ _IS_bamum_Supplement}');
    Error('\P{/a/ _IS_bamum_Supplement}');
    Expect(1, 92735, '\p{isbamumsupplement}', "");
    Expect(0, 92735, '\p{^isbamumsupplement}', "");
    Expect(0, 92735, '\P{isbamumsupplement}', "");
    Expect(1, 92735, '\P{^isbamumsupplement}', "");
    Expect(0, 92736, '\p{isbamumsupplement}', "");
    Expect(1, 92736, '\p{^isbamumsupplement}', "");
    Expect(1, 92736, '\P{isbamumsupplement}', "");
    Expect(0, 92736, '\P{^isbamumsupplement}', "");
    Expect(1, 92735, '\p{-Is_Bamum_supplement}', "");
    Expect(0, 92735, '\p{^-Is_Bamum_supplement}', "");
    Expect(0, 92735, '\P{-Is_Bamum_supplement}', "");
    Expect(1, 92735, '\P{^-Is_Bamum_supplement}', "");
    Expect(0, 92736, '\p{-Is_Bamum_supplement}', "");
    Expect(1, 92736, '\p{^-Is_Bamum_supplement}', "");
    Expect(1, 92736, '\P{-Is_Bamum_supplement}', "");
    Expect(0, 92736, '\P{^-Is_Bamum_supplement}', "");
    Error('\p{_:=In_bamum_Supplement}');
    Error('\P{_:=In_bamum_Supplement}');
    Expect(1, 92735, '\p{inbamumsupplement}', "");
    Expect(0, 92735, '\p{^inbamumsupplement}', "");
    Expect(0, 92735, '\P{inbamumsupplement}', "");
    Expect(1, 92735, '\P{^inbamumsupplement}', "");
    Expect(0, 92736, '\p{inbamumsupplement}', "");
    Expect(1, 92736, '\p{^inbamumsupplement}', "");
    Expect(1, 92736, '\P{inbamumsupplement}', "");
    Expect(0, 92736, '\P{^inbamumsupplement}', "");
    Expect(1, 92735, '\p{ IN_Bamum_Supplement}', "");
    Expect(0, 92735, '\p{^ IN_Bamum_Supplement}', "");
    Expect(0, 92735, '\P{ IN_Bamum_Supplement}', "");
    Expect(1, 92735, '\P{^ IN_Bamum_Supplement}', "");
    Expect(0, 92736, '\p{ IN_Bamum_Supplement}', "");
    Expect(1, 92736, '\p{^ IN_Bamum_Supplement}', "");
    Expect(1, 92736, '\P{ IN_Bamum_Supplement}', "");
    Expect(0, 92736, '\P{^ IN_Bamum_Supplement}', "");
    Error('\p{/a/-Bamum_Sup}');
    Error('\P{/a/-Bamum_Sup}');
    Expect(1, 92735, '\p{bamumsup}', "");
    Expect(0, 92735, '\p{^bamumsup}', "");
    Expect(0, 92735, '\P{bamumsup}', "");
    Expect(1, 92735, '\P{^bamumsup}', "");
    Expect(0, 92736, '\p{bamumsup}', "");
    Expect(1, 92736, '\p{^bamumsup}', "");
    Expect(1, 92736, '\P{bamumsup}', "");
    Expect(0, 92736, '\P{^bamumsup}', "");
    Expect(1, 92735, '\p{ -BAMUM_SUP}', "");
    Expect(0, 92735, '\p{^ -BAMUM_SUP}', "");
    Expect(0, 92735, '\P{ -BAMUM_SUP}', "");
    Expect(1, 92735, '\P{^ -BAMUM_SUP}', "");
    Expect(0, 92736, '\p{ -BAMUM_SUP}', "");
    Expect(1, 92736, '\p{^ -BAMUM_SUP}', "");
    Expect(1, 92736, '\P{ -BAMUM_SUP}', "");
    Expect(0, 92736, '\P{^ -BAMUM_SUP}', "");
    Error('\p{_/a/IS_Bamum_sup}');
    Error('\P{_/a/IS_Bamum_sup}');
    Expect(1, 92735, '\p{isbamumsup}', "");
    Expect(0, 92735, '\p{^isbamumsup}', "");
    Expect(0, 92735, '\P{isbamumsup}', "");
    Expect(1, 92735, '\P{^isbamumsup}', "");
    Expect(0, 92736, '\p{isbamumsup}', "");
    Expect(1, 92736, '\p{^isbamumsup}', "");
    Expect(1, 92736, '\P{isbamumsup}', "");
    Expect(0, 92736, '\P{^isbamumsup}', "");
    Expect(1, 92735, '\p{_-Is_Bamum_SUP}', "");
    Expect(0, 92735, '\p{^_-Is_Bamum_SUP}', "");
    Expect(0, 92735, '\P{_-Is_Bamum_SUP}', "");
    Expect(1, 92735, '\P{^_-Is_Bamum_SUP}', "");
    Expect(0, 92736, '\p{_-Is_Bamum_SUP}', "");
    Expect(1, 92736, '\p{^_-Is_Bamum_SUP}', "");
    Expect(1, 92736, '\P{_-Is_Bamum_SUP}', "");
    Expect(0, 92736, '\P{^_-Is_Bamum_SUP}', "");
    Error('\p{ /a/IN_BAMUM_Sup}');
    Error('\P{ /a/IN_BAMUM_Sup}');
    Expect(1, 92735, '\p{inbamumsup}', "");
    Expect(0, 92735, '\p{^inbamumsup}', "");
    Expect(0, 92735, '\P{inbamumsup}', "");
    Expect(1, 92735, '\P{^inbamumsup}', "");
    Expect(0, 92736, '\p{inbamumsup}', "");
    Expect(1, 92736, '\p{^inbamumsup}', "");
    Expect(1, 92736, '\P{inbamumsup}', "");
    Expect(0, 92736, '\P{^inbamumsup}', "");
    Expect(1, 92735, '\p{In_bamum_SUP}', "");
    Expect(0, 92735, '\p{^In_bamum_SUP}', "");
    Expect(0, 92735, '\P{In_bamum_SUP}', "");
    Expect(1, 92735, '\P{^In_bamum_SUP}', "");
    Expect(0, 92736, '\p{In_bamum_SUP}', "");
    Expect(1, 92736, '\p{^In_bamum_SUP}', "");
    Expect(1, 92736, '\P{In_bamum_SUP}', "");
    Expect(0, 92736, '\P{^In_bamum_SUP}', "");
    Error('\p{ _Bassa_Vah/a/}');
    Error('\P{ _Bassa_Vah/a/}');
    Expect(1, 92917, '\p{bassavah}', "");
    Expect(0, 92917, '\p{^bassavah}', "");
    Expect(0, 92917, '\P{bassavah}', "");
    Expect(1, 92917, '\P{^bassavah}', "");
    Expect(0, 92918, '\p{bassavah}', "");
    Expect(1, 92918, '\p{^bassavah}', "");
    Expect(1, 92918, '\P{bassavah}', "");
    Expect(0, 92918, '\P{^bassavah}', "");
    Expect(1, 92917, '\p{	BASSA_Vah}', "");
    Expect(0, 92917, '\p{^	BASSA_Vah}', "");
    Expect(0, 92917, '\P{	BASSA_Vah}', "");
    Expect(1, 92917, '\P{^	BASSA_Vah}', "");
    Expect(0, 92918, '\p{	BASSA_Vah}', "");
    Expect(1, 92918, '\p{^	BASSA_Vah}', "");
    Expect(1, 92918, '\P{	BASSA_Vah}', "");
    Expect(0, 92918, '\P{^	BASSA_Vah}', "");
    Error('\p{_is_Bassa_vah:=}');
    Error('\P{_is_Bassa_vah:=}');
    Expect(1, 92917, '\p{isbassavah}', "");
    Expect(0, 92917, '\p{^isbassavah}', "");
    Expect(0, 92917, '\P{isbassavah}', "");
    Expect(1, 92917, '\P{^isbassavah}', "");
    Expect(0, 92918, '\p{isbassavah}', "");
    Expect(1, 92918, '\p{^isbassavah}', "");
    Expect(1, 92918, '\P{isbassavah}', "");
    Expect(0, 92918, '\P{^isbassavah}', "");
    Expect(1, 92917, '\p{	IS_bassa_Vah}', "");
    Expect(0, 92917, '\p{^	IS_bassa_Vah}', "");
    Expect(0, 92917, '\P{	IS_bassa_Vah}', "");
    Expect(1, 92917, '\P{^	IS_bassa_Vah}', "");
    Expect(0, 92918, '\p{	IS_bassa_Vah}', "");
    Expect(1, 92918, '\p{^	IS_bassa_Vah}', "");
    Expect(1, 92918, '\P{	IS_bassa_Vah}', "");
    Expect(0, 92918, '\P{^	IS_bassa_Vah}', "");
    Error('\p{/a/	-Bass}');
    Error('\P{/a/	-Bass}');
    Expect(1, 92917, '\p{bass}', "");
    Expect(0, 92917, '\p{^bass}', "");
    Expect(0, 92917, '\P{bass}', "");
    Expect(1, 92917, '\P{^bass}', "");
    Expect(0, 92918, '\p{bass}', "");
    Expect(1, 92918, '\p{^bass}', "");
    Expect(1, 92918, '\P{bass}', "");
    Expect(0, 92918, '\P{^bass}', "");
    Expect(1, 92917, '\p{	_Bass}', "");
    Expect(0, 92917, '\p{^	_Bass}', "");
    Expect(0, 92917, '\P{	_Bass}', "");
    Expect(1, 92917, '\P{^	_Bass}', "");
    Expect(0, 92918, '\p{	_Bass}', "");
    Expect(1, 92918, '\p{^	_Bass}', "");
    Expect(1, 92918, '\P{	_Bass}', "");
    Expect(0, 92918, '\P{^	_Bass}', "");
    Error('\p{-/a/Is_BASS}');
    Error('\P{-/a/Is_BASS}');
    Expect(1, 92917, '\p{isbass}', "");
    Expect(0, 92917, '\p{^isbass}', "");
    Expect(0, 92917, '\P{isbass}', "");
    Expect(1, 92917, '\P{^isbass}', "");
    Expect(0, 92918, '\p{isbass}', "");
    Expect(1, 92918, '\p{^isbass}', "");
    Expect(1, 92918, '\P{isbass}', "");
    Expect(0, 92918, '\P{^isbass}', "");
    Expect(1, 92917, '\p{_ Is_bass}', "");
    Expect(0, 92917, '\p{^_ Is_bass}', "");
    Expect(0, 92917, '\P{_ Is_bass}', "");
    Expect(1, 92917, '\P{^_ Is_bass}', "");
    Expect(0, 92918, '\p{_ Is_bass}', "");
    Expect(1, 92918, '\p{^_ Is_bass}', "");
    Expect(1, 92918, '\P{_ Is_bass}', "");
    Expect(0, 92918, '\P{^_ Is_bass}', "");
    Error('\p{/a/		BATAK}');
    Error('\P{/a/		BATAK}');
    Expect(1, 7167, '\p{batak}', "");
    Expect(0, 7167, '\p{^batak}', "");
    Expect(0, 7167, '\P{batak}', "");
    Expect(1, 7167, '\P{^batak}', "");
    Expect(0, 7168, '\p{batak}', "");
    Expect(1, 7168, '\p{^batak}', "");
    Expect(1, 7168, '\P{batak}', "");
    Expect(0, 7168, '\P{^batak}', "");
    Expect(1, 7167, '\p{ Batak}', "");
    Expect(0, 7167, '\p{^ Batak}', "");
    Expect(0, 7167, '\P{ Batak}', "");
    Expect(1, 7167, '\P{^ Batak}', "");
    Expect(0, 7168, '\p{ Batak}', "");
    Expect(1, 7168, '\p{^ Batak}', "");
    Expect(1, 7168, '\P{ Batak}', "");
    Expect(0, 7168, '\P{^ Batak}', "");
    Error('\p{_Is_batak:=}');
    Error('\P{_Is_batak:=}');
    Expect(1, 7167, '\p{isbatak}', "");
    Expect(0, 7167, '\p{^isbatak}', "");
    Expect(0, 7167, '\P{isbatak}', "");
    Expect(1, 7167, '\P{^isbatak}', "");
    Expect(0, 7168, '\p{isbatak}', "");
    Expect(1, 7168, '\p{^isbatak}', "");
    Expect(1, 7168, '\P{isbatak}', "");
    Expect(0, 7168, '\P{^isbatak}', "");
    Expect(1, 7167, '\p{- Is_BATAK}', "");
    Expect(0, 7167, '\p{^- Is_BATAK}', "");
    Expect(0, 7167, '\P{- Is_BATAK}', "");
    Expect(1, 7167, '\P{^- Is_BATAK}', "");
    Expect(0, 7168, '\p{- Is_BATAK}', "");
    Expect(1, 7168, '\p{^- Is_BATAK}', "");
    Expect(1, 7168, '\P{- Is_BATAK}', "");
    Expect(0, 7168, '\P{^- Is_BATAK}', "");
    Error('\p{_:=BATK}');
    Error('\P{_:=BATK}');
    Expect(1, 7167, '\p{batk}', "");
    Expect(0, 7167, '\p{^batk}', "");
    Expect(0, 7167, '\P{batk}', "");
    Expect(1, 7167, '\P{^batk}', "");
    Expect(0, 7168, '\p{batk}', "");
    Expect(1, 7168, '\p{^batk}', "");
    Expect(1, 7168, '\P{batk}', "");
    Expect(0, 7168, '\P{^batk}', "");
    Expect(1, 7167, '\p{		Batk}', "");
    Expect(0, 7167, '\p{^		Batk}', "");
    Expect(0, 7167, '\P{		Batk}', "");
    Expect(1, 7167, '\P{^		Batk}', "");
    Expect(0, 7168, '\p{		Batk}', "");
    Expect(1, 7168, '\p{^		Batk}', "");
    Expect(1, 7168, '\P{		Batk}', "");
    Expect(0, 7168, '\P{^		Batk}', "");
    Error('\p{	/a/Is_Batk}');
    Error('\P{	/a/Is_Batk}');
    Expect(1, 7167, '\p{isbatk}', "");
    Expect(0, 7167, '\p{^isbatk}', "");
    Expect(0, 7167, '\P{isbatk}', "");
    Expect(1, 7167, '\P{^isbatk}', "");
    Expect(0, 7168, '\p{isbatk}', "");
    Expect(1, 7168, '\p{^isbatk}', "");
    Expect(1, 7168, '\P{isbatk}', "");
    Expect(0, 7168, '\P{^isbatk}', "");
    Expect(1, 7167, '\p{- IS_Batk}', "");
    Expect(0, 7167, '\p{^- IS_Batk}', "");
    Expect(0, 7167, '\P{- IS_Batk}', "");
    Expect(1, 7167, '\P{^- IS_Batk}', "");
    Expect(0, 7168, '\p{- IS_Batk}', "");
    Expect(1, 7168, '\p{^- IS_Batk}', "");
    Expect(1, 7168, '\P{- IS_Batk}', "");
    Expect(0, 7168, '\P{^- IS_Batk}', "");
    Error('\p{/a/__Bengali}');
    Error('\P{/a/__Bengali}');
    Expect(1, 43249, '\p{bengali}', "");
    Expect(0, 43249, '\p{^bengali}', "");
    Expect(0, 43249, '\P{bengali}', "");
    Expect(1, 43249, '\P{^bengali}', "");
    Expect(0, 43250, '\p{bengali}', "");
    Expect(1, 43250, '\p{^bengali}', "");
    Expect(1, 43250, '\P{bengali}', "");
    Expect(0, 43250, '\P{^bengali}', "");
    Expect(1, 43249, '\p{ 	bengali}', "");
    Expect(0, 43249, '\p{^ 	bengali}', "");
    Expect(0, 43249, '\P{ 	bengali}', "");
    Expect(1, 43249, '\P{^ 	bengali}', "");
    Expect(0, 43250, '\p{ 	bengali}', "");
    Expect(1, 43250, '\p{^ 	bengali}', "");
    Expect(1, 43250, '\P{ 	bengali}', "");
    Expect(0, 43250, '\P{^ 	bengali}', "");
    Error('\p{:=	-is_BENGALI}');
    Error('\P{:=	-is_BENGALI}');
    Expect(1, 43249, '\p{isbengali}', "");
    Expect(0, 43249, '\p{^isbengali}', "");
    Expect(0, 43249, '\P{isbengali}', "");
    Expect(1, 43249, '\P{^isbengali}', "");
    Expect(0, 43250, '\p{isbengali}', "");
    Expect(1, 43250, '\p{^isbengali}', "");
    Expect(1, 43250, '\P{isbengali}', "");
    Expect(0, 43250, '\P{^isbengali}', "");
    Expect(1, 43249, '\p{_	IS_bengali}', "");
    Expect(0, 43249, '\p{^_	IS_bengali}', "");
    Expect(0, 43249, '\P{_	IS_bengali}', "");
    Expect(1, 43249, '\P{^_	IS_bengali}', "");
    Expect(0, 43250, '\p{_	IS_bengali}', "");
    Expect(1, 43250, '\p{^_	IS_bengali}', "");
    Expect(1, 43250, '\P{_	IS_bengali}', "");
    Expect(0, 43250, '\P{^_	IS_bengali}', "");
    Error('\p{:=-	Beng}');
    Error('\P{:=-	Beng}');
    Expect(1, 43249, '\p{beng}', "");
    Expect(0, 43249, '\p{^beng}', "");
    Expect(0, 43249, '\P{beng}', "");
    Expect(1, 43249, '\P{^beng}', "");
    Expect(0, 43250, '\p{beng}', "");
    Expect(1, 43250, '\p{^beng}', "");
    Expect(1, 43250, '\P{beng}', "");
    Expect(0, 43250, '\P{^beng}', "");
    Expect(1, 43249, '\p{	Beng}', "");
    Expect(0, 43249, '\p{^	Beng}', "");
    Expect(0, 43249, '\P{	Beng}', "");
    Expect(1, 43249, '\P{^	Beng}', "");
    Expect(0, 43250, '\p{	Beng}', "");
    Expect(1, 43250, '\p{^	Beng}', "");
    Expect(1, 43250, '\P{	Beng}', "");
    Expect(0, 43250, '\P{^	Beng}', "");
    Error('\p{/a/ Is_Beng}');
    Error('\P{/a/ Is_Beng}');
    Expect(1, 43249, '\p{isbeng}', "");
    Expect(0, 43249, '\p{^isbeng}', "");
    Expect(0, 43249, '\P{isbeng}', "");
    Expect(1, 43249, '\P{^isbeng}', "");
    Expect(0, 43250, '\p{isbeng}', "");
    Expect(1, 43250, '\p{^isbeng}', "");
    Expect(1, 43250, '\P{isbeng}', "");
    Expect(0, 43250, '\P{^isbeng}', "");
    Expect(1, 43249, '\p{_	Is_beng}', "");
    Expect(0, 43249, '\p{^_	Is_beng}', "");
    Expect(0, 43249, '\P{_	Is_beng}', "");
    Expect(1, 43249, '\P{^_	Is_beng}', "");
    Expect(0, 43250, '\p{_	Is_beng}', "");
    Expect(1, 43250, '\p{^_	Is_beng}', "");
    Expect(1, 43250, '\P{_	Is_beng}', "");
    Expect(0, 43250, '\P{^_	Is_beng}', "");
    Error('\p{:=BHAIKSUKI}');
    Error('\P{:=BHAIKSUKI}');
    Expect(1, 72812, '\p{bhaiksuki}', "");
    Expect(0, 72812, '\p{^bhaiksuki}', "");
    Expect(0, 72812, '\P{bhaiksuki}', "");
    Expect(1, 72812, '\P{^bhaiksuki}', "");
    Expect(0, 72813, '\p{bhaiksuki}', "");
    Expect(1, 72813, '\p{^bhaiksuki}', "");
    Expect(1, 72813, '\P{bhaiksuki}', "");
    Expect(0, 72813, '\P{^bhaiksuki}', "");
    Expect(1, 72812, '\p{	-BHAIKSUKI}', "");
    Expect(0, 72812, '\p{^	-BHAIKSUKI}', "");
    Expect(0, 72812, '\P{	-BHAIKSUKI}', "");
    Expect(1, 72812, '\P{^	-BHAIKSUKI}', "");
    Expect(0, 72813, '\p{	-BHAIKSUKI}', "");
    Expect(1, 72813, '\p{^	-BHAIKSUKI}', "");
    Expect(1, 72813, '\P{	-BHAIKSUKI}', "");
    Expect(0, 72813, '\P{^	-BHAIKSUKI}', "");
    Error('\p{/a/ Is_BHAIKSUKI}');
    Error('\P{/a/ Is_BHAIKSUKI}');
    Expect(1, 72812, '\p{isbhaiksuki}', "");
    Expect(0, 72812, '\p{^isbhaiksuki}', "");
    Expect(0, 72812, '\P{isbhaiksuki}', "");
    Expect(1, 72812, '\P{^isbhaiksuki}', "");
    Expect(0, 72813, '\p{isbhaiksuki}', "");
    Expect(1, 72813, '\p{^isbhaiksuki}', "");
    Expect(1, 72813, '\P{isbhaiksuki}', "");
    Expect(0, 72813, '\P{^isbhaiksuki}', "");
    Expect(1, 72812, '\p{ 	Is_Bhaiksuki}', "");
    Expect(0, 72812, '\p{^ 	Is_Bhaiksuki}', "");
    Expect(0, 72812, '\P{ 	Is_Bhaiksuki}', "");
    Expect(1, 72812, '\P{^ 	Is_Bhaiksuki}', "");
    Expect(0, 72813, '\p{ 	Is_Bhaiksuki}', "");
    Expect(1, 72813, '\p{^ 	Is_Bhaiksuki}', "");
    Expect(1, 72813, '\P{ 	Is_Bhaiksuki}', "");
    Expect(0, 72813, '\P{^ 	Is_Bhaiksuki}', "");
    Error('\p{- bhks:=}');
    Error('\P{- bhks:=}');
    Expect(1, 72812, '\p{bhks}', "");
    Expect(0, 72812, '\p{^bhks}', "");
    Expect(0, 72812, '\P{bhks}', "");
    Expect(1, 72812, '\P{^bhks}', "");
    Expect(0, 72813, '\p{bhks}', "");
    Expect(1, 72813, '\p{^bhks}', "");
    Expect(1, 72813, '\P{bhks}', "");
    Expect(0, 72813, '\P{^bhks}', "");
    Expect(1, 72812, '\p{ BHKS}', "");
    Expect(0, 72812, '\p{^ BHKS}', "");
    Expect(0, 72812, '\P{ BHKS}', "");
    Expect(1, 72812, '\P{^ BHKS}', "");
    Expect(0, 72813, '\p{ BHKS}', "");
    Expect(1, 72813, '\p{^ BHKS}', "");
    Expect(1, 72813, '\P{ BHKS}', "");
    Expect(0, 72813, '\P{^ BHKS}', "");
    Error('\p{ -Is_BHKS:=}');
    Error('\P{ -Is_BHKS:=}');
    Expect(1, 72812, '\p{isbhks}', "");
    Expect(0, 72812, '\p{^isbhks}', "");
    Expect(0, 72812, '\P{isbhks}', "");
    Expect(1, 72812, '\P{^isbhks}', "");
    Expect(0, 72813, '\p{isbhks}', "");
    Expect(1, 72813, '\p{^isbhks}', "");
    Expect(1, 72813, '\P{isbhks}', "");
    Expect(0, 72813, '\P{^isbhks}', "");
    Expect(1, 72812, '\p{-Is_Bhks}', "");
    Expect(0, 72812, '\p{^-Is_Bhks}', "");
    Expect(0, 72812, '\P{-Is_Bhks}', "");
    Expect(1, 72812, '\P{^-Is_Bhks}', "");
    Expect(0, 72813, '\p{-Is_Bhks}', "");
    Expect(1, 72813, '\p{^-Is_Bhks}', "");
    Expect(1, 72813, '\P{-Is_Bhks}', "");
    Expect(0, 72813, '\P{^-Is_Bhks}', "");
    Error('\p{:=		Bidi_Control}');
    Error('\P{:=		Bidi_Control}');
    Expect(1, 8297, '\p{bidicontrol}', "");
    Expect(0, 8297, '\p{^bidicontrol}', "");
    Expect(0, 8297, '\P{bidicontrol}', "");
    Expect(1, 8297, '\P{^bidicontrol}', "");
    Expect(0, 8298, '\p{bidicontrol}', "");
    Expect(1, 8298, '\p{^bidicontrol}', "");
    Expect(1, 8298, '\P{bidicontrol}', "");
    Expect(0, 8298, '\P{^bidicontrol}', "");
    Expect(1, 8297, '\p{-Bidi_Control}', "");
    Expect(0, 8297, '\p{^-Bidi_Control}', "");
    Expect(0, 8297, '\P{-Bidi_Control}', "");
    Expect(1, 8297, '\P{^-Bidi_Control}', "");
    Expect(0, 8298, '\p{-Bidi_Control}', "");
    Expect(1, 8298, '\p{^-Bidi_Control}', "");
    Expect(1, 8298, '\P{-Bidi_Control}', "");
    Expect(0, 8298, '\P{^-Bidi_Control}', "");
    Error('\p{:=- Is_BIDI_control}');
    Error('\P{:=- Is_BIDI_control}');
    Expect(1, 8297, '\p{isbidicontrol}', "");
    Expect(0, 8297, '\p{^isbidicontrol}', "");
    Expect(0, 8297, '\P{isbidicontrol}', "");
    Expect(1, 8297, '\P{^isbidicontrol}', "");
    Expect(0, 8298, '\p{isbidicontrol}', "");
    Expect(1, 8298, '\p{^isbidicontrol}', "");
    Expect(1, 8298, '\P{isbidicontrol}', "");
    Expect(0, 8298, '\P{^isbidicontrol}', "");
    Expect(1, 8297, '\p{- IS_BIDI_control}', "");
    Expect(0, 8297, '\p{^- IS_BIDI_control}', "");
    Expect(0, 8297, '\P{- IS_BIDI_control}', "");
    Expect(1, 8297, '\P{^- IS_BIDI_control}', "");
    Expect(0, 8298, '\p{- IS_BIDI_control}', "");
    Expect(1, 8298, '\p{^- IS_BIDI_control}', "");
    Expect(1, 8298, '\P{- IS_BIDI_control}', "");
    Expect(0, 8298, '\P{^- IS_BIDI_control}', "");
    Error('\p{:=_	BIDI_C}');
    Error('\P{:=_	BIDI_C}');
    Expect(1, 8297, '\p{bidic}', "");
    Expect(0, 8297, '\p{^bidic}', "");
    Expect(0, 8297, '\P{bidic}', "");
    Expect(1, 8297, '\P{^bidic}', "");
    Expect(0, 8298, '\p{bidic}', "");
    Expect(1, 8298, '\p{^bidic}', "");
    Expect(1, 8298, '\P{bidic}', "");
    Expect(0, 8298, '\P{^bidic}', "");
    Expect(1, 8297, '\p{--Bidi_C}', "");
    Expect(0, 8297, '\p{^--Bidi_C}', "");
    Expect(0, 8297, '\P{--Bidi_C}', "");
    Expect(1, 8297, '\P{^--Bidi_C}', "");
    Expect(0, 8298, '\p{--Bidi_C}', "");
    Expect(1, 8298, '\p{^--Bidi_C}', "");
    Expect(1, 8298, '\P{--Bidi_C}', "");
    Expect(0, 8298, '\P{^--Bidi_C}', "");
    Error('\p{:=	_IS_Bidi_C}');
    Error('\P{:=	_IS_Bidi_C}');
    Expect(1, 8297, '\p{isbidic}', "");
    Expect(0, 8297, '\p{^isbidic}', "");
    Expect(0, 8297, '\P{isbidic}', "");
    Expect(1, 8297, '\P{^isbidic}', "");
    Expect(0, 8298, '\p{isbidic}', "");
    Expect(1, 8298, '\p{^isbidic}', "");
    Expect(1, 8298, '\P{isbidic}', "");
    Expect(0, 8298, '\P{^isbidic}', "");
    Expect(1, 8297, '\p{		is_bidi_C}', "");
    Expect(0, 8297, '\p{^		is_bidi_C}', "");
    Expect(0, 8297, '\P{		is_bidi_C}', "");
    Expect(1, 8297, '\P{^		is_bidi_C}', "");
    Expect(0, 8298, '\p{		is_bidi_C}', "");
    Expect(1, 8298, '\p{^		is_bidi_C}', "");
    Expect(1, 8298, '\P{		is_bidi_C}', "");
    Expect(0, 8298, '\P{^		is_bidi_C}', "");
    Error('\p{:=  Bidi_Mirrored}');
    Error('\P{:=  Bidi_Mirrored}');
    Expect(1, 120771, '\p{bidimirrored}', "");
    Expect(0, 120771, '\p{^bidimirrored}', "");
    Expect(0, 120771, '\P{bidimirrored}', "");
    Expect(1, 120771, '\P{^bidimirrored}', "");
    Expect(0, 120772, '\p{bidimirrored}', "");
    Expect(1, 120772, '\p{^bidimirrored}', "");
    Expect(1, 120772, '\P{bidimirrored}', "");
    Expect(0, 120772, '\P{^bidimirrored}', "");
    Expect(1, 120771, '\p{-_Bidi_mirrored}', "");
    Expect(0, 120771, '\p{^-_Bidi_mirrored}', "");
    Expect(0, 120771, '\P{-_Bidi_mirrored}', "");
    Expect(1, 120771, '\P{^-_Bidi_mirrored}', "");
    Expect(0, 120772, '\p{-_Bidi_mirrored}', "");
    Expect(1, 120772, '\p{^-_Bidi_mirrored}', "");
    Expect(1, 120772, '\P{-_Bidi_mirrored}', "");
    Expect(0, 120772, '\P{^-_Bidi_mirrored}', "");
    Error('\p{_/a/Is_BIDI_Mirrored}');
    Error('\P{_/a/Is_BIDI_Mirrored}');
    Expect(1, 120771, '\p{isbidimirrored}', "");
    Expect(0, 120771, '\p{^isbidimirrored}', "");
    Expect(0, 120771, '\P{isbidimirrored}', "");
    Expect(1, 120771, '\P{^isbidimirrored}', "");
    Expect(0, 120772, '\p{isbidimirrored}', "");
    Expect(1, 120772, '\p{^isbidimirrored}', "");
    Expect(1, 120772, '\P{isbidimirrored}', "");
    Expect(0, 120772, '\P{^isbidimirrored}', "");
    Expect(1, 120771, '\p{ 	Is_Bidi_MIRRORED}', "");
    Expect(0, 120771, '\p{^ 	Is_Bidi_MIRRORED}', "");
    Expect(0, 120771, '\P{ 	Is_Bidi_MIRRORED}', "");
    Expect(1, 120771, '\P{^ 	Is_Bidi_MIRRORED}', "");
    Expect(0, 120772, '\p{ 	Is_Bidi_MIRRORED}', "");
    Expect(1, 120772, '\p{^ 	Is_Bidi_MIRRORED}', "");
    Expect(1, 120772, '\P{ 	Is_Bidi_MIRRORED}', "");
    Expect(0, 120772, '\P{^ 	Is_Bidi_MIRRORED}', "");
    Error('\p{-BIDI_M:=}');
    Error('\P{-BIDI_M:=}');
    Expect(1, 120771, '\p{bidim}', "");
    Expect(0, 120771, '\p{^bidim}', "");
    Expect(0, 120771, '\P{bidim}', "");
    Expect(1, 120771, '\P{^bidim}', "");
    Expect(0, 120772, '\p{bidim}', "");
    Expect(1, 120772, '\p{^bidim}', "");
    Expect(1, 120772, '\P{bidim}', "");
    Expect(0, 120772, '\P{^bidim}', "");
    Expect(1, 120771, '\p{	_bidi_M}', "");
    Expect(0, 120771, '\p{^	_bidi_M}', "");
    Expect(0, 120771, '\P{	_bidi_M}', "");
    Expect(1, 120771, '\P{^	_bidi_M}', "");
    Expect(0, 120772, '\p{	_bidi_M}', "");
    Expect(1, 120772, '\p{^	_bidi_M}', "");
    Expect(1, 120772, '\P{	_bidi_M}', "");
    Expect(0, 120772, '\P{^	_bidi_M}', "");
    Error('\p{:=		Is_bidi_M}');
    Error('\P{:=		Is_bidi_M}');
    Expect(1, 120771, '\p{isbidim}', "");
    Expect(0, 120771, '\p{^isbidim}', "");
    Expect(0, 120771, '\P{isbidim}', "");
    Expect(1, 120771, '\P{^isbidim}', "");
    Expect(0, 120772, '\p{isbidim}', "");
    Expect(1, 120772, '\p{^isbidim}', "");
    Expect(1, 120772, '\P{isbidim}', "");
    Expect(0, 120772, '\P{^isbidim}', "");
    Expect(1, 120771, '\p{		Is_Bidi_M}', "");
    Expect(0, 120771, '\p{^		Is_Bidi_M}', "");
    Expect(0, 120771, '\P{		Is_Bidi_M}', "");
    Expect(1, 120771, '\P{^		Is_Bidi_M}', "");
    Expect(0, 120772, '\p{		Is_Bidi_M}', "");
    Expect(1, 120772, '\p{^		Is_Bidi_M}', "");
    Expect(1, 120772, '\P{		Is_Bidi_M}', "");
    Expect(0, 120772, '\P{^		Is_Bidi_M}', "");
    Error('\p{-XPosixBlank/a/}');
    Error('\P{-XPosixBlank/a/}');
    Expect(1, 12288, '\p{xposixblank}', "");
    Expect(0, 12288, '\p{^xposixblank}', "");
    Expect(0, 12288, '\P{xposixblank}', "");
    Expect(1, 12288, '\P{^xposixblank}', "");
    Expect(0, 12289, '\p{xposixblank}', "");
    Expect(1, 12289, '\p{^xposixblank}', "");
    Expect(1, 12289, '\P{xposixblank}', "");
    Expect(0, 12289, '\P{^xposixblank}', "");
    Expect(1, 12288, '\p{	 XPOSIXBLANK}', "");
    Expect(0, 12288, '\p{^	 XPOSIXBLANK}', "");
    Expect(0, 12288, '\P{	 XPOSIXBLANK}', "");
    Expect(1, 12288, '\P{^	 XPOSIXBLANK}', "");
    Expect(0, 12289, '\p{	 XPOSIXBLANK}', "");
    Expect(1, 12289, '\p{^	 XPOSIXBLANK}', "");
    Expect(1, 12289, '\P{	 XPOSIXBLANK}', "");
    Expect(0, 12289, '\P{^	 XPOSIXBLANK}', "");
    Error('\p{-_Blank:=}');
    Error('\P{-_Blank:=}');
    Expect(1, 12288, '\p{blank}', "");
    Expect(0, 12288, '\p{^blank}', "");
    Expect(0, 12288, '\P{blank}', "");
    Expect(1, 12288, '\P{^blank}', "");
    Expect(0, 12289, '\p{blank}', "");
    Expect(1, 12289, '\p{^blank}', "");
    Expect(1, 12289, '\P{blank}', "");
    Expect(0, 12289, '\P{^blank}', "");
    Expect(1, 12288, '\p{	blank}', "");
    Expect(0, 12288, '\p{^	blank}', "");
    Expect(0, 12288, '\P{	blank}', "");
    Expect(1, 12288, '\P{^	blank}', "");
    Expect(0, 12289, '\p{	blank}', "");
    Expect(1, 12289, '\p{^	blank}', "");
    Expect(1, 12289, '\P{	blank}', "");
    Expect(0, 12289, '\P{^	blank}', "");
    Error('\p{:=-HorizSpace}');
    Error('\P{:=-HorizSpace}');
    Expect(1, 12288, '\p{horizspace}', "");
    Expect(0, 12288, '\p{^horizspace}', "");
    Expect(0, 12288, '\P{horizspace}', "");
    Expect(1, 12288, '\P{^horizspace}', "");
    Expect(0, 12289, '\p{horizspace}', "");
    Expect(1, 12289, '\p{^horizspace}', "");
    Expect(1, 12289, '\P{horizspace}', "");
    Expect(0, 12289, '\P{^horizspace}', "");
    Expect(1, 12288, '\p{	 HORIZSPACE}', "");
    Expect(0, 12288, '\p{^	 HORIZSPACE}', "");
    Expect(0, 12288, '\P{	 HORIZSPACE}', "");
    Expect(1, 12288, '\P{^	 HORIZSPACE}', "");
    Expect(0, 12289, '\p{	 HORIZSPACE}', "");
    Expect(1, 12289, '\p{^	 HORIZSPACE}', "");
    Expect(1, 12289, '\P{	 HORIZSPACE}', "");
    Expect(0, 12289, '\P{^	 HORIZSPACE}', "");
    Error('\p{-_Is_XPOSIXBLANK/a/}');
    Error('\P{-_Is_XPOSIXBLANK/a/}');
    Expect(1, 12288, '\p{isxposixblank}', "");
    Expect(0, 12288, '\p{^isxposixblank}', "");
    Expect(0, 12288, '\P{isxposixblank}', "");
    Expect(1, 12288, '\P{^isxposixblank}', "");
    Expect(0, 12289, '\p{isxposixblank}', "");
    Expect(1, 12289, '\p{^isxposixblank}', "");
    Expect(1, 12289, '\P{isxposixblank}', "");
    Expect(0, 12289, '\P{^isxposixblank}', "");
    Expect(1, 12288, '\p{_-IS_XPOSIXBLANK}', "");
    Expect(0, 12288, '\p{^_-IS_XPOSIXBLANK}', "");
    Expect(0, 12288, '\P{_-IS_XPOSIXBLANK}', "");
    Expect(1, 12288, '\P{^_-IS_XPOSIXBLANK}', "");
    Expect(0, 12289, '\p{_-IS_XPOSIXBLANK}', "");
    Expect(1, 12289, '\p{^_-IS_XPOSIXBLANK}', "");
    Expect(1, 12289, '\P{_-IS_XPOSIXBLANK}', "");
    Expect(0, 12289, '\P{^_-IS_XPOSIXBLANK}', "");
    Error('\p{ IS_blank:=}');
    Error('\P{ IS_blank:=}');
    Expect(1, 12288, '\p{isblank}', "");
    Expect(0, 12288, '\p{^isblank}', "");
    Expect(0, 12288, '\P{isblank}', "");
    Expect(1, 12288, '\P{^isblank}', "");
    Expect(0, 12289, '\p{isblank}', "");
    Expect(1, 12289, '\p{^isblank}', "");
    Expect(1, 12289, '\P{isblank}', "");
    Expect(0, 12289, '\P{^isblank}', "");
    Expect(1, 12288, '\p{-is_BLANK}', "");
    Expect(0, 12288, '\p{^-is_BLANK}', "");
    Expect(0, 12288, '\P{-is_BLANK}', "");
    Expect(1, 12288, '\P{^-is_BLANK}', "");
    Expect(0, 12289, '\p{-is_BLANK}', "");
    Expect(1, 12289, '\p{^-is_BLANK}', "");
    Expect(1, 12289, '\P{-is_BLANK}', "");
    Expect(0, 12289, '\P{^-is_BLANK}', "");
    Error('\p{/a/_Is_horizspace}');
    Error('\P{/a/_Is_horizspace}');
    Expect(1, 12288, '\p{ishorizspace}', "");
    Expect(0, 12288, '\p{^ishorizspace}', "");
    Expect(0, 12288, '\P{ishorizspace}', "");
    Expect(1, 12288, '\P{^ishorizspace}', "");
    Expect(0, 12289, '\p{ishorizspace}', "");
    Expect(1, 12289, '\p{^ishorizspace}', "");
    Expect(1, 12289, '\P{ishorizspace}', "");
    Expect(0, 12289, '\P{^ishorizspace}', "");
    Expect(1, 12288, '\p{ _Is_HorizSpace}', "");
    Expect(0, 12288, '\p{^ _Is_HorizSpace}', "");
    Expect(0, 12288, '\P{ _Is_HorizSpace}', "");
    Expect(1, 12288, '\P{^ _Is_HorizSpace}', "");
    Expect(0, 12289, '\p{ _Is_HorizSpace}', "");
    Expect(1, 12289, '\p{^ _Is_HorizSpace}', "");
    Expect(1, 12289, '\P{ _Is_HorizSpace}', "");
    Expect(0, 12289, '\P{^ _Is_HorizSpace}', "");
    Error('\p{ /a/Block_Elements}');
    Error('\P{ /a/Block_Elements}');
    Expect(1, 9631, '\p{blockelements}', "");
    Expect(0, 9631, '\p{^blockelements}', "");
    Expect(0, 9631, '\P{blockelements}', "");
    Expect(1, 9631, '\P{^blockelements}', "");
    Expect(0, 9632, '\p{blockelements}', "");
    Expect(1, 9632, '\p{^blockelements}', "");
    Expect(1, 9632, '\P{blockelements}', "");
    Expect(0, 9632, '\P{^blockelements}', "");
    Expect(1, 9631, '\p{	 Block_Elements}', "");
    Expect(0, 9631, '\p{^	 Block_Elements}', "");
    Expect(0, 9631, '\P{	 Block_Elements}', "");
    Expect(1, 9631, '\P{^	 Block_Elements}', "");
    Expect(0, 9632, '\p{	 Block_Elements}', "");
    Expect(1, 9632, '\p{^	 Block_Elements}', "");
    Expect(1, 9632, '\P{	 Block_Elements}', "");
    Expect(0, 9632, '\P{^	 Block_Elements}', "");
    Error('\p{  IS_block_Elements/a/}');
    Error('\P{  IS_block_Elements/a/}');
    Expect(1, 9631, '\p{isblockelements}', "");
    Expect(0, 9631, '\p{^isblockelements}', "");
    Expect(0, 9631, '\P{isblockelements}', "");
    Expect(1, 9631, '\P{^isblockelements}', "");
    Expect(0, 9632, '\p{isblockelements}', "");
    Expect(1, 9632, '\p{^isblockelements}', "");
    Expect(1, 9632, '\P{isblockelements}', "");
    Expect(0, 9632, '\P{^isblockelements}', "");
    Expect(1, 9631, '\p{ is_Block_Elements}', "");
    Expect(0, 9631, '\p{^ is_Block_Elements}', "");
    Expect(0, 9631, '\P{ is_Block_Elements}', "");
    Expect(1, 9631, '\P{^ is_Block_Elements}', "");
    Expect(0, 9632, '\p{ is_Block_Elements}', "");
    Expect(1, 9632, '\p{^ is_Block_Elements}', "");
    Expect(1, 9632, '\P{ is_Block_Elements}', "");
    Expect(0, 9632, '\P{^ is_Block_Elements}', "");
    Error('\p{ IN_Block_elements/a/}');
    Error('\P{ IN_Block_elements/a/}');
    Expect(1, 9631, '\p{inblockelements}', "");
    Expect(0, 9631, '\p{^inblockelements}', "");
    Expect(0, 9631, '\P{inblockelements}', "");
    Expect(1, 9631, '\P{^inblockelements}', "");
    Expect(0, 9632, '\p{inblockelements}', "");
    Expect(1, 9632, '\p{^inblockelements}', "");
    Expect(1, 9632, '\P{inblockelements}', "");
    Expect(0, 9632, '\P{^inblockelements}', "");
    Expect(1, 9631, '\p{ In_BLOCK_Elements}', "");
    Expect(0, 9631, '\p{^ In_BLOCK_Elements}', "");
    Expect(0, 9631, '\P{ In_BLOCK_Elements}', "");
    Expect(1, 9631, '\P{^ In_BLOCK_Elements}', "");
    Expect(0, 9632, '\p{ In_BLOCK_Elements}', "");
    Expect(1, 9632, '\p{^ In_BLOCK_Elements}', "");
    Expect(1, 9632, '\P{ In_BLOCK_Elements}', "");
    Expect(0, 9632, '\P{^ In_BLOCK_Elements}', "");
    Error('\p{ bopomofo/a/}');
    Error('\P{ bopomofo/a/}');
    Expect(1, 65381, '\p{bopomofo}', "");
    Expect(0, 65381, '\p{^bopomofo}', "");
    Expect(0, 65381, '\P{bopomofo}', "");
    Expect(1, 65381, '\P{^bopomofo}', "");
    Expect(0, 65382, '\p{bopomofo}', "");
    Expect(1, 65382, '\p{^bopomofo}', "");
    Expect(1, 65382, '\P{bopomofo}', "");
    Expect(0, 65382, '\P{^bopomofo}', "");
    Expect(1, 65381, '\p{ 	Bopomofo}', "");
    Expect(0, 65381, '\p{^ 	Bopomofo}', "");
    Expect(0, 65381, '\P{ 	Bopomofo}', "");
    Expect(1, 65381, '\P{^ 	Bopomofo}', "");
    Expect(0, 65382, '\p{ 	Bopomofo}', "");
    Expect(1, 65382, '\p{^ 	Bopomofo}', "");
    Expect(1, 65382, '\P{ 	Bopomofo}', "");
    Expect(0, 65382, '\P{^ 	Bopomofo}', "");
    Error('\p{_:=Is_Bopomofo}');
    Error('\P{_:=Is_Bopomofo}');
    Expect(1, 65381, '\p{isbopomofo}', "");
    Expect(0, 65381, '\p{^isbopomofo}', "");
    Expect(0, 65381, '\P{isbopomofo}', "");
    Expect(1, 65381, '\P{^isbopomofo}', "");
    Expect(0, 65382, '\p{isbopomofo}', "");
    Expect(1, 65382, '\p{^isbopomofo}', "");
    Expect(1, 65382, '\P{isbopomofo}', "");
    Expect(0, 65382, '\P{^isbopomofo}', "");
    Expect(1, 65381, '\p{__is_bopomofo}', "");
    Expect(0, 65381, '\p{^__is_bopomofo}', "");
    Expect(0, 65381, '\P{__is_bopomofo}', "");
    Expect(1, 65381, '\P{^__is_bopomofo}', "");
    Expect(0, 65382, '\p{__is_bopomofo}', "");
    Expect(1, 65382, '\p{^__is_bopomofo}', "");
    Expect(1, 65382, '\P{__is_bopomofo}', "");
    Expect(0, 65382, '\P{^__is_bopomofo}', "");
    Error('\p{ Bopo/a/}');
    Error('\P{ Bopo/a/}');
    Expect(1, 65381, '\p{bopo}', "");
    Expect(0, 65381, '\p{^bopo}', "");
    Expect(0, 65381, '\P{bopo}', "");
    Expect(1, 65381, '\P{^bopo}', "");
    Expect(0, 65382, '\p{bopo}', "");
    Expect(1, 65382, '\p{^bopo}', "");
    Expect(1, 65382, '\P{bopo}', "");
    Expect(0, 65382, '\P{^bopo}', "");
    Expect(1, 65381, '\p{ Bopo}', "");
    Expect(0, 65381, '\p{^ Bopo}', "");
    Expect(0, 65381, '\P{ Bopo}', "");
    Expect(1, 65381, '\P{^ Bopo}', "");
    Expect(0, 65382, '\p{ Bopo}', "");
    Expect(1, 65382, '\p{^ Bopo}', "");
    Expect(1, 65382, '\P{ Bopo}', "");
    Expect(0, 65382, '\P{^ Bopo}', "");
    Error('\p{ :=Is_BOPO}');
    Error('\P{ :=Is_BOPO}');
    Expect(1, 65381, '\p{isbopo}', "");
    Expect(0, 65381, '\p{^isbopo}', "");
    Expect(0, 65381, '\P{isbopo}', "");
    Expect(1, 65381, '\P{^isbopo}', "");
    Expect(0, 65382, '\p{isbopo}', "");
    Expect(1, 65382, '\p{^isbopo}', "");
    Expect(1, 65382, '\P{isbopo}', "");
    Expect(0, 65382, '\P{^isbopo}', "");
    Expect(1, 65381, '\p{-_Is_Bopo}', "");
    Expect(0, 65381, '\p{^-_Is_Bopo}', "");
    Expect(0, 65381, '\P{-_Is_Bopo}', "");
    Expect(1, 65381, '\P{^-_Is_Bopo}', "");
    Expect(0, 65382, '\p{-_Is_Bopo}', "");
    Expect(1, 65382, '\p{^-_Is_Bopo}', "");
    Expect(1, 65382, '\P{-_Is_Bopo}', "");
    Expect(0, 65382, '\P{^-_Is_Bopo}', "");
    Error('\p{	/a/Bopomofo_EXTENDED}');
    Error('\P{	/a/Bopomofo_EXTENDED}');
    Expect(1, 12735, '\p{bopomofoextended}', "");
    Expect(0, 12735, '\p{^bopomofoextended}', "");
    Expect(0, 12735, '\P{bopomofoextended}', "");
    Expect(1, 12735, '\P{^bopomofoextended}', "");
    Expect(0, 12736, '\p{bopomofoextended}', "");
    Expect(1, 12736, '\p{^bopomofoextended}', "");
    Expect(1, 12736, '\P{bopomofoextended}', "");
    Expect(0, 12736, '\P{^bopomofoextended}', "");
    Expect(1, 12735, '\p{	 bopomofo_extended}', "");
    Expect(0, 12735, '\p{^	 bopomofo_extended}', "");
    Expect(0, 12735, '\P{	 bopomofo_extended}', "");
    Expect(1, 12735, '\P{^	 bopomofo_extended}', "");
    Expect(0, 12736, '\p{	 bopomofo_extended}', "");
    Expect(1, 12736, '\p{^	 bopomofo_extended}', "");
    Expect(1, 12736, '\P{	 bopomofo_extended}', "");
    Expect(0, 12736, '\P{^	 bopomofo_extended}', "");
    Error('\p{ /a/Is_Bopomofo_extended}');
    Error('\P{ /a/Is_Bopomofo_extended}');
    Expect(1, 12735, '\p{isbopomofoextended}', "");
    Expect(0, 12735, '\p{^isbopomofoextended}', "");
    Expect(0, 12735, '\P{isbopomofoextended}', "");
    Expect(1, 12735, '\P{^isbopomofoextended}', "");
    Expect(0, 12736, '\p{isbopomofoextended}', "");
    Expect(1, 12736, '\p{^isbopomofoextended}', "");
    Expect(1, 12736, '\P{isbopomofoextended}', "");
    Expect(0, 12736, '\P{^isbopomofoextended}', "");
    Expect(1, 12735, '\p{_-is_bopomofo_EXTENDED}', "");
    Expect(0, 12735, '\p{^_-is_bopomofo_EXTENDED}', "");
    Expect(0, 12735, '\P{_-is_bopomofo_EXTENDED}', "");
    Expect(1, 12735, '\P{^_-is_bopomofo_EXTENDED}', "");
    Expect(0, 12736, '\p{_-is_bopomofo_EXTENDED}', "");
    Expect(1, 12736, '\p{^_-is_bopomofo_EXTENDED}', "");
    Expect(1, 12736, '\P{_-is_bopomofo_EXTENDED}', "");
    Expect(0, 12736, '\P{^_-is_bopomofo_EXTENDED}', "");
    Error('\p{_IN_Bopomofo_EXTENDED:=}');
    Error('\P{_IN_Bopomofo_EXTENDED:=}');
    Expect(1, 12735, '\p{inbopomofoextended}', "");
    Expect(0, 12735, '\p{^inbopomofoextended}', "");
    Expect(0, 12735, '\P{inbopomofoextended}', "");
    Expect(1, 12735, '\P{^inbopomofoextended}', "");
    Expect(0, 12736, '\p{inbopomofoextended}', "");
    Expect(1, 12736, '\p{^inbopomofoextended}', "");
    Expect(1, 12736, '\P{inbopomofoextended}', "");
    Expect(0, 12736, '\P{^inbopomofoextended}', "");
    Expect(1, 12735, '\p{_In_Bopomofo_Extended}', "");
    Expect(0, 12735, '\p{^_In_Bopomofo_Extended}', "");
    Expect(0, 12735, '\P{_In_Bopomofo_Extended}', "");
    Expect(1, 12735, '\P{^_In_Bopomofo_Extended}', "");
    Expect(0, 12736, '\p{_In_Bopomofo_Extended}', "");
    Expect(1, 12736, '\p{^_In_Bopomofo_Extended}', "");
    Expect(1, 12736, '\P{_In_Bopomofo_Extended}', "");
    Expect(0, 12736, '\P{^_In_Bopomofo_Extended}', "");
    Error('\p{	:=bopomofo_Ext}');
    Error('\P{	:=bopomofo_Ext}');
    Expect(1, 12735, '\p{bopomofoext}', "");
    Expect(0, 12735, '\p{^bopomofoext}', "");
    Expect(0, 12735, '\P{bopomofoext}', "");
    Expect(1, 12735, '\P{^bopomofoext}', "");
    Expect(0, 12736, '\p{bopomofoext}', "");
    Expect(1, 12736, '\p{^bopomofoext}', "");
    Expect(1, 12736, '\P{bopomofoext}', "");
    Expect(0, 12736, '\P{^bopomofoext}', "");
    Expect(1, 12735, '\p{--Bopomofo_EXT}', "");
    Expect(0, 12735, '\p{^--Bopomofo_EXT}', "");
    Expect(0, 12735, '\P{--Bopomofo_EXT}', "");
    Expect(1, 12735, '\P{^--Bopomofo_EXT}', "");
    Expect(0, 12736, '\p{--Bopomofo_EXT}', "");
    Expect(1, 12736, '\p{^--Bopomofo_EXT}', "");
    Expect(1, 12736, '\P{--Bopomofo_EXT}', "");
    Expect(0, 12736, '\P{^--Bopomofo_EXT}', "");
    Error('\p{:=Is_bopomofo_EXT}');
    Error('\P{:=Is_bopomofo_EXT}');
    Expect(1, 12735, '\p{isbopomofoext}', "");
    Expect(0, 12735, '\p{^isbopomofoext}', "");
    Expect(0, 12735, '\P{isbopomofoext}', "");
    Expect(1, 12735, '\P{^isbopomofoext}', "");
    Expect(0, 12736, '\p{isbopomofoext}', "");
    Expect(1, 12736, '\p{^isbopomofoext}', "");
    Expect(1, 12736, '\P{isbopomofoext}', "");
    Expect(0, 12736, '\P{^isbopomofoext}', "");
    Expect(1, 12735, '\p{_ Is_Bopomofo_Ext}', "");
    Expect(0, 12735, '\p{^_ Is_Bopomofo_Ext}', "");
    Expect(0, 12735, '\P{_ Is_Bopomofo_Ext}', "");
    Expect(1, 12735, '\P{^_ Is_Bopomofo_Ext}', "");
    Expect(0, 12736, '\p{_ Is_Bopomofo_Ext}', "");
    Expect(1, 12736, '\p{^_ Is_Bopomofo_Ext}', "");
    Expect(1, 12736, '\P{_ Is_Bopomofo_Ext}', "");
    Expect(0, 12736, '\P{^_ Is_Bopomofo_Ext}', "");
    Error('\p{ :=In_bopomofo_EXT}');
    Error('\P{ :=In_bopomofo_EXT}');
    Expect(1, 12735, '\p{inbopomofoext}', "");
    Expect(0, 12735, '\p{^inbopomofoext}', "");
    Expect(0, 12735, '\P{inbopomofoext}', "");
    Expect(1, 12735, '\P{^inbopomofoext}', "");
    Expect(0, 12736, '\p{inbopomofoext}', "");
    Expect(1, 12736, '\p{^inbopomofoext}', "");
    Expect(1, 12736, '\P{inbopomofoext}', "");
    Expect(0, 12736, '\P{^inbopomofoext}', "");
    Expect(1, 12735, '\p{-in_BOPOMOFO_EXT}', "");
    Expect(0, 12735, '\p{^-in_BOPOMOFO_EXT}', "");
    Expect(0, 12735, '\P{-in_BOPOMOFO_EXT}', "");
    Expect(1, 12735, '\P{^-in_BOPOMOFO_EXT}', "");
    Expect(0, 12736, '\p{-in_BOPOMOFO_EXT}', "");
    Expect(1, 12736, '\p{^-in_BOPOMOFO_EXT}', "");
    Expect(1, 12736, '\P{-in_BOPOMOFO_EXT}', "");
    Expect(0, 12736, '\P{^-in_BOPOMOFO_EXT}', "");
    Error('\p{_-box_Drawing:=}');
    Error('\P{_-box_Drawing:=}');
    Expect(1, 9599, '\p{boxdrawing}', "");
    Expect(0, 9599, '\p{^boxdrawing}', "");
    Expect(0, 9599, '\P{boxdrawing}', "");
    Expect(1, 9599, '\P{^boxdrawing}', "");
    Expect(0, 9600, '\p{boxdrawing}', "");
    Expect(1, 9600, '\p{^boxdrawing}', "");
    Expect(1, 9600, '\P{boxdrawing}', "");
    Expect(0, 9600, '\P{^boxdrawing}', "");
    Expect(1, 9599, '\p{	 BOX_Drawing}', "");
    Expect(0, 9599, '\p{^	 BOX_Drawing}', "");
    Expect(0, 9599, '\P{	 BOX_Drawing}', "");
    Expect(1, 9599, '\P{^	 BOX_Drawing}', "");
    Expect(0, 9600, '\p{	 BOX_Drawing}', "");
    Expect(1, 9600, '\p{^	 BOX_Drawing}', "");
    Expect(1, 9600, '\P{	 BOX_Drawing}', "");
    Expect(0, 9600, '\P{^	 BOX_Drawing}', "");
    Error('\p{-_IS_Box_Drawing/a/}');
    Error('\P{-_IS_Box_Drawing/a/}');
    Expect(1, 9599, '\p{isboxdrawing}', "");
    Expect(0, 9599, '\p{^isboxdrawing}', "");
    Expect(0, 9599, '\P{isboxdrawing}', "");
    Expect(1, 9599, '\P{^isboxdrawing}', "");
    Expect(0, 9600, '\p{isboxdrawing}', "");
    Expect(1, 9600, '\p{^isboxdrawing}', "");
    Expect(1, 9600, '\P{isboxdrawing}', "");
    Expect(0, 9600, '\P{^isboxdrawing}', "");
    Expect(1, 9599, '\p{_is_BOX_Drawing}', "");
    Expect(0, 9599, '\p{^_is_BOX_Drawing}', "");
    Expect(0, 9599, '\P{_is_BOX_Drawing}', "");
    Expect(1, 9599, '\P{^_is_BOX_Drawing}', "");
    Expect(0, 9600, '\p{_is_BOX_Drawing}', "");
    Expect(1, 9600, '\p{^_is_BOX_Drawing}', "");
    Expect(1, 9600, '\P{_is_BOX_Drawing}', "");
    Expect(0, 9600, '\P{^_is_BOX_Drawing}', "");
    Error('\p{	IN_BOX_Drawing/a/}');
    Error('\P{	IN_BOX_Drawing/a/}');
    Expect(1, 9599, '\p{inboxdrawing}', "");
    Expect(0, 9599, '\p{^inboxdrawing}', "");
    Expect(0, 9599, '\P{inboxdrawing}', "");
    Expect(1, 9599, '\P{^inboxdrawing}', "");
    Expect(0, 9600, '\p{inboxdrawing}', "");
    Expect(1, 9600, '\p{^inboxdrawing}', "");
    Expect(1, 9600, '\P{inboxdrawing}', "");
    Expect(0, 9600, '\P{^inboxdrawing}', "");
    Expect(1, 9599, '\p{ -In_Box_DRAWING}', "");
    Expect(0, 9599, '\p{^ -In_Box_DRAWING}', "");
    Expect(0, 9599, '\P{ -In_Box_DRAWING}', "");
    Expect(1, 9599, '\P{^ -In_Box_DRAWING}', "");
    Expect(0, 9600, '\p{ -In_Box_DRAWING}', "");
    Expect(1, 9600, '\p{^ -In_Box_DRAWING}', "");
    Expect(1, 9600, '\P{ -In_Box_DRAWING}', "");
    Expect(0, 9600, '\P{^ -In_Box_DRAWING}', "");
    Error('\p{-/a/brahmi}');
    Error('\P{-/a/brahmi}');
    Expect(1, 69759, '\p{brahmi}', "");
    Expect(0, 69759, '\p{^brahmi}', "");
    Expect(0, 69759, '\P{brahmi}', "");
    Expect(1, 69759, '\P{^brahmi}', "");
    Expect(0, 69760, '\p{brahmi}', "");
    Expect(1, 69760, '\p{^brahmi}', "");
    Expect(1, 69760, '\P{brahmi}', "");
    Expect(0, 69760, '\P{^brahmi}', "");
    Expect(1, 69759, '\p{ 	brahmi}', "");
    Expect(0, 69759, '\p{^ 	brahmi}', "");
    Expect(0, 69759, '\P{ 	brahmi}', "");
    Expect(1, 69759, '\P{^ 	brahmi}', "");
    Expect(0, 69760, '\p{ 	brahmi}', "");
    Expect(1, 69760, '\p{^ 	brahmi}', "");
    Expect(1, 69760, '\P{ 	brahmi}', "");
    Expect(0, 69760, '\P{^ 	brahmi}', "");
    Error('\p{/a/_Is_brahmi}');
    Error('\P{/a/_Is_brahmi}');
    Expect(1, 69759, '\p{isbrahmi}', "");
    Expect(0, 69759, '\p{^isbrahmi}', "");
    Expect(0, 69759, '\P{isbrahmi}', "");
    Expect(1, 69759, '\P{^isbrahmi}', "");
    Expect(0, 69760, '\p{isbrahmi}', "");
    Expect(1, 69760, '\p{^isbrahmi}', "");
    Expect(1, 69760, '\P{isbrahmi}', "");
    Expect(0, 69760, '\P{^isbrahmi}', "");
    Expect(1, 69759, '\p{		IS_Brahmi}', "");
    Expect(0, 69759, '\p{^		IS_Brahmi}', "");
    Expect(0, 69759, '\P{		IS_Brahmi}', "");
    Expect(1, 69759, '\P{^		IS_Brahmi}', "");
    Expect(0, 69760, '\p{		IS_Brahmi}', "");
    Expect(1, 69760, '\p{^		IS_Brahmi}', "");
    Expect(1, 69760, '\P{		IS_Brahmi}', "");
    Expect(0, 69760, '\P{^		IS_Brahmi}', "");
    Error('\p{--BRAH/a/}');
    Error('\P{--BRAH/a/}');
    Expect(1, 69759, '\p{brah}', "");
    Expect(0, 69759, '\p{^brah}', "");
    Expect(0, 69759, '\P{brah}', "");
    Expect(1, 69759, '\P{^brah}', "");
    Expect(0, 69760, '\p{brah}', "");
    Expect(1, 69760, '\p{^brah}', "");
    Expect(1, 69760, '\P{brah}', "");
    Expect(0, 69760, '\P{^brah}', "");
    Expect(1, 69759, '\p{ BRAH}', "");
    Expect(0, 69759, '\p{^ BRAH}', "");
    Expect(0, 69759, '\P{ BRAH}', "");
    Expect(1, 69759, '\P{^ BRAH}', "");
    Expect(0, 69760, '\p{ BRAH}', "");
    Expect(1, 69760, '\p{^ BRAH}', "");
    Expect(1, 69760, '\P{ BRAH}', "");
    Expect(0, 69760, '\P{^ BRAH}', "");
    Error('\p{/a/_-Is_Brah}');
    Error('\P{/a/_-Is_Brah}');
    Expect(1, 69759, '\p{isbrah}', "");
    Expect(0, 69759, '\p{^isbrah}', "");
    Expect(0, 69759, '\P{isbrah}', "");
    Expect(1, 69759, '\P{^isbrah}', "");
    Expect(0, 69760, '\p{isbrah}', "");
    Expect(1, 69760, '\p{^isbrah}', "");
    Expect(1, 69760, '\P{isbrah}', "");
    Expect(0, 69760, '\P{^isbrah}', "");
    Expect(1, 69759, '\p{	Is_Brah}', "");
    Expect(0, 69759, '\p{^	Is_Brah}', "");
    Expect(0, 69759, '\P{	Is_Brah}', "");
    Expect(1, 69759, '\P{^	Is_Brah}', "");
    Expect(0, 69760, '\p{	Is_Brah}', "");
    Expect(1, 69760, '\p{^	Is_Brah}', "");
    Expect(1, 69760, '\P{	Is_Brah}', "");
    Expect(0, 69760, '\P{^	Is_Brah}', "");
    Error('\p{ :=Braille}');
    Error('\P{ :=Braille}');
    Expect(1, 10495, '\p{braille}', "");
    Expect(0, 10495, '\p{^braille}', "");
    Expect(0, 10495, '\P{braille}', "");
    Expect(1, 10495, '\P{^braille}', "");
    Expect(0, 10496, '\p{braille}', "");
    Expect(1, 10496, '\p{^braille}', "");
    Expect(1, 10496, '\P{braille}', "");
    Expect(0, 10496, '\P{^braille}', "");
    Expect(1, 10495, '\p{ _BRAILLE}', "");
    Expect(0, 10495, '\p{^ _BRAILLE}', "");
    Expect(0, 10495, '\P{ _BRAILLE}', "");
    Expect(1, 10495, '\P{^ _BRAILLE}', "");
    Expect(0, 10496, '\p{ _BRAILLE}', "");
    Expect(1, 10496, '\p{^ _BRAILLE}', "");
    Expect(1, 10496, '\P{ _BRAILLE}', "");
    Expect(0, 10496, '\P{^ _BRAILLE}', "");
    Error('\p{	Is_braille/a/}');
    Error('\P{	Is_braille/a/}');
    Expect(1, 10495, '\p{isbraille}', "");
    Expect(0, 10495, '\p{^isbraille}', "");
    Expect(0, 10495, '\P{isbraille}', "");
    Expect(1, 10495, '\P{^isbraille}', "");
    Expect(0, 10496, '\p{isbraille}', "");
    Expect(1, 10496, '\p{^isbraille}', "");
    Expect(1, 10496, '\P{isbraille}', "");
    Expect(0, 10496, '\P{^isbraille}', "");
    Expect(1, 10495, '\p{		is_Braille}', "");
    Expect(0, 10495, '\p{^		is_Braille}', "");
    Expect(0, 10495, '\P{		is_Braille}', "");
    Expect(1, 10495, '\P{^		is_Braille}', "");
    Expect(0, 10496, '\p{		is_Braille}', "");
    Expect(1, 10496, '\p{^		is_Braille}', "");
    Expect(1, 10496, '\P{		is_Braille}', "");
    Expect(0, 10496, '\P{^		is_Braille}', "");
    Error('\p{	 Brai/a/}');
    Error('\P{	 Brai/a/}');
    Expect(1, 10495, '\p{brai}', "");
    Expect(0, 10495, '\p{^brai}', "");
    Expect(0, 10495, '\P{brai}', "");
    Expect(1, 10495, '\P{^brai}', "");
    Expect(0, 10496, '\p{brai}', "");
    Expect(1, 10496, '\p{^brai}', "");
    Expect(1, 10496, '\P{brai}', "");
    Expect(0, 10496, '\P{^brai}', "");
    Expect(1, 10495, '\p{ Brai}', "");
    Expect(0, 10495, '\p{^ Brai}', "");
    Expect(0, 10495, '\P{ Brai}', "");
    Expect(1, 10495, '\P{^ Brai}', "");
    Expect(0, 10496, '\p{ Brai}', "");
    Expect(1, 10496, '\p{^ Brai}', "");
    Expect(1, 10496, '\P{ Brai}', "");
    Expect(0, 10496, '\P{^ Brai}', "");
    Error('\p{_/a/is_brai}');
    Error('\P{_/a/is_brai}');
    Expect(1, 10495, '\p{isbrai}', "");
    Expect(0, 10495, '\p{^isbrai}', "");
    Expect(0, 10495, '\P{isbrai}', "");
    Expect(1, 10495, '\P{^isbrai}', "");
    Expect(0, 10496, '\p{isbrai}', "");
    Expect(1, 10496, '\p{^isbrai}', "");
    Expect(1, 10496, '\P{isbrai}', "");
    Expect(0, 10496, '\P{^isbrai}', "");
    Expect(1, 10495, '\p{  is_Brai}', "");
    Expect(0, 10495, '\p{^  is_Brai}', "");
    Expect(0, 10495, '\P{  is_Brai}', "");
    Expect(1, 10495, '\P{^  is_Brai}', "");
    Expect(0, 10496, '\p{  is_Brai}', "");
    Expect(1, 10496, '\p{^  is_Brai}', "");
    Expect(1, 10496, '\P{  is_Brai}', "");
    Expect(0, 10496, '\P{^  is_Brai}', "");
    Error('\p{:= braille_Patterns}');
    Error('\P{:= braille_Patterns}');
    Expect(1, 10495, '\p{braillepatterns}', "");
    Expect(0, 10495, '\p{^braillepatterns}', "");
    Expect(0, 10495, '\P{braillepatterns}', "");
    Expect(1, 10495, '\P{^braillepatterns}', "");
    Expect(0, 10496, '\p{braillepatterns}', "");
    Expect(1, 10496, '\p{^braillepatterns}', "");
    Expect(1, 10496, '\P{braillepatterns}', "");
    Expect(0, 10496, '\P{^braillepatterns}', "");
    Expect(1, 10495, '\p{  BRAILLE_patterns}', "");
    Expect(0, 10495, '\p{^  BRAILLE_patterns}', "");
    Expect(0, 10495, '\P{  BRAILLE_patterns}', "");
    Expect(1, 10495, '\P{^  BRAILLE_patterns}', "");
    Expect(0, 10496, '\p{  BRAILLE_patterns}', "");
    Expect(1, 10496, '\p{^  BRAILLE_patterns}', "");
    Expect(1, 10496, '\P{  BRAILLE_patterns}', "");
    Expect(0, 10496, '\P{^  BRAILLE_patterns}', "");
    Error('\p{:=	 Is_braille_Patterns}');
    Error('\P{:=	 Is_braille_Patterns}');
    Expect(1, 10495, '\p{isbraillepatterns}', "");
    Expect(0, 10495, '\p{^isbraillepatterns}', "");
    Expect(0, 10495, '\P{isbraillepatterns}', "");
    Expect(1, 10495, '\P{^isbraillepatterns}', "");
    Expect(0, 10496, '\p{isbraillepatterns}', "");
    Expect(1, 10496, '\p{^isbraillepatterns}', "");
    Expect(1, 10496, '\P{isbraillepatterns}', "");
    Expect(0, 10496, '\P{^isbraillepatterns}', "");
    Expect(1, 10495, '\p{	 is_BRAILLE_Patterns}', "");
    Expect(0, 10495, '\p{^	 is_BRAILLE_Patterns}', "");
    Expect(0, 10495, '\P{	 is_BRAILLE_Patterns}', "");
    Expect(1, 10495, '\P{^	 is_BRAILLE_Patterns}', "");
    Expect(0, 10496, '\p{	 is_BRAILLE_Patterns}', "");
    Expect(1, 10496, '\p{^	 is_BRAILLE_Patterns}', "");
    Expect(1, 10496, '\P{	 is_BRAILLE_Patterns}', "");
    Expect(0, 10496, '\P{^	 is_BRAILLE_Patterns}', "");
    Error('\p{/a/In_BRAILLE_patterns}');
    Error('\P{/a/In_BRAILLE_patterns}');
    Expect(1, 10495, '\p{inbraillepatterns}', "");
    Expect(0, 10495, '\p{^inbraillepatterns}', "");
    Expect(0, 10495, '\P{inbraillepatterns}', "");
    Expect(1, 10495, '\P{^inbraillepatterns}', "");
    Expect(0, 10496, '\p{inbraillepatterns}', "");
    Expect(1, 10496, '\p{^inbraillepatterns}', "");
    Expect(1, 10496, '\P{inbraillepatterns}', "");
    Expect(0, 10496, '\P{^inbraillepatterns}', "");
    Expect(1, 10495, '\p{-in_BRAILLE_PATTERNS}', "");
    Expect(0, 10495, '\p{^-in_BRAILLE_PATTERNS}', "");
    Expect(0, 10495, '\P{-in_BRAILLE_PATTERNS}', "");
    Expect(1, 10495, '\P{^-in_BRAILLE_PATTERNS}', "");
    Expect(0, 10496, '\p{-in_BRAILLE_PATTERNS}', "");
    Expect(1, 10496, '\p{^-in_BRAILLE_PATTERNS}', "");
    Expect(1, 10496, '\P{-in_BRAILLE_PATTERNS}', "");
    Expect(0, 10496, '\P{^-in_BRAILLE_PATTERNS}', "");
    Error('\p{/a/	In_braille}');
    Error('\P{/a/	In_braille}');
    Expect(1, 10495, '\p{inbraille}', "");
    Expect(0, 10495, '\p{^inbraille}', "");
    Expect(0, 10495, '\P{inbraille}', "");
    Expect(1, 10495, '\P{^inbraille}', "");
    Expect(0, 10496, '\p{inbraille}', "");
    Expect(1, 10496, '\p{^inbraille}', "");
    Expect(1, 10496, '\P{inbraille}', "");
    Expect(0, 10496, '\P{^inbraille}', "");
    Expect(1, 10495, '\p{__In_braille}', "");
    Expect(0, 10495, '\p{^__In_braille}', "");
    Expect(0, 10495, '\P{__In_braille}', "");
    Expect(1, 10495, '\P{^__In_braille}', "");
    Expect(0, 10496, '\p{__In_braille}', "");
    Expect(1, 10496, '\p{^__In_braille}', "");
    Expect(1, 10496, '\P{__In_braille}', "");
    Expect(0, 10496, '\P{^__In_braille}', "");
    Error('\p{/a/	Buginese}');
    Error('\P{/a/	Buginese}');
    Expect(1, 43471, '\p{buginese}', "");
    Expect(0, 43471, '\p{^buginese}', "");
    Expect(0, 43471, '\P{buginese}', "");
    Expect(1, 43471, '\P{^buginese}', "");
    Expect(0, 43472, '\p{buginese}', "");
    Expect(1, 43472, '\p{^buginese}', "");
    Expect(1, 43472, '\P{buginese}', "");
    Expect(0, 43472, '\P{^buginese}', "");
    Expect(1, 43471, '\p{-buginese}', "");
    Expect(0, 43471, '\p{^-buginese}', "");
    Expect(0, 43471, '\P{-buginese}', "");
    Expect(1, 43471, '\P{^-buginese}', "");
    Expect(0, 43472, '\p{-buginese}', "");
    Expect(1, 43472, '\p{^-buginese}', "");
    Expect(1, 43472, '\P{-buginese}', "");
    Expect(0, 43472, '\P{^-buginese}', "");
    Error('\p{ _Is_buginese/a/}');
    Error('\P{ _Is_buginese/a/}');
    Expect(1, 43471, '\p{isbuginese}', "");
    Expect(0, 43471, '\p{^isbuginese}', "");
    Expect(0, 43471, '\P{isbuginese}', "");
    Expect(1, 43471, '\P{^isbuginese}', "");
    Expect(0, 43472, '\p{isbuginese}', "");
    Expect(1, 43472, '\p{^isbuginese}', "");
    Expect(1, 43472, '\P{isbuginese}', "");
    Expect(0, 43472, '\P{^isbuginese}', "");
    Expect(1, 43471, '\p{-	Is_Buginese}', "");
    Expect(0, 43471, '\p{^-	Is_Buginese}', "");
    Expect(0, 43471, '\P{-	Is_Buginese}', "");
    Expect(1, 43471, '\P{^-	Is_Buginese}', "");
    Expect(0, 43472, '\p{-	Is_Buginese}', "");
    Expect(1, 43472, '\p{^-	Is_Buginese}', "");
    Expect(1, 43472, '\P{-	Is_Buginese}', "");
    Expect(0, 43472, '\P{^-	Is_Buginese}', "");
    Error('\p{:= Bugi}');
    Error('\P{:= Bugi}');
    Expect(1, 43471, '\p{bugi}', "");
    Expect(0, 43471, '\p{^bugi}', "");
    Expect(0, 43471, '\P{bugi}', "");
    Expect(1, 43471, '\P{^bugi}', "");
    Expect(0, 43472, '\p{bugi}', "");
    Expect(1, 43472, '\p{^bugi}', "");
    Expect(1, 43472, '\P{bugi}', "");
    Expect(0, 43472, '\P{^bugi}', "");
    Expect(1, 43471, '\p{- Bugi}', "");
    Expect(0, 43471, '\p{^- Bugi}', "");
    Expect(0, 43471, '\P{- Bugi}', "");
    Expect(1, 43471, '\P{^- Bugi}', "");
    Expect(0, 43472, '\p{- Bugi}', "");
    Expect(1, 43472, '\p{^- Bugi}', "");
    Expect(1, 43472, '\P{- Bugi}', "");
    Expect(0, 43472, '\P{^- Bugi}', "");
    Error('\p{ /a/Is_Bugi}');
    Error('\P{ /a/Is_Bugi}');
    Expect(1, 43471, '\p{isbugi}', "");
    Expect(0, 43471, '\p{^isbugi}', "");
    Expect(0, 43471, '\P{isbugi}', "");
    Expect(1, 43471, '\P{^isbugi}', "");
    Expect(0, 43472, '\p{isbugi}', "");
    Expect(1, 43472, '\p{^isbugi}', "");
    Expect(1, 43472, '\P{isbugi}', "");
    Expect(0, 43472, '\P{^isbugi}', "");
    Expect(1, 43471, '\p{__IS_bugi}', "");
    Expect(0, 43471, '\p{^__IS_bugi}', "");
    Expect(0, 43471, '\P{__IS_bugi}', "");
    Expect(1, 43471, '\P{^__IS_bugi}', "");
    Expect(0, 43472, '\p{__IS_bugi}', "");
    Expect(1, 43472, '\p{^__IS_bugi}', "");
    Expect(1, 43472, '\P{__IS_bugi}', "");
    Expect(0, 43472, '\P{^__IS_bugi}', "");
    Error('\p{/a/-	buhid}');
    Error('\P{/a/-	buhid}');
    Expect(1, 5971, '\p{buhid}', "");
    Expect(0, 5971, '\p{^buhid}', "");
    Expect(0, 5971, '\P{buhid}', "");
    Expect(1, 5971, '\P{^buhid}', "");
    Expect(0, 5972, '\p{buhid}', "");
    Expect(1, 5972, '\p{^buhid}', "");
    Expect(1, 5972, '\P{buhid}', "");
    Expect(0, 5972, '\P{^buhid}', "");
    Expect(1, 5971, '\p{	-Buhid}', "");
    Expect(0, 5971, '\p{^	-Buhid}', "");
    Expect(0, 5971, '\P{	-Buhid}', "");
    Expect(1, 5971, '\P{^	-Buhid}', "");
    Expect(0, 5972, '\p{	-Buhid}', "");
    Expect(1, 5972, '\p{^	-Buhid}', "");
    Expect(1, 5972, '\P{	-Buhid}', "");
    Expect(0, 5972, '\P{^	-Buhid}', "");
    Error('\p{- is_buhid/a/}');
    Error('\P{- is_buhid/a/}');
    Expect(1, 5971, '\p{isbuhid}', "");
    Expect(0, 5971, '\p{^isbuhid}', "");
    Expect(0, 5971, '\P{isbuhid}', "");
    Expect(1, 5971, '\P{^isbuhid}', "");
    Expect(0, 5972, '\p{isbuhid}', "");
    Expect(1, 5972, '\p{^isbuhid}', "");
    Expect(1, 5972, '\P{isbuhid}', "");
    Expect(0, 5972, '\P{^isbuhid}', "");
    Expect(1, 5971, '\p{- IS_Buhid}', "");
    Expect(0, 5971, '\p{^- IS_Buhid}', "");
    Expect(0, 5971, '\P{- IS_Buhid}', "");
    Expect(1, 5971, '\P{^- IS_Buhid}', "");
    Expect(0, 5972, '\p{- IS_Buhid}', "");
    Expect(1, 5972, '\p{^- IS_Buhid}', "");
    Expect(1, 5972, '\P{- IS_Buhid}', "");
    Expect(0, 5972, '\P{^- IS_Buhid}', "");
    Error('\p{/a/ 	buhd}');
    Error('\P{/a/ 	buhd}');
    Expect(1, 5971, '\p{buhd}', "");
    Expect(0, 5971, '\p{^buhd}', "");
    Expect(0, 5971, '\P{buhd}', "");
    Expect(1, 5971, '\P{^buhd}', "");
    Expect(0, 5972, '\p{buhd}', "");
    Expect(1, 5972, '\p{^buhd}', "");
    Expect(1, 5972, '\P{buhd}', "");
    Expect(0, 5972, '\P{^buhd}', "");
    Expect(1, 5971, '\p{ Buhd}', "");
    Expect(0, 5971, '\p{^ Buhd}', "");
    Expect(0, 5971, '\P{ Buhd}', "");
    Expect(1, 5971, '\P{^ Buhd}', "");
    Expect(0, 5972, '\p{ Buhd}', "");
    Expect(1, 5972, '\p{^ Buhd}', "");
    Expect(1, 5972, '\P{ Buhd}', "");
    Expect(0, 5972, '\P{^ Buhd}', "");
    Error('\p{-is_buhd:=}');
    Error('\P{-is_buhd:=}');
    Expect(1, 5971, '\p{isbuhd}', "");
    Expect(0, 5971, '\p{^isbuhd}', "");
    Expect(0, 5971, '\P{isbuhd}', "");
    Expect(1, 5971, '\P{^isbuhd}', "");
    Expect(0, 5972, '\p{isbuhd}', "");
    Expect(1, 5972, '\p{^isbuhd}', "");
    Expect(1, 5972, '\P{isbuhd}', "");
    Expect(0, 5972, '\P{^isbuhd}', "");
    Expect(1, 5971, '\p{_ Is_buhd}', "");
    Expect(0, 5971, '\p{^_ Is_buhd}', "");
    Expect(0, 5971, '\P{_ Is_buhd}', "");
    Expect(1, 5971, '\P{^_ Is_buhd}', "");
    Expect(0, 5972, '\p{_ Is_buhd}', "");
    Expect(1, 5972, '\p{^_ Is_buhd}', "");
    Expect(1, 5972, '\P{_ Is_buhd}', "");
    Expect(0, 5972, '\P{^_ Is_buhd}', "");
    Error('\p{-_Byzantine_MUSICAL_Symbols:=}');
    Error('\P{-_Byzantine_MUSICAL_Symbols:=}');
    Expect(1, 119039, '\p{byzantinemusicalsymbols}', "");
    Expect(0, 119039, '\p{^byzantinemusicalsymbols}', "");
    Expect(0, 119039, '\P{byzantinemusicalsymbols}', "");
    Expect(1, 119039, '\P{^byzantinemusicalsymbols}', "");
    Expect(0, 119040, '\p{byzantinemusicalsymbols}', "");
    Expect(1, 119040, '\p{^byzantinemusicalsymbols}', "");
    Expect(1, 119040, '\P{byzantinemusicalsymbols}', "");
    Expect(0, 119040, '\P{^byzantinemusicalsymbols}', "");
    Expect(1, 119039, '\p{--byzantine_Musical_Symbols}', "");
    Expect(0, 119039, '\p{^--byzantine_Musical_Symbols}', "");
    Expect(0, 119039, '\P{--byzantine_Musical_Symbols}', "");
    Expect(1, 119039, '\P{^--byzantine_Musical_Symbols}', "");
    Expect(0, 119040, '\p{--byzantine_Musical_Symbols}', "");
    Expect(1, 119040, '\p{^--byzantine_Musical_Symbols}', "");
    Expect(1, 119040, '\P{--byzantine_Musical_Symbols}', "");
    Expect(0, 119040, '\P{^--byzantine_Musical_Symbols}', "");
    Error('\p{		IS_BYZANTINE_MUSICAL_symbols/a/}');
    Error('\P{		IS_BYZANTINE_MUSICAL_symbols/a/}');
    Expect(1, 119039, '\p{isbyzantinemusicalsymbols}', "");
    Expect(0, 119039, '\p{^isbyzantinemusicalsymbols}', "");
    Expect(0, 119039, '\P{isbyzantinemusicalsymbols}', "");
    Expect(1, 119039, '\P{^isbyzantinemusicalsymbols}', "");
    Expect(0, 119040, '\p{isbyzantinemusicalsymbols}', "");
    Expect(1, 119040, '\p{^isbyzantinemusicalsymbols}', "");
    Expect(1, 119040, '\P{isbyzantinemusicalsymbols}', "");
    Expect(0, 119040, '\P{^isbyzantinemusicalsymbols}', "");
    Expect(1, 119039, '\p{	 Is_Byzantine_Musical_SYMBOLS}', "");
    Expect(0, 119039, '\p{^	 Is_Byzantine_Musical_SYMBOLS}', "");
    Expect(0, 119039, '\P{	 Is_Byzantine_Musical_SYMBOLS}', "");
    Expect(1, 119039, '\P{^	 Is_Byzantine_Musical_SYMBOLS}', "");
    Expect(0, 119040, '\p{	 Is_Byzantine_Musical_SYMBOLS}', "");
    Expect(1, 119040, '\p{^	 Is_Byzantine_Musical_SYMBOLS}', "");
    Expect(1, 119040, '\P{	 Is_Byzantine_Musical_SYMBOLS}', "");
    Expect(0, 119040, '\P{^	 Is_Byzantine_Musical_SYMBOLS}', "");
    Error('\p{:=	 In_Byzantine_Musical_symbols}');
    Error('\P{:=	 In_Byzantine_Musical_symbols}');
    Expect(1, 119039, '\p{inbyzantinemusicalsymbols}', "");
    Expect(0, 119039, '\p{^inbyzantinemusicalsymbols}', "");
    Expect(0, 119039, '\P{inbyzantinemusicalsymbols}', "");
    Expect(1, 119039, '\P{^inbyzantinemusicalsymbols}', "");
    Expect(0, 119040, '\p{inbyzantinemusicalsymbols}', "");
    Expect(1, 119040, '\p{^inbyzantinemusicalsymbols}', "");
    Expect(1, 119040, '\P{inbyzantinemusicalsymbols}', "");
    Expect(0, 119040, '\P{^inbyzantinemusicalsymbols}', "");
    Expect(1, 119039, '\p{__in_Byzantine_Musical_symbols}', "");
    Expect(0, 119039, '\p{^__in_Byzantine_Musical_symbols}', "");
    Expect(0, 119039, '\P{__in_Byzantine_Musical_symbols}', "");
    Expect(1, 119039, '\P{^__in_Byzantine_Musical_symbols}', "");
    Expect(0, 119040, '\p{__in_Byzantine_Musical_symbols}', "");
    Expect(1, 119040, '\p{^__in_Byzantine_Musical_symbols}', "");
    Expect(1, 119040, '\P{__in_Byzantine_Musical_symbols}', "");
    Expect(0, 119040, '\P{^__in_Byzantine_Musical_symbols}', "");
    Error('\p{ :=byzantine_Music}');
    Error('\P{ :=byzantine_Music}');
    Expect(1, 119039, '\p{byzantinemusic}', "");
    Expect(0, 119039, '\p{^byzantinemusic}', "");
    Expect(0, 119039, '\P{byzantinemusic}', "");
    Expect(1, 119039, '\P{^byzantinemusic}', "");
    Expect(0, 119040, '\p{byzantinemusic}', "");
    Expect(1, 119040, '\p{^byzantinemusic}', "");
    Expect(1, 119040, '\P{byzantinemusic}', "");
    Expect(0, 119040, '\P{^byzantinemusic}', "");
    Expect(1, 119039, '\p{-	Byzantine_MUSIC}', "");
    Expect(0, 119039, '\p{^-	Byzantine_MUSIC}', "");
    Expect(0, 119039, '\P{-	Byzantine_MUSIC}', "");
    Expect(1, 119039, '\P{^-	Byzantine_MUSIC}', "");
    Expect(0, 119040, '\p{-	Byzantine_MUSIC}', "");
    Expect(1, 119040, '\p{^-	Byzantine_MUSIC}', "");
    Expect(1, 119040, '\P{-	Byzantine_MUSIC}', "");
    Expect(0, 119040, '\P{^-	Byzantine_MUSIC}', "");
    Error('\p{ /a/Is_Byzantine_Music}');
    Error('\P{ /a/Is_Byzantine_Music}');
    Expect(1, 119039, '\p{isbyzantinemusic}', "");
    Expect(0, 119039, '\p{^isbyzantinemusic}', "");
    Expect(0, 119039, '\P{isbyzantinemusic}', "");
    Expect(1, 119039, '\P{^isbyzantinemusic}', "");
    Expect(0, 119040, '\p{isbyzantinemusic}', "");
    Expect(1, 119040, '\p{^isbyzantinemusic}', "");
    Expect(1, 119040, '\P{isbyzantinemusic}', "");
    Expect(0, 119040, '\P{^isbyzantinemusic}', "");
    Expect(1, 119039, '\p{	-Is_Byzantine_music}', "");
    Expect(0, 119039, '\p{^	-Is_Byzantine_music}', "");
    Expect(0, 119039, '\P{	-Is_Byzantine_music}', "");
    Expect(1, 119039, '\P{^	-Is_Byzantine_music}', "");
    Expect(0, 119040, '\p{	-Is_Byzantine_music}', "");
    Expect(1, 119040, '\p{^	-Is_Byzantine_music}', "");
    Expect(1, 119040, '\P{	-Is_Byzantine_music}', "");
    Expect(0, 119040, '\P{^	-Is_Byzantine_music}', "");
    Error('\p{/a/_in_byzantine_Music}');
    Error('\P{/a/_in_byzantine_Music}');
    Expect(1, 119039, '\p{inbyzantinemusic}', "");
    Expect(0, 119039, '\p{^inbyzantinemusic}', "");
    Expect(0, 119039, '\P{inbyzantinemusic}', "");
    Expect(1, 119039, '\P{^inbyzantinemusic}', "");
    Expect(0, 119040, '\p{inbyzantinemusic}', "");
    Expect(1, 119040, '\p{^inbyzantinemusic}', "");
    Expect(1, 119040, '\P{inbyzantinemusic}', "");
    Expect(0, 119040, '\P{^inbyzantinemusic}', "");
    Expect(1, 119039, '\p{-_IN_byzantine_MUSIC}', "");
    Expect(0, 119039, '\p{^-_IN_byzantine_MUSIC}', "");
    Expect(0, 119039, '\P{-_IN_byzantine_MUSIC}', "");
    Expect(1, 119039, '\P{^-_IN_byzantine_MUSIC}', "");
    Expect(0, 119040, '\p{-_IN_byzantine_MUSIC}', "");
    Expect(1, 119040, '\p{^-_IN_byzantine_MUSIC}', "");
    Expect(1, 119040, '\P{-_IN_byzantine_MUSIC}', "");
    Expect(0, 119040, '\P{^-_IN_byzantine_MUSIC}', "");
    Error('\p{/a/ canadian_Aboriginal}');
    Error('\P{/a/ canadian_Aboriginal}');
    Expect(1, 6389, '\p{canadianaboriginal}', "");
    Expect(0, 6389, '\p{^canadianaboriginal}', "");
    Expect(0, 6389, '\P{canadianaboriginal}', "");
    Expect(1, 6389, '\P{^canadianaboriginal}', "");
    Expect(0, 6390, '\p{canadianaboriginal}', "");
    Expect(1, 6390, '\p{^canadianaboriginal}', "");
    Expect(1, 6390, '\P{canadianaboriginal}', "");
    Expect(0, 6390, '\P{^canadianaboriginal}', "");
    Expect(1, 6389, '\p{-Canadian_ABORIGINAL}', "");
    Expect(0, 6389, '\p{^-Canadian_ABORIGINAL}', "");
    Expect(0, 6389, '\P{-Canadian_ABORIGINAL}', "");
    Expect(1, 6389, '\P{^-Canadian_ABORIGINAL}', "");
    Expect(0, 6390, '\p{-Canadian_ABORIGINAL}', "");
    Expect(1, 6390, '\p{^-Canadian_ABORIGINAL}', "");
    Expect(1, 6390, '\P{-Canadian_ABORIGINAL}', "");
    Expect(0, 6390, '\P{^-Canadian_ABORIGINAL}', "");
    Error('\p{:=is_canadian_ABORIGINAL}');
    Error('\P{:=is_canadian_ABORIGINAL}');
    Expect(1, 6389, '\p{iscanadianaboriginal}', "");
    Expect(0, 6389, '\p{^iscanadianaboriginal}', "");
    Expect(0, 6389, '\P{iscanadianaboriginal}', "");
    Expect(1, 6389, '\P{^iscanadianaboriginal}', "");
    Expect(0, 6390, '\p{iscanadianaboriginal}', "");
    Expect(1, 6390, '\p{^iscanadianaboriginal}', "");
    Expect(1, 6390, '\P{iscanadianaboriginal}', "");
    Expect(0, 6390, '\P{^iscanadianaboriginal}', "");
    Expect(1, 6389, '\p{	_IS_CANADIAN_aboriginal}', "");
    Expect(0, 6389, '\p{^	_IS_CANADIAN_aboriginal}', "");
    Expect(0, 6389, '\P{	_IS_CANADIAN_aboriginal}', "");
    Expect(1, 6389, '\P{^	_IS_CANADIAN_aboriginal}', "");
    Expect(0, 6390, '\p{	_IS_CANADIAN_aboriginal}', "");
    Expect(1, 6390, '\p{^	_IS_CANADIAN_aboriginal}', "");
    Expect(1, 6390, '\P{	_IS_CANADIAN_aboriginal}', "");
    Expect(0, 6390, '\P{^	_IS_CANADIAN_aboriginal}', "");
    Error('\p{  Cans/a/}');
    Error('\P{  Cans/a/}');
    Expect(1, 6389, '\p{cans}', "");
    Expect(0, 6389, '\p{^cans}', "");
    Expect(0, 6389, '\P{cans}', "");
    Expect(1, 6389, '\P{^cans}', "");
    Expect(0, 6390, '\p{cans}', "");
    Expect(1, 6390, '\p{^cans}', "");
    Expect(1, 6390, '\P{cans}', "");
    Expect(0, 6390, '\P{^cans}', "");
    Expect(1, 6389, '\p{  Cans}', "");
    Expect(0, 6389, '\p{^  Cans}', "");
    Expect(0, 6389, '\P{  Cans}', "");
    Expect(1, 6389, '\P{^  Cans}', "");
    Expect(0, 6390, '\p{  Cans}', "");
    Expect(1, 6390, '\p{^  Cans}', "");
    Expect(1, 6390, '\P{  Cans}', "");
    Expect(0, 6390, '\P{^  Cans}', "");
    Error('\p{:=Is_Cans}');
    Error('\P{:=Is_Cans}');
    Expect(1, 6389, '\p{iscans}', "");
    Expect(0, 6389, '\p{^iscans}', "");
    Expect(0, 6389, '\P{iscans}', "");
    Expect(1, 6389, '\P{^iscans}', "");
    Expect(0, 6390, '\p{iscans}', "");
    Expect(1, 6390, '\p{^iscans}', "");
    Expect(1, 6390, '\P{iscans}', "");
    Expect(0, 6390, '\P{^iscans}', "");
    Expect(1, 6389, '\p{ -Is_Cans}', "");
    Expect(0, 6389, '\p{^ -Is_Cans}', "");
    Expect(0, 6389, '\P{ -Is_Cans}', "");
    Expect(1, 6389, '\P{^ -Is_Cans}', "");
    Expect(0, 6390, '\p{ -Is_Cans}', "");
    Expect(1, 6390, '\p{^ -Is_Cans}', "");
    Expect(1, 6390, '\P{ -Is_Cans}', "");
    Expect(0, 6390, '\P{^ -Is_Cans}', "");
    Error('\p{	CARIAN:=}');
    Error('\P{	CARIAN:=}');
    Expect(1, 66256, '\p{carian}', "");
    Expect(0, 66256, '\p{^carian}', "");
    Expect(0, 66256, '\P{carian}', "");
    Expect(1, 66256, '\P{^carian}', "");
    Expect(0, 66257, '\p{carian}', "");
    Expect(1, 66257, '\p{^carian}', "");
    Expect(1, 66257, '\P{carian}', "");
    Expect(0, 66257, '\P{^carian}', "");
    Expect(1, 66256, '\p{- CARIAN}', "");
    Expect(0, 66256, '\p{^- CARIAN}', "");
    Expect(0, 66256, '\P{- CARIAN}', "");
    Expect(1, 66256, '\P{^- CARIAN}', "");
    Expect(0, 66257, '\p{- CARIAN}', "");
    Expect(1, 66257, '\p{^- CARIAN}', "");
    Expect(1, 66257, '\P{- CARIAN}', "");
    Expect(0, 66257, '\P{^- CARIAN}', "");
    Error('\p{_-IS_CARIAN:=}');
    Error('\P{_-IS_CARIAN:=}');
    Expect(1, 66256, '\p{iscarian}', "");
    Expect(0, 66256, '\p{^iscarian}', "");
    Expect(0, 66256, '\P{iscarian}', "");
    Expect(1, 66256, '\P{^iscarian}', "");
    Expect(0, 66257, '\p{iscarian}', "");
    Expect(1, 66257, '\p{^iscarian}', "");
    Expect(1, 66257, '\P{iscarian}', "");
    Expect(0, 66257, '\P{^iscarian}', "");
    Expect(1, 66256, '\p{--Is_carian}', "");
    Expect(0, 66256, '\p{^--Is_carian}', "");
    Expect(0, 66256, '\P{--Is_carian}', "");
    Expect(1, 66256, '\P{^--Is_carian}', "");
    Expect(0, 66257, '\p{--Is_carian}', "");
    Expect(1, 66257, '\p{^--Is_carian}', "");
    Expect(1, 66257, '\P{--Is_carian}', "");
    Expect(0, 66257, '\P{^--Is_carian}', "");
    Error('\p{ _Cari:=}');
    Error('\P{ _Cari:=}');
    Expect(1, 66256, '\p{cari}', "");
    Expect(0, 66256, '\p{^cari}', "");
    Expect(0, 66256, '\P{cari}', "");
    Expect(1, 66256, '\P{^cari}', "");
    Expect(0, 66257, '\p{cari}', "");
    Expect(1, 66257, '\p{^cari}', "");
    Expect(1, 66257, '\P{cari}', "");
    Expect(0, 66257, '\P{^cari}', "");
    Expect(1, 66256, '\p{	Cari}', "");
    Expect(0, 66256, '\p{^	Cari}', "");
    Expect(0, 66256, '\P{	Cari}', "");
    Expect(1, 66256, '\P{^	Cari}', "");
    Expect(0, 66257, '\p{	Cari}', "");
    Expect(1, 66257, '\p{^	Cari}', "");
    Expect(1, 66257, '\P{	Cari}', "");
    Expect(0, 66257, '\P{^	Cari}', "");
    Error('\p{:= -IS_CARI}');
    Error('\P{:= -IS_CARI}');
    Expect(1, 66256, '\p{iscari}', "");
    Expect(0, 66256, '\p{^iscari}', "");
    Expect(0, 66256, '\P{iscari}', "");
    Expect(1, 66256, '\P{^iscari}', "");
    Expect(0, 66257, '\p{iscari}', "");
    Expect(1, 66257, '\p{^iscari}', "");
    Expect(1, 66257, '\P{iscari}', "");
    Expect(0, 66257, '\P{^iscari}', "");
    Expect(1, 66256, '\p{_	Is_Cari}', "");
    Expect(0, 66256, '\p{^_	Is_Cari}', "");
    Expect(0, 66256, '\P{_	Is_Cari}', "");
    Expect(1, 66256, '\P{^_	Is_Cari}', "");
    Expect(0, 66257, '\p{_	Is_Cari}', "");
    Expect(1, 66257, '\p{^_	Is_Cari}', "");
    Expect(1, 66257, '\P{_	Is_Cari}', "");
    Expect(0, 66257, '\P{^_	Is_Cari}', "");
    Error('\p{	Case_Ignorable:=}');
    Error('\P{	Case_Ignorable:=}');
    Expect(1, 917999, '\p{caseignorable}', "");
    Expect(0, 917999, '\p{^caseignorable}', "");
    Expect(0, 917999, '\P{caseignorable}', "");
    Expect(1, 917999, '\P{^caseignorable}', "");
    Expect(0, 918000, '\p{caseignorable}', "");
    Expect(1, 918000, '\p{^caseignorable}', "");
    Expect(1, 918000, '\P{caseignorable}', "");
    Expect(0, 918000, '\P{^caseignorable}', "");
    Expect(1, 917999, '\p{ CASE_Ignorable}', "");
    Expect(0, 917999, '\p{^ CASE_Ignorable}', "");
    Expect(0, 917999, '\P{ CASE_Ignorable}', "");
    Expect(1, 917999, '\P{^ CASE_Ignorable}', "");
    Expect(0, 918000, '\p{ CASE_Ignorable}', "");
    Expect(1, 918000, '\p{^ CASE_Ignorable}', "");
    Expect(1, 918000, '\P{ CASE_Ignorable}', "");
    Expect(0, 918000, '\P{^ CASE_Ignorable}', "");
    Error('\p{-/a/Is_case_ignorable}');
    Error('\P{-/a/Is_case_ignorable}');
    Expect(1, 917999, '\p{iscaseignorable}', "");
    Expect(0, 917999, '\p{^iscaseignorable}', "");
    Expect(0, 917999, '\P{iscaseignorable}', "");
    Expect(1, 917999, '\P{^iscaseignorable}', "");
    Expect(0, 918000, '\p{iscaseignorable}', "");
    Expect(1, 918000, '\p{^iscaseignorable}', "");
    Expect(1, 918000, '\P{iscaseignorable}', "");
    Expect(0, 918000, '\P{^iscaseignorable}', "");
    Expect(1, 917999, '\p{	 Is_Case_Ignorable}', "");
    Expect(0, 917999, '\p{^	 Is_Case_Ignorable}', "");
    Expect(0, 917999, '\P{	 Is_Case_Ignorable}', "");
    Expect(1, 917999, '\P{^	 Is_Case_Ignorable}', "");
    Expect(0, 918000, '\p{	 Is_Case_Ignorable}', "");
    Expect(1, 918000, '\p{^	 Is_Case_Ignorable}', "");
    Expect(1, 918000, '\P{	 Is_Case_Ignorable}', "");
    Expect(0, 918000, '\P{^	 Is_Case_Ignorable}', "");
    Error('\p{	/a/CI}');
    Error('\P{	/a/CI}');
    Expect(1, 917999, '\p{ci}', "");
    Expect(0, 917999, '\p{^ci}', "");
    Expect(0, 917999, '\P{ci}', "");
    Expect(1, 917999, '\P{^ci}', "");
    Expect(0, 918000, '\p{ci}', "");
    Expect(1, 918000, '\p{^ci}', "");
    Expect(1, 918000, '\P{ci}', "");
    Expect(0, 918000, '\P{^ci}', "");
    Expect(1, 917999, '\p{		CI}', "");
    Expect(0, 917999, '\p{^		CI}', "");
    Expect(0, 917999, '\P{		CI}', "");
    Expect(1, 917999, '\P{^		CI}', "");
    Expect(0, 918000, '\p{		CI}', "");
    Expect(1, 918000, '\p{^		CI}', "");
    Expect(1, 918000, '\P{		CI}', "");
    Expect(0, 918000, '\P{^		CI}', "");
    Error('\p{  IS_CI:=}');
    Error('\P{  IS_CI:=}');
    Expect(1, 917999, '\p{isci}', "");
    Expect(0, 917999, '\p{^isci}', "");
    Expect(0, 917999, '\P{isci}', "");
    Expect(1, 917999, '\P{^isci}', "");
    Expect(0, 918000, '\p{isci}', "");
    Expect(1, 918000, '\p{^isci}', "");
    Expect(1, 918000, '\P{isci}', "");
    Expect(0, 918000, '\P{^isci}', "");
    Expect(1, 917999, '\p{ Is_CI}', "");
    Expect(0, 917999, '\p{^ Is_CI}', "");
    Expect(0, 917999, '\P{ Is_CI}', "");
    Expect(1, 917999, '\P{^ Is_CI}', "");
    Expect(0, 918000, '\p{ Is_CI}', "");
    Expect(1, 918000, '\p{^ Is_CI}', "");
    Expect(1, 918000, '\P{ Is_CI}', "");
    Expect(0, 918000, '\P{^ Is_CI}', "");
    Error('\p{:=CASED}');
    Error('\P{:=CASED}');
    Expect(1, 127369, '\p{cased}', "");
    Expect(0, 127369, '\p{^cased}', "");
    Expect(0, 127369, '\P{cased}', "");
    Expect(1, 127369, '\P{^cased}', "");
    Expect(0, 127370, '\p{cased}', "");
    Expect(1, 127370, '\p{^cased}', "");
    Expect(1, 127370, '\P{cased}', "");
    Expect(0, 127370, '\P{^cased}', "");
    Expect(1, 127369, '\p{ cased}', "");
    Expect(0, 127369, '\p{^ cased}', "");
    Expect(0, 127369, '\P{ cased}', "");
    Expect(1, 127369, '\P{^ cased}', "");
    Expect(0, 127370, '\p{ cased}', "");
    Expect(1, 127370, '\p{^ cased}', "");
    Expect(1, 127370, '\P{ cased}', "");
    Expect(0, 127370, '\P{^ cased}', "");
    Error('\p{_ IS_Cased:=}');
    Error('\P{_ IS_Cased:=}');
    Expect(1, 127369, '\p{iscased}', "");
    Expect(0, 127369, '\p{^iscased}', "");
    Expect(0, 127369, '\P{iscased}', "");
    Expect(1, 127369, '\P{^iscased}', "");
    Expect(0, 127370, '\p{iscased}', "");
    Expect(1, 127370, '\p{^iscased}', "");
    Expect(1, 127370, '\P{iscased}', "");
    Expect(0, 127370, '\P{^iscased}', "");
    Expect(1, 127369, '\p{- is_CASED}', "");
    Expect(0, 127369, '\p{^- is_CASED}', "");
    Expect(0, 127369, '\P{- is_CASED}', "");
    Expect(1, 127369, '\P{^- is_CASED}', "");
    Expect(0, 127370, '\p{- is_CASED}', "");
    Expect(1, 127370, '\p{^- is_CASED}', "");
    Expect(1, 127370, '\P{- is_CASED}', "");
    Expect(0, 127370, '\P{^- is_CASED}', "");
    Error('\p{/a/-_Cased_Letter}');
    Error('\P{/a/-_Cased_Letter}');
    Expect(1, 125251, '\p{casedletter}', "");
    Expect(0, 125251, '\p{^casedletter}', "");
    Expect(0, 125251, '\P{casedletter}', "");
    Expect(1, 125251, '\P{^casedletter}', "");
    Expect(0, 125252, '\p{casedletter}', "");
    Expect(1, 125252, '\p{^casedletter}', "");
    Expect(1, 125252, '\P{casedletter}', "");
    Expect(0, 125252, '\P{^casedletter}', "");
    Expect(1, 125251, '\p{	CASED_Letter}', "");
    Expect(0, 125251, '\p{^	CASED_Letter}', "");
    Expect(0, 125251, '\P{	CASED_Letter}', "");
    Expect(1, 125251, '\P{^	CASED_Letter}', "");
    Expect(0, 125252, '\p{	CASED_Letter}', "");
    Expect(1, 125252, '\p{^	CASED_Letter}', "");
    Expect(1, 125252, '\P{	CASED_Letter}', "");
    Expect(0, 125252, '\P{^	CASED_Letter}', "");
    Error('\p{  IS_cased_LETTER/a/}');
    Error('\P{  IS_cased_LETTER/a/}');
    Expect(1, 125251, '\p{iscasedletter}', "");
    Expect(0, 125251, '\p{^iscasedletter}', "");
    Expect(0, 125251, '\P{iscasedletter}', "");
    Expect(1, 125251, '\P{^iscasedletter}', "");
    Expect(0, 125252, '\p{iscasedletter}', "");
    Expect(1, 125252, '\p{^iscasedletter}', "");
    Expect(1, 125252, '\P{iscasedletter}', "");
    Expect(0, 125252, '\P{^iscasedletter}', "");
    Expect(1, 125251, '\p{	_Is_Cased_Letter}', "");
    Expect(0, 125251, '\p{^	_Is_Cased_Letter}', "");
    Expect(0, 125251, '\P{	_Is_Cased_Letter}', "");
    Expect(1, 125251, '\P{^	_Is_Cased_Letter}', "");
    Expect(0, 125252, '\p{	_Is_Cased_Letter}', "");
    Expect(1, 125252, '\p{^	_Is_Cased_Letter}', "");
    Expect(1, 125252, '\P{	_Is_Cased_Letter}', "");
    Expect(0, 125252, '\P{^	_Is_Cased_Letter}', "");
    Error('\p{:= 	LC}');
    Error('\P{:= 	LC}');
    Expect(1, 125251, '\p{lc}', "");
    Expect(0, 125251, '\p{^lc}', "");
    Expect(0, 125251, '\P{lc}', "");
    Expect(1, 125251, '\P{^lc}', "");
    Expect(0, 125252, '\p{lc}', "");
    Expect(1, 125252, '\p{^lc}', "");
    Expect(1, 125252, '\P{lc}', "");
    Expect(0, 125252, '\P{^lc}', "");
    Expect(1, 125251, '\p{ _LC}', "");
    Expect(0, 125251, '\p{^ _LC}', "");
    Expect(0, 125251, '\P{ _LC}', "");
    Expect(1, 125251, '\P{^ _LC}', "");
    Expect(0, 125252, '\p{ _LC}', "");
    Expect(1, 125252, '\p{^ _LC}', "");
    Expect(1, 125252, '\P{ _LC}', "");
    Expect(0, 125252, '\P{^ _LC}', "");
    Error('\p{ Is_LC/a/}');
    Error('\P{ Is_LC/a/}');
    Expect(1, 125251, '\p{islc}', "");
    Expect(0, 125251, '\p{^islc}', "");
    Expect(0, 125251, '\P{islc}', "");
    Expect(1, 125251, '\P{^islc}', "");
    Expect(0, 125252, '\p{islc}', "");
    Expect(1, 125252, '\p{^islc}', "");
    Expect(1, 125252, '\P{islc}', "");
    Expect(0, 125252, '\P{^islc}', "");
    Expect(1, 125251, '\p{	_is_LC}', "");
    Expect(0, 125251, '\p{^	_is_LC}', "");
    Expect(0, 125251, '\P{	_is_LC}', "");
    Expect(1, 125251, '\P{^	_is_LC}', "");
    Expect(0, 125252, '\p{	_is_LC}', "");
    Expect(1, 125252, '\p{^	_is_LC}', "");
    Expect(1, 125252, '\P{	_is_LC}', "");
    Expect(0, 125252, '\P{^	_is_LC}', "");
    Error('\p{:=	_l_}');
    Error('\P{:=	_l_}');
    Expect(1, 125251, '\p{l_}', "");
    Expect(0, 125251, '\p{^l_}', "");
    Expect(0, 125251, '\P{l_}', "");
    Expect(1, 125251, '\P{^l_}', "");
    Expect(0, 125252, '\p{l_}', "");
    Expect(1, 125252, '\p{^l_}', "");
    Expect(1, 125252, '\P{l_}', "");
    Expect(0, 125252, '\P{^l_}', "");
    Expect(1, 125251, '\p{ _l_}', "");
    Expect(0, 125251, '\p{^ _l_}', "");
    Expect(0, 125251, '\P{ _l_}', "");
    Expect(1, 125251, '\P{^ _l_}', "");
    Expect(0, 125252, '\p{ _l_}', "");
    Expect(1, 125252, '\p{^ _l_}', "");
    Expect(1, 125252, '\P{ _l_}', "");
    Expect(0, 125252, '\P{^ _l_}', "");
    Error('\p{- is_L_:=}');
    Error('\P{- is_L_:=}');
    Expect(1, 125251, '\p{isl_}', "");
    Expect(0, 125251, '\p{^isl_}', "");
    Expect(0, 125251, '\P{isl_}', "");
    Expect(1, 125251, '\P{^isl_}', "");
    Expect(0, 125252, '\p{isl_}', "");
    Expect(1, 125252, '\p{^isl_}', "");
    Expect(1, 125252, '\P{isl_}', "");
    Expect(0, 125252, '\P{^isl_}', "");
    Expect(1, 125251, '\p{_-Is_L_}', "");
    Expect(0, 125251, '\p{^_-Is_L_}', "");
    Expect(0, 125251, '\P{_-Is_L_}', "");
    Expect(1, 125251, '\P{^_-Is_L_}', "");
    Expect(0, 125252, '\p{_-Is_L_}', "");
    Expect(1, 125252, '\p{^_-Is_L_}', "");
    Expect(1, 125252, '\P{_-Is_L_}', "");
    Expect(0, 125252, '\P{^_-Is_L_}', "");
    Error('\p{ :=L&}');
    Error('\P{ :=L&}');
    Expect(1, 125251, '\p{l&}', "");
    Expect(0, 125251, '\p{^l&}', "");
    Expect(0, 125251, '\P{l&}', "");
    Expect(1, 125251, '\P{^l&}', "");
    Expect(0, 125252, '\p{l&}', "");
    Expect(1, 125252, '\p{^l&}', "");
    Expect(1, 125252, '\P{l&}', "");
    Expect(0, 125252, '\P{^l&}', "");
    Expect(1, 125251, '\p{-	L&}', "");
    Expect(0, 125251, '\p{^-	L&}', "");
    Expect(0, 125251, '\P{-	L&}', "");
    Expect(1, 125251, '\P{^-	L&}', "");
    Expect(0, 125252, '\p{-	L&}', "");
    Expect(1, 125252, '\p{^-	L&}', "");
    Expect(1, 125252, '\P{-	L&}', "");
    Expect(0, 125252, '\P{^-	L&}', "");
    Error('\p{-Is_L&/a/}');
    Error('\P{-Is_L&/a/}');
    Expect(1, 125251, '\p{isl&}', "");
    Expect(0, 125251, '\p{^isl&}', "");
    Expect(0, 125251, '\P{isl&}', "");
    Expect(1, 125251, '\P{^isl&}', "");
    Expect(0, 125252, '\p{isl&}', "");
    Expect(1, 125252, '\p{^isl&}', "");
    Expect(1, 125252, '\P{isl&}', "");
    Expect(0, 125252, '\P{^isl&}', "");
    Expect(1, 125251, '\p{	_Is_L&}', "");
    Expect(0, 125251, '\p{^	_Is_L&}', "");
    Expect(0, 125251, '\P{	_Is_L&}', "");
    Expect(1, 125251, '\P{^	_Is_L&}', "");
    Expect(0, 125252, '\p{	_Is_L&}', "");
    Expect(1, 125252, '\p{^	_Is_L&}', "");
    Expect(1, 125252, '\P{	_Is_L&}', "");
    Expect(0, 125252, '\P{^	_Is_L&}', "");
    Error('\p{_Caucasian_ALBANIAN:=}');
    Error('\P{_Caucasian_ALBANIAN:=}');
    Expect(1, 66927, '\p{caucasianalbanian}', "");
    Expect(0, 66927, '\p{^caucasianalbanian}', "");
    Expect(0, 66927, '\P{caucasianalbanian}', "");
    Expect(1, 66927, '\P{^caucasianalbanian}', "");
    Expect(0, 66928, '\p{caucasianalbanian}', "");
    Expect(1, 66928, '\p{^caucasianalbanian}', "");
    Expect(1, 66928, '\P{caucasianalbanian}', "");
    Expect(0, 66928, '\P{^caucasianalbanian}', "");
    Expect(1, 66927, '\p{ caucasian_albanian}', "");
    Expect(0, 66927, '\p{^ caucasian_albanian}', "");
    Expect(0, 66927, '\P{ caucasian_albanian}', "");
    Expect(1, 66927, '\P{^ caucasian_albanian}', "");
    Expect(0, 66928, '\p{ caucasian_albanian}', "");
    Expect(1, 66928, '\p{^ caucasian_albanian}', "");
    Expect(1, 66928, '\P{ caucasian_albanian}', "");
    Expect(0, 66928, '\P{^ caucasian_albanian}', "");
    Error('\p{	:=Is_CAUCASIAN_Albanian}');
    Error('\P{	:=Is_CAUCASIAN_Albanian}');
    Expect(1, 66927, '\p{iscaucasianalbanian}', "");
    Expect(0, 66927, '\p{^iscaucasianalbanian}', "");
    Expect(0, 66927, '\P{iscaucasianalbanian}', "");
    Expect(1, 66927, '\P{^iscaucasianalbanian}', "");
    Expect(0, 66928, '\p{iscaucasianalbanian}', "");
    Expect(1, 66928, '\p{^iscaucasianalbanian}', "");
    Expect(1, 66928, '\P{iscaucasianalbanian}', "");
    Expect(0, 66928, '\P{^iscaucasianalbanian}', "");
    Expect(1, 66927, '\p{-	IS_CAUCASIAN_albanian}', "");
    Expect(0, 66927, '\p{^-	IS_CAUCASIAN_albanian}', "");
    Expect(0, 66927, '\P{-	IS_CAUCASIAN_albanian}', "");
    Expect(1, 66927, '\P{^-	IS_CAUCASIAN_albanian}', "");
    Expect(0, 66928, '\p{-	IS_CAUCASIAN_albanian}', "");
    Expect(1, 66928, '\p{^-	IS_CAUCASIAN_albanian}', "");
    Expect(1, 66928, '\P{-	IS_CAUCASIAN_albanian}', "");
    Expect(0, 66928, '\P{^-	IS_CAUCASIAN_albanian}', "");
    Error('\p{:=	_Aghb}');
    Error('\P{:=	_Aghb}');
    Expect(1, 66927, '\p{aghb}', "");
    Expect(0, 66927, '\p{^aghb}', "");
    Expect(0, 66927, '\P{aghb}', "");
    Expect(1, 66927, '\P{^aghb}', "");
    Expect(0, 66928, '\p{aghb}', "");
    Expect(1, 66928, '\p{^aghb}', "");
    Expect(1, 66928, '\P{aghb}', "");
    Expect(0, 66928, '\P{^aghb}', "");
    Expect(1, 66927, '\p{_	AGHB}', "");
    Expect(0, 66927, '\p{^_	AGHB}', "");
    Expect(0, 66927, '\P{_	AGHB}', "");
    Expect(1, 66927, '\P{^_	AGHB}', "");
    Expect(0, 66928, '\p{_	AGHB}', "");
    Expect(1, 66928, '\p{^_	AGHB}', "");
    Expect(1, 66928, '\P{_	AGHB}', "");
    Expect(0, 66928, '\P{^_	AGHB}', "");
    Error('\p{:=	 Is_aghb}');
    Error('\P{:=	 Is_aghb}');
    Expect(1, 66927, '\p{isaghb}', "");
    Expect(0, 66927, '\p{^isaghb}', "");
    Expect(0, 66927, '\P{isaghb}', "");
    Expect(1, 66927, '\P{^isaghb}', "");
    Expect(0, 66928, '\p{isaghb}', "");
    Expect(1, 66928, '\p{^isaghb}', "");
    Expect(1, 66928, '\P{isaghb}', "");
    Expect(0, 66928, '\P{^isaghb}', "");
    Expect(1, 66927, '\p{_-Is_AGHB}', "");
    Expect(0, 66927, '\p{^_-Is_AGHB}', "");
    Expect(0, 66927, '\P{_-Is_AGHB}', "");
    Expect(1, 66927, '\P{^_-Is_AGHB}', "");
    Expect(0, 66928, '\p{_-Is_AGHB}', "");
    Expect(1, 66928, '\p{^_-Is_AGHB}', "");
    Expect(1, 66928, '\P{_-Is_AGHB}', "");
    Expect(0, 66928, '\P{^_-Is_AGHB}', "");
    Error('\p{_Chakma:=}');
    Error('\P{_Chakma:=}');
    Expect(1, 69959, '\p{chakma}', "");
    Expect(0, 69959, '\p{^chakma}', "");
    Expect(0, 69959, '\P{chakma}', "");
    Expect(1, 69959, '\P{^chakma}', "");
    Expect(0, 69960, '\p{chakma}', "");
    Expect(1, 69960, '\p{^chakma}', "");
    Expect(1, 69960, '\P{chakma}', "");
    Expect(0, 69960, '\P{^chakma}', "");
    Expect(1, 69959, '\p{-Chakma}', "");
    Expect(0, 69959, '\p{^-Chakma}', "");
    Expect(0, 69959, '\P{-Chakma}', "");
    Expect(1, 69959, '\P{^-Chakma}', "");
    Expect(0, 69960, '\p{-Chakma}', "");
    Expect(1, 69960, '\p{^-Chakma}', "");
    Expect(1, 69960, '\P{-Chakma}', "");
    Expect(0, 69960, '\P{^-Chakma}', "");
    Error('\p{:=	 Is_Chakma}');
    Error('\P{:=	 Is_Chakma}');
    Expect(1, 69959, '\p{ischakma}', "");
    Expect(0, 69959, '\p{^ischakma}', "");
    Expect(0, 69959, '\P{ischakma}', "");
    Expect(1, 69959, '\P{^ischakma}', "");
    Expect(0, 69960, '\p{ischakma}', "");
    Expect(1, 69960, '\p{^ischakma}', "");
    Expect(1, 69960, '\P{ischakma}', "");
    Expect(0, 69960, '\P{^ischakma}', "");
    Expect(1, 69959, '\p{  IS_chakma}', "");
    Expect(0, 69959, '\p{^  IS_chakma}', "");
    Expect(0, 69959, '\P{  IS_chakma}', "");
    Expect(1, 69959, '\P{^  IS_chakma}', "");
    Expect(0, 69960, '\p{  IS_chakma}', "");
    Expect(1, 69960, '\p{^  IS_chakma}', "");
    Expect(1, 69960, '\P{  IS_chakma}', "");
    Expect(0, 69960, '\P{^  IS_chakma}', "");
    Error('\p{ /a/Cakm}');
    Error('\P{ /a/Cakm}');
    Expect(1, 69959, '\p{cakm}', "");
    Expect(0, 69959, '\p{^cakm}', "");
    Expect(0, 69959, '\P{cakm}', "");
    Expect(1, 69959, '\P{^cakm}', "");
    Expect(0, 69960, '\p{cakm}', "");
    Expect(1, 69960, '\p{^cakm}', "");
    Expect(1, 69960, '\P{cakm}', "");
    Expect(0, 69960, '\P{^cakm}', "");
    Expect(1, 69959, '\p{CAKM}', "");
    Expect(0, 69959, '\p{^CAKM}', "");
    Expect(0, 69959, '\P{CAKM}', "");
    Expect(1, 69959, '\P{^CAKM}', "");
    Expect(0, 69960, '\p{CAKM}', "");
    Expect(1, 69960, '\p{^CAKM}', "");
    Expect(1, 69960, '\P{CAKM}', "");
    Expect(0, 69960, '\P{^CAKM}', "");
    Error('\p{/a/	_IS_Cakm}');
    Error('\P{/a/	_IS_Cakm}');
    Expect(1, 69959, '\p{iscakm}', "");
    Expect(0, 69959, '\p{^iscakm}', "");
    Expect(0, 69959, '\P{iscakm}', "");
    Expect(1, 69959, '\P{^iscakm}', "");
    Expect(0, 69960, '\p{iscakm}', "");
    Expect(1, 69960, '\p{^iscakm}', "");
    Expect(1, 69960, '\P{iscakm}', "");
    Expect(0, 69960, '\P{^iscakm}', "");
    Expect(1, 69959, '\p{-Is_cakm}', "");
    Expect(0, 69959, '\p{^-Is_cakm}', "");
    Expect(0, 69959, '\P{-Is_cakm}', "");
    Expect(1, 69959, '\P{^-Is_cakm}', "");
    Expect(0, 69960, '\p{-Is_cakm}', "");
    Expect(1, 69960, '\p{^-Is_cakm}', "");
    Expect(1, 69960, '\P{-Is_cakm}', "");
    Expect(0, 69960, '\P{^-Is_cakm}', "");
    Error('\p{:=_	CHAM}');
    Error('\P{:=_	CHAM}');
    Expect(1, 43615, '\p{cham}', "");
    Expect(0, 43615, '\p{^cham}', "");
    Expect(0, 43615, '\P{cham}', "");
    Expect(1, 43615, '\P{^cham}', "");
    Expect(0, 43616, '\p{cham}', "");
    Expect(1, 43616, '\p{^cham}', "");
    Expect(1, 43616, '\P{cham}', "");
    Expect(0, 43616, '\P{^cham}', "");
    Expect(1, 43615, '\p{  Cham}', "");
    Expect(0, 43615, '\p{^  Cham}', "");
    Expect(0, 43615, '\P{  Cham}', "");
    Expect(1, 43615, '\P{^  Cham}', "");
    Expect(0, 43616, '\p{  Cham}', "");
    Expect(1, 43616, '\p{^  Cham}', "");
    Expect(1, 43616, '\P{  Cham}', "");
    Expect(0, 43616, '\P{^  Cham}', "");
    Error('\p{	_is_Cham:=}');
    Error('\P{	_is_Cham:=}');
    Expect(1, 43615, '\p{ischam}', "");
    Expect(0, 43615, '\p{^ischam}', "");
    Expect(0, 43615, '\P{ischam}', "");
    Expect(1, 43615, '\P{^ischam}', "");
    Expect(0, 43616, '\p{ischam}', "");
    Expect(1, 43616, '\p{^ischam}', "");
    Expect(1, 43616, '\P{ischam}', "");
    Expect(0, 43616, '\P{^ischam}', "");
    Expect(1, 43615, '\p{-Is_Cham}', "");
    Expect(0, 43615, '\p{^-Is_Cham}', "");
    Expect(0, 43615, '\P{-Is_Cham}', "");
    Expect(1, 43615, '\P{^-Is_Cham}', "");
    Expect(0, 43616, '\p{-Is_Cham}', "");
    Expect(1, 43616, '\p{^-Is_Cham}', "");
    Expect(1, 43616, '\P{-Is_Cham}', "");
    Expect(0, 43616, '\P{^-Is_Cham}', "");
    Error('\p{	/a/Changes_When_CASEFOLDED}');
    Error('\P{	/a/Changes_When_CASEFOLDED}');
    Expect(1, 125217, '\p{changeswhencasefolded}', "");
    Expect(0, 125217, '\p{^changeswhencasefolded}', "");
    Expect(0, 125217, '\P{changeswhencasefolded}', "");
    Expect(1, 125217, '\P{^changeswhencasefolded}', "");
    Expect(0, 125218, '\p{changeswhencasefolded}', "");
    Expect(1, 125218, '\p{^changeswhencasefolded}', "");
    Expect(1, 125218, '\P{changeswhencasefolded}', "");
    Expect(0, 125218, '\P{^changeswhencasefolded}', "");
    Expect(1, 125217, '\p{ _changes_When_CASEFOLDED}', "");
    Expect(0, 125217, '\p{^ _changes_When_CASEFOLDED}', "");
    Expect(0, 125217, '\P{ _changes_When_CASEFOLDED}', "");
    Expect(1, 125217, '\P{^ _changes_When_CASEFOLDED}', "");
    Expect(0, 125218, '\p{ _changes_When_CASEFOLDED}', "");
    Expect(1, 125218, '\p{^ _changes_When_CASEFOLDED}', "");
    Expect(1, 125218, '\P{ _changes_When_CASEFOLDED}', "");
    Expect(0, 125218, '\P{^ _changes_When_CASEFOLDED}', "");
    Error('\p{ Is_CHANGES_When_Casefolded/a/}');
    Error('\P{ Is_CHANGES_When_Casefolded/a/}');
    Expect(1, 125217, '\p{ischangeswhencasefolded}', "");
    Expect(0, 125217, '\p{^ischangeswhencasefolded}', "");
    Expect(0, 125217, '\P{ischangeswhencasefolded}', "");
    Expect(1, 125217, '\P{^ischangeswhencasefolded}', "");
    Expect(0, 125218, '\p{ischangeswhencasefolded}', "");
    Expect(1, 125218, '\p{^ischangeswhencasefolded}', "");
    Expect(1, 125218, '\P{ischangeswhencasefolded}', "");
    Expect(0, 125218, '\P{^ischangeswhencasefolded}', "");
    Expect(1, 125217, '\p{ _IS_changes_When_Casefolded}', "");
    Expect(0, 125217, '\p{^ _IS_changes_When_Casefolded}', "");
    Expect(0, 125217, '\P{ _IS_changes_When_Casefolded}', "");
    Expect(1, 125217, '\P{^ _IS_changes_When_Casefolded}', "");
    Expect(0, 125218, '\p{ _IS_changes_When_Casefolded}', "");
    Expect(1, 125218, '\p{^ _IS_changes_When_Casefolded}', "");
    Expect(1, 125218, '\P{ _IS_changes_When_Casefolded}', "");
    Expect(0, 125218, '\P{^ _IS_changes_When_Casefolded}', "");
    Error('\p{/a/ cwcf}');
    Error('\P{/a/ cwcf}');
    Expect(1, 125217, '\p{cwcf}', "");
    Expect(0, 125217, '\p{^cwcf}', "");
    Expect(0, 125217, '\P{cwcf}', "");
    Expect(1, 125217, '\P{^cwcf}', "");
    Expect(0, 125218, '\p{cwcf}', "");
    Expect(1, 125218, '\p{^cwcf}', "");
    Expect(1, 125218, '\P{cwcf}', "");
    Expect(0, 125218, '\P{^cwcf}', "");
    Expect(1, 125217, '\p{	 CWCF}', "");
    Expect(0, 125217, '\p{^	 CWCF}', "");
    Expect(0, 125217, '\P{	 CWCF}', "");
    Expect(1, 125217, '\P{^	 CWCF}', "");
    Expect(0, 125218, '\p{	 CWCF}', "");
    Expect(1, 125218, '\p{^	 CWCF}', "");
    Expect(1, 125218, '\P{	 CWCF}', "");
    Expect(0, 125218, '\P{^	 CWCF}', "");
    Error('\p{	Is_CWCF:=}');
    Error('\P{	Is_CWCF:=}');
    Expect(1, 125217, '\p{iscwcf}', "");
    Expect(0, 125217, '\p{^iscwcf}', "");
    Expect(0, 125217, '\P{iscwcf}', "");
    Expect(1, 125217, '\P{^iscwcf}', "");
    Expect(0, 125218, '\p{iscwcf}', "");
    Expect(1, 125218, '\p{^iscwcf}', "");
    Expect(1, 125218, '\P{iscwcf}', "");
    Expect(0, 125218, '\P{^iscwcf}', "");
    Expect(1, 125217, '\p{ Is_CWCF}', "");
    Expect(0, 125217, '\p{^ Is_CWCF}', "");
    Expect(0, 125217, '\P{ Is_CWCF}', "");
    Expect(1, 125217, '\P{^ Is_CWCF}', "");
    Expect(0, 125218, '\p{ Is_CWCF}', "");
    Expect(1, 125218, '\p{^ Is_CWCF}', "");
    Expect(1, 125218, '\P{ Is_CWCF}', "");
    Expect(0, 125218, '\P{^ Is_CWCF}', "");
    Error('\p{_CHANGES_when_casemapped/a/}');
    Error('\P{_CHANGES_when_casemapped/a/}');
    Expect(1, 125251, '\p{changeswhencasemapped}', "");
    Expect(0, 125251, '\p{^changeswhencasemapped}', "");
    Expect(0, 125251, '\P{changeswhencasemapped}', "");
    Expect(1, 125251, '\P{^changeswhencasemapped}', "");
    Expect(0, 125252, '\p{changeswhencasemapped}', "");
    Expect(1, 125252, '\p{^changeswhencasemapped}', "");
    Expect(1, 125252, '\P{changeswhencasemapped}', "");
    Expect(0, 125252, '\P{^changeswhencasemapped}', "");
    Expect(1, 125251, '\p{-Changes_when_Casemapped}', "");
    Expect(0, 125251, '\p{^-Changes_when_Casemapped}', "");
    Expect(0, 125251, '\P{-Changes_when_Casemapped}', "");
    Expect(1, 125251, '\P{^-Changes_when_Casemapped}', "");
    Expect(0, 125252, '\p{-Changes_when_Casemapped}', "");
    Expect(1, 125252, '\p{^-Changes_when_Casemapped}', "");
    Expect(1, 125252, '\P{-Changes_when_Casemapped}', "");
    Expect(0, 125252, '\P{^-Changes_when_Casemapped}', "");
    Error('\p{/a/_-Is_Changes_WHEN_CASEMAPPED}');
    Error('\P{/a/_-Is_Changes_WHEN_CASEMAPPED}');
    Expect(1, 125251, '\p{ischangeswhencasemapped}', "");
    Expect(0, 125251, '\p{^ischangeswhencasemapped}', "");
    Expect(0, 125251, '\P{ischangeswhencasemapped}', "");
    Expect(1, 125251, '\P{^ischangeswhencasemapped}', "");
    Expect(0, 125252, '\p{ischangeswhencasemapped}', "");
    Expect(1, 125252, '\p{^ischangeswhencasemapped}', "");
    Expect(1, 125252, '\P{ischangeswhencasemapped}', "");
    Expect(0, 125252, '\P{^ischangeswhencasemapped}', "");
    Expect(1, 125251, '\p{-Is_changes_When_Casemapped}', "");
    Expect(0, 125251, '\p{^-Is_changes_When_Casemapped}', "");
    Expect(0, 125251, '\P{-Is_changes_When_Casemapped}', "");
    Expect(1, 125251, '\P{^-Is_changes_When_Casemapped}', "");
    Expect(0, 125252, '\p{-Is_changes_When_Casemapped}', "");
    Expect(1, 125252, '\p{^-Is_changes_When_Casemapped}', "");
    Expect(1, 125252, '\P{-Is_changes_When_Casemapped}', "");
    Expect(0, 125252, '\P{^-Is_changes_When_Casemapped}', "");
    Error('\p{ :=cwcm}');
    Error('\P{ :=cwcm}');
    Expect(1, 125251, '\p{cwcm}', "");
    Expect(0, 125251, '\p{^cwcm}', "");
    Expect(0, 125251, '\P{cwcm}', "");
    Expect(1, 125251, '\P{^cwcm}', "");
    Expect(0, 125252, '\p{cwcm}', "");
    Expect(1, 125252, '\p{^cwcm}', "");
    Expect(1, 125252, '\P{cwcm}', "");
    Expect(0, 125252, '\P{^cwcm}', "");
    Expect(1, 125251, '\p{	CWCM}', "");
    Expect(0, 125251, '\p{^	CWCM}', "");
    Expect(0, 125251, '\P{	CWCM}', "");
    Expect(1, 125251, '\P{^	CWCM}', "");
    Expect(0, 125252, '\p{	CWCM}', "");
    Expect(1, 125252, '\p{^	CWCM}', "");
    Expect(1, 125252, '\P{	CWCM}', "");
    Expect(0, 125252, '\P{^	CWCM}', "");
    Error('\p{-IS_CWCM/a/}');
    Error('\P{-IS_CWCM/a/}');
    Expect(1, 125251, '\p{iscwcm}', "");
    Expect(0, 125251, '\p{^iscwcm}', "");
    Expect(0, 125251, '\P{iscwcm}', "");
    Expect(1, 125251, '\P{^iscwcm}', "");
    Expect(0, 125252, '\p{iscwcm}', "");
    Expect(1, 125252, '\p{^iscwcm}', "");
    Expect(1, 125252, '\P{iscwcm}', "");
    Expect(0, 125252, '\P{^iscwcm}', "");
    Expect(1, 125251, '\p{ Is_CWCM}', "");
    Expect(0, 125251, '\p{^ Is_CWCM}', "");
    Expect(0, 125251, '\P{ Is_CWCM}', "");
    Expect(1, 125251, '\P{^ Is_CWCM}', "");
    Expect(0, 125252, '\p{ Is_CWCM}', "");
    Expect(1, 125252, '\p{^ Is_CWCM}', "");
    Expect(1, 125252, '\P{ Is_CWCM}', "");
    Expect(0, 125252, '\P{^ Is_CWCM}', "");
    Error('\p{ /a/Changes_When_Lowercased}');
    Error('\P{ /a/Changes_When_Lowercased}');
    Expect(1, 125217, '\p{changeswhenlowercased}', "");
    Expect(0, 125217, '\p{^changeswhenlowercased}', "");
    Expect(0, 125217, '\P{changeswhenlowercased}', "");
    Expect(1, 125217, '\P{^changeswhenlowercased}', "");
    Expect(0, 125218, '\p{changeswhenlowercased}', "");
    Expect(1, 125218, '\p{^changeswhenlowercased}', "");
    Expect(1, 125218, '\P{changeswhenlowercased}', "");
    Expect(0, 125218, '\P{^changeswhenlowercased}', "");
    Expect(1, 125217, '\p{-_Changes_when_lowercased}', "");
    Expect(0, 125217, '\p{^-_Changes_when_lowercased}', "");
    Expect(0, 125217, '\P{-_Changes_when_lowercased}', "");
    Expect(1, 125217, '\P{^-_Changes_when_lowercased}', "");
    Expect(0, 125218, '\p{-_Changes_when_lowercased}', "");
    Expect(1, 125218, '\p{^-_Changes_when_lowercased}', "");
    Expect(1, 125218, '\P{-_Changes_when_lowercased}', "");
    Expect(0, 125218, '\P{^-_Changes_when_lowercased}', "");
    Error('\p{_IS_Changes_When_Lowercased/a/}');
    Error('\P{_IS_Changes_When_Lowercased/a/}');
    Expect(1, 125217, '\p{ischangeswhenlowercased}', "");
    Expect(0, 125217, '\p{^ischangeswhenlowercased}', "");
    Expect(0, 125217, '\P{ischangeswhenlowercased}', "");
    Expect(1, 125217, '\P{^ischangeswhenlowercased}', "");
    Expect(0, 125218, '\p{ischangeswhenlowercased}', "");
    Expect(1, 125218, '\p{^ischangeswhenlowercased}', "");
    Expect(1, 125218, '\P{ischangeswhenlowercased}', "");
    Expect(0, 125218, '\P{^ischangeswhenlowercased}', "");
    Expect(1, 125217, '\p{	-is_Changes_when_LOWERCASED}', "");
    Expect(0, 125217, '\p{^	-is_Changes_when_LOWERCASED}', "");
    Expect(0, 125217, '\P{	-is_Changes_when_LOWERCASED}', "");
    Expect(1, 125217, '\P{^	-is_Changes_when_LOWERCASED}', "");
    Expect(0, 125218, '\p{	-is_Changes_when_LOWERCASED}', "");
    Expect(1, 125218, '\p{^	-is_Changes_when_LOWERCASED}', "");
    Expect(1, 125218, '\P{	-is_Changes_when_LOWERCASED}', "");
    Expect(0, 125218, '\P{^	-is_Changes_when_LOWERCASED}', "");
    Error('\p{-:=CWL}');
    Error('\P{-:=CWL}');
    Expect(1, 125217, '\p{cwl}', "");
    Expect(0, 125217, '\p{^cwl}', "");
    Expect(0, 125217, '\P{cwl}', "");
    Expect(1, 125217, '\P{^cwl}', "");
    Expect(0, 125218, '\p{cwl}', "");
    Expect(1, 125218, '\p{^cwl}', "");
    Expect(1, 125218, '\P{cwl}', "");
    Expect(0, 125218, '\P{^cwl}', "");
    Expect(1, 125217, '\p{-CWL}', "");
    Expect(0, 125217, '\p{^-CWL}', "");
    Expect(0, 125217, '\P{-CWL}', "");
    Expect(1, 125217, '\P{^-CWL}', "");
    Expect(0, 125218, '\p{-CWL}', "");
    Expect(1, 125218, '\p{^-CWL}', "");
    Expect(1, 125218, '\P{-CWL}', "");
    Expect(0, 125218, '\P{^-CWL}', "");
    Error('\p{-Is_CWL:=}');
    Error('\P{-Is_CWL:=}');
    Expect(1, 125217, '\p{iscwl}', "");
    Expect(0, 125217, '\p{^iscwl}', "");
    Expect(0, 125217, '\P{iscwl}', "");
    Expect(1, 125217, '\P{^iscwl}', "");
    Expect(0, 125218, '\p{iscwl}', "");
    Expect(1, 125218, '\p{^iscwl}', "");
    Expect(1, 125218, '\P{iscwl}', "");
    Expect(0, 125218, '\P{^iscwl}', "");
    Expect(1, 125217, '\p{  Is_CWL}', "");
    Expect(0, 125217, '\p{^  Is_CWL}', "");
    Expect(0, 125217, '\P{  Is_CWL}', "");
    Expect(1, 125217, '\P{^  Is_CWL}', "");
    Expect(0, 125218, '\p{  Is_CWL}', "");
    Expect(1, 125218, '\p{^  Is_CWL}', "");
    Expect(1, 125218, '\P{  Is_CWL}', "");
    Expect(0, 125218, '\P{^  Is_CWL}', "");
    Error('\p{/a/- Changes_when_NFKC_casefolded}');
    Error('\P{/a/- Changes_when_NFKC_casefolded}');
    Expect(1, 921599, '\p{changeswhennfkccasefolded}', "");
    Expect(0, 921599, '\p{^changeswhennfkccasefolded}', "");
    Expect(0, 921599, '\P{changeswhennfkccasefolded}', "");
    Expect(1, 921599, '\P{^changeswhennfkccasefolded}', "");
    Expect(0, 921600, '\p{changeswhennfkccasefolded}', "");
    Expect(1, 921600, '\p{^changeswhennfkccasefolded}', "");
    Expect(1, 921600, '\P{changeswhennfkccasefolded}', "");
    Expect(0, 921600, '\P{^changeswhennfkccasefolded}', "");
    Expect(1, 921599, '\p{		CHANGES_When_NFKC_Casefolded}', "");
    Expect(0, 921599, '\p{^		CHANGES_When_NFKC_Casefolded}', "");
    Expect(0, 921599, '\P{		CHANGES_When_NFKC_Casefolded}', "");
    Expect(1, 921599, '\P{^		CHANGES_When_NFKC_Casefolded}', "");
    Expect(0, 921600, '\p{		CHANGES_When_NFKC_Casefolded}', "");
    Expect(1, 921600, '\p{^		CHANGES_When_NFKC_Casefolded}', "");
    Expect(1, 921600, '\P{		CHANGES_When_NFKC_Casefolded}', "");
    Expect(0, 921600, '\P{^		CHANGES_When_NFKC_Casefolded}', "");
    Error('\p{ is_changes_When_nfkc_casefolded:=}');
    Error('\P{ is_changes_When_nfkc_casefolded:=}');
    Expect(1, 921599, '\p{ischangeswhennfkccasefolded}', "");
    Expect(0, 921599, '\p{^ischangeswhennfkccasefolded}', "");
    Expect(0, 921599, '\P{ischangeswhennfkccasefolded}', "");
    Expect(1, 921599, '\P{^ischangeswhennfkccasefolded}', "");
    Expect(0, 921600, '\p{ischangeswhennfkccasefolded}', "");
    Expect(1, 921600, '\p{^ischangeswhennfkccasefolded}', "");
    Expect(1, 921600, '\P{ischangeswhennfkccasefolded}', "");
    Expect(0, 921600, '\P{^ischangeswhennfkccasefolded}', "");
    Expect(1, 921599, '\p{-IS_CHANGES_When_NFKC_casefolded}', "");
    Expect(0, 921599, '\p{^-IS_CHANGES_When_NFKC_casefolded}', "");
    Expect(0, 921599, '\P{-IS_CHANGES_When_NFKC_casefolded}', "");
    Expect(1, 921599, '\P{^-IS_CHANGES_When_NFKC_casefolded}', "");
    Expect(0, 921600, '\p{-IS_CHANGES_When_NFKC_casefolded}', "");
    Expect(1, 921600, '\p{^-IS_CHANGES_When_NFKC_casefolded}', "");
    Expect(1, 921600, '\P{-IS_CHANGES_When_NFKC_casefolded}', "");
    Expect(0, 921600, '\P{^-IS_CHANGES_When_NFKC_casefolded}', "");
    Error('\p{-/a/CWKCF}');
    Error('\P{-/a/CWKCF}');
    Expect(1, 921599, '\p{cwkcf}', "");
    Expect(0, 921599, '\p{^cwkcf}', "");
    Expect(0, 921599, '\P{cwkcf}', "");
    Expect(1, 921599, '\P{^cwkcf}', "");
    Expect(0, 921600, '\p{cwkcf}', "");
    Expect(1, 921600, '\p{^cwkcf}', "");
    Expect(1, 921600, '\P{cwkcf}', "");
    Expect(0, 921600, '\P{^cwkcf}', "");
    Expect(1, 921599, '\p{	_CWKCF}', "");
    Expect(0, 921599, '\p{^	_CWKCF}', "");
    Expect(0, 921599, '\P{	_CWKCF}', "");
    Expect(1, 921599, '\P{^	_CWKCF}', "");
    Expect(0, 921600, '\p{	_CWKCF}', "");
    Expect(1, 921600, '\p{^	_CWKCF}', "");
    Expect(1, 921600, '\P{	_CWKCF}', "");
    Expect(0, 921600, '\P{^	_CWKCF}', "");
    Error('\p{	-is_CWKCF/a/}');
    Error('\P{	-is_CWKCF/a/}');
    Expect(1, 921599, '\p{iscwkcf}', "");
    Expect(0, 921599, '\p{^iscwkcf}', "");
    Expect(0, 921599, '\P{iscwkcf}', "");
    Expect(1, 921599, '\P{^iscwkcf}', "");
    Expect(0, 921600, '\p{iscwkcf}', "");
    Expect(1, 921600, '\p{^iscwkcf}', "");
    Expect(1, 921600, '\P{iscwkcf}', "");
    Expect(0, 921600, '\P{^iscwkcf}', "");
    Expect(1, 921599, '\p{--is_CWKCF}', "");
    Expect(0, 921599, '\p{^--is_CWKCF}', "");
    Expect(0, 921599, '\P{--is_CWKCF}', "");
    Expect(1, 921599, '\P{^--is_CWKCF}', "");
    Expect(0, 921600, '\p{--is_CWKCF}', "");
    Expect(1, 921600, '\p{^--is_CWKCF}', "");
    Expect(1, 921600, '\P{--is_CWKCF}', "");
    Expect(0, 921600, '\P{^--is_CWKCF}', "");
    Error('\p{:=_changes_When_titlecased}');
    Error('\P{:=_changes_When_titlecased}');
    Expect(1, 125251, '\p{changeswhentitlecased}', "");
    Expect(0, 125251, '\p{^changeswhentitlecased}', "");
    Expect(0, 125251, '\P{changeswhentitlecased}', "");
    Expect(1, 125251, '\P{^changeswhentitlecased}', "");
    Expect(0, 125252, '\p{changeswhentitlecased}', "");
    Expect(1, 125252, '\p{^changeswhentitlecased}', "");
    Expect(1, 125252, '\P{changeswhentitlecased}', "");
    Expect(0, 125252, '\P{^changeswhentitlecased}', "");
    Expect(1, 125251, '\p{-	CHANGES_When_Titlecased}', "");
    Expect(0, 125251, '\p{^-	CHANGES_When_Titlecased}', "");
    Expect(0, 125251, '\P{-	CHANGES_When_Titlecased}', "");
    Expect(1, 125251, '\P{^-	CHANGES_When_Titlecased}', "");
    Expect(0, 125252, '\p{-	CHANGES_When_Titlecased}', "");
    Expect(1, 125252, '\p{^-	CHANGES_When_Titlecased}', "");
    Expect(1, 125252, '\P{-	CHANGES_When_Titlecased}', "");
    Expect(0, 125252, '\P{^-	CHANGES_When_Titlecased}', "");
    Error('\p{	-Is_Changes_When_Titlecased/a/}');
    Error('\P{	-Is_Changes_When_Titlecased/a/}');
    Expect(1, 125251, '\p{ischangeswhentitlecased}', "");
    Expect(0, 125251, '\p{^ischangeswhentitlecased}', "");
    Expect(0, 125251, '\P{ischangeswhentitlecased}', "");
    Expect(1, 125251, '\P{^ischangeswhentitlecased}', "");
    Expect(0, 125252, '\p{ischangeswhentitlecased}', "");
    Expect(1, 125252, '\p{^ischangeswhentitlecased}', "");
    Expect(1, 125252, '\P{ischangeswhentitlecased}', "");
    Expect(0, 125252, '\P{^ischangeswhentitlecased}', "");
    Expect(1, 125251, '\p{_-is_Changes_WHEN_Titlecased}', "");
    Expect(0, 125251, '\p{^_-is_Changes_WHEN_Titlecased}', "");
    Expect(0, 125251, '\P{_-is_Changes_WHEN_Titlecased}', "");
    Expect(1, 125251, '\P{^_-is_Changes_WHEN_Titlecased}', "");
    Expect(0, 125252, '\p{_-is_Changes_WHEN_Titlecased}', "");
    Expect(1, 125252, '\p{^_-is_Changes_WHEN_Titlecased}', "");
    Expect(1, 125252, '\P{_-is_Changes_WHEN_Titlecased}', "");
    Expect(0, 125252, '\P{^_-is_Changes_WHEN_Titlecased}', "");
    Error('\p{	/a/CWT}');
    Error('\P{	/a/CWT}');
    Expect(1, 125251, '\p{cwt}', "");
    Expect(0, 125251, '\p{^cwt}', "");
    Expect(0, 125251, '\P{cwt}', "");
    Expect(1, 125251, '\P{^cwt}', "");
    Expect(0, 125252, '\p{cwt}', "");
    Expect(1, 125252, '\p{^cwt}', "");
    Expect(1, 125252, '\P{cwt}', "");
    Expect(0, 125252, '\P{^cwt}', "");
    Expect(1, 125251, '\p{	_CWT}', "");
    Expect(0, 125251, '\p{^	_CWT}', "");
    Expect(0, 125251, '\P{	_CWT}', "");
    Expect(1, 125251, '\P{^	_CWT}', "");
    Expect(0, 125252, '\p{	_CWT}', "");
    Expect(1, 125252, '\p{^	_CWT}', "");
    Expect(1, 125252, '\P{	_CWT}', "");
    Expect(0, 125252, '\P{^	_CWT}', "");
    Error('\p{		is_CWT:=}');
    Error('\P{		is_CWT:=}');
    Expect(1, 125251, '\p{iscwt}', "");
    Expect(0, 125251, '\p{^iscwt}', "");
    Expect(0, 125251, '\P{iscwt}', "");
    Expect(1, 125251, '\P{^iscwt}', "");
    Expect(0, 125252, '\p{iscwt}', "");
    Expect(1, 125252, '\p{^iscwt}', "");
    Expect(1, 125252, '\P{iscwt}', "");
    Expect(0, 125252, '\P{^iscwt}', "");
    Expect(1, 125251, '\p{ 	is_cwt}', "");
    Expect(0, 125251, '\p{^ 	is_cwt}', "");
    Expect(0, 125251, '\P{ 	is_cwt}', "");
    Expect(1, 125251, '\P{^ 	is_cwt}', "");
    Expect(0, 125252, '\p{ 	is_cwt}', "");
    Expect(1, 125252, '\p{^ 	is_cwt}', "");
    Expect(1, 125252, '\P{ 	is_cwt}', "");
    Expect(0, 125252, '\P{^ 	is_cwt}', "");
    Error('\p{:=-_Changes_When_UPPERCASED}');
    Error('\P{:=-_Changes_When_UPPERCASED}');
    Expect(1, 125251, '\p{changeswhenuppercased}', "");
    Expect(0, 125251, '\p{^changeswhenuppercased}', "");
    Expect(0, 125251, '\P{changeswhenuppercased}', "");
    Expect(1, 125251, '\P{^changeswhenuppercased}', "");
    Expect(0, 125252, '\p{changeswhenuppercased}', "");
    Expect(1, 125252, '\p{^changeswhenuppercased}', "");
    Expect(1, 125252, '\P{changeswhenuppercased}', "");
    Expect(0, 125252, '\P{^changeswhenuppercased}', "");
    Expect(1, 125251, '\p{_Changes_when_Uppercased}', "");
    Expect(0, 125251, '\p{^_Changes_when_Uppercased}', "");
    Expect(0, 125251, '\P{_Changes_when_Uppercased}', "");
    Expect(1, 125251, '\P{^_Changes_when_Uppercased}', "");
    Expect(0, 125252, '\p{_Changes_when_Uppercased}', "");
    Expect(1, 125252, '\p{^_Changes_when_Uppercased}', "");
    Expect(1, 125252, '\P{_Changes_when_Uppercased}', "");
    Expect(0, 125252, '\P{^_Changes_when_Uppercased}', "");
    Error('\p{:=_-IS_Changes_When_Uppercased}');
    Error('\P{:=_-IS_Changes_When_Uppercased}');
    Expect(1, 125251, '\p{ischangeswhenuppercased}', "");
    Expect(0, 125251, '\p{^ischangeswhenuppercased}', "");
    Expect(0, 125251, '\P{ischangeswhenuppercased}', "");
    Expect(1, 125251, '\P{^ischangeswhenuppercased}', "");
    Expect(0, 125252, '\p{ischangeswhenuppercased}', "");
    Expect(1, 125252, '\p{^ischangeswhenuppercased}', "");
    Expect(1, 125252, '\P{ischangeswhenuppercased}', "");
    Expect(0, 125252, '\P{^ischangeswhenuppercased}', "");
    Expect(1, 125251, '\p{	_is_changes_WHEN_Uppercased}', "");
    Expect(0, 125251, '\p{^	_is_changes_WHEN_Uppercased}', "");
    Expect(0, 125251, '\P{	_is_changes_WHEN_Uppercased}', "");
    Expect(1, 125251, '\P{^	_is_changes_WHEN_Uppercased}', "");
    Expect(0, 125252, '\p{	_is_changes_WHEN_Uppercased}', "");
    Expect(1, 125252, '\p{^	_is_changes_WHEN_Uppercased}', "");
    Expect(1, 125252, '\P{	_is_changes_WHEN_Uppercased}', "");
    Expect(0, 125252, '\P{^	_is_changes_WHEN_Uppercased}', "");
    Error('\p{-CWU:=}');
    Error('\P{-CWU:=}');
    Expect(1, 125251, '\p{cwu}', "");
    Expect(0, 125251, '\p{^cwu}', "");
    Expect(0, 125251, '\P{cwu}', "");
    Expect(1, 125251, '\P{^cwu}', "");
    Expect(0, 125252, '\p{cwu}', "");
    Expect(1, 125252, '\p{^cwu}', "");
    Expect(1, 125252, '\P{cwu}', "");
    Expect(0, 125252, '\P{^cwu}', "");
    Expect(1, 125251, '\p{	CWU}', "");
    Expect(0, 125251, '\p{^	CWU}', "");
    Expect(0, 125251, '\P{	CWU}', "");
    Expect(1, 125251, '\P{^	CWU}', "");
    Expect(0, 125252, '\p{	CWU}', "");
    Expect(1, 125252, '\p{^	CWU}', "");
    Expect(1, 125252, '\P{	CWU}', "");
    Expect(0, 125252, '\P{^	CWU}', "");
    Error('\p{_IS_CWU/a/}');
    Error('\P{_IS_CWU/a/}');
    Expect(1, 125251, '\p{iscwu}', "");
    Expect(0, 125251, '\p{^iscwu}', "");
    Expect(0, 125251, '\P{iscwu}', "");
    Expect(1, 125251, '\P{^iscwu}', "");
    Expect(0, 125252, '\p{iscwu}', "");
    Expect(1, 125252, '\p{^iscwu}', "");
    Expect(1, 125252, '\P{iscwu}', "");
    Expect(0, 125252, '\P{^iscwu}', "");
    Expect(1, 125251, '\p{_Is_CWU}', "");
    Expect(0, 125251, '\p{^_Is_CWU}', "");
    Expect(0, 125251, '\P{_Is_CWU}', "");
    Expect(1, 125251, '\P{^_Is_CWU}', "");
    Expect(0, 125252, '\p{_Is_CWU}', "");
    Expect(1, 125252, '\p{^_Is_CWU}', "");
    Expect(1, 125252, '\P{_Is_CWU}', "");
    Expect(0, 125252, '\P{^_Is_CWU}', "");
    Error('\p{	:=CHEROKEE}');
    Error('\P{	:=CHEROKEE}');
    Expect(1, 43967, '\p{cherokee}', "");
    Expect(0, 43967, '\p{^cherokee}', "");
    Expect(0, 43967, '\P{cherokee}', "");
    Expect(1, 43967, '\P{^cherokee}', "");
    Expect(0, 43968, '\p{cherokee}', "");
    Expect(1, 43968, '\p{^cherokee}', "");
    Expect(1, 43968, '\P{cherokee}', "");
    Expect(0, 43968, '\P{^cherokee}', "");
    Expect(1, 43967, '\p{_Cherokee}', "");
    Expect(0, 43967, '\p{^_Cherokee}', "");
    Expect(0, 43967, '\P{_Cherokee}', "");
    Expect(1, 43967, '\P{^_Cherokee}', "");
    Expect(0, 43968, '\p{_Cherokee}', "");
    Expect(1, 43968, '\p{^_Cherokee}', "");
    Expect(1, 43968, '\P{_Cherokee}', "");
    Expect(0, 43968, '\P{^_Cherokee}', "");
    Error('\p{ Is_cherokee/a/}');
    Error('\P{ Is_cherokee/a/}');
    Expect(1, 43967, '\p{ischerokee}', "");
    Expect(0, 43967, '\p{^ischerokee}', "");
    Expect(0, 43967, '\P{ischerokee}', "");
    Expect(1, 43967, '\P{^ischerokee}', "");
    Expect(0, 43968, '\p{ischerokee}', "");
    Expect(1, 43968, '\p{^ischerokee}', "");
    Expect(1, 43968, '\P{ischerokee}', "");
    Expect(0, 43968, '\P{^ischerokee}', "");
    Expect(1, 43967, '\p{_IS_cherokee}', "");
    Expect(0, 43967, '\p{^_IS_cherokee}', "");
    Expect(0, 43967, '\P{_IS_cherokee}', "");
    Expect(1, 43967, '\P{^_IS_cherokee}', "");
    Expect(0, 43968, '\p{_IS_cherokee}', "");
    Expect(1, 43968, '\p{^_IS_cherokee}', "");
    Expect(1, 43968, '\P{_IS_cherokee}', "");
    Expect(0, 43968, '\P{^_IS_cherokee}', "");
    Error('\p{:=-	CHER}');
    Error('\P{:=-	CHER}');
    Expect(1, 43967, '\p{cher}', "");
    Expect(0, 43967, '\p{^cher}', "");
    Expect(0, 43967, '\P{cher}', "");
    Expect(1, 43967, '\P{^cher}', "");
    Expect(0, 43968, '\p{cher}', "");
    Expect(1, 43968, '\p{^cher}', "");
    Expect(1, 43968, '\P{cher}', "");
    Expect(0, 43968, '\P{^cher}', "");
    Expect(1, 43967, '\p{_ cher}', "");
    Expect(0, 43967, '\p{^_ cher}', "");
    Expect(0, 43967, '\P{_ cher}', "");
    Expect(1, 43967, '\P{^_ cher}', "");
    Expect(0, 43968, '\p{_ cher}', "");
    Expect(1, 43968, '\p{^_ cher}', "");
    Expect(1, 43968, '\P{_ cher}', "");
    Expect(0, 43968, '\P{^_ cher}', "");
    Error('\p{ /a/Is_Cher}');
    Error('\P{ /a/Is_Cher}');
    Expect(1, 43967, '\p{ischer}', "");
    Expect(0, 43967, '\p{^ischer}', "");
    Expect(0, 43967, '\P{ischer}', "");
    Expect(1, 43967, '\P{^ischer}', "");
    Expect(0, 43968, '\p{ischer}', "");
    Expect(1, 43968, '\p{^ischer}', "");
    Expect(1, 43968, '\P{ischer}', "");
    Expect(0, 43968, '\P{^ischer}', "");
    Expect(1, 43967, '\p{_-Is_Cher}', "");
    Expect(0, 43967, '\p{^_-Is_Cher}', "");
    Expect(0, 43967, '\P{_-Is_Cher}', "");
    Expect(1, 43967, '\P{^_-Is_Cher}', "");
    Expect(0, 43968, '\p{_-Is_Cher}', "");
    Expect(1, 43968, '\p{^_-Is_Cher}', "");
    Expect(1, 43968, '\P{_-Is_Cher}', "");
    Expect(0, 43968, '\P{^_-Is_Cher}', "");
    Error('\p{cherokee_supplement:=}');
    Error('\P{cherokee_supplement:=}');
    Expect(1, 43967, '\p{cherokeesupplement}', "");
    Expect(0, 43967, '\p{^cherokeesupplement}', "");
    Expect(0, 43967, '\P{cherokeesupplement}', "");
    Expect(1, 43967, '\P{^cherokeesupplement}', "");
    Expect(0, 43968, '\p{cherokeesupplement}', "");
    Expect(1, 43968, '\p{^cherokeesupplement}', "");
    Expect(1, 43968, '\P{cherokeesupplement}', "");
    Expect(0, 43968, '\P{^cherokeesupplement}', "");
    Expect(1, 43967, '\p{	-Cherokee_Supplement}', "");
    Expect(0, 43967, '\p{^	-Cherokee_Supplement}', "");
    Expect(0, 43967, '\P{	-Cherokee_Supplement}', "");
    Expect(1, 43967, '\P{^	-Cherokee_Supplement}', "");
    Expect(0, 43968, '\p{	-Cherokee_Supplement}', "");
    Expect(1, 43968, '\p{^	-Cherokee_Supplement}', "");
    Expect(1, 43968, '\P{	-Cherokee_Supplement}', "");
    Expect(0, 43968, '\P{^	-Cherokee_Supplement}', "");
    Error('\p{_:=IS_cherokee_SUPPLEMENT}');
    Error('\P{_:=IS_cherokee_SUPPLEMENT}');
    Expect(1, 43967, '\p{ischerokeesupplement}', "");
    Expect(0, 43967, '\p{^ischerokeesupplement}', "");
    Expect(0, 43967, '\P{ischerokeesupplement}', "");
    Expect(1, 43967, '\P{^ischerokeesupplement}', "");
    Expect(0, 43968, '\p{ischerokeesupplement}', "");
    Expect(1, 43968, '\p{^ischerokeesupplement}', "");
    Expect(1, 43968, '\P{ischerokeesupplement}', "");
    Expect(0, 43968, '\P{^ischerokeesupplement}', "");
    Expect(1, 43967, '\p{	-is_Cherokee_Supplement}', "");
    Expect(0, 43967, '\p{^	-is_Cherokee_Supplement}', "");
    Expect(0, 43967, '\P{	-is_Cherokee_Supplement}', "");
    Expect(1, 43967, '\P{^	-is_Cherokee_Supplement}', "");
    Expect(0, 43968, '\p{	-is_Cherokee_Supplement}', "");
    Expect(1, 43968, '\p{^	-is_Cherokee_Supplement}', "");
    Expect(1, 43968, '\P{	-is_Cherokee_Supplement}', "");
    Expect(0, 43968, '\P{^	-is_Cherokee_Supplement}', "");
    Error('\p{/a/__in_CHEROKEE_Supplement}');
    Error('\P{/a/__in_CHEROKEE_Supplement}');
    Expect(1, 43967, '\p{incherokeesupplement}', "");
    Expect(0, 43967, '\p{^incherokeesupplement}', "");
    Expect(0, 43967, '\P{incherokeesupplement}', "");
    Expect(1, 43967, '\P{^incherokeesupplement}', "");
    Expect(0, 43968, '\p{incherokeesupplement}', "");
    Expect(1, 43968, '\p{^incherokeesupplement}', "");
    Expect(1, 43968, '\P{incherokeesupplement}', "");
    Expect(0, 43968, '\P{^incherokeesupplement}', "");
    Expect(1, 43967, '\p{	 in_cherokee_supplement}', "");
    Expect(0, 43967, '\p{^	 in_cherokee_supplement}', "");
    Expect(0, 43967, '\P{	 in_cherokee_supplement}', "");
    Expect(1, 43967, '\P{^	 in_cherokee_supplement}', "");
    Expect(0, 43968, '\p{	 in_cherokee_supplement}', "");
    Expect(1, 43968, '\p{^	 in_cherokee_supplement}', "");
    Expect(1, 43968, '\P{	 in_cherokee_supplement}', "");
    Expect(0, 43968, '\P{^	 in_cherokee_supplement}', "");
    Error('\p{ /a/CHEROKEE_SUP}');
    Error('\P{ /a/CHEROKEE_SUP}');
    Expect(1, 43967, '\p{cherokeesup}', "");
    Expect(0, 43967, '\p{^cherokeesup}', "");
    Expect(0, 43967, '\P{cherokeesup}', "");
    Expect(1, 43967, '\P{^cherokeesup}', "");
    Expect(0, 43968, '\p{cherokeesup}', "");
    Expect(1, 43968, '\p{^cherokeesup}', "");
    Expect(1, 43968, '\P{cherokeesup}', "");
    Expect(0, 43968, '\P{^cherokeesup}', "");
    Expect(1, 43967, '\p{-_Cherokee_Sup}', "");
    Expect(0, 43967, '\p{^-_Cherokee_Sup}', "");
    Expect(0, 43967, '\P{-_Cherokee_Sup}', "");
    Expect(1, 43967, '\P{^-_Cherokee_Sup}', "");
    Expect(0, 43968, '\p{-_Cherokee_Sup}', "");
    Expect(1, 43968, '\p{^-_Cherokee_Sup}', "");
    Expect(1, 43968, '\P{-_Cherokee_Sup}', "");
    Expect(0, 43968, '\P{^-_Cherokee_Sup}', "");
    Error('\p{/a/ _is_Cherokee_Sup}');
    Error('\P{/a/ _is_Cherokee_Sup}');
    Expect(1, 43967, '\p{ischerokeesup}', "");
    Expect(0, 43967, '\p{^ischerokeesup}', "");
    Expect(0, 43967, '\P{ischerokeesup}', "");
    Expect(1, 43967, '\P{^ischerokeesup}', "");
    Expect(0, 43968, '\p{ischerokeesup}', "");
    Expect(1, 43968, '\p{^ischerokeesup}', "");
    Expect(1, 43968, '\P{ischerokeesup}', "");
    Expect(0, 43968, '\P{^ischerokeesup}', "");
    Expect(1, 43967, '\p{		Is_cherokee_Sup}', "");
    Expect(0, 43967, '\p{^		Is_cherokee_Sup}', "");
    Expect(0, 43967, '\P{		Is_cherokee_Sup}', "");
    Expect(1, 43967, '\P{^		Is_cherokee_Sup}', "");
    Expect(0, 43968, '\p{		Is_cherokee_Sup}', "");
    Expect(1, 43968, '\p{^		Is_cherokee_Sup}', "");
    Expect(1, 43968, '\P{		Is_cherokee_Sup}', "");
    Expect(0, 43968, '\P{^		Is_cherokee_Sup}', "");
    Error('\p{:= 	IN_Cherokee_SUP}');
    Error('\P{:= 	IN_Cherokee_SUP}');
    Expect(1, 43967, '\p{incherokeesup}', "");
    Expect(0, 43967, '\p{^incherokeesup}', "");
    Expect(0, 43967, '\P{incherokeesup}', "");
    Expect(1, 43967, '\P{^incherokeesup}', "");
    Expect(0, 43968, '\p{incherokeesup}', "");
    Expect(1, 43968, '\p{^incherokeesup}', "");
    Expect(1, 43968, '\P{incherokeesup}', "");
    Expect(0, 43968, '\P{^incherokeesup}', "");
    Expect(1, 43967, '\p{_	IN_Cherokee_Sup}', "");
    Expect(0, 43967, '\p{^_	IN_Cherokee_Sup}', "");
    Expect(0, 43967, '\P{_	IN_Cherokee_Sup}', "");
    Expect(1, 43967, '\P{^_	IN_Cherokee_Sup}', "");
    Expect(0, 43968, '\p{_	IN_Cherokee_Sup}', "");
    Expect(1, 43968, '\p{^_	IN_Cherokee_Sup}', "");
    Expect(1, 43968, '\P{_	IN_Cherokee_Sup}', "");
    Expect(0, 43968, '\P{^_	IN_Cherokee_Sup}', "");
    Error('\p{_Chess_Symbols/a/}');
    Error('\P{_Chess_Symbols/a/}');
    Expect(1, 129647, '\p{chesssymbols}', "");
    Expect(0, 129647, '\p{^chesssymbols}', "");
    Expect(0, 129647, '\P{chesssymbols}', "");
    Expect(1, 129647, '\P{^chesssymbols}', "");
    Expect(0, 129648, '\p{chesssymbols}', "");
    Expect(1, 129648, '\p{^chesssymbols}', "");
    Expect(1, 129648, '\P{chesssymbols}', "");
    Expect(0, 129648, '\P{^chesssymbols}', "");
    Expect(1, 129647, '\p{ Chess_Symbols}', "");
    Expect(0, 129647, '\p{^ Chess_Symbols}', "");
    Expect(0, 129647, '\P{ Chess_Symbols}', "");
    Expect(1, 129647, '\P{^ Chess_Symbols}', "");
    Expect(0, 129648, '\p{ Chess_Symbols}', "");
    Expect(1, 129648, '\p{^ Chess_Symbols}', "");
    Expect(1, 129648, '\P{ Chess_Symbols}', "");
    Expect(0, 129648, '\P{^ Chess_Symbols}', "");
    Error('\p{	 Is_CHESS_Symbols:=}');
    Error('\P{	 Is_CHESS_Symbols:=}');
    Expect(1, 129647, '\p{ischesssymbols}', "");
    Expect(0, 129647, '\p{^ischesssymbols}', "");
    Expect(0, 129647, '\P{ischesssymbols}', "");
    Expect(1, 129647, '\P{^ischesssymbols}', "");
    Expect(0, 129648, '\p{ischesssymbols}', "");
    Expect(1, 129648, '\p{^ischesssymbols}', "");
    Expect(1, 129648, '\P{ischesssymbols}', "");
    Expect(0, 129648, '\P{^ischesssymbols}', "");
    Expect(1, 129647, '\p{_-is_Chess_SYMBOLS}', "");
    Expect(0, 129647, '\p{^_-is_Chess_SYMBOLS}', "");
    Expect(0, 129647, '\P{_-is_Chess_SYMBOLS}', "");
    Expect(1, 129647, '\P{^_-is_Chess_SYMBOLS}', "");
    Expect(0, 129648, '\p{_-is_Chess_SYMBOLS}', "");
    Expect(1, 129648, '\p{^_-is_Chess_SYMBOLS}', "");
    Expect(1, 129648, '\P{_-is_Chess_SYMBOLS}', "");
    Expect(0, 129648, '\P{^_-is_Chess_SYMBOLS}', "");
    Error('\p{/a/_	In_CHESS_Symbols}');
    Error('\P{/a/_	In_CHESS_Symbols}');
    Expect(1, 129647, '\p{inchesssymbols}', "");
    Expect(0, 129647, '\p{^inchesssymbols}', "");
    Expect(0, 129647, '\P{inchesssymbols}', "");
    Expect(1, 129647, '\P{^inchesssymbols}', "");
    Expect(0, 129648, '\p{inchesssymbols}', "");
    Expect(1, 129648, '\p{^inchesssymbols}', "");
    Expect(1, 129648, '\P{inchesssymbols}', "");
    Expect(0, 129648, '\P{^inchesssymbols}', "");
    Expect(1, 129647, '\p{	 In_Chess_SYMBOLS}', "");
    Expect(0, 129647, '\p{^	 In_Chess_SYMBOLS}', "");
    Expect(0, 129647, '\P{	 In_Chess_SYMBOLS}', "");
    Expect(1, 129647, '\P{^	 In_Chess_SYMBOLS}', "");
    Expect(0, 129648, '\p{	 In_Chess_SYMBOLS}', "");
    Expect(1, 129648, '\p{^	 In_Chess_SYMBOLS}', "");
    Expect(1, 129648, '\P{	 In_Chess_SYMBOLS}', "");
    Expect(0, 129648, '\P{^	 In_Chess_SYMBOLS}', "");
    Error('\p{/a/__Chorasmian}');
    Error('\P{/a/__Chorasmian}');
    Expect(1, 69579, '\p{chorasmian}', "");
    Expect(0, 69579, '\p{^chorasmian}', "");
    Expect(0, 69579, '\P{chorasmian}', "");
    Expect(1, 69579, '\P{^chorasmian}', "");
    Expect(0, 69580, '\p{chorasmian}', "");
    Expect(1, 69580, '\p{^chorasmian}', "");
    Expect(1, 69580, '\P{chorasmian}', "");
    Expect(0, 69580, '\P{^chorasmian}', "");
    Expect(1, 69579, '\p{		CHORASMIAN}', "");
    Expect(0, 69579, '\p{^		CHORASMIAN}', "");
    Expect(0, 69579, '\P{		CHORASMIAN}', "");
    Expect(1, 69579, '\P{^		CHORASMIAN}', "");
    Expect(0, 69580, '\p{		CHORASMIAN}', "");
    Expect(1, 69580, '\p{^		CHORASMIAN}', "");
    Expect(1, 69580, '\P{		CHORASMIAN}', "");
    Expect(0, 69580, '\P{^		CHORASMIAN}', "");
    Error('\p{_:=Is_chorasmian}');
    Error('\P{_:=Is_chorasmian}');
    Expect(1, 69579, '\p{ischorasmian}', "");
    Expect(0, 69579, '\p{^ischorasmian}', "");
    Expect(0, 69579, '\P{ischorasmian}', "");
    Expect(1, 69579, '\P{^ischorasmian}', "");
    Expect(0, 69580, '\p{ischorasmian}', "");
    Expect(1, 69580, '\p{^ischorasmian}', "");
    Expect(1, 69580, '\P{ischorasmian}', "");
    Expect(0, 69580, '\P{^ischorasmian}', "");
    Expect(1, 69579, '\p{_	IS_chorasmian}', "");
    Expect(0, 69579, '\p{^_	IS_chorasmian}', "");
    Expect(0, 69579, '\P{_	IS_chorasmian}', "");
    Expect(1, 69579, '\P{^_	IS_chorasmian}', "");
    Expect(0, 69580, '\p{_	IS_chorasmian}', "");
    Expect(1, 69580, '\p{^_	IS_chorasmian}', "");
    Expect(1, 69580, '\P{_	IS_chorasmian}', "");
    Expect(0, 69580, '\P{^_	IS_chorasmian}', "");
    Error('\p{:=_-Chrs}');
    Error('\P{:=_-Chrs}');
    Expect(1, 69579, '\p{chrs}', "");
    Expect(0, 69579, '\p{^chrs}', "");
    Expect(0, 69579, '\P{chrs}', "");
    Expect(1, 69579, '\P{^chrs}', "");
    Expect(0, 69580, '\p{chrs}', "");
    Expect(1, 69580, '\p{^chrs}', "");
    Expect(1, 69580, '\P{chrs}', "");
    Expect(0, 69580, '\P{^chrs}', "");
    Expect(1, 69579, '\p{  chrs}', "");
    Expect(0, 69579, '\p{^  chrs}', "");
    Expect(0, 69579, '\P{  chrs}', "");
    Expect(1, 69579, '\P{^  chrs}', "");
    Expect(0, 69580, '\p{  chrs}', "");
    Expect(1, 69580, '\p{^  chrs}', "");
    Expect(1, 69580, '\P{  chrs}', "");
    Expect(0, 69580, '\P{^  chrs}', "");
    Error('\p{:=- Is_Chrs}');
    Error('\P{:=- Is_Chrs}');
    Expect(1, 69579, '\p{ischrs}', "");
    Expect(0, 69579, '\p{^ischrs}', "");
    Expect(0, 69579, '\P{ischrs}', "");
    Expect(1, 69579, '\P{^ischrs}', "");
    Expect(0, 69580, '\p{ischrs}', "");
    Expect(1, 69580, '\p{^ischrs}', "");
    Expect(1, 69580, '\P{ischrs}', "");
    Expect(0, 69580, '\P{^ischrs}', "");
    Expect(1, 69579, '\p{-_is_Chrs}', "");
    Expect(0, 69579, '\p{^-_is_Chrs}', "");
    Expect(0, 69579, '\P{-_is_Chrs}', "");
    Expect(1, 69579, '\P{^-_is_Chrs}', "");
    Expect(0, 69580, '\p{-_is_Chrs}', "");
    Expect(1, 69580, '\p{^-_is_Chrs}', "");
    Expect(1, 69580, '\P{-_is_Chrs}', "");
    Expect(0, 69580, '\P{^-_is_Chrs}', "");
    Error('\p{  cjk_Compatibility:=}');
    Error('\P{  cjk_Compatibility:=}');
    Expect(1, 13311, '\p{cjkcompatibility}', "");
    Expect(0, 13311, '\p{^cjkcompatibility}', "");
    Expect(0, 13311, '\P{cjkcompatibility}', "");
    Expect(1, 13311, '\P{^cjkcompatibility}', "");
    Expect(0, 13312, '\p{cjkcompatibility}', "");
    Expect(1, 13312, '\p{^cjkcompatibility}', "");
    Expect(1, 13312, '\P{cjkcompatibility}', "");
    Expect(0, 13312, '\P{^cjkcompatibility}', "");
    Expect(1, 13311, '\p{--CJK_Compatibility}', "");
    Expect(0, 13311, '\p{^--CJK_Compatibility}', "");
    Expect(0, 13311, '\P{--CJK_Compatibility}', "");
    Expect(1, 13311, '\P{^--CJK_Compatibility}', "");
    Expect(0, 13312, '\p{--CJK_Compatibility}', "");
    Expect(1, 13312, '\p{^--CJK_Compatibility}', "");
    Expect(1, 13312, '\P{--CJK_Compatibility}', "");
    Expect(0, 13312, '\P{^--CJK_Compatibility}', "");
    Error('\p{_/a/Is_CJK_Compatibility}');
    Error('\P{_/a/Is_CJK_Compatibility}');
    Expect(1, 13311, '\p{iscjkcompatibility}', "");
    Expect(0, 13311, '\p{^iscjkcompatibility}', "");
    Expect(0, 13311, '\P{iscjkcompatibility}', "");
    Expect(1, 13311, '\P{^iscjkcompatibility}', "");
    Expect(0, 13312, '\p{iscjkcompatibility}', "");
    Expect(1, 13312, '\p{^iscjkcompatibility}', "");
    Expect(1, 13312, '\P{iscjkcompatibility}', "");
    Expect(0, 13312, '\P{^iscjkcompatibility}', "");
    Expect(1, 13311, '\p{_Is_CJK_Compatibility}', "");
    Expect(0, 13311, '\p{^_Is_CJK_Compatibility}', "");
    Expect(0, 13311, '\P{_Is_CJK_Compatibility}', "");
    Expect(1, 13311, '\P{^_Is_CJK_Compatibility}', "");
    Expect(0, 13312, '\p{_Is_CJK_Compatibility}', "");
    Expect(1, 13312, '\p{^_Is_CJK_Compatibility}', "");
    Expect(1, 13312, '\P{_Is_CJK_Compatibility}', "");
    Expect(0, 13312, '\P{^_Is_CJK_Compatibility}', "");
    Error('\p{/a/	In_CJK_COMPATIBILITY}');
    Error('\P{/a/	In_CJK_COMPATIBILITY}');
    Expect(1, 13311, '\p{incjkcompatibility}', "");
    Expect(0, 13311, '\p{^incjkcompatibility}', "");
    Expect(0, 13311, '\P{incjkcompatibility}', "");
    Expect(1, 13311, '\P{^incjkcompatibility}', "");
    Expect(0, 13312, '\p{incjkcompatibility}', "");
    Expect(1, 13312, '\p{^incjkcompatibility}', "");
    Expect(1, 13312, '\P{incjkcompatibility}', "");
    Expect(0, 13312, '\P{^incjkcompatibility}', "");
    Expect(1, 13311, '\p{_in_cjk_COMPATIBILITY}', "");
    Expect(0, 13311, '\p{^_in_cjk_COMPATIBILITY}', "");
    Expect(0, 13311, '\P{_in_cjk_COMPATIBILITY}', "");
    Expect(1, 13311, '\P{^_in_cjk_COMPATIBILITY}', "");
    Expect(0, 13312, '\p{_in_cjk_COMPATIBILITY}', "");
    Expect(1, 13312, '\p{^_in_cjk_COMPATIBILITY}', "");
    Expect(1, 13312, '\P{_in_cjk_COMPATIBILITY}', "");
    Expect(0, 13312, '\P{^_in_cjk_COMPATIBILITY}', "");
    Error('\p{  CJK_compat:=}');
    Error('\P{  CJK_compat:=}');
    Expect(1, 13311, '\p{cjkcompat}', "");
    Expect(0, 13311, '\p{^cjkcompat}', "");
    Expect(0, 13311, '\P{cjkcompat}', "");
    Expect(1, 13311, '\P{^cjkcompat}', "");
    Expect(0, 13312, '\p{cjkcompat}', "");
    Expect(1, 13312, '\p{^cjkcompat}', "");
    Expect(1, 13312, '\P{cjkcompat}', "");
    Expect(0, 13312, '\P{^cjkcompat}', "");
    Expect(1, 13311, '\p{	cjk_compat}', "");
    Expect(0, 13311, '\p{^	cjk_compat}', "");
    Expect(0, 13311, '\P{	cjk_compat}', "");
    Expect(1, 13311, '\P{^	cjk_compat}', "");
    Expect(0, 13312, '\p{	cjk_compat}', "");
    Expect(1, 13312, '\p{^	cjk_compat}', "");
    Expect(1, 13312, '\P{	cjk_compat}', "");
    Expect(0, 13312, '\P{^	cjk_compat}', "");
    Error('\p{_:=Is_CJK_Compat}');
    Error('\P{_:=Is_CJK_Compat}');
    Expect(1, 13311, '\p{iscjkcompat}', "");
    Expect(0, 13311, '\p{^iscjkcompat}', "");
    Expect(0, 13311, '\P{iscjkcompat}', "");
    Expect(1, 13311, '\P{^iscjkcompat}', "");
    Expect(0, 13312, '\p{iscjkcompat}', "");
    Expect(1, 13312, '\p{^iscjkcompat}', "");
    Expect(1, 13312, '\P{iscjkcompat}', "");
    Expect(0, 13312, '\P{^iscjkcompat}', "");
    Expect(1, 13311, '\p{ IS_cjk_Compat}', "");
    Expect(0, 13311, '\p{^ IS_cjk_Compat}', "");
    Expect(0, 13311, '\P{ IS_cjk_Compat}', "");
    Expect(1, 13311, '\P{^ IS_cjk_Compat}', "");
    Expect(0, 13312, '\p{ IS_cjk_Compat}', "");
    Expect(1, 13312, '\p{^ IS_cjk_Compat}', "");
    Expect(1, 13312, '\P{ IS_cjk_Compat}', "");
    Expect(0, 13312, '\P{^ IS_cjk_Compat}', "");
    Error('\p{_In_cjk_compat:=}');
    Error('\P{_In_cjk_compat:=}');
    Expect(1, 13311, '\p{incjkcompat}', "");
    Expect(0, 13311, '\p{^incjkcompat}', "");
    Expect(0, 13311, '\P{incjkcompat}', "");
    Expect(1, 13311, '\P{^incjkcompat}', "");
    Expect(0, 13312, '\p{incjkcompat}', "");
    Expect(1, 13312, '\p{^incjkcompat}', "");
    Expect(1, 13312, '\P{incjkcompat}', "");
    Expect(0, 13312, '\P{^incjkcompat}', "");
    Expect(1, 13311, '\p{ _In_CJK_Compat}', "");
    Expect(0, 13311, '\p{^ _In_CJK_Compat}', "");
    Expect(0, 13311, '\P{ _In_CJK_Compat}', "");
    Expect(1, 13311, '\P{^ _In_CJK_Compat}', "");
    Expect(0, 13312, '\p{ _In_CJK_Compat}', "");
    Expect(1, 13312, '\p{^ _In_CJK_Compat}', "");
    Expect(1, 13312, '\P{ _In_CJK_Compat}', "");
    Expect(0, 13312, '\P{^ _In_CJK_Compat}', "");
    Error('\p{_:=CJK_Compatibility_Forms}');
    Error('\P{_:=CJK_Compatibility_Forms}');
    Expect(1, 65103, '\p{cjkcompatibilityforms}', "");
    Expect(0, 65103, '\p{^cjkcompatibilityforms}', "");
    Expect(0, 65103, '\P{cjkcompatibilityforms}', "");
    Expect(1, 65103, '\P{^cjkcompatibilityforms}', "");
    Expect(0, 65104, '\p{cjkcompatibilityforms}', "");
    Expect(1, 65104, '\p{^cjkcompatibilityforms}', "");
    Expect(1, 65104, '\P{cjkcompatibilityforms}', "");
    Expect(0, 65104, '\P{^cjkcompatibilityforms}', "");
    Expect(1, 65103, '\p{_ CJK_COMPATIBILITY_FORMS}', "");
    Expect(0, 65103, '\p{^_ CJK_COMPATIBILITY_FORMS}', "");
    Expect(0, 65103, '\P{_ CJK_COMPATIBILITY_FORMS}', "");
    Expect(1, 65103, '\P{^_ CJK_COMPATIBILITY_FORMS}', "");
    Expect(0, 65104, '\p{_ CJK_COMPATIBILITY_FORMS}', "");
    Expect(1, 65104, '\p{^_ CJK_COMPATIBILITY_FORMS}', "");
    Expect(1, 65104, '\P{_ CJK_COMPATIBILITY_FORMS}', "");
    Expect(0, 65104, '\P{^_ CJK_COMPATIBILITY_FORMS}', "");
    Error('\p{	:=IS_CJK_Compatibility_Forms}');
    Error('\P{	:=IS_CJK_Compatibility_Forms}');
    Expect(1, 65103, '\p{iscjkcompatibilityforms}', "");
    Expect(0, 65103, '\p{^iscjkcompatibilityforms}', "");
    Expect(0, 65103, '\P{iscjkcompatibilityforms}', "");
    Expect(1, 65103, '\P{^iscjkcompatibilityforms}', "");
    Expect(0, 65104, '\p{iscjkcompatibilityforms}', "");
    Expect(1, 65104, '\p{^iscjkcompatibilityforms}', "");
    Expect(1, 65104, '\P{iscjkcompatibilityforms}', "");
    Expect(0, 65104, '\P{^iscjkcompatibilityforms}', "");
    Expect(1, 65103, '\p{-Is_CJK_COMPATIBILITY_FORMS}', "");
    Expect(0, 65103, '\p{^-Is_CJK_COMPATIBILITY_FORMS}', "");
    Expect(0, 65103, '\P{-Is_CJK_COMPATIBILITY_FORMS}', "");
    Expect(1, 65103, '\P{^-Is_CJK_COMPATIBILITY_FORMS}', "");
    Expect(0, 65104, '\p{-Is_CJK_COMPATIBILITY_FORMS}', "");
    Expect(1, 65104, '\p{^-Is_CJK_COMPATIBILITY_FORMS}', "");
    Expect(1, 65104, '\P{-Is_CJK_COMPATIBILITY_FORMS}', "");
    Expect(0, 65104, '\P{^-Is_CJK_COMPATIBILITY_FORMS}', "");
    Error('\p{	/a/IN_CJK_compatibility_FORMS}');
    Error('\P{	/a/IN_CJK_compatibility_FORMS}');
    Expect(1, 65103, '\p{incjkcompatibilityforms}', "");
    Expect(0, 65103, '\p{^incjkcompatibilityforms}', "");
    Expect(0, 65103, '\P{incjkcompatibilityforms}', "");
    Expect(1, 65103, '\P{^incjkcompatibilityforms}', "");
    Expect(0, 65104, '\p{incjkcompatibilityforms}', "");
    Expect(1, 65104, '\p{^incjkcompatibilityforms}', "");
    Expect(1, 65104, '\P{incjkcompatibilityforms}', "");
    Expect(0, 65104, '\P{^incjkcompatibilityforms}', "");
    Expect(1, 65103, '\p{ _In_CJK_Compatibility_Forms}', "");
    Expect(0, 65103, '\p{^ _In_CJK_Compatibility_Forms}', "");
    Expect(0, 65103, '\P{ _In_CJK_Compatibility_Forms}', "");
    Expect(1, 65103, '\P{^ _In_CJK_Compatibility_Forms}', "");
    Expect(0, 65104, '\p{ _In_CJK_Compatibility_Forms}', "");
    Expect(1, 65104, '\p{^ _In_CJK_Compatibility_Forms}', "");
    Expect(1, 65104, '\P{ _In_CJK_Compatibility_Forms}', "");
    Expect(0, 65104, '\P{^ _In_CJK_Compatibility_Forms}', "");
    Error('\p{	/a/CJK_Compat_forms}');
    Error('\P{	/a/CJK_Compat_forms}');
    Expect(1, 65103, '\p{cjkcompatforms}', "");
    Expect(0, 65103, '\p{^cjkcompatforms}', "");
    Expect(0, 65103, '\P{cjkcompatforms}', "");
    Expect(1, 65103, '\P{^cjkcompatforms}', "");
    Expect(0, 65104, '\p{cjkcompatforms}', "");
    Expect(1, 65104, '\p{^cjkcompatforms}', "");
    Expect(1, 65104, '\P{cjkcompatforms}', "");
    Expect(0, 65104, '\P{^cjkcompatforms}', "");
    Expect(1, 65103, '\p{_CJK_Compat_Forms}', "");
    Expect(0, 65103, '\p{^_CJK_Compat_Forms}', "");
    Expect(0, 65103, '\P{_CJK_Compat_Forms}', "");
    Expect(1, 65103, '\P{^_CJK_Compat_Forms}', "");
    Expect(0, 65104, '\p{_CJK_Compat_Forms}', "");
    Expect(1, 65104, '\p{^_CJK_Compat_Forms}', "");
    Expect(1, 65104, '\P{_CJK_Compat_Forms}', "");
    Expect(0, 65104, '\P{^_CJK_Compat_Forms}', "");
    Error('\p{ -is_cjk_COMPAT_Forms/a/}');
    Error('\P{ -is_cjk_COMPAT_Forms/a/}');
    Expect(1, 65103, '\p{iscjkcompatforms}', "");
    Expect(0, 65103, '\p{^iscjkcompatforms}', "");
    Expect(0, 65103, '\P{iscjkcompatforms}', "");
    Expect(1, 65103, '\P{^iscjkcompatforms}', "");
    Expect(0, 65104, '\p{iscjkcompatforms}', "");
    Expect(1, 65104, '\p{^iscjkcompatforms}', "");
    Expect(1, 65104, '\P{iscjkcompatforms}', "");
    Expect(0, 65104, '\P{^iscjkcompatforms}', "");
    Expect(1, 65103, '\p{	 Is_CJK_COMPAT_Forms}', "");
    Expect(0, 65103, '\p{^	 Is_CJK_COMPAT_Forms}', "");
    Expect(0, 65103, '\P{	 Is_CJK_COMPAT_Forms}', "");
    Expect(1, 65103, '\P{^	 Is_CJK_COMPAT_Forms}', "");
    Expect(0, 65104, '\p{	 Is_CJK_COMPAT_Forms}', "");
    Expect(1, 65104, '\p{^	 Is_CJK_COMPAT_Forms}', "");
    Expect(1, 65104, '\P{	 Is_CJK_COMPAT_Forms}', "");
    Expect(0, 65104, '\P{^	 Is_CJK_COMPAT_Forms}', "");
    Error('\p{_ In_CJK_Compat_forms:=}');
    Error('\P{_ In_CJK_Compat_forms:=}');
    Expect(1, 65103, '\p{incjkcompatforms}', "");
    Expect(0, 65103, '\p{^incjkcompatforms}', "");
    Expect(0, 65103, '\P{incjkcompatforms}', "");
    Expect(1, 65103, '\P{^incjkcompatforms}', "");
    Expect(0, 65104, '\p{incjkcompatforms}', "");
    Expect(1, 65104, '\p{^incjkcompatforms}', "");
    Expect(1, 65104, '\P{incjkcompatforms}', "");
    Expect(0, 65104, '\P{^incjkcompatforms}', "");
    Expect(1, 65103, '\p{ _In_CJK_COMPAT_forms}', "");
    Expect(0, 65103, '\p{^ _In_CJK_COMPAT_forms}', "");
    Expect(0, 65103, '\P{ _In_CJK_COMPAT_forms}', "");
    Expect(1, 65103, '\P{^ _In_CJK_COMPAT_forms}', "");
    Expect(0, 65104, '\p{ _In_CJK_COMPAT_forms}', "");
    Expect(1, 65104, '\p{^ _In_CJK_COMPAT_forms}', "");
    Expect(1, 65104, '\P{ _In_CJK_COMPAT_forms}', "");
    Expect(0, 65104, '\P{^ _In_CJK_COMPAT_forms}', "");
    Error('\p{CJK_COMPATIBILITY_Ideographs/a/}');
    Error('\P{CJK_COMPATIBILITY_Ideographs/a/}');
    Expect(1, 64255, '\p{cjkcompatibilityideographs}', "");
    Expect(0, 64255, '\p{^cjkcompatibilityideographs}', "");
    Expect(0, 64255, '\P{cjkcompatibilityideographs}', "");
    Expect(1, 64255, '\P{^cjkcompatibilityideographs}', "");
    Expect(0, 64256, '\p{cjkcompatibilityideographs}', "");
    Expect(1, 64256, '\p{^cjkcompatibilityideographs}', "");
    Expect(1, 64256, '\P{cjkcompatibilityideographs}', "");
    Expect(0, 64256, '\P{^cjkcompatibilityideographs}', "");
    Expect(1, 64255, '\p{ CJK_Compatibility_Ideographs}', "");
    Expect(0, 64255, '\p{^ CJK_Compatibility_Ideographs}', "");
    Expect(0, 64255, '\P{ CJK_Compatibility_Ideographs}', "");
    Expect(1, 64255, '\P{^ CJK_Compatibility_Ideographs}', "");
    Expect(0, 64256, '\p{ CJK_Compatibility_Ideographs}', "");
    Expect(1, 64256, '\p{^ CJK_Compatibility_Ideographs}', "");
    Expect(1, 64256, '\P{ CJK_Compatibility_Ideographs}', "");
    Expect(0, 64256, '\P{^ CJK_Compatibility_Ideographs}', "");
    Error('\p{/a/		Is_CJK_Compatibility_Ideographs}');
    Error('\P{/a/		Is_CJK_Compatibility_Ideographs}');
    Expect(1, 64255, '\p{iscjkcompatibilityideographs}', "");
    Expect(0, 64255, '\p{^iscjkcompatibilityideographs}', "");
    Expect(0, 64255, '\P{iscjkcompatibilityideographs}', "");
    Expect(1, 64255, '\P{^iscjkcompatibilityideographs}', "");
    Expect(0, 64256, '\p{iscjkcompatibilityideographs}', "");
    Expect(1, 64256, '\p{^iscjkcompatibilityideographs}', "");
    Expect(1, 64256, '\P{iscjkcompatibilityideographs}', "");
    Expect(0, 64256, '\P{^iscjkcompatibilityideographs}', "");
    Expect(1, 64255, '\p{	Is_CJK_COMPATIBILITY_IDEOGRAPHS}', "");
    Expect(0, 64255, '\p{^	Is_CJK_COMPATIBILITY_IDEOGRAPHS}', "");
    Expect(0, 64255, '\P{	Is_CJK_COMPATIBILITY_IDEOGRAPHS}', "");
    Expect(1, 64255, '\P{^	Is_CJK_COMPATIBILITY_IDEOGRAPHS}', "");
    Expect(0, 64256, '\p{	Is_CJK_COMPATIBILITY_IDEOGRAPHS}', "");
    Expect(1, 64256, '\p{^	Is_CJK_COMPATIBILITY_IDEOGRAPHS}', "");
    Expect(1, 64256, '\P{	Is_CJK_COMPATIBILITY_IDEOGRAPHS}', "");
    Expect(0, 64256, '\P{^	Is_CJK_COMPATIBILITY_IDEOGRAPHS}', "");
    Error('\p{/a/	in_CJK_COMPATIBILITY_Ideographs}');
    Error('\P{/a/	in_CJK_COMPATIBILITY_Ideographs}');
    Expect(1, 64255, '\p{incjkcompatibilityideographs}', "");
    Expect(0, 64255, '\p{^incjkcompatibilityideographs}', "");
    Expect(0, 64255, '\P{incjkcompatibilityideographs}', "");
    Expect(1, 64255, '\P{^incjkcompatibilityideographs}', "");
    Expect(0, 64256, '\p{incjkcompatibilityideographs}', "");
    Expect(1, 64256, '\p{^incjkcompatibilityideographs}', "");
    Expect(1, 64256, '\P{incjkcompatibilityideographs}', "");
    Expect(0, 64256, '\P{^incjkcompatibilityideographs}', "");
    Expect(1, 64255, '\p{ 	In_CJK_COMPATIBILITY_ideographs}', "");
    Expect(0, 64255, '\p{^ 	In_CJK_COMPATIBILITY_ideographs}', "");
    Expect(0, 64255, '\P{ 	In_CJK_COMPATIBILITY_ideographs}', "");
    Expect(1, 64255, '\P{^ 	In_CJK_COMPATIBILITY_ideographs}', "");
    Expect(0, 64256, '\p{ 	In_CJK_COMPATIBILITY_ideographs}', "");
    Expect(1, 64256, '\p{^ 	In_CJK_COMPATIBILITY_ideographs}', "");
    Expect(1, 64256, '\P{ 	In_CJK_COMPATIBILITY_ideographs}', "");
    Expect(0, 64256, '\P{^ 	In_CJK_COMPATIBILITY_ideographs}', "");
    Error('\p{:= CJK_Compat_Ideographs}');
    Error('\P{:= CJK_Compat_Ideographs}');
    Expect(1, 64255, '\p{cjkcompatideographs}', "");
    Expect(0, 64255, '\p{^cjkcompatideographs}', "");
    Expect(0, 64255, '\P{cjkcompatideographs}', "");
    Expect(1, 64255, '\P{^cjkcompatideographs}', "");
    Expect(0, 64256, '\p{cjkcompatideographs}', "");
    Expect(1, 64256, '\p{^cjkcompatideographs}', "");
    Expect(1, 64256, '\P{cjkcompatideographs}', "");
    Expect(0, 64256, '\P{^cjkcompatideographs}', "");
    Expect(1, 64255, '\p{		cjk_COMPAT_ideographs}', "");
    Expect(0, 64255, '\p{^		cjk_COMPAT_ideographs}', "");
    Expect(0, 64255, '\P{		cjk_COMPAT_ideographs}', "");
    Expect(1, 64255, '\P{^		cjk_COMPAT_ideographs}', "");
    Expect(0, 64256, '\p{		cjk_COMPAT_ideographs}', "");
    Expect(1, 64256, '\p{^		cjk_COMPAT_ideographs}', "");
    Expect(1, 64256, '\P{		cjk_COMPAT_ideographs}', "");
    Expect(0, 64256, '\P{^		cjk_COMPAT_ideographs}', "");
    Error('\p{:=	IS_CJK_compat_IDEOGRAPHS}');
    Error('\P{:=	IS_CJK_compat_IDEOGRAPHS}');
    Expect(1, 64255, '\p{iscjkcompatideographs}', "");
    Expect(0, 64255, '\p{^iscjkcompatideographs}', "");
    Expect(0, 64255, '\P{iscjkcompatideographs}', "");
    Expect(1, 64255, '\P{^iscjkcompatideographs}', "");
    Expect(0, 64256, '\p{iscjkcompatideographs}', "");
    Expect(1, 64256, '\p{^iscjkcompatideographs}', "");
    Expect(1, 64256, '\P{iscjkcompatideographs}', "");
    Expect(0, 64256, '\P{^iscjkcompatideographs}', "");
    Expect(1, 64255, '\p{ _is_cjk_compat_Ideographs}', "");
    Expect(0, 64255, '\p{^ _is_cjk_compat_Ideographs}', "");
    Expect(0, 64255, '\P{ _is_cjk_compat_Ideographs}', "");
    Expect(1, 64255, '\P{^ _is_cjk_compat_Ideographs}', "");
    Expect(0, 64256, '\p{ _is_cjk_compat_Ideographs}', "");
    Expect(1, 64256, '\p{^ _is_cjk_compat_Ideographs}', "");
    Expect(1, 64256, '\P{ _is_cjk_compat_Ideographs}', "");
    Expect(0, 64256, '\P{^ _is_cjk_compat_Ideographs}', "");
    Error('\p{ in_CJK_compat_ideographs/a/}');
    Error('\P{ in_CJK_compat_ideographs/a/}');
    Expect(1, 64255, '\p{incjkcompatideographs}', "");
    Expect(0, 64255, '\p{^incjkcompatideographs}', "");
    Expect(0, 64255, '\P{incjkcompatideographs}', "");
    Expect(1, 64255, '\P{^incjkcompatideographs}', "");
    Expect(0, 64256, '\p{incjkcompatideographs}', "");
    Expect(1, 64256, '\p{^incjkcompatideographs}', "");
    Expect(1, 64256, '\P{incjkcompatideographs}', "");
    Expect(0, 64256, '\P{^incjkcompatideographs}', "");
    Expect(1, 64255, '\p{	_In_cjk_compat_IDEOGRAPHS}', "");
    Expect(0, 64255, '\p{^	_In_cjk_compat_IDEOGRAPHS}', "");
    Expect(0, 64255, '\P{	_In_cjk_compat_IDEOGRAPHS}', "");
    Expect(1, 64255, '\P{^	_In_cjk_compat_IDEOGRAPHS}', "");
    Expect(0, 64256, '\p{	_In_cjk_compat_IDEOGRAPHS}', "");
    Expect(1, 64256, '\p{^	_In_cjk_compat_IDEOGRAPHS}', "");
    Expect(1, 64256, '\P{	_In_cjk_compat_IDEOGRAPHS}', "");
    Expect(0, 64256, '\P{^	_In_cjk_compat_IDEOGRAPHS}', "");
    Error('\p{/a/ -CJK_COMPATIBILITY_Ideographs_SUPPLEMENT}');
    Error('\P{/a/ -CJK_COMPATIBILITY_Ideographs_SUPPLEMENT}');
    Expect(1, 195103, '\p{cjkcompatibilityideographssupplement}', "");
    Expect(0, 195103, '\p{^cjkcompatibilityideographssupplement}', "");
    Expect(0, 195103, '\P{cjkcompatibilityideographssupplement}', "");
    Expect(1, 195103, '\P{^cjkcompatibilityideographssupplement}', "");
    Expect(0, 195104, '\p{cjkcompatibilityideographssupplement}', "");
    Expect(1, 195104, '\p{^cjkcompatibilityideographssupplement}', "");
    Expect(1, 195104, '\P{cjkcompatibilityideographssupplement}', "");
    Expect(0, 195104, '\P{^cjkcompatibilityideographssupplement}', "");
    Expect(1, 195103, '\p{_ CJK_Compatibility_Ideographs_Supplement}', "");
    Expect(0, 195103, '\p{^_ CJK_Compatibility_Ideographs_Supplement}', "");
    Expect(0, 195103, '\P{_ CJK_Compatibility_Ideographs_Supplement}', "");
    Expect(1, 195103, '\P{^_ CJK_Compatibility_Ideographs_Supplement}', "");
    Expect(0, 195104, '\p{_ CJK_Compatibility_Ideographs_Supplement}', "");
    Expect(1, 195104, '\p{^_ CJK_Compatibility_Ideographs_Supplement}', "");
    Expect(1, 195104, '\P{_ CJK_Compatibility_Ideographs_Supplement}', "");
    Expect(0, 195104, '\P{^_ CJK_Compatibility_Ideographs_Supplement}', "");
    Error('\p{/a/Is_CJK_Compatibility_Ideographs_Supplement}');
    Error('\P{/a/Is_CJK_Compatibility_Ideographs_Supplement}');
    Expect(1, 195103, '\p{iscjkcompatibilityideographssupplement}', "");
    Expect(0, 195103, '\p{^iscjkcompatibilityideographssupplement}', "");
    Expect(0, 195103, '\P{iscjkcompatibilityideographssupplement}', "");
    Expect(1, 195103, '\P{^iscjkcompatibilityideographssupplement}', "");
    Expect(0, 195104, '\p{iscjkcompatibilityideographssupplement}', "");
    Expect(1, 195104, '\p{^iscjkcompatibilityideographssupplement}', "");
    Expect(1, 195104, '\P{iscjkcompatibilityideographssupplement}', "");
    Expect(0, 195104, '\P{^iscjkcompatibilityideographssupplement}', "");
    Expect(1, 195103, '\p{	 is_CJK_Compatibility_Ideographs_SUPPLEMENT}', "");
    Expect(0, 195103, '\p{^	 is_CJK_Compatibility_Ideographs_SUPPLEMENT}', "");
    Expect(0, 195103, '\P{	 is_CJK_Compatibility_Ideographs_SUPPLEMENT}', "");
    Expect(1, 195103, '\P{^	 is_CJK_Compatibility_Ideographs_SUPPLEMENT}', "");
    Expect(0, 195104, '\p{	 is_CJK_Compatibility_Ideographs_SUPPLEMENT}', "");
    Expect(1, 195104, '\p{^	 is_CJK_Compatibility_Ideographs_SUPPLEMENT}', "");
    Expect(1, 195104, '\P{	 is_CJK_Compatibility_Ideographs_SUPPLEMENT}', "");
    Expect(0, 195104, '\P{^	 is_CJK_Compatibility_Ideographs_SUPPLEMENT}', "");
    Error('\p{--In_cjk_compatibility_IDEOGRAPHS_SUPPLEMENT:=}');
    Error('\P{--In_cjk_compatibility_IDEOGRAPHS_SUPPLEMENT:=}');
    Expect(1, 195103, '\p{incjkcompatibilityideographssupplement}', "");
    Expect(0, 195103, '\p{^incjkcompatibilityideographssupplement}', "");
    Expect(0, 195103, '\P{incjkcompatibilityideographssupplement}', "");
    Expect(1, 195103, '\P{^incjkcompatibilityideographssupplement}', "");
    Expect(0, 195104, '\p{incjkcompatibilityideographssupplement}', "");
    Expect(1, 195104, '\p{^incjkcompatibilityideographssupplement}', "");
    Expect(1, 195104, '\P{incjkcompatibilityideographssupplement}', "");
    Expect(0, 195104, '\P{^incjkcompatibilityideographssupplement}', "");
    Expect(1, 195103, '\p{-	in_CJK_Compatibility_ideographs_Supplement}', "");
    Expect(0, 195103, '\p{^-	in_CJK_Compatibility_ideographs_Supplement}', "");
    Expect(0, 195103, '\P{-	in_CJK_Compatibility_ideographs_Supplement}', "");
    Expect(1, 195103, '\P{^-	in_CJK_Compatibility_ideographs_Supplement}', "");
    Expect(0, 195104, '\p{-	in_CJK_Compatibility_ideographs_Supplement}', "");
    Expect(1, 195104, '\p{^-	in_CJK_Compatibility_ideographs_Supplement}', "");
    Expect(1, 195104, '\P{-	in_CJK_Compatibility_ideographs_Supplement}', "");
    Expect(0, 195104, '\P{^-	in_CJK_Compatibility_ideographs_Supplement}', "");
    Error('\p{_/a/CJK_COMPAT_Ideographs_sup}');
    Error('\P{_/a/CJK_COMPAT_Ideographs_sup}');
    Expect(1, 195103, '\p{cjkcompatideographssup}', "");
    Expect(0, 195103, '\p{^cjkcompatideographssup}', "");
    Expect(0, 195103, '\P{cjkcompatideographssup}', "");
    Expect(1, 195103, '\P{^cjkcompatideographssup}', "");
    Expect(0, 195104, '\p{cjkcompatideographssup}', "");
    Expect(1, 195104, '\p{^cjkcompatideographssup}', "");
    Expect(1, 195104, '\P{cjkcompatideographssup}', "");
    Expect(0, 195104, '\P{^cjkcompatideographssup}', "");
    Expect(1, 195103, '\p{	 cjk_Compat_Ideographs_Sup}', "");
    Expect(0, 195103, '\p{^	 cjk_Compat_Ideographs_Sup}', "");
    Expect(0, 195103, '\P{	 cjk_Compat_Ideographs_Sup}', "");
    Expect(1, 195103, '\P{^	 cjk_Compat_Ideographs_Sup}', "");
    Expect(0, 195104, '\p{	 cjk_Compat_Ideographs_Sup}', "");
    Expect(1, 195104, '\p{^	 cjk_Compat_Ideographs_Sup}', "");
    Expect(1, 195104, '\P{	 cjk_Compat_Ideographs_Sup}', "");
    Expect(0, 195104, '\P{^	 cjk_Compat_Ideographs_Sup}', "");
    Error('\p{	-Is_CJK_compat_ideographs_sup:=}');
    Error('\P{	-Is_CJK_compat_ideographs_sup:=}');
    Expect(1, 195103, '\p{iscjkcompatideographssup}', "");
    Expect(0, 195103, '\p{^iscjkcompatideographssup}', "");
    Expect(0, 195103, '\P{iscjkcompatideographssup}', "");
    Expect(1, 195103, '\P{^iscjkcompatideographssup}', "");
    Expect(0, 195104, '\p{iscjkcompatideographssup}', "");
    Expect(1, 195104, '\p{^iscjkcompatideographssup}', "");
    Expect(1, 195104, '\P{iscjkcompatideographssup}', "");
    Expect(0, 195104, '\P{^iscjkcompatideographssup}', "");
    Expect(1, 195103, '\p{_-IS_CJK_Compat_IDEOGRAPHS_sup}', "");
    Expect(0, 195103, '\p{^_-IS_CJK_Compat_IDEOGRAPHS_sup}', "");
    Expect(0, 195103, '\P{_-IS_CJK_Compat_IDEOGRAPHS_sup}', "");
    Expect(1, 195103, '\P{^_-IS_CJK_Compat_IDEOGRAPHS_sup}', "");
    Expect(0, 195104, '\p{_-IS_CJK_Compat_IDEOGRAPHS_sup}', "");
    Expect(1, 195104, '\p{^_-IS_CJK_Compat_IDEOGRAPHS_sup}', "");
    Expect(1, 195104, '\P{_-IS_CJK_Compat_IDEOGRAPHS_sup}', "");
    Expect(0, 195104, '\P{^_-IS_CJK_Compat_IDEOGRAPHS_sup}', "");
    Error('\p{_/a/In_CJK_COMPAT_Ideographs_sup}');
    Error('\P{_/a/In_CJK_COMPAT_Ideographs_sup}');
    Expect(1, 195103, '\p{incjkcompatideographssup}', "");
    Expect(0, 195103, '\p{^incjkcompatideographssup}', "");
    Expect(0, 195103, '\P{incjkcompatideographssup}', "");
    Expect(1, 195103, '\P{^incjkcompatideographssup}', "");
    Expect(0, 195104, '\p{incjkcompatideographssup}', "");
    Expect(1, 195104, '\p{^incjkcompatideographssup}', "");
    Expect(1, 195104, '\P{incjkcompatideographssup}', "");
    Expect(0, 195104, '\P{^incjkcompatideographssup}', "");
    Expect(1, 195103, '\p{ _In_CJK_Compat_Ideographs_Sup}', "");
    Expect(0, 195103, '\p{^ _In_CJK_Compat_Ideographs_Sup}', "");
    Expect(0, 195103, '\P{ _In_CJK_Compat_Ideographs_Sup}', "");
    Expect(1, 195103, '\P{^ _In_CJK_Compat_Ideographs_Sup}', "");
    Expect(0, 195104, '\p{ _In_CJK_Compat_Ideographs_Sup}', "");
    Expect(1, 195104, '\p{^ _In_CJK_Compat_Ideographs_Sup}', "");
    Expect(1, 195104, '\P{ _In_CJK_Compat_Ideographs_Sup}', "");
    Expect(0, 195104, '\P{^ _In_CJK_Compat_Ideographs_Sup}', "");
    Error('\p{-/a/cjk_Radicals_SUPPLEMENT}');
    Error('\P{-/a/cjk_Radicals_SUPPLEMENT}');
    Expect(1, 12031, '\p{cjkradicalssupplement}', "");
    Expect(0, 12031, '\p{^cjkradicalssupplement}', "");
    Expect(0, 12031, '\P{cjkradicalssupplement}', "");
    Expect(1, 12031, '\P{^cjkradicalssupplement}', "");
    Expect(0, 12032, '\p{cjkradicalssupplement}', "");
    Expect(1, 12032, '\p{^cjkradicalssupplement}', "");
    Expect(1, 12032, '\P{cjkradicalssupplement}', "");
    Expect(0, 12032, '\P{^cjkradicalssupplement}', "");
    Expect(1, 12031, '\p{_CJK_Radicals_Supplement}', "");
    Expect(0, 12031, '\p{^_CJK_Radicals_Supplement}', "");
    Expect(0, 12031, '\P{_CJK_Radicals_Supplement}', "");
    Expect(1, 12031, '\P{^_CJK_Radicals_Supplement}', "");
    Expect(0, 12032, '\p{_CJK_Radicals_Supplement}', "");
    Expect(1, 12032, '\p{^_CJK_Radicals_Supplement}', "");
    Expect(1, 12032, '\P{_CJK_Radicals_Supplement}', "");
    Expect(0, 12032, '\P{^_CJK_Radicals_Supplement}', "");
    Error('\p{:= IS_cjk_Radicals_Supplement}');
    Error('\P{:= IS_cjk_Radicals_Supplement}');
    Expect(1, 12031, '\p{iscjkradicalssupplement}', "");
    Expect(0, 12031, '\p{^iscjkradicalssupplement}', "");
    Expect(0, 12031, '\P{iscjkradicalssupplement}', "");
    Expect(1, 12031, '\P{^iscjkradicalssupplement}', "");
    Expect(0, 12032, '\p{iscjkradicalssupplement}', "");
    Expect(1, 12032, '\p{^iscjkradicalssupplement}', "");
    Expect(1, 12032, '\P{iscjkradicalssupplement}', "");
    Expect(0, 12032, '\P{^iscjkradicalssupplement}', "");
    Expect(1, 12031, '\p{		is_cjk_Radicals_Supplement}', "");
    Expect(0, 12031, '\p{^		is_cjk_Radicals_Supplement}', "");
    Expect(0, 12031, '\P{		is_cjk_Radicals_Supplement}', "");
    Expect(1, 12031, '\P{^		is_cjk_Radicals_Supplement}', "");
    Expect(0, 12032, '\p{		is_cjk_Radicals_Supplement}', "");
    Expect(1, 12032, '\p{^		is_cjk_Radicals_Supplement}', "");
    Expect(1, 12032, '\P{		is_cjk_Radicals_Supplement}', "");
    Expect(0, 12032, '\P{^		is_cjk_Radicals_Supplement}', "");
    Error('\p{_In_CJK_RADICALS_Supplement:=}');
    Error('\P{_In_CJK_RADICALS_Supplement:=}');
    Expect(1, 12031, '\p{incjkradicalssupplement}', "");
    Expect(0, 12031, '\p{^incjkradicalssupplement}', "");
    Expect(0, 12031, '\P{incjkradicalssupplement}', "");
    Expect(1, 12031, '\P{^incjkradicalssupplement}', "");
    Expect(0, 12032, '\p{incjkradicalssupplement}', "");
    Expect(1, 12032, '\p{^incjkradicalssupplement}', "");
    Expect(1, 12032, '\P{incjkradicalssupplement}', "");
    Expect(0, 12032, '\P{^incjkradicalssupplement}', "");
    Expect(1, 12031, '\p{--IN_CJK_radicals_SUPPLEMENT}', "");
    Expect(0, 12031, '\p{^--IN_CJK_radicals_SUPPLEMENT}', "");
    Expect(0, 12031, '\P{--IN_CJK_radicals_SUPPLEMENT}', "");
    Expect(1, 12031, '\P{^--IN_CJK_radicals_SUPPLEMENT}', "");
    Expect(0, 12032, '\p{--IN_CJK_radicals_SUPPLEMENT}', "");
    Expect(1, 12032, '\p{^--IN_CJK_radicals_SUPPLEMENT}', "");
    Expect(1, 12032, '\P{--IN_CJK_radicals_SUPPLEMENT}', "");
    Expect(0, 12032, '\P{^--IN_CJK_radicals_SUPPLEMENT}', "");
    Error('\p{_-CJK_Radicals_sup/a/}');
    Error('\P{_-CJK_Radicals_sup/a/}');
    Expect(1, 12031, '\p{cjkradicalssup}', "");
    Expect(0, 12031, '\p{^cjkradicalssup}', "");
    Expect(0, 12031, '\P{cjkradicalssup}', "");
    Expect(1, 12031, '\P{^cjkradicalssup}', "");
    Expect(0, 12032, '\p{cjkradicalssup}', "");
    Expect(1, 12032, '\p{^cjkradicalssup}', "");
    Expect(1, 12032, '\P{cjkradicalssup}', "");
    Expect(0, 12032, '\P{^cjkradicalssup}', "");
    Expect(1, 12031, '\p{ 	CJK_radicals_Sup}', "");
    Expect(0, 12031, '\p{^ 	CJK_radicals_Sup}', "");
    Expect(0, 12031, '\P{ 	CJK_radicals_Sup}', "");
    Expect(1, 12031, '\P{^ 	CJK_radicals_Sup}', "");
    Expect(0, 12032, '\p{ 	CJK_radicals_Sup}', "");
    Expect(1, 12032, '\p{^ 	CJK_radicals_Sup}', "");
    Expect(1, 12032, '\P{ 	CJK_radicals_Sup}', "");
    Expect(0, 12032, '\P{^ 	CJK_radicals_Sup}', "");
    Error('\p{-is_CJK_Radicals_Sup:=}');
    Error('\P{-is_CJK_Radicals_Sup:=}');
    Expect(1, 12031, '\p{iscjkradicalssup}', "");
    Expect(0, 12031, '\p{^iscjkradicalssup}', "");
    Expect(0, 12031, '\P{iscjkradicalssup}', "");
    Expect(1, 12031, '\P{^iscjkradicalssup}', "");
    Expect(0, 12032, '\p{iscjkradicalssup}', "");
    Expect(1, 12032, '\p{^iscjkradicalssup}', "");
    Expect(1, 12032, '\P{iscjkradicalssup}', "");
    Expect(0, 12032, '\P{^iscjkradicalssup}', "");
    Expect(1, 12031, '\p{	_Is_cjk_Radicals_sup}', "");
    Expect(0, 12031, '\p{^	_Is_cjk_Radicals_sup}', "");
    Expect(0, 12031, '\P{	_Is_cjk_Radicals_sup}', "");
    Expect(1, 12031, '\P{^	_Is_cjk_Radicals_sup}', "");
    Expect(0, 12032, '\p{	_Is_cjk_Radicals_sup}', "");
    Expect(1, 12032, '\p{^	_Is_cjk_Radicals_sup}', "");
    Expect(1, 12032, '\P{	_Is_cjk_Radicals_sup}', "");
    Expect(0, 12032, '\P{^	_Is_cjk_Radicals_sup}', "");
    Error('\p{	/a/In_CJK_RADICALS_SUP}');
    Error('\P{	/a/In_CJK_RADICALS_SUP}');
    Expect(1, 12031, '\p{incjkradicalssup}', "");
    Expect(0, 12031, '\p{^incjkradicalssup}', "");
    Expect(0, 12031, '\P{incjkradicalssup}', "");
    Expect(1, 12031, '\P{^incjkradicalssup}', "");
    Expect(0, 12032, '\p{incjkradicalssup}', "");
    Expect(1, 12032, '\p{^incjkradicalssup}', "");
    Expect(1, 12032, '\P{incjkradicalssup}', "");
    Expect(0, 12032, '\P{^incjkradicalssup}', "");
    Expect(1, 12031, '\p{-_in_CJK_RADICALS_Sup}', "");
    Expect(0, 12031, '\p{^-_in_CJK_RADICALS_Sup}', "");
    Expect(0, 12031, '\P{-_in_CJK_RADICALS_Sup}', "");
    Expect(1, 12031, '\P{^-_in_CJK_RADICALS_Sup}', "");
    Expect(0, 12032, '\p{-_in_CJK_RADICALS_Sup}', "");
    Expect(1, 12032, '\p{^-_in_CJK_RADICALS_Sup}', "");
    Expect(1, 12032, '\P{-_in_CJK_RADICALS_Sup}', "");
    Expect(0, 12032, '\P{^-_in_CJK_RADICALS_Sup}', "");
    Error('\p{-:=CJK_STROKES}');
    Error('\P{-:=CJK_STROKES}');
    Expect(1, 12783, '\p{cjkstrokes}', "");
    Expect(0, 12783, '\p{^cjkstrokes}', "");
    Expect(0, 12783, '\P{cjkstrokes}', "");
    Expect(1, 12783, '\P{^cjkstrokes}', "");
    Expect(0, 12784, '\p{cjkstrokes}', "");
    Expect(1, 12784, '\p{^cjkstrokes}', "");
    Expect(1, 12784, '\P{cjkstrokes}', "");
    Expect(0, 12784, '\P{^cjkstrokes}', "");
    Expect(1, 12783, '\p{	CJK_STROKES}', "");
    Expect(0, 12783, '\p{^	CJK_STROKES}', "");
    Expect(0, 12783, '\P{	CJK_STROKES}', "");
    Expect(1, 12783, '\P{^	CJK_STROKES}', "");
    Expect(0, 12784, '\p{	CJK_STROKES}', "");
    Expect(1, 12784, '\p{^	CJK_STROKES}', "");
    Expect(1, 12784, '\P{	CJK_STROKES}', "");
    Expect(0, 12784, '\P{^	CJK_STROKES}', "");
    Error('\p{_/a/IS_cjk_STROKES}');
    Error('\P{_/a/IS_cjk_STROKES}');
    Expect(1, 12783, '\p{iscjkstrokes}', "");
    Expect(0, 12783, '\p{^iscjkstrokes}', "");
    Expect(0, 12783, '\P{iscjkstrokes}', "");
    Expect(1, 12783, '\P{^iscjkstrokes}', "");
    Expect(0, 12784, '\p{iscjkstrokes}', "");
    Expect(1, 12784, '\p{^iscjkstrokes}', "");
    Expect(1, 12784, '\P{iscjkstrokes}', "");
    Expect(0, 12784, '\P{^iscjkstrokes}', "");
    Expect(1, 12783, '\p{_-Is_cjk_Strokes}', "");
    Expect(0, 12783, '\p{^_-Is_cjk_Strokes}', "");
    Expect(0, 12783, '\P{_-Is_cjk_Strokes}', "");
    Expect(1, 12783, '\P{^_-Is_cjk_Strokes}', "");
    Expect(0, 12784, '\p{_-Is_cjk_Strokes}', "");
    Expect(1, 12784, '\p{^_-Is_cjk_Strokes}', "");
    Expect(1, 12784, '\P{_-Is_cjk_Strokes}', "");
    Expect(0, 12784, '\P{^_-Is_cjk_Strokes}', "");
    Error('\p{  In_CJK_Strokes:=}');
    Error('\P{  In_CJK_Strokes:=}');
    Expect(1, 12783, '\p{incjkstrokes}', "");
    Expect(0, 12783, '\p{^incjkstrokes}', "");
    Expect(0, 12783, '\P{incjkstrokes}', "");
    Expect(1, 12783, '\P{^incjkstrokes}', "");
    Expect(0, 12784, '\p{incjkstrokes}', "");
    Expect(1, 12784, '\p{^incjkstrokes}', "");
    Expect(1, 12784, '\P{incjkstrokes}', "");
    Expect(0, 12784, '\P{^incjkstrokes}', "");
    Expect(1, 12783, '\p{		In_CJK_STROKES}', "");
    Expect(0, 12783, '\p{^		In_CJK_STROKES}', "");
    Expect(0, 12783, '\P{		In_CJK_STROKES}', "");
    Expect(1, 12783, '\P{^		In_CJK_STROKES}', "");
    Expect(0, 12784, '\p{		In_CJK_STROKES}', "");
    Expect(1, 12784, '\p{^		In_CJK_STROKES}', "");
    Expect(1, 12784, '\P{		In_CJK_STROKES}', "");
    Expect(0, 12784, '\P{^		In_CJK_STROKES}', "");
    Error('\p{/a/_CJK_Symbols_And_Punctuation}');
    Error('\P{/a/_CJK_Symbols_And_Punctuation}');
    Expect(1, 12351, '\p{cjksymbolsandpunctuation}', "");
    Expect(0, 12351, '\p{^cjksymbolsandpunctuation}', "");
    Expect(0, 12351, '\P{cjksymbolsandpunctuation}', "");
    Expect(1, 12351, '\P{^cjksymbolsandpunctuation}', "");
    Expect(0, 12352, '\p{cjksymbolsandpunctuation}', "");
    Expect(1, 12352, '\p{^cjksymbolsandpunctuation}', "");
    Expect(1, 12352, '\P{cjksymbolsandpunctuation}', "");
    Expect(0, 12352, '\P{^cjksymbolsandpunctuation}', "");
    Expect(1, 12351, '\p{-_CJK_symbols_And_Punctuation}', "");
    Expect(0, 12351, '\p{^-_CJK_symbols_And_Punctuation}', "");
    Expect(0, 12351, '\P{-_CJK_symbols_And_Punctuation}', "");
    Expect(1, 12351, '\P{^-_CJK_symbols_And_Punctuation}', "");
    Expect(0, 12352, '\p{-_CJK_symbols_And_Punctuation}', "");
    Expect(1, 12352, '\p{^-_CJK_symbols_And_Punctuation}', "");
    Expect(1, 12352, '\P{-_CJK_symbols_And_Punctuation}', "");
    Expect(0, 12352, '\P{^-_CJK_symbols_And_Punctuation}', "");
    Error('\p{:=	Is_CJK_Symbols_AND_PUNCTUATION}');
    Error('\P{:=	Is_CJK_Symbols_AND_PUNCTUATION}');
    Expect(1, 12351, '\p{iscjksymbolsandpunctuation}', "");
    Expect(0, 12351, '\p{^iscjksymbolsandpunctuation}', "");
    Expect(0, 12351, '\P{iscjksymbolsandpunctuation}', "");
    Expect(1, 12351, '\P{^iscjksymbolsandpunctuation}', "");
    Expect(0, 12352, '\p{iscjksymbolsandpunctuation}', "");
    Expect(1, 12352, '\p{^iscjksymbolsandpunctuation}', "");
    Expect(1, 12352, '\P{iscjksymbolsandpunctuation}', "");
    Expect(0, 12352, '\P{^iscjksymbolsandpunctuation}', "");
    Expect(1, 12351, '\p{-	Is_cjk_symbols_And_PUNCTUATION}', "");
    Expect(0, 12351, '\p{^-	Is_cjk_symbols_And_PUNCTUATION}', "");
    Expect(0, 12351, '\P{-	Is_cjk_symbols_And_PUNCTUATION}', "");
    Expect(1, 12351, '\P{^-	Is_cjk_symbols_And_PUNCTUATION}', "");
    Expect(0, 12352, '\p{-	Is_cjk_symbols_And_PUNCTUATION}', "");
    Expect(1, 12352, '\p{^-	Is_cjk_symbols_And_PUNCTUATION}', "");
    Expect(1, 12352, '\P{-	Is_cjk_symbols_And_PUNCTUATION}', "");
    Expect(0, 12352, '\P{^-	Is_cjk_symbols_And_PUNCTUATION}', "");
    Error('\p{/a/- IN_CJK_Symbols_AND_punctuation}');
    Error('\P{/a/- IN_CJK_Symbols_AND_punctuation}');
    Expect(1, 12351, '\p{incjksymbolsandpunctuation}', "");
    Expect(0, 12351, '\p{^incjksymbolsandpunctuation}', "");
    Expect(0, 12351, '\P{incjksymbolsandpunctuation}', "");
    Expect(1, 12351, '\P{^incjksymbolsandpunctuation}', "");
    Expect(0, 12352, '\p{incjksymbolsandpunctuation}', "");
    Expect(1, 12352, '\p{^incjksymbolsandpunctuation}', "");
    Expect(1, 12352, '\P{incjksymbolsandpunctuation}', "");
    Expect(0, 12352, '\P{^incjksymbolsandpunctuation}', "");
    Expect(1, 12351, '\p{ In_CJK_symbols_And_Punctuation}', "");
    Expect(0, 12351, '\p{^ In_CJK_symbols_And_Punctuation}', "");
    Expect(0, 12351, '\P{ In_CJK_symbols_And_Punctuation}', "");
    Expect(1, 12351, '\P{^ In_CJK_symbols_And_Punctuation}', "");
    Expect(0, 12352, '\p{ In_CJK_symbols_And_Punctuation}', "");
    Expect(1, 12352, '\p{^ In_CJK_symbols_And_Punctuation}', "");
    Expect(1, 12352, '\P{ In_CJK_symbols_And_Punctuation}', "");
    Expect(0, 12352, '\P{^ In_CJK_symbols_And_Punctuation}', "");
    Error('\p{__CJK_symbols:=}');
    Error('\P{__CJK_symbols:=}');
    Expect(1, 12351, '\p{cjksymbols}', "");
    Expect(0, 12351, '\p{^cjksymbols}', "");
    Expect(0, 12351, '\P{cjksymbols}', "");
    Expect(1, 12351, '\P{^cjksymbols}', "");
    Expect(0, 12352, '\p{cjksymbols}', "");
    Expect(1, 12352, '\p{^cjksymbols}', "");
    Expect(1, 12352, '\P{cjksymbols}', "");
    Expect(0, 12352, '\P{^cjksymbols}', "");
    Expect(1, 12351, '\p{-	CJK_symbols}', "");
    Expect(0, 12351, '\p{^-	CJK_symbols}', "");
    Expect(0, 12351, '\P{-	CJK_symbols}', "");
    Expect(1, 12351, '\P{^-	CJK_symbols}', "");
    Expect(0, 12352, '\p{-	CJK_symbols}', "");
    Expect(1, 12352, '\p{^-	CJK_symbols}', "");
    Expect(1, 12352, '\P{-	CJK_symbols}', "");
    Expect(0, 12352, '\P{^-	CJK_symbols}', "");
    Error('\p{/a/__IS_CJK_Symbols}');
    Error('\P{/a/__IS_CJK_Symbols}');
    Expect(1, 12351, '\p{iscjksymbols}', "");
    Expect(0, 12351, '\p{^iscjksymbols}', "");
    Expect(0, 12351, '\P{iscjksymbols}', "");
    Expect(1, 12351, '\P{^iscjksymbols}', "");
    Expect(0, 12352, '\p{iscjksymbols}', "");
    Expect(1, 12352, '\p{^iscjksymbols}', "");
    Expect(1, 12352, '\P{iscjksymbols}', "");
    Expect(0, 12352, '\P{^iscjksymbols}', "");
    Expect(1, 12351, '\p{-_Is_cjk_SYMBOLS}', "");
    Expect(0, 12351, '\p{^-_Is_cjk_SYMBOLS}', "");
    Expect(0, 12351, '\P{-_Is_cjk_SYMBOLS}', "");
    Expect(1, 12351, '\P{^-_Is_cjk_SYMBOLS}', "");
    Expect(0, 12352, '\p{-_Is_cjk_SYMBOLS}', "");
    Expect(1, 12352, '\p{^-_Is_cjk_SYMBOLS}', "");
    Expect(1, 12352, '\P{-_Is_cjk_SYMBOLS}', "");
    Expect(0, 12352, '\P{^-_Is_cjk_SYMBOLS}', "");
    Error('\p{ -In_CJK_Symbols/a/}');
    Error('\P{ -In_CJK_Symbols/a/}');
    Expect(1, 12351, '\p{incjksymbols}', "");
    Expect(0, 12351, '\p{^incjksymbols}', "");
    Expect(0, 12351, '\P{incjksymbols}', "");
    Expect(1, 12351, '\P{^incjksymbols}', "");
    Expect(0, 12352, '\p{incjksymbols}', "");
    Expect(1, 12352, '\p{^incjksymbols}', "");
    Expect(1, 12352, '\P{incjksymbols}', "");
    Expect(0, 12352, '\P{^incjksymbols}', "");
    Expect(1, 12351, '\p{_-In_CJK_Symbols}', "");
    Expect(0, 12351, '\p{^_-In_CJK_Symbols}', "");
    Expect(0, 12351, '\P{_-In_CJK_Symbols}', "");
    Expect(1, 12351, '\P{^_-In_CJK_Symbols}', "");
    Expect(0, 12352, '\p{_-In_CJK_Symbols}', "");
    Expect(1, 12352, '\p{^_-In_CJK_Symbols}', "");
    Expect(1, 12352, '\P{_-In_CJK_Symbols}', "");
    Expect(0, 12352, '\P{^_-In_CJK_Symbols}', "");
    Error('\p{ _CJK_unified_Ideographs:=}');
    Error('\P{ _CJK_unified_Ideographs:=}');
    Expect(1, 40959, '\p{cjkunifiedideographs}', "");
    Expect(0, 40959, '\p{^cjkunifiedideographs}', "");
    Expect(0, 40959, '\P{cjkunifiedideographs}', "");
    Expect(1, 40959, '\P{^cjkunifiedideographs}', "");
    Expect(0, 40960, '\p{cjkunifiedideographs}', "");
    Expect(1, 40960, '\p{^cjkunifiedideographs}', "");
    Expect(1, 40960, '\P{cjkunifiedideographs}', "");
    Expect(0, 40960, '\P{^cjkunifiedideographs}', "");
    Expect(1, 40959, '\p{ -CJK_unified_Ideographs}', "");
    Expect(0, 40959, '\p{^ -CJK_unified_Ideographs}', "");
    Expect(0, 40959, '\P{ -CJK_unified_Ideographs}', "");
    Expect(1, 40959, '\P{^ -CJK_unified_Ideographs}', "");
    Expect(0, 40960, '\p{ -CJK_unified_Ideographs}', "");
    Expect(1, 40960, '\p{^ -CJK_unified_Ideographs}', "");
    Expect(1, 40960, '\P{ -CJK_unified_Ideographs}', "");
    Expect(0, 40960, '\P{^ -CJK_unified_Ideographs}', "");
    Error('\p{/a/_Is_CJK_unified_IDEOGRAPHS}');
    Error('\P{/a/_Is_CJK_unified_IDEOGRAPHS}');
    Expect(1, 40959, '\p{iscjkunifiedideographs}', "");
    Expect(0, 40959, '\p{^iscjkunifiedideographs}', "");
    Expect(0, 40959, '\P{iscjkunifiedideographs}', "");
    Expect(1, 40959, '\P{^iscjkunifiedideographs}', "");
    Expect(0, 40960, '\p{iscjkunifiedideographs}', "");
    Expect(1, 40960, '\p{^iscjkunifiedideographs}', "");
    Expect(1, 40960, '\P{iscjkunifiedideographs}', "");
    Expect(0, 40960, '\P{^iscjkunifiedideographs}', "");
    Expect(1, 40959, '\p{ _is_CJK_UNIFIED_Ideographs}', "");
    Expect(0, 40959, '\p{^ _is_CJK_UNIFIED_Ideographs}', "");
    Expect(0, 40959, '\P{ _is_CJK_UNIFIED_Ideographs}', "");
    Expect(1, 40959, '\P{^ _is_CJK_UNIFIED_Ideographs}', "");
    Expect(0, 40960, '\p{ _is_CJK_UNIFIED_Ideographs}', "");
    Expect(1, 40960, '\p{^ _is_CJK_UNIFIED_Ideographs}', "");
    Expect(1, 40960, '\P{ _is_CJK_UNIFIED_Ideographs}', "");
    Expect(0, 40960, '\P{^ _is_CJK_UNIFIED_Ideographs}', "");
    Error('\p{:=In_cjk_Unified_Ideographs}');
    Error('\P{:=In_cjk_Unified_Ideographs}');
    Expect(1, 40959, '\p{incjkunifiedideographs}', "");
    Expect(0, 40959, '\p{^incjkunifiedideographs}', "");
    Expect(0, 40959, '\P{incjkunifiedideographs}', "");
    Expect(1, 40959, '\P{^incjkunifiedideographs}', "");
    Expect(0, 40960, '\p{incjkunifiedideographs}', "");
    Expect(1, 40960, '\p{^incjkunifiedideographs}', "");
    Expect(1, 40960, '\P{incjkunifiedideographs}', "");
    Expect(0, 40960, '\P{^incjkunifiedideographs}', "");
    Expect(1, 40959, '\p{	-IN_CJK_unified_IDEOGRAPHS}', "");
    Expect(0, 40959, '\p{^	-IN_CJK_unified_IDEOGRAPHS}', "");
    Expect(0, 40959, '\P{	-IN_CJK_unified_IDEOGRAPHS}', "");
    Expect(1, 40959, '\P{^	-IN_CJK_unified_IDEOGRAPHS}', "");
    Expect(0, 40960, '\p{	-IN_CJK_unified_IDEOGRAPHS}', "");
    Expect(1, 40960, '\p{^	-IN_CJK_unified_IDEOGRAPHS}', "");
    Expect(1, 40960, '\P{	-IN_CJK_unified_IDEOGRAPHS}', "");
    Expect(0, 40960, '\P{^	-IN_CJK_unified_IDEOGRAPHS}', "");
    Error('\p{:=--CJK}');
    Error('\P{:=--CJK}');
    Expect(1, 40959, '\p{cjk}', "");
    Expect(0, 40959, '\p{^cjk}', "");
    Expect(0, 40959, '\P{cjk}', "");
    Expect(1, 40959, '\P{^cjk}', "");
    Expect(0, 40960, '\p{cjk}', "");
    Expect(1, 40960, '\p{^cjk}', "");
    Expect(1, 40960, '\P{cjk}', "");
    Expect(0, 40960, '\P{^cjk}', "");
    Expect(1, 40959, '\p{ _CJK}', "");
    Expect(0, 40959, '\p{^ _CJK}', "");
    Expect(0, 40959, '\P{ _CJK}', "");
    Expect(1, 40959, '\P{^ _CJK}', "");
    Expect(0, 40960, '\p{ _CJK}', "");
    Expect(1, 40960, '\p{^ _CJK}', "");
    Expect(1, 40960, '\P{ _CJK}', "");
    Expect(0, 40960, '\P{^ _CJK}', "");
    Error('\p{--Is_CJK/a/}');
    Error('\P{--Is_CJK/a/}');
    Expect(1, 40959, '\p{iscjk}', "");
    Expect(0, 40959, '\p{^iscjk}', "");
    Expect(0, 40959, '\P{iscjk}', "");
    Expect(1, 40959, '\P{^iscjk}', "");
    Expect(0, 40960, '\p{iscjk}', "");
    Expect(1, 40960, '\p{^iscjk}', "");
    Expect(1, 40960, '\P{iscjk}', "");
    Expect(0, 40960, '\P{^iscjk}', "");
    Expect(1, 40959, '\p{ 	IS_cjk}', "");
    Expect(0, 40959, '\p{^ 	IS_cjk}', "");
    Expect(0, 40959, '\P{ 	IS_cjk}', "");
    Expect(1, 40959, '\P{^ 	IS_cjk}', "");
    Expect(0, 40960, '\p{ 	IS_cjk}', "");
    Expect(1, 40960, '\p{^ 	IS_cjk}', "");
    Expect(1, 40960, '\P{ 	IS_cjk}', "");
    Expect(0, 40960, '\P{^ 	IS_cjk}', "");
    Error('\p{		IN_CJK:=}');
    Error('\P{		IN_CJK:=}');
    Expect(1, 40959, '\p{incjk}', "");
    Expect(0, 40959, '\p{^incjk}', "");
    Expect(0, 40959, '\P{incjk}', "");
    Expect(1, 40959, '\P{^incjk}', "");
    Expect(0, 40960, '\p{incjk}', "");
    Expect(1, 40960, '\p{^incjk}', "");
    Expect(1, 40960, '\P{incjk}', "");
    Expect(0, 40960, '\P{^incjk}', "");
    Expect(1, 40959, '\p{In_cjk}', "");
    Expect(0, 40959, '\p{^In_cjk}', "");
    Expect(0, 40959, '\P{In_cjk}', "");
    Expect(1, 40959, '\P{^In_cjk}', "");
    Expect(0, 40960, '\p{In_cjk}', "");
    Expect(1, 40960, '\p{^In_cjk}', "");
    Expect(1, 40960, '\P{In_cjk}', "");
    Expect(0, 40960, '\P{^In_cjk}', "");
    Error('\p{ :=CJK_UNIFIED_ideographs_extension_a}');
    Error('\P{ :=CJK_UNIFIED_ideographs_extension_a}');
    Expect(1, 19903, '\p{cjkunifiedideographsextensiona}', "");
    Expect(0, 19903, '\p{^cjkunifiedideographsextensiona}', "");
    Expect(0, 19903, '\P{cjkunifiedideographsextensiona}', "");
    Expect(1, 19903, '\P{^cjkunifiedideographsextensiona}', "");
    Expect(0, 19904, '\p{cjkunifiedideographsextensiona}', "");
    Expect(1, 19904, '\p{^cjkunifiedideographsextensiona}', "");
    Expect(1, 19904, '\P{cjkunifiedideographsextensiona}', "");
    Expect(0, 19904, '\P{^cjkunifiedideographsextensiona}', "");
    Expect(1, 19903, '\p{	_cjk_UNIFIED_IDEOGRAPHS_EXTENSION_a}', "");
    Expect(0, 19903, '\p{^	_cjk_UNIFIED_IDEOGRAPHS_EXTENSION_a}', "");
    Expect(0, 19903, '\P{	_cjk_UNIFIED_IDEOGRAPHS_EXTENSION_a}', "");
    Expect(1, 19903, '\P{^	_cjk_UNIFIED_IDEOGRAPHS_EXTENSION_a}', "");
    Expect(0, 19904, '\p{	_cjk_UNIFIED_IDEOGRAPHS_EXTENSION_a}', "");
    Expect(1, 19904, '\p{^	_cjk_UNIFIED_IDEOGRAPHS_EXTENSION_a}', "");
    Expect(1, 19904, '\P{	_cjk_UNIFIED_IDEOGRAPHS_EXTENSION_a}', "");
    Expect(0, 19904, '\P{^	_cjk_UNIFIED_IDEOGRAPHS_EXTENSION_a}', "");
    Error('\p{/a/	Is_CJK_UNIFIED_Ideographs_Extension_a}');
    Error('\P{/a/	Is_CJK_UNIFIED_Ideographs_Extension_a}');
    Expect(1, 19903, '\p{iscjkunifiedideographsextensiona}', "");
    Expect(0, 19903, '\p{^iscjkunifiedideographsextensiona}', "");
    Expect(0, 19903, '\P{iscjkunifiedideographsextensiona}', "");
    Expect(1, 19903, '\P{^iscjkunifiedideographsextensiona}', "");
    Expect(0, 19904, '\p{iscjkunifiedideographsextensiona}', "");
    Expect(1, 19904, '\p{^iscjkunifiedideographsextensiona}', "");
    Expect(1, 19904, '\P{iscjkunifiedideographsextensiona}', "");
    Expect(0, 19904, '\P{^iscjkunifiedideographsextensiona}', "");
    Expect(1, 19903, '\p{__IS_CJK_Unified_Ideographs_Extension_A}', "");
    Expect(0, 19903, '\p{^__IS_CJK_Unified_Ideographs_Extension_A}', "");
    Expect(0, 19903, '\P{__IS_CJK_Unified_Ideographs_Extension_A}', "");
    Expect(1, 19903, '\P{^__IS_CJK_Unified_Ideographs_Extension_A}', "");
    Expect(0, 19904, '\p{__IS_CJK_Unified_Ideographs_Extension_A}', "");
    Expect(1, 19904, '\p{^__IS_CJK_Unified_Ideographs_Extension_A}', "");
    Expect(1, 19904, '\P{__IS_CJK_Unified_Ideographs_Extension_A}', "");
    Expect(0, 19904, '\P{^__IS_CJK_Unified_Ideographs_Extension_A}', "");
    Error('\p{ /a/in_cjk_UNIFIED_ideographs_Extension_a}');
    Error('\P{ /a/in_cjk_UNIFIED_ideographs_Extension_a}');
    Expect(1, 19903, '\p{incjkunifiedideographsextensiona}', "");
    Expect(0, 19903, '\p{^incjkunifiedideographsextensiona}', "");
    Expect(0, 19903, '\P{incjkunifiedideographsextensiona}', "");
    Expect(1, 19903, '\P{^incjkunifiedideographsextensiona}', "");
    Expect(0, 19904, '\p{incjkunifiedideographsextensiona}', "");
    Expect(1, 19904, '\p{^incjkunifiedideographsextensiona}', "");
    Expect(1, 19904, '\P{incjkunifiedideographsextensiona}', "");
    Expect(0, 19904, '\P{^incjkunifiedideographsextensiona}', "");
    Expect(1, 19903, '\p{ 	in_CJK_unified_Ideographs_Extension_A}', "");
    Expect(0, 19903, '\p{^ 	in_CJK_unified_Ideographs_Extension_A}', "");
    Expect(0, 19903, '\P{ 	in_CJK_unified_Ideographs_Extension_A}', "");
    Expect(1, 19903, '\P{^ 	in_CJK_unified_Ideographs_Extension_A}', "");
    Expect(0, 19904, '\p{ 	in_CJK_unified_Ideographs_Extension_A}', "");
    Expect(1, 19904, '\p{^ 	in_CJK_unified_Ideographs_Extension_A}', "");
    Expect(1, 19904, '\P{ 	in_CJK_unified_Ideographs_Extension_A}', "");
    Expect(0, 19904, '\P{^ 	in_CJK_unified_Ideographs_Extension_A}', "");
    Error('\p{_-CJK_EXT_A:=}');
    Error('\P{_-CJK_EXT_A:=}');
    Expect(1, 19903, '\p{cjkexta}', "");
    Expect(0, 19903, '\p{^cjkexta}', "");
    Expect(0, 19903, '\P{cjkexta}', "");
    Expect(1, 19903, '\P{^cjkexta}', "");
    Expect(0, 19904, '\p{cjkexta}', "");
    Expect(1, 19904, '\p{^cjkexta}', "");
    Expect(1, 19904, '\P{cjkexta}', "");
    Expect(0, 19904, '\P{^cjkexta}', "");
    Expect(1, 19903, '\p{ _CJK_ext_A}', "");
    Expect(0, 19903, '\p{^ _CJK_ext_A}', "");
    Expect(0, 19903, '\P{ _CJK_ext_A}', "");
    Expect(1, 19903, '\P{^ _CJK_ext_A}', "");
    Expect(0, 19904, '\p{ _CJK_ext_A}', "");
    Expect(1, 19904, '\p{^ _CJK_ext_A}', "");
    Expect(1, 19904, '\P{ _CJK_ext_A}', "");
    Expect(0, 19904, '\P{^ _CJK_ext_A}', "");
    Error('\p{		Is_CJK_EXT_a:=}');
    Error('\P{		Is_CJK_EXT_a:=}');
    Expect(1, 19903, '\p{iscjkexta}', "");
    Expect(0, 19903, '\p{^iscjkexta}', "");
    Expect(0, 19903, '\P{iscjkexta}', "");
    Expect(1, 19903, '\P{^iscjkexta}', "");
    Expect(0, 19904, '\p{iscjkexta}', "");
    Expect(1, 19904, '\p{^iscjkexta}', "");
    Expect(1, 19904, '\P{iscjkexta}', "");
    Expect(0, 19904, '\P{^iscjkexta}', "");
    Expect(1, 19903, '\p{_	is_cjk_Ext_A}', "");
    Expect(0, 19903, '\p{^_	is_cjk_Ext_A}', "");
    Expect(0, 19903, '\P{_	is_cjk_Ext_A}', "");
    Expect(1, 19903, '\P{^_	is_cjk_Ext_A}', "");
    Expect(0, 19904, '\p{_	is_cjk_Ext_A}', "");
    Expect(1, 19904, '\p{^_	is_cjk_Ext_A}', "");
    Expect(1, 19904, '\P{_	is_cjk_Ext_A}', "");
    Expect(0, 19904, '\P{^_	is_cjk_Ext_A}', "");
    Error('\p{-/a/In_CJK_Ext_A}');
    Error('\P{-/a/In_CJK_Ext_A}');
    Expect(1, 19903, '\p{incjkexta}', "");
    Expect(0, 19903, '\p{^incjkexta}', "");
    Expect(0, 19903, '\P{incjkexta}', "");
    Expect(1, 19903, '\P{^incjkexta}', "");
    Expect(0, 19904, '\p{incjkexta}', "");
    Expect(1, 19904, '\p{^incjkexta}', "");
    Expect(1, 19904, '\P{incjkexta}', "");
    Expect(0, 19904, '\P{^incjkexta}', "");
    Expect(1, 19903, '\p{_-in_CJK_Ext_A}', "");
    Expect(0, 19903, '\p{^_-in_CJK_Ext_A}', "");
    Expect(0, 19903, '\P{_-in_CJK_Ext_A}', "");
    Expect(1, 19903, '\P{^_-in_CJK_Ext_A}', "");
    Expect(0, 19904, '\p{_-in_CJK_Ext_A}', "");
    Expect(1, 19904, '\p{^_-in_CJK_Ext_A}', "");
    Expect(1, 19904, '\P{_-in_CJK_Ext_A}', "");
    Expect(0, 19904, '\P{^_-in_CJK_Ext_A}', "");
    Error('\p{-cjk_UNIFIED_Ideographs_Extension_B/a/}');
    Error('\P{-cjk_UNIFIED_Ideographs_Extension_B/a/}');
    Expect(1, 173791, '\p{cjkunifiedideographsextensionb}', "");
    Expect(0, 173791, '\p{^cjkunifiedideographsextensionb}', "");
    Expect(0, 173791, '\P{cjkunifiedideographsextensionb}', "");
    Expect(1, 173791, '\P{^cjkunifiedideographsextensionb}', "");
    Expect(0, 173792, '\p{cjkunifiedideographsextensionb}', "");
    Expect(1, 173792, '\p{^cjkunifiedideographsextensionb}', "");
    Expect(1, 173792, '\P{cjkunifiedideographsextensionb}', "");
    Expect(0, 173792, '\P{^cjkunifiedideographsextensionb}', "");
    Expect(1, 173791, '\p{-CJK_Unified_ideographs_Extension_b}', "");
    Expect(0, 173791, '\p{^-CJK_Unified_ideographs_Extension_b}', "");
    Expect(0, 173791, '\P{-CJK_Unified_ideographs_Extension_b}', "");
    Expect(1, 173791, '\P{^-CJK_Unified_ideographs_Extension_b}', "");
    Expect(0, 173792, '\p{-CJK_Unified_ideographs_Extension_b}', "");
    Expect(1, 173792, '\p{^-CJK_Unified_ideographs_Extension_b}', "");
    Expect(1, 173792, '\P{-CJK_Unified_ideographs_Extension_b}', "");
    Expect(0, 173792, '\P{^-CJK_Unified_ideographs_Extension_b}', "");
    Error('\p{_is_CJK_unified_Ideographs_EXTENSION_B/a/}');
    Error('\P{_is_CJK_unified_Ideographs_EXTENSION_B/a/}');
    Expect(1, 173791, '\p{iscjkunifiedideographsextensionb}', "");
    Expect(0, 173791, '\p{^iscjkunifiedideographsextensionb}', "");
    Expect(0, 173791, '\P{iscjkunifiedideographsextensionb}', "");
    Expect(1, 173791, '\P{^iscjkunifiedideographsextensionb}', "");
    Expect(0, 173792, '\p{iscjkunifiedideographsextensionb}', "");
    Expect(1, 173792, '\p{^iscjkunifiedideographsextensionb}', "");
    Expect(1, 173792, '\P{iscjkunifiedideographsextensionb}', "");
    Expect(0, 173792, '\P{^iscjkunifiedideographsextensionb}', "");
    Expect(1, 173791, '\p{-Is_CJK_unified_ideographs_extension_B}', "");
    Expect(0, 173791, '\p{^-Is_CJK_unified_ideographs_extension_B}', "");
    Expect(0, 173791, '\P{-Is_CJK_unified_ideographs_extension_B}', "");
    Expect(1, 173791, '\P{^-Is_CJK_unified_ideographs_extension_B}', "");
    Expect(0, 173792, '\p{-Is_CJK_unified_ideographs_extension_B}', "");
    Expect(1, 173792, '\p{^-Is_CJK_unified_ideographs_extension_B}', "");
    Expect(1, 173792, '\P{-Is_CJK_unified_ideographs_extension_B}', "");
    Expect(0, 173792, '\P{^-Is_CJK_unified_ideographs_extension_B}', "");
    Error('\p{/a/IN_CJK_Unified_IDEOGRAPHS_Extension_B}');
    Error('\P{/a/IN_CJK_Unified_IDEOGRAPHS_Extension_B}');
    Expect(1, 173791, '\p{incjkunifiedideographsextensionb}', "");
    Expect(0, 173791, '\p{^incjkunifiedideographsextensionb}', "");
    Expect(0, 173791, '\P{incjkunifiedideographsextensionb}', "");
    Expect(1, 173791, '\P{^incjkunifiedideographsextensionb}', "");
    Expect(0, 173792, '\p{incjkunifiedideographsextensionb}', "");
    Expect(1, 173792, '\p{^incjkunifiedideographsextensionb}', "");
    Expect(1, 173792, '\P{incjkunifiedideographsextensionb}', "");
    Expect(0, 173792, '\P{^incjkunifiedideographsextensionb}', "");
    Expect(1, 173791, '\p{-	In_cjk_UNIFIED_ideographs_EXTENSION_b}', "");
    Expect(0, 173791, '\p{^-	In_cjk_UNIFIED_ideographs_EXTENSION_b}', "");
    Expect(0, 173791, '\P{-	In_cjk_UNIFIED_ideographs_EXTENSION_b}', "");
    Expect(1, 173791, '\P{^-	In_cjk_UNIFIED_ideographs_EXTENSION_b}', "");
    Expect(0, 173792, '\p{-	In_cjk_UNIFIED_ideographs_EXTENSION_b}', "");
    Expect(1, 173792, '\p{^-	In_cjk_UNIFIED_ideographs_EXTENSION_b}', "");
    Expect(1, 173792, '\P{-	In_cjk_UNIFIED_ideographs_EXTENSION_b}', "");
    Expect(0, 173792, '\P{^-	In_cjk_UNIFIED_ideographs_EXTENSION_b}', "");
    Error('\p{-/a/CJK_Ext_b}');
    Error('\P{-/a/CJK_Ext_b}');
    Expect(1, 173791, '\p{cjkextb}', "");
    Expect(0, 173791, '\p{^cjkextb}', "");
    Expect(0, 173791, '\P{cjkextb}', "");
    Expect(1, 173791, '\P{^cjkextb}', "");
    Expect(0, 173792, '\p{cjkextb}', "");
    Expect(1, 173792, '\p{^cjkextb}', "");
    Expect(1, 173792, '\P{cjkextb}', "");
    Expect(0, 173792, '\P{^cjkextb}', "");
    Expect(1, 173791, '\p{--CJK_Ext_B}', "");
    Expect(0, 173791, '\p{^--CJK_Ext_B}', "");
    Expect(0, 173791, '\P{--CJK_Ext_B}', "");
    Expect(1, 173791, '\P{^--CJK_Ext_B}', "");
    Expect(0, 173792, '\p{--CJK_Ext_B}', "");
    Expect(1, 173792, '\p{^--CJK_Ext_B}', "");
    Expect(1, 173792, '\P{--CJK_Ext_B}', "");
    Expect(0, 173792, '\P{^--CJK_Ext_B}', "");
    Error('\p{:=- IS_CJK_ext_B}');
    Error('\P{:=- IS_CJK_ext_B}');
    Expect(1, 173791, '\p{iscjkextb}', "");
    Expect(0, 173791, '\p{^iscjkextb}', "");
    Expect(0, 173791, '\P{iscjkextb}', "");
    Expect(1, 173791, '\P{^iscjkextb}', "");
    Expect(0, 173792, '\p{iscjkextb}', "");
    Expect(1, 173792, '\p{^iscjkextb}', "");
    Expect(1, 173792, '\P{iscjkextb}', "");
    Expect(0, 173792, '\P{^iscjkextb}', "");
    Expect(1, 173791, '\p{		is_CJK_Ext_B}', "");
    Expect(0, 173791, '\p{^		is_CJK_Ext_B}', "");
    Expect(0, 173791, '\P{		is_CJK_Ext_B}', "");
    Expect(1, 173791, '\P{^		is_CJK_Ext_B}', "");
    Expect(0, 173792, '\p{		is_CJK_Ext_B}', "");
    Expect(1, 173792, '\p{^		is_CJK_Ext_B}', "");
    Expect(1, 173792, '\P{		is_CJK_Ext_B}', "");
    Expect(0, 173792, '\P{^		is_CJK_Ext_B}', "");
    Error('\p{:=IN_CJK_Ext_B}');
    Error('\P{:=IN_CJK_Ext_B}');
    Expect(1, 173791, '\p{incjkextb}', "");
    Expect(0, 173791, '\p{^incjkextb}', "");
    Expect(0, 173791, '\P{incjkextb}', "");
    Expect(1, 173791, '\P{^incjkextb}', "");
    Expect(0, 173792, '\p{incjkextb}', "");
    Expect(1, 173792, '\p{^incjkextb}', "");
    Expect(1, 173792, '\P{incjkextb}', "");
    Expect(0, 173792, '\P{^incjkextb}', "");
    Expect(1, 173791, '\p{-	In_CJK_EXT_b}', "");
    Expect(0, 173791, '\p{^-	In_CJK_EXT_b}', "");
    Expect(0, 173791, '\P{-	In_CJK_EXT_b}', "");
    Expect(1, 173791, '\P{^-	In_CJK_EXT_b}', "");
    Expect(0, 173792, '\p{-	In_CJK_EXT_b}', "");
    Expect(1, 173792, '\p{^-	In_CJK_EXT_b}', "");
    Expect(1, 173792, '\P{-	In_CJK_EXT_b}', "");
    Expect(0, 173792, '\P{^-	In_CJK_EXT_b}', "");
    Error('\p{_-CJK_UNIFIED_Ideographs_Extension_C:=}');
    Error('\P{_-CJK_UNIFIED_Ideographs_Extension_C:=}');
    Expect(1, 177983, '\p{cjkunifiedideographsextensionc}', "");
    Expect(0, 177983, '\p{^cjkunifiedideographsextensionc}', "");
    Expect(0, 177983, '\P{cjkunifiedideographsextensionc}', "");
    Expect(1, 177983, '\P{^cjkunifiedideographsextensionc}', "");
    Expect(0, 177984, '\p{cjkunifiedideographsextensionc}', "");
    Expect(1, 177984, '\p{^cjkunifiedideographsextensionc}', "");
    Expect(1, 177984, '\P{cjkunifiedideographsextensionc}', "");
    Expect(0, 177984, '\P{^cjkunifiedideographsextensionc}', "");
    Expect(1, 177983, '\p{_CJK_UNIFIED_IDEOGRAPHS_extension_c}', "");
    Expect(0, 177983, '\p{^_CJK_UNIFIED_IDEOGRAPHS_extension_c}', "");
    Expect(0, 177983, '\P{_CJK_UNIFIED_IDEOGRAPHS_extension_c}', "");
    Expect(1, 177983, '\P{^_CJK_UNIFIED_IDEOGRAPHS_extension_c}', "");
    Expect(0, 177984, '\p{_CJK_UNIFIED_IDEOGRAPHS_extension_c}', "");
    Expect(1, 177984, '\p{^_CJK_UNIFIED_IDEOGRAPHS_extension_c}', "");
    Expect(1, 177984, '\P{_CJK_UNIFIED_IDEOGRAPHS_extension_c}', "");
    Expect(0, 177984, '\P{^_CJK_UNIFIED_IDEOGRAPHS_extension_c}', "");
    Error('\p{ :=Is_CJK_Unified_ideographs_extension_C}');
    Error('\P{ :=Is_CJK_Unified_ideographs_extension_C}');
    Expect(1, 177983, '\p{iscjkunifiedideographsextensionc}', "");
    Expect(0, 177983, '\p{^iscjkunifiedideographsextensionc}', "");
    Expect(0, 177983, '\P{iscjkunifiedideographsextensionc}', "");
    Expect(1, 177983, '\P{^iscjkunifiedideographsextensionc}', "");
    Expect(0, 177984, '\p{iscjkunifiedideographsextensionc}', "");
    Expect(1, 177984, '\p{^iscjkunifiedideographsextensionc}', "");
    Expect(1, 177984, '\P{iscjkunifiedideographsextensionc}', "");
    Expect(0, 177984, '\P{^iscjkunifiedideographsextensionc}', "");
    Expect(1, 177983, '\p{-IS_CJK_Unified_Ideographs_EXTENSION_C}', "");
    Expect(0, 177983, '\p{^-IS_CJK_Unified_Ideographs_EXTENSION_C}', "");
    Expect(0, 177983, '\P{-IS_CJK_Unified_Ideographs_EXTENSION_C}', "");
    Expect(1, 177983, '\P{^-IS_CJK_Unified_Ideographs_EXTENSION_C}', "");
    Expect(0, 177984, '\p{-IS_CJK_Unified_Ideographs_EXTENSION_C}', "");
    Expect(1, 177984, '\p{^-IS_CJK_Unified_Ideographs_EXTENSION_C}', "");
    Expect(1, 177984, '\P{-IS_CJK_Unified_Ideographs_EXTENSION_C}', "");
    Expect(0, 177984, '\P{^-IS_CJK_Unified_Ideographs_EXTENSION_C}', "");
    Error('\p{-/a/In_CJK_Unified_Ideographs_Extension_C}');
    Error('\P{-/a/In_CJK_Unified_Ideographs_Extension_C}');
    Expect(1, 177983, '\p{incjkunifiedideographsextensionc}', "");
    Expect(0, 177983, '\p{^incjkunifiedideographsextensionc}', "");
    Expect(0, 177983, '\P{incjkunifiedideographsextensionc}', "");
    Expect(1, 177983, '\P{^incjkunifiedideographsextensionc}', "");
    Expect(0, 177984, '\p{incjkunifiedideographsextensionc}', "");
    Expect(1, 177984, '\p{^incjkunifiedideographsextensionc}', "");
    Expect(1, 177984, '\P{incjkunifiedideographsextensionc}', "");
    Expect(0, 177984, '\P{^incjkunifiedideographsextensionc}', "");
    Expect(1, 177983, '\p{	In_CJK_Unified_IDEOGRAPHS_extension_C}', "");
    Expect(0, 177983, '\p{^	In_CJK_Unified_IDEOGRAPHS_extension_C}', "");
    Expect(0, 177983, '\P{	In_CJK_Unified_IDEOGRAPHS_extension_C}', "");
    Expect(1, 177983, '\P{^	In_CJK_Unified_IDEOGRAPHS_extension_C}', "");
    Expect(0, 177984, '\p{	In_CJK_Unified_IDEOGRAPHS_extension_C}', "");
    Expect(1, 177984, '\p{^	In_CJK_Unified_IDEOGRAPHS_extension_C}', "");
    Expect(1, 177984, '\P{	In_CJK_Unified_IDEOGRAPHS_extension_C}', "");
    Expect(0, 177984, '\P{^	In_CJK_Unified_IDEOGRAPHS_extension_C}', "");
    Error('\p{-/a/CJK_ext_C}');
    Error('\P{-/a/CJK_ext_C}');
    Expect(1, 177983, '\p{cjkextc}', "");
    Expect(0, 177983, '\p{^cjkextc}', "");
    Expect(0, 177983, '\P{cjkextc}', "");
    Expect(1, 177983, '\P{^cjkextc}', "");
    Expect(0, 177984, '\p{cjkextc}', "");
    Expect(1, 177984, '\p{^cjkextc}', "");
    Expect(1, 177984, '\P{cjkextc}', "");
    Expect(0, 177984, '\P{^cjkextc}', "");
    Expect(1, 177983, '\p{ CJK_ext_C}', "");
    Expect(0, 177983, '\p{^ CJK_ext_C}', "");
    Expect(0, 177983, '\P{ CJK_ext_C}', "");
    Expect(1, 177983, '\P{^ CJK_ext_C}', "");
    Expect(0, 177984, '\p{ CJK_ext_C}', "");
    Expect(1, 177984, '\p{^ CJK_ext_C}', "");
    Expect(1, 177984, '\P{ CJK_ext_C}', "");
    Expect(0, 177984, '\P{^ CJK_ext_C}', "");
    Error('\p{-IS_CJK_ext_C/a/}');
    Error('\P{-IS_CJK_ext_C/a/}');
    Expect(1, 177983, '\p{iscjkextc}', "");
    Expect(0, 177983, '\p{^iscjkextc}', "");
    Expect(0, 177983, '\P{iscjkextc}', "");
    Expect(1, 177983, '\P{^iscjkextc}', "");
    Expect(0, 177984, '\p{iscjkextc}', "");
    Expect(1, 177984, '\p{^iscjkextc}', "");
    Expect(1, 177984, '\P{iscjkextc}', "");
    Expect(0, 177984, '\P{^iscjkextc}', "");
    Expect(1, 177983, '\p{--Is_cjk_EXT_C}', "");
    Expect(0, 177983, '\p{^--Is_cjk_EXT_C}', "");
    Expect(0, 177983, '\P{--Is_cjk_EXT_C}', "");
    Expect(1, 177983, '\P{^--Is_cjk_EXT_C}', "");
    Expect(0, 177984, '\p{--Is_cjk_EXT_C}', "");
    Expect(1, 177984, '\p{^--Is_cjk_EXT_C}', "");
    Expect(1, 177984, '\P{--Is_cjk_EXT_C}', "");
    Expect(0, 177984, '\P{^--Is_cjk_EXT_C}', "");
    Error('\p{-	In_CJK_EXT_c/a/}');
    Error('\P{-	In_CJK_EXT_c/a/}');
    Expect(1, 177983, '\p{incjkextc}', "");
    Expect(0, 177983, '\p{^incjkextc}', "");
    Expect(0, 177983, '\P{incjkextc}', "");
    Expect(1, 177983, '\P{^incjkextc}', "");
    Expect(0, 177984, '\p{incjkextc}', "");
    Expect(1, 177984, '\p{^incjkextc}', "");
    Expect(1, 177984, '\P{incjkextc}', "");
    Expect(0, 177984, '\P{^incjkextc}', "");
    Expect(1, 177983, '\p{-IN_cjk_ext_C}', "");
    Expect(0, 177983, '\p{^-IN_cjk_ext_C}', "");
    Expect(0, 177983, '\P{-IN_cjk_ext_C}', "");
    Expect(1, 177983, '\P{^-IN_cjk_ext_C}', "");
    Expect(0, 177984, '\p{-IN_cjk_ext_C}', "");
    Expect(1, 177984, '\p{^-IN_cjk_ext_C}', "");
    Expect(1, 177984, '\P{-IN_cjk_ext_C}', "");
    Expect(0, 177984, '\P{^-IN_cjk_ext_C}', "");
    Error('\p{_:=CJK_Unified_Ideographs_extension_d}');
    Error('\P{_:=CJK_Unified_Ideographs_extension_d}');
    Expect(1, 178207, '\p{cjkunifiedideographsextensiond}', "");
    Expect(0, 178207, '\p{^cjkunifiedideographsextensiond}', "");
    Expect(0, 178207, '\P{cjkunifiedideographsextensiond}', "");
    Expect(1, 178207, '\P{^cjkunifiedideographsextensiond}', "");
    Expect(0, 178208, '\p{cjkunifiedideographsextensiond}', "");
    Expect(1, 178208, '\p{^cjkunifiedideographsextensiond}', "");
    Expect(1, 178208, '\P{cjkunifiedideographsextensiond}', "");
    Expect(0, 178208, '\P{^cjkunifiedideographsextensiond}', "");
    Expect(1, 178207, '\p{_CJK_Unified_Ideographs_Extension_D}', "");
    Expect(0, 178207, '\p{^_CJK_Unified_Ideographs_Extension_D}', "");
    Expect(0, 178207, '\P{_CJK_Unified_Ideographs_Extension_D}', "");
    Expect(1, 178207, '\P{^_CJK_Unified_Ideographs_Extension_D}', "");
    Expect(0, 178208, '\p{_CJK_Unified_Ideographs_Extension_D}', "");
    Expect(1, 178208, '\p{^_CJK_Unified_Ideographs_Extension_D}', "");
    Expect(1, 178208, '\P{_CJK_Unified_Ideographs_Extension_D}', "");
    Expect(0, 178208, '\P{^_CJK_Unified_Ideographs_Extension_D}', "");
    Error('\p{:=	 IS_CJK_unified_Ideographs_EXTENSION_d}');
    Error('\P{:=	 IS_CJK_unified_Ideographs_EXTENSION_d}');
    Expect(1, 178207, '\p{iscjkunifiedideographsextensiond}', "");
    Expect(0, 178207, '\p{^iscjkunifiedideographsextensiond}', "");
    Expect(0, 178207, '\P{iscjkunifiedideographsextensiond}', "");
    Expect(1, 178207, '\P{^iscjkunifiedideographsextensiond}', "");
    Expect(0, 178208, '\p{iscjkunifiedideographsextensiond}', "");
    Expect(1, 178208, '\p{^iscjkunifiedideographsextensiond}', "");
    Expect(1, 178208, '\P{iscjkunifiedideographsextensiond}', "");
    Expect(0, 178208, '\P{^iscjkunifiedideographsextensiond}', "");
    Expect(1, 178207, '\p{ _Is_CJK_UNIFIED_IDEOGRAPHS_EXTENSION_D}', "");
    Expect(0, 178207, '\p{^ _Is_CJK_UNIFIED_IDEOGRAPHS_EXTENSION_D}', "");
    Expect(0, 178207, '\P{ _Is_CJK_UNIFIED_IDEOGRAPHS_EXTENSION_D}', "");
    Expect(1, 178207, '\P{^ _Is_CJK_UNIFIED_IDEOGRAPHS_EXTENSION_D}', "");
    Expect(0, 178208, '\p{ _Is_CJK_UNIFIED_IDEOGRAPHS_EXTENSION_D}', "");
    Expect(1, 178208, '\p{^ _Is_CJK_UNIFIED_IDEOGRAPHS_EXTENSION_D}', "");
    Expect(1, 178208, '\P{ _Is_CJK_UNIFIED_IDEOGRAPHS_EXTENSION_D}', "");
    Expect(0, 178208, '\P{^ _Is_CJK_UNIFIED_IDEOGRAPHS_EXTENSION_D}', "");
    Error('\p{	In_CJK_UNIFIED_Ideographs_Extension_D/a/}');
    Error('\P{	In_CJK_UNIFIED_Ideographs_Extension_D/a/}');
    Expect(1, 178207, '\p{incjkunifiedideographsextensiond}', "");
    Expect(0, 178207, '\p{^incjkunifiedideographsextensiond}', "");
    Expect(0, 178207, '\P{incjkunifiedideographsextensiond}', "");
    Expect(1, 178207, '\P{^incjkunifiedideographsextensiond}', "");
    Expect(0, 178208, '\p{incjkunifiedideographsextensiond}', "");
    Expect(1, 178208, '\p{^incjkunifiedideographsextensiond}', "");
    Expect(1, 178208, '\P{incjkunifiedideographsextensiond}', "");
    Expect(0, 178208, '\P{^incjkunifiedideographsextensiond}', "");
    Expect(1, 178207, '\p{	_IN_CJK_Unified_Ideographs_extension_D}', "");
    Expect(0, 178207, '\p{^	_IN_CJK_Unified_Ideographs_extension_D}', "");
    Expect(0, 178207, '\P{	_IN_CJK_Unified_Ideographs_extension_D}', "");
    Expect(1, 178207, '\P{^	_IN_CJK_Unified_Ideographs_extension_D}', "");
    Expect(0, 178208, '\p{	_IN_CJK_Unified_Ideographs_extension_D}', "");
    Expect(1, 178208, '\p{^	_IN_CJK_Unified_Ideographs_extension_D}', "");
    Expect(1, 178208, '\P{	_IN_CJK_Unified_Ideographs_extension_D}', "");
    Expect(0, 178208, '\P{^	_IN_CJK_Unified_Ideographs_extension_D}', "");
    Error('\p{-:=CJK_Ext_D}');
    Error('\P{-:=CJK_Ext_D}');
    Expect(1, 178207, '\p{cjkextd}', "");
    Expect(0, 178207, '\p{^cjkextd}', "");
    Expect(0, 178207, '\P{cjkextd}', "");
    Expect(1, 178207, '\P{^cjkextd}', "");
    Expect(0, 178208, '\p{cjkextd}', "");
    Expect(1, 178208, '\p{^cjkextd}', "");
    Expect(1, 178208, '\P{cjkextd}', "");
    Expect(0, 178208, '\P{^cjkextd}', "");
    Expect(1, 178207, '\p{-CJK_ext_D}', "");
    Expect(0, 178207, '\p{^-CJK_ext_D}', "");
    Expect(0, 178207, '\P{-CJK_ext_D}', "");
    Expect(1, 178207, '\P{^-CJK_ext_D}', "");
    Expect(0, 178208, '\p{-CJK_ext_D}', "");
    Expect(1, 178208, '\p{^-CJK_ext_D}', "");
    Expect(1, 178208, '\P{-CJK_ext_D}', "");
    Expect(0, 178208, '\P{^-CJK_ext_D}', "");
    Error('\p{:=--is_CJK_ext_d}');
    Error('\P{:=--is_CJK_ext_d}');
    Expect(1, 178207, '\p{iscjkextd}', "");
    Expect(0, 178207, '\p{^iscjkextd}', "");
    Expect(0, 178207, '\P{iscjkextd}', "");
    Expect(1, 178207, '\P{^iscjkextd}', "");
    Expect(0, 178208, '\p{iscjkextd}', "");
    Expect(1, 178208, '\p{^iscjkextd}', "");
    Expect(1, 178208, '\P{iscjkextd}', "");
    Expect(0, 178208, '\P{^iscjkextd}', "");
    Expect(1, 178207, '\p{ _IS_CJK_Ext_d}', "");
    Expect(0, 178207, '\p{^ _IS_CJK_Ext_d}', "");
    Expect(0, 178207, '\P{ _IS_CJK_Ext_d}', "");
    Expect(1, 178207, '\P{^ _IS_CJK_Ext_d}', "");
    Expect(0, 178208, '\p{ _IS_CJK_Ext_d}', "");
    Expect(1, 178208, '\p{^ _IS_CJK_Ext_d}', "");
    Expect(1, 178208, '\P{ _IS_CJK_Ext_d}', "");
    Expect(0, 178208, '\P{^ _IS_CJK_Ext_d}', "");
    Error('\p{	/a/IN_CJK_Ext_D}');
    Error('\P{	/a/IN_CJK_Ext_D}');
    Expect(1, 178207, '\p{incjkextd}', "");
    Expect(0, 178207, '\p{^incjkextd}', "");
    Expect(0, 178207, '\P{incjkextd}', "");
    Expect(1, 178207, '\P{^incjkextd}', "");
    Expect(0, 178208, '\p{incjkextd}', "");
    Expect(1, 178208, '\p{^incjkextd}', "");
    Expect(1, 178208, '\P{incjkextd}', "");
    Expect(0, 178208, '\P{^incjkextd}', "");
    Expect(1, 178207, '\p{_ in_CJK_Ext_d}', "");
    Expect(0, 178207, '\p{^_ in_CJK_Ext_d}', "");
    Expect(0, 178207, '\P{_ in_CJK_Ext_d}', "");
    Expect(1, 178207, '\P{^_ in_CJK_Ext_d}', "");
    Expect(0, 178208, '\p{_ in_CJK_Ext_d}', "");
    Expect(1, 178208, '\p{^_ in_CJK_Ext_d}', "");
    Expect(1, 178208, '\P{_ in_CJK_Ext_d}', "");
    Expect(0, 178208, '\P{^_ in_CJK_Ext_d}', "");
    Error('\p{/a/	-CJK_unified_IDEOGRAPHS_EXTENSION_E}');
    Error('\P{/a/	-CJK_unified_IDEOGRAPHS_EXTENSION_E}');
    Expect(1, 183983, '\p{cjkunifiedideographsextensione}', "");
    Expect(0, 183983, '\p{^cjkunifiedideographsextensione}', "");
    Expect(0, 183983, '\P{cjkunifiedideographsextensione}', "");
    Expect(1, 183983, '\P{^cjkunifiedideographsextensione}', "");
    Expect(0, 183984, '\p{cjkunifiedideographsextensione}', "");
    Expect(1, 183984, '\p{^cjkunifiedideographsextensione}', "");
    Expect(1, 183984, '\P{cjkunifiedideographsextensione}', "");
    Expect(0, 183984, '\P{^cjkunifiedideographsextensione}', "");
    Expect(1, 183983, '\p{_ CJK_UNIFIED_Ideographs_extension_E}', "");
    Expect(0, 183983, '\p{^_ CJK_UNIFIED_Ideographs_extension_E}', "");
    Expect(0, 183983, '\P{_ CJK_UNIFIED_Ideographs_extension_E}', "");
    Expect(1, 183983, '\P{^_ CJK_UNIFIED_Ideographs_extension_E}', "");
    Expect(0, 183984, '\p{_ CJK_UNIFIED_Ideographs_extension_E}', "");
    Expect(1, 183984, '\p{^_ CJK_UNIFIED_Ideographs_extension_E}', "");
    Expect(1, 183984, '\P{_ CJK_UNIFIED_Ideographs_extension_E}', "");
    Expect(0, 183984, '\P{^_ CJK_UNIFIED_Ideographs_extension_E}', "");
    Error('\p{:=is_CJK_Unified_ideographs_Extension_E}');
    Error('\P{:=is_CJK_Unified_ideographs_Extension_E}');
    Expect(1, 183983, '\p{iscjkunifiedideographsextensione}', "");
    Expect(0, 183983, '\p{^iscjkunifiedideographsextensione}', "");
    Expect(0, 183983, '\P{iscjkunifiedideographsextensione}', "");
    Expect(1, 183983, '\P{^iscjkunifiedideographsextensione}', "");
    Expect(0, 183984, '\p{iscjkunifiedideographsextensione}', "");
    Expect(1, 183984, '\p{^iscjkunifiedideographsextensione}', "");
    Expect(1, 183984, '\P{iscjkunifiedideographsextensione}', "");
    Expect(0, 183984, '\P{^iscjkunifiedideographsextensione}', "");
    Expect(1, 183983, '\p{Is_CJK_Unified_IDEOGRAPHS_EXTENSION_E}', "");
    Expect(0, 183983, '\p{^Is_CJK_Unified_IDEOGRAPHS_EXTENSION_E}', "");
    Expect(0, 183983, '\P{Is_CJK_Unified_IDEOGRAPHS_EXTENSION_E}', "");
    Expect(1, 183983, '\P{^Is_CJK_Unified_IDEOGRAPHS_EXTENSION_E}', "");
    Expect(0, 183984, '\p{Is_CJK_Unified_IDEOGRAPHS_EXTENSION_E}', "");
    Expect(1, 183984, '\p{^Is_CJK_Unified_IDEOGRAPHS_EXTENSION_E}', "");
    Expect(1, 183984, '\P{Is_CJK_Unified_IDEOGRAPHS_EXTENSION_E}', "");
    Expect(0, 183984, '\P{^Is_CJK_Unified_IDEOGRAPHS_EXTENSION_E}', "");
    Error('\p{	_IN_CJK_Unified_Ideographs_EXTENSION_e/a/}');
    Error('\P{	_IN_CJK_Unified_Ideographs_EXTENSION_e/a/}');
    Expect(1, 183983, '\p{incjkunifiedideographsextensione}', "");
    Expect(0, 183983, '\p{^incjkunifiedideographsextensione}', "");
    Expect(0, 183983, '\P{incjkunifiedideographsextensione}', "");
    Expect(1, 183983, '\P{^incjkunifiedideographsextensione}', "");
    Expect(0, 183984, '\p{incjkunifiedideographsextensione}', "");
    Expect(1, 183984, '\p{^incjkunifiedideographsextensione}', "");
    Expect(1, 183984, '\P{incjkunifiedideographsextensione}', "");
    Expect(0, 183984, '\P{^incjkunifiedideographsextensione}', "");
    Expect(1, 183983, '\p{	 In_CJK_unified_Ideographs_extension_e}', "");
    Expect(0, 183983, '\p{^	 In_CJK_unified_Ideographs_extension_e}', "");
    Expect(0, 183983, '\P{	 In_CJK_unified_Ideographs_extension_e}', "");
    Expect(1, 183983, '\P{^	 In_CJK_unified_Ideographs_extension_e}', "");
    Expect(0, 183984, '\p{	 In_CJK_unified_Ideographs_extension_e}', "");
    Expect(1, 183984, '\p{^	 In_CJK_unified_Ideographs_extension_e}', "");
    Expect(1, 183984, '\P{	 In_CJK_unified_Ideographs_extension_e}', "");
    Expect(0, 183984, '\P{^	 In_CJK_unified_Ideographs_extension_e}', "");
    Error('\p{_/a/CJK_EXT_E}');
    Error('\P{_/a/CJK_EXT_E}');
    Expect(1, 183983, '\p{cjkexte}', "");
    Expect(0, 183983, '\p{^cjkexte}', "");
    Expect(0, 183983, '\P{cjkexte}', "");
    Expect(1, 183983, '\P{^cjkexte}', "");
    Expect(0, 183984, '\p{cjkexte}', "");
    Expect(1, 183984, '\p{^cjkexte}', "");
    Expect(1, 183984, '\P{cjkexte}', "");
    Expect(0, 183984, '\P{^cjkexte}', "");
    Expect(1, 183983, '\p{_-CJK_Ext_E}', "");
    Expect(0, 183983, '\p{^_-CJK_Ext_E}', "");
    Expect(0, 183983, '\P{_-CJK_Ext_E}', "");
    Expect(1, 183983, '\P{^_-CJK_Ext_E}', "");
    Expect(0, 183984, '\p{_-CJK_Ext_E}', "");
    Expect(1, 183984, '\p{^_-CJK_Ext_E}', "");
    Expect(1, 183984, '\P{_-CJK_Ext_E}', "");
    Expect(0, 183984, '\P{^_-CJK_Ext_E}', "");
    Error('\p{- Is_CJK_ext_E/a/}');
    Error('\P{- Is_CJK_ext_E/a/}');
    Expect(1, 183983, '\p{iscjkexte}', "");
    Expect(0, 183983, '\p{^iscjkexte}', "");
    Expect(0, 183983, '\P{iscjkexte}', "");
    Expect(1, 183983, '\P{^iscjkexte}', "");
    Expect(0, 183984, '\p{iscjkexte}', "");
    Expect(1, 183984, '\p{^iscjkexte}', "");
    Expect(1, 183984, '\P{iscjkexte}', "");
    Expect(0, 183984, '\P{^iscjkexte}', "");
    Expect(1, 183983, '\p{  IS_cjk_EXT_e}', "");
    Expect(0, 183983, '\p{^  IS_cjk_EXT_e}', "");
    Expect(0, 183983, '\P{  IS_cjk_EXT_e}', "");
    Expect(1, 183983, '\P{^  IS_cjk_EXT_e}', "");
    Expect(0, 183984, '\p{  IS_cjk_EXT_e}', "");
    Expect(1, 183984, '\p{^  IS_cjk_EXT_e}', "");
    Expect(1, 183984, '\P{  IS_cjk_EXT_e}', "");
    Expect(0, 183984, '\P{^  IS_cjk_EXT_e}', "");
    Error('\p{/a/		in_CJK_Ext_E}');
    Error('\P{/a/		in_CJK_Ext_E}');
    Expect(1, 183983, '\p{incjkexte}', "");
    Expect(0, 183983, '\p{^incjkexte}', "");
    Expect(0, 183983, '\P{incjkexte}', "");
    Expect(1, 183983, '\P{^incjkexte}', "");
    Expect(0, 183984, '\p{incjkexte}', "");
    Expect(1, 183984, '\p{^incjkexte}', "");
    Expect(1, 183984, '\P{incjkexte}', "");
    Expect(0, 183984, '\P{^incjkexte}', "");
    Expect(1, 183983, '\p{_In_CJK_EXT_E}', "");
    Expect(0, 183983, '\p{^_In_CJK_EXT_E}', "");
    Expect(0, 183983, '\P{_In_CJK_EXT_E}', "");
    Expect(1, 183983, '\P{^_In_CJK_EXT_E}', "");
    Expect(0, 183984, '\p{_In_CJK_EXT_E}', "");
    Expect(1, 183984, '\p{^_In_CJK_EXT_E}', "");
    Expect(1, 183984, '\P{_In_CJK_EXT_E}', "");
    Expect(0, 183984, '\P{^_In_CJK_EXT_E}', "");
    Error('\p{:=cjk_UNIFIED_IDEOGRAPHS_Extension_f}');
    Error('\P{:=cjk_UNIFIED_IDEOGRAPHS_Extension_f}');
    Expect(1, 191471, '\p{cjkunifiedideographsextensionf}', "");
    Expect(0, 191471, '\p{^cjkunifiedideographsextensionf}', "");
    Expect(0, 191471, '\P{cjkunifiedideographsextensionf}', "");
    Expect(1, 191471, '\P{^cjkunifiedideographsextensionf}', "");
    Expect(0, 191472, '\p{cjkunifiedideographsextensionf}', "");
    Expect(1, 191472, '\p{^cjkunifiedideographsextensionf}', "");
    Expect(1, 191472, '\P{cjkunifiedideographsextensionf}', "");
    Expect(0, 191472, '\P{^cjkunifiedideographsextensionf}', "");
    Expect(1, 191471, '\p{-CJK_UNIFIED_Ideographs_Extension_F}', "");
    Expect(0, 191471, '\p{^-CJK_UNIFIED_Ideographs_Extension_F}', "");
    Expect(0, 191471, '\P{-CJK_UNIFIED_Ideographs_Extension_F}', "");
    Expect(1, 191471, '\P{^-CJK_UNIFIED_Ideographs_Extension_F}', "");
    Expect(0, 191472, '\p{-CJK_UNIFIED_Ideographs_Extension_F}', "");
    Expect(1, 191472, '\p{^-CJK_UNIFIED_Ideographs_Extension_F}', "");
    Expect(1, 191472, '\P{-CJK_UNIFIED_Ideographs_Extension_F}', "");
    Expect(0, 191472, '\P{^-CJK_UNIFIED_Ideographs_Extension_F}', "");
    Error('\p{:= is_CJK_UNIFIED_IDEOGRAPHS_EXTENSION_F}');
    Error('\P{:= is_CJK_UNIFIED_IDEOGRAPHS_EXTENSION_F}');
    Expect(1, 191471, '\p{iscjkunifiedideographsextensionf}', "");
    Expect(0, 191471, '\p{^iscjkunifiedideographsextensionf}', "");
    Expect(0, 191471, '\P{iscjkunifiedideographsextensionf}', "");
    Expect(1, 191471, '\P{^iscjkunifiedideographsextensionf}', "");
    Expect(0, 191472, '\p{iscjkunifiedideographsextensionf}', "");
    Expect(1, 191472, '\p{^iscjkunifiedideographsextensionf}', "");
    Expect(1, 191472, '\P{iscjkunifiedideographsextensionf}', "");
    Expect(0, 191472, '\P{^iscjkunifiedideographsextensionf}', "");
    Expect(1, 191471, '\p{-Is_CJK_Unified_Ideographs_EXTENSION_F}', "");
    Expect(0, 191471, '\p{^-Is_CJK_Unified_Ideographs_EXTENSION_F}', "");
    Expect(0, 191471, '\P{-Is_CJK_Unified_Ideographs_EXTENSION_F}', "");
    Expect(1, 191471, '\P{^-Is_CJK_Unified_Ideographs_EXTENSION_F}', "");
    Expect(0, 191472, '\p{-Is_CJK_Unified_Ideographs_EXTENSION_F}', "");
    Expect(1, 191472, '\p{^-Is_CJK_Unified_Ideographs_EXTENSION_F}', "");
    Expect(1, 191472, '\P{-Is_CJK_Unified_Ideographs_EXTENSION_F}', "");
    Expect(0, 191472, '\P{^-Is_CJK_Unified_Ideographs_EXTENSION_F}', "");
    Error('\p{/a/- in_cjk_unified_Ideographs_extension_F}');
    Error('\P{/a/- in_cjk_unified_Ideographs_extension_F}');
    Expect(1, 191471, '\p{incjkunifiedideographsextensionf}', "");
    Expect(0, 191471, '\p{^incjkunifiedideographsextensionf}', "");
    Expect(0, 191471, '\P{incjkunifiedideographsextensionf}', "");
    Expect(1, 191471, '\P{^incjkunifiedideographsextensionf}', "");
    Expect(0, 191472, '\p{incjkunifiedideographsextensionf}', "");
    Expect(1, 191472, '\p{^incjkunifiedideographsextensionf}', "");
    Expect(1, 191472, '\P{incjkunifiedideographsextensionf}', "");
    Expect(0, 191472, '\P{^incjkunifiedideographsextensionf}', "");
    Expect(1, 191471, '\p{	IN_CJK_Unified_ideographs_EXTENSION_f}', "");
    Expect(0, 191471, '\p{^	IN_CJK_Unified_ideographs_EXTENSION_f}', "");
    Expect(0, 191471, '\P{	IN_CJK_Unified_ideographs_EXTENSION_f}', "");
    Expect(1, 191471, '\P{^	IN_CJK_Unified_ideographs_EXTENSION_f}', "");
    Expect(0, 191472, '\p{	IN_CJK_Unified_ideographs_EXTENSION_f}', "");
    Expect(1, 191472, '\p{^	IN_CJK_Unified_ideographs_EXTENSION_f}', "");
    Expect(1, 191472, '\P{	IN_CJK_Unified_ideographs_EXTENSION_f}', "");
    Expect(0, 191472, '\P{^	IN_CJK_Unified_ideographs_EXTENSION_f}', "");
    Error('\p{:=- CJK_Ext_F}');
    Error('\P{:=- CJK_Ext_F}');
    Expect(1, 191471, '\p{cjkextf}', "");
    Expect(0, 191471, '\p{^cjkextf}', "");
    Expect(0, 191471, '\P{cjkextf}', "");
    Expect(1, 191471, '\P{^cjkextf}', "");
    Expect(0, 191472, '\p{cjkextf}', "");
    Expect(1, 191472, '\p{^cjkextf}', "");
    Expect(1, 191472, '\P{cjkextf}', "");
    Expect(0, 191472, '\P{^cjkextf}', "");
    Expect(1, 191471, '\p{		cjk_ext_F}', "");
    Expect(0, 191471, '\p{^		cjk_ext_F}', "");
    Expect(0, 191471, '\P{		cjk_ext_F}', "");
    Expect(1, 191471, '\P{^		cjk_ext_F}', "");
    Expect(0, 191472, '\p{		cjk_ext_F}', "");
    Expect(1, 191472, '\p{^		cjk_ext_F}', "");
    Expect(1, 191472, '\P{		cjk_ext_F}', "");
    Expect(0, 191472, '\P{^		cjk_ext_F}', "");
    Error('\p{_Is_cjk_Ext_F/a/}');
    Error('\P{_Is_cjk_Ext_F/a/}');
    Expect(1, 191471, '\p{iscjkextf}', "");
    Expect(0, 191471, '\p{^iscjkextf}', "");
    Expect(0, 191471, '\P{iscjkextf}', "");
    Expect(1, 191471, '\P{^iscjkextf}', "");
    Expect(0, 191472, '\p{iscjkextf}', "");
    Expect(1, 191472, '\p{^iscjkextf}', "");
    Expect(1, 191472, '\P{iscjkextf}', "");
    Expect(0, 191472, '\P{^iscjkextf}', "");
    Expect(1, 191471, '\p{_	Is_cjk_Ext_F}', "");
    Expect(0, 191471, '\p{^_	Is_cjk_Ext_F}', "");
    Expect(0, 191471, '\P{_	Is_cjk_Ext_F}', "");
    Expect(1, 191471, '\P{^_	Is_cjk_Ext_F}', "");
    Expect(0, 191472, '\p{_	Is_cjk_Ext_F}', "");
    Expect(1, 191472, '\p{^_	Is_cjk_Ext_F}', "");
    Expect(1, 191472, '\P{_	Is_cjk_Ext_F}', "");
    Expect(0, 191472, '\P{^_	Is_cjk_Ext_F}', "");
    Error('\p{/a/ _IN_CJK_ext_F}');
    Error('\P{/a/ _IN_CJK_ext_F}');
    Expect(1, 191471, '\p{incjkextf}', "");
    Expect(0, 191471, '\p{^incjkextf}', "");
    Expect(0, 191471, '\P{incjkextf}', "");
    Expect(1, 191471, '\P{^incjkextf}', "");
    Expect(0, 191472, '\p{incjkextf}', "");
    Expect(1, 191472, '\p{^incjkextf}', "");
    Expect(1, 191472, '\P{incjkextf}', "");
    Expect(0, 191472, '\P{^incjkextf}', "");
    Expect(1, 191471, '\p{	In_CJK_Ext_F}', "");
    Expect(0, 191471, '\p{^	In_CJK_Ext_F}', "");
    Expect(0, 191471, '\P{	In_CJK_Ext_F}', "");
    Expect(1, 191471, '\P{^	In_CJK_Ext_F}', "");
    Expect(0, 191472, '\p{	In_CJK_Ext_F}', "");
    Expect(1, 191472, '\p{^	In_CJK_Ext_F}', "");
    Expect(1, 191472, '\P{	In_CJK_Ext_F}', "");
    Expect(0, 191472, '\P{^	In_CJK_Ext_F}', "");
    Error('\p{/a/ _cjk_unified_Ideographs_extension_G}');
    Error('\P{/a/ _cjk_unified_Ideographs_extension_G}');
    Expect(1, 201551, '\p{cjkunifiedideographsextensiong}', "");
    Expect(0, 201551, '\p{^cjkunifiedideographsextensiong}', "");
    Expect(0, 201551, '\P{cjkunifiedideographsextensiong}', "");
    Expect(1, 201551, '\P{^cjkunifiedideographsextensiong}', "");
    Expect(0, 201552, '\p{cjkunifiedideographsextensiong}', "");
    Expect(1, 201552, '\p{^cjkunifiedideographsextensiong}', "");
    Expect(1, 201552, '\P{cjkunifiedideographsextensiong}', "");
    Expect(0, 201552, '\P{^cjkunifiedideographsextensiong}', "");
    Expect(1, 201551, '\p{ 	CJK_Unified_Ideographs_EXTENSION_G}', "");
    Expect(0, 201551, '\p{^ 	CJK_Unified_Ideographs_EXTENSION_G}', "");
    Expect(0, 201551, '\P{ 	CJK_Unified_Ideographs_EXTENSION_G}', "");
    Expect(1, 201551, '\P{^ 	CJK_Unified_Ideographs_EXTENSION_G}', "");
    Expect(0, 201552, '\p{ 	CJK_Unified_Ideographs_EXTENSION_G}', "");
    Expect(1, 201552, '\p{^ 	CJK_Unified_Ideographs_EXTENSION_G}', "");
    Expect(1, 201552, '\P{ 	CJK_Unified_Ideographs_EXTENSION_G}', "");
    Expect(0, 201552, '\P{^ 	CJK_Unified_Ideographs_EXTENSION_G}', "");
    Error('\p{-:=is_CJK_unified_ideographs_extension_G}');
    Error('\P{-:=is_CJK_unified_ideographs_extension_G}');
    Expect(1, 201551, '\p{iscjkunifiedideographsextensiong}', "");
    Expect(0, 201551, '\p{^iscjkunifiedideographsextensiong}', "");
    Expect(0, 201551, '\P{iscjkunifiedideographsextensiong}', "");
    Expect(1, 201551, '\P{^iscjkunifiedideographsextensiong}', "");
    Expect(0, 201552, '\p{iscjkunifiedideographsextensiong}', "");
    Expect(1, 201552, '\p{^iscjkunifiedideographsextensiong}', "");
    Expect(1, 201552, '\P{iscjkunifiedideographsextensiong}', "");
    Expect(0, 201552, '\P{^iscjkunifiedideographsextensiong}', "");
    Expect(1, 201551, '\p{_is_CJK_Unified_Ideographs_Extension_g}', "");
    Expect(0, 201551, '\p{^_is_CJK_Unified_Ideographs_Extension_g}', "");
    Expect(0, 201551, '\P{_is_CJK_Unified_Ideographs_Extension_g}', "");
    Expect(1, 201551, '\P{^_is_CJK_Unified_Ideographs_Extension_g}', "");
    Expect(0, 201552, '\p{_is_CJK_Unified_Ideographs_Extension_g}', "");
    Expect(1, 201552, '\p{^_is_CJK_Unified_Ideographs_Extension_g}', "");
    Expect(1, 201552, '\P{_is_CJK_Unified_Ideographs_Extension_g}', "");
    Expect(0, 201552, '\P{^_is_CJK_Unified_Ideographs_Extension_g}', "");
    Error('\p{-	IN_CJK_unified_Ideographs_EXTENSION_G:=}');
    Error('\P{-	IN_CJK_unified_Ideographs_EXTENSION_G:=}');
    Expect(1, 201551, '\p{incjkunifiedideographsextensiong}', "");
    Expect(0, 201551, '\p{^incjkunifiedideographsextensiong}', "");
    Expect(0, 201551, '\P{incjkunifiedideographsextensiong}', "");
    Expect(1, 201551, '\P{^incjkunifiedideographsextensiong}', "");
    Expect(0, 201552, '\p{incjkunifiedideographsextensiong}', "");
    Expect(1, 201552, '\p{^incjkunifiedideographsextensiong}', "");
    Expect(1, 201552, '\P{incjkunifiedideographsextensiong}', "");
    Expect(0, 201552, '\P{^incjkunifiedideographsextensiong}', "");
    Expect(1, 201551, '\p{	_In_CJK_Unified_Ideographs_EXTENSION_G}', "");
    Expect(0, 201551, '\p{^	_In_CJK_Unified_Ideographs_EXTENSION_G}', "");
    Expect(0, 201551, '\P{	_In_CJK_Unified_Ideographs_EXTENSION_G}', "");
    Expect(1, 201551, '\P{^	_In_CJK_Unified_Ideographs_EXTENSION_G}', "");
    Expect(0, 201552, '\p{	_In_CJK_Unified_Ideographs_EXTENSION_G}', "");
    Expect(1, 201552, '\p{^	_In_CJK_Unified_Ideographs_EXTENSION_G}', "");
    Expect(1, 201552, '\P{	_In_CJK_Unified_Ideographs_EXTENSION_G}', "");
    Expect(0, 201552, '\P{^	_In_CJK_Unified_Ideographs_EXTENSION_G}', "");
    Error('\p{	:=CJK_Ext_G}');
    Error('\P{	:=CJK_Ext_G}');
    Expect(1, 201551, '\p{cjkextg}', "");
    Expect(0, 201551, '\p{^cjkextg}', "");
    Expect(0, 201551, '\P{cjkextg}', "");
    Expect(1, 201551, '\P{^cjkextg}', "");
    Expect(0, 201552, '\p{cjkextg}', "");
    Expect(1, 201552, '\p{^cjkextg}', "");
    Expect(1, 201552, '\P{cjkextg}', "");
    Expect(0, 201552, '\P{^cjkextg}', "");
    Expect(1, 201551, '\p{	-CJK_Ext_G}', "");
    Expect(0, 201551, '\p{^	-CJK_Ext_G}', "");
    Expect(0, 201551, '\P{	-CJK_Ext_G}', "");
    Expect(1, 201551, '\P{^	-CJK_Ext_G}', "");
    Expect(0, 201552, '\p{	-CJK_Ext_G}', "");
    Expect(1, 201552, '\p{^	-CJK_Ext_G}', "");
    Expect(1, 201552, '\P{	-CJK_Ext_G}', "");
    Expect(0, 201552, '\P{^	-CJK_Ext_G}', "");
    Error('\p{:=	Is_CJK_Ext_G}');
    Error('\P{:=	Is_CJK_Ext_G}');
    Expect(1, 201551, '\p{iscjkextg}', "");
    Expect(0, 201551, '\p{^iscjkextg}', "");
    Expect(0, 201551, '\P{iscjkextg}', "");
    Expect(1, 201551, '\P{^iscjkextg}', "");
    Expect(0, 201552, '\p{iscjkextg}', "");
    Expect(1, 201552, '\p{^iscjkextg}', "");
    Expect(1, 201552, '\P{iscjkextg}', "");
    Expect(0, 201552, '\P{^iscjkextg}', "");
    Expect(1, 201551, '\p{-_IS_CJK_ext_G}', "");
    Expect(0, 201551, '\p{^-_IS_CJK_ext_G}', "");
    Expect(0, 201551, '\P{-_IS_CJK_ext_G}', "");
    Expect(1, 201551, '\P{^-_IS_CJK_ext_G}', "");
    Expect(0, 201552, '\p{-_IS_CJK_ext_G}', "");
    Expect(1, 201552, '\p{^-_IS_CJK_ext_G}', "");
    Expect(1, 201552, '\P{-_IS_CJK_ext_G}', "");
    Expect(0, 201552, '\P{^-_IS_CJK_ext_G}', "");
    Error('\p{	:=In_CJK_Ext_g}');
    Error('\P{	:=In_CJK_Ext_g}');
    Expect(1, 201551, '\p{incjkextg}', "");
    Expect(0, 201551, '\p{^incjkextg}', "");
    Expect(0, 201551, '\P{incjkextg}', "");
    Expect(1, 201551, '\P{^incjkextg}', "");
    Expect(0, 201552, '\p{incjkextg}', "");
    Expect(1, 201552, '\p{^incjkextg}', "");
    Expect(1, 201552, '\P{incjkextg}', "");
    Expect(0, 201552, '\P{^incjkextg}', "");
    Expect(1, 201551, '\p{	IN_CJK_ext_G}', "");
    Expect(0, 201551, '\p{^	IN_CJK_ext_G}', "");
    Expect(0, 201551, '\P{	IN_CJK_ext_G}', "");
    Expect(1, 201551, '\P{^	IN_CJK_ext_G}', "");
    Expect(0, 201552, '\p{	IN_CJK_ext_G}', "");
    Expect(1, 201552, '\p{^	IN_CJK_ext_G}', "");
    Expect(1, 201552, '\P{	IN_CJK_ext_G}', "");
    Expect(0, 201552, '\P{^	IN_CJK_ext_G}', "");
    Error('\p{ /a/Close_PUNCTUATION}');
    Error('\P{ /a/Close_PUNCTUATION}');
    Expect(1, 65379, '\p{closepunctuation}', "");
    Expect(0, 65379, '\p{^closepunctuation}', "");
    Expect(0, 65379, '\P{closepunctuation}', "");
    Expect(1, 65379, '\P{^closepunctuation}', "");
    Expect(0, 65380, '\p{closepunctuation}', "");
    Expect(1, 65380, '\p{^closepunctuation}', "");
    Expect(1, 65380, '\P{closepunctuation}', "");
    Expect(0, 65380, '\P{^closepunctuation}', "");
    Expect(1, 65379, '\p{-_close_punctuation}', "");
    Expect(0, 65379, '\p{^-_close_punctuation}', "");
    Expect(0, 65379, '\P{-_close_punctuation}', "");
    Expect(1, 65379, '\P{^-_close_punctuation}', "");
    Expect(0, 65380, '\p{-_close_punctuation}', "");
    Expect(1, 65380, '\p{^-_close_punctuation}', "");
    Expect(1, 65380, '\P{-_close_punctuation}', "");
    Expect(0, 65380, '\P{^-_close_punctuation}', "");
    Error('\p{:=_-Is_close_punctuation}');
    Error('\P{:=_-Is_close_punctuation}');
    Expect(1, 65379, '\p{isclosepunctuation}', "");
    Expect(0, 65379, '\p{^isclosepunctuation}', "");
    Expect(0, 65379, '\P{isclosepunctuation}', "");
    Expect(1, 65379, '\P{^isclosepunctuation}', "");
    Expect(0, 65380, '\p{isclosepunctuation}', "");
    Expect(1, 65380, '\p{^isclosepunctuation}', "");
    Expect(1, 65380, '\P{isclosepunctuation}', "");
    Expect(0, 65380, '\P{^isclosepunctuation}', "");
    Expect(1, 65379, '\p{_Is_close_PUNCTUATION}', "");
    Expect(0, 65379, '\p{^_Is_close_PUNCTUATION}', "");
    Expect(0, 65379, '\P{_Is_close_PUNCTUATION}', "");
    Expect(1, 65379, '\P{^_Is_close_PUNCTUATION}', "");
    Expect(0, 65380, '\p{_Is_close_PUNCTUATION}', "");
    Expect(1, 65380, '\p{^_Is_close_PUNCTUATION}', "");
    Expect(1, 65380, '\P{_Is_close_PUNCTUATION}', "");
    Expect(0, 65380, '\P{^_Is_close_PUNCTUATION}', "");
    Error('\p{/a/	Pe}');
    Error('\P{/a/	Pe}');
    Expect(1, 65379, '\p{pe}', "");
    Expect(0, 65379, '\p{^pe}', "");
    Expect(0, 65379, '\P{pe}', "");
    Expect(1, 65379, '\P{^pe}', "");
    Expect(0, 65380, '\p{pe}', "");
    Expect(1, 65380, '\p{^pe}', "");
    Expect(1, 65380, '\P{pe}', "");
    Expect(0, 65380, '\P{^pe}', "");
    Expect(1, 65379, '\p{_PE}', "");
    Expect(0, 65379, '\p{^_PE}', "");
    Expect(0, 65379, '\P{_PE}', "");
    Expect(1, 65379, '\P{^_PE}', "");
    Expect(0, 65380, '\p{_PE}', "");
    Expect(1, 65380, '\p{^_PE}', "");
    Expect(1, 65380, '\P{_PE}', "");
    Expect(0, 65380, '\P{^_PE}', "");
    Error('\p{_	Is_Pe:=}');
    Error('\P{_	Is_Pe:=}');
    Expect(1, 65379, '\p{ispe}', "");
    Expect(0, 65379, '\p{^ispe}', "");
    Expect(0, 65379, '\P{ispe}', "");
    Expect(1, 65379, '\P{^ispe}', "");
    Expect(0, 65380, '\p{ispe}', "");
    Expect(1, 65380, '\p{^ispe}', "");
    Expect(1, 65380, '\P{ispe}', "");
    Expect(0, 65380, '\P{^ispe}', "");
    Expect(1, 65379, '\p{_is_pe}', "");
    Expect(0, 65379, '\p{^_is_pe}', "");
    Expect(0, 65379, '\P{_is_pe}', "");
    Expect(1, 65379, '\P{^_is_pe}', "");
    Expect(0, 65380, '\p{_is_pe}', "");
    Expect(1, 65380, '\p{^_is_pe}', "");
    Expect(1, 65380, '\P{_is_pe}', "");
    Expect(0, 65380, '\P{^_is_pe}', "");
    Error('\p{_/a/xposixcntrl}');
    Error('\P{_/a/xposixcntrl}');
    Expect(1, 159, '\p{xposixcntrl}', "");
    Expect(0, 159, '\p{^xposixcntrl}', "");
    Expect(0, 159, '\P{xposixcntrl}', "");
    Expect(1, 159, '\P{^xposixcntrl}', "");
    Expect(0, 160, '\p{xposixcntrl}', "");
    Expect(1, 160, '\p{^xposixcntrl}', "");
    Expect(1, 160, '\P{xposixcntrl}', "");
    Expect(0, 160, '\P{^xposixcntrl}', "");
    Error('\p{/a/	-CNTRL}');
    Error('\P{/a/	-CNTRL}');
    Expect(1, 159, '\p{cntrl}', "");
    Expect(0, 159, '\p{^cntrl}', "");
    Expect(0, 159, '\P{cntrl}', "");
    Expect(1, 159, '\P{^cntrl}', "");
    Expect(0, 160, '\p{cntrl}', "");
    Expect(1, 160, '\p{^cntrl}', "");
    Expect(1, 160, '\P{cntrl}', "");
    Expect(0, 160, '\P{^cntrl}', "");
    Expect(1, 159, '\p{-	Cntrl}', "");
    Expect(0, 159, '\p{^-	Cntrl}', "");
    Expect(0, 159, '\P{-	Cntrl}', "");
    Expect(1, 159, '\P{^-	Cntrl}', "");
    Expect(0, 160, '\p{-	Cntrl}', "");
    Expect(1, 160, '\p{^-	Cntrl}', "");
    Expect(1, 160, '\P{-	Cntrl}', "");
    Expect(0, 160, '\P{^-	Cntrl}', "");
    Error('\p{:=	IS_XPosixCntrl}');
    Error('\P{:=	IS_XPosixCntrl}');
    Expect(1, 159, '\p{isxposixcntrl}', "");
    Expect(0, 159, '\p{^isxposixcntrl}', "");
    Expect(0, 159, '\P{isxposixcntrl}', "");
    Expect(1, 159, '\P{^isxposixcntrl}', "");
    Expect(0, 160, '\p{isxposixcntrl}', "");
    Expect(1, 160, '\p{^isxposixcntrl}', "");
    Expect(1, 160, '\P{isxposixcntrl}', "");
    Expect(0, 160, '\P{^isxposixcntrl}', "");
    Expect(1, 159, '\p{--Is_XPosixCntrl}', "");
    Expect(0, 159, '\p{^--Is_XPosixCntrl}', "");
    Expect(0, 159, '\P{--Is_XPosixCntrl}', "");
    Expect(1, 159, '\P{^--Is_XPosixCntrl}', "");
    Expect(0, 160, '\p{--Is_XPosixCntrl}', "");
    Expect(1, 160, '\p{^--Is_XPosixCntrl}', "");
    Expect(1, 160, '\P{--Is_XPosixCntrl}', "");
    Expect(0, 160, '\P{^--Is_XPosixCntrl}', "");
    Error('\p{ 	Is_Cntrl:=}');
    Error('\P{ 	Is_Cntrl:=}');
    Expect(1, 159, '\p{iscntrl}', "");
    Expect(0, 159, '\p{^iscntrl}', "");
    Expect(0, 159, '\P{iscntrl}', "");
    Expect(1, 159, '\P{^iscntrl}', "");
    Expect(0, 160, '\p{iscntrl}', "");
    Expect(1, 160, '\p{^iscntrl}', "");
    Expect(1, 160, '\P{iscntrl}', "");
    Expect(0, 160, '\P{^iscntrl}', "");
    Expect(1, 159, '\p{_	IS_cntrl}', "");
    Expect(0, 159, '\p{^_	IS_cntrl}', "");
    Expect(0, 159, '\P{_	IS_cntrl}', "");
    Expect(1, 159, '\P{^_	IS_cntrl}', "");
    Expect(0, 160, '\p{_	IS_cntrl}', "");
    Expect(1, 160, '\p{^_	IS_cntrl}', "");
    Expect(1, 160, '\P{_	IS_cntrl}', "");
    Expect(0, 160, '\P{^_	IS_cntrl}', "");
    Error('\p{:=_	Control}');
    Error('\P{:=_	Control}');
    Expect(1, 159, '\p{control}', "");
    Expect(0, 159, '\p{^control}', "");
    Expect(0, 159, '\P{control}', "");
    Expect(1, 159, '\P{^control}', "");
    Expect(0, 160, '\p{control}', "");
    Expect(1, 160, '\p{^control}', "");
    Expect(1, 160, '\P{control}', "");
    Expect(0, 160, '\P{^control}', "");
    Expect(1, 159, '\p{Control}', "");
    Expect(0, 159, '\p{^Control}', "");
    Expect(0, 159, '\P{Control}', "");
    Expect(1, 159, '\P{^Control}', "");
    Expect(0, 160, '\p{Control}', "");
    Expect(1, 160, '\p{^Control}', "");
    Expect(1, 160, '\P{Control}', "");
    Expect(0, 160, '\P{^Control}', "");
    Error('\p{/a/--is_Control}');
    Error('\P{/a/--is_Control}');
    Expect(1, 159, '\p{iscontrol}', "");
    Expect(0, 159, '\p{^iscontrol}', "");
    Expect(0, 159, '\P{iscontrol}', "");
    Expect(1, 159, '\P{^iscontrol}', "");
    Expect(0, 160, '\p{iscontrol}', "");
    Expect(1, 160, '\p{^iscontrol}', "");
    Expect(1, 160, '\P{iscontrol}', "");
    Expect(0, 160, '\P{^iscontrol}', "");
    Expect(1, 159, '\p{	 IS_Control}', "");
    Expect(0, 159, '\p{^	 IS_Control}', "");
    Expect(0, 159, '\P{	 IS_Control}', "");
    Expect(1, 159, '\P{^	 IS_Control}', "");
    Expect(0, 160, '\p{	 IS_Control}', "");
    Expect(1, 160, '\p{^	 IS_Control}', "");
    Expect(1, 160, '\P{	 IS_Control}', "");
    Expect(0, 160, '\P{^	 IS_Control}', "");
    Error('\p{ /a/Cc}');
    Error('\P{ /a/Cc}');
    Expect(1, 159, '\p{cc}', "");
    Expect(0, 159, '\p{^cc}', "");
    Expect(0, 159, '\P{cc}', "");
    Expect(1, 159, '\P{^cc}', "");
    Expect(0, 160, '\p{cc}', "");
    Expect(1, 160, '\p{^cc}', "");
    Expect(1, 160, '\P{cc}', "");
    Expect(0, 160, '\P{^cc}', "");
    Expect(1, 159, '\p{	 Cc}', "");
    Expect(0, 159, '\p{^	 Cc}', "");
    Expect(0, 159, '\P{	 Cc}', "");
    Expect(1, 159, '\P{^	 Cc}', "");
    Expect(0, 160, '\p{	 Cc}', "");
    Expect(1, 160, '\p{^	 Cc}', "");
    Expect(1, 160, '\P{	 Cc}', "");
    Expect(0, 160, '\P{^	 Cc}', "");
    Error('\p{:=	IS_CC}');
    Error('\P{:=	IS_CC}');
    Expect(1, 159, '\p{iscc}', "");
    Expect(0, 159, '\p{^iscc}', "");
    Expect(0, 159, '\P{iscc}', "");
    Expect(1, 159, '\P{^iscc}', "");
    Expect(0, 160, '\p{iscc}', "");
    Expect(1, 160, '\p{^iscc}', "");
    Expect(1, 160, '\P{iscc}', "");
    Expect(0, 160, '\P{^iscc}', "");
    Expect(1, 159, '\p{__IS_Cc}', "");
    Expect(0, 159, '\p{^__IS_Cc}', "");
    Expect(0, 159, '\P{__IS_Cc}', "");
    Expect(1, 159, '\P{^__IS_Cc}', "");
    Expect(0, 160, '\p{__IS_Cc}', "");
    Expect(1, 160, '\p{^__IS_Cc}', "");
    Expect(1, 160, '\P{__IS_Cc}', "");
    Expect(0, 160, '\P{^__IS_Cc}', "");
    Error('\p{:=Combining_diacritical_Marks}');
    Error('\P{:=Combining_diacritical_Marks}');
    Expect(1, 879, '\p{combiningdiacriticalmarks}', "");
    Expect(0, 879, '\p{^combiningdiacriticalmarks}', "");
    Expect(0, 879, '\P{combiningdiacriticalmarks}', "");
    Expect(1, 879, '\P{^combiningdiacriticalmarks}', "");
    Expect(0, 880, '\p{combiningdiacriticalmarks}', "");
    Expect(1, 880, '\p{^combiningdiacriticalmarks}', "");
    Expect(1, 880, '\P{combiningdiacriticalmarks}', "");
    Expect(0, 880, '\P{^combiningdiacriticalmarks}', "");
    Expect(1, 879, '\p{_	Combining_DIACRITICAL_Marks}', "");
    Expect(0, 879, '\p{^_	Combining_DIACRITICAL_Marks}', "");
    Expect(0, 879, '\P{_	Combining_DIACRITICAL_Marks}', "");
    Expect(1, 879, '\P{^_	Combining_DIACRITICAL_Marks}', "");
    Expect(0, 880, '\p{_	Combining_DIACRITICAL_Marks}', "");
    Expect(1, 880, '\p{^_	Combining_DIACRITICAL_Marks}', "");
    Expect(1, 880, '\P{_	Combining_DIACRITICAL_Marks}', "");
    Expect(0, 880, '\P{^_	Combining_DIACRITICAL_Marks}', "");
    Error('\p{	/a/IS_COMBINING_Diacritical_Marks}');
    Error('\P{	/a/IS_COMBINING_Diacritical_Marks}');
    Expect(1, 879, '\p{iscombiningdiacriticalmarks}', "");
    Expect(0, 879, '\p{^iscombiningdiacriticalmarks}', "");
    Expect(0, 879, '\P{iscombiningdiacriticalmarks}', "");
    Expect(1, 879, '\P{^iscombiningdiacriticalmarks}', "");
    Expect(0, 880, '\p{iscombiningdiacriticalmarks}', "");
    Expect(1, 880, '\p{^iscombiningdiacriticalmarks}', "");
    Expect(1, 880, '\P{iscombiningdiacriticalmarks}', "");
    Expect(0, 880, '\P{^iscombiningdiacriticalmarks}', "");
    Expect(1, 879, '\p{_Is_combining_diacritical_Marks}', "");
    Expect(0, 879, '\p{^_Is_combining_diacritical_Marks}', "");
    Expect(0, 879, '\P{_Is_combining_diacritical_Marks}', "");
    Expect(1, 879, '\P{^_Is_combining_diacritical_Marks}', "");
    Expect(0, 880, '\p{_Is_combining_diacritical_Marks}', "");
    Expect(1, 880, '\p{^_Is_combining_diacritical_Marks}', "");
    Expect(1, 880, '\P{_Is_combining_diacritical_Marks}', "");
    Expect(0, 880, '\P{^_Is_combining_diacritical_Marks}', "");
    Error('\p{ :=IN_COMBINING_Diacritical_Marks}');
    Error('\P{ :=IN_COMBINING_Diacritical_Marks}');
    Expect(1, 879, '\p{incombiningdiacriticalmarks}', "");
    Expect(0, 879, '\p{^incombiningdiacriticalmarks}', "");
    Expect(0, 879, '\P{incombiningdiacriticalmarks}', "");
    Expect(1, 879, '\P{^incombiningdiacriticalmarks}', "");
    Expect(0, 880, '\p{incombiningdiacriticalmarks}', "");
    Expect(1, 880, '\p{^incombiningdiacriticalmarks}', "");
    Expect(1, 880, '\P{incombiningdiacriticalmarks}', "");
    Expect(0, 880, '\P{^incombiningdiacriticalmarks}', "");
    Expect(1, 879, '\p{-IN_combining_DIACRITICAL_Marks}', "");
    Expect(0, 879, '\p{^-IN_combining_DIACRITICAL_Marks}', "");
    Expect(0, 879, '\P{-IN_combining_DIACRITICAL_Marks}', "");
    Expect(1, 879, '\P{^-IN_combining_DIACRITICAL_Marks}', "");
    Expect(0, 880, '\p{-IN_combining_DIACRITICAL_Marks}', "");
    Expect(1, 880, '\p{^-IN_combining_DIACRITICAL_Marks}', "");
    Expect(1, 880, '\P{-IN_combining_DIACRITICAL_Marks}', "");
    Expect(0, 880, '\P{^-IN_combining_DIACRITICAL_Marks}', "");
    Error('\p{_diacriticals:=}');
    Error('\P{_diacriticals:=}');
    Expect(1, 879, '\p{diacriticals}', "");
    Expect(0, 879, '\p{^diacriticals}', "");
    Expect(0, 879, '\P{diacriticals}', "");
    Expect(1, 879, '\P{^diacriticals}', "");
    Expect(0, 880, '\p{diacriticals}', "");
    Expect(1, 880, '\p{^diacriticals}', "");
    Expect(1, 880, '\P{diacriticals}', "");
    Expect(0, 880, '\P{^diacriticals}', "");
    Expect(1, 879, '\p{ -Diacriticals}', "");
    Expect(0, 879, '\p{^ -Diacriticals}', "");
    Expect(0, 879, '\P{ -Diacriticals}', "");
    Expect(1, 879, '\P{^ -Diacriticals}', "");
    Expect(0, 880, '\p{ -Diacriticals}', "");
    Expect(1, 880, '\p{^ -Diacriticals}', "");
    Expect(1, 880, '\P{ -Diacriticals}', "");
    Expect(0, 880, '\P{^ -Diacriticals}', "");
    Error('\p{_-Is_diacriticals:=}');
    Error('\P{_-Is_diacriticals:=}');
    Expect(1, 879, '\p{isdiacriticals}', "");
    Expect(0, 879, '\p{^isdiacriticals}', "");
    Expect(0, 879, '\P{isdiacriticals}', "");
    Expect(1, 879, '\P{^isdiacriticals}', "");
    Expect(0, 880, '\p{isdiacriticals}', "");
    Expect(1, 880, '\p{^isdiacriticals}', "");
    Expect(1, 880, '\P{isdiacriticals}', "");
    Expect(0, 880, '\P{^isdiacriticals}', "");
    Expect(1, 879, '\p{-	Is_diacriticals}', "");
    Expect(0, 879, '\p{^-	Is_diacriticals}', "");
    Expect(0, 879, '\P{-	Is_diacriticals}', "");
    Expect(1, 879, '\P{^-	Is_diacriticals}', "");
    Expect(0, 880, '\p{-	Is_diacriticals}', "");
    Expect(1, 880, '\p{^-	Is_diacriticals}', "");
    Expect(1, 880, '\P{-	Is_diacriticals}', "");
    Expect(0, 880, '\P{^-	Is_diacriticals}', "");
    Error('\p{:=_ IN_DIACRITICALS}');
    Error('\P{:=_ IN_DIACRITICALS}');
    Expect(1, 879, '\p{indiacriticals}', "");
    Expect(0, 879, '\p{^indiacriticals}', "");
    Expect(0, 879, '\P{indiacriticals}', "");
    Expect(1, 879, '\P{^indiacriticals}', "");
    Expect(0, 880, '\p{indiacriticals}', "");
    Expect(1, 880, '\p{^indiacriticals}', "");
    Expect(1, 880, '\P{indiacriticals}', "");
    Expect(0, 880, '\P{^indiacriticals}', "");
    Expect(1, 879, '\p{  in_Diacriticals}', "");
    Expect(0, 879, '\p{^  in_Diacriticals}', "");
    Expect(0, 879, '\P{  in_Diacriticals}', "");
    Expect(1, 879, '\P{^  in_Diacriticals}', "");
    Expect(0, 880, '\p{  in_Diacriticals}', "");
    Expect(1, 880, '\p{^  in_Diacriticals}', "");
    Expect(1, 880, '\P{  in_Diacriticals}', "");
    Expect(0, 880, '\P{^  in_Diacriticals}', "");
    Error('\p{ /a/COMBINING_Diacritical_marks_EXTENDED}');
    Error('\P{ /a/COMBINING_Diacritical_marks_EXTENDED}');
    Expect(1, 6911, '\p{combiningdiacriticalmarksextended}', "");
    Expect(0, 6911, '\p{^combiningdiacriticalmarksextended}', "");
    Expect(0, 6911, '\P{combiningdiacriticalmarksextended}', "");
    Expect(1, 6911, '\P{^combiningdiacriticalmarksextended}', "");
    Expect(0, 6912, '\p{combiningdiacriticalmarksextended}', "");
    Expect(1, 6912, '\p{^combiningdiacriticalmarksextended}', "");
    Expect(1, 6912, '\P{combiningdiacriticalmarksextended}', "");
    Expect(0, 6912, '\P{^combiningdiacriticalmarksextended}', "");
    Expect(1, 6911, '\p{	Combining_DIACRITICAL_Marks_EXTENDED}', "");
    Expect(0, 6911, '\p{^	Combining_DIACRITICAL_Marks_EXTENDED}', "");
    Expect(0, 6911, '\P{	Combining_DIACRITICAL_Marks_EXTENDED}', "");
    Expect(1, 6911, '\P{^	Combining_DIACRITICAL_Marks_EXTENDED}', "");
    Expect(0, 6912, '\p{	Combining_DIACRITICAL_Marks_EXTENDED}', "");
    Expect(1, 6912, '\p{^	Combining_DIACRITICAL_Marks_EXTENDED}', "");
    Expect(1, 6912, '\P{	Combining_DIACRITICAL_Marks_EXTENDED}', "");
    Expect(0, 6912, '\P{^	Combining_DIACRITICAL_Marks_EXTENDED}', "");
    Error('\p{	-Is_COMBINING_DIACRITICAL_MARKS_Extended:=}');
    Error('\P{	-Is_COMBINING_DIACRITICAL_MARKS_Extended:=}');
    Expect(1, 6911, '\p{iscombiningdiacriticalmarksextended}', "");
    Expect(0, 6911, '\p{^iscombiningdiacriticalmarksextended}', "");
    Expect(0, 6911, '\P{iscombiningdiacriticalmarksextended}', "");
    Expect(1, 6911, '\P{^iscombiningdiacriticalmarksextended}', "");
    Expect(0, 6912, '\p{iscombiningdiacriticalmarksextended}', "");
    Expect(1, 6912, '\p{^iscombiningdiacriticalmarksextended}', "");
    Expect(1, 6912, '\P{iscombiningdiacriticalmarksextended}', "");
    Expect(0, 6912, '\P{^iscombiningdiacriticalmarksextended}', "");
    Expect(1, 6911, '\p{	is_Combining_DIACRITICAL_MARKS_Extended}', "");
    Expect(0, 6911, '\p{^	is_Combining_DIACRITICAL_MARKS_Extended}', "");
    Expect(0, 6911, '\P{	is_Combining_DIACRITICAL_MARKS_Extended}', "");
    Expect(1, 6911, '\P{^	is_Combining_DIACRITICAL_MARKS_Extended}', "");
    Expect(0, 6912, '\p{	is_Combining_DIACRITICAL_MARKS_Extended}', "");
    Expect(1, 6912, '\p{^	is_Combining_DIACRITICAL_MARKS_Extended}', "");
    Expect(1, 6912, '\P{	is_Combining_DIACRITICAL_MARKS_Extended}', "");
    Expect(0, 6912, '\P{^	is_Combining_DIACRITICAL_MARKS_Extended}', "");
    Error('\p{	In_combining_DIACRITICAL_MARKS_extended:=}');
    Error('\P{	In_combining_DIACRITICAL_MARKS_extended:=}');
    Expect(1, 6911, '\p{incombiningdiacriticalmarksextended}', "");
    Expect(0, 6911, '\p{^incombiningdiacriticalmarksextended}', "");
    Expect(0, 6911, '\P{incombiningdiacriticalmarksextended}', "");
    Expect(1, 6911, '\P{^incombiningdiacriticalmarksextended}', "");
    Expect(0, 6912, '\p{incombiningdiacriticalmarksextended}', "");
    Expect(1, 6912, '\p{^incombiningdiacriticalmarksextended}', "");
    Expect(1, 6912, '\P{incombiningdiacriticalmarksextended}', "");
    Expect(0, 6912, '\P{^incombiningdiacriticalmarksextended}', "");
    Expect(1, 6911, '\p{- in_combining_diacritical_Marks_Extended}', "");
    Expect(0, 6911, '\p{^- in_combining_diacritical_Marks_Extended}', "");
    Expect(0, 6911, '\P{- in_combining_diacritical_Marks_Extended}', "");
    Expect(1, 6911, '\P{^- in_combining_diacritical_Marks_Extended}', "");
    Expect(0, 6912, '\p{- in_combining_diacritical_Marks_Extended}', "");
    Expect(1, 6912, '\p{^- in_combining_diacritical_Marks_Extended}', "");
    Expect(1, 6912, '\P{- in_combining_diacritical_Marks_Extended}', "");
    Expect(0, 6912, '\P{^- in_combining_diacritical_Marks_Extended}', "");
    Error('\p{ /a/Diacriticals_Ext}');
    Error('\P{ /a/Diacriticals_Ext}');
    Expect(1, 6911, '\p{diacriticalsext}', "");
    Expect(0, 6911, '\p{^diacriticalsext}', "");
    Expect(0, 6911, '\P{diacriticalsext}', "");
    Expect(1, 6911, '\P{^diacriticalsext}', "");
    Expect(0, 6912, '\p{diacriticalsext}', "");
    Expect(1, 6912, '\p{^diacriticalsext}', "");
    Expect(1, 6912, '\P{diacriticalsext}', "");
    Expect(0, 6912, '\P{^diacriticalsext}', "");
    Expect(1, 6911, '\p{ 	diacriticals_Ext}', "");
    Expect(0, 6911, '\p{^ 	diacriticals_Ext}', "");
    Expect(0, 6911, '\P{ 	diacriticals_Ext}', "");
    Expect(1, 6911, '\P{^ 	diacriticals_Ext}', "");
    Expect(0, 6912, '\p{ 	diacriticals_Ext}', "");
    Expect(1, 6912, '\p{^ 	diacriticals_Ext}', "");
    Expect(1, 6912, '\P{ 	diacriticals_Ext}', "");
    Expect(0, 6912, '\P{^ 	diacriticals_Ext}', "");
    Error('\p{_/a/is_DIACRITICALS_ext}');
    Error('\P{_/a/is_DIACRITICALS_ext}');
    Expect(1, 6911, '\p{isdiacriticalsext}', "");
    Expect(0, 6911, '\p{^isdiacriticalsext}', "");
    Expect(0, 6911, '\P{isdiacriticalsext}', "");
    Expect(1, 6911, '\P{^isdiacriticalsext}', "");
    Expect(0, 6912, '\p{isdiacriticalsext}', "");
    Expect(1, 6912, '\p{^isdiacriticalsext}', "");
    Expect(1, 6912, '\P{isdiacriticalsext}', "");
    Expect(0, 6912, '\P{^isdiacriticalsext}', "");
    Expect(1, 6911, '\p{- is_Diacriticals_Ext}', "");
    Expect(0, 6911, '\p{^- is_Diacriticals_Ext}', "");
    Expect(0, 6911, '\P{- is_Diacriticals_Ext}', "");
    Expect(1, 6911, '\P{^- is_Diacriticals_Ext}', "");
    Expect(0, 6912, '\p{- is_Diacriticals_Ext}', "");
    Expect(1, 6912, '\p{^- is_Diacriticals_Ext}', "");
    Expect(1, 6912, '\P{- is_Diacriticals_Ext}', "");
    Expect(0, 6912, '\P{^- is_Diacriticals_Ext}', "");
    Error('\p{:=_	in_Diacriticals_EXT}');
    Error('\P{:=_	in_Diacriticals_EXT}');
    Expect(1, 6911, '\p{indiacriticalsext}', "");
    Expect(0, 6911, '\p{^indiacriticalsext}', "");
    Expect(0, 6911, '\P{indiacriticalsext}', "");
    Expect(1, 6911, '\P{^indiacriticalsext}', "");
    Expect(0, 6912, '\p{indiacriticalsext}', "");
    Expect(1, 6912, '\p{^indiacriticalsext}', "");
    Expect(1, 6912, '\P{indiacriticalsext}', "");
    Expect(0, 6912, '\P{^indiacriticalsext}', "");
    Expect(1, 6911, '\p{	 In_DIACRITICALS_Ext}', "");
    Expect(0, 6911, '\p{^	 In_DIACRITICALS_Ext}', "");
    Expect(0, 6911, '\P{	 In_DIACRITICALS_Ext}', "");
    Expect(1, 6911, '\P{^	 In_DIACRITICALS_Ext}', "");
    Expect(0, 6912, '\p{	 In_DIACRITICALS_Ext}', "");
    Expect(1, 6912, '\p{^	 In_DIACRITICALS_Ext}', "");
    Expect(1, 6912, '\P{	 In_DIACRITICALS_Ext}', "");
    Expect(0, 6912, '\P{^	 In_DIACRITICALS_Ext}', "");
    Error('\p{-Combining_DIACRITICAL_Marks_For_SYMBOLS/a/}');
    Error('\P{-Combining_DIACRITICAL_Marks_For_SYMBOLS/a/}');
    Expect(1, 8447, '\p{combiningdiacriticalmarksforsymbols}', "");
    Expect(0, 8447, '\p{^combiningdiacriticalmarksforsymbols}', "");
    Expect(0, 8447, '\P{combiningdiacriticalmarksforsymbols}', "");
    Expect(1, 8447, '\P{^combiningdiacriticalmarksforsymbols}', "");
    Expect(0, 8448, '\p{combiningdiacriticalmarksforsymbols}', "");
    Expect(1, 8448, '\p{^combiningdiacriticalmarksforsymbols}', "");
    Expect(1, 8448, '\P{combiningdiacriticalmarksforsymbols}', "");
    Expect(0, 8448, '\P{^combiningdiacriticalmarksforsymbols}', "");
    Expect(1, 8447, '\p{- combining_Diacritical_Marks_For_SYMBOLS}', "");
    Expect(0, 8447, '\p{^- combining_Diacritical_Marks_For_SYMBOLS}', "");
    Expect(0, 8447, '\P{- combining_Diacritical_Marks_For_SYMBOLS}', "");
    Expect(1, 8447, '\P{^- combining_Diacritical_Marks_For_SYMBOLS}', "");
    Expect(0, 8448, '\p{- combining_Diacritical_Marks_For_SYMBOLS}', "");
    Expect(1, 8448, '\p{^- combining_Diacritical_Marks_For_SYMBOLS}', "");
    Expect(1, 8448, '\P{- combining_Diacritical_Marks_For_SYMBOLS}', "");
    Expect(0, 8448, '\P{^- combining_Diacritical_Marks_For_SYMBOLS}', "");
    Error('\p{:= is_Combining_diacritical_MARKS_for_SYMBOLS}');
    Error('\P{:= is_Combining_diacritical_MARKS_for_SYMBOLS}');
    Expect(1, 8447, '\p{iscombiningdiacriticalmarksforsymbols}', "");
    Expect(0, 8447, '\p{^iscombiningdiacriticalmarksforsymbols}', "");
    Expect(0, 8447, '\P{iscombiningdiacriticalmarksforsymbols}', "");
    Expect(1, 8447, '\P{^iscombiningdiacriticalmarksforsymbols}', "");
    Expect(0, 8448, '\p{iscombiningdiacriticalmarksforsymbols}', "");
    Expect(1, 8448, '\p{^iscombiningdiacriticalmarksforsymbols}', "");
    Expect(1, 8448, '\P{iscombiningdiacriticalmarksforsymbols}', "");
    Expect(0, 8448, '\P{^iscombiningdiacriticalmarksforsymbols}', "");
    Expect(1, 8447, '\p{-_Is_Combining_Diacritical_marks_FOR_SYMBOLS}', "");
    Expect(0, 8447, '\p{^-_Is_Combining_Diacritical_marks_FOR_SYMBOLS}', "");
    Expect(0, 8447, '\P{-_Is_Combining_Diacritical_marks_FOR_SYMBOLS}', "");
    Expect(1, 8447, '\P{^-_Is_Combining_Diacritical_marks_FOR_SYMBOLS}', "");
    Expect(0, 8448, '\p{-_Is_Combining_Diacritical_marks_FOR_SYMBOLS}', "");
    Expect(1, 8448, '\p{^-_Is_Combining_Diacritical_marks_FOR_SYMBOLS}', "");
    Expect(1, 8448, '\P{-_Is_Combining_Diacritical_marks_FOR_SYMBOLS}', "");
    Expect(0, 8448, '\P{^-_Is_Combining_Diacritical_marks_FOR_SYMBOLS}', "");
    Error('\p{_:=in_combining_diacritical_Marks_for_symbols}');
    Error('\P{_:=in_combining_diacritical_Marks_for_symbols}');
    Expect(1, 8447, '\p{incombiningdiacriticalmarksforsymbols}', "");
    Expect(0, 8447, '\p{^incombiningdiacriticalmarksforsymbols}', "");
    Expect(0, 8447, '\P{incombiningdiacriticalmarksforsymbols}', "");
    Expect(1, 8447, '\P{^incombiningdiacriticalmarksforsymbols}', "");
    Expect(0, 8448, '\p{incombiningdiacriticalmarksforsymbols}', "");
    Expect(1, 8448, '\p{^incombiningdiacriticalmarksforsymbols}', "");
    Expect(1, 8448, '\P{incombiningdiacriticalmarksforsymbols}', "");
    Expect(0, 8448, '\P{^incombiningdiacriticalmarksforsymbols}', "");
    Expect(1, 8447, '\p{_ In_combining_Diacritical_MARKS_FOR_symbols}', "");
    Expect(0, 8447, '\p{^_ In_combining_Diacritical_MARKS_FOR_symbols}', "");
    Expect(0, 8447, '\P{_ In_combining_Diacritical_MARKS_FOR_symbols}', "");
    Expect(1, 8447, '\P{^_ In_combining_Diacritical_MARKS_FOR_symbols}', "");
    Expect(0, 8448, '\p{_ In_combining_Diacritical_MARKS_FOR_symbols}', "");
    Expect(1, 8448, '\p{^_ In_combining_Diacritical_MARKS_FOR_symbols}', "");
    Expect(1, 8448, '\P{_ In_combining_Diacritical_MARKS_FOR_symbols}', "");
    Expect(0, 8448, '\P{^_ In_combining_Diacritical_MARKS_FOR_symbols}', "");
    Error('\p{_/a/Diacriticals_For_SYMBOLS}');
    Error('\P{_/a/Diacriticals_For_SYMBOLS}');
    Expect(1, 8447, '\p{diacriticalsforsymbols}', "");
    Expect(0, 8447, '\p{^diacriticalsforsymbols}', "");
    Expect(0, 8447, '\P{diacriticalsforsymbols}', "");
    Expect(1, 8447, '\P{^diacriticalsforsymbols}', "");
    Expect(0, 8448, '\p{diacriticalsforsymbols}', "");
    Expect(1, 8448, '\p{^diacriticalsforsymbols}', "");
    Expect(1, 8448, '\P{diacriticalsforsymbols}', "");
    Expect(0, 8448, '\P{^diacriticalsforsymbols}', "");
    Expect(1, 8447, '\p{ _diacriticals_For_Symbols}', "");
    Expect(0, 8447, '\p{^ _diacriticals_For_Symbols}', "");
    Expect(0, 8447, '\P{ _diacriticals_For_Symbols}', "");
    Expect(1, 8447, '\P{^ _diacriticals_For_Symbols}', "");
    Expect(0, 8448, '\p{ _diacriticals_For_Symbols}', "");
    Expect(1, 8448, '\p{^ _diacriticals_For_Symbols}', "");
    Expect(1, 8448, '\P{ _diacriticals_For_Symbols}', "");
    Expect(0, 8448, '\P{^ _diacriticals_For_Symbols}', "");
    Error('\p{  is_diacriticals_For_SYMBOLS:=}');
    Error('\P{  is_diacriticals_For_SYMBOLS:=}');
    Expect(1, 8447, '\p{isdiacriticalsforsymbols}', "");
    Expect(0, 8447, '\p{^isdiacriticalsforsymbols}', "");
    Expect(0, 8447, '\P{isdiacriticalsforsymbols}', "");
    Expect(1, 8447, '\P{^isdiacriticalsforsymbols}', "");
    Expect(0, 8448, '\p{isdiacriticalsforsymbols}', "");
    Expect(1, 8448, '\p{^isdiacriticalsforsymbols}', "");
    Expect(1, 8448, '\P{isdiacriticalsforsymbols}', "");
    Expect(0, 8448, '\P{^isdiacriticalsforsymbols}', "");
    Expect(1, 8447, '\p{	-Is_Diacriticals_FOR_Symbols}', "");
    Expect(0, 8447, '\p{^	-Is_Diacriticals_FOR_Symbols}', "");
    Expect(0, 8447, '\P{	-Is_Diacriticals_FOR_Symbols}', "");
    Expect(1, 8447, '\P{^	-Is_Diacriticals_FOR_Symbols}', "");
    Expect(0, 8448, '\p{	-Is_Diacriticals_FOR_Symbols}', "");
    Expect(1, 8448, '\p{^	-Is_Diacriticals_FOR_Symbols}', "");
    Expect(1, 8448, '\P{	-Is_Diacriticals_FOR_Symbols}', "");
    Expect(0, 8448, '\P{^	-Is_Diacriticals_FOR_Symbols}', "");
    Error('\p{-in_Diacriticals_for_SYMBOLS:=}');
    Error('\P{-in_Diacriticals_for_SYMBOLS:=}');
    Expect(1, 8447, '\p{indiacriticalsforsymbols}', "");
    Expect(0, 8447, '\p{^indiacriticalsforsymbols}', "");
    Expect(0, 8447, '\P{indiacriticalsforsymbols}', "");
    Expect(1, 8447, '\P{^indiacriticalsforsymbols}', "");
    Expect(0, 8448, '\p{indiacriticalsforsymbols}', "");
    Expect(1, 8448, '\p{^indiacriticalsforsymbols}', "");
    Expect(1, 8448, '\P{indiacriticalsforsymbols}', "");
    Expect(0, 8448, '\P{^indiacriticalsforsymbols}', "");
    Expect(1, 8447, '\p{--IN_DIACRITICALS_for_Symbols}', "");
    Expect(0, 8447, '\p{^--IN_DIACRITICALS_for_Symbols}', "");
    Expect(0, 8447, '\P{--IN_DIACRITICALS_for_Symbols}', "");
    Expect(1, 8447, '\P{^--IN_DIACRITICALS_for_Symbols}', "");
    Expect(0, 8448, '\p{--IN_DIACRITICALS_for_Symbols}', "");
    Expect(1, 8448, '\p{^--IN_DIACRITICALS_for_Symbols}', "");
    Expect(1, 8448, '\P{--IN_DIACRITICALS_for_Symbols}', "");
    Expect(0, 8448, '\P{^--IN_DIACRITICALS_for_Symbols}', "");
    Error('\p{/a/Combining_marks_FOR_Symbols}');
    Error('\P{/a/Combining_marks_FOR_Symbols}');
    Expect(1, 8447, '\p{combiningmarksforsymbols}', "");
    Expect(0, 8447, '\p{^combiningmarksforsymbols}', "");
    Expect(0, 8447, '\P{combiningmarksforsymbols}', "");
    Expect(1, 8447, '\P{^combiningmarksforsymbols}', "");
    Expect(0, 8448, '\p{combiningmarksforsymbols}', "");
    Expect(1, 8448, '\p{^combiningmarksforsymbols}', "");
    Expect(1, 8448, '\P{combiningmarksforsymbols}', "");
    Expect(0, 8448, '\P{^combiningmarksforsymbols}', "");
    Expect(1, 8447, '\p{	Combining_marks_for_Symbols}', "");
    Expect(0, 8447, '\p{^	Combining_marks_for_Symbols}', "");
    Expect(0, 8447, '\P{	Combining_marks_for_Symbols}', "");
    Expect(1, 8447, '\P{^	Combining_marks_for_Symbols}', "");
    Expect(0, 8448, '\p{	Combining_marks_for_Symbols}', "");
    Expect(1, 8448, '\p{^	Combining_marks_for_Symbols}', "");
    Expect(1, 8448, '\P{	Combining_marks_for_Symbols}', "");
    Expect(0, 8448, '\P{^	Combining_marks_for_Symbols}', "");
    Error('\p{ _IS_combining_marks_For_Symbols/a/}');
    Error('\P{ _IS_combining_marks_For_Symbols/a/}');
    Expect(1, 8447, '\p{iscombiningmarksforsymbols}', "");
    Expect(0, 8447, '\p{^iscombiningmarksforsymbols}', "");
    Expect(0, 8447, '\P{iscombiningmarksforsymbols}', "");
    Expect(1, 8447, '\P{^iscombiningmarksforsymbols}', "");
    Expect(0, 8448, '\p{iscombiningmarksforsymbols}', "");
    Expect(1, 8448, '\p{^iscombiningmarksforsymbols}', "");
    Expect(1, 8448, '\P{iscombiningmarksforsymbols}', "");
    Expect(0, 8448, '\P{^iscombiningmarksforsymbols}', "");
    Expect(1, 8447, '\p{ Is_COMBINING_Marks_For_Symbols}', "");
    Expect(0, 8447, '\p{^ Is_COMBINING_Marks_For_Symbols}', "");
    Expect(0, 8447, '\P{ Is_COMBINING_Marks_For_Symbols}', "");
    Expect(1, 8447, '\P{^ Is_COMBINING_Marks_For_Symbols}', "");
    Expect(0, 8448, '\p{ Is_COMBINING_Marks_For_Symbols}', "");
    Expect(1, 8448, '\p{^ Is_COMBINING_Marks_For_Symbols}', "");
    Expect(1, 8448, '\P{ Is_COMBINING_Marks_For_Symbols}', "");
    Expect(0, 8448, '\P{^ Is_COMBINING_Marks_For_Symbols}', "");
    Error('\p{/a/_	In_Combining_MARKS_For_symbols}');
    Error('\P{/a/_	In_Combining_MARKS_For_symbols}');
    Expect(1, 8447, '\p{incombiningmarksforsymbols}', "");
    Expect(0, 8447, '\p{^incombiningmarksforsymbols}', "");
    Expect(0, 8447, '\P{incombiningmarksforsymbols}', "");
    Expect(1, 8447, '\P{^incombiningmarksforsymbols}', "");
    Expect(0, 8448, '\p{incombiningmarksforsymbols}', "");
    Expect(1, 8448, '\p{^incombiningmarksforsymbols}', "");
    Expect(1, 8448, '\P{incombiningmarksforsymbols}', "");
    Expect(0, 8448, '\P{^incombiningmarksforsymbols}', "");
    Expect(1, 8447, '\p{_in_Combining_MARKS_For_Symbols}', "");
    Expect(0, 8447, '\p{^_in_Combining_MARKS_For_Symbols}', "");
    Expect(0, 8447, '\P{_in_Combining_MARKS_For_Symbols}', "");
    Expect(1, 8447, '\P{^_in_Combining_MARKS_For_Symbols}', "");
    Expect(0, 8448, '\p{_in_Combining_MARKS_For_Symbols}', "");
    Expect(1, 8448, '\p{^_in_Combining_MARKS_For_Symbols}', "");
    Expect(1, 8448, '\P{_in_Combining_MARKS_For_Symbols}', "");
    Expect(0, 8448, '\P{^_in_Combining_MARKS_For_Symbols}', "");
    Error('\p{	/a/Combining_diacritical_Marks_Supplement}');
    Error('\P{	/a/Combining_diacritical_Marks_Supplement}');
    Expect(1, 7679, '\p{combiningdiacriticalmarkssupplement}', "");
    Expect(0, 7679, '\p{^combiningdiacriticalmarkssupplement}', "");
    Expect(0, 7679, '\P{combiningdiacriticalmarkssupplement}', "");
    Expect(1, 7679, '\P{^combiningdiacriticalmarkssupplement}', "");
    Expect(0, 7680, '\p{combiningdiacriticalmarkssupplement}', "");
    Expect(1, 7680, '\p{^combiningdiacriticalmarkssupplement}', "");
    Expect(1, 7680, '\P{combiningdiacriticalmarkssupplement}', "");
    Expect(0, 7680, '\P{^combiningdiacriticalmarkssupplement}', "");
    Expect(1, 7679, '\p{-combining_DIACRITICAL_marks_supplement}', "");
    Expect(0, 7679, '\p{^-combining_DIACRITICAL_marks_supplement}', "");
    Expect(0, 7679, '\P{-combining_DIACRITICAL_marks_supplement}', "");
    Expect(1, 7679, '\P{^-combining_DIACRITICAL_marks_supplement}', "");
    Expect(0, 7680, '\p{-combining_DIACRITICAL_marks_supplement}', "");
    Expect(1, 7680, '\p{^-combining_DIACRITICAL_marks_supplement}', "");
    Expect(1, 7680, '\P{-combining_DIACRITICAL_marks_supplement}', "");
    Expect(0, 7680, '\P{^-combining_DIACRITICAL_marks_supplement}', "");
    Error('\p{:= Is_combining_DIACRITICAL_Marks_supplement}');
    Error('\P{:= Is_combining_DIACRITICAL_Marks_supplement}');
    Expect(1, 7679, '\p{iscombiningdiacriticalmarkssupplement}', "");
    Expect(0, 7679, '\p{^iscombiningdiacriticalmarkssupplement}', "");
    Expect(0, 7679, '\P{iscombiningdiacriticalmarkssupplement}', "");
    Expect(1, 7679, '\P{^iscombiningdiacriticalmarkssupplement}', "");
    Expect(0, 7680, '\p{iscombiningdiacriticalmarkssupplement}', "");
    Expect(1, 7680, '\p{^iscombiningdiacriticalmarkssupplement}', "");
    Expect(1, 7680, '\P{iscombiningdiacriticalmarkssupplement}', "");
    Expect(0, 7680, '\P{^iscombiningdiacriticalmarkssupplement}', "");
    Expect(1, 7679, '\p{-IS_Combining_Diacritical_Marks_supplement}', "");
    Expect(0, 7679, '\p{^-IS_Combining_Diacritical_Marks_supplement}', "");
    Expect(0, 7679, '\P{-IS_Combining_Diacritical_Marks_supplement}', "");
    Expect(1, 7679, '\P{^-IS_Combining_Diacritical_Marks_supplement}', "");
    Expect(0, 7680, '\p{-IS_Combining_Diacritical_Marks_supplement}', "");
    Expect(1, 7680, '\p{^-IS_Combining_Diacritical_Marks_supplement}', "");
    Expect(1, 7680, '\P{-IS_Combining_Diacritical_Marks_supplement}', "");
    Expect(0, 7680, '\P{^-IS_Combining_Diacritical_Marks_supplement}', "");
    Error('\p{/a/ _IN_Combining_Diacritical_Marks_Supplement}');
    Error('\P{/a/ _IN_Combining_Diacritical_Marks_Supplement}');
    Expect(1, 7679, '\p{incombiningdiacriticalmarkssupplement}', "");
    Expect(0, 7679, '\p{^incombiningdiacriticalmarkssupplement}', "");
    Expect(0, 7679, '\P{incombiningdiacriticalmarkssupplement}', "");
    Expect(1, 7679, '\P{^incombiningdiacriticalmarkssupplement}', "");
    Expect(0, 7680, '\p{incombiningdiacriticalmarkssupplement}', "");
    Expect(1, 7680, '\p{^incombiningdiacriticalmarkssupplement}', "");
    Expect(1, 7680, '\P{incombiningdiacriticalmarkssupplement}', "");
    Expect(0, 7680, '\P{^incombiningdiacriticalmarkssupplement}', "");
    Expect(1, 7679, '\p{_in_combining_DIACRITICAL_Marks_supplement}', "");
    Expect(0, 7679, '\p{^_in_combining_DIACRITICAL_Marks_supplement}', "");
    Expect(0, 7679, '\P{_in_combining_DIACRITICAL_Marks_supplement}', "");
    Expect(1, 7679, '\P{^_in_combining_DIACRITICAL_Marks_supplement}', "");
    Expect(0, 7680, '\p{_in_combining_DIACRITICAL_Marks_supplement}', "");
    Expect(1, 7680, '\p{^_in_combining_DIACRITICAL_Marks_supplement}', "");
    Expect(1, 7680, '\P{_in_combining_DIACRITICAL_Marks_supplement}', "");
    Expect(0, 7680, '\P{^_in_combining_DIACRITICAL_Marks_supplement}', "");
    Error('\p{/a/__DIACRITICALS_sup}');
    Error('\P{/a/__DIACRITICALS_sup}');
    Expect(1, 7679, '\p{diacriticalssup}', "");
    Expect(0, 7679, '\p{^diacriticalssup}', "");
    Expect(0, 7679, '\P{diacriticalssup}', "");
    Expect(1, 7679, '\P{^diacriticalssup}', "");
    Expect(0, 7680, '\p{diacriticalssup}', "");
    Expect(1, 7680, '\p{^diacriticalssup}', "");
    Expect(1, 7680, '\P{diacriticalssup}', "");
    Expect(0, 7680, '\P{^diacriticalssup}', "");
    Expect(1, 7679, '\p{-_DIACRITICALS_Sup}', "");
    Expect(0, 7679, '\p{^-_DIACRITICALS_Sup}', "");
    Expect(0, 7679, '\P{-_DIACRITICALS_Sup}', "");
    Expect(1, 7679, '\P{^-_DIACRITICALS_Sup}', "");
    Expect(0, 7680, '\p{-_DIACRITICALS_Sup}', "");
    Expect(1, 7680, '\p{^-_DIACRITICALS_Sup}', "");
    Expect(1, 7680, '\P{-_DIACRITICALS_Sup}', "");
    Expect(0, 7680, '\P{^-_DIACRITICALS_Sup}', "");
    Error('\p{:= is_Diacriticals_sup}');
    Error('\P{:= is_Diacriticals_sup}');
    Expect(1, 7679, '\p{isdiacriticalssup}', "");
    Expect(0, 7679, '\p{^isdiacriticalssup}', "");
    Expect(0, 7679, '\P{isdiacriticalssup}', "");
    Expect(1, 7679, '\P{^isdiacriticalssup}', "");
    Expect(0, 7680, '\p{isdiacriticalssup}', "");
    Expect(1, 7680, '\p{^isdiacriticalssup}', "");
    Expect(1, 7680, '\P{isdiacriticalssup}', "");
    Expect(0, 7680, '\P{^isdiacriticalssup}', "");
    Expect(1, 7679, '\p{- is_DIACRITICALS_sup}', "");
    Expect(0, 7679, '\p{^- is_DIACRITICALS_sup}', "");
    Expect(0, 7679, '\P{- is_DIACRITICALS_sup}', "");
    Expect(1, 7679, '\P{^- is_DIACRITICALS_sup}', "");
    Expect(0, 7680, '\p{- is_DIACRITICALS_sup}', "");
    Expect(1, 7680, '\p{^- is_DIACRITICALS_sup}', "");
    Expect(1, 7680, '\P{- is_DIACRITICALS_sup}', "");
    Expect(0, 7680, '\P{^- is_DIACRITICALS_sup}', "");
    Error('\p{:=	_In_Diacriticals_sup}');
    Error('\P{:=	_In_Diacriticals_sup}');
    Expect(1, 7679, '\p{indiacriticalssup}', "");
    Expect(0, 7679, '\p{^indiacriticalssup}', "");
    Expect(0, 7679, '\P{indiacriticalssup}', "");
    Expect(1, 7679, '\P{^indiacriticalssup}', "");
    Expect(0, 7680, '\p{indiacriticalssup}', "");
    Expect(1, 7680, '\p{^indiacriticalssup}', "");
    Expect(1, 7680, '\P{indiacriticalssup}', "");
    Expect(0, 7680, '\P{^indiacriticalssup}', "");
    Expect(1, 7679, '\p{_ in_Diacriticals_Sup}', "");
    Expect(0, 7679, '\p{^_ in_Diacriticals_Sup}', "");
    Expect(0, 7679, '\P{_ in_Diacriticals_Sup}', "");
    Expect(1, 7679, '\P{^_ in_Diacriticals_Sup}', "");
    Expect(0, 7680, '\p{_ in_Diacriticals_Sup}', "");
    Expect(1, 7680, '\p{^_ in_Diacriticals_Sup}', "");
    Expect(1, 7680, '\P{_ in_Diacriticals_Sup}', "");
    Expect(0, 7680, '\P{^_ in_Diacriticals_Sup}', "");
    Error('\p{/a/__Combining_half_Marks}');
    Error('\P{/a/__Combining_half_Marks}');
    Expect(1, 65071, '\p{combininghalfmarks}', "");
    Expect(0, 65071, '\p{^combininghalfmarks}', "");
    Expect(0, 65071, '\P{combininghalfmarks}', "");
    Expect(1, 65071, '\P{^combininghalfmarks}', "");
    Expect(0, 65072, '\p{combininghalfmarks}', "");
    Expect(1, 65072, '\p{^combininghalfmarks}', "");
    Expect(1, 65072, '\P{combininghalfmarks}', "");
    Expect(0, 65072, '\P{^combininghalfmarks}', "");
    Expect(1, 65071, '\p{- COMBINING_Half_Marks}', "");
    Expect(0, 65071, '\p{^- COMBINING_Half_Marks}', "");
    Expect(0, 65071, '\P{- COMBINING_Half_Marks}', "");
    Expect(1, 65071, '\P{^- COMBINING_Half_Marks}', "");
    Expect(0, 65072, '\p{- COMBINING_Half_Marks}', "");
    Expect(1, 65072, '\p{^- COMBINING_Half_Marks}', "");
    Expect(1, 65072, '\P{- COMBINING_Half_Marks}', "");
    Expect(0, 65072, '\P{^- COMBINING_Half_Marks}', "");
    Error('\p{ 	Is_COMBINING_HALF_Marks/a/}');
    Error('\P{ 	Is_COMBINING_HALF_Marks/a/}');
    Expect(1, 65071, '\p{iscombininghalfmarks}', "");
    Expect(0, 65071, '\p{^iscombininghalfmarks}', "");
    Expect(0, 65071, '\P{iscombininghalfmarks}', "");
    Expect(1, 65071, '\P{^iscombininghalfmarks}', "");
    Expect(0, 65072, '\p{iscombininghalfmarks}', "");
    Expect(1, 65072, '\p{^iscombininghalfmarks}', "");
    Expect(1, 65072, '\P{iscombininghalfmarks}', "");
    Expect(0, 65072, '\P{^iscombininghalfmarks}', "");
    Expect(1, 65071, '\p{ 	is_COMBINING_Half_MARKS}', "");
    Expect(0, 65071, '\p{^ 	is_COMBINING_Half_MARKS}', "");
    Expect(0, 65071, '\P{ 	is_COMBINING_Half_MARKS}', "");
    Expect(1, 65071, '\P{^ 	is_COMBINING_Half_MARKS}', "");
    Expect(0, 65072, '\p{ 	is_COMBINING_Half_MARKS}', "");
    Expect(1, 65072, '\p{^ 	is_COMBINING_Half_MARKS}', "");
    Expect(1, 65072, '\P{ 	is_COMBINING_Half_MARKS}', "");
    Expect(0, 65072, '\P{^ 	is_COMBINING_Half_MARKS}', "");
    Error('\p{_	In_Combining_HALF_Marks:=}');
    Error('\P{_	In_Combining_HALF_Marks:=}');
    Expect(1, 65071, '\p{incombininghalfmarks}', "");
    Expect(0, 65071, '\p{^incombininghalfmarks}', "");
    Expect(0, 65071, '\P{incombininghalfmarks}', "");
    Expect(1, 65071, '\P{^incombininghalfmarks}', "");
    Expect(0, 65072, '\p{incombininghalfmarks}', "");
    Expect(1, 65072, '\p{^incombininghalfmarks}', "");
    Expect(1, 65072, '\P{incombininghalfmarks}', "");
    Expect(0, 65072, '\P{^incombininghalfmarks}', "");
    Expect(1, 65071, '\p{-_In_COMBINING_half_marks}', "");
    Expect(0, 65071, '\p{^-_In_COMBINING_half_marks}', "");
    Expect(0, 65071, '\P{-_In_COMBINING_half_marks}', "");
    Expect(1, 65071, '\P{^-_In_COMBINING_half_marks}', "");
    Expect(0, 65072, '\p{-_In_COMBINING_half_marks}', "");
    Expect(1, 65072, '\p{^-_In_COMBINING_half_marks}', "");
    Expect(1, 65072, '\P{-_In_COMBINING_half_marks}', "");
    Expect(0, 65072, '\P{^-_In_COMBINING_half_marks}', "");
    Error('\p{ :=Half_Marks}');
    Error('\P{ :=Half_Marks}');
    Expect(1, 65071, '\p{halfmarks}', "");
    Expect(0, 65071, '\p{^halfmarks}', "");
    Expect(0, 65071, '\P{halfmarks}', "");
    Expect(1, 65071, '\P{^halfmarks}', "");
    Expect(0, 65072, '\p{halfmarks}', "");
    Expect(1, 65072, '\p{^halfmarks}', "");
    Expect(1, 65072, '\P{halfmarks}', "");
    Expect(0, 65072, '\P{^halfmarks}', "");
    Expect(1, 65071, '\p{-	HALF_MARKS}', "");
    Expect(0, 65071, '\p{^-	HALF_MARKS}', "");
    Expect(0, 65071, '\P{-	HALF_MARKS}', "");
    Expect(1, 65071, '\P{^-	HALF_MARKS}', "");
    Expect(0, 65072, '\p{-	HALF_MARKS}', "");
    Expect(1, 65072, '\p{^-	HALF_MARKS}', "");
    Expect(1, 65072, '\P{-	HALF_MARKS}', "");
    Expect(0, 65072, '\P{^-	HALF_MARKS}', "");
    Error('\p{:=_	IS_half_Marks}');
    Error('\P{:=_	IS_half_Marks}');
    Expect(1, 65071, '\p{ishalfmarks}', "");
    Expect(0, 65071, '\p{^ishalfmarks}', "");
    Expect(0, 65071, '\P{ishalfmarks}', "");
    Expect(1, 65071, '\P{^ishalfmarks}', "");
    Expect(0, 65072, '\p{ishalfmarks}', "");
    Expect(1, 65072, '\p{^ishalfmarks}', "");
    Expect(1, 65072, '\P{ishalfmarks}', "");
    Expect(0, 65072, '\P{^ishalfmarks}', "");
    Expect(1, 65071, '\p{_is_half_MARKS}', "");
    Expect(0, 65071, '\p{^_is_half_MARKS}', "");
    Expect(0, 65071, '\P{_is_half_MARKS}', "");
    Expect(1, 65071, '\P{^_is_half_MARKS}', "");
    Expect(0, 65072, '\p{_is_half_MARKS}', "");
    Expect(1, 65072, '\p{^_is_half_MARKS}', "");
    Expect(1, 65072, '\P{_is_half_MARKS}', "");
    Expect(0, 65072, '\P{^_is_half_MARKS}', "");
    Error('\p{-:=IN_Half_marks}');
    Error('\P{-:=IN_Half_marks}');
    Expect(1, 65071, '\p{inhalfmarks}', "");
    Expect(0, 65071, '\p{^inhalfmarks}', "");
    Expect(0, 65071, '\P{inhalfmarks}', "");
    Expect(1, 65071, '\P{^inhalfmarks}', "");
    Expect(0, 65072, '\p{inhalfmarks}', "");
    Expect(1, 65072, '\p{^inhalfmarks}', "");
    Expect(1, 65072, '\P{inhalfmarks}', "");
    Expect(0, 65072, '\P{^inhalfmarks}', "");
    Expect(1, 65071, '\p{-	In_half_MARKS}', "");
    Expect(0, 65071, '\p{^-	In_half_MARKS}', "");
    Expect(0, 65071, '\P{-	In_half_MARKS}', "");
    Expect(1, 65071, '\P{^-	In_half_MARKS}', "");
    Expect(0, 65072, '\p{-	In_half_MARKS}', "");
    Expect(1, 65072, '\p{^-	In_half_MARKS}', "");
    Expect(1, 65072, '\P{-	In_half_MARKS}', "");
    Expect(0, 65072, '\P{^-	In_half_MARKS}', "");
    Error('\p{:=common}');
    Error('\P{:=common}');
    Expect(1, 917631, '\p{common}', "");
    Expect(0, 917631, '\p{^common}', "");
    Expect(0, 917631, '\P{common}', "");
    Expect(1, 917631, '\P{^common}', "");
    Expect(0, 917632, '\p{common}', "");
    Expect(1, 917632, '\p{^common}', "");
    Expect(1, 917632, '\P{common}', "");
    Expect(0, 917632, '\P{^common}', "");
    Expect(1, 917631, '\p{	common}', "");
    Expect(0, 917631, '\p{^	common}', "");
    Expect(0, 917631, '\P{	common}', "");
    Expect(1, 917631, '\P{^	common}', "");
    Expect(0, 917632, '\p{	common}', "");
    Expect(1, 917632, '\p{^	common}', "");
    Expect(1, 917632, '\P{	common}', "");
    Expect(0, 917632, '\P{^	common}', "");
    Error('\p{-_IS_Common/a/}');
    Error('\P{-_IS_Common/a/}');
    Expect(1, 917631, '\p{iscommon}', "");
    Expect(0, 917631, '\p{^iscommon}', "");
    Expect(0, 917631, '\P{iscommon}', "");
    Expect(1, 917631, '\P{^iscommon}', "");
    Expect(0, 917632, '\p{iscommon}', "");
    Expect(1, 917632, '\p{^iscommon}', "");
    Expect(1, 917632, '\P{iscommon}', "");
    Expect(0, 917632, '\P{^iscommon}', "");
    Expect(1, 917631, '\p{-_Is_Common}', "");
    Expect(0, 917631, '\p{^-_Is_Common}', "");
    Expect(0, 917631, '\P{-_Is_Common}', "");
    Expect(1, 917631, '\P{^-_Is_Common}', "");
    Expect(0, 917632, '\p{-_Is_Common}', "");
    Expect(1, 917632, '\p{^-_Is_Common}', "");
    Expect(1, 917632, '\P{-_Is_Common}', "");
    Expect(0, 917632, '\P{^-_Is_Common}', "");
    Error('\p{/a/-zyyy}');
    Error('\P{/a/-zyyy}');
    Expect(1, 917631, '\p{zyyy}', "");
    Expect(0, 917631, '\p{^zyyy}', "");
    Expect(0, 917631, '\P{zyyy}', "");
    Expect(1, 917631, '\P{^zyyy}', "");
    Expect(0, 917632, '\p{zyyy}', "");
    Expect(1, 917632, '\p{^zyyy}', "");
    Expect(1, 917632, '\P{zyyy}', "");
    Expect(0, 917632, '\P{^zyyy}', "");
    Expect(1, 917631, '\p{	zyyy}', "");
    Expect(0, 917631, '\p{^	zyyy}', "");
    Expect(0, 917631, '\P{	zyyy}', "");
    Expect(1, 917631, '\P{^	zyyy}', "");
    Expect(0, 917632, '\p{	zyyy}', "");
    Expect(1, 917632, '\p{^	zyyy}', "");
    Expect(1, 917632, '\P{	zyyy}', "");
    Expect(0, 917632, '\P{^	zyyy}', "");
    Error('\p{:=- Is_Zyyy}');
    Error('\P{:=- Is_Zyyy}');
    Expect(1, 917631, '\p{iszyyy}', "");
    Expect(0, 917631, '\p{^iszyyy}', "");
    Expect(0, 917631, '\P{iszyyy}', "");
    Expect(1, 917631, '\P{^iszyyy}', "");
    Expect(0, 917632, '\p{iszyyy}', "");
    Expect(1, 917632, '\p{^iszyyy}', "");
    Expect(1, 917632, '\P{iszyyy}', "");
    Expect(0, 917632, '\P{^iszyyy}', "");
    Expect(1, 917631, '\p{-Is_zyyy}', "");
    Expect(0, 917631, '\p{^-Is_zyyy}', "");
    Expect(0, 917631, '\P{-Is_zyyy}', "");
    Expect(1, 917631, '\P{^-Is_zyyy}', "");
    Expect(0, 917632, '\p{-Is_zyyy}', "");
    Expect(1, 917632, '\p{^-Is_zyyy}', "");
    Expect(1, 917632, '\P{-Is_zyyy}', "");
    Expect(0, 917632, '\P{^-Is_zyyy}', "");
    Error('\p{_Common_indic_NUMBER_FORMS:=}');
    Error('\P{_Common_indic_NUMBER_FORMS:=}');
    Expect(1, 43071, '\p{commonindicnumberforms}', "");
    Expect(0, 43071, '\p{^commonindicnumberforms}', "");
    Expect(0, 43071, '\P{commonindicnumberforms}', "");
    Expect(1, 43071, '\P{^commonindicnumberforms}', "");
    Expect(0, 43072, '\p{commonindicnumberforms}', "");
    Expect(1, 43072, '\p{^commonindicnumberforms}', "");
    Expect(1, 43072, '\P{commonindicnumberforms}', "");
    Expect(0, 43072, '\P{^commonindicnumberforms}', "");
    Expect(1, 43071, '\p{_COMMON_indic_NUMBER_FORMS}', "");
    Expect(0, 43071, '\p{^_COMMON_indic_NUMBER_FORMS}', "");
    Expect(0, 43071, '\P{_COMMON_indic_NUMBER_FORMS}', "");
    Expect(1, 43071, '\P{^_COMMON_indic_NUMBER_FORMS}', "");
    Expect(0, 43072, '\p{_COMMON_indic_NUMBER_FORMS}', "");
    Expect(1, 43072, '\p{^_COMMON_indic_NUMBER_FORMS}', "");
    Expect(1, 43072, '\P{_COMMON_indic_NUMBER_FORMS}', "");
    Expect(0, 43072, '\P{^_COMMON_indic_NUMBER_FORMS}', "");
    Error('\p{_/a/IS_Common_INDIC_NUMBER_forms}');
    Error('\P{_/a/IS_Common_INDIC_NUMBER_forms}');
    Expect(1, 43071, '\p{iscommonindicnumberforms}', "");
    Expect(0, 43071, '\p{^iscommonindicnumberforms}', "");
    Expect(0, 43071, '\P{iscommonindicnumberforms}', "");
    Expect(1, 43071, '\P{^iscommonindicnumberforms}', "");
    Expect(0, 43072, '\p{iscommonindicnumberforms}', "");
    Expect(1, 43072, '\p{^iscommonindicnumberforms}', "");
    Expect(1, 43072, '\P{iscommonindicnumberforms}', "");
    Expect(0, 43072, '\P{^iscommonindicnumberforms}', "");
    Expect(1, 43071, '\p{ Is_COMMON_INDIC_number_Forms}', "");
    Expect(0, 43071, '\p{^ Is_COMMON_INDIC_number_Forms}', "");
    Expect(0, 43071, '\P{ Is_COMMON_INDIC_number_Forms}', "");
    Expect(1, 43071, '\P{^ Is_COMMON_INDIC_number_Forms}', "");
    Expect(0, 43072, '\p{ Is_COMMON_INDIC_number_Forms}', "");
    Expect(1, 43072, '\p{^ Is_COMMON_INDIC_number_Forms}', "");
    Expect(1, 43072, '\P{ Is_COMMON_INDIC_number_Forms}', "");
    Expect(0, 43072, '\P{^ Is_COMMON_INDIC_number_Forms}', "");
    Error('\p{IN_Common_indic_Number_FORMS:=}');
    Error('\P{IN_Common_indic_Number_FORMS:=}');
    Expect(1, 43071, '\p{incommonindicnumberforms}', "");
    Expect(0, 43071, '\p{^incommonindicnumberforms}', "");
    Expect(0, 43071, '\P{incommonindicnumberforms}', "");
    Expect(1, 43071, '\P{^incommonindicnumberforms}', "");
    Expect(0, 43072, '\p{incommonindicnumberforms}', "");
    Expect(1, 43072, '\p{^incommonindicnumberforms}', "");
    Expect(1, 43072, '\P{incommonindicnumberforms}', "");
    Expect(0, 43072, '\P{^incommonindicnumberforms}', "");
    Expect(1, 43071, '\p{ 	in_common_INDIC_Number_FORMS}', "");
    Expect(0, 43071, '\p{^ 	in_common_INDIC_Number_FORMS}', "");
    Expect(0, 43071, '\P{ 	in_common_INDIC_Number_FORMS}', "");
    Expect(1, 43071, '\P{^ 	in_common_INDIC_Number_FORMS}', "");
    Expect(0, 43072, '\p{ 	in_common_INDIC_Number_FORMS}', "");
    Expect(1, 43072, '\p{^ 	in_common_INDIC_Number_FORMS}', "");
    Expect(1, 43072, '\P{ 	in_common_INDIC_Number_FORMS}', "");
    Expect(0, 43072, '\P{^ 	in_common_INDIC_Number_FORMS}', "");
    Error('\p{:=	Indic_Number_Forms}');
    Error('\P{:=	Indic_Number_Forms}');
    Expect(1, 43071, '\p{indicnumberforms}', "");
    Expect(0, 43071, '\p{^indicnumberforms}', "");
    Expect(0, 43071, '\P{indicnumberforms}', "");
    Expect(1, 43071, '\P{^indicnumberforms}', "");
    Expect(0, 43072, '\p{indicnumberforms}', "");
    Expect(1, 43072, '\p{^indicnumberforms}', "");
    Expect(1, 43072, '\P{indicnumberforms}', "");
    Expect(0, 43072, '\P{^indicnumberforms}', "");
    Expect(1, 43071, '\p{		INDIC_Number_FORMS}', "");
    Expect(0, 43071, '\p{^		INDIC_Number_FORMS}', "");
    Expect(0, 43071, '\P{		INDIC_Number_FORMS}', "");
    Expect(1, 43071, '\P{^		INDIC_Number_FORMS}', "");
    Expect(0, 43072, '\p{		INDIC_Number_FORMS}', "");
    Expect(1, 43072, '\p{^		INDIC_Number_FORMS}', "");
    Expect(1, 43072, '\P{		INDIC_Number_FORMS}', "");
    Expect(0, 43072, '\P{^		INDIC_Number_FORMS}', "");
    Error('\p{_Is_Indic_Number_FORMS/a/}');
    Error('\P{_Is_Indic_Number_FORMS/a/}');
    Expect(1, 43071, '\p{isindicnumberforms}', "");
    Expect(0, 43071, '\p{^isindicnumberforms}', "");
    Expect(0, 43071, '\P{isindicnumberforms}', "");
    Expect(1, 43071, '\P{^isindicnumberforms}', "");
    Expect(0, 43072, '\p{isindicnumberforms}', "");
    Expect(1, 43072, '\p{^isindicnumberforms}', "");
    Expect(1, 43072, '\P{isindicnumberforms}', "");
    Expect(0, 43072, '\P{^isindicnumberforms}', "");
    Expect(1, 43071, '\p{-_is_indic_NUMBER_forms}', "");
    Expect(0, 43071, '\p{^-_is_indic_NUMBER_forms}', "");
    Expect(0, 43071, '\P{-_is_indic_NUMBER_forms}', "");
    Expect(1, 43071, '\P{^-_is_indic_NUMBER_forms}', "");
    Expect(0, 43072, '\p{-_is_indic_NUMBER_forms}', "");
    Expect(1, 43072, '\p{^-_is_indic_NUMBER_forms}', "");
    Expect(1, 43072, '\P{-_is_indic_NUMBER_forms}', "");
    Expect(0, 43072, '\P{^-_is_indic_NUMBER_forms}', "");
    Error('\p{/a/--IN_indic_NUMBER_FORMS}');
    Error('\P{/a/--IN_indic_NUMBER_FORMS}');
    Expect(1, 43071, '\p{inindicnumberforms}', "");
    Expect(0, 43071, '\p{^inindicnumberforms}', "");
    Expect(0, 43071, '\P{inindicnumberforms}', "");
    Expect(1, 43071, '\P{^inindicnumberforms}', "");
    Expect(0, 43072, '\p{inindicnumberforms}', "");
    Expect(1, 43072, '\p{^inindicnumberforms}', "");
    Expect(1, 43072, '\P{inindicnumberforms}', "");
    Expect(0, 43072, '\P{^inindicnumberforms}', "");
    Expect(1, 43071, '\p{__In_indic_Number_Forms}', "");
    Expect(0, 43071, '\p{^__In_indic_Number_Forms}', "");
    Expect(0, 43071, '\P{__In_indic_Number_Forms}', "");
    Expect(1, 43071, '\P{^__In_indic_Number_Forms}', "");
    Expect(0, 43072, '\p{__In_indic_Number_Forms}', "");
    Expect(1, 43072, '\p{^__In_indic_Number_Forms}', "");
    Expect(1, 43072, '\P{__In_indic_Number_Forms}', "");
    Expect(0, 43072, '\P{^__In_indic_Number_Forms}', "");
    Error('\p{Composition_Exclusion:=}');
    Error('\P{Composition_Exclusion:=}');
    Expect(1, 119232, '\p{compositionexclusion}', "");
    Expect(0, 119232, '\p{^compositionexclusion}', "");
    Expect(0, 119232, '\P{compositionexclusion}', "");
    Expect(1, 119232, '\P{^compositionexclusion}', "");
    Expect(0, 119233, '\p{compositionexclusion}', "");
    Expect(1, 119233, '\p{^compositionexclusion}', "");
    Expect(1, 119233, '\P{compositionexclusion}', "");
    Expect(0, 119233, '\P{^compositionexclusion}', "");
    Expect(1, 119232, '\p{	composition_EXCLUSION}', "");
    Expect(0, 119232, '\p{^	composition_EXCLUSION}', "");
    Expect(0, 119232, '\P{	composition_EXCLUSION}', "");
    Expect(1, 119232, '\P{^	composition_EXCLUSION}', "");
    Expect(0, 119233, '\p{	composition_EXCLUSION}', "");
    Expect(1, 119233, '\p{^	composition_EXCLUSION}', "");
    Expect(1, 119233, '\P{	composition_EXCLUSION}', "");
    Expect(0, 119233, '\P{^	composition_EXCLUSION}', "");
    Error('\p{:=  is_Composition_Exclusion}');
    Error('\P{:=  is_Composition_Exclusion}');
    Expect(1, 119232, '\p{iscompositionexclusion}', "");
    Expect(0, 119232, '\p{^iscompositionexclusion}', "");
    Expect(0, 119232, '\P{iscompositionexclusion}', "");
    Expect(1, 119232, '\P{^iscompositionexclusion}', "");
    Expect(0, 119233, '\p{iscompositionexclusion}', "");
    Expect(1, 119233, '\p{^iscompositionexclusion}', "");
    Expect(1, 119233, '\P{iscompositionexclusion}', "");
    Expect(0, 119233, '\P{^iscompositionexclusion}', "");
    Expect(1, 119232, '\p{ IS_Composition_Exclusion}', "");
    Expect(0, 119232, '\p{^ IS_Composition_Exclusion}', "");
    Expect(0, 119232, '\P{ IS_Composition_Exclusion}', "");
    Expect(1, 119232, '\P{^ IS_Composition_Exclusion}', "");
    Expect(0, 119233, '\p{ IS_Composition_Exclusion}', "");
    Expect(1, 119233, '\p{^ IS_Composition_Exclusion}', "");
    Expect(1, 119233, '\P{ IS_Composition_Exclusion}', "");
    Expect(0, 119233, '\P{^ IS_Composition_Exclusion}', "");
    Error('\p{ CE:=}');
    Error('\P{ CE:=}');
    Expect(1, 119232, '\p{ce}', "");
    Expect(0, 119232, '\p{^ce}', "");
    Expect(0, 119232, '\P{ce}', "");
    Expect(1, 119232, '\P{^ce}', "");
    Expect(0, 119233, '\p{ce}', "");
    Expect(1, 119233, '\p{^ce}', "");
    Expect(1, 119233, '\P{ce}', "");
    Expect(0, 119233, '\P{^ce}', "");
    Expect(1, 119232, '\p{_	CE}', "");
    Expect(0, 119232, '\p{^_	CE}', "");
    Expect(0, 119232, '\P{_	CE}', "");
    Expect(1, 119232, '\P{^_	CE}', "");
    Expect(0, 119233, '\p{_	CE}', "");
    Expect(1, 119233, '\p{^_	CE}', "");
    Expect(1, 119233, '\P{_	CE}', "");
    Expect(0, 119233, '\P{^_	CE}', "");
    Error('\p{_Is_CE:=}');
    Error('\P{_Is_CE:=}');
    Expect(1, 119232, '\p{isce}', "");
    Expect(0, 119232, '\p{^isce}', "");
    Expect(0, 119232, '\P{isce}', "");
    Expect(1, 119232, '\P{^isce}', "");
    Expect(0, 119233, '\p{isce}', "");
    Expect(1, 119233, '\p{^isce}', "");
    Expect(1, 119233, '\P{isce}', "");
    Expect(0, 119233, '\P{^isce}', "");
    Expect(1, 119232, '\p{	-Is_CE}', "");
    Expect(0, 119232, '\p{^	-Is_CE}', "");
    Expect(0, 119232, '\P{	-Is_CE}', "");
    Expect(1, 119232, '\P{^	-Is_CE}', "");
    Expect(0, 119233, '\p{	-Is_CE}', "");
    Expect(1, 119233, '\p{^	-Is_CE}', "");
    Expect(1, 119233, '\P{	-Is_CE}', "");
    Expect(0, 119233, '\P{^	-Is_CE}', "");
    Error('\p{	Connector_Punctuation:=}');
    Error('\P{	Connector_Punctuation:=}');
    Expect(1, 65343, '\p{connectorpunctuation}', "");
    Expect(0, 65343, '\p{^connectorpunctuation}', "");
    Expect(0, 65343, '\P{connectorpunctuation}', "");
    Expect(1, 65343, '\P{^connectorpunctuation}', "");
    Expect(0, 65344, '\p{connectorpunctuation}', "");
    Expect(1, 65344, '\p{^connectorpunctuation}', "");
    Expect(1, 65344, '\P{connectorpunctuation}', "");
    Expect(0, 65344, '\P{^connectorpunctuation}', "");
    Expect(1, 65343, '\p{-_Connector_punctuation}', "");
    Expect(0, 65343, '\p{^-_Connector_punctuation}', "");
    Expect(0, 65343, '\P{-_Connector_punctuation}', "");
    Expect(1, 65343, '\P{^-_Connector_punctuation}', "");
    Expect(0, 65344, '\p{-_Connector_punctuation}', "");
    Expect(1, 65344, '\p{^-_Connector_punctuation}', "");
    Expect(1, 65344, '\P{-_Connector_punctuation}', "");
    Expect(0, 65344, '\P{^-_Connector_punctuation}', "");
    Error('\p{ _Is_connector_punctuation/a/}');
    Error('\P{ _Is_connector_punctuation/a/}');
    Expect(1, 65343, '\p{isconnectorpunctuation}', "");
    Expect(0, 65343, '\p{^isconnectorpunctuation}', "");
    Expect(0, 65343, '\P{isconnectorpunctuation}', "");
    Expect(1, 65343, '\P{^isconnectorpunctuation}', "");
    Expect(0, 65344, '\p{isconnectorpunctuation}', "");
    Expect(1, 65344, '\p{^isconnectorpunctuation}', "");
    Expect(1, 65344, '\P{isconnectorpunctuation}', "");
    Expect(0, 65344, '\P{^isconnectorpunctuation}', "");
    Expect(1, 65343, '\p{	Is_Connector_PUNCTUATION}', "");
    Expect(0, 65343, '\p{^	Is_Connector_PUNCTUATION}', "");
    Expect(0, 65343, '\P{	Is_Connector_PUNCTUATION}', "");
    Expect(1, 65343, '\P{^	Is_Connector_PUNCTUATION}', "");
    Expect(0, 65344, '\p{	Is_Connector_PUNCTUATION}', "");
    Expect(1, 65344, '\p{^	Is_Connector_PUNCTUATION}', "");
    Expect(1, 65344, '\P{	Is_Connector_PUNCTUATION}', "");
    Expect(0, 65344, '\P{^	Is_Connector_PUNCTUATION}', "");
    Error('\p{:= PC}');
    Error('\P{:= PC}');
    Expect(1, 65343, '\p{pc}', "");
    Expect(0, 65343, '\p{^pc}', "");
    Expect(0, 65343, '\P{pc}', "");
    Expect(1, 65343, '\P{^pc}', "");
    Expect(0, 65344, '\p{pc}', "");
    Expect(1, 65344, '\p{^pc}', "");
    Expect(1, 65344, '\P{pc}', "");
    Expect(0, 65344, '\P{^pc}', "");
    Expect(1, 65343, '\p{	PC}', "");
    Expect(0, 65343, '\p{^	PC}', "");
    Expect(0, 65343, '\P{	PC}', "");
    Expect(1, 65343, '\P{^	PC}', "");
    Expect(0, 65344, '\p{	PC}', "");
    Expect(1, 65344, '\p{^	PC}', "");
    Expect(1, 65344, '\P{	PC}', "");
    Expect(0, 65344, '\P{^	PC}', "");
    Error('\p{/a/--is_PC}');
    Error('\P{/a/--is_PC}');
    Expect(1, 65343, '\p{ispc}', "");
    Expect(0, 65343, '\p{^ispc}', "");
    Expect(0, 65343, '\P{ispc}', "");
    Expect(1, 65343, '\P{^ispc}', "");
    Expect(0, 65344, '\p{ispc}', "");
    Expect(1, 65344, '\p{^ispc}', "");
    Expect(1, 65344, '\P{ispc}', "");
    Expect(0, 65344, '\P{^ispc}', "");
    Expect(1, 65343, '\p{  Is_PC}', "");
    Expect(0, 65343, '\p{^  Is_PC}', "");
    Expect(0, 65343, '\P{  Is_PC}', "");
    Expect(1, 65343, '\P{^  Is_PC}', "");
    Expect(0, 65344, '\p{  Is_PC}', "");
    Expect(1, 65344, '\p{^  Is_PC}', "");
    Expect(1, 65344, '\P{  Is_PC}', "");
    Expect(0, 65344, '\P{^  Is_PC}', "");
    Error('\p{:=-	CONTROL_pictures}');
    Error('\P{:=-	CONTROL_pictures}');
    Expect(1, 9279, '\p{controlpictures}', "");
    Expect(0, 9279, '\p{^controlpictures}', "");
    Expect(0, 9279, '\P{controlpictures}', "");
    Expect(1, 9279, '\P{^controlpictures}', "");
    Expect(0, 9280, '\p{controlpictures}', "");
    Expect(1, 9280, '\p{^controlpictures}', "");
    Expect(1, 9280, '\P{controlpictures}', "");
    Expect(0, 9280, '\P{^controlpictures}', "");
    Expect(1, 9279, '\p{-_Control_pictures}', "");
    Expect(0, 9279, '\p{^-_Control_pictures}', "");
    Expect(0, 9279, '\P{-_Control_pictures}', "");
    Expect(1, 9279, '\P{^-_Control_pictures}', "");
    Expect(0, 9280, '\p{-_Control_pictures}', "");
    Expect(1, 9280, '\p{^-_Control_pictures}', "");
    Expect(1, 9280, '\P{-_Control_pictures}', "");
    Expect(0, 9280, '\P{^-_Control_pictures}', "");
    Error('\p{:=	_Is_control_Pictures}');
    Error('\P{:=	_Is_control_Pictures}');
    Expect(1, 9279, '\p{iscontrolpictures}', "");
    Expect(0, 9279, '\p{^iscontrolpictures}', "");
    Expect(0, 9279, '\P{iscontrolpictures}', "");
    Expect(1, 9279, '\P{^iscontrolpictures}', "");
    Expect(0, 9280, '\p{iscontrolpictures}', "");
    Expect(1, 9280, '\p{^iscontrolpictures}', "");
    Expect(1, 9280, '\P{iscontrolpictures}', "");
    Expect(0, 9280, '\P{^iscontrolpictures}', "");
    Expect(1, 9279, '\p{ is_Control_Pictures}', "");
    Expect(0, 9279, '\p{^ is_Control_Pictures}', "");
    Expect(0, 9279, '\P{ is_Control_Pictures}', "");
    Expect(1, 9279, '\P{^ is_Control_Pictures}', "");
    Expect(0, 9280, '\p{ is_Control_Pictures}', "");
    Expect(1, 9280, '\p{^ is_Control_Pictures}', "");
    Expect(1, 9280, '\P{ is_Control_Pictures}', "");
    Expect(0, 9280, '\P{^ is_Control_Pictures}', "");
    Error('\p{- In_Control_pictures:=}');
    Error('\P{- In_Control_pictures:=}');
    Expect(1, 9279, '\p{incontrolpictures}', "");
    Expect(0, 9279, '\p{^incontrolpictures}', "");
    Expect(0, 9279, '\P{incontrolpictures}', "");
    Expect(1, 9279, '\P{^incontrolpictures}', "");
    Expect(0, 9280, '\p{incontrolpictures}', "");
    Expect(1, 9280, '\p{^incontrolpictures}', "");
    Expect(1, 9280, '\P{incontrolpictures}', "");
    Expect(0, 9280, '\P{^incontrolpictures}', "");
    Expect(1, 9279, '\p{ _In_control_Pictures}', "");
    Expect(0, 9279, '\p{^ _In_control_Pictures}', "");
    Expect(0, 9279, '\P{ _In_control_Pictures}', "");
    Expect(1, 9279, '\P{^ _In_control_Pictures}', "");
    Expect(0, 9280, '\p{ _In_control_Pictures}', "");
    Expect(1, 9280, '\p{^ _In_control_Pictures}', "");
    Expect(1, 9280, '\P{ _In_control_Pictures}', "");
    Expect(0, 9280, '\P{^ _In_control_Pictures}', "");
    Error('\p{ Coptic/a/}');
    Error('\P{ Coptic/a/}');
    Expect(1, 66299, '\p{coptic}', "");
    Expect(0, 66299, '\p{^coptic}', "");
    Expect(0, 66299, '\P{coptic}', "");
    Expect(1, 66299, '\P{^coptic}', "");
    Expect(0, 66300, '\p{coptic}', "");
    Expect(1, 66300, '\p{^coptic}', "");
    Expect(1, 66300, '\P{coptic}', "");
    Expect(0, 66300, '\P{^coptic}', "");
    Expect(1, 66299, '\p{ _Coptic}', "");
    Expect(0, 66299, '\p{^ _Coptic}', "");
    Expect(0, 66299, '\P{ _Coptic}', "");
    Expect(1, 66299, '\P{^ _Coptic}', "");
    Expect(0, 66300, '\p{ _Coptic}', "");
    Expect(1, 66300, '\p{^ _Coptic}', "");
    Expect(1, 66300, '\P{ _Coptic}', "");
    Expect(0, 66300, '\P{^ _Coptic}', "");
    Error('\p{ IS_Coptic/a/}');
    Error('\P{ IS_Coptic/a/}');
    Expect(1, 66299, '\p{iscoptic}', "");
    Expect(0, 66299, '\p{^iscoptic}', "");
    Expect(0, 66299, '\P{iscoptic}', "");
    Expect(1, 66299, '\P{^iscoptic}', "");
    Expect(0, 66300, '\p{iscoptic}', "");
    Expect(1, 66300, '\p{^iscoptic}', "");
    Expect(1, 66300, '\P{iscoptic}', "");
    Expect(0, 66300, '\P{^iscoptic}', "");
    Expect(1, 66299, '\p{-Is_Coptic}', "");
    Expect(0, 66299, '\p{^-Is_Coptic}', "");
    Expect(0, 66299, '\P{-Is_Coptic}', "");
    Expect(1, 66299, '\P{^-Is_Coptic}', "");
    Expect(0, 66300, '\p{-Is_Coptic}', "");
    Expect(1, 66300, '\p{^-Is_Coptic}', "");
    Expect(1, 66300, '\P{-Is_Coptic}', "");
    Expect(0, 66300, '\P{^-Is_Coptic}', "");
    Error('\p{ :=Copt}');
    Error('\P{ :=Copt}');
    Expect(1, 66299, '\p{copt}', "");
    Expect(0, 66299, '\p{^copt}', "");
    Expect(0, 66299, '\P{copt}', "");
    Expect(1, 66299, '\P{^copt}', "");
    Expect(0, 66300, '\p{copt}', "");
    Expect(1, 66300, '\p{^copt}', "");
    Expect(1, 66300, '\P{copt}', "");
    Expect(0, 66300, '\P{^copt}', "");
    Expect(1, 66299, '\p{__Copt}', "");
    Expect(0, 66299, '\p{^__Copt}', "");
    Expect(0, 66299, '\P{__Copt}', "");
    Expect(1, 66299, '\P{^__Copt}', "");
    Expect(0, 66300, '\p{__Copt}', "");
    Expect(1, 66300, '\p{^__Copt}', "");
    Expect(1, 66300, '\P{__Copt}', "");
    Expect(0, 66300, '\P{^__Copt}', "");
    Error('\p{_Is_Copt:=}');
    Error('\P{_Is_Copt:=}');
    Expect(1, 66299, '\p{iscopt}', "");
    Expect(0, 66299, '\p{^iscopt}', "");
    Expect(0, 66299, '\P{iscopt}', "");
    Expect(1, 66299, '\P{^iscopt}', "");
    Expect(0, 66300, '\p{iscopt}', "");
    Expect(1, 66300, '\p{^iscopt}', "");
    Expect(1, 66300, '\P{iscopt}', "");
    Expect(0, 66300, '\P{^iscopt}', "");
    Expect(1, 66299, '\p{	-Is_COPT}', "");
    Expect(0, 66299, '\p{^	-Is_COPT}', "");
    Expect(0, 66299, '\P{	-Is_COPT}', "");
    Expect(1, 66299, '\P{^	-Is_COPT}', "");
    Expect(0, 66300, '\p{	-Is_COPT}', "");
    Expect(1, 66300, '\p{^	-Is_COPT}', "");
    Expect(1, 66300, '\P{	-Is_COPT}', "");
    Expect(0, 66300, '\P{^	-Is_COPT}', "");
    Error('\p{-/a/QAAC}');
    Error('\P{-/a/QAAC}');
    Expect(1, 66299, '\p{qaac}', "");
    Expect(0, 66299, '\p{^qaac}', "");
    Expect(0, 66299, '\P{qaac}', "");
    Expect(1, 66299, '\P{^qaac}', "");
    Expect(0, 66300, '\p{qaac}', "");
    Expect(1, 66300, '\p{^qaac}', "");
    Expect(1, 66300, '\P{qaac}', "");
    Expect(0, 66300, '\P{^qaac}', "");
    Expect(1, 66299, '\p{-Qaac}', "");
    Expect(0, 66299, '\p{^-Qaac}', "");
    Expect(0, 66299, '\P{-Qaac}', "");
    Expect(1, 66299, '\P{^-Qaac}', "");
    Expect(0, 66300, '\p{-Qaac}', "");
    Expect(1, 66300, '\p{^-Qaac}', "");
    Expect(1, 66300, '\P{-Qaac}', "");
    Expect(0, 66300, '\P{^-Qaac}', "");
    Error('\p{-IS_QAAC/a/}');
    Error('\P{-IS_QAAC/a/}');
    Expect(1, 66299, '\p{isqaac}', "");
    Expect(0, 66299, '\p{^isqaac}', "");
    Expect(0, 66299, '\P{isqaac}', "");
    Expect(1, 66299, '\P{^isqaac}', "");
    Expect(0, 66300, '\p{isqaac}', "");
    Expect(1, 66300, '\p{^isqaac}', "");
    Expect(1, 66300, '\P{isqaac}', "");
    Expect(0, 66300, '\P{^isqaac}', "");
    Expect(1, 66299, '\p{--IS_Qaac}', "");
    Expect(0, 66299, '\p{^--IS_Qaac}', "");
    Expect(0, 66299, '\P{--IS_Qaac}', "");
    Expect(1, 66299, '\P{^--IS_Qaac}', "");
    Expect(0, 66300, '\p{--IS_Qaac}', "");
    Expect(1, 66300, '\p{^--IS_Qaac}', "");
    Expect(1, 66300, '\P{--IS_Qaac}', "");
    Expect(0, 66300, '\P{^--IS_Qaac}', "");
    Error('\p{/a/Coptic_epact_Numbers}');
    Error('\P{/a/Coptic_epact_Numbers}');
    Expect(1, 66303, '\p{copticepactnumbers}', "");
    Expect(0, 66303, '\p{^copticepactnumbers}', "");
    Expect(0, 66303, '\P{copticepactnumbers}', "");
    Expect(1, 66303, '\P{^copticepactnumbers}', "");
    Expect(0, 66304, '\p{copticepactnumbers}', "");
    Expect(1, 66304, '\p{^copticepactnumbers}', "");
    Expect(1, 66304, '\P{copticepactnumbers}', "");
    Expect(0, 66304, '\P{^copticepactnumbers}', "");
    Expect(1, 66303, '\p{_Coptic_Epact_Numbers}', "");
    Expect(0, 66303, '\p{^_Coptic_Epact_Numbers}', "");
    Expect(0, 66303, '\P{_Coptic_Epact_Numbers}', "");
    Expect(1, 66303, '\P{^_Coptic_Epact_Numbers}', "");
    Expect(0, 66304, '\p{_Coptic_Epact_Numbers}', "");
    Expect(1, 66304, '\p{^_Coptic_Epact_Numbers}', "");
    Expect(1, 66304, '\P{_Coptic_Epact_Numbers}', "");
    Expect(0, 66304, '\P{^_Coptic_Epact_Numbers}', "");
    Error('\p{-IS_Coptic_epact_Numbers:=}');
    Error('\P{-IS_Coptic_epact_Numbers:=}');
    Expect(1, 66303, '\p{iscopticepactnumbers}', "");
    Expect(0, 66303, '\p{^iscopticepactnumbers}', "");
    Expect(0, 66303, '\P{iscopticepactnumbers}', "");
    Expect(1, 66303, '\P{^iscopticepactnumbers}', "");
    Expect(0, 66304, '\p{iscopticepactnumbers}', "");
    Expect(1, 66304, '\p{^iscopticepactnumbers}', "");
    Expect(1, 66304, '\P{iscopticepactnumbers}', "");
    Expect(0, 66304, '\P{^iscopticepactnumbers}', "");
    Expect(1, 66303, '\p{ Is_Coptic_epact_Numbers}', "");
    Expect(0, 66303, '\p{^ Is_Coptic_epact_Numbers}', "");
    Expect(0, 66303, '\P{ Is_Coptic_epact_Numbers}', "");
    Expect(1, 66303, '\P{^ Is_Coptic_epact_Numbers}', "");
    Expect(0, 66304, '\p{ Is_Coptic_epact_Numbers}', "");
    Expect(1, 66304, '\p{^ Is_Coptic_epact_Numbers}', "");
    Expect(1, 66304, '\P{ Is_Coptic_epact_Numbers}', "");
    Expect(0, 66304, '\P{^ Is_Coptic_epact_Numbers}', "");
    Error('\p{:=-_IN_Coptic_EPACT_numbers}');
    Error('\P{:=-_IN_Coptic_EPACT_numbers}');
    Expect(1, 66303, '\p{incopticepactnumbers}', "");
    Expect(0, 66303, '\p{^incopticepactnumbers}', "");
    Expect(0, 66303, '\P{incopticepactnumbers}', "");
    Expect(1, 66303, '\P{^incopticepactnumbers}', "");
    Expect(0, 66304, '\p{incopticepactnumbers}', "");
    Expect(1, 66304, '\p{^incopticepactnumbers}', "");
    Expect(1, 66304, '\P{incopticepactnumbers}', "");
    Expect(0, 66304, '\P{^incopticepactnumbers}', "");
    Expect(1, 66303, '\p{ In_Coptic_Epact_Numbers}', "");
    Expect(0, 66303, '\p{^ In_Coptic_Epact_Numbers}', "");
    Expect(0, 66303, '\P{ In_Coptic_Epact_Numbers}', "");
    Expect(1, 66303, '\P{^ In_Coptic_Epact_Numbers}', "");
    Expect(0, 66304, '\p{ In_Coptic_Epact_Numbers}', "");
    Expect(1, 66304, '\p{^ In_Coptic_Epact_Numbers}', "");
    Expect(1, 66304, '\P{ In_Coptic_Epact_Numbers}', "");
    Expect(0, 66304, '\P{^ In_Coptic_Epact_Numbers}', "");
    Error('\p{ 	Counting_rod_Numerals/a/}');
    Error('\P{ 	Counting_rod_Numerals/a/}');
    Expect(1, 119679, '\p{countingrodnumerals}', "");
    Expect(0, 119679, '\p{^countingrodnumerals}', "");
    Expect(0, 119679, '\P{countingrodnumerals}', "");
    Expect(1, 119679, '\P{^countingrodnumerals}', "");
    Expect(0, 119680, '\p{countingrodnumerals}', "");
    Expect(1, 119680, '\p{^countingrodnumerals}', "");
    Expect(1, 119680, '\P{countingrodnumerals}', "");
    Expect(0, 119680, '\P{^countingrodnumerals}', "");
    Expect(1, 119679, '\p{		COUNTING_Rod_numerals}', "");
    Expect(0, 119679, '\p{^		COUNTING_Rod_numerals}', "");
    Expect(0, 119679, '\P{		COUNTING_Rod_numerals}', "");
    Expect(1, 119679, '\P{^		COUNTING_Rod_numerals}', "");
    Expect(0, 119680, '\p{		COUNTING_Rod_numerals}', "");
    Expect(1, 119680, '\p{^		COUNTING_Rod_numerals}', "");
    Expect(1, 119680, '\P{		COUNTING_Rod_numerals}', "");
    Expect(0, 119680, '\P{^		COUNTING_Rod_numerals}', "");
    Error('\p{/a/__is_Counting_rod_Numerals}');
    Error('\P{/a/__is_Counting_rod_Numerals}');
    Expect(1, 119679, '\p{iscountingrodnumerals}', "");
    Expect(0, 119679, '\p{^iscountingrodnumerals}', "");
    Expect(0, 119679, '\P{iscountingrodnumerals}', "");
    Expect(1, 119679, '\P{^iscountingrodnumerals}', "");
    Expect(0, 119680, '\p{iscountingrodnumerals}', "");
    Expect(1, 119680, '\p{^iscountingrodnumerals}', "");
    Expect(1, 119680, '\P{iscountingrodnumerals}', "");
    Expect(0, 119680, '\P{^iscountingrodnumerals}', "");
    Expect(1, 119679, '\p{ is_COUNTING_rod_numerals}', "");
    Expect(0, 119679, '\p{^ is_COUNTING_rod_numerals}', "");
    Expect(0, 119679, '\P{ is_COUNTING_rod_numerals}', "");
    Expect(1, 119679, '\P{^ is_COUNTING_rod_numerals}', "");
    Expect(0, 119680, '\p{ is_COUNTING_rod_numerals}', "");
    Expect(1, 119680, '\p{^ is_COUNTING_rod_numerals}', "");
    Expect(1, 119680, '\P{ is_COUNTING_rod_numerals}', "");
    Expect(0, 119680, '\P{^ is_COUNTING_rod_numerals}', "");
    Error('\p{	-In_Counting_ROD_NUMERALS:=}');
    Error('\P{	-In_Counting_ROD_NUMERALS:=}');
    Expect(1, 119679, '\p{incountingrodnumerals}', "");
    Expect(0, 119679, '\p{^incountingrodnumerals}', "");
    Expect(0, 119679, '\P{incountingrodnumerals}', "");
    Expect(1, 119679, '\P{^incountingrodnumerals}', "");
    Expect(0, 119680, '\p{incountingrodnumerals}', "");
    Expect(1, 119680, '\p{^incountingrodnumerals}', "");
    Expect(1, 119680, '\P{incountingrodnumerals}', "");
    Expect(0, 119680, '\P{^incountingrodnumerals}', "");
    Expect(1, 119679, '\p{In_COUNTING_ROD_Numerals}', "");
    Expect(0, 119679, '\p{^In_COUNTING_ROD_Numerals}', "");
    Expect(0, 119679, '\P{In_COUNTING_ROD_Numerals}', "");
    Expect(1, 119679, '\P{^In_COUNTING_ROD_Numerals}', "");
    Expect(0, 119680, '\p{In_COUNTING_ROD_Numerals}', "");
    Expect(1, 119680, '\p{^In_COUNTING_ROD_Numerals}', "");
    Expect(1, 119680, '\P{In_COUNTING_ROD_Numerals}', "");
    Expect(0, 119680, '\P{^In_COUNTING_ROD_Numerals}', "");
    Error('\p{_/a/Counting_rod}');
    Error('\P{_/a/Counting_rod}');
    Expect(1, 119679, '\p{countingrod}', "");
    Expect(0, 119679, '\p{^countingrod}', "");
    Expect(0, 119679, '\P{countingrod}', "");
    Expect(1, 119679, '\P{^countingrod}', "");
    Expect(0, 119680, '\p{countingrod}', "");
    Expect(1, 119680, '\p{^countingrod}', "");
    Expect(1, 119680, '\P{countingrod}', "");
    Expect(0, 119680, '\P{^countingrod}', "");
    Expect(1, 119679, '\p{		Counting_ROD}', "");
    Expect(0, 119679, '\p{^		Counting_ROD}', "");
    Expect(0, 119679, '\P{		Counting_ROD}', "");
    Expect(1, 119679, '\P{^		Counting_ROD}', "");
    Expect(0, 119680, '\p{		Counting_ROD}', "");
    Expect(1, 119680, '\p{^		Counting_ROD}', "");
    Expect(1, 119680, '\P{		Counting_ROD}', "");
    Expect(0, 119680, '\P{^		Counting_ROD}', "");
    Error('\p{:=_-IS_Counting_ROD}');
    Error('\P{:=_-IS_Counting_ROD}');
    Expect(1, 119679, '\p{iscountingrod}', "");
    Expect(0, 119679, '\p{^iscountingrod}', "");
    Expect(0, 119679, '\P{iscountingrod}', "");
    Expect(1, 119679, '\P{^iscountingrod}', "");
    Expect(0, 119680, '\p{iscountingrod}', "");
    Expect(1, 119680, '\p{^iscountingrod}', "");
    Expect(1, 119680, '\P{iscountingrod}', "");
    Expect(0, 119680, '\P{^iscountingrod}', "");
    Expect(1, 119679, '\p{_-is_Counting_ROD}', "");
    Expect(0, 119679, '\p{^_-is_Counting_ROD}', "");
    Expect(0, 119679, '\P{_-is_Counting_ROD}', "");
    Expect(1, 119679, '\P{^_-is_Counting_ROD}', "");
    Expect(0, 119680, '\p{_-is_Counting_ROD}', "");
    Expect(1, 119680, '\p{^_-is_Counting_ROD}', "");
    Expect(1, 119680, '\P{_-is_Counting_ROD}', "");
    Expect(0, 119680, '\P{^_-is_Counting_ROD}', "");
    Error('\p{/a/  In_Counting_rod}');
    Error('\P{/a/  In_Counting_rod}');
    Expect(1, 119679, '\p{incountingrod}', "");
    Expect(0, 119679, '\p{^incountingrod}', "");
    Expect(0, 119679, '\P{incountingrod}', "");
    Expect(1, 119679, '\P{^incountingrod}', "");
    Expect(0, 119680, '\p{incountingrod}', "");
    Expect(1, 119680, '\p{^incountingrod}', "");
    Expect(1, 119680, '\P{incountingrod}', "");
    Expect(0, 119680, '\P{^incountingrod}', "");
    Expect(1, 119679, '\p{_ in_Counting_rod}', "");
    Expect(0, 119679, '\p{^_ in_Counting_rod}', "");
    Expect(0, 119679, '\P{_ in_Counting_rod}', "");
    Expect(1, 119679, '\P{^_ in_Counting_rod}', "");
    Expect(0, 119680, '\p{_ in_Counting_rod}', "");
    Expect(1, 119680, '\p{^_ in_Counting_rod}', "");
    Expect(1, 119680, '\P{_ in_Counting_rod}', "");
    Expect(0, 119680, '\P{^_ in_Counting_rod}', "");
    Error('\p{/a/	cuneiform}');
    Error('\P{/a/	cuneiform}');
    Expect(1, 75075, '\p{cuneiform}', "");
    Expect(0, 75075, '\p{^cuneiform}', "");
    Expect(0, 75075, '\P{cuneiform}', "");
    Expect(1, 75075, '\P{^cuneiform}', "");
    Expect(0, 75076, '\p{cuneiform}', "");
    Expect(1, 75076, '\p{^cuneiform}', "");
    Expect(1, 75076, '\P{cuneiform}', "");
    Expect(0, 75076, '\P{^cuneiform}', "");
    Expect(1, 75075, '\p{_	CUNEIFORM}', "");
    Expect(0, 75075, '\p{^_	CUNEIFORM}', "");
    Expect(0, 75075, '\P{_	CUNEIFORM}', "");
    Expect(1, 75075, '\P{^_	CUNEIFORM}', "");
    Expect(0, 75076, '\p{_	CUNEIFORM}', "");
    Expect(1, 75076, '\p{^_	CUNEIFORM}', "");
    Expect(1, 75076, '\P{_	CUNEIFORM}', "");
    Expect(0, 75076, '\P{^_	CUNEIFORM}', "");
    Error('\p{Is_Cuneiform:=}');
    Error('\P{Is_Cuneiform:=}');
    Expect(1, 75075, '\p{iscuneiform}', "");
    Expect(0, 75075, '\p{^iscuneiform}', "");
    Expect(0, 75075, '\P{iscuneiform}', "");
    Expect(1, 75075, '\P{^iscuneiform}', "");
    Expect(0, 75076, '\p{iscuneiform}', "");
    Expect(1, 75076, '\p{^iscuneiform}', "");
    Expect(1, 75076, '\P{iscuneiform}', "");
    Expect(0, 75076, '\P{^iscuneiform}', "");
    Expect(1, 75075, '\p{__IS_Cuneiform}', "");
    Expect(0, 75075, '\p{^__IS_Cuneiform}', "");
    Expect(0, 75075, '\P{__IS_Cuneiform}', "");
    Expect(1, 75075, '\P{^__IS_Cuneiform}', "");
    Expect(0, 75076, '\p{__IS_Cuneiform}', "");
    Expect(1, 75076, '\p{^__IS_Cuneiform}', "");
    Expect(1, 75076, '\P{__IS_Cuneiform}', "");
    Expect(0, 75076, '\P{^__IS_Cuneiform}', "");
    Error('\p{:=xsux}');
    Error('\P{:=xsux}');
    Expect(1, 75075, '\p{xsux}', "");
    Expect(0, 75075, '\p{^xsux}', "");
    Expect(0, 75075, '\P{xsux}', "");
    Expect(1, 75075, '\P{^xsux}', "");
    Expect(0, 75076, '\p{xsux}', "");
    Expect(1, 75076, '\p{^xsux}', "");
    Expect(1, 75076, '\P{xsux}', "");
    Expect(0, 75076, '\P{^xsux}', "");
    Expect(1, 75075, '\p{	Xsux}', "");
    Expect(0, 75075, '\p{^	Xsux}', "");
    Expect(0, 75075, '\P{	Xsux}', "");
    Expect(1, 75075, '\P{^	Xsux}', "");
    Expect(0, 75076, '\p{	Xsux}', "");
    Expect(1, 75076, '\p{^	Xsux}', "");
    Expect(1, 75076, '\P{	Xsux}', "");
    Expect(0, 75076, '\P{^	Xsux}', "");
    Error('\p{		Is_xsux:=}');
    Error('\P{		Is_xsux:=}');
    Expect(1, 75075, '\p{isxsux}', "");
    Expect(0, 75075, '\p{^isxsux}', "");
    Expect(0, 75075, '\P{isxsux}', "");
    Expect(1, 75075, '\P{^isxsux}', "");
    Expect(0, 75076, '\p{isxsux}', "");
    Expect(1, 75076, '\p{^isxsux}', "");
    Expect(1, 75076, '\P{isxsux}', "");
    Expect(0, 75076, '\P{^isxsux}', "");
    Expect(1, 75075, '\p{-IS_Xsux}', "");
    Expect(0, 75075, '\p{^-IS_Xsux}', "");
    Expect(0, 75075, '\P{-IS_Xsux}', "");
    Expect(1, 75075, '\P{^-IS_Xsux}', "");
    Expect(0, 75076, '\p{-IS_Xsux}', "");
    Expect(1, 75076, '\p{^-IS_Xsux}', "");
    Expect(1, 75076, '\P{-IS_Xsux}', "");
    Expect(0, 75076, '\P{^-IS_Xsux}', "");
    Error('\p{:= _cuneiform_numbers_AND_punctuation}');
    Error('\P{:= _cuneiform_numbers_AND_punctuation}');
    Expect(1, 74879, '\p{cuneiformnumbersandpunctuation}', "");
    Expect(0, 74879, '\p{^cuneiformnumbersandpunctuation}', "");
    Expect(0, 74879, '\P{cuneiformnumbersandpunctuation}', "");
    Expect(1, 74879, '\P{^cuneiformnumbersandpunctuation}', "");
    Expect(0, 74880, '\p{cuneiformnumbersandpunctuation}', "");
    Expect(1, 74880, '\p{^cuneiformnumbersandpunctuation}', "");
    Expect(1, 74880, '\P{cuneiformnumbersandpunctuation}', "");
    Expect(0, 74880, '\P{^cuneiformnumbersandpunctuation}', "");
    Expect(1, 74879, '\p{_	Cuneiform_Numbers_and_Punctuation}', "");
    Expect(0, 74879, '\p{^_	Cuneiform_Numbers_and_Punctuation}', "");
    Expect(0, 74879, '\P{_	Cuneiform_Numbers_and_Punctuation}', "");
    Expect(1, 74879, '\P{^_	Cuneiform_Numbers_and_Punctuation}', "");
    Expect(0, 74880, '\p{_	Cuneiform_Numbers_and_Punctuation}', "");
    Expect(1, 74880, '\p{^_	Cuneiform_Numbers_and_Punctuation}', "");
    Expect(1, 74880, '\P{_	Cuneiform_Numbers_and_Punctuation}', "");
    Expect(0, 74880, '\P{^_	Cuneiform_Numbers_and_Punctuation}', "");
    Error('\p{/a/- Is_CUNEIFORM_Numbers_And_PUNCTUATION}');
    Error('\P{/a/- Is_CUNEIFORM_Numbers_And_PUNCTUATION}');
    Expect(1, 74879, '\p{iscuneiformnumbersandpunctuation}', "");
    Expect(0, 74879, '\p{^iscuneiformnumbersandpunctuation}', "");
    Expect(0, 74879, '\P{iscuneiformnumbersandpunctuation}', "");
    Expect(1, 74879, '\P{^iscuneiformnumbersandpunctuation}', "");
    Expect(0, 74880, '\p{iscuneiformnumbersandpunctuation}', "");
    Expect(1, 74880, '\p{^iscuneiformnumbersandpunctuation}', "");
    Expect(1, 74880, '\P{iscuneiformnumbersandpunctuation}', "");
    Expect(0, 74880, '\P{^iscuneiformnumbersandpunctuation}', "");
    Expect(1, 74879, '\p{		is_Cuneiform_Numbers_and_PUNCTUATION}', "");
    Expect(0, 74879, '\p{^		is_Cuneiform_Numbers_and_PUNCTUATION}', "");
    Expect(0, 74879, '\P{		is_Cuneiform_Numbers_and_PUNCTUATION}', "");
    Expect(1, 74879, '\P{^		is_Cuneiform_Numbers_and_PUNCTUATION}', "");
    Expect(0, 74880, '\p{		is_Cuneiform_Numbers_and_PUNCTUATION}', "");
    Expect(1, 74880, '\p{^		is_Cuneiform_Numbers_and_PUNCTUATION}', "");
    Expect(1, 74880, '\P{		is_Cuneiform_Numbers_and_PUNCTUATION}', "");
    Expect(0, 74880, '\P{^		is_Cuneiform_Numbers_and_PUNCTUATION}', "");
    Error('\p{ _IN_CUNEIFORM_Numbers_And_PUNCTUATION:=}');
    Error('\P{ _IN_CUNEIFORM_Numbers_And_PUNCTUATION:=}');
    Expect(1, 74879, '\p{incuneiformnumbersandpunctuation}', "");
    Expect(0, 74879, '\p{^incuneiformnumbersandpunctuation}', "");
    Expect(0, 74879, '\P{incuneiformnumbersandpunctuation}', "");
    Expect(1, 74879, '\P{^incuneiformnumbersandpunctuation}', "");
    Expect(0, 74880, '\p{incuneiformnumbersandpunctuation}', "");
    Expect(1, 74880, '\p{^incuneiformnumbersandpunctuation}', "");
    Expect(1, 74880, '\P{incuneiformnumbersandpunctuation}', "");
    Expect(0, 74880, '\P{^incuneiformnumbersandpunctuation}', "");
    Expect(1, 74879, '\p{	-In_CUNEIFORM_NUMBERS_And_PUNCTUATION}', "");
    Expect(0, 74879, '\p{^	-In_CUNEIFORM_NUMBERS_And_PUNCTUATION}', "");
    Expect(0, 74879, '\P{	-In_CUNEIFORM_NUMBERS_And_PUNCTUATION}', "");
    Expect(1, 74879, '\P{^	-In_CUNEIFORM_NUMBERS_And_PUNCTUATION}', "");
    Expect(0, 74880, '\p{	-In_CUNEIFORM_NUMBERS_And_PUNCTUATION}', "");
    Expect(1, 74880, '\p{^	-In_CUNEIFORM_NUMBERS_And_PUNCTUATION}', "");
    Expect(1, 74880, '\P{	-In_CUNEIFORM_NUMBERS_And_PUNCTUATION}', "");
    Expect(0, 74880, '\P{^	-In_CUNEIFORM_NUMBERS_And_PUNCTUATION}', "");
    Error('\p{		cuneiform_numbers:=}');
    Error('\P{		cuneiform_numbers:=}');
    Expect(1, 74879, '\p{cuneiformnumbers}', "");
    Expect(0, 74879, '\p{^cuneiformnumbers}', "");
    Expect(0, 74879, '\P{cuneiformnumbers}', "");
    Expect(1, 74879, '\P{^cuneiformnumbers}', "");
    Expect(0, 74880, '\p{cuneiformnumbers}', "");
    Expect(1, 74880, '\p{^cuneiformnumbers}', "");
    Expect(1, 74880, '\P{cuneiformnumbers}', "");
    Expect(0, 74880, '\P{^cuneiformnumbers}', "");
    Expect(1, 74879, '\p{		cuneiform_numbers}', "");
    Expect(0, 74879, '\p{^		cuneiform_numbers}', "");
    Expect(0, 74879, '\P{		cuneiform_numbers}', "");
    Expect(1, 74879, '\P{^		cuneiform_numbers}', "");
    Expect(0, 74880, '\p{		cuneiform_numbers}', "");
    Expect(1, 74880, '\p{^		cuneiform_numbers}', "");
    Expect(1, 74880, '\P{		cuneiform_numbers}', "");
    Expect(0, 74880, '\P{^		cuneiform_numbers}', "");
    Error('\p{:= _is_Cuneiform_Numbers}');
    Error('\P{:= _is_Cuneiform_Numbers}');
    Expect(1, 74879, '\p{iscuneiformnumbers}', "");
    Expect(0, 74879, '\p{^iscuneiformnumbers}', "");
    Expect(0, 74879, '\P{iscuneiformnumbers}', "");
    Expect(1, 74879, '\P{^iscuneiformnumbers}', "");
    Expect(0, 74880, '\p{iscuneiformnumbers}', "");
    Expect(1, 74880, '\p{^iscuneiformnumbers}', "");
    Expect(1, 74880, '\P{iscuneiformnumbers}', "");
    Expect(0, 74880, '\P{^iscuneiformnumbers}', "");
    Expect(1, 74879, '\p{_ Is_Cuneiform_Numbers}', "");
    Expect(0, 74879, '\p{^_ Is_Cuneiform_Numbers}', "");
    Expect(0, 74879, '\P{_ Is_Cuneiform_Numbers}', "");
    Expect(1, 74879, '\P{^_ Is_Cuneiform_Numbers}', "");
    Expect(0, 74880, '\p{_ Is_Cuneiform_Numbers}', "");
    Expect(1, 74880, '\p{^_ Is_Cuneiform_Numbers}', "");
    Expect(1, 74880, '\P{_ Is_Cuneiform_Numbers}', "");
    Expect(0, 74880, '\P{^_ Is_Cuneiform_Numbers}', "");
    Error('\p{/a/ _in_cuneiform_numbers}');
    Error('\P{/a/ _in_cuneiform_numbers}');
    Expect(1, 74879, '\p{incuneiformnumbers}', "");
    Expect(0, 74879, '\p{^incuneiformnumbers}', "");
    Expect(0, 74879, '\P{incuneiformnumbers}', "");
    Expect(1, 74879, '\P{^incuneiformnumbers}', "");
    Expect(0, 74880, '\p{incuneiformnumbers}', "");
    Expect(1, 74880, '\p{^incuneiformnumbers}', "");
    Expect(1, 74880, '\P{incuneiformnumbers}', "");
    Expect(0, 74880, '\P{^incuneiformnumbers}', "");
    Expect(1, 74879, '\p{	-In_cuneiform_NUMBERS}', "");
    Expect(0, 74879, '\p{^	-In_cuneiform_NUMBERS}', "");
    Expect(0, 74879, '\P{	-In_cuneiform_NUMBERS}', "");
    Expect(1, 74879, '\P{^	-In_cuneiform_NUMBERS}', "");
    Expect(0, 74880, '\p{	-In_cuneiform_NUMBERS}', "");
    Expect(1, 74880, '\p{^	-In_cuneiform_NUMBERS}', "");
    Expect(1, 74880, '\P{	-In_cuneiform_NUMBERS}', "");
    Expect(0, 74880, '\P{^	-In_cuneiform_NUMBERS}', "");
    Error('\p{-:=CURRENCY_Symbol}');
    Error('\P{-:=CURRENCY_Symbol}');
    Expect(1, 126128, '\p{currencysymbol}', "");
    Expect(0, 126128, '\p{^currencysymbol}', "");
    Expect(0, 126128, '\P{currencysymbol}', "");
    Expect(1, 126128, '\P{^currencysymbol}', "");
    Expect(0, 126129, '\p{currencysymbol}', "");
    Expect(1, 126129, '\p{^currencysymbol}', "");
    Expect(1, 126129, '\P{currencysymbol}', "");
    Expect(0, 126129, '\P{^currencysymbol}', "");
    Expect(1, 126128, '\p{  CURRENCY_Symbol}', "");
    Expect(0, 126128, '\p{^  CURRENCY_Symbol}', "");
    Expect(0, 126128, '\P{  CURRENCY_Symbol}', "");
    Expect(1, 126128, '\P{^  CURRENCY_Symbol}', "");
    Expect(0, 126129, '\p{  CURRENCY_Symbol}', "");
    Expect(1, 126129, '\p{^  CURRENCY_Symbol}', "");
    Expect(1, 126129, '\P{  CURRENCY_Symbol}', "");
    Expect(0, 126129, '\P{^  CURRENCY_Symbol}', "");
    Error('\p{	/a/is_CURRENCY_Symbol}');
    Error('\P{	/a/is_CURRENCY_Symbol}');
    Expect(1, 126128, '\p{iscurrencysymbol}', "");
    Expect(0, 126128, '\p{^iscurrencysymbol}', "");
    Expect(0, 126128, '\P{iscurrencysymbol}', "");
    Expect(1, 126128, '\P{^iscurrencysymbol}', "");
    Expect(0, 126129, '\p{iscurrencysymbol}', "");
    Expect(1, 126129, '\p{^iscurrencysymbol}', "");
    Expect(1, 126129, '\P{iscurrencysymbol}', "");
    Expect(0, 126129, '\P{^iscurrencysymbol}', "");
    Expect(1, 126128, '\p{	IS_CURRENCY_Symbol}', "");
    Expect(0, 126128, '\p{^	IS_CURRENCY_Symbol}', "");
    Expect(0, 126128, '\P{	IS_CURRENCY_Symbol}', "");
    Expect(1, 126128, '\P{^	IS_CURRENCY_Symbol}', "");
    Expect(0, 126129, '\p{	IS_CURRENCY_Symbol}', "");
    Expect(1, 126129, '\p{^	IS_CURRENCY_Symbol}', "");
    Expect(1, 126129, '\P{	IS_CURRENCY_Symbol}', "");
    Expect(0, 126129, '\P{^	IS_CURRENCY_Symbol}', "");
    Error('\p{-:=Sc}');
    Error('\P{-:=Sc}');
    Expect(1, 126128, '\p{sc}', "");
    Expect(0, 126128, '\p{^sc}', "");
    Expect(0, 126128, '\P{sc}', "");
    Expect(1, 126128, '\P{^sc}', "");
    Expect(0, 126129, '\p{sc}', "");
    Expect(1, 126129, '\p{^sc}', "");
    Expect(1, 126129, '\P{sc}', "");
    Expect(0, 126129, '\P{^sc}', "");
    Expect(1, 126128, '\p{  Sc}', "");
    Expect(0, 126128, '\p{^  Sc}', "");
    Expect(0, 126128, '\P{  Sc}', "");
    Expect(1, 126128, '\P{^  Sc}', "");
    Expect(0, 126129, '\p{  Sc}', "");
    Expect(1, 126129, '\p{^  Sc}', "");
    Expect(1, 126129, '\P{  Sc}', "");
    Expect(0, 126129, '\P{^  Sc}', "");
    Error('\p{_:=Is_Sc}');
    Error('\P{_:=Is_Sc}');
    Expect(1, 126128, '\p{issc}', "");
    Expect(0, 126128, '\p{^issc}', "");
    Expect(0, 126128, '\P{issc}', "");
    Expect(1, 126128, '\P{^issc}', "");
    Expect(0, 126129, '\p{issc}', "");
    Expect(1, 126129, '\p{^issc}', "");
    Expect(1, 126129, '\P{issc}', "");
    Expect(0, 126129, '\P{^issc}', "");
    Expect(1, 126128, '\p{_IS_Sc}', "");
    Expect(0, 126128, '\p{^_IS_Sc}', "");
    Expect(0, 126128, '\P{_IS_Sc}', "");
    Expect(1, 126128, '\P{^_IS_Sc}', "");
    Expect(0, 126129, '\p{_IS_Sc}', "");
    Expect(1, 126129, '\p{^_IS_Sc}', "");
    Expect(1, 126129, '\P{_IS_Sc}', "");
    Expect(0, 126129, '\P{^_IS_Sc}', "");
    Error('\p{_-currency_Symbols/a/}');
    Error('\P{_-currency_Symbols/a/}');
    Expect(1, 8399, '\p{currencysymbols}', "");
    Expect(0, 8399, '\p{^currencysymbols}', "");
    Expect(0, 8399, '\P{currencysymbols}', "");
    Expect(1, 8399, '\P{^currencysymbols}', "");
    Expect(0, 8400, '\p{currencysymbols}', "");
    Expect(1, 8400, '\p{^currencysymbols}', "");
    Expect(1, 8400, '\P{currencysymbols}', "");
    Expect(0, 8400, '\P{^currencysymbols}', "");
    Expect(1, 8399, '\p{	currency_SYMBOLS}', "");
    Expect(0, 8399, '\p{^	currency_SYMBOLS}', "");
    Expect(0, 8399, '\P{	currency_SYMBOLS}', "");
    Expect(1, 8399, '\P{^	currency_SYMBOLS}', "");
    Expect(0, 8400, '\p{	currency_SYMBOLS}', "");
    Expect(1, 8400, '\p{^	currency_SYMBOLS}', "");
    Expect(1, 8400, '\P{	currency_SYMBOLS}', "");
    Expect(0, 8400, '\P{^	currency_SYMBOLS}', "");
    Error('\p{ 	IS_Currency_SYMBOLS/a/}');
    Error('\P{ 	IS_Currency_SYMBOLS/a/}');
    Expect(1, 8399, '\p{iscurrencysymbols}', "");
    Expect(0, 8399, '\p{^iscurrencysymbols}', "");
    Expect(0, 8399, '\P{iscurrencysymbols}', "");
    Expect(1, 8399, '\P{^iscurrencysymbols}', "");
    Expect(0, 8400, '\p{iscurrencysymbols}', "");
    Expect(1, 8400, '\p{^iscurrencysymbols}', "");
    Expect(1, 8400, '\P{iscurrencysymbols}', "");
    Expect(0, 8400, '\P{^iscurrencysymbols}', "");
    Expect(1, 8399, '\p{	Is_Currency_Symbols}', "");
    Expect(0, 8399, '\p{^	Is_Currency_Symbols}', "");
    Expect(0, 8399, '\P{	Is_Currency_Symbols}', "");
    Expect(1, 8399, '\P{^	Is_Currency_Symbols}', "");
    Expect(0, 8400, '\p{	Is_Currency_Symbols}', "");
    Expect(1, 8400, '\p{^	Is_Currency_Symbols}', "");
    Expect(1, 8400, '\P{	Is_Currency_Symbols}', "");
    Expect(0, 8400, '\P{^	Is_Currency_Symbols}', "");
    Error('\p{ In_Currency_Symbols/a/}');
    Error('\P{ In_Currency_Symbols/a/}');
    Expect(1, 8399, '\p{incurrencysymbols}', "");
    Expect(0, 8399, '\p{^incurrencysymbols}', "");
    Expect(0, 8399, '\P{incurrencysymbols}', "");
    Expect(1, 8399, '\P{^incurrencysymbols}', "");
    Expect(0, 8400, '\p{incurrencysymbols}', "");
    Expect(1, 8400, '\p{^incurrencysymbols}', "");
    Expect(1, 8400, '\P{incurrencysymbols}', "");
    Expect(0, 8400, '\P{^incurrencysymbols}', "");
    Expect(1, 8399, '\p{	In_Currency_symbols}', "");
    Expect(0, 8399, '\p{^	In_Currency_symbols}', "");
    Expect(0, 8399, '\P{	In_Currency_symbols}', "");
    Expect(1, 8399, '\P{^	In_Currency_symbols}', "");
    Expect(0, 8400, '\p{	In_Currency_symbols}', "");
    Expect(1, 8400, '\p{^	In_Currency_symbols}', "");
    Expect(1, 8400, '\P{	In_Currency_symbols}', "");
    Expect(0, 8400, '\P{^	In_Currency_symbols}', "");
    Error('\p{:= _cypriot}');
    Error('\P{:= _cypriot}');
    Expect(1, 67647, '\p{cypriot}', "");
    Expect(0, 67647, '\p{^cypriot}', "");
    Expect(0, 67647, '\P{cypriot}', "");
    Expect(1, 67647, '\P{^cypriot}', "");
    Expect(0, 67648, '\p{cypriot}', "");
    Expect(1, 67648, '\p{^cypriot}', "");
    Expect(1, 67648, '\P{cypriot}', "");
    Expect(0, 67648, '\P{^cypriot}', "");
    Expect(1, 67647, '\p{- CYPRIOT}', "");
    Expect(0, 67647, '\p{^- CYPRIOT}', "");
    Expect(0, 67647, '\P{- CYPRIOT}', "");
    Expect(1, 67647, '\P{^- CYPRIOT}', "");
    Expect(0, 67648, '\p{- CYPRIOT}', "");
    Expect(1, 67648, '\p{^- CYPRIOT}', "");
    Expect(1, 67648, '\P{- CYPRIOT}', "");
    Expect(0, 67648, '\P{^- CYPRIOT}', "");
    Error('\p{_	IS_Cypriot/a/}');
    Error('\P{_	IS_Cypriot/a/}');
    Expect(1, 67647, '\p{iscypriot}', "");
    Expect(0, 67647, '\p{^iscypriot}', "");
    Expect(0, 67647, '\P{iscypriot}', "");
    Expect(1, 67647, '\P{^iscypriot}', "");
    Expect(0, 67648, '\p{iscypriot}', "");
    Expect(1, 67648, '\p{^iscypriot}', "");
    Expect(1, 67648, '\P{iscypriot}', "");
    Expect(0, 67648, '\P{^iscypriot}', "");
    Expect(1, 67647, '\p{__Is_cypriot}', "");
    Expect(0, 67647, '\p{^__Is_cypriot}', "");
    Expect(0, 67647, '\P{__Is_cypriot}', "");
    Expect(1, 67647, '\P{^__Is_cypriot}', "");
    Expect(0, 67648, '\p{__Is_cypriot}', "");
    Expect(1, 67648, '\p{^__Is_cypriot}', "");
    Expect(1, 67648, '\P{__Is_cypriot}', "");
    Expect(0, 67648, '\P{^__Is_cypriot}', "");
    Error('\p{- Cprt:=}');
    Error('\P{- Cprt:=}');
    Expect(1, 67647, '\p{cprt}', "");
    Expect(0, 67647, '\p{^cprt}', "");
    Expect(0, 67647, '\P{cprt}', "");
    Expect(1, 67647, '\P{^cprt}', "");
    Expect(0, 67648, '\p{cprt}', "");
    Expect(1, 67648, '\p{^cprt}', "");
    Expect(1, 67648, '\P{cprt}', "");
    Expect(0, 67648, '\P{^cprt}', "");
    Expect(1, 67647, '\p{-Cprt}', "");
    Expect(0, 67647, '\p{^-Cprt}', "");
    Expect(0, 67647, '\P{-Cprt}', "");
    Expect(1, 67647, '\P{^-Cprt}', "");
    Expect(0, 67648, '\p{-Cprt}', "");
    Expect(1, 67648, '\p{^-Cprt}', "");
    Expect(1, 67648, '\P{-Cprt}', "");
    Expect(0, 67648, '\P{^-Cprt}', "");
    Error('\p{  IS_CPRT:=}');
    Error('\P{  IS_CPRT:=}');
    Expect(1, 67647, '\p{iscprt}', "");
    Expect(0, 67647, '\p{^iscprt}', "");
    Expect(0, 67647, '\P{iscprt}', "");
    Expect(1, 67647, '\P{^iscprt}', "");
    Expect(0, 67648, '\p{iscprt}', "");
    Expect(1, 67648, '\p{^iscprt}', "");
    Expect(1, 67648, '\P{iscprt}', "");
    Expect(0, 67648, '\P{^iscprt}', "");
    Expect(1, 67647, '\p{ 	IS_CPRT}', "");
    Expect(0, 67647, '\p{^ 	IS_CPRT}', "");
    Expect(0, 67647, '\P{ 	IS_CPRT}', "");
    Expect(1, 67647, '\P{^ 	IS_CPRT}', "");
    Expect(0, 67648, '\p{ 	IS_CPRT}', "");
    Expect(1, 67648, '\p{^ 	IS_CPRT}', "");
    Expect(1, 67648, '\P{ 	IS_CPRT}', "");
    Expect(0, 67648, '\P{^ 	IS_CPRT}', "");
    Error('\p{	:=cypriot_syllabary}');
    Error('\P{	:=cypriot_syllabary}');
    Expect(1, 67647, '\p{cypriotsyllabary}', "");
    Expect(0, 67647, '\p{^cypriotsyllabary}', "");
    Expect(0, 67647, '\P{cypriotsyllabary}', "");
    Expect(1, 67647, '\P{^cypriotsyllabary}', "");
    Expect(0, 67648, '\p{cypriotsyllabary}', "");
    Expect(1, 67648, '\p{^cypriotsyllabary}', "");
    Expect(1, 67648, '\P{cypriotsyllabary}', "");
    Expect(0, 67648, '\P{^cypriotsyllabary}', "");
    Expect(1, 67647, '\p{ 	CYPRIOT_Syllabary}', "");
    Expect(0, 67647, '\p{^ 	CYPRIOT_Syllabary}', "");
    Expect(0, 67647, '\P{ 	CYPRIOT_Syllabary}', "");
    Expect(1, 67647, '\P{^ 	CYPRIOT_Syllabary}', "");
    Expect(0, 67648, '\p{ 	CYPRIOT_Syllabary}', "");
    Expect(1, 67648, '\p{^ 	CYPRIOT_Syllabary}', "");
    Expect(1, 67648, '\P{ 	CYPRIOT_Syllabary}', "");
    Expect(0, 67648, '\P{^ 	CYPRIOT_Syllabary}', "");
    Error('\p{:=	_Is_CYPRIOT_Syllabary}');
    Error('\P{:=	_Is_CYPRIOT_Syllabary}');
    Expect(1, 67647, '\p{iscypriotsyllabary}', "");
    Expect(0, 67647, '\p{^iscypriotsyllabary}', "");
    Expect(0, 67647, '\P{iscypriotsyllabary}', "");
    Expect(1, 67647, '\P{^iscypriotsyllabary}', "");
    Expect(0, 67648, '\p{iscypriotsyllabary}', "");
    Expect(1, 67648, '\p{^iscypriotsyllabary}', "");
    Expect(1, 67648, '\P{iscypriotsyllabary}', "");
    Expect(0, 67648, '\P{^iscypriotsyllabary}', "");
    Expect(1, 67647, '\p{-_Is_Cypriot_SYLLABARY}', "");
    Expect(0, 67647, '\p{^-_Is_Cypriot_SYLLABARY}', "");
    Expect(0, 67647, '\P{-_Is_Cypriot_SYLLABARY}', "");
    Expect(1, 67647, '\P{^-_Is_Cypriot_SYLLABARY}', "");
    Expect(0, 67648, '\p{-_Is_Cypriot_SYLLABARY}', "");
    Expect(1, 67648, '\p{^-_Is_Cypriot_SYLLABARY}', "");
    Expect(1, 67648, '\P{-_Is_Cypriot_SYLLABARY}', "");
    Expect(0, 67648, '\P{^-_Is_Cypriot_SYLLABARY}', "");
    Error('\p{_ In_cypriot_Syllabary:=}');
    Error('\P{_ In_cypriot_Syllabary:=}');
    Expect(1, 67647, '\p{incypriotsyllabary}', "");
    Expect(0, 67647, '\p{^incypriotsyllabary}', "");
    Expect(0, 67647, '\P{incypriotsyllabary}', "");
    Expect(1, 67647, '\P{^incypriotsyllabary}', "");
    Expect(0, 67648, '\p{incypriotsyllabary}', "");
    Expect(1, 67648, '\p{^incypriotsyllabary}', "");
    Expect(1, 67648, '\P{incypriotsyllabary}', "");
    Expect(0, 67648, '\P{^incypriotsyllabary}', "");
    Expect(1, 67647, '\p{	In_Cypriot_SYLLABARY}', "");
    Expect(0, 67647, '\p{^	In_Cypriot_SYLLABARY}', "");
    Expect(0, 67647, '\P{	In_Cypriot_SYLLABARY}', "");
    Expect(1, 67647, '\P{^	In_Cypriot_SYLLABARY}', "");
    Expect(0, 67648, '\p{	In_Cypriot_SYLLABARY}', "");
    Expect(1, 67648, '\p{^	In_Cypriot_SYLLABARY}', "");
    Expect(1, 67648, '\P{	In_Cypriot_SYLLABARY}', "");
    Expect(0, 67648, '\P{^	In_Cypriot_SYLLABARY}', "");
    Error('\p{/a/ -Cyrillic}');
    Error('\P{/a/ -Cyrillic}');
    Expect(1, 65071, '\p{cyrillic}', "");
    Expect(0, 65071, '\p{^cyrillic}', "");
    Expect(0, 65071, '\P{cyrillic}', "");
    Expect(1, 65071, '\P{^cyrillic}', "");
    Expect(0, 65072, '\p{cyrillic}', "");
    Expect(1, 65072, '\p{^cyrillic}', "");
    Expect(1, 65072, '\P{cyrillic}', "");
    Expect(0, 65072, '\P{^cyrillic}', "");
    Expect(1, 65071, '\p{-Cyrillic}', "");
    Expect(0, 65071, '\p{^-Cyrillic}', "");
    Expect(0, 65071, '\P{-Cyrillic}', "");
    Expect(1, 65071, '\P{^-Cyrillic}', "");
    Expect(0, 65072, '\p{-Cyrillic}', "");
    Expect(1, 65072, '\p{^-Cyrillic}', "");
    Expect(1, 65072, '\P{-Cyrillic}', "");
    Expect(0, 65072, '\P{^-Cyrillic}', "");
    Error('\p{-:=Is_Cyrillic}');
    Error('\P{-:=Is_Cyrillic}');
    Expect(1, 65071, '\p{iscyrillic}', "");
    Expect(0, 65071, '\p{^iscyrillic}', "");
    Expect(0, 65071, '\P{iscyrillic}', "");
    Expect(1, 65071, '\P{^iscyrillic}', "");
    Expect(0, 65072, '\p{iscyrillic}', "");
    Expect(1, 65072, '\p{^iscyrillic}', "");
    Expect(1, 65072, '\P{iscyrillic}', "");
    Expect(0, 65072, '\P{^iscyrillic}', "");
    Expect(1, 65071, '\p{ -IS_Cyrillic}', "");
    Expect(0, 65071, '\p{^ -IS_Cyrillic}', "");
    Expect(0, 65071, '\P{ -IS_Cyrillic}', "");
    Expect(1, 65071, '\P{^ -IS_Cyrillic}', "");
    Expect(0, 65072, '\p{ -IS_Cyrillic}', "");
    Expect(1, 65072, '\p{^ -IS_Cyrillic}', "");
    Expect(1, 65072, '\P{ -IS_Cyrillic}', "");
    Expect(0, 65072, '\P{^ -IS_Cyrillic}', "");
    Error('\p{_/a/CYRL}');
    Error('\P{_/a/CYRL}');
    Expect(1, 65071, '\p{cyrl}', "");
    Expect(0, 65071, '\p{^cyrl}', "");
    Expect(0, 65071, '\P{cyrl}', "");
    Expect(1, 65071, '\P{^cyrl}', "");
    Expect(0, 65072, '\p{cyrl}', "");
    Expect(1, 65072, '\p{^cyrl}', "");
    Expect(1, 65072, '\P{cyrl}', "");
    Expect(0, 65072, '\P{^cyrl}', "");
    Expect(1, 65071, '\p{_	CYRL}', "");
    Expect(0, 65071, '\p{^_	CYRL}', "");
    Expect(0, 65071, '\P{_	CYRL}', "");
    Expect(1, 65071, '\P{^_	CYRL}', "");
    Expect(0, 65072, '\p{_	CYRL}', "");
    Expect(1, 65072, '\p{^_	CYRL}', "");
    Expect(1, 65072, '\P{_	CYRL}', "");
    Expect(0, 65072, '\P{^_	CYRL}', "");
    Error('\p{-/a/is_CYRL}');
    Error('\P{-/a/is_CYRL}');
    Expect(1, 65071, '\p{iscyrl}', "");
    Expect(0, 65071, '\p{^iscyrl}', "");
    Expect(0, 65071, '\P{iscyrl}', "");
    Expect(1, 65071, '\P{^iscyrl}', "");
    Expect(0, 65072, '\p{iscyrl}', "");
    Expect(1, 65072, '\p{^iscyrl}', "");
    Expect(1, 65072, '\P{iscyrl}', "");
    Expect(0, 65072, '\P{^iscyrl}', "");
    Expect(1, 65071, '\p{	Is_Cyrl}', "");
    Expect(0, 65071, '\p{^	Is_Cyrl}', "");
    Expect(0, 65071, '\P{	Is_Cyrl}', "");
    Expect(1, 65071, '\P{^	Is_Cyrl}', "");
    Expect(0, 65072, '\p{	Is_Cyrl}', "");
    Expect(1, 65072, '\p{^	Is_Cyrl}', "");
    Expect(1, 65072, '\P{	Is_Cyrl}', "");
    Expect(0, 65072, '\P{^	Is_Cyrl}', "");
    Error('\p{ -Cyrillic_Extended_A/a/}');
    Error('\P{ -Cyrillic_Extended_A/a/}');
    Expect(1, 11775, '\p{cyrillicextendeda}', "");
    Expect(0, 11775, '\p{^cyrillicextendeda}', "");
    Expect(0, 11775, '\P{cyrillicextendeda}', "");
    Expect(1, 11775, '\P{^cyrillicextendeda}', "");
    Expect(0, 11776, '\p{cyrillicextendeda}', "");
    Expect(1, 11776, '\p{^cyrillicextendeda}', "");
    Expect(1, 11776, '\P{cyrillicextendeda}', "");
    Expect(0, 11776, '\P{^cyrillicextendeda}', "");
    Expect(1, 11775, '\p{	 CYRILLIC_Extended_A}', "");
    Expect(0, 11775, '\p{^	 CYRILLIC_Extended_A}', "");
    Expect(0, 11775, '\P{	 CYRILLIC_Extended_A}', "");
    Expect(1, 11775, '\P{^	 CYRILLIC_Extended_A}', "");
    Expect(0, 11776, '\p{	 CYRILLIC_Extended_A}', "");
    Expect(1, 11776, '\p{^	 CYRILLIC_Extended_A}', "");
    Expect(1, 11776, '\P{	 CYRILLIC_Extended_A}', "");
    Expect(0, 11776, '\P{^	 CYRILLIC_Extended_A}', "");
    Error('\p{/a/Is_CYRILLIC_extended_A}');
    Error('\P{/a/Is_CYRILLIC_extended_A}');
    Expect(1, 11775, '\p{iscyrillicextendeda}', "");
    Expect(0, 11775, '\p{^iscyrillicextendeda}', "");
    Expect(0, 11775, '\P{iscyrillicextendeda}', "");
    Expect(1, 11775, '\P{^iscyrillicextendeda}', "");
    Expect(0, 11776, '\p{iscyrillicextendeda}', "");
    Expect(1, 11776, '\p{^iscyrillicextendeda}', "");
    Expect(1, 11776, '\P{iscyrillicextendeda}', "");
    Expect(0, 11776, '\P{^iscyrillicextendeda}', "");
    Expect(1, 11775, '\p{_-is_cyrillic_Extended_A}', "");
    Expect(0, 11775, '\p{^_-is_cyrillic_Extended_A}', "");
    Expect(0, 11775, '\P{_-is_cyrillic_Extended_A}', "");
    Expect(1, 11775, '\P{^_-is_cyrillic_Extended_A}', "");
    Expect(0, 11776, '\p{_-is_cyrillic_Extended_A}', "");
    Expect(1, 11776, '\p{^_-is_cyrillic_Extended_A}', "");
    Expect(1, 11776, '\P{_-is_cyrillic_Extended_A}', "");
    Expect(0, 11776, '\P{^_-is_cyrillic_Extended_A}', "");
    Error('\p{/a/	 in_cyrillic_extended_a}');
    Error('\P{/a/	 in_cyrillic_extended_a}');
    Expect(1, 11775, '\p{incyrillicextendeda}', "");
    Expect(0, 11775, '\p{^incyrillicextendeda}', "");
    Expect(0, 11775, '\P{incyrillicextendeda}', "");
    Expect(1, 11775, '\P{^incyrillicextendeda}', "");
    Expect(0, 11776, '\p{incyrillicextendeda}', "");
    Expect(1, 11776, '\p{^incyrillicextendeda}', "");
    Expect(1, 11776, '\P{incyrillicextendeda}', "");
    Expect(0, 11776, '\P{^incyrillicextendeda}', "");
    Expect(1, 11775, '\p{_In_Cyrillic_extended_A}', "");
    Expect(0, 11775, '\p{^_In_Cyrillic_extended_A}', "");
    Expect(0, 11775, '\P{_In_Cyrillic_extended_A}', "");
    Expect(1, 11775, '\P{^_In_Cyrillic_extended_A}', "");
    Expect(0, 11776, '\p{_In_Cyrillic_extended_A}', "");
    Expect(1, 11776, '\p{^_In_Cyrillic_extended_A}', "");
    Expect(1, 11776, '\P{_In_Cyrillic_extended_A}', "");
    Expect(0, 11776, '\P{^_In_Cyrillic_extended_A}', "");
    Error('\p{ 	Cyrillic_Ext_A:=}');
    Error('\P{ 	Cyrillic_Ext_A:=}');
    Expect(1, 11775, '\p{cyrillicexta}', "");
    Expect(0, 11775, '\p{^cyrillicexta}', "");
    Expect(0, 11775, '\P{cyrillicexta}', "");
    Expect(1, 11775, '\P{^cyrillicexta}', "");
    Expect(0, 11776, '\p{cyrillicexta}', "");
    Expect(1, 11776, '\p{^cyrillicexta}', "");
    Expect(1, 11776, '\P{cyrillicexta}', "");
    Expect(0, 11776, '\P{^cyrillicexta}', "");
    Expect(1, 11775, '\p{_ Cyrillic_Ext_A}', "");
    Expect(0, 11775, '\p{^_ Cyrillic_Ext_A}', "");
    Expect(0, 11775, '\P{_ Cyrillic_Ext_A}', "");
    Expect(1, 11775, '\P{^_ Cyrillic_Ext_A}', "");
    Expect(0, 11776, '\p{_ Cyrillic_Ext_A}', "");
    Expect(1, 11776, '\p{^_ Cyrillic_Ext_A}', "");
    Expect(1, 11776, '\P{_ Cyrillic_Ext_A}', "");
    Expect(0, 11776, '\P{^_ Cyrillic_Ext_A}', "");
    Error('\p{	/a/is_Cyrillic_ext_A}');
    Error('\P{	/a/is_Cyrillic_ext_A}');
    Expect(1, 11775, '\p{iscyrillicexta}', "");
    Expect(0, 11775, '\p{^iscyrillicexta}', "");
    Expect(0, 11775, '\P{iscyrillicexta}', "");
    Expect(1, 11775, '\P{^iscyrillicexta}', "");
    Expect(0, 11776, '\p{iscyrillicexta}', "");
    Expect(1, 11776, '\p{^iscyrillicexta}', "");
    Expect(1, 11776, '\P{iscyrillicexta}', "");
    Expect(0, 11776, '\P{^iscyrillicexta}', "");
    Expect(1, 11775, '\p{_ Is_Cyrillic_EXT_A}', "");
    Expect(0, 11775, '\p{^_ Is_Cyrillic_EXT_A}', "");
    Expect(0, 11775, '\P{_ Is_Cyrillic_EXT_A}', "");
    Expect(1, 11775, '\P{^_ Is_Cyrillic_EXT_A}', "");
    Expect(0, 11776, '\p{_ Is_Cyrillic_EXT_A}', "");
    Expect(1, 11776, '\p{^_ Is_Cyrillic_EXT_A}', "");
    Expect(1, 11776, '\P{_ Is_Cyrillic_EXT_A}', "");
    Expect(0, 11776, '\P{^_ Is_Cyrillic_EXT_A}', "");
    Error('\p{/a/_	in_CYRILLIC_ext_A}');
    Error('\P{/a/_	in_CYRILLIC_ext_A}');
    Expect(1, 11775, '\p{incyrillicexta}', "");
    Expect(0, 11775, '\p{^incyrillicexta}', "");
    Expect(0, 11775, '\P{incyrillicexta}', "");
    Expect(1, 11775, '\P{^incyrillicexta}', "");
    Expect(0, 11776, '\p{incyrillicexta}', "");
    Expect(1, 11776, '\p{^incyrillicexta}', "");
    Expect(1, 11776, '\P{incyrillicexta}', "");
    Expect(0, 11776, '\P{^incyrillicexta}', "");
    Expect(1, 11775, '\p{	 in_Cyrillic_EXT_A}', "");
    Expect(0, 11775, '\p{^	 in_Cyrillic_EXT_A}', "");
    Expect(0, 11775, '\P{	 in_Cyrillic_EXT_A}', "");
    Expect(1, 11775, '\P{^	 in_Cyrillic_EXT_A}', "");
    Expect(0, 11776, '\p{	 in_Cyrillic_EXT_A}', "");
    Expect(1, 11776, '\p{^	 in_Cyrillic_EXT_A}', "");
    Expect(1, 11776, '\P{	 in_Cyrillic_EXT_A}', "");
    Expect(0, 11776, '\P{^	 in_Cyrillic_EXT_A}', "");
    Error('\p{ /a/Cyrillic_Extended_B}');
    Error('\P{ /a/Cyrillic_Extended_B}');
    Expect(1, 42655, '\p{cyrillicextendedb}', "");
    Expect(0, 42655, '\p{^cyrillicextendedb}', "");
    Expect(0, 42655, '\P{cyrillicextendedb}', "");
    Expect(1, 42655, '\P{^cyrillicextendedb}', "");
    Expect(0, 42656, '\p{cyrillicextendedb}', "");
    Expect(1, 42656, '\p{^cyrillicextendedb}', "");
    Expect(1, 42656, '\P{cyrillicextendedb}', "");
    Expect(0, 42656, '\P{^cyrillicextendedb}', "");
    Expect(1, 42655, '\p{_ cyrillic_Extended_b}', "");
    Expect(0, 42655, '\p{^_ cyrillic_Extended_b}', "");
    Expect(0, 42655, '\P{_ cyrillic_Extended_b}', "");
    Expect(1, 42655, '\P{^_ cyrillic_Extended_b}', "");
    Expect(0, 42656, '\p{_ cyrillic_Extended_b}', "");
    Expect(1, 42656, '\p{^_ cyrillic_Extended_b}', "");
    Expect(1, 42656, '\P{_ cyrillic_Extended_b}', "");
    Expect(0, 42656, '\P{^_ cyrillic_Extended_b}', "");
    Error('\p{-:=Is_Cyrillic_Extended_b}');
    Error('\P{-:=Is_Cyrillic_Extended_b}');
    Expect(1, 42655, '\p{iscyrillicextendedb}', "");
    Expect(0, 42655, '\p{^iscyrillicextendedb}', "");
    Expect(0, 42655, '\P{iscyrillicextendedb}', "");
    Expect(1, 42655, '\P{^iscyrillicextendedb}', "");
    Expect(0, 42656, '\p{iscyrillicextendedb}', "");
    Expect(1, 42656, '\p{^iscyrillicextendedb}', "");
    Expect(1, 42656, '\P{iscyrillicextendedb}', "");
    Expect(0, 42656, '\P{^iscyrillicextendedb}', "");
    Expect(1, 42655, '\p{_Is_Cyrillic_Extended_b}', "");
    Expect(0, 42655, '\p{^_Is_Cyrillic_Extended_b}', "");
    Expect(0, 42655, '\P{_Is_Cyrillic_Extended_b}', "");
    Expect(1, 42655, '\P{^_Is_Cyrillic_Extended_b}', "");
    Expect(0, 42656, '\p{_Is_Cyrillic_Extended_b}', "");
    Expect(1, 42656, '\p{^_Is_Cyrillic_Extended_b}', "");
    Expect(1, 42656, '\P{_Is_Cyrillic_Extended_b}', "");
    Expect(0, 42656, '\P{^_Is_Cyrillic_Extended_b}', "");
    Error('\p{ 	in_cyrillic_Extended_B:=}');
    Error('\P{ 	in_cyrillic_Extended_B:=}');
    Expect(1, 42655, '\p{incyrillicextendedb}', "");
    Expect(0, 42655, '\p{^incyrillicextendedb}', "");
    Expect(0, 42655, '\P{incyrillicextendedb}', "");
    Expect(1, 42655, '\P{^incyrillicextendedb}', "");
    Expect(0, 42656, '\p{incyrillicextendedb}', "");
    Expect(1, 42656, '\p{^incyrillicextendedb}', "");
    Expect(1, 42656, '\P{incyrillicextendedb}', "");
    Expect(0, 42656, '\P{^incyrillicextendedb}', "");
    Expect(1, 42655, '\p{_-In_cyrillic_EXTENDED_B}', "");
    Expect(0, 42655, '\p{^_-In_cyrillic_EXTENDED_B}', "");
    Expect(0, 42655, '\P{_-In_cyrillic_EXTENDED_B}', "");
    Expect(1, 42655, '\P{^_-In_cyrillic_EXTENDED_B}', "");
    Expect(0, 42656, '\p{_-In_cyrillic_EXTENDED_B}', "");
    Expect(1, 42656, '\p{^_-In_cyrillic_EXTENDED_B}', "");
    Expect(1, 42656, '\P{_-In_cyrillic_EXTENDED_B}', "");
    Expect(0, 42656, '\P{^_-In_cyrillic_EXTENDED_B}', "");
    Error('\p{:= Cyrillic_Ext_b}');
    Error('\P{:= Cyrillic_Ext_b}');
    Expect(1, 42655, '\p{cyrillicextb}', "");
    Expect(0, 42655, '\p{^cyrillicextb}', "");
    Expect(0, 42655, '\P{cyrillicextb}', "");
    Expect(1, 42655, '\P{^cyrillicextb}', "");
    Expect(0, 42656, '\p{cyrillicextb}', "");
    Expect(1, 42656, '\p{^cyrillicextb}', "");
    Expect(1, 42656, '\P{cyrillicextb}', "");
    Expect(0, 42656, '\P{^cyrillicextb}', "");
    Expect(1, 42655, '\p{_cyrillic_EXT_B}', "");
    Expect(0, 42655, '\p{^_cyrillic_EXT_B}', "");
    Expect(0, 42655, '\P{_cyrillic_EXT_B}', "");
    Expect(1, 42655, '\P{^_cyrillic_EXT_B}', "");
    Expect(0, 42656, '\p{_cyrillic_EXT_B}', "");
    Expect(1, 42656, '\p{^_cyrillic_EXT_B}', "");
    Expect(1, 42656, '\P{_cyrillic_EXT_B}', "");
    Expect(0, 42656, '\P{^_cyrillic_EXT_B}', "");
    Error('\p{-/a/Is_Cyrillic_ext_B}');
    Error('\P{-/a/Is_Cyrillic_ext_B}');
    Expect(1, 42655, '\p{iscyrillicextb}', "");
    Expect(0, 42655, '\p{^iscyrillicextb}', "");
    Expect(0, 42655, '\P{iscyrillicextb}', "");
    Expect(1, 42655, '\P{^iscyrillicextb}', "");
    Expect(0, 42656, '\p{iscyrillicextb}', "");
    Expect(1, 42656, '\p{^iscyrillicextb}', "");
    Expect(1, 42656, '\P{iscyrillicextb}', "");
    Expect(0, 42656, '\P{^iscyrillicextb}', "");
    Expect(1, 42655, '\p{Is_cyrillic_ext_b}', "");
    Expect(0, 42655, '\p{^Is_cyrillic_ext_b}', "");
    Expect(0, 42655, '\P{Is_cyrillic_ext_b}', "");
    Expect(1, 42655, '\P{^Is_cyrillic_ext_b}', "");
    Expect(0, 42656, '\p{Is_cyrillic_ext_b}', "");
    Expect(1, 42656, '\p{^Is_cyrillic_ext_b}', "");
    Expect(1, 42656, '\P{Is_cyrillic_ext_b}', "");
    Expect(0, 42656, '\P{^Is_cyrillic_ext_b}', "");
    Error('\p{:=	 In_Cyrillic_EXT_b}');
    Error('\P{:=	 In_Cyrillic_EXT_b}');
    Expect(1, 42655, '\p{incyrillicextb}', "");
    Expect(0, 42655, '\p{^incyrillicextb}', "");
    Expect(0, 42655, '\P{incyrillicextb}', "");
    Expect(1, 42655, '\P{^incyrillicextb}', "");
    Expect(0, 42656, '\p{incyrillicextb}', "");
    Expect(1, 42656, '\p{^incyrillicextb}', "");
    Expect(1, 42656, '\P{incyrillicextb}', "");
    Expect(0, 42656, '\P{^incyrillicextb}', "");
    Expect(1, 42655, '\p{ 	in_Cyrillic_Ext_B}', "");
    Expect(0, 42655, '\p{^ 	in_Cyrillic_Ext_B}', "");
    Expect(0, 42655, '\P{ 	in_Cyrillic_Ext_B}', "");
    Expect(1, 42655, '\P{^ 	in_Cyrillic_Ext_B}', "");
    Expect(0, 42656, '\p{ 	in_Cyrillic_Ext_B}', "");
    Expect(1, 42656, '\p{^ 	in_Cyrillic_Ext_B}', "");
    Expect(1, 42656, '\P{ 	in_Cyrillic_Ext_B}', "");
    Expect(0, 42656, '\P{^ 	in_Cyrillic_Ext_B}', "");
    Error('\p{_:=cyrillic_Extended_C}');
    Error('\P{_:=cyrillic_Extended_C}');
    Expect(1, 7311, '\p{cyrillicextendedc}', "");
    Expect(0, 7311, '\p{^cyrillicextendedc}', "");
    Expect(0, 7311, '\P{cyrillicextendedc}', "");
    Expect(1, 7311, '\P{^cyrillicextendedc}', "");
    Expect(0, 7312, '\p{cyrillicextendedc}', "");
    Expect(1, 7312, '\p{^cyrillicextendedc}', "");
    Expect(1, 7312, '\P{cyrillicextendedc}', "");
    Expect(0, 7312, '\P{^cyrillicextendedc}', "");
    Expect(1, 7311, '\p{	 Cyrillic_EXTENDED_C}', "");
    Expect(0, 7311, '\p{^	 Cyrillic_EXTENDED_C}', "");
    Expect(0, 7311, '\P{	 Cyrillic_EXTENDED_C}', "");
    Expect(1, 7311, '\P{^	 Cyrillic_EXTENDED_C}', "");
    Expect(0, 7312, '\p{	 Cyrillic_EXTENDED_C}', "");
    Expect(1, 7312, '\p{^	 Cyrillic_EXTENDED_C}', "");
    Expect(1, 7312, '\P{	 Cyrillic_EXTENDED_C}', "");
    Expect(0, 7312, '\P{^	 Cyrillic_EXTENDED_C}', "");
    Error('\p{		Is_CYRILLIC_extended_C/a/}');
    Error('\P{		Is_CYRILLIC_extended_C/a/}');
    Expect(1, 7311, '\p{iscyrillicextendedc}', "");
    Expect(0, 7311, '\p{^iscyrillicextendedc}', "");
    Expect(0, 7311, '\P{iscyrillicextendedc}', "");
    Expect(1, 7311, '\P{^iscyrillicextendedc}', "");
    Expect(0, 7312, '\p{iscyrillicextendedc}', "");
    Expect(1, 7312, '\p{^iscyrillicextendedc}', "");
    Expect(1, 7312, '\P{iscyrillicextendedc}', "");
    Expect(0, 7312, '\P{^iscyrillicextendedc}', "");
    Expect(1, 7311, '\p{ _is_Cyrillic_Extended_C}', "");
    Expect(0, 7311, '\p{^ _is_Cyrillic_Extended_C}', "");
    Expect(0, 7311, '\P{ _is_Cyrillic_Extended_C}', "");
    Expect(1, 7311, '\P{^ _is_Cyrillic_Extended_C}', "");
    Expect(0, 7312, '\p{ _is_Cyrillic_Extended_C}', "");
    Expect(1, 7312, '\p{^ _is_Cyrillic_Extended_C}', "");
    Expect(1, 7312, '\P{ _is_Cyrillic_Extended_C}', "");
    Expect(0, 7312, '\P{^ _is_Cyrillic_Extended_C}', "");
    Error('\p{_ IN_Cyrillic_Extended_C:=}');
    Error('\P{_ IN_Cyrillic_Extended_C:=}');
    Expect(1, 7311, '\p{incyrillicextendedc}', "");
    Expect(0, 7311, '\p{^incyrillicextendedc}', "");
    Expect(0, 7311, '\P{incyrillicextendedc}', "");
    Expect(1, 7311, '\P{^incyrillicextendedc}', "");
    Expect(0, 7312, '\p{incyrillicextendedc}', "");
    Expect(1, 7312, '\p{^incyrillicextendedc}', "");
    Expect(1, 7312, '\P{incyrillicextendedc}', "");
    Expect(0, 7312, '\P{^incyrillicextendedc}', "");
    Expect(1, 7311, '\p{_IN_CYRILLIC_Extended_C}', "");
    Expect(0, 7311, '\p{^_IN_CYRILLIC_Extended_C}', "");
    Expect(0, 7311, '\P{_IN_CYRILLIC_Extended_C}', "");
    Expect(1, 7311, '\P{^_IN_CYRILLIC_Extended_C}', "");
    Expect(0, 7312, '\p{_IN_CYRILLIC_Extended_C}', "");
    Expect(1, 7312, '\p{^_IN_CYRILLIC_Extended_C}', "");
    Expect(1, 7312, '\P{_IN_CYRILLIC_Extended_C}', "");
    Expect(0, 7312, '\P{^_IN_CYRILLIC_Extended_C}', "");
    Error('\p{	 cyrillic_Ext_C/a/}');
    Error('\P{	 cyrillic_Ext_C/a/}');
    Expect(1, 7311, '\p{cyrillicextc}', "");
    Expect(0, 7311, '\p{^cyrillicextc}', "");
    Expect(0, 7311, '\P{cyrillicextc}', "");
    Expect(1, 7311, '\P{^cyrillicextc}', "");
    Expect(0, 7312, '\p{cyrillicextc}', "");
    Expect(1, 7312, '\p{^cyrillicextc}', "");
    Expect(1, 7312, '\P{cyrillicextc}', "");
    Expect(0, 7312, '\P{^cyrillicextc}', "");
    Expect(1, 7311, '\p{--cyrillic_EXT_C}', "");
    Expect(0, 7311, '\p{^--cyrillic_EXT_C}', "");
    Expect(0, 7311, '\P{--cyrillic_EXT_C}', "");
    Expect(1, 7311, '\P{^--cyrillic_EXT_C}', "");
    Expect(0, 7312, '\p{--cyrillic_EXT_C}', "");
    Expect(1, 7312, '\p{^--cyrillic_EXT_C}', "");
    Expect(1, 7312, '\P{--cyrillic_EXT_C}', "");
    Expect(0, 7312, '\P{^--cyrillic_EXT_C}', "");
    Error('\p{	/a/is_CYRILLIC_Ext_c}');
    Error('\P{	/a/is_CYRILLIC_Ext_c}');
    Expect(1, 7311, '\p{iscyrillicextc}', "");
    Expect(0, 7311, '\p{^iscyrillicextc}', "");
    Expect(0, 7311, '\P{iscyrillicextc}', "");
    Expect(1, 7311, '\P{^iscyrillicextc}', "");
    Expect(0, 7312, '\p{iscyrillicextc}', "");
    Expect(1, 7312, '\p{^iscyrillicextc}', "");
    Expect(1, 7312, '\P{iscyrillicextc}', "");
    Expect(0, 7312, '\P{^iscyrillicextc}', "");
    Expect(1, 7311, '\p{--is_Cyrillic_EXT_C}', "");
    Expect(0, 7311, '\p{^--is_Cyrillic_EXT_C}', "");
    Expect(0, 7311, '\P{--is_Cyrillic_EXT_C}', "");
    Expect(1, 7311, '\P{^--is_Cyrillic_EXT_C}', "");
    Expect(0, 7312, '\p{--is_Cyrillic_EXT_C}', "");
    Expect(1, 7312, '\p{^--is_Cyrillic_EXT_C}', "");
    Expect(1, 7312, '\P{--is_Cyrillic_EXT_C}', "");
    Expect(0, 7312, '\P{^--is_Cyrillic_EXT_C}', "");
    Error('\p{:=	 IN_CYRILLIC_EXT_c}');
    Error('\P{:=	 IN_CYRILLIC_EXT_c}');
    Expect(1, 7311, '\p{incyrillicextc}', "");
    Expect(0, 7311, '\p{^incyrillicextc}', "");
    Expect(0, 7311, '\P{incyrillicextc}', "");
    Expect(1, 7311, '\P{^incyrillicextc}', "");
    Expect(0, 7312, '\p{incyrillicextc}', "");
    Expect(1, 7312, '\p{^incyrillicextc}', "");
    Expect(1, 7312, '\P{incyrillicextc}', "");
    Expect(0, 7312, '\P{^incyrillicextc}', "");
    Expect(1, 7311, '\p{- In_Cyrillic_ext_c}', "");
    Expect(0, 7311, '\p{^- In_Cyrillic_ext_c}', "");
    Expect(0, 7311, '\P{- In_Cyrillic_ext_c}', "");
    Expect(1, 7311, '\P{^- In_Cyrillic_ext_c}', "");
    Expect(0, 7312, '\p{- In_Cyrillic_ext_c}', "");
    Expect(1, 7312, '\p{^- In_Cyrillic_ext_c}', "");
    Expect(1, 7312, '\P{- In_Cyrillic_ext_c}', "");
    Expect(0, 7312, '\P{^- In_Cyrillic_ext_c}', "");
    Error('\p{:=_Cyrillic_Supplement}');
    Error('\P{:=_Cyrillic_Supplement}');
    Expect(1, 1327, '\p{cyrillicsupplement}', "");
    Expect(0, 1327, '\p{^cyrillicsupplement}', "");
    Expect(0, 1327, '\P{cyrillicsupplement}', "");
    Expect(1, 1327, '\P{^cyrillicsupplement}', "");
    Expect(0, 1328, '\p{cyrillicsupplement}', "");
    Expect(1, 1328, '\p{^cyrillicsupplement}', "");
    Expect(1, 1328, '\P{cyrillicsupplement}', "");
    Expect(0, 1328, '\P{^cyrillicsupplement}', "");
    Expect(1, 1327, '\p{	Cyrillic_SUPPLEMENT}', "");
    Expect(0, 1327, '\p{^	Cyrillic_SUPPLEMENT}', "");
    Expect(0, 1327, '\P{	Cyrillic_SUPPLEMENT}', "");
    Expect(1, 1327, '\P{^	Cyrillic_SUPPLEMENT}', "");
    Expect(0, 1328, '\p{	Cyrillic_SUPPLEMENT}', "");
    Expect(1, 1328, '\p{^	Cyrillic_SUPPLEMENT}', "");
    Expect(1, 1328, '\P{	Cyrillic_SUPPLEMENT}', "");
    Expect(0, 1328, '\P{^	Cyrillic_SUPPLEMENT}', "");
    Error('\p{Is_Cyrillic_supplement/a/}');
    Error('\P{Is_Cyrillic_supplement/a/}');
    Expect(1, 1327, '\p{iscyrillicsupplement}', "");
    Expect(0, 1327, '\p{^iscyrillicsupplement}', "");
    Expect(0, 1327, '\P{iscyrillicsupplement}', "");
    Expect(1, 1327, '\P{^iscyrillicsupplement}', "");
    Expect(0, 1328, '\p{iscyrillicsupplement}', "");
    Expect(1, 1328, '\p{^iscyrillicsupplement}', "");
    Expect(1, 1328, '\P{iscyrillicsupplement}', "");
    Expect(0, 1328, '\P{^iscyrillicsupplement}', "");
    Expect(1, 1327, '\p{_Is_Cyrillic_SUPPLEMENT}', "");
    Expect(0, 1327, '\p{^_Is_Cyrillic_SUPPLEMENT}', "");
    Expect(0, 1327, '\P{_Is_Cyrillic_SUPPLEMENT}', "");
    Expect(1, 1327, '\P{^_Is_Cyrillic_SUPPLEMENT}', "");
    Expect(0, 1328, '\p{_Is_Cyrillic_SUPPLEMENT}', "");
    Expect(1, 1328, '\p{^_Is_Cyrillic_SUPPLEMENT}', "");
    Expect(1, 1328, '\P{_Is_Cyrillic_SUPPLEMENT}', "");
    Expect(0, 1328, '\P{^_Is_Cyrillic_SUPPLEMENT}', "");
    Error('\p{:=_IN_CYRILLIC_Supplement}');
    Error('\P{:=_IN_CYRILLIC_Supplement}');
    Expect(1, 1327, '\p{incyrillicsupplement}', "");
    Expect(0, 1327, '\p{^incyrillicsupplement}', "");
    Expect(0, 1327, '\P{incyrillicsupplement}', "");
    Expect(1, 1327, '\P{^incyrillicsupplement}', "");
    Expect(0, 1328, '\p{incyrillicsupplement}', "");
    Expect(1, 1328, '\p{^incyrillicsupplement}', "");
    Expect(1, 1328, '\P{incyrillicsupplement}', "");
    Expect(0, 1328, '\P{^incyrillicsupplement}', "");
    Expect(1, 1327, '\p{- in_Cyrillic_Supplement}', "");
    Expect(0, 1327, '\p{^- in_Cyrillic_Supplement}', "");
    Expect(0, 1327, '\P{- in_Cyrillic_Supplement}', "");
    Expect(1, 1327, '\P{^- in_Cyrillic_Supplement}', "");
    Expect(0, 1328, '\p{- in_Cyrillic_Supplement}', "");
    Expect(1, 1328, '\p{^- in_Cyrillic_Supplement}', "");
    Expect(1, 1328, '\P{- in_Cyrillic_Supplement}', "");
    Expect(0, 1328, '\P{^- in_Cyrillic_Supplement}', "");
    Error('\p{:=CYRILLIC_Sup}');
    Error('\P{:=CYRILLIC_Sup}');
    Expect(1, 1327, '\p{cyrillicsup}', "");
    Expect(0, 1327, '\p{^cyrillicsup}', "");
    Expect(0, 1327, '\P{cyrillicsup}', "");
    Expect(1, 1327, '\P{^cyrillicsup}', "");
    Expect(0, 1328, '\p{cyrillicsup}', "");
    Expect(1, 1328, '\p{^cyrillicsup}', "");
    Expect(1, 1328, '\P{cyrillicsup}', "");
    Expect(0, 1328, '\P{^cyrillicsup}', "");
    Expect(1, 1327, '\p{-	Cyrillic_Sup}', "");
    Expect(0, 1327, '\p{^-	Cyrillic_Sup}', "");
    Expect(0, 1327, '\P{-	Cyrillic_Sup}', "");
    Expect(1, 1327, '\P{^-	Cyrillic_Sup}', "");
    Expect(0, 1328, '\p{-	Cyrillic_Sup}', "");
    Expect(1, 1328, '\p{^-	Cyrillic_Sup}', "");
    Expect(1, 1328, '\P{-	Cyrillic_Sup}', "");
    Expect(0, 1328, '\P{^-	Cyrillic_Sup}', "");
    Error('\p{		Is_CYRILLIC_SUP:=}');
    Error('\P{		Is_CYRILLIC_SUP:=}');
    Expect(1, 1327, '\p{iscyrillicsup}', "");
    Expect(0, 1327, '\p{^iscyrillicsup}', "");
    Expect(0, 1327, '\P{iscyrillicsup}', "");
    Expect(1, 1327, '\P{^iscyrillicsup}', "");
    Expect(0, 1328, '\p{iscyrillicsup}', "");
    Expect(1, 1328, '\p{^iscyrillicsup}', "");
    Expect(1, 1328, '\P{iscyrillicsup}', "");
    Expect(0, 1328, '\P{^iscyrillicsup}', "");
    Expect(1, 1327, '\p{-Is_Cyrillic_Sup}', "");
    Expect(0, 1327, '\p{^-Is_Cyrillic_Sup}', "");
    Expect(0, 1327, '\P{-Is_Cyrillic_Sup}', "");
    Expect(1, 1327, '\P{^-Is_Cyrillic_Sup}', "");
    Expect(0, 1328, '\p{-Is_Cyrillic_Sup}', "");
    Expect(1, 1328, '\p{^-Is_Cyrillic_Sup}', "");
    Expect(1, 1328, '\P{-Is_Cyrillic_Sup}', "");
    Expect(0, 1328, '\P{^-Is_Cyrillic_Sup}', "");
    Error('\p{_In_Cyrillic_Sup/a/}');
    Error('\P{_In_Cyrillic_Sup/a/}');
    Expect(1, 1327, '\p{incyrillicsup}', "");
    Expect(0, 1327, '\p{^incyrillicsup}', "");
    Expect(0, 1327, '\P{incyrillicsup}', "");
    Expect(1, 1327, '\P{^incyrillicsup}', "");
    Expect(0, 1328, '\p{incyrillicsup}', "");
    Expect(1, 1328, '\p{^incyrillicsup}', "");
    Expect(1, 1328, '\P{incyrillicsup}', "");
    Expect(0, 1328, '\P{^incyrillicsup}', "");
    Expect(1, 1327, '\p{ -In_CYRILLIC_sup}', "");
    Expect(0, 1327, '\p{^ -In_CYRILLIC_sup}', "");
    Expect(0, 1327, '\P{ -In_CYRILLIC_sup}', "");
    Expect(1, 1327, '\P{^ -In_CYRILLIC_sup}', "");
    Expect(0, 1328, '\p{ -In_CYRILLIC_sup}', "");
    Expect(1, 1328, '\p{^ -In_CYRILLIC_sup}', "");
    Expect(1, 1328, '\P{ -In_CYRILLIC_sup}', "");
    Expect(0, 1328, '\P{^ -In_CYRILLIC_sup}', "");
    Error('\p{/a/		cyrillic_Supplementary}');
    Error('\P{/a/		cyrillic_Supplementary}');
    Expect(1, 1327, '\p{cyrillicsupplementary}', "");
    Expect(0, 1327, '\p{^cyrillicsupplementary}', "");
    Expect(0, 1327, '\P{cyrillicsupplementary}', "");
    Expect(1, 1327, '\P{^cyrillicsupplementary}', "");
    Expect(0, 1328, '\p{cyrillicsupplementary}', "");
    Expect(1, 1328, '\p{^cyrillicsupplementary}', "");
    Expect(1, 1328, '\P{cyrillicsupplementary}', "");
    Expect(0, 1328, '\P{^cyrillicsupplementary}', "");
    Expect(1, 1327, '\p{-_Cyrillic_Supplementary}', "");
    Expect(0, 1327, '\p{^-_Cyrillic_Supplementary}', "");
    Expect(0, 1327, '\P{-_Cyrillic_Supplementary}', "");
    Expect(1, 1327, '\P{^-_Cyrillic_Supplementary}', "");
    Expect(0, 1328, '\p{-_Cyrillic_Supplementary}', "");
    Expect(1, 1328, '\p{^-_Cyrillic_Supplementary}', "");
    Expect(1, 1328, '\P{-_Cyrillic_Supplementary}', "");
    Expect(0, 1328, '\P{^-_Cyrillic_Supplementary}', "");
    Error('\p{/a/_-Is_Cyrillic_supplementary}');
    Error('\P{/a/_-Is_Cyrillic_supplementary}');
    Expect(1, 1327, '\p{iscyrillicsupplementary}', "");
    Expect(0, 1327, '\p{^iscyrillicsupplementary}', "");
    Expect(0, 1327, '\P{iscyrillicsupplementary}', "");
    Expect(1, 1327, '\P{^iscyrillicsupplementary}', "");
    Expect(0, 1328, '\p{iscyrillicsupplementary}', "");
    Expect(1, 1328, '\p{^iscyrillicsupplementary}', "");
    Expect(1, 1328, '\P{iscyrillicsupplementary}', "");
    Expect(0, 1328, '\P{^iscyrillicsupplementary}', "");
    Expect(1, 1327, '\p{_ is_CYRILLIC_SUPPLEMENTARY}', "");
    Expect(0, 1327, '\p{^_ is_CYRILLIC_SUPPLEMENTARY}', "");
    Expect(0, 1327, '\P{_ is_CYRILLIC_SUPPLEMENTARY}', "");
    Expect(1, 1327, '\P{^_ is_CYRILLIC_SUPPLEMENTARY}', "");
    Expect(0, 1328, '\p{_ is_CYRILLIC_SUPPLEMENTARY}', "");
    Expect(1, 1328, '\p{^_ is_CYRILLIC_SUPPLEMENTARY}', "");
    Expect(1, 1328, '\P{_ is_CYRILLIC_SUPPLEMENTARY}', "");
    Expect(0, 1328, '\P{^_ is_CYRILLIC_SUPPLEMENTARY}', "");
    Error('\p{ :=in_cyrillic_Supplementary}');
    Error('\P{ :=in_cyrillic_Supplementary}');
    Expect(1, 1327, '\p{incyrillicsupplementary}', "");
    Expect(0, 1327, '\p{^incyrillicsupplementary}', "");
    Expect(0, 1327, '\P{incyrillicsupplementary}', "");
    Expect(1, 1327, '\P{^incyrillicsupplementary}', "");
    Expect(0, 1328, '\p{incyrillicsupplementary}', "");
    Expect(1, 1328, '\p{^incyrillicsupplementary}', "");
    Expect(1, 1328, '\P{incyrillicsupplementary}', "");
    Expect(0, 1328, '\P{^incyrillicsupplementary}', "");
    Expect(1, 1327, '\p{  in_Cyrillic_supplementary}', "");
    Expect(0, 1327, '\p{^  in_Cyrillic_supplementary}', "");
    Expect(0, 1327, '\P{  in_Cyrillic_supplementary}', "");
    Expect(1, 1327, '\P{^  in_Cyrillic_supplementary}', "");
    Expect(0, 1328, '\p{  in_Cyrillic_supplementary}', "");
    Expect(1, 1328, '\p{^  in_Cyrillic_supplementary}', "");
    Expect(1, 1328, '\P{  in_Cyrillic_supplementary}', "");
    Expect(0, 1328, '\P{^  in_Cyrillic_supplementary}', "");
    Error('\p{	 DASH/a/}');
    Error('\P{	 DASH/a/}');
    Expect(1, 69293, '\p{dash}', "");
    Expect(0, 69293, '\p{^dash}', "");
    Expect(0, 69293, '\P{dash}', "");
    Expect(1, 69293, '\P{^dash}', "");
    Expect(0, 69294, '\p{dash}', "");
    Expect(1, 69294, '\p{^dash}', "");
    Expect(1, 69294, '\P{dash}', "");
    Expect(0, 69294, '\P{^dash}', "");
    Expect(1, 69293, '\p{ DASH}', "");
    Expect(0, 69293, '\p{^ DASH}', "");
    Expect(0, 69293, '\P{ DASH}', "");
    Expect(1, 69293, '\P{^ DASH}', "");
    Expect(0, 69294, '\p{ DASH}', "");
    Expect(1, 69294, '\p{^ DASH}', "");
    Expect(1, 69294, '\P{ DASH}', "");
    Expect(0, 69294, '\P{^ DASH}', "");
    Error('\p{ /a/IS_Dash}');
    Error('\P{ /a/IS_Dash}');
    Expect(1, 69293, '\p{isdash}', "");
    Expect(0, 69293, '\p{^isdash}', "");
    Expect(0, 69293, '\P{isdash}', "");
    Expect(1, 69293, '\P{^isdash}', "");
    Expect(0, 69294, '\p{isdash}', "");
    Expect(1, 69294, '\p{^isdash}', "");
    Expect(1, 69294, '\P{isdash}', "");
    Expect(0, 69294, '\P{^isdash}', "");
    Expect(1, 69293, '\p{--IS_Dash}', "");
    Expect(0, 69293, '\p{^--IS_Dash}', "");
    Expect(0, 69293, '\P{--IS_Dash}', "");
    Expect(1, 69293, '\P{^--IS_Dash}', "");
    Expect(0, 69294, '\p{--IS_Dash}', "");
    Expect(1, 69294, '\p{^--IS_Dash}', "");
    Expect(1, 69294, '\P{--IS_Dash}', "");
    Expect(0, 69294, '\P{^--IS_Dash}', "");
    Error('\p{_:=dash_PUNCTUATION}');
    Error('\P{_:=dash_PUNCTUATION}');
    Expect(1, 69293, '\p{dashpunctuation}', "");
    Expect(0, 69293, '\p{^dashpunctuation}', "");
    Expect(0, 69293, '\P{dashpunctuation}', "");
    Expect(1, 69293, '\P{^dashpunctuation}', "");
    Expect(0, 69294, '\p{dashpunctuation}', "");
    Expect(1, 69294, '\p{^dashpunctuation}', "");
    Expect(1, 69294, '\P{dashpunctuation}', "");
    Expect(0, 69294, '\P{^dashpunctuation}', "");
    Expect(1, 69293, '\p{	 DASH_Punctuation}', "");
    Expect(0, 69293, '\p{^	 DASH_Punctuation}', "");
    Expect(0, 69293, '\P{	 DASH_Punctuation}', "");
    Expect(1, 69293, '\P{^	 DASH_Punctuation}', "");
    Expect(0, 69294, '\p{	 DASH_Punctuation}', "");
    Expect(1, 69294, '\p{^	 DASH_Punctuation}', "");
    Expect(1, 69294, '\P{	 DASH_Punctuation}', "");
    Expect(0, 69294, '\P{^	 DASH_Punctuation}', "");
    Error('\p{-/a/is_Dash_PUNCTUATION}');
    Error('\P{-/a/is_Dash_PUNCTUATION}');
    Expect(1, 69293, '\p{isdashpunctuation}', "");
    Expect(0, 69293, '\p{^isdashpunctuation}', "");
    Expect(0, 69293, '\P{isdashpunctuation}', "");
    Expect(1, 69293, '\P{^isdashpunctuation}', "");
    Expect(0, 69294, '\p{isdashpunctuation}', "");
    Expect(1, 69294, '\p{^isdashpunctuation}', "");
    Expect(1, 69294, '\P{isdashpunctuation}', "");
    Expect(0, 69294, '\P{^isdashpunctuation}', "");
    Expect(1, 69293, '\p{ -IS_Dash_PUNCTUATION}', "");
    Expect(0, 69293, '\p{^ -IS_Dash_PUNCTUATION}', "");
    Expect(0, 69293, '\P{ -IS_Dash_PUNCTUATION}', "");
    Expect(1, 69293, '\P{^ -IS_Dash_PUNCTUATION}', "");
    Expect(0, 69294, '\p{ -IS_Dash_PUNCTUATION}', "");
    Expect(1, 69294, '\p{^ -IS_Dash_PUNCTUATION}', "");
    Expect(1, 69294, '\P{ -IS_Dash_PUNCTUATION}', "");
    Expect(0, 69294, '\P{^ -IS_Dash_PUNCTUATION}', "");
    Error('\p{		PD/a/}');
    Error('\P{		PD/a/}');
    Expect(1, 69293, '\p{pd}', "");
    Expect(0, 69293, '\p{^pd}', "");
    Expect(0, 69293, '\P{pd}', "");
    Expect(1, 69293, '\P{^pd}', "");
    Expect(0, 69294, '\p{pd}', "");
    Expect(1, 69294, '\p{^pd}', "");
    Expect(1, 69294, '\P{pd}', "");
    Expect(0, 69294, '\P{^pd}', "");
    Expect(1, 69293, '\p{	 PD}', "");
    Expect(0, 69293, '\p{^	 PD}', "");
    Expect(0, 69293, '\P{	 PD}', "");
    Expect(1, 69293, '\P{^	 PD}', "");
    Expect(0, 69294, '\p{	 PD}', "");
    Expect(1, 69294, '\p{^	 PD}', "");
    Expect(1, 69294, '\P{	 PD}', "");
    Expect(0, 69294, '\P{^	 PD}', "");
    Error('\p{/a/- IS_pd}');
    Error('\P{/a/- IS_pd}');
    Expect(1, 69293, '\p{ispd}', "");
    Expect(0, 69293, '\p{^ispd}', "");
    Expect(0, 69293, '\P{ispd}', "");
    Expect(1, 69293, '\P{^ispd}', "");
    Expect(0, 69294, '\p{ispd}', "");
    Expect(1, 69294, '\p{^ispd}', "");
    Expect(1, 69294, '\P{ispd}', "");
    Expect(0, 69294, '\P{^ispd}', "");
    Expect(1, 69293, '\p{ 	Is_PD}', "");
    Expect(0, 69293, '\p{^ 	Is_PD}', "");
    Expect(0, 69293, '\P{ 	Is_PD}', "");
    Expect(1, 69293, '\P{^ 	Is_PD}', "");
    Expect(0, 69294, '\p{ 	Is_PD}', "");
    Expect(1, 69294, '\p{^ 	Is_PD}', "");
    Expect(1, 69294, '\P{ 	Is_PD}', "");
    Expect(0, 69294, '\P{^ 	Is_PD}', "");
    Error('\p{  DEFAULT_IGNORABLE_Code_Point/a/}');
    Error('\P{  DEFAULT_IGNORABLE_Code_Point/a/}');
    Expect(1, 921599, '\p{defaultignorablecodepoint}', "");
    Expect(0, 921599, '\p{^defaultignorablecodepoint}', "");
    Expect(0, 921599, '\P{defaultignorablecodepoint}', "");
    Expect(1, 921599, '\P{^defaultignorablecodepoint}', "");
    Expect(0, 921600, '\p{defaultignorablecodepoint}', "");
    Expect(1, 921600, '\p{^defaultignorablecodepoint}', "");
    Expect(1, 921600, '\P{defaultignorablecodepoint}', "");
    Expect(0, 921600, '\P{^defaultignorablecodepoint}', "");
    Expect(1, 921599, '\p{--Default_Ignorable_Code_Point}', "");
    Expect(0, 921599, '\p{^--Default_Ignorable_Code_Point}', "");
    Expect(0, 921599, '\P{--Default_Ignorable_Code_Point}', "");
    Expect(1, 921599, '\P{^--Default_Ignorable_Code_Point}', "");
    Expect(0, 921600, '\p{--Default_Ignorable_Code_Point}', "");
    Expect(1, 921600, '\p{^--Default_Ignorable_Code_Point}', "");
    Expect(1, 921600, '\P{--Default_Ignorable_Code_Point}', "");
    Expect(0, 921600, '\P{^--Default_Ignorable_Code_Point}', "");
    Error('\p{ is_Default_Ignorable_Code_point/a/}');
    Error('\P{ is_Default_Ignorable_Code_point/a/}');
    Expect(1, 921599, '\p{isdefaultignorablecodepoint}', "");
    Expect(0, 921599, '\p{^isdefaultignorablecodepoint}', "");
    Expect(0, 921599, '\P{isdefaultignorablecodepoint}', "");
    Expect(1, 921599, '\P{^isdefaultignorablecodepoint}', "");
    Expect(0, 921600, '\p{isdefaultignorablecodepoint}', "");
    Expect(1, 921600, '\p{^isdefaultignorablecodepoint}', "");
    Expect(1, 921600, '\P{isdefaultignorablecodepoint}', "");
    Expect(0, 921600, '\P{^isdefaultignorablecodepoint}', "");
    Expect(1, 921599, '\p{-is_Default_Ignorable_Code_Point}', "");
    Expect(0, 921599, '\p{^-is_Default_Ignorable_Code_Point}', "");
    Expect(0, 921599, '\P{-is_Default_Ignorable_Code_Point}', "");
    Expect(1, 921599, '\P{^-is_Default_Ignorable_Code_Point}', "");
    Expect(0, 921600, '\p{-is_Default_Ignorable_Code_Point}', "");
    Expect(1, 921600, '\p{^-is_Default_Ignorable_Code_Point}', "");
    Expect(1, 921600, '\P{-is_Default_Ignorable_Code_Point}', "");
    Expect(0, 921600, '\P{^-is_Default_Ignorable_Code_Point}', "");
    Error('\p{/a/	 DI}');
    Error('\P{/a/	 DI}');
    Expect(1, 921599, '\p{di}', "");
    Expect(0, 921599, '\p{^di}', "");
    Expect(0, 921599, '\P{di}', "");
    Expect(1, 921599, '\P{^di}', "");
    Expect(0, 921600, '\p{di}', "");
    Expect(1, 921600, '\p{^di}', "");
    Expect(1, 921600, '\P{di}', "");
    Expect(0, 921600, '\P{^di}', "");
    Expect(1, 921599, '\p{-DI}', "");
    Expect(0, 921599, '\p{^-DI}', "");
    Expect(0, 921599, '\P{-DI}', "");
    Expect(1, 921599, '\P{^-DI}', "");
    Expect(0, 921600, '\p{-DI}', "");
    Expect(1, 921600, '\p{^-DI}', "");
    Expect(1, 921600, '\P{-DI}', "");
    Expect(0, 921600, '\P{^-DI}', "");
    Error('\p{-_Is_DI:=}');
    Error('\P{-_Is_DI:=}');
    Expect(1, 921599, '\p{isdi}', "");
    Expect(0, 921599, '\p{^isdi}', "");
    Expect(0, 921599, '\P{isdi}', "");
    Expect(1, 921599, '\P{^isdi}', "");
    Expect(0, 921600, '\p{isdi}', "");
    Expect(1, 921600, '\p{^isdi}', "");
    Expect(1, 921600, '\P{isdi}', "");
    Expect(0, 921600, '\P{^isdi}', "");
    Expect(1, 921599, '\p{_Is_di}', "");
    Expect(0, 921599, '\p{^_Is_di}', "");
    Expect(0, 921599, '\P{_Is_di}', "");
    Expect(1, 921599, '\P{^_Is_di}', "");
    Expect(0, 921600, '\p{_Is_di}', "");
    Expect(1, 921600, '\p{^_Is_di}', "");
    Expect(1, 921600, '\P{_Is_di}', "");
    Expect(0, 921600, '\P{^_Is_di}', "");
    Error('\p{	:=deprecated}');
    Error('\P{	:=deprecated}');
    Expect(1, 917505, '\p{deprecated}', "");
    Expect(0, 917505, '\p{^deprecated}', "");
    Expect(0, 917505, '\P{deprecated}', "");
    Expect(1, 917505, '\P{^deprecated}', "");
    Expect(0, 917506, '\p{deprecated}', "");
    Expect(1, 917506, '\p{^deprecated}', "");
    Expect(1, 917506, '\P{deprecated}', "");
    Expect(0, 917506, '\P{^deprecated}', "");
    Expect(1, 917505, '\p{ Deprecated}', "");
    Expect(0, 917505, '\p{^ Deprecated}', "");
    Expect(0, 917505, '\P{ Deprecated}', "");
    Expect(1, 917505, '\P{^ Deprecated}', "");
    Expect(0, 917506, '\p{ Deprecated}', "");
    Expect(1, 917506, '\p{^ Deprecated}', "");
    Expect(1, 917506, '\P{ Deprecated}', "");
    Expect(0, 917506, '\P{^ Deprecated}', "");
    Error('\p{/a/_ Is_DEPRECATED}');
    Error('\P{/a/_ Is_DEPRECATED}');
    Expect(1, 917505, '\p{isdeprecated}', "");
    Expect(0, 917505, '\p{^isdeprecated}', "");
    Expect(0, 917505, '\P{isdeprecated}', "");
    Expect(1, 917505, '\P{^isdeprecated}', "");
    Expect(0, 917506, '\p{isdeprecated}', "");
    Expect(1, 917506, '\p{^isdeprecated}', "");
    Expect(1, 917506, '\P{isdeprecated}', "");
    Expect(0, 917506, '\P{^isdeprecated}', "");
    Expect(1, 917505, '\p{  Is_DEPRECATED}', "");
    Expect(0, 917505, '\p{^  Is_DEPRECATED}', "");
    Expect(0, 917505, '\P{  Is_DEPRECATED}', "");
    Expect(1, 917505, '\P{^  Is_DEPRECATED}', "");
    Expect(0, 917506, '\p{  Is_DEPRECATED}', "");
    Expect(1, 917506, '\p{^  Is_DEPRECATED}', "");
    Expect(1, 917506, '\P{  Is_DEPRECATED}', "");
    Expect(0, 917506, '\P{^  Is_DEPRECATED}', "");
    Error('\p{:=__Dep}');
    Error('\P{:=__Dep}');
    Expect(1, 917505, '\p{dep}', "");
    Expect(0, 917505, '\p{^dep}', "");
    Expect(0, 917505, '\P{dep}', "");
    Expect(1, 917505, '\P{^dep}', "");
    Expect(0, 917506, '\p{dep}', "");
    Expect(1, 917506, '\p{^dep}', "");
    Expect(1, 917506, '\P{dep}', "");
    Expect(0, 917506, '\P{^dep}', "");
    Expect(1, 917505, '\p{__DEP}', "");
    Expect(0, 917505, '\p{^__DEP}', "");
    Expect(0, 917505, '\P{__DEP}', "");
    Expect(1, 917505, '\P{^__DEP}', "");
    Expect(0, 917506, '\p{__DEP}', "");
    Expect(1, 917506, '\p{^__DEP}', "");
    Expect(1, 917506, '\P{__DEP}', "");
    Expect(0, 917506, '\P{^__DEP}', "");
    Error('\p{	/a/is_Dep}');
    Error('\P{	/a/is_Dep}');
    Expect(1, 917505, '\p{isdep}', "");
    Expect(0, 917505, '\p{^isdep}', "");
    Expect(0, 917505, '\P{isdep}', "");
    Expect(1, 917505, '\P{^isdep}', "");
    Expect(0, 917506, '\p{isdep}', "");
    Expect(1, 917506, '\p{^isdep}', "");
    Expect(1, 917506, '\P{isdep}', "");
    Expect(0, 917506, '\P{^isdep}', "");
    Expect(1, 917505, '\p{	-IS_Dep}', "");
    Expect(0, 917505, '\p{^	-IS_Dep}', "");
    Expect(0, 917505, '\P{	-IS_Dep}', "");
    Expect(1, 917505, '\P{^	-IS_Dep}', "");
    Expect(0, 917506, '\p{	-IS_Dep}', "");
    Expect(1, 917506, '\p{^	-IS_Dep}', "");
    Expect(1, 917506, '\P{	-IS_Dep}', "");
    Expect(0, 917506, '\P{^	-IS_Dep}', "");
    Error('\p{-/a/Deseret}');
    Error('\P{-/a/Deseret}');
    Expect(1, 66639, '\p{deseret}', "");
    Expect(0, 66639, '\p{^deseret}', "");
    Expect(0, 66639, '\P{deseret}', "");
    Expect(1, 66639, '\P{^deseret}', "");
    Expect(0, 66640, '\p{deseret}', "");
    Expect(1, 66640, '\p{^deseret}', "");
    Expect(1, 66640, '\P{deseret}', "");
    Expect(0, 66640, '\P{^deseret}', "");
    Expect(1, 66639, '\p{--deseret}', "");
    Expect(0, 66639, '\p{^--deseret}', "");
    Expect(0, 66639, '\P{--deseret}', "");
    Expect(1, 66639, '\P{^--deseret}', "");
    Expect(0, 66640, '\p{--deseret}', "");
    Expect(1, 66640, '\p{^--deseret}', "");
    Expect(1, 66640, '\P{--deseret}', "");
    Expect(0, 66640, '\P{^--deseret}', "");
    Error('\p{ _IS_DESERET/a/}');
    Error('\P{ _IS_DESERET/a/}');
    Expect(1, 66639, '\p{isdeseret}', "");
    Expect(0, 66639, '\p{^isdeseret}', "");
    Expect(0, 66639, '\P{isdeseret}', "");
    Expect(1, 66639, '\P{^isdeseret}', "");
    Expect(0, 66640, '\p{isdeseret}', "");
    Expect(1, 66640, '\p{^isdeseret}', "");
    Expect(1, 66640, '\P{isdeseret}', "");
    Expect(0, 66640, '\P{^isdeseret}', "");
    Expect(1, 66639, '\p{		Is_Deseret}', "");
    Expect(0, 66639, '\p{^		Is_Deseret}', "");
    Expect(0, 66639, '\P{		Is_Deseret}', "");
    Expect(1, 66639, '\P{^		Is_Deseret}', "");
    Expect(0, 66640, '\p{		Is_Deseret}', "");
    Expect(1, 66640, '\p{^		Is_Deseret}', "");
    Expect(1, 66640, '\P{		Is_Deseret}', "");
    Expect(0, 66640, '\P{^		Is_Deseret}', "");
    Error('\p{/a/ 	Dsrt}');
    Error('\P{/a/ 	Dsrt}');
    Expect(1, 66639, '\p{dsrt}', "");
    Expect(0, 66639, '\p{^dsrt}', "");
    Expect(0, 66639, '\P{dsrt}', "");
    Expect(1, 66639, '\P{^dsrt}', "");
    Expect(0, 66640, '\p{dsrt}', "");
    Expect(1, 66640, '\p{^dsrt}', "");
    Expect(1, 66640, '\P{dsrt}', "");
    Expect(0, 66640, '\P{^dsrt}', "");
    Expect(1, 66639, '\p{--Dsrt}', "");
    Expect(0, 66639, '\p{^--Dsrt}', "");
    Expect(0, 66639, '\P{--Dsrt}', "");
    Expect(1, 66639, '\P{^--Dsrt}', "");
    Expect(0, 66640, '\p{--Dsrt}', "");
    Expect(1, 66640, '\p{^--Dsrt}', "");
    Expect(1, 66640, '\P{--Dsrt}', "");
    Expect(0, 66640, '\P{^--Dsrt}', "");
    Error('\p{ -is_DSRT:=}');
    Error('\P{ -is_DSRT:=}');
    Expect(1, 66639, '\p{isdsrt}', "");
    Expect(0, 66639, '\p{^isdsrt}', "");
    Expect(0, 66639, '\P{isdsrt}', "");
    Expect(1, 66639, '\P{^isdsrt}', "");
    Expect(0, 66640, '\p{isdsrt}', "");
    Expect(1, 66640, '\p{^isdsrt}', "");
    Expect(1, 66640, '\P{isdsrt}', "");
    Expect(0, 66640, '\P{^isdsrt}', "");
    Expect(1, 66639, '\p{ -IS_dsrt}', "");
    Expect(0, 66639, '\p{^ -IS_dsrt}', "");
    Expect(0, 66639, '\P{ -IS_dsrt}', "");
    Expect(1, 66639, '\P{^ -IS_dsrt}', "");
    Expect(0, 66640, '\p{ -IS_dsrt}', "");
    Expect(1, 66640, '\p{^ -IS_dsrt}', "");
    Expect(1, 66640, '\P{ -IS_dsrt}', "");
    Expect(0, 66640, '\P{^ -IS_dsrt}', "");
    Error('\p{ /a/devanagari}');
    Error('\P{ /a/devanagari}');
    Expect(1, 43263, '\p{devanagari}', "");
    Expect(0, 43263, '\p{^devanagari}', "");
    Expect(0, 43263, '\P{devanagari}', "");
    Expect(1, 43263, '\P{^devanagari}', "");
    Expect(0, 43264, '\p{devanagari}', "");
    Expect(1, 43264, '\p{^devanagari}', "");
    Expect(1, 43264, '\P{devanagari}', "");
    Expect(0, 43264, '\P{^devanagari}', "");
    Expect(1, 43263, '\p{_	devanagari}', "");
    Expect(0, 43263, '\p{^_	devanagari}', "");
    Expect(0, 43263, '\P{_	devanagari}', "");
    Expect(1, 43263, '\P{^_	devanagari}', "");
    Expect(0, 43264, '\p{_	devanagari}', "");
    Expect(1, 43264, '\p{^_	devanagari}', "");
    Expect(1, 43264, '\P{_	devanagari}', "");
    Expect(0, 43264, '\P{^_	devanagari}', "");
    Error('\p{:=__IS_Devanagari}');
    Error('\P{:=__IS_Devanagari}');
    Expect(1, 43263, '\p{isdevanagari}', "");
    Expect(0, 43263, '\p{^isdevanagari}', "");
    Expect(0, 43263, '\P{isdevanagari}', "");
    Expect(1, 43263, '\P{^isdevanagari}', "");
    Expect(0, 43264, '\p{isdevanagari}', "");
    Expect(1, 43264, '\p{^isdevanagari}', "");
    Expect(1, 43264, '\P{isdevanagari}', "");
    Expect(0, 43264, '\P{^isdevanagari}', "");
    Expect(1, 43263, '\p{Is_DEVANAGARI}', "");
    Expect(0, 43263, '\p{^Is_DEVANAGARI}', "");
    Expect(0, 43263, '\P{Is_DEVANAGARI}', "");
    Expect(1, 43263, '\P{^Is_DEVANAGARI}', "");
    Expect(0, 43264, '\p{Is_DEVANAGARI}', "");
    Expect(1, 43264, '\p{^Is_DEVANAGARI}', "");
    Expect(1, 43264, '\P{Is_DEVANAGARI}', "");
    Expect(0, 43264, '\P{^Is_DEVANAGARI}', "");
    Error('\p{ _deva/a/}');
    Error('\P{ _deva/a/}');
    Expect(1, 43263, '\p{deva}', "");
    Expect(0, 43263, '\p{^deva}', "");
    Expect(0, 43263, '\P{deva}', "");
    Expect(1, 43263, '\P{^deva}', "");
    Expect(0, 43264, '\p{deva}', "");
    Expect(1, 43264, '\p{^deva}', "");
    Expect(1, 43264, '\P{deva}', "");
    Expect(0, 43264, '\P{^deva}', "");
    Expect(1, 43263, '\p{_	Deva}', "");
    Expect(0, 43263, '\p{^_	Deva}', "");
    Expect(0, 43263, '\P{_	Deva}', "");
    Expect(1, 43263, '\P{^_	Deva}', "");
    Expect(0, 43264, '\p{_	Deva}', "");
    Expect(1, 43264, '\p{^_	Deva}', "");
    Expect(1, 43264, '\P{_	Deva}', "");
    Expect(0, 43264, '\P{^_	Deva}', "");
    Error('\p{_	IS_Deva/a/}');
    Error('\P{_	IS_Deva/a/}');
    Expect(1, 43263, '\p{isdeva}', "");
    Expect(0, 43263, '\p{^isdeva}', "");
    Expect(0, 43263, '\P{isdeva}', "");
    Expect(1, 43263, '\P{^isdeva}', "");
    Expect(0, 43264, '\p{isdeva}', "");
    Expect(1, 43264, '\p{^isdeva}', "");
    Expect(1, 43264, '\P{isdeva}', "");
    Expect(0, 43264, '\P{^isdeva}', "");
    Expect(1, 43263, '\p{	is_Deva}', "");
    Expect(0, 43263, '\p{^	is_Deva}', "");
    Expect(0, 43263, '\P{	is_Deva}', "");
    Expect(1, 43263, '\P{^	is_Deva}', "");
    Expect(0, 43264, '\p{	is_Deva}', "");
    Expect(1, 43264, '\p{^	is_Deva}', "");
    Expect(1, 43264, '\P{	is_Deva}', "");
    Expect(0, 43264, '\P{^	is_Deva}', "");
    Error('\p{/a/Devanagari_Extended}');
    Error('\P{/a/Devanagari_Extended}');
    Expect(1, 43263, '\p{devanagariextended}', "");
    Expect(0, 43263, '\p{^devanagariextended}', "");
    Expect(0, 43263, '\P{devanagariextended}', "");
    Expect(1, 43263, '\P{^devanagariextended}', "");
    Expect(0, 43264, '\p{devanagariextended}', "");
    Expect(1, 43264, '\p{^devanagariextended}', "");
    Expect(1, 43264, '\P{devanagariextended}', "");
    Expect(0, 43264, '\P{^devanagariextended}', "");
    Expect(1, 43263, '\p{_ devanagari_Extended}', "");
    Expect(0, 43263, '\p{^_ devanagari_Extended}', "");
    Expect(0, 43263, '\P{_ devanagari_Extended}', "");
    Expect(1, 43263, '\P{^_ devanagari_Extended}', "");
    Expect(0, 43264, '\p{_ devanagari_Extended}', "");
    Expect(1, 43264, '\p{^_ devanagari_Extended}', "");
    Expect(1, 43264, '\P{_ devanagari_Extended}', "");
    Expect(0, 43264, '\P{^_ devanagari_Extended}', "");
    Error('\p{	/a/is_DEVANAGARI_Extended}');
    Error('\P{	/a/is_DEVANAGARI_Extended}');
    Expect(1, 43263, '\p{isdevanagariextended}', "");
    Expect(0, 43263, '\p{^isdevanagariextended}', "");
    Expect(0, 43263, '\P{isdevanagariextended}', "");
    Expect(1, 43263, '\P{^isdevanagariextended}', "");
    Expect(0, 43264, '\p{isdevanagariextended}', "");
    Expect(1, 43264, '\p{^isdevanagariextended}', "");
    Expect(1, 43264, '\P{isdevanagariextended}', "");
    Expect(0, 43264, '\P{^isdevanagariextended}', "");
    Expect(1, 43263, '\p{_-IS_devanagari_extended}', "");
    Expect(0, 43263, '\p{^_-IS_devanagari_extended}', "");
    Expect(0, 43263, '\P{_-IS_devanagari_extended}', "");
    Expect(1, 43263, '\P{^_-IS_devanagari_extended}', "");
    Expect(0, 43264, '\p{_-IS_devanagari_extended}', "");
    Expect(1, 43264, '\p{^_-IS_devanagari_extended}', "");
    Expect(1, 43264, '\P{_-IS_devanagari_extended}', "");
    Expect(0, 43264, '\P{^_-IS_devanagari_extended}', "");
    Error('\p{/a/	in_DEVANAGARI_Extended}');
    Error('\P{/a/	in_DEVANAGARI_Extended}');
    Expect(1, 43263, '\p{indevanagariextended}', "");
    Expect(0, 43263, '\p{^indevanagariextended}', "");
    Expect(0, 43263, '\P{indevanagariextended}', "");
    Expect(1, 43263, '\P{^indevanagariextended}', "");
    Expect(0, 43264, '\p{indevanagariextended}', "");
    Expect(1, 43264, '\p{^indevanagariextended}', "");
    Expect(1, 43264, '\P{indevanagariextended}', "");
    Expect(0, 43264, '\P{^indevanagariextended}', "");
    Expect(1, 43263, '\p{ _IN_Devanagari_Extended}', "");
    Expect(0, 43263, '\p{^ _IN_Devanagari_Extended}', "");
    Expect(0, 43263, '\P{ _IN_Devanagari_Extended}', "");
    Expect(1, 43263, '\P{^ _IN_Devanagari_Extended}', "");
    Expect(0, 43264, '\p{ _IN_Devanagari_Extended}', "");
    Expect(1, 43264, '\p{^ _IN_Devanagari_Extended}', "");
    Expect(1, 43264, '\P{ _IN_Devanagari_Extended}', "");
    Expect(0, 43264, '\P{^ _IN_Devanagari_Extended}', "");
    Error('\p{:= _devanagari_Ext}');
    Error('\P{:= _devanagari_Ext}');
    Expect(1, 43263, '\p{devanagariext}', "");
    Expect(0, 43263, '\p{^devanagariext}', "");
    Expect(0, 43263, '\P{devanagariext}', "");
    Expect(1, 43263, '\P{^devanagariext}', "");
    Expect(0, 43264, '\p{devanagariext}', "");
    Expect(1, 43264, '\p{^devanagariext}', "");
    Expect(1, 43264, '\P{devanagariext}', "");
    Expect(0, 43264, '\P{^devanagariext}', "");
    Expect(1, 43263, '\p{	-Devanagari_ext}', "");
    Expect(0, 43263, '\p{^	-Devanagari_ext}', "");
    Expect(0, 43263, '\P{	-Devanagari_ext}', "");
    Expect(1, 43263, '\P{^	-Devanagari_ext}', "");
    Expect(0, 43264, '\p{	-Devanagari_ext}', "");
    Expect(1, 43264, '\p{^	-Devanagari_ext}', "");
    Expect(1, 43264, '\P{	-Devanagari_ext}', "");
    Expect(0, 43264, '\P{^	-Devanagari_ext}', "");
    Error('\p{/a/	_IS_devanagari_EXT}');
    Error('\P{/a/	_IS_devanagari_EXT}');
    Expect(1, 43263, '\p{isdevanagariext}', "");
    Expect(0, 43263, '\p{^isdevanagariext}', "");
    Expect(0, 43263, '\P{isdevanagariext}', "");
    Expect(1, 43263, '\P{^isdevanagariext}', "");
    Expect(0, 43264, '\p{isdevanagariext}', "");
    Expect(1, 43264, '\p{^isdevanagariext}', "");
    Expect(1, 43264, '\P{isdevanagariext}', "");
    Expect(0, 43264, '\P{^isdevanagariext}', "");
    Expect(1, 43263, '\p{--Is_Devanagari_EXT}', "");
    Expect(0, 43263, '\p{^--Is_Devanagari_EXT}', "");
    Expect(0, 43263, '\P{--Is_Devanagari_EXT}', "");
    Expect(1, 43263, '\P{^--Is_Devanagari_EXT}', "");
    Expect(0, 43264, '\p{--Is_Devanagari_EXT}', "");
    Expect(1, 43264, '\p{^--Is_Devanagari_EXT}', "");
    Expect(1, 43264, '\P{--Is_Devanagari_EXT}', "");
    Expect(0, 43264, '\P{^--Is_Devanagari_EXT}', "");
    Error('\p{:=In_Devanagari_Ext}');
    Error('\P{:=In_Devanagari_Ext}');
    Expect(1, 43263, '\p{indevanagariext}', "");
    Expect(0, 43263, '\p{^indevanagariext}', "");
    Expect(0, 43263, '\P{indevanagariext}', "");
    Expect(1, 43263, '\P{^indevanagariext}', "");
    Expect(0, 43264, '\p{indevanagariext}', "");
    Expect(1, 43264, '\p{^indevanagariext}', "");
    Expect(1, 43264, '\P{indevanagariext}', "");
    Expect(0, 43264, '\P{^indevanagariext}', "");
    Expect(1, 43263, '\p{	In_Devanagari_ext}', "");
    Expect(0, 43263, '\p{^	In_Devanagari_ext}', "");
    Expect(0, 43263, '\P{	In_Devanagari_ext}', "");
    Expect(1, 43263, '\P{^	In_Devanagari_ext}', "");
    Expect(0, 43264, '\p{	In_Devanagari_ext}', "");
    Expect(1, 43264, '\p{^	In_Devanagari_ext}', "");
    Expect(1, 43264, '\P{	In_Devanagari_ext}', "");
    Expect(0, 43264, '\P{^	In_Devanagari_ext}', "");
    Error('\p{/a/ 	DIACRITIC}');
    Error('\P{/a/ 	DIACRITIC}');
    Expect(1, 125258, '\p{diacritic}', "");
    Expect(0, 125258, '\p{^diacritic}', "");
    Expect(0, 125258, '\P{diacritic}', "");
    Expect(1, 125258, '\P{^diacritic}', "");
    Expect(0, 125259, '\p{diacritic}', "");
    Expect(1, 125259, '\p{^diacritic}', "");
    Expect(1, 125259, '\P{diacritic}', "");
    Expect(0, 125259, '\P{^diacritic}', "");
    Expect(1, 125258, '\p{ DIACRITIC}', "");
    Expect(0, 125258, '\p{^ DIACRITIC}', "");
    Expect(0, 125258, '\P{ DIACRITIC}', "");
    Expect(1, 125258, '\P{^ DIACRITIC}', "");
    Expect(0, 125259, '\p{ DIACRITIC}', "");
    Expect(1, 125259, '\p{^ DIACRITIC}', "");
    Expect(1, 125259, '\P{ DIACRITIC}', "");
    Expect(0, 125259, '\P{^ DIACRITIC}', "");
    Error('\p{-:=is_diacritic}');
    Error('\P{-:=is_diacritic}');
    Expect(1, 125258, '\p{isdiacritic}', "");
    Expect(0, 125258, '\p{^isdiacritic}', "");
    Expect(0, 125258, '\P{isdiacritic}', "");
    Expect(1, 125258, '\P{^isdiacritic}', "");
    Expect(0, 125259, '\p{isdiacritic}', "");
    Expect(1, 125259, '\p{^isdiacritic}', "");
    Expect(1, 125259, '\P{isdiacritic}', "");
    Expect(0, 125259, '\P{^isdiacritic}', "");
    Expect(1, 125258, '\p{_ Is_Diacritic}', "");
    Expect(0, 125258, '\p{^_ Is_Diacritic}', "");
    Expect(0, 125258, '\P{_ Is_Diacritic}', "");
    Expect(1, 125258, '\P{^_ Is_Diacritic}', "");
    Expect(0, 125259, '\p{_ Is_Diacritic}', "");
    Expect(1, 125259, '\p{^_ Is_Diacritic}', "");
    Expect(1, 125259, '\P{_ Is_Diacritic}', "");
    Expect(0, 125259, '\P{^_ Is_Diacritic}', "");
    Error('\p{	_DIA/a/}');
    Error('\P{	_DIA/a/}');
    Expect(1, 125258, '\p{dia}', "");
    Expect(0, 125258, '\p{^dia}', "");
    Expect(0, 125258, '\P{dia}', "");
    Expect(1, 125258, '\P{^dia}', "");
    Expect(0, 125259, '\p{dia}', "");
    Expect(1, 125259, '\p{^dia}', "");
    Expect(1, 125259, '\P{dia}', "");
    Expect(0, 125259, '\P{^dia}', "");
    Expect(1, 125258, '\p{-_dia}', "");
    Expect(0, 125258, '\p{^-_dia}', "");
    Expect(0, 125258, '\P{-_dia}', "");
    Expect(1, 125258, '\P{^-_dia}', "");
    Expect(0, 125259, '\p{-_dia}', "");
    Expect(1, 125259, '\p{^-_dia}', "");
    Expect(1, 125259, '\P{-_dia}', "");
    Expect(0, 125259, '\P{^-_dia}', "");
    Error('\p{	/a/IS_Dia}');
    Error('\P{	/a/IS_Dia}');
    Expect(1, 125258, '\p{isdia}', "");
    Expect(0, 125258, '\p{^isdia}', "");
    Expect(0, 125258, '\P{isdia}', "");
    Expect(1, 125258, '\P{^isdia}', "");
    Expect(0, 125259, '\p{isdia}', "");
    Expect(1, 125259, '\p{^isdia}', "");
    Expect(1, 125259, '\P{isdia}', "");
    Expect(0, 125259, '\P{^isdia}', "");
    Expect(1, 125258, '\p{_is_DIA}', "");
    Expect(0, 125258, '\p{^_is_DIA}', "");
    Expect(0, 125258, '\P{_is_DIA}', "");
    Expect(1, 125258, '\P{^_is_DIA}', "");
    Expect(0, 125259, '\p{_is_DIA}', "");
    Expect(1, 125259, '\p{^_is_DIA}', "");
    Expect(1, 125259, '\P{_is_DIA}', "");
    Expect(0, 125259, '\P{^_is_DIA}', "");
    Error('\p{_XPosixDigit:=}');
    Error('\P{_XPosixDigit:=}');
    Expect(1, 130041, '\p{xposixdigit}', "");
    Expect(0, 130041, '\p{^xposixdigit}', "");
    Expect(0, 130041, '\P{xposixdigit}', "");
    Expect(1, 130041, '\P{^xposixdigit}', "");
    Expect(0, 130042, '\p{xposixdigit}', "");
    Expect(1, 130042, '\p{^xposixdigit}', "");
    Expect(1, 130042, '\P{xposixdigit}', "");
    Expect(0, 130042, '\P{^xposixdigit}', "");
    Expect(1, 130041, '\p{XPosixDigit}', "");
    Expect(0, 130041, '\p{^XPosixDigit}', "");
    Expect(0, 130041, '\P{XPosixDigit}', "");
    Expect(1, 130041, '\P{^XPosixDigit}', "");
    Expect(0, 130042, '\p{XPosixDigit}', "");
    Expect(1, 130042, '\p{^XPosixDigit}', "");
    Expect(1, 130042, '\P{XPosixDigit}', "");
    Expect(0, 130042, '\P{^XPosixDigit}', "");
    Error('\p{	_DIGIT/a/}');
    Error('\P{	_DIGIT/a/}');
    Expect(1, 130041, '\p{digit}', "");
    Expect(0, 130041, '\p{^digit}', "");
    Expect(0, 130041, '\P{digit}', "");
    Expect(1, 130041, '\P{^digit}', "");
    Expect(0, 130042, '\p{digit}', "");
    Expect(1, 130042, '\p{^digit}', "");
    Expect(1, 130042, '\P{digit}', "");
    Expect(0, 130042, '\P{^digit}', "");
    Expect(1, 130041, '\p{- Digit}', "");
    Expect(0, 130041, '\p{^- Digit}', "");
    Expect(0, 130041, '\P{- Digit}', "");
    Expect(1, 130041, '\P{^- Digit}', "");
    Expect(0, 130042, '\p{- Digit}', "");
    Expect(1, 130042, '\p{^- Digit}', "");
    Expect(1, 130042, '\P{- Digit}', "");
    Expect(0, 130042, '\P{^- Digit}', "");
    Error('\p{ :=Is_xposixdigit}');
    Error('\P{ :=Is_xposixdigit}');
    Expect(1, 130041, '\p{isxposixdigit}', "");
    Expect(0, 130041, '\p{^isxposixdigit}', "");
    Expect(0, 130041, '\P{isxposixdigit}', "");
    Expect(1, 130041, '\P{^isxposixdigit}', "");
    Expect(0, 130042, '\p{isxposixdigit}', "");
    Expect(1, 130042, '\p{^isxposixdigit}', "");
    Expect(1, 130042, '\P{isxposixdigit}', "");
    Expect(0, 130042, '\P{^isxposixdigit}', "");
    Expect(1, 130041, '\p{-Is_xposixdigit}', "");
    Expect(0, 130041, '\p{^-Is_xposixdigit}', "");
    Expect(0, 130041, '\P{-Is_xposixdigit}', "");
    Expect(1, 130041, '\P{^-Is_xposixdigit}', "");
    Expect(0, 130042, '\p{-Is_xposixdigit}', "");
    Expect(1, 130042, '\p{^-Is_xposixdigit}', "");
    Expect(1, 130042, '\P{-Is_xposixdigit}', "");
    Expect(0, 130042, '\P{^-Is_xposixdigit}', "");
    Error('\p{:=Is_DIGIT}');
    Error('\P{:=Is_DIGIT}');
    Expect(1, 130041, '\p{isdigit}', "");
    Expect(0, 130041, '\p{^isdigit}', "");
    Expect(0, 130041, '\P{isdigit}', "");
    Expect(1, 130041, '\P{^isdigit}', "");
    Expect(0, 130042, '\p{isdigit}', "");
    Expect(1, 130042, '\p{^isdigit}', "");
    Expect(1, 130042, '\P{isdigit}', "");
    Expect(0, 130042, '\P{^isdigit}', "");
    Expect(1, 130041, '\p{	IS_DIGIT}', "");
    Expect(0, 130041, '\p{^	IS_DIGIT}', "");
    Expect(0, 130041, '\P{	IS_DIGIT}', "");
    Expect(1, 130041, '\P{^	IS_DIGIT}', "");
    Expect(0, 130042, '\p{	IS_DIGIT}', "");
    Expect(1, 130042, '\p{^	IS_DIGIT}', "");
    Expect(1, 130042, '\P{	IS_DIGIT}', "");
    Expect(0, 130042, '\P{^	IS_DIGIT}', "");
    Error('\p{	/a/DECIMAL_Number}');
    Error('\P{	/a/DECIMAL_Number}');
    Expect(1, 130041, '\p{decimalnumber}', "");
    Expect(0, 130041, '\p{^decimalnumber}', "");
    Expect(0, 130041, '\P{decimalnumber}', "");
    Expect(1, 130041, '\P{^decimalnumber}', "");
    Expect(0, 130042, '\p{decimalnumber}', "");
    Expect(1, 130042, '\p{^decimalnumber}', "");
    Expect(1, 130042, '\P{decimalnumber}', "");
    Expect(0, 130042, '\P{^decimalnumber}', "");
    Expect(1, 130041, '\p{-_decimal_NUMBER}', "");
    Expect(0, 130041, '\p{^-_decimal_NUMBER}', "");
    Expect(0, 130041, '\P{-_decimal_NUMBER}', "");
    Expect(1, 130041, '\P{^-_decimal_NUMBER}', "");
    Expect(0, 130042, '\p{-_decimal_NUMBER}', "");
    Expect(1, 130042, '\p{^-_decimal_NUMBER}', "");
    Expect(1, 130042, '\P{-_decimal_NUMBER}', "");
    Expect(0, 130042, '\P{^-_decimal_NUMBER}', "");
    Error('\p{_:=Is_Decimal_number}');
    Error('\P{_:=Is_Decimal_number}');
    Expect(1, 130041, '\p{isdecimalnumber}', "");
    Expect(0, 130041, '\p{^isdecimalnumber}', "");
    Expect(0, 130041, '\P{isdecimalnumber}', "");
    Expect(1, 130041, '\P{^isdecimalnumber}', "");
    Expect(0, 130042, '\p{isdecimalnumber}', "");
    Expect(1, 130042, '\p{^isdecimalnumber}', "");
    Expect(1, 130042, '\P{isdecimalnumber}', "");
    Expect(0, 130042, '\P{^isdecimalnumber}', "");
    Expect(1, 130041, '\p{_Is_Decimal_Number}', "");
    Expect(0, 130041, '\p{^_Is_Decimal_Number}', "");
    Expect(0, 130041, '\P{_Is_Decimal_Number}', "");
    Expect(1, 130041, '\P{^_Is_Decimal_Number}', "");
    Expect(0, 130042, '\p{_Is_Decimal_Number}', "");
    Expect(1, 130042, '\p{^_Is_Decimal_Number}', "");
    Expect(1, 130042, '\P{_Is_Decimal_Number}', "");
    Expect(0, 130042, '\P{^_Is_Decimal_Number}', "");
    Error('\p{	:=Nd}');
    Error('\P{	:=Nd}');
    Expect(1, 130041, '\p{nd}', "");
    Expect(0, 130041, '\p{^nd}', "");
    Expect(0, 130041, '\P{nd}', "");
    Expect(1, 130041, '\P{^nd}', "");
    Expect(0, 130042, '\p{nd}', "");
    Expect(1, 130042, '\p{^nd}', "");
    Expect(1, 130042, '\P{nd}', "");
    Expect(0, 130042, '\P{^nd}', "");
    Expect(1, 130041, '\p{__Nd}', "");
    Expect(0, 130041, '\p{^__Nd}', "");
    Expect(0, 130041, '\P{__Nd}', "");
    Expect(1, 130041, '\P{^__Nd}', "");
    Expect(0, 130042, '\p{__Nd}', "");
    Expect(1, 130042, '\p{^__Nd}', "");
    Expect(1, 130042, '\P{__Nd}', "");
    Expect(0, 130042, '\P{^__Nd}', "");
    Error('\p{-/a/is_ND}');
    Error('\P{-/a/is_ND}');
    Expect(1, 130041, '\p{isnd}', "");
    Expect(0, 130041, '\p{^isnd}', "");
    Expect(0, 130041, '\P{isnd}', "");
    Expect(1, 130041, '\P{^isnd}', "");
    Expect(0, 130042, '\p{isnd}', "");
    Expect(1, 130042, '\p{^isnd}', "");
    Expect(1, 130042, '\P{isnd}', "");
    Expect(0, 130042, '\P{^isnd}', "");
    Expect(1, 130041, '\p{		is_Nd}', "");
    Expect(0, 130041, '\p{^		is_Nd}', "");
    Expect(0, 130041, '\P{		is_Nd}', "");
    Expect(1, 130041, '\P{^		is_Nd}', "");
    Expect(0, 130042, '\p{		is_Nd}', "");
    Expect(1, 130042, '\p{^		is_Nd}', "");
    Expect(1, 130042, '\P{		is_Nd}', "");
    Expect(0, 130042, '\P{^		is_Nd}', "");
    Error('\p{/a/  Dingbats}');
    Error('\P{/a/  Dingbats}');
    Expect(1, 10175, '\p{dingbats}', "");
    Expect(0, 10175, '\p{^dingbats}', "");
    Expect(0, 10175, '\P{dingbats}', "");
    Expect(1, 10175, '\P{^dingbats}', "");
    Expect(0, 10176, '\p{dingbats}', "");
    Expect(1, 10176, '\p{^dingbats}', "");
    Expect(1, 10176, '\P{dingbats}', "");
    Expect(0, 10176, '\P{^dingbats}', "");
    Expect(1, 10175, '\p{_dingbats}', "");
    Expect(0, 10175, '\p{^_dingbats}', "");
    Expect(0, 10175, '\P{_dingbats}', "");
    Expect(1, 10175, '\P{^_dingbats}', "");
    Expect(0, 10176, '\p{_dingbats}', "");
    Expect(1, 10176, '\p{^_dingbats}', "");
    Expect(1, 10176, '\P{_dingbats}', "");
    Expect(0, 10176, '\P{^_dingbats}', "");
    Error('\p{/a/	Is_DINGBATS}');
    Error('\P{/a/	Is_DINGBATS}');
    Expect(1, 10175, '\p{isdingbats}', "");
    Expect(0, 10175, '\p{^isdingbats}', "");
    Expect(0, 10175, '\P{isdingbats}', "");
    Expect(1, 10175, '\P{^isdingbats}', "");
    Expect(0, 10176, '\p{isdingbats}', "");
    Expect(1, 10176, '\p{^isdingbats}', "");
    Expect(1, 10176, '\P{isdingbats}', "");
    Expect(0, 10176, '\P{^isdingbats}', "");
    Expect(1, 10175, '\p{ -is_Dingbats}', "");
    Expect(0, 10175, '\p{^ -is_Dingbats}', "");
    Expect(0, 10175, '\P{ -is_Dingbats}', "");
    Expect(1, 10175, '\P{^ -is_Dingbats}', "");
    Expect(0, 10176, '\p{ -is_Dingbats}', "");
    Expect(1, 10176, '\p{^ -is_Dingbats}', "");
    Expect(1, 10176, '\P{ -is_Dingbats}', "");
    Expect(0, 10176, '\P{^ -is_Dingbats}', "");
    Error('\p{		In_Dingbats/a/}');
    Error('\P{		In_Dingbats/a/}');
    Expect(1, 10175, '\p{indingbats}', "");
    Expect(0, 10175, '\p{^indingbats}', "");
    Expect(0, 10175, '\P{indingbats}', "");
    Expect(1, 10175, '\P{^indingbats}', "");
    Expect(0, 10176, '\p{indingbats}', "");
    Expect(1, 10176, '\p{^indingbats}', "");
    Expect(1, 10176, '\P{indingbats}', "");
    Expect(0, 10176, '\P{^indingbats}', "");
    Expect(1, 10175, '\p{- In_DINGBATS}', "");
    Expect(0, 10175, '\p{^- In_DINGBATS}', "");
    Expect(0, 10175, '\P{- In_DINGBATS}', "");
    Expect(1, 10175, '\P{^- In_DINGBATS}', "");
    Expect(0, 10176, '\p{- In_DINGBATS}', "");
    Expect(1, 10176, '\p{^- In_DINGBATS}', "");
    Expect(1, 10176, '\P{- In_DINGBATS}', "");
    Expect(0, 10176, '\P{^- In_DINGBATS}', "");
    Error('\p{		Dives_AKURU:=}');
    Error('\P{		Dives_AKURU:=}');
    Expect(1, 72025, '\p{divesakuru}', "");
    Expect(0, 72025, '\p{^divesakuru}', "");
    Expect(0, 72025, '\P{divesakuru}', "");
    Expect(1, 72025, '\P{^divesakuru}', "");
    Expect(0, 72026, '\p{divesakuru}', "");
    Expect(1, 72026, '\p{^divesakuru}', "");
    Expect(1, 72026, '\P{divesakuru}', "");
    Expect(0, 72026, '\P{^divesakuru}', "");
    Expect(1, 72025, '\p{	_dives_Akuru}', "");
    Expect(0, 72025, '\p{^	_dives_Akuru}', "");
    Expect(0, 72025, '\P{	_dives_Akuru}', "");
    Expect(1, 72025, '\P{^	_dives_Akuru}', "");
    Expect(0, 72026, '\p{	_dives_Akuru}', "");
    Expect(1, 72026, '\p{^	_dives_Akuru}', "");
    Expect(1, 72026, '\P{	_dives_Akuru}', "");
    Expect(0, 72026, '\P{^	_dives_Akuru}', "");
    Error('\p{- Is_Dives_AKURU/a/}');
    Error('\P{- Is_Dives_AKURU/a/}');
    Expect(1, 72025, '\p{isdivesakuru}', "");
    Expect(0, 72025, '\p{^isdivesakuru}', "");
    Expect(0, 72025, '\P{isdivesakuru}', "");
    Expect(1, 72025, '\P{^isdivesakuru}', "");
    Expect(0, 72026, '\p{isdivesakuru}', "");
    Expect(1, 72026, '\p{^isdivesakuru}', "");
    Expect(1, 72026, '\P{isdivesakuru}', "");
    Expect(0, 72026, '\P{^isdivesakuru}', "");
    Expect(1, 72025, '\p{ _Is_dives_AKURU}', "");
    Expect(0, 72025, '\p{^ _Is_dives_AKURU}', "");
    Expect(0, 72025, '\P{ _Is_dives_AKURU}', "");
    Expect(1, 72025, '\P{^ _Is_dives_AKURU}', "");
    Expect(0, 72026, '\p{ _Is_dives_AKURU}', "");
    Expect(1, 72026, '\p{^ _Is_dives_AKURU}', "");
    Expect(1, 72026, '\P{ _Is_dives_AKURU}', "");
    Expect(0, 72026, '\P{^ _Is_dives_AKURU}', "");
    Error('\p{/a/Diak}');
    Error('\P{/a/Diak}');
    Expect(1, 72025, '\p{diak}', "");
    Expect(0, 72025, '\p{^diak}', "");
    Expect(0, 72025, '\P{diak}', "");
    Expect(1, 72025, '\P{^diak}', "");
    Expect(0, 72026, '\p{diak}', "");
    Expect(1, 72026, '\p{^diak}', "");
    Expect(1, 72026, '\P{diak}', "");
    Expect(0, 72026, '\P{^diak}', "");
    Expect(1, 72025, '\p{-	diak}', "");
    Expect(0, 72025, '\p{^-	diak}', "");
    Expect(0, 72025, '\P{-	diak}', "");
    Expect(1, 72025, '\P{^-	diak}', "");
    Expect(0, 72026, '\p{-	diak}', "");
    Expect(1, 72026, '\p{^-	diak}', "");
    Expect(1, 72026, '\P{-	diak}', "");
    Expect(0, 72026, '\P{^-	diak}', "");
    Error('\p{:=IS_DIAK}');
    Error('\P{:=IS_DIAK}');
    Expect(1, 72025, '\p{isdiak}', "");
    Expect(0, 72025, '\p{^isdiak}', "");
    Expect(0, 72025, '\P{isdiak}', "");
    Expect(1, 72025, '\P{^isdiak}', "");
    Expect(0, 72026, '\p{isdiak}', "");
    Expect(1, 72026, '\p{^isdiak}', "");
    Expect(1, 72026, '\P{isdiak}', "");
    Expect(0, 72026, '\P{^isdiak}', "");
    Expect(1, 72025, '\p{	-IS_Diak}', "");
    Expect(0, 72025, '\p{^	-IS_Diak}', "");
    Expect(0, 72025, '\P{	-IS_Diak}', "");
    Expect(1, 72025, '\P{^	-IS_Diak}', "");
    Expect(0, 72026, '\p{	-IS_Diak}', "");
    Expect(1, 72026, '\p{^	-IS_Diak}', "");
    Expect(1, 72026, '\P{	-IS_Diak}', "");
    Expect(0, 72026, '\P{^	-IS_Diak}', "");
    Error('\p{_/a/Dogra}');
    Error('\P{_/a/Dogra}');
    Expect(1, 71739, '\p{dogra}', "");
    Expect(0, 71739, '\p{^dogra}', "");
    Expect(0, 71739, '\P{dogra}', "");
    Expect(1, 71739, '\P{^dogra}', "");
    Expect(0, 71740, '\p{dogra}', "");
    Expect(1, 71740, '\p{^dogra}', "");
    Expect(1, 71740, '\P{dogra}', "");
    Expect(0, 71740, '\P{^dogra}', "");
    Expect(1, 71739, '\p{	 Dogra}', "");
    Expect(0, 71739, '\p{^	 Dogra}', "");
    Expect(0, 71739, '\P{	 Dogra}', "");
    Expect(1, 71739, '\P{^	 Dogra}', "");
    Expect(0, 71740, '\p{	 Dogra}', "");
    Expect(1, 71740, '\p{^	 Dogra}', "");
    Expect(1, 71740, '\P{	 Dogra}', "");
    Expect(0, 71740, '\P{^	 Dogra}', "");
    Error('\p{:= -is_dogra}');
    Error('\P{:= -is_dogra}');
    Expect(1, 71739, '\p{isdogra}', "");
    Expect(0, 71739, '\p{^isdogra}', "");
    Expect(0, 71739, '\P{isdogra}', "");
    Expect(1, 71739, '\P{^isdogra}', "");
    Expect(0, 71740, '\p{isdogra}', "");
    Expect(1, 71740, '\p{^isdogra}', "");
    Expect(1, 71740, '\P{isdogra}', "");
    Expect(0, 71740, '\P{^isdogra}', "");
    Expect(1, 71739, '\p{	-IS_DOGRA}', "");
    Expect(0, 71739, '\p{^	-IS_DOGRA}', "");
    Expect(0, 71739, '\P{	-IS_DOGRA}', "");
    Expect(1, 71739, '\P{^	-IS_DOGRA}', "");
    Expect(0, 71740, '\p{	-IS_DOGRA}', "");
    Expect(1, 71740, '\p{^	-IS_DOGRA}', "");
    Expect(1, 71740, '\P{	-IS_DOGRA}', "");
    Expect(0, 71740, '\P{^	-IS_DOGRA}', "");
    Error('\p{-_Dogr:=}');
    Error('\P{-_Dogr:=}');
    Expect(1, 71739, '\p{dogr}', "");
    Expect(0, 71739, '\p{^dogr}', "");
    Expect(0, 71739, '\P{dogr}', "");
    Expect(1, 71739, '\P{^dogr}', "");
    Expect(0, 71740, '\p{dogr}', "");
    Expect(1, 71740, '\p{^dogr}', "");
    Expect(1, 71740, '\P{dogr}', "");
    Expect(0, 71740, '\P{^dogr}', "");
    Expect(1, 71739, '\p{ DOGR}', "");
    Expect(0, 71739, '\p{^ DOGR}', "");
    Expect(0, 71739, '\P{ DOGR}', "");
    Expect(1, 71739, '\P{^ DOGR}', "");
    Expect(0, 71740, '\p{ DOGR}', "");
    Expect(1, 71740, '\p{^ DOGR}', "");
    Expect(1, 71740, '\P{ DOGR}', "");
    Expect(0, 71740, '\P{^ DOGR}', "");
    Error('\p{ -is_dogr:=}');
    Error('\P{ -is_dogr:=}');
    Expect(1, 71739, '\p{isdogr}', "");
    Expect(0, 71739, '\p{^isdogr}', "");
    Expect(0, 71739, '\P{isdogr}', "");
    Expect(1, 71739, '\P{^isdogr}', "");
    Expect(0, 71740, '\p{isdogr}', "");
    Expect(1, 71740, '\p{^isdogr}', "");
    Expect(1, 71740, '\P{isdogr}', "");
    Expect(0, 71740, '\P{^isdogr}', "");
    Expect(1, 71739, '\p{	-IS_dogr}', "");
    Expect(0, 71739, '\p{^	-IS_dogr}', "");
    Expect(0, 71739, '\P{	-IS_dogr}', "");
    Expect(1, 71739, '\P{^	-IS_dogr}', "");
    Expect(0, 71740, '\p{	-IS_dogr}', "");
    Expect(1, 71740, '\p{^	-IS_dogr}', "");
    Expect(1, 71740, '\P{	-IS_dogr}', "");
    Expect(0, 71740, '\P{^	-IS_dogr}', "");
    Error('\p{__Domino_Tiles/a/}');
    Error('\P{__Domino_Tiles/a/}');
    Expect(1, 127135, '\p{dominotiles}', "");
    Expect(0, 127135, '\p{^dominotiles}', "");
    Expect(0, 127135, '\P{dominotiles}', "");
    Expect(1, 127135, '\P{^dominotiles}', "");
    Expect(0, 127136, '\p{dominotiles}', "");
    Expect(1, 127136, '\p{^dominotiles}', "");
    Expect(1, 127136, '\P{dominotiles}', "");
    Expect(0, 127136, '\P{^dominotiles}', "");
    Expect(1, 127135, '\p{- domino_Tiles}', "");
    Expect(0, 127135, '\p{^- domino_Tiles}', "");
    Expect(0, 127135, '\P{- domino_Tiles}', "");
    Expect(1, 127135, '\P{^- domino_Tiles}', "");
    Expect(0, 127136, '\p{- domino_Tiles}', "");
    Expect(1, 127136, '\p{^- domino_Tiles}', "");
    Expect(1, 127136, '\P{- domino_Tiles}', "");
    Expect(0, 127136, '\P{^- domino_Tiles}', "");
    Error('\p{  Is_DOMINO_TILES/a/}');
    Error('\P{  Is_DOMINO_TILES/a/}');
    Expect(1, 127135, '\p{isdominotiles}', "");
    Expect(0, 127135, '\p{^isdominotiles}', "");
    Expect(0, 127135, '\P{isdominotiles}', "");
    Expect(1, 127135, '\P{^isdominotiles}', "");
    Expect(0, 127136, '\p{isdominotiles}', "");
    Expect(1, 127136, '\p{^isdominotiles}', "");
    Expect(1, 127136, '\P{isdominotiles}', "");
    Expect(0, 127136, '\P{^isdominotiles}', "");
    Expect(1, 127135, '\p{_-Is_domino_Tiles}', "");
    Expect(0, 127135, '\p{^_-Is_domino_Tiles}', "");
    Expect(0, 127135, '\P{_-Is_domino_Tiles}', "");
    Expect(1, 127135, '\P{^_-Is_domino_Tiles}', "");
    Expect(0, 127136, '\p{_-Is_domino_Tiles}', "");
    Expect(1, 127136, '\p{^_-Is_domino_Tiles}', "");
    Expect(1, 127136, '\P{_-Is_domino_Tiles}', "");
    Expect(0, 127136, '\P{^_-Is_domino_Tiles}', "");
    Error('\p{	IN_DOMINO_Tiles:=}');
    Error('\P{	IN_DOMINO_Tiles:=}');
    Expect(1, 127135, '\p{indominotiles}', "");
    Expect(0, 127135, '\p{^indominotiles}', "");
    Expect(0, 127135, '\P{indominotiles}', "");
    Expect(1, 127135, '\P{^indominotiles}', "");
    Expect(0, 127136, '\p{indominotiles}', "");
    Expect(1, 127136, '\p{^indominotiles}', "");
    Expect(1, 127136, '\P{indominotiles}', "");
    Expect(0, 127136, '\P{^indominotiles}', "");
    Expect(1, 127135, '\p{_	in_DOMINO_Tiles}', "");
    Expect(0, 127135, '\p{^_	in_DOMINO_Tiles}', "");
    Expect(0, 127135, '\P{_	in_DOMINO_Tiles}', "");
    Expect(1, 127135, '\P{^_	in_DOMINO_Tiles}', "");
    Expect(0, 127136, '\p{_	in_DOMINO_Tiles}', "");
    Expect(1, 127136, '\p{^_	in_DOMINO_Tiles}', "");
    Expect(1, 127136, '\P{_	in_DOMINO_Tiles}', "");
    Expect(0, 127136, '\P{^_	in_DOMINO_Tiles}', "");
    Error('\p{Domino/a/}');
    Error('\P{Domino/a/}');
    Expect(1, 127135, '\p{domino}', "");
    Expect(0, 127135, '\p{^domino}', "");
    Expect(0, 127135, '\P{domino}', "");
    Expect(1, 127135, '\P{^domino}', "");
    Expect(0, 127136, '\p{domino}', "");
    Expect(1, 127136, '\p{^domino}', "");
    Expect(1, 127136, '\P{domino}', "");
    Expect(0, 127136, '\P{^domino}', "");
    Expect(1, 127135, '\p{Domino}', "");
    Expect(0, 127135, '\p{^Domino}', "");
    Expect(0, 127135, '\P{Domino}', "");
    Expect(1, 127135, '\P{^Domino}', "");
    Expect(0, 127136, '\p{Domino}', "");
    Expect(1, 127136, '\p{^Domino}', "");
    Expect(1, 127136, '\P{Domino}', "");
    Expect(0, 127136, '\P{^Domino}', "");
    Error('\p{	Is_Domino/a/}');
    Error('\P{	Is_Domino/a/}');
    Expect(1, 127135, '\p{isdomino}', "");
    Expect(0, 127135, '\p{^isdomino}', "");
    Expect(0, 127135, '\P{isdomino}', "");
    Expect(1, 127135, '\P{^isdomino}', "");
    Expect(0, 127136, '\p{isdomino}', "");
    Expect(1, 127136, '\p{^isdomino}', "");
    Expect(1, 127136, '\P{isdomino}', "");
    Expect(0, 127136, '\P{^isdomino}', "");
    Expect(1, 127135, '\p{_-Is_domino}', "");
    Expect(0, 127135, '\p{^_-Is_domino}', "");
    Expect(0, 127135, '\P{_-Is_domino}', "");
    Expect(1, 127135, '\P{^_-Is_domino}', "");
    Expect(0, 127136, '\p{_-Is_domino}', "");
    Expect(1, 127136, '\p{^_-Is_domino}', "");
    Expect(1, 127136, '\P{_-Is_domino}', "");
    Expect(0, 127136, '\P{^_-Is_domino}', "");
    Error('\p{/a/-IN_Domino}');
    Error('\P{/a/-IN_Domino}');
    Expect(1, 127135, '\p{indomino}', "");
    Expect(0, 127135, '\p{^indomino}', "");
    Expect(0, 127135, '\P{indomino}', "");
    Expect(1, 127135, '\P{^indomino}', "");
    Expect(0, 127136, '\p{indomino}', "");
    Expect(1, 127136, '\p{^indomino}', "");
    Expect(1, 127136, '\P{indomino}', "");
    Expect(0, 127136, '\P{^indomino}', "");
    Expect(1, 127135, '\p{ _In_Domino}', "");
    Expect(0, 127135, '\p{^ _In_Domino}', "");
    Expect(0, 127135, '\P{ _In_Domino}', "");
    Expect(1, 127135, '\P{^ _In_Domino}', "");
    Expect(0, 127136, '\p{ _In_Domino}', "");
    Expect(1, 127136, '\p{^ _In_Domino}', "");
    Expect(1, 127136, '\P{ _In_Domino}', "");
    Expect(0, 127136, '\P{^ _In_Domino}', "");
    Error('\p{/a/DUPLOYAN}');
    Error('\P{/a/DUPLOYAN}');
    Expect(1, 113827, '\p{duployan}', "");
    Expect(0, 113827, '\p{^duployan}', "");
    Expect(0, 113827, '\P{duployan}', "");
    Expect(1, 113827, '\P{^duployan}', "");
    Expect(0, 113828, '\p{duployan}', "");
    Expect(1, 113828, '\p{^duployan}', "");
    Expect(1, 113828, '\P{duployan}', "");
    Expect(0, 113828, '\P{^duployan}', "");
    Expect(1, 113827, '\p{ 	duployan}', "");
    Expect(0, 113827, '\p{^ 	duployan}', "");
    Expect(0, 113827, '\P{ 	duployan}', "");
    Expect(1, 113827, '\P{^ 	duployan}', "");
    Expect(0, 113828, '\p{ 	duployan}', "");
    Expect(1, 113828, '\p{^ 	duployan}', "");
    Expect(1, 113828, '\P{ 	duployan}', "");
    Expect(0, 113828, '\P{^ 	duployan}', "");
    Error('\p{/a/__IS_duployan}');
    Error('\P{/a/__IS_duployan}');
    Expect(1, 113827, '\p{isduployan}', "");
    Expect(0, 113827, '\p{^isduployan}', "");
    Expect(0, 113827, '\P{isduployan}', "");
    Expect(1, 113827, '\P{^isduployan}', "");
    Expect(0, 113828, '\p{isduployan}', "");
    Expect(1, 113828, '\p{^isduployan}', "");
    Expect(1, 113828, '\P{isduployan}', "");
    Expect(0, 113828, '\P{^isduployan}', "");
    Expect(1, 113827, '\p{	 Is_Duployan}', "");
    Expect(0, 113827, '\p{^	 Is_Duployan}', "");
    Expect(0, 113827, '\P{	 Is_Duployan}', "");
    Expect(1, 113827, '\P{^	 Is_Duployan}', "");
    Expect(0, 113828, '\p{	 Is_Duployan}', "");
    Expect(1, 113828, '\p{^	 Is_Duployan}', "");
    Expect(1, 113828, '\P{	 Is_Duployan}', "");
    Expect(0, 113828, '\P{^	 Is_Duployan}', "");
    Error('\p{		Dupl/a/}');
    Error('\P{		Dupl/a/}');
    Expect(1, 113827, '\p{dupl}', "");
    Expect(0, 113827, '\p{^dupl}', "");
    Expect(0, 113827, '\P{dupl}', "");
    Expect(1, 113827, '\P{^dupl}', "");
    Expect(0, 113828, '\p{dupl}', "");
    Expect(1, 113828, '\p{^dupl}', "");
    Expect(1, 113828, '\P{dupl}', "");
    Expect(0, 113828, '\P{^dupl}', "");
    Expect(1, 113827, '\p{_	dupl}', "");
    Expect(0, 113827, '\p{^_	dupl}', "");
    Expect(0, 113827, '\P{_	dupl}', "");
    Expect(1, 113827, '\P{^_	dupl}', "");
    Expect(0, 113828, '\p{_	dupl}', "");
    Expect(1, 113828, '\p{^_	dupl}', "");
    Expect(1, 113828, '\P{_	dupl}', "");
    Expect(0, 113828, '\P{^_	dupl}', "");
    Error('\p{/a/ _is_dupl}');
    Error('\P{/a/ _is_dupl}');
    Expect(1, 113827, '\p{isdupl}', "");
    Expect(0, 113827, '\p{^isdupl}', "");
    Expect(0, 113827, '\P{isdupl}', "");
    Expect(1, 113827, '\P{^isdupl}', "");
    Expect(0, 113828, '\p{isdupl}', "");
    Expect(1, 113828, '\p{^isdupl}', "");
    Expect(1, 113828, '\P{isdupl}', "");
    Expect(0, 113828, '\P{^isdupl}', "");
    Expect(1, 113827, '\p{	 Is_Dupl}', "");
    Expect(0, 113827, '\p{^	 Is_Dupl}', "");
    Expect(0, 113827, '\P{	 Is_Dupl}', "");
    Expect(1, 113827, '\P{^	 Is_Dupl}', "");
    Expect(0, 113828, '\p{	 Is_Dupl}', "");
    Expect(1, 113828, '\p{^	 Is_Dupl}', "");
    Expect(1, 113828, '\P{	 Is_Dupl}', "");
    Expect(0, 113828, '\P{^	 Is_Dupl}', "");
    Error('\p{-EARLY_dynastic_Cuneiform/a/}');
    Error('\P{-EARLY_dynastic_Cuneiform/a/}');
    Expect(1, 75087, '\p{earlydynasticcuneiform}', "");
    Expect(0, 75087, '\p{^earlydynasticcuneiform}', "");
    Expect(0, 75087, '\P{earlydynasticcuneiform}', "");
    Expect(1, 75087, '\P{^earlydynasticcuneiform}', "");
    Expect(0, 75088, '\p{earlydynasticcuneiform}', "");
    Expect(1, 75088, '\p{^earlydynasticcuneiform}', "");
    Expect(1, 75088, '\P{earlydynasticcuneiform}', "");
    Expect(0, 75088, '\P{^earlydynasticcuneiform}', "");
    Expect(1, 75087, '\p{_Early_Dynastic_CUNEIFORM}', "");
    Expect(0, 75087, '\p{^_Early_Dynastic_CUNEIFORM}', "");
    Expect(0, 75087, '\P{_Early_Dynastic_CUNEIFORM}', "");
    Expect(1, 75087, '\P{^_Early_Dynastic_CUNEIFORM}', "");
    Expect(0, 75088, '\p{_Early_Dynastic_CUNEIFORM}', "");
    Expect(1, 75088, '\p{^_Early_Dynastic_CUNEIFORM}', "");
    Expect(1, 75088, '\P{_Early_Dynastic_CUNEIFORM}', "");
    Expect(0, 75088, '\P{^_Early_Dynastic_CUNEIFORM}', "");
    Error('\p{-:=Is_early_DYNASTIC_CUNEIFORM}');
    Error('\P{-:=Is_early_DYNASTIC_CUNEIFORM}');
    Expect(1, 75087, '\p{isearlydynasticcuneiform}', "");
    Expect(0, 75087, '\p{^isearlydynasticcuneiform}', "");
    Expect(0, 75087, '\P{isearlydynasticcuneiform}', "");
    Expect(1, 75087, '\P{^isearlydynasticcuneiform}', "");
    Expect(0, 75088, '\p{isearlydynasticcuneiform}', "");
    Expect(1, 75088, '\p{^isearlydynasticcuneiform}', "");
    Expect(1, 75088, '\P{isearlydynasticcuneiform}', "");
    Expect(0, 75088, '\P{^isearlydynasticcuneiform}', "");
    Expect(1, 75087, '\p{_IS_EARLY_DYNASTIC_Cuneiform}', "");
    Expect(0, 75087, '\p{^_IS_EARLY_DYNASTIC_Cuneiform}', "");
    Expect(0, 75087, '\P{_IS_EARLY_DYNASTIC_Cuneiform}', "");
    Expect(1, 75087, '\P{^_IS_EARLY_DYNASTIC_Cuneiform}', "");
    Expect(0, 75088, '\p{_IS_EARLY_DYNASTIC_Cuneiform}', "");
    Expect(1, 75088, '\p{^_IS_EARLY_DYNASTIC_Cuneiform}', "");
    Expect(1, 75088, '\P{_IS_EARLY_DYNASTIC_Cuneiform}', "");
    Expect(0, 75088, '\P{^_IS_EARLY_DYNASTIC_Cuneiform}', "");
    Error('\p{:= -In_early_DYNASTIC_cuneiform}');
    Error('\P{:= -In_early_DYNASTIC_cuneiform}');
    Expect(1, 75087, '\p{inearlydynasticcuneiform}', "");
    Expect(0, 75087, '\p{^inearlydynasticcuneiform}', "");
    Expect(0, 75087, '\P{inearlydynasticcuneiform}', "");
    Expect(1, 75087, '\P{^inearlydynasticcuneiform}', "");
    Expect(0, 75088, '\p{inearlydynasticcuneiform}', "");
    Expect(1, 75088, '\p{^inearlydynasticcuneiform}', "");
    Expect(1, 75088, '\P{inearlydynasticcuneiform}', "");
    Expect(0, 75088, '\P{^inearlydynasticcuneiform}', "");
    Expect(1, 75087, '\p{	 In_early_Dynastic_CUNEIFORM}', "");
    Expect(0, 75087, '\p{^	 In_early_Dynastic_CUNEIFORM}', "");
    Expect(0, 75087, '\P{	 In_early_Dynastic_CUNEIFORM}', "");
    Expect(1, 75087, '\P{^	 In_early_Dynastic_CUNEIFORM}', "");
    Expect(0, 75088, '\p{	 In_early_Dynastic_CUNEIFORM}', "");
    Expect(1, 75088, '\p{^	 In_early_Dynastic_CUNEIFORM}', "");
    Expect(1, 75088, '\P{	 In_early_Dynastic_CUNEIFORM}', "");
    Expect(0, 75088, '\P{^	 In_early_Dynastic_CUNEIFORM}', "");
    Error('\p{ :=Egyptian_hieroglyph_Format_Controls}');
    Error('\P{ :=Egyptian_hieroglyph_Format_Controls}');
    Expect(1, 78911, '\p{egyptianhieroglyphformatcontrols}', "");
    Expect(0, 78911, '\p{^egyptianhieroglyphformatcontrols}', "");
    Expect(0, 78911, '\P{egyptianhieroglyphformatcontrols}', "");
    Expect(1, 78911, '\P{^egyptianhieroglyphformatcontrols}', "");
    Expect(0, 78912, '\p{egyptianhieroglyphformatcontrols}', "");
    Expect(1, 78912, '\p{^egyptianhieroglyphformatcontrols}', "");
    Expect(1, 78912, '\P{egyptianhieroglyphformatcontrols}', "");
    Expect(0, 78912, '\P{^egyptianhieroglyphformatcontrols}', "");
    Expect(1, 78911, '\p{_-egyptian_hieroglyph_Format_Controls}', "");
    Expect(0, 78911, '\p{^_-egyptian_hieroglyph_Format_Controls}', "");
    Expect(0, 78911, '\P{_-egyptian_hieroglyph_Format_Controls}', "");
    Expect(1, 78911, '\P{^_-egyptian_hieroglyph_Format_Controls}', "");
    Expect(0, 78912, '\p{_-egyptian_hieroglyph_Format_Controls}', "");
    Expect(1, 78912, '\p{^_-egyptian_hieroglyph_Format_Controls}', "");
    Expect(1, 78912, '\P{_-egyptian_hieroglyph_Format_Controls}', "");
    Expect(0, 78912, '\P{^_-egyptian_hieroglyph_Format_Controls}', "");
    Error('\p{/a/	_Is_Egyptian_HIEROGLYPH_FORMAT_CONTROLS}');
    Error('\P{/a/	_Is_Egyptian_HIEROGLYPH_FORMAT_CONTROLS}');
    Expect(1, 78911, '\p{isegyptianhieroglyphformatcontrols}', "");
    Expect(0, 78911, '\p{^isegyptianhieroglyphformatcontrols}', "");
    Expect(0, 78911, '\P{isegyptianhieroglyphformatcontrols}', "");
    Expect(1, 78911, '\P{^isegyptianhieroglyphformatcontrols}', "");
    Expect(0, 78912, '\p{isegyptianhieroglyphformatcontrols}', "");
    Expect(1, 78912, '\p{^isegyptianhieroglyphformatcontrols}', "");
    Expect(1, 78912, '\P{isegyptianhieroglyphformatcontrols}', "");
    Expect(0, 78912, '\P{^isegyptianhieroglyphformatcontrols}', "");
    Expect(1, 78911, '\p{ -is_EGYPTIAN_Hieroglyph_FORMAT_controls}', "");
    Expect(0, 78911, '\p{^ -is_EGYPTIAN_Hieroglyph_FORMAT_controls}', "");
    Expect(0, 78911, '\P{ -is_EGYPTIAN_Hieroglyph_FORMAT_controls}', "");
    Expect(1, 78911, '\P{^ -is_EGYPTIAN_Hieroglyph_FORMAT_controls}', "");
    Expect(0, 78912, '\p{ -is_EGYPTIAN_Hieroglyph_FORMAT_controls}', "");
    Expect(1, 78912, '\p{^ -is_EGYPTIAN_Hieroglyph_FORMAT_controls}', "");
    Expect(1, 78912, '\P{ -is_EGYPTIAN_Hieroglyph_FORMAT_controls}', "");
    Expect(0, 78912, '\P{^ -is_EGYPTIAN_Hieroglyph_FORMAT_controls}', "");
    Error('\p{:=	_In_egyptian_hieroglyph_FORMAT_Controls}');
    Error('\P{:=	_In_egyptian_hieroglyph_FORMAT_Controls}');
    Expect(1, 78911, '\p{inegyptianhieroglyphformatcontrols}', "");
    Expect(0, 78911, '\p{^inegyptianhieroglyphformatcontrols}', "");
    Expect(0, 78911, '\P{inegyptianhieroglyphformatcontrols}', "");
    Expect(1, 78911, '\P{^inegyptianhieroglyphformatcontrols}', "");
    Expect(0, 78912, '\p{inegyptianhieroglyphformatcontrols}', "");
    Expect(1, 78912, '\p{^inegyptianhieroglyphformatcontrols}', "");
    Expect(1, 78912, '\P{inegyptianhieroglyphformatcontrols}', "");
    Expect(0, 78912, '\P{^inegyptianhieroglyphformatcontrols}', "");
    Expect(1, 78911, '\p{	_In_EGYPTIAN_Hieroglyph_Format_CONTROLS}', "");
    Expect(0, 78911, '\p{^	_In_EGYPTIAN_Hieroglyph_Format_CONTROLS}', "");
    Expect(0, 78911, '\P{	_In_EGYPTIAN_Hieroglyph_Format_CONTROLS}', "");
    Expect(1, 78911, '\P{^	_In_EGYPTIAN_Hieroglyph_Format_CONTROLS}', "");
    Expect(0, 78912, '\p{	_In_EGYPTIAN_Hieroglyph_Format_CONTROLS}', "");
    Expect(1, 78912, '\p{^	_In_EGYPTIAN_Hieroglyph_Format_CONTROLS}', "");
    Expect(1, 78912, '\P{	_In_EGYPTIAN_Hieroglyph_Format_CONTROLS}', "");
    Expect(0, 78912, '\P{^	_In_EGYPTIAN_Hieroglyph_Format_CONTROLS}', "");
    Error('\p{EGYPTIAN_hieroglyphs/a/}');
    Error('\P{EGYPTIAN_hieroglyphs/a/}');
    Expect(1, 78904, '\p{egyptianhieroglyphs}', "");
    Expect(0, 78904, '\p{^egyptianhieroglyphs}', "");
    Expect(0, 78904, '\P{egyptianhieroglyphs}', "");
    Expect(1, 78904, '\P{^egyptianhieroglyphs}', "");
    Expect(0, 78905, '\p{egyptianhieroglyphs}', "");
    Expect(1, 78905, '\p{^egyptianhieroglyphs}', "");
    Expect(1, 78905, '\P{egyptianhieroglyphs}', "");
    Expect(0, 78905, '\P{^egyptianhieroglyphs}', "");
    Expect(1, 78904, '\p{-_EGYPTIAN_hieroglyphs}', "");
    Expect(0, 78904, '\p{^-_EGYPTIAN_hieroglyphs}', "");
    Expect(0, 78904, '\P{-_EGYPTIAN_hieroglyphs}', "");
    Expect(1, 78904, '\P{^-_EGYPTIAN_hieroglyphs}', "");
    Expect(0, 78905, '\p{-_EGYPTIAN_hieroglyphs}', "");
    Expect(1, 78905, '\p{^-_EGYPTIAN_hieroglyphs}', "");
    Expect(1, 78905, '\P{-_EGYPTIAN_hieroglyphs}', "");
    Expect(0, 78905, '\P{^-_EGYPTIAN_hieroglyphs}', "");
    Error('\p{		Is_EGYPTIAN_Hieroglyphs/a/}');
    Error('\P{		Is_EGYPTIAN_Hieroglyphs/a/}');
    Expect(1, 78904, '\p{isegyptianhieroglyphs}', "");
    Expect(0, 78904, '\p{^isegyptianhieroglyphs}', "");
    Expect(0, 78904, '\P{isegyptianhieroglyphs}', "");
    Expect(1, 78904, '\P{^isegyptianhieroglyphs}', "");
    Expect(0, 78905, '\p{isegyptianhieroglyphs}', "");
    Expect(1, 78905, '\p{^isegyptianhieroglyphs}', "");
    Expect(1, 78905, '\P{isegyptianhieroglyphs}', "");
    Expect(0, 78905, '\P{^isegyptianhieroglyphs}', "");
    Expect(1, 78904, '\p{		IS_egyptian_hieroglyphs}', "");
    Expect(0, 78904, '\p{^		IS_egyptian_hieroglyphs}', "");
    Expect(0, 78904, '\P{		IS_egyptian_hieroglyphs}', "");
    Expect(1, 78904, '\P{^		IS_egyptian_hieroglyphs}', "");
    Expect(0, 78905, '\p{		IS_egyptian_hieroglyphs}', "");
    Expect(1, 78905, '\p{^		IS_egyptian_hieroglyphs}', "");
    Expect(1, 78905, '\P{		IS_egyptian_hieroglyphs}', "");
    Expect(0, 78905, '\P{^		IS_egyptian_hieroglyphs}', "");
    Error('\p{_ Egyp/a/}');
    Error('\P{_ Egyp/a/}');
    Expect(1, 78904, '\p{egyp}', "");
    Expect(0, 78904, '\p{^egyp}', "");
    Expect(0, 78904, '\P{egyp}', "");
    Expect(1, 78904, '\P{^egyp}', "");
    Expect(0, 78905, '\p{egyp}', "");
    Expect(1, 78905, '\p{^egyp}', "");
    Expect(1, 78905, '\P{egyp}', "");
    Expect(0, 78905, '\P{^egyp}', "");
    Expect(1, 78904, '\p{__Egyp}', "");
    Expect(0, 78904, '\p{^__Egyp}', "");
    Expect(0, 78904, '\P{__Egyp}', "");
    Expect(1, 78904, '\P{^__Egyp}', "");
    Expect(0, 78905, '\p{__Egyp}', "");
    Expect(1, 78905, '\p{^__Egyp}', "");
    Expect(1, 78905, '\P{__Egyp}', "");
    Expect(0, 78905, '\P{^__Egyp}', "");
    Error('\p{ /a/IS_egyp}');
    Error('\P{ /a/IS_egyp}');
    Expect(1, 78904, '\p{isegyp}', "");
    Expect(0, 78904, '\p{^isegyp}', "");
    Expect(0, 78904, '\P{isegyp}', "");
    Expect(1, 78904, '\P{^isegyp}', "");
    Expect(0, 78905, '\p{isegyp}', "");
    Expect(1, 78905, '\p{^isegyp}', "");
    Expect(1, 78905, '\P{isegyp}', "");
    Expect(0, 78905, '\P{^isegyp}', "");
    Expect(1, 78904, '\p{	-IS_EGYP}', "");
    Expect(0, 78904, '\p{^	-IS_EGYP}', "");
    Expect(0, 78904, '\P{	-IS_EGYP}', "");
    Expect(1, 78904, '\P{^	-IS_EGYP}', "");
    Expect(0, 78905, '\p{	-IS_EGYP}', "");
    Expect(1, 78905, '\p{^	-IS_EGYP}', "");
    Expect(1, 78905, '\P{	-IS_EGYP}', "");
    Expect(0, 78905, '\P{^	-IS_EGYP}', "");
    Error('\p{--Elbasan/a/}');
    Error('\P{--Elbasan/a/}');
    Expect(1, 66855, '\p{elbasan}', "");
    Expect(0, 66855, '\p{^elbasan}', "");
    Expect(0, 66855, '\P{elbasan}', "");
    Expect(1, 66855, '\P{^elbasan}', "");
    Expect(0, 66856, '\p{elbasan}', "");
    Expect(1, 66856, '\p{^elbasan}', "");
    Expect(1, 66856, '\P{elbasan}', "");
    Expect(0, 66856, '\P{^elbasan}', "");
    Expect(1, 66855, '\p{	Elbasan}', "");
    Expect(0, 66855, '\p{^	Elbasan}', "");
    Expect(0, 66855, '\P{	Elbasan}', "");
    Expect(1, 66855, '\P{^	Elbasan}', "");
    Expect(0, 66856, '\p{	Elbasan}', "");
    Expect(1, 66856, '\p{^	Elbasan}', "");
    Expect(1, 66856, '\P{	Elbasan}', "");
    Expect(0, 66856, '\P{^	Elbasan}', "");
    Error('\p{/a/--is_ELBASAN}');
    Error('\P{/a/--is_ELBASAN}');
    Expect(1, 66855, '\p{iselbasan}', "");
    Expect(0, 66855, '\p{^iselbasan}', "");
    Expect(0, 66855, '\P{iselbasan}', "");
    Expect(1, 66855, '\P{^iselbasan}', "");
    Expect(0, 66856, '\p{iselbasan}', "");
    Expect(1, 66856, '\p{^iselbasan}', "");
    Expect(1, 66856, '\P{iselbasan}', "");
    Expect(0, 66856, '\P{^iselbasan}', "");
    Expect(1, 66855, '\p{__Is_Elbasan}', "");
    Expect(0, 66855, '\p{^__Is_Elbasan}', "");
    Expect(0, 66855, '\P{__Is_Elbasan}', "");
    Expect(1, 66855, '\P{^__Is_Elbasan}', "");
    Expect(0, 66856, '\p{__Is_Elbasan}', "");
    Expect(1, 66856, '\p{^__Is_Elbasan}', "");
    Expect(1, 66856, '\P{__Is_Elbasan}', "");
    Expect(0, 66856, '\P{^__Is_Elbasan}', "");
    Error('\p{  ELBA/a/}');
    Error('\P{  ELBA/a/}');
    Expect(1, 66855, '\p{elba}', "");
    Expect(0, 66855, '\p{^elba}', "");
    Expect(0, 66855, '\P{elba}', "");
    Expect(1, 66855, '\P{^elba}', "");
    Expect(0, 66856, '\p{elba}', "");
    Expect(1, 66856, '\p{^elba}', "");
    Expect(1, 66856, '\P{elba}', "");
    Expect(0, 66856, '\P{^elba}', "");
    Expect(1, 66855, '\p{_ Elba}', "");
    Expect(0, 66855, '\p{^_ Elba}', "");
    Expect(0, 66855, '\P{_ Elba}', "");
    Expect(1, 66855, '\P{^_ Elba}', "");
    Expect(0, 66856, '\p{_ Elba}', "");
    Expect(1, 66856, '\p{^_ Elba}', "");
    Expect(1, 66856, '\P{_ Elba}', "");
    Expect(0, 66856, '\P{^_ Elba}', "");
    Error('\p{:= Is_elba}');
    Error('\P{:= Is_elba}');
    Expect(1, 66855, '\p{iselba}', "");
    Expect(0, 66855, '\p{^iselba}', "");
    Expect(0, 66855, '\P{iselba}', "");
    Expect(1, 66855, '\P{^iselba}', "");
    Expect(0, 66856, '\p{iselba}', "");
    Expect(1, 66856, '\p{^iselba}', "");
    Expect(1, 66856, '\P{iselba}', "");
    Expect(0, 66856, '\P{^iselba}', "");
    Expect(1, 66855, '\p{--Is_ELBA}', "");
    Expect(0, 66855, '\p{^--Is_ELBA}', "");
    Expect(0, 66855, '\P{--Is_ELBA}', "");
    Expect(1, 66855, '\P{^--Is_ELBA}', "");
    Expect(0, 66856, '\p{--Is_ELBA}', "");
    Expect(1, 66856, '\p{^--Is_ELBA}', "");
    Expect(1, 66856, '\P{--Is_ELBA}', "");
    Expect(0, 66856, '\P{^--Is_ELBA}', "");
    Error('\p{:=elymaic}');
    Error('\P{:=elymaic}');
    Expect(1, 69622, '\p{elymaic}', "");
    Expect(0, 69622, '\p{^elymaic}', "");
    Expect(0, 69622, '\P{elymaic}', "");
    Expect(1, 69622, '\P{^elymaic}', "");
    Expect(0, 69623, '\p{elymaic}', "");
    Expect(1, 69623, '\p{^elymaic}', "");
    Expect(1, 69623, '\P{elymaic}', "");
    Expect(0, 69623, '\P{^elymaic}', "");
    Expect(1, 69622, '\p{--elymaic}', "");
    Expect(0, 69622, '\p{^--elymaic}', "");
    Expect(0, 69622, '\P{--elymaic}', "");
    Expect(1, 69622, '\P{^--elymaic}', "");
    Expect(0, 69623, '\p{--elymaic}', "");
    Expect(1, 69623, '\p{^--elymaic}', "");
    Expect(1, 69623, '\P{--elymaic}', "");
    Expect(0, 69623, '\P{^--elymaic}', "");
    Error('\p{ is_Elymaic:=}');
    Error('\P{ is_Elymaic:=}');
    Expect(1, 69622, '\p{iselymaic}', "");
    Expect(0, 69622, '\p{^iselymaic}', "");
    Expect(0, 69622, '\P{iselymaic}', "");
    Expect(1, 69622, '\P{^iselymaic}', "");
    Expect(0, 69623, '\p{iselymaic}', "");
    Expect(1, 69623, '\p{^iselymaic}', "");
    Expect(1, 69623, '\P{iselymaic}', "");
    Expect(0, 69623, '\P{^iselymaic}', "");
    Expect(1, 69622, '\p{	-Is_elymaic}', "");
    Expect(0, 69622, '\p{^	-Is_elymaic}', "");
    Expect(0, 69622, '\P{	-Is_elymaic}', "");
    Expect(1, 69622, '\P{^	-Is_elymaic}', "");
    Expect(0, 69623, '\p{	-Is_elymaic}', "");
    Expect(1, 69623, '\p{^	-Is_elymaic}', "");
    Expect(1, 69623, '\P{	-Is_elymaic}', "");
    Expect(0, 69623, '\P{^	-Is_elymaic}', "");
    Error('\p{	elym/a/}');
    Error('\P{	elym/a/}');
    Expect(1, 69622, '\p{elym}', "");
    Expect(0, 69622, '\p{^elym}', "");
    Expect(0, 69622, '\P{elym}', "");
    Expect(1, 69622, '\P{^elym}', "");
    Expect(0, 69623, '\p{elym}', "");
    Expect(1, 69623, '\p{^elym}', "");
    Expect(1, 69623, '\P{elym}', "");
    Expect(0, 69623, '\P{^elym}', "");
    Expect(1, 69622, '\p{ elym}', "");
    Expect(0, 69622, '\p{^ elym}', "");
    Expect(0, 69622, '\P{ elym}', "");
    Expect(1, 69622, '\P{^ elym}', "");
    Expect(0, 69623, '\p{ elym}', "");
    Expect(1, 69623, '\p{^ elym}', "");
    Expect(1, 69623, '\P{ elym}', "");
    Expect(0, 69623, '\P{^ elym}', "");
    Error('\p{_Is_ELYM/a/}');
    Error('\P{_Is_ELYM/a/}');
    Expect(1, 69622, '\p{iselym}', "");
    Expect(0, 69622, '\p{^iselym}', "");
    Expect(0, 69622, '\P{iselym}', "");
    Expect(1, 69622, '\P{^iselym}', "");
    Expect(0, 69623, '\p{iselym}', "");
    Expect(1, 69623, '\p{^iselym}', "");
    Expect(1, 69623, '\P{iselym}', "");
    Expect(0, 69623, '\P{^iselym}', "");
    Expect(1, 69622, '\p{	 IS_Elym}', "");
    Expect(0, 69622, '\p{^	 IS_Elym}', "");
    Expect(0, 69622, '\P{	 IS_Elym}', "");
    Expect(1, 69622, '\P{^	 IS_Elym}', "");
    Expect(0, 69623, '\p{	 IS_Elym}', "");
    Expect(1, 69623, '\p{^	 IS_Elym}', "");
    Expect(1, 69623, '\P{	 IS_Elym}', "");
    Expect(0, 69623, '\P{^	 IS_Elym}', "");
    Error('\p{ emoji/a/}');
    Error('\P{ emoji/a/}');
    Expect(1, 129750, '\p{emoji}', "");
    Expect(0, 129750, '\p{^emoji}', "");
    Expect(0, 129750, '\P{emoji}', "");
    Expect(1, 129750, '\P{^emoji}', "");
    Expect(0, 129751, '\p{emoji}', "");
    Expect(1, 129751, '\p{^emoji}', "");
    Expect(1, 129751, '\P{emoji}', "");
    Expect(0, 129751, '\P{^emoji}', "");
    Expect(1, 129750, '\p{ _Emoji}', "");
    Expect(0, 129750, '\p{^ _Emoji}', "");
    Expect(0, 129750, '\P{ _Emoji}', "");
    Expect(1, 129750, '\P{^ _Emoji}', "");
    Expect(0, 129751, '\p{ _Emoji}', "");
    Expect(1, 129751, '\p{^ _Emoji}', "");
    Expect(1, 129751, '\P{ _Emoji}', "");
    Expect(0, 129751, '\P{^ _Emoji}', "");
    Error('\p{/a/		is_emoji}');
    Error('\P{/a/		is_emoji}');
    Expect(1, 129750, '\p{isemoji}', "");
    Expect(0, 129750, '\p{^isemoji}', "");
    Expect(0, 129750, '\P{isemoji}', "");
    Expect(1, 129750, '\P{^isemoji}', "");
    Expect(0, 129751, '\p{isemoji}', "");
    Expect(1, 129751, '\p{^isemoji}', "");
    Expect(1, 129751, '\P{isemoji}', "");
    Expect(0, 129751, '\P{^isemoji}', "");
    Expect(1, 129750, '\p{		is_emoji}', "");
    Expect(0, 129750, '\p{^		is_emoji}', "");
    Expect(0, 129750, '\P{		is_emoji}', "");
    Expect(1, 129750, '\P{^		is_emoji}', "");
    Expect(0, 129751, '\p{		is_emoji}', "");
    Expect(1, 129751, '\p{^		is_emoji}', "");
    Expect(1, 129751, '\P{		is_emoji}', "");
    Expect(0, 129751, '\P{^		is_emoji}', "");
    Error('\p{	/a/EMOJI_COMPONENT}');
    Error('\P{	/a/EMOJI_COMPONENT}');
    Expect(1, 917631, '\p{emojicomponent}', "");
    Expect(0, 917631, '\p{^emojicomponent}', "");
    Expect(0, 917631, '\P{emojicomponent}', "");
    Expect(1, 917631, '\P{^emojicomponent}', "");
    Expect(0, 917632, '\p{emojicomponent}', "");
    Expect(1, 917632, '\p{^emojicomponent}', "");
    Expect(1, 917632, '\P{emojicomponent}', "");
    Expect(0, 917632, '\P{^emojicomponent}', "");
    Expect(1, 917631, '\p{-Emoji_Component}', "");
    Expect(0, 917631, '\p{^-Emoji_Component}', "");
    Expect(0, 917631, '\P{-Emoji_Component}', "");
    Expect(1, 917631, '\P{^-Emoji_Component}', "");
    Expect(0, 917632, '\p{-Emoji_Component}', "");
    Expect(1, 917632, '\p{^-Emoji_Component}', "");
    Expect(1, 917632, '\P{-Emoji_Component}', "");
    Expect(0, 917632, '\P{^-Emoji_Component}', "");
    Error('\p{  Is_Emoji_Component:=}');
    Error('\P{  Is_Emoji_Component:=}');
    Expect(1, 917631, '\p{isemojicomponent}', "");
    Expect(0, 917631, '\p{^isemojicomponent}', "");
    Expect(0, 917631, '\P{isemojicomponent}', "");
    Expect(1, 917631, '\P{^isemojicomponent}', "");
    Expect(0, 917632, '\p{isemojicomponent}', "");
    Expect(1, 917632, '\p{^isemojicomponent}', "");
    Expect(1, 917632, '\P{isemojicomponent}', "");
    Expect(0, 917632, '\P{^isemojicomponent}', "");
    Expect(1, 917631, '\p{_-Is_emoji_component}', "");
    Expect(0, 917631, '\p{^_-Is_emoji_component}', "");
    Expect(0, 917631, '\P{_-Is_emoji_component}', "");
    Expect(1, 917631, '\P{^_-Is_emoji_component}', "");
    Expect(0, 917632, '\p{_-Is_emoji_component}', "");
    Expect(1, 917632, '\p{^_-Is_emoji_component}', "");
    Expect(1, 917632, '\P{_-Is_emoji_component}', "");
    Expect(0, 917632, '\P{^_-Is_emoji_component}', "");
    Error('\p{:=- ECOMP}');
    Error('\P{:=- ECOMP}');
    Expect(1, 917631, '\p{ecomp}', "");
    Expect(0, 917631, '\p{^ecomp}', "");
    Expect(0, 917631, '\P{ecomp}', "");
    Expect(1, 917631, '\P{^ecomp}', "");
    Expect(0, 917632, '\p{ecomp}', "");
    Expect(1, 917632, '\p{^ecomp}', "");
    Expect(1, 917632, '\P{ecomp}', "");
    Expect(0, 917632, '\P{^ecomp}', "");
    Expect(1, 917631, '\p{	-ECOMP}', "");
    Expect(0, 917631, '\p{^	-ECOMP}', "");
    Expect(0, 917631, '\P{	-ECOMP}', "");
    Expect(1, 917631, '\P{^	-ECOMP}', "");
    Expect(0, 917632, '\p{	-ECOMP}', "");
    Expect(1, 917632, '\p{^	-ECOMP}', "");
    Expect(1, 917632, '\P{	-ECOMP}', "");
    Expect(0, 917632, '\P{^	-ECOMP}', "");
    Error('\p{- is_ECOMP:=}');
    Error('\P{- is_ECOMP:=}');
    Expect(1, 917631, '\p{isecomp}', "");
    Expect(0, 917631, '\p{^isecomp}', "");
    Expect(0, 917631, '\P{isecomp}', "");
    Expect(1, 917631, '\P{^isecomp}', "");
    Expect(0, 917632, '\p{isecomp}', "");
    Expect(1, 917632, '\p{^isecomp}', "");
    Expect(1, 917632, '\P{isecomp}', "");
    Expect(0, 917632, '\P{^isecomp}', "");
    Expect(1, 917631, '\p{ -Is_EComp}', "");
    Expect(0, 917631, '\p{^ -Is_EComp}', "");
    Expect(0, 917631, '\P{ -Is_EComp}', "");
    Expect(1, 917631, '\P{^ -Is_EComp}', "");
    Expect(0, 917632, '\p{ -Is_EComp}', "");
    Expect(1, 917632, '\p{^ -Is_EComp}', "");
    Expect(1, 917632, '\P{ -Is_EComp}', "");
    Expect(0, 917632, '\P{^ -Is_EComp}', "");
    Error('\p{:=_Emoji_Modifier}');
    Error('\P{:=_Emoji_Modifier}');
    Expect(1, 127999, '\p{emojimodifier}', "");
    Expect(0, 127999, '\p{^emojimodifier}', "");
    Expect(0, 127999, '\P{emojimodifier}', "");
    Expect(1, 127999, '\P{^emojimodifier}', "");
    Expect(0, 128000, '\p{emojimodifier}', "");
    Expect(1, 128000, '\p{^emojimodifier}', "");
    Expect(1, 128000, '\P{emojimodifier}', "");
    Expect(0, 128000, '\P{^emojimodifier}', "");
    Expect(1, 127999, '\p{  Emoji_Modifier}', "");
    Expect(0, 127999, '\p{^  Emoji_Modifier}', "");
    Expect(0, 127999, '\P{  Emoji_Modifier}', "");
    Expect(1, 127999, '\P{^  Emoji_Modifier}', "");
    Expect(0, 128000, '\p{  Emoji_Modifier}', "");
    Expect(1, 128000, '\p{^  Emoji_Modifier}', "");
    Expect(1, 128000, '\P{  Emoji_Modifier}', "");
    Expect(0, 128000, '\P{^  Emoji_Modifier}', "");
    Error('\p{:=is_Emoji_Modifier}');
    Error('\P{:=is_Emoji_Modifier}');
    Expect(1, 127999, '\p{isemojimodifier}', "");
    Expect(0, 127999, '\p{^isemojimodifier}', "");
    Expect(0, 127999, '\P{isemojimodifier}', "");
    Expect(1, 127999, '\P{^isemojimodifier}', "");
    Expect(0, 128000, '\p{isemojimodifier}', "");
    Expect(1, 128000, '\p{^isemojimodifier}', "");
    Expect(1, 128000, '\P{isemojimodifier}', "");
    Expect(0, 128000, '\P{^isemojimodifier}', "");
    Expect(1, 127999, '\p{_-Is_EMOJI_Modifier}', "");
    Expect(0, 127999, '\p{^_-Is_EMOJI_Modifier}', "");
    Expect(0, 127999, '\P{_-Is_EMOJI_Modifier}', "");
    Expect(1, 127999, '\P{^_-Is_EMOJI_Modifier}', "");
    Expect(0, 128000, '\p{_-Is_EMOJI_Modifier}', "");
    Expect(1, 128000, '\p{^_-Is_EMOJI_Modifier}', "");
    Expect(1, 128000, '\P{_-Is_EMOJI_Modifier}', "");
    Expect(0, 128000, '\P{^_-Is_EMOJI_Modifier}', "");
    Error('\p{  EMOD:=}');
    Error('\P{  EMOD:=}');
    Expect(1, 127999, '\p{emod}', "");
    Expect(0, 127999, '\p{^emod}', "");
    Expect(0, 127999, '\P{emod}', "");
    Expect(1, 127999, '\P{^emod}', "");
    Expect(0, 128000, '\p{emod}', "");
    Expect(1, 128000, '\p{^emod}', "");
    Expect(1, 128000, '\P{emod}', "");
    Expect(0, 128000, '\P{^emod}', "");
    Expect(1, 127999, '\p{_EMod}', "");
    Expect(0, 127999, '\p{^_EMod}', "");
    Expect(0, 127999, '\P{_EMod}', "");
    Expect(1, 127999, '\P{^_EMod}', "");
    Expect(0, 128000, '\p{_EMod}', "");
    Expect(1, 128000, '\p{^_EMod}', "");
    Expect(1, 128000, '\P{_EMod}', "");
    Expect(0, 128000, '\P{^_EMod}', "");
    Error('\p{_/a/is_EMOD}');
    Error('\P{_/a/is_EMOD}');
    Expect(1, 127999, '\p{isemod}', "");
    Expect(0, 127999, '\p{^isemod}', "");
    Expect(0, 127999, '\P{isemod}', "");
    Expect(1, 127999, '\P{^isemod}', "");
    Expect(0, 128000, '\p{isemod}', "");
    Expect(1, 128000, '\p{^isemod}', "");
    Expect(1, 128000, '\P{isemod}', "");
    Expect(0, 128000, '\P{^isemod}', "");
    Expect(1, 127999, '\p{	Is_EMOD}', "");
    Expect(0, 127999, '\p{^	Is_EMOD}', "");
    Expect(0, 127999, '\P{	Is_EMOD}', "");
    Expect(1, 127999, '\P{^	Is_EMOD}', "");
    Expect(0, 128000, '\p{	Is_EMOD}', "");
    Expect(1, 128000, '\p{^	Is_EMOD}', "");
    Expect(1, 128000, '\P{	Is_EMOD}', "");
    Expect(0, 128000, '\P{^	Is_EMOD}', "");
    Error('\p{- EMOJI_modifier_base:=}');
    Error('\P{- EMOJI_modifier_base:=}');
    Expect(1, 129501, '\p{emojimodifierbase}', "");
    Expect(0, 129501, '\p{^emojimodifierbase}', "");
    Expect(0, 129501, '\P{emojimodifierbase}', "");
    Expect(1, 129501, '\P{^emojimodifierbase}', "");
    Expect(0, 129502, '\p{emojimodifierbase}', "");
    Expect(1, 129502, '\p{^emojimodifierbase}', "");
    Expect(1, 129502, '\P{emojimodifierbase}', "");
    Expect(0, 129502, '\P{^emojimodifierbase}', "");
    Expect(1, 129501, '\p{emoji_Modifier_Base}', "");
    Expect(0, 129501, '\p{^emoji_Modifier_Base}', "");
    Expect(0, 129501, '\P{emoji_Modifier_Base}', "");
    Expect(1, 129501, '\P{^emoji_Modifier_Base}', "");
    Expect(0, 129502, '\p{emoji_Modifier_Base}', "");
    Expect(1, 129502, '\p{^emoji_Modifier_Base}', "");
    Expect(1, 129502, '\P{emoji_Modifier_Base}', "");
    Expect(0, 129502, '\P{^emoji_Modifier_Base}', "");
    Error('\p{:= Is_Emoji_MODIFIER_Base}');
    Error('\P{:= Is_Emoji_MODIFIER_Base}');
    Expect(1, 129501, '\p{isemojimodifierbase}', "");
    Expect(0, 129501, '\p{^isemojimodifierbase}', "");
    Expect(0, 129501, '\P{isemojimodifierbase}', "");
    Expect(1, 129501, '\P{^isemojimodifierbase}', "");
    Expect(0, 129502, '\p{isemojimodifierbase}', "");
    Expect(1, 129502, '\p{^isemojimodifierbase}', "");
    Expect(1, 129502, '\P{isemojimodifierbase}', "");
    Expect(0, 129502, '\P{^isemojimodifierbase}', "");
    Expect(1, 129501, '\p{- Is_Emoji_Modifier_base}', "");
    Expect(0, 129501, '\p{^- Is_Emoji_Modifier_base}', "");
    Expect(0, 129501, '\P{- Is_Emoji_Modifier_base}', "");
    Expect(1, 129501, '\P{^- Is_Emoji_Modifier_base}', "");
    Expect(0, 129502, '\p{- Is_Emoji_Modifier_base}', "");
    Expect(1, 129502, '\p{^- Is_Emoji_Modifier_base}', "");
    Expect(1, 129502, '\P{- Is_Emoji_Modifier_base}', "");
    Expect(0, 129502, '\P{^- Is_Emoji_Modifier_base}', "");
    Error('\p{ _EBase/a/}');
    Error('\P{ _EBase/a/}');
    Expect(1, 129501, '\p{ebase}', "");
    Expect(0, 129501, '\p{^ebase}', "");
    Expect(0, 129501, '\P{ebase}', "");
    Expect(1, 129501, '\P{^ebase}', "");
    Expect(0, 129502, '\p{ebase}', "");
    Expect(1, 129502, '\p{^ebase}', "");
    Expect(1, 129502, '\P{ebase}', "");
    Expect(0, 129502, '\P{^ebase}', "");
    Expect(1, 129501, '\p{	 ebase}', "");
    Expect(0, 129501, '\p{^	 ebase}', "");
    Expect(0, 129501, '\P{	 ebase}', "");
    Expect(1, 129501, '\P{^	 ebase}', "");
    Expect(0, 129502, '\p{	 ebase}', "");
    Expect(1, 129502, '\p{^	 ebase}', "");
    Expect(1, 129502, '\P{	 ebase}', "");
    Expect(0, 129502, '\P{^	 ebase}', "");
    Error('\p{	/a/IS_EBASE}');
    Error('\P{	/a/IS_EBASE}');
    Expect(1, 129501, '\p{isebase}', "");
    Expect(0, 129501, '\p{^isebase}', "");
    Expect(0, 129501, '\P{isebase}', "");
    Expect(1, 129501, '\P{^isebase}', "");
    Expect(0, 129502, '\p{isebase}', "");
    Expect(1, 129502, '\p{^isebase}', "");
    Expect(1, 129502, '\P{isebase}', "");
    Expect(0, 129502, '\P{^isebase}', "");
    Expect(1, 129501, '\p{is_EBASE}', "");
    Expect(0, 129501, '\p{^is_EBASE}', "");
    Expect(0, 129501, '\P{is_EBASE}', "");
    Expect(1, 129501, '\P{^is_EBASE}', "");
    Expect(0, 129502, '\p{is_EBASE}', "");
    Expect(1, 129502, '\p{^is_EBASE}', "");
    Expect(1, 129502, '\P{is_EBASE}', "");
    Expect(0, 129502, '\P{^is_EBASE}', "");
    Error('\p{  EMOJI_Presentation/a/}');
    Error('\P{  EMOJI_Presentation/a/}');
    Expect(1, 129750, '\p{emojipresentation}', "");
    Expect(0, 129750, '\p{^emojipresentation}', "");
    Expect(0, 129750, '\P{emojipresentation}', "");
    Expect(1, 129750, '\P{^emojipresentation}', "");
    Expect(0, 129751, '\p{emojipresentation}', "");
    Expect(1, 129751, '\p{^emojipresentation}', "");
    Expect(1, 129751, '\P{emojipresentation}', "");
    Expect(0, 129751, '\P{^emojipresentation}', "");
    Expect(1, 129750, '\p{_Emoji_presentation}', "");
    Expect(0, 129750, '\p{^_Emoji_presentation}', "");
    Expect(0, 129750, '\P{_Emoji_presentation}', "");
    Expect(1, 129750, '\P{^_Emoji_presentation}', "");
    Expect(0, 129751, '\p{_Emoji_presentation}', "");
    Expect(1, 129751, '\p{^_Emoji_presentation}', "");
    Expect(1, 129751, '\P{_Emoji_presentation}', "");
    Expect(0, 129751, '\P{^_Emoji_presentation}', "");
    Error('\p{/a/	 Is_Emoji_Presentation}');
    Error('\P{/a/	 Is_Emoji_Presentation}');
    Expect(1, 129750, '\p{isemojipresentation}', "");
    Expect(0, 129750, '\p{^isemojipresentation}', "");
    Expect(0, 129750, '\P{isemojipresentation}', "");
    Expect(1, 129750, '\P{^isemojipresentation}', "");
    Expect(0, 129751, '\p{isemojipresentation}', "");
    Expect(1, 129751, '\p{^isemojipresentation}', "");
    Expect(1, 129751, '\P{isemojipresentation}', "");
    Expect(0, 129751, '\P{^isemojipresentation}', "");
    Expect(1, 129750, '\p{_Is_emoji_Presentation}', "");
    Expect(0, 129750, '\p{^_Is_emoji_Presentation}', "");
    Expect(0, 129750, '\P{_Is_emoji_Presentation}', "");
    Expect(1, 129750, '\P{^_Is_emoji_Presentation}', "");
    Expect(0, 129751, '\p{_Is_emoji_Presentation}', "");
    Expect(1, 129751, '\p{^_Is_emoji_Presentation}', "");
    Expect(1, 129751, '\P{_Is_emoji_Presentation}', "");
    Expect(0, 129751, '\P{^_Is_emoji_Presentation}', "");
    Error('\p{:= _EPRES}');
    Error('\P{:= _EPRES}');
    Expect(1, 129750, '\p{epres}', "");
    Expect(0, 129750, '\p{^epres}', "");
    Expect(0, 129750, '\P{epres}', "");
    Expect(1, 129750, '\P{^epres}', "");
    Expect(0, 129751, '\p{epres}', "");
    Expect(1, 129751, '\p{^epres}', "");
    Expect(1, 129751, '\P{epres}', "");
    Expect(0, 129751, '\P{^epres}', "");
    Expect(1, 129750, '\p{_ epres}', "");
    Expect(0, 129750, '\p{^_ epres}', "");
    Expect(0, 129750, '\P{_ epres}', "");
    Expect(1, 129750, '\P{^_ epres}', "");
    Expect(0, 129751, '\p{_ epres}', "");
    Expect(1, 129751, '\p{^_ epres}', "");
    Expect(1, 129751, '\P{_ epres}', "");
    Expect(0, 129751, '\P{^_ epres}', "");
    Error('\p{:=- IS_EPRES}');
    Error('\P{:=- IS_EPRES}');
    Expect(1, 129750, '\p{isepres}', "");
    Expect(0, 129750, '\p{^isepres}', "");
    Expect(0, 129750, '\P{isepres}', "");
    Expect(1, 129750, '\P{^isepres}', "");
    Expect(0, 129751, '\p{isepres}', "");
    Expect(1, 129751, '\p{^isepres}', "");
    Expect(1, 129751, '\P{isepres}', "");
    Expect(0, 129751, '\P{^isepres}', "");
    Expect(1, 129750, '\p{-is_EPres}', "");
    Expect(0, 129750, '\p{^-is_EPres}', "");
    Expect(0, 129750, '\P{-is_EPres}', "");
    Expect(1, 129750, '\P{^-is_EPres}', "");
    Expect(0, 129751, '\p{-is_EPres}', "");
    Expect(1, 129751, '\p{^-is_EPres}', "");
    Expect(1, 129751, '\P{-is_EPres}', "");
    Expect(0, 129751, '\P{^-is_EPres}', "");
    Error('\p{/a/- Emoticons}');
    Error('\P{/a/- Emoticons}');
    Expect(1, 128591, '\p{emoticons}', "");
    Expect(0, 128591, '\p{^emoticons}', "");
    Expect(0, 128591, '\P{emoticons}', "");
    Expect(1, 128591, '\P{^emoticons}', "");
    Expect(0, 128592, '\p{emoticons}', "");
    Expect(1, 128592, '\p{^emoticons}', "");
    Expect(1, 128592, '\P{emoticons}', "");
    Expect(0, 128592, '\P{^emoticons}', "");
    Expect(1, 128591, '\p{_	emoticons}', "");
    Expect(0, 128591, '\p{^_	emoticons}', "");
    Expect(0, 128591, '\P{_	emoticons}', "");
    Expect(1, 128591, '\P{^_	emoticons}', "");
    Expect(0, 128592, '\p{_	emoticons}', "");
    Expect(1, 128592, '\p{^_	emoticons}', "");
    Expect(1, 128592, '\P{_	emoticons}', "");
    Expect(0, 128592, '\P{^_	emoticons}', "");
    Error('\p{	 IS_Emoticons:=}');
    Error('\P{	 IS_Emoticons:=}');
    Expect(1, 128591, '\p{isemoticons}', "");
    Expect(0, 128591, '\p{^isemoticons}', "");
    Expect(0, 128591, '\P{isemoticons}', "");
    Expect(1, 128591, '\P{^isemoticons}', "");
    Expect(0, 128592, '\p{isemoticons}', "");
    Expect(1, 128592, '\p{^isemoticons}', "");
    Expect(1, 128592, '\P{isemoticons}', "");
    Expect(0, 128592, '\P{^isemoticons}', "");
    Expect(1, 128591, '\p{_-IS_EMOTICONS}', "");
    Expect(0, 128591, '\p{^_-IS_EMOTICONS}', "");
    Expect(0, 128591, '\P{_-IS_EMOTICONS}', "");
    Expect(1, 128591, '\P{^_-IS_EMOTICONS}', "");
    Expect(0, 128592, '\p{_-IS_EMOTICONS}', "");
    Expect(1, 128592, '\p{^_-IS_EMOTICONS}', "");
    Expect(1, 128592, '\P{_-IS_EMOTICONS}', "");
    Expect(0, 128592, '\P{^_-IS_EMOTICONS}', "");
    Error('\p{_	In_Emoticons:=}');
    Error('\P{_	In_Emoticons:=}');
    Expect(1, 128591, '\p{inemoticons}', "");
    Expect(0, 128591, '\p{^inemoticons}', "");
    Expect(0, 128591, '\P{inemoticons}', "");
    Expect(1, 128591, '\P{^inemoticons}', "");
    Expect(0, 128592, '\p{inemoticons}', "");
    Expect(1, 128592, '\p{^inemoticons}', "");
    Expect(1, 128592, '\P{inemoticons}', "");
    Expect(0, 128592, '\P{^inemoticons}', "");
    Expect(1, 128591, '\p{- In_emoticons}', "");
    Expect(0, 128591, '\p{^- In_emoticons}', "");
    Expect(0, 128591, '\P{- In_emoticons}', "");
    Expect(1, 128591, '\P{^- In_emoticons}', "");
    Expect(0, 128592, '\p{- In_emoticons}', "");
    Expect(1, 128592, '\p{^- In_emoticons}', "");
    Expect(1, 128592, '\P{- In_emoticons}', "");
    Expect(0, 128592, '\P{^- In_emoticons}', "");
    Error('\p{-enclosed_Alphanumeric_Supplement/a/}');
    Error('\P{-enclosed_Alphanumeric_Supplement/a/}');
    Expect(1, 127487, '\p{enclosedalphanumericsupplement}', "");
    Expect(0, 127487, '\p{^enclosedalphanumericsupplement}', "");
    Expect(0, 127487, '\P{enclosedalphanumericsupplement}', "");
    Expect(1, 127487, '\P{^enclosedalphanumericsupplement}', "");
    Expect(0, 127488, '\p{enclosedalphanumericsupplement}', "");
    Expect(1, 127488, '\p{^enclosedalphanumericsupplement}', "");
    Expect(1, 127488, '\P{enclosedalphanumericsupplement}', "");
    Expect(0, 127488, '\P{^enclosedalphanumericsupplement}', "");
    Expect(1, 127487, '\p{_	Enclosed_alphanumeric_supplement}', "");
    Expect(0, 127487, '\p{^_	Enclosed_alphanumeric_supplement}', "");
    Expect(0, 127487, '\P{_	Enclosed_alphanumeric_supplement}', "");
    Expect(1, 127487, '\P{^_	Enclosed_alphanumeric_supplement}', "");
    Expect(0, 127488, '\p{_	Enclosed_alphanumeric_supplement}', "");
    Expect(1, 127488, '\p{^_	Enclosed_alphanumeric_supplement}', "");
    Expect(1, 127488, '\P{_	Enclosed_alphanumeric_supplement}', "");
    Expect(0, 127488, '\P{^_	Enclosed_alphanumeric_supplement}', "");
    Error('\p{_Is_enclosed_ALPHANUMERIC_SUPPLEMENT:=}');
    Error('\P{_Is_enclosed_ALPHANUMERIC_SUPPLEMENT:=}');
    Expect(1, 127487, '\p{isenclosedalphanumericsupplement}', "");
    Expect(0, 127487, '\p{^isenclosedalphanumericsupplement}', "");
    Expect(0, 127487, '\P{isenclosedalphanumericsupplement}', "");
    Expect(1, 127487, '\P{^isenclosedalphanumericsupplement}', "");
    Expect(0, 127488, '\p{isenclosedalphanumericsupplement}', "");
    Expect(1, 127488, '\p{^isenclosedalphanumericsupplement}', "");
    Expect(1, 127488, '\P{isenclosedalphanumericsupplement}', "");
    Expect(0, 127488, '\P{^isenclosedalphanumericsupplement}', "");
    Expect(1, 127487, '\p{	 Is_Enclosed_Alphanumeric_Supplement}', "");
    Expect(0, 127487, '\p{^	 Is_Enclosed_Alphanumeric_Supplement}', "");
    Expect(0, 127487, '\P{	 Is_Enclosed_Alphanumeric_Supplement}', "");
    Expect(1, 127487, '\P{^	 Is_Enclosed_Alphanumeric_Supplement}', "");
    Expect(0, 127488, '\p{	 Is_Enclosed_Alphanumeric_Supplement}', "");
    Expect(1, 127488, '\p{^	 Is_Enclosed_Alphanumeric_Supplement}', "");
    Expect(1, 127488, '\P{	 Is_Enclosed_Alphanumeric_Supplement}', "");
    Expect(0, 127488, '\P{^	 Is_Enclosed_Alphanumeric_Supplement}', "");
    Error('\p{	 In_enclosed_ALPHANUMERIC_Supplement/a/}');
    Error('\P{	 In_enclosed_ALPHANUMERIC_Supplement/a/}');
    Expect(1, 127487, '\p{inenclosedalphanumericsupplement}', "");
    Expect(0, 127487, '\p{^inenclosedalphanumericsupplement}', "");
    Expect(0, 127487, '\P{inenclosedalphanumericsupplement}', "");
    Expect(1, 127487, '\P{^inenclosedalphanumericsupplement}', "");
    Expect(0, 127488, '\p{inenclosedalphanumericsupplement}', "");
    Expect(1, 127488, '\p{^inenclosedalphanumericsupplement}', "");
    Expect(1, 127488, '\P{inenclosedalphanumericsupplement}', "");
    Expect(0, 127488, '\P{^inenclosedalphanumericsupplement}', "");
    Expect(1, 127487, '\p{  In_enclosed_ALPHANUMERIC_SUPPLEMENT}', "");
    Expect(0, 127487, '\p{^  In_enclosed_ALPHANUMERIC_SUPPLEMENT}', "");
    Expect(0, 127487, '\P{  In_enclosed_ALPHANUMERIC_SUPPLEMENT}', "");
    Expect(1, 127487, '\P{^  In_enclosed_ALPHANUMERIC_SUPPLEMENT}', "");
    Expect(0, 127488, '\p{  In_enclosed_ALPHANUMERIC_SUPPLEMENT}', "");
    Expect(1, 127488, '\p{^  In_enclosed_ALPHANUMERIC_SUPPLEMENT}', "");
    Expect(1, 127488, '\P{  In_enclosed_ALPHANUMERIC_SUPPLEMENT}', "");
    Expect(0, 127488, '\P{^  In_enclosed_ALPHANUMERIC_SUPPLEMENT}', "");
    Error('\p{	:=enclosed_alphanum_Sup}');
    Error('\P{	:=enclosed_alphanum_Sup}');
    Expect(1, 127487, '\p{enclosedalphanumsup}', "");
    Expect(0, 127487, '\p{^enclosedalphanumsup}', "");
    Expect(0, 127487, '\P{enclosedalphanumsup}', "");
    Expect(1, 127487, '\P{^enclosedalphanumsup}', "");
    Expect(0, 127488, '\p{enclosedalphanumsup}', "");
    Expect(1, 127488, '\p{^enclosedalphanumsup}', "");
    Expect(1, 127488, '\P{enclosedalphanumsup}', "");
    Expect(0, 127488, '\P{^enclosedalphanumsup}', "");
    Expect(1, 127487, '\p{_ENCLOSED_ALPHANUM_Sup}', "");
    Expect(0, 127487, '\p{^_ENCLOSED_ALPHANUM_Sup}', "");
    Expect(0, 127487, '\P{_ENCLOSED_ALPHANUM_Sup}', "");
    Expect(1, 127487, '\P{^_ENCLOSED_ALPHANUM_Sup}', "");
    Expect(0, 127488, '\p{_ENCLOSED_ALPHANUM_Sup}', "");
    Expect(1, 127488, '\p{^_ENCLOSED_ALPHANUM_Sup}', "");
    Expect(1, 127488, '\P{_ENCLOSED_ALPHANUM_Sup}', "");
    Expect(0, 127488, '\P{^_ENCLOSED_ALPHANUM_Sup}', "");
    Error('\p{ is_enclosed_alphanum_SUP:=}');
    Error('\P{ is_enclosed_alphanum_SUP:=}');
    Expect(1, 127487, '\p{isenclosedalphanumsup}', "");
    Expect(0, 127487, '\p{^isenclosedalphanumsup}', "");
    Expect(0, 127487, '\P{isenclosedalphanumsup}', "");
    Expect(1, 127487, '\P{^isenclosedalphanumsup}', "");
    Expect(0, 127488, '\p{isenclosedalphanumsup}', "");
    Expect(1, 127488, '\p{^isenclosedalphanumsup}', "");
    Expect(1, 127488, '\P{isenclosedalphanumsup}', "");
    Expect(0, 127488, '\P{^isenclosedalphanumsup}', "");
    Expect(1, 127487, '\p{	_Is_Enclosed_Alphanum_Sup}', "");
    Expect(0, 127487, '\p{^	_Is_Enclosed_Alphanum_Sup}', "");
    Expect(0, 127487, '\P{	_Is_Enclosed_Alphanum_Sup}', "");
    Expect(1, 127487, '\P{^	_Is_Enclosed_Alphanum_Sup}', "");
    Expect(0, 127488, '\p{	_Is_Enclosed_Alphanum_Sup}', "");
    Expect(1, 127488, '\p{^	_Is_Enclosed_Alphanum_Sup}', "");
    Expect(1, 127488, '\P{	_Is_Enclosed_Alphanum_Sup}', "");
    Expect(0, 127488, '\P{^	_Is_Enclosed_Alphanum_Sup}', "");
    Error('\p{ In_ENCLOSED_Alphanum_SUP/a/}');
    Error('\P{ In_ENCLOSED_Alphanum_SUP/a/}');
    Expect(1, 127487, '\p{inenclosedalphanumsup}', "");
    Expect(0, 127487, '\p{^inenclosedalphanumsup}', "");
    Expect(0, 127487, '\P{inenclosedalphanumsup}', "");
    Expect(1, 127487, '\P{^inenclosedalphanumsup}', "");
    Expect(0, 127488, '\p{inenclosedalphanumsup}', "");
    Expect(1, 127488, '\p{^inenclosedalphanumsup}', "");
    Expect(1, 127488, '\P{inenclosedalphanumsup}', "");
    Expect(0, 127488, '\P{^inenclosedalphanumsup}', "");
    Expect(1, 127487, '\p{__in_enclosed_Alphanum_sup}', "");
    Expect(0, 127487, '\p{^__in_enclosed_Alphanum_sup}', "");
    Expect(0, 127487, '\P{__in_enclosed_Alphanum_sup}', "");
    Expect(1, 127487, '\P{^__in_enclosed_Alphanum_sup}', "");
    Expect(0, 127488, '\p{__in_enclosed_Alphanum_sup}', "");
    Expect(1, 127488, '\p{^__in_enclosed_Alphanum_sup}', "");
    Expect(1, 127488, '\P{__in_enclosed_Alphanum_sup}', "");
    Expect(0, 127488, '\P{^__in_enclosed_Alphanum_sup}', "");
    Error('\p{	:=ENCLOSED_Alphanumerics}');
    Error('\P{	:=ENCLOSED_Alphanumerics}');
    Expect(1, 9471, '\p{enclosedalphanumerics}', "");
    Expect(0, 9471, '\p{^enclosedalphanumerics}', "");
    Expect(0, 9471, '\P{enclosedalphanumerics}', "");
    Expect(1, 9471, '\P{^enclosedalphanumerics}', "");
    Expect(0, 9472, '\p{enclosedalphanumerics}', "");
    Expect(1, 9472, '\p{^enclosedalphanumerics}', "");
    Expect(1, 9472, '\P{enclosedalphanumerics}', "");
    Expect(0, 9472, '\P{^enclosedalphanumerics}', "");
    Expect(1, 9471, '\p{		Enclosed_Alphanumerics}', "");
    Expect(0, 9471, '\p{^		Enclosed_Alphanumerics}', "");
    Expect(0, 9471, '\P{		Enclosed_Alphanumerics}', "");
    Expect(1, 9471, '\P{^		Enclosed_Alphanumerics}', "");
    Expect(0, 9472, '\p{		Enclosed_Alphanumerics}', "");
    Expect(1, 9472, '\p{^		Enclosed_Alphanumerics}', "");
    Expect(1, 9472, '\P{		Enclosed_Alphanumerics}', "");
    Expect(0, 9472, '\P{^		Enclosed_Alphanumerics}', "");
    Error('\p{:=-	is_Enclosed_alphanumerics}');
    Error('\P{:=-	is_Enclosed_alphanumerics}');
    Expect(1, 9471, '\p{isenclosedalphanumerics}', "");
    Expect(0, 9471, '\p{^isenclosedalphanumerics}', "");
    Expect(0, 9471, '\P{isenclosedalphanumerics}', "");
    Expect(1, 9471, '\P{^isenclosedalphanumerics}', "");
    Expect(0, 9472, '\p{isenclosedalphanumerics}', "");
    Expect(1, 9472, '\p{^isenclosedalphanumerics}', "");
    Expect(1, 9472, '\P{isenclosedalphanumerics}', "");
    Expect(0, 9472, '\P{^isenclosedalphanumerics}', "");
    Expect(1, 9471, '\p{	IS_enclosed_Alphanumerics}', "");
    Expect(0, 9471, '\p{^	IS_enclosed_Alphanumerics}', "");
    Expect(0, 9471, '\P{	IS_enclosed_Alphanumerics}', "");
    Expect(1, 9471, '\P{^	IS_enclosed_Alphanumerics}', "");
    Expect(0, 9472, '\p{	IS_enclosed_Alphanumerics}', "");
    Expect(1, 9472, '\p{^	IS_enclosed_Alphanumerics}', "");
    Expect(1, 9472, '\P{	IS_enclosed_Alphanumerics}', "");
    Expect(0, 9472, '\P{^	IS_enclosed_Alphanumerics}', "");
    Error('\p{:=--in_ENCLOSED_Alphanumerics}');
    Error('\P{:=--in_ENCLOSED_Alphanumerics}');
    Expect(1, 9471, '\p{inenclosedalphanumerics}', "");
    Expect(0, 9471, '\p{^inenclosedalphanumerics}', "");
    Expect(0, 9471, '\P{inenclosedalphanumerics}', "");
    Expect(1, 9471, '\P{^inenclosedalphanumerics}', "");
    Expect(0, 9472, '\p{inenclosedalphanumerics}', "");
    Expect(1, 9472, '\p{^inenclosedalphanumerics}', "");
    Expect(1, 9472, '\P{inenclosedalphanumerics}', "");
    Expect(0, 9472, '\P{^inenclosedalphanumerics}', "");
    Expect(1, 9471, '\p{-IN_ENCLOSED_Alphanumerics}', "");
    Expect(0, 9471, '\p{^-IN_ENCLOSED_Alphanumerics}', "");
    Expect(0, 9471, '\P{-IN_ENCLOSED_Alphanumerics}', "");
    Expect(1, 9471, '\P{^-IN_ENCLOSED_Alphanumerics}', "");
    Expect(0, 9472, '\p{-IN_ENCLOSED_Alphanumerics}', "");
    Expect(1, 9472, '\p{^-IN_ENCLOSED_Alphanumerics}', "");
    Expect(1, 9472, '\P{-IN_ENCLOSED_Alphanumerics}', "");
    Expect(0, 9472, '\P{^-IN_ENCLOSED_Alphanumerics}', "");
    Error('\p{:=ENCLOSED_Alphanum}');
    Error('\P{:=ENCLOSED_Alphanum}');
    Expect(1, 9471, '\p{enclosedalphanum}', "");
    Expect(0, 9471, '\p{^enclosedalphanum}', "");
    Expect(0, 9471, '\P{enclosedalphanum}', "");
    Expect(1, 9471, '\P{^enclosedalphanum}', "");
    Expect(0, 9472, '\p{enclosedalphanum}', "");
    Expect(1, 9472, '\p{^enclosedalphanum}', "");
    Expect(1, 9472, '\P{enclosedalphanum}', "");
    Expect(0, 9472, '\P{^enclosedalphanum}', "");
    Expect(1, 9471, '\p{ Enclosed_ALPHANUM}', "");
    Expect(0, 9471, '\p{^ Enclosed_ALPHANUM}', "");
    Expect(0, 9471, '\P{ Enclosed_ALPHANUM}', "");
    Expect(1, 9471, '\P{^ Enclosed_ALPHANUM}', "");
    Expect(0, 9472, '\p{ Enclosed_ALPHANUM}', "");
    Expect(1, 9472, '\p{^ Enclosed_ALPHANUM}', "");
    Expect(1, 9472, '\P{ Enclosed_ALPHANUM}', "");
    Expect(0, 9472, '\P{^ Enclosed_ALPHANUM}', "");
    Error('\p{	_Is_Enclosed_ALPHANUM/a/}');
    Error('\P{	_Is_Enclosed_ALPHANUM/a/}');
    Expect(1, 9471, '\p{isenclosedalphanum}', "");
    Expect(0, 9471, '\p{^isenclosedalphanum}', "");
    Expect(0, 9471, '\P{isenclosedalphanum}', "");
    Expect(1, 9471, '\P{^isenclosedalphanum}', "");
    Expect(0, 9472, '\p{isenclosedalphanum}', "");
    Expect(1, 9472, '\p{^isenclosedalphanum}', "");
    Expect(1, 9472, '\P{isenclosedalphanum}', "");
    Expect(0, 9472, '\P{^isenclosedalphanum}', "");
    Expect(1, 9471, '\p{	_IS_enclosed_Alphanum}', "");
    Expect(0, 9471, '\p{^	_IS_enclosed_Alphanum}', "");
    Expect(0, 9471, '\P{	_IS_enclosed_Alphanum}', "");
    Expect(1, 9471, '\P{^	_IS_enclosed_Alphanum}', "");
    Expect(0, 9472, '\p{	_IS_enclosed_Alphanum}', "");
    Expect(1, 9472, '\p{^	_IS_enclosed_Alphanum}', "");
    Expect(1, 9472, '\P{	_IS_enclosed_Alphanum}', "");
    Expect(0, 9472, '\P{^	_IS_enclosed_Alphanum}', "");
    Error('\p{__in_Enclosed_Alphanum/a/}');
    Error('\P{__in_Enclosed_Alphanum/a/}');
    Expect(1, 9471, '\p{inenclosedalphanum}', "");
    Expect(0, 9471, '\p{^inenclosedalphanum}', "");
    Expect(0, 9471, '\P{inenclosedalphanum}', "");
    Expect(1, 9471, '\P{^inenclosedalphanum}', "");
    Expect(0, 9472, '\p{inenclosedalphanum}', "");
    Expect(1, 9472, '\p{^inenclosedalphanum}', "");
    Expect(1, 9472, '\P{inenclosedalphanum}', "");
    Expect(0, 9472, '\P{^inenclosedalphanum}', "");
    Expect(1, 9471, '\p{ _IN_enclosed_Alphanum}', "");
    Expect(0, 9471, '\p{^ _IN_enclosed_Alphanum}', "");
    Expect(0, 9471, '\P{ _IN_enclosed_Alphanum}', "");
    Expect(1, 9471, '\P{^ _IN_enclosed_Alphanum}', "");
    Expect(0, 9472, '\p{ _IN_enclosed_Alphanum}', "");
    Expect(1, 9472, '\p{^ _IN_enclosed_Alphanum}', "");
    Expect(1, 9472, '\P{ _IN_enclosed_Alphanum}', "");
    Expect(0, 9472, '\P{^ _IN_enclosed_Alphanum}', "");
    Error('\p{:=-_enclosed_CJK_LETTERS_And_MONTHS}');
    Error('\P{:=-_enclosed_CJK_LETTERS_And_MONTHS}');
    Expect(1, 13055, '\p{enclosedcjklettersandmonths}', "");
    Expect(0, 13055, '\p{^enclosedcjklettersandmonths}', "");
    Expect(0, 13055, '\P{enclosedcjklettersandmonths}', "");
    Expect(1, 13055, '\P{^enclosedcjklettersandmonths}', "");
    Expect(0, 13056, '\p{enclosedcjklettersandmonths}', "");
    Expect(1, 13056, '\p{^enclosedcjklettersandmonths}', "");
    Expect(1, 13056, '\P{enclosedcjklettersandmonths}', "");
    Expect(0, 13056, '\P{^enclosedcjklettersandmonths}', "");
    Expect(1, 13055, '\p{__ENCLOSED_cjk_Letters_and_MONTHS}', "");
    Expect(0, 13055, '\p{^__ENCLOSED_cjk_Letters_and_MONTHS}', "");
    Expect(0, 13055, '\P{__ENCLOSED_cjk_Letters_and_MONTHS}', "");
    Expect(1, 13055, '\P{^__ENCLOSED_cjk_Letters_and_MONTHS}', "");
    Expect(0, 13056, '\p{__ENCLOSED_cjk_Letters_and_MONTHS}', "");
    Expect(1, 13056, '\p{^__ENCLOSED_cjk_Letters_and_MONTHS}', "");
    Expect(1, 13056, '\P{__ENCLOSED_cjk_Letters_and_MONTHS}', "");
    Expect(0, 13056, '\P{^__ENCLOSED_cjk_Letters_and_MONTHS}', "");
    Error('\p{:=	IS_enclosed_CJK_LETTERS_and_Months}');
    Error('\P{:=	IS_enclosed_CJK_LETTERS_and_Months}');
    Expect(1, 13055, '\p{isenclosedcjklettersandmonths}', "");
    Expect(0, 13055, '\p{^isenclosedcjklettersandmonths}', "");
    Expect(0, 13055, '\P{isenclosedcjklettersandmonths}', "");
    Expect(1, 13055, '\P{^isenclosedcjklettersandmonths}', "");
    Expect(0, 13056, '\p{isenclosedcjklettersandmonths}', "");
    Expect(1, 13056, '\p{^isenclosedcjklettersandmonths}', "");
    Expect(1, 13056, '\P{isenclosedcjklettersandmonths}', "");
    Expect(0, 13056, '\P{^isenclosedcjklettersandmonths}', "");
    Expect(1, 13055, '\p{ 	is_Enclosed_CJK_Letters_and_months}', "");
    Expect(0, 13055, '\p{^ 	is_Enclosed_CJK_Letters_and_months}', "");
    Expect(0, 13055, '\P{ 	is_Enclosed_CJK_Letters_and_months}', "");
    Expect(1, 13055, '\P{^ 	is_Enclosed_CJK_Letters_and_months}', "");
    Expect(0, 13056, '\p{ 	is_Enclosed_CJK_Letters_and_months}', "");
    Expect(1, 13056, '\p{^ 	is_Enclosed_CJK_Letters_and_months}', "");
    Expect(1, 13056, '\P{ 	is_Enclosed_CJK_Letters_and_months}', "");
    Expect(0, 13056, '\P{^ 	is_Enclosed_CJK_Letters_and_months}', "");
    Error('\p{/a/-_in_enclosed_CJK_Letters_and_Months}');
    Error('\P{/a/-_in_enclosed_CJK_Letters_and_Months}');
    Expect(1, 13055, '\p{inenclosedcjklettersandmonths}', "");
    Expect(0, 13055, '\p{^inenclosedcjklettersandmonths}', "");
    Expect(0, 13055, '\P{inenclosedcjklettersandmonths}', "");
    Expect(1, 13055, '\P{^inenclosedcjklettersandmonths}', "");
    Expect(0, 13056, '\p{inenclosedcjklettersandmonths}', "");
    Expect(1, 13056, '\p{^inenclosedcjklettersandmonths}', "");
    Expect(1, 13056, '\P{inenclosedcjklettersandmonths}', "");
    Expect(0, 13056, '\P{^inenclosedcjklettersandmonths}', "");
    Expect(1, 13055, '\p{ IN_Enclosed_CJK_Letters_and_Months}', "");
    Expect(0, 13055, '\p{^ IN_Enclosed_CJK_Letters_and_Months}', "");
    Expect(0, 13055, '\P{ IN_Enclosed_CJK_Letters_and_Months}', "");
    Expect(1, 13055, '\P{^ IN_Enclosed_CJK_Letters_and_Months}', "");
    Expect(0, 13056, '\p{ IN_Enclosed_CJK_Letters_and_Months}', "");
    Expect(1, 13056, '\p{^ IN_Enclosed_CJK_Letters_and_Months}', "");
    Expect(1, 13056, '\P{ IN_Enclosed_CJK_Letters_and_Months}', "");
    Expect(0, 13056, '\P{^ IN_Enclosed_CJK_Letters_and_Months}', "");
    Error('\p{_:=enclosed_cjk}');
    Error('\P{_:=enclosed_cjk}');
    Expect(1, 13055, '\p{enclosedcjk}', "");
    Expect(0, 13055, '\p{^enclosedcjk}', "");
    Expect(0, 13055, '\P{enclosedcjk}', "");
    Expect(1, 13055, '\P{^enclosedcjk}', "");
    Expect(0, 13056, '\p{enclosedcjk}', "");
    Expect(1, 13056, '\p{^enclosedcjk}', "");
    Expect(1, 13056, '\P{enclosedcjk}', "");
    Expect(0, 13056, '\P{^enclosedcjk}', "");
    Expect(1, 13055, '\p{- ENCLOSED_cjk}', "");
    Expect(0, 13055, '\p{^- ENCLOSED_cjk}', "");
    Expect(0, 13055, '\P{- ENCLOSED_cjk}', "");
    Expect(1, 13055, '\P{^- ENCLOSED_cjk}', "");
    Expect(0, 13056, '\p{- ENCLOSED_cjk}', "");
    Expect(1, 13056, '\p{^- ENCLOSED_cjk}', "");
    Expect(1, 13056, '\P{- ENCLOSED_cjk}', "");
    Expect(0, 13056, '\P{^- ENCLOSED_cjk}', "");
    Error('\p{ IS_Enclosed_CJK:=}');
    Error('\P{ IS_Enclosed_CJK:=}');
    Expect(1, 13055, '\p{isenclosedcjk}', "");
    Expect(0, 13055, '\p{^isenclosedcjk}', "");
    Expect(0, 13055, '\P{isenclosedcjk}', "");
    Expect(1, 13055, '\P{^isenclosedcjk}', "");
    Expect(0, 13056, '\p{isenclosedcjk}', "");
    Expect(1, 13056, '\p{^isenclosedcjk}', "");
    Expect(1, 13056, '\P{isenclosedcjk}', "");
    Expect(0, 13056, '\P{^isenclosedcjk}', "");
    Expect(1, 13055, '\p{	_Is_ENCLOSED_cjk}', "");
    Expect(0, 13055, '\p{^	_Is_ENCLOSED_cjk}', "");
    Expect(0, 13055, '\P{	_Is_ENCLOSED_cjk}', "");
    Expect(1, 13055, '\P{^	_Is_ENCLOSED_cjk}', "");
    Expect(0, 13056, '\p{	_Is_ENCLOSED_cjk}', "");
    Expect(1, 13056, '\p{^	_Is_ENCLOSED_cjk}', "");
    Expect(1, 13056, '\P{	_Is_ENCLOSED_cjk}', "");
    Expect(0, 13056, '\P{^	_Is_ENCLOSED_cjk}', "");
    Error('\p{:=in_Enclosed_CJK}');
    Error('\P{:=in_Enclosed_CJK}');
    Expect(1, 13055, '\p{inenclosedcjk}', "");
    Expect(0, 13055, '\p{^inenclosedcjk}', "");
    Expect(0, 13055, '\P{inenclosedcjk}', "");
    Expect(1, 13055, '\P{^inenclosedcjk}', "");
    Expect(0, 13056, '\p{inenclosedcjk}', "");
    Expect(1, 13056, '\p{^inenclosedcjk}', "");
    Expect(1, 13056, '\P{inenclosedcjk}', "");
    Expect(0, 13056, '\P{^inenclosedcjk}', "");
    Expect(1, 13055, '\p{	 In_Enclosed_CJK}', "");
    Expect(0, 13055, '\p{^	 In_Enclosed_CJK}', "");
    Expect(0, 13055, '\P{	 In_Enclosed_CJK}', "");
    Expect(1, 13055, '\P{^	 In_Enclosed_CJK}', "");
    Expect(0, 13056, '\p{	 In_Enclosed_CJK}', "");
    Expect(1, 13056, '\p{^	 In_Enclosed_CJK}', "");
    Expect(1, 13056, '\P{	 In_Enclosed_CJK}', "");
    Expect(0, 13056, '\P{^	 In_Enclosed_CJK}', "");
    Error('\p{		ENCLOSED_IDEOGRAPHIC_Supplement/a/}');
    Error('\P{		ENCLOSED_IDEOGRAPHIC_Supplement/a/}');
    Expect(1, 127743, '\p{enclosedideographicsupplement}', "");
    Expect(0, 127743, '\p{^enclosedideographicsupplement}', "");
    Expect(0, 127743, '\P{enclosedideographicsupplement}', "");
    Expect(1, 127743, '\P{^enclosedideographicsupplement}', "");
    Expect(0, 127744, '\p{enclosedideographicsupplement}', "");
    Expect(1, 127744, '\p{^enclosedideographicsupplement}', "");
    Expect(1, 127744, '\P{enclosedideographicsupplement}', "");
    Expect(0, 127744, '\P{^enclosedideographicsupplement}', "");
    Expect(1, 127743, '\p{__ENCLOSED_Ideographic_supplement}', "");
    Expect(0, 127743, '\p{^__ENCLOSED_Ideographic_supplement}', "");
    Expect(0, 127743, '\P{__ENCLOSED_Ideographic_supplement}', "");
    Expect(1, 127743, '\P{^__ENCLOSED_Ideographic_supplement}', "");
    Expect(0, 127744, '\p{__ENCLOSED_Ideographic_supplement}', "");
    Expect(1, 127744, '\p{^__ENCLOSED_Ideographic_supplement}', "");
    Expect(1, 127744, '\P{__ENCLOSED_Ideographic_supplement}', "");
    Expect(0, 127744, '\P{^__ENCLOSED_Ideographic_supplement}', "");
    Error('\p{_Is_ENCLOSED_IDEOGRAPHIC_Supplement/a/}');
    Error('\P{_Is_ENCLOSED_IDEOGRAPHIC_Supplement/a/}');
    Expect(1, 127743, '\p{isenclosedideographicsupplement}', "");
    Expect(0, 127743, '\p{^isenclosedideographicsupplement}', "");
    Expect(0, 127743, '\P{isenclosedideographicsupplement}', "");
    Expect(1, 127743, '\P{^isenclosedideographicsupplement}', "");
    Expect(0, 127744, '\p{isenclosedideographicsupplement}', "");
    Expect(1, 127744, '\p{^isenclosedideographicsupplement}', "");
    Expect(1, 127744, '\P{isenclosedideographicsupplement}', "");
    Expect(0, 127744, '\P{^isenclosedideographicsupplement}', "");
    Expect(1, 127743, '\p{__is_enclosed_Ideographic_Supplement}', "");
    Expect(0, 127743, '\p{^__is_enclosed_Ideographic_Supplement}', "");
    Expect(0, 127743, '\P{__is_enclosed_Ideographic_Supplement}', "");
    Expect(1, 127743, '\P{^__is_enclosed_Ideographic_Supplement}', "");
    Expect(0, 127744, '\p{__is_enclosed_Ideographic_Supplement}', "");
    Expect(1, 127744, '\p{^__is_enclosed_Ideographic_Supplement}', "");
    Expect(1, 127744, '\P{__is_enclosed_Ideographic_Supplement}', "");
    Expect(0, 127744, '\P{^__is_enclosed_Ideographic_Supplement}', "");
    Error('\p{:= 	IN_enclosed_Ideographic_supplement}');
    Error('\P{:= 	IN_enclosed_Ideographic_supplement}');
    Expect(1, 127743, '\p{inenclosedideographicsupplement}', "");
    Expect(0, 127743, '\p{^inenclosedideographicsupplement}', "");
    Expect(0, 127743, '\P{inenclosedideographicsupplement}', "");
    Expect(1, 127743, '\P{^inenclosedideographicsupplement}', "");
    Expect(0, 127744, '\p{inenclosedideographicsupplement}', "");
    Expect(1, 127744, '\p{^inenclosedideographicsupplement}', "");
    Expect(1, 127744, '\P{inenclosedideographicsupplement}', "");
    Expect(0, 127744, '\P{^inenclosedideographicsupplement}', "");
    Expect(1, 127743, '\p{- IN_ENCLOSED_Ideographic_Supplement}', "");
    Expect(0, 127743, '\p{^- IN_ENCLOSED_Ideographic_Supplement}', "");
    Expect(0, 127743, '\P{- IN_ENCLOSED_Ideographic_Supplement}', "");
    Expect(1, 127743, '\P{^- IN_ENCLOSED_Ideographic_Supplement}', "");
    Expect(0, 127744, '\p{- IN_ENCLOSED_Ideographic_Supplement}', "");
    Expect(1, 127744, '\p{^- IN_ENCLOSED_Ideographic_Supplement}', "");
    Expect(1, 127744, '\P{- IN_ENCLOSED_Ideographic_Supplement}', "");
    Expect(0, 127744, '\P{^- IN_ENCLOSED_Ideographic_Supplement}', "");
    Error('\p{	_enclosed_Ideographic_SUP:=}');
    Error('\P{	_enclosed_Ideographic_SUP:=}');
    Expect(1, 127743, '\p{enclosedideographicsup}', "");
    Expect(0, 127743, '\p{^enclosedideographicsup}', "");
    Expect(0, 127743, '\P{enclosedideographicsup}', "");
    Expect(1, 127743, '\P{^enclosedideographicsup}', "");
    Expect(0, 127744, '\p{enclosedideographicsup}', "");
    Expect(1, 127744, '\p{^enclosedideographicsup}', "");
    Expect(1, 127744, '\P{enclosedideographicsup}', "");
    Expect(0, 127744, '\P{^enclosedideographicsup}', "");
    Expect(1, 127743, '\p{-_enclosed_Ideographic_Sup}', "");
    Expect(0, 127743, '\p{^-_enclosed_Ideographic_Sup}', "");
    Expect(0, 127743, '\P{-_enclosed_Ideographic_Sup}', "");
    Expect(1, 127743, '\P{^-_enclosed_Ideographic_Sup}', "");
    Expect(0, 127744, '\p{-_enclosed_Ideographic_Sup}', "");
    Expect(1, 127744, '\p{^-_enclosed_Ideographic_Sup}', "");
    Expect(1, 127744, '\P{-_enclosed_Ideographic_Sup}', "");
    Expect(0, 127744, '\P{^-_enclosed_Ideographic_Sup}', "");
    Error('\p{:=		is_enclosed_Ideographic_Sup}');
    Error('\P{:=		is_enclosed_Ideographic_Sup}');
    Expect(1, 127743, '\p{isenclosedideographicsup}', "");
    Expect(0, 127743, '\p{^isenclosedideographicsup}', "");
    Expect(0, 127743, '\P{isenclosedideographicsup}', "");
    Expect(1, 127743, '\P{^isenclosedideographicsup}', "");
    Expect(0, 127744, '\p{isenclosedideographicsup}', "");
    Expect(1, 127744, '\p{^isenclosedideographicsup}', "");
    Expect(1, 127744, '\P{isenclosedideographicsup}', "");
    Expect(0, 127744, '\P{^isenclosedideographicsup}', "");
    Expect(1, 127743, '\p{	Is_Enclosed_Ideographic_sup}', "");
    Expect(0, 127743, '\p{^	Is_Enclosed_Ideographic_sup}', "");
    Expect(0, 127743, '\P{	Is_Enclosed_Ideographic_sup}', "");
    Expect(1, 127743, '\P{^	Is_Enclosed_Ideographic_sup}', "");
    Expect(0, 127744, '\p{	Is_Enclosed_Ideographic_sup}', "");
    Expect(1, 127744, '\p{^	Is_Enclosed_Ideographic_sup}', "");
    Expect(1, 127744, '\P{	Is_Enclosed_Ideographic_sup}', "");
    Expect(0, 127744, '\P{^	Is_Enclosed_Ideographic_sup}', "");
    Error('\p{_-In_Enclosed_IDEOGRAPHIC_SUP/a/}');
    Error('\P{_-In_Enclosed_IDEOGRAPHIC_SUP/a/}');
    Expect(1, 127743, '\p{inenclosedideographicsup}', "");
    Expect(0, 127743, '\p{^inenclosedideographicsup}', "");
    Expect(0, 127743, '\P{inenclosedideographicsup}', "");
    Expect(1, 127743, '\P{^inenclosedideographicsup}', "");
    Expect(0, 127744, '\p{inenclosedideographicsup}', "");
    Expect(1, 127744, '\p{^inenclosedideographicsup}', "");
    Expect(1, 127744, '\P{inenclosedideographicsup}', "");
    Expect(0, 127744, '\P{^inenclosedideographicsup}', "");
    Expect(1, 127743, '\p{	-In_ENCLOSED_Ideographic_SUP}', "");
    Expect(0, 127743, '\p{^	-In_ENCLOSED_Ideographic_SUP}', "");
    Expect(0, 127743, '\P{	-In_ENCLOSED_Ideographic_SUP}', "");
    Expect(1, 127743, '\P{^	-In_ENCLOSED_Ideographic_SUP}', "");
    Expect(0, 127744, '\p{	-In_ENCLOSED_Ideographic_SUP}', "");
    Expect(1, 127744, '\p{^	-In_ENCLOSED_Ideographic_SUP}', "");
    Expect(1, 127744, '\P{	-In_ENCLOSED_Ideographic_SUP}', "");
    Expect(0, 127744, '\P{^	-In_ENCLOSED_Ideographic_SUP}', "");
    Error('\p{/a/	enclosing_Mark}');
    Error('\P{/a/	enclosing_Mark}');
    Expect(1, 42610, '\p{enclosingmark}', "");
    Expect(0, 42610, '\p{^enclosingmark}', "");
    Expect(0, 42610, '\P{enclosingmark}', "");
    Expect(1, 42610, '\P{^enclosingmark}', "");
    Expect(0, 42611, '\p{enclosingmark}', "");
    Expect(1, 42611, '\p{^enclosingmark}', "");
    Expect(1, 42611, '\P{enclosingmark}', "");
    Expect(0, 42611, '\P{^enclosingmark}', "");
    Expect(1, 42610, '\p{ Enclosing_MARK}', "");
    Expect(0, 42610, '\p{^ Enclosing_MARK}', "");
    Expect(0, 42610, '\P{ Enclosing_MARK}', "");
    Expect(1, 42610, '\P{^ Enclosing_MARK}', "");
    Expect(0, 42611, '\p{ Enclosing_MARK}', "");
    Expect(1, 42611, '\p{^ Enclosing_MARK}', "");
    Expect(1, 42611, '\P{ Enclosing_MARK}', "");
    Expect(0, 42611, '\P{^ Enclosing_MARK}', "");
    Error('\p{/a/__Is_Enclosing_Mark}');
    Error('\P{/a/__Is_Enclosing_Mark}');
    Expect(1, 42610, '\p{isenclosingmark}', "");
    Expect(0, 42610, '\p{^isenclosingmark}', "");
    Expect(0, 42610, '\P{isenclosingmark}', "");
    Expect(1, 42610, '\P{^isenclosingmark}', "");
    Expect(0, 42611, '\p{isenclosingmark}', "");
    Expect(1, 42611, '\p{^isenclosingmark}', "");
    Expect(1, 42611, '\P{isenclosingmark}', "");
    Expect(0, 42611, '\P{^isenclosingmark}', "");
    Expect(1, 42610, '\p{-Is_enclosing_Mark}', "");
    Expect(0, 42610, '\p{^-Is_enclosing_Mark}', "");
    Expect(0, 42610, '\P{-Is_enclosing_Mark}', "");
    Expect(1, 42610, '\P{^-Is_enclosing_Mark}', "");
    Expect(0, 42611, '\p{-Is_enclosing_Mark}', "");
    Expect(1, 42611, '\p{^-Is_enclosing_Mark}', "");
    Expect(1, 42611, '\P{-Is_enclosing_Mark}', "");
    Expect(0, 42611, '\P{^-Is_enclosing_Mark}', "");
    Error('\p{/a/-_Me}');
    Error('\P{/a/-_Me}');
    Expect(1, 42610, '\p{me}', "");
    Expect(0, 42610, '\p{^me}', "");
    Expect(0, 42610, '\P{me}', "");
    Expect(1, 42610, '\P{^me}', "");
    Expect(0, 42611, '\p{me}', "");
    Expect(1, 42611, '\p{^me}', "");
    Expect(1, 42611, '\P{me}', "");
    Expect(0, 42611, '\P{^me}', "");
    Expect(1, 42610, '\p{	-ME}', "");
    Expect(0, 42610, '\p{^	-ME}', "");
    Expect(0, 42610, '\P{	-ME}', "");
    Expect(1, 42610, '\P{^	-ME}', "");
    Expect(0, 42611, '\p{	-ME}', "");
    Expect(1, 42611, '\p{^	-ME}', "");
    Expect(1, 42611, '\P{	-ME}', "");
    Expect(0, 42611, '\P{^	-ME}', "");
    Error('\p{/a/_ Is_me}');
    Error('\P{/a/_ Is_me}');
    Expect(1, 42610, '\p{isme}', "");
    Expect(0, 42610, '\p{^isme}', "");
    Expect(0, 42610, '\P{isme}', "");
    Expect(1, 42610, '\P{^isme}', "");
    Expect(0, 42611, '\p{isme}', "");
    Expect(1, 42611, '\p{^isme}', "");
    Expect(1, 42611, '\P{isme}', "");
    Expect(0, 42611, '\P{^isme}', "");
    Expect(1, 42610, '\p{ is_Me}', "");
    Expect(0, 42610, '\p{^ is_Me}', "");
    Expect(0, 42610, '\P{ is_Me}', "");
    Expect(1, 42610, '\P{^ is_Me}', "");
    Expect(0, 42611, '\p{ is_Me}', "");
    Expect(1, 42611, '\p{^ is_Me}', "");
    Expect(1, 42611, '\P{ is_Me}', "");
    Expect(0, 42611, '\P{^ is_Me}', "");
    Error('\p{/a/Ethiopic}');
    Error('\P{/a/Ethiopic}');
    Expect(1, 43822, '\p{ethiopic}', "");
    Expect(0, 43822, '\p{^ethiopic}', "");
    Expect(0, 43822, '\P{ethiopic}', "");
    Expect(1, 43822, '\P{^ethiopic}', "");
    Expect(0, 43823, '\p{ethiopic}', "");
    Expect(1, 43823, '\p{^ethiopic}', "");
    Expect(1, 43823, '\P{ethiopic}', "");
    Expect(0, 43823, '\P{^ethiopic}', "");
    Expect(1, 43822, '\p{	Ethiopic}', "");
    Expect(0, 43822, '\p{^	Ethiopic}', "");
    Expect(0, 43822, '\P{	Ethiopic}', "");
    Expect(1, 43822, '\P{^	Ethiopic}', "");
    Expect(0, 43823, '\p{	Ethiopic}', "");
    Expect(1, 43823, '\p{^	Ethiopic}', "");
    Expect(1, 43823, '\P{	Ethiopic}', "");
    Expect(0, 43823, '\P{^	Ethiopic}', "");
    Error('\p{ Is_ETHIOPIC/a/}');
    Error('\P{ Is_ETHIOPIC/a/}');
    Expect(1, 43822, '\p{isethiopic}', "");
    Expect(0, 43822, '\p{^isethiopic}', "");
    Expect(0, 43822, '\P{isethiopic}', "");
    Expect(1, 43822, '\P{^isethiopic}', "");
    Expect(0, 43823, '\p{isethiopic}', "");
    Expect(1, 43823, '\p{^isethiopic}', "");
    Expect(1, 43823, '\P{isethiopic}', "");
    Expect(0, 43823, '\P{^isethiopic}', "");
    Expect(1, 43822, '\p{Is_ETHIOPIC}', "");
    Expect(0, 43822, '\p{^Is_ETHIOPIC}', "");
    Expect(0, 43822, '\P{Is_ETHIOPIC}', "");
    Expect(1, 43822, '\P{^Is_ETHIOPIC}', "");
    Expect(0, 43823, '\p{Is_ETHIOPIC}', "");
    Expect(1, 43823, '\p{^Is_ETHIOPIC}', "");
    Expect(1, 43823, '\P{Is_ETHIOPIC}', "");
    Expect(0, 43823, '\P{^Is_ETHIOPIC}', "");
    Error('\p{:=- Ethi}');
    Error('\P{:=- Ethi}');
    Expect(1, 43822, '\p{ethi}', "");
    Expect(0, 43822, '\p{^ethi}', "");
    Expect(0, 43822, '\P{ethi}', "");
    Expect(1, 43822, '\P{^ethi}', "");
    Expect(0, 43823, '\p{ethi}', "");
    Expect(1, 43823, '\p{^ethi}', "");
    Expect(1, 43823, '\P{ethi}', "");
    Expect(0, 43823, '\P{^ethi}', "");
    Expect(1, 43822, '\p{	ETHI}', "");
    Expect(0, 43822, '\p{^	ETHI}', "");
    Expect(0, 43822, '\P{	ETHI}', "");
    Expect(1, 43822, '\P{^	ETHI}', "");
    Expect(0, 43823, '\p{	ETHI}', "");
    Expect(1, 43823, '\p{^	ETHI}', "");
    Expect(1, 43823, '\P{	ETHI}', "");
    Expect(0, 43823, '\P{^	ETHI}', "");
    Error('\p{_-IS_ETHI:=}');
    Error('\P{_-IS_ETHI:=}');
    Expect(1, 43822, '\p{isethi}', "");
    Expect(0, 43822, '\p{^isethi}', "");
    Expect(0, 43822, '\P{isethi}', "");
    Expect(1, 43822, '\P{^isethi}', "");
    Expect(0, 43823, '\p{isethi}', "");
    Expect(1, 43823, '\p{^isethi}', "");
    Expect(1, 43823, '\P{isethi}', "");
    Expect(0, 43823, '\P{^isethi}', "");
    Expect(1, 43822, '\p{_	is_ETHI}', "");
    Expect(0, 43822, '\p{^_	is_ETHI}', "");
    Expect(0, 43822, '\P{_	is_ETHI}', "");
    Expect(1, 43822, '\P{^_	is_ETHI}', "");
    Expect(0, 43823, '\p{_	is_ETHI}', "");
    Expect(1, 43823, '\p{^_	is_ETHI}', "");
    Expect(1, 43823, '\P{_	is_ETHI}', "");
    Expect(0, 43823, '\P{^_	is_ETHI}', "");
    Error('\p{/a/ ETHIOPIC_Extended}');
    Error('\P{/a/ ETHIOPIC_Extended}');
    Expect(1, 11743, '\p{ethiopicextended}', "");
    Expect(0, 11743, '\p{^ethiopicextended}', "");
    Expect(0, 11743, '\P{ethiopicextended}', "");
    Expect(1, 11743, '\P{^ethiopicextended}', "");
    Expect(0, 11744, '\p{ethiopicextended}', "");
    Expect(1, 11744, '\p{^ethiopicextended}', "");
    Expect(1, 11744, '\P{ethiopicextended}', "");
    Expect(0, 11744, '\P{^ethiopicextended}', "");
    Expect(1, 11743, '\p{ 	Ethiopic_extended}', "");
    Expect(0, 11743, '\p{^ 	Ethiopic_extended}', "");
    Expect(0, 11743, '\P{ 	Ethiopic_extended}', "");
    Expect(1, 11743, '\P{^ 	Ethiopic_extended}', "");
    Expect(0, 11744, '\p{ 	Ethiopic_extended}', "");
    Expect(1, 11744, '\p{^ 	Ethiopic_extended}', "");
    Expect(1, 11744, '\P{ 	Ethiopic_extended}', "");
    Expect(0, 11744, '\P{^ 	Ethiopic_extended}', "");
    Error('\p{ is_Ethiopic_Extended:=}');
    Error('\P{ is_Ethiopic_Extended:=}');
    Expect(1, 11743, '\p{isethiopicextended}', "");
    Expect(0, 11743, '\p{^isethiopicextended}', "");
    Expect(0, 11743, '\P{isethiopicextended}', "");
    Expect(1, 11743, '\P{^isethiopicextended}', "");
    Expect(0, 11744, '\p{isethiopicextended}', "");
    Expect(1, 11744, '\p{^isethiopicextended}', "");
    Expect(1, 11744, '\P{isethiopicextended}', "");
    Expect(0, 11744, '\P{^isethiopicextended}', "");
    Expect(1, 11743, '\p{--IS_ETHIOPIC_EXTENDED}', "");
    Expect(0, 11743, '\p{^--IS_ETHIOPIC_EXTENDED}', "");
    Expect(0, 11743, '\P{--IS_ETHIOPIC_EXTENDED}', "");
    Expect(1, 11743, '\P{^--IS_ETHIOPIC_EXTENDED}', "");
    Expect(0, 11744, '\p{--IS_ETHIOPIC_EXTENDED}', "");
    Expect(1, 11744, '\p{^--IS_ETHIOPIC_EXTENDED}', "");
    Expect(1, 11744, '\P{--IS_ETHIOPIC_EXTENDED}', "");
    Expect(0, 11744, '\P{^--IS_ETHIOPIC_EXTENDED}', "");
    Error('\p{:=__In_Ethiopic_extended}');
    Error('\P{:=__In_Ethiopic_extended}');
    Expect(1, 11743, '\p{inethiopicextended}', "");
    Expect(0, 11743, '\p{^inethiopicextended}', "");
    Expect(0, 11743, '\P{inethiopicextended}', "");
    Expect(1, 11743, '\P{^inethiopicextended}', "");
    Expect(0, 11744, '\p{inethiopicextended}', "");
    Expect(1, 11744, '\p{^inethiopicextended}', "");
    Expect(1, 11744, '\P{inethiopicextended}', "");
    Expect(0, 11744, '\P{^inethiopicextended}', "");
    Expect(1, 11743, '\p{_ IN_ethiopic_extended}', "");
    Expect(0, 11743, '\p{^_ IN_ethiopic_extended}', "");
    Expect(0, 11743, '\P{_ IN_ethiopic_extended}', "");
    Expect(1, 11743, '\P{^_ IN_ethiopic_extended}', "");
    Expect(0, 11744, '\p{_ IN_ethiopic_extended}', "");
    Expect(1, 11744, '\p{^_ IN_ethiopic_extended}', "");
    Expect(1, 11744, '\P{_ IN_ethiopic_extended}', "");
    Expect(0, 11744, '\P{^_ IN_ethiopic_extended}', "");
    Error('\p{ Ethiopic_EXT/a/}');
    Error('\P{ Ethiopic_EXT/a/}');
    Expect(1, 11743, '\p{ethiopicext}', "");
    Expect(0, 11743, '\p{^ethiopicext}', "");
    Expect(0, 11743, '\P{ethiopicext}', "");
    Expect(1, 11743, '\P{^ethiopicext}', "");
    Expect(0, 11744, '\p{ethiopicext}', "");
    Expect(1, 11744, '\p{^ethiopicext}', "");
    Expect(1, 11744, '\P{ethiopicext}', "");
    Expect(0, 11744, '\P{^ethiopicext}', "");
    Expect(1, 11743, '\p{__ethiopic_EXT}', "");
    Expect(0, 11743, '\p{^__ethiopic_EXT}', "");
    Expect(0, 11743, '\P{__ethiopic_EXT}', "");
    Expect(1, 11743, '\P{^__ethiopic_EXT}', "");
    Expect(0, 11744, '\p{__ethiopic_EXT}', "");
    Expect(1, 11744, '\p{^__ethiopic_EXT}', "");
    Expect(1, 11744, '\P{__ethiopic_EXT}', "");
    Expect(0, 11744, '\P{^__ethiopic_EXT}', "");
    Error('\p{--IS_ETHIOPIC_Ext:=}');
    Error('\P{--IS_ETHIOPIC_Ext:=}');
    Expect(1, 11743, '\p{isethiopicext}', "");
    Expect(0, 11743, '\p{^isethiopicext}', "");
    Expect(0, 11743, '\P{isethiopicext}', "");
    Expect(1, 11743, '\P{^isethiopicext}', "");
    Expect(0, 11744, '\p{isethiopicext}', "");
    Expect(1, 11744, '\p{^isethiopicext}', "");
    Expect(1, 11744, '\P{isethiopicext}', "");
    Expect(0, 11744, '\P{^isethiopicext}', "");
    Expect(1, 11743, '\p{ Is_ETHIOPIC_EXT}', "");
    Expect(0, 11743, '\p{^ Is_ETHIOPIC_EXT}', "");
    Expect(0, 11743, '\P{ Is_ETHIOPIC_EXT}', "");
    Expect(1, 11743, '\P{^ Is_ETHIOPIC_EXT}', "");
    Expect(0, 11744, '\p{ Is_ETHIOPIC_EXT}', "");
    Expect(1, 11744, '\p{^ Is_ETHIOPIC_EXT}', "");
    Expect(1, 11744, '\P{ Is_ETHIOPIC_EXT}', "");
    Expect(0, 11744, '\P{^ Is_ETHIOPIC_EXT}', "");
    Error('\p{/a/_In_Ethiopic_Ext}');
    Error('\P{/a/_In_Ethiopic_Ext}');
    Expect(1, 11743, '\p{inethiopicext}', "");
    Expect(0, 11743, '\p{^inethiopicext}', "");
    Expect(0, 11743, '\P{inethiopicext}', "");
    Expect(1, 11743, '\P{^inethiopicext}', "");
    Expect(0, 11744, '\p{inethiopicext}', "");
    Expect(1, 11744, '\p{^inethiopicext}', "");
    Expect(1, 11744, '\P{inethiopicext}', "");
    Expect(0, 11744, '\P{^inethiopicext}', "");
    Expect(1, 11743, '\p{ 	In_ethiopic_EXT}', "");
    Expect(0, 11743, '\p{^ 	In_ethiopic_EXT}', "");
    Expect(0, 11743, '\P{ 	In_ethiopic_EXT}', "");
    Expect(1, 11743, '\P{^ 	In_ethiopic_EXT}', "");
    Expect(0, 11744, '\p{ 	In_ethiopic_EXT}', "");
    Expect(1, 11744, '\p{^ 	In_ethiopic_EXT}', "");
    Expect(1, 11744, '\P{ 	In_ethiopic_EXT}', "");
    Expect(0, 11744, '\P{^ 	In_ethiopic_EXT}', "");
    Error('\p{		ETHIOPIC_Extended_A/a/}');
    Error('\P{		ETHIOPIC_Extended_A/a/}');
    Expect(1, 43823, '\p{ethiopicextendeda}', "");
    Expect(0, 43823, '\p{^ethiopicextendeda}', "");
    Expect(0, 43823, '\P{ethiopicextendeda}', "");
    Expect(1, 43823, '\P{^ethiopicextendeda}', "");
    Expect(0, 43824, '\p{ethiopicextendeda}', "");
    Expect(1, 43824, '\p{^ethiopicextendeda}', "");
    Expect(1, 43824, '\P{ethiopicextendeda}', "");
    Expect(0, 43824, '\P{^ethiopicextendeda}', "");
    Expect(1, 43823, '\p{	 ETHIOPIC_Extended_a}', "");
    Expect(0, 43823, '\p{^	 ETHIOPIC_Extended_a}', "");
    Expect(0, 43823, '\P{	 ETHIOPIC_Extended_a}', "");
    Expect(1, 43823, '\P{^	 ETHIOPIC_Extended_a}', "");
    Expect(0, 43824, '\p{	 ETHIOPIC_Extended_a}', "");
    Expect(1, 43824, '\p{^	 ETHIOPIC_Extended_a}', "");
    Expect(1, 43824, '\P{	 ETHIOPIC_Extended_a}', "");
    Expect(0, 43824, '\P{^	 ETHIOPIC_Extended_a}', "");
    Error('\p{-:=Is_ETHIOPIC_EXTENDED_A}');
    Error('\P{-:=Is_ETHIOPIC_EXTENDED_A}');
    Expect(1, 43823, '\p{isethiopicextendeda}', "");
    Expect(0, 43823, '\p{^isethiopicextendeda}', "");
    Expect(0, 43823, '\P{isethiopicextendeda}', "");
    Expect(1, 43823, '\P{^isethiopicextendeda}', "");
    Expect(0, 43824, '\p{isethiopicextendeda}', "");
    Expect(1, 43824, '\p{^isethiopicextendeda}', "");
    Expect(1, 43824, '\P{isethiopicextendeda}', "");
    Expect(0, 43824, '\P{^isethiopicextendeda}', "");
    Expect(1, 43823, '\p{-IS_Ethiopic_extended_A}', "");
    Expect(0, 43823, '\p{^-IS_Ethiopic_extended_A}', "");
    Expect(0, 43823, '\P{-IS_Ethiopic_extended_A}', "");
    Expect(1, 43823, '\P{^-IS_Ethiopic_extended_A}', "");
    Expect(0, 43824, '\p{-IS_Ethiopic_extended_A}', "");
    Expect(1, 43824, '\p{^-IS_Ethiopic_extended_A}', "");
    Expect(1, 43824, '\P{-IS_Ethiopic_extended_A}', "");
    Expect(0, 43824, '\P{^-IS_Ethiopic_extended_A}', "");
    Error('\p{-in_ethiopic_EXTENDED_A/a/}');
    Error('\P{-in_ethiopic_EXTENDED_A/a/}');
    Expect(1, 43823, '\p{inethiopicextendeda}', "");
    Expect(0, 43823, '\p{^inethiopicextendeda}', "");
    Expect(0, 43823, '\P{inethiopicextendeda}', "");
    Expect(1, 43823, '\P{^inethiopicextendeda}', "");
    Expect(0, 43824, '\p{inethiopicextendeda}', "");
    Expect(1, 43824, '\p{^inethiopicextendeda}', "");
    Expect(1, 43824, '\P{inethiopicextendeda}', "");
    Expect(0, 43824, '\P{^inethiopicextendeda}', "");
    Expect(1, 43823, '\p{  in_ETHIOPIC_Extended_A}', "");
    Expect(0, 43823, '\p{^  in_ETHIOPIC_Extended_A}', "");
    Expect(0, 43823, '\P{  in_ETHIOPIC_Extended_A}', "");
    Expect(1, 43823, '\P{^  in_ETHIOPIC_Extended_A}', "");
    Expect(0, 43824, '\p{  in_ETHIOPIC_Extended_A}', "");
    Expect(1, 43824, '\p{^  in_ETHIOPIC_Extended_A}', "");
    Expect(1, 43824, '\P{  in_ETHIOPIC_Extended_A}', "");
    Expect(0, 43824, '\P{^  in_ETHIOPIC_Extended_A}', "");
    Error('\p{	:=ETHIOPIC_ext_A}');
    Error('\P{	:=ETHIOPIC_ext_A}');
    Expect(1, 43823, '\p{ethiopicexta}', "");
    Expect(0, 43823, '\p{^ethiopicexta}', "");
    Expect(0, 43823, '\P{ethiopicexta}', "");
    Expect(1, 43823, '\P{^ethiopicexta}', "");
    Expect(0, 43824, '\p{ethiopicexta}', "");
    Expect(1, 43824, '\p{^ethiopicexta}', "");
    Expect(1, 43824, '\P{ethiopicexta}', "");
    Expect(0, 43824, '\P{^ethiopicexta}', "");
    Expect(1, 43823, '\p{_ethiopic_EXT_A}', "");
    Expect(0, 43823, '\p{^_ethiopic_EXT_A}', "");
    Expect(0, 43823, '\P{_ethiopic_EXT_A}', "");
    Expect(1, 43823, '\P{^_ethiopic_EXT_A}', "");
    Expect(0, 43824, '\p{_ethiopic_EXT_A}', "");
    Expect(1, 43824, '\p{^_ethiopic_EXT_A}', "");
    Expect(1, 43824, '\P{_ethiopic_EXT_A}', "");
    Expect(0, 43824, '\P{^_ethiopic_EXT_A}', "");
    Error('\p{/a/ _Is_Ethiopic_Ext_A}');
    Error('\P{/a/ _Is_Ethiopic_Ext_A}');
    Expect(1, 43823, '\p{isethiopicexta}', "");
    Expect(0, 43823, '\p{^isethiopicexta}', "");
    Expect(0, 43823, '\P{isethiopicexta}', "");
    Expect(1, 43823, '\P{^isethiopicexta}', "");
    Expect(0, 43824, '\p{isethiopicexta}', "");
    Expect(1, 43824, '\p{^isethiopicexta}', "");
    Expect(1, 43824, '\P{isethiopicexta}', "");
    Expect(0, 43824, '\P{^isethiopicexta}', "");
    Expect(1, 43823, '\p{ Is_ETHIOPIC_ext_A}', "");
    Expect(0, 43823, '\p{^ Is_ETHIOPIC_ext_A}', "");
    Expect(0, 43823, '\P{ Is_ETHIOPIC_ext_A}', "");
    Expect(1, 43823, '\P{^ Is_ETHIOPIC_ext_A}', "");
    Expect(0, 43824, '\p{ Is_ETHIOPIC_ext_A}', "");
    Expect(1, 43824, '\p{^ Is_ETHIOPIC_ext_A}', "");
    Expect(1, 43824, '\P{ Is_ETHIOPIC_ext_A}', "");
    Expect(0, 43824, '\P{^ Is_ETHIOPIC_ext_A}', "");
    Error('\p{	/a/in_Ethiopic_Ext_A}');
    Error('\P{	/a/in_Ethiopic_Ext_A}');
    Expect(1, 43823, '\p{inethiopicexta}', "");
    Expect(0, 43823, '\p{^inethiopicexta}', "");
    Expect(0, 43823, '\P{inethiopicexta}', "");
    Expect(1, 43823, '\P{^inethiopicexta}', "");
    Expect(0, 43824, '\p{inethiopicexta}', "");
    Expect(1, 43824, '\p{^inethiopicexta}', "");
    Expect(1, 43824, '\P{inethiopicexta}', "");
    Expect(0, 43824, '\P{^inethiopicexta}', "");
    Expect(1, 43823, '\p{__In_ethiopic_ext_A}', "");
    Expect(0, 43823, '\p{^__In_ethiopic_ext_A}', "");
    Expect(0, 43823, '\P{__In_ethiopic_ext_A}', "");
    Expect(1, 43823, '\P{^__In_ethiopic_ext_A}', "");
    Expect(0, 43824, '\p{__In_ethiopic_ext_A}', "");
    Expect(1, 43824, '\p{^__In_ethiopic_ext_A}', "");
    Expect(1, 43824, '\P{__In_ethiopic_ext_A}', "");
    Expect(0, 43824, '\P{^__In_ethiopic_ext_A}', "");
    Error('\p{-/a/Ethiopic_Supplement}');
    Error('\P{-/a/Ethiopic_Supplement}');
    Expect(1, 5023, '\p{ethiopicsupplement}', "");
    Expect(0, 5023, '\p{^ethiopicsupplement}', "");
    Expect(0, 5023, '\P{ethiopicsupplement}', "");
    Expect(1, 5023, '\P{^ethiopicsupplement}', "");
    Expect(0, 5024, '\p{ethiopicsupplement}', "");
    Expect(1, 5024, '\p{^ethiopicsupplement}', "");
    Expect(1, 5024, '\P{ethiopicsupplement}', "");
    Expect(0, 5024, '\P{^ethiopicsupplement}', "");
    Expect(1, 5023, '\p{ -Ethiopic_SUPPLEMENT}', "");
    Expect(0, 5023, '\p{^ -Ethiopic_SUPPLEMENT}', "");
    Expect(0, 5023, '\P{ -Ethiopic_SUPPLEMENT}', "");
    Expect(1, 5023, '\P{^ -Ethiopic_SUPPLEMENT}', "");
    Expect(0, 5024, '\p{ -Ethiopic_SUPPLEMENT}', "");
    Expect(1, 5024, '\p{^ -Ethiopic_SUPPLEMENT}', "");
    Expect(1, 5024, '\P{ -Ethiopic_SUPPLEMENT}', "");
    Expect(0, 5024, '\P{^ -Ethiopic_SUPPLEMENT}', "");
    Error('\p{	:=Is_Ethiopic_SUPPLEMENT}');
    Error('\P{	:=Is_Ethiopic_SUPPLEMENT}');
    Expect(1, 5023, '\p{isethiopicsupplement}', "");
    Expect(0, 5023, '\p{^isethiopicsupplement}', "");
    Expect(0, 5023, '\P{isethiopicsupplement}', "");
    Expect(1, 5023, '\P{^isethiopicsupplement}', "");
    Expect(0, 5024, '\p{isethiopicsupplement}', "");
    Expect(1, 5024, '\p{^isethiopicsupplement}', "");
    Expect(1, 5024, '\P{isethiopicsupplement}', "");
    Expect(0, 5024, '\P{^isethiopicsupplement}', "");
    Expect(1, 5023, '\p{_ IS_Ethiopic_supplement}', "");
    Expect(0, 5023, '\p{^_ IS_Ethiopic_supplement}', "");
    Expect(0, 5023, '\P{_ IS_Ethiopic_supplement}', "");
    Expect(1, 5023, '\P{^_ IS_Ethiopic_supplement}', "");
    Expect(0, 5024, '\p{_ IS_Ethiopic_supplement}', "");
    Expect(1, 5024, '\p{^_ IS_Ethiopic_supplement}', "");
    Expect(1, 5024, '\P{_ IS_Ethiopic_supplement}', "");
    Expect(0, 5024, '\P{^_ IS_Ethiopic_supplement}', "");
    Error('\p{ in_Ethiopic_Supplement/a/}');
    Error('\P{ in_Ethiopic_Supplement/a/}');
    Expect(1, 5023, '\p{inethiopicsupplement}', "");
    Expect(0, 5023, '\p{^inethiopicsupplement}', "");
    Expect(0, 5023, '\P{inethiopicsupplement}', "");
    Expect(1, 5023, '\P{^inethiopicsupplement}', "");
    Expect(0, 5024, '\p{inethiopicsupplement}', "");
    Expect(1, 5024, '\p{^inethiopicsupplement}', "");
    Expect(1, 5024, '\P{inethiopicsupplement}', "");
    Expect(0, 5024, '\P{^inethiopicsupplement}', "");
    Expect(1, 5023, '\p{  in_ethiopic_Supplement}', "");
    Expect(0, 5023, '\p{^  in_ethiopic_Supplement}', "");
    Expect(0, 5023, '\P{  in_ethiopic_Supplement}', "");
    Expect(1, 5023, '\P{^  in_ethiopic_Supplement}', "");
    Expect(0, 5024, '\p{  in_ethiopic_Supplement}', "");
    Expect(1, 5024, '\p{^  in_ethiopic_Supplement}', "");
    Expect(1, 5024, '\P{  in_ethiopic_Supplement}', "");
    Expect(0, 5024, '\P{^  in_ethiopic_Supplement}', "");
    Error('\p{-:=Ethiopic_Sup}');
    Error('\P{-:=Ethiopic_Sup}');
    Expect(1, 5023, '\p{ethiopicsup}', "");
    Expect(0, 5023, '\p{^ethiopicsup}', "");
    Expect(0, 5023, '\P{ethiopicsup}', "");
    Expect(1, 5023, '\P{^ethiopicsup}', "");
    Expect(0, 5024, '\p{ethiopicsup}', "");
    Expect(1, 5024, '\p{^ethiopicsup}', "");
    Expect(1, 5024, '\P{ethiopicsup}', "");
    Expect(0, 5024, '\P{^ethiopicsup}', "");
    Expect(1, 5023, '\p{- ETHIOPIC_sup}', "");
    Expect(0, 5023, '\p{^- ETHIOPIC_sup}', "");
    Expect(0, 5023, '\P{- ETHIOPIC_sup}', "");
    Expect(1, 5023, '\P{^- ETHIOPIC_sup}', "");
    Expect(0, 5024, '\p{- ETHIOPIC_sup}', "");
    Expect(1, 5024, '\p{^- ETHIOPIC_sup}', "");
    Expect(1, 5024, '\P{- ETHIOPIC_sup}', "");
    Expect(0, 5024, '\P{^- ETHIOPIC_sup}', "");
    Error('\p{  Is_Ethiopic_Sup:=}');
    Error('\P{  Is_Ethiopic_Sup:=}');
    Expect(1, 5023, '\p{isethiopicsup}', "");
    Expect(0, 5023, '\p{^isethiopicsup}', "");
    Expect(0, 5023, '\P{isethiopicsup}', "");
    Expect(1, 5023, '\P{^isethiopicsup}', "");
    Expect(0, 5024, '\p{isethiopicsup}', "");
    Expect(1, 5024, '\p{^isethiopicsup}', "");
    Expect(1, 5024, '\P{isethiopicsup}', "");
    Expect(0, 5024, '\P{^isethiopicsup}', "");
    Expect(1, 5023, '\p{-	is_ETHIOPIC_Sup}', "");
    Expect(0, 5023, '\p{^-	is_ETHIOPIC_Sup}', "");
    Expect(0, 5023, '\P{-	is_ETHIOPIC_Sup}', "");
    Expect(1, 5023, '\P{^-	is_ETHIOPIC_Sup}', "");
    Expect(0, 5024, '\p{-	is_ETHIOPIC_Sup}', "");
    Expect(1, 5024, '\p{^-	is_ETHIOPIC_Sup}', "");
    Expect(1, 5024, '\P{-	is_ETHIOPIC_Sup}', "");
    Expect(0, 5024, '\P{^-	is_ETHIOPIC_Sup}', "");
    Error('\p{:=-in_ETHIOPIC_SUP}');
    Error('\P{:=-in_ETHIOPIC_SUP}');
    Expect(1, 5023, '\p{inethiopicsup}', "");
    Expect(0, 5023, '\p{^inethiopicsup}', "");
    Expect(0, 5023, '\P{inethiopicsup}', "");
    Expect(1, 5023, '\P{^inethiopicsup}', "");
    Expect(0, 5024, '\p{inethiopicsup}', "");
    Expect(1, 5024, '\p{^inethiopicsup}', "");
    Expect(1, 5024, '\P{inethiopicsup}', "");
    Expect(0, 5024, '\P{^inethiopicsup}', "");
    Expect(1, 5023, '\p{		in_Ethiopic_Sup}', "");
    Expect(0, 5023, '\p{^		in_Ethiopic_Sup}', "");
    Expect(0, 5023, '\P{		in_Ethiopic_Sup}', "");
    Expect(1, 5023, '\P{^		in_Ethiopic_Sup}', "");
    Expect(0, 5024, '\p{		in_Ethiopic_Sup}', "");
    Expect(1, 5024, '\p{^		in_Ethiopic_Sup}', "");
    Expect(1, 5024, '\P{		in_Ethiopic_Sup}', "");
    Expect(0, 5024, '\P{^		in_Ethiopic_Sup}', "");
    Error('\p{Expands_On_NFC}');
    Error('\P{Expands_On_NFC}');
    Error('\p{XO_NFC}');
    Error('\P{XO_NFC}');
    Error('\p{Expands_On_NFD}');
    Error('\P{Expands_On_NFD}');
    Error('\p{XO_NFD}');
    Error('\P{XO_NFD}');
    Error('\p{Expands_On_NFKC}');
    Error('\P{Expands_On_NFKC}');
    Error('\p{XO_NFKC}');
    Error('\P{XO_NFKC}');
    Error('\p{Expands_On_NFKD}');
    Error('\P{Expands_On_NFKD}');
    Error('\p{XO_NFKD}');
    Error('\P{XO_NFKD}');
    Error('\p{	_Extended_Pictographic/a/}');
    Error('\P{	_Extended_Pictographic/a/}');
    Expect(1, 131069, '\p{extendedpictographic}', "");
    Expect(0, 131069, '\p{^extendedpictographic}', "");
    Expect(0, 131069, '\P{extendedpictographic}', "");
    Expect(1, 131069, '\P{^extendedpictographic}', "");
    Expect(0, 131072, '\p{extendedpictographic}', "");
    Expect(1, 131072, '\p{^extendedpictographic}', "");
    Expect(1, 131072, '\P{extendedpictographic}', "");
    Expect(0, 131072, '\P{^extendedpictographic}', "");
    Expect(1, 131069, '\p{ _EXTENDED_PICTOGRAPHIC}', "");
    Expect(0, 131069, '\p{^ _EXTENDED_PICTOGRAPHIC}', "");
    Expect(0, 131069, '\P{ _EXTENDED_PICTOGRAPHIC}', "");
    Expect(1, 131069, '\P{^ _EXTENDED_PICTOGRAPHIC}', "");
    Expect(0, 131072, '\p{ _EXTENDED_PICTOGRAPHIC}', "");
    Expect(1, 131072, '\p{^ _EXTENDED_PICTOGRAPHIC}', "");
    Expect(1, 131072, '\P{ _EXTENDED_PICTOGRAPHIC}', "");
    Expect(0, 131072, '\P{^ _EXTENDED_PICTOGRAPHIC}', "");
    Error('\p{/a/	Is_EXTENDED_pictographic}');
    Error('\P{/a/	Is_EXTENDED_pictographic}');
    Expect(1, 131069, '\p{isextendedpictographic}', "");
    Expect(0, 131069, '\p{^isextendedpictographic}', "");
    Expect(0, 131069, '\P{isextendedpictographic}', "");
    Expect(1, 131069, '\P{^isextendedpictographic}', "");
    Expect(0, 131072, '\p{isextendedpictographic}', "");
    Expect(1, 131072, '\p{^isextendedpictographic}', "");
    Expect(1, 131072, '\P{isextendedpictographic}', "");
    Expect(0, 131072, '\P{^isextendedpictographic}', "");
    Expect(1, 131069, '\p{ IS_Extended_pictographic}', "");
    Expect(0, 131069, '\p{^ IS_Extended_pictographic}', "");
    Expect(0, 131069, '\P{ IS_Extended_pictographic}', "");
    Expect(1, 131069, '\P{^ IS_Extended_pictographic}', "");
    Expect(0, 131072, '\p{ IS_Extended_pictographic}', "");
    Expect(1, 131072, '\p{^ IS_Extended_pictographic}', "");
    Expect(1, 131072, '\P{ IS_Extended_pictographic}', "");
    Expect(0, 131072, '\P{^ IS_Extended_pictographic}', "");
    Error('\p{:= 	extpict}');
    Error('\P{:= 	extpict}');
    Expect(1, 131069, '\p{extpict}', "");
    Expect(0, 131069, '\p{^extpict}', "");
    Expect(0, 131069, '\P{extpict}', "");
    Expect(1, 131069, '\P{^extpict}', "");
    Expect(0, 131072, '\p{extpict}', "");
    Expect(1, 131072, '\p{^extpict}', "");
    Expect(1, 131072, '\P{extpict}', "");
    Expect(0, 131072, '\P{^extpict}', "");
    Expect(1, 131069, '\p{-EXTPICT}', "");
    Expect(0, 131069, '\p{^-EXTPICT}', "");
    Expect(0, 131069, '\P{-EXTPICT}', "");
    Expect(1, 131069, '\P{^-EXTPICT}', "");
    Expect(0, 131072, '\p{-EXTPICT}', "");
    Expect(1, 131072, '\p{^-EXTPICT}', "");
    Expect(1, 131072, '\P{-EXTPICT}', "");
    Expect(0, 131072, '\P{^-EXTPICT}', "");
    Error('\p{_ is_EXTPICT:=}');
    Error('\P{_ is_EXTPICT:=}');
    Expect(1, 131069, '\p{isextpict}', "");
    Expect(0, 131069, '\p{^isextpict}', "");
    Expect(0, 131069, '\P{isextpict}', "");
    Expect(1, 131069, '\P{^isextpict}', "");
    Expect(0, 131072, '\p{isextpict}', "");
    Expect(1, 131072, '\p{^isextpict}', "");
    Expect(1, 131072, '\P{isextpict}', "");
    Expect(0, 131072, '\P{^isextpict}', "");
    Expect(1, 131069, '\p{_is_EXTPICT}', "");
    Expect(0, 131069, '\p{^_is_EXTPICT}', "");
    Expect(0, 131069, '\P{_is_EXTPICT}', "");
    Expect(1, 131069, '\P{^_is_EXTPICT}', "");
    Expect(0, 131072, '\p{_is_EXTPICT}', "");
    Expect(1, 131072, '\p{^_is_EXTPICT}', "");
    Expect(1, 131072, '\P{_is_EXTPICT}', "");
    Expect(0, 131072, '\P{^_is_EXTPICT}', "");
    Error('\p{_/a/Extender}');
    Error('\P{_/a/Extender}');
    Expect(1, 125254, '\p{extender}', "");
    Expect(0, 125254, '\p{^extender}', "");
    Expect(0, 125254, '\P{extender}', "");
    Expect(1, 125254, '\P{^extender}', "");
    Expect(0, 125255, '\p{extender}', "");
    Expect(1, 125255, '\p{^extender}', "");
    Expect(1, 125255, '\P{extender}', "");
    Expect(0, 125255, '\P{^extender}', "");
    Expect(1, 125254, '\p{--extender}', "");
    Expect(0, 125254, '\p{^--extender}', "");
    Expect(0, 125254, '\P{--extender}', "");
    Expect(1, 125254, '\P{^--extender}', "");
    Expect(0, 125255, '\p{--extender}', "");
    Expect(1, 125255, '\p{^--extender}', "");
    Expect(1, 125255, '\P{--extender}', "");
    Expect(0, 125255, '\P{^--extender}', "");
    Error('\p{_ IS_Extender/a/}');
    Error('\P{_ IS_Extender/a/}');
    Expect(1, 125254, '\p{isextender}', "");
    Expect(0, 125254, '\p{^isextender}', "");
    Expect(0, 125254, '\P{isextender}', "");
    Expect(1, 125254, '\P{^isextender}', "");
    Expect(0, 125255, '\p{isextender}', "");
    Expect(1, 125255, '\p{^isextender}', "");
    Expect(1, 125255, '\P{isextender}', "");
    Expect(0, 125255, '\P{^isextender}', "");
    Expect(1, 125254, '\p{		IS_extender}', "");
    Expect(0, 125254, '\p{^		IS_extender}', "");
    Expect(0, 125254, '\P{		IS_extender}', "");
    Expect(1, 125254, '\P{^		IS_extender}', "");
    Expect(0, 125255, '\p{		IS_extender}', "");
    Expect(1, 125255, '\p{^		IS_extender}', "");
    Expect(1, 125255, '\P{		IS_extender}', "");
    Expect(0, 125255, '\P{^		IS_extender}', "");
    Error('\p{Ext:=}');
    Error('\P{Ext:=}');
    Expect(1, 125254, '\p{ext}', "");
    Expect(0, 125254, '\p{^ext}', "");
    Expect(0, 125254, '\P{ext}', "");
    Expect(1, 125254, '\P{^ext}', "");
    Expect(0, 125255, '\p{ext}', "");
    Expect(1, 125255, '\p{^ext}', "");
    Expect(1, 125255, '\P{ext}', "");
    Expect(0, 125255, '\P{^ext}', "");
    Expect(1, 125254, '\p{	_Ext}', "");
    Expect(0, 125254, '\p{^	_Ext}', "");
    Expect(0, 125254, '\P{	_Ext}', "");
    Expect(1, 125254, '\P{^	_Ext}', "");
    Expect(0, 125255, '\p{	_Ext}', "");
    Expect(1, 125255, '\p{^	_Ext}', "");
    Expect(1, 125255, '\P{	_Ext}', "");
    Expect(0, 125255, '\P{^	_Ext}', "");
    Error('\p{:=  Is_ext}');
    Error('\P{:=  Is_ext}');
    Expect(1, 125254, '\p{isext}', "");
    Expect(0, 125254, '\p{^isext}', "");
    Expect(0, 125254, '\P{isext}', "");
    Expect(1, 125254, '\P{^isext}', "");
    Expect(0, 125255, '\p{isext}', "");
    Expect(1, 125255, '\p{^isext}', "");
    Expect(1, 125255, '\P{isext}', "");
    Expect(0, 125255, '\P{^isext}', "");
    Expect(1, 125254, '\p{-IS_ext}', "");
    Expect(0, 125254, '\p{^-IS_ext}', "");
    Expect(0, 125254, '\P{-IS_ext}', "");
    Expect(1, 125254, '\P{^-IS_ext}', "");
    Expect(0, 125255, '\p{-IS_ext}', "");
    Expect(1, 125255, '\p{^-IS_ext}', "");
    Expect(1, 125255, '\P{-IS_ext}', "");
    Expect(0, 125255, '\P{^-IS_ext}', "");
    Error('\p{:= -FINAL_PUNCTUATION}');
    Error('\P{:= -FINAL_PUNCTUATION}');
    Expect(1, 11809, '\p{finalpunctuation}', "");
    Expect(0, 11809, '\p{^finalpunctuation}', "");
    Expect(0, 11809, '\P{finalpunctuation}', "");
    Expect(1, 11809, '\P{^finalpunctuation}', "");
    Expect(0, 11810, '\p{finalpunctuation}', "");
    Expect(1, 11810, '\p{^finalpunctuation}', "");
    Expect(1, 11810, '\P{finalpunctuation}', "");
    Expect(0, 11810, '\P{^finalpunctuation}', "");
    Expect(1, 11809, '\p{_	Final_Punctuation}', "");
    Expect(0, 11809, '\p{^_	Final_Punctuation}', "");
    Expect(0, 11809, '\P{_	Final_Punctuation}', "");
    Expect(1, 11809, '\P{^_	Final_Punctuation}', "");
    Expect(0, 11810, '\p{_	Final_Punctuation}', "");
    Expect(1, 11810, '\p{^_	Final_Punctuation}', "");
    Expect(1, 11810, '\P{_	Final_Punctuation}', "");
    Expect(0, 11810, '\P{^_	Final_Punctuation}', "");
    Error('\p{:=Is_FINAL_PUNCTUATION}');
    Error('\P{:=Is_FINAL_PUNCTUATION}');
    Expect(1, 11809, '\p{isfinalpunctuation}', "");
    Expect(0, 11809, '\p{^isfinalpunctuation}', "");
    Expect(0, 11809, '\P{isfinalpunctuation}', "");
    Expect(1, 11809, '\P{^isfinalpunctuation}', "");
    Expect(0, 11810, '\p{isfinalpunctuation}', "");
    Expect(1, 11810, '\p{^isfinalpunctuation}', "");
    Expect(1, 11810, '\P{isfinalpunctuation}', "");
    Expect(0, 11810, '\P{^isfinalpunctuation}', "");
    Expect(1, 11809, '\p{ 	is_Final_Punctuation}', "");
    Expect(0, 11809, '\p{^ 	is_Final_Punctuation}', "");
    Expect(0, 11809, '\P{ 	is_Final_Punctuation}', "");
    Expect(1, 11809, '\P{^ 	is_Final_Punctuation}', "");
    Expect(0, 11810, '\p{ 	is_Final_Punctuation}', "");
    Expect(1, 11810, '\p{^ 	is_Final_Punctuation}', "");
    Expect(1, 11810, '\P{ 	is_Final_Punctuation}', "");
    Expect(0, 11810, '\P{^ 	is_Final_Punctuation}', "");
    Error('\p{	:=Pf}');
    Error('\P{	:=Pf}');
    Expect(1, 11809, '\p{pf}', "");
    Expect(0, 11809, '\p{^pf}', "");
    Expect(0, 11809, '\P{pf}', "");
    Expect(1, 11809, '\P{^pf}', "");
    Expect(0, 11810, '\p{pf}', "");
    Expect(1, 11810, '\p{^pf}', "");
    Expect(1, 11810, '\P{pf}', "");
    Expect(0, 11810, '\P{^pf}', "");
    Expect(1, 11809, '\p{ 	Pf}', "");
    Expect(0, 11809, '\p{^ 	Pf}', "");
    Expect(0, 11809, '\P{ 	Pf}', "");
    Expect(1, 11809, '\P{^ 	Pf}', "");
    Expect(0, 11810, '\p{ 	Pf}', "");
    Expect(1, 11810, '\p{^ 	Pf}', "");
    Expect(1, 11810, '\P{ 	Pf}', "");
    Expect(0, 11810, '\P{^ 	Pf}', "");
    Error('\p{ -is_Pf/a/}');
    Error('\P{ -is_Pf/a/}');
    Expect(1, 11809, '\p{ispf}', "");
    Expect(0, 11809, '\p{^ispf}', "");
    Expect(0, 11809, '\P{ispf}', "");
    Expect(1, 11809, '\P{^ispf}', "");
    Expect(0, 11810, '\p{ispf}', "");
    Expect(1, 11810, '\p{^ispf}', "");
    Expect(1, 11810, '\P{ispf}', "");
    Expect(0, 11810, '\P{^ispf}', "");
    Expect(1, 11809, '\p{-Is_Pf}', "");
    Expect(0, 11809, '\p{^-Is_Pf}', "");
    Expect(0, 11809, '\P{-Is_Pf}', "");
    Expect(1, 11809, '\P{^-Is_Pf}', "");
    Expect(0, 11810, '\p{-Is_Pf}', "");
    Expect(1, 11810, '\p{^-Is_Pf}', "");
    Expect(1, 11810, '\P{-Is_Pf}', "");
    Expect(0, 11810, '\P{^-Is_Pf}', "");
    Error('\p{:= 	Format}');
    Error('\P{:= 	Format}');
    Expect(1, 917631, '\p{format}', "");
    Expect(0, 917631, '\p{^format}', "");
    Expect(0, 917631, '\P{format}', "");
    Expect(1, 917631, '\P{^format}', "");
    Expect(0, 917632, '\p{format}', "");
    Expect(1, 917632, '\p{^format}', "");
    Expect(1, 917632, '\P{format}', "");
    Expect(0, 917632, '\P{^format}', "");
    Expect(1, 917631, '\p{-format}', "");
    Expect(0, 917631, '\p{^-format}', "");
    Expect(0, 917631, '\P{-format}', "");
    Expect(1, 917631, '\P{^-format}', "");
    Expect(0, 917632, '\p{-format}', "");
    Expect(1, 917632, '\p{^-format}', "");
    Expect(1, 917632, '\P{-format}', "");
    Expect(0, 917632, '\P{^-format}', "");
    Error('\p{_	Is_Format:=}');
    Error('\P{_	Is_Format:=}');
    Expect(1, 917631, '\p{isformat}', "");
    Expect(0, 917631, '\p{^isformat}', "");
    Expect(0, 917631, '\P{isformat}', "");
    Expect(1, 917631, '\P{^isformat}', "");
    Expect(0, 917632, '\p{isformat}', "");
    Expect(1, 917632, '\p{^isformat}', "");
    Expect(1, 917632, '\P{isformat}', "");
    Expect(0, 917632, '\P{^isformat}', "");
    Expect(1, 917631, '\p{ 	IS_Format}', "");
    Expect(0, 917631, '\p{^ 	IS_Format}', "");
    Expect(0, 917631, '\P{ 	IS_Format}', "");
    Expect(1, 917631, '\P{^ 	IS_Format}', "");
    Expect(0, 917632, '\p{ 	IS_Format}', "");
    Expect(1, 917632, '\p{^ 	IS_Format}', "");
    Expect(1, 917632, '\P{ 	IS_Format}', "");
    Expect(0, 917632, '\P{^ 	IS_Format}', "");
    Error('\p{_ cf:=}');
    Error('\P{_ cf:=}');
    Expect(1, 917631, '\p{cf}', "");
    Expect(0, 917631, '\p{^cf}', "");
    Expect(0, 917631, '\P{cf}', "");
    Expect(1, 917631, '\P{^cf}', "");
    Expect(0, 917632, '\p{cf}', "");
    Expect(1, 917632, '\p{^cf}', "");
    Expect(1, 917632, '\P{cf}', "");
    Expect(0, 917632, '\P{^cf}', "");
    Expect(1, 917631, '\p{-	CF}', "");
    Expect(0, 917631, '\p{^-	CF}', "");
    Expect(0, 917631, '\P{-	CF}', "");
    Expect(1, 917631, '\P{^-	CF}', "");
    Expect(0, 917632, '\p{-	CF}', "");
    Expect(1, 917632, '\p{^-	CF}', "");
    Expect(1, 917632, '\P{-	CF}', "");
    Expect(0, 917632, '\P{^-	CF}', "");
    Error('\p{ /a/Is_CF}');
    Error('\P{ /a/Is_CF}');
    Expect(1, 917631, '\p{iscf}', "");
    Expect(0, 917631, '\p{^iscf}', "");
    Expect(0, 917631, '\P{iscf}', "");
    Expect(1, 917631, '\P{^iscf}', "");
    Expect(0, 917632, '\p{iscf}', "");
    Expect(1, 917632, '\p{^iscf}', "");
    Expect(1, 917632, '\P{iscf}', "");
    Expect(0, 917632, '\P{^iscf}', "");
    Expect(1, 917631, '\p{__Is_Cf}', "");
    Expect(0, 917631, '\p{^__Is_Cf}', "");
    Expect(0, 917631, '\P{__Is_Cf}', "");
    Expect(1, 917631, '\P{^__Is_Cf}', "");
    Expect(0, 917632, '\p{__Is_Cf}', "");
    Expect(1, 917632, '\p{^__Is_Cf}', "");
    Expect(1, 917632, '\P{__Is_Cf}', "");
    Expect(0, 917632, '\P{^__Is_Cf}', "");
    Error('\p{ FULL_composition_Exclusion:=}');
    Error('\P{ FULL_composition_Exclusion:=}');
    Expect(1, 195101, '\p{fullcompositionexclusion}', "");
    Expect(0, 195101, '\p{^fullcompositionexclusion}', "");
    Expect(0, 195101, '\P{fullcompositionexclusion}', "");
    Expect(1, 195101, '\P{^fullcompositionexclusion}', "");
    Expect(0, 195102, '\p{fullcompositionexclusion}', "");
    Expect(1, 195102, '\p{^fullcompositionexclusion}', "");
    Expect(1, 195102, '\P{fullcompositionexclusion}', "");
    Expect(0, 195102, '\P{^fullcompositionexclusion}', "");
    Expect(1, 195101, '\p{full_COMPOSITION_Exclusion}', "");
    Expect(0, 195101, '\p{^full_COMPOSITION_Exclusion}', "");
    Expect(0, 195101, '\P{full_COMPOSITION_Exclusion}', "");
    Expect(1, 195101, '\P{^full_COMPOSITION_Exclusion}', "");
    Expect(0, 195102, '\p{full_COMPOSITION_Exclusion}', "");
    Expect(1, 195102, '\p{^full_COMPOSITION_Exclusion}', "");
    Expect(1, 195102, '\P{full_COMPOSITION_Exclusion}', "");
    Expect(0, 195102, '\P{^full_COMPOSITION_Exclusion}', "");
    Error('\p{ :=Is_FULL_Composition_EXCLUSION}');
    Error('\P{ :=Is_FULL_Composition_EXCLUSION}');
    Expect(1, 195101, '\p{isfullcompositionexclusion}', "");
    Expect(0, 195101, '\p{^isfullcompositionexclusion}', "");
    Expect(0, 195101, '\P{isfullcompositionexclusion}', "");
    Expect(1, 195101, '\P{^isfullcompositionexclusion}', "");
    Expect(0, 195102, '\p{isfullcompositionexclusion}', "");
    Expect(1, 195102, '\p{^isfullcompositionexclusion}', "");
    Expect(1, 195102, '\P{isfullcompositionexclusion}', "");
    Expect(0, 195102, '\P{^isfullcompositionexclusion}', "");
    Expect(1, 195101, '\p{ _IS_Full_Composition_Exclusion}', "");
    Expect(0, 195101, '\p{^ _IS_Full_Composition_Exclusion}', "");
    Expect(0, 195101, '\P{ _IS_Full_Composition_Exclusion}', "");
    Expect(1, 195101, '\P{^ _IS_Full_Composition_Exclusion}', "");
    Expect(0, 195102, '\p{ _IS_Full_Composition_Exclusion}', "");
    Expect(1, 195102, '\p{^ _IS_Full_Composition_Exclusion}', "");
    Expect(1, 195102, '\P{ _IS_Full_Composition_Exclusion}', "");
    Expect(0, 195102, '\P{^ _IS_Full_Composition_Exclusion}', "");
    Error('\p{:= -comp_EX}');
    Error('\P{:= -comp_EX}');
    Expect(1, 195101, '\p{compex}', "");
    Expect(0, 195101, '\p{^compex}', "");
    Expect(0, 195101, '\P{compex}', "");
    Expect(1, 195101, '\P{^compex}', "");
    Expect(0, 195102, '\p{compex}', "");
    Expect(1, 195102, '\p{^compex}', "");
    Expect(1, 195102, '\P{compex}', "");
    Expect(0, 195102, '\P{^compex}', "");
    Expect(1, 195101, '\p{_ comp_ex}', "");
    Expect(0, 195101, '\p{^_ comp_ex}', "");
    Expect(0, 195101, '\P{_ comp_ex}', "");
    Expect(1, 195101, '\P{^_ comp_ex}', "");
    Expect(0, 195102, '\p{_ comp_ex}', "");
    Expect(1, 195102, '\p{^_ comp_ex}', "");
    Expect(1, 195102, '\P{_ comp_ex}', "");
    Expect(0, 195102, '\P{^_ comp_ex}', "");
    Error('\p{/a/-	Is_comp_ex}');
    Error('\P{/a/-	Is_comp_ex}');
    Expect(1, 195101, '\p{iscompex}', "");
    Expect(0, 195101, '\p{^iscompex}', "");
    Expect(0, 195101, '\P{iscompex}', "");
    Expect(1, 195101, '\P{^iscompex}', "");
    Expect(0, 195102, '\p{iscompex}', "");
    Expect(1, 195102, '\p{^iscompex}', "");
    Expect(1, 195102, '\P{iscompex}', "");
    Expect(0, 195102, '\P{^iscompex}', "");
    Expect(1, 195101, '\p{_Is_COMP_Ex}', "");
    Expect(0, 195101, '\p{^_Is_COMP_Ex}', "");
    Expect(0, 195101, '\P{_Is_COMP_Ex}', "");
    Expect(1, 195101, '\P{^_Is_COMP_Ex}', "");
    Expect(0, 195102, '\p{_Is_COMP_Ex}', "");
    Expect(1, 195102, '\p{^_Is_COMP_Ex}', "");
    Expect(1, 195102, '\P{_Is_COMP_Ex}', "");
    Expect(0, 195102, '\P{^_Is_COMP_Ex}', "");
    Error('\p{  GENERAL_Punctuation:=}');
    Error('\P{  GENERAL_Punctuation:=}');
    Expect(1, 8303, '\p{generalpunctuation}', "");
    Expect(0, 8303, '\p{^generalpunctuation}', "");
    Expect(0, 8303, '\P{generalpunctuation}', "");
    Expect(1, 8303, '\P{^generalpunctuation}', "");
    Expect(0, 8304, '\p{generalpunctuation}', "");
    Expect(1, 8304, '\p{^generalpunctuation}', "");
    Expect(1, 8304, '\P{generalpunctuation}', "");
    Expect(0, 8304, '\P{^generalpunctuation}', "");
    Expect(1, 8303, '\p{- General_Punctuation}', "");
    Expect(0, 8303, '\p{^- General_Punctuation}', "");
    Expect(0, 8303, '\P{- General_Punctuation}', "");
    Expect(1, 8303, '\P{^- General_Punctuation}', "");
    Expect(0, 8304, '\p{- General_Punctuation}', "");
    Expect(1, 8304, '\p{^- General_Punctuation}', "");
    Expect(1, 8304, '\P{- General_Punctuation}', "");
    Expect(0, 8304, '\P{^- General_Punctuation}', "");
    Error('\p{	 is_general_punctuation/a/}');
    Error('\P{	 is_general_punctuation/a/}');
    Expect(1, 8303, '\p{isgeneralpunctuation}', "");
    Expect(0, 8303, '\p{^isgeneralpunctuation}', "");
    Expect(0, 8303, '\P{isgeneralpunctuation}', "");
    Expect(1, 8303, '\P{^isgeneralpunctuation}', "");
    Expect(0, 8304, '\p{isgeneralpunctuation}', "");
    Expect(1, 8304, '\p{^isgeneralpunctuation}', "");
    Expect(1, 8304, '\P{isgeneralpunctuation}', "");
    Expect(0, 8304, '\P{^isgeneralpunctuation}', "");
    Expect(1, 8303, '\p{ -Is_General_punctuation}', "");
    Expect(0, 8303, '\p{^ -Is_General_punctuation}', "");
    Expect(0, 8303, '\P{ -Is_General_punctuation}', "");
    Expect(1, 8303, '\P{^ -Is_General_punctuation}', "");
    Expect(0, 8304, '\p{ -Is_General_punctuation}', "");
    Expect(1, 8304, '\p{^ -Is_General_punctuation}', "");
    Expect(1, 8304, '\P{ -Is_General_punctuation}', "");
    Expect(0, 8304, '\P{^ -Is_General_punctuation}', "");
    Error('\p{	In_General_Punctuation:=}');
    Error('\P{	In_General_Punctuation:=}');
    Expect(1, 8303, '\p{ingeneralpunctuation}', "");
    Expect(0, 8303, '\p{^ingeneralpunctuation}', "");
    Expect(0, 8303, '\P{ingeneralpunctuation}', "");
    Expect(1, 8303, '\P{^ingeneralpunctuation}', "");
    Expect(0, 8304, '\p{ingeneralpunctuation}', "");
    Expect(1, 8304, '\p{^ingeneralpunctuation}', "");
    Expect(1, 8304, '\P{ingeneralpunctuation}', "");
    Expect(0, 8304, '\P{^ingeneralpunctuation}', "");
    Expect(1, 8303, '\p{--In_GENERAL_Punctuation}', "");
    Expect(0, 8303, '\p{^--In_GENERAL_Punctuation}', "");
    Expect(0, 8303, '\P{--In_GENERAL_Punctuation}', "");
    Expect(1, 8303, '\P{^--In_GENERAL_Punctuation}', "");
    Expect(0, 8304, '\p{--In_GENERAL_Punctuation}', "");
    Expect(1, 8304, '\p{^--In_GENERAL_Punctuation}', "");
    Expect(1, 8304, '\P{--In_GENERAL_Punctuation}', "");
    Expect(0, 8304, '\P{^--In_GENERAL_Punctuation}', "");
    Error('\p{	:=IN_Punctuation}');
    Error('\P{	:=IN_Punctuation}');
    Expect(1, 8303, '\p{inpunctuation}', "");
    Expect(0, 8303, '\p{^inpunctuation}', "");
    Expect(0, 8303, '\P{inpunctuation}', "");
    Expect(1, 8303, '\P{^inpunctuation}', "");
    Expect(0, 8304, '\p{inpunctuation}', "");
    Expect(1, 8304, '\p{^inpunctuation}', "");
    Expect(1, 8304, '\P{inpunctuation}', "");
    Expect(0, 8304, '\P{^inpunctuation}', "");
    Expect(1, 8303, '\p{_ IN_Punctuation}', "");
    Expect(0, 8303, '\p{^_ IN_Punctuation}', "");
    Expect(0, 8303, '\P{_ IN_Punctuation}', "");
    Expect(1, 8303, '\P{^_ IN_Punctuation}', "");
    Expect(0, 8304, '\p{_ IN_Punctuation}', "");
    Expect(1, 8304, '\p{^_ IN_Punctuation}', "");
    Expect(1, 8304, '\P{_ IN_Punctuation}', "");
    Expect(0, 8304, '\P{^_ IN_Punctuation}', "");
    Error('\p{ /a/geometric_Shapes}');
    Error('\P{ /a/geometric_Shapes}');
    Expect(1, 9727, '\p{geometricshapes}', "");
    Expect(0, 9727, '\p{^geometricshapes}', "");
    Expect(0, 9727, '\P{geometricshapes}', "");
    Expect(1, 9727, '\P{^geometricshapes}', "");
    Expect(0, 9728, '\p{geometricshapes}', "");
    Expect(1, 9728, '\p{^geometricshapes}', "");
    Expect(1, 9728, '\P{geometricshapes}', "");
    Expect(0, 9728, '\P{^geometricshapes}', "");
    Expect(1, 9727, '\p{-	Geometric_Shapes}', "");
    Expect(0, 9727, '\p{^-	Geometric_Shapes}', "");
    Expect(0, 9727, '\P{-	Geometric_Shapes}', "");
    Expect(1, 9727, '\P{^-	Geometric_Shapes}', "");
    Expect(0, 9728, '\p{-	Geometric_Shapes}', "");
    Expect(1, 9728, '\p{^-	Geometric_Shapes}', "");
    Expect(1, 9728, '\P{-	Geometric_Shapes}', "");
    Expect(0, 9728, '\P{^-	Geometric_Shapes}', "");
    Error('\p{ :=IS_Geometric_Shapes}');
    Error('\P{ :=IS_Geometric_Shapes}');
    Expect(1, 9727, '\p{isgeometricshapes}', "");
    Expect(0, 9727, '\p{^isgeometricshapes}', "");
    Expect(0, 9727, '\P{isgeometricshapes}', "");
    Expect(1, 9727, '\P{^isgeometricshapes}', "");
    Expect(0, 9728, '\p{isgeometricshapes}', "");
    Expect(1, 9728, '\p{^isgeometricshapes}', "");
    Expect(1, 9728, '\P{isgeometricshapes}', "");
    Expect(0, 9728, '\P{^isgeometricshapes}', "");
    Expect(1, 9727, '\p{-_Is_GEOMETRIC_SHAPES}', "");
    Expect(0, 9727, '\p{^-_Is_GEOMETRIC_SHAPES}', "");
    Expect(0, 9727, '\P{-_Is_GEOMETRIC_SHAPES}', "");
    Expect(1, 9727, '\P{^-_Is_GEOMETRIC_SHAPES}', "");
    Expect(0, 9728, '\p{-_Is_GEOMETRIC_SHAPES}', "");
    Expect(1, 9728, '\p{^-_Is_GEOMETRIC_SHAPES}', "");
    Expect(1, 9728, '\P{-_Is_GEOMETRIC_SHAPES}', "");
    Expect(0, 9728, '\P{^-_Is_GEOMETRIC_SHAPES}', "");
    Error('\p{-In_GEOMETRIC_Shapes:=}');
    Error('\P{-In_GEOMETRIC_Shapes:=}');
    Expect(1, 9727, '\p{ingeometricshapes}', "");
    Expect(0, 9727, '\p{^ingeometricshapes}', "");
    Expect(0, 9727, '\P{ingeometricshapes}', "");
    Expect(1, 9727, '\P{^ingeometricshapes}', "");
    Expect(0, 9728, '\p{ingeometricshapes}', "");
    Expect(1, 9728, '\p{^ingeometricshapes}', "");
    Expect(1, 9728, '\P{ingeometricshapes}', "");
    Expect(0, 9728, '\P{^ingeometricshapes}', "");
    Expect(1, 9727, '\p{-in_GEOMETRIC_Shapes}', "");
    Expect(0, 9727, '\p{^-in_GEOMETRIC_Shapes}', "");
    Expect(0, 9727, '\P{-in_GEOMETRIC_Shapes}', "");
    Expect(1, 9727, '\P{^-in_GEOMETRIC_Shapes}', "");
    Expect(0, 9728, '\p{-in_GEOMETRIC_Shapes}', "");
    Expect(1, 9728, '\p{^-in_GEOMETRIC_Shapes}', "");
    Expect(1, 9728, '\P{-in_GEOMETRIC_Shapes}', "");
    Expect(0, 9728, '\P{^-in_GEOMETRIC_Shapes}', "");
    Error('\p{-/a/Geometric_Shapes_Extended}');
    Error('\P{-/a/Geometric_Shapes_Extended}');
    Expect(1, 129023, '\p{geometricshapesextended}', "");
    Expect(0, 129023, '\p{^geometricshapesextended}', "");
    Expect(0, 129023, '\P{geometricshapesextended}', "");
    Expect(1, 129023, '\P{^geometricshapesextended}', "");
    Expect(0, 129024, '\p{geometricshapesextended}', "");
    Expect(1, 129024, '\p{^geometricshapesextended}', "");
    Expect(1, 129024, '\P{geometricshapesextended}', "");
    Expect(0, 129024, '\P{^geometricshapesextended}', "");
    Expect(1, 129023, '\p{_GEOMETRIC_Shapes_Extended}', "");
    Expect(0, 129023, '\p{^_GEOMETRIC_Shapes_Extended}', "");
    Expect(0, 129023, '\P{_GEOMETRIC_Shapes_Extended}', "");
    Expect(1, 129023, '\P{^_GEOMETRIC_Shapes_Extended}', "");
    Expect(0, 129024, '\p{_GEOMETRIC_Shapes_Extended}', "");
    Expect(1, 129024, '\p{^_GEOMETRIC_Shapes_Extended}', "");
    Expect(1, 129024, '\P{_GEOMETRIC_Shapes_Extended}', "");
    Expect(0, 129024, '\P{^_GEOMETRIC_Shapes_Extended}', "");
    Error('\p{:=-Is_geometric_Shapes_Extended}');
    Error('\P{:=-Is_geometric_Shapes_Extended}');
    Expect(1, 129023, '\p{isgeometricshapesextended}', "");
    Expect(0, 129023, '\p{^isgeometricshapesextended}', "");
    Expect(0, 129023, '\P{isgeometricshapesextended}', "");
    Expect(1, 129023, '\P{^isgeometricshapesextended}', "");
    Expect(0, 129024, '\p{isgeometricshapesextended}', "");
    Expect(1, 129024, '\p{^isgeometricshapesextended}', "");
    Expect(1, 129024, '\P{isgeometricshapesextended}', "");
    Expect(0, 129024, '\P{^isgeometricshapesextended}', "");
    Expect(1, 129023, '\p{- Is_Geometric_SHAPES_Extended}', "");
    Expect(0, 129023, '\p{^- Is_Geometric_SHAPES_Extended}', "");
    Expect(0, 129023, '\P{- Is_Geometric_SHAPES_Extended}', "");
    Expect(1, 129023, '\P{^- Is_Geometric_SHAPES_Extended}', "");
    Expect(0, 129024, '\p{- Is_Geometric_SHAPES_Extended}', "");
    Expect(1, 129024, '\p{^- Is_Geometric_SHAPES_Extended}', "");
    Expect(1, 129024, '\P{- Is_Geometric_SHAPES_Extended}', "");
    Expect(0, 129024, '\P{^- Is_Geometric_SHAPES_Extended}', "");
    Error('\p{ /a/in_Geometric_shapes_extended}');
    Error('\P{ /a/in_Geometric_shapes_extended}');
    Expect(1, 129023, '\p{ingeometricshapesextended}', "");
    Expect(0, 129023, '\p{^ingeometricshapesextended}', "");
    Expect(0, 129023, '\P{ingeometricshapesextended}', "");
    Expect(1, 129023, '\P{^ingeometricshapesextended}', "");
    Expect(0, 129024, '\p{ingeometricshapesextended}', "");
    Expect(1, 129024, '\p{^ingeometricshapesextended}', "");
    Expect(1, 129024, '\P{ingeometricshapesextended}', "");
    Expect(0, 129024, '\P{^ingeometricshapesextended}', "");
    Expect(1, 129023, '\p{-In_Geometric_Shapes_extended}', "");
    Expect(0, 129023, '\p{^-In_Geometric_Shapes_extended}', "");
    Expect(0, 129023, '\P{-In_Geometric_Shapes_extended}', "");
    Expect(1, 129023, '\P{^-In_Geometric_Shapes_extended}', "");
    Expect(0, 129024, '\p{-In_Geometric_Shapes_extended}', "");
    Expect(1, 129024, '\p{^-In_Geometric_Shapes_extended}', "");
    Expect(1, 129024, '\P{-In_Geometric_Shapes_extended}', "");
    Expect(0, 129024, '\P{^-In_Geometric_Shapes_extended}', "");
    Error('\p{_	geometric_Shapes_EXT:=}');
    Error('\P{_	geometric_Shapes_EXT:=}');
    Expect(1, 129023, '\p{geometricshapesext}', "");
    Expect(0, 129023, '\p{^geometricshapesext}', "");
    Expect(0, 129023, '\P{geometricshapesext}', "");
    Expect(1, 129023, '\P{^geometricshapesext}', "");
    Expect(0, 129024, '\p{geometricshapesext}', "");
    Expect(1, 129024, '\p{^geometricshapesext}', "");
    Expect(1, 129024, '\P{geometricshapesext}', "");
    Expect(0, 129024, '\P{^geometricshapesext}', "");
    Expect(1, 129023, '\p{_ Geometric_SHAPES_ext}', "");
    Expect(0, 129023, '\p{^_ Geometric_SHAPES_ext}', "");
    Expect(0, 129023, '\P{_ Geometric_SHAPES_ext}', "");
    Expect(1, 129023, '\P{^_ Geometric_SHAPES_ext}', "");
    Expect(0, 129024, '\p{_ Geometric_SHAPES_ext}', "");
    Expect(1, 129024, '\p{^_ Geometric_SHAPES_ext}', "");
    Expect(1, 129024, '\P{_ Geometric_SHAPES_ext}', "");
    Expect(0, 129024, '\P{^_ Geometric_SHAPES_ext}', "");
    Error('\p{:=Is_Geometric_Shapes_Ext}');
    Error('\P{:=Is_Geometric_Shapes_Ext}');
    Expect(1, 129023, '\p{isgeometricshapesext}', "");
    Expect(0, 129023, '\p{^isgeometricshapesext}', "");
    Expect(0, 129023, '\P{isgeometricshapesext}', "");
    Expect(1, 129023, '\P{^isgeometricshapesext}', "");
    Expect(0, 129024, '\p{isgeometricshapesext}', "");
    Expect(1, 129024, '\p{^isgeometricshapesext}', "");
    Expect(1, 129024, '\P{isgeometricshapesext}', "");
    Expect(0, 129024, '\P{^isgeometricshapesext}', "");
    Expect(1, 129023, '\p{--Is_Geometric_shapes_EXT}', "");
    Expect(0, 129023, '\p{^--Is_Geometric_shapes_EXT}', "");
    Expect(0, 129023, '\P{--Is_Geometric_shapes_EXT}', "");
    Expect(1, 129023, '\P{^--Is_Geometric_shapes_EXT}', "");
    Expect(0, 129024, '\p{--Is_Geometric_shapes_EXT}', "");
    Expect(1, 129024, '\p{^--Is_Geometric_shapes_EXT}', "");
    Expect(1, 129024, '\P{--Is_Geometric_shapes_EXT}', "");
    Expect(0, 129024, '\P{^--Is_Geometric_shapes_EXT}', "");
    Error('\p{/a/-_IN_GEOMETRIC_Shapes_Ext}');
    Error('\P{/a/-_IN_GEOMETRIC_Shapes_Ext}');
    Expect(1, 129023, '\p{ingeometricshapesext}', "");
    Expect(0, 129023, '\p{^ingeometricshapesext}', "");
    Expect(0, 129023, '\P{ingeometricshapesext}', "");
    Expect(1, 129023, '\P{^ingeometricshapesext}', "");
    Expect(0, 129024, '\p{ingeometricshapesext}', "");
    Expect(1, 129024, '\p{^ingeometricshapesext}', "");
    Expect(1, 129024, '\P{ingeometricshapesext}', "");
    Expect(0, 129024, '\P{^ingeometricshapesext}', "");
    Expect(1, 129023, '\p{ -In_Geometric_SHAPES_ext}', "");
    Expect(0, 129023, '\p{^ -In_Geometric_SHAPES_ext}', "");
    Expect(0, 129023, '\P{ -In_Geometric_SHAPES_ext}', "");
    Expect(1, 129023, '\P{^ -In_Geometric_SHAPES_ext}', "");
    Expect(0, 129024, '\p{ -In_Geometric_SHAPES_ext}', "");
    Expect(1, 129024, '\p{^ -In_Geometric_SHAPES_ext}', "");
    Expect(1, 129024, '\P{ -In_Geometric_SHAPES_ext}', "");
    Expect(0, 129024, '\P{^ -In_Geometric_SHAPES_ext}', "");
    Error('\p{/a/GEORGIAN}');
    Error('\P{/a/GEORGIAN}');
    Expect(1, 11565, '\p{georgian}', "");
    Expect(0, 11565, '\p{^georgian}', "");
    Expect(0, 11565, '\P{georgian}', "");
    Expect(1, 11565, '\P{^georgian}', "");
    Expect(0, 11566, '\p{georgian}', "");
    Expect(1, 11566, '\p{^georgian}', "");
    Expect(1, 11566, '\P{georgian}', "");
    Expect(0, 11566, '\P{^georgian}', "");
    Expect(1, 11565, '\p{	GEORGIAN}', "");
    Expect(0, 11565, '\p{^	GEORGIAN}', "");
    Expect(0, 11565, '\P{	GEORGIAN}', "");
    Expect(1, 11565, '\P{^	GEORGIAN}', "");
    Expect(0, 11566, '\p{	GEORGIAN}', "");
    Expect(1, 11566, '\p{^	GEORGIAN}', "");
    Expect(1, 11566, '\P{	GEORGIAN}', "");
    Expect(0, 11566, '\P{^	GEORGIAN}', "");
    Error('\p{:=IS_GEORGIAN}');
    Error('\P{:=IS_GEORGIAN}');
    Expect(1, 11565, '\p{isgeorgian}', "");
    Expect(0, 11565, '\p{^isgeorgian}', "");
    Expect(0, 11565, '\P{isgeorgian}', "");
    Expect(1, 11565, '\P{^isgeorgian}', "");
    Expect(0, 11566, '\p{isgeorgian}', "");
    Expect(1, 11566, '\p{^isgeorgian}', "");
    Expect(1, 11566, '\P{isgeorgian}', "");
    Expect(0, 11566, '\P{^isgeorgian}', "");
    Expect(1, 11565, '\p{ _is_GEORGIAN}', "");
    Expect(0, 11565, '\p{^ _is_GEORGIAN}', "");
    Expect(0, 11565, '\P{ _is_GEORGIAN}', "");
    Expect(1, 11565, '\P{^ _is_GEORGIAN}', "");
    Expect(0, 11566, '\p{ _is_GEORGIAN}', "");
    Expect(1, 11566, '\p{^ _is_GEORGIAN}', "");
    Expect(1, 11566, '\P{ _is_GEORGIAN}', "");
    Expect(0, 11566, '\P{^ _is_GEORGIAN}', "");
    Error('\p{-:=geor}');
    Error('\P{-:=geor}');
    Expect(1, 11565, '\p{geor}', "");
    Expect(0, 11565, '\p{^geor}', "");
    Expect(0, 11565, '\P{geor}', "");
    Expect(1, 11565, '\P{^geor}', "");
    Expect(0, 11566, '\p{geor}', "");
    Expect(1, 11566, '\p{^geor}', "");
    Expect(1, 11566, '\P{geor}', "");
    Expect(0, 11566, '\P{^geor}', "");
    Expect(1, 11565, '\p{ _geor}', "");
    Expect(0, 11565, '\p{^ _geor}', "");
    Expect(0, 11565, '\P{ _geor}', "");
    Expect(1, 11565, '\P{^ _geor}', "");
    Expect(0, 11566, '\p{ _geor}', "");
    Expect(1, 11566, '\p{^ _geor}', "");
    Expect(1, 11566, '\P{ _geor}', "");
    Expect(0, 11566, '\P{^ _geor}', "");
    Error('\p{_ IS_GEOR/a/}');
    Error('\P{_ IS_GEOR/a/}');
    Expect(1, 11565, '\p{isgeor}', "");
    Expect(0, 11565, '\p{^isgeor}', "");
    Expect(0, 11565, '\P{isgeor}', "");
    Expect(1, 11565, '\P{^isgeor}', "");
    Expect(0, 11566, '\p{isgeor}', "");
    Expect(1, 11566, '\p{^isgeor}', "");
    Expect(1, 11566, '\P{isgeor}', "");
    Expect(0, 11566, '\P{^isgeor}', "");
    Expect(1, 11565, '\p{	 Is_Geor}', "");
    Expect(0, 11565, '\p{^	 Is_Geor}', "");
    Expect(0, 11565, '\P{	 Is_Geor}', "");
    Expect(1, 11565, '\P{^	 Is_Geor}', "");
    Expect(0, 11566, '\p{	 Is_Geor}', "");
    Expect(1, 11566, '\p{^	 Is_Geor}', "");
    Expect(1, 11566, '\P{	 Is_Geor}', "");
    Expect(0, 11566, '\P{^	 Is_Geor}', "");
    Error('\p{-:=Georgian_Extended}');
    Error('\P{-:=Georgian_Extended}');
    Expect(1, 7359, '\p{georgianextended}', "");
    Expect(0, 7359, '\p{^georgianextended}', "");
    Expect(0, 7359, '\P{georgianextended}', "");
    Expect(1, 7359, '\P{^georgianextended}', "");
    Expect(0, 7360, '\p{georgianextended}', "");
    Expect(1, 7360, '\p{^georgianextended}', "");
    Expect(1, 7360, '\P{georgianextended}', "");
    Expect(0, 7360, '\P{^georgianextended}', "");
    Expect(1, 7359, '\p{ Georgian_Extended}', "");
    Expect(0, 7359, '\p{^ Georgian_Extended}', "");
    Expect(0, 7359, '\P{ Georgian_Extended}', "");
    Expect(1, 7359, '\P{^ Georgian_Extended}', "");
    Expect(0, 7360, '\p{ Georgian_Extended}', "");
    Expect(1, 7360, '\p{^ Georgian_Extended}', "");
    Expect(1, 7360, '\P{ Georgian_Extended}', "");
    Expect(0, 7360, '\P{^ Georgian_Extended}', "");
    Error('\p{/a/		IS_Georgian_extended}');
    Error('\P{/a/		IS_Georgian_extended}');
    Expect(1, 7359, '\p{isgeorgianextended}', "");
    Expect(0, 7359, '\p{^isgeorgianextended}', "");
    Expect(0, 7359, '\P{isgeorgianextended}', "");
    Expect(1, 7359, '\P{^isgeorgianextended}', "");
    Expect(0, 7360, '\p{isgeorgianextended}', "");
    Expect(1, 7360, '\p{^isgeorgianextended}', "");
    Expect(1, 7360, '\P{isgeorgianextended}', "");
    Expect(0, 7360, '\P{^isgeorgianextended}', "");
    Expect(1, 7359, '\p{	 Is_Georgian_Extended}', "");
    Expect(0, 7359, '\p{^	 Is_Georgian_Extended}', "");
    Expect(0, 7359, '\P{	 Is_Georgian_Extended}', "");
    Expect(1, 7359, '\P{^	 Is_Georgian_Extended}', "");
    Expect(0, 7360, '\p{	 Is_Georgian_Extended}', "");
    Expect(1, 7360, '\p{^	 Is_Georgian_Extended}', "");
    Expect(1, 7360, '\P{	 Is_Georgian_Extended}', "");
    Expect(0, 7360, '\P{^	 Is_Georgian_Extended}', "");
    Error('\p{ :=In_Georgian_extended}');
    Error('\P{ :=In_Georgian_extended}');
    Expect(1, 7359, '\p{ingeorgianextended}', "");
    Expect(0, 7359, '\p{^ingeorgianextended}', "");
    Expect(0, 7359, '\P{ingeorgianextended}', "");
    Expect(1, 7359, '\P{^ingeorgianextended}', "");
    Expect(0, 7360, '\p{ingeorgianextended}', "");
    Expect(1, 7360, '\p{^ingeorgianextended}', "");
    Expect(1, 7360, '\P{ingeorgianextended}', "");
    Expect(0, 7360, '\P{^ingeorgianextended}', "");
    Expect(1, 7359, '\p{- In_Georgian_EXTENDED}', "");
    Expect(0, 7359, '\p{^- In_Georgian_EXTENDED}', "");
    Expect(0, 7359, '\P{- In_Georgian_EXTENDED}', "");
    Expect(1, 7359, '\P{^- In_Georgian_EXTENDED}', "");
    Expect(0, 7360, '\p{- In_Georgian_EXTENDED}', "");
    Expect(1, 7360, '\p{^- In_Georgian_EXTENDED}', "");
    Expect(1, 7360, '\P{- In_Georgian_EXTENDED}', "");
    Expect(0, 7360, '\P{^- In_Georgian_EXTENDED}', "");
    Error('\p{  Georgian_Ext:=}');
    Error('\P{  Georgian_Ext:=}');
    Expect(1, 7359, '\p{georgianext}', "");
    Expect(0, 7359, '\p{^georgianext}', "");
    Expect(0, 7359, '\P{georgianext}', "");
    Expect(1, 7359, '\P{^georgianext}', "");
    Expect(0, 7360, '\p{georgianext}', "");
    Expect(1, 7360, '\p{^georgianext}', "");
    Expect(1, 7360, '\P{georgianext}', "");
    Expect(0, 7360, '\P{^georgianext}', "");
    Expect(1, 7359, '\p{  georgian_Ext}', "");
    Expect(0, 7359, '\p{^  georgian_Ext}', "");
    Expect(0, 7359, '\P{  georgian_Ext}', "");
    Expect(1, 7359, '\P{^  georgian_Ext}', "");
    Expect(0, 7360, '\p{  georgian_Ext}', "");
    Expect(1, 7360, '\p{^  georgian_Ext}', "");
    Expect(1, 7360, '\P{  georgian_Ext}', "");
    Expect(0, 7360, '\P{^  georgian_Ext}', "");
    Error('\p{ -Is_Georgian_ext:=}');
    Error('\P{ -Is_Georgian_ext:=}');
    Expect(1, 7359, '\p{isgeorgianext}', "");
    Expect(0, 7359, '\p{^isgeorgianext}', "");
    Expect(0, 7359, '\P{isgeorgianext}', "");
    Expect(1, 7359, '\P{^isgeorgianext}', "");
    Expect(0, 7360, '\p{isgeorgianext}', "");
    Expect(1, 7360, '\p{^isgeorgianext}', "");
    Expect(1, 7360, '\P{isgeorgianext}', "");
    Expect(0, 7360, '\P{^isgeorgianext}', "");
    Expect(1, 7359, '\p{-_Is_Georgian_Ext}', "");
    Expect(0, 7359, '\p{^-_Is_Georgian_Ext}', "");
    Expect(0, 7359, '\P{-_Is_Georgian_Ext}', "");
    Expect(1, 7359, '\P{^-_Is_Georgian_Ext}', "");
    Expect(0, 7360, '\p{-_Is_Georgian_Ext}', "");
    Expect(1, 7360, '\p{^-_Is_Georgian_Ext}', "");
    Expect(1, 7360, '\P{-_Is_Georgian_Ext}', "");
    Expect(0, 7360, '\P{^-_Is_Georgian_Ext}', "");
    Error('\p{_In_GEORGIAN_EXT:=}');
    Error('\P{_In_GEORGIAN_EXT:=}');
    Expect(1, 7359, '\p{ingeorgianext}', "");
    Expect(0, 7359, '\p{^ingeorgianext}', "");
    Expect(0, 7359, '\P{ingeorgianext}', "");
    Expect(1, 7359, '\P{^ingeorgianext}', "");
    Expect(0, 7360, '\p{ingeorgianext}', "");
    Expect(1, 7360, '\p{^ingeorgianext}', "");
    Expect(1, 7360, '\P{ingeorgianext}', "");
    Expect(0, 7360, '\P{^ingeorgianext}', "");
    Expect(1, 7359, '\p{-In_georgian_EXT}', "");
    Expect(0, 7359, '\p{^-In_georgian_EXT}', "");
    Expect(0, 7359, '\P{-In_georgian_EXT}', "");
    Expect(1, 7359, '\P{^-In_georgian_EXT}', "");
    Expect(0, 7360, '\p{-In_georgian_EXT}', "");
    Expect(1, 7360, '\p{^-In_georgian_EXT}', "");
    Expect(1, 7360, '\P{-In_georgian_EXT}', "");
    Expect(0, 7360, '\P{^-In_georgian_EXT}', "");
    Error('\p{:=georgian_SUPPLEMENT}');
    Error('\P{:=georgian_SUPPLEMENT}');
    Expect(1, 11567, '\p{georgiansupplement}', "");
    Expect(0, 11567, '\p{^georgiansupplement}', "");
    Expect(0, 11567, '\P{georgiansupplement}', "");
    Expect(1, 11567, '\P{^georgiansupplement}', "");
    Expect(0, 11568, '\p{georgiansupplement}', "");
    Expect(1, 11568, '\p{^georgiansupplement}', "");
    Expect(1, 11568, '\P{georgiansupplement}', "");
    Expect(0, 11568, '\P{^georgiansupplement}', "");
    Expect(1, 11567, '\p{	Georgian_Supplement}', "");
    Expect(0, 11567, '\p{^	Georgian_Supplement}', "");
    Expect(0, 11567, '\P{	Georgian_Supplement}', "");
    Expect(1, 11567, '\P{^	Georgian_Supplement}', "");
    Expect(0, 11568, '\p{	Georgian_Supplement}', "");
    Expect(1, 11568, '\p{^	Georgian_Supplement}', "");
    Expect(1, 11568, '\P{	Georgian_Supplement}', "");
    Expect(0, 11568, '\P{^	Georgian_Supplement}', "");
    Error('\p{-	Is_GEORGIAN_Supplement:=}');
    Error('\P{-	Is_GEORGIAN_Supplement:=}');
    Expect(1, 11567, '\p{isgeorgiansupplement}', "");
    Expect(0, 11567, '\p{^isgeorgiansupplement}', "");
    Expect(0, 11567, '\P{isgeorgiansupplement}', "");
    Expect(1, 11567, '\P{^isgeorgiansupplement}', "");
    Expect(0, 11568, '\p{isgeorgiansupplement}', "");
    Expect(1, 11568, '\p{^isgeorgiansupplement}', "");
    Expect(1, 11568, '\P{isgeorgiansupplement}', "");
    Expect(0, 11568, '\P{^isgeorgiansupplement}', "");
    Expect(1, 11567, '\p{_ Is_Georgian_SUPPLEMENT}', "");
    Expect(0, 11567, '\p{^_ Is_Georgian_SUPPLEMENT}', "");
    Expect(0, 11567, '\P{_ Is_Georgian_SUPPLEMENT}', "");
    Expect(1, 11567, '\P{^_ Is_Georgian_SUPPLEMENT}', "");
    Expect(0, 11568, '\p{_ Is_Georgian_SUPPLEMENT}', "");
    Expect(1, 11568, '\p{^_ Is_Georgian_SUPPLEMENT}', "");
    Expect(1, 11568, '\P{_ Is_Georgian_SUPPLEMENT}', "");
    Expect(0, 11568, '\P{^_ Is_Georgian_SUPPLEMENT}', "");
    Error('\p{/a/	-In_GEORGIAN_supplement}');
    Error('\P{/a/	-In_GEORGIAN_supplement}');
    Expect(1, 11567, '\p{ingeorgiansupplement}', "");
    Expect(0, 11567, '\p{^ingeorgiansupplement}', "");
    Expect(0, 11567, '\P{ingeorgiansupplement}', "");
    Expect(1, 11567, '\P{^ingeorgiansupplement}', "");
    Expect(0, 11568, '\p{ingeorgiansupplement}', "");
    Expect(1, 11568, '\p{^ingeorgiansupplement}', "");
    Expect(1, 11568, '\P{ingeorgiansupplement}', "");
    Expect(0, 11568, '\P{^ingeorgiansupplement}', "");
    Expect(1, 11567, '\p{ _In_Georgian_Supplement}', "");
    Expect(0, 11567, '\p{^ _In_Georgian_Supplement}', "");
    Expect(0, 11567, '\P{ _In_Georgian_Supplement}', "");
    Expect(1, 11567, '\P{^ _In_Georgian_Supplement}', "");
    Expect(0, 11568, '\p{ _In_Georgian_Supplement}', "");
    Expect(1, 11568, '\p{^ _In_Georgian_Supplement}', "");
    Expect(1, 11568, '\P{ _In_Georgian_Supplement}', "");
    Expect(0, 11568, '\P{^ _In_Georgian_Supplement}', "");
    Error('\p{_ GEORGIAN_Sup:=}');
    Error('\P{_ GEORGIAN_Sup:=}');
    Expect(1, 11567, '\p{georgiansup}', "");
    Expect(0, 11567, '\p{^georgiansup}', "");
    Expect(0, 11567, '\P{georgiansup}', "");
    Expect(1, 11567, '\P{^georgiansup}', "");
    Expect(0, 11568, '\p{georgiansup}', "");
    Expect(1, 11568, '\p{^georgiansup}', "");
    Expect(1, 11568, '\P{georgiansup}', "");
    Expect(0, 11568, '\P{^georgiansup}', "");
    Expect(1, 11567, '\p{	 Georgian_Sup}', "");
    Expect(0, 11567, '\p{^	 Georgian_Sup}', "");
    Expect(0, 11567, '\P{	 Georgian_Sup}', "");
    Expect(1, 11567, '\P{^	 Georgian_Sup}', "");
    Expect(0, 11568, '\p{	 Georgian_Sup}', "");
    Expect(1, 11568, '\p{^	 Georgian_Sup}', "");
    Expect(1, 11568, '\P{	 Georgian_Sup}', "");
    Expect(0, 11568, '\P{^	 Georgian_Sup}', "");
    Error('\p{:=- Is_georgian_Sup}');
    Error('\P{:=- Is_georgian_Sup}');
    Expect(1, 11567, '\p{isgeorgiansup}', "");
    Expect(0, 11567, '\p{^isgeorgiansup}', "");
    Expect(0, 11567, '\P{isgeorgiansup}', "");
    Expect(1, 11567, '\P{^isgeorgiansup}', "");
    Expect(0, 11568, '\p{isgeorgiansup}', "");
    Expect(1, 11568, '\p{^isgeorgiansup}', "");
    Expect(1, 11568, '\P{isgeorgiansup}', "");
    Expect(0, 11568, '\P{^isgeorgiansup}', "");
    Expect(1, 11567, '\p{_-is_Georgian_SUP}', "");
    Expect(0, 11567, '\p{^_-is_Georgian_SUP}', "");
    Expect(0, 11567, '\P{_-is_Georgian_SUP}', "");
    Expect(1, 11567, '\P{^_-is_Georgian_SUP}', "");
    Expect(0, 11568, '\p{_-is_Georgian_SUP}', "");
    Expect(1, 11568, '\p{^_-is_Georgian_SUP}', "");
    Expect(1, 11568, '\P{_-is_Georgian_SUP}', "");
    Expect(0, 11568, '\P{^_-is_Georgian_SUP}', "");
    Error('\p{_:=IN_Georgian_Sup}');
    Error('\P{_:=IN_Georgian_Sup}');
    Expect(1, 11567, '\p{ingeorgiansup}', "");
    Expect(0, 11567, '\p{^ingeorgiansup}', "");
    Expect(0, 11567, '\P{ingeorgiansup}', "");
    Expect(1, 11567, '\P{^ingeorgiansup}', "");
    Expect(0, 11568, '\p{ingeorgiansup}', "");
    Expect(1, 11568, '\p{^ingeorgiansup}', "");
    Expect(1, 11568, '\P{ingeorgiansup}', "");
    Expect(0, 11568, '\P{^ingeorgiansup}', "");
    Expect(1, 11567, '\p{	In_Georgian_SUP}', "");
    Expect(0, 11567, '\p{^	In_Georgian_SUP}', "");
    Expect(0, 11567, '\P{	In_Georgian_SUP}', "");
    Expect(1, 11567, '\P{^	In_Georgian_SUP}', "");
    Expect(0, 11568, '\p{	In_Georgian_SUP}', "");
    Expect(1, 11568, '\p{^	In_Georgian_SUP}', "");
    Expect(1, 11568, '\P{	In_Georgian_SUP}', "");
    Expect(0, 11568, '\P{^	In_Georgian_SUP}', "");
    Error('\p{/a/-Glagolitic}');
    Error('\P{/a/-Glagolitic}');
    Expect(1, 122922, '\p{glagolitic}', "");
    Expect(0, 122922, '\p{^glagolitic}', "");
    Expect(0, 122922, '\P{glagolitic}', "");
    Expect(1, 122922, '\P{^glagolitic}', "");
    Expect(0, 122923, '\p{glagolitic}', "");
    Expect(1, 122923, '\p{^glagolitic}', "");
    Expect(1, 122923, '\P{glagolitic}', "");
    Expect(0, 122923, '\P{^glagolitic}', "");
    Expect(1, 122922, '\p{-Glagolitic}', "");
    Expect(0, 122922, '\p{^-Glagolitic}', "");
    Expect(0, 122922, '\P{-Glagolitic}', "");
    Expect(1, 122922, '\P{^-Glagolitic}', "");
    Expect(0, 122923, '\p{-Glagolitic}', "");
    Expect(1, 122923, '\p{^-Glagolitic}', "");
    Expect(1, 122923, '\P{-Glagolitic}', "");
    Expect(0, 122923, '\P{^-Glagolitic}', "");
    Error('\p{/a/		Is_Glagolitic}');
    Error('\P{/a/		Is_Glagolitic}');
    Expect(1, 122922, '\p{isglagolitic}', "");
    Expect(0, 122922, '\p{^isglagolitic}', "");
    Expect(0, 122922, '\P{isglagolitic}', "");
    Expect(1, 122922, '\P{^isglagolitic}', "");
    Expect(0, 122923, '\p{isglagolitic}', "");
    Expect(1, 122923, '\p{^isglagolitic}', "");
    Expect(1, 122923, '\P{isglagolitic}', "");
    Expect(0, 122923, '\P{^isglagolitic}', "");
    Expect(1, 122922, '\p{	IS_glagolitic}', "");
    Expect(0, 122922, '\p{^	IS_glagolitic}', "");
    Expect(0, 122922, '\P{	IS_glagolitic}', "");
    Expect(1, 122922, '\P{^	IS_glagolitic}', "");
    Expect(0, 122923, '\p{	IS_glagolitic}', "");
    Expect(1, 122923, '\p{^	IS_glagolitic}', "");
    Expect(1, 122923, '\P{	IS_glagolitic}', "");
    Expect(0, 122923, '\P{^	IS_glagolitic}', "");
    Error('\p{ 	GLAG/a/}');
    Error('\P{ 	GLAG/a/}');
    Expect(1, 122922, '\p{glag}', "");
    Expect(0, 122922, '\p{^glag}', "");
    Expect(0, 122922, '\P{glag}', "");
    Expect(1, 122922, '\P{^glag}', "");
    Expect(0, 122923, '\p{glag}', "");
    Expect(1, 122923, '\p{^glag}', "");
    Expect(1, 122923, '\P{glag}', "");
    Expect(0, 122923, '\P{^glag}', "");
    Expect(1, 122922, '\p{__glag}', "");
    Expect(0, 122922, '\p{^__glag}', "");
    Expect(0, 122922, '\P{__glag}', "");
    Expect(1, 122922, '\P{^__glag}', "");
    Expect(0, 122923, '\p{__glag}', "");
    Expect(1, 122923, '\p{^__glag}', "");
    Expect(1, 122923, '\P{__glag}', "");
    Expect(0, 122923, '\P{^__glag}', "");
    Error('\p{:=IS_GLAG}');
    Error('\P{:=IS_GLAG}');
    Expect(1, 122922, '\p{isglag}', "");
    Expect(0, 122922, '\p{^isglag}', "");
    Expect(0, 122922, '\P{isglag}', "");
    Expect(1, 122922, '\P{^isglag}', "");
    Expect(0, 122923, '\p{isglag}', "");
    Expect(1, 122923, '\p{^isglag}', "");
    Expect(1, 122923, '\P{isglag}', "");
    Expect(0, 122923, '\P{^isglag}', "");
    Expect(1, 122922, '\p{-	Is_Glag}', "");
    Expect(0, 122922, '\p{^-	Is_Glag}', "");
    Expect(0, 122922, '\P{-	Is_Glag}', "");
    Expect(1, 122922, '\P{^-	Is_Glag}', "");
    Expect(0, 122923, '\p{-	Is_Glag}', "");
    Expect(1, 122923, '\p{^-	Is_Glag}', "");
    Expect(1, 122923, '\P{-	Is_Glag}', "");
    Expect(0, 122923, '\P{^-	Is_Glag}', "");
    Error('\p{	_glagolitic_supplement:=}');
    Error('\P{	_glagolitic_supplement:=}');
    Expect(1, 122927, '\p{glagoliticsupplement}', "");
    Expect(0, 122927, '\p{^glagoliticsupplement}', "");
    Expect(0, 122927, '\P{glagoliticsupplement}', "");
    Expect(1, 122927, '\P{^glagoliticsupplement}', "");
    Expect(0, 122928, '\p{glagoliticsupplement}', "");
    Expect(1, 122928, '\p{^glagoliticsupplement}', "");
    Expect(1, 122928, '\P{glagoliticsupplement}', "");
    Expect(0, 122928, '\P{^glagoliticsupplement}', "");
    Expect(1, 122927, '\p{_Glagolitic_Supplement}', "");
    Expect(0, 122927, '\p{^_Glagolitic_Supplement}', "");
    Expect(0, 122927, '\P{_Glagolitic_Supplement}', "");
    Expect(1, 122927, '\P{^_Glagolitic_Supplement}', "");
    Expect(0, 122928, '\p{_Glagolitic_Supplement}', "");
    Expect(1, 122928, '\p{^_Glagolitic_Supplement}', "");
    Expect(1, 122928, '\P{_Glagolitic_Supplement}', "");
    Expect(0, 122928, '\P{^_Glagolitic_Supplement}', "");
    Error('\p{:=IS_GLAGOLITIC_supplement}');
    Error('\P{:=IS_GLAGOLITIC_supplement}');
    Expect(1, 122927, '\p{isglagoliticsupplement}', "");
    Expect(0, 122927, '\p{^isglagoliticsupplement}', "");
    Expect(0, 122927, '\P{isglagoliticsupplement}', "");
    Expect(1, 122927, '\P{^isglagoliticsupplement}', "");
    Expect(0, 122928, '\p{isglagoliticsupplement}', "");
    Expect(1, 122928, '\p{^isglagoliticsupplement}', "");
    Expect(1, 122928, '\P{isglagoliticsupplement}', "");
    Expect(0, 122928, '\P{^isglagoliticsupplement}', "");
    Expect(1, 122927, '\p{--IS_GLAGOLITIC_SUPPLEMENT}', "");
    Expect(0, 122927, '\p{^--IS_GLAGOLITIC_SUPPLEMENT}', "");
    Expect(0, 122927, '\P{--IS_GLAGOLITIC_SUPPLEMENT}', "");
    Expect(1, 122927, '\P{^--IS_GLAGOLITIC_SUPPLEMENT}', "");
    Expect(0, 122928, '\p{--IS_GLAGOLITIC_SUPPLEMENT}', "");
    Expect(1, 122928, '\p{^--IS_GLAGOLITIC_SUPPLEMENT}', "");
    Expect(1, 122928, '\P{--IS_GLAGOLITIC_SUPPLEMENT}', "");
    Expect(0, 122928, '\P{^--IS_GLAGOLITIC_SUPPLEMENT}', "");
    Error('\p{_:=IN_GLAGOLITIC_Supplement}');
    Error('\P{_:=IN_GLAGOLITIC_Supplement}');
    Expect(1, 122927, '\p{inglagoliticsupplement}', "");
    Expect(0, 122927, '\p{^inglagoliticsupplement}', "");
    Expect(0, 122927, '\P{inglagoliticsupplement}', "");
    Expect(1, 122927, '\P{^inglagoliticsupplement}', "");
    Expect(0, 122928, '\p{inglagoliticsupplement}', "");
    Expect(1, 122928, '\p{^inglagoliticsupplement}', "");
    Expect(1, 122928, '\P{inglagoliticsupplement}', "");
    Expect(0, 122928, '\P{^inglagoliticsupplement}', "");
    Expect(1, 122927, '\p{_	in_GLAGOLITIC_SUPPLEMENT}', "");
    Expect(0, 122927, '\p{^_	in_GLAGOLITIC_SUPPLEMENT}', "");
    Expect(0, 122927, '\P{_	in_GLAGOLITIC_SUPPLEMENT}', "");
    Expect(1, 122927, '\P{^_	in_GLAGOLITIC_SUPPLEMENT}', "");
    Expect(0, 122928, '\p{_	in_GLAGOLITIC_SUPPLEMENT}', "");
    Expect(1, 122928, '\p{^_	in_GLAGOLITIC_SUPPLEMENT}', "");
    Expect(1, 122928, '\P{_	in_GLAGOLITIC_SUPPLEMENT}', "");
    Expect(0, 122928, '\P{^_	in_GLAGOLITIC_SUPPLEMENT}', "");
    Error('\p{:=- Glagolitic_SUP}');
    Error('\P{:=- Glagolitic_SUP}');
    Expect(1, 122927, '\p{glagoliticsup}', "");
    Expect(0, 122927, '\p{^glagoliticsup}', "");
    Expect(0, 122927, '\P{glagoliticsup}', "");
    Expect(1, 122927, '\P{^glagoliticsup}', "");
    Expect(0, 122928, '\p{glagoliticsup}', "");
    Expect(1, 122928, '\p{^glagoliticsup}', "");
    Expect(1, 122928, '\P{glagoliticsup}', "");
    Expect(0, 122928, '\P{^glagoliticsup}', "");
    Expect(1, 122927, '\p{_Glagolitic_SUP}', "");
    Expect(0, 122927, '\p{^_Glagolitic_SUP}', "");
    Expect(0, 122927, '\P{_Glagolitic_SUP}', "");
    Expect(1, 122927, '\P{^_Glagolitic_SUP}', "");
    Expect(0, 122928, '\p{_Glagolitic_SUP}', "");
    Expect(1, 122928, '\p{^_Glagolitic_SUP}', "");
    Expect(1, 122928, '\P{_Glagolitic_SUP}', "");
    Expect(0, 122928, '\P{^_Glagolitic_SUP}', "");
    Error('\p{_Is_Glagolitic_Sup/a/}');
    Error('\P{_Is_Glagolitic_Sup/a/}');
    Expect(1, 122927, '\p{isglagoliticsup}', "");
    Expect(0, 122927, '\p{^isglagoliticsup}', "");
    Expect(0, 122927, '\P{isglagoliticsup}', "");
    Expect(1, 122927, '\P{^isglagoliticsup}', "");
    Expect(0, 122928, '\p{isglagoliticsup}', "");
    Expect(1, 122928, '\p{^isglagoliticsup}', "");
    Expect(1, 122928, '\P{isglagoliticsup}', "");
    Expect(0, 122928, '\P{^isglagoliticsup}', "");
    Expect(1, 122927, '\p{ -IS_glagolitic_Sup}', "");
    Expect(0, 122927, '\p{^ -IS_glagolitic_Sup}', "");
    Expect(0, 122927, '\P{ -IS_glagolitic_Sup}', "");
    Expect(1, 122927, '\P{^ -IS_glagolitic_Sup}', "");
    Expect(0, 122928, '\p{ -IS_glagolitic_Sup}', "");
    Expect(1, 122928, '\p{^ -IS_glagolitic_Sup}', "");
    Expect(1, 122928, '\P{ -IS_glagolitic_Sup}', "");
    Expect(0, 122928, '\P{^ -IS_glagolitic_Sup}', "");
    Error('\p{:=In_Glagolitic_Sup}');
    Error('\P{:=In_Glagolitic_Sup}');
    Expect(1, 122927, '\p{inglagoliticsup}', "");
    Expect(0, 122927, '\p{^inglagoliticsup}', "");
    Expect(0, 122927, '\P{inglagoliticsup}', "");
    Expect(1, 122927, '\P{^inglagoliticsup}', "");
    Expect(0, 122928, '\p{inglagoliticsup}', "");
    Expect(1, 122928, '\p{^inglagoliticsup}', "");
    Expect(1, 122928, '\P{inglagoliticsup}', "");
    Expect(0, 122928, '\P{^inglagoliticsup}', "");
    Expect(1, 122927, '\p{_	IN_Glagolitic_sup}', "");
    Expect(0, 122927, '\p{^_	IN_Glagolitic_sup}', "");
    Expect(0, 122927, '\P{_	IN_Glagolitic_sup}', "");
    Expect(1, 122927, '\P{^_	IN_Glagolitic_sup}', "");
    Expect(0, 122928, '\p{_	IN_Glagolitic_sup}', "");
    Expect(1, 122928, '\p{^_	IN_Glagolitic_sup}', "");
    Expect(1, 122928, '\P{_	IN_Glagolitic_sup}', "");
    Expect(0, 122928, '\P{^_	IN_Glagolitic_sup}', "");
    Error('\p{ /a/GOTHIC}');
    Error('\P{ /a/GOTHIC}');
    Expect(1, 66378, '\p{gothic}', "");
    Expect(0, 66378, '\p{^gothic}', "");
    Expect(0, 66378, '\P{gothic}', "");
    Expect(1, 66378, '\P{^gothic}', "");
    Expect(0, 66379, '\p{gothic}', "");
    Expect(1, 66379, '\p{^gothic}', "");
    Expect(1, 66379, '\P{gothic}', "");
    Expect(0, 66379, '\P{^gothic}', "");
    Expect(1, 66378, '\p{__GOTHIC}', "");
    Expect(0, 66378, '\p{^__GOTHIC}', "");
    Expect(0, 66378, '\P{__GOTHIC}', "");
    Expect(1, 66378, '\P{^__GOTHIC}', "");
    Expect(0, 66379, '\p{__GOTHIC}', "");
    Expect(1, 66379, '\p{^__GOTHIC}', "");
    Expect(1, 66379, '\P{__GOTHIC}', "");
    Expect(0, 66379, '\P{^__GOTHIC}', "");
    Error('\p{/a/__IS_gothic}');
    Error('\P{/a/__IS_gothic}');
    Expect(1, 66378, '\p{isgothic}', "");
    Expect(0, 66378, '\p{^isgothic}', "");
    Expect(0, 66378, '\P{isgothic}', "");
    Expect(1, 66378, '\P{^isgothic}', "");
    Expect(0, 66379, '\p{isgothic}', "");
    Expect(1, 66379, '\p{^isgothic}', "");
    Expect(1, 66379, '\P{isgothic}', "");
    Expect(0, 66379, '\P{^isgothic}', "");
    Expect(1, 66378, '\p{ 	IS_gothic}', "");
    Expect(0, 66378, '\p{^ 	IS_gothic}', "");
    Expect(0, 66378, '\P{ 	IS_gothic}', "");
    Expect(1, 66378, '\P{^ 	IS_gothic}', "");
    Expect(0, 66379, '\p{ 	IS_gothic}', "");
    Expect(1, 66379, '\p{^ 	IS_gothic}', "");
    Expect(1, 66379, '\P{ 	IS_gothic}', "");
    Expect(0, 66379, '\P{^ 	IS_gothic}', "");
    Error('\p{ :=GOTH}');
    Error('\P{ :=GOTH}');
    Expect(1, 66378, '\p{goth}', "");
    Expect(0, 66378, '\p{^goth}', "");
    Expect(0, 66378, '\P{goth}', "");
    Expect(1, 66378, '\P{^goth}', "");
    Expect(0, 66379, '\p{goth}', "");
    Expect(1, 66379, '\p{^goth}', "");
    Expect(1, 66379, '\P{goth}', "");
    Expect(0, 66379, '\P{^goth}', "");
    Expect(1, 66378, '\p{ goth}', "");
    Expect(0, 66378, '\p{^ goth}', "");
    Expect(0, 66378, '\P{ goth}', "");
    Expect(1, 66378, '\P{^ goth}', "");
    Expect(0, 66379, '\p{ goth}', "");
    Expect(1, 66379, '\p{^ goth}', "");
    Expect(1, 66379, '\P{ goth}', "");
    Expect(0, 66379, '\P{^ goth}', "");
    Error('\p{--is_goth:=}');
    Error('\P{--is_goth:=}');
    Expect(1, 66378, '\p{isgoth}', "");
    Expect(0, 66378, '\p{^isgoth}', "");
    Expect(0, 66378, '\P{isgoth}', "");
    Expect(1, 66378, '\P{^isgoth}', "");
    Expect(0, 66379, '\p{isgoth}', "");
    Expect(1, 66379, '\p{^isgoth}', "");
    Expect(1, 66379, '\P{isgoth}', "");
    Expect(0, 66379, '\P{^isgoth}', "");
    Expect(1, 66378, '\p{-Is_Goth}', "");
    Expect(0, 66378, '\p{^-Is_Goth}', "");
    Expect(0, 66378, '\P{-Is_Goth}', "");
    Expect(1, 66378, '\P{^-Is_Goth}', "");
    Expect(0, 66379, '\p{-Is_Goth}', "");
    Expect(1, 66379, '\p{^-Is_Goth}', "");
    Expect(1, 66379, '\P{-Is_Goth}', "");
    Expect(0, 66379, '\P{^-Is_Goth}', "");
    Error('\p{ -Grantha:=}');
    Error('\P{ -Grantha:=}');
    Expect(1, 73683, '\p{grantha}', "");
    Expect(0, 73683, '\p{^grantha}', "");
    Expect(0, 73683, '\P{grantha}', "");
    Expect(1, 73683, '\P{^grantha}', "");
    Expect(0, 73684, '\p{grantha}', "");
    Expect(1, 73684, '\p{^grantha}', "");
    Expect(1, 73684, '\P{grantha}', "");
    Expect(0, 73684, '\P{^grantha}', "");
    Expect(1, 73683, '\p{_GRANTHA}', "");
    Expect(0, 73683, '\p{^_GRANTHA}', "");
    Expect(0, 73683, '\P{_GRANTHA}', "");
    Expect(1, 73683, '\P{^_GRANTHA}', "");
    Expect(0, 73684, '\p{_GRANTHA}', "");
    Expect(1, 73684, '\p{^_GRANTHA}', "");
    Expect(1, 73684, '\P{_GRANTHA}', "");
    Expect(0, 73684, '\P{^_GRANTHA}', "");
    Error('\p{:=-IS_GRANTHA}');
    Error('\P{:=-IS_GRANTHA}');
    Expect(1, 73683, '\p{isgrantha}', "");
    Expect(0, 73683, '\p{^isgrantha}', "");
    Expect(0, 73683, '\P{isgrantha}', "");
    Expect(1, 73683, '\P{^isgrantha}', "");
    Expect(0, 73684, '\p{isgrantha}', "");
    Expect(1, 73684, '\p{^isgrantha}', "");
    Expect(1, 73684, '\P{isgrantha}', "");
    Expect(0, 73684, '\P{^isgrantha}', "");
    Expect(1, 73683, '\p{ 	IS_Grantha}', "");
    Expect(0, 73683, '\p{^ 	IS_Grantha}', "");
    Expect(0, 73683, '\P{ 	IS_Grantha}', "");
    Expect(1, 73683, '\P{^ 	IS_Grantha}', "");
    Expect(0, 73684, '\p{ 	IS_Grantha}', "");
    Expect(1, 73684, '\p{^ 	IS_Grantha}', "");
    Expect(1, 73684, '\P{ 	IS_Grantha}', "");
    Expect(0, 73684, '\P{^ 	IS_Grantha}', "");
    Error('\p{	/a/Gran}');
    Error('\P{	/a/Gran}');
    Expect(1, 73683, '\p{gran}', "");
    Expect(0, 73683, '\p{^gran}', "");
    Expect(0, 73683, '\P{gran}', "");
    Expect(1, 73683, '\P{^gran}', "");
    Expect(0, 73684, '\p{gran}', "");
    Expect(1, 73684, '\p{^gran}', "");
    Expect(1, 73684, '\P{gran}', "");
    Expect(0, 73684, '\P{^gran}', "");
    Expect(1, 73683, '\p{--Gran}', "");
    Expect(0, 73683, '\p{^--Gran}', "");
    Expect(0, 73683, '\P{--Gran}', "");
    Expect(1, 73683, '\P{^--Gran}', "");
    Expect(0, 73684, '\p{--Gran}', "");
    Expect(1, 73684, '\p{^--Gran}', "");
    Expect(1, 73684, '\P{--Gran}', "");
    Expect(0, 73684, '\P{^--Gran}', "");
    Error('\p{_/a/Is_Gran}');
    Error('\P{_/a/Is_Gran}');
    Expect(1, 73683, '\p{isgran}', "");
    Expect(0, 73683, '\p{^isgran}', "");
    Expect(0, 73683, '\P{isgran}', "");
    Expect(1, 73683, '\P{^isgran}', "");
    Expect(0, 73684, '\p{isgran}', "");
    Expect(1, 73684, '\p{^isgran}', "");
    Expect(1, 73684, '\P{isgran}', "");
    Expect(0, 73684, '\P{^isgran}', "");
    Expect(1, 73683, '\p{ -Is_Gran}', "");
    Expect(0, 73683, '\p{^ -Is_Gran}', "");
    Expect(0, 73683, '\P{ -Is_Gran}', "");
    Expect(1, 73683, '\P{^ -Is_Gran}', "");
    Expect(0, 73684, '\p{ -Is_Gran}', "");
    Expect(1, 73684, '\p{^ -Is_Gran}', "");
    Expect(1, 73684, '\P{ -Is_Gran}', "");
    Expect(0, 73684, '\P{^ -Is_Gran}', "");
    Error('\p{ :=xposixgraph}');
    Error('\P{ :=xposixgraph}');
    Expect(1, 1114109, '\p{xposixgraph}', "");
    Expect(0, 1114109, '\p{^xposixgraph}', "");
    Expect(0, 1114109, '\P{xposixgraph}', "");
    Expect(1, 1114109, '\P{^xposixgraph}', "");
    Expect(0, 918000, '\p{xposixgraph}', "");
    Expect(1, 918000, '\p{^xposixgraph}', "");
    Expect(1, 918000, '\P{xposixgraph}', "");
    Expect(0, 918000, '\P{^xposixgraph}', "");
    Expect(1, 1114109, '\p{- XPOSIXGRAPH}', "");
    Expect(0, 1114109, '\p{^- XPOSIXGRAPH}', "");
    Expect(0, 1114109, '\P{- XPOSIXGRAPH}', "");
    Expect(1, 1114109, '\P{^- XPOSIXGRAPH}', "");
    Expect(0, 918000, '\p{- XPOSIXGRAPH}', "");
    Expect(1, 918000, '\p{^- XPOSIXGRAPH}', "");
    Expect(1, 918000, '\P{- XPOSIXGRAPH}', "");
    Expect(0, 918000, '\P{^- XPOSIXGRAPH}', "");
    Error('\p{:=__GRAPH}');
    Error('\P{:=__GRAPH}');
    Expect(1, 1114109, '\p{graph}', "");
    Expect(0, 1114109, '\p{^graph}', "");
    Expect(0, 1114109, '\P{graph}', "");
    Expect(1, 1114109, '\P{^graph}', "");
    Expect(0, 918000, '\p{graph}', "");
    Expect(1, 918000, '\p{^graph}', "");
    Expect(1, 918000, '\P{graph}', "");
    Expect(0, 918000, '\P{^graph}', "");
    Expect(1, 1114109, '\p{  Graph}', "");
    Expect(0, 1114109, '\p{^  Graph}', "");
    Expect(0, 1114109, '\P{  Graph}', "");
    Expect(1, 1114109, '\P{^  Graph}', "");
    Expect(0, 918000, '\p{  Graph}', "");
    Expect(1, 918000, '\p{^  Graph}', "");
    Expect(1, 918000, '\P{  Graph}', "");
    Expect(0, 918000, '\P{^  Graph}', "");
    Error('\p{__is_XPosixGraph/a/}');
    Error('\P{__is_XPosixGraph/a/}');
    Expect(1, 1114109, '\p{isxposixgraph}', "");
    Expect(0, 1114109, '\p{^isxposixgraph}', "");
    Expect(0, 1114109, '\P{isxposixgraph}', "");
    Expect(1, 1114109, '\P{^isxposixgraph}', "");
    Expect(0, 918000, '\p{isxposixgraph}', "");
    Expect(1, 918000, '\p{^isxposixgraph}', "");
    Expect(1, 918000, '\P{isxposixgraph}', "");
    Expect(0, 918000, '\P{^isxposixgraph}', "");
    Expect(1, 1114109, '\p{-_IS_XPOSIXGRAPH}', "");
    Expect(0, 1114109, '\p{^-_IS_XPOSIXGRAPH}', "");
    Expect(0, 1114109, '\P{-_IS_XPOSIXGRAPH}', "");
    Expect(1, 1114109, '\P{^-_IS_XPOSIXGRAPH}', "");
    Expect(0, 918000, '\p{-_IS_XPOSIXGRAPH}', "");
    Expect(1, 918000, '\p{^-_IS_XPOSIXGRAPH}', "");
    Expect(1, 918000, '\P{-_IS_XPOSIXGRAPH}', "");
    Expect(0, 918000, '\P{^-_IS_XPOSIXGRAPH}', "");
    Error('\p{/a/ Is_GRAPH}');
    Error('\P{/a/ Is_GRAPH}');
    Expect(1, 1114109, '\p{isgraph}', "");
    Expect(0, 1114109, '\p{^isgraph}', "");
    Expect(0, 1114109, '\P{isgraph}', "");
    Expect(1, 1114109, '\P{^isgraph}', "");
    Expect(0, 918000, '\p{isgraph}', "");
    Expect(1, 918000, '\p{^isgraph}', "");
    Expect(1, 918000, '\P{isgraph}', "");
    Expect(0, 918000, '\P{^isgraph}', "");
    Expect(1, 1114109, '\p{__Is_Graph}', "");
    Expect(0, 1114109, '\p{^__Is_Graph}', "");
    Expect(0, 1114109, '\P{__Is_Graph}', "");
    Expect(1, 1114109, '\P{^__Is_Graph}', "");
    Expect(0, 918000, '\p{__Is_Graph}', "");
    Expect(1, 918000, '\p{^__Is_Graph}', "");
    Expect(1, 918000, '\P{__Is_Graph}', "");
    Expect(0, 918000, '\P{^__Is_Graph}', "");
    Error('\p{ -grapheme_base:=}');
    Error('\P{ -grapheme_base:=}');
    Expect(1, 201546, '\p{graphemebase}', "");
    Expect(0, 201546, '\p{^graphemebase}', "");
    Expect(0, 201546, '\P{graphemebase}', "");
    Expect(1, 201546, '\P{^graphemebase}', "");
    Expect(0, 201547, '\p{graphemebase}', "");
    Expect(1, 201547, '\p{^graphemebase}', "");
    Expect(1, 201547, '\P{graphemebase}', "");
    Expect(0, 201547, '\P{^graphemebase}', "");
    Expect(1, 201546, '\p{ Grapheme_Base}', "");
    Expect(0, 201546, '\p{^ Grapheme_Base}', "");
    Expect(0, 201546, '\P{ Grapheme_Base}', "");
    Expect(1, 201546, '\P{^ Grapheme_Base}', "");
    Expect(0, 201547, '\p{ Grapheme_Base}', "");
    Expect(1, 201547, '\p{^ Grapheme_Base}', "");
    Expect(1, 201547, '\P{ Grapheme_Base}', "");
    Expect(0, 201547, '\P{^ Grapheme_Base}', "");
    Error('\p{-Is_Grapheme_Base:=}');
    Error('\P{-Is_Grapheme_Base:=}');
    Expect(1, 201546, '\p{isgraphemebase}', "");
    Expect(0, 201546, '\p{^isgraphemebase}', "");
    Expect(0, 201546, '\P{isgraphemebase}', "");
    Expect(1, 201546, '\P{^isgraphemebase}', "");
    Expect(0, 201547, '\p{isgraphemebase}', "");
    Expect(1, 201547, '\p{^isgraphemebase}', "");
    Expect(1, 201547, '\P{isgraphemebase}', "");
    Expect(0, 201547, '\P{^isgraphemebase}', "");
    Expect(1, 201546, '\p{_	Is_Grapheme_Base}', "");
    Expect(0, 201546, '\p{^_	Is_Grapheme_Base}', "");
    Expect(0, 201546, '\P{_	Is_Grapheme_Base}', "");
    Expect(1, 201546, '\P{^_	Is_Grapheme_Base}', "");
    Expect(0, 201547, '\p{_	Is_Grapheme_Base}', "");
    Expect(1, 201547, '\p{^_	Is_Grapheme_Base}', "");
    Expect(1, 201547, '\P{_	Is_Grapheme_Base}', "");
    Expect(0, 201547, '\P{^_	Is_Grapheme_Base}', "");
    Error('\p{:=_Gr_Base}');
    Error('\P{:=_Gr_Base}');
    Expect(1, 201546, '\p{grbase}', "");
    Expect(0, 201546, '\p{^grbase}', "");
    Expect(0, 201546, '\P{grbase}', "");
    Expect(1, 201546, '\P{^grbase}', "");
    Expect(0, 201547, '\p{grbase}', "");
    Expect(1, 201547, '\p{^grbase}', "");
    Expect(1, 201547, '\P{grbase}', "");
    Expect(0, 201547, '\P{^grbase}', "");
    Expect(1, 201546, '\p{- gr_base}', "");
    Expect(0, 201546, '\p{^- gr_base}', "");
    Expect(0, 201546, '\P{- gr_base}', "");
    Expect(1, 201546, '\P{^- gr_base}', "");
    Expect(0, 201547, '\p{- gr_base}', "");
    Expect(1, 201547, '\p{^- gr_base}', "");
    Expect(1, 201547, '\P{- gr_base}', "");
    Expect(0, 201547, '\P{^- gr_base}', "");
    Error('\p{ :=Is_GR_Base}');
    Error('\P{ :=Is_GR_Base}');
    Expect(1, 201546, '\p{isgrbase}', "");
    Expect(0, 201546, '\p{^isgrbase}', "");
    Expect(0, 201546, '\P{isgrbase}', "");
    Expect(1, 201546, '\P{^isgrbase}', "");
    Expect(0, 201547, '\p{isgrbase}', "");
    Expect(1, 201547, '\p{^isgrbase}', "");
    Expect(1, 201547, '\P{isgrbase}', "");
    Expect(0, 201547, '\P{^isgrbase}', "");
    Expect(1, 201546, '\p{-Is_Gr_base}', "");
    Expect(0, 201546, '\p{^-Is_Gr_base}', "");
    Expect(0, 201546, '\P{-Is_Gr_base}', "");
    Expect(1, 201546, '\P{^-Is_Gr_base}', "");
    Expect(0, 201547, '\p{-Is_Gr_base}', "");
    Expect(1, 201547, '\p{^-Is_Gr_base}', "");
    Expect(1, 201547, '\P{-Is_Gr_base}', "");
    Expect(0, 201547, '\P{^-Is_Gr_base}', "");
    Error('\p{:=	Grapheme_EXTEND}');
    Error('\P{:=	Grapheme_EXTEND}');
    Expect(1, 917999, '\p{graphemeextend}', "");
    Expect(0, 917999, '\p{^graphemeextend}', "");
    Expect(0, 917999, '\P{graphemeextend}', "");
    Expect(1, 917999, '\P{^graphemeextend}', "");
    Expect(0, 918000, '\p{graphemeextend}', "");
    Expect(1, 918000, '\p{^graphemeextend}', "");
    Expect(1, 918000, '\P{graphemeextend}', "");
    Expect(0, 918000, '\P{^graphemeextend}', "");
    Expect(1, 917999, '\p{_ Grapheme_Extend}', "");
    Expect(0, 917999, '\p{^_ Grapheme_Extend}', "");
    Expect(0, 917999, '\P{_ Grapheme_Extend}', "");
    Expect(1, 917999, '\P{^_ Grapheme_Extend}', "");
    Expect(0, 918000, '\p{_ Grapheme_Extend}', "");
    Expect(1, 918000, '\p{^_ Grapheme_Extend}', "");
    Expect(1, 918000, '\P{_ Grapheme_Extend}', "");
    Expect(0, 918000, '\P{^_ Grapheme_Extend}', "");
    Error('\p{-Is_Grapheme_EXTEND/a/}');
    Error('\P{-Is_Grapheme_EXTEND/a/}');
    Expect(1, 917999, '\p{isgraphemeextend}', "");
    Expect(0, 917999, '\p{^isgraphemeextend}', "");
    Expect(0, 917999, '\P{isgraphemeextend}', "");
    Expect(1, 917999, '\P{^isgraphemeextend}', "");
    Expect(0, 918000, '\p{isgraphemeextend}', "");
    Expect(1, 918000, '\p{^isgraphemeextend}', "");
    Expect(1, 918000, '\P{isgraphemeextend}', "");
    Expect(0, 918000, '\P{^isgraphemeextend}', "");
    Expect(1, 917999, '\p{ _IS_Grapheme_Extend}', "");
    Expect(0, 917999, '\p{^ _IS_Grapheme_Extend}', "");
    Expect(0, 917999, '\P{ _IS_Grapheme_Extend}', "");
    Expect(1, 917999, '\P{^ _IS_Grapheme_Extend}', "");
    Expect(0, 918000, '\p{ _IS_Grapheme_Extend}', "");
    Expect(1, 918000, '\p{^ _IS_Grapheme_Extend}', "");
    Expect(1, 918000, '\P{ _IS_Grapheme_Extend}', "");
    Expect(0, 918000, '\P{^ _IS_Grapheme_Extend}', "");
    Error('\p{_gr_Ext:=}');
    Error('\P{_gr_Ext:=}');
    Expect(1, 917999, '\p{grext}', "");
    Expect(0, 917999, '\p{^grext}', "");
    Expect(0, 917999, '\P{grext}', "");
    Expect(1, 917999, '\P{^grext}', "");
    Expect(0, 918000, '\p{grext}', "");
    Expect(1, 918000, '\p{^grext}', "");
    Expect(1, 918000, '\P{grext}', "");
    Expect(0, 918000, '\P{^grext}', "");
    Expect(1, 917999, '\p{-Gr_Ext}', "");
    Expect(0, 917999, '\p{^-Gr_Ext}', "");
    Expect(0, 917999, '\P{-Gr_Ext}', "");
    Expect(1, 917999, '\P{^-Gr_Ext}', "");
    Expect(0, 918000, '\p{-Gr_Ext}', "");
    Expect(1, 918000, '\p{^-Gr_Ext}', "");
    Expect(1, 918000, '\P{-Gr_Ext}', "");
    Expect(0, 918000, '\P{^-Gr_Ext}', "");
    Error('\p{	/a/Is_GR_EXT}');
    Error('\P{	/a/Is_GR_EXT}');
    Expect(1, 917999, '\p{isgrext}', "");
    Expect(0, 917999, '\p{^isgrext}', "");
    Expect(0, 917999, '\P{isgrext}', "");
    Expect(1, 917999, '\P{^isgrext}', "");
    Expect(0, 918000, '\p{isgrext}', "");
    Expect(1, 918000, '\p{^isgrext}', "");
    Expect(1, 918000, '\P{isgrext}', "");
    Expect(0, 918000, '\P{^isgrext}', "");
    Expect(1, 917999, '\p{	IS_GR_EXT}', "");
    Expect(0, 917999, '\p{^	IS_GR_EXT}', "");
    Expect(0, 917999, '\P{	IS_GR_EXT}', "");
    Expect(1, 917999, '\P{^	IS_GR_EXT}', "");
    Expect(0, 918000, '\p{	IS_GR_EXT}', "");
    Expect(1, 918000, '\p{^	IS_GR_EXT}', "");
    Expect(1, 918000, '\P{	IS_GR_EXT}', "");
    Expect(0, 918000, '\P{^	IS_GR_EXT}', "");
    Error('\p{Grapheme_Link}');
    Error('\P{Grapheme_Link}');
    Error('\p{Gr_Link}');
    Error('\P{Gr_Link}');
    Error('\p{ /a/Greek}');
    Error('\P{ /a/Greek}');
    Expect(1, 119365, '\p{greek}', "");
    Expect(0, 119365, '\p{^greek}', "");
    Expect(0, 119365, '\P{greek}', "");
    Expect(1, 119365, '\P{^greek}', "");
    Expect(0, 119366, '\p{greek}', "");
    Expect(1, 119366, '\p{^greek}', "");
    Expect(1, 119366, '\P{greek}', "");
    Expect(0, 119366, '\P{^greek}', "");
    Expect(1, 119365, '\p{-	greek}', "");
    Expect(0, 119365, '\p{^-	greek}', "");
    Expect(0, 119365, '\P{-	greek}', "");
    Expect(1, 119365, '\P{^-	greek}', "");
    Expect(0, 119366, '\p{-	greek}', "");
    Expect(1, 119366, '\p{^-	greek}', "");
    Expect(1, 119366, '\P{-	greek}', "");
    Expect(0, 119366, '\P{^-	greek}', "");
    Error('\p{/a/  Is_GREEK}');
    Error('\P{/a/  Is_GREEK}');
    Expect(1, 119365, '\p{isgreek}', "");
    Expect(0, 119365, '\p{^isgreek}', "");
    Expect(0, 119365, '\P{isgreek}', "");
    Expect(1, 119365, '\P{^isgreek}', "");
    Expect(0, 119366, '\p{isgreek}', "");
    Expect(1, 119366, '\p{^isgreek}', "");
    Expect(1, 119366, '\P{isgreek}', "");
    Expect(0, 119366, '\P{^isgreek}', "");
    Expect(1, 119365, '\p{_IS_greek}', "");
    Expect(0, 119365, '\p{^_IS_greek}', "");
    Expect(0, 119365, '\P{_IS_greek}', "");
    Expect(1, 119365, '\P{^_IS_greek}', "");
    Expect(0, 119366, '\p{_IS_greek}', "");
    Expect(1, 119366, '\p{^_IS_greek}', "");
    Expect(1, 119366, '\P{_IS_greek}', "");
    Expect(0, 119366, '\P{^_IS_greek}', "");
    Error('\p{		Grek/a/}');
    Error('\P{		Grek/a/}');
    Expect(1, 119365, '\p{grek}', "");
    Expect(0, 119365, '\p{^grek}', "");
    Expect(0, 119365, '\P{grek}', "");
    Expect(1, 119365, '\P{^grek}', "");
    Expect(0, 119366, '\p{grek}', "");
    Expect(1, 119366, '\p{^grek}', "");
    Expect(1, 119366, '\P{grek}', "");
    Expect(0, 119366, '\P{^grek}', "");
    Expect(1, 119365, '\p{_grek}', "");
    Expect(0, 119365, '\p{^_grek}', "");
    Expect(0, 119365, '\P{_grek}', "");
    Expect(1, 119365, '\P{^_grek}', "");
    Expect(0, 119366, '\p{_grek}', "");
    Expect(1, 119366, '\p{^_grek}', "");
    Expect(1, 119366, '\P{_grek}', "");
    Expect(0, 119366, '\P{^_grek}', "");
    Error('\p{	/a/IS_grek}');
    Error('\P{	/a/IS_grek}');
    Expect(1, 119365, '\p{isgrek}', "");
    Expect(0, 119365, '\p{^isgrek}', "");
    Expect(0, 119365, '\P{isgrek}', "");
    Expect(1, 119365, '\P{^isgrek}', "");
    Expect(0, 119366, '\p{isgrek}', "");
    Expect(1, 119366, '\p{^isgrek}', "");
    Expect(1, 119366, '\P{isgrek}', "");
    Expect(0, 119366, '\P{^isgrek}', "");
    Expect(1, 119365, '\p{	 Is_GREK}', "");
    Expect(0, 119365, '\p{^	 Is_GREK}', "");
    Expect(0, 119365, '\P{	 Is_GREK}', "");
    Expect(1, 119365, '\P{^	 Is_GREK}', "");
    Expect(0, 119366, '\p{	 Is_GREK}', "");
    Expect(1, 119366, '\p{^	 Is_GREK}', "");
    Expect(1, 119366, '\P{	 Is_GREK}', "");
    Expect(0, 119366, '\P{^	 Is_GREK}', "");
    Error('\p{:=_Greek_and_Coptic}');
    Error('\P{:=_Greek_and_Coptic}');
    Expect(1, 1023, '\p{greekandcoptic}', "");
    Expect(0, 1023, '\p{^greekandcoptic}', "");
    Expect(0, 1023, '\P{greekandcoptic}', "");
    Expect(1, 1023, '\P{^greekandcoptic}', "");
    Expect(0, 1024, '\p{greekandcoptic}', "");
    Expect(1, 1024, '\p{^greekandcoptic}', "");
    Expect(1, 1024, '\P{greekandcoptic}', "");
    Expect(0, 1024, '\P{^greekandcoptic}', "");
    Expect(1, 1023, '\p{ 	Greek_and_Coptic}', "");
    Expect(0, 1023, '\p{^ 	Greek_and_Coptic}', "");
    Expect(0, 1023, '\P{ 	Greek_and_Coptic}', "");
    Expect(1, 1023, '\P{^ 	Greek_and_Coptic}', "");
    Expect(0, 1024, '\p{ 	Greek_and_Coptic}', "");
    Expect(1, 1024, '\p{^ 	Greek_and_Coptic}', "");
    Expect(1, 1024, '\P{ 	Greek_and_Coptic}', "");
    Expect(0, 1024, '\P{^ 	Greek_and_Coptic}', "");
    Error('\p{:=IS_Greek_And_Coptic}');
    Error('\P{:=IS_Greek_And_Coptic}');
    Expect(1, 1023, '\p{isgreekandcoptic}', "");
    Expect(0, 1023, '\p{^isgreekandcoptic}', "");
    Expect(0, 1023, '\P{isgreekandcoptic}', "");
    Expect(1, 1023, '\P{^isgreekandcoptic}', "");
    Expect(0, 1024, '\p{isgreekandcoptic}', "");
    Expect(1, 1024, '\p{^isgreekandcoptic}', "");
    Expect(1, 1024, '\P{isgreekandcoptic}', "");
    Expect(0, 1024, '\P{^isgreekandcoptic}', "");
    Expect(1, 1023, '\p{  Is_Greek_And_COPTIC}', "");
    Expect(0, 1023, '\p{^  Is_Greek_And_COPTIC}', "");
    Expect(0, 1023, '\P{  Is_Greek_And_COPTIC}', "");
    Expect(1, 1023, '\P{^  Is_Greek_And_COPTIC}', "");
    Expect(0, 1024, '\p{  Is_Greek_And_COPTIC}', "");
    Expect(1, 1024, '\p{^  Is_Greek_And_COPTIC}', "");
    Expect(1, 1024, '\P{  Is_Greek_And_COPTIC}', "");
    Expect(0, 1024, '\P{^  Is_Greek_And_COPTIC}', "");
    Error('\p{:=  In_Greek_And_coptic}');
    Error('\P{:=  In_Greek_And_coptic}');
    Expect(1, 1023, '\p{ingreekandcoptic}', "");
    Expect(0, 1023, '\p{^ingreekandcoptic}', "");
    Expect(0, 1023, '\P{ingreekandcoptic}', "");
    Expect(1, 1023, '\P{^ingreekandcoptic}', "");
    Expect(0, 1024, '\p{ingreekandcoptic}', "");
    Expect(1, 1024, '\p{^ingreekandcoptic}', "");
    Expect(1, 1024, '\P{ingreekandcoptic}', "");
    Expect(0, 1024, '\P{^ingreekandcoptic}', "");
    Expect(1, 1023, '\p{-In_Greek_AND_Coptic}', "");
    Expect(0, 1023, '\p{^-In_Greek_AND_Coptic}', "");
    Expect(0, 1023, '\P{-In_Greek_AND_Coptic}', "");
    Expect(1, 1023, '\P{^-In_Greek_AND_Coptic}', "");
    Expect(0, 1024, '\p{-In_Greek_AND_Coptic}', "");
    Expect(1, 1024, '\p{^-In_Greek_AND_Coptic}', "");
    Expect(1, 1024, '\P{-In_Greek_AND_Coptic}', "");
    Expect(0, 1024, '\P{^-In_Greek_AND_Coptic}', "");
    Error('\p{	 IN_greek/a/}');
    Error('\P{	 IN_greek/a/}');
    Expect(1, 1023, '\p{ingreek}', "");
    Expect(0, 1023, '\p{^ingreek}', "");
    Expect(0, 1023, '\P{ingreek}', "");
    Expect(1, 1023, '\P{^ingreek}', "");
    Expect(0, 1024, '\p{ingreek}', "");
    Expect(1, 1024, '\p{^ingreek}', "");
    Expect(1, 1024, '\P{ingreek}', "");
    Expect(0, 1024, '\P{^ingreek}', "");
    Expect(1, 1023, '\p{-	in_Greek}', "");
    Expect(0, 1023, '\p{^-	in_Greek}', "");
    Expect(0, 1023, '\P{-	in_Greek}', "");
    Expect(1, 1023, '\P{^-	in_Greek}', "");
    Expect(0, 1024, '\p{-	in_Greek}', "");
    Expect(1, 1024, '\p{^-	in_Greek}', "");
    Expect(1, 1024, '\P{-	in_Greek}', "");
    Expect(0, 1024, '\P{^-	in_Greek}', "");
    Error('\p{ :=GREEK_Extended}');
    Error('\P{ :=GREEK_Extended}');
    Expect(1, 8191, '\p{greekextended}', "");
    Expect(0, 8191, '\p{^greekextended}', "");
    Expect(0, 8191, '\P{greekextended}', "");
    Expect(1, 8191, '\P{^greekextended}', "");
    Expect(0, 8192, '\p{greekextended}', "");
    Expect(1, 8192, '\p{^greekextended}', "");
    Expect(1, 8192, '\P{greekextended}', "");
    Expect(0, 8192, '\P{^greekextended}', "");
    Expect(1, 8191, '\p{  GREEK_extended}', "");
    Expect(0, 8191, '\p{^  GREEK_extended}', "");
    Expect(0, 8191, '\P{  GREEK_extended}', "");
    Expect(1, 8191, '\P{^  GREEK_extended}', "");
    Expect(0, 8192, '\p{  GREEK_extended}', "");
    Expect(1, 8192, '\p{^  GREEK_extended}', "");
    Expect(1, 8192, '\P{  GREEK_extended}', "");
    Expect(0, 8192, '\P{^  GREEK_extended}', "");
    Error('\p{/a/ Is_GREEK_EXTENDED}');
    Error('\P{/a/ Is_GREEK_EXTENDED}');
    Expect(1, 8191, '\p{isgreekextended}', "");
    Expect(0, 8191, '\p{^isgreekextended}', "");
    Expect(0, 8191, '\P{isgreekextended}', "");
    Expect(1, 8191, '\P{^isgreekextended}', "");
    Expect(0, 8192, '\p{isgreekextended}', "");
    Expect(1, 8192, '\p{^isgreekextended}', "");
    Expect(1, 8192, '\P{isgreekextended}', "");
    Expect(0, 8192, '\P{^isgreekextended}', "");
    Expect(1, 8191, '\p{--Is_greek_Extended}', "");
    Expect(0, 8191, '\p{^--Is_greek_Extended}', "");
    Expect(0, 8191, '\P{--Is_greek_Extended}', "");
    Expect(1, 8191, '\P{^--Is_greek_Extended}', "");
    Expect(0, 8192, '\p{--Is_greek_Extended}', "");
    Expect(1, 8192, '\p{^--Is_greek_Extended}', "");
    Expect(1, 8192, '\P{--Is_greek_Extended}', "");
    Expect(0, 8192, '\P{^--Is_greek_Extended}', "");
    Error('\p{_/a/in_greek_Extended}');
    Error('\P{_/a/in_greek_Extended}');
    Expect(1, 8191, '\p{ingreekextended}', "");
    Expect(0, 8191, '\p{^ingreekextended}', "");
    Expect(0, 8191, '\P{ingreekextended}', "");
    Expect(1, 8191, '\P{^ingreekextended}', "");
    Expect(0, 8192, '\p{ingreekextended}', "");
    Expect(1, 8192, '\p{^ingreekextended}', "");
    Expect(1, 8192, '\P{ingreekextended}', "");
    Expect(0, 8192, '\P{^ingreekextended}', "");
    Expect(1, 8191, '\p{in_Greek_extended}', "");
    Expect(0, 8191, '\p{^in_Greek_extended}', "");
    Expect(0, 8191, '\P{in_Greek_extended}', "");
    Expect(1, 8191, '\P{^in_Greek_extended}', "");
    Expect(0, 8192, '\p{in_Greek_extended}', "");
    Expect(1, 8192, '\p{^in_Greek_extended}', "");
    Expect(1, 8192, '\P{in_Greek_extended}', "");
    Expect(0, 8192, '\P{^in_Greek_extended}', "");
    Error('\p{_-Greek_Ext/a/}');
    Error('\P{_-Greek_Ext/a/}');
    Expect(1, 8191, '\p{greekext}', "");
    Expect(0, 8191, '\p{^greekext}', "");
    Expect(0, 8191, '\P{greekext}', "");
    Expect(1, 8191, '\P{^greekext}', "");
    Expect(0, 8192, '\p{greekext}', "");
    Expect(1, 8192, '\p{^greekext}', "");
    Expect(1, 8192, '\P{greekext}', "");
    Expect(0, 8192, '\P{^greekext}', "");
    Expect(1, 8191, '\p{Greek_EXT}', "");
    Expect(0, 8191, '\p{^Greek_EXT}', "");
    Expect(0, 8191, '\P{Greek_EXT}', "");
    Expect(1, 8191, '\P{^Greek_EXT}', "");
    Expect(0, 8192, '\p{Greek_EXT}', "");
    Expect(1, 8192, '\p{^Greek_EXT}', "");
    Expect(1, 8192, '\P{Greek_EXT}', "");
    Expect(0, 8192, '\P{^Greek_EXT}', "");
    Error('\p{/a/	 is_Greek_Ext}');
    Error('\P{/a/	 is_Greek_Ext}');
    Expect(1, 8191, '\p{isgreekext}', "");
    Expect(0, 8191, '\p{^isgreekext}', "");
    Expect(0, 8191, '\P{isgreekext}', "");
    Expect(1, 8191, '\P{^isgreekext}', "");
    Expect(0, 8192, '\p{isgreekext}', "");
    Expect(1, 8192, '\p{^isgreekext}', "");
    Expect(1, 8192, '\P{isgreekext}', "");
    Expect(0, 8192, '\P{^isgreekext}', "");
    Expect(1, 8191, '\p{Is_Greek_Ext}', "");
    Expect(0, 8191, '\p{^Is_Greek_Ext}', "");
    Expect(0, 8191, '\P{Is_Greek_Ext}', "");
    Expect(1, 8191, '\P{^Is_Greek_Ext}', "");
    Expect(0, 8192, '\p{Is_Greek_Ext}', "");
    Expect(1, 8192, '\p{^Is_Greek_Ext}', "");
    Expect(1, 8192, '\P{Is_Greek_Ext}', "");
    Expect(0, 8192, '\P{^Is_Greek_Ext}', "");
    Error('\p{	:=IN_GREEK_Ext}');
    Error('\P{	:=IN_GREEK_Ext}');
    Expect(1, 8191, '\p{ingreekext}', "");
    Expect(0, 8191, '\p{^ingreekext}', "");
    Expect(0, 8191, '\P{ingreekext}', "");
    Expect(1, 8191, '\P{^ingreekext}', "");
    Expect(0, 8192, '\p{ingreekext}', "");
    Expect(1, 8192, '\p{^ingreekext}', "");
    Expect(1, 8192, '\P{ingreekext}', "");
    Expect(0, 8192, '\P{^ingreekext}', "");
    Expect(1, 8191, '\p{ In_Greek_ext}', "");
    Expect(0, 8191, '\p{^ In_Greek_ext}', "");
    Expect(0, 8191, '\P{ In_Greek_ext}', "");
    Expect(1, 8191, '\P{^ In_Greek_ext}', "");
    Expect(0, 8192, '\p{ In_Greek_ext}', "");
    Expect(1, 8192, '\p{^ In_Greek_ext}', "");
    Expect(1, 8192, '\P{ In_Greek_ext}', "");
    Expect(0, 8192, '\P{^ In_Greek_ext}', "");
    Error('\p{GUJARATI:=}');
    Error('\P{GUJARATI:=}');
    Expect(1, 43065, '\p{gujarati}', "");
    Expect(0, 43065, '\p{^gujarati}', "");
    Expect(0, 43065, '\P{gujarati}', "");
    Expect(1, 43065, '\P{^gujarati}', "");
    Expect(0, 43066, '\p{gujarati}', "");
    Expect(1, 43066, '\p{^gujarati}', "");
    Expect(1, 43066, '\P{gujarati}', "");
    Expect(0, 43066, '\P{^gujarati}', "");
    Expect(1, 43065, '\p{-_Gujarati}', "");
    Expect(0, 43065, '\p{^-_Gujarati}', "");
    Expect(0, 43065, '\P{-_Gujarati}', "");
    Expect(1, 43065, '\P{^-_Gujarati}', "");
    Expect(0, 43066, '\p{-_Gujarati}', "");
    Expect(1, 43066, '\p{^-_Gujarati}', "");
    Expect(1, 43066, '\P{-_Gujarati}', "");
    Expect(0, 43066, '\P{^-_Gujarati}', "");
    Error('\p{:=__is_GUJARATI}');
    Error('\P{:=__is_GUJARATI}');
    Expect(1, 43065, '\p{isgujarati}', "");
    Expect(0, 43065, '\p{^isgujarati}', "");
    Expect(0, 43065, '\P{isgujarati}', "");
    Expect(1, 43065, '\P{^isgujarati}', "");
    Expect(0, 43066, '\p{isgujarati}', "");
    Expect(1, 43066, '\p{^isgujarati}', "");
    Expect(1, 43066, '\P{isgujarati}', "");
    Expect(0, 43066, '\P{^isgujarati}', "");
    Expect(1, 43065, '\p{_is_GUJARATI}', "");
    Expect(0, 43065, '\p{^_is_GUJARATI}', "");
    Expect(0, 43065, '\P{_is_GUJARATI}', "");
    Expect(1, 43065, '\P{^_is_GUJARATI}', "");
    Expect(0, 43066, '\p{_is_GUJARATI}', "");
    Expect(1, 43066, '\p{^_is_GUJARATI}', "");
    Expect(1, 43066, '\P{_is_GUJARATI}', "");
    Expect(0, 43066, '\P{^_is_GUJARATI}', "");
    Error('\p{ GUJR/a/}');
    Error('\P{ GUJR/a/}');
    Expect(1, 43065, '\p{gujr}', "");
    Expect(0, 43065, '\p{^gujr}', "");
    Expect(0, 43065, '\P{gujr}', "");
    Expect(1, 43065, '\P{^gujr}', "");
    Expect(0, 43066, '\p{gujr}', "");
    Expect(1, 43066, '\p{^gujr}', "");
    Expect(1, 43066, '\P{gujr}', "");
    Expect(0, 43066, '\P{^gujr}', "");
    Expect(1, 43065, '\p{	Gujr}', "");
    Expect(0, 43065, '\p{^	Gujr}', "");
    Expect(0, 43065, '\P{	Gujr}', "");
    Expect(1, 43065, '\P{^	Gujr}', "");
    Expect(0, 43066, '\p{	Gujr}', "");
    Expect(1, 43066, '\p{^	Gujr}', "");
    Expect(1, 43066, '\P{	Gujr}', "");
    Expect(0, 43066, '\P{^	Gujr}', "");
    Error('\p{:=Is_gujr}');
    Error('\P{:=Is_gujr}');
    Expect(1, 43065, '\p{isgujr}', "");
    Expect(0, 43065, '\p{^isgujr}', "");
    Expect(0, 43065, '\P{isgujr}', "");
    Expect(1, 43065, '\P{^isgujr}', "");
    Expect(0, 43066, '\p{isgujr}', "");
    Expect(1, 43066, '\p{^isgujr}', "");
    Expect(1, 43066, '\P{isgujr}', "");
    Expect(0, 43066, '\P{^isgujr}', "");
    Expect(1, 43065, '\p{__Is_gujr}', "");
    Expect(0, 43065, '\p{^__Is_gujr}', "");
    Expect(0, 43065, '\P{__Is_gujr}', "");
    Expect(1, 43065, '\P{^__Is_gujr}', "");
    Expect(0, 43066, '\p{__Is_gujr}', "");
    Expect(1, 43066, '\p{^__Is_gujr}', "");
    Expect(1, 43066, '\P{__Is_gujr}', "");
    Expect(0, 43066, '\P{^__Is_gujr}', "");
    Error('\p{/a/Gunjala_Gondi}');
    Error('\P{/a/Gunjala_Gondi}');
    Expect(1, 73129, '\p{gunjalagondi}', "");
    Expect(0, 73129, '\p{^gunjalagondi}', "");
    Expect(0, 73129, '\P{gunjalagondi}', "");
    Expect(1, 73129, '\P{^gunjalagondi}', "");
    Expect(0, 73130, '\p{gunjalagondi}', "");
    Expect(1, 73130, '\p{^gunjalagondi}', "");
    Expect(1, 73130, '\P{gunjalagondi}', "");
    Expect(0, 73130, '\P{^gunjalagondi}', "");
    Expect(1, 73129, '\p{_-gunjala_Gondi}', "");
    Expect(0, 73129, '\p{^_-gunjala_Gondi}', "");
    Expect(0, 73129, '\P{_-gunjala_Gondi}', "");
    Expect(1, 73129, '\P{^_-gunjala_Gondi}', "");
    Expect(0, 73130, '\p{_-gunjala_Gondi}', "");
    Expect(1, 73130, '\p{^_-gunjala_Gondi}', "");
    Expect(1, 73130, '\P{_-gunjala_Gondi}', "");
    Expect(0, 73130, '\P{^_-gunjala_Gondi}', "");
    Error('\p{_:=is_GUNJALA_Gondi}');
    Error('\P{_:=is_GUNJALA_Gondi}');
    Expect(1, 73129, '\p{isgunjalagondi}', "");
    Expect(0, 73129, '\p{^isgunjalagondi}', "");
    Expect(0, 73129, '\P{isgunjalagondi}', "");
    Expect(1, 73129, '\P{^isgunjalagondi}', "");
    Expect(0, 73130, '\p{isgunjalagondi}', "");
    Expect(1, 73130, '\p{^isgunjalagondi}', "");
    Expect(1, 73130, '\P{isgunjalagondi}', "");
    Expect(0, 73130, '\P{^isgunjalagondi}', "");
    Expect(1, 73129, '\p{--IS_GUNJALA_Gondi}', "");
    Expect(0, 73129, '\p{^--IS_GUNJALA_Gondi}', "");
    Expect(0, 73129, '\P{--IS_GUNJALA_Gondi}', "");
    Expect(1, 73129, '\P{^--IS_GUNJALA_Gondi}', "");
    Expect(0, 73130, '\p{--IS_GUNJALA_Gondi}', "");
    Expect(1, 73130, '\p{^--IS_GUNJALA_Gondi}', "");
    Expect(1, 73130, '\P{--IS_GUNJALA_Gondi}', "");
    Expect(0, 73130, '\P{^--IS_GUNJALA_Gondi}', "");
    Error('\p{- gong/a/}');
    Error('\P{- gong/a/}');
    Expect(1, 73129, '\p{gong}', "");
    Expect(0, 73129, '\p{^gong}', "");
    Expect(0, 73129, '\P{gong}', "");
    Expect(1, 73129, '\P{^gong}', "");
    Expect(0, 73130, '\p{gong}', "");
    Expect(1, 73130, '\p{^gong}', "");
    Expect(1, 73130, '\P{gong}', "");
    Expect(0, 73130, '\P{^gong}', "");
    Expect(1, 73129, '\p{-GONG}', "");
    Expect(0, 73129, '\p{^-GONG}', "");
    Expect(0, 73129, '\P{-GONG}', "");
    Expect(1, 73129, '\P{^-GONG}', "");
    Expect(0, 73130, '\p{-GONG}', "");
    Expect(1, 73130, '\p{^-GONG}', "");
    Expect(1, 73130, '\P{-GONG}', "");
    Expect(0, 73130, '\P{^-GONG}', "");
    Error('\p{/a/_	Is_gong}');
    Error('\P{/a/_	Is_gong}');
    Expect(1, 73129, '\p{isgong}', "");
    Expect(0, 73129, '\p{^isgong}', "");
    Expect(0, 73129, '\P{isgong}', "");
    Expect(1, 73129, '\P{^isgong}', "");
    Expect(0, 73130, '\p{isgong}', "");
    Expect(1, 73130, '\p{^isgong}', "");
    Expect(1, 73130, '\P{isgong}', "");
    Expect(0, 73130, '\P{^isgong}', "");
    Expect(1, 73129, '\p{ -Is_gong}', "");
    Expect(0, 73129, '\p{^ -Is_gong}', "");
    Expect(0, 73129, '\P{ -Is_gong}', "");
    Expect(1, 73129, '\P{^ -Is_gong}', "");
    Expect(0, 73130, '\p{ -Is_gong}', "");
    Expect(1, 73130, '\p{^ -Is_gong}', "");
    Expect(1, 73130, '\P{ -Is_gong}', "");
    Expect(0, 73130, '\P{^ -Is_gong}', "");
    Error('\p{/a/ -GURMUKHI}');
    Error('\P{/a/ -GURMUKHI}');
    Expect(1, 43065, '\p{gurmukhi}', "");
    Expect(0, 43065, '\p{^gurmukhi}', "");
    Expect(0, 43065, '\P{gurmukhi}', "");
    Expect(1, 43065, '\P{^gurmukhi}', "");
    Expect(0, 43066, '\p{gurmukhi}', "");
    Expect(1, 43066, '\p{^gurmukhi}', "");
    Expect(1, 43066, '\P{gurmukhi}', "");
    Expect(0, 43066, '\P{^gurmukhi}', "");
    Expect(1, 43065, '\p{ _Gurmukhi}', "");
    Expect(0, 43065, '\p{^ _Gurmukhi}', "");
    Expect(0, 43065, '\P{ _Gurmukhi}', "");
    Expect(1, 43065, '\P{^ _Gurmukhi}', "");
    Expect(0, 43066, '\p{ _Gurmukhi}', "");
    Expect(1, 43066, '\p{^ _Gurmukhi}', "");
    Expect(1, 43066, '\P{ _Gurmukhi}', "");
    Expect(0, 43066, '\P{^ _Gurmukhi}', "");
    Error('\p{:= Is_Gurmukhi}');
    Error('\P{:= Is_Gurmukhi}');
    Expect(1, 43065, '\p{isgurmukhi}', "");
    Expect(0, 43065, '\p{^isgurmukhi}', "");
    Expect(0, 43065, '\P{isgurmukhi}', "");
    Expect(1, 43065, '\P{^isgurmukhi}', "");
    Expect(0, 43066, '\p{isgurmukhi}', "");
    Expect(1, 43066, '\p{^isgurmukhi}', "");
    Expect(1, 43066, '\P{isgurmukhi}', "");
    Expect(0, 43066, '\P{^isgurmukhi}', "");
    Expect(1, 43065, '\p{ -Is_Gurmukhi}', "");
    Expect(0, 43065, '\p{^ -Is_Gurmukhi}', "");
    Expect(0, 43065, '\P{ -Is_Gurmukhi}', "");
    Expect(1, 43065, '\P{^ -Is_Gurmukhi}', "");
    Expect(0, 43066, '\p{ -Is_Gurmukhi}', "");
    Expect(1, 43066, '\p{^ -Is_Gurmukhi}', "");
    Expect(1, 43066, '\P{ -Is_Gurmukhi}', "");
    Expect(0, 43066, '\P{^ -Is_Gurmukhi}', "");
    Error('\p{:=_ GURU}');
    Error('\P{:=_ GURU}');
    Expect(1, 43065, '\p{guru}', "");
    Expect(0, 43065, '\p{^guru}', "");
    Expect(0, 43065, '\P{guru}', "");
    Expect(1, 43065, '\P{^guru}', "");
    Expect(0, 43066, '\p{guru}', "");
    Expect(1, 43066, '\p{^guru}', "");
    Expect(1, 43066, '\P{guru}', "");
    Expect(0, 43066, '\P{^guru}', "");
    Expect(1, 43065, '\p{_	guru}', "");
    Expect(0, 43065, '\p{^_	guru}', "");
    Expect(0, 43065, '\P{_	guru}', "");
    Expect(1, 43065, '\P{^_	guru}', "");
    Expect(0, 43066, '\p{_	guru}', "");
    Expect(1, 43066, '\p{^_	guru}', "");
    Expect(1, 43066, '\P{_	guru}', "");
    Expect(0, 43066, '\P{^_	guru}', "");
    Error('\p{_ Is_GURU/a/}');
    Error('\P{_ Is_GURU/a/}');
    Expect(1, 43065, '\p{isguru}', "");
    Expect(0, 43065, '\p{^isguru}', "");
    Expect(0, 43065, '\P{isguru}', "");
    Expect(1, 43065, '\P{^isguru}', "");
    Expect(0, 43066, '\p{isguru}', "");
    Expect(1, 43066, '\p{^isguru}', "");
    Expect(1, 43066, '\P{isguru}', "");
    Expect(0, 43066, '\P{^isguru}', "");
    Expect(1, 43065, '\p{	-is_guru}', "");
    Expect(0, 43065, '\p{^	-is_guru}', "");
    Expect(0, 43065, '\P{	-is_guru}', "");
    Expect(1, 43065, '\P{^	-is_guru}', "");
    Expect(0, 43066, '\p{	-is_guru}', "");
    Expect(1, 43066, '\p{^	-is_guru}', "");
    Expect(1, 43066, '\P{	-is_guru}', "");
    Expect(0, 43066, '\P{^	-is_guru}', "");
    Error('\p{  Halfwidth_AND_Fullwidth_forms:=}');
    Error('\P{  Halfwidth_AND_Fullwidth_forms:=}');
    Expect(1, 65519, '\p{halfwidthandfullwidthforms}', "");
    Expect(0, 65519, '\p{^halfwidthandfullwidthforms}', "");
    Expect(0, 65519, '\P{halfwidthandfullwidthforms}', "");
    Expect(1, 65519, '\P{^halfwidthandfullwidthforms}', "");
    Expect(0, 65520, '\p{halfwidthandfullwidthforms}', "");
    Expect(1, 65520, '\p{^halfwidthandfullwidthforms}', "");
    Expect(1, 65520, '\P{halfwidthandfullwidthforms}', "");
    Expect(0, 65520, '\P{^halfwidthandfullwidthforms}', "");
    Expect(1, 65519, '\p{ Halfwidth_And_FULLWIDTH_Forms}', "");
    Expect(0, 65519, '\p{^ Halfwidth_And_FULLWIDTH_Forms}', "");
    Expect(0, 65519, '\P{ Halfwidth_And_FULLWIDTH_Forms}', "");
    Expect(1, 65519, '\P{^ Halfwidth_And_FULLWIDTH_Forms}', "");
    Expect(0, 65520, '\p{ Halfwidth_And_FULLWIDTH_Forms}', "");
    Expect(1, 65520, '\p{^ Halfwidth_And_FULLWIDTH_Forms}', "");
    Expect(1, 65520, '\P{ Halfwidth_And_FULLWIDTH_Forms}', "");
    Expect(0, 65520, '\P{^ Halfwidth_And_FULLWIDTH_Forms}', "");
    Error('\p{- is_Halfwidth_And_fullwidth_Forms:=}');
    Error('\P{- is_Halfwidth_And_fullwidth_Forms:=}');
    Expect(1, 65519, '\p{ishalfwidthandfullwidthforms}', "");
    Expect(0, 65519, '\p{^ishalfwidthandfullwidthforms}', "");
    Expect(0, 65519, '\P{ishalfwidthandfullwidthforms}', "");
    Expect(1, 65519, '\P{^ishalfwidthandfullwidthforms}', "");
    Expect(0, 65520, '\p{ishalfwidthandfullwidthforms}', "");
    Expect(1, 65520, '\p{^ishalfwidthandfullwidthforms}', "");
    Expect(1, 65520, '\P{ishalfwidthandfullwidthforms}', "");
    Expect(0, 65520, '\P{^ishalfwidthandfullwidthforms}', "");
    Expect(1, 65519, '\p{		IS_Halfwidth_And_Fullwidth_Forms}', "");
    Expect(0, 65519, '\p{^		IS_Halfwidth_And_Fullwidth_Forms}', "");
    Expect(0, 65519, '\P{		IS_Halfwidth_And_Fullwidth_Forms}', "");
    Expect(1, 65519, '\P{^		IS_Halfwidth_And_Fullwidth_Forms}', "");
    Expect(0, 65520, '\p{		IS_Halfwidth_And_Fullwidth_Forms}', "");
    Expect(1, 65520, '\p{^		IS_Halfwidth_And_Fullwidth_Forms}', "");
    Expect(1, 65520, '\P{		IS_Halfwidth_And_Fullwidth_Forms}', "");
    Expect(0, 65520, '\P{^		IS_Halfwidth_And_Fullwidth_Forms}', "");
    Error('\p{-/a/In_HALFWIDTH_AND_FULLWIDTH_FORMS}');
    Error('\P{-/a/In_HALFWIDTH_AND_FULLWIDTH_FORMS}');
    Expect(1, 65519, '\p{inhalfwidthandfullwidthforms}', "");
    Expect(0, 65519, '\p{^inhalfwidthandfullwidthforms}', "");
    Expect(0, 65519, '\P{inhalfwidthandfullwidthforms}', "");
    Expect(1, 65519, '\P{^inhalfwidthandfullwidthforms}', "");
    Expect(0, 65520, '\p{inhalfwidthandfullwidthforms}', "");
    Expect(1, 65520, '\p{^inhalfwidthandfullwidthforms}', "");
    Expect(1, 65520, '\P{inhalfwidthandfullwidthforms}', "");
    Expect(0, 65520, '\P{^inhalfwidthandfullwidthforms}', "");
    Expect(1, 65519, '\p{	_IN_Halfwidth_and_Fullwidth_Forms}', "");
    Expect(0, 65519, '\p{^	_IN_Halfwidth_and_Fullwidth_Forms}', "");
    Expect(0, 65519, '\P{	_IN_Halfwidth_and_Fullwidth_Forms}', "");
    Expect(1, 65519, '\P{^	_IN_Halfwidth_and_Fullwidth_Forms}', "");
    Expect(0, 65520, '\p{	_IN_Halfwidth_and_Fullwidth_Forms}', "");
    Expect(1, 65520, '\p{^	_IN_Halfwidth_and_Fullwidth_Forms}', "");
    Expect(1, 65520, '\P{	_IN_Halfwidth_and_Fullwidth_Forms}', "");
    Expect(0, 65520, '\P{^	_IN_Halfwidth_and_Fullwidth_Forms}', "");
    Error('\p{/a/_half_and_full_forms}');
    Error('\P{/a/_half_and_full_forms}');
    Expect(1, 65519, '\p{halfandfullforms}', "");
    Expect(0, 65519, '\p{^halfandfullforms}', "");
    Expect(0, 65519, '\P{halfandfullforms}', "");
    Expect(1, 65519, '\P{^halfandfullforms}', "");
    Expect(0, 65520, '\p{halfandfullforms}', "");
    Expect(1, 65520, '\p{^halfandfullforms}', "");
    Expect(1, 65520, '\P{halfandfullforms}', "");
    Expect(0, 65520, '\P{^halfandfullforms}', "");
    Expect(1, 65519, '\p{	-HALF_And_FULL_forms}', "");
    Expect(0, 65519, '\p{^	-HALF_And_FULL_forms}', "");
    Expect(0, 65519, '\P{	-HALF_And_FULL_forms}', "");
    Expect(1, 65519, '\P{^	-HALF_And_FULL_forms}', "");
    Expect(0, 65520, '\p{	-HALF_And_FULL_forms}', "");
    Expect(1, 65520, '\p{^	-HALF_And_FULL_forms}', "");
    Expect(1, 65520, '\P{	-HALF_And_FULL_forms}', "");
    Expect(0, 65520, '\P{^	-HALF_And_FULL_forms}', "");
    Error('\p{is_half_AND_Full_forms/a/}');
    Error('\P{is_half_AND_Full_forms/a/}');
    Expect(1, 65519, '\p{ishalfandfullforms}', "");
    Expect(0, 65519, '\p{^ishalfandfullforms}', "");
    Expect(0, 65519, '\P{ishalfandfullforms}', "");
    Expect(1, 65519, '\P{^ishalfandfullforms}', "");
    Expect(0, 65520, '\p{ishalfandfullforms}', "");
    Expect(1, 65520, '\p{^ishalfandfullforms}', "");
    Expect(1, 65520, '\P{ishalfandfullforms}', "");
    Expect(0, 65520, '\P{^ishalfandfullforms}', "");
    Expect(1, 65519, '\p{--Is_Half_And_Full_forms}', "");
    Expect(0, 65519, '\p{^--Is_Half_And_Full_forms}', "");
    Expect(0, 65519, '\P{--Is_Half_And_Full_forms}', "");
    Expect(1, 65519, '\P{^--Is_Half_And_Full_forms}', "");
    Expect(0, 65520, '\p{--Is_Half_And_Full_forms}', "");
    Expect(1, 65520, '\p{^--Is_Half_And_Full_forms}', "");
    Expect(1, 65520, '\P{--Is_Half_And_Full_forms}', "");
    Expect(0, 65520, '\P{^--Is_Half_And_Full_forms}', "");
    Error('\p{	:=In_HALF_And_full_Forms}');
    Error('\P{	:=In_HALF_And_full_Forms}');
    Expect(1, 65519, '\p{inhalfandfullforms}', "");
    Expect(0, 65519, '\p{^inhalfandfullforms}', "");
    Expect(0, 65519, '\P{inhalfandfullforms}', "");
    Expect(1, 65519, '\P{^inhalfandfullforms}', "");
    Expect(0, 65520, '\p{inhalfandfullforms}', "");
    Expect(1, 65520, '\p{^inhalfandfullforms}', "");
    Expect(1, 65520, '\P{inhalfandfullforms}', "");
    Expect(0, 65520, '\P{^inhalfandfullforms}', "");
    Expect(1, 65519, '\p{--IN_HALF_and_FULL_forms}', "");
    Expect(0, 65519, '\p{^--IN_HALF_and_FULL_forms}', "");
    Expect(0, 65519, '\P{--IN_HALF_and_FULL_forms}', "");
    Expect(1, 65519, '\P{^--IN_HALF_and_FULL_forms}', "");
    Expect(0, 65520, '\p{--IN_HALF_and_FULL_forms}', "");
    Expect(1, 65520, '\p{^--IN_HALF_and_FULL_forms}', "");
    Expect(1, 65520, '\P{--IN_HALF_and_FULL_forms}', "");
    Expect(0, 65520, '\P{^--IN_HALF_and_FULL_forms}', "");
    Error('\p{:= HAN}');
    Error('\P{:= HAN}');
    Expect(1, 201546, '\p{han}', "");
    Expect(0, 201546, '\p{^han}', "");
    Expect(0, 201546, '\P{han}', "");
    Expect(1, 201546, '\P{^han}', "");
    Expect(0, 201547, '\p{han}', "");
    Expect(1, 201547, '\p{^han}', "");
    Expect(1, 201547, '\P{han}', "");
    Expect(0, 201547, '\P{^han}', "");
    Expect(1, 201546, '\p{		han}', "");
    Expect(0, 201546, '\p{^		han}', "");
    Expect(0, 201546, '\P{		han}', "");
    Expect(1, 201546, '\P{^		han}', "");
    Expect(0, 201547, '\p{		han}', "");
    Expect(1, 201547, '\p{^		han}', "");
    Expect(1, 201547, '\P{		han}', "");
    Expect(0, 201547, '\P{^		han}', "");
    Error('\p{-is_HAN/a/}');
    Error('\P{-is_HAN/a/}');
    Expect(1, 201546, '\p{ishan}', "");
    Expect(0, 201546, '\p{^ishan}', "");
    Expect(0, 201546, '\P{ishan}', "");
    Expect(1, 201546, '\P{^ishan}', "");
    Expect(0, 201547, '\p{ishan}', "");
    Expect(1, 201547, '\p{^ishan}', "");
    Expect(1, 201547, '\P{ishan}', "");
    Expect(0, 201547, '\P{^ishan}', "");
    Expect(1, 201546, '\p{  is_Han}', "");
    Expect(0, 201546, '\p{^  is_Han}', "");
    Expect(0, 201546, '\P{  is_Han}', "");
    Expect(1, 201546, '\P{^  is_Han}', "");
    Expect(0, 201547, '\p{  is_Han}', "");
    Expect(1, 201547, '\p{^  is_Han}', "");
    Expect(1, 201547, '\P{  is_Han}', "");
    Expect(0, 201547, '\P{^  is_Han}', "");
    Error('\p{:=_ HANI}');
    Error('\P{:=_ HANI}');
    Expect(1, 201546, '\p{hani}', "");
    Expect(0, 201546, '\p{^hani}', "");
    Expect(0, 201546, '\P{hani}', "");
    Expect(1, 201546, '\P{^hani}', "");
    Expect(0, 201547, '\p{hani}', "");
    Expect(1, 201547, '\p{^hani}', "");
    Expect(1, 201547, '\P{hani}', "");
    Expect(0, 201547, '\P{^hani}', "");
    Expect(1, 201546, '\p{_	Hani}', "");
    Expect(0, 201546, '\p{^_	Hani}', "");
    Expect(0, 201546, '\P{_	Hani}', "");
    Expect(1, 201546, '\P{^_	Hani}', "");
    Expect(0, 201547, '\p{_	Hani}', "");
    Expect(1, 201547, '\p{^_	Hani}', "");
    Expect(1, 201547, '\P{_	Hani}', "");
    Expect(0, 201547, '\P{^_	Hani}', "");
    Error('\p{/a/__IS_HANI}');
    Error('\P{/a/__IS_HANI}');
    Expect(1, 201546, '\p{ishani}', "");
    Expect(0, 201546, '\p{^ishani}', "");
    Expect(0, 201546, '\P{ishani}', "");
    Expect(1, 201546, '\P{^ishani}', "");
    Expect(0, 201547, '\p{ishani}', "");
    Expect(1, 201547, '\p{^ishani}', "");
    Expect(1, 201547, '\P{ishani}', "");
    Expect(0, 201547, '\P{^ishani}', "");
    Expect(1, 201546, '\p{ _Is_Hani}', "");
    Expect(0, 201546, '\p{^ _Is_Hani}', "");
    Expect(0, 201546, '\P{ _Is_Hani}', "");
    Expect(1, 201546, '\P{^ _Is_Hani}', "");
    Expect(0, 201547, '\p{ _Is_Hani}', "");
    Expect(1, 201547, '\p{^ _Is_Hani}', "");
    Expect(1, 201547, '\P{ _Is_Hani}', "");
    Expect(0, 201547, '\P{^ _Is_Hani}', "");
    Error('\p{	/a/Hangul}');
    Error('\P{	/a/Hangul}');
    Expect(1, 65500, '\p{hangul}', "");
    Expect(0, 65500, '\p{^hangul}', "");
    Expect(0, 65500, '\P{hangul}', "");
    Expect(1, 65500, '\P{^hangul}', "");
    Expect(0, 65501, '\p{hangul}', "");
    Expect(1, 65501, '\p{^hangul}', "");
    Expect(1, 65501, '\P{hangul}', "");
    Expect(0, 65501, '\P{^hangul}', "");
    Expect(1, 65500, '\p{ _hangul}', "");
    Expect(0, 65500, '\p{^ _hangul}', "");
    Expect(0, 65500, '\P{ _hangul}', "");
    Expect(1, 65500, '\P{^ _hangul}', "");
    Expect(0, 65501, '\p{ _hangul}', "");
    Expect(1, 65501, '\p{^ _hangul}', "");
    Expect(1, 65501, '\P{ _hangul}', "");
    Expect(0, 65501, '\P{^ _hangul}', "");
    Error('\p{/a/  Is_HANGUL}');
    Error('\P{/a/  Is_HANGUL}');
    Expect(1, 65500, '\p{ishangul}', "");
    Expect(0, 65500, '\p{^ishangul}', "");
    Expect(0, 65500, '\P{ishangul}', "");
    Expect(1, 65500, '\P{^ishangul}', "");
    Expect(0, 65501, '\p{ishangul}', "");
    Expect(1, 65501, '\p{^ishangul}', "");
    Expect(1, 65501, '\P{ishangul}', "");
    Expect(0, 65501, '\P{^ishangul}', "");
    Expect(1, 65500, '\p{-	Is_Hangul}', "");
    Expect(0, 65500, '\p{^-	Is_Hangul}', "");
    Expect(0, 65500, '\P{-	Is_Hangul}', "");
    Expect(1, 65500, '\P{^-	Is_Hangul}', "");
    Expect(0, 65501, '\p{-	Is_Hangul}', "");
    Expect(1, 65501, '\p{^-	Is_Hangul}', "");
    Expect(1, 65501, '\P{-	Is_Hangul}', "");
    Expect(0, 65501, '\P{^-	Is_Hangul}', "");
    Error('\p{ :=hang}');
    Error('\P{ :=hang}');
    Expect(1, 65500, '\p{hang}', "");
    Expect(0, 65500, '\p{^hang}', "");
    Expect(0, 65500, '\P{hang}', "");
    Expect(1, 65500, '\P{^hang}', "");
    Expect(0, 65501, '\p{hang}', "");
    Expect(1, 65501, '\p{^hang}', "");
    Expect(1, 65501, '\P{hang}', "");
    Expect(0, 65501, '\P{^hang}', "");
    Expect(1, 65500, '\p{_hang}', "");
    Expect(0, 65500, '\p{^_hang}', "");
    Expect(0, 65500, '\P{_hang}', "");
    Expect(1, 65500, '\P{^_hang}', "");
    Expect(0, 65501, '\p{_hang}', "");
    Expect(1, 65501, '\p{^_hang}', "");
    Expect(1, 65501, '\P{_hang}', "");
    Expect(0, 65501, '\P{^_hang}', "");
    Error('\p{- IS_Hang/a/}');
    Error('\P{- IS_Hang/a/}');
    Expect(1, 65500, '\p{ishang}', "");
    Expect(0, 65500, '\p{^ishang}', "");
    Expect(0, 65500, '\P{ishang}', "");
    Expect(1, 65500, '\P{^ishang}', "");
    Expect(0, 65501, '\p{ishang}', "");
    Expect(1, 65501, '\p{^ishang}', "");
    Expect(1, 65501, '\P{ishang}', "");
    Expect(0, 65501, '\P{^ishang}', "");
    Expect(1, 65500, '\p{_-Is_hang}', "");
    Expect(0, 65500, '\p{^_-Is_hang}', "");
    Expect(0, 65500, '\P{_-Is_hang}', "");
    Expect(1, 65500, '\P{^_-Is_hang}', "");
    Expect(0, 65501, '\p{_-Is_hang}', "");
    Expect(1, 65501, '\p{^_-Is_hang}', "");
    Expect(1, 65501, '\P{_-Is_hang}', "");
    Expect(0, 65501, '\P{^_-Is_hang}', "");
    Error('\p{_:=Hangul_Compatibility_Jamo}');
    Error('\P{_:=Hangul_Compatibility_Jamo}');
    Expect(1, 12687, '\p{hangulcompatibilityjamo}', "");
    Expect(0, 12687, '\p{^hangulcompatibilityjamo}', "");
    Expect(0, 12687, '\P{hangulcompatibilityjamo}', "");
    Expect(1, 12687, '\P{^hangulcompatibilityjamo}', "");
    Expect(0, 12688, '\p{hangulcompatibilityjamo}', "");
    Expect(1, 12688, '\p{^hangulcompatibilityjamo}', "");
    Expect(1, 12688, '\P{hangulcompatibilityjamo}', "");
    Expect(0, 12688, '\P{^hangulcompatibilityjamo}', "");
    Expect(1, 12687, '\p{_HANGUL_COMPATIBILITY_Jamo}', "");
    Expect(0, 12687, '\p{^_HANGUL_COMPATIBILITY_Jamo}', "");
    Expect(0, 12687, '\P{_HANGUL_COMPATIBILITY_Jamo}', "");
    Expect(1, 12687, '\P{^_HANGUL_COMPATIBILITY_Jamo}', "");
    Expect(0, 12688, '\p{_HANGUL_COMPATIBILITY_Jamo}', "");
    Expect(1, 12688, '\p{^_HANGUL_COMPATIBILITY_Jamo}', "");
    Expect(1, 12688, '\P{_HANGUL_COMPATIBILITY_Jamo}', "");
    Expect(0, 12688, '\P{^_HANGUL_COMPATIBILITY_Jamo}', "");
    Error('\p{-_IS_HANGUL_COMPATIBILITY_Jamo:=}');
    Error('\P{-_IS_HANGUL_COMPATIBILITY_Jamo:=}');
    Expect(1, 12687, '\p{ishangulcompatibilityjamo}', "");
    Expect(0, 12687, '\p{^ishangulcompatibilityjamo}', "");
    Expect(0, 12687, '\P{ishangulcompatibilityjamo}', "");
    Expect(1, 12687, '\P{^ishangulcompatibilityjamo}', "");
    Expect(0, 12688, '\p{ishangulcompatibilityjamo}', "");
    Expect(1, 12688, '\p{^ishangulcompatibilityjamo}', "");
    Expect(1, 12688, '\P{ishangulcompatibilityjamo}', "");
    Expect(0, 12688, '\P{^ishangulcompatibilityjamo}', "");
    Expect(1, 12687, '\p{	_Is_hangul_compatibility_jamo}', "");
    Expect(0, 12687, '\p{^	_Is_hangul_compatibility_jamo}', "");
    Expect(0, 12687, '\P{	_Is_hangul_compatibility_jamo}', "");
    Expect(1, 12687, '\P{^	_Is_hangul_compatibility_jamo}', "");
    Expect(0, 12688, '\p{	_Is_hangul_compatibility_jamo}', "");
    Expect(1, 12688, '\p{^	_Is_hangul_compatibility_jamo}', "");
    Expect(1, 12688, '\P{	_Is_hangul_compatibility_jamo}', "");
    Expect(0, 12688, '\P{^	_Is_hangul_compatibility_jamo}', "");
    Error('\p{:= IN_HANGUL_Compatibility_JAMO}');
    Error('\P{:= IN_HANGUL_Compatibility_JAMO}');
    Expect(1, 12687, '\p{inhangulcompatibilityjamo}', "");
    Expect(0, 12687, '\p{^inhangulcompatibilityjamo}', "");
    Expect(0, 12687, '\P{inhangulcompatibilityjamo}', "");
    Expect(1, 12687, '\P{^inhangulcompatibilityjamo}', "");
    Expect(0, 12688, '\p{inhangulcompatibilityjamo}', "");
    Expect(1, 12688, '\p{^inhangulcompatibilityjamo}', "");
    Expect(1, 12688, '\P{inhangulcompatibilityjamo}', "");
    Expect(0, 12688, '\P{^inhangulcompatibilityjamo}', "");
    Expect(1, 12687, '\p{ 	In_Hangul_Compatibility_jamo}', "");
    Expect(0, 12687, '\p{^ 	In_Hangul_Compatibility_jamo}', "");
    Expect(0, 12687, '\P{ 	In_Hangul_Compatibility_jamo}', "");
    Expect(1, 12687, '\P{^ 	In_Hangul_Compatibility_jamo}', "");
    Expect(0, 12688, '\p{ 	In_Hangul_Compatibility_jamo}', "");
    Expect(1, 12688, '\p{^ 	In_Hangul_Compatibility_jamo}', "");
    Expect(1, 12688, '\P{ 	In_Hangul_Compatibility_jamo}', "");
    Expect(0, 12688, '\P{^ 	In_Hangul_Compatibility_jamo}', "");
    Error('\p{	compat_Jamo:=}');
    Error('\P{	compat_Jamo:=}');
    Expect(1, 12687, '\p{compatjamo}', "");
    Expect(0, 12687, '\p{^compatjamo}', "");
    Expect(0, 12687, '\P{compatjamo}', "");
    Expect(1, 12687, '\P{^compatjamo}', "");
    Expect(0, 12688, '\p{compatjamo}', "");
    Expect(1, 12688, '\p{^compatjamo}', "");
    Expect(1, 12688, '\P{compatjamo}', "");
    Expect(0, 12688, '\P{^compatjamo}', "");
    Expect(1, 12687, '\p{--COMPAT_JAMO}', "");
    Expect(0, 12687, '\p{^--COMPAT_JAMO}', "");
    Expect(0, 12687, '\P{--COMPAT_JAMO}', "");
    Expect(1, 12687, '\P{^--COMPAT_JAMO}', "");
    Expect(0, 12688, '\p{--COMPAT_JAMO}', "");
    Expect(1, 12688, '\p{^--COMPAT_JAMO}', "");
    Expect(1, 12688, '\P{--COMPAT_JAMO}', "");
    Expect(0, 12688, '\P{^--COMPAT_JAMO}', "");
    Error('\p{_Is_Compat_JAMO/a/}');
    Error('\P{_Is_Compat_JAMO/a/}');
    Expect(1, 12687, '\p{iscompatjamo}', "");
    Expect(0, 12687, '\p{^iscompatjamo}', "");
    Expect(0, 12687, '\P{iscompatjamo}', "");
    Expect(1, 12687, '\P{^iscompatjamo}', "");
    Expect(0, 12688, '\p{iscompatjamo}', "");
    Expect(1, 12688, '\p{^iscompatjamo}', "");
    Expect(1, 12688, '\P{iscompatjamo}', "");
    Expect(0, 12688, '\P{^iscompatjamo}', "");
    Expect(1, 12687, '\p{	-Is_compat_Jamo}', "");
    Expect(0, 12687, '\p{^	-Is_compat_Jamo}', "");
    Expect(0, 12687, '\P{	-Is_compat_Jamo}', "");
    Expect(1, 12687, '\P{^	-Is_compat_Jamo}', "");
    Expect(0, 12688, '\p{	-Is_compat_Jamo}', "");
    Expect(1, 12688, '\p{^	-Is_compat_Jamo}', "");
    Expect(1, 12688, '\P{	-Is_compat_Jamo}', "");
    Expect(0, 12688, '\P{^	-Is_compat_Jamo}', "");
    Error('\p{__In_COMPAT_Jamo/a/}');
    Error('\P{__In_COMPAT_Jamo/a/}');
    Expect(1, 12687, '\p{incompatjamo}', "");
    Expect(0, 12687, '\p{^incompatjamo}', "");
    Expect(0, 12687, '\P{incompatjamo}', "");
    Expect(1, 12687, '\P{^incompatjamo}', "");
    Expect(0, 12688, '\p{incompatjamo}', "");
    Expect(1, 12688, '\p{^incompatjamo}', "");
    Expect(1, 12688, '\P{incompatjamo}', "");
    Expect(0, 12688, '\P{^incompatjamo}', "");
    Expect(1, 12687, '\p{-In_Compat_Jamo}', "");
    Expect(0, 12687, '\p{^-In_Compat_Jamo}', "");
    Expect(0, 12687, '\P{-In_Compat_Jamo}', "");
    Expect(1, 12687, '\P{^-In_Compat_Jamo}', "");
    Expect(0, 12688, '\p{-In_Compat_Jamo}', "");
    Expect(1, 12688, '\p{^-In_Compat_Jamo}', "");
    Expect(1, 12688, '\P{-In_Compat_Jamo}', "");
    Expect(0, 12688, '\P{^-In_Compat_Jamo}', "");
    Error('\p{ Hangul_Jamo:=}');
    Error('\P{ Hangul_Jamo:=}');
    Expect(1, 4607, '\p{hanguljamo}', "");
    Expect(0, 4607, '\p{^hanguljamo}', "");
    Expect(0, 4607, '\P{hanguljamo}', "");
    Expect(1, 4607, '\P{^hanguljamo}', "");
    Expect(0, 4608, '\p{hanguljamo}', "");
    Expect(1, 4608, '\p{^hanguljamo}', "");
    Expect(1, 4608, '\P{hanguljamo}', "");
    Expect(0, 4608, '\P{^hanguljamo}', "");
    Expect(1, 4607, '\p{ hangul_Jamo}', "");
    Expect(0, 4607, '\p{^ hangul_Jamo}', "");
    Expect(0, 4607, '\P{ hangul_Jamo}', "");
    Expect(1, 4607, '\P{^ hangul_Jamo}', "");
    Expect(0, 4608, '\p{ hangul_Jamo}', "");
    Expect(1, 4608, '\p{^ hangul_Jamo}', "");
    Expect(1, 4608, '\P{ hangul_Jamo}', "");
    Expect(0, 4608, '\P{^ hangul_Jamo}', "");
    Error('\p{ :=Is_hangul_Jamo}');
    Error('\P{ :=Is_hangul_Jamo}');
    Expect(1, 4607, '\p{ishanguljamo}', "");
    Expect(0, 4607, '\p{^ishanguljamo}', "");
    Expect(0, 4607, '\P{ishanguljamo}', "");
    Expect(1, 4607, '\P{^ishanguljamo}', "");
    Expect(0, 4608, '\p{ishanguljamo}', "");
    Expect(1, 4608, '\p{^ishanguljamo}', "");
    Expect(1, 4608, '\P{ishanguljamo}', "");
    Expect(0, 4608, '\P{^ishanguljamo}', "");
    Expect(1, 4607, '\p{Is_Hangul_jamo}', "");
    Expect(0, 4607, '\p{^Is_Hangul_jamo}', "");
    Expect(0, 4607, '\P{Is_Hangul_jamo}', "");
    Expect(1, 4607, '\P{^Is_Hangul_jamo}', "");
    Expect(0, 4608, '\p{Is_Hangul_jamo}', "");
    Expect(1, 4608, '\p{^Is_Hangul_jamo}', "");
    Expect(1, 4608, '\P{Is_Hangul_jamo}', "");
    Expect(0, 4608, '\P{^Is_Hangul_jamo}', "");
    Error('\p{-in_HANGUL_JAMO/a/}');
    Error('\P{-in_HANGUL_JAMO/a/}');
    Expect(1, 4607, '\p{inhanguljamo}', "");
    Expect(0, 4607, '\p{^inhanguljamo}', "");
    Expect(0, 4607, '\P{inhanguljamo}', "");
    Expect(1, 4607, '\P{^inhanguljamo}', "");
    Expect(0, 4608, '\p{inhanguljamo}', "");
    Expect(1, 4608, '\p{^inhanguljamo}', "");
    Expect(1, 4608, '\P{inhanguljamo}', "");
    Expect(0, 4608, '\P{^inhanguljamo}', "");
    Expect(1, 4607, '\p{	-In_Hangul_jamo}', "");
    Expect(0, 4607, '\p{^	-In_Hangul_jamo}', "");
    Expect(0, 4607, '\P{	-In_Hangul_jamo}', "");
    Expect(1, 4607, '\P{^	-In_Hangul_jamo}', "");
    Expect(0, 4608, '\p{	-In_Hangul_jamo}', "");
    Expect(1, 4608, '\p{^	-In_Hangul_jamo}', "");
    Expect(1, 4608, '\P{	-In_Hangul_jamo}', "");
    Expect(0, 4608, '\P{^	-In_Hangul_jamo}', "");
    Error('\p{-	Jamo/a/}');
    Error('\P{-	Jamo/a/}');
    Expect(1, 4607, '\p{jamo}', "");
    Expect(0, 4607, '\p{^jamo}', "");
    Expect(0, 4607, '\P{jamo}', "");
    Expect(1, 4607, '\P{^jamo}', "");
    Expect(0, 4608, '\p{jamo}', "");
    Expect(1, 4608, '\p{^jamo}', "");
    Expect(1, 4608, '\P{jamo}', "");
    Expect(0, 4608, '\P{^jamo}', "");
    Expect(1, 4607, '\p{	-JAMO}', "");
    Expect(0, 4607, '\p{^	-JAMO}', "");
    Expect(0, 4607, '\P{	-JAMO}', "");
    Expect(1, 4607, '\P{^	-JAMO}', "");
    Expect(0, 4608, '\p{	-JAMO}', "");
    Expect(1, 4608, '\p{^	-JAMO}', "");
    Expect(1, 4608, '\P{	-JAMO}', "");
    Expect(0, 4608, '\P{^	-JAMO}', "");
    Error('\p{/a/	 is_jamo}');
    Error('\P{/a/	 is_jamo}');
    Expect(1, 4607, '\p{isjamo}', "");
    Expect(0, 4607, '\p{^isjamo}', "");
    Expect(0, 4607, '\P{isjamo}', "");
    Expect(1, 4607, '\P{^isjamo}', "");
    Expect(0, 4608, '\p{isjamo}', "");
    Expect(1, 4608, '\p{^isjamo}', "");
    Expect(1, 4608, '\P{isjamo}', "");
    Expect(0, 4608, '\P{^isjamo}', "");
    Expect(1, 4607, '\p{	-IS_jamo}', "");
    Expect(0, 4607, '\p{^	-IS_jamo}', "");
    Expect(0, 4607, '\P{	-IS_jamo}', "");
    Expect(1, 4607, '\P{^	-IS_jamo}', "");
    Expect(0, 4608, '\p{	-IS_jamo}', "");
    Expect(1, 4608, '\p{^	-IS_jamo}', "");
    Expect(1, 4608, '\P{	-IS_jamo}', "");
    Expect(0, 4608, '\P{^	-IS_jamo}', "");
    Error('\p{_in_jamo:=}');
    Error('\P{_in_jamo:=}');
    Expect(1, 4607, '\p{injamo}', "");
    Expect(0, 4607, '\p{^injamo}', "");
    Expect(0, 4607, '\P{injamo}', "");
    Expect(1, 4607, '\P{^injamo}', "");
    Expect(0, 4608, '\p{injamo}', "");
    Expect(1, 4608, '\p{^injamo}', "");
    Expect(1, 4608, '\P{injamo}', "");
    Expect(0, 4608, '\P{^injamo}', "");
    Expect(1, 4607, '\p{	in_jamo}', "");
    Expect(0, 4607, '\p{^	in_jamo}', "");
    Expect(0, 4607, '\P{	in_jamo}', "");
    Expect(1, 4607, '\P{^	in_jamo}', "");
    Expect(0, 4608, '\p{	in_jamo}', "");
    Expect(1, 4608, '\p{^	in_jamo}', "");
    Expect(1, 4608, '\P{	in_jamo}', "");
    Expect(0, 4608, '\P{^	in_jamo}', "");
    Error('\p{	Hangul_Jamo_Extended_A:=}');
    Error('\P{	Hangul_Jamo_Extended_A:=}');
    Expect(1, 43391, '\p{hanguljamoextendeda}', "");
    Expect(0, 43391, '\p{^hanguljamoextendeda}', "");
    Expect(0, 43391, '\P{hanguljamoextendeda}', "");
    Expect(1, 43391, '\P{^hanguljamoextendeda}', "");
    Expect(0, 43392, '\p{hanguljamoextendeda}', "");
    Expect(1, 43392, '\p{^hanguljamoextendeda}', "");
    Expect(1, 43392, '\P{hanguljamoextendeda}', "");
    Expect(0, 43392, '\P{^hanguljamoextendeda}', "");
    Expect(1, 43391, '\p{	 Hangul_Jamo_Extended_A}', "");
    Expect(0, 43391, '\p{^	 Hangul_Jamo_Extended_A}', "");
    Expect(0, 43391, '\P{	 Hangul_Jamo_Extended_A}', "");
    Expect(1, 43391, '\P{^	 Hangul_Jamo_Extended_A}', "");
    Expect(0, 43392, '\p{	 Hangul_Jamo_Extended_A}', "");
    Expect(1, 43392, '\p{^	 Hangul_Jamo_Extended_A}', "");
    Expect(1, 43392, '\P{	 Hangul_Jamo_Extended_A}', "");
    Expect(0, 43392, '\P{^	 Hangul_Jamo_Extended_A}', "");
    Error('\p{/a/- Is_Hangul_Jamo_Extended_a}');
    Error('\P{/a/- Is_Hangul_Jamo_Extended_a}');
    Expect(1, 43391, '\p{ishanguljamoextendeda}', "");
    Expect(0, 43391, '\p{^ishanguljamoextendeda}', "");
    Expect(0, 43391, '\P{ishanguljamoextendeda}', "");
    Expect(1, 43391, '\P{^ishanguljamoextendeda}', "");
    Expect(0, 43392, '\p{ishanguljamoextendeda}', "");
    Expect(1, 43392, '\p{^ishanguljamoextendeda}', "");
    Expect(1, 43392, '\P{ishanguljamoextendeda}', "");
    Expect(0, 43392, '\P{^ishanguljamoextendeda}', "");
    Expect(1, 43391, '\p{	Is_Hangul_jamo_extended_A}', "");
    Expect(0, 43391, '\p{^	Is_Hangul_jamo_extended_A}', "");
    Expect(0, 43391, '\P{	Is_Hangul_jamo_extended_A}', "");
    Expect(1, 43391, '\P{^	Is_Hangul_jamo_extended_A}', "");
    Expect(0, 43392, '\p{	Is_Hangul_jamo_extended_A}', "");
    Expect(1, 43392, '\p{^	Is_Hangul_jamo_extended_A}', "");
    Expect(1, 43392, '\P{	Is_Hangul_jamo_extended_A}', "");
    Expect(0, 43392, '\P{^	Is_Hangul_jamo_extended_A}', "");
    Error('\p{- in_hangul_Jamo_extended_A:=}');
    Error('\P{- in_hangul_Jamo_extended_A:=}');
    Expect(1, 43391, '\p{inhanguljamoextendeda}', "");
    Expect(0, 43391, '\p{^inhanguljamoextendeda}', "");
    Expect(0, 43391, '\P{inhanguljamoextendeda}', "");
    Expect(1, 43391, '\P{^inhanguljamoextendeda}', "");
    Expect(0, 43392, '\p{inhanguljamoextendeda}', "");
    Expect(1, 43392, '\p{^inhanguljamoextendeda}', "");
    Expect(1, 43392, '\P{inhanguljamoextendeda}', "");
    Expect(0, 43392, '\P{^inhanguljamoextendeda}', "");
    Expect(1, 43391, '\p{-In_Hangul_JAMO_Extended_A}', "");
    Expect(0, 43391, '\p{^-In_Hangul_JAMO_Extended_A}', "");
    Expect(0, 43391, '\P{-In_Hangul_JAMO_Extended_A}', "");
    Expect(1, 43391, '\P{^-In_Hangul_JAMO_Extended_A}', "");
    Expect(0, 43392, '\p{-In_Hangul_JAMO_Extended_A}', "");
    Expect(1, 43392, '\p{^-In_Hangul_JAMO_Extended_A}', "");
    Expect(1, 43392, '\P{-In_Hangul_JAMO_Extended_A}', "");
    Expect(0, 43392, '\P{^-In_Hangul_JAMO_Extended_A}', "");
    Error('\p{/a/_	jamo_Ext_A}');
    Error('\P{/a/_	jamo_Ext_A}');
    Expect(1, 43391, '\p{jamoexta}', "");
    Expect(0, 43391, '\p{^jamoexta}', "");
    Expect(0, 43391, '\P{jamoexta}', "");
    Expect(1, 43391, '\P{^jamoexta}', "");
    Expect(0, 43392, '\p{jamoexta}', "");
    Expect(1, 43392, '\p{^jamoexta}', "");
    Expect(1, 43392, '\P{jamoexta}', "");
    Expect(0, 43392, '\P{^jamoexta}', "");
    Expect(1, 43391, '\p{	_JAMO_Ext_A}', "");
    Expect(0, 43391, '\p{^	_JAMO_Ext_A}', "");
    Expect(0, 43391, '\P{	_JAMO_Ext_A}', "");
    Expect(1, 43391, '\P{^	_JAMO_Ext_A}', "");
    Expect(0, 43392, '\p{	_JAMO_Ext_A}', "");
    Expect(1, 43392, '\p{^	_JAMO_Ext_A}', "");
    Expect(1, 43392, '\P{	_JAMO_Ext_A}', "");
    Expect(0, 43392, '\P{^	_JAMO_Ext_A}', "");
    Error('\p{:=_IS_Jamo_Ext_A}');
    Error('\P{:=_IS_Jamo_Ext_A}');
    Expect(1, 43391, '\p{isjamoexta}', "");
    Expect(0, 43391, '\p{^isjamoexta}', "");
    Expect(0, 43391, '\P{isjamoexta}', "");
    Expect(1, 43391, '\P{^isjamoexta}', "");
    Expect(0, 43392, '\p{isjamoexta}', "");
    Expect(1, 43392, '\p{^isjamoexta}', "");
    Expect(1, 43392, '\P{isjamoexta}', "");
    Expect(0, 43392, '\P{^isjamoexta}', "");
    Expect(1, 43391, '\p{--Is_Jamo_Ext_A}', "");
    Expect(0, 43391, '\p{^--Is_Jamo_Ext_A}', "");
    Expect(0, 43391, '\P{--Is_Jamo_Ext_A}', "");
    Expect(1, 43391, '\P{^--Is_Jamo_Ext_A}', "");
    Expect(0, 43392, '\p{--Is_Jamo_Ext_A}', "");
    Expect(1, 43392, '\p{^--Is_Jamo_Ext_A}', "");
    Expect(1, 43392, '\P{--Is_Jamo_Ext_A}', "");
    Expect(0, 43392, '\P{^--Is_Jamo_Ext_A}', "");
    Error('\p{/a/ 	IN_jamo_Ext_A}');
    Error('\P{/a/ 	IN_jamo_Ext_A}');
    Expect(1, 43391, '\p{injamoexta}', "");
    Expect(0, 43391, '\p{^injamoexta}', "");
    Expect(0, 43391, '\P{injamoexta}', "");
    Expect(1, 43391, '\P{^injamoexta}', "");
    Expect(0, 43392, '\p{injamoexta}', "");
    Expect(1, 43392, '\p{^injamoexta}', "");
    Expect(1, 43392, '\P{injamoexta}', "");
    Expect(0, 43392, '\P{^injamoexta}', "");
    Expect(1, 43391, '\p{ 	In_JAMO_Ext_A}', "");
    Expect(0, 43391, '\p{^ 	In_JAMO_Ext_A}', "");
    Expect(0, 43391, '\P{ 	In_JAMO_Ext_A}', "");
    Expect(1, 43391, '\P{^ 	In_JAMO_Ext_A}', "");
    Expect(0, 43392, '\p{ 	In_JAMO_Ext_A}', "");
    Expect(1, 43392, '\p{^ 	In_JAMO_Ext_A}', "");
    Expect(1, 43392, '\P{ 	In_JAMO_Ext_A}', "");
    Expect(0, 43392, '\P{^ 	In_JAMO_Ext_A}', "");
    Error('\p{- Hangul_jamo_extended_b/a/}');
    Error('\P{- Hangul_jamo_extended_b/a/}');
    Expect(1, 55295, '\p{hanguljamoextendedb}', "");
    Expect(0, 55295, '\p{^hanguljamoextendedb}', "");
    Expect(0, 55295, '\P{hanguljamoextendedb}', "");
    Expect(1, 55295, '\P{^hanguljamoextendedb}', "");
    Expect(0, 57344, '\p{hanguljamoextendedb}', "");
    Expect(1, 57344, '\p{^hanguljamoextendedb}', "");
    Expect(1, 57344, '\P{hanguljamoextendedb}', "");
    Expect(0, 57344, '\P{^hanguljamoextendedb}', "");
    Expect(1, 55295, '\p{ Hangul_Jamo_Extended_B}', "");
    Expect(0, 55295, '\p{^ Hangul_Jamo_Extended_B}', "");
    Expect(0, 55295, '\P{ Hangul_Jamo_Extended_B}', "");
    Expect(1, 55295, '\P{^ Hangul_Jamo_Extended_B}', "");
    Expect(0, 57344, '\p{ Hangul_Jamo_Extended_B}', "");
    Expect(1, 57344, '\p{^ Hangul_Jamo_Extended_B}', "");
    Expect(1, 57344, '\P{ Hangul_Jamo_Extended_B}', "");
    Expect(0, 57344, '\P{^ Hangul_Jamo_Extended_B}', "");
    Error('\p{:=_Is_HANGUL_JAMO_EXTENDED_B}');
    Error('\P{:=_Is_HANGUL_JAMO_EXTENDED_B}');
    Expect(1, 55295, '\p{ishanguljamoextendedb}', "");
    Expect(0, 55295, '\p{^ishanguljamoextendedb}', "");
    Expect(0, 55295, '\P{ishanguljamoextendedb}', "");
    Expect(1, 55295, '\P{^ishanguljamoextendedb}', "");
    Expect(0, 57344, '\p{ishanguljamoextendedb}', "");
    Expect(1, 57344, '\p{^ishanguljamoextendedb}', "");
    Expect(1, 57344, '\P{ishanguljamoextendedb}', "");
    Expect(0, 57344, '\P{^ishanguljamoextendedb}', "");
    Expect(1, 55295, '\p{_Is_hangul_JAMO_Extended_b}', "");
    Expect(0, 55295, '\p{^_Is_hangul_JAMO_Extended_b}', "");
    Expect(0, 55295, '\P{_Is_hangul_JAMO_Extended_b}', "");
    Expect(1, 55295, '\P{^_Is_hangul_JAMO_Extended_b}', "");
    Expect(0, 57344, '\p{_Is_hangul_JAMO_Extended_b}', "");
    Expect(1, 57344, '\p{^_Is_hangul_JAMO_Extended_b}', "");
    Expect(1, 57344, '\P{_Is_hangul_JAMO_Extended_b}', "");
    Expect(0, 57344, '\P{^_Is_hangul_JAMO_Extended_b}', "");
    Error('\p{:=IN_Hangul_jamo_extended_B}');
    Error('\P{:=IN_Hangul_jamo_extended_B}');
    Expect(1, 55295, '\p{inhanguljamoextendedb}', "");
    Expect(0, 55295, '\p{^inhanguljamoextendedb}', "");
    Expect(0, 55295, '\P{inhanguljamoextendedb}', "");
    Expect(1, 55295, '\P{^inhanguljamoextendedb}', "");
    Expect(0, 57344, '\p{inhanguljamoextendedb}', "");
    Expect(1, 57344, '\p{^inhanguljamoextendedb}', "");
    Expect(1, 57344, '\P{inhanguljamoextendedb}', "");
    Expect(0, 57344, '\P{^inhanguljamoextendedb}', "");
    Expect(1, 55295, '\p{_in_Hangul_jamo_extended_B}', "");
    Expect(0, 55295, '\p{^_in_Hangul_jamo_extended_B}', "");
    Expect(0, 55295, '\P{_in_Hangul_jamo_extended_B}', "");
    Expect(1, 55295, '\P{^_in_Hangul_jamo_extended_B}', "");
    Expect(0, 57344, '\p{_in_Hangul_jamo_extended_B}', "");
    Expect(1, 57344, '\p{^_in_Hangul_jamo_extended_B}', "");
    Expect(1, 57344, '\P{_in_Hangul_jamo_extended_B}', "");
    Expect(0, 57344, '\P{^_in_Hangul_jamo_extended_B}', "");
    Error('\p{ /a/JAMO_ext_B}');
    Error('\P{ /a/JAMO_ext_B}');
    Expect(1, 55295, '\p{jamoextb}', "");
    Expect(0, 55295, '\p{^jamoextb}', "");
    Expect(0, 55295, '\P{jamoextb}', "");
    Expect(1, 55295, '\P{^jamoextb}', "");
    Expect(0, 57344, '\p{jamoextb}', "");
    Expect(1, 57344, '\p{^jamoextb}', "");
    Expect(1, 57344, '\P{jamoextb}', "");
    Expect(0, 57344, '\P{^jamoextb}', "");
    Expect(1, 55295, '\p{-	Jamo_ext_B}', "");
    Expect(0, 55295, '\p{^-	Jamo_ext_B}', "");
    Expect(0, 55295, '\P{-	Jamo_ext_B}', "");
    Expect(1, 55295, '\P{^-	Jamo_ext_B}', "");
    Expect(0, 57344, '\p{-	Jamo_ext_B}', "");
    Expect(1, 57344, '\p{^-	Jamo_ext_B}', "");
    Expect(1, 57344, '\P{-	Jamo_ext_B}', "");
    Expect(0, 57344, '\P{^-	Jamo_ext_B}', "");
    Error('\p{:=	is_jamo_ext_B}');
    Error('\P{:=	is_jamo_ext_B}');
    Expect(1, 55295, '\p{isjamoextb}', "");
    Expect(0, 55295, '\p{^isjamoextb}', "");
    Expect(0, 55295, '\P{isjamoextb}', "");
    Expect(1, 55295, '\P{^isjamoextb}', "");
    Expect(0, 57344, '\p{isjamoextb}', "");
    Expect(1, 57344, '\p{^isjamoextb}', "");
    Expect(1, 57344, '\P{isjamoextb}', "");
    Expect(0, 57344, '\P{^isjamoextb}', "");
    Expect(1, 55295, '\p{	IS_Jamo_ext_B}', "");
    Expect(0, 55295, '\p{^	IS_Jamo_ext_B}', "");
    Expect(0, 55295, '\P{	IS_Jamo_ext_B}', "");
    Expect(1, 55295, '\P{^	IS_Jamo_ext_B}', "");
    Expect(0, 57344, '\p{	IS_Jamo_ext_B}', "");
    Expect(1, 57344, '\p{^	IS_Jamo_ext_B}', "");
    Expect(1, 57344, '\P{	IS_Jamo_ext_B}', "");
    Expect(0, 57344, '\P{^	IS_Jamo_ext_B}', "");
    Error('\p{	-IN_jamo_Ext_B/a/}');
    Error('\P{	-IN_jamo_Ext_B/a/}');
    Expect(1, 55295, '\p{injamoextb}', "");
    Expect(0, 55295, '\p{^injamoextb}', "");
    Expect(0, 55295, '\P{injamoextb}', "");
    Expect(1, 55295, '\P{^injamoextb}', "");
    Expect(0, 57344, '\p{injamoextb}', "");
    Expect(1, 57344, '\p{^injamoextb}', "");
    Expect(1, 57344, '\P{injamoextb}', "");
    Expect(0, 57344, '\P{^injamoextb}', "");
    Expect(1, 55295, '\p{_In_Jamo_Ext_B}', "");
    Expect(0, 55295, '\p{^_In_Jamo_Ext_B}', "");
    Expect(0, 55295, '\P{_In_Jamo_Ext_B}', "");
    Expect(1, 55295, '\P{^_In_Jamo_Ext_B}', "");
    Expect(0, 57344, '\p{_In_Jamo_Ext_B}', "");
    Expect(1, 57344, '\p{^_In_Jamo_Ext_B}', "");
    Expect(1, 57344, '\P{_In_Jamo_Ext_B}', "");
    Expect(0, 57344, '\P{^_In_Jamo_Ext_B}', "");
    Error('\p{__hangul_syllables:=}');
    Error('\P{__hangul_syllables:=}');
    Expect(1, 55215, '\p{hangulsyllables}', "");
    Expect(0, 55215, '\p{^hangulsyllables}', "");
    Expect(0, 55215, '\P{hangulsyllables}', "");
    Expect(1, 55215, '\P{^hangulsyllables}', "");
    Expect(0, 55216, '\p{hangulsyllables}', "");
    Expect(1, 55216, '\p{^hangulsyllables}', "");
    Expect(1, 55216, '\P{hangulsyllables}', "");
    Expect(0, 55216, '\P{^hangulsyllables}', "");
    Expect(1, 55215, '\p{ HANGUL_syllables}', "");
    Expect(0, 55215, '\p{^ HANGUL_syllables}', "");
    Expect(0, 55215, '\P{ HANGUL_syllables}', "");
    Expect(1, 55215, '\P{^ HANGUL_syllables}', "");
    Expect(0, 55216, '\p{ HANGUL_syllables}', "");
    Expect(1, 55216, '\p{^ HANGUL_syllables}', "");
    Expect(1, 55216, '\P{ HANGUL_syllables}', "");
    Expect(0, 55216, '\P{^ HANGUL_syllables}', "");
    Error('\p{ 	is_Hangul_syllables:=}');
    Error('\P{ 	is_Hangul_syllables:=}');
    Expect(1, 55215, '\p{ishangulsyllables}', "");
    Expect(0, 55215, '\p{^ishangulsyllables}', "");
    Expect(0, 55215, '\P{ishangulsyllables}', "");
    Expect(1, 55215, '\P{^ishangulsyllables}', "");
    Expect(0, 55216, '\p{ishangulsyllables}', "");
    Expect(1, 55216, '\p{^ishangulsyllables}', "");
    Expect(1, 55216, '\P{ishangulsyllables}', "");
    Expect(0, 55216, '\P{^ishangulsyllables}', "");
    Expect(1, 55215, '\p{_IS_HANGUL_syllables}', "");
    Expect(0, 55215, '\p{^_IS_HANGUL_syllables}', "");
    Expect(0, 55215, '\P{_IS_HANGUL_syllables}', "");
    Expect(1, 55215, '\P{^_IS_HANGUL_syllables}', "");
    Expect(0, 55216, '\p{_IS_HANGUL_syllables}', "");
    Expect(1, 55216, '\p{^_IS_HANGUL_syllables}', "");
    Expect(1, 55216, '\P{_IS_HANGUL_syllables}', "");
    Expect(0, 55216, '\P{^_IS_HANGUL_syllables}', "");
    Error('\p{-/a/IN_Hangul_Syllables}');
    Error('\P{-/a/IN_Hangul_Syllables}');
    Expect(1, 55215, '\p{inhangulsyllables}', "");
    Expect(0, 55215, '\p{^inhangulsyllables}', "");
    Expect(0, 55215, '\P{inhangulsyllables}', "");
    Expect(1, 55215, '\P{^inhangulsyllables}', "");
    Expect(0, 55216, '\p{inhangulsyllables}', "");
    Expect(1, 55216, '\p{^inhangulsyllables}', "");
    Expect(1, 55216, '\P{inhangulsyllables}', "");
    Expect(0, 55216, '\P{^inhangulsyllables}', "");
    Expect(1, 55215, '\p{_In_hangul_syllables}', "");
    Expect(0, 55215, '\p{^_In_hangul_syllables}', "");
    Expect(0, 55215, '\P{_In_hangul_syllables}', "");
    Expect(1, 55215, '\P{^_In_hangul_syllables}', "");
    Expect(0, 55216, '\p{_In_hangul_syllables}', "");
    Expect(1, 55216, '\p{^_In_hangul_syllables}', "");
    Expect(1, 55216, '\P{_In_hangul_syllables}', "");
    Expect(0, 55216, '\P{^_In_hangul_syllables}', "");
    Error('\p{:=IN_HANGUL}');
    Error('\P{:=IN_HANGUL}');
    Expect(1, 55215, '\p{inhangul}', "");
    Expect(0, 55215, '\p{^inhangul}', "");
    Expect(0, 55215, '\P{inhangul}', "");
    Expect(1, 55215, '\P{^inhangul}', "");
    Expect(0, 55216, '\p{inhangul}', "");
    Expect(1, 55216, '\p{^inhangul}', "");
    Expect(1, 55216, '\P{inhangul}', "");
    Expect(0, 55216, '\P{^inhangul}', "");
    Expect(1, 55215, '\p{ In_HANGUL}', "");
    Expect(0, 55215, '\p{^ In_HANGUL}', "");
    Expect(0, 55215, '\P{ In_HANGUL}', "");
    Expect(1, 55215, '\P{^ In_HANGUL}', "");
    Expect(0, 55216, '\p{ In_HANGUL}', "");
    Expect(1, 55216, '\p{^ In_HANGUL}', "");
    Expect(1, 55216, '\P{ In_HANGUL}', "");
    Expect(0, 55216, '\P{^ In_HANGUL}', "");
    Error('\p{/a/	_Hanifi_Rohingya}');
    Error('\P{/a/	_Hanifi_Rohingya}');
    Expect(1, 68921, '\p{hanifirohingya}', "");
    Expect(0, 68921, '\p{^hanifirohingya}', "");
    Expect(0, 68921, '\P{hanifirohingya}', "");
    Expect(1, 68921, '\P{^hanifirohingya}', "");
    Expect(0, 68922, '\p{hanifirohingya}', "");
    Expect(1, 68922, '\p{^hanifirohingya}', "");
    Expect(1, 68922, '\P{hanifirohingya}', "");
    Expect(0, 68922, '\P{^hanifirohingya}', "");
    Expect(1, 68921, '\p{	 hanifi_rohingya}', "");
    Expect(0, 68921, '\p{^	 hanifi_rohingya}', "");
    Expect(0, 68921, '\P{	 hanifi_rohingya}', "");
    Expect(1, 68921, '\P{^	 hanifi_rohingya}', "");
    Expect(0, 68922, '\p{	 hanifi_rohingya}', "");
    Expect(1, 68922, '\p{^	 hanifi_rohingya}', "");
    Expect(1, 68922, '\P{	 hanifi_rohingya}', "");
    Expect(0, 68922, '\P{^	 hanifi_rohingya}', "");
    Error('\p{	-IS_hanifi_rohingya:=}');
    Error('\P{	-IS_hanifi_rohingya:=}');
    Expect(1, 68921, '\p{ishanifirohingya}', "");
    Expect(0, 68921, '\p{^ishanifirohingya}', "");
    Expect(0, 68921, '\P{ishanifirohingya}', "");
    Expect(1, 68921, '\P{^ishanifirohingya}', "");
    Expect(0, 68922, '\p{ishanifirohingya}', "");
    Expect(1, 68922, '\p{^ishanifirohingya}', "");
    Expect(1, 68922, '\P{ishanifirohingya}', "");
    Expect(0, 68922, '\P{^ishanifirohingya}', "");
    Expect(1, 68921, '\p{-	is_HANIFI_rohingya}', "");
    Expect(0, 68921, '\p{^-	is_HANIFI_rohingya}', "");
    Expect(0, 68921, '\P{-	is_HANIFI_rohingya}', "");
    Expect(1, 68921, '\P{^-	is_HANIFI_rohingya}', "");
    Expect(0, 68922, '\p{-	is_HANIFI_rohingya}', "");
    Expect(1, 68922, '\p{^-	is_HANIFI_rohingya}', "");
    Expect(1, 68922, '\P{-	is_HANIFI_rohingya}', "");
    Expect(0, 68922, '\P{^-	is_HANIFI_rohingya}', "");
    Error('\p{  Rohg:=}');
    Error('\P{  Rohg:=}');
    Expect(1, 68921, '\p{rohg}', "");
    Expect(0, 68921, '\p{^rohg}', "");
    Expect(0, 68921, '\P{rohg}', "");
    Expect(1, 68921, '\P{^rohg}', "");
    Expect(0, 68922, '\p{rohg}', "");
    Expect(1, 68922, '\p{^rohg}', "");
    Expect(1, 68922, '\P{rohg}', "");
    Expect(0, 68922, '\P{^rohg}', "");
    Expect(1, 68921, '\p{-	Rohg}', "");
    Expect(0, 68921, '\p{^-	Rohg}', "");
    Expect(0, 68921, '\P{-	Rohg}', "");
    Expect(1, 68921, '\P{^-	Rohg}', "");
    Expect(0, 68922, '\p{-	Rohg}', "");
    Expect(1, 68922, '\p{^-	Rohg}', "");
    Expect(1, 68922, '\P{-	Rohg}', "");
    Expect(0, 68922, '\P{^-	Rohg}', "");
    Error('\p{:=--IS_Rohg}');
    Error('\P{:=--IS_Rohg}');
    Expect(1, 68921, '\p{isrohg}', "");
    Expect(0, 68921, '\p{^isrohg}', "");
    Expect(0, 68921, '\P{isrohg}', "");
    Expect(1, 68921, '\P{^isrohg}', "");
    Expect(0, 68922, '\p{isrohg}', "");
    Expect(1, 68922, '\p{^isrohg}', "");
    Expect(1, 68922, '\P{isrohg}', "");
    Expect(0, 68922, '\P{^isrohg}', "");
    Expect(1, 68921, '\p{ is_rohg}', "");
    Expect(0, 68921, '\p{^ is_rohg}', "");
    Expect(0, 68921, '\P{ is_rohg}', "");
    Expect(1, 68921, '\P{^ is_rohg}', "");
    Expect(0, 68922, '\p{ is_rohg}', "");
    Expect(1, 68922, '\p{^ is_rohg}', "");
    Expect(1, 68922, '\P{ is_rohg}', "");
    Expect(0, 68922, '\P{^ is_rohg}', "");
    Error('\p{:=_ Hanunoo}');
    Error('\P{:=_ Hanunoo}');
    Expect(1, 5942, '\p{hanunoo}', "");
    Expect(0, 5942, '\p{^hanunoo}', "");
    Expect(0, 5942, '\P{hanunoo}', "");
    Expect(1, 5942, '\P{^hanunoo}', "");
    Expect(0, 5943, '\p{hanunoo}', "");
    Expect(1, 5943, '\p{^hanunoo}', "");
    Expect(1, 5943, '\P{hanunoo}', "");
    Expect(0, 5943, '\P{^hanunoo}', "");
    Expect(1, 5942, '\p{ 	Hanunoo}', "");
    Expect(0, 5942, '\p{^ 	Hanunoo}', "");
    Expect(0, 5942, '\P{ 	Hanunoo}', "");
    Expect(1, 5942, '\P{^ 	Hanunoo}', "");
    Expect(0, 5943, '\p{ 	Hanunoo}', "");
    Expect(1, 5943, '\p{^ 	Hanunoo}', "");
    Expect(1, 5943, '\P{ 	Hanunoo}', "");
    Expect(0, 5943, '\P{^ 	Hanunoo}', "");
    Error('\p{Is_Hanunoo:=}');
    Error('\P{Is_Hanunoo:=}');
    Expect(1, 5942, '\p{ishanunoo}', "");
    Expect(0, 5942, '\p{^ishanunoo}', "");
    Expect(0, 5942, '\P{ishanunoo}', "");
    Expect(1, 5942, '\P{^ishanunoo}', "");
    Expect(0, 5943, '\p{ishanunoo}', "");
    Expect(1, 5943, '\p{^ishanunoo}', "");
    Expect(1, 5943, '\P{ishanunoo}', "");
    Expect(0, 5943, '\P{^ishanunoo}', "");
    Expect(1, 5942, '\p{is_Hanunoo}', "");
    Expect(0, 5942, '\p{^is_Hanunoo}', "");
    Expect(0, 5942, '\P{is_Hanunoo}', "");
    Expect(1, 5942, '\P{^is_Hanunoo}', "");
    Expect(0, 5943, '\p{is_Hanunoo}', "");
    Expect(1, 5943, '\p{^is_Hanunoo}', "");
    Expect(1, 5943, '\P{is_Hanunoo}', "");
    Expect(0, 5943, '\P{^is_Hanunoo}', "");
    Error('\p{/a/--Hano}');
    Error('\P{/a/--Hano}');
    Expect(1, 5942, '\p{hano}', "");
    Expect(0, 5942, '\p{^hano}', "");
    Expect(0, 5942, '\P{hano}', "");
    Expect(1, 5942, '\P{^hano}', "");
    Expect(0, 5943, '\p{hano}', "");
    Expect(1, 5943, '\p{^hano}', "");
    Expect(1, 5943, '\P{hano}', "");
    Expect(0, 5943, '\P{^hano}', "");
    Expect(1, 5942, '\p{	 HANO}', "");
    Expect(0, 5942, '\p{^	 HANO}', "");
    Expect(0, 5942, '\P{	 HANO}', "");
    Expect(1, 5942, '\P{^	 HANO}', "");
    Expect(0, 5943, '\p{	 HANO}', "");
    Expect(1, 5943, '\p{^	 HANO}', "");
    Expect(1, 5943, '\P{	 HANO}', "");
    Expect(0, 5943, '\P{^	 HANO}', "");
    Error('\p{  Is_Hano/a/}');
    Error('\P{  Is_Hano/a/}');
    Expect(1, 5942, '\p{ishano}', "");
    Expect(0, 5942, '\p{^ishano}', "");
    Expect(0, 5942, '\P{ishano}', "");
    Expect(1, 5942, '\P{^ishano}', "");
    Expect(0, 5943, '\p{ishano}', "");
    Expect(1, 5943, '\p{^ishano}', "");
    Expect(1, 5943, '\P{ishano}', "");
    Expect(0, 5943, '\P{^ishano}', "");
    Expect(1, 5942, '\p{_is_Hano}', "");
    Expect(0, 5942, '\p{^_is_Hano}', "");
    Expect(0, 5942, '\P{_is_Hano}', "");
    Expect(1, 5942, '\P{^_is_Hano}', "");
    Expect(0, 5943, '\p{_is_Hano}', "");
    Expect(1, 5943, '\p{^_is_Hano}', "");
    Expect(1, 5943, '\P{_is_Hano}', "");
    Expect(0, 5943, '\P{^_is_Hano}', "");
    Error('\p{/a/	HATRAN}');
    Error('\P{/a/	HATRAN}');
    Expect(1, 67839, '\p{hatran}', "");
    Expect(0, 67839, '\p{^hatran}', "");
    Expect(0, 67839, '\P{hatran}', "");
    Expect(1, 67839, '\P{^hatran}', "");
    Expect(0, 67840, '\p{hatran}', "");
    Expect(1, 67840, '\p{^hatran}', "");
    Expect(1, 67840, '\P{hatran}', "");
    Expect(0, 67840, '\P{^hatran}', "");
    Expect(1, 67839, '\p{ HATRAN}', "");
    Expect(0, 67839, '\p{^ HATRAN}', "");
    Expect(0, 67839, '\P{ HATRAN}', "");
    Expect(1, 67839, '\P{^ HATRAN}', "");
    Expect(0, 67840, '\p{ HATRAN}', "");
    Expect(1, 67840, '\p{^ HATRAN}', "");
    Expect(1, 67840, '\P{ HATRAN}', "");
    Expect(0, 67840, '\P{^ HATRAN}', "");
    Error('\p{:=	IS_Hatran}');
    Error('\P{:=	IS_Hatran}');
    Expect(1, 67839, '\p{ishatran}', "");
    Expect(0, 67839, '\p{^ishatran}', "");
    Expect(0, 67839, '\P{ishatran}', "");
    Expect(1, 67839, '\P{^ishatran}', "");
    Expect(0, 67840, '\p{ishatran}', "");
    Expect(1, 67840, '\p{^ishatran}', "");
    Expect(1, 67840, '\P{ishatran}', "");
    Expect(0, 67840, '\P{^ishatran}', "");
    Expect(1, 67839, '\p{		Is_HATRAN}', "");
    Expect(0, 67839, '\p{^		Is_HATRAN}', "");
    Expect(0, 67839, '\P{		Is_HATRAN}', "");
    Expect(1, 67839, '\P{^		Is_HATRAN}', "");
    Expect(0, 67840, '\p{		Is_HATRAN}', "");
    Expect(1, 67840, '\p{^		Is_HATRAN}', "");
    Expect(1, 67840, '\P{		Is_HATRAN}', "");
    Expect(0, 67840, '\P{^		Is_HATRAN}', "");
    Error('\p{_Hatr/a/}');
    Error('\P{_Hatr/a/}');
    Expect(1, 67839, '\p{hatr}', "");
    Expect(0, 67839, '\p{^hatr}', "");
    Expect(0, 67839, '\P{hatr}', "");
    Expect(1, 67839, '\P{^hatr}', "");
    Expect(0, 67840, '\p{hatr}', "");
    Expect(1, 67840, '\p{^hatr}', "");
    Expect(1, 67840, '\P{hatr}', "");
    Expect(0, 67840, '\P{^hatr}', "");
    Expect(1, 67839, '\p{-Hatr}', "");
    Expect(0, 67839, '\p{^-Hatr}', "");
    Expect(0, 67839, '\P{-Hatr}', "");
    Expect(1, 67839, '\P{^-Hatr}', "");
    Expect(0, 67840, '\p{-Hatr}', "");
    Expect(1, 67840, '\p{^-Hatr}', "");
    Expect(1, 67840, '\P{-Hatr}', "");
    Expect(0, 67840, '\P{^-Hatr}', "");
    Error('\p{_/a/Is_Hatr}');
    Error('\P{_/a/Is_Hatr}');
    Expect(1, 67839, '\p{ishatr}', "");
    Expect(0, 67839, '\p{^ishatr}', "");
    Expect(0, 67839, '\P{ishatr}', "");
    Expect(1, 67839, '\P{^ishatr}', "");
    Expect(0, 67840, '\p{ishatr}', "");
    Expect(1, 67840, '\p{^ishatr}', "");
    Expect(1, 67840, '\P{ishatr}', "");
    Expect(0, 67840, '\P{^ishatr}', "");
    Expect(1, 67839, '\p{_is_hatr}', "");
    Expect(0, 67839, '\p{^_is_hatr}', "");
    Expect(0, 67839, '\P{_is_hatr}', "");
    Expect(1, 67839, '\P{^_is_hatr}', "");
    Expect(0, 67840, '\p{_is_hatr}', "");
    Expect(1, 67840, '\p{^_is_hatr}', "");
    Expect(1, 67840, '\P{_is_hatr}', "");
    Expect(0, 67840, '\P{^_is_hatr}', "");
    Error('\p{ /a/Hebrew}');
    Error('\P{ /a/Hebrew}');
    Expect(1, 64335, '\p{hebrew}', "");
    Expect(0, 64335, '\p{^hebrew}', "");
    Expect(0, 64335, '\P{hebrew}', "");
    Expect(1, 64335, '\P{^hebrew}', "");
    Expect(0, 64336, '\p{hebrew}', "");
    Expect(1, 64336, '\p{^hebrew}', "");
    Expect(1, 64336, '\P{hebrew}', "");
    Expect(0, 64336, '\P{^hebrew}', "");
    Expect(1, 64335, '\p{ 	HEBREW}', "");
    Expect(0, 64335, '\p{^ 	HEBREW}', "");
    Expect(0, 64335, '\P{ 	HEBREW}', "");
    Expect(1, 64335, '\P{^ 	HEBREW}', "");
    Expect(0, 64336, '\p{ 	HEBREW}', "");
    Expect(1, 64336, '\p{^ 	HEBREW}', "");
    Expect(1, 64336, '\P{ 	HEBREW}', "");
    Expect(0, 64336, '\P{^ 	HEBREW}', "");
    Error('\p{:=- IS_HEBREW}');
    Error('\P{:=- IS_HEBREW}');
    Expect(1, 64335, '\p{ishebrew}', "");
    Expect(0, 64335, '\p{^ishebrew}', "");
    Expect(0, 64335, '\P{ishebrew}', "");
    Expect(1, 64335, '\P{^ishebrew}', "");
    Expect(0, 64336, '\p{ishebrew}', "");
    Expect(1, 64336, '\p{^ishebrew}', "");
    Expect(1, 64336, '\P{ishebrew}', "");
    Expect(0, 64336, '\P{^ishebrew}', "");
    Expect(1, 64335, '\p{-	is_Hebrew}', "");
    Expect(0, 64335, '\p{^-	is_Hebrew}', "");
    Expect(0, 64335, '\P{-	is_Hebrew}', "");
    Expect(1, 64335, '\P{^-	is_Hebrew}', "");
    Expect(0, 64336, '\p{-	is_Hebrew}', "");
    Expect(1, 64336, '\p{^-	is_Hebrew}', "");
    Expect(1, 64336, '\P{-	is_Hebrew}', "");
    Expect(0, 64336, '\P{^-	is_Hebrew}', "");
    Error('\p{:=Hebr}');
    Error('\P{:=Hebr}');
    Expect(1, 64335, '\p{hebr}', "");
    Expect(0, 64335, '\p{^hebr}', "");
    Expect(0, 64335, '\P{hebr}', "");
    Expect(1, 64335, '\P{^hebr}', "");
    Expect(0, 64336, '\p{hebr}', "");
    Expect(1, 64336, '\p{^hebr}', "");
    Expect(1, 64336, '\P{hebr}', "");
    Expect(0, 64336, '\P{^hebr}', "");
    Expect(1, 64335, '\p{  Hebr}', "");
    Expect(0, 64335, '\p{^  Hebr}', "");
    Expect(0, 64335, '\P{  Hebr}', "");
    Expect(1, 64335, '\P{^  Hebr}', "");
    Expect(0, 64336, '\p{  Hebr}', "");
    Expect(1, 64336, '\p{^  Hebr}', "");
    Expect(1, 64336, '\P{  Hebr}', "");
    Expect(0, 64336, '\P{^  Hebr}', "");
    Error('\p{-/a/Is_Hebr}');
    Error('\P{-/a/Is_Hebr}');
    Expect(1, 64335, '\p{ishebr}', "");
    Expect(0, 64335, '\p{^ishebr}', "");
    Expect(0, 64335, '\P{ishebr}', "");
    Expect(1, 64335, '\P{^ishebr}', "");
    Expect(0, 64336, '\p{ishebr}', "");
    Expect(1, 64336, '\p{^ishebr}', "");
    Expect(1, 64336, '\P{ishebr}', "");
    Expect(0, 64336, '\P{^ishebr}', "");
    Expect(1, 64335, '\p{	IS_hebr}', "");
    Expect(0, 64335, '\p{^	IS_hebr}', "");
    Expect(0, 64335, '\P{	IS_hebr}', "");
    Expect(1, 64335, '\P{^	IS_hebr}', "");
    Expect(0, 64336, '\p{	IS_hebr}', "");
    Expect(1, 64336, '\p{^	IS_hebr}', "");
    Expect(1, 64336, '\P{	IS_hebr}', "");
    Expect(0, 64336, '\P{^	IS_hebr}', "");
    Error('\p{	High_private_Use_SURROGATES/a/}');
    Error('\P{	High_private_Use_SURROGATES/a/}');
    Expect(1, 56319, '\p{highprivateusesurrogates}', "");
    Expect(0, 56319, '\p{^highprivateusesurrogates}', "");
    Expect(0, 56319, '\P{highprivateusesurrogates}', "");
    Expect(1, 56319, '\P{^highprivateusesurrogates}', "");
    Expect(0, 57344, '\p{highprivateusesurrogates}', "");
    Expect(1, 57344, '\p{^highprivateusesurrogates}', "");
    Expect(1, 57344, '\P{highprivateusesurrogates}', "");
    Expect(0, 57344, '\P{^highprivateusesurrogates}', "");
    Expect(1, 56319, '\p{  High_PRIVATE_Use_surrogates}', "");
    Expect(0, 56319, '\p{^  High_PRIVATE_Use_surrogates}', "");
    Expect(0, 56319, '\P{  High_PRIVATE_Use_surrogates}', "");
    Expect(1, 56319, '\P{^  High_PRIVATE_Use_surrogates}', "");
    Expect(0, 57344, '\p{  High_PRIVATE_Use_surrogates}', "");
    Expect(1, 57344, '\p{^  High_PRIVATE_Use_surrogates}', "");
    Expect(1, 57344, '\P{  High_PRIVATE_Use_surrogates}', "");
    Expect(0, 57344, '\P{^  High_PRIVATE_Use_surrogates}', "");
    Error('\p{:=is_High_Private_Use_SURROGATES}');
    Error('\P{:=is_High_Private_Use_SURROGATES}');
    Expect(1, 56319, '\p{ishighprivateusesurrogates}', "");
    Expect(0, 56319, '\p{^ishighprivateusesurrogates}', "");
    Expect(0, 56319, '\P{ishighprivateusesurrogates}', "");
    Expect(1, 56319, '\P{^ishighprivateusesurrogates}', "");
    Expect(0, 57344, '\p{ishighprivateusesurrogates}', "");
    Expect(1, 57344, '\p{^ishighprivateusesurrogates}', "");
    Expect(1, 57344, '\P{ishighprivateusesurrogates}', "");
    Expect(0, 57344, '\P{^ishighprivateusesurrogates}', "");
    Expect(1, 56319, '\p{ -IS_HIGH_PRIVATE_Use_surrogates}', "");
    Expect(0, 56319, '\p{^ -IS_HIGH_PRIVATE_Use_surrogates}', "");
    Expect(0, 56319, '\P{ -IS_HIGH_PRIVATE_Use_surrogates}', "");
    Expect(1, 56319, '\P{^ -IS_HIGH_PRIVATE_Use_surrogates}', "");
    Expect(0, 57344, '\p{ -IS_HIGH_PRIVATE_Use_surrogates}', "");
    Expect(1, 57344, '\p{^ -IS_HIGH_PRIVATE_Use_surrogates}', "");
    Expect(1, 57344, '\P{ -IS_HIGH_PRIVATE_Use_surrogates}', "");
    Expect(0, 57344, '\P{^ -IS_HIGH_PRIVATE_Use_surrogates}', "");
    Error('\p{_In_High_Private_use_SURROGATES/a/}');
    Error('\P{_In_High_Private_use_SURROGATES/a/}');
    Expect(1, 56319, '\p{inhighprivateusesurrogates}', "");
    Expect(0, 56319, '\p{^inhighprivateusesurrogates}', "");
    Expect(0, 56319, '\P{inhighprivateusesurrogates}', "");
    Expect(1, 56319, '\P{^inhighprivateusesurrogates}', "");
    Expect(0, 57344, '\p{inhighprivateusesurrogates}', "");
    Expect(1, 57344, '\p{^inhighprivateusesurrogates}', "");
    Expect(1, 57344, '\P{inhighprivateusesurrogates}', "");
    Expect(0, 57344, '\P{^inhighprivateusesurrogates}', "");
    Expect(1, 56319, '\p{--In_High_PRIVATE_USE_surrogates}', "");
    Expect(0, 56319, '\p{^--In_High_PRIVATE_USE_surrogates}', "");
    Expect(0, 56319, '\P{--In_High_PRIVATE_USE_surrogates}', "");
    Expect(1, 56319, '\P{^--In_High_PRIVATE_USE_surrogates}', "");
    Expect(0, 57344, '\p{--In_High_PRIVATE_USE_surrogates}', "");
    Expect(1, 57344, '\p{^--In_High_PRIVATE_USE_surrogates}', "");
    Expect(1, 57344, '\P{--In_High_PRIVATE_USE_surrogates}', "");
    Expect(0, 57344, '\P{^--In_High_PRIVATE_USE_surrogates}', "");
    Error('\p{/a/	high_pu_Surrogates}');
    Error('\P{/a/	high_pu_Surrogates}');
    Expect(1, 56319, '\p{highpusurrogates}', "");
    Expect(0, 56319, '\p{^highpusurrogates}', "");
    Expect(0, 56319, '\P{highpusurrogates}', "");
    Expect(1, 56319, '\P{^highpusurrogates}', "");
    Expect(0, 57344, '\p{highpusurrogates}', "");
    Expect(1, 57344, '\p{^highpusurrogates}', "");
    Expect(1, 57344, '\P{highpusurrogates}', "");
    Expect(0, 57344, '\P{^highpusurrogates}', "");
    Expect(1, 56319, '\p{ 	High_PU_Surrogates}', "");
    Expect(0, 56319, '\p{^ 	High_PU_Surrogates}', "");
    Expect(0, 56319, '\P{ 	High_PU_Surrogates}', "");
    Expect(1, 56319, '\P{^ 	High_PU_Surrogates}', "");
    Expect(0, 57344, '\p{ 	High_PU_Surrogates}', "");
    Expect(1, 57344, '\p{^ 	High_PU_Surrogates}', "");
    Expect(1, 57344, '\P{ 	High_PU_Surrogates}', "");
    Expect(0, 57344, '\P{^ 	High_PU_Surrogates}', "");
    Error('\p{ -Is_High_pu_surrogates:=}');
    Error('\P{ -Is_High_pu_surrogates:=}');
    Expect(1, 56319, '\p{ishighpusurrogates}', "");
    Expect(0, 56319, '\p{^ishighpusurrogates}', "");
    Expect(0, 56319, '\P{ishighpusurrogates}', "");
    Expect(1, 56319, '\P{^ishighpusurrogates}', "");
    Expect(0, 57344, '\p{ishighpusurrogates}', "");
    Expect(1, 57344, '\p{^ishighpusurrogates}', "");
    Expect(1, 57344, '\P{ishighpusurrogates}', "");
    Expect(0, 57344, '\P{^ishighpusurrogates}', "");
    Expect(1, 56319, '\p{	_Is_HIGH_PU_SURROGATES}', "");
    Expect(0, 56319, '\p{^	_Is_HIGH_PU_SURROGATES}', "");
    Expect(0, 56319, '\P{	_Is_HIGH_PU_SURROGATES}', "");
    Expect(1, 56319, '\P{^	_Is_HIGH_PU_SURROGATES}', "");
    Expect(0, 57344, '\p{	_Is_HIGH_PU_SURROGATES}', "");
    Expect(1, 57344, '\p{^	_Is_HIGH_PU_SURROGATES}', "");
    Expect(1, 57344, '\P{	_Is_HIGH_PU_SURROGATES}', "");
    Expect(0, 57344, '\P{^	_Is_HIGH_PU_SURROGATES}', "");
    Error('\p{ In_high_PU_Surrogates/a/}');
    Error('\P{ In_high_PU_Surrogates/a/}');
    Expect(1, 56319, '\p{inhighpusurrogates}', "");
    Expect(0, 56319, '\p{^inhighpusurrogates}', "");
    Expect(0, 56319, '\P{inhighpusurrogates}', "");
    Expect(1, 56319, '\P{^inhighpusurrogates}', "");
    Expect(0, 57344, '\p{inhighpusurrogates}', "");
    Expect(1, 57344, '\p{^inhighpusurrogates}', "");
    Expect(1, 57344, '\P{inhighpusurrogates}', "");
    Expect(0, 57344, '\P{^inhighpusurrogates}', "");
    Expect(1, 56319, '\p{	IN_High_PU_Surrogates}', "");
    Expect(0, 56319, '\p{^	IN_High_PU_Surrogates}', "");
    Expect(0, 56319, '\P{	IN_High_PU_Surrogates}', "");
    Expect(1, 56319, '\P{^	IN_High_PU_Surrogates}', "");
    Expect(0, 57344, '\p{	IN_High_PU_Surrogates}', "");
    Expect(1, 57344, '\p{^	IN_High_PU_Surrogates}', "");
    Expect(1, 57344, '\P{	IN_High_PU_Surrogates}', "");
    Expect(0, 57344, '\P{^	IN_High_PU_Surrogates}', "");
    Error('\p{_High_surrogates:=}');
    Error('\P{_High_surrogates:=}');
    Expect(1, 56191, '\p{highsurrogates}', "");
    Expect(0, 56191, '\p{^highsurrogates}', "");
    Expect(0, 56191, '\P{highsurrogates}', "");
    Expect(1, 56191, '\P{^highsurrogates}', "");
    Expect(0, 57344, '\p{highsurrogates}', "");
    Expect(1, 57344, '\p{^highsurrogates}', "");
    Expect(1, 57344, '\P{highsurrogates}', "");
    Expect(0, 57344, '\P{^highsurrogates}', "");
    Expect(1, 56191, '\p{_-High_SURROGATES}', "");
    Expect(0, 56191, '\p{^_-High_SURROGATES}', "");
    Expect(0, 56191, '\P{_-High_SURROGATES}', "");
    Expect(1, 56191, '\P{^_-High_SURROGATES}', "");
    Expect(0, 57344, '\p{_-High_SURROGATES}', "");
    Expect(1, 57344, '\p{^_-High_SURROGATES}', "");
    Expect(1, 57344, '\P{_-High_SURROGATES}', "");
    Expect(0, 57344, '\P{^_-High_SURROGATES}', "");
    Error('\p{ IS_high_surrogates/a/}');
    Error('\P{ IS_high_surrogates/a/}');
    Expect(1, 56191, '\p{ishighsurrogates}', "");
    Expect(0, 56191, '\p{^ishighsurrogates}', "");
    Expect(0, 56191, '\P{ishighsurrogates}', "");
    Expect(1, 56191, '\P{^ishighsurrogates}', "");
    Expect(0, 57344, '\p{ishighsurrogates}', "");
    Expect(1, 57344, '\p{^ishighsurrogates}', "");
    Expect(1, 57344, '\P{ishighsurrogates}', "");
    Expect(0, 57344, '\P{^ishighsurrogates}', "");
    Expect(1, 56191, '\p{	Is_high_surrogates}', "");
    Expect(0, 56191, '\p{^	Is_high_surrogates}', "");
    Expect(0, 56191, '\P{	Is_high_surrogates}', "");
    Expect(1, 56191, '\P{^	Is_high_surrogates}', "");
    Expect(0, 57344, '\p{	Is_high_surrogates}', "");
    Expect(1, 57344, '\p{^	Is_high_surrogates}', "");
    Expect(1, 57344, '\P{	Is_high_surrogates}', "");
    Expect(0, 57344, '\P{^	Is_high_surrogates}', "");
    Error('\p{:=_	IN_high_Surrogates}');
    Error('\P{:=_	IN_high_Surrogates}');
    Expect(1, 56191, '\p{inhighsurrogates}', "");
    Expect(0, 56191, '\p{^inhighsurrogates}', "");
    Expect(0, 56191, '\P{inhighsurrogates}', "");
    Expect(1, 56191, '\P{^inhighsurrogates}', "");
    Expect(0, 57344, '\p{inhighsurrogates}', "");
    Expect(1, 57344, '\p{^inhighsurrogates}', "");
    Expect(1, 57344, '\P{inhighsurrogates}', "");
    Expect(0, 57344, '\P{^inhighsurrogates}', "");
    Expect(1, 56191, '\p{-IN_high_Surrogates}', "");
    Expect(0, 56191, '\p{^-IN_high_Surrogates}', "");
    Expect(0, 56191, '\P{-IN_high_Surrogates}', "");
    Expect(1, 56191, '\P{^-IN_high_Surrogates}', "");
    Expect(0, 57344, '\p{-IN_high_Surrogates}', "");
    Expect(1, 57344, '\p{^-IN_high_Surrogates}', "");
    Expect(1, 57344, '\P{-IN_high_Surrogates}', "");
    Expect(0, 57344, '\P{^-IN_high_Surrogates}', "");
    Error('\p{  HIRAGANA:=}');
    Error('\P{  HIRAGANA:=}');
    Expect(1, 127488, '\p{hiragana}', "");
    Expect(0, 127488, '\p{^hiragana}', "");
    Expect(0, 127488, '\P{hiragana}', "");
    Expect(1, 127488, '\P{^hiragana}', "");
    Expect(0, 127489, '\p{hiragana}', "");
    Expect(1, 127489, '\p{^hiragana}', "");
    Expect(1, 127489, '\P{hiragana}', "");
    Expect(0, 127489, '\P{^hiragana}', "");
    Expect(1, 127488, '\p{__Hiragana}', "");
    Expect(0, 127488, '\p{^__Hiragana}', "");
    Expect(0, 127488, '\P{__Hiragana}', "");
    Expect(1, 127488, '\P{^__Hiragana}', "");
    Expect(0, 127489, '\p{__Hiragana}', "");
    Expect(1, 127489, '\p{^__Hiragana}', "");
    Expect(1, 127489, '\P{__Hiragana}', "");
    Expect(0, 127489, '\P{^__Hiragana}', "");
    Error('\p{-/a/IS_HIRAGANA}');
    Error('\P{-/a/IS_HIRAGANA}');
    Expect(1, 127488, '\p{ishiragana}', "");
    Expect(0, 127488, '\p{^ishiragana}', "");
    Expect(0, 127488, '\P{ishiragana}', "");
    Expect(1, 127488, '\P{^ishiragana}', "");
    Expect(0, 127489, '\p{ishiragana}', "");
    Expect(1, 127489, '\p{^ishiragana}', "");
    Expect(1, 127489, '\P{ishiragana}', "");
    Expect(0, 127489, '\P{^ishiragana}', "");
    Expect(1, 127488, '\p{-is_Hiragana}', "");
    Expect(0, 127488, '\p{^-is_Hiragana}', "");
    Expect(0, 127488, '\P{-is_Hiragana}', "");
    Expect(1, 127488, '\P{^-is_Hiragana}', "");
    Expect(0, 127489, '\p{-is_Hiragana}', "");
    Expect(1, 127489, '\p{^-is_Hiragana}', "");
    Expect(1, 127489, '\P{-is_Hiragana}', "");
    Expect(0, 127489, '\P{^-is_Hiragana}', "");
    Error('\p{-:=HIRA}');
    Error('\P{-:=HIRA}');
    Expect(1, 127488, '\p{hira}', "");
    Expect(0, 127488, '\p{^hira}', "");
    Expect(0, 127488, '\P{hira}', "");
    Expect(1, 127488, '\P{^hira}', "");
    Expect(0, 127489, '\p{hira}', "");
    Expect(1, 127489, '\p{^hira}', "");
    Expect(1, 127489, '\P{hira}', "");
    Expect(0, 127489, '\P{^hira}', "");
    Expect(1, 127488, '\p{_Hira}', "");
    Expect(0, 127488, '\p{^_Hira}', "");
    Expect(0, 127488, '\P{_Hira}', "");
    Expect(1, 127488, '\P{^_Hira}', "");
    Expect(0, 127489, '\p{_Hira}', "");
    Expect(1, 127489, '\p{^_Hira}', "");
    Expect(1, 127489, '\P{_Hira}', "");
    Expect(0, 127489, '\P{^_Hira}', "");
    Error('\p{/a/-_Is_HIRA}');
    Error('\P{/a/-_Is_HIRA}');
    Expect(1, 127488, '\p{ishira}', "");
    Expect(0, 127488, '\p{^ishira}', "");
    Expect(0, 127488, '\P{ishira}', "");
    Expect(1, 127488, '\P{^ishira}', "");
    Expect(0, 127489, '\p{ishira}', "");
    Expect(1, 127489, '\p{^ishira}', "");
    Expect(1, 127489, '\P{ishira}', "");
    Expect(0, 127489, '\P{^ishira}', "");
    Expect(1, 127488, '\p{_IS_hira}', "");
    Expect(0, 127488, '\p{^_IS_hira}', "");
    Expect(0, 127488, '\P{_IS_hira}', "");
    Expect(1, 127488, '\P{^_IS_hira}', "");
    Expect(0, 127489, '\p{_IS_hira}', "");
    Expect(1, 127489, '\p{^_IS_hira}', "");
    Expect(1, 127489, '\P{_IS_hira}', "");
    Expect(0, 127489, '\P{^_IS_hira}', "");
    Error('\p{:=	 Hyphen}');
    Error('\P{:=	 Hyphen}');
    Expect(1, 65381, '\p{hyphen}', 'deprecated');
    Expect(0, 65381, '\p{^hyphen}', 'deprecated');
    Expect(0, 65381, '\P{hyphen}', 'deprecated');
    Expect(1, 65381, '\P{^hyphen}', 'deprecated');
    Expect(0, 65382, '\p{hyphen}', 'deprecated');
    Expect(1, 65382, '\p{^hyphen}', 'deprecated');
    Expect(1, 65382, '\P{hyphen}', 'deprecated');
    Expect(0, 65382, '\P{^hyphen}', 'deprecated');
    Expect(1, 65381, '\p{-HYPHEN}', 'deprecated');
    Expect(0, 65381, '\p{^-HYPHEN}', 'deprecated');
    Expect(0, 65381, '\P{-HYPHEN}', 'deprecated');
    Expect(1, 65381, '\P{^-HYPHEN}', 'deprecated');
    Expect(0, 65382, '\p{-HYPHEN}', 'deprecated');
    Expect(1, 65382, '\p{^-HYPHEN}', 'deprecated');
    Expect(1, 65382, '\P{-HYPHEN}', 'deprecated');
    Expect(0, 65382, '\P{^-HYPHEN}', 'deprecated');
    Error('\p{		is_Hyphen:=}');
    Error('\P{		is_Hyphen:=}');
    Expect(1, 65381, '\p{ishyphen}', 'deprecated');
    Expect(0, 65381, '\p{^ishyphen}', 'deprecated');
    Expect(0, 65381, '\P{ishyphen}', 'deprecated');
    Expect(1, 65381, '\P{^ishyphen}', 'deprecated');
    Expect(0, 65382, '\p{ishyphen}', 'deprecated');
    Expect(1, 65382, '\p{^ishyphen}', 'deprecated');
    Expect(1, 65382, '\P{ishyphen}', 'deprecated');
    Expect(0, 65382, '\P{^ishyphen}', 'deprecated');
    Expect(1, 65381, '\p{-	Is_Hyphen}', 'deprecated');
    Expect(0, 65381, '\p{^-	Is_Hyphen}', 'deprecated');
    Expect(0, 65381, '\P{-	Is_Hyphen}', 'deprecated');
    Expect(1, 65381, '\P{^-	Is_Hyphen}', 'deprecated');
    Expect(0, 65382, '\p{-	Is_Hyphen}', 'deprecated');
    Expect(1, 65382, '\p{^-	Is_Hyphen}', 'deprecated');
    Expect(1, 65382, '\P{-	Is_Hyphen}', 'deprecated');
    Expect(0, 65382, '\P{^-	Is_Hyphen}', 'deprecated');
    Error('\p{-:=ID_continue}');
    Error('\P{-:=ID_continue}');
    Expect(1, 917999, '\p{idcontinue}', "");
    Expect(0, 917999, '\p{^idcontinue}', "");
    Expect(0, 917999, '\P{idcontinue}', "");
    Expect(1, 917999, '\P{^idcontinue}', "");
    Expect(0, 918000, '\p{idcontinue}', "");
    Expect(1, 918000, '\p{^idcontinue}', "");
    Expect(1, 918000, '\P{idcontinue}', "");
    Expect(0, 918000, '\P{^idcontinue}', "");
    Expect(1, 917999, '\p{_ id_Continue}', "");
    Expect(0, 917999, '\p{^_ id_Continue}', "");
    Expect(0, 917999, '\P{_ id_Continue}', "");
    Expect(1, 917999, '\P{^_ id_Continue}', "");
    Expect(0, 918000, '\p{_ id_Continue}', "");
    Expect(1, 918000, '\p{^_ id_Continue}', "");
    Expect(1, 918000, '\P{_ id_Continue}', "");
    Expect(0, 918000, '\P{^_ id_Continue}', "");
    Error('\p{_	Is_ID_Continue:=}');
    Error('\P{_	Is_ID_Continue:=}');
    Expect(1, 917999, '\p{isidcontinue}', "");
    Expect(0, 917999, '\p{^isidcontinue}', "");
    Expect(0, 917999, '\P{isidcontinue}', "");
    Expect(1, 917999, '\P{^isidcontinue}', "");
    Expect(0, 918000, '\p{isidcontinue}', "");
    Expect(1, 918000, '\p{^isidcontinue}', "");
    Expect(1, 918000, '\P{isidcontinue}', "");
    Expect(0, 918000, '\P{^isidcontinue}', "");
    Expect(1, 917999, '\p{_Is_ID_Continue}', "");
    Expect(0, 917999, '\p{^_Is_ID_Continue}', "");
    Expect(0, 917999, '\P{_Is_ID_Continue}', "");
    Expect(1, 917999, '\P{^_Is_ID_Continue}', "");
    Expect(0, 918000, '\p{_Is_ID_Continue}', "");
    Expect(1, 918000, '\p{^_Is_ID_Continue}', "");
    Expect(1, 918000, '\P{_Is_ID_Continue}', "");
    Expect(0, 918000, '\P{^_Is_ID_Continue}', "");
    Error('\p{ IDC:=}');
    Error('\P{ IDC:=}');
    Expect(1, 917999, '\p{idc}', "");
    Expect(0, 917999, '\p{^idc}', "");
    Expect(0, 917999, '\P{idc}', "");
    Expect(1, 917999, '\P{^idc}', "");
    Expect(0, 918000, '\p{idc}', "");
    Expect(1, 918000, '\p{^idc}', "");
    Expect(1, 918000, '\P{idc}', "");
    Expect(0, 918000, '\P{^idc}', "");
    Expect(1, 917999, '\p{-	IDC}', "");
    Expect(0, 917999, '\p{^-	IDC}', "");
    Expect(0, 917999, '\P{-	IDC}', "");
    Expect(1, 917999, '\P{^-	IDC}', "");
    Expect(0, 918000, '\p{-	IDC}', "");
    Expect(1, 918000, '\p{^-	IDC}', "");
    Expect(1, 918000, '\P{-	IDC}', "");
    Expect(0, 918000, '\P{^-	IDC}', "");
    Error('\p{ :=Is_IDC}');
    Error('\P{ :=Is_IDC}');
    Expect(1, 917999, '\p{isidc}', "");
    Expect(0, 917999, '\p{^isidc}', "");
    Expect(0, 917999, '\P{isidc}', "");
    Expect(1, 917999, '\P{^isidc}', "");
    Expect(0, 918000, '\p{isidc}', "");
    Expect(1, 918000, '\p{^isidc}', "");
    Expect(1, 918000, '\P{isidc}', "");
    Expect(0, 918000, '\P{^isidc}', "");
    Expect(1, 917999, '\p{_is_IDC}', "");
    Expect(0, 917999, '\p{^_is_IDC}', "");
    Expect(0, 917999, '\P{_is_IDC}', "");
    Expect(1, 917999, '\P{^_is_IDC}', "");
    Expect(0, 918000, '\p{_is_IDC}', "");
    Expect(1, 918000, '\p{^_is_IDC}', "");
    Expect(1, 918000, '\P{_is_IDC}', "");
    Expect(0, 918000, '\P{^_is_IDC}', "");
    Error('\p{	-id_Start/a/}');
    Error('\P{	-id_Start/a/}');
    Expect(1, 201546, '\p{idstart}', "");
    Expect(0, 201546, '\p{^idstart}', "");
    Expect(0, 201546, '\P{idstart}', "");
    Expect(1, 201546, '\P{^idstart}', "");
    Expect(0, 201547, '\p{idstart}', "");
    Expect(1, 201547, '\p{^idstart}', "");
    Expect(1, 201547, '\P{idstart}', "");
    Expect(0, 201547, '\P{^idstart}', "");
    Expect(1, 201546, '\p{ 	ID_start}', "");
    Expect(0, 201546, '\p{^ 	ID_start}', "");
    Expect(0, 201546, '\P{ 	ID_start}', "");
    Expect(1, 201546, '\P{^ 	ID_start}', "");
    Expect(0, 201547, '\p{ 	ID_start}', "");
    Expect(1, 201547, '\p{^ 	ID_start}', "");
    Expect(1, 201547, '\P{ 	ID_start}', "");
    Expect(0, 201547, '\P{^ 	ID_start}', "");
    Error('\p{	 is_ID_Start:=}');
    Error('\P{	 is_ID_Start:=}');
    Expect(1, 201546, '\p{isidstart}', "");
    Expect(0, 201546, '\p{^isidstart}', "");
    Expect(0, 201546, '\P{isidstart}', "");
    Expect(1, 201546, '\P{^isidstart}', "");
    Expect(0, 201547, '\p{isidstart}', "");
    Expect(1, 201547, '\p{^isidstart}', "");
    Expect(1, 201547, '\P{isidstart}', "");
    Expect(0, 201547, '\P{^isidstart}', "");
    Expect(1, 201546, '\p{ -Is_ID_Start}', "");
    Expect(0, 201546, '\p{^ -Is_ID_Start}', "");
    Expect(0, 201546, '\P{ -Is_ID_Start}', "");
    Expect(1, 201546, '\P{^ -Is_ID_Start}', "");
    Expect(0, 201547, '\p{ -Is_ID_Start}', "");
    Expect(1, 201547, '\p{^ -Is_ID_Start}', "");
    Expect(1, 201547, '\P{ -Is_ID_Start}', "");
    Expect(0, 201547, '\P{^ -Is_ID_Start}', "");
    Error('\p{-ids/a/}');
    Error('\P{-ids/a/}');
    Expect(1, 201546, '\p{ids}', "");
    Expect(0, 201546, '\p{^ids}', "");
    Expect(0, 201546, '\P{ids}', "");
    Expect(1, 201546, '\P{^ids}', "");
    Expect(0, 201547, '\p{ids}', "");
    Expect(1, 201547, '\p{^ids}', "");
    Expect(1, 201547, '\P{ids}', "");
    Expect(0, 201547, '\P{^ids}', "");
    Expect(1, 201546, '\p{ IDS}', "");
    Expect(0, 201546, '\p{^ IDS}', "");
    Expect(0, 201546, '\P{ IDS}', "");
    Expect(1, 201546, '\P{^ IDS}', "");
    Expect(0, 201547, '\p{ IDS}', "");
    Expect(1, 201547, '\p{^ IDS}', "");
    Expect(1, 201547, '\P{ IDS}', "");
    Expect(0, 201547, '\P{^ IDS}', "");
    Error('\p{is_IDS/a/}');
    Error('\P{is_IDS/a/}');
    Expect(1, 201546, '\p{isids}', "");
    Expect(0, 201546, '\p{^isids}', "");
    Expect(0, 201546, '\P{isids}', "");
    Expect(1, 201546, '\P{^isids}', "");
    Expect(0, 201547, '\p{isids}', "");
    Expect(1, 201547, '\p{^isids}', "");
    Expect(1, 201547, '\P{isids}', "");
    Expect(0, 201547, '\P{^isids}', "");
    Expect(1, 201546, '\p{_is_IDS}', "");
    Expect(0, 201546, '\p{^_is_IDS}', "");
    Expect(0, 201546, '\P{_is_IDS}', "");
    Expect(1, 201546, '\P{^_is_IDS}', "");
    Expect(0, 201547, '\p{_is_IDS}', "");
    Expect(1, 201547, '\p{^_is_IDS}', "");
    Expect(1, 201547, '\P{_is_IDS}', "");
    Expect(0, 201547, '\P{^_is_IDS}', "");
    Error('\p{/a/	_IDEOGRAPHIC}');
    Error('\P{/a/	_IDEOGRAPHIC}');
    Expect(1, 201546, '\p{ideographic}', "");
    Expect(0, 201546, '\p{^ideographic}', "");
    Expect(0, 201546, '\P{ideographic}', "");
    Expect(1, 201546, '\P{^ideographic}', "");
    Expect(0, 201547, '\p{ideographic}', "");
    Expect(1, 201547, '\p{^ideographic}', "");
    Expect(1, 201547, '\P{ideographic}', "");
    Expect(0, 201547, '\P{^ideographic}', "");
    Expect(1, 201546, '\p{ Ideographic}', "");
    Expect(0, 201546, '\p{^ Ideographic}', "");
    Expect(0, 201546, '\P{ Ideographic}', "");
    Expect(1, 201546, '\P{^ Ideographic}', "");
    Expect(0, 201547, '\p{ Ideographic}', "");
    Expect(1, 201547, '\p{^ Ideographic}', "");
    Expect(1, 201547, '\P{ Ideographic}', "");
    Expect(0, 201547, '\P{^ Ideographic}', "");
    Error('\p{_	IS_Ideographic:=}');
    Error('\P{_	IS_Ideographic:=}');
    Expect(1, 201546, '\p{isideographic}', "");
    Expect(0, 201546, '\p{^isideographic}', "");
    Expect(0, 201546, '\P{isideographic}', "");
    Expect(1, 201546, '\P{^isideographic}', "");
    Expect(0, 201547, '\p{isideographic}', "");
    Expect(1, 201547, '\p{^isideographic}', "");
    Expect(1, 201547, '\P{isideographic}', "");
    Expect(0, 201547, '\P{^isideographic}', "");
    Expect(1, 201546, '\p{  is_Ideographic}', "");
    Expect(0, 201546, '\p{^  is_Ideographic}', "");
    Expect(0, 201546, '\P{  is_Ideographic}', "");
    Expect(1, 201546, '\P{^  is_Ideographic}', "");
    Expect(0, 201547, '\p{  is_Ideographic}', "");
    Expect(1, 201547, '\p{^  is_Ideographic}', "");
    Expect(1, 201547, '\P{  is_Ideographic}', "");
    Expect(0, 201547, '\P{^  is_Ideographic}', "");
    Error('\p{_ideo:=}');
    Error('\P{_ideo:=}');
    Expect(1, 201546, '\p{ideo}', "");
    Expect(0, 201546, '\p{^ideo}', "");
    Expect(0, 201546, '\P{ideo}', "");
    Expect(1, 201546, '\P{^ideo}', "");
    Expect(0, 201547, '\p{ideo}', "");
    Expect(1, 201547, '\p{^ideo}', "");
    Expect(1, 201547, '\P{ideo}', "");
    Expect(0, 201547, '\P{^ideo}', "");
    Expect(1, 201546, '\p{ IDEO}', "");
    Expect(0, 201546, '\p{^ IDEO}', "");
    Expect(0, 201546, '\P{ IDEO}', "");
    Expect(1, 201546, '\P{^ IDEO}', "");
    Expect(0, 201547, '\p{ IDEO}', "");
    Expect(1, 201547, '\p{^ IDEO}', "");
    Expect(1, 201547, '\P{ IDEO}', "");
    Expect(0, 201547, '\P{^ IDEO}', "");
    Error('\p{:=-_is_IDEO}');
    Error('\P{:=-_is_IDEO}');
    Expect(1, 201546, '\p{isideo}', "");
    Expect(0, 201546, '\p{^isideo}', "");
    Expect(0, 201546, '\P{isideo}', "");
    Expect(1, 201546, '\P{^isideo}', "");
    Expect(0, 201547, '\p{isideo}', "");
    Expect(1, 201547, '\p{^isideo}', "");
    Expect(1, 201547, '\P{isideo}', "");
    Expect(0, 201547, '\P{^isideo}', "");
    Expect(1, 201546, '\p{_ IS_Ideo}', "");
    Expect(0, 201546, '\p{^_ IS_Ideo}', "");
    Expect(0, 201546, '\P{_ IS_Ideo}', "");
    Expect(1, 201546, '\P{^_ IS_Ideo}', "");
    Expect(0, 201547, '\p{_ IS_Ideo}', "");
    Expect(1, 201547, '\p{^_ IS_Ideo}', "");
    Expect(1, 201547, '\P{_ IS_Ideo}', "");
    Expect(0, 201547, '\P{^_ IS_Ideo}', "");
    Error('\p{/a/_	IDEOGRAPHIC_Description_Characters}');
    Error('\P{/a/_	IDEOGRAPHIC_Description_Characters}');
    Expect(1, 12287, '\p{ideographicdescriptioncharacters}', "");
    Expect(0, 12287, '\p{^ideographicdescriptioncharacters}', "");
    Expect(0, 12287, '\P{ideographicdescriptioncharacters}', "");
    Expect(1, 12287, '\P{^ideographicdescriptioncharacters}', "");
    Expect(0, 12288, '\p{ideographicdescriptioncharacters}', "");
    Expect(1, 12288, '\p{^ideographicdescriptioncharacters}', "");
    Expect(1, 12288, '\P{ideographicdescriptioncharacters}', "");
    Expect(0, 12288, '\P{^ideographicdescriptioncharacters}', "");
    Expect(1, 12287, '\p{-	IDEOGRAPHIC_Description_characters}', "");
    Expect(0, 12287, '\p{^-	IDEOGRAPHIC_Description_characters}', "");
    Expect(0, 12287, '\P{-	IDEOGRAPHIC_Description_characters}', "");
    Expect(1, 12287, '\P{^-	IDEOGRAPHIC_Description_characters}', "");
    Expect(0, 12288, '\p{-	IDEOGRAPHIC_Description_characters}', "");
    Expect(1, 12288, '\p{^-	IDEOGRAPHIC_Description_characters}', "");
    Expect(1, 12288, '\P{-	IDEOGRAPHIC_Description_characters}', "");
    Expect(0, 12288, '\P{^-	IDEOGRAPHIC_Description_characters}', "");
    Error('\p{	Is_ideographic_description_Characters:=}');
    Error('\P{	Is_ideographic_description_Characters:=}');
    Expect(1, 12287, '\p{isideographicdescriptioncharacters}', "");
    Expect(0, 12287, '\p{^isideographicdescriptioncharacters}', "");
    Expect(0, 12287, '\P{isideographicdescriptioncharacters}', "");
    Expect(1, 12287, '\P{^isideographicdescriptioncharacters}', "");
    Expect(0, 12288, '\p{isideographicdescriptioncharacters}', "");
    Expect(1, 12288, '\p{^isideographicdescriptioncharacters}', "");
    Expect(1, 12288, '\P{isideographicdescriptioncharacters}', "");
    Expect(0, 12288, '\P{^isideographicdescriptioncharacters}', "");
    Expect(1, 12287, '\p{ is_Ideographic_description_Characters}', "");
    Expect(0, 12287, '\p{^ is_Ideographic_description_Characters}', "");
    Expect(0, 12287, '\P{ is_Ideographic_description_Characters}', "");
    Expect(1, 12287, '\P{^ is_Ideographic_description_Characters}', "");
    Expect(0, 12288, '\p{ is_Ideographic_description_Characters}', "");
    Expect(1, 12288, '\p{^ is_Ideographic_description_Characters}', "");
    Expect(1, 12288, '\P{ is_Ideographic_description_Characters}', "");
    Expect(0, 12288, '\P{^ is_Ideographic_description_Characters}', "");
    Error('\p{ :=In_Ideographic_DESCRIPTION_CHARACTERS}');
    Error('\P{ :=In_Ideographic_DESCRIPTION_CHARACTERS}');
    Expect(1, 12287, '\p{inideographicdescriptioncharacters}', "");
    Expect(0, 12287, '\p{^inideographicdescriptioncharacters}', "");
    Expect(0, 12287, '\P{inideographicdescriptioncharacters}', "");
    Expect(1, 12287, '\P{^inideographicdescriptioncharacters}', "");
    Expect(0, 12288, '\p{inideographicdescriptioncharacters}', "");
    Expect(1, 12288, '\p{^inideographicdescriptioncharacters}', "");
    Expect(1, 12288, '\P{inideographicdescriptioncharacters}', "");
    Expect(0, 12288, '\P{^inideographicdescriptioncharacters}', "");
    Expect(1, 12287, '\p{		In_IDEOGRAPHIC_Description_CHARACTERS}', "");
    Expect(0, 12287, '\p{^		In_IDEOGRAPHIC_Description_CHARACTERS}', "");
    Expect(0, 12287, '\P{		In_IDEOGRAPHIC_Description_CHARACTERS}', "");
    Expect(1, 12287, '\P{^		In_IDEOGRAPHIC_Description_CHARACTERS}', "");
    Expect(0, 12288, '\p{		In_IDEOGRAPHIC_Description_CHARACTERS}', "");
    Expect(1, 12288, '\p{^		In_IDEOGRAPHIC_Description_CHARACTERS}', "");
    Expect(1, 12288, '\P{		In_IDEOGRAPHIC_Description_CHARACTERS}', "");
    Expect(0, 12288, '\P{^		In_IDEOGRAPHIC_Description_CHARACTERS}', "");
    Error('\p{/a/_ IN_IDC}');
    Error('\P{/a/_ IN_IDC}');
    Expect(1, 12287, '\p{inidc}', "");
    Expect(0, 12287, '\p{^inidc}', "");
    Expect(0, 12287, '\P{inidc}', "");
    Expect(1, 12287, '\P{^inidc}', "");
    Expect(0, 12288, '\p{inidc}', "");
    Expect(1, 12288, '\p{^inidc}', "");
    Expect(1, 12288, '\P{inidc}', "");
    Expect(0, 12288, '\P{^inidc}', "");
    Expect(1, 12287, '\p{-_In_idc}', "");
    Expect(0, 12287, '\p{^-_In_idc}', "");
    Expect(0, 12287, '\P{-_In_idc}', "");
    Expect(1, 12287, '\P{^-_In_idc}', "");
    Expect(0, 12288, '\p{-_In_idc}', "");
    Expect(1, 12288, '\p{^-_In_idc}', "");
    Expect(1, 12288, '\P{-_In_idc}', "");
    Expect(0, 12288, '\P{^-_In_idc}', "");
    Error('\p{ ideographic_symbols_and_Punctuation/a/}');
    Error('\P{ ideographic_symbols_and_Punctuation/a/}');
    Expect(1, 94207, '\p{ideographicsymbolsandpunctuation}', "");
    Expect(0, 94207, '\p{^ideographicsymbolsandpunctuation}', "");
    Expect(0, 94207, '\P{ideographicsymbolsandpunctuation}', "");
    Expect(1, 94207, '\P{^ideographicsymbolsandpunctuation}', "");
    Expect(0, 94208, '\p{ideographicsymbolsandpunctuation}', "");
    Expect(1, 94208, '\p{^ideographicsymbolsandpunctuation}', "");
    Expect(1, 94208, '\P{ideographicsymbolsandpunctuation}', "");
    Expect(0, 94208, '\P{^ideographicsymbolsandpunctuation}', "");
    Expect(1, 94207, '\p{	-Ideographic_Symbols_AND_Punctuation}', "");
    Expect(0, 94207, '\p{^	-Ideographic_Symbols_AND_Punctuation}', "");
    Expect(0, 94207, '\P{	-Ideographic_Symbols_AND_Punctuation}', "");
    Expect(1, 94207, '\P{^	-Ideographic_Symbols_AND_Punctuation}', "");
    Expect(0, 94208, '\p{	-Ideographic_Symbols_AND_Punctuation}', "");
    Expect(1, 94208, '\p{^	-Ideographic_Symbols_AND_Punctuation}', "");
    Expect(1, 94208, '\P{	-Ideographic_Symbols_AND_Punctuation}', "");
    Expect(0, 94208, '\P{^	-Ideographic_Symbols_AND_Punctuation}', "");
    Error('\p{_IS_IDEOGRAPHIC_Symbols_And_PUNCTUATION/a/}');
    Error('\P{_IS_IDEOGRAPHIC_Symbols_And_PUNCTUATION/a/}');
    Expect(1, 94207, '\p{isideographicsymbolsandpunctuation}', "");
    Expect(0, 94207, '\p{^isideographicsymbolsandpunctuation}', "");
    Expect(0, 94207, '\P{isideographicsymbolsandpunctuation}', "");
    Expect(1, 94207, '\P{^isideographicsymbolsandpunctuation}', "");
    Expect(0, 94208, '\p{isideographicsymbolsandpunctuation}', "");
    Expect(1, 94208, '\p{^isideographicsymbolsandpunctuation}', "");
    Expect(1, 94208, '\P{isideographicsymbolsandpunctuation}', "");
    Expect(0, 94208, '\P{^isideographicsymbolsandpunctuation}', "");
    Expect(1, 94207, '\p{		is_Ideographic_symbols_and_PUNCTUATION}', "");
    Expect(0, 94207, '\p{^		is_Ideographic_symbols_and_PUNCTUATION}', "");
    Expect(0, 94207, '\P{		is_Ideographic_symbols_and_PUNCTUATION}', "");
    Expect(1, 94207, '\P{^		is_Ideographic_symbols_and_PUNCTUATION}', "");
    Expect(0, 94208, '\p{		is_Ideographic_symbols_and_PUNCTUATION}', "");
    Expect(1, 94208, '\p{^		is_Ideographic_symbols_and_PUNCTUATION}', "");
    Expect(1, 94208, '\P{		is_Ideographic_symbols_and_PUNCTUATION}', "");
    Expect(0, 94208, '\P{^		is_Ideographic_symbols_and_PUNCTUATION}', "");
    Error('\p{__In_Ideographic_Symbols_And_Punctuation:=}');
    Error('\P{__In_Ideographic_Symbols_And_Punctuation:=}');
    Expect(1, 94207, '\p{inideographicsymbolsandpunctuation}', "");
    Expect(0, 94207, '\p{^inideographicsymbolsandpunctuation}', "");
    Expect(0, 94207, '\P{inideographicsymbolsandpunctuation}', "");
    Expect(1, 94207, '\P{^inideographicsymbolsandpunctuation}', "");
    Expect(0, 94208, '\p{inideographicsymbolsandpunctuation}', "");
    Expect(1, 94208, '\p{^inideographicsymbolsandpunctuation}', "");
    Expect(1, 94208, '\P{inideographicsymbolsandpunctuation}', "");
    Expect(0, 94208, '\P{^inideographicsymbolsandpunctuation}', "");
    Expect(1, 94207, '\p{ _in_IDEOGRAPHIC_Symbols_And_PUNCTUATION}', "");
    Expect(0, 94207, '\p{^ _in_IDEOGRAPHIC_Symbols_And_PUNCTUATION}', "");
    Expect(0, 94207, '\P{ _in_IDEOGRAPHIC_Symbols_And_PUNCTUATION}', "");
    Expect(1, 94207, '\P{^ _in_IDEOGRAPHIC_Symbols_And_PUNCTUATION}', "");
    Expect(0, 94208, '\p{ _in_IDEOGRAPHIC_Symbols_And_PUNCTUATION}', "");
    Expect(1, 94208, '\p{^ _in_IDEOGRAPHIC_Symbols_And_PUNCTUATION}', "");
    Expect(1, 94208, '\P{ _in_IDEOGRAPHIC_Symbols_And_PUNCTUATION}', "");
    Expect(0, 94208, '\P{^ _in_IDEOGRAPHIC_Symbols_And_PUNCTUATION}', "");
    Error('\p{_-Ideographic_SYMBOLS/a/}');
    Error('\P{_-Ideographic_SYMBOLS/a/}');
    Expect(1, 94207, '\p{ideographicsymbols}', "");
    Expect(0, 94207, '\p{^ideographicsymbols}', "");
    Expect(0, 94207, '\P{ideographicsymbols}', "");
    Expect(1, 94207, '\P{^ideographicsymbols}', "");
    Expect(0, 94208, '\p{ideographicsymbols}', "");
    Expect(1, 94208, '\p{^ideographicsymbols}', "");
    Expect(1, 94208, '\P{ideographicsymbols}', "");
    Expect(0, 94208, '\P{^ideographicsymbols}', "");
    Expect(1, 94207, '\p{ Ideographic_Symbols}', "");
    Expect(0, 94207, '\p{^ Ideographic_Symbols}', "");
    Expect(0, 94207, '\P{ Ideographic_Symbols}', "");
    Expect(1, 94207, '\P{^ Ideographic_Symbols}', "");
    Expect(0, 94208, '\p{ Ideographic_Symbols}', "");
    Expect(1, 94208, '\p{^ Ideographic_Symbols}', "");
    Expect(1, 94208, '\P{ Ideographic_Symbols}', "");
    Expect(0, 94208, '\P{^ Ideographic_Symbols}', "");
    Error('\p{/a/	_Is_ideographic_SYMBOLS}');
    Error('\P{/a/	_Is_ideographic_SYMBOLS}');
    Expect(1, 94207, '\p{isideographicsymbols}', "");
    Expect(0, 94207, '\p{^isideographicsymbols}', "");
    Expect(0, 94207, '\P{isideographicsymbols}', "");
    Expect(1, 94207, '\P{^isideographicsymbols}', "");
    Expect(0, 94208, '\p{isideographicsymbols}', "");
    Expect(1, 94208, '\p{^isideographicsymbols}', "");
    Expect(1, 94208, '\P{isideographicsymbols}', "");
    Expect(0, 94208, '\P{^isideographicsymbols}', "");
    Expect(1, 94207, '\p{ is_ideographic_SYMBOLS}', "");
    Expect(0, 94207, '\p{^ is_ideographic_SYMBOLS}', "");
    Expect(0, 94207, '\P{ is_ideographic_SYMBOLS}', "");
    Expect(1, 94207, '\P{^ is_ideographic_SYMBOLS}', "");
    Expect(0, 94208, '\p{ is_ideographic_SYMBOLS}', "");
    Expect(1, 94208, '\p{^ is_ideographic_SYMBOLS}', "");
    Expect(1, 94208, '\P{ is_ideographic_SYMBOLS}', "");
    Expect(0, 94208, '\P{^ is_ideographic_SYMBOLS}', "");
    Error('\p{	/a/in_ideographic_symbols}');
    Error('\P{	/a/in_ideographic_symbols}');
    Expect(1, 94207, '\p{inideographicsymbols}', "");
    Expect(0, 94207, '\p{^inideographicsymbols}', "");
    Expect(0, 94207, '\P{inideographicsymbols}', "");
    Expect(1, 94207, '\P{^inideographicsymbols}', "");
    Expect(0, 94208, '\p{inideographicsymbols}', "");
    Expect(1, 94208, '\p{^inideographicsymbols}', "");
    Expect(1, 94208, '\P{inideographicsymbols}', "");
    Expect(0, 94208, '\P{^inideographicsymbols}', "");
    Expect(1, 94207, '\p{  IN_IDEOGRAPHIC_Symbols}', "");
    Expect(0, 94207, '\p{^  IN_IDEOGRAPHIC_Symbols}', "");
    Expect(0, 94207, '\P{  IN_IDEOGRAPHIC_Symbols}', "");
    Expect(1, 94207, '\P{^  IN_IDEOGRAPHIC_Symbols}', "");
    Expect(0, 94208, '\p{  IN_IDEOGRAPHIC_Symbols}', "");
    Expect(1, 94208, '\p{^  IN_IDEOGRAPHIC_Symbols}', "");
    Expect(1, 94208, '\P{  IN_IDEOGRAPHIC_Symbols}', "");
    Expect(0, 94208, '\P{^  IN_IDEOGRAPHIC_Symbols}', "");
    Error('\p{:=IDS_Binary_Operator}');
    Error('\P{:=IDS_Binary_Operator}');
    Expect(1, 12283, '\p{idsbinaryoperator}', "");
    Expect(0, 12283, '\p{^idsbinaryoperator}', "");
    Expect(0, 12283, '\P{idsbinaryoperator}', "");
    Expect(1, 12283, '\P{^idsbinaryoperator}', "");
    Expect(0, 12284, '\p{idsbinaryoperator}', "");
    Expect(1, 12284, '\p{^idsbinaryoperator}', "");
    Expect(1, 12284, '\P{idsbinaryoperator}', "");
    Expect(0, 12284, '\P{^idsbinaryoperator}', "");
    Expect(1, 12283, '\p{ -IDS_binary_Operator}', "");
    Expect(0, 12283, '\p{^ -IDS_binary_Operator}', "");
    Expect(0, 12283, '\P{ -IDS_binary_Operator}', "");
    Expect(1, 12283, '\P{^ -IDS_binary_Operator}', "");
    Expect(0, 12284, '\p{ -IDS_binary_Operator}', "");
    Expect(1, 12284, '\p{^ -IDS_binary_Operator}', "");
    Expect(1, 12284, '\P{ -IDS_binary_Operator}', "");
    Expect(0, 12284, '\P{^ -IDS_binary_Operator}', "");
    Error('\p{ Is_IDS_Binary_Operator:=}');
    Error('\P{ Is_IDS_Binary_Operator:=}');
    Expect(1, 12283, '\p{isidsbinaryoperator}', "");
    Expect(0, 12283, '\p{^isidsbinaryoperator}', "");
    Expect(0, 12283, '\P{isidsbinaryoperator}', "");
    Expect(1, 12283, '\P{^isidsbinaryoperator}', "");
    Expect(0, 12284, '\p{isidsbinaryoperator}', "");
    Expect(1, 12284, '\p{^isidsbinaryoperator}', "");
    Expect(1, 12284, '\P{isidsbinaryoperator}', "");
    Expect(0, 12284, '\P{^isidsbinaryoperator}', "");
    Expect(1, 12283, '\p{-_Is_IDS_Binary_Operator}', "");
    Expect(0, 12283, '\p{^-_Is_IDS_Binary_Operator}', "");
    Expect(0, 12283, '\P{-_Is_IDS_Binary_Operator}', "");
    Expect(1, 12283, '\P{^-_Is_IDS_Binary_Operator}', "");
    Expect(0, 12284, '\p{-_Is_IDS_Binary_Operator}', "");
    Expect(1, 12284, '\p{^-_Is_IDS_Binary_Operator}', "");
    Expect(1, 12284, '\P{-_Is_IDS_Binary_Operator}', "");
    Expect(0, 12284, '\P{^-_Is_IDS_Binary_Operator}', "");
    Error('\p{/a/ 	IDSB}');
    Error('\P{/a/ 	IDSB}');
    Expect(1, 12283, '\p{idsb}', "");
    Expect(0, 12283, '\p{^idsb}', "");
    Expect(0, 12283, '\P{idsb}', "");
    Expect(1, 12283, '\P{^idsb}', "");
    Expect(0, 12284, '\p{idsb}', "");
    Expect(1, 12284, '\p{^idsb}', "");
    Expect(1, 12284, '\P{idsb}', "");
    Expect(0, 12284, '\P{^idsb}', "");
    Expect(1, 12283, '\p{ -idsb}', "");
    Expect(0, 12283, '\p{^ -idsb}', "");
    Expect(0, 12283, '\P{ -idsb}', "");
    Expect(1, 12283, '\P{^ -idsb}', "");
    Expect(0, 12284, '\p{ -idsb}', "");
    Expect(1, 12284, '\p{^ -idsb}', "");
    Expect(1, 12284, '\P{ -idsb}', "");
    Expect(0, 12284, '\P{^ -idsb}', "");
    Error('\p{ /a/is_IDSB}');
    Error('\P{ /a/is_IDSB}');
    Expect(1, 12283, '\p{isidsb}', "");
    Expect(0, 12283, '\p{^isidsb}', "");
    Expect(0, 12283, '\P{isidsb}', "");
    Expect(1, 12283, '\P{^isidsb}', "");
    Expect(0, 12284, '\p{isidsb}', "");
    Expect(1, 12284, '\p{^isidsb}', "");
    Expect(1, 12284, '\P{isidsb}', "");
    Expect(0, 12284, '\P{^isidsb}', "");
    Expect(1, 12283, '\p{ 	IS_idsb}', "");
    Expect(0, 12283, '\p{^ 	IS_idsb}', "");
    Expect(0, 12283, '\P{ 	IS_idsb}', "");
    Expect(1, 12283, '\P{^ 	IS_idsb}', "");
    Expect(0, 12284, '\p{ 	IS_idsb}', "");
    Expect(1, 12284, '\p{^ 	IS_idsb}', "");
    Expect(1, 12284, '\P{ 	IS_idsb}', "");
    Expect(0, 12284, '\P{^ 	IS_idsb}', "");
    Error('\p{_:=IDS_TRINARY_Operator}');
    Error('\P{_:=IDS_TRINARY_Operator}');
    Expect(1, 12275, '\p{idstrinaryoperator}', "");
    Expect(0, 12275, '\p{^idstrinaryoperator}', "");
    Expect(0, 12275, '\P{idstrinaryoperator}', "");
    Expect(1, 12275, '\P{^idstrinaryoperator}', "");
    Expect(0, 12276, '\p{idstrinaryoperator}', "");
    Expect(1, 12276, '\p{^idstrinaryoperator}', "");
    Expect(1, 12276, '\P{idstrinaryoperator}', "");
    Expect(0, 12276, '\P{^idstrinaryoperator}', "");
    Expect(1, 12275, '\p{ _ids_trinary_OPERATOR}', "");
    Expect(0, 12275, '\p{^ _ids_trinary_OPERATOR}', "");
    Expect(0, 12275, '\P{ _ids_trinary_OPERATOR}', "");
    Expect(1, 12275, '\P{^ _ids_trinary_OPERATOR}', "");
    Expect(0, 12276, '\p{ _ids_trinary_OPERATOR}', "");
    Expect(1, 12276, '\p{^ _ids_trinary_OPERATOR}', "");
    Expect(1, 12276, '\P{ _ids_trinary_OPERATOR}', "");
    Expect(0, 12276, '\P{^ _ids_trinary_OPERATOR}', "");
    Error('\p{	Is_ids_TRINARY_Operator:=}');
    Error('\P{	Is_ids_TRINARY_Operator:=}');
    Expect(1, 12275, '\p{isidstrinaryoperator}', "");
    Expect(0, 12275, '\p{^isidstrinaryoperator}', "");
    Expect(0, 12275, '\P{isidstrinaryoperator}', "");
    Expect(1, 12275, '\P{^isidstrinaryoperator}', "");
    Expect(0, 12276, '\p{isidstrinaryoperator}', "");
    Expect(1, 12276, '\p{^isidstrinaryoperator}', "");
    Expect(1, 12276, '\P{isidstrinaryoperator}', "");
    Expect(0, 12276, '\P{^isidstrinaryoperator}', "");
    Expect(1, 12275, '\p{-IS_IDS_Trinary_operator}', "");
    Expect(0, 12275, '\p{^-IS_IDS_Trinary_operator}', "");
    Expect(0, 12275, '\P{-IS_IDS_Trinary_operator}', "");
    Expect(1, 12275, '\P{^-IS_IDS_Trinary_operator}', "");
    Expect(0, 12276, '\p{-IS_IDS_Trinary_operator}', "");
    Expect(1, 12276, '\p{^-IS_IDS_Trinary_operator}', "");
    Expect(1, 12276, '\P{-IS_IDS_Trinary_operator}', "");
    Expect(0, 12276, '\P{^-IS_IDS_Trinary_operator}', "");
    Error('\p{_ idst:=}');
    Error('\P{_ idst:=}');
    Expect(1, 12275, '\p{idst}', "");
    Expect(0, 12275, '\p{^idst}', "");
    Expect(0, 12275, '\P{idst}', "");
    Expect(1, 12275, '\P{^idst}', "");
    Expect(0, 12276, '\p{idst}', "");
    Expect(1, 12276, '\p{^idst}', "");
    Expect(1, 12276, '\P{idst}', "");
    Expect(0, 12276, '\P{^idst}', "");
    Expect(1, 12275, '\p{ IDST}', "");
    Expect(0, 12275, '\p{^ IDST}', "");
    Expect(0, 12275, '\P{ IDST}', "");
    Expect(1, 12275, '\P{^ IDST}', "");
    Expect(0, 12276, '\p{ IDST}', "");
    Expect(1, 12276, '\p{^ IDST}', "");
    Expect(1, 12276, '\P{ IDST}', "");
    Expect(0, 12276, '\P{^ IDST}', "");
    Error('\p{:=_	IS_IDST}');
    Error('\P{:=_	IS_IDST}');
    Expect(1, 12275, '\p{isidst}', "");
    Expect(0, 12275, '\p{^isidst}', "");
    Expect(0, 12275, '\P{isidst}', "");
    Expect(1, 12275, '\P{^isidst}', "");
    Expect(0, 12276, '\p{isidst}', "");
    Expect(1, 12276, '\p{^isidst}', "");
    Expect(1, 12276, '\P{isidst}', "");
    Expect(0, 12276, '\P{^isidst}', "");
    Expect(1, 12275, '\p{_ Is_IDST}', "");
    Expect(0, 12275, '\p{^_ Is_IDST}', "");
    Expect(0, 12275, '\P{_ Is_IDST}', "");
    Expect(1, 12275, '\P{^_ Is_IDST}', "");
    Expect(0, 12276, '\p{_ Is_IDST}', "");
    Expect(1, 12276, '\p{^_ Is_IDST}', "");
    Expect(1, 12276, '\P{_ Is_IDST}', "");
    Expect(0, 12276, '\P{^_ Is_IDST}', "");
    Error('\p{-:=Imperial_ARAMAIC}');
    Error('\P{-:=Imperial_ARAMAIC}');
    Expect(1, 67679, '\p{imperialaramaic}', "");
    Expect(0, 67679, '\p{^imperialaramaic}', "");
    Expect(0, 67679, '\P{imperialaramaic}', "");
    Expect(1, 67679, '\P{^imperialaramaic}', "");
    Expect(0, 67680, '\p{imperialaramaic}', "");
    Expect(1, 67680, '\p{^imperialaramaic}', "");
    Expect(1, 67680, '\P{imperialaramaic}', "");
    Expect(0, 67680, '\P{^imperialaramaic}', "");
    Expect(1, 67679, '\p{_	Imperial_Aramaic}', "");
    Expect(0, 67679, '\p{^_	Imperial_Aramaic}', "");
    Expect(0, 67679, '\P{_	Imperial_Aramaic}', "");
    Expect(1, 67679, '\P{^_	Imperial_Aramaic}', "");
    Expect(0, 67680, '\p{_	Imperial_Aramaic}', "");
    Expect(1, 67680, '\p{^_	Imperial_Aramaic}', "");
    Expect(1, 67680, '\P{_	Imperial_Aramaic}', "");
    Expect(0, 67680, '\P{^_	Imperial_Aramaic}', "");
    Error('\p{:=	is_imperial_Aramaic}');
    Error('\P{:=	is_imperial_Aramaic}');
    Expect(1, 67679, '\p{isimperialaramaic}', "");
    Expect(0, 67679, '\p{^isimperialaramaic}', "");
    Expect(0, 67679, '\P{isimperialaramaic}', "");
    Expect(1, 67679, '\P{^isimperialaramaic}', "");
    Expect(0, 67680, '\p{isimperialaramaic}', "");
    Expect(1, 67680, '\p{^isimperialaramaic}', "");
    Expect(1, 67680, '\P{isimperialaramaic}', "");
    Expect(0, 67680, '\P{^isimperialaramaic}', "");
    Expect(1, 67679, '\p{ Is_Imperial_Aramaic}', "");
    Expect(0, 67679, '\p{^ Is_Imperial_Aramaic}', "");
    Expect(0, 67679, '\P{ Is_Imperial_Aramaic}', "");
    Expect(1, 67679, '\P{^ Is_Imperial_Aramaic}', "");
    Expect(0, 67680, '\p{ Is_Imperial_Aramaic}', "");
    Expect(1, 67680, '\p{^ Is_Imperial_Aramaic}', "");
    Expect(1, 67680, '\P{ Is_Imperial_Aramaic}', "");
    Expect(0, 67680, '\P{^ Is_Imperial_Aramaic}', "");
    Error('\p{__Armi/a/}');
    Error('\P{__Armi/a/}');
    Expect(1, 67679, '\p{armi}', "");
    Expect(0, 67679, '\p{^armi}', "");
    Expect(0, 67679, '\P{armi}', "");
    Expect(1, 67679, '\P{^armi}', "");
    Expect(0, 67680, '\p{armi}', "");
    Expect(1, 67680, '\p{^armi}', "");
    Expect(1, 67680, '\P{armi}', "");
    Expect(0, 67680, '\P{^armi}', "");
    Expect(1, 67679, '\p{Armi}', "");
    Expect(0, 67679, '\p{^Armi}', "");
    Expect(0, 67679, '\P{Armi}', "");
    Expect(1, 67679, '\P{^Armi}', "");
    Expect(0, 67680, '\p{Armi}', "");
    Expect(1, 67680, '\p{^Armi}', "");
    Expect(1, 67680, '\P{Armi}', "");
    Expect(0, 67680, '\P{^Armi}', "");
    Error('\p{/a/	_Is_armi}');
    Error('\P{/a/	_Is_armi}');
    Expect(1, 67679, '\p{isarmi}', "");
    Expect(0, 67679, '\p{^isarmi}', "");
    Expect(0, 67679, '\P{isarmi}', "");
    Expect(1, 67679, '\P{^isarmi}', "");
    Expect(0, 67680, '\p{isarmi}', "");
    Expect(1, 67680, '\p{^isarmi}', "");
    Expect(1, 67680, '\P{isarmi}', "");
    Expect(0, 67680, '\P{^isarmi}', "");
    Expect(1, 67679, '\p{_ IS_Armi}', "");
    Expect(0, 67679, '\p{^_ IS_Armi}', "");
    Expect(0, 67679, '\P{_ IS_Armi}', "");
    Expect(1, 67679, '\P{^_ IS_Armi}', "");
    Expect(0, 67680, '\p{_ IS_Armi}', "");
    Expect(1, 67680, '\p{^_ IS_Armi}', "");
    Expect(1, 67680, '\P{_ IS_Armi}', "");
    Expect(0, 67680, '\P{^_ IS_Armi}', "");
    Error('\p{:=in_ADLAM}');
    Error('\P{:=in_ADLAM}');
    Expect(1, 125279, '\p{inadlam}', "");
    Expect(0, 125279, '\p{^inadlam}', "");
    Expect(0, 125279, '\P{inadlam}', "");
    Expect(1, 125279, '\P{^inadlam}', "");
    Expect(0, 125280, '\p{inadlam}', "");
    Expect(1, 125280, '\p{^inadlam}', "");
    Expect(1, 125280, '\P{inadlam}', "");
    Expect(0, 125280, '\P{^inadlam}', "");
    Expect(1, 125279, '\p{-IN_ADLAM}', "");
    Expect(0, 125279, '\p{^-IN_ADLAM}', "");
    Expect(0, 125279, '\P{-IN_ADLAM}', "");
    Expect(1, 125279, '\P{^-IN_ADLAM}', "");
    Expect(0, 125280, '\p{-IN_ADLAM}', "");
    Expect(1, 125280, '\p{^-IN_ADLAM}', "");
    Expect(1, 125280, '\P{-IN_ADLAM}', "");
    Expect(0, 125280, '\P{^-IN_ADLAM}', "");
    Error('\p{:=_IN_Adlam}');
    Error('\P{:=_IN_Adlam}');
    Expect(1, 125279, '\p{In_Adlam}', "");
    Expect(0, 125279, '\p{^In_Adlam}', "");
    Expect(0, 125279, '\P{In_Adlam}', "");
    Expect(1, 125279, '\P{^In_Adlam}', "");
    Expect(0, 125280, '\p{In_Adlam}', "");
    Expect(1, 125280, '\p{^In_Adlam}', "");
    Expect(1, 125280, '\P{In_Adlam}', "");
    Expect(0, 125280, '\P{^In_Adlam}', "");
    Error('\p{/a/__In_ahom}');
    Error('\P{/a/__In_ahom}');
    Expect(1, 71487, '\p{inahom}', "");
    Expect(0, 71487, '\p{^inahom}', "");
    Expect(0, 71487, '\P{inahom}', "");
    Expect(1, 71487, '\P{^inahom}', "");
    Expect(0, 71488, '\p{inahom}', "");
    Expect(1, 71488, '\p{^inahom}', "");
    Expect(1, 71488, '\P{inahom}', "");
    Expect(0, 71488, '\P{^inahom}', "");
    Expect(1, 71487, '\p{ in_Ahom}', "");
    Expect(0, 71487, '\p{^ in_Ahom}', "");
    Expect(0, 71487, '\P{ in_Ahom}', "");
    Expect(1, 71487, '\P{^ in_Ahom}', "");
    Expect(0, 71488, '\p{ in_Ahom}', "");
    Expect(1, 71488, '\p{^ in_Ahom}', "");
    Expect(1, 71488, '\P{ in_Ahom}', "");
    Expect(0, 71488, '\P{^ in_Ahom}', "");
    Error('\p{/a/  In_Ahom}');
    Error('\P{/a/  In_Ahom}');
    Expect(1, 71487, '\p{_ in_ahom}', "");
    Expect(0, 71487, '\p{^_ in_ahom}', "");
    Expect(0, 71487, '\P{_ in_ahom}', "");
    Expect(1, 71487, '\P{^_ in_ahom}', "");
    Expect(0, 71488, '\p{_ in_ahom}', "");
    Expect(1, 71488, '\p{^_ in_ahom}', "");
    Expect(1, 71488, '\P{_ in_ahom}', "");
    Expect(0, 71488, '\P{^_ in_ahom}', "");
    Error('\p{	:=in_Anatolian_hieroglyphs}');
    Error('\P{	:=in_Anatolian_hieroglyphs}');
    Expect(1, 83583, '\p{inanatolianhieroglyphs}', "");
    Expect(0, 83583, '\p{^inanatolianhieroglyphs}', "");
    Expect(0, 83583, '\P{inanatolianhieroglyphs}', "");
    Expect(1, 83583, '\P{^inanatolianhieroglyphs}', "");
    Expect(0, 83584, '\p{inanatolianhieroglyphs}', "");
    Expect(1, 83584, '\p{^inanatolianhieroglyphs}', "");
    Expect(1, 83584, '\P{inanatolianhieroglyphs}', "");
    Expect(0, 83584, '\P{^inanatolianhieroglyphs}', "");
    Expect(1, 83583, '\p{_	In_Anatolian_hieroglyphs}', "");
    Expect(0, 83583, '\p{^_	In_Anatolian_hieroglyphs}', "");
    Expect(0, 83583, '\P{_	In_Anatolian_hieroglyphs}', "");
    Expect(1, 83583, '\P{^_	In_Anatolian_hieroglyphs}', "");
    Expect(0, 83584, '\p{_	In_Anatolian_hieroglyphs}', "");
    Expect(1, 83584, '\p{^_	In_Anatolian_hieroglyphs}', "");
    Expect(1, 83584, '\P{_	In_Anatolian_hieroglyphs}', "");
    Expect(0, 83584, '\P{^_	In_Anatolian_hieroglyphs}', "");
    Error('\p{ -In_Anatolian_Hieroglyphs:=}');
    Error('\P{ -In_Anatolian_Hieroglyphs:=}');
    Expect(1, 83583, '\p{	in_ANATOLIAN_hieroglyphs}', "");
    Expect(0, 83583, '\p{^	in_ANATOLIAN_hieroglyphs}', "");
    Expect(0, 83583, '\P{	in_ANATOLIAN_hieroglyphs}', "");
    Expect(1, 83583, '\P{^	in_ANATOLIAN_hieroglyphs}', "");
    Expect(0, 83584, '\p{	in_ANATOLIAN_hieroglyphs}', "");
    Expect(1, 83584, '\p{^	in_ANATOLIAN_hieroglyphs}', "");
    Expect(1, 83584, '\P{	in_ANATOLIAN_hieroglyphs}', "");
    Expect(0, 83584, '\P{^	in_ANATOLIAN_hieroglyphs}', "");
    Error('\p{/a/In_Arabic}');
    Error('\P{/a/In_Arabic}');
    Expect(1, 1791, '\p{inarabic}', "");
    Expect(0, 1791, '\p{^inarabic}', "");
    Expect(0, 1791, '\P{inarabic}', "");
    Expect(1, 1791, '\P{^inarabic}', "");
    Expect(0, 1792, '\p{inarabic}', "");
    Expect(1, 1792, '\p{^inarabic}', "");
    Expect(1, 1792, '\P{inarabic}', "");
    Expect(0, 1792, '\P{^inarabic}', "");
    Expect(1, 1791, '\p{_IN_arabic}', "");
    Expect(0, 1791, '\p{^_IN_arabic}', "");
    Expect(0, 1791, '\P{_IN_arabic}', "");
    Expect(1, 1791, '\P{^_IN_arabic}', "");
    Expect(0, 1792, '\p{_IN_arabic}', "");
    Expect(1, 1792, '\p{^_IN_arabic}', "");
    Expect(1, 1792, '\P{_IN_arabic}', "");
    Expect(0, 1792, '\P{^_IN_arabic}', "");
    Error('\p{/a/-	in_ARABIC}');
    Error('\P{/a/-	in_ARABIC}');
    Expect(1, 1791, '\p{ 	in_arabic}', "");
    Expect(0, 1791, '\p{^ 	in_arabic}', "");
    Expect(0, 1791, '\P{ 	in_arabic}', "");
    Expect(1, 1791, '\P{^ 	in_arabic}', "");
    Expect(0, 1792, '\p{ 	in_arabic}', "");
    Expect(1, 1792, '\p{^ 	in_arabic}', "");
    Expect(1, 1792, '\P{ 	in_arabic}', "");
    Expect(0, 1792, '\P{^ 	in_arabic}', "");
    Error('\p{_:=In_Armenian}');
    Error('\P{_:=In_Armenian}');
    Expect(1, 1423, '\p{inarmenian}', "");
    Expect(0, 1423, '\p{^inarmenian}', "");
    Expect(0, 1423, '\P{inarmenian}', "");
    Expect(1, 1423, '\P{^inarmenian}', "");
    Expect(0, 1424, '\p{inarmenian}', "");
    Expect(1, 1424, '\p{^inarmenian}', "");
    Expect(1, 1424, '\P{inarmenian}', "");
    Expect(0, 1424, '\P{^inarmenian}', "");
    Expect(1, 1423, '\p{-_IN_ARMENIAN}', "");
    Expect(0, 1423, '\p{^-_IN_ARMENIAN}', "");
    Expect(0, 1423, '\P{-_IN_ARMENIAN}', "");
    Expect(1, 1423, '\P{^-_IN_ARMENIAN}', "");
    Expect(0, 1424, '\p{-_IN_ARMENIAN}', "");
    Expect(1, 1424, '\p{^-_IN_ARMENIAN}', "");
    Expect(1, 1424, '\P{-_IN_ARMENIAN}', "");
    Expect(0, 1424, '\P{^-_IN_ARMENIAN}', "");
    Error('\p{/a/-IN_Armenian}');
    Error('\P{/a/-IN_Armenian}');
    Expect(1, 1423, '\p{ _In_ARMENIAN}', "");
    Expect(0, 1423, '\p{^ _In_ARMENIAN}', "");
    Expect(0, 1423, '\P{ _In_ARMENIAN}', "");
    Expect(1, 1423, '\P{^ _In_ARMENIAN}', "");
    Expect(0, 1424, '\p{ _In_ARMENIAN}', "");
    Expect(1, 1424, '\p{^ _In_ARMENIAN}', "");
    Expect(1, 1424, '\P{ _In_ARMENIAN}', "");
    Expect(0, 1424, '\P{^ _In_ARMENIAN}', "");
    Error('\p{_ In_avestan/a/}');
    Error('\P{_ In_avestan/a/}');
    Expect(1, 68415, '\p{inavestan}', "");
    Expect(0, 68415, '\p{^inavestan}', "");
    Expect(0, 68415, '\P{inavestan}', "");
    Expect(1, 68415, '\P{^inavestan}', "");
    Expect(0, 68416, '\p{inavestan}', "");
    Expect(1, 68416, '\p{^inavestan}', "");
    Expect(1, 68416, '\P{inavestan}', "");
    Expect(0, 68416, '\P{^inavestan}', "");
    Expect(1, 68415, '\p{	_In_Avestan}', "");
    Expect(0, 68415, '\p{^	_In_Avestan}', "");
    Expect(0, 68415, '\P{	_In_Avestan}', "");
    Expect(1, 68415, '\P{^	_In_Avestan}', "");
    Expect(0, 68416, '\p{	_In_Avestan}', "");
    Expect(1, 68416, '\p{^	_In_Avestan}', "");
    Expect(1, 68416, '\P{	_In_Avestan}', "");
    Expect(0, 68416, '\P{^	_In_Avestan}', "");
    Error('\p{_In_Avestan/a/}');
    Error('\P{_In_Avestan/a/}');
    Expect(1, 68415, '\p{		IN_AVESTAN}', "");
    Expect(0, 68415, '\p{^		IN_AVESTAN}', "");
    Expect(0, 68415, '\P{		IN_AVESTAN}', "");
    Expect(1, 68415, '\P{^		IN_AVESTAN}', "");
    Expect(0, 68416, '\p{		IN_AVESTAN}', "");
    Expect(1, 68416, '\p{^		IN_AVESTAN}', "");
    Expect(1, 68416, '\P{		IN_AVESTAN}', "");
    Expect(0, 68416, '\P{^		IN_AVESTAN}', "");
    Error('\p{_-IN_BALINESE/a/}');
    Error('\P{_-IN_BALINESE/a/}');
    Expect(1, 7039, '\p{inbalinese}', "");
    Expect(0, 7039, '\p{^inbalinese}', "");
    Expect(0, 7039, '\P{inbalinese}', "");
    Expect(1, 7039, '\P{^inbalinese}', "");
    Expect(0, 7040, '\p{inbalinese}', "");
    Expect(1, 7040, '\p{^inbalinese}', "");
    Expect(1, 7040, '\P{inbalinese}', "");
    Expect(0, 7040, '\P{^inbalinese}', "");
    Expect(1, 7039, '\p{  in_Balinese}', "");
    Expect(0, 7039, '\p{^  in_Balinese}', "");
    Expect(0, 7039, '\P{  in_Balinese}', "");
    Expect(1, 7039, '\P{^  in_Balinese}', "");
    Expect(0, 7040, '\p{  in_Balinese}', "");
    Expect(1, 7040, '\p{^  in_Balinese}', "");
    Expect(1, 7040, '\P{  in_Balinese}', "");
    Expect(0, 7040, '\P{^  in_Balinese}', "");
    Error('\p{-/a/In_balinese}');
    Error('\P{-/a/In_balinese}');
    Expect(1, 7039, '\p{	 IN_balinese}', "");
    Expect(0, 7039, '\p{^	 IN_balinese}', "");
    Expect(0, 7039, '\P{	 IN_balinese}', "");
    Expect(1, 7039, '\P{^	 IN_balinese}', "");
    Expect(0, 7040, '\p{	 IN_balinese}', "");
    Expect(1, 7040, '\p{^	 IN_balinese}', "");
    Expect(1, 7040, '\P{	 IN_balinese}', "");
    Expect(0, 7040, '\P{^	 IN_balinese}', "");
    Error('\p{_In_Bamum/a/}');
    Error('\P{_In_Bamum/a/}');
    Expect(1, 42751, '\p{inbamum}', "");
    Expect(0, 42751, '\p{^inbamum}', "");
    Expect(0, 42751, '\P{inbamum}', "");
    Expect(1, 42751, '\P{^inbamum}', "");
    Expect(0, 42752, '\p{inbamum}', "");
    Expect(1, 42752, '\p{^inbamum}', "");
    Expect(1, 42752, '\P{inbamum}', "");
    Expect(0, 42752, '\P{^inbamum}', "");
    Expect(1, 42751, '\p{_	IN_Bamum}', "");
    Expect(0, 42751, '\p{^_	IN_Bamum}', "");
    Expect(0, 42751, '\P{_	IN_Bamum}', "");
    Expect(1, 42751, '\P{^_	IN_Bamum}', "");
    Expect(0, 42752, '\p{_	IN_Bamum}', "");
    Expect(1, 42752, '\p{^_	IN_Bamum}', "");
    Expect(1, 42752, '\P{_	IN_Bamum}', "");
    Expect(0, 42752, '\P{^_	IN_Bamum}', "");
    Error('\p{:=	in_BAMUM}');
    Error('\P{:=	in_BAMUM}');
    Expect(1, 42751, '\p{		IN_Bamum}', "");
    Expect(0, 42751, '\p{^		IN_Bamum}', "");
    Expect(0, 42751, '\P{		IN_Bamum}', "");
    Expect(1, 42751, '\P{^		IN_Bamum}', "");
    Expect(0, 42752, '\p{		IN_Bamum}', "");
    Expect(1, 42752, '\p{^		IN_Bamum}', "");
    Expect(1, 42752, '\P{		IN_Bamum}', "");
    Expect(0, 42752, '\P{^		IN_Bamum}', "");
    Error('\p{	_IN_bassa_Vah:=}');
    Error('\P{	_IN_bassa_Vah:=}');
    Expect(1, 92927, '\p{inbassavah}', "");
    Expect(0, 92927, '\p{^inbassavah}', "");
    Expect(0, 92927, '\P{inbassavah}', "");
    Expect(1, 92927, '\P{^inbassavah}', "");
    Expect(0, 92928, '\p{inbassavah}', "");
    Expect(1, 92928, '\p{^inbassavah}', "");
    Expect(1, 92928, '\P{inbassavah}', "");
    Expect(0, 92928, '\P{^inbassavah}', "");
    Expect(1, 92927, '\p{		In_Bassa_VAH}', "");
    Expect(0, 92927, '\p{^		In_Bassa_VAH}', "");
    Expect(0, 92927, '\P{		In_Bassa_VAH}', "");
    Expect(1, 92927, '\P{^		In_Bassa_VAH}', "");
    Expect(0, 92928, '\p{		In_Bassa_VAH}', "");
    Expect(1, 92928, '\p{^		In_Bassa_VAH}', "");
    Expect(1, 92928, '\P{		In_Bassa_VAH}', "");
    Expect(0, 92928, '\P{^		In_Bassa_VAH}', "");
    Error('\p{/a/	-IN_bassa_VAH}');
    Error('\P{/a/	-IN_bassa_VAH}');
    Expect(1, 92927, '\p{_	In_Bassa_Vah}', "");
    Expect(0, 92927, '\p{^_	In_Bassa_Vah}', "");
    Expect(0, 92927, '\P{_	In_Bassa_Vah}', "");
    Expect(1, 92927, '\P{^_	In_Bassa_Vah}', "");
    Expect(0, 92928, '\p{_	In_Bassa_Vah}', "");
    Expect(1, 92928, '\p{^_	In_Bassa_Vah}', "");
    Expect(1, 92928, '\P{_	In_Bassa_Vah}', "");
    Expect(0, 92928, '\P{^_	In_Bassa_Vah}', "");
    Error('\p{In_batak/a/}');
    Error('\P{In_batak/a/}');
    Expect(1, 7167, '\p{inbatak}', "");
    Expect(0, 7167, '\p{^inbatak}', "");
    Expect(0, 7167, '\P{inbatak}', "");
    Expect(1, 7167, '\P{^inbatak}', "");
    Expect(0, 7168, '\p{inbatak}', "");
    Expect(1, 7168, '\p{^inbatak}', "");
    Expect(1, 7168, '\P{inbatak}', "");
    Expect(0, 7168, '\P{^inbatak}', "");
    Expect(1, 7167, '\p{  In_BATAK}', "");
    Expect(0, 7167, '\p{^  In_BATAK}', "");
    Expect(0, 7167, '\P{  In_BATAK}', "");
    Expect(1, 7167, '\P{^  In_BATAK}', "");
    Expect(0, 7168, '\p{  In_BATAK}', "");
    Expect(1, 7168, '\p{^  In_BATAK}', "");
    Expect(1, 7168, '\P{  In_BATAK}', "");
    Expect(0, 7168, '\P{^  In_BATAK}', "");
    Error('\p{_:=IN_Batak}');
    Error('\P{_:=IN_Batak}');
    Expect(1, 7167, '\p{_in_batak}', "");
    Expect(0, 7167, '\p{^_in_batak}', "");
    Expect(0, 7167, '\P{_in_batak}', "");
    Expect(1, 7167, '\P{^_in_batak}', "");
    Expect(0, 7168, '\p{_in_batak}', "");
    Expect(1, 7168, '\p{^_in_batak}', "");
    Expect(1, 7168, '\P{_in_batak}', "");
    Expect(0, 7168, '\P{^_in_batak}', "");
    Error('\p{/a/-In_Bengali}');
    Error('\P{/a/-In_Bengali}');
    Expect(1, 2559, '\p{inbengali}', "");
    Expect(0, 2559, '\p{^inbengali}', "");
    Expect(0, 2559, '\P{inbengali}', "");
    Expect(1, 2559, '\P{^inbengali}', "");
    Expect(0, 2560, '\p{inbengali}', "");
    Expect(1, 2560, '\p{^inbengali}', "");
    Expect(1, 2560, '\P{inbengali}', "");
    Expect(0, 2560, '\P{^inbengali}', "");
    Expect(1, 2559, '\p{		IN_bengali}', "");
    Expect(0, 2559, '\p{^		IN_bengali}', "");
    Expect(0, 2559, '\P{		IN_bengali}', "");
    Expect(1, 2559, '\P{^		IN_bengali}', "");
    Expect(0, 2560, '\p{		IN_bengali}', "");
    Expect(1, 2560, '\p{^		IN_bengali}', "");
    Expect(1, 2560, '\P{		IN_bengali}', "");
    Expect(0, 2560, '\P{^		IN_bengali}', "");
    Error('\p{/a/_in_BENGALI}');
    Error('\P{/a/_in_BENGALI}');
    Expect(1, 2559, '\p{_	In_Bengali}', "");
    Expect(0, 2559, '\p{^_	In_Bengali}', "");
    Expect(0, 2559, '\P{_	In_Bengali}', "");
    Expect(1, 2559, '\P{^_	In_Bengali}', "");
    Expect(0, 2560, '\p{_	In_Bengali}', "");
    Expect(1, 2560, '\p{^_	In_Bengali}', "");
    Expect(1, 2560, '\P{_	In_Bengali}', "");
    Expect(0, 2560, '\P{^_	In_Bengali}', "");
    Error('\p{ IN_Bhaiksuki/a/}');
    Error('\P{ IN_Bhaiksuki/a/}');
    Expect(1, 72815, '\p{inbhaiksuki}', "");
    Expect(0, 72815, '\p{^inbhaiksuki}', "");
    Expect(0, 72815, '\P{inbhaiksuki}', "");
    Expect(1, 72815, '\P{^inbhaiksuki}', "");
    Expect(0, 72816, '\p{inbhaiksuki}', "");
    Expect(1, 72816, '\p{^inbhaiksuki}', "");
    Expect(1, 72816, '\P{inbhaiksuki}', "");
    Expect(0, 72816, '\P{^inbhaiksuki}', "");
    Expect(1, 72815, '\p{--In_Bhaiksuki}', "");
    Expect(0, 72815, '\p{^--In_Bhaiksuki}', "");
    Expect(0, 72815, '\P{--In_Bhaiksuki}', "");
    Expect(1, 72815, '\P{^--In_Bhaiksuki}', "");
    Expect(0, 72816, '\p{--In_Bhaiksuki}', "");
    Expect(1, 72816, '\p{^--In_Bhaiksuki}', "");
    Expect(1, 72816, '\P{--In_Bhaiksuki}', "");
    Expect(0, 72816, '\P{^--In_Bhaiksuki}', "");
    Error('\p{:=		In_BHAIKSUKI}');
    Error('\P{:=		In_BHAIKSUKI}');
    Expect(1, 72815, '\p{	in_Bhaiksuki}', "");
    Expect(0, 72815, '\p{^	in_Bhaiksuki}', "");
    Expect(0, 72815, '\P{	in_Bhaiksuki}', "");
    Expect(1, 72815, '\P{^	in_Bhaiksuki}', "");
    Expect(0, 72816, '\p{	in_Bhaiksuki}', "");
    Expect(1, 72816, '\p{^	in_Bhaiksuki}', "");
    Expect(1, 72816, '\P{	in_Bhaiksuki}', "");
    Expect(0, 72816, '\P{^	in_Bhaiksuki}', "");
    Error('\p{/a/ -In_BOPOMOFO}');
    Error('\P{/a/ -In_BOPOMOFO}');
    Expect(1, 12591, '\p{inbopomofo}', "");
    Expect(0, 12591, '\p{^inbopomofo}', "");
    Expect(0, 12591, '\P{inbopomofo}', "");
    Expect(1, 12591, '\P{^inbopomofo}', "");
    Expect(0, 12592, '\p{inbopomofo}', "");
    Expect(1, 12592, '\p{^inbopomofo}', "");
    Expect(1, 12592, '\P{inbopomofo}', "");
    Expect(0, 12592, '\P{^inbopomofo}', "");
    Expect(1, 12591, '\p{__in_Bopomofo}', "");
    Expect(0, 12591, '\p{^__in_Bopomofo}', "");
    Expect(0, 12591, '\P{__in_Bopomofo}', "");
    Expect(1, 12591, '\P{^__in_Bopomofo}', "");
    Expect(0, 12592, '\p{__in_Bopomofo}', "");
    Expect(1, 12592, '\p{^__in_Bopomofo}', "");
    Expect(1, 12592, '\P{__in_Bopomofo}', "");
    Expect(0, 12592, '\P{^__in_Bopomofo}', "");
    Error('\p{/a/	IN_Bopomofo}');
    Error('\P{/a/	IN_Bopomofo}');
    Expect(1, 12591, '\p{_-IN_bopomofo}', "");
    Expect(0, 12591, '\p{^_-IN_bopomofo}', "");
    Expect(0, 12591, '\P{_-IN_bopomofo}', "");
    Expect(1, 12591, '\P{^_-IN_bopomofo}', "");
    Expect(0, 12592, '\p{_-IN_bopomofo}', "");
    Expect(1, 12592, '\p{^_-IN_bopomofo}', "");
    Expect(1, 12592, '\P{_-IN_bopomofo}', "");
    Expect(0, 12592, '\P{^_-IN_bopomofo}', "");
    Error('\p{	:=In_Brahmi}');
    Error('\P{	:=In_Brahmi}');
    Expect(1, 69759, '\p{inbrahmi}', "");
    Expect(0, 69759, '\p{^inbrahmi}', "");
    Expect(0, 69759, '\P{inbrahmi}', "");
    Expect(1, 69759, '\P{^inbrahmi}', "");
    Expect(0, 69760, '\p{inbrahmi}', "");
    Expect(1, 69760, '\p{^inbrahmi}', "");
    Expect(1, 69760, '\P{inbrahmi}', "");
    Expect(0, 69760, '\P{^inbrahmi}', "");
    Expect(1, 69759, '\p{		IN_Brahmi}', "");
    Expect(0, 69759, '\p{^		IN_Brahmi}', "");
    Expect(0, 69759, '\P{		IN_Brahmi}', "");
    Expect(1, 69759, '\P{^		IN_Brahmi}', "");
    Expect(0, 69760, '\p{		IN_Brahmi}', "");
    Expect(1, 69760, '\p{^		IN_Brahmi}', "");
    Expect(1, 69760, '\P{		IN_Brahmi}', "");
    Expect(0, 69760, '\P{^		IN_Brahmi}', "");
    Error('\p{ :=In_Brahmi}');
    Error('\P{ :=In_Brahmi}');
    Expect(1, 69759, '\p{-In_BRAHMI}', "");
    Expect(0, 69759, '\p{^-In_BRAHMI}', "");
    Expect(0, 69759, '\P{-In_BRAHMI}', "");
    Expect(1, 69759, '\P{^-In_BRAHMI}', "");
    Expect(0, 69760, '\p{-In_BRAHMI}', "");
    Expect(1, 69760, '\p{^-In_BRAHMI}', "");
    Expect(1, 69760, '\P{-In_BRAHMI}', "");
    Expect(0, 69760, '\P{^-In_BRAHMI}', "");
    Error('\p{ _IN_BUGINESE/a/}');
    Error('\P{ _IN_BUGINESE/a/}');
    Expect(1, 6687, '\p{inbuginese}', "");
    Expect(0, 6687, '\p{^inbuginese}', "");
    Expect(0, 6687, '\P{inbuginese}', "");
    Expect(1, 6687, '\P{^inbuginese}', "");
    Expect(0, 6688, '\p{inbuginese}', "");
    Expect(1, 6688, '\p{^inbuginese}', "");
    Expect(1, 6688, '\P{inbuginese}', "");
    Expect(0, 6688, '\P{^inbuginese}', "");
    Expect(1, 6687, '\p{  IN_buginese}', "");
    Expect(0, 6687, '\p{^  IN_buginese}', "");
    Expect(0, 6687, '\P{  IN_buginese}', "");
    Expect(1, 6687, '\P{^  IN_buginese}', "");
    Expect(0, 6688, '\p{  IN_buginese}', "");
    Expect(1, 6688, '\p{^  IN_buginese}', "");
    Expect(1, 6688, '\P{  IN_buginese}', "");
    Expect(0, 6688, '\P{^  IN_buginese}', "");
    Error('\p{--In_BUGINESE/a/}');
    Error('\P{--In_BUGINESE/a/}');
    Expect(1, 6687, '\p{ _In_buginese}', "");
    Expect(0, 6687, '\p{^ _In_buginese}', "");
    Expect(0, 6687, '\P{ _In_buginese}', "");
    Expect(1, 6687, '\P{^ _In_buginese}', "");
    Expect(0, 6688, '\p{ _In_buginese}', "");
    Expect(1, 6688, '\p{^ _In_buginese}', "");
    Expect(1, 6688, '\P{ _In_buginese}', "");
    Expect(0, 6688, '\P{^ _In_buginese}', "");
    Error('\p{_in_Buhid/a/}');
    Error('\P{_in_Buhid/a/}');
    Expect(1, 5983, '\p{inbuhid}', "");
    Expect(0, 5983, '\p{^inbuhid}', "");
    Expect(0, 5983, '\P{inbuhid}', "");
    Expect(1, 5983, '\P{^inbuhid}', "");
    Expect(0, 5984, '\p{inbuhid}', "");
    Expect(1, 5984, '\p{^inbuhid}', "");
    Expect(1, 5984, '\P{inbuhid}', "");
    Expect(0, 5984, '\P{^inbuhid}', "");
    Expect(1, 5983, '\p{	_In_buhid}', "");
    Expect(0, 5983, '\p{^	_In_buhid}', "");
    Expect(0, 5983, '\P{	_In_buhid}', "");
    Expect(1, 5983, '\P{^	_In_buhid}', "");
    Expect(0, 5984, '\p{	_In_buhid}', "");
    Expect(1, 5984, '\p{^	_In_buhid}', "");
    Expect(1, 5984, '\P{	_In_buhid}', "");
    Expect(0, 5984, '\P{^	_In_buhid}', "");
    Error('\p{:= In_Buhid}');
    Error('\P{:= In_Buhid}');
    Expect(1, 5983, '\p{_IN_Buhid}', "");
    Expect(0, 5983, '\p{^_IN_Buhid}', "");
    Expect(0, 5983, '\P{_IN_Buhid}', "");
    Expect(1, 5983, '\P{^_IN_Buhid}', "");
    Expect(0, 5984, '\p{_IN_Buhid}', "");
    Expect(1, 5984, '\p{^_IN_Buhid}', "");
    Expect(1, 5984, '\P{_IN_Buhid}', "");
    Expect(0, 5984, '\P{^_IN_Buhid}', "");
    Error('\p{  In_Carian/a/}');
    Error('\P{  In_Carian/a/}');
    Expect(1, 66271, '\p{incarian}', "");
    Expect(0, 66271, '\p{^incarian}', "");
    Expect(0, 66271, '\P{incarian}', "");
    Expect(1, 66271, '\P{^incarian}', "");
    Expect(0, 66272, '\p{incarian}', "");
    Expect(1, 66272, '\p{^incarian}', "");
    Expect(1, 66272, '\P{incarian}', "");
    Expect(0, 66272, '\P{^incarian}', "");
    Expect(1, 66271, '\p{- In_Carian}', "");
    Expect(0, 66271, '\p{^- In_Carian}', "");
    Expect(0, 66271, '\P{- In_Carian}', "");
    Expect(1, 66271, '\P{^- In_Carian}', "");
    Expect(0, 66272, '\p{- In_Carian}', "");
    Expect(1, 66272, '\p{^- In_Carian}', "");
    Expect(1, 66272, '\P{- In_Carian}', "");
    Expect(0, 66272, '\P{^- In_Carian}', "");
    Error('\p{:=_IN_Carian}');
    Error('\P{:=_IN_Carian}');
    Expect(1, 66271, '\p{ IN_CARIAN}', "");
    Expect(0, 66271, '\p{^ IN_CARIAN}', "");
    Expect(0, 66271, '\P{ IN_CARIAN}', "");
    Expect(1, 66271, '\P{^ IN_CARIAN}', "");
    Expect(0, 66272, '\p{ IN_CARIAN}', "");
    Expect(1, 66272, '\p{^ IN_CARIAN}', "");
    Expect(1, 66272, '\P{ IN_CARIAN}', "");
    Expect(0, 66272, '\P{^ IN_CARIAN}', "");
    Error('\p{:=--In_caucasian_Albanian}');
    Error('\P{:=--In_caucasian_Albanian}');
    Expect(1, 66927, '\p{incaucasianalbanian}', "");
    Expect(0, 66927, '\p{^incaucasianalbanian}', "");
    Expect(0, 66927, '\P{incaucasianalbanian}', "");
    Expect(1, 66927, '\P{^incaucasianalbanian}', "");
    Expect(0, 66928, '\p{incaucasianalbanian}', "");
    Expect(1, 66928, '\p{^incaucasianalbanian}', "");
    Expect(1, 66928, '\P{incaucasianalbanian}', "");
    Expect(0, 66928, '\P{^incaucasianalbanian}', "");
    Expect(1, 66927, '\p{ In_Caucasian_albanian}', "");
    Expect(0, 66927, '\p{^ In_Caucasian_albanian}', "");
    Expect(0, 66927, '\P{ In_Caucasian_albanian}', "");
    Expect(1, 66927, '\P{^ In_Caucasian_albanian}', "");
    Expect(0, 66928, '\p{ In_Caucasian_albanian}', "");
    Expect(1, 66928, '\p{^ In_Caucasian_albanian}', "");
    Expect(1, 66928, '\P{ In_Caucasian_albanian}', "");
    Expect(0, 66928, '\P{^ In_Caucasian_albanian}', "");
    Error('\p{_:=IN_Caucasian_albanian}');
    Error('\P{_:=IN_Caucasian_albanian}');
    Expect(1, 66927, '\p{_-in_Caucasian_albanian}', "");
    Expect(0, 66927, '\p{^_-in_Caucasian_albanian}', "");
    Expect(0, 66927, '\P{_-in_Caucasian_albanian}', "");
    Expect(1, 66927, '\P{^_-in_Caucasian_albanian}', "");
    Expect(0, 66928, '\p{_-in_Caucasian_albanian}', "");
    Expect(1, 66928, '\p{^_-in_Caucasian_albanian}', "");
    Expect(1, 66928, '\P{_-in_Caucasian_albanian}', "");
    Expect(0, 66928, '\P{^_-in_Caucasian_albanian}', "");
    Error('\p{:=In_Chakma}');
    Error('\P{:=In_Chakma}');
    Expect(1, 69967, '\p{inchakma}', "");
    Expect(0, 69967, '\p{^inchakma}', "");
    Expect(0, 69967, '\P{inchakma}', "");
    Expect(1, 69967, '\P{^inchakma}', "");
    Expect(0, 69968, '\p{inchakma}', "");
    Expect(1, 69968, '\p{^inchakma}', "");
    Expect(1, 69968, '\P{inchakma}', "");
    Expect(0, 69968, '\P{^inchakma}', "");
    Expect(1, 69967, '\p{_-In_CHAKMA}', "");
    Expect(0, 69967, '\p{^_-In_CHAKMA}', "");
    Expect(0, 69967, '\P{_-In_CHAKMA}', "");
    Expect(1, 69967, '\P{^_-In_CHAKMA}', "");
    Expect(0, 69968, '\p{_-In_CHAKMA}', "");
    Expect(1, 69968, '\p{^_-In_CHAKMA}', "");
    Expect(1, 69968, '\P{_-In_CHAKMA}', "");
    Expect(0, 69968, '\P{^_-In_CHAKMA}', "");
    Error('\p{/a/  In_Chakma}');
    Error('\P{/a/  In_Chakma}');
    Expect(1, 69967, '\p{	_In_CHAKMA}', "");
    Expect(0, 69967, '\p{^	_In_CHAKMA}', "");
    Expect(0, 69967, '\P{	_In_CHAKMA}', "");
    Expect(1, 69967, '\P{^	_In_CHAKMA}', "");
    Expect(0, 69968, '\p{	_In_CHAKMA}', "");
    Expect(1, 69968, '\p{^	_In_CHAKMA}', "");
    Expect(1, 69968, '\P{	_In_CHAKMA}', "");
    Expect(0, 69968, '\P{^	_In_CHAKMA}', "");
    Error('\p{-IN_CHAM:=}');
    Error('\P{-IN_CHAM:=}');
    Expect(1, 43615, '\p{incham}', "");
    Expect(0, 43615, '\p{^incham}', "");
    Expect(0, 43615, '\P{incham}', "");
    Expect(1, 43615, '\P{^incham}', "");
    Expect(0, 43616, '\p{incham}', "");
    Expect(1, 43616, '\p{^incham}', "");
    Expect(1, 43616, '\P{incham}', "");
    Expect(0, 43616, '\P{^incham}', "");
    Expect(1, 43615, '\p{- In_CHAM}', "");
    Expect(0, 43615, '\p{^- In_CHAM}', "");
    Expect(0, 43615, '\P{- In_CHAM}', "");
    Expect(1, 43615, '\P{^- In_CHAM}', "");
    Expect(0, 43616, '\p{- In_CHAM}', "");
    Expect(1, 43616, '\p{^- In_CHAM}', "");
    Expect(1, 43616, '\P{- In_CHAM}', "");
    Expect(0, 43616, '\P{^- In_CHAM}', "");
    Error('\p{-:=IN_Cham}');
    Error('\P{-:=IN_Cham}');
    Expect(1, 43615, '\p{		IN_CHAM}', "");
    Expect(0, 43615, '\p{^		IN_CHAM}', "");
    Expect(0, 43615, '\P{		IN_CHAM}', "");
    Expect(1, 43615, '\P{^		IN_CHAM}', "");
    Expect(0, 43616, '\p{		IN_CHAM}', "");
    Expect(1, 43616, '\p{^		IN_CHAM}', "");
    Expect(1, 43616, '\P{		IN_CHAM}', "");
    Expect(0, 43616, '\P{^		IN_CHAM}', "");
    Error('\p{ 	in_Cherokee/a/}');
    Error('\P{ 	in_Cherokee/a/}');
    Expect(1, 5119, '\p{incherokee}', "");
    Expect(0, 5119, '\p{^incherokee}', "");
    Expect(0, 5119, '\P{incherokee}', "");
    Expect(1, 5119, '\P{^incherokee}', "");
    Expect(0, 5120, '\p{incherokee}', "");
    Expect(1, 5120, '\p{^incherokee}', "");
    Expect(1, 5120, '\P{incherokee}', "");
    Expect(0, 5120, '\P{^incherokee}', "");
    Expect(1, 5119, '\p{	_In_Cherokee}', "");
    Expect(0, 5119, '\p{^	_In_Cherokee}', "");
    Expect(0, 5119, '\P{	_In_Cherokee}', "");
    Expect(1, 5119, '\P{^	_In_Cherokee}', "");
    Expect(0, 5120, '\p{	_In_Cherokee}', "");
    Expect(1, 5120, '\p{^	_In_Cherokee}', "");
    Expect(1, 5120, '\P{	_In_Cherokee}', "");
    Expect(0, 5120, '\P{^	_In_Cherokee}', "");
    Error('\p{ :=In_CHEROKEE}');
    Error('\P{ :=In_CHEROKEE}');
    Expect(1, 5119, '\p{	-In_cherokee}', "");
    Expect(0, 5119, '\p{^	-In_cherokee}', "");
    Expect(0, 5119, '\P{	-In_cherokee}', "");
    Expect(1, 5119, '\P{^	-In_cherokee}', "");
    Expect(0, 5120, '\p{	-In_cherokee}', "");
    Expect(1, 5120, '\p{^	-In_cherokee}', "");
    Expect(1, 5120, '\P{	-In_cherokee}', "");
    Expect(0, 5120, '\P{^	-In_cherokee}', "");
    Error('\p{/a/ _IN_chorasmian}');
    Error('\P{/a/ _IN_chorasmian}');
    Expect(1, 69599, '\p{inchorasmian}', "");
    Expect(0, 69599, '\p{^inchorasmian}', "");
    Expect(0, 69599, '\P{inchorasmian}', "");
    Expect(1, 69599, '\P{^inchorasmian}', "");
    Expect(0, 69600, '\p{inchorasmian}', "");
    Expect(1, 69600, '\p{^inchorasmian}', "");
    Expect(1, 69600, '\P{inchorasmian}', "");
    Expect(0, 69600, '\P{^inchorasmian}', "");
    Expect(1, 69599, '\p{- in_Chorasmian}', "");
    Expect(0, 69599, '\p{^- in_Chorasmian}', "");
    Expect(0, 69599, '\P{- in_Chorasmian}', "");
    Expect(1, 69599, '\P{^- in_Chorasmian}', "");
    Expect(0, 69600, '\p{- in_Chorasmian}', "");
    Expect(1, 69600, '\p{^- in_Chorasmian}', "");
    Expect(1, 69600, '\P{- in_Chorasmian}', "");
    Expect(0, 69600, '\P{^- in_Chorasmian}', "");
    Error('\p{ 	IN_chorasmian:=}');
    Error('\P{ 	IN_chorasmian:=}');
    Expect(1, 69599, '\p{	-in_Chorasmian}', "");
    Expect(0, 69599, '\p{^	-in_Chorasmian}', "");
    Expect(0, 69599, '\P{	-in_Chorasmian}', "");
    Expect(1, 69599, '\P{^	-in_Chorasmian}', "");
    Expect(0, 69600, '\p{	-in_Chorasmian}', "");
    Expect(1, 69600, '\p{^	-in_Chorasmian}', "");
    Expect(1, 69600, '\P{	-in_Chorasmian}', "");
    Expect(0, 69600, '\P{^	-in_Chorasmian}', "");
    Error('\p{_:=in_Coptic}');
    Error('\P{_:=in_Coptic}');
    Expect(1, 11519, '\p{incoptic}', "");
    Expect(0, 11519, '\p{^incoptic}', "");
    Expect(0, 11519, '\P{incoptic}', "");
    Expect(1, 11519, '\P{^incoptic}', "");
    Expect(0, 11520, '\p{incoptic}', "");
    Expect(1, 11520, '\p{^incoptic}', "");
    Expect(1, 11520, '\P{incoptic}', "");
    Expect(0, 11520, '\P{^incoptic}', "");
    Expect(1, 11519, '\p{ -IN_Coptic}', "");
    Expect(0, 11519, '\p{^ -IN_Coptic}', "");
    Expect(0, 11519, '\P{ -IN_Coptic}', "");
    Expect(1, 11519, '\P{^ -IN_Coptic}', "");
    Expect(0, 11520, '\p{ -IN_Coptic}', "");
    Expect(1, 11520, '\p{^ -IN_Coptic}', "");
    Expect(1, 11520, '\P{ -IN_Coptic}', "");
    Expect(0, 11520, '\P{^ -IN_Coptic}', "");
    Error('\p{-_IN_coptic/a/}');
    Error('\P{-_IN_coptic/a/}');
    Expect(1, 11519, '\p{-	In_Coptic}', "");
    Expect(0, 11519, '\p{^-	In_Coptic}', "");
    Expect(0, 11519, '\P{-	In_Coptic}', "");
    Expect(1, 11519, '\P{^-	In_Coptic}', "");
    Expect(0, 11520, '\p{-	In_Coptic}', "");
    Expect(1, 11520, '\p{^-	In_Coptic}', "");
    Expect(1, 11520, '\P{-	In_Coptic}', "");
    Expect(0, 11520, '\P{^-	In_Coptic}', "");
    Error('\p{/a/ _In_Cuneiform}');
    Error('\P{/a/ _In_Cuneiform}');
    Expect(1, 74751, '\p{incuneiform}', "");
    Expect(0, 74751, '\p{^incuneiform}', "");
    Expect(0, 74751, '\P{incuneiform}', "");
    Expect(1, 74751, '\P{^incuneiform}', "");
    Expect(0, 74752, '\p{incuneiform}', "");
    Expect(1, 74752, '\p{^incuneiform}', "");
    Expect(1, 74752, '\P{incuneiform}', "");
    Expect(0, 74752, '\P{^incuneiform}', "");
    Expect(1, 74751, '\p{--In_Cuneiform}', "");
    Expect(0, 74751, '\p{^--In_Cuneiform}', "");
    Expect(0, 74751, '\P{--In_Cuneiform}', "");
    Expect(1, 74751, '\P{^--In_Cuneiform}', "");
    Expect(0, 74752, '\p{--In_Cuneiform}', "");
    Expect(1, 74752, '\p{^--In_Cuneiform}', "");
    Expect(1, 74752, '\P{--In_Cuneiform}', "");
    Expect(0, 74752, '\P{^--In_Cuneiform}', "");
    Error('\p{:= in_CUNEIFORM}');
    Error('\P{:= in_CUNEIFORM}');
    Expect(1, 74751, '\p{	In_CUNEIFORM}', "");
    Expect(0, 74751, '\p{^	In_CUNEIFORM}', "");
    Expect(0, 74751, '\P{	In_CUNEIFORM}', "");
    Expect(1, 74751, '\P{^	In_CUNEIFORM}', "");
    Expect(0, 74752, '\p{	In_CUNEIFORM}', "");
    Expect(1, 74752, '\p{^	In_CUNEIFORM}', "");
    Expect(1, 74752, '\P{	In_CUNEIFORM}', "");
    Expect(0, 74752, '\P{^	In_CUNEIFORM}', "");
    Error('\p{:=__IN_Cyrillic}');
    Error('\P{:=__IN_Cyrillic}');
    Expect(1, 1279, '\p{incyrillic}', "");
    Expect(0, 1279, '\p{^incyrillic}', "");
    Expect(0, 1279, '\P{incyrillic}', "");
    Expect(1, 1279, '\P{^incyrillic}', "");
    Expect(0, 1280, '\p{incyrillic}', "");
    Expect(1, 1280, '\p{^incyrillic}', "");
    Expect(1, 1280, '\P{incyrillic}', "");
    Expect(0, 1280, '\P{^incyrillic}', "");
    Expect(1, 1279, '\p{ _In_CYRILLIC}', "");
    Expect(0, 1279, '\p{^ _In_CYRILLIC}', "");
    Expect(0, 1279, '\P{ _In_CYRILLIC}', "");
    Expect(1, 1279, '\P{^ _In_CYRILLIC}', "");
    Expect(0, 1280, '\p{ _In_CYRILLIC}', "");
    Expect(1, 1280, '\p{^ _In_CYRILLIC}', "");
    Expect(1, 1280, '\P{ _In_CYRILLIC}', "");
    Expect(0, 1280, '\P{^ _In_CYRILLIC}', "");
    Error('\p{-/a/In_CYRILLIC}');
    Error('\P{-/a/In_CYRILLIC}');
    Expect(1, 1279, '\p{ -In_Cyrillic}', "");
    Expect(0, 1279, '\p{^ -In_Cyrillic}', "");
    Expect(0, 1279, '\P{ -In_Cyrillic}', "");
    Expect(1, 1279, '\P{^ -In_Cyrillic}', "");
    Expect(0, 1280, '\p{ -In_Cyrillic}', "");
    Expect(1, 1280, '\p{^ -In_Cyrillic}', "");
    Expect(1, 1280, '\P{ -In_Cyrillic}', "");
    Expect(0, 1280, '\P{^ -In_Cyrillic}', "");
    Error('\p{/a/--in_Deseret}');
    Error('\P{/a/--in_Deseret}');
    Expect(1, 66639, '\p{indeseret}', "");
    Expect(0, 66639, '\p{^indeseret}', "");
    Expect(0, 66639, '\P{indeseret}', "");
    Expect(1, 66639, '\P{^indeseret}', "");
    Expect(0, 66640, '\p{indeseret}', "");
    Expect(1, 66640, '\p{^indeseret}', "");
    Expect(1, 66640, '\P{indeseret}', "");
    Expect(0, 66640, '\P{^indeseret}', "");
    Expect(1, 66639, '\p{ 	In_DESERET}', "");
    Expect(0, 66639, '\p{^ 	In_DESERET}', "");
    Expect(0, 66639, '\P{ 	In_DESERET}', "");
    Expect(1, 66639, '\P{^ 	In_DESERET}', "");
    Expect(0, 66640, '\p{ 	In_DESERET}', "");
    Expect(1, 66640, '\p{^ 	In_DESERET}', "");
    Expect(1, 66640, '\P{ 	In_DESERET}', "");
    Expect(0, 66640, '\P{^ 	In_DESERET}', "");
    Error('\p{:=	_in_Deseret}');
    Error('\P{:=	_in_Deseret}');
    Expect(1, 66639, '\p{-	In_Deseret}', "");
    Expect(0, 66639, '\p{^-	In_Deseret}', "");
    Expect(0, 66639, '\P{-	In_Deseret}', "");
    Expect(1, 66639, '\P{^-	In_Deseret}', "");
    Expect(0, 66640, '\p{-	In_Deseret}', "");
    Expect(1, 66640, '\p{^-	In_Deseret}', "");
    Expect(1, 66640, '\P{-	In_Deseret}', "");
    Expect(0, 66640, '\P{^-	In_Deseret}', "");
    Error('\p{	:=in_Devanagari}');
    Error('\P{	:=in_Devanagari}');
    Expect(1, 2431, '\p{indevanagari}', "");
    Expect(0, 2431, '\p{^indevanagari}', "");
    Expect(0, 2431, '\P{indevanagari}', "");
    Expect(1, 2431, '\P{^indevanagari}', "");
    Expect(0, 2432, '\p{indevanagari}', "");
    Expect(1, 2432, '\p{^indevanagari}', "");
    Expect(1, 2432, '\P{indevanagari}', "");
    Expect(0, 2432, '\P{^indevanagari}', "");
    Expect(1, 2431, '\p{ in_Devanagari}', "");
    Expect(0, 2431, '\p{^ in_Devanagari}', "");
    Expect(0, 2431, '\P{ in_Devanagari}', "");
    Expect(1, 2431, '\P{^ in_Devanagari}', "");
    Expect(0, 2432, '\p{ in_Devanagari}', "");
    Expect(1, 2432, '\p{^ in_Devanagari}', "");
    Expect(1, 2432, '\P{ in_Devanagari}', "");
    Expect(0, 2432, '\P{^ in_Devanagari}', "");
    Error('\p{_:=In_Devanagari}');
    Error('\P{_:=In_Devanagari}');
    Expect(1, 2431, '\p{_in_DEVANAGARI}', "");
    Expect(0, 2431, '\p{^_in_DEVANAGARI}', "");
    Expect(0, 2431, '\P{_in_DEVANAGARI}', "");
    Expect(1, 2431, '\P{^_in_DEVANAGARI}', "");
    Expect(0, 2432, '\p{_in_DEVANAGARI}', "");
    Expect(1, 2432, '\p{^_in_DEVANAGARI}', "");
    Expect(1, 2432, '\P{_in_DEVANAGARI}', "");
    Expect(0, 2432, '\P{^_in_DEVANAGARI}', "");
    Error('\p{_in_dives_AKURU:=}');
    Error('\P{_in_dives_AKURU:=}');
    Expect(1, 72031, '\p{indivesakuru}', "");
    Expect(0, 72031, '\p{^indivesakuru}', "");
    Expect(0, 72031, '\P{indivesakuru}', "");
    Expect(1, 72031, '\P{^indivesakuru}', "");
    Expect(0, 72032, '\p{indivesakuru}', "");
    Expect(1, 72032, '\p{^indivesakuru}', "");
    Expect(1, 72032, '\P{indivesakuru}', "");
    Expect(0, 72032, '\P{^indivesakuru}', "");
    Expect(1, 72031, '\p{-In_DIVES_AKURU}', "");
    Expect(0, 72031, '\p{^-In_DIVES_AKURU}', "");
    Expect(0, 72031, '\P{-In_DIVES_AKURU}', "");
    Expect(1, 72031, '\P{^-In_DIVES_AKURU}', "");
    Expect(0, 72032, '\p{-In_DIVES_AKURU}', "");
    Expect(1, 72032, '\p{^-In_DIVES_AKURU}', "");
    Expect(1, 72032, '\P{-In_DIVES_AKURU}', "");
    Expect(0, 72032, '\P{^-In_DIVES_AKURU}', "");
    Error('\p{/a/_ In_Dives_Akuru}');
    Error('\P{/a/_ In_Dives_Akuru}');
    Expect(1, 72031, '\p{	 In_dives_AKURU}', "");
    Expect(0, 72031, '\p{^	 In_dives_AKURU}', "");
    Expect(0, 72031, '\P{	 In_dives_AKURU}', "");
    Expect(1, 72031, '\P{^	 In_dives_AKURU}', "");
    Expect(0, 72032, '\p{	 In_dives_AKURU}', "");
    Expect(1, 72032, '\p{^	 In_dives_AKURU}', "");
    Expect(1, 72032, '\P{	 In_dives_AKURU}', "");
    Expect(0, 72032, '\P{^	 In_dives_AKURU}', "");
    Error('\p{ IN_dogra:=}');
    Error('\P{ IN_dogra:=}');
    Expect(1, 71759, '\p{indogra}', "");
    Expect(0, 71759, '\p{^indogra}', "");
    Expect(0, 71759, '\P{indogra}', "");
    Expect(1, 71759, '\P{^indogra}', "");
    Expect(0, 71760, '\p{indogra}', "");
    Expect(1, 71760, '\p{^indogra}', "");
    Expect(1, 71760, '\P{indogra}', "");
    Expect(0, 71760, '\P{^indogra}', "");
    Expect(1, 71759, '\p{-in_DOGRA}', "");
    Expect(0, 71759, '\p{^-in_DOGRA}', "");
    Expect(0, 71759, '\P{-in_DOGRA}', "");
    Expect(1, 71759, '\P{^-in_DOGRA}', "");
    Expect(0, 71760, '\p{-in_DOGRA}', "");
    Expect(1, 71760, '\p{^-in_DOGRA}', "");
    Expect(1, 71760, '\P{-in_DOGRA}', "");
    Expect(0, 71760, '\P{^-in_DOGRA}', "");
    Error('\p{_/a/in_dogra}');
    Error('\P{_/a/in_dogra}');
    Expect(1, 71759, '\p{ 	In_dogra}', "");
    Expect(0, 71759, '\p{^ 	In_dogra}', "");
    Expect(0, 71759, '\P{ 	In_dogra}', "");
    Expect(1, 71759, '\P{^ 	In_dogra}', "");
    Expect(0, 71760, '\p{ 	In_dogra}', "");
    Expect(1, 71760, '\p{^ 	In_dogra}', "");
    Expect(1, 71760, '\P{ 	In_dogra}', "");
    Expect(0, 71760, '\P{^ 	In_dogra}', "");
    Error('\p{_-IN_duployan/a/}');
    Error('\P{_-IN_duployan/a/}');
    Expect(1, 113823, '\p{induployan}', "");
    Expect(0, 113823, '\p{^induployan}', "");
    Expect(0, 113823, '\P{induployan}', "");
    Expect(1, 113823, '\P{^induployan}', "");
    Expect(0, 113824, '\p{induployan}', "");
    Expect(1, 113824, '\p{^induployan}', "");
    Expect(1, 113824, '\P{induployan}', "");
    Expect(0, 113824, '\P{^induployan}', "");
    Expect(1, 113823, '\p{	In_DUPLOYAN}', "");
    Expect(0, 113823, '\p{^	In_DUPLOYAN}', "");
    Expect(0, 113823, '\P{	In_DUPLOYAN}', "");
    Expect(1, 113823, '\P{^	In_DUPLOYAN}', "");
    Expect(0, 113824, '\p{	In_DUPLOYAN}', "");
    Expect(1, 113824, '\p{^	In_DUPLOYAN}', "");
    Expect(1, 113824, '\P{	In_DUPLOYAN}', "");
    Expect(0, 113824, '\P{^	In_DUPLOYAN}', "");
    Error('\p{:= -In_DUPLOYAN}');
    Error('\P{:= -In_DUPLOYAN}');
    Expect(1, 113823, '\p{	 IN_Duployan}', "");
    Expect(0, 113823, '\p{^	 IN_Duployan}', "");
    Expect(0, 113823, '\P{	 IN_Duployan}', "");
    Expect(1, 113823, '\P{^	 IN_Duployan}', "");
    Expect(0, 113824, '\p{	 IN_Duployan}', "");
    Expect(1, 113824, '\p{^	 IN_Duployan}', "");
    Expect(1, 113824, '\P{	 IN_Duployan}', "");
    Expect(0, 113824, '\P{^	 IN_Duployan}', "");
    Error('\p{ _In_EGYPTIAN_HIEROGLYPHS:=}');
    Error('\P{ _In_EGYPTIAN_HIEROGLYPHS:=}');
    Expect(1, 78895, '\p{inegyptianhieroglyphs}', "");
    Expect(0, 78895, '\p{^inegyptianhieroglyphs}', "");
    Expect(0, 78895, '\P{inegyptianhieroglyphs}', "");
    Expect(1, 78895, '\P{^inegyptianhieroglyphs}', "");
    Expect(0, 78896, '\p{inegyptianhieroglyphs}', "");
    Expect(1, 78896, '\p{^inegyptianhieroglyphs}', "");
    Expect(1, 78896, '\P{inegyptianhieroglyphs}', "");
    Expect(0, 78896, '\P{^inegyptianhieroglyphs}', "");
    Expect(1, 78895, '\p{In_Egyptian_Hieroglyphs}', "");
    Expect(0, 78895, '\p{^In_Egyptian_Hieroglyphs}', "");
    Expect(0, 78895, '\P{In_Egyptian_Hieroglyphs}', "");
    Expect(1, 78895, '\P{^In_Egyptian_Hieroglyphs}', "");
    Expect(0, 78896, '\p{In_Egyptian_Hieroglyphs}', "");
    Expect(1, 78896, '\p{^In_Egyptian_Hieroglyphs}', "");
    Expect(1, 78896, '\P{In_Egyptian_Hieroglyphs}', "");
    Expect(0, 78896, '\P{^In_Egyptian_Hieroglyphs}', "");
    Error('\p{/a/	 In_EGYPTIAN_Hieroglyphs}');
    Error('\P{/a/	 In_EGYPTIAN_Hieroglyphs}');
    Expect(1, 78895, '\p{ -In_Egyptian_hieroglyphs}', "");
    Expect(0, 78895, '\p{^ -In_Egyptian_hieroglyphs}', "");
    Expect(0, 78895, '\P{ -In_Egyptian_hieroglyphs}', "");
    Expect(1, 78895, '\P{^ -In_Egyptian_hieroglyphs}', "");
    Expect(0, 78896, '\p{ -In_Egyptian_hieroglyphs}', "");
    Expect(1, 78896, '\p{^ -In_Egyptian_hieroglyphs}', "");
    Expect(1, 78896, '\P{ -In_Egyptian_hieroglyphs}', "");
    Expect(0, 78896, '\P{^ -In_Egyptian_hieroglyphs}', "");
    Error('\p{	_In_ELBASAN/a/}');
    Error('\P{	_In_ELBASAN/a/}');
    Expect(1, 66863, '\p{inelbasan}', "");
    Expect(0, 66863, '\p{^inelbasan}', "");
    Expect(0, 66863, '\P{inelbasan}', "");
    Expect(1, 66863, '\P{^inelbasan}', "");
    Expect(0, 66864, '\p{inelbasan}', "");
    Expect(1, 66864, '\p{^inelbasan}', "");
    Expect(1, 66864, '\P{inelbasan}', "");
    Expect(0, 66864, '\P{^inelbasan}', "");
    Expect(1, 66863, '\p{	_in_Elbasan}', "");
    Expect(0, 66863, '\p{^	_in_Elbasan}', "");
    Expect(0, 66863, '\P{	_in_Elbasan}', "");
    Expect(1, 66863, '\P{^	_in_Elbasan}', "");
    Expect(0, 66864, '\p{	_in_Elbasan}', "");
    Expect(1, 66864, '\p{^	_in_Elbasan}', "");
    Expect(1, 66864, '\P{	_in_Elbasan}', "");
    Expect(0, 66864, '\P{^	_in_Elbasan}', "");
    Error('\p{_In_Elbasan/a/}');
    Error('\P{_In_Elbasan/a/}');
    Expect(1, 66863, '\p{-in_Elbasan}', "");
    Expect(0, 66863, '\p{^-in_Elbasan}', "");
    Expect(0, 66863, '\P{-in_Elbasan}', "");
    Expect(1, 66863, '\P{^-in_Elbasan}', "");
    Expect(0, 66864, '\p{-in_Elbasan}', "");
    Expect(1, 66864, '\p{^-in_Elbasan}', "");
    Expect(1, 66864, '\P{-in_Elbasan}', "");
    Expect(0, 66864, '\P{^-in_Elbasan}', "");
    Error('\p{:=		in_ELYMAIC}');
    Error('\P{:=		in_ELYMAIC}');
    Expect(1, 69631, '\p{inelymaic}', "");
    Expect(0, 69631, '\p{^inelymaic}', "");
    Expect(0, 69631, '\P{inelymaic}', "");
    Expect(1, 69631, '\P{^inelymaic}', "");
    Expect(0, 69632, '\p{inelymaic}', "");
    Expect(1, 69632, '\p{^inelymaic}', "");
    Expect(1, 69632, '\P{inelymaic}', "");
    Expect(0, 69632, '\P{^inelymaic}', "");
    Expect(1, 69631, '\p{  In_ELYMAIC}', "");
    Expect(0, 69631, '\p{^  In_ELYMAIC}', "");
    Expect(0, 69631, '\P{  In_ELYMAIC}', "");
    Expect(1, 69631, '\P{^  In_ELYMAIC}', "");
    Expect(0, 69632, '\p{  In_ELYMAIC}', "");
    Expect(1, 69632, '\p{^  In_ELYMAIC}', "");
    Expect(1, 69632, '\P{  In_ELYMAIC}', "");
    Expect(0, 69632, '\P{^  In_ELYMAIC}', "");
    Error('\p{In_Elymaic/a/}');
    Error('\P{In_Elymaic/a/}');
    Expect(1, 69631, '\p{ In_elymaic}', "");
    Expect(0, 69631, '\p{^ In_elymaic}', "");
    Expect(0, 69631, '\P{ In_elymaic}', "");
    Expect(1, 69631, '\P{^ In_elymaic}', "");
    Expect(0, 69632, '\p{ In_elymaic}', "");
    Expect(1, 69632, '\p{^ In_elymaic}', "");
    Expect(1, 69632, '\P{ In_elymaic}', "");
    Expect(0, 69632, '\P{^ In_elymaic}', "");
    Error('\p{--IN_Ethiopic:=}');
    Error('\P{--IN_Ethiopic:=}');
    Expect(1, 4991, '\p{inethiopic}', "");
    Expect(0, 4991, '\p{^inethiopic}', "");
    Expect(0, 4991, '\P{inethiopic}', "");
    Expect(1, 4991, '\P{^inethiopic}', "");
    Expect(0, 4992, '\p{inethiopic}', "");
    Expect(1, 4992, '\p{^inethiopic}', "");
    Expect(1, 4992, '\P{inethiopic}', "");
    Expect(0, 4992, '\P{^inethiopic}', "");
    Expect(1, 4991, '\p{-	In_Ethiopic}', "");
    Expect(0, 4991, '\p{^-	In_Ethiopic}', "");
    Expect(0, 4991, '\P{-	In_Ethiopic}', "");
    Expect(1, 4991, '\P{^-	In_Ethiopic}', "");
    Expect(0, 4992, '\p{-	In_Ethiopic}', "");
    Expect(1, 4992, '\p{^-	In_Ethiopic}', "");
    Expect(1, 4992, '\P{-	In_Ethiopic}', "");
    Expect(0, 4992, '\P{^-	In_Ethiopic}', "");
    Error('\p{:=-	IN_ethiopic}');
    Error('\P{:=-	IN_ethiopic}');
    Expect(1, 4991, '\p{-in_Ethiopic}', "");
    Expect(0, 4991, '\p{^-in_Ethiopic}', "");
    Expect(0, 4991, '\P{-in_Ethiopic}', "");
    Expect(1, 4991, '\P{^-in_Ethiopic}', "");
    Expect(0, 4992, '\p{-in_Ethiopic}', "");
    Expect(1, 4992, '\p{^-in_Ethiopic}', "");
    Expect(1, 4992, '\P{-in_Ethiopic}', "");
    Expect(0, 4992, '\P{^-in_Ethiopic}', "");
    Error('\p{:=	_in_Georgian}');
    Error('\P{:=	_in_Georgian}');
    Expect(1, 4351, '\p{ingeorgian}', "");
    Expect(0, 4351, '\p{^ingeorgian}', "");
    Expect(0, 4351, '\P{ingeorgian}', "");
    Expect(1, 4351, '\P{^ingeorgian}', "");
    Expect(0, 4352, '\p{ingeorgian}', "");
    Expect(1, 4352, '\p{^ingeorgian}', "");
    Expect(1, 4352, '\P{ingeorgian}', "");
    Expect(0, 4352, '\P{^ingeorgian}', "");
    Expect(1, 4351, '\p{	-In_Georgian}', "");
    Expect(0, 4351, '\p{^	-In_Georgian}', "");
    Expect(0, 4351, '\P{	-In_Georgian}', "");
    Expect(1, 4351, '\P{^	-In_Georgian}', "");
    Expect(0, 4352, '\p{	-In_Georgian}', "");
    Expect(1, 4352, '\p{^	-In_Georgian}', "");
    Expect(1, 4352, '\P{	-In_Georgian}', "");
    Expect(0, 4352, '\P{^	-In_Georgian}', "");
    Error('\p{_	In_Georgian/a/}');
    Error('\P{_	In_Georgian/a/}');
    Expect(1, 4351, '\p{- In_Georgian}', "");
    Expect(0, 4351, '\p{^- In_Georgian}', "");
    Expect(0, 4351, '\P{- In_Georgian}', "");
    Expect(1, 4351, '\P{^- In_Georgian}', "");
    Expect(0, 4352, '\p{- In_Georgian}', "");
    Expect(1, 4352, '\p{^- In_Georgian}', "");
    Expect(1, 4352, '\P{- In_Georgian}', "");
    Expect(0, 4352, '\P{^- In_Georgian}', "");
    Error('\p{:=	In_GLAGOLITIC}');
    Error('\P{:=	In_GLAGOLITIC}');
    Expect(1, 11359, '\p{inglagolitic}', "");
    Expect(0, 11359, '\p{^inglagolitic}', "");
    Expect(0, 11359, '\P{inglagolitic}', "");
    Expect(1, 11359, '\P{^inglagolitic}', "");
    Expect(0, 11360, '\p{inglagolitic}', "");
    Expect(1, 11360, '\p{^inglagolitic}', "");
    Expect(1, 11360, '\P{inglagolitic}', "");
    Expect(0, 11360, '\P{^inglagolitic}', "");
    Expect(1, 11359, '\p{- in_Glagolitic}', "");
    Expect(0, 11359, '\p{^- in_Glagolitic}', "");
    Expect(0, 11359, '\P{- in_Glagolitic}', "");
    Expect(1, 11359, '\P{^- in_Glagolitic}', "");
    Expect(0, 11360, '\p{- in_Glagolitic}', "");
    Expect(1, 11360, '\p{^- in_Glagolitic}', "");
    Expect(1, 11360, '\P{- in_Glagolitic}', "");
    Expect(0, 11360, '\P{^- in_Glagolitic}', "");
    Error('\p{:=-IN_Glagolitic}');
    Error('\P{:=-IN_Glagolitic}');
    Expect(1, 11359, '\p{IN_Glagolitic}', "");
    Expect(0, 11359, '\p{^IN_Glagolitic}', "");
    Expect(0, 11359, '\P{IN_Glagolitic}', "");
    Expect(1, 11359, '\P{^IN_Glagolitic}', "");
    Expect(0, 11360, '\p{IN_Glagolitic}', "");
    Expect(1, 11360, '\p{^IN_Glagolitic}', "");
    Expect(1, 11360, '\P{IN_Glagolitic}', "");
    Expect(0, 11360, '\P{^IN_Glagolitic}', "");
    Error('\p{_	IN_GOTHIC/a/}');
    Error('\P{_	IN_GOTHIC/a/}');
    Expect(1, 66383, '\p{ingothic}', "");
    Expect(0, 66383, '\p{^ingothic}', "");
    Expect(0, 66383, '\P{ingothic}', "");
    Expect(1, 66383, '\P{^ingothic}', "");
    Expect(0, 66384, '\p{ingothic}', "");
    Expect(1, 66384, '\p{^ingothic}', "");
    Expect(1, 66384, '\P{ingothic}', "");
    Expect(0, 66384, '\P{^ingothic}', "");
    Expect(1, 66383, '\p{_ IN_Gothic}', "");
    Expect(0, 66383, '\p{^_ IN_Gothic}', "");
    Expect(0, 66383, '\P{_ IN_Gothic}', "");
    Expect(1, 66383, '\P{^_ IN_Gothic}', "");
    Expect(0, 66384, '\p{_ IN_Gothic}', "");
    Expect(1, 66384, '\p{^_ IN_Gothic}', "");
    Expect(1, 66384, '\P{_ IN_Gothic}', "");
    Expect(0, 66384, '\P{^_ IN_Gothic}', "");
    Error('\p{/a/	in_Gothic}');
    Error('\P{/a/	in_Gothic}');
    Expect(1, 66383, '\p{-_IN_gothic}', "");
    Expect(0, 66383, '\p{^-_IN_gothic}', "");
    Expect(0, 66383, '\P{-_IN_gothic}', "");
    Expect(1, 66383, '\P{^-_IN_gothic}', "");
    Expect(0, 66384, '\p{-_IN_gothic}', "");
    Expect(1, 66384, '\p{^-_IN_gothic}', "");
    Expect(1, 66384, '\P{-_IN_gothic}', "");
    Expect(0, 66384, '\P{^-_IN_gothic}', "");
    Error('\p{/a/-	In_Grantha}');
    Error('\P{/a/-	In_Grantha}');
    Expect(1, 70527, '\p{ingrantha}', "");
    Expect(0, 70527, '\p{^ingrantha}', "");
    Expect(0, 70527, '\P{ingrantha}', "");
    Expect(1, 70527, '\P{^ingrantha}', "");
    Expect(0, 70528, '\p{ingrantha}', "");
    Expect(1, 70528, '\p{^ingrantha}', "");
    Expect(1, 70528, '\P{ingrantha}', "");
    Expect(0, 70528, '\P{^ingrantha}', "");
    Expect(1, 70527, '\p{_In_GRANTHA}', "");
    Expect(0, 70527, '\p{^_In_GRANTHA}', "");
    Expect(0, 70527, '\P{_In_GRANTHA}', "");
    Expect(1, 70527, '\P{^_In_GRANTHA}', "");
    Expect(0, 70528, '\p{_In_GRANTHA}', "");
    Expect(1, 70528, '\p{^_In_GRANTHA}', "");
    Expect(1, 70528, '\P{_In_GRANTHA}', "");
    Expect(0, 70528, '\P{^_In_GRANTHA}', "");
    Error('\p{:=In_Grantha}');
    Error('\P{:=In_Grantha}');
    Expect(1, 70527, '\p{-IN_Grantha}', "");
    Expect(0, 70527, '\p{^-IN_Grantha}', "");
    Expect(0, 70527, '\P{-IN_Grantha}', "");
    Expect(1, 70527, '\P{^-IN_Grantha}', "");
    Expect(0, 70528, '\p{-IN_Grantha}', "");
    Expect(1, 70528, '\p{^-IN_Grantha}', "");
    Expect(1, 70528, '\P{-IN_Grantha}', "");
    Expect(0, 70528, '\P{^-IN_Grantha}', "");
    Error('\p{-/a/In_gujarati}');
    Error('\P{-/a/In_gujarati}');
    Expect(1, 2815, '\p{ingujarati}', "");
    Expect(0, 2815, '\p{^ingujarati}', "");
    Expect(0, 2815, '\P{ingujarati}', "");
    Expect(1, 2815, '\P{^ingujarati}', "");
    Expect(0, 2816, '\p{ingujarati}', "");
    Expect(1, 2816, '\p{^ingujarati}', "");
    Expect(1, 2816, '\P{ingujarati}', "");
    Expect(0, 2816, '\P{^ingujarati}', "");
    Expect(1, 2815, '\p{	-In_Gujarati}', "");
    Expect(0, 2815, '\p{^	-In_Gujarati}', "");
    Expect(0, 2815, '\P{	-In_Gujarati}', "");
    Expect(1, 2815, '\P{^	-In_Gujarati}', "");
    Expect(0, 2816, '\p{	-In_Gujarati}', "");
    Expect(1, 2816, '\p{^	-In_Gujarati}', "");
    Expect(1, 2816, '\P{	-In_Gujarati}', "");
    Expect(0, 2816, '\P{^	-In_Gujarati}', "");
    Error('\p{/a/_-in_Gujarati}');
    Error('\P{/a/_-in_Gujarati}');
    Expect(1, 2815, '\p{	In_Gujarati}', "");
    Expect(0, 2815, '\p{^	In_Gujarati}', "");
    Expect(0, 2815, '\P{	In_Gujarati}', "");
    Expect(1, 2815, '\P{^	In_Gujarati}', "");
    Expect(0, 2816, '\p{	In_Gujarati}', "");
    Expect(1, 2816, '\p{^	In_Gujarati}', "");
    Expect(1, 2816, '\P{	In_Gujarati}', "");
    Expect(0, 2816, '\P{^	In_Gujarati}', "");
    Error('\p{/a/	 In_Gunjala_GONDI}');
    Error('\P{/a/	 In_Gunjala_GONDI}');
    Expect(1, 73135, '\p{ingunjalagondi}', "");
    Expect(0, 73135, '\p{^ingunjalagondi}', "");
    Expect(0, 73135, '\P{ingunjalagondi}', "");
    Expect(1, 73135, '\P{^ingunjalagondi}', "");
    Expect(0, 73136, '\p{ingunjalagondi}', "");
    Expect(1, 73136, '\p{^ingunjalagondi}', "");
    Expect(1, 73136, '\P{ingunjalagondi}', "");
    Expect(0, 73136, '\P{^ingunjalagondi}', "");
    Expect(1, 73135, '\p{ _in_Gunjala_Gondi}', "");
    Expect(0, 73135, '\p{^ _in_Gunjala_Gondi}', "");
    Expect(0, 73135, '\P{ _in_Gunjala_Gondi}', "");
    Expect(1, 73135, '\P{^ _in_Gunjala_Gondi}', "");
    Expect(0, 73136, '\p{ _in_Gunjala_Gondi}', "");
    Expect(1, 73136, '\p{^ _in_Gunjala_Gondi}', "");
    Expect(1, 73136, '\P{ _in_Gunjala_Gondi}', "");
    Expect(0, 73136, '\P{^ _in_Gunjala_Gondi}', "");
    Error('\p{/a/	In_Gunjala_gondi}');
    Error('\P{/a/	In_Gunjala_gondi}');
    Expect(1, 73135, '\p{ 	IN_GUNJALA_GONDI}', "");
    Expect(0, 73135, '\p{^ 	IN_GUNJALA_GONDI}', "");
    Expect(0, 73135, '\P{ 	IN_GUNJALA_GONDI}', "");
    Expect(1, 73135, '\P{^ 	IN_GUNJALA_GONDI}', "");
    Expect(0, 73136, '\p{ 	IN_GUNJALA_GONDI}', "");
    Expect(1, 73136, '\p{^ 	IN_GUNJALA_GONDI}', "");
    Expect(1, 73136, '\P{ 	IN_GUNJALA_GONDI}', "");
    Expect(0, 73136, '\P{^ 	IN_GUNJALA_GONDI}', "");
    Error('\p{  In_gurmukhi:=}');
    Error('\P{  In_gurmukhi:=}');
    Expect(1, 2687, '\p{ingurmukhi}', "");
    Expect(0, 2687, '\p{^ingurmukhi}', "");
    Expect(0, 2687, '\P{ingurmukhi}', "");
    Expect(1, 2687, '\P{^ingurmukhi}', "");
    Expect(0, 2688, '\p{ingurmukhi}', "");
    Expect(1, 2688, '\p{^ingurmukhi}', "");
    Expect(1, 2688, '\P{ingurmukhi}', "");
    Expect(0, 2688, '\P{^ingurmukhi}', "");
    Expect(1, 2687, '\p{	 in_Gurmukhi}', "");
    Expect(0, 2687, '\p{^	 in_Gurmukhi}', "");
    Expect(0, 2687, '\P{	 in_Gurmukhi}', "");
    Expect(1, 2687, '\P{^	 in_Gurmukhi}', "");
    Expect(0, 2688, '\p{	 in_Gurmukhi}', "");
    Expect(1, 2688, '\p{^	 in_Gurmukhi}', "");
    Expect(1, 2688, '\P{	 in_Gurmukhi}', "");
    Expect(0, 2688, '\P{^	 in_Gurmukhi}', "");
    Error('\p{:=_In_gurmukhi}');
    Error('\P{:=_In_gurmukhi}');
    Expect(1, 2687, '\p{	In_GURMUKHI}', "");
    Expect(0, 2687, '\p{^	In_GURMUKHI}', "");
    Expect(0, 2687, '\P{	In_GURMUKHI}', "");
    Expect(1, 2687, '\P{^	In_GURMUKHI}', "");
    Expect(0, 2688, '\p{	In_GURMUKHI}', "");
    Expect(1, 2688, '\p{^	In_GURMUKHI}', "");
    Expect(1, 2688, '\P{	In_GURMUKHI}', "");
    Expect(0, 2688, '\P{^	In_GURMUKHI}', "");
    Error('\p{/a/	 IN_Hanifi_ROHINGYA}');
    Error('\P{/a/	 IN_Hanifi_ROHINGYA}');
    Expect(1, 68927, '\p{inhanifirohingya}', "");
    Expect(0, 68927, '\p{^inhanifirohingya}', "");
    Expect(0, 68927, '\P{inhanifirohingya}', "");
    Expect(1, 68927, '\P{^inhanifirohingya}', "");
    Expect(0, 68928, '\p{inhanifirohingya}', "");
    Expect(1, 68928, '\p{^inhanifirohingya}', "");
    Expect(1, 68928, '\P{inhanifirohingya}', "");
    Expect(0, 68928, '\P{^inhanifirohingya}', "");
    Expect(1, 68927, '\p{-_IN_HANIFI_rohingya}', "");
    Expect(0, 68927, '\p{^-_IN_HANIFI_rohingya}', "");
    Expect(0, 68927, '\P{-_IN_HANIFI_rohingya}', "");
    Expect(1, 68927, '\P{^-_IN_HANIFI_rohingya}', "");
    Expect(0, 68928, '\p{-_IN_HANIFI_rohingya}', "");
    Expect(1, 68928, '\p{^-_IN_HANIFI_rohingya}', "");
    Expect(1, 68928, '\P{-_IN_HANIFI_rohingya}', "");
    Expect(0, 68928, '\P{^-_IN_HANIFI_rohingya}', "");
    Error('\p{-	In_Hanifi_Rohingya/a/}');
    Error('\P{-	In_Hanifi_Rohingya/a/}');
    Expect(1, 68927, '\p{_ In_Hanifi_Rohingya}', "");
    Expect(0, 68927, '\p{^_ In_Hanifi_Rohingya}', "");
    Expect(0, 68927, '\P{_ In_Hanifi_Rohingya}', "");
    Expect(1, 68927, '\P{^_ In_Hanifi_Rohingya}', "");
    Expect(0, 68928, '\p{_ In_Hanifi_Rohingya}', "");
    Expect(1, 68928, '\p{^_ In_Hanifi_Rohingya}', "");
    Expect(1, 68928, '\P{_ In_Hanifi_Rohingya}', "");
    Expect(0, 68928, '\P{^_ In_Hanifi_Rohingya}', "");
    Error('\p{	:=in_HANUNOO}');
    Error('\P{	:=in_HANUNOO}');
    Expect(1, 5951, '\p{inhanunoo}', "");
    Expect(0, 5951, '\p{^inhanunoo}', "");
    Expect(0, 5951, '\P{inhanunoo}', "");
    Expect(1, 5951, '\P{^inhanunoo}', "");
    Expect(0, 5952, '\p{inhanunoo}', "");
    Expect(1, 5952, '\p{^inhanunoo}', "");
    Expect(1, 5952, '\P{inhanunoo}', "");
    Expect(0, 5952, '\P{^inhanunoo}', "");
    Expect(1, 5951, '\p{_	In_hanunoo}', "");
    Expect(0, 5951, '\p{^_	In_hanunoo}', "");
    Expect(0, 5951, '\P{_	In_hanunoo}', "");
    Expect(1, 5951, '\P{^_	In_hanunoo}', "");
    Expect(0, 5952, '\p{_	In_hanunoo}', "");
    Expect(1, 5952, '\p{^_	In_hanunoo}', "");
    Expect(1, 5952, '\P{_	In_hanunoo}', "");
    Expect(0, 5952, '\P{^_	In_hanunoo}', "");
    Error('\p{/a/_	in_HANUNOO}');
    Error('\P{/a/_	in_HANUNOO}');
    Expect(1, 5951, '\p{--In_Hanunoo}', "");
    Expect(0, 5951, '\p{^--In_Hanunoo}', "");
    Expect(0, 5951, '\P{--In_Hanunoo}', "");
    Expect(1, 5951, '\P{^--In_Hanunoo}', "");
    Expect(0, 5952, '\p{--In_Hanunoo}', "");
    Expect(1, 5952, '\p{^--In_Hanunoo}', "");
    Expect(1, 5952, '\P{--In_Hanunoo}', "");
    Expect(0, 5952, '\P{^--In_Hanunoo}', "");
    Error('\p{	-In_Hatran/a/}');
    Error('\P{	-In_Hatran/a/}');
    Expect(1, 67839, '\p{inhatran}', "");
    Expect(0, 67839, '\p{^inhatran}', "");
    Expect(0, 67839, '\P{inhatran}', "");
    Expect(1, 67839, '\P{^inhatran}', "");
    Expect(0, 67840, '\p{inhatran}', "");
    Expect(1, 67840, '\p{^inhatran}', "");
    Expect(1, 67840, '\P{inhatran}', "");
    Expect(0, 67840, '\P{^inhatran}', "");
    Expect(1, 67839, '\p{ -in_Hatran}', "");
    Expect(0, 67839, '\p{^ -in_Hatran}', "");
    Expect(0, 67839, '\P{ -in_Hatran}', "");
    Expect(1, 67839, '\P{^ -in_Hatran}', "");
    Expect(0, 67840, '\p{ -in_Hatran}', "");
    Expect(1, 67840, '\p{^ -in_Hatran}', "");
    Expect(1, 67840, '\P{ -in_Hatran}', "");
    Expect(0, 67840, '\P{^ -in_Hatran}', "");
    Error('\p{/a/in_Hatran}');
    Error('\P{/a/in_Hatran}');
    Expect(1, 67839, '\p{-IN_Hatran}', "");
    Expect(0, 67839, '\p{^-IN_Hatran}', "");
    Expect(0, 67839, '\P{-IN_Hatran}', "");
    Expect(1, 67839, '\P{^-IN_Hatran}', "");
    Expect(0, 67840, '\p{-IN_Hatran}', "");
    Expect(1, 67840, '\p{^-IN_Hatran}', "");
    Expect(1, 67840, '\P{-IN_Hatran}', "");
    Expect(0, 67840, '\P{^-IN_Hatran}', "");
    Error('\p{-	IN_Hebrew/a/}');
    Error('\P{-	IN_Hebrew/a/}');
    Expect(1, 1535, '\p{inhebrew}', "");
    Expect(0, 1535, '\p{^inhebrew}', "");
    Expect(0, 1535, '\P{inhebrew}', "");
    Expect(1, 1535, '\P{^inhebrew}', "");
    Expect(0, 1536, '\p{inhebrew}', "");
    Expect(1, 1536, '\p{^inhebrew}', "");
    Expect(1, 1536, '\P{inhebrew}', "");
    Expect(0, 1536, '\P{^inhebrew}', "");
    Expect(1, 1535, '\p{	IN_HEBREW}', "");
    Expect(0, 1535, '\p{^	IN_HEBREW}', "");
    Expect(0, 1535, '\P{	IN_HEBREW}', "");
    Expect(1, 1535, '\P{^	IN_HEBREW}', "");
    Expect(0, 1536, '\p{	IN_HEBREW}', "");
    Expect(1, 1536, '\p{^	IN_HEBREW}', "");
    Expect(1, 1536, '\P{	IN_HEBREW}', "");
    Expect(0, 1536, '\P{^	IN_HEBREW}', "");
    Error('\p{:=	In_Hebrew}');
    Error('\P{:=	In_Hebrew}');
    Expect(1, 1535, '\p{  In_hebrew}', "");
    Expect(0, 1535, '\p{^  In_hebrew}', "");
    Expect(0, 1535, '\P{  In_hebrew}', "");
    Expect(1, 1535, '\P{^  In_hebrew}', "");
    Expect(0, 1536, '\p{  In_hebrew}', "");
    Expect(1, 1536, '\p{^  In_hebrew}', "");
    Expect(1, 1536, '\P{  In_hebrew}', "");
    Expect(0, 1536, '\P{^  In_hebrew}', "");
    Error('\p{/a/_IN_Hiragana}');
    Error('\P{/a/_IN_Hiragana}');
    Expect(1, 12447, '\p{inhiragana}', "");
    Expect(0, 12447, '\p{^inhiragana}', "");
    Expect(0, 12447, '\P{inhiragana}', "");
    Expect(1, 12447, '\P{^inhiragana}', "");
    Expect(0, 12448, '\p{inhiragana}', "");
    Expect(1, 12448, '\p{^inhiragana}', "");
    Expect(1, 12448, '\P{inhiragana}', "");
    Expect(0, 12448, '\P{^inhiragana}', "");
    Expect(1, 12447, '\p{__In_Hiragana}', "");
    Expect(0, 12447, '\p{^__In_Hiragana}', "");
    Expect(0, 12447, '\P{__In_Hiragana}', "");
    Expect(1, 12447, '\P{^__In_Hiragana}', "");
    Expect(0, 12448, '\p{__In_Hiragana}', "");
    Expect(1, 12448, '\p{^__In_Hiragana}', "");
    Expect(1, 12448, '\P{__In_Hiragana}', "");
    Expect(0, 12448, '\P{^__In_Hiragana}', "");
    Error('\p{-in_Hiragana:=}');
    Error('\P{-in_Hiragana:=}');
    Expect(1, 12447, '\p{-in_Hiragana}', "");
    Expect(0, 12447, '\p{^-in_Hiragana}', "");
    Expect(0, 12447, '\P{-in_Hiragana}', "");
    Expect(1, 12447, '\P{^-in_Hiragana}', "");
    Expect(0, 12448, '\p{-in_Hiragana}', "");
    Expect(1, 12448, '\p{^-in_Hiragana}', "");
    Expect(1, 12448, '\P{-in_Hiragana}', "");
    Expect(0, 12448, '\P{^-in_Hiragana}', "");
    Error('\p{ _In_imperial_ARAMAIC/a/}');
    Error('\P{ _In_imperial_ARAMAIC/a/}');
    Expect(1, 67679, '\p{inimperialaramaic}', "");
    Expect(0, 67679, '\p{^inimperialaramaic}', "");
    Expect(0, 67679, '\P{inimperialaramaic}', "");
    Expect(1, 67679, '\P{^inimperialaramaic}', "");
    Expect(0, 67680, '\p{inimperialaramaic}', "");
    Expect(1, 67680, '\p{^inimperialaramaic}', "");
    Expect(1, 67680, '\P{inimperialaramaic}', "");
    Expect(0, 67680, '\P{^inimperialaramaic}', "");
    Expect(1, 67679, '\p{ _In_Imperial_aramaic}', "");
    Expect(0, 67679, '\p{^ _In_Imperial_aramaic}', "");
    Expect(0, 67679, '\P{ _In_Imperial_aramaic}', "");
    Expect(1, 67679, '\P{^ _In_Imperial_aramaic}', "");
    Expect(0, 67680, '\p{ _In_Imperial_aramaic}', "");
    Expect(1, 67680, '\p{^ _In_Imperial_aramaic}', "");
    Expect(1, 67680, '\P{ _In_Imperial_aramaic}', "");
    Expect(0, 67680, '\P{^ _In_Imperial_aramaic}', "");
    Error('\p{- in_IMPERIAL_ARAMAIC/a/}');
    Error('\P{- in_IMPERIAL_ARAMAIC/a/}');
    Expect(1, 67679, '\p{- IN_Imperial_aramaic}', "");
    Expect(0, 67679, '\p{^- IN_Imperial_aramaic}', "");
    Expect(0, 67679, '\P{- IN_Imperial_aramaic}', "");
    Expect(1, 67679, '\P{^- IN_Imperial_aramaic}', "");
    Expect(0, 67680, '\p{- IN_Imperial_aramaic}', "");
    Expect(1, 67680, '\p{^- IN_Imperial_aramaic}', "");
    Expect(1, 67680, '\P{- IN_Imperial_aramaic}', "");
    Expect(0, 67680, '\P{^- IN_Imperial_aramaic}', "");
    Error('\p{_/a/IN_Inscriptional_Pahlavi}');
    Error('\P{_/a/IN_Inscriptional_Pahlavi}');
    Expect(1, 68479, '\p{ininscriptionalpahlavi}', "");
    Expect(0, 68479, '\p{^ininscriptionalpahlavi}', "");
    Expect(0, 68479, '\P{ininscriptionalpahlavi}', "");
    Expect(1, 68479, '\P{^ininscriptionalpahlavi}', "");
    Expect(0, 68480, '\p{ininscriptionalpahlavi}', "");
    Expect(1, 68480, '\p{^ininscriptionalpahlavi}', "");
    Expect(1, 68480, '\P{ininscriptionalpahlavi}', "");
    Expect(0, 68480, '\P{^ininscriptionalpahlavi}', "");
    Expect(1, 68479, '\p{__In_INSCRIPTIONAL_pahlavi}', "");
    Expect(0, 68479, '\p{^__In_INSCRIPTIONAL_pahlavi}', "");
    Expect(0, 68479, '\P{__In_INSCRIPTIONAL_pahlavi}', "");
    Expect(1, 68479, '\P{^__In_INSCRIPTIONAL_pahlavi}', "");
    Expect(0, 68480, '\p{__In_INSCRIPTIONAL_pahlavi}', "");
    Expect(1, 68480, '\p{^__In_INSCRIPTIONAL_pahlavi}', "");
    Expect(1, 68480, '\P{__In_INSCRIPTIONAL_pahlavi}', "");
    Expect(0, 68480, '\P{^__In_INSCRIPTIONAL_pahlavi}', "");
    Error('\p{/a/-	In_Inscriptional_pahlavi}');
    Error('\P{/a/-	In_Inscriptional_pahlavi}');
    Expect(1, 68479, '\p{-_IN_Inscriptional_Pahlavi}', "");
    Expect(0, 68479, '\p{^-_IN_Inscriptional_Pahlavi}', "");
    Expect(0, 68479, '\P{-_IN_Inscriptional_Pahlavi}', "");
    Expect(1, 68479, '\P{^-_IN_Inscriptional_Pahlavi}', "");
    Expect(0, 68480, '\p{-_IN_Inscriptional_Pahlavi}', "");
    Expect(1, 68480, '\p{^-_IN_Inscriptional_Pahlavi}', "");
    Expect(1, 68480, '\P{-_IN_Inscriptional_Pahlavi}', "");
    Expect(0, 68480, '\P{^-_IN_Inscriptional_Pahlavi}', "");
    Error('\p{:=-_In_inscriptional_parthian}');
    Error('\P{:=-_In_inscriptional_parthian}');
    Expect(1, 68447, '\p{ininscriptionalparthian}', "");
    Expect(0, 68447, '\p{^ininscriptionalparthian}', "");
    Expect(0, 68447, '\P{ininscriptionalparthian}', "");
    Expect(1, 68447, '\P{^ininscriptionalparthian}', "");
    Expect(0, 68448, '\p{ininscriptionalparthian}', "");
    Expect(1, 68448, '\p{^ininscriptionalparthian}', "");
    Expect(1, 68448, '\P{ininscriptionalparthian}', "");
    Expect(0, 68448, '\P{^ininscriptionalparthian}', "");
    Expect(1, 68447, '\p{	 In_inscriptional_Parthian}', "");
    Expect(0, 68447, '\p{^	 In_inscriptional_Parthian}', "");
    Expect(0, 68447, '\P{	 In_inscriptional_Parthian}', "");
    Expect(1, 68447, '\P{^	 In_inscriptional_Parthian}', "");
    Expect(0, 68448, '\p{	 In_inscriptional_Parthian}', "");
    Expect(1, 68448, '\p{^	 In_inscriptional_Parthian}', "");
    Expect(1, 68448, '\P{	 In_inscriptional_Parthian}', "");
    Expect(0, 68448, '\P{^	 In_inscriptional_Parthian}', "");
    Error('\p{	:=in_Inscriptional_Parthian}');
    Error('\P{	:=in_Inscriptional_Parthian}');
    Expect(1, 68447, '\p{-	in_Inscriptional_Parthian}', "");
    Expect(0, 68447, '\p{^-	in_Inscriptional_Parthian}', "");
    Expect(0, 68447, '\P{-	in_Inscriptional_Parthian}', "");
    Expect(1, 68447, '\P{^-	in_Inscriptional_Parthian}', "");
    Expect(0, 68448, '\p{-	in_Inscriptional_Parthian}', "");
    Expect(1, 68448, '\p{^-	in_Inscriptional_Parthian}', "");
    Expect(1, 68448, '\P{-	in_Inscriptional_Parthian}', "");
    Expect(0, 68448, '\P{^-	in_Inscriptional_Parthian}', "");
    Error('\p{:=IN_Javanese}');
    Error('\P{:=IN_Javanese}');
    Expect(1, 43487, '\p{injavanese}', "");
    Expect(0, 43487, '\p{^injavanese}', "");
    Expect(0, 43487, '\P{injavanese}', "");
    Expect(1, 43487, '\P{^injavanese}', "");
    Expect(0, 43488, '\p{injavanese}', "");
    Expect(1, 43488, '\p{^injavanese}', "");
    Expect(1, 43488, '\P{injavanese}', "");
    Expect(0, 43488, '\P{^injavanese}', "");
    Expect(1, 43487, '\p{_-In_JAVANESE}', "");
    Expect(0, 43487, '\p{^_-In_JAVANESE}', "");
    Expect(0, 43487, '\P{_-In_JAVANESE}', "");
    Expect(1, 43487, '\P{^_-In_JAVANESE}', "");
    Expect(0, 43488, '\p{_-In_JAVANESE}', "");
    Expect(1, 43488, '\p{^_-In_JAVANESE}', "");
    Expect(1, 43488, '\P{_-In_JAVANESE}', "");
    Expect(0, 43488, '\P{^_-In_JAVANESE}', "");
    Error('\p{  in_Javanese:=}');
    Error('\P{  in_Javanese:=}');
    Expect(1, 43487, '\p{		In_Javanese}', "");
    Expect(0, 43487, '\p{^		In_Javanese}', "");
    Expect(0, 43487, '\P{		In_Javanese}', "");
    Expect(1, 43487, '\P{^		In_Javanese}', "");
    Expect(0, 43488, '\p{		In_Javanese}', "");
    Expect(1, 43488, '\p{^		In_Javanese}', "");
    Expect(1, 43488, '\P{		In_Javanese}', "");
    Expect(0, 43488, '\P{^		In_Javanese}', "");
    Error('\p{	:=in_KAITHI}');
    Error('\P{	:=in_KAITHI}');
    Expect(1, 69839, '\p{inkaithi}', "");
    Expect(0, 69839, '\p{^inkaithi}', "");
    Expect(0, 69839, '\P{inkaithi}', "");
    Expect(1, 69839, '\P{^inkaithi}', "");
    Expect(0, 69840, '\p{inkaithi}', "");
    Expect(1, 69840, '\p{^inkaithi}', "");
    Expect(1, 69840, '\P{inkaithi}', "");
    Expect(0, 69840, '\P{^inkaithi}', "");
    Expect(1, 69839, '\p{ -In_KAITHI}', "");
    Expect(0, 69839, '\p{^ -In_KAITHI}', "");
    Expect(0, 69839, '\P{ -In_KAITHI}', "");
    Expect(1, 69839, '\P{^ -In_KAITHI}', "");
    Expect(0, 69840, '\p{ -In_KAITHI}', "");
    Expect(1, 69840, '\p{^ -In_KAITHI}', "");
    Expect(1, 69840, '\P{ -In_KAITHI}', "");
    Expect(0, 69840, '\P{^ -In_KAITHI}', "");
    Error('\p{ /a/IN_Kaithi}');
    Error('\P{ /a/IN_Kaithi}');
    Expect(1, 69839, '\p{-In_KAITHI}', "");
    Expect(0, 69839, '\p{^-In_KAITHI}', "");
    Expect(0, 69839, '\P{-In_KAITHI}', "");
    Expect(1, 69839, '\P{^-In_KAITHI}', "");
    Expect(0, 69840, '\p{-In_KAITHI}', "");
    Expect(1, 69840, '\p{^-In_KAITHI}', "");
    Expect(1, 69840, '\P{-In_KAITHI}', "");
    Expect(0, 69840, '\P{^-In_KAITHI}', "");
    Error('\p{:=		In_KANNADA}');
    Error('\P{:=		In_KANNADA}');
    Expect(1, 3327, '\p{inkannada}', "");
    Expect(0, 3327, '\p{^inkannada}', "");
    Expect(0, 3327, '\P{inkannada}', "");
    Expect(1, 3327, '\P{^inkannada}', "");
    Expect(0, 3328, '\p{inkannada}', "");
    Expect(1, 3328, '\p{^inkannada}', "");
    Expect(1, 3328, '\P{inkannada}', "");
    Expect(0, 3328, '\P{^inkannada}', "");
    Expect(1, 3327, '\p{		In_Kannada}', "");
    Expect(0, 3327, '\p{^		In_Kannada}', "");
    Expect(0, 3327, '\P{		In_Kannada}', "");
    Expect(1, 3327, '\P{^		In_Kannada}', "");
    Expect(0, 3328, '\p{		In_Kannada}', "");
    Expect(1, 3328, '\p{^		In_Kannada}', "");
    Expect(1, 3328, '\P{		In_Kannada}', "");
    Expect(0, 3328, '\P{^		In_Kannada}', "");
    Error('\p{:= in_KANNADA}');
    Error('\P{:= in_KANNADA}');
    Expect(1, 3327, '\p{	in_Kannada}', "");
    Expect(0, 3327, '\p{^	in_Kannada}', "");
    Expect(0, 3327, '\P{	in_Kannada}', "");
    Expect(1, 3327, '\P{^	in_Kannada}', "");
    Expect(0, 3328, '\p{	in_Kannada}', "");
    Expect(1, 3328, '\p{^	in_Kannada}', "");
    Expect(1, 3328, '\P{	in_Kannada}', "");
    Expect(0, 3328, '\P{^	in_Kannada}', "");
    Error('\p{:= _In_Katakana}');
    Error('\P{:= _In_Katakana}');
    Expect(1, 12543, '\p{inkatakana}', "");
    Expect(0, 12543, '\p{^inkatakana}', "");
    Expect(0, 12543, '\P{inkatakana}', "");
    Expect(1, 12543, '\P{^inkatakana}', "");
    Expect(0, 12544, '\p{inkatakana}', "");
    Expect(1, 12544, '\p{^inkatakana}', "");
    Expect(1, 12544, '\P{inkatakana}', "");
    Expect(0, 12544, '\P{^inkatakana}', "");
    Expect(1, 12543, '\p{_-In_Katakana}', "");
    Expect(0, 12543, '\p{^_-In_Katakana}', "");
    Expect(0, 12543, '\P{_-In_Katakana}', "");
    Expect(1, 12543, '\P{^_-In_Katakana}', "");
    Expect(0, 12544, '\p{_-In_Katakana}', "");
    Expect(1, 12544, '\p{^_-In_Katakana}', "");
    Expect(1, 12544, '\P{_-In_Katakana}', "");
    Expect(0, 12544, '\P{^_-In_Katakana}', "");
    Error('\p{:= IN_Katakana}');
    Error('\P{:= IN_Katakana}');
    Expect(1, 12543, '\p{- In_Katakana}', "");
    Expect(0, 12543, '\p{^- In_Katakana}', "");
    Expect(0, 12543, '\P{- In_Katakana}', "");
    Expect(1, 12543, '\P{^- In_Katakana}', "");
    Expect(0, 12544, '\p{- In_Katakana}', "");
    Expect(1, 12544, '\p{^- In_Katakana}', "");
    Expect(1, 12544, '\P{- In_Katakana}', "");
    Expect(0, 12544, '\P{^- In_Katakana}', "");
    Error('\p{:=in_Kayah_LI}');
    Error('\P{:=in_Kayah_LI}');
    Expect(1, 43311, '\p{inkayahli}', "");
    Expect(0, 43311, '\p{^inkayahli}', "");
    Expect(0, 43311, '\P{inkayahli}', "");
    Expect(1, 43311, '\P{^inkayahli}', "");
    Expect(0, 43312, '\p{inkayahli}', "");
    Expect(1, 43312, '\p{^inkayahli}', "");
    Expect(1, 43312, '\P{inkayahli}', "");
    Expect(0, 43312, '\P{^inkayahli}', "");
    Expect(1, 43311, '\p{_	In_kayah_li}', "");
    Expect(0, 43311, '\p{^_	In_kayah_li}', "");
    Expect(0, 43311, '\P{_	In_kayah_li}', "");
    Expect(1, 43311, '\P{^_	In_kayah_li}', "");
    Expect(0, 43312, '\p{_	In_kayah_li}', "");
    Expect(1, 43312, '\p{^_	In_kayah_li}', "");
    Expect(1, 43312, '\P{_	In_kayah_li}', "");
    Expect(0, 43312, '\P{^_	In_kayah_li}', "");
    Error('\p{/a/_In_Kayah_li}');
    Error('\P{/a/_In_Kayah_li}');
    Expect(1, 43311, '\p{	 In_Kayah_li}', "");
    Expect(0, 43311, '\p{^	 In_Kayah_li}', "");
    Expect(0, 43311, '\P{	 In_Kayah_li}', "");
    Expect(1, 43311, '\P{^	 In_Kayah_li}', "");
    Expect(0, 43312, '\p{	 In_Kayah_li}', "");
    Expect(1, 43312, '\p{^	 In_Kayah_li}', "");
    Expect(1, 43312, '\P{	 In_Kayah_li}', "");
    Expect(0, 43312, '\P{^	 In_Kayah_li}', "");
    Error('\p{_:=In_Kharoshthi}');
    Error('\P{_:=In_Kharoshthi}');
    Expect(1, 68191, '\p{inkharoshthi}', "");
    Expect(0, 68191, '\p{^inkharoshthi}', "");
    Expect(0, 68191, '\P{inkharoshthi}', "");
    Expect(1, 68191, '\P{^inkharoshthi}', "");
    Expect(0, 68192, '\p{inkharoshthi}', "");
    Expect(1, 68192, '\p{^inkharoshthi}', "");
    Expect(1, 68192, '\P{inkharoshthi}', "");
    Expect(0, 68192, '\P{^inkharoshthi}', "");
    Expect(1, 68191, '\p{_ in_Kharoshthi}', "");
    Expect(0, 68191, '\p{^_ in_Kharoshthi}', "");
    Expect(0, 68191, '\P{_ in_Kharoshthi}', "");
    Expect(1, 68191, '\P{^_ in_Kharoshthi}', "");
    Expect(0, 68192, '\p{_ in_Kharoshthi}', "");
    Expect(1, 68192, '\p{^_ in_Kharoshthi}', "");
    Expect(1, 68192, '\P{_ in_Kharoshthi}', "");
    Expect(0, 68192, '\P{^_ in_Kharoshthi}', "");
    Error('\p{/a/In_Kharoshthi}');
    Error('\P{/a/In_Kharoshthi}');
    Expect(1, 68191, '\p{-In_kharoshthi}', "");
    Expect(0, 68191, '\p{^-In_kharoshthi}', "");
    Expect(0, 68191, '\P{-In_kharoshthi}', "");
    Expect(1, 68191, '\P{^-In_kharoshthi}', "");
    Expect(0, 68192, '\p{-In_kharoshthi}', "");
    Expect(1, 68192, '\p{^-In_kharoshthi}', "");
    Expect(1, 68192, '\P{-In_kharoshthi}', "");
    Expect(0, 68192, '\P{^-In_kharoshthi}', "");
    Error('\p{/a/- In_KHITAN_SMALL_script}');
    Error('\P{/a/- In_KHITAN_SMALL_script}');
    Expect(1, 101631, '\p{inkhitansmallscript}', "");
    Expect(0, 101631, '\p{^inkhitansmallscript}', "");
    Expect(0, 101631, '\P{inkhitansmallscript}', "");
    Expect(1, 101631, '\P{^inkhitansmallscript}', "");
    Expect(0, 101632, '\p{inkhitansmallscript}', "");
    Expect(1, 101632, '\p{^inkhitansmallscript}', "");
    Expect(1, 101632, '\P{inkhitansmallscript}', "");
    Expect(0, 101632, '\P{^inkhitansmallscript}', "");
    Expect(1, 101631, '\p{in_khitan_SMALL_Script}', "");
    Expect(0, 101631, '\p{^in_khitan_SMALL_Script}', "");
    Expect(0, 101631, '\P{in_khitan_SMALL_Script}', "");
    Expect(1, 101631, '\P{^in_khitan_SMALL_Script}', "");
    Expect(0, 101632, '\p{in_khitan_SMALL_Script}', "");
    Expect(1, 101632, '\p{^in_khitan_SMALL_Script}', "");
    Expect(1, 101632, '\P{in_khitan_SMALL_Script}', "");
    Expect(0, 101632, '\P{^in_khitan_SMALL_Script}', "");
    Error('\p{  In_khitan_Small_Script:=}');
    Error('\P{  In_khitan_Small_Script:=}');
    Expect(1, 101631, '\p{-In_Khitan_Small_script}', "");
    Expect(0, 101631, '\p{^-In_Khitan_Small_script}', "");
    Expect(0, 101631, '\P{-In_Khitan_Small_script}', "");
    Expect(1, 101631, '\P{^-In_Khitan_Small_script}', "");
    Expect(0, 101632, '\p{-In_Khitan_Small_script}', "");
    Expect(1, 101632, '\p{^-In_Khitan_Small_script}', "");
    Expect(1, 101632, '\P{-In_Khitan_Small_script}', "");
    Expect(0, 101632, '\P{^-In_Khitan_Small_script}', "");
    Error('\p{IN_KHMER:=}');
    Error('\P{IN_KHMER:=}');
    Expect(1, 6143, '\p{inkhmer}', "");
    Expect(0, 6143, '\p{^inkhmer}', "");
    Expect(0, 6143, '\P{inkhmer}', "");
    Expect(1, 6143, '\P{^inkhmer}', "");
    Expect(0, 6144, '\p{inkhmer}', "");
    Expect(1, 6144, '\p{^inkhmer}', "");
    Expect(1, 6144, '\P{inkhmer}', "");
    Expect(0, 6144, '\P{^inkhmer}', "");
    Expect(1, 6143, '\p{  IN_khmer}', "");
    Expect(0, 6143, '\p{^  IN_khmer}', "");
    Expect(0, 6143, '\P{  IN_khmer}', "");
    Expect(1, 6143, '\P{^  IN_khmer}', "");
    Expect(0, 6144, '\p{  IN_khmer}', "");
    Expect(1, 6144, '\p{^  IN_khmer}', "");
    Expect(1, 6144, '\P{  IN_khmer}', "");
    Expect(0, 6144, '\P{^  IN_khmer}', "");
    Error('\p{/a/_ in_khmer}');
    Error('\P{/a/_ in_khmer}');
    Expect(1, 6143, '\p{In_KHMER}', "");
    Expect(0, 6143, '\p{^In_KHMER}', "");
    Expect(0, 6143, '\P{In_KHMER}', "");
    Expect(1, 6143, '\P{^In_KHMER}', "");
    Expect(0, 6144, '\p{In_KHMER}', "");
    Expect(1, 6144, '\p{^In_KHMER}', "");
    Expect(1, 6144, '\P{In_KHMER}', "");
    Expect(0, 6144, '\P{^In_KHMER}', "");
    Error('\p{-/a/in_Khojki}');
    Error('\P{-/a/in_Khojki}');
    Expect(1, 70223, '\p{inkhojki}', "");
    Expect(0, 70223, '\p{^inkhojki}', "");
    Expect(0, 70223, '\P{inkhojki}', "");
    Expect(1, 70223, '\P{^inkhojki}', "");
    Expect(0, 70224, '\p{inkhojki}', "");
    Expect(1, 70224, '\p{^inkhojki}', "");
    Expect(1, 70224, '\P{inkhojki}', "");
    Expect(0, 70224, '\P{^inkhojki}', "");
    Expect(1, 70223, '\p{_	In_Khojki}', "");
    Expect(0, 70223, '\p{^_	In_Khojki}', "");
    Expect(0, 70223, '\P{_	In_Khojki}', "");
    Expect(1, 70223, '\P{^_	In_Khojki}', "");
    Expect(0, 70224, '\p{_	In_Khojki}', "");
    Expect(1, 70224, '\p{^_	In_Khojki}', "");
    Expect(1, 70224, '\P{_	In_Khojki}', "");
    Expect(0, 70224, '\P{^_	In_Khojki}', "");
    Error('\p{	/a/in_Khojki}');
    Error('\P{	/a/in_Khojki}');
    Expect(1, 70223, '\p{_	IN_Khojki}', "");
    Expect(0, 70223, '\p{^_	IN_Khojki}', "");
    Expect(0, 70223, '\P{_	IN_Khojki}', "");
    Expect(1, 70223, '\P{^_	IN_Khojki}', "");
    Expect(0, 70224, '\p{_	IN_Khojki}', "");
    Expect(1, 70224, '\p{^_	IN_Khojki}', "");
    Expect(1, 70224, '\P{_	IN_Khojki}', "");
    Expect(0, 70224, '\P{^_	IN_Khojki}', "");
    Error('\p{		In_khudawadi/a/}');
    Error('\P{		In_khudawadi/a/}');
    Expect(1, 70399, '\p{inkhudawadi}', "");
    Expect(0, 70399, '\p{^inkhudawadi}', "");
    Expect(0, 70399, '\P{inkhudawadi}', "");
    Expect(1, 70399, '\P{^inkhudawadi}', "");
    Expect(0, 70400, '\p{inkhudawadi}', "");
    Expect(1, 70400, '\p{^inkhudawadi}', "");
    Expect(1, 70400, '\P{inkhudawadi}', "");
    Expect(0, 70400, '\P{^inkhudawadi}', "");
    Expect(1, 70399, '\p{__In_KHUDAWADI}', "");
    Expect(0, 70399, '\p{^__In_KHUDAWADI}', "");
    Expect(0, 70399, '\P{__In_KHUDAWADI}', "");
    Expect(1, 70399, '\P{^__In_KHUDAWADI}', "");
    Expect(0, 70400, '\p{__In_KHUDAWADI}', "");
    Expect(1, 70400, '\p{^__In_KHUDAWADI}', "");
    Expect(1, 70400, '\P{__In_KHUDAWADI}', "");
    Expect(0, 70400, '\P{^__In_KHUDAWADI}', "");
    Error('\p{	In_Khudawadi/a/}');
    Error('\P{	In_Khudawadi/a/}');
    Expect(1, 70399, '\p{-In_KHUDAWADI}', "");
    Expect(0, 70399, '\p{^-In_KHUDAWADI}', "");
    Expect(0, 70399, '\P{-In_KHUDAWADI}', "");
    Expect(1, 70399, '\P{^-In_KHUDAWADI}', "");
    Expect(0, 70400, '\p{-In_KHUDAWADI}', "");
    Expect(1, 70400, '\p{^-In_KHUDAWADI}', "");
    Expect(1, 70400, '\P{-In_KHUDAWADI}', "");
    Expect(0, 70400, '\P{^-In_KHUDAWADI}', "");
    Error('\p{	:=In_Lao}');
    Error('\P{	:=In_Lao}');
    Expect(1, 3839, '\p{inlao}', "");
    Expect(0, 3839, '\p{^inlao}', "");
    Expect(0, 3839, '\P{inlao}', "");
    Expect(1, 3839, '\P{^inlao}', "");
    Expect(0, 3840, '\p{inlao}', "");
    Expect(1, 3840, '\p{^inlao}', "");
    Expect(1, 3840, '\P{inlao}', "");
    Expect(0, 3840, '\P{^inlao}', "");
    Expect(1, 3839, '\p{	In_LAO}', "");
    Expect(0, 3839, '\p{^	In_LAO}', "");
    Expect(0, 3839, '\P{	In_LAO}', "");
    Expect(1, 3839, '\P{^	In_LAO}', "");
    Expect(0, 3840, '\p{	In_LAO}', "");
    Expect(1, 3840, '\p{^	In_LAO}', "");
    Expect(1, 3840, '\P{	In_LAO}', "");
    Expect(0, 3840, '\P{^	In_LAO}', "");
    Error('\p{/a/In_lao}');
    Error('\P{/a/In_lao}');
    Expect(1, 3839, '\p{	 In_lao}', "");
    Expect(0, 3839, '\p{^	 In_lao}', "");
    Expect(0, 3839, '\P{	 In_lao}', "");
    Expect(1, 3839, '\P{^	 In_lao}', "");
    Expect(0, 3840, '\p{	 In_lao}', "");
    Expect(1, 3840, '\p{^	 In_lao}', "");
    Expect(1, 3840, '\P{	 In_lao}', "");
    Expect(0, 3840, '\P{^	 In_lao}', "");
    Error('\p{/a/ _in_Lepcha}');
    Error('\P{/a/ _in_Lepcha}');
    Expect(1, 7247, '\p{inlepcha}', "");
    Expect(0, 7247, '\p{^inlepcha}', "");
    Expect(0, 7247, '\P{inlepcha}', "");
    Expect(1, 7247, '\P{^inlepcha}', "");
    Expect(0, 7248, '\p{inlepcha}', "");
    Expect(1, 7248, '\p{^inlepcha}', "");
    Expect(1, 7248, '\P{inlepcha}', "");
    Expect(0, 7248, '\P{^inlepcha}', "");
    Expect(1, 7247, '\p{ -IN_Lepcha}', "");
    Expect(0, 7247, '\p{^ -IN_Lepcha}', "");
    Expect(0, 7247, '\P{ -IN_Lepcha}', "");
    Expect(1, 7247, '\P{^ -IN_Lepcha}', "");
    Expect(0, 7248, '\p{ -IN_Lepcha}', "");
    Expect(1, 7248, '\p{^ -IN_Lepcha}', "");
    Expect(1, 7248, '\P{ -IN_Lepcha}', "");
    Expect(0, 7248, '\P{^ -IN_Lepcha}', "");
    Error('\p{ In_lepcha:=}');
    Error('\P{ In_lepcha:=}');
    Expect(1, 7247, '\p{__in_lepcha}', "");
    Expect(0, 7247, '\p{^__in_lepcha}', "");
    Expect(0, 7247, '\P{__in_lepcha}', "");
    Expect(1, 7247, '\P{^__in_lepcha}', "");
    Expect(0, 7248, '\p{__in_lepcha}', "");
    Expect(1, 7248, '\p{^__in_lepcha}', "");
    Expect(1, 7248, '\P{__in_lepcha}', "");
    Expect(0, 7248, '\P{^__in_lepcha}', "");
    Error('\p{/a/ 	In_LIMBU}');
    Error('\P{/a/ 	In_LIMBU}');
    Expect(1, 6479, '\p{inlimbu}', "");
    Expect(0, 6479, '\p{^inlimbu}', "");
    Expect(0, 6479, '\P{inlimbu}', "");
    Expect(1, 6479, '\P{^inlimbu}', "");
    Expect(0, 6480, '\p{inlimbu}', "");
    Expect(1, 6480, '\p{^inlimbu}', "");
    Expect(1, 6480, '\P{inlimbu}', "");
    Expect(0, 6480, '\P{^inlimbu}', "");
    Expect(1, 6479, '\p{_In_Limbu}', "");
    Expect(0, 6479, '\p{^_In_Limbu}', "");
    Expect(0, 6479, '\P{_In_Limbu}', "");
    Expect(1, 6479, '\P{^_In_Limbu}', "");
    Expect(0, 6480, '\p{_In_Limbu}', "");
    Expect(1, 6480, '\p{^_In_Limbu}', "");
    Expect(1, 6480, '\P{_In_Limbu}', "");
    Expect(0, 6480, '\P{^_In_Limbu}', "");
    Error('\p{-:=In_Limbu}');
    Error('\P{-:=In_Limbu}');
    Expect(1, 6479, '\p{-_IN_limbu}', "");
    Expect(0, 6479, '\p{^-_IN_limbu}', "");
    Expect(0, 6479, '\P{-_IN_limbu}', "");
    Expect(1, 6479, '\P{^-_IN_limbu}', "");
    Expect(0, 6480, '\p{-_IN_limbu}', "");
    Expect(1, 6480, '\p{^-_IN_limbu}', "");
    Expect(1, 6480, '\P{-_IN_limbu}', "");
    Expect(0, 6480, '\P{^-_IN_limbu}', "");
    Error('\p{/a/ In_LINEAR_A}');
    Error('\P{/a/ In_LINEAR_A}');
    Expect(1, 67455, '\p{inlineara}', "");
    Expect(0, 67455, '\p{^inlineara}', "");
    Expect(0, 67455, '\P{inlineara}', "");
    Expect(1, 67455, '\P{^inlineara}', "");
    Expect(0, 67456, '\p{inlineara}', "");
    Expect(1, 67456, '\p{^inlineara}', "");
    Expect(1, 67456, '\P{inlineara}', "");
    Expect(0, 67456, '\P{^inlineara}', "");
    Expect(1, 67455, '\p{		In_Linear_A}', "");
    Expect(0, 67455, '\p{^		In_Linear_A}', "");
    Expect(0, 67455, '\P{		In_Linear_A}', "");
    Expect(1, 67455, '\P{^		In_Linear_A}', "");
    Expect(0, 67456, '\p{		In_Linear_A}', "");
    Expect(1, 67456, '\p{^		In_Linear_A}', "");
    Expect(1, 67456, '\P{		In_Linear_A}', "");
    Expect(0, 67456, '\P{^		In_Linear_A}', "");
    Error('\p{ :=In_Linear_A}');
    Error('\P{ :=In_Linear_A}');
    Expect(1, 67455, '\p{-IN_Linear_a}', "");
    Expect(0, 67455, '\p{^-IN_Linear_a}', "");
    Expect(0, 67455, '\P{-IN_Linear_a}', "");
    Expect(1, 67455, '\P{^-IN_Linear_a}', "");
    Expect(0, 67456, '\p{-IN_Linear_a}', "");
    Expect(1, 67456, '\p{^-IN_Linear_a}', "");
    Expect(1, 67456, '\P{-IN_Linear_a}', "");
    Expect(0, 67456, '\P{^-IN_Linear_a}', "");
    Error('\p{:=-in_LISU}');
    Error('\P{:=-in_LISU}');
    Expect(1, 42239, '\p{inlisu}', "");
    Expect(0, 42239, '\p{^inlisu}', "");
    Expect(0, 42239, '\P{inlisu}', "");
    Expect(1, 42239, '\P{^inlisu}', "");
    Expect(0, 42240, '\p{inlisu}', "");
    Expect(1, 42240, '\p{^inlisu}', "");
    Expect(1, 42240, '\P{inlisu}', "");
    Expect(0, 42240, '\P{^inlisu}', "");
    Expect(1, 42239, '\p{ -IN_Lisu}', "");
    Expect(0, 42239, '\p{^ -IN_Lisu}', "");
    Expect(0, 42239, '\P{ -IN_Lisu}', "");
    Expect(1, 42239, '\P{^ -IN_Lisu}', "");
    Expect(0, 42240, '\p{ -IN_Lisu}', "");
    Expect(1, 42240, '\p{^ -IN_Lisu}', "");
    Expect(1, 42240, '\P{ -IN_Lisu}', "");
    Expect(0, 42240, '\P{^ -IN_Lisu}', "");
    Error('\p{/a/-In_LISU}');
    Error('\P{/a/-In_LISU}');
    Expect(1, 42239, '\p{_ In_Lisu}', "");
    Expect(0, 42239, '\p{^_ In_Lisu}', "");
    Expect(0, 42239, '\P{_ In_Lisu}', "");
    Expect(1, 42239, '\P{^_ In_Lisu}', "");
    Expect(0, 42240, '\p{_ In_Lisu}', "");
    Expect(1, 42240, '\p{^_ In_Lisu}', "");
    Expect(1, 42240, '\P{_ In_Lisu}', "");
    Expect(0, 42240, '\P{^_ In_Lisu}', "");
    Error('\p{/a/ In_Lycian}');
    Error('\P{/a/ In_Lycian}');
    Expect(1, 66207, '\p{inlycian}', "");
    Expect(0, 66207, '\p{^inlycian}', "");
    Expect(0, 66207, '\P{inlycian}', "");
    Expect(1, 66207, '\P{^inlycian}', "");
    Expect(0, 66208, '\p{inlycian}', "");
    Expect(1, 66208, '\p{^inlycian}', "");
    Expect(1, 66208, '\P{inlycian}', "");
    Expect(0, 66208, '\P{^inlycian}', "");
    Expect(1, 66207, '\p{_In_lycian}', "");
    Expect(0, 66207, '\p{^_In_lycian}', "");
    Expect(0, 66207, '\P{_In_lycian}', "");
    Expect(1, 66207, '\P{^_In_lycian}', "");
    Expect(0, 66208, '\p{_In_lycian}', "");
    Expect(1, 66208, '\p{^_In_lycian}', "");
    Expect(1, 66208, '\P{_In_lycian}', "");
    Expect(0, 66208, '\P{^_In_lycian}', "");
    Error('\p{ In_lycian:=}');
    Error('\P{ In_lycian:=}');
    Expect(1, 66207, '\p{	 In_lycian}', "");
    Expect(0, 66207, '\p{^	 In_lycian}', "");
    Expect(0, 66207, '\P{	 In_lycian}', "");
    Expect(1, 66207, '\P{^	 In_lycian}', "");
    Expect(0, 66208, '\p{	 In_lycian}', "");
    Expect(1, 66208, '\p{^	 In_lycian}', "");
    Expect(1, 66208, '\P{	 In_lycian}', "");
    Expect(0, 66208, '\P{^	 In_lycian}', "");
    Error('\p{-:=In_LYDIAN}');
    Error('\P{-:=In_LYDIAN}');
    Expect(1, 67903, '\p{inlydian}', "");
    Expect(0, 67903, '\p{^inlydian}', "");
    Expect(0, 67903, '\P{inlydian}', "");
    Expect(1, 67903, '\P{^inlydian}', "");
    Expect(0, 67904, '\p{inlydian}', "");
    Expect(1, 67904, '\p{^inlydian}', "");
    Expect(1, 67904, '\P{inlydian}', "");
    Expect(0, 67904, '\P{^inlydian}', "");
    Expect(1, 67903, '\p{-	in_LYDIAN}', "");
    Expect(0, 67903, '\p{^-	in_LYDIAN}', "");
    Expect(0, 67903, '\P{-	in_LYDIAN}', "");
    Expect(1, 67903, '\P{^-	in_LYDIAN}', "");
    Expect(0, 67904, '\p{-	in_LYDIAN}', "");
    Expect(1, 67904, '\p{^-	in_LYDIAN}', "");
    Expect(1, 67904, '\P{-	in_LYDIAN}', "");
    Expect(0, 67904, '\P{^-	in_LYDIAN}', "");
    Error('\p{ /a/In_lydian}');
    Error('\P{ /a/In_lydian}');
    Expect(1, 67903, '\p{	in_lydian}', "");
    Expect(0, 67903, '\p{^	in_lydian}', "");
    Expect(0, 67903, '\P{	in_lydian}', "");
    Expect(1, 67903, '\P{^	in_lydian}', "");
    Expect(0, 67904, '\p{	in_lydian}', "");
    Expect(1, 67904, '\p{^	in_lydian}', "");
    Expect(1, 67904, '\P{	in_lydian}', "");
    Expect(0, 67904, '\P{^	in_lydian}', "");
    Error('\p{_/a/In_Mahajani}');
    Error('\P{_/a/In_Mahajani}');
    Expect(1, 70015, '\p{inmahajani}', "");
    Expect(0, 70015, '\p{^inmahajani}', "");
    Expect(0, 70015, '\P{inmahajani}', "");
    Expect(1, 70015, '\P{^inmahajani}', "");
    Expect(0, 70016, '\p{inmahajani}', "");
    Expect(1, 70016, '\p{^inmahajani}', "");
    Expect(1, 70016, '\P{inmahajani}', "");
    Expect(0, 70016, '\P{^inmahajani}', "");
    Expect(1, 70015, '\p{  IN_mahajani}', "");
    Expect(0, 70015, '\p{^  IN_mahajani}', "");
    Expect(0, 70015, '\P{  IN_mahajani}', "");
    Expect(1, 70015, '\P{^  IN_mahajani}', "");
    Expect(0, 70016, '\p{  IN_mahajani}', "");
    Expect(1, 70016, '\p{^  IN_mahajani}', "");
    Expect(1, 70016, '\P{  IN_mahajani}', "");
    Expect(0, 70016, '\P{^  IN_mahajani}', "");
    Error('\p{	In_mahajani:=}');
    Error('\P{	In_mahajani:=}');
    Expect(1, 70015, '\p{	IN_mahajani}', "");
    Expect(0, 70015, '\p{^	IN_mahajani}', "");
    Expect(0, 70015, '\P{	IN_mahajani}', "");
    Expect(1, 70015, '\P{^	IN_mahajani}', "");
    Expect(0, 70016, '\p{	IN_mahajani}', "");
    Expect(1, 70016, '\p{^	IN_mahajani}', "");
    Expect(1, 70016, '\P{	IN_mahajani}', "");
    Expect(0, 70016, '\P{^	IN_mahajani}', "");
    Error('\p{_:=In_MAKASAR}');
    Error('\P{_:=In_MAKASAR}');
    Expect(1, 73471, '\p{inmakasar}', "");
    Expect(0, 73471, '\p{^inmakasar}', "");
    Expect(0, 73471, '\P{inmakasar}', "");
    Expect(1, 73471, '\P{^inmakasar}', "");
    Expect(0, 73472, '\p{inmakasar}', "");
    Expect(1, 73472, '\p{^inmakasar}', "");
    Expect(1, 73472, '\P{inmakasar}', "");
    Expect(0, 73472, '\P{^inmakasar}', "");
    Expect(1, 73471, '\p{__In_Makasar}', "");
    Expect(0, 73471, '\p{^__In_Makasar}', "");
    Expect(0, 73471, '\P{__In_Makasar}', "");
    Expect(1, 73471, '\P{^__In_Makasar}', "");
    Expect(0, 73472, '\p{__In_Makasar}', "");
    Expect(1, 73472, '\p{^__In_Makasar}', "");
    Expect(1, 73472, '\P{__In_Makasar}', "");
    Expect(0, 73472, '\P{^__In_Makasar}', "");
    Error('\p{-_In_MAKASAR:=}');
    Error('\P{-_In_MAKASAR:=}');
    Expect(1, 73471, '\p{__In_makasar}', "");
    Expect(0, 73471, '\p{^__In_makasar}', "");
    Expect(0, 73471, '\P{__In_makasar}', "");
    Expect(1, 73471, '\P{^__In_makasar}', "");
    Expect(0, 73472, '\p{__In_makasar}', "");
    Expect(1, 73472, '\p{^__In_makasar}', "");
    Expect(1, 73472, '\P{__In_makasar}', "");
    Expect(0, 73472, '\P{^__In_makasar}', "");
    Error('\p{ _In_MALAYALAM/a/}');
    Error('\P{ _In_MALAYALAM/a/}');
    Expect(1, 3455, '\p{inmalayalam}', "");
    Expect(0, 3455, '\p{^inmalayalam}', "");
    Expect(0, 3455, '\P{inmalayalam}', "");
    Expect(1, 3455, '\P{^inmalayalam}', "");
    Expect(0, 3456, '\p{inmalayalam}', "");
    Expect(1, 3456, '\p{^inmalayalam}', "");
    Expect(1, 3456, '\P{inmalayalam}', "");
    Expect(0, 3456, '\P{^inmalayalam}', "");
    Expect(1, 3455, '\p{- In_malayalam}', "");
    Expect(0, 3455, '\p{^- In_malayalam}', "");
    Expect(0, 3455, '\P{- In_malayalam}', "");
    Expect(1, 3455, '\P{^- In_malayalam}', "");
    Expect(0, 3456, '\p{- In_malayalam}', "");
    Expect(1, 3456, '\p{^- In_malayalam}', "");
    Expect(1, 3456, '\P{- In_malayalam}', "");
    Expect(0, 3456, '\P{^- In_malayalam}', "");
    Error('\p{/a/ IN_malayalam}');
    Error('\P{/a/ IN_malayalam}');
    Expect(1, 3455, '\p{-	in_malayalam}', "");
    Expect(0, 3455, '\p{^-	in_malayalam}', "");
    Expect(0, 3455, '\P{-	in_malayalam}', "");
    Expect(1, 3455, '\P{^-	in_malayalam}', "");
    Expect(0, 3456, '\p{-	in_malayalam}', "");
    Expect(1, 3456, '\p{^-	in_malayalam}', "");
    Expect(1, 3456, '\P{-	in_malayalam}', "");
    Expect(0, 3456, '\P{^-	in_malayalam}', "");
    Error('\p{_:=In_Mandaic}');
    Error('\P{_:=In_Mandaic}');
    Expect(1, 2143, '\p{inmandaic}', "");
    Expect(0, 2143, '\p{^inmandaic}', "");
    Expect(0, 2143, '\P{inmandaic}', "");
    Expect(1, 2143, '\P{^inmandaic}', "");
    Expect(0, 2144, '\p{inmandaic}', "");
    Expect(1, 2144, '\p{^inmandaic}', "");
    Expect(1, 2144, '\P{inmandaic}', "");
    Expect(0, 2144, '\P{^inmandaic}', "");
    Expect(1, 2143, '\p{_in_mandaic}', "");
    Expect(0, 2143, '\p{^_in_mandaic}', "");
    Expect(0, 2143, '\P{_in_mandaic}', "");
    Expect(1, 2143, '\P{^_in_mandaic}', "");
    Expect(0, 2144, '\p{_in_mandaic}', "");
    Expect(1, 2144, '\p{^_in_mandaic}', "");
    Expect(1, 2144, '\P{_in_mandaic}', "");
    Expect(0, 2144, '\P{^_in_mandaic}', "");
    Error('\p{__IN_mandaic:=}');
    Error('\P{__IN_mandaic:=}');
    Expect(1, 2143, '\p{-IN_Mandaic}', "");
    Expect(0, 2143, '\p{^-IN_Mandaic}', "");
    Expect(0, 2143, '\P{-IN_Mandaic}', "");
    Expect(1, 2143, '\P{^-IN_Mandaic}', "");
    Expect(0, 2144, '\p{-IN_Mandaic}', "");
    Expect(1, 2144, '\p{^-IN_Mandaic}', "");
    Expect(1, 2144, '\P{-IN_Mandaic}', "");
    Expect(0, 2144, '\P{^-IN_Mandaic}', "");
    Error('\p{:=_ In_Manichaean}');
    Error('\P{:=_ In_Manichaean}');
    Expect(1, 68351, '\p{inmanichaean}', "");
    Expect(0, 68351, '\p{^inmanichaean}', "");
    Expect(0, 68351, '\P{inmanichaean}', "");
    Expect(1, 68351, '\P{^inmanichaean}', "");
    Expect(0, 68352, '\p{inmanichaean}', "");
    Expect(1, 68352, '\p{^inmanichaean}', "");
    Expect(1, 68352, '\P{inmanichaean}', "");
    Expect(0, 68352, '\P{^inmanichaean}', "");
    Expect(1, 68351, '\p{_in_manichaean}', "");
    Expect(0, 68351, '\p{^_in_manichaean}', "");
    Expect(0, 68351, '\P{_in_manichaean}', "");
    Expect(1, 68351, '\P{^_in_manichaean}', "");
    Expect(0, 68352, '\p{_in_manichaean}', "");
    Expect(1, 68352, '\p{^_in_manichaean}', "");
    Expect(1, 68352, '\P{_in_manichaean}', "");
    Expect(0, 68352, '\P{^_in_manichaean}', "");
    Error('\p{:=_IN_manichaean}');
    Error('\P{:=_IN_manichaean}');
    Expect(1, 68351, '\p{_IN_Manichaean}', "");
    Expect(0, 68351, '\p{^_IN_Manichaean}', "");
    Expect(0, 68351, '\P{_IN_Manichaean}', "");
    Expect(1, 68351, '\P{^_IN_Manichaean}', "");
    Expect(0, 68352, '\p{_IN_Manichaean}', "");
    Expect(1, 68352, '\p{^_IN_Manichaean}', "");
    Expect(1, 68352, '\P{_IN_Manichaean}', "");
    Expect(0, 68352, '\P{^_IN_Manichaean}', "");
    Error('\p{	/a/In_marchen}');
    Error('\P{	/a/In_marchen}');
    Expect(1, 72895, '\p{inmarchen}', "");
    Expect(0, 72895, '\p{^inmarchen}', "");
    Expect(0, 72895, '\P{inmarchen}', "");
    Expect(1, 72895, '\P{^inmarchen}', "");
    Expect(0, 72896, '\p{inmarchen}', "");
    Expect(1, 72896, '\p{^inmarchen}', "");
    Expect(1, 72896, '\P{inmarchen}', "");
    Expect(0, 72896, '\P{^inmarchen}', "");
    Expect(1, 72895, '\p{	in_Marchen}', "");
    Expect(0, 72895, '\p{^	in_Marchen}', "");
    Expect(0, 72895, '\P{	in_Marchen}', "");
    Expect(1, 72895, '\P{^	in_Marchen}', "");
    Expect(0, 72896, '\p{	in_Marchen}', "");
    Expect(1, 72896, '\p{^	in_Marchen}', "");
    Expect(1, 72896, '\P{	in_Marchen}', "");
    Expect(0, 72896, '\P{^	in_Marchen}', "");
    Error('\p{	_IN_MARCHEN:=}');
    Error('\P{	_IN_MARCHEN:=}');
    Expect(1, 72895, '\p{- in_Marchen}', "");
    Expect(0, 72895, '\p{^- in_Marchen}', "");
    Expect(0, 72895, '\P{- in_Marchen}', "");
    Expect(1, 72895, '\P{^- in_Marchen}', "");
    Expect(0, 72896, '\p{- in_Marchen}', "");
    Expect(1, 72896, '\p{^- in_Marchen}', "");
    Expect(1, 72896, '\P{- in_Marchen}', "");
    Expect(0, 72896, '\P{^- in_Marchen}', "");
    Error('\p{:=-In_Masaram_Gondi}');
    Error('\P{:=-In_Masaram_Gondi}');
    Expect(1, 73055, '\p{inmasaramgondi}', "");
    Expect(0, 73055, '\p{^inmasaramgondi}', "");
    Expect(0, 73055, '\P{inmasaramgondi}', "");
    Expect(1, 73055, '\P{^inmasaramgondi}', "");
    Expect(0, 73056, '\p{inmasaramgondi}', "");
    Expect(1, 73056, '\p{^inmasaramgondi}', "");
    Expect(1, 73056, '\P{inmasaramgondi}', "");
    Expect(0, 73056, '\P{^inmasaramgondi}', "");
    Expect(1, 73055, '\p{	-In_Masaram_Gondi}', "");
    Expect(0, 73055, '\p{^	-In_Masaram_Gondi}', "");
    Expect(0, 73055, '\P{	-In_Masaram_Gondi}', "");
    Expect(1, 73055, '\P{^	-In_Masaram_Gondi}', "");
    Expect(0, 73056, '\p{	-In_Masaram_Gondi}', "");
    Expect(1, 73056, '\p{^	-In_Masaram_Gondi}', "");
    Expect(1, 73056, '\P{	-In_Masaram_Gondi}', "");
    Expect(0, 73056, '\P{^	-In_Masaram_Gondi}', "");
    Error('\p{	-In_masaram_Gondi:=}');
    Error('\P{	-In_masaram_Gondi:=}');
    Expect(1, 73055, '\p{ 	In_Masaram_GONDI}', "");
    Expect(0, 73055, '\p{^ 	In_Masaram_GONDI}', "");
    Expect(0, 73055, '\P{ 	In_Masaram_GONDI}', "");
    Expect(1, 73055, '\P{^ 	In_Masaram_GONDI}', "");
    Expect(0, 73056, '\p{ 	In_Masaram_GONDI}', "");
    Expect(1, 73056, '\p{^ 	In_Masaram_GONDI}', "");
    Expect(1, 73056, '\P{ 	In_Masaram_GONDI}', "");
    Expect(0, 73056, '\P{^ 	In_Masaram_GONDI}', "");
    Error('\p{/a/	 IN_Medefaidrin}');
    Error('\P{/a/	 IN_Medefaidrin}');
    Expect(1, 93855, '\p{inmedefaidrin}', "");
    Expect(0, 93855, '\p{^inmedefaidrin}', "");
    Expect(0, 93855, '\P{inmedefaidrin}', "");
    Expect(1, 93855, '\P{^inmedefaidrin}', "");
    Expect(0, 93856, '\p{inmedefaidrin}', "");
    Expect(1, 93856, '\p{^inmedefaidrin}', "");
    Expect(1, 93856, '\P{inmedefaidrin}', "");
    Expect(0, 93856, '\P{^inmedefaidrin}', "");
    Expect(1, 93855, '\p{__In_medefaidrin}', "");
    Expect(0, 93855, '\p{^__In_medefaidrin}', "");
    Expect(0, 93855, '\P{__In_medefaidrin}', "");
    Expect(1, 93855, '\P{^__In_medefaidrin}', "");
    Expect(0, 93856, '\p{__In_medefaidrin}', "");
    Expect(1, 93856, '\p{^__In_medefaidrin}', "");
    Expect(1, 93856, '\P{__In_medefaidrin}', "");
    Expect(0, 93856, '\P{^__In_medefaidrin}', "");
    Error('\p{:= 	In_Medefaidrin}');
    Error('\P{:= 	In_Medefaidrin}');
    Expect(1, 93855, '\p{- in_medefaidrin}', "");
    Expect(0, 93855, '\p{^- in_medefaidrin}', "");
    Expect(0, 93855, '\P{- in_medefaidrin}', "");
    Expect(1, 93855, '\P{^- in_medefaidrin}', "");
    Expect(0, 93856, '\p{- in_medefaidrin}', "");
    Expect(1, 93856, '\p{^- in_medefaidrin}', "");
    Expect(1, 93856, '\P{- in_medefaidrin}', "");
    Expect(0, 93856, '\P{^- in_medefaidrin}', "");
    Error('\p{	/a/In_Meetei_Mayek}');
    Error('\P{	/a/In_Meetei_Mayek}');
    Expect(1, 44031, '\p{inmeeteimayek}', "");
    Expect(0, 44031, '\p{^inmeeteimayek}', "");
    Expect(0, 44031, '\P{inmeeteimayek}', "");
    Expect(1, 44031, '\P{^inmeeteimayek}', "");
    Expect(0, 44032, '\p{inmeeteimayek}', "");
    Expect(1, 44032, '\p{^inmeeteimayek}', "");
    Expect(1, 44032, '\P{inmeeteimayek}', "");
    Expect(0, 44032, '\P{^inmeeteimayek}', "");
    Expect(1, 44031, '\p{		in_Meetei_Mayek}', "");
    Expect(0, 44031, '\p{^		in_Meetei_Mayek}', "");
    Expect(0, 44031, '\P{		in_Meetei_Mayek}', "");
    Expect(1, 44031, '\P{^		in_Meetei_Mayek}', "");
    Expect(0, 44032, '\p{		in_Meetei_Mayek}', "");
    Expect(1, 44032, '\p{^		in_Meetei_Mayek}', "");
    Expect(1, 44032, '\P{		in_Meetei_Mayek}', "");
    Expect(0, 44032, '\P{^		in_Meetei_Mayek}', "");
    Error('\p{In_meetei_MAYEK:=}');
    Error('\P{In_meetei_MAYEK:=}');
    Expect(1, 44031, '\p{ -in_meetei_mayek}', "");
    Expect(0, 44031, '\p{^ -in_meetei_mayek}', "");
    Expect(0, 44031, '\P{ -in_meetei_mayek}', "");
    Expect(1, 44031, '\P{^ -in_meetei_mayek}', "");
    Expect(0, 44032, '\p{ -in_meetei_mayek}', "");
    Expect(1, 44032, '\p{^ -in_meetei_mayek}', "");
    Expect(1, 44032, '\P{ -in_meetei_mayek}', "");
    Expect(0, 44032, '\P{^ -in_meetei_mayek}', "");
    Error('\p{:=	-in_mende_Kikakui}');
    Error('\P{:=	-in_mende_Kikakui}');
    Expect(1, 125151, '\p{inmendekikakui}', "");
    Expect(0, 125151, '\p{^inmendekikakui}', "");
    Expect(0, 125151, '\P{inmendekikakui}', "");
    Expect(1, 125151, '\P{^inmendekikakui}', "");
    Expect(0, 125152, '\p{inmendekikakui}', "");
    Expect(1, 125152, '\p{^inmendekikakui}', "");
    Expect(1, 125152, '\P{inmendekikakui}', "");
    Expect(0, 125152, '\P{^inmendekikakui}', "");
    Expect(1, 125151, '\p{_ In_Mende_kikakui}', "");
    Expect(0, 125151, '\p{^_ In_Mende_kikakui}', "");
    Expect(0, 125151, '\P{_ In_Mende_kikakui}', "");
    Expect(1, 125151, '\P{^_ In_Mende_kikakui}', "");
    Expect(0, 125152, '\p{_ In_Mende_kikakui}', "");
    Expect(1, 125152, '\p{^_ In_Mende_kikakui}', "");
    Expect(1, 125152, '\P{_ In_Mende_kikakui}', "");
    Expect(0, 125152, '\P{^_ In_Mende_kikakui}', "");
    Error('\p{	-in_MENDE_kikakui/a/}');
    Error('\P{	-in_MENDE_kikakui/a/}');
    Expect(1, 125151, '\p{ -in_mende_KIKAKUI}', "");
    Expect(0, 125151, '\p{^ -in_mende_KIKAKUI}', "");
    Expect(0, 125151, '\P{ -in_mende_KIKAKUI}', "");
    Expect(1, 125151, '\P{^ -in_mende_KIKAKUI}', "");
    Expect(0, 125152, '\p{ -in_mende_KIKAKUI}', "");
    Expect(1, 125152, '\p{^ -in_mende_KIKAKUI}', "");
    Expect(1, 125152, '\P{ -in_mende_KIKAKUI}', "");
    Expect(0, 125152, '\P{^ -in_mende_KIKAKUI}', "");
    Error('\p{/a/ in_Meroitic_Cursive}');
    Error('\P{/a/ in_Meroitic_Cursive}');
    Expect(1, 68095, '\p{inmeroiticcursive}', "");
    Expect(0, 68095, '\p{^inmeroiticcursive}', "");
    Expect(0, 68095, '\P{inmeroiticcursive}', "");
    Expect(1, 68095, '\P{^inmeroiticcursive}', "");
    Expect(0, 68096, '\p{inmeroiticcursive}', "");
    Expect(1, 68096, '\p{^inmeroiticcursive}', "");
    Expect(1, 68096, '\P{inmeroiticcursive}', "");
    Expect(0, 68096, '\P{^inmeroiticcursive}', "");
    Expect(1, 68095, '\p{ in_Meroitic_Cursive}', "");
    Expect(0, 68095, '\p{^ in_Meroitic_Cursive}', "");
    Expect(0, 68095, '\P{ in_Meroitic_Cursive}', "");
    Expect(1, 68095, '\P{^ in_Meroitic_Cursive}', "");
    Expect(0, 68096, '\p{ in_Meroitic_Cursive}', "");
    Expect(1, 68096, '\p{^ in_Meroitic_Cursive}', "");
    Expect(1, 68096, '\P{ in_Meroitic_Cursive}', "");
    Expect(0, 68096, '\P{^ in_Meroitic_Cursive}', "");
    Error('\p{	:=In_Meroitic_CURSIVE}');
    Error('\P{	:=In_Meroitic_CURSIVE}');
    Expect(1, 68095, '\p{_ In_Meroitic_Cursive}', "");
    Expect(0, 68095, '\p{^_ In_Meroitic_Cursive}', "");
    Expect(0, 68095, '\P{_ In_Meroitic_Cursive}', "");
    Expect(1, 68095, '\P{^_ In_Meroitic_Cursive}', "");
    Expect(0, 68096, '\p{_ In_Meroitic_Cursive}', "");
    Expect(1, 68096, '\p{^_ In_Meroitic_Cursive}', "");
    Expect(1, 68096, '\P{_ In_Meroitic_Cursive}', "");
    Expect(0, 68096, '\P{^_ In_Meroitic_Cursive}', "");
    Error('\p{/a/	-In_MEROITIC_hieroglyphs}');
    Error('\P{/a/	-In_MEROITIC_hieroglyphs}');
    Expect(1, 67999, '\p{inmeroitichieroglyphs}', "");
    Expect(0, 67999, '\p{^inmeroitichieroglyphs}', "");
    Expect(0, 67999, '\P{inmeroitichieroglyphs}', "");
    Expect(1, 67999, '\P{^inmeroitichieroglyphs}', "");
    Expect(0, 68000, '\p{inmeroitichieroglyphs}', "");
    Expect(1, 68000, '\p{^inmeroitichieroglyphs}', "");
    Expect(1, 68000, '\P{inmeroitichieroglyphs}', "");
    Expect(0, 68000, '\P{^inmeroitichieroglyphs}', "");
    Expect(1, 67999, '\p{_IN_meroitic_hieroglyphs}', "");
    Expect(0, 67999, '\p{^_IN_meroitic_hieroglyphs}', "");
    Expect(0, 67999, '\P{_IN_meroitic_hieroglyphs}', "");
    Expect(1, 67999, '\P{^_IN_meroitic_hieroglyphs}', "");
    Expect(0, 68000, '\p{_IN_meroitic_hieroglyphs}', "");
    Expect(1, 68000, '\p{^_IN_meroitic_hieroglyphs}', "");
    Expect(1, 68000, '\P{_IN_meroitic_hieroglyphs}', "");
    Expect(0, 68000, '\P{^_IN_meroitic_hieroglyphs}', "");
    Error('\p{ IN_MEROITIC_hieroglyphs/a/}');
    Error('\P{ IN_MEROITIC_hieroglyphs/a/}');
    Expect(1, 67999, '\p{__In_MEROITIC_HIEROGLYPHS}', "");
    Expect(0, 67999, '\p{^__In_MEROITIC_HIEROGLYPHS}', "");
    Expect(0, 67999, '\P{__In_MEROITIC_HIEROGLYPHS}', "");
    Expect(1, 67999, '\P{^__In_MEROITIC_HIEROGLYPHS}', "");
    Expect(0, 68000, '\p{__In_MEROITIC_HIEROGLYPHS}', "");
    Expect(1, 68000, '\p{^__In_MEROITIC_HIEROGLYPHS}', "");
    Expect(1, 68000, '\P{__In_MEROITIC_HIEROGLYPHS}', "");
    Expect(0, 68000, '\P{^__In_MEROITIC_HIEROGLYPHS}', "");
    Error('\p{-IN_miao/a/}');
    Error('\P{-IN_miao/a/}');
    Expect(1, 94111, '\p{inmiao}', "");
    Expect(0, 94111, '\p{^inmiao}', "");
    Expect(0, 94111, '\P{inmiao}', "");
    Expect(1, 94111, '\P{^inmiao}', "");
    Expect(0, 94112, '\p{inmiao}', "");
    Expect(1, 94112, '\p{^inmiao}', "");
    Expect(1, 94112, '\P{inmiao}', "");
    Expect(0, 94112, '\P{^inmiao}', "");
    Expect(1, 94111, '\p{- in_miao}', "");
    Expect(0, 94111, '\p{^- in_miao}', "");
    Expect(0, 94111, '\P{- in_miao}', "");
    Expect(1, 94111, '\P{^- in_miao}', "");
    Expect(0, 94112, '\p{- in_miao}', "");
    Expect(1, 94112, '\p{^- in_miao}', "");
    Expect(1, 94112, '\P{- in_miao}', "");
    Expect(0, 94112, '\P{^- in_miao}', "");
    Error('\p{/a/__IN_Miao}');
    Error('\P{/a/__IN_Miao}');
    Expect(1, 94111, '\p{ -in_miao}', "");
    Expect(0, 94111, '\p{^ -in_miao}', "");
    Expect(0, 94111, '\P{ -in_miao}', "");
    Expect(1, 94111, '\P{^ -in_miao}', "");
    Expect(0, 94112, '\p{ -in_miao}', "");
    Expect(1, 94112, '\p{^ -in_miao}', "");
    Expect(1, 94112, '\P{ -in_miao}', "");
    Expect(0, 94112, '\P{^ -in_miao}', "");
    Error('\p{-:=In_modi}');
    Error('\P{-:=In_modi}');
    Expect(1, 71263, '\p{inmodi}', "");
    Expect(0, 71263, '\p{^inmodi}', "");
    Expect(0, 71263, '\P{inmodi}', "");
    Expect(1, 71263, '\P{^inmodi}', "");
    Expect(0, 71264, '\p{inmodi}', "");
    Expect(1, 71264, '\p{^inmodi}', "");
    Expect(1, 71264, '\P{inmodi}', "");
    Expect(0, 71264, '\P{^inmodi}', "");
    Expect(1, 71263, '\p{_ In_Modi}', "");
    Expect(0, 71263, '\p{^_ In_Modi}', "");
    Expect(0, 71263, '\P{_ In_Modi}', "");
    Expect(1, 71263, '\P{^_ In_Modi}', "");
    Expect(0, 71264, '\p{_ In_Modi}', "");
    Expect(1, 71264, '\p{^_ In_Modi}', "");
    Expect(1, 71264, '\P{_ In_Modi}', "");
    Expect(0, 71264, '\P{^_ In_Modi}', "");
    Error('\p{/a/in_MODI}');
    Error('\P{/a/in_MODI}');
    Expect(1, 71263, '\p{	_In_modi}', "");
    Expect(0, 71263, '\p{^	_In_modi}', "");
    Expect(0, 71263, '\P{	_In_modi}', "");
    Expect(1, 71263, '\P{^	_In_modi}', "");
    Expect(0, 71264, '\p{	_In_modi}', "");
    Expect(1, 71264, '\p{^	_In_modi}', "");
    Expect(1, 71264, '\P{	_In_modi}', "");
    Expect(0, 71264, '\P{^	_In_modi}', "");
    Error('\p{in_mongolian:=}');
    Error('\P{in_mongolian:=}');
    Expect(1, 6319, '\p{inmongolian}', "");
    Expect(0, 6319, '\p{^inmongolian}', "");
    Expect(0, 6319, '\P{inmongolian}', "");
    Expect(1, 6319, '\P{^inmongolian}', "");
    Expect(0, 6320, '\p{inmongolian}', "");
    Expect(1, 6320, '\p{^inmongolian}', "");
    Expect(1, 6320, '\P{inmongolian}', "");
    Expect(0, 6320, '\P{^inmongolian}', "");
    Expect(1, 6319, '\p{	-IN_mongolian}', "");
    Expect(0, 6319, '\p{^	-IN_mongolian}', "");
    Expect(0, 6319, '\P{	-IN_mongolian}', "");
    Expect(1, 6319, '\P{^	-IN_mongolian}', "");
    Expect(0, 6320, '\p{	-IN_mongolian}', "");
    Expect(1, 6320, '\p{^	-IN_mongolian}', "");
    Expect(1, 6320, '\P{	-IN_mongolian}', "");
    Expect(0, 6320, '\P{^	-IN_mongolian}', "");
    Error('\p{:=-	IN_MONGOLIAN}');
    Error('\P{:=-	IN_MONGOLIAN}');
    Expect(1, 6319, '\p{in_Mongolian}', "");
    Expect(0, 6319, '\p{^in_Mongolian}', "");
    Expect(0, 6319, '\P{in_Mongolian}', "");
    Expect(1, 6319, '\P{^in_Mongolian}', "");
    Expect(0, 6320, '\p{in_Mongolian}', "");
    Expect(1, 6320, '\p{^in_Mongolian}', "");
    Expect(1, 6320, '\P{in_Mongolian}', "");
    Expect(0, 6320, '\P{^in_Mongolian}', "");
    Error('\p{ :=In_Mro}');
    Error('\P{ :=In_Mro}');
    Expect(1, 92783, '\p{inmro}', "");
    Expect(0, 92783, '\p{^inmro}', "");
    Expect(0, 92783, '\P{inmro}', "");
    Expect(1, 92783, '\P{^inmro}', "");
    Expect(0, 92784, '\p{inmro}', "");
    Expect(1, 92784, '\p{^inmro}', "");
    Expect(1, 92784, '\P{inmro}', "");
    Expect(0, 92784, '\P{^inmro}', "");
    Expect(1, 92783, '\p{-_IN_MRO}', "");
    Expect(0, 92783, '\p{^-_IN_MRO}', "");
    Expect(0, 92783, '\P{-_IN_MRO}', "");
    Expect(1, 92783, '\P{^-_IN_MRO}', "");
    Expect(0, 92784, '\p{-_IN_MRO}', "");
    Expect(1, 92784, '\p{^-_IN_MRO}', "");
    Expect(1, 92784, '\P{-_IN_MRO}', "");
    Expect(0, 92784, '\P{^-_IN_MRO}', "");
    Error('\p{	IN_mro:=}');
    Error('\P{	IN_mro:=}');
    Expect(1, 92783, '\p{-In_Mro}', "");
    Expect(0, 92783, '\p{^-In_Mro}', "");
    Expect(0, 92783, '\P{-In_Mro}', "");
    Expect(1, 92783, '\P{^-In_Mro}', "");
    Expect(0, 92784, '\p{-In_Mro}', "");
    Expect(1, 92784, '\p{^-In_Mro}', "");
    Expect(1, 92784, '\P{-In_Mro}', "");
    Expect(0, 92784, '\P{^-In_Mro}', "");
    Error('\p{/a/-In_Multani}');
    Error('\P{/a/-In_Multani}');
    Expect(1, 70319, '\p{inmultani}', "");
    Expect(0, 70319, '\p{^inmultani}', "");
    Expect(0, 70319, '\P{inmultani}', "");
    Expect(1, 70319, '\P{^inmultani}', "");
    Expect(0, 70320, '\p{inmultani}', "");
    Expect(1, 70320, '\p{^inmultani}', "");
    Expect(1, 70320, '\P{inmultani}', "");
    Expect(0, 70320, '\P{^inmultani}', "");
    Expect(1, 70319, '\p{-In_MULTANI}', "");
    Expect(0, 70319, '\p{^-In_MULTANI}', "");
    Expect(0, 70319, '\P{-In_MULTANI}', "");
    Expect(1, 70319, '\P{^-In_MULTANI}', "");
    Expect(0, 70320, '\p{-In_MULTANI}', "");
    Expect(1, 70320, '\p{^-In_MULTANI}', "");
    Expect(1, 70320, '\P{-In_MULTANI}', "");
    Expect(0, 70320, '\P{^-In_MULTANI}', "");
    Error('\p{/a/-in_multani}');
    Error('\P{/a/-in_multani}');
    Expect(1, 70319, '\p{  In_multani}', "");
    Expect(0, 70319, '\p{^  In_multani}', "");
    Expect(0, 70319, '\P{  In_multani}', "");
    Expect(1, 70319, '\P{^  In_multani}', "");
    Expect(0, 70320, '\p{  In_multani}', "");
    Expect(1, 70320, '\p{^  In_multani}', "");
    Expect(1, 70320, '\P{  In_multani}', "");
    Expect(0, 70320, '\P{^  In_multani}', "");
    Error('\p{ /a/In_MYANMAR}');
    Error('\P{ /a/In_MYANMAR}');
    Expect(1, 4255, '\p{inmyanmar}', "");
    Expect(0, 4255, '\p{^inmyanmar}', "");
    Expect(0, 4255, '\P{inmyanmar}', "");
    Expect(1, 4255, '\P{^inmyanmar}', "");
    Expect(0, 4256, '\p{inmyanmar}', "");
    Expect(1, 4256, '\p{^inmyanmar}', "");
    Expect(1, 4256, '\P{inmyanmar}', "");
    Expect(0, 4256, '\P{^inmyanmar}', "");
    Expect(1, 4255, '\p{__IN_MYANMAR}', "");
    Expect(0, 4255, '\p{^__IN_MYANMAR}', "");
    Expect(0, 4255, '\P{__IN_MYANMAR}', "");
    Expect(1, 4255, '\P{^__IN_MYANMAR}', "");
    Expect(0, 4256, '\p{__IN_MYANMAR}', "");
    Expect(1, 4256, '\p{^__IN_MYANMAR}', "");
    Expect(1, 4256, '\P{__IN_MYANMAR}', "");
    Expect(0, 4256, '\P{^__IN_MYANMAR}', "");
    Error('\p{:= In_Myanmar}');
    Error('\P{:= In_Myanmar}');
    Expect(1, 4255, '\p{_	in_MYANMAR}', "");
    Expect(0, 4255, '\p{^_	in_MYANMAR}', "");
    Expect(0, 4255, '\P{_	in_MYANMAR}', "");
    Expect(1, 4255, '\P{^_	in_MYANMAR}', "");
    Expect(0, 4256, '\p{_	in_MYANMAR}', "");
    Expect(1, 4256, '\p{^_	in_MYANMAR}', "");
    Expect(1, 4256, '\P{_	in_MYANMAR}', "");
    Expect(0, 4256, '\P{^_	in_MYANMAR}', "");
    Error('\p{_-In_Nabataean/a/}');
    Error('\P{_-In_Nabataean/a/}');
    Expect(1, 67759, '\p{innabataean}', "");
    Expect(0, 67759, '\p{^innabataean}', "");
    Expect(0, 67759, '\P{innabataean}', "");
    Expect(1, 67759, '\P{^innabataean}', "");
    Expect(0, 67760, '\p{innabataean}', "");
    Expect(1, 67760, '\p{^innabataean}', "");
    Expect(1, 67760, '\P{innabataean}', "");
    Expect(0, 67760, '\P{^innabataean}', "");
    Expect(1, 67759, '\p{	IN_Nabataean}', "");
    Expect(0, 67759, '\p{^	IN_Nabataean}', "");
    Expect(0, 67759, '\P{	IN_Nabataean}', "");
    Expect(1, 67759, '\P{^	IN_Nabataean}', "");
    Expect(0, 67760, '\p{	IN_Nabataean}', "");
    Expect(1, 67760, '\p{^	IN_Nabataean}', "");
    Expect(1, 67760, '\P{	IN_Nabataean}', "");
    Expect(0, 67760, '\P{^	IN_Nabataean}', "");
    Error('\p{ /a/In_nabataean}');
    Error('\P{ /a/In_nabataean}');
    Expect(1, 67759, '\p{-In_NABATAEAN}', "");
    Expect(0, 67759, '\p{^-In_NABATAEAN}', "");
    Expect(0, 67759, '\P{-In_NABATAEAN}', "");
    Expect(1, 67759, '\P{^-In_NABATAEAN}', "");
    Expect(0, 67760, '\p{-In_NABATAEAN}', "");
    Expect(1, 67760, '\p{^-In_NABATAEAN}', "");
    Expect(1, 67760, '\P{-In_NABATAEAN}', "");
    Expect(0, 67760, '\P{^-In_NABATAEAN}', "");
    Error('\p{ -in_Nandinagari:=}');
    Error('\P{ -in_Nandinagari:=}');
    Expect(1, 72191, '\p{innandinagari}', "");
    Expect(0, 72191, '\p{^innandinagari}', "");
    Expect(0, 72191, '\P{innandinagari}', "");
    Expect(1, 72191, '\P{^innandinagari}', "");
    Expect(0, 72192, '\p{innandinagari}', "");
    Expect(1, 72192, '\p{^innandinagari}', "");
    Expect(1, 72192, '\P{innandinagari}', "");
    Expect(0, 72192, '\P{^innandinagari}', "");
    Expect(1, 72191, '\p{-	IN_Nandinagari}', "");
    Expect(0, 72191, '\p{^-	IN_Nandinagari}', "");
    Expect(0, 72191, '\P{-	IN_Nandinagari}', "");
    Expect(1, 72191, '\P{^-	IN_Nandinagari}', "");
    Expect(0, 72192, '\p{-	IN_Nandinagari}', "");
    Expect(1, 72192, '\p{^-	IN_Nandinagari}', "");
    Expect(1, 72192, '\P{-	IN_Nandinagari}', "");
    Expect(0, 72192, '\P{^-	IN_Nandinagari}', "");
    Error('\p{_ In_NANDINAGARI:=}');
    Error('\P{_ In_NANDINAGARI:=}');
    Expect(1, 72191, '\p{	_In_nandinagari}', "");
    Expect(0, 72191, '\p{^	_In_nandinagari}', "");
    Expect(0, 72191, '\P{	_In_nandinagari}', "");
    Expect(1, 72191, '\P{^	_In_nandinagari}', "");
    Expect(0, 72192, '\p{	_In_nandinagari}', "");
    Expect(1, 72192, '\p{^	_In_nandinagari}', "");
    Expect(1, 72192, '\P{	_In_nandinagari}', "");
    Expect(0, 72192, '\P{^	_In_nandinagari}', "");
    Error('\p{:=In_NEW_Tai_LUE}');
    Error('\P{:=In_NEW_Tai_LUE}');
    Expect(1, 6623, '\p{innewtailue}', "");
    Expect(0, 6623, '\p{^innewtailue}', "");
    Expect(0, 6623, '\P{innewtailue}', "");
    Expect(1, 6623, '\P{^innewtailue}', "");
    Expect(0, 6624, '\p{innewtailue}', "");
    Expect(1, 6624, '\p{^innewtailue}', "");
    Expect(1, 6624, '\P{innewtailue}', "");
    Expect(0, 6624, '\P{^innewtailue}', "");
    Expect(1, 6623, '\p{_	In_NEW_Tai_LUE}', "");
    Expect(0, 6623, '\p{^_	In_NEW_Tai_LUE}', "");
    Expect(0, 6623, '\P{_	In_NEW_Tai_LUE}', "");
    Expect(1, 6623, '\P{^_	In_NEW_Tai_LUE}', "");
    Expect(0, 6624, '\p{_	In_NEW_Tai_LUE}', "");
    Expect(1, 6624, '\p{^_	In_NEW_Tai_LUE}', "");
    Expect(1, 6624, '\P{_	In_NEW_Tai_LUE}', "");
    Expect(0, 6624, '\P{^_	In_NEW_Tai_LUE}', "");
    Error('\p{-/a/IN_New_Tai_Lue}');
    Error('\P{-/a/IN_New_Tai_Lue}');
    Expect(1, 6623, '\p{-_In_New_Tai_Lue}', "");
    Expect(0, 6623, '\p{^-_In_New_Tai_Lue}', "");
    Expect(0, 6623, '\P{-_In_New_Tai_Lue}', "");
    Expect(1, 6623, '\P{^-_In_New_Tai_Lue}', "");
    Expect(0, 6624, '\p{-_In_New_Tai_Lue}', "");
    Expect(1, 6624, '\p{^-_In_New_Tai_Lue}', "");
    Expect(1, 6624, '\P{-_In_New_Tai_Lue}', "");
    Expect(0, 6624, '\P{^-_In_New_Tai_Lue}', "");
    Error('\p{-In_NEWA/a/}');
    Error('\P{-In_NEWA/a/}');
    Expect(1, 70783, '\p{innewa}', "");
    Expect(0, 70783, '\p{^innewa}', "");
    Expect(0, 70783, '\P{innewa}', "");
    Expect(1, 70783, '\P{^innewa}', "");
    Expect(0, 70784, '\p{innewa}', "");
    Expect(1, 70784, '\p{^innewa}', "");
    Expect(1, 70784, '\P{innewa}', "");
    Expect(0, 70784, '\P{^innewa}', "");
    Expect(1, 70783, '\p{		In_NEWA}', "");
    Expect(0, 70783, '\p{^		In_NEWA}', "");
    Expect(0, 70783, '\P{		In_NEWA}', "");
    Expect(1, 70783, '\P{^		In_NEWA}', "");
    Expect(0, 70784, '\p{		In_NEWA}', "");
    Expect(1, 70784, '\p{^		In_NEWA}', "");
    Expect(1, 70784, '\P{		In_NEWA}', "");
    Expect(0, 70784, '\P{^		In_NEWA}', "");
    Error('\p{-_In_newa:=}');
    Error('\P{-_In_newa:=}');
    Expect(1, 70783, '\p{-_IN_Newa}', "");
    Expect(0, 70783, '\p{^-_IN_Newa}', "");
    Expect(0, 70783, '\P{-_IN_Newa}', "");
    Expect(1, 70783, '\P{^-_IN_Newa}', "");
    Expect(0, 70784, '\p{-_IN_Newa}', "");
    Expect(1, 70784, '\p{^-_IN_Newa}', "");
    Expect(1, 70784, '\P{-_IN_Newa}', "");
    Expect(0, 70784, '\P{^-_IN_Newa}', "");
    Error('\p{/a/	IN_NKo}');
    Error('\P{/a/	IN_NKo}');
    Expect(1, 2047, '\p{innko}', "");
    Expect(0, 2047, '\p{^innko}', "");
    Expect(0, 2047, '\P{innko}', "");
    Expect(1, 2047, '\P{^innko}', "");
    Expect(0, 2048, '\p{innko}', "");
    Expect(1, 2048, '\p{^innko}', "");
    Expect(1, 2048, '\P{innko}', "");
    Expect(0, 2048, '\P{^innko}', "");
    Expect(1, 2047, '\p{ -In_NKO}', "");
    Expect(0, 2047, '\p{^ -In_NKO}', "");
    Expect(0, 2047, '\P{ -In_NKO}', "");
    Expect(1, 2047, '\P{^ -In_NKO}', "");
    Expect(0, 2048, '\p{ -In_NKO}', "");
    Expect(1, 2048, '\p{^ -In_NKO}', "");
    Expect(1, 2048, '\P{ -In_NKO}', "");
    Expect(0, 2048, '\P{^ -In_NKO}', "");
    Error('\p{:=-in_NKO}');
    Error('\P{:=-in_NKO}');
    Expect(1, 2047, '\p{- in_NKo}', "");
    Expect(0, 2047, '\p{^- in_NKo}', "");
    Expect(0, 2047, '\P{- in_NKo}', "");
    Expect(1, 2047, '\P{^- in_NKo}', "");
    Expect(0, 2048, '\p{- in_NKo}', "");
    Expect(1, 2048, '\p{^- in_NKo}', "");
    Expect(1, 2048, '\P{- in_NKo}', "");
    Expect(0, 2048, '\P{^- in_NKo}', "");
    Error('\p{/a/in_nushu}');
    Error('\P{/a/in_nushu}');
    Expect(1, 111359, '\p{innushu}', "");
    Expect(0, 111359, '\p{^innushu}', "");
    Expect(0, 111359, '\P{innushu}', "");
    Expect(1, 111359, '\P{^innushu}', "");
    Expect(0, 111360, '\p{innushu}', "");
    Expect(1, 111360, '\p{^innushu}', "");
    Expect(1, 111360, '\P{innushu}', "");
    Expect(0, 111360, '\P{^innushu}', "");
    Expect(1, 111359, '\p{_-In_Nushu}', "");
    Expect(0, 111359, '\p{^_-In_Nushu}', "");
    Expect(0, 111359, '\P{_-In_Nushu}', "");
    Expect(1, 111359, '\P{^_-In_Nushu}', "");
    Expect(0, 111360, '\p{_-In_Nushu}', "");
    Expect(1, 111360, '\p{^_-In_Nushu}', "");
    Expect(1, 111360, '\P{_-In_Nushu}', "");
    Expect(0, 111360, '\P{^_-In_Nushu}', "");
    Error('\p{ _in_Nushu:=}');
    Error('\P{ _in_Nushu:=}');
    Error('\p{_-In_nyiakeng_Puachue_HMONG/a/}');
    Error('\P{_-In_nyiakeng_Puachue_HMONG/a/}');
    Expect(1, 123215, '\p{innyiakengpuachuehmong}', "");
    Expect(0, 123215, '\p{^innyiakengpuachuehmong}', "");
    Expect(0, 123215, '\P{innyiakengpuachuehmong}', "");
    Expect(1, 123215, '\P{^innyiakengpuachuehmong}', "");
    Expect(0, 123216, '\p{innyiakengpuachuehmong}', "");
    Expect(1, 123216, '\p{^innyiakengpuachuehmong}', "");
    Expect(1, 123216, '\P{innyiakengpuachuehmong}', "");
    Expect(0, 123216, '\P{^innyiakengpuachuehmong}', "");
    Expect(1, 123215, '\p{-In_nyiakeng_Puachue_Hmong}', "");
    Expect(0, 123215, '\p{^-In_nyiakeng_Puachue_Hmong}', "");
    Expect(0, 123215, '\P{-In_nyiakeng_Puachue_Hmong}', "");
    Expect(1, 123215, '\P{^-In_nyiakeng_Puachue_Hmong}', "");
    Expect(0, 123216, '\p{-In_nyiakeng_Puachue_Hmong}', "");
    Expect(1, 123216, '\p{^-In_nyiakeng_Puachue_Hmong}', "");
    Expect(1, 123216, '\P{-In_nyiakeng_Puachue_Hmong}', "");
    Expect(0, 123216, '\P{^-In_nyiakeng_Puachue_Hmong}', "");
    Error('\p{:= _IN_NYIAKENG_Puachue_hmong}');
    Error('\P{:= _IN_NYIAKENG_Puachue_hmong}');
    Expect(1, 123215, '\p{_in_NYIAKENG_Puachue_Hmong}', "");
    Expect(0, 123215, '\p{^_in_NYIAKENG_Puachue_Hmong}', "");
    Expect(0, 123215, '\P{_in_NYIAKENG_Puachue_Hmong}', "");
    Expect(1, 123215, '\P{^_in_NYIAKENG_Puachue_Hmong}', "");
    Expect(0, 123216, '\p{_in_NYIAKENG_Puachue_Hmong}', "");
    Expect(1, 123216, '\p{^_in_NYIAKENG_Puachue_Hmong}', "");
    Expect(1, 123216, '\P{_in_NYIAKENG_Puachue_Hmong}', "");
    Expect(0, 123216, '\P{^_in_NYIAKENG_Puachue_Hmong}', "");
    Error('\p{ -In_OGHAM/a/}');
    Error('\P{ -In_OGHAM/a/}');
    Expect(1, 5791, '\p{inogham}', "");
    Expect(0, 5791, '\p{^inogham}', "");
    Expect(0, 5791, '\P{inogham}', "");
    Expect(1, 5791, '\P{^inogham}', "");
    Expect(0, 5792, '\p{inogham}', "");
    Expect(1, 5792, '\p{^inogham}', "");
    Expect(1, 5792, '\P{inogham}', "");
    Expect(0, 5792, '\P{^inogham}', "");
    Expect(1, 5791, '\p{  IN_Ogham}', "");
    Expect(0, 5791, '\p{^  IN_Ogham}', "");
    Expect(0, 5791, '\P{  IN_Ogham}', "");
    Expect(1, 5791, '\P{^  IN_Ogham}', "");
    Expect(0, 5792, '\p{  IN_Ogham}', "");
    Expect(1, 5792, '\p{^  IN_Ogham}', "");
    Expect(1, 5792, '\P{  IN_Ogham}', "");
    Expect(0, 5792, '\P{^  IN_Ogham}', "");
    Error('\p{/a/In_Ogham}');
    Error('\P{/a/In_Ogham}');
    Expect(1, 5791, '\p{		In_ogham}', "");
    Expect(0, 5791, '\p{^		In_ogham}', "");
    Expect(0, 5791, '\P{		In_ogham}', "");
    Expect(1, 5791, '\P{^		In_ogham}', "");
    Expect(0, 5792, '\p{		In_ogham}', "");
    Expect(1, 5792, '\p{^		In_ogham}', "");
    Expect(1, 5792, '\P{		In_ogham}', "");
    Expect(0, 5792, '\P{^		In_ogham}', "");
    Error('\p{	/a/IN_Ol_chiki}');
    Error('\P{	/a/IN_Ol_chiki}');
    Expect(1, 7295, '\p{inolchiki}', "");
    Expect(0, 7295, '\p{^inolchiki}', "");
    Expect(0, 7295, '\P{inolchiki}', "");
    Expect(1, 7295, '\P{^inolchiki}', "");
    Expect(0, 7296, '\p{inolchiki}', "");
    Expect(1, 7296, '\p{^inolchiki}', "");
    Expect(1, 7296, '\P{inolchiki}', "");
    Expect(0, 7296, '\P{^inolchiki}', "");
    Expect(1, 7295, '\p{_In_Ol_Chiki}', "");
    Expect(0, 7295, '\p{^_In_Ol_Chiki}', "");
    Expect(0, 7295, '\P{_In_Ol_Chiki}', "");
    Expect(1, 7295, '\P{^_In_Ol_Chiki}', "");
    Expect(0, 7296, '\p{_In_Ol_Chiki}', "");
    Expect(1, 7296, '\p{^_In_Ol_Chiki}', "");
    Expect(1, 7296, '\P{_In_Ol_Chiki}', "");
    Expect(0, 7296, '\P{^_In_Ol_Chiki}', "");
    Error('\p{_-In_Ol_Chiki/a/}');
    Error('\P{_-In_Ol_Chiki/a/}');
    Expect(1, 7295, '\p{-_In_OL_Chiki}', "");
    Expect(0, 7295, '\p{^-_In_OL_Chiki}', "");
    Expect(0, 7295, '\P{-_In_OL_Chiki}', "");
    Expect(1, 7295, '\P{^-_In_OL_Chiki}', "");
    Expect(0, 7296, '\p{-_In_OL_Chiki}', "");
    Expect(1, 7296, '\p{^-_In_OL_Chiki}', "");
    Expect(1, 7296, '\P{-_In_OL_Chiki}', "");
    Expect(0, 7296, '\P{^-_In_OL_Chiki}', "");
    Error('\p{		IN_Old_Hungarian:=}');
    Error('\P{		IN_Old_Hungarian:=}');
    Expect(1, 68863, '\p{inoldhungarian}', "");
    Expect(0, 68863, '\p{^inoldhungarian}', "");
    Expect(0, 68863, '\P{inoldhungarian}', "");
    Expect(1, 68863, '\P{^inoldhungarian}', "");
    Expect(0, 68864, '\p{inoldhungarian}', "");
    Expect(1, 68864, '\p{^inoldhungarian}', "");
    Expect(1, 68864, '\P{inoldhungarian}', "");
    Expect(0, 68864, '\P{^inoldhungarian}', "");
    Expect(1, 68863, '\p{ In_Old_hungarian}', "");
    Expect(0, 68863, '\p{^ In_Old_hungarian}', "");
    Expect(0, 68863, '\P{ In_Old_hungarian}', "");
    Expect(1, 68863, '\P{^ In_Old_hungarian}', "");
    Expect(0, 68864, '\p{ In_Old_hungarian}', "");
    Expect(1, 68864, '\p{^ In_Old_hungarian}', "");
    Expect(1, 68864, '\P{ In_Old_hungarian}', "");
    Expect(0, 68864, '\P{^ In_Old_hungarian}', "");
    Error('\p{_:=in_OLD_HUNGARIAN}');
    Error('\P{_:=in_OLD_HUNGARIAN}');
    Expect(1, 68863, '\p{--IN_old_HUNGARIAN}', "");
    Expect(0, 68863, '\p{^--IN_old_HUNGARIAN}', "");
    Expect(0, 68863, '\P{--IN_old_HUNGARIAN}', "");
    Expect(1, 68863, '\P{^--IN_old_HUNGARIAN}', "");
    Expect(0, 68864, '\p{--IN_old_HUNGARIAN}', "");
    Expect(1, 68864, '\p{^--IN_old_HUNGARIAN}', "");
    Expect(1, 68864, '\P{--IN_old_HUNGARIAN}', "");
    Expect(0, 68864, '\P{^--IN_old_HUNGARIAN}', "");
    Error('\p{:= _IN_Old_Italic}');
    Error('\P{:= _IN_Old_Italic}');
    Expect(1, 66351, '\p{inolditalic}', "");
    Expect(0, 66351, '\p{^inolditalic}', "");
    Expect(0, 66351, '\P{inolditalic}', "");
    Expect(1, 66351, '\P{^inolditalic}', "");
    Expect(0, 66352, '\p{inolditalic}', "");
    Expect(1, 66352, '\p{^inolditalic}', "");
    Expect(1, 66352, '\P{inolditalic}', "");
    Expect(0, 66352, '\P{^inolditalic}', "");
    Expect(1, 66351, '\p{_-in_old_Italic}', "");
    Expect(0, 66351, '\p{^_-in_old_Italic}', "");
    Expect(0, 66351, '\P{_-in_old_Italic}', "");
    Expect(1, 66351, '\P{^_-in_old_Italic}', "");
    Expect(0, 66352, '\p{_-in_old_Italic}', "");
    Expect(1, 66352, '\p{^_-in_old_Italic}', "");
    Expect(1, 66352, '\P{_-in_old_Italic}', "");
    Expect(0, 66352, '\P{^_-in_old_Italic}', "");
    Error('\p{_-In_Old_Italic/a/}');
    Error('\P{_-In_Old_Italic/a/}');
    Expect(1, 66351, '\p{_	In_Old_ITALIC}', "");
    Expect(0, 66351, '\p{^_	In_Old_ITALIC}', "");
    Expect(0, 66351, '\P{_	In_Old_ITALIC}', "");
    Expect(1, 66351, '\P{^_	In_Old_ITALIC}', "");
    Expect(0, 66352, '\p{_	In_Old_ITALIC}', "");
    Expect(1, 66352, '\p{^_	In_Old_ITALIC}', "");
    Expect(1, 66352, '\P{_	In_Old_ITALIC}', "");
    Expect(0, 66352, '\P{^_	In_Old_ITALIC}', "");
    Error('\p{:=in_OLD_NORTH_Arabian}');
    Error('\P{:=in_OLD_NORTH_Arabian}');
    Expect(1, 68255, '\p{inoldnortharabian}', "");
    Expect(0, 68255, '\p{^inoldnortharabian}', "");
    Expect(0, 68255, '\P{inoldnortharabian}', "");
    Expect(1, 68255, '\P{^inoldnortharabian}', "");
    Expect(0, 68256, '\p{inoldnortharabian}', "");
    Expect(1, 68256, '\p{^inoldnortharabian}', "");
    Expect(1, 68256, '\P{inoldnortharabian}', "");
    Expect(0, 68256, '\P{^inoldnortharabian}', "");
    Expect(1, 68255, '\p{- IN_old_North_Arabian}', "");
    Expect(0, 68255, '\p{^- IN_old_North_Arabian}', "");
    Expect(0, 68255, '\P{- IN_old_North_Arabian}', "");
    Expect(1, 68255, '\P{^- IN_old_North_Arabian}', "");
    Expect(0, 68256, '\p{- IN_old_North_Arabian}', "");
    Expect(1, 68256, '\p{^- IN_old_North_Arabian}', "");
    Expect(1, 68256, '\P{- IN_old_North_Arabian}', "");
    Expect(0, 68256, '\P{^- IN_old_North_Arabian}', "");
    Error('\p{ _in_old_North_Arabian/a/}');
    Error('\P{ _in_old_North_Arabian/a/}');
    Expect(1, 68255, '\p{_In_Old_North_Arabian}', "");
    Expect(0, 68255, '\p{^_In_Old_North_Arabian}', "");
    Expect(0, 68255, '\P{_In_Old_North_Arabian}', "");
    Expect(1, 68255, '\P{^_In_Old_North_Arabian}', "");
    Expect(0, 68256, '\p{_In_Old_North_Arabian}', "");
    Expect(1, 68256, '\p{^_In_Old_North_Arabian}', "");
    Expect(1, 68256, '\P{_In_Old_North_Arabian}', "");
    Expect(0, 68256, '\P{^_In_Old_North_Arabian}', "");
    Error('\p{_:=in_old_Permic}');
    Error('\P{_:=in_old_Permic}');
    Expect(1, 66431, '\p{inoldpermic}', "");
    Expect(0, 66431, '\p{^inoldpermic}', "");
    Expect(0, 66431, '\P{inoldpermic}', "");
    Expect(1, 66431, '\P{^inoldpermic}', "");
    Expect(0, 66432, '\p{inoldpermic}', "");
    Expect(1, 66432, '\p{^inoldpermic}', "");
    Expect(1, 66432, '\P{inoldpermic}', "");
    Expect(0, 66432, '\P{^inoldpermic}', "");
    Expect(1, 66431, '\p{_in_Old_Permic}', "");
    Expect(0, 66431, '\p{^_in_Old_Permic}', "");
    Expect(0, 66431, '\P{_in_Old_Permic}', "");
    Expect(1, 66431, '\P{^_in_Old_Permic}', "");
    Expect(0, 66432, '\p{_in_Old_Permic}', "");
    Expect(1, 66432, '\p{^_in_Old_Permic}', "");
    Expect(1, 66432, '\P{_in_Old_Permic}', "");
    Expect(0, 66432, '\P{^_in_Old_Permic}', "");
    Error('\p{-IN_Old_permic:=}');
    Error('\P{-IN_Old_permic:=}');
    Expect(1, 66431, '\p{-_In_Old_permic}', "");
    Expect(0, 66431, '\p{^-_In_Old_permic}', "");
    Expect(0, 66431, '\P{-_In_Old_permic}', "");
    Expect(1, 66431, '\P{^-_In_Old_permic}', "");
    Expect(0, 66432, '\p{-_In_Old_permic}', "");
    Expect(1, 66432, '\p{^-_In_Old_permic}', "");
    Expect(1, 66432, '\P{-_In_Old_permic}', "");
    Expect(0, 66432, '\P{^-_In_Old_permic}', "");
    Error('\p{:=	 IN_old_PERSIAN}');
    Error('\P{:=	 IN_old_PERSIAN}');
    Expect(1, 66527, '\p{inoldpersian}', "");
    Expect(0, 66527, '\p{^inoldpersian}', "");
    Expect(0, 66527, '\P{inoldpersian}', "");
    Expect(1, 66527, '\P{^inoldpersian}', "");
    Expect(0, 66528, '\p{inoldpersian}', "");
    Expect(1, 66528, '\p{^inoldpersian}', "");
    Expect(1, 66528, '\P{inoldpersian}', "");
    Expect(0, 66528, '\P{^inoldpersian}', "");
    Expect(1, 66527, '\p{- In_Old_Persian}', "");
    Expect(0, 66527, '\p{^- In_Old_Persian}', "");
    Expect(0, 66527, '\P{- In_Old_Persian}', "");
    Expect(1, 66527, '\P{^- In_Old_Persian}', "");
    Expect(0, 66528, '\p{- In_Old_Persian}', "");
    Expect(1, 66528, '\p{^- In_Old_Persian}', "");
    Expect(1, 66528, '\P{- In_Old_Persian}', "");
    Expect(0, 66528, '\P{^- In_Old_Persian}', "");
    Error('\p{_:=IN_Old_persian}');
    Error('\P{_:=IN_Old_persian}');
    Expect(1, 66527, '\p{_In_OLD_Persian}', "");
    Expect(0, 66527, '\p{^_In_OLD_Persian}', "");
    Expect(0, 66527, '\P{_In_OLD_Persian}', "");
    Expect(1, 66527, '\P{^_In_OLD_Persian}', "");
    Expect(0, 66528, '\p{_In_OLD_Persian}', "");
    Expect(1, 66528, '\p{^_In_OLD_Persian}', "");
    Expect(1, 66528, '\P{_In_OLD_Persian}', "");
    Expect(0, 66528, '\P{^_In_OLD_Persian}', "");
    Error('\p{ /a/in_old_sogdian}');
    Error('\P{ /a/in_old_sogdian}');
    Expect(1, 69423, '\p{inoldsogdian}', "");
    Expect(0, 69423, '\p{^inoldsogdian}', "");
    Expect(0, 69423, '\P{inoldsogdian}', "");
    Expect(1, 69423, '\P{^inoldsogdian}', "");
    Expect(0, 69424, '\p{inoldsogdian}', "");
    Expect(1, 69424, '\p{^inoldsogdian}', "");
    Expect(1, 69424, '\P{inoldsogdian}', "");
    Expect(0, 69424, '\P{^inoldsogdian}', "");
    Expect(1, 69423, '\p{- In_OLD_Sogdian}', "");
    Expect(0, 69423, '\p{^- In_OLD_Sogdian}', "");
    Expect(0, 69423, '\P{- In_OLD_Sogdian}', "");
    Expect(1, 69423, '\P{^- In_OLD_Sogdian}', "");
    Expect(0, 69424, '\p{- In_OLD_Sogdian}', "");
    Expect(1, 69424, '\p{^- In_OLD_Sogdian}', "");
    Expect(1, 69424, '\P{- In_OLD_Sogdian}', "");
    Expect(0, 69424, '\P{^- In_OLD_Sogdian}', "");
    Error('\p{_/a/In_OLD_Sogdian}');
    Error('\P{_/a/In_OLD_Sogdian}');
    Expect(1, 69423, '\p{In_OLD_sogdian}', "");
    Expect(0, 69423, '\p{^In_OLD_sogdian}', "");
    Expect(0, 69423, '\P{In_OLD_sogdian}', "");
    Expect(1, 69423, '\P{^In_OLD_sogdian}', "");
    Expect(0, 69424, '\p{In_OLD_sogdian}', "");
    Expect(1, 69424, '\p{^In_OLD_sogdian}', "");
    Expect(1, 69424, '\P{In_OLD_sogdian}', "");
    Expect(0, 69424, '\P{^In_OLD_sogdian}', "");
    Error('\p{	-IN_old_South_arabian:=}');
    Error('\P{	-IN_old_South_arabian:=}');
    Expect(1, 68223, '\p{inoldsoutharabian}', "");
    Expect(0, 68223, '\p{^inoldsoutharabian}', "");
    Expect(0, 68223, '\P{inoldsoutharabian}', "");
    Expect(1, 68223, '\P{^inoldsoutharabian}', "");
    Expect(0, 68224, '\p{inoldsoutharabian}', "");
    Expect(1, 68224, '\p{^inoldsoutharabian}', "");
    Expect(1, 68224, '\P{inoldsoutharabian}', "");
    Expect(0, 68224, '\P{^inoldsoutharabian}', "");
    Expect(1, 68223, '\p{	In_Old_SOUTH_Arabian}', "");
    Expect(0, 68223, '\p{^	In_Old_SOUTH_Arabian}', "");
    Expect(0, 68223, '\P{	In_Old_SOUTH_Arabian}', "");
    Expect(1, 68223, '\P{^	In_Old_SOUTH_Arabian}', "");
    Expect(0, 68224, '\p{	In_Old_SOUTH_Arabian}', "");
    Expect(1, 68224, '\p{^	In_Old_SOUTH_Arabian}', "");
    Expect(1, 68224, '\P{	In_Old_SOUTH_Arabian}', "");
    Expect(0, 68224, '\P{^	In_Old_SOUTH_Arabian}', "");
    Error('\p{_-In_Old_South_ARABIAN:=}');
    Error('\P{_-In_Old_South_ARABIAN:=}');
    Expect(1, 68223, '\p{		in_OLD_south_Arabian}', "");
    Expect(0, 68223, '\p{^		in_OLD_south_Arabian}', "");
    Expect(0, 68223, '\P{		in_OLD_south_Arabian}', "");
    Expect(1, 68223, '\P{^		in_OLD_south_Arabian}', "");
    Expect(0, 68224, '\p{		in_OLD_south_Arabian}', "");
    Expect(1, 68224, '\p{^		in_OLD_south_Arabian}', "");
    Expect(1, 68224, '\P{		in_OLD_south_Arabian}', "");
    Expect(0, 68224, '\P{^		in_OLD_south_Arabian}', "");
    Error('\p{:=	 In_old_Turkic}');
    Error('\P{:=	 In_old_Turkic}');
    Expect(1, 68687, '\p{inoldturkic}', "");
    Expect(0, 68687, '\p{^inoldturkic}', "");
    Expect(0, 68687, '\P{inoldturkic}', "");
    Expect(1, 68687, '\P{^inoldturkic}', "");
    Expect(0, 68688, '\p{inoldturkic}', "");
    Expect(1, 68688, '\p{^inoldturkic}', "");
    Expect(1, 68688, '\P{inoldturkic}', "");
    Expect(0, 68688, '\P{^inoldturkic}', "");
    Expect(1, 68687, '\p{-	IN_OLD_Turkic}', "");
    Expect(0, 68687, '\p{^-	IN_OLD_Turkic}', "");
    Expect(0, 68687, '\P{-	IN_OLD_Turkic}', "");
    Expect(1, 68687, '\P{^-	IN_OLD_Turkic}', "");
    Expect(0, 68688, '\p{-	IN_OLD_Turkic}', "");
    Expect(1, 68688, '\p{^-	IN_OLD_Turkic}', "");
    Expect(1, 68688, '\P{-	IN_OLD_Turkic}', "");
    Expect(0, 68688, '\P{^-	IN_OLD_Turkic}', "");
    Error('\p{_:=In_Old_turkic}');
    Error('\P{_:=In_Old_turkic}');
    Expect(1, 68687, '\p{ IN_Old_TURKIC}', "");
    Expect(0, 68687, '\p{^ IN_Old_TURKIC}', "");
    Expect(0, 68687, '\P{ IN_Old_TURKIC}', "");
    Expect(1, 68687, '\P{^ IN_Old_TURKIC}', "");
    Expect(0, 68688, '\p{ IN_Old_TURKIC}', "");
    Expect(1, 68688, '\p{^ IN_Old_TURKIC}', "");
    Expect(1, 68688, '\P{ IN_Old_TURKIC}', "");
    Expect(0, 68688, '\P{^ IN_Old_TURKIC}', "");
    Error('\p{	-In_ORIYA:=}');
    Error('\P{	-In_ORIYA:=}');
    Expect(1, 2943, '\p{inoriya}', "");
    Expect(0, 2943, '\p{^inoriya}', "");
    Expect(0, 2943, '\P{inoriya}', "");
    Expect(1, 2943, '\P{^inoriya}', "");
    Expect(0, 2944, '\p{inoriya}', "");
    Expect(1, 2944, '\p{^inoriya}', "");
    Expect(1, 2944, '\P{inoriya}', "");
    Expect(0, 2944, '\P{^inoriya}', "");
    Expect(1, 2943, '\p{		IN_Oriya}', "");
    Expect(0, 2943, '\p{^		IN_Oriya}', "");
    Expect(0, 2943, '\P{		IN_Oriya}', "");
    Expect(1, 2943, '\P{^		IN_Oriya}', "");
    Expect(0, 2944, '\p{		IN_Oriya}', "");
    Expect(1, 2944, '\p{^		IN_Oriya}', "");
    Expect(1, 2944, '\P{		IN_Oriya}', "");
    Expect(0, 2944, '\P{^		IN_Oriya}', "");
    Error('\p{-/a/IN_Oriya}');
    Error('\P{-/a/IN_Oriya}');
    Expect(1, 2943, '\p{ -in_ORIYA}', "");
    Expect(0, 2943, '\p{^ -in_ORIYA}', "");
    Expect(0, 2943, '\P{ -in_ORIYA}', "");
    Expect(1, 2943, '\P{^ -in_ORIYA}', "");
    Expect(0, 2944, '\p{ -in_ORIYA}', "");
    Expect(1, 2944, '\p{^ -in_ORIYA}', "");
    Expect(1, 2944, '\P{ -in_ORIYA}', "");
    Expect(0, 2944, '\P{^ -in_ORIYA}', "");
    Error('\p{:=_In_Osage}');
    Error('\P{:=_In_Osage}');
    Expect(1, 66815, '\p{inosage}', "");
    Expect(0, 66815, '\p{^inosage}', "");
    Expect(0, 66815, '\P{inosage}', "");
    Expect(1, 66815, '\P{^inosage}', "");
    Expect(0, 66816, '\p{inosage}', "");
    Expect(1, 66816, '\p{^inosage}', "");
    Expect(1, 66816, '\P{inosage}', "");
    Expect(0, 66816, '\P{^inosage}', "");
    Expect(1, 66815, '\p{_In_OSAGE}', "");
    Expect(0, 66815, '\p{^_In_OSAGE}', "");
    Expect(0, 66815, '\P{_In_OSAGE}', "");
    Expect(1, 66815, '\P{^_In_OSAGE}', "");
    Expect(0, 66816, '\p{_In_OSAGE}', "");
    Expect(1, 66816, '\p{^_In_OSAGE}', "");
    Expect(1, 66816, '\P{_In_OSAGE}', "");
    Expect(0, 66816, '\P{^_In_OSAGE}', "");
    Error('\p{-In_osage/a/}');
    Error('\P{-In_osage/a/}');
    Expect(1, 66815, '\p{-	In_Osage}', "");
    Expect(0, 66815, '\p{^-	In_Osage}', "");
    Expect(0, 66815, '\P{-	In_Osage}', "");
    Expect(1, 66815, '\P{^-	In_Osage}', "");
    Expect(0, 66816, '\p{-	In_Osage}', "");
    Expect(1, 66816, '\p{^-	In_Osage}', "");
    Expect(1, 66816, '\P{-	In_Osage}', "");
    Expect(0, 66816, '\P{^-	In_Osage}', "");
    Error('\p{	/a/In_OSMANYA}');
    Error('\P{	/a/In_OSMANYA}');
    Expect(1, 66735, '\p{inosmanya}', "");
    Expect(0, 66735, '\p{^inosmanya}', "");
    Expect(0, 66735, '\P{inosmanya}', "");
    Expect(1, 66735, '\P{^inosmanya}', "");
    Expect(0, 66736, '\p{inosmanya}', "");
    Expect(1, 66736, '\p{^inosmanya}', "");
    Expect(1, 66736, '\P{inosmanya}', "");
    Expect(0, 66736, '\P{^inosmanya}', "");
    Expect(1, 66735, '\p{ 	In_OSMANYA}', "");
    Expect(0, 66735, '\p{^ 	In_OSMANYA}', "");
    Expect(0, 66735, '\P{ 	In_OSMANYA}', "");
    Expect(1, 66735, '\P{^ 	In_OSMANYA}', "");
    Expect(0, 66736, '\p{ 	In_OSMANYA}', "");
    Expect(1, 66736, '\p{^ 	In_OSMANYA}', "");
    Expect(1, 66736, '\P{ 	In_OSMANYA}', "");
    Expect(0, 66736, '\P{^ 	In_OSMANYA}', "");
    Error('\p{:=in_Osmanya}');
    Error('\P{:=in_Osmanya}');
    Expect(1, 66735, '\p{	_IN_Osmanya}', "");
    Expect(0, 66735, '\p{^	_IN_Osmanya}', "");
    Expect(0, 66735, '\P{	_IN_Osmanya}', "");
    Expect(1, 66735, '\P{^	_IN_Osmanya}', "");
    Expect(0, 66736, '\p{	_IN_Osmanya}', "");
    Expect(1, 66736, '\p{^	_IN_Osmanya}', "");
    Expect(1, 66736, '\P{	_IN_Osmanya}', "");
    Expect(0, 66736, '\P{^	_IN_Osmanya}', "");
    Error('\p{_:=In_Pahawh_HMONG}');
    Error('\P{_:=In_Pahawh_HMONG}');
    Expect(1, 93071, '\p{inpahawhhmong}', "");
    Expect(0, 93071, '\p{^inpahawhhmong}', "");
    Expect(0, 93071, '\P{inpahawhhmong}', "");
    Expect(1, 93071, '\P{^inpahawhhmong}', "");
    Expect(0, 93072, '\p{inpahawhhmong}', "");
    Expect(1, 93072, '\p{^inpahawhhmong}', "");
    Expect(1, 93072, '\P{inpahawhhmong}', "");
    Expect(0, 93072, '\P{^inpahawhhmong}', "");
    Expect(1, 93071, '\p{-IN_pahawh_Hmong}', "");
    Expect(0, 93071, '\p{^-IN_pahawh_Hmong}', "");
    Expect(0, 93071, '\P{-IN_pahawh_Hmong}', "");
    Expect(1, 93071, '\P{^-IN_pahawh_Hmong}', "");
    Expect(0, 93072, '\p{-IN_pahawh_Hmong}', "");
    Expect(1, 93072, '\p{^-IN_pahawh_Hmong}', "");
    Expect(1, 93072, '\P{-IN_pahawh_Hmong}', "");
    Expect(0, 93072, '\P{^-IN_pahawh_Hmong}', "");
    Error('\p{__In_PAHAWH_Hmong:=}');
    Error('\P{__In_PAHAWH_Hmong:=}');
    Expect(1, 93071, '\p{- IN_PAHAWH_Hmong}', "");
    Expect(0, 93071, '\p{^- IN_PAHAWH_Hmong}', "");
    Expect(0, 93071, '\P{- IN_PAHAWH_Hmong}', "");
    Expect(1, 93071, '\P{^- IN_PAHAWH_Hmong}', "");
    Expect(0, 93072, '\p{- IN_PAHAWH_Hmong}', "");
    Expect(1, 93072, '\p{^- IN_PAHAWH_Hmong}', "");
    Expect(1, 93072, '\P{- IN_PAHAWH_Hmong}', "");
    Expect(0, 93072, '\P{^- IN_PAHAWH_Hmong}', "");
    Error('\p{-/a/IN_PALMYRENE}');
    Error('\P{-/a/IN_PALMYRENE}');
    Expect(1, 67711, '\p{inpalmyrene}', "");
    Expect(0, 67711, '\p{^inpalmyrene}', "");
    Expect(0, 67711, '\P{inpalmyrene}', "");
    Expect(1, 67711, '\P{^inpalmyrene}', "");
    Expect(0, 67712, '\p{inpalmyrene}', "");
    Expect(1, 67712, '\p{^inpalmyrene}', "");
    Expect(1, 67712, '\P{inpalmyrene}', "");
    Expect(0, 67712, '\P{^inpalmyrene}', "");
    Expect(1, 67711, '\p{	_IN_PALMYRENE}', "");
    Expect(0, 67711, '\p{^	_IN_PALMYRENE}', "");
    Expect(0, 67711, '\P{	_IN_PALMYRENE}', "");
    Expect(1, 67711, '\P{^	_IN_PALMYRENE}', "");
    Expect(0, 67712, '\p{	_IN_PALMYRENE}', "");
    Expect(1, 67712, '\p{^	_IN_PALMYRENE}', "");
    Expect(1, 67712, '\P{	_IN_PALMYRENE}', "");
    Expect(0, 67712, '\P{^	_IN_PALMYRENE}', "");
    Error('\p{/a/	_In_Palmyrene}');
    Error('\P{/a/	_In_Palmyrene}');
    Expect(1, 67711, '\p{	In_Palmyrene}', "");
    Expect(0, 67711, '\p{^	In_Palmyrene}', "");
    Expect(0, 67711, '\P{	In_Palmyrene}', "");
    Expect(1, 67711, '\P{^	In_Palmyrene}', "");
    Expect(0, 67712, '\p{	In_Palmyrene}', "");
    Expect(1, 67712, '\p{^	In_Palmyrene}', "");
    Expect(1, 67712, '\P{	In_Palmyrene}', "");
    Expect(0, 67712, '\P{^	In_Palmyrene}', "");
    Error('\p{:=	_In_Pau_Cin_hau}');
    Error('\P{:=	_In_Pau_Cin_hau}');
    Expect(1, 72447, '\p{inpaucinhau}', "");
    Expect(0, 72447, '\p{^inpaucinhau}', "");
    Expect(0, 72447, '\P{inpaucinhau}', "");
    Expect(1, 72447, '\P{^inpaucinhau}', "");
    Expect(0, 72448, '\p{inpaucinhau}', "");
    Expect(1, 72448, '\p{^inpaucinhau}', "");
    Expect(1, 72448, '\P{inpaucinhau}', "");
    Expect(0, 72448, '\P{^inpaucinhau}', "");
    Expect(1, 72447, '\p{-_in_PAU_CIN_hau}', "");
    Expect(0, 72447, '\p{^-_in_PAU_CIN_hau}', "");
    Expect(0, 72447, '\P{-_in_PAU_CIN_hau}', "");
    Expect(1, 72447, '\P{^-_in_PAU_CIN_hau}', "");
    Expect(0, 72448, '\p{-_in_PAU_CIN_hau}', "");
    Expect(1, 72448, '\p{^-_in_PAU_CIN_hau}', "");
    Expect(1, 72448, '\P{-_in_PAU_CIN_hau}', "");
    Expect(0, 72448, '\P{^-_in_PAU_CIN_hau}', "");
    Error('\p{/a/  In_PAU_Cin_HAU}');
    Error('\P{/a/  In_PAU_Cin_HAU}');
    Expect(1, 72447, '\p{-in_Pau_Cin_hau}', "");
    Expect(0, 72447, '\p{^-in_Pau_Cin_hau}', "");
    Expect(0, 72447, '\P{-in_Pau_Cin_hau}', "");
    Expect(1, 72447, '\P{^-in_Pau_Cin_hau}', "");
    Expect(0, 72448, '\p{-in_Pau_Cin_hau}', "");
    Expect(1, 72448, '\p{^-in_Pau_Cin_hau}', "");
    Expect(1, 72448, '\P{-in_Pau_Cin_hau}', "");
    Expect(0, 72448, '\P{^-in_Pau_Cin_hau}', "");
    Error('\p{:=	_IN_Phags_Pa}');
    Error('\P{:=	_IN_Phags_Pa}');
    Expect(1, 43135, '\p{inphagspa}', "");
    Expect(0, 43135, '\p{^inphagspa}', "");
    Expect(0, 43135, '\P{inphagspa}', "");
    Expect(1, 43135, '\P{^inphagspa}', "");
    Expect(0, 43136, '\p{inphagspa}', "");
    Expect(1, 43136, '\p{^inphagspa}', "");
    Expect(1, 43136, '\P{inphagspa}', "");
    Expect(0, 43136, '\P{^inphagspa}', "");
    Expect(1, 43135, '\p{		In_phags_Pa}', "");
    Expect(0, 43135, '\p{^		In_phags_Pa}', "");
    Expect(0, 43135, '\P{		In_phags_Pa}', "");
    Expect(1, 43135, '\P{^		In_phags_Pa}', "");
    Expect(0, 43136, '\p{		In_phags_Pa}', "");
    Expect(1, 43136, '\p{^		In_phags_Pa}', "");
    Expect(1, 43136, '\P{		In_phags_Pa}', "");
    Expect(0, 43136, '\P{^		In_phags_Pa}', "");
    Error('\p{ In_PHAGS_PA/a/}');
    Error('\P{ In_PHAGS_PA/a/}');
    Expect(1, 43135, '\p{	 in_Phags_Pa}', "");
    Expect(0, 43135, '\p{^	 in_Phags_Pa}', "");
    Expect(0, 43135, '\P{	 in_Phags_Pa}', "");
    Expect(1, 43135, '\P{^	 in_Phags_Pa}', "");
    Expect(0, 43136, '\p{	 in_Phags_Pa}', "");
    Expect(1, 43136, '\p{^	 in_Phags_Pa}', "");
    Expect(1, 43136, '\P{	 in_Phags_Pa}', "");
    Expect(0, 43136, '\P{^	 in_Phags_Pa}', "");
    Error('\p{/a/ IN_phoenician}');
    Error('\P{/a/ IN_phoenician}');
    Expect(1, 67871, '\p{inphoenician}', "");
    Expect(0, 67871, '\p{^inphoenician}', "");
    Expect(0, 67871, '\P{inphoenician}', "");
    Expect(1, 67871, '\P{^inphoenician}', "");
    Expect(0, 67872, '\p{inphoenician}', "");
    Expect(1, 67872, '\p{^inphoenician}', "");
    Expect(1, 67872, '\P{inphoenician}', "");
    Expect(0, 67872, '\P{^inphoenician}', "");
    Expect(1, 67871, '\p{		In_Phoenician}', "");
    Expect(0, 67871, '\p{^		In_Phoenician}', "");
    Expect(0, 67871, '\P{		In_Phoenician}', "");
    Expect(1, 67871, '\P{^		In_Phoenician}', "");
    Expect(0, 67872, '\p{		In_Phoenician}', "");
    Expect(1, 67872, '\p{^		In_Phoenician}', "");
    Expect(1, 67872, '\P{		In_Phoenician}', "");
    Expect(0, 67872, '\P{^		In_Phoenician}', "");
    Error('\p{_IN_Phoenician:=}');
    Error('\P{_IN_Phoenician:=}');
    Expect(1, 67871, '\p{	 In_Phoenician}', "");
    Expect(0, 67871, '\p{^	 In_Phoenician}', "");
    Expect(0, 67871, '\P{	 In_Phoenician}', "");
    Expect(1, 67871, '\P{^	 In_Phoenician}', "");
    Expect(0, 67872, '\p{	 In_Phoenician}', "");
    Expect(1, 67872, '\p{^	 In_Phoenician}', "");
    Expect(1, 67872, '\P{	 In_Phoenician}', "");
    Expect(0, 67872, '\P{^	 In_Phoenician}', "");
    Error('\p{--IN_PSALTER_pahlavi/a/}');
    Error('\P{--IN_PSALTER_pahlavi/a/}');
    Expect(1, 68527, '\p{inpsalterpahlavi}', "");
    Expect(0, 68527, '\p{^inpsalterpahlavi}', "");
    Expect(0, 68527, '\P{inpsalterpahlavi}', "");
    Expect(1, 68527, '\P{^inpsalterpahlavi}', "");
    Expect(0, 68528, '\p{inpsalterpahlavi}', "");
    Expect(1, 68528, '\p{^inpsalterpahlavi}', "");
    Expect(1, 68528, '\P{inpsalterpahlavi}', "");
    Expect(0, 68528, '\P{^inpsalterpahlavi}', "");
    Expect(1, 68527, '\p{-	in_Psalter_Pahlavi}', "");
    Expect(0, 68527, '\p{^-	in_Psalter_Pahlavi}', "");
    Expect(0, 68527, '\P{-	in_Psalter_Pahlavi}', "");
    Expect(1, 68527, '\P{^-	in_Psalter_Pahlavi}', "");
    Expect(0, 68528, '\p{-	in_Psalter_Pahlavi}', "");
    Expect(1, 68528, '\p{^-	in_Psalter_Pahlavi}', "");
    Expect(1, 68528, '\P{-	in_Psalter_Pahlavi}', "");
    Expect(0, 68528, '\P{^-	in_Psalter_Pahlavi}', "");
    Error('\p{	/a/IN_psalter_PAHLAVI}');
    Error('\P{	/a/IN_psalter_PAHLAVI}');
    Expect(1, 68527, '\p{- in_Psalter_PAHLAVI}', "");
    Expect(0, 68527, '\p{^- in_Psalter_PAHLAVI}', "");
    Expect(0, 68527, '\P{- in_Psalter_PAHLAVI}', "");
    Expect(1, 68527, '\P{^- in_Psalter_PAHLAVI}', "");
    Expect(0, 68528, '\p{- in_Psalter_PAHLAVI}', "");
    Expect(1, 68528, '\p{^- in_Psalter_PAHLAVI}', "");
    Expect(1, 68528, '\P{- in_Psalter_PAHLAVI}', "");
    Expect(0, 68528, '\P{^- in_Psalter_PAHLAVI}', "");
    Error('\p{_/a/In_rejang}');
    Error('\P{_/a/In_rejang}');
    Expect(1, 43359, '\p{inrejang}', "");
    Expect(0, 43359, '\p{^inrejang}', "");
    Expect(0, 43359, '\P{inrejang}', "");
    Expect(1, 43359, '\P{^inrejang}', "");
    Expect(0, 43360, '\p{inrejang}', "");
    Expect(1, 43360, '\p{^inrejang}', "");
    Expect(1, 43360, '\P{inrejang}', "");
    Expect(0, 43360, '\P{^inrejang}', "");
    Expect(1, 43359, '\p{_-In_Rejang}', "");
    Expect(0, 43359, '\p{^_-In_Rejang}', "");
    Expect(0, 43359, '\P{_-In_Rejang}', "");
    Expect(1, 43359, '\P{^_-In_Rejang}', "");
    Expect(0, 43360, '\p{_-In_Rejang}', "");
    Expect(1, 43360, '\p{^_-In_Rejang}', "");
    Expect(1, 43360, '\P{_-In_Rejang}', "");
    Expect(0, 43360, '\P{^_-In_Rejang}', "");
    Error('\p{/a/__In_Rejang}');
    Error('\P{/a/__In_Rejang}');
    Expect(1, 43359, '\p{	_in_REJANG}', "");
    Expect(0, 43359, '\p{^	_in_REJANG}', "");
    Expect(0, 43359, '\P{	_in_REJANG}', "");
    Expect(1, 43359, '\P{^	_in_REJANG}', "");
    Expect(0, 43360, '\p{	_in_REJANG}', "");
    Expect(1, 43360, '\p{^	_in_REJANG}', "");
    Expect(1, 43360, '\P{	_in_REJANG}', "");
    Expect(0, 43360, '\P{^	_in_REJANG}', "");
    Error('\p{:=	In_runic}');
    Error('\P{:=	In_runic}');
    Expect(1, 5887, '\p{inrunic}', "");
    Expect(0, 5887, '\p{^inrunic}', "");
    Expect(0, 5887, '\P{inrunic}', "");
    Expect(1, 5887, '\P{^inrunic}', "");
    Expect(0, 5888, '\p{inrunic}', "");
    Expect(1, 5888, '\p{^inrunic}', "");
    Expect(1, 5888, '\P{inrunic}', "");
    Expect(0, 5888, '\P{^inrunic}', "");
    Expect(1, 5887, '\p{ In_Runic}', "");
    Expect(0, 5887, '\p{^ In_Runic}', "");
    Expect(0, 5887, '\P{ In_Runic}', "");
    Expect(1, 5887, '\P{^ In_Runic}', "");
    Expect(0, 5888, '\p{ In_Runic}', "");
    Expect(1, 5888, '\p{^ In_Runic}', "");
    Expect(1, 5888, '\P{ In_Runic}', "");
    Expect(0, 5888, '\P{^ In_Runic}', "");
    Error('\p{__In_RUNIC/a/}');
    Error('\P{__In_RUNIC/a/}');
    Expect(1, 5887, '\p{	In_Runic}', "");
    Expect(0, 5887, '\p{^	In_Runic}', "");
    Expect(0, 5887, '\P{	In_Runic}', "");
    Expect(1, 5887, '\P{^	In_Runic}', "");
    Expect(0, 5888, '\p{	In_Runic}', "");
    Expect(1, 5888, '\p{^	In_Runic}', "");
    Expect(1, 5888, '\P{	In_Runic}', "");
    Expect(0, 5888, '\P{^	In_Runic}', "");
    Error('\p{	:=In_Samaritan}');
    Error('\P{	:=In_Samaritan}');
    Expect(1, 2111, '\p{insamaritan}', "");
    Expect(0, 2111, '\p{^insamaritan}', "");
    Expect(0, 2111, '\P{insamaritan}', "");
    Expect(1, 2111, '\P{^insamaritan}', "");
    Expect(0, 2112, '\p{insamaritan}', "");
    Expect(1, 2112, '\p{^insamaritan}', "");
    Expect(1, 2112, '\P{insamaritan}', "");
    Expect(0, 2112, '\P{^insamaritan}', "");
    Expect(1, 2111, '\p{_In_Samaritan}', "");
    Expect(0, 2111, '\p{^_In_Samaritan}', "");
    Expect(0, 2111, '\P{_In_Samaritan}', "");
    Expect(1, 2111, '\P{^_In_Samaritan}', "");
    Expect(0, 2112, '\p{_In_Samaritan}', "");
    Expect(1, 2112, '\p{^_In_Samaritan}', "");
    Expect(1, 2112, '\P{_In_Samaritan}', "");
    Expect(0, 2112, '\P{^_In_Samaritan}', "");
    Error('\p{ :=in_SAMARITAN}');
    Error('\P{ :=in_SAMARITAN}');
    Expect(1, 2111, '\p{-In_Samaritan}', "");
    Expect(0, 2111, '\p{^-In_Samaritan}', "");
    Expect(0, 2111, '\P{-In_Samaritan}', "");
    Expect(1, 2111, '\P{^-In_Samaritan}', "");
    Expect(0, 2112, '\p{-In_Samaritan}', "");
    Expect(1, 2112, '\p{^-In_Samaritan}', "");
    Expect(1, 2112, '\P{-In_Samaritan}', "");
    Expect(0, 2112, '\P{^-In_Samaritan}', "");
    Error('\p{_IN_saurashtra/a/}');
    Error('\P{_IN_saurashtra/a/}');
    Expect(1, 43231, '\p{insaurashtra}', "");
    Expect(0, 43231, '\p{^insaurashtra}', "");
    Expect(0, 43231, '\P{insaurashtra}', "");
    Expect(1, 43231, '\P{^insaurashtra}', "");
    Expect(0, 43232, '\p{insaurashtra}', "");
    Expect(1, 43232, '\p{^insaurashtra}', "");
    Expect(1, 43232, '\P{insaurashtra}', "");
    Expect(0, 43232, '\P{^insaurashtra}', "");
    Expect(1, 43231, '\p{in_Saurashtra}', "");
    Expect(0, 43231, '\p{^in_Saurashtra}', "");
    Expect(0, 43231, '\P{in_Saurashtra}', "");
    Expect(1, 43231, '\P{^in_Saurashtra}', "");
    Expect(0, 43232, '\p{in_Saurashtra}', "");
    Expect(1, 43232, '\p{^in_Saurashtra}', "");
    Expect(1, 43232, '\P{in_Saurashtra}', "");
    Expect(0, 43232, '\P{^in_Saurashtra}', "");
    Error('\p{		IN_saurashtra:=}');
    Error('\P{		IN_saurashtra:=}');
    Expect(1, 43231, '\p{_	In_Saurashtra}', "");
    Expect(0, 43231, '\p{^_	In_Saurashtra}', "");
    Expect(0, 43231, '\P{_	In_Saurashtra}', "");
    Expect(1, 43231, '\P{^_	In_Saurashtra}', "");
    Expect(0, 43232, '\p{_	In_Saurashtra}', "");
    Expect(1, 43232, '\p{^_	In_Saurashtra}', "");
    Expect(1, 43232, '\P{_	In_Saurashtra}', "");
    Expect(0, 43232, '\P{^_	In_Saurashtra}', "");
    Error('\p{/a/	 In_SHARADA}');
    Error('\P{/a/	 In_SHARADA}');
    Expect(1, 70111, '\p{insharada}', "");
    Expect(0, 70111, '\p{^insharada}', "");
    Expect(0, 70111, '\P{insharada}', "");
    Expect(1, 70111, '\P{^insharada}', "");
    Expect(0, 70112, '\p{insharada}', "");
    Expect(1, 70112, '\p{^insharada}', "");
    Expect(1, 70112, '\P{insharada}', "");
    Expect(0, 70112, '\P{^insharada}', "");
    Expect(1, 70111, '\p{__in_Sharada}', "");
    Expect(0, 70111, '\p{^__in_Sharada}', "");
    Expect(0, 70111, '\P{__in_Sharada}', "");
    Expect(1, 70111, '\P{^__in_Sharada}', "");
    Expect(0, 70112, '\p{__in_Sharada}', "");
    Expect(1, 70112, '\p{^__in_Sharada}', "");
    Expect(1, 70112, '\P{__in_Sharada}', "");
    Expect(0, 70112, '\P{^__in_Sharada}', "");
    Error('\p{	:=In_Sharada}');
    Error('\P{	:=In_Sharada}');
    Expect(1, 70111, '\p{ In_SHARADA}', "");
    Expect(0, 70111, '\p{^ In_SHARADA}', "");
    Expect(0, 70111, '\P{ In_SHARADA}', "");
    Expect(1, 70111, '\P{^ In_SHARADA}', "");
    Expect(0, 70112, '\p{ In_SHARADA}', "");
    Expect(1, 70112, '\p{^ In_SHARADA}', "");
    Expect(1, 70112, '\P{ In_SHARADA}', "");
    Expect(0, 70112, '\P{^ In_SHARADA}', "");
    Error('\p{_/a/in_Shavian}');
    Error('\P{_/a/in_Shavian}');
    Expect(1, 66687, '\p{inshavian}', "");
    Expect(0, 66687, '\p{^inshavian}', "");
    Expect(0, 66687, '\P{inshavian}', "");
    Expect(1, 66687, '\P{^inshavian}', "");
    Expect(0, 66688, '\p{inshavian}', "");
    Expect(1, 66688, '\p{^inshavian}', "");
    Expect(1, 66688, '\P{inshavian}', "");
    Expect(0, 66688, '\P{^inshavian}', "");
    Expect(1, 66687, '\p{	In_Shavian}', "");
    Expect(0, 66687, '\p{^	In_Shavian}', "");
    Expect(0, 66687, '\P{	In_Shavian}', "");
    Expect(1, 66687, '\P{^	In_Shavian}', "");
    Expect(0, 66688, '\p{	In_Shavian}', "");
    Expect(1, 66688, '\p{^	In_Shavian}', "");
    Expect(1, 66688, '\P{	In_Shavian}', "");
    Expect(0, 66688, '\P{^	In_Shavian}', "");
    Error('\p{	_IN_Shavian:=}');
    Error('\P{	_IN_Shavian:=}');
    Expect(1, 66687, '\p{_In_shavian}', "");
    Expect(0, 66687, '\p{^_In_shavian}', "");
    Expect(0, 66687, '\P{_In_shavian}', "");
    Expect(1, 66687, '\P{^_In_shavian}', "");
    Expect(0, 66688, '\p{_In_shavian}', "");
    Expect(1, 66688, '\p{^_In_shavian}', "");
    Expect(1, 66688, '\P{_In_shavian}', "");
    Expect(0, 66688, '\P{^_In_shavian}', "");
    Error('\p{_:=IN_Siddham}');
    Error('\P{_:=IN_Siddham}');
    Expect(1, 71167, '\p{insiddham}', "");
    Expect(0, 71167, '\p{^insiddham}', "");
    Expect(0, 71167, '\P{insiddham}', "");
    Expect(1, 71167, '\P{^insiddham}', "");
    Expect(0, 71168, '\p{insiddham}', "");
    Expect(1, 71168, '\p{^insiddham}', "");
    Expect(1, 71168, '\P{insiddham}', "");
    Expect(0, 71168, '\P{^insiddham}', "");
    Expect(1, 71167, '\p{--In_Siddham}', "");
    Expect(0, 71167, '\p{^--In_Siddham}', "");
    Expect(0, 71167, '\P{--In_Siddham}', "");
    Expect(1, 71167, '\P{^--In_Siddham}', "");
    Expect(0, 71168, '\p{--In_Siddham}', "");
    Expect(1, 71168, '\p{^--In_Siddham}', "");
    Expect(1, 71168, '\P{--In_Siddham}', "");
    Expect(0, 71168, '\P{^--In_Siddham}', "");
    Error('\p{ -In_siddham/a/}');
    Error('\P{ -In_siddham/a/}');
    Expect(1, 71167, '\p{_In_Siddham}', "");
    Expect(0, 71167, '\p{^_In_Siddham}', "");
    Expect(0, 71167, '\P{_In_Siddham}', "");
    Expect(1, 71167, '\P{^_In_Siddham}', "");
    Expect(0, 71168, '\p{_In_Siddham}', "");
    Expect(1, 71168, '\p{^_In_Siddham}', "");
    Expect(1, 71168, '\P{_In_Siddham}', "");
    Expect(0, 71168, '\P{^_In_Siddham}', "");
    Error('\p{/a/  In_Sinhala}');
    Error('\P{/a/  In_Sinhala}');
    Expect(1, 3583, '\p{insinhala}', "");
    Expect(0, 3583, '\p{^insinhala}', "");
    Expect(0, 3583, '\P{insinhala}', "");
    Expect(1, 3583, '\P{^insinhala}', "");
    Expect(0, 3584, '\p{insinhala}', "");
    Expect(1, 3584, '\p{^insinhala}', "");
    Expect(1, 3584, '\P{insinhala}', "");
    Expect(0, 3584, '\P{^insinhala}', "");
    Expect(1, 3583, '\p{  In_Sinhala}', "");
    Expect(0, 3583, '\p{^  In_Sinhala}', "");
    Expect(0, 3583, '\P{  In_Sinhala}', "");
    Expect(1, 3583, '\P{^  In_Sinhala}', "");
    Expect(0, 3584, '\p{  In_Sinhala}', "");
    Expect(1, 3584, '\p{^  In_Sinhala}', "");
    Expect(1, 3584, '\P{  In_Sinhala}', "");
    Expect(0, 3584, '\P{^  In_Sinhala}', "");
    Error('\p{	:=in_sinhala}');
    Error('\P{	:=in_sinhala}');
    Expect(1, 3583, '\p{ _In_SINHALA}', "");
    Expect(0, 3583, '\p{^ _In_SINHALA}', "");
    Expect(0, 3583, '\P{ _In_SINHALA}', "");
    Expect(1, 3583, '\P{^ _In_SINHALA}', "");
    Expect(0, 3584, '\p{ _In_SINHALA}', "");
    Expect(1, 3584, '\p{^ _In_SINHALA}', "");
    Expect(1, 3584, '\P{ _In_SINHALA}', "");
    Expect(0, 3584, '\P{^ _In_SINHALA}', "");
    Error('\p{ 	In_SOGDIAN:=}');
    Error('\P{ 	In_SOGDIAN:=}');
    Expect(1, 69487, '\p{insogdian}', "");
    Expect(0, 69487, '\p{^insogdian}', "");
    Expect(0, 69487, '\P{insogdian}', "");
    Expect(1, 69487, '\P{^insogdian}', "");
    Expect(0, 69488, '\p{insogdian}', "");
    Expect(1, 69488, '\p{^insogdian}', "");
    Expect(1, 69488, '\P{insogdian}', "");
    Expect(0, 69488, '\P{^insogdian}', "");
    Expect(1, 69487, '\p{	IN_SOGDIAN}', "");
    Expect(0, 69487, '\p{^	IN_SOGDIAN}', "");
    Expect(0, 69487, '\P{	IN_SOGDIAN}', "");
    Expect(1, 69487, '\P{^	IN_SOGDIAN}', "");
    Expect(0, 69488, '\p{	IN_SOGDIAN}', "");
    Expect(1, 69488, '\p{^	IN_SOGDIAN}', "");
    Expect(1, 69488, '\P{	IN_SOGDIAN}', "");
    Expect(0, 69488, '\P{^	IN_SOGDIAN}', "");
    Error('\p{:=		In_SOGDIAN}');
    Error('\P{:=		In_SOGDIAN}');
    Expect(1, 69487, '\p{- IN_Sogdian}', "");
    Expect(0, 69487, '\p{^- IN_Sogdian}', "");
    Expect(0, 69487, '\P{- IN_Sogdian}', "");
    Expect(1, 69487, '\P{^- IN_Sogdian}', "");
    Expect(0, 69488, '\p{- IN_Sogdian}', "");
    Expect(1, 69488, '\p{^- IN_Sogdian}', "");
    Expect(1, 69488, '\P{- IN_Sogdian}', "");
    Expect(0, 69488, '\P{^- IN_Sogdian}', "");
    Error('\p{_:=IN_Sora_Sompeng}');
    Error('\P{_:=IN_Sora_Sompeng}');
    Expect(1, 69887, '\p{insorasompeng}', "");
    Expect(0, 69887, '\p{^insorasompeng}', "");
    Expect(0, 69887, '\P{insorasompeng}', "");
    Expect(1, 69887, '\P{^insorasompeng}', "");
    Expect(0, 69888, '\p{insorasompeng}', "");
    Expect(1, 69888, '\p{^insorasompeng}', "");
    Expect(1, 69888, '\P{insorasompeng}', "");
    Expect(0, 69888, '\P{^insorasompeng}', "");
    Expect(1, 69887, '\p{_	In_Sora_sompeng}', "");
    Expect(0, 69887, '\p{^_	In_Sora_sompeng}', "");
    Expect(0, 69887, '\P{_	In_Sora_sompeng}', "");
    Expect(1, 69887, '\P{^_	In_Sora_sompeng}', "");
    Expect(0, 69888, '\p{_	In_Sora_sompeng}', "");
    Expect(1, 69888, '\p{^_	In_Sora_sompeng}', "");
    Expect(1, 69888, '\P{_	In_Sora_sompeng}', "");
    Expect(0, 69888, '\P{^_	In_Sora_sompeng}', "");
    Error('\p{/a/-In_Sora_SOMPENG}');
    Error('\P{/a/-In_Sora_SOMPENG}');
    Expect(1, 69887, '\p{_ IN_Sora_Sompeng}', "");
    Expect(0, 69887, '\p{^_ IN_Sora_Sompeng}', "");
    Expect(0, 69887, '\P{_ IN_Sora_Sompeng}', "");
    Expect(1, 69887, '\P{^_ IN_Sora_Sompeng}', "");
    Expect(0, 69888, '\p{_ IN_Sora_Sompeng}', "");
    Expect(1, 69888, '\p{^_ IN_Sora_Sompeng}', "");
    Expect(1, 69888, '\P{_ IN_Sora_Sompeng}', "");
    Expect(0, 69888, '\P{^_ IN_Sora_Sompeng}', "");
    Error('\p{ -IN_Soyombo/a/}');
    Error('\P{ -IN_Soyombo/a/}');
    Expect(1, 72367, '\p{insoyombo}', "");
    Expect(0, 72367, '\p{^insoyombo}', "");
    Expect(0, 72367, '\P{insoyombo}', "");
    Expect(1, 72367, '\P{^insoyombo}', "");
    Expect(0, 72368, '\p{insoyombo}', "");
    Expect(1, 72368, '\p{^insoyombo}', "");
    Expect(1, 72368, '\P{insoyombo}', "");
    Expect(0, 72368, '\P{^insoyombo}', "");
    Expect(1, 72367, '\p{_IN_Soyombo}', "");
    Expect(0, 72367, '\p{^_IN_Soyombo}', "");
    Expect(0, 72367, '\P{_IN_Soyombo}', "");
    Expect(1, 72367, '\P{^_IN_Soyombo}', "");
    Expect(0, 72368, '\p{_IN_Soyombo}', "");
    Expect(1, 72368, '\p{^_IN_Soyombo}', "");
    Expect(1, 72368, '\P{_IN_Soyombo}', "");
    Expect(0, 72368, '\P{^_IN_Soyombo}', "");
    Error('\p{In_Soyombo:=}');
    Error('\P{In_Soyombo:=}');
    Expect(1, 72367, '\p{	in_Soyombo}', "");
    Expect(0, 72367, '\p{^	in_Soyombo}', "");
    Expect(0, 72367, '\P{	in_Soyombo}', "");
    Expect(1, 72367, '\P{^	in_Soyombo}', "");
    Expect(0, 72368, '\p{	in_Soyombo}', "");
    Expect(1, 72368, '\p{^	in_Soyombo}', "");
    Expect(1, 72368, '\P{	in_Soyombo}', "");
    Expect(0, 72368, '\P{^	in_Soyombo}', "");
    Error('\p{	In_sundanese/a/}');
    Error('\P{	In_sundanese/a/}');
    Expect(1, 7103, '\p{insundanese}', "");
    Expect(0, 7103, '\p{^insundanese}', "");
    Expect(0, 7103, '\P{insundanese}', "");
    Expect(1, 7103, '\P{^insundanese}', "");
    Expect(0, 7104, '\p{insundanese}', "");
    Expect(1, 7104, '\p{^insundanese}', "");
    Expect(1, 7104, '\P{insundanese}', "");
    Expect(0, 7104, '\P{^insundanese}', "");
    Expect(1, 7103, '\p{_In_Sundanese}', "");
    Expect(0, 7103, '\p{^_In_Sundanese}', "");
    Expect(0, 7103, '\P{_In_Sundanese}', "");
    Expect(1, 7103, '\P{^_In_Sundanese}', "");
    Expect(0, 7104, '\p{_In_Sundanese}', "");
    Expect(1, 7104, '\p{^_In_Sundanese}', "");
    Expect(1, 7104, '\P{_In_Sundanese}', "");
    Expect(0, 7104, '\P{^_In_Sundanese}', "");
    Error('\p{	:=IN_SUNDANESE}');
    Error('\P{	:=IN_SUNDANESE}');
    Expect(1, 7103, '\p{-_In_SUNDANESE}', "");
    Expect(0, 7103, '\p{^-_In_SUNDANESE}', "");
    Expect(0, 7103, '\P{-_In_SUNDANESE}', "");
    Expect(1, 7103, '\P{^-_In_SUNDANESE}', "");
    Expect(0, 7104, '\p{-_In_SUNDANESE}', "");
    Expect(1, 7104, '\p{^-_In_SUNDANESE}', "");
    Expect(1, 7104, '\P{-_In_SUNDANESE}', "");
    Expect(0, 7104, '\P{^-_In_SUNDANESE}', "");
    Error('\p{:=__In_Syloti_nagri}');
    Error('\P{:=__In_Syloti_nagri}');
    Expect(1, 43055, '\p{insylotinagri}', "");
    Expect(0, 43055, '\p{^insylotinagri}', "");
    Expect(0, 43055, '\P{insylotinagri}', "");
    Expect(1, 43055, '\P{^insylotinagri}', "");
    Expect(0, 43056, '\p{insylotinagri}', "");
    Expect(1, 43056, '\p{^insylotinagri}', "");
    Expect(1, 43056, '\P{insylotinagri}', "");
    Expect(0, 43056, '\P{^insylotinagri}', "");
    Expect(1, 43055, '\p{	 IN_syloti_Nagri}', "");
    Expect(0, 43055, '\p{^	 IN_syloti_Nagri}', "");
    Expect(0, 43055, '\P{	 IN_syloti_Nagri}', "");
    Expect(1, 43055, '\P{^	 IN_syloti_Nagri}', "");
    Expect(0, 43056, '\p{	 IN_syloti_Nagri}', "");
    Expect(1, 43056, '\p{^	 IN_syloti_Nagri}', "");
    Expect(1, 43056, '\P{	 IN_syloti_Nagri}', "");
    Expect(0, 43056, '\P{^	 IN_syloti_Nagri}', "");
    Error('\p{ In_Syloti_nagri:=}');
    Error('\P{ In_Syloti_nagri:=}');
    Expect(1, 43055, '\p{__In_syloti_Nagri}', "");
    Expect(0, 43055, '\p{^__In_syloti_Nagri}', "");
    Expect(0, 43055, '\P{__In_syloti_Nagri}', "");
    Expect(1, 43055, '\P{^__In_syloti_Nagri}', "");
    Expect(0, 43056, '\p{__In_syloti_Nagri}', "");
    Expect(1, 43056, '\p{^__In_syloti_Nagri}', "");
    Expect(1, 43056, '\P{__In_syloti_Nagri}', "");
    Expect(0, 43056, '\P{^__In_syloti_Nagri}', "");
    Error('\p{_/a/IN_Syriac}');
    Error('\P{_/a/IN_Syriac}');
    Expect(1, 1871, '\p{insyriac}', "");
    Expect(0, 1871, '\p{^insyriac}', "");
    Expect(0, 1871, '\P{insyriac}', "");
    Expect(1, 1871, '\P{^insyriac}', "");
    Expect(0, 1872, '\p{insyriac}', "");
    Expect(1, 1872, '\p{^insyriac}', "");
    Expect(1, 1872, '\P{insyriac}', "");
    Expect(0, 1872, '\P{^insyriac}', "");
    Expect(1, 1871, '\p{ IN_Syriac}', "");
    Expect(0, 1871, '\p{^ IN_Syriac}', "");
    Expect(0, 1871, '\P{ IN_Syriac}', "");
    Expect(1, 1871, '\P{^ IN_Syriac}', "");
    Expect(0, 1872, '\p{ IN_Syriac}', "");
    Expect(1, 1872, '\p{^ IN_Syriac}', "");
    Expect(1, 1872, '\P{ IN_Syriac}', "");
    Expect(0, 1872, '\P{^ IN_Syriac}', "");
    Error('\p{	-in_SYRIAC/a/}');
    Error('\P{	-in_SYRIAC/a/}');
    Expect(1, 1871, '\p{	_In_syriac}', "");
    Expect(0, 1871, '\p{^	_In_syriac}', "");
    Expect(0, 1871, '\P{	_In_syriac}', "");
    Expect(1, 1871, '\P{^	_In_syriac}', "");
    Expect(0, 1872, '\p{	_In_syriac}', "");
    Expect(1, 1872, '\p{^	_In_syriac}', "");
    Expect(1, 1872, '\P{	_In_syriac}', "");
    Expect(0, 1872, '\P{^	_In_syriac}', "");
    Error('\p{:=	 IN_Tagalog}');
    Error('\P{:=	 IN_Tagalog}');
    Expect(1, 5919, '\p{intagalog}', "");
    Expect(0, 5919, '\p{^intagalog}', "");
    Expect(0, 5919, '\P{intagalog}', "");
    Expect(1, 5919, '\P{^intagalog}', "");
    Expect(0, 5920, '\p{intagalog}', "");
    Expect(1, 5920, '\p{^intagalog}', "");
    Expect(1, 5920, '\P{intagalog}', "");
    Expect(0, 5920, '\P{^intagalog}', "");
    Expect(1, 5919, '\p{In_Tagalog}', "");
    Expect(0, 5919, '\p{^In_Tagalog}', "");
    Expect(0, 5919, '\P{In_Tagalog}', "");
    Expect(1, 5919, '\P{^In_Tagalog}', "");
    Expect(0, 5920, '\p{In_Tagalog}', "");
    Expect(1, 5920, '\p{^In_Tagalog}', "");
    Expect(1, 5920, '\P{In_Tagalog}', "");
    Expect(0, 5920, '\P{^In_Tagalog}', "");
    Error('\p{_:=In_Tagalog}');
    Error('\P{_:=In_Tagalog}');
    Expect(1, 5919, '\p{_ In_Tagalog}', "");
    Expect(0, 5919, '\p{^_ In_Tagalog}', "");
    Expect(0, 5919, '\P{_ In_Tagalog}', "");
    Expect(1, 5919, '\P{^_ In_Tagalog}', "");
    Expect(0, 5920, '\p{_ In_Tagalog}', "");
    Expect(1, 5920, '\p{^_ In_Tagalog}', "");
    Expect(1, 5920, '\P{_ In_Tagalog}', "");
    Expect(0, 5920, '\P{^_ In_Tagalog}', "");
    Error('\p{:=_-In_Tagbanwa}');
    Error('\P{:=_-In_Tagbanwa}');
    Expect(1, 6015, '\p{intagbanwa}', "");
    Expect(0, 6015, '\p{^intagbanwa}', "");
    Expect(0, 6015, '\P{intagbanwa}', "");
    Expect(1, 6015, '\P{^intagbanwa}', "");
    Expect(0, 6016, '\p{intagbanwa}', "");
    Expect(1, 6016, '\p{^intagbanwa}', "");
    Expect(1, 6016, '\P{intagbanwa}', "");
    Expect(0, 6016, '\P{^intagbanwa}', "");
    Expect(1, 6015, '\p{	IN_Tagbanwa}', "");
    Expect(0, 6015, '\p{^	IN_Tagbanwa}', "");
    Expect(0, 6015, '\P{	IN_Tagbanwa}', "");
    Expect(1, 6015, '\P{^	IN_Tagbanwa}', "");
    Expect(0, 6016, '\p{	IN_Tagbanwa}', "");
    Expect(1, 6016, '\p{^	IN_Tagbanwa}', "");
    Expect(1, 6016, '\P{	IN_Tagbanwa}', "");
    Expect(0, 6016, '\P{^	IN_Tagbanwa}', "");
    Error('\p{:=In_Tagbanwa}');
    Error('\P{:=In_Tagbanwa}');
    Expect(1, 6015, '\p{- In_Tagbanwa}', "");
    Expect(0, 6015, '\p{^- In_Tagbanwa}', "");
    Expect(0, 6015, '\P{- In_Tagbanwa}', "");
    Expect(1, 6015, '\P{^- In_Tagbanwa}', "");
    Expect(0, 6016, '\p{- In_Tagbanwa}', "");
    Expect(1, 6016, '\p{^- In_Tagbanwa}', "");
    Expect(1, 6016, '\P{- In_Tagbanwa}', "");
    Expect(0, 6016, '\P{^- In_Tagbanwa}', "");
    Error('\p{:=_in_TAI_Le}');
    Error('\P{:=_in_TAI_Le}');
    Expect(1, 6527, '\p{intaile}', "");
    Expect(0, 6527, '\p{^intaile}', "");
    Expect(0, 6527, '\P{intaile}', "");
    Expect(1, 6527, '\P{^intaile}', "");
    Expect(0, 6528, '\p{intaile}', "");
    Expect(1, 6528, '\p{^intaile}', "");
    Expect(1, 6528, '\P{intaile}', "");
    Expect(0, 6528, '\P{^intaile}', "");
    Expect(1, 6527, '\p{_In_tai_Le}', "");
    Expect(0, 6527, '\p{^_In_tai_Le}', "");
    Expect(0, 6527, '\P{_In_tai_Le}', "");
    Expect(1, 6527, '\P{^_In_tai_Le}', "");
    Expect(0, 6528, '\p{_In_tai_Le}', "");
    Expect(1, 6528, '\p{^_In_tai_Le}', "");
    Expect(1, 6528, '\P{_In_tai_Le}', "");
    Expect(0, 6528, '\P{^_In_tai_Le}', "");
    Error('\p{_In_tai_Le:=}');
    Error('\P{_In_tai_Le:=}');
    Expect(1, 6527, '\p{In_TAI_Le}', "");
    Expect(0, 6527, '\p{^In_TAI_Le}', "");
    Expect(0, 6527, '\P{In_TAI_Le}', "");
    Expect(1, 6527, '\P{^In_TAI_Le}', "");
    Expect(0, 6528, '\p{In_TAI_Le}', "");
    Expect(1, 6528, '\p{^In_TAI_Le}', "");
    Expect(1, 6528, '\P{In_TAI_Le}', "");
    Expect(0, 6528, '\P{^In_TAI_Le}', "");
    Error('\p{/a/_in_Tai_tham}');
    Error('\P{/a/_in_Tai_tham}');
    Expect(1, 6831, '\p{intaitham}', "");
    Expect(0, 6831, '\p{^intaitham}', "");
    Expect(0, 6831, '\P{intaitham}', "");
    Expect(1, 6831, '\P{^intaitham}', "");
    Expect(0, 6832, '\p{intaitham}', "");
    Expect(1, 6832, '\p{^intaitham}', "");
    Expect(1, 6832, '\P{intaitham}', "");
    Expect(0, 6832, '\P{^intaitham}', "");
    Expect(1, 6831, '\p{-	in_Tai_Tham}', "");
    Expect(0, 6831, '\p{^-	in_Tai_Tham}', "");
    Expect(0, 6831, '\P{-	in_Tai_Tham}', "");
    Expect(1, 6831, '\P{^-	in_Tai_Tham}', "");
    Expect(0, 6832, '\p{-	in_Tai_Tham}', "");
    Expect(1, 6832, '\p{^-	in_Tai_Tham}', "");
    Expect(1, 6832, '\P{-	in_Tai_Tham}', "");
    Expect(0, 6832, '\P{^-	in_Tai_Tham}', "");
    Error('\p{ /a/In_TAI_THAM}');
    Error('\P{ /a/In_TAI_THAM}');
    Expect(1, 6831, '\p{-In_TAI_tham}', "");
    Expect(0, 6831, '\p{^-In_TAI_tham}', "");
    Expect(0, 6831, '\P{-In_TAI_tham}', "");
    Expect(1, 6831, '\P{^-In_TAI_tham}', "");
    Expect(0, 6832, '\p{-In_TAI_tham}', "");
    Expect(1, 6832, '\p{^-In_TAI_tham}', "");
    Expect(1, 6832, '\P{-In_TAI_tham}', "");
    Expect(0, 6832, '\P{^-In_TAI_tham}', "");
    Error('\p{	 In_Tai_Viet/a/}');
    Error('\P{	 In_Tai_Viet/a/}');
    Expect(1, 43743, '\p{intaiviet}', "");
    Expect(0, 43743, '\p{^intaiviet}', "");
    Expect(0, 43743, '\P{intaiviet}', "");
    Expect(1, 43743, '\P{^intaiviet}', "");
    Expect(0, 43744, '\p{intaiviet}', "");
    Expect(1, 43744, '\p{^intaiviet}', "");
    Expect(1, 43744, '\P{intaiviet}', "");
    Expect(0, 43744, '\P{^intaiviet}', "");
    Expect(1, 43743, '\p{--IN_Tai_Viet}', "");
    Expect(0, 43743, '\p{^--IN_Tai_Viet}', "");
    Expect(0, 43743, '\P{--IN_Tai_Viet}', "");
    Expect(1, 43743, '\P{^--IN_Tai_Viet}', "");
    Expect(0, 43744, '\p{--IN_Tai_Viet}', "");
    Expect(1, 43744, '\p{^--IN_Tai_Viet}', "");
    Expect(1, 43744, '\P{--IN_Tai_Viet}', "");
    Expect(0, 43744, '\P{^--IN_Tai_Viet}', "");
    Error('\p{:=	 In_tai_Viet}');
    Error('\P{:=	 In_tai_Viet}');
    Expect(1, 43743, '\p{_In_TAI_viet}', "");
    Expect(0, 43743, '\p{^_In_TAI_viet}', "");
    Expect(0, 43743, '\P{_In_TAI_viet}', "");
    Expect(1, 43743, '\P{^_In_TAI_viet}', "");
    Expect(0, 43744, '\p{_In_TAI_viet}', "");
    Expect(1, 43744, '\p{^_In_TAI_viet}', "");
    Expect(1, 43744, '\P{_In_TAI_viet}', "");
    Expect(0, 43744, '\P{^_In_TAI_viet}', "");
    Error('\p{_IN_Takri:=}');
    Error('\P{_IN_Takri:=}');
    Expect(1, 71375, '\p{intakri}', "");
    Expect(0, 71375, '\p{^intakri}', "");
    Expect(0, 71375, '\P{intakri}', "");
    Expect(1, 71375, '\P{^intakri}', "");
    Expect(0, 71376, '\p{intakri}', "");
    Expect(1, 71376, '\p{^intakri}', "");
    Expect(1, 71376, '\P{intakri}', "");
    Expect(0, 71376, '\P{^intakri}', "");
    Expect(1, 71375, '\p{-In_Takri}', "");
    Expect(0, 71375, '\p{^-In_Takri}', "");
    Expect(0, 71375, '\P{-In_Takri}', "");
    Expect(1, 71375, '\P{^-In_Takri}', "");
    Expect(0, 71376, '\p{-In_Takri}', "");
    Expect(1, 71376, '\p{^-In_Takri}', "");
    Expect(1, 71376, '\P{-In_Takri}', "");
    Expect(0, 71376, '\P{^-In_Takri}', "");
    Error('\p{_:=in_TAKRI}');
    Error('\P{_:=in_TAKRI}');
    Expect(1, 71375, '\p{	in_takri}', "");
    Expect(0, 71375, '\p{^	in_takri}', "");
    Expect(0, 71375, '\P{	in_takri}', "");
    Expect(1, 71375, '\P{^	in_takri}', "");
    Expect(0, 71376, '\p{	in_takri}', "");
    Expect(1, 71376, '\p{^	in_takri}', "");
    Expect(1, 71376, '\P{	in_takri}', "");
    Expect(0, 71376, '\P{^	in_takri}', "");
    Error('\p{ :=In_Tamil}');
    Error('\P{ :=In_Tamil}');
    Expect(1, 3071, '\p{intamil}', "");
    Expect(0, 3071, '\p{^intamil}', "");
    Expect(0, 3071, '\P{intamil}', "");
    Expect(1, 3071, '\P{^intamil}', "");
    Expect(0, 3072, '\p{intamil}', "");
    Expect(1, 3072, '\p{^intamil}', "");
    Expect(1, 3072, '\P{intamil}', "");
    Expect(0, 3072, '\P{^intamil}', "");
    Expect(1, 3071, '\p{	-IN_Tamil}', "");
    Expect(0, 3071, '\p{^	-IN_Tamil}', "");
    Expect(0, 3071, '\P{	-IN_Tamil}', "");
    Expect(1, 3071, '\P{^	-IN_Tamil}', "");
    Expect(0, 3072, '\p{	-IN_Tamil}', "");
    Expect(1, 3072, '\p{^	-IN_Tamil}', "");
    Expect(1, 3072, '\P{	-IN_Tamil}', "");
    Expect(0, 3072, '\P{^	-IN_Tamil}', "");
    Error('\p{	/a/In_Tamil}');
    Error('\P{	/a/In_Tamil}');
    Expect(1, 3071, '\p{ _IN_Tamil}', "");
    Expect(0, 3071, '\p{^ _IN_Tamil}', "");
    Expect(0, 3071, '\P{ _IN_Tamil}', "");
    Expect(1, 3071, '\P{^ _IN_Tamil}', "");
    Expect(0, 3072, '\p{ _IN_Tamil}', "");
    Expect(1, 3072, '\p{^ _IN_Tamil}', "");
    Expect(1, 3072, '\P{ _IN_Tamil}', "");
    Expect(0, 3072, '\P{^ _IN_Tamil}', "");
    Error('\p{:= 	in_TANGUT}');
    Error('\P{:= 	in_TANGUT}');
    Expect(1, 100351, '\p{intangut}', "");
    Expect(0, 100351, '\p{^intangut}', "");
    Expect(0, 100351, '\P{intangut}', "");
    Expect(1, 100351, '\P{^intangut}', "");
    Expect(0, 100352, '\p{intangut}', "");
    Expect(1, 100352, '\p{^intangut}', "");
    Expect(1, 100352, '\P{intangut}', "");
    Expect(0, 100352, '\P{^intangut}', "");
    Expect(1, 100351, '\p{	-In_TANGUT}', "");
    Expect(0, 100351, '\p{^	-In_TANGUT}', "");
    Expect(0, 100351, '\P{	-In_TANGUT}', "");
    Expect(1, 100351, '\P{^	-In_TANGUT}', "");
    Expect(0, 100352, '\p{	-In_TANGUT}', "");
    Expect(1, 100352, '\p{^	-In_TANGUT}', "");
    Expect(1, 100352, '\P{	-In_TANGUT}', "");
    Expect(0, 100352, '\P{^	-In_TANGUT}', "");
    Error('\p{_/a/In_TANGUT}');
    Error('\P{_/a/In_TANGUT}');
    Expect(1, 100351, '\p{		In_Tangut}', "");
    Expect(0, 100351, '\p{^		In_Tangut}', "");
    Expect(0, 100351, '\P{		In_Tangut}', "");
    Expect(1, 100351, '\P{^		In_Tangut}', "");
    Expect(0, 100352, '\p{		In_Tangut}', "");
    Expect(1, 100352, '\p{^		In_Tangut}', "");
    Expect(1, 100352, '\P{		In_Tangut}', "");
    Expect(0, 100352, '\P{^		In_Tangut}', "");
    Error('\p{_/a/In_TELUGU}');
    Error('\P{_/a/In_TELUGU}');
    Expect(1, 3199, '\p{intelugu}', "");
    Expect(0, 3199, '\p{^intelugu}', "");
    Expect(0, 3199, '\P{intelugu}', "");
    Expect(1, 3199, '\P{^intelugu}', "");
    Expect(0, 3200, '\p{intelugu}', "");
    Expect(1, 3200, '\p{^intelugu}', "");
    Expect(1, 3200, '\P{intelugu}', "");
    Expect(0, 3200, '\P{^intelugu}', "");
    Expect(1, 3199, '\p{_-in_telugu}', "");
    Expect(0, 3199, '\p{^_-in_telugu}', "");
    Expect(0, 3199, '\P{_-in_telugu}', "");
    Expect(1, 3199, '\P{^_-in_telugu}', "");
    Expect(0, 3200, '\p{_-in_telugu}', "");
    Expect(1, 3200, '\p{^_-in_telugu}', "");
    Expect(1, 3200, '\P{_-in_telugu}', "");
    Expect(0, 3200, '\P{^_-in_telugu}', "");
    Error('\p{	:=IN_TELUGU}');
    Error('\P{	:=IN_TELUGU}');
    Expect(1, 3199, '\p{	in_telugu}', "");
    Expect(0, 3199, '\p{^	in_telugu}', "");
    Expect(0, 3199, '\P{	in_telugu}', "");
    Expect(1, 3199, '\P{^	in_telugu}', "");
    Expect(0, 3200, '\p{	in_telugu}', "");
    Expect(1, 3200, '\p{^	in_telugu}', "");
    Expect(1, 3200, '\P{	in_telugu}', "");
    Expect(0, 3200, '\P{^	in_telugu}', "");
    Error('\p{:=_in_Thaana}');
    Error('\P{:=_in_Thaana}');
    Expect(1, 1983, '\p{inthaana}', "");
    Expect(0, 1983, '\p{^inthaana}', "");
    Expect(0, 1983, '\P{inthaana}', "");
    Expect(1, 1983, '\P{^inthaana}', "");
    Expect(0, 1984, '\p{inthaana}', "");
    Expect(1, 1984, '\p{^inthaana}', "");
    Expect(1, 1984, '\P{inthaana}', "");
    Expect(0, 1984, '\P{^inthaana}', "");
    Expect(1, 1983, '\p{ -in_Thaana}', "");
    Expect(0, 1983, '\p{^ -in_Thaana}', "");
    Expect(0, 1983, '\P{ -in_Thaana}', "");
    Expect(1, 1983, '\P{^ -in_Thaana}', "");
    Expect(0, 1984, '\p{ -in_Thaana}', "");
    Expect(1, 1984, '\p{^ -in_Thaana}', "");
    Expect(1, 1984, '\P{ -in_Thaana}', "");
    Expect(0, 1984, '\P{^ -in_Thaana}', "");
    Error('\p{		IN_THAANA/a/}');
    Error('\P{		IN_THAANA/a/}');
    Expect(1, 1983, '\p{ 	In_thaana}', "");
    Expect(0, 1983, '\p{^ 	In_thaana}', "");
    Expect(0, 1983, '\P{ 	In_thaana}', "");
    Expect(1, 1983, '\P{^ 	In_thaana}', "");
    Expect(0, 1984, '\p{ 	In_thaana}', "");
    Expect(1, 1984, '\p{^ 	In_thaana}', "");
    Expect(1, 1984, '\P{ 	In_thaana}', "");
    Expect(0, 1984, '\P{^ 	In_thaana}', "");
    Error('\p{/a/ _IN_Thai}');
    Error('\P{/a/ _IN_Thai}');
    Expect(1, 3711, '\p{inthai}', "");
    Expect(0, 3711, '\p{^inthai}', "");
    Expect(0, 3711, '\P{inthai}', "");
    Expect(1, 3711, '\P{^inthai}', "");
    Expect(0, 3712, '\p{inthai}', "");
    Expect(1, 3712, '\p{^inthai}', "");
    Expect(1, 3712, '\P{inthai}', "");
    Expect(0, 3712, '\P{^inthai}', "");
    Expect(1, 3711, '\p{-_IN_THAI}', "");
    Expect(0, 3711, '\p{^-_IN_THAI}', "");
    Expect(0, 3711, '\P{-_IN_THAI}', "");
    Expect(1, 3711, '\P{^-_IN_THAI}', "");
    Expect(0, 3712, '\p{-_IN_THAI}', "");
    Expect(1, 3712, '\p{^-_IN_THAI}', "");
    Expect(1, 3712, '\P{-_IN_THAI}', "");
    Expect(0, 3712, '\P{^-_IN_THAI}', "");
    Error('\p{ in_THAI/a/}');
    Error('\P{ in_THAI/a/}');
    Expect(1, 3711, '\p{	IN_THAI}', "");
    Expect(0, 3711, '\p{^	IN_THAI}', "");
    Expect(0, 3711, '\P{	IN_THAI}', "");
    Expect(1, 3711, '\P{^	IN_THAI}', "");
    Expect(0, 3712, '\p{	IN_THAI}', "");
    Expect(1, 3712, '\p{^	IN_THAI}', "");
    Expect(1, 3712, '\P{	IN_THAI}', "");
    Expect(0, 3712, '\P{^	IN_THAI}', "");
    Error('\p{:=_IN_Tibetan}');
    Error('\P{:=_IN_Tibetan}');
    Expect(1, 4095, '\p{intibetan}', "");
    Expect(0, 4095, '\p{^intibetan}', "");
    Expect(0, 4095, '\P{intibetan}', "");
    Expect(1, 4095, '\P{^intibetan}', "");
    Expect(0, 4096, '\p{intibetan}', "");
    Expect(1, 4096, '\p{^intibetan}', "");
    Expect(1, 4096, '\P{intibetan}', "");
    Expect(0, 4096, '\P{^intibetan}', "");
    Expect(1, 4095, '\p{_	IN_Tibetan}', "");
    Expect(0, 4095, '\p{^_	IN_Tibetan}', "");
    Expect(0, 4095, '\P{_	IN_Tibetan}', "");
    Expect(1, 4095, '\P{^_	IN_Tibetan}', "");
    Expect(0, 4096, '\p{_	IN_Tibetan}', "");
    Expect(1, 4096, '\p{^_	IN_Tibetan}', "");
    Expect(1, 4096, '\P{_	IN_Tibetan}', "");
    Expect(0, 4096, '\P{^_	IN_Tibetan}', "");
    Error('\p{/a/In_Tibetan}');
    Error('\P{/a/In_Tibetan}');
    Expect(1, 4095, '\p{-_IN_Tibetan}', "");
    Expect(0, 4095, '\p{^-_IN_Tibetan}', "");
    Expect(0, 4095, '\P{-_IN_Tibetan}', "");
    Expect(1, 4095, '\P{^-_IN_Tibetan}', "");
    Expect(0, 4096, '\p{-_IN_Tibetan}', "");
    Expect(1, 4096, '\p{^-_IN_Tibetan}', "");
    Expect(1, 4096, '\P{-_IN_Tibetan}', "");
    Expect(0, 4096, '\P{^-_IN_Tibetan}', "");
    Error('\p{__IN_TIFINAGH:=}');
    Error('\P{__IN_TIFINAGH:=}');
    Expect(1, 11647, '\p{intifinagh}', "");
    Expect(0, 11647, '\p{^intifinagh}', "");
    Expect(0, 11647, '\P{intifinagh}', "");
    Expect(1, 11647, '\P{^intifinagh}', "");
    Expect(0, 11648, '\p{intifinagh}', "");
    Expect(1, 11648, '\p{^intifinagh}', "");
    Expect(1, 11648, '\P{intifinagh}', "");
    Expect(0, 11648, '\P{^intifinagh}', "");
    Expect(1, 11647, '\p{__in_tifinagh}', "");
    Expect(0, 11647, '\p{^__in_tifinagh}', "");
    Expect(0, 11647, '\P{__in_tifinagh}', "");
    Expect(1, 11647, '\P{^__in_tifinagh}', "");
    Expect(0, 11648, '\p{__in_tifinagh}', "");
    Expect(1, 11648, '\p{^__in_tifinagh}', "");
    Expect(1, 11648, '\P{__in_tifinagh}', "");
    Expect(0, 11648, '\P{^__in_tifinagh}', "");
    Error('\p{/a/_IN_TIFINAGH}');
    Error('\P{/a/_IN_TIFINAGH}');
    Expect(1, 11647, '\p{-	in_Tifinagh}', "");
    Expect(0, 11647, '\p{^-	in_Tifinagh}', "");
    Expect(0, 11647, '\P{-	in_Tifinagh}', "");
    Expect(1, 11647, '\P{^-	in_Tifinagh}', "");
    Expect(0, 11648, '\p{-	in_Tifinagh}', "");
    Expect(1, 11648, '\p{^-	in_Tifinagh}', "");
    Expect(1, 11648, '\P{-	in_Tifinagh}', "");
    Expect(0, 11648, '\P{^-	in_Tifinagh}', "");
    Error('\p{/a/-In_Tirhuta}');
    Error('\P{/a/-In_Tirhuta}');
    Expect(1, 70879, '\p{intirhuta}', "");
    Expect(0, 70879, '\p{^intirhuta}', "");
    Expect(0, 70879, '\P{intirhuta}', "");
    Expect(1, 70879, '\P{^intirhuta}', "");
    Expect(0, 70880, '\p{intirhuta}', "");
    Expect(1, 70880, '\p{^intirhuta}', "");
    Expect(1, 70880, '\P{intirhuta}', "");
    Expect(0, 70880, '\P{^intirhuta}', "");
    Expect(1, 70879, '\p{ 	in_Tirhuta}', "");
    Expect(0, 70879, '\p{^ 	in_Tirhuta}', "");
    Expect(0, 70879, '\P{ 	in_Tirhuta}', "");
    Expect(1, 70879, '\P{^ 	in_Tirhuta}', "");
    Expect(0, 70880, '\p{ 	in_Tirhuta}', "");
    Expect(1, 70880, '\p{^ 	in_Tirhuta}', "");
    Expect(1, 70880, '\P{ 	in_Tirhuta}', "");
    Expect(0, 70880, '\P{^ 	in_Tirhuta}', "");
    Error('\p{_/a/IN_TIRHUTA}');
    Error('\P{_/a/IN_TIRHUTA}');
    Expect(1, 70879, '\p{  In_tirhuta}', "");
    Expect(0, 70879, '\p{^  In_tirhuta}', "");
    Expect(0, 70879, '\P{  In_tirhuta}', "");
    Expect(1, 70879, '\P{^  In_tirhuta}', "");
    Expect(0, 70880, '\p{  In_tirhuta}', "");
    Expect(1, 70880, '\p{^  In_tirhuta}', "");
    Expect(1, 70880, '\P{  In_tirhuta}', "");
    Expect(0, 70880, '\P{^  In_tirhuta}', "");
    Error('\p{	_in_ugaritic/a/}');
    Error('\P{	_in_ugaritic/a/}');
    Expect(1, 66463, '\p{inugaritic}', "");
    Expect(0, 66463, '\p{^inugaritic}', "");
    Expect(0, 66463, '\P{inugaritic}', "");
    Expect(1, 66463, '\P{^inugaritic}', "");
    Expect(0, 66464, '\p{inugaritic}', "");
    Expect(1, 66464, '\p{^inugaritic}', "");
    Expect(1, 66464, '\P{inugaritic}', "");
    Expect(0, 66464, '\P{^inugaritic}', "");
    Expect(1, 66463, '\p{	in_UGARITIC}', "");
    Expect(0, 66463, '\p{^	in_UGARITIC}', "");
    Expect(0, 66463, '\P{	in_UGARITIC}', "");
    Expect(1, 66463, '\P{^	in_UGARITIC}', "");
    Expect(0, 66464, '\p{	in_UGARITIC}', "");
    Expect(1, 66464, '\p{^	in_UGARITIC}', "");
    Expect(1, 66464, '\P{	in_UGARITIC}', "");
    Expect(0, 66464, '\P{^	in_UGARITIC}', "");
    Error('\p{/a/	 IN_Ugaritic}');
    Error('\P{/a/	 IN_Ugaritic}');
    Expect(1, 66463, '\p{_ IN_UGARITIC}', "");
    Expect(0, 66463, '\p{^_ IN_UGARITIC}', "");
    Expect(0, 66463, '\P{_ IN_UGARITIC}', "");
    Expect(1, 66463, '\P{^_ IN_UGARITIC}', "");
    Expect(0, 66464, '\p{_ IN_UGARITIC}', "");
    Expect(1, 66464, '\p{^_ IN_UGARITIC}', "");
    Expect(1, 66464, '\P{_ IN_UGARITIC}', "");
    Expect(0, 66464, '\P{^_ IN_UGARITIC}', "");
    Error('\p{-In_Vai/a/}');
    Error('\P{-In_Vai/a/}');
    Expect(1, 42559, '\p{invai}', "");
    Expect(0, 42559, '\p{^invai}', "");
    Expect(0, 42559, '\P{invai}', "");
    Expect(1, 42559, '\P{^invai}', "");
    Expect(0, 42560, '\p{invai}', "");
    Expect(1, 42560, '\p{^invai}', "");
    Expect(1, 42560, '\P{invai}', "");
    Expect(0, 42560, '\P{^invai}', "");
    Expect(1, 42559, '\p{_In_Vai}', "");
    Expect(0, 42559, '\p{^_In_Vai}', "");
    Expect(0, 42559, '\P{_In_Vai}', "");
    Expect(1, 42559, '\P{^_In_Vai}', "");
    Expect(0, 42560, '\p{_In_Vai}', "");
    Expect(1, 42560, '\p{^_In_Vai}', "");
    Expect(1, 42560, '\P{_In_Vai}', "");
    Expect(0, 42560, '\P{^_In_Vai}', "");
    Error('\p{	/a/In_Vai}');
    Error('\P{	/a/In_Vai}');
    Expect(1, 42559, '\p{	In_vai}', "");
    Expect(0, 42559, '\p{^	In_vai}', "");
    Expect(0, 42559, '\P{	In_vai}', "");
    Expect(1, 42559, '\P{^	In_vai}', "");
    Expect(0, 42560, '\p{	In_vai}', "");
    Expect(1, 42560, '\p{^	In_vai}', "");
    Expect(1, 42560, '\P{	In_vai}', "");
    Expect(0, 42560, '\P{^	In_vai}', "");
    Error('\p{ in_WANCHO/a/}');
    Error('\P{ in_WANCHO/a/}');
    Expect(1, 123647, '\p{inwancho}', "");
    Expect(0, 123647, '\p{^inwancho}', "");
    Expect(0, 123647, '\P{inwancho}', "");
    Expect(1, 123647, '\P{^inwancho}', "");
    Expect(0, 123648, '\p{inwancho}', "");
    Expect(1, 123648, '\p{^inwancho}', "");
    Expect(1, 123648, '\P{inwancho}', "");
    Expect(0, 123648, '\P{^inwancho}', "");
    Expect(1, 123647, '\p{  in_WANCHO}', "");
    Expect(0, 123647, '\p{^  in_WANCHO}', "");
    Expect(0, 123647, '\P{  in_WANCHO}', "");
    Expect(1, 123647, '\P{^  in_WANCHO}', "");
    Expect(0, 123648, '\p{  in_WANCHO}', "");
    Expect(1, 123648, '\p{^  in_WANCHO}', "");
    Expect(1, 123648, '\P{  in_WANCHO}', "");
    Expect(0, 123648, '\P{^  in_WANCHO}', "");
    Error('\p{:=In_wancho}');
    Error('\P{:=In_wancho}');
    Expect(1, 123647, '\p{ IN_Wancho}', "");
    Expect(0, 123647, '\p{^ IN_Wancho}', "");
    Expect(0, 123647, '\P{ IN_Wancho}', "");
    Expect(1, 123647, '\P{^ IN_Wancho}', "");
    Expect(0, 123648, '\p{ IN_Wancho}', "");
    Expect(1, 123648, '\p{^ IN_Wancho}', "");
    Expect(1, 123648, '\P{ IN_Wancho}', "");
    Expect(0, 123648, '\P{^ IN_Wancho}', "");
    Error('\p{_	IN_Warang_citi/a/}');
    Error('\P{_	IN_Warang_citi/a/}');
    Expect(1, 71935, '\p{inwarangciti}', "");
    Expect(0, 71935, '\p{^inwarangciti}', "");
    Expect(0, 71935, '\P{inwarangciti}', "");
    Expect(1, 71935, '\P{^inwarangciti}', "");
    Expect(0, 71936, '\p{inwarangciti}', "");
    Expect(1, 71936, '\p{^inwarangciti}', "");
    Expect(1, 71936, '\P{inwarangciti}', "");
    Expect(0, 71936, '\P{^inwarangciti}', "");
    Expect(1, 71935, '\p{- in_Warang_Citi}', "");
    Expect(0, 71935, '\p{^- in_Warang_Citi}', "");
    Expect(0, 71935, '\P{- in_Warang_Citi}', "");
    Expect(1, 71935, '\P{^- in_Warang_Citi}', "");
    Expect(0, 71936, '\p{- in_Warang_Citi}', "");
    Expect(1, 71936, '\p{^- in_Warang_Citi}', "");
    Expect(1, 71936, '\P{- in_Warang_Citi}', "");
    Expect(0, 71936, '\P{^- in_Warang_Citi}', "");
    Error('\p{/a/_-in_warang_Citi}');
    Error('\P{/a/_-in_warang_Citi}');
    Expect(1, 71935, '\p{ In_warang_citi}', "");
    Expect(0, 71935, '\p{^ In_warang_citi}', "");
    Expect(0, 71935, '\P{ In_warang_citi}', "");
    Expect(1, 71935, '\P{^ In_warang_citi}', "");
    Expect(0, 71936, '\p{ In_warang_citi}', "");
    Expect(1, 71936, '\p{^ In_warang_citi}', "");
    Expect(1, 71936, '\P{ In_warang_citi}', "");
    Expect(0, 71936, '\P{^ In_warang_citi}', "");
    Error('\p{:=	_in_yezidi}');
    Error('\P{:=	_in_yezidi}');
    Expect(1, 69311, '\p{inyezidi}', "");
    Expect(0, 69311, '\p{^inyezidi}', "");
    Expect(0, 69311, '\P{inyezidi}', "");
    Expect(1, 69311, '\P{^inyezidi}', "");
    Expect(0, 69312, '\p{inyezidi}', "");
    Expect(1, 69312, '\p{^inyezidi}', "");
    Expect(1, 69312, '\P{inyezidi}', "");
    Expect(0, 69312, '\P{^inyezidi}', "");
    Expect(1, 69311, '\p{ IN_YEZIDI}', "");
    Expect(0, 69311, '\p{^ IN_YEZIDI}', "");
    Expect(0, 69311, '\P{ IN_YEZIDI}', "");
    Expect(1, 69311, '\P{^ IN_YEZIDI}', "");
    Expect(0, 69312, '\p{ IN_YEZIDI}', "");
    Expect(1, 69312, '\p{^ IN_YEZIDI}', "");
    Expect(1, 69312, '\P{ IN_YEZIDI}', "");
    Expect(0, 69312, '\P{^ IN_YEZIDI}', "");
    Error('\p{ 	In_Yezidi/a/}');
    Error('\P{ 	In_Yezidi/a/}');
    Expect(1, 69311, '\p{	_in_Yezidi}', "");
    Expect(0, 69311, '\p{^	_in_Yezidi}', "");
    Expect(0, 69311, '\P{	_in_Yezidi}', "");
    Expect(1, 69311, '\P{^	_in_Yezidi}', "");
    Expect(0, 69312, '\p{	_in_Yezidi}', "");
    Expect(1, 69312, '\p{^	_in_Yezidi}', "");
    Expect(1, 69312, '\P{	_in_Yezidi}', "");
    Expect(0, 69312, '\P{^	_in_Yezidi}', "");
    Error('\p{	IN_Zanabazar_Square:=}');
    Error('\P{	IN_Zanabazar_Square:=}');
    Expect(1, 72271, '\p{inzanabazarsquare}', "");
    Expect(0, 72271, '\p{^inzanabazarsquare}', "");
    Expect(0, 72271, '\P{inzanabazarsquare}', "");
    Expect(1, 72271, '\P{^inzanabazarsquare}', "");
    Expect(0, 72272, '\p{inzanabazarsquare}', "");
    Expect(1, 72272, '\p{^inzanabazarsquare}', "");
    Expect(1, 72272, '\P{inzanabazarsquare}', "");
    Expect(0, 72272, '\P{^inzanabazarsquare}', "");
    Expect(1, 72271, '\p{	 In_Zanabazar_SQUARE}', "");
    Expect(0, 72271, '\p{^	 In_Zanabazar_SQUARE}', "");
    Expect(0, 72271, '\P{	 In_Zanabazar_SQUARE}', "");
    Expect(1, 72271, '\P{^	 In_Zanabazar_SQUARE}', "");
    Expect(0, 72272, '\p{	 In_Zanabazar_SQUARE}', "");
    Expect(1, 72272, '\p{^	 In_Zanabazar_SQUARE}', "");
    Expect(1, 72272, '\P{	 In_Zanabazar_SQUARE}', "");
    Expect(0, 72272, '\P{^	 In_Zanabazar_SQUARE}', "");
    Error('\p{/a/_In_Zanabazar_Square}');
    Error('\P{/a/_In_Zanabazar_Square}');
    Expect(1, 72271, '\p{_In_ZANABAZAR_square}', "");
    Expect(0, 72271, '\p{^_In_ZANABAZAR_square}', "");
    Expect(0, 72271, '\P{_In_ZANABAZAR_square}', "");
    Expect(1, 72271, '\P{^_In_ZANABAZAR_square}', "");
    Expect(0, 72272, '\p{_In_ZANABAZAR_square}', "");
    Expect(1, 72272, '\p{^_In_ZANABAZAR_square}', "");
    Expect(1, 72272, '\P{_In_ZANABAZAR_square}', "");
    Expect(0, 72272, '\P{^_In_ZANABAZAR_square}', "");
    Error('\p{_:=indic_Siyaq_Numbers}');
    Error('\P{_:=indic_Siyaq_Numbers}');
    Expect(1, 126143, '\p{indicsiyaqnumbers}', "");
    Expect(0, 126143, '\p{^indicsiyaqnumbers}', "");
    Expect(0, 126143, '\P{indicsiyaqnumbers}', "");
    Expect(1, 126143, '\P{^indicsiyaqnumbers}', "");
    Expect(0, 126144, '\p{indicsiyaqnumbers}', "");
    Expect(1, 126144, '\p{^indicsiyaqnumbers}', "");
    Expect(1, 126144, '\P{indicsiyaqnumbers}', "");
    Expect(0, 126144, '\P{^indicsiyaqnumbers}', "");
    Expect(1, 126143, '\p{_	Indic_Siyaq_numbers}', "");
    Expect(0, 126143, '\p{^_	Indic_Siyaq_numbers}', "");
    Expect(0, 126143, '\P{_	Indic_Siyaq_numbers}', "");
    Expect(1, 126143, '\P{^_	Indic_Siyaq_numbers}', "");
    Expect(0, 126144, '\p{_	Indic_Siyaq_numbers}', "");
    Expect(1, 126144, '\p{^_	Indic_Siyaq_numbers}', "");
    Expect(1, 126144, '\P{_	Indic_Siyaq_numbers}', "");
    Expect(0, 126144, '\P{^_	Indic_Siyaq_numbers}', "");
    Error('\p{	_Is_INDIC_Siyaq_Numbers:=}');
    Error('\P{	_Is_INDIC_Siyaq_Numbers:=}');
    Expect(1, 126143, '\p{isindicsiyaqnumbers}', "");
    Expect(0, 126143, '\p{^isindicsiyaqnumbers}', "");
    Expect(0, 126143, '\P{isindicsiyaqnumbers}', "");
    Expect(1, 126143, '\P{^isindicsiyaqnumbers}', "");
    Expect(0, 126144, '\p{isindicsiyaqnumbers}', "");
    Expect(1, 126144, '\p{^isindicsiyaqnumbers}', "");
    Expect(1, 126144, '\P{isindicsiyaqnumbers}', "");
    Expect(0, 126144, '\P{^isindicsiyaqnumbers}', "");
    Expect(1, 126143, '\p{	 is_Indic_siyaq_Numbers}', "");
    Expect(0, 126143, '\p{^	 is_Indic_siyaq_Numbers}', "");
    Expect(0, 126143, '\P{	 is_Indic_siyaq_Numbers}', "");
    Expect(1, 126143, '\P{^	 is_Indic_siyaq_Numbers}', "");
    Expect(0, 126144, '\p{	 is_Indic_siyaq_Numbers}', "");
    Expect(1, 126144, '\p{^	 is_Indic_siyaq_Numbers}', "");
    Expect(1, 126144, '\P{	 is_Indic_siyaq_Numbers}', "");
    Expect(0, 126144, '\P{^	 is_Indic_siyaq_Numbers}', "");
    Error('\p{-:=In_Indic_Siyaq_Numbers}');
    Error('\P{-:=In_Indic_Siyaq_Numbers}');
    Expect(1, 126143, '\p{inindicsiyaqnumbers}', "");
    Expect(0, 126143, '\p{^inindicsiyaqnumbers}', "");
    Expect(0, 126143, '\P{inindicsiyaqnumbers}', "");
    Expect(1, 126143, '\P{^inindicsiyaqnumbers}', "");
    Expect(0, 126144, '\p{inindicsiyaqnumbers}', "");
    Expect(1, 126144, '\p{^inindicsiyaqnumbers}', "");
    Expect(1, 126144, '\P{inindicsiyaqnumbers}', "");
    Expect(0, 126144, '\P{^inindicsiyaqnumbers}', "");
    Expect(1, 126143, '\p{- IN_Indic_siyaq_NUMBERS}', "");
    Expect(0, 126143, '\p{^- IN_Indic_siyaq_NUMBERS}', "");
    Expect(0, 126143, '\P{- IN_Indic_siyaq_NUMBERS}', "");
    Expect(1, 126143, '\P{^- IN_Indic_siyaq_NUMBERS}', "");
    Expect(0, 126144, '\p{- IN_Indic_siyaq_NUMBERS}', "");
    Expect(1, 126144, '\p{^- IN_Indic_siyaq_NUMBERS}', "");
    Expect(1, 126144, '\P{- IN_Indic_siyaq_NUMBERS}', "");
    Expect(0, 126144, '\P{^- IN_Indic_siyaq_NUMBERS}', "");
    Error('\p{/a/--INHERITED}');
    Error('\P{/a/--INHERITED}');
    Expect(1, 917999, '\p{inherited}', "");
    Expect(0, 917999, '\p{^inherited}', "");
    Expect(0, 917999, '\P{inherited}', "");
    Expect(1, 917999, '\P{^inherited}', "");
    Expect(0, 918000, '\p{inherited}', "");
    Expect(1, 918000, '\p{^inherited}', "");
    Expect(1, 918000, '\P{inherited}', "");
    Expect(0, 918000, '\P{^inherited}', "");
    Expect(1, 917999, '\p{ -Inherited}', "");
    Expect(0, 917999, '\p{^ -Inherited}', "");
    Expect(0, 917999, '\P{ -Inherited}', "");
    Expect(1, 917999, '\P{^ -Inherited}', "");
    Expect(0, 918000, '\p{ -Inherited}', "");
    Expect(1, 918000, '\p{^ -Inherited}', "");
    Expect(1, 918000, '\P{ -Inherited}', "");
    Expect(0, 918000, '\P{^ -Inherited}', "");
    Error('\p{:=	-is_Inherited}');
    Error('\P{:=	-is_Inherited}');
    Expect(1, 917999, '\p{isinherited}', "");
    Expect(0, 917999, '\p{^isinherited}', "");
    Expect(0, 917999, '\P{isinherited}', "");
    Expect(1, 917999, '\P{^isinherited}', "");
    Expect(0, 918000, '\p{isinherited}', "");
    Expect(1, 918000, '\p{^isinherited}', "");
    Expect(1, 918000, '\P{isinherited}', "");
    Expect(0, 918000, '\P{^isinherited}', "");
    Expect(1, 917999, '\p{ -IS_inherited}', "");
    Expect(0, 917999, '\p{^ -IS_inherited}', "");
    Expect(0, 917999, '\P{ -IS_inherited}', "");
    Expect(1, 917999, '\P{^ -IS_inherited}', "");
    Expect(0, 918000, '\p{ -IS_inherited}', "");
    Expect(1, 918000, '\p{^ -IS_inherited}', "");
    Expect(1, 918000, '\P{ -IS_inherited}', "");
    Expect(0, 918000, '\P{^ -IS_inherited}', "");
    Error('\p{	/a/zinh}');
    Error('\P{	/a/zinh}');
    Expect(1, 917999, '\p{zinh}', "");
    Expect(0, 917999, '\p{^zinh}', "");
    Expect(0, 917999, '\P{zinh}', "");
    Expect(1, 917999, '\P{^zinh}', "");
    Expect(0, 918000, '\p{zinh}', "");
    Expect(1, 918000, '\p{^zinh}', "");
    Expect(1, 918000, '\P{zinh}', "");
    Expect(0, 918000, '\P{^zinh}', "");
    Expect(1, 917999, '\p{ ZINH}', "");
    Expect(0, 917999, '\p{^ ZINH}', "");
    Expect(0, 917999, '\P{ ZINH}', "");
    Expect(1, 917999, '\P{^ ZINH}', "");
    Expect(0, 918000, '\p{ ZINH}', "");
    Expect(1, 918000, '\p{^ ZINH}', "");
    Expect(1, 918000, '\P{ ZINH}', "");
    Expect(0, 918000, '\P{^ ZINH}', "");
    Error('\p{/a/--Is_zinh}');
    Error('\P{/a/--Is_zinh}');
    Expect(1, 917999, '\p{iszinh}', "");
    Expect(0, 917999, '\p{^iszinh}', "");
    Expect(0, 917999, '\P{iszinh}', "");
    Expect(1, 917999, '\P{^iszinh}', "");
    Expect(0, 918000, '\p{iszinh}', "");
    Expect(1, 918000, '\p{^iszinh}', "");
    Expect(1, 918000, '\P{iszinh}', "");
    Expect(0, 918000, '\P{^iszinh}', "");
    Expect(1, 917999, '\p{ Is_Zinh}', "");
    Expect(0, 917999, '\p{^ Is_Zinh}', "");
    Expect(0, 917999, '\P{ Is_Zinh}', "");
    Expect(1, 917999, '\P{^ Is_Zinh}', "");
    Expect(0, 918000, '\p{ Is_Zinh}', "");
    Expect(1, 918000, '\p{^ Is_Zinh}', "");
    Expect(1, 918000, '\P{ Is_Zinh}', "");
    Expect(0, 918000, '\P{^ Is_Zinh}', "");
    Error('\p{/a/ qaai}');
    Error('\P{/a/ qaai}');
    Expect(1, 917999, '\p{qaai}', "");
    Expect(0, 917999, '\p{^qaai}', "");
    Expect(0, 917999, '\P{qaai}', "");
    Expect(1, 917999, '\P{^qaai}', "");
    Expect(0, 918000, '\p{qaai}', "");
    Expect(1, 918000, '\p{^qaai}', "");
    Expect(1, 918000, '\P{qaai}', "");
    Expect(0, 918000, '\P{^qaai}', "");
    Expect(1, 917999, '\p{-	Qaai}', "");
    Expect(0, 917999, '\p{^-	Qaai}', "");
    Expect(0, 917999, '\P{-	Qaai}', "");
    Expect(1, 917999, '\P{^-	Qaai}', "");
    Expect(0, 918000, '\p{-	Qaai}', "");
    Expect(1, 918000, '\p{^-	Qaai}', "");
    Expect(1, 918000, '\P{-	Qaai}', "");
    Expect(0, 918000, '\P{^-	Qaai}', "");
    Error('\p{/a/is_QAAI}');
    Error('\P{/a/is_QAAI}');
    Expect(1, 917999, '\p{isqaai}', "");
    Expect(0, 917999, '\p{^isqaai}', "");
    Expect(0, 917999, '\P{isqaai}', "");
    Expect(1, 917999, '\P{^isqaai}', "");
    Expect(0, 918000, '\p{isqaai}', "");
    Expect(1, 918000, '\p{^isqaai}', "");
    Expect(1, 918000, '\P{isqaai}', "");
    Expect(0, 918000, '\P{^isqaai}', "");
    Expect(1, 917999, '\p{--Is_qaai}', "");
    Expect(0, 917999, '\p{^--Is_qaai}', "");
    Expect(0, 917999, '\P{--Is_qaai}', "");
    Expect(1, 917999, '\P{^--Is_qaai}', "");
    Expect(0, 918000, '\p{--Is_qaai}', "");
    Expect(1, 918000, '\p{^--Is_qaai}', "");
    Expect(1, 918000, '\P{--Is_qaai}', "");
    Expect(0, 918000, '\P{^--Is_qaai}', "");
    Error('\p{-:=Initial_punctuation}');
    Error('\P{-:=Initial_punctuation}');
    Expect(1, 11808, '\p{initialpunctuation}', "");
    Expect(0, 11808, '\p{^initialpunctuation}', "");
    Expect(0, 11808, '\P{initialpunctuation}', "");
    Expect(1, 11808, '\P{^initialpunctuation}', "");
    Expect(0, 11809, '\p{initialpunctuation}', "");
    Expect(1, 11809, '\p{^initialpunctuation}', "");
    Expect(1, 11809, '\P{initialpunctuation}', "");
    Expect(0, 11809, '\P{^initialpunctuation}', "");
    Expect(1, 11808, '\p{_initial_Punctuation}', "");
    Expect(0, 11808, '\p{^_initial_Punctuation}', "");
    Expect(0, 11808, '\P{_initial_Punctuation}', "");
    Expect(1, 11808, '\P{^_initial_Punctuation}', "");
    Expect(0, 11809, '\p{_initial_Punctuation}', "");
    Expect(1, 11809, '\p{^_initial_Punctuation}', "");
    Expect(1, 11809, '\P{_initial_Punctuation}', "");
    Expect(0, 11809, '\P{^_initial_Punctuation}', "");
    Error('\p{-/a/Is_Initial_PUNCTUATION}');
    Error('\P{-/a/Is_Initial_PUNCTUATION}');
    Expect(1, 11808, '\p{isinitialpunctuation}', "");
    Expect(0, 11808, '\p{^isinitialpunctuation}', "");
    Expect(0, 11808, '\P{isinitialpunctuation}', "");
    Expect(1, 11808, '\P{^isinitialpunctuation}', "");
    Expect(0, 11809, '\p{isinitialpunctuation}', "");
    Expect(1, 11809, '\p{^isinitialpunctuation}', "");
    Expect(1, 11809, '\P{isinitialpunctuation}', "");
    Expect(0, 11809, '\P{^isinitialpunctuation}', "");
    Expect(1, 11808, '\p{- Is_initial_Punctuation}', "");
    Expect(0, 11808, '\p{^- Is_initial_Punctuation}', "");
    Expect(0, 11808, '\P{- Is_initial_Punctuation}', "");
    Expect(1, 11808, '\P{^- Is_initial_Punctuation}', "");
    Expect(0, 11809, '\p{- Is_initial_Punctuation}', "");
    Expect(1, 11809, '\p{^- Is_initial_Punctuation}', "");
    Expect(1, 11809, '\P{- Is_initial_Punctuation}', "");
    Expect(0, 11809, '\P{^- Is_initial_Punctuation}', "");
    Error('\p{:=__Pi}');
    Error('\P{:=__Pi}');
    Expect(1, 11808, '\p{pi}', "");
    Expect(0, 11808, '\p{^pi}', "");
    Expect(0, 11808, '\P{pi}', "");
    Expect(1, 11808, '\P{^pi}', "");
    Expect(0, 11809, '\p{pi}', "");
    Expect(1, 11809, '\p{^pi}', "");
    Expect(1, 11809, '\P{pi}', "");
    Expect(0, 11809, '\P{^pi}', "");
    Error('\p{ /a/Is_pi}');
    Error('\P{ /a/Is_pi}');
    Expect(1, 11808, '\p{ispi}', "");
    Expect(0, 11808, '\p{^ispi}', "");
    Expect(0, 11808, '\P{ispi}', "");
    Expect(1, 11808, '\P{^ispi}', "");
    Expect(0, 11809, '\p{ispi}', "");
    Expect(1, 11809, '\p{^ispi}', "");
    Expect(1, 11809, '\P{ispi}', "");
    Expect(0, 11809, '\P{^ispi}', "");
    Expect(1, 11808, '\p{_ is_Pi}', "");
    Expect(0, 11808, '\p{^_ is_Pi}', "");
    Expect(0, 11808, '\P{_ is_Pi}', "");
    Expect(1, 11808, '\P{^_ is_Pi}', "");
    Expect(0, 11809, '\p{_ is_Pi}', "");
    Expect(1, 11809, '\p{^_ is_Pi}', "");
    Expect(1, 11809, '\P{_ is_Pi}', "");
    Expect(0, 11809, '\P{^_ is_Pi}', "");
    Error('\p{-	Inscriptional_Pahlavi/a/}');
    Error('\P{-	Inscriptional_Pahlavi/a/}');
    Expect(1, 68479, '\p{inscriptionalpahlavi}', "");
    Expect(0, 68479, '\p{^inscriptionalpahlavi}', "");
    Expect(0, 68479, '\P{inscriptionalpahlavi}', "");
    Expect(1, 68479, '\P{^inscriptionalpahlavi}', "");
    Expect(0, 68480, '\p{inscriptionalpahlavi}', "");
    Expect(1, 68480, '\p{^inscriptionalpahlavi}', "");
    Expect(1, 68480, '\P{inscriptionalpahlavi}', "");
    Expect(0, 68480, '\P{^inscriptionalpahlavi}', "");
    Expect(1, 68479, '\p{--Inscriptional_PAHLAVI}', "");
    Expect(0, 68479, '\p{^--Inscriptional_PAHLAVI}', "");
    Expect(0, 68479, '\P{--Inscriptional_PAHLAVI}', "");
    Expect(1, 68479, '\P{^--Inscriptional_PAHLAVI}', "");
    Expect(0, 68480, '\p{--Inscriptional_PAHLAVI}', "");
    Expect(1, 68480, '\p{^--Inscriptional_PAHLAVI}', "");
    Expect(1, 68480, '\P{--Inscriptional_PAHLAVI}', "");
    Expect(0, 68480, '\P{^--Inscriptional_PAHLAVI}', "");
    Error('\p{:=is_inscriptional_pahlavi}');
    Error('\P{:=is_inscriptional_pahlavi}');
    Expect(1, 68479, '\p{isinscriptionalpahlavi}', "");
    Expect(0, 68479, '\p{^isinscriptionalpahlavi}', "");
    Expect(0, 68479, '\P{isinscriptionalpahlavi}', "");
    Expect(1, 68479, '\P{^isinscriptionalpahlavi}', "");
    Expect(0, 68480, '\p{isinscriptionalpahlavi}', "");
    Expect(1, 68480, '\p{^isinscriptionalpahlavi}', "");
    Expect(1, 68480, '\P{isinscriptionalpahlavi}', "");
    Expect(0, 68480, '\P{^isinscriptionalpahlavi}', "");
    Expect(1, 68479, '\p{		Is_inscriptional_PAHLAVI}', "");
    Expect(0, 68479, '\p{^		Is_inscriptional_PAHLAVI}', "");
    Expect(0, 68479, '\P{		Is_inscriptional_PAHLAVI}', "");
    Expect(1, 68479, '\P{^		Is_inscriptional_PAHLAVI}', "");
    Expect(0, 68480, '\p{		Is_inscriptional_PAHLAVI}', "");
    Expect(1, 68480, '\p{^		Is_inscriptional_PAHLAVI}', "");
    Expect(1, 68480, '\P{		Is_inscriptional_PAHLAVI}', "");
    Expect(0, 68480, '\P{^		Is_inscriptional_PAHLAVI}', "");
    Error('\p{:=_ Phli}');
    Error('\P{:=_ Phli}');
    Expect(1, 68479, '\p{phli}', "");
    Expect(0, 68479, '\p{^phli}', "");
    Expect(0, 68479, '\P{phli}', "");
    Expect(1, 68479, '\P{^phli}', "");
    Expect(0, 68480, '\p{phli}', "");
    Expect(1, 68480, '\p{^phli}', "");
    Expect(1, 68480, '\P{phli}', "");
    Expect(0, 68480, '\P{^phli}', "");
    Expect(1, 68479, '\p{		phli}', "");
    Expect(0, 68479, '\p{^		phli}', "");
    Expect(0, 68479, '\P{		phli}', "");
    Expect(1, 68479, '\P{^		phli}', "");
    Expect(0, 68480, '\p{		phli}', "");
    Expect(1, 68480, '\p{^		phli}', "");
    Expect(1, 68480, '\P{		phli}', "");
    Expect(0, 68480, '\P{^		phli}', "");
    Error('\p{  is_PHLI:=}');
    Error('\P{  is_PHLI:=}');
    Expect(1, 68479, '\p{isphli}', "");
    Expect(0, 68479, '\p{^isphli}', "");
    Expect(0, 68479, '\P{isphli}', "");
    Expect(1, 68479, '\P{^isphli}', "");
    Expect(0, 68480, '\p{isphli}', "");
    Expect(1, 68480, '\p{^isphli}', "");
    Expect(1, 68480, '\P{isphli}', "");
    Expect(0, 68480, '\P{^isphli}', "");
    Expect(1, 68479, '\p{_IS_phli}', "");
    Expect(0, 68479, '\p{^_IS_phli}', "");
    Expect(0, 68479, '\P{_IS_phli}', "");
    Expect(1, 68479, '\P{^_IS_phli}', "");
    Expect(0, 68480, '\p{_IS_phli}', "");
    Expect(1, 68480, '\p{^_IS_phli}', "");
    Expect(1, 68480, '\P{_IS_phli}', "");
    Expect(0, 68480, '\P{^_IS_phli}', "");
    Error('\p{:=	 inscriptional_PARTHIAN}');
    Error('\P{:=	 inscriptional_PARTHIAN}');
    Expect(1, 68447, '\p{inscriptionalparthian}', "");
    Expect(0, 68447, '\p{^inscriptionalparthian}', "");
    Expect(0, 68447, '\P{inscriptionalparthian}', "");
    Expect(1, 68447, '\P{^inscriptionalparthian}', "");
    Expect(0, 68448, '\p{inscriptionalparthian}', "");
    Expect(1, 68448, '\p{^inscriptionalparthian}', "");
    Expect(1, 68448, '\P{inscriptionalparthian}', "");
    Expect(0, 68448, '\P{^inscriptionalparthian}', "");
    Expect(1, 68447, '\p{-inscriptional_parthian}', "");
    Expect(0, 68447, '\p{^-inscriptional_parthian}', "");
    Expect(0, 68447, '\P{-inscriptional_parthian}', "");
    Expect(1, 68447, '\P{^-inscriptional_parthian}', "");
    Expect(0, 68448, '\p{-inscriptional_parthian}', "");
    Expect(1, 68448, '\p{^-inscriptional_parthian}', "");
    Expect(1, 68448, '\P{-inscriptional_parthian}', "");
    Expect(0, 68448, '\P{^-inscriptional_parthian}', "");
    Error('\p{ Is_Inscriptional_parthian:=}');
    Error('\P{ Is_Inscriptional_parthian:=}');
    Expect(1, 68447, '\p{isinscriptionalparthian}', "");
    Expect(0, 68447, '\p{^isinscriptionalparthian}', "");
    Expect(0, 68447, '\P{isinscriptionalparthian}', "");
    Expect(1, 68447, '\P{^isinscriptionalparthian}', "");
    Expect(0, 68448, '\p{isinscriptionalparthian}', "");
    Expect(1, 68448, '\p{^isinscriptionalparthian}', "");
    Expect(1, 68448, '\P{isinscriptionalparthian}', "");
    Expect(0, 68448, '\P{^isinscriptionalparthian}', "");
    Expect(1, 68447, '\p{- Is_inscriptional_PARTHIAN}', "");
    Expect(0, 68447, '\p{^- Is_inscriptional_PARTHIAN}', "");
    Expect(0, 68447, '\P{- Is_inscriptional_PARTHIAN}', "");
    Expect(1, 68447, '\P{^- Is_inscriptional_PARTHIAN}', "");
    Expect(0, 68448, '\p{- Is_inscriptional_PARTHIAN}', "");
    Expect(1, 68448, '\p{^- Is_inscriptional_PARTHIAN}', "");
    Expect(1, 68448, '\P{- Is_inscriptional_PARTHIAN}', "");
    Expect(0, 68448, '\P{^- Is_inscriptional_PARTHIAN}', "");
    Error('\p{/a/-_Prti}');
    Error('\P{/a/-_Prti}');
    Expect(1, 68447, '\p{prti}', "");
    Expect(0, 68447, '\p{^prti}', "");
    Expect(0, 68447, '\P{prti}', "");
    Expect(1, 68447, '\P{^prti}', "");
    Expect(0, 68448, '\p{prti}', "");
    Expect(1, 68448, '\p{^prti}', "");
    Expect(1, 68448, '\P{prti}', "");
    Expect(0, 68448, '\P{^prti}', "");
    Expect(1, 68447, '\p{Prti}', "");
    Expect(0, 68447, '\p{^Prti}', "");
    Expect(0, 68447, '\P{Prti}', "");
    Expect(1, 68447, '\P{^Prti}', "");
    Expect(0, 68448, '\p{Prti}', "");
    Expect(1, 68448, '\p{^Prti}', "");
    Expect(1, 68448, '\P{Prti}', "");
    Expect(0, 68448, '\P{^Prti}', "");
    Error('\p{_IS_prti:=}');
    Error('\P{_IS_prti:=}');
    Expect(1, 68447, '\p{isprti}', "");
    Expect(0, 68447, '\p{^isprti}', "");
    Expect(0, 68447, '\P{isprti}', "");
    Expect(1, 68447, '\P{^isprti}', "");
    Expect(0, 68448, '\p{isprti}', "");
    Expect(1, 68448, '\p{^isprti}', "");
    Expect(1, 68448, '\P{isprti}', "");
    Expect(0, 68448, '\P{^isprti}', "");
    Expect(1, 68447, '\p{	is_PRTI}', "");
    Expect(0, 68447, '\p{^	is_PRTI}', "");
    Expect(0, 68447, '\P{	is_PRTI}', "");
    Expect(1, 68447, '\P{^	is_PRTI}', "");
    Expect(0, 68448, '\p{	is_PRTI}', "");
    Expect(1, 68448, '\p{^	is_PRTI}', "");
    Expect(1, 68448, '\P{	is_PRTI}', "");
    Expect(0, 68448, '\P{^	is_PRTI}', "");
    Error('\p{ /a/IPA_Extensions}');
    Error('\P{ /a/IPA_Extensions}');
    Expect(1, 687, '\p{ipaextensions}', "");
    Expect(0, 687, '\p{^ipaextensions}', "");
    Expect(0, 687, '\P{ipaextensions}', "");
    Expect(1, 687, '\P{^ipaextensions}', "");
    Expect(0, 688, '\p{ipaextensions}', "");
    Expect(1, 688, '\p{^ipaextensions}', "");
    Expect(1, 688, '\P{ipaextensions}', "");
    Expect(0, 688, '\P{^ipaextensions}', "");
    Expect(1, 687, '\p{	 IPA_Extensions}', "");
    Expect(0, 687, '\p{^	 IPA_Extensions}', "");
    Expect(0, 687, '\P{	 IPA_Extensions}', "");
    Expect(1, 687, '\P{^	 IPA_Extensions}', "");
    Expect(0, 688, '\p{	 IPA_Extensions}', "");
    Expect(1, 688, '\p{^	 IPA_Extensions}', "");
    Expect(1, 688, '\P{	 IPA_Extensions}', "");
    Expect(0, 688, '\P{^	 IPA_Extensions}', "");
    Error('\p{/a/	IS_IPA_extensions}');
    Error('\P{/a/	IS_IPA_extensions}');
    Expect(1, 687, '\p{isipaextensions}', "");
    Expect(0, 687, '\p{^isipaextensions}', "");
    Expect(0, 687, '\P{isipaextensions}', "");
    Expect(1, 687, '\P{^isipaextensions}', "");
    Expect(0, 688, '\p{isipaextensions}', "");
    Expect(1, 688, '\p{^isipaextensions}', "");
    Expect(1, 688, '\P{isipaextensions}', "");
    Expect(0, 688, '\P{^isipaextensions}', "");
    Expect(1, 687, '\p{ _Is_IPA_EXTENSIONS}', "");
    Expect(0, 687, '\p{^ _Is_IPA_EXTENSIONS}', "");
    Expect(0, 687, '\P{ _Is_IPA_EXTENSIONS}', "");
    Expect(1, 687, '\P{^ _Is_IPA_EXTENSIONS}', "");
    Expect(0, 688, '\p{ _Is_IPA_EXTENSIONS}', "");
    Expect(1, 688, '\p{^ _Is_IPA_EXTENSIONS}', "");
    Expect(1, 688, '\P{ _Is_IPA_EXTENSIONS}', "");
    Expect(0, 688, '\P{^ _Is_IPA_EXTENSIONS}', "");
    Error('\p{	 in_IPA_extensions:=}');
    Error('\P{	 in_IPA_extensions:=}');
    Expect(1, 687, '\p{inipaextensions}', "");
    Expect(0, 687, '\p{^inipaextensions}', "");
    Expect(0, 687, '\P{inipaextensions}', "");
    Expect(1, 687, '\P{^inipaextensions}', "");
    Expect(0, 688, '\p{inipaextensions}', "");
    Expect(1, 688, '\p{^inipaextensions}', "");
    Expect(1, 688, '\P{inipaextensions}', "");
    Expect(0, 688, '\P{^inipaextensions}', "");
    Expect(1, 687, '\p{	-In_ipa_extensions}', "");
    Expect(0, 687, '\p{^	-In_ipa_extensions}', "");
    Expect(0, 687, '\P{	-In_ipa_extensions}', "");
    Expect(1, 687, '\P{^	-In_ipa_extensions}', "");
    Expect(0, 688, '\p{	-In_ipa_extensions}', "");
    Expect(1, 688, '\p{^	-In_ipa_extensions}', "");
    Expect(1, 688, '\P{	-In_ipa_extensions}', "");
    Expect(0, 688, '\P{^	-In_ipa_extensions}', "");
    Error('\p{/a/_ipa_ext}');
    Error('\P{/a/_ipa_ext}');
    Expect(1, 687, '\p{ipaext}', "");
    Expect(0, 687, '\p{^ipaext}', "");
    Expect(0, 687, '\P{ipaext}', "");
    Expect(1, 687, '\P{^ipaext}', "");
    Expect(0, 688, '\p{ipaext}', "");
    Expect(1, 688, '\p{^ipaext}', "");
    Expect(1, 688, '\P{ipaext}', "");
    Expect(0, 688, '\P{^ipaext}', "");
    Expect(1, 687, '\p{_IPA_EXT}', "");
    Expect(0, 687, '\p{^_IPA_EXT}', "");
    Expect(0, 687, '\P{_IPA_EXT}', "");
    Expect(1, 687, '\P{^_IPA_EXT}', "");
    Expect(0, 688, '\p{_IPA_EXT}', "");
    Expect(1, 688, '\p{^_IPA_EXT}', "");
    Expect(1, 688, '\P{_IPA_EXT}', "");
    Expect(0, 688, '\P{^_IPA_EXT}', "");
    Error('\p{ Is_IPA_EXT/a/}');
    Error('\P{ Is_IPA_EXT/a/}');
    Expect(1, 687, '\p{isipaext}', "");
    Expect(0, 687, '\p{^isipaext}', "");
    Expect(0, 687, '\P{isipaext}', "");
    Expect(1, 687, '\P{^isipaext}', "");
    Expect(0, 688, '\p{isipaext}', "");
    Expect(1, 688, '\p{^isipaext}', "");
    Expect(1, 688, '\P{isipaext}', "");
    Expect(0, 688, '\P{^isipaext}', "");
    Expect(1, 687, '\p{	_IS_IPA_Ext}', "");
    Expect(0, 687, '\p{^	_IS_IPA_Ext}', "");
    Expect(0, 687, '\P{	_IS_IPA_Ext}', "");
    Expect(1, 687, '\P{^	_IS_IPA_Ext}', "");
    Expect(0, 688, '\p{	_IS_IPA_Ext}', "");
    Expect(1, 688, '\p{^	_IS_IPA_Ext}', "");
    Expect(1, 688, '\P{	_IS_IPA_Ext}', "");
    Expect(0, 688, '\P{^	_IS_IPA_Ext}', "");
    Error('\p{-	In_IPA_EXT/a/}');
    Error('\P{-	In_IPA_EXT/a/}');
    Expect(1, 687, '\p{inipaext}', "");
    Expect(0, 687, '\p{^inipaext}', "");
    Expect(0, 687, '\P{inipaext}', "");
    Expect(1, 687, '\P{^inipaext}', "");
    Expect(0, 688, '\p{inipaext}', "");
    Expect(1, 688, '\p{^inipaext}', "");
    Expect(1, 688, '\P{inipaext}', "");
    Expect(0, 688, '\P{^inipaext}', "");
    Expect(1, 687, '\p{-In_ipa_Ext}', "");
    Expect(0, 687, '\p{^-In_ipa_Ext}', "");
    Expect(0, 687, '\P{-In_ipa_Ext}', "");
    Expect(1, 687, '\P{^-In_ipa_Ext}', "");
    Expect(0, 688, '\p{-In_ipa_Ext}', "");
    Expect(1, 688, '\p{^-In_ipa_Ext}', "");
    Expect(1, 688, '\P{-In_ipa_Ext}', "");
    Expect(0, 688, '\P{^-In_ipa_Ext}', "");
    Error('\p{:=-Javanese}');
    Error('\P{:=-Javanese}');
    Expect(1, 43487, '\p{javanese}', "");
    Expect(0, 43487, '\p{^javanese}', "");
    Expect(0, 43487, '\P{javanese}', "");
    Expect(1, 43487, '\P{^javanese}', "");
    Expect(0, 43488, '\p{javanese}', "");
    Expect(1, 43488, '\p{^javanese}', "");
    Expect(1, 43488, '\P{javanese}', "");
    Expect(0, 43488, '\P{^javanese}', "");
    Expect(1, 43487, '\p{ Javanese}', "");
    Expect(0, 43487, '\p{^ Javanese}', "");
    Expect(0, 43487, '\P{ Javanese}', "");
    Expect(1, 43487, '\P{^ Javanese}', "");
    Expect(0, 43488, '\p{ Javanese}', "");
    Expect(1, 43488, '\p{^ Javanese}', "");
    Expect(1, 43488, '\P{ Javanese}', "");
    Expect(0, 43488, '\P{^ Javanese}', "");
    Error('\p{	:=Is_javanese}');
    Error('\P{	:=Is_javanese}');
    Expect(1, 43487, '\p{isjavanese}', "");
    Expect(0, 43487, '\p{^isjavanese}', "");
    Expect(0, 43487, '\P{isjavanese}', "");
    Expect(1, 43487, '\P{^isjavanese}', "");
    Expect(0, 43488, '\p{isjavanese}', "");
    Expect(1, 43488, '\p{^isjavanese}', "");
    Expect(1, 43488, '\P{isjavanese}', "");
    Expect(0, 43488, '\P{^isjavanese}', "");
    Expect(1, 43487, '\p{ Is_Javanese}', "");
    Expect(0, 43487, '\p{^ Is_Javanese}', "");
    Expect(0, 43487, '\P{ Is_Javanese}', "");
    Expect(1, 43487, '\P{^ Is_Javanese}', "");
    Expect(0, 43488, '\p{ Is_Javanese}', "");
    Expect(1, 43488, '\p{^ Is_Javanese}', "");
    Expect(1, 43488, '\P{ Is_Javanese}', "");
    Expect(0, 43488, '\P{^ Is_Javanese}', "");
    Error('\p{	 Java:=}');
    Error('\P{	 Java:=}');
    Expect(1, 43487, '\p{java}', "");
    Expect(0, 43487, '\p{^java}', "");
    Expect(0, 43487, '\P{java}', "");
    Expect(1, 43487, '\P{^java}', "");
    Expect(0, 43488, '\p{java}', "");
    Expect(1, 43488, '\p{^java}', "");
    Expect(1, 43488, '\P{java}', "");
    Expect(0, 43488, '\P{^java}', "");
    Expect(1, 43487, '\p{	_JAVA}', "");
    Expect(0, 43487, '\p{^	_JAVA}', "");
    Expect(0, 43487, '\P{	_JAVA}', "");
    Expect(1, 43487, '\P{^	_JAVA}', "");
    Expect(0, 43488, '\p{	_JAVA}', "");
    Expect(1, 43488, '\p{^	_JAVA}', "");
    Expect(1, 43488, '\P{	_JAVA}', "");
    Expect(0, 43488, '\P{^	_JAVA}', "");
    Error('\p{/a/_is_JAVA}');
    Error('\P{/a/_is_JAVA}');
    Expect(1, 43487, '\p{isjava}', "");
    Expect(0, 43487, '\p{^isjava}', "");
    Expect(0, 43487, '\P{isjava}', "");
    Expect(1, 43487, '\P{^isjava}', "");
    Expect(0, 43488, '\p{isjava}', "");
    Expect(1, 43488, '\p{^isjava}', "");
    Expect(1, 43488, '\P{isjava}', "");
    Expect(0, 43488, '\P{^isjava}', "");
    Expect(1, 43487, '\p{_-Is_Java}', "");
    Expect(0, 43487, '\p{^_-Is_Java}', "");
    Expect(0, 43487, '\P{_-Is_Java}', "");
    Expect(1, 43487, '\P{^_-Is_Java}', "");
    Expect(0, 43488, '\p{_-Is_Java}', "");
    Expect(1, 43488, '\p{^_-Is_Java}', "");
    Expect(1, 43488, '\P{_-Is_Java}', "");
    Expect(0, 43488, '\P{^_-Is_Java}', "");
    Error('\p{  Join_CONTROL:=}');
    Error('\P{  Join_CONTROL:=}');
    Expect(1, 8205, '\p{joincontrol}', "");
    Expect(0, 8205, '\p{^joincontrol}', "");
    Expect(0, 8205, '\P{joincontrol}', "");
    Expect(1, 8205, '\P{^joincontrol}', "");
    Expect(0, 8206, '\p{joincontrol}', "");
    Expect(1, 8206, '\p{^joincontrol}', "");
    Expect(1, 8206, '\P{joincontrol}', "");
    Expect(0, 8206, '\P{^joincontrol}', "");
    Expect(1, 8205, '\p{	Join_Control}', "");
    Expect(0, 8205, '\p{^	Join_Control}', "");
    Expect(0, 8205, '\P{	Join_Control}', "");
    Expect(1, 8205, '\P{^	Join_Control}', "");
    Expect(0, 8206, '\p{	Join_Control}', "");
    Expect(1, 8206, '\p{^	Join_Control}', "");
    Expect(1, 8206, '\P{	Join_Control}', "");
    Expect(0, 8206, '\P{^	Join_Control}', "");
    Error('\p{- is_JOIN_control:=}');
    Error('\P{- is_JOIN_control:=}');
    Expect(1, 8205, '\p{isjoincontrol}', "");
    Expect(0, 8205, '\p{^isjoincontrol}', "");
    Expect(0, 8205, '\P{isjoincontrol}', "");
    Expect(1, 8205, '\P{^isjoincontrol}', "");
    Expect(0, 8206, '\p{isjoincontrol}', "");
    Expect(1, 8206, '\p{^isjoincontrol}', "");
    Expect(1, 8206, '\P{isjoincontrol}', "");
    Expect(0, 8206, '\P{^isjoincontrol}', "");
    Expect(1, 8205, '\p{	Is_Join_Control}', "");
    Expect(0, 8205, '\p{^	Is_Join_Control}', "");
    Expect(0, 8205, '\P{	Is_Join_Control}', "");
    Expect(1, 8205, '\P{^	Is_Join_Control}', "");
    Expect(0, 8206, '\p{	Is_Join_Control}', "");
    Expect(1, 8206, '\p{^	Is_Join_Control}', "");
    Expect(1, 8206, '\P{	Is_Join_Control}', "");
    Expect(0, 8206, '\P{^	Is_Join_Control}', "");
    Error('\p{-/a/join_c}');
    Error('\P{-/a/join_c}');
    Expect(1, 8205, '\p{joinc}', "");
    Expect(0, 8205, '\p{^joinc}', "");
    Expect(0, 8205, '\P{joinc}', "");
    Expect(1, 8205, '\P{^joinc}', "");
    Expect(0, 8206, '\p{joinc}', "");
    Expect(1, 8206, '\p{^joinc}', "");
    Expect(1, 8206, '\P{joinc}', "");
    Expect(0, 8206, '\P{^joinc}', "");
    Expect(1, 8205, '\p{_JOIN_C}', "");
    Expect(0, 8205, '\p{^_JOIN_C}', "");
    Expect(0, 8205, '\P{_JOIN_C}', "");
    Expect(1, 8205, '\P{^_JOIN_C}', "");
    Expect(0, 8206, '\p{_JOIN_C}', "");
    Expect(1, 8206, '\p{^_JOIN_C}', "");
    Expect(1, 8206, '\P{_JOIN_C}', "");
    Expect(0, 8206, '\P{^_JOIN_C}', "");
    Error('\p{- Is_Join_C:=}');
    Error('\P{- Is_Join_C:=}');
    Expect(1, 8205, '\p{isjoinc}', "");
    Expect(0, 8205, '\p{^isjoinc}', "");
    Expect(0, 8205, '\P{isjoinc}', "");
    Expect(1, 8205, '\P{^isjoinc}', "");
    Expect(0, 8206, '\p{isjoinc}', "");
    Expect(1, 8206, '\p{^isjoinc}', "");
    Expect(1, 8206, '\P{isjoinc}', "");
    Expect(0, 8206, '\P{^isjoinc}', "");
    Expect(1, 8205, '\p{Is_JOIN_C}', "");
    Expect(0, 8205, '\p{^Is_JOIN_C}', "");
    Expect(0, 8205, '\P{Is_JOIN_C}', "");
    Expect(1, 8205, '\P{^Is_JOIN_C}', "");
    Expect(0, 8206, '\p{Is_JOIN_C}', "");
    Expect(1, 8206, '\p{^Is_JOIN_C}', "");
    Expect(1, 8206, '\P{Is_JOIN_C}', "");
    Expect(0, 8206, '\P{^Is_JOIN_C}', "");
    Error('\p{/a/-Kaithi}');
    Error('\P{/a/-Kaithi}');
    Expect(1, 69837, '\p{kaithi}', "");
    Expect(0, 69837, '\p{^kaithi}', "");
    Expect(0, 69837, '\P{kaithi}', "");
    Expect(1, 69837, '\P{^kaithi}', "");
    Expect(0, 69838, '\p{kaithi}', "");
    Expect(1, 69838, '\p{^kaithi}', "");
    Expect(1, 69838, '\P{kaithi}', "");
    Expect(0, 69838, '\P{^kaithi}', "");
    Expect(1, 69837, '\p{  kaithi}', "");
    Expect(0, 69837, '\p{^  kaithi}', "");
    Expect(0, 69837, '\P{  kaithi}', "");
    Expect(1, 69837, '\P{^  kaithi}', "");
    Expect(0, 69838, '\p{  kaithi}', "");
    Expect(1, 69838, '\p{^  kaithi}', "");
    Expect(1, 69838, '\P{  kaithi}', "");
    Expect(0, 69838, '\P{^  kaithi}', "");
    Error('\p{  Is_KAITHI/a/}');
    Error('\P{  Is_KAITHI/a/}');
    Expect(1, 69837, '\p{iskaithi}', "");
    Expect(0, 69837, '\p{^iskaithi}', "");
    Expect(0, 69837, '\P{iskaithi}', "");
    Expect(1, 69837, '\P{^iskaithi}', "");
    Expect(0, 69838, '\p{iskaithi}', "");
    Expect(1, 69838, '\p{^iskaithi}', "");
    Expect(1, 69838, '\P{iskaithi}', "");
    Expect(0, 69838, '\P{^iskaithi}', "");
    Expect(1, 69837, '\p{ _IS_KAITHI}', "");
    Expect(0, 69837, '\p{^ _IS_KAITHI}', "");
    Expect(0, 69837, '\P{ _IS_KAITHI}', "");
    Expect(1, 69837, '\P{^ _IS_KAITHI}', "");
    Expect(0, 69838, '\p{ _IS_KAITHI}', "");
    Expect(1, 69838, '\p{^ _IS_KAITHI}', "");
    Expect(1, 69838, '\P{ _IS_KAITHI}', "");
    Expect(0, 69838, '\P{^ _IS_KAITHI}', "");
    Error('\p{/a/-Kthi}');
    Error('\P{/a/-Kthi}');
    Expect(1, 69837, '\p{kthi}', "");
    Expect(0, 69837, '\p{^kthi}', "");
    Expect(0, 69837, '\P{kthi}', "");
    Expect(1, 69837, '\P{^kthi}', "");
    Expect(0, 69838, '\p{kthi}', "");
    Expect(1, 69838, '\p{^kthi}', "");
    Expect(1, 69838, '\P{kthi}', "");
    Expect(0, 69838, '\P{^kthi}', "");
    Expect(1, 69837, '\p{-	Kthi}', "");
    Expect(0, 69837, '\p{^-	Kthi}', "");
    Expect(0, 69837, '\P{-	Kthi}', "");
    Expect(1, 69837, '\P{^-	Kthi}', "");
    Expect(0, 69838, '\p{-	Kthi}', "");
    Expect(1, 69838, '\p{^-	Kthi}', "");
    Expect(1, 69838, '\P{-	Kthi}', "");
    Expect(0, 69838, '\P{^-	Kthi}', "");
    Error('\p{_/a/Is_kthi}');
    Error('\P{_/a/Is_kthi}');
    Expect(1, 69837, '\p{iskthi}', "");
    Expect(0, 69837, '\p{^iskthi}', "");
    Expect(0, 69837, '\P{iskthi}', "");
    Expect(1, 69837, '\P{^iskthi}', "");
    Expect(0, 69838, '\p{iskthi}', "");
    Expect(1, 69838, '\p{^iskthi}', "");
    Expect(1, 69838, '\P{iskthi}', "");
    Expect(0, 69838, '\P{^iskthi}', "");
    Expect(1, 69837, '\p{		Is_Kthi}', "");
    Expect(0, 69837, '\p{^		Is_Kthi}', "");
    Expect(0, 69837, '\P{		Is_Kthi}', "");
    Expect(1, 69837, '\P{^		Is_Kthi}', "");
    Expect(0, 69838, '\p{		Is_Kthi}', "");
    Expect(1, 69838, '\p{^		Is_Kthi}', "");
    Expect(1, 69838, '\P{		Is_Kthi}', "");
    Expect(0, 69838, '\P{^		Is_Kthi}', "");
    Error('\p{		Kana_extended_A/a/}');
    Error('\P{		Kana_extended_A/a/}');
    Expect(1, 110895, '\p{kanaextendeda}', "");
    Expect(0, 110895, '\p{^kanaextendeda}', "");
    Expect(0, 110895, '\P{kanaextendeda}', "");
    Expect(1, 110895, '\P{^kanaextendeda}', "");
    Expect(0, 110896, '\p{kanaextendeda}', "");
    Expect(1, 110896, '\p{^kanaextendeda}', "");
    Expect(1, 110896, '\P{kanaextendeda}', "");
    Expect(0, 110896, '\P{^kanaextendeda}', "");
    Expect(1, 110895, '\p{kana_Extended_A}', "");
    Expect(0, 110895, '\p{^kana_Extended_A}', "");
    Expect(0, 110895, '\P{kana_Extended_A}', "");
    Expect(1, 110895, '\P{^kana_Extended_A}', "");
    Expect(0, 110896, '\p{kana_Extended_A}', "");
    Expect(1, 110896, '\p{^kana_Extended_A}', "");
    Expect(1, 110896, '\P{kana_Extended_A}', "");
    Expect(0, 110896, '\P{^kana_Extended_A}', "");
    Error('\p{ /a/IS_Kana_EXTENDED_A}');
    Error('\P{ /a/IS_Kana_EXTENDED_A}');
    Expect(1, 110895, '\p{iskanaextendeda}', "");
    Expect(0, 110895, '\p{^iskanaextendeda}', "");
    Expect(0, 110895, '\P{iskanaextendeda}', "");
    Expect(1, 110895, '\P{^iskanaextendeda}', "");
    Expect(0, 110896, '\p{iskanaextendeda}', "");
    Expect(1, 110896, '\p{^iskanaextendeda}', "");
    Expect(1, 110896, '\P{iskanaextendeda}', "");
    Expect(0, 110896, '\P{^iskanaextendeda}', "");
    Expect(1, 110895, '\p{ is_kana_extended_A}', "");
    Expect(0, 110895, '\p{^ is_kana_extended_A}', "");
    Expect(0, 110895, '\P{ is_kana_extended_A}', "");
    Expect(1, 110895, '\P{^ is_kana_extended_A}', "");
    Expect(0, 110896, '\p{ is_kana_extended_A}', "");
    Expect(1, 110896, '\p{^ is_kana_extended_A}', "");
    Expect(1, 110896, '\P{ is_kana_extended_A}', "");
    Expect(0, 110896, '\P{^ is_kana_extended_A}', "");
    Error('\p{ /a/In_KANA_Extended_a}');
    Error('\P{ /a/In_KANA_Extended_a}');
    Expect(1, 110895, '\p{inkanaextendeda}', "");
    Expect(0, 110895, '\p{^inkanaextendeda}', "");
    Expect(0, 110895, '\P{inkanaextendeda}', "");
    Expect(1, 110895, '\P{^inkanaextendeda}', "");
    Expect(0, 110896, '\p{inkanaextendeda}', "");
    Expect(1, 110896, '\p{^inkanaextendeda}', "");
    Expect(1, 110896, '\P{inkanaextendeda}', "");
    Expect(0, 110896, '\P{^inkanaextendeda}', "");
    Expect(1, 110895, '\p{-	In_kana_Extended_a}', "");
    Expect(0, 110895, '\p{^-	In_kana_Extended_a}', "");
    Expect(0, 110895, '\P{-	In_kana_Extended_a}', "");
    Expect(1, 110895, '\P{^-	In_kana_Extended_a}', "");
    Expect(0, 110896, '\p{-	In_kana_Extended_a}', "");
    Expect(1, 110896, '\p{^-	In_kana_Extended_a}', "");
    Expect(1, 110896, '\P{-	In_kana_Extended_a}', "");
    Expect(0, 110896, '\P{^-	In_kana_Extended_a}', "");
    Error('\p{-_Kana_EXT_A/a/}');
    Error('\P{-_Kana_EXT_A/a/}');
    Expect(1, 110895, '\p{kanaexta}', "");
    Expect(0, 110895, '\p{^kanaexta}', "");
    Expect(0, 110895, '\P{kanaexta}', "");
    Expect(1, 110895, '\P{^kanaexta}', "");
    Expect(0, 110896, '\p{kanaexta}', "");
    Expect(1, 110896, '\p{^kanaexta}', "");
    Expect(1, 110896, '\P{kanaexta}', "");
    Expect(0, 110896, '\P{^kanaexta}', "");
    Expect(1, 110895, '\p{- Kana_Ext_A}', "");
    Expect(0, 110895, '\p{^- Kana_Ext_A}', "");
    Expect(0, 110895, '\P{- Kana_Ext_A}', "");
    Expect(1, 110895, '\P{^- Kana_Ext_A}', "");
    Expect(0, 110896, '\p{- Kana_Ext_A}', "");
    Expect(1, 110896, '\p{^- Kana_Ext_A}', "");
    Expect(1, 110896, '\P{- Kana_Ext_A}', "");
    Expect(0, 110896, '\P{^- Kana_Ext_A}', "");
    Error('\p{/a/__Is_Kana_ext_A}');
    Error('\P{/a/__Is_Kana_ext_A}');
    Expect(1, 110895, '\p{iskanaexta}', "");
    Expect(0, 110895, '\p{^iskanaexta}', "");
    Expect(0, 110895, '\P{iskanaexta}', "");
    Expect(1, 110895, '\P{^iskanaexta}', "");
    Expect(0, 110896, '\p{iskanaexta}', "");
    Expect(1, 110896, '\p{^iskanaexta}', "");
    Expect(1, 110896, '\P{iskanaexta}', "");
    Expect(0, 110896, '\P{^iskanaexta}', "");
    Expect(1, 110895, '\p{-Is_Kana_ext_a}', "");
    Expect(0, 110895, '\p{^-Is_Kana_ext_a}', "");
    Expect(0, 110895, '\P{-Is_Kana_ext_a}', "");
    Expect(1, 110895, '\P{^-Is_Kana_ext_a}', "");
    Expect(0, 110896, '\p{-Is_Kana_ext_a}', "");
    Expect(1, 110896, '\p{^-Is_Kana_ext_a}', "");
    Expect(1, 110896, '\P{-Is_Kana_ext_a}', "");
    Expect(0, 110896, '\P{^-Is_Kana_ext_a}', "");
    Error('\p{_/a/IN_kana_Ext_A}');
    Error('\P{_/a/IN_kana_Ext_A}');
    Expect(1, 110895, '\p{inkanaexta}', "");
    Expect(0, 110895, '\p{^inkanaexta}', "");
    Expect(0, 110895, '\P{inkanaexta}', "");
    Expect(1, 110895, '\P{^inkanaexta}', "");
    Expect(0, 110896, '\p{inkanaexta}', "");
    Expect(1, 110896, '\p{^inkanaexta}', "");
    Expect(1, 110896, '\P{inkanaexta}', "");
    Expect(0, 110896, '\P{^inkanaexta}', "");
    Expect(1, 110895, '\p{_In_kana_EXT_A}', "");
    Expect(0, 110895, '\p{^_In_kana_EXT_A}', "");
    Expect(0, 110895, '\P{_In_kana_EXT_A}', "");
    Expect(1, 110895, '\P{^_In_kana_EXT_A}', "");
    Expect(0, 110896, '\p{_In_kana_EXT_A}', "");
    Expect(1, 110896, '\p{^_In_kana_EXT_A}', "");
    Expect(1, 110896, '\P{_In_kana_EXT_A}', "");
    Expect(0, 110896, '\P{^_In_kana_EXT_A}', "");
    Error('\p{	KANA_supplement:=}');
    Error('\P{	KANA_supplement:=}');
    Expect(1, 110847, '\p{kanasupplement}', "");
    Expect(0, 110847, '\p{^kanasupplement}', "");
    Expect(0, 110847, '\P{kanasupplement}', "");
    Expect(1, 110847, '\P{^kanasupplement}', "");
    Expect(0, 110848, '\p{kanasupplement}', "");
    Expect(1, 110848, '\p{^kanasupplement}', "");
    Expect(1, 110848, '\P{kanasupplement}', "");
    Expect(0, 110848, '\P{^kanasupplement}', "");
    Expect(1, 110847, '\p{  Kana_supplement}', "");
    Expect(0, 110847, '\p{^  Kana_supplement}', "");
    Expect(0, 110847, '\P{  Kana_supplement}', "");
    Expect(1, 110847, '\P{^  Kana_supplement}', "");
    Expect(0, 110848, '\p{  Kana_supplement}', "");
    Expect(1, 110848, '\p{^  Kana_supplement}', "");
    Expect(1, 110848, '\P{  Kana_supplement}', "");
    Expect(0, 110848, '\P{^  Kana_supplement}', "");
    Error('\p{-Is_KANA_SUPPLEMENT/a/}');
    Error('\P{-Is_KANA_SUPPLEMENT/a/}');
    Expect(1, 110847, '\p{iskanasupplement}', "");
    Expect(0, 110847, '\p{^iskanasupplement}', "");
    Expect(0, 110847, '\P{iskanasupplement}', "");
    Expect(1, 110847, '\P{^iskanasupplement}', "");
    Expect(0, 110848, '\p{iskanasupplement}', "");
    Expect(1, 110848, '\p{^iskanasupplement}', "");
    Expect(1, 110848, '\P{iskanasupplement}', "");
    Expect(0, 110848, '\P{^iskanasupplement}', "");
    Expect(1, 110847, '\p{-_Is_KANA_supplement}', "");
    Expect(0, 110847, '\p{^-_Is_KANA_supplement}', "");
    Expect(0, 110847, '\P{-_Is_KANA_supplement}', "");
    Expect(1, 110847, '\P{^-_Is_KANA_supplement}', "");
    Expect(0, 110848, '\p{-_Is_KANA_supplement}', "");
    Expect(1, 110848, '\p{^-_Is_KANA_supplement}', "");
    Expect(1, 110848, '\P{-_Is_KANA_supplement}', "");
    Expect(0, 110848, '\P{^-_Is_KANA_supplement}', "");
    Error('\p{-/a/In_kana_SUPPLEMENT}');
    Error('\P{-/a/In_kana_SUPPLEMENT}');
    Expect(1, 110847, '\p{inkanasupplement}', "");
    Expect(0, 110847, '\p{^inkanasupplement}', "");
    Expect(0, 110847, '\P{inkanasupplement}', "");
    Expect(1, 110847, '\P{^inkanasupplement}', "");
    Expect(0, 110848, '\p{inkanasupplement}', "");
    Expect(1, 110848, '\p{^inkanasupplement}', "");
    Expect(1, 110848, '\P{inkanasupplement}', "");
    Expect(0, 110848, '\P{^inkanasupplement}', "");
    Expect(1, 110847, '\p{ In_KANA_SUPPLEMENT}', "");
    Expect(0, 110847, '\p{^ In_KANA_SUPPLEMENT}', "");
    Expect(0, 110847, '\P{ In_KANA_SUPPLEMENT}', "");
    Expect(1, 110847, '\P{^ In_KANA_SUPPLEMENT}', "");
    Expect(0, 110848, '\p{ In_KANA_SUPPLEMENT}', "");
    Expect(1, 110848, '\p{^ In_KANA_SUPPLEMENT}', "");
    Expect(1, 110848, '\P{ In_KANA_SUPPLEMENT}', "");
    Expect(0, 110848, '\P{^ In_KANA_SUPPLEMENT}', "");
    Error('\p{	:=Kana_Sup}');
    Error('\P{	:=Kana_Sup}');
    Expect(1, 110847, '\p{kanasup}', "");
    Expect(0, 110847, '\p{^kanasup}', "");
    Expect(0, 110847, '\P{kanasup}', "");
    Expect(1, 110847, '\P{^kanasup}', "");
    Expect(0, 110848, '\p{kanasup}', "");
    Expect(1, 110848, '\p{^kanasup}', "");
    Expect(1, 110848, '\P{kanasup}', "");
    Expect(0, 110848, '\P{^kanasup}', "");
    Expect(1, 110847, '\p{_Kana_sup}', "");
    Expect(0, 110847, '\p{^_Kana_sup}', "");
    Expect(0, 110847, '\P{_Kana_sup}', "");
    Expect(1, 110847, '\P{^_Kana_sup}', "");
    Expect(0, 110848, '\p{_Kana_sup}', "");
    Expect(1, 110848, '\p{^_Kana_sup}', "");
    Expect(1, 110848, '\P{_Kana_sup}', "");
    Expect(0, 110848, '\P{^_Kana_sup}', "");
    Error('\p{	:=Is_Kana_sup}');
    Error('\P{	:=Is_Kana_sup}');
    Expect(1, 110847, '\p{iskanasup}', "");
    Expect(0, 110847, '\p{^iskanasup}', "");
    Expect(0, 110847, '\P{iskanasup}', "");
    Expect(1, 110847, '\P{^iskanasup}', "");
    Expect(0, 110848, '\p{iskanasup}', "");
    Expect(1, 110848, '\p{^iskanasup}', "");
    Expect(1, 110848, '\P{iskanasup}', "");
    Expect(0, 110848, '\P{^iskanasup}', "");
    Expect(1, 110847, '\p{-_is_Kana_sup}', "");
    Expect(0, 110847, '\p{^-_is_Kana_sup}', "");
    Expect(0, 110847, '\P{-_is_Kana_sup}', "");
    Expect(1, 110847, '\P{^-_is_Kana_sup}', "");
    Expect(0, 110848, '\p{-_is_Kana_sup}', "");
    Expect(1, 110848, '\p{^-_is_Kana_sup}', "");
    Expect(1, 110848, '\P{-_is_Kana_sup}', "");
    Expect(0, 110848, '\P{^-_is_Kana_sup}', "");
    Error('\p{-IN_Kana_sup:=}');
    Error('\P{-IN_Kana_sup:=}');
    Expect(1, 110847, '\p{inkanasup}', "");
    Expect(0, 110847, '\p{^inkanasup}', "");
    Expect(0, 110847, '\P{inkanasup}', "");
    Expect(1, 110847, '\P{^inkanasup}', "");
    Expect(0, 110848, '\p{inkanasup}', "");
    Expect(1, 110848, '\p{^inkanasup}', "");
    Expect(1, 110848, '\P{inkanasup}', "");
    Expect(0, 110848, '\P{^inkanasup}', "");
    Expect(1, 110847, '\p{	 In_KANA_Sup}', "");
    Expect(0, 110847, '\p{^	 In_KANA_Sup}', "");
    Expect(0, 110847, '\P{	 In_KANA_Sup}', "");
    Expect(1, 110847, '\P{^	 In_KANA_Sup}', "");
    Expect(0, 110848, '\p{	 In_KANA_Sup}', "");
    Expect(1, 110848, '\p{^	 In_KANA_Sup}', "");
    Expect(1, 110848, '\P{	 In_KANA_Sup}', "");
    Expect(0, 110848, '\P{^	 In_KANA_Sup}', "");
    Error('\p{	:=Kanbun}');
    Error('\P{	:=Kanbun}');
    Expect(1, 12703, '\p{kanbun}', "");
    Expect(0, 12703, '\p{^kanbun}', "");
    Expect(0, 12703, '\P{kanbun}', "");
    Expect(1, 12703, '\P{^kanbun}', "");
    Expect(0, 12704, '\p{kanbun}', "");
    Expect(1, 12704, '\p{^kanbun}', "");
    Expect(1, 12704, '\P{kanbun}', "");
    Expect(0, 12704, '\P{^kanbun}', "");
    Expect(1, 12703, '\p{ -Kanbun}', "");
    Expect(0, 12703, '\p{^ -Kanbun}', "");
    Expect(0, 12703, '\P{ -Kanbun}', "");
    Expect(1, 12703, '\P{^ -Kanbun}', "");
    Expect(0, 12704, '\p{ -Kanbun}', "");
    Expect(1, 12704, '\p{^ -Kanbun}', "");
    Expect(1, 12704, '\P{ -Kanbun}', "");
    Expect(0, 12704, '\P{^ -Kanbun}', "");
    Error('\p{:= Is_Kanbun}');
    Error('\P{:= Is_Kanbun}');
    Expect(1, 12703, '\p{iskanbun}', "");
    Expect(0, 12703, '\p{^iskanbun}', "");
    Expect(0, 12703, '\P{iskanbun}', "");
    Expect(1, 12703, '\P{^iskanbun}', "");
    Expect(0, 12704, '\p{iskanbun}', "");
    Expect(1, 12704, '\p{^iskanbun}', "");
    Expect(1, 12704, '\P{iskanbun}', "");
    Expect(0, 12704, '\P{^iskanbun}', "");
    Expect(1, 12703, '\p{Is_kanbun}', "");
    Expect(0, 12703, '\p{^Is_kanbun}', "");
    Expect(0, 12703, '\P{Is_kanbun}', "");
    Expect(1, 12703, '\P{^Is_kanbun}', "");
    Expect(0, 12704, '\p{Is_kanbun}', "");
    Expect(1, 12704, '\p{^Is_kanbun}', "");
    Expect(1, 12704, '\P{Is_kanbun}', "");
    Expect(0, 12704, '\P{^Is_kanbun}', "");
    Error('\p{	in_Kanbun/a/}');
    Error('\P{	in_Kanbun/a/}');
    Expect(1, 12703, '\p{inkanbun}', "");
    Expect(0, 12703, '\p{^inkanbun}', "");
    Expect(0, 12703, '\P{inkanbun}', "");
    Expect(1, 12703, '\P{^inkanbun}', "");
    Expect(0, 12704, '\p{inkanbun}', "");
    Expect(1, 12704, '\p{^inkanbun}', "");
    Expect(1, 12704, '\P{inkanbun}', "");
    Expect(0, 12704, '\P{^inkanbun}', "");
    Expect(1, 12703, '\p{	IN_KANBUN}', "");
    Expect(0, 12703, '\p{^	IN_KANBUN}', "");
    Expect(0, 12703, '\P{	IN_KANBUN}', "");
    Expect(1, 12703, '\P{^	IN_KANBUN}', "");
    Expect(0, 12704, '\p{	IN_KANBUN}', "");
    Expect(1, 12704, '\p{^	IN_KANBUN}', "");
    Expect(1, 12704, '\P{	IN_KANBUN}', "");
    Expect(0, 12704, '\P{^	IN_KANBUN}', "");
    Error('\p{ 	Kangxi_RADICALS/a/}');
    Error('\P{ 	Kangxi_RADICALS/a/}');
    Expect(1, 12255, '\p{kangxiradicals}', "");
    Expect(0, 12255, '\p{^kangxiradicals}', "");
    Expect(0, 12255, '\P{kangxiradicals}', "");
    Expect(1, 12255, '\P{^kangxiradicals}', "");
    Expect(0, 12256, '\p{kangxiradicals}', "");
    Expect(1, 12256, '\p{^kangxiradicals}', "");
    Expect(1, 12256, '\P{kangxiradicals}', "");
    Expect(0, 12256, '\P{^kangxiradicals}', "");
    Expect(1, 12255, '\p{  Kangxi_RADICALS}', "");
    Expect(0, 12255, '\p{^  Kangxi_RADICALS}', "");
    Expect(0, 12255, '\P{  Kangxi_RADICALS}', "");
    Expect(1, 12255, '\P{^  Kangxi_RADICALS}', "");
    Expect(0, 12256, '\p{  Kangxi_RADICALS}', "");
    Expect(1, 12256, '\p{^  Kangxi_RADICALS}', "");
    Expect(1, 12256, '\P{  Kangxi_RADICALS}', "");
    Expect(0, 12256, '\P{^  Kangxi_RADICALS}', "");
    Error('\p{/a/ is_kangxi_radicals}');
    Error('\P{/a/ is_kangxi_radicals}');
    Expect(1, 12255, '\p{iskangxiradicals}', "");
    Expect(0, 12255, '\p{^iskangxiradicals}', "");
    Expect(0, 12255, '\P{iskangxiradicals}', "");
    Expect(1, 12255, '\P{^iskangxiradicals}', "");
    Expect(0, 12256, '\p{iskangxiradicals}', "");
    Expect(1, 12256, '\p{^iskangxiradicals}', "");
    Expect(1, 12256, '\P{iskangxiradicals}', "");
    Expect(0, 12256, '\P{^iskangxiradicals}', "");
    Expect(1, 12255, '\p{-	Is_KANGXI_Radicals}', "");
    Expect(0, 12255, '\p{^-	Is_KANGXI_Radicals}', "");
    Expect(0, 12255, '\P{-	Is_KANGXI_Radicals}', "");
    Expect(1, 12255, '\P{^-	Is_KANGXI_Radicals}', "");
    Expect(0, 12256, '\p{-	Is_KANGXI_Radicals}', "");
    Expect(1, 12256, '\p{^-	Is_KANGXI_Radicals}', "");
    Expect(1, 12256, '\P{-	Is_KANGXI_Radicals}', "");
    Expect(0, 12256, '\P{^-	Is_KANGXI_Radicals}', "");
    Error('\p{/a/--in_Kangxi_Radicals}');
    Error('\P{/a/--in_Kangxi_Radicals}');
    Expect(1, 12255, '\p{inkangxiradicals}', "");
    Expect(0, 12255, '\p{^inkangxiradicals}', "");
    Expect(0, 12255, '\P{inkangxiradicals}', "");
    Expect(1, 12255, '\P{^inkangxiradicals}', "");
    Expect(0, 12256, '\p{inkangxiradicals}', "");
    Expect(1, 12256, '\p{^inkangxiradicals}', "");
    Expect(1, 12256, '\P{inkangxiradicals}', "");
    Expect(0, 12256, '\P{^inkangxiradicals}', "");
    Expect(1, 12255, '\p{	In_KANGXI_RADICALS}', "");
    Expect(0, 12255, '\p{^	In_KANGXI_RADICALS}', "");
    Expect(0, 12255, '\P{	In_KANGXI_RADICALS}', "");
    Expect(1, 12255, '\P{^	In_KANGXI_RADICALS}', "");
    Expect(0, 12256, '\p{	In_KANGXI_RADICALS}', "");
    Expect(1, 12256, '\p{^	In_KANGXI_RADICALS}', "");
    Expect(1, 12256, '\P{	In_KANGXI_RADICALS}', "");
    Expect(0, 12256, '\P{^	In_KANGXI_RADICALS}', "");
    Error('\p{/a/-kangxi}');
    Error('\P{/a/-kangxi}');
    Expect(1, 12255, '\p{kangxi}', "");
    Expect(0, 12255, '\p{^kangxi}', "");
    Expect(0, 12255, '\P{kangxi}', "");
    Expect(1, 12255, '\P{^kangxi}', "");
    Expect(0, 12256, '\p{kangxi}', "");
    Expect(1, 12256, '\p{^kangxi}', "");
    Expect(1, 12256, '\P{kangxi}', "");
    Expect(0, 12256, '\P{^kangxi}', "");
    Expect(1, 12255, '\p{ kangxi}', "");
    Expect(0, 12255, '\p{^ kangxi}', "");
    Expect(0, 12255, '\P{ kangxi}', "");
    Expect(1, 12255, '\P{^ kangxi}', "");
    Expect(0, 12256, '\p{ kangxi}', "");
    Expect(1, 12256, '\p{^ kangxi}', "");
    Expect(1, 12256, '\P{ kangxi}', "");
    Expect(0, 12256, '\P{^ kangxi}', "");
    Error('\p{	:=IS_Kangxi}');
    Error('\P{	:=IS_Kangxi}');
    Expect(1, 12255, '\p{iskangxi}', "");
    Expect(0, 12255, '\p{^iskangxi}', "");
    Expect(0, 12255, '\P{iskangxi}', "");
    Expect(1, 12255, '\P{^iskangxi}', "");
    Expect(0, 12256, '\p{iskangxi}', "");
    Expect(1, 12256, '\p{^iskangxi}', "");
    Expect(1, 12256, '\P{iskangxi}', "");
    Expect(0, 12256, '\P{^iskangxi}', "");
    Expect(1, 12255, '\p{_ Is_KANGXI}', "");
    Expect(0, 12255, '\p{^_ Is_KANGXI}', "");
    Expect(0, 12255, '\P{_ Is_KANGXI}', "");
    Expect(1, 12255, '\P{^_ Is_KANGXI}', "");
    Expect(0, 12256, '\p{_ Is_KANGXI}', "");
    Expect(1, 12256, '\p{^_ Is_KANGXI}', "");
    Expect(1, 12256, '\P{_ Is_KANGXI}', "");
    Expect(0, 12256, '\P{^_ Is_KANGXI}', "");
    Error('\p{:=in_Kangxi}');
    Error('\P{:=in_Kangxi}');
    Expect(1, 12255, '\p{inkangxi}', "");
    Expect(0, 12255, '\p{^inkangxi}', "");
    Expect(0, 12255, '\P{inkangxi}', "");
    Expect(1, 12255, '\P{^inkangxi}', "");
    Expect(0, 12256, '\p{inkangxi}', "");
    Expect(1, 12256, '\p{^inkangxi}', "");
    Expect(1, 12256, '\P{inkangxi}', "");
    Expect(0, 12256, '\P{^inkangxi}', "");
    Expect(1, 12255, '\p{ In_kangxi}', "");
    Expect(0, 12255, '\p{^ In_kangxi}', "");
    Expect(0, 12255, '\P{ In_kangxi}', "");
    Expect(1, 12255, '\P{^ In_kangxi}', "");
    Expect(0, 12256, '\p{ In_kangxi}', "");
    Expect(1, 12256, '\p{^ In_kangxi}', "");
    Expect(1, 12256, '\P{ In_kangxi}', "");
    Expect(0, 12256, '\P{^ In_kangxi}', "");
    Error('\p{	kannada:=}');
    Error('\P{	kannada:=}');
    Expect(1, 43061, '\p{kannada}', "");
    Expect(0, 43061, '\p{^kannada}', "");
    Expect(0, 43061, '\P{kannada}', "");
    Expect(1, 43061, '\P{^kannada}', "");
    Expect(0, 43062, '\p{kannada}', "");
    Expect(1, 43062, '\p{^kannada}', "");
    Expect(1, 43062, '\P{kannada}', "");
    Expect(0, 43062, '\P{^kannada}', "");
    Expect(1, 43061, '\p{	_Kannada}', "");
    Expect(0, 43061, '\p{^	_Kannada}', "");
    Expect(0, 43061, '\P{	_Kannada}', "");
    Expect(1, 43061, '\P{^	_Kannada}', "");
    Expect(0, 43062, '\p{	_Kannada}', "");
    Expect(1, 43062, '\p{^	_Kannada}', "");
    Expect(1, 43062, '\P{	_Kannada}', "");
    Expect(0, 43062, '\P{^	_Kannada}', "");
    Error('\p{:= 	Is_Kannada}');
    Error('\P{:= 	Is_Kannada}');
    Expect(1, 43061, '\p{iskannada}', "");
    Expect(0, 43061, '\p{^iskannada}', "");
    Expect(0, 43061, '\P{iskannada}', "");
    Expect(1, 43061, '\P{^iskannada}', "");
    Expect(0, 43062, '\p{iskannada}', "");
    Expect(1, 43062, '\p{^iskannada}', "");
    Expect(1, 43062, '\P{iskannada}', "");
    Expect(0, 43062, '\P{^iskannada}', "");
    Expect(1, 43061, '\p{	 IS_KANNADA}', "");
    Expect(0, 43061, '\p{^	 IS_KANNADA}', "");
    Expect(0, 43061, '\P{	 IS_KANNADA}', "");
    Expect(1, 43061, '\P{^	 IS_KANNADA}', "");
    Expect(0, 43062, '\p{	 IS_KANNADA}', "");
    Expect(1, 43062, '\p{^	 IS_KANNADA}', "");
    Expect(1, 43062, '\P{	 IS_KANNADA}', "");
    Expect(0, 43062, '\P{^	 IS_KANNADA}', "");
    Error('\p{		knda/a/}');
    Error('\P{		knda/a/}');
    Expect(1, 43061, '\p{knda}', "");
    Expect(0, 43061, '\p{^knda}', "");
    Expect(0, 43061, '\P{knda}', "");
    Expect(1, 43061, '\P{^knda}', "");
    Expect(0, 43062, '\p{knda}', "");
    Expect(1, 43062, '\p{^knda}', "");
    Expect(1, 43062, '\P{knda}', "");
    Expect(0, 43062, '\P{^knda}', "");
    Expect(1, 43061, '\p{_KNDA}', "");
    Expect(0, 43061, '\p{^_KNDA}', "");
    Expect(0, 43061, '\P{_KNDA}', "");
    Expect(1, 43061, '\P{^_KNDA}', "");
    Expect(0, 43062, '\p{_KNDA}', "");
    Expect(1, 43062, '\p{^_KNDA}', "");
    Expect(1, 43062, '\P{_KNDA}', "");
    Expect(0, 43062, '\P{^_KNDA}', "");
    Error('\p{:=	-Is_Knda}');
    Error('\P{:=	-Is_Knda}');
    Expect(1, 43061, '\p{isknda}', "");
    Expect(0, 43061, '\p{^isknda}', "");
    Expect(0, 43061, '\P{isknda}', "");
    Expect(1, 43061, '\P{^isknda}', "");
    Expect(0, 43062, '\p{isknda}', "");
    Expect(1, 43062, '\p{^isknda}', "");
    Expect(1, 43062, '\P{isknda}', "");
    Expect(0, 43062, '\P{^isknda}', "");
    Expect(1, 43061, '\p{ _Is_Knda}', "");
    Expect(0, 43061, '\p{^ _Is_Knda}', "");
    Expect(0, 43061, '\P{ _Is_Knda}', "");
    Expect(1, 43061, '\P{^ _Is_Knda}', "");
    Expect(0, 43062, '\p{ _Is_Knda}', "");
    Expect(1, 43062, '\p{^ _Is_Knda}', "");
    Expect(1, 43062, '\P{ _Is_Knda}', "");
    Expect(0, 43062, '\P{^ _Is_Knda}', "");
    Error('\p{:= 	Katakana}');
    Error('\P{:= 	Katakana}');
    Expect(1, 110951, '\p{katakana}', "");
    Expect(0, 110951, '\p{^katakana}', "");
    Expect(0, 110951, '\P{katakana}', "");
    Expect(1, 110951, '\P{^katakana}', "");
    Expect(0, 110952, '\p{katakana}', "");
    Expect(1, 110952, '\p{^katakana}', "");
    Expect(1, 110952, '\P{katakana}', "");
    Expect(0, 110952, '\P{^katakana}', "");
    Expect(1, 110951, '\p{-KATAKANA}', "");
    Expect(0, 110951, '\p{^-KATAKANA}', "");
    Expect(0, 110951, '\P{-KATAKANA}', "");
    Expect(1, 110951, '\P{^-KATAKANA}', "");
    Expect(0, 110952, '\p{-KATAKANA}', "");
    Expect(1, 110952, '\p{^-KATAKANA}', "");
    Expect(1, 110952, '\P{-KATAKANA}', "");
    Expect(0, 110952, '\P{^-KATAKANA}', "");
    Error('\p{:=-_Is_KATAKANA}');
    Error('\P{:=-_Is_KATAKANA}');
    Expect(1, 110951, '\p{iskatakana}', "");
    Expect(0, 110951, '\p{^iskatakana}', "");
    Expect(0, 110951, '\P{iskatakana}', "");
    Expect(1, 110951, '\P{^iskatakana}', "");
    Expect(0, 110952, '\p{iskatakana}', "");
    Expect(1, 110952, '\p{^iskatakana}', "");
    Expect(1, 110952, '\P{iskatakana}', "");
    Expect(0, 110952, '\P{^iskatakana}', "");
    Expect(1, 110951, '\p{- is_KATAKANA}', "");
    Expect(0, 110951, '\p{^- is_KATAKANA}', "");
    Expect(0, 110951, '\P{- is_KATAKANA}', "");
    Expect(1, 110951, '\P{^- is_KATAKANA}', "");
    Expect(0, 110952, '\p{- is_KATAKANA}', "");
    Expect(1, 110952, '\p{^- is_KATAKANA}', "");
    Expect(1, 110952, '\P{- is_KATAKANA}', "");
    Expect(0, 110952, '\P{^- is_KATAKANA}', "");
    Error('\p{/a/-Kana}');
    Error('\P{/a/-Kana}');
    Expect(1, 110951, '\p{kana}', "");
    Expect(0, 110951, '\p{^kana}', "");
    Expect(0, 110951, '\P{kana}', "");
    Expect(1, 110951, '\P{^kana}', "");
    Expect(0, 110952, '\p{kana}', "");
    Expect(1, 110952, '\p{^kana}', "");
    Expect(1, 110952, '\P{kana}', "");
    Expect(0, 110952, '\P{^kana}', "");
    Expect(1, 110951, '\p{-_Kana}', "");
    Expect(0, 110951, '\p{^-_Kana}', "");
    Expect(0, 110951, '\P{-_Kana}', "");
    Expect(1, 110951, '\P{^-_Kana}', "");
    Expect(0, 110952, '\p{-_Kana}', "");
    Expect(1, 110952, '\p{^-_Kana}', "");
    Expect(1, 110952, '\P{-_Kana}', "");
    Expect(0, 110952, '\P{^-_Kana}', "");
    Error('\p{ :=Is_kana}');
    Error('\P{ :=Is_kana}');
    Expect(1, 110951, '\p{iskana}', "");
    Expect(0, 110951, '\p{^iskana}', "");
    Expect(0, 110951, '\P{iskana}', "");
    Expect(1, 110951, '\P{^iskana}', "");
    Expect(0, 110952, '\p{iskana}', "");
    Expect(1, 110952, '\p{^iskana}', "");
    Expect(1, 110952, '\P{iskana}', "");
    Expect(0, 110952, '\P{^iskana}', "");
    Expect(1, 110951, '\p{_ Is_kana}', "");
    Expect(0, 110951, '\p{^_ Is_kana}', "");
    Expect(0, 110951, '\P{_ Is_kana}', "");
    Expect(1, 110951, '\P{^_ Is_kana}', "");
    Expect(0, 110952, '\p{_ Is_kana}', "");
    Expect(1, 110952, '\p{^_ Is_kana}', "");
    Expect(1, 110952, '\P{_ Is_kana}', "");
    Expect(0, 110952, '\P{^_ Is_kana}', "");
    Error('\p{Katakana_Or_Hiragana}');
    Error('\P{Katakana_Or_Hiragana}');
    Error('\p{Hrkt}');
    Error('\P{Hrkt}');
    Error('\p{_-Katakana_PHONETIC_Extensions:=}');
    Error('\P{_-Katakana_PHONETIC_Extensions:=}');
    Expect(1, 12799, '\p{katakanaphoneticextensions}', "");
    Expect(0, 12799, '\p{^katakanaphoneticextensions}', "");
    Expect(0, 12799, '\P{katakanaphoneticextensions}', "");
    Expect(1, 12799, '\P{^katakanaphoneticextensions}', "");
    Expect(0, 12800, '\p{katakanaphoneticextensions}', "");
    Expect(1, 12800, '\p{^katakanaphoneticextensions}', "");
    Expect(1, 12800, '\P{katakanaphoneticextensions}', "");
    Expect(0, 12800, '\P{^katakanaphoneticextensions}', "");
    Expect(1, 12799, '\p{-katakana_phonetic_Extensions}', "");
    Expect(0, 12799, '\p{^-katakana_phonetic_Extensions}', "");
    Expect(0, 12799, '\P{-katakana_phonetic_Extensions}', "");
    Expect(1, 12799, '\P{^-katakana_phonetic_Extensions}', "");
    Expect(0, 12800, '\p{-katakana_phonetic_Extensions}', "");
    Expect(1, 12800, '\p{^-katakana_phonetic_Extensions}', "");
    Expect(1, 12800, '\P{-katakana_phonetic_Extensions}', "");
    Expect(0, 12800, '\P{^-katakana_phonetic_Extensions}', "");
    Error('\p{:=  is_KATAKANA_Phonetic_Extensions}');
    Error('\P{:=  is_KATAKANA_Phonetic_Extensions}');
    Expect(1, 12799, '\p{iskatakanaphoneticextensions}', "");
    Expect(0, 12799, '\p{^iskatakanaphoneticextensions}', "");
    Expect(0, 12799, '\P{iskatakanaphoneticextensions}', "");
    Expect(1, 12799, '\P{^iskatakanaphoneticextensions}', "");
    Expect(0, 12800, '\p{iskatakanaphoneticextensions}', "");
    Expect(1, 12800, '\p{^iskatakanaphoneticextensions}', "");
    Expect(1, 12800, '\P{iskatakanaphoneticextensions}', "");
    Expect(0, 12800, '\P{^iskatakanaphoneticextensions}', "");
    Expect(1, 12799, '\p{ 	Is_katakana_PHONETIC_Extensions}', "");
    Expect(0, 12799, '\p{^ 	Is_katakana_PHONETIC_Extensions}', "");
    Expect(0, 12799, '\P{ 	Is_katakana_PHONETIC_Extensions}', "");
    Expect(1, 12799, '\P{^ 	Is_katakana_PHONETIC_Extensions}', "");
    Expect(0, 12800, '\p{ 	Is_katakana_PHONETIC_Extensions}', "");
    Expect(1, 12800, '\p{^ 	Is_katakana_PHONETIC_Extensions}', "");
    Expect(1, 12800, '\P{ 	Is_katakana_PHONETIC_Extensions}', "");
    Expect(0, 12800, '\P{^ 	Is_katakana_PHONETIC_Extensions}', "");
    Error('\p{:=	-In_Katakana_phonetic_Extensions}');
    Error('\P{:=	-In_Katakana_phonetic_Extensions}');
    Expect(1, 12799, '\p{inkatakanaphoneticextensions}', "");
    Expect(0, 12799, '\p{^inkatakanaphoneticextensions}', "");
    Expect(0, 12799, '\P{inkatakanaphoneticextensions}', "");
    Expect(1, 12799, '\P{^inkatakanaphoneticextensions}', "");
    Expect(0, 12800, '\p{inkatakanaphoneticextensions}', "");
    Expect(1, 12800, '\p{^inkatakanaphoneticextensions}', "");
    Expect(1, 12800, '\P{inkatakanaphoneticextensions}', "");
    Expect(0, 12800, '\P{^inkatakanaphoneticextensions}', "");
    Expect(1, 12799, '\p{_In_katakana_phonetic_extensions}', "");
    Expect(0, 12799, '\p{^_In_katakana_phonetic_extensions}', "");
    Expect(0, 12799, '\P{_In_katakana_phonetic_extensions}', "");
    Expect(1, 12799, '\P{^_In_katakana_phonetic_extensions}', "");
    Expect(0, 12800, '\p{_In_katakana_phonetic_extensions}', "");
    Expect(1, 12800, '\p{^_In_katakana_phonetic_extensions}', "");
    Expect(1, 12800, '\P{_In_katakana_phonetic_extensions}', "");
    Expect(0, 12800, '\P{^_In_katakana_phonetic_extensions}', "");
    Error('\p{- KATAKANA_Ext:=}');
    Error('\P{- KATAKANA_Ext:=}');
    Expect(1, 12799, '\p{katakanaext}', "");
    Expect(0, 12799, '\p{^katakanaext}', "");
    Expect(0, 12799, '\P{katakanaext}', "");
    Expect(1, 12799, '\P{^katakanaext}', "");
    Expect(0, 12800, '\p{katakanaext}', "");
    Expect(1, 12800, '\p{^katakanaext}', "");
    Expect(1, 12800, '\P{katakanaext}', "");
    Expect(0, 12800, '\P{^katakanaext}', "");
    Expect(1, 12799, '\p{_KATAKANA_EXT}', "");
    Expect(0, 12799, '\p{^_KATAKANA_EXT}', "");
    Expect(0, 12799, '\P{_KATAKANA_EXT}', "");
    Expect(1, 12799, '\P{^_KATAKANA_EXT}', "");
    Expect(0, 12800, '\p{_KATAKANA_EXT}', "");
    Expect(1, 12800, '\p{^_KATAKANA_EXT}', "");
    Expect(1, 12800, '\P{_KATAKANA_EXT}', "");
    Expect(0, 12800, '\P{^_KATAKANA_EXT}', "");
    Error('\p{/a/_	Is_katakana_Ext}');
    Error('\P{/a/_	Is_katakana_Ext}');
    Expect(1, 12799, '\p{iskatakanaext}', "");
    Expect(0, 12799, '\p{^iskatakanaext}', "");
    Expect(0, 12799, '\P{iskatakanaext}', "");
    Expect(1, 12799, '\P{^iskatakanaext}', "");
    Expect(0, 12800, '\p{iskatakanaext}', "");
    Expect(1, 12800, '\p{^iskatakanaext}', "");
    Expect(1, 12800, '\P{iskatakanaext}', "");
    Expect(0, 12800, '\P{^iskatakanaext}', "");
    Expect(1, 12799, '\p{		IS_Katakana_EXT}', "");
    Expect(0, 12799, '\p{^		IS_Katakana_EXT}', "");
    Expect(0, 12799, '\P{		IS_Katakana_EXT}', "");
    Expect(1, 12799, '\P{^		IS_Katakana_EXT}', "");
    Expect(0, 12800, '\p{		IS_Katakana_EXT}', "");
    Expect(1, 12800, '\p{^		IS_Katakana_EXT}', "");
    Expect(1, 12800, '\P{		IS_Katakana_EXT}', "");
    Expect(0, 12800, '\P{^		IS_Katakana_EXT}', "");
    Error('\p{_	In_Katakana_Ext:=}');
    Error('\P{_	In_Katakana_Ext:=}');
    Expect(1, 12799, '\p{inkatakanaext}', "");
    Expect(0, 12799, '\p{^inkatakanaext}', "");
    Expect(0, 12799, '\P{inkatakanaext}', "");
    Expect(1, 12799, '\P{^inkatakanaext}', "");
    Expect(0, 12800, '\p{inkatakanaext}', "");
    Expect(1, 12800, '\p{^inkatakanaext}', "");
    Expect(1, 12800, '\P{inkatakanaext}', "");
    Expect(0, 12800, '\P{^inkatakanaext}', "");
    Expect(1, 12799, '\p{ _In_katakana_Ext}', "");
    Expect(0, 12799, '\p{^ _In_katakana_Ext}', "");
    Expect(0, 12799, '\P{ _In_katakana_Ext}', "");
    Expect(1, 12799, '\P{^ _In_katakana_Ext}', "");
    Expect(0, 12800, '\p{ _In_katakana_Ext}', "");
    Expect(1, 12800, '\p{^ _In_katakana_Ext}', "");
    Expect(1, 12800, '\P{ _In_katakana_Ext}', "");
    Expect(0, 12800, '\P{^ _In_katakana_Ext}', "");
    Error('\p{:=	Kayah_Li}');
    Error('\P{:=	Kayah_Li}');
    Expect(1, 43311, '\p{kayahli}', "");
    Expect(0, 43311, '\p{^kayahli}', "");
    Expect(0, 43311, '\P{kayahli}', "");
    Expect(1, 43311, '\P{^kayahli}', "");
    Expect(0, 43312, '\p{kayahli}', "");
    Expect(1, 43312, '\p{^kayahli}', "");
    Expect(1, 43312, '\P{kayahli}', "");
    Expect(0, 43312, '\P{^kayahli}', "");
    Expect(1, 43311, '\p{	kayah_Li}', "");
    Expect(0, 43311, '\p{^	kayah_Li}', "");
    Expect(0, 43311, '\P{	kayah_Li}', "");
    Expect(1, 43311, '\P{^	kayah_Li}', "");
    Expect(0, 43312, '\p{	kayah_Li}', "");
    Expect(1, 43312, '\p{^	kayah_Li}', "");
    Expect(1, 43312, '\P{	kayah_Li}', "");
    Expect(0, 43312, '\P{^	kayah_Li}', "");
    Error('\p{-:=IS_KAYAH_Li}');
    Error('\P{-:=IS_KAYAH_Li}');
    Expect(1, 43311, '\p{iskayahli}', "");
    Expect(0, 43311, '\p{^iskayahli}', "");
    Expect(0, 43311, '\P{iskayahli}', "");
    Expect(1, 43311, '\P{^iskayahli}', "");
    Expect(0, 43312, '\p{iskayahli}', "");
    Expect(1, 43312, '\p{^iskayahli}', "");
    Expect(1, 43312, '\P{iskayahli}', "");
    Expect(0, 43312, '\P{^iskayahli}', "");
    Expect(1, 43311, '\p{		Is_Kayah_Li}', "");
    Expect(0, 43311, '\p{^		Is_Kayah_Li}', "");
    Expect(0, 43311, '\P{		Is_Kayah_Li}', "");
    Expect(1, 43311, '\P{^		Is_Kayah_Li}', "");
    Expect(0, 43312, '\p{		Is_Kayah_Li}', "");
    Expect(1, 43312, '\p{^		Is_Kayah_Li}', "");
    Expect(1, 43312, '\P{		Is_Kayah_Li}', "");
    Expect(0, 43312, '\P{^		Is_Kayah_Li}', "");
    Error('\p{	Kali/a/}');
    Error('\P{	Kali/a/}');
    Expect(1, 43311, '\p{kali}', "");
    Expect(0, 43311, '\p{^kali}', "");
    Expect(0, 43311, '\P{kali}', "");
    Expect(1, 43311, '\P{^kali}', "");
    Expect(0, 43312, '\p{kali}', "");
    Expect(1, 43312, '\p{^kali}', "");
    Expect(1, 43312, '\P{kali}', "");
    Expect(0, 43312, '\P{^kali}', "");
    Expect(1, 43311, '\p{_Kali}', "");
    Expect(0, 43311, '\p{^_Kali}', "");
    Expect(0, 43311, '\P{_Kali}', "");
    Expect(1, 43311, '\P{^_Kali}', "");
    Expect(0, 43312, '\p{_Kali}', "");
    Expect(1, 43312, '\p{^_Kali}', "");
    Expect(1, 43312, '\P{_Kali}', "");
    Expect(0, 43312, '\P{^_Kali}', "");
    Error('\p{is_Kali:=}');
    Error('\P{is_Kali:=}');
    Expect(1, 43311, '\p{iskali}', "");
    Expect(0, 43311, '\p{^iskali}', "");
    Expect(0, 43311, '\P{iskali}', "");
    Expect(1, 43311, '\P{^iskali}', "");
    Expect(0, 43312, '\p{iskali}', "");
    Expect(1, 43312, '\p{^iskali}', "");
    Expect(1, 43312, '\P{iskali}', "");
    Expect(0, 43312, '\P{^iskali}', "");
    Expect(1, 43311, '\p{	 Is_Kali}', "");
    Expect(0, 43311, '\p{^	 Is_Kali}', "");
    Expect(0, 43311, '\P{	 Is_Kali}', "");
    Expect(1, 43311, '\P{^	 Is_Kali}', "");
    Expect(0, 43312, '\p{	 Is_Kali}', "");
    Expect(1, 43312, '\p{^	 Is_Kali}', "");
    Expect(1, 43312, '\P{	 Is_Kali}', "");
    Expect(0, 43312, '\P{^	 Is_Kali}', "");
    Error('\p{:=_ Kharoshthi}');
    Error('\P{:=_ Kharoshthi}');
    Expect(1, 68184, '\p{kharoshthi}', "");
    Expect(0, 68184, '\p{^kharoshthi}', "");
    Expect(0, 68184, '\P{kharoshthi}', "");
    Expect(1, 68184, '\P{^kharoshthi}', "");
    Expect(0, 68185, '\p{kharoshthi}', "");
    Expect(1, 68185, '\p{^kharoshthi}', "");
    Expect(1, 68185, '\P{kharoshthi}', "");
    Expect(0, 68185, '\P{^kharoshthi}', "");
    Expect(1, 68184, '\p{ kharoshthi}', "");
    Expect(0, 68184, '\p{^ kharoshthi}', "");
    Expect(0, 68184, '\P{ kharoshthi}', "");
    Expect(1, 68184, '\P{^ kharoshthi}', "");
    Expect(0, 68185, '\p{ kharoshthi}', "");
    Expect(1, 68185, '\p{^ kharoshthi}', "");
    Expect(1, 68185, '\P{ kharoshthi}', "");
    Expect(0, 68185, '\P{^ kharoshthi}', "");
    Error('\p{/a/	is_Kharoshthi}');
    Error('\P{/a/	is_Kharoshthi}');
    Expect(1, 68184, '\p{iskharoshthi}', "");
    Expect(0, 68184, '\p{^iskharoshthi}', "");
    Expect(0, 68184, '\P{iskharoshthi}', "");
    Expect(1, 68184, '\P{^iskharoshthi}', "");
    Expect(0, 68185, '\p{iskharoshthi}', "");
    Expect(1, 68185, '\p{^iskharoshthi}', "");
    Expect(1, 68185, '\P{iskharoshthi}', "");
    Expect(0, 68185, '\P{^iskharoshthi}', "");
    Expect(1, 68184, '\p{- is_Kharoshthi}', "");
    Expect(0, 68184, '\p{^- is_Kharoshthi}', "");
    Expect(0, 68184, '\P{- is_Kharoshthi}', "");
    Expect(1, 68184, '\P{^- is_Kharoshthi}', "");
    Expect(0, 68185, '\p{- is_Kharoshthi}', "");
    Expect(1, 68185, '\p{^- is_Kharoshthi}', "");
    Expect(1, 68185, '\P{- is_Kharoshthi}', "");
    Expect(0, 68185, '\P{^- is_Kharoshthi}', "");
    Error('\p{/a/_	khar}');
    Error('\P{/a/_	khar}');
    Expect(1, 68184, '\p{khar}', "");
    Expect(0, 68184, '\p{^khar}', "");
    Expect(0, 68184, '\P{khar}', "");
    Expect(1, 68184, '\P{^khar}', "");
    Expect(0, 68185, '\p{khar}', "");
    Expect(1, 68185, '\p{^khar}', "");
    Expect(1, 68185, '\P{khar}', "");
    Expect(0, 68185, '\P{^khar}', "");
    Expect(1, 68184, '\p{ 	Khar}', "");
    Expect(0, 68184, '\p{^ 	Khar}', "");
    Expect(0, 68184, '\P{ 	Khar}', "");
    Expect(1, 68184, '\P{^ 	Khar}', "");
    Expect(0, 68185, '\p{ 	Khar}', "");
    Expect(1, 68185, '\p{^ 	Khar}', "");
    Expect(1, 68185, '\P{ 	Khar}', "");
    Expect(0, 68185, '\P{^ 	Khar}', "");
    Error('\p{:=_	is_Khar}');
    Error('\P{:=_	is_Khar}');
    Expect(1, 68184, '\p{iskhar}', "");
    Expect(0, 68184, '\p{^iskhar}', "");
    Expect(0, 68184, '\P{iskhar}', "");
    Expect(1, 68184, '\P{^iskhar}', "");
    Expect(0, 68185, '\p{iskhar}', "");
    Expect(1, 68185, '\p{^iskhar}', "");
    Expect(1, 68185, '\P{iskhar}', "");
    Expect(0, 68185, '\P{^iskhar}', "");
    Expect(1, 68184, '\p{IS_KHAR}', "");
    Expect(0, 68184, '\p{^IS_KHAR}', "");
    Expect(0, 68184, '\P{IS_KHAR}', "");
    Expect(1, 68184, '\P{^IS_KHAR}', "");
    Expect(0, 68185, '\p{IS_KHAR}', "");
    Expect(1, 68185, '\p{^IS_KHAR}', "");
    Expect(1, 68185, '\P{IS_KHAR}', "");
    Expect(0, 68185, '\P{^IS_KHAR}', "");
    Error('\p{:= 	khitan_Small_script}');
    Error('\P{:= 	khitan_Small_script}');
    Expect(1, 101589, '\p{khitansmallscript}', "");
    Expect(0, 101589, '\p{^khitansmallscript}', "");
    Expect(0, 101589, '\P{khitansmallscript}', "");
    Expect(1, 101589, '\P{^khitansmallscript}', "");
    Expect(0, 101590, '\p{khitansmallscript}', "");
    Expect(1, 101590, '\p{^khitansmallscript}', "");
    Expect(1, 101590, '\P{khitansmallscript}', "");
    Expect(0, 101590, '\P{^khitansmallscript}', "");
    Expect(1, 101589, '\p{-KHITAN_Small_Script}', "");
    Expect(0, 101589, '\p{^-KHITAN_Small_Script}', "");
    Expect(0, 101589, '\P{-KHITAN_Small_Script}', "");
    Expect(1, 101589, '\P{^-KHITAN_Small_Script}', "");
    Expect(0, 101590, '\p{-KHITAN_Small_Script}', "");
    Expect(1, 101590, '\p{^-KHITAN_Small_Script}', "");
    Expect(1, 101590, '\P{-KHITAN_Small_Script}', "");
    Expect(0, 101590, '\P{^-KHITAN_Small_Script}', "");
    Error('\p{ Is_Khitan_Small_Script/a/}');
    Error('\P{ Is_Khitan_Small_Script/a/}');
    Expect(1, 101589, '\p{iskhitansmallscript}', "");
    Expect(0, 101589, '\p{^iskhitansmallscript}', "");
    Expect(0, 101589, '\P{iskhitansmallscript}', "");
    Expect(1, 101589, '\P{^iskhitansmallscript}', "");
    Expect(0, 101590, '\p{iskhitansmallscript}', "");
    Expect(1, 101590, '\p{^iskhitansmallscript}', "");
    Expect(1, 101590, '\P{iskhitansmallscript}', "");
    Expect(0, 101590, '\P{^iskhitansmallscript}', "");
    Expect(1, 101589, '\p{	_IS_khitan_SMALL_SCRIPT}', "");
    Expect(0, 101589, '\p{^	_IS_khitan_SMALL_SCRIPT}', "");
    Expect(0, 101589, '\P{	_IS_khitan_SMALL_SCRIPT}', "");
    Expect(1, 101589, '\P{^	_IS_khitan_SMALL_SCRIPT}', "");
    Expect(0, 101590, '\p{	_IS_khitan_SMALL_SCRIPT}', "");
    Expect(1, 101590, '\p{^	_IS_khitan_SMALL_SCRIPT}', "");
    Expect(1, 101590, '\P{	_IS_khitan_SMALL_SCRIPT}', "");
    Expect(0, 101590, '\P{^	_IS_khitan_SMALL_SCRIPT}', "");
    Error('\p{:=kits}');
    Error('\P{:=kits}');
    Expect(1, 101589, '\p{kits}', "");
    Expect(0, 101589, '\p{^kits}', "");
    Expect(0, 101589, '\P{kits}', "");
    Expect(1, 101589, '\P{^kits}', "");
    Expect(0, 101590, '\p{kits}', "");
    Expect(1, 101590, '\p{^kits}', "");
    Expect(1, 101590, '\P{kits}', "");
    Expect(0, 101590, '\P{^kits}', "");
    Expect(1, 101589, '\p{ Kits}', "");
    Expect(0, 101589, '\p{^ Kits}', "");
    Expect(0, 101589, '\P{ Kits}', "");
    Expect(1, 101589, '\P{^ Kits}', "");
    Expect(0, 101590, '\p{ Kits}', "");
    Expect(1, 101590, '\p{^ Kits}', "");
    Expect(1, 101590, '\P{ Kits}', "");
    Expect(0, 101590, '\P{^ Kits}', "");
    Error('\p{- Is_kits/a/}');
    Error('\P{- Is_kits/a/}');
    Expect(1, 101589, '\p{iskits}', "");
    Expect(0, 101589, '\p{^iskits}', "");
    Expect(0, 101589, '\P{iskits}', "");
    Expect(1, 101589, '\P{^iskits}', "");
    Expect(0, 101590, '\p{iskits}', "");
    Expect(1, 101590, '\p{^iskits}', "");
    Expect(1, 101590, '\P{iskits}', "");
    Expect(0, 101590, '\P{^iskits}', "");
    Expect(1, 101589, '\p{Is_kits}', "");
    Expect(0, 101589, '\p{^Is_kits}', "");
    Expect(0, 101589, '\P{Is_kits}', "");
    Expect(1, 101589, '\P{^Is_kits}', "");
    Expect(0, 101590, '\p{Is_kits}', "");
    Expect(1, 101590, '\p{^Is_kits}', "");
    Expect(1, 101590, '\P{Is_kits}', "");
    Expect(0, 101590, '\P{^Is_kits}', "");
    Error('\p{/a/- khmer}');
    Error('\P{/a/- khmer}');
    Expect(1, 6655, '\p{khmer}', "");
    Expect(0, 6655, '\p{^khmer}', "");
    Expect(0, 6655, '\P{khmer}', "");
    Expect(1, 6655, '\P{^khmer}', "");
    Expect(0, 6656, '\p{khmer}', "");
    Expect(1, 6656, '\p{^khmer}', "");
    Expect(1, 6656, '\P{khmer}', "");
    Expect(0, 6656, '\P{^khmer}', "");
    Expect(1, 6655, '\p{_	KHMER}', "");
    Expect(0, 6655, '\p{^_	KHMER}', "");
    Expect(0, 6655, '\P{_	KHMER}', "");
    Expect(1, 6655, '\P{^_	KHMER}', "");
    Expect(0, 6656, '\p{_	KHMER}', "");
    Expect(1, 6656, '\p{^_	KHMER}', "");
    Expect(1, 6656, '\P{_	KHMER}', "");
    Expect(0, 6656, '\P{^_	KHMER}', "");
    Error('\p{	/a/is_khmer}');
    Error('\P{	/a/is_khmer}');
    Expect(1, 6655, '\p{iskhmer}', "");
    Expect(0, 6655, '\p{^iskhmer}', "");
    Expect(0, 6655, '\P{iskhmer}', "");
    Expect(1, 6655, '\P{^iskhmer}', "");
    Expect(0, 6656, '\p{iskhmer}', "");
    Expect(1, 6656, '\p{^iskhmer}', "");
    Expect(1, 6656, '\P{iskhmer}', "");
    Expect(0, 6656, '\P{^iskhmer}', "");
    Expect(1, 6655, '\p{  IS_KHMER}', "");
    Expect(0, 6655, '\p{^  IS_KHMER}', "");
    Expect(0, 6655, '\P{  IS_KHMER}', "");
    Expect(1, 6655, '\P{^  IS_KHMER}', "");
    Expect(0, 6656, '\p{  IS_KHMER}', "");
    Expect(1, 6656, '\p{^  IS_KHMER}', "");
    Expect(1, 6656, '\P{  IS_KHMER}', "");
    Expect(0, 6656, '\P{^  IS_KHMER}', "");
    Error('\p{/a/khmr}');
    Error('\P{/a/khmr}');
    Expect(1, 6655, '\p{khmr}', "");
    Expect(0, 6655, '\p{^khmr}', "");
    Expect(0, 6655, '\P{khmr}', "");
    Expect(1, 6655, '\P{^khmr}', "");
    Expect(0, 6656, '\p{khmr}', "");
    Expect(1, 6656, '\p{^khmr}', "");
    Expect(1, 6656, '\P{khmr}', "");
    Expect(0, 6656, '\P{^khmr}', "");
    Expect(1, 6655, '\p{-	Khmr}', "");
    Expect(0, 6655, '\p{^-	Khmr}', "");
    Expect(0, 6655, '\P{-	Khmr}', "");
    Expect(1, 6655, '\P{^-	Khmr}', "");
    Expect(0, 6656, '\p{-	Khmr}', "");
    Expect(1, 6656, '\p{^-	Khmr}', "");
    Expect(1, 6656, '\P{-	Khmr}', "");
    Expect(0, 6656, '\P{^-	Khmr}', "");
    Error('\p{	:=IS_khmr}');
    Error('\P{	:=IS_khmr}');
    Expect(1, 6655, '\p{iskhmr}', "");
    Expect(0, 6655, '\p{^iskhmr}', "");
    Expect(0, 6655, '\P{iskhmr}', "");
    Expect(1, 6655, '\P{^iskhmr}', "");
    Expect(0, 6656, '\p{iskhmr}', "");
    Expect(1, 6656, '\p{^iskhmr}', "");
    Expect(1, 6656, '\P{iskhmr}', "");
    Expect(0, 6656, '\P{^iskhmr}', "");
    Expect(1, 6655, '\p{		Is_Khmr}', "");
    Expect(0, 6655, '\p{^		Is_Khmr}', "");
    Expect(0, 6655, '\P{		Is_Khmr}', "");
    Expect(1, 6655, '\P{^		Is_Khmr}', "");
    Expect(0, 6656, '\p{		Is_Khmr}', "");
    Expect(1, 6656, '\p{^		Is_Khmr}', "");
    Expect(1, 6656, '\P{		Is_Khmr}', "");
    Expect(0, 6656, '\P{^		Is_Khmr}', "");
    Error('\p{-:=khmer_symbols}');
    Error('\P{-:=khmer_symbols}');
    Expect(1, 6655, '\p{khmersymbols}', "");
    Expect(0, 6655, '\p{^khmersymbols}', "");
    Expect(0, 6655, '\P{khmersymbols}', "");
    Expect(1, 6655, '\P{^khmersymbols}', "");
    Expect(0, 6656, '\p{khmersymbols}', "");
    Expect(1, 6656, '\p{^khmersymbols}', "");
    Expect(1, 6656, '\P{khmersymbols}', "");
    Expect(0, 6656, '\P{^khmersymbols}', "");
    Expect(1, 6655, '\p{_khmer_Symbols}', "");
    Expect(0, 6655, '\p{^_khmer_Symbols}', "");
    Expect(0, 6655, '\P{_khmer_Symbols}', "");
    Expect(1, 6655, '\P{^_khmer_Symbols}', "");
    Expect(0, 6656, '\p{_khmer_Symbols}', "");
    Expect(1, 6656, '\p{^_khmer_Symbols}', "");
    Expect(1, 6656, '\P{_khmer_Symbols}', "");
    Expect(0, 6656, '\P{^_khmer_Symbols}', "");
    Error('\p{ 	is_Khmer_SYMBOLS:=}');
    Error('\P{ 	is_Khmer_SYMBOLS:=}');
    Expect(1, 6655, '\p{iskhmersymbols}', "");
    Expect(0, 6655, '\p{^iskhmersymbols}', "");
    Expect(0, 6655, '\P{iskhmersymbols}', "");
    Expect(1, 6655, '\P{^iskhmersymbols}', "");
    Expect(0, 6656, '\p{iskhmersymbols}', "");
    Expect(1, 6656, '\p{^iskhmersymbols}', "");
    Expect(1, 6656, '\P{iskhmersymbols}', "");
    Expect(0, 6656, '\P{^iskhmersymbols}', "");
    Expect(1, 6655, '\p{	-is_KHMER_Symbols}', "");
    Expect(0, 6655, '\p{^	-is_KHMER_Symbols}', "");
    Expect(0, 6655, '\P{	-is_KHMER_Symbols}', "");
    Expect(1, 6655, '\P{^	-is_KHMER_Symbols}', "");
    Expect(0, 6656, '\p{	-is_KHMER_Symbols}', "");
    Expect(1, 6656, '\p{^	-is_KHMER_Symbols}', "");
    Expect(1, 6656, '\P{	-is_KHMER_Symbols}', "");
    Expect(0, 6656, '\P{^	-is_KHMER_Symbols}', "");
    Error('\p{ IN_Khmer_Symbols/a/}');
    Error('\P{ IN_Khmer_Symbols/a/}');
    Expect(1, 6655, '\p{inkhmersymbols}', "");
    Expect(0, 6655, '\p{^inkhmersymbols}', "");
    Expect(0, 6655, '\P{inkhmersymbols}', "");
    Expect(1, 6655, '\P{^inkhmersymbols}', "");
    Expect(0, 6656, '\p{inkhmersymbols}', "");
    Expect(1, 6656, '\p{^inkhmersymbols}', "");
    Expect(1, 6656, '\P{inkhmersymbols}', "");
    Expect(0, 6656, '\P{^inkhmersymbols}', "");
    Expect(1, 6655, '\p{- In_KHMER_symbols}', "");
    Expect(0, 6655, '\p{^- In_KHMER_symbols}', "");
    Expect(0, 6655, '\P{- In_KHMER_symbols}', "");
    Expect(1, 6655, '\P{^- In_KHMER_symbols}', "");
    Expect(0, 6656, '\p{- In_KHMER_symbols}', "");
    Expect(1, 6656, '\p{^- In_KHMER_symbols}', "");
    Expect(1, 6656, '\P{- In_KHMER_symbols}', "");
    Expect(0, 6656, '\P{^- In_KHMER_symbols}', "");
    Error('\p{	/a/khojki}');
    Error('\P{	/a/khojki}');
    Expect(1, 70206, '\p{khojki}', "");
    Expect(0, 70206, '\p{^khojki}', "");
    Expect(0, 70206, '\P{khojki}', "");
    Expect(1, 70206, '\P{^khojki}', "");
    Expect(0, 70207, '\p{khojki}', "");
    Expect(1, 70207, '\p{^khojki}', "");
    Expect(1, 70207, '\P{khojki}', "");
    Expect(0, 70207, '\P{^khojki}', "");
    Expect(1, 70206, '\p{-KHOJKI}', "");
    Expect(0, 70206, '\p{^-KHOJKI}', "");
    Expect(0, 70206, '\P{-KHOJKI}', "");
    Expect(1, 70206, '\P{^-KHOJKI}', "");
    Expect(0, 70207, '\p{-KHOJKI}', "");
    Expect(1, 70207, '\p{^-KHOJKI}', "");
    Expect(1, 70207, '\P{-KHOJKI}', "");
    Expect(0, 70207, '\P{^-KHOJKI}', "");
    Error('\p{ _IS_Khojki/a/}');
    Error('\P{ _IS_Khojki/a/}');
    Expect(1, 70206, '\p{iskhojki}', "");
    Expect(0, 70206, '\p{^iskhojki}', "");
    Expect(0, 70206, '\P{iskhojki}', "");
    Expect(1, 70206, '\P{^iskhojki}', "");
    Expect(0, 70207, '\p{iskhojki}', "");
    Expect(1, 70207, '\p{^iskhojki}', "");
    Expect(1, 70207, '\P{iskhojki}', "");
    Expect(0, 70207, '\P{^iskhojki}', "");
    Expect(1, 70206, '\p{_	IS_khojki}', "");
    Expect(0, 70206, '\p{^_	IS_khojki}', "");
    Expect(0, 70206, '\P{_	IS_khojki}', "");
    Expect(1, 70206, '\P{^_	IS_khojki}', "");
    Expect(0, 70207, '\p{_	IS_khojki}', "");
    Expect(1, 70207, '\p{^_	IS_khojki}', "");
    Expect(1, 70207, '\P{_	IS_khojki}', "");
    Expect(0, 70207, '\P{^_	IS_khojki}', "");
    Error('\p{_/a/khoj}');
    Error('\P{_/a/khoj}');
    Expect(1, 70206, '\p{khoj}', "");
    Expect(0, 70206, '\p{^khoj}', "");
    Expect(0, 70206, '\P{khoj}', "");
    Expect(1, 70206, '\P{^khoj}', "");
    Expect(0, 70207, '\p{khoj}', "");
    Expect(1, 70207, '\p{^khoj}', "");
    Expect(1, 70207, '\P{khoj}', "");
    Expect(0, 70207, '\P{^khoj}', "");
    Expect(1, 70206, '\p{_ KHOJ}', "");
    Expect(0, 70206, '\p{^_ KHOJ}', "");
    Expect(0, 70206, '\P{_ KHOJ}', "");
    Expect(1, 70206, '\P{^_ KHOJ}', "");
    Expect(0, 70207, '\p{_ KHOJ}', "");
    Expect(1, 70207, '\p{^_ KHOJ}', "");
    Expect(1, 70207, '\P{_ KHOJ}', "");
    Expect(0, 70207, '\P{^_ KHOJ}', "");
    Error('\p{_ is_KHOJ:=}');
    Error('\P{_ is_KHOJ:=}');
    Expect(1, 70206, '\p{iskhoj}', "");
    Expect(0, 70206, '\p{^iskhoj}', "");
    Expect(0, 70206, '\P{iskhoj}', "");
    Expect(1, 70206, '\P{^iskhoj}', "");
    Expect(0, 70207, '\p{iskhoj}', "");
    Expect(1, 70207, '\p{^iskhoj}', "");
    Expect(1, 70207, '\P{iskhoj}', "");
    Expect(0, 70207, '\P{^iskhoj}', "");
    Expect(1, 70206, '\p{	is_Khoj}', "");
    Expect(0, 70206, '\p{^	is_Khoj}', "");
    Expect(0, 70206, '\P{	is_Khoj}', "");
    Expect(1, 70206, '\P{^	is_Khoj}', "");
    Expect(0, 70207, '\p{	is_Khoj}', "");
    Expect(1, 70207, '\p{^	is_Khoj}', "");
    Expect(1, 70207, '\P{	is_Khoj}', "");
    Expect(0, 70207, '\P{^	is_Khoj}', "");
    Error('\p{:=		Khudawadi}');
    Error('\P{:=		Khudawadi}');
    Expect(1, 70393, '\p{khudawadi}', "");
    Expect(0, 70393, '\p{^khudawadi}', "");
    Expect(0, 70393, '\P{khudawadi}', "");
    Expect(1, 70393, '\P{^khudawadi}', "");
    Expect(0, 70394, '\p{khudawadi}', "");
    Expect(1, 70394, '\p{^khudawadi}', "");
    Expect(1, 70394, '\P{khudawadi}', "");
    Expect(0, 70394, '\P{^khudawadi}', "");
    Expect(1, 70393, '\p{	Khudawadi}', "");
    Expect(0, 70393, '\p{^	Khudawadi}', "");
    Expect(0, 70393, '\P{	Khudawadi}', "");
    Expect(1, 70393, '\P{^	Khudawadi}', "");
    Expect(0, 70394, '\p{	Khudawadi}', "");
    Expect(1, 70394, '\p{^	Khudawadi}', "");
    Expect(1, 70394, '\P{	Khudawadi}', "");
    Expect(0, 70394, '\P{^	Khudawadi}', "");
    Error('\p{:=-	IS_khudawadi}');
    Error('\P{:=-	IS_khudawadi}');
    Expect(1, 70393, '\p{iskhudawadi}', "");
    Expect(0, 70393, '\p{^iskhudawadi}', "");
    Expect(0, 70393, '\P{iskhudawadi}', "");
    Expect(1, 70393, '\P{^iskhudawadi}', "");
    Expect(0, 70394, '\p{iskhudawadi}', "");
    Expect(1, 70394, '\p{^iskhudawadi}', "");
    Expect(1, 70394, '\P{iskhudawadi}', "");
    Expect(0, 70394, '\P{^iskhudawadi}', "");
    Expect(1, 70393, '\p{-IS_KHUDAWADI}', "");
    Expect(0, 70393, '\p{^-IS_KHUDAWADI}', "");
    Expect(0, 70393, '\P{-IS_KHUDAWADI}', "");
    Expect(1, 70393, '\P{^-IS_KHUDAWADI}', "");
    Expect(0, 70394, '\p{-IS_KHUDAWADI}', "");
    Expect(1, 70394, '\p{^-IS_KHUDAWADI}', "");
    Expect(1, 70394, '\P{-IS_KHUDAWADI}', "");
    Expect(0, 70394, '\P{^-IS_KHUDAWADI}', "");
    Error('\p{-:=Sind}');
    Error('\P{-:=Sind}');
    Expect(1, 70393, '\p{sind}', "");
    Expect(0, 70393, '\p{^sind}', "");
    Expect(0, 70393, '\P{sind}', "");
    Expect(1, 70393, '\P{^sind}', "");
    Expect(0, 70394, '\p{sind}', "");
    Expect(1, 70394, '\p{^sind}', "");
    Expect(1, 70394, '\P{sind}', "");
    Expect(0, 70394, '\P{^sind}', "");
    Expect(1, 70393, '\p{	-Sind}', "");
    Expect(0, 70393, '\p{^	-Sind}', "");
    Expect(0, 70393, '\P{	-Sind}', "");
    Expect(1, 70393, '\P{^	-Sind}', "");
    Expect(0, 70394, '\p{	-Sind}', "");
    Expect(1, 70394, '\p{^	-Sind}', "");
    Expect(1, 70394, '\P{	-Sind}', "");
    Expect(0, 70394, '\P{^	-Sind}', "");
    Error('\p{/a/is_sind}');
    Error('\P{/a/is_sind}');
    Expect(1, 70393, '\p{issind}', "");
    Expect(0, 70393, '\p{^issind}', "");
    Expect(0, 70393, '\P{issind}', "");
    Expect(1, 70393, '\P{^issind}', "");
    Expect(0, 70394, '\p{issind}', "");
    Expect(1, 70394, '\p{^issind}', "");
    Expect(1, 70394, '\P{issind}', "");
    Expect(0, 70394, '\P{^issind}', "");
    Expect(1, 70393, '\p{	_Is_Sind}', "");
    Expect(0, 70393, '\p{^	_Is_Sind}', "");
    Expect(0, 70393, '\P{	_Is_Sind}', "");
    Expect(1, 70393, '\P{^	_Is_Sind}', "");
    Expect(0, 70394, '\p{	_Is_Sind}', "");
    Expect(1, 70394, '\p{^	_Is_Sind}', "");
    Expect(1, 70394, '\P{	_Is_Sind}', "");
    Expect(0, 70394, '\P{^	_Is_Sind}', "");
    Error('\p{ Lao:=}');
    Error('\P{ Lao:=}');
    Expect(1, 3807, '\p{lao}', "");
    Expect(0, 3807, '\p{^lao}', "");
    Expect(0, 3807, '\P{lao}', "");
    Expect(1, 3807, '\P{^lao}', "");
    Expect(0, 3808, '\p{lao}', "");
    Expect(1, 3808, '\p{^lao}', "");
    Expect(1, 3808, '\P{lao}', "");
    Expect(0, 3808, '\P{^lao}', "");
    Expect(1, 3807, '\p{  lao}', "");
    Expect(0, 3807, '\p{^  lao}', "");
    Expect(0, 3807, '\P{  lao}', "");
    Expect(1, 3807, '\P{^  lao}', "");
    Expect(0, 3808, '\p{  lao}', "");
    Expect(1, 3808, '\p{^  lao}', "");
    Expect(1, 3808, '\P{  lao}', "");
    Expect(0, 3808, '\P{^  lao}', "");
    Error('\p{:=IS_Lao}');
    Error('\P{:=IS_Lao}');
    Expect(1, 3807, '\p{islao}', "");
    Expect(0, 3807, '\p{^islao}', "");
    Expect(0, 3807, '\P{islao}', "");
    Expect(1, 3807, '\P{^islao}', "");
    Expect(0, 3808, '\p{islao}', "");
    Expect(1, 3808, '\p{^islao}', "");
    Expect(1, 3808, '\P{islao}', "");
    Expect(0, 3808, '\P{^islao}', "");
    Expect(1, 3807, '\p{ _IS_LAO}', "");
    Expect(0, 3807, '\p{^ _IS_LAO}', "");
    Expect(0, 3807, '\P{ _IS_LAO}', "");
    Expect(1, 3807, '\P{^ _IS_LAO}', "");
    Expect(0, 3808, '\p{ _IS_LAO}', "");
    Expect(1, 3808, '\p{^ _IS_LAO}', "");
    Expect(1, 3808, '\P{ _IS_LAO}', "");
    Expect(0, 3808, '\P{^ _IS_LAO}', "");
    Error('\p{-LAOO/a/}');
    Error('\P{-LAOO/a/}');
    Expect(1, 3807, '\p{laoo}', "");
    Expect(0, 3807, '\p{^laoo}', "");
    Expect(0, 3807, '\P{laoo}', "");
    Expect(1, 3807, '\P{^laoo}', "");
    Expect(0, 3808, '\p{laoo}', "");
    Expect(1, 3808, '\p{^laoo}', "");
    Expect(1, 3808, '\P{laoo}', "");
    Expect(0, 3808, '\P{^laoo}', "");
    Expect(1, 3807, '\p{ LAOO}', "");
    Expect(0, 3807, '\p{^ LAOO}', "");
    Expect(0, 3807, '\P{ LAOO}', "");
    Expect(1, 3807, '\P{^ LAOO}', "");
    Expect(0, 3808, '\p{ LAOO}', "");
    Expect(1, 3808, '\p{^ LAOO}', "");
    Expect(1, 3808, '\P{ LAOO}', "");
    Expect(0, 3808, '\P{^ LAOO}', "");
    Error('\p{:=	Is_LAOO}');
    Error('\P{:=	Is_LAOO}');
    Expect(1, 3807, '\p{islaoo}', "");
    Expect(0, 3807, '\p{^islaoo}', "");
    Expect(0, 3807, '\P{islaoo}', "");
    Expect(1, 3807, '\P{^islaoo}', "");
    Expect(0, 3808, '\p{islaoo}', "");
    Expect(1, 3808, '\p{^islaoo}', "");
    Expect(1, 3808, '\P{islaoo}', "");
    Expect(0, 3808, '\P{^islaoo}', "");
    Expect(1, 3807, '\p{-_IS_LAOO}', "");
    Expect(0, 3807, '\p{^-_IS_LAOO}', "");
    Expect(0, 3807, '\P{-_IS_LAOO}', "");
    Expect(1, 3807, '\P{^-_IS_LAOO}', "");
    Expect(0, 3808, '\p{-_IS_LAOO}', "");
    Expect(1, 3808, '\p{^-_IS_LAOO}', "");
    Expect(1, 3808, '\P{-_IS_LAOO}', "");
    Expect(0, 3808, '\P{^-_IS_LAOO}', "");
    Error('\p{:=	LATIN}');
    Error('\P{:=	LATIN}');
    Expect(1, 65370, '\p{latin}', "");
    Expect(0, 65370, '\p{^latin}', "");
    Expect(0, 65370, '\P{latin}', "");
    Expect(1, 65370, '\P{^latin}', "");
    Expect(0, 65371, '\p{latin}', "");
    Expect(1, 65371, '\p{^latin}', "");
    Expect(1, 65371, '\P{latin}', "");
    Expect(0, 65371, '\P{^latin}', "");
    Expect(1, 65370, '\p{ -LATIN}', "");
    Expect(0, 65370, '\p{^ -LATIN}', "");
    Expect(0, 65370, '\P{ -LATIN}', "");
    Expect(1, 65370, '\P{^ -LATIN}', "");
    Expect(0, 65371, '\p{ -LATIN}', "");
    Expect(1, 65371, '\p{^ -LATIN}', "");
    Expect(1, 65371, '\P{ -LATIN}', "");
    Expect(0, 65371, '\P{^ -LATIN}', "");
    Error('\p{ :=Is_Latin}');
    Error('\P{ :=Is_Latin}');
    Expect(1, 65370, '\p{islatin}', "");
    Expect(0, 65370, '\p{^islatin}', "");
    Expect(0, 65370, '\P{islatin}', "");
    Expect(1, 65370, '\P{^islatin}', "");
    Expect(0, 65371, '\p{islatin}', "");
    Expect(1, 65371, '\p{^islatin}', "");
    Expect(1, 65371, '\P{islatin}', "");
    Expect(0, 65371, '\P{^islatin}', "");
    Expect(1, 65370, '\p{	is_Latin}', "");
    Expect(0, 65370, '\p{^	is_Latin}', "");
    Expect(0, 65370, '\P{	is_Latin}', "");
    Expect(1, 65370, '\P{^	is_Latin}', "");
    Expect(0, 65371, '\p{	is_Latin}', "");
    Expect(1, 65371, '\p{^	is_Latin}', "");
    Expect(1, 65371, '\P{	is_Latin}', "");
    Expect(0, 65371, '\P{^	is_Latin}', "");
    Error('\p{/a/- latn}');
    Error('\P{/a/- latn}');
    Expect(1, 65370, '\p{latn}', "");
    Expect(0, 65370, '\p{^latn}', "");
    Expect(0, 65370, '\P{latn}', "");
    Expect(1, 65370, '\P{^latn}', "");
    Expect(0, 65371, '\p{latn}', "");
    Expect(1, 65371, '\p{^latn}', "");
    Expect(1, 65371, '\P{latn}', "");
    Expect(0, 65371, '\P{^latn}', "");
    Expect(1, 65370, '\p{ Latn}', "");
    Expect(0, 65370, '\p{^ Latn}', "");
    Expect(0, 65370, '\P{ Latn}', "");
    Expect(1, 65370, '\P{^ Latn}', "");
    Expect(0, 65371, '\p{ Latn}', "");
    Expect(1, 65371, '\p{^ Latn}', "");
    Expect(1, 65371, '\P{ Latn}', "");
    Expect(0, 65371, '\P{^ Latn}', "");
    Error('\p{ _Is_LATN:=}');
    Error('\P{ _Is_LATN:=}');
    Expect(1, 65370, '\p{islatn}', "");
    Expect(0, 65370, '\p{^islatn}', "");
    Expect(0, 65370, '\P{islatn}', "");
    Expect(1, 65370, '\P{^islatn}', "");
    Expect(0, 65371, '\p{islatn}', "");
    Expect(1, 65371, '\p{^islatn}', "");
    Expect(1, 65371, '\P{islatn}', "");
    Expect(0, 65371, '\P{^islatn}', "");
    Expect(1, 65370, '\p{		is_Latn}', "");
    Expect(0, 65370, '\p{^		is_Latn}', "");
    Expect(0, 65370, '\P{		is_Latn}', "");
    Expect(1, 65370, '\P{^		is_Latn}', "");
    Expect(0, 65371, '\p{		is_Latn}', "");
    Expect(1, 65371, '\p{^		is_Latn}', "");
    Expect(1, 65371, '\P{		is_Latn}', "");
    Expect(0, 65371, '\P{^		is_Latn}', "");
    Error('\p{Latin_1_SUPPLEMENT/a/}');
    Error('\P{Latin_1_SUPPLEMENT/a/}');
    Expect(1, 255, '\p{latin1supplement}', "");
    Expect(0, 255, '\p{^latin1supplement}', "");
    Expect(0, 255, '\P{latin1supplement}', "");
    Expect(1, 255, '\P{^latin1supplement}', "");
    Expect(0, 256, '\p{latin1supplement}', "");
    Expect(1, 256, '\p{^latin1supplement}', "");
    Expect(1, 256, '\P{latin1supplement}', "");
    Expect(0, 256, '\P{^latin1supplement}', "");
    Expect(1, 255, '\p{-Latin_1_SUPPLEMENT}', "");
    Expect(0, 255, '\p{^-Latin_1_SUPPLEMENT}', "");
    Expect(0, 255, '\P{-Latin_1_SUPPLEMENT}', "");
    Expect(1, 255, '\P{^-Latin_1_SUPPLEMENT}', "");
    Expect(0, 256, '\p{-Latin_1_SUPPLEMENT}', "");
    Expect(1, 256, '\p{^-Latin_1_SUPPLEMENT}', "");
    Expect(1, 256, '\P{-Latin_1_SUPPLEMENT}', "");
    Expect(0, 256, '\P{^-Latin_1_SUPPLEMENT}', "");
    Error('\p{/a/	 Is_Latin_1_SUPPLEMENT}');
    Error('\P{/a/	 Is_Latin_1_SUPPLEMENT}');
    Expect(1, 255, '\p{islatin1supplement}', "");
    Expect(0, 255, '\p{^islatin1supplement}', "");
    Expect(0, 255, '\P{islatin1supplement}', "");
    Expect(1, 255, '\P{^islatin1supplement}', "");
    Expect(0, 256, '\p{islatin1supplement}', "");
    Expect(1, 256, '\p{^islatin1supplement}', "");
    Expect(1, 256, '\P{islatin1supplement}', "");
    Expect(0, 256, '\P{^islatin1supplement}', "");
    Expect(1, 255, '\p{_Is_Latin_1_Supplement}', "");
    Expect(0, 255, '\p{^_Is_Latin_1_Supplement}', "");
    Expect(0, 255, '\P{_Is_Latin_1_Supplement}', "");
    Expect(1, 255, '\P{^_Is_Latin_1_Supplement}', "");
    Expect(0, 256, '\p{_Is_Latin_1_Supplement}', "");
    Expect(1, 256, '\p{^_Is_Latin_1_Supplement}', "");
    Expect(1, 256, '\P{_Is_Latin_1_Supplement}', "");
    Expect(0, 256, '\P{^_Is_Latin_1_Supplement}', "");
    Error('\p{ _In_latin_1_supplement/a/}');
    Error('\P{ _In_latin_1_supplement/a/}');
    Expect(1, 255, '\p{inlatin1supplement}', "");
    Expect(0, 255, '\p{^inlatin1supplement}', "");
    Expect(0, 255, '\P{inlatin1supplement}', "");
    Expect(1, 255, '\P{^inlatin1supplement}', "");
    Expect(0, 256, '\p{inlatin1supplement}', "");
    Expect(1, 256, '\p{^inlatin1supplement}', "");
    Expect(1, 256, '\P{inlatin1supplement}', "");
    Expect(0, 256, '\P{^inlatin1supplement}', "");
    Expect(1, 255, '\p{_-In_Latin_1_Supplement}', "");
    Expect(0, 255, '\p{^_-In_Latin_1_Supplement}', "");
    Expect(0, 255, '\P{_-In_Latin_1_Supplement}', "");
    Expect(1, 255, '\P{^_-In_Latin_1_Supplement}', "");
    Expect(0, 256, '\p{_-In_Latin_1_Supplement}', "");
    Expect(1, 256, '\p{^_-In_Latin_1_Supplement}', "");
    Expect(1, 256, '\P{_-In_Latin_1_Supplement}', "");
    Expect(0, 256, '\P{^_-In_Latin_1_Supplement}', "");
    Error('\p{/a/-_LATIN_1_SUP}');
    Error('\P{/a/-_LATIN_1_SUP}');
    Expect(1, 255, '\p{latin1sup}', "");
    Expect(0, 255, '\p{^latin1sup}', "");
    Expect(0, 255, '\P{latin1sup}', "");
    Expect(1, 255, '\P{^latin1sup}', "");
    Expect(0, 256, '\p{latin1sup}', "");
    Expect(1, 256, '\p{^latin1sup}', "");
    Expect(1, 256, '\P{latin1sup}', "");
    Expect(0, 256, '\P{^latin1sup}', "");
    Expect(1, 255, '\p{	-latin_1_Sup}', "");
    Expect(0, 255, '\p{^	-latin_1_Sup}', "");
    Expect(0, 255, '\P{	-latin_1_Sup}', "");
    Expect(1, 255, '\P{^	-latin_1_Sup}', "");
    Expect(0, 256, '\p{	-latin_1_Sup}', "");
    Expect(1, 256, '\p{^	-latin_1_Sup}', "");
    Expect(1, 256, '\P{	-latin_1_Sup}', "");
    Expect(0, 256, '\P{^	-latin_1_Sup}', "");
    Error('\p{/a/-	IS_LATIN_1_Sup}');
    Error('\P{/a/-	IS_LATIN_1_Sup}');
    Expect(1, 255, '\p{islatin1sup}', "");
    Expect(0, 255, '\p{^islatin1sup}', "");
    Expect(0, 255, '\P{islatin1sup}', "");
    Expect(1, 255, '\P{^islatin1sup}', "");
    Expect(0, 256, '\p{islatin1sup}', "");
    Expect(1, 256, '\p{^islatin1sup}', "");
    Expect(1, 256, '\P{islatin1sup}', "");
    Expect(0, 256, '\P{^islatin1sup}', "");
    Expect(1, 255, '\p{	Is_Latin_1_Sup}', "");
    Expect(0, 255, '\p{^	Is_Latin_1_Sup}', "");
    Expect(0, 255, '\P{	Is_Latin_1_Sup}', "");
    Expect(1, 255, '\P{^	Is_Latin_1_Sup}', "");
    Expect(0, 256, '\p{	Is_Latin_1_Sup}', "");
    Expect(1, 256, '\p{^	Is_Latin_1_Sup}', "");
    Expect(1, 256, '\P{	Is_Latin_1_Sup}', "");
    Expect(0, 256, '\P{^	Is_Latin_1_Sup}', "");
    Error('\p{_In_LATIN_1_sup/a/}');
    Error('\P{_In_LATIN_1_sup/a/}');
    Expect(1, 255, '\p{inlatin1sup}', "");
    Expect(0, 255, '\p{^inlatin1sup}', "");
    Expect(0, 255, '\P{inlatin1sup}', "");
    Expect(1, 255, '\P{^inlatin1sup}', "");
    Expect(0, 256, '\p{inlatin1sup}', "");
    Expect(1, 256, '\p{^inlatin1sup}', "");
    Expect(1, 256, '\P{inlatin1sup}', "");
    Expect(0, 256, '\P{^inlatin1sup}', "");
    Expect(1, 255, '\p{	In_Latin_1_Sup}', "");
    Expect(0, 255, '\p{^	In_Latin_1_Sup}', "");
    Expect(0, 255, '\P{	In_Latin_1_Sup}', "");
    Expect(1, 255, '\P{^	In_Latin_1_Sup}', "");
    Expect(0, 256, '\p{	In_Latin_1_Sup}', "");
    Expect(1, 256, '\p{^	In_Latin_1_Sup}', "");
    Expect(1, 256, '\P{	In_Latin_1_Sup}', "");
    Expect(0, 256, '\P{^	In_Latin_1_Sup}', "");
    Error('\p{__Latin_1:=}');
    Error('\P{__Latin_1:=}');
    Expect(1, 255, '\p{latin1}', "");
    Expect(0, 255, '\p{^latin1}', "");
    Expect(0, 255, '\P{latin1}', "");
    Expect(1, 255, '\P{^latin1}', "");
    Expect(0, 256, '\p{latin1}', "");
    Expect(1, 256, '\p{^latin1}', "");
    Expect(1, 256, '\P{latin1}', "");
    Expect(0, 256, '\P{^latin1}', "");
    Expect(1, 255, '\p{	-LATIN_1}', "");
    Expect(0, 255, '\p{^	-LATIN_1}', "");
    Expect(0, 255, '\P{	-LATIN_1}', "");
    Expect(1, 255, '\P{^	-LATIN_1}', "");
    Expect(0, 256, '\p{	-LATIN_1}', "");
    Expect(1, 256, '\p{^	-LATIN_1}', "");
    Expect(1, 256, '\P{	-LATIN_1}', "");
    Expect(0, 256, '\P{^	-LATIN_1}', "");
    Error('\p{-_Is_LATIN_1:=}');
    Error('\P{-_Is_LATIN_1:=}');
    Expect(1, 255, '\p{islatin1}', "");
    Expect(0, 255, '\p{^islatin1}', "");
    Expect(0, 255, '\P{islatin1}', "");
    Expect(1, 255, '\P{^islatin1}', "");
    Expect(0, 256, '\p{islatin1}', "");
    Expect(1, 256, '\p{^islatin1}', "");
    Expect(1, 256, '\P{islatin1}', "");
    Expect(0, 256, '\P{^islatin1}', "");
    Expect(1, 255, '\p{ -Is_Latin_1}', "");
    Expect(0, 255, '\p{^ -Is_Latin_1}', "");
    Expect(0, 255, '\P{ -Is_Latin_1}', "");
    Expect(1, 255, '\P{^ -Is_Latin_1}', "");
    Expect(0, 256, '\p{ -Is_Latin_1}', "");
    Expect(1, 256, '\p{^ -Is_Latin_1}', "");
    Expect(1, 256, '\P{ -Is_Latin_1}', "");
    Expect(0, 256, '\P{^ -Is_Latin_1}', "");
    Error('\p{:=-_in_Latin_1}');
    Error('\P{:=-_in_Latin_1}');
    Expect(1, 255, '\p{inlatin1}', "");
    Expect(0, 255, '\p{^inlatin1}', "");
    Expect(0, 255, '\P{inlatin1}', "");
    Expect(1, 255, '\P{^inlatin1}', "");
    Expect(0, 256, '\p{inlatin1}', "");
    Expect(1, 256, '\p{^inlatin1}', "");
    Expect(1, 256, '\P{inlatin1}', "");
    Expect(0, 256, '\P{^inlatin1}', "");
    Expect(1, 255, '\p{  in_latin_1}', "");
    Expect(0, 255, '\p{^  in_latin_1}', "");
    Expect(0, 255, '\P{  in_latin_1}', "");
    Expect(1, 255, '\P{^  in_latin_1}', "");
    Expect(0, 256, '\p{  in_latin_1}', "");
    Expect(1, 256, '\p{^  in_latin_1}', "");
    Expect(1, 256, '\P{  in_latin_1}', "");
    Expect(0, 256, '\P{^  in_latin_1}', "");
    Error('\p{-/a/latin_EXTENDED_a}');
    Error('\P{-/a/latin_EXTENDED_a}');
    Expect(1, 383, '\p{latinextendeda}', "");
    Expect(0, 383, '\p{^latinextendeda}', "");
    Expect(0, 383, '\P{latinextendeda}', "");
    Expect(1, 383, '\P{^latinextendeda}', "");
    Expect(0, 384, '\p{latinextendeda}', "");
    Expect(1, 384, '\p{^latinextendeda}', "");
    Expect(1, 384, '\P{latinextendeda}', "");
    Expect(0, 384, '\P{^latinextendeda}', "");
    Expect(1, 383, '\p{	-LATIN_Extended_A}', "");
    Expect(0, 383, '\p{^	-LATIN_Extended_A}', "");
    Expect(0, 383, '\P{	-LATIN_Extended_A}', "");
    Expect(1, 383, '\P{^	-LATIN_Extended_A}', "");
    Expect(0, 384, '\p{	-LATIN_Extended_A}', "");
    Expect(1, 384, '\p{^	-LATIN_Extended_A}', "");
    Expect(1, 384, '\P{	-LATIN_Extended_A}', "");
    Expect(0, 384, '\P{^	-LATIN_Extended_A}', "");
    Error('\p{:=Is_latin_extended_A}');
    Error('\P{:=Is_latin_extended_A}');
    Expect(1, 383, '\p{islatinextendeda}', "");
    Expect(0, 383, '\p{^islatinextendeda}', "");
    Expect(0, 383, '\P{islatinextendeda}', "");
    Expect(1, 383, '\P{^islatinextendeda}', "");
    Expect(0, 384, '\p{islatinextendeda}', "");
    Expect(1, 384, '\p{^islatinextendeda}', "");
    Expect(1, 384, '\P{islatinextendeda}', "");
    Expect(0, 384, '\P{^islatinextendeda}', "");
    Expect(1, 383, '\p{	Is_Latin_EXTENDED_A}', "");
    Expect(0, 383, '\p{^	Is_Latin_EXTENDED_A}', "");
    Expect(0, 383, '\P{	Is_Latin_EXTENDED_A}', "");
    Expect(1, 383, '\P{^	Is_Latin_EXTENDED_A}', "");
    Expect(0, 384, '\p{	Is_Latin_EXTENDED_A}', "");
    Expect(1, 384, '\p{^	Is_Latin_EXTENDED_A}', "");
    Expect(1, 384, '\P{	Is_Latin_EXTENDED_A}', "");
    Expect(0, 384, '\P{^	Is_Latin_EXTENDED_A}', "");
    Error('\p{:= In_latin_EXTENDED_a}');
    Error('\P{:= In_latin_EXTENDED_a}');
    Expect(1, 383, '\p{inlatinextendeda}', "");
    Expect(0, 383, '\p{^inlatinextendeda}', "");
    Expect(0, 383, '\P{inlatinextendeda}', "");
    Expect(1, 383, '\P{^inlatinextendeda}', "");
    Expect(0, 384, '\p{inlatinextendeda}', "");
    Expect(1, 384, '\p{^inlatinextendeda}', "");
    Expect(1, 384, '\P{inlatinextendeda}', "");
    Expect(0, 384, '\P{^inlatinextendeda}', "");
    Expect(1, 383, '\p{	In_Latin_Extended_A}', "");
    Expect(0, 383, '\p{^	In_Latin_Extended_A}', "");
    Expect(0, 383, '\P{	In_Latin_Extended_A}', "");
    Expect(1, 383, '\P{^	In_Latin_Extended_A}', "");
    Expect(0, 384, '\p{	In_Latin_Extended_A}', "");
    Expect(1, 384, '\p{^	In_Latin_Extended_A}', "");
    Expect(1, 384, '\P{	In_Latin_Extended_A}', "");
    Expect(0, 384, '\P{^	In_Latin_Extended_A}', "");
    Error('\p{-:=LATIN_EXT_A}');
    Error('\P{-:=LATIN_EXT_A}');
    Expect(1, 383, '\p{latinexta}', "");
    Expect(0, 383, '\p{^latinexta}', "");
    Expect(0, 383, '\P{latinexta}', "");
    Expect(1, 383, '\P{^latinexta}', "");
    Expect(0, 384, '\p{latinexta}', "");
    Expect(1, 384, '\p{^latinexta}', "");
    Expect(1, 384, '\P{latinexta}', "");
    Expect(0, 384, '\P{^latinexta}', "");
    Expect(1, 383, '\p{		latin_ext_A}', "");
    Expect(0, 383, '\p{^		latin_ext_A}', "");
    Expect(0, 383, '\P{		latin_ext_A}', "");
    Expect(1, 383, '\P{^		latin_ext_A}', "");
    Expect(0, 384, '\p{		latin_ext_A}', "");
    Expect(1, 384, '\p{^		latin_ext_A}', "");
    Expect(1, 384, '\P{		latin_ext_A}', "");
    Expect(0, 384, '\P{^		latin_ext_A}', "");
    Error('\p{- Is_LATIN_Ext_A/a/}');
    Error('\P{- Is_LATIN_Ext_A/a/}');
    Expect(1, 383, '\p{islatinexta}', "");
    Expect(0, 383, '\p{^islatinexta}', "");
    Expect(0, 383, '\P{islatinexta}', "");
    Expect(1, 383, '\P{^islatinexta}', "");
    Expect(0, 384, '\p{islatinexta}', "");
    Expect(1, 384, '\p{^islatinexta}', "");
    Expect(1, 384, '\P{islatinexta}', "");
    Expect(0, 384, '\P{^islatinexta}', "");
    Expect(1, 383, '\p{	 Is_latin_EXT_a}', "");
    Expect(0, 383, '\p{^	 Is_latin_EXT_a}', "");
    Expect(0, 383, '\P{	 Is_latin_EXT_a}', "");
    Expect(1, 383, '\P{^	 Is_latin_EXT_a}', "");
    Expect(0, 384, '\p{	 Is_latin_EXT_a}', "");
    Expect(1, 384, '\p{^	 Is_latin_EXT_a}', "");
    Expect(1, 384, '\P{	 Is_latin_EXT_a}', "");
    Expect(0, 384, '\P{^	 Is_latin_EXT_a}', "");
    Error('\p{:=--In_Latin_EXT_A}');
    Error('\P{:=--In_Latin_EXT_A}');
    Expect(1, 383, '\p{inlatinexta}', "");
    Expect(0, 383, '\p{^inlatinexta}', "");
    Expect(0, 383, '\P{inlatinexta}', "");
    Expect(1, 383, '\P{^inlatinexta}', "");
    Expect(0, 384, '\p{inlatinexta}', "");
    Expect(1, 384, '\p{^inlatinexta}', "");
    Expect(1, 384, '\P{inlatinexta}', "");
    Expect(0, 384, '\P{^inlatinexta}', "");
    Expect(1, 383, '\p{__In_latin_ext_A}', "");
    Expect(0, 383, '\p{^__In_latin_ext_A}', "");
    Expect(0, 383, '\P{__In_latin_ext_A}', "");
    Expect(1, 383, '\P{^__In_latin_ext_A}', "");
    Expect(0, 384, '\p{__In_latin_ext_A}', "");
    Expect(1, 384, '\p{^__In_latin_ext_A}', "");
    Expect(1, 384, '\P{__In_latin_ext_A}', "");
    Expect(0, 384, '\P{^__In_latin_ext_A}', "");
    Error('\p{/a/__Latin_EXTENDED_Additional}');
    Error('\P{/a/__Latin_EXTENDED_Additional}');
    Expect(1, 7935, '\p{latinextendedadditional}', "");
    Expect(0, 7935, '\p{^latinextendedadditional}', "");
    Expect(0, 7935, '\P{latinextendedadditional}', "");
    Expect(1, 7935, '\P{^latinextendedadditional}', "");
    Expect(0, 7936, '\p{latinextendedadditional}', "");
    Expect(1, 7936, '\p{^latinextendedadditional}', "");
    Expect(1, 7936, '\P{latinextendedadditional}', "");
    Expect(0, 7936, '\P{^latinextendedadditional}', "");
    Expect(1, 7935, '\p{	_Latin_Extended_Additional}', "");
    Expect(0, 7935, '\p{^	_Latin_Extended_Additional}', "");
    Expect(0, 7935, '\P{	_Latin_Extended_Additional}', "");
    Expect(1, 7935, '\P{^	_Latin_Extended_Additional}', "");
    Expect(0, 7936, '\p{	_Latin_Extended_Additional}', "");
    Expect(1, 7936, '\p{^	_Latin_Extended_Additional}', "");
    Expect(1, 7936, '\P{	_Latin_Extended_Additional}', "");
    Expect(0, 7936, '\P{^	_Latin_Extended_Additional}', "");
    Error('\p{ Is_Latin_Extended_Additional:=}');
    Error('\P{ Is_Latin_Extended_Additional:=}');
    Expect(1, 7935, '\p{islatinextendedadditional}', "");
    Expect(0, 7935, '\p{^islatinextendedadditional}', "");
    Expect(0, 7935, '\P{islatinextendedadditional}', "");
    Expect(1, 7935, '\P{^islatinextendedadditional}', "");
    Expect(0, 7936, '\p{islatinextendedadditional}', "");
    Expect(1, 7936, '\p{^islatinextendedadditional}', "");
    Expect(1, 7936, '\P{islatinextendedadditional}', "");
    Expect(0, 7936, '\P{^islatinextendedadditional}', "");
    Expect(1, 7935, '\p{- is_Latin_Extended_ADDITIONAL}', "");
    Expect(0, 7935, '\p{^- is_Latin_Extended_ADDITIONAL}', "");
    Expect(0, 7935, '\P{- is_Latin_Extended_ADDITIONAL}', "");
    Expect(1, 7935, '\P{^- is_Latin_Extended_ADDITIONAL}', "");
    Expect(0, 7936, '\p{- is_Latin_Extended_ADDITIONAL}', "");
    Expect(1, 7936, '\p{^- is_Latin_Extended_ADDITIONAL}', "");
    Expect(1, 7936, '\P{- is_Latin_Extended_ADDITIONAL}', "");
    Expect(0, 7936, '\P{^- is_Latin_Extended_ADDITIONAL}', "");
    Error('\p{/a/	in_LATIN_Extended_additional}');
    Error('\P{/a/	in_LATIN_Extended_additional}');
    Expect(1, 7935, '\p{inlatinextendedadditional}', "");
    Expect(0, 7935, '\p{^inlatinextendedadditional}', "");
    Expect(0, 7935, '\P{inlatinextendedadditional}', "");
    Expect(1, 7935, '\P{^inlatinextendedadditional}', "");
    Expect(0, 7936, '\p{inlatinextendedadditional}', "");
    Expect(1, 7936, '\p{^inlatinextendedadditional}', "");
    Expect(1, 7936, '\P{inlatinextendedadditional}', "");
    Expect(0, 7936, '\P{^inlatinextendedadditional}', "");
    Expect(1, 7935, '\p{_In_Latin_Extended_Additional}', "");
    Expect(0, 7935, '\p{^_In_Latin_Extended_Additional}', "");
    Expect(0, 7935, '\P{_In_Latin_Extended_Additional}', "");
    Expect(1, 7935, '\P{^_In_Latin_Extended_Additional}', "");
    Expect(0, 7936, '\p{_In_Latin_Extended_Additional}', "");
    Expect(1, 7936, '\p{^_In_Latin_Extended_Additional}', "");
    Expect(1, 7936, '\P{_In_Latin_Extended_Additional}', "");
    Expect(0, 7936, '\P{^_In_Latin_Extended_Additional}', "");
    Error('\p{	latin_ext_Additional/a/}');
    Error('\P{	latin_ext_Additional/a/}');
    Expect(1, 7935, '\p{latinextadditional}', "");
    Expect(0, 7935, '\p{^latinextadditional}', "");
    Expect(0, 7935, '\P{latinextadditional}', "");
    Expect(1, 7935, '\P{^latinextadditional}', "");
    Expect(0, 7936, '\p{latinextadditional}', "");
    Expect(1, 7936, '\p{^latinextadditional}', "");
    Expect(1, 7936, '\P{latinextadditional}', "");
    Expect(0, 7936, '\P{^latinextadditional}', "");
    Expect(1, 7935, '\p{	latin_ext_Additional}', "");
    Expect(0, 7935, '\p{^	latin_ext_Additional}', "");
    Expect(0, 7935, '\P{	latin_ext_Additional}', "");
    Expect(1, 7935, '\P{^	latin_ext_Additional}', "");
    Expect(0, 7936, '\p{	latin_ext_Additional}', "");
    Expect(1, 7936, '\p{^	latin_ext_Additional}', "");
    Expect(1, 7936, '\P{	latin_ext_Additional}', "");
    Expect(0, 7936, '\P{^	latin_ext_Additional}', "");
    Error('\p{-	Is_LATIN_Ext_ADDITIONAL:=}');
    Error('\P{-	Is_LATIN_Ext_ADDITIONAL:=}');
    Expect(1, 7935, '\p{islatinextadditional}', "");
    Expect(0, 7935, '\p{^islatinextadditional}', "");
    Expect(0, 7935, '\P{islatinextadditional}', "");
    Expect(1, 7935, '\P{^islatinextadditional}', "");
    Expect(0, 7936, '\p{islatinextadditional}', "");
    Expect(1, 7936, '\p{^islatinextadditional}', "");
    Expect(1, 7936, '\P{islatinextadditional}', "");
    Expect(0, 7936, '\P{^islatinextadditional}', "");
    Expect(1, 7935, '\p{	_is_LATIN_ext_additional}', "");
    Expect(0, 7935, '\p{^	_is_LATIN_ext_additional}', "");
    Expect(0, 7935, '\P{	_is_LATIN_ext_additional}', "");
    Expect(1, 7935, '\P{^	_is_LATIN_ext_additional}', "");
    Expect(0, 7936, '\p{	_is_LATIN_ext_additional}', "");
    Expect(1, 7936, '\p{^	_is_LATIN_ext_additional}', "");
    Expect(1, 7936, '\P{	_is_LATIN_ext_additional}', "");
    Expect(0, 7936, '\P{^	_is_LATIN_ext_additional}', "");
    Error('\p{_	in_latin_EXT_Additional:=}');
    Error('\P{_	in_latin_EXT_Additional:=}');
    Expect(1, 7935, '\p{inlatinextadditional}', "");
    Expect(0, 7935, '\p{^inlatinextadditional}', "");
    Expect(0, 7935, '\P{inlatinextadditional}', "");
    Expect(1, 7935, '\P{^inlatinextadditional}', "");
    Expect(0, 7936, '\p{inlatinextadditional}', "");
    Expect(1, 7936, '\p{^inlatinextadditional}', "");
    Expect(1, 7936, '\P{inlatinextadditional}', "");
    Expect(0, 7936, '\P{^inlatinextadditional}', "");
    Expect(1, 7935, '\p{ _In_LATIN_Ext_Additional}', "");
    Expect(0, 7935, '\p{^ _In_LATIN_Ext_Additional}', "");
    Expect(0, 7935, '\P{ _In_LATIN_Ext_Additional}', "");
    Expect(1, 7935, '\P{^ _In_LATIN_Ext_Additional}', "");
    Expect(0, 7936, '\p{ _In_LATIN_Ext_Additional}', "");
    Expect(1, 7936, '\p{^ _In_LATIN_Ext_Additional}', "");
    Expect(1, 7936, '\P{ _In_LATIN_Ext_Additional}', "");
    Expect(0, 7936, '\P{^ _In_LATIN_Ext_Additional}', "");
    Error('\p{:=-_LATIN_EXTENDED_B}');
    Error('\P{:=-_LATIN_EXTENDED_B}');
    Expect(1, 591, '\p{latinextendedb}', "");
    Expect(0, 591, '\p{^latinextendedb}', "");
    Expect(0, 591, '\P{latinextendedb}', "");
    Expect(1, 591, '\P{^latinextendedb}', "");
    Expect(0, 592, '\p{latinextendedb}', "");
    Expect(1, 592, '\p{^latinextendedb}', "");
    Expect(1, 592, '\P{latinextendedb}', "");
    Expect(0, 592, '\P{^latinextendedb}', "");
    Expect(1, 591, '\p{	 LATIN_Extended_B}', "");
    Expect(0, 591, '\p{^	 LATIN_Extended_B}', "");
    Expect(0, 591, '\P{	 LATIN_Extended_B}', "");
    Expect(1, 591, '\P{^	 LATIN_Extended_B}', "");
    Expect(0, 592, '\p{	 LATIN_Extended_B}', "");
    Expect(1, 592, '\p{^	 LATIN_Extended_B}', "");
    Expect(1, 592, '\P{	 LATIN_Extended_B}', "");
    Expect(0, 592, '\P{^	 LATIN_Extended_B}', "");
    Error('\p{_IS_LATIN_extended_B:=}');
    Error('\P{_IS_LATIN_extended_B:=}');
    Expect(1, 591, '\p{islatinextendedb}', "");
    Expect(0, 591, '\p{^islatinextendedb}', "");
    Expect(0, 591, '\P{islatinextendedb}', "");
    Expect(1, 591, '\P{^islatinextendedb}', "");
    Expect(0, 592, '\p{islatinextendedb}', "");
    Expect(1, 592, '\p{^islatinextendedb}', "");
    Expect(1, 592, '\P{islatinextendedb}', "");
    Expect(0, 592, '\P{^islatinextendedb}', "");
    Expect(1, 591, '\p{ 	is_Latin_Extended_B}', "");
    Expect(0, 591, '\p{^ 	is_Latin_Extended_B}', "");
    Expect(0, 591, '\P{ 	is_Latin_Extended_B}', "");
    Expect(1, 591, '\P{^ 	is_Latin_Extended_B}', "");
    Expect(0, 592, '\p{ 	is_Latin_Extended_B}', "");
    Expect(1, 592, '\p{^ 	is_Latin_Extended_B}', "");
    Expect(1, 592, '\P{ 	is_Latin_Extended_B}', "");
    Expect(0, 592, '\P{^ 	is_Latin_Extended_B}', "");
    Error('\p{/a/		In_LATIN_extended_b}');
    Error('\P{/a/		In_LATIN_extended_b}');
    Expect(1, 591, '\p{inlatinextendedb}', "");
    Expect(0, 591, '\p{^inlatinextendedb}', "");
    Expect(0, 591, '\P{inlatinextendedb}', "");
    Expect(1, 591, '\P{^inlatinextendedb}', "");
    Expect(0, 592, '\p{inlatinextendedb}', "");
    Expect(1, 592, '\p{^inlatinextendedb}', "");
    Expect(1, 592, '\P{inlatinextendedb}', "");
    Expect(0, 592, '\P{^inlatinextendedb}', "");
    Expect(1, 591, '\p{-	IN_Latin_extended_B}', "");
    Expect(0, 591, '\p{^-	IN_Latin_extended_B}', "");
    Expect(0, 591, '\P{-	IN_Latin_extended_B}', "");
    Expect(1, 591, '\P{^-	IN_Latin_extended_B}', "");
    Expect(0, 592, '\p{-	IN_Latin_extended_B}', "");
    Expect(1, 592, '\p{^-	IN_Latin_extended_B}', "");
    Expect(1, 592, '\P{-	IN_Latin_extended_B}', "");
    Expect(0, 592, '\P{^-	IN_Latin_extended_B}', "");
    Error('\p{/a/LATIN_EXT_B}');
    Error('\P{/a/LATIN_EXT_B}');
    Expect(1, 591, '\p{latinextb}', "");
    Expect(0, 591, '\p{^latinextb}', "");
    Expect(0, 591, '\P{latinextb}', "");
    Expect(1, 591, '\P{^latinextb}', "");
    Expect(0, 592, '\p{latinextb}', "");
    Expect(1, 592, '\p{^latinextb}', "");
    Expect(1, 592, '\P{latinextb}', "");
    Expect(0, 592, '\P{^latinextb}', "");
    Expect(1, 591, '\p{ 	LATIN_Ext_B}', "");
    Expect(0, 591, '\p{^ 	LATIN_Ext_B}', "");
    Expect(0, 591, '\P{ 	LATIN_Ext_B}', "");
    Expect(1, 591, '\P{^ 	LATIN_Ext_B}', "");
    Expect(0, 592, '\p{ 	LATIN_Ext_B}', "");
    Expect(1, 592, '\p{^ 	LATIN_Ext_B}', "");
    Expect(1, 592, '\P{ 	LATIN_Ext_B}', "");
    Expect(0, 592, '\P{^ 	LATIN_Ext_B}', "");
    Error('\p{_/a/is_Latin_Ext_B}');
    Error('\P{_/a/is_Latin_Ext_B}');
    Expect(1, 591, '\p{islatinextb}', "");
    Expect(0, 591, '\p{^islatinextb}', "");
    Expect(0, 591, '\P{islatinextb}', "");
    Expect(1, 591, '\P{^islatinextb}', "");
    Expect(0, 592, '\p{islatinextb}', "");
    Expect(1, 592, '\p{^islatinextb}', "");
    Expect(1, 592, '\P{islatinextb}', "");
    Expect(0, 592, '\P{^islatinextb}', "");
    Expect(1, 591, '\p{	-Is_LATIN_EXT_B}', "");
    Expect(0, 591, '\p{^	-Is_LATIN_EXT_B}', "");
    Expect(0, 591, '\P{	-Is_LATIN_EXT_B}', "");
    Expect(1, 591, '\P{^	-Is_LATIN_EXT_B}', "");
    Expect(0, 592, '\p{	-Is_LATIN_EXT_B}', "");
    Expect(1, 592, '\p{^	-Is_LATIN_EXT_B}', "");
    Expect(1, 592, '\P{	-Is_LATIN_EXT_B}', "");
    Expect(0, 592, '\P{^	-Is_LATIN_EXT_B}', "");
    Error('\p{ in_Latin_EXT_B/a/}');
    Error('\P{ in_Latin_EXT_B/a/}');
    Expect(1, 591, '\p{inlatinextb}', "");
    Expect(0, 591, '\p{^inlatinextb}', "");
    Expect(0, 591, '\P{inlatinextb}', "");
    Expect(1, 591, '\P{^inlatinextb}', "");
    Expect(0, 592, '\p{inlatinextb}', "");
    Expect(1, 592, '\p{^inlatinextb}', "");
    Expect(1, 592, '\P{inlatinextb}', "");
    Expect(0, 592, '\P{^inlatinextb}', "");
    Expect(1, 591, '\p{	 IN_latin_EXT_B}', "");
    Expect(0, 591, '\p{^	 IN_latin_EXT_B}', "");
    Expect(0, 591, '\P{	 IN_latin_EXT_B}', "");
    Expect(1, 591, '\P{^	 IN_latin_EXT_B}', "");
    Expect(0, 592, '\p{	 IN_latin_EXT_B}', "");
    Expect(1, 592, '\p{^	 IN_latin_EXT_B}', "");
    Expect(1, 592, '\P{	 IN_latin_EXT_B}', "");
    Expect(0, 592, '\P{^	 IN_latin_EXT_B}', "");
    Error('\p{/a/-_LATIN_extended_C}');
    Error('\P{/a/-_LATIN_extended_C}');
    Expect(1, 11391, '\p{latinextendedc}', "");
    Expect(0, 11391, '\p{^latinextendedc}', "");
    Expect(0, 11391, '\P{latinextendedc}', "");
    Expect(1, 11391, '\P{^latinextendedc}', "");
    Expect(0, 11392, '\p{latinextendedc}', "");
    Expect(1, 11392, '\p{^latinextendedc}', "");
    Expect(1, 11392, '\P{latinextendedc}', "");
    Expect(0, 11392, '\P{^latinextendedc}', "");
    Expect(1, 11391, '\p{ -Latin_EXTENDED_C}', "");
    Expect(0, 11391, '\p{^ -Latin_EXTENDED_C}', "");
    Expect(0, 11391, '\P{ -Latin_EXTENDED_C}', "");
    Expect(1, 11391, '\P{^ -Latin_EXTENDED_C}', "");
    Expect(0, 11392, '\p{ -Latin_EXTENDED_C}', "");
    Expect(1, 11392, '\p{^ -Latin_EXTENDED_C}', "");
    Expect(1, 11392, '\P{ -Latin_EXTENDED_C}', "");
    Expect(0, 11392, '\P{^ -Latin_EXTENDED_C}', "");
    Error('\p{-:=is_LATIN_Extended_C}');
    Error('\P{-:=is_LATIN_Extended_C}');
    Expect(1, 11391, '\p{islatinextendedc}', "");
    Expect(0, 11391, '\p{^islatinextendedc}', "");
    Expect(0, 11391, '\P{islatinextendedc}', "");
    Expect(1, 11391, '\P{^islatinextendedc}', "");
    Expect(0, 11392, '\p{islatinextendedc}', "");
    Expect(1, 11392, '\p{^islatinextendedc}', "");
    Expect(1, 11392, '\P{islatinextendedc}', "");
    Expect(0, 11392, '\P{^islatinextendedc}', "");
    Expect(1, 11391, '\p{ 	Is_latin_Extended_C}', "");
    Expect(0, 11391, '\p{^ 	Is_latin_Extended_C}', "");
    Expect(0, 11391, '\P{ 	Is_latin_Extended_C}', "");
    Expect(1, 11391, '\P{^ 	Is_latin_Extended_C}', "");
    Expect(0, 11392, '\p{ 	Is_latin_Extended_C}', "");
    Expect(1, 11392, '\p{^ 	Is_latin_Extended_C}', "");
    Expect(1, 11392, '\P{ 	Is_latin_Extended_C}', "");
    Expect(0, 11392, '\P{^ 	Is_latin_Extended_C}', "");
    Error('\p{_/a/in_LATIN_EXTENDED_C}');
    Error('\P{_/a/in_LATIN_EXTENDED_C}');
    Expect(1, 11391, '\p{inlatinextendedc}', "");
    Expect(0, 11391, '\p{^inlatinextendedc}', "");
    Expect(0, 11391, '\P{inlatinextendedc}', "");
    Expect(1, 11391, '\P{^inlatinextendedc}', "");
    Expect(0, 11392, '\p{inlatinextendedc}', "");
    Expect(1, 11392, '\p{^inlatinextendedc}', "");
    Expect(1, 11392, '\P{inlatinextendedc}', "");
    Expect(0, 11392, '\P{^inlatinextendedc}', "");
    Expect(1, 11391, '\p{ _In_Latin_Extended_c}', "");
    Expect(0, 11391, '\p{^ _In_Latin_Extended_c}', "");
    Expect(0, 11391, '\P{ _In_Latin_Extended_c}', "");
    Expect(1, 11391, '\P{^ _In_Latin_Extended_c}', "");
    Expect(0, 11392, '\p{ _In_Latin_Extended_c}', "");
    Expect(1, 11392, '\p{^ _In_Latin_Extended_c}', "");
    Expect(1, 11392, '\P{ _In_Latin_Extended_c}', "");
    Expect(0, 11392, '\P{^ _In_Latin_Extended_c}', "");
    Error('\p{/a/	-Latin_EXT_C}');
    Error('\P{/a/	-Latin_EXT_C}');
    Expect(1, 11391, '\p{latinextc}', "");
    Expect(0, 11391, '\p{^latinextc}', "");
    Expect(0, 11391, '\P{latinextc}', "");
    Expect(1, 11391, '\P{^latinextc}', "");
    Expect(0, 11392, '\p{latinextc}', "");
    Expect(1, 11392, '\p{^latinextc}', "");
    Expect(1, 11392, '\P{latinextc}', "");
    Expect(0, 11392, '\P{^latinextc}', "");
    Expect(1, 11391, '\p{ _Latin_Ext_C}', "");
    Expect(0, 11391, '\p{^ _Latin_Ext_C}', "");
    Expect(0, 11391, '\P{ _Latin_Ext_C}', "");
    Expect(1, 11391, '\P{^ _Latin_Ext_C}', "");
    Expect(0, 11392, '\p{ _Latin_Ext_C}', "");
    Expect(1, 11392, '\p{^ _Latin_Ext_C}', "");
    Expect(1, 11392, '\P{ _Latin_Ext_C}', "");
    Expect(0, 11392, '\P{^ _Latin_Ext_C}', "");
    Error('\p{ Is_latin_Ext_C:=}');
    Error('\P{ Is_latin_Ext_C:=}');
    Expect(1, 11391, '\p{islatinextc}', "");
    Expect(0, 11391, '\p{^islatinextc}', "");
    Expect(0, 11391, '\P{islatinextc}', "");
    Expect(1, 11391, '\P{^islatinextc}', "");
    Expect(0, 11392, '\p{islatinextc}', "");
    Expect(1, 11392, '\p{^islatinextc}', "");
    Expect(1, 11392, '\P{islatinextc}', "");
    Expect(0, 11392, '\P{^islatinextc}', "");
    Expect(1, 11391, '\p{ 	Is_LATIN_Ext_C}', "");
    Expect(0, 11391, '\p{^ 	Is_LATIN_Ext_C}', "");
    Expect(0, 11391, '\P{ 	Is_LATIN_Ext_C}', "");
    Expect(1, 11391, '\P{^ 	Is_LATIN_Ext_C}', "");
    Expect(0, 11392, '\p{ 	Is_LATIN_Ext_C}', "");
    Expect(1, 11392, '\p{^ 	Is_LATIN_Ext_C}', "");
    Expect(1, 11392, '\P{ 	Is_LATIN_Ext_C}', "");
    Expect(0, 11392, '\P{^ 	Is_LATIN_Ext_C}', "");
    Error('\p{/a/-In_Latin_Ext_c}');
    Error('\P{/a/-In_Latin_Ext_c}');
    Expect(1, 11391, '\p{inlatinextc}', "");
    Expect(0, 11391, '\p{^inlatinextc}', "");
    Expect(0, 11391, '\P{inlatinextc}', "");
    Expect(1, 11391, '\P{^inlatinextc}', "");
    Expect(0, 11392, '\p{inlatinextc}', "");
    Expect(1, 11392, '\p{^inlatinextc}', "");
    Expect(1, 11392, '\P{inlatinextc}', "");
    Expect(0, 11392, '\P{^inlatinextc}', "");
    Expect(1, 11391, '\p{ IN_Latin_ext_C}', "");
    Expect(0, 11391, '\p{^ IN_Latin_ext_C}', "");
    Expect(0, 11391, '\P{ IN_Latin_ext_C}', "");
    Expect(1, 11391, '\P{^ IN_Latin_ext_C}', "");
    Expect(0, 11392, '\p{ IN_Latin_ext_C}', "");
    Expect(1, 11392, '\p{^ IN_Latin_ext_C}', "");
    Expect(1, 11392, '\P{ IN_Latin_ext_C}', "");
    Expect(0, 11392, '\P{^ IN_Latin_ext_C}', "");
    Error('\p{/a/Latin_EXTENDED_D}');
    Error('\P{/a/Latin_EXTENDED_D}');
    Expect(1, 43007, '\p{latinextendedd}', "");
    Expect(0, 43007, '\p{^latinextendedd}', "");
    Expect(0, 43007, '\P{latinextendedd}', "");
    Expect(1, 43007, '\P{^latinextendedd}', "");
    Expect(0, 43008, '\p{latinextendedd}', "");
    Expect(1, 43008, '\p{^latinextendedd}', "");
    Expect(1, 43008, '\P{latinextendedd}', "");
    Expect(0, 43008, '\P{^latinextendedd}', "");
    Expect(1, 43007, '\p{ -Latin_extended_D}', "");
    Expect(0, 43007, '\p{^ -Latin_extended_D}', "");
    Expect(0, 43007, '\P{ -Latin_extended_D}', "");
    Expect(1, 43007, '\P{^ -Latin_extended_D}', "");
    Expect(0, 43008, '\p{ -Latin_extended_D}', "");
    Expect(1, 43008, '\p{^ -Latin_extended_D}', "");
    Expect(1, 43008, '\P{ -Latin_extended_D}', "");
    Expect(0, 43008, '\P{^ -Latin_extended_D}', "");
    Error('\p{/a/ Is_Latin_Extended_D}');
    Error('\P{/a/ Is_Latin_Extended_D}');
    Expect(1, 43007, '\p{islatinextendedd}', "");
    Expect(0, 43007, '\p{^islatinextendedd}', "");
    Expect(0, 43007, '\P{islatinextendedd}', "");
    Expect(1, 43007, '\P{^islatinextendedd}', "");
    Expect(0, 43008, '\p{islatinextendedd}', "");
    Expect(1, 43008, '\p{^islatinextendedd}', "");
    Expect(1, 43008, '\P{islatinextendedd}', "");
    Expect(0, 43008, '\P{^islatinextendedd}', "");
    Expect(1, 43007, '\p{ 	Is_LATIN_EXTENDED_D}', "");
    Expect(0, 43007, '\p{^ 	Is_LATIN_EXTENDED_D}', "");
    Expect(0, 43007, '\P{ 	Is_LATIN_EXTENDED_D}', "");
    Expect(1, 43007, '\P{^ 	Is_LATIN_EXTENDED_D}', "");
    Expect(0, 43008, '\p{ 	Is_LATIN_EXTENDED_D}', "");
    Expect(1, 43008, '\p{^ 	Is_LATIN_EXTENDED_D}', "");
    Expect(1, 43008, '\P{ 	Is_LATIN_EXTENDED_D}', "");
    Expect(0, 43008, '\P{^ 	Is_LATIN_EXTENDED_D}', "");
    Error('\p{/a/	_in_Latin_Extended_d}');
    Error('\P{/a/	_in_Latin_Extended_d}');
    Expect(1, 43007, '\p{inlatinextendedd}', "");
    Expect(0, 43007, '\p{^inlatinextendedd}', "");
    Expect(0, 43007, '\P{inlatinextendedd}', "");
    Expect(1, 43007, '\P{^inlatinextendedd}', "");
    Expect(0, 43008, '\p{inlatinextendedd}', "");
    Expect(1, 43008, '\p{^inlatinextendedd}', "");
    Expect(1, 43008, '\P{inlatinextendedd}', "");
    Expect(0, 43008, '\P{^inlatinextendedd}', "");
    Expect(1, 43007, '\p{_in_LATIN_EXTENDED_d}', "");
    Expect(0, 43007, '\p{^_in_LATIN_EXTENDED_d}', "");
    Expect(0, 43007, '\P{_in_LATIN_EXTENDED_d}', "");
    Expect(1, 43007, '\P{^_in_LATIN_EXTENDED_d}', "");
    Expect(0, 43008, '\p{_in_LATIN_EXTENDED_d}', "");
    Expect(1, 43008, '\p{^_in_LATIN_EXTENDED_d}', "");
    Expect(1, 43008, '\P{_in_LATIN_EXTENDED_d}', "");
    Expect(0, 43008, '\P{^_in_LATIN_EXTENDED_d}', "");
    Error('\p{_/a/latin_Ext_D}');
    Error('\P{_/a/latin_Ext_D}');
    Expect(1, 43007, '\p{latinextd}', "");
    Expect(0, 43007, '\p{^latinextd}', "");
    Expect(0, 43007, '\P{latinextd}', "");
    Expect(1, 43007, '\P{^latinextd}', "");
    Expect(0, 43008, '\p{latinextd}', "");
    Expect(1, 43008, '\p{^latinextd}', "");
    Expect(1, 43008, '\P{latinextd}', "");
    Expect(0, 43008, '\P{^latinextd}', "");
    Expect(1, 43007, '\p{	latin_EXT_D}', "");
    Expect(0, 43007, '\p{^	latin_EXT_D}', "");
    Expect(0, 43007, '\P{	latin_EXT_D}', "");
    Expect(1, 43007, '\P{^	latin_EXT_D}', "");
    Expect(0, 43008, '\p{	latin_EXT_D}', "");
    Expect(1, 43008, '\p{^	latin_EXT_D}', "");
    Expect(1, 43008, '\P{	latin_EXT_D}', "");
    Expect(0, 43008, '\P{^	latin_EXT_D}', "");
    Error('\p{_Is_Latin_EXT_D/a/}');
    Error('\P{_Is_Latin_EXT_D/a/}');
    Expect(1, 43007, '\p{islatinextd}', "");
    Expect(0, 43007, '\p{^islatinextd}', "");
    Expect(0, 43007, '\P{islatinextd}', "");
    Expect(1, 43007, '\P{^islatinextd}', "");
    Expect(0, 43008, '\p{islatinextd}', "");
    Expect(1, 43008, '\p{^islatinextd}', "");
    Expect(1, 43008, '\P{islatinextd}', "");
    Expect(0, 43008, '\P{^islatinextd}', "");
    Expect(1, 43007, '\p{_-Is_Latin_ext_D}', "");
    Expect(0, 43007, '\p{^_-Is_Latin_ext_D}', "");
    Expect(0, 43007, '\P{_-Is_Latin_ext_D}', "");
    Expect(1, 43007, '\P{^_-Is_Latin_ext_D}', "");
    Expect(0, 43008, '\p{_-Is_Latin_ext_D}', "");
    Expect(1, 43008, '\p{^_-Is_Latin_ext_D}', "");
    Expect(1, 43008, '\P{_-Is_Latin_ext_D}', "");
    Expect(0, 43008, '\P{^_-Is_Latin_ext_D}', "");
    Error('\p{	In_latin_ext_D:=}');
    Error('\P{	In_latin_ext_D:=}');
    Expect(1, 43007, '\p{inlatinextd}', "");
    Expect(0, 43007, '\p{^inlatinextd}', "");
    Expect(0, 43007, '\P{inlatinextd}', "");
    Expect(1, 43007, '\P{^inlatinextd}', "");
    Expect(0, 43008, '\p{inlatinextd}', "");
    Expect(1, 43008, '\p{^inlatinextd}', "");
    Expect(1, 43008, '\P{inlatinextd}', "");
    Expect(0, 43008, '\P{^inlatinextd}', "");
    Expect(1, 43007, '\p{_	In_Latin_EXT_D}', "");
    Expect(0, 43007, '\p{^_	In_Latin_EXT_D}', "");
    Expect(0, 43007, '\P{_	In_Latin_EXT_D}', "");
    Expect(1, 43007, '\P{^_	In_Latin_EXT_D}', "");
    Expect(0, 43008, '\p{_	In_Latin_EXT_D}', "");
    Expect(1, 43008, '\p{^_	In_Latin_EXT_D}', "");
    Expect(1, 43008, '\P{_	In_Latin_EXT_D}', "");
    Expect(0, 43008, '\P{^_	In_Latin_EXT_D}', "");
    Error('\p{:=	Latin_EXTENDED_E}');
    Error('\P{:=	Latin_EXTENDED_E}');
    Expect(1, 43887, '\p{latinextendede}', "");
    Expect(0, 43887, '\p{^latinextendede}', "");
    Expect(0, 43887, '\P{latinextendede}', "");
    Expect(1, 43887, '\P{^latinextendede}', "");
    Expect(0, 43888, '\p{latinextendede}', "");
    Expect(1, 43888, '\p{^latinextendede}', "");
    Expect(1, 43888, '\P{latinextendede}', "");
    Expect(0, 43888, '\P{^latinextendede}', "");
    Expect(1, 43887, '\p{	LATIN_EXTENDED_E}', "");
    Expect(0, 43887, '\p{^	LATIN_EXTENDED_E}', "");
    Expect(0, 43887, '\P{	LATIN_EXTENDED_E}', "");
    Expect(1, 43887, '\P{^	LATIN_EXTENDED_E}', "");
    Expect(0, 43888, '\p{	LATIN_EXTENDED_E}', "");
    Expect(1, 43888, '\p{^	LATIN_EXTENDED_E}', "");
    Expect(1, 43888, '\P{	LATIN_EXTENDED_E}', "");
    Expect(0, 43888, '\P{^	LATIN_EXTENDED_E}', "");
    Error('\p{-/a/is_Latin_Extended_E}');
    Error('\P{-/a/is_Latin_Extended_E}');
    Expect(1, 43887, '\p{islatinextendede}', "");
    Expect(0, 43887, '\p{^islatinextendede}', "");
    Expect(0, 43887, '\P{islatinextendede}', "");
    Expect(1, 43887, '\P{^islatinextendede}', "");
    Expect(0, 43888, '\p{islatinextendede}', "");
    Expect(1, 43888, '\p{^islatinextendede}', "");
    Expect(1, 43888, '\P{islatinextendede}', "");
    Expect(0, 43888, '\P{^islatinextendede}', "");
    Expect(1, 43887, '\p{	 IS_latin_Extended_e}', "");
    Expect(0, 43887, '\p{^	 IS_latin_Extended_e}', "");
    Expect(0, 43887, '\P{	 IS_latin_Extended_e}', "");
    Expect(1, 43887, '\P{^	 IS_latin_Extended_e}', "");
    Expect(0, 43888, '\p{	 IS_latin_Extended_e}', "");
    Expect(1, 43888, '\p{^	 IS_latin_Extended_e}', "");
    Expect(1, 43888, '\P{	 IS_latin_Extended_e}', "");
    Expect(0, 43888, '\P{^	 IS_latin_Extended_e}', "");
    Error('\p{:=-In_LATIN_Extended_E}');
    Error('\P{:=-In_LATIN_Extended_E}');
    Expect(1, 43887, '\p{inlatinextendede}', "");
    Expect(0, 43887, '\p{^inlatinextendede}', "");
    Expect(0, 43887, '\P{inlatinextendede}', "");
    Expect(1, 43887, '\P{^inlatinextendede}', "");
    Expect(0, 43888, '\p{inlatinextendede}', "");
    Expect(1, 43888, '\p{^inlatinextendede}', "");
    Expect(1, 43888, '\P{inlatinextendede}', "");
    Expect(0, 43888, '\P{^inlatinextendede}', "");
    Expect(1, 43887, '\p{_-IN_latin_Extended_E}', "");
    Expect(0, 43887, '\p{^_-IN_latin_Extended_E}', "");
    Expect(0, 43887, '\P{_-IN_latin_Extended_E}', "");
    Expect(1, 43887, '\P{^_-IN_latin_Extended_E}', "");
    Expect(0, 43888, '\p{_-IN_latin_Extended_E}', "");
    Expect(1, 43888, '\p{^_-IN_latin_Extended_E}', "");
    Expect(1, 43888, '\P{_-IN_latin_Extended_E}', "");
    Expect(0, 43888, '\P{^_-IN_latin_Extended_E}', "");
    Error('\p{:=--Latin_Ext_E}');
    Error('\P{:=--Latin_Ext_E}');
    Expect(1, 43887, '\p{latinexte}', "");
    Expect(0, 43887, '\p{^latinexte}', "");
    Expect(0, 43887, '\P{latinexte}', "");
    Expect(1, 43887, '\P{^latinexte}', "");
    Expect(0, 43888, '\p{latinexte}', "");
    Expect(1, 43888, '\p{^latinexte}', "");
    Expect(1, 43888, '\P{latinexte}', "");
    Expect(0, 43888, '\P{^latinexte}', "");
    Expect(1, 43887, '\p{_	Latin_ext_E}', "");
    Expect(0, 43887, '\p{^_	Latin_ext_E}', "");
    Expect(0, 43887, '\P{_	Latin_ext_E}', "");
    Expect(1, 43887, '\P{^_	Latin_ext_E}', "");
    Expect(0, 43888, '\p{_	Latin_ext_E}', "");
    Expect(1, 43888, '\p{^_	Latin_ext_E}', "");
    Expect(1, 43888, '\P{_	Latin_ext_E}', "");
    Expect(0, 43888, '\P{^_	Latin_ext_E}', "");
    Error('\p{/a/ 	is_latin_Ext_E}');
    Error('\P{/a/ 	is_latin_Ext_E}');
    Expect(1, 43887, '\p{islatinexte}', "");
    Expect(0, 43887, '\p{^islatinexte}', "");
    Expect(0, 43887, '\P{islatinexte}', "");
    Expect(1, 43887, '\P{^islatinexte}', "");
    Expect(0, 43888, '\p{islatinexte}', "");
    Expect(1, 43888, '\p{^islatinexte}', "");
    Expect(1, 43888, '\P{islatinexte}', "");
    Expect(0, 43888, '\P{^islatinexte}', "");
    Expect(1, 43887, '\p{ Is_latin_Ext_e}', "");
    Expect(0, 43887, '\p{^ Is_latin_Ext_e}', "");
    Expect(0, 43887, '\P{ Is_latin_Ext_e}', "");
    Expect(1, 43887, '\P{^ Is_latin_Ext_e}', "");
    Expect(0, 43888, '\p{ Is_latin_Ext_e}', "");
    Expect(1, 43888, '\p{^ Is_latin_Ext_e}', "");
    Expect(1, 43888, '\P{ Is_latin_Ext_e}', "");
    Expect(0, 43888, '\P{^ Is_latin_Ext_e}', "");
    Error('\p{_-In_Latin_Ext_E/a/}');
    Error('\P{_-In_Latin_Ext_E/a/}');
    Expect(1, 43887, '\p{inlatinexte}', "");
    Expect(0, 43887, '\p{^inlatinexte}', "");
    Expect(0, 43887, '\P{inlatinexte}', "");
    Expect(1, 43887, '\P{^inlatinexte}', "");
    Expect(0, 43888, '\p{inlatinexte}', "");
    Expect(1, 43888, '\p{^inlatinexte}', "");
    Expect(1, 43888, '\P{inlatinexte}', "");
    Expect(0, 43888, '\P{^inlatinexte}', "");
    Expect(1, 43887, '\p{_	In_Latin_EXT_E}', "");
    Expect(0, 43887, '\p{^_	In_Latin_EXT_E}', "");
    Expect(0, 43887, '\P{_	In_Latin_EXT_E}', "");
    Expect(1, 43887, '\P{^_	In_Latin_EXT_E}', "");
    Expect(0, 43888, '\p{_	In_Latin_EXT_E}', "");
    Expect(1, 43888, '\p{^_	In_Latin_EXT_E}', "");
    Expect(1, 43888, '\P{_	In_Latin_EXT_E}', "");
    Expect(0, 43888, '\P{^_	In_Latin_EXT_E}', "");
    Error('\p{	/a/Lepcha}');
    Error('\P{	/a/Lepcha}');
    Expect(1, 7247, '\p{lepcha}', "");
    Expect(0, 7247, '\p{^lepcha}', "");
    Expect(0, 7247, '\P{lepcha}', "");
    Expect(1, 7247, '\P{^lepcha}', "");
    Expect(0, 7248, '\p{lepcha}', "");
    Expect(1, 7248, '\p{^lepcha}', "");
    Expect(1, 7248, '\P{lepcha}', "");
    Expect(0, 7248, '\P{^lepcha}', "");
    Expect(1, 7247, '\p{-lepcha}', "");
    Expect(0, 7247, '\p{^-lepcha}', "");
    Expect(0, 7247, '\P{-lepcha}', "");
    Expect(1, 7247, '\P{^-lepcha}', "");
    Expect(0, 7248, '\p{-lepcha}', "");
    Expect(1, 7248, '\p{^-lepcha}', "");
    Expect(1, 7248, '\P{-lepcha}', "");
    Expect(0, 7248, '\P{^-lepcha}', "");
    Error('\p{-:=Is_LEPCHA}');
    Error('\P{-:=Is_LEPCHA}');
    Expect(1, 7247, '\p{islepcha}', "");
    Expect(0, 7247, '\p{^islepcha}', "");
    Expect(0, 7247, '\P{islepcha}', "");
    Expect(1, 7247, '\P{^islepcha}', "");
    Expect(0, 7248, '\p{islepcha}', "");
    Expect(1, 7248, '\p{^islepcha}', "");
    Expect(1, 7248, '\P{islepcha}', "");
    Expect(0, 7248, '\P{^islepcha}', "");
    Expect(1, 7247, '\p{ 	is_LEPCHA}', "");
    Expect(0, 7247, '\p{^ 	is_LEPCHA}', "");
    Expect(0, 7247, '\P{ 	is_LEPCHA}', "");
    Expect(1, 7247, '\P{^ 	is_LEPCHA}', "");
    Expect(0, 7248, '\p{ 	is_LEPCHA}', "");
    Expect(1, 7248, '\p{^ 	is_LEPCHA}', "");
    Expect(1, 7248, '\P{ 	is_LEPCHA}', "");
    Expect(0, 7248, '\P{^ 	is_LEPCHA}', "");
    Error('\p{/a/ -Lepc}');
    Error('\P{/a/ -Lepc}');
    Expect(1, 7247, '\p{lepc}', "");
    Expect(0, 7247, '\p{^lepc}', "");
    Expect(0, 7247, '\P{lepc}', "");
    Expect(1, 7247, '\P{^lepc}', "");
    Expect(0, 7248, '\p{lepc}', "");
    Expect(1, 7248, '\p{^lepc}', "");
    Expect(1, 7248, '\P{lepc}', "");
    Expect(0, 7248, '\P{^lepc}', "");
    Expect(1, 7247, '\p{  LEPC}', "");
    Expect(0, 7247, '\p{^  LEPC}', "");
    Expect(0, 7247, '\P{  LEPC}', "");
    Expect(1, 7247, '\P{^  LEPC}', "");
    Expect(0, 7248, '\p{  LEPC}', "");
    Expect(1, 7248, '\p{^  LEPC}', "");
    Expect(1, 7248, '\P{  LEPC}', "");
    Expect(0, 7248, '\P{^  LEPC}', "");
    Error('\p{:= 	Is_Lepc}');
    Error('\P{:= 	Is_Lepc}');
    Expect(1, 7247, '\p{islepc}', "");
    Expect(0, 7247, '\p{^islepc}', "");
    Expect(0, 7247, '\P{islepc}', "");
    Expect(1, 7247, '\P{^islepc}', "");
    Expect(0, 7248, '\p{islepc}', "");
    Expect(1, 7248, '\p{^islepc}', "");
    Expect(1, 7248, '\P{islepc}', "");
    Expect(0, 7248, '\P{^islepc}', "");
    Expect(1, 7247, '\p{-is_LEPC}', "");
    Expect(0, 7247, '\p{^-is_LEPC}', "");
    Expect(0, 7247, '\P{-is_LEPC}', "");
    Expect(1, 7247, '\P{^-is_LEPC}', "");
    Expect(0, 7248, '\p{-is_LEPC}', "");
    Expect(1, 7248, '\p{^-is_LEPC}', "");
    Expect(1, 7248, '\P{-is_LEPC}', "");
    Expect(0, 7248, '\P{^-is_LEPC}', "");
    Error('\p{/a/_	LETTER}');
    Error('\P{/a/_	LETTER}');
    Expect(1, 201546, '\p{letter}', "");
    Expect(0, 201546, '\p{^letter}', "");
    Expect(0, 201546, '\P{letter}', "");
    Expect(1, 201546, '\P{^letter}', "");
    Expect(0, 201547, '\p{letter}', "");
    Expect(1, 201547, '\p{^letter}', "");
    Expect(1, 201547, '\P{letter}', "");
    Expect(0, 201547, '\P{^letter}', "");
    Expect(1, 201546, '\p{	LETTER}', "");
    Expect(0, 201546, '\p{^	LETTER}', "");
    Expect(0, 201546, '\P{	LETTER}', "");
    Expect(1, 201546, '\P{^	LETTER}', "");
    Expect(0, 201547, '\p{	LETTER}', "");
    Expect(1, 201547, '\p{^	LETTER}', "");
    Expect(1, 201547, '\P{	LETTER}', "");
    Expect(0, 201547, '\P{^	LETTER}', "");
    Error('\p{-:=is_LETTER}');
    Error('\P{-:=is_LETTER}');
    Expect(1, 201546, '\p{isletter}', "");
    Expect(0, 201546, '\p{^isletter}', "");
    Expect(0, 201546, '\P{isletter}', "");
    Expect(1, 201546, '\P{^isletter}', "");
    Expect(0, 201547, '\p{isletter}', "");
    Expect(1, 201547, '\p{^isletter}', "");
    Expect(1, 201547, '\P{isletter}', "");
    Expect(0, 201547, '\P{^isletter}', "");
    Expect(1, 201546, '\p{--is_letter}', "");
    Expect(0, 201546, '\p{^--is_letter}', "");
    Expect(0, 201546, '\P{--is_letter}', "");
    Expect(1, 201546, '\P{^--is_letter}', "");
    Expect(0, 201547, '\p{--is_letter}', "");
    Expect(1, 201547, '\p{^--is_letter}', "");
    Expect(1, 201547, '\P{--is_letter}', "");
    Expect(0, 201547, '\P{^--is_letter}', "");
    Error('\p{-:=L}');
    Error('\P{-:=L}');
    Expect(1, 201546, '\p{l}', "");
    Expect(0, 201546, '\p{^l}', "");
    Expect(0, 201546, '\P{l}', "");
    Expect(1, 201546, '\P{^l}', "");
    Expect(0, 201547, '\p{l}', "");
    Expect(1, 201547, '\p{^l}', "");
    Expect(1, 201547, '\P{l}', "");
    Expect(0, 201547, '\P{^l}', "");
    Expect(1, 201546, '\p{_-L}', "");
    Expect(0, 201546, '\p{^_-L}', "");
    Expect(0, 201546, '\P{_-L}', "");
    Expect(1, 201546, '\P{^_-L}', "");
    Expect(0, 201547, '\p{_-L}', "");
    Expect(1, 201547, '\p{^_-L}', "");
    Expect(1, 201547, '\P{_-L}', "");
    Expect(0, 201547, '\P{^_-L}', "");
    Error('\p{-	Is_l:=}');
    Error('\P{-	Is_l:=}');
    Expect(1, 201546, '\p{isl}', "");
    Expect(0, 201546, '\p{^isl}', "");
    Expect(0, 201546, '\P{isl}', "");
    Expect(1, 201546, '\P{^isl}', "");
    Expect(0, 201547, '\p{isl}', "");
    Expect(1, 201547, '\p{^isl}', "");
    Expect(1, 201547, '\P{isl}', "");
    Expect(0, 201547, '\P{^isl}', "");
    Expect(1, 201546, '\p{ is_L}', "");
    Expect(0, 201546, '\p{^ is_L}', "");
    Expect(0, 201546, '\P{ is_L}', "");
    Expect(1, 201546, '\P{^ is_L}', "");
    Expect(0, 201547, '\p{ is_L}', "");
    Expect(1, 201547, '\p{^ is_L}', "");
    Expect(1, 201547, '\P{ is_L}', "");
    Expect(0, 201547, '\P{^ is_L}', "");
    Error('\p{/a/letter_Number}');
    Error('\P{/a/letter_Number}');
    Expect(1, 74862, '\p{letternumber}', "");
    Expect(0, 74862, '\p{^letternumber}', "");
    Expect(0, 74862, '\P{letternumber}', "");
    Expect(1, 74862, '\P{^letternumber}', "");
    Expect(0, 74863, '\p{letternumber}', "");
    Expect(1, 74863, '\p{^letternumber}', "");
    Expect(1, 74863, '\P{letternumber}', "");
    Expect(0, 74863, '\P{^letternumber}', "");
    Expect(1, 74862, '\p{letter_NUMBER}', "");
    Expect(0, 74862, '\p{^letter_NUMBER}', "");
    Expect(0, 74862, '\P{letter_NUMBER}', "");
    Expect(1, 74862, '\P{^letter_NUMBER}', "");
    Expect(0, 74863, '\p{letter_NUMBER}', "");
    Expect(1, 74863, '\p{^letter_NUMBER}', "");
    Expect(1, 74863, '\P{letter_NUMBER}', "");
    Expect(0, 74863, '\P{^letter_NUMBER}', "");
    Error('\p{/a/ is_letter_Number}');
    Error('\P{/a/ is_letter_Number}');
    Expect(1, 74862, '\p{isletternumber}', "");
    Expect(0, 74862, '\p{^isletternumber}', "");
    Expect(0, 74862, '\P{isletternumber}', "");
    Expect(1, 74862, '\P{^isletternumber}', "");
    Expect(0, 74863, '\p{isletternumber}', "");
    Expect(1, 74863, '\p{^isletternumber}', "");
    Expect(1, 74863, '\P{isletternumber}', "");
    Expect(0, 74863, '\P{^isletternumber}', "");
    Expect(1, 74862, '\p{- Is_LETTER_number}', "");
    Expect(0, 74862, '\p{^- Is_LETTER_number}', "");
    Expect(0, 74862, '\P{- Is_LETTER_number}', "");
    Expect(1, 74862, '\P{^- Is_LETTER_number}', "");
    Expect(0, 74863, '\p{- Is_LETTER_number}', "");
    Expect(1, 74863, '\p{^- Is_LETTER_number}', "");
    Expect(1, 74863, '\P{- Is_LETTER_number}', "");
    Expect(0, 74863, '\P{^- Is_LETTER_number}', "");
    Error('\p{_/a/NL}');
    Error('\P{_/a/NL}');
    Expect(1, 74862, '\p{nl}', "");
    Expect(0, 74862, '\p{^nl}', "");
    Expect(0, 74862, '\P{nl}', "");
    Expect(1, 74862, '\P{^nl}', "");
    Expect(0, 74863, '\p{nl}', "");
    Expect(1, 74863, '\p{^nl}', "");
    Expect(1, 74863, '\P{nl}', "");
    Expect(0, 74863, '\P{^nl}', "");
    Expect(1, 74862, '\p{		Nl}', "");
    Expect(0, 74862, '\p{^		Nl}', "");
    Expect(0, 74862, '\P{		Nl}', "");
    Expect(1, 74862, '\P{^		Nl}', "");
    Expect(0, 74863, '\p{		Nl}', "");
    Expect(1, 74863, '\p{^		Nl}', "");
    Expect(1, 74863, '\P{		Nl}', "");
    Expect(0, 74863, '\P{^		Nl}', "");
    Error('\p{/a/Is_NL}');
    Error('\P{/a/Is_NL}');
    Expect(1, 74862, '\p{isnl}', "");
    Expect(0, 74862, '\p{^isnl}', "");
    Expect(0, 74862, '\P{isnl}', "");
    Expect(1, 74862, '\P{^isnl}', "");
    Expect(0, 74863, '\p{isnl}', "");
    Expect(1, 74863, '\p{^isnl}', "");
    Expect(1, 74863, '\P{isnl}', "");
    Expect(0, 74863, '\P{^isnl}', "");
    Expect(1, 74862, '\p{_ is_nl}', "");
    Expect(0, 74862, '\p{^_ is_nl}', "");
    Expect(0, 74862, '\P{_ is_nl}', "");
    Expect(1, 74862, '\P{^_ is_nl}', "");
    Expect(0, 74863, '\p{_ is_nl}', "");
    Expect(1, 74863, '\p{^_ is_nl}', "");
    Expect(1, 74863, '\P{_ is_nl}', "");
    Expect(0, 74863, '\P{^_ is_nl}', "");
    Error('\p{_-LETTERLIKE_SYMBOLS:=}');
    Error('\P{_-LETTERLIKE_SYMBOLS:=}');
    Expect(1, 8527, '\p{letterlikesymbols}', "");
    Expect(0, 8527, '\p{^letterlikesymbols}', "");
    Expect(0, 8527, '\P{letterlikesymbols}', "");
    Expect(1, 8527, '\P{^letterlikesymbols}', "");
    Expect(0, 8528, '\p{letterlikesymbols}', "");
    Expect(1, 8528, '\p{^letterlikesymbols}', "");
    Expect(1, 8528, '\P{letterlikesymbols}', "");
    Expect(0, 8528, '\P{^letterlikesymbols}', "");
    Expect(1, 8527, '\p{_	LETTERLIKE_symbols}', "");
    Expect(0, 8527, '\p{^_	LETTERLIKE_symbols}', "");
    Expect(0, 8527, '\P{_	LETTERLIKE_symbols}', "");
    Expect(1, 8527, '\P{^_	LETTERLIKE_symbols}', "");
    Expect(0, 8528, '\p{_	LETTERLIKE_symbols}', "");
    Expect(1, 8528, '\p{^_	LETTERLIKE_symbols}', "");
    Expect(1, 8528, '\P{_	LETTERLIKE_symbols}', "");
    Expect(0, 8528, '\P{^_	LETTERLIKE_symbols}', "");
    Error('\p{/a/IS_letterlike_symbols}');
    Error('\P{/a/IS_letterlike_symbols}');
    Expect(1, 8527, '\p{isletterlikesymbols}', "");
    Expect(0, 8527, '\p{^isletterlikesymbols}', "");
    Expect(0, 8527, '\P{isletterlikesymbols}', "");
    Expect(1, 8527, '\P{^isletterlikesymbols}', "");
    Expect(0, 8528, '\p{isletterlikesymbols}', "");
    Expect(1, 8528, '\p{^isletterlikesymbols}', "");
    Expect(1, 8528, '\P{isletterlikesymbols}', "");
    Expect(0, 8528, '\P{^isletterlikesymbols}', "");
    Expect(1, 8527, '\p{__is_letterlike_SYMBOLS}', "");
    Expect(0, 8527, '\p{^__is_letterlike_SYMBOLS}', "");
    Expect(0, 8527, '\P{__is_letterlike_SYMBOLS}', "");
    Expect(1, 8527, '\P{^__is_letterlike_SYMBOLS}', "");
    Expect(0, 8528, '\p{__is_letterlike_SYMBOLS}', "");
    Expect(1, 8528, '\p{^__is_letterlike_SYMBOLS}', "");
    Expect(1, 8528, '\P{__is_letterlike_SYMBOLS}', "");
    Expect(0, 8528, '\P{^__is_letterlike_SYMBOLS}', "");
    Error('\p{ In_Letterlike_Symbols/a/}');
    Error('\P{ In_Letterlike_Symbols/a/}');
    Expect(1, 8527, '\p{inletterlikesymbols}', "");
    Expect(0, 8527, '\p{^inletterlikesymbols}', "");
    Expect(0, 8527, '\P{inletterlikesymbols}', "");
    Expect(1, 8527, '\P{^inletterlikesymbols}', "");
    Expect(0, 8528, '\p{inletterlikesymbols}', "");
    Expect(1, 8528, '\p{^inletterlikesymbols}', "");
    Expect(1, 8528, '\P{inletterlikesymbols}', "");
    Expect(0, 8528, '\P{^inletterlikesymbols}', "");
    Expect(1, 8527, '\p{-_in_LETTERLIKE_Symbols}', "");
    Expect(0, 8527, '\p{^-_in_LETTERLIKE_Symbols}', "");
    Expect(0, 8527, '\P{-_in_LETTERLIKE_Symbols}', "");
    Expect(1, 8527, '\P{^-_in_LETTERLIKE_Symbols}', "");
    Expect(0, 8528, '\p{-_in_LETTERLIKE_Symbols}', "");
    Expect(1, 8528, '\p{^-_in_LETTERLIKE_Symbols}', "");
    Expect(1, 8528, '\P{-_in_LETTERLIKE_Symbols}', "");
    Expect(0, 8528, '\P{^-_in_LETTERLIKE_Symbols}', "");
    Error('\p{:=-	limbu}');
    Error('\P{:=-	limbu}');
    Expect(1, 6479, '\p{limbu}', "");
    Expect(0, 6479, '\p{^limbu}', "");
    Expect(0, 6479, '\P{limbu}', "");
    Expect(1, 6479, '\P{^limbu}', "");
    Expect(0, 6480, '\p{limbu}', "");
    Expect(1, 6480, '\p{^limbu}', "");
    Expect(1, 6480, '\P{limbu}', "");
    Expect(0, 6480, '\P{^limbu}', "");
    Expect(1, 6479, '\p{-LIMBU}', "");
    Expect(0, 6479, '\p{^-LIMBU}', "");
    Expect(0, 6479, '\P{-LIMBU}', "");
    Expect(1, 6479, '\P{^-LIMBU}', "");
    Expect(0, 6480, '\p{-LIMBU}', "");
    Expect(1, 6480, '\p{^-LIMBU}', "");
    Expect(1, 6480, '\P{-LIMBU}', "");
    Expect(0, 6480, '\P{^-LIMBU}', "");
    Error('\p{_/a/Is_LIMBU}');
    Error('\P{_/a/Is_LIMBU}');
    Expect(1, 6479, '\p{islimbu}', "");
    Expect(0, 6479, '\p{^islimbu}', "");
    Expect(0, 6479, '\P{islimbu}', "");
    Expect(1, 6479, '\P{^islimbu}', "");
    Expect(0, 6480, '\p{islimbu}', "");
    Expect(1, 6480, '\p{^islimbu}', "");
    Expect(1, 6480, '\P{islimbu}', "");
    Expect(0, 6480, '\P{^islimbu}', "");
    Expect(1, 6479, '\p{		IS_Limbu}', "");
    Expect(0, 6479, '\p{^		IS_Limbu}', "");
    Expect(0, 6479, '\P{		IS_Limbu}', "");
    Expect(1, 6479, '\P{^		IS_Limbu}', "");
    Expect(0, 6480, '\p{		IS_Limbu}', "");
    Expect(1, 6480, '\p{^		IS_Limbu}', "");
    Expect(1, 6480, '\P{		IS_Limbu}', "");
    Expect(0, 6480, '\P{^		IS_Limbu}', "");
    Error('\p{	_Limb/a/}');
    Error('\P{	_Limb/a/}');
    Expect(1, 6479, '\p{limb}', "");
    Expect(0, 6479, '\p{^limb}', "");
    Expect(0, 6479, '\P{limb}', "");
    Expect(1, 6479, '\P{^limb}', "");
    Expect(0, 6480, '\p{limb}', "");
    Expect(1, 6480, '\p{^limb}', "");
    Expect(1, 6480, '\P{limb}', "");
    Expect(0, 6480, '\P{^limb}', "");
    Expect(1, 6479, '\p{ LIMB}', "");
    Expect(0, 6479, '\p{^ LIMB}', "");
    Expect(0, 6479, '\P{ LIMB}', "");
    Expect(1, 6479, '\P{^ LIMB}', "");
    Expect(0, 6480, '\p{ LIMB}', "");
    Expect(1, 6480, '\p{^ LIMB}', "");
    Expect(1, 6480, '\P{ LIMB}', "");
    Expect(0, 6480, '\P{^ LIMB}', "");
    Error('\p{:=IS_LIMB}');
    Error('\P{:=IS_LIMB}');
    Expect(1, 6479, '\p{islimb}', "");
    Expect(0, 6479, '\p{^islimb}', "");
    Expect(0, 6479, '\P{islimb}', "");
    Expect(1, 6479, '\P{^islimb}', "");
    Expect(0, 6480, '\p{islimb}', "");
    Expect(1, 6480, '\p{^islimb}', "");
    Expect(1, 6480, '\P{islimb}', "");
    Expect(0, 6480, '\P{^islimb}', "");
    Expect(1, 6479, '\p{	-Is_Limb}', "");
    Expect(0, 6479, '\p{^	-Is_Limb}', "");
    Expect(0, 6479, '\P{	-Is_Limb}', "");
    Expect(1, 6479, '\P{^	-Is_Limb}', "");
    Expect(0, 6480, '\p{	-Is_Limb}', "");
    Expect(1, 6480, '\p{^	-Is_Limb}', "");
    Expect(1, 6480, '\P{	-Is_Limb}', "");
    Expect(0, 6480, '\P{^	-Is_Limb}', "");
    Error('\p{	/a/LINE_separator}');
    Error('\P{	/a/LINE_separator}');
    Expect(1, 8232, '\p{lineseparator}', "");
    Expect(0, 8232, '\p{^lineseparator}', "");
    Expect(0, 8232, '\P{lineseparator}', "");
    Expect(1, 8232, '\P{^lineseparator}', "");
    Expect(0, 8233, '\p{lineseparator}', "");
    Expect(1, 8233, '\p{^lineseparator}', "");
    Expect(1, 8233, '\P{lineseparator}', "");
    Expect(0, 8233, '\P{^lineseparator}', "");
    Expect(1, 8232, '\p{- Line_separator}', "");
    Expect(0, 8232, '\p{^- Line_separator}', "");
    Expect(0, 8232, '\P{- Line_separator}', "");
    Expect(1, 8232, '\P{^- Line_separator}', "");
    Expect(0, 8233, '\p{- Line_separator}', "");
    Expect(1, 8233, '\p{^- Line_separator}', "");
    Expect(1, 8233, '\P{- Line_separator}', "");
    Expect(0, 8233, '\P{^- Line_separator}', "");
    Error('\p{:=_Is_line_separator}');
    Error('\P{:=_Is_line_separator}');
    Expect(1, 8232, '\p{islineseparator}', "");
    Expect(0, 8232, '\p{^islineseparator}', "");
    Expect(0, 8232, '\P{islineseparator}', "");
    Expect(1, 8232, '\P{^islineseparator}', "");
    Expect(0, 8233, '\p{islineseparator}', "");
    Expect(1, 8233, '\p{^islineseparator}', "");
    Expect(1, 8233, '\P{islineseparator}', "");
    Expect(0, 8233, '\P{^islineseparator}', "");
    Expect(1, 8232, '\p{ -Is_Line_separator}', "");
    Expect(0, 8232, '\p{^ -Is_Line_separator}', "");
    Expect(0, 8232, '\P{ -Is_Line_separator}', "");
    Expect(1, 8232, '\P{^ -Is_Line_separator}', "");
    Expect(0, 8233, '\p{ -Is_Line_separator}', "");
    Expect(1, 8233, '\p{^ -Is_Line_separator}', "");
    Expect(1, 8233, '\P{ -Is_Line_separator}', "");
    Expect(0, 8233, '\P{^ -Is_Line_separator}', "");
    Error('\p{_:=zl}');
    Error('\P{_:=zl}');
    Expect(1, 8232, '\p{zl}', "");
    Expect(0, 8232, '\p{^zl}', "");
    Expect(0, 8232, '\P{zl}', "");
    Expect(1, 8232, '\P{^zl}', "");
    Expect(0, 8233, '\p{zl}', "");
    Expect(1, 8233, '\p{^zl}', "");
    Expect(1, 8233, '\P{zl}', "");
    Expect(0, 8233, '\P{^zl}', "");
    Expect(1, 8232, '\p{  Zl}', "");
    Expect(0, 8232, '\p{^  Zl}', "");
    Expect(0, 8232, '\P{  Zl}', "");
    Expect(1, 8232, '\P{^  Zl}', "");
    Expect(0, 8233, '\p{  Zl}', "");
    Expect(1, 8233, '\p{^  Zl}', "");
    Expect(1, 8233, '\P{  Zl}', "");
    Expect(0, 8233, '\P{^  Zl}', "");
    Error('\p{:=_ IS_zl}');
    Error('\P{:=_ IS_zl}');
    Expect(1, 8232, '\p{iszl}', "");
    Expect(0, 8232, '\p{^iszl}', "");
    Expect(0, 8232, '\P{iszl}', "");
    Expect(1, 8232, '\P{^iszl}', "");
    Expect(0, 8233, '\p{iszl}', "");
    Expect(1, 8233, '\p{^iszl}', "");
    Expect(1, 8233, '\P{iszl}', "");
    Expect(0, 8233, '\P{^iszl}', "");
    Expect(1, 8232, '\p{ _Is_ZL}', "");
    Expect(0, 8232, '\p{^ _Is_ZL}', "");
    Expect(0, 8232, '\P{ _Is_ZL}', "");
    Expect(1, 8232, '\P{^ _Is_ZL}', "");
    Expect(0, 8233, '\p{ _Is_ZL}', "");
    Expect(1, 8233, '\p{^ _Is_ZL}', "");
    Expect(1, 8233, '\P{ _Is_ZL}', "");
    Expect(0, 8233, '\P{^ _Is_ZL}', "");
    Error('\p{LINEAR_a:=}');
    Error('\P{LINEAR_a:=}');
    Expect(1, 67431, '\p{lineara}', "");
    Expect(0, 67431, '\p{^lineara}', "");
    Expect(0, 67431, '\P{lineara}', "");
    Expect(1, 67431, '\P{^lineara}', "");
    Expect(0, 67432, '\p{lineara}', "");
    Expect(1, 67432, '\p{^lineara}', "");
    Expect(1, 67432, '\P{lineara}', "");
    Expect(0, 67432, '\P{^lineara}', "");
    Expect(1, 67431, '\p{ _Linear_a}', "");
    Expect(0, 67431, '\p{^ _Linear_a}', "");
    Expect(0, 67431, '\P{ _Linear_a}', "");
    Expect(1, 67431, '\P{^ _Linear_a}', "");
    Expect(0, 67432, '\p{ _Linear_a}', "");
    Expect(1, 67432, '\p{^ _Linear_a}', "");
    Expect(1, 67432, '\P{ _Linear_a}', "");
    Expect(0, 67432, '\P{^ _Linear_a}', "");
    Error('\p{-:=IS_LINEAR_A}');
    Error('\P{-:=IS_LINEAR_A}');
    Expect(1, 67431, '\p{islineara}', "");
    Expect(0, 67431, '\p{^islineara}', "");
    Expect(0, 67431, '\P{islineara}', "");
    Expect(1, 67431, '\P{^islineara}', "");
    Expect(0, 67432, '\p{islineara}', "");
    Expect(1, 67432, '\p{^islineara}', "");
    Expect(1, 67432, '\P{islineara}', "");
    Expect(0, 67432, '\P{^islineara}', "");
    Expect(1, 67431, '\p{_-Is_linear_A}', "");
    Expect(0, 67431, '\p{^_-Is_linear_A}', "");
    Expect(0, 67431, '\P{_-Is_linear_A}', "");
    Expect(1, 67431, '\P{^_-Is_linear_A}', "");
    Expect(0, 67432, '\p{_-Is_linear_A}', "");
    Expect(1, 67432, '\p{^_-Is_linear_A}', "");
    Expect(1, 67432, '\P{_-Is_linear_A}', "");
    Expect(0, 67432, '\P{^_-Is_linear_A}', "");
    Error('\p{_ LINA:=}');
    Error('\P{_ LINA:=}');
    Expect(1, 67431, '\p{lina}', "");
    Expect(0, 67431, '\p{^lina}', "");
    Expect(0, 67431, '\P{lina}', "");
    Expect(1, 67431, '\P{^lina}', "");
    Expect(0, 67432, '\p{lina}', "");
    Expect(1, 67432, '\p{^lina}', "");
    Expect(1, 67432, '\P{lina}', "");
    Expect(0, 67432, '\P{^lina}', "");
    Expect(1, 67431, '\p{_-lina}', "");
    Expect(0, 67431, '\p{^_-lina}', "");
    Expect(0, 67431, '\P{_-lina}', "");
    Expect(1, 67431, '\P{^_-lina}', "");
    Expect(0, 67432, '\p{_-lina}', "");
    Expect(1, 67432, '\p{^_-lina}', "");
    Expect(1, 67432, '\P{_-lina}', "");
    Expect(0, 67432, '\P{^_-lina}', "");
    Error('\p{/a/_ Is_Lina}');
    Error('\P{/a/_ Is_Lina}');
    Expect(1, 67431, '\p{islina}', "");
    Expect(0, 67431, '\p{^islina}', "");
    Expect(0, 67431, '\P{islina}', "");
    Expect(1, 67431, '\P{^islina}', "");
    Expect(0, 67432, '\p{islina}', "");
    Expect(1, 67432, '\p{^islina}', "");
    Expect(1, 67432, '\P{islina}', "");
    Expect(0, 67432, '\P{^islina}', "");
    Expect(1, 67431, '\p{-is_Lina}', "");
    Expect(0, 67431, '\p{^-is_Lina}', "");
    Expect(0, 67431, '\P{-is_Lina}', "");
    Expect(1, 67431, '\P{^-is_Lina}', "");
    Expect(0, 67432, '\p{-is_Lina}', "");
    Expect(1, 67432, '\p{^-is_Lina}', "");
    Expect(1, 67432, '\P{-is_Lina}', "");
    Expect(0, 67432, '\P{^-is_Lina}', "");
    Error('\p{/a/-linear_B}');
    Error('\P{/a/-linear_B}');
    Expect(1, 65855, '\p{linearb}', "");
    Expect(0, 65855, '\p{^linearb}', "");
    Expect(0, 65855, '\P{linearb}', "");
    Expect(1, 65855, '\P{^linearb}', "");
    Expect(0, 65856, '\p{linearb}', "");
    Expect(1, 65856, '\p{^linearb}', "");
    Expect(1, 65856, '\P{linearb}', "");
    Expect(0, 65856, '\P{^linearb}', "");
    Expect(1, 65855, '\p{-LINEAR_B}', "");
    Expect(0, 65855, '\p{^-LINEAR_B}', "");
    Expect(0, 65855, '\P{-LINEAR_B}', "");
    Expect(1, 65855, '\P{^-LINEAR_B}', "");
    Expect(0, 65856, '\p{-LINEAR_B}', "");
    Expect(1, 65856, '\p{^-LINEAR_B}', "");
    Expect(1, 65856, '\P{-LINEAR_B}', "");
    Expect(0, 65856, '\P{^-LINEAR_B}', "");
    Error('\p{-:=IS_LINEAR_B}');
    Error('\P{-:=IS_LINEAR_B}');
    Expect(1, 65855, '\p{islinearb}', "");
    Expect(0, 65855, '\p{^islinearb}', "");
    Expect(0, 65855, '\P{islinearb}', "");
    Expect(1, 65855, '\P{^islinearb}', "");
    Expect(0, 65856, '\p{islinearb}', "");
    Expect(1, 65856, '\p{^islinearb}', "");
    Expect(1, 65856, '\P{islinearb}', "");
    Expect(0, 65856, '\P{^islinearb}', "");
    Expect(1, 65855, '\p{ _IS_Linear_B}', "");
    Expect(0, 65855, '\p{^ _IS_Linear_B}', "");
    Expect(0, 65855, '\P{ _IS_Linear_B}', "");
    Expect(1, 65855, '\P{^ _IS_Linear_B}', "");
    Expect(0, 65856, '\p{ _IS_Linear_B}', "");
    Expect(1, 65856, '\p{^ _IS_Linear_B}', "");
    Expect(1, 65856, '\P{ _IS_Linear_B}', "");
    Expect(0, 65856, '\P{^ _IS_Linear_B}', "");
    Error('\p{-	linb/a/}');
    Error('\P{-	linb/a/}');
    Expect(1, 65855, '\p{linb}', "");
    Expect(0, 65855, '\p{^linb}', "");
    Expect(0, 65855, '\P{linb}', "");
    Expect(1, 65855, '\P{^linb}', "");
    Expect(0, 65856, '\p{linb}', "");
    Expect(1, 65856, '\p{^linb}', "");
    Expect(1, 65856, '\P{linb}', "");
    Expect(0, 65856, '\P{^linb}', "");
    Expect(1, 65855, '\p{	-linb}', "");
    Expect(0, 65855, '\p{^	-linb}', "");
    Expect(0, 65855, '\P{	-linb}', "");
    Expect(1, 65855, '\P{^	-linb}', "");
    Expect(0, 65856, '\p{	-linb}', "");
    Expect(1, 65856, '\p{^	-linb}', "");
    Expect(1, 65856, '\P{	-linb}', "");
    Expect(0, 65856, '\P{^	-linb}', "");
    Error('\p{:=Is_Linb}');
    Error('\P{:=Is_Linb}');
    Expect(1, 65855, '\p{islinb}', "");
    Expect(0, 65855, '\p{^islinb}', "");
    Expect(0, 65855, '\P{islinb}', "");
    Expect(1, 65855, '\P{^islinb}', "");
    Expect(0, 65856, '\p{islinb}', "");
    Expect(1, 65856, '\p{^islinb}', "");
    Expect(1, 65856, '\P{islinb}', "");
    Expect(0, 65856, '\P{^islinb}', "");
    Expect(1, 65855, '\p{	is_linb}', "");
    Expect(0, 65855, '\p{^	is_linb}', "");
    Expect(0, 65855, '\P{	is_linb}', "");
    Expect(1, 65855, '\P{^	is_linb}', "");
    Expect(0, 65856, '\p{	is_linb}', "");
    Expect(1, 65856, '\p{^	is_linb}', "");
    Expect(1, 65856, '\P{	is_linb}', "");
    Expect(0, 65856, '\P{^	is_linb}', "");
    Error('\p{ _Linear_B_IDEOGRAMS/a/}');
    Error('\P{ _Linear_B_IDEOGRAMS/a/}');
    Expect(1, 65791, '\p{linearbideograms}', "");
    Expect(0, 65791, '\p{^linearbideograms}', "");
    Expect(0, 65791, '\P{linearbideograms}', "");
    Expect(1, 65791, '\P{^linearbideograms}', "");
    Expect(0, 65792, '\p{linearbideograms}', "");
    Expect(1, 65792, '\p{^linearbideograms}', "");
    Expect(1, 65792, '\P{linearbideograms}', "");
    Expect(0, 65792, '\P{^linearbideograms}', "");
    Expect(1, 65791, '\p{	linear_B_Ideograms}', "");
    Expect(0, 65791, '\p{^	linear_B_Ideograms}', "");
    Expect(0, 65791, '\P{	linear_B_Ideograms}', "");
    Expect(1, 65791, '\P{^	linear_B_Ideograms}', "");
    Expect(0, 65792, '\p{	linear_B_Ideograms}', "");
    Expect(1, 65792, '\p{^	linear_B_Ideograms}', "");
    Expect(1, 65792, '\P{	linear_B_Ideograms}', "");
    Expect(0, 65792, '\P{^	linear_B_Ideograms}', "");
    Error('\p{_Is_LINEAR_B_Ideograms/a/}');
    Error('\P{_Is_LINEAR_B_Ideograms/a/}');
    Expect(1, 65791, '\p{islinearbideograms}', "");
    Expect(0, 65791, '\p{^islinearbideograms}', "");
    Expect(0, 65791, '\P{islinearbideograms}', "");
    Expect(1, 65791, '\P{^islinearbideograms}', "");
    Expect(0, 65792, '\p{islinearbideograms}', "");
    Expect(1, 65792, '\p{^islinearbideograms}', "");
    Expect(1, 65792, '\P{islinearbideograms}', "");
    Expect(0, 65792, '\P{^islinearbideograms}', "");
    Expect(1, 65791, '\p{	 IS_Linear_B_Ideograms}', "");
    Expect(0, 65791, '\p{^	 IS_Linear_B_Ideograms}', "");
    Expect(0, 65791, '\P{	 IS_Linear_B_Ideograms}', "");
    Expect(1, 65791, '\P{^	 IS_Linear_B_Ideograms}', "");
    Expect(0, 65792, '\p{	 IS_Linear_B_Ideograms}', "");
    Expect(1, 65792, '\p{^	 IS_Linear_B_Ideograms}', "");
    Expect(1, 65792, '\P{	 IS_Linear_B_Ideograms}', "");
    Expect(0, 65792, '\P{^	 IS_Linear_B_Ideograms}', "");
    Error('\p{/a/-In_linear_B_Ideograms}');
    Error('\P{/a/-In_linear_B_Ideograms}');
    Expect(1, 65791, '\p{inlinearbideograms}', "");
    Expect(0, 65791, '\p{^inlinearbideograms}', "");
    Expect(0, 65791, '\P{inlinearbideograms}', "");
    Expect(1, 65791, '\P{^inlinearbideograms}', "");
    Expect(0, 65792, '\p{inlinearbideograms}', "");
    Expect(1, 65792, '\p{^inlinearbideograms}', "");
    Expect(1, 65792, '\P{inlinearbideograms}', "");
    Expect(0, 65792, '\P{^inlinearbideograms}', "");
    Expect(1, 65791, '\p{__In_LINEAR_B_Ideograms}', "");
    Expect(0, 65791, '\p{^__In_LINEAR_B_Ideograms}', "");
    Expect(0, 65791, '\P{__In_LINEAR_B_Ideograms}', "");
    Expect(1, 65791, '\P{^__In_LINEAR_B_Ideograms}', "");
    Expect(0, 65792, '\p{__In_LINEAR_B_Ideograms}', "");
    Expect(1, 65792, '\p{^__In_LINEAR_B_Ideograms}', "");
    Expect(1, 65792, '\P{__In_LINEAR_B_Ideograms}', "");
    Expect(0, 65792, '\P{^__In_LINEAR_B_Ideograms}', "");
    Error('\p{-linear_B_syllabary/a/}');
    Error('\P{-linear_B_syllabary/a/}');
    Expect(1, 65663, '\p{linearbsyllabary}', "");
    Expect(0, 65663, '\p{^linearbsyllabary}', "");
    Expect(0, 65663, '\P{linearbsyllabary}', "");
    Expect(1, 65663, '\P{^linearbsyllabary}', "");
    Expect(0, 65664, '\p{linearbsyllabary}', "");
    Expect(1, 65664, '\p{^linearbsyllabary}', "");
    Expect(1, 65664, '\P{linearbsyllabary}', "");
    Expect(0, 65664, '\P{^linearbsyllabary}', "");
    Expect(1, 65663, '\p{	linear_B_syllabary}', "");
    Expect(0, 65663, '\p{^	linear_B_syllabary}', "");
    Expect(0, 65663, '\P{	linear_B_syllabary}', "");
    Expect(1, 65663, '\P{^	linear_B_syllabary}', "");
    Expect(0, 65664, '\p{	linear_B_syllabary}', "");
    Expect(1, 65664, '\p{^	linear_B_syllabary}', "");
    Expect(1, 65664, '\P{	linear_B_syllabary}', "");
    Expect(0, 65664, '\P{^	linear_B_syllabary}', "");
    Error('\p{_ is_Linear_b_syllabary:=}');
    Error('\P{_ is_Linear_b_syllabary:=}');
    Expect(1, 65663, '\p{islinearbsyllabary}', "");
    Expect(0, 65663, '\p{^islinearbsyllabary}', "");
    Expect(0, 65663, '\P{islinearbsyllabary}', "");
    Expect(1, 65663, '\P{^islinearbsyllabary}', "");
    Expect(0, 65664, '\p{islinearbsyllabary}', "");
    Expect(1, 65664, '\p{^islinearbsyllabary}', "");
    Expect(1, 65664, '\P{islinearbsyllabary}', "");
    Expect(0, 65664, '\P{^islinearbsyllabary}', "");
    Expect(1, 65663, '\p{-is_Linear_B_syllabary}', "");
    Expect(0, 65663, '\p{^-is_Linear_B_syllabary}', "");
    Expect(0, 65663, '\P{-is_Linear_B_syllabary}', "");
    Expect(1, 65663, '\P{^-is_Linear_B_syllabary}', "");
    Expect(0, 65664, '\p{-is_Linear_B_syllabary}', "");
    Expect(1, 65664, '\p{^-is_Linear_B_syllabary}', "");
    Expect(1, 65664, '\P{-is_Linear_B_syllabary}', "");
    Expect(0, 65664, '\P{^-is_Linear_B_syllabary}', "");
    Error('\p{-	in_Linear_B_Syllabary:=}');
    Error('\P{-	in_Linear_B_Syllabary:=}');
    Expect(1, 65663, '\p{inlinearbsyllabary}', "");
    Expect(0, 65663, '\p{^inlinearbsyllabary}', "");
    Expect(0, 65663, '\P{inlinearbsyllabary}', "");
    Expect(1, 65663, '\P{^inlinearbsyllabary}', "");
    Expect(0, 65664, '\p{inlinearbsyllabary}', "");
    Expect(1, 65664, '\p{^inlinearbsyllabary}', "");
    Expect(1, 65664, '\P{inlinearbsyllabary}', "");
    Expect(0, 65664, '\P{^inlinearbsyllabary}', "");
    Expect(1, 65663, '\p{	in_Linear_b_syllabary}', "");
    Expect(0, 65663, '\p{^	in_Linear_b_syllabary}', "");
    Expect(0, 65663, '\P{	in_Linear_b_syllabary}', "");
    Expect(1, 65663, '\P{^	in_Linear_b_syllabary}', "");
    Expect(0, 65664, '\p{	in_Linear_b_syllabary}', "");
    Expect(1, 65664, '\p{^	in_Linear_b_syllabary}', "");
    Expect(1, 65664, '\P{	in_Linear_b_syllabary}', "");
    Expect(0, 65664, '\P{^	in_Linear_b_syllabary}', "");
    Error('\p{/a/Lisu}');
    Error('\P{/a/Lisu}');
    Expect(1, 73648, '\p{lisu}', "");
    Expect(0, 73648, '\p{^lisu}', "");
    Expect(0, 73648, '\P{lisu}', "");
    Expect(1, 73648, '\P{^lisu}', "");
    Expect(0, 73649, '\p{lisu}', "");
    Expect(1, 73649, '\p{^lisu}', "");
    Expect(1, 73649, '\P{lisu}', "");
    Expect(0, 73649, '\P{^lisu}', "");
    Expect(1, 73648, '\p{	-lisu}', "");
    Expect(0, 73648, '\p{^	-lisu}', "");
    Expect(0, 73648, '\P{	-lisu}', "");
    Expect(1, 73648, '\P{^	-lisu}', "");
    Expect(0, 73649, '\p{	-lisu}', "");
    Expect(1, 73649, '\p{^	-lisu}', "");
    Expect(1, 73649, '\P{	-lisu}', "");
    Expect(0, 73649, '\P{^	-lisu}', "");
    Error('\p{:=Is_lisu}');
    Error('\P{:=Is_lisu}');
    Expect(1, 73648, '\p{islisu}', "");
    Expect(0, 73648, '\p{^islisu}', "");
    Expect(0, 73648, '\P{islisu}', "");
    Expect(1, 73648, '\P{^islisu}', "");
    Expect(0, 73649, '\p{islisu}', "");
    Expect(1, 73649, '\p{^islisu}', "");
    Expect(1, 73649, '\P{islisu}', "");
    Expect(0, 73649, '\P{^islisu}', "");
    Expect(1, 73648, '\p{--is_LISU}', "");
    Expect(0, 73648, '\p{^--is_LISU}', "");
    Expect(0, 73648, '\P{--is_LISU}', "");
    Expect(1, 73648, '\P{^--is_LISU}', "");
    Expect(0, 73649, '\p{--is_LISU}', "");
    Expect(1, 73649, '\p{^--is_LISU}', "");
    Expect(1, 73649, '\P{--is_LISU}', "");
    Expect(0, 73649, '\P{^--is_LISU}', "");
    Error('\p{  lisu_supplement/a/}');
    Error('\P{  lisu_supplement/a/}');
    Expect(1, 73663, '\p{lisusupplement}', "");
    Expect(0, 73663, '\p{^lisusupplement}', "");
    Expect(0, 73663, '\P{lisusupplement}', "");
    Expect(1, 73663, '\P{^lisusupplement}', "");
    Expect(0, 73664, '\p{lisusupplement}', "");
    Expect(1, 73664, '\p{^lisusupplement}', "");
    Expect(1, 73664, '\P{lisusupplement}', "");
    Expect(0, 73664, '\P{^lisusupplement}', "");
    Expect(1, 73663, '\p{ lisu_supplement}', "");
    Expect(0, 73663, '\p{^ lisu_supplement}', "");
    Expect(0, 73663, '\P{ lisu_supplement}', "");
    Expect(1, 73663, '\P{^ lisu_supplement}', "");
    Expect(0, 73664, '\p{ lisu_supplement}', "");
    Expect(1, 73664, '\p{^ lisu_supplement}', "");
    Expect(1, 73664, '\P{ lisu_supplement}', "");
    Expect(0, 73664, '\P{^ lisu_supplement}', "");
    Error('\p{:=		is_Lisu_SUPPLEMENT}');
    Error('\P{:=		is_Lisu_SUPPLEMENT}');
    Expect(1, 73663, '\p{islisusupplement}', "");
    Expect(0, 73663, '\p{^islisusupplement}', "");
    Expect(0, 73663, '\P{islisusupplement}', "");
    Expect(1, 73663, '\P{^islisusupplement}', "");
    Expect(0, 73664, '\p{islisusupplement}', "");
    Expect(1, 73664, '\p{^islisusupplement}', "");
    Expect(1, 73664, '\P{islisusupplement}', "");
    Expect(0, 73664, '\P{^islisusupplement}', "");
    Expect(1, 73663, '\p{_Is_Lisu_supplement}', "");
    Expect(0, 73663, '\p{^_Is_Lisu_supplement}', "");
    Expect(0, 73663, '\P{_Is_Lisu_supplement}', "");
    Expect(1, 73663, '\P{^_Is_Lisu_supplement}', "");
    Expect(0, 73664, '\p{_Is_Lisu_supplement}', "");
    Expect(1, 73664, '\p{^_Is_Lisu_supplement}', "");
    Expect(1, 73664, '\P{_Is_Lisu_supplement}', "");
    Expect(0, 73664, '\P{^_Is_Lisu_supplement}', "");
    Error('\p{/a/- in_LISU_supplement}');
    Error('\P{/a/- in_LISU_supplement}');
    Expect(1, 73663, '\p{inlisusupplement}', "");
    Expect(0, 73663, '\p{^inlisusupplement}', "");
    Expect(0, 73663, '\P{inlisusupplement}', "");
    Expect(1, 73663, '\P{^inlisusupplement}', "");
    Expect(0, 73664, '\p{inlisusupplement}', "");
    Expect(1, 73664, '\p{^inlisusupplement}', "");
    Expect(1, 73664, '\P{inlisusupplement}', "");
    Expect(0, 73664, '\P{^inlisusupplement}', "");
    Expect(1, 73663, '\p{ -In_Lisu_Supplement}', "");
    Expect(0, 73663, '\p{^ -In_Lisu_Supplement}', "");
    Expect(0, 73663, '\P{ -In_Lisu_Supplement}', "");
    Expect(1, 73663, '\P{^ -In_Lisu_Supplement}', "");
    Expect(0, 73664, '\p{ -In_Lisu_Supplement}', "");
    Expect(1, 73664, '\p{^ -In_Lisu_Supplement}', "");
    Expect(1, 73664, '\P{ -In_Lisu_Supplement}', "");
    Expect(0, 73664, '\P{^ -In_Lisu_Supplement}', "");
    Error('\p{-lisu_Sup:=}');
    Error('\P{-lisu_Sup:=}');
    Expect(1, 73663, '\p{lisusup}', "");
    Expect(0, 73663, '\p{^lisusup}', "");
    Expect(0, 73663, '\P{lisusup}', "");
    Expect(1, 73663, '\P{^lisusup}', "");
    Expect(0, 73664, '\p{lisusup}', "");
    Expect(1, 73664, '\p{^lisusup}', "");
    Expect(1, 73664, '\P{lisusup}', "");
    Expect(0, 73664, '\P{^lisusup}', "");
    Expect(1, 73663, '\p{-_Lisu_sup}', "");
    Expect(0, 73663, '\p{^-_Lisu_sup}', "");
    Expect(0, 73663, '\P{-_Lisu_sup}', "");
    Expect(1, 73663, '\P{^-_Lisu_sup}', "");
    Expect(0, 73664, '\p{-_Lisu_sup}', "");
    Expect(1, 73664, '\p{^-_Lisu_sup}', "");
    Expect(1, 73664, '\P{-_Lisu_sup}', "");
    Expect(0, 73664, '\P{^-_Lisu_sup}', "");
    Error('\p{ -IS_Lisu_SUP:=}');
    Error('\P{ -IS_Lisu_SUP:=}');
    Expect(1, 73663, '\p{islisusup}', "");
    Expect(0, 73663, '\p{^islisusup}', "");
    Expect(0, 73663, '\P{islisusup}', "");
    Expect(1, 73663, '\P{^islisusup}', "");
    Expect(0, 73664, '\p{islisusup}', "");
    Expect(1, 73664, '\p{^islisusup}', "");
    Expect(1, 73664, '\P{islisusup}', "");
    Expect(0, 73664, '\P{^islisusup}', "");
    Expect(1, 73663, '\p{ _is_LISU_sup}', "");
    Expect(0, 73663, '\p{^ _is_LISU_sup}', "");
    Expect(0, 73663, '\P{ _is_LISU_sup}', "");
    Expect(1, 73663, '\P{^ _is_LISU_sup}', "");
    Expect(0, 73664, '\p{ _is_LISU_sup}', "");
    Expect(1, 73664, '\p{^ _is_LISU_sup}', "");
    Expect(1, 73664, '\P{ _is_LISU_sup}', "");
    Expect(0, 73664, '\P{^ _is_LISU_sup}', "");
    Error('\p{/a/IN_Lisu_SUP}');
    Error('\P{/a/IN_Lisu_SUP}');
    Expect(1, 73663, '\p{inlisusup}', "");
    Expect(0, 73663, '\p{^inlisusup}', "");
    Expect(0, 73663, '\P{inlisusup}', "");
    Expect(1, 73663, '\P{^inlisusup}', "");
    Expect(0, 73664, '\p{inlisusup}', "");
    Expect(1, 73664, '\p{^inlisusup}', "");
    Expect(1, 73664, '\P{inlisusup}', "");
    Expect(0, 73664, '\P{^inlisusup}', "");
    Expect(1, 73663, '\p{--IN_Lisu_Sup}', "");
    Expect(0, 73663, '\p{^--IN_Lisu_Sup}', "");
    Expect(0, 73663, '\P{--IN_Lisu_Sup}', "");
    Expect(1, 73663, '\P{^--IN_Lisu_Sup}', "");
    Expect(0, 73664, '\p{--IN_Lisu_Sup}', "");
    Expect(1, 73664, '\p{^--IN_Lisu_Sup}', "");
    Expect(1, 73664, '\P{--IN_Lisu_Sup}', "");
    Expect(0, 73664, '\P{^--IN_Lisu_Sup}', "");
    Error('\p{_/a/Logical_order_Exception}');
    Error('\P{_/a/Logical_order_Exception}');
    Expect(1, 43708, '\p{logicalorderexception}', "");
    Expect(0, 43708, '\p{^logicalorderexception}', "");
    Expect(0, 43708, '\P{logicalorderexception}', "");
    Expect(1, 43708, '\P{^logicalorderexception}', "");
    Expect(0, 43709, '\p{logicalorderexception}', "");
    Expect(1, 43709, '\p{^logicalorderexception}', "");
    Expect(1, 43709, '\P{logicalorderexception}', "");
    Expect(0, 43709, '\P{^logicalorderexception}', "");
    Expect(1, 43708, '\p{__LOGICAL_ORDER_Exception}', "");
    Expect(0, 43708, '\p{^__LOGICAL_ORDER_Exception}', "");
    Expect(0, 43708, '\P{__LOGICAL_ORDER_Exception}', "");
    Expect(1, 43708, '\P{^__LOGICAL_ORDER_Exception}', "");
    Expect(0, 43709, '\p{__LOGICAL_ORDER_Exception}', "");
    Expect(1, 43709, '\p{^__LOGICAL_ORDER_Exception}', "");
    Expect(1, 43709, '\P{__LOGICAL_ORDER_Exception}', "");
    Expect(0, 43709, '\P{^__LOGICAL_ORDER_Exception}', "");
    Error('\p{_-IS_LOGICAL_Order_EXCEPTION/a/}');
    Error('\P{_-IS_LOGICAL_Order_EXCEPTION/a/}');
    Expect(1, 43708, '\p{islogicalorderexception}', "");
    Expect(0, 43708, '\p{^islogicalorderexception}', "");
    Expect(0, 43708, '\P{islogicalorderexception}', "");
    Expect(1, 43708, '\P{^islogicalorderexception}', "");
    Expect(0, 43709, '\p{islogicalorderexception}', "");
    Expect(1, 43709, '\p{^islogicalorderexception}', "");
    Expect(1, 43709, '\P{islogicalorderexception}', "");
    Expect(0, 43709, '\P{^islogicalorderexception}', "");
    Expect(1, 43708, '\p{_-IS_Logical_Order_exception}', "");
    Expect(0, 43708, '\p{^_-IS_Logical_Order_exception}', "");
    Expect(0, 43708, '\P{_-IS_Logical_Order_exception}', "");
    Expect(1, 43708, '\P{^_-IS_Logical_Order_exception}', "");
    Expect(0, 43709, '\p{_-IS_Logical_Order_exception}', "");
    Expect(1, 43709, '\p{^_-IS_Logical_Order_exception}', "");
    Expect(1, 43709, '\P{_-IS_Logical_Order_exception}', "");
    Expect(0, 43709, '\P{^_-IS_Logical_Order_exception}', "");
    Error('\p{-/a/LOE}');
    Error('\P{-/a/LOE}');
    Expect(1, 43708, '\p{loe}', "");
    Expect(0, 43708, '\p{^loe}', "");
    Expect(0, 43708, '\P{loe}', "");
    Expect(1, 43708, '\P{^loe}', "");
    Expect(0, 43709, '\p{loe}', "");
    Expect(1, 43709, '\p{^loe}', "");
    Expect(1, 43709, '\P{loe}', "");
    Expect(0, 43709, '\P{^loe}', "");
    Expect(1, 43708, '\p{-LOE}', "");
    Expect(0, 43708, '\p{^-LOE}', "");
    Expect(0, 43708, '\P{-LOE}', "");
    Expect(1, 43708, '\P{^-LOE}', "");
    Expect(0, 43709, '\p{-LOE}', "");
    Expect(1, 43709, '\p{^-LOE}', "");
    Expect(1, 43709, '\P{-LOE}', "");
    Expect(0, 43709, '\P{^-LOE}', "");
    Error('\p{-IS_LOE/a/}');
    Error('\P{-IS_LOE/a/}');
    Expect(1, 43708, '\p{isloe}', "");
    Expect(0, 43708, '\p{^isloe}', "");
    Expect(0, 43708, '\P{isloe}', "");
    Expect(1, 43708, '\P{^isloe}', "");
    Expect(0, 43709, '\p{isloe}', "");
    Expect(1, 43709, '\p{^isloe}', "");
    Expect(1, 43709, '\P{isloe}', "");
    Expect(0, 43709, '\P{^isloe}', "");
    Expect(1, 43708, '\p{-_Is_LOE}', "");
    Expect(0, 43708, '\p{^-_Is_LOE}', "");
    Expect(0, 43708, '\P{-_Is_LOE}', "");
    Expect(1, 43708, '\P{^-_Is_LOE}', "");
    Expect(0, 43709, '\p{-_Is_LOE}', "");
    Expect(1, 43709, '\p{^-_Is_LOE}', "");
    Expect(1, 43709, '\P{-_Is_LOE}', "");
    Expect(0, 43709, '\P{^-_Is_LOE}', "");
    Error('\p{-Low_Surrogates:=}');
    Error('\P{-Low_Surrogates:=}');
    Expect(1, 57343, '\p{lowsurrogates}', "");
    Expect(0, 57343, '\p{^lowsurrogates}', "");
    Expect(0, 57343, '\P{lowsurrogates}', "");
    Expect(1, 57343, '\P{^lowsurrogates}', "");
    Expect(0, 57344, '\p{lowsurrogates}', "");
    Expect(1, 57344, '\p{^lowsurrogates}', "");
    Expect(1, 57344, '\P{lowsurrogates}', "");
    Expect(0, 57344, '\P{^lowsurrogates}', "");
    Expect(1, 57343, '\p{ LOW_SURROGATES}', "");
    Expect(0, 57343, '\p{^ LOW_SURROGATES}', "");
    Expect(0, 57343, '\P{ LOW_SURROGATES}', "");
    Expect(1, 57343, '\P{^ LOW_SURROGATES}', "");
    Expect(0, 57344, '\p{ LOW_SURROGATES}', "");
    Expect(1, 57344, '\p{^ LOW_SURROGATES}', "");
    Expect(1, 57344, '\P{ LOW_SURROGATES}', "");
    Expect(0, 57344, '\P{^ LOW_SURROGATES}', "");
    Error('\p{__Is_Low_Surrogates/a/}');
    Error('\P{__Is_Low_Surrogates/a/}');
    Expect(1, 57343, '\p{islowsurrogates}', "");
    Expect(0, 57343, '\p{^islowsurrogates}', "");
    Expect(0, 57343, '\P{islowsurrogates}', "");
    Expect(1, 57343, '\P{^islowsurrogates}', "");
    Expect(0, 57344, '\p{islowsurrogates}', "");
    Expect(1, 57344, '\p{^islowsurrogates}', "");
    Expect(1, 57344, '\P{islowsurrogates}', "");
    Expect(0, 57344, '\P{^islowsurrogates}', "");
    Expect(1, 57343, '\p{-	IS_Low_Surrogates}', "");
    Expect(0, 57343, '\p{^-	IS_Low_Surrogates}', "");
    Expect(0, 57343, '\P{-	IS_Low_Surrogates}', "");
    Expect(1, 57343, '\P{^-	IS_Low_Surrogates}', "");
    Expect(0, 57344, '\p{-	IS_Low_Surrogates}', "");
    Expect(1, 57344, '\p{^-	IS_Low_Surrogates}', "");
    Expect(1, 57344, '\P{-	IS_Low_Surrogates}', "");
    Expect(0, 57344, '\P{^-	IS_Low_Surrogates}', "");
    Error('\p{:=In_Low_SURROGATES}');
    Error('\P{:=In_Low_SURROGATES}');
    Expect(1, 57343, '\p{inlowsurrogates}', "");
    Expect(0, 57343, '\p{^inlowsurrogates}', "");
    Expect(0, 57343, '\P{inlowsurrogates}', "");
    Expect(1, 57343, '\P{^inlowsurrogates}', "");
    Expect(0, 57344, '\p{inlowsurrogates}', "");
    Expect(1, 57344, '\p{^inlowsurrogates}', "");
    Expect(1, 57344, '\P{inlowsurrogates}', "");
    Expect(0, 57344, '\P{^inlowsurrogates}', "");
    Expect(1, 57343, '\p{_	In_Low_Surrogates}', "");
    Expect(0, 57343, '\p{^_	In_Low_Surrogates}', "");
    Expect(0, 57343, '\P{_	In_Low_Surrogates}', "");
    Expect(1, 57343, '\P{^_	In_Low_Surrogates}', "");
    Expect(0, 57344, '\p{_	In_Low_Surrogates}', "");
    Expect(1, 57344, '\p{^_	In_Low_Surrogates}', "");
    Expect(1, 57344, '\P{_	In_Low_Surrogates}', "");
    Expect(0, 57344, '\P{^_	In_Low_Surrogates}', "");
    Error('\p{  Lowercase_LETTER/a/}');
    Error('\P{  Lowercase_LETTER/a/}');
    Expect(1, 125251, '\p{lowercaseletter}', "");
    Expect(0, 125251, '\p{^lowercaseletter}', "");
    Expect(0, 125251, '\P{lowercaseletter}', "");
    Expect(1, 125251, '\P{^lowercaseletter}', "");
    Expect(0, 125252, '\p{lowercaseletter}', "");
    Expect(1, 125252, '\p{^lowercaseletter}', "");
    Expect(1, 125252, '\P{lowercaseletter}', "");
    Expect(0, 125252, '\P{^lowercaseletter}', "");
    Expect(1, 125251, '\p{  Lowercase_Letter}', "");
    Expect(0, 125251, '\p{^  Lowercase_Letter}', "");
    Expect(0, 125251, '\P{  Lowercase_Letter}', "");
    Expect(1, 125251, '\P{^  Lowercase_Letter}', "");
    Expect(0, 125252, '\p{  Lowercase_Letter}', "");
    Expect(1, 125252, '\p{^  Lowercase_Letter}', "");
    Expect(1, 125252, '\P{  Lowercase_Letter}', "");
    Expect(0, 125252, '\P{^  Lowercase_Letter}', "");
    Error('\p{	:=is_Lowercase_Letter}');
    Error('\P{	:=is_Lowercase_Letter}');
    Expect(1, 125251, '\p{islowercaseletter}', "");
    Expect(0, 125251, '\p{^islowercaseletter}', "");
    Expect(0, 125251, '\P{islowercaseletter}', "");
    Expect(1, 125251, '\P{^islowercaseletter}', "");
    Expect(0, 125252, '\p{islowercaseletter}', "");
    Expect(1, 125252, '\p{^islowercaseletter}', "");
    Expect(1, 125252, '\P{islowercaseletter}', "");
    Expect(0, 125252, '\P{^islowercaseletter}', "");
    Expect(1, 125251, '\p{	-is_LOWERCASE_Letter}', "");
    Expect(0, 125251, '\p{^	-is_LOWERCASE_Letter}', "");
    Expect(0, 125251, '\P{	-is_LOWERCASE_Letter}', "");
    Expect(1, 125251, '\P{^	-is_LOWERCASE_Letter}', "");
    Expect(0, 125252, '\p{	-is_LOWERCASE_Letter}', "");
    Expect(1, 125252, '\p{^	-is_LOWERCASE_Letter}', "");
    Expect(1, 125252, '\P{	-is_LOWERCASE_Letter}', "");
    Expect(0, 125252, '\P{^	-is_LOWERCASE_Letter}', "");
    Error('\p{-/a/ll}');
    Error('\P{-/a/ll}');
    Expect(1, 125251, '\p{ll}', "");
    Expect(0, 125251, '\p{^ll}', "");
    Expect(0, 125251, '\P{ll}', "");
    Expect(1, 125251, '\P{^ll}', "");
    Expect(0, 125252, '\p{ll}', "");
    Expect(1, 125252, '\p{^ll}', "");
    Expect(1, 125252, '\P{ll}', "");
    Expect(0, 125252, '\P{^ll}', "");
    Expect(1, 125251, '\p{_-LL}', "");
    Expect(0, 125251, '\p{^_-LL}', "");
    Expect(0, 125251, '\P{_-LL}', "");
    Expect(1, 125251, '\P{^_-LL}', "");
    Expect(0, 125252, '\p{_-LL}', "");
    Expect(1, 125252, '\p{^_-LL}', "");
    Expect(1, 125252, '\P{_-LL}', "");
    Expect(0, 125252, '\P{^_-LL}', "");
    Error('\p{-/a/is_Ll}');
    Error('\P{-/a/is_Ll}');
    Expect(1, 125251, '\p{isll}', "");
    Expect(0, 125251, '\p{^isll}', "");
    Expect(0, 125251, '\P{isll}', "");
    Expect(1, 125251, '\P{^isll}', "");
    Expect(0, 125252, '\p{isll}', "");
    Expect(1, 125252, '\p{^isll}', "");
    Expect(1, 125252, '\P{isll}', "");
    Expect(0, 125252, '\P{^isll}', "");
    Expect(1, 125251, '\p{	-IS_Ll}', "");
    Expect(0, 125251, '\p{^	-IS_Ll}', "");
    Expect(0, 125251, '\P{	-IS_Ll}', "");
    Expect(1, 125251, '\P{^	-IS_Ll}', "");
    Expect(0, 125252, '\p{	-IS_Ll}', "");
    Expect(1, 125252, '\p{^	-IS_Ll}', "");
    Expect(1, 125252, '\P{	-IS_Ll}', "");
    Expect(0, 125252, '\P{^	-IS_Ll}', "");
    Error('\p{  LYCIAN/a/}');
    Error('\P{  LYCIAN/a/}');
    Expect(1, 66204, '\p{lycian}', "");
    Expect(0, 66204, '\p{^lycian}', "");
    Expect(0, 66204, '\P{lycian}', "");
    Expect(1, 66204, '\P{^lycian}', "");
    Expect(0, 66205, '\p{lycian}', "");
    Expect(1, 66205, '\p{^lycian}', "");
    Expect(1, 66205, '\P{lycian}', "");
    Expect(0, 66205, '\P{^lycian}', "");
    Expect(1, 66204, '\p{ lycian}', "");
    Expect(0, 66204, '\p{^ lycian}', "");
    Expect(0, 66204, '\P{ lycian}', "");
    Expect(1, 66204, '\P{^ lycian}', "");
    Expect(0, 66205, '\p{ lycian}', "");
    Expect(1, 66205, '\p{^ lycian}', "");
    Expect(1, 66205, '\P{ lycian}', "");
    Expect(0, 66205, '\P{^ lycian}', "");
    Error('\p{/a/_ IS_Lycian}');
    Error('\P{/a/_ IS_Lycian}');
    Expect(1, 66204, '\p{islycian}', "");
    Expect(0, 66204, '\p{^islycian}', "");
    Expect(0, 66204, '\P{islycian}', "");
    Expect(1, 66204, '\P{^islycian}', "");
    Expect(0, 66205, '\p{islycian}', "");
    Expect(1, 66205, '\p{^islycian}', "");
    Expect(1, 66205, '\P{islycian}', "");
    Expect(0, 66205, '\P{^islycian}', "");
    Expect(1, 66204, '\p{_ Is_Lycian}', "");
    Expect(0, 66204, '\p{^_ Is_Lycian}', "");
    Expect(0, 66204, '\P{_ Is_Lycian}', "");
    Expect(1, 66204, '\P{^_ Is_Lycian}', "");
    Expect(0, 66205, '\p{_ Is_Lycian}', "");
    Expect(1, 66205, '\p{^_ Is_Lycian}', "");
    Expect(1, 66205, '\P{_ Is_Lycian}', "");
    Expect(0, 66205, '\P{^_ Is_Lycian}', "");
    Error('\p{	:=Lyci}');
    Error('\P{	:=Lyci}');
    Expect(1, 66204, '\p{lyci}', "");
    Expect(0, 66204, '\p{^lyci}', "");
    Expect(0, 66204, '\P{lyci}', "");
    Expect(1, 66204, '\P{^lyci}', "");
    Expect(0, 66205, '\p{lyci}', "");
    Expect(1, 66205, '\p{^lyci}', "");
    Expect(1, 66205, '\P{lyci}', "");
    Expect(0, 66205, '\P{^lyci}', "");
    Expect(1, 66204, '\p{	_LYCI}', "");
    Expect(0, 66204, '\p{^	_LYCI}', "");
    Expect(0, 66204, '\P{	_LYCI}', "");
    Expect(1, 66204, '\P{^	_LYCI}', "");
    Expect(0, 66205, '\p{	_LYCI}', "");
    Expect(1, 66205, '\p{^	_LYCI}', "");
    Expect(1, 66205, '\P{	_LYCI}', "");
    Expect(0, 66205, '\P{^	_LYCI}', "");
    Error('\p{/a/_	IS_LYCI}');
    Error('\P{/a/_	IS_LYCI}');
    Expect(1, 66204, '\p{islyci}', "");
    Expect(0, 66204, '\p{^islyci}', "");
    Expect(0, 66204, '\P{islyci}', "");
    Expect(1, 66204, '\P{^islyci}', "");
    Expect(0, 66205, '\p{islyci}', "");
    Expect(1, 66205, '\p{^islyci}', "");
    Expect(1, 66205, '\P{islyci}', "");
    Expect(0, 66205, '\P{^islyci}', "");
    Expect(1, 66204, '\p{_-Is_lyci}', "");
    Expect(0, 66204, '\p{^_-Is_lyci}', "");
    Expect(0, 66204, '\P{_-Is_lyci}', "");
    Expect(1, 66204, '\P{^_-Is_lyci}', "");
    Expect(0, 66205, '\p{_-Is_lyci}', "");
    Expect(1, 66205, '\p{^_-Is_lyci}', "");
    Expect(1, 66205, '\P{_-Is_lyci}', "");
    Expect(0, 66205, '\P{^_-Is_lyci}', "");
    Error('\p{-:=Lydian}');
    Error('\P{-:=Lydian}');
    Expect(1, 67903, '\p{lydian}', "");
    Expect(0, 67903, '\p{^lydian}', "");
    Expect(0, 67903, '\P{lydian}', "");
    Expect(1, 67903, '\P{^lydian}', "");
    Expect(0, 67904, '\p{lydian}', "");
    Expect(1, 67904, '\p{^lydian}', "");
    Expect(1, 67904, '\P{lydian}', "");
    Expect(0, 67904, '\P{^lydian}', "");
    Expect(1, 67903, '\p{ 	lydian}', "");
    Expect(0, 67903, '\p{^ 	lydian}', "");
    Expect(0, 67903, '\P{ 	lydian}', "");
    Expect(1, 67903, '\P{^ 	lydian}', "");
    Expect(0, 67904, '\p{ 	lydian}', "");
    Expect(1, 67904, '\p{^ 	lydian}', "");
    Expect(1, 67904, '\P{ 	lydian}', "");
    Expect(0, 67904, '\P{^ 	lydian}', "");
    Error('\p{ Is_Lydian/a/}');
    Error('\P{ Is_Lydian/a/}');
    Expect(1, 67903, '\p{islydian}', "");
    Expect(0, 67903, '\p{^islydian}', "");
    Expect(0, 67903, '\P{islydian}', "");
    Expect(1, 67903, '\P{^islydian}', "");
    Expect(0, 67904, '\p{islydian}', "");
    Expect(1, 67904, '\p{^islydian}', "");
    Expect(1, 67904, '\P{islydian}', "");
    Expect(0, 67904, '\P{^islydian}', "");
    Expect(1, 67903, '\p{_-is_Lydian}', "");
    Expect(0, 67903, '\p{^_-is_Lydian}', "");
    Expect(0, 67903, '\P{_-is_Lydian}', "");
    Expect(1, 67903, '\P{^_-is_Lydian}', "");
    Expect(0, 67904, '\p{_-is_Lydian}', "");
    Expect(1, 67904, '\p{^_-is_Lydian}', "");
    Expect(1, 67904, '\P{_-is_Lydian}', "");
    Expect(0, 67904, '\P{^_-is_Lydian}', "");
    Error('\p{/a/_	lydi}');
    Error('\P{/a/_	lydi}');
    Expect(1, 67903, '\p{lydi}', "");
    Expect(0, 67903, '\p{^lydi}', "");
    Expect(0, 67903, '\P{lydi}', "");
    Expect(1, 67903, '\P{^lydi}', "");
    Expect(0, 67904, '\p{lydi}', "");
    Expect(1, 67904, '\p{^lydi}', "");
    Expect(1, 67904, '\P{lydi}', "");
    Expect(0, 67904, '\P{^lydi}', "");
    Expect(1, 67903, '\p{ Lydi}', "");
    Expect(0, 67903, '\p{^ Lydi}', "");
    Expect(0, 67903, '\P{ Lydi}', "");
    Expect(1, 67903, '\P{^ Lydi}', "");
    Expect(0, 67904, '\p{ Lydi}', "");
    Expect(1, 67904, '\p{^ Lydi}', "");
    Expect(1, 67904, '\P{ Lydi}', "");
    Expect(0, 67904, '\P{^ Lydi}', "");
    Error('\p{:=--is_lydi}');
    Error('\P{:=--is_lydi}');
    Expect(1, 67903, '\p{islydi}', "");
    Expect(0, 67903, '\p{^islydi}', "");
    Expect(0, 67903, '\P{islydi}', "");
    Expect(1, 67903, '\P{^islydi}', "");
    Expect(0, 67904, '\p{islydi}', "");
    Expect(1, 67904, '\p{^islydi}', "");
    Expect(1, 67904, '\P{islydi}', "");
    Expect(0, 67904, '\P{^islydi}', "");
    Expect(1, 67903, '\p{-IS_Lydi}', "");
    Expect(0, 67903, '\p{^-IS_Lydi}', "");
    Expect(0, 67903, '\P{-IS_Lydi}', "");
    Expect(1, 67903, '\P{^-IS_Lydi}', "");
    Expect(0, 67904, '\p{-IS_Lydi}', "");
    Expect(1, 67904, '\p{^-IS_Lydi}', "");
    Expect(1, 67904, '\P{-IS_Lydi}', "");
    Expect(0, 67904, '\P{^-IS_Lydi}', "");
    Error('\p{/a/mahajani}');
    Error('\P{/a/mahajani}');
    Expect(1, 70006, '\p{mahajani}', "");
    Expect(0, 70006, '\p{^mahajani}', "");
    Expect(0, 70006, '\P{mahajani}', "");
    Expect(1, 70006, '\P{^mahajani}', "");
    Expect(0, 70007, '\p{mahajani}', "");
    Expect(1, 70007, '\p{^mahajani}', "");
    Expect(1, 70007, '\P{mahajani}', "");
    Expect(0, 70007, '\P{^mahajani}', "");
    Expect(1, 70006, '\p{	Mahajani}', "");
    Expect(0, 70006, '\p{^	Mahajani}', "");
    Expect(0, 70006, '\P{	Mahajani}', "");
    Expect(1, 70006, '\P{^	Mahajani}', "");
    Expect(0, 70007, '\p{	Mahajani}', "");
    Expect(1, 70007, '\p{^	Mahajani}', "");
    Expect(1, 70007, '\P{	Mahajani}', "");
    Expect(0, 70007, '\P{^	Mahajani}', "");
    Error('\p{_Is_Mahajani:=}');
    Error('\P{_Is_Mahajani:=}');
    Expect(1, 70006, '\p{ismahajani}', "");
    Expect(0, 70006, '\p{^ismahajani}', "");
    Expect(0, 70006, '\P{ismahajani}', "");
    Expect(1, 70006, '\P{^ismahajani}', "");
    Expect(0, 70007, '\p{ismahajani}', "");
    Expect(1, 70007, '\p{^ismahajani}', "");
    Expect(1, 70007, '\P{ismahajani}', "");
    Expect(0, 70007, '\P{^ismahajani}', "");
    Expect(1, 70006, '\p{-	IS_Mahajani}', "");
    Expect(0, 70006, '\p{^-	IS_Mahajani}', "");
    Expect(0, 70006, '\P{-	IS_Mahajani}', "");
    Expect(1, 70006, '\P{^-	IS_Mahajani}', "");
    Expect(0, 70007, '\p{-	IS_Mahajani}', "");
    Expect(1, 70007, '\p{^-	IS_Mahajani}', "");
    Expect(1, 70007, '\P{-	IS_Mahajani}', "");
    Expect(0, 70007, '\P{^-	IS_Mahajani}', "");
    Error('\p{- Mahj:=}');
    Error('\P{- Mahj:=}');
    Expect(1, 70006, '\p{mahj}', "");
    Expect(0, 70006, '\p{^mahj}', "");
    Expect(0, 70006, '\P{mahj}', "");
    Expect(1, 70006, '\P{^mahj}', "");
    Expect(0, 70007, '\p{mahj}', "");
    Expect(1, 70007, '\p{^mahj}', "");
    Expect(1, 70007, '\P{mahj}', "");
    Expect(0, 70007, '\P{^mahj}', "");
    Expect(1, 70006, '\p{ mahj}', "");
    Expect(0, 70006, '\p{^ mahj}', "");
    Expect(0, 70006, '\P{ mahj}', "");
    Expect(1, 70006, '\P{^ mahj}', "");
    Expect(0, 70007, '\p{ mahj}', "");
    Expect(1, 70007, '\p{^ mahj}', "");
    Expect(1, 70007, '\P{ mahj}', "");
    Expect(0, 70007, '\P{^ mahj}', "");
    Error('\p{/a/	is_Mahj}');
    Error('\P{/a/	is_Mahj}');
    Expect(1, 70006, '\p{ismahj}', "");
    Expect(0, 70006, '\p{^ismahj}', "");
    Expect(0, 70006, '\P{ismahj}', "");
    Expect(1, 70006, '\P{^ismahj}', "");
    Expect(0, 70007, '\p{ismahj}', "");
    Expect(1, 70007, '\p{^ismahj}', "");
    Expect(1, 70007, '\P{ismahj}', "");
    Expect(0, 70007, '\P{^ismahj}', "");
    Expect(1, 70006, '\p{	 Is_MAHJ}', "");
    Expect(0, 70006, '\p{^	 Is_MAHJ}', "");
    Expect(0, 70006, '\P{	 Is_MAHJ}', "");
    Expect(1, 70006, '\P{^	 Is_MAHJ}', "");
    Expect(0, 70007, '\p{	 Is_MAHJ}', "");
    Expect(1, 70007, '\p{^	 Is_MAHJ}', "");
    Expect(1, 70007, '\P{	 Is_MAHJ}', "");
    Expect(0, 70007, '\P{^	 Is_MAHJ}', "");
    Error('\p{:=		Mahjong_Tiles}');
    Error('\P{:=		Mahjong_Tiles}');
    Expect(1, 127023, '\p{mahjongtiles}', "");
    Expect(0, 127023, '\p{^mahjongtiles}', "");
    Expect(0, 127023, '\P{mahjongtiles}', "");
    Expect(1, 127023, '\P{^mahjongtiles}', "");
    Expect(0, 127024, '\p{mahjongtiles}', "");
    Expect(1, 127024, '\p{^mahjongtiles}', "");
    Expect(1, 127024, '\P{mahjongtiles}', "");
    Expect(0, 127024, '\P{^mahjongtiles}', "");
    Expect(1, 127023, '\p{-Mahjong_tiles}', "");
    Expect(0, 127023, '\p{^-Mahjong_tiles}', "");
    Expect(0, 127023, '\P{-Mahjong_tiles}', "");
    Expect(1, 127023, '\P{^-Mahjong_tiles}', "");
    Expect(0, 127024, '\p{-Mahjong_tiles}', "");
    Expect(1, 127024, '\p{^-Mahjong_tiles}', "");
    Expect(1, 127024, '\P{-Mahjong_tiles}', "");
    Expect(0, 127024, '\P{^-Mahjong_tiles}', "");
    Error('\p{/a/_ Is_Mahjong_tiles}');
    Error('\P{/a/_ Is_Mahjong_tiles}');
    Expect(1, 127023, '\p{ismahjongtiles}', "");
    Expect(0, 127023, '\p{^ismahjongtiles}', "");
    Expect(0, 127023, '\P{ismahjongtiles}', "");
    Expect(1, 127023, '\P{^ismahjongtiles}', "");
    Expect(0, 127024, '\p{ismahjongtiles}', "");
    Expect(1, 127024, '\p{^ismahjongtiles}', "");
    Expect(1, 127024, '\P{ismahjongtiles}', "");
    Expect(0, 127024, '\P{^ismahjongtiles}', "");
    Expect(1, 127023, '\p{-	Is_mahjong_TILES}', "");
    Expect(0, 127023, '\p{^-	Is_mahjong_TILES}', "");
    Expect(0, 127023, '\P{-	Is_mahjong_TILES}', "");
    Expect(1, 127023, '\P{^-	Is_mahjong_TILES}', "");
    Expect(0, 127024, '\p{-	Is_mahjong_TILES}', "");
    Expect(1, 127024, '\p{^-	Is_mahjong_TILES}', "");
    Expect(1, 127024, '\P{-	Is_mahjong_TILES}', "");
    Expect(0, 127024, '\P{^-	Is_mahjong_TILES}', "");
    Error('\p{-in_MAHJONG_tiles/a/}');
    Error('\P{-in_MAHJONG_tiles/a/}');
    Expect(1, 127023, '\p{inmahjongtiles}', "");
    Expect(0, 127023, '\p{^inmahjongtiles}', "");
    Expect(0, 127023, '\P{inmahjongtiles}', "");
    Expect(1, 127023, '\P{^inmahjongtiles}', "");
    Expect(0, 127024, '\p{inmahjongtiles}', "");
    Expect(1, 127024, '\p{^inmahjongtiles}', "");
    Expect(1, 127024, '\P{inmahjongtiles}', "");
    Expect(0, 127024, '\P{^inmahjongtiles}', "");
    Expect(1, 127023, '\p{-IN_Mahjong_TILES}', "");
    Expect(0, 127023, '\p{^-IN_Mahjong_TILES}', "");
    Expect(0, 127023, '\P{-IN_Mahjong_TILES}', "");
    Expect(1, 127023, '\P{^-IN_Mahjong_TILES}', "");
    Expect(0, 127024, '\p{-IN_Mahjong_TILES}', "");
    Expect(1, 127024, '\p{^-IN_Mahjong_TILES}', "");
    Expect(1, 127024, '\P{-IN_Mahjong_TILES}', "");
    Expect(0, 127024, '\P{^-IN_Mahjong_TILES}', "");
    Error('\p{:=__MAHJONG}');
    Error('\P{:=__MAHJONG}');
    Expect(1, 127023, '\p{mahjong}', "");
    Expect(0, 127023, '\p{^mahjong}', "");
    Expect(0, 127023, '\P{mahjong}', "");
    Expect(1, 127023, '\P{^mahjong}', "");
    Expect(0, 127024, '\p{mahjong}', "");
    Expect(1, 127024, '\p{^mahjong}', "");
    Expect(1, 127024, '\P{mahjong}', "");
    Expect(0, 127024, '\P{^mahjong}', "");
    Expect(1, 127023, '\p{ -mahjong}', "");
    Expect(0, 127023, '\p{^ -mahjong}', "");
    Expect(0, 127023, '\P{ -mahjong}', "");
    Expect(1, 127023, '\P{^ -mahjong}', "");
    Expect(0, 127024, '\p{ -mahjong}', "");
    Expect(1, 127024, '\p{^ -mahjong}', "");
    Expect(1, 127024, '\P{ -mahjong}', "");
    Expect(0, 127024, '\P{^ -mahjong}', "");
    Error('\p{/a/-is_Mahjong}');
    Error('\P{/a/-is_Mahjong}');
    Expect(1, 127023, '\p{ismahjong}', "");
    Expect(0, 127023, '\p{^ismahjong}', "");
    Expect(0, 127023, '\P{ismahjong}', "");
    Expect(1, 127023, '\P{^ismahjong}', "");
    Expect(0, 127024, '\p{ismahjong}', "");
    Expect(1, 127024, '\p{^ismahjong}', "");
    Expect(1, 127024, '\P{ismahjong}', "");
    Expect(0, 127024, '\P{^ismahjong}', "");
    Expect(1, 127023, '\p{ IS_MAHJONG}', "");
    Expect(0, 127023, '\p{^ IS_MAHJONG}', "");
    Expect(0, 127023, '\P{ IS_MAHJONG}', "");
    Expect(1, 127023, '\P{^ IS_MAHJONG}', "");
    Expect(0, 127024, '\p{ IS_MAHJONG}', "");
    Expect(1, 127024, '\p{^ IS_MAHJONG}', "");
    Expect(1, 127024, '\P{ IS_MAHJONG}', "");
    Expect(0, 127024, '\P{^ IS_MAHJONG}', "");
    Error('\p{/a/--In_Mahjong}');
    Error('\P{/a/--In_Mahjong}');
    Expect(1, 127023, '\p{inmahjong}', "");
    Expect(0, 127023, '\p{^inmahjong}', "");
    Expect(0, 127023, '\P{inmahjong}', "");
    Expect(1, 127023, '\P{^inmahjong}', "");
    Expect(0, 127024, '\p{inmahjong}', "");
    Expect(1, 127024, '\p{^inmahjong}', "");
    Expect(1, 127024, '\P{inmahjong}', "");
    Expect(0, 127024, '\P{^inmahjong}', "");
    Expect(1, 127023, '\p{ In_mahjong}', "");
    Expect(0, 127023, '\p{^ In_mahjong}', "");
    Expect(0, 127023, '\P{ In_mahjong}', "");
    Expect(1, 127023, '\P{^ In_mahjong}', "");
    Expect(0, 127024, '\p{ In_mahjong}', "");
    Expect(1, 127024, '\p{^ In_mahjong}', "");
    Expect(1, 127024, '\P{ In_mahjong}', "");
    Expect(0, 127024, '\P{^ In_mahjong}', "");
    Error('\p{	makasar:=}');
    Error('\P{	makasar:=}');
    Expect(1, 73464, '\p{makasar}', "");
    Expect(0, 73464, '\p{^makasar}', "");
    Expect(0, 73464, '\P{makasar}', "");
    Expect(1, 73464, '\P{^makasar}', "");
    Expect(0, 73465, '\p{makasar}', "");
    Expect(1, 73465, '\p{^makasar}', "");
    Expect(1, 73465, '\P{makasar}', "");
    Expect(0, 73465, '\P{^makasar}', "");
    Expect(1, 73464, '\p{ _MAKASAR}', "");
    Expect(0, 73464, '\p{^ _MAKASAR}', "");
    Expect(0, 73464, '\P{ _MAKASAR}', "");
    Expect(1, 73464, '\P{^ _MAKASAR}', "");
    Expect(0, 73465, '\p{ _MAKASAR}', "");
    Expect(1, 73465, '\p{^ _MAKASAR}', "");
    Expect(1, 73465, '\P{ _MAKASAR}', "");
    Expect(0, 73465, '\P{^ _MAKASAR}', "");
    Error('\p{_ is_Makasar/a/}');
    Error('\P{_ is_Makasar/a/}');
    Expect(1, 73464, '\p{ismakasar}', "");
    Expect(0, 73464, '\p{^ismakasar}', "");
    Expect(0, 73464, '\P{ismakasar}', "");
    Expect(1, 73464, '\P{^ismakasar}', "");
    Expect(0, 73465, '\p{ismakasar}', "");
    Expect(1, 73465, '\p{^ismakasar}', "");
    Expect(1, 73465, '\P{ismakasar}', "");
    Expect(0, 73465, '\P{^ismakasar}', "");
    Expect(1, 73464, '\p{IS_makasar}', "");
    Expect(0, 73464, '\p{^IS_makasar}', "");
    Expect(0, 73464, '\P{IS_makasar}', "");
    Expect(1, 73464, '\P{^IS_makasar}', "");
    Expect(0, 73465, '\p{IS_makasar}', "");
    Expect(1, 73465, '\p{^IS_makasar}', "");
    Expect(1, 73465, '\P{IS_makasar}', "");
    Expect(0, 73465, '\P{^IS_makasar}', "");
    Error('\p{- maka:=}');
    Error('\P{- maka:=}');
    Expect(1, 73464, '\p{maka}', "");
    Expect(0, 73464, '\p{^maka}', "");
    Expect(0, 73464, '\P{maka}', "");
    Expect(1, 73464, '\P{^maka}', "");
    Expect(0, 73465, '\p{maka}', "");
    Expect(1, 73465, '\p{^maka}', "");
    Expect(1, 73465, '\P{maka}', "");
    Expect(0, 73465, '\P{^maka}', "");
    Expect(1, 73464, '\p{	_Maka}', "");
    Expect(0, 73464, '\p{^	_Maka}', "");
    Expect(0, 73464, '\P{	_Maka}', "");
    Expect(1, 73464, '\P{^	_Maka}', "");
    Expect(0, 73465, '\p{	_Maka}', "");
    Expect(1, 73465, '\p{^	_Maka}', "");
    Expect(1, 73465, '\P{	_Maka}', "");
    Expect(0, 73465, '\P{^	_Maka}', "");
    Error('\p{:=_-Is_MAKA}');
    Error('\P{:=_-Is_MAKA}');
    Expect(1, 73464, '\p{ismaka}', "");
    Expect(0, 73464, '\p{^ismaka}', "");
    Expect(0, 73464, '\P{ismaka}', "");
    Expect(1, 73464, '\P{^ismaka}', "");
    Expect(0, 73465, '\p{ismaka}', "");
    Expect(1, 73465, '\p{^ismaka}', "");
    Expect(1, 73465, '\P{ismaka}', "");
    Expect(0, 73465, '\P{^ismaka}', "");
    Expect(1, 73464, '\p{_ is_Maka}', "");
    Expect(0, 73464, '\p{^_ is_Maka}', "");
    Expect(0, 73464, '\P{_ is_Maka}', "");
    Expect(1, 73464, '\P{^_ is_Maka}', "");
    Expect(0, 73465, '\p{_ is_Maka}', "");
    Expect(1, 73465, '\p{^_ is_Maka}', "");
    Expect(1, 73465, '\P{_ is_Maka}', "");
    Expect(0, 73465, '\P{^_ is_Maka}', "");
    Error('\p{_:=malayalam}');
    Error('\P{_:=malayalam}');
    Expect(1, 43058, '\p{malayalam}', "");
    Expect(0, 43058, '\p{^malayalam}', "");
    Expect(0, 43058, '\P{malayalam}', "");
    Expect(1, 43058, '\P{^malayalam}', "");
    Expect(0, 43059, '\p{malayalam}', "");
    Expect(1, 43059, '\p{^malayalam}', "");
    Expect(1, 43059, '\P{malayalam}', "");
    Expect(0, 43059, '\P{^malayalam}', "");
    Expect(1, 43058, '\p{_	Malayalam}', "");
    Expect(0, 43058, '\p{^_	Malayalam}', "");
    Expect(0, 43058, '\P{_	Malayalam}', "");
    Expect(1, 43058, '\P{^_	Malayalam}', "");
    Expect(0, 43059, '\p{_	Malayalam}', "");
    Expect(1, 43059, '\p{^_	Malayalam}', "");
    Expect(1, 43059, '\P{_	Malayalam}', "");
    Expect(0, 43059, '\P{^_	Malayalam}', "");
    Error('\p{	Is_malayalam/a/}');
    Error('\P{	Is_malayalam/a/}');
    Expect(1, 43058, '\p{ismalayalam}', "");
    Expect(0, 43058, '\p{^ismalayalam}', "");
    Expect(0, 43058, '\P{ismalayalam}', "");
    Expect(1, 43058, '\P{^ismalayalam}', "");
    Expect(0, 43059, '\p{ismalayalam}', "");
    Expect(1, 43059, '\p{^ismalayalam}', "");
    Expect(1, 43059, '\P{ismalayalam}', "");
    Expect(0, 43059, '\P{^ismalayalam}', "");
    Expect(1, 43058, '\p{-Is_Malayalam}', "");
    Expect(0, 43058, '\p{^-Is_Malayalam}', "");
    Expect(0, 43058, '\P{-Is_Malayalam}', "");
    Expect(1, 43058, '\P{^-Is_Malayalam}', "");
    Expect(0, 43059, '\p{-Is_Malayalam}', "");
    Expect(1, 43059, '\p{^-Is_Malayalam}', "");
    Expect(1, 43059, '\P{-Is_Malayalam}', "");
    Expect(0, 43059, '\P{^-Is_Malayalam}', "");
    Error('\p{ Mlym/a/}');
    Error('\P{ Mlym/a/}');
    Expect(1, 43058, '\p{mlym}', "");
    Expect(0, 43058, '\p{^mlym}', "");
    Expect(0, 43058, '\P{mlym}', "");
    Expect(1, 43058, '\P{^mlym}', "");
    Expect(0, 43059, '\p{mlym}', "");
    Expect(1, 43059, '\p{^mlym}', "");
    Expect(1, 43059, '\P{mlym}', "");
    Expect(0, 43059, '\P{^mlym}', "");
    Expect(1, 43058, '\p{ Mlym}', "");
    Expect(0, 43058, '\p{^ Mlym}', "");
    Expect(0, 43058, '\P{ Mlym}', "");
    Expect(1, 43058, '\P{^ Mlym}', "");
    Expect(0, 43059, '\p{ Mlym}', "");
    Expect(1, 43059, '\p{^ Mlym}', "");
    Expect(1, 43059, '\P{ Mlym}', "");
    Expect(0, 43059, '\P{^ Mlym}', "");
    Error('\p{:=--is_Mlym}');
    Error('\P{:=--is_Mlym}');
    Expect(1, 43058, '\p{ismlym}', "");
    Expect(0, 43058, '\p{^ismlym}', "");
    Expect(0, 43058, '\P{ismlym}', "");
    Expect(1, 43058, '\P{^ismlym}', "");
    Expect(0, 43059, '\p{ismlym}', "");
    Expect(1, 43059, '\p{^ismlym}', "");
    Expect(1, 43059, '\P{ismlym}', "");
    Expect(0, 43059, '\P{^ismlym}', "");
    Expect(1, 43058, '\p{-	Is_mlym}', "");
    Expect(0, 43058, '\p{^-	Is_mlym}', "");
    Expect(0, 43058, '\P{-	Is_mlym}', "");
    Expect(1, 43058, '\P{^-	Is_mlym}', "");
    Expect(0, 43059, '\p{-	Is_mlym}', "");
    Expect(1, 43059, '\p{^-	Is_mlym}', "");
    Expect(1, 43059, '\P{-	Is_mlym}', "");
    Expect(0, 43059, '\P{^-	Is_mlym}', "");
    Error('\p{	-Mandaic:=}');
    Error('\P{	-Mandaic:=}');
    Expect(1, 2142, '\p{mandaic}', "");
    Expect(0, 2142, '\p{^mandaic}', "");
    Expect(0, 2142, '\P{mandaic}', "");
    Expect(1, 2142, '\P{^mandaic}', "");
    Expect(0, 2143, '\p{mandaic}', "");
    Expect(1, 2143, '\p{^mandaic}', "");
    Expect(1, 2143, '\P{mandaic}', "");
    Expect(0, 2143, '\P{^mandaic}', "");
    Expect(1, 2142, '\p{--mandaic}', "");
    Expect(0, 2142, '\p{^--mandaic}', "");
    Expect(0, 2142, '\P{--mandaic}', "");
    Expect(1, 2142, '\P{^--mandaic}', "");
    Expect(0, 2143, '\p{--mandaic}', "");
    Expect(1, 2143, '\p{^--mandaic}', "");
    Expect(1, 2143, '\P{--mandaic}', "");
    Expect(0, 2143, '\P{^--mandaic}', "");
    Error('\p{-/a/IS_MANDAIC}');
    Error('\P{-/a/IS_MANDAIC}');
    Expect(1, 2142, '\p{ismandaic}', "");
    Expect(0, 2142, '\p{^ismandaic}', "");
    Expect(0, 2142, '\P{ismandaic}', "");
    Expect(1, 2142, '\P{^ismandaic}', "");
    Expect(0, 2143, '\p{ismandaic}', "");
    Expect(1, 2143, '\p{^ismandaic}', "");
    Expect(1, 2143, '\P{ismandaic}', "");
    Expect(0, 2143, '\P{^ismandaic}', "");
    Expect(1, 2142, '\p{-IS_Mandaic}', "");
    Expect(0, 2142, '\p{^-IS_Mandaic}', "");
    Expect(0, 2142, '\P{-IS_Mandaic}', "");
    Expect(1, 2142, '\P{^-IS_Mandaic}', "");
    Expect(0, 2143, '\p{-IS_Mandaic}', "");
    Expect(1, 2143, '\p{^-IS_Mandaic}', "");
    Expect(1, 2143, '\P{-IS_Mandaic}', "");
    Expect(0, 2143, '\P{^-IS_Mandaic}', "");
    Error('\p{ Mand:=}');
    Error('\P{ Mand:=}');
    Expect(1, 2142, '\p{mand}', "");
    Expect(0, 2142, '\p{^mand}', "");
    Expect(0, 2142, '\P{mand}', "");
    Expect(1, 2142, '\P{^mand}', "");
    Expect(0, 2143, '\p{mand}', "");
    Expect(1, 2143, '\p{^mand}', "");
    Expect(1, 2143, '\P{mand}', "");
    Expect(0, 2143, '\P{^mand}', "");
    Expect(1, 2142, '\p{ 	Mand}', "");
    Expect(0, 2142, '\p{^ 	Mand}', "");
    Expect(0, 2142, '\P{ 	Mand}', "");
    Expect(1, 2142, '\P{^ 	Mand}', "");
    Expect(0, 2143, '\p{ 	Mand}', "");
    Expect(1, 2143, '\p{^ 	Mand}', "");
    Expect(1, 2143, '\P{ 	Mand}', "");
    Expect(0, 2143, '\P{^ 	Mand}', "");
    Error('\p{:=-is_Mand}');
    Error('\P{:=-is_Mand}');
    Expect(1, 2142, '\p{ismand}', "");
    Expect(0, 2142, '\p{^ismand}', "");
    Expect(0, 2142, '\P{ismand}', "");
    Expect(1, 2142, '\P{^ismand}', "");
    Expect(0, 2143, '\p{ismand}', "");
    Expect(1, 2143, '\p{^ismand}', "");
    Expect(1, 2143, '\P{ismand}', "");
    Expect(0, 2143, '\P{^ismand}', "");
    Expect(1, 2142, '\p{-IS_Mand}', "");
    Expect(0, 2142, '\p{^-IS_Mand}', "");
    Expect(0, 2142, '\P{-IS_Mand}', "");
    Expect(1, 2142, '\P{^-IS_Mand}', "");
    Expect(0, 2143, '\p{-IS_Mand}', "");
    Expect(1, 2143, '\p{^-IS_Mand}', "");
    Expect(1, 2143, '\P{-IS_Mand}', "");
    Expect(0, 2143, '\P{^-IS_Mand}', "");
    Error('\p{/a/Manichaean}');
    Error('\P{/a/Manichaean}');
    Expect(1, 68342, '\p{manichaean}', "");
    Expect(0, 68342, '\p{^manichaean}', "");
    Expect(0, 68342, '\P{manichaean}', "");
    Expect(1, 68342, '\P{^manichaean}', "");
    Expect(0, 68343, '\p{manichaean}', "");
    Expect(1, 68343, '\p{^manichaean}', "");
    Expect(1, 68343, '\P{manichaean}', "");
    Expect(0, 68343, '\P{^manichaean}', "");
    Expect(1, 68342, '\p{_-Manichaean}', "");
    Expect(0, 68342, '\p{^_-Manichaean}', "");
    Expect(0, 68342, '\P{_-Manichaean}', "");
    Expect(1, 68342, '\P{^_-Manichaean}', "");
    Expect(0, 68343, '\p{_-Manichaean}', "");
    Expect(1, 68343, '\p{^_-Manichaean}', "");
    Expect(1, 68343, '\P{_-Manichaean}', "");
    Expect(0, 68343, '\P{^_-Manichaean}', "");
    Error('\p{:= 	Is_manichaean}');
    Error('\P{:= 	Is_manichaean}');
    Expect(1, 68342, '\p{ismanichaean}', "");
    Expect(0, 68342, '\p{^ismanichaean}', "");
    Expect(0, 68342, '\P{ismanichaean}', "");
    Expect(1, 68342, '\P{^ismanichaean}', "");
    Expect(0, 68343, '\p{ismanichaean}', "");
    Expect(1, 68343, '\p{^ismanichaean}', "");
    Expect(1, 68343, '\P{ismanichaean}', "");
    Expect(0, 68343, '\P{^ismanichaean}', "");
    Expect(1, 68342, '\p{_Is_Manichaean}', "");
    Expect(0, 68342, '\p{^_Is_Manichaean}', "");
    Expect(0, 68342, '\P{_Is_Manichaean}', "");
    Expect(1, 68342, '\P{^_Is_Manichaean}', "");
    Expect(0, 68343, '\p{_Is_Manichaean}', "");
    Expect(1, 68343, '\p{^_Is_Manichaean}', "");
    Expect(1, 68343, '\P{_Is_Manichaean}', "");
    Expect(0, 68343, '\P{^_Is_Manichaean}', "");
    Error('\p{-/a/Mani}');
    Error('\P{-/a/Mani}');
    Expect(1, 68342, '\p{mani}', "");
    Expect(0, 68342, '\p{^mani}', "");
    Expect(0, 68342, '\P{mani}', "");
    Expect(1, 68342, '\P{^mani}', "");
    Expect(0, 68343, '\p{mani}', "");
    Expect(1, 68343, '\p{^mani}', "");
    Expect(1, 68343, '\P{mani}', "");
    Expect(0, 68343, '\P{^mani}', "");
    Expect(1, 68342, '\p{_ mani}', "");
    Expect(0, 68342, '\p{^_ mani}', "");
    Expect(0, 68342, '\P{_ mani}', "");
    Expect(1, 68342, '\P{^_ mani}', "");
    Expect(0, 68343, '\p{_ mani}', "");
    Expect(1, 68343, '\p{^_ mani}', "");
    Expect(1, 68343, '\P{_ mani}', "");
    Expect(0, 68343, '\P{^_ mani}', "");
    Error('\p{/a/-	is_Mani}');
    Error('\P{/a/-	is_Mani}');
    Expect(1, 68342, '\p{ismani}', "");
    Expect(0, 68342, '\p{^ismani}', "");
    Expect(0, 68342, '\P{ismani}', "");
    Expect(1, 68342, '\P{^ismani}', "");
    Expect(0, 68343, '\p{ismani}', "");
    Expect(1, 68343, '\p{^ismani}', "");
    Expect(1, 68343, '\P{ismani}', "");
    Expect(0, 68343, '\P{^ismani}', "");
    Expect(1, 68342, '\p{ _is_MANI}', "");
    Expect(0, 68342, '\p{^ _is_MANI}', "");
    Expect(0, 68342, '\P{ _is_MANI}', "");
    Expect(1, 68342, '\P{^ _is_MANI}', "");
    Expect(0, 68343, '\p{ _is_MANI}', "");
    Expect(1, 68343, '\p{^ _is_MANI}', "");
    Expect(1, 68343, '\P{ _is_MANI}', "");
    Expect(0, 68343, '\P{^ _is_MANI}', "");
    Error('\p{/a/	-marchen}');
    Error('\P{/a/	-marchen}');
    Expect(1, 72886, '\p{marchen}', "");
    Expect(0, 72886, '\p{^marchen}', "");
    Expect(0, 72886, '\P{marchen}', "");
    Expect(1, 72886, '\P{^marchen}', "");
    Expect(0, 72887, '\p{marchen}', "");
    Expect(1, 72887, '\p{^marchen}', "");
    Expect(1, 72887, '\P{marchen}', "");
    Expect(0, 72887, '\P{^marchen}', "");
    Expect(1, 72886, '\p{- MARCHEN}', "");
    Expect(0, 72886, '\p{^- MARCHEN}', "");
    Expect(0, 72886, '\P{- MARCHEN}', "");
    Expect(1, 72886, '\P{^- MARCHEN}', "");
    Expect(0, 72887, '\p{- MARCHEN}', "");
    Expect(1, 72887, '\p{^- MARCHEN}', "");
    Expect(1, 72887, '\P{- MARCHEN}', "");
    Expect(0, 72887, '\P{^- MARCHEN}', "");
    Error('\p{:=-	IS_marchen}');
    Error('\P{:=-	IS_marchen}');
    Expect(1, 72886, '\p{ismarchen}', "");
    Expect(0, 72886, '\p{^ismarchen}', "");
    Expect(0, 72886, '\P{ismarchen}', "");
    Expect(1, 72886, '\P{^ismarchen}', "");
    Expect(0, 72887, '\p{ismarchen}', "");
    Expect(1, 72887, '\p{^ismarchen}', "");
    Expect(1, 72887, '\P{ismarchen}', "");
    Expect(0, 72887, '\P{^ismarchen}', "");
    Expect(1, 72886, '\p{ Is_Marchen}', "");
    Expect(0, 72886, '\p{^ Is_Marchen}', "");
    Expect(0, 72886, '\P{ Is_Marchen}', "");
    Expect(1, 72886, '\P{^ Is_Marchen}', "");
    Expect(0, 72887, '\p{ Is_Marchen}', "");
    Expect(1, 72887, '\p{^ Is_Marchen}', "");
    Expect(1, 72887, '\P{ Is_Marchen}', "");
    Expect(0, 72887, '\P{^ Is_Marchen}', "");
    Error('\p{/a/ -Marc}');
    Error('\P{/a/ -Marc}');
    Expect(1, 72886, '\p{marc}', "");
    Expect(0, 72886, '\p{^marc}', "");
    Expect(0, 72886, '\P{marc}', "");
    Expect(1, 72886, '\P{^marc}', "");
    Expect(0, 72887, '\p{marc}', "");
    Expect(1, 72887, '\p{^marc}', "");
    Expect(1, 72887, '\P{marc}', "");
    Expect(0, 72887, '\P{^marc}', "");
    Expect(1, 72886, '\p{__MARC}', "");
    Expect(0, 72886, '\p{^__MARC}', "");
    Expect(0, 72886, '\P{__MARC}', "");
    Expect(1, 72886, '\P{^__MARC}', "");
    Expect(0, 72887, '\p{__MARC}', "");
    Expect(1, 72887, '\p{^__MARC}', "");
    Expect(1, 72887, '\P{__MARC}', "");
    Expect(0, 72887, '\P{^__MARC}', "");
    Error('\p{ Is_Marc/a/}');
    Error('\P{ Is_Marc/a/}');
    Expect(1, 72886, '\p{ismarc}', "");
    Expect(0, 72886, '\p{^ismarc}', "");
    Expect(0, 72886, '\P{ismarc}', "");
    Expect(1, 72886, '\P{^ismarc}', "");
    Expect(0, 72887, '\p{ismarc}', "");
    Expect(1, 72887, '\p{^ismarc}', "");
    Expect(1, 72887, '\P{ismarc}', "");
    Expect(0, 72887, '\P{^ismarc}', "");
    Expect(1, 72886, '\p{-	Is_Marc}', "");
    Expect(0, 72886, '\p{^-	Is_Marc}', "");
    Expect(0, 72886, '\P{-	Is_Marc}', "");
    Expect(1, 72886, '\P{^-	Is_Marc}', "");
    Expect(0, 72887, '\p{-	Is_Marc}', "");
    Expect(1, 72887, '\p{^-	Is_Marc}', "");
    Expect(1, 72887, '\P{-	Is_Marc}', "");
    Expect(0, 72887, '\P{^-	Is_Marc}', "");
    Error('\p{	/a/mark}');
    Error('\P{	/a/mark}');
    Expect(1, 917999, '\p{mark}', "");
    Expect(0, 917999, '\p{^mark}', "");
    Expect(0, 917999, '\P{mark}', "");
    Expect(1, 917999, '\P{^mark}', "");
    Expect(0, 918000, '\p{mark}', "");
    Expect(1, 918000, '\p{^mark}', "");
    Expect(1, 918000, '\P{mark}', "");
    Expect(0, 918000, '\P{^mark}', "");
    Expect(1, 917999, '\p{_-mark}', "");
    Expect(0, 917999, '\p{^_-mark}', "");
    Expect(0, 917999, '\P{_-mark}', "");
    Expect(1, 917999, '\P{^_-mark}', "");
    Expect(0, 918000, '\p{_-mark}', "");
    Expect(1, 918000, '\p{^_-mark}', "");
    Expect(1, 918000, '\P{_-mark}', "");
    Expect(0, 918000, '\P{^_-mark}', "");
    Error('\p{ :=is_mark}');
    Error('\P{ :=is_mark}');
    Expect(1, 917999, '\p{ismark}', "");
    Expect(0, 917999, '\p{^ismark}', "");
    Expect(0, 917999, '\P{ismark}', "");
    Expect(1, 917999, '\P{^ismark}', "");
    Expect(0, 918000, '\p{ismark}', "");
    Expect(1, 918000, '\p{^ismark}', "");
    Expect(1, 918000, '\P{ismark}', "");
    Expect(0, 918000, '\P{^ismark}', "");
    Expect(1, 917999, '\p{__Is_Mark}', "");
    Expect(0, 917999, '\p{^__Is_Mark}', "");
    Expect(0, 917999, '\P{__Is_Mark}', "");
    Expect(1, 917999, '\P{^__Is_Mark}', "");
    Expect(0, 918000, '\p{__Is_Mark}', "");
    Expect(1, 918000, '\p{^__Is_Mark}', "");
    Expect(1, 918000, '\P{__Is_Mark}', "");
    Expect(0, 918000, '\P{^__Is_Mark}', "");
    Error('\p{m:=}');
    Error('\P{m:=}');
    Expect(1, 917999, '\p{m}', "");
    Expect(0, 917999, '\p{^m}', "");
    Expect(0, 917999, '\P{m}', "");
    Expect(1, 917999, '\P{^m}', "");
    Expect(0, 918000, '\p{m}', "");
    Expect(1, 918000, '\p{^m}', "");
    Expect(1, 918000, '\P{m}', "");
    Expect(0, 918000, '\P{^m}', "");
    Expect(1, 917999, '\p{	_M}', "");
    Expect(0, 917999, '\p{^	_M}', "");
    Expect(0, 917999, '\P{	_M}', "");
    Expect(1, 917999, '\P{^	_M}', "");
    Expect(0, 918000, '\p{	_M}', "");
    Expect(1, 918000, '\p{^	_M}', "");
    Expect(1, 918000, '\P{	_M}', "");
    Expect(0, 918000, '\P{^	_M}', "");
    Error('\p{-/a/Is_M}');
    Error('\P{-/a/Is_M}');
    Expect(1, 917999, '\p{ism}', "");
    Expect(0, 917999, '\p{^ism}', "");
    Expect(0, 917999, '\P{ism}', "");
    Expect(1, 917999, '\P{^ism}', "");
    Expect(0, 918000, '\p{ism}', "");
    Expect(1, 918000, '\p{^ism}', "");
    Expect(1, 918000, '\P{ism}', "");
    Expect(0, 918000, '\P{^ism}', "");
    Expect(1, 917999, '\p{ Is_M}', "");
    Expect(0, 917999, '\p{^ Is_M}', "");
    Expect(0, 917999, '\P{ Is_M}', "");
    Expect(1, 917999, '\P{^ Is_M}', "");
    Expect(0, 918000, '\p{ Is_M}', "");
    Expect(1, 918000, '\p{^ Is_M}', "");
    Expect(1, 918000, '\P{ Is_M}', "");
    Expect(0, 918000, '\P{^ Is_M}', "");
    Error('\p{	:=Combining_Mark}');
    Error('\P{	:=Combining_Mark}');
    Expect(1, 917999, '\p{combiningmark}', "");
    Expect(0, 917999, '\p{^combiningmark}', "");
    Expect(0, 917999, '\P{combiningmark}', "");
    Expect(1, 917999, '\P{^combiningmark}', "");
    Expect(0, 918000, '\p{combiningmark}', "");
    Expect(1, 918000, '\p{^combiningmark}', "");
    Expect(1, 918000, '\P{combiningmark}', "");
    Expect(0, 918000, '\P{^combiningmark}', "");
    Expect(1, 917999, '\p{	-Combining_MARK}', "");
    Expect(0, 917999, '\p{^	-Combining_MARK}', "");
    Expect(0, 917999, '\P{	-Combining_MARK}', "");
    Expect(1, 917999, '\P{^	-Combining_MARK}', "");
    Expect(0, 918000, '\p{	-Combining_MARK}', "");
    Expect(1, 918000, '\p{^	-Combining_MARK}', "");
    Expect(1, 918000, '\P{	-Combining_MARK}', "");
    Expect(0, 918000, '\P{^	-Combining_MARK}', "");
    Error('\p{__Is_Combining_Mark/a/}');
    Error('\P{__Is_Combining_Mark/a/}');
    Expect(1, 917999, '\p{iscombiningmark}', "");
    Expect(0, 917999, '\p{^iscombiningmark}', "");
    Expect(0, 917999, '\P{iscombiningmark}', "");
    Expect(1, 917999, '\P{^iscombiningmark}', "");
    Expect(0, 918000, '\p{iscombiningmark}', "");
    Expect(1, 918000, '\p{^iscombiningmark}', "");
    Expect(1, 918000, '\P{iscombiningmark}', "");
    Expect(0, 918000, '\P{^iscombiningmark}', "");
    Expect(1, 917999, '\p{	Is_combining_Mark}', "");
    Expect(0, 917999, '\p{^	Is_combining_Mark}', "");
    Expect(0, 917999, '\P{	Is_combining_Mark}', "");
    Expect(1, 917999, '\P{^	Is_combining_Mark}', "");
    Expect(0, 918000, '\p{	Is_combining_Mark}', "");
    Expect(1, 918000, '\p{^	Is_combining_Mark}', "");
    Expect(1, 918000, '\P{	Is_combining_Mark}', "");
    Expect(0, 918000, '\P{^	Is_combining_Mark}', "");
    Error('\p{	MASARAM_gondi:=}');
    Error('\P{	MASARAM_gondi:=}');
    Expect(1, 73049, '\p{masaramgondi}', "");
    Expect(0, 73049, '\p{^masaramgondi}', "");
    Expect(0, 73049, '\P{masaramgondi}', "");
    Expect(1, 73049, '\P{^masaramgondi}', "");
    Expect(0, 73050, '\p{masaramgondi}', "");
    Expect(1, 73050, '\p{^masaramgondi}', "");
    Expect(1, 73050, '\P{masaramgondi}', "");
    Expect(0, 73050, '\P{^masaramgondi}', "");
    Expect(1, 73049, '\p{ Masaram_gondi}', "");
    Expect(0, 73049, '\p{^ Masaram_gondi}', "");
    Expect(0, 73049, '\P{ Masaram_gondi}', "");
    Expect(1, 73049, '\P{^ Masaram_gondi}', "");
    Expect(0, 73050, '\p{ Masaram_gondi}', "");
    Expect(1, 73050, '\p{^ Masaram_gondi}', "");
    Expect(1, 73050, '\P{ Masaram_gondi}', "");
    Expect(0, 73050, '\P{^ Masaram_gondi}', "");
    Error('\p{/a/- Is_Masaram_Gondi}');
    Error('\P{/a/- Is_Masaram_Gondi}');
    Expect(1, 73049, '\p{ismasaramgondi}', "");
    Expect(0, 73049, '\p{^ismasaramgondi}', "");
    Expect(0, 73049, '\P{ismasaramgondi}', "");
    Expect(1, 73049, '\P{^ismasaramgondi}', "");
    Expect(0, 73050, '\p{ismasaramgondi}', "");
    Expect(1, 73050, '\p{^ismasaramgondi}', "");
    Expect(1, 73050, '\P{ismasaramgondi}', "");
    Expect(0, 73050, '\P{^ismasaramgondi}', "");
    Expect(1, 73049, '\p{_	IS_Masaram_GONDI}', "");
    Expect(0, 73049, '\p{^_	IS_Masaram_GONDI}', "");
    Expect(0, 73049, '\P{_	IS_Masaram_GONDI}', "");
    Expect(1, 73049, '\P{^_	IS_Masaram_GONDI}', "");
    Expect(0, 73050, '\p{_	IS_Masaram_GONDI}', "");
    Expect(1, 73050, '\p{^_	IS_Masaram_GONDI}', "");
    Expect(1, 73050, '\P{_	IS_Masaram_GONDI}', "");
    Expect(0, 73050, '\P{^_	IS_Masaram_GONDI}', "");
    Error('\p{	 gonm/a/}');
    Error('\P{	 gonm/a/}');
    Expect(1, 73049, '\p{gonm}', "");
    Expect(0, 73049, '\p{^gonm}', "");
    Expect(0, 73049, '\P{gonm}', "");
    Expect(1, 73049, '\P{^gonm}', "");
    Expect(0, 73050, '\p{gonm}', "");
    Expect(1, 73050, '\p{^gonm}', "");
    Expect(1, 73050, '\P{gonm}', "");
    Expect(0, 73050, '\P{^gonm}', "");
    Expect(1, 73049, '\p{ -Gonm}', "");
    Expect(0, 73049, '\p{^ -Gonm}', "");
    Expect(0, 73049, '\P{ -Gonm}', "");
    Expect(1, 73049, '\P{^ -Gonm}', "");
    Expect(0, 73050, '\p{ -Gonm}', "");
    Expect(1, 73050, '\p{^ -Gonm}', "");
    Expect(1, 73050, '\P{ -Gonm}', "");
    Expect(0, 73050, '\P{^ -Gonm}', "");
    Error('\p{/a/_-Is_Gonm}');
    Error('\P{/a/_-Is_Gonm}');
    Expect(1, 73049, '\p{isgonm}', "");
    Expect(0, 73049, '\p{^isgonm}', "");
    Expect(0, 73049, '\P{isgonm}', "");
    Expect(1, 73049, '\P{^isgonm}', "");
    Expect(0, 73050, '\p{isgonm}', "");
    Expect(1, 73050, '\p{^isgonm}', "");
    Expect(1, 73050, '\P{isgonm}', "");
    Expect(0, 73050, '\P{^isgonm}', "");
    Expect(1, 73049, '\p{  Is_Gonm}', "");
    Expect(0, 73049, '\p{^  Is_Gonm}', "");
    Expect(0, 73049, '\P{  Is_Gonm}', "");
    Expect(1, 73049, '\P{^  Is_Gonm}', "");
    Expect(0, 73050, '\p{  Is_Gonm}', "");
    Expect(1, 73050, '\p{^  Is_Gonm}', "");
    Expect(1, 73050, '\P{  Is_Gonm}', "");
    Expect(0, 73050, '\P{^  Is_Gonm}', "");
    Error('\p{-:=MATH}');
    Error('\P{-:=MATH}');
    Expect(1, 126705, '\p{math}', "");
    Expect(0, 126705, '\p{^math}', "");
    Expect(0, 126705, '\P{math}', "");
    Expect(1, 126705, '\P{^math}', "");
    Expect(0, 126706, '\p{math}', "");
    Expect(1, 126706, '\p{^math}', "");
    Expect(1, 126706, '\P{math}', "");
    Expect(0, 126706, '\P{^math}', "");
    Expect(1, 126705, '\p{-	Math}', "");
    Expect(0, 126705, '\p{^-	Math}', "");
    Expect(0, 126705, '\P{-	Math}', "");
    Expect(1, 126705, '\P{^-	Math}', "");
    Expect(0, 126706, '\p{-	Math}', "");
    Expect(1, 126706, '\p{^-	Math}', "");
    Expect(1, 126706, '\P{-	Math}', "");
    Expect(0, 126706, '\P{^-	Math}', "");
    Error('\p{:=IS_Math}');
    Error('\P{:=IS_Math}');
    Expect(1, 126705, '\p{ismath}', "");
    Expect(0, 126705, '\p{^ismath}', "");
    Expect(0, 126705, '\P{ismath}', "");
    Expect(1, 126705, '\P{^ismath}', "");
    Expect(0, 126706, '\p{ismath}', "");
    Expect(1, 126706, '\p{^ismath}', "");
    Expect(1, 126706, '\P{ismath}', "");
    Expect(0, 126706, '\P{^ismath}', "");
    Expect(1, 126705, '\p{	_is_Math}', "");
    Expect(0, 126705, '\p{^	_is_Math}', "");
    Expect(0, 126705, '\P{	_is_Math}', "");
    Expect(1, 126705, '\P{^	_is_Math}', "");
    Expect(0, 126706, '\p{	_is_Math}', "");
    Expect(1, 126706, '\p{^	_is_Math}', "");
    Expect(1, 126706, '\P{	_is_Math}', "");
    Expect(0, 126706, '\P{^	_is_Math}', "");
    Error('\p{/a/-_MATH_symbol}');
    Error('\P{/a/-_MATH_symbol}');
    Expect(1, 126705, '\p{mathsymbol}', "");
    Expect(0, 126705, '\p{^mathsymbol}', "");
    Expect(0, 126705, '\P{mathsymbol}', "");
    Expect(1, 126705, '\P{^mathsymbol}', "");
    Expect(0, 126706, '\p{mathsymbol}', "");
    Expect(1, 126706, '\p{^mathsymbol}', "");
    Expect(1, 126706, '\P{mathsymbol}', "");
    Expect(0, 126706, '\P{^mathsymbol}', "");
    Expect(1, 126705, '\p{	 MATH_SYMBOL}', "");
    Expect(0, 126705, '\p{^	 MATH_SYMBOL}', "");
    Expect(0, 126705, '\P{	 MATH_SYMBOL}', "");
    Expect(1, 126705, '\P{^	 MATH_SYMBOL}', "");
    Expect(0, 126706, '\p{	 MATH_SYMBOL}', "");
    Expect(1, 126706, '\p{^	 MATH_SYMBOL}', "");
    Expect(1, 126706, '\P{	 MATH_SYMBOL}', "");
    Expect(0, 126706, '\P{^	 MATH_SYMBOL}', "");
    Error('\p{ /a/Is_math_Symbol}');
    Error('\P{ /a/Is_math_Symbol}');
    Expect(1, 126705, '\p{ismathsymbol}', "");
    Expect(0, 126705, '\p{^ismathsymbol}', "");
    Expect(0, 126705, '\P{ismathsymbol}', "");
    Expect(1, 126705, '\P{^ismathsymbol}', "");
    Expect(0, 126706, '\p{ismathsymbol}', "");
    Expect(1, 126706, '\p{^ismathsymbol}', "");
    Expect(1, 126706, '\P{ismathsymbol}', "");
    Expect(0, 126706, '\P{^ismathsymbol}', "");
    Expect(1, 126705, '\p{_-Is_math_Symbol}', "");
    Expect(0, 126705, '\p{^_-Is_math_Symbol}', "");
    Expect(0, 126705, '\P{_-Is_math_Symbol}', "");
    Expect(1, 126705, '\P{^_-Is_math_Symbol}', "");
    Expect(0, 126706, '\p{_-Is_math_Symbol}', "");
    Expect(1, 126706, '\p{^_-Is_math_Symbol}', "");
    Expect(1, 126706, '\P{_-Is_math_Symbol}', "");
    Expect(0, 126706, '\P{^_-Is_math_Symbol}', "");
    Error('\p{	_Sm:=}');
    Error('\P{	_Sm:=}');
    Expect(1, 126705, '\p{sm}', "");
    Expect(0, 126705, '\p{^sm}', "");
    Expect(0, 126705, '\P{sm}', "");
    Expect(1, 126705, '\P{^sm}', "");
    Expect(0, 126706, '\p{sm}', "");
    Expect(1, 126706, '\p{^sm}', "");
    Expect(1, 126706, '\P{sm}', "");
    Expect(0, 126706, '\P{^sm}', "");
    Expect(1, 126705, '\p{ -Sm}', "");
    Expect(0, 126705, '\p{^ -Sm}', "");
    Expect(0, 126705, '\P{ -Sm}', "");
    Expect(1, 126705, '\P{^ -Sm}', "");
    Expect(0, 126706, '\p{ -Sm}', "");
    Expect(1, 126706, '\p{^ -Sm}', "");
    Expect(1, 126706, '\P{ -Sm}', "");
    Expect(0, 126706, '\P{^ -Sm}', "");
    Error('\p{ -Is_SM/a/}');
    Error('\P{ -Is_SM/a/}');
    Expect(1, 126705, '\p{issm}', "");
    Expect(0, 126705, '\p{^issm}', "");
    Expect(0, 126705, '\P{issm}', "");
    Expect(1, 126705, '\P{^issm}', "");
    Expect(0, 126706, '\p{issm}', "");
    Expect(1, 126706, '\p{^issm}', "");
    Expect(1, 126706, '\P{issm}', "");
    Expect(0, 126706, '\P{^issm}', "");
    Expect(1, 126705, '\p{	-Is_SM}', "");
    Expect(0, 126705, '\p{^	-Is_SM}', "");
    Expect(0, 126705, '\P{	-Is_SM}', "");
    Expect(1, 126705, '\P{^	-Is_SM}', "");
    Expect(0, 126706, '\p{	-Is_SM}', "");
    Expect(1, 126706, '\p{^	-Is_SM}', "");
    Expect(1, 126706, '\P{	-Is_SM}', "");
    Expect(0, 126706, '\P{^	-Is_SM}', "");
    Error('\p{ /a/Mathematical_Alphanumeric_symbols}');
    Error('\P{ /a/Mathematical_Alphanumeric_symbols}');
    Expect(1, 120831, '\p{mathematicalalphanumericsymbols}', "");
    Expect(0, 120831, '\p{^mathematicalalphanumericsymbols}', "");
    Expect(0, 120831, '\P{mathematicalalphanumericsymbols}', "");
    Expect(1, 120831, '\P{^mathematicalalphanumericsymbols}', "");
    Expect(0, 120832, '\p{mathematicalalphanumericsymbols}', "");
    Expect(1, 120832, '\p{^mathematicalalphanumericsymbols}', "");
    Expect(1, 120832, '\P{mathematicalalphanumericsymbols}', "");
    Expect(0, 120832, '\P{^mathematicalalphanumericsymbols}', "");
    Expect(1, 120831, '\p{	MATHEMATICAL_Alphanumeric_symbols}', "");
    Expect(0, 120831, '\p{^	MATHEMATICAL_Alphanumeric_symbols}', "");
    Expect(0, 120831, '\P{	MATHEMATICAL_Alphanumeric_symbols}', "");
    Expect(1, 120831, '\P{^	MATHEMATICAL_Alphanumeric_symbols}', "");
    Expect(0, 120832, '\p{	MATHEMATICAL_Alphanumeric_symbols}', "");
    Expect(1, 120832, '\p{^	MATHEMATICAL_Alphanumeric_symbols}', "");
    Expect(1, 120832, '\P{	MATHEMATICAL_Alphanumeric_symbols}', "");
    Expect(0, 120832, '\P{^	MATHEMATICAL_Alphanumeric_symbols}', "");
    Error('\p{:=-_IS_mathematical_alphanumeric_Symbols}');
    Error('\P{:=-_IS_mathematical_alphanumeric_Symbols}');
    Expect(1, 120831, '\p{ismathematicalalphanumericsymbols}', "");
    Expect(0, 120831, '\p{^ismathematicalalphanumericsymbols}', "");
    Expect(0, 120831, '\P{ismathematicalalphanumericsymbols}', "");
    Expect(1, 120831, '\P{^ismathematicalalphanumericsymbols}', "");
    Expect(0, 120832, '\p{ismathematicalalphanumericsymbols}', "");
    Expect(1, 120832, '\p{^ismathematicalalphanumericsymbols}', "");
    Expect(1, 120832, '\P{ismathematicalalphanumericsymbols}', "");
    Expect(0, 120832, '\P{^ismathematicalalphanumericsymbols}', "");
    Expect(1, 120831, '\p{_	IS_MATHEMATICAL_Alphanumeric_Symbols}', "");
    Expect(0, 120831, '\p{^_	IS_MATHEMATICAL_Alphanumeric_Symbols}', "");
    Expect(0, 120831, '\P{_	IS_MATHEMATICAL_Alphanumeric_Symbols}', "");
    Expect(1, 120831, '\P{^_	IS_MATHEMATICAL_Alphanumeric_Symbols}', "");
    Expect(0, 120832, '\p{_	IS_MATHEMATICAL_Alphanumeric_Symbols}', "");
    Expect(1, 120832, '\p{^_	IS_MATHEMATICAL_Alphanumeric_Symbols}', "");
    Expect(1, 120832, '\P{_	IS_MATHEMATICAL_Alphanumeric_Symbols}', "");
    Expect(0, 120832, '\P{^_	IS_MATHEMATICAL_Alphanumeric_Symbols}', "");
    Error('\p{/a/ _in_mathematical_Alphanumeric_Symbols}');
    Error('\P{/a/ _in_mathematical_Alphanumeric_Symbols}');
    Expect(1, 120831, '\p{inmathematicalalphanumericsymbols}', "");
    Expect(0, 120831, '\p{^inmathematicalalphanumericsymbols}', "");
    Expect(0, 120831, '\P{inmathematicalalphanumericsymbols}', "");
    Expect(1, 120831, '\P{^inmathematicalalphanumericsymbols}', "");
    Expect(0, 120832, '\p{inmathematicalalphanumericsymbols}', "");
    Expect(1, 120832, '\p{^inmathematicalalphanumericsymbols}', "");
    Expect(1, 120832, '\P{inmathematicalalphanumericsymbols}', "");
    Expect(0, 120832, '\P{^inmathematicalalphanumericsymbols}', "");
    Expect(1, 120831, '\p{ 	In_mathematical_Alphanumeric_SYMBOLS}', "");
    Expect(0, 120831, '\p{^ 	In_mathematical_Alphanumeric_SYMBOLS}', "");
    Expect(0, 120831, '\P{ 	In_mathematical_Alphanumeric_SYMBOLS}', "");
    Expect(1, 120831, '\P{^ 	In_mathematical_Alphanumeric_SYMBOLS}', "");
    Expect(0, 120832, '\p{ 	In_mathematical_Alphanumeric_SYMBOLS}', "");
    Expect(1, 120832, '\p{^ 	In_mathematical_Alphanumeric_SYMBOLS}', "");
    Expect(1, 120832, '\P{ 	In_mathematical_Alphanumeric_SYMBOLS}', "");
    Expect(0, 120832, '\P{^ 	In_mathematical_Alphanumeric_SYMBOLS}', "");
    Error('\p{:=--Math_alphanum}');
    Error('\P{:=--Math_alphanum}');
    Expect(1, 120831, '\p{mathalphanum}', "");
    Expect(0, 120831, '\p{^mathalphanum}', "");
    Expect(0, 120831, '\P{mathalphanum}', "");
    Expect(1, 120831, '\P{^mathalphanum}', "");
    Expect(0, 120832, '\p{mathalphanum}', "");
    Expect(1, 120832, '\p{^mathalphanum}', "");
    Expect(1, 120832, '\P{mathalphanum}', "");
    Expect(0, 120832, '\P{^mathalphanum}', "");
    Expect(1, 120831, '\p{	math_alphanum}', "");
    Expect(0, 120831, '\p{^	math_alphanum}', "");
    Expect(0, 120831, '\P{	math_alphanum}', "");
    Expect(1, 120831, '\P{^	math_alphanum}', "");
    Expect(0, 120832, '\p{	math_alphanum}', "");
    Expect(1, 120832, '\p{^	math_alphanum}', "");
    Expect(1, 120832, '\P{	math_alphanum}', "");
    Expect(0, 120832, '\P{^	math_alphanum}', "");
    Error('\p{ Is_math_Alphanum/a/}');
    Error('\P{ Is_math_Alphanum/a/}');
    Expect(1, 120831, '\p{ismathalphanum}', "");
    Expect(0, 120831, '\p{^ismathalphanum}', "");
    Expect(0, 120831, '\P{ismathalphanum}', "");
    Expect(1, 120831, '\P{^ismathalphanum}', "");
    Expect(0, 120832, '\p{ismathalphanum}', "");
    Expect(1, 120832, '\p{^ismathalphanum}', "");
    Expect(1, 120832, '\P{ismathalphanum}', "");
    Expect(0, 120832, '\P{^ismathalphanum}', "");
    Expect(1, 120831, '\p{  Is_Math_alphanum}', "");
    Expect(0, 120831, '\p{^  Is_Math_alphanum}', "");
    Expect(0, 120831, '\P{  Is_Math_alphanum}', "");
    Expect(1, 120831, '\P{^  Is_Math_alphanum}', "");
    Expect(0, 120832, '\p{  Is_Math_alphanum}', "");
    Expect(1, 120832, '\p{^  Is_Math_alphanum}', "");
    Expect(1, 120832, '\P{  Is_Math_alphanum}', "");
    Expect(0, 120832, '\P{^  Is_Math_alphanum}', "");
    Error('\p{_	IN_Math_Alphanum:=}');
    Error('\P{_	IN_Math_Alphanum:=}');
    Expect(1, 120831, '\p{inmathalphanum}', "");
    Expect(0, 120831, '\p{^inmathalphanum}', "");
    Expect(0, 120831, '\P{inmathalphanum}', "");
    Expect(1, 120831, '\P{^inmathalphanum}', "");
    Expect(0, 120832, '\p{inmathalphanum}', "");
    Expect(1, 120832, '\p{^inmathalphanum}', "");
    Expect(1, 120832, '\P{inmathalphanum}', "");
    Expect(0, 120832, '\P{^inmathalphanum}', "");
    Expect(1, 120831, '\p{ -IN_Math_Alphanum}', "");
    Expect(0, 120831, '\p{^ -IN_Math_Alphanum}', "");
    Expect(0, 120831, '\P{ -IN_Math_Alphanum}', "");
    Expect(1, 120831, '\P{^ -IN_Math_Alphanum}', "");
    Expect(0, 120832, '\p{ -IN_Math_Alphanum}', "");
    Expect(1, 120832, '\p{^ -IN_Math_Alphanum}', "");
    Expect(1, 120832, '\P{ -IN_Math_Alphanum}', "");
    Expect(0, 120832, '\P{^ -IN_Math_Alphanum}', "");
    Error('\p{/a/-	Mathematical_Operators}');
    Error('\P{/a/-	Mathematical_Operators}');
    Expect(1, 8959, '\p{mathematicaloperators}', "");
    Expect(0, 8959, '\p{^mathematicaloperators}', "");
    Expect(0, 8959, '\P{mathematicaloperators}', "");
    Expect(1, 8959, '\P{^mathematicaloperators}', "");
    Expect(0, 8960, '\p{mathematicaloperators}', "");
    Expect(1, 8960, '\p{^mathematicaloperators}', "");
    Expect(1, 8960, '\P{mathematicaloperators}', "");
    Expect(0, 8960, '\P{^mathematicaloperators}', "");
    Expect(1, 8959, '\p{__mathematical_Operators}', "");
    Expect(0, 8959, '\p{^__mathematical_Operators}', "");
    Expect(0, 8959, '\P{__mathematical_Operators}', "");
    Expect(1, 8959, '\P{^__mathematical_Operators}', "");
    Expect(0, 8960, '\p{__mathematical_Operators}', "");
    Expect(1, 8960, '\p{^__mathematical_Operators}', "");
    Expect(1, 8960, '\P{__mathematical_Operators}', "");
    Expect(0, 8960, '\P{^__mathematical_Operators}', "");
    Error('\p{  is_Mathematical_operators:=}');
    Error('\P{  is_Mathematical_operators:=}');
    Expect(1, 8959, '\p{ismathematicaloperators}', "");
    Expect(0, 8959, '\p{^ismathematicaloperators}', "");
    Expect(0, 8959, '\P{ismathematicaloperators}', "");
    Expect(1, 8959, '\P{^ismathematicaloperators}', "");
    Expect(0, 8960, '\p{ismathematicaloperators}', "");
    Expect(1, 8960, '\p{^ismathematicaloperators}', "");
    Expect(1, 8960, '\P{ismathematicaloperators}', "");
    Expect(0, 8960, '\P{^ismathematicaloperators}', "");
    Expect(1, 8959, '\p{_Is_MATHEMATICAL_OPERATORS}', "");
    Expect(0, 8959, '\p{^_Is_MATHEMATICAL_OPERATORS}', "");
    Expect(0, 8959, '\P{_Is_MATHEMATICAL_OPERATORS}', "");
    Expect(1, 8959, '\P{^_Is_MATHEMATICAL_OPERATORS}', "");
    Expect(0, 8960, '\p{_Is_MATHEMATICAL_OPERATORS}', "");
    Expect(1, 8960, '\p{^_Is_MATHEMATICAL_OPERATORS}', "");
    Expect(1, 8960, '\P{_Is_MATHEMATICAL_OPERATORS}', "");
    Expect(0, 8960, '\P{^_Is_MATHEMATICAL_OPERATORS}', "");
    Error('\p{:= In_Mathematical_OPERATORS}');
    Error('\P{:= In_Mathematical_OPERATORS}');
    Expect(1, 8959, '\p{inmathematicaloperators}', "");
    Expect(0, 8959, '\p{^inmathematicaloperators}', "");
    Expect(0, 8959, '\P{inmathematicaloperators}', "");
    Expect(1, 8959, '\P{^inmathematicaloperators}', "");
    Expect(0, 8960, '\p{inmathematicaloperators}', "");
    Expect(1, 8960, '\p{^inmathematicaloperators}', "");
    Expect(1, 8960, '\P{inmathematicaloperators}', "");
    Expect(0, 8960, '\P{^inmathematicaloperators}', "");
    Expect(1, 8959, '\p{-	In_mathematical_Operators}', "");
    Expect(0, 8959, '\p{^-	In_mathematical_Operators}', "");
    Expect(0, 8959, '\P{-	In_mathematical_Operators}', "");
    Expect(1, 8959, '\P{^-	In_mathematical_Operators}', "");
    Expect(0, 8960, '\p{-	In_mathematical_Operators}', "");
    Expect(1, 8960, '\p{^-	In_mathematical_Operators}', "");
    Expect(1, 8960, '\P{-	In_mathematical_Operators}', "");
    Expect(0, 8960, '\P{^-	In_mathematical_Operators}', "");
    Error('\p{ /a/Math_operators}');
    Error('\P{ /a/Math_operators}');
    Expect(1, 8959, '\p{mathoperators}', "");
    Expect(0, 8959, '\p{^mathoperators}', "");
    Expect(0, 8959, '\P{mathoperators}', "");
    Expect(1, 8959, '\P{^mathoperators}', "");
    Expect(0, 8960, '\p{mathoperators}', "");
    Expect(1, 8960, '\p{^mathoperators}', "");
    Expect(1, 8960, '\P{mathoperators}', "");
    Expect(0, 8960, '\P{^mathoperators}', "");
    Expect(1, 8959, '\p{	_Math_operators}', "");
    Expect(0, 8959, '\p{^	_Math_operators}', "");
    Expect(0, 8959, '\P{	_Math_operators}', "");
    Expect(1, 8959, '\P{^	_Math_operators}', "");
    Expect(0, 8960, '\p{	_Math_operators}', "");
    Expect(1, 8960, '\p{^	_Math_operators}', "");
    Expect(1, 8960, '\P{	_Math_operators}', "");
    Expect(0, 8960, '\P{^	_Math_operators}', "");
    Error('\p{/a/ _Is_Math_Operators}');
    Error('\P{/a/ _Is_Math_Operators}');
    Expect(1, 8959, '\p{ismathoperators}', "");
    Expect(0, 8959, '\p{^ismathoperators}', "");
    Expect(0, 8959, '\P{ismathoperators}', "");
    Expect(1, 8959, '\P{^ismathoperators}', "");
    Expect(0, 8960, '\p{ismathoperators}', "");
    Expect(1, 8960, '\p{^ismathoperators}', "");
    Expect(1, 8960, '\P{ismathoperators}', "");
    Expect(0, 8960, '\P{^ismathoperators}', "");
    Expect(1, 8959, '\p{ _Is_math_operators}', "");
    Expect(0, 8959, '\p{^ _Is_math_operators}', "");
    Expect(0, 8959, '\P{ _Is_math_operators}', "");
    Expect(1, 8959, '\P{^ _Is_math_operators}', "");
    Expect(0, 8960, '\p{ _Is_math_operators}', "");
    Expect(1, 8960, '\p{^ _Is_math_operators}', "");
    Expect(1, 8960, '\P{ _Is_math_operators}', "");
    Expect(0, 8960, '\P{^ _Is_math_operators}', "");
    Error('\p{:= _In_Math_OPERATORS}');
    Error('\P{:= _In_Math_OPERATORS}');
    Expect(1, 8959, '\p{inmathoperators}', "");
    Expect(0, 8959, '\p{^inmathoperators}', "");
    Expect(0, 8959, '\P{inmathoperators}', "");
    Expect(1, 8959, '\P{^inmathoperators}', "");
    Expect(0, 8960, '\p{inmathoperators}', "");
    Expect(1, 8960, '\p{^inmathoperators}', "");
    Expect(1, 8960, '\P{inmathoperators}', "");
    Expect(0, 8960, '\P{^inmathoperators}', "");
    Expect(1, 8959, '\p{ _In_Math_Operators}', "");
    Expect(0, 8959, '\p{^ _In_Math_Operators}', "");
    Expect(0, 8959, '\P{ _In_Math_Operators}', "");
    Expect(1, 8959, '\P{^ _In_Math_Operators}', "");
    Expect(0, 8960, '\p{ _In_Math_Operators}', "");
    Expect(1, 8960, '\p{^ _In_Math_Operators}', "");
    Expect(1, 8960, '\P{ _In_Math_Operators}', "");
    Expect(0, 8960, '\P{^ _In_Math_Operators}', "");
    Error('\p{-:=MAYAN_numerals}');
    Error('\P{-:=MAYAN_numerals}');
    Expect(1, 119551, '\p{mayannumerals}', "");
    Expect(0, 119551, '\p{^mayannumerals}', "");
    Expect(0, 119551, '\P{mayannumerals}', "");
    Expect(1, 119551, '\P{^mayannumerals}', "");
    Expect(0, 119552, '\p{mayannumerals}', "");
    Expect(1, 119552, '\p{^mayannumerals}', "");
    Expect(1, 119552, '\P{mayannumerals}', "");
    Expect(0, 119552, '\P{^mayannumerals}', "");
    Expect(1, 119551, '\p{_mayan_NUMERALS}', "");
    Expect(0, 119551, '\p{^_mayan_NUMERALS}', "");
    Expect(0, 119551, '\P{_mayan_NUMERALS}', "");
    Expect(1, 119551, '\P{^_mayan_NUMERALS}', "");
    Expect(0, 119552, '\p{_mayan_NUMERALS}', "");
    Expect(1, 119552, '\p{^_mayan_NUMERALS}', "");
    Expect(1, 119552, '\P{_mayan_NUMERALS}', "");
    Expect(0, 119552, '\P{^_mayan_NUMERALS}', "");
    Error('\p{/a/_Is_Mayan_numerals}');
    Error('\P{/a/_Is_Mayan_numerals}');
    Expect(1, 119551, '\p{ismayannumerals}', "");
    Expect(0, 119551, '\p{^ismayannumerals}', "");
    Expect(0, 119551, '\P{ismayannumerals}', "");
    Expect(1, 119551, '\P{^ismayannumerals}', "");
    Expect(0, 119552, '\p{ismayannumerals}', "");
    Expect(1, 119552, '\p{^ismayannumerals}', "");
    Expect(1, 119552, '\P{ismayannumerals}', "");
    Expect(0, 119552, '\P{^ismayannumerals}', "");
    Expect(1, 119551, '\p{--Is_Mayan_numerals}', "");
    Expect(0, 119551, '\p{^--Is_Mayan_numerals}', "");
    Expect(0, 119551, '\P{--Is_Mayan_numerals}', "");
    Expect(1, 119551, '\P{^--Is_Mayan_numerals}', "");
    Expect(0, 119552, '\p{--Is_Mayan_numerals}', "");
    Expect(1, 119552, '\p{^--Is_Mayan_numerals}', "");
    Expect(1, 119552, '\P{--Is_Mayan_numerals}', "");
    Expect(0, 119552, '\P{^--Is_Mayan_numerals}', "");
    Error('\p{/a/IN_Mayan_Numerals}');
    Error('\P{/a/IN_Mayan_Numerals}');
    Expect(1, 119551, '\p{inmayannumerals}', "");
    Expect(0, 119551, '\p{^inmayannumerals}', "");
    Expect(0, 119551, '\P{inmayannumerals}', "");
    Expect(1, 119551, '\P{^inmayannumerals}', "");
    Expect(0, 119552, '\p{inmayannumerals}', "");
    Expect(1, 119552, '\p{^inmayannumerals}', "");
    Expect(1, 119552, '\P{inmayannumerals}', "");
    Expect(0, 119552, '\P{^inmayannumerals}', "");
    Expect(1, 119551, '\p{	-IN_Mayan_Numerals}', "");
    Expect(0, 119551, '\p{^	-IN_Mayan_Numerals}', "");
    Expect(0, 119551, '\P{	-IN_Mayan_Numerals}', "");
    Expect(1, 119551, '\P{^	-IN_Mayan_Numerals}', "");
    Expect(0, 119552, '\p{	-IN_Mayan_Numerals}', "");
    Expect(1, 119552, '\p{^	-IN_Mayan_Numerals}', "");
    Expect(1, 119552, '\P{	-IN_Mayan_Numerals}', "");
    Expect(0, 119552, '\P{^	-IN_Mayan_Numerals}', "");
    Error('\p{	_Medefaidrin:=}');
    Error('\P{	_Medefaidrin:=}');
    Expect(1, 93850, '\p{medefaidrin}', "");
    Expect(0, 93850, '\p{^medefaidrin}', "");
    Expect(0, 93850, '\P{medefaidrin}', "");
    Expect(1, 93850, '\P{^medefaidrin}', "");
    Expect(0, 93851, '\p{medefaidrin}', "");
    Expect(1, 93851, '\p{^medefaidrin}', "");
    Expect(1, 93851, '\P{medefaidrin}', "");
    Expect(0, 93851, '\P{^medefaidrin}', "");
    Expect(1, 93850, '\p{  Medefaidrin}', "");
    Expect(0, 93850, '\p{^  Medefaidrin}', "");
    Expect(0, 93850, '\P{  Medefaidrin}', "");
    Expect(1, 93850, '\P{^  Medefaidrin}', "");
    Expect(0, 93851, '\p{  Medefaidrin}', "");
    Expect(1, 93851, '\p{^  Medefaidrin}', "");
    Expect(1, 93851, '\P{  Medefaidrin}', "");
    Expect(0, 93851, '\P{^  Medefaidrin}', "");
    Error('\p{:= IS_Medefaidrin}');
    Error('\P{:= IS_Medefaidrin}');
    Expect(1, 93850, '\p{ismedefaidrin}', "");
    Expect(0, 93850, '\p{^ismedefaidrin}', "");
    Expect(0, 93850, '\P{ismedefaidrin}', "");
    Expect(1, 93850, '\P{^ismedefaidrin}', "");
    Expect(0, 93851, '\p{ismedefaidrin}', "");
    Expect(1, 93851, '\p{^ismedefaidrin}', "");
    Expect(1, 93851, '\P{ismedefaidrin}', "");
    Expect(0, 93851, '\P{^ismedefaidrin}', "");
    Expect(1, 93850, '\p{IS_medefaidrin}', "");
    Expect(0, 93850, '\p{^IS_medefaidrin}', "");
    Expect(0, 93850, '\P{IS_medefaidrin}', "");
    Expect(1, 93850, '\P{^IS_medefaidrin}', "");
    Expect(0, 93851, '\p{IS_medefaidrin}', "");
    Expect(1, 93851, '\p{^IS_medefaidrin}', "");
    Expect(1, 93851, '\P{IS_medefaidrin}', "");
    Expect(0, 93851, '\P{^IS_medefaidrin}', "");
    Error('\p{		Medf/a/}');
    Error('\P{		Medf/a/}');
    Expect(1, 93850, '\p{medf}', "");
    Expect(0, 93850, '\p{^medf}', "");
    Expect(0, 93850, '\P{medf}', "");
    Expect(1, 93850, '\P{^medf}', "");
    Expect(0, 93851, '\p{medf}', "");
    Expect(1, 93851, '\p{^medf}', "");
    Expect(1, 93851, '\P{medf}', "");
    Expect(0, 93851, '\P{^medf}', "");
    Expect(1, 93850, '\p{-medf}', "");
    Expect(0, 93850, '\p{^-medf}', "");
    Expect(0, 93850, '\P{-medf}', "");
    Expect(1, 93850, '\P{^-medf}', "");
    Expect(0, 93851, '\p{-medf}', "");
    Expect(1, 93851, '\p{^-medf}', "");
    Expect(1, 93851, '\P{-medf}', "");
    Expect(0, 93851, '\P{^-medf}', "");
    Error('\p{:=-_IS_Medf}');
    Error('\P{:=-_IS_Medf}');
    Expect(1, 93850, '\p{ismedf}', "");
    Expect(0, 93850, '\p{^ismedf}', "");
    Expect(0, 93850, '\P{ismedf}', "");
    Expect(1, 93850, '\P{^ismedf}', "");
    Expect(0, 93851, '\p{ismedf}', "");
    Expect(1, 93851, '\p{^ismedf}', "");
    Expect(1, 93851, '\P{ismedf}', "");
    Expect(0, 93851, '\P{^ismedf}', "");
    Expect(1, 93850, '\p{-_Is_Medf}', "");
    Expect(0, 93850, '\p{^-_Is_Medf}', "");
    Expect(0, 93850, '\P{-_Is_Medf}', "");
    Expect(1, 93850, '\P{^-_Is_Medf}', "");
    Expect(0, 93851, '\p{-_Is_Medf}', "");
    Expect(1, 93851, '\p{^-_Is_Medf}', "");
    Expect(1, 93851, '\P{-_Is_Medf}', "");
    Expect(0, 93851, '\P{^-_Is_Medf}', "");
    Error('\p{_ Meetei_MAYEK:=}');
    Error('\P{_ Meetei_MAYEK:=}');
    Expect(1, 44025, '\p{meeteimayek}', "");
    Expect(0, 44025, '\p{^meeteimayek}', "");
    Expect(0, 44025, '\P{meeteimayek}', "");
    Expect(1, 44025, '\P{^meeteimayek}', "");
    Expect(0, 44026, '\p{meeteimayek}', "");
    Expect(1, 44026, '\p{^meeteimayek}', "");
    Expect(1, 44026, '\P{meeteimayek}', "");
    Expect(0, 44026, '\P{^meeteimayek}', "");
    Expect(1, 44025, '\p{_ meetei_mayek}', "");
    Expect(0, 44025, '\p{^_ meetei_mayek}', "");
    Expect(0, 44025, '\P{_ meetei_mayek}', "");
    Expect(1, 44025, '\P{^_ meetei_mayek}', "");
    Expect(0, 44026, '\p{_ meetei_mayek}', "");
    Expect(1, 44026, '\p{^_ meetei_mayek}', "");
    Expect(1, 44026, '\P{_ meetei_mayek}', "");
    Expect(0, 44026, '\P{^_ meetei_mayek}', "");
    Error('\p{ _Is_Meetei_Mayek:=}');
    Error('\P{ _Is_Meetei_Mayek:=}');
    Expect(1, 44025, '\p{ismeeteimayek}', "");
    Expect(0, 44025, '\p{^ismeeteimayek}', "");
    Expect(0, 44025, '\P{ismeeteimayek}', "");
    Expect(1, 44025, '\P{^ismeeteimayek}', "");
    Expect(0, 44026, '\p{ismeeteimayek}', "");
    Expect(1, 44026, '\p{^ismeeteimayek}', "");
    Expect(1, 44026, '\P{ismeeteimayek}', "");
    Expect(0, 44026, '\P{^ismeeteimayek}', "");
    Expect(1, 44025, '\p{-IS_meetei_mayek}', "");
    Expect(0, 44025, '\p{^-IS_meetei_mayek}', "");
    Expect(0, 44025, '\P{-IS_meetei_mayek}', "");
    Expect(1, 44025, '\P{^-IS_meetei_mayek}', "");
    Expect(0, 44026, '\p{-IS_meetei_mayek}', "");
    Expect(1, 44026, '\p{^-IS_meetei_mayek}', "");
    Expect(1, 44026, '\P{-IS_meetei_mayek}', "");
    Expect(0, 44026, '\P{^-IS_meetei_mayek}', "");
    Error('\p{		Mtei:=}');
    Error('\P{		Mtei:=}');
    Expect(1, 44025, '\p{mtei}', "");
    Expect(0, 44025, '\p{^mtei}', "");
    Expect(0, 44025, '\P{mtei}', "");
    Expect(1, 44025, '\P{^mtei}', "");
    Expect(0, 44026, '\p{mtei}', "");
    Expect(1, 44026, '\p{^mtei}', "");
    Expect(1, 44026, '\P{mtei}', "");
    Expect(0, 44026, '\P{^mtei}', "");
    Expect(1, 44025, '\p{-	Mtei}', "");
    Expect(0, 44025, '\p{^-	Mtei}', "");
    Expect(0, 44025, '\P{-	Mtei}', "");
    Expect(1, 44025, '\P{^-	Mtei}', "");
    Expect(0, 44026, '\p{-	Mtei}', "");
    Expect(1, 44026, '\p{^-	Mtei}', "");
    Expect(1, 44026, '\P{-	Mtei}', "");
    Expect(0, 44026, '\P{^-	Mtei}', "");
    Error('\p{:=_-IS_MTEI}');
    Error('\P{:=_-IS_MTEI}');
    Expect(1, 44025, '\p{ismtei}', "");
    Expect(0, 44025, '\p{^ismtei}', "");
    Expect(0, 44025, '\P{ismtei}', "");
    Expect(1, 44025, '\P{^ismtei}', "");
    Expect(0, 44026, '\p{ismtei}', "");
    Expect(1, 44026, '\p{^ismtei}', "");
    Expect(1, 44026, '\P{ismtei}', "");
    Expect(0, 44026, '\P{^ismtei}', "");
    Expect(1, 44025, '\p{	-Is_Mtei}', "");
    Expect(0, 44025, '\p{^	-Is_Mtei}', "");
    Expect(0, 44025, '\P{	-Is_Mtei}', "");
    Expect(1, 44025, '\P{^	-Is_Mtei}', "");
    Expect(0, 44026, '\p{	-Is_Mtei}', "");
    Expect(1, 44026, '\p{^	-Is_Mtei}', "");
    Expect(1, 44026, '\P{	-Is_Mtei}', "");
    Expect(0, 44026, '\P{^	-Is_Mtei}', "");
    Error('\p{/a/_meetei_MAYEK_EXTENSIONS}');
    Error('\P{/a/_meetei_MAYEK_EXTENSIONS}');
    Expect(1, 43775, '\p{meeteimayekextensions}', "");
    Expect(0, 43775, '\p{^meeteimayekextensions}', "");
    Expect(0, 43775, '\P{meeteimayekextensions}', "");
    Expect(1, 43775, '\P{^meeteimayekextensions}', "");
    Expect(0, 43776, '\p{meeteimayekextensions}', "");
    Expect(1, 43776, '\p{^meeteimayekextensions}', "");
    Expect(1, 43776, '\P{meeteimayekextensions}', "");
    Expect(0, 43776, '\P{^meeteimayekextensions}', "");
    Expect(1, 43775, '\p{	Meetei_mayek_extensions}', "");
    Expect(0, 43775, '\p{^	Meetei_mayek_extensions}', "");
    Expect(0, 43775, '\P{	Meetei_mayek_extensions}', "");
    Expect(1, 43775, '\P{^	Meetei_mayek_extensions}', "");
    Expect(0, 43776, '\p{	Meetei_mayek_extensions}', "");
    Expect(1, 43776, '\p{^	Meetei_mayek_extensions}', "");
    Expect(1, 43776, '\P{	Meetei_mayek_extensions}', "");
    Expect(0, 43776, '\P{^	Meetei_mayek_extensions}', "");
    Error('\p{	IS_Meetei_MAYEK_extensions:=}');
    Error('\P{	IS_Meetei_MAYEK_extensions:=}');
    Expect(1, 43775, '\p{ismeeteimayekextensions}', "");
    Expect(0, 43775, '\p{^ismeeteimayekextensions}', "");
    Expect(0, 43775, '\P{ismeeteimayekextensions}', "");
    Expect(1, 43775, '\P{^ismeeteimayekextensions}', "");
    Expect(0, 43776, '\p{ismeeteimayekextensions}', "");
    Expect(1, 43776, '\p{^ismeeteimayekextensions}', "");
    Expect(1, 43776, '\P{ismeeteimayekextensions}', "");
    Expect(0, 43776, '\P{^ismeeteimayekextensions}', "");
    Expect(1, 43775, '\p{__is_Meetei_Mayek_EXTENSIONS}', "");
    Expect(0, 43775, '\p{^__is_Meetei_Mayek_EXTENSIONS}', "");
    Expect(0, 43775, '\P{__is_Meetei_Mayek_EXTENSIONS}', "");
    Expect(1, 43775, '\P{^__is_Meetei_Mayek_EXTENSIONS}', "");
    Expect(0, 43776, '\p{__is_Meetei_Mayek_EXTENSIONS}', "");
    Expect(1, 43776, '\p{^__is_Meetei_Mayek_EXTENSIONS}', "");
    Expect(1, 43776, '\P{__is_Meetei_Mayek_EXTENSIONS}', "");
    Expect(0, 43776, '\P{^__is_Meetei_Mayek_EXTENSIONS}', "");
    Error('\p{:=	-IN_meetei_mayek_EXTENSIONS}');
    Error('\P{:=	-IN_meetei_mayek_EXTENSIONS}');
    Expect(1, 43775, '\p{inmeeteimayekextensions}', "");
    Expect(0, 43775, '\p{^inmeeteimayekextensions}', "");
    Expect(0, 43775, '\P{inmeeteimayekextensions}', "");
    Expect(1, 43775, '\P{^inmeeteimayekextensions}', "");
    Expect(0, 43776, '\p{inmeeteimayekextensions}', "");
    Expect(1, 43776, '\p{^inmeeteimayekextensions}', "");
    Expect(1, 43776, '\P{inmeeteimayekextensions}', "");
    Expect(0, 43776, '\P{^inmeeteimayekextensions}', "");
    Expect(1, 43775, '\p{ IN_MEETEI_mayek_extensions}', "");
    Expect(0, 43775, '\p{^ IN_MEETEI_mayek_extensions}', "");
    Expect(0, 43775, '\P{ IN_MEETEI_mayek_extensions}', "");
    Expect(1, 43775, '\P{^ IN_MEETEI_mayek_extensions}', "");
    Expect(0, 43776, '\p{ IN_MEETEI_mayek_extensions}', "");
    Expect(1, 43776, '\p{^ IN_MEETEI_mayek_extensions}', "");
    Expect(1, 43776, '\P{ IN_MEETEI_mayek_extensions}', "");
    Expect(0, 43776, '\P{^ IN_MEETEI_mayek_extensions}', "");
    Error('\p{-/a/Meetei_Mayek_Ext}');
    Error('\P{-/a/Meetei_Mayek_Ext}');
    Expect(1, 43775, '\p{meeteimayekext}', "");
    Expect(0, 43775, '\p{^meeteimayekext}', "");
    Expect(0, 43775, '\P{meeteimayekext}', "");
    Expect(1, 43775, '\P{^meeteimayekext}', "");
    Expect(0, 43776, '\p{meeteimayekext}', "");
    Expect(1, 43776, '\p{^meeteimayekext}', "");
    Expect(1, 43776, '\P{meeteimayekext}', "");
    Expect(0, 43776, '\P{^meeteimayekext}', "");
    Expect(1, 43775, '\p{  meetei_MAYEK_EXT}', "");
    Expect(0, 43775, '\p{^  meetei_MAYEK_EXT}', "");
    Expect(0, 43775, '\P{  meetei_MAYEK_EXT}', "");
    Expect(1, 43775, '\P{^  meetei_MAYEK_EXT}', "");
    Expect(0, 43776, '\p{  meetei_MAYEK_EXT}', "");
    Expect(1, 43776, '\p{^  meetei_MAYEK_EXT}', "");
    Expect(1, 43776, '\P{  meetei_MAYEK_EXT}', "");
    Expect(0, 43776, '\P{^  meetei_MAYEK_EXT}', "");
    Error('\p{	/a/Is_meetei_mayek_EXT}');
    Error('\P{	/a/Is_meetei_mayek_EXT}');
    Expect(1, 43775, '\p{ismeeteimayekext}', "");
    Expect(0, 43775, '\p{^ismeeteimayekext}', "");
    Expect(0, 43775, '\P{ismeeteimayekext}', "");
    Expect(1, 43775, '\P{^ismeeteimayekext}', "");
    Expect(0, 43776, '\p{ismeeteimayekext}', "");
    Expect(1, 43776, '\p{^ismeeteimayekext}', "");
    Expect(1, 43776, '\P{ismeeteimayekext}', "");
    Expect(0, 43776, '\P{^ismeeteimayekext}', "");
    Expect(1, 43775, '\p{_Is_Meetei_mayek_EXT}', "");
    Expect(0, 43775, '\p{^_Is_Meetei_mayek_EXT}', "");
    Expect(0, 43775, '\P{_Is_Meetei_mayek_EXT}', "");
    Expect(1, 43775, '\P{^_Is_Meetei_mayek_EXT}', "");
    Expect(0, 43776, '\p{_Is_Meetei_mayek_EXT}', "");
    Expect(1, 43776, '\p{^_Is_Meetei_mayek_EXT}', "");
    Expect(1, 43776, '\P{_Is_Meetei_mayek_EXT}', "");
    Expect(0, 43776, '\P{^_Is_Meetei_mayek_EXT}', "");
    Error('\p{ 	in_Meetei_MAYEK_ext:=}');
    Error('\P{ 	in_Meetei_MAYEK_ext:=}');
    Expect(1, 43775, '\p{inmeeteimayekext}', "");
    Expect(0, 43775, '\p{^inmeeteimayekext}', "");
    Expect(0, 43775, '\P{inmeeteimayekext}', "");
    Expect(1, 43775, '\P{^inmeeteimayekext}', "");
    Expect(0, 43776, '\p{inmeeteimayekext}', "");
    Expect(1, 43776, '\p{^inmeeteimayekext}', "");
    Expect(1, 43776, '\P{inmeeteimayekext}', "");
    Expect(0, 43776, '\P{^inmeeteimayekext}', "");
    Expect(1, 43775, '\p{		in_meetei_Mayek_Ext}', "");
    Expect(0, 43775, '\p{^		in_meetei_Mayek_Ext}', "");
    Expect(0, 43775, '\P{		in_meetei_Mayek_Ext}', "");
    Expect(1, 43775, '\P{^		in_meetei_Mayek_Ext}', "");
    Expect(0, 43776, '\p{		in_meetei_Mayek_Ext}', "");
    Expect(1, 43776, '\p{^		in_meetei_Mayek_Ext}', "");
    Expect(1, 43776, '\P{		in_meetei_Mayek_Ext}', "");
    Expect(0, 43776, '\P{^		in_meetei_Mayek_Ext}', "");
    Error('\p{ MENDE_kikakui:=}');
    Error('\P{ MENDE_kikakui:=}');
    Expect(1, 125142, '\p{mendekikakui}', "");
    Expect(0, 125142, '\p{^mendekikakui}', "");
    Expect(0, 125142, '\P{mendekikakui}', "");
    Expect(1, 125142, '\P{^mendekikakui}', "");
    Expect(0, 125143, '\p{mendekikakui}', "");
    Expect(1, 125143, '\p{^mendekikakui}', "");
    Expect(1, 125143, '\P{mendekikakui}', "");
    Expect(0, 125143, '\P{^mendekikakui}', "");
    Expect(1, 125142, '\p{  Mende_kikakui}', "");
    Expect(0, 125142, '\p{^  Mende_kikakui}', "");
    Expect(0, 125142, '\P{  Mende_kikakui}', "");
    Expect(1, 125142, '\P{^  Mende_kikakui}', "");
    Expect(0, 125143, '\p{  Mende_kikakui}', "");
    Expect(1, 125143, '\p{^  Mende_kikakui}', "");
    Expect(1, 125143, '\P{  Mende_kikakui}', "");
    Expect(0, 125143, '\P{^  Mende_kikakui}', "");
    Error('\p{/a/  Is_Mende_kikakui}');
    Error('\P{/a/  Is_Mende_kikakui}');
    Expect(1, 125142, '\p{ismendekikakui}', "");
    Expect(0, 125142, '\p{^ismendekikakui}', "");
    Expect(0, 125142, '\P{ismendekikakui}', "");
    Expect(1, 125142, '\P{^ismendekikakui}', "");
    Expect(0, 125143, '\p{ismendekikakui}', "");
    Expect(1, 125143, '\p{^ismendekikakui}', "");
    Expect(1, 125143, '\P{ismendekikakui}', "");
    Expect(0, 125143, '\P{^ismendekikakui}', "");
    Expect(1, 125142, '\p{	_is_Mende_Kikakui}', "");
    Expect(0, 125142, '\p{^	_is_Mende_Kikakui}', "");
    Expect(0, 125142, '\P{	_is_Mende_Kikakui}', "");
    Expect(1, 125142, '\P{^	_is_Mende_Kikakui}', "");
    Expect(0, 125143, '\p{	_is_Mende_Kikakui}', "");
    Expect(1, 125143, '\p{^	_is_Mende_Kikakui}', "");
    Expect(1, 125143, '\P{	_is_Mende_Kikakui}', "");
    Expect(0, 125143, '\P{^	_is_Mende_Kikakui}', "");
    Error('\p{:=_ Mend}');
    Error('\P{:=_ Mend}');
    Expect(1, 125142, '\p{mend}', "");
    Expect(0, 125142, '\p{^mend}', "");
    Expect(0, 125142, '\P{mend}', "");
    Expect(1, 125142, '\P{^mend}', "");
    Expect(0, 125143, '\p{mend}', "");
    Expect(1, 125143, '\p{^mend}', "");
    Expect(1, 125143, '\P{mend}', "");
    Expect(0, 125143, '\P{^mend}', "");
    Expect(1, 125142, '\p{	-MEND}', "");
    Expect(0, 125142, '\p{^	-MEND}', "");
    Expect(0, 125142, '\P{	-MEND}', "");
    Expect(1, 125142, '\P{^	-MEND}', "");
    Expect(0, 125143, '\p{	-MEND}', "");
    Expect(1, 125143, '\p{^	-MEND}', "");
    Expect(1, 125143, '\P{	-MEND}', "");
    Expect(0, 125143, '\P{^	-MEND}', "");
    Error('\p{:=	-is_Mend}');
    Error('\P{:=	-is_Mend}');
    Expect(1, 125142, '\p{ismend}', "");
    Expect(0, 125142, '\p{^ismend}', "");
    Expect(0, 125142, '\P{ismend}', "");
    Expect(1, 125142, '\P{^ismend}', "");
    Expect(0, 125143, '\p{ismend}', "");
    Expect(1, 125143, '\p{^ismend}', "");
    Expect(1, 125143, '\P{ismend}', "");
    Expect(0, 125143, '\P{^ismend}', "");
    Expect(1, 125142, '\p{	-Is_mend}', "");
    Expect(0, 125142, '\p{^	-Is_mend}', "");
    Expect(0, 125142, '\P{	-Is_mend}', "");
    Expect(1, 125142, '\P{^	-Is_mend}', "");
    Expect(0, 125143, '\p{	-Is_mend}', "");
    Expect(1, 125143, '\p{^	-Is_mend}', "");
    Expect(1, 125143, '\P{	-Is_mend}', "");
    Expect(0, 125143, '\P{^	-Is_mend}', "");
    Error('\p{:= 	Meroitic_Cursive}');
    Error('\P{:= 	Meroitic_Cursive}');
    Expect(1, 68095, '\p{meroiticcursive}', "");
    Expect(0, 68095, '\p{^meroiticcursive}', "");
    Expect(0, 68095, '\P{meroiticcursive}', "");
    Expect(1, 68095, '\P{^meroiticcursive}', "");
    Expect(0, 68096, '\p{meroiticcursive}', "");
    Expect(1, 68096, '\p{^meroiticcursive}', "");
    Expect(1, 68096, '\P{meroiticcursive}', "");
    Expect(0, 68096, '\P{^meroiticcursive}', "");
    Expect(1, 68095, '\p{-Meroitic_CURSIVE}', "");
    Expect(0, 68095, '\p{^-Meroitic_CURSIVE}', "");
    Expect(0, 68095, '\P{-Meroitic_CURSIVE}', "");
    Expect(1, 68095, '\P{^-Meroitic_CURSIVE}', "");
    Expect(0, 68096, '\p{-Meroitic_CURSIVE}', "");
    Expect(1, 68096, '\p{^-Meroitic_CURSIVE}', "");
    Expect(1, 68096, '\P{-Meroitic_CURSIVE}', "");
    Expect(0, 68096, '\P{^-Meroitic_CURSIVE}', "");
    Error('\p{:=_-Is_MEROITIC_Cursive}');
    Error('\P{:=_-Is_MEROITIC_Cursive}');
    Expect(1, 68095, '\p{ismeroiticcursive}', "");
    Expect(0, 68095, '\p{^ismeroiticcursive}', "");
    Expect(0, 68095, '\P{ismeroiticcursive}', "");
    Expect(1, 68095, '\P{^ismeroiticcursive}', "");
    Expect(0, 68096, '\p{ismeroiticcursive}', "");
    Expect(1, 68096, '\p{^ismeroiticcursive}', "");
    Expect(1, 68096, '\P{ismeroiticcursive}', "");
    Expect(0, 68096, '\P{^ismeroiticcursive}', "");
    Expect(1, 68095, '\p{	Is_Meroitic_CURSIVE}', "");
    Expect(0, 68095, '\p{^	Is_Meroitic_CURSIVE}', "");
    Expect(0, 68095, '\P{	Is_Meroitic_CURSIVE}', "");
    Expect(1, 68095, '\P{^	Is_Meroitic_CURSIVE}', "");
    Expect(0, 68096, '\p{	Is_Meroitic_CURSIVE}', "");
    Expect(1, 68096, '\p{^	Is_Meroitic_CURSIVE}', "");
    Expect(1, 68096, '\P{	Is_Meroitic_CURSIVE}', "");
    Expect(0, 68096, '\P{^	Is_Meroitic_CURSIVE}', "");
    Error('\p{/a/ merc}');
    Error('\P{/a/ merc}');
    Expect(1, 68095, '\p{merc}', "");
    Expect(0, 68095, '\p{^merc}', "");
    Expect(0, 68095, '\P{merc}', "");
    Expect(1, 68095, '\P{^merc}', "");
    Expect(0, 68096, '\p{merc}', "");
    Expect(1, 68096, '\p{^merc}', "");
    Expect(1, 68096, '\P{merc}', "");
    Expect(0, 68096, '\P{^merc}', "");
    Expect(1, 68095, '\p{	merc}', "");
    Expect(0, 68095, '\p{^	merc}', "");
    Expect(0, 68095, '\P{	merc}', "");
    Expect(1, 68095, '\P{^	merc}', "");
    Expect(0, 68096, '\p{	merc}', "");
    Expect(1, 68096, '\p{^	merc}', "");
    Expect(1, 68096, '\P{	merc}', "");
    Expect(0, 68096, '\P{^	merc}', "");
    Error('\p{-is_Merc:=}');
    Error('\P{-is_Merc:=}');
    Expect(1, 68095, '\p{ismerc}', "");
    Expect(0, 68095, '\p{^ismerc}', "");
    Expect(0, 68095, '\P{ismerc}', "");
    Expect(1, 68095, '\P{^ismerc}', "");
    Expect(0, 68096, '\p{ismerc}', "");
    Expect(1, 68096, '\p{^ismerc}', "");
    Expect(1, 68096, '\P{ismerc}', "");
    Expect(0, 68096, '\P{^ismerc}', "");
    Expect(1, 68095, '\p{-Is_merc}', "");
    Expect(0, 68095, '\p{^-Is_merc}', "");
    Expect(0, 68095, '\P{-Is_merc}', "");
    Expect(1, 68095, '\P{^-Is_merc}', "");
    Expect(0, 68096, '\p{-Is_merc}', "");
    Expect(1, 68096, '\p{^-Is_merc}', "");
    Expect(1, 68096, '\P{-Is_merc}', "");
    Expect(0, 68096, '\P{^-Is_merc}', "");
    Error('\p{	MEROITIC_Hieroglyphs:=}');
    Error('\P{	MEROITIC_Hieroglyphs:=}');
    Expect(1, 67999, '\p{meroitichieroglyphs}', "");
    Expect(0, 67999, '\p{^meroitichieroglyphs}', "");
    Expect(0, 67999, '\P{meroitichieroglyphs}', "");
    Expect(1, 67999, '\P{^meroitichieroglyphs}', "");
    Expect(0, 68000, '\p{meroitichieroglyphs}', "");
    Expect(1, 68000, '\p{^meroitichieroglyphs}', "");
    Expect(1, 68000, '\P{meroitichieroglyphs}', "");
    Expect(0, 68000, '\P{^meroitichieroglyphs}', "");
    Expect(1, 67999, '\p{_-MEROITIC_hieroglyphs}', "");
    Expect(0, 67999, '\p{^_-MEROITIC_hieroglyphs}', "");
    Expect(0, 67999, '\P{_-MEROITIC_hieroglyphs}', "");
    Expect(1, 67999, '\P{^_-MEROITIC_hieroglyphs}', "");
    Expect(0, 68000, '\p{_-MEROITIC_hieroglyphs}', "");
    Expect(1, 68000, '\p{^_-MEROITIC_hieroglyphs}', "");
    Expect(1, 68000, '\P{_-MEROITIC_hieroglyphs}', "");
    Expect(0, 68000, '\P{^_-MEROITIC_hieroglyphs}', "");
    Error('\p{ 	IS_Meroitic_Hieroglyphs/a/}');
    Error('\P{ 	IS_Meroitic_Hieroglyphs/a/}');
    Expect(1, 67999, '\p{ismeroitichieroglyphs}', "");
    Expect(0, 67999, '\p{^ismeroitichieroglyphs}', "");
    Expect(0, 67999, '\P{ismeroitichieroglyphs}', "");
    Expect(1, 67999, '\P{^ismeroitichieroglyphs}', "");
    Expect(0, 68000, '\p{ismeroitichieroglyphs}', "");
    Expect(1, 68000, '\p{^ismeroitichieroglyphs}', "");
    Expect(1, 68000, '\P{ismeroitichieroglyphs}', "");
    Expect(0, 68000, '\P{^ismeroitichieroglyphs}', "");
    Expect(1, 67999, '\p{ -IS_MEROITIC_Hieroglyphs}', "");
    Expect(0, 67999, '\p{^ -IS_MEROITIC_Hieroglyphs}', "");
    Expect(0, 67999, '\P{ -IS_MEROITIC_Hieroglyphs}', "");
    Expect(1, 67999, '\P{^ -IS_MEROITIC_Hieroglyphs}', "");
    Expect(0, 68000, '\p{ -IS_MEROITIC_Hieroglyphs}', "");
    Expect(1, 68000, '\p{^ -IS_MEROITIC_Hieroglyphs}', "");
    Expect(1, 68000, '\P{ -IS_MEROITIC_Hieroglyphs}', "");
    Expect(0, 68000, '\P{^ -IS_MEROITIC_Hieroglyphs}', "");
    Error('\p{ :=mero}');
    Error('\P{ :=mero}');
    Expect(1, 67999, '\p{mero}', "");
    Expect(0, 67999, '\p{^mero}', "");
    Expect(0, 67999, '\P{mero}', "");
    Expect(1, 67999, '\P{^mero}', "");
    Expect(0, 68000, '\p{mero}', "");
    Expect(1, 68000, '\p{^mero}', "");
    Expect(1, 68000, '\P{mero}', "");
    Expect(0, 68000, '\P{^mero}', "");
    Expect(1, 67999, '\p{_Mero}', "");
    Expect(0, 67999, '\p{^_Mero}', "");
    Expect(0, 67999, '\P{_Mero}', "");
    Expect(1, 67999, '\P{^_Mero}', "");
    Expect(0, 68000, '\p{_Mero}', "");
    Expect(1, 68000, '\p{^_Mero}', "");
    Expect(1, 68000, '\P{_Mero}', "");
    Expect(0, 68000, '\P{^_Mero}', "");
    Error('\p{:=-	Is_MERO}');
    Error('\P{:=-	Is_MERO}');
    Expect(1, 67999, '\p{ismero}', "");
    Expect(0, 67999, '\p{^ismero}', "");
    Expect(0, 67999, '\P{ismero}', "");
    Expect(1, 67999, '\P{^ismero}', "");
    Expect(0, 68000, '\p{ismero}', "");
    Expect(1, 68000, '\p{^ismero}', "");
    Expect(1, 68000, '\P{ismero}', "");
    Expect(0, 68000, '\P{^ismero}', "");
    Expect(1, 67999, '\p{	IS_Mero}', "");
    Expect(0, 67999, '\p{^	IS_Mero}', "");
    Expect(0, 67999, '\P{	IS_Mero}', "");
    Expect(1, 67999, '\P{^	IS_Mero}', "");
    Expect(0, 68000, '\p{	IS_Mero}', "");
    Expect(1, 68000, '\p{^	IS_Mero}', "");
    Expect(1, 68000, '\P{	IS_Mero}', "");
    Expect(0, 68000, '\P{^	IS_Mero}', "");
    Error('\p{-:=miao}');
    Error('\P{-:=miao}');
    Expect(1, 94111, '\p{miao}', "");
    Expect(0, 94111, '\p{^miao}', "");
    Expect(0, 94111, '\P{miao}', "");
    Expect(1, 94111, '\P{^miao}', "");
    Expect(0, 94112, '\p{miao}', "");
    Expect(1, 94112, '\p{^miao}', "");
    Expect(1, 94112, '\P{miao}', "");
    Expect(0, 94112, '\P{^miao}', "");
    Expect(1, 94111, '\p{		miao}', "");
    Expect(0, 94111, '\p{^		miao}', "");
    Expect(0, 94111, '\P{		miao}', "");
    Expect(1, 94111, '\P{^		miao}', "");
    Expect(0, 94112, '\p{		miao}', "");
    Expect(1, 94112, '\p{^		miao}', "");
    Expect(1, 94112, '\P{		miao}', "");
    Expect(0, 94112, '\P{^		miao}', "");
    Error('\p{-/a/Is_miao}');
    Error('\P{-/a/Is_miao}');
    Expect(1, 94111, '\p{ismiao}', "");
    Expect(0, 94111, '\p{^ismiao}', "");
    Expect(0, 94111, '\P{ismiao}', "");
    Expect(1, 94111, '\P{^ismiao}', "");
    Expect(0, 94112, '\p{ismiao}', "");
    Expect(1, 94112, '\p{^ismiao}', "");
    Expect(1, 94112, '\P{ismiao}', "");
    Expect(0, 94112, '\P{^ismiao}', "");
    Expect(1, 94111, '\p{_IS_MIAO}', "");
    Expect(0, 94111, '\p{^_IS_MIAO}', "");
    Expect(0, 94111, '\P{_IS_MIAO}', "");
    Expect(1, 94111, '\P{^_IS_MIAO}', "");
    Expect(0, 94112, '\p{_IS_MIAO}', "");
    Expect(1, 94112, '\p{^_IS_MIAO}', "");
    Expect(1, 94112, '\P{_IS_MIAO}', "");
    Expect(0, 94112, '\P{^_IS_MIAO}', "");
    Error('\p{ /a/plrd}');
    Error('\P{ /a/plrd}');
    Expect(1, 94111, '\p{plrd}', "");
    Expect(0, 94111, '\p{^plrd}', "");
    Expect(0, 94111, '\P{plrd}', "");
    Expect(1, 94111, '\P{^plrd}', "");
    Expect(0, 94112, '\p{plrd}', "");
    Expect(1, 94112, '\p{^plrd}', "");
    Expect(1, 94112, '\P{plrd}', "");
    Expect(0, 94112, '\P{^plrd}', "");
    Expect(1, 94111, '\p{Plrd}', "");
    Expect(0, 94111, '\p{^Plrd}', "");
    Expect(0, 94111, '\P{Plrd}', "");
    Expect(1, 94111, '\P{^Plrd}', "");
    Expect(0, 94112, '\p{Plrd}', "");
    Expect(1, 94112, '\p{^Plrd}', "");
    Expect(1, 94112, '\P{Plrd}', "");
    Expect(0, 94112, '\P{^Plrd}', "");
    Error('\p{/a/  Is_Plrd}');
    Error('\P{/a/  Is_Plrd}');
    Expect(1, 94111, '\p{isplrd}', "");
    Expect(0, 94111, '\p{^isplrd}', "");
    Expect(0, 94111, '\P{isplrd}', "");
    Expect(1, 94111, '\P{^isplrd}', "");
    Expect(0, 94112, '\p{isplrd}', "");
    Expect(1, 94112, '\p{^isplrd}', "");
    Expect(1, 94112, '\P{isplrd}', "");
    Expect(0, 94112, '\P{^isplrd}', "");
    Expect(1, 94111, '\p{ IS_PLRD}', "");
    Expect(0, 94111, '\p{^ IS_PLRD}', "");
    Expect(0, 94111, '\P{ IS_PLRD}', "");
    Expect(1, 94111, '\P{^ IS_PLRD}', "");
    Expect(0, 94112, '\p{ IS_PLRD}', "");
    Expect(1, 94112, '\p{^ IS_PLRD}', "");
    Expect(1, 94112, '\P{ IS_PLRD}', "");
    Expect(0, 94112, '\P{^ IS_PLRD}', "");
    Error('\p{	:=miscellaneous_Mathematical_symbols_A}');
    Error('\P{	:=miscellaneous_Mathematical_symbols_A}');
    Expect(1, 10223, '\p{miscellaneousmathematicalsymbolsa}', "");
    Expect(0, 10223, '\p{^miscellaneousmathematicalsymbolsa}', "");
    Expect(0, 10223, '\P{miscellaneousmathematicalsymbolsa}', "");
    Expect(1, 10223, '\P{^miscellaneousmathematicalsymbolsa}', "");
    Expect(0, 10224, '\p{miscellaneousmathematicalsymbolsa}', "");
    Expect(1, 10224, '\p{^miscellaneousmathematicalsymbolsa}', "");
    Expect(1, 10224, '\P{miscellaneousmathematicalsymbolsa}', "");
    Expect(0, 10224, '\P{^miscellaneousmathematicalsymbolsa}', "");
    Expect(1, 10223, '\p{ _Miscellaneous_MATHEMATICAL_SYMBOLS_A}', "");
    Expect(0, 10223, '\p{^ _Miscellaneous_MATHEMATICAL_SYMBOLS_A}', "");
    Expect(0, 10223, '\P{ _Miscellaneous_MATHEMATICAL_SYMBOLS_A}', "");
    Expect(1, 10223, '\P{^ _Miscellaneous_MATHEMATICAL_SYMBOLS_A}', "");
    Expect(0, 10224, '\p{ _Miscellaneous_MATHEMATICAL_SYMBOLS_A}', "");
    Expect(1, 10224, '\p{^ _Miscellaneous_MATHEMATICAL_SYMBOLS_A}', "");
    Expect(1, 10224, '\P{ _Miscellaneous_MATHEMATICAL_SYMBOLS_A}', "");
    Expect(0, 10224, '\P{^ _Miscellaneous_MATHEMATICAL_SYMBOLS_A}', "");
    Error('\p{-	Is_miscellaneous_mathematical_SYMBOLS_A:=}');
    Error('\P{-	Is_miscellaneous_mathematical_SYMBOLS_A:=}');
    Expect(1, 10223, '\p{ismiscellaneousmathematicalsymbolsa}', "");
    Expect(0, 10223, '\p{^ismiscellaneousmathematicalsymbolsa}', "");
    Expect(0, 10223, '\P{ismiscellaneousmathematicalsymbolsa}', "");
    Expect(1, 10223, '\P{^ismiscellaneousmathematicalsymbolsa}', "");
    Expect(0, 10224, '\p{ismiscellaneousmathematicalsymbolsa}', "");
    Expect(1, 10224, '\p{^ismiscellaneousmathematicalsymbolsa}', "");
    Expect(1, 10224, '\P{ismiscellaneousmathematicalsymbolsa}', "");
    Expect(0, 10224, '\P{^ismiscellaneousmathematicalsymbolsa}', "");
    Expect(1, 10223, '\p{	_Is_Miscellaneous_Mathematical_SYMBOLS_a}', "");
    Expect(0, 10223, '\p{^	_Is_Miscellaneous_Mathematical_SYMBOLS_a}', "");
    Expect(0, 10223, '\P{	_Is_Miscellaneous_Mathematical_SYMBOLS_a}', "");
    Expect(1, 10223, '\P{^	_Is_Miscellaneous_Mathematical_SYMBOLS_a}', "");
    Expect(0, 10224, '\p{	_Is_Miscellaneous_Mathematical_SYMBOLS_a}', "");
    Expect(1, 10224, '\p{^	_Is_Miscellaneous_Mathematical_SYMBOLS_a}', "");
    Expect(1, 10224, '\P{	_Is_Miscellaneous_Mathematical_SYMBOLS_a}', "");
    Expect(0, 10224, '\P{^	_Is_Miscellaneous_Mathematical_SYMBOLS_a}', "");
    Error('\p{:=_ in_MISCELLANEOUS_Mathematical_SYMBOLS_a}');
    Error('\P{:=_ in_MISCELLANEOUS_Mathematical_SYMBOLS_a}');
    Expect(1, 10223, '\p{inmiscellaneousmathematicalsymbolsa}', "");
    Expect(0, 10223, '\p{^inmiscellaneousmathematicalsymbolsa}', "");
    Expect(0, 10223, '\P{inmiscellaneousmathematicalsymbolsa}', "");
    Expect(1, 10223, '\P{^inmiscellaneousmathematicalsymbolsa}', "");
    Expect(0, 10224, '\p{inmiscellaneousmathematicalsymbolsa}', "");
    Expect(1, 10224, '\p{^inmiscellaneousmathematicalsymbolsa}', "");
    Expect(1, 10224, '\P{inmiscellaneousmathematicalsymbolsa}', "");
    Expect(0, 10224, '\P{^inmiscellaneousmathematicalsymbolsa}', "");
    Expect(1, 10223, '\p{-_In_Miscellaneous_Mathematical_Symbols_A}', "");
    Expect(0, 10223, '\p{^-_In_Miscellaneous_Mathematical_Symbols_A}', "");
    Expect(0, 10223, '\P{-_In_Miscellaneous_Mathematical_Symbols_A}', "");
    Expect(1, 10223, '\P{^-_In_Miscellaneous_Mathematical_Symbols_A}', "");
    Expect(0, 10224, '\p{-_In_Miscellaneous_Mathematical_Symbols_A}', "");
    Expect(1, 10224, '\p{^-_In_Miscellaneous_Mathematical_Symbols_A}', "");
    Expect(1, 10224, '\P{-_In_Miscellaneous_Mathematical_Symbols_A}', "");
    Expect(0, 10224, '\P{^-_In_Miscellaneous_Mathematical_Symbols_A}', "");
    Error('\p{-/a/Misc_Math_Symbols_A}');
    Error('\P{-/a/Misc_Math_Symbols_A}');
    Expect(1, 10223, '\p{miscmathsymbolsa}', "");
    Expect(0, 10223, '\p{^miscmathsymbolsa}', "");
    Expect(0, 10223, '\P{miscmathsymbolsa}', "");
    Expect(1, 10223, '\P{^miscmathsymbolsa}', "");
    Expect(0, 10224, '\p{miscmathsymbolsa}', "");
    Expect(1, 10224, '\p{^miscmathsymbolsa}', "");
    Expect(1, 10224, '\P{miscmathsymbolsa}', "");
    Expect(0, 10224, '\P{^miscmathsymbolsa}', "");
    Expect(1, 10223, '\p{--MISC_Math_Symbols_A}', "");
    Expect(0, 10223, '\p{^--MISC_Math_Symbols_A}', "");
    Expect(0, 10223, '\P{--MISC_Math_Symbols_A}', "");
    Expect(1, 10223, '\P{^--MISC_Math_Symbols_A}', "");
    Expect(0, 10224, '\p{--MISC_Math_Symbols_A}', "");
    Expect(1, 10224, '\p{^--MISC_Math_Symbols_A}', "");
    Expect(1, 10224, '\P{--MISC_Math_Symbols_A}', "");
    Expect(0, 10224, '\P{^--MISC_Math_Symbols_A}', "");
    Error('\p{--Is_MISC_Math_symbols_A:=}');
    Error('\P{--Is_MISC_Math_symbols_A:=}');
    Expect(1, 10223, '\p{ismiscmathsymbolsa}', "");
    Expect(0, 10223, '\p{^ismiscmathsymbolsa}', "");
    Expect(0, 10223, '\P{ismiscmathsymbolsa}', "");
    Expect(1, 10223, '\P{^ismiscmathsymbolsa}', "");
    Expect(0, 10224, '\p{ismiscmathsymbolsa}', "");
    Expect(1, 10224, '\p{^ismiscmathsymbolsa}', "");
    Expect(1, 10224, '\P{ismiscmathsymbolsa}', "");
    Expect(0, 10224, '\P{^ismiscmathsymbolsa}', "");
    Expect(1, 10223, '\p{--Is_MISC_math_Symbols_A}', "");
    Expect(0, 10223, '\p{^--Is_MISC_math_Symbols_A}', "");
    Expect(0, 10223, '\P{--Is_MISC_math_Symbols_A}', "");
    Expect(1, 10223, '\P{^--Is_MISC_math_Symbols_A}', "");
    Expect(0, 10224, '\p{--Is_MISC_math_Symbols_A}', "");
    Expect(1, 10224, '\p{^--Is_MISC_math_Symbols_A}', "");
    Expect(1, 10224, '\P{--Is_MISC_math_Symbols_A}', "");
    Expect(0, 10224, '\P{^--Is_MISC_math_Symbols_A}', "");
    Error('\p{:=_In_MISC_Math_Symbols_A}');
    Error('\P{:=_In_MISC_Math_Symbols_A}');
    Expect(1, 10223, '\p{inmiscmathsymbolsa}', "");
    Expect(0, 10223, '\p{^inmiscmathsymbolsa}', "");
    Expect(0, 10223, '\P{inmiscmathsymbolsa}', "");
    Expect(1, 10223, '\P{^inmiscmathsymbolsa}', "");
    Expect(0, 10224, '\p{inmiscmathsymbolsa}', "");
    Expect(1, 10224, '\p{^inmiscmathsymbolsa}', "");
    Expect(1, 10224, '\P{inmiscmathsymbolsa}', "");
    Expect(0, 10224, '\P{^inmiscmathsymbolsa}', "");
    Expect(1, 10223, '\p{ in_MISC_math_symbols_A}', "");
    Expect(0, 10223, '\p{^ in_MISC_math_symbols_A}', "");
    Expect(0, 10223, '\P{ in_MISC_math_symbols_A}', "");
    Expect(1, 10223, '\P{^ in_MISC_math_symbols_A}', "");
    Expect(0, 10224, '\p{ in_MISC_math_symbols_A}', "");
    Expect(1, 10224, '\p{^ in_MISC_math_symbols_A}', "");
    Expect(1, 10224, '\P{ in_MISC_math_symbols_A}', "");
    Expect(0, 10224, '\P{^ in_MISC_math_symbols_A}', "");
    Error('\p{ miscellaneous_MATHEMATICAL_symbols_b:=}');
    Error('\P{ miscellaneous_MATHEMATICAL_symbols_b:=}');
    Expect(1, 10751, '\p{miscellaneousmathematicalsymbolsb}', "");
    Expect(0, 10751, '\p{^miscellaneousmathematicalsymbolsb}', "");
    Expect(0, 10751, '\P{miscellaneousmathematicalsymbolsb}', "");
    Expect(1, 10751, '\P{^miscellaneousmathematicalsymbolsb}', "");
    Expect(0, 10752, '\p{miscellaneousmathematicalsymbolsb}', "");
    Expect(1, 10752, '\p{^miscellaneousmathematicalsymbolsb}', "");
    Expect(1, 10752, '\P{miscellaneousmathematicalsymbolsb}', "");
    Expect(0, 10752, '\P{^miscellaneousmathematicalsymbolsb}', "");
    Expect(1, 10751, '\p{	MISCELLANEOUS_mathematical_Symbols_b}', "");
    Expect(0, 10751, '\p{^	MISCELLANEOUS_mathematical_Symbols_b}', "");
    Expect(0, 10751, '\P{	MISCELLANEOUS_mathematical_Symbols_b}', "");
    Expect(1, 10751, '\P{^	MISCELLANEOUS_mathematical_Symbols_b}', "");
    Expect(0, 10752, '\p{	MISCELLANEOUS_mathematical_Symbols_b}', "");
    Expect(1, 10752, '\p{^	MISCELLANEOUS_mathematical_Symbols_b}', "");
    Expect(1, 10752, '\P{	MISCELLANEOUS_mathematical_Symbols_b}', "");
    Expect(0, 10752, '\P{^	MISCELLANEOUS_mathematical_Symbols_b}', "");
    Error('\p{/a/-_Is_Miscellaneous_MATHEMATICAL_Symbols_b}');
    Error('\P{/a/-_Is_Miscellaneous_MATHEMATICAL_Symbols_b}');
    Expect(1, 10751, '\p{ismiscellaneousmathematicalsymbolsb}', "");
    Expect(0, 10751, '\p{^ismiscellaneousmathematicalsymbolsb}', "");
    Expect(0, 10751, '\P{ismiscellaneousmathematicalsymbolsb}', "");
    Expect(1, 10751, '\P{^ismiscellaneousmathematicalsymbolsb}', "");
    Expect(0, 10752, '\p{ismiscellaneousmathematicalsymbolsb}', "");
    Expect(1, 10752, '\p{^ismiscellaneousmathematicalsymbolsb}', "");
    Expect(1, 10752, '\P{ismiscellaneousmathematicalsymbolsb}', "");
    Expect(0, 10752, '\P{^ismiscellaneousmathematicalsymbolsb}', "");
    Expect(1, 10751, '\p{_-Is_MISCELLANEOUS_Mathematical_SYMBOLS_B}', "");
    Expect(0, 10751, '\p{^_-Is_MISCELLANEOUS_Mathematical_SYMBOLS_B}', "");
    Expect(0, 10751, '\P{_-Is_MISCELLANEOUS_Mathematical_SYMBOLS_B}', "");
    Expect(1, 10751, '\P{^_-Is_MISCELLANEOUS_Mathematical_SYMBOLS_B}', "");
    Expect(0, 10752, '\p{_-Is_MISCELLANEOUS_Mathematical_SYMBOLS_B}', "");
    Expect(1, 10752, '\p{^_-Is_MISCELLANEOUS_Mathematical_SYMBOLS_B}', "");
    Expect(1, 10752, '\P{_-Is_MISCELLANEOUS_Mathematical_SYMBOLS_B}', "");
    Expect(0, 10752, '\P{^_-Is_MISCELLANEOUS_Mathematical_SYMBOLS_B}', "");
    Error('\p{_:=In_MISCELLANEOUS_mathematical_Symbols_B}');
    Error('\P{_:=In_MISCELLANEOUS_mathematical_Symbols_B}');
    Expect(1, 10751, '\p{inmiscellaneousmathematicalsymbolsb}', "");
    Expect(0, 10751, '\p{^inmiscellaneousmathematicalsymbolsb}', "");
    Expect(0, 10751, '\P{inmiscellaneousmathematicalsymbolsb}', "");
    Expect(1, 10751, '\P{^inmiscellaneousmathematicalsymbolsb}', "");
    Expect(0, 10752, '\p{inmiscellaneousmathematicalsymbolsb}', "");
    Expect(1, 10752, '\p{^inmiscellaneousmathematicalsymbolsb}', "");
    Expect(1, 10752, '\P{inmiscellaneousmathematicalsymbolsb}', "");
    Expect(0, 10752, '\P{^inmiscellaneousmathematicalsymbolsb}', "");
    Expect(1, 10751, '\p{ In_Miscellaneous_mathematical_symbols_B}', "");
    Expect(0, 10751, '\p{^ In_Miscellaneous_mathematical_symbols_B}', "");
    Expect(0, 10751, '\P{ In_Miscellaneous_mathematical_symbols_B}', "");
    Expect(1, 10751, '\P{^ In_Miscellaneous_mathematical_symbols_B}', "");
    Expect(0, 10752, '\p{ In_Miscellaneous_mathematical_symbols_B}', "");
    Expect(1, 10752, '\p{^ In_Miscellaneous_mathematical_symbols_B}', "");
    Expect(1, 10752, '\P{ In_Miscellaneous_mathematical_symbols_B}', "");
    Expect(0, 10752, '\P{^ In_Miscellaneous_mathematical_symbols_B}', "");
    Error('\p{/a/ Misc_MATH_Symbols_B}');
    Error('\P{/a/ Misc_MATH_Symbols_B}');
    Expect(1, 10751, '\p{miscmathsymbolsb}', "");
    Expect(0, 10751, '\p{^miscmathsymbolsb}', "");
    Expect(0, 10751, '\P{miscmathsymbolsb}', "");
    Expect(1, 10751, '\P{^miscmathsymbolsb}', "");
    Expect(0, 10752, '\p{miscmathsymbolsb}', "");
    Expect(1, 10752, '\p{^miscmathsymbolsb}', "");
    Expect(1, 10752, '\P{miscmathsymbolsb}', "");
    Expect(0, 10752, '\P{^miscmathsymbolsb}', "");
    Expect(1, 10751, '\p{	_misc_math_symbols_B}', "");
    Expect(0, 10751, '\p{^	_misc_math_symbols_B}', "");
    Expect(0, 10751, '\P{	_misc_math_symbols_B}', "");
    Expect(1, 10751, '\P{^	_misc_math_symbols_B}', "");
    Expect(0, 10752, '\p{	_misc_math_symbols_B}', "");
    Expect(1, 10752, '\p{^	_misc_math_symbols_B}', "");
    Expect(1, 10752, '\P{	_misc_math_symbols_B}', "");
    Expect(0, 10752, '\P{^	_misc_math_symbols_B}', "");
    Error('\p{/a/	 Is_MISC_Math_Symbols_B}');
    Error('\P{/a/	 Is_MISC_Math_Symbols_B}');
    Expect(1, 10751, '\p{ismiscmathsymbolsb}', "");
    Expect(0, 10751, '\p{^ismiscmathsymbolsb}', "");
    Expect(0, 10751, '\P{ismiscmathsymbolsb}', "");
    Expect(1, 10751, '\P{^ismiscmathsymbolsb}', "");
    Expect(0, 10752, '\p{ismiscmathsymbolsb}', "");
    Expect(1, 10752, '\p{^ismiscmathsymbolsb}', "");
    Expect(1, 10752, '\P{ismiscmathsymbolsb}', "");
    Expect(0, 10752, '\P{^ismiscmathsymbolsb}', "");
    Expect(1, 10751, '\p{	IS_Misc_Math_symbols_B}', "");
    Expect(0, 10751, '\p{^	IS_Misc_Math_symbols_B}', "");
    Expect(0, 10751, '\P{	IS_Misc_Math_symbols_B}', "");
    Expect(1, 10751, '\P{^	IS_Misc_Math_symbols_B}', "");
    Expect(0, 10752, '\p{	IS_Misc_Math_symbols_B}', "");
    Expect(1, 10752, '\p{^	IS_Misc_Math_symbols_B}', "");
    Expect(1, 10752, '\P{	IS_Misc_Math_symbols_B}', "");
    Expect(0, 10752, '\P{^	IS_Misc_Math_symbols_B}', "");
    Error('\p{_In_Misc_math_Symbols_B:=}');
    Error('\P{_In_Misc_math_Symbols_B:=}');
    Expect(1, 10751, '\p{inmiscmathsymbolsb}', "");
    Expect(0, 10751, '\p{^inmiscmathsymbolsb}', "");
    Expect(0, 10751, '\P{inmiscmathsymbolsb}', "");
    Expect(1, 10751, '\P{^inmiscmathsymbolsb}', "");
    Expect(0, 10752, '\p{inmiscmathsymbolsb}', "");
    Expect(1, 10752, '\p{^inmiscmathsymbolsb}', "");
    Expect(1, 10752, '\P{inmiscmathsymbolsb}', "");
    Expect(0, 10752, '\P{^inmiscmathsymbolsb}', "");
    Expect(1, 10751, '\p{_ IN_misc_Math_Symbols_B}', "");
    Expect(0, 10751, '\p{^_ IN_misc_Math_Symbols_B}', "");
    Expect(0, 10751, '\P{_ IN_misc_Math_Symbols_B}', "");
    Expect(1, 10751, '\P{^_ IN_misc_Math_Symbols_B}', "");
    Expect(0, 10752, '\p{_ IN_misc_Math_Symbols_B}', "");
    Expect(1, 10752, '\p{^_ IN_misc_Math_Symbols_B}', "");
    Expect(1, 10752, '\P{_ IN_misc_Math_Symbols_B}', "");
    Expect(0, 10752, '\P{^_ IN_misc_Math_Symbols_B}', "");
    Error('\p{:=-_Miscellaneous_Symbols}');
    Error('\P{:=-_Miscellaneous_Symbols}');
    Expect(1, 9983, '\p{miscellaneoussymbols}', "");
    Expect(0, 9983, '\p{^miscellaneoussymbols}', "");
    Expect(0, 9983, '\P{miscellaneoussymbols}', "");
    Expect(1, 9983, '\P{^miscellaneoussymbols}', "");
    Expect(0, 9984, '\p{miscellaneoussymbols}', "");
    Expect(1, 9984, '\p{^miscellaneoussymbols}', "");
    Expect(1, 9984, '\P{miscellaneoussymbols}', "");
    Expect(0, 9984, '\P{^miscellaneoussymbols}', "");
    Expect(1, 9983, '\p{_Miscellaneous_SYMBOLS}', "");
    Expect(0, 9983, '\p{^_Miscellaneous_SYMBOLS}', "");
    Expect(0, 9983, '\P{_Miscellaneous_SYMBOLS}', "");
    Expect(1, 9983, '\P{^_Miscellaneous_SYMBOLS}', "");
    Expect(0, 9984, '\p{_Miscellaneous_SYMBOLS}', "");
    Expect(1, 9984, '\p{^_Miscellaneous_SYMBOLS}', "");
    Expect(1, 9984, '\P{_Miscellaneous_SYMBOLS}', "");
    Expect(0, 9984, '\P{^_Miscellaneous_SYMBOLS}', "");
    Error('\p{-_Is_Miscellaneous_Symbols:=}');
    Error('\P{-_Is_Miscellaneous_Symbols:=}');
    Expect(1, 9983, '\p{ismiscellaneoussymbols}', "");
    Expect(0, 9983, '\p{^ismiscellaneoussymbols}', "");
    Expect(0, 9983, '\P{ismiscellaneoussymbols}', "");
    Expect(1, 9983, '\P{^ismiscellaneoussymbols}', "");
    Expect(0, 9984, '\p{ismiscellaneoussymbols}', "");
    Expect(1, 9984, '\p{^ismiscellaneoussymbols}', "");
    Expect(1, 9984, '\P{ismiscellaneoussymbols}', "");
    Expect(0, 9984, '\P{^ismiscellaneoussymbols}', "");
    Expect(1, 9983, '\p{	_IS_Miscellaneous_symbols}', "");
    Expect(0, 9983, '\p{^	_IS_Miscellaneous_symbols}', "");
    Expect(0, 9983, '\P{	_IS_Miscellaneous_symbols}', "");
    Expect(1, 9983, '\P{^	_IS_Miscellaneous_symbols}', "");
    Expect(0, 9984, '\p{	_IS_Miscellaneous_symbols}', "");
    Expect(1, 9984, '\p{^	_IS_Miscellaneous_symbols}', "");
    Expect(1, 9984, '\P{	_IS_Miscellaneous_symbols}', "");
    Expect(0, 9984, '\P{^	_IS_Miscellaneous_symbols}', "");
    Error('\p{/a/_in_Miscellaneous_Symbols}');
    Error('\P{/a/_in_Miscellaneous_Symbols}');
    Expect(1, 9983, '\p{inmiscellaneoussymbols}', "");
    Expect(0, 9983, '\p{^inmiscellaneoussymbols}', "");
    Expect(0, 9983, '\P{inmiscellaneoussymbols}', "");
    Expect(1, 9983, '\P{^inmiscellaneoussymbols}', "");
    Expect(0, 9984, '\p{inmiscellaneoussymbols}', "");
    Expect(1, 9984, '\p{^inmiscellaneoussymbols}', "");
    Expect(1, 9984, '\P{inmiscellaneoussymbols}', "");
    Expect(0, 9984, '\P{^inmiscellaneoussymbols}', "");
    Expect(1, 9983, '\p{-in_MISCELLANEOUS_symbols}', "");
    Expect(0, 9983, '\p{^-in_MISCELLANEOUS_symbols}', "");
    Expect(0, 9983, '\P{-in_MISCELLANEOUS_symbols}', "");
    Expect(1, 9983, '\P{^-in_MISCELLANEOUS_symbols}', "");
    Expect(0, 9984, '\p{-in_MISCELLANEOUS_symbols}', "");
    Expect(1, 9984, '\p{^-in_MISCELLANEOUS_symbols}', "");
    Expect(1, 9984, '\P{-in_MISCELLANEOUS_symbols}', "");
    Expect(0, 9984, '\P{^-in_MISCELLANEOUS_symbols}', "");
    Error('\p{/a/-MISC_Symbols}');
    Error('\P{/a/-MISC_Symbols}');
    Expect(1, 9983, '\p{miscsymbols}', "");
    Expect(0, 9983, '\p{^miscsymbols}', "");
    Expect(0, 9983, '\P{miscsymbols}', "");
    Expect(1, 9983, '\P{^miscsymbols}', "");
    Expect(0, 9984, '\p{miscsymbols}', "");
    Expect(1, 9984, '\p{^miscsymbols}', "");
    Expect(1, 9984, '\P{miscsymbols}', "");
    Expect(0, 9984, '\P{^miscsymbols}', "");
    Expect(1, 9983, '\p{ Misc_Symbols}', "");
    Expect(0, 9983, '\p{^ Misc_Symbols}', "");
    Expect(0, 9983, '\P{ Misc_Symbols}', "");
    Expect(1, 9983, '\P{^ Misc_Symbols}', "");
    Expect(0, 9984, '\p{ Misc_Symbols}', "");
    Expect(1, 9984, '\p{^ Misc_Symbols}', "");
    Expect(1, 9984, '\P{ Misc_Symbols}', "");
    Expect(0, 9984, '\P{^ Misc_Symbols}', "");
    Error('\p{_/a/IS_MISC_symbols}');
    Error('\P{_/a/IS_MISC_symbols}');
    Expect(1, 9983, '\p{ismiscsymbols}', "");
    Expect(0, 9983, '\p{^ismiscsymbols}', "");
    Expect(0, 9983, '\P{ismiscsymbols}', "");
    Expect(1, 9983, '\P{^ismiscsymbols}', "");
    Expect(0, 9984, '\p{ismiscsymbols}', "");
    Expect(1, 9984, '\p{^ismiscsymbols}', "");
    Expect(1, 9984, '\P{ismiscsymbols}', "");
    Expect(0, 9984, '\P{^ismiscsymbols}', "");
    Expect(1, 9983, '\p{- Is_Misc_symbols}', "");
    Expect(0, 9983, '\p{^- Is_Misc_symbols}', "");
    Expect(0, 9983, '\P{- Is_Misc_symbols}', "");
    Expect(1, 9983, '\P{^- Is_Misc_symbols}', "");
    Expect(0, 9984, '\p{- Is_Misc_symbols}', "");
    Expect(1, 9984, '\p{^- Is_Misc_symbols}', "");
    Expect(1, 9984, '\P{- Is_Misc_symbols}', "");
    Expect(0, 9984, '\P{^- Is_Misc_symbols}', "");
    Error('\p{ In_Misc_symbols/a/}');
    Error('\P{ In_Misc_symbols/a/}');
    Expect(1, 9983, '\p{inmiscsymbols}', "");
    Expect(0, 9983, '\p{^inmiscsymbols}', "");
    Expect(0, 9983, '\P{inmiscsymbols}', "");
    Expect(1, 9983, '\P{^inmiscsymbols}', "");
    Expect(0, 9984, '\p{inmiscsymbols}', "");
    Expect(1, 9984, '\p{^inmiscsymbols}', "");
    Expect(1, 9984, '\P{inmiscsymbols}', "");
    Expect(0, 9984, '\P{^inmiscsymbols}', "");
    Expect(1, 9983, '\p{		In_Misc_SYMBOLS}', "");
    Expect(0, 9983, '\p{^		In_Misc_SYMBOLS}', "");
    Expect(0, 9983, '\P{		In_Misc_SYMBOLS}', "");
    Expect(1, 9983, '\P{^		In_Misc_SYMBOLS}', "");
    Expect(0, 9984, '\p{		In_Misc_SYMBOLS}', "");
    Expect(1, 9984, '\p{^		In_Misc_SYMBOLS}', "");
    Expect(1, 9984, '\P{		In_Misc_SYMBOLS}', "");
    Expect(0, 9984, '\P{^		In_Misc_SYMBOLS}', "");
    Error('\p{ :=Miscellaneous_symbols_and_ARROWS}');
    Error('\P{ :=Miscellaneous_symbols_and_ARROWS}');
    Expect(1, 11263, '\p{miscellaneoussymbolsandarrows}', "");
    Expect(0, 11263, '\p{^miscellaneoussymbolsandarrows}', "");
    Expect(0, 11263, '\P{miscellaneoussymbolsandarrows}', "");
    Expect(1, 11263, '\P{^miscellaneoussymbolsandarrows}', "");
    Expect(0, 11264, '\p{miscellaneoussymbolsandarrows}', "");
    Expect(1, 11264, '\p{^miscellaneoussymbolsandarrows}', "");
    Expect(1, 11264, '\P{miscellaneoussymbolsandarrows}', "");
    Expect(0, 11264, '\P{^miscellaneoussymbolsandarrows}', "");
    Expect(1, 11263, '\p{	_MISCELLANEOUS_Symbols_AND_ARROWS}', "");
    Expect(0, 11263, '\p{^	_MISCELLANEOUS_Symbols_AND_ARROWS}', "");
    Expect(0, 11263, '\P{	_MISCELLANEOUS_Symbols_AND_ARROWS}', "");
    Expect(1, 11263, '\P{^	_MISCELLANEOUS_Symbols_AND_ARROWS}', "");
    Expect(0, 11264, '\p{	_MISCELLANEOUS_Symbols_AND_ARROWS}', "");
    Expect(1, 11264, '\p{^	_MISCELLANEOUS_Symbols_AND_ARROWS}', "");
    Expect(1, 11264, '\P{	_MISCELLANEOUS_Symbols_AND_ARROWS}', "");
    Expect(0, 11264, '\P{^	_MISCELLANEOUS_Symbols_AND_ARROWS}', "");
    Error('\p{/a/ -is_MISCELLANEOUS_Symbols_And_arrows}');
    Error('\P{/a/ -is_MISCELLANEOUS_Symbols_And_arrows}');
    Expect(1, 11263, '\p{ismiscellaneoussymbolsandarrows}', "");
    Expect(0, 11263, '\p{^ismiscellaneoussymbolsandarrows}', "");
    Expect(0, 11263, '\P{ismiscellaneoussymbolsandarrows}', "");
    Expect(1, 11263, '\P{^ismiscellaneoussymbolsandarrows}', "");
    Expect(0, 11264, '\p{ismiscellaneoussymbolsandarrows}', "");
    Expect(1, 11264, '\p{^ismiscellaneoussymbolsandarrows}', "");
    Expect(1, 11264, '\P{ismiscellaneoussymbolsandarrows}', "");
    Expect(0, 11264, '\P{^ismiscellaneoussymbolsandarrows}', "");
    Expect(1, 11263, '\p{	is_Miscellaneous_symbols_AND_ARROWS}', "");
    Expect(0, 11263, '\p{^	is_Miscellaneous_symbols_AND_ARROWS}', "");
    Expect(0, 11263, '\P{	is_Miscellaneous_symbols_AND_ARROWS}', "");
    Expect(1, 11263, '\P{^	is_Miscellaneous_symbols_AND_ARROWS}', "");
    Expect(0, 11264, '\p{	is_Miscellaneous_symbols_AND_ARROWS}', "");
    Expect(1, 11264, '\p{^	is_Miscellaneous_symbols_AND_ARROWS}', "");
    Expect(1, 11264, '\P{	is_Miscellaneous_symbols_AND_ARROWS}', "");
    Expect(0, 11264, '\P{^	is_Miscellaneous_symbols_AND_ARROWS}', "");
    Error('\p{_	In_MISCELLANEOUS_SYMBOLS_AND_arrows:=}');
    Error('\P{_	In_MISCELLANEOUS_SYMBOLS_AND_arrows:=}');
    Expect(1, 11263, '\p{inmiscellaneoussymbolsandarrows}', "");
    Expect(0, 11263, '\p{^inmiscellaneoussymbolsandarrows}', "");
    Expect(0, 11263, '\P{inmiscellaneoussymbolsandarrows}', "");
    Expect(1, 11263, '\P{^inmiscellaneoussymbolsandarrows}', "");
    Expect(0, 11264, '\p{inmiscellaneoussymbolsandarrows}', "");
    Expect(1, 11264, '\p{^inmiscellaneoussymbolsandarrows}', "");
    Expect(1, 11264, '\P{inmiscellaneoussymbolsandarrows}', "");
    Expect(0, 11264, '\P{^inmiscellaneoussymbolsandarrows}', "");
    Expect(1, 11263, '\p{-_IN_MISCELLANEOUS_Symbols_And_Arrows}', "");
    Expect(0, 11263, '\p{^-_IN_MISCELLANEOUS_Symbols_And_Arrows}', "");
    Expect(0, 11263, '\P{-_IN_MISCELLANEOUS_Symbols_And_Arrows}', "");
    Expect(1, 11263, '\P{^-_IN_MISCELLANEOUS_Symbols_And_Arrows}', "");
    Expect(0, 11264, '\p{-_IN_MISCELLANEOUS_Symbols_And_Arrows}', "");
    Expect(1, 11264, '\p{^-_IN_MISCELLANEOUS_Symbols_And_Arrows}', "");
    Expect(1, 11264, '\P{-_IN_MISCELLANEOUS_Symbols_And_Arrows}', "");
    Expect(0, 11264, '\P{^-_IN_MISCELLANEOUS_Symbols_And_Arrows}', "");
    Error('\p{ /a/Misc_ARROWS}');
    Error('\P{ /a/Misc_ARROWS}');
    Expect(1, 11263, '\p{miscarrows}', "");
    Expect(0, 11263, '\p{^miscarrows}', "");
    Expect(0, 11263, '\P{miscarrows}', "");
    Expect(1, 11263, '\P{^miscarrows}', "");
    Expect(0, 11264, '\p{miscarrows}', "");
    Expect(1, 11264, '\p{^miscarrows}', "");
    Expect(1, 11264, '\P{miscarrows}', "");
    Expect(0, 11264, '\P{^miscarrows}', "");
    Expect(1, 11263, '\p{_Misc_Arrows}', "");
    Expect(0, 11263, '\p{^_Misc_Arrows}', "");
    Expect(0, 11263, '\P{_Misc_Arrows}', "");
    Expect(1, 11263, '\P{^_Misc_Arrows}', "");
    Expect(0, 11264, '\p{_Misc_Arrows}', "");
    Expect(1, 11264, '\p{^_Misc_Arrows}', "");
    Expect(1, 11264, '\P{_Misc_Arrows}', "");
    Expect(0, 11264, '\P{^_Misc_Arrows}', "");
    Error('\p{ /a/Is_MISC_arrows}');
    Error('\P{ /a/Is_MISC_arrows}');
    Expect(1, 11263, '\p{ismiscarrows}', "");
    Expect(0, 11263, '\p{^ismiscarrows}', "");
    Expect(0, 11263, '\P{ismiscarrows}', "");
    Expect(1, 11263, '\P{^ismiscarrows}', "");
    Expect(0, 11264, '\p{ismiscarrows}', "");
    Expect(1, 11264, '\p{^ismiscarrows}', "");
    Expect(1, 11264, '\P{ismiscarrows}', "");
    Expect(0, 11264, '\P{^ismiscarrows}', "");
    Expect(1, 11263, '\p{	-Is_MISC_Arrows}', "");
    Expect(0, 11263, '\p{^	-Is_MISC_Arrows}', "");
    Expect(0, 11263, '\P{	-Is_MISC_Arrows}', "");
    Expect(1, 11263, '\P{^	-Is_MISC_Arrows}', "");
    Expect(0, 11264, '\p{	-Is_MISC_Arrows}', "");
    Expect(1, 11264, '\p{^	-Is_MISC_Arrows}', "");
    Expect(1, 11264, '\P{	-Is_MISC_Arrows}', "");
    Expect(0, 11264, '\P{^	-Is_MISC_Arrows}', "");
    Error('\p{-_In_MISC_ARROWS:=}');
    Error('\P{-_In_MISC_ARROWS:=}');
    Expect(1, 11263, '\p{inmiscarrows}', "");
    Expect(0, 11263, '\p{^inmiscarrows}', "");
    Expect(0, 11263, '\P{inmiscarrows}', "");
    Expect(1, 11263, '\P{^inmiscarrows}', "");
    Expect(0, 11264, '\p{inmiscarrows}', "");
    Expect(1, 11264, '\p{^inmiscarrows}', "");
    Expect(1, 11264, '\P{inmiscarrows}', "");
    Expect(0, 11264, '\P{^inmiscarrows}', "");
    Expect(1, 11263, '\p{	In_Misc_Arrows}', "");
    Expect(0, 11263, '\p{^	In_Misc_Arrows}', "");
    Expect(0, 11263, '\P{	In_Misc_Arrows}', "");
    Expect(1, 11263, '\P{^	In_Misc_Arrows}', "");
    Expect(0, 11264, '\p{	In_Misc_Arrows}', "");
    Expect(1, 11264, '\p{^	In_Misc_Arrows}', "");
    Expect(1, 11264, '\P{	In_Misc_Arrows}', "");
    Expect(0, 11264, '\P{^	In_Misc_Arrows}', "");
    Error('\p{/a/ Miscellaneous_symbols_and_PICTOGRAPHS}');
    Error('\P{/a/ Miscellaneous_symbols_and_PICTOGRAPHS}');
    Expect(1, 128511, '\p{miscellaneoussymbolsandpictographs}', "");
    Expect(0, 128511, '\p{^miscellaneoussymbolsandpictographs}', "");
    Expect(0, 128511, '\P{miscellaneoussymbolsandpictographs}', "");
    Expect(1, 128511, '\P{^miscellaneoussymbolsandpictographs}', "");
    Expect(0, 128512, '\p{miscellaneoussymbolsandpictographs}', "");
    Expect(1, 128512, '\p{^miscellaneoussymbolsandpictographs}', "");
    Expect(1, 128512, '\P{miscellaneoussymbolsandpictographs}', "");
    Expect(0, 128512, '\P{^miscellaneoussymbolsandpictographs}', "");
    Expect(1, 128511, '\p{	_Miscellaneous_symbols_and_Pictographs}', "");
    Expect(0, 128511, '\p{^	_Miscellaneous_symbols_and_Pictographs}', "");
    Expect(0, 128511, '\P{	_Miscellaneous_symbols_and_Pictographs}', "");
    Expect(1, 128511, '\P{^	_Miscellaneous_symbols_and_Pictographs}', "");
    Expect(0, 128512, '\p{	_Miscellaneous_symbols_and_Pictographs}', "");
    Expect(1, 128512, '\p{^	_Miscellaneous_symbols_and_Pictographs}', "");
    Expect(1, 128512, '\P{	_Miscellaneous_symbols_and_Pictographs}', "");
    Expect(0, 128512, '\P{^	_Miscellaneous_symbols_and_Pictographs}', "");
    Error('\p{-/a/Is_MISCELLANEOUS_symbols_and_Pictographs}');
    Error('\P{-/a/Is_MISCELLANEOUS_symbols_and_Pictographs}');
    Expect(1, 128511, '\p{ismiscellaneoussymbolsandpictographs}', "");
    Expect(0, 128511, '\p{^ismiscellaneoussymbolsandpictographs}', "");
    Expect(0, 128511, '\P{ismiscellaneoussymbolsandpictographs}', "");
    Expect(1, 128511, '\P{^ismiscellaneoussymbolsandpictographs}', "");
    Expect(0, 128512, '\p{ismiscellaneoussymbolsandpictographs}', "");
    Expect(1, 128512, '\p{^ismiscellaneoussymbolsandpictographs}', "");
    Expect(1, 128512, '\P{ismiscellaneoussymbolsandpictographs}', "");
    Expect(0, 128512, '\P{^ismiscellaneoussymbolsandpictographs}', "");
    Expect(1, 128511, '\p{ 	is_Miscellaneous_Symbols_And_Pictographs}', "");
    Expect(0, 128511, '\p{^ 	is_Miscellaneous_Symbols_And_Pictographs}', "");
    Expect(0, 128511, '\P{ 	is_Miscellaneous_Symbols_And_Pictographs}', "");
    Expect(1, 128511, '\P{^ 	is_Miscellaneous_Symbols_And_Pictographs}', "");
    Expect(0, 128512, '\p{ 	is_Miscellaneous_Symbols_And_Pictographs}', "");
    Expect(1, 128512, '\p{^ 	is_Miscellaneous_Symbols_And_Pictographs}', "");
    Expect(1, 128512, '\P{ 	is_Miscellaneous_Symbols_And_Pictographs}', "");
    Expect(0, 128512, '\P{^ 	is_Miscellaneous_Symbols_And_Pictographs}', "");
    Error('\p{-/a/In_MISCELLANEOUS_Symbols_And_Pictographs}');
    Error('\P{-/a/In_MISCELLANEOUS_Symbols_And_Pictographs}');
    Expect(1, 128511, '\p{inmiscellaneoussymbolsandpictographs}', "");
    Expect(0, 128511, '\p{^inmiscellaneoussymbolsandpictographs}', "");
    Expect(0, 128511, '\P{inmiscellaneoussymbolsandpictographs}', "");
    Expect(1, 128511, '\P{^inmiscellaneoussymbolsandpictographs}', "");
    Expect(0, 128512, '\p{inmiscellaneoussymbolsandpictographs}', "");
    Expect(1, 128512, '\p{^inmiscellaneoussymbolsandpictographs}', "");
    Expect(1, 128512, '\P{inmiscellaneoussymbolsandpictographs}', "");
    Expect(0, 128512, '\P{^inmiscellaneoussymbolsandpictographs}', "");
    Expect(1, 128511, '\p{_In_miscellaneous_Symbols_And_PICTOGRAPHS}', "");
    Expect(0, 128511, '\p{^_In_miscellaneous_Symbols_And_PICTOGRAPHS}', "");
    Expect(0, 128511, '\P{_In_miscellaneous_Symbols_And_PICTOGRAPHS}', "");
    Expect(1, 128511, '\P{^_In_miscellaneous_Symbols_And_PICTOGRAPHS}', "");
    Expect(0, 128512, '\p{_In_miscellaneous_Symbols_And_PICTOGRAPHS}', "");
    Expect(1, 128512, '\p{^_In_miscellaneous_Symbols_And_PICTOGRAPHS}', "");
    Expect(1, 128512, '\P{_In_miscellaneous_Symbols_And_PICTOGRAPHS}', "");
    Expect(0, 128512, '\P{^_In_miscellaneous_Symbols_And_PICTOGRAPHS}', "");
    Error('\p{ 	MISC_pictographs/a/}');
    Error('\P{ 	MISC_pictographs/a/}');
    Expect(1, 128511, '\p{miscpictographs}', "");
    Expect(0, 128511, '\p{^miscpictographs}', "");
    Expect(0, 128511, '\P{miscpictographs}', "");
    Expect(1, 128511, '\P{^miscpictographs}', "");
    Expect(0, 128512, '\p{miscpictographs}', "");
    Expect(1, 128512, '\p{^miscpictographs}', "");
    Expect(1, 128512, '\P{miscpictographs}', "");
    Expect(0, 128512, '\P{^miscpictographs}', "");
    Expect(1, 128511, '\p{	-misc_pictographs}', "");
    Expect(0, 128511, '\p{^	-misc_pictographs}', "");
    Expect(0, 128511, '\P{	-misc_pictographs}', "");
    Expect(1, 128511, '\P{^	-misc_pictographs}', "");
    Expect(0, 128512, '\p{	-misc_pictographs}', "");
    Expect(1, 128512, '\p{^	-misc_pictographs}', "");
    Expect(1, 128512, '\P{	-misc_pictographs}', "");
    Expect(0, 128512, '\P{^	-misc_pictographs}', "");
    Error('\p{-/a/IS_misc_Pictographs}');
    Error('\P{-/a/IS_misc_Pictographs}');
    Expect(1, 128511, '\p{ismiscpictographs}', "");
    Expect(0, 128511, '\p{^ismiscpictographs}', "");
    Expect(0, 128511, '\P{ismiscpictographs}', "");
    Expect(1, 128511, '\P{^ismiscpictographs}', "");
    Expect(0, 128512, '\p{ismiscpictographs}', "");
    Expect(1, 128512, '\p{^ismiscpictographs}', "");
    Expect(1, 128512, '\P{ismiscpictographs}', "");
    Expect(0, 128512, '\P{^ismiscpictographs}', "");
    Expect(1, 128511, '\p{- Is_Misc_pictographs}', "");
    Expect(0, 128511, '\p{^- Is_Misc_pictographs}', "");
    Expect(0, 128511, '\P{- Is_Misc_pictographs}', "");
    Expect(1, 128511, '\P{^- Is_Misc_pictographs}', "");
    Expect(0, 128512, '\p{- Is_Misc_pictographs}', "");
    Expect(1, 128512, '\p{^- Is_Misc_pictographs}', "");
    Expect(1, 128512, '\P{- Is_Misc_pictographs}', "");
    Expect(0, 128512, '\P{^- Is_Misc_pictographs}', "");
    Error('\p{__In_Misc_pictographs/a/}');
    Error('\P{__In_Misc_pictographs/a/}');
    Expect(1, 128511, '\p{inmiscpictographs}', "");
    Expect(0, 128511, '\p{^inmiscpictographs}', "");
    Expect(0, 128511, '\P{inmiscpictographs}', "");
    Expect(1, 128511, '\P{^inmiscpictographs}', "");
    Expect(0, 128512, '\p{inmiscpictographs}', "");
    Expect(1, 128512, '\p{^inmiscpictographs}', "");
    Expect(1, 128512, '\P{inmiscpictographs}', "");
    Expect(0, 128512, '\P{^inmiscpictographs}', "");
    Expect(1, 128511, '\p{  in_Misc_PICTOGRAPHS}', "");
    Expect(0, 128511, '\p{^  in_Misc_PICTOGRAPHS}', "");
    Expect(0, 128511, '\P{  in_Misc_PICTOGRAPHS}', "");
    Expect(1, 128511, '\P{^  in_Misc_PICTOGRAPHS}', "");
    Expect(0, 128512, '\p{  in_Misc_PICTOGRAPHS}', "");
    Expect(1, 128512, '\p{^  in_Misc_PICTOGRAPHS}', "");
    Expect(1, 128512, '\P{  in_Misc_PICTOGRAPHS}', "");
    Expect(0, 128512, '\P{^  in_Misc_PICTOGRAPHS}', "");
    Error('\p{/a/	 MISCELLANEOUS_Technical}');
    Error('\P{/a/	 MISCELLANEOUS_Technical}');
    Expect(1, 9215, '\p{miscellaneoustechnical}', "");
    Expect(0, 9215, '\p{^miscellaneoustechnical}', "");
    Expect(0, 9215, '\P{miscellaneoustechnical}', "");
    Expect(1, 9215, '\P{^miscellaneoustechnical}', "");
    Expect(0, 9216, '\p{miscellaneoustechnical}', "");
    Expect(1, 9216, '\p{^miscellaneoustechnical}', "");
    Expect(1, 9216, '\P{miscellaneoustechnical}', "");
    Expect(0, 9216, '\P{^miscellaneoustechnical}', "");
    Expect(1, 9215, '\p{	Miscellaneous_TECHNICAL}', "");
    Expect(0, 9215, '\p{^	Miscellaneous_TECHNICAL}', "");
    Expect(0, 9215, '\P{	Miscellaneous_TECHNICAL}', "");
    Expect(1, 9215, '\P{^	Miscellaneous_TECHNICAL}', "");
    Expect(0, 9216, '\p{	Miscellaneous_TECHNICAL}', "");
    Expect(1, 9216, '\p{^	Miscellaneous_TECHNICAL}', "");
    Expect(1, 9216, '\P{	Miscellaneous_TECHNICAL}', "");
    Expect(0, 9216, '\P{^	Miscellaneous_TECHNICAL}', "");
    Error('\p{:=is_MISCELLANEOUS_technical}');
    Error('\P{:=is_MISCELLANEOUS_technical}');
    Expect(1, 9215, '\p{ismiscellaneoustechnical}', "");
    Expect(0, 9215, '\p{^ismiscellaneoustechnical}', "");
    Expect(0, 9215, '\P{ismiscellaneoustechnical}', "");
    Expect(1, 9215, '\P{^ismiscellaneoustechnical}', "");
    Expect(0, 9216, '\p{ismiscellaneoustechnical}', "");
    Expect(1, 9216, '\p{^ismiscellaneoustechnical}', "");
    Expect(1, 9216, '\P{ismiscellaneoustechnical}', "");
    Expect(0, 9216, '\P{^ismiscellaneoustechnical}', "");
    Expect(1, 9215, '\p{_	Is_Miscellaneous_Technical}', "");
    Expect(0, 9215, '\p{^_	Is_Miscellaneous_Technical}', "");
    Expect(0, 9215, '\P{_	Is_Miscellaneous_Technical}', "");
    Expect(1, 9215, '\P{^_	Is_Miscellaneous_Technical}', "");
    Expect(0, 9216, '\p{_	Is_Miscellaneous_Technical}', "");
    Expect(1, 9216, '\p{^_	Is_Miscellaneous_Technical}', "");
    Expect(1, 9216, '\P{_	Is_Miscellaneous_Technical}', "");
    Expect(0, 9216, '\P{^_	Is_Miscellaneous_Technical}', "");
    Error('\p{ :=In_Miscellaneous_technical}');
    Error('\P{ :=In_Miscellaneous_technical}');
    Expect(1, 9215, '\p{inmiscellaneoustechnical}', "");
    Expect(0, 9215, '\p{^inmiscellaneoustechnical}', "");
    Expect(0, 9215, '\P{inmiscellaneoustechnical}', "");
    Expect(1, 9215, '\P{^inmiscellaneoustechnical}', "");
    Expect(0, 9216, '\p{inmiscellaneoustechnical}', "");
    Expect(1, 9216, '\p{^inmiscellaneoustechnical}', "");
    Expect(1, 9216, '\P{inmiscellaneoustechnical}', "");
    Expect(0, 9216, '\P{^inmiscellaneoustechnical}', "");
    Expect(1, 9215, '\p{-In_miscellaneous_Technical}', "");
    Expect(0, 9215, '\p{^-In_miscellaneous_Technical}', "");
    Expect(0, 9215, '\P{-In_miscellaneous_Technical}', "");
    Expect(1, 9215, '\P{^-In_miscellaneous_Technical}', "");
    Expect(0, 9216, '\p{-In_miscellaneous_Technical}', "");
    Expect(1, 9216, '\p{^-In_miscellaneous_Technical}', "");
    Expect(1, 9216, '\P{-In_miscellaneous_Technical}', "");
    Expect(0, 9216, '\P{^-In_miscellaneous_Technical}', "");
    Error('\p{ /a/misc_Technical}');
    Error('\P{ /a/misc_Technical}');
    Expect(1, 9215, '\p{misctechnical}', "");
    Expect(0, 9215, '\p{^misctechnical}', "");
    Expect(0, 9215, '\P{misctechnical}', "");
    Expect(1, 9215, '\P{^misctechnical}', "");
    Expect(0, 9216, '\p{misctechnical}', "");
    Expect(1, 9216, '\p{^misctechnical}', "");
    Expect(1, 9216, '\P{misctechnical}', "");
    Expect(0, 9216, '\P{^misctechnical}', "");
    Expect(1, 9215, '\p{  Misc_technical}', "");
    Expect(0, 9215, '\p{^  Misc_technical}', "");
    Expect(0, 9215, '\P{  Misc_technical}', "");
    Expect(1, 9215, '\P{^  Misc_technical}', "");
    Expect(0, 9216, '\p{  Misc_technical}', "");
    Expect(1, 9216, '\p{^  Misc_technical}', "");
    Expect(1, 9216, '\P{  Misc_technical}', "");
    Expect(0, 9216, '\P{^  Misc_technical}', "");
    Error('\p{_Is_Misc_Technical:=}');
    Error('\P{_Is_Misc_Technical:=}');
    Expect(1, 9215, '\p{ismisctechnical}', "");
    Expect(0, 9215, '\p{^ismisctechnical}', "");
    Expect(0, 9215, '\P{ismisctechnical}', "");
    Expect(1, 9215, '\P{^ismisctechnical}', "");
    Expect(0, 9216, '\p{ismisctechnical}', "");
    Expect(1, 9216, '\p{^ismisctechnical}', "");
    Expect(1, 9216, '\P{ismisctechnical}', "");
    Expect(0, 9216, '\P{^ismisctechnical}', "");
    Expect(1, 9215, '\p{  is_misc_technical}', "");
    Expect(0, 9215, '\p{^  is_misc_technical}', "");
    Expect(0, 9215, '\P{  is_misc_technical}', "");
    Expect(1, 9215, '\P{^  is_misc_technical}', "");
    Expect(0, 9216, '\p{  is_misc_technical}', "");
    Expect(1, 9216, '\p{^  is_misc_technical}', "");
    Expect(1, 9216, '\P{  is_misc_technical}', "");
    Expect(0, 9216, '\P{^  is_misc_technical}', "");
    Error('\p{-:=In_Misc_Technical}');
    Error('\P{-:=In_Misc_Technical}');
    Expect(1, 9215, '\p{inmisctechnical}', "");
    Expect(0, 9215, '\p{^inmisctechnical}', "");
    Expect(0, 9215, '\P{inmisctechnical}', "");
    Expect(1, 9215, '\P{^inmisctechnical}', "");
    Expect(0, 9216, '\p{inmisctechnical}', "");
    Expect(1, 9216, '\p{^inmisctechnical}', "");
    Expect(1, 9216, '\P{inmisctechnical}', "");
    Expect(0, 9216, '\P{^inmisctechnical}', "");
    Expect(1, 9215, '\p{ IN_Misc_Technical}', "");
    Expect(0, 9215, '\p{^ IN_Misc_Technical}', "");
    Expect(0, 9215, '\P{ IN_Misc_Technical}', "");
    Expect(1, 9215, '\P{^ IN_Misc_Technical}', "");
    Expect(0, 9216, '\p{ IN_Misc_Technical}', "");
    Expect(1, 9216, '\p{^ IN_Misc_Technical}', "");
    Expect(1, 9216, '\P{ IN_Misc_Technical}', "");
    Expect(0, 9216, '\P{^ IN_Misc_Technical}', "");
    Error('\p{ /a/Modi}');
    Error('\P{ /a/Modi}');
    Expect(1, 71257, '\p{modi}', "");
    Expect(0, 71257, '\p{^modi}', "");
    Expect(0, 71257, '\P{modi}', "");
    Expect(1, 71257, '\P{^modi}', "");
    Expect(0, 71258, '\p{modi}', "");
    Expect(1, 71258, '\p{^modi}', "");
    Expect(1, 71258, '\P{modi}', "");
    Expect(0, 71258, '\P{^modi}', "");
    Expect(1, 71257, '\p{-	MODI}', "");
    Expect(0, 71257, '\p{^-	MODI}', "");
    Expect(0, 71257, '\P{-	MODI}', "");
    Expect(1, 71257, '\P{^-	MODI}', "");
    Expect(0, 71258, '\p{-	MODI}', "");
    Expect(1, 71258, '\p{^-	MODI}', "");
    Expect(1, 71258, '\P{-	MODI}', "");
    Expect(0, 71258, '\P{^-	MODI}', "");
    Error('\p{_ IS_Modi:=}');
    Error('\P{_ IS_Modi:=}');
    Expect(1, 71257, '\p{ismodi}', "");
    Expect(0, 71257, '\p{^ismodi}', "");
    Expect(0, 71257, '\P{ismodi}', "");
    Expect(1, 71257, '\P{^ismodi}', "");
    Expect(0, 71258, '\p{ismodi}', "");
    Expect(1, 71258, '\p{^ismodi}', "");
    Expect(1, 71258, '\P{ismodi}', "");
    Expect(0, 71258, '\P{^ismodi}', "");
    Expect(1, 71257, '\p{	_Is_modi}', "");
    Expect(0, 71257, '\p{^	_Is_modi}', "");
    Expect(0, 71257, '\P{	_Is_modi}', "");
    Expect(1, 71257, '\P{^	_Is_modi}', "");
    Expect(0, 71258, '\p{	_Is_modi}', "");
    Expect(1, 71258, '\p{^	_Is_modi}', "");
    Expect(1, 71258, '\P{	_Is_modi}', "");
    Expect(0, 71258, '\P{^	_Is_modi}', "");
    Error('\p{/a/	-MODIFIER_letter}');
    Error('\P{/a/	-MODIFIER_letter}');
    Expect(1, 125259, '\p{modifierletter}', "");
    Expect(0, 125259, '\p{^modifierletter}', "");
    Expect(0, 125259, '\P{modifierletter}', "");
    Expect(1, 125259, '\P{^modifierletter}', "");
    Expect(0, 125260, '\p{modifierletter}', "");
    Expect(1, 125260, '\p{^modifierletter}', "");
    Expect(1, 125260, '\P{modifierletter}', "");
    Expect(0, 125260, '\P{^modifierletter}', "");
    Expect(1, 125259, '\p{-Modifier_letter}', "");
    Expect(0, 125259, '\p{^-Modifier_letter}', "");
    Expect(0, 125259, '\P{-Modifier_letter}', "");
    Expect(1, 125259, '\P{^-Modifier_letter}', "");
    Expect(0, 125260, '\p{-Modifier_letter}', "");
    Expect(1, 125260, '\p{^-Modifier_letter}', "");
    Expect(1, 125260, '\P{-Modifier_letter}', "");
    Expect(0, 125260, '\P{^-Modifier_letter}', "");
    Error('\p{_IS_MODIFIER_letter:=}');
    Error('\P{_IS_MODIFIER_letter:=}');
    Expect(1, 125259, '\p{ismodifierletter}', "");
    Expect(0, 125259, '\p{^ismodifierletter}', "");
    Expect(0, 125259, '\P{ismodifierletter}', "");
    Expect(1, 125259, '\P{^ismodifierletter}', "");
    Expect(0, 125260, '\p{ismodifierletter}', "");
    Expect(1, 125260, '\p{^ismodifierletter}', "");
    Expect(1, 125260, '\P{ismodifierletter}', "");
    Expect(0, 125260, '\P{^ismodifierletter}', "");
    Expect(1, 125259, '\p{-	Is_Modifier_letter}', "");
    Expect(0, 125259, '\p{^-	Is_Modifier_letter}', "");
    Expect(0, 125259, '\P{-	Is_Modifier_letter}', "");
    Expect(1, 125259, '\P{^-	Is_Modifier_letter}', "");
    Expect(0, 125260, '\p{-	Is_Modifier_letter}', "");
    Expect(1, 125260, '\p{^-	Is_Modifier_letter}', "");
    Expect(1, 125260, '\P{-	Is_Modifier_letter}', "");
    Expect(0, 125260, '\P{^-	Is_Modifier_letter}', "");
    Error('\p{:=	lm}');
    Error('\P{:=	lm}');
    Expect(1, 125259, '\p{lm}', "");
    Expect(0, 125259, '\p{^lm}', "");
    Expect(0, 125259, '\P{lm}', "");
    Expect(1, 125259, '\P{^lm}', "");
    Expect(0, 125260, '\p{lm}', "");
    Expect(1, 125260, '\p{^lm}', "");
    Expect(1, 125260, '\P{lm}', "");
    Expect(0, 125260, '\P{^lm}', "");
    Expect(1, 125259, '\p{	 lm}', "");
    Expect(0, 125259, '\p{^	 lm}', "");
    Expect(0, 125259, '\P{	 lm}', "");
    Expect(1, 125259, '\P{^	 lm}', "");
    Expect(0, 125260, '\p{	 lm}', "");
    Expect(1, 125260, '\p{^	 lm}', "");
    Expect(1, 125260, '\P{	 lm}', "");
    Expect(0, 125260, '\P{^	 lm}', "");
    Error('\p{	_is_Lm/a/}');
    Error('\P{	_is_Lm/a/}');
    Expect(1, 125259, '\p{islm}', "");
    Expect(0, 125259, '\p{^islm}', "");
    Expect(0, 125259, '\P{islm}', "");
    Expect(1, 125259, '\P{^islm}', "");
    Expect(0, 125260, '\p{islm}', "");
    Expect(1, 125260, '\p{^islm}', "");
    Expect(1, 125260, '\P{islm}', "");
    Expect(0, 125260, '\P{^islm}', "");
    Expect(1, 125259, '\p{	IS_lm}', "");
    Expect(0, 125259, '\p{^	IS_lm}', "");
    Expect(0, 125259, '\P{	IS_lm}', "");
    Expect(1, 125259, '\P{^	IS_lm}', "");
    Expect(0, 125260, '\p{	IS_lm}', "");
    Expect(1, 125260, '\p{^	IS_lm}', "");
    Expect(1, 125260, '\P{	IS_lm}', "");
    Expect(0, 125260, '\P{^	IS_lm}', "");
    Error('\p{_MODIFIER_SYMBOL/a/}');
    Error('\P{_MODIFIER_SYMBOL/a/}');
    Expect(1, 127999, '\p{modifiersymbol}', "");
    Expect(0, 127999, '\p{^modifiersymbol}', "");
    Expect(0, 127999, '\P{modifiersymbol}', "");
    Expect(1, 127999, '\P{^modifiersymbol}', "");
    Expect(0, 128000, '\p{modifiersymbol}', "");
    Expect(1, 128000, '\p{^modifiersymbol}', "");
    Expect(1, 128000, '\P{modifiersymbol}', "");
    Expect(0, 128000, '\P{^modifiersymbol}', "");
    Expect(1, 127999, '\p{_Modifier_symbol}', "");
    Expect(0, 127999, '\p{^_Modifier_symbol}', "");
    Expect(0, 127999, '\P{_Modifier_symbol}', "");
    Expect(1, 127999, '\P{^_Modifier_symbol}', "");
    Expect(0, 128000, '\p{_Modifier_symbol}', "");
    Expect(1, 128000, '\p{^_Modifier_symbol}', "");
    Expect(1, 128000, '\P{_Modifier_symbol}', "");
    Expect(0, 128000, '\P{^_Modifier_symbol}', "");
    Error('\p{_/a/Is_MODIFIER_symbol}');
    Error('\P{_/a/Is_MODIFIER_symbol}');
    Expect(1, 127999, '\p{ismodifiersymbol}', "");
    Expect(0, 127999, '\p{^ismodifiersymbol}', "");
    Expect(0, 127999, '\P{ismodifiersymbol}', "");
    Expect(1, 127999, '\P{^ismodifiersymbol}', "");
    Expect(0, 128000, '\p{ismodifiersymbol}', "");
    Expect(1, 128000, '\p{^ismodifiersymbol}', "");
    Expect(1, 128000, '\P{ismodifiersymbol}', "");
    Expect(0, 128000, '\P{^ismodifiersymbol}', "");
    Expect(1, 127999, '\p{_ Is_MODIFIER_Symbol}', "");
    Expect(0, 127999, '\p{^_ Is_MODIFIER_Symbol}', "");
    Expect(0, 127999, '\P{_ Is_MODIFIER_Symbol}', "");
    Expect(1, 127999, '\P{^_ Is_MODIFIER_Symbol}', "");
    Expect(0, 128000, '\p{_ Is_MODIFIER_Symbol}', "");
    Expect(1, 128000, '\p{^_ Is_MODIFIER_Symbol}', "");
    Expect(1, 128000, '\P{_ Is_MODIFIER_Symbol}', "");
    Expect(0, 128000, '\P{^_ Is_MODIFIER_Symbol}', "");
    Error('\p{/a/Sk}');
    Error('\P{/a/Sk}');
    Expect(1, 127999, '\p{sk}', "");
    Expect(0, 127999, '\p{^sk}', "");
    Expect(0, 127999, '\P{sk}', "");
    Expect(1, 127999, '\P{^sk}', "");
    Expect(0, 128000, '\p{sk}', "");
    Expect(1, 128000, '\p{^sk}', "");
    Expect(1, 128000, '\P{sk}', "");
    Expect(0, 128000, '\P{^sk}', "");
    Expect(1, 127999, '\p{-	Sk}', "");
    Expect(0, 127999, '\p{^-	Sk}', "");
    Expect(0, 127999, '\P{-	Sk}', "");
    Expect(1, 127999, '\P{^-	Sk}', "");
    Expect(0, 128000, '\p{-	Sk}', "");
    Expect(1, 128000, '\p{^-	Sk}', "");
    Expect(1, 128000, '\P{-	Sk}', "");
    Expect(0, 128000, '\P{^-	Sk}', "");
    Error('\p{/a/  Is_sk}');
    Error('\P{/a/  Is_sk}');
    Expect(1, 127999, '\p{issk}', "");
    Expect(0, 127999, '\p{^issk}', "");
    Expect(0, 127999, '\P{issk}', "");
    Expect(1, 127999, '\P{^issk}', "");
    Expect(0, 128000, '\p{issk}', "");
    Expect(1, 128000, '\p{^issk}', "");
    Expect(1, 128000, '\P{issk}', "");
    Expect(0, 128000, '\P{^issk}', "");
    Expect(1, 127999, '\p{	IS_Sk}', "");
    Expect(0, 127999, '\p{^	IS_Sk}', "");
    Expect(0, 127999, '\P{	IS_Sk}', "");
    Expect(1, 127999, '\P{^	IS_Sk}', "");
    Expect(0, 128000, '\p{	IS_Sk}', "");
    Expect(1, 128000, '\p{^	IS_Sk}', "");
    Expect(1, 128000, '\P{	IS_Sk}', "");
    Expect(0, 128000, '\P{^	IS_Sk}', "");
    Error('\p{_-modifier_Tone_LETTERS:=}');
    Error('\P{_-modifier_Tone_LETTERS:=}');
    Expect(1, 42783, '\p{modifiertoneletters}', "");
    Expect(0, 42783, '\p{^modifiertoneletters}', "");
    Expect(0, 42783, '\P{modifiertoneletters}', "");
    Expect(1, 42783, '\P{^modifiertoneletters}', "");
    Expect(0, 42784, '\p{modifiertoneletters}', "");
    Expect(1, 42784, '\p{^modifiertoneletters}', "");
    Expect(1, 42784, '\P{modifiertoneletters}', "");
    Expect(0, 42784, '\P{^modifiertoneletters}', "");
    Expect(1, 42783, '\p{ MODIFIER_Tone_LETTERS}', "");
    Expect(0, 42783, '\p{^ MODIFIER_Tone_LETTERS}', "");
    Expect(0, 42783, '\P{ MODIFIER_Tone_LETTERS}', "");
    Expect(1, 42783, '\P{^ MODIFIER_Tone_LETTERS}', "");
    Expect(0, 42784, '\p{ MODIFIER_Tone_LETTERS}', "");
    Expect(1, 42784, '\p{^ MODIFIER_Tone_LETTERS}', "");
    Expect(1, 42784, '\P{ MODIFIER_Tone_LETTERS}', "");
    Expect(0, 42784, '\P{^ MODIFIER_Tone_LETTERS}', "");
    Error('\p{-	is_MODIFIER_Tone_LETTERS/a/}');
    Error('\P{-	is_MODIFIER_Tone_LETTERS/a/}');
    Expect(1, 42783, '\p{ismodifiertoneletters}', "");
    Expect(0, 42783, '\p{^ismodifiertoneletters}', "");
    Expect(0, 42783, '\P{ismodifiertoneletters}', "");
    Expect(1, 42783, '\P{^ismodifiertoneletters}', "");
    Expect(0, 42784, '\p{ismodifiertoneletters}', "");
    Expect(1, 42784, '\p{^ismodifiertoneletters}', "");
    Expect(1, 42784, '\P{ismodifiertoneletters}', "");
    Expect(0, 42784, '\P{^ismodifiertoneletters}', "");
    Expect(1, 42783, '\p{is_modifier_TONE_letters}', "");
    Expect(0, 42783, '\p{^is_modifier_TONE_letters}', "");
    Expect(0, 42783, '\P{is_modifier_TONE_letters}', "");
    Expect(1, 42783, '\P{^is_modifier_TONE_letters}', "");
    Expect(0, 42784, '\p{is_modifier_TONE_letters}', "");
    Expect(1, 42784, '\p{^is_modifier_TONE_letters}', "");
    Expect(1, 42784, '\P{is_modifier_TONE_letters}', "");
    Expect(0, 42784, '\P{^is_modifier_TONE_letters}', "");
    Error('\p{IN_Modifier_Tone_Letters/a/}');
    Error('\P{IN_Modifier_Tone_Letters/a/}');
    Expect(1, 42783, '\p{inmodifiertoneletters}', "");
    Expect(0, 42783, '\p{^inmodifiertoneletters}', "");
    Expect(0, 42783, '\P{inmodifiertoneletters}', "");
    Expect(1, 42783, '\P{^inmodifiertoneletters}', "");
    Expect(0, 42784, '\p{inmodifiertoneletters}', "");
    Expect(1, 42784, '\p{^inmodifiertoneletters}', "");
    Expect(1, 42784, '\P{inmodifiertoneletters}', "");
    Expect(0, 42784, '\P{^inmodifiertoneletters}', "");
    Expect(1, 42783, '\p{	In_MODIFIER_tone_Letters}', "");
    Expect(0, 42783, '\p{^	In_MODIFIER_tone_Letters}', "");
    Expect(0, 42783, '\P{	In_MODIFIER_tone_Letters}', "");
    Expect(1, 42783, '\P{^	In_MODIFIER_tone_Letters}', "");
    Expect(0, 42784, '\p{	In_MODIFIER_tone_Letters}', "");
    Expect(1, 42784, '\p{^	In_MODIFIER_tone_Letters}', "");
    Expect(1, 42784, '\P{	In_MODIFIER_tone_Letters}', "");
    Expect(0, 42784, '\P{^	In_MODIFIER_tone_Letters}', "");
    Error('\p{/a/-Mongolian}');
    Error('\P{/a/-Mongolian}');
    Expect(1, 71276, '\p{mongolian}', "");
    Expect(0, 71276, '\p{^mongolian}', "");
    Expect(0, 71276, '\P{mongolian}', "");
    Expect(1, 71276, '\P{^mongolian}', "");
    Expect(0, 71277, '\p{mongolian}', "");
    Expect(1, 71277, '\p{^mongolian}', "");
    Expect(1, 71277, '\P{mongolian}', "");
    Expect(0, 71277, '\P{^mongolian}', "");
    Expect(1, 71276, '\p{ -Mongolian}', "");
    Expect(0, 71276, '\p{^ -Mongolian}', "");
    Expect(0, 71276, '\P{ -Mongolian}', "");
    Expect(1, 71276, '\P{^ -Mongolian}', "");
    Expect(0, 71277, '\p{ -Mongolian}', "");
    Expect(1, 71277, '\p{^ -Mongolian}', "");
    Expect(1, 71277, '\P{ -Mongolian}', "");
    Expect(0, 71277, '\P{^ -Mongolian}', "");
    Error('\p{ IS_Mongolian:=}');
    Error('\P{ IS_Mongolian:=}');
    Expect(1, 71276, '\p{ismongolian}', "");
    Expect(0, 71276, '\p{^ismongolian}', "");
    Expect(0, 71276, '\P{ismongolian}', "");
    Expect(1, 71276, '\P{^ismongolian}', "");
    Expect(0, 71277, '\p{ismongolian}', "");
    Expect(1, 71277, '\p{^ismongolian}', "");
    Expect(1, 71277, '\P{ismongolian}', "");
    Expect(0, 71277, '\P{^ismongolian}', "");
    Expect(1, 71276, '\p{- IS_MONGOLIAN}', "");
    Expect(0, 71276, '\p{^- IS_MONGOLIAN}', "");
    Expect(0, 71276, '\P{- IS_MONGOLIAN}', "");
    Expect(1, 71276, '\P{^- IS_MONGOLIAN}', "");
    Expect(0, 71277, '\p{- IS_MONGOLIAN}', "");
    Expect(1, 71277, '\p{^- IS_MONGOLIAN}', "");
    Expect(1, 71277, '\P{- IS_MONGOLIAN}', "");
    Expect(0, 71277, '\P{^- IS_MONGOLIAN}', "");
    Error('\p{ /a/MONG}');
    Error('\P{ /a/MONG}');
    Expect(1, 71276, '\p{mong}', "");
    Expect(0, 71276, '\p{^mong}', "");
    Expect(0, 71276, '\P{mong}', "");
    Expect(1, 71276, '\P{^mong}', "");
    Expect(0, 71277, '\p{mong}', "");
    Expect(1, 71277, '\p{^mong}', "");
    Expect(1, 71277, '\P{mong}', "");
    Expect(0, 71277, '\P{^mong}', "");
    Expect(1, 71276, '\p{	 MONG}', "");
    Expect(0, 71276, '\p{^	 MONG}', "");
    Expect(0, 71276, '\P{	 MONG}', "");
    Expect(1, 71276, '\P{^	 MONG}', "");
    Expect(0, 71277, '\p{	 MONG}', "");
    Expect(1, 71277, '\p{^	 MONG}', "");
    Expect(1, 71277, '\P{	 MONG}', "");
    Expect(0, 71277, '\P{^	 MONG}', "");
    Error('\p{	IS_mong/a/}');
    Error('\P{	IS_mong/a/}');
    Expect(1, 71276, '\p{ismong}', "");
    Expect(0, 71276, '\p{^ismong}', "");
    Expect(0, 71276, '\P{ismong}', "");
    Expect(1, 71276, '\P{^ismong}', "");
    Expect(0, 71277, '\p{ismong}', "");
    Expect(1, 71277, '\p{^ismong}', "");
    Expect(1, 71277, '\P{ismong}', "");
    Expect(0, 71277, '\P{^ismong}', "");
    Expect(1, 71276, '\p{	 Is_Mong}', "");
    Expect(0, 71276, '\p{^	 Is_Mong}', "");
    Expect(0, 71276, '\P{	 Is_Mong}', "");
    Expect(1, 71276, '\P{^	 Is_Mong}', "");
    Expect(0, 71277, '\p{	 Is_Mong}', "");
    Expect(1, 71277, '\p{^	 Is_Mong}', "");
    Expect(1, 71277, '\P{	 Is_Mong}', "");
    Expect(0, 71277, '\P{^	 Is_Mong}', "");
    Error('\p{_/a/Mongolian_SUPPLEMENT}');
    Error('\P{_/a/Mongolian_SUPPLEMENT}');
    Expect(1, 71295, '\p{mongoliansupplement}', "");
    Expect(0, 71295, '\p{^mongoliansupplement}', "");
    Expect(0, 71295, '\P{mongoliansupplement}', "");
    Expect(1, 71295, '\P{^mongoliansupplement}', "");
    Expect(0, 71296, '\p{mongoliansupplement}', "");
    Expect(1, 71296, '\p{^mongoliansupplement}', "");
    Expect(1, 71296, '\P{mongoliansupplement}', "");
    Expect(0, 71296, '\P{^mongoliansupplement}', "");
    Expect(1, 71295, '\p{ 	Mongolian_supplement}', "");
    Expect(0, 71295, '\p{^ 	Mongolian_supplement}', "");
    Expect(0, 71295, '\P{ 	Mongolian_supplement}', "");
    Expect(1, 71295, '\P{^ 	Mongolian_supplement}', "");
    Expect(0, 71296, '\p{ 	Mongolian_supplement}', "");
    Expect(1, 71296, '\p{^ 	Mongolian_supplement}', "");
    Expect(1, 71296, '\P{ 	Mongolian_supplement}', "");
    Expect(0, 71296, '\P{^ 	Mongolian_supplement}', "");
    Error('\p{/a/-	is_MONGOLIAN_Supplement}');
    Error('\P{/a/-	is_MONGOLIAN_Supplement}');
    Expect(1, 71295, '\p{ismongoliansupplement}', "");
    Expect(0, 71295, '\p{^ismongoliansupplement}', "");
    Expect(0, 71295, '\P{ismongoliansupplement}', "");
    Expect(1, 71295, '\P{^ismongoliansupplement}', "");
    Expect(0, 71296, '\p{ismongoliansupplement}', "");
    Expect(1, 71296, '\p{^ismongoliansupplement}', "");
    Expect(1, 71296, '\P{ismongoliansupplement}', "");
    Expect(0, 71296, '\P{^ismongoliansupplement}', "");
    Expect(1, 71295, '\p{_	is_Mongolian_Supplement}', "");
    Expect(0, 71295, '\p{^_	is_Mongolian_Supplement}', "");
    Expect(0, 71295, '\P{_	is_Mongolian_Supplement}', "");
    Expect(1, 71295, '\P{^_	is_Mongolian_Supplement}', "");
    Expect(0, 71296, '\p{_	is_Mongolian_Supplement}', "");
    Expect(1, 71296, '\p{^_	is_Mongolian_Supplement}', "");
    Expect(1, 71296, '\P{_	is_Mongolian_Supplement}', "");
    Expect(0, 71296, '\P{^_	is_Mongolian_Supplement}', "");
    Error('\p{_:=IN_mongolian_supplement}');
    Error('\P{_:=IN_mongolian_supplement}');
    Expect(1, 71295, '\p{inmongoliansupplement}', "");
    Expect(0, 71295, '\p{^inmongoliansupplement}', "");
    Expect(0, 71295, '\P{inmongoliansupplement}', "");
    Expect(1, 71295, '\P{^inmongoliansupplement}', "");
    Expect(0, 71296, '\p{inmongoliansupplement}', "");
    Expect(1, 71296, '\p{^inmongoliansupplement}', "");
    Expect(1, 71296, '\P{inmongoliansupplement}', "");
    Expect(0, 71296, '\P{^inmongoliansupplement}', "");
    Expect(1, 71295, '\p{ -In_Mongolian_Supplement}', "");
    Expect(0, 71295, '\p{^ -In_Mongolian_Supplement}', "");
    Expect(0, 71295, '\P{ -In_Mongolian_Supplement}', "");
    Expect(1, 71295, '\P{^ -In_Mongolian_Supplement}', "");
    Expect(0, 71296, '\p{ -In_Mongolian_Supplement}', "");
    Expect(1, 71296, '\p{^ -In_Mongolian_Supplement}', "");
    Expect(1, 71296, '\P{ -In_Mongolian_Supplement}', "");
    Expect(0, 71296, '\P{^ -In_Mongolian_Supplement}', "");
    Error('\p{:=- mongolian_SUP}');
    Error('\P{:=- mongolian_SUP}');
    Expect(1, 71295, '\p{mongoliansup}', "");
    Expect(0, 71295, '\p{^mongoliansup}', "");
    Expect(0, 71295, '\P{mongoliansup}', "");
    Expect(1, 71295, '\P{^mongoliansup}', "");
    Expect(0, 71296, '\p{mongoliansup}', "");
    Expect(1, 71296, '\p{^mongoliansup}', "");
    Expect(1, 71296, '\P{mongoliansup}', "");
    Expect(0, 71296, '\P{^mongoliansup}', "");
    Expect(1, 71295, '\p{_	Mongolian_sup}', "");
    Expect(0, 71295, '\p{^_	Mongolian_sup}', "");
    Expect(0, 71295, '\P{_	Mongolian_sup}', "");
    Expect(1, 71295, '\P{^_	Mongolian_sup}', "");
    Expect(0, 71296, '\p{_	Mongolian_sup}', "");
    Expect(1, 71296, '\p{^_	Mongolian_sup}', "");
    Expect(1, 71296, '\P{_	Mongolian_sup}', "");
    Expect(0, 71296, '\P{^_	Mongolian_sup}', "");
    Error('\p{/a/-_IS_mongolian_sup}');
    Error('\P{/a/-_IS_mongolian_sup}');
    Expect(1, 71295, '\p{ismongoliansup}', "");
    Expect(0, 71295, '\p{^ismongoliansup}', "");
    Expect(0, 71295, '\P{ismongoliansup}', "");
    Expect(1, 71295, '\P{^ismongoliansup}', "");
    Expect(0, 71296, '\p{ismongoliansup}', "");
    Expect(1, 71296, '\p{^ismongoliansup}', "");
    Expect(1, 71296, '\P{ismongoliansup}', "");
    Expect(0, 71296, '\P{^ismongoliansup}', "");
    Expect(1, 71295, '\p{  Is_Mongolian_sup}', "");
    Expect(0, 71295, '\p{^  Is_Mongolian_sup}', "");
    Expect(0, 71295, '\P{  Is_Mongolian_sup}', "");
    Expect(1, 71295, '\P{^  Is_Mongolian_sup}', "");
    Expect(0, 71296, '\p{  Is_Mongolian_sup}', "");
    Expect(1, 71296, '\p{^  Is_Mongolian_sup}', "");
    Expect(1, 71296, '\P{  Is_Mongolian_sup}', "");
    Expect(0, 71296, '\P{^  Is_Mongolian_sup}', "");
    Error('\p{/a/In_Mongolian_sup}');
    Error('\P{/a/In_Mongolian_sup}');
    Expect(1, 71295, '\p{inmongoliansup}', "");
    Expect(0, 71295, '\p{^inmongoliansup}', "");
    Expect(0, 71295, '\P{inmongoliansup}', "");
    Expect(1, 71295, '\P{^inmongoliansup}', "");
    Expect(0, 71296, '\p{inmongoliansup}', "");
    Expect(1, 71296, '\p{^inmongoliansup}', "");
    Expect(1, 71296, '\P{inmongoliansup}', "");
    Expect(0, 71296, '\P{^inmongoliansup}', "");
    Expect(1, 71295, '\p{--In_MONGOLIAN_Sup}', "");
    Expect(0, 71295, '\p{^--In_MONGOLIAN_Sup}', "");
    Expect(0, 71295, '\P{--In_MONGOLIAN_Sup}', "");
    Expect(1, 71295, '\P{^--In_MONGOLIAN_Sup}', "");
    Expect(0, 71296, '\p{--In_MONGOLIAN_Sup}', "");
    Expect(1, 71296, '\p{^--In_MONGOLIAN_Sup}', "");
    Expect(1, 71296, '\P{--In_MONGOLIAN_Sup}', "");
    Expect(0, 71296, '\P{^--In_MONGOLIAN_Sup}', "");
    Error('\p{/a/Mro}');
    Error('\P{/a/Mro}');
    Expect(1, 92783, '\p{mro}', "");
    Expect(0, 92783, '\p{^mro}', "");
    Expect(0, 92783, '\P{mro}', "");
    Expect(1, 92783, '\P{^mro}', "");
    Expect(0, 92784, '\p{mro}', "");
    Expect(1, 92784, '\p{^mro}', "");
    Expect(1, 92784, '\P{mro}', "");
    Expect(0, 92784, '\P{^mro}', "");
    Expect(1, 92783, '\p{-	mro}', "");
    Expect(0, 92783, '\p{^-	mro}', "");
    Expect(0, 92783, '\P{-	mro}', "");
    Expect(1, 92783, '\P{^-	mro}', "");
    Expect(0, 92784, '\p{-	mro}', "");
    Expect(1, 92784, '\p{^-	mro}', "");
    Expect(1, 92784, '\P{-	mro}', "");
    Expect(0, 92784, '\P{^-	mro}', "");
    Error('\p{:=- Is_mro}');
    Error('\P{:=- Is_mro}');
    Expect(1, 92783, '\p{ismro}', "");
    Expect(0, 92783, '\p{^ismro}', "");
    Expect(0, 92783, '\P{ismro}', "");
    Expect(1, 92783, '\P{^ismro}', "");
    Expect(0, 92784, '\p{ismro}', "");
    Expect(1, 92784, '\p{^ismro}', "");
    Expect(1, 92784, '\P{ismro}', "");
    Expect(0, 92784, '\P{^ismro}', "");
    Expect(1, 92783, '\p{  Is_MRO}', "");
    Expect(0, 92783, '\p{^  Is_MRO}', "");
    Expect(0, 92783, '\P{  Is_MRO}', "");
    Expect(1, 92783, '\P{^  Is_MRO}', "");
    Expect(0, 92784, '\p{  Is_MRO}', "");
    Expect(1, 92784, '\p{^  Is_MRO}', "");
    Expect(1, 92784, '\P{  Is_MRO}', "");
    Expect(0, 92784, '\P{^  Is_MRO}', "");
    Error('\p{/a/- MROO}');
    Error('\P{/a/- MROO}');
    Expect(1, 92783, '\p{mroo}', "");
    Expect(0, 92783, '\p{^mroo}', "");
    Expect(0, 92783, '\P{mroo}', "");
    Expect(1, 92783, '\P{^mroo}', "");
    Expect(0, 92784, '\p{mroo}', "");
    Expect(1, 92784, '\p{^mroo}', "");
    Expect(1, 92784, '\P{mroo}', "");
    Expect(0, 92784, '\P{^mroo}', "");
    Expect(1, 92783, '\p{ 	Mroo}', "");
    Expect(0, 92783, '\p{^ 	Mroo}', "");
    Expect(0, 92783, '\P{ 	Mroo}', "");
    Expect(1, 92783, '\P{^ 	Mroo}', "");
    Expect(0, 92784, '\p{ 	Mroo}', "");
    Expect(1, 92784, '\p{^ 	Mroo}', "");
    Expect(1, 92784, '\P{ 	Mroo}', "");
    Expect(0, 92784, '\P{^ 	Mroo}', "");
    Error('\p{/a/IS_mroo}');
    Error('\P{/a/IS_mroo}');
    Expect(1, 92783, '\p{ismroo}', "");
    Expect(0, 92783, '\p{^ismroo}', "");
    Expect(0, 92783, '\P{ismroo}', "");
    Expect(1, 92783, '\P{^ismroo}', "");
    Expect(0, 92784, '\p{ismroo}', "");
    Expect(1, 92784, '\p{^ismroo}', "");
    Expect(1, 92784, '\P{ismroo}', "");
    Expect(0, 92784, '\P{^ismroo}', "");
    Expect(1, 92783, '\p{_-IS_mroo}', "");
    Expect(0, 92783, '\p{^_-IS_mroo}', "");
    Expect(0, 92783, '\P{_-IS_mroo}', "");
    Expect(1, 92783, '\P{^_-IS_mroo}', "");
    Expect(0, 92784, '\p{_-IS_mroo}', "");
    Expect(1, 92784, '\p{^_-IS_mroo}', "");
    Expect(1, 92784, '\P{_-IS_mroo}', "");
    Expect(0, 92784, '\P{^_-IS_mroo}', "");
    Error('\p{MULTANI/a/}');
    Error('\P{MULTANI/a/}');
    Expect(1, 70313, '\p{multani}', "");
    Expect(0, 70313, '\p{^multani}', "");
    Expect(0, 70313, '\P{multani}', "");
    Expect(1, 70313, '\P{^multani}', "");
    Expect(0, 70314, '\p{multani}', "");
    Expect(1, 70314, '\p{^multani}', "");
    Expect(1, 70314, '\P{multani}', "");
    Expect(0, 70314, '\P{^multani}', "");
    Expect(1, 70313, '\p{-	multani}', "");
    Expect(0, 70313, '\p{^-	multani}', "");
    Expect(0, 70313, '\P{-	multani}', "");
    Expect(1, 70313, '\P{^-	multani}', "");
    Expect(0, 70314, '\p{-	multani}', "");
    Expect(1, 70314, '\p{^-	multani}', "");
    Expect(1, 70314, '\P{-	multani}', "");
    Expect(0, 70314, '\P{^-	multani}', "");
    Error('\p{/a/	IS_MULTANI}');
    Error('\P{/a/	IS_MULTANI}');
    Expect(1, 70313, '\p{ismultani}', "");
    Expect(0, 70313, '\p{^ismultani}', "");
    Expect(0, 70313, '\P{ismultani}', "");
    Expect(1, 70313, '\P{^ismultani}', "");
    Expect(0, 70314, '\p{ismultani}', "");
    Expect(1, 70314, '\p{^ismultani}', "");
    Expect(1, 70314, '\P{ismultani}', "");
    Expect(0, 70314, '\P{^ismultani}', "");
    Expect(1, 70313, '\p{ Is_Multani}', "");
    Expect(0, 70313, '\p{^ Is_Multani}', "");
    Expect(0, 70313, '\P{ Is_Multani}', "");
    Expect(1, 70313, '\P{^ Is_Multani}', "");
    Expect(0, 70314, '\p{ Is_Multani}', "");
    Expect(1, 70314, '\p{^ Is_Multani}', "");
    Expect(1, 70314, '\P{ Is_Multani}', "");
    Expect(0, 70314, '\P{^ Is_Multani}', "");
    Error('\p{ MULT:=}');
    Error('\P{ MULT:=}');
    Expect(1, 70313, '\p{mult}', "");
    Expect(0, 70313, '\p{^mult}', "");
    Expect(0, 70313, '\P{mult}', "");
    Expect(1, 70313, '\P{^mult}', "");
    Expect(0, 70314, '\p{mult}', "");
    Expect(1, 70314, '\p{^mult}', "");
    Expect(1, 70314, '\P{mult}', "");
    Expect(0, 70314, '\P{^mult}', "");
    Expect(1, 70313, '\p{ mult}', "");
    Expect(0, 70313, '\p{^ mult}', "");
    Expect(0, 70313, '\P{ mult}', "");
    Expect(1, 70313, '\P{^ mult}', "");
    Expect(0, 70314, '\p{ mult}', "");
    Expect(1, 70314, '\p{^ mult}', "");
    Expect(1, 70314, '\P{ mult}', "");
    Expect(0, 70314, '\P{^ mult}', "");
    Error('\p{:=_ Is_mult}');
    Error('\P{:=_ Is_mult}');
    Expect(1, 70313, '\p{ismult}', "");
    Expect(0, 70313, '\p{^ismult}', "");
    Expect(0, 70313, '\P{ismult}', "");
    Expect(1, 70313, '\P{^ismult}', "");
    Expect(0, 70314, '\p{ismult}', "");
    Expect(1, 70314, '\p{^ismult}', "");
    Expect(1, 70314, '\P{ismult}', "");
    Expect(0, 70314, '\P{^ismult}', "");
    Expect(1, 70313, '\p{ _IS_mult}', "");
    Expect(0, 70313, '\p{^ _IS_mult}', "");
    Expect(0, 70313, '\P{ _IS_mult}', "");
    Expect(1, 70313, '\P{^ _IS_mult}', "");
    Expect(0, 70314, '\p{ _IS_mult}', "");
    Expect(1, 70314, '\p{^ _IS_mult}', "");
    Expect(1, 70314, '\P{ _IS_mult}', "");
    Expect(0, 70314, '\P{^ _IS_mult}', "");
    Error('\p{:=	musical_symbols}');
    Error('\P{:=	musical_symbols}');
    Expect(1, 119295, '\p{musicalsymbols}', "");
    Expect(0, 119295, '\p{^musicalsymbols}', "");
    Expect(0, 119295, '\P{musicalsymbols}', "");
    Expect(1, 119295, '\P{^musicalsymbols}', "");
    Expect(0, 119296, '\p{musicalsymbols}', "");
    Expect(1, 119296, '\p{^musicalsymbols}', "");
    Expect(1, 119296, '\P{musicalsymbols}', "");
    Expect(0, 119296, '\P{^musicalsymbols}', "");
    Expect(1, 119295, '\p{ _Musical_Symbols}', "");
    Expect(0, 119295, '\p{^ _Musical_Symbols}', "");
    Expect(0, 119295, '\P{ _Musical_Symbols}', "");
    Expect(1, 119295, '\P{^ _Musical_Symbols}', "");
    Expect(0, 119296, '\p{ _Musical_Symbols}', "");
    Expect(1, 119296, '\p{^ _Musical_Symbols}', "");
    Expect(1, 119296, '\P{ _Musical_Symbols}', "");
    Expect(0, 119296, '\P{^ _Musical_Symbols}', "");
    Error('\p{/a/	is_Musical_Symbols}');
    Error('\P{/a/	is_Musical_Symbols}');
    Expect(1, 119295, '\p{ismusicalsymbols}', "");
    Expect(0, 119295, '\p{^ismusicalsymbols}', "");
    Expect(0, 119295, '\P{ismusicalsymbols}', "");
    Expect(1, 119295, '\P{^ismusicalsymbols}', "");
    Expect(0, 119296, '\p{ismusicalsymbols}', "");
    Expect(1, 119296, '\p{^ismusicalsymbols}', "");
    Expect(1, 119296, '\P{ismusicalsymbols}', "");
    Expect(0, 119296, '\P{^ismusicalsymbols}', "");
    Expect(1, 119295, '\p{_	Is_Musical_Symbols}', "");
    Expect(0, 119295, '\p{^_	Is_Musical_Symbols}', "");
    Expect(0, 119295, '\P{_	Is_Musical_Symbols}', "");
    Expect(1, 119295, '\P{^_	Is_Musical_Symbols}', "");
    Expect(0, 119296, '\p{_	Is_Musical_Symbols}', "");
    Expect(1, 119296, '\p{^_	Is_Musical_Symbols}', "");
    Expect(1, 119296, '\P{_	Is_Musical_Symbols}', "");
    Expect(0, 119296, '\P{^_	Is_Musical_Symbols}', "");
    Error('\p{	-In_Musical_Symbols/a/}');
    Error('\P{	-In_Musical_Symbols/a/}');
    Expect(1, 119295, '\p{inmusicalsymbols}', "");
    Expect(0, 119295, '\p{^inmusicalsymbols}', "");
    Expect(0, 119295, '\P{inmusicalsymbols}', "");
    Expect(1, 119295, '\P{^inmusicalsymbols}', "");
    Expect(0, 119296, '\p{inmusicalsymbols}', "");
    Expect(1, 119296, '\p{^inmusicalsymbols}', "");
    Expect(1, 119296, '\P{inmusicalsymbols}', "");
    Expect(0, 119296, '\P{^inmusicalsymbols}', "");
    Expect(1, 119295, '\p{ -in_Musical_Symbols}', "");
    Expect(0, 119295, '\p{^ -in_Musical_Symbols}', "");
    Expect(0, 119295, '\P{ -in_Musical_Symbols}', "");
    Expect(1, 119295, '\P{^ -in_Musical_Symbols}', "");
    Expect(0, 119296, '\p{ -in_Musical_Symbols}', "");
    Expect(1, 119296, '\p{^ -in_Musical_Symbols}', "");
    Expect(1, 119296, '\P{ -in_Musical_Symbols}', "");
    Expect(0, 119296, '\P{^ -in_Musical_Symbols}', "");
    Error('\p{	/a/music}');
    Error('\P{	/a/music}');
    Expect(1, 119295, '\p{music}', "");
    Expect(0, 119295, '\p{^music}', "");
    Expect(0, 119295, '\P{music}', "");
    Expect(1, 119295, '\P{^music}', "");
    Expect(0, 119296, '\p{music}', "");
    Expect(1, 119296, '\p{^music}', "");
    Expect(1, 119296, '\P{music}', "");
    Expect(0, 119296, '\P{^music}', "");
    Expect(1, 119295, '\p{_-MUSIC}', "");
    Expect(0, 119295, '\p{^_-MUSIC}', "");
    Expect(0, 119295, '\P{_-MUSIC}', "");
    Expect(1, 119295, '\P{^_-MUSIC}', "");
    Expect(0, 119296, '\p{_-MUSIC}', "");
    Expect(1, 119296, '\p{^_-MUSIC}', "");
    Expect(1, 119296, '\P{_-MUSIC}', "");
    Expect(0, 119296, '\P{^_-MUSIC}', "");
    Error('\p{ _is_MUSIC/a/}');
    Error('\P{ _is_MUSIC/a/}');
    Expect(1, 119295, '\p{ismusic}', "");
    Expect(0, 119295, '\p{^ismusic}', "");
    Expect(0, 119295, '\P{ismusic}', "");
    Expect(1, 119295, '\P{^ismusic}', "");
    Expect(0, 119296, '\p{ismusic}', "");
    Expect(1, 119296, '\p{^ismusic}', "");
    Expect(1, 119296, '\P{ismusic}', "");
    Expect(0, 119296, '\P{^ismusic}', "");
    Expect(1, 119295, '\p{_is_music}', "");
    Expect(0, 119295, '\p{^_is_music}', "");
    Expect(0, 119295, '\P{_is_music}', "");
    Expect(1, 119295, '\P{^_is_music}', "");
    Expect(0, 119296, '\p{_is_music}', "");
    Expect(1, 119296, '\p{^_is_music}', "");
    Expect(1, 119296, '\P{_is_music}', "");
    Expect(0, 119296, '\P{^_is_music}', "");
    Error('\p{ In_MUSIC/a/}');
    Error('\P{ In_MUSIC/a/}');
    Expect(1, 119295, '\p{inmusic}', "");
    Expect(0, 119295, '\p{^inmusic}', "");
    Expect(0, 119295, '\P{inmusic}', "");
    Expect(1, 119295, '\P{^inmusic}', "");
    Expect(0, 119296, '\p{inmusic}', "");
    Expect(1, 119296, '\p{^inmusic}', "");
    Expect(1, 119296, '\P{inmusic}', "");
    Expect(0, 119296, '\P{^inmusic}', "");
    Expect(1, 119295, '\p{__In_music}', "");
    Expect(0, 119295, '\p{^__In_music}', "");
    Expect(0, 119295, '\P{__In_music}', "");
    Expect(1, 119295, '\P{^__In_music}', "");
    Expect(0, 119296, '\p{__In_music}', "");
    Expect(1, 119296, '\p{^__In_music}', "");
    Expect(1, 119296, '\P{__In_music}', "");
    Expect(0, 119296, '\P{^__In_music}', "");
    Error('\p{	/a/Myanmar}');
    Error('\P{	/a/Myanmar}');
    Expect(1, 43647, '\p{myanmar}', "");
    Expect(0, 43647, '\p{^myanmar}', "");
    Expect(0, 43647, '\P{myanmar}', "");
    Expect(1, 43647, '\P{^myanmar}', "");
    Expect(0, 43648, '\p{myanmar}', "");
    Expect(1, 43648, '\p{^myanmar}', "");
    Expect(1, 43648, '\P{myanmar}', "");
    Expect(0, 43648, '\P{^myanmar}', "");
    Expect(1, 43647, '\p{ myanmar}', "");
    Expect(0, 43647, '\p{^ myanmar}', "");
    Expect(0, 43647, '\P{ myanmar}', "");
    Expect(1, 43647, '\P{^ myanmar}', "");
    Expect(0, 43648, '\p{ myanmar}', "");
    Expect(1, 43648, '\p{^ myanmar}', "");
    Expect(1, 43648, '\P{ myanmar}', "");
    Expect(0, 43648, '\P{^ myanmar}', "");
    Error('\p{:=-Is_MYANMAR}');
    Error('\P{:=-Is_MYANMAR}');
    Expect(1, 43647, '\p{ismyanmar}', "");
    Expect(0, 43647, '\p{^ismyanmar}', "");
    Expect(0, 43647, '\P{ismyanmar}', "");
    Expect(1, 43647, '\P{^ismyanmar}', "");
    Expect(0, 43648, '\p{ismyanmar}', "");
    Expect(1, 43648, '\p{^ismyanmar}', "");
    Expect(1, 43648, '\P{ismyanmar}', "");
    Expect(0, 43648, '\P{^ismyanmar}', "");
    Expect(1, 43647, '\p{	-Is_myanmar}', "");
    Expect(0, 43647, '\p{^	-Is_myanmar}', "");
    Expect(0, 43647, '\P{	-Is_myanmar}', "");
    Expect(1, 43647, '\P{^	-Is_myanmar}', "");
    Expect(0, 43648, '\p{	-Is_myanmar}', "");
    Expect(1, 43648, '\p{^	-Is_myanmar}', "");
    Expect(1, 43648, '\P{	-Is_myanmar}', "");
    Expect(0, 43648, '\P{^	-Is_myanmar}', "");
    Error('\p{/a/mymr}');
    Error('\P{/a/mymr}');
    Expect(1, 43647, '\p{mymr}', "");
    Expect(0, 43647, '\p{^mymr}', "");
    Expect(0, 43647, '\P{mymr}', "");
    Expect(1, 43647, '\P{^mymr}', "");
    Expect(0, 43648, '\p{mymr}', "");
    Expect(1, 43648, '\p{^mymr}', "");
    Expect(1, 43648, '\P{mymr}', "");
    Expect(0, 43648, '\P{^mymr}', "");
    Expect(1, 43647, '\p{_-mymr}', "");
    Expect(0, 43647, '\p{^_-mymr}', "");
    Expect(0, 43647, '\P{_-mymr}', "");
    Expect(1, 43647, '\P{^_-mymr}', "");
    Expect(0, 43648, '\p{_-mymr}', "");
    Expect(1, 43648, '\p{^_-mymr}', "");
    Expect(1, 43648, '\P{_-mymr}', "");
    Expect(0, 43648, '\P{^_-mymr}', "");
    Error('\p{:=_	Is_mymr}');
    Error('\P{:=_	Is_mymr}');
    Expect(1, 43647, '\p{ismymr}', "");
    Expect(0, 43647, '\p{^ismymr}', "");
    Expect(0, 43647, '\P{ismymr}', "");
    Expect(1, 43647, '\P{^ismymr}', "");
    Expect(0, 43648, '\p{ismymr}', "");
    Expect(1, 43648, '\p{^ismymr}', "");
    Expect(1, 43648, '\P{ismymr}', "");
    Expect(0, 43648, '\P{^ismymr}', "");
    Expect(1, 43647, '\p{	_is_MYMR}', "");
    Expect(0, 43647, '\p{^	_is_MYMR}', "");
    Expect(0, 43647, '\P{	_is_MYMR}', "");
    Expect(1, 43647, '\P{^	_is_MYMR}', "");
    Expect(0, 43648, '\p{	_is_MYMR}', "");
    Expect(1, 43648, '\p{^	_is_MYMR}', "");
    Expect(1, 43648, '\P{	_is_MYMR}', "");
    Expect(0, 43648, '\P{^	_is_MYMR}', "");
    Error('\p{		Myanmar_EXTENDED_A:=}');
    Error('\P{		Myanmar_EXTENDED_A:=}');
    Expect(1, 43647, '\p{myanmarextendeda}', "");
    Expect(0, 43647, '\p{^myanmarextendeda}', "");
    Expect(0, 43647, '\P{myanmarextendeda}', "");
    Expect(1, 43647, '\P{^myanmarextendeda}', "");
    Expect(0, 43648, '\p{myanmarextendeda}', "");
    Expect(1, 43648, '\p{^myanmarextendeda}', "");
    Expect(1, 43648, '\P{myanmarextendeda}', "");
    Expect(0, 43648, '\P{^myanmarextendeda}', "");
    Expect(1, 43647, '\p{_myanmar_extended_a}', "");
    Expect(0, 43647, '\p{^_myanmar_extended_a}', "");
    Expect(0, 43647, '\P{_myanmar_extended_a}', "");
    Expect(1, 43647, '\P{^_myanmar_extended_a}', "");
    Expect(0, 43648, '\p{_myanmar_extended_a}', "");
    Expect(1, 43648, '\p{^_myanmar_extended_a}', "");
    Expect(1, 43648, '\P{_myanmar_extended_a}', "");
    Expect(0, 43648, '\P{^_myanmar_extended_a}', "");
    Error('\p{:=	 is_Myanmar_extended_A}');
    Error('\P{:=	 is_Myanmar_extended_A}');
    Expect(1, 43647, '\p{ismyanmarextendeda}', "");
    Expect(0, 43647, '\p{^ismyanmarextendeda}', "");
    Expect(0, 43647, '\P{ismyanmarextendeda}', "");
    Expect(1, 43647, '\P{^ismyanmarextendeda}', "");
    Expect(0, 43648, '\p{ismyanmarextendeda}', "");
    Expect(1, 43648, '\p{^ismyanmarextendeda}', "");
    Expect(1, 43648, '\P{ismyanmarextendeda}', "");
    Expect(0, 43648, '\P{^ismyanmarextendeda}', "");
    Expect(1, 43647, '\p{ IS_Myanmar_Extended_a}', "");
    Expect(0, 43647, '\p{^ IS_Myanmar_Extended_a}', "");
    Expect(0, 43647, '\P{ IS_Myanmar_Extended_a}', "");
    Expect(1, 43647, '\P{^ IS_Myanmar_Extended_a}', "");
    Expect(0, 43648, '\p{ IS_Myanmar_Extended_a}', "");
    Expect(1, 43648, '\p{^ IS_Myanmar_Extended_a}', "");
    Expect(1, 43648, '\P{ IS_Myanmar_Extended_a}', "");
    Expect(0, 43648, '\P{^ IS_Myanmar_Extended_a}', "");
    Error('\p{-	in_Myanmar_Extended_A:=}');
    Error('\P{-	in_Myanmar_Extended_A:=}');
    Expect(1, 43647, '\p{inmyanmarextendeda}', "");
    Expect(0, 43647, '\p{^inmyanmarextendeda}', "");
    Expect(0, 43647, '\P{inmyanmarextendeda}', "");
    Expect(1, 43647, '\P{^inmyanmarextendeda}', "");
    Expect(0, 43648, '\p{inmyanmarextendeda}', "");
    Expect(1, 43648, '\p{^inmyanmarextendeda}', "");
    Expect(1, 43648, '\P{inmyanmarextendeda}', "");
    Expect(0, 43648, '\P{^inmyanmarextendeda}', "");
    Expect(1, 43647, '\p{-In_MYANMAR_extended_A}', "");
    Expect(0, 43647, '\p{^-In_MYANMAR_extended_A}', "");
    Expect(0, 43647, '\P{-In_MYANMAR_extended_A}', "");
    Expect(1, 43647, '\P{^-In_MYANMAR_extended_A}', "");
    Expect(0, 43648, '\p{-In_MYANMAR_extended_A}', "");
    Expect(1, 43648, '\p{^-In_MYANMAR_extended_A}', "");
    Expect(1, 43648, '\P{-In_MYANMAR_extended_A}', "");
    Expect(0, 43648, '\P{^-In_MYANMAR_extended_A}', "");
    Error('\p{/a/-Myanmar_Ext_A}');
    Error('\P{/a/-Myanmar_Ext_A}');
    Expect(1, 43647, '\p{myanmarexta}', "");
    Expect(0, 43647, '\p{^myanmarexta}', "");
    Expect(0, 43647, '\P{myanmarexta}', "");
    Expect(1, 43647, '\P{^myanmarexta}', "");
    Expect(0, 43648, '\p{myanmarexta}', "");
    Expect(1, 43648, '\p{^myanmarexta}', "");
    Expect(1, 43648, '\P{myanmarexta}', "");
    Expect(0, 43648, '\P{^myanmarexta}', "");
    Expect(1, 43647, '\p{ _MYANMAR_EXT_A}', "");
    Expect(0, 43647, '\p{^ _MYANMAR_EXT_A}', "");
    Expect(0, 43647, '\P{ _MYANMAR_EXT_A}', "");
    Expect(1, 43647, '\P{^ _MYANMAR_EXT_A}', "");
    Expect(0, 43648, '\p{ _MYANMAR_EXT_A}', "");
    Expect(1, 43648, '\p{^ _MYANMAR_EXT_A}', "");
    Expect(1, 43648, '\P{ _MYANMAR_EXT_A}', "");
    Expect(0, 43648, '\P{^ _MYANMAR_EXT_A}', "");
    Error('\p{-	Is_Myanmar_EXT_A/a/}');
    Error('\P{-	Is_Myanmar_EXT_A/a/}');
    Expect(1, 43647, '\p{ismyanmarexta}', "");
    Expect(0, 43647, '\p{^ismyanmarexta}', "");
    Expect(0, 43647, '\P{ismyanmarexta}', "");
    Expect(1, 43647, '\P{^ismyanmarexta}', "");
    Expect(0, 43648, '\p{ismyanmarexta}', "");
    Expect(1, 43648, '\p{^ismyanmarexta}', "");
    Expect(1, 43648, '\P{ismyanmarexta}', "");
    Expect(0, 43648, '\P{^ismyanmarexta}', "");
    Expect(1, 43647, '\p{	Is_MYANMAR_ext_a}', "");
    Expect(0, 43647, '\p{^	Is_MYANMAR_ext_a}', "");
    Expect(0, 43647, '\P{	Is_MYANMAR_ext_a}', "");
    Expect(1, 43647, '\P{^	Is_MYANMAR_ext_a}', "");
    Expect(0, 43648, '\p{	Is_MYANMAR_ext_a}', "");
    Expect(1, 43648, '\p{^	Is_MYANMAR_ext_a}', "");
    Expect(1, 43648, '\P{	Is_MYANMAR_ext_a}', "");
    Expect(0, 43648, '\P{^	Is_MYANMAR_ext_a}', "");
    Error('\p{/a/		In_MYANMAR_EXT_A}');
    Error('\P{/a/		In_MYANMAR_EXT_A}');
    Expect(1, 43647, '\p{inmyanmarexta}', "");
    Expect(0, 43647, '\p{^inmyanmarexta}', "");
    Expect(0, 43647, '\P{inmyanmarexta}', "");
    Expect(1, 43647, '\P{^inmyanmarexta}', "");
    Expect(0, 43648, '\p{inmyanmarexta}', "");
    Expect(1, 43648, '\p{^inmyanmarexta}', "");
    Expect(1, 43648, '\P{inmyanmarexta}', "");
    Expect(0, 43648, '\P{^inmyanmarexta}', "");
    Expect(1, 43647, '\p{  In_Myanmar_EXT_A}', "");
    Expect(0, 43647, '\p{^  In_Myanmar_EXT_A}', "");
    Expect(0, 43647, '\P{  In_Myanmar_EXT_A}', "");
    Expect(1, 43647, '\P{^  In_Myanmar_EXT_A}', "");
    Expect(0, 43648, '\p{  In_Myanmar_EXT_A}', "");
    Expect(1, 43648, '\p{^  In_Myanmar_EXT_A}', "");
    Expect(1, 43648, '\P{  In_Myanmar_EXT_A}', "");
    Expect(0, 43648, '\P{^  In_Myanmar_EXT_A}', "");
    Error('\p{- myanmar_EXTENDED_B/a/}');
    Error('\P{- myanmar_EXTENDED_B/a/}');
    Expect(1, 43519, '\p{myanmarextendedb}', "");
    Expect(0, 43519, '\p{^myanmarextendedb}', "");
    Expect(0, 43519, '\P{myanmarextendedb}', "");
    Expect(1, 43519, '\P{^myanmarextendedb}', "");
    Expect(0, 43520, '\p{myanmarextendedb}', "");
    Expect(1, 43520, '\p{^myanmarextendedb}', "");
    Expect(1, 43520, '\P{myanmarextendedb}', "");
    Expect(0, 43520, '\P{^myanmarextendedb}', "");
    Expect(1, 43519, '\p{_	Myanmar_Extended_b}', "");
    Expect(0, 43519, '\p{^_	Myanmar_Extended_b}', "");
    Expect(0, 43519, '\P{_	Myanmar_Extended_b}', "");
    Expect(1, 43519, '\P{^_	Myanmar_Extended_b}', "");
    Expect(0, 43520, '\p{_	Myanmar_Extended_b}', "");
    Expect(1, 43520, '\p{^_	Myanmar_Extended_b}', "");
    Expect(1, 43520, '\P{_	Myanmar_Extended_b}', "");
    Expect(0, 43520, '\P{^_	Myanmar_Extended_b}', "");
    Error('\p{ Is_Myanmar_extended_B/a/}');
    Error('\P{ Is_Myanmar_extended_B/a/}');
    Expect(1, 43519, '\p{ismyanmarextendedb}', "");
    Expect(0, 43519, '\p{^ismyanmarextendedb}', "");
    Expect(0, 43519, '\P{ismyanmarextendedb}', "");
    Expect(1, 43519, '\P{^ismyanmarextendedb}', "");
    Expect(0, 43520, '\p{ismyanmarextendedb}', "");
    Expect(1, 43520, '\p{^ismyanmarextendedb}', "");
    Expect(1, 43520, '\P{ismyanmarextendedb}', "");
    Expect(0, 43520, '\P{^ismyanmarextendedb}', "");
    Expect(1, 43519, '\p{	_Is_Myanmar_Extended_b}', "");
    Expect(0, 43519, '\p{^	_Is_Myanmar_Extended_b}', "");
    Expect(0, 43519, '\P{	_Is_Myanmar_Extended_b}', "");
    Expect(1, 43519, '\P{^	_Is_Myanmar_Extended_b}', "");
    Expect(0, 43520, '\p{	_Is_Myanmar_Extended_b}', "");
    Expect(1, 43520, '\p{^	_Is_Myanmar_Extended_b}', "");
    Expect(1, 43520, '\P{	_Is_Myanmar_Extended_b}', "");
    Expect(0, 43520, '\P{^	_Is_Myanmar_Extended_b}', "");
    Error('\p{:=		in_Myanmar_extended_b}');
    Error('\P{:=		in_Myanmar_extended_b}');
    Expect(1, 43519, '\p{inmyanmarextendedb}', "");
    Expect(0, 43519, '\p{^inmyanmarextendedb}', "");
    Expect(0, 43519, '\P{inmyanmarextendedb}', "");
    Expect(1, 43519, '\P{^inmyanmarextendedb}', "");
    Expect(0, 43520, '\p{inmyanmarextendedb}', "");
    Expect(1, 43520, '\p{^inmyanmarextendedb}', "");
    Expect(1, 43520, '\P{inmyanmarextendedb}', "");
    Expect(0, 43520, '\P{^inmyanmarextendedb}', "");
    Expect(1, 43519, '\p{	In_Myanmar_EXTENDED_B}', "");
    Expect(0, 43519, '\p{^	In_Myanmar_EXTENDED_B}', "");
    Expect(0, 43519, '\P{	In_Myanmar_EXTENDED_B}', "");
    Expect(1, 43519, '\P{^	In_Myanmar_EXTENDED_B}', "");
    Expect(0, 43520, '\p{	In_Myanmar_EXTENDED_B}', "");
    Expect(1, 43520, '\p{^	In_Myanmar_EXTENDED_B}', "");
    Expect(1, 43520, '\P{	In_Myanmar_EXTENDED_B}', "");
    Expect(0, 43520, '\P{^	In_Myanmar_EXTENDED_B}', "");
    Error('\p{/a/-myanmar_Ext_B}');
    Error('\P{/a/-myanmar_Ext_B}');
    Expect(1, 43519, '\p{myanmarextb}', "");
    Expect(0, 43519, '\p{^myanmarextb}', "");
    Expect(0, 43519, '\P{myanmarextb}', "");
    Expect(1, 43519, '\P{^myanmarextb}', "");
    Expect(0, 43520, '\p{myanmarextb}', "");
    Expect(1, 43520, '\p{^myanmarextb}', "");
    Expect(1, 43520, '\P{myanmarextb}', "");
    Expect(0, 43520, '\P{^myanmarextb}', "");
    Expect(1, 43519, '\p{	Myanmar_EXT_B}', "");
    Expect(0, 43519, '\p{^	Myanmar_EXT_B}', "");
    Expect(0, 43519, '\P{	Myanmar_EXT_B}', "");
    Expect(1, 43519, '\P{^	Myanmar_EXT_B}', "");
    Expect(0, 43520, '\p{	Myanmar_EXT_B}', "");
    Expect(1, 43520, '\p{^	Myanmar_EXT_B}', "");
    Expect(1, 43520, '\P{	Myanmar_EXT_B}', "");
    Expect(0, 43520, '\P{^	Myanmar_EXT_B}', "");
    Error('\p{/a/	_IS_MYANMAR_EXT_b}');
    Error('\P{/a/	_IS_MYANMAR_EXT_b}');
    Expect(1, 43519, '\p{ismyanmarextb}', "");
    Expect(0, 43519, '\p{^ismyanmarextb}', "");
    Expect(0, 43519, '\P{ismyanmarextb}', "");
    Expect(1, 43519, '\P{^ismyanmarextb}', "");
    Expect(0, 43520, '\p{ismyanmarextb}', "");
    Expect(1, 43520, '\p{^ismyanmarextb}', "");
    Expect(1, 43520, '\P{ismyanmarextb}', "");
    Expect(0, 43520, '\P{^ismyanmarextb}', "");
    Expect(1, 43519, '\p{-_Is_myanmar_Ext_b}', "");
    Expect(0, 43519, '\p{^-_Is_myanmar_Ext_b}', "");
    Expect(0, 43519, '\P{-_Is_myanmar_Ext_b}', "");
    Expect(1, 43519, '\P{^-_Is_myanmar_Ext_b}', "");
    Expect(0, 43520, '\p{-_Is_myanmar_Ext_b}', "");
    Expect(1, 43520, '\p{^-_Is_myanmar_Ext_b}', "");
    Expect(1, 43520, '\P{-_Is_myanmar_Ext_b}', "");
    Expect(0, 43520, '\P{^-_Is_myanmar_Ext_b}', "");
    Error('\p{	in_Myanmar_Ext_b/a/}');
    Error('\P{	in_Myanmar_Ext_b/a/}');
    Expect(1, 43519, '\p{inmyanmarextb}', "");
    Expect(0, 43519, '\p{^inmyanmarextb}', "");
    Expect(0, 43519, '\P{inmyanmarextb}', "");
    Expect(1, 43519, '\P{^inmyanmarextb}', "");
    Expect(0, 43520, '\p{inmyanmarextb}', "");
    Expect(1, 43520, '\p{^inmyanmarextb}', "");
    Expect(1, 43520, '\P{inmyanmarextb}', "");
    Expect(0, 43520, '\P{^inmyanmarextb}', "");
    Expect(1, 43519, '\p{	-In_Myanmar_ext_B}', "");
    Expect(0, 43519, '\p{^	-In_Myanmar_ext_B}', "");
    Expect(0, 43519, '\P{	-In_Myanmar_ext_B}', "");
    Expect(1, 43519, '\P{^	-In_Myanmar_ext_B}', "");
    Expect(0, 43520, '\p{	-In_Myanmar_ext_B}', "");
    Expect(1, 43520, '\p{^	-In_Myanmar_ext_B}', "");
    Expect(1, 43520, '\P{	-In_Myanmar_ext_B}', "");
    Expect(0, 43520, '\P{^	-In_Myanmar_ext_B}', "");
    Error('\p{	/a/nabataean}');
    Error('\P{	/a/nabataean}');
    Expect(1, 67759, '\p{nabataean}', "");
    Expect(0, 67759, '\p{^nabataean}', "");
    Expect(0, 67759, '\P{nabataean}', "");
    Expect(1, 67759, '\P{^nabataean}', "");
    Expect(0, 67760, '\p{nabataean}', "");
    Expect(1, 67760, '\p{^nabataean}', "");
    Expect(1, 67760, '\P{nabataean}', "");
    Expect(0, 67760, '\P{^nabataean}', "");
    Expect(1, 67759, '\p{ NABATAEAN}', "");
    Expect(0, 67759, '\p{^ NABATAEAN}', "");
    Expect(0, 67759, '\P{ NABATAEAN}', "");
    Expect(1, 67759, '\P{^ NABATAEAN}', "");
    Expect(0, 67760, '\p{ NABATAEAN}', "");
    Expect(1, 67760, '\p{^ NABATAEAN}', "");
    Expect(1, 67760, '\P{ NABATAEAN}', "");
    Expect(0, 67760, '\P{^ NABATAEAN}', "");
    Error('\p{	-IS_NABATAEAN:=}');
    Error('\P{	-IS_NABATAEAN:=}');
    Expect(1, 67759, '\p{isnabataean}', "");
    Expect(0, 67759, '\p{^isnabataean}', "");
    Expect(0, 67759, '\P{isnabataean}', "");
    Expect(1, 67759, '\P{^isnabataean}', "");
    Expect(0, 67760, '\p{isnabataean}', "");
    Expect(1, 67760, '\p{^isnabataean}', "");
    Expect(1, 67760, '\P{isnabataean}', "");
    Expect(0, 67760, '\P{^isnabataean}', "");
    Expect(1, 67759, '\p{_IS_nabataean}', "");
    Expect(0, 67759, '\p{^_IS_nabataean}', "");
    Expect(0, 67759, '\P{_IS_nabataean}', "");
    Expect(1, 67759, '\P{^_IS_nabataean}', "");
    Expect(0, 67760, '\p{_IS_nabataean}', "");
    Expect(1, 67760, '\p{^_IS_nabataean}', "");
    Expect(1, 67760, '\P{_IS_nabataean}', "");
    Expect(0, 67760, '\P{^_IS_nabataean}', "");
    Error('\p{/a/	nbat}');
    Error('\P{/a/	nbat}');
    Expect(1, 67759, '\p{nbat}', "");
    Expect(0, 67759, '\p{^nbat}', "");
    Expect(0, 67759, '\P{nbat}', "");
    Expect(1, 67759, '\P{^nbat}', "");
    Expect(0, 67760, '\p{nbat}', "");
    Expect(1, 67760, '\p{^nbat}', "");
    Expect(1, 67760, '\P{nbat}', "");
    Expect(0, 67760, '\P{^nbat}', "");
    Expect(1, 67759, '\p{-_Nbat}', "");
    Expect(0, 67759, '\p{^-_Nbat}', "");
    Expect(0, 67759, '\P{-_Nbat}', "");
    Expect(1, 67759, '\P{^-_Nbat}', "");
    Expect(0, 67760, '\p{-_Nbat}', "");
    Expect(1, 67760, '\p{^-_Nbat}', "");
    Expect(1, 67760, '\P{-_Nbat}', "");
    Expect(0, 67760, '\P{^-_Nbat}', "");
    Error('\p{/a/Is_NBAT}');
    Error('\P{/a/Is_NBAT}');
    Expect(1, 67759, '\p{isnbat}', "");
    Expect(0, 67759, '\p{^isnbat}', "");
    Expect(0, 67759, '\P{isnbat}', "");
    Expect(1, 67759, '\P{^isnbat}', "");
    Expect(0, 67760, '\p{isnbat}', "");
    Expect(1, 67760, '\p{^isnbat}', "");
    Expect(1, 67760, '\P{isnbat}', "");
    Expect(0, 67760, '\P{^isnbat}', "");
    Expect(1, 67759, '\p{-IS_NBAT}', "");
    Expect(0, 67759, '\p{^-IS_NBAT}', "");
    Expect(0, 67759, '\P{-IS_NBAT}', "");
    Expect(1, 67759, '\P{^-IS_NBAT}', "");
    Expect(0, 67760, '\p{-IS_NBAT}', "");
    Expect(1, 67760, '\p{^-IS_NBAT}', "");
    Expect(1, 67760, '\P{-IS_NBAT}', "");
    Expect(0, 67760, '\P{^-IS_NBAT}', "");
    Error('\p{/a/  Nandinagari}');
    Error('\P{/a/  Nandinagari}');
    Expect(1, 72164, '\p{nandinagari}', "");
    Expect(0, 72164, '\p{^nandinagari}', "");
    Expect(0, 72164, '\P{nandinagari}', "");
    Expect(1, 72164, '\P{^nandinagari}', "");
    Expect(0, 72165, '\p{nandinagari}', "");
    Expect(1, 72165, '\p{^nandinagari}', "");
    Expect(1, 72165, '\P{nandinagari}', "");
    Expect(0, 72165, '\P{^nandinagari}', "");
    Expect(1, 72164, '\p{_NANDINAGARI}', "");
    Expect(0, 72164, '\p{^_NANDINAGARI}', "");
    Expect(0, 72164, '\P{_NANDINAGARI}', "");
    Expect(1, 72164, '\P{^_NANDINAGARI}', "");
    Expect(0, 72165, '\p{_NANDINAGARI}', "");
    Expect(1, 72165, '\p{^_NANDINAGARI}', "");
    Expect(1, 72165, '\P{_NANDINAGARI}', "");
    Expect(0, 72165, '\P{^_NANDINAGARI}', "");
    Error('\p{/a/Is_nandinagari}');
    Error('\P{/a/Is_nandinagari}');
    Expect(1, 72164, '\p{isnandinagari}', "");
    Expect(0, 72164, '\p{^isnandinagari}', "");
    Expect(0, 72164, '\P{isnandinagari}', "");
    Expect(1, 72164, '\P{^isnandinagari}', "");
    Expect(0, 72165, '\p{isnandinagari}', "");
    Expect(1, 72165, '\p{^isnandinagari}', "");
    Expect(1, 72165, '\P{isnandinagari}', "");
    Expect(0, 72165, '\P{^isnandinagari}', "");
    Expect(1, 72164, '\p{- IS_NANDINAGARI}', "");
    Expect(0, 72164, '\p{^- IS_NANDINAGARI}', "");
    Expect(0, 72164, '\P{- IS_NANDINAGARI}', "");
    Expect(1, 72164, '\P{^- IS_NANDINAGARI}', "");
    Expect(0, 72165, '\p{- IS_NANDINAGARI}', "");
    Expect(1, 72165, '\p{^- IS_NANDINAGARI}', "");
    Expect(1, 72165, '\P{- IS_NANDINAGARI}', "");
    Expect(0, 72165, '\P{^- IS_NANDINAGARI}', "");
    Error('\p{	_nand/a/}');
    Error('\P{	_nand/a/}');
    Expect(1, 72164, '\p{nand}', "");
    Expect(0, 72164, '\p{^nand}', "");
    Expect(0, 72164, '\P{nand}', "");
    Expect(1, 72164, '\P{^nand}', "");
    Expect(0, 72165, '\p{nand}', "");
    Expect(1, 72165, '\p{^nand}', "");
    Expect(1, 72165, '\P{nand}', "");
    Expect(0, 72165, '\P{^nand}', "");
    Expect(1, 72164, '\p{	NAND}', "");
    Expect(0, 72164, '\p{^	NAND}', "");
    Expect(0, 72164, '\P{	NAND}', "");
    Expect(1, 72164, '\P{^	NAND}', "");
    Expect(0, 72165, '\p{	NAND}', "");
    Expect(1, 72165, '\p{^	NAND}', "");
    Expect(1, 72165, '\P{	NAND}', "");
    Expect(0, 72165, '\P{^	NAND}', "");
    Error('\p{--is_nand:=}');
    Error('\P{--is_nand:=}');
    Expect(1, 72164, '\p{isnand}', "");
    Expect(0, 72164, '\p{^isnand}', "");
    Expect(0, 72164, '\P{isnand}', "");
    Expect(1, 72164, '\P{^isnand}', "");
    Expect(0, 72165, '\p{isnand}', "");
    Expect(1, 72165, '\p{^isnand}', "");
    Expect(1, 72165, '\P{isnand}', "");
    Expect(0, 72165, '\P{^isnand}', "");
    Expect(1, 72164, '\p{- Is_Nand}', "");
    Expect(0, 72164, '\p{^- Is_Nand}', "");
    Expect(0, 72164, '\P{- Is_Nand}', "");
    Expect(1, 72164, '\P{^- Is_Nand}', "");
    Expect(0, 72165, '\p{- Is_Nand}', "");
    Expect(1, 72165, '\p{^- Is_Nand}', "");
    Expect(1, 72165, '\P{- Is_Nand}', "");
    Expect(0, 72165, '\P{^- Is_Nand}', "");
    Error('\p{ :=new_Tai_LUE}');
    Error('\P{ :=new_Tai_LUE}');
    Expect(1, 6623, '\p{newtailue}', "");
    Expect(0, 6623, '\p{^newtailue}', "");
    Expect(0, 6623, '\P{newtailue}', "");
    Expect(1, 6623, '\P{^newtailue}', "");
    Expect(0, 6624, '\p{newtailue}', "");
    Expect(1, 6624, '\p{^newtailue}', "");
    Expect(1, 6624, '\P{newtailue}', "");
    Expect(0, 6624, '\P{^newtailue}', "");
    Expect(1, 6623, '\p{_-new_Tai_lue}', "");
    Expect(0, 6623, '\p{^_-new_Tai_lue}', "");
    Expect(0, 6623, '\P{_-new_Tai_lue}', "");
    Expect(1, 6623, '\P{^_-new_Tai_lue}', "");
    Expect(0, 6624, '\p{_-new_Tai_lue}', "");
    Expect(1, 6624, '\p{^_-new_Tai_lue}', "");
    Expect(1, 6624, '\P{_-new_Tai_lue}', "");
    Expect(0, 6624, '\P{^_-new_Tai_lue}', "");
    Error('\p{:=	is_NEW_Tai_LUE}');
    Error('\P{:=	is_NEW_Tai_LUE}');
    Expect(1, 6623, '\p{isnewtailue}', "");
    Expect(0, 6623, '\p{^isnewtailue}', "");
    Expect(0, 6623, '\P{isnewtailue}', "");
    Expect(1, 6623, '\P{^isnewtailue}', "");
    Expect(0, 6624, '\p{isnewtailue}', "");
    Expect(1, 6624, '\p{^isnewtailue}', "");
    Expect(1, 6624, '\P{isnewtailue}', "");
    Expect(0, 6624, '\P{^isnewtailue}', "");
    Expect(1, 6623, '\p{		IS_NEW_tai_Lue}', "");
    Expect(0, 6623, '\p{^		IS_NEW_tai_Lue}', "");
    Expect(0, 6623, '\P{		IS_NEW_tai_Lue}', "");
    Expect(1, 6623, '\P{^		IS_NEW_tai_Lue}', "");
    Expect(0, 6624, '\p{		IS_NEW_tai_Lue}', "");
    Expect(1, 6624, '\p{^		IS_NEW_tai_Lue}', "");
    Expect(1, 6624, '\P{		IS_NEW_tai_Lue}', "");
    Expect(0, 6624, '\P{^		IS_NEW_tai_Lue}', "");
    Error('\p{	_Talu:=}');
    Error('\P{	_Talu:=}');
    Expect(1, 6623, '\p{talu}', "");
    Expect(0, 6623, '\p{^talu}', "");
    Expect(0, 6623, '\P{talu}', "");
    Expect(1, 6623, '\P{^talu}', "");
    Expect(0, 6624, '\p{talu}', "");
    Expect(1, 6624, '\p{^talu}', "");
    Expect(1, 6624, '\P{talu}', "");
    Expect(0, 6624, '\P{^talu}', "");
    Expect(1, 6623, '\p{-_Talu}', "");
    Expect(0, 6623, '\p{^-_Talu}', "");
    Expect(0, 6623, '\P{-_Talu}', "");
    Expect(1, 6623, '\P{^-_Talu}', "");
    Expect(0, 6624, '\p{-_Talu}', "");
    Expect(1, 6624, '\p{^-_Talu}', "");
    Expect(1, 6624, '\P{-_Talu}', "");
    Expect(0, 6624, '\P{^-_Talu}', "");
    Error('\p{	_Is_talu/a/}');
    Error('\P{	_Is_talu/a/}');
    Expect(1, 6623, '\p{istalu}', "");
    Expect(0, 6623, '\p{^istalu}', "");
    Expect(0, 6623, '\P{istalu}', "");
    Expect(1, 6623, '\P{^istalu}', "");
    Expect(0, 6624, '\p{istalu}', "");
    Expect(1, 6624, '\p{^istalu}', "");
    Expect(1, 6624, '\P{istalu}', "");
    Expect(0, 6624, '\P{^istalu}', "");
    Expect(1, 6623, '\p{ _is_TALU}', "");
    Expect(0, 6623, '\p{^ _is_TALU}', "");
    Expect(0, 6623, '\P{ _is_TALU}', "");
    Expect(1, 6623, '\P{^ _is_TALU}', "");
    Expect(0, 6624, '\p{ _is_TALU}', "");
    Expect(1, 6624, '\p{^ _is_TALU}', "");
    Expect(1, 6624, '\P{ _is_TALU}', "");
    Expect(0, 6624, '\P{^ _is_TALU}', "");
    Error('\p{-/a/Newa}');
    Error('\P{-/a/Newa}');
    Expect(1, 70753, '\p{newa}', "");
    Expect(0, 70753, '\p{^newa}', "");
    Expect(0, 70753, '\P{newa}', "");
    Expect(1, 70753, '\P{^newa}', "");
    Expect(0, 70754, '\p{newa}', "");
    Expect(1, 70754, '\p{^newa}', "");
    Expect(1, 70754, '\P{newa}', "");
    Expect(0, 70754, '\P{^newa}', "");
    Expect(1, 70753, '\p{_Newa}', "");
    Expect(0, 70753, '\p{^_Newa}', "");
    Expect(0, 70753, '\P{_Newa}', "");
    Expect(1, 70753, '\P{^_Newa}', "");
    Expect(0, 70754, '\p{_Newa}', "");
    Expect(1, 70754, '\p{^_Newa}', "");
    Expect(1, 70754, '\P{_Newa}', "");
    Expect(0, 70754, '\P{^_Newa}', "");
    Error('\p{__is_newa/a/}');
    Error('\P{__is_newa/a/}');
    Expect(1, 70753, '\p{isnewa}', "");
    Expect(0, 70753, '\p{^isnewa}', "");
    Expect(0, 70753, '\P{isnewa}', "");
    Expect(1, 70753, '\P{^isnewa}', "");
    Expect(0, 70754, '\p{isnewa}', "");
    Expect(1, 70754, '\p{^isnewa}', "");
    Expect(1, 70754, '\P{isnewa}', "");
    Expect(0, 70754, '\P{^isnewa}', "");
    Expect(1, 70753, '\p{-_Is_newa}', "");
    Expect(0, 70753, '\p{^-_Is_newa}', "");
    Expect(0, 70753, '\P{-_Is_newa}', "");
    Expect(1, 70753, '\P{^-_Is_newa}', "");
    Expect(0, 70754, '\p{-_Is_newa}', "");
    Expect(1, 70754, '\p{^-_Is_newa}', "");
    Expect(1, 70754, '\P{-_Is_newa}', "");
    Expect(0, 70754, '\P{^-_Is_newa}', "");
    Error('\p{/a/		NKO}');
    Error('\P{/a/		NKO}');
    Expect(1, 2047, '\p{nko}', "");
    Expect(0, 2047, '\p{^nko}', "");
    Expect(0, 2047, '\P{nko}', "");
    Expect(1, 2047, '\P{^nko}', "");
    Expect(0, 2048, '\p{nko}', "");
    Expect(1, 2048, '\p{^nko}', "");
    Expect(1, 2048, '\P{nko}', "");
    Expect(0, 2048, '\P{^nko}', "");
    Expect(1, 2047, '\p{	_NKO}', "");
    Expect(0, 2047, '\p{^	_NKO}', "");
    Expect(0, 2047, '\P{	_NKO}', "");
    Expect(1, 2047, '\P{^	_NKO}', "");
    Expect(0, 2048, '\p{	_NKO}', "");
    Expect(1, 2048, '\p{^	_NKO}', "");
    Expect(1, 2048, '\P{	_NKO}', "");
    Expect(0, 2048, '\P{^	_NKO}', "");
    Error('\p{_/a/Is_Nko}');
    Error('\P{_/a/Is_Nko}');
    Expect(1, 2047, '\p{isnko}', "");
    Expect(0, 2047, '\p{^isnko}', "");
    Expect(0, 2047, '\P{isnko}', "");
    Expect(1, 2047, '\P{^isnko}', "");
    Expect(0, 2048, '\p{isnko}', "");
    Expect(1, 2048, '\p{^isnko}', "");
    Expect(1, 2048, '\P{isnko}', "");
    Expect(0, 2048, '\P{^isnko}', "");
    Expect(1, 2047, '\p{	is_Nko}', "");
    Expect(0, 2047, '\p{^	is_Nko}', "");
    Expect(0, 2047, '\P{	is_Nko}', "");
    Expect(1, 2047, '\P{^	is_Nko}', "");
    Expect(0, 2048, '\p{	is_Nko}', "");
    Expect(1, 2048, '\p{^	is_Nko}', "");
    Expect(1, 2048, '\P{	is_Nko}', "");
    Expect(0, 2048, '\P{^	is_Nko}', "");
    Error('\p{__nkoo:=}');
    Error('\P{__nkoo:=}');
    Expect(1, 2047, '\p{nkoo}', "");
    Expect(0, 2047, '\p{^nkoo}', "");
    Expect(0, 2047, '\P{nkoo}', "");
    Expect(1, 2047, '\P{^nkoo}', "");
    Expect(0, 2048, '\p{nkoo}', "");
    Expect(1, 2048, '\p{^nkoo}', "");
    Expect(1, 2048, '\P{nkoo}', "");
    Expect(0, 2048, '\P{^nkoo}', "");
    Expect(1, 2047, '\p{	 NKOO}', "");
    Expect(0, 2047, '\p{^	 NKOO}', "");
    Expect(0, 2047, '\P{	 NKOO}', "");
    Expect(1, 2047, '\P{^	 NKOO}', "");
    Expect(0, 2048, '\p{	 NKOO}', "");
    Expect(1, 2048, '\p{^	 NKOO}', "");
    Expect(1, 2048, '\P{	 NKOO}', "");
    Expect(0, 2048, '\P{^	 NKOO}', "");
    Error('\p{-Is_nkoo:=}');
    Error('\P{-Is_nkoo:=}');
    Expect(1, 2047, '\p{isnkoo}', "");
    Expect(0, 2047, '\p{^isnkoo}', "");
    Expect(0, 2047, '\P{isnkoo}', "");
    Expect(1, 2047, '\P{^isnkoo}', "");
    Expect(0, 2048, '\p{isnkoo}', "");
    Expect(1, 2048, '\p{^isnkoo}', "");
    Expect(1, 2048, '\P{isnkoo}', "");
    Expect(0, 2048, '\P{^isnkoo}', "");
    Expect(1, 2047, '\p{-	is_NKOO}', "");
    Expect(0, 2047, '\p{^-	is_NKOO}', "");
    Expect(0, 2047, '\P{-	is_NKOO}', "");
    Expect(1, 2047, '\P{^-	is_NKOO}', "");
    Expect(0, 2048, '\p{-	is_NKOO}', "");
    Expect(1, 2048, '\p{^-	is_NKOO}', "");
    Expect(1, 2048, '\P{-	is_NKOO}', "");
    Expect(0, 2048, '\P{^-	is_NKOO}', "");
    Error('\p{:=	NO_BLOCK}');
    Error('\P{:=	NO_BLOCK}');
    Expect(1, 918000, '\p{noblock}', "");
    Expect(0, 918000, '\p{^noblock}', "");
    Expect(0, 918000, '\P{noblock}', "");
    Expect(1, 918000, '\P{^noblock}', "");
    Expect(0, 983040, '\p{noblock}', "");
    Expect(1, 983040, '\p{^noblock}', "");
    Expect(1, 983040, '\P{noblock}', "");
    Expect(0, 983040, '\P{^noblock}', "");
    Expect(1, 918000, '\p{NO_block}', "");
    Expect(0, 918000, '\p{^NO_block}', "");
    Expect(0, 918000, '\P{NO_block}', "");
    Expect(1, 918000, '\P{^NO_block}', "");
    Expect(0, 983040, '\p{NO_block}', "");
    Expect(1, 983040, '\p{^NO_block}', "");
    Expect(1, 983040, '\P{NO_block}', "");
    Expect(0, 983040, '\P{^NO_block}', "");
    Error('\p{--IS_NO_Block:=}');
    Error('\P{--IS_NO_Block:=}');
    Expect(1, 918000, '\p{isnoblock}', "");
    Expect(0, 918000, '\p{^isnoblock}', "");
    Expect(0, 918000, '\P{isnoblock}', "");
    Expect(1, 918000, '\P{^isnoblock}', "");
    Expect(0, 983040, '\p{isnoblock}', "");
    Expect(1, 983040, '\p{^isnoblock}', "");
    Expect(1, 983040, '\P{isnoblock}', "");
    Expect(0, 983040, '\P{^isnoblock}', "");
    Expect(1, 918000, '\p{	_Is_No_Block}', "");
    Expect(0, 918000, '\p{^	_Is_No_Block}', "");
    Expect(0, 918000, '\P{	_Is_No_Block}', "");
    Expect(1, 918000, '\P{^	_Is_No_Block}', "");
    Expect(0, 983040, '\p{	_Is_No_Block}', "");
    Expect(1, 983040, '\p{^	_Is_No_Block}', "");
    Expect(1, 983040, '\P{	_Is_No_Block}', "");
    Expect(0, 983040, '\P{^	_Is_No_Block}', "");
    Error('\p{_	in_No_BLOCK/a/}');
    Error('\P{_	in_No_BLOCK/a/}');
    Expect(1, 918000, '\p{innoblock}', "");
    Expect(0, 918000, '\p{^innoblock}', "");
    Expect(0, 918000, '\P{innoblock}', "");
    Expect(1, 918000, '\P{^innoblock}', "");
    Expect(0, 983040, '\p{innoblock}', "");
    Expect(1, 983040, '\p{^innoblock}', "");
    Expect(1, 983040, '\P{innoblock}', "");
    Expect(0, 983040, '\P{^innoblock}', "");
    Expect(1, 918000, '\p{ -in_no_Block}', "");
    Expect(0, 918000, '\p{^ -in_no_Block}', "");
    Expect(0, 918000, '\P{ -in_no_Block}', "");
    Expect(1, 918000, '\P{^ -in_no_Block}', "");
    Expect(0, 983040, '\p{ -in_no_Block}', "");
    Expect(1, 983040, '\p{^ -in_no_Block}', "");
    Expect(1, 983040, '\P{ -in_no_Block}', "");
    Expect(0, 983040, '\P{^ -in_no_Block}', "");
    Error('\p{:=-_nb}');
    Error('\P{:=-_nb}');
    Expect(1, 918000, '\p{nb}', "");
    Expect(0, 918000, '\p{^nb}', "");
    Expect(0, 918000, '\P{nb}', "");
    Expect(1, 918000, '\P{^nb}', "");
    Expect(0, 983040, '\p{nb}', "");
    Expect(1, 983040, '\p{^nb}', "");
    Expect(1, 983040, '\P{nb}', "");
    Expect(0, 983040, '\P{^nb}', "");
    Expect(1, 918000, '\p{_nb}', "");
    Expect(0, 918000, '\p{^_nb}', "");
    Expect(0, 918000, '\P{_nb}', "");
    Expect(1, 918000, '\P{^_nb}', "");
    Expect(0, 983040, '\p{_nb}', "");
    Expect(1, 983040, '\p{^_nb}', "");
    Expect(1, 983040, '\P{_nb}', "");
    Expect(0, 983040, '\P{^_nb}', "");
    Error('\p{:=  Is_NB}');
    Error('\P{:=  Is_NB}');
    Expect(1, 918000, '\p{isnb}', "");
    Expect(0, 918000, '\p{^isnb}', "");
    Expect(0, 918000, '\P{isnb}', "");
    Expect(1, 918000, '\P{^isnb}', "");
    Expect(0, 983040, '\p{isnb}', "");
    Expect(1, 983040, '\p{^isnb}', "");
    Expect(1, 983040, '\P{isnb}', "");
    Expect(0, 983040, '\P{^isnb}', "");
    Expect(1, 918000, '\p{	-IS_NB}', "");
    Expect(0, 918000, '\p{^	-IS_NB}', "");
    Expect(0, 918000, '\P{	-IS_NB}', "");
    Expect(1, 918000, '\P{^	-IS_NB}', "");
    Expect(0, 983040, '\p{	-IS_NB}', "");
    Expect(1, 983040, '\p{^	-IS_NB}', "");
    Expect(1, 983040, '\P{	-IS_NB}', "");
    Expect(0, 983040, '\P{^	-IS_NB}', "");
    Error('\p{_-IN_NB:=}');
    Error('\P{_-IN_NB:=}');
    Expect(1, 918000, '\p{innb}', "");
    Expect(0, 918000, '\p{^innb}', "");
    Expect(0, 918000, '\P{innb}', "");
    Expect(1, 918000, '\P{^innb}', "");
    Expect(0, 983040, '\p{innb}', "");
    Expect(1, 983040, '\p{^innb}', "");
    Expect(1, 983040, '\P{innb}', "");
    Expect(0, 983040, '\P{^innb}', "");
    Expect(1, 918000, '\p{ In_nb}', "");
    Expect(0, 918000, '\p{^ In_nb}', "");
    Expect(0, 918000, '\P{ In_nb}', "");
    Expect(1, 918000, '\P{^ In_nb}', "");
    Expect(0, 983040, '\p{ In_nb}', "");
    Expect(1, 983040, '\p{^ In_nb}', "");
    Expect(1, 983040, '\P{ In_nb}', "");
    Expect(0, 983040, '\P{^ In_nb}', "");
    Error('\p{/a/NONCHARACTER_CODE_POINT}');
    Error('\P{/a/NONCHARACTER_CODE_POINT}');
    Expect(1, 1114111, '\p{noncharactercodepoint}', "");
    Expect(0, 1114111, '\p{^noncharactercodepoint}', "");
    Expect(0, 1114111, '\P{noncharactercodepoint}', "");
    Expect(1, 1114111, '\P{^noncharactercodepoint}', "");
    Expect(0, 1114109, '\p{noncharactercodepoint}', "");
    Expect(1, 1114109, '\p{^noncharactercodepoint}', "");
    Expect(1, 1114109, '\P{noncharactercodepoint}', "");
    Expect(0, 1114109, '\P{^noncharactercodepoint}', "");
    Expect(1, 1114111, '\p{-Noncharacter_code_POINT}', "");
    Expect(0, 1114111, '\p{^-Noncharacter_code_POINT}', "");
    Expect(0, 1114111, '\P{-Noncharacter_code_POINT}', "");
    Expect(1, 1114111, '\P{^-Noncharacter_code_POINT}', "");
    Expect(0, 1114109, '\p{-Noncharacter_code_POINT}', "");
    Expect(1, 1114109, '\p{^-Noncharacter_code_POINT}', "");
    Expect(1, 1114109, '\P{-Noncharacter_code_POINT}', "");
    Expect(0, 1114109, '\P{^-Noncharacter_code_POINT}', "");
    Error('\p{_Is_noncharacter_Code_point:=}');
    Error('\P{_Is_noncharacter_Code_point:=}');
    Expect(1, 1114111, '\p{isnoncharactercodepoint}', "");
    Expect(0, 1114111, '\p{^isnoncharactercodepoint}', "");
    Expect(0, 1114111, '\P{isnoncharactercodepoint}', "");
    Expect(1, 1114111, '\P{^isnoncharactercodepoint}', "");
    Expect(0, 1114109, '\p{isnoncharactercodepoint}', "");
    Expect(1, 1114109, '\p{^isnoncharactercodepoint}', "");
    Expect(1, 1114109, '\P{isnoncharactercodepoint}', "");
    Expect(0, 1114109, '\P{^isnoncharactercodepoint}', "");
    Expect(1, 1114111, '\p{	is_Noncharacter_Code_point}', "");
    Expect(0, 1114111, '\p{^	is_Noncharacter_Code_point}', "");
    Expect(0, 1114111, '\P{	is_Noncharacter_Code_point}', "");
    Expect(1, 1114111, '\P{^	is_Noncharacter_Code_point}', "");
    Expect(0, 1114109, '\p{	is_Noncharacter_Code_point}', "");
    Expect(1, 1114109, '\p{^	is_Noncharacter_Code_point}', "");
    Expect(1, 1114109, '\P{	is_Noncharacter_Code_point}', "");
    Expect(0, 1114109, '\P{^	is_Noncharacter_Code_point}', "");
    Error('\p{	NCHAR/a/}');
    Error('\P{	NCHAR/a/}');
    Expect(1, 1114111, '\p{nchar}', "");
    Expect(0, 1114111, '\p{^nchar}', "");
    Expect(0, 1114111, '\P{nchar}', "");
    Expect(1, 1114111, '\P{^nchar}', "");
    Expect(0, 1114109, '\p{nchar}', "");
    Expect(1, 1114109, '\p{^nchar}', "");
    Expect(1, 1114109, '\P{nchar}', "");
    Expect(0, 1114109, '\P{^nchar}', "");
    Expect(1, 1114111, '\p{ NChar}', "");
    Expect(0, 1114111, '\p{^ NChar}', "");
    Expect(0, 1114111, '\P{ NChar}', "");
    Expect(1, 1114111, '\P{^ NChar}', "");
    Expect(0, 1114109, '\p{ NChar}', "");
    Expect(1, 1114109, '\p{^ NChar}', "");
    Expect(1, 1114109, '\P{ NChar}', "");
    Expect(0, 1114109, '\P{^ NChar}', "");
    Error('\p{/a/_Is_NChar}');
    Error('\P{/a/_Is_NChar}');
    Expect(1, 1114111, '\p{isnchar}', "");
    Expect(0, 1114111, '\p{^isnchar}', "");
    Expect(0, 1114111, '\P{isnchar}', "");
    Expect(1, 1114111, '\P{^isnchar}', "");
    Expect(0, 1114109, '\p{isnchar}', "");
    Expect(1, 1114109, '\p{^isnchar}', "");
    Expect(1, 1114109, '\P{isnchar}', "");
    Expect(0, 1114109, '\P{^isnchar}', "");
    Expect(1, 1114111, '\p{	_Is_NCHAR}', "");
    Expect(0, 1114111, '\p{^	_Is_NCHAR}', "");
    Expect(0, 1114111, '\P{	_Is_NCHAR}', "");
    Expect(1, 1114111, '\P{^	_Is_NCHAR}', "");
    Expect(0, 1114109, '\p{	_Is_NCHAR}', "");
    Expect(1, 1114109, '\p{^	_Is_NCHAR}', "");
    Expect(1, 1114109, '\P{	_Is_NCHAR}', "");
    Expect(0, 1114109, '\P{^	_Is_NCHAR}', "");
    Error('\p{	NONSPACING_mark:=}');
    Error('\P{	NONSPACING_mark:=}');
    Expect(1, 917999, '\p{nonspacingmark}', "");
    Expect(0, 917999, '\p{^nonspacingmark}', "");
    Expect(0, 917999, '\P{nonspacingmark}', "");
    Expect(1, 917999, '\P{^nonspacingmark}', "");
    Expect(0, 918000, '\p{nonspacingmark}', "");
    Expect(1, 918000, '\p{^nonspacingmark}', "");
    Expect(1, 918000, '\P{nonspacingmark}', "");
    Expect(0, 918000, '\P{^nonspacingmark}', "");
    Expect(1, 917999, '\p{-_nonspacing_mark}', "");
    Expect(0, 917999, '\p{^-_nonspacing_mark}', "");
    Expect(0, 917999, '\P{-_nonspacing_mark}', "");
    Expect(1, 917999, '\P{^-_nonspacing_mark}', "");
    Expect(0, 918000, '\p{-_nonspacing_mark}', "");
    Expect(1, 918000, '\p{^-_nonspacing_mark}', "");
    Expect(1, 918000, '\P{-_nonspacing_mark}', "");
    Expect(0, 918000, '\P{^-_nonspacing_mark}', "");
    Error('\p{:= _Is_NONSPACING_Mark}');
    Error('\P{:= _Is_NONSPACING_Mark}');
    Expect(1, 917999, '\p{isnonspacingmark}', "");
    Expect(0, 917999, '\p{^isnonspacingmark}', "");
    Expect(0, 917999, '\P{isnonspacingmark}', "");
    Expect(1, 917999, '\P{^isnonspacingmark}', "");
    Expect(0, 918000, '\p{isnonspacingmark}', "");
    Expect(1, 918000, '\p{^isnonspacingmark}', "");
    Expect(1, 918000, '\P{isnonspacingmark}', "");
    Expect(0, 918000, '\P{^isnonspacingmark}', "");
    Expect(1, 917999, '\p{--IS_Nonspacing_mark}', "");
    Expect(0, 917999, '\p{^--IS_Nonspacing_mark}', "");
    Expect(0, 917999, '\P{--IS_Nonspacing_mark}', "");
    Expect(1, 917999, '\P{^--IS_Nonspacing_mark}', "");
    Expect(0, 918000, '\p{--IS_Nonspacing_mark}', "");
    Expect(1, 918000, '\p{^--IS_Nonspacing_mark}', "");
    Expect(1, 918000, '\P{--IS_Nonspacing_mark}', "");
    Expect(0, 918000, '\P{^--IS_Nonspacing_mark}', "");
    Error('\p{:=	 Mn}');
    Error('\P{:=	 Mn}');
    Expect(1, 917999, '\p{mn}', "");
    Expect(0, 917999, '\p{^mn}', "");
    Expect(0, 917999, '\P{mn}', "");
    Expect(1, 917999, '\P{^mn}', "");
    Expect(0, 918000, '\p{mn}', "");
    Expect(1, 918000, '\p{^mn}', "");
    Expect(1, 918000, '\P{mn}', "");
    Expect(0, 918000, '\P{^mn}', "");
    Expect(1, 917999, '\p{_-Mn}', "");
    Expect(0, 917999, '\p{^_-Mn}', "");
    Expect(0, 917999, '\P{_-Mn}', "");
    Expect(1, 917999, '\P{^_-Mn}', "");
    Expect(0, 918000, '\p{_-Mn}', "");
    Expect(1, 918000, '\p{^_-Mn}', "");
    Expect(1, 918000, '\P{_-Mn}', "");
    Expect(0, 918000, '\P{^_-Mn}', "");
    Error('\p{ IS_Mn:=}');
    Error('\P{ IS_Mn:=}');
    Expect(1, 917999, '\p{ismn}', "");
    Expect(0, 917999, '\p{^ismn}', "");
    Expect(0, 917999, '\P{ismn}', "");
    Expect(1, 917999, '\P{^ismn}', "");
    Expect(0, 918000, '\p{ismn}', "");
    Expect(1, 918000, '\p{^ismn}', "");
    Expect(1, 918000, '\P{ismn}', "");
    Expect(0, 918000, '\P{^ismn}', "");
    Expect(1, 917999, '\p{ 	Is_MN}', "");
    Expect(0, 917999, '\p{^ 	Is_MN}', "");
    Expect(0, 917999, '\P{ 	Is_MN}', "");
    Expect(1, 917999, '\P{^ 	Is_MN}', "");
    Expect(0, 918000, '\p{ 	Is_MN}', "");
    Expect(1, 918000, '\p{^ 	Is_MN}', "");
    Expect(1, 918000, '\P{ 	Is_MN}', "");
    Expect(0, 918000, '\P{^ 	Is_MN}', "");
    Error('\p{ number:=}');
    Error('\P{ number:=}');
    Expect(1, 130041, '\p{number}', "");
    Expect(0, 130041, '\p{^number}', "");
    Expect(0, 130041, '\P{number}', "");
    Expect(1, 130041, '\P{^number}', "");
    Expect(0, 130042, '\p{number}', "");
    Expect(1, 130042, '\p{^number}', "");
    Expect(1, 130042, '\P{number}', "");
    Expect(0, 130042, '\P{^number}', "");
    Expect(1, 130041, '\p{	-Number}', "");
    Expect(0, 130041, '\p{^	-Number}', "");
    Expect(0, 130041, '\P{	-Number}', "");
    Expect(1, 130041, '\P{^	-Number}', "");
    Expect(0, 130042, '\p{	-Number}', "");
    Expect(1, 130042, '\p{^	-Number}', "");
    Expect(1, 130042, '\P{	-Number}', "");
    Expect(0, 130042, '\P{^	-Number}', "");
    Error('\p{:=	_is_number}');
    Error('\P{:=	_is_number}');
    Expect(1, 130041, '\p{isnumber}', "");
    Expect(0, 130041, '\p{^isnumber}', "");
    Expect(0, 130041, '\P{isnumber}', "");
    Expect(1, 130041, '\P{^isnumber}', "");
    Expect(0, 130042, '\p{isnumber}', "");
    Expect(1, 130042, '\p{^isnumber}', "");
    Expect(1, 130042, '\P{isnumber}', "");
    Expect(0, 130042, '\P{^isnumber}', "");
    Expect(1, 130041, '\p{		Is_Number}', "");
    Expect(0, 130041, '\p{^		Is_Number}', "");
    Expect(0, 130041, '\P{		Is_Number}', "");
    Expect(1, 130041, '\P{^		Is_Number}', "");
    Expect(0, 130042, '\p{		Is_Number}', "");
    Expect(1, 130042, '\p{^		Is_Number}', "");
    Expect(1, 130042, '\P{		Is_Number}', "");
    Expect(0, 130042, '\P{^		Is_Number}', "");
    Error('\p{/a/-_N}');
    Error('\P{/a/-_N}');
    Expect(1, 130041, '\p{n}', "");
    Expect(0, 130041, '\p{^n}', "");
    Expect(0, 130041, '\P{n}', "");
    Expect(1, 130041, '\P{^n}', "");
    Expect(0, 130042, '\p{n}', "");
    Expect(1, 130042, '\p{^n}', "");
    Expect(1, 130042, '\P{n}', "");
    Expect(0, 130042, '\P{^n}', "");
    Expect(1, 130041, '\p{  N}', "");
    Expect(0, 130041, '\p{^  N}', "");
    Expect(0, 130041, '\P{  N}', "");
    Expect(1, 130041, '\P{^  N}', "");
    Expect(0, 130042, '\p{  N}', "");
    Expect(1, 130042, '\p{^  N}', "");
    Expect(1, 130042, '\P{  N}', "");
    Expect(0, 130042, '\P{^  N}', "");
    Error('\p{_	Is_N:=}');
    Error('\P{_	Is_N:=}');
    Expect(1, 130041, '\p{isn}', "");
    Expect(0, 130041, '\p{^isn}', "");
    Expect(0, 130041, '\P{isn}', "");
    Expect(1, 130041, '\P{^isn}', "");
    Expect(0, 130042, '\p{isn}', "");
    Expect(1, 130042, '\p{^isn}', "");
    Expect(1, 130042, '\P{isn}', "");
    Expect(0, 130042, '\P{^isn}', "");
    Expect(1, 130041, '\p{	_Is_N}', "");
    Expect(0, 130041, '\p{^	_Is_N}', "");
    Expect(0, 130041, '\P{	_Is_N}', "");
    Expect(1, 130041, '\P{^	_Is_N}', "");
    Expect(0, 130042, '\p{	_Is_N}', "");
    Expect(1, 130042, '\p{^	_Is_N}', "");
    Expect(1, 130042, '\P{	_Is_N}', "");
    Expect(0, 130042, '\P{^	_Is_N}', "");
    Error('\p{_-Number_FORMS/a/}');
    Error('\P{_-Number_FORMS/a/}');
    Expect(1, 8591, '\p{numberforms}', "");
    Expect(0, 8591, '\p{^numberforms}', "");
    Expect(0, 8591, '\P{numberforms}', "");
    Expect(1, 8591, '\P{^numberforms}', "");
    Expect(0, 8592, '\p{numberforms}', "");
    Expect(1, 8592, '\p{^numberforms}', "");
    Expect(1, 8592, '\P{numberforms}', "");
    Expect(0, 8592, '\P{^numberforms}', "");
    Expect(1, 8591, '\p{-Number_Forms}', "");
    Expect(0, 8591, '\p{^-Number_Forms}', "");
    Expect(0, 8591, '\P{-Number_Forms}', "");
    Expect(1, 8591, '\P{^-Number_Forms}', "");
    Expect(0, 8592, '\p{-Number_Forms}', "");
    Expect(1, 8592, '\p{^-Number_Forms}', "");
    Expect(1, 8592, '\P{-Number_Forms}', "");
    Expect(0, 8592, '\P{^-Number_Forms}', "");
    Error('\p{_/a/is_number_Forms}');
    Error('\P{_/a/is_number_Forms}');
    Expect(1, 8591, '\p{isnumberforms}', "");
    Expect(0, 8591, '\p{^isnumberforms}', "");
    Expect(0, 8591, '\P{isnumberforms}', "");
    Expect(1, 8591, '\P{^isnumberforms}', "");
    Expect(0, 8592, '\p{isnumberforms}', "");
    Expect(1, 8592, '\p{^isnumberforms}', "");
    Expect(1, 8592, '\P{isnumberforms}', "");
    Expect(0, 8592, '\P{^isnumberforms}', "");
    Expect(1, 8591, '\p{  Is_Number_forms}', "");
    Expect(0, 8591, '\p{^  Is_Number_forms}', "");
    Expect(0, 8591, '\P{  Is_Number_forms}', "");
    Expect(1, 8591, '\P{^  Is_Number_forms}', "");
    Expect(0, 8592, '\p{  Is_Number_forms}', "");
    Expect(1, 8592, '\p{^  Is_Number_forms}', "");
    Expect(1, 8592, '\P{  Is_Number_forms}', "");
    Expect(0, 8592, '\P{^  Is_Number_forms}', "");
    Error('\p{-/a/In_Number_Forms}');
    Error('\P{-/a/In_Number_Forms}');
    Expect(1, 8591, '\p{innumberforms}', "");
    Expect(0, 8591, '\p{^innumberforms}', "");
    Expect(0, 8591, '\P{innumberforms}', "");
    Expect(1, 8591, '\P{^innumberforms}', "");
    Expect(0, 8592, '\p{innumberforms}', "");
    Expect(1, 8592, '\p{^innumberforms}', "");
    Expect(1, 8592, '\P{innumberforms}', "");
    Expect(0, 8592, '\P{^innumberforms}', "");
    Expect(1, 8591, '\p{-	in_number_Forms}', "");
    Expect(0, 8591, '\p{^-	in_number_Forms}', "");
    Expect(0, 8591, '\P{-	in_number_Forms}', "");
    Expect(1, 8591, '\P{^-	in_number_Forms}', "");
    Expect(0, 8592, '\p{-	in_number_Forms}', "");
    Expect(1, 8592, '\p{^-	in_number_Forms}', "");
    Expect(1, 8592, '\P{-	in_number_Forms}', "");
    Expect(0, 8592, '\P{^-	in_number_Forms}', "");
    Error('\p{-	NUSHU/a/}');
    Error('\P{-	NUSHU/a/}');
    Expect(1, 111355, '\p{nushu}', "");
    Expect(0, 111355, '\p{^nushu}', "");
    Expect(0, 111355, '\P{nushu}', "");
    Expect(1, 111355, '\P{^nushu}', "");
    Expect(0, 111356, '\p{nushu}', "");
    Expect(1, 111356, '\p{^nushu}', "");
    Expect(1, 111356, '\P{nushu}', "");
    Expect(0, 111356, '\P{^nushu}', "");
    Expect(1, 111355, '\p{NUSHU}', "");
    Expect(0, 111355, '\p{^NUSHU}', "");
    Expect(0, 111355, '\P{NUSHU}', "");
    Expect(1, 111355, '\P{^NUSHU}', "");
    Expect(0, 111356, '\p{NUSHU}', "");
    Expect(1, 111356, '\p{^NUSHU}', "");
    Expect(1, 111356, '\P{NUSHU}', "");
    Expect(0, 111356, '\P{^NUSHU}', "");
    Error('\p{  Is_Nushu/a/}');
    Error('\P{  Is_Nushu/a/}');
    Expect(1, 111355, '\p{isnushu}', "");
    Expect(0, 111355, '\p{^isnushu}', "");
    Expect(0, 111355, '\P{isnushu}', "");
    Expect(1, 111355, '\P{^isnushu}', "");
    Expect(0, 111356, '\p{isnushu}', "");
    Expect(1, 111356, '\p{^isnushu}', "");
    Expect(1, 111356, '\P{isnushu}', "");
    Expect(0, 111356, '\P{^isnushu}', "");
    Expect(1, 111355, '\p{--Is_Nushu}', "");
    Expect(0, 111355, '\p{^--Is_Nushu}', "");
    Expect(0, 111355, '\P{--Is_Nushu}', "");
    Expect(1, 111355, '\P{^--Is_Nushu}', "");
    Expect(0, 111356, '\p{--Is_Nushu}', "");
    Expect(1, 111356, '\p{^--Is_Nushu}', "");
    Expect(1, 111356, '\P{--Is_Nushu}', "");
    Expect(0, 111356, '\P{^--Is_Nushu}', "");
    Error('\p{/a/  NSHU}');
    Error('\P{/a/  NSHU}');
    Expect(1, 111355, '\p{nshu}', "");
    Expect(0, 111355, '\p{^nshu}', "");
    Expect(0, 111355, '\P{nshu}', "");
    Expect(1, 111355, '\P{^nshu}', "");
    Expect(0, 111356, '\p{nshu}', "");
    Expect(1, 111356, '\p{^nshu}', "");
    Expect(1, 111356, '\P{nshu}', "");
    Expect(0, 111356, '\P{^nshu}', "");
    Expect(1, 111355, '\p{_ Nshu}', "");
    Expect(0, 111355, '\p{^_ Nshu}', "");
    Expect(0, 111355, '\P{_ Nshu}', "");
    Expect(1, 111355, '\P{^_ Nshu}', "");
    Expect(0, 111356, '\p{_ Nshu}', "");
    Expect(1, 111356, '\p{^_ Nshu}', "");
    Expect(1, 111356, '\P{_ Nshu}', "");
    Expect(0, 111356, '\P{^_ Nshu}', "");
    Error('\p{	 Is_NSHU/a/}');
    Error('\P{	 Is_NSHU/a/}');
    Expect(1, 111355, '\p{isnshu}', "");
    Expect(0, 111355, '\p{^isnshu}', "");
    Expect(0, 111355, '\P{isnshu}', "");
    Expect(1, 111355, '\P{^isnshu}', "");
    Expect(0, 111356, '\p{isnshu}', "");
    Expect(1, 111356, '\p{^isnshu}', "");
    Expect(1, 111356, '\P{isnshu}', "");
    Expect(0, 111356, '\P{^isnshu}', "");
    Expect(1, 111355, '\p{ -Is_NSHU}', "");
    Expect(0, 111355, '\p{^ -Is_NSHU}', "");
    Expect(0, 111355, '\P{ -Is_NSHU}', "");
    Expect(1, 111355, '\P{^ -Is_NSHU}', "");
    Expect(0, 111356, '\p{ -Is_NSHU}', "");
    Expect(1, 111356, '\p{^ -Is_NSHU}', "");
    Expect(1, 111356, '\P{ -Is_NSHU}', "");
    Expect(0, 111356, '\P{^ -Is_NSHU}', "");
    Error('\p{_nyiakeng_puachue_Hmong/a/}');
    Error('\P{_nyiakeng_puachue_Hmong/a/}');
    Expect(1, 123215, '\p{nyiakengpuachuehmong}', "");
    Expect(0, 123215, '\p{^nyiakengpuachuehmong}', "");
    Expect(0, 123215, '\P{nyiakengpuachuehmong}', "");
    Expect(1, 123215, '\P{^nyiakengpuachuehmong}', "");
    Expect(0, 123216, '\p{nyiakengpuachuehmong}', "");
    Expect(1, 123216, '\p{^nyiakengpuachuehmong}', "");
    Expect(1, 123216, '\P{nyiakengpuachuehmong}', "");
    Expect(0, 123216, '\P{^nyiakengpuachuehmong}', "");
    Expect(1, 123215, '\p{-	Nyiakeng_puachue_hmong}', "");
    Expect(0, 123215, '\p{^-	Nyiakeng_puachue_hmong}', "");
    Expect(0, 123215, '\P{-	Nyiakeng_puachue_hmong}', "");
    Expect(1, 123215, '\P{^-	Nyiakeng_puachue_hmong}', "");
    Expect(0, 123216, '\p{-	Nyiakeng_puachue_hmong}', "");
    Expect(1, 123216, '\p{^-	Nyiakeng_puachue_hmong}', "");
    Expect(1, 123216, '\P{-	Nyiakeng_puachue_hmong}', "");
    Expect(0, 123216, '\P{^-	Nyiakeng_puachue_hmong}', "");
    Error('\p{	Is_Nyiakeng_Puachue_hmong/a/}');
    Error('\P{	Is_Nyiakeng_Puachue_hmong/a/}');
    Expect(1, 123215, '\p{isnyiakengpuachuehmong}', "");
    Expect(0, 123215, '\p{^isnyiakengpuachuehmong}', "");
    Expect(0, 123215, '\P{isnyiakengpuachuehmong}', "");
    Expect(1, 123215, '\P{^isnyiakengpuachuehmong}', "");
    Expect(0, 123216, '\p{isnyiakengpuachuehmong}', "");
    Expect(1, 123216, '\p{^isnyiakengpuachuehmong}', "");
    Expect(1, 123216, '\P{isnyiakengpuachuehmong}', "");
    Expect(0, 123216, '\P{^isnyiakengpuachuehmong}', "");
    Expect(1, 123215, '\p{ Is_nyiakeng_PUACHUE_hmong}', "");
    Expect(0, 123215, '\p{^ Is_nyiakeng_PUACHUE_hmong}', "");
    Expect(0, 123215, '\P{ Is_nyiakeng_PUACHUE_hmong}', "");
    Expect(1, 123215, '\P{^ Is_nyiakeng_PUACHUE_hmong}', "");
    Expect(0, 123216, '\p{ Is_nyiakeng_PUACHUE_hmong}', "");
    Expect(1, 123216, '\p{^ Is_nyiakeng_PUACHUE_hmong}', "");
    Expect(1, 123216, '\P{ Is_nyiakeng_PUACHUE_hmong}', "");
    Expect(0, 123216, '\P{^ Is_nyiakeng_PUACHUE_hmong}', "");
    Error('\p{_-Hmnp:=}');
    Error('\P{_-Hmnp:=}');
    Expect(1, 123215, '\p{hmnp}', "");
    Expect(0, 123215, '\p{^hmnp}', "");
    Expect(0, 123215, '\P{hmnp}', "");
    Expect(1, 123215, '\P{^hmnp}', "");
    Expect(0, 123216, '\p{hmnp}', "");
    Expect(1, 123216, '\p{^hmnp}', "");
    Expect(1, 123216, '\P{hmnp}', "");
    Expect(0, 123216, '\P{^hmnp}', "");
    Expect(1, 123215, '\p{		Hmnp}', "");
    Expect(0, 123215, '\p{^		Hmnp}', "");
    Expect(0, 123215, '\P{		Hmnp}', "");
    Expect(1, 123215, '\P{^		Hmnp}', "");
    Expect(0, 123216, '\p{		Hmnp}', "");
    Expect(1, 123216, '\p{^		Hmnp}', "");
    Expect(1, 123216, '\P{		Hmnp}', "");
    Expect(0, 123216, '\P{^		Hmnp}', "");
    Error('\p{:=		Is_Hmnp}');
    Error('\P{:=		Is_Hmnp}');
    Expect(1, 123215, '\p{ishmnp}', "");
    Expect(0, 123215, '\p{^ishmnp}', "");
    Expect(0, 123215, '\P{ishmnp}', "");
    Expect(1, 123215, '\P{^ishmnp}', "");
    Expect(0, 123216, '\p{ishmnp}', "");
    Expect(1, 123216, '\p{^ishmnp}', "");
    Expect(1, 123216, '\P{ishmnp}', "");
    Expect(0, 123216, '\P{^ishmnp}', "");
    Expect(1, 123215, '\p{	-is_Hmnp}', "");
    Expect(0, 123215, '\p{^	-is_Hmnp}', "");
    Expect(0, 123215, '\P{	-is_Hmnp}', "");
    Expect(1, 123215, '\P{^	-is_Hmnp}', "");
    Expect(0, 123216, '\p{	-is_Hmnp}', "");
    Expect(1, 123216, '\p{^	-is_Hmnp}', "");
    Expect(1, 123216, '\P{	-is_Hmnp}', "");
    Expect(0, 123216, '\P{^	-is_Hmnp}', "");
    Error('\p{	/a/Ogham}');
    Error('\P{	/a/Ogham}');
    Expect(1, 5788, '\p{ogham}', "");
    Expect(0, 5788, '\p{^ogham}', "");
    Expect(0, 5788, '\P{ogham}', "");
    Expect(1, 5788, '\P{^ogham}', "");
    Expect(0, 5789, '\p{ogham}', "");
    Expect(1, 5789, '\p{^ogham}', "");
    Expect(1, 5789, '\P{ogham}', "");
    Expect(0, 5789, '\P{^ogham}', "");
    Expect(1, 5788, '\p{- ogham}', "");
    Expect(0, 5788, '\p{^- ogham}', "");
    Expect(0, 5788, '\P{- ogham}', "");
    Expect(1, 5788, '\P{^- ogham}', "");
    Expect(0, 5789, '\p{- ogham}', "");
    Expect(1, 5789, '\p{^- ogham}', "");
    Expect(1, 5789, '\P{- ogham}', "");
    Expect(0, 5789, '\P{^- ogham}', "");
    Error('\p{-_IS_Ogham:=}');
    Error('\P{-_IS_Ogham:=}');
    Expect(1, 5788, '\p{isogham}', "");
    Expect(0, 5788, '\p{^isogham}', "");
    Expect(0, 5788, '\P{isogham}', "");
    Expect(1, 5788, '\P{^isogham}', "");
    Expect(0, 5789, '\p{isogham}', "");
    Expect(1, 5789, '\p{^isogham}', "");
    Expect(1, 5789, '\P{isogham}', "");
    Expect(0, 5789, '\P{^isogham}', "");
    Expect(1, 5788, '\p{Is_Ogham}', "");
    Expect(0, 5788, '\p{^Is_Ogham}', "");
    Expect(0, 5788, '\P{Is_Ogham}', "");
    Expect(1, 5788, '\P{^Is_Ogham}', "");
    Expect(0, 5789, '\p{Is_Ogham}', "");
    Expect(1, 5789, '\p{^Is_Ogham}', "");
    Expect(1, 5789, '\P{Is_Ogham}', "");
    Expect(0, 5789, '\P{^Is_Ogham}', "");
    Error('\p{_:=Ogam}');
    Error('\P{_:=Ogam}');
    Expect(1, 5788, '\p{ogam}', "");
    Expect(0, 5788, '\p{^ogam}', "");
    Expect(0, 5788, '\P{ogam}', "");
    Expect(1, 5788, '\P{^ogam}', "");
    Expect(0, 5789, '\p{ogam}', "");
    Expect(1, 5789, '\p{^ogam}', "");
    Expect(1, 5789, '\P{ogam}', "");
    Expect(0, 5789, '\P{^ogam}', "");
    Expect(1, 5788, '\p{-_ogam}', "");
    Expect(0, 5788, '\p{^-_ogam}', "");
    Expect(0, 5788, '\P{-_ogam}', "");
    Expect(1, 5788, '\P{^-_ogam}', "");
    Expect(0, 5789, '\p{-_ogam}', "");
    Expect(1, 5789, '\p{^-_ogam}', "");
    Expect(1, 5789, '\P{-_ogam}', "");
    Expect(0, 5789, '\P{^-_ogam}', "");
    Error('\p{-:=Is_ogam}');
    Error('\P{-:=Is_ogam}');
    Expect(1, 5788, '\p{isogam}', "");
    Expect(0, 5788, '\p{^isogam}', "");
    Expect(0, 5788, '\P{isogam}', "");
    Expect(1, 5788, '\P{^isogam}', "");
    Expect(0, 5789, '\p{isogam}', "");
    Expect(1, 5789, '\p{^isogam}', "");
    Expect(1, 5789, '\P{isogam}', "");
    Expect(0, 5789, '\P{^isogam}', "");
    Expect(1, 5788, '\p{		IS_Ogam}', "");
    Expect(0, 5788, '\p{^		IS_Ogam}', "");
    Expect(0, 5788, '\P{		IS_Ogam}', "");
    Expect(1, 5788, '\P{^		IS_Ogam}', "");
    Expect(0, 5789, '\p{		IS_Ogam}', "");
    Expect(1, 5789, '\p{^		IS_Ogam}', "");
    Expect(1, 5789, '\P{		IS_Ogam}', "");
    Expect(0, 5789, '\P{^		IS_Ogam}', "");
    Error('\p{/a/_ Ol_Chiki}');
    Error('\P{/a/_ Ol_Chiki}');
    Expect(1, 7295, '\p{olchiki}', "");
    Expect(0, 7295, '\p{^olchiki}', "");
    Expect(0, 7295, '\P{olchiki}', "");
    Expect(1, 7295, '\P{^olchiki}', "");
    Expect(0, 7296, '\p{olchiki}', "");
    Expect(1, 7296, '\p{^olchiki}', "");
    Expect(1, 7296, '\P{olchiki}', "");
    Expect(0, 7296, '\P{^olchiki}', "");
    Expect(1, 7295, '\p{--OL_CHIKI}', "");
    Expect(0, 7295, '\p{^--OL_CHIKI}', "");
    Expect(0, 7295, '\P{--OL_CHIKI}', "");
    Expect(1, 7295, '\P{^--OL_CHIKI}', "");
    Expect(0, 7296, '\p{--OL_CHIKI}', "");
    Expect(1, 7296, '\p{^--OL_CHIKI}', "");
    Expect(1, 7296, '\P{--OL_CHIKI}', "");
    Expect(0, 7296, '\P{^--OL_CHIKI}', "");
    Error('\p{/a/		Is_ol_chiki}');
    Error('\P{/a/		Is_ol_chiki}');
    Expect(1, 7295, '\p{isolchiki}', "");
    Expect(0, 7295, '\p{^isolchiki}', "");
    Expect(0, 7295, '\P{isolchiki}', "");
    Expect(1, 7295, '\P{^isolchiki}', "");
    Expect(0, 7296, '\p{isolchiki}', "");
    Expect(1, 7296, '\p{^isolchiki}', "");
    Expect(1, 7296, '\P{isolchiki}', "");
    Expect(0, 7296, '\P{^isolchiki}', "");
    Expect(1, 7295, '\p{--is_OL_CHIKI}', "");
    Expect(0, 7295, '\p{^--is_OL_CHIKI}', "");
    Expect(0, 7295, '\P{--is_OL_CHIKI}', "");
    Expect(1, 7295, '\P{^--is_OL_CHIKI}', "");
    Expect(0, 7296, '\p{--is_OL_CHIKI}', "");
    Expect(1, 7296, '\p{^--is_OL_CHIKI}', "");
    Expect(1, 7296, '\P{--is_OL_CHIKI}', "");
    Expect(0, 7296, '\P{^--is_OL_CHIKI}', "");
    Error('\p{-_Olck/a/}');
    Error('\P{-_Olck/a/}');
    Expect(1, 7295, '\p{olck}', "");
    Expect(0, 7295, '\p{^olck}', "");
    Expect(0, 7295, '\P{olck}', "");
    Expect(1, 7295, '\P{^olck}', "");
    Expect(0, 7296, '\p{olck}', "");
    Expect(1, 7296, '\p{^olck}', "");
    Expect(1, 7296, '\P{olck}', "");
    Expect(0, 7296, '\P{^olck}', "");
    Expect(1, 7295, '\p{ olck}', "");
    Expect(0, 7295, '\p{^ olck}', "");
    Expect(0, 7295, '\P{ olck}', "");
    Expect(1, 7295, '\P{^ olck}', "");
    Expect(0, 7296, '\p{ olck}', "");
    Expect(1, 7296, '\p{^ olck}', "");
    Expect(1, 7296, '\P{ olck}', "");
    Expect(0, 7296, '\P{^ olck}', "");
    Error('\p{/a/ IS_Olck}');
    Error('\P{/a/ IS_Olck}');
    Expect(1, 7295, '\p{isolck}', "");
    Expect(0, 7295, '\p{^isolck}', "");
    Expect(0, 7295, '\P{isolck}', "");
    Expect(1, 7295, '\P{^isolck}', "");
    Expect(0, 7296, '\p{isolck}', "");
    Expect(1, 7296, '\p{^isolck}', "");
    Expect(1, 7296, '\P{isolck}', "");
    Expect(0, 7296, '\P{^isolck}', "");
    Expect(1, 7295, '\p{	Is_Olck}', "");
    Expect(0, 7295, '\p{^	Is_Olck}', "");
    Expect(0, 7295, '\P{	Is_Olck}', "");
    Expect(1, 7295, '\P{^	Is_Olck}', "");
    Expect(0, 7296, '\p{	Is_Olck}', "");
    Expect(1, 7296, '\p{^	Is_Olck}', "");
    Expect(1, 7296, '\P{	Is_Olck}', "");
    Expect(0, 7296, '\P{^	Is_Olck}', "");
    Error('\p{:=_	Old_hungarian}');
    Error('\P{:=_	Old_hungarian}');
    Expect(1, 68863, '\p{oldhungarian}', "");
    Expect(0, 68863, '\p{^oldhungarian}', "");
    Expect(0, 68863, '\P{oldhungarian}', "");
    Expect(1, 68863, '\P{^oldhungarian}', "");
    Expect(0, 68864, '\p{oldhungarian}', "");
    Expect(1, 68864, '\p{^oldhungarian}', "");
    Expect(1, 68864, '\P{oldhungarian}', "");
    Expect(0, 68864, '\P{^oldhungarian}', "");
    Expect(1, 68863, '\p{_-Old_HUNGARIAN}', "");
    Expect(0, 68863, '\p{^_-Old_HUNGARIAN}', "");
    Expect(0, 68863, '\P{_-Old_HUNGARIAN}', "");
    Expect(1, 68863, '\P{^_-Old_HUNGARIAN}', "");
    Expect(0, 68864, '\p{_-Old_HUNGARIAN}', "");
    Expect(1, 68864, '\p{^_-Old_HUNGARIAN}', "");
    Expect(1, 68864, '\P{_-Old_HUNGARIAN}', "");
    Expect(0, 68864, '\P{^_-Old_HUNGARIAN}', "");
    Error('\p{/a/	_IS_old_Hungarian}');
    Error('\P{/a/	_IS_old_Hungarian}');
    Expect(1, 68863, '\p{isoldhungarian}', "");
    Expect(0, 68863, '\p{^isoldhungarian}', "");
    Expect(0, 68863, '\P{isoldhungarian}', "");
    Expect(1, 68863, '\P{^isoldhungarian}', "");
    Expect(0, 68864, '\p{isoldhungarian}', "");
    Expect(1, 68864, '\p{^isoldhungarian}', "");
    Expect(1, 68864, '\P{isoldhungarian}', "");
    Expect(0, 68864, '\P{^isoldhungarian}', "");
    Expect(1, 68863, '\p{__Is_old_Hungarian}', "");
    Expect(0, 68863, '\p{^__Is_old_Hungarian}', "");
    Expect(0, 68863, '\P{__Is_old_Hungarian}', "");
    Expect(1, 68863, '\P{^__Is_old_Hungarian}', "");
    Expect(0, 68864, '\p{__Is_old_Hungarian}', "");
    Expect(1, 68864, '\p{^__Is_old_Hungarian}', "");
    Expect(1, 68864, '\P{__Is_old_Hungarian}', "");
    Expect(0, 68864, '\P{^__Is_old_Hungarian}', "");
    Error('\p{_/a/Hung}');
    Error('\P{_/a/Hung}');
    Expect(1, 68863, '\p{hung}', "");
    Expect(0, 68863, '\p{^hung}', "");
    Expect(0, 68863, '\P{hung}', "");
    Expect(1, 68863, '\P{^hung}', "");
    Expect(0, 68864, '\p{hung}', "");
    Expect(1, 68864, '\p{^hung}', "");
    Expect(1, 68864, '\P{hung}', "");
    Expect(0, 68864, '\P{^hung}', "");
    Expect(1, 68863, '\p{ -Hung}', "");
    Expect(0, 68863, '\p{^ -Hung}', "");
    Expect(0, 68863, '\P{ -Hung}', "");
    Expect(1, 68863, '\P{^ -Hung}', "");
    Expect(0, 68864, '\p{ -Hung}', "");
    Expect(1, 68864, '\p{^ -Hung}', "");
    Expect(1, 68864, '\P{ -Hung}', "");
    Expect(0, 68864, '\P{^ -Hung}', "");
    Error('\p{:= _is_Hung}');
    Error('\P{:= _is_Hung}');
    Expect(1, 68863, '\p{ishung}', "");
    Expect(0, 68863, '\p{^ishung}', "");
    Expect(0, 68863, '\P{ishung}', "");
    Expect(1, 68863, '\P{^ishung}', "");
    Expect(0, 68864, '\p{ishung}', "");
    Expect(1, 68864, '\p{^ishung}', "");
    Expect(1, 68864, '\P{ishung}', "");
    Expect(0, 68864, '\P{^ishung}', "");
    Expect(1, 68863, '\p{	 IS_Hung}', "");
    Expect(0, 68863, '\p{^	 IS_Hung}', "");
    Expect(0, 68863, '\P{	 IS_Hung}', "");
    Expect(1, 68863, '\P{^	 IS_Hung}', "");
    Expect(0, 68864, '\p{	 IS_Hung}', "");
    Expect(1, 68864, '\p{^	 IS_Hung}', "");
    Expect(1, 68864, '\P{	 IS_Hung}', "");
    Expect(0, 68864, '\P{^	 IS_Hung}', "");
    Error('\p{	_Old_italic/a/}');
    Error('\P{	_Old_italic/a/}');
    Expect(1, 66351, '\p{olditalic}', "");
    Expect(0, 66351, '\p{^olditalic}', "");
    Expect(0, 66351, '\P{olditalic}', "");
    Expect(1, 66351, '\P{^olditalic}', "");
    Expect(0, 66352, '\p{olditalic}', "");
    Expect(1, 66352, '\p{^olditalic}', "");
    Expect(1, 66352, '\P{olditalic}', "");
    Expect(0, 66352, '\P{^olditalic}', "");
    Expect(1, 66351, '\p{ Old_italic}', "");
    Expect(0, 66351, '\p{^ Old_italic}', "");
    Expect(0, 66351, '\P{ Old_italic}', "");
    Expect(1, 66351, '\P{^ Old_italic}', "");
    Expect(0, 66352, '\p{ Old_italic}', "");
    Expect(1, 66352, '\p{^ Old_italic}', "");
    Expect(1, 66352, '\P{ Old_italic}', "");
    Expect(0, 66352, '\P{^ Old_italic}', "");
    Error('\p{:=_	IS_Old_ITALIC}');
    Error('\P{:=_	IS_Old_ITALIC}');
    Expect(1, 66351, '\p{isolditalic}', "");
    Expect(0, 66351, '\p{^isolditalic}', "");
    Expect(0, 66351, '\P{isolditalic}', "");
    Expect(1, 66351, '\P{^isolditalic}', "");
    Expect(0, 66352, '\p{isolditalic}', "");
    Expect(1, 66352, '\p{^isolditalic}', "");
    Expect(1, 66352, '\P{isolditalic}', "");
    Expect(0, 66352, '\P{^isolditalic}', "");
    Expect(1, 66351, '\p{  is_OLD_ITALIC}', "");
    Expect(0, 66351, '\p{^  is_OLD_ITALIC}', "");
    Expect(0, 66351, '\P{  is_OLD_ITALIC}', "");
    Expect(1, 66351, '\P{^  is_OLD_ITALIC}', "");
    Expect(0, 66352, '\p{  is_OLD_ITALIC}', "");
    Expect(1, 66352, '\p{^  is_OLD_ITALIC}', "");
    Expect(1, 66352, '\P{  is_OLD_ITALIC}', "");
    Expect(0, 66352, '\P{^  is_OLD_ITALIC}', "");
    Error('\p{ :=Ital}');
    Error('\P{ :=Ital}');
    Expect(1, 66351, '\p{ital}', "");
    Expect(0, 66351, '\p{^ital}', "");
    Expect(0, 66351, '\P{ital}', "");
    Expect(1, 66351, '\P{^ital}', "");
    Expect(0, 66352, '\p{ital}', "");
    Expect(1, 66352, '\p{^ital}', "");
    Expect(1, 66352, '\P{ital}', "");
    Expect(0, 66352, '\P{^ital}', "");
    Expect(1, 66351, '\p{-_Ital}', "");
    Expect(0, 66351, '\p{^-_Ital}', "");
    Expect(0, 66351, '\P{-_Ital}', "");
    Expect(1, 66351, '\P{^-_Ital}', "");
    Expect(0, 66352, '\p{-_Ital}', "");
    Expect(1, 66352, '\p{^-_Ital}', "");
    Expect(1, 66352, '\P{-_Ital}', "");
    Expect(0, 66352, '\P{^-_Ital}', "");
    Error('\p{	IS_ITAL/a/}');
    Error('\P{	IS_ITAL/a/}');
    Expect(1, 66351, '\p{isital}', "");
    Expect(0, 66351, '\p{^isital}', "");
    Expect(0, 66351, '\P{isital}', "");
    Expect(1, 66351, '\P{^isital}', "");
    Expect(0, 66352, '\p{isital}', "");
    Expect(1, 66352, '\p{^isital}', "");
    Expect(1, 66352, '\P{isital}', "");
    Expect(0, 66352, '\P{^isital}', "");
    Expect(1, 66351, '\p{_is_ital}', "");
    Expect(0, 66351, '\p{^_is_ital}', "");
    Expect(0, 66351, '\P{_is_ital}', "");
    Expect(1, 66351, '\P{^_is_ital}', "");
    Expect(0, 66352, '\p{_is_ital}', "");
    Expect(1, 66352, '\p{^_is_ital}', "");
    Expect(1, 66352, '\P{_is_ital}', "");
    Expect(0, 66352, '\P{^_is_ital}', "");
    Error('\p{/a/ 	Old_North_Arabian}');
    Error('\P{/a/ 	Old_North_Arabian}');
    Expect(1, 68255, '\p{oldnortharabian}', "");
    Expect(0, 68255, '\p{^oldnortharabian}', "");
    Expect(0, 68255, '\P{oldnortharabian}', "");
    Expect(1, 68255, '\P{^oldnortharabian}', "");
    Expect(0, 68256, '\p{oldnortharabian}', "");
    Expect(1, 68256, '\p{^oldnortharabian}', "");
    Expect(1, 68256, '\P{oldnortharabian}', "");
    Expect(0, 68256, '\P{^oldnortharabian}', "");
    Expect(1, 68255, '\p{	old_north_ARABIAN}', "");
    Expect(0, 68255, '\p{^	old_north_ARABIAN}', "");
    Expect(0, 68255, '\P{	old_north_ARABIAN}', "");
    Expect(1, 68255, '\P{^	old_north_ARABIAN}', "");
    Expect(0, 68256, '\p{	old_north_ARABIAN}', "");
    Expect(1, 68256, '\p{^	old_north_ARABIAN}', "");
    Expect(1, 68256, '\P{	old_north_ARABIAN}', "");
    Expect(0, 68256, '\P{^	old_north_ARABIAN}', "");
    Error('\p{/a/--Is_old_North_Arabian}');
    Error('\P{/a/--Is_old_North_Arabian}');
    Expect(1, 68255, '\p{isoldnortharabian}', "");
    Expect(0, 68255, '\p{^isoldnortharabian}', "");
    Expect(0, 68255, '\P{isoldnortharabian}', "");
    Expect(1, 68255, '\P{^isoldnortharabian}', "");
    Expect(0, 68256, '\p{isoldnortharabian}', "");
    Expect(1, 68256, '\p{^isoldnortharabian}', "");
    Expect(1, 68256, '\P{isoldnortharabian}', "");
    Expect(0, 68256, '\P{^isoldnortharabian}', "");
    Expect(1, 68255, '\p{	Is_Old_North_Arabian}', "");
    Expect(0, 68255, '\p{^	Is_Old_North_Arabian}', "");
    Expect(0, 68255, '\P{	Is_Old_North_Arabian}', "");
    Expect(1, 68255, '\P{^	Is_Old_North_Arabian}', "");
    Expect(0, 68256, '\p{	Is_Old_North_Arabian}', "");
    Expect(1, 68256, '\p{^	Is_Old_North_Arabian}', "");
    Expect(1, 68256, '\P{	Is_Old_North_Arabian}', "");
    Expect(0, 68256, '\P{^	Is_Old_North_Arabian}', "");
    Error('\p{- Narb:=}');
    Error('\P{- Narb:=}');
    Expect(1, 68255, '\p{narb}', "");
    Expect(0, 68255, '\p{^narb}', "");
    Expect(0, 68255, '\P{narb}', "");
    Expect(1, 68255, '\P{^narb}', "");
    Expect(0, 68256, '\p{narb}', "");
    Expect(1, 68256, '\p{^narb}', "");
    Expect(1, 68256, '\P{narb}', "");
    Expect(0, 68256, '\P{^narb}', "");
    Expect(1, 68255, '\p{ 	Narb}', "");
    Expect(0, 68255, '\p{^ 	Narb}', "");
    Expect(0, 68255, '\P{ 	Narb}', "");
    Expect(1, 68255, '\P{^ 	Narb}', "");
    Expect(0, 68256, '\p{ 	Narb}', "");
    Expect(1, 68256, '\p{^ 	Narb}', "");
    Expect(1, 68256, '\P{ 	Narb}', "");
    Expect(0, 68256, '\P{^ 	Narb}', "");
    Error('\p{	Is_NARB:=}');
    Error('\P{	Is_NARB:=}');
    Expect(1, 68255, '\p{isnarb}', "");
    Expect(0, 68255, '\p{^isnarb}', "");
    Expect(0, 68255, '\P{isnarb}', "");
    Expect(1, 68255, '\P{^isnarb}', "");
    Expect(0, 68256, '\p{isnarb}', "");
    Expect(1, 68256, '\p{^isnarb}', "");
    Expect(1, 68256, '\P{isnarb}', "");
    Expect(0, 68256, '\P{^isnarb}', "");
    Expect(1, 68255, '\p{Is_narb}', "");
    Expect(0, 68255, '\p{^Is_narb}', "");
    Expect(0, 68255, '\P{Is_narb}', "");
    Expect(1, 68255, '\P{^Is_narb}', "");
    Expect(0, 68256, '\p{Is_narb}', "");
    Expect(1, 68256, '\p{^Is_narb}', "");
    Expect(1, 68256, '\P{Is_narb}', "");
    Expect(0, 68256, '\P{^Is_narb}', "");
    Error('\p{ -Old_Permic:=}');
    Error('\P{ -Old_Permic:=}');
    Expect(1, 66426, '\p{oldpermic}', "");
    Expect(0, 66426, '\p{^oldpermic}', "");
    Expect(0, 66426, '\P{oldpermic}', "");
    Expect(1, 66426, '\P{^oldpermic}', "");
    Expect(0, 66427, '\p{oldpermic}', "");
    Expect(1, 66427, '\p{^oldpermic}', "");
    Expect(1, 66427, '\P{oldpermic}', "");
    Expect(0, 66427, '\P{^oldpermic}', "");
    Expect(1, 66426, '\p{ -Old_Permic}', "");
    Expect(0, 66426, '\p{^ -Old_Permic}', "");
    Expect(0, 66426, '\P{ -Old_Permic}', "");
    Expect(1, 66426, '\P{^ -Old_Permic}', "");
    Expect(0, 66427, '\p{ -Old_Permic}', "");
    Expect(1, 66427, '\p{^ -Old_Permic}', "");
    Expect(1, 66427, '\P{ -Old_Permic}', "");
    Expect(0, 66427, '\P{^ -Old_Permic}', "");
    Error('\p{/a/Is_OLD_Permic}');
    Error('\P{/a/Is_OLD_Permic}');
    Expect(1, 66426, '\p{isoldpermic}', "");
    Expect(0, 66426, '\p{^isoldpermic}', "");
    Expect(0, 66426, '\P{isoldpermic}', "");
    Expect(1, 66426, '\P{^isoldpermic}', "");
    Expect(0, 66427, '\p{isoldpermic}', "");
    Expect(1, 66427, '\p{^isoldpermic}', "");
    Expect(1, 66427, '\P{isoldpermic}', "");
    Expect(0, 66427, '\P{^isoldpermic}', "");
    Expect(1, 66426, '\p{	 Is_OLD_Permic}', "");
    Expect(0, 66426, '\p{^	 Is_OLD_Permic}', "");
    Expect(0, 66426, '\P{	 Is_OLD_Permic}', "");
    Expect(1, 66426, '\P{^	 Is_OLD_Permic}', "");
    Expect(0, 66427, '\p{	 Is_OLD_Permic}', "");
    Expect(1, 66427, '\p{^	 Is_OLD_Permic}', "");
    Expect(1, 66427, '\P{	 Is_OLD_Permic}', "");
    Expect(0, 66427, '\P{^	 Is_OLD_Permic}', "");
    Error('\p{	Perm:=}');
    Error('\P{	Perm:=}');
    Expect(1, 66426, '\p{perm}', "");
    Expect(0, 66426, '\p{^perm}', "");
    Expect(0, 66426, '\P{perm}', "");
    Expect(1, 66426, '\P{^perm}', "");
    Expect(0, 66427, '\p{perm}', "");
    Expect(1, 66427, '\p{^perm}', "");
    Expect(1, 66427, '\P{perm}', "");
    Expect(0, 66427, '\P{^perm}', "");
    Expect(1, 66426, '\p{_ Perm}', "");
    Expect(0, 66426, '\p{^_ Perm}', "");
    Expect(0, 66426, '\P{_ Perm}', "");
    Expect(1, 66426, '\P{^_ Perm}', "");
    Expect(0, 66427, '\p{_ Perm}', "");
    Expect(1, 66427, '\p{^_ Perm}', "");
    Expect(1, 66427, '\P{_ Perm}', "");
    Expect(0, 66427, '\P{^_ Perm}', "");
    Error('\p{_/a/IS_perm}');
    Error('\P{_/a/IS_perm}');
    Expect(1, 66426, '\p{isperm}', "");
    Expect(0, 66426, '\p{^isperm}', "");
    Expect(0, 66426, '\P{isperm}', "");
    Expect(1, 66426, '\P{^isperm}', "");
    Expect(0, 66427, '\p{isperm}', "");
    Expect(1, 66427, '\p{^isperm}', "");
    Expect(1, 66427, '\P{isperm}', "");
    Expect(0, 66427, '\P{^isperm}', "");
    Expect(1, 66426, '\p{_Is_Perm}', "");
    Expect(0, 66426, '\p{^_Is_Perm}', "");
    Expect(0, 66426, '\P{_Is_Perm}', "");
    Expect(1, 66426, '\P{^_Is_Perm}', "");
    Expect(0, 66427, '\p{_Is_Perm}', "");
    Expect(1, 66427, '\p{^_Is_Perm}', "");
    Expect(1, 66427, '\P{_Is_Perm}', "");
    Expect(0, 66427, '\P{^_Is_Perm}', "");
    Error('\p{-:=Old_persian}');
    Error('\P{-:=Old_persian}');
    Expect(1, 66517, '\p{oldpersian}', "");
    Expect(0, 66517, '\p{^oldpersian}', "");
    Expect(0, 66517, '\P{oldpersian}', "");
    Expect(1, 66517, '\P{^oldpersian}', "");
    Expect(0, 66518, '\p{oldpersian}', "");
    Expect(1, 66518, '\p{^oldpersian}', "");
    Expect(1, 66518, '\P{oldpersian}', "");
    Expect(0, 66518, '\P{^oldpersian}', "");
    Expect(1, 66517, '\p{-	old_Persian}', "");
    Expect(0, 66517, '\p{^-	old_Persian}', "");
    Expect(0, 66517, '\P{-	old_Persian}', "");
    Expect(1, 66517, '\P{^-	old_Persian}', "");
    Expect(0, 66518, '\p{-	old_Persian}', "");
    Expect(1, 66518, '\p{^-	old_Persian}', "");
    Expect(1, 66518, '\P{-	old_Persian}', "");
    Expect(0, 66518, '\P{^-	old_Persian}', "");
    Error('\p{:=_ Is_Old_persian}');
    Error('\P{:=_ Is_Old_persian}');
    Expect(1, 66517, '\p{isoldpersian}', "");
    Expect(0, 66517, '\p{^isoldpersian}', "");
    Expect(0, 66517, '\P{isoldpersian}', "");
    Expect(1, 66517, '\P{^isoldpersian}', "");
    Expect(0, 66518, '\p{isoldpersian}', "");
    Expect(1, 66518, '\p{^isoldpersian}', "");
    Expect(1, 66518, '\P{isoldpersian}', "");
    Expect(0, 66518, '\P{^isoldpersian}', "");
    Expect(1, 66517, '\p{_is_old_PERSIAN}', "");
    Expect(0, 66517, '\p{^_is_old_PERSIAN}', "");
    Expect(0, 66517, '\P{_is_old_PERSIAN}', "");
    Expect(1, 66517, '\P{^_is_old_PERSIAN}', "");
    Expect(0, 66518, '\p{_is_old_PERSIAN}', "");
    Expect(1, 66518, '\p{^_is_old_PERSIAN}', "");
    Expect(1, 66518, '\P{_is_old_PERSIAN}', "");
    Expect(0, 66518, '\P{^_is_old_PERSIAN}', "");
    Error('\p{-/a/xpeo}');
    Error('\P{-/a/xpeo}');
    Expect(1, 66517, '\p{xpeo}', "");
    Expect(0, 66517, '\p{^xpeo}', "");
    Expect(0, 66517, '\P{xpeo}', "");
    Expect(1, 66517, '\P{^xpeo}', "");
    Expect(0, 66518, '\p{xpeo}', "");
    Expect(1, 66518, '\p{^xpeo}', "");
    Expect(1, 66518, '\P{xpeo}', "");
    Expect(0, 66518, '\P{^xpeo}', "");
    Expect(1, 66517, '\p{_XPEO}', "");
    Expect(0, 66517, '\p{^_XPEO}', "");
    Expect(0, 66517, '\P{_XPEO}', "");
    Expect(1, 66517, '\P{^_XPEO}', "");
    Expect(0, 66518, '\p{_XPEO}', "");
    Expect(1, 66518, '\p{^_XPEO}', "");
    Expect(1, 66518, '\P{_XPEO}', "");
    Expect(0, 66518, '\P{^_XPEO}', "");
    Error('\p{ IS_xpeo/a/}');
    Error('\P{ IS_xpeo/a/}');
    Expect(1, 66517, '\p{isxpeo}', "");
    Expect(0, 66517, '\p{^isxpeo}', "");
    Expect(0, 66517, '\P{isxpeo}', "");
    Expect(1, 66517, '\P{^isxpeo}', "");
    Expect(0, 66518, '\p{isxpeo}', "");
    Expect(1, 66518, '\p{^isxpeo}', "");
    Expect(1, 66518, '\P{isxpeo}', "");
    Expect(0, 66518, '\P{^isxpeo}', "");
    Expect(1, 66517, '\p{ Is_Xpeo}', "");
    Expect(0, 66517, '\p{^ Is_Xpeo}', "");
    Expect(0, 66517, '\P{ Is_Xpeo}', "");
    Expect(1, 66517, '\P{^ Is_Xpeo}', "");
    Expect(0, 66518, '\p{ Is_Xpeo}', "");
    Expect(1, 66518, '\p{^ Is_Xpeo}', "");
    Expect(1, 66518, '\P{ Is_Xpeo}', "");
    Expect(0, 66518, '\P{^ Is_Xpeo}', "");
    Error('\p{:=	Old_SOGDIAN}');
    Error('\P{:=	Old_SOGDIAN}');
    Expect(1, 69415, '\p{oldsogdian}', "");
    Expect(0, 69415, '\p{^oldsogdian}', "");
    Expect(0, 69415, '\P{oldsogdian}', "");
    Expect(1, 69415, '\P{^oldsogdian}', "");
    Expect(0, 69416, '\p{oldsogdian}', "");
    Expect(1, 69416, '\p{^oldsogdian}', "");
    Expect(1, 69416, '\P{oldsogdian}', "");
    Expect(0, 69416, '\P{^oldsogdian}', "");
    Expect(1, 69415, '\p{- OLD_SOGDIAN}', "");
    Expect(0, 69415, '\p{^- OLD_SOGDIAN}', "");
    Expect(0, 69415, '\P{- OLD_SOGDIAN}', "");
    Expect(1, 69415, '\P{^- OLD_SOGDIAN}', "");
    Expect(0, 69416, '\p{- OLD_SOGDIAN}', "");
    Expect(1, 69416, '\p{^- OLD_SOGDIAN}', "");
    Expect(1, 69416, '\P{- OLD_SOGDIAN}', "");
    Expect(0, 69416, '\P{^- OLD_SOGDIAN}', "");
    Error('\p{:= Is_OLD_sogdian}');
    Error('\P{:= Is_OLD_sogdian}');
    Expect(1, 69415, '\p{isoldsogdian}', "");
    Expect(0, 69415, '\p{^isoldsogdian}', "");
    Expect(0, 69415, '\P{isoldsogdian}', "");
    Expect(1, 69415, '\P{^isoldsogdian}', "");
    Expect(0, 69416, '\p{isoldsogdian}', "");
    Expect(1, 69416, '\p{^isoldsogdian}', "");
    Expect(1, 69416, '\P{isoldsogdian}', "");
    Expect(0, 69416, '\P{^isoldsogdian}', "");
    Expect(1, 69415, '\p{-Is_old_SOGDIAN}', "");
    Expect(0, 69415, '\p{^-Is_old_SOGDIAN}', "");
    Expect(0, 69415, '\P{-Is_old_SOGDIAN}', "");
    Expect(1, 69415, '\P{^-Is_old_SOGDIAN}', "");
    Expect(0, 69416, '\p{-Is_old_SOGDIAN}', "");
    Expect(1, 69416, '\p{^-Is_old_SOGDIAN}', "");
    Expect(1, 69416, '\P{-Is_old_SOGDIAN}', "");
    Expect(0, 69416, '\P{^-Is_old_SOGDIAN}', "");
    Error('\p{/a/_SOGO}');
    Error('\P{/a/_SOGO}');
    Expect(1, 69415, '\p{sogo}', "");
    Expect(0, 69415, '\p{^sogo}', "");
    Expect(0, 69415, '\P{sogo}', "");
    Expect(1, 69415, '\P{^sogo}', "");
    Expect(0, 69416, '\p{sogo}', "");
    Expect(1, 69416, '\p{^sogo}', "");
    Expect(1, 69416, '\P{sogo}', "");
    Expect(0, 69416, '\P{^sogo}', "");
    Expect(1, 69415, '\p{_Sogo}', "");
    Expect(0, 69415, '\p{^_Sogo}', "");
    Expect(0, 69415, '\P{_Sogo}', "");
    Expect(1, 69415, '\P{^_Sogo}', "");
    Expect(0, 69416, '\p{_Sogo}', "");
    Expect(1, 69416, '\p{^_Sogo}', "");
    Expect(1, 69416, '\P{_Sogo}', "");
    Expect(0, 69416, '\P{^_Sogo}', "");
    Error('\p{/a/ is_Sogo}');
    Error('\P{/a/ is_Sogo}');
    Expect(1, 69415, '\p{issogo}', "");
    Expect(0, 69415, '\p{^issogo}', "");
    Expect(0, 69415, '\P{issogo}', "");
    Expect(1, 69415, '\P{^issogo}', "");
    Expect(0, 69416, '\p{issogo}', "");
    Expect(1, 69416, '\p{^issogo}', "");
    Expect(1, 69416, '\P{issogo}', "");
    Expect(0, 69416, '\P{^issogo}', "");
    Expect(1, 69415, '\p{-_Is_SOGO}', "");
    Expect(0, 69415, '\p{^-_Is_SOGO}', "");
    Expect(0, 69415, '\P{-_Is_SOGO}', "");
    Expect(1, 69415, '\P{^-_Is_SOGO}', "");
    Expect(0, 69416, '\p{-_Is_SOGO}', "");
    Expect(1, 69416, '\p{^-_Is_SOGO}', "");
    Expect(1, 69416, '\P{-_Is_SOGO}', "");
    Expect(0, 69416, '\P{^-_Is_SOGO}', "");
    Error('\p{	/a/old_SOUTH_Arabian}');
    Error('\P{	/a/old_SOUTH_Arabian}');
    Expect(1, 68223, '\p{oldsoutharabian}', "");
    Expect(0, 68223, '\p{^oldsoutharabian}', "");
    Expect(0, 68223, '\P{oldsoutharabian}', "");
    Expect(1, 68223, '\P{^oldsoutharabian}', "");
    Expect(0, 68224, '\p{oldsoutharabian}', "");
    Expect(1, 68224, '\p{^oldsoutharabian}', "");
    Expect(1, 68224, '\P{oldsoutharabian}', "");
    Expect(0, 68224, '\P{^oldsoutharabian}', "");
    Expect(1, 68223, '\p{_ Old_South_ARABIAN}', "");
    Expect(0, 68223, '\p{^_ Old_South_ARABIAN}', "");
    Expect(0, 68223, '\P{_ Old_South_ARABIAN}', "");
    Expect(1, 68223, '\P{^_ Old_South_ARABIAN}', "");
    Expect(0, 68224, '\p{_ Old_South_ARABIAN}', "");
    Expect(1, 68224, '\p{^_ Old_South_ARABIAN}', "");
    Expect(1, 68224, '\P{_ Old_South_ARABIAN}', "");
    Expect(0, 68224, '\P{^_ Old_South_ARABIAN}', "");
    Error('\p{_:=Is_Old_SOUTH_Arabian}');
    Error('\P{_:=Is_Old_SOUTH_Arabian}');
    Expect(1, 68223, '\p{isoldsoutharabian}', "");
    Expect(0, 68223, '\p{^isoldsoutharabian}', "");
    Expect(0, 68223, '\P{isoldsoutharabian}', "");
    Expect(1, 68223, '\P{^isoldsoutharabian}', "");
    Expect(0, 68224, '\p{isoldsoutharabian}', "");
    Expect(1, 68224, '\p{^isoldsoutharabian}', "");
    Expect(1, 68224, '\P{isoldsoutharabian}', "");
    Expect(0, 68224, '\P{^isoldsoutharabian}', "");
    Expect(1, 68223, '\p{ is_old_South_Arabian}', "");
    Expect(0, 68223, '\p{^ is_old_South_Arabian}', "");
    Expect(0, 68223, '\P{ is_old_South_Arabian}', "");
    Expect(1, 68223, '\P{^ is_old_South_Arabian}', "");
    Expect(0, 68224, '\p{ is_old_South_Arabian}', "");
    Expect(1, 68224, '\p{^ is_old_South_Arabian}', "");
    Expect(1, 68224, '\P{ is_old_South_Arabian}', "");
    Expect(0, 68224, '\P{^ is_old_South_Arabian}', "");
    Error('\p{:= -Sarb}');
    Error('\P{:= -Sarb}');
    Expect(1, 68223, '\p{sarb}', "");
    Expect(0, 68223, '\p{^sarb}', "");
    Expect(0, 68223, '\P{sarb}', "");
    Expect(1, 68223, '\P{^sarb}', "");
    Expect(0, 68224, '\p{sarb}', "");
    Expect(1, 68224, '\p{^sarb}', "");
    Expect(1, 68224, '\P{sarb}', "");
    Expect(0, 68224, '\P{^sarb}', "");
    Expect(1, 68223, '\p{_sarb}', "");
    Expect(0, 68223, '\p{^_sarb}', "");
    Expect(0, 68223, '\P{_sarb}', "");
    Expect(1, 68223, '\P{^_sarb}', "");
    Expect(0, 68224, '\p{_sarb}', "");
    Expect(1, 68224, '\p{^_sarb}', "");
    Expect(1, 68224, '\P{_sarb}', "");
    Expect(0, 68224, '\P{^_sarb}', "");
    Error('\p{/a/Is_Sarb}');
    Error('\P{/a/Is_Sarb}');
    Expect(1, 68223, '\p{issarb}', "");
    Expect(0, 68223, '\p{^issarb}', "");
    Expect(0, 68223, '\P{issarb}', "");
    Expect(1, 68223, '\P{^issarb}', "");
    Expect(0, 68224, '\p{issarb}', "");
    Expect(1, 68224, '\p{^issarb}', "");
    Expect(1, 68224, '\P{issarb}', "");
    Expect(0, 68224, '\P{^issarb}', "");
    Expect(1, 68223, '\p{	-Is_Sarb}', "");
    Expect(0, 68223, '\p{^	-Is_Sarb}', "");
    Expect(0, 68223, '\P{	-Is_Sarb}', "");
    Expect(1, 68223, '\P{^	-Is_Sarb}', "");
    Expect(0, 68224, '\p{	-Is_Sarb}', "");
    Expect(1, 68224, '\p{^	-Is_Sarb}', "");
    Expect(1, 68224, '\P{	-Is_Sarb}', "");
    Expect(0, 68224, '\P{^	-Is_Sarb}', "");
    Error('\p{_:=old_Turkic}');
    Error('\P{_:=old_Turkic}');
    Expect(1, 68680, '\p{oldturkic}', "");
    Expect(0, 68680, '\p{^oldturkic}', "");
    Expect(0, 68680, '\P{oldturkic}', "");
    Expect(1, 68680, '\P{^oldturkic}', "");
    Expect(0, 68681, '\p{oldturkic}', "");
    Expect(1, 68681, '\p{^oldturkic}', "");
    Expect(1, 68681, '\P{oldturkic}', "");
    Expect(0, 68681, '\P{^oldturkic}', "");
    Expect(1, 68680, '\p{	Old_Turkic}', "");
    Expect(0, 68680, '\p{^	Old_Turkic}', "");
    Expect(0, 68680, '\P{	Old_Turkic}', "");
    Expect(1, 68680, '\P{^	Old_Turkic}', "");
    Expect(0, 68681, '\p{	Old_Turkic}', "");
    Expect(1, 68681, '\p{^	Old_Turkic}', "");
    Expect(1, 68681, '\P{	Old_Turkic}', "");
    Expect(0, 68681, '\P{^	Old_Turkic}', "");
    Error('\p{is_old_turkic:=}');
    Error('\P{is_old_turkic:=}');
    Expect(1, 68680, '\p{isoldturkic}', "");
    Expect(0, 68680, '\p{^isoldturkic}', "");
    Expect(0, 68680, '\P{isoldturkic}', "");
    Expect(1, 68680, '\P{^isoldturkic}', "");
    Expect(0, 68681, '\p{isoldturkic}', "");
    Expect(1, 68681, '\p{^isoldturkic}', "");
    Expect(1, 68681, '\P{isoldturkic}', "");
    Expect(0, 68681, '\P{^isoldturkic}', "");
    Expect(1, 68680, '\p{-_is_Old_Turkic}', "");
    Expect(0, 68680, '\p{^-_is_Old_Turkic}', "");
    Expect(0, 68680, '\P{-_is_Old_Turkic}', "");
    Expect(1, 68680, '\P{^-_is_Old_Turkic}', "");
    Expect(0, 68681, '\p{-_is_Old_Turkic}', "");
    Expect(1, 68681, '\p{^-_is_Old_Turkic}', "");
    Expect(1, 68681, '\P{-_is_Old_Turkic}', "");
    Expect(0, 68681, '\P{^-_is_Old_Turkic}', "");
    Error('\p{/a/Orkh}');
    Error('\P{/a/Orkh}');
    Expect(1, 68680, '\p{orkh}', "");
    Expect(0, 68680, '\p{^orkh}', "");
    Expect(0, 68680, '\P{orkh}', "");
    Expect(1, 68680, '\P{^orkh}', "");
    Expect(0, 68681, '\p{orkh}', "");
    Expect(1, 68681, '\p{^orkh}', "");
    Expect(1, 68681, '\P{orkh}', "");
    Expect(0, 68681, '\P{^orkh}', "");
    Expect(1, 68680, '\p{  ORKH}', "");
    Expect(0, 68680, '\p{^  ORKH}', "");
    Expect(0, 68680, '\P{  ORKH}', "");
    Expect(1, 68680, '\P{^  ORKH}', "");
    Expect(0, 68681, '\p{  ORKH}', "");
    Expect(1, 68681, '\p{^  ORKH}', "");
    Expect(1, 68681, '\P{  ORKH}', "");
    Expect(0, 68681, '\P{^  ORKH}', "");
    Error('\p{-:=is_orkh}');
    Error('\P{-:=is_orkh}');
    Expect(1, 68680, '\p{isorkh}', "");
    Expect(0, 68680, '\p{^isorkh}', "");
    Expect(0, 68680, '\P{isorkh}', "");
    Expect(1, 68680, '\P{^isorkh}', "");
    Expect(0, 68681, '\p{isorkh}', "");
    Expect(1, 68681, '\p{^isorkh}', "");
    Expect(1, 68681, '\P{isorkh}', "");
    Expect(0, 68681, '\P{^isorkh}', "");
    Expect(1, 68680, '\p{-_IS_orkh}', "");
    Expect(0, 68680, '\p{^-_IS_orkh}', "");
    Expect(0, 68680, '\P{-_IS_orkh}', "");
    Expect(1, 68680, '\P{^-_IS_orkh}', "");
    Expect(0, 68681, '\p{-_IS_orkh}', "");
    Expect(1, 68681, '\p{^-_IS_orkh}', "");
    Expect(1, 68681, '\P{-_IS_orkh}', "");
    Expect(0, 68681, '\P{^-_IS_orkh}', "");
    Error('\p{:= -Open_PUNCTUATION}');
    Error('\P{:= -Open_PUNCTUATION}');
    Expect(1, 65378, '\p{openpunctuation}', "");
    Expect(0, 65378, '\p{^openpunctuation}', "");
    Expect(0, 65378, '\P{openpunctuation}', "");
    Expect(1, 65378, '\P{^openpunctuation}', "");
    Expect(0, 65379, '\p{openpunctuation}', "");
    Expect(1, 65379, '\p{^openpunctuation}', "");
    Expect(1, 65379, '\P{openpunctuation}', "");
    Expect(0, 65379, '\P{^openpunctuation}', "");
    Expect(1, 65378, '\p{Open_PUNCTUATION}', "");
    Expect(0, 65378, '\p{^Open_PUNCTUATION}', "");
    Expect(0, 65378, '\P{Open_PUNCTUATION}', "");
    Expect(1, 65378, '\P{^Open_PUNCTUATION}', "");
    Expect(0, 65379, '\p{Open_PUNCTUATION}', "");
    Expect(1, 65379, '\p{^Open_PUNCTUATION}', "");
    Expect(1, 65379, '\P{Open_PUNCTUATION}', "");
    Expect(0, 65379, '\P{^Open_PUNCTUATION}', "");
    Error('\p{-/a/IS_Open_Punctuation}');
    Error('\P{-/a/IS_Open_Punctuation}');
    Expect(1, 65378, '\p{isopenpunctuation}', "");
    Expect(0, 65378, '\p{^isopenpunctuation}', "");
    Expect(0, 65378, '\P{isopenpunctuation}', "");
    Expect(1, 65378, '\P{^isopenpunctuation}', "");
    Expect(0, 65379, '\p{isopenpunctuation}', "");
    Expect(1, 65379, '\p{^isopenpunctuation}', "");
    Expect(1, 65379, '\P{isopenpunctuation}', "");
    Expect(0, 65379, '\P{^isopenpunctuation}', "");
    Expect(1, 65378, '\p{_-is_OPEN_PUNCTUATION}', "");
    Expect(0, 65378, '\p{^_-is_OPEN_PUNCTUATION}', "");
    Expect(0, 65378, '\P{_-is_OPEN_PUNCTUATION}', "");
    Expect(1, 65378, '\P{^_-is_OPEN_PUNCTUATION}', "");
    Expect(0, 65379, '\p{_-is_OPEN_PUNCTUATION}', "");
    Expect(1, 65379, '\p{^_-is_OPEN_PUNCTUATION}', "");
    Expect(1, 65379, '\P{_-is_OPEN_PUNCTUATION}', "");
    Expect(0, 65379, '\P{^_-is_OPEN_PUNCTUATION}', "");
    Error('\p{	 PS/a/}');
    Error('\P{	 PS/a/}');
    Expect(1, 65378, '\p{ps}', "");
    Expect(0, 65378, '\p{^ps}', "");
    Expect(0, 65378, '\P{ps}', "");
    Expect(1, 65378, '\P{^ps}', "");
    Expect(0, 65379, '\p{ps}', "");
    Expect(1, 65379, '\p{^ps}', "");
    Expect(1, 65379, '\P{ps}', "");
    Expect(0, 65379, '\P{^ps}', "");
    Expect(1, 65378, '\p{Ps}', "");
    Expect(0, 65378, '\p{^Ps}', "");
    Expect(0, 65378, '\P{Ps}', "");
    Expect(1, 65378, '\P{^Ps}', "");
    Expect(0, 65379, '\p{Ps}', "");
    Expect(1, 65379, '\p{^Ps}', "");
    Expect(1, 65379, '\P{Ps}', "");
    Expect(0, 65379, '\P{^Ps}', "");
    Error('\p{-Is_PS:=}');
    Error('\P{-Is_PS:=}');
    Expect(1, 65378, '\p{isps}', "");
    Expect(0, 65378, '\p{^isps}', "");
    Expect(0, 65378, '\P{isps}', "");
    Expect(1, 65378, '\P{^isps}', "");
    Expect(0, 65379, '\p{isps}', "");
    Expect(1, 65379, '\p{^isps}', "");
    Expect(1, 65379, '\P{isps}', "");
    Expect(0, 65379, '\P{^isps}', "");
    Expect(1, 65378, '\p{	_IS_Ps}', "");
    Expect(0, 65378, '\p{^	_IS_Ps}', "");
    Expect(0, 65378, '\P{	_IS_Ps}', "");
    Expect(1, 65378, '\P{^	_IS_Ps}', "");
    Expect(0, 65379, '\p{	_IS_Ps}', "");
    Expect(1, 65379, '\p{^	_IS_Ps}', "");
    Expect(1, 65379, '\P{	_IS_Ps}', "");
    Expect(0, 65379, '\P{^	_IS_Ps}', "");
    Error('\p{_optical_Character_Recognition/a/}');
    Error('\P{_optical_Character_Recognition/a/}');
    Expect(1, 9311, '\p{opticalcharacterrecognition}', "");
    Expect(0, 9311, '\p{^opticalcharacterrecognition}', "");
    Expect(0, 9311, '\P{opticalcharacterrecognition}', "");
    Expect(1, 9311, '\P{^opticalcharacterrecognition}', "");
    Expect(0, 9312, '\p{opticalcharacterrecognition}', "");
    Expect(1, 9312, '\p{^opticalcharacterrecognition}', "");
    Expect(1, 9312, '\P{opticalcharacterrecognition}', "");
    Expect(0, 9312, '\P{^opticalcharacterrecognition}', "");
    Expect(1, 9311, '\p{OPTICAL_Character_RECOGNITION}', "");
    Expect(0, 9311, '\p{^OPTICAL_Character_RECOGNITION}', "");
    Expect(0, 9311, '\P{OPTICAL_Character_RECOGNITION}', "");
    Expect(1, 9311, '\P{^OPTICAL_Character_RECOGNITION}', "");
    Expect(0, 9312, '\p{OPTICAL_Character_RECOGNITION}', "");
    Expect(1, 9312, '\p{^OPTICAL_Character_RECOGNITION}', "");
    Expect(1, 9312, '\P{OPTICAL_Character_RECOGNITION}', "");
    Expect(0, 9312, '\P{^OPTICAL_Character_RECOGNITION}', "");
    Error('\p{- IS_OPTICAL_Character_RECOGNITION:=}');
    Error('\P{- IS_OPTICAL_Character_RECOGNITION:=}');
    Expect(1, 9311, '\p{isopticalcharacterrecognition}', "");
    Expect(0, 9311, '\p{^isopticalcharacterrecognition}', "");
    Expect(0, 9311, '\P{isopticalcharacterrecognition}', "");
    Expect(1, 9311, '\P{^isopticalcharacterrecognition}', "");
    Expect(0, 9312, '\p{isopticalcharacterrecognition}', "");
    Expect(1, 9312, '\p{^isopticalcharacterrecognition}', "");
    Expect(1, 9312, '\P{isopticalcharacterrecognition}', "");
    Expect(0, 9312, '\P{^isopticalcharacterrecognition}', "");
    Expect(1, 9311, '\p{__IS_OPTICAL_Character_Recognition}', "");
    Expect(0, 9311, '\p{^__IS_OPTICAL_Character_Recognition}', "");
    Expect(0, 9311, '\P{__IS_OPTICAL_Character_Recognition}', "");
    Expect(1, 9311, '\P{^__IS_OPTICAL_Character_Recognition}', "");
    Expect(0, 9312, '\p{__IS_OPTICAL_Character_Recognition}', "");
    Expect(1, 9312, '\p{^__IS_OPTICAL_Character_Recognition}', "");
    Expect(1, 9312, '\P{__IS_OPTICAL_Character_Recognition}', "");
    Expect(0, 9312, '\P{^__IS_OPTICAL_Character_Recognition}', "");
    Error('\p{	:=In_OPTICAL_Character_Recognition}');
    Error('\P{	:=In_OPTICAL_Character_Recognition}');
    Expect(1, 9311, '\p{inopticalcharacterrecognition}', "");
    Expect(0, 9311, '\p{^inopticalcharacterrecognition}', "");
    Expect(0, 9311, '\P{inopticalcharacterrecognition}', "");
    Expect(1, 9311, '\P{^inopticalcharacterrecognition}', "");
    Expect(0, 9312, '\p{inopticalcharacterrecognition}', "");
    Expect(1, 9312, '\p{^inopticalcharacterrecognition}', "");
    Expect(1, 9312, '\P{inopticalcharacterrecognition}', "");
    Expect(0, 9312, '\P{^inopticalcharacterrecognition}', "");
    Expect(1, 9311, '\p{	_In_OPTICAL_CHARACTER_Recognition}', "");
    Expect(0, 9311, '\p{^	_In_OPTICAL_CHARACTER_Recognition}', "");
    Expect(0, 9311, '\P{	_In_OPTICAL_CHARACTER_Recognition}', "");
    Expect(1, 9311, '\P{^	_In_OPTICAL_CHARACTER_Recognition}', "");
    Expect(0, 9312, '\p{	_In_OPTICAL_CHARACTER_Recognition}', "");
    Expect(1, 9312, '\p{^	_In_OPTICAL_CHARACTER_Recognition}', "");
    Expect(1, 9312, '\P{	_In_OPTICAL_CHARACTER_Recognition}', "");
    Expect(0, 9312, '\P{^	_In_OPTICAL_CHARACTER_Recognition}', "");
    Error('\p{_OCR:=}');
    Error('\P{_OCR:=}');
    Expect(1, 9311, '\p{ocr}', "");
    Expect(0, 9311, '\p{^ocr}', "");
    Expect(0, 9311, '\P{ocr}', "");
    Expect(1, 9311, '\P{^ocr}', "");
    Expect(0, 9312, '\p{ocr}', "");
    Expect(1, 9312, '\p{^ocr}', "");
    Expect(1, 9312, '\P{ocr}', "");
    Expect(0, 9312, '\P{^ocr}', "");
    Expect(1, 9311, '\p{		ocr}', "");
    Expect(0, 9311, '\p{^		ocr}', "");
    Expect(0, 9311, '\P{		ocr}', "");
    Expect(1, 9311, '\P{^		ocr}', "");
    Expect(0, 9312, '\p{		ocr}', "");
    Expect(1, 9312, '\p{^		ocr}', "");
    Expect(1, 9312, '\P{		ocr}', "");
    Expect(0, 9312, '\P{^		ocr}', "");
    Error('\p{/a/_is_OCR}');
    Error('\P{/a/_is_OCR}');
    Expect(1, 9311, '\p{isocr}', "");
    Expect(0, 9311, '\p{^isocr}', "");
    Expect(0, 9311, '\P{isocr}', "");
    Expect(1, 9311, '\P{^isocr}', "");
    Expect(0, 9312, '\p{isocr}', "");
    Expect(1, 9312, '\p{^isocr}', "");
    Expect(1, 9312, '\P{isocr}', "");
    Expect(0, 9312, '\P{^isocr}', "");
    Expect(1, 9311, '\p{ Is_OCR}', "");
    Expect(0, 9311, '\p{^ Is_OCR}', "");
    Expect(0, 9311, '\P{ Is_OCR}', "");
    Expect(1, 9311, '\P{^ Is_OCR}', "");
    Expect(0, 9312, '\p{ Is_OCR}', "");
    Expect(1, 9312, '\p{^ Is_OCR}', "");
    Expect(1, 9312, '\P{ Is_OCR}', "");
    Expect(0, 9312, '\P{^ Is_OCR}', "");
    Error('\p{:=_	in_OCR}');
    Error('\P{:=_	in_OCR}');
    Expect(1, 9311, '\p{inocr}', "");
    Expect(0, 9311, '\p{^inocr}', "");
    Expect(0, 9311, '\P{inocr}', "");
    Expect(1, 9311, '\P{^inocr}', "");
    Expect(0, 9312, '\p{inocr}', "");
    Expect(1, 9312, '\p{^inocr}', "");
    Expect(1, 9312, '\P{inocr}', "");
    Expect(0, 9312, '\P{^inocr}', "");
    Expect(1, 9311, '\p{_IN_OCR}', "");
    Expect(0, 9311, '\p{^_IN_OCR}', "");
    Expect(0, 9311, '\P{_IN_OCR}', "");
    Expect(1, 9311, '\P{^_IN_OCR}', "");
    Expect(0, 9312, '\p{_IN_OCR}', "");
    Expect(1, 9312, '\p{^_IN_OCR}', "");
    Expect(1, 9312, '\P{_IN_OCR}', "");
    Expect(0, 9312, '\P{^_IN_OCR}', "");
    Error('\p{	:=oriya}');
    Error('\P{	:=oriya}');
    Expect(1, 7410, '\p{oriya}', "");
    Expect(0, 7410, '\p{^oriya}', "");
    Expect(0, 7410, '\P{oriya}', "");
    Expect(1, 7410, '\P{^oriya}', "");
    Expect(0, 7411, '\p{oriya}', "");
    Expect(1, 7411, '\p{^oriya}', "");
    Expect(1, 7411, '\P{oriya}', "");
    Expect(0, 7411, '\P{^oriya}', "");
    Expect(1, 7410, '\p{	_oriya}', "");
    Expect(0, 7410, '\p{^	_oriya}', "");
    Expect(0, 7410, '\P{	_oriya}', "");
    Expect(1, 7410, '\P{^	_oriya}', "");
    Expect(0, 7411, '\p{	_oriya}', "");
    Expect(1, 7411, '\p{^	_oriya}', "");
    Expect(1, 7411, '\P{	_oriya}', "");
    Expect(0, 7411, '\P{^	_oriya}', "");
    Error('\p{	:=IS_Oriya}');
    Error('\P{	:=IS_Oriya}');
    Expect(1, 7410, '\p{isoriya}', "");
    Expect(0, 7410, '\p{^isoriya}', "");
    Expect(0, 7410, '\P{isoriya}', "");
    Expect(1, 7410, '\P{^isoriya}', "");
    Expect(0, 7411, '\p{isoriya}', "");
    Expect(1, 7411, '\p{^isoriya}', "");
    Expect(1, 7411, '\P{isoriya}', "");
    Expect(0, 7411, '\P{^isoriya}', "");
    Expect(1, 7410, '\p{--Is_ORIYA}', "");
    Expect(0, 7410, '\p{^--Is_ORIYA}', "");
    Expect(0, 7410, '\P{--Is_ORIYA}', "");
    Expect(1, 7410, '\P{^--Is_ORIYA}', "");
    Expect(0, 7411, '\p{--Is_ORIYA}', "");
    Expect(1, 7411, '\p{^--Is_ORIYA}', "");
    Expect(1, 7411, '\P{--Is_ORIYA}', "");
    Expect(0, 7411, '\P{^--Is_ORIYA}', "");
    Error('\p{:=Orya}');
    Error('\P{:=Orya}');
    Expect(1, 7410, '\p{orya}', "");
    Expect(0, 7410, '\p{^orya}', "");
    Expect(0, 7410, '\P{orya}', "");
    Expect(1, 7410, '\P{^orya}', "");
    Expect(0, 7411, '\p{orya}', "");
    Expect(1, 7411, '\p{^orya}', "");
    Expect(1, 7411, '\P{orya}', "");
    Expect(0, 7411, '\P{^orya}', "");
    Expect(1, 7410, '\p{	Orya}', "");
    Expect(0, 7410, '\p{^	Orya}', "");
    Expect(0, 7410, '\P{	Orya}', "");
    Expect(1, 7410, '\P{^	Orya}', "");
    Expect(0, 7411, '\p{	Orya}', "");
    Expect(1, 7411, '\p{^	Orya}', "");
    Expect(1, 7411, '\P{	Orya}', "");
    Expect(0, 7411, '\P{^	Orya}', "");
    Error('\p{- Is_Orya:=}');
    Error('\P{- Is_Orya:=}');
    Expect(1, 7410, '\p{isorya}', "");
    Expect(0, 7410, '\p{^isorya}', "");
    Expect(0, 7410, '\P{isorya}', "");
    Expect(1, 7410, '\P{^isorya}', "");
    Expect(0, 7411, '\p{isorya}', "");
    Expect(1, 7411, '\p{^isorya}', "");
    Expect(1, 7411, '\P{isorya}', "");
    Expect(0, 7411, '\P{^isorya}', "");
    Expect(1, 7410, '\p{		Is_orya}', "");
    Expect(0, 7410, '\p{^		Is_orya}', "");
    Expect(0, 7410, '\P{		Is_orya}', "");
    Expect(1, 7410, '\P{^		Is_orya}', "");
    Expect(0, 7411, '\p{		Is_orya}', "");
    Expect(1, 7411, '\p{^		Is_orya}', "");
    Expect(1, 7411, '\P{		Is_orya}', "");
    Expect(0, 7411, '\P{^		Is_orya}', "");
    Error('\p{:= _Ornamental_Dingbats}');
    Error('\P{:= _Ornamental_Dingbats}');
    Expect(1, 128639, '\p{ornamentaldingbats}', "");
    Expect(0, 128639, '\p{^ornamentaldingbats}', "");
    Expect(0, 128639, '\P{ornamentaldingbats}', "");
    Expect(1, 128639, '\P{^ornamentaldingbats}', "");
    Expect(0, 128640, '\p{ornamentaldingbats}', "");
    Expect(1, 128640, '\p{^ornamentaldingbats}', "");
    Expect(1, 128640, '\P{ornamentaldingbats}', "");
    Expect(0, 128640, '\P{^ornamentaldingbats}', "");
    Expect(1, 128639, '\p{__ornamental_dingbats}', "");
    Expect(0, 128639, '\p{^__ornamental_dingbats}', "");
    Expect(0, 128639, '\P{__ornamental_dingbats}', "");
    Expect(1, 128639, '\P{^__ornamental_dingbats}', "");
    Expect(0, 128640, '\p{__ornamental_dingbats}', "");
    Expect(1, 128640, '\p{^__ornamental_dingbats}', "");
    Expect(1, 128640, '\P{__ornamental_dingbats}', "");
    Expect(0, 128640, '\P{^__ornamental_dingbats}', "");
    Error('\p{/a/  Is_Ornamental_Dingbats}');
    Error('\P{/a/  Is_Ornamental_Dingbats}');
    Expect(1, 128639, '\p{isornamentaldingbats}', "");
    Expect(0, 128639, '\p{^isornamentaldingbats}', "");
    Expect(0, 128639, '\P{isornamentaldingbats}', "");
    Expect(1, 128639, '\P{^isornamentaldingbats}', "");
    Expect(0, 128640, '\p{isornamentaldingbats}', "");
    Expect(1, 128640, '\p{^isornamentaldingbats}', "");
    Expect(1, 128640, '\P{isornamentaldingbats}', "");
    Expect(0, 128640, '\P{^isornamentaldingbats}', "");
    Expect(1, 128639, '\p{-_IS_Ornamental_Dingbats}', "");
    Expect(0, 128639, '\p{^-_IS_Ornamental_Dingbats}', "");
    Expect(0, 128639, '\P{-_IS_Ornamental_Dingbats}', "");
    Expect(1, 128639, '\P{^-_IS_Ornamental_Dingbats}', "");
    Expect(0, 128640, '\p{-_IS_Ornamental_Dingbats}', "");
    Expect(1, 128640, '\p{^-_IS_Ornamental_Dingbats}', "");
    Expect(1, 128640, '\P{-_IS_Ornamental_Dingbats}', "");
    Expect(0, 128640, '\P{^-_IS_Ornamental_Dingbats}', "");
    Error('\p{-:=in_Ornamental_Dingbats}');
    Error('\P{-:=in_Ornamental_Dingbats}');
    Expect(1, 128639, '\p{inornamentaldingbats}', "");
    Expect(0, 128639, '\p{^inornamentaldingbats}', "");
    Expect(0, 128639, '\P{inornamentaldingbats}', "");
    Expect(1, 128639, '\P{^inornamentaldingbats}', "");
    Expect(0, 128640, '\p{inornamentaldingbats}', "");
    Expect(1, 128640, '\p{^inornamentaldingbats}', "");
    Expect(1, 128640, '\P{inornamentaldingbats}', "");
    Expect(0, 128640, '\P{^inornamentaldingbats}', "");
    Expect(1, 128639, '\p{_-In_Ornamental_dingbats}', "");
    Expect(0, 128639, '\p{^_-In_Ornamental_dingbats}', "");
    Expect(0, 128639, '\P{_-In_Ornamental_dingbats}', "");
    Expect(1, 128639, '\P{^_-In_Ornamental_dingbats}', "");
    Expect(0, 128640, '\p{_-In_Ornamental_dingbats}', "");
    Expect(1, 128640, '\p{^_-In_Ornamental_dingbats}', "");
    Expect(1, 128640, '\P{_-In_Ornamental_dingbats}', "");
    Expect(0, 128640, '\P{^_-In_Ornamental_dingbats}', "");
    Error('\p{_	Osage:=}');
    Error('\P{_	Osage:=}');
    Expect(1, 66811, '\p{osage}', "");
    Expect(0, 66811, '\p{^osage}', "");
    Expect(0, 66811, '\P{osage}', "");
    Expect(1, 66811, '\P{^osage}', "");
    Expect(0, 66812, '\p{osage}', "");
    Expect(1, 66812, '\p{^osage}', "");
    Expect(1, 66812, '\P{osage}', "");
    Expect(0, 66812, '\P{^osage}', "");
    Expect(1, 66811, '\p{ osage}', "");
    Expect(0, 66811, '\p{^ osage}', "");
    Expect(0, 66811, '\P{ osage}', "");
    Expect(1, 66811, '\P{^ osage}', "");
    Expect(0, 66812, '\p{ osage}', "");
    Expect(1, 66812, '\p{^ osage}', "");
    Expect(1, 66812, '\P{ osage}', "");
    Expect(0, 66812, '\P{^ osage}', "");
    Error('\p{ /a/Is_OSAGE}');
    Error('\P{ /a/Is_OSAGE}');
    Expect(1, 66811, '\p{isosage}', "");
    Expect(0, 66811, '\p{^isosage}', "");
    Expect(0, 66811, '\P{isosage}', "");
    Expect(1, 66811, '\P{^isosage}', "");
    Expect(0, 66812, '\p{isosage}', "");
    Expect(1, 66812, '\p{^isosage}', "");
    Expect(1, 66812, '\P{isosage}', "");
    Expect(0, 66812, '\P{^isosage}', "");
    Expect(1, 66811, '\p{_Is_Osage}', "");
    Expect(0, 66811, '\p{^_Is_Osage}', "");
    Expect(0, 66811, '\P{_Is_Osage}', "");
    Expect(1, 66811, '\P{^_Is_Osage}', "");
    Expect(0, 66812, '\p{_Is_Osage}', "");
    Expect(1, 66812, '\p{^_Is_Osage}', "");
    Expect(1, 66812, '\P{_Is_Osage}', "");
    Expect(0, 66812, '\P{^_Is_Osage}', "");
    Error('\p{/a/osge}');
    Error('\P{/a/osge}');
    Expect(1, 66811, '\p{osge}', "");
    Expect(0, 66811, '\p{^osge}', "");
    Expect(0, 66811, '\P{osge}', "");
    Expect(1, 66811, '\P{^osge}', "");
    Expect(0, 66812, '\p{osge}', "");
    Expect(1, 66812, '\p{^osge}', "");
    Expect(1, 66812, '\P{osge}', "");
    Expect(0, 66812, '\P{^osge}', "");
    Expect(1, 66811, '\p{_	osge}', "");
    Expect(0, 66811, '\p{^_	osge}', "");
    Expect(0, 66811, '\P{_	osge}', "");
    Expect(1, 66811, '\P{^_	osge}', "");
    Expect(0, 66812, '\p{_	osge}', "");
    Expect(1, 66812, '\p{^_	osge}', "");
    Expect(1, 66812, '\P{_	osge}', "");
    Expect(0, 66812, '\P{^_	osge}', "");
    Error('\p{ IS_Osge/a/}');
    Error('\P{ IS_Osge/a/}');
    Expect(1, 66811, '\p{isosge}', "");
    Expect(0, 66811, '\p{^isosge}', "");
    Expect(0, 66811, '\P{isosge}', "");
    Expect(1, 66811, '\P{^isosge}', "");
    Expect(0, 66812, '\p{isosge}', "");
    Expect(1, 66812, '\p{^isosge}', "");
    Expect(1, 66812, '\P{isosge}', "");
    Expect(0, 66812, '\P{^isosge}', "");
    Expect(1, 66811, '\p{-IS_osge}', "");
    Expect(0, 66811, '\p{^-IS_osge}', "");
    Expect(0, 66811, '\P{-IS_osge}', "");
    Expect(1, 66811, '\P{^-IS_osge}', "");
    Expect(0, 66812, '\p{-IS_osge}', "");
    Expect(1, 66812, '\p{^-IS_osge}', "");
    Expect(1, 66812, '\P{-IS_osge}', "");
    Expect(0, 66812, '\P{^-IS_osge}', "");
    Error('\p{:=Osmanya}');
    Error('\P{:=Osmanya}');
    Expect(1, 66729, '\p{osmanya}', "");
    Expect(0, 66729, '\p{^osmanya}', "");
    Expect(0, 66729, '\P{osmanya}', "");
    Expect(1, 66729, '\P{^osmanya}', "");
    Expect(0, 66730, '\p{osmanya}', "");
    Expect(1, 66730, '\p{^osmanya}', "");
    Expect(1, 66730, '\P{osmanya}', "");
    Expect(0, 66730, '\P{^osmanya}', "");
    Expect(1, 66729, '\p{_ Osmanya}', "");
    Expect(0, 66729, '\p{^_ Osmanya}', "");
    Expect(0, 66729, '\P{_ Osmanya}', "");
    Expect(1, 66729, '\P{^_ Osmanya}', "");
    Expect(0, 66730, '\p{_ Osmanya}', "");
    Expect(1, 66730, '\p{^_ Osmanya}', "");
    Expect(1, 66730, '\P{_ Osmanya}', "");
    Expect(0, 66730, '\P{^_ Osmanya}', "");
    Error('\p{_:=Is_Osmanya}');
    Error('\P{_:=Is_Osmanya}');
    Expect(1, 66729, '\p{isosmanya}', "");
    Expect(0, 66729, '\p{^isosmanya}', "");
    Expect(0, 66729, '\P{isosmanya}', "");
    Expect(1, 66729, '\P{^isosmanya}', "");
    Expect(0, 66730, '\p{isosmanya}', "");
    Expect(1, 66730, '\p{^isosmanya}', "");
    Expect(1, 66730, '\P{isosmanya}', "");
    Expect(0, 66730, '\P{^isosmanya}', "");
    Expect(1, 66729, '\p{-IS_OSMANYA}', "");
    Expect(0, 66729, '\p{^-IS_OSMANYA}', "");
    Expect(0, 66729, '\P{-IS_OSMANYA}', "");
    Expect(1, 66729, '\P{^-IS_OSMANYA}', "");
    Expect(0, 66730, '\p{-IS_OSMANYA}', "");
    Expect(1, 66730, '\p{^-IS_OSMANYA}', "");
    Expect(1, 66730, '\P{-IS_OSMANYA}', "");
    Expect(0, 66730, '\P{^-IS_OSMANYA}', "");
    Error('\p{		Osma:=}');
    Error('\P{		Osma:=}');
    Expect(1, 66729, '\p{osma}', "");
    Expect(0, 66729, '\p{^osma}', "");
    Expect(0, 66729, '\P{osma}', "");
    Expect(1, 66729, '\P{^osma}', "");
    Expect(0, 66730, '\p{osma}', "");
    Expect(1, 66730, '\p{^osma}', "");
    Expect(1, 66730, '\P{osma}', "");
    Expect(0, 66730, '\P{^osma}', "");
    Expect(1, 66729, '\p{-OSMA}', "");
    Expect(0, 66729, '\p{^-OSMA}', "");
    Expect(0, 66729, '\P{-OSMA}', "");
    Expect(1, 66729, '\P{^-OSMA}', "");
    Expect(0, 66730, '\p{-OSMA}', "");
    Expect(1, 66730, '\p{^-OSMA}', "");
    Expect(1, 66730, '\P{-OSMA}', "");
    Expect(0, 66730, '\P{^-OSMA}', "");
    Error('\p{_	Is_Osma/a/}');
    Error('\P{_	Is_Osma/a/}');
    Expect(1, 66729, '\p{isosma}', "");
    Expect(0, 66729, '\p{^isosma}', "");
    Expect(0, 66729, '\P{isosma}', "");
    Expect(1, 66729, '\P{^isosma}', "");
    Expect(0, 66730, '\p{isosma}', "");
    Expect(1, 66730, '\p{^isosma}', "");
    Expect(1, 66730, '\P{isosma}', "");
    Expect(0, 66730, '\P{^isosma}', "");
    Expect(1, 66729, '\p{	-Is_osma}', "");
    Expect(0, 66729, '\p{^	-Is_osma}', "");
    Expect(0, 66729, '\P{	-Is_osma}', "");
    Expect(1, 66729, '\P{^	-Is_osma}', "");
    Expect(0, 66730, '\p{	-Is_osma}', "");
    Expect(1, 66730, '\p{^	-Is_osma}', "");
    Expect(1, 66730, '\P{	-Is_osma}', "");
    Expect(0, 66730, '\P{^	-Is_osma}', "");
    Error('\p{_-other/a/}');
    Error('\P{_-other/a/}');
    Expect(1, 918000, '\p{other}', "");
    Expect(0, 918000, '\p{^other}', "");
    Expect(0, 918000, '\P{other}', "");
    Expect(1, 918000, '\P{^other}', "");
    Expect(0, 917999, '\p{other}', "");
    Expect(1, 917999, '\p{^other}', "");
    Expect(1, 917999, '\P{other}', "");
    Expect(0, 917999, '\P{^other}', "");
    Expect(1, 918000, '\p{	other}', "");
    Expect(0, 918000, '\p{^	other}', "");
    Expect(0, 918000, '\P{	other}', "");
    Expect(1, 918000, '\P{^	other}', "");
    Expect(0, 917999, '\p{	other}', "");
    Expect(1, 917999, '\p{^	other}', "");
    Expect(1, 917999, '\P{	other}', "");
    Expect(0, 917999, '\P{^	other}', "");
    Error('\p{	/a/Is_OTHER}');
    Error('\P{	/a/Is_OTHER}');
    Expect(1, 918000, '\p{isother}', "");
    Expect(0, 918000, '\p{^isother}', "");
    Expect(0, 918000, '\P{isother}', "");
    Expect(1, 918000, '\P{^isother}', "");
    Expect(0, 917999, '\p{isother}', "");
    Expect(1, 917999, '\p{^isother}', "");
    Expect(1, 917999, '\P{isother}', "");
    Expect(0, 917999, '\P{^isother}', "");
    Expect(1, 918000, '\p{	-Is_Other}', "");
    Expect(0, 918000, '\p{^	-Is_Other}', "");
    Expect(0, 918000, '\P{	-Is_Other}', "");
    Expect(1, 918000, '\P{^	-Is_Other}', "");
    Expect(0, 917999, '\p{	-Is_Other}', "");
    Expect(1, 917999, '\p{^	-Is_Other}', "");
    Expect(1, 917999, '\P{	-Is_Other}', "");
    Expect(0, 917999, '\P{^	-Is_Other}', "");
    Error('\p{	/a/C}');
    Error('\P{	/a/C}');
    Expect(1, 918000, '\p{c}', "");
    Expect(0, 918000, '\p{^c}', "");
    Expect(0, 918000, '\P{c}', "");
    Expect(1, 918000, '\P{^c}', "");
    Expect(0, 917999, '\p{c}', "");
    Expect(1, 917999, '\p{^c}', "");
    Expect(1, 917999, '\P{c}', "");
    Expect(0, 917999, '\P{^c}', "");
    Expect(1, 918000, '\p{	 c}', "");
    Expect(0, 918000, '\p{^	 c}', "");
    Expect(0, 918000, '\P{	 c}', "");
    Expect(1, 918000, '\P{^	 c}', "");
    Expect(0, 917999, '\p{	 c}', "");
    Expect(1, 917999, '\p{^	 c}', "");
    Expect(1, 917999, '\P{	 c}', "");
    Expect(0, 917999, '\P{^	 c}', "");
    Error('\p{	_is_C:=}');
    Error('\P{	_is_C:=}');
    Expect(1, 918000, '\p{isc}', "");
    Expect(0, 918000, '\p{^isc}', "");
    Expect(0, 918000, '\P{isc}', "");
    Expect(1, 918000, '\P{^isc}', "");
    Expect(0, 917999, '\p{isc}', "");
    Expect(1, 917999, '\p{^isc}', "");
    Expect(1, 917999, '\P{isc}', "");
    Expect(0, 917999, '\P{^isc}', "");
    Expect(1, 918000, '\p{-Is_C}', "");
    Expect(0, 918000, '\p{^-Is_C}', "");
    Expect(0, 918000, '\P{-Is_C}', "");
    Expect(1, 918000, '\P{^-Is_C}', "");
    Expect(0, 917999, '\p{-Is_C}', "");
    Expect(1, 917999, '\p{^-Is_C}', "");
    Expect(1, 917999, '\P{-Is_C}', "");
    Expect(0, 917999, '\P{^-Is_C}', "");
    Error('\p{Other_Alphabetic}');
    Error('\P{Other_Alphabetic}');
    Error('\p{OAlpha}');
    Error('\P{OAlpha}');
    Error('\p{Other_Default_Ignorable_Code_Point}');
    Error('\P{Other_Default_Ignorable_Code_Point}');
    Error('\p{ODI}');
    Error('\P{ODI}');
    Error('\p{Other_Grapheme_Extend}');
    Error('\P{Other_Grapheme_Extend}');
    Error('\p{OGr_Ext}');
    Error('\P{OGr_Ext}');
    Error('\p{Other_ID_Continue}');
    Error('\P{Other_ID_Continue}');
    Error('\p{OIDC}');
    Error('\P{OIDC}');
    Error('\p{Other_ID_Start}');
    Error('\P{Other_ID_Start}');
    Error('\p{OIDS}');
    Error('\P{OIDS}');
    Error('\p{	_other_Letter:=}');
    Error('\P{	_other_Letter:=}');
    Expect(1, 201546, '\p{otherletter}', "");
    Expect(0, 201546, '\p{^otherletter}', "");
    Expect(0, 201546, '\P{otherletter}', "");
    Expect(1, 201546, '\P{^otherletter}', "");
    Expect(0, 201547, '\p{otherletter}', "");
    Expect(1, 201547, '\p{^otherletter}', "");
    Expect(1, 201547, '\P{otherletter}', "");
    Expect(0, 201547, '\P{^otherletter}', "");
    Expect(1, 201546, '\p{ _Other_letter}', "");
    Expect(0, 201546, '\p{^ _Other_letter}', "");
    Expect(0, 201546, '\P{ _Other_letter}', "");
    Expect(1, 201546, '\P{^ _Other_letter}', "");
    Expect(0, 201547, '\p{ _Other_letter}', "");
    Expect(1, 201547, '\p{^ _Other_letter}', "");
    Expect(1, 201547, '\P{ _Other_letter}', "");
    Expect(0, 201547, '\P{^ _Other_letter}', "");
    Error('\p{	Is_other_Letter:=}');
    Error('\P{	Is_other_Letter:=}');
    Expect(1, 201546, '\p{isotherletter}', "");
    Expect(0, 201546, '\p{^isotherletter}', "");
    Expect(0, 201546, '\P{isotherletter}', "");
    Expect(1, 201546, '\P{^isotherletter}', "");
    Expect(0, 201547, '\p{isotherletter}', "");
    Expect(1, 201547, '\p{^isotherletter}', "");
    Expect(1, 201547, '\P{isotherletter}', "");
    Expect(0, 201547, '\P{^isotherletter}', "");
    Expect(1, 201546, '\p{	 Is_Other_Letter}', "");
    Expect(0, 201546, '\p{^	 Is_Other_Letter}', "");
    Expect(0, 201546, '\P{	 Is_Other_Letter}', "");
    Expect(1, 201546, '\P{^	 Is_Other_Letter}', "");
    Expect(0, 201547, '\p{	 Is_Other_Letter}', "");
    Expect(1, 201547, '\p{^	 Is_Other_Letter}', "");
    Expect(1, 201547, '\P{	 Is_Other_Letter}', "");
    Expect(0, 201547, '\P{^	 Is_Other_Letter}', "");
    Error('\p{ :=LO}');
    Error('\P{ :=LO}');
    Expect(1, 201546, '\p{lo}', "");
    Expect(0, 201546, '\p{^lo}', "");
    Expect(0, 201546, '\P{lo}', "");
    Expect(1, 201546, '\P{^lo}', "");
    Expect(0, 201547, '\p{lo}', "");
    Expect(1, 201547, '\p{^lo}', "");
    Expect(1, 201547, '\P{lo}', "");
    Expect(0, 201547, '\P{^lo}', "");
    Expect(1, 201546, '\p{_-Lo}', "");
    Expect(0, 201546, '\p{^_-Lo}', "");
    Expect(0, 201546, '\P{_-Lo}', "");
    Expect(1, 201546, '\P{^_-Lo}', "");
    Expect(0, 201547, '\p{_-Lo}', "");
    Expect(1, 201547, '\p{^_-Lo}', "");
    Expect(1, 201547, '\P{_-Lo}', "");
    Expect(0, 201547, '\P{^_-Lo}', "");
    Error('\p{ _is_Lo/a/}');
    Error('\P{ _is_Lo/a/}');
    Expect(1, 201546, '\p{islo}', "");
    Expect(0, 201546, '\p{^islo}', "");
    Expect(0, 201546, '\P{islo}', "");
    Expect(1, 201546, '\P{^islo}', "");
    Expect(0, 201547, '\p{islo}', "");
    Expect(1, 201547, '\p{^islo}', "");
    Expect(1, 201547, '\P{islo}', "");
    Expect(0, 201547, '\P{^islo}', "");
    Expect(1, 201546, '\p{	 Is_Lo}', "");
    Expect(0, 201546, '\p{^	 Is_Lo}', "");
    Expect(0, 201546, '\P{	 Is_Lo}', "");
    Expect(1, 201546, '\P{^	 Is_Lo}', "");
    Expect(0, 201547, '\p{	 Is_Lo}', "");
    Expect(1, 201547, '\p{^	 Is_Lo}', "");
    Expect(1, 201547, '\P{	 Is_Lo}', "");
    Expect(0, 201547, '\P{^	 Is_Lo}', "");
    Error('\p{Other_Lowercase}');
    Error('\P{Other_Lowercase}');
    Error('\p{OLower}');
    Error('\P{OLower}');
    Error('\p{Other_Math}');
    Error('\P{Other_Math}');
    Error('\p{OMath}');
    Error('\P{OMath}');
    Error('\p{ 	OTHER_Number/a/}');
    Error('\P{ 	OTHER_Number/a/}');
    Expect(1, 127244, '\p{othernumber}', "");
    Expect(0, 127244, '\p{^othernumber}', "");
    Expect(0, 127244, '\P{othernumber}', "");
    Expect(1, 127244, '\P{^othernumber}', "");
    Expect(0, 127245, '\p{othernumber}', "");
    Expect(1, 127245, '\p{^othernumber}', "");
    Expect(1, 127245, '\P{othernumber}', "");
    Expect(0, 127245, '\P{^othernumber}', "");
    Expect(1, 127244, '\p{__Other_Number}', "");
    Expect(0, 127244, '\p{^__Other_Number}', "");
    Expect(0, 127244, '\P{__Other_Number}', "");
    Expect(1, 127244, '\P{^__Other_Number}', "");
    Expect(0, 127245, '\p{__Other_Number}', "");
    Expect(1, 127245, '\p{^__Other_Number}', "");
    Expect(1, 127245, '\P{__Other_Number}', "");
    Expect(0, 127245, '\P{^__Other_Number}', "");
    Error('\p{ _IS_other_number/a/}');
    Error('\P{ _IS_other_number/a/}');
    Expect(1, 127244, '\p{isothernumber}', "");
    Expect(0, 127244, '\p{^isothernumber}', "");
    Expect(0, 127244, '\P{isothernumber}', "");
    Expect(1, 127244, '\P{^isothernumber}', "");
    Expect(0, 127245, '\p{isothernumber}', "");
    Expect(1, 127245, '\p{^isothernumber}', "");
    Expect(1, 127245, '\P{isothernumber}', "");
    Expect(0, 127245, '\P{^isothernumber}', "");
    Expect(1, 127244, '\p{-	is_Other_number}', "");
    Expect(0, 127244, '\p{^-	is_Other_number}', "");
    Expect(0, 127244, '\P{-	is_Other_number}', "");
    Expect(1, 127244, '\P{^-	is_Other_number}', "");
    Expect(0, 127245, '\p{-	is_Other_number}', "");
    Expect(1, 127245, '\p{^-	is_Other_number}', "");
    Expect(1, 127245, '\P{-	is_Other_number}', "");
    Expect(0, 127245, '\P{^-	is_Other_number}', "");
    Error('\p{ :=No}');
    Error('\P{ :=No}');
    Expect(1, 127244, '\p{no}', "");
    Expect(0, 127244, '\p{^no}', "");
    Expect(0, 127244, '\P{no}', "");
    Expect(1, 127244, '\P{^no}', "");
    Expect(0, 127245, '\p{no}', "");
    Expect(1, 127245, '\p{^no}', "");
    Expect(1, 127245, '\P{no}', "");
    Expect(0, 127245, '\P{^no}', "");
    Expect(1, 127244, '\p{_-No}', "");
    Expect(0, 127244, '\p{^_-No}', "");
    Expect(0, 127244, '\P{_-No}', "");
    Expect(1, 127244, '\P{^_-No}', "");
    Expect(0, 127245, '\p{_-No}', "");
    Expect(1, 127245, '\p{^_-No}', "");
    Expect(1, 127245, '\P{_-No}', "");
    Expect(0, 127245, '\P{^_-No}', "");
    Error('\p{-	is_No/a/}');
    Error('\P{-	is_No/a/}');
    Expect(1, 127244, '\p{isno}', "");
    Expect(0, 127244, '\p{^isno}', "");
    Expect(0, 127244, '\P{isno}', "");
    Expect(1, 127244, '\P{^isno}', "");
    Expect(0, 127245, '\p{isno}', "");
    Expect(1, 127245, '\p{^isno}', "");
    Expect(1, 127245, '\P{isno}', "");
    Expect(0, 127245, '\P{^isno}', "");
    Expect(1, 127244, '\p{-	IS_no}', "");
    Expect(0, 127244, '\p{^-	IS_no}', "");
    Expect(0, 127244, '\P{-	IS_no}', "");
    Expect(1, 127244, '\P{^-	IS_no}', "");
    Expect(0, 127245, '\p{-	IS_no}', "");
    Expect(1, 127245, '\p{^-	IS_no}', "");
    Expect(1, 127245, '\P{-	IS_no}', "");
    Expect(0, 127245, '\P{^-	IS_no}', "");
    Error('\p{ /a/other_Punctuation}');
    Error('\P{ /a/other_Punctuation}');
    Expect(1, 125279, '\p{otherpunctuation}', "");
    Expect(0, 125279, '\p{^otherpunctuation}', "");
    Expect(0, 125279, '\P{otherpunctuation}', "");
    Expect(1, 125279, '\P{^otherpunctuation}', "");
    Expect(0, 125280, '\p{otherpunctuation}', "");
    Expect(1, 125280, '\p{^otherpunctuation}', "");
    Expect(1, 125280, '\P{otherpunctuation}', "");
    Expect(0, 125280, '\P{^otherpunctuation}', "");
    Expect(1, 125279, '\p{ -other_Punctuation}', "");
    Expect(0, 125279, '\p{^ -other_Punctuation}', "");
    Expect(0, 125279, '\P{ -other_Punctuation}', "");
    Expect(1, 125279, '\P{^ -other_Punctuation}', "");
    Expect(0, 125280, '\p{ -other_Punctuation}', "");
    Expect(1, 125280, '\p{^ -other_Punctuation}', "");
    Expect(1, 125280, '\P{ -other_Punctuation}', "");
    Expect(0, 125280, '\P{^ -other_Punctuation}', "");
    Error('\p{- IS_OTHER_PUNCTUATION/a/}');
    Error('\P{- IS_OTHER_PUNCTUATION/a/}');
    Expect(1, 125279, '\p{isotherpunctuation}', "");
    Expect(0, 125279, '\p{^isotherpunctuation}', "");
    Expect(0, 125279, '\P{isotherpunctuation}', "");
    Expect(1, 125279, '\P{^isotherpunctuation}', "");
    Expect(0, 125280, '\p{isotherpunctuation}', "");
    Expect(1, 125280, '\p{^isotherpunctuation}', "");
    Expect(1, 125280, '\P{isotherpunctuation}', "");
    Expect(0, 125280, '\P{^isotherpunctuation}', "");
    Expect(1, 125279, '\p{		is_Other_Punctuation}', "");
    Expect(0, 125279, '\p{^		is_Other_Punctuation}', "");
    Expect(0, 125279, '\P{		is_Other_Punctuation}', "");
    Expect(1, 125279, '\P{^		is_Other_Punctuation}', "");
    Expect(0, 125280, '\p{		is_Other_Punctuation}', "");
    Expect(1, 125280, '\p{^		is_Other_Punctuation}', "");
    Expect(1, 125280, '\P{		is_Other_Punctuation}', "");
    Expect(0, 125280, '\P{^		is_Other_Punctuation}', "");
    Error('\p{/a/ _po}');
    Error('\P{/a/ _po}');
    Expect(1, 125279, '\p{po}', "");
    Expect(0, 125279, '\p{^po}', "");
    Expect(0, 125279, '\P{po}', "");
    Expect(1, 125279, '\P{^po}', "");
    Expect(0, 125280, '\p{po}', "");
    Expect(1, 125280, '\p{^po}', "");
    Expect(1, 125280, '\P{po}', "");
    Expect(0, 125280, '\P{^po}', "");
    Expect(1, 125279, '\p{ Po}', "");
    Expect(0, 125279, '\p{^ Po}', "");
    Expect(0, 125279, '\P{ Po}', "");
    Expect(1, 125279, '\P{^ Po}', "");
    Expect(0, 125280, '\p{ Po}', "");
    Expect(1, 125280, '\p{^ Po}', "");
    Expect(1, 125280, '\P{ Po}', "");
    Expect(0, 125280, '\P{^ Po}', "");
    Error('\p{/a/ -Is_po}');
    Error('\P{/a/ -Is_po}');
    Expect(1, 125279, '\p{ispo}', "");
    Expect(0, 125279, '\p{^ispo}', "");
    Expect(0, 125279, '\P{ispo}', "");
    Expect(1, 125279, '\P{^ispo}', "");
    Expect(0, 125280, '\p{ispo}', "");
    Expect(1, 125280, '\p{^ispo}', "");
    Expect(1, 125280, '\P{ispo}', "");
    Expect(0, 125280, '\P{^ispo}', "");
    Expect(1, 125279, '\p{ _is_PO}', "");
    Expect(0, 125279, '\p{^ _is_PO}', "");
    Expect(0, 125279, '\P{ _is_PO}', "");
    Expect(1, 125279, '\P{^ _is_PO}', "");
    Expect(0, 125280, '\p{ _is_PO}', "");
    Expect(1, 125280, '\p{^ _is_PO}', "");
    Expect(1, 125280, '\P{ _is_PO}', "");
    Expect(0, 125280, '\P{^ _is_PO}', "");
    Error('\p{/a/ _Other_SYMBOL}');
    Error('\P{/a/ _Other_SYMBOL}');
    Expect(1, 129994, '\p{othersymbol}', "");
    Expect(0, 129994, '\p{^othersymbol}', "");
    Expect(0, 129994, '\P{othersymbol}', "");
    Expect(1, 129994, '\P{^othersymbol}', "");
    Expect(0, 129995, '\p{othersymbol}', "");
    Expect(1, 129995, '\p{^othersymbol}', "");
    Expect(1, 129995, '\P{othersymbol}', "");
    Expect(0, 129995, '\P{^othersymbol}', "");
    Expect(1, 129994, '\p{_-Other_Symbol}', "");
    Expect(0, 129994, '\p{^_-Other_Symbol}', "");
    Expect(0, 129994, '\P{_-Other_Symbol}', "");
    Expect(1, 129994, '\P{^_-Other_Symbol}', "");
    Expect(0, 129995, '\p{_-Other_Symbol}', "");
    Expect(1, 129995, '\p{^_-Other_Symbol}', "");
    Expect(1, 129995, '\P{_-Other_Symbol}', "");
    Expect(0, 129995, '\P{^_-Other_Symbol}', "");
    Error('\p{/a/_	Is_Other_symbol}');
    Error('\P{/a/_	Is_Other_symbol}');
    Expect(1, 129994, '\p{isothersymbol}', "");
    Expect(0, 129994, '\p{^isothersymbol}', "");
    Expect(0, 129994, '\P{isothersymbol}', "");
    Expect(1, 129994, '\P{^isothersymbol}', "");
    Expect(0, 129995, '\p{isothersymbol}', "");
    Expect(1, 129995, '\p{^isothersymbol}', "");
    Expect(1, 129995, '\P{isothersymbol}', "");
    Expect(0, 129995, '\P{^isothersymbol}', "");
    Expect(1, 129994, '\p{-Is_other_Symbol}', "");
    Expect(0, 129994, '\p{^-Is_other_Symbol}', "");
    Expect(0, 129994, '\P{-Is_other_Symbol}', "");
    Expect(1, 129994, '\P{^-Is_other_Symbol}', "");
    Expect(0, 129995, '\p{-Is_other_Symbol}', "");
    Expect(1, 129995, '\p{^-Is_other_Symbol}', "");
    Expect(1, 129995, '\P{-Is_other_Symbol}', "");
    Expect(0, 129995, '\P{^-Is_other_Symbol}', "");
    Error('\p{ /a/So}');
    Error('\P{ /a/So}');
    Expect(1, 129994, '\p{so}', "");
    Expect(0, 129994, '\p{^so}', "");
    Expect(0, 129994, '\P{so}', "");
    Expect(1, 129994, '\P{^so}', "");
    Expect(0, 129995, '\p{so}', "");
    Expect(1, 129995, '\p{^so}', "");
    Expect(1, 129995, '\P{so}', "");
    Expect(0, 129995, '\P{^so}', "");
    Expect(1, 129994, '\p{-so}', "");
    Expect(0, 129994, '\p{^-so}', "");
    Expect(0, 129994, '\P{-so}', "");
    Expect(1, 129994, '\P{^-so}', "");
    Expect(0, 129995, '\p{-so}', "");
    Expect(1, 129995, '\p{^-so}', "");
    Expect(1, 129995, '\P{-so}', "");
    Expect(0, 129995, '\P{^-so}', "");
    Error('\p{-/a/Is_so}');
    Error('\P{-/a/Is_so}');
    Expect(1, 129994, '\p{isso}', "");
    Expect(0, 129994, '\p{^isso}', "");
    Expect(0, 129994, '\P{isso}', "");
    Expect(1, 129994, '\P{^isso}', "");
    Expect(0, 129995, '\p{isso}', "");
    Expect(1, 129995, '\p{^isso}', "");
    Expect(1, 129995, '\P{isso}', "");
    Expect(0, 129995, '\P{^isso}', "");
    Expect(1, 129994, '\p{_	Is_SO}', "");
    Expect(0, 129994, '\p{^_	Is_SO}', "");
    Expect(0, 129994, '\P{_	Is_SO}', "");
    Expect(1, 129994, '\P{^_	Is_SO}', "");
    Expect(0, 129995, '\p{_	Is_SO}', "");
    Expect(1, 129995, '\p{^_	Is_SO}', "");
    Expect(1, 129995, '\P{_	Is_SO}', "");
    Expect(0, 129995, '\P{^_	Is_SO}', "");
    Error('\p{Other_Uppercase}');
    Error('\P{Other_Uppercase}');
    Error('\p{OUpper}');
    Error('\P{OUpper}');
    Error('\p{/a/__ottoman_SIYAQ_Numbers}');
    Error('\P{/a/__ottoman_SIYAQ_Numbers}');
    Expect(1, 126287, '\p{ottomansiyaqnumbers}', "");
    Expect(0, 126287, '\p{^ottomansiyaqnumbers}', "");
    Expect(0, 126287, '\P{ottomansiyaqnumbers}', "");
    Expect(1, 126287, '\P{^ottomansiyaqnumbers}', "");
    Expect(0, 126288, '\p{ottomansiyaqnumbers}', "");
    Expect(1, 126288, '\p{^ottomansiyaqnumbers}', "");
    Expect(1, 126288, '\P{ottomansiyaqnumbers}', "");
    Expect(0, 126288, '\P{^ottomansiyaqnumbers}', "");
    Expect(1, 126287, '\p{_	Ottoman_Siyaq_NUMBERS}', "");
    Expect(0, 126287, '\p{^_	Ottoman_Siyaq_NUMBERS}', "");
    Expect(0, 126287, '\P{_	Ottoman_Siyaq_NUMBERS}', "");
    Expect(1, 126287, '\P{^_	Ottoman_Siyaq_NUMBERS}', "");
    Expect(0, 126288, '\p{_	Ottoman_Siyaq_NUMBERS}', "");
    Expect(1, 126288, '\p{^_	Ottoman_Siyaq_NUMBERS}', "");
    Expect(1, 126288, '\P{_	Ottoman_Siyaq_NUMBERS}', "");
    Expect(0, 126288, '\P{^_	Ottoman_Siyaq_NUMBERS}', "");
    Error('\p{/a/_Is_Ottoman_SIYAQ_numbers}');
    Error('\P{/a/_Is_Ottoman_SIYAQ_numbers}');
    Expect(1, 126287, '\p{isottomansiyaqnumbers}', "");
    Expect(0, 126287, '\p{^isottomansiyaqnumbers}', "");
    Expect(0, 126287, '\P{isottomansiyaqnumbers}', "");
    Expect(1, 126287, '\P{^isottomansiyaqnumbers}', "");
    Expect(0, 126288, '\p{isottomansiyaqnumbers}', "");
    Expect(1, 126288, '\p{^isottomansiyaqnumbers}', "");
    Expect(1, 126288, '\P{isottomansiyaqnumbers}', "");
    Expect(0, 126288, '\P{^isottomansiyaqnumbers}', "");
    Expect(1, 126287, '\p{-_is_ottoman_Siyaq_NUMBERS}', "");
    Expect(0, 126287, '\p{^-_is_ottoman_Siyaq_NUMBERS}', "");
    Expect(0, 126287, '\P{-_is_ottoman_Siyaq_NUMBERS}', "");
    Expect(1, 126287, '\P{^-_is_ottoman_Siyaq_NUMBERS}', "");
    Expect(0, 126288, '\p{-_is_ottoman_Siyaq_NUMBERS}', "");
    Expect(1, 126288, '\p{^-_is_ottoman_Siyaq_NUMBERS}', "");
    Expect(1, 126288, '\P{-_is_ottoman_Siyaq_NUMBERS}', "");
    Expect(0, 126288, '\P{^-_is_ottoman_Siyaq_NUMBERS}', "");
    Error('\p{ :=in_Ottoman_siyaq_Numbers}');
    Error('\P{ :=in_Ottoman_siyaq_Numbers}');
    Expect(1, 126287, '\p{inottomansiyaqnumbers}', "");
    Expect(0, 126287, '\p{^inottomansiyaqnumbers}', "");
    Expect(0, 126287, '\P{inottomansiyaqnumbers}', "");
    Expect(1, 126287, '\P{^inottomansiyaqnumbers}', "");
    Expect(0, 126288, '\p{inottomansiyaqnumbers}', "");
    Expect(1, 126288, '\p{^inottomansiyaqnumbers}', "");
    Expect(1, 126288, '\P{inottomansiyaqnumbers}', "");
    Expect(0, 126288, '\P{^inottomansiyaqnumbers}', "");
    Expect(1, 126287, '\p{__In_OTTOMAN_Siyaq_Numbers}', "");
    Expect(0, 126287, '\p{^__In_OTTOMAN_Siyaq_Numbers}', "");
    Expect(0, 126287, '\P{__In_OTTOMAN_Siyaq_Numbers}', "");
    Expect(1, 126287, '\P{^__In_OTTOMAN_Siyaq_Numbers}', "");
    Expect(0, 126288, '\p{__In_OTTOMAN_Siyaq_Numbers}', "");
    Expect(1, 126288, '\p{^__In_OTTOMAN_Siyaq_Numbers}', "");
    Expect(1, 126288, '\P{__In_OTTOMAN_Siyaq_Numbers}', "");
    Expect(0, 126288, '\P{^__In_OTTOMAN_Siyaq_Numbers}', "");
    Error('\p{ _PAHAWH_hmong/a/}');
    Error('\P{ _PAHAWH_hmong/a/}');
    Expect(1, 93071, '\p{pahawhhmong}', "");
    Expect(0, 93071, '\p{^pahawhhmong}', "");
    Expect(0, 93071, '\P{pahawhhmong}', "");
    Expect(1, 93071, '\P{^pahawhhmong}', "");
    Expect(0, 93072, '\p{pahawhhmong}', "");
    Expect(1, 93072, '\p{^pahawhhmong}', "");
    Expect(1, 93072, '\P{pahawhhmong}', "");
    Expect(0, 93072, '\P{^pahawhhmong}', "");
    Expect(1, 93071, '\p{-PAHAWH_hmong}', "");
    Expect(0, 93071, '\p{^-PAHAWH_hmong}', "");
    Expect(0, 93071, '\P{-PAHAWH_hmong}', "");
    Expect(1, 93071, '\P{^-PAHAWH_hmong}', "");
    Expect(0, 93072, '\p{-PAHAWH_hmong}', "");
    Expect(1, 93072, '\p{^-PAHAWH_hmong}', "");
    Expect(1, 93072, '\P{-PAHAWH_hmong}', "");
    Expect(0, 93072, '\P{^-PAHAWH_hmong}', "");
    Error('\p{	Is_Pahawh_Hmong:=}');
    Error('\P{	Is_Pahawh_Hmong:=}');
    Expect(1, 93071, '\p{ispahawhhmong}', "");
    Expect(0, 93071, '\p{^ispahawhhmong}', "");
    Expect(0, 93071, '\P{ispahawhhmong}', "");
    Expect(1, 93071, '\P{^ispahawhhmong}', "");
    Expect(0, 93072, '\p{ispahawhhmong}', "");
    Expect(1, 93072, '\p{^ispahawhhmong}', "");
    Expect(1, 93072, '\P{ispahawhhmong}', "");
    Expect(0, 93072, '\P{^ispahawhhmong}', "");
    Expect(1, 93071, '\p{ _is_Pahawh_hmong}', "");
    Expect(0, 93071, '\p{^ _is_Pahawh_hmong}', "");
    Expect(0, 93071, '\P{ _is_Pahawh_hmong}', "");
    Expect(1, 93071, '\P{^ _is_Pahawh_hmong}', "");
    Expect(0, 93072, '\p{ _is_Pahawh_hmong}', "");
    Expect(1, 93072, '\p{^ _is_Pahawh_hmong}', "");
    Expect(1, 93072, '\P{ _is_Pahawh_hmong}', "");
    Expect(0, 93072, '\P{^ _is_Pahawh_hmong}', "");
    Error('\p{:=	_HMNG}');
    Error('\P{:=	_HMNG}');
    Expect(1, 93071, '\p{hmng}', "");
    Expect(0, 93071, '\p{^hmng}', "");
    Expect(0, 93071, '\P{hmng}', "");
    Expect(1, 93071, '\P{^hmng}', "");
    Expect(0, 93072, '\p{hmng}', "");
    Expect(1, 93072, '\p{^hmng}', "");
    Expect(1, 93072, '\P{hmng}', "");
    Expect(0, 93072, '\P{^hmng}', "");
    Expect(1, 93071, '\p{ 	hmng}', "");
    Expect(0, 93071, '\p{^ 	hmng}', "");
    Expect(0, 93071, '\P{ 	hmng}', "");
    Expect(1, 93071, '\P{^ 	hmng}', "");
    Expect(0, 93072, '\p{ 	hmng}', "");
    Expect(1, 93072, '\p{^ 	hmng}', "");
    Expect(1, 93072, '\P{ 	hmng}', "");
    Expect(0, 93072, '\P{^ 	hmng}', "");
    Error('\p{/a/_-IS_Hmng}');
    Error('\P{/a/_-IS_Hmng}');
    Expect(1, 93071, '\p{ishmng}', "");
    Expect(0, 93071, '\p{^ishmng}', "");
    Expect(0, 93071, '\P{ishmng}', "");
    Expect(1, 93071, '\P{^ishmng}', "");
    Expect(0, 93072, '\p{ishmng}', "");
    Expect(1, 93072, '\p{^ishmng}', "");
    Expect(1, 93072, '\P{ishmng}', "");
    Expect(0, 93072, '\P{^ishmng}', "");
    Expect(1, 93071, '\p{Is_hmng}', "");
    Expect(0, 93071, '\p{^Is_hmng}', "");
    Expect(0, 93071, '\P{Is_hmng}', "");
    Expect(1, 93071, '\P{^Is_hmng}', "");
    Expect(0, 93072, '\p{Is_hmng}', "");
    Expect(1, 93072, '\p{^Is_hmng}', "");
    Expect(1, 93072, '\P{Is_hmng}', "");
    Expect(0, 93072, '\P{^Is_hmng}', "");
    Error('\p{_/a/PALMYRENE}');
    Error('\P{_/a/PALMYRENE}');
    Expect(1, 67711, '\p{palmyrene}', "");
    Expect(0, 67711, '\p{^palmyrene}', "");
    Expect(0, 67711, '\P{palmyrene}', "");
    Expect(1, 67711, '\P{^palmyrene}', "");
    Expect(0, 67712, '\p{palmyrene}', "");
    Expect(1, 67712, '\p{^palmyrene}', "");
    Expect(1, 67712, '\P{palmyrene}', "");
    Expect(0, 67712, '\P{^palmyrene}', "");
    Expect(1, 67711, '\p{  Palmyrene}', "");
    Expect(0, 67711, '\p{^  Palmyrene}', "");
    Expect(0, 67711, '\P{  Palmyrene}', "");
    Expect(1, 67711, '\P{^  Palmyrene}', "");
    Expect(0, 67712, '\p{  Palmyrene}', "");
    Expect(1, 67712, '\p{^  Palmyrene}', "");
    Expect(1, 67712, '\P{  Palmyrene}', "");
    Expect(0, 67712, '\P{^  Palmyrene}', "");
    Error('\p{_/a/Is_palmyrene}');
    Error('\P{_/a/Is_palmyrene}');
    Expect(1, 67711, '\p{ispalmyrene}', "");
    Expect(0, 67711, '\p{^ispalmyrene}', "");
    Expect(0, 67711, '\P{ispalmyrene}', "");
    Expect(1, 67711, '\P{^ispalmyrene}', "");
    Expect(0, 67712, '\p{ispalmyrene}', "");
    Expect(1, 67712, '\p{^ispalmyrene}', "");
    Expect(1, 67712, '\P{ispalmyrene}', "");
    Expect(0, 67712, '\P{^ispalmyrene}', "");
    Expect(1, 67711, '\p{-	is_palmyrene}', "");
    Expect(0, 67711, '\p{^-	is_palmyrene}', "");
    Expect(0, 67711, '\P{-	is_palmyrene}', "");
    Expect(1, 67711, '\P{^-	is_palmyrene}', "");
    Expect(0, 67712, '\p{-	is_palmyrene}', "");
    Expect(1, 67712, '\p{^-	is_palmyrene}', "");
    Expect(1, 67712, '\P{-	is_palmyrene}', "");
    Expect(0, 67712, '\P{^-	is_palmyrene}', "");
    Error('\p{/a/Palm}');
    Error('\P{/a/Palm}');
    Expect(1, 67711, '\p{palm}', "");
    Expect(0, 67711, '\p{^palm}', "");
    Expect(0, 67711, '\P{palm}', "");
    Expect(1, 67711, '\P{^palm}', "");
    Expect(0, 67712, '\p{palm}', "");
    Expect(1, 67712, '\p{^palm}', "");
    Expect(1, 67712, '\P{palm}', "");
    Expect(0, 67712, '\P{^palm}', "");
    Expect(1, 67711, '\p{_	Palm}', "");
    Expect(0, 67711, '\p{^_	Palm}', "");
    Expect(0, 67711, '\P{_	Palm}', "");
    Expect(1, 67711, '\P{^_	Palm}', "");
    Expect(0, 67712, '\p{_	Palm}', "");
    Expect(1, 67712, '\p{^_	Palm}', "");
    Expect(1, 67712, '\P{_	Palm}', "");
    Expect(0, 67712, '\P{^_	Palm}', "");
    Error('\p{-Is_palm/a/}');
    Error('\P{-Is_palm/a/}');
    Expect(1, 67711, '\p{ispalm}', "");
    Expect(0, 67711, '\p{^ispalm}', "");
    Expect(0, 67711, '\P{ispalm}', "");
    Expect(1, 67711, '\P{^ispalm}', "");
    Expect(0, 67712, '\p{ispalm}', "");
    Expect(1, 67712, '\p{^ispalm}', "");
    Expect(1, 67712, '\P{ispalm}', "");
    Expect(0, 67712, '\P{^ispalm}', "");
    Expect(1, 67711, '\p{	Is_PALM}', "");
    Expect(0, 67711, '\p{^	Is_PALM}', "");
    Expect(0, 67711, '\P{	Is_PALM}', "");
    Expect(1, 67711, '\P{^	Is_PALM}', "");
    Expect(0, 67712, '\p{	Is_PALM}', "");
    Expect(1, 67712, '\p{^	Is_PALM}', "");
    Expect(1, 67712, '\P{	Is_PALM}', "");
    Expect(0, 67712, '\P{^	Is_PALM}', "");
    Error('\p{-Paragraph_SEPARATOR:=}');
    Error('\P{-Paragraph_SEPARATOR:=}');
    Expect(1, 8233, '\p{paragraphseparator}', "");
    Expect(0, 8233, '\p{^paragraphseparator}', "");
    Expect(0, 8233, '\P{paragraphseparator}', "");
    Expect(1, 8233, '\P{^paragraphseparator}', "");
    Expect(0, 8234, '\p{paragraphseparator}', "");
    Expect(1, 8234, '\p{^paragraphseparator}', "");
    Expect(1, 8234, '\P{paragraphseparator}', "");
    Expect(0, 8234, '\P{^paragraphseparator}', "");
    Expect(1, 8233, '\p{ 	PARAGRAPH_Separator}', "");
    Expect(0, 8233, '\p{^ 	PARAGRAPH_Separator}', "");
    Expect(0, 8233, '\P{ 	PARAGRAPH_Separator}', "");
    Expect(1, 8233, '\P{^ 	PARAGRAPH_Separator}', "");
    Expect(0, 8234, '\p{ 	PARAGRAPH_Separator}', "");
    Expect(1, 8234, '\p{^ 	PARAGRAPH_Separator}', "");
    Expect(1, 8234, '\P{ 	PARAGRAPH_Separator}', "");
    Expect(0, 8234, '\P{^ 	PARAGRAPH_Separator}', "");
    Error('\p{:= -Is_Paragraph_separator}');
    Error('\P{:= -Is_Paragraph_separator}');
    Expect(1, 8233, '\p{isparagraphseparator}', "");
    Expect(0, 8233, '\p{^isparagraphseparator}', "");
    Expect(0, 8233, '\P{isparagraphseparator}', "");
    Expect(1, 8233, '\P{^isparagraphseparator}', "");
    Expect(0, 8234, '\p{isparagraphseparator}', "");
    Expect(1, 8234, '\p{^isparagraphseparator}', "");
    Expect(1, 8234, '\P{isparagraphseparator}', "");
    Expect(0, 8234, '\P{^isparagraphseparator}', "");
    Expect(1, 8233, '\p{__is_PARAGRAPH_Separator}', "");
    Expect(0, 8233, '\p{^__is_PARAGRAPH_Separator}', "");
    Expect(0, 8233, '\P{__is_PARAGRAPH_Separator}', "");
    Expect(1, 8233, '\P{^__is_PARAGRAPH_Separator}', "");
    Expect(0, 8234, '\p{__is_PARAGRAPH_Separator}', "");
    Expect(1, 8234, '\p{^__is_PARAGRAPH_Separator}', "");
    Expect(1, 8234, '\P{__is_PARAGRAPH_Separator}', "");
    Expect(0, 8234, '\P{^__is_PARAGRAPH_Separator}', "");
    Error('\p{:=__ZP}');
    Error('\P{:=__ZP}');
    Expect(1, 8233, '\p{zp}', "");
    Expect(0, 8233, '\p{^zp}', "");
    Expect(0, 8233, '\P{zp}', "");
    Expect(1, 8233, '\P{^zp}', "");
    Expect(0, 8234, '\p{zp}', "");
    Expect(1, 8234, '\p{^zp}', "");
    Expect(1, 8234, '\P{zp}', "");
    Expect(0, 8234, '\P{^zp}', "");
    Expect(1, 8233, '\p{_ZP}', "");
    Expect(0, 8233, '\p{^_ZP}', "");
    Expect(0, 8233, '\P{_ZP}', "");
    Expect(1, 8233, '\P{^_ZP}', "");
    Expect(0, 8234, '\p{_ZP}', "");
    Expect(1, 8234, '\p{^_ZP}', "");
    Expect(1, 8234, '\P{_ZP}', "");
    Expect(0, 8234, '\P{^_ZP}', "");
    Error('\p{		Is_ZP/a/}');
    Error('\P{		Is_ZP/a/}');
    Expect(1, 8233, '\p{iszp}', "");
    Expect(0, 8233, '\p{^iszp}', "");
    Expect(0, 8233, '\P{iszp}', "");
    Expect(1, 8233, '\P{^iszp}', "");
    Expect(0, 8234, '\p{iszp}', "");
    Expect(1, 8234, '\p{^iszp}', "");
    Expect(1, 8234, '\P{iszp}', "");
    Expect(0, 8234, '\P{^iszp}', "");
    Expect(1, 8233, '\p{-_IS_Zp}', "");
    Expect(0, 8233, '\p{^-_IS_Zp}', "");
    Expect(0, 8233, '\P{-_IS_Zp}', "");
    Expect(1, 8233, '\P{^-_IS_Zp}', "");
    Expect(0, 8234, '\p{-_IS_Zp}', "");
    Expect(1, 8234, '\p{^-_IS_Zp}', "");
    Expect(1, 8234, '\P{-_IS_Zp}', "");
    Expect(0, 8234, '\P{^-_IS_Zp}', "");
    Error('\p{-pattern_Syntax:=}');
    Error('\P{-pattern_Syntax:=}');
    Expect(1, 65094, '\p{patternsyntax}', "");
    Expect(0, 65094, '\p{^patternsyntax}', "");
    Expect(0, 65094, '\P{patternsyntax}', "");
    Expect(1, 65094, '\P{^patternsyntax}', "");
    Expect(0, 65095, '\p{patternsyntax}', "");
    Expect(1, 65095, '\p{^patternsyntax}', "");
    Expect(1, 65095, '\P{patternsyntax}', "");
    Expect(0, 65095, '\P{^patternsyntax}', "");
    Expect(1, 65094, '\p{__Pattern_SYNTAX}', "");
    Expect(0, 65094, '\p{^__Pattern_SYNTAX}', "");
    Expect(0, 65094, '\P{__Pattern_SYNTAX}', "");
    Expect(1, 65094, '\P{^__Pattern_SYNTAX}', "");
    Expect(0, 65095, '\p{__Pattern_SYNTAX}', "");
    Expect(1, 65095, '\p{^__Pattern_SYNTAX}', "");
    Expect(1, 65095, '\P{__Pattern_SYNTAX}', "");
    Expect(0, 65095, '\P{^__Pattern_SYNTAX}', "");
    Error('\p{:= 	IS_pattern_Syntax}');
    Error('\P{:= 	IS_pattern_Syntax}');
    Expect(1, 65094, '\p{ispatternsyntax}', "");
    Expect(0, 65094, '\p{^ispatternsyntax}', "");
    Expect(0, 65094, '\P{ispatternsyntax}', "");
    Expect(1, 65094, '\P{^ispatternsyntax}', "");
    Expect(0, 65095, '\p{ispatternsyntax}', "");
    Expect(1, 65095, '\p{^ispatternsyntax}', "");
    Expect(1, 65095, '\P{ispatternsyntax}', "");
    Expect(0, 65095, '\P{^ispatternsyntax}', "");
    Expect(1, 65094, '\p{ Is_PATTERN_Syntax}', "");
    Expect(0, 65094, '\p{^ Is_PATTERN_Syntax}', "");
    Expect(0, 65094, '\P{ Is_PATTERN_Syntax}', "");
    Expect(1, 65094, '\P{^ Is_PATTERN_Syntax}', "");
    Expect(0, 65095, '\p{ Is_PATTERN_Syntax}', "");
    Expect(1, 65095, '\p{^ Is_PATTERN_Syntax}', "");
    Expect(1, 65095, '\P{ Is_PATTERN_Syntax}', "");
    Expect(0, 65095, '\P{^ Is_PATTERN_Syntax}', "");
    Error('\p{		Pat_syn:=}');
    Error('\P{		Pat_syn:=}');
    Expect(1, 65094, '\p{patsyn}', "");
    Expect(0, 65094, '\p{^patsyn}', "");
    Expect(0, 65094, '\P{patsyn}', "");
    Expect(1, 65094, '\P{^patsyn}', "");
    Expect(0, 65095, '\p{patsyn}', "");
    Expect(1, 65095, '\p{^patsyn}', "");
    Expect(1, 65095, '\P{patsyn}', "");
    Expect(0, 65095, '\P{^patsyn}', "");
    Expect(1, 65094, '\p{		pat_Syn}', "");
    Expect(0, 65094, '\p{^		pat_Syn}', "");
    Expect(0, 65094, '\P{		pat_Syn}', "");
    Expect(1, 65094, '\P{^		pat_Syn}', "");
    Expect(0, 65095, '\p{		pat_Syn}', "");
    Expect(1, 65095, '\p{^		pat_Syn}', "");
    Expect(1, 65095, '\P{		pat_Syn}', "");
    Expect(0, 65095, '\P{^		pat_Syn}', "");
    Error('\p{ 	is_Pat_Syn/a/}');
    Error('\P{ 	is_Pat_Syn/a/}');
    Expect(1, 65094, '\p{ispatsyn}', "");
    Expect(0, 65094, '\p{^ispatsyn}', "");
    Expect(0, 65094, '\P{ispatsyn}', "");
    Expect(1, 65094, '\P{^ispatsyn}', "");
    Expect(0, 65095, '\p{ispatsyn}', "");
    Expect(1, 65095, '\p{^ispatsyn}', "");
    Expect(1, 65095, '\P{ispatsyn}', "");
    Expect(0, 65095, '\P{^ispatsyn}', "");
    Expect(1, 65094, '\p{ Is_pat_Syn}', "");
    Expect(0, 65094, '\p{^ Is_pat_Syn}', "");
    Expect(0, 65094, '\P{ Is_pat_Syn}', "");
    Expect(1, 65094, '\P{^ Is_pat_Syn}', "");
    Expect(0, 65095, '\p{ Is_pat_Syn}', "");
    Expect(1, 65095, '\p{^ Is_pat_Syn}', "");
    Expect(1, 65095, '\P{ Is_pat_Syn}', "");
    Expect(0, 65095, '\P{^ Is_pat_Syn}', "");
    Error('\p{-_Pattern_white_space/a/}');
    Error('\P{-_Pattern_white_space/a/}');
    Expect(1, 8233, '\p{patternwhitespace}', "");
    Expect(0, 8233, '\p{^patternwhitespace}', "");
    Expect(0, 8233, '\P{patternwhitespace}', "");
    Expect(1, 8233, '\P{^patternwhitespace}', "");
    Expect(0, 8234, '\p{patternwhitespace}', "");
    Expect(1, 8234, '\p{^patternwhitespace}', "");
    Expect(1, 8234, '\P{patternwhitespace}', "");
    Expect(0, 8234, '\P{^patternwhitespace}', "");
    Expect(1, 8233, '\p{_	PATTERN_WHITE_space}', "");
    Expect(0, 8233, '\p{^_	PATTERN_WHITE_space}', "");
    Expect(0, 8233, '\P{_	PATTERN_WHITE_space}', "");
    Expect(1, 8233, '\P{^_	PATTERN_WHITE_space}', "");
    Expect(0, 8234, '\p{_	PATTERN_WHITE_space}', "");
    Expect(1, 8234, '\p{^_	PATTERN_WHITE_space}', "");
    Expect(1, 8234, '\P{_	PATTERN_WHITE_space}', "");
    Expect(0, 8234, '\P{^_	PATTERN_WHITE_space}', "");
    Error('\p{	/a/IS_pattern_white_SPACE}');
    Error('\P{	/a/IS_pattern_white_SPACE}');
    Expect(1, 8233, '\p{ispatternwhitespace}', "");
    Expect(0, 8233, '\p{^ispatternwhitespace}', "");
    Expect(0, 8233, '\P{ispatternwhitespace}', "");
    Expect(1, 8233, '\P{^ispatternwhitespace}', "");
    Expect(0, 8234, '\p{ispatternwhitespace}', "");
    Expect(1, 8234, '\p{^ispatternwhitespace}', "");
    Expect(1, 8234, '\P{ispatternwhitespace}', "");
    Expect(0, 8234, '\P{^ispatternwhitespace}', "");
    Expect(1, 8233, '\p{	Is_PATTERN_white_SPACE}', "");
    Expect(0, 8233, '\p{^	Is_PATTERN_white_SPACE}', "");
    Expect(0, 8233, '\P{	Is_PATTERN_white_SPACE}', "");
    Expect(1, 8233, '\P{^	Is_PATTERN_white_SPACE}', "");
    Expect(0, 8234, '\p{	Is_PATTERN_white_SPACE}', "");
    Expect(1, 8234, '\p{^	Is_PATTERN_white_SPACE}', "");
    Expect(1, 8234, '\P{	Is_PATTERN_white_SPACE}', "");
    Expect(0, 8234, '\P{^	Is_PATTERN_white_SPACE}', "");
    Error('\p{:=-PAT_WS}');
    Error('\P{:=-PAT_WS}');
    Expect(1, 8233, '\p{patws}', "");
    Expect(0, 8233, '\p{^patws}', "");
    Expect(0, 8233, '\P{patws}', "");
    Expect(1, 8233, '\P{^patws}', "");
    Expect(0, 8234, '\p{patws}', "");
    Expect(1, 8234, '\p{^patws}', "");
    Expect(1, 8234, '\P{patws}', "");
    Expect(0, 8234, '\P{^patws}', "");
    Expect(1, 8233, '\p{_Pat_WS}', "");
    Expect(0, 8233, '\p{^_Pat_WS}', "");
    Expect(0, 8233, '\P{_Pat_WS}', "");
    Expect(1, 8233, '\P{^_Pat_WS}', "");
    Expect(0, 8234, '\p{_Pat_WS}', "");
    Expect(1, 8234, '\p{^_Pat_WS}', "");
    Expect(1, 8234, '\P{_Pat_WS}', "");
    Expect(0, 8234, '\P{^_Pat_WS}', "");
    Error('\p{:=_	Is_pat_WS}');
    Error('\P{:=_	Is_pat_WS}');
    Expect(1, 8233, '\p{ispatws}', "");
    Expect(0, 8233, '\p{^ispatws}', "");
    Expect(0, 8233, '\P{ispatws}', "");
    Expect(1, 8233, '\P{^ispatws}', "");
    Expect(0, 8234, '\p{ispatws}', "");
    Expect(1, 8234, '\p{^ispatws}', "");
    Expect(1, 8234, '\P{ispatws}', "");
    Expect(0, 8234, '\P{^ispatws}', "");
    Expect(1, 8233, '\p{IS_pat_WS}', "");
    Expect(0, 8233, '\p{^IS_pat_WS}', "");
    Expect(0, 8233, '\P{IS_pat_WS}', "");
    Expect(1, 8233, '\P{^IS_pat_WS}', "");
    Expect(0, 8234, '\p{IS_pat_WS}', "");
    Expect(1, 8234, '\p{^IS_pat_WS}', "");
    Expect(1, 8234, '\P{IS_pat_WS}', "");
    Expect(0, 8234, '\P{^IS_pat_WS}', "");
    Error('\p{	Pau_Cin_Hau:=}');
    Error('\P{	Pau_Cin_Hau:=}');
    Expect(1, 72440, '\p{paucinhau}', "");
    Expect(0, 72440, '\p{^paucinhau}', "");
    Expect(0, 72440, '\P{paucinhau}', "");
    Expect(1, 72440, '\P{^paucinhau}', "");
    Expect(0, 72441, '\p{paucinhau}', "");
    Expect(1, 72441, '\p{^paucinhau}', "");
    Expect(1, 72441, '\P{paucinhau}', "");
    Expect(0, 72441, '\P{^paucinhau}', "");
    Expect(1, 72440, '\p{  Pau_cin_Hau}', "");
    Expect(0, 72440, '\p{^  Pau_cin_Hau}', "");
    Expect(0, 72440, '\P{  Pau_cin_Hau}', "");
    Expect(1, 72440, '\P{^  Pau_cin_Hau}', "");
    Expect(0, 72441, '\p{  Pau_cin_Hau}', "");
    Expect(1, 72441, '\p{^  Pau_cin_Hau}', "");
    Expect(1, 72441, '\P{  Pau_cin_Hau}', "");
    Expect(0, 72441, '\P{^  Pau_cin_Hau}', "");
    Error('\p{/a/ -is_PAU_Cin_hau}');
    Error('\P{/a/ -is_PAU_Cin_hau}');
    Expect(1, 72440, '\p{ispaucinhau}', "");
    Expect(0, 72440, '\p{^ispaucinhau}', "");
    Expect(0, 72440, '\P{ispaucinhau}', "");
    Expect(1, 72440, '\P{^ispaucinhau}', "");
    Expect(0, 72441, '\p{ispaucinhau}', "");
    Expect(1, 72441, '\p{^ispaucinhau}', "");
    Expect(1, 72441, '\P{ispaucinhau}', "");
    Expect(0, 72441, '\P{^ispaucinhau}', "");
    Expect(1, 72440, '\p{Is_pau_cin_Hau}', "");
    Expect(0, 72440, '\p{^Is_pau_cin_Hau}', "");
    Expect(0, 72440, '\P{Is_pau_cin_Hau}', "");
    Expect(1, 72440, '\P{^Is_pau_cin_Hau}', "");
    Expect(0, 72441, '\p{Is_pau_cin_Hau}', "");
    Expect(1, 72441, '\p{^Is_pau_cin_Hau}', "");
    Expect(1, 72441, '\P{Is_pau_cin_Hau}', "");
    Expect(0, 72441, '\P{^Is_pau_cin_Hau}', "");
    Error('\p{- Pauc/a/}');
    Error('\P{- Pauc/a/}');
    Expect(1, 72440, '\p{pauc}', "");
    Expect(0, 72440, '\p{^pauc}', "");
    Expect(0, 72440, '\P{pauc}', "");
    Expect(1, 72440, '\P{^pauc}', "");
    Expect(0, 72441, '\p{pauc}', "");
    Expect(1, 72441, '\p{^pauc}', "");
    Expect(1, 72441, '\P{pauc}', "");
    Expect(0, 72441, '\P{^pauc}', "");
    Expect(1, 72440, '\p{ _Pauc}', "");
    Expect(0, 72440, '\p{^ _Pauc}', "");
    Expect(0, 72440, '\P{ _Pauc}', "");
    Expect(1, 72440, '\P{^ _Pauc}', "");
    Expect(0, 72441, '\p{ _Pauc}', "");
    Expect(1, 72441, '\p{^ _Pauc}', "");
    Expect(1, 72441, '\P{ _Pauc}', "");
    Expect(0, 72441, '\P{^ _Pauc}', "");
    Error('\p{_ is_Pauc:=}');
    Error('\P{_ is_Pauc:=}');
    Expect(1, 72440, '\p{ispauc}', "");
    Expect(0, 72440, '\p{^ispauc}', "");
    Expect(0, 72440, '\P{ispauc}', "");
    Expect(1, 72440, '\P{^ispauc}', "");
    Expect(0, 72441, '\p{ispauc}', "");
    Expect(1, 72441, '\p{^ispauc}', "");
    Expect(1, 72441, '\P{ispauc}', "");
    Expect(0, 72441, '\P{^ispauc}', "");
    Expect(1, 72440, '\p{	-is_pauc}', "");
    Expect(0, 72440, '\p{^	-is_pauc}', "");
    Expect(0, 72440, '\P{	-is_pauc}', "");
    Expect(1, 72440, '\P{^	-is_pauc}', "");
    Expect(0, 72441, '\p{	-is_pauc}', "");
    Expect(1, 72441, '\p{^	-is_pauc}', "");
    Expect(1, 72441, '\P{	-is_pauc}', "");
    Expect(0, 72441, '\P{^	-is_pauc}', "");
    Error('\p{_PHAGS_pa/a/}');
    Error('\P{_PHAGS_pa/a/}');
    Expect(1, 43127, '\p{phagspa}', "");
    Expect(0, 43127, '\p{^phagspa}', "");
    Expect(0, 43127, '\P{phagspa}', "");
    Expect(1, 43127, '\P{^phagspa}', "");
    Expect(0, 43128, '\p{phagspa}', "");
    Expect(1, 43128, '\p{^phagspa}', "");
    Expect(1, 43128, '\P{phagspa}', "");
    Expect(0, 43128, '\P{^phagspa}', "");
    Expect(1, 43127, '\p{- PHAGS_pa}', "");
    Expect(0, 43127, '\p{^- PHAGS_pa}', "");
    Expect(0, 43127, '\P{- PHAGS_pa}', "");
    Expect(1, 43127, '\P{^- PHAGS_pa}', "");
    Expect(0, 43128, '\p{- PHAGS_pa}', "");
    Expect(1, 43128, '\p{^- PHAGS_pa}', "");
    Expect(1, 43128, '\P{- PHAGS_pa}', "");
    Expect(0, 43128, '\P{^- PHAGS_pa}', "");
    Error('\p{-Is_phags_Pa:=}');
    Error('\P{-Is_phags_Pa:=}');
    Expect(1, 43127, '\p{isphagspa}', "");
    Expect(0, 43127, '\p{^isphagspa}', "");
    Expect(0, 43127, '\P{isphagspa}', "");
    Expect(1, 43127, '\P{^isphagspa}', "");
    Expect(0, 43128, '\p{isphagspa}', "");
    Expect(1, 43128, '\p{^isphagspa}', "");
    Expect(1, 43128, '\P{isphagspa}', "");
    Expect(0, 43128, '\P{^isphagspa}', "");
    Expect(1, 43127, '\p{-IS_Phags_pa}', "");
    Expect(0, 43127, '\p{^-IS_Phags_pa}', "");
    Expect(0, 43127, '\P{-IS_Phags_pa}', "");
    Expect(1, 43127, '\P{^-IS_Phags_pa}', "");
    Expect(0, 43128, '\p{-IS_Phags_pa}', "");
    Expect(1, 43128, '\p{^-IS_Phags_pa}', "");
    Expect(1, 43128, '\P{-IS_Phags_pa}', "");
    Expect(0, 43128, '\P{^-IS_Phags_pa}', "");
    Error('\p{-	phag/a/}');
    Error('\P{-	phag/a/}');
    Expect(1, 43127, '\p{phag}', "");
    Expect(0, 43127, '\p{^phag}', "");
    Expect(0, 43127, '\P{phag}', "");
    Expect(1, 43127, '\P{^phag}', "");
    Expect(0, 43128, '\p{phag}', "");
    Expect(1, 43128, '\p{^phag}', "");
    Expect(1, 43128, '\P{phag}', "");
    Expect(0, 43128, '\P{^phag}', "");
    Expect(1, 43127, '\p{_Phag}', "");
    Expect(0, 43127, '\p{^_Phag}', "");
    Expect(0, 43127, '\P{_Phag}', "");
    Expect(1, 43127, '\P{^_Phag}', "");
    Expect(0, 43128, '\p{_Phag}', "");
    Expect(1, 43128, '\p{^_Phag}', "");
    Expect(1, 43128, '\P{_Phag}', "");
    Expect(0, 43128, '\P{^_Phag}', "");
    Error('\p{ is_PHAG:=}');
    Error('\P{ is_PHAG:=}');
    Expect(1, 43127, '\p{isphag}', "");
    Expect(0, 43127, '\p{^isphag}', "");
    Expect(0, 43127, '\P{isphag}', "");
    Expect(1, 43127, '\P{^isphag}', "");
    Expect(0, 43128, '\p{isphag}', "");
    Expect(1, 43128, '\p{^isphag}', "");
    Expect(1, 43128, '\P{isphag}', "");
    Expect(0, 43128, '\P{^isphag}', "");
    Expect(1, 43127, '\p{ _IS_Phag}', "");
    Expect(0, 43127, '\p{^ _IS_Phag}', "");
    Expect(0, 43127, '\P{ _IS_Phag}', "");
    Expect(1, 43127, '\P{^ _IS_Phag}', "");
    Expect(0, 43128, '\p{ _IS_Phag}', "");
    Expect(1, 43128, '\p{^ _IS_Phag}', "");
    Expect(1, 43128, '\P{ _IS_Phag}', "");
    Expect(0, 43128, '\P{^ _IS_Phag}', "");
    Error('\p{/a/--Phaistos_DISC}');
    Error('\P{/a/--Phaistos_DISC}');
    Expect(1, 66047, '\p{phaistosdisc}', "");
    Expect(0, 66047, '\p{^phaistosdisc}', "");
    Expect(0, 66047, '\P{phaistosdisc}', "");
    Expect(1, 66047, '\P{^phaistosdisc}', "");
    Expect(0, 66048, '\p{phaistosdisc}', "");
    Expect(1, 66048, '\p{^phaistosdisc}', "");
    Expect(1, 66048, '\P{phaistosdisc}', "");
    Expect(0, 66048, '\P{^phaistosdisc}', "");
    Expect(1, 66047, '\p{__Phaistos_Disc}', "");
    Expect(0, 66047, '\p{^__Phaistos_Disc}', "");
    Expect(0, 66047, '\P{__Phaistos_Disc}', "");
    Expect(1, 66047, '\P{^__Phaistos_Disc}', "");
    Expect(0, 66048, '\p{__Phaistos_Disc}', "");
    Expect(1, 66048, '\p{^__Phaistos_Disc}', "");
    Expect(1, 66048, '\P{__Phaistos_Disc}', "");
    Expect(0, 66048, '\P{^__Phaistos_Disc}', "");
    Error('\p{:= IS_Phaistos_Disc}');
    Error('\P{:= IS_Phaistos_Disc}');
    Expect(1, 66047, '\p{isphaistosdisc}', "");
    Expect(0, 66047, '\p{^isphaistosdisc}', "");
    Expect(0, 66047, '\P{isphaistosdisc}', "");
    Expect(1, 66047, '\P{^isphaistosdisc}', "");
    Expect(0, 66048, '\p{isphaistosdisc}', "");
    Expect(1, 66048, '\p{^isphaistosdisc}', "");
    Expect(1, 66048, '\P{isphaistosdisc}', "");
    Expect(0, 66048, '\P{^isphaistosdisc}', "");
    Expect(1, 66047, '\p{_Is_Phaistos_DISC}', "");
    Expect(0, 66047, '\p{^_Is_Phaistos_DISC}', "");
    Expect(0, 66047, '\P{_Is_Phaistos_DISC}', "");
    Expect(1, 66047, '\P{^_Is_Phaistos_DISC}', "");
    Expect(0, 66048, '\p{_Is_Phaistos_DISC}', "");
    Expect(1, 66048, '\p{^_Is_Phaistos_DISC}', "");
    Expect(1, 66048, '\P{_Is_Phaistos_DISC}', "");
    Expect(0, 66048, '\P{^_Is_Phaistos_DISC}', "");
    Error('\p{/a/ -In_Phaistos_DISC}');
    Error('\P{/a/ -In_Phaistos_DISC}');
    Expect(1, 66047, '\p{inphaistosdisc}', "");
    Expect(0, 66047, '\p{^inphaistosdisc}', "");
    Expect(0, 66047, '\P{inphaistosdisc}', "");
    Expect(1, 66047, '\P{^inphaistosdisc}', "");
    Expect(0, 66048, '\p{inphaistosdisc}', "");
    Expect(1, 66048, '\p{^inphaistosdisc}', "");
    Expect(1, 66048, '\P{inphaistosdisc}', "");
    Expect(0, 66048, '\P{^inphaistosdisc}', "");
    Expect(1, 66047, '\p{ -In_PHAISTOS_Disc}', "");
    Expect(0, 66047, '\p{^ -In_PHAISTOS_Disc}', "");
    Expect(0, 66047, '\P{ -In_PHAISTOS_Disc}', "");
    Expect(1, 66047, '\P{^ -In_PHAISTOS_Disc}', "");
    Expect(0, 66048, '\p{ -In_PHAISTOS_Disc}', "");
    Expect(1, 66048, '\p{^ -In_PHAISTOS_Disc}', "");
    Expect(1, 66048, '\P{ -In_PHAISTOS_Disc}', "");
    Expect(0, 66048, '\P{^ -In_PHAISTOS_Disc}', "");
    Error('\p{_-Phaistos:=}');
    Error('\P{_-Phaistos:=}');
    Expect(1, 66047, '\p{phaistos}', "");
    Expect(0, 66047, '\p{^phaistos}', "");
    Expect(0, 66047, '\P{phaistos}', "");
    Expect(1, 66047, '\P{^phaistos}', "");
    Expect(0, 66048, '\p{phaistos}', "");
    Expect(1, 66048, '\p{^phaistos}', "");
    Expect(1, 66048, '\P{phaistos}', "");
    Expect(0, 66048, '\P{^phaistos}', "");
    Expect(1, 66047, '\p{ -PHAISTOS}', "");
    Expect(0, 66047, '\p{^ -PHAISTOS}', "");
    Expect(0, 66047, '\P{ -PHAISTOS}', "");
    Expect(1, 66047, '\P{^ -PHAISTOS}', "");
    Expect(0, 66048, '\p{ -PHAISTOS}', "");
    Expect(1, 66048, '\p{^ -PHAISTOS}', "");
    Expect(1, 66048, '\P{ -PHAISTOS}', "");
    Expect(0, 66048, '\P{^ -PHAISTOS}', "");
    Error('\p{/a/  Is_phaistos}');
    Error('\P{/a/  Is_phaistos}');
    Expect(1, 66047, '\p{isphaistos}', "");
    Expect(0, 66047, '\p{^isphaistos}', "");
    Expect(0, 66047, '\P{isphaistos}', "");
    Expect(1, 66047, '\P{^isphaistos}', "");
    Expect(0, 66048, '\p{isphaistos}', "");
    Expect(1, 66048, '\p{^isphaistos}', "");
    Expect(1, 66048, '\P{isphaistos}', "");
    Expect(0, 66048, '\P{^isphaistos}', "");
    Expect(1, 66047, '\p{ Is_phaistos}', "");
    Expect(0, 66047, '\p{^ Is_phaistos}', "");
    Expect(0, 66047, '\P{ Is_phaistos}', "");
    Expect(1, 66047, '\P{^ Is_phaistos}', "");
    Expect(0, 66048, '\p{ Is_phaistos}', "");
    Expect(1, 66048, '\p{^ Is_phaistos}', "");
    Expect(1, 66048, '\P{ Is_phaistos}', "");
    Expect(0, 66048, '\P{^ Is_phaistos}', "");
    Error('\p{/a/ -In_Phaistos}');
    Error('\P{/a/ -In_Phaistos}');
    Expect(1, 66047, '\p{inphaistos}', "");
    Expect(0, 66047, '\p{^inphaistos}', "");
    Expect(0, 66047, '\P{inphaistos}', "");
    Expect(1, 66047, '\P{^inphaistos}', "");
    Expect(0, 66048, '\p{inphaistos}', "");
    Expect(1, 66048, '\p{^inphaistos}', "");
    Expect(1, 66048, '\P{inphaistos}', "");
    Expect(0, 66048, '\P{^inphaistos}', "");
    Expect(1, 66047, '\p{-in_phaistos}', "");
    Expect(0, 66047, '\p{^-in_phaistos}', "");
    Expect(0, 66047, '\P{-in_phaistos}', "");
    Expect(1, 66047, '\P{^-in_phaistos}', "");
    Expect(0, 66048, '\p{-in_phaistos}', "");
    Expect(1, 66048, '\p{^-in_phaistos}', "");
    Expect(1, 66048, '\P{-in_phaistos}', "");
    Expect(0, 66048, '\P{^-in_phaistos}', "");
    Error('\p{/a/--Phoenician}');
    Error('\P{/a/--Phoenician}');
    Expect(1, 67871, '\p{phoenician}', "");
    Expect(0, 67871, '\p{^phoenician}', "");
    Expect(0, 67871, '\P{phoenician}', "");
    Expect(1, 67871, '\P{^phoenician}', "");
    Expect(0, 67872, '\p{phoenician}', "");
    Expect(1, 67872, '\p{^phoenician}', "");
    Expect(1, 67872, '\P{phoenician}', "");
    Expect(0, 67872, '\P{^phoenician}', "");
    Expect(1, 67871, '\p{_-Phoenician}', "");
    Expect(0, 67871, '\p{^_-Phoenician}', "");
    Expect(0, 67871, '\P{_-Phoenician}', "");
    Expect(1, 67871, '\P{^_-Phoenician}', "");
    Expect(0, 67872, '\p{_-Phoenician}', "");
    Expect(1, 67872, '\p{^_-Phoenician}', "");
    Expect(1, 67872, '\P{_-Phoenician}', "");
    Expect(0, 67872, '\P{^_-Phoenician}', "");
    Error('\p{:=_is_Phoenician}');
    Error('\P{:=_is_Phoenician}');
    Expect(1, 67871, '\p{isphoenician}', "");
    Expect(0, 67871, '\p{^isphoenician}', "");
    Expect(0, 67871, '\P{isphoenician}', "");
    Expect(1, 67871, '\P{^isphoenician}', "");
    Expect(0, 67872, '\p{isphoenician}', "");
    Expect(1, 67872, '\p{^isphoenician}', "");
    Expect(1, 67872, '\P{isphoenician}', "");
    Expect(0, 67872, '\P{^isphoenician}', "");
    Expect(1, 67871, '\p{	_is_PHOENICIAN}', "");
    Expect(0, 67871, '\p{^	_is_PHOENICIAN}', "");
    Expect(0, 67871, '\P{	_is_PHOENICIAN}', "");
    Expect(1, 67871, '\P{^	_is_PHOENICIAN}', "");
    Expect(0, 67872, '\p{	_is_PHOENICIAN}', "");
    Expect(1, 67872, '\p{^	_is_PHOENICIAN}', "");
    Expect(1, 67872, '\P{	_is_PHOENICIAN}', "");
    Expect(0, 67872, '\P{^	_is_PHOENICIAN}', "");
    Error('\p{_-phnx:=}');
    Error('\P{_-phnx:=}');
    Expect(1, 67871, '\p{phnx}', "");
    Expect(0, 67871, '\p{^phnx}', "");
    Expect(0, 67871, '\P{phnx}', "");
    Expect(1, 67871, '\P{^phnx}', "");
    Expect(0, 67872, '\p{phnx}', "");
    Expect(1, 67872, '\p{^phnx}', "");
    Expect(1, 67872, '\P{phnx}', "");
    Expect(0, 67872, '\P{^phnx}', "");
    Expect(1, 67871, '\p{ Phnx}', "");
    Expect(0, 67871, '\p{^ Phnx}', "");
    Expect(0, 67871, '\P{ Phnx}', "");
    Expect(1, 67871, '\P{^ Phnx}', "");
    Expect(0, 67872, '\p{ Phnx}', "");
    Expect(1, 67872, '\p{^ Phnx}', "");
    Expect(1, 67872, '\P{ Phnx}', "");
    Expect(0, 67872, '\P{^ Phnx}', "");
    Error('\p{:=_Is_phnx}');
    Error('\P{:=_Is_phnx}');
    Expect(1, 67871, '\p{isphnx}', "");
    Expect(0, 67871, '\p{^isphnx}', "");
    Expect(0, 67871, '\P{isphnx}', "");
    Expect(1, 67871, '\P{^isphnx}', "");
    Expect(0, 67872, '\p{isphnx}', "");
    Expect(1, 67872, '\p{^isphnx}', "");
    Expect(1, 67872, '\P{isphnx}', "");
    Expect(0, 67872, '\P{^isphnx}', "");
    Expect(1, 67871, '\p{ Is_phnx}', "");
    Expect(0, 67871, '\p{^ Is_phnx}', "");
    Expect(0, 67871, '\P{ Is_phnx}', "");
    Expect(1, 67871, '\P{^ Is_phnx}', "");
    Expect(0, 67872, '\p{ Is_phnx}', "");
    Expect(1, 67872, '\p{^ Is_phnx}', "");
    Expect(1, 67872, '\P{ Is_phnx}', "");
    Expect(0, 67872, '\P{^ Is_phnx}', "");
    Error('\p{/a/Phonetic_EXTENSIONS}');
    Error('\P{/a/Phonetic_EXTENSIONS}');
    Expect(1, 7551, '\p{phoneticextensions}', "");
    Expect(0, 7551, '\p{^phoneticextensions}', "");
    Expect(0, 7551, '\P{phoneticextensions}', "");
    Expect(1, 7551, '\P{^phoneticextensions}', "");
    Expect(0, 7552, '\p{phoneticextensions}', "");
    Expect(1, 7552, '\p{^phoneticextensions}', "");
    Expect(1, 7552, '\P{phoneticextensions}', "");
    Expect(0, 7552, '\P{^phoneticextensions}', "");
    Expect(1, 7551, '\p{	 PHONETIC_Extensions}', "");
    Expect(0, 7551, '\p{^	 PHONETIC_Extensions}', "");
    Expect(0, 7551, '\P{	 PHONETIC_Extensions}', "");
    Expect(1, 7551, '\P{^	 PHONETIC_Extensions}', "");
    Expect(0, 7552, '\p{	 PHONETIC_Extensions}', "");
    Expect(1, 7552, '\p{^	 PHONETIC_Extensions}', "");
    Expect(1, 7552, '\P{	 PHONETIC_Extensions}', "");
    Expect(0, 7552, '\P{^	 PHONETIC_Extensions}', "");
    Error('\p{	_Is_Phonetic_Extensions/a/}');
    Error('\P{	_Is_Phonetic_Extensions/a/}');
    Expect(1, 7551, '\p{isphoneticextensions}', "");
    Expect(0, 7551, '\p{^isphoneticextensions}', "");
    Expect(0, 7551, '\P{isphoneticextensions}', "");
    Expect(1, 7551, '\P{^isphoneticextensions}', "");
    Expect(0, 7552, '\p{isphoneticextensions}', "");
    Expect(1, 7552, '\p{^isphoneticextensions}', "");
    Expect(1, 7552, '\P{isphoneticextensions}', "");
    Expect(0, 7552, '\P{^isphoneticextensions}', "");
    Expect(1, 7551, '\p{_Is_phonetic_extensions}', "");
    Expect(0, 7551, '\p{^_Is_phonetic_extensions}', "");
    Expect(0, 7551, '\P{_Is_phonetic_extensions}', "");
    Expect(1, 7551, '\P{^_Is_phonetic_extensions}', "");
    Expect(0, 7552, '\p{_Is_phonetic_extensions}', "");
    Expect(1, 7552, '\p{^_Is_phonetic_extensions}', "");
    Expect(1, 7552, '\P{_Is_phonetic_extensions}', "");
    Expect(0, 7552, '\P{^_Is_phonetic_extensions}', "");
    Error('\p{/a/__In_Phonetic_EXTENSIONS}');
    Error('\P{/a/__In_Phonetic_EXTENSIONS}');
    Expect(1, 7551, '\p{inphoneticextensions}', "");
    Expect(0, 7551, '\p{^inphoneticextensions}', "");
    Expect(0, 7551, '\P{inphoneticextensions}', "");
    Expect(1, 7551, '\P{^inphoneticextensions}', "");
    Expect(0, 7552, '\p{inphoneticextensions}', "");
    Expect(1, 7552, '\p{^inphoneticextensions}', "");
    Expect(1, 7552, '\P{inphoneticextensions}', "");
    Expect(0, 7552, '\P{^inphoneticextensions}', "");
    Expect(1, 7551, '\p{ In_PHONETIC_Extensions}', "");
    Expect(0, 7551, '\p{^ In_PHONETIC_Extensions}', "");
    Expect(0, 7551, '\P{ In_PHONETIC_Extensions}', "");
    Expect(1, 7551, '\P{^ In_PHONETIC_Extensions}', "");
    Expect(0, 7552, '\p{ In_PHONETIC_Extensions}', "");
    Expect(1, 7552, '\p{^ In_PHONETIC_Extensions}', "");
    Expect(1, 7552, '\P{ In_PHONETIC_Extensions}', "");
    Expect(0, 7552, '\P{^ In_PHONETIC_Extensions}', "");
    Error('\p{:=Phonetic_EXT}');
    Error('\P{:=Phonetic_EXT}');
    Expect(1, 7551, '\p{phoneticext}', "");
    Expect(0, 7551, '\p{^phoneticext}', "");
    Expect(0, 7551, '\P{phoneticext}', "");
    Expect(1, 7551, '\P{^phoneticext}', "");
    Expect(0, 7552, '\p{phoneticext}', "");
    Expect(1, 7552, '\p{^phoneticext}', "");
    Expect(1, 7552, '\P{phoneticext}', "");
    Expect(0, 7552, '\P{^phoneticext}', "");
    Expect(1, 7551, '\p{	_PHONETIC_Ext}', "");
    Expect(0, 7551, '\p{^	_PHONETIC_Ext}', "");
    Expect(0, 7551, '\P{	_PHONETIC_Ext}', "");
    Expect(1, 7551, '\P{^	_PHONETIC_Ext}', "");
    Expect(0, 7552, '\p{	_PHONETIC_Ext}', "");
    Expect(1, 7552, '\p{^	_PHONETIC_Ext}', "");
    Expect(1, 7552, '\P{	_PHONETIC_Ext}', "");
    Expect(0, 7552, '\P{^	_PHONETIC_Ext}', "");
    Error('\p{:= 	IS_phonetic_Ext}');
    Error('\P{:= 	IS_phonetic_Ext}');
    Expect(1, 7551, '\p{isphoneticext}', "");
    Expect(0, 7551, '\p{^isphoneticext}', "");
    Expect(0, 7551, '\P{isphoneticext}', "");
    Expect(1, 7551, '\P{^isphoneticext}', "");
    Expect(0, 7552, '\p{isphoneticext}', "");
    Expect(1, 7552, '\p{^isphoneticext}', "");
    Expect(1, 7552, '\P{isphoneticext}', "");
    Expect(0, 7552, '\P{^isphoneticext}', "");
    Expect(1, 7551, '\p{_	IS_Phonetic_Ext}', "");
    Expect(0, 7551, '\p{^_	IS_Phonetic_Ext}', "");
    Expect(0, 7551, '\P{_	IS_Phonetic_Ext}', "");
    Expect(1, 7551, '\P{^_	IS_Phonetic_Ext}', "");
    Expect(0, 7552, '\p{_	IS_Phonetic_Ext}', "");
    Expect(1, 7552, '\p{^_	IS_Phonetic_Ext}', "");
    Expect(1, 7552, '\P{_	IS_Phonetic_Ext}', "");
    Expect(0, 7552, '\P{^_	IS_Phonetic_Ext}', "");
    Error('\p{	/a/IN_phonetic_Ext}');
    Error('\P{	/a/IN_phonetic_Ext}');
    Expect(1, 7551, '\p{inphoneticext}', "");
    Expect(0, 7551, '\p{^inphoneticext}', "");
    Expect(0, 7551, '\P{inphoneticext}', "");
    Expect(1, 7551, '\P{^inphoneticext}', "");
    Expect(0, 7552, '\p{inphoneticext}', "");
    Expect(1, 7552, '\p{^inphoneticext}', "");
    Expect(1, 7552, '\P{inphoneticext}', "");
    Expect(0, 7552, '\P{^inphoneticext}', "");
    Expect(1, 7551, '\p{ _In_PHONETIC_Ext}', "");
    Expect(0, 7551, '\p{^ _In_PHONETIC_Ext}', "");
    Expect(0, 7551, '\P{ _In_PHONETIC_Ext}', "");
    Expect(1, 7551, '\P{^ _In_PHONETIC_Ext}', "");
    Expect(0, 7552, '\p{ _In_PHONETIC_Ext}', "");
    Expect(1, 7552, '\p{^ _In_PHONETIC_Ext}', "");
    Expect(1, 7552, '\P{ _In_PHONETIC_Ext}', "");
    Expect(0, 7552, '\P{^ _In_PHONETIC_Ext}', "");
    Error('\p{:=Phonetic_EXTENSIONS_Supplement}');
    Error('\P{:=Phonetic_EXTENSIONS_Supplement}');
    Expect(1, 7615, '\p{phoneticextensionssupplement}', "");
    Expect(0, 7615, '\p{^phoneticextensionssupplement}', "");
    Expect(0, 7615, '\P{phoneticextensionssupplement}', "");
    Expect(1, 7615, '\P{^phoneticextensionssupplement}', "");
    Expect(0, 7616, '\p{phoneticextensionssupplement}', "");
    Expect(1, 7616, '\p{^phoneticextensionssupplement}', "");
    Expect(1, 7616, '\P{phoneticextensionssupplement}', "");
    Expect(0, 7616, '\P{^phoneticextensionssupplement}', "");
    Expect(1, 7615, '\p{-PHONETIC_Extensions_Supplement}', "");
    Expect(0, 7615, '\p{^-PHONETIC_Extensions_Supplement}', "");
    Expect(0, 7615, '\P{-PHONETIC_Extensions_Supplement}', "");
    Expect(1, 7615, '\P{^-PHONETIC_Extensions_Supplement}', "");
    Expect(0, 7616, '\p{-PHONETIC_Extensions_Supplement}', "");
    Expect(1, 7616, '\p{^-PHONETIC_Extensions_Supplement}', "");
    Expect(1, 7616, '\P{-PHONETIC_Extensions_Supplement}', "");
    Expect(0, 7616, '\P{^-PHONETIC_Extensions_Supplement}', "");
    Error('\p{-:=Is_Phonetic_Extensions_supplement}');
    Error('\P{-:=Is_Phonetic_Extensions_supplement}');
    Expect(1, 7615, '\p{isphoneticextensionssupplement}', "");
    Expect(0, 7615, '\p{^isphoneticextensionssupplement}', "");
    Expect(0, 7615, '\P{isphoneticextensionssupplement}', "");
    Expect(1, 7615, '\P{^isphoneticextensionssupplement}', "");
    Expect(0, 7616, '\p{isphoneticextensionssupplement}', "");
    Expect(1, 7616, '\p{^isphoneticextensionssupplement}', "");
    Expect(1, 7616, '\P{isphoneticextensionssupplement}', "");
    Expect(0, 7616, '\P{^isphoneticextensionssupplement}', "");
    Expect(1, 7615, '\p{IS_Phonetic_extensions_SUPPLEMENT}', "");
    Expect(0, 7615, '\p{^IS_Phonetic_extensions_SUPPLEMENT}', "");
    Expect(0, 7615, '\P{IS_Phonetic_extensions_SUPPLEMENT}', "");
    Expect(1, 7615, '\P{^IS_Phonetic_extensions_SUPPLEMENT}', "");
    Expect(0, 7616, '\p{IS_Phonetic_extensions_SUPPLEMENT}', "");
    Expect(1, 7616, '\p{^IS_Phonetic_extensions_SUPPLEMENT}', "");
    Expect(1, 7616, '\P{IS_Phonetic_extensions_SUPPLEMENT}', "");
    Expect(0, 7616, '\P{^IS_Phonetic_extensions_SUPPLEMENT}', "");
    Error('\p{  In_PHONETIC_Extensions_Supplement/a/}');
    Error('\P{  In_PHONETIC_Extensions_Supplement/a/}');
    Expect(1, 7615, '\p{inphoneticextensionssupplement}', "");
    Expect(0, 7615, '\p{^inphoneticextensionssupplement}', "");
    Expect(0, 7615, '\P{inphoneticextensionssupplement}', "");
    Expect(1, 7615, '\P{^inphoneticextensionssupplement}', "");
    Expect(0, 7616, '\p{inphoneticextensionssupplement}', "");
    Expect(1, 7616, '\p{^inphoneticextensionssupplement}', "");
    Expect(1, 7616, '\P{inphoneticextensionssupplement}', "");
    Expect(0, 7616, '\P{^inphoneticextensionssupplement}', "");
    Expect(1, 7615, '\p{	in_phonetic_EXTENSIONS_SUPPLEMENT}', "");
    Expect(0, 7615, '\p{^	in_phonetic_EXTENSIONS_SUPPLEMENT}', "");
    Expect(0, 7615, '\P{	in_phonetic_EXTENSIONS_SUPPLEMENT}', "");
    Expect(1, 7615, '\P{^	in_phonetic_EXTENSIONS_SUPPLEMENT}', "");
    Expect(0, 7616, '\p{	in_phonetic_EXTENSIONS_SUPPLEMENT}', "");
    Expect(1, 7616, '\p{^	in_phonetic_EXTENSIONS_SUPPLEMENT}', "");
    Expect(1, 7616, '\P{	in_phonetic_EXTENSIONS_SUPPLEMENT}', "");
    Expect(0, 7616, '\P{^	in_phonetic_EXTENSIONS_SUPPLEMENT}', "");
    Error('\p{ -Phonetic_Ext_SUP/a/}');
    Error('\P{ -Phonetic_Ext_SUP/a/}');
    Expect(1, 7615, '\p{phoneticextsup}', "");
    Expect(0, 7615, '\p{^phoneticextsup}', "");
    Expect(0, 7615, '\P{phoneticextsup}', "");
    Expect(1, 7615, '\P{^phoneticextsup}', "");
    Expect(0, 7616, '\p{phoneticextsup}', "");
    Expect(1, 7616, '\p{^phoneticextsup}', "");
    Expect(1, 7616, '\P{phoneticextsup}', "");
    Expect(0, 7616, '\P{^phoneticextsup}', "");
    Expect(1, 7615, '\p{_ phonetic_Ext_Sup}', "");
    Expect(0, 7615, '\p{^_ phonetic_Ext_Sup}', "");
    Expect(0, 7615, '\P{_ phonetic_Ext_Sup}', "");
    Expect(1, 7615, '\P{^_ phonetic_Ext_Sup}', "");
    Expect(0, 7616, '\p{_ phonetic_Ext_Sup}', "");
    Expect(1, 7616, '\p{^_ phonetic_Ext_Sup}', "");
    Expect(1, 7616, '\P{_ phonetic_Ext_Sup}', "");
    Expect(0, 7616, '\P{^_ phonetic_Ext_Sup}', "");
    Error('\p{/a/ _Is_Phonetic_EXT_SUP}');
    Error('\P{/a/ _Is_Phonetic_EXT_SUP}');
    Expect(1, 7615, '\p{isphoneticextsup}', "");
    Expect(0, 7615, '\p{^isphoneticextsup}', "");
    Expect(0, 7615, '\P{isphoneticextsup}', "");
    Expect(1, 7615, '\P{^isphoneticextsup}', "");
    Expect(0, 7616, '\p{isphoneticextsup}', "");
    Expect(1, 7616, '\p{^isphoneticextsup}', "");
    Expect(1, 7616, '\P{isphoneticextsup}', "");
    Expect(0, 7616, '\P{^isphoneticextsup}', "");
    Expect(1, 7615, '\p{	 Is_Phonetic_Ext_sup}', "");
    Expect(0, 7615, '\p{^	 Is_Phonetic_Ext_sup}', "");
    Expect(0, 7615, '\P{	 Is_Phonetic_Ext_sup}', "");
    Expect(1, 7615, '\P{^	 Is_Phonetic_Ext_sup}', "");
    Expect(0, 7616, '\p{	 Is_Phonetic_Ext_sup}', "");
    Expect(1, 7616, '\p{^	 Is_Phonetic_Ext_sup}', "");
    Expect(1, 7616, '\P{	 Is_Phonetic_Ext_sup}', "");
    Expect(0, 7616, '\P{^	 Is_Phonetic_Ext_sup}', "");
    Error('\p{ /a/in_PHONETIC_Ext_Sup}');
    Error('\P{ /a/in_PHONETIC_Ext_Sup}');
    Expect(1, 7615, '\p{inphoneticextsup}', "");
    Expect(0, 7615, '\p{^inphoneticextsup}', "");
    Expect(0, 7615, '\P{inphoneticextsup}', "");
    Expect(1, 7615, '\P{^inphoneticextsup}', "");
    Expect(0, 7616, '\p{inphoneticextsup}', "");
    Expect(1, 7616, '\p{^inphoneticextsup}', "");
    Expect(1, 7616, '\P{inphoneticextsup}', "");
    Expect(0, 7616, '\P{^inphoneticextsup}', "");
    Expect(1, 7615, '\p{_-in_phonetic_EXT_Sup}', "");
    Expect(0, 7615, '\p{^_-in_phonetic_EXT_Sup}', "");
    Expect(0, 7615, '\P{_-in_phonetic_EXT_Sup}', "");
    Expect(1, 7615, '\P{^_-in_phonetic_EXT_Sup}', "");
    Expect(0, 7616, '\p{_-in_phonetic_EXT_Sup}', "");
    Expect(1, 7616, '\p{^_-in_phonetic_EXT_Sup}', "");
    Expect(1, 7616, '\P{_-in_phonetic_EXT_Sup}', "");
    Expect(0, 7616, '\P{^_-in_phonetic_EXT_Sup}', "");
    Error('\p{_:=playing_Cards}');
    Error('\P{_:=playing_Cards}');
    Expect(1, 127231, '\p{playingcards}', "");
    Expect(0, 127231, '\p{^playingcards}', "");
    Expect(0, 127231, '\P{playingcards}', "");
    Expect(1, 127231, '\P{^playingcards}', "");
    Expect(0, 127232, '\p{playingcards}', "");
    Expect(1, 127232, '\p{^playingcards}', "");
    Expect(1, 127232, '\P{playingcards}', "");
    Expect(0, 127232, '\P{^playingcards}', "");
    Expect(1, 127231, '\p{__PLAYING_cards}', "");
    Expect(0, 127231, '\p{^__PLAYING_cards}', "");
    Expect(0, 127231, '\P{__PLAYING_cards}', "");
    Expect(1, 127231, '\P{^__PLAYING_cards}', "");
    Expect(0, 127232, '\p{__PLAYING_cards}', "");
    Expect(1, 127232, '\p{^__PLAYING_cards}', "");
    Expect(1, 127232, '\P{__PLAYING_cards}', "");
    Expect(0, 127232, '\P{^__PLAYING_cards}', "");
    Error('\p{:= _IS_Playing_CARDS}');
    Error('\P{:= _IS_Playing_CARDS}');
    Expect(1, 127231, '\p{isplayingcards}', "");
    Expect(0, 127231, '\p{^isplayingcards}', "");
    Expect(0, 127231, '\P{isplayingcards}', "");
    Expect(1, 127231, '\P{^isplayingcards}', "");
    Expect(0, 127232, '\p{isplayingcards}', "");
    Expect(1, 127232, '\p{^isplayingcards}', "");
    Expect(1, 127232, '\P{isplayingcards}', "");
    Expect(0, 127232, '\P{^isplayingcards}', "");
    Expect(1, 127231, '\p{	-IS_PLAYING_CARDS}', "");
    Expect(0, 127231, '\p{^	-IS_PLAYING_CARDS}', "");
    Expect(0, 127231, '\P{	-IS_PLAYING_CARDS}', "");
    Expect(1, 127231, '\P{^	-IS_PLAYING_CARDS}', "");
    Expect(0, 127232, '\p{	-IS_PLAYING_CARDS}', "");
    Expect(1, 127232, '\p{^	-IS_PLAYING_CARDS}', "");
    Expect(1, 127232, '\P{	-IS_PLAYING_CARDS}', "");
    Expect(0, 127232, '\P{^	-IS_PLAYING_CARDS}', "");
    Error('\p{	/a/In_Playing_Cards}');
    Error('\P{	/a/In_Playing_Cards}');
    Expect(1, 127231, '\p{inplayingcards}', "");
    Expect(0, 127231, '\p{^inplayingcards}', "");
    Expect(0, 127231, '\P{inplayingcards}', "");
    Expect(1, 127231, '\P{^inplayingcards}', "");
    Expect(0, 127232, '\p{inplayingcards}', "");
    Expect(1, 127232, '\p{^inplayingcards}', "");
    Expect(1, 127232, '\P{inplayingcards}', "");
    Expect(0, 127232, '\P{^inplayingcards}', "");
    Expect(1, 127231, '\p{ In_Playing_cards}', "");
    Expect(0, 127231, '\p{^ In_Playing_cards}', "");
    Expect(0, 127231, '\P{ In_Playing_cards}', "");
    Expect(1, 127231, '\P{^ In_Playing_cards}', "");
    Expect(0, 127232, '\p{ In_Playing_cards}', "");
    Expect(1, 127232, '\p{^ In_Playing_cards}', "");
    Expect(1, 127232, '\P{ In_Playing_cards}', "");
    Expect(0, 127232, '\P{^ In_Playing_cards}', "");
    Error('\p{-/a/PosixAlnum}');
    Error('\P{-/a/PosixAlnum}');
    Expect(1, 122, '\p{posixalnum}', "");
    Expect(0, 122, '\p{^posixalnum}', "");
    Expect(0, 122, '\P{posixalnum}', "");
    Expect(1, 122, '\P{^posixalnum}', "");
    Expect(0, 123, '\p{posixalnum}', "");
    Expect(1, 123, '\p{^posixalnum}', "");
    Expect(1, 123, '\P{posixalnum}', "");
    Expect(0, 123, '\P{^posixalnum}', "");
    Expect(1, 122, '\p{-	PosixAlnum}', "");
    Expect(0, 122, '\p{^-	PosixAlnum}', "");
    Expect(0, 122, '\P{-	PosixAlnum}', "");
    Expect(1, 122, '\P{^-	PosixAlnum}', "");
    Expect(0, 123, '\p{-	PosixAlnum}', "");
    Expect(1, 123, '\p{^-	PosixAlnum}', "");
    Expect(1, 123, '\P{-	PosixAlnum}', "");
    Expect(0, 123, '\P{^-	PosixAlnum}', "");
    Error('\p{:=Is_POSIXALNUM}');
    Error('\P{:=Is_POSIXALNUM}');
    Expect(1, 122, '\p{isposixalnum}', "");
    Expect(0, 122, '\p{^isposixalnum}', "");
    Expect(0, 122, '\P{isposixalnum}', "");
    Expect(1, 122, '\P{^isposixalnum}', "");
    Expect(0, 123, '\p{isposixalnum}', "");
    Expect(1, 123, '\p{^isposixalnum}', "");
    Expect(1, 123, '\P{isposixalnum}', "");
    Expect(0, 123, '\P{^isposixalnum}', "");
    Expect(1, 122, '\p{ Is_PosixAlnum}', "");
    Expect(0, 122, '\p{^ Is_PosixAlnum}', "");
    Expect(0, 122, '\P{ Is_PosixAlnum}', "");
    Expect(1, 122, '\P{^ Is_PosixAlnum}', "");
    Expect(0, 123, '\p{ Is_PosixAlnum}', "");
    Expect(1, 123, '\p{^ Is_PosixAlnum}', "");
    Expect(1, 123, '\P{ Is_PosixAlnum}', "");
    Expect(0, 123, '\P{^ Is_PosixAlnum}', "");
    Error('\p{	/a/posixalpha}');
    Error('\P{	/a/posixalpha}');
    Expect(1, 122, '\p{posixalpha}', "");
    Expect(0, 122, '\p{^posixalpha}', "");
    Expect(0, 122, '\P{posixalpha}', "");
    Expect(1, 122, '\P{^posixalpha}', "");
    Expect(0, 123, '\p{posixalpha}', "");
    Expect(1, 123, '\p{^posixalpha}', "");
    Expect(1, 123, '\P{posixalpha}', "");
    Expect(0, 123, '\P{^posixalpha}', "");
    Expect(1, 122, '\p{_posixalpha}', "");
    Expect(0, 122, '\p{^_posixalpha}', "");
    Expect(0, 122, '\P{_posixalpha}', "");
    Expect(1, 122, '\P{^_posixalpha}', "");
    Expect(0, 123, '\p{_posixalpha}', "");
    Expect(1, 123, '\p{^_posixalpha}', "");
    Expect(1, 123, '\P{_posixalpha}', "");
    Expect(0, 123, '\P{^_posixalpha}', "");
    Error('\p{	_Is_PosixAlpha:=}');
    Error('\P{	_Is_PosixAlpha:=}');
    Expect(1, 122, '\p{isposixalpha}', "");
    Expect(0, 122, '\p{^isposixalpha}', "");
    Expect(0, 122, '\P{isposixalpha}', "");
    Expect(1, 122, '\P{^isposixalpha}', "");
    Expect(0, 123, '\p{isposixalpha}', "");
    Expect(1, 123, '\p{^isposixalpha}', "");
    Expect(1, 123, '\P{isposixalpha}', "");
    Expect(0, 123, '\P{^isposixalpha}', "");
    Expect(1, 122, '\p{ -Is_POSIXALPHA}', "");
    Expect(0, 122, '\p{^ -Is_POSIXALPHA}', "");
    Expect(0, 122, '\P{ -Is_POSIXALPHA}', "");
    Expect(1, 122, '\P{^ -Is_POSIXALPHA}', "");
    Expect(0, 123, '\p{ -Is_POSIXALPHA}', "");
    Expect(1, 123, '\p{^ -Is_POSIXALPHA}', "");
    Expect(1, 123, '\P{ -Is_POSIXALPHA}', "");
    Expect(0, 123, '\P{^ -Is_POSIXALPHA}', "");
    Error('\p{:=_	PosixBlank}');
    Error('\P{:=_	PosixBlank}');
    Expect(1, 32, '\p{posixblank}', "");
    Expect(0, 32, '\p{^posixblank}', "");
    Expect(0, 32, '\P{posixblank}', "");
    Expect(1, 32, '\P{^posixblank}', "");
    Expect(0, 33, '\p{posixblank}', "");
    Expect(1, 33, '\p{^posixblank}', "");
    Expect(1, 33, '\P{posixblank}', "");
    Expect(0, 33, '\P{^posixblank}', "");
    Expect(1, 32, '\p{		POSIXBLANK}', "");
    Expect(0, 32, '\p{^		POSIXBLANK}', "");
    Expect(0, 32, '\P{		POSIXBLANK}', "");
    Expect(1, 32, '\P{^		POSIXBLANK}', "");
    Expect(0, 33, '\p{		POSIXBLANK}', "");
    Expect(1, 33, '\p{^		POSIXBLANK}', "");
    Expect(1, 33, '\P{		POSIXBLANK}', "");
    Expect(0, 33, '\P{^		POSIXBLANK}', "");
    Error('\p{	 is_posixblank:=}');
    Error('\P{	 is_posixblank:=}');
    Expect(1, 32, '\p{isposixblank}', "");
    Expect(0, 32, '\p{^isposixblank}', "");
    Expect(0, 32, '\P{isposixblank}', "");
    Expect(1, 32, '\P{^isposixblank}', "");
    Expect(0, 33, '\p{isposixblank}', "");
    Expect(1, 33, '\p{^isposixblank}', "");
    Expect(1, 33, '\P{isposixblank}', "");
    Expect(0, 33, '\P{^isposixblank}', "");
    Expect(1, 32, '\p{_ IS_POSIXBLANK}', "");
    Expect(0, 32, '\p{^_ IS_POSIXBLANK}', "");
    Expect(0, 32, '\P{_ IS_POSIXBLANK}', "");
    Expect(1, 32, '\P{^_ IS_POSIXBLANK}', "");
    Expect(0, 33, '\p{_ IS_POSIXBLANK}', "");
    Expect(1, 33, '\p{^_ IS_POSIXBLANK}', "");
    Expect(1, 33, '\P{_ IS_POSIXBLANK}', "");
    Expect(0, 33, '\P{^_ IS_POSIXBLANK}', "");
    Error('\p{-:=posixcntrl}');
    Error('\P{-:=posixcntrl}');
    Expect(1, 127, '\p{posixcntrl}', "");
    Expect(0, 127, '\p{^posixcntrl}', "");
    Expect(0, 127, '\P{posixcntrl}', "");
    Expect(1, 127, '\P{^posixcntrl}', "");
    Expect(0, 128, '\p{posixcntrl}', "");
    Expect(1, 128, '\p{^posixcntrl}', "");
    Expect(1, 128, '\P{posixcntrl}', "");
    Expect(0, 128, '\P{^posixcntrl}', "");
    Expect(1, 127, '\p{ -PosixCntrl}', "");
    Expect(0, 127, '\p{^ -PosixCntrl}', "");
    Expect(0, 127, '\P{ -PosixCntrl}', "");
    Expect(1, 127, '\P{^ -PosixCntrl}', "");
    Expect(0, 128, '\p{ -PosixCntrl}', "");
    Expect(1, 128, '\p{^ -PosixCntrl}', "");
    Expect(1, 128, '\P{ -PosixCntrl}', "");
    Expect(0, 128, '\P{^ -PosixCntrl}', "");
    Error('\p{	/a/IS_posixcntrl}');
    Error('\P{	/a/IS_posixcntrl}');
    Expect(1, 127, '\p{isposixcntrl}', "");
    Expect(0, 127, '\p{^isposixcntrl}', "");
    Expect(0, 127, '\P{isposixcntrl}', "");
    Expect(1, 127, '\P{^isposixcntrl}', "");
    Expect(0, 128, '\p{isposixcntrl}', "");
    Expect(1, 128, '\p{^isposixcntrl}', "");
    Expect(1, 128, '\P{isposixcntrl}', "");
    Expect(0, 128, '\P{^isposixcntrl}', "");
    Expect(1, 127, '\p{IS_PosixCntrl}', "");
    Expect(0, 127, '\p{^IS_PosixCntrl}', "");
    Expect(0, 127, '\P{IS_PosixCntrl}', "");
    Expect(1, 127, '\P{^IS_PosixCntrl}', "");
    Expect(0, 128, '\p{IS_PosixCntrl}', "");
    Expect(1, 128, '\p{^IS_PosixCntrl}', "");
    Expect(1, 128, '\P{IS_PosixCntrl}', "");
    Expect(0, 128, '\P{^IS_PosixCntrl}', "");
    Error('\p{ POSIXDIGIT:=}');
    Error('\P{ POSIXDIGIT:=}');
    Expect(1, 57, '\p{posixdigit}', "");
    Expect(0, 57, '\p{^posixdigit}', "");
    Expect(0, 57, '\P{posixdigit}', "");
    Expect(1, 57, '\P{^posixdigit}', "");
    Expect(0, 58, '\p{posixdigit}', "");
    Expect(1, 58, '\p{^posixdigit}', "");
    Expect(1, 58, '\P{posixdigit}', "");
    Expect(0, 58, '\P{^posixdigit}', "");
    Expect(1, 57, '\p{_ PosixDigit}', "");
    Expect(0, 57, '\p{^_ PosixDigit}', "");
    Expect(0, 57, '\P{_ PosixDigit}', "");
    Expect(1, 57, '\P{^_ PosixDigit}', "");
    Expect(0, 58, '\p{_ PosixDigit}', "");
    Expect(1, 58, '\p{^_ PosixDigit}', "");
    Expect(1, 58, '\P{_ PosixDigit}', "");
    Expect(0, 58, '\P{^_ PosixDigit}', "");
    Error('\p{/a/	is_PosixDigit}');
    Error('\P{/a/	is_PosixDigit}');
    Expect(1, 57, '\p{isposixdigit}', "");
    Expect(0, 57, '\p{^isposixdigit}', "");
    Expect(0, 57, '\P{isposixdigit}', "");
    Expect(1, 57, '\P{^isposixdigit}', "");
    Expect(0, 58, '\p{isposixdigit}', "");
    Expect(1, 58, '\p{^isposixdigit}', "");
    Expect(1, 58, '\P{isposixdigit}', "");
    Expect(0, 58, '\P{^isposixdigit}', "");
    Expect(1, 57, '\p{_ Is_PosixDigit}', "");
    Expect(0, 57, '\p{^_ Is_PosixDigit}', "");
    Expect(0, 57, '\P{_ Is_PosixDigit}', "");
    Expect(1, 57, '\P{^_ Is_PosixDigit}', "");
    Expect(0, 58, '\p{_ Is_PosixDigit}', "");
    Expect(1, 58, '\p{^_ Is_PosixDigit}', "");
    Expect(1, 58, '\P{_ Is_PosixDigit}', "");
    Expect(0, 58, '\P{^_ Is_PosixDigit}', "");
    Error('\p{:= _PosixGraph}');
    Error('\P{:= _PosixGraph}');
    Expect(1, 126, '\p{posixgraph}', "");
    Expect(0, 126, '\p{^posixgraph}', "");
    Expect(0, 126, '\P{posixgraph}', "");
    Expect(1, 126, '\P{^posixgraph}', "");
    Expect(0, 127, '\p{posixgraph}', "");
    Expect(1, 127, '\p{^posixgraph}', "");
    Expect(1, 127, '\P{posixgraph}', "");
    Expect(0, 127, '\P{^posixgraph}', "");
    Expect(1, 126, '\p{- PosixGraph}', "");
    Expect(0, 126, '\p{^- PosixGraph}', "");
    Expect(0, 126, '\P{- PosixGraph}', "");
    Expect(1, 126, '\P{^- PosixGraph}', "");
    Expect(0, 127, '\p{- PosixGraph}', "");
    Expect(1, 127, '\p{^- PosixGraph}', "");
    Expect(1, 127, '\P{- PosixGraph}', "");
    Expect(0, 127, '\P{^- PosixGraph}', "");
    Error('\p{/a/is_PosixGraph}');
    Error('\P{/a/is_PosixGraph}');
    Expect(1, 126, '\p{isposixgraph}', "");
    Expect(0, 126, '\p{^isposixgraph}', "");
    Expect(0, 126, '\P{isposixgraph}', "");
    Expect(1, 126, '\P{^isposixgraph}', "");
    Expect(0, 127, '\p{isposixgraph}', "");
    Expect(1, 127, '\p{^isposixgraph}', "");
    Expect(1, 127, '\P{isposixgraph}', "");
    Expect(0, 127, '\P{^isposixgraph}', "");
    Expect(1, 126, '\p{-_is_POSIXGRAPH}', "");
    Expect(0, 126, '\p{^-_is_POSIXGRAPH}', "");
    Expect(0, 126, '\P{-_is_POSIXGRAPH}', "");
    Expect(1, 126, '\P{^-_is_POSIXGRAPH}', "");
    Expect(0, 127, '\p{-_is_POSIXGRAPH}', "");
    Expect(1, 127, '\p{^-_is_POSIXGRAPH}', "");
    Expect(1, 127, '\P{-_is_POSIXGRAPH}', "");
    Expect(0, 127, '\P{^-_is_POSIXGRAPH}', "");
    Error('\p{-/a/posixlower}');
    Error('\P{-/a/posixlower}');
    Expect(1, 122, '\p{posixlower}', "");
    Expect(0, 122, '\p{^posixlower}', "");
    Expect(0, 122, '\P{posixlower}', "");
    Expect(1, 122, '\P{^posixlower}', "");
    Expect(0, 123, '\p{posixlower}', "");
    Expect(1, 123, '\p{^posixlower}', "");
    Expect(1, 123, '\P{posixlower}', "");
    Expect(0, 123, '\P{^posixlower}', "");
    Expect(1, 122, '\p{_PosixLower}', "");
    Expect(0, 122, '\p{^_PosixLower}', "");
    Expect(0, 122, '\P{_PosixLower}', "");
    Expect(1, 122, '\P{^_PosixLower}', "");
    Expect(0, 123, '\p{_PosixLower}', "");
    Expect(1, 123, '\p{^_PosixLower}', "");
    Expect(1, 123, '\P{_PosixLower}', "");
    Expect(0, 123, '\P{^_PosixLower}', "");
    Error('\p{:=	-IS_posixlower}');
    Error('\P{:=	-IS_posixlower}');
    Expect(1, 122, '\p{isposixlower}', "");
    Expect(0, 122, '\p{^isposixlower}', "");
    Expect(0, 122, '\P{isposixlower}', "");
    Expect(1, 122, '\P{^isposixlower}', "");
    Expect(0, 123, '\p{isposixlower}', "");
    Expect(1, 123, '\p{^isposixlower}', "");
    Expect(1, 123, '\P{isposixlower}', "");
    Expect(0, 123, '\P{^isposixlower}', "");
    Expect(1, 122, '\p{ _Is_posixlower}', "");
    Expect(0, 122, '\p{^ _Is_posixlower}', "");
    Expect(0, 122, '\P{ _Is_posixlower}', "");
    Expect(1, 122, '\P{^ _Is_posixlower}', "");
    Expect(0, 123, '\p{ _Is_posixlower}', "");
    Expect(1, 123, '\p{^ _Is_posixlower}', "");
    Expect(1, 123, '\P{ _Is_posixlower}', "");
    Expect(0, 123, '\P{^ _Is_posixlower}', "");
    Error('\p{_/a/PosixPrint}');
    Error('\P{_/a/PosixPrint}');
    Expect(1, 126, '\p{posixprint}', "");
    Expect(0, 126, '\p{^posixprint}', "");
    Expect(0, 126, '\P{posixprint}', "");
    Expect(1, 126, '\P{^posixprint}', "");
    Expect(0, 127, '\p{posixprint}', "");
    Expect(1, 127, '\p{^posixprint}', "");
    Expect(1, 127, '\P{posixprint}', "");
    Expect(0, 127, '\P{^posixprint}', "");
    Expect(1, 126, '\p{- posixprint}', "");
    Expect(0, 126, '\p{^- posixprint}', "");
    Expect(0, 126, '\P{- posixprint}', "");
    Expect(1, 126, '\P{^- posixprint}', "");
    Expect(0, 127, '\p{- posixprint}', "");
    Expect(1, 127, '\p{^- posixprint}', "");
    Expect(1, 127, '\P{- posixprint}', "");
    Expect(0, 127, '\P{^- posixprint}', "");
    Error('\p{:=	 Is_PosixPrint}');
    Error('\P{:=	 Is_PosixPrint}');
    Expect(1, 126, '\p{isposixprint}', "");
    Expect(0, 126, '\p{^isposixprint}', "");
    Expect(0, 126, '\P{isposixprint}', "");
    Expect(1, 126, '\P{^isposixprint}', "");
    Expect(0, 127, '\p{isposixprint}', "");
    Expect(1, 127, '\p{^isposixprint}', "");
    Expect(1, 127, '\P{isposixprint}', "");
    Expect(0, 127, '\P{^isposixprint}', "");
    Expect(1, 126, '\p{	Is_PosixPrint}', "");
    Expect(0, 126, '\p{^	Is_PosixPrint}', "");
    Expect(0, 126, '\P{	Is_PosixPrint}', "");
    Expect(1, 126, '\P{^	Is_PosixPrint}', "");
    Expect(0, 127, '\p{	Is_PosixPrint}', "");
    Expect(1, 127, '\p{^	Is_PosixPrint}', "");
    Expect(1, 127, '\P{	Is_PosixPrint}', "");
    Expect(0, 127, '\P{^	Is_PosixPrint}', "");
    Error('\p{_-POSIXPUNCT:=}');
    Error('\P{_-POSIXPUNCT:=}');
    Expect(1, 126, '\p{posixpunct}', "");
    Expect(0, 126, '\p{^posixpunct}', "");
    Expect(0, 126, '\P{posixpunct}', "");
    Expect(1, 126, '\P{^posixpunct}', "");
    Expect(0, 127, '\p{posixpunct}', "");
    Expect(1, 127, '\p{^posixpunct}', "");
    Expect(1, 127, '\P{posixpunct}', "");
    Expect(0, 127, '\P{^posixpunct}', "");
    Expect(1, 126, '\p{_	posixpunct}', "");
    Expect(0, 126, '\p{^_	posixpunct}', "");
    Expect(0, 126, '\P{_	posixpunct}', "");
    Expect(1, 126, '\P{^_	posixpunct}', "");
    Expect(0, 127, '\p{_	posixpunct}', "");
    Expect(1, 127, '\p{^_	posixpunct}', "");
    Expect(1, 127, '\P{_	posixpunct}', "");
    Expect(0, 127, '\P{^_	posixpunct}', "");
    Error('\p{_:=Is_POSIXPUNCT}');
    Error('\P{_:=Is_POSIXPUNCT}');
    Expect(1, 126, '\p{isposixpunct}', "");
    Expect(0, 126, '\p{^isposixpunct}', "");
    Expect(0, 126, '\P{isposixpunct}', "");
    Expect(1, 126, '\P{^isposixpunct}', "");
    Expect(0, 127, '\p{isposixpunct}', "");
    Expect(1, 127, '\p{^isposixpunct}', "");
    Expect(1, 127, '\P{isposixpunct}', "");
    Expect(0, 127, '\P{^isposixpunct}', "");
    Expect(1, 126, '\p{	-Is_posixpunct}', "");
    Expect(0, 126, '\p{^	-Is_posixpunct}', "");
    Expect(0, 126, '\P{	-Is_posixpunct}', "");
    Expect(1, 126, '\P{^	-Is_posixpunct}', "");
    Expect(0, 127, '\p{	-Is_posixpunct}', "");
    Expect(1, 127, '\p{^	-Is_posixpunct}', "");
    Expect(1, 127, '\P{	-Is_posixpunct}', "");
    Expect(0, 127, '\P{^	-Is_posixpunct}', "");
    Error('\p{- POSIXSPACE/a/}');
    Error('\P{- POSIXSPACE/a/}');
    Expect(1, 32, '\p{posixspace}', "");
    Expect(0, 32, '\p{^posixspace}', "");
    Expect(0, 32, '\P{posixspace}', "");
    Expect(1, 32, '\P{^posixspace}', "");
    Expect(0, 33, '\p{posixspace}', "");
    Expect(1, 33, '\p{^posixspace}', "");
    Expect(1, 33, '\P{posixspace}', "");
    Expect(0, 33, '\P{^posixspace}', "");
    Expect(1, 32, '\p{__POSIXSPACE}', "");
    Expect(0, 32, '\p{^__POSIXSPACE}', "");
    Expect(0, 32, '\P{__POSIXSPACE}', "");
    Expect(1, 32, '\P{^__POSIXSPACE}', "");
    Expect(0, 33, '\p{__POSIXSPACE}', "");
    Expect(1, 33, '\p{^__POSIXSPACE}', "");
    Expect(1, 33, '\P{__POSIXSPACE}', "");
    Expect(0, 33, '\P{^__POSIXSPACE}', "");
    Error('\p{:=	_PerlSpace}');
    Error('\P{:=	_PerlSpace}');
    Expect(1, 32, '\p{perlspace}', "");
    Expect(0, 32, '\p{^perlspace}', "");
    Expect(0, 32, '\P{perlspace}', "");
    Expect(1, 32, '\P{^perlspace}', "");
    Expect(0, 33, '\p{perlspace}', "");
    Expect(1, 33, '\p{^perlspace}', "");
    Expect(1, 33, '\P{perlspace}', "");
    Expect(0, 33, '\P{^perlspace}', "");
    Expect(1, 32, '\p{_	PerlSpace}', "");
    Expect(0, 32, '\p{^_	PerlSpace}', "");
    Expect(0, 32, '\P{_	PerlSpace}', "");
    Expect(1, 32, '\P{^_	PerlSpace}', "");
    Expect(0, 33, '\p{_	PerlSpace}', "");
    Expect(1, 33, '\p{^_	PerlSpace}', "");
    Expect(1, 33, '\P{_	PerlSpace}', "");
    Expect(0, 33, '\P{^_	PerlSpace}', "");
    Error('\p{	 Is_POSIXSPACE/a/}');
    Error('\P{	 Is_POSIXSPACE/a/}');
    Expect(1, 32, '\p{isposixspace}', "");
    Expect(0, 32, '\p{^isposixspace}', "");
    Expect(0, 32, '\P{isposixspace}', "");
    Expect(1, 32, '\P{^isposixspace}', "");
    Expect(0, 33, '\p{isposixspace}', "");
    Expect(1, 33, '\p{^isposixspace}', "");
    Expect(1, 33, '\P{isposixspace}', "");
    Expect(0, 33, '\P{^isposixspace}', "");
    Expect(1, 32, '\p{-IS_PosixSpace}', "");
    Expect(0, 32, '\p{^-IS_PosixSpace}', "");
    Expect(0, 32, '\P{-IS_PosixSpace}', "");
    Expect(1, 32, '\P{^-IS_PosixSpace}', "");
    Expect(0, 33, '\p{-IS_PosixSpace}', "");
    Expect(1, 33, '\p{^-IS_PosixSpace}', "");
    Expect(1, 33, '\P{-IS_PosixSpace}', "");
    Expect(0, 33, '\P{^-IS_PosixSpace}', "");
    Error('\p{/a/_	Is_PerlSpace}');
    Error('\P{/a/_	Is_PerlSpace}');
    Expect(1, 32, '\p{isperlspace}', "");
    Expect(0, 32, '\p{^isperlspace}', "");
    Expect(0, 32, '\P{isperlspace}', "");
    Expect(1, 32, '\P{^isperlspace}', "");
    Expect(0, 33, '\p{isperlspace}', "");
    Expect(1, 33, '\p{^isperlspace}', "");
    Expect(1, 33, '\P{isperlspace}', "");
    Expect(0, 33, '\P{^isperlspace}', "");
    Expect(1, 32, '\p{__Is_perlspace}', "");
    Expect(0, 32, '\p{^__Is_perlspace}', "");
    Expect(0, 32, '\P{__Is_perlspace}', "");
    Expect(1, 32, '\P{^__Is_perlspace}', "");
    Expect(0, 33, '\p{__Is_perlspace}', "");
    Expect(1, 33, '\p{^__Is_perlspace}', "");
    Expect(1, 33, '\P{__Is_perlspace}', "");
    Expect(0, 33, '\P{^__Is_perlspace}', "");
    Error('\p{_:=POSIXUPPER}');
    Error('\P{_:=POSIXUPPER}');
    Expect(1, 90, '\p{posixupper}', "");
    Expect(0, 90, '\p{^posixupper}', "");
    Expect(0, 90, '\P{posixupper}', "");
    Expect(1, 90, '\P{^posixupper}', "");
    Expect(0, 91, '\p{posixupper}', "");
    Expect(1, 91, '\p{^posixupper}', "");
    Expect(1, 91, '\P{posixupper}', "");
    Expect(0, 91, '\P{^posixupper}', "");
    Expect(1, 90, '\p{_-POSIXUPPER}', "");
    Expect(0, 90, '\p{^_-POSIXUPPER}', "");
    Expect(0, 90, '\P{_-POSIXUPPER}', "");
    Expect(1, 90, '\P{^_-POSIXUPPER}', "");
    Expect(0, 91, '\p{_-POSIXUPPER}', "");
    Expect(1, 91, '\p{^_-POSIXUPPER}', "");
    Expect(1, 91, '\P{_-POSIXUPPER}', "");
    Expect(0, 91, '\P{^_-POSIXUPPER}', "");
    Error('\p{:= -IS_POSIXUPPER}');
    Error('\P{:= -IS_POSIXUPPER}');
    Expect(1, 90, '\p{isposixupper}', "");
    Expect(0, 90, '\p{^isposixupper}', "");
    Expect(0, 90, '\P{isposixupper}', "");
    Expect(1, 90, '\P{^isposixupper}', "");
    Expect(0, 91, '\p{isposixupper}', "");
    Expect(1, 91, '\p{^isposixupper}', "");
    Expect(1, 91, '\P{isposixupper}', "");
    Expect(0, 91, '\P{^isposixupper}', "");
    Expect(1, 90, '\p{-Is_posixupper}', "");
    Expect(0, 90, '\p{^-Is_posixupper}', "");
    Expect(0, 90, '\P{-Is_posixupper}', "");
    Expect(1, 90, '\P{^-Is_posixupper}', "");
    Expect(0, 91, '\p{-Is_posixupper}', "");
    Expect(1, 91, '\p{^-Is_posixupper}', "");
    Expect(1, 91, '\P{-Is_posixupper}', "");
    Expect(0, 91, '\P{^-Is_posixupper}', "");
    Error('\p{_PosixWord/a/}');
    Error('\P{_PosixWord/a/}');
    Expect(1, 122, '\p{posixword}', "");
    Expect(0, 122, '\p{^posixword}', "");
    Expect(0, 122, '\P{posixword}', "");
    Expect(1, 122, '\P{^posixword}', "");
    Expect(0, 123, '\p{posixword}', "");
    Expect(1, 123, '\p{^posixword}', "");
    Expect(1, 123, '\P{posixword}', "");
    Expect(0, 123, '\P{^posixword}', "");
    Expect(1, 122, '\p{_ PosixWord}', "");
    Expect(0, 122, '\p{^_ PosixWord}', "");
    Expect(0, 122, '\P{_ PosixWord}', "");
    Expect(1, 122, '\P{^_ PosixWord}', "");
    Expect(0, 123, '\p{_ PosixWord}', "");
    Expect(1, 123, '\p{^_ PosixWord}', "");
    Expect(1, 123, '\P{_ PosixWord}', "");
    Expect(0, 123, '\P{^_ PosixWord}', "");
    Error('\p{  PERLWORD/a/}');
    Error('\P{  PERLWORD/a/}');
    Expect(1, 122, '\p{perlword}', "");
    Expect(0, 122, '\p{^perlword}', "");
    Expect(0, 122, '\P{perlword}', "");
    Expect(1, 122, '\P{^perlword}', "");
    Expect(0, 123, '\p{perlword}', "");
    Expect(1, 123, '\p{^perlword}', "");
    Expect(1, 123, '\P{perlword}', "");
    Expect(0, 123, '\P{^perlword}', "");
    Expect(1, 122, '\p{ -PerlWord}', "");
    Expect(0, 122, '\p{^ -PerlWord}', "");
    Expect(0, 122, '\P{ -PerlWord}', "");
    Expect(1, 122, '\P{^ -PerlWord}', "");
    Expect(0, 123, '\p{ -PerlWord}', "");
    Expect(1, 123, '\p{^ -PerlWord}', "");
    Expect(1, 123, '\P{ -PerlWord}', "");
    Expect(0, 123, '\P{^ -PerlWord}', "");
    Error('\p{/a/	-IS_PosixWord}');
    Error('\P{/a/	-IS_PosixWord}');
    Expect(1, 122, '\p{isposixword}', "");
    Expect(0, 122, '\p{^isposixword}', "");
    Expect(0, 122, '\P{isposixword}', "");
    Expect(1, 122, '\P{^isposixword}', "");
    Expect(0, 123, '\p{isposixword}', "");
    Expect(1, 123, '\p{^isposixword}', "");
    Expect(1, 123, '\P{isposixword}', "");
    Expect(0, 123, '\P{^isposixword}', "");
    Expect(1, 122, '\p{_-Is_PosixWord}', "");
    Expect(0, 122, '\p{^_-Is_PosixWord}', "");
    Expect(0, 122, '\P{_-Is_PosixWord}', "");
    Expect(1, 122, '\P{^_-Is_PosixWord}', "");
    Expect(0, 123, '\p{_-Is_PosixWord}', "");
    Expect(1, 123, '\p{^_-Is_PosixWord}', "");
    Expect(1, 123, '\P{_-Is_PosixWord}', "");
    Expect(0, 123, '\P{^_-Is_PosixWord}', "");
    Error('\p{_/a/Is_PerlWord}');
    Error('\P{_/a/Is_PerlWord}');
    Expect(1, 122, '\p{isperlword}', "");
    Expect(0, 122, '\p{^isperlword}', "");
    Expect(0, 122, '\P{isperlword}', "");
    Expect(1, 122, '\P{^isperlword}', "");
    Expect(0, 123, '\p{isperlword}', "");
    Expect(1, 123, '\p{^isperlword}', "");
    Expect(1, 123, '\P{isperlword}', "");
    Expect(0, 123, '\P{^isperlword}', "");
    Expect(1, 122, '\p{--Is_PerlWord}', "");
    Expect(0, 122, '\p{^--Is_PerlWord}', "");
    Expect(0, 122, '\P{--Is_PerlWord}', "");
    Expect(1, 122, '\P{^--Is_PerlWord}', "");
    Expect(0, 123, '\p{--Is_PerlWord}', "");
    Expect(1, 123, '\p{^--Is_PerlWord}', "");
    Expect(1, 123, '\P{--Is_PerlWord}', "");
    Expect(0, 123, '\P{^--Is_PerlWord}', "");
    Error('\p{ /a/PosixXDigit}');
    Error('\P{ /a/PosixXDigit}');
    Expect(1, 102, '\p{posixxdigit}', "");
    Expect(0, 102, '\p{^posixxdigit}', "");
    Expect(0, 102, '\P{posixxdigit}', "");
    Expect(1, 102, '\P{^posixxdigit}', "");
    Expect(0, 103, '\p{posixxdigit}', "");
    Expect(1, 103, '\p{^posixxdigit}', "");
    Expect(1, 103, '\P{posixxdigit}', "");
    Expect(0, 103, '\P{^posixxdigit}', "");
    Expect(1, 102, '\p{-posixxdigit}', "");
    Expect(0, 102, '\p{^-posixxdigit}', "");
    Expect(0, 102, '\P{-posixxdigit}', "");
    Expect(1, 102, '\P{^-posixxdigit}', "");
    Expect(0, 103, '\p{-posixxdigit}', "");
    Expect(1, 103, '\p{^-posixxdigit}', "");
    Expect(1, 103, '\P{-posixxdigit}', "");
    Expect(0, 103, '\P{^-posixxdigit}', "");
    Error('\p{	:=Is_PosixXDigit}');
    Error('\P{	:=Is_PosixXDigit}');
    Expect(1, 102, '\p{isposixxdigit}', "");
    Expect(0, 102, '\p{^isposixxdigit}', "");
    Expect(0, 102, '\P{isposixxdigit}', "");
    Expect(1, 102, '\P{^isposixxdigit}', "");
    Expect(0, 103, '\p{isposixxdigit}', "");
    Expect(1, 103, '\p{^isposixxdigit}', "");
    Expect(1, 103, '\P{isposixxdigit}', "");
    Expect(0, 103, '\P{^isposixxdigit}', "");
    Expect(1, 102, '\p{__is_posixxdigit}', "");
    Expect(0, 102, '\p{^__is_posixxdigit}', "");
    Expect(0, 102, '\P{__is_posixxdigit}', "");
    Expect(1, 102, '\P{^__is_posixxdigit}', "");
    Expect(0, 103, '\p{__is_posixxdigit}', "");
    Expect(1, 103, '\p{^__is_posixxdigit}', "");
    Expect(1, 103, '\P{__is_posixxdigit}', "");
    Expect(0, 103, '\P{^__is_posixxdigit}', "");
    Error('\p{	:=ascii_hex_DIGIT}');
    Error('\P{	:=ascii_hex_DIGIT}');
    Expect(1, 102, '\p{asciihexdigit}', "");
    Expect(0, 102, '\p{^asciihexdigit}', "");
    Expect(0, 102, '\P{asciihexdigit}', "");
    Expect(1, 102, '\P{^asciihexdigit}', "");
    Expect(0, 103, '\p{asciihexdigit}', "");
    Expect(1, 103, '\p{^asciihexdigit}', "");
    Expect(1, 103, '\P{asciihexdigit}', "");
    Expect(0, 103, '\P{^asciihexdigit}', "");
    Expect(1, 102, '\p{_ ASCII_hex_Digit}', "");
    Expect(0, 102, '\p{^_ ASCII_hex_Digit}', "");
    Expect(0, 102, '\P{_ ASCII_hex_Digit}', "");
    Expect(1, 102, '\P{^_ ASCII_hex_Digit}', "");
    Expect(0, 103, '\p{_ ASCII_hex_Digit}', "");
    Expect(1, 103, '\p{^_ ASCII_hex_Digit}', "");
    Expect(1, 103, '\P{_ ASCII_hex_Digit}', "");
    Expect(0, 103, '\P{^_ ASCII_hex_Digit}', "");
    Error('\p{_:=Is_ascii_HEX_Digit}');
    Error('\P{_:=Is_ascii_HEX_Digit}');
    Expect(1, 102, '\p{isasciihexdigit}', "");
    Expect(0, 102, '\p{^isasciihexdigit}', "");
    Expect(0, 102, '\P{isasciihexdigit}', "");
    Expect(1, 102, '\P{^isasciihexdigit}', "");
    Expect(0, 103, '\p{isasciihexdigit}', "");
    Expect(1, 103, '\p{^isasciihexdigit}', "");
    Expect(1, 103, '\P{isasciihexdigit}', "");
    Expect(0, 103, '\P{^isasciihexdigit}', "");
    Expect(1, 102, '\p{  Is_ASCII_HEX_Digit}', "");
    Expect(0, 102, '\p{^  Is_ASCII_HEX_Digit}', "");
    Expect(0, 102, '\P{  Is_ASCII_HEX_Digit}', "");
    Expect(1, 102, '\P{^  Is_ASCII_HEX_Digit}', "");
    Expect(0, 103, '\p{  Is_ASCII_HEX_Digit}', "");
    Expect(1, 103, '\p{^  Is_ASCII_HEX_Digit}', "");
    Expect(1, 103, '\P{  Is_ASCII_HEX_Digit}', "");
    Expect(0, 103, '\P{^  Is_ASCII_HEX_Digit}', "");
    Error('\p{__AHex/a/}');
    Error('\P{__AHex/a/}');
    Expect(1, 102, '\p{ahex}', "");
    Expect(0, 102, '\p{^ahex}', "");
    Expect(0, 102, '\P{ahex}', "");
    Expect(1, 102, '\P{^ahex}', "");
    Expect(0, 103, '\p{ahex}', "");
    Expect(1, 103, '\p{^ahex}', "");
    Expect(1, 103, '\P{ahex}', "");
    Expect(0, 103, '\P{^ahex}', "");
    Expect(1, 102, '\p{- AHex}', "");
    Expect(0, 102, '\p{^- AHex}', "");
    Expect(0, 102, '\P{- AHex}', "");
    Expect(1, 102, '\P{^- AHex}', "");
    Expect(0, 103, '\p{- AHex}', "");
    Expect(1, 103, '\p{^- AHex}', "");
    Expect(1, 103, '\P{- AHex}', "");
    Expect(0, 103, '\P{^- AHex}', "");
    Error('\p{	:=Is_ahex}');
    Error('\P{	:=Is_ahex}');
    Expect(1, 102, '\p{isahex}', "");
    Expect(0, 102, '\p{^isahex}', "");
    Expect(0, 102, '\P{isahex}', "");
    Expect(1, 102, '\P{^isahex}', "");
    Expect(0, 103, '\p{isahex}', "");
    Expect(1, 103, '\p{^isahex}', "");
    Expect(1, 103, '\P{isahex}', "");
    Expect(0, 103, '\P{^isahex}', "");
    Expect(1, 102, '\p{	Is_AHex}', "");
    Expect(0, 102, '\p{^	Is_AHex}', "");
    Expect(0, 102, '\P{	Is_AHex}', "");
    Expect(1, 102, '\P{^	Is_AHex}', "");
    Expect(0, 103, '\p{	Is_AHex}', "");
    Expect(1, 103, '\p{^	Is_AHex}', "");
    Expect(1, 103, '\P{	Is_AHex}', "");
    Expect(0, 103, '\P{^	Is_AHex}', "");
    Error('\p{:=	 PREPENDED_Concatenation_Mark}');
    Error('\P{:=	 PREPENDED_Concatenation_Mark}');
    Expect(1, 69837, '\p{prependedconcatenationmark}', "");
    Expect(0, 69837, '\p{^prependedconcatenationmark}', "");
    Expect(0, 69837, '\P{prependedconcatenationmark}', "");
    Expect(1, 69837, '\P{^prependedconcatenationmark}', "");
    Expect(0, 69838, '\p{prependedconcatenationmark}', "");
    Expect(1, 69838, '\p{^prependedconcatenationmark}', "");
    Expect(1, 69838, '\P{prependedconcatenationmark}', "");
    Expect(0, 69838, '\P{^prependedconcatenationmark}', "");
    Expect(1, 69837, '\p{_PREPENDED_concatenation_Mark}', "");
    Expect(0, 69837, '\p{^_PREPENDED_concatenation_Mark}', "");
    Expect(0, 69837, '\P{_PREPENDED_concatenation_Mark}', "");
    Expect(1, 69837, '\P{^_PREPENDED_concatenation_Mark}', "");
    Expect(0, 69838, '\p{_PREPENDED_concatenation_Mark}', "");
    Expect(1, 69838, '\p{^_PREPENDED_concatenation_Mark}', "");
    Expect(1, 69838, '\P{_PREPENDED_concatenation_Mark}', "");
    Expect(0, 69838, '\P{^_PREPENDED_concatenation_Mark}', "");
    Error('\p{:=  Is_Prepended_CONCATENATION_Mark}');
    Error('\P{:=  Is_Prepended_CONCATENATION_Mark}');
    Expect(1, 69837, '\p{isprependedconcatenationmark}', "");
    Expect(0, 69837, '\p{^isprependedconcatenationmark}', "");
    Expect(0, 69837, '\P{isprependedconcatenationmark}', "");
    Expect(1, 69837, '\P{^isprependedconcatenationmark}', "");
    Expect(0, 69838, '\p{isprependedconcatenationmark}', "");
    Expect(1, 69838, '\p{^isprependedconcatenationmark}', "");
    Expect(1, 69838, '\P{isprependedconcatenationmark}', "");
    Expect(0, 69838, '\P{^isprependedconcatenationmark}', "");
    Expect(1, 69837, '\p{ 	Is_Prepended_Concatenation_Mark}', "");
    Expect(0, 69837, '\p{^ 	Is_Prepended_Concatenation_Mark}', "");
    Expect(0, 69837, '\P{ 	Is_Prepended_Concatenation_Mark}', "");
    Expect(1, 69837, '\P{^ 	Is_Prepended_Concatenation_Mark}', "");
    Expect(0, 69838, '\p{ 	Is_Prepended_Concatenation_Mark}', "");
    Expect(1, 69838, '\p{^ 	Is_Prepended_Concatenation_Mark}', "");
    Expect(1, 69838, '\P{ 	Is_Prepended_Concatenation_Mark}', "");
    Expect(0, 69838, '\P{^ 	Is_Prepended_Concatenation_Mark}', "");
    Error('\p{	/a/pcm}');
    Error('\P{	/a/pcm}');
    Expect(1, 69837, '\p{pcm}', "");
    Expect(0, 69837, '\p{^pcm}', "");
    Expect(0, 69837, '\P{pcm}', "");
    Expect(1, 69837, '\P{^pcm}', "");
    Expect(0, 69838, '\p{pcm}', "");
    Expect(1, 69838, '\p{^pcm}', "");
    Expect(1, 69838, '\P{pcm}', "");
    Expect(0, 69838, '\P{^pcm}', "");
    Expect(1, 69837, '\p{	-PCM}', "");
    Expect(0, 69837, '\p{^	-PCM}', "");
    Expect(0, 69837, '\P{	-PCM}', "");
    Expect(1, 69837, '\P{^	-PCM}', "");
    Expect(0, 69838, '\p{	-PCM}', "");
    Expect(1, 69838, '\p{^	-PCM}', "");
    Expect(1, 69838, '\P{	-PCM}', "");
    Expect(0, 69838, '\P{^	-PCM}', "");
    Error('\p{ _IS_PCM/a/}');
    Error('\P{ _IS_PCM/a/}');
    Expect(1, 69837, '\p{ispcm}', "");
    Expect(0, 69837, '\p{^ispcm}', "");
    Expect(0, 69837, '\P{ispcm}', "");
    Expect(1, 69837, '\P{^ispcm}', "");
    Expect(0, 69838, '\p{ispcm}', "");
    Expect(1, 69838, '\p{^ispcm}', "");
    Expect(1, 69838, '\P{ispcm}', "");
    Expect(0, 69838, '\P{^ispcm}', "");
    Expect(1, 69837, '\p{-is_PCM}', "");
    Expect(0, 69837, '\p{^-is_PCM}', "");
    Expect(0, 69837, '\P{-is_PCM}', "");
    Expect(1, 69837, '\P{^-is_PCM}', "");
    Expect(0, 69838, '\p{-is_PCM}', "");
    Expect(1, 69838, '\p{^-is_PCM}', "");
    Expect(1, 69838, '\P{-is_PCM}', "");
    Expect(0, 69838, '\P{^-is_PCM}', "");
    Error('\p{ :=XPosixPrint}');
    Error('\P{ :=XPosixPrint}');
    Expect(1, 1114109, '\p{xposixprint}', "");
    Expect(0, 1114109, '\p{^xposixprint}', "");
    Expect(0, 1114109, '\P{xposixprint}', "");
    Expect(1, 1114109, '\P{^xposixprint}', "");
    Expect(0, 918000, '\p{xposixprint}', "");
    Expect(1, 918000, '\p{^xposixprint}', "");
    Expect(1, 918000, '\P{xposixprint}', "");
    Expect(0, 918000, '\P{^xposixprint}', "");
    Expect(1, 1114109, '\p{-_xposixprint}', "");
    Expect(0, 1114109, '\p{^-_xposixprint}', "");
    Expect(0, 1114109, '\P{-_xposixprint}', "");
    Expect(1, 1114109, '\P{^-_xposixprint}', "");
    Expect(0, 918000, '\p{-_xposixprint}', "");
    Expect(1, 918000, '\p{^-_xposixprint}', "");
    Expect(1, 918000, '\P{-_xposixprint}', "");
    Expect(0, 918000, '\P{^-_xposixprint}', "");
    Error('\p{/a/ Print}');
    Error('\P{/a/ Print}');
    Expect(1, 1114109, '\p{print}', "");
    Expect(0, 1114109, '\p{^print}', "");
    Expect(0, 1114109, '\P{print}', "");
    Expect(1, 1114109, '\P{^print}', "");
    Expect(0, 918000, '\p{print}', "");
    Expect(1, 918000, '\p{^print}', "");
    Expect(1, 918000, '\P{print}', "");
    Expect(0, 918000, '\P{^print}', "");
    Expect(1, 1114109, '\p{	 PRINT}', "");
    Expect(0, 1114109, '\p{^	 PRINT}', "");
    Expect(0, 1114109, '\P{	 PRINT}', "");
    Expect(1, 1114109, '\P{^	 PRINT}', "");
    Expect(0, 918000, '\p{	 PRINT}', "");
    Expect(1, 918000, '\p{^	 PRINT}', "");
    Expect(1, 918000, '\P{	 PRINT}', "");
    Expect(0, 918000, '\P{^	 PRINT}', "");
    Error('\p{	-is_XPosixPrint/a/}');
    Error('\P{	-is_XPosixPrint/a/}');
    Expect(1, 1114109, '\p{isxposixprint}', "");
    Expect(0, 1114109, '\p{^isxposixprint}', "");
    Expect(0, 1114109, '\P{isxposixprint}', "");
    Expect(1, 1114109, '\P{^isxposixprint}', "");
    Expect(0, 918000, '\p{isxposixprint}', "");
    Expect(1, 918000, '\p{^isxposixprint}', "");
    Expect(1, 918000, '\P{isxposixprint}', "");
    Expect(0, 918000, '\P{^isxposixprint}', "");
    Expect(1, 1114109, '\p{ Is_XPosixPrint}', "");
    Expect(0, 1114109, '\p{^ Is_XPosixPrint}', "");
    Expect(0, 1114109, '\P{ Is_XPosixPrint}', "");
    Expect(1, 1114109, '\P{^ Is_XPosixPrint}', "");
    Expect(0, 918000, '\p{ Is_XPosixPrint}', "");
    Expect(1, 918000, '\p{^ Is_XPosixPrint}', "");
    Expect(1, 918000, '\P{ Is_XPosixPrint}', "");
    Expect(0, 918000, '\P{^ Is_XPosixPrint}', "");
    Error('\p{/a/  is_print}');
    Error('\P{/a/  is_print}');
    Expect(1, 1114109, '\p{isprint}', "");
    Expect(0, 1114109, '\p{^isprint}', "");
    Expect(0, 1114109, '\P{isprint}', "");
    Expect(1, 1114109, '\P{^isprint}', "");
    Expect(0, 918000, '\p{isprint}', "");
    Expect(1, 918000, '\p{^isprint}', "");
    Expect(1, 918000, '\P{isprint}', "");
    Expect(0, 918000, '\P{^isprint}', "");
    Expect(1, 1114109, '\p{	-IS_Print}', "");
    Expect(0, 1114109, '\p{^	-IS_Print}', "");
    Expect(0, 1114109, '\P{	-IS_Print}', "");
    Expect(1, 1114109, '\P{^	-IS_Print}', "");
    Expect(0, 918000, '\p{	-IS_Print}', "");
    Expect(1, 918000, '\p{^	-IS_Print}', "");
    Expect(1, 918000, '\P{	-IS_Print}', "");
    Expect(0, 918000, '\P{^	-IS_Print}', "");
    Error('\p{	:=Private_USE}');
    Error('\P{	:=Private_USE}');
    Expect(1, 1114109, '\p{privateuse}', "");
    Expect(0, 1114109, '\p{^privateuse}', "");
    Expect(0, 1114109, '\P{privateuse}', "");
    Expect(1, 1114109, '\P{^privateuse}', "");
    Expect(0, 63744, '\p{privateuse}', "");
    Expect(1, 63744, '\p{^privateuse}', "");
    Expect(1, 63744, '\P{privateuse}', "");
    Expect(0, 63744, '\P{^privateuse}', "");
    Expect(1, 1114109, '\p{ 	Private_Use}', "");
    Expect(0, 1114109, '\p{^ 	Private_Use}', "");
    Expect(0, 1114109, '\P{ 	Private_Use}', "");
    Expect(1, 1114109, '\P{^ 	Private_Use}', "");
    Expect(0, 63744, '\p{ 	Private_Use}', "");
    Expect(1, 63744, '\p{^ 	Private_Use}', "");
    Expect(1, 63744, '\P{ 	Private_Use}', "");
    Expect(0, 63744, '\P{^ 	Private_Use}', "");
    Error('\p{:=--Is_private_use}');
    Error('\P{:=--Is_private_use}');
    Expect(1, 1114109, '\p{isprivateuse}', "");
    Expect(0, 1114109, '\p{^isprivateuse}', "");
    Expect(0, 1114109, '\P{isprivateuse}', "");
    Expect(1, 1114109, '\P{^isprivateuse}', "");
    Expect(0, 63744, '\p{isprivateuse}', "");
    Expect(1, 63744, '\p{^isprivateuse}', "");
    Expect(1, 63744, '\P{isprivateuse}', "");
    Expect(0, 63744, '\P{^isprivateuse}', "");
    Expect(1, 1114109, '\p{_	Is_Private_use}', "");
    Expect(0, 1114109, '\p{^_	Is_Private_use}', "");
    Expect(0, 1114109, '\P{_	Is_Private_use}', "");
    Expect(1, 1114109, '\P{^_	Is_Private_use}', "");
    Expect(0, 63744, '\p{_	Is_Private_use}', "");
    Expect(1, 63744, '\p{^_	Is_Private_use}', "");
    Expect(1, 63744, '\P{_	Is_Private_use}', "");
    Expect(0, 63744, '\P{^_	Is_Private_use}', "");
    Error('\p{:=  Co}');
    Error('\P{:=  Co}');
    Expect(1, 1114109, '\p{co}', "");
    Expect(0, 1114109, '\p{^co}', "");
    Expect(0, 1114109, '\P{co}', "");
    Expect(1, 1114109, '\P{^co}', "");
    Expect(0, 63744, '\p{co}', "");
    Expect(1, 63744, '\p{^co}', "");
    Expect(1, 63744, '\P{co}', "");
    Expect(0, 63744, '\P{^co}', "");
    Expect(1, 1114109, '\p{	 Co}', "");
    Expect(0, 1114109, '\p{^	 Co}', "");
    Expect(0, 1114109, '\P{	 Co}', "");
    Expect(1, 1114109, '\P{^	 Co}', "");
    Expect(0, 63744, '\p{	 Co}', "");
    Expect(1, 63744, '\p{^	 Co}', "");
    Expect(1, 63744, '\P{	 Co}', "");
    Expect(0, 63744, '\P{^	 Co}', "");
    Error('\p{ 	Is_Co/a/}');
    Error('\P{ 	Is_Co/a/}');
    Expect(1, 1114109, '\p{isco}', "");
    Expect(0, 1114109, '\p{^isco}', "");
    Expect(0, 1114109, '\P{isco}', "");
    Expect(1, 1114109, '\P{^isco}', "");
    Expect(0, 63744, '\p{isco}', "");
    Expect(1, 63744, '\p{^isco}', "");
    Expect(1, 63744, '\P{isco}', "");
    Expect(0, 63744, '\P{^isco}', "");
    Expect(1, 1114109, '\p{__IS_co}', "");
    Expect(0, 1114109, '\p{^__IS_co}', "");
    Expect(0, 1114109, '\P{__IS_co}', "");
    Expect(1, 1114109, '\P{^__IS_co}', "");
    Expect(0, 63744, '\p{__IS_co}', "");
    Expect(1, 63744, '\p{^__IS_co}', "");
    Expect(1, 63744, '\P{__IS_co}', "");
    Expect(0, 63744, '\P{^__IS_co}', "");
    Error('\p{:=-PRIVATE_USE_area}');
    Error('\P{:=-PRIVATE_USE_area}');
    Expect(1, 63743, '\p{privateusearea}', "");
    Expect(0, 63743, '\p{^privateusearea}', "");
    Expect(0, 63743, '\P{privateusearea}', "");
    Expect(1, 63743, '\P{^privateusearea}', "");
    Expect(0, 63744, '\p{privateusearea}', "");
    Expect(1, 63744, '\p{^privateusearea}', "");
    Expect(1, 63744, '\P{privateusearea}', "");
    Expect(0, 63744, '\P{^privateusearea}', "");
    Expect(1, 63743, '\p{ Private_USE_Area}', "");
    Expect(0, 63743, '\p{^ Private_USE_Area}', "");
    Expect(0, 63743, '\P{ Private_USE_Area}', "");
    Expect(1, 63743, '\P{^ Private_USE_Area}', "");
    Expect(0, 63744, '\p{ Private_USE_Area}', "");
    Expect(1, 63744, '\p{^ Private_USE_Area}', "");
    Expect(1, 63744, '\P{ Private_USE_Area}', "");
    Expect(0, 63744, '\P{^ Private_USE_Area}', "");
    Error('\p{/a/IS_private_use_AREA}');
    Error('\P{/a/IS_private_use_AREA}');
    Expect(1, 63743, '\p{isprivateusearea}', "");
    Expect(0, 63743, '\p{^isprivateusearea}', "");
    Expect(0, 63743, '\P{isprivateusearea}', "");
    Expect(1, 63743, '\P{^isprivateusearea}', "");
    Expect(0, 63744, '\p{isprivateusearea}', "");
    Expect(1, 63744, '\p{^isprivateusearea}', "");
    Expect(1, 63744, '\P{isprivateusearea}', "");
    Expect(0, 63744, '\P{^isprivateusearea}', "");
    Expect(1, 63743, '\p{ is_Private_USE_Area}', "");
    Expect(0, 63743, '\p{^ is_Private_USE_Area}', "");
    Expect(0, 63743, '\P{ is_Private_USE_Area}', "");
    Expect(1, 63743, '\P{^ is_Private_USE_Area}', "");
    Expect(0, 63744, '\p{ is_Private_USE_Area}', "");
    Expect(1, 63744, '\p{^ is_Private_USE_Area}', "");
    Expect(1, 63744, '\P{ is_Private_USE_Area}', "");
    Expect(0, 63744, '\P{^ is_Private_USE_Area}', "");
    Error('\p{:=_In_private_Use_AREA}');
    Error('\P{:=_In_private_Use_AREA}');
    Expect(1, 63743, '\p{inprivateusearea}', "");
    Expect(0, 63743, '\p{^inprivateusearea}', "");
    Expect(0, 63743, '\P{inprivateusearea}', "");
    Expect(1, 63743, '\P{^inprivateusearea}', "");
    Expect(0, 63744, '\p{inprivateusearea}', "");
    Expect(1, 63744, '\p{^inprivateusearea}', "");
    Expect(1, 63744, '\P{inprivateusearea}', "");
    Expect(0, 63744, '\P{^inprivateusearea}', "");
    Expect(1, 63743, '\p{--In_private_use_AREA}', "");
    Expect(0, 63743, '\p{^--In_private_use_AREA}', "");
    Expect(0, 63743, '\P{--In_private_use_AREA}', "");
    Expect(1, 63743, '\P{^--In_private_use_AREA}', "");
    Expect(0, 63744, '\p{--In_private_use_AREA}', "");
    Expect(1, 63744, '\p{^--In_private_use_AREA}', "");
    Expect(1, 63744, '\P{--In_private_use_AREA}', "");
    Expect(0, 63744, '\P{^--In_private_use_AREA}', "");
    Error('\p{/a/-	PUA}');
    Error('\P{/a/-	PUA}');
    Expect(1, 63743, '\p{pua}', "");
    Expect(0, 63743, '\p{^pua}', "");
    Expect(0, 63743, '\P{pua}', "");
    Expect(1, 63743, '\P{^pua}', "");
    Expect(0, 63744, '\p{pua}', "");
    Expect(1, 63744, '\p{^pua}', "");
    Expect(1, 63744, '\P{pua}', "");
    Expect(0, 63744, '\P{^pua}', "");
    Expect(1, 63743, '\p{	 PUA}', "");
    Expect(0, 63743, '\p{^	 PUA}', "");
    Expect(0, 63743, '\P{	 PUA}', "");
    Expect(1, 63743, '\P{^	 PUA}', "");
    Expect(0, 63744, '\p{	 PUA}', "");
    Expect(1, 63744, '\p{^	 PUA}', "");
    Expect(1, 63744, '\P{	 PUA}', "");
    Expect(0, 63744, '\P{^	 PUA}', "");
    Error('\p{/a/ Is_PUA}');
    Error('\P{/a/ Is_PUA}');
    Expect(1, 63743, '\p{ispua}', "");
    Expect(0, 63743, '\p{^ispua}', "");
    Expect(0, 63743, '\P{ispua}', "");
    Expect(1, 63743, '\P{^ispua}', "");
    Expect(0, 63744, '\p{ispua}', "");
    Expect(1, 63744, '\p{^ispua}', "");
    Expect(1, 63744, '\P{ispua}', "");
    Expect(0, 63744, '\P{^ispua}', "");
    Expect(1, 63743, '\p{--Is_pua}', "");
    Expect(0, 63743, '\p{^--Is_pua}', "");
    Expect(0, 63743, '\P{--Is_pua}', "");
    Expect(1, 63743, '\P{^--Is_pua}', "");
    Expect(0, 63744, '\p{--Is_pua}', "");
    Expect(1, 63744, '\p{^--Is_pua}', "");
    Expect(1, 63744, '\P{--Is_pua}', "");
    Expect(0, 63744, '\P{^--Is_pua}', "");
    Error('\p{:= In_PUA}');
    Error('\P{:= In_PUA}');
    Expect(1, 63743, '\p{inpua}', "");
    Expect(0, 63743, '\p{^inpua}', "");
    Expect(0, 63743, '\P{inpua}', "");
    Expect(1, 63743, '\P{^inpua}', "");
    Expect(0, 63744, '\p{inpua}', "");
    Expect(1, 63744, '\p{^inpua}', "");
    Expect(1, 63744, '\P{inpua}', "");
    Expect(0, 63744, '\P{^inpua}', "");
    Expect(1, 63743, '\p{-	In_PUA}', "");
    Expect(0, 63743, '\p{^-	In_PUA}', "");
    Expect(0, 63743, '\P{-	In_PUA}', "");
    Expect(1, 63743, '\P{^-	In_PUA}', "");
    Expect(0, 63744, '\p{-	In_PUA}', "");
    Expect(1, 63744, '\p{^-	In_PUA}', "");
    Expect(1, 63744, '\P{-	In_PUA}', "");
    Expect(0, 63744, '\P{^-	In_PUA}', "");
    Error('\p{	:=in_PRIVATE_use}');
    Error('\P{	:=in_PRIVATE_use}');
    Expect(1, 63743, '\p{inprivateuse}', "");
    Expect(0, 63743, '\p{^inprivateuse}', "");
    Expect(0, 63743, '\P{inprivateuse}', "");
    Expect(1, 63743, '\P{^inprivateuse}', "");
    Expect(0, 63744, '\p{inprivateuse}', "");
    Expect(1, 63744, '\p{^inprivateuse}', "");
    Expect(1, 63744, '\P{inprivateuse}', "");
    Expect(0, 63744, '\P{^inprivateuse}', "");
    Expect(1, 63743, '\p{	-IN_Private_use}', "");
    Expect(0, 63743, '\p{^	-IN_Private_use}', "");
    Expect(0, 63743, '\P{	-IN_Private_use}', "");
    Expect(1, 63743, '\P{^	-IN_Private_use}', "");
    Expect(0, 63744, '\p{	-IN_Private_use}', "");
    Expect(1, 63744, '\p{^	-IN_Private_use}', "");
    Expect(1, 63744, '\P{	-IN_Private_use}', "");
    Expect(0, 63744, '\P{^	-IN_Private_use}', "");
    Error('\p{:= _Psalter_Pahlavi}');
    Error('\P{:= _Psalter_Pahlavi}');
    Expect(1, 68527, '\p{psalterpahlavi}', "");
    Expect(0, 68527, '\p{^psalterpahlavi}', "");
    Expect(0, 68527, '\P{psalterpahlavi}', "");
    Expect(1, 68527, '\P{^psalterpahlavi}', "");
    Expect(0, 68528, '\p{psalterpahlavi}', "");
    Expect(1, 68528, '\p{^psalterpahlavi}', "");
    Expect(1, 68528, '\P{psalterpahlavi}', "");
    Expect(0, 68528, '\P{^psalterpahlavi}', "");
    Expect(1, 68527, '\p{_Psalter_PAHLAVI}', "");
    Expect(0, 68527, '\p{^_Psalter_PAHLAVI}', "");
    Expect(0, 68527, '\P{_Psalter_PAHLAVI}', "");
    Expect(1, 68527, '\P{^_Psalter_PAHLAVI}', "");
    Expect(0, 68528, '\p{_Psalter_PAHLAVI}', "");
    Expect(1, 68528, '\p{^_Psalter_PAHLAVI}', "");
    Expect(1, 68528, '\P{_Psalter_PAHLAVI}', "");
    Expect(0, 68528, '\P{^_Psalter_PAHLAVI}', "");
    Error('\p{_Is_Psalter_Pahlavi/a/}');
    Error('\P{_Is_Psalter_Pahlavi/a/}');
    Expect(1, 68527, '\p{ispsalterpahlavi}', "");
    Expect(0, 68527, '\p{^ispsalterpahlavi}', "");
    Expect(0, 68527, '\P{ispsalterpahlavi}', "");
    Expect(1, 68527, '\P{^ispsalterpahlavi}', "");
    Expect(0, 68528, '\p{ispsalterpahlavi}', "");
    Expect(1, 68528, '\p{^ispsalterpahlavi}', "");
    Expect(1, 68528, '\P{ispsalterpahlavi}', "");
    Expect(0, 68528, '\P{^ispsalterpahlavi}', "");
    Expect(1, 68527, '\p{	-Is_PSALTER_pahlavi}', "");
    Expect(0, 68527, '\p{^	-Is_PSALTER_pahlavi}', "");
    Expect(0, 68527, '\P{	-Is_PSALTER_pahlavi}', "");
    Expect(1, 68527, '\P{^	-Is_PSALTER_pahlavi}', "");
    Expect(0, 68528, '\p{	-Is_PSALTER_pahlavi}', "");
    Expect(1, 68528, '\p{^	-Is_PSALTER_pahlavi}', "");
    Expect(1, 68528, '\P{	-Is_PSALTER_pahlavi}', "");
    Expect(0, 68528, '\P{^	-Is_PSALTER_pahlavi}', "");
    Error('\p{	_phlp/a/}');
    Error('\P{	_phlp/a/}');
    Expect(1, 68527, '\p{phlp}', "");
    Expect(0, 68527, '\p{^phlp}', "");
    Expect(0, 68527, '\P{phlp}', "");
    Expect(1, 68527, '\P{^phlp}', "");
    Expect(0, 68528, '\p{phlp}', "");
    Expect(1, 68528, '\p{^phlp}', "");
    Expect(1, 68528, '\P{phlp}', "");
    Expect(0, 68528, '\P{^phlp}', "");
    Expect(1, 68527, '\p{_Phlp}', "");
    Expect(0, 68527, '\p{^_Phlp}', "");
    Expect(0, 68527, '\P{_Phlp}', "");
    Expect(1, 68527, '\P{^_Phlp}', "");
    Expect(0, 68528, '\p{_Phlp}', "");
    Expect(1, 68528, '\p{^_Phlp}', "");
    Expect(1, 68528, '\P{_Phlp}', "");
    Expect(0, 68528, '\P{^_Phlp}', "");
    Error('\p{:=-is_Phlp}');
    Error('\P{:=-is_Phlp}');
    Expect(1, 68527, '\p{isphlp}', "");
    Expect(0, 68527, '\p{^isphlp}', "");
    Expect(0, 68527, '\P{isphlp}', "");
    Expect(1, 68527, '\P{^isphlp}', "");
    Expect(0, 68528, '\p{isphlp}', "");
    Expect(1, 68528, '\p{^isphlp}', "");
    Expect(1, 68528, '\P{isphlp}', "");
    Expect(0, 68528, '\P{^isphlp}', "");
    Expect(1, 68527, '\p{ Is_Phlp}', "");
    Expect(0, 68527, '\p{^ Is_Phlp}', "");
    Expect(0, 68527, '\P{ Is_Phlp}', "");
    Expect(1, 68527, '\P{^ Is_Phlp}', "");
    Expect(0, 68528, '\p{ Is_Phlp}', "");
    Expect(1, 68528, '\p{^ Is_Phlp}', "");
    Expect(1, 68528, '\P{ Is_Phlp}', "");
    Expect(0, 68528, '\P{^ Is_Phlp}', "");
    Error('\p{/a/_-punct}');
    Error('\P{/a/_-punct}');
    Expect(1, 125279, '\p{punct}', "");
    Expect(0, 125279, '\p{^punct}', "");
    Expect(0, 125279, '\P{punct}', "");
    Expect(1, 125279, '\P{^punct}', "");
    Expect(0, 125280, '\p{punct}', "");
    Expect(1, 125280, '\p{^punct}', "");
    Expect(1, 125280, '\P{punct}', "");
    Expect(0, 125280, '\P{^punct}', "");
    Expect(1, 125279, '\p{		punct}', "");
    Expect(0, 125279, '\p{^		punct}', "");
    Expect(0, 125279, '\P{		punct}', "");
    Expect(1, 125279, '\P{^		punct}', "");
    Expect(0, 125280, '\p{		punct}', "");
    Expect(1, 125280, '\p{^		punct}', "");
    Expect(1, 125280, '\P{		punct}', "");
    Expect(0, 125280, '\P{^		punct}', "");
    Error('\p{_/a/Is_Punct}');
    Error('\P{_/a/Is_Punct}');
    Expect(1, 125279, '\p{ispunct}', "");
    Expect(0, 125279, '\p{^ispunct}', "");
    Expect(0, 125279, '\P{ispunct}', "");
    Expect(1, 125279, '\P{^ispunct}', "");
    Expect(0, 125280, '\p{ispunct}', "");
    Expect(1, 125280, '\p{^ispunct}', "");
    Expect(1, 125280, '\P{ispunct}', "");
    Expect(0, 125280, '\P{^ispunct}', "");
    Expect(1, 125279, '\p{_	is_PUNCT}', "");
    Expect(0, 125279, '\p{^_	is_PUNCT}', "");
    Expect(0, 125279, '\P{_	is_PUNCT}', "");
    Expect(1, 125279, '\P{^_	is_PUNCT}', "");
    Expect(0, 125280, '\p{_	is_PUNCT}', "");
    Expect(1, 125280, '\p{^_	is_PUNCT}', "");
    Expect(1, 125280, '\P{_	is_PUNCT}', "");
    Expect(0, 125280, '\P{^_	is_PUNCT}', "");
    Error('\p{_-Punctuation/a/}');
    Error('\P{_-Punctuation/a/}');
    Expect(1, 125279, '\p{punctuation}', "");
    Expect(0, 125279, '\p{^punctuation}', "");
    Expect(0, 125279, '\P{punctuation}', "");
    Expect(1, 125279, '\P{^punctuation}', "");
    Expect(0, 125280, '\p{punctuation}', "");
    Expect(1, 125280, '\p{^punctuation}', "");
    Expect(1, 125280, '\P{punctuation}', "");
    Expect(0, 125280, '\P{^punctuation}', "");
    Expect(1, 125279, '\p{	-PUNCTUATION}', "");
    Expect(0, 125279, '\p{^	-PUNCTUATION}', "");
    Expect(0, 125279, '\P{	-PUNCTUATION}', "");
    Expect(1, 125279, '\P{^	-PUNCTUATION}', "");
    Expect(0, 125280, '\p{	-PUNCTUATION}', "");
    Expect(1, 125280, '\p{^	-PUNCTUATION}', "");
    Expect(1, 125280, '\P{	-PUNCTUATION}', "");
    Expect(0, 125280, '\P{^	-PUNCTUATION}', "");
    Error('\p{	:=is_Punctuation}');
    Error('\P{	:=is_Punctuation}');
    Expect(1, 125279, '\p{ispunctuation}', "");
    Expect(0, 125279, '\p{^ispunctuation}', "");
    Expect(0, 125279, '\P{ispunctuation}', "");
    Expect(1, 125279, '\P{^ispunctuation}', "");
    Expect(0, 125280, '\p{ispunctuation}', "");
    Expect(1, 125280, '\p{^ispunctuation}', "");
    Expect(1, 125280, '\P{ispunctuation}', "");
    Expect(0, 125280, '\P{^ispunctuation}', "");
    Expect(1, 125279, '\p{  Is_Punctuation}', "");
    Expect(0, 125279, '\p{^  Is_Punctuation}', "");
    Expect(0, 125279, '\P{  Is_Punctuation}', "");
    Expect(1, 125279, '\P{^  Is_Punctuation}', "");
    Expect(0, 125280, '\p{  Is_Punctuation}', "");
    Expect(1, 125280, '\p{^  Is_Punctuation}', "");
    Expect(1, 125280, '\P{  Is_Punctuation}', "");
    Expect(0, 125280, '\P{^  Is_Punctuation}', "");
    Error('\p{-P/a/}');
    Error('\P{-P/a/}');
    Expect(1, 125279, '\p{p}', "");
    Expect(0, 125279, '\p{^p}', "");
    Expect(0, 125279, '\P{p}', "");
    Expect(1, 125279, '\P{^p}', "");
    Expect(0, 125280, '\p{p}', "");
    Expect(1, 125280, '\p{^p}', "");
    Expect(1, 125280, '\P{p}', "");
    Expect(0, 125280, '\P{^p}', "");
    Expect(1, 125279, '\p{-p}', "");
    Expect(0, 125279, '\p{^-p}', "");
    Expect(0, 125279, '\P{-p}', "");
    Expect(1, 125279, '\P{^-p}', "");
    Expect(0, 125280, '\p{-p}', "");
    Expect(1, 125280, '\p{^-p}', "");
    Expect(1, 125280, '\P{-p}', "");
    Expect(0, 125280, '\P{^-p}', "");
    Error('\p{:=	Is_P}');
    Error('\P{:=	Is_P}');
    Expect(1, 125279, '\p{isp}', "");
    Expect(0, 125279, '\p{^isp}', "");
    Expect(0, 125279, '\P{isp}', "");
    Expect(1, 125279, '\P{^isp}', "");
    Expect(0, 125280, '\p{isp}', "");
    Expect(1, 125280, '\p{^isp}', "");
    Expect(1, 125280, '\P{isp}', "");
    Expect(0, 125280, '\P{^isp}', "");
    Expect(1, 125279, '\p{_	Is_P}', "");
    Expect(0, 125279, '\p{^_	Is_P}', "");
    Expect(0, 125279, '\P{_	Is_P}', "");
    Expect(1, 125279, '\P{^_	Is_P}', "");
    Expect(0, 125280, '\p{_	Is_P}', "");
    Expect(1, 125280, '\p{^_	Is_P}', "");
    Expect(1, 125280, '\P{_	Is_P}', "");
    Expect(0, 125280, '\P{^_	Is_P}', "");
    Error('\p{-quotation_mark/a/}');
    Error('\P{-quotation_mark/a/}');
    Expect(1, 65379, '\p{quotationmark}', "");
    Expect(0, 65379, '\p{^quotationmark}', "");
    Expect(0, 65379, '\P{quotationmark}', "");
    Expect(1, 65379, '\P{^quotationmark}', "");
    Expect(0, 65380, '\p{quotationmark}', "");
    Expect(1, 65380, '\p{^quotationmark}', "");
    Expect(1, 65380, '\P{quotationmark}', "");
    Expect(0, 65380, '\P{^quotationmark}', "");
    Expect(1, 65379, '\p{_-quotation_MARK}', "");
    Expect(0, 65379, '\p{^_-quotation_MARK}', "");
    Expect(0, 65379, '\P{_-quotation_MARK}', "");
    Expect(1, 65379, '\P{^_-quotation_MARK}', "");
    Expect(0, 65380, '\p{_-quotation_MARK}', "");
    Expect(1, 65380, '\p{^_-quotation_MARK}', "");
    Expect(1, 65380, '\P{_-quotation_MARK}', "");
    Expect(0, 65380, '\P{^_-quotation_MARK}', "");
    Error('\p{:=-Is_Quotation_mark}');
    Error('\P{:=-Is_Quotation_mark}');
    Expect(1, 65379, '\p{isquotationmark}', "");
    Expect(0, 65379, '\p{^isquotationmark}', "");
    Expect(0, 65379, '\P{isquotationmark}', "");
    Expect(1, 65379, '\P{^isquotationmark}', "");
    Expect(0, 65380, '\p{isquotationmark}', "");
    Expect(1, 65380, '\p{^isquotationmark}', "");
    Expect(1, 65380, '\P{isquotationmark}', "");
    Expect(0, 65380, '\P{^isquotationmark}', "");
    Expect(1, 65379, '\p{IS_Quotation_Mark}', "");
    Expect(0, 65379, '\p{^IS_Quotation_Mark}', "");
    Expect(0, 65379, '\P{IS_Quotation_Mark}', "");
    Expect(1, 65379, '\P{^IS_Quotation_Mark}', "");
    Expect(0, 65380, '\p{IS_Quotation_Mark}', "");
    Expect(1, 65380, '\p{^IS_Quotation_Mark}', "");
    Expect(1, 65380, '\P{IS_Quotation_Mark}', "");
    Expect(0, 65380, '\P{^IS_Quotation_Mark}', "");
    Error('\p{_/a/QMARK}');
    Error('\P{_/a/QMARK}');
}
if (!$::TESTCHUNK or $::TESTCHUNK == 4) {
    Expect(1, 65379, '\p{qmark}', "");
    Expect(0, 65379, '\p{^qmark}', "");
    Expect(0, 65379, '\P{qmark}', "");
    Expect(1, 65379, '\P{^qmark}', "");
    Expect(0, 65380, '\p{qmark}', "");
    Expect(1, 65380, '\p{^qmark}', "");
    Expect(1, 65380, '\P{qmark}', "");
    Expect(0, 65380, '\P{^qmark}', "");
    Expect(1, 65379, '\p{_QMark}', "");
    Expect(0, 65379, '\p{^_QMark}', "");
    Expect(0, 65379, '\P{_QMark}', "");
    Expect(1, 65379, '\P{^_QMark}', "");
    Expect(0, 65380, '\p{_QMark}', "");
    Expect(1, 65380, '\p{^_QMark}', "");
    Expect(1, 65380, '\P{_QMark}', "");
    Expect(0, 65380, '\P{^_QMark}', "");
    Error('\p{:=-	IS_qmark}');
    Error('\P{:=-	IS_qmark}');
    Expect(1, 65379, '\p{isqmark}', "");
    Expect(0, 65379, '\p{^isqmark}', "");
    Expect(0, 65379, '\P{isqmark}', "");
    Expect(1, 65379, '\P{^isqmark}', "");
    Expect(0, 65380, '\p{isqmark}', "");
    Expect(1, 65380, '\p{^isqmark}', "");
    Expect(1, 65380, '\P{isqmark}', "");
    Expect(0, 65380, '\P{^isqmark}', "");
    Expect(1, 65379, '\p{	-Is_QMark}', "");
    Expect(0, 65379, '\p{^	-Is_QMark}', "");
    Expect(0, 65379, '\P{	-Is_QMark}', "");
    Expect(1, 65379, '\P{^	-Is_QMark}', "");
    Expect(0, 65380, '\p{	-Is_QMark}', "");
    Expect(1, 65380, '\p{^	-Is_QMark}', "");
    Expect(1, 65380, '\P{	-Is_QMark}', "");
    Expect(0, 65380, '\P{^	-Is_QMark}', "");
    Error('\p{/a/  Radical}');
    Error('\P{/a/  Radical}');
    Expect(1, 12245, '\p{radical}', "");
    Expect(0, 12245, '\p{^radical}', "");
    Expect(0, 12245, '\P{radical}', "");
    Expect(1, 12245, '\P{^radical}', "");
    Expect(0, 12246, '\p{radical}', "");
    Expect(1, 12246, '\p{^radical}', "");
    Expect(1, 12246, '\P{radical}', "");
    Expect(0, 12246, '\P{^radical}', "");
    Expect(1, 12245, '\p{ 	Radical}', "");
    Expect(0, 12245, '\p{^ 	Radical}', "");
    Expect(0, 12245, '\P{ 	Radical}', "");
    Expect(1, 12245, '\P{^ 	Radical}', "");
    Expect(0, 12246, '\p{ 	Radical}', "");
    Expect(1, 12246, '\p{^ 	Radical}', "");
    Expect(1, 12246, '\P{ 	Radical}', "");
    Expect(0, 12246, '\P{^ 	Radical}', "");
    Error('\p{-/a/Is_RADICAL}');
    Error('\P{-/a/Is_RADICAL}');
    Expect(1, 12245, '\p{isradical}', "");
    Expect(0, 12245, '\p{^isradical}', "");
    Expect(0, 12245, '\P{isradical}', "");
    Expect(1, 12245, '\P{^isradical}', "");
    Expect(0, 12246, '\p{isradical}', "");
    Expect(1, 12246, '\p{^isradical}', "");
    Expect(1, 12246, '\P{isradical}', "");
    Expect(0, 12246, '\P{^isradical}', "");
    Expect(1, 12245, '\p{- Is_Radical}', "");
    Expect(0, 12245, '\p{^- Is_Radical}', "");
    Expect(0, 12245, '\P{- Is_Radical}', "");
    Expect(1, 12245, '\P{^- Is_Radical}', "");
    Expect(0, 12246, '\p{- Is_Radical}', "");
    Expect(1, 12246, '\p{^- Is_Radical}', "");
    Expect(1, 12246, '\P{- Is_Radical}', "");
    Expect(0, 12246, '\P{^- Is_Radical}', "");
    Error('\p{	:=Regional_Indicator}');
    Error('\P{	:=Regional_Indicator}');
    Expect(1, 127487, '\p{regionalindicator}', "");
    Expect(0, 127487, '\p{^regionalindicator}', "");
    Expect(0, 127487, '\P{regionalindicator}', "");
    Expect(1, 127487, '\P{^regionalindicator}', "");
    Expect(0, 127488, '\p{regionalindicator}', "");
    Expect(1, 127488, '\p{^regionalindicator}', "");
    Expect(1, 127488, '\P{regionalindicator}', "");
    Expect(0, 127488, '\P{^regionalindicator}', "");
    Expect(1, 127487, '\p{	regional_Indicator}', "");
    Expect(0, 127487, '\p{^	regional_Indicator}', "");
    Expect(0, 127487, '\P{	regional_Indicator}', "");
    Expect(1, 127487, '\P{^	regional_Indicator}', "");
    Expect(0, 127488, '\p{	regional_Indicator}', "");
    Expect(1, 127488, '\p{^	regional_Indicator}', "");
    Expect(1, 127488, '\P{	regional_Indicator}', "");
    Expect(0, 127488, '\P{^	regional_Indicator}', "");
    Error('\p{	/a/Is_REGIONAL_INDICATOR}');
    Error('\P{	/a/Is_REGIONAL_INDICATOR}');
    Expect(1, 127487, '\p{isregionalindicator}', "");
    Expect(0, 127487, '\p{^isregionalindicator}', "");
    Expect(0, 127487, '\P{isregionalindicator}', "");
    Expect(1, 127487, '\P{^isregionalindicator}', "");
    Expect(0, 127488, '\p{isregionalindicator}', "");
    Expect(1, 127488, '\p{^isregionalindicator}', "");
    Expect(1, 127488, '\P{isregionalindicator}', "");
    Expect(0, 127488, '\P{^isregionalindicator}', "");
    Expect(1, 127487, '\p{	is_Regional_indicator}', "");
    Expect(0, 127487, '\p{^	is_Regional_indicator}', "");
    Expect(0, 127487, '\P{	is_Regional_indicator}', "");
    Expect(1, 127487, '\P{^	is_Regional_indicator}', "");
    Expect(0, 127488, '\p{	is_Regional_indicator}', "");
    Expect(1, 127488, '\p{^	is_Regional_indicator}', "");
    Expect(1, 127488, '\P{	is_Regional_indicator}', "");
    Expect(0, 127488, '\P{^	is_Regional_indicator}', "");
    Error('\p{:= RI}');
    Error('\P{:= RI}');
    Expect(1, 127487, '\p{ri}', "");
    Expect(0, 127487, '\p{^ri}', "");
    Expect(0, 127487, '\P{ri}', "");
    Expect(1, 127487, '\P{^ri}', "");
    Expect(0, 127488, '\p{ri}', "");
    Expect(1, 127488, '\p{^ri}', "");
    Expect(1, 127488, '\P{ri}', "");
    Expect(0, 127488, '\P{^ri}', "");
    Expect(1, 127487, '\p{ RI}', "");
    Expect(0, 127487, '\p{^ RI}', "");
    Expect(0, 127487, '\P{ RI}', "");
    Expect(1, 127487, '\P{^ RI}', "");
    Expect(0, 127488, '\p{ RI}', "");
    Expect(1, 127488, '\p{^ RI}', "");
    Expect(1, 127488, '\P{ RI}', "");
    Expect(0, 127488, '\P{^ RI}', "");
    Error('\p{:=-	Is_ri}');
    Error('\P{:=-	Is_ri}');
    Expect(1, 127487, '\p{isri}', "");
    Expect(0, 127487, '\p{^isri}', "");
    Expect(0, 127487, '\P{isri}', "");
    Expect(1, 127487, '\P{^isri}', "");
    Expect(0, 127488, '\p{isri}', "");
    Expect(1, 127488, '\p{^isri}', "");
    Expect(1, 127488, '\P{isri}', "");
    Expect(0, 127488, '\P{^isri}', "");
    Expect(1, 127487, '\p{	 IS_ri}', "");
    Expect(0, 127487, '\p{^	 IS_ri}', "");
    Expect(0, 127487, '\P{	 IS_ri}', "");
    Expect(1, 127487, '\P{^	 IS_ri}', "");
    Expect(0, 127488, '\p{	 IS_ri}', "");
    Expect(1, 127488, '\p{^	 IS_ri}', "");
    Expect(1, 127488, '\P{	 IS_ri}', "");
    Expect(0, 127488, '\P{^	 IS_ri}', "");
    Error('\p{	:=rejang}');
    Error('\P{	:=rejang}');
    Expect(1, 43359, '\p{rejang}', "");
    Expect(0, 43359, '\p{^rejang}', "");
    Expect(0, 43359, '\P{rejang}', "");
    Expect(1, 43359, '\P{^rejang}', "");
    Expect(0, 43360, '\p{rejang}', "");
    Expect(1, 43360, '\p{^rejang}', "");
    Expect(1, 43360, '\P{rejang}', "");
    Expect(0, 43360, '\P{^rejang}', "");
    Expect(1, 43359, '\p{_-Rejang}', "");
    Expect(0, 43359, '\p{^_-Rejang}', "");
    Expect(0, 43359, '\P{_-Rejang}', "");
    Expect(1, 43359, '\P{^_-Rejang}', "");
    Expect(0, 43360, '\p{_-Rejang}', "");
    Expect(1, 43360, '\p{^_-Rejang}', "");
    Expect(1, 43360, '\P{_-Rejang}', "");
    Expect(0, 43360, '\P{^_-Rejang}', "");
    Error('\p{-	Is_rejang/a/}');
    Error('\P{-	Is_rejang/a/}');
    Expect(1, 43359, '\p{isrejang}', "");
    Expect(0, 43359, '\p{^isrejang}', "");
    Expect(0, 43359, '\P{isrejang}', "");
    Expect(1, 43359, '\P{^isrejang}', "");
    Expect(0, 43360, '\p{isrejang}', "");
    Expect(1, 43360, '\p{^isrejang}', "");
    Expect(1, 43360, '\P{isrejang}', "");
    Expect(0, 43360, '\P{^isrejang}', "");
    Expect(1, 43359, '\p{_is_Rejang}', "");
    Expect(0, 43359, '\p{^_is_Rejang}', "");
    Expect(0, 43359, '\P{_is_Rejang}', "");
    Expect(1, 43359, '\P{^_is_Rejang}', "");
    Expect(0, 43360, '\p{_is_Rejang}', "");
    Expect(1, 43360, '\p{^_is_Rejang}', "");
    Expect(1, 43360, '\P{_is_Rejang}', "");
    Expect(0, 43360, '\P{^_is_Rejang}', "");
    Error('\p{/a/_	Rjng}');
    Error('\P{/a/_	Rjng}');
    Expect(1, 43359, '\p{rjng}', "");
    Expect(0, 43359, '\p{^rjng}', "");
    Expect(0, 43359, '\P{rjng}', "");
    Expect(1, 43359, '\P{^rjng}', "");
    Expect(0, 43360, '\p{rjng}', "");
    Expect(1, 43360, '\p{^rjng}', "");
    Expect(1, 43360, '\P{rjng}', "");
    Expect(0, 43360, '\P{^rjng}', "");
    Expect(1, 43359, '\p{	Rjng}', "");
    Expect(0, 43359, '\p{^	Rjng}', "");
    Expect(0, 43359, '\P{	Rjng}', "");
    Expect(1, 43359, '\P{^	Rjng}', "");
    Expect(0, 43360, '\p{	Rjng}', "");
    Expect(1, 43360, '\p{^	Rjng}', "");
    Expect(1, 43360, '\P{	Rjng}', "");
    Expect(0, 43360, '\P{^	Rjng}', "");
    Error('\p{__Is_RJNG/a/}');
    Error('\P{__Is_RJNG/a/}');
    Expect(1, 43359, '\p{isrjng}', "");
    Expect(0, 43359, '\p{^isrjng}', "");
    Expect(0, 43359, '\P{isrjng}', "");
    Expect(1, 43359, '\P{^isrjng}', "");
    Expect(0, 43360, '\p{isrjng}', "");
    Expect(1, 43360, '\p{^isrjng}', "");
    Expect(1, 43360, '\P{isrjng}', "");
    Expect(0, 43360, '\P{^isrjng}', "");
    Expect(1, 43359, '\p{_ Is_RJNG}', "");
    Expect(0, 43359, '\p{^_ Is_RJNG}', "");
    Expect(0, 43359, '\P{_ Is_RJNG}', "");
    Expect(1, 43359, '\P{^_ Is_RJNG}', "");
    Expect(0, 43360, '\p{_ Is_RJNG}', "");
    Expect(1, 43360, '\p{^_ Is_RJNG}', "");
    Expect(1, 43360, '\P{_ Is_RJNG}', "");
    Expect(0, 43360, '\P{^_ Is_RJNG}', "");
    Error('\p{	:=rumi_Numeral_SYMBOLS}');
    Error('\P{	:=rumi_Numeral_SYMBOLS}');
    Expect(1, 69247, '\p{ruminumeralsymbols}', "");
    Expect(0, 69247, '\p{^ruminumeralsymbols}', "");
    Expect(0, 69247, '\P{ruminumeralsymbols}', "");
    Expect(1, 69247, '\P{^ruminumeralsymbols}', "");
    Expect(0, 69248, '\p{ruminumeralsymbols}', "");
    Expect(1, 69248, '\p{^ruminumeralsymbols}', "");
    Expect(1, 69248, '\P{ruminumeralsymbols}', "");
    Expect(0, 69248, '\P{^ruminumeralsymbols}', "");
    Expect(1, 69247, '\p{ rumi_Numeral_Symbols}', "");
    Expect(0, 69247, '\p{^ rumi_Numeral_Symbols}', "");
    Expect(0, 69247, '\P{ rumi_Numeral_Symbols}', "");
    Expect(1, 69247, '\P{^ rumi_Numeral_Symbols}', "");
    Expect(0, 69248, '\p{ rumi_Numeral_Symbols}', "");
    Expect(1, 69248, '\p{^ rumi_Numeral_Symbols}', "");
    Expect(1, 69248, '\P{ rumi_Numeral_Symbols}', "");
    Expect(0, 69248, '\P{^ rumi_Numeral_Symbols}', "");
    Error('\p{-Is_Rumi_numeral_Symbols:=}');
    Error('\P{-Is_Rumi_numeral_Symbols:=}');
    Expect(1, 69247, '\p{isruminumeralsymbols}', "");
    Expect(0, 69247, '\p{^isruminumeralsymbols}', "");
    Expect(0, 69247, '\P{isruminumeralsymbols}', "");
    Expect(1, 69247, '\P{^isruminumeralsymbols}', "");
    Expect(0, 69248, '\p{isruminumeralsymbols}', "");
    Expect(1, 69248, '\p{^isruminumeralsymbols}', "");
    Expect(1, 69248, '\P{isruminumeralsymbols}', "");
    Expect(0, 69248, '\P{^isruminumeralsymbols}', "");
    Expect(1, 69247, '\p{_	IS_Rumi_NUMERAL_symbols}', "");
    Expect(0, 69247, '\p{^_	IS_Rumi_NUMERAL_symbols}', "");
    Expect(0, 69247, '\P{_	IS_Rumi_NUMERAL_symbols}', "");
    Expect(1, 69247, '\P{^_	IS_Rumi_NUMERAL_symbols}', "");
    Expect(0, 69248, '\p{_	IS_Rumi_NUMERAL_symbols}', "");
    Expect(1, 69248, '\p{^_	IS_Rumi_NUMERAL_symbols}', "");
    Expect(1, 69248, '\P{_	IS_Rumi_NUMERAL_symbols}', "");
    Expect(0, 69248, '\P{^_	IS_Rumi_NUMERAL_symbols}', "");
    Error('\p{		in_RUMI_numeral_Symbols/a/}');
    Error('\P{		in_RUMI_numeral_Symbols/a/}');
    Expect(1, 69247, '\p{inruminumeralsymbols}', "");
    Expect(0, 69247, '\p{^inruminumeralsymbols}', "");
    Expect(0, 69247, '\P{inruminumeralsymbols}', "");
    Expect(1, 69247, '\P{^inruminumeralsymbols}', "");
    Expect(0, 69248, '\p{inruminumeralsymbols}', "");
    Expect(1, 69248, '\p{^inruminumeralsymbols}', "");
    Expect(1, 69248, '\P{inruminumeralsymbols}', "");
    Expect(0, 69248, '\P{^inruminumeralsymbols}', "");
    Expect(1, 69247, '\p{		In_Rumi_Numeral_symbols}', "");
    Expect(0, 69247, '\p{^		In_Rumi_Numeral_symbols}', "");
    Expect(0, 69247, '\P{		In_Rumi_Numeral_symbols}', "");
    Expect(1, 69247, '\P{^		In_Rumi_Numeral_symbols}', "");
    Expect(0, 69248, '\p{		In_Rumi_Numeral_symbols}', "");
    Expect(1, 69248, '\p{^		In_Rumi_Numeral_symbols}', "");
    Expect(1, 69248, '\P{		In_Rumi_Numeral_symbols}', "");
    Expect(0, 69248, '\P{^		In_Rumi_Numeral_symbols}', "");
    Error('\p{:= 	Rumi}');
    Error('\P{:= 	Rumi}');
    Expect(1, 69247, '\p{rumi}', "");
    Expect(0, 69247, '\p{^rumi}', "");
    Expect(0, 69247, '\P{rumi}', "");
    Expect(1, 69247, '\P{^rumi}', "");
    Expect(0, 69248, '\p{rumi}', "");
    Expect(1, 69248, '\p{^rumi}', "");
    Expect(1, 69248, '\P{rumi}', "");
    Expect(0, 69248, '\P{^rumi}', "");
    Expect(1, 69247, '\p{  rumi}', "");
    Expect(0, 69247, '\p{^  rumi}', "");
    Expect(0, 69247, '\P{  rumi}', "");
    Expect(1, 69247, '\P{^  rumi}', "");
    Expect(0, 69248, '\p{  rumi}', "");
    Expect(1, 69248, '\p{^  rumi}', "");
    Expect(1, 69248, '\P{  rumi}', "");
    Expect(0, 69248, '\P{^  rumi}', "");
    Error('\p{:= Is_rumi}');
    Error('\P{:= Is_rumi}');
    Expect(1, 69247, '\p{isrumi}', "");
    Expect(0, 69247, '\p{^isrumi}', "");
    Expect(0, 69247, '\P{isrumi}', "");
    Expect(1, 69247, '\P{^isrumi}', "");
    Expect(0, 69248, '\p{isrumi}', "");
    Expect(1, 69248, '\p{^isrumi}', "");
    Expect(1, 69248, '\P{isrumi}', "");
    Expect(0, 69248, '\P{^isrumi}', "");
    Expect(1, 69247, '\p{__Is_rumi}', "");
    Expect(0, 69247, '\p{^__Is_rumi}', "");
    Expect(0, 69247, '\P{__Is_rumi}', "");
    Expect(1, 69247, '\P{^__Is_rumi}', "");
    Expect(0, 69248, '\p{__Is_rumi}', "");
    Expect(1, 69248, '\p{^__Is_rumi}', "");
    Expect(1, 69248, '\P{__Is_rumi}', "");
    Expect(0, 69248, '\P{^__Is_rumi}', "");
    Error('\p{/a/ _IN_RUMI}');
    Error('\P{/a/ _IN_RUMI}');
    Expect(1, 69247, '\p{inrumi}', "");
    Expect(0, 69247, '\p{^inrumi}', "");
    Expect(0, 69247, '\P{inrumi}', "");
    Expect(1, 69247, '\P{^inrumi}', "");
    Expect(0, 69248, '\p{inrumi}', "");
    Expect(1, 69248, '\p{^inrumi}', "");
    Expect(1, 69248, '\P{inrumi}', "");
    Expect(0, 69248, '\P{^inrumi}', "");
    Expect(1, 69247, '\p{-In_Rumi}', "");
    Expect(0, 69247, '\p{^-In_Rumi}', "");
    Expect(0, 69247, '\P{-In_Rumi}', "");
    Expect(1, 69247, '\P{^-In_Rumi}', "");
    Expect(0, 69248, '\p{-In_Rumi}', "");
    Expect(1, 69248, '\p{^-In_Rumi}', "");
    Expect(1, 69248, '\P{-In_Rumi}', "");
    Expect(0, 69248, '\P{^-In_Rumi}', "");
    Error('\p{-	Runic/a/}');
    Error('\P{-	Runic/a/}');
    Expect(1, 5880, '\p{runic}', "");
    Expect(0, 5880, '\p{^runic}', "");
    Expect(0, 5880, '\P{runic}', "");
    Expect(1, 5880, '\P{^runic}', "");
    Expect(0, 5881, '\p{runic}', "");
    Expect(1, 5881, '\p{^runic}', "");
    Expect(1, 5881, '\P{runic}', "");
    Expect(0, 5881, '\P{^runic}', "");
    Expect(1, 5880, '\p{ -RUNIC}', "");
    Expect(0, 5880, '\p{^ -RUNIC}', "");
    Expect(0, 5880, '\P{ -RUNIC}', "");
    Expect(1, 5880, '\P{^ -RUNIC}', "");
    Expect(0, 5881, '\p{ -RUNIC}', "");
    Expect(1, 5881, '\p{^ -RUNIC}', "");
    Expect(1, 5881, '\P{ -RUNIC}', "");
    Expect(0, 5881, '\P{^ -RUNIC}', "");
    Error('\p{:=-	Is_runic}');
    Error('\P{:=-	Is_runic}');
    Expect(1, 5880, '\p{isrunic}', "");
    Expect(0, 5880, '\p{^isrunic}', "");
    Expect(0, 5880, '\P{isrunic}', "");
    Expect(1, 5880, '\P{^isrunic}', "");
    Expect(0, 5881, '\p{isrunic}', "");
    Expect(1, 5881, '\p{^isrunic}', "");
    Expect(1, 5881, '\P{isrunic}', "");
    Expect(0, 5881, '\P{^isrunic}', "");
    Expect(1, 5880, '\p{_IS_Runic}', "");
    Expect(0, 5880, '\p{^_IS_Runic}', "");
    Expect(0, 5880, '\P{_IS_Runic}', "");
    Expect(1, 5880, '\P{^_IS_Runic}', "");
    Expect(0, 5881, '\p{_IS_Runic}', "");
    Expect(1, 5881, '\p{^_IS_Runic}', "");
    Expect(1, 5881, '\P{_IS_Runic}', "");
    Expect(0, 5881, '\P{^_IS_Runic}', "");
    Error('\p{/a/RUNR}');
    Error('\P{/a/RUNR}');
    Expect(1, 5880, '\p{runr}', "");
    Expect(0, 5880, '\p{^runr}', "");
    Expect(0, 5880, '\P{runr}', "");
    Expect(1, 5880, '\P{^runr}', "");
    Expect(0, 5881, '\p{runr}', "");
    Expect(1, 5881, '\p{^runr}', "");
    Expect(1, 5881, '\P{runr}', "");
    Expect(0, 5881, '\P{^runr}', "");
    Expect(1, 5880, '\p{	Runr}', "");
    Expect(0, 5880, '\p{^	Runr}', "");
    Expect(0, 5880, '\P{	Runr}', "");
    Expect(1, 5880, '\P{^	Runr}', "");
    Expect(0, 5881, '\p{	Runr}', "");
    Expect(1, 5881, '\p{^	Runr}', "");
    Expect(1, 5881, '\P{	Runr}', "");
    Expect(0, 5881, '\P{^	Runr}', "");
    Error('\p{_:=is_Runr}');
    Error('\P{_:=is_Runr}');
    Expect(1, 5880, '\p{isrunr}', "");
    Expect(0, 5880, '\p{^isrunr}', "");
    Expect(0, 5880, '\P{isrunr}', "");
    Expect(1, 5880, '\P{^isrunr}', "");
    Expect(0, 5881, '\p{isrunr}', "");
    Expect(1, 5881, '\p{^isrunr}', "");
    Expect(1, 5881, '\P{isrunr}', "");
    Expect(0, 5881, '\P{^isrunr}', "");
    Expect(1, 5880, '\p{  Is_runr}', "");
    Expect(0, 5880, '\p{^  Is_runr}', "");
    Expect(0, 5880, '\P{  Is_runr}', "");
    Expect(1, 5880, '\P{^  Is_runr}', "");
    Expect(0, 5881, '\p{  Is_runr}', "");
    Expect(1, 5881, '\p{^  Is_runr}', "");
    Expect(1, 5881, '\P{  Is_runr}', "");
    Expect(0, 5881, '\P{^  Is_runr}', "");
    Error('\p{	/a/Samaritan}');
    Error('\P{	/a/Samaritan}');
    Expect(1, 2110, '\p{samaritan}', "");
    Expect(0, 2110, '\p{^samaritan}', "");
    Expect(0, 2110, '\P{samaritan}', "");
    Expect(1, 2110, '\P{^samaritan}', "");
    Expect(0, 2111, '\p{samaritan}', "");
    Expect(1, 2111, '\p{^samaritan}', "");
    Expect(1, 2111, '\P{samaritan}', "");
    Expect(0, 2111, '\P{^samaritan}', "");
    Expect(1, 2110, '\p{	 Samaritan}', "");
    Expect(0, 2110, '\p{^	 Samaritan}', "");
    Expect(0, 2110, '\P{	 Samaritan}', "");
    Expect(1, 2110, '\P{^	 Samaritan}', "");
    Expect(0, 2111, '\p{	 Samaritan}', "");
    Expect(1, 2111, '\p{^	 Samaritan}', "");
    Expect(1, 2111, '\P{	 Samaritan}', "");
    Expect(0, 2111, '\P{^	 Samaritan}', "");
    Error('\p{ 	IS_Samaritan:=}');
    Error('\P{ 	IS_Samaritan:=}');
    Expect(1, 2110, '\p{issamaritan}', "");
    Expect(0, 2110, '\p{^issamaritan}', "");
    Expect(0, 2110, '\P{issamaritan}', "");
    Expect(1, 2110, '\P{^issamaritan}', "");
    Expect(0, 2111, '\p{issamaritan}', "");
    Expect(1, 2111, '\p{^issamaritan}', "");
    Expect(1, 2111, '\P{issamaritan}', "");
    Expect(0, 2111, '\P{^issamaritan}', "");
    Expect(1, 2110, '\p{ _Is_Samaritan}', "");
    Expect(0, 2110, '\p{^ _Is_Samaritan}', "");
    Expect(0, 2110, '\P{ _Is_Samaritan}', "");
    Expect(1, 2110, '\P{^ _Is_Samaritan}', "");
    Expect(0, 2111, '\p{ _Is_Samaritan}', "");
    Expect(1, 2111, '\p{^ _Is_Samaritan}', "");
    Expect(1, 2111, '\P{ _Is_Samaritan}', "");
    Expect(0, 2111, '\P{^ _Is_Samaritan}', "");
    Error('\p{:=	samr}');
    Error('\P{:=	samr}');
    Expect(1, 2110, '\p{samr}', "");
    Expect(0, 2110, '\p{^samr}', "");
    Expect(0, 2110, '\P{samr}', "");
    Expect(1, 2110, '\P{^samr}', "");
    Expect(0, 2111, '\p{samr}', "");
    Expect(1, 2111, '\p{^samr}', "");
    Expect(1, 2111, '\P{samr}', "");
    Expect(0, 2111, '\P{^samr}', "");
    Expect(1, 2110, '\p{ 	SAMR}', "");
    Expect(0, 2110, '\p{^ 	SAMR}', "");
    Expect(0, 2110, '\P{ 	SAMR}', "");
    Expect(1, 2110, '\P{^ 	SAMR}', "");
    Expect(0, 2111, '\p{ 	SAMR}', "");
    Expect(1, 2111, '\p{^ 	SAMR}', "");
    Expect(1, 2111, '\P{ 	SAMR}', "");
    Expect(0, 2111, '\P{^ 	SAMR}', "");
    Error('\p{	/a/Is_Samr}');
    Error('\P{	/a/Is_Samr}');
    Expect(1, 2110, '\p{issamr}', "");
    Expect(0, 2110, '\p{^issamr}', "");
    Expect(0, 2110, '\P{issamr}', "");
    Expect(1, 2110, '\P{^issamr}', "");
    Expect(0, 2111, '\p{issamr}', "");
    Expect(1, 2111, '\p{^issamr}', "");
    Expect(1, 2111, '\P{issamr}', "");
    Expect(0, 2111, '\P{^issamr}', "");
    Expect(1, 2110, '\p{_Is_Samr}', "");
    Expect(0, 2110, '\p{^_Is_Samr}', "");
    Expect(0, 2110, '\P{_Is_Samr}', "");
    Expect(1, 2110, '\P{^_Is_Samr}', "");
    Expect(0, 2111, '\p{_Is_Samr}', "");
    Expect(1, 2111, '\p{^_Is_Samr}', "");
    Expect(1, 2111, '\P{_Is_Samr}', "");
    Expect(0, 2111, '\P{^_Is_Samr}', "");
    Error('\p{/a/saurashtra}');
    Error('\P{/a/saurashtra}');
    Expect(1, 43225, '\p{saurashtra}', "");
    Expect(0, 43225, '\p{^saurashtra}', "");
    Expect(0, 43225, '\P{saurashtra}', "");
    Expect(1, 43225, '\P{^saurashtra}', "");
    Expect(0, 43226, '\p{saurashtra}', "");
    Expect(1, 43226, '\p{^saurashtra}', "");
    Expect(1, 43226, '\P{saurashtra}', "");
    Expect(0, 43226, '\P{^saurashtra}', "");
    Expect(1, 43225, '\p{_SAURASHTRA}', "");
    Expect(0, 43225, '\p{^_SAURASHTRA}', "");
    Expect(0, 43225, '\P{_SAURASHTRA}', "");
    Expect(1, 43225, '\P{^_SAURASHTRA}', "");
    Expect(0, 43226, '\p{_SAURASHTRA}', "");
    Expect(1, 43226, '\p{^_SAURASHTRA}', "");
    Expect(1, 43226, '\P{_SAURASHTRA}', "");
    Expect(0, 43226, '\P{^_SAURASHTRA}', "");
    Error('\p{	_is_Saurashtra:=}');
    Error('\P{	_is_Saurashtra:=}');
    Expect(1, 43225, '\p{issaurashtra}', "");
    Expect(0, 43225, '\p{^issaurashtra}', "");
    Expect(0, 43225, '\P{issaurashtra}', "");
    Expect(1, 43225, '\P{^issaurashtra}', "");
    Expect(0, 43226, '\p{issaurashtra}', "");
    Expect(1, 43226, '\p{^issaurashtra}', "");
    Expect(1, 43226, '\P{issaurashtra}', "");
    Expect(0, 43226, '\P{^issaurashtra}', "");
    Expect(1, 43225, '\p{- Is_Saurashtra}', "");
    Expect(0, 43225, '\p{^- Is_Saurashtra}', "");
    Expect(0, 43225, '\P{- Is_Saurashtra}', "");
    Expect(1, 43225, '\P{^- Is_Saurashtra}', "");
    Expect(0, 43226, '\p{- Is_Saurashtra}', "");
    Expect(1, 43226, '\p{^- Is_Saurashtra}', "");
    Expect(1, 43226, '\P{- Is_Saurashtra}', "");
    Expect(0, 43226, '\P{^- Is_Saurashtra}', "");
    Error('\p{	Saur:=}');
    Error('\P{	Saur:=}');
    Expect(1, 43225, '\p{saur}', "");
    Expect(0, 43225, '\p{^saur}', "");
    Expect(0, 43225, '\P{saur}', "");
    Expect(1, 43225, '\P{^saur}', "");
    Expect(0, 43226, '\p{saur}', "");
    Expect(1, 43226, '\p{^saur}', "");
    Expect(1, 43226, '\P{saur}', "");
    Expect(0, 43226, '\P{^saur}', "");
    Expect(1, 43225, '\p{ 	saur}', "");
    Expect(0, 43225, '\p{^ 	saur}', "");
    Expect(0, 43225, '\P{ 	saur}', "");
    Expect(1, 43225, '\P{^ 	saur}', "");
    Expect(0, 43226, '\p{ 	saur}', "");
    Expect(1, 43226, '\p{^ 	saur}', "");
    Expect(1, 43226, '\P{ 	saur}', "");
    Expect(0, 43226, '\P{^ 	saur}', "");
    Error('\p{:=		Is_SAUR}');
    Error('\P{:=		Is_SAUR}');
    Expect(1, 43225, '\p{issaur}', "");
    Expect(0, 43225, '\p{^issaur}', "");
    Expect(0, 43225, '\P{issaur}', "");
    Expect(1, 43225, '\P{^issaur}', "");
    Expect(0, 43226, '\p{issaur}', "");
    Expect(1, 43226, '\p{^issaur}', "");
    Expect(1, 43226, '\P{issaur}', "");
    Expect(0, 43226, '\P{^issaur}', "");
    Expect(1, 43225, '\p{_	IS_Saur}', "");
    Expect(0, 43225, '\p{^_	IS_Saur}', "");
    Expect(0, 43225, '\P{_	IS_Saur}', "");
    Expect(1, 43225, '\P{^_	IS_Saur}', "");
    Expect(0, 43226, '\p{_	IS_Saur}', "");
    Expect(1, 43226, '\p{^_	IS_Saur}', "");
    Expect(1, 43226, '\P{_	IS_Saur}', "");
    Expect(0, 43226, '\P{^_	IS_Saur}', "");
    Error('\p{:=Sentence_TERMINAL}');
    Error('\P{:=Sentence_TERMINAL}');
    Expect(1, 121480, '\p{sentenceterminal}', "");
    Expect(0, 121480, '\p{^sentenceterminal}', "");
    Expect(0, 121480, '\P{sentenceterminal}', "");
    Expect(1, 121480, '\P{^sentenceterminal}', "");
    Expect(0, 121481, '\p{sentenceterminal}', "");
    Expect(1, 121481, '\p{^sentenceterminal}', "");
    Expect(1, 121481, '\P{sentenceterminal}', "");
    Expect(0, 121481, '\P{^sentenceterminal}', "");
    Expect(1, 121480, '\p{Sentence_TERMINAL}', "");
    Expect(0, 121480, '\p{^Sentence_TERMINAL}', "");
    Expect(0, 121480, '\P{Sentence_TERMINAL}', "");
    Expect(1, 121480, '\P{^Sentence_TERMINAL}', "");
    Expect(0, 121481, '\p{Sentence_TERMINAL}', "");
    Expect(1, 121481, '\p{^Sentence_TERMINAL}', "");
    Expect(1, 121481, '\P{Sentence_TERMINAL}', "");
    Expect(0, 121481, '\P{^Sentence_TERMINAL}', "");
    Error('\p{/a/Is_sentence_Terminal}');
    Error('\P{/a/Is_sentence_Terminal}');
    Expect(1, 121480, '\p{issentenceterminal}', "");
    Expect(0, 121480, '\p{^issentenceterminal}', "");
    Expect(0, 121480, '\P{issentenceterminal}', "");
    Expect(1, 121480, '\P{^issentenceterminal}', "");
    Expect(0, 121481, '\p{issentenceterminal}', "");
    Expect(1, 121481, '\p{^issentenceterminal}', "");
    Expect(1, 121481, '\P{issentenceterminal}', "");
    Expect(0, 121481, '\P{^issentenceterminal}', "");
    Expect(1, 121480, '\p{  IS_sentence_Terminal}', "");
    Expect(0, 121480, '\p{^  IS_sentence_Terminal}', "");
    Expect(0, 121480, '\P{  IS_sentence_Terminal}', "");
    Expect(1, 121480, '\P{^  IS_sentence_Terminal}', "");
    Expect(0, 121481, '\p{  IS_sentence_Terminal}', "");
    Expect(1, 121481, '\p{^  IS_sentence_Terminal}', "");
    Expect(1, 121481, '\P{  IS_sentence_Terminal}', "");
    Expect(0, 121481, '\P{^  IS_sentence_Terminal}', "");
    Error('\p{--STerm/a/}');
    Error('\P{--STerm/a/}');
    Expect(1, 121480, '\p{sterm}', "");
    Expect(0, 121480, '\p{^sterm}', "");
    Expect(0, 121480, '\P{sterm}', "");
    Expect(1, 121480, '\P{^sterm}', "");
    Expect(0, 121481, '\p{sterm}', "");
    Expect(1, 121481, '\p{^sterm}', "");
    Expect(1, 121481, '\P{sterm}', "");
    Expect(0, 121481, '\P{^sterm}', "");
    Expect(1, 121480, '\p{--sterm}', "");
    Expect(0, 121480, '\p{^--sterm}', "");
    Expect(0, 121480, '\P{--sterm}', "");
    Expect(1, 121480, '\P{^--sterm}', "");
    Expect(0, 121481, '\p{--sterm}', "");
    Expect(1, 121481, '\p{^--sterm}', "");
    Expect(1, 121481, '\P{--sterm}', "");
    Expect(0, 121481, '\P{^--sterm}', "");
    Error('\p{:=IS_sterm}');
    Error('\P{:=IS_sterm}');
    Expect(1, 121480, '\p{issterm}', "");
    Expect(0, 121480, '\p{^issterm}', "");
    Expect(0, 121480, '\P{issterm}', "");
    Expect(1, 121480, '\P{^issterm}', "");
    Expect(0, 121481, '\p{issterm}', "");
    Expect(1, 121481, '\p{^issterm}', "");
    Expect(1, 121481, '\P{issterm}', "");
    Expect(0, 121481, '\P{^issterm}', "");
    Expect(1, 121480, '\p{-_IS_STerm}', "");
    Expect(0, 121480, '\p{^-_IS_STerm}', "");
    Expect(0, 121480, '\P{-_IS_STerm}', "");
    Expect(1, 121480, '\P{^-_IS_STerm}', "");
    Expect(0, 121481, '\p{-_IS_STerm}', "");
    Expect(1, 121481, '\p{^-_IS_STerm}', "");
    Expect(1, 121481, '\P{-_IS_STerm}', "");
    Expect(0, 121481, '\P{^-_IS_STerm}', "");
    Error('\p{_:=separator}');
    Error('\P{_:=separator}');
    Expect(1, 12288, '\p{separator}', "");
    Expect(0, 12288, '\p{^separator}', "");
    Expect(0, 12288, '\P{separator}', "");
    Expect(1, 12288, '\P{^separator}', "");
    Expect(0, 12289, '\p{separator}', "");
    Expect(1, 12289, '\p{^separator}', "");
    Expect(1, 12289, '\P{separator}', "");
    Expect(0, 12289, '\P{^separator}', "");
    Expect(1, 12288, '\p{_Separator}', "");
    Expect(0, 12288, '\p{^_Separator}', "");
    Expect(0, 12288, '\P{_Separator}', "");
    Expect(1, 12288, '\P{^_Separator}', "");
    Expect(0, 12289, '\p{_Separator}', "");
    Expect(1, 12289, '\p{^_Separator}', "");
    Expect(1, 12289, '\P{_Separator}', "");
    Expect(0, 12289, '\P{^_Separator}', "");
    Error('\p{-:=is_SEPARATOR}');
    Error('\P{-:=is_SEPARATOR}');
    Expect(1, 12288, '\p{isseparator}', "");
    Expect(0, 12288, '\p{^isseparator}', "");
    Expect(0, 12288, '\P{isseparator}', "");
    Expect(1, 12288, '\P{^isseparator}', "");
    Expect(0, 12289, '\p{isseparator}', "");
    Expect(1, 12289, '\p{^isseparator}', "");
    Expect(1, 12289, '\P{isseparator}', "");
    Expect(0, 12289, '\P{^isseparator}', "");
    Expect(1, 12288, '\p{  IS_separator}', "");
    Expect(0, 12288, '\p{^  IS_separator}', "");
    Expect(0, 12288, '\P{  IS_separator}', "");
    Expect(1, 12288, '\P{^  IS_separator}', "");
    Expect(0, 12289, '\p{  IS_separator}', "");
    Expect(1, 12289, '\p{^  IS_separator}', "");
    Expect(1, 12289, '\P{  IS_separator}', "");
    Expect(0, 12289, '\P{^  IS_separator}', "");
    Error('\p{	:=Z}');
    Error('\P{	:=Z}');
    Expect(1, 12288, '\p{z}', "");
    Expect(0, 12288, '\p{^z}', "");
    Expect(0, 12288, '\P{z}', "");
    Expect(1, 12288, '\P{^z}', "");
    Expect(0, 12289, '\p{z}', "");
    Expect(1, 12289, '\p{^z}', "");
    Expect(1, 12289, '\P{z}', "");
    Expect(0, 12289, '\P{^z}', "");
    Expect(1, 12288, '\p{	_z}', "");
    Expect(0, 12288, '\p{^	_z}', "");
    Expect(0, 12288, '\P{	_z}', "");
    Expect(1, 12288, '\P{^	_z}', "");
    Expect(0, 12289, '\p{	_z}', "");
    Expect(1, 12289, '\p{^	_z}', "");
    Expect(1, 12289, '\P{	_z}', "");
    Expect(0, 12289, '\P{^	_z}', "");
    Error('\p{-:=Is_Z}');
    Error('\P{-:=Is_Z}');
    Expect(1, 12288, '\p{isz}', "");
    Expect(0, 12288, '\p{^isz}', "");
    Expect(0, 12288, '\P{isz}', "");
    Expect(1, 12288, '\P{^isz}', "");
    Expect(0, 12289, '\p{isz}', "");
    Expect(1, 12289, '\p{^isz}', "");
    Expect(1, 12289, '\P{isz}', "");
    Expect(0, 12289, '\P{^isz}', "");
    Expect(1, 12288, '\p{  Is_Z}', "");
    Expect(0, 12288, '\p{^  Is_Z}', "");
    Expect(0, 12288, '\P{  Is_Z}', "");
    Expect(1, 12288, '\P{^  Is_Z}', "");
    Expect(0, 12289, '\p{  Is_Z}', "");
    Expect(1, 12289, '\p{^  Is_Z}', "");
    Expect(1, 12289, '\P{  Is_Z}', "");
    Expect(0, 12289, '\P{^  Is_Z}', "");
    Error('\p{--Sharada:=}');
    Error('\P{--Sharada:=}');
    Expect(1, 70111, '\p{sharada}', "");
    Expect(0, 70111, '\p{^sharada}', "");
    Expect(0, 70111, '\P{sharada}', "");
    Expect(1, 70111, '\P{^sharada}', "");
    Expect(0, 70112, '\p{sharada}', "");
    Expect(1, 70112, '\p{^sharada}', "");
    Expect(1, 70112, '\P{sharada}', "");
    Expect(0, 70112, '\P{^sharada}', "");
    Expect(1, 70111, '\p{-Sharada}', "");
    Expect(0, 70111, '\p{^-Sharada}', "");
    Expect(0, 70111, '\P{-Sharada}', "");
    Expect(1, 70111, '\P{^-Sharada}', "");
    Expect(0, 70112, '\p{-Sharada}', "");
    Expect(1, 70112, '\p{^-Sharada}', "");
    Expect(1, 70112, '\P{-Sharada}', "");
    Expect(0, 70112, '\P{^-Sharada}', "");
    Error('\p{/a/_is_Sharada}');
    Error('\P{/a/_is_Sharada}');
    Expect(1, 70111, '\p{issharada}', "");
    Expect(0, 70111, '\p{^issharada}', "");
    Expect(0, 70111, '\P{issharada}', "");
    Expect(1, 70111, '\P{^issharada}', "");
    Expect(0, 70112, '\p{issharada}', "");
    Expect(1, 70112, '\p{^issharada}', "");
    Expect(1, 70112, '\P{issharada}', "");
    Expect(0, 70112, '\P{^issharada}', "");
    Expect(1, 70111, '\p{_Is_sharada}', "");
    Expect(0, 70111, '\p{^_Is_sharada}', "");
    Expect(0, 70111, '\P{_Is_sharada}', "");
    Expect(1, 70111, '\P{^_Is_sharada}', "");
    Expect(0, 70112, '\p{_Is_sharada}', "");
    Expect(1, 70112, '\p{^_Is_sharada}', "");
    Expect(1, 70112, '\P{_Is_sharada}', "");
    Expect(0, 70112, '\P{^_Is_sharada}', "");
    Error('\p{:= _SHRD}');
    Error('\P{:= _SHRD}');
    Expect(1, 70111, '\p{shrd}', "");
    Expect(0, 70111, '\p{^shrd}', "");
    Expect(0, 70111, '\P{shrd}', "");
    Expect(1, 70111, '\P{^shrd}', "");
    Expect(0, 70112, '\p{shrd}', "");
    Expect(1, 70112, '\p{^shrd}', "");
    Expect(1, 70112, '\P{shrd}', "");
    Expect(0, 70112, '\P{^shrd}', "");
    Expect(1, 70111, '\p{  Shrd}', "");
    Expect(0, 70111, '\p{^  Shrd}', "");
    Expect(0, 70111, '\P{  Shrd}', "");
    Expect(1, 70111, '\P{^  Shrd}', "");
    Expect(0, 70112, '\p{  Shrd}', "");
    Expect(1, 70112, '\p{^  Shrd}', "");
    Expect(1, 70112, '\P{  Shrd}', "");
    Expect(0, 70112, '\P{^  Shrd}', "");
    Error('\p{ /a/Is_SHRD}');
    Error('\P{ /a/Is_SHRD}');
    Expect(1, 70111, '\p{isshrd}', "");
    Expect(0, 70111, '\p{^isshrd}', "");
    Expect(0, 70111, '\P{isshrd}', "");
    Expect(1, 70111, '\P{^isshrd}', "");
    Expect(0, 70112, '\p{isshrd}', "");
    Expect(1, 70112, '\p{^isshrd}', "");
    Expect(1, 70112, '\P{isshrd}', "");
    Expect(0, 70112, '\P{^isshrd}', "");
    Expect(1, 70111, '\p{	IS_shrd}', "");
    Expect(0, 70111, '\p{^	IS_shrd}', "");
    Expect(0, 70111, '\P{	IS_shrd}', "");
    Expect(1, 70111, '\P{^	IS_shrd}', "");
    Expect(0, 70112, '\p{	IS_shrd}', "");
    Expect(1, 70112, '\p{^	IS_shrd}', "");
    Expect(1, 70112, '\P{	IS_shrd}', "");
    Expect(0, 70112, '\P{^	IS_shrd}', "");
    Error('\p{	:=Shavian}');
    Error('\P{	:=Shavian}');
    Expect(1, 66687, '\p{shavian}', "");
    Expect(0, 66687, '\p{^shavian}', "");
    Expect(0, 66687, '\P{shavian}', "");
    Expect(1, 66687, '\P{^shavian}', "");
    Expect(0, 66688, '\p{shavian}', "");
    Expect(1, 66688, '\p{^shavian}', "");
    Expect(1, 66688, '\P{shavian}', "");
    Expect(0, 66688, '\P{^shavian}', "");
    Expect(1, 66687, '\p{-_shavian}', "");
    Expect(0, 66687, '\p{^-_shavian}', "");
    Expect(0, 66687, '\P{-_shavian}', "");
    Expect(1, 66687, '\P{^-_shavian}', "");
    Expect(0, 66688, '\p{-_shavian}', "");
    Expect(1, 66688, '\p{^-_shavian}', "");
    Expect(1, 66688, '\P{-_shavian}', "");
    Expect(0, 66688, '\P{^-_shavian}', "");
    Error('\p{-/a/is_Shavian}');
    Error('\P{-/a/is_Shavian}');
    Expect(1, 66687, '\p{isshavian}', "");
    Expect(0, 66687, '\p{^isshavian}', "");
    Expect(0, 66687, '\P{isshavian}', "");
    Expect(1, 66687, '\P{^isshavian}', "");
    Expect(0, 66688, '\p{isshavian}', "");
    Expect(1, 66688, '\p{^isshavian}', "");
    Expect(1, 66688, '\P{isshavian}', "");
    Expect(0, 66688, '\P{^isshavian}', "");
    Expect(1, 66687, '\p{	-Is_Shavian}', "");
    Expect(0, 66687, '\p{^	-Is_Shavian}', "");
    Expect(0, 66687, '\P{	-Is_Shavian}', "");
    Expect(1, 66687, '\P{^	-Is_Shavian}', "");
    Expect(0, 66688, '\p{	-Is_Shavian}', "");
    Expect(1, 66688, '\p{^	-Is_Shavian}', "");
    Expect(1, 66688, '\P{	-Is_Shavian}', "");
    Expect(0, 66688, '\P{^	-Is_Shavian}', "");
    Error('\p{/a/	-shaw}');
    Error('\P{/a/	-shaw}');
    Expect(1, 66687, '\p{shaw}', "");
    Expect(0, 66687, '\p{^shaw}', "");
    Expect(0, 66687, '\P{shaw}', "");
    Expect(1, 66687, '\P{^shaw}', "");
    Expect(0, 66688, '\p{shaw}', "");
    Expect(1, 66688, '\p{^shaw}', "");
    Expect(1, 66688, '\P{shaw}', "");
    Expect(0, 66688, '\P{^shaw}', "");
    Expect(1, 66687, '\p{ _Shaw}', "");
    Expect(0, 66687, '\p{^ _Shaw}', "");
    Expect(0, 66687, '\P{ _Shaw}', "");
    Expect(1, 66687, '\P{^ _Shaw}', "");
    Expect(0, 66688, '\p{ _Shaw}', "");
    Expect(1, 66688, '\p{^ _Shaw}', "");
    Expect(1, 66688, '\P{ _Shaw}', "");
    Expect(0, 66688, '\P{^ _Shaw}', "");
    Error('\p{_	Is_Shaw:=}');
    Error('\P{_	Is_Shaw:=}');
    Expect(1, 66687, '\p{isshaw}', "");
    Expect(0, 66687, '\p{^isshaw}', "");
    Expect(0, 66687, '\P{isshaw}', "");
    Expect(1, 66687, '\P{^isshaw}', "");
    Expect(0, 66688, '\p{isshaw}', "");
    Expect(1, 66688, '\p{^isshaw}', "");
    Expect(1, 66688, '\P{isshaw}', "");
    Expect(0, 66688, '\P{^isshaw}', "");
    Expect(1, 66687, '\p{ _is_Shaw}', "");
    Expect(0, 66687, '\p{^ _is_Shaw}', "");
    Expect(0, 66687, '\P{ _is_Shaw}', "");
    Expect(1, 66687, '\P{^ _is_Shaw}', "");
    Expect(0, 66688, '\p{ _is_Shaw}', "");
    Expect(1, 66688, '\p{^ _is_Shaw}', "");
    Expect(1, 66688, '\P{ _is_Shaw}', "");
    Expect(0, 66688, '\P{^ _is_Shaw}', "");
    Error('\p{	:=SHORTHAND_Format_Controls}');
    Error('\P{	:=SHORTHAND_Format_Controls}');
    Expect(1, 113839, '\p{shorthandformatcontrols}', "");
    Expect(0, 113839, '\p{^shorthandformatcontrols}', "");
    Expect(0, 113839, '\P{shorthandformatcontrols}', "");
    Expect(1, 113839, '\P{^shorthandformatcontrols}', "");
    Expect(0, 113840, '\p{shorthandformatcontrols}', "");
    Expect(1, 113840, '\p{^shorthandformatcontrols}', "");
    Expect(1, 113840, '\P{shorthandformatcontrols}', "");
    Expect(0, 113840, '\P{^shorthandformatcontrols}', "");
    Expect(1, 113839, '\p{  Shorthand_FORMAT_Controls}', "");
    Expect(0, 113839, '\p{^  Shorthand_FORMAT_Controls}', "");
    Expect(0, 113839, '\P{  Shorthand_FORMAT_Controls}', "");
    Expect(1, 113839, '\P{^  Shorthand_FORMAT_Controls}', "");
    Expect(0, 113840, '\p{  Shorthand_FORMAT_Controls}', "");
    Expect(1, 113840, '\p{^  Shorthand_FORMAT_Controls}', "");
    Expect(1, 113840, '\P{  Shorthand_FORMAT_Controls}', "");
    Expect(0, 113840, '\P{^  Shorthand_FORMAT_Controls}', "");
    Error('\p{_:=Is_SHORTHAND_Format_controls}');
    Error('\P{_:=Is_SHORTHAND_Format_controls}');
    Expect(1, 113839, '\p{isshorthandformatcontrols}', "");
    Expect(0, 113839, '\p{^isshorthandformatcontrols}', "");
    Expect(0, 113839, '\P{isshorthandformatcontrols}', "");
    Expect(1, 113839, '\P{^isshorthandformatcontrols}', "");
    Expect(0, 113840, '\p{isshorthandformatcontrols}', "");
    Expect(1, 113840, '\p{^isshorthandformatcontrols}', "");
    Expect(1, 113840, '\P{isshorthandformatcontrols}', "");
    Expect(0, 113840, '\P{^isshorthandformatcontrols}', "");
    Expect(1, 113839, '\p{-Is_Shorthand_Format_Controls}', "");
    Expect(0, 113839, '\p{^-Is_Shorthand_Format_Controls}', "");
    Expect(0, 113839, '\P{-Is_Shorthand_Format_Controls}', "");
    Expect(1, 113839, '\P{^-Is_Shorthand_Format_Controls}', "");
    Expect(0, 113840, '\p{-Is_Shorthand_Format_Controls}', "");
    Expect(1, 113840, '\p{^-Is_Shorthand_Format_Controls}', "");
    Expect(1, 113840, '\P{-Is_Shorthand_Format_Controls}', "");
    Expect(0, 113840, '\P{^-Is_Shorthand_Format_Controls}', "");
    Error('\p{ /a/In_SHORTHAND_Format_controls}');
    Error('\P{ /a/In_SHORTHAND_Format_controls}');
    Expect(1, 113839, '\p{inshorthandformatcontrols}', "");
    Expect(0, 113839, '\p{^inshorthandformatcontrols}', "");
    Expect(0, 113839, '\P{inshorthandformatcontrols}', "");
    Expect(1, 113839, '\P{^inshorthandformatcontrols}', "");
    Expect(0, 113840, '\p{inshorthandformatcontrols}', "");
    Expect(1, 113840, '\p{^inshorthandformatcontrols}', "");
    Expect(1, 113840, '\P{inshorthandformatcontrols}', "");
    Expect(0, 113840, '\P{^inshorthandformatcontrols}', "");
    Expect(1, 113839, '\p{	 In_Shorthand_FORMAT_controls}', "");
    Expect(0, 113839, '\p{^	 In_Shorthand_FORMAT_controls}', "");
    Expect(0, 113839, '\P{	 In_Shorthand_FORMAT_controls}', "");
    Expect(1, 113839, '\P{^	 In_Shorthand_FORMAT_controls}', "");
    Expect(0, 113840, '\p{	 In_Shorthand_FORMAT_controls}', "");
    Expect(1, 113840, '\p{^	 In_Shorthand_FORMAT_controls}', "");
    Expect(1, 113840, '\P{	 In_Shorthand_FORMAT_controls}', "");
    Expect(0, 113840, '\P{^	 In_Shorthand_FORMAT_controls}', "");
    Error('\p{	:=SIDDHAM}');
    Error('\P{	:=SIDDHAM}');
    Expect(1, 71133, '\p{siddham}', "");
    Expect(0, 71133, '\p{^siddham}', "");
    Expect(0, 71133, '\P{siddham}', "");
    Expect(1, 71133, '\P{^siddham}', "");
    Expect(0, 71134, '\p{siddham}', "");
    Expect(1, 71134, '\p{^siddham}', "");
    Expect(1, 71134, '\P{siddham}', "");
    Expect(0, 71134, '\P{^siddham}', "");
    Expect(1, 71133, '\p{Siddham}', "");
    Expect(0, 71133, '\p{^Siddham}', "");
    Expect(0, 71133, '\P{Siddham}', "");
    Expect(1, 71133, '\P{^Siddham}', "");
    Expect(0, 71134, '\p{Siddham}', "");
    Expect(1, 71134, '\p{^Siddham}', "");
    Expect(1, 71134, '\P{Siddham}', "");
    Expect(0, 71134, '\P{^Siddham}', "");
    Error('\p{__is_Siddham/a/}');
    Error('\P{__is_Siddham/a/}');
    Expect(1, 71133, '\p{issiddham}', "");
    Expect(0, 71133, '\p{^issiddham}', "");
    Expect(0, 71133, '\P{issiddham}', "");
    Expect(1, 71133, '\P{^issiddham}', "");
    Expect(0, 71134, '\p{issiddham}', "");
    Expect(1, 71134, '\p{^issiddham}', "");
    Expect(1, 71134, '\P{issiddham}', "");
    Expect(0, 71134, '\P{^issiddham}', "");
    Expect(1, 71133, '\p{_is_siddham}', "");
    Expect(0, 71133, '\p{^_is_siddham}', "");
    Expect(0, 71133, '\P{_is_siddham}', "");
    Expect(1, 71133, '\P{^_is_siddham}', "");
    Expect(0, 71134, '\p{_is_siddham}', "");
    Expect(1, 71134, '\p{^_is_siddham}', "");
    Expect(1, 71134, '\P{_is_siddham}', "");
    Expect(0, 71134, '\P{^_is_siddham}', "");
    Error('\p{- SIDD/a/}');
    Error('\P{- SIDD/a/}');
    Expect(1, 71133, '\p{sidd}', "");
    Expect(0, 71133, '\p{^sidd}', "");
    Expect(0, 71133, '\P{sidd}', "");
    Expect(1, 71133, '\P{^sidd}', "");
    Expect(0, 71134, '\p{sidd}', "");
    Expect(1, 71134, '\p{^sidd}', "");
    Expect(1, 71134, '\P{sidd}', "");
    Expect(0, 71134, '\P{^sidd}', "");
    Expect(1, 71133, '\p{-Sidd}', "");
    Expect(0, 71133, '\p{^-Sidd}', "");
    Expect(0, 71133, '\P{-Sidd}', "");
    Expect(1, 71133, '\P{^-Sidd}', "");
    Expect(0, 71134, '\p{-Sidd}', "");
    Expect(1, 71134, '\p{^-Sidd}', "");
    Expect(1, 71134, '\P{-Sidd}', "");
    Expect(0, 71134, '\P{^-Sidd}', "");
    Error('\p{_/a/Is_Sidd}');
    Error('\P{_/a/Is_Sidd}');
    Expect(1, 71133, '\p{issidd}', "");
    Expect(0, 71133, '\p{^issidd}', "");
    Expect(0, 71133, '\P{issidd}', "");
    Expect(1, 71133, '\P{^issidd}', "");
    Expect(0, 71134, '\p{issidd}', "");
    Expect(1, 71134, '\p{^issidd}', "");
    Expect(1, 71134, '\P{issidd}', "");
    Expect(0, 71134, '\P{^issidd}', "");
    Expect(1, 71133, '\p{_Is_Sidd}', "");
    Expect(0, 71133, '\p{^_Is_Sidd}', "");
    Expect(0, 71133, '\P{_Is_Sidd}', "");
    Expect(1, 71133, '\P{^_Is_Sidd}', "");
    Expect(0, 71134, '\p{_Is_Sidd}', "");
    Expect(1, 71134, '\p{^_Is_Sidd}', "");
    Expect(1, 71134, '\P{_Is_Sidd}', "");
    Expect(0, 71134, '\P{^_Is_Sidd}', "");
    Error('\p{_SignWriting:=}');
    Error('\P{_SignWriting:=}');
    Expect(1, 121519, '\p{signwriting}', "");
    Expect(0, 121519, '\p{^signwriting}', "");
    Expect(0, 121519, '\P{signwriting}', "");
    Expect(1, 121519, '\P{^signwriting}', "");
    Expect(0, 121520, '\p{signwriting}', "");
    Expect(1, 121520, '\p{^signwriting}', "");
    Expect(1, 121520, '\P{signwriting}', "");
    Expect(0, 121520, '\P{^signwriting}', "");
    Expect(1, 121519, '\p{ SIGNWRITING}', "");
    Expect(0, 121519, '\p{^ SIGNWRITING}', "");
    Expect(0, 121519, '\P{ SIGNWRITING}', "");
    Expect(1, 121519, '\P{^ SIGNWRITING}', "");
    Expect(0, 121520, '\p{ SIGNWRITING}', "");
    Expect(1, 121520, '\p{^ SIGNWRITING}', "");
    Expect(1, 121520, '\P{ SIGNWRITING}', "");
    Expect(0, 121520, '\P{^ SIGNWRITING}', "");
    Error('\p{:=	_Is_signwriting}');
    Error('\P{:=	_Is_signwriting}');
    Expect(1, 121519, '\p{issignwriting}', "");
    Expect(0, 121519, '\p{^issignwriting}', "");
    Expect(0, 121519, '\P{issignwriting}', "");
    Expect(1, 121519, '\P{^issignwriting}', "");
    Expect(0, 121520, '\p{issignwriting}', "");
    Expect(1, 121520, '\p{^issignwriting}', "");
    Expect(1, 121520, '\P{issignwriting}', "");
    Expect(0, 121520, '\P{^issignwriting}', "");
    Expect(1, 121519, '\p{  is_SignWriting}', "");
    Expect(0, 121519, '\p{^  is_SignWriting}', "");
    Expect(0, 121519, '\P{  is_SignWriting}', "");
    Expect(1, 121519, '\P{^  is_SignWriting}', "");
    Expect(0, 121520, '\p{  is_SignWriting}', "");
    Expect(1, 121520, '\p{^  is_SignWriting}', "");
    Expect(1, 121520, '\P{  is_SignWriting}', "");
    Expect(0, 121520, '\P{^  is_SignWriting}', "");
    Error('\p{:=-Sgnw}');
    Error('\P{:=-Sgnw}');
    Expect(1, 121519, '\p{sgnw}', "");
    Expect(0, 121519, '\p{^sgnw}', "");
    Expect(0, 121519, '\P{sgnw}', "");
    Expect(1, 121519, '\P{^sgnw}', "");
    Expect(0, 121520, '\p{sgnw}', "");
    Expect(1, 121520, '\p{^sgnw}', "");
    Expect(1, 121520, '\P{sgnw}', "");
    Expect(0, 121520, '\P{^sgnw}', "");
    Expect(1, 121519, '\p{_sgnw}', "");
    Expect(0, 121519, '\p{^_sgnw}', "");
    Expect(0, 121519, '\P{_sgnw}', "");
    Expect(1, 121519, '\P{^_sgnw}', "");
    Expect(0, 121520, '\p{_sgnw}', "");
    Expect(1, 121520, '\p{^_sgnw}', "");
    Expect(1, 121520, '\P{_sgnw}', "");
    Expect(0, 121520, '\P{^_sgnw}', "");
    Error('\p{/a/	 is_sgnw}');
    Error('\P{/a/	 is_sgnw}');
    Expect(1, 121519, '\p{issgnw}', "");
    Expect(0, 121519, '\p{^issgnw}', "");
    Expect(0, 121519, '\P{issgnw}', "");
    Expect(1, 121519, '\P{^issgnw}', "");
    Expect(0, 121520, '\p{issgnw}', "");
    Expect(1, 121520, '\p{^issgnw}', "");
    Expect(1, 121520, '\P{issgnw}', "");
    Expect(0, 121520, '\P{^issgnw}', "");
    Expect(1, 121519, '\p{_is_sgnw}', "");
    Expect(0, 121519, '\p{^_is_sgnw}', "");
    Expect(0, 121519, '\P{_is_sgnw}', "");
    Expect(1, 121519, '\P{^_is_sgnw}', "");
    Expect(0, 121520, '\p{_is_sgnw}', "");
    Expect(1, 121520, '\p{^_is_sgnw}', "");
    Expect(1, 121520, '\P{_is_sgnw}', "");
    Expect(0, 121520, '\P{^_is_sgnw}', "");
    Error('\p{/a/-	sinhala}');
    Error('\P{/a/-	sinhala}');
    Expect(1, 70132, '\p{sinhala}', "");
    Expect(0, 70132, '\p{^sinhala}', "");
    Expect(0, 70132, '\P{sinhala}', "");
    Expect(1, 70132, '\P{^sinhala}', "");
    Expect(0, 70133, '\p{sinhala}', "");
    Expect(1, 70133, '\p{^sinhala}', "");
    Expect(1, 70133, '\P{sinhala}', "");
    Expect(0, 70133, '\P{^sinhala}', "");
    Expect(1, 70132, '\p{_Sinhala}', "");
    Expect(0, 70132, '\p{^_Sinhala}', "");
    Expect(0, 70132, '\P{_Sinhala}', "");
    Expect(1, 70132, '\P{^_Sinhala}', "");
    Expect(0, 70133, '\p{_Sinhala}', "");
    Expect(1, 70133, '\p{^_Sinhala}', "");
    Expect(1, 70133, '\P{_Sinhala}', "");
    Expect(0, 70133, '\P{^_Sinhala}', "");
    Error('\p{:=is_sinhala}');
    Error('\P{:=is_sinhala}');
    Expect(1, 70132, '\p{issinhala}', "");
    Expect(0, 70132, '\p{^issinhala}', "");
    Expect(0, 70132, '\P{issinhala}', "");
    Expect(1, 70132, '\P{^issinhala}', "");
    Expect(0, 70133, '\p{issinhala}', "");
    Expect(1, 70133, '\p{^issinhala}', "");
    Expect(1, 70133, '\P{issinhala}', "");
    Expect(0, 70133, '\P{^issinhala}', "");
    Expect(1, 70132, '\p{__is_Sinhala}', "");
    Expect(0, 70132, '\p{^__is_Sinhala}', "");
    Expect(0, 70132, '\P{__is_Sinhala}', "");
    Expect(1, 70132, '\P{^__is_Sinhala}', "");
    Expect(0, 70133, '\p{__is_Sinhala}', "");
    Expect(1, 70133, '\p{^__is_Sinhala}', "");
    Expect(1, 70133, '\P{__is_Sinhala}', "");
    Expect(0, 70133, '\P{^__is_Sinhala}', "");
    Error('\p{_	sinh:=}');
    Error('\P{_	sinh:=}');
    Expect(1, 70132, '\p{sinh}', "");
    Expect(0, 70132, '\p{^sinh}', "");
    Expect(0, 70132, '\P{sinh}', "");
    Expect(1, 70132, '\P{^sinh}', "");
    Expect(0, 70133, '\p{sinh}', "");
    Expect(1, 70133, '\p{^sinh}', "");
    Expect(1, 70133, '\P{sinh}', "");
    Expect(0, 70133, '\P{^sinh}', "");
    Expect(1, 70132, '\p{- Sinh}', "");
    Expect(0, 70132, '\p{^- Sinh}', "");
    Expect(0, 70132, '\P{- Sinh}', "");
    Expect(1, 70132, '\P{^- Sinh}', "");
    Expect(0, 70133, '\p{- Sinh}', "");
    Expect(1, 70133, '\p{^- Sinh}', "");
    Expect(1, 70133, '\P{- Sinh}', "");
    Expect(0, 70133, '\P{^- Sinh}', "");
    Error('\p{_/a/Is_SINH}');
    Error('\P{_/a/Is_SINH}');
    Expect(1, 70132, '\p{issinh}', "");
    Expect(0, 70132, '\p{^issinh}', "");
    Expect(0, 70132, '\P{issinh}', "");
    Expect(1, 70132, '\P{^issinh}', "");
    Expect(0, 70133, '\p{issinh}', "");
    Expect(1, 70133, '\p{^issinh}', "");
    Expect(1, 70133, '\P{issinh}', "");
    Expect(0, 70133, '\P{^issinh}', "");
    Expect(1, 70132, '\p{__Is_Sinh}', "");
    Expect(0, 70132, '\p{^__Is_Sinh}', "");
    Expect(0, 70132, '\P{__Is_Sinh}', "");
    Expect(1, 70132, '\P{^__Is_Sinh}', "");
    Expect(0, 70133, '\p{__Is_Sinh}', "");
    Expect(1, 70133, '\p{^__Is_Sinh}', "");
    Expect(1, 70133, '\P{__Is_Sinh}', "");
    Expect(0, 70133, '\P{^__Is_Sinh}', "");
    Error('\p{--Sinhala_archaic_NUMBERS/a/}');
    Error('\P{--Sinhala_archaic_NUMBERS/a/}');
    Expect(1, 70143, '\p{sinhalaarchaicnumbers}', "");
    Expect(0, 70143, '\p{^sinhalaarchaicnumbers}', "");
    Expect(0, 70143, '\P{sinhalaarchaicnumbers}', "");
    Expect(1, 70143, '\P{^sinhalaarchaicnumbers}', "");
    Expect(0, 70144, '\p{sinhalaarchaicnumbers}', "");
    Expect(1, 70144, '\p{^sinhalaarchaicnumbers}', "");
    Expect(1, 70144, '\P{sinhalaarchaicnumbers}', "");
    Expect(0, 70144, '\P{^sinhalaarchaicnumbers}', "");
    Expect(1, 70143, '\p{ 	Sinhala_Archaic_Numbers}', "");
    Expect(0, 70143, '\p{^ 	Sinhala_Archaic_Numbers}', "");
    Expect(0, 70143, '\P{ 	Sinhala_Archaic_Numbers}', "");
    Expect(1, 70143, '\P{^ 	Sinhala_Archaic_Numbers}', "");
    Expect(0, 70144, '\p{ 	Sinhala_Archaic_Numbers}', "");
    Expect(1, 70144, '\p{^ 	Sinhala_Archaic_Numbers}', "");
    Expect(1, 70144, '\P{ 	Sinhala_Archaic_Numbers}', "");
    Expect(0, 70144, '\P{^ 	Sinhala_Archaic_Numbers}', "");
    Error('\p{	:=IS_sinhala_Archaic_Numbers}');
    Error('\P{	:=IS_sinhala_Archaic_Numbers}');
    Expect(1, 70143, '\p{issinhalaarchaicnumbers}', "");
    Expect(0, 70143, '\p{^issinhalaarchaicnumbers}', "");
    Expect(0, 70143, '\P{issinhalaarchaicnumbers}', "");
    Expect(1, 70143, '\P{^issinhalaarchaicnumbers}', "");
    Expect(0, 70144, '\p{issinhalaarchaicnumbers}', "");
    Expect(1, 70144, '\p{^issinhalaarchaicnumbers}', "");
    Expect(1, 70144, '\P{issinhalaarchaicnumbers}', "");
    Expect(0, 70144, '\P{^issinhalaarchaicnumbers}', "");
    Expect(1, 70143, '\p{_ IS_sinhala_ARCHAIC_Numbers}', "");
    Expect(0, 70143, '\p{^_ IS_sinhala_ARCHAIC_Numbers}', "");
    Expect(0, 70143, '\P{_ IS_sinhala_ARCHAIC_Numbers}', "");
    Expect(1, 70143, '\P{^_ IS_sinhala_ARCHAIC_Numbers}', "");
    Expect(0, 70144, '\p{_ IS_sinhala_ARCHAIC_Numbers}', "");
    Expect(1, 70144, '\p{^_ IS_sinhala_ARCHAIC_Numbers}', "");
    Expect(1, 70144, '\P{_ IS_sinhala_ARCHAIC_Numbers}', "");
    Expect(0, 70144, '\P{^_ IS_sinhala_ARCHAIC_Numbers}', "");
    Error('\p{		In_sinhala_Archaic_NUMBERS/a/}');
    Error('\P{		In_sinhala_Archaic_NUMBERS/a/}');
    Expect(1, 70143, '\p{insinhalaarchaicnumbers}', "");
    Expect(0, 70143, '\p{^insinhalaarchaicnumbers}', "");
    Expect(0, 70143, '\P{insinhalaarchaicnumbers}', "");
    Expect(1, 70143, '\P{^insinhalaarchaicnumbers}', "");
    Expect(0, 70144, '\p{insinhalaarchaicnumbers}', "");
    Expect(1, 70144, '\p{^insinhalaarchaicnumbers}', "");
    Expect(1, 70144, '\P{insinhalaarchaicnumbers}', "");
    Expect(0, 70144, '\P{^insinhalaarchaicnumbers}', "");
    Expect(1, 70143, '\p{In_Sinhala_ARCHAIC_numbers}', "");
    Expect(0, 70143, '\p{^In_Sinhala_ARCHAIC_numbers}', "");
    Expect(0, 70143, '\P{In_Sinhala_ARCHAIC_numbers}', "");
    Expect(1, 70143, '\P{^In_Sinhala_ARCHAIC_numbers}', "");
    Expect(0, 70144, '\p{In_Sinhala_ARCHAIC_numbers}', "");
    Expect(1, 70144, '\p{^In_Sinhala_ARCHAIC_numbers}', "");
    Expect(1, 70144, '\P{In_Sinhala_ARCHAIC_numbers}', "");
    Expect(0, 70144, '\P{^In_Sinhala_ARCHAIC_numbers}', "");
    Error('\p{/a/	 small_form_variants}');
    Error('\P{/a/	 small_form_variants}');
    Expect(1, 65135, '\p{smallformvariants}', "");
    Expect(0, 65135, '\p{^smallformvariants}', "");
    Expect(0, 65135, '\P{smallformvariants}', "");
    Expect(1, 65135, '\P{^smallformvariants}', "");
    Expect(0, 65136, '\p{smallformvariants}', "");
    Expect(1, 65136, '\p{^smallformvariants}', "");
    Expect(1, 65136, '\P{smallformvariants}', "");
    Expect(0, 65136, '\P{^smallformvariants}', "");
    Expect(1, 65135, '\p{ 	small_form_variants}', "");
    Expect(0, 65135, '\p{^ 	small_form_variants}', "");
    Expect(0, 65135, '\P{ 	small_form_variants}', "");
    Expect(1, 65135, '\P{^ 	small_form_variants}', "");
    Expect(0, 65136, '\p{ 	small_form_variants}', "");
    Expect(1, 65136, '\p{^ 	small_form_variants}', "");
    Expect(1, 65136, '\P{ 	small_form_variants}', "");
    Expect(0, 65136, '\P{^ 	small_form_variants}', "");
    Error('\p{/a/__IS_small_form_VARIANTS}');
    Error('\P{/a/__IS_small_form_VARIANTS}');
    Expect(1, 65135, '\p{issmallformvariants}', "");
    Expect(0, 65135, '\p{^issmallformvariants}', "");
    Expect(0, 65135, '\P{issmallformvariants}', "");
    Expect(1, 65135, '\P{^issmallformvariants}', "");
    Expect(0, 65136, '\p{issmallformvariants}', "");
    Expect(1, 65136, '\p{^issmallformvariants}', "");
    Expect(1, 65136, '\P{issmallformvariants}', "");
    Expect(0, 65136, '\P{^issmallformvariants}', "");
    Expect(1, 65135, '\p{-Is_Small_FORM_Variants}', "");
    Expect(0, 65135, '\p{^-Is_Small_FORM_Variants}', "");
    Expect(0, 65135, '\P{-Is_Small_FORM_Variants}', "");
    Expect(1, 65135, '\P{^-Is_Small_FORM_Variants}', "");
    Expect(0, 65136, '\p{-Is_Small_FORM_Variants}', "");
    Expect(1, 65136, '\p{^-Is_Small_FORM_Variants}', "");
    Expect(1, 65136, '\P{-Is_Small_FORM_Variants}', "");
    Expect(0, 65136, '\P{^-Is_Small_FORM_Variants}', "");
    Error('\p{ In_Small_FORM_VARIANTS:=}');
    Error('\P{ In_Small_FORM_VARIANTS:=}');
    Expect(1, 65135, '\p{insmallformvariants}', "");
    Expect(0, 65135, '\p{^insmallformvariants}', "");
    Expect(0, 65135, '\P{insmallformvariants}', "");
    Expect(1, 65135, '\P{^insmallformvariants}', "");
    Expect(0, 65136, '\p{insmallformvariants}', "");
    Expect(1, 65136, '\p{^insmallformvariants}', "");
    Expect(1, 65136, '\P{insmallformvariants}', "");
    Expect(0, 65136, '\P{^insmallformvariants}', "");
    Expect(1, 65135, '\p{		in_SMALL_Form_Variants}', "");
    Expect(0, 65135, '\p{^		in_SMALL_Form_Variants}', "");
    Expect(0, 65135, '\P{		in_SMALL_Form_Variants}', "");
    Expect(1, 65135, '\P{^		in_SMALL_Form_Variants}', "");
    Expect(0, 65136, '\p{		in_SMALL_Form_Variants}', "");
    Expect(1, 65136, '\p{^		in_SMALL_Form_Variants}', "");
    Expect(1, 65136, '\P{		in_SMALL_Form_Variants}', "");
    Expect(0, 65136, '\P{^		in_SMALL_Form_Variants}', "");
    Error('\p{:= SMALL_Forms}');
    Error('\P{:= SMALL_Forms}');
    Expect(1, 65135, '\p{smallforms}', "");
    Expect(0, 65135, '\p{^smallforms}', "");
    Expect(0, 65135, '\P{smallforms}', "");
    Expect(1, 65135, '\P{^smallforms}', "");
    Expect(0, 65136, '\p{smallforms}', "");
    Expect(1, 65136, '\p{^smallforms}', "");
    Expect(1, 65136, '\P{smallforms}', "");
    Expect(0, 65136, '\P{^smallforms}', "");
    Expect(1, 65135, '\p{	Small_Forms}', "");
    Expect(0, 65135, '\p{^	Small_Forms}', "");
    Expect(0, 65135, '\P{	Small_Forms}', "");
    Expect(1, 65135, '\P{^	Small_Forms}', "");
    Expect(0, 65136, '\p{	Small_Forms}', "");
    Expect(1, 65136, '\p{^	Small_Forms}', "");
    Expect(1, 65136, '\P{	Small_Forms}', "");
    Expect(0, 65136, '\P{^	Small_Forms}', "");
    Error('\p{/a/--IS_small_Forms}');
    Error('\P{/a/--IS_small_Forms}');
    Expect(1, 65135, '\p{issmallforms}', "");
    Expect(0, 65135, '\p{^issmallforms}', "");
    Expect(0, 65135, '\P{issmallforms}', "");
    Expect(1, 65135, '\P{^issmallforms}', "");
    Expect(0, 65136, '\p{issmallforms}', "");
    Expect(1, 65136, '\p{^issmallforms}', "");
    Expect(1, 65136, '\P{issmallforms}', "");
    Expect(0, 65136, '\P{^issmallforms}', "");
    Expect(1, 65135, '\p{	_Is_Small_Forms}', "");
    Expect(0, 65135, '\p{^	_Is_Small_Forms}', "");
    Expect(0, 65135, '\P{	_Is_Small_Forms}', "");
    Expect(1, 65135, '\P{^	_Is_Small_Forms}', "");
    Expect(0, 65136, '\p{	_Is_Small_Forms}', "");
    Expect(1, 65136, '\p{^	_Is_Small_Forms}', "");
    Expect(1, 65136, '\P{	_Is_Small_Forms}', "");
    Expect(0, 65136, '\P{^	_Is_Small_Forms}', "");
    Error('\p{:=_	In_SMALL_Forms}');
    Error('\P{:=_	In_SMALL_Forms}');
    Expect(1, 65135, '\p{insmallforms}', "");
    Expect(0, 65135, '\p{^insmallforms}', "");
    Expect(0, 65135, '\P{insmallforms}', "");
    Expect(1, 65135, '\P{^insmallforms}', "");
    Expect(0, 65136, '\p{insmallforms}', "");
    Expect(1, 65136, '\p{^insmallforms}', "");
    Expect(1, 65136, '\P{insmallforms}', "");
    Expect(0, 65136, '\P{^insmallforms}', "");
    Expect(1, 65135, '\p{_In_SMALL_Forms}', "");
    Expect(0, 65135, '\p{^_In_SMALL_Forms}', "");
    Expect(0, 65135, '\P{_In_SMALL_Forms}', "");
    Expect(1, 65135, '\P{^_In_SMALL_Forms}', "");
    Expect(0, 65136, '\p{_In_SMALL_Forms}', "");
    Expect(1, 65136, '\p{^_In_SMALL_Forms}', "");
    Expect(1, 65136, '\P{_In_SMALL_Forms}', "");
    Expect(0, 65136, '\P{^_In_SMALL_Forms}', "");
    Error('\p{_:=Small_KANA_Extension}');
    Error('\P{_:=Small_KANA_Extension}');
    Expect(1, 110959, '\p{smallkanaextension}', "");
    Expect(0, 110959, '\p{^smallkanaextension}', "");
    Expect(0, 110959, '\P{smallkanaextension}', "");
    Expect(1, 110959, '\P{^smallkanaextension}', "");
    Expect(0, 110960, '\p{smallkanaextension}', "");
    Expect(1, 110960, '\p{^smallkanaextension}', "");
    Expect(1, 110960, '\P{smallkanaextension}', "");
    Expect(0, 110960, '\P{^smallkanaextension}', "");
    Expect(1, 110959, '\p{	-small_KANA_EXTENSION}', "");
    Expect(0, 110959, '\p{^	-small_KANA_EXTENSION}', "");
    Expect(0, 110959, '\P{	-small_KANA_EXTENSION}', "");
    Expect(1, 110959, '\P{^	-small_KANA_EXTENSION}', "");
    Expect(0, 110960, '\p{	-small_KANA_EXTENSION}', "");
    Expect(1, 110960, '\p{^	-small_KANA_EXTENSION}', "");
    Expect(1, 110960, '\P{	-small_KANA_EXTENSION}', "");
    Expect(0, 110960, '\P{^	-small_KANA_EXTENSION}', "");
    Error('\p{--is_SMALL_Kana_extension:=}');
    Error('\P{--is_SMALL_Kana_extension:=}');
    Expect(1, 110959, '\p{issmallkanaextension}', "");
    Expect(0, 110959, '\p{^issmallkanaextension}', "");
    Expect(0, 110959, '\P{issmallkanaextension}', "");
    Expect(1, 110959, '\P{^issmallkanaextension}', "");
    Expect(0, 110960, '\p{issmallkanaextension}', "");
    Expect(1, 110960, '\p{^issmallkanaextension}', "");
    Expect(1, 110960, '\P{issmallkanaextension}', "");
    Expect(0, 110960, '\P{^issmallkanaextension}', "");
    Expect(1, 110959, '\p{__Is_Small_kana_EXTENSION}', "");
    Expect(0, 110959, '\p{^__Is_Small_kana_EXTENSION}', "");
    Expect(0, 110959, '\P{__Is_Small_kana_EXTENSION}', "");
    Expect(1, 110959, '\P{^__Is_Small_kana_EXTENSION}', "");
    Expect(0, 110960, '\p{__Is_Small_kana_EXTENSION}', "");
    Expect(1, 110960, '\p{^__Is_Small_kana_EXTENSION}', "");
    Expect(1, 110960, '\P{__Is_Small_kana_EXTENSION}', "");
    Expect(0, 110960, '\P{^__Is_Small_kana_EXTENSION}', "");
    Error('\p{:= In_SMALL_Kana_Extension}');
    Error('\P{:= In_SMALL_Kana_Extension}');
    Expect(1, 110959, '\p{insmallkanaextension}', "");
    Expect(0, 110959, '\p{^insmallkanaextension}', "");
    Expect(0, 110959, '\P{insmallkanaextension}', "");
    Expect(1, 110959, '\P{^insmallkanaextension}', "");
    Expect(0, 110960, '\p{insmallkanaextension}', "");
    Expect(1, 110960, '\p{^insmallkanaextension}', "");
    Expect(1, 110960, '\P{insmallkanaextension}', "");
    Expect(0, 110960, '\P{^insmallkanaextension}', "");
    Expect(1, 110959, '\p{	-In_SMALL_Kana_Extension}', "");
    Expect(0, 110959, '\p{^	-In_SMALL_Kana_Extension}', "");
    Expect(0, 110959, '\P{	-In_SMALL_Kana_Extension}', "");
    Expect(1, 110959, '\P{^	-In_SMALL_Kana_Extension}', "");
    Expect(0, 110960, '\p{	-In_SMALL_Kana_Extension}', "");
    Expect(1, 110960, '\p{^	-In_SMALL_Kana_Extension}', "");
    Expect(1, 110960, '\P{	-In_SMALL_Kana_Extension}', "");
    Expect(0, 110960, '\P{^	-In_SMALL_Kana_Extension}', "");
    Error('\p{ :=Small_Kana_Ext}');
    Error('\P{ :=Small_Kana_Ext}');
    Expect(1, 110959, '\p{smallkanaext}', "");
    Expect(0, 110959, '\p{^smallkanaext}', "");
    Expect(0, 110959, '\P{smallkanaext}', "");
    Expect(1, 110959, '\P{^smallkanaext}', "");
    Expect(0, 110960, '\p{smallkanaext}', "");
    Expect(1, 110960, '\p{^smallkanaext}', "");
    Expect(1, 110960, '\P{smallkanaext}', "");
    Expect(0, 110960, '\P{^smallkanaext}', "");
    Expect(1, 110959, '\p{Small_KANA_Ext}', "");
    Expect(0, 110959, '\p{^Small_KANA_Ext}', "");
    Expect(0, 110959, '\P{Small_KANA_Ext}', "");
    Expect(1, 110959, '\P{^Small_KANA_Ext}', "");
    Expect(0, 110960, '\p{Small_KANA_Ext}', "");
    Expect(1, 110960, '\p{^Small_KANA_Ext}', "");
    Expect(1, 110960, '\P{Small_KANA_Ext}', "");
    Expect(0, 110960, '\P{^Small_KANA_Ext}', "");
    Error('\p{/a/IS_Small_KANA_EXT}');
    Error('\P{/a/IS_Small_KANA_EXT}');
    Expect(1, 110959, '\p{issmallkanaext}', "");
    Expect(0, 110959, '\p{^issmallkanaext}', "");
    Expect(0, 110959, '\P{issmallkanaext}', "");
    Expect(1, 110959, '\P{^issmallkanaext}', "");
    Expect(0, 110960, '\p{issmallkanaext}', "");
    Expect(1, 110960, '\p{^issmallkanaext}', "");
    Expect(1, 110960, '\P{issmallkanaext}', "");
    Expect(0, 110960, '\P{^issmallkanaext}', "");
    Expect(1, 110959, '\p{ Is_SMALL_Kana_ext}', "");
    Expect(0, 110959, '\p{^ Is_SMALL_Kana_ext}', "");
    Expect(0, 110959, '\P{ Is_SMALL_Kana_ext}', "");
    Expect(1, 110959, '\P{^ Is_SMALL_Kana_ext}', "");
    Expect(0, 110960, '\p{ Is_SMALL_Kana_ext}', "");
    Expect(1, 110960, '\p{^ Is_SMALL_Kana_ext}', "");
    Expect(1, 110960, '\P{ Is_SMALL_Kana_ext}', "");
    Expect(0, 110960, '\P{^ Is_SMALL_Kana_ext}', "");
    Error('\p{	-In_SMALL_Kana_Ext/a/}');
    Error('\P{	-In_SMALL_Kana_Ext/a/}');
    Expect(1, 110959, '\p{insmallkanaext}', "");
    Expect(0, 110959, '\p{^insmallkanaext}', "");
    Expect(0, 110959, '\P{insmallkanaext}', "");
    Expect(1, 110959, '\P{^insmallkanaext}', "");
    Expect(0, 110960, '\p{insmallkanaext}', "");
    Expect(1, 110960, '\p{^insmallkanaext}', "");
    Expect(1, 110960, '\P{insmallkanaext}', "");
    Expect(0, 110960, '\P{^insmallkanaext}', "");
    Expect(1, 110959, '\p{	In_Small_KANA_Ext}', "");
    Expect(0, 110959, '\p{^	In_Small_KANA_Ext}', "");
    Expect(0, 110959, '\P{	In_Small_KANA_Ext}', "");
    Expect(1, 110959, '\P{^	In_Small_KANA_Ext}', "");
    Expect(0, 110960, '\p{	In_Small_KANA_Ext}', "");
    Expect(1, 110960, '\p{^	In_Small_KANA_Ext}', "");
    Expect(1, 110960, '\P{	In_Small_KANA_Ext}', "");
    Expect(0, 110960, '\P{^	In_Small_KANA_Ext}', "");
    Error('\p{-	Soft_Dotted:=}');
    Error('\P{-	Soft_Dotted:=}');
    Expect(1, 120467, '\p{softdotted}', "");
    Expect(0, 120467, '\p{^softdotted}', "");
    Expect(0, 120467, '\P{softdotted}', "");
    Expect(1, 120467, '\P{^softdotted}', "");
    Expect(0, 120468, '\p{softdotted}', "");
    Expect(1, 120468, '\p{^softdotted}', "");
    Expect(1, 120468, '\P{softdotted}', "");
    Expect(0, 120468, '\P{^softdotted}', "");
    Expect(1, 120467, '\p{- soft_Dotted}', "");
    Expect(0, 120467, '\p{^- soft_Dotted}', "");
    Expect(0, 120467, '\P{- soft_Dotted}', "");
    Expect(1, 120467, '\P{^- soft_Dotted}', "");
    Expect(0, 120468, '\p{- soft_Dotted}', "");
    Expect(1, 120468, '\p{^- soft_Dotted}', "");
    Expect(1, 120468, '\P{- soft_Dotted}', "");
    Expect(0, 120468, '\P{^- soft_Dotted}', "");
    Error('\p{__is_Soft_DOTTED:=}');
    Error('\P{__is_Soft_DOTTED:=}');
    Expect(1, 120467, '\p{issoftdotted}', "");
    Expect(0, 120467, '\p{^issoftdotted}', "");
    Expect(0, 120467, '\P{issoftdotted}', "");
    Expect(1, 120467, '\P{^issoftdotted}', "");
    Expect(0, 120468, '\p{issoftdotted}', "");
    Expect(1, 120468, '\p{^issoftdotted}', "");
    Expect(1, 120468, '\P{issoftdotted}', "");
    Expect(0, 120468, '\P{^issoftdotted}', "");
    Expect(1, 120467, '\p{_ Is_SOFT_Dotted}', "");
    Expect(0, 120467, '\p{^_ Is_SOFT_Dotted}', "");
    Expect(0, 120467, '\P{_ Is_SOFT_Dotted}', "");
    Expect(1, 120467, '\P{^_ Is_SOFT_Dotted}', "");
    Expect(0, 120468, '\p{_ Is_SOFT_Dotted}', "");
    Expect(1, 120468, '\p{^_ Is_SOFT_Dotted}', "");
    Expect(1, 120468, '\P{_ Is_SOFT_Dotted}', "");
    Expect(0, 120468, '\P{^_ Is_SOFT_Dotted}', "");
    Error('\p{ 	sd/a/}');
    Error('\P{ 	sd/a/}');
    Expect(1, 120467, '\p{sd}', "");
    Expect(0, 120467, '\p{^sd}', "");
    Expect(0, 120467, '\P{sd}', "");
    Expect(1, 120467, '\P{^sd}', "");
    Expect(0, 120468, '\p{sd}', "");
    Expect(1, 120468, '\p{^sd}', "");
    Expect(1, 120468, '\P{sd}', "");
    Expect(0, 120468, '\P{^sd}', "");
    Expect(1, 120467, '\p{_	sd}', "");
    Expect(0, 120467, '\p{^_	sd}', "");
    Expect(0, 120467, '\P{_	sd}', "");
    Expect(1, 120467, '\P{^_	sd}', "");
    Expect(0, 120468, '\p{_	sd}', "");
    Expect(1, 120468, '\p{^_	sd}', "");
    Expect(1, 120468, '\P{_	sd}', "");
    Expect(0, 120468, '\P{^_	sd}', "");
    Error('\p{_-Is_SD:=}');
    Error('\P{_-Is_SD:=}');
    Expect(1, 120467, '\p{issd}', "");
    Expect(0, 120467, '\p{^issd}', "");
    Expect(0, 120467, '\P{issd}', "");
    Expect(1, 120467, '\P{^issd}', "");
    Expect(0, 120468, '\p{issd}', "");
    Expect(1, 120468, '\p{^issd}', "");
    Expect(1, 120468, '\P{issd}', "");
    Expect(0, 120468, '\P{^issd}', "");
    Expect(1, 120467, '\p{	_Is_sd}', "");
    Expect(0, 120467, '\p{^	_Is_sd}', "");
    Expect(0, 120467, '\P{	_Is_sd}', "");
    Expect(1, 120467, '\P{^	_Is_sd}', "");
    Expect(0, 120468, '\p{	_Is_sd}', "");
    Expect(1, 120468, '\p{^	_Is_sd}', "");
    Expect(1, 120468, '\P{	_Is_sd}', "");
    Expect(0, 120468, '\P{^	_Is_sd}', "");
    Error('\p{-_SOGDIAN/a/}');
    Error('\P{-_SOGDIAN/a/}');
    Expect(1, 69465, '\p{sogdian}', "");
    Expect(0, 69465, '\p{^sogdian}', "");
    Expect(0, 69465, '\P{sogdian}', "");
    Expect(1, 69465, '\P{^sogdian}', "");
    Expect(0, 69466, '\p{sogdian}', "");
    Expect(1, 69466, '\p{^sogdian}', "");
    Expect(1, 69466, '\P{sogdian}', "");
    Expect(0, 69466, '\P{^sogdian}', "");
    Expect(1, 69465, '\p{- sogdian}', "");
    Expect(0, 69465, '\p{^- sogdian}', "");
    Expect(0, 69465, '\P{- sogdian}', "");
    Expect(1, 69465, '\P{^- sogdian}', "");
    Expect(0, 69466, '\p{- sogdian}', "");
    Expect(1, 69466, '\p{^- sogdian}', "");
    Expect(1, 69466, '\P{- sogdian}', "");
    Expect(0, 69466, '\P{^- sogdian}', "");
    Error('\p{ -Is_SOGDIAN:=}');
    Error('\P{ -Is_SOGDIAN:=}');
    Expect(1, 69465, '\p{issogdian}', "");
    Expect(0, 69465, '\p{^issogdian}', "");
    Expect(0, 69465, '\P{issogdian}', "");
    Expect(1, 69465, '\P{^issogdian}', "");
    Expect(0, 69466, '\p{issogdian}', "");
    Expect(1, 69466, '\p{^issogdian}', "");
    Expect(1, 69466, '\P{issogdian}', "");
    Expect(0, 69466, '\P{^issogdian}', "");
    Expect(1, 69465, '\p{  is_Sogdian}', "");
    Expect(0, 69465, '\p{^  is_Sogdian}', "");
    Expect(0, 69465, '\P{  is_Sogdian}', "");
    Expect(1, 69465, '\P{^  is_Sogdian}', "");
    Expect(0, 69466, '\p{  is_Sogdian}', "");
    Expect(1, 69466, '\p{^  is_Sogdian}', "");
    Expect(1, 69466, '\P{  is_Sogdian}', "");
    Expect(0, 69466, '\P{^  is_Sogdian}', "");
    Error('\p{  Sogd:=}');
    Error('\P{  Sogd:=}');
    Expect(1, 69465, '\p{sogd}', "");
    Expect(0, 69465, '\p{^sogd}', "");
    Expect(0, 69465, '\P{sogd}', "");
    Expect(1, 69465, '\P{^sogd}', "");
    Expect(0, 69466, '\p{sogd}', "");
    Expect(1, 69466, '\p{^sogd}', "");
    Expect(1, 69466, '\P{sogd}', "");
    Expect(0, 69466, '\P{^sogd}', "");
    Expect(1, 69465, '\p{		SOGD}', "");
    Expect(0, 69465, '\p{^		SOGD}', "");
    Expect(0, 69465, '\P{		SOGD}', "");
    Expect(1, 69465, '\P{^		SOGD}', "");
    Expect(0, 69466, '\p{		SOGD}', "");
    Expect(1, 69466, '\p{^		SOGD}', "");
    Expect(1, 69466, '\P{		SOGD}', "");
    Expect(0, 69466, '\P{^		SOGD}', "");
    Error('\p{ _Is_Sogd/a/}');
    Error('\P{ _Is_Sogd/a/}');
    Expect(1, 69465, '\p{issogd}', "");
    Expect(0, 69465, '\p{^issogd}', "");
    Expect(0, 69465, '\P{issogd}', "");
    Expect(1, 69465, '\P{^issogd}', "");
    Expect(0, 69466, '\p{issogd}', "");
    Expect(1, 69466, '\p{^issogd}', "");
    Expect(1, 69466, '\P{issogd}', "");
    Expect(0, 69466, '\P{^issogd}', "");
    Expect(1, 69465, '\p{ IS_sogd}', "");
    Expect(0, 69465, '\p{^ IS_sogd}', "");
    Expect(0, 69465, '\P{ IS_sogd}', "");
    Expect(1, 69465, '\P{^ IS_sogd}', "");
    Expect(0, 69466, '\p{ IS_sogd}', "");
    Expect(1, 69466, '\p{^ IS_sogd}', "");
    Expect(1, 69466, '\P{ IS_sogd}', "");
    Expect(0, 69466, '\P{^ IS_sogd}', "");
    Error('\p{:= _sora_Sompeng}');
    Error('\P{:= _sora_Sompeng}');
    Expect(1, 69881, '\p{sorasompeng}', "");
    Expect(0, 69881, '\p{^sorasompeng}', "");
    Expect(0, 69881, '\P{sorasompeng}', "");
    Expect(1, 69881, '\P{^sorasompeng}', "");
    Expect(0, 69882, '\p{sorasompeng}', "");
    Expect(1, 69882, '\p{^sorasompeng}', "");
    Expect(1, 69882, '\P{sorasompeng}', "");
    Expect(0, 69882, '\P{^sorasompeng}', "");
    Expect(1, 69881, '\p{  Sora_sompeng}', "");
    Expect(0, 69881, '\p{^  Sora_sompeng}', "");
    Expect(0, 69881, '\P{  Sora_sompeng}', "");
    Expect(1, 69881, '\P{^  Sora_sompeng}', "");
    Expect(0, 69882, '\p{  Sora_sompeng}', "");
    Expect(1, 69882, '\p{^  Sora_sompeng}', "");
    Expect(1, 69882, '\P{  Sora_sompeng}', "");
    Expect(0, 69882, '\P{^  Sora_sompeng}', "");
    Error('\p{-_Is_Sora_Sompeng/a/}');
    Error('\P{-_Is_Sora_Sompeng/a/}');
    Expect(1, 69881, '\p{issorasompeng}', "");
    Expect(0, 69881, '\p{^issorasompeng}', "");
    Expect(0, 69881, '\P{issorasompeng}', "");
    Expect(1, 69881, '\P{^issorasompeng}', "");
    Expect(0, 69882, '\p{issorasompeng}', "");
    Expect(1, 69882, '\p{^issorasompeng}', "");
    Expect(1, 69882, '\P{issorasompeng}', "");
    Expect(0, 69882, '\P{^issorasompeng}', "");
    Expect(1, 69881, '\p{_ is_sora_SOMPENG}', "");
    Expect(0, 69881, '\p{^_ is_sora_SOMPENG}', "");
    Expect(0, 69881, '\P{_ is_sora_SOMPENG}', "");
    Expect(1, 69881, '\P{^_ is_sora_SOMPENG}', "");
    Expect(0, 69882, '\p{_ is_sora_SOMPENG}', "");
    Expect(1, 69882, '\p{^_ is_sora_SOMPENG}', "");
    Expect(1, 69882, '\P{_ is_sora_SOMPENG}', "");
    Expect(0, 69882, '\P{^_ is_sora_SOMPENG}', "");
    Error('\p{__sora:=}');
    Error('\P{__sora:=}');
    Expect(1, 69881, '\p{sora}', "");
    Expect(0, 69881, '\p{^sora}', "");
    Expect(0, 69881, '\P{sora}', "");
    Expect(1, 69881, '\P{^sora}', "");
    Expect(0, 69882, '\p{sora}', "");
    Expect(1, 69882, '\p{^sora}', "");
    Expect(1, 69882, '\P{sora}', "");
    Expect(0, 69882, '\P{^sora}', "");
    Expect(1, 69881, '\p{-_Sora}', "");
    Expect(0, 69881, '\p{^-_Sora}', "");
    Expect(0, 69881, '\P{-_Sora}', "");
    Expect(1, 69881, '\P{^-_Sora}', "");
    Expect(0, 69882, '\p{-_Sora}', "");
    Expect(1, 69882, '\p{^-_Sora}', "");
    Expect(1, 69882, '\P{-_Sora}', "");
    Expect(0, 69882, '\P{^-_Sora}', "");
    Error('\p{_IS_sora/a/}');
    Error('\P{_IS_sora/a/}');
    Expect(1, 69881, '\p{issora}', "");
    Expect(0, 69881, '\p{^issora}', "");
    Expect(0, 69881, '\P{issora}', "");
    Expect(1, 69881, '\P{^issora}', "");
    Expect(0, 69882, '\p{issora}', "");
    Expect(1, 69882, '\p{^issora}', "");
    Expect(1, 69882, '\P{issora}', "");
    Expect(0, 69882, '\P{^issora}', "");
    Expect(1, 69881, '\p{	 Is_Sora}', "");
    Expect(0, 69881, '\p{^	 Is_Sora}', "");
    Expect(0, 69881, '\P{	 Is_Sora}', "");
    Expect(1, 69881, '\P{^	 Is_Sora}', "");
    Expect(0, 69882, '\p{	 Is_Sora}', "");
    Expect(1, 69882, '\p{^	 Is_Sora}', "");
    Expect(1, 69882, '\P{	 Is_Sora}', "");
    Expect(0, 69882, '\P{^	 Is_Sora}', "");
    Error('\p{/a/- soyombo}');
    Error('\P{/a/- soyombo}');
    Expect(1, 72354, '\p{soyombo}', "");
    Expect(0, 72354, '\p{^soyombo}', "");
    Expect(0, 72354, '\P{soyombo}', "");
    Expect(1, 72354, '\P{^soyombo}', "");
    Expect(0, 72355, '\p{soyombo}', "");
    Expect(1, 72355, '\p{^soyombo}', "");
    Expect(1, 72355, '\P{soyombo}', "");
    Expect(0, 72355, '\P{^soyombo}', "");
    Expect(1, 72354, '\p{_soyombo}', "");
    Expect(0, 72354, '\p{^_soyombo}', "");
    Expect(0, 72354, '\P{_soyombo}', "");
    Expect(1, 72354, '\P{^_soyombo}', "");
    Expect(0, 72355, '\p{_soyombo}', "");
    Expect(1, 72355, '\p{^_soyombo}', "");
    Expect(1, 72355, '\P{_soyombo}', "");
    Expect(0, 72355, '\P{^_soyombo}', "");
    Error('\p{:=		is_Soyombo}');
    Error('\P{:=		is_Soyombo}');
    Expect(1, 72354, '\p{issoyombo}', "");
    Expect(0, 72354, '\p{^issoyombo}', "");
    Expect(0, 72354, '\P{issoyombo}', "");
    Expect(1, 72354, '\P{^issoyombo}', "");
    Expect(0, 72355, '\p{issoyombo}', "");
    Expect(1, 72355, '\p{^issoyombo}', "");
    Expect(1, 72355, '\P{issoyombo}', "");
    Expect(0, 72355, '\P{^issoyombo}', "");
    Expect(1, 72354, '\p{_	Is_Soyombo}', "");
    Expect(0, 72354, '\p{^_	Is_Soyombo}', "");
    Expect(0, 72354, '\P{_	Is_Soyombo}', "");
    Expect(1, 72354, '\P{^_	Is_Soyombo}', "");
    Expect(0, 72355, '\p{_	Is_Soyombo}', "");
    Expect(1, 72355, '\p{^_	Is_Soyombo}', "");
    Expect(1, 72355, '\P{_	Is_Soyombo}', "");
    Expect(0, 72355, '\P{^_	Is_Soyombo}', "");
    Error('\p{/a/ 	Soyo}');
    Error('\P{/a/ 	Soyo}');
    Expect(1, 72354, '\p{soyo}', "");
    Expect(0, 72354, '\p{^soyo}', "");
    Expect(0, 72354, '\P{soyo}', "");
    Expect(1, 72354, '\P{^soyo}', "");
    Expect(0, 72355, '\p{soyo}', "");
    Expect(1, 72355, '\p{^soyo}', "");
    Expect(1, 72355, '\P{soyo}', "");
    Expect(0, 72355, '\P{^soyo}', "");
    Expect(1, 72354, '\p{  soyo}', "");
    Expect(0, 72354, '\p{^  soyo}', "");
    Expect(0, 72354, '\P{  soyo}', "");
    Expect(1, 72354, '\P{^  soyo}', "");
    Expect(0, 72355, '\p{  soyo}', "");
    Expect(1, 72355, '\p{^  soyo}', "");
    Expect(1, 72355, '\P{  soyo}', "");
    Expect(0, 72355, '\P{^  soyo}', "");
    Error('\p{/a/	 Is_soyo}');
    Error('\P{/a/	 Is_soyo}');
    Expect(1, 72354, '\p{issoyo}', "");
    Expect(0, 72354, '\p{^issoyo}', "");
    Expect(0, 72354, '\P{issoyo}', "");
    Expect(1, 72354, '\P{^issoyo}', "");
    Expect(0, 72355, '\p{issoyo}', "");
    Expect(1, 72355, '\p{^issoyo}', "");
    Expect(1, 72355, '\P{issoyo}', "");
    Expect(0, 72355, '\P{^issoyo}', "");
    Expect(1, 72354, '\p{-	IS_Soyo}', "");
    Expect(0, 72354, '\p{^-	IS_Soyo}', "");
    Expect(0, 72354, '\P{-	IS_Soyo}', "");
    Expect(1, 72354, '\P{^-	IS_Soyo}', "");
    Expect(0, 72355, '\p{-	IS_Soyo}', "");
    Expect(1, 72355, '\p{^-	IS_Soyo}', "");
    Expect(1, 72355, '\P{-	IS_Soyo}', "");
    Expect(0, 72355, '\P{^-	IS_Soyo}', "");
    Error('\p{_/a/space_Separator}');
    Error('\P{_/a/space_Separator}');
    Expect(1, 12288, '\p{spaceseparator}', "");
    Expect(0, 12288, '\p{^spaceseparator}', "");
    Expect(0, 12288, '\P{spaceseparator}', "");
    Expect(1, 12288, '\P{^spaceseparator}', "");
    Expect(0, 12289, '\p{spaceseparator}', "");
    Expect(1, 12289, '\p{^spaceseparator}', "");
    Expect(1, 12289, '\P{spaceseparator}', "");
    Expect(0, 12289, '\P{^spaceseparator}', "");
    Expect(1, 12288, '\p{_	SPACE_SEPARATOR}', "");
    Expect(0, 12288, '\p{^_	SPACE_SEPARATOR}', "");
    Expect(0, 12288, '\P{_	SPACE_SEPARATOR}', "");
    Expect(1, 12288, '\P{^_	SPACE_SEPARATOR}', "");
    Expect(0, 12289, '\p{_	SPACE_SEPARATOR}', "");
    Expect(1, 12289, '\p{^_	SPACE_SEPARATOR}', "");
    Expect(1, 12289, '\P{_	SPACE_SEPARATOR}', "");
    Expect(0, 12289, '\P{^_	SPACE_SEPARATOR}', "");
    Error('\p{	_Is_Space_separator/a/}');
    Error('\P{	_Is_Space_separator/a/}');
    Expect(1, 12288, '\p{isspaceseparator}', "");
    Expect(0, 12288, '\p{^isspaceseparator}', "");
    Expect(0, 12288, '\P{isspaceseparator}', "");
    Expect(1, 12288, '\P{^isspaceseparator}', "");
    Expect(0, 12289, '\p{isspaceseparator}', "");
    Expect(1, 12289, '\p{^isspaceseparator}', "");
    Expect(1, 12289, '\P{isspaceseparator}', "");
    Expect(0, 12289, '\P{^isspaceseparator}', "");
    Expect(1, 12288, '\p{ Is_space_separator}', "");
    Expect(0, 12288, '\p{^ Is_space_separator}', "");
    Expect(0, 12288, '\P{ Is_space_separator}', "");
    Expect(1, 12288, '\P{^ Is_space_separator}', "");
    Expect(0, 12289, '\p{ Is_space_separator}', "");
    Expect(1, 12289, '\p{^ Is_space_separator}', "");
    Expect(1, 12289, '\P{ Is_space_separator}', "");
    Expect(0, 12289, '\P{^ Is_space_separator}', "");
    Error('\p{/a/_Zs}');
    Error('\P{/a/_Zs}');
    Expect(1, 12288, '\p{zs}', "");
    Expect(0, 12288, '\p{^zs}', "");
    Expect(0, 12288, '\P{zs}', "");
    Expect(1, 12288, '\P{^zs}', "");
    Expect(0, 12289, '\p{zs}', "");
    Expect(1, 12289, '\p{^zs}', "");
    Expect(1, 12289, '\P{zs}', "");
    Expect(0, 12289, '\P{^zs}', "");
    Expect(1, 12288, '\p{--Zs}', "");
    Expect(0, 12288, '\p{^--Zs}', "");
    Expect(0, 12288, '\P{--Zs}', "");
    Expect(1, 12288, '\P{^--Zs}', "");
    Expect(0, 12289, '\p{--Zs}', "");
    Expect(1, 12289, '\p{^--Zs}', "");
    Expect(1, 12289, '\P{--Zs}', "");
    Expect(0, 12289, '\P{^--Zs}', "");
    Error('\p{	-Is_ZS/a/}');
    Error('\P{	-Is_ZS/a/}');
    Expect(1, 12288, '\p{iszs}', "");
    Expect(0, 12288, '\p{^iszs}', "");
    Expect(0, 12288, '\P{iszs}', "");
    Expect(1, 12288, '\P{^iszs}', "");
    Expect(0, 12289, '\p{iszs}', "");
    Expect(1, 12289, '\p{^iszs}', "");
    Expect(1, 12289, '\P{iszs}', "");
    Expect(0, 12289, '\P{^iszs}', "");
    Expect(1, 12288, '\p{__Is_Zs}', "");
    Expect(0, 12288, '\p{^__Is_Zs}', "");
    Expect(0, 12288, '\P{__Is_Zs}', "");
    Expect(1, 12288, '\P{^__Is_Zs}', "");
    Expect(0, 12289, '\p{__Is_Zs}', "");
    Expect(1, 12289, '\p{^__Is_Zs}', "");
    Expect(1, 12289, '\P{__Is_Zs}', "");
    Expect(0, 12289, '\P{^__Is_Zs}', "");
    Error('\p{_Spacing_Mark:=}');
    Error('\P{_Spacing_Mark:=}');
    Expect(1, 119154, '\p{spacingmark}', "");
    Expect(0, 119154, '\p{^spacingmark}', "");
    Expect(0, 119154, '\P{spacingmark}', "");
    Expect(1, 119154, '\P{^spacingmark}', "");
    Expect(0, 119155, '\p{spacingmark}', "");
    Expect(1, 119155, '\p{^spacingmark}', "");
    Expect(1, 119155, '\P{spacingmark}', "");
    Expect(0, 119155, '\P{^spacingmark}', "");
    Expect(1, 119154, '\p{ 	Spacing_mark}', "");
    Expect(0, 119154, '\p{^ 	Spacing_mark}', "");
    Expect(0, 119154, '\P{ 	Spacing_mark}', "");
    Expect(1, 119154, '\P{^ 	Spacing_mark}', "");
    Expect(0, 119155, '\p{ 	Spacing_mark}', "");
    Expect(1, 119155, '\p{^ 	Spacing_mark}', "");
    Expect(1, 119155, '\P{ 	Spacing_mark}', "");
    Expect(0, 119155, '\P{^ 	Spacing_mark}', "");
    Error('\p{/a/-_IS_Spacing_Mark}');
    Error('\P{/a/-_IS_Spacing_Mark}');
    Expect(1, 119154, '\p{isspacingmark}', "");
    Expect(0, 119154, '\p{^isspacingmark}', "");
    Expect(0, 119154, '\P{isspacingmark}', "");
    Expect(1, 119154, '\P{^isspacingmark}', "");
    Expect(0, 119155, '\p{isspacingmark}', "");
    Expect(1, 119155, '\p{^isspacingmark}', "");
    Expect(1, 119155, '\P{isspacingmark}', "");
    Expect(0, 119155, '\P{^isspacingmark}', "");
    Expect(1, 119154, '\p{ -Is_Spacing_mark}', "");
    Expect(0, 119154, '\p{^ -Is_Spacing_mark}', "");
    Expect(0, 119154, '\P{ -Is_Spacing_mark}', "");
    Expect(1, 119154, '\P{^ -Is_Spacing_mark}', "");
    Expect(0, 119155, '\p{ -Is_Spacing_mark}', "");
    Expect(1, 119155, '\p{^ -Is_Spacing_mark}', "");
    Expect(1, 119155, '\P{ -Is_Spacing_mark}', "");
    Expect(0, 119155, '\P{^ -Is_Spacing_mark}', "");
    Error('\p{_/a/mc}');
    Error('\P{_/a/mc}');
    Expect(1, 119154, '\p{mc}', "");
    Expect(0, 119154, '\p{^mc}', "");
    Expect(0, 119154, '\P{mc}', "");
    Expect(1, 119154, '\P{^mc}', "");
    Expect(0, 119155, '\p{mc}', "");
    Expect(1, 119155, '\p{^mc}', "");
    Expect(1, 119155, '\P{mc}', "");
    Expect(0, 119155, '\P{^mc}', "");
    Expect(1, 119154, '\p{	-mc}', "");
    Expect(0, 119154, '\p{^	-mc}', "");
    Expect(0, 119154, '\P{	-mc}', "");
    Expect(1, 119154, '\P{^	-mc}', "");
    Expect(0, 119155, '\p{	-mc}', "");
    Expect(1, 119155, '\p{^	-mc}', "");
    Expect(1, 119155, '\P{	-mc}', "");
    Expect(0, 119155, '\P{^	-mc}', "");
    Error('\p{ :=Is_Mc}');
    Error('\P{ :=Is_Mc}');
    Expect(1, 119154, '\p{ismc}', "");
    Expect(0, 119154, '\p{^ismc}', "");
    Expect(0, 119154, '\P{ismc}', "");
    Expect(1, 119154, '\P{^ismc}', "");
    Expect(0, 119155, '\p{ismc}', "");
    Expect(1, 119155, '\p{^ismc}', "");
    Expect(1, 119155, '\P{ismc}', "");
    Expect(0, 119155, '\P{^ismc}', "");
    Expect(1, 119154, '\p{		is_MC}', "");
    Expect(0, 119154, '\p{^		is_MC}', "");
    Expect(0, 119154, '\P{		is_MC}', "");
    Expect(1, 119154, '\P{^		is_MC}', "");
    Expect(0, 119155, '\p{		is_MC}', "");
    Expect(1, 119155, '\p{^		is_MC}', "");
    Expect(1, 119155, '\P{		is_MC}', "");
    Expect(0, 119155, '\P{^		is_MC}', "");
    Error('\p{:=	 spacing_Modifier_letters}');
    Error('\P{:=	 spacing_Modifier_letters}');
    Expect(1, 767, '\p{spacingmodifierletters}', "");
    Expect(0, 767, '\p{^spacingmodifierletters}', "");
    Expect(0, 767, '\P{spacingmodifierletters}', "");
    Expect(1, 767, '\P{^spacingmodifierletters}', "");
    Expect(0, 768, '\p{spacingmodifierletters}', "");
    Expect(1, 768, '\p{^spacingmodifierletters}', "");
    Expect(1, 768, '\P{spacingmodifierletters}', "");
    Expect(0, 768, '\P{^spacingmodifierletters}', "");
    Expect(1, 767, '\p{	Spacing_MODIFIER_Letters}', "");
    Expect(0, 767, '\p{^	Spacing_MODIFIER_Letters}', "");
    Expect(0, 767, '\P{	Spacing_MODIFIER_Letters}', "");
    Expect(1, 767, '\P{^	Spacing_MODIFIER_Letters}', "");
    Expect(0, 768, '\p{	Spacing_MODIFIER_Letters}', "");
    Expect(1, 768, '\p{^	Spacing_MODIFIER_Letters}', "");
    Expect(1, 768, '\P{	Spacing_MODIFIER_Letters}', "");
    Expect(0, 768, '\P{^	Spacing_MODIFIER_Letters}', "");
    Error('\p{__IS_SPACING_modifier_Letters:=}');
    Error('\P{__IS_SPACING_modifier_Letters:=}');
    Expect(1, 767, '\p{isspacingmodifierletters}', "");
    Expect(0, 767, '\p{^isspacingmodifierletters}', "");
    Expect(0, 767, '\P{isspacingmodifierletters}', "");
    Expect(1, 767, '\P{^isspacingmodifierletters}', "");
    Expect(0, 768, '\p{isspacingmodifierletters}', "");
    Expect(1, 768, '\p{^isspacingmodifierletters}', "");
    Expect(1, 768, '\P{isspacingmodifierletters}', "");
    Expect(0, 768, '\P{^isspacingmodifierletters}', "");
    Expect(1, 767, '\p{_	Is_SPACING_MODIFIER_LETTERS}', "");
    Expect(0, 767, '\p{^_	Is_SPACING_MODIFIER_LETTERS}', "");
    Expect(0, 767, '\P{_	Is_SPACING_MODIFIER_LETTERS}', "");
    Expect(1, 767, '\P{^_	Is_SPACING_MODIFIER_LETTERS}', "");
    Expect(0, 768, '\p{_	Is_SPACING_MODIFIER_LETTERS}', "");
    Expect(1, 768, '\p{^_	Is_SPACING_MODIFIER_LETTERS}', "");
    Expect(1, 768, '\P{_	Is_SPACING_MODIFIER_LETTERS}', "");
    Expect(0, 768, '\P{^_	Is_SPACING_MODIFIER_LETTERS}', "");
    Error('\p{/a/  IN_Spacing_modifier_Letters}');
    Error('\P{/a/  IN_Spacing_modifier_Letters}');
    Expect(1, 767, '\p{inspacingmodifierletters}', "");
    Expect(0, 767, '\p{^inspacingmodifierletters}', "");
    Expect(0, 767, '\P{inspacingmodifierletters}', "");
    Expect(1, 767, '\P{^inspacingmodifierletters}', "");
    Expect(0, 768, '\p{inspacingmodifierletters}', "");
    Expect(1, 768, '\p{^inspacingmodifierletters}', "");
    Expect(1, 768, '\P{inspacingmodifierletters}', "");
    Expect(0, 768, '\P{^inspacingmodifierletters}', "");
    Expect(1, 767, '\p{-In_Spacing_MODIFIER_LETTERS}', "");
    Expect(0, 767, '\p{^-In_Spacing_MODIFIER_LETTERS}', "");
    Expect(0, 767, '\P{-In_Spacing_MODIFIER_LETTERS}', "");
    Expect(1, 767, '\P{^-In_Spacing_MODIFIER_LETTERS}', "");
    Expect(0, 768, '\p{-In_Spacing_MODIFIER_LETTERS}', "");
    Expect(1, 768, '\p{^-In_Spacing_MODIFIER_LETTERS}', "");
    Expect(1, 768, '\P{-In_Spacing_MODIFIER_LETTERS}', "");
    Expect(0, 768, '\P{^-In_Spacing_MODIFIER_LETTERS}', "");
    Error('\p{:=	Modifier_LETTERS}');
    Error('\P{:=	Modifier_LETTERS}');
    Expect(1, 767, '\p{modifierletters}', "");
    Expect(0, 767, '\p{^modifierletters}', "");
    Expect(0, 767, '\P{modifierletters}', "");
    Expect(1, 767, '\P{^modifierletters}', "");
    Expect(0, 768, '\p{modifierletters}', "");
    Expect(1, 768, '\p{^modifierletters}', "");
    Expect(1, 768, '\P{modifierletters}', "");
    Expect(0, 768, '\P{^modifierletters}', "");
    Expect(1, 767, '\p{ -modifier_letters}', "");
    Expect(0, 767, '\p{^ -modifier_letters}', "");
    Expect(0, 767, '\P{ -modifier_letters}', "");
    Expect(1, 767, '\P{^ -modifier_letters}', "");
    Expect(0, 768, '\p{ -modifier_letters}', "");
    Expect(1, 768, '\p{^ -modifier_letters}', "");
    Expect(1, 768, '\P{ -modifier_letters}', "");
    Expect(0, 768, '\P{^ -modifier_letters}', "");
    Error('\p{_:=Is_modifier_letters}');
    Error('\P{_:=Is_modifier_letters}');
    Expect(1, 767, '\p{ismodifierletters}', "");
    Expect(0, 767, '\p{^ismodifierletters}', "");
    Expect(0, 767, '\P{ismodifierletters}', "");
    Expect(1, 767, '\P{^ismodifierletters}', "");
    Expect(0, 768, '\p{ismodifierletters}', "");
    Expect(1, 768, '\p{^ismodifierletters}', "");
    Expect(1, 768, '\P{ismodifierletters}', "");
    Expect(0, 768, '\P{^ismodifierletters}', "");
    Expect(1, 767, '\p{	_Is_modifier_Letters}', "");
    Expect(0, 767, '\p{^	_Is_modifier_Letters}', "");
    Expect(0, 767, '\P{	_Is_modifier_Letters}', "");
    Expect(1, 767, '\P{^	_Is_modifier_Letters}', "");
    Expect(0, 768, '\p{	_Is_modifier_Letters}', "");
    Expect(1, 768, '\p{^	_Is_modifier_Letters}', "");
    Expect(1, 768, '\P{	_Is_modifier_Letters}', "");
    Expect(0, 768, '\P{^	_Is_modifier_Letters}', "");
    Error('\p{-	IN_Modifier_letters/a/}');
    Error('\P{-	IN_Modifier_letters/a/}');
    Expect(1, 767, '\p{inmodifierletters}', "");
    Expect(0, 767, '\p{^inmodifierletters}', "");
    Expect(0, 767, '\P{inmodifierletters}', "");
    Expect(1, 767, '\P{^inmodifierletters}', "");
    Expect(0, 768, '\p{inmodifierletters}', "");
    Expect(1, 768, '\p{^inmodifierletters}', "");
    Expect(1, 768, '\P{inmodifierletters}', "");
    Expect(0, 768, '\P{^inmodifierletters}', "");
    Expect(1, 767, '\p{_ in_Modifier_letters}', "");
    Expect(0, 767, '\p{^_ in_Modifier_letters}', "");
    Expect(0, 767, '\P{_ in_Modifier_letters}', "");
    Expect(1, 767, '\P{^_ in_Modifier_letters}', "");
    Expect(0, 768, '\p{_ in_Modifier_letters}', "");
    Expect(1, 768, '\p{^_ in_Modifier_letters}', "");
    Expect(1, 768, '\P{_ in_Modifier_letters}', "");
    Expect(0, 768, '\P{^_ in_Modifier_letters}', "");
    Error('\p{:=Specials}');
    Error('\P{:=Specials}');
    Expect(1, 65520, '\p{specials}', "");
    Expect(0, 65520, '\p{^specials}', "");
    Expect(0, 65520, '\P{specials}', "");
    Expect(1, 65520, '\P{^specials}', "");
    Expect(0, 65536, '\p{specials}', "");
    Expect(1, 65536, '\p{^specials}', "");
    Expect(1, 65536, '\P{specials}', "");
    Expect(0, 65536, '\P{^specials}', "");
    Expect(1, 65520, '\p{  specials}', "");
    Expect(0, 65520, '\p{^  specials}', "");
    Expect(0, 65520, '\P{  specials}', "");
    Expect(1, 65520, '\P{^  specials}', "");
    Expect(0, 65536, '\p{  specials}', "");
    Expect(1, 65536, '\p{^  specials}', "");
    Expect(1, 65536, '\P{  specials}', "");
    Expect(0, 65536, '\P{^  specials}', "");
    Error('\p{		Is_specials:=}');
    Error('\P{		Is_specials:=}');
    Expect(1, 65520, '\p{isspecials}', "");
    Expect(0, 65520, '\p{^isspecials}', "");
    Expect(0, 65520, '\P{isspecials}', "");
    Expect(1, 65520, '\P{^isspecials}', "");
    Expect(0, 65536, '\p{isspecials}', "");
    Expect(1, 65536, '\p{^isspecials}', "");
    Expect(1, 65536, '\P{isspecials}', "");
    Expect(0, 65536, '\P{^isspecials}', "");
    Expect(1, 65520, '\p{	-Is_Specials}', "");
    Expect(0, 65520, '\p{^	-Is_Specials}', "");
    Expect(0, 65520, '\P{	-Is_Specials}', "");
    Expect(1, 65520, '\P{^	-Is_Specials}', "");
    Expect(0, 65536, '\p{	-Is_Specials}', "");
    Expect(1, 65536, '\p{^	-Is_Specials}', "");
    Expect(1, 65536, '\P{	-Is_Specials}', "");
    Expect(0, 65536, '\P{^	-Is_Specials}', "");
    Error('\p{	-In_SPECIALS:=}');
    Error('\P{	-In_SPECIALS:=}');
    Expect(1, 65520, '\p{inspecials}', "");
    Expect(0, 65520, '\p{^inspecials}', "");
    Expect(0, 65520, '\P{inspecials}', "");
    Expect(1, 65520, '\P{^inspecials}', "");
    Expect(0, 65536, '\p{inspecials}', "");
    Expect(1, 65536, '\p{^inspecials}', "");
    Expect(1, 65536, '\P{inspecials}', "");
    Expect(0, 65536, '\P{^inspecials}', "");
    Expect(1, 65520, '\p{-_In_SPECIALS}', "");
    Expect(0, 65520, '\p{^-_In_SPECIALS}', "");
    Expect(0, 65520, '\P{-_In_SPECIALS}', "");
    Expect(1, 65520, '\P{^-_In_SPECIALS}', "");
    Expect(0, 65536, '\p{-_In_SPECIALS}', "");
    Expect(1, 65536, '\p{^-_In_SPECIALS}', "");
    Expect(1, 65536, '\P{-_In_SPECIALS}', "");
    Expect(0, 65536, '\P{^-_In_SPECIALS}', "");
    Error('\p{--Sundanese/a/}');
    Error('\P{--Sundanese/a/}');
    Expect(1, 7367, '\p{sundanese}', "");
    Expect(0, 7367, '\p{^sundanese}', "");
    Expect(0, 7367, '\P{sundanese}', "");
    Expect(1, 7367, '\P{^sundanese}', "");
    Expect(0, 7368, '\p{sundanese}', "");
    Expect(1, 7368, '\p{^sundanese}', "");
    Expect(1, 7368, '\P{sundanese}', "");
    Expect(0, 7368, '\P{^sundanese}', "");
    Expect(1, 7367, '\p{-SUNDANESE}', "");
    Expect(0, 7367, '\p{^-SUNDANESE}', "");
    Expect(0, 7367, '\P{-SUNDANESE}', "");
    Expect(1, 7367, '\P{^-SUNDANESE}', "");
    Expect(0, 7368, '\p{-SUNDANESE}', "");
    Expect(1, 7368, '\p{^-SUNDANESE}', "");
    Expect(1, 7368, '\P{-SUNDANESE}', "");
    Expect(0, 7368, '\P{^-SUNDANESE}', "");
    Error('\p{	-IS_Sundanese/a/}');
    Error('\P{	-IS_Sundanese/a/}');
    Expect(1, 7367, '\p{issundanese}', "");
    Expect(0, 7367, '\p{^issundanese}', "");
    Expect(0, 7367, '\P{issundanese}', "");
    Expect(1, 7367, '\P{^issundanese}', "");
    Expect(0, 7368, '\p{issundanese}', "");
    Expect(1, 7368, '\p{^issundanese}', "");
    Expect(1, 7368, '\P{issundanese}', "");
    Expect(0, 7368, '\P{^issundanese}', "");
    Expect(1, 7367, '\p{  Is_Sundanese}', "");
    Expect(0, 7367, '\p{^  Is_Sundanese}', "");
    Expect(0, 7367, '\P{  Is_Sundanese}', "");
    Expect(1, 7367, '\P{^  Is_Sundanese}', "");
    Expect(0, 7368, '\p{  Is_Sundanese}', "");
    Expect(1, 7368, '\p{^  Is_Sundanese}', "");
    Expect(1, 7368, '\P{  Is_Sundanese}', "");
    Expect(0, 7368, '\P{^  Is_Sundanese}', "");
    Error('\p{/a/	-SUND}');
    Error('\P{/a/	-SUND}');
    Expect(1, 7367, '\p{sund}', "");
    Expect(0, 7367, '\p{^sund}', "");
    Expect(0, 7367, '\P{sund}', "");
    Expect(1, 7367, '\P{^sund}', "");
    Expect(0, 7368, '\p{sund}', "");
    Expect(1, 7368, '\p{^sund}', "");
    Expect(1, 7368, '\P{sund}', "");
    Expect(0, 7368, '\P{^sund}', "");
    Expect(1, 7367, '\p{	 Sund}', "");
    Expect(0, 7367, '\p{^	 Sund}', "");
    Expect(0, 7367, '\P{	 Sund}', "");
    Expect(1, 7367, '\P{^	 Sund}', "");
    Expect(0, 7368, '\p{	 Sund}', "");
    Expect(1, 7368, '\p{^	 Sund}', "");
    Expect(1, 7368, '\P{	 Sund}', "");
    Expect(0, 7368, '\P{^	 Sund}', "");
    Error('\p{:=Is_SUND}');
    Error('\P{:=Is_SUND}');
    Expect(1, 7367, '\p{issund}', "");
    Expect(0, 7367, '\p{^issund}', "");
    Expect(0, 7367, '\P{issund}', "");
    Expect(1, 7367, '\P{^issund}', "");
    Expect(0, 7368, '\p{issund}', "");
    Expect(1, 7368, '\p{^issund}', "");
    Expect(1, 7368, '\P{issund}', "");
    Expect(0, 7368, '\P{^issund}', "");
    Expect(1, 7367, '\p{	-IS_Sund}', "");
    Expect(0, 7367, '\p{^	-IS_Sund}', "");
    Expect(0, 7367, '\P{	-IS_Sund}', "");
    Expect(1, 7367, '\P{^	-IS_Sund}', "");
    Expect(0, 7368, '\p{	-IS_Sund}', "");
    Expect(1, 7368, '\p{^	-IS_Sund}', "");
    Expect(1, 7368, '\P{	-IS_Sund}', "");
    Expect(0, 7368, '\P{^	-IS_Sund}', "");
    Error('\p{ -Sundanese_supplement:=}');
    Error('\P{ -Sundanese_supplement:=}');
    Expect(1, 7375, '\p{sundanesesupplement}', "");
    Expect(0, 7375, '\p{^sundanesesupplement}', "");
    Expect(0, 7375, '\P{sundanesesupplement}', "");
    Expect(1, 7375, '\P{^sundanesesupplement}', "");
    Expect(0, 7376, '\p{sundanesesupplement}', "");
    Expect(1, 7376, '\p{^sundanesesupplement}', "");
    Expect(1, 7376, '\P{sundanesesupplement}', "");
    Expect(0, 7376, '\P{^sundanesesupplement}', "");
    Expect(1, 7375, '\p{ Sundanese_supplement}', "");
    Expect(0, 7375, '\p{^ Sundanese_supplement}', "");
    Expect(0, 7375, '\P{ Sundanese_supplement}', "");
    Expect(1, 7375, '\P{^ Sundanese_supplement}', "");
    Expect(0, 7376, '\p{ Sundanese_supplement}', "");
    Expect(1, 7376, '\p{^ Sundanese_supplement}', "");
    Expect(1, 7376, '\P{ Sundanese_supplement}', "");
    Expect(0, 7376, '\P{^ Sundanese_supplement}', "");
    Error('\p{/a/ IS_Sundanese_Supplement}');
    Error('\P{/a/ IS_Sundanese_Supplement}');
    Expect(1, 7375, '\p{issundanesesupplement}', "");
    Expect(0, 7375, '\p{^issundanesesupplement}', "");
    Expect(0, 7375, '\P{issundanesesupplement}', "");
    Expect(1, 7375, '\P{^issundanesesupplement}', "");
    Expect(0, 7376, '\p{issundanesesupplement}', "");
    Expect(1, 7376, '\p{^issundanesesupplement}', "");
    Expect(1, 7376, '\P{issundanesesupplement}', "");
    Expect(0, 7376, '\P{^issundanesesupplement}', "");
    Expect(1, 7375, '\p{ IS_SUNDANESE_Supplement}', "");
    Expect(0, 7375, '\p{^ IS_SUNDANESE_Supplement}', "");
    Expect(0, 7375, '\P{ IS_SUNDANESE_Supplement}', "");
    Expect(1, 7375, '\P{^ IS_SUNDANESE_Supplement}', "");
    Expect(0, 7376, '\p{ IS_SUNDANESE_Supplement}', "");
    Expect(1, 7376, '\p{^ IS_SUNDANESE_Supplement}', "");
    Expect(1, 7376, '\P{ IS_SUNDANESE_Supplement}', "");
    Expect(0, 7376, '\P{^ IS_SUNDANESE_Supplement}', "");
    Error('\p{ 	In_Sundanese_Supplement/a/}');
    Error('\P{ 	In_Sundanese_Supplement/a/}');
    Expect(1, 7375, '\p{insundanesesupplement}', "");
    Expect(0, 7375, '\p{^insundanesesupplement}', "");
    Expect(0, 7375, '\P{insundanesesupplement}', "");
    Expect(1, 7375, '\P{^insundanesesupplement}', "");
    Expect(0, 7376, '\p{insundanesesupplement}', "");
    Expect(1, 7376, '\p{^insundanesesupplement}', "");
    Expect(1, 7376, '\P{insundanesesupplement}', "");
    Expect(0, 7376, '\P{^insundanesesupplement}', "");
    Expect(1, 7375, '\p{ -IN_Sundanese_SUPPLEMENT}', "");
    Expect(0, 7375, '\p{^ -IN_Sundanese_SUPPLEMENT}', "");
    Expect(0, 7375, '\P{ -IN_Sundanese_SUPPLEMENT}', "");
    Expect(1, 7375, '\P{^ -IN_Sundanese_SUPPLEMENT}', "");
    Expect(0, 7376, '\p{ -IN_Sundanese_SUPPLEMENT}', "");
    Expect(1, 7376, '\p{^ -IN_Sundanese_SUPPLEMENT}', "");
    Expect(1, 7376, '\P{ -IN_Sundanese_SUPPLEMENT}', "");
    Expect(0, 7376, '\P{^ -IN_Sundanese_SUPPLEMENT}', "");
    Error('\p{_ Sundanese_Sup:=}');
    Error('\P{_ Sundanese_Sup:=}');
    Expect(1, 7375, '\p{sundanesesup}', "");
    Expect(0, 7375, '\p{^sundanesesup}', "");
    Expect(0, 7375, '\P{sundanesesup}', "");
    Expect(1, 7375, '\P{^sundanesesup}', "");
    Expect(0, 7376, '\p{sundanesesup}', "");
    Expect(1, 7376, '\p{^sundanesesup}', "");
    Expect(1, 7376, '\P{sundanesesup}', "");
    Expect(0, 7376, '\P{^sundanesesup}', "");
    Expect(1, 7375, '\p{-Sundanese_Sup}', "");
    Expect(0, 7375, '\p{^-Sundanese_Sup}', "");
    Expect(0, 7375, '\P{-Sundanese_Sup}', "");
    Expect(1, 7375, '\P{^-Sundanese_Sup}', "");
    Expect(0, 7376, '\p{-Sundanese_Sup}', "");
    Expect(1, 7376, '\p{^-Sundanese_Sup}', "");
    Expect(1, 7376, '\P{-Sundanese_Sup}', "");
    Expect(0, 7376, '\P{^-Sundanese_Sup}', "");
    Error('\p{/a/	 Is_Sundanese_Sup}');
    Error('\P{/a/	 Is_Sundanese_Sup}');
    Expect(1, 7375, '\p{issundanesesup}', "");
    Expect(0, 7375, '\p{^issundanesesup}', "");
    Expect(0, 7375, '\P{issundanesesup}', "");
    Expect(1, 7375, '\P{^issundanesesup}', "");
    Expect(0, 7376, '\p{issundanesesup}', "");
    Expect(1, 7376, '\p{^issundanesesup}', "");
    Expect(1, 7376, '\P{issundanesesup}', "");
    Expect(0, 7376, '\P{^issundanesesup}', "");
    Expect(1, 7375, '\p{	IS_sundanese_Sup}', "");
    Expect(0, 7375, '\p{^	IS_sundanese_Sup}', "");
    Expect(0, 7375, '\P{	IS_sundanese_Sup}', "");
    Expect(1, 7375, '\P{^	IS_sundanese_Sup}', "");
    Expect(0, 7376, '\p{	IS_sundanese_Sup}', "");
    Expect(1, 7376, '\p{^	IS_sundanese_Sup}', "");
    Expect(1, 7376, '\P{	IS_sundanese_Sup}', "");
    Expect(0, 7376, '\P{^	IS_sundanese_Sup}', "");
    Error('\p{:=_-In_SUNDANESE_Sup}');
    Error('\P{:=_-In_SUNDANESE_Sup}');
    Expect(1, 7375, '\p{insundanesesup}', "");
    Expect(0, 7375, '\p{^insundanesesup}', "");
    Expect(0, 7375, '\P{insundanesesup}', "");
    Expect(1, 7375, '\P{^insundanesesup}', "");
    Expect(0, 7376, '\p{insundanesesup}', "");
    Expect(1, 7376, '\p{^insundanesesup}', "");
    Expect(1, 7376, '\P{insundanesesup}', "");
    Expect(0, 7376, '\P{^insundanesesup}', "");
    Expect(1, 7375, '\p{_in_Sundanese_Sup}', "");
    Expect(0, 7375, '\p{^_in_Sundanese_Sup}', "");
    Expect(0, 7375, '\P{_in_Sundanese_Sup}', "");
    Expect(1, 7375, '\P{^_in_Sundanese_Sup}', "");
    Expect(0, 7376, '\p{_in_Sundanese_Sup}', "");
    Expect(1, 7376, '\p{^_in_Sundanese_Sup}', "");
    Expect(1, 7376, '\P{_in_Sundanese_Sup}', "");
    Expect(0, 7376, '\P{^_in_Sundanese_Sup}', "");
    Error('\p{:=	superscripts_And_SUBSCRIPTS}');
    Error('\P{:=	superscripts_And_SUBSCRIPTS}');
    Expect(1, 8351, '\p{superscriptsandsubscripts}', "");
    Expect(0, 8351, '\p{^superscriptsandsubscripts}', "");
    Expect(0, 8351, '\P{superscriptsandsubscripts}', "");
    Expect(1, 8351, '\P{^superscriptsandsubscripts}', "");
    Expect(0, 8352, '\p{superscriptsandsubscripts}', "");
    Expect(1, 8352, '\p{^superscriptsandsubscripts}', "");
    Expect(1, 8352, '\P{superscriptsandsubscripts}', "");
    Expect(0, 8352, '\P{^superscriptsandsubscripts}', "");
    Expect(1, 8351, '\p{ Superscripts_and_SUBSCRIPTS}', "");
    Expect(0, 8351, '\p{^ Superscripts_and_SUBSCRIPTS}', "");
    Expect(0, 8351, '\P{ Superscripts_and_SUBSCRIPTS}', "");
    Expect(1, 8351, '\P{^ Superscripts_and_SUBSCRIPTS}', "");
    Expect(0, 8352, '\p{ Superscripts_and_SUBSCRIPTS}', "");
    Expect(1, 8352, '\p{^ Superscripts_and_SUBSCRIPTS}', "");
    Expect(1, 8352, '\P{ Superscripts_and_SUBSCRIPTS}', "");
    Expect(0, 8352, '\P{^ Superscripts_and_SUBSCRIPTS}', "");
    Error('\p{--IS_Superscripts_AND_Subscripts/a/}');
    Error('\P{--IS_Superscripts_AND_Subscripts/a/}');
    Expect(1, 8351, '\p{issuperscriptsandsubscripts}', "");
    Expect(0, 8351, '\p{^issuperscriptsandsubscripts}', "");
    Expect(0, 8351, '\P{issuperscriptsandsubscripts}', "");
    Expect(1, 8351, '\P{^issuperscriptsandsubscripts}', "");
    Expect(0, 8352, '\p{issuperscriptsandsubscripts}', "");
    Expect(1, 8352, '\p{^issuperscriptsandsubscripts}', "");
    Expect(1, 8352, '\P{issuperscriptsandsubscripts}', "");
    Expect(0, 8352, '\P{^issuperscriptsandsubscripts}', "");
    Expect(1, 8351, '\p{_IS_superscripts_AND_Subscripts}', "");
    Expect(0, 8351, '\p{^_IS_superscripts_AND_Subscripts}', "");
    Expect(0, 8351, '\P{_IS_superscripts_AND_Subscripts}', "");
    Expect(1, 8351, '\P{^_IS_superscripts_AND_Subscripts}', "");
    Expect(0, 8352, '\p{_IS_superscripts_AND_Subscripts}', "");
    Expect(1, 8352, '\p{^_IS_superscripts_AND_Subscripts}', "");
    Expect(1, 8352, '\P{_IS_superscripts_AND_Subscripts}', "");
    Expect(0, 8352, '\P{^_IS_superscripts_AND_Subscripts}', "");
    Error('\p{	_IN_superscripts_and_Subscripts/a/}');
    Error('\P{	_IN_superscripts_and_Subscripts/a/}');
    Expect(1, 8351, '\p{insuperscriptsandsubscripts}', "");
    Expect(0, 8351, '\p{^insuperscriptsandsubscripts}', "");
    Expect(0, 8351, '\P{insuperscriptsandsubscripts}', "");
    Expect(1, 8351, '\P{^insuperscriptsandsubscripts}', "");
    Expect(0, 8352, '\p{insuperscriptsandsubscripts}', "");
    Expect(1, 8352, '\p{^insuperscriptsandsubscripts}', "");
    Expect(1, 8352, '\P{insuperscriptsandsubscripts}', "");
    Expect(0, 8352, '\P{^insuperscriptsandsubscripts}', "");
    Expect(1, 8351, '\p{ 	In_Superscripts_AND_Subscripts}', "");
    Expect(0, 8351, '\p{^ 	In_Superscripts_AND_Subscripts}', "");
    Expect(0, 8351, '\P{ 	In_Superscripts_AND_Subscripts}', "");
    Expect(1, 8351, '\P{^ 	In_Superscripts_AND_Subscripts}', "");
    Expect(0, 8352, '\p{ 	In_Superscripts_AND_Subscripts}', "");
    Expect(1, 8352, '\p{^ 	In_Superscripts_AND_Subscripts}', "");
    Expect(1, 8352, '\P{ 	In_Superscripts_AND_Subscripts}', "");
    Expect(0, 8352, '\P{^ 	In_Superscripts_AND_Subscripts}', "");
    Error('\p{:= _Super_and_sub}');
    Error('\P{:= _Super_and_sub}');
    Expect(1, 8351, '\p{superandsub}', "");
    Expect(0, 8351, '\p{^superandsub}', "");
    Expect(0, 8351, '\P{superandsub}', "");
    Expect(1, 8351, '\P{^superandsub}', "");
    Expect(0, 8352, '\p{superandsub}', "");
    Expect(1, 8352, '\p{^superandsub}', "");
    Expect(1, 8352, '\P{superandsub}', "");
    Expect(0, 8352, '\P{^superandsub}', "");
    Expect(1, 8351, '\p{		super_And_Sub}', "");
    Expect(0, 8351, '\p{^		super_And_Sub}', "");
    Expect(0, 8351, '\P{		super_And_Sub}', "");
    Expect(1, 8351, '\P{^		super_And_Sub}', "");
    Expect(0, 8352, '\p{		super_And_Sub}', "");
    Expect(1, 8352, '\p{^		super_And_Sub}', "");
    Expect(1, 8352, '\P{		super_And_Sub}', "");
    Expect(0, 8352, '\P{^		super_And_Sub}', "");
    Error('\p{:=-IS_SUPER_AND_sub}');
    Error('\P{:=-IS_SUPER_AND_sub}');
    Expect(1, 8351, '\p{issuperandsub}', "");
    Expect(0, 8351, '\p{^issuperandsub}', "");
    Expect(0, 8351, '\P{issuperandsub}', "");
    Expect(1, 8351, '\P{^issuperandsub}', "");
    Expect(0, 8352, '\p{issuperandsub}', "");
    Expect(1, 8352, '\p{^issuperandsub}', "");
    Expect(1, 8352, '\P{issuperandsub}', "");
    Expect(0, 8352, '\P{^issuperandsub}', "");
    Expect(1, 8351, '\p{_IS_Super_And_Sub}', "");
    Expect(0, 8351, '\p{^_IS_Super_And_Sub}', "");
    Expect(0, 8351, '\P{_IS_Super_And_Sub}', "");
    Expect(1, 8351, '\P{^_IS_Super_And_Sub}', "");
    Expect(0, 8352, '\p{_IS_Super_And_Sub}', "");
    Expect(1, 8352, '\p{^_IS_Super_And_Sub}', "");
    Expect(1, 8352, '\P{_IS_Super_And_Sub}', "");
    Expect(0, 8352, '\P{^_IS_Super_And_Sub}', "");
    Error('\p{	in_Super_and_Sub:=}');
    Error('\P{	in_Super_and_Sub:=}');
    Expect(1, 8351, '\p{insuperandsub}', "");
    Expect(0, 8351, '\p{^insuperandsub}', "");
    Expect(0, 8351, '\P{insuperandsub}', "");
    Expect(1, 8351, '\P{^insuperandsub}', "");
    Expect(0, 8352, '\p{insuperandsub}', "");
    Expect(1, 8352, '\p{^insuperandsub}', "");
    Expect(1, 8352, '\P{insuperandsub}', "");
    Expect(0, 8352, '\P{^insuperandsub}', "");
    Expect(1, 8351, '\p{ -IN_Super_and_Sub}', "");
    Expect(0, 8351, '\p{^ -IN_Super_and_Sub}', "");
    Expect(0, 8351, '\P{ -IN_Super_and_Sub}', "");
    Expect(1, 8351, '\P{^ -IN_Super_and_Sub}', "");
    Expect(0, 8352, '\p{ -IN_Super_and_Sub}', "");
    Expect(1, 8352, '\p{^ -IN_Super_and_Sub}', "");
    Expect(1, 8352, '\P{ -IN_Super_and_Sub}', "");
    Expect(0, 8352, '\P{^ -IN_Super_and_Sub}', "");
    Error('\p{_-Supplemental_ARROWS_A/a/}');
    Error('\P{_-Supplemental_ARROWS_A/a/}');
    Expect(1, 10239, '\p{supplementalarrowsa}', "");
    Expect(0, 10239, '\p{^supplementalarrowsa}', "");
    Expect(0, 10239, '\P{supplementalarrowsa}', "");
    Expect(1, 10239, '\P{^supplementalarrowsa}', "");
    Expect(0, 10240, '\p{supplementalarrowsa}', "");
    Expect(1, 10240, '\p{^supplementalarrowsa}', "");
    Expect(1, 10240, '\P{supplementalarrowsa}', "");
    Expect(0, 10240, '\P{^supplementalarrowsa}', "");
    Expect(1, 10239, '\p{ Supplemental_ARROWS_a}', "");
    Expect(0, 10239, '\p{^ Supplemental_ARROWS_a}', "");
    Expect(0, 10239, '\P{ Supplemental_ARROWS_a}', "");
    Expect(1, 10239, '\P{^ Supplemental_ARROWS_a}', "");
    Expect(0, 10240, '\p{ Supplemental_ARROWS_a}', "");
    Expect(1, 10240, '\p{^ Supplemental_ARROWS_a}', "");
    Expect(1, 10240, '\P{ Supplemental_ARROWS_a}', "");
    Expect(0, 10240, '\P{^ Supplemental_ARROWS_a}', "");
    Error('\p{	:=is_Supplemental_Arrows_A}');
    Error('\P{	:=is_Supplemental_Arrows_A}');
    Expect(1, 10239, '\p{issupplementalarrowsa}', "");
    Expect(0, 10239, '\p{^issupplementalarrowsa}', "");
    Expect(0, 10239, '\P{issupplementalarrowsa}', "");
    Expect(1, 10239, '\P{^issupplementalarrowsa}', "");
    Expect(0, 10240, '\p{issupplementalarrowsa}', "");
    Expect(1, 10240, '\p{^issupplementalarrowsa}', "");
    Expect(1, 10240, '\P{issupplementalarrowsa}', "");
    Expect(0, 10240, '\P{^issupplementalarrowsa}', "");
    Expect(1, 10239, '\p{		is_supplemental_Arrows_a}', "");
    Expect(0, 10239, '\p{^		is_supplemental_Arrows_a}', "");
    Expect(0, 10239, '\P{		is_supplemental_Arrows_a}', "");
    Expect(1, 10239, '\P{^		is_supplemental_Arrows_a}', "");
    Expect(0, 10240, '\p{		is_supplemental_Arrows_a}', "");
    Expect(1, 10240, '\p{^		is_supplemental_Arrows_a}', "");
    Expect(1, 10240, '\P{		is_supplemental_Arrows_a}', "");
    Expect(0, 10240, '\P{^		is_supplemental_Arrows_a}', "");
    Error('\p{__In_Supplemental_Arrows_a/a/}');
    Error('\P{__In_Supplemental_Arrows_a/a/}');
    Expect(1, 10239, '\p{insupplementalarrowsa}', "");
    Expect(0, 10239, '\p{^insupplementalarrowsa}', "");
    Expect(0, 10239, '\P{insupplementalarrowsa}', "");
    Expect(1, 10239, '\P{^insupplementalarrowsa}', "");
    Expect(0, 10240, '\p{insupplementalarrowsa}', "");
    Expect(1, 10240, '\p{^insupplementalarrowsa}', "");
    Expect(1, 10240, '\P{insupplementalarrowsa}', "");
    Expect(0, 10240, '\P{^insupplementalarrowsa}', "");
    Expect(1, 10239, '\p{_	in_supplemental_Arrows_A}', "");
    Expect(0, 10239, '\p{^_	in_supplemental_Arrows_A}', "");
    Expect(0, 10239, '\P{_	in_supplemental_Arrows_A}', "");
    Expect(1, 10239, '\P{^_	in_supplemental_Arrows_A}', "");
    Expect(0, 10240, '\p{_	in_supplemental_Arrows_A}', "");
    Expect(1, 10240, '\p{^_	in_supplemental_Arrows_A}', "");
    Expect(1, 10240, '\P{_	in_supplemental_Arrows_A}', "");
    Expect(0, 10240, '\P{^_	in_supplemental_Arrows_A}', "");
    Error('\p{/a/_	SUP_Arrows_A}');
    Error('\P{/a/_	SUP_Arrows_A}');
    Expect(1, 10239, '\p{suparrowsa}', "");
    Expect(0, 10239, '\p{^suparrowsa}', "");
    Expect(0, 10239, '\P{suparrowsa}', "");
    Expect(1, 10239, '\P{^suparrowsa}', "");
    Expect(0, 10240, '\p{suparrowsa}', "");
    Expect(1, 10240, '\p{^suparrowsa}', "");
    Expect(1, 10240, '\P{suparrowsa}', "");
    Expect(0, 10240, '\P{^suparrowsa}', "");
    Expect(1, 10239, '\p{Sup_ARROWS_A}', "");
    Expect(0, 10239, '\p{^Sup_ARROWS_A}', "");
    Expect(0, 10239, '\P{Sup_ARROWS_A}', "");
    Expect(1, 10239, '\P{^Sup_ARROWS_A}', "");
    Expect(0, 10240, '\p{Sup_ARROWS_A}', "");
    Expect(1, 10240, '\p{^Sup_ARROWS_A}', "");
    Expect(1, 10240, '\P{Sup_ARROWS_A}', "");
    Expect(0, 10240, '\P{^Sup_ARROWS_A}', "");
    Error('\p{		IS_sup_arrows_a:=}');
    Error('\P{		IS_sup_arrows_a:=}');
    Expect(1, 10239, '\p{issuparrowsa}', "");
    Expect(0, 10239, '\p{^issuparrowsa}', "");
    Expect(0, 10239, '\P{issuparrowsa}', "");
    Expect(1, 10239, '\P{^issuparrowsa}', "");
    Expect(0, 10240, '\p{issuparrowsa}', "");
    Expect(1, 10240, '\p{^issuparrowsa}', "");
    Expect(1, 10240, '\P{issuparrowsa}', "");
    Expect(0, 10240, '\P{^issuparrowsa}', "");
    Expect(1, 10239, '\p{  Is_sup_arrows_a}', "");
    Expect(0, 10239, '\p{^  Is_sup_arrows_a}', "");
    Expect(0, 10239, '\P{  Is_sup_arrows_a}', "");
    Expect(1, 10239, '\P{^  Is_sup_arrows_a}', "");
    Expect(0, 10240, '\p{  Is_sup_arrows_a}', "");
    Expect(1, 10240, '\p{^  Is_sup_arrows_a}', "");
    Expect(1, 10240, '\P{  Is_sup_arrows_a}', "");
    Expect(0, 10240, '\P{^  Is_sup_arrows_a}', "");
    Error('\p{_IN_SUP_arrows_A/a/}');
    Error('\P{_IN_SUP_arrows_A/a/}');
    Expect(1, 10239, '\p{insuparrowsa}', "");
    Expect(0, 10239, '\p{^insuparrowsa}', "");
    Expect(0, 10239, '\P{insuparrowsa}', "");
    Expect(1, 10239, '\P{^insuparrowsa}', "");
    Expect(0, 10240, '\p{insuparrowsa}', "");
    Expect(1, 10240, '\p{^insuparrowsa}', "");
    Expect(1, 10240, '\P{insuparrowsa}', "");
    Expect(0, 10240, '\P{^insuparrowsa}', "");
    Expect(1, 10239, '\p{ 	IN_sup_ARROWS_A}', "");
    Expect(0, 10239, '\p{^ 	IN_sup_ARROWS_A}', "");
    Expect(0, 10239, '\P{ 	IN_sup_ARROWS_A}', "");
    Expect(1, 10239, '\P{^ 	IN_sup_ARROWS_A}', "");
    Expect(0, 10240, '\p{ 	IN_sup_ARROWS_A}', "");
    Expect(1, 10240, '\p{^ 	IN_sup_ARROWS_A}', "");
    Expect(1, 10240, '\P{ 	IN_sup_ARROWS_A}', "");
    Expect(0, 10240, '\P{^ 	IN_sup_ARROWS_A}', "");
    Error('\p{_	Supplemental_arrows_B/a/}');
    Error('\P{_	Supplemental_arrows_B/a/}');
    Expect(1, 10623, '\p{supplementalarrowsb}', "");
    Expect(0, 10623, '\p{^supplementalarrowsb}', "");
    Expect(0, 10623, '\P{supplementalarrowsb}', "");
    Expect(1, 10623, '\P{^supplementalarrowsb}', "");
    Expect(0, 10624, '\p{supplementalarrowsb}', "");
    Expect(1, 10624, '\p{^supplementalarrowsb}', "");
    Expect(1, 10624, '\P{supplementalarrowsb}', "");
    Expect(0, 10624, '\P{^supplementalarrowsb}', "");
    Expect(1, 10623, '\p{	Supplemental_ARROWS_b}', "");
    Expect(0, 10623, '\p{^	Supplemental_ARROWS_b}', "");
    Expect(0, 10623, '\P{	Supplemental_ARROWS_b}', "");
    Expect(1, 10623, '\P{^	Supplemental_ARROWS_b}', "");
    Expect(0, 10624, '\p{	Supplemental_ARROWS_b}', "");
    Expect(1, 10624, '\p{^	Supplemental_ARROWS_b}', "");
    Expect(1, 10624, '\P{	Supplemental_ARROWS_b}', "");
    Expect(0, 10624, '\P{^	Supplemental_ARROWS_b}', "");
    Error('\p{:=is_supplemental_arrows_B}');
    Error('\P{:=is_supplemental_arrows_B}');
    Expect(1, 10623, '\p{issupplementalarrowsb}', "");
    Expect(0, 10623, '\p{^issupplementalarrowsb}', "");
    Expect(0, 10623, '\P{issupplementalarrowsb}', "");
    Expect(1, 10623, '\P{^issupplementalarrowsb}', "");
    Expect(0, 10624, '\p{issupplementalarrowsb}', "");
    Expect(1, 10624, '\p{^issupplementalarrowsb}', "");
    Expect(1, 10624, '\P{issupplementalarrowsb}', "");
    Expect(0, 10624, '\P{^issupplementalarrowsb}', "");
    Expect(1, 10623, '\p{_ is_Supplemental_Arrows_B}', "");
    Expect(0, 10623, '\p{^_ is_Supplemental_Arrows_B}', "");
    Expect(0, 10623, '\P{_ is_Supplemental_Arrows_B}', "");
    Expect(1, 10623, '\P{^_ is_Supplemental_Arrows_B}', "");
    Expect(0, 10624, '\p{_ is_Supplemental_Arrows_B}', "");
    Expect(1, 10624, '\p{^_ is_Supplemental_Arrows_B}', "");
    Expect(1, 10624, '\P{_ is_Supplemental_Arrows_B}', "");
    Expect(0, 10624, '\P{^_ is_Supplemental_Arrows_B}', "");
    Error('\p{--in_Supplemental_ARROWS_B:=}');
    Error('\P{--in_Supplemental_ARROWS_B:=}');
    Expect(1, 10623, '\p{insupplementalarrowsb}', "");
    Expect(0, 10623, '\p{^insupplementalarrowsb}', "");
    Expect(0, 10623, '\P{insupplementalarrowsb}', "");
    Expect(1, 10623, '\P{^insupplementalarrowsb}', "");
    Expect(0, 10624, '\p{insupplementalarrowsb}', "");
    Expect(1, 10624, '\p{^insupplementalarrowsb}', "");
    Expect(1, 10624, '\P{insupplementalarrowsb}', "");
    Expect(0, 10624, '\P{^insupplementalarrowsb}', "");
    Expect(1, 10623, '\p{_-In_supplemental_arrows_b}', "");
    Expect(0, 10623, '\p{^_-In_supplemental_arrows_b}', "");
    Expect(0, 10623, '\P{_-In_supplemental_arrows_b}', "");
    Expect(1, 10623, '\P{^_-In_supplemental_arrows_b}', "");
    Expect(0, 10624, '\p{_-In_supplemental_arrows_b}', "");
    Expect(1, 10624, '\p{^_-In_supplemental_arrows_b}', "");
    Expect(1, 10624, '\P{_-In_supplemental_arrows_b}', "");
    Expect(0, 10624, '\P{^_-In_supplemental_arrows_b}', "");
    Error('\p{__Sup_ARROWS_B:=}');
    Error('\P{__Sup_ARROWS_B:=}');
    Expect(1, 10623, '\p{suparrowsb}', "");
    Expect(0, 10623, '\p{^suparrowsb}', "");
    Expect(0, 10623, '\P{suparrowsb}', "");
    Expect(1, 10623, '\P{^suparrowsb}', "");
    Expect(0, 10624, '\p{suparrowsb}', "");
    Expect(1, 10624, '\p{^suparrowsb}', "");
    Expect(1, 10624, '\P{suparrowsb}', "");
    Expect(0, 10624, '\P{^suparrowsb}', "");
    Expect(1, 10623, '\p{ SUP_ARROWS_B}', "");
    Expect(0, 10623, '\p{^ SUP_ARROWS_B}', "");
    Expect(0, 10623, '\P{ SUP_ARROWS_B}', "");
    Expect(1, 10623, '\P{^ SUP_ARROWS_B}', "");
    Expect(0, 10624, '\p{ SUP_ARROWS_B}', "");
    Expect(1, 10624, '\p{^ SUP_ARROWS_B}', "");
    Expect(1, 10624, '\P{ SUP_ARROWS_B}', "");
    Expect(0, 10624, '\P{^ SUP_ARROWS_B}', "");
    Error('\p{-	IS_sup_ARROWS_b:=}');
    Error('\P{-	IS_sup_ARROWS_b:=}');
    Expect(1, 10623, '\p{issuparrowsb}', "");
    Expect(0, 10623, '\p{^issuparrowsb}', "");
    Expect(0, 10623, '\P{issuparrowsb}', "");
    Expect(1, 10623, '\P{^issuparrowsb}', "");
    Expect(0, 10624, '\p{issuparrowsb}', "");
    Expect(1, 10624, '\p{^issuparrowsb}', "");
    Expect(1, 10624, '\P{issuparrowsb}', "");
    Expect(0, 10624, '\P{^issuparrowsb}', "");
    Expect(1, 10623, '\p{-_Is_sup_ARROWS_b}', "");
    Expect(0, 10623, '\p{^-_Is_sup_ARROWS_b}', "");
    Expect(0, 10623, '\P{-_Is_sup_ARROWS_b}', "");
    Expect(1, 10623, '\P{^-_Is_sup_ARROWS_b}', "");
    Expect(0, 10624, '\p{-_Is_sup_ARROWS_b}', "");
    Expect(1, 10624, '\p{^-_Is_sup_ARROWS_b}', "");
    Expect(1, 10624, '\P{-_Is_sup_ARROWS_b}', "");
    Expect(0, 10624, '\P{^-_Is_sup_ARROWS_b}', "");
    Error('\p{	 in_SUP_ARROWS_B/a/}');
    Error('\P{	 in_SUP_ARROWS_B/a/}');
    Expect(1, 10623, '\p{insuparrowsb}', "");
    Expect(0, 10623, '\p{^insuparrowsb}', "");
    Expect(0, 10623, '\P{insuparrowsb}', "");
    Expect(1, 10623, '\P{^insuparrowsb}', "");
    Expect(0, 10624, '\p{insuparrowsb}', "");
    Expect(1, 10624, '\p{^insuparrowsb}', "");
    Expect(1, 10624, '\P{insuparrowsb}', "");
    Expect(0, 10624, '\P{^insuparrowsb}', "");
    Expect(1, 10623, '\p{in_Sup_ARROWS_B}', "");
    Expect(0, 10623, '\p{^in_Sup_ARROWS_B}', "");
    Expect(0, 10623, '\P{in_Sup_ARROWS_B}', "");
    Expect(1, 10623, '\P{^in_Sup_ARROWS_B}', "");
    Expect(0, 10624, '\p{in_Sup_ARROWS_B}', "");
    Expect(1, 10624, '\p{^in_Sup_ARROWS_B}', "");
    Expect(1, 10624, '\P{in_Sup_ARROWS_B}', "");
    Expect(0, 10624, '\P{^in_Sup_ARROWS_B}', "");
    Error('\p{:=	SUPPLEMENTAL_Arrows_C}');
    Error('\P{:=	SUPPLEMENTAL_Arrows_C}');
    Expect(1, 129279, '\p{supplementalarrowsc}', "");
    Expect(0, 129279, '\p{^supplementalarrowsc}', "");
    Expect(0, 129279, '\P{supplementalarrowsc}', "");
    Expect(1, 129279, '\P{^supplementalarrowsc}', "");
    Expect(0, 129280, '\p{supplementalarrowsc}', "");
    Expect(1, 129280, '\p{^supplementalarrowsc}', "");
    Expect(1, 129280, '\P{supplementalarrowsc}', "");
    Expect(0, 129280, '\P{^supplementalarrowsc}', "");
    Expect(1, 129279, '\p{ 	Supplemental_Arrows_C}', "");
    Expect(0, 129279, '\p{^ 	Supplemental_Arrows_C}', "");
    Expect(0, 129279, '\P{ 	Supplemental_Arrows_C}', "");
    Expect(1, 129279, '\P{^ 	Supplemental_Arrows_C}', "");
    Expect(0, 129280, '\p{ 	Supplemental_Arrows_C}', "");
    Expect(1, 129280, '\p{^ 	Supplemental_Arrows_C}', "");
    Expect(1, 129280, '\P{ 	Supplemental_Arrows_C}', "");
    Expect(0, 129280, '\P{^ 	Supplemental_Arrows_C}', "");
    Error('\p{	/a/Is_supplemental_Arrows_C}');
    Error('\P{	/a/Is_supplemental_Arrows_C}');
    Expect(1, 129279, '\p{issupplementalarrowsc}', "");
    Expect(0, 129279, '\p{^issupplementalarrowsc}', "");
    Expect(0, 129279, '\P{issupplementalarrowsc}', "");
    Expect(1, 129279, '\P{^issupplementalarrowsc}', "");
    Expect(0, 129280, '\p{issupplementalarrowsc}', "");
    Expect(1, 129280, '\p{^issupplementalarrowsc}', "");
    Expect(1, 129280, '\P{issupplementalarrowsc}', "");
    Expect(0, 129280, '\P{^issupplementalarrowsc}', "");
    Expect(1, 129279, '\p{ -is_Supplemental_arrows_C}', "");
    Expect(0, 129279, '\p{^ -is_Supplemental_arrows_C}', "");
    Expect(0, 129279, '\P{ -is_Supplemental_arrows_C}', "");
    Expect(1, 129279, '\P{^ -is_Supplemental_arrows_C}', "");
    Expect(0, 129280, '\p{ -is_Supplemental_arrows_C}', "");
    Expect(1, 129280, '\p{^ -is_Supplemental_arrows_C}', "");
    Expect(1, 129280, '\P{ -is_Supplemental_arrows_C}', "");
    Expect(0, 129280, '\P{^ -is_Supplemental_arrows_C}', "");
    Error('\p{/a/_In_Supplemental_Arrows_C}');
    Error('\P{/a/_In_Supplemental_Arrows_C}');
    Expect(1, 129279, '\p{insupplementalarrowsc}', "");
    Expect(0, 129279, '\p{^insupplementalarrowsc}', "");
    Expect(0, 129279, '\P{insupplementalarrowsc}', "");
    Expect(1, 129279, '\P{^insupplementalarrowsc}', "");
    Expect(0, 129280, '\p{insupplementalarrowsc}', "");
    Expect(1, 129280, '\p{^insupplementalarrowsc}', "");
    Expect(1, 129280, '\P{insupplementalarrowsc}', "");
    Expect(0, 129280, '\P{^insupplementalarrowsc}', "");
    Expect(1, 129279, '\p{	 IN_Supplemental_ARROWS_C}', "");
    Expect(0, 129279, '\p{^	 IN_Supplemental_ARROWS_C}', "");
    Expect(0, 129279, '\P{	 IN_Supplemental_ARROWS_C}', "");
    Expect(1, 129279, '\P{^	 IN_Supplemental_ARROWS_C}', "");
    Expect(0, 129280, '\p{	 IN_Supplemental_ARROWS_C}', "");
    Expect(1, 129280, '\p{^	 IN_Supplemental_ARROWS_C}', "");
    Expect(1, 129280, '\P{	 IN_Supplemental_ARROWS_C}', "");
    Expect(0, 129280, '\P{^	 IN_Supplemental_ARROWS_C}', "");
    Error('\p{:=Sup_Arrows_C}');
    Error('\P{:=Sup_Arrows_C}');
    Expect(1, 129279, '\p{suparrowsc}', "");
    Expect(0, 129279, '\p{^suparrowsc}', "");
    Expect(0, 129279, '\P{suparrowsc}', "");
    Expect(1, 129279, '\P{^suparrowsc}', "");
    Expect(0, 129280, '\p{suparrowsc}', "");
    Expect(1, 129280, '\p{^suparrowsc}', "");
    Expect(1, 129280, '\P{suparrowsc}', "");
    Expect(0, 129280, '\P{^suparrowsc}', "");
    Expect(1, 129279, '\p{_-Sup_arrows_c}', "");
    Expect(0, 129279, '\p{^_-Sup_arrows_c}', "");
    Expect(0, 129279, '\P{_-Sup_arrows_c}', "");
    Expect(1, 129279, '\P{^_-Sup_arrows_c}', "");
    Expect(0, 129280, '\p{_-Sup_arrows_c}', "");
    Expect(1, 129280, '\p{^_-Sup_arrows_c}', "");
    Expect(1, 129280, '\P{_-Sup_arrows_c}', "");
    Expect(0, 129280, '\P{^_-Sup_arrows_c}', "");
    Error('\p{/a/ _Is_Sup_Arrows_c}');
    Error('\P{/a/ _Is_Sup_Arrows_c}');
    Expect(1, 129279, '\p{issuparrowsc}', "");
    Expect(0, 129279, '\p{^issuparrowsc}', "");
    Expect(0, 129279, '\P{issuparrowsc}', "");
    Expect(1, 129279, '\P{^issuparrowsc}', "");
    Expect(0, 129280, '\p{issuparrowsc}', "");
    Expect(1, 129280, '\p{^issuparrowsc}', "");
    Expect(1, 129280, '\P{issuparrowsc}', "");
    Expect(0, 129280, '\P{^issuparrowsc}', "");
    Expect(1, 129279, '\p{ Is_Sup_Arrows_c}', "");
    Expect(0, 129279, '\p{^ Is_Sup_Arrows_c}', "");
    Expect(0, 129279, '\P{ Is_Sup_Arrows_c}', "");
    Expect(1, 129279, '\P{^ Is_Sup_Arrows_c}', "");
    Expect(0, 129280, '\p{ Is_Sup_Arrows_c}', "");
    Expect(1, 129280, '\p{^ Is_Sup_Arrows_c}', "");
    Expect(1, 129280, '\P{ Is_Sup_Arrows_c}', "");
    Expect(0, 129280, '\P{^ Is_Sup_Arrows_c}', "");
    Error('\p{_:=in_Sup_Arrows_C}');
    Error('\P{_:=in_Sup_Arrows_C}');
    Expect(1, 129279, '\p{insuparrowsc}', "");
    Expect(0, 129279, '\p{^insuparrowsc}', "");
    Expect(0, 129279, '\P{insuparrowsc}', "");
    Expect(1, 129279, '\P{^insuparrowsc}', "");
    Expect(0, 129280, '\p{insuparrowsc}', "");
    Expect(1, 129280, '\p{^insuparrowsc}', "");
    Expect(1, 129280, '\P{insuparrowsc}', "");
    Expect(0, 129280, '\P{^insuparrowsc}', "");
    Expect(1, 129279, '\p{_ in_sup_Arrows_C}', "");
    Expect(0, 129279, '\p{^_ in_sup_Arrows_C}', "");
    Expect(0, 129279, '\P{_ in_sup_Arrows_C}', "");
    Expect(1, 129279, '\P{^_ in_sup_Arrows_C}', "");
    Expect(0, 129280, '\p{_ in_sup_Arrows_C}', "");
    Expect(1, 129280, '\p{^_ in_sup_Arrows_C}', "");
    Expect(1, 129280, '\P{_ in_sup_Arrows_C}', "");
    Expect(0, 129280, '\P{^_ in_sup_Arrows_C}', "");
    Error('\p{:=	supplemental_MATHEMATICAL_Operators}');
    Error('\P{:=	supplemental_MATHEMATICAL_Operators}');
    Expect(1, 11007, '\p{supplementalmathematicaloperators}', "");
    Expect(0, 11007, '\p{^supplementalmathematicaloperators}', "");
    Expect(0, 11007, '\P{supplementalmathematicaloperators}', "");
    Expect(1, 11007, '\P{^supplementalmathematicaloperators}', "");
    Expect(0, 11008, '\p{supplementalmathematicaloperators}', "");
    Expect(1, 11008, '\p{^supplementalmathematicaloperators}', "");
    Expect(1, 11008, '\P{supplementalmathematicaloperators}', "");
    Expect(0, 11008, '\P{^supplementalmathematicaloperators}', "");
    Expect(1, 11007, '\p{Supplemental_mathematical_operators}', "");
    Expect(0, 11007, '\p{^Supplemental_mathematical_operators}', "");
    Expect(0, 11007, '\P{Supplemental_mathematical_operators}', "");
    Expect(1, 11007, '\P{^Supplemental_mathematical_operators}', "");
    Expect(0, 11008, '\p{Supplemental_mathematical_operators}', "");
    Expect(1, 11008, '\p{^Supplemental_mathematical_operators}', "");
    Expect(1, 11008, '\P{Supplemental_mathematical_operators}', "");
    Expect(0, 11008, '\P{^Supplemental_mathematical_operators}', "");
    Error('\p{	:=Is_Supplemental_mathematical_OPERATORS}');
    Error('\P{	:=Is_Supplemental_mathematical_OPERATORS}');
    Expect(1, 11007, '\p{issupplementalmathematicaloperators}', "");
    Expect(0, 11007, '\p{^issupplementalmathematicaloperators}', "");
    Expect(0, 11007, '\P{issupplementalmathematicaloperators}', "");
    Expect(1, 11007, '\P{^issupplementalmathematicaloperators}', "");
    Expect(0, 11008, '\p{issupplementalmathematicaloperators}', "");
    Expect(1, 11008, '\p{^issupplementalmathematicaloperators}', "");
    Expect(1, 11008, '\P{issupplementalmathematicaloperators}', "");
    Expect(0, 11008, '\P{^issupplementalmathematicaloperators}', "");
    Expect(1, 11007, '\p{ _IS_supplemental_MATHEMATICAL_OPERATORS}', "");
    Expect(0, 11007, '\p{^ _IS_supplemental_MATHEMATICAL_OPERATORS}', "");
    Expect(0, 11007, '\P{ _IS_supplemental_MATHEMATICAL_OPERATORS}', "");
    Expect(1, 11007, '\P{^ _IS_supplemental_MATHEMATICAL_OPERATORS}', "");
    Expect(0, 11008, '\p{ _IS_supplemental_MATHEMATICAL_OPERATORS}', "");
    Expect(1, 11008, '\p{^ _IS_supplemental_MATHEMATICAL_OPERATORS}', "");
    Expect(1, 11008, '\P{ _IS_supplemental_MATHEMATICAL_OPERATORS}', "");
    Expect(0, 11008, '\P{^ _IS_supplemental_MATHEMATICAL_OPERATORS}', "");
    Error('\p{-/a/in_Supplemental_Mathematical_Operators}');
    Error('\P{-/a/in_Supplemental_Mathematical_Operators}');
    Expect(1, 11007, '\p{insupplementalmathematicaloperators}', "");
    Expect(0, 11007, '\p{^insupplementalmathematicaloperators}', "");
    Expect(0, 11007, '\P{insupplementalmathematicaloperators}', "");
    Expect(1, 11007, '\P{^insupplementalmathematicaloperators}', "");
    Expect(0, 11008, '\p{insupplementalmathematicaloperators}', "");
    Expect(1, 11008, '\p{^insupplementalmathematicaloperators}', "");
    Expect(1, 11008, '\P{insupplementalmathematicaloperators}', "");
    Expect(0, 11008, '\P{^insupplementalmathematicaloperators}', "");
    Expect(1, 11007, '\p{-_in_SUPPLEMENTAL_Mathematical_operators}', "");
    Expect(0, 11007, '\p{^-_in_SUPPLEMENTAL_Mathematical_operators}', "");
    Expect(0, 11007, '\P{-_in_SUPPLEMENTAL_Mathematical_operators}', "");
    Expect(1, 11007, '\P{^-_in_SUPPLEMENTAL_Mathematical_operators}', "");
    Expect(0, 11008, '\p{-_in_SUPPLEMENTAL_Mathematical_operators}', "");
    Expect(1, 11008, '\p{^-_in_SUPPLEMENTAL_Mathematical_operators}', "");
    Expect(1, 11008, '\P{-_in_SUPPLEMENTAL_Mathematical_operators}', "");
    Expect(0, 11008, '\P{^-_in_SUPPLEMENTAL_Mathematical_operators}', "");
    Error('\p{-:=Sup_Math_Operators}');
    Error('\P{-:=Sup_Math_Operators}');
    Expect(1, 11007, '\p{supmathoperators}', "");
    Expect(0, 11007, '\p{^supmathoperators}', "");
    Expect(0, 11007, '\P{supmathoperators}', "");
    Expect(1, 11007, '\P{^supmathoperators}', "");
    Expect(0, 11008, '\p{supmathoperators}', "");
    Expect(1, 11008, '\p{^supmathoperators}', "");
    Expect(1, 11008, '\P{supmathoperators}', "");
    Expect(0, 11008, '\P{^supmathoperators}', "");
    Expect(1, 11007, '\p{--sup_Math_OPERATORS}', "");
    Expect(0, 11007, '\p{^--sup_Math_OPERATORS}', "");
    Expect(0, 11007, '\P{--sup_Math_OPERATORS}', "");
    Expect(1, 11007, '\P{^--sup_Math_OPERATORS}', "");
    Expect(0, 11008, '\p{--sup_Math_OPERATORS}', "");
    Expect(1, 11008, '\p{^--sup_Math_OPERATORS}', "");
    Expect(1, 11008, '\P{--sup_Math_OPERATORS}', "");
    Expect(0, 11008, '\P{^--sup_Math_OPERATORS}', "");
    Error('\p{/a/-_is_Sup_Math_OPERATORS}');
    Error('\P{/a/-_is_Sup_Math_OPERATORS}');
    Expect(1, 11007, '\p{issupmathoperators}', "");
    Expect(0, 11007, '\p{^issupmathoperators}', "");
    Expect(0, 11007, '\P{issupmathoperators}', "");
    Expect(1, 11007, '\P{^issupmathoperators}', "");
    Expect(0, 11008, '\p{issupmathoperators}', "");
    Expect(1, 11008, '\p{^issupmathoperators}', "");
    Expect(1, 11008, '\P{issupmathoperators}', "");
    Expect(0, 11008, '\P{^issupmathoperators}', "");
    Expect(1, 11007, '\p{		Is_Sup_MATH_OPERATORS}', "");
    Expect(0, 11007, '\p{^		Is_Sup_MATH_OPERATORS}', "");
    Expect(0, 11007, '\P{		Is_Sup_MATH_OPERATORS}', "");
    Expect(1, 11007, '\P{^		Is_Sup_MATH_OPERATORS}', "");
    Expect(0, 11008, '\p{		Is_Sup_MATH_OPERATORS}', "");
    Expect(1, 11008, '\p{^		Is_Sup_MATH_OPERATORS}', "");
    Expect(1, 11008, '\P{		Is_Sup_MATH_OPERATORS}', "");
    Expect(0, 11008, '\P{^		Is_Sup_MATH_OPERATORS}', "");
    Error('\p{ in_Sup_MATH_Operators:=}');
    Error('\P{ in_Sup_MATH_Operators:=}');
    Expect(1, 11007, '\p{insupmathoperators}', "");
    Expect(0, 11007, '\p{^insupmathoperators}', "");
    Expect(0, 11007, '\P{insupmathoperators}', "");
    Expect(1, 11007, '\P{^insupmathoperators}', "");
    Expect(0, 11008, '\p{insupmathoperators}', "");
    Expect(1, 11008, '\p{^insupmathoperators}', "");
    Expect(1, 11008, '\P{insupmathoperators}', "");
    Expect(0, 11008, '\P{^insupmathoperators}', "");
    Expect(1, 11007, '\p{	_In_Sup_math_Operators}', "");
    Expect(0, 11007, '\p{^	_In_Sup_math_Operators}', "");
    Expect(0, 11007, '\P{	_In_Sup_math_Operators}', "");
    Expect(1, 11007, '\P{^	_In_Sup_math_Operators}', "");
    Expect(0, 11008, '\p{	_In_Sup_math_Operators}', "");
    Expect(1, 11008, '\p{^	_In_Sup_math_Operators}', "");
    Expect(1, 11008, '\P{	_In_Sup_math_Operators}', "");
    Expect(0, 11008, '\P{^	_In_Sup_math_Operators}', "");
    Error('\p{	/a/Supplemental_PUNCTUATION}');
    Error('\P{	/a/Supplemental_PUNCTUATION}');
    Expect(1, 11903, '\p{supplementalpunctuation}', "");
    Expect(0, 11903, '\p{^supplementalpunctuation}', "");
    Expect(0, 11903, '\P{supplementalpunctuation}', "");
    Expect(1, 11903, '\P{^supplementalpunctuation}', "");
    Expect(0, 11904, '\p{supplementalpunctuation}', "");
    Expect(1, 11904, '\p{^supplementalpunctuation}', "");
    Expect(1, 11904, '\P{supplementalpunctuation}', "");
    Expect(0, 11904, '\P{^supplementalpunctuation}', "");
    Expect(1, 11903, '\p{ _supplemental_Punctuation}', "");
    Expect(0, 11903, '\p{^ _supplemental_Punctuation}', "");
    Expect(0, 11903, '\P{ _supplemental_Punctuation}', "");
    Expect(1, 11903, '\P{^ _supplemental_Punctuation}', "");
    Expect(0, 11904, '\p{ _supplemental_Punctuation}', "");
    Expect(1, 11904, '\p{^ _supplemental_Punctuation}', "");
    Expect(1, 11904, '\P{ _supplemental_Punctuation}', "");
    Expect(0, 11904, '\P{^ _supplemental_Punctuation}', "");
    Error('\p{/a/-	is_Supplemental_Punctuation}');
    Error('\P{/a/-	is_Supplemental_Punctuation}');
    Expect(1, 11903, '\p{issupplementalpunctuation}', "");
    Expect(0, 11903, '\p{^issupplementalpunctuation}', "");
    Expect(0, 11903, '\P{issupplementalpunctuation}', "");
    Expect(1, 11903, '\P{^issupplementalpunctuation}', "");
    Expect(0, 11904, '\p{issupplementalpunctuation}', "");
    Expect(1, 11904, '\p{^issupplementalpunctuation}', "");
    Expect(1, 11904, '\P{issupplementalpunctuation}', "");
    Expect(0, 11904, '\P{^issupplementalpunctuation}', "");
    Expect(1, 11903, '\p{ 	IS_Supplemental_PUNCTUATION}', "");
    Expect(0, 11903, '\p{^ 	IS_Supplemental_PUNCTUATION}', "");
    Expect(0, 11903, '\P{ 	IS_Supplemental_PUNCTUATION}', "");
    Expect(1, 11903, '\P{^ 	IS_Supplemental_PUNCTUATION}', "");
    Expect(0, 11904, '\p{ 	IS_Supplemental_PUNCTUATION}', "");
    Expect(1, 11904, '\p{^ 	IS_Supplemental_PUNCTUATION}', "");
    Expect(1, 11904, '\P{ 	IS_Supplemental_PUNCTUATION}', "");
    Expect(0, 11904, '\P{^ 	IS_Supplemental_PUNCTUATION}', "");
    Error('\p{ -In_supplemental_Punctuation/a/}');
    Error('\P{ -In_supplemental_Punctuation/a/}');
    Expect(1, 11903, '\p{insupplementalpunctuation}', "");
    Expect(0, 11903, '\p{^insupplementalpunctuation}', "");
    Expect(0, 11903, '\P{insupplementalpunctuation}', "");
    Expect(1, 11903, '\P{^insupplementalpunctuation}', "");
    Expect(0, 11904, '\p{insupplementalpunctuation}', "");
    Expect(1, 11904, '\p{^insupplementalpunctuation}', "");
    Expect(1, 11904, '\P{insupplementalpunctuation}', "");
    Expect(0, 11904, '\P{^insupplementalpunctuation}', "");
    Expect(1, 11903, '\p{-_in_SUPPLEMENTAL_PUNCTUATION}', "");
    Expect(0, 11903, '\p{^-_in_SUPPLEMENTAL_PUNCTUATION}', "");
    Expect(0, 11903, '\P{-_in_SUPPLEMENTAL_PUNCTUATION}', "");
    Expect(1, 11903, '\P{^-_in_SUPPLEMENTAL_PUNCTUATION}', "");
    Expect(0, 11904, '\p{-_in_SUPPLEMENTAL_PUNCTUATION}', "");
    Expect(1, 11904, '\p{^-_in_SUPPLEMENTAL_PUNCTUATION}', "");
    Expect(1, 11904, '\P{-_in_SUPPLEMENTAL_PUNCTUATION}', "");
    Expect(0, 11904, '\P{^-_in_SUPPLEMENTAL_PUNCTUATION}', "");
    Error('\p{	/a/sup_punctuation}');
    Error('\P{	/a/sup_punctuation}');
    Expect(1, 11903, '\p{suppunctuation}', "");
    Expect(0, 11903, '\p{^suppunctuation}', "");
    Expect(0, 11903, '\P{suppunctuation}', "");
    Expect(1, 11903, '\P{^suppunctuation}', "");
    Expect(0, 11904, '\p{suppunctuation}', "");
    Expect(1, 11904, '\p{^suppunctuation}', "");
    Expect(1, 11904, '\P{suppunctuation}', "");
    Expect(0, 11904, '\P{^suppunctuation}', "");
    Expect(1, 11903, '\p{	_SUP_Punctuation}', "");
    Expect(0, 11903, '\p{^	_SUP_Punctuation}', "");
    Expect(0, 11903, '\P{	_SUP_Punctuation}', "");
    Expect(1, 11903, '\P{^	_SUP_Punctuation}', "");
    Expect(0, 11904, '\p{	_SUP_Punctuation}', "");
    Expect(1, 11904, '\p{^	_SUP_Punctuation}', "");
    Expect(1, 11904, '\P{	_SUP_Punctuation}', "");
    Expect(0, 11904, '\P{^	_SUP_Punctuation}', "");
    Error('\p{:=		Is_SUP_punctuation}');
    Error('\P{:=		Is_SUP_punctuation}');
    Expect(1, 11903, '\p{issuppunctuation}', "");
    Expect(0, 11903, '\p{^issuppunctuation}', "");
    Expect(0, 11903, '\P{issuppunctuation}', "");
    Expect(1, 11903, '\P{^issuppunctuation}', "");
    Expect(0, 11904, '\p{issuppunctuation}', "");
    Expect(1, 11904, '\p{^issuppunctuation}', "");
    Expect(1, 11904, '\P{issuppunctuation}', "");
    Expect(0, 11904, '\P{^issuppunctuation}', "");
    Expect(1, 11903, '\p{-Is_Sup_punctuation}', "");
    Expect(0, 11903, '\p{^-Is_Sup_punctuation}', "");
    Expect(0, 11903, '\P{-Is_Sup_punctuation}', "");
    Expect(1, 11903, '\P{^-Is_Sup_punctuation}', "");
    Expect(0, 11904, '\p{-Is_Sup_punctuation}', "");
    Expect(1, 11904, '\p{^-Is_Sup_punctuation}', "");
    Expect(1, 11904, '\P{-Is_Sup_punctuation}', "");
    Expect(0, 11904, '\P{^-Is_Sup_punctuation}', "");
    Error('\p{ In_sup_Punctuation/a/}');
    Error('\P{ In_sup_Punctuation/a/}');
    Expect(1, 11903, '\p{insuppunctuation}', "");
    Expect(0, 11903, '\p{^insuppunctuation}', "");
    Expect(0, 11903, '\P{insuppunctuation}', "");
    Expect(1, 11903, '\P{^insuppunctuation}', "");
    Expect(0, 11904, '\p{insuppunctuation}', "");
    Expect(1, 11904, '\p{^insuppunctuation}', "");
    Expect(1, 11904, '\P{insuppunctuation}', "");
    Expect(0, 11904, '\P{^insuppunctuation}', "");
    Expect(1, 11903, '\p{ _in_Sup_Punctuation}', "");
    Expect(0, 11903, '\p{^ _in_Sup_Punctuation}', "");
    Expect(0, 11903, '\P{ _in_Sup_Punctuation}', "");
    Expect(1, 11903, '\P{^ _in_Sup_Punctuation}', "");
    Expect(0, 11904, '\p{ _in_Sup_Punctuation}', "");
    Expect(1, 11904, '\p{^ _in_Sup_Punctuation}', "");
    Expect(1, 11904, '\P{ _in_Sup_Punctuation}', "");
    Expect(0, 11904, '\P{^ _in_Sup_Punctuation}', "");
    Error('\p{:=_-supplemental_Symbols_and_Pictographs}');
    Error('\P{:=_-supplemental_Symbols_and_Pictographs}');
    Expect(1, 129535, '\p{supplementalsymbolsandpictographs}', "");
    Expect(0, 129535, '\p{^supplementalsymbolsandpictographs}', "");
    Expect(0, 129535, '\P{supplementalsymbolsandpictographs}', "");
    Expect(1, 129535, '\P{^supplementalsymbolsandpictographs}', "");
    Expect(0, 129536, '\p{supplementalsymbolsandpictographs}', "");
    Expect(1, 129536, '\p{^supplementalsymbolsandpictographs}', "");
    Expect(1, 129536, '\P{supplementalsymbolsandpictographs}', "");
    Expect(0, 129536, '\P{^supplementalsymbolsandpictographs}', "");
    Expect(1, 129535, '\p{ SUPPLEMENTAL_symbols_And_PICTOGRAPHS}', "");
    Expect(0, 129535, '\p{^ SUPPLEMENTAL_symbols_And_PICTOGRAPHS}', "");
    Expect(0, 129535, '\P{ SUPPLEMENTAL_symbols_And_PICTOGRAPHS}', "");
    Expect(1, 129535, '\P{^ SUPPLEMENTAL_symbols_And_PICTOGRAPHS}', "");
    Expect(0, 129536, '\p{ SUPPLEMENTAL_symbols_And_PICTOGRAPHS}', "");
    Expect(1, 129536, '\p{^ SUPPLEMENTAL_symbols_And_PICTOGRAPHS}', "");
    Expect(1, 129536, '\P{ SUPPLEMENTAL_symbols_And_PICTOGRAPHS}', "");
    Expect(0, 129536, '\P{^ SUPPLEMENTAL_symbols_And_PICTOGRAPHS}', "");
    Error('\p{_Is_supplemental_Symbols_And_PICTOGRAPHS/a/}');
    Error('\P{_Is_supplemental_Symbols_And_PICTOGRAPHS/a/}');
    Expect(1, 129535, '\p{issupplementalsymbolsandpictographs}', "");
    Expect(0, 129535, '\p{^issupplementalsymbolsandpictographs}', "");
    Expect(0, 129535, '\P{issupplementalsymbolsandpictographs}', "");
    Expect(1, 129535, '\P{^issupplementalsymbolsandpictographs}', "");
    Expect(0, 129536, '\p{issupplementalsymbolsandpictographs}', "");
    Expect(1, 129536, '\p{^issupplementalsymbolsandpictographs}', "");
    Expect(1, 129536, '\P{issupplementalsymbolsandpictographs}', "");
    Expect(0, 129536, '\P{^issupplementalsymbolsandpictographs}', "");
    Expect(1, 129535, '\p{ is_Supplemental_Symbols_And_Pictographs}', "");
    Expect(0, 129535, '\p{^ is_Supplemental_Symbols_And_Pictographs}', "");
    Expect(0, 129535, '\P{ is_Supplemental_Symbols_And_Pictographs}', "");
    Expect(1, 129535, '\P{^ is_Supplemental_Symbols_And_Pictographs}', "");
    Expect(0, 129536, '\p{ is_Supplemental_Symbols_And_Pictographs}', "");
    Expect(1, 129536, '\p{^ is_Supplemental_Symbols_And_Pictographs}', "");
    Expect(1, 129536, '\P{ is_Supplemental_Symbols_And_Pictographs}', "");
    Expect(0, 129536, '\P{^ is_Supplemental_Symbols_And_Pictographs}', "");
    Error('\p{	_IN_Supplemental_SYMBOLS_and_PICTOGRAPHS:=}');
    Error('\P{	_IN_Supplemental_SYMBOLS_and_PICTOGRAPHS:=}');
    Expect(1, 129535, '\p{insupplementalsymbolsandpictographs}', "");
    Expect(0, 129535, '\p{^insupplementalsymbolsandpictographs}', "");
    Expect(0, 129535, '\P{insupplementalsymbolsandpictographs}', "");
    Expect(1, 129535, '\P{^insupplementalsymbolsandpictographs}', "");
    Expect(0, 129536, '\p{insupplementalsymbolsandpictographs}', "");
    Expect(1, 129536, '\p{^insupplementalsymbolsandpictographs}', "");
    Expect(1, 129536, '\P{insupplementalsymbolsandpictographs}', "");
    Expect(0, 129536, '\P{^insupplementalsymbolsandpictographs}', "");
    Expect(1, 129535, '\p{_In_SUPPLEMENTAL_Symbols_AND_Pictographs}', "");
    Expect(0, 129535, '\p{^_In_SUPPLEMENTAL_Symbols_AND_Pictographs}', "");
    Expect(0, 129535, '\P{_In_SUPPLEMENTAL_Symbols_AND_Pictographs}', "");
    Expect(1, 129535, '\P{^_In_SUPPLEMENTAL_Symbols_AND_Pictographs}', "");
    Expect(0, 129536, '\p{_In_SUPPLEMENTAL_Symbols_AND_Pictographs}', "");
    Expect(1, 129536, '\p{^_In_SUPPLEMENTAL_Symbols_AND_Pictographs}', "");
    Expect(1, 129536, '\P{_In_SUPPLEMENTAL_Symbols_AND_Pictographs}', "");
    Expect(0, 129536, '\P{^_In_SUPPLEMENTAL_Symbols_AND_Pictographs}', "");
    Error('\p{:=		sup_symbols_AND_PICTOGRAPHS}');
    Error('\P{:=		sup_symbols_AND_PICTOGRAPHS}');
    Expect(1, 129535, '\p{supsymbolsandpictographs}', "");
    Expect(0, 129535, '\p{^supsymbolsandpictographs}', "");
    Expect(0, 129535, '\P{supsymbolsandpictographs}', "");
    Expect(1, 129535, '\P{^supsymbolsandpictographs}', "");
    Expect(0, 129536, '\p{supsymbolsandpictographs}', "");
    Expect(1, 129536, '\p{^supsymbolsandpictographs}', "");
    Expect(1, 129536, '\P{supsymbolsandpictographs}', "");
    Expect(0, 129536, '\P{^supsymbolsandpictographs}', "");
    Expect(1, 129535, '\p{		Sup_Symbols_And_PICTOGRAPHS}', "");
    Expect(0, 129535, '\p{^		Sup_Symbols_And_PICTOGRAPHS}', "");
    Expect(0, 129535, '\P{		Sup_Symbols_And_PICTOGRAPHS}', "");
    Expect(1, 129535, '\P{^		Sup_Symbols_And_PICTOGRAPHS}', "");
    Expect(0, 129536, '\p{		Sup_Symbols_And_PICTOGRAPHS}', "");
    Expect(1, 129536, '\p{^		Sup_Symbols_And_PICTOGRAPHS}', "");
    Expect(1, 129536, '\P{		Sup_Symbols_And_PICTOGRAPHS}', "");
    Expect(0, 129536, '\P{^		Sup_Symbols_And_PICTOGRAPHS}', "");
    Error('\p{_-Is_Sup_SYMBOLS_AND_PICTOGRAPHS/a/}');
    Error('\P{_-Is_Sup_SYMBOLS_AND_PICTOGRAPHS/a/}');
    Expect(1, 129535, '\p{issupsymbolsandpictographs}', "");
    Expect(0, 129535, '\p{^issupsymbolsandpictographs}', "");
    Expect(0, 129535, '\P{issupsymbolsandpictographs}', "");
    Expect(1, 129535, '\P{^issupsymbolsandpictographs}', "");
    Expect(0, 129536, '\p{issupsymbolsandpictographs}', "");
    Expect(1, 129536, '\p{^issupsymbolsandpictographs}', "");
    Expect(1, 129536, '\P{issupsymbolsandpictographs}', "");
    Expect(0, 129536, '\P{^issupsymbolsandpictographs}', "");
    Expect(1, 129535, '\p{__IS_Sup_symbols_And_pictographs}', "");
    Expect(0, 129535, '\p{^__IS_Sup_symbols_And_pictographs}', "");
    Expect(0, 129535, '\P{__IS_Sup_symbols_And_pictographs}', "");
    Expect(1, 129535, '\P{^__IS_Sup_symbols_And_pictographs}', "");
    Expect(0, 129536, '\p{__IS_Sup_symbols_And_pictographs}', "");
    Expect(1, 129536, '\p{^__IS_Sup_symbols_And_pictographs}', "");
    Expect(1, 129536, '\P{__IS_Sup_symbols_And_pictographs}', "");
    Expect(0, 129536, '\P{^__IS_Sup_symbols_And_pictographs}', "");
    Error('\p{:=-In_sup_symbols_And_Pictographs}');
    Error('\P{:=-In_sup_symbols_And_Pictographs}');
    Expect(1, 129535, '\p{insupsymbolsandpictographs}', "");
    Expect(0, 129535, '\p{^insupsymbolsandpictographs}', "");
    Expect(0, 129535, '\P{insupsymbolsandpictographs}', "");
    Expect(1, 129535, '\P{^insupsymbolsandpictographs}', "");
    Expect(0, 129536, '\p{insupsymbolsandpictographs}', "");
    Expect(1, 129536, '\p{^insupsymbolsandpictographs}', "");
    Expect(1, 129536, '\P{insupsymbolsandpictographs}', "");
    Expect(0, 129536, '\P{^insupsymbolsandpictographs}', "");
    Expect(1, 129535, '\p{	In_sup_SYMBOLS_And_pictographs}', "");
    Expect(0, 129535, '\p{^	In_sup_SYMBOLS_And_pictographs}', "");
    Expect(0, 129535, '\P{	In_sup_SYMBOLS_And_pictographs}', "");
    Expect(1, 129535, '\P{^	In_sup_SYMBOLS_And_pictographs}', "");
    Expect(0, 129536, '\p{	In_sup_SYMBOLS_And_pictographs}', "");
    Expect(1, 129536, '\p{^	In_sup_SYMBOLS_And_pictographs}', "");
    Expect(1, 129536, '\P{	In_sup_SYMBOLS_And_pictographs}', "");
    Expect(0, 129536, '\P{^	In_sup_SYMBOLS_And_pictographs}', "");
    Error('\p{/a/ -SUPPLEMENTARY_PRIVATE_Use_Area_A}');
    Error('\P{/a/ -SUPPLEMENTARY_PRIVATE_Use_Area_A}');
    Expect(1, 983040, '\p{supplementaryprivateuseareaa}', "");
    Expect(0, 983040, '\p{^supplementaryprivateuseareaa}', "");
    Expect(0, 983040, '\P{supplementaryprivateuseareaa}', "");
    Expect(1, 983040, '\P{^supplementaryprivateuseareaa}', "");
    Expect(0, 1048576, '\p{supplementaryprivateuseareaa}', "");
    Expect(1, 1048576, '\p{^supplementaryprivateuseareaa}', "");
    Expect(1, 1048576, '\P{supplementaryprivateuseareaa}', "");
    Expect(0, 1048576, '\P{^supplementaryprivateuseareaa}', "");
    Expect(1, 983040, '\p{-_Supplementary_Private_use_AREA_A}', "");
    Expect(0, 983040, '\p{^-_Supplementary_Private_use_AREA_A}', "");
    Expect(0, 983040, '\P{-_Supplementary_Private_use_AREA_A}', "");
    Expect(1, 983040, '\P{^-_Supplementary_Private_use_AREA_A}', "");
    Expect(0, 1048576, '\p{-_Supplementary_Private_use_AREA_A}', "");
    Expect(1, 1048576, '\p{^-_Supplementary_Private_use_AREA_A}', "");
    Expect(1, 1048576, '\P{-_Supplementary_Private_use_AREA_A}', "");
    Expect(0, 1048576, '\P{^-_Supplementary_Private_use_AREA_A}', "");
    Error('\p{ /a/Is_supplementary_private_USE_AREA_A}');
    Error('\P{ /a/Is_supplementary_private_USE_AREA_A}');
    Expect(1, 983040, '\p{issupplementaryprivateuseareaa}', "");
    Expect(0, 983040, '\p{^issupplementaryprivateuseareaa}', "");
    Expect(0, 983040, '\P{issupplementaryprivateuseareaa}', "");
    Expect(1, 983040, '\P{^issupplementaryprivateuseareaa}', "");
    Expect(0, 1048576, '\p{issupplementaryprivateuseareaa}', "");
    Expect(1, 1048576, '\p{^issupplementaryprivateuseareaa}', "");
    Expect(1, 1048576, '\P{issupplementaryprivateuseareaa}', "");
    Expect(0, 1048576, '\P{^issupplementaryprivateuseareaa}', "");
    Expect(1, 983040, '\p{	 IS_SUPPLEMENTARY_PRIVATE_Use_Area_A}', "");
    Expect(0, 983040, '\p{^	 IS_SUPPLEMENTARY_PRIVATE_Use_Area_A}', "");
    Expect(0, 983040, '\P{	 IS_SUPPLEMENTARY_PRIVATE_Use_Area_A}', "");
    Expect(1, 983040, '\P{^	 IS_SUPPLEMENTARY_PRIVATE_Use_Area_A}', "");
    Expect(0, 1048576, '\p{	 IS_SUPPLEMENTARY_PRIVATE_Use_Area_A}', "");
    Expect(1, 1048576, '\p{^	 IS_SUPPLEMENTARY_PRIVATE_Use_Area_A}', "");
    Expect(1, 1048576, '\P{	 IS_SUPPLEMENTARY_PRIVATE_Use_Area_A}', "");
    Expect(0, 1048576, '\P{^	 IS_SUPPLEMENTARY_PRIVATE_Use_Area_A}', "");
    Error('\p{:=		In_Supplementary_Private_Use_Area_a}');
    Error('\P{:=		In_Supplementary_Private_Use_Area_a}');
    Expect(1, 983040, '\p{insupplementaryprivateuseareaa}', "");
    Expect(0, 983040, '\p{^insupplementaryprivateuseareaa}', "");
    Expect(0, 983040, '\P{insupplementaryprivateuseareaa}', "");
    Expect(1, 983040, '\P{^insupplementaryprivateuseareaa}', "");
    Expect(0, 1048576, '\p{insupplementaryprivateuseareaa}', "");
    Expect(1, 1048576, '\p{^insupplementaryprivateuseareaa}', "");
    Expect(1, 1048576, '\P{insupplementaryprivateuseareaa}', "");
    Expect(0, 1048576, '\P{^insupplementaryprivateuseareaa}', "");
    Expect(1, 983040, '\p{	-IN_SUPPLEMENTARY_Private_Use_AREA_a}', "");
    Expect(0, 983040, '\p{^	-IN_SUPPLEMENTARY_Private_Use_AREA_a}', "");
    Expect(0, 983040, '\P{	-IN_SUPPLEMENTARY_Private_Use_AREA_a}', "");
    Expect(1, 983040, '\P{^	-IN_SUPPLEMENTARY_Private_Use_AREA_a}', "");
    Expect(0, 1048576, '\p{	-IN_SUPPLEMENTARY_Private_Use_AREA_a}', "");
    Expect(1, 1048576, '\p{^	-IN_SUPPLEMENTARY_Private_Use_AREA_a}', "");
    Expect(1, 1048576, '\P{	-IN_SUPPLEMENTARY_Private_Use_AREA_a}', "");
    Expect(0, 1048576, '\P{^	-IN_SUPPLEMENTARY_Private_Use_AREA_a}', "");
    Error('\p{Sup_pua_A:=}');
    Error('\P{Sup_pua_A:=}');
    Expect(1, 983040, '\p{suppuaa}', "");
    Expect(0, 983040, '\p{^suppuaa}', "");
    Expect(0, 983040, '\P{suppuaa}', "");
    Expect(1, 983040, '\P{^suppuaa}', "");
    Expect(0, 1048576, '\p{suppuaa}', "");
    Expect(1, 1048576, '\p{^suppuaa}', "");
    Expect(1, 1048576, '\P{suppuaa}', "");
    Expect(0, 1048576, '\P{^suppuaa}', "");
    Expect(1, 983040, '\p{		Sup_PUA_A}', "");
    Expect(0, 983040, '\p{^		Sup_PUA_A}', "");
    Expect(0, 983040, '\P{		Sup_PUA_A}', "");
    Expect(1, 983040, '\P{^		Sup_PUA_A}', "");
    Expect(0, 1048576, '\p{		Sup_PUA_A}', "");
    Expect(1, 1048576, '\p{^		Sup_PUA_A}', "");
    Expect(1, 1048576, '\P{		Sup_PUA_A}', "");
    Expect(0, 1048576, '\P{^		Sup_PUA_A}', "");
    Error('\p{/a/-	Is_Sup_PUA_a}');
    Error('\P{/a/-	Is_Sup_PUA_a}');
    Expect(1, 983040, '\p{issuppuaa}', "");
    Expect(0, 983040, '\p{^issuppuaa}', "");
    Expect(0, 983040, '\P{issuppuaa}', "");
    Expect(1, 983040, '\P{^issuppuaa}', "");
    Expect(0, 1048576, '\p{issuppuaa}', "");
    Expect(1, 1048576, '\p{^issuppuaa}', "");
    Expect(1, 1048576, '\P{issuppuaa}', "");
    Expect(0, 1048576, '\P{^issuppuaa}', "");
    Expect(1, 983040, '\p{-IS_SUP_PUA_A}', "");
    Expect(0, 983040, '\p{^-IS_SUP_PUA_A}', "");
    Expect(0, 983040, '\P{-IS_SUP_PUA_A}', "");
    Expect(1, 983040, '\P{^-IS_SUP_PUA_A}', "");
    Expect(0, 1048576, '\p{-IS_SUP_PUA_A}', "");
    Expect(1, 1048576, '\p{^-IS_SUP_PUA_A}', "");
    Expect(1, 1048576, '\P{-IS_SUP_PUA_A}', "");
    Expect(0, 1048576, '\P{^-IS_SUP_PUA_A}', "");
    Error('\p{ 	In_Sup_PUA_A/a/}');
    Error('\P{ 	In_Sup_PUA_A/a/}');
    Expect(1, 983040, '\p{insuppuaa}', "");
    Expect(0, 983040, '\p{^insuppuaa}', "");
    Expect(0, 983040, '\P{insuppuaa}', "");
    Expect(1, 983040, '\P{^insuppuaa}', "");
    Expect(0, 1048576, '\p{insuppuaa}', "");
    Expect(1, 1048576, '\p{^insuppuaa}', "");
    Expect(1, 1048576, '\P{insuppuaa}', "");
    Expect(0, 1048576, '\P{^insuppuaa}', "");
    Expect(1, 983040, '\p{_ IN_Sup_pua_A}', "");
    Expect(0, 983040, '\p{^_ IN_Sup_pua_A}', "");
    Expect(0, 983040, '\P{_ IN_Sup_pua_A}', "");
    Expect(1, 983040, '\P{^_ IN_Sup_pua_A}', "");
    Expect(0, 1048576, '\p{_ IN_Sup_pua_A}', "");
    Expect(1, 1048576, '\p{^_ IN_Sup_pua_A}', "");
    Expect(1, 1048576, '\P{_ IN_Sup_pua_A}', "");
    Expect(0, 1048576, '\P{^_ IN_Sup_pua_A}', "");
    Error('\p{/a/-supplementary_PRIVATE_use_AREA_B}');
    Error('\P{/a/-supplementary_PRIVATE_use_AREA_B}');
    Expect(1, 1048576, '\p{supplementaryprivateuseareab}', "");
    Expect(0, 1048576, '\p{^supplementaryprivateuseareab}', "");
    Expect(0, 1048576, '\P{supplementaryprivateuseareab}', "");
    Expect(1, 1048576, '\P{^supplementaryprivateuseareab}', "");
    Expect(0, 1, '\p{supplementaryprivateuseareab}', "");
    Expect(1, 1, '\p{^supplementaryprivateuseareab}', "");
    Expect(1, 1, '\P{supplementaryprivateuseareab}', "");
    Expect(0, 1, '\P{^supplementaryprivateuseareab}', "");
    Expect(1, 1048576, '\p{_-Supplementary_Private_use_Area_B}', "");
    Expect(0, 1048576, '\p{^_-Supplementary_Private_use_Area_B}', "");
    Expect(0, 1048576, '\P{_-Supplementary_Private_use_Area_B}', "");
    Expect(1, 1048576, '\P{^_-Supplementary_Private_use_Area_B}', "");
    Expect(0, 1, '\p{_-Supplementary_Private_use_Area_B}', "");
    Expect(1, 1, '\p{^_-Supplementary_Private_use_Area_B}', "");
    Expect(1, 1, '\P{_-Supplementary_Private_use_Area_B}', "");
    Expect(0, 1, '\P{^_-Supplementary_Private_use_Area_B}', "");
    Error('\p{is_supplementary_private_use_AREA_B/a/}');
    Error('\P{is_supplementary_private_use_AREA_B/a/}');
    Expect(1, 1048576, '\p{issupplementaryprivateuseareab}', "");
    Expect(0, 1048576, '\p{^issupplementaryprivateuseareab}', "");
    Expect(0, 1048576, '\P{issupplementaryprivateuseareab}', "");
    Expect(1, 1048576, '\P{^issupplementaryprivateuseareab}', "");
    Expect(0, 1, '\p{issupplementaryprivateuseareab}', "");
    Expect(1, 1, '\p{^issupplementaryprivateuseareab}', "");
    Expect(1, 1, '\P{issupplementaryprivateuseareab}', "");
    Expect(0, 1, '\P{^issupplementaryprivateuseareab}', "");
    Expect(1, 1048576, '\p{ _is_SUPPLEMENTARY_private_use_AREA_B}', "");
    Expect(0, 1048576, '\p{^ _is_SUPPLEMENTARY_private_use_AREA_B}', "");
    Expect(0, 1048576, '\P{ _is_SUPPLEMENTARY_private_use_AREA_B}', "");
    Expect(1, 1048576, '\P{^ _is_SUPPLEMENTARY_private_use_AREA_B}', "");
    Expect(0, 1, '\p{ _is_SUPPLEMENTARY_private_use_AREA_B}', "");
    Expect(1, 1, '\p{^ _is_SUPPLEMENTARY_private_use_AREA_B}', "");
    Expect(1, 1, '\P{ _is_SUPPLEMENTARY_private_use_AREA_B}', "");
    Expect(0, 1, '\P{^ _is_SUPPLEMENTARY_private_use_AREA_B}', "");
    Error('\p{_/a/In_SUPPLEMENTARY_PRIVATE_Use_Area_B}');
    Error('\P{_/a/In_SUPPLEMENTARY_PRIVATE_Use_Area_B}');
    Expect(1, 1048576, '\p{insupplementaryprivateuseareab}', "");
    Expect(0, 1048576, '\p{^insupplementaryprivateuseareab}', "");
    Expect(0, 1048576, '\P{insupplementaryprivateuseareab}', "");
    Expect(1, 1048576, '\P{^insupplementaryprivateuseareab}', "");
    Expect(0, 1, '\p{insupplementaryprivateuseareab}', "");
    Expect(1, 1, '\p{^insupplementaryprivateuseareab}', "");
    Expect(1, 1, '\P{insupplementaryprivateuseareab}', "");
    Expect(0, 1, '\P{^insupplementaryprivateuseareab}', "");
    Expect(1, 1048576, '\p{_in_SUPPLEMENTARY_Private_use_AREA_B}', "");
    Expect(0, 1048576, '\p{^_in_SUPPLEMENTARY_Private_use_AREA_B}', "");
    Expect(0, 1048576, '\P{_in_SUPPLEMENTARY_Private_use_AREA_B}', "");
    Expect(1, 1048576, '\P{^_in_SUPPLEMENTARY_Private_use_AREA_B}', "");
    Expect(0, 1, '\p{_in_SUPPLEMENTARY_Private_use_AREA_B}', "");
    Expect(1, 1, '\p{^_in_SUPPLEMENTARY_Private_use_AREA_B}', "");
    Expect(1, 1, '\P{_in_SUPPLEMENTARY_Private_use_AREA_B}', "");
    Expect(0, 1, '\P{^_in_SUPPLEMENTARY_Private_use_AREA_B}', "");
    Error('\p{ _sup_PUA_b:=}');
    Error('\P{ _sup_PUA_b:=}');
    Expect(1, 1048576, '\p{suppuab}', "");
    Expect(0, 1048576, '\p{^suppuab}', "");
    Expect(0, 1048576, '\P{suppuab}', "");
    Expect(1, 1048576, '\P{^suppuab}', "");
    Expect(0, 1, '\p{suppuab}', "");
    Expect(1, 1, '\p{^suppuab}', "");
    Expect(1, 1, '\P{suppuab}', "");
    Expect(0, 1, '\P{^suppuab}', "");
    Expect(1, 1048576, '\p{-_SUP_PUA_B}', "");
    Expect(0, 1048576, '\p{^-_SUP_PUA_B}', "");
    Expect(0, 1048576, '\P{-_SUP_PUA_B}', "");
    Expect(1, 1048576, '\P{^-_SUP_PUA_B}', "");
    Expect(0, 1, '\p{-_SUP_PUA_B}', "");
    Expect(1, 1, '\p{^-_SUP_PUA_B}', "");
    Expect(1, 1, '\P{-_SUP_PUA_B}', "");
    Expect(0, 1, '\P{^-_SUP_PUA_B}', "");
    Error('\p{	:=is_SUP_pua_B}');
    Error('\P{	:=is_SUP_pua_B}');
    Expect(1, 1048576, '\p{issuppuab}', "");
    Expect(0, 1048576, '\p{^issuppuab}', "");
    Expect(0, 1048576, '\P{issuppuab}', "");
    Expect(1, 1048576, '\P{^issuppuab}', "");
    Expect(0, 1, '\p{issuppuab}', "");
    Expect(1, 1, '\p{^issuppuab}', "");
    Expect(1, 1, '\P{issuppuab}', "");
    Expect(0, 1, '\P{^issuppuab}', "");
    Expect(1, 1048576, '\p{_Is_sup_pua_B}', "");
    Expect(0, 1048576, '\p{^_Is_sup_pua_B}', "");
    Expect(0, 1048576, '\P{_Is_sup_pua_B}', "");
    Expect(1, 1048576, '\P{^_Is_sup_pua_B}', "");
    Expect(0, 1, '\p{_Is_sup_pua_B}', "");
    Expect(1, 1, '\p{^_Is_sup_pua_B}', "");
    Expect(1, 1, '\P{_Is_sup_pua_B}', "");
    Expect(0, 1, '\P{^_Is_sup_pua_B}', "");
    Error('\p{-	In_Sup_PUA_B/a/}');
    Error('\P{-	In_Sup_PUA_B/a/}');
    Expect(1, 1048576, '\p{insuppuab}', "");
    Expect(0, 1048576, '\p{^insuppuab}', "");
    Expect(0, 1048576, '\P{insuppuab}', "");
    Expect(1, 1048576, '\P{^insuppuab}', "");
    Expect(0, 1, '\p{insuppuab}', "");
    Expect(1, 1, '\p{^insuppuab}', "");
    Expect(1, 1, '\P{insuppuab}', "");
    Expect(0, 1, '\P{^insuppuab}', "");
    Expect(1, 1048576, '\p{_ In_Sup_PUA_b}', "");
    Expect(0, 1048576, '\p{^_ In_Sup_PUA_b}', "");
    Expect(0, 1048576, '\P{_ In_Sup_PUA_b}', "");
    Expect(1, 1048576, '\P{^_ In_Sup_PUA_b}', "");
    Expect(0, 1, '\p{_ In_Sup_PUA_b}', "");
    Expect(1, 1, '\p{^_ In_Sup_PUA_b}', "");
    Expect(1, 1, '\P{_ In_Sup_PUA_b}', "");
    Expect(0, 1, '\P{^_ In_Sup_PUA_b}', "");
    Error('\p{:=-_SURROGATE}');
    Error('\P{:=-_SURROGATE}');
    Expect(1, 57343, '\p{surrogate}', "");
    Expect(0, 57343, '\p{^surrogate}', "");
    Expect(0, 57343, '\P{surrogate}', "");
    Expect(1, 57343, '\P{^surrogate}', "");
    Expect(0, 57344, '\p{surrogate}', "");
    Expect(1, 57344, '\p{^surrogate}', "");
    Expect(1, 57344, '\P{surrogate}', "");
    Expect(0, 57344, '\P{^surrogate}', "");
    Expect(1, 57343, '\p{_Surrogate}', "");
    Expect(0, 57343, '\p{^_Surrogate}', "");
    Expect(0, 57343, '\P{_Surrogate}', "");
    Expect(1, 57343, '\P{^_Surrogate}', "");
    Expect(0, 57344, '\p{_Surrogate}', "");
    Expect(1, 57344, '\p{^_Surrogate}', "");
    Expect(1, 57344, '\P{_Surrogate}', "");
    Expect(0, 57344, '\P{^_Surrogate}', "");
    Error('\p{/a/_	Is_Surrogate}');
    Error('\P{/a/_	Is_Surrogate}');
    Expect(1, 57343, '\p{issurrogate}', "");
    Expect(0, 57343, '\p{^issurrogate}', "");
    Expect(0, 57343, '\P{issurrogate}', "");
    Expect(1, 57343, '\P{^issurrogate}', "");
    Expect(0, 57344, '\p{issurrogate}', "");
    Expect(1, 57344, '\p{^issurrogate}', "");
    Expect(1, 57344, '\P{issurrogate}', "");
    Expect(0, 57344, '\P{^issurrogate}', "");
    Expect(1, 57343, '\p{_is_Surrogate}', "");
    Expect(0, 57343, '\p{^_is_Surrogate}', "");
    Expect(0, 57343, '\P{_is_Surrogate}', "");
    Expect(1, 57343, '\P{^_is_Surrogate}', "");
    Expect(0, 57344, '\p{_is_Surrogate}', "");
    Expect(1, 57344, '\p{^_is_Surrogate}', "");
    Expect(1, 57344, '\P{_is_Surrogate}', "");
    Expect(0, 57344, '\P{^_is_Surrogate}', "");
    Error('\p{/a/-cs}');
    Error('\P{/a/-cs}');
    Expect(1, 57343, '\p{cs}', "");
    Expect(0, 57343, '\p{^cs}', "");
    Expect(0, 57343, '\P{cs}', "");
    Expect(1, 57343, '\P{^cs}', "");
    Expect(0, 57344, '\p{cs}', "");
    Expect(1, 57344, '\p{^cs}', "");
    Expect(1, 57344, '\P{cs}', "");
    Expect(0, 57344, '\P{^cs}', "");
    Expect(1, 57343, '\p{_CS}', "");
    Expect(0, 57343, '\p{^_CS}', "");
    Expect(0, 57343, '\P{_CS}', "");
    Expect(1, 57343, '\P{^_CS}', "");
    Expect(0, 57344, '\p{_CS}', "");
    Expect(1, 57344, '\p{^_CS}', "");
    Expect(1, 57344, '\P{_CS}', "");
    Expect(0, 57344, '\P{^_CS}', "");
    Error('\p{	/a/IS_Cs}');
    Error('\P{	/a/IS_Cs}');
    Expect(1, 57343, '\p{iscs}', "");
    Expect(0, 57343, '\p{^iscs}', "");
    Expect(0, 57343, '\P{iscs}', "");
    Expect(1, 57343, '\P{^iscs}', "");
    Expect(0, 57344, '\p{iscs}', "");
    Expect(1, 57344, '\p{^iscs}', "");
    Expect(1, 57344, '\P{iscs}', "");
    Expect(0, 57344, '\P{^iscs}', "");
    Expect(1, 57343, '\p{-Is_cs}', "");
    Expect(0, 57343, '\p{^-Is_cs}', "");
    Expect(0, 57343, '\P{-Is_cs}', "");
    Expect(1, 57343, '\P{^-Is_cs}', "");
    Expect(0, 57344, '\p{-Is_cs}', "");
    Expect(1, 57344, '\p{^-Is_cs}', "");
    Expect(1, 57344, '\P{-Is_cs}', "");
    Expect(0, 57344, '\P{^-Is_cs}', "");
    Error('\p{-:=sutton_SIGNWRITING}');
    Error('\P{-:=sutton_SIGNWRITING}');
    Expect(1, 121519, '\p{suttonsignwriting}', "");
    Expect(0, 121519, '\p{^suttonsignwriting}', "");
    Expect(0, 121519, '\P{suttonsignwriting}', "");
    Expect(1, 121519, '\P{^suttonsignwriting}', "");
    Expect(0, 121520, '\p{suttonsignwriting}', "");
    Expect(1, 121520, '\p{^suttonsignwriting}', "");
    Expect(1, 121520, '\P{suttonsignwriting}', "");
    Expect(0, 121520, '\P{^suttonsignwriting}', "");
    Expect(1, 121519, '\p{ SUTTON_SignWriting}', "");
    Expect(0, 121519, '\p{^ SUTTON_SignWriting}', "");
    Expect(0, 121519, '\P{ SUTTON_SignWriting}', "");
    Expect(1, 121519, '\P{^ SUTTON_SignWriting}', "");
    Expect(0, 121520, '\p{ SUTTON_SignWriting}', "");
    Expect(1, 121520, '\p{^ SUTTON_SignWriting}', "");
    Expect(1, 121520, '\P{ SUTTON_SignWriting}', "");
    Expect(0, 121520, '\P{^ SUTTON_SignWriting}', "");
    Error('\p{:=__Is_Sutton_signwriting}');
    Error('\P{:=__Is_Sutton_signwriting}');
    Expect(1, 121519, '\p{issuttonsignwriting}', "");
    Expect(0, 121519, '\p{^issuttonsignwriting}', "");
    Expect(0, 121519, '\P{issuttonsignwriting}', "");
    Expect(1, 121519, '\P{^issuttonsignwriting}', "");
    Expect(0, 121520, '\p{issuttonsignwriting}', "");
    Expect(1, 121520, '\p{^issuttonsignwriting}', "");
    Expect(1, 121520, '\P{issuttonsignwriting}', "");
    Expect(0, 121520, '\P{^issuttonsignwriting}', "");
    Expect(1, 121519, '\p{	-is_Sutton_SignWriting}', "");
    Expect(0, 121519, '\p{^	-is_Sutton_SignWriting}', "");
    Expect(0, 121519, '\P{	-is_Sutton_SignWriting}', "");
    Expect(1, 121519, '\P{^	-is_Sutton_SignWriting}', "");
    Expect(0, 121520, '\p{	-is_Sutton_SignWriting}', "");
    Expect(1, 121520, '\p{^	-is_Sutton_SignWriting}', "");
    Expect(1, 121520, '\P{	-is_Sutton_SignWriting}', "");
    Expect(0, 121520, '\P{^	-is_Sutton_SignWriting}', "");
    Error('\p{-IN_sutton_SignWriting/a/}');
    Error('\P{-IN_sutton_SignWriting/a/}');
    Expect(1, 121519, '\p{insuttonsignwriting}', "");
    Expect(0, 121519, '\p{^insuttonsignwriting}', "");
    Expect(0, 121519, '\P{insuttonsignwriting}', "");
    Expect(1, 121519, '\P{^insuttonsignwriting}', "");
    Expect(0, 121520, '\p{insuttonsignwriting}', "");
    Expect(1, 121520, '\p{^insuttonsignwriting}', "");
    Expect(1, 121520, '\P{insuttonsignwriting}', "");
    Expect(0, 121520, '\P{^insuttonsignwriting}', "");
    Expect(1, 121519, '\p{_	In_Sutton_SignWriting}', "");
    Expect(0, 121519, '\p{^_	In_Sutton_SignWriting}', "");
    Expect(0, 121519, '\P{_	In_Sutton_SignWriting}', "");
    Expect(1, 121519, '\P{^_	In_Sutton_SignWriting}', "");
    Expect(0, 121520, '\p{_	In_Sutton_SignWriting}', "");
    Expect(1, 121520, '\p{^_	In_Sutton_SignWriting}', "");
    Expect(1, 121520, '\P{_	In_Sutton_SignWriting}', "");
    Expect(0, 121520, '\P{^_	In_Sutton_SignWriting}', "");
    Error('\p{--SYLOTI_Nagri:=}');
    Error('\P{--SYLOTI_Nagri:=}');
    Expect(1, 43052, '\p{sylotinagri}', "");
    Expect(0, 43052, '\p{^sylotinagri}', "");
    Expect(0, 43052, '\P{sylotinagri}', "");
    Expect(1, 43052, '\P{^sylotinagri}', "");
    Expect(0, 43053, '\p{sylotinagri}', "");
    Expect(1, 43053, '\p{^sylotinagri}', "");
    Expect(1, 43053, '\P{sylotinagri}', "");
    Expect(0, 43053, '\P{^sylotinagri}', "");
    Expect(1, 43052, '\p{__SYLOTI_Nagri}', "");
    Expect(0, 43052, '\p{^__SYLOTI_Nagri}', "");
    Expect(0, 43052, '\P{__SYLOTI_Nagri}', "");
    Expect(1, 43052, '\P{^__SYLOTI_Nagri}', "");
    Expect(0, 43053, '\p{__SYLOTI_Nagri}', "");
    Expect(1, 43053, '\p{^__SYLOTI_Nagri}', "");
    Expect(1, 43053, '\P{__SYLOTI_Nagri}', "");
    Expect(0, 43053, '\P{^__SYLOTI_Nagri}', "");
    Error('\p{--Is_syloti_Nagri/a/}');
    Error('\P{--Is_syloti_Nagri/a/}');
    Expect(1, 43052, '\p{issylotinagri}', "");
    Expect(0, 43052, '\p{^issylotinagri}', "");
    Expect(0, 43052, '\P{issylotinagri}', "");
    Expect(1, 43052, '\P{^issylotinagri}', "");
    Expect(0, 43053, '\p{issylotinagri}', "");
    Expect(1, 43053, '\p{^issylotinagri}', "");
    Expect(1, 43053, '\P{issylotinagri}', "");
    Expect(0, 43053, '\P{^issylotinagri}', "");
    Expect(1, 43052, '\p{ 	IS_SYLOTI_NAGRI}', "");
    Expect(0, 43052, '\p{^ 	IS_SYLOTI_NAGRI}', "");
    Expect(0, 43052, '\P{ 	IS_SYLOTI_NAGRI}', "");
    Expect(1, 43052, '\P{^ 	IS_SYLOTI_NAGRI}', "");
    Expect(0, 43053, '\p{ 	IS_SYLOTI_NAGRI}', "");
    Expect(1, 43053, '\p{^ 	IS_SYLOTI_NAGRI}', "");
    Expect(1, 43053, '\P{ 	IS_SYLOTI_NAGRI}', "");
    Expect(0, 43053, '\P{^ 	IS_SYLOTI_NAGRI}', "");
    Error('\p{_:=Sylo}');
    Error('\P{_:=Sylo}');
    Expect(1, 43052, '\p{sylo}', "");
    Expect(0, 43052, '\p{^sylo}', "");
    Expect(0, 43052, '\P{sylo}', "");
    Expect(1, 43052, '\P{^sylo}', "");
    Expect(0, 43053, '\p{sylo}', "");
    Expect(1, 43053, '\p{^sylo}', "");
    Expect(1, 43053, '\P{sylo}', "");
    Expect(0, 43053, '\P{^sylo}', "");
    Expect(1, 43052, '\p{	Sylo}', "");
    Expect(0, 43052, '\p{^	Sylo}', "");
    Expect(0, 43052, '\P{	Sylo}', "");
    Expect(1, 43052, '\P{^	Sylo}', "");
    Expect(0, 43053, '\p{	Sylo}', "");
    Expect(1, 43053, '\p{^	Sylo}', "");
    Expect(1, 43053, '\P{	Sylo}', "");
    Expect(0, 43053, '\P{^	Sylo}', "");
    Error('\p{:= Is_sylo}');
    Error('\P{:= Is_sylo}');
    Expect(1, 43052, '\p{issylo}', "");
    Expect(0, 43052, '\p{^issylo}', "");
    Expect(0, 43052, '\P{issylo}', "");
    Expect(1, 43052, '\P{^issylo}', "");
    Expect(0, 43053, '\p{issylo}', "");
    Expect(1, 43053, '\p{^issylo}', "");
    Expect(1, 43053, '\P{issylo}', "");
    Expect(0, 43053, '\P{^issylo}', "");
    Expect(1, 43052, '\p{ Is_SYLO}', "");
    Expect(0, 43052, '\p{^ Is_SYLO}', "");
    Expect(0, 43052, '\P{ Is_SYLO}', "");
    Expect(1, 43052, '\P{^ Is_SYLO}', "");
    Expect(0, 43053, '\p{ Is_SYLO}', "");
    Expect(1, 43053, '\p{^ Is_SYLO}', "");
    Expect(1, 43053, '\P{ Is_SYLO}', "");
    Expect(0, 43053, '\P{^ Is_SYLO}', "");
    Error('\p{symbol/a/}');
    Error('\P{symbol/a/}');
    Expect(1, 129994, '\p{symbol}', "");
    Expect(0, 129994, '\p{^symbol}', "");
    Expect(0, 129994, '\P{symbol}', "");
    Expect(1, 129994, '\P{^symbol}', "");
    Expect(0, 129995, '\p{symbol}', "");
    Expect(1, 129995, '\p{^symbol}', "");
    Expect(1, 129995, '\P{symbol}', "");
    Expect(0, 129995, '\P{^symbol}', "");
    Expect(1, 129994, '\p{_Symbol}', "");
    Expect(0, 129994, '\p{^_Symbol}', "");
    Expect(0, 129994, '\P{_Symbol}', "");
    Expect(1, 129994, '\P{^_Symbol}', "");
    Expect(0, 129995, '\p{_Symbol}', "");
    Expect(1, 129995, '\p{^_Symbol}', "");
    Expect(1, 129995, '\P{_Symbol}', "");
    Expect(0, 129995, '\P{^_Symbol}', "");
    Error('\p{/a/is_SYMBOL}');
    Error('\P{/a/is_SYMBOL}');
    Expect(1, 129994, '\p{issymbol}', "");
    Expect(0, 129994, '\p{^issymbol}', "");
    Expect(0, 129994, '\P{issymbol}', "");
    Expect(1, 129994, '\P{^issymbol}', "");
    Expect(0, 129995, '\p{issymbol}', "");
    Expect(1, 129995, '\p{^issymbol}', "");
    Expect(1, 129995, '\P{issymbol}', "");
    Expect(0, 129995, '\P{^issymbol}', "");
    Expect(1, 129994, '\p{ Is_symbol}', "");
    Expect(0, 129994, '\p{^ Is_symbol}', "");
    Expect(0, 129994, '\P{ Is_symbol}', "");
    Expect(1, 129994, '\P{^ Is_symbol}', "");
    Expect(0, 129995, '\p{ Is_symbol}', "");
    Expect(1, 129995, '\p{^ Is_symbol}', "");
    Expect(1, 129995, '\P{ Is_symbol}', "");
    Expect(0, 129995, '\P{^ Is_symbol}', "");
    Error('\p{/a/	-S}');
    Error('\P{/a/	-S}');
    Expect(1, 129994, '\p{s}', "");
    Expect(0, 129994, '\p{^s}', "");
    Expect(0, 129994, '\P{s}', "");
    Expect(1, 129994, '\P{^s}', "");
    Expect(0, 129995, '\p{s}', "");
    Expect(1, 129995, '\p{^s}', "");
    Expect(1, 129995, '\P{s}', "");
    Expect(0, 129995, '\P{^s}', "");
    Expect(1, 129994, '\p{		s}', "");
    Expect(0, 129994, '\p{^		s}', "");
    Expect(0, 129994, '\P{		s}', "");
    Expect(1, 129994, '\P{^		s}', "");
    Expect(0, 129995, '\p{		s}', "");
    Expect(1, 129995, '\p{^		s}', "");
    Expect(1, 129995, '\P{		s}', "");
    Expect(0, 129995, '\P{^		s}', "");
    Error('\p{- Is_s/a/}');
    Error('\P{- Is_s/a/}');
    Expect(1, 129994, '\p{iss}', "");
    Expect(0, 129994, '\p{^iss}', "");
    Expect(0, 129994, '\P{iss}', "");
    Expect(1, 129994, '\P{^iss}', "");
    Expect(0, 129995, '\p{iss}', "");
    Expect(1, 129995, '\p{^iss}', "");
    Expect(1, 129995, '\P{iss}', "");
    Expect(0, 129995, '\P{^iss}', "");
    Expect(1, 129994, '\p{-	Is_s}', "");
    Expect(0, 129994, '\p{^-	Is_s}', "");
    Expect(0, 129994, '\P{-	Is_s}', "");
    Expect(1, 129994, '\P{^-	Is_s}', "");
    Expect(0, 129995, '\p{-	Is_s}', "");
    Expect(1, 129995, '\p{^-	Is_s}', "");
    Expect(1, 129995, '\P{-	Is_s}', "");
    Expect(0, 129995, '\P{^-	Is_s}', "");
    Error('\p{ :=SYMBOLS_and_Pictographs_Extended_a}');
    Error('\P{ :=SYMBOLS_and_Pictographs_Extended_a}');
    Expect(1, 129791, '\p{symbolsandpictographsextendeda}', "");
    Expect(0, 129791, '\p{^symbolsandpictographsextendeda}', "");
    Expect(0, 129791, '\P{symbolsandpictographsextendeda}', "");
    Expect(1, 129791, '\P{^symbolsandpictographsextendeda}', "");
    Expect(0, 129792, '\p{symbolsandpictographsextendeda}', "");
    Expect(1, 129792, '\p{^symbolsandpictographsextendeda}', "");
    Expect(1, 129792, '\P{symbolsandpictographsextendeda}', "");
    Expect(0, 129792, '\P{^symbolsandpictographsextendeda}', "");
    Expect(1, 129791, '\p{_Symbols_And_PICTOGRAPHS_extended_A}', "");
    Expect(0, 129791, '\p{^_Symbols_And_PICTOGRAPHS_extended_A}', "");
    Expect(0, 129791, '\P{_Symbols_And_PICTOGRAPHS_extended_A}', "");
    Expect(1, 129791, '\P{^_Symbols_And_PICTOGRAPHS_extended_A}', "");
    Expect(0, 129792, '\p{_Symbols_And_PICTOGRAPHS_extended_A}', "");
    Expect(1, 129792, '\p{^_Symbols_And_PICTOGRAPHS_extended_A}', "");
    Expect(1, 129792, '\P{_Symbols_And_PICTOGRAPHS_extended_A}', "");
    Expect(0, 129792, '\P{^_Symbols_And_PICTOGRAPHS_extended_A}', "");
    Error('\p{- is_Symbols_AND_Pictographs_extended_A:=}');
    Error('\P{- is_Symbols_AND_Pictographs_extended_A:=}');
    Expect(1, 129791, '\p{issymbolsandpictographsextendeda}', "");
    Expect(0, 129791, '\p{^issymbolsandpictographsextendeda}', "");
    Expect(0, 129791, '\P{issymbolsandpictographsextendeda}', "");
    Expect(1, 129791, '\P{^issymbolsandpictographsextendeda}', "");
    Expect(0, 129792, '\p{issymbolsandpictographsextendeda}', "");
    Expect(1, 129792, '\p{^issymbolsandpictographsextendeda}', "");
    Expect(1, 129792, '\P{issymbolsandpictographsextendeda}', "");
    Expect(0, 129792, '\P{^issymbolsandpictographsextendeda}', "");
    Expect(1, 129791, '\p{	Is_SYMBOLS_and_pictographs_Extended_A}', "");
    Expect(0, 129791, '\p{^	Is_SYMBOLS_and_pictographs_Extended_A}', "");
    Expect(0, 129791, '\P{	Is_SYMBOLS_and_pictographs_Extended_A}', "");
    Expect(1, 129791, '\P{^	Is_SYMBOLS_and_pictographs_Extended_A}', "");
    Expect(0, 129792, '\p{	Is_SYMBOLS_and_pictographs_Extended_A}', "");
    Expect(1, 129792, '\p{^	Is_SYMBOLS_and_pictographs_Extended_A}', "");
    Expect(1, 129792, '\P{	Is_SYMBOLS_and_pictographs_Extended_A}', "");
    Expect(0, 129792, '\P{^	Is_SYMBOLS_and_pictographs_Extended_A}', "");
    Error('\p{/a/	-in_Symbols_And_Pictographs_extended_A}');
    Error('\P{/a/	-in_Symbols_And_Pictographs_extended_A}');
    Expect(1, 129791, '\p{insymbolsandpictographsextendeda}', "");
    Expect(0, 129791, '\p{^insymbolsandpictographsextendeda}', "");
    Expect(0, 129791, '\P{insymbolsandpictographsextendeda}', "");
    Expect(1, 129791, '\P{^insymbolsandpictographsextendeda}', "");
    Expect(0, 129792, '\p{insymbolsandpictographsextendeda}', "");
    Expect(1, 129792, '\p{^insymbolsandpictographsextendeda}', "");
    Expect(1, 129792, '\P{insymbolsandpictographsextendeda}', "");
    Expect(0, 129792, '\P{^insymbolsandpictographsextendeda}', "");
    Expect(1, 129791, '\p{_In_Symbols_And_Pictographs_extended_A}', "");
    Expect(0, 129791, '\p{^_In_Symbols_And_Pictographs_extended_A}', "");
    Expect(0, 129791, '\P{_In_Symbols_And_Pictographs_extended_A}', "");
    Expect(1, 129791, '\P{^_In_Symbols_And_Pictographs_extended_A}', "");
    Expect(0, 129792, '\p{_In_Symbols_And_Pictographs_extended_A}', "");
    Expect(1, 129792, '\p{^_In_Symbols_And_Pictographs_extended_A}', "");
    Expect(1, 129792, '\P{_In_Symbols_And_Pictographs_extended_A}', "");
    Expect(0, 129792, '\P{^_In_Symbols_And_Pictographs_extended_A}', "");
    Error('\p{:= Symbols_AND_pictographs_ext_A}');
    Error('\P{:= Symbols_AND_pictographs_ext_A}');
    Expect(1, 129791, '\p{symbolsandpictographsexta}', "");
    Expect(0, 129791, '\p{^symbolsandpictographsexta}', "");
    Expect(0, 129791, '\P{symbolsandpictographsexta}', "");
    Expect(1, 129791, '\P{^symbolsandpictographsexta}', "");
    Expect(0, 129792, '\p{symbolsandpictographsexta}', "");
    Expect(1, 129792, '\p{^symbolsandpictographsexta}', "");
    Expect(1, 129792, '\P{symbolsandpictographsexta}', "");
    Expect(0, 129792, '\P{^symbolsandpictographsexta}', "");
    Expect(1, 129791, '\p{- Symbols_And_PICTOGRAPHS_Ext_a}', "");
    Expect(0, 129791, '\p{^- Symbols_And_PICTOGRAPHS_Ext_a}', "");
    Expect(0, 129791, '\P{- Symbols_And_PICTOGRAPHS_Ext_a}', "");
    Expect(1, 129791, '\P{^- Symbols_And_PICTOGRAPHS_Ext_a}', "");
    Expect(0, 129792, '\p{- Symbols_And_PICTOGRAPHS_Ext_a}', "");
    Expect(1, 129792, '\p{^- Symbols_And_PICTOGRAPHS_Ext_a}', "");
    Expect(1, 129792, '\P{- Symbols_And_PICTOGRAPHS_Ext_a}', "");
    Expect(0, 129792, '\P{^- Symbols_And_PICTOGRAPHS_Ext_a}', "");
    Error('\p{/a/ IS_Symbols_And_pictographs_EXT_A}');
    Error('\P{/a/ IS_Symbols_And_pictographs_EXT_A}');
    Expect(1, 129791, '\p{issymbolsandpictographsexta}', "");
    Expect(0, 129791, '\p{^issymbolsandpictographsexta}', "");
    Expect(0, 129791, '\P{issymbolsandpictographsexta}', "");
    Expect(1, 129791, '\P{^issymbolsandpictographsexta}', "");
    Expect(0, 129792, '\p{issymbolsandpictographsexta}', "");
    Expect(1, 129792, '\p{^issymbolsandpictographsexta}', "");
    Expect(1, 129792, '\P{issymbolsandpictographsexta}', "");
    Expect(0, 129792, '\P{^issymbolsandpictographsexta}', "");
    Expect(1, 129791, '\p{Is_SYMBOLS_and_Pictographs_ext_A}', "");
    Expect(0, 129791, '\p{^Is_SYMBOLS_and_Pictographs_ext_A}', "");
    Expect(0, 129791, '\P{Is_SYMBOLS_and_Pictographs_ext_A}', "");
    Expect(1, 129791, '\P{^Is_SYMBOLS_and_Pictographs_ext_A}', "");
    Expect(0, 129792, '\p{Is_SYMBOLS_and_Pictographs_ext_A}', "");
    Expect(1, 129792, '\p{^Is_SYMBOLS_and_Pictographs_ext_A}', "");
    Expect(1, 129792, '\P{Is_SYMBOLS_and_Pictographs_ext_A}', "");
    Expect(0, 129792, '\P{^Is_SYMBOLS_and_Pictographs_ext_A}', "");
    Error('\p{_ In_Symbols_And_Pictographs_EXT_A/a/}');
    Error('\P{_ In_Symbols_And_Pictographs_EXT_A/a/}');
    Expect(1, 129791, '\p{insymbolsandpictographsexta}', "");
    Expect(0, 129791, '\p{^insymbolsandpictographsexta}', "");
    Expect(0, 129791, '\P{insymbolsandpictographsexta}', "");
    Expect(1, 129791, '\P{^insymbolsandpictographsexta}', "");
    Expect(0, 129792, '\p{insymbolsandpictographsexta}', "");
    Expect(1, 129792, '\p{^insymbolsandpictographsexta}', "");
    Expect(1, 129792, '\P{insymbolsandpictographsexta}', "");
    Expect(0, 129792, '\P{^insymbolsandpictographsexta}', "");
    Expect(1, 129791, '\p{	 In_Symbols_And_pictographs_EXT_A}', "");
    Expect(0, 129791, '\p{^	 In_Symbols_And_pictographs_EXT_A}', "");
    Expect(0, 129791, '\P{	 In_Symbols_And_pictographs_EXT_A}', "");
    Expect(1, 129791, '\P{^	 In_Symbols_And_pictographs_EXT_A}', "");
    Expect(0, 129792, '\p{	 In_Symbols_And_pictographs_EXT_A}', "");
    Expect(1, 129792, '\p{^	 In_Symbols_And_pictographs_EXT_A}', "");
    Expect(1, 129792, '\P{	 In_Symbols_And_pictographs_EXT_A}', "");
    Expect(0, 129792, '\P{^	 In_Symbols_And_pictographs_EXT_A}', "");
    Error('\p{_Symbols_For_Legacy_computing/a/}');
    Error('\P{_Symbols_For_Legacy_computing/a/}');
    Expect(1, 130047, '\p{symbolsforlegacycomputing}', "");
    Expect(0, 130047, '\p{^symbolsforlegacycomputing}', "");
    Expect(0, 130047, '\P{symbolsforlegacycomputing}', "");
    Expect(1, 130047, '\P{^symbolsforlegacycomputing}', "");
    Expect(0, 130048, '\p{symbolsforlegacycomputing}', "");
    Expect(1, 130048, '\p{^symbolsforlegacycomputing}', "");
    Expect(1, 130048, '\P{symbolsforlegacycomputing}', "");
    Expect(0, 130048, '\P{^symbolsforlegacycomputing}', "");
    Expect(1, 130047, '\p{- Symbols_For_Legacy_COMPUTING}', "");
    Expect(0, 130047, '\p{^- Symbols_For_Legacy_COMPUTING}', "");
    Expect(0, 130047, '\P{- Symbols_For_Legacy_COMPUTING}', "");
    Expect(1, 130047, '\P{^- Symbols_For_Legacy_COMPUTING}', "");
    Expect(0, 130048, '\p{- Symbols_For_Legacy_COMPUTING}', "");
    Expect(1, 130048, '\p{^- Symbols_For_Legacy_COMPUTING}', "");
    Expect(1, 130048, '\P{- Symbols_For_Legacy_COMPUTING}', "");
    Expect(0, 130048, '\P{^- Symbols_For_Legacy_COMPUTING}', "");
    Error('\p{_/a/IS_SYMBOLS_FOR_LEGACY_Computing}');
    Error('\P{_/a/IS_SYMBOLS_FOR_LEGACY_Computing}');
    Expect(1, 130047, '\p{issymbolsforlegacycomputing}', "");
    Expect(0, 130047, '\p{^issymbolsforlegacycomputing}', "");
    Expect(0, 130047, '\P{issymbolsforlegacycomputing}', "");
    Expect(1, 130047, '\P{^issymbolsforlegacycomputing}', "");
    Expect(0, 130048, '\p{issymbolsforlegacycomputing}', "");
    Expect(1, 130048, '\p{^issymbolsforlegacycomputing}', "");
    Expect(1, 130048, '\P{issymbolsforlegacycomputing}', "");
    Expect(0, 130048, '\P{^issymbolsforlegacycomputing}', "");
    Expect(1, 130047, '\p{-	Is_symbols_For_Legacy_Computing}', "");
    Expect(0, 130047, '\p{^-	Is_symbols_For_Legacy_Computing}', "");
    Expect(0, 130047, '\P{-	Is_symbols_For_Legacy_Computing}', "");
    Expect(1, 130047, '\P{^-	Is_symbols_For_Legacy_Computing}', "");
    Expect(0, 130048, '\p{-	Is_symbols_For_Legacy_Computing}', "");
    Expect(1, 130048, '\p{^-	Is_symbols_For_Legacy_Computing}', "");
    Expect(1, 130048, '\P{-	Is_symbols_For_Legacy_Computing}', "");
    Expect(0, 130048, '\P{^-	Is_symbols_For_Legacy_Computing}', "");
    Error('\p{/a/IN_SYMBOLS_For_LEGACY_computing}');
    Error('\P{/a/IN_SYMBOLS_For_LEGACY_computing}');
    Expect(1, 130047, '\p{insymbolsforlegacycomputing}', "");
    Expect(0, 130047, '\p{^insymbolsforlegacycomputing}', "");
    Expect(0, 130047, '\P{insymbolsforlegacycomputing}', "");
    Expect(1, 130047, '\P{^insymbolsforlegacycomputing}', "");
    Expect(0, 130048, '\p{insymbolsforlegacycomputing}', "");
    Expect(1, 130048, '\p{^insymbolsforlegacycomputing}', "");
    Expect(1, 130048, '\P{insymbolsforlegacycomputing}', "");
    Expect(0, 130048, '\P{^insymbolsforlegacycomputing}', "");
    Expect(1, 130047, '\p{		in_symbols_For_LEGACY_COMPUTING}', "");
    Expect(0, 130047, '\p{^		in_symbols_For_LEGACY_COMPUTING}', "");
    Expect(0, 130047, '\P{		in_symbols_For_LEGACY_COMPUTING}', "");
    Expect(1, 130047, '\P{^		in_symbols_For_LEGACY_COMPUTING}', "");
    Expect(0, 130048, '\p{		in_symbols_For_LEGACY_COMPUTING}', "");
    Expect(1, 130048, '\p{^		in_symbols_For_LEGACY_COMPUTING}', "");
    Expect(1, 130048, '\P{		in_symbols_For_LEGACY_COMPUTING}', "");
    Expect(0, 130048, '\P{^		in_symbols_For_LEGACY_COMPUTING}', "");
    Error('\p{	 Syriac/a/}');
    Error('\P{	 Syriac/a/}');
    Expect(1, 7672, '\p{syriac}', "");
    Expect(0, 7672, '\p{^syriac}', "");
    Expect(0, 7672, '\P{syriac}', "");
    Expect(1, 7672, '\P{^syriac}', "");
    Expect(0, 7673, '\p{syriac}', "");
    Expect(1, 7673, '\p{^syriac}', "");
    Expect(1, 7673, '\P{syriac}', "");
    Expect(0, 7673, '\P{^syriac}', "");
    Expect(1, 7672, '\p{-Syriac}', "");
    Expect(0, 7672, '\p{^-Syriac}', "");
    Expect(0, 7672, '\P{-Syriac}', "");
    Expect(1, 7672, '\P{^-Syriac}', "");
    Expect(0, 7673, '\p{-Syriac}', "");
    Expect(1, 7673, '\p{^-Syriac}', "");
    Expect(1, 7673, '\P{-Syriac}', "");
    Expect(0, 7673, '\P{^-Syriac}', "");
    Error('\p{--IS_SYRIAC/a/}');
    Error('\P{--IS_SYRIAC/a/}');
    Expect(1, 7672, '\p{issyriac}', "");
    Expect(0, 7672, '\p{^issyriac}', "");
    Expect(0, 7672, '\P{issyriac}', "");
    Expect(1, 7672, '\P{^issyriac}', "");
    Expect(0, 7673, '\p{issyriac}', "");
    Expect(1, 7673, '\p{^issyriac}', "");
    Expect(1, 7673, '\P{issyriac}', "");
    Expect(0, 7673, '\P{^issyriac}', "");
    Expect(1, 7672, '\p{	IS_SYRIAC}', "");
    Expect(0, 7672, '\p{^	IS_SYRIAC}', "");
    Expect(0, 7672, '\P{	IS_SYRIAC}', "");
    Expect(1, 7672, '\P{^	IS_SYRIAC}', "");
    Expect(0, 7673, '\p{	IS_SYRIAC}', "");
    Expect(1, 7673, '\p{^	IS_SYRIAC}', "");
    Expect(1, 7673, '\P{	IS_SYRIAC}', "");
    Expect(0, 7673, '\P{^	IS_SYRIAC}', "");
    Error('\p{/a/	_SYRC}');
    Error('\P{/a/	_SYRC}');
    Expect(1, 7672, '\p{syrc}', "");
    Expect(0, 7672, '\p{^syrc}', "");
    Expect(0, 7672, '\P{syrc}', "");
    Expect(1, 7672, '\P{^syrc}', "");
    Expect(0, 7673, '\p{syrc}', "");
    Expect(1, 7673, '\p{^syrc}', "");
    Expect(1, 7673, '\P{syrc}', "");
    Expect(0, 7673, '\P{^syrc}', "");
    Expect(1, 7672, '\p{_ syrc}', "");
    Expect(0, 7672, '\p{^_ syrc}', "");
    Expect(0, 7672, '\P{_ syrc}', "");
    Expect(1, 7672, '\P{^_ syrc}', "");
    Expect(0, 7673, '\p{_ syrc}', "");
    Expect(1, 7673, '\p{^_ syrc}', "");
    Expect(1, 7673, '\P{_ syrc}', "");
    Expect(0, 7673, '\P{^_ syrc}', "");
    Error('\p{ /a/Is_SYRC}');
    Error('\P{ /a/Is_SYRC}');
    Expect(1, 7672, '\p{issyrc}', "");
    Expect(0, 7672, '\p{^issyrc}', "");
    Expect(0, 7672, '\P{issyrc}', "");
    Expect(1, 7672, '\P{^issyrc}', "");
    Expect(0, 7673, '\p{issyrc}', "");
    Expect(1, 7673, '\p{^issyrc}', "");
    Expect(1, 7673, '\P{issyrc}', "");
    Expect(0, 7673, '\P{^issyrc}', "");
    Expect(1, 7672, '\p{  is_Syrc}', "");
    Expect(0, 7672, '\p{^  is_Syrc}', "");
    Expect(0, 7672, '\P{  is_Syrc}', "");
    Expect(1, 7672, '\P{^  is_Syrc}', "");
    Expect(0, 7673, '\p{  is_Syrc}', "");
    Expect(1, 7673, '\p{^  is_Syrc}', "");
    Expect(1, 7673, '\P{  is_Syrc}', "");
    Expect(0, 7673, '\P{^  is_Syrc}', "");
    Error('\p{:=-syriac_Supplement}');
    Error('\P{:=-syriac_Supplement}');
    Expect(1, 2159, '\p{syriacsupplement}', "");
    Expect(0, 2159, '\p{^syriacsupplement}', "");
    Expect(0, 2159, '\P{syriacsupplement}', "");
    Expect(1, 2159, '\P{^syriacsupplement}', "");
    Expect(0, 2160, '\p{syriacsupplement}', "");
    Expect(1, 2160, '\p{^syriacsupplement}', "");
    Expect(1, 2160, '\P{syriacsupplement}', "");
    Expect(0, 2160, '\P{^syriacsupplement}', "");
    Expect(1, 2159, '\p{_Syriac_Supplement}', "");
    Expect(0, 2159, '\p{^_Syriac_Supplement}', "");
    Expect(0, 2159, '\P{_Syriac_Supplement}', "");
    Expect(1, 2159, '\P{^_Syriac_Supplement}', "");
    Expect(0, 2160, '\p{_Syriac_Supplement}', "");
    Expect(1, 2160, '\p{^_Syriac_Supplement}', "");
    Expect(1, 2160, '\P{_Syriac_Supplement}', "");
    Expect(0, 2160, '\P{^_Syriac_Supplement}', "");
    Error('\p{/a/__Is_SYRIAC_Supplement}');
    Error('\P{/a/__Is_SYRIAC_Supplement}');
    Expect(1, 2159, '\p{issyriacsupplement}', "");
    Expect(0, 2159, '\p{^issyriacsupplement}', "");
    Expect(0, 2159, '\P{issyriacsupplement}', "");
    Expect(1, 2159, '\P{^issyriacsupplement}', "");
    Expect(0, 2160, '\p{issyriacsupplement}', "");
    Expect(1, 2160, '\p{^issyriacsupplement}', "");
    Expect(1, 2160, '\P{issyriacsupplement}', "");
    Expect(0, 2160, '\P{^issyriacsupplement}', "");
    Expect(1, 2159, '\p{- is_Syriac_Supplement}', "");
    Expect(0, 2159, '\p{^- is_Syriac_Supplement}', "");
    Expect(0, 2159, '\P{- is_Syriac_Supplement}', "");
    Expect(1, 2159, '\P{^- is_Syriac_Supplement}', "");
    Expect(0, 2160, '\p{- is_Syriac_Supplement}', "");
    Expect(1, 2160, '\p{^- is_Syriac_Supplement}', "");
    Expect(1, 2160, '\P{- is_Syriac_Supplement}', "");
    Expect(0, 2160, '\P{^- is_Syriac_Supplement}', "");
    Error('\p{ _In_SYRIAC_supplement:=}');
    Error('\P{ _In_SYRIAC_supplement:=}');
    Expect(1, 2159, '\p{insyriacsupplement}', "");
    Expect(0, 2159, '\p{^insyriacsupplement}', "");
    Expect(0, 2159, '\P{insyriacsupplement}', "");
    Expect(1, 2159, '\P{^insyriacsupplement}', "");
    Expect(0, 2160, '\p{insyriacsupplement}', "");
    Expect(1, 2160, '\p{^insyriacsupplement}', "");
    Expect(1, 2160, '\P{insyriacsupplement}', "");
    Expect(0, 2160, '\P{^insyriacsupplement}', "");
    Expect(1, 2159, '\p{-In_Syriac_SUPPLEMENT}', "");
    Expect(0, 2159, '\p{^-In_Syriac_SUPPLEMENT}', "");
    Expect(0, 2159, '\P{-In_Syriac_SUPPLEMENT}', "");
    Expect(1, 2159, '\P{^-In_Syriac_SUPPLEMENT}', "");
    Expect(0, 2160, '\p{-In_Syriac_SUPPLEMENT}', "");
    Expect(1, 2160, '\p{^-In_Syriac_SUPPLEMENT}', "");
    Expect(1, 2160, '\P{-In_Syriac_SUPPLEMENT}', "");
    Expect(0, 2160, '\P{^-In_Syriac_SUPPLEMENT}', "");
    Error('\p{_ SYRIAC_SUP:=}');
    Error('\P{_ SYRIAC_SUP:=}');
    Expect(1, 2159, '\p{syriacsup}', "");
    Expect(0, 2159, '\p{^syriacsup}', "");
    Expect(0, 2159, '\P{syriacsup}', "");
    Expect(1, 2159, '\P{^syriacsup}', "");
    Expect(0, 2160, '\p{syriacsup}', "");
    Expect(1, 2160, '\p{^syriacsup}', "");
    Expect(1, 2160, '\P{syriacsup}', "");
    Expect(0, 2160, '\P{^syriacsup}', "");
    Expect(1, 2159, '\p{_	Syriac_SUP}', "");
    Expect(0, 2159, '\p{^_	Syriac_SUP}', "");
    Expect(0, 2159, '\P{_	Syriac_SUP}', "");
    Expect(1, 2159, '\P{^_	Syriac_SUP}', "");
    Expect(0, 2160, '\p{_	Syriac_SUP}', "");
    Expect(1, 2160, '\p{^_	Syriac_SUP}', "");
    Expect(1, 2160, '\P{_	Syriac_SUP}', "");
    Expect(0, 2160, '\P{^_	Syriac_SUP}', "");
    Error('\p{/a/_	Is_syriac_sup}');
    Error('\P{/a/_	Is_syriac_sup}');
    Expect(1, 2159, '\p{issyriacsup}', "");
    Expect(0, 2159, '\p{^issyriacsup}', "");
    Expect(0, 2159, '\P{issyriacsup}', "");
    Expect(1, 2159, '\P{^issyriacsup}', "");
    Expect(0, 2160, '\p{issyriacsup}', "");
    Expect(1, 2160, '\p{^issyriacsup}', "");
    Expect(1, 2160, '\P{issyriacsup}', "");
    Expect(0, 2160, '\P{^issyriacsup}', "");
    Expect(1, 2159, '\p{_	IS_SYRIAC_SUP}', "");
    Expect(0, 2159, '\p{^_	IS_SYRIAC_SUP}', "");
    Expect(0, 2159, '\P{_	IS_SYRIAC_SUP}', "");
    Expect(1, 2159, '\P{^_	IS_SYRIAC_SUP}', "");
    Expect(0, 2160, '\p{_	IS_SYRIAC_SUP}', "");
    Expect(1, 2160, '\p{^_	IS_SYRIAC_SUP}', "");
    Expect(1, 2160, '\P{_	IS_SYRIAC_SUP}', "");
    Expect(0, 2160, '\P{^_	IS_SYRIAC_SUP}', "");
    Error('\p{:=In_Syriac_Sup}');
    Error('\P{:=In_Syriac_Sup}');
    Expect(1, 2159, '\p{insyriacsup}', "");
    Expect(0, 2159, '\p{^insyriacsup}', "");
    Expect(0, 2159, '\P{insyriacsup}', "");
    Expect(1, 2159, '\P{^insyriacsup}', "");
    Expect(0, 2160, '\p{insyriacsup}', "");
    Expect(1, 2160, '\p{^insyriacsup}', "");
    Expect(1, 2160, '\P{insyriacsup}', "");
    Expect(0, 2160, '\P{^insyriacsup}', "");
    Expect(1, 2159, '\p{ 	IN_syriac_SUP}', "");
    Expect(0, 2159, '\p{^ 	IN_syriac_SUP}', "");
    Expect(0, 2159, '\P{ 	IN_syriac_SUP}', "");
    Expect(1, 2159, '\P{^ 	IN_syriac_SUP}', "");
    Expect(0, 2160, '\p{ 	IN_syriac_SUP}', "");
    Expect(1, 2160, '\p{^ 	IN_syriac_SUP}', "");
    Expect(1, 2160, '\P{ 	IN_syriac_SUP}', "");
    Expect(0, 2160, '\P{^ 	IN_syriac_SUP}', "");
    Error('\p{:=TAGALOG}');
    Error('\P{:=TAGALOG}');
    Expect(1, 5942, '\p{tagalog}', "");
    Expect(0, 5942, '\p{^tagalog}', "");
    Expect(0, 5942, '\P{tagalog}', "");
    Expect(1, 5942, '\P{^tagalog}', "");
    Expect(0, 5943, '\p{tagalog}', "");
    Expect(1, 5943, '\p{^tagalog}', "");
    Expect(1, 5943, '\P{tagalog}', "");
    Expect(0, 5943, '\P{^tagalog}', "");
    Expect(1, 5942, '\p{--tagalog}', "");
    Expect(0, 5942, '\p{^--tagalog}', "");
    Expect(0, 5942, '\P{--tagalog}', "");
    Expect(1, 5942, '\P{^--tagalog}', "");
    Expect(0, 5943, '\p{--tagalog}', "");
    Expect(1, 5943, '\p{^--tagalog}', "");
    Expect(1, 5943, '\P{--tagalog}', "");
    Expect(0, 5943, '\P{^--tagalog}', "");
    Error('\p{ :=Is_TAGALOG}');
    Error('\P{ :=Is_TAGALOG}');
    Expect(1, 5942, '\p{istagalog}', "");
    Expect(0, 5942, '\p{^istagalog}', "");
    Expect(0, 5942, '\P{istagalog}', "");
    Expect(1, 5942, '\P{^istagalog}', "");
    Expect(0, 5943, '\p{istagalog}', "");
    Expect(1, 5943, '\p{^istagalog}', "");
    Expect(1, 5943, '\P{istagalog}', "");
    Expect(0, 5943, '\P{^istagalog}', "");
    Expect(1, 5942, '\p{Is_Tagalog}', "");
    Expect(0, 5942, '\p{^Is_Tagalog}', "");
    Expect(0, 5942, '\P{Is_Tagalog}', "");
    Expect(1, 5942, '\P{^Is_Tagalog}', "");
    Expect(0, 5943, '\p{Is_Tagalog}', "");
    Expect(1, 5943, '\p{^Is_Tagalog}', "");
    Expect(1, 5943, '\P{Is_Tagalog}', "");
    Expect(0, 5943, '\P{^Is_Tagalog}', "");
    Error('\p{	/a/Tglg}');
    Error('\P{	/a/Tglg}');
    Expect(1, 5942, '\p{tglg}', "");
    Expect(0, 5942, '\p{^tglg}', "");
    Expect(0, 5942, '\P{tglg}', "");
    Expect(1, 5942, '\P{^tglg}', "");
    Expect(0, 5943, '\p{tglg}', "");
    Expect(1, 5943, '\p{^tglg}', "");
    Expect(1, 5943, '\P{tglg}', "");
    Expect(0, 5943, '\P{^tglg}', "");
    Expect(1, 5942, '\p{	_tglg}', "");
    Expect(0, 5942, '\p{^	_tglg}', "");
    Expect(0, 5942, '\P{	_tglg}', "");
    Expect(1, 5942, '\P{^	_tglg}', "");
    Expect(0, 5943, '\p{	_tglg}', "");
    Expect(1, 5943, '\p{^	_tglg}', "");
    Expect(1, 5943, '\P{	_tglg}', "");
    Expect(0, 5943, '\P{^	_tglg}', "");
    Error('\p{-/a/Is_tglg}');
    Error('\P{-/a/Is_tglg}');
    Expect(1, 5942, '\p{istglg}', "");
    Expect(0, 5942, '\p{^istglg}', "");
    Expect(0, 5942, '\P{istglg}', "");
    Expect(1, 5942, '\P{^istglg}', "");
    Expect(0, 5943, '\p{istglg}', "");
    Expect(1, 5943, '\p{^istglg}', "");
    Expect(1, 5943, '\P{istglg}', "");
    Expect(0, 5943, '\P{^istglg}', "");
    Expect(1, 5942, '\p{ -is_TGLG}', "");
    Expect(0, 5942, '\p{^ -is_TGLG}', "");
    Expect(0, 5942, '\P{ -is_TGLG}', "");
    Expect(1, 5942, '\P{^ -is_TGLG}', "");
    Expect(0, 5943, '\p{ -is_TGLG}', "");
    Expect(1, 5943, '\p{^ -is_TGLG}', "");
    Expect(1, 5943, '\P{ -is_TGLG}', "");
    Expect(0, 5943, '\P{^ -is_TGLG}', "");
    Error('\p{:= -Tagbanwa}');
    Error('\P{:= -Tagbanwa}');
    Expect(1, 6003, '\p{tagbanwa}', "");
    Expect(0, 6003, '\p{^tagbanwa}', "");
    Expect(0, 6003, '\P{tagbanwa}', "");
    Expect(1, 6003, '\P{^tagbanwa}', "");
    Expect(0, 6004, '\p{tagbanwa}', "");
    Expect(1, 6004, '\p{^tagbanwa}', "");
    Expect(1, 6004, '\P{tagbanwa}', "");
    Expect(0, 6004, '\P{^tagbanwa}', "");
    Expect(1, 6003, '\p{ 	Tagbanwa}', "");
    Expect(0, 6003, '\p{^ 	Tagbanwa}', "");
    Expect(0, 6003, '\P{ 	Tagbanwa}', "");
    Expect(1, 6003, '\P{^ 	Tagbanwa}', "");
    Expect(0, 6004, '\p{ 	Tagbanwa}', "");
    Expect(1, 6004, '\p{^ 	Tagbanwa}', "");
    Expect(1, 6004, '\P{ 	Tagbanwa}', "");
    Expect(0, 6004, '\P{^ 	Tagbanwa}', "");
    Error('\p{/a/_IS_Tagbanwa}');
    Error('\P{/a/_IS_Tagbanwa}');
    Expect(1, 6003, '\p{istagbanwa}', "");
    Expect(0, 6003, '\p{^istagbanwa}', "");
    Expect(0, 6003, '\P{istagbanwa}', "");
    Expect(1, 6003, '\P{^istagbanwa}', "");
    Expect(0, 6004, '\p{istagbanwa}', "");
    Expect(1, 6004, '\p{^istagbanwa}', "");
    Expect(1, 6004, '\P{istagbanwa}', "");
    Expect(0, 6004, '\P{^istagbanwa}', "");
    Expect(1, 6003, '\p{- IS_Tagbanwa}', "");
    Expect(0, 6003, '\p{^- IS_Tagbanwa}', "");
    Expect(0, 6003, '\P{- IS_Tagbanwa}', "");
    Expect(1, 6003, '\P{^- IS_Tagbanwa}', "");
    Expect(0, 6004, '\p{- IS_Tagbanwa}', "");
    Expect(1, 6004, '\p{^- IS_Tagbanwa}', "");
    Expect(1, 6004, '\P{- IS_Tagbanwa}', "");
    Expect(0, 6004, '\P{^- IS_Tagbanwa}', "");
    Error('\p{	 TAGB:=}');
    Error('\P{	 TAGB:=}');
    Expect(1, 6003, '\p{tagb}', "");
    Expect(0, 6003, '\p{^tagb}', "");
    Expect(0, 6003, '\P{tagb}', "");
    Expect(1, 6003, '\P{^tagb}', "");
    Expect(0, 6004, '\p{tagb}', "");
    Expect(1, 6004, '\p{^tagb}', "");
    Expect(1, 6004, '\P{tagb}', "");
    Expect(0, 6004, '\P{^tagb}', "");
    Expect(1, 6003, '\p{	_Tagb}', "");
    Expect(0, 6003, '\p{^	_Tagb}', "");
    Expect(0, 6003, '\P{	_Tagb}', "");
    Expect(1, 6003, '\P{^	_Tagb}', "");
    Expect(0, 6004, '\p{	_Tagb}', "");
    Expect(1, 6004, '\p{^	_Tagb}', "");
    Expect(1, 6004, '\P{	_Tagb}', "");
    Expect(0, 6004, '\P{^	_Tagb}', "");
    Error('\p{:=--Is_Tagb}');
    Error('\P{:=--Is_Tagb}');
    Expect(1, 6003, '\p{istagb}', "");
    Expect(0, 6003, '\p{^istagb}', "");
    Expect(0, 6003, '\P{istagb}', "");
    Expect(1, 6003, '\P{^istagb}', "");
    Expect(0, 6004, '\p{istagb}', "");
    Expect(1, 6004, '\p{^istagb}', "");
    Expect(1, 6004, '\P{istagb}', "");
    Expect(0, 6004, '\P{^istagb}', "");
    Expect(1, 6003, '\p{ 	Is_Tagb}', "");
    Expect(0, 6003, '\p{^ 	Is_Tagb}', "");
    Expect(0, 6003, '\P{ 	Is_Tagb}', "");
    Expect(1, 6003, '\P{^ 	Is_Tagb}', "");
    Expect(0, 6004, '\p{ 	Is_Tagb}', "");
    Expect(1, 6004, '\p{^ 	Is_Tagb}', "");
    Expect(1, 6004, '\P{ 	Is_Tagb}', "");
    Expect(0, 6004, '\P{^ 	Is_Tagb}', "");
    Error('\p{-	Tags:=}');
    Error('\P{-	Tags:=}');
    Expect(1, 917631, '\p{tags}', "");
    Expect(0, 917631, '\p{^tags}', "");
    Expect(0, 917631, '\P{tags}', "");
    Expect(1, 917631, '\P{^tags}', "");
    Expect(0, 917632, '\p{tags}', "");
    Expect(1, 917632, '\p{^tags}', "");
    Expect(1, 917632, '\P{tags}', "");
    Expect(0, 917632, '\P{^tags}', "");
    Expect(1, 917631, '\p{-_tags}', "");
    Expect(0, 917631, '\p{^-_tags}', "");
    Expect(0, 917631, '\P{-_tags}', "");
    Expect(1, 917631, '\P{^-_tags}', "");
    Expect(0, 917632, '\p{-_tags}', "");
    Expect(1, 917632, '\p{^-_tags}', "");
    Expect(1, 917632, '\P{-_tags}', "");
    Expect(0, 917632, '\P{^-_tags}', "");
    Error('\p{/a/_	Is_tags}');
    Error('\P{/a/_	Is_tags}');
    Expect(1, 917631, '\p{istags}', "");
    Expect(0, 917631, '\p{^istags}', "");
    Expect(0, 917631, '\P{istags}', "");
    Expect(1, 917631, '\P{^istags}', "");
    Expect(0, 917632, '\p{istags}', "");
    Expect(1, 917632, '\p{^istags}', "");
    Expect(1, 917632, '\P{istags}', "");
    Expect(0, 917632, '\P{^istags}', "");
    Expect(1, 917631, '\p{	 Is_TAGS}', "");
    Expect(0, 917631, '\p{^	 Is_TAGS}', "");
    Expect(0, 917631, '\P{	 Is_TAGS}', "");
    Expect(1, 917631, '\P{^	 Is_TAGS}', "");
    Expect(0, 917632, '\p{	 Is_TAGS}', "");
    Expect(1, 917632, '\p{^	 Is_TAGS}', "");
    Expect(1, 917632, '\P{	 Is_TAGS}', "");
    Expect(0, 917632, '\P{^	 Is_TAGS}', "");
    Error('\p{:=IN_TAGS}');
    Error('\P{:=IN_TAGS}');
    Expect(1, 917631, '\p{intags}', "");
    Expect(0, 917631, '\p{^intags}', "");
    Expect(0, 917631, '\P{intags}', "");
    Expect(1, 917631, '\P{^intags}', "");
    Expect(0, 917632, '\p{intags}', "");
    Expect(1, 917632, '\p{^intags}', "");
    Expect(1, 917632, '\P{intags}', "");
    Expect(0, 917632, '\P{^intags}', "");
    Expect(1, 917631, '\p{-_in_tags}', "");
    Expect(0, 917631, '\p{^-_in_tags}', "");
    Expect(0, 917631, '\P{-_in_tags}', "");
    Expect(1, 917631, '\P{^-_in_tags}', "");
    Expect(0, 917632, '\p{-_in_tags}', "");
    Expect(1, 917632, '\p{^-_in_tags}', "");
    Expect(1, 917632, '\P{-_in_tags}', "");
    Expect(0, 917632, '\P{^-_in_tags}', "");
    Error('\p{/a/TAI_LE}');
    Error('\P{/a/TAI_LE}');
    Expect(1, 6516, '\p{taile}', "");
    Expect(0, 6516, '\p{^taile}', "");
    Expect(0, 6516, '\P{taile}', "");
    Expect(1, 6516, '\P{^taile}', "");
    Expect(0, 6517, '\p{taile}', "");
    Expect(1, 6517, '\p{^taile}', "");
    Expect(1, 6517, '\P{taile}', "");
    Expect(0, 6517, '\P{^taile}', "");
    Expect(1, 6516, '\p{ _tai_le}', "");
    Expect(0, 6516, '\p{^ _tai_le}', "");
    Expect(0, 6516, '\P{ _tai_le}', "");
    Expect(1, 6516, '\P{^ _tai_le}', "");
    Expect(0, 6517, '\p{ _tai_le}', "");
    Expect(1, 6517, '\p{^ _tai_le}', "");
    Expect(1, 6517, '\P{ _tai_le}', "");
    Expect(0, 6517, '\P{^ _tai_le}', "");
    Error('\p{/a/_ IS_TAI_le}');
    Error('\P{/a/_ IS_TAI_le}');
    Expect(1, 6516, '\p{istaile}', "");
    Expect(0, 6516, '\p{^istaile}', "");
    Expect(0, 6516, '\P{istaile}', "");
    Expect(1, 6516, '\P{^istaile}', "");
    Expect(0, 6517, '\p{istaile}', "");
    Expect(1, 6517, '\p{^istaile}', "");
    Expect(1, 6517, '\P{istaile}', "");
    Expect(0, 6517, '\P{^istaile}', "");
    Expect(1, 6516, '\p{	 is_Tai_le}', "");
    Expect(0, 6516, '\p{^	 is_Tai_le}', "");
    Expect(0, 6516, '\P{	 is_Tai_le}', "");
    Expect(1, 6516, '\P{^	 is_Tai_le}', "");
    Expect(0, 6517, '\p{	 is_Tai_le}', "");
    Expect(1, 6517, '\p{^	 is_Tai_le}', "");
    Expect(1, 6517, '\P{	 is_Tai_le}', "");
    Expect(0, 6517, '\P{^	 is_Tai_le}', "");
    Error('\p{ TALE:=}');
    Error('\P{ TALE:=}');
    Expect(1, 6516, '\p{tale}', "");
    Expect(0, 6516, '\p{^tale}', "");
    Expect(0, 6516, '\P{tale}', "");
    Expect(1, 6516, '\P{^tale}', "");
    Expect(0, 6517, '\p{tale}', "");
    Expect(1, 6517, '\p{^tale}', "");
    Expect(1, 6517, '\P{tale}', "");
    Expect(0, 6517, '\P{^tale}', "");
    Expect(1, 6516, '\p{-	TALE}', "");
    Expect(0, 6516, '\p{^-	TALE}', "");
    Expect(0, 6516, '\P{-	TALE}', "");
    Expect(1, 6516, '\P{^-	TALE}', "");
    Expect(0, 6517, '\p{-	TALE}', "");
    Expect(1, 6517, '\p{^-	TALE}', "");
    Expect(1, 6517, '\P{-	TALE}', "");
    Expect(0, 6517, '\P{^-	TALE}', "");
    Error('\p{ :=Is_Tale}');
    Error('\P{ :=Is_Tale}');
    Expect(1, 6516, '\p{istale}', "");
    Expect(0, 6516, '\p{^istale}', "");
    Expect(0, 6516, '\P{istale}', "");
    Expect(1, 6516, '\P{^istale}', "");
    Expect(0, 6517, '\p{istale}', "");
    Expect(1, 6517, '\p{^istale}', "");
    Expect(1, 6517, '\P{istale}', "");
    Expect(0, 6517, '\P{^istale}', "");
    Expect(1, 6516, '\p{_Is_TALE}', "");
    Expect(0, 6516, '\p{^_Is_TALE}', "");
    Expect(0, 6516, '\P{_Is_TALE}', "");
    Expect(1, 6516, '\P{^_Is_TALE}', "");
    Expect(0, 6517, '\p{_Is_TALE}', "");
    Expect(1, 6517, '\p{^_Is_TALE}', "");
    Expect(1, 6517, '\P{_Is_TALE}', "");
    Expect(0, 6517, '\P{^_Is_TALE}', "");
    Error('\p{/a/__Tai_Tham}');
    Error('\P{/a/__Tai_Tham}');
    Expect(1, 6829, '\p{taitham}', "");
    Expect(0, 6829, '\p{^taitham}', "");
    Expect(0, 6829, '\P{taitham}', "");
    Expect(1, 6829, '\P{^taitham}', "");
    Expect(0, 6830, '\p{taitham}', "");
    Expect(1, 6830, '\p{^taitham}', "");
    Expect(1, 6830, '\P{taitham}', "");
    Expect(0, 6830, '\P{^taitham}', "");
    Expect(1, 6829, '\p{_-tai_tham}', "");
    Expect(0, 6829, '\p{^_-tai_tham}', "");
    Expect(0, 6829, '\P{_-tai_tham}', "");
    Expect(1, 6829, '\P{^_-tai_tham}', "");
    Expect(0, 6830, '\p{_-tai_tham}', "");
    Expect(1, 6830, '\p{^_-tai_tham}', "");
    Expect(1, 6830, '\P{_-tai_tham}', "");
    Expect(0, 6830, '\P{^_-tai_tham}', "");
    Error('\p{-:=Is_tai_THAM}');
    Error('\P{-:=Is_tai_THAM}');
    Expect(1, 6829, '\p{istaitham}', "");
    Expect(0, 6829, '\p{^istaitham}', "");
    Expect(0, 6829, '\P{istaitham}', "");
    Expect(1, 6829, '\P{^istaitham}', "");
    Expect(0, 6830, '\p{istaitham}', "");
    Expect(1, 6830, '\p{^istaitham}', "");
    Expect(1, 6830, '\P{istaitham}', "");
    Expect(0, 6830, '\P{^istaitham}', "");
    Expect(1, 6829, '\p{	is_TAI_tham}', "");
    Expect(0, 6829, '\p{^	is_TAI_tham}', "");
    Expect(0, 6829, '\P{	is_TAI_tham}', "");
    Expect(1, 6829, '\P{^	is_TAI_tham}', "");
    Expect(0, 6830, '\p{	is_TAI_tham}', "");
    Expect(1, 6830, '\p{^	is_TAI_tham}', "");
    Expect(1, 6830, '\P{	is_TAI_tham}', "");
    Expect(0, 6830, '\P{^	is_TAI_tham}', "");
    Error('\p{:=-_LANA}');
    Error('\P{:=-_LANA}');
    Expect(1, 6829, '\p{lana}', "");
    Expect(0, 6829, '\p{^lana}', "");
    Expect(0, 6829, '\P{lana}', "");
    Expect(1, 6829, '\P{^lana}', "");
    Expect(0, 6830, '\p{lana}', "");
    Expect(1, 6830, '\p{^lana}', "");
    Expect(1, 6830, '\P{lana}', "");
    Expect(0, 6830, '\P{^lana}', "");
    Expect(1, 6829, '\p{_-lana}', "");
    Expect(0, 6829, '\p{^_-lana}', "");
    Expect(0, 6829, '\P{_-lana}', "");
    Expect(1, 6829, '\P{^_-lana}', "");
    Expect(0, 6830, '\p{_-lana}', "");
    Expect(1, 6830, '\p{^_-lana}', "");
    Expect(1, 6830, '\P{_-lana}', "");
    Expect(0, 6830, '\P{^_-lana}', "");
    Error('\p{/a/ 	is_Lana}');
    Error('\P{/a/ 	is_Lana}');
    Expect(1, 6829, '\p{islana}', "");
    Expect(0, 6829, '\p{^islana}', "");
    Expect(0, 6829, '\P{islana}', "");
    Expect(1, 6829, '\P{^islana}', "");
    Expect(0, 6830, '\p{islana}', "");
    Expect(1, 6830, '\p{^islana}', "");
    Expect(1, 6830, '\P{islana}', "");
    Expect(0, 6830, '\P{^islana}', "");
    Expect(1, 6829, '\p{	 is_Lana}', "");
    Expect(0, 6829, '\p{^	 is_Lana}', "");
    Expect(0, 6829, '\P{	 is_Lana}', "");
    Expect(1, 6829, '\P{^	 is_Lana}', "");
    Expect(0, 6830, '\p{	 is_Lana}', "");
    Expect(1, 6830, '\p{^	 is_Lana}', "");
    Expect(1, 6830, '\P{	 is_Lana}', "");
    Expect(0, 6830, '\P{^	 is_Lana}', "");
    Error('\p{	TAI_viet:=}');
    Error('\P{	TAI_viet:=}');
    Expect(1, 43743, '\p{taiviet}', "");
    Expect(0, 43743, '\p{^taiviet}', "");
    Expect(0, 43743, '\P{taiviet}', "");
    Expect(1, 43743, '\P{^taiviet}', "");
    Expect(0, 43744, '\p{taiviet}', "");
    Expect(1, 43744, '\p{^taiviet}', "");
    Expect(1, 43744, '\P{taiviet}', "");
    Expect(0, 43744, '\P{^taiviet}', "");
    Expect(1, 43743, '\p{		tai_viet}', "");
    Expect(0, 43743, '\p{^		tai_viet}', "");
    Expect(0, 43743, '\P{		tai_viet}', "");
    Expect(1, 43743, '\P{^		tai_viet}', "");
    Expect(0, 43744, '\p{		tai_viet}', "");
    Expect(1, 43744, '\p{^		tai_viet}', "");
    Expect(1, 43744, '\P{		tai_viet}', "");
    Expect(0, 43744, '\P{^		tai_viet}', "");
    Error('\p{/a/	_Is_Tai_Viet}');
    Error('\P{/a/	_Is_Tai_Viet}');
    Expect(1, 43743, '\p{istaiviet}', "");
    Expect(0, 43743, '\p{^istaiviet}', "");
    Expect(0, 43743, '\P{istaiviet}', "");
    Expect(1, 43743, '\P{^istaiviet}', "");
    Expect(0, 43744, '\p{istaiviet}', "");
    Expect(1, 43744, '\p{^istaiviet}', "");
    Expect(1, 43744, '\P{istaiviet}', "");
    Expect(0, 43744, '\P{^istaiviet}', "");
    Expect(1, 43743, '\p{ -Is_TAI_VIET}', "");
    Expect(0, 43743, '\p{^ -Is_TAI_VIET}', "");
    Expect(0, 43743, '\P{ -Is_TAI_VIET}', "");
    Expect(1, 43743, '\P{^ -Is_TAI_VIET}', "");
    Expect(0, 43744, '\p{ -Is_TAI_VIET}', "");
    Expect(1, 43744, '\p{^ -Is_TAI_VIET}', "");
    Expect(1, 43744, '\P{ -Is_TAI_VIET}', "");
    Expect(0, 43744, '\P{^ -Is_TAI_VIET}', "");
    Error('\p{:=		tavt}');
    Error('\P{:=		tavt}');
    Expect(1, 43743, '\p{tavt}', "");
    Expect(0, 43743, '\p{^tavt}', "");
    Expect(0, 43743, '\P{tavt}', "");
    Expect(1, 43743, '\P{^tavt}', "");
    Expect(0, 43744, '\p{tavt}', "");
    Expect(1, 43744, '\p{^tavt}', "");
    Expect(1, 43744, '\P{tavt}', "");
    Expect(0, 43744, '\P{^tavt}', "");
    Expect(1, 43743, '\p{	 tavt}', "");
    Expect(0, 43743, '\p{^	 tavt}', "");
    Expect(0, 43743, '\P{	 tavt}', "");
    Expect(1, 43743, '\P{^	 tavt}', "");
    Expect(0, 43744, '\p{	 tavt}', "");
    Expect(1, 43744, '\p{^	 tavt}', "");
    Expect(1, 43744, '\P{	 tavt}', "");
    Expect(0, 43744, '\P{^	 tavt}', "");
    Error('\p{-_Is_tavt/a/}');
    Error('\P{-_Is_tavt/a/}');
    Expect(1, 43743, '\p{istavt}', "");
    Expect(0, 43743, '\p{^istavt}', "");
    Expect(0, 43743, '\P{istavt}', "");
    Expect(1, 43743, '\P{^istavt}', "");
    Expect(0, 43744, '\p{istavt}', "");
    Expect(1, 43744, '\p{^istavt}', "");
    Expect(1, 43744, '\P{istavt}', "");
    Expect(0, 43744, '\P{^istavt}', "");
    Expect(1, 43743, '\p{	 IS_TAVT}', "");
    Expect(0, 43743, '\p{^	 IS_TAVT}', "");
    Expect(0, 43743, '\P{	 IS_TAVT}', "");
    Expect(1, 43743, '\P{^	 IS_TAVT}', "");
    Expect(0, 43744, '\p{	 IS_TAVT}', "");
    Expect(1, 43744, '\p{^	 IS_TAVT}', "");
    Expect(1, 43744, '\P{	 IS_TAVT}', "");
    Expect(0, 43744, '\P{^	 IS_TAVT}', "");
    Error('\p{_ Tai_Xuan_Jing_SYMBOLS/a/}');
    Error('\P{_ Tai_Xuan_Jing_SYMBOLS/a/}');
    Expect(1, 119647, '\p{taixuanjingsymbols}', "");
    Expect(0, 119647, '\p{^taixuanjingsymbols}', "");
    Expect(0, 119647, '\P{taixuanjingsymbols}', "");
    Expect(1, 119647, '\P{^taixuanjingsymbols}', "");
    Expect(0, 119648, '\p{taixuanjingsymbols}', "");
    Expect(1, 119648, '\p{^taixuanjingsymbols}', "");
    Expect(1, 119648, '\P{taixuanjingsymbols}', "");
    Expect(0, 119648, '\P{^taixuanjingsymbols}', "");
    Expect(1, 119647, '\p{ -TAI_xuan_Jing_Symbols}', "");
    Expect(0, 119647, '\p{^ -TAI_xuan_Jing_Symbols}', "");
    Expect(0, 119647, '\P{ -TAI_xuan_Jing_Symbols}', "");
    Expect(1, 119647, '\P{^ -TAI_xuan_Jing_Symbols}', "");
    Expect(0, 119648, '\p{ -TAI_xuan_Jing_Symbols}', "");
    Expect(1, 119648, '\p{^ -TAI_xuan_Jing_Symbols}', "");
    Expect(1, 119648, '\P{ -TAI_xuan_Jing_Symbols}', "");
    Expect(0, 119648, '\P{^ -TAI_xuan_Jing_Symbols}', "");
    Error('\p{:=	is_tai_xuan_JING_symbols}');
    Error('\P{:=	is_tai_xuan_JING_symbols}');
    Expect(1, 119647, '\p{istaixuanjingsymbols}', "");
    Expect(0, 119647, '\p{^istaixuanjingsymbols}', "");
    Expect(0, 119647, '\P{istaixuanjingsymbols}', "");
    Expect(1, 119647, '\P{^istaixuanjingsymbols}', "");
    Expect(0, 119648, '\p{istaixuanjingsymbols}', "");
    Expect(1, 119648, '\p{^istaixuanjingsymbols}', "");
    Expect(1, 119648, '\P{istaixuanjingsymbols}', "");
    Expect(0, 119648, '\P{^istaixuanjingsymbols}', "");
    Expect(1, 119647, '\p{- is_tai_Xuan_Jing_symbols}', "");
    Expect(0, 119647, '\p{^- is_tai_Xuan_Jing_symbols}', "");
    Expect(0, 119647, '\P{- is_tai_Xuan_Jing_symbols}', "");
    Expect(1, 119647, '\P{^- is_tai_Xuan_Jing_symbols}', "");
    Expect(0, 119648, '\p{- is_tai_Xuan_Jing_symbols}', "");
    Expect(1, 119648, '\p{^- is_tai_Xuan_Jing_symbols}', "");
    Expect(1, 119648, '\P{- is_tai_Xuan_Jing_symbols}', "");
    Expect(0, 119648, '\P{^- is_tai_Xuan_Jing_symbols}', "");
    Error('\p{/a/--IN_Tai_XUAN_JING_Symbols}');
    Error('\P{/a/--IN_Tai_XUAN_JING_Symbols}');
    Expect(1, 119647, '\p{intaixuanjingsymbols}', "");
    Expect(0, 119647, '\p{^intaixuanjingsymbols}', "");
    Expect(0, 119647, '\P{intaixuanjingsymbols}', "");
    Expect(1, 119647, '\P{^intaixuanjingsymbols}', "");
    Expect(0, 119648, '\p{intaixuanjingsymbols}', "");
    Expect(1, 119648, '\p{^intaixuanjingsymbols}', "");
    Expect(1, 119648, '\P{intaixuanjingsymbols}', "");
    Expect(0, 119648, '\P{^intaixuanjingsymbols}', "");
    Expect(1, 119647, '\p{_	In_Tai_Xuan_Jing_symbols}', "");
    Expect(0, 119647, '\p{^_	In_Tai_Xuan_Jing_symbols}', "");
    Expect(0, 119647, '\P{_	In_Tai_Xuan_Jing_symbols}', "");
    Expect(1, 119647, '\P{^_	In_Tai_Xuan_Jing_symbols}', "");
    Expect(0, 119648, '\p{_	In_Tai_Xuan_Jing_symbols}', "");
    Expect(1, 119648, '\p{^_	In_Tai_Xuan_Jing_symbols}', "");
    Expect(1, 119648, '\P{_	In_Tai_Xuan_Jing_symbols}', "");
    Expect(0, 119648, '\P{^_	In_Tai_Xuan_Jing_symbols}', "");
    Error('\p{ :=Tai_Xuan_JING}');
    Error('\P{ :=Tai_Xuan_JING}');
    Expect(1, 119647, '\p{taixuanjing}', "");
    Expect(0, 119647, '\p{^taixuanjing}', "");
    Expect(0, 119647, '\P{taixuanjing}', "");
    Expect(1, 119647, '\P{^taixuanjing}', "");
    Expect(0, 119648, '\p{taixuanjing}', "");
    Expect(1, 119648, '\p{^taixuanjing}', "");
    Expect(1, 119648, '\P{taixuanjing}', "");
    Expect(0, 119648, '\P{^taixuanjing}', "");
    Expect(1, 119647, '\p{ -TAI_XUAN_Jing}', "");
    Expect(0, 119647, '\p{^ -TAI_XUAN_Jing}', "");
    Expect(0, 119647, '\P{ -TAI_XUAN_Jing}', "");
    Expect(1, 119647, '\P{^ -TAI_XUAN_Jing}', "");
    Expect(0, 119648, '\p{ -TAI_XUAN_Jing}', "");
    Expect(1, 119648, '\p{^ -TAI_XUAN_Jing}', "");
    Expect(1, 119648, '\P{ -TAI_XUAN_Jing}', "");
    Expect(0, 119648, '\P{^ -TAI_XUAN_Jing}', "");
    Error('\p{	_Is_Tai_Xuan_JING:=}');
    Error('\P{	_Is_Tai_Xuan_JING:=}');
    Expect(1, 119647, '\p{istaixuanjing}', "");
    Expect(0, 119647, '\p{^istaixuanjing}', "");
    Expect(0, 119647, '\P{istaixuanjing}', "");
    Expect(1, 119647, '\P{^istaixuanjing}', "");
    Expect(0, 119648, '\p{istaixuanjing}', "");
    Expect(1, 119648, '\p{^istaixuanjing}', "");
    Expect(1, 119648, '\P{istaixuanjing}', "");
    Expect(0, 119648, '\P{^istaixuanjing}', "");
    Expect(1, 119647, '\p{ 	Is_Tai_XUAN_Jing}', "");
    Expect(0, 119647, '\p{^ 	Is_Tai_XUAN_Jing}', "");
    Expect(0, 119647, '\P{ 	Is_Tai_XUAN_Jing}', "");
    Expect(1, 119647, '\P{^ 	Is_Tai_XUAN_Jing}', "");
    Expect(0, 119648, '\p{ 	Is_Tai_XUAN_Jing}', "");
    Expect(1, 119648, '\p{^ 	Is_Tai_XUAN_Jing}', "");
    Expect(1, 119648, '\P{ 	Is_Tai_XUAN_Jing}', "");
    Expect(0, 119648, '\P{^ 	Is_Tai_XUAN_Jing}', "");
    Error('\p{	:=IN_tai_Xuan_Jing}');
    Error('\P{	:=IN_tai_Xuan_Jing}');
    Expect(1, 119647, '\p{intaixuanjing}', "");
    Expect(0, 119647, '\p{^intaixuanjing}', "");
    Expect(0, 119647, '\P{intaixuanjing}', "");
    Expect(1, 119647, '\P{^intaixuanjing}', "");
    Expect(0, 119648, '\p{intaixuanjing}', "");
    Expect(1, 119648, '\p{^intaixuanjing}', "");
    Expect(1, 119648, '\P{intaixuanjing}', "");
    Expect(0, 119648, '\P{^intaixuanjing}', "");
    Expect(1, 119647, '\p{	 in_Tai_XUAN_Jing}', "");
    Expect(0, 119647, '\p{^	 in_Tai_XUAN_Jing}', "");
    Expect(0, 119647, '\P{	 in_Tai_XUAN_Jing}', "");
    Expect(1, 119647, '\P{^	 in_Tai_XUAN_Jing}', "");
    Expect(0, 119648, '\p{	 in_Tai_XUAN_Jing}', "");
    Expect(1, 119648, '\p{^	 in_Tai_XUAN_Jing}', "");
    Expect(1, 119648, '\P{	 in_Tai_XUAN_Jing}', "");
    Expect(0, 119648, '\P{^	 in_Tai_XUAN_Jing}', "");
    Error('\p{ /a/takri}');
    Error('\P{ /a/takri}');
    Expect(1, 71369, '\p{takri}', "");
    Expect(0, 71369, '\p{^takri}', "");
    Expect(0, 71369, '\P{takri}', "");
    Expect(1, 71369, '\P{^takri}', "");
    Expect(0, 71370, '\p{takri}', "");
    Expect(1, 71370, '\p{^takri}', "");
    Expect(1, 71370, '\P{takri}', "");
    Expect(0, 71370, '\P{^takri}', "");
    Expect(1, 71369, '\p{_-Takri}', "");
    Expect(0, 71369, '\p{^_-Takri}', "");
    Expect(0, 71369, '\P{_-Takri}', "");
    Expect(1, 71369, '\P{^_-Takri}', "");
    Expect(0, 71370, '\p{_-Takri}', "");
    Expect(1, 71370, '\p{^_-Takri}', "");
    Expect(1, 71370, '\P{_-Takri}', "");
    Expect(0, 71370, '\P{^_-Takri}', "");
    Error('\p{	/a/IS_Takri}');
    Error('\P{	/a/IS_Takri}');
    Expect(1, 71369, '\p{istakri}', "");
    Expect(0, 71369, '\p{^istakri}', "");
    Expect(0, 71369, '\P{istakri}', "");
    Expect(1, 71369, '\P{^istakri}', "");
    Expect(0, 71370, '\p{istakri}', "");
    Expect(1, 71370, '\p{^istakri}', "");
    Expect(1, 71370, '\P{istakri}', "");
    Expect(0, 71370, '\P{^istakri}', "");
    Expect(1, 71369, '\p{is_TAKRI}', "");
    Expect(0, 71369, '\p{^is_TAKRI}', "");
    Expect(0, 71369, '\P{is_TAKRI}', "");
    Expect(1, 71369, '\P{^is_TAKRI}', "");
    Expect(0, 71370, '\p{is_TAKRI}', "");
    Expect(1, 71370, '\p{^is_TAKRI}', "");
    Expect(1, 71370, '\P{is_TAKRI}', "");
    Expect(0, 71370, '\P{^is_TAKRI}', "");
    Error('\p{ :=Takr}');
    Error('\P{ :=Takr}');
    Expect(1, 71369, '\p{takr}', "");
    Expect(0, 71369, '\p{^takr}', "");
    Expect(0, 71369, '\P{takr}', "");
    Expect(1, 71369, '\P{^takr}', "");
    Expect(0, 71370, '\p{takr}', "");
    Expect(1, 71370, '\p{^takr}', "");
    Expect(1, 71370, '\P{takr}', "");
    Expect(0, 71370, '\P{^takr}', "");
    Expect(1, 71369, '\p{Takr}', "");
    Expect(0, 71369, '\p{^Takr}', "");
    Expect(0, 71369, '\P{Takr}', "");
    Expect(1, 71369, '\P{^Takr}', "");
    Expect(0, 71370, '\p{Takr}', "");
    Expect(1, 71370, '\p{^Takr}', "");
    Expect(1, 71370, '\P{Takr}', "");
    Expect(0, 71370, '\P{^Takr}', "");
    Error('\p{		is_TAKR:=}');
    Error('\P{		is_TAKR:=}');
    Expect(1, 71369, '\p{istakr}', "");
    Expect(0, 71369, '\p{^istakr}', "");
    Expect(0, 71369, '\P{istakr}', "");
    Expect(1, 71369, '\P{^istakr}', "");
    Expect(0, 71370, '\p{istakr}', "");
    Expect(1, 71370, '\p{^istakr}', "");
    Expect(1, 71370, '\P{istakr}', "");
    Expect(0, 71370, '\P{^istakr}', "");
    Expect(1, 71369, '\p{	Is_TAKR}', "");
    Expect(0, 71369, '\p{^	Is_TAKR}', "");
    Expect(0, 71369, '\P{	Is_TAKR}', "");
    Expect(1, 71369, '\P{^	Is_TAKR}', "");
    Expect(0, 71370, '\p{	Is_TAKR}', "");
    Expect(1, 71370, '\p{^	Is_TAKR}', "");
    Expect(1, 71370, '\P{	Is_TAKR}', "");
    Expect(0, 71370, '\P{^	Is_TAKR}', "");
    Error('\p{ :=tamil}');
    Error('\P{ :=tamil}');
    Expect(1, 73727, '\p{tamil}', "");
    Expect(0, 73727, '\p{^tamil}', "");
    Expect(0, 73727, '\P{tamil}', "");
    Expect(1, 73727, '\P{^tamil}', "");
    Expect(0, 73728, '\p{tamil}', "");
    Expect(1, 73728, '\p{^tamil}', "");
    Expect(1, 73728, '\P{tamil}', "");
    Expect(0, 73728, '\P{^tamil}', "");
    Expect(1, 73727, '\p{_ TAMIL}', "");
    Expect(0, 73727, '\p{^_ TAMIL}', "");
    Expect(0, 73727, '\P{_ TAMIL}', "");
    Expect(1, 73727, '\P{^_ TAMIL}', "");
    Expect(0, 73728, '\p{_ TAMIL}', "");
    Expect(1, 73728, '\p{^_ TAMIL}', "");
    Expect(1, 73728, '\P{_ TAMIL}', "");
    Expect(0, 73728, '\P{^_ TAMIL}', "");
    Error('\p{ :=IS_tamil}');
    Error('\P{ :=IS_tamil}');
    Expect(1, 73727, '\p{istamil}', "");
    Expect(0, 73727, '\p{^istamil}', "");
    Expect(0, 73727, '\P{istamil}', "");
    Expect(1, 73727, '\P{^istamil}', "");
    Expect(0, 73728, '\p{istamil}', "");
    Expect(1, 73728, '\p{^istamil}', "");
    Expect(1, 73728, '\P{istamil}', "");
    Expect(0, 73728, '\P{^istamil}', "");
    Expect(1, 73727, '\p{_ Is_tamil}', "");
    Expect(0, 73727, '\p{^_ Is_tamil}', "");
    Expect(0, 73727, '\P{_ Is_tamil}', "");
    Expect(1, 73727, '\P{^_ Is_tamil}', "");
    Expect(0, 73728, '\p{_ Is_tamil}', "");
    Expect(1, 73728, '\p{^_ Is_tamil}', "");
    Expect(1, 73728, '\P{_ Is_tamil}', "");
    Expect(0, 73728, '\P{^_ Is_tamil}', "");
    Error('\p{:=-_Taml}');
    Error('\P{:=-_Taml}');
    Expect(1, 73727, '\p{taml}', "");
    Expect(0, 73727, '\p{^taml}', "");
    Expect(0, 73727, '\P{taml}', "");
    Expect(1, 73727, '\P{^taml}', "");
    Expect(0, 73728, '\p{taml}', "");
    Expect(1, 73728, '\p{^taml}', "");
    Expect(1, 73728, '\P{taml}', "");
    Expect(0, 73728, '\P{^taml}', "");
    Expect(1, 73727, '\p{_Taml}', "");
    Expect(0, 73727, '\p{^_Taml}', "");
    Expect(0, 73727, '\P{_Taml}', "");
    Expect(1, 73727, '\P{^_Taml}', "");
    Expect(0, 73728, '\p{_Taml}', "");
    Expect(1, 73728, '\p{^_Taml}', "");
    Expect(1, 73728, '\P{_Taml}', "");
    Expect(0, 73728, '\P{^_Taml}', "");
    Error('\p{_Is_Taml:=}');
    Error('\P{_Is_Taml:=}');
    Expect(1, 73727, '\p{istaml}', "");
    Expect(0, 73727, '\p{^istaml}', "");
    Expect(0, 73727, '\P{istaml}', "");
    Expect(1, 73727, '\P{^istaml}', "");
    Expect(0, 73728, '\p{istaml}', "");
    Expect(1, 73728, '\p{^istaml}', "");
    Expect(1, 73728, '\P{istaml}', "");
    Expect(0, 73728, '\P{^istaml}', "");
    Expect(1, 73727, '\p{_Is_taml}', "");
    Expect(0, 73727, '\p{^_Is_taml}', "");
    Expect(0, 73727, '\P{_Is_taml}', "");
    Expect(1, 73727, '\P{^_Is_taml}', "");
    Expect(0, 73728, '\p{_Is_taml}', "");
    Expect(1, 73728, '\p{^_Is_taml}', "");
    Expect(1, 73728, '\P{_Is_taml}', "");
    Expect(0, 73728, '\P{^_Is_taml}', "");
    Error('\p{ :=TAMIL_supplement}');
    Error('\P{ :=TAMIL_supplement}');
    Expect(1, 73727, '\p{tamilsupplement}', "");
    Expect(0, 73727, '\p{^tamilsupplement}', "");
    Expect(0, 73727, '\P{tamilsupplement}', "");
    Expect(1, 73727, '\P{^tamilsupplement}', "");
    Expect(0, 73728, '\p{tamilsupplement}', "");
    Expect(1, 73728, '\p{^tamilsupplement}', "");
    Expect(1, 73728, '\P{tamilsupplement}', "");
    Expect(0, 73728, '\P{^tamilsupplement}', "");
    Expect(1, 73727, '\p{-TAMIL_Supplement}', "");
    Expect(0, 73727, '\p{^-TAMIL_Supplement}', "");
    Expect(0, 73727, '\P{-TAMIL_Supplement}', "");
    Expect(1, 73727, '\P{^-TAMIL_Supplement}', "");
    Expect(0, 73728, '\p{-TAMIL_Supplement}', "");
    Expect(1, 73728, '\p{^-TAMIL_Supplement}', "");
    Expect(1, 73728, '\P{-TAMIL_Supplement}', "");
    Expect(0, 73728, '\P{^-TAMIL_Supplement}', "");
    Error('\p{/a/-_IS_TAMIL_Supplement}');
    Error('\P{/a/-_IS_TAMIL_Supplement}');
    Expect(1, 73727, '\p{istamilsupplement}', "");
    Expect(0, 73727, '\p{^istamilsupplement}', "");
    Expect(0, 73727, '\P{istamilsupplement}', "");
    Expect(1, 73727, '\P{^istamilsupplement}', "");
    Expect(0, 73728, '\p{istamilsupplement}', "");
    Expect(1, 73728, '\p{^istamilsupplement}', "");
    Expect(1, 73728, '\P{istamilsupplement}', "");
    Expect(0, 73728, '\P{^istamilsupplement}', "");
    Expect(1, 73727, '\p{ Is_Tamil_SUPPLEMENT}', "");
    Expect(0, 73727, '\p{^ Is_Tamil_SUPPLEMENT}', "");
    Expect(0, 73727, '\P{ Is_Tamil_SUPPLEMENT}', "");
    Expect(1, 73727, '\P{^ Is_Tamil_SUPPLEMENT}', "");
    Expect(0, 73728, '\p{ Is_Tamil_SUPPLEMENT}', "");
    Expect(1, 73728, '\p{^ Is_Tamil_SUPPLEMENT}', "");
    Expect(1, 73728, '\P{ Is_Tamil_SUPPLEMENT}', "");
    Expect(0, 73728, '\P{^ Is_Tamil_SUPPLEMENT}', "");
    Error('\p{	 In_Tamil_SUPPLEMENT/a/}');
    Error('\P{	 In_Tamil_SUPPLEMENT/a/}');
    Expect(1, 73727, '\p{intamilsupplement}', "");
    Expect(0, 73727, '\p{^intamilsupplement}', "");
    Expect(0, 73727, '\P{intamilsupplement}', "");
    Expect(1, 73727, '\P{^intamilsupplement}', "");
    Expect(0, 73728, '\p{intamilsupplement}', "");
    Expect(1, 73728, '\p{^intamilsupplement}', "");
    Expect(1, 73728, '\P{intamilsupplement}', "");
    Expect(0, 73728, '\P{^intamilsupplement}', "");
    Expect(1, 73727, '\p{ _IN_Tamil_Supplement}', "");
    Expect(0, 73727, '\p{^ _IN_Tamil_Supplement}', "");
    Expect(0, 73727, '\P{ _IN_Tamil_Supplement}', "");
    Expect(1, 73727, '\P{^ _IN_Tamil_Supplement}', "");
    Expect(0, 73728, '\p{ _IN_Tamil_Supplement}', "");
    Expect(1, 73728, '\p{^ _IN_Tamil_Supplement}', "");
    Expect(1, 73728, '\P{ _IN_Tamil_Supplement}', "");
    Expect(0, 73728, '\P{^ _IN_Tamil_Supplement}', "");
    Error('\p{_-tamil_SUP/a/}');
    Error('\P{_-tamil_SUP/a/}');
    Expect(1, 73727, '\p{tamilsup}', "");
    Expect(0, 73727, '\p{^tamilsup}', "");
    Expect(0, 73727, '\P{tamilsup}', "");
    Expect(1, 73727, '\P{^tamilsup}', "");
    Expect(0, 73728, '\p{tamilsup}', "");
    Expect(1, 73728, '\p{^tamilsup}', "");
    Expect(1, 73728, '\P{tamilsup}', "");
    Expect(0, 73728, '\P{^tamilsup}', "");
    Expect(1, 73727, '\p{	_tamil_Sup}', "");
    Expect(0, 73727, '\p{^	_tamil_Sup}', "");
    Expect(0, 73727, '\P{	_tamil_Sup}', "");
    Expect(1, 73727, '\P{^	_tamil_Sup}', "");
    Expect(0, 73728, '\p{	_tamil_Sup}', "");
    Expect(1, 73728, '\p{^	_tamil_Sup}', "");
    Expect(1, 73728, '\P{	_tamil_Sup}', "");
    Expect(0, 73728, '\P{^	_tamil_Sup}', "");
    Error('\p{/a/	_Is_Tamil_Sup}');
    Error('\P{/a/	_Is_Tamil_Sup}');
    Expect(1, 73727, '\p{istamilsup}', "");
    Expect(0, 73727, '\p{^istamilsup}', "");
    Expect(0, 73727, '\P{istamilsup}', "");
    Expect(1, 73727, '\P{^istamilsup}', "");
    Expect(0, 73728, '\p{istamilsup}', "");
    Expect(1, 73728, '\p{^istamilsup}', "");
    Expect(1, 73728, '\P{istamilsup}', "");
    Expect(0, 73728, '\P{^istamilsup}', "");
    Expect(1, 73727, '\p{__IS_TAMIL_Sup}', "");
    Expect(0, 73727, '\p{^__IS_TAMIL_Sup}', "");
    Expect(0, 73727, '\P{__IS_TAMIL_Sup}', "");
    Expect(1, 73727, '\P{^__IS_TAMIL_Sup}', "");
    Expect(0, 73728, '\p{__IS_TAMIL_Sup}', "");
    Expect(1, 73728, '\p{^__IS_TAMIL_Sup}', "");
    Expect(1, 73728, '\P{__IS_TAMIL_Sup}', "");
    Expect(0, 73728, '\P{^__IS_TAMIL_Sup}', "");
    Error('\p{- IN_tamil_Sup/a/}');
    Error('\P{- IN_tamil_Sup/a/}');
    Expect(1, 73727, '\p{intamilsup}', "");
    Expect(0, 73727, '\p{^intamilsup}', "");
    Expect(0, 73727, '\P{intamilsup}', "");
    Expect(1, 73727, '\P{^intamilsup}', "");
    Expect(0, 73728, '\p{intamilsup}', "");
    Expect(1, 73728, '\p{^intamilsup}', "");
    Expect(1, 73728, '\P{intamilsup}', "");
    Expect(0, 73728, '\P{^intamilsup}', "");
    Expect(1, 73727, '\p{	In_Tamil_SUP}', "");
    Expect(0, 73727, '\p{^	In_Tamil_SUP}', "");
    Expect(0, 73727, '\P{	In_Tamil_SUP}', "");
    Expect(1, 73727, '\P{^	In_Tamil_SUP}', "");
    Expect(0, 73728, '\p{	In_Tamil_SUP}', "");
    Expect(1, 73728, '\p{^	In_Tamil_SUP}', "");
    Expect(1, 73728, '\P{	In_Tamil_SUP}', "");
    Expect(0, 73728, '\P{^	In_Tamil_SUP}', "");
    Error('\p{_/a/tangut}');
    Error('\P{_/a/tangut}');
    Expect(1, 101640, '\p{tangut}', "");
    Expect(0, 101640, '\p{^tangut}', "");
    Expect(0, 101640, '\P{tangut}', "");
    Expect(1, 101640, '\P{^tangut}', "");
    Expect(0, 101641, '\p{tangut}', "");
    Expect(1, 101641, '\p{^tangut}', "");
    Expect(1, 101641, '\P{tangut}', "");
    Expect(0, 101641, '\P{^tangut}', "");
    Expect(1, 101640, '\p{_-Tangut}', "");
    Expect(0, 101640, '\p{^_-Tangut}', "");
    Expect(0, 101640, '\P{_-Tangut}', "");
    Expect(1, 101640, '\P{^_-Tangut}', "");
    Expect(0, 101641, '\p{_-Tangut}', "");
    Expect(1, 101641, '\p{^_-Tangut}', "");
    Expect(1, 101641, '\P{_-Tangut}', "");
    Expect(0, 101641, '\P{^_-Tangut}', "");
    Error('\p{:= Is_Tangut}');
    Error('\P{:= Is_Tangut}');
    Expect(1, 101640, '\p{istangut}', "");
    Expect(0, 101640, '\p{^istangut}', "");
    Expect(0, 101640, '\P{istangut}', "");
    Expect(1, 101640, '\P{^istangut}', "");
    Expect(0, 101641, '\p{istangut}', "");
    Expect(1, 101641, '\p{^istangut}', "");
    Expect(1, 101641, '\P{istangut}', "");
    Expect(0, 101641, '\P{^istangut}', "");
    Expect(1, 101640, '\p{-_Is_Tangut}', "");
    Expect(0, 101640, '\p{^-_Is_Tangut}', "");
    Expect(0, 101640, '\P{-_Is_Tangut}', "");
    Expect(1, 101640, '\P{^-_Is_Tangut}', "");
    Expect(0, 101641, '\p{-_Is_Tangut}', "");
    Expect(1, 101641, '\p{^-_Is_Tangut}', "");
    Expect(1, 101641, '\P{-_Is_Tangut}', "");
    Expect(0, 101641, '\P{^-_Is_Tangut}', "");
    Error('\p{:=-	TANG}');
    Error('\P{:=-	TANG}');
    Expect(1, 101640, '\p{tang}', "");
    Expect(0, 101640, '\p{^tang}', "");
    Expect(0, 101640, '\P{tang}', "");
    Expect(1, 101640, '\P{^tang}', "");
    Expect(0, 101641, '\p{tang}', "");
    Expect(1, 101641, '\p{^tang}', "");
    Expect(1, 101641, '\P{tang}', "");
    Expect(0, 101641, '\P{^tang}', "");
    Expect(1, 101640, '\p{	Tang}', "");
    Expect(0, 101640, '\p{^	Tang}', "");
    Expect(0, 101640, '\P{	Tang}', "");
    Expect(1, 101640, '\P{^	Tang}', "");
    Expect(0, 101641, '\p{	Tang}', "");
    Expect(1, 101641, '\p{^	Tang}', "");
    Expect(1, 101641, '\P{	Tang}', "");
    Expect(0, 101641, '\P{^	Tang}', "");
    Error('\p{:=	Is_tang}');
    Error('\P{:=	Is_tang}');
    Expect(1, 101640, '\p{istang}', "");
    Expect(0, 101640, '\p{^istang}', "");
    Expect(0, 101640, '\P{istang}', "");
    Expect(1, 101640, '\P{^istang}', "");
    Expect(0, 101641, '\p{istang}', "");
    Expect(1, 101641, '\p{^istang}', "");
    Expect(1, 101641, '\P{istang}', "");
    Expect(0, 101641, '\P{^istang}', "");
    Expect(1, 101640, '\p{-IS_Tang}', "");
    Expect(0, 101640, '\p{^-IS_Tang}', "");
    Expect(0, 101640, '\P{-IS_Tang}', "");
    Expect(1, 101640, '\P{^-IS_Tang}', "");
    Expect(0, 101641, '\p{-IS_Tang}', "");
    Expect(1, 101641, '\p{^-IS_Tang}', "");
    Expect(1, 101641, '\P{-IS_Tang}', "");
    Expect(0, 101641, '\P{^-IS_Tang}', "");
    Error('\p{ :=TANGUT_components}');
    Error('\P{ :=TANGUT_components}');
    Expect(1, 101119, '\p{tangutcomponents}', "");
    Expect(0, 101119, '\p{^tangutcomponents}', "");
    Expect(0, 101119, '\P{tangutcomponents}', "");
    Expect(1, 101119, '\P{^tangutcomponents}', "");
    Expect(0, 101120, '\p{tangutcomponents}', "");
    Expect(1, 101120, '\p{^tangutcomponents}', "");
    Expect(1, 101120, '\P{tangutcomponents}', "");
    Expect(0, 101120, '\P{^tangutcomponents}', "");
    Expect(1, 101119, '\p{	TANGUT_COMPONENTS}', "");
    Expect(0, 101119, '\p{^	TANGUT_COMPONENTS}', "");
    Expect(0, 101119, '\P{	TANGUT_COMPONENTS}', "");
    Expect(1, 101119, '\P{^	TANGUT_COMPONENTS}', "");
    Expect(0, 101120, '\p{	TANGUT_COMPONENTS}', "");
    Expect(1, 101120, '\p{^	TANGUT_COMPONENTS}', "");
    Expect(1, 101120, '\P{	TANGUT_COMPONENTS}', "");
    Expect(0, 101120, '\P{^	TANGUT_COMPONENTS}', "");
    Error('\p{/a/  IS_tangut_components}');
    Error('\P{/a/  IS_tangut_components}');
    Expect(1, 101119, '\p{istangutcomponents}', "");
    Expect(0, 101119, '\p{^istangutcomponents}', "");
    Expect(0, 101119, '\P{istangutcomponents}', "");
    Expect(1, 101119, '\P{^istangutcomponents}', "");
    Expect(0, 101120, '\p{istangutcomponents}', "");
    Expect(1, 101120, '\p{^istangutcomponents}', "");
    Expect(1, 101120, '\P{istangutcomponents}', "");
    Expect(0, 101120, '\P{^istangutcomponents}', "");
    Expect(1, 101119, '\p{__Is_TANGUT_Components}', "");
    Expect(0, 101119, '\p{^__Is_TANGUT_Components}', "");
    Expect(0, 101119, '\P{__Is_TANGUT_Components}', "");
    Expect(1, 101119, '\P{^__Is_TANGUT_Components}', "");
    Expect(0, 101120, '\p{__Is_TANGUT_Components}', "");
    Expect(1, 101120, '\p{^__Is_TANGUT_Components}', "");
    Expect(1, 101120, '\P{__Is_TANGUT_Components}', "");
    Expect(0, 101120, '\P{^__Is_TANGUT_Components}', "");
    Error('\p{-:=In_Tangut_COMPONENTS}');
    Error('\P{-:=In_Tangut_COMPONENTS}');
    Expect(1, 101119, '\p{intangutcomponents}', "");
    Expect(0, 101119, '\p{^intangutcomponents}', "");
    Expect(0, 101119, '\P{intangutcomponents}', "");
    Expect(1, 101119, '\P{^intangutcomponents}', "");
    Expect(0, 101120, '\p{intangutcomponents}', "");
    Expect(1, 101120, '\p{^intangutcomponents}', "");
    Expect(1, 101120, '\P{intangutcomponents}', "");
    Expect(0, 101120, '\P{^intangutcomponents}', "");
    Expect(1, 101119, '\p{_	In_TANGUT_COMPONENTS}', "");
    Expect(0, 101119, '\p{^_	In_TANGUT_COMPONENTS}', "");
    Expect(0, 101119, '\P{_	In_TANGUT_COMPONENTS}', "");
    Expect(1, 101119, '\P{^_	In_TANGUT_COMPONENTS}', "");
    Expect(0, 101120, '\p{_	In_TANGUT_COMPONENTS}', "");
    Expect(1, 101120, '\p{^_	In_TANGUT_COMPONENTS}', "");
    Expect(1, 101120, '\P{_	In_TANGUT_COMPONENTS}', "");
    Expect(0, 101120, '\P{^_	In_TANGUT_COMPONENTS}', "");
    Error('\p{_Tangut_supplement/a/}');
    Error('\P{_Tangut_supplement/a/}');
    Expect(1, 101775, '\p{tangutsupplement}', "");
    Expect(0, 101775, '\p{^tangutsupplement}', "");
    Expect(0, 101775, '\P{tangutsupplement}', "");
    Expect(1, 101775, '\P{^tangutsupplement}', "");
    Expect(0, 101776, '\p{tangutsupplement}', "");
    Expect(1, 101776, '\p{^tangutsupplement}', "");
    Expect(1, 101776, '\P{tangutsupplement}', "");
    Expect(0, 101776, '\P{^tangutsupplement}', "");
    Expect(1, 101775, '\p{	TANGUT_SUPPLEMENT}', "");
    Expect(0, 101775, '\p{^	TANGUT_SUPPLEMENT}', "");
    Expect(0, 101775, '\P{	TANGUT_SUPPLEMENT}', "");
    Expect(1, 101775, '\P{^	TANGUT_SUPPLEMENT}', "");
    Expect(0, 101776, '\p{	TANGUT_SUPPLEMENT}', "");
    Expect(1, 101776, '\p{^	TANGUT_SUPPLEMENT}', "");
    Expect(1, 101776, '\P{	TANGUT_SUPPLEMENT}', "");
    Expect(0, 101776, '\P{^	TANGUT_SUPPLEMENT}', "");
    Error('\p{_ Is_TANGUT_Supplement:=}');
    Error('\P{_ Is_TANGUT_Supplement:=}');
    Expect(1, 101775, '\p{istangutsupplement}', "");
    Expect(0, 101775, '\p{^istangutsupplement}', "");
    Expect(0, 101775, '\P{istangutsupplement}', "");
    Expect(1, 101775, '\P{^istangutsupplement}', "");
    Expect(0, 101776, '\p{istangutsupplement}', "");
    Expect(1, 101776, '\p{^istangutsupplement}', "");
    Expect(1, 101776, '\P{istangutsupplement}', "");
    Expect(0, 101776, '\P{^istangutsupplement}', "");
    Expect(1, 101775, '\p{		is_TANGUT_Supplement}', "");
    Expect(0, 101775, '\p{^		is_TANGUT_Supplement}', "");
    Expect(0, 101775, '\P{		is_TANGUT_Supplement}', "");
    Expect(1, 101775, '\P{^		is_TANGUT_Supplement}', "");
    Expect(0, 101776, '\p{		is_TANGUT_Supplement}', "");
    Expect(1, 101776, '\p{^		is_TANGUT_Supplement}', "");
    Expect(1, 101776, '\P{		is_TANGUT_Supplement}', "");
    Expect(0, 101776, '\P{^		is_TANGUT_Supplement}', "");
    Error('\p{:=_in_Tangut_Supplement}');
    Error('\P{:=_in_Tangut_Supplement}');
    Expect(1, 101775, '\p{intangutsupplement}', "");
    Expect(0, 101775, '\p{^intangutsupplement}', "");
    Expect(0, 101775, '\P{intangutsupplement}', "");
    Expect(1, 101775, '\P{^intangutsupplement}', "");
    Expect(0, 101776, '\p{intangutsupplement}', "");
    Expect(1, 101776, '\p{^intangutsupplement}', "");
    Expect(1, 101776, '\P{intangutsupplement}', "");
    Expect(0, 101776, '\P{^intangutsupplement}', "");
    Expect(1, 101775, '\p{_in_tangut_Supplement}', "");
    Expect(0, 101775, '\p{^_in_tangut_Supplement}', "");
    Expect(0, 101775, '\P{_in_tangut_Supplement}', "");
    Expect(1, 101775, '\P{^_in_tangut_Supplement}', "");
    Expect(0, 101776, '\p{_in_tangut_Supplement}', "");
    Expect(1, 101776, '\p{^_in_tangut_Supplement}', "");
    Expect(1, 101776, '\P{_in_tangut_Supplement}', "");
    Expect(0, 101776, '\P{^_in_tangut_Supplement}', "");
    Error('\p{_:=Tangut_sup}');
    Error('\P{_:=Tangut_sup}');
    Expect(1, 101775, '\p{tangutsup}', "");
    Expect(0, 101775, '\p{^tangutsup}', "");
    Expect(0, 101775, '\P{tangutsup}', "");
    Expect(1, 101775, '\P{^tangutsup}', "");
    Expect(0, 101776, '\p{tangutsup}', "");
    Expect(1, 101776, '\p{^tangutsup}', "");
    Expect(1, 101776, '\P{tangutsup}', "");
    Expect(0, 101776, '\P{^tangutsup}', "");
    Expect(1, 101775, '\p{_ tangut_sup}', "");
    Expect(0, 101775, '\p{^_ tangut_sup}', "");
    Expect(0, 101775, '\P{_ tangut_sup}', "");
    Expect(1, 101775, '\P{^_ tangut_sup}', "");
    Expect(0, 101776, '\p{_ tangut_sup}', "");
    Expect(1, 101776, '\p{^_ tangut_sup}', "");
    Expect(1, 101776, '\P{_ tangut_sup}', "");
    Expect(0, 101776, '\P{^_ tangut_sup}', "");
    Error('\p{/a/ 	is_tangut_sup}');
    Error('\P{/a/ 	is_tangut_sup}');
    Expect(1, 101775, '\p{istangutsup}', "");
    Expect(0, 101775, '\p{^istangutsup}', "");
    Expect(0, 101775, '\P{istangutsup}', "");
    Expect(1, 101775, '\P{^istangutsup}', "");
    Expect(0, 101776, '\p{istangutsup}', "");
    Expect(1, 101776, '\p{^istangutsup}', "");
    Expect(1, 101776, '\P{istangutsup}', "");
    Expect(0, 101776, '\P{^istangutsup}', "");
    Expect(1, 101775, '\p{is_Tangut_Sup}', "");
    Expect(0, 101775, '\p{^is_Tangut_Sup}', "");
    Expect(0, 101775, '\P{is_Tangut_Sup}', "");
    Expect(1, 101775, '\P{^is_Tangut_Sup}', "");
    Expect(0, 101776, '\p{is_Tangut_Sup}', "");
    Expect(1, 101776, '\p{^is_Tangut_Sup}', "");
    Expect(1, 101776, '\P{is_Tangut_Sup}', "");
    Expect(0, 101776, '\P{^is_Tangut_Sup}', "");
    Error('\p{-/a/IN_Tangut_SUP}');
    Error('\P{-/a/IN_Tangut_SUP}');
    Expect(1, 101775, '\p{intangutsup}', "");
    Expect(0, 101775, '\p{^intangutsup}', "");
    Expect(0, 101775, '\P{intangutsup}', "");
    Expect(1, 101775, '\P{^intangutsup}', "");
    Expect(0, 101776, '\p{intangutsup}', "");
    Expect(1, 101776, '\p{^intangutsup}', "");
    Expect(1, 101776, '\P{intangutsup}', "");
    Expect(0, 101776, '\P{^intangutsup}', "");
    Expect(1, 101775, '\p{-In_TANGUT_sup}', "");
    Expect(0, 101775, '\p{^-In_TANGUT_sup}', "");
    Expect(0, 101775, '\P{-In_TANGUT_sup}', "");
    Expect(1, 101775, '\P{^-In_TANGUT_sup}', "");
    Expect(0, 101776, '\p{-In_TANGUT_sup}', "");
    Expect(1, 101776, '\p{^-In_TANGUT_sup}', "");
    Expect(1, 101776, '\P{-In_TANGUT_sup}', "");
    Expect(0, 101776, '\P{^-In_TANGUT_sup}', "");
    Error('\p{/a/-Telugu}');
    Error('\P{/a/-Telugu}');
    Expect(1, 7410, '\p{telugu}', "");
    Expect(0, 7410, '\p{^telugu}', "");
    Expect(0, 7410, '\P{telugu}', "");
    Expect(1, 7410, '\P{^telugu}', "");
    Expect(0, 7411, '\p{telugu}', "");
    Expect(1, 7411, '\p{^telugu}', "");
    Expect(1, 7411, '\P{telugu}', "");
    Expect(0, 7411, '\P{^telugu}', "");
    Expect(1, 7410, '\p{_	TELUGU}', "");
    Expect(0, 7410, '\p{^_	TELUGU}', "");
    Expect(0, 7410, '\P{_	TELUGU}', "");
    Expect(1, 7410, '\P{^_	TELUGU}', "");
    Expect(0, 7411, '\p{_	TELUGU}', "");
    Expect(1, 7411, '\p{^_	TELUGU}', "");
    Expect(1, 7411, '\P{_	TELUGU}', "");
    Expect(0, 7411, '\P{^_	TELUGU}', "");
    Error('\p{	/a/Is_Telugu}');
    Error('\P{	/a/Is_Telugu}');
    Expect(1, 7410, '\p{istelugu}', "");
    Expect(0, 7410, '\p{^istelugu}', "");
    Expect(0, 7410, '\P{istelugu}', "");
    Expect(1, 7410, '\P{^istelugu}', "");
    Expect(0, 7411, '\p{istelugu}', "");
    Expect(1, 7411, '\p{^istelugu}', "");
    Expect(1, 7411, '\P{istelugu}', "");
    Expect(0, 7411, '\P{^istelugu}', "");
    Expect(1, 7410, '\p{ -Is_Telugu}', "");
    Expect(0, 7410, '\p{^ -Is_Telugu}', "");
    Expect(0, 7410, '\P{ -Is_Telugu}', "");
    Expect(1, 7410, '\P{^ -Is_Telugu}', "");
    Expect(0, 7411, '\p{ -Is_Telugu}', "");
    Expect(1, 7411, '\p{^ -Is_Telugu}', "");
    Expect(1, 7411, '\P{ -Is_Telugu}', "");
    Expect(0, 7411, '\P{^ -Is_Telugu}', "");
    Error('\p{	/a/telu}');
    Error('\P{	/a/telu}');
    Expect(1, 7410, '\p{telu}', "");
    Expect(0, 7410, '\p{^telu}', "");
    Expect(0, 7410, '\P{telu}', "");
    Expect(1, 7410, '\P{^telu}', "");
    Expect(0, 7411, '\p{telu}', "");
    Expect(1, 7411, '\p{^telu}', "");
    Expect(1, 7411, '\P{telu}', "");
    Expect(0, 7411, '\P{^telu}', "");
    Expect(1, 7410, '\p{	_telu}', "");
    Expect(0, 7410, '\p{^	_telu}', "");
    Expect(0, 7410, '\P{	_telu}', "");
    Expect(1, 7410, '\P{^	_telu}', "");
    Expect(0, 7411, '\p{	_telu}', "");
    Expect(1, 7411, '\p{^	_telu}', "");
    Expect(1, 7411, '\P{	_telu}', "");
    Expect(0, 7411, '\P{^	_telu}', "");
    Error('\p{--IS_telu:=}');
    Error('\P{--IS_telu:=}');
    Expect(1, 7410, '\p{istelu}', "");
    Expect(0, 7410, '\p{^istelu}', "");
    Expect(0, 7410, '\P{istelu}', "");
    Expect(1, 7410, '\P{^istelu}', "");
    Expect(0, 7411, '\p{istelu}', "");
    Expect(1, 7411, '\p{^istelu}', "");
    Expect(1, 7411, '\P{istelu}', "");
    Expect(0, 7411, '\P{^istelu}', "");
    Expect(1, 7410, '\p{Is_TELU}', "");
    Expect(0, 7410, '\p{^Is_TELU}', "");
    Expect(0, 7410, '\P{Is_TELU}', "");
    Expect(1, 7410, '\P{^Is_TELU}', "");
    Expect(0, 7411, '\p{Is_TELU}', "");
    Expect(1, 7411, '\p{^Is_TELU}', "");
    Expect(1, 7411, '\P{Is_TELU}', "");
    Expect(0, 7411, '\P{^Is_TELU}', "");
    Error('\p{/a/-terminal_Punctuation}');
    Error('\P{/a/-terminal_Punctuation}');
    Expect(1, 121482, '\p{terminalpunctuation}', "");
    Expect(0, 121482, '\p{^terminalpunctuation}', "");
    Expect(0, 121482, '\P{terminalpunctuation}', "");
    Expect(1, 121482, '\P{^terminalpunctuation}', "");
    Expect(0, 121483, '\p{terminalpunctuation}', "");
    Expect(1, 121483, '\p{^terminalpunctuation}', "");
    Expect(1, 121483, '\P{terminalpunctuation}', "");
    Expect(0, 121483, '\P{^terminalpunctuation}', "");
    Expect(1, 121482, '\p{		Terminal_punctuation}', "");
    Expect(0, 121482, '\p{^		Terminal_punctuation}', "");
    Expect(0, 121482, '\P{		Terminal_punctuation}', "");
    Expect(1, 121482, '\P{^		Terminal_punctuation}', "");
    Expect(0, 121483, '\p{		Terminal_punctuation}', "");
    Expect(1, 121483, '\p{^		Terminal_punctuation}', "");
    Expect(1, 121483, '\P{		Terminal_punctuation}', "");
    Expect(0, 121483, '\P{^		Terminal_punctuation}', "");
    Error('\p{	/a/is_Terminal_PUNCTUATION}');
    Error('\P{	/a/is_Terminal_PUNCTUATION}');
    Expect(1, 121482, '\p{isterminalpunctuation}', "");
    Expect(0, 121482, '\p{^isterminalpunctuation}', "");
    Expect(0, 121482, '\P{isterminalpunctuation}', "");
    Expect(1, 121482, '\P{^isterminalpunctuation}', "");
    Expect(0, 121483, '\p{isterminalpunctuation}', "");
    Expect(1, 121483, '\p{^isterminalpunctuation}', "");
    Expect(1, 121483, '\P{isterminalpunctuation}', "");
    Expect(0, 121483, '\P{^isterminalpunctuation}', "");
    Expect(1, 121482, '\p{	_Is_Terminal_PUNCTUATION}', "");
    Expect(0, 121482, '\p{^	_Is_Terminal_PUNCTUATION}', "");
    Expect(0, 121482, '\P{	_Is_Terminal_PUNCTUATION}', "");
    Expect(1, 121482, '\P{^	_Is_Terminal_PUNCTUATION}', "");
    Expect(0, 121483, '\p{	_Is_Terminal_PUNCTUATION}', "");
    Expect(1, 121483, '\p{^	_Is_Terminal_PUNCTUATION}', "");
    Expect(1, 121483, '\P{	_Is_Terminal_PUNCTUATION}', "");
    Expect(0, 121483, '\P{^	_Is_Terminal_PUNCTUATION}', "");
    Error('\p{_/a/Term}');
    Error('\P{_/a/Term}');
    Expect(1, 121482, '\p{term}', "");
    Expect(0, 121482, '\p{^term}', "");
    Expect(0, 121482, '\P{term}', "");
    Expect(1, 121482, '\P{^term}', "");
    Expect(0, 121483, '\p{term}', "");
    Expect(1, 121483, '\p{^term}', "");
    Expect(1, 121483, '\P{term}', "");
    Expect(0, 121483, '\P{^term}', "");
    Expect(1, 121482, '\p{	-TERM}', "");
    Expect(0, 121482, '\p{^	-TERM}', "");
    Expect(0, 121482, '\P{	-TERM}', "");
    Expect(1, 121482, '\P{^	-TERM}', "");
    Expect(0, 121483, '\p{	-TERM}', "");
    Expect(1, 121483, '\p{^	-TERM}', "");
    Expect(1, 121483, '\P{	-TERM}', "");
    Expect(0, 121483, '\P{^	-TERM}', "");
    Error('\p{-IS_Term:=}');
    Error('\P{-IS_Term:=}');
    Expect(1, 121482, '\p{isterm}', "");
    Expect(0, 121482, '\p{^isterm}', "");
    Expect(0, 121482, '\P{isterm}', "");
    Expect(1, 121482, '\P{^isterm}', "");
    Expect(0, 121483, '\p{isterm}', "");
    Expect(1, 121483, '\p{^isterm}', "");
    Expect(1, 121483, '\P{isterm}', "");
    Expect(0, 121483, '\P{^isterm}', "");
    Expect(1, 121482, '\p{is_term}', "");
    Expect(0, 121482, '\p{^is_term}', "");
    Expect(0, 121482, '\P{is_term}', "");
    Expect(1, 121482, '\P{^is_term}', "");
    Expect(0, 121483, '\p{is_term}', "");
    Expect(1, 121483, '\p{^is_term}', "");
    Expect(1, 121483, '\P{is_term}', "");
    Expect(0, 121483, '\P{^is_term}', "");
    Error('\p{ -THAANA/a/}');
    Error('\P{ -THAANA/a/}');
    Expect(1, 65021, '\p{thaana}', "");
    Expect(0, 65021, '\p{^thaana}', "");
    Expect(0, 65021, '\P{thaana}', "");
    Expect(1, 65021, '\P{^thaana}', "");
    Expect(0, 65022, '\p{thaana}', "");
    Expect(1, 65022, '\p{^thaana}', "");
    Expect(1, 65022, '\P{thaana}', "");
    Expect(0, 65022, '\P{^thaana}', "");
    Expect(1, 65021, '\p{__thaana}', "");
    Expect(0, 65021, '\p{^__thaana}', "");
    Expect(0, 65021, '\P{__thaana}', "");
    Expect(1, 65021, '\P{^__thaana}', "");
    Expect(0, 65022, '\p{__thaana}', "");
    Expect(1, 65022, '\p{^__thaana}', "");
    Expect(1, 65022, '\P{__thaana}', "");
    Expect(0, 65022, '\P{^__thaana}', "");
    Error('\p{/a/	is_Thaana}');
    Error('\P{/a/	is_Thaana}');
    Expect(1, 65021, '\p{isthaana}', "");
    Expect(0, 65021, '\p{^isthaana}', "");
    Expect(0, 65021, '\P{isthaana}', "");
    Expect(1, 65021, '\P{^isthaana}', "");
    Expect(0, 65022, '\p{isthaana}', "");
    Expect(1, 65022, '\p{^isthaana}', "");
    Expect(1, 65022, '\P{isthaana}', "");
    Expect(0, 65022, '\P{^isthaana}', "");
    Expect(1, 65021, '\p{		is_thaana}', "");
    Expect(0, 65021, '\p{^		is_thaana}', "");
    Expect(0, 65021, '\P{		is_thaana}', "");
    Expect(1, 65021, '\P{^		is_thaana}', "");
    Expect(0, 65022, '\p{		is_thaana}', "");
    Expect(1, 65022, '\p{^		is_thaana}', "");
    Expect(1, 65022, '\P{		is_thaana}', "");
    Expect(0, 65022, '\P{^		is_thaana}', "");
    Error('\p{:=_Thaa}');
    Error('\P{:=_Thaa}');
    Expect(1, 65021, '\p{thaa}', "");
    Expect(0, 65021, '\p{^thaa}', "");
    Expect(0, 65021, '\P{thaa}', "");
    Expect(1, 65021, '\P{^thaa}', "");
    Expect(0, 65022, '\p{thaa}', "");
    Expect(1, 65022, '\p{^thaa}', "");
    Expect(1, 65022, '\P{thaa}', "");
    Expect(0, 65022, '\P{^thaa}', "");
    Expect(1, 65021, '\p{		THAA}', "");
    Expect(0, 65021, '\p{^		THAA}', "");
    Expect(0, 65021, '\P{		THAA}', "");
    Expect(1, 65021, '\P{^		THAA}', "");
    Expect(0, 65022, '\p{		THAA}', "");
    Expect(1, 65022, '\p{^		THAA}', "");
    Expect(1, 65022, '\P{		THAA}', "");
    Expect(0, 65022, '\P{^		THAA}', "");
    Error('\p{/a/		Is_THAA}');
    Error('\P{/a/		Is_THAA}');
    Expect(1, 65021, '\p{isthaa}', "");
    Expect(0, 65021, '\p{^isthaa}', "");
    Expect(0, 65021, '\P{isthaa}', "");
    Expect(1, 65021, '\P{^isthaa}', "");
    Expect(0, 65022, '\p{isthaa}', "");
    Expect(1, 65022, '\p{^isthaa}', "");
    Expect(1, 65022, '\P{isthaa}', "");
    Expect(0, 65022, '\P{^isthaa}', "");
    Expect(1, 65021, '\p{_	Is_thaa}', "");
    Expect(0, 65021, '\p{^_	Is_thaa}', "");
    Expect(0, 65021, '\P{_	Is_thaa}', "");
    Expect(1, 65021, '\P{^_	Is_thaa}', "");
    Expect(0, 65022, '\p{_	Is_thaa}', "");
    Expect(1, 65022, '\p{^_	Is_thaa}', "");
    Expect(1, 65022, '\P{_	Is_thaa}', "");
    Expect(0, 65022, '\P{^_	Is_thaa}', "");
    Error('\p{-THAI/a/}');
    Error('\P{-THAI/a/}');
    Expect(1, 3675, '\p{thai}', "");
    Expect(0, 3675, '\p{^thai}', "");
    Expect(0, 3675, '\P{thai}', "");
    Expect(1, 3675, '\P{^thai}', "");
    Expect(0, 3676, '\p{thai}', "");
    Expect(1, 3676, '\p{^thai}', "");
    Expect(1, 3676, '\P{thai}', "");
    Expect(0, 3676, '\P{^thai}', "");
    Expect(1, 3675, '\p{Thai}', "");
    Expect(0, 3675, '\p{^Thai}', "");
    Expect(0, 3675, '\P{Thai}', "");
    Expect(1, 3675, '\P{^Thai}', "");
    Expect(0, 3676, '\p{Thai}', "");
    Expect(1, 3676, '\p{^Thai}', "");
    Expect(1, 3676, '\P{Thai}', "");
    Expect(0, 3676, '\P{^Thai}', "");
    Error('\p{:= is_Thai}');
    Error('\P{:= is_Thai}');
    Expect(1, 3675, '\p{isthai}', "");
    Expect(0, 3675, '\p{^isthai}', "");
    Expect(0, 3675, '\P{isthai}', "");
    Expect(1, 3675, '\P{^isthai}', "");
    Expect(0, 3676, '\p{isthai}', "");
    Expect(1, 3676, '\p{^isthai}', "");
    Expect(1, 3676, '\P{isthai}', "");
    Expect(0, 3676, '\P{^isthai}', "");
    Expect(1, 3675, '\p{_ Is_thai}', "");
    Expect(0, 3675, '\p{^_ Is_thai}', "");
    Expect(0, 3675, '\P{_ Is_thai}', "");
    Expect(1, 3675, '\P{^_ Is_thai}', "");
    Expect(0, 3676, '\p{_ Is_thai}', "");
    Expect(1, 3676, '\p{^_ Is_thai}', "");
    Expect(1, 3676, '\P{_ Is_thai}', "");
    Expect(0, 3676, '\P{^_ Is_thai}', "");
    Error('\p{:=-Tibetan}');
    Error('\P{:=-Tibetan}');
    Expect(1, 4058, '\p{tibetan}', "");
    Expect(0, 4058, '\p{^tibetan}', "");
    Expect(0, 4058, '\P{tibetan}', "");
    Expect(1, 4058, '\P{^tibetan}', "");
    Expect(0, 4059, '\p{tibetan}', "");
    Expect(1, 4059, '\p{^tibetan}', "");
    Expect(1, 4059, '\P{tibetan}', "");
    Expect(0, 4059, '\P{^tibetan}', "");
    Expect(1, 4058, '\p{-Tibetan}', "");
    Expect(0, 4058, '\p{^-Tibetan}', "");
    Expect(0, 4058, '\P{-Tibetan}', "");
    Expect(1, 4058, '\P{^-Tibetan}', "");
    Expect(0, 4059, '\p{-Tibetan}', "");
    Expect(1, 4059, '\p{^-Tibetan}', "");
    Expect(1, 4059, '\P{-Tibetan}', "");
    Expect(0, 4059, '\P{^-Tibetan}', "");
    Error('\p{_IS_Tibetan/a/}');
    Error('\P{_IS_Tibetan/a/}');
    Expect(1, 4058, '\p{istibetan}', "");
    Expect(0, 4058, '\p{^istibetan}', "");
    Expect(0, 4058, '\P{istibetan}', "");
    Expect(1, 4058, '\P{^istibetan}', "");
    Expect(0, 4059, '\p{istibetan}', "");
    Expect(1, 4059, '\p{^istibetan}', "");
    Expect(1, 4059, '\P{istibetan}', "");
    Expect(0, 4059, '\P{^istibetan}', "");
    Expect(1, 4058, '\p{	is_Tibetan}', "");
    Expect(0, 4058, '\p{^	is_Tibetan}', "");
    Expect(0, 4058, '\P{	is_Tibetan}', "");
    Expect(1, 4058, '\P{^	is_Tibetan}', "");
    Expect(0, 4059, '\p{	is_Tibetan}', "");
    Expect(1, 4059, '\p{^	is_Tibetan}', "");
    Expect(1, 4059, '\P{	is_Tibetan}', "");
    Expect(0, 4059, '\P{^	is_Tibetan}', "");
    Error('\p{ 	Tibt:=}');
    Error('\P{ 	Tibt:=}');
    Expect(1, 4058, '\p{tibt}', "");
    Expect(0, 4058, '\p{^tibt}', "");
    Expect(0, 4058, '\P{tibt}', "");
    Expect(1, 4058, '\P{^tibt}', "");
    Expect(0, 4059, '\p{tibt}', "");
    Expect(1, 4059, '\p{^tibt}', "");
    Expect(1, 4059, '\P{tibt}', "");
    Expect(0, 4059, '\P{^tibt}', "");
    Expect(1, 4058, '\p{-tibt}', "");
    Expect(0, 4058, '\p{^-tibt}', "");
    Expect(0, 4058, '\P{-tibt}', "");
    Expect(1, 4058, '\P{^-tibt}', "");
    Expect(0, 4059, '\p{-tibt}', "");
    Expect(1, 4059, '\p{^-tibt}', "");
    Expect(1, 4059, '\P{-tibt}', "");
    Expect(0, 4059, '\P{^-tibt}', "");
    Error('\p{:=_	IS_tibt}');
    Error('\P{:=_	IS_tibt}');
    Expect(1, 4058, '\p{istibt}', "");
    Expect(0, 4058, '\p{^istibt}', "");
    Expect(0, 4058, '\P{istibt}', "");
    Expect(1, 4058, '\P{^istibt}', "");
    Expect(0, 4059, '\p{istibt}', "");
    Expect(1, 4059, '\p{^istibt}', "");
    Expect(1, 4059, '\P{istibt}', "");
    Expect(0, 4059, '\P{^istibt}', "");
    Expect(1, 4058, '\p{-_IS_tibt}', "");
    Expect(0, 4058, '\p{^-_IS_tibt}', "");
    Expect(0, 4058, '\P{-_IS_tibt}', "");
    Expect(1, 4058, '\P{^-_IS_tibt}', "");
    Expect(0, 4059, '\p{-_IS_tibt}', "");
    Expect(1, 4059, '\p{^-_IS_tibt}', "");
    Expect(1, 4059, '\P{-_IS_tibt}', "");
    Expect(0, 4059, '\P{^-_IS_tibt}', "");
    Error('\p{-/a/TIFINAGH}');
    Error('\P{-/a/TIFINAGH}');
    Expect(1, 11647, '\p{tifinagh}', "");
    Expect(0, 11647, '\p{^tifinagh}', "");
    Expect(0, 11647, '\P{tifinagh}', "");
    Expect(1, 11647, '\P{^tifinagh}', "");
    Expect(0, 11648, '\p{tifinagh}', "");
    Expect(1, 11648, '\p{^tifinagh}', "");
    Expect(1, 11648, '\P{tifinagh}', "");
    Expect(0, 11648, '\P{^tifinagh}', "");
    Expect(1, 11647, '\p{ 	Tifinagh}', "");
    Expect(0, 11647, '\p{^ 	Tifinagh}', "");
    Expect(0, 11647, '\P{ 	Tifinagh}', "");
    Expect(1, 11647, '\P{^ 	Tifinagh}', "");
    Expect(0, 11648, '\p{ 	Tifinagh}', "");
    Expect(1, 11648, '\p{^ 	Tifinagh}', "");
    Expect(1, 11648, '\P{ 	Tifinagh}', "");
    Expect(0, 11648, '\P{^ 	Tifinagh}', "");
    Error('\p{:=Is_Tifinagh}');
    Error('\P{:=Is_Tifinagh}');
    Expect(1, 11647, '\p{istifinagh}', "");
    Expect(0, 11647, '\p{^istifinagh}', "");
    Expect(0, 11647, '\P{istifinagh}', "");
    Expect(1, 11647, '\P{^istifinagh}', "");
    Expect(0, 11648, '\p{istifinagh}', "");
    Expect(1, 11648, '\p{^istifinagh}', "");
    Expect(1, 11648, '\P{istifinagh}', "");
    Expect(0, 11648, '\P{^istifinagh}', "");
    Expect(1, 11647, '\p{_	IS_TIFINAGH}', "");
    Expect(0, 11647, '\p{^_	IS_TIFINAGH}', "");
    Expect(0, 11647, '\P{_	IS_TIFINAGH}', "");
    Expect(1, 11647, '\P{^_	IS_TIFINAGH}', "");
    Expect(0, 11648, '\p{_	IS_TIFINAGH}', "");
    Expect(1, 11648, '\p{^_	IS_TIFINAGH}', "");
    Expect(1, 11648, '\P{_	IS_TIFINAGH}', "");
    Expect(0, 11648, '\P{^_	IS_TIFINAGH}', "");
    Error('\p{_ tfng/a/}');
    Error('\P{_ tfng/a/}');
    Expect(1, 11647, '\p{tfng}', "");
    Expect(0, 11647, '\p{^tfng}', "");
    Expect(0, 11647, '\P{tfng}', "");
    Expect(1, 11647, '\P{^tfng}', "");
    Expect(0, 11648, '\p{tfng}', "");
    Expect(1, 11648, '\p{^tfng}', "");
    Expect(1, 11648, '\P{tfng}', "");
    Expect(0, 11648, '\P{^tfng}', "");
    Expect(1, 11647, '\p{  Tfng}', "");
    Expect(0, 11647, '\p{^  Tfng}', "");
    Expect(0, 11647, '\P{  Tfng}', "");
    Expect(1, 11647, '\P{^  Tfng}', "");
    Expect(0, 11648, '\p{  Tfng}', "");
    Expect(1, 11648, '\p{^  Tfng}', "");
    Expect(1, 11648, '\P{  Tfng}', "");
    Expect(0, 11648, '\P{^  Tfng}', "");
    Error('\p{-/a/is_Tfng}');
    Error('\P{-/a/is_Tfng}');
    Expect(1, 11647, '\p{istfng}', "");
    Expect(0, 11647, '\p{^istfng}', "");
    Expect(0, 11647, '\P{istfng}', "");
    Expect(1, 11647, '\P{^istfng}', "");
    Expect(0, 11648, '\p{istfng}', "");
    Expect(1, 11648, '\p{^istfng}', "");
    Expect(1, 11648, '\P{istfng}', "");
    Expect(0, 11648, '\P{^istfng}', "");
    Expect(1, 11647, '\p{		IS_Tfng}', "");
    Expect(0, 11647, '\p{^		IS_Tfng}', "");
    Expect(0, 11647, '\P{		IS_Tfng}', "");
    Expect(1, 11647, '\P{^		IS_Tfng}', "");
    Expect(0, 11648, '\p{		IS_Tfng}', "");
    Expect(1, 11648, '\p{^		IS_Tfng}', "");
    Expect(1, 11648, '\P{		IS_Tfng}', "");
    Expect(0, 11648, '\P{^		IS_Tfng}', "");
    Error('\p{ :=Tirhuta}');
    Error('\P{ :=Tirhuta}');
    Expect(1, 70873, '\p{tirhuta}', "");
    Expect(0, 70873, '\p{^tirhuta}', "");
    Expect(0, 70873, '\P{tirhuta}', "");
    Expect(1, 70873, '\P{^tirhuta}', "");
    Expect(0, 70874, '\p{tirhuta}', "");
    Expect(1, 70874, '\p{^tirhuta}', "");
    Expect(1, 70874, '\P{tirhuta}', "");
    Expect(0, 70874, '\P{^tirhuta}', "");
    Expect(1, 70873, '\p{		TIRHUTA}', "");
    Expect(0, 70873, '\p{^		TIRHUTA}', "");
    Expect(0, 70873, '\P{		TIRHUTA}', "");
    Expect(1, 70873, '\P{^		TIRHUTA}', "");
    Expect(0, 70874, '\p{		TIRHUTA}', "");
    Expect(1, 70874, '\p{^		TIRHUTA}', "");
    Expect(1, 70874, '\P{		TIRHUTA}', "");
    Expect(0, 70874, '\P{^		TIRHUTA}', "");
    Error('\p{:=--is_tirhuta}');
    Error('\P{:=--is_tirhuta}');
    Expect(1, 70873, '\p{istirhuta}', "");
    Expect(0, 70873, '\p{^istirhuta}', "");
    Expect(0, 70873, '\P{istirhuta}', "");
    Expect(1, 70873, '\P{^istirhuta}', "");
    Expect(0, 70874, '\p{istirhuta}', "");
    Expect(1, 70874, '\p{^istirhuta}', "");
    Expect(1, 70874, '\P{istirhuta}', "");
    Expect(0, 70874, '\P{^istirhuta}', "");
    Expect(1, 70873, '\p{	 IS_Tirhuta}', "");
    Expect(0, 70873, '\p{^	 IS_Tirhuta}', "");
    Expect(0, 70873, '\P{	 IS_Tirhuta}', "");
    Expect(1, 70873, '\P{^	 IS_Tirhuta}', "");
    Expect(0, 70874, '\p{	 IS_Tirhuta}', "");
    Expect(1, 70874, '\p{^	 IS_Tirhuta}', "");
    Expect(1, 70874, '\P{	 IS_Tirhuta}', "");
    Expect(0, 70874, '\P{^	 IS_Tirhuta}', "");
    Error('\p{:= 	TIRH}');
    Error('\P{:= 	TIRH}');
    Expect(1, 70873, '\p{tirh}', "");
    Expect(0, 70873, '\p{^tirh}', "");
    Expect(0, 70873, '\P{tirh}', "");
    Expect(1, 70873, '\P{^tirh}', "");
    Expect(0, 70874, '\p{tirh}', "");
    Expect(1, 70874, '\p{^tirh}', "");
    Expect(1, 70874, '\P{tirh}', "");
    Expect(0, 70874, '\P{^tirh}', "");
    Expect(1, 70873, '\p{  Tirh}', "");
    Expect(0, 70873, '\p{^  Tirh}', "");
    Expect(0, 70873, '\P{  Tirh}', "");
    Expect(1, 70873, '\P{^  Tirh}', "");
    Expect(0, 70874, '\p{  Tirh}', "");
    Expect(1, 70874, '\p{^  Tirh}', "");
    Expect(1, 70874, '\P{  Tirh}', "");
    Expect(0, 70874, '\P{^  Tirh}', "");
    Error('\p{/a/_is_TIRH}');
    Error('\P{/a/_is_TIRH}');
    Expect(1, 70873, '\p{istirh}', "");
    Expect(0, 70873, '\p{^istirh}', "");
    Expect(0, 70873, '\P{istirh}', "");
    Expect(1, 70873, '\P{^istirh}', "");
    Expect(0, 70874, '\p{istirh}', "");
    Expect(1, 70874, '\p{^istirh}', "");
    Expect(1, 70874, '\P{istirh}', "");
    Expect(0, 70874, '\P{^istirh}', "");
    Expect(1, 70873, '\p{  IS_Tirh}', "");
    Expect(0, 70873, '\p{^  IS_Tirh}', "");
    Expect(0, 70873, '\P{  IS_Tirh}', "");
    Expect(1, 70873, '\P{^  IS_Tirh}', "");
    Expect(0, 70874, '\p{  IS_Tirh}', "");
    Expect(1, 70874, '\p{^  IS_Tirh}', "");
    Expect(1, 70874, '\P{  IS_Tirh}', "");
    Expect(0, 70874, '\P{^  IS_Tirh}', "");
    Error('\p{:=_-TITLECASE}');
    Error('\P{:=_-TITLECASE}');
    Expect(1, 8188, '\p{titlecase}', "");
    Expect(0, 8188, '\p{^titlecase}', "");
    Expect(0, 8188, '\P{titlecase}', "");
    Expect(1, 8188, '\P{^titlecase}', "");
    Expect(0, 8189, '\p{titlecase}', "");
    Expect(1, 8189, '\p{^titlecase}', "");
    Expect(1, 8189, '\P{titlecase}', "");
    Expect(0, 8189, '\P{^titlecase}', "");
    Expect(1, 8188, '\p{_-titlecase}', "");
    Expect(0, 8188, '\p{^_-titlecase}', "");
    Expect(0, 8188, '\P{_-titlecase}', "");
    Expect(1, 8188, '\P{^_-titlecase}', "");
    Expect(0, 8189, '\p{_-titlecase}', "");
    Expect(1, 8189, '\p{^_-titlecase}', "");
    Expect(1, 8189, '\P{_-titlecase}', "");
    Expect(0, 8189, '\P{^_-titlecase}', "");
    Error('\p{/a/		Title}');
    Error('\P{/a/		Title}');
    Expect(1, 8188, '\p{title}', "");
    Expect(0, 8188, '\p{^title}', "");
    Expect(0, 8188, '\P{title}', "");
    Expect(1, 8188, '\P{^title}', "");
    Expect(0, 8189, '\p{title}', "");
    Expect(1, 8189, '\p{^title}', "");
    Expect(1, 8189, '\P{title}', "");
    Expect(0, 8189, '\P{^title}', "");
    Expect(1, 8188, '\p{ Title}', "");
    Expect(0, 8188, '\p{^ Title}', "");
    Expect(0, 8188, '\P{ Title}', "");
    Expect(1, 8188, '\P{^ Title}', "");
    Expect(0, 8189, '\p{ Title}', "");
    Expect(1, 8189, '\p{^ Title}', "");
    Expect(1, 8189, '\P{ Title}', "");
    Expect(0, 8189, '\P{^ Title}', "");
    Error('\p{/a/is_Titlecase}');
    Error('\P{/a/is_Titlecase}');
    Expect(1, 8188, '\p{istitlecase}', "");
    Expect(0, 8188, '\p{^istitlecase}', "");
    Expect(0, 8188, '\P{istitlecase}', "");
    Expect(1, 8188, '\P{^istitlecase}', "");
    Expect(0, 8189, '\p{istitlecase}', "");
    Expect(1, 8189, '\p{^istitlecase}', "");
    Expect(1, 8189, '\P{istitlecase}', "");
    Expect(0, 8189, '\P{^istitlecase}', "");
    Expect(1, 8188, '\p{_-IS_titlecase}', "");
    Expect(0, 8188, '\p{^_-IS_titlecase}', "");
    Expect(0, 8188, '\P{_-IS_titlecase}', "");
    Expect(1, 8188, '\P{^_-IS_titlecase}', "");
    Expect(0, 8189, '\p{_-IS_titlecase}', "");
    Expect(1, 8189, '\p{^_-IS_titlecase}', "");
    Expect(1, 8189, '\P{_-IS_titlecase}', "");
    Expect(0, 8189, '\P{^_-IS_titlecase}', "");
    Error('\p{/a/-_IS_title}');
    Error('\P{/a/-_IS_title}');
    Expect(1, 8188, '\p{istitle}', "");
    Expect(0, 8188, '\p{^istitle}', "");
    Expect(0, 8188, '\P{istitle}', "");
    Expect(1, 8188, '\P{^istitle}', "");
    Expect(0, 8189, '\p{istitle}', "");
    Expect(1, 8189, '\p{^istitle}', "");
    Expect(1, 8189, '\P{istitle}', "");
    Expect(0, 8189, '\P{^istitle}', "");
    Expect(1, 8188, '\p{__is_Title}', "");
    Expect(0, 8188, '\p{^__is_Title}', "");
    Expect(0, 8188, '\P{__is_Title}', "");
    Expect(1, 8188, '\P{^__is_Title}', "");
    Expect(0, 8189, '\p{__is_Title}', "");
    Expect(1, 8189, '\p{^__is_Title}', "");
    Expect(1, 8189, '\P{__is_Title}', "");
    Expect(0, 8189, '\P{^__is_Title}', "");
    Error('\p{:=_Titlecase_Letter}');
    Error('\P{:=_Titlecase_Letter}');
    Expect(1, 8188, '\p{titlecaseletter}', "");
    Expect(0, 8188, '\p{^titlecaseletter}', "");
    Expect(0, 8188, '\P{titlecaseletter}', "");
    Expect(1, 8188, '\P{^titlecaseletter}', "");
    Expect(0, 8189, '\p{titlecaseletter}', "");
    Expect(1, 8189, '\p{^titlecaseletter}', "");
    Expect(1, 8189, '\P{titlecaseletter}', "");
    Expect(0, 8189, '\P{^titlecaseletter}', "");
    Expect(1, 8188, '\p{__Titlecase_LETTER}', "");
    Expect(0, 8188, '\p{^__Titlecase_LETTER}', "");
    Expect(0, 8188, '\P{__Titlecase_LETTER}', "");
    Expect(1, 8188, '\P{^__Titlecase_LETTER}', "");
    Expect(0, 8189, '\p{__Titlecase_LETTER}', "");
    Expect(1, 8189, '\p{^__Titlecase_LETTER}', "");
    Expect(1, 8189, '\P{__Titlecase_LETTER}', "");
    Expect(0, 8189, '\P{^__Titlecase_LETTER}', "");
    Error('\p{:=Is_Titlecase_letter}');
    Error('\P{:=Is_Titlecase_letter}');
    Expect(1, 8188, '\p{istitlecaseletter}', "");
    Expect(0, 8188, '\p{^istitlecaseletter}', "");
    Expect(0, 8188, '\P{istitlecaseletter}', "");
    Expect(1, 8188, '\P{^istitlecaseletter}', "");
    Expect(0, 8189, '\p{istitlecaseletter}', "");
    Expect(1, 8189, '\p{^istitlecaseletter}', "");
    Expect(1, 8189, '\P{istitlecaseletter}', "");
    Expect(0, 8189, '\P{^istitlecaseletter}', "");
    Expect(1, 8188, '\p{	 Is_Titlecase_Letter}', "");
    Expect(0, 8188, '\p{^	 Is_Titlecase_Letter}', "");
    Expect(0, 8188, '\P{	 Is_Titlecase_Letter}', "");
    Expect(1, 8188, '\P{^	 Is_Titlecase_Letter}', "");
    Expect(0, 8189, '\p{	 Is_Titlecase_Letter}', "");
    Expect(1, 8189, '\p{^	 Is_Titlecase_Letter}', "");
    Expect(1, 8189, '\P{	 Is_Titlecase_Letter}', "");
    Expect(0, 8189, '\P{^	 Is_Titlecase_Letter}', "");
    Error('\p{-_LT:=}');
    Error('\P{-_LT:=}');
    Expect(1, 8188, '\p{lt}', "");
    Expect(0, 8188, '\p{^lt}', "");
    Expect(0, 8188, '\P{lt}', "");
    Expect(1, 8188, '\P{^lt}', "");
    Expect(0, 8189, '\p{lt}', "");
    Expect(1, 8189, '\p{^lt}', "");
    Expect(1, 8189, '\P{lt}', "");
    Expect(0, 8189, '\P{^lt}', "");
    Expect(1, 8188, '\p{-	Lt}', "");
    Expect(0, 8188, '\p{^-	Lt}', "");
    Expect(0, 8188, '\P{-	Lt}', "");
    Expect(1, 8188, '\P{^-	Lt}', "");
    Expect(0, 8189, '\p{-	Lt}', "");
    Expect(1, 8189, '\p{^-	Lt}', "");
    Expect(1, 8189, '\P{-	Lt}', "");
    Expect(0, 8189, '\P{^-	Lt}', "");
    Error('\p{:=_ Is_Lt}');
    Error('\P{:=_ Is_Lt}');
    Expect(1, 8188, '\p{islt}', "");
    Expect(0, 8188, '\p{^islt}', "");
    Expect(0, 8188, '\P{islt}', "");
    Expect(1, 8188, '\P{^islt}', "");
    Expect(0, 8189, '\p{islt}', "");
    Expect(1, 8189, '\p{^islt}', "");
    Expect(1, 8189, '\P{islt}', "");
    Expect(0, 8189, '\P{^islt}', "");
    Expect(1, 8188, '\p{- Is_Lt}', "");
    Expect(0, 8188, '\p{^- Is_Lt}', "");
    Expect(0, 8188, '\P{- Is_Lt}', "");
    Expect(1, 8188, '\P{^- Is_Lt}', "");
    Expect(0, 8189, '\p{- Is_Lt}', "");
    Expect(1, 8189, '\p{^- Is_Lt}', "");
    Expect(1, 8189, '\P{- Is_Lt}', "");
    Expect(0, 8189, '\P{^- Is_Lt}', "");
    Error('\p{ transport_And_MAP_SYMBOLS:=}');
    Error('\P{ transport_And_MAP_SYMBOLS:=}');
    Expect(1, 128767, '\p{transportandmapsymbols}', "");
    Expect(0, 128767, '\p{^transportandmapsymbols}', "");
    Expect(0, 128767, '\P{transportandmapsymbols}', "");
    Expect(1, 128767, '\P{^transportandmapsymbols}', "");
    Expect(0, 128768, '\p{transportandmapsymbols}', "");
    Expect(1, 128768, '\p{^transportandmapsymbols}', "");
    Expect(1, 128768, '\P{transportandmapsymbols}', "");
    Expect(0, 128768, '\P{^transportandmapsymbols}', "");
    Expect(1, 128767, '\p{-Transport_And_Map_symbols}', "");
    Expect(0, 128767, '\p{^-Transport_And_Map_symbols}', "");
    Expect(0, 128767, '\P{-Transport_And_Map_symbols}', "");
    Expect(1, 128767, '\P{^-Transport_And_Map_symbols}', "");
    Expect(0, 128768, '\p{-Transport_And_Map_symbols}', "");
    Expect(1, 128768, '\p{^-Transport_And_Map_symbols}', "");
    Expect(1, 128768, '\P{-Transport_And_Map_symbols}', "");
    Expect(0, 128768, '\P{^-Transport_And_Map_symbols}', "");
    Error('\p{:=Is_Transport_and_MAP_symbols}');
    Error('\P{:=Is_Transport_and_MAP_symbols}');
    Expect(1, 128767, '\p{istransportandmapsymbols}', "");
    Expect(0, 128767, '\p{^istransportandmapsymbols}', "");
    Expect(0, 128767, '\P{istransportandmapsymbols}', "");
    Expect(1, 128767, '\P{^istransportandmapsymbols}', "");
    Expect(0, 128768, '\p{istransportandmapsymbols}', "");
    Expect(1, 128768, '\p{^istransportandmapsymbols}', "");
    Expect(1, 128768, '\P{istransportandmapsymbols}', "");
    Expect(0, 128768, '\P{^istransportandmapsymbols}', "");
    Expect(1, 128767, '\p{--Is_transport_And_Map_Symbols}', "");
    Expect(0, 128767, '\p{^--Is_transport_And_Map_Symbols}', "");
    Expect(0, 128767, '\P{--Is_transport_And_Map_Symbols}', "");
    Expect(1, 128767, '\P{^--Is_transport_And_Map_Symbols}', "");
    Expect(0, 128768, '\p{--Is_transport_And_Map_Symbols}', "");
    Expect(1, 128768, '\p{^--Is_transport_And_Map_Symbols}', "");
    Expect(1, 128768, '\P{--Is_transport_And_Map_Symbols}', "");
    Expect(0, 128768, '\P{^--Is_transport_And_Map_Symbols}', "");
    Error('\p{:=-_IN_Transport_And_map_SYMBOLS}');
    Error('\P{:=-_IN_Transport_And_map_SYMBOLS}');
    Expect(1, 128767, '\p{intransportandmapsymbols}', "");
    Expect(0, 128767, '\p{^intransportandmapsymbols}', "");
    Expect(0, 128767, '\P{intransportandmapsymbols}', "");
    Expect(1, 128767, '\P{^intransportandmapsymbols}', "");
    Expect(0, 128768, '\p{intransportandmapsymbols}', "");
    Expect(1, 128768, '\p{^intransportandmapsymbols}', "");
    Expect(1, 128768, '\P{intransportandmapsymbols}', "");
    Expect(0, 128768, '\P{^intransportandmapsymbols}', "");
    Expect(1, 128767, '\p{	IN_transport_And_Map_symbols}', "");
    Expect(0, 128767, '\p{^	IN_transport_And_Map_symbols}', "");
    Expect(0, 128767, '\P{	IN_transport_And_Map_symbols}', "");
    Expect(1, 128767, '\P{^	IN_transport_And_Map_symbols}', "");
    Expect(0, 128768, '\p{	IN_transport_And_Map_symbols}', "");
    Expect(1, 128768, '\p{^	IN_transport_And_Map_symbols}', "");
    Expect(1, 128768, '\P{	IN_transport_And_Map_symbols}', "");
    Expect(0, 128768, '\P{^	IN_transport_And_Map_symbols}', "");
    Error('\p{/a/_ Transport_And_Map}');
    Error('\P{/a/_ Transport_And_Map}');
    Expect(1, 128767, '\p{transportandmap}', "");
    Expect(0, 128767, '\p{^transportandmap}', "");
    Expect(0, 128767, '\P{transportandmap}', "");
    Expect(1, 128767, '\P{^transportandmap}', "");
    Expect(0, 128768, '\p{transportandmap}', "");
    Expect(1, 128768, '\p{^transportandmap}', "");
    Expect(1, 128768, '\P{transportandmap}', "");
    Expect(0, 128768, '\P{^transportandmap}', "");
    Expect(1, 128767, '\p{ transport_And_Map}', "");
    Expect(0, 128767, '\p{^ transport_And_Map}', "");
    Expect(0, 128767, '\P{ transport_And_Map}', "");
    Expect(1, 128767, '\P{^ transport_And_Map}', "");
    Expect(0, 128768, '\p{ transport_And_Map}', "");
    Expect(1, 128768, '\p{^ transport_And_Map}', "");
    Expect(1, 128768, '\P{ transport_And_Map}', "");
    Expect(0, 128768, '\P{^ transport_And_Map}', "");
    Error('\p{-/a/is_Transport_and_Map}');
    Error('\P{-/a/is_Transport_and_Map}');
    Expect(1, 128767, '\p{istransportandmap}', "");
    Expect(0, 128767, '\p{^istransportandmap}', "");
    Expect(0, 128767, '\P{istransportandmap}', "");
    Expect(1, 128767, '\P{^istransportandmap}', "");
    Expect(0, 128768, '\p{istransportandmap}', "");
    Expect(1, 128768, '\p{^istransportandmap}', "");
    Expect(1, 128768, '\P{istransportandmap}', "");
    Expect(0, 128768, '\P{^istransportandmap}', "");
    Expect(1, 128767, '\p{_is_transport_AND_Map}', "");
    Expect(0, 128767, '\p{^_is_transport_AND_Map}', "");
    Expect(0, 128767, '\P{_is_transport_AND_Map}', "");
    Expect(1, 128767, '\P{^_is_transport_AND_Map}', "");
    Expect(0, 128768, '\p{_is_transport_AND_Map}', "");
    Expect(1, 128768, '\p{^_is_transport_AND_Map}', "");
    Expect(1, 128768, '\P{_is_transport_AND_Map}', "");
    Expect(0, 128768, '\P{^_is_transport_AND_Map}', "");
    Error('\p{ /a/In_transport_And_Map}');
    Error('\P{ /a/In_transport_And_Map}');
    Expect(1, 128767, '\p{intransportandmap}', "");
    Expect(0, 128767, '\p{^intransportandmap}', "");
    Expect(0, 128767, '\P{intransportandmap}', "");
    Expect(1, 128767, '\P{^intransportandmap}', "");
    Expect(0, 128768, '\p{intransportandmap}', "");
    Expect(1, 128768, '\p{^intransportandmap}', "");
    Expect(1, 128768, '\P{intransportandmap}', "");
    Expect(0, 128768, '\P{^intransportandmap}', "");
    Expect(1, 128767, '\p{-_In_Transport_And_MAP}', "");
    Expect(0, 128767, '\p{^-_In_Transport_And_MAP}', "");
    Expect(0, 128767, '\P{-_In_Transport_And_MAP}', "");
    Expect(1, 128767, '\P{^-_In_Transport_And_MAP}', "");
    Expect(0, 128768, '\p{-_In_Transport_And_MAP}', "");
    Expect(1, 128768, '\p{^-_In_Transport_And_MAP}', "");
    Expect(1, 128768, '\P{-_In_Transport_And_MAP}', "");
    Expect(0, 128768, '\P{^-_In_Transport_And_MAP}', "");
    Error('\p{_ Ugaritic:=}');
    Error('\P{_ Ugaritic:=}');
    Expect(1, 66463, '\p{ugaritic}', "");
    Expect(0, 66463, '\p{^ugaritic}', "");
    Expect(0, 66463, '\P{ugaritic}', "");
    Expect(1, 66463, '\P{^ugaritic}', "");
    Expect(0, 66464, '\p{ugaritic}', "");
    Expect(1, 66464, '\p{^ugaritic}', "");
    Expect(1, 66464, '\P{ugaritic}', "");
    Expect(0, 66464, '\P{^ugaritic}', "");
    Expect(1, 66463, '\p{ -UGARITIC}', "");
    Expect(0, 66463, '\p{^ -UGARITIC}', "");
    Expect(0, 66463, '\P{ -UGARITIC}', "");
    Expect(1, 66463, '\P{^ -UGARITIC}', "");
    Expect(0, 66464, '\p{ -UGARITIC}', "");
    Expect(1, 66464, '\p{^ -UGARITIC}', "");
    Expect(1, 66464, '\P{ -UGARITIC}', "");
    Expect(0, 66464, '\P{^ -UGARITIC}', "");
    Error('\p{/a/-Is_UGARITIC}');
    Error('\P{/a/-Is_UGARITIC}');
    Expect(1, 66463, '\p{isugaritic}', "");
    Expect(0, 66463, '\p{^isugaritic}', "");
    Expect(0, 66463, '\P{isugaritic}', "");
    Expect(1, 66463, '\P{^isugaritic}', "");
    Expect(0, 66464, '\p{isugaritic}', "");
    Expect(1, 66464, '\p{^isugaritic}', "");
    Expect(1, 66464, '\P{isugaritic}', "");
    Expect(0, 66464, '\P{^isugaritic}', "");
    Expect(1, 66463, '\p{_-IS_Ugaritic}', "");
    Expect(0, 66463, '\p{^_-IS_Ugaritic}', "");
    Expect(0, 66463, '\P{_-IS_Ugaritic}', "");
    Expect(1, 66463, '\P{^_-IS_Ugaritic}', "");
    Expect(0, 66464, '\p{_-IS_Ugaritic}', "");
    Expect(1, 66464, '\p{^_-IS_Ugaritic}', "");
    Expect(1, 66464, '\P{_-IS_Ugaritic}', "");
    Expect(0, 66464, '\P{^_-IS_Ugaritic}', "");
    Error('\p{_/a/Ugar}');
    Error('\P{_/a/Ugar}');
    Expect(1, 66463, '\p{ugar}', "");
    Expect(0, 66463, '\p{^ugar}', "");
    Expect(0, 66463, '\P{ugar}', "");
    Expect(1, 66463, '\P{^ugar}', "");
    Expect(0, 66464, '\p{ugar}', "");
    Expect(1, 66464, '\p{^ugar}', "");
    Expect(1, 66464, '\P{ugar}', "");
    Expect(0, 66464, '\P{^ugar}', "");
    Expect(1, 66463, '\p{- Ugar}', "");
    Expect(0, 66463, '\p{^- Ugar}', "");
    Expect(0, 66463, '\P{- Ugar}', "");
    Expect(1, 66463, '\P{^- Ugar}', "");
    Expect(0, 66464, '\p{- Ugar}', "");
    Expect(1, 66464, '\p{^- Ugar}', "");
    Expect(1, 66464, '\P{- Ugar}', "");
    Expect(0, 66464, '\P{^- Ugar}', "");
    Error('\p{  Is_UGAR:=}');
    Error('\P{  Is_UGAR:=}');
    Expect(1, 66463, '\p{isugar}', "");
    Expect(0, 66463, '\p{^isugar}', "");
    Expect(0, 66463, '\P{isugar}', "");
    Expect(1, 66463, '\P{^isugar}', "");
    Expect(0, 66464, '\p{isugar}', "");
    Expect(1, 66464, '\p{^isugar}', "");
    Expect(1, 66464, '\P{isugar}', "");
    Expect(0, 66464, '\P{^isugar}', "");
    Expect(1, 66463, '\p{ IS_Ugar}', "");
    Expect(0, 66463, '\p{^ IS_Ugar}', "");
    Expect(0, 66463, '\P{ IS_Ugar}', "");
    Expect(1, 66463, '\P{^ IS_Ugar}', "");
    Expect(0, 66464, '\p{ IS_Ugar}', "");
    Expect(1, 66464, '\p{^ IS_Ugar}', "");
    Expect(1, 66464, '\P{ IS_Ugar}', "");
    Expect(0, 66464, '\P{^ IS_Ugar}', "");
    Error('\p{:=-UNASSIGNED}');
    Error('\P{:=-UNASSIGNED}');
    Expect(1, 918000, '\p{unassigned}', "");
    Expect(0, 918000, '\p{^unassigned}', "");
    Expect(0, 918000, '\P{unassigned}', "");
    Expect(1, 918000, '\P{^unassigned}', "");
    Expect(0, 1114109, '\p{unassigned}', "");
    Expect(1, 1114109, '\p{^unassigned}', "");
    Expect(1, 1114109, '\P{unassigned}', "");
    Expect(0, 1114109, '\P{^unassigned}', "");
    Expect(1, 918000, '\p{ Unassigned}', "");
    Expect(0, 918000, '\p{^ Unassigned}', "");
    Expect(0, 918000, '\P{ Unassigned}', "");
    Expect(1, 918000, '\P{^ Unassigned}', "");
    Expect(0, 1114109, '\p{ Unassigned}', "");
    Expect(1, 1114109, '\p{^ Unassigned}', "");
    Expect(1, 1114109, '\P{ Unassigned}', "");
    Expect(0, 1114109, '\P{^ Unassigned}', "");
    Error('\p{  Is_unassigned/a/}');
    Error('\P{  Is_unassigned/a/}');
    Expect(1, 918000, '\p{isunassigned}', "");
    Expect(0, 918000, '\p{^isunassigned}', "");
    Expect(0, 918000, '\P{isunassigned}', "");
    Expect(1, 918000, '\P{^isunassigned}', "");
    Expect(0, 1114109, '\p{isunassigned}', "");
    Expect(1, 1114109, '\p{^isunassigned}', "");
    Expect(1, 1114109, '\P{isunassigned}', "");
    Expect(0, 1114109, '\P{^isunassigned}', "");
    Expect(1, 918000, '\p{__Is_UNASSIGNED}', "");
    Expect(0, 918000, '\p{^__Is_UNASSIGNED}', "");
    Expect(0, 918000, '\P{__Is_UNASSIGNED}', "");
    Expect(1, 918000, '\P{^__Is_UNASSIGNED}', "");
    Expect(0, 1114109, '\p{__Is_UNASSIGNED}', "");
    Expect(1, 1114109, '\p{^__Is_UNASSIGNED}', "");
    Expect(1, 1114109, '\P{__Is_UNASSIGNED}', "");
    Expect(0, 1114109, '\P{^__Is_UNASSIGNED}', "");
    Error('\p{_	Cn:=}');
    Error('\P{_	Cn:=}');
    Expect(1, 918000, '\p{cn}', "");
    Expect(0, 918000, '\p{^cn}', "");
    Expect(0, 918000, '\P{cn}', "");
    Expect(1, 918000, '\P{^cn}', "");
    Expect(0, 1114109, '\p{cn}', "");
    Expect(1, 1114109, '\p{^cn}', "");
    Expect(1, 1114109, '\P{cn}', "");
    Expect(0, 1114109, '\P{^cn}', "");
    Expect(1, 918000, '\p{_ CN}', "");
    Expect(0, 918000, '\p{^_ CN}', "");
    Expect(0, 918000, '\P{_ CN}', "");
    Expect(1, 918000, '\P{^_ CN}', "");
    Expect(0, 1114109, '\p{_ CN}', "");
    Expect(1, 1114109, '\p{^_ CN}', "");
    Expect(1, 1114109, '\P{_ CN}', "");
    Expect(0, 1114109, '\P{^_ CN}', "");
    Error('\p{/a/Is_Cn}');
    Error('\P{/a/Is_Cn}');
    Expect(1, 918000, '\p{iscn}', "");
    Expect(0, 918000, '\p{^iscn}', "");
    Expect(0, 918000, '\P{iscn}', "");
    Expect(1, 918000, '\P{^iscn}', "");
    Expect(0, 1114109, '\p{iscn}', "");
    Expect(1, 1114109, '\p{^iscn}', "");
    Expect(1, 1114109, '\P{iscn}', "");
    Expect(0, 1114109, '\P{^iscn}', "");
    Expect(1, 918000, '\p{_	IS_Cn}', "");
    Expect(0, 918000, '\p{^_	IS_Cn}', "");
    Expect(0, 918000, '\P{_	IS_Cn}', "");
    Expect(1, 918000, '\P{^_	IS_Cn}', "");
    Expect(0, 1114109, '\p{_	IS_Cn}', "");
    Expect(1, 1114109, '\p{^_	IS_Cn}', "");
    Expect(1, 1114109, '\P{_	IS_Cn}', "");
    Expect(0, 1114109, '\P{^_	IS_Cn}', "");
    Error('\p{/a/-_unified_canadian_aboriginal_syllabics}');
    Error('\P{/a/-_unified_canadian_aboriginal_syllabics}');
    Expect(1, 5759, '\p{unifiedcanadianaboriginalsyllabics}', "");
    Expect(0, 5759, '\p{^unifiedcanadianaboriginalsyllabics}', "");
    Expect(0, 5759, '\P{unifiedcanadianaboriginalsyllabics}', "");
    Expect(1, 5759, '\P{^unifiedcanadianaboriginalsyllabics}', "");
    Expect(0, 5760, '\p{unifiedcanadianaboriginalsyllabics}', "");
    Expect(1, 5760, '\p{^unifiedcanadianaboriginalsyllabics}', "");
    Expect(1, 5760, '\P{unifiedcanadianaboriginalsyllabics}', "");
    Expect(0, 5760, '\P{^unifiedcanadianaboriginalsyllabics}', "");
    Expect(1, 5759, '\p{	Unified_Canadian_Aboriginal_Syllabics}', "");
    Expect(0, 5759, '\p{^	Unified_Canadian_Aboriginal_Syllabics}', "");
    Expect(0, 5759, '\P{	Unified_Canadian_Aboriginal_Syllabics}', "");
    Expect(1, 5759, '\P{^	Unified_Canadian_Aboriginal_Syllabics}', "");
    Expect(0, 5760, '\p{	Unified_Canadian_Aboriginal_Syllabics}', "");
    Expect(1, 5760, '\p{^	Unified_Canadian_Aboriginal_Syllabics}', "");
    Expect(1, 5760, '\P{	Unified_Canadian_Aboriginal_Syllabics}', "");
    Expect(0, 5760, '\P{^	Unified_Canadian_Aboriginal_Syllabics}', "");
    Error('\p{	_Is_unified_Canadian_Aboriginal_Syllabics:=}');
    Error('\P{	_Is_unified_Canadian_Aboriginal_Syllabics:=}');
    Expect(1, 5759, '\p{isunifiedcanadianaboriginalsyllabics}', "");
    Expect(0, 5759, '\p{^isunifiedcanadianaboriginalsyllabics}', "");
    Expect(0, 5759, '\P{isunifiedcanadianaboriginalsyllabics}', "");
    Expect(1, 5759, '\P{^isunifiedcanadianaboriginalsyllabics}', "");
    Expect(0, 5760, '\p{isunifiedcanadianaboriginalsyllabics}', "");
    Expect(1, 5760, '\p{^isunifiedcanadianaboriginalsyllabics}', "");
    Expect(1, 5760, '\P{isunifiedcanadianaboriginalsyllabics}', "");
    Expect(0, 5760, '\P{^isunifiedcanadianaboriginalsyllabics}', "");
    Expect(1, 5759, '\p{	IS_unified_Canadian_Aboriginal_syllabics}', "");
    Expect(0, 5759, '\p{^	IS_unified_Canadian_Aboriginal_syllabics}', "");
    Expect(0, 5759, '\P{	IS_unified_Canadian_Aboriginal_syllabics}', "");
    Expect(1, 5759, '\P{^	IS_unified_Canadian_Aboriginal_syllabics}', "");
    Expect(0, 5760, '\p{	IS_unified_Canadian_Aboriginal_syllabics}', "");
    Expect(1, 5760, '\p{^	IS_unified_Canadian_Aboriginal_syllabics}', "");
    Expect(1, 5760, '\P{	IS_unified_Canadian_Aboriginal_syllabics}', "");
    Expect(0, 5760, '\P{^	IS_unified_Canadian_Aboriginal_syllabics}', "");
    Error('\p{_/a/in_UNIFIED_Canadian_Aboriginal_Syllabics}');
    Error('\P{_/a/in_UNIFIED_Canadian_Aboriginal_Syllabics}');
    Expect(1, 5759, '\p{inunifiedcanadianaboriginalsyllabics}', "");
    Expect(0, 5759, '\p{^inunifiedcanadianaboriginalsyllabics}', "");
    Expect(0, 5759, '\P{inunifiedcanadianaboriginalsyllabics}', "");
    Expect(1, 5759, '\P{^inunifiedcanadianaboriginalsyllabics}', "");
    Expect(0, 5760, '\p{inunifiedcanadianaboriginalsyllabics}', "");
    Expect(1, 5760, '\p{^inunifiedcanadianaboriginalsyllabics}', "");
    Expect(1, 5760, '\P{inunifiedcanadianaboriginalsyllabics}', "");
    Expect(0, 5760, '\P{^inunifiedcanadianaboriginalsyllabics}', "");
    Expect(1, 5759, '\p{ -IN_UNIFIED_Canadian_ABORIGINAL_SYLLABICS}', "");
    Expect(0, 5759, '\p{^ -IN_UNIFIED_Canadian_ABORIGINAL_SYLLABICS}', "");
    Expect(0, 5759, '\P{ -IN_UNIFIED_Canadian_ABORIGINAL_SYLLABICS}', "");
    Expect(1, 5759, '\P{^ -IN_UNIFIED_Canadian_ABORIGINAL_SYLLABICS}', "");
    Expect(0, 5760, '\p{ -IN_UNIFIED_Canadian_ABORIGINAL_SYLLABICS}', "");
    Expect(1, 5760, '\p{^ -IN_UNIFIED_Canadian_ABORIGINAL_SYLLABICS}', "");
    Expect(1, 5760, '\P{ -IN_UNIFIED_Canadian_ABORIGINAL_SYLLABICS}', "");
    Expect(0, 5760, '\P{^ -IN_UNIFIED_Canadian_ABORIGINAL_SYLLABICS}', "");
    Error('\p{ 	UCAS/a/}');
    Error('\P{ 	UCAS/a/}');
    Expect(1, 5759, '\p{ucas}', "");
    Expect(0, 5759, '\p{^ucas}', "");
    Expect(0, 5759, '\P{ucas}', "");
    Expect(1, 5759, '\P{^ucas}', "");
    Expect(0, 5760, '\p{ucas}', "");
    Expect(1, 5760, '\p{^ucas}', "");
    Expect(1, 5760, '\P{ucas}', "");
    Expect(0, 5760, '\P{^ucas}', "");
    Expect(1, 5759, '\p{ ucas}', "");
    Expect(0, 5759, '\p{^ ucas}', "");
    Expect(0, 5759, '\P{ ucas}', "");
    Expect(1, 5759, '\P{^ ucas}', "");
    Expect(0, 5760, '\p{ ucas}', "");
    Expect(1, 5760, '\p{^ ucas}', "");
    Expect(1, 5760, '\P{ ucas}', "");
    Expect(0, 5760, '\P{^ ucas}', "");
    Error('\p{:= 	is_UCAS}');
    Error('\P{:= 	is_UCAS}');
    Expect(1, 5759, '\p{isucas}', "");
    Expect(0, 5759, '\p{^isucas}', "");
    Expect(0, 5759, '\P{isucas}', "");
    Expect(1, 5759, '\P{^isucas}', "");
    Expect(0, 5760, '\p{isucas}', "");
    Expect(1, 5760, '\p{^isucas}', "");
    Expect(1, 5760, '\P{isucas}', "");
    Expect(0, 5760, '\P{^isucas}', "");
    Expect(1, 5759, '\p{ -IS_ucas}', "");
    Expect(0, 5759, '\p{^ -IS_ucas}', "");
    Expect(0, 5759, '\P{ -IS_ucas}', "");
    Expect(1, 5759, '\P{^ -IS_ucas}', "");
    Expect(0, 5760, '\p{ -IS_ucas}', "");
    Expect(1, 5760, '\p{^ -IS_ucas}', "");
    Expect(1, 5760, '\P{ -IS_ucas}', "");
    Expect(0, 5760, '\P{^ -IS_ucas}', "");
    Error('\p{-in_UCAS/a/}');
    Error('\P{-in_UCAS/a/}');
    Expect(1, 5759, '\p{inucas}', "");
    Expect(0, 5759, '\p{^inucas}', "");
    Expect(0, 5759, '\P{inucas}', "");
    Expect(1, 5759, '\P{^inucas}', "");
    Expect(0, 5760, '\p{inucas}', "");
    Expect(1, 5760, '\p{^inucas}', "");
    Expect(1, 5760, '\P{inucas}', "");
    Expect(0, 5760, '\P{^inucas}', "");
    Expect(1, 5759, '\p{_	In_ucas}', "");
    Expect(0, 5759, '\p{^_	In_ucas}', "");
    Expect(0, 5759, '\P{_	In_ucas}', "");
    Expect(1, 5759, '\P{^_	In_ucas}', "");
    Expect(0, 5760, '\p{_	In_ucas}', "");
    Expect(1, 5760, '\p{^_	In_ucas}', "");
    Expect(1, 5760, '\P{_	In_ucas}', "");
    Expect(0, 5760, '\P{^_	In_ucas}', "");
    Error('\p{- Canadian_Syllabics/a/}');
    Error('\P{- Canadian_Syllabics/a/}');
    Expect(1, 5759, '\p{canadiansyllabics}', "");
    Expect(0, 5759, '\p{^canadiansyllabics}', "");
    Expect(0, 5759, '\P{canadiansyllabics}', "");
    Expect(1, 5759, '\P{^canadiansyllabics}', "");
    Expect(0, 5760, '\p{canadiansyllabics}', "");
    Expect(1, 5760, '\p{^canadiansyllabics}', "");
    Expect(1, 5760, '\P{canadiansyllabics}', "");
    Expect(0, 5760, '\P{^canadiansyllabics}', "");
    Expect(1, 5759, '\p{	canadian_Syllabics}', "");
    Expect(0, 5759, '\p{^	canadian_Syllabics}', "");
    Expect(0, 5759, '\P{	canadian_Syllabics}', "");
    Expect(1, 5759, '\P{^	canadian_Syllabics}', "");
    Expect(0, 5760, '\p{	canadian_Syllabics}', "");
    Expect(1, 5760, '\p{^	canadian_Syllabics}', "");
    Expect(1, 5760, '\P{	canadian_Syllabics}', "");
    Expect(0, 5760, '\P{^	canadian_Syllabics}', "");
    Error('\p{		Is_Canadian_Syllabics:=}');
    Error('\P{		Is_Canadian_Syllabics:=}');
    Expect(1, 5759, '\p{iscanadiansyllabics}', "");
    Expect(0, 5759, '\p{^iscanadiansyllabics}', "");
    Expect(0, 5759, '\P{iscanadiansyllabics}', "");
    Expect(1, 5759, '\P{^iscanadiansyllabics}', "");
    Expect(0, 5760, '\p{iscanadiansyllabics}', "");
    Expect(1, 5760, '\p{^iscanadiansyllabics}', "");
    Expect(1, 5760, '\P{iscanadiansyllabics}', "");
    Expect(0, 5760, '\P{^iscanadiansyllabics}', "");
    Expect(1, 5759, '\p{-Is_CANADIAN_SYLLABICS}', "");
    Expect(0, 5759, '\p{^-Is_CANADIAN_SYLLABICS}', "");
    Expect(0, 5759, '\P{-Is_CANADIAN_SYLLABICS}', "");
    Expect(1, 5759, '\P{^-Is_CANADIAN_SYLLABICS}', "");
    Expect(0, 5760, '\p{-Is_CANADIAN_SYLLABICS}', "");
    Expect(1, 5760, '\p{^-Is_CANADIAN_SYLLABICS}', "");
    Expect(1, 5760, '\P{-Is_CANADIAN_SYLLABICS}', "");
    Expect(0, 5760, '\P{^-Is_CANADIAN_SYLLABICS}', "");
    Error('\p{		in_CANADIAN_Syllabics/a/}');
    Error('\P{		in_CANADIAN_Syllabics/a/}');
    Expect(1, 5759, '\p{incanadiansyllabics}', "");
    Expect(0, 5759, '\p{^incanadiansyllabics}', "");
    Expect(0, 5759, '\P{incanadiansyllabics}', "");
    Expect(1, 5759, '\P{^incanadiansyllabics}', "");
    Expect(0, 5760, '\p{incanadiansyllabics}', "");
    Expect(1, 5760, '\p{^incanadiansyllabics}', "");
    Expect(1, 5760, '\P{incanadiansyllabics}', "");
    Expect(0, 5760, '\P{^incanadiansyllabics}', "");
    Expect(1, 5759, '\p{  In_Canadian_Syllabics}', "");
    Expect(0, 5759, '\p{^  In_Canadian_Syllabics}', "");
    Expect(0, 5759, '\P{  In_Canadian_Syllabics}', "");
    Expect(1, 5759, '\P{^  In_Canadian_Syllabics}', "");
    Expect(0, 5760, '\p{  In_Canadian_Syllabics}', "");
    Expect(1, 5760, '\p{^  In_Canadian_Syllabics}', "");
    Expect(1, 5760, '\P{  In_Canadian_Syllabics}', "");
    Expect(0, 5760, '\P{^  In_Canadian_Syllabics}', "");
    Error('\p{		unified_canadian_Aboriginal_syllabics_Extended:=}');
    Error('\P{		unified_canadian_Aboriginal_syllabics_Extended:=}');
    Expect(1, 6399, '\p{unifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(0, 6399, '\p{^unifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(0, 6399, '\P{unifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(1, 6399, '\P{^unifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(0, 6400, '\p{unifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(1, 6400, '\p{^unifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(1, 6400, '\P{unifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(0, 6400, '\P{^unifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(1, 6399, '\p{ -unified_Canadian_Aboriginal_Syllabics_EXTENDED}', "");
    Expect(0, 6399, '\p{^ -unified_Canadian_Aboriginal_Syllabics_EXTENDED}', "");
    Expect(0, 6399, '\P{ -unified_Canadian_Aboriginal_Syllabics_EXTENDED}', "");
    Expect(1, 6399, '\P{^ -unified_Canadian_Aboriginal_Syllabics_EXTENDED}', "");
    Expect(0, 6400, '\p{ -unified_Canadian_Aboriginal_Syllabics_EXTENDED}', "");
    Expect(1, 6400, '\p{^ -unified_Canadian_Aboriginal_Syllabics_EXTENDED}', "");
    Expect(1, 6400, '\P{ -unified_Canadian_Aboriginal_Syllabics_EXTENDED}', "");
    Expect(0, 6400, '\P{^ -unified_Canadian_Aboriginal_Syllabics_EXTENDED}', "");
    Error('\p{ /a/Is_Unified_CANADIAN_Aboriginal_Syllabics_extended}');
    Error('\P{ /a/Is_Unified_CANADIAN_Aboriginal_Syllabics_extended}');
    Expect(1, 6399, '\p{isunifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(0, 6399, '\p{^isunifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(0, 6399, '\P{isunifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(1, 6399, '\P{^isunifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(0, 6400, '\p{isunifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(1, 6400, '\p{^isunifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(1, 6400, '\P{isunifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(0, 6400, '\P{^isunifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(1, 6399, '\p{		is_Unified_Canadian_ABORIGINAL_syllabics_Extended}', "");
    Expect(0, 6399, '\p{^		is_Unified_Canadian_ABORIGINAL_syllabics_Extended}', "");
    Expect(0, 6399, '\P{		is_Unified_Canadian_ABORIGINAL_syllabics_Extended}', "");
    Expect(1, 6399, '\P{^		is_Unified_Canadian_ABORIGINAL_syllabics_Extended}', "");
    Expect(0, 6400, '\p{		is_Unified_Canadian_ABORIGINAL_syllabics_Extended}', "");
    Expect(1, 6400, '\p{^		is_Unified_Canadian_ABORIGINAL_syllabics_Extended}', "");
    Expect(1, 6400, '\P{		is_Unified_Canadian_ABORIGINAL_syllabics_Extended}', "");
    Expect(0, 6400, '\P{^		is_Unified_Canadian_ABORIGINAL_syllabics_Extended}', "");
    Error('\p{_:=IN_unified_canadian_aboriginal_SYLLABICS_Extended}');
    Error('\P{_:=IN_unified_canadian_aboriginal_SYLLABICS_Extended}');
    Expect(1, 6399, '\p{inunifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(0, 6399, '\p{^inunifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(0, 6399, '\P{inunifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(1, 6399, '\P{^inunifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(0, 6400, '\p{inunifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(1, 6400, '\p{^inunifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(1, 6400, '\P{inunifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(0, 6400, '\P{^inunifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(1, 6399, '\p{  IN_UNIFIED_canadian_ABORIGINAL_Syllabics_EXTENDED}', "");
    Expect(0, 6399, '\p{^  IN_UNIFIED_canadian_ABORIGINAL_Syllabics_EXTENDED}', "");
    Expect(0, 6399, '\P{  IN_UNIFIED_canadian_ABORIGINAL_Syllabics_EXTENDED}', "");
    Expect(1, 6399, '\P{^  IN_UNIFIED_canadian_ABORIGINAL_Syllabics_EXTENDED}', "");
    Expect(0, 6400, '\p{  IN_UNIFIED_canadian_ABORIGINAL_Syllabics_EXTENDED}', "");
    Expect(1, 6400, '\p{^  IN_UNIFIED_canadian_ABORIGINAL_Syllabics_EXTENDED}', "");
    Expect(1, 6400, '\P{  IN_UNIFIED_canadian_ABORIGINAL_Syllabics_EXTENDED}', "");
    Expect(0, 6400, '\P{^  IN_UNIFIED_canadian_ABORIGINAL_Syllabics_EXTENDED}', "");
    Error('\p{/a/- UCAS_Ext}');
    Error('\P{/a/- UCAS_Ext}');
    Expect(1, 6399, '\p{ucasext}', "");
    Expect(0, 6399, '\p{^ucasext}', "");
    Expect(0, 6399, '\P{ucasext}', "");
    Expect(1, 6399, '\P{^ucasext}', "");
    Expect(0, 6400, '\p{ucasext}', "");
    Expect(1, 6400, '\p{^ucasext}', "");
    Expect(1, 6400, '\P{ucasext}', "");
    Expect(0, 6400, '\P{^ucasext}', "");
    Expect(1, 6399, '\p{_ ucas_Ext}', "");
    Expect(0, 6399, '\p{^_ ucas_Ext}', "");
    Expect(0, 6399, '\P{_ ucas_Ext}', "");
    Expect(1, 6399, '\P{^_ ucas_Ext}', "");
    Expect(0, 6400, '\p{_ ucas_Ext}', "");
    Expect(1, 6400, '\p{^_ ucas_Ext}', "");
    Expect(1, 6400, '\P{_ ucas_Ext}', "");
    Expect(0, 6400, '\P{^_ ucas_Ext}', "");
    Error('\p{/a/ is_UCAS_ext}');
    Error('\P{/a/ is_UCAS_ext}');
    Expect(1, 6399, '\p{isucasext}', "");
    Expect(0, 6399, '\p{^isucasext}', "");
    Expect(0, 6399, '\P{isucasext}', "");
    Expect(1, 6399, '\P{^isucasext}', "");
    Expect(0, 6400, '\p{isucasext}', "");
    Expect(1, 6400, '\p{^isucasext}', "");
    Expect(1, 6400, '\P{isucasext}', "");
    Expect(0, 6400, '\P{^isucasext}', "");
    Expect(1, 6399, '\p{-Is_ucas_Ext}', "");
    Expect(0, 6399, '\p{^-Is_ucas_Ext}', "");
    Expect(0, 6399, '\P{-Is_ucas_Ext}', "");
    Expect(1, 6399, '\P{^-Is_ucas_Ext}', "");
    Expect(0, 6400, '\p{-Is_ucas_Ext}', "");
    Expect(1, 6400, '\p{^-Is_ucas_Ext}', "");
    Expect(1, 6400, '\P{-Is_ucas_Ext}', "");
    Expect(0, 6400, '\P{^-Is_ucas_Ext}', "");
    Error('\p{_ IN_ucas_EXT/a/}');
    Error('\P{_ IN_ucas_EXT/a/}');
    Expect(1, 6399, '\p{inucasext}', "");
    Expect(0, 6399, '\p{^inucasext}', "");
    Expect(0, 6399, '\P{inucasext}', "");
    Expect(1, 6399, '\P{^inucasext}', "");
    Expect(0, 6400, '\p{inucasext}', "");
    Expect(1, 6400, '\p{^inucasext}', "");
    Expect(1, 6400, '\P{inucasext}', "");
    Expect(0, 6400, '\P{^inucasext}', "");
    Expect(1, 6399, '\p{ -In_ucas_Ext}', "");
    Expect(0, 6399, '\p{^ -In_ucas_Ext}', "");
    Expect(0, 6399, '\P{ -In_ucas_Ext}', "");
    Expect(1, 6399, '\P{^ -In_ucas_Ext}', "");
    Expect(0, 6400, '\p{ -In_ucas_Ext}', "");
    Expect(1, 6400, '\p{^ -In_ucas_Ext}', "");
    Expect(1, 6400, '\P{ -In_ucas_Ext}', "");
    Expect(0, 6400, '\P{^ -In_ucas_Ext}', "");
    Error('\p{ /a/UNIFIED_Ideograph}');
    Error('\P{ /a/UNIFIED_Ideograph}');
    Expect(1, 201546, '\p{unifiedideograph}', "");
    Expect(0, 201546, '\p{^unifiedideograph}', "");
    Expect(0, 201546, '\P{unifiedideograph}', "");
    Expect(1, 201546, '\P{^unifiedideograph}', "");
    Expect(0, 201547, '\p{unifiedideograph}', "");
    Expect(1, 201547, '\p{^unifiedideograph}', "");
    Expect(1, 201547, '\P{unifiedideograph}', "");
    Expect(0, 201547, '\P{^unifiedideograph}', "");
    Expect(1, 201546, '\p{ -Unified_ideograph}', "");
    Expect(0, 201546, '\p{^ -Unified_ideograph}', "");
    Expect(0, 201546, '\P{ -Unified_ideograph}', "");
    Expect(1, 201546, '\P{^ -Unified_ideograph}', "");
    Expect(0, 201547, '\p{ -Unified_ideograph}', "");
    Expect(1, 201547, '\p{^ -Unified_ideograph}', "");
    Expect(1, 201547, '\P{ -Unified_ideograph}', "");
    Expect(0, 201547, '\P{^ -Unified_ideograph}', "");
    Error('\p{ /a/Is_Unified_Ideograph}');
    Error('\P{ /a/Is_Unified_Ideograph}');
    Expect(1, 201546, '\p{isunifiedideograph}', "");
    Expect(0, 201546, '\p{^isunifiedideograph}', "");
    Expect(0, 201546, '\P{isunifiedideograph}', "");
    Expect(1, 201546, '\P{^isunifiedideograph}', "");
    Expect(0, 201547, '\p{isunifiedideograph}', "");
    Expect(1, 201547, '\p{^isunifiedideograph}', "");
    Expect(1, 201547, '\P{isunifiedideograph}', "");
    Expect(0, 201547, '\P{^isunifiedideograph}', "");
    Expect(1, 201546, '\p{_-Is_Unified_Ideograph}', "");
    Expect(0, 201546, '\p{^_-Is_Unified_Ideograph}', "");
    Expect(0, 201546, '\P{_-Is_Unified_Ideograph}', "");
    Expect(1, 201546, '\P{^_-Is_Unified_Ideograph}', "");
    Expect(0, 201547, '\p{_-Is_Unified_Ideograph}', "");
    Expect(1, 201547, '\p{^_-Is_Unified_Ideograph}', "");
    Expect(1, 201547, '\P{_-Is_Unified_Ideograph}', "");
    Expect(0, 201547, '\P{^_-Is_Unified_Ideograph}', "");
    Error('\p{/a/	UIDEO}');
    Error('\P{/a/	UIDEO}');
    Expect(1, 201546, '\p{uideo}', "");
    Expect(0, 201546, '\p{^uideo}', "");
    Expect(0, 201546, '\P{uideo}', "");
    Expect(1, 201546, '\P{^uideo}', "");
    Expect(0, 201547, '\p{uideo}', "");
    Expect(1, 201547, '\p{^uideo}', "");
    Expect(1, 201547, '\P{uideo}', "");
    Expect(0, 201547, '\P{^uideo}', "");
    Expect(1, 201546, '\p{_ UIDEO}', "");
    Expect(0, 201546, '\p{^_ UIDEO}', "");
    Expect(0, 201546, '\P{_ UIDEO}', "");
    Expect(1, 201546, '\P{^_ UIDEO}', "");
    Expect(0, 201547, '\p{_ UIDEO}', "");
    Expect(1, 201547, '\p{^_ UIDEO}', "");
    Expect(1, 201547, '\P{_ UIDEO}', "");
    Expect(0, 201547, '\P{^_ UIDEO}', "");
    Error('\p{:=_	is_UIDEO}');
    Error('\P{:=_	is_UIDEO}');
    Expect(1, 201546, '\p{isuideo}', "");
    Expect(0, 201546, '\p{^isuideo}', "");
    Expect(0, 201546, '\P{isuideo}', "");
    Expect(1, 201546, '\P{^isuideo}', "");
    Expect(0, 201547, '\p{isuideo}', "");
    Expect(1, 201547, '\p{^isuideo}', "");
    Expect(1, 201547, '\P{isuideo}', "");
    Expect(0, 201547, '\P{^isuideo}', "");
    Expect(1, 201546, '\p{_-IS_UIdeo}', "");
    Expect(0, 201546, '\p{^_-IS_UIdeo}', "");
    Expect(0, 201546, '\P{_-IS_UIdeo}', "");
    Expect(1, 201546, '\P{^_-IS_UIdeo}', "");
    Expect(0, 201547, '\p{_-IS_UIdeo}', "");
    Expect(1, 201547, '\p{^_-IS_UIdeo}', "");
    Expect(1, 201547, '\P{_-IS_UIdeo}', "");
    Expect(0, 201547, '\P{^_-IS_UIdeo}', "");
    Error('\p{/a/-	Unknown}');
    Error('\P{/a/-	Unknown}');
    Expect(1, 918000, '\p{unknown}', "");
    Expect(0, 918000, '\p{^unknown}', "");
    Expect(0, 918000, '\P{unknown}', "");
    Expect(1, 918000, '\P{^unknown}', "");
    Expect(0, 917999, '\p{unknown}', "");
    Expect(1, 917999, '\p{^unknown}', "");
    Expect(1, 917999, '\P{unknown}', "");
    Expect(0, 917999, '\P{^unknown}', "");
    Expect(1, 918000, '\p{		UNKNOWN}', "");
    Expect(0, 918000, '\p{^		UNKNOWN}', "");
    Expect(0, 918000, '\P{		UNKNOWN}', "");
    Expect(1, 918000, '\P{^		UNKNOWN}', "");
    Expect(0, 917999, '\p{		UNKNOWN}', "");
    Expect(1, 917999, '\p{^		UNKNOWN}', "");
    Expect(1, 917999, '\P{		UNKNOWN}', "");
    Expect(0, 917999, '\P{^		UNKNOWN}', "");
    Error('\p{ IS_UNKNOWN:=}');
    Error('\P{ IS_UNKNOWN:=}');
    Expect(1, 918000, '\p{isunknown}', "");
    Expect(0, 918000, '\p{^isunknown}', "");
    Expect(0, 918000, '\P{isunknown}', "");
    Expect(1, 918000, '\P{^isunknown}', "");
    Expect(0, 917999, '\p{isunknown}', "");
    Expect(1, 917999, '\p{^isunknown}', "");
    Expect(1, 917999, '\P{isunknown}', "");
    Expect(0, 917999, '\P{^isunknown}', "");
    Expect(1, 918000, '\p{Is_Unknown}', "");
    Expect(0, 918000, '\p{^Is_Unknown}', "");
    Expect(0, 918000, '\P{Is_Unknown}', "");
    Expect(1, 918000, '\P{^Is_Unknown}', "");
    Expect(0, 917999, '\p{Is_Unknown}', "");
    Expect(1, 917999, '\p{^Is_Unknown}', "");
    Expect(1, 917999, '\P{Is_Unknown}', "");
    Expect(0, 917999, '\P{^Is_Unknown}', "");
    Error('\p{- ZZZZ/a/}');
    Error('\P{- ZZZZ/a/}');
    Expect(1, 918000, '\p{zzzz}', "");
    Expect(0, 918000, '\p{^zzzz}', "");
    Expect(0, 918000, '\P{zzzz}', "");
    Expect(1, 918000, '\P{^zzzz}', "");
    Expect(0, 917999, '\p{zzzz}', "");
    Expect(1, 917999, '\p{^zzzz}', "");
    Expect(1, 917999, '\P{zzzz}', "");
    Expect(0, 917999, '\P{^zzzz}', "");
    Expect(1, 918000, '\p{_-zzzz}', "");
    Expect(0, 918000, '\p{^_-zzzz}', "");
    Expect(0, 918000, '\P{_-zzzz}', "");
    Expect(1, 918000, '\P{^_-zzzz}', "");
    Expect(0, 917999, '\p{_-zzzz}', "");
    Expect(1, 917999, '\p{^_-zzzz}', "");
    Expect(1, 917999, '\P{_-zzzz}', "");
    Expect(0, 917999, '\P{^_-zzzz}', "");
    Error('\p{- is_Zzzz/a/}');
    Error('\P{- is_Zzzz/a/}');
    Expect(1, 918000, '\p{iszzzz}', "");
    Expect(0, 918000, '\p{^iszzzz}', "");
    Expect(0, 918000, '\P{iszzzz}', "");
    Expect(1, 918000, '\P{^iszzzz}', "");
    Expect(0, 917999, '\p{iszzzz}', "");
    Expect(1, 917999, '\p{^iszzzz}', "");
    Expect(1, 917999, '\P{iszzzz}', "");
    Expect(0, 917999, '\P{^iszzzz}', "");
    Expect(1, 918000, '\p{_IS_Zzzz}', "");
    Expect(0, 918000, '\p{^_IS_Zzzz}', "");
    Expect(0, 918000, '\P{_IS_Zzzz}', "");
    Expect(1, 918000, '\P{^_IS_Zzzz}', "");
    Expect(0, 917999, '\p{_IS_Zzzz}', "");
    Expect(1, 917999, '\p{^_IS_Zzzz}', "");
    Expect(1, 917999, '\P{_IS_Zzzz}', "");
    Expect(0, 917999, '\P{^_IS_Zzzz}', "");
    Error('\p{:= -Uppercase_Letter}');
    Error('\P{:= -Uppercase_Letter}');
    Expect(1, 125217, '\p{uppercaseletter}', "");
    Expect(0, 125217, '\p{^uppercaseletter}', "");
    Expect(0, 125217, '\P{uppercaseletter}', "");
    Expect(1, 125217, '\P{^uppercaseletter}', "");
    Expect(0, 125218, '\p{uppercaseletter}', "");
    Expect(1, 125218, '\p{^uppercaseletter}', "");
    Expect(1, 125218, '\P{uppercaseletter}', "");
    Expect(0, 125218, '\P{^uppercaseletter}', "");
    Expect(1, 125217, '\p{-Uppercase_letter}', "");
    Expect(0, 125217, '\p{^-Uppercase_letter}', "");
    Expect(0, 125217, '\P{-Uppercase_letter}', "");
    Expect(1, 125217, '\P{^-Uppercase_letter}', "");
    Expect(0, 125218, '\p{-Uppercase_letter}', "");
    Expect(1, 125218, '\p{^-Uppercase_letter}', "");
    Expect(1, 125218, '\P{-Uppercase_letter}', "");
    Expect(0, 125218, '\P{^-Uppercase_letter}', "");
    Error('\p{__Is_Uppercase_LETTER/a/}');
    Error('\P{__Is_Uppercase_LETTER/a/}');
    Expect(1, 125217, '\p{isuppercaseletter}', "");
    Expect(0, 125217, '\p{^isuppercaseletter}', "");
    Expect(0, 125217, '\P{isuppercaseletter}', "");
    Expect(1, 125217, '\P{^isuppercaseletter}', "");
    Expect(0, 125218, '\p{isuppercaseletter}', "");
    Expect(1, 125218, '\p{^isuppercaseletter}', "");
    Expect(1, 125218, '\P{isuppercaseletter}', "");
    Expect(0, 125218, '\P{^isuppercaseletter}', "");
    Expect(1, 125217, '\p{-_Is_Uppercase_LETTER}', "");
    Expect(0, 125217, '\p{^-_Is_Uppercase_LETTER}', "");
    Expect(0, 125217, '\P{-_Is_Uppercase_LETTER}', "");
    Expect(1, 125217, '\P{^-_Is_Uppercase_LETTER}', "");
    Expect(0, 125218, '\p{-_Is_Uppercase_LETTER}', "");
    Expect(1, 125218, '\p{^-_Is_Uppercase_LETTER}', "");
    Expect(1, 125218, '\P{-_Is_Uppercase_LETTER}', "");
    Expect(0, 125218, '\P{^-_Is_Uppercase_LETTER}', "");
    Error('\p{ /a/lu}');
    Error('\P{ /a/lu}');
    Expect(1, 125217, '\p{lu}', "");
    Expect(0, 125217, '\p{^lu}', "");
    Expect(0, 125217, '\P{lu}', "");
    Expect(1, 125217, '\P{^lu}', "");
    Expect(0, 125218, '\p{lu}', "");
    Expect(1, 125218, '\p{^lu}', "");
    Expect(1, 125218, '\P{lu}', "");
    Expect(0, 125218, '\P{^lu}', "");
    Expect(1, 125217, '\p{-	Lu}', "");
    Expect(0, 125217, '\p{^-	Lu}', "");
    Expect(0, 125217, '\P{-	Lu}', "");
    Expect(1, 125217, '\P{^-	Lu}', "");
    Expect(0, 125218, '\p{-	Lu}', "");
    Expect(1, 125218, '\p{^-	Lu}', "");
    Expect(1, 125218, '\P{-	Lu}', "");
    Expect(0, 125218, '\P{^-	Lu}', "");
    Error('\p{/a/	-Is_Lu}');
    Error('\P{/a/	-Is_Lu}');
    Expect(1, 125217, '\p{islu}', "");
    Expect(0, 125217, '\p{^islu}', "");
    Expect(0, 125217, '\P{islu}', "");
    Expect(1, 125217, '\P{^islu}', "");
    Expect(0, 125218, '\p{islu}', "");
    Expect(1, 125218, '\p{^islu}', "");
    Expect(1, 125218, '\P{islu}', "");
    Expect(0, 125218, '\P{^islu}', "");
    Expect(1, 125217, '\p{	-Is_LU}', "");
    Expect(0, 125217, '\p{^	-Is_LU}', "");
    Expect(0, 125217, '\P{	-Is_LU}', "");
    Expect(1, 125217, '\P{^	-Is_LU}', "");
    Expect(0, 125218, '\p{	-Is_LU}', "");
    Expect(1, 125218, '\p{^	-Is_LU}', "");
    Expect(1, 125218, '\P{	-Is_LU}', "");
    Expect(0, 125218, '\P{^	-Is_LU}', "");
    Error('\p{_ Vai/a/}');
    Error('\P{_ Vai/a/}');
    Expect(1, 42539, '\p{vai}', "");
    Expect(0, 42539, '\p{^vai}', "");
    Expect(0, 42539, '\P{vai}', "");
    Expect(1, 42539, '\P{^vai}', "");
    Expect(0, 42540, '\p{vai}', "");
    Expect(1, 42540, '\p{^vai}', "");
    Expect(1, 42540, '\P{vai}', "");
    Expect(0, 42540, '\P{^vai}', "");
    Expect(1, 42539, '\p{_	Vai}', "");
    Expect(0, 42539, '\p{^_	Vai}', "");
    Expect(0, 42539, '\P{_	Vai}', "");
    Expect(1, 42539, '\P{^_	Vai}', "");
    Expect(0, 42540, '\p{_	Vai}', "");
    Expect(1, 42540, '\p{^_	Vai}', "");
    Expect(1, 42540, '\P{_	Vai}', "");
    Expect(0, 42540, '\P{^_	Vai}', "");
    Error('\p{-/a/Is_Vai}');
    Error('\P{-/a/Is_Vai}');
    Expect(1, 42539, '\p{isvai}', "");
    Expect(0, 42539, '\p{^isvai}', "");
    Expect(0, 42539, '\P{isvai}', "");
    Expect(1, 42539, '\P{^isvai}', "");
    Expect(0, 42540, '\p{isvai}', "");
    Expect(1, 42540, '\p{^isvai}', "");
    Expect(1, 42540, '\P{isvai}', "");
    Expect(0, 42540, '\P{^isvai}', "");
    Expect(1, 42539, '\p{	_IS_Vai}', "");
    Expect(0, 42539, '\p{^	_IS_Vai}', "");
    Expect(0, 42539, '\P{	_IS_Vai}', "");
    Expect(1, 42539, '\P{^	_IS_Vai}', "");
    Expect(0, 42540, '\p{	_IS_Vai}', "");
    Expect(1, 42540, '\p{^	_IS_Vai}', "");
    Expect(1, 42540, '\P{	_IS_Vai}', "");
    Expect(0, 42540, '\P{^	_IS_Vai}', "");
    Error('\p{ Vaii/a/}');
    Error('\P{ Vaii/a/}');
    Expect(1, 42539, '\p{vaii}', "");
    Expect(0, 42539, '\p{^vaii}', "");
    Expect(0, 42539, '\P{vaii}', "");
    Expect(1, 42539, '\P{^vaii}', "");
    Expect(0, 42540, '\p{vaii}', "");
    Expect(1, 42540, '\p{^vaii}', "");
    Expect(1, 42540, '\P{vaii}', "");
    Expect(0, 42540, '\P{^vaii}', "");
    Expect(1, 42539, '\p{_	VAII}', "");
    Expect(0, 42539, '\p{^_	VAII}', "");
    Expect(0, 42539, '\P{_	VAII}', "");
    Expect(1, 42539, '\P{^_	VAII}', "");
    Expect(0, 42540, '\p{_	VAII}', "");
    Expect(1, 42540, '\p{^_	VAII}', "");
    Expect(1, 42540, '\P{_	VAII}', "");
    Expect(0, 42540, '\P{^_	VAII}', "");
    Error('\p{_is_vaii/a/}');
    Error('\P{_is_vaii/a/}');
    Expect(1, 42539, '\p{isvaii}', "");
    Expect(0, 42539, '\p{^isvaii}', "");
    Expect(0, 42539, '\P{isvaii}', "");
    Expect(1, 42539, '\P{^isvaii}', "");
    Expect(0, 42540, '\p{isvaii}', "");
    Expect(1, 42540, '\p{^isvaii}', "");
    Expect(1, 42540, '\P{isvaii}', "");
    Expect(0, 42540, '\P{^isvaii}', "");
    Expect(1, 42539, '\p{- Is_vaii}', "");
    Expect(0, 42539, '\p{^- Is_vaii}', "");
    Expect(0, 42539, '\P{- Is_vaii}', "");
    Expect(1, 42539, '\P{^- Is_vaii}', "");
    Expect(0, 42540, '\p{- Is_vaii}', "");
    Expect(1, 42540, '\p{^- Is_vaii}', "");
    Expect(1, 42540, '\P{- Is_vaii}', "");
    Expect(0, 42540, '\P{^- Is_vaii}', "");
    Error('\p{	:=variation_selector}');
    Error('\P{	:=variation_selector}');
    Expect(1, 917999, '\p{variationselector}', "");
    Expect(0, 917999, '\p{^variationselector}', "");
    Expect(0, 917999, '\P{variationselector}', "");
    Expect(1, 917999, '\P{^variationselector}', "");
    Expect(0, 918000, '\p{variationselector}', "");
    Expect(1, 918000, '\p{^variationselector}', "");
    Expect(1, 918000, '\P{variationselector}', "");
    Expect(0, 918000, '\P{^variationselector}', "");
    Expect(1, 917999, '\p{ 	variation_SELECTOR}', "");
    Expect(0, 917999, '\p{^ 	variation_SELECTOR}', "");
    Expect(0, 917999, '\P{ 	variation_SELECTOR}', "");
    Expect(1, 917999, '\P{^ 	variation_SELECTOR}', "");
    Expect(0, 918000, '\p{ 	variation_SELECTOR}', "");
    Expect(1, 918000, '\p{^ 	variation_SELECTOR}', "");
    Expect(1, 918000, '\P{ 	variation_SELECTOR}', "");
    Expect(0, 918000, '\P{^ 	variation_SELECTOR}', "");
    Error('\p{_:=Is_Variation_SELECTOR}');
    Error('\P{_:=Is_Variation_SELECTOR}');
    Expect(1, 917999, '\p{isvariationselector}', "");
    Expect(0, 917999, '\p{^isvariationselector}', "");
    Expect(0, 917999, '\P{isvariationselector}', "");
    Expect(1, 917999, '\P{^isvariationselector}', "");
    Expect(0, 918000, '\p{isvariationselector}', "");
    Expect(1, 918000, '\p{^isvariationselector}', "");
    Expect(1, 918000, '\P{isvariationselector}', "");
    Expect(0, 918000, '\P{^isvariationselector}', "");
    Expect(1, 917999, '\p{ _is_variation_selector}', "");
    Expect(0, 917999, '\p{^ _is_variation_selector}', "");
    Expect(0, 917999, '\P{ _is_variation_selector}', "");
    Expect(1, 917999, '\P{^ _is_variation_selector}', "");
    Expect(0, 918000, '\p{ _is_variation_selector}', "");
    Expect(1, 918000, '\p{^ _is_variation_selector}', "");
    Expect(1, 918000, '\P{ _is_variation_selector}', "");
    Expect(0, 918000, '\P{^ _is_variation_selector}', "");
    Error('\p{/a/-_VS}');
    Error('\P{/a/-_VS}');
    Expect(1, 917999, '\p{vs}', "");
    Expect(0, 917999, '\p{^vs}', "");
    Expect(0, 917999, '\P{vs}', "");
    Expect(1, 917999, '\P{^vs}', "");
    Expect(0, 918000, '\p{vs}', "");
    Expect(1, 918000, '\p{^vs}', "");
    Expect(1, 918000, '\P{vs}', "");
    Expect(0, 918000, '\P{^vs}', "");
    Expect(1, 917999, '\p{-_vs}', "");
    Expect(0, 917999, '\p{^-_vs}', "");
    Expect(0, 917999, '\P{-_vs}', "");
    Expect(1, 917999, '\P{^-_vs}', "");
    Expect(0, 918000, '\p{-_vs}', "");
    Expect(1, 918000, '\p{^-_vs}', "");
    Expect(1, 918000, '\P{-_vs}', "");
    Expect(0, 918000, '\P{^-_vs}', "");
    Error('\p{	IS_VS:=}');
    Error('\P{	IS_VS:=}');
    Expect(1, 917999, '\p{isvs}', "");
    Expect(0, 917999, '\p{^isvs}', "");
    Expect(0, 917999, '\P{isvs}', "");
    Expect(1, 917999, '\P{^isvs}', "");
    Expect(0, 918000, '\p{isvs}', "");
    Expect(1, 918000, '\p{^isvs}', "");
    Expect(1, 918000, '\P{isvs}', "");
    Expect(0, 918000, '\P{^isvs}', "");
    Expect(1, 917999, '\p{IS_VS}', "");
    Expect(0, 917999, '\p{^IS_VS}', "");
    Expect(0, 917999, '\P{IS_VS}', "");
    Expect(1, 917999, '\P{^IS_VS}', "");
    Expect(0, 918000, '\p{IS_VS}', "");
    Expect(1, 918000, '\p{^IS_VS}', "");
    Expect(1, 918000, '\P{IS_VS}', "");
    Expect(0, 918000, '\P{^IS_VS}', "");
    Error('\p{ 	VARIATION_selectors/a/}');
    Error('\P{ 	VARIATION_selectors/a/}');
    Expect(1, 65039, '\p{variationselectors}', "");
    Expect(0, 65039, '\p{^variationselectors}', "");
    Expect(0, 65039, '\P{variationselectors}', "");
    Expect(1, 65039, '\P{^variationselectors}', "");
    Expect(0, 65040, '\p{variationselectors}', "");
    Expect(1, 65040, '\p{^variationselectors}', "");
    Expect(1, 65040, '\P{variationselectors}', "");
    Expect(0, 65040, '\P{^variationselectors}', "");
    Expect(1, 65039, '\p{  Variation_Selectors}', "");
    Expect(0, 65039, '\p{^  Variation_Selectors}', "");
    Expect(0, 65039, '\P{  Variation_Selectors}', "");
    Expect(1, 65039, '\P{^  Variation_Selectors}', "");
    Expect(0, 65040, '\p{  Variation_Selectors}', "");
    Expect(1, 65040, '\p{^  Variation_Selectors}', "");
    Expect(1, 65040, '\P{  Variation_Selectors}', "");
    Expect(0, 65040, '\P{^  Variation_Selectors}', "");
    Error('\p{	/a/Is_Variation_Selectors}');
    Error('\P{	/a/Is_Variation_Selectors}');
    Expect(1, 65039, '\p{isvariationselectors}', "");
    Expect(0, 65039, '\p{^isvariationselectors}', "");
    Expect(0, 65039, '\P{isvariationselectors}', "");
    Expect(1, 65039, '\P{^isvariationselectors}', "");
    Expect(0, 65040, '\p{isvariationselectors}', "");
    Expect(1, 65040, '\p{^isvariationselectors}', "");
    Expect(1, 65040, '\P{isvariationselectors}', "");
    Expect(0, 65040, '\P{^isvariationselectors}', "");
    Expect(1, 65039, '\p{ 	Is_variation_Selectors}', "");
    Expect(0, 65039, '\p{^ 	Is_variation_Selectors}', "");
    Expect(0, 65039, '\P{ 	Is_variation_Selectors}', "");
    Expect(1, 65039, '\P{^ 	Is_variation_Selectors}', "");
    Expect(0, 65040, '\p{ 	Is_variation_Selectors}', "");
    Expect(1, 65040, '\p{^ 	Is_variation_Selectors}', "");
    Expect(1, 65040, '\P{ 	Is_variation_Selectors}', "");
    Expect(0, 65040, '\P{^ 	Is_variation_Selectors}', "");
    Error('\p{:= -in_variation_Selectors}');
    Error('\P{:= -in_variation_Selectors}');
    Expect(1, 65039, '\p{invariationselectors}', "");
    Expect(0, 65039, '\p{^invariationselectors}', "");
    Expect(0, 65039, '\P{invariationselectors}', "");
    Expect(1, 65039, '\P{^invariationselectors}', "");
    Expect(0, 65040, '\p{invariationselectors}', "");
    Expect(1, 65040, '\p{^invariationselectors}', "");
    Expect(1, 65040, '\P{invariationselectors}', "");
    Expect(0, 65040, '\P{^invariationselectors}', "");
    Expect(1, 65039, '\p{	_IN_Variation_SELECTORS}', "");
    Expect(0, 65039, '\p{^	_IN_Variation_SELECTORS}', "");
    Expect(0, 65039, '\P{	_IN_Variation_SELECTORS}', "");
    Expect(1, 65039, '\P{^	_IN_Variation_SELECTORS}', "");
    Expect(0, 65040, '\p{	_IN_Variation_SELECTORS}', "");
    Expect(1, 65040, '\p{^	_IN_Variation_SELECTORS}', "");
    Expect(1, 65040, '\P{	_IN_Variation_SELECTORS}', "");
    Expect(0, 65040, '\P{^	_IN_Variation_SELECTORS}', "");
    Error('\p{/a/-In_VS}');
    Error('\P{/a/-In_VS}');
    Expect(1, 65039, '\p{invs}', "");
    Expect(0, 65039, '\p{^invs}', "");
    Expect(0, 65039, '\P{invs}', "");
    Expect(1, 65039, '\P{^invs}', "");
    Expect(0, 65040, '\p{invs}', "");
    Expect(1, 65040, '\p{^invs}', "");
    Expect(1, 65040, '\P{invs}', "");
    Expect(0, 65040, '\P{^invs}', "");
    Expect(1, 65039, '\p{	IN_VS}', "");
    Expect(0, 65039, '\p{^	IN_VS}', "");
    Expect(0, 65039, '\P{	IN_VS}', "");
    Expect(1, 65039, '\P{^	IN_VS}', "");
    Expect(0, 65040, '\p{	IN_VS}', "");
    Expect(1, 65040, '\p{^	IN_VS}', "");
    Expect(1, 65040, '\P{	IN_VS}', "");
    Expect(0, 65040, '\P{^	IN_VS}', "");
    Error('\p{-:=VARIATION_Selectors_SUPPLEMENT}');
    Error('\P{-:=VARIATION_Selectors_SUPPLEMENT}');
    Expect(1, 917999, '\p{variationselectorssupplement}', "");
    Expect(0, 917999, '\p{^variationselectorssupplement}', "");
    Expect(0, 917999, '\P{variationselectorssupplement}', "");
    Expect(1, 917999, '\P{^variationselectorssupplement}', "");
    Expect(0, 918000, '\p{variationselectorssupplement}', "");
    Expect(1, 918000, '\p{^variationselectorssupplement}', "");
    Expect(1, 918000, '\P{variationselectorssupplement}', "");
    Expect(0, 918000, '\P{^variationselectorssupplement}', "");
    Expect(1, 917999, '\p{	 Variation_Selectors_Supplement}', "");
    Expect(0, 917999, '\p{^	 Variation_Selectors_Supplement}', "");
    Expect(0, 917999, '\P{	 Variation_Selectors_Supplement}', "");
    Expect(1, 917999, '\P{^	 Variation_Selectors_Supplement}', "");
    Expect(0, 918000, '\p{	 Variation_Selectors_Supplement}', "");
    Expect(1, 918000, '\p{^	 Variation_Selectors_Supplement}', "");
    Expect(1, 918000, '\P{	 Variation_Selectors_Supplement}', "");
    Expect(0, 918000, '\P{^	 Variation_Selectors_Supplement}', "");
    Error('\p{ _Is_VARIATION_Selectors_SUPPLEMENT/a/}');
    Error('\P{ _Is_VARIATION_Selectors_SUPPLEMENT/a/}');
    Expect(1, 917999, '\p{isvariationselectorssupplement}', "");
    Expect(0, 917999, '\p{^isvariationselectorssupplement}', "");
    Expect(0, 917999, '\P{isvariationselectorssupplement}', "");
    Expect(1, 917999, '\P{^isvariationselectorssupplement}', "");
    Expect(0, 918000, '\p{isvariationselectorssupplement}', "");
    Expect(1, 918000, '\p{^isvariationselectorssupplement}', "");
    Expect(1, 918000, '\P{isvariationselectorssupplement}', "");
    Expect(0, 918000, '\P{^isvariationselectorssupplement}', "");
    Expect(1, 917999, '\p{-Is_variation_selectors_SUPPLEMENT}', "");
    Expect(0, 917999, '\p{^-Is_variation_selectors_SUPPLEMENT}', "");
    Expect(0, 917999, '\P{-Is_variation_selectors_SUPPLEMENT}', "");
    Expect(1, 917999, '\P{^-Is_variation_selectors_SUPPLEMENT}', "");
    Expect(0, 918000, '\p{-Is_variation_selectors_SUPPLEMENT}', "");
    Expect(1, 918000, '\p{^-Is_variation_selectors_SUPPLEMENT}', "");
    Expect(1, 918000, '\P{-Is_variation_selectors_SUPPLEMENT}', "");
    Expect(0, 918000, '\P{^-Is_variation_selectors_SUPPLEMENT}', "");
    Error('\p{/a/in_VARIATION_SELECTORS_Supplement}');
    Error('\P{/a/in_VARIATION_SELECTORS_Supplement}');
    Expect(1, 917999, '\p{invariationselectorssupplement}', "");
    Expect(0, 917999, '\p{^invariationselectorssupplement}', "");
    Expect(0, 917999, '\P{invariationselectorssupplement}', "");
    Expect(1, 917999, '\P{^invariationselectorssupplement}', "");
    Expect(0, 918000, '\p{invariationselectorssupplement}', "");
    Expect(1, 918000, '\p{^invariationselectorssupplement}', "");
    Expect(1, 918000, '\P{invariationselectorssupplement}', "");
    Expect(0, 918000, '\P{^invariationselectorssupplement}', "");
    Expect(1, 917999, '\p{-	IN_Variation_Selectors_SUPPLEMENT}', "");
    Expect(0, 917999, '\p{^-	IN_Variation_Selectors_SUPPLEMENT}', "");
    Expect(0, 917999, '\P{-	IN_Variation_Selectors_SUPPLEMENT}', "");
    Expect(1, 917999, '\P{^-	IN_Variation_Selectors_SUPPLEMENT}', "");
    Expect(0, 918000, '\p{-	IN_Variation_Selectors_SUPPLEMENT}', "");
    Expect(1, 918000, '\p{^-	IN_Variation_Selectors_SUPPLEMENT}', "");
    Expect(1, 918000, '\P{-	IN_Variation_Selectors_SUPPLEMENT}', "");
    Expect(0, 918000, '\P{^-	IN_Variation_Selectors_SUPPLEMENT}', "");
    Error('\p{:= vs_SUP}');
    Error('\P{:= vs_SUP}');
    Expect(1, 917999, '\p{vssup}', "");
    Expect(0, 917999, '\p{^vssup}', "");
    Expect(0, 917999, '\P{vssup}', "");
    Expect(1, 917999, '\P{^vssup}', "");
    Expect(0, 918000, '\p{vssup}', "");
    Expect(1, 918000, '\p{^vssup}', "");
    Expect(1, 918000, '\P{vssup}', "");
    Expect(0, 918000, '\P{^vssup}', "");
    Expect(1, 917999, '\p{-VS_SUP}', "");
    Expect(0, 917999, '\p{^-VS_SUP}', "");
    Expect(0, 917999, '\P{-VS_SUP}', "");
    Expect(1, 917999, '\P{^-VS_SUP}', "");
    Expect(0, 918000, '\p{-VS_SUP}', "");
    Expect(1, 918000, '\p{^-VS_SUP}', "");
    Expect(1, 918000, '\P{-VS_SUP}', "");
    Expect(0, 918000, '\P{^-VS_SUP}', "");
    Error('\p{	:=is_VS_Sup}');
    Error('\P{	:=is_VS_Sup}');
    Expect(1, 917999, '\p{isvssup}', "");
    Expect(0, 917999, '\p{^isvssup}', "");
    Expect(0, 917999, '\P{isvssup}', "");
    Expect(1, 917999, '\P{^isvssup}', "");
    Expect(0, 918000, '\p{isvssup}', "");
    Expect(1, 918000, '\p{^isvssup}', "");
    Expect(1, 918000, '\P{isvssup}', "");
    Expect(0, 918000, '\P{^isvssup}', "");
    Expect(1, 917999, '\p{	_Is_VS_Sup}', "");
    Expect(0, 917999, '\p{^	_Is_VS_Sup}', "");
    Expect(0, 917999, '\P{	_Is_VS_Sup}', "");
    Expect(1, 917999, '\P{^	_Is_VS_Sup}', "");
    Expect(0, 918000, '\p{	_Is_VS_Sup}', "");
    Expect(1, 918000, '\p{^	_Is_VS_Sup}', "");
    Expect(1, 918000, '\P{	_Is_VS_Sup}', "");
    Expect(0, 918000, '\P{^	_Is_VS_Sup}', "");
    Error('\p{ :=in_VS_SUP}');
    Error('\P{ :=in_VS_SUP}');
    Expect(1, 917999, '\p{invssup}', "");
    Expect(0, 917999, '\p{^invssup}', "");
    Expect(0, 917999, '\P{invssup}', "");
    Expect(1, 917999, '\P{^invssup}', "");
    Expect(0, 918000, '\p{invssup}', "");
    Expect(1, 918000, '\p{^invssup}', "");
    Expect(1, 918000, '\P{invssup}', "");
    Expect(0, 918000, '\P{^invssup}', "");
    Expect(1, 917999, '\p{	_In_VS_SUP}', "");
    Expect(0, 917999, '\p{^	_In_VS_SUP}', "");
    Expect(0, 917999, '\P{	_In_VS_SUP}', "");
    Expect(1, 917999, '\P{^	_In_VS_SUP}', "");
    Expect(0, 918000, '\p{	_In_VS_SUP}', "");
    Expect(1, 918000, '\p{^	_In_VS_SUP}', "");
    Expect(1, 918000, '\P{	_In_VS_SUP}', "");
    Expect(0, 918000, '\P{^	_In_VS_SUP}', "");
    Error('\p{/a/  VEDIC_extensions}');
    Error('\P{/a/  VEDIC_extensions}');
    Expect(1, 7423, '\p{vedicextensions}', "");
    Expect(0, 7423, '\p{^vedicextensions}', "");
    Expect(0, 7423, '\P{vedicextensions}', "");
    Expect(1, 7423, '\P{^vedicextensions}', "");
    Expect(0, 7424, '\p{vedicextensions}', "");
    Expect(1, 7424, '\p{^vedicextensions}', "");
    Expect(1, 7424, '\P{vedicextensions}', "");
    Expect(0, 7424, '\P{^vedicextensions}', "");
    Expect(1, 7423, '\p{--VEDIC_extensions}', "");
    Expect(0, 7423, '\p{^--VEDIC_extensions}', "");
    Expect(0, 7423, '\P{--VEDIC_extensions}', "");
    Expect(1, 7423, '\P{^--VEDIC_extensions}', "");
    Expect(0, 7424, '\p{--VEDIC_extensions}', "");
    Expect(1, 7424, '\p{^--VEDIC_extensions}', "");
    Expect(1, 7424, '\P{--VEDIC_extensions}', "");
    Expect(0, 7424, '\P{^--VEDIC_extensions}', "");
    Error('\p{-is_Vedic_Extensions:=}');
    Error('\P{-is_Vedic_Extensions:=}');
    Expect(1, 7423, '\p{isvedicextensions}', "");
    Expect(0, 7423, '\p{^isvedicextensions}', "");
    Expect(0, 7423, '\P{isvedicextensions}', "");
    Expect(1, 7423, '\P{^isvedicextensions}', "");
    Expect(0, 7424, '\p{isvedicextensions}', "");
    Expect(1, 7424, '\p{^isvedicextensions}', "");
    Expect(1, 7424, '\P{isvedicextensions}', "");
    Expect(0, 7424, '\P{^isvedicextensions}', "");
    Expect(1, 7423, '\p{--Is_VEDIC_Extensions}', "");
    Expect(0, 7423, '\p{^--Is_VEDIC_Extensions}', "");
    Expect(0, 7423, '\P{--Is_VEDIC_Extensions}', "");
    Expect(1, 7423, '\P{^--Is_VEDIC_Extensions}', "");
    Expect(0, 7424, '\p{--Is_VEDIC_Extensions}', "");
    Expect(1, 7424, '\p{^--Is_VEDIC_Extensions}', "");
    Expect(1, 7424, '\P{--Is_VEDIC_Extensions}', "");
    Expect(0, 7424, '\P{^--Is_VEDIC_Extensions}', "");
    Error('\p{ /a/In_Vedic_Extensions}');
    Error('\P{ /a/In_Vedic_Extensions}');
    Expect(1, 7423, '\p{invedicextensions}', "");
    Expect(0, 7423, '\p{^invedicextensions}', "");
    Expect(0, 7423, '\P{invedicextensions}', "");
    Expect(1, 7423, '\P{^invedicextensions}', "");
    Expect(0, 7424, '\p{invedicextensions}', "");
    Expect(1, 7424, '\p{^invedicextensions}', "");
    Expect(1, 7424, '\P{invedicextensions}', "");
    Expect(0, 7424, '\P{^invedicextensions}', "");
    Expect(1, 7423, '\p{	 IN_Vedic_Extensions}', "");
    Expect(0, 7423, '\p{^	 IN_Vedic_Extensions}', "");
    Expect(0, 7423, '\P{	 IN_Vedic_Extensions}', "");
    Expect(1, 7423, '\P{^	 IN_Vedic_Extensions}', "");
    Expect(0, 7424, '\p{	 IN_Vedic_Extensions}', "");
    Expect(1, 7424, '\p{^	 IN_Vedic_Extensions}', "");
    Expect(1, 7424, '\P{	 IN_Vedic_Extensions}', "");
    Expect(0, 7424, '\P{^	 IN_Vedic_Extensions}', "");
    Error('\p{	:=VEDIC_EXT}');
    Error('\P{	:=VEDIC_EXT}');
    Expect(1, 7423, '\p{vedicext}', "");
    Expect(0, 7423, '\p{^vedicext}', "");
    Expect(0, 7423, '\P{vedicext}', "");
    Expect(1, 7423, '\P{^vedicext}', "");
    Expect(0, 7424, '\p{vedicext}', "");
    Expect(1, 7424, '\p{^vedicext}', "");
    Expect(1, 7424, '\P{vedicext}', "");
    Expect(0, 7424, '\P{^vedicext}', "");
    Expect(1, 7423, '\p{	_vedic_Ext}', "");
    Expect(0, 7423, '\p{^	_vedic_Ext}', "");
    Expect(0, 7423, '\P{	_vedic_Ext}', "");
    Expect(1, 7423, '\P{^	_vedic_Ext}', "");
    Expect(0, 7424, '\p{	_vedic_Ext}', "");
    Expect(1, 7424, '\p{^	_vedic_Ext}', "");
    Expect(1, 7424, '\P{	_vedic_Ext}', "");
    Expect(0, 7424, '\P{^	_vedic_Ext}', "");
    Error('\p{ :=Is_VEDIC_Ext}');
    Error('\P{ :=Is_VEDIC_Ext}');
    Expect(1, 7423, '\p{isvedicext}', "");
    Expect(0, 7423, '\p{^isvedicext}', "");
    Expect(0, 7423, '\P{isvedicext}', "");
    Expect(1, 7423, '\P{^isvedicext}', "");
    Expect(0, 7424, '\p{isvedicext}', "");
    Expect(1, 7424, '\p{^isvedicext}', "");
    Expect(1, 7424, '\P{isvedicext}', "");
    Expect(0, 7424, '\P{^isvedicext}', "");
    Expect(1, 7423, '\p{	Is_vedic_Ext}', "");
    Expect(0, 7423, '\p{^	Is_vedic_Ext}', "");
    Expect(0, 7423, '\P{	Is_vedic_Ext}', "");
    Expect(1, 7423, '\P{^	Is_vedic_Ext}', "");
    Expect(0, 7424, '\p{	Is_vedic_Ext}', "");
    Expect(1, 7424, '\p{^	Is_vedic_Ext}', "");
    Expect(1, 7424, '\P{	Is_vedic_Ext}', "");
    Expect(0, 7424, '\P{^	Is_vedic_Ext}', "");
    Error('\p{/a/IN_vedic_ext}');
    Error('\P{/a/IN_vedic_ext}');
    Expect(1, 7423, '\p{invedicext}', "");
    Expect(0, 7423, '\p{^invedicext}', "");
    Expect(0, 7423, '\P{invedicext}', "");
    Expect(1, 7423, '\P{^invedicext}', "");
    Expect(0, 7424, '\p{invedicext}', "");
    Expect(1, 7424, '\p{^invedicext}', "");
    Expect(1, 7424, '\P{invedicext}', "");
    Expect(0, 7424, '\P{^invedicext}', "");
    Expect(1, 7423, '\p{  IN_Vedic_Ext}', "");
    Expect(0, 7423, '\p{^  IN_Vedic_Ext}', "");
    Expect(0, 7423, '\P{  IN_Vedic_Ext}', "");
    Expect(1, 7423, '\P{^  IN_Vedic_Ext}', "");
    Expect(0, 7424, '\p{  IN_Vedic_Ext}', "");
    Expect(1, 7424, '\p{^  IN_Vedic_Ext}', "");
    Expect(1, 7424, '\P{  IN_Vedic_Ext}', "");
    Expect(0, 7424, '\P{^  IN_Vedic_Ext}', "");
    Error('\p{_:=VERTICAL_Forms}');
    Error('\P{_:=VERTICAL_Forms}');
    Expect(1, 65055, '\p{verticalforms}', "");
    Expect(0, 65055, '\p{^verticalforms}', "");
    Expect(0, 65055, '\P{verticalforms}', "");
    Expect(1, 65055, '\P{^verticalforms}', "");
    Expect(0, 65056, '\p{verticalforms}', "");
    Expect(1, 65056, '\p{^verticalforms}', "");
    Expect(1, 65056, '\P{verticalforms}', "");
    Expect(0, 65056, '\P{^verticalforms}', "");
    Expect(1, 65055, '\p{	-vertical_Forms}', "");
    Expect(0, 65055, '\p{^	-vertical_Forms}', "");
    Expect(0, 65055, '\P{	-vertical_Forms}', "");
    Expect(1, 65055, '\P{^	-vertical_Forms}', "");
    Expect(0, 65056, '\p{	-vertical_Forms}', "");
    Expect(1, 65056, '\p{^	-vertical_Forms}', "");
    Expect(1, 65056, '\P{	-vertical_Forms}', "");
    Expect(0, 65056, '\P{^	-vertical_Forms}', "");
    Error('\p{:=--is_Vertical_Forms}');
    Error('\P{:=--is_Vertical_Forms}');
    Expect(1, 65055, '\p{isverticalforms}', "");
    Expect(0, 65055, '\p{^isverticalforms}', "");
    Expect(0, 65055, '\P{isverticalforms}', "");
    Expect(1, 65055, '\P{^isverticalforms}', "");
    Expect(0, 65056, '\p{isverticalforms}', "");
    Expect(1, 65056, '\p{^isverticalforms}', "");
    Expect(1, 65056, '\P{isverticalforms}', "");
    Expect(0, 65056, '\P{^isverticalforms}', "");
    Expect(1, 65055, '\p{	 Is_VERTICAL_forms}', "");
    Expect(0, 65055, '\p{^	 Is_VERTICAL_forms}', "");
    Expect(0, 65055, '\P{	 Is_VERTICAL_forms}', "");
    Expect(1, 65055, '\P{^	 Is_VERTICAL_forms}', "");
    Expect(0, 65056, '\p{	 Is_VERTICAL_forms}', "");
    Expect(1, 65056, '\p{^	 Is_VERTICAL_forms}', "");
    Expect(1, 65056, '\P{	 Is_VERTICAL_forms}', "");
    Expect(0, 65056, '\P{^	 Is_VERTICAL_forms}', "");
    Error('\p{-:=In_Vertical_forms}');
    Error('\P{-:=In_Vertical_forms}');
    Expect(1, 65055, '\p{inverticalforms}', "");
    Expect(0, 65055, '\p{^inverticalforms}', "");
    Expect(0, 65055, '\P{inverticalforms}', "");
    Expect(1, 65055, '\P{^inverticalforms}', "");
    Expect(0, 65056, '\p{inverticalforms}', "");
    Expect(1, 65056, '\p{^inverticalforms}', "");
    Expect(1, 65056, '\P{inverticalforms}', "");
    Expect(0, 65056, '\P{^inverticalforms}', "");
    Expect(1, 65055, '\p{_IN_Vertical_forms}', "");
    Expect(0, 65055, '\p{^_IN_Vertical_forms}', "");
    Expect(0, 65055, '\P{_IN_Vertical_forms}', "");
    Expect(1, 65055, '\P{^_IN_Vertical_forms}', "");
    Expect(0, 65056, '\p{_IN_Vertical_forms}', "");
    Expect(1, 65056, '\p{^_IN_Vertical_forms}', "");
    Expect(1, 65056, '\P{_IN_Vertical_forms}', "");
    Expect(0, 65056, '\P{^_IN_Vertical_forms}', "");
    Error('\p{:=VertSpace}');
    Error('\P{:=VertSpace}');
    Expect(1, 8233, '\p{vertspace}', "");
    Expect(0, 8233, '\p{^vertspace}', "");
    Expect(0, 8233, '\P{vertspace}', "");
    Expect(1, 8233, '\P{^vertspace}', "");
    Expect(0, 8234, '\p{vertspace}', "");
    Expect(1, 8234, '\p{^vertspace}', "");
    Expect(1, 8234, '\P{vertspace}', "");
    Expect(0, 8234, '\P{^vertspace}', "");
    Expect(1, 8233, '\p{_ VertSpace}', "");
    Expect(0, 8233, '\p{^_ VertSpace}', "");
    Expect(0, 8233, '\P{_ VertSpace}', "");
    Expect(1, 8233, '\P{^_ VertSpace}', "");
    Expect(0, 8234, '\p{_ VertSpace}', "");
    Expect(1, 8234, '\p{^_ VertSpace}', "");
    Expect(1, 8234, '\P{_ VertSpace}', "");
    Expect(0, 8234, '\P{^_ VertSpace}', "");
    Error('\p{/a/ IS_VertSpace}');
    Error('\P{/a/ IS_VertSpace}');
    Expect(1, 8233, '\p{isvertspace}', "");
    Expect(0, 8233, '\p{^isvertspace}', "");
    Expect(0, 8233, '\P{isvertspace}', "");
    Expect(1, 8233, '\P{^isvertspace}', "");
    Expect(0, 8234, '\p{isvertspace}', "");
    Expect(1, 8234, '\p{^isvertspace}', "");
    Expect(1, 8234, '\P{isvertspace}', "");
    Expect(0, 8234, '\P{^isvertspace}', "");
    Expect(1, 8233, '\p{ _IS_vertspace}', "");
    Expect(0, 8233, '\p{^ _IS_vertspace}', "");
    Expect(0, 8233, '\P{ _IS_vertspace}', "");
    Expect(1, 8233, '\P{^ _IS_vertspace}', "");
    Expect(0, 8234, '\p{ _IS_vertspace}', "");
    Expect(1, 8234, '\p{^ _IS_vertspace}', "");
    Expect(1, 8234, '\P{ _IS_vertspace}', "");
    Expect(0, 8234, '\P{^ _IS_vertspace}', "");
    Error('\p{/a/	-Wancho}');
    Error('\P{/a/	-Wancho}');
    Expect(1, 123647, '\p{wancho}', "");
    Expect(0, 123647, '\p{^wancho}', "");
    Expect(0, 123647, '\P{wancho}', "");
    Expect(1, 123647, '\P{^wancho}', "");
    Expect(0, 123648, '\p{wancho}', "");
    Expect(1, 123648, '\p{^wancho}', "");
    Expect(1, 123648, '\P{wancho}', "");
    Expect(0, 123648, '\P{^wancho}', "");
    Expect(1, 123647, '\p{	-WANCHO}', "");
    Expect(0, 123647, '\p{^	-WANCHO}', "");
    Expect(0, 123647, '\P{	-WANCHO}', "");
    Expect(1, 123647, '\P{^	-WANCHO}', "");
    Expect(0, 123648, '\p{	-WANCHO}', "");
    Expect(1, 123648, '\p{^	-WANCHO}', "");
    Expect(1, 123648, '\P{	-WANCHO}', "");
    Expect(0, 123648, '\P{^	-WANCHO}', "");
    Error('\p{	:=is_Wancho}');
    Error('\P{	:=is_Wancho}');
    Expect(1, 123647, '\p{iswancho}', "");
    Expect(0, 123647, '\p{^iswancho}', "");
    Expect(0, 123647, '\P{iswancho}', "");
    Expect(1, 123647, '\P{^iswancho}', "");
    Expect(0, 123648, '\p{iswancho}', "");
    Expect(1, 123648, '\p{^iswancho}', "");
    Expect(1, 123648, '\P{iswancho}', "");
    Expect(0, 123648, '\P{^iswancho}', "");
    Expect(1, 123647, '\p{-Is_wancho}', "");
    Expect(0, 123647, '\p{^-Is_wancho}', "");
    Expect(0, 123647, '\P{-Is_wancho}', "");
    Expect(1, 123647, '\P{^-Is_wancho}', "");
    Expect(0, 123648, '\p{-Is_wancho}', "");
    Expect(1, 123648, '\p{^-Is_wancho}', "");
    Expect(1, 123648, '\P{-Is_wancho}', "");
    Expect(0, 123648, '\P{^-Is_wancho}', "");
    Error('\p{_/a/Wcho}');
    Error('\P{_/a/Wcho}');
    Expect(1, 123647, '\p{wcho}', "");
    Expect(0, 123647, '\p{^wcho}', "");
    Expect(0, 123647, '\P{wcho}', "");
    Expect(1, 123647, '\P{^wcho}', "");
    Expect(0, 123648, '\p{wcho}', "");
    Expect(1, 123648, '\p{^wcho}', "");
    Expect(1, 123648, '\P{wcho}', "");
    Expect(0, 123648, '\P{^wcho}', "");
    Expect(1, 123647, '\p{	wcho}', "");
    Expect(0, 123647, '\p{^	wcho}', "");
    Expect(0, 123647, '\P{	wcho}', "");
    Expect(1, 123647, '\P{^	wcho}', "");
    Expect(0, 123648, '\p{	wcho}', "");
    Expect(1, 123648, '\p{^	wcho}', "");
    Expect(1, 123648, '\P{	wcho}', "");
    Expect(0, 123648, '\P{^	wcho}', "");
    Error('\p{-	is_Wcho:=}');
    Error('\P{-	is_Wcho:=}');
    Expect(1, 123647, '\p{iswcho}', "");
    Expect(0, 123647, '\p{^iswcho}', "");
    Expect(0, 123647, '\P{iswcho}', "");
    Expect(1, 123647, '\P{^iswcho}', "");
    Expect(0, 123648, '\p{iswcho}', "");
    Expect(1, 123648, '\p{^iswcho}', "");
    Expect(1, 123648, '\P{iswcho}', "");
    Expect(0, 123648, '\P{^iswcho}', "");
    Expect(1, 123647, '\p{		Is_Wcho}', "");
    Expect(0, 123647, '\p{^		Is_Wcho}', "");
    Expect(0, 123647, '\P{		Is_Wcho}', "");
    Expect(1, 123647, '\P{^		Is_Wcho}', "");
    Expect(0, 123648, '\p{		Is_Wcho}', "");
    Expect(1, 123648, '\p{^		Is_Wcho}', "");
    Expect(1, 123648, '\P{		Is_Wcho}', "");
    Expect(0, 123648, '\P{^		Is_Wcho}', "");
    Error('\p{_:=Warang_Citi}');
    Error('\P{_:=Warang_Citi}');
    Expect(1, 71935, '\p{warangciti}', "");
    Expect(0, 71935, '\p{^warangciti}', "");
    Expect(0, 71935, '\P{warangciti}', "");
    Expect(1, 71935, '\P{^warangciti}', "");
    Expect(0, 71936, '\p{warangciti}', "");
    Expect(1, 71936, '\p{^warangciti}', "");
    Expect(1, 71936, '\P{warangciti}', "");
    Expect(0, 71936, '\P{^warangciti}', "");
    Expect(1, 71935, '\p{-Warang_citi}', "");
    Expect(0, 71935, '\p{^-Warang_citi}', "");
    Expect(0, 71935, '\P{-Warang_citi}', "");
    Expect(1, 71935, '\P{^-Warang_citi}', "");
    Expect(0, 71936, '\p{-Warang_citi}', "");
    Expect(1, 71936, '\p{^-Warang_citi}', "");
    Expect(1, 71936, '\P{-Warang_citi}', "");
    Expect(0, 71936, '\P{^-Warang_citi}', "");
    Error('\p{/a/ IS_WARANG_Citi}');
    Error('\P{/a/ IS_WARANG_Citi}');
    Expect(1, 71935, '\p{iswarangciti}', "");
    Expect(0, 71935, '\p{^iswarangciti}', "");
    Expect(0, 71935, '\P{iswarangciti}', "");
    Expect(1, 71935, '\P{^iswarangciti}', "");
    Expect(0, 71936, '\p{iswarangciti}', "");
    Expect(1, 71936, '\p{^iswarangciti}', "");
    Expect(1, 71936, '\P{iswarangciti}', "");
    Expect(0, 71936, '\P{^iswarangciti}', "");
    Expect(1, 71935, '\p{	_Is_WARANG_Citi}', "");
    Expect(0, 71935, '\p{^	_Is_WARANG_Citi}', "");
    Expect(0, 71935, '\P{	_Is_WARANG_Citi}', "");
    Expect(1, 71935, '\P{^	_Is_WARANG_Citi}', "");
    Expect(0, 71936, '\p{	_Is_WARANG_Citi}', "");
    Expect(1, 71936, '\p{^	_Is_WARANG_Citi}', "");
    Expect(1, 71936, '\P{	_Is_WARANG_Citi}', "");
    Expect(0, 71936, '\P{^	_Is_WARANG_Citi}', "");
    Error('\p{ :=WARA}');
    Error('\P{ :=WARA}');
    Expect(1, 71935, '\p{wara}', "");
    Expect(0, 71935, '\p{^wara}', "");
    Expect(0, 71935, '\P{wara}', "");
    Expect(1, 71935, '\P{^wara}', "");
    Expect(0, 71936, '\p{wara}', "");
    Expect(1, 71936, '\p{^wara}', "");
    Expect(1, 71936, '\P{wara}', "");
    Expect(0, 71936, '\P{^wara}', "");
    Expect(1, 71935, '\p{	wara}', "");
    Expect(0, 71935, '\p{^	wara}', "");
    Expect(0, 71935, '\P{	wara}', "");
    Expect(1, 71935, '\P{^	wara}', "");
    Expect(0, 71936, '\p{	wara}', "");
    Expect(1, 71936, '\p{^	wara}', "");
    Expect(1, 71936, '\P{	wara}', "");
    Expect(0, 71936, '\P{^	wara}', "");
    Error('\p{:=- Is_Wara}');
    Error('\P{:=- Is_Wara}');
    Expect(1, 71935, '\p{iswara}', "");
    Expect(0, 71935, '\p{^iswara}', "");
    Expect(0, 71935, '\P{iswara}', "");
    Expect(1, 71935, '\P{^iswara}', "");
    Expect(0, 71936, '\p{iswara}', "");
    Expect(1, 71936, '\p{^iswara}', "");
    Expect(1, 71936, '\P{iswara}', "");
    Expect(0, 71936, '\P{^iswara}', "");
    Expect(1, 71935, '\p{-	is_Wara}', "");
    Expect(0, 71935, '\p{^-	is_Wara}', "");
    Expect(0, 71935, '\P{-	is_Wara}', "");
    Expect(1, 71935, '\P{^-	is_Wara}', "");
    Expect(0, 71936, '\p{-	is_Wara}', "");
    Expect(1, 71936, '\p{^-	is_Wara}', "");
    Expect(1, 71936, '\P{-	is_Wara}', "");
    Expect(0, 71936, '\P{^-	is_Wara}', "");
    Error('\p{ white_Space:=}');
    Error('\P{ white_Space:=}');
    Expect(1, 12288, '\p{whitespace}', "");
    Expect(0, 12288, '\p{^whitespace}', "");
    Expect(0, 12288, '\P{whitespace}', "");
    Expect(1, 12288, '\P{^whitespace}', "");
    Expect(0, 12289, '\p{whitespace}', "");
    Expect(1, 12289, '\p{^whitespace}', "");
    Expect(1, 12289, '\P{whitespace}', "");
    Expect(0, 12289, '\P{^whitespace}', "");
    Expect(1, 12288, '\p{-	White_Space}', "");
    Expect(0, 12288, '\p{^-	White_Space}', "");
    Expect(0, 12288, '\P{-	White_Space}', "");
    Expect(1, 12288, '\P{^-	White_Space}', "");
    Expect(0, 12289, '\p{-	White_Space}', "");
    Expect(1, 12289, '\p{^-	White_Space}', "");
    Expect(1, 12289, '\P{-	White_Space}', "");
    Expect(0, 12289, '\P{^-	White_Space}', "");
    Error('\p{/a/--Is_White_Space}');
    Error('\P{/a/--Is_White_Space}');
    Expect(1, 12288, '\p{iswhitespace}', "");
    Expect(0, 12288, '\p{^iswhitespace}', "");
    Expect(0, 12288, '\P{iswhitespace}', "");
    Expect(1, 12288, '\P{^iswhitespace}', "");
    Expect(0, 12289, '\p{iswhitespace}', "");
    Expect(1, 12289, '\p{^iswhitespace}', "");
    Expect(1, 12289, '\P{iswhitespace}', "");
    Expect(0, 12289, '\P{^iswhitespace}', "");
    Expect(1, 12288, '\p{		Is_white_Space}', "");
    Expect(0, 12288, '\p{^		Is_white_Space}', "");
    Expect(0, 12288, '\P{		Is_white_Space}', "");
    Expect(1, 12288, '\P{^		Is_white_Space}', "");
    Expect(0, 12289, '\p{		Is_white_Space}', "");
    Expect(1, 12289, '\p{^		Is_white_Space}', "");
    Expect(1, 12289, '\P{		Is_white_Space}', "");
    Expect(0, 12289, '\P{^		Is_white_Space}', "");
    Error('\p{:=WSPACE}');
    Error('\P{:=WSPACE}');
    Expect(1, 12288, '\p{wspace}', "");
    Expect(0, 12288, '\p{^wspace}', "");
    Expect(0, 12288, '\P{wspace}', "");
    Expect(1, 12288, '\P{^wspace}', "");
    Expect(0, 12289, '\p{wspace}', "");
    Expect(1, 12289, '\p{^wspace}', "");
    Expect(1, 12289, '\P{wspace}', "");
    Expect(0, 12289, '\P{^wspace}', "");
    Expect(1, 12288, '\p{	 wspace}', "");
    Expect(0, 12288, '\p{^	 wspace}', "");
    Expect(0, 12288, '\P{	 wspace}', "");
    Expect(1, 12288, '\P{^	 wspace}', "");
    Expect(0, 12289, '\p{	 wspace}', "");
    Expect(1, 12289, '\p{^	 wspace}', "");
    Expect(1, 12289, '\P{	 wspace}', "");
    Expect(0, 12289, '\P{^	 wspace}', "");
    Error('\p{/a/	-IS_WSpace}');
    Error('\P{/a/	-IS_WSpace}');
    Expect(1, 12288, '\p{iswspace}', "");
    Expect(0, 12288, '\p{^iswspace}', "");
    Expect(0, 12288, '\P{iswspace}', "");
    Expect(1, 12288, '\P{^iswspace}', "");
    Expect(0, 12289, '\p{iswspace}', "");
    Expect(1, 12289, '\p{^iswspace}', "");
    Expect(1, 12289, '\P{iswspace}', "");
    Expect(0, 12289, '\P{^iswspace}', "");
    Expect(1, 12288, '\p{_-Is_WSpace}', "");
    Expect(0, 12288, '\p{^_-Is_WSpace}', "");
    Expect(0, 12288, '\P{_-Is_WSpace}', "");
    Expect(1, 12288, '\P{^_-Is_WSpace}', "");
    Expect(0, 12289, '\p{_-Is_WSpace}', "");
    Expect(1, 12289, '\p{^_-Is_WSpace}', "");
    Expect(1, 12289, '\P{_-Is_WSpace}', "");
    Expect(0, 12289, '\P{^_-Is_WSpace}', "");
    Error('\p{	 Space/a/}');
    Error('\P{	 Space/a/}');
    Expect(1, 12288, '\p{space}', "");
    Expect(0, 12288, '\p{^space}', "");
    Expect(0, 12288, '\P{space}', "");
    Expect(1, 12288, '\P{^space}', "");
    Expect(0, 12289, '\p{space}', "");
    Expect(1, 12289, '\p{^space}', "");
    Expect(1, 12289, '\P{space}', "");
    Expect(0, 12289, '\P{^space}', "");
    Expect(1, 12288, '\p{  Space}', "");
    Expect(0, 12288, '\p{^  Space}', "");
    Expect(0, 12288, '\P{  Space}', "");
    Expect(1, 12288, '\P{^  Space}', "");
    Expect(0, 12289, '\p{  Space}', "");
    Expect(1, 12289, '\p{^  Space}', "");
    Expect(1, 12289, '\P{  Space}', "");
    Expect(0, 12289, '\P{^  Space}', "");
    Error('\p{_/a/is_SPACE}');
    Error('\P{_/a/is_SPACE}');
    Expect(1, 12288, '\p{isspace}', "");
    Expect(0, 12288, '\p{^isspace}', "");
    Expect(0, 12288, '\P{isspace}', "");
    Expect(1, 12288, '\P{^isspace}', "");
    Expect(0, 12289, '\p{isspace}', "");
    Expect(1, 12289, '\p{^isspace}', "");
    Expect(1, 12289, '\P{isspace}', "");
    Expect(0, 12289, '\P{^isspace}', "");
    Expect(1, 12288, '\p{-_is_SPACE}', "");
    Expect(0, 12288, '\p{^-_is_SPACE}', "");
    Expect(0, 12288, '\P{-_is_SPACE}', "");
    Expect(1, 12288, '\P{^-_is_SPACE}', "");
    Expect(0, 12289, '\p{-_is_SPACE}', "");
    Expect(1, 12289, '\p{^-_is_SPACE}', "");
    Expect(1, 12289, '\P{-_is_SPACE}', "");
    Expect(0, 12289, '\P{^-_is_SPACE}', "");
    Error('\p{ :=XPosixWord}');
    Error('\P{ :=XPosixWord}');
    Expect(1, 917999, '\p{xposixword}', "");
    Expect(0, 917999, '\p{^xposixword}', "");
    Expect(0, 917999, '\P{xposixword}', "");
    Expect(1, 917999, '\P{^xposixword}', "");
    Expect(0, 918000, '\p{xposixword}', "");
    Expect(1, 918000, '\p{^xposixword}', "");
    Expect(1, 918000, '\P{xposixword}', "");
    Expect(0, 918000, '\P{^xposixword}', "");
    Expect(1, 917999, '\p{_ XPosixWord}', "");
    Expect(0, 917999, '\p{^_ XPosixWord}', "");
    Expect(0, 917999, '\P{_ XPosixWord}', "");
    Expect(1, 917999, '\P{^_ XPosixWord}', "");
    Expect(0, 918000, '\p{_ XPosixWord}', "");
    Expect(1, 918000, '\p{^_ XPosixWord}', "");
    Expect(1, 918000, '\P{_ XPosixWord}', "");
    Expect(0, 918000, '\P{^_ XPosixWord}', "");
    Error('\p{-:=WORD}');
    Error('\P{-:=WORD}');
    Expect(1, 917999, '\p{word}', "");
    Expect(0, 917999, '\p{^word}', "");
    Expect(0, 917999, '\P{word}', "");
    Expect(1, 917999, '\P{^word}', "");
    Expect(0, 918000, '\p{word}', "");
    Expect(1, 918000, '\p{^word}', "");
    Expect(1, 918000, '\P{word}', "");
    Expect(0, 918000, '\P{^word}', "");
    Expect(1, 917999, '\p{ 	word}', "");
    Expect(0, 917999, '\p{^ 	word}', "");
    Expect(0, 917999, '\P{ 	word}', "");
    Expect(1, 917999, '\P{^ 	word}', "");
    Expect(0, 918000, '\p{ 	word}', "");
    Expect(1, 918000, '\p{^ 	word}', "");
    Expect(1, 918000, '\P{ 	word}', "");
    Expect(0, 918000, '\P{^ 	word}', "");
    Error('\p{_/a/is_XPosixWord}');
    Error('\P{_/a/is_XPosixWord}');
    Expect(1, 917999, '\p{isxposixword}', "");
    Expect(0, 917999, '\p{^isxposixword}', "");
    Expect(0, 917999, '\P{isxposixword}', "");
    Expect(1, 917999, '\P{^isxposixword}', "");
    Expect(0, 918000, '\p{isxposixword}', "");
    Expect(1, 918000, '\p{^isxposixword}', "");
    Expect(1, 918000, '\P{isxposixword}', "");
    Expect(0, 918000, '\P{^isxposixword}', "");
    Expect(1, 917999, '\p{		Is_XPOSIXWORD}', "");
    Expect(0, 917999, '\p{^		Is_XPOSIXWORD}', "");
    Expect(0, 917999, '\P{		Is_XPOSIXWORD}', "");
    Expect(1, 917999, '\P{^		Is_XPOSIXWORD}', "");
    Expect(0, 918000, '\p{		Is_XPOSIXWORD}', "");
    Expect(1, 918000, '\p{^		Is_XPOSIXWORD}', "");
    Expect(1, 918000, '\P{		Is_XPOSIXWORD}', "");
    Expect(0, 918000, '\P{^		Is_XPOSIXWORD}', "");
    Error('\p{/a/ Is_Word}');
    Error('\P{/a/ Is_Word}');
    Expect(1, 917999, '\p{isword}', "");
    Expect(0, 917999, '\p{^isword}', "");
    Expect(0, 917999, '\P{isword}', "");
    Expect(1, 917999, '\P{^isword}', "");
    Expect(0, 918000, '\p{isword}', "");
    Expect(1, 918000, '\p{^isword}', "");
    Expect(1, 918000, '\P{isword}', "");
    Expect(0, 918000, '\P{^isword}', "");
    Expect(1, 917999, '\p{	 is_Word}', "");
    Expect(0, 917999, '\p{^	 is_Word}', "");
    Expect(0, 917999, '\P{	 is_Word}', "");
    Expect(1, 917999, '\P{^	 is_Word}', "");
    Expect(0, 918000, '\p{	 is_Word}', "");
    Expect(1, 918000, '\p{^	 is_Word}', "");
    Expect(1, 918000, '\P{	 is_Word}', "");
    Expect(0, 918000, '\P{^	 is_Word}', "");
    Error('\p{ :=xposixxdigit}');
    Error('\P{ :=xposixxdigit}');
    Expect(1, 65350, '\p{xposixxdigit}', "");
    Expect(0, 65350, '\p{^xposixxdigit}', "");
    Expect(0, 65350, '\P{xposixxdigit}', "");
    Expect(1, 65350, '\P{^xposixxdigit}', "");
    Expect(0, 65351, '\p{xposixxdigit}', "");
    Expect(1, 65351, '\p{^xposixxdigit}', "");
    Expect(1, 65351, '\P{xposixxdigit}', "");
    Expect(0, 65351, '\P{^xposixxdigit}', "");
    Expect(1, 65350, '\p{ _XPosixXDigit}', "");
    Expect(0, 65350, '\p{^ _XPosixXDigit}', "");
    Expect(0, 65350, '\P{ _XPosixXDigit}', "");
    Expect(1, 65350, '\P{^ _XPosixXDigit}', "");
    Expect(0, 65351, '\p{ _XPosixXDigit}', "");
    Expect(1, 65351, '\p{^ _XPosixXDigit}', "");
    Expect(1, 65351, '\P{ _XPosixXDigit}', "");
    Expect(0, 65351, '\P{^ _XPosixXDigit}', "");
    Error('\p{/a/--XDigit}');
    Error('\P{/a/--XDigit}');
    Expect(1, 65350, '\p{xdigit}', "");
    Expect(0, 65350, '\p{^xdigit}', "");
    Expect(0, 65350, '\P{xdigit}', "");
    Expect(1, 65350, '\P{^xdigit}', "");
    Expect(0, 65351, '\p{xdigit}', "");
    Expect(1, 65351, '\p{^xdigit}', "");
    Expect(1, 65351, '\P{xdigit}', "");
    Expect(0, 65351, '\P{^xdigit}', "");
    Expect(1, 65350, '\p{_ xdigit}', "");
    Expect(0, 65350, '\p{^_ xdigit}', "");
    Expect(0, 65350, '\P{_ xdigit}', "");
    Expect(1, 65350, '\P{^_ xdigit}', "");
    Expect(0, 65351, '\p{_ xdigit}', "");
    Expect(1, 65351, '\p{^_ xdigit}', "");
    Expect(1, 65351, '\P{_ xdigit}', "");
    Expect(0, 65351, '\P{^_ xdigit}', "");
    Error('\p{/a/ 	Is_XPosixXDigit}');
    Error('\P{/a/ 	Is_XPosixXDigit}');
    Expect(1, 65350, '\p{isxposixxdigit}', "");
    Expect(0, 65350, '\p{^isxposixxdigit}', "");
    Expect(0, 65350, '\P{isxposixxdigit}', "");
    Expect(1, 65350, '\P{^isxposixxdigit}', "");
    Expect(0, 65351, '\p{isxposixxdigit}', "");
    Expect(1, 65351, '\p{^isxposixxdigit}', "");
    Expect(1, 65351, '\P{isxposixxdigit}', "");
    Expect(0, 65351, '\P{^isxposixxdigit}', "");
    Expect(1, 65350, '\p{	is_XPosixXDigit}', "");
    Expect(0, 65350, '\p{^	is_XPosixXDigit}', "");
    Expect(0, 65350, '\P{	is_XPosixXDigit}', "");
    Expect(1, 65350, '\P{^	is_XPosixXDigit}', "");
    Expect(0, 65351, '\p{	is_XPosixXDigit}', "");
    Expect(1, 65351, '\p{^	is_XPosixXDigit}', "");
    Expect(1, 65351, '\P{	is_XPosixXDigit}', "");
    Expect(0, 65351, '\P{^	is_XPosixXDigit}', "");
    Error('\p{_IS_XDigit:=}');
    Error('\P{_IS_XDigit:=}');
    Expect(1, 65350, '\p{isxdigit}', "");
    Expect(0, 65350, '\p{^isxdigit}', "");
    Expect(0, 65350, '\P{isxdigit}', "");
    Expect(1, 65350, '\P{^isxdigit}', "");
    Expect(0, 65351, '\p{isxdigit}', "");
    Expect(1, 65351, '\p{^isxdigit}', "");
    Expect(1, 65351, '\P{isxdigit}', "");
    Expect(0, 65351, '\P{^isxdigit}', "");
    Expect(1, 65350, '\p{_	IS_XDigit}', "");
    Expect(0, 65350, '\p{^_	IS_XDigit}', "");
    Expect(0, 65350, '\P{_	IS_XDigit}', "");
    Expect(1, 65350, '\P{^_	IS_XDigit}', "");
    Expect(0, 65351, '\p{_	IS_XDigit}', "");
    Expect(1, 65351, '\p{^_	IS_XDigit}', "");
    Expect(1, 65351, '\P{_	IS_XDigit}', "");
    Expect(0, 65351, '\P{^_	IS_XDigit}', "");
    Error('\p{:=	_Hex_digit}');
    Error('\P{:=	_Hex_digit}');
    Expect(1, 65350, '\p{hexdigit}', "");
    Expect(0, 65350, '\p{^hexdigit}', "");
    Expect(0, 65350, '\P{hexdigit}', "");
    Expect(1, 65350, '\P{^hexdigit}', "");
    Expect(0, 65351, '\p{hexdigit}', "");
    Expect(1, 65351, '\p{^hexdigit}', "");
    Expect(1, 65351, '\P{hexdigit}', "");
    Expect(0, 65351, '\P{^hexdigit}', "");
    Expect(1, 65350, '\p{_HEX_Digit}', "");
    Expect(0, 65350, '\p{^_HEX_Digit}', "");
    Expect(0, 65350, '\P{_HEX_Digit}', "");
    Expect(1, 65350, '\P{^_HEX_Digit}', "");
    Expect(0, 65351, '\p{_HEX_Digit}', "");
    Expect(1, 65351, '\p{^_HEX_Digit}', "");
    Expect(1, 65351, '\P{_HEX_Digit}', "");
    Expect(0, 65351, '\P{^_HEX_Digit}', "");
    Error('\p{:=-	Is_Hex_Digit}');
    Error('\P{:=-	Is_Hex_Digit}');
    Expect(1, 65350, '\p{ishexdigit}', "");
    Expect(0, 65350, '\p{^ishexdigit}', "");
    Expect(0, 65350, '\P{ishexdigit}', "");
    Expect(1, 65350, '\P{^ishexdigit}', "");
    Expect(0, 65351, '\p{ishexdigit}', "");
    Expect(1, 65351, '\p{^ishexdigit}', "");
    Expect(1, 65351, '\P{ishexdigit}', "");
    Expect(0, 65351, '\P{^ishexdigit}', "");
    Expect(1, 65350, '\p{_-Is_Hex_digit}', "");
    Expect(0, 65350, '\p{^_-Is_Hex_digit}', "");
    Expect(0, 65350, '\P{_-Is_Hex_digit}', "");
    Expect(1, 65350, '\P{^_-Is_Hex_digit}', "");
    Expect(0, 65351, '\p{_-Is_Hex_digit}', "");
    Expect(1, 65351, '\p{^_-Is_Hex_digit}', "");
    Expect(1, 65351, '\P{_-Is_Hex_digit}', "");
    Expect(0, 65351, '\P{^_-Is_Hex_digit}', "");
    Error('\p{:=HEX}');
    Error('\P{:=HEX}');
    Expect(1, 65350, '\p{hex}', "");
    Expect(0, 65350, '\p{^hex}', "");
    Expect(0, 65350, '\P{hex}', "");
    Expect(1, 65350, '\P{^hex}', "");
    Expect(0, 65351, '\p{hex}', "");
    Expect(1, 65351, '\p{^hex}', "");
    Expect(1, 65351, '\P{hex}', "");
    Expect(0, 65351, '\P{^hex}', "");
    Expect(1, 65350, '\p{ Hex}', "");
    Expect(0, 65350, '\p{^ Hex}', "");
    Expect(0, 65350, '\P{ Hex}', "");
    Expect(1, 65350, '\P{^ Hex}', "");
    Expect(0, 65351, '\p{ Hex}', "");
    Expect(1, 65351, '\p{^ Hex}', "");
    Expect(1, 65351, '\P{ Hex}', "");
    Expect(0, 65351, '\P{^ Hex}', "");
    Error('\p{	IS_HEX/a/}');
    Error('\P{	IS_HEX/a/}');
    Expect(1, 65350, '\p{ishex}', "");
    Expect(0, 65350, '\p{^ishex}', "");
    Expect(0, 65350, '\P{ishex}', "");
    Expect(1, 65350, '\P{^ishex}', "");
    Expect(0, 65351, '\p{ishex}', "");
    Expect(1, 65351, '\p{^ishex}', "");
    Expect(1, 65351, '\P{ishex}', "");
    Expect(0, 65351, '\P{^ishex}', "");
    Expect(1, 65350, '\p{_is_hex}', "");
    Expect(0, 65350, '\p{^_is_hex}', "");
    Expect(0, 65350, '\P{_is_hex}', "");
    Expect(1, 65350, '\P{^_is_hex}', "");
    Expect(0, 65351, '\p{_is_hex}', "");
    Expect(1, 65351, '\p{^_is_hex}', "");
    Expect(1, 65351, '\P{_is_hex}', "");
    Expect(0, 65351, '\P{^_is_hex}', "");
    Error('\p{	 XID_CONTINUE:=}');
    Error('\P{	 XID_CONTINUE:=}');
    Expect(1, 917999, '\p{xidcontinue}', "");
    Expect(0, 917999, '\p{^xidcontinue}', "");
    Expect(0, 917999, '\P{xidcontinue}', "");
    Expect(1, 917999, '\P{^xidcontinue}', "");
    Expect(0, 918000, '\p{xidcontinue}', "");
    Expect(1, 918000, '\p{^xidcontinue}', "");
    Expect(1, 918000, '\P{xidcontinue}', "");
    Expect(0, 918000, '\P{^xidcontinue}', "");
    Expect(1, 917999, '\p{	 XID_CONTINUE}', "");
    Expect(0, 917999, '\p{^	 XID_CONTINUE}', "");
    Expect(0, 917999, '\P{	 XID_CONTINUE}', "");
    Expect(1, 917999, '\P{^	 XID_CONTINUE}', "");
    Expect(0, 918000, '\p{	 XID_CONTINUE}', "");
    Expect(1, 918000, '\p{^	 XID_CONTINUE}', "");
    Expect(1, 918000, '\P{	 XID_CONTINUE}', "");
    Expect(0, 918000, '\P{^	 XID_CONTINUE}', "");
    Error('\p{_/a/is_XID_CONTINUE}');
    Error('\P{_/a/is_XID_CONTINUE}');
    Expect(1, 917999, '\p{isxidcontinue}', "");
    Expect(0, 917999, '\p{^isxidcontinue}', "");
    Expect(0, 917999, '\P{isxidcontinue}', "");
    Expect(1, 917999, '\P{^isxidcontinue}', "");
    Expect(0, 918000, '\p{isxidcontinue}', "");
    Expect(1, 918000, '\p{^isxidcontinue}', "");
    Expect(1, 918000, '\P{isxidcontinue}', "");
    Expect(0, 918000, '\P{^isxidcontinue}', "");
    Expect(1, 917999, '\p{--IS_XID_CONTINUE}', "");
    Expect(0, 917999, '\p{^--IS_XID_CONTINUE}', "");
    Expect(0, 917999, '\P{--IS_XID_CONTINUE}', "");
    Expect(1, 917999, '\P{^--IS_XID_CONTINUE}', "");
    Expect(0, 918000, '\p{--IS_XID_CONTINUE}', "");
    Expect(1, 918000, '\p{^--IS_XID_CONTINUE}', "");
    Expect(1, 918000, '\P{--IS_XID_CONTINUE}', "");
    Expect(0, 918000, '\P{^--IS_XID_CONTINUE}', "");
    Error('\p{-:=xidc}');
    Error('\P{-:=xidc}');
    Expect(1, 917999, '\p{xidc}', "");
    Expect(0, 917999, '\p{^xidc}', "");
    Expect(0, 917999, '\P{xidc}', "");
    Expect(1, 917999, '\P{^xidc}', "");
    Expect(0, 918000, '\p{xidc}', "");
    Expect(1, 918000, '\p{^xidc}', "");
    Expect(1, 918000, '\P{xidc}', "");
    Expect(0, 918000, '\P{^xidc}', "");
    Expect(1, 917999, '\p{-xidc}', "");
    Expect(0, 917999, '\p{^-xidc}', "");
    Expect(0, 917999, '\P{-xidc}', "");
    Expect(1, 917999, '\P{^-xidc}', "");
    Expect(0, 918000, '\p{-xidc}', "");
    Expect(1, 918000, '\p{^-xidc}', "");
    Expect(1, 918000, '\P{-xidc}', "");
    Expect(0, 918000, '\P{^-xidc}', "");
    Error('\p{	 is_XIDC:=}');
    Error('\P{	 is_XIDC:=}');
    Expect(1, 917999, '\p{isxidc}', "");
    Expect(0, 917999, '\p{^isxidc}', "");
    Expect(0, 917999, '\P{isxidc}', "");
    Expect(1, 917999, '\P{^isxidc}', "");
    Expect(0, 918000, '\p{isxidc}', "");
    Expect(1, 918000, '\p{^isxidc}', "");
    Expect(1, 918000, '\P{isxidc}', "");
    Expect(0, 918000, '\P{^isxidc}', "");
    Expect(1, 917999, '\p{-Is_XIDC}', "");
    Expect(0, 917999, '\p{^-Is_XIDC}', "");
    Expect(0, 917999, '\P{-Is_XIDC}', "");
    Expect(1, 917999, '\P{^-Is_XIDC}', "");
    Expect(0, 918000, '\p{-Is_XIDC}', "");
    Expect(1, 918000, '\p{^-Is_XIDC}', "");
    Expect(1, 918000, '\P{-Is_XIDC}', "");
    Expect(0, 918000, '\P{^-Is_XIDC}', "");
    Error('\p{:=  XID_START}');
    Error('\P{:=  XID_START}');
    Expect(1, 201546, '\p{xidstart}', "");
    Expect(0, 201546, '\p{^xidstart}', "");
    Expect(0, 201546, '\P{xidstart}', "");
    Expect(1, 201546, '\P{^xidstart}', "");
    Expect(0, 201547, '\p{xidstart}', "");
    Expect(1, 201547, '\p{^xidstart}', "");
    Expect(1, 201547, '\P{xidstart}', "");
    Expect(0, 201547, '\P{^xidstart}', "");
    Expect(1, 201546, '\p{_ XID_START}', "");
    Expect(0, 201546, '\p{^_ XID_START}', "");
    Expect(0, 201546, '\P{_ XID_START}', "");
    Expect(1, 201546, '\P{^_ XID_START}', "");
    Expect(0, 201547, '\p{_ XID_START}', "");
    Expect(1, 201547, '\p{^_ XID_START}', "");
    Expect(1, 201547, '\P{_ XID_START}', "");
    Expect(0, 201547, '\P{^_ XID_START}', "");
    Error('\p{/a/-	Is_xid_Start}');
    Error('\P{/a/-	Is_xid_Start}');
    Expect(1, 201546, '\p{isxidstart}', "");
    Expect(0, 201546, '\p{^isxidstart}', "");
    Expect(0, 201546, '\P{isxidstart}', "");
    Expect(1, 201546, '\P{^isxidstart}', "");
    Expect(0, 201547, '\p{isxidstart}', "");
    Expect(1, 201547, '\p{^isxidstart}', "");
    Expect(1, 201547, '\P{isxidstart}', "");
    Expect(0, 201547, '\P{^isxidstart}', "");
    Expect(1, 201546, '\p{ Is_xid_Start}', "");
    Expect(0, 201546, '\p{^ Is_xid_Start}', "");
    Expect(0, 201546, '\P{ Is_xid_Start}', "");
    Expect(1, 201546, '\P{^ Is_xid_Start}', "");
    Expect(0, 201547, '\p{ Is_xid_Start}', "");
    Expect(1, 201547, '\p{^ Is_xid_Start}', "");
    Expect(1, 201547, '\P{ Is_xid_Start}', "");
    Expect(0, 201547, '\P{^ Is_xid_Start}', "");
    Error('\p{:= 	XIDS}');
    Error('\P{:= 	XIDS}');
    Expect(1, 201546, '\p{xids}', "");
    Expect(0, 201546, '\p{^xids}', "");
    Expect(0, 201546, '\P{xids}', "");
    Expect(1, 201546, '\P{^xids}', "");
    Expect(0, 201547, '\p{xids}', "");
    Expect(1, 201547, '\p{^xids}', "");
    Expect(1, 201547, '\P{xids}', "");
    Expect(0, 201547, '\P{^xids}', "");
    Expect(1, 201546, '\p{_-XIDS}', "");
    Expect(0, 201546, '\p{^_-XIDS}', "");
    Expect(0, 201546, '\P{_-XIDS}', "");
    Expect(1, 201546, '\P{^_-XIDS}', "");
    Expect(0, 201547, '\p{_-XIDS}', "");
    Expect(1, 201547, '\p{^_-XIDS}', "");
    Expect(1, 201547, '\P{_-XIDS}', "");
    Expect(0, 201547, '\P{^_-XIDS}', "");
    Error('\p{	IS_xids/a/}');
    Error('\P{	IS_xids/a/}');
    Expect(1, 201546, '\p{isxids}', "");
    Expect(0, 201546, '\p{^isxids}', "");
    Expect(0, 201546, '\P{isxids}', "");
    Expect(1, 201546, '\P{^isxids}', "");
    Expect(0, 201547, '\p{isxids}', "");
    Expect(1, 201547, '\p{^isxids}', "");
    Expect(1, 201547, '\P{isxids}', "");
    Expect(0, 201547, '\P{^isxids}', "");
    Expect(1, 201546, '\p{ 	is_XIDS}', "");
    Expect(0, 201546, '\p{^ 	is_XIDS}', "");
    Expect(0, 201546, '\P{ 	is_XIDS}', "");
    Expect(1, 201546, '\P{^ 	is_XIDS}', "");
    Expect(0, 201547, '\p{ 	is_XIDS}', "");
    Expect(1, 201547, '\p{^ 	is_XIDS}', "");
    Expect(1, 201547, '\P{ 	is_XIDS}', "");
    Expect(0, 201547, '\P{^ 	is_XIDS}', "");
    Error('\p{  XPosixAlpha/a/}');
    Error('\P{  XPosixAlpha/a/}');
    Expect(1, 201546, '\p{xposixalpha}', "");
    Expect(0, 201546, '\p{^xposixalpha}', "");
    Expect(0, 201546, '\P{xposixalpha}', "");
    Expect(1, 201546, '\P{^xposixalpha}', "");
    Expect(0, 201547, '\p{xposixalpha}', "");
    Expect(1, 201547, '\p{^xposixalpha}', "");
    Expect(1, 201547, '\P{xposixalpha}', "");
    Expect(0, 201547, '\P{^xposixalpha}', "");
    Expect(1, 201546, '\p{-	xposixalpha}', "");
    Expect(0, 201546, '\p{^-	xposixalpha}', "");
    Expect(0, 201546, '\P{-	xposixalpha}', "");
    Expect(1, 201546, '\P{^-	xposixalpha}', "");
    Expect(0, 201547, '\p{-	xposixalpha}', "");
    Expect(1, 201547, '\p{^-	xposixalpha}', "");
    Expect(1, 201547, '\P{-	xposixalpha}', "");
    Expect(0, 201547, '\P{^-	xposixalpha}', "");
    Error('\p{	_Is_XPOSIXALPHA/a/}');
    Error('\P{	_Is_XPOSIXALPHA/a/}');
    Expect(1, 201546, '\p{isxposixalpha}', "");
    Expect(0, 201546, '\p{^isxposixalpha}', "");
    Expect(0, 201546, '\P{isxposixalpha}', "");
    Expect(1, 201546, '\P{^isxposixalpha}', "");
    Expect(0, 201547, '\p{isxposixalpha}', "");
    Expect(1, 201547, '\p{^isxposixalpha}', "");
    Expect(1, 201547, '\P{isxposixalpha}', "");
    Expect(0, 201547, '\P{^isxposixalpha}', "");
    Expect(1, 201546, '\p{ -Is_XPOSIXALPHA}', "");
    Expect(0, 201546, '\p{^ -Is_XPOSIXALPHA}', "");
    Expect(0, 201546, '\P{ -Is_XPOSIXALPHA}', "");
    Expect(1, 201546, '\P{^ -Is_XPOSIXALPHA}', "");
    Expect(0, 201547, '\p{ -Is_XPOSIXALPHA}', "");
    Expect(1, 201547, '\p{^ -Is_XPOSIXALPHA}', "");
    Expect(1, 201547, '\P{ -Is_XPOSIXALPHA}', "");
    Expect(0, 201547, '\P{^ -Is_XPOSIXALPHA}', "");
    Error('\p{	_ALPHABETIC:=}');
    Error('\P{	_ALPHABETIC:=}');
    Expect(1, 201546, '\p{alphabetic}', "");
    Expect(0, 201546, '\p{^alphabetic}', "");
    Expect(0, 201546, '\P{alphabetic}', "");
    Expect(1, 201546, '\P{^alphabetic}', "");
    Expect(0, 201547, '\p{alphabetic}', "");
    Expect(1, 201547, '\p{^alphabetic}', "");
    Expect(1, 201547, '\P{alphabetic}', "");
    Expect(0, 201547, '\P{^alphabetic}', "");
    Expect(1, 201546, '\p{-ALPHABETIC}', "");
    Expect(0, 201546, '\p{^-ALPHABETIC}', "");
    Expect(0, 201546, '\P{-ALPHABETIC}', "");
    Expect(1, 201546, '\P{^-ALPHABETIC}', "");
    Expect(0, 201547, '\p{-ALPHABETIC}', "");
    Expect(1, 201547, '\p{^-ALPHABETIC}', "");
    Expect(1, 201547, '\P{-ALPHABETIC}', "");
    Expect(0, 201547, '\P{^-ALPHABETIC}', "");
    Error('\p{ Is_alphabetic/a/}');
    Error('\P{ Is_alphabetic/a/}');
    Expect(1, 201546, '\p{isalphabetic}', "");
    Expect(0, 201546, '\p{^isalphabetic}', "");
    Expect(0, 201546, '\P{isalphabetic}', "");
    Expect(1, 201546, '\P{^isalphabetic}', "");
    Expect(0, 201547, '\p{isalphabetic}', "");
    Expect(1, 201547, '\p{^isalphabetic}', "");
    Expect(1, 201547, '\P{isalphabetic}', "");
    Expect(0, 201547, '\P{^isalphabetic}', "");
    Expect(1, 201546, '\p{  Is_Alphabetic}', "");
    Expect(0, 201546, '\p{^  Is_Alphabetic}', "");
    Expect(0, 201546, '\P{  Is_Alphabetic}', "");
    Expect(1, 201546, '\P{^  Is_Alphabetic}', "");
    Expect(0, 201547, '\p{  Is_Alphabetic}', "");
    Expect(1, 201547, '\p{^  Is_Alphabetic}', "");
    Expect(1, 201547, '\P{  Is_Alphabetic}', "");
    Expect(0, 201547, '\P{^  Is_Alphabetic}', "");
    Error('\p{	/a/Alpha}');
    Error('\P{	/a/Alpha}');
    Expect(1, 201546, '\p{alpha}', "");
    Expect(0, 201546, '\p{^alpha}', "");
    Expect(0, 201546, '\P{alpha}', "");
    Expect(1, 201546, '\P{^alpha}', "");
    Expect(0, 201547, '\p{alpha}', "");
    Expect(1, 201547, '\p{^alpha}', "");
    Expect(1, 201547, '\P{alpha}', "");
    Expect(0, 201547, '\P{^alpha}', "");
    Expect(1, 201546, '\p{-_Alpha}', "");
    Expect(0, 201546, '\p{^-_Alpha}', "");
    Expect(0, 201546, '\P{-_Alpha}', "");
    Expect(1, 201546, '\P{^-_Alpha}', "");
    Expect(0, 201547, '\p{-_Alpha}', "");
    Expect(1, 201547, '\p{^-_Alpha}', "");
    Expect(1, 201547, '\P{-_Alpha}', "");
    Expect(0, 201547, '\P{^-_Alpha}', "");
    Error('\p{- is_ALPHA:=}');
    Error('\P{- is_ALPHA:=}');
    Expect(1, 201546, '\p{isalpha}', "");
    Expect(0, 201546, '\p{^isalpha}', "");
    Expect(0, 201546, '\P{isalpha}', "");
    Expect(1, 201546, '\P{^isalpha}', "");
    Expect(0, 201547, '\p{isalpha}', "");
    Expect(1, 201547, '\p{^isalpha}', "");
    Expect(1, 201547, '\P{isalpha}', "");
    Expect(0, 201547, '\P{^isalpha}', "");
    Expect(1, 201546, '\p{	_is_ALPHA}', "");
    Expect(0, 201546, '\p{^	_is_ALPHA}', "");
    Expect(0, 201546, '\P{	_is_ALPHA}', "");
    Expect(1, 201546, '\P{^	_is_ALPHA}', "");
    Expect(0, 201547, '\p{	_is_ALPHA}', "");
    Expect(1, 201547, '\p{^	_is_ALPHA}', "");
    Expect(1, 201547, '\P{	_is_ALPHA}', "");
    Expect(0, 201547, '\P{^	_is_ALPHA}', "");
    Error('\p{/a/ _XPOSIXLOWER}');
    Error('\P{/a/ _XPOSIXLOWER}');
    Expect(1, 125251, '\p{xposixlower}', "");
    Expect(0, 125251, '\p{^xposixlower}', "");
    Expect(0, 125251, '\P{xposixlower}', "");
    Expect(1, 125251, '\P{^xposixlower}', "");
    Expect(0, 125252, '\p{xposixlower}', "");
    Expect(1, 125252, '\p{^xposixlower}', "");
    Expect(1, 125252, '\P{xposixlower}', "");
    Expect(0, 125252, '\P{^xposixlower}', "");
    Expect(1, 125251, '\p{		XPOSIXLOWER}', "");
    Expect(0, 125251, '\p{^		XPOSIXLOWER}', "");
    Expect(0, 125251, '\P{		XPOSIXLOWER}', "");
    Expect(1, 125251, '\P{^		XPOSIXLOWER}', "");
    Expect(0, 125252, '\p{		XPOSIXLOWER}', "");
    Expect(1, 125252, '\p{^		XPOSIXLOWER}', "");
    Expect(1, 125252, '\P{		XPOSIXLOWER}', "");
    Expect(0, 125252, '\P{^		XPOSIXLOWER}', "");
    Error('\p{/a/	Is_XPosixLower}');
    Error('\P{/a/	Is_XPosixLower}');
    Expect(1, 125251, '\p{isxposixlower}', "");
    Expect(0, 125251, '\p{^isxposixlower}', "");
    Expect(0, 125251, '\P{isxposixlower}', "");
    Expect(1, 125251, '\P{^isxposixlower}', "");
    Expect(0, 125252, '\p{isxposixlower}', "");
    Expect(1, 125252, '\p{^isxposixlower}', "");
    Expect(1, 125252, '\P{isxposixlower}', "");
    Expect(0, 125252, '\P{^isxposixlower}', "");
    Expect(1, 125251, '\p{ IS_XPOSIXLOWER}', "");
    Expect(0, 125251, '\p{^ IS_XPOSIXLOWER}', "");
    Expect(0, 125251, '\P{ IS_XPOSIXLOWER}', "");
    Expect(1, 125251, '\P{^ IS_XPOSIXLOWER}', "");
    Expect(0, 125252, '\p{ IS_XPOSIXLOWER}', "");
    Expect(1, 125252, '\p{^ IS_XPOSIXLOWER}', "");
    Expect(1, 125252, '\P{ IS_XPOSIXLOWER}', "");
    Expect(0, 125252, '\P{^ IS_XPOSIXLOWER}', "");
    Error('\p{-	LOWERCASE/a/}');
    Error('\P{-	LOWERCASE/a/}');
    Expect(1, 125251, '\p{lowercase}', "");
    Expect(0, 125251, '\p{^lowercase}', "");
    Expect(0, 125251, '\P{lowercase}', "");
    Expect(1, 125251, '\P{^lowercase}', "");
    Expect(0, 125252, '\p{lowercase}', "");
    Expect(1, 125252, '\p{^lowercase}', "");
    Expect(1, 125252, '\P{lowercase}', "");
    Expect(0, 125252, '\P{^lowercase}', "");
    Expect(1, 125251, '\p{	Lowercase}', "");
    Expect(0, 125251, '\p{^	Lowercase}', "");
    Expect(0, 125251, '\P{	Lowercase}', "");
    Expect(1, 125251, '\P{^	Lowercase}', "");
    Expect(0, 125252, '\p{	Lowercase}', "");
    Expect(1, 125252, '\p{^	Lowercase}', "");
    Expect(1, 125252, '\P{	Lowercase}', "");
    Expect(0, 125252, '\P{^	Lowercase}', "");
    Error('\p{/a/Is_Lowercase}');
    Error('\P{/a/Is_Lowercase}');
    Expect(1, 125251, '\p{islowercase}', "");
    Expect(0, 125251, '\p{^islowercase}', "");
    Expect(0, 125251, '\P{islowercase}', "");
    Expect(1, 125251, '\P{^islowercase}', "");
    Expect(0, 125252, '\p{islowercase}', "");
    Expect(1, 125252, '\p{^islowercase}', "");
    Expect(1, 125252, '\P{islowercase}', "");
    Expect(0, 125252, '\P{^islowercase}', "");
    Expect(1, 125251, '\p{ -Is_Lowercase}', "");
    Expect(0, 125251, '\p{^ -Is_Lowercase}', "");
    Expect(0, 125251, '\P{ -Is_Lowercase}', "");
    Expect(1, 125251, '\P{^ -Is_Lowercase}', "");
    Expect(0, 125252, '\p{ -Is_Lowercase}', "");
    Expect(1, 125252, '\p{^ -Is_Lowercase}', "");
    Expect(1, 125252, '\P{ -Is_Lowercase}', "");
    Expect(0, 125252, '\P{^ -Is_Lowercase}', "");
    Error('\p{/a/lower}');
    Error('\P{/a/lower}');
    Expect(1, 125251, '\p{lower}', "");
    Expect(0, 125251, '\p{^lower}', "");
    Expect(0, 125251, '\P{lower}', "");
    Expect(1, 125251, '\P{^lower}', "");
    Expect(0, 125252, '\p{lower}', "");
    Expect(1, 125252, '\p{^lower}', "");
    Expect(1, 125252, '\P{lower}', "");
    Expect(0, 125252, '\P{^lower}', "");
    Expect(1, 125251, '\p{_-lower}', "");
    Expect(0, 125251, '\p{^_-lower}', "");
    Expect(0, 125251, '\P{_-lower}', "");
    Expect(1, 125251, '\P{^_-lower}', "");
    Expect(0, 125252, '\p{_-lower}', "");
    Expect(1, 125252, '\p{^_-lower}', "");
    Expect(1, 125252, '\P{_-lower}', "");
    Expect(0, 125252, '\P{^_-lower}', "");
    Error('\p{ 	Is_LOWER/a/}');
    Error('\P{ 	Is_LOWER/a/}');
    Expect(1, 125251, '\p{islower}', "");
    Expect(0, 125251, '\p{^islower}', "");
    Expect(0, 125251, '\P{islower}', "");
    Expect(1, 125251, '\P{^islower}', "");
    Expect(0, 125252, '\p{islower}', "");
    Expect(1, 125252, '\p{^islower}', "");
    Expect(1, 125252, '\P{islower}', "");
    Expect(0, 125252, '\P{^islower}', "");
    Expect(1, 125251, '\p{-	IS_lower}', "");
    Expect(0, 125251, '\p{^-	IS_lower}', "");
    Expect(0, 125251, '\P{-	IS_lower}', "");
    Expect(1, 125251, '\P{^-	IS_lower}', "");
    Expect(0, 125252, '\p{-	IS_lower}', "");
    Expect(1, 125252, '\p{^-	IS_lower}', "");
    Expect(1, 125252, '\P{-	IS_lower}', "");
    Expect(0, 125252, '\P{^-	IS_lower}', "");
    Error('\p{/a/ _XPosixPunct}');
    Error('\P{/a/ _XPosixPunct}');
    Expect(1, 125279, '\p{xposixpunct}', "");
    Expect(0, 125279, '\p{^xposixpunct}', "");
    Expect(0, 125279, '\P{xposixpunct}', "");
    Expect(1, 125279, '\P{^xposixpunct}', "");
    Expect(0, 125280, '\p{xposixpunct}', "");
    Expect(1, 125280, '\p{^xposixpunct}', "");
    Expect(1, 125280, '\P{xposixpunct}', "");
    Expect(0, 125280, '\P{^xposixpunct}', "");
    Expect(1, 125279, '\p{-	XPosixPunct}', "");
    Expect(0, 125279, '\p{^-	XPosixPunct}', "");
    Expect(0, 125279, '\P{-	XPosixPunct}', "");
    Expect(1, 125279, '\P{^-	XPosixPunct}', "");
    Expect(0, 125280, '\p{-	XPosixPunct}', "");
    Expect(1, 125280, '\p{^-	XPosixPunct}', "");
    Expect(1, 125280, '\P{-	XPosixPunct}', "");
    Expect(0, 125280, '\P{^-	XPosixPunct}', "");
    Error('\p{/a/- Is_XPOSIXPUNCT}');
    Error('\P{/a/- Is_XPOSIXPUNCT}');
    Expect(1, 125279, '\p{isxposixpunct}', "");
    Expect(0, 125279, '\p{^isxposixpunct}', "");
    Expect(0, 125279, '\P{isxposixpunct}', "");
    Expect(1, 125279, '\P{^isxposixpunct}', "");
    Expect(0, 125280, '\p{isxposixpunct}', "");
    Expect(1, 125280, '\p{^isxposixpunct}', "");
    Expect(1, 125280, '\P{isxposixpunct}', "");
    Expect(0, 125280, '\P{^isxposixpunct}', "");
    Expect(1, 125279, '\p{--Is_xposixpunct}', "");
    Expect(0, 125279, '\p{^--Is_xposixpunct}', "");
    Expect(0, 125279, '\P{--Is_xposixpunct}', "");
    Expect(1, 125279, '\P{^--Is_xposixpunct}', "");
    Expect(0, 125280, '\p{--Is_xposixpunct}', "");
    Expect(1, 125280, '\p{^--Is_xposixpunct}', "");
    Expect(1, 125280, '\P{--Is_xposixpunct}', "");
    Expect(0, 125280, '\P{^--Is_xposixpunct}', "");
    Error('\p{- XPOSIXSPACE:=}');
    Error('\P{- XPOSIXSPACE:=}');
    Expect(1, 12288, '\p{xposixspace}', "");
    Expect(0, 12288, '\p{^xposixspace}', "");
    Expect(0, 12288, '\P{xposixspace}', "");
    Expect(1, 12288, '\P{^xposixspace}', "");
    Expect(0, 12289, '\p{xposixspace}', "");
    Expect(1, 12289, '\p{^xposixspace}', "");
    Expect(1, 12289, '\P{xposixspace}', "");
    Expect(0, 12289, '\P{^xposixspace}', "");
    Expect(1, 12288, '\p{ XPosixSpace}', "");
    Expect(0, 12288, '\p{^ XPosixSpace}', "");
    Expect(0, 12288, '\P{ XPosixSpace}', "");
    Expect(1, 12288, '\P{^ XPosixSpace}', "");
    Expect(0, 12289, '\p{ XPosixSpace}', "");
    Expect(1, 12289, '\p{^ XPosixSpace}', "");
    Expect(1, 12289, '\P{ XPosixSpace}', "");
    Expect(0, 12289, '\P{^ XPosixSpace}', "");
    Error('\p{  XPerlSpace/a/}');
    Error('\P{  XPerlSpace/a/}');
    Expect(1, 12288, '\p{xperlspace}', "");
    Expect(0, 12288, '\p{^xperlspace}', "");
    Expect(0, 12288, '\P{xperlspace}', "");
    Expect(1, 12288, '\P{^xperlspace}', "");
    Expect(0, 12289, '\p{xperlspace}', "");
    Expect(1, 12289, '\p{^xperlspace}', "");
    Expect(1, 12289, '\P{xperlspace}', "");
    Expect(0, 12289, '\P{^xperlspace}', "");
    Expect(1, 12288, '\p{		XPerlSpace}', "");
    Expect(0, 12288, '\p{^		XPerlSpace}', "");
    Expect(0, 12288, '\P{		XPerlSpace}', "");
    Expect(1, 12288, '\P{^		XPerlSpace}', "");
    Expect(0, 12289, '\p{		XPerlSpace}', "");
    Expect(1, 12289, '\p{^		XPerlSpace}', "");
    Expect(1, 12289, '\P{		XPerlSpace}', "");
    Expect(0, 12289, '\P{^		XPerlSpace}', "");
    Error('\p{-:=SpacePerl}');
    Error('\P{-:=SpacePerl}');
    Expect(1, 12288, '\p{spaceperl}', "");
    Expect(0, 12288, '\p{^spaceperl}', "");
    Expect(0, 12288, '\P{spaceperl}', "");
    Expect(1, 12288, '\P{^spaceperl}', "");
    Expect(0, 12289, '\p{spaceperl}', "");
    Expect(1, 12289, '\p{^spaceperl}', "");
    Expect(1, 12289, '\P{spaceperl}', "");
    Expect(0, 12289, '\P{^spaceperl}', "");
    Expect(1, 12288, '\p{-	SpacePerl}', "");
    Expect(0, 12288, '\p{^-	SpacePerl}', "");
    Expect(0, 12288, '\P{-	SpacePerl}', "");
    Expect(1, 12288, '\P{^-	SpacePerl}', "");
    Expect(0, 12289, '\p{-	SpacePerl}', "");
    Expect(1, 12289, '\p{^-	SpacePerl}', "");
    Expect(1, 12289, '\P{-	SpacePerl}', "");
    Expect(0, 12289, '\P{^-	SpacePerl}', "");
    Error('\p{:=IS_xposixspace}');
    Error('\P{:=IS_xposixspace}');
    Expect(1, 12288, '\p{isxposixspace}', "");
    Expect(0, 12288, '\p{^isxposixspace}', "");
    Expect(0, 12288, '\P{isxposixspace}', "");
    Expect(1, 12288, '\P{^isxposixspace}', "");
    Expect(0, 12289, '\p{isxposixspace}', "");
    Expect(1, 12289, '\p{^isxposixspace}', "");
    Expect(1, 12289, '\P{isxposixspace}', "");
    Expect(0, 12289, '\P{^isxposixspace}', "");
    Expect(1, 12288, '\p{- is_XPOSIXSPACE}', "");
    Expect(0, 12288, '\p{^- is_XPOSIXSPACE}', "");
    Expect(0, 12288, '\P{- is_XPOSIXSPACE}', "");
    Expect(1, 12288, '\P{^- is_XPOSIXSPACE}', "");
    Expect(0, 12289, '\p{- is_XPOSIXSPACE}', "");
    Expect(1, 12289, '\p{^- is_XPOSIXSPACE}', "");
    Expect(1, 12289, '\P{- is_XPOSIXSPACE}', "");
    Expect(0, 12289, '\P{^- is_XPOSIXSPACE}', "");
    Error('\p{:=	_Is_XPerlSpace}');
    Error('\P{:=	_Is_XPerlSpace}');
    Expect(1, 12288, '\p{isxperlspace}', "");
    Expect(0, 12288, '\p{^isxperlspace}', "");
    Expect(0, 12288, '\P{isxperlspace}', "");
    Expect(1, 12288, '\P{^isxperlspace}', "");
    Expect(0, 12289, '\p{isxperlspace}', "");
    Expect(1, 12289, '\p{^isxperlspace}', "");
    Expect(1, 12289, '\P{isxperlspace}', "");
    Expect(0, 12289, '\P{^isxperlspace}', "");
    Expect(1, 12288, '\p{  is_XPERLSPACE}', "");
    Expect(0, 12288, '\p{^  is_XPERLSPACE}', "");
    Expect(0, 12288, '\P{  is_XPERLSPACE}', "");
    Expect(1, 12288, '\P{^  is_XPERLSPACE}', "");
    Expect(0, 12289, '\p{  is_XPERLSPACE}', "");
    Expect(1, 12289, '\p{^  is_XPERLSPACE}', "");
    Expect(1, 12289, '\P{  is_XPERLSPACE}', "");
    Expect(0, 12289, '\P{^  is_XPERLSPACE}', "");
    Error('\p{:=_	is_SPACEPERL}');
    Error('\P{:=_	is_SPACEPERL}');
    Expect(1, 12288, '\p{isspaceperl}', "");
    Expect(0, 12288, '\p{^isspaceperl}', "");
    Expect(0, 12288, '\P{isspaceperl}', "");
    Expect(1, 12288, '\P{^isspaceperl}', "");
    Expect(0, 12289, '\p{isspaceperl}', "");
    Expect(1, 12289, '\p{^isspaceperl}', "");
    Expect(1, 12289, '\P{isspaceperl}', "");
    Expect(0, 12289, '\P{^isspaceperl}', "");
    Expect(1, 12288, '\p{-_IS_SPACEPERL}', "");
    Expect(0, 12288, '\p{^-_IS_SPACEPERL}', "");
    Expect(0, 12288, '\P{-_IS_SPACEPERL}', "");
    Expect(1, 12288, '\P{^-_IS_SPACEPERL}', "");
    Expect(0, 12289, '\p{-_IS_SPACEPERL}', "");
    Expect(1, 12289, '\p{^-_IS_SPACEPERL}', "");
    Expect(1, 12289, '\P{-_IS_SPACEPERL}', "");
    Expect(0, 12289, '\P{^-_IS_SPACEPERL}', "");
    Error('\p{- XPOSIXUPPER:=}');
    Error('\P{- XPOSIXUPPER:=}');
    Expect(1, 127369, '\p{xposixupper}', "");
    Expect(0, 127369, '\p{^xposixupper}', "");
    Expect(0, 127369, '\P{xposixupper}', "");
    Expect(1, 127369, '\P{^xposixupper}', "");
    Expect(0, 127370, '\p{xposixupper}', "");
    Expect(1, 127370, '\p{^xposixupper}', "");
    Expect(1, 127370, '\P{xposixupper}', "");
    Expect(0, 127370, '\P{^xposixupper}', "");
    Expect(1, 127369, '\p{_XPosixUpper}', "");
    Expect(0, 127369, '\p{^_XPosixUpper}', "");
    Expect(0, 127369, '\P{_XPosixUpper}', "");
    Expect(1, 127369, '\P{^_XPosixUpper}', "");
    Expect(0, 127370, '\p{_XPosixUpper}', "");
    Expect(1, 127370, '\p{^_XPosixUpper}', "");
    Expect(1, 127370, '\P{_XPosixUpper}', "");
    Expect(0, 127370, '\P{^_XPosixUpper}', "");
    Error('\p{-/a/Is_XPosixUpper}');
    Error('\P{-/a/Is_XPosixUpper}');
    Expect(1, 127369, '\p{isxposixupper}', "");
    Expect(0, 127369, '\p{^isxposixupper}', "");
    Expect(0, 127369, '\P{isxposixupper}', "");
    Expect(1, 127369, '\P{^isxposixupper}', "");
    Expect(0, 127370, '\p{isxposixupper}', "");
    Expect(1, 127370, '\p{^isxposixupper}', "");
    Expect(1, 127370, '\P{isxposixupper}', "");
    Expect(0, 127370, '\P{^isxposixupper}', "");
    Expect(1, 127369, '\p{		is_xposixupper}', "");
    Expect(0, 127369, '\p{^		is_xposixupper}', "");
    Expect(0, 127369, '\P{		is_xposixupper}', "");
    Expect(1, 127369, '\P{^		is_xposixupper}', "");
    Expect(0, 127370, '\p{		is_xposixupper}', "");
    Expect(1, 127370, '\p{^		is_xposixupper}', "");
    Expect(1, 127370, '\P{		is_xposixupper}', "");
    Expect(0, 127370, '\P{^		is_xposixupper}', "");
    Error('\p{/a/_UPPERCASE}');
    Error('\P{/a/_UPPERCASE}');
    Expect(1, 127369, '\p{uppercase}', "");
    Expect(0, 127369, '\p{^uppercase}', "");
    Expect(0, 127369, '\P{uppercase}', "");
    Expect(1, 127369, '\P{^uppercase}', "");
    Expect(0, 127370, '\p{uppercase}', "");
    Expect(1, 127370, '\p{^uppercase}', "");
    Expect(1, 127370, '\P{uppercase}', "");
    Expect(0, 127370, '\P{^uppercase}', "");
    Expect(1, 127369, '\p{-Uppercase}', "");
    Expect(0, 127369, '\p{^-Uppercase}', "");
    Expect(0, 127369, '\P{-Uppercase}', "");
    Expect(1, 127369, '\P{^-Uppercase}', "");
    Expect(0, 127370, '\p{-Uppercase}', "");
    Expect(1, 127370, '\p{^-Uppercase}', "");
    Expect(1, 127370, '\P{-Uppercase}', "");
    Expect(0, 127370, '\P{^-Uppercase}', "");
    Error('\p{ /a/Is_Uppercase}');
    Error('\P{ /a/Is_Uppercase}');
    Expect(1, 127369, '\p{isuppercase}', "");
    Expect(0, 127369, '\p{^isuppercase}', "");
    Expect(0, 127369, '\P{isuppercase}', "");
    Expect(1, 127369, '\P{^isuppercase}', "");
    Expect(0, 127370, '\p{isuppercase}', "");
    Expect(1, 127370, '\p{^isuppercase}', "");
    Expect(1, 127370, '\P{isuppercase}', "");
    Expect(0, 127370, '\P{^isuppercase}', "");
    Expect(1, 127369, '\p{--Is_Uppercase}', "");
    Expect(0, 127369, '\p{^--Is_Uppercase}', "");
    Expect(0, 127369, '\P{--Is_Uppercase}', "");
    Expect(1, 127369, '\P{^--Is_Uppercase}', "");
    Expect(0, 127370, '\p{--Is_Uppercase}', "");
    Expect(1, 127370, '\p{^--Is_Uppercase}', "");
    Expect(1, 127370, '\P{--Is_Uppercase}', "");
    Expect(0, 127370, '\P{^--Is_Uppercase}', "");
    Error('\p{upper/a/}');
    Error('\P{upper/a/}');
    Expect(1, 127369, '\p{upper}', "");
    Expect(0, 127369, '\p{^upper}', "");
    Expect(0, 127369, '\P{upper}', "");
    Expect(1, 127369, '\P{^upper}', "");
    Expect(0, 127370, '\p{upper}', "");
    Expect(1, 127370, '\p{^upper}', "");
    Expect(1, 127370, '\P{upper}', "");
    Expect(0, 127370, '\P{^upper}', "");
    Expect(1, 127369, '\p{_ UPPER}', "");
    Expect(0, 127369, '\p{^_ UPPER}', "");
    Expect(0, 127369, '\P{_ UPPER}', "");
    Expect(1, 127369, '\P{^_ UPPER}', "");
    Expect(0, 127370, '\p{_ UPPER}', "");
    Expect(1, 127370, '\p{^_ UPPER}', "");
    Expect(1, 127370, '\P{_ UPPER}', "");
    Expect(0, 127370, '\P{^_ UPPER}', "");
    Error('\p{/a/IS_Upper}');
    Error('\P{/a/IS_Upper}');
    Expect(1, 127369, '\p{isupper}', "");
    Expect(0, 127369, '\p{^isupper}', "");
    Expect(0, 127369, '\P{isupper}', "");
    Expect(1, 127369, '\P{^isupper}', "");
    Expect(0, 127370, '\p{isupper}', "");
    Expect(1, 127370, '\p{^isupper}', "");
    Expect(1, 127370, '\P{isupper}', "");
    Expect(0, 127370, '\P{^isupper}', "");
    Expect(1, 127369, '\p{_	Is_Upper}', "");
    Expect(0, 127369, '\p{^_	Is_Upper}', "");
    Expect(0, 127369, '\P{_	Is_Upper}', "");
    Expect(1, 127369, '\P{^_	Is_Upper}', "");
    Expect(0, 127370, '\p{_	Is_Upper}', "");
    Expect(1, 127370, '\p{^_	Is_Upper}', "");
    Expect(1, 127370, '\P{_	Is_Upper}', "");
    Expect(0, 127370, '\P{^_	Is_Upper}', "");
    Error('\p{ 	yezidi/a/}');
    Error('\P{ 	yezidi/a/}');
    Expect(1, 69297, '\p{yezidi}', "");
    Expect(0, 69297, '\p{^yezidi}', "");
    Expect(0, 69297, '\P{yezidi}', "");
    Expect(1, 69297, '\P{^yezidi}', "");
    Expect(0, 69298, '\p{yezidi}', "");
    Expect(1, 69298, '\p{^yezidi}', "");
    Expect(1, 69298, '\P{yezidi}', "");
    Expect(0, 69298, '\P{^yezidi}', "");
    Expect(1, 69297, '\p{_ Yezidi}', "");
    Expect(0, 69297, '\p{^_ Yezidi}', "");
    Expect(0, 69297, '\P{_ Yezidi}', "");
    Expect(1, 69297, '\P{^_ Yezidi}', "");
    Expect(0, 69298, '\p{_ Yezidi}', "");
    Expect(1, 69298, '\p{^_ Yezidi}', "");
    Expect(1, 69298, '\P{_ Yezidi}', "");
    Expect(0, 69298, '\P{^_ Yezidi}', "");
    Error('\p{_:=IS_yezidi}');
    Error('\P{_:=IS_yezidi}');
    Expect(1, 69297, '\p{isyezidi}', "");
    Expect(0, 69297, '\p{^isyezidi}', "");
    Expect(0, 69297, '\P{isyezidi}', "");
    Expect(1, 69297, '\P{^isyezidi}', "");
    Expect(0, 69298, '\p{isyezidi}', "");
    Expect(1, 69298, '\p{^isyezidi}', "");
    Expect(1, 69298, '\P{isyezidi}', "");
    Expect(0, 69298, '\P{^isyezidi}', "");
    Expect(1, 69297, '\p{ IS_Yezidi}', "");
    Expect(0, 69297, '\p{^ IS_Yezidi}', "");
    Expect(0, 69297, '\P{ IS_Yezidi}', "");
    Expect(1, 69297, '\P{^ IS_Yezidi}', "");
    Expect(0, 69298, '\p{ IS_Yezidi}', "");
    Expect(1, 69298, '\p{^ IS_Yezidi}', "");
    Expect(1, 69298, '\P{ IS_Yezidi}', "");
    Expect(0, 69298, '\P{^ IS_Yezidi}', "");
    Error('\p{:= -YEZI}');
    Error('\P{:= -YEZI}');
    Expect(1, 69297, '\p{yezi}', "");
    Expect(0, 69297, '\p{^yezi}', "");
    Expect(0, 69297, '\P{yezi}', "");
    Expect(1, 69297, '\P{^yezi}', "");
    Expect(0, 69298, '\p{yezi}', "");
    Expect(1, 69298, '\p{^yezi}', "");
    Expect(1, 69298, '\P{yezi}', "");
    Expect(0, 69298, '\P{^yezi}', "");
    Expect(1, 69297, '\p{_YEZI}', "");
    Expect(0, 69297, '\p{^_YEZI}', "");
    Expect(0, 69297, '\P{_YEZI}', "");
    Expect(1, 69297, '\P{^_YEZI}', "");
    Expect(0, 69298, '\p{_YEZI}', "");
    Expect(1, 69298, '\p{^_YEZI}', "");
    Expect(1, 69298, '\P{_YEZI}', "");
    Expect(0, 69298, '\P{^_YEZI}', "");
    Error('\p{_:=IS_yezi}');
    Error('\P{_:=IS_yezi}');
    Expect(1, 69297, '\p{isyezi}', "");
    Expect(0, 69297, '\p{^isyezi}', "");
    Expect(0, 69297, '\P{isyezi}', "");
    Expect(1, 69297, '\P{^isyezi}', "");
    Expect(0, 69298, '\p{isyezi}', "");
    Expect(1, 69298, '\p{^isyezi}', "");
    Expect(1, 69298, '\P{isyezi}', "");
    Expect(0, 69298, '\P{^isyezi}', "");
    Expect(1, 69297, '\p{-is_YEZI}', "");
    Expect(0, 69297, '\p{^-is_YEZI}', "");
    Expect(0, 69297, '\P{-is_YEZI}', "");
    Expect(1, 69297, '\P{^-is_YEZI}', "");
    Expect(0, 69298, '\p{-is_YEZI}', "");
    Expect(1, 69298, '\p{^-is_YEZI}', "");
    Expect(1, 69298, '\P{-is_YEZI}', "");
    Expect(0, 69298, '\P{^-is_YEZI}', "");
    Error('\p{-:=Yi}');
    Error('\P{-:=Yi}');
    Expect(1, 65381, '\p{yi}', "");
    Expect(0, 65381, '\p{^yi}', "");
    Expect(0, 65381, '\P{yi}', "");
    Expect(1, 65381, '\P{^yi}', "");
    Expect(0, 65382, '\p{yi}', "");
    Expect(1, 65382, '\p{^yi}', "");
    Expect(1, 65382, '\P{yi}', "");
    Expect(0, 65382, '\P{^yi}', "");
    Expect(1, 65381, '\p{	_yi}', "");
    Expect(0, 65381, '\p{^	_yi}', "");
    Expect(0, 65381, '\P{	_yi}', "");
    Expect(1, 65381, '\P{^	_yi}', "");
    Expect(0, 65382, '\p{	_yi}', "");
    Expect(1, 65382, '\p{^	_yi}', "");
    Expect(1, 65382, '\P{	_yi}', "");
    Expect(0, 65382, '\P{^	_yi}', "");
    Error('\p{-Is_Yi/a/}');
    Error('\P{-Is_Yi/a/}');
    Expect(1, 65381, '\p{isyi}', "");
    Expect(0, 65381, '\p{^isyi}', "");
    Expect(0, 65381, '\P{isyi}', "");
    Expect(1, 65381, '\P{^isyi}', "");
    Expect(0, 65382, '\p{isyi}', "");
    Expect(1, 65382, '\p{^isyi}', "");
    Expect(1, 65382, '\P{isyi}', "");
    Expect(0, 65382, '\P{^isyi}', "");
    Expect(1, 65381, '\p{	Is_Yi}', "");
    Expect(0, 65381, '\p{^	Is_Yi}', "");
    Expect(0, 65381, '\P{	Is_Yi}', "");
    Expect(1, 65381, '\P{^	Is_Yi}', "");
    Expect(0, 65382, '\p{	Is_Yi}', "");
    Expect(1, 65382, '\p{^	Is_Yi}', "");
    Expect(1, 65382, '\P{	Is_Yi}', "");
    Expect(0, 65382, '\P{^	Is_Yi}', "");
    Error('\p{__Yiii:=}');
    Error('\P{__Yiii:=}');
    Expect(1, 65381, '\p{yiii}', "");
    Expect(0, 65381, '\p{^yiii}', "");
    Expect(0, 65381, '\P{yiii}', "");
    Expect(1, 65381, '\P{^yiii}', "");
    Expect(0, 65382, '\p{yiii}', "");
    Expect(1, 65382, '\p{^yiii}', "");
    Expect(1, 65382, '\P{yiii}', "");
    Expect(0, 65382, '\P{^yiii}', "");
    Expect(1, 65381, '\p{	YIII}', "");
    Expect(0, 65381, '\p{^	YIII}', "");
    Expect(0, 65381, '\P{	YIII}', "");
    Expect(1, 65381, '\P{^	YIII}', "");
    Expect(0, 65382, '\p{	YIII}', "");
    Expect(1, 65382, '\p{^	YIII}', "");
    Expect(1, 65382, '\P{	YIII}', "");
    Expect(0, 65382, '\P{^	YIII}', "");
    Error('\p{ :=Is_Yiii}');
    Error('\P{ :=Is_Yiii}');
    Expect(1, 65381, '\p{isyiii}', "");
    Expect(0, 65381, '\p{^isyiii}', "");
    Expect(0, 65381, '\P{isyiii}', "");
    Expect(1, 65381, '\P{^isyiii}', "");
    Expect(0, 65382, '\p{isyiii}', "");
    Expect(1, 65382, '\p{^isyiii}', "");
    Expect(1, 65382, '\P{isyiii}', "");
    Expect(0, 65382, '\P{^isyiii}', "");
    Expect(1, 65381, '\p{_IS_yiii}', "");
    Expect(0, 65381, '\p{^_IS_yiii}', "");
    Expect(0, 65381, '\P{_IS_yiii}', "");
    Expect(1, 65381, '\P{^_IS_yiii}', "");
    Expect(0, 65382, '\p{_IS_yiii}', "");
    Expect(1, 65382, '\p{^_IS_yiii}', "");
    Expect(1, 65382, '\P{_IS_yiii}', "");
    Expect(0, 65382, '\P{^_IS_yiii}', "");
    Error('\p{ Yi_Radicals/a/}');
    Error('\P{ Yi_Radicals/a/}');
    Expect(1, 42191, '\p{yiradicals}', "");
    Expect(0, 42191, '\p{^yiradicals}', "");
    Expect(0, 42191, '\P{yiradicals}', "");
    Expect(1, 42191, '\P{^yiradicals}', "");
    Expect(0, 42192, '\p{yiradicals}', "");
    Expect(1, 42192, '\p{^yiradicals}', "");
    Expect(1, 42192, '\P{yiradicals}', "");
    Expect(0, 42192, '\P{^yiradicals}', "");
    Expect(1, 42191, '\p{-	YI_RADICALS}', "");
    Expect(0, 42191, '\p{^-	YI_RADICALS}', "");
    Expect(0, 42191, '\P{-	YI_RADICALS}', "");
    Expect(1, 42191, '\P{^-	YI_RADICALS}', "");
    Expect(0, 42192, '\p{-	YI_RADICALS}', "");
    Expect(1, 42192, '\p{^-	YI_RADICALS}', "");
    Expect(1, 42192, '\P{-	YI_RADICALS}', "");
    Expect(0, 42192, '\P{^-	YI_RADICALS}', "");
    Error('\p{ :=IS_Yi_Radicals}');
    Error('\P{ :=IS_Yi_Radicals}');
    Expect(1, 42191, '\p{isyiradicals}', "");
    Expect(0, 42191, '\p{^isyiradicals}', "");
    Expect(0, 42191, '\P{isyiradicals}', "");
    Expect(1, 42191, '\P{^isyiradicals}', "");
    Expect(0, 42192, '\p{isyiradicals}', "");
    Expect(1, 42192, '\p{^isyiradicals}', "");
    Expect(1, 42192, '\P{isyiradicals}', "");
    Expect(0, 42192, '\P{^isyiradicals}', "");
    Expect(1, 42191, '\p{_	Is_YI_radicals}', "");
    Expect(0, 42191, '\p{^_	Is_YI_radicals}', "");
    Expect(0, 42191, '\P{_	Is_YI_radicals}', "");
    Expect(1, 42191, '\P{^_	Is_YI_radicals}', "");
    Expect(0, 42192, '\p{_	Is_YI_radicals}', "");
    Expect(1, 42192, '\p{^_	Is_YI_radicals}', "");
    Expect(1, 42192, '\P{_	Is_YI_radicals}', "");
    Expect(0, 42192, '\P{^_	Is_YI_radicals}', "");
    Error('\p{_In_Yi_radicals/a/}');
    Error('\P{_In_Yi_radicals/a/}');
    Expect(1, 42191, '\p{inyiradicals}', "");
    Expect(0, 42191, '\p{^inyiradicals}', "");
    Expect(0, 42191, '\P{inyiradicals}', "");
    Expect(1, 42191, '\P{^inyiradicals}', "");
    Expect(0, 42192, '\p{inyiradicals}', "");
    Expect(1, 42192, '\p{^inyiradicals}', "");
    Expect(1, 42192, '\P{inyiradicals}', "");
    Expect(0, 42192, '\P{^inyiradicals}', "");
    Expect(1, 42191, '\p{		In_Yi_Radicals}', "");
    Expect(0, 42191, '\p{^		In_Yi_Radicals}', "");
    Expect(0, 42191, '\P{		In_Yi_Radicals}', "");
    Expect(1, 42191, '\P{^		In_Yi_Radicals}', "");
    Expect(0, 42192, '\p{		In_Yi_Radicals}', "");
    Expect(1, 42192, '\p{^		In_Yi_Radicals}', "");
    Expect(1, 42192, '\P{		In_Yi_Radicals}', "");
    Expect(0, 42192, '\P{^		In_Yi_Radicals}', "");
    Error('\p{-	YI_SYLLABLES/a/}');
    Error('\P{-	YI_SYLLABLES/a/}');
    Expect(1, 42127, '\p{yisyllables}', "");
    Expect(0, 42127, '\p{^yisyllables}', "");
    Expect(0, 42127, '\P{yisyllables}', "");
    Expect(1, 42127, '\P{^yisyllables}', "");
    Expect(0, 42128, '\p{yisyllables}', "");
    Expect(1, 42128, '\p{^yisyllables}', "");
    Expect(1, 42128, '\P{yisyllables}', "");
    Expect(0, 42128, '\P{^yisyllables}', "");
    Expect(1, 42127, '\p{ _yi_Syllables}', "");
    Expect(0, 42127, '\p{^ _yi_Syllables}', "");
    Expect(0, 42127, '\P{ _yi_Syllables}', "");
    Expect(1, 42127, '\P{^ _yi_Syllables}', "");
    Expect(0, 42128, '\p{ _yi_Syllables}', "");
    Expect(1, 42128, '\p{^ _yi_Syllables}', "");
    Expect(1, 42128, '\P{ _yi_Syllables}', "");
    Expect(0, 42128, '\P{^ _yi_Syllables}', "");
    Error('\p{/a/IS_Yi_Syllables}');
    Error('\P{/a/IS_Yi_Syllables}');
    Expect(1, 42127, '\p{isyisyllables}', "");
    Expect(0, 42127, '\p{^isyisyllables}', "");
    Expect(0, 42127, '\P{isyisyllables}', "");
    Expect(1, 42127, '\P{^isyisyllables}', "");
    Expect(0, 42128, '\p{isyisyllables}', "");
    Expect(1, 42128, '\p{^isyisyllables}', "");
    Expect(1, 42128, '\P{isyisyllables}', "");
    Expect(0, 42128, '\P{^isyisyllables}', "");
    Expect(1, 42127, '\p{-Is_yi_SYLLABLES}', "");
    Expect(0, 42127, '\p{^-Is_yi_SYLLABLES}', "");
    Expect(0, 42127, '\P{-Is_yi_SYLLABLES}', "");
    Expect(1, 42127, '\P{^-Is_yi_SYLLABLES}', "");
    Expect(0, 42128, '\p{-Is_yi_SYLLABLES}', "");
    Expect(1, 42128, '\p{^-Is_yi_SYLLABLES}', "");
    Expect(1, 42128, '\P{-Is_yi_SYLLABLES}', "");
    Expect(0, 42128, '\P{^-Is_yi_SYLLABLES}', "");
    Error('\p{in_YI_Syllables/a/}');
    Error('\P{in_YI_Syllables/a/}');
    Expect(1, 42127, '\p{inyisyllables}', "");
    Expect(0, 42127, '\p{^inyisyllables}', "");
    Expect(0, 42127, '\P{inyisyllables}', "");
    Expect(1, 42127, '\P{^inyisyllables}', "");
    Expect(0, 42128, '\p{inyisyllables}', "");
    Expect(1, 42128, '\p{^inyisyllables}', "");
    Expect(1, 42128, '\P{inyisyllables}', "");
    Expect(0, 42128, '\P{^inyisyllables}', "");
    Expect(1, 42127, '\p{-	IN_yi_syllables}', "");
    Expect(0, 42127, '\p{^-	IN_yi_syllables}', "");
    Expect(0, 42127, '\P{-	IN_yi_syllables}', "");
    Expect(1, 42127, '\P{^-	IN_yi_syllables}', "");
    Expect(0, 42128, '\p{-	IN_yi_syllables}', "");
    Expect(1, 42128, '\p{^-	IN_yi_syllables}', "");
    Expect(1, 42128, '\P{-	IN_yi_syllables}', "");
    Expect(0, 42128, '\P{^-	IN_yi_syllables}', "");
    Error('\p{_/a/Yijing_HEXAGRAM_Symbols}');
    Error('\P{_/a/Yijing_HEXAGRAM_Symbols}');
    Expect(1, 19967, '\p{yijinghexagramsymbols}', "");
    Expect(0, 19967, '\p{^yijinghexagramsymbols}', "");
    Expect(0, 19967, '\P{yijinghexagramsymbols}', "");
    Expect(1, 19967, '\P{^yijinghexagramsymbols}', "");
    Expect(0, 19968, '\p{yijinghexagramsymbols}', "");
    Expect(1, 19968, '\p{^yijinghexagramsymbols}', "");
    Expect(1, 19968, '\P{yijinghexagramsymbols}', "");
    Expect(0, 19968, '\P{^yijinghexagramsymbols}', "");
    Expect(1, 19967, '\p{_ YIJING_HEXAGRAM_Symbols}', "");
    Expect(0, 19967, '\p{^_ YIJING_HEXAGRAM_Symbols}', "");
    Expect(0, 19967, '\P{_ YIJING_HEXAGRAM_Symbols}', "");
    Expect(1, 19967, '\P{^_ YIJING_HEXAGRAM_Symbols}', "");
    Expect(0, 19968, '\p{_ YIJING_HEXAGRAM_Symbols}', "");
    Expect(1, 19968, '\p{^_ YIJING_HEXAGRAM_Symbols}', "");
    Expect(1, 19968, '\P{_ YIJING_HEXAGRAM_Symbols}', "");
    Expect(0, 19968, '\P{^_ YIJING_HEXAGRAM_Symbols}', "");
    Error('\p{:=_	is_Yijing_hexagram_Symbols}');
    Error('\P{:=_	is_Yijing_hexagram_Symbols}');
    Expect(1, 19967, '\p{isyijinghexagramsymbols}', "");
    Expect(0, 19967, '\p{^isyijinghexagramsymbols}', "");
    Expect(0, 19967, '\P{isyijinghexagramsymbols}', "");
    Expect(1, 19967, '\P{^isyijinghexagramsymbols}', "");
    Expect(0, 19968, '\p{isyijinghexagramsymbols}', "");
    Expect(1, 19968, '\p{^isyijinghexagramsymbols}', "");
    Expect(1, 19968, '\P{isyijinghexagramsymbols}', "");
    Expect(0, 19968, '\P{^isyijinghexagramsymbols}', "");
    Expect(1, 19967, '\p{_Is_YIJING_HEXAGRAM_Symbols}', "");
    Expect(0, 19967, '\p{^_Is_YIJING_HEXAGRAM_Symbols}', "");
    Expect(0, 19967, '\P{_Is_YIJING_HEXAGRAM_Symbols}', "");
    Expect(1, 19967, '\P{^_Is_YIJING_HEXAGRAM_Symbols}', "");
    Expect(0, 19968, '\p{_Is_YIJING_HEXAGRAM_Symbols}', "");
    Expect(1, 19968, '\p{^_Is_YIJING_HEXAGRAM_Symbols}', "");
    Expect(1, 19968, '\P{_Is_YIJING_HEXAGRAM_Symbols}', "");
    Expect(0, 19968, '\P{^_Is_YIJING_HEXAGRAM_Symbols}', "");
    Error('\p{/a/In_Yijing_Hexagram_SYMBOLS}');
    Error('\P{/a/In_Yijing_Hexagram_SYMBOLS}');
    Expect(1, 19967, '\p{inyijinghexagramsymbols}', "");
    Expect(0, 19967, '\p{^inyijinghexagramsymbols}', "");
    Expect(0, 19967, '\P{inyijinghexagramsymbols}', "");
    Expect(1, 19967, '\P{^inyijinghexagramsymbols}', "");
    Expect(0, 19968, '\p{inyijinghexagramsymbols}', "");
    Expect(1, 19968, '\p{^inyijinghexagramsymbols}', "");
    Expect(1, 19968, '\P{inyijinghexagramsymbols}', "");
    Expect(0, 19968, '\P{^inyijinghexagramsymbols}', "");
    Expect(1, 19967, '\p{	-in_Yijing_HEXAGRAM_SYMBOLS}', "");
    Expect(0, 19967, '\p{^	-in_Yijing_HEXAGRAM_SYMBOLS}', "");
    Expect(0, 19967, '\P{	-in_Yijing_HEXAGRAM_SYMBOLS}', "");
    Expect(1, 19967, '\P{^	-in_Yijing_HEXAGRAM_SYMBOLS}', "");
    Expect(0, 19968, '\p{	-in_Yijing_HEXAGRAM_SYMBOLS}', "");
    Expect(1, 19968, '\p{^	-in_Yijing_HEXAGRAM_SYMBOLS}', "");
    Expect(1, 19968, '\P{	-in_Yijing_HEXAGRAM_SYMBOLS}', "");
    Expect(0, 19968, '\P{^	-in_Yijing_HEXAGRAM_SYMBOLS}', "");
    Error('\p{/a/-YIJING}');
    Error('\P{/a/-YIJING}');
    Expect(1, 19967, '\p{yijing}', "");
    Expect(0, 19967, '\p{^yijing}', "");
    Expect(0, 19967, '\P{yijing}', "");
    Expect(1, 19967, '\P{^yijing}', "");
    Expect(0, 19968, '\p{yijing}', "");
    Expect(1, 19968, '\p{^yijing}', "");
    Expect(1, 19968, '\P{yijing}', "");
    Expect(0, 19968, '\P{^yijing}', "");
    Expect(1, 19967, '\p{-	YIJING}', "");
    Expect(0, 19967, '\p{^-	YIJING}', "");
    Expect(0, 19967, '\P{-	YIJING}', "");
    Expect(1, 19967, '\P{^-	YIJING}', "");
    Expect(0, 19968, '\p{-	YIJING}', "");
    Expect(1, 19968, '\p{^-	YIJING}', "");
    Expect(1, 19968, '\P{-	YIJING}', "");
    Expect(0, 19968, '\P{^-	YIJING}', "");
    Error('\p{	:=IS_yijing}');
    Error('\P{	:=IS_yijing}');
    Expect(1, 19967, '\p{isyijing}', "");
    Expect(0, 19967, '\p{^isyijing}', "");
    Expect(0, 19967, '\P{isyijing}', "");
    Expect(1, 19967, '\P{^isyijing}', "");
    Expect(0, 19968, '\p{isyijing}', "");
    Expect(1, 19968, '\p{^isyijing}', "");
    Expect(1, 19968, '\P{isyijing}', "");
    Expect(0, 19968, '\P{^isyijing}', "");
    Expect(1, 19967, '\p{_	Is_yijing}', "");
    Expect(0, 19967, '\p{^_	Is_yijing}', "");
    Expect(0, 19967, '\P{_	Is_yijing}', "");
    Expect(1, 19967, '\P{^_	Is_yijing}', "");
    Expect(0, 19968, '\p{_	Is_yijing}', "");
    Expect(1, 19968, '\p{^_	Is_yijing}', "");
    Expect(1, 19968, '\P{_	Is_yijing}', "");
    Expect(0, 19968, '\P{^_	Is_yijing}', "");
    Error('\p{ /a/IN_YIJING}');
    Error('\P{ /a/IN_YIJING}');
    Expect(1, 19967, '\p{inyijing}', "");
    Expect(0, 19967, '\p{^inyijing}', "");
    Expect(0, 19967, '\P{inyijing}', "");
    Expect(1, 19967, '\P{^inyijing}', "");
    Expect(0, 19968, '\p{inyijing}', "");
    Expect(1, 19968, '\p{^inyijing}', "");
    Expect(1, 19968, '\P{inyijing}', "");
    Expect(0, 19968, '\P{^inyijing}', "");
    Expect(1, 19967, '\p{	in_Yijing}', "");
    Expect(0, 19967, '\p{^	in_Yijing}', "");
    Expect(0, 19967, '\P{	in_Yijing}', "");
    Expect(1, 19967, '\P{^	in_Yijing}', "");
    Expect(0, 19968, '\p{	in_Yijing}', "");
    Expect(1, 19968, '\p{^	in_Yijing}', "");
    Expect(1, 19968, '\P{	in_Yijing}', "");
    Expect(0, 19968, '\P{^	in_Yijing}', "");
    Error('\p{:=__Zanabazar_square}');
    Error('\P{:=__Zanabazar_square}');
    Expect(1, 72263, '\p{zanabazarsquare}', "");
    Expect(0, 72263, '\p{^zanabazarsquare}', "");
    Expect(0, 72263, '\P{zanabazarsquare}', "");
    Expect(1, 72263, '\P{^zanabazarsquare}', "");
    Expect(0, 72264, '\p{zanabazarsquare}', "");
    Expect(1, 72264, '\p{^zanabazarsquare}', "");
    Expect(1, 72264, '\P{zanabazarsquare}', "");
    Expect(0, 72264, '\P{^zanabazarsquare}', "");
    Expect(1, 72263, '\p{	zanabazar_Square}', "");
    Expect(0, 72263, '\p{^	zanabazar_Square}', "");
    Expect(0, 72263, '\P{	zanabazar_Square}', "");
    Expect(1, 72263, '\P{^	zanabazar_Square}', "");
    Expect(0, 72264, '\p{	zanabazar_Square}', "");
    Expect(1, 72264, '\p{^	zanabazar_Square}', "");
    Expect(1, 72264, '\P{	zanabazar_Square}', "");
    Expect(0, 72264, '\P{^	zanabazar_Square}', "");
    Error('\p{/a/  Is_ZANABAZAR_Square}');
    Error('\P{/a/  Is_ZANABAZAR_Square}');
    Expect(1, 72263, '\p{iszanabazarsquare}', "");
    Expect(0, 72263, '\p{^iszanabazarsquare}', "");
    Expect(0, 72263, '\P{iszanabazarsquare}', "");
    Expect(1, 72263, '\P{^iszanabazarsquare}', "");
    Expect(0, 72264, '\p{iszanabazarsquare}', "");
    Expect(1, 72264, '\p{^iszanabazarsquare}', "");
    Expect(1, 72264, '\P{iszanabazarsquare}', "");
    Expect(0, 72264, '\P{^iszanabazarsquare}', "");
    Expect(1, 72263, '\p{-_Is_zanabazar_Square}', "");
    Expect(0, 72263, '\p{^-_Is_zanabazar_Square}', "");
    Expect(0, 72263, '\P{-_Is_zanabazar_Square}', "");
    Expect(1, 72263, '\P{^-_Is_zanabazar_Square}', "");
    Expect(0, 72264, '\p{-_Is_zanabazar_Square}', "");
    Expect(1, 72264, '\p{^-_Is_zanabazar_Square}', "");
    Expect(1, 72264, '\P{-_Is_zanabazar_Square}', "");
    Expect(0, 72264, '\P{^-_Is_zanabazar_Square}', "");
    Error('\p{ zanb:=}');
    Error('\P{ zanb:=}');
    Expect(1, 72263, '\p{zanb}', "");
    Expect(0, 72263, '\p{^zanb}', "");
    Expect(0, 72263, '\P{zanb}', "");
    Expect(1, 72263, '\P{^zanb}', "");
    Expect(0, 72264, '\p{zanb}', "");
    Expect(1, 72264, '\p{^zanb}', "");
    Expect(1, 72264, '\P{zanb}', "");
    Expect(0, 72264, '\P{^zanb}', "");
    Expect(1, 72263, '\p{_Zanb}', "");
    Expect(0, 72263, '\p{^_Zanb}', "");
    Expect(0, 72263, '\P{_Zanb}', "");
    Expect(1, 72263, '\P{^_Zanb}', "");
    Expect(0, 72264, '\p{_Zanb}', "");
    Expect(1, 72264, '\p{^_Zanb}', "");
    Expect(1, 72264, '\P{_Zanb}', "");
    Expect(0, 72264, '\P{^_Zanb}', "");
    Error('\p{-	Is_ZANB/a/}');
    Error('\P{-	Is_ZANB/a/}');
    Expect(1, 72263, '\p{iszanb}', "");
    Expect(0, 72263, '\p{^iszanb}', "");
    Expect(0, 72263, '\P{iszanb}', "");
    Expect(1, 72263, '\P{^iszanb}', "");
    Expect(0, 72264, '\p{iszanb}', "");
    Expect(1, 72264, '\p{^iszanb}', "");
    Expect(1, 72264, '\P{iszanb}', "");
    Expect(0, 72264, '\P{^iszanb}', "");
    Expect(1, 72263, '\p{	_IS_Zanb}', "");
    Expect(0, 72263, '\p{^	_IS_Zanb}', "");
    Expect(0, 72263, '\P{	_IS_Zanb}', "");
    Expect(1, 72263, '\P{^	_IS_Zanb}', "");
    Expect(0, 72264, '\p{	_IS_Zanb}', "");
    Expect(1, 72264, '\p{^	_IS_Zanb}', "");
    Expect(1, 72264, '\P{	_IS_Zanb}', "");
    Expect(0, 72264, '\P{^	_IS_Zanb}', "");
    Error('\p{perlcharnames}');
    Error('\P{perlcharnames}');
    Error('\p{perldecimaldigit}');
    Error('\P{perldecimaldigit}');
    Error('\p{perldecompositionmapping}');
    Error('\P{perldecompositionmapping}');
    Error('\p{Quotation_Mark=:=	No}');
    Error('\P{Quotation_Mark=:=	No}');
    Expect(1, 65380, '\p{Quotation_Mark=:\ANo\z:}', "");;
    Expect(0, 65379, '\p{Quotation_Mark=:\ANo\z:}', "");;
    Expect(1, 65380, '\p{Quotation_Mark=no}', "");
    Expect(0, 65380, '\p{^Quotation_Mark=no}', "");
    Expect(0, 65380, '\P{Quotation_Mark=no}', "");
    Expect(1, 65380, '\P{^Quotation_Mark=no}', "");
    Expect(0, 65379, '\p{Quotation_Mark=no}', "");
    Expect(1, 65379, '\p{^Quotation_Mark=no}', "");
    Expect(1, 65379, '\P{Quotation_Mark=no}', "");
    Expect(0, 65379, '\P{^Quotation_Mark=no}', "");
    Expect(1, 65380, '\p{Quotation_Mark=:\Ano\z:}', "");;
    Expect(0, 65379, '\p{Quotation_Mark=:\Ano\z:}', "");;
    Expect(1, 65380, '\p{Quotation_Mark=-No}', "");
    Expect(0, 65380, '\p{^Quotation_Mark=-No}', "");
    Expect(0, 65380, '\P{Quotation_Mark=-No}', "");
    Expect(1, 65380, '\P{^Quotation_Mark=-No}', "");
    Expect(0, 65379, '\p{Quotation_Mark=-No}', "");
    Expect(1, 65379, '\p{^Quotation_Mark=-No}', "");
    Expect(1, 65379, '\P{Quotation_Mark=-No}', "");
    Expect(0, 65379, '\P{^Quotation_Mark=-No}', "");
    Error('\p{QMark=:=N}');
    Error('\P{QMark=:=N}');
    Expect(1, 65380, '\p{QMark=:\AN\z:}', "");;
    Expect(0, 65379, '\p{QMark=:\AN\z:}', "");;
    Expect(1, 65380, '\p{QMark=n}', "");
    Expect(0, 65380, '\p{^QMark=n}', "");
    Expect(0, 65380, '\P{QMark=n}', "");
    Expect(1, 65380, '\P{^QMark=n}', "");
    Expect(0, 65379, '\p{QMark=n}', "");
    Expect(1, 65379, '\p{^QMark=n}', "");
    Expect(1, 65379, '\P{QMark=n}', "");
    Expect(0, 65379, '\P{^QMark=n}', "");
    Expect(1, 65380, '\p{QMark=:\An\z:}', "");;
    Expect(0, 65379, '\p{QMark=:\An\z:}', "");;
    Expect(1, 65380, '\p{QMark=	_N}', "");
    Expect(0, 65380, '\p{^QMark=	_N}', "");
    Expect(0, 65380, '\P{QMark=	_N}', "");
    Expect(1, 65380, '\P{^QMark=	_N}', "");
    Expect(0, 65379, '\p{QMark=	_N}', "");
    Expect(1, 65379, '\p{^QMark=	_N}', "");
    Expect(1, 65379, '\P{QMark=	_N}', "");
    Expect(0, 65379, '\P{^QMark=	_N}', "");
    Error('\p{Is_Quotation_Mark=:=F}');
    Error('\P{Is_Quotation_Mark=:=F}');
    Expect(1, 65380, '\p{Is_Quotation_Mark=f}', "");
    Expect(0, 65380, '\p{^Is_Quotation_Mark=f}', "");
    Expect(0, 65380, '\P{Is_Quotation_Mark=f}', "");
    Expect(1, 65380, '\P{^Is_Quotation_Mark=f}', "");
    Expect(0, 65379, '\p{Is_Quotation_Mark=f}', "");
    Expect(1, 65379, '\p{^Is_Quotation_Mark=f}', "");
    Expect(1, 65379, '\P{Is_Quotation_Mark=f}', "");
    Expect(0, 65379, '\P{^Is_Quotation_Mark=f}', "");
    Expect(1, 65380, '\p{Is_Quotation_Mark= _f}', "");
    Expect(0, 65380, '\p{^Is_Quotation_Mark= _f}', "");
    Expect(0, 65380, '\P{Is_Quotation_Mark= _f}', "");
    Expect(1, 65380, '\P{^Is_Quotation_Mark= _f}', "");
    Expect(0, 65379, '\p{Is_Quotation_Mark= _f}', "");
    Expect(1, 65379, '\p{^Is_Quotation_Mark= _f}', "");
    Expect(1, 65379, '\P{Is_Quotation_Mark= _f}', "");
    Expect(0, 65379, '\P{^Is_Quotation_Mark= _f}', "");
    Error('\p{Is_QMark=_false/a/}');
    Error('\P{Is_QMark=_false/a/}');
    Expect(1, 65380, '\p{Is_QMark=false}', "");
    Expect(0, 65380, '\p{^Is_QMark=false}', "");
    Expect(0, 65380, '\P{Is_QMark=false}', "");
    Expect(1, 65380, '\P{^Is_QMark=false}', "");
    Expect(0, 65379, '\p{Is_QMark=false}', "");
    Expect(1, 65379, '\p{^Is_QMark=false}', "");
    Expect(1, 65379, '\P{Is_QMark=false}', "");
    Expect(0, 65379, '\P{^Is_QMark=false}', "");
    Expect(1, 65380, '\p{Is_QMark=_False}', "");
    Expect(0, 65380, '\p{^Is_QMark=_False}', "");
    Expect(0, 65380, '\P{Is_QMark=_False}', "");
    Expect(1, 65380, '\P{^Is_QMark=_False}', "");
    Expect(0, 65379, '\p{Is_QMark=_False}', "");
    Expect(1, 65379, '\p{^Is_QMark=_False}', "");
    Expect(1, 65379, '\P{Is_QMark=_False}', "");
    Expect(0, 65379, '\P{^Is_QMark=_False}', "");
    Error('\p{Quotation_Mark=_:=YES}');
    Error('\P{Quotation_Mark=_:=YES}');
    Expect(1, 65379, '\p{Quotation_Mark=:\AYes\z:}', "");;
    Expect(0, 65380, '\p{Quotation_Mark=:\AYes\z:}', "");;
    Expect(1, 65379, '\p{Quotation_Mark=yes}', "");
    Expect(0, 65379, '\p{^Quotation_Mark=yes}', "");
    Expect(0, 65379, '\P{Quotation_Mark=yes}', "");
    Expect(1, 65379, '\P{^Quotation_Mark=yes}', "");
    Expect(0, 65380, '\p{Quotation_Mark=yes}', "");
    Expect(1, 65380, '\p{^Quotation_Mark=yes}', "");
    Expect(1, 65380, '\P{Quotation_Mark=yes}', "");
    Expect(0, 65380, '\P{^Quotation_Mark=yes}', "");
    Expect(1, 65379, '\p{Quotation_Mark=:\Ayes\z:}', "");;
    Expect(0, 65380, '\p{Quotation_Mark=:\Ayes\z:}', "");;
    Expect(1, 65379, '\p{Quotation_Mark=YES}', "");
    Expect(0, 65379, '\p{^Quotation_Mark=YES}', "");
    Expect(0, 65379, '\P{Quotation_Mark=YES}', "");
    Expect(1, 65379, '\P{^Quotation_Mark=YES}', "");
    Expect(0, 65380, '\p{Quotation_Mark=YES}', "");
    Expect(1, 65380, '\p{^Quotation_Mark=YES}', "");
    Expect(1, 65380, '\P{Quotation_Mark=YES}', "");
    Expect(0, 65380, '\P{^Quotation_Mark=YES}', "");
    Error('\p{QMark=	Y/a/}');
    Error('\P{QMark=	Y/a/}');
    Expect(1, 65379, '\p{QMark=:\AY\z:}', "");;
    Expect(0, 65380, '\p{QMark=:\AY\z:}', "");;
    Expect(1, 65379, '\p{QMark=y}', "");
    Expect(0, 65379, '\p{^QMark=y}', "");
    Expect(0, 65379, '\P{QMark=y}', "");
    Expect(1, 65379, '\P{^QMark=y}', "");
    Expect(0, 65380, '\p{QMark=y}', "");
    Expect(1, 65380, '\p{^QMark=y}', "");
    Expect(1, 65380, '\P{QMark=y}', "");
    Expect(0, 65380, '\P{^QMark=y}', "");
    Expect(1, 65379, '\p{QMark=:\Ay\z:}', "");;
    Expect(0, 65380, '\p{QMark=:\Ay\z:}', "");;
    Expect(1, 65379, '\p{QMark=-y}', "");
    Expect(0, 65379, '\p{^QMark=-y}', "");
    Expect(0, 65379, '\P{QMark=-y}', "");
    Expect(1, 65379, '\P{^QMark=-y}', "");
    Expect(0, 65380, '\p{QMark=-y}', "");
    Expect(1, 65380, '\p{^QMark=-y}', "");
    Expect(1, 65380, '\P{QMark=-y}', "");
    Expect(0, 65380, '\P{^QMark=-y}', "");
    Error('\p{Is_Quotation_Mark=_ T:=}');
    Error('\P{Is_Quotation_Mark=_ T:=}');
    Expect(1, 65379, '\p{Is_Quotation_Mark=t}', "");
    Expect(0, 65379, '\p{^Is_Quotation_Mark=t}', "");
    Expect(0, 65379, '\P{Is_Quotation_Mark=t}', "");
    Expect(1, 65379, '\P{^Is_Quotation_Mark=t}', "");
    Expect(0, 65380, '\p{Is_Quotation_Mark=t}', "");
    Expect(1, 65380, '\p{^Is_Quotation_Mark=t}', "");
    Expect(1, 65380, '\P{Is_Quotation_Mark=t}', "");
    Expect(0, 65380, '\P{^Is_Quotation_Mark=t}', "");
    Expect(1, 65379, '\p{Is_Quotation_Mark=		T}', "");
    Expect(0, 65379, '\p{^Is_Quotation_Mark=		T}', "");
    Expect(0, 65379, '\P{Is_Quotation_Mark=		T}', "");
    Expect(1, 65379, '\P{^Is_Quotation_Mark=		T}', "");
    Expect(0, 65380, '\p{Is_Quotation_Mark=		T}', "");
    Expect(1, 65380, '\p{^Is_Quotation_Mark=		T}', "");
    Expect(1, 65380, '\P{Is_Quotation_Mark=		T}', "");
    Expect(0, 65380, '\P{^Is_Quotation_Mark=		T}', "");
    Error('\p{Is_QMark=:=	TRUE}');
    Error('\P{Is_QMark=:=	TRUE}');
    Expect(1, 65379, '\p{Is_QMark=true}', "");
    Expect(0, 65379, '\p{^Is_QMark=true}', "");
    Expect(0, 65379, '\P{Is_QMark=true}', "");
    Expect(1, 65379, '\P{^Is_QMark=true}', "");
    Expect(0, 65380, '\p{Is_QMark=true}', "");
    Expect(1, 65380, '\p{^Is_QMark=true}', "");
    Expect(1, 65380, '\P{Is_QMark=true}', "");
    Expect(0, 65380, '\P{^Is_QMark=true}', "");
    Expect(1, 65379, '\p{Is_QMark=	true}', "");
    Expect(0, 65379, '\p{^Is_QMark=	true}', "");
    Expect(0, 65379, '\P{Is_QMark=	true}', "");
    Expect(1, 65379, '\P{^Is_QMark=	true}', "");
    Expect(0, 65380, '\p{Is_QMark=	true}', "");
    Expect(1, 65380, '\p{^Is_QMark=	true}', "");
    Expect(1, 65380, '\P{Is_QMark=	true}', "");
    Expect(0, 65380, '\P{^Is_QMark=	true}', "");
    Error('\p{Radical=_no/a/}');
    Error('\P{Radical=_no/a/}');
    Expect(1, 12246, '\p{Radical=:\ANo\z:}', "");;
    Expect(0, 12245, '\p{Radical=:\ANo\z:}', "");;
    Expect(1, 12246, '\p{Radical=no}', "");
    Expect(0, 12246, '\p{^Radical=no}', "");
    Expect(0, 12246, '\P{Radical=no}', "");
    Expect(1, 12246, '\P{^Radical=no}', "");
    Expect(0, 12245, '\p{Radical=no}', "");
    Expect(1, 12245, '\p{^Radical=no}', "");
    Expect(1, 12245, '\P{Radical=no}', "");
    Expect(0, 12245, '\P{^Radical=no}', "");
    Expect(1, 12246, '\p{Radical=:\Ano\z:}', "");;
    Expect(0, 12245, '\p{Radical=:\Ano\z:}', "");;
    Expect(1, 12246, '\p{Radical= -no}', "");
    Expect(0, 12246, '\p{^Radical= -no}', "");
    Expect(0, 12246, '\P{Radical= -no}', "");
    Expect(1, 12246, '\P{^Radical= -no}', "");
    Expect(0, 12245, '\p{Radical= -no}', "");
    Expect(1, 12245, '\p{^Radical= -no}', "");
    Expect(1, 12245, '\P{Radical= -no}', "");
    Expect(0, 12245, '\P{^Radical= -no}', "");
    Error('\p{Is_Radical:   /a/ _N}');
    Error('\P{Is_Radical:   /a/ _N}');
    Expect(1, 12246, '\p{Is_Radical=n}', "");
    Expect(0, 12246, '\p{^Is_Radical=n}', "");
    Expect(0, 12246, '\P{Is_Radical=n}', "");
    Expect(1, 12246, '\P{^Is_Radical=n}', "");
    Expect(0, 12245, '\p{Is_Radical=n}', "");
    Expect(1, 12245, '\p{^Is_Radical=n}', "");
    Expect(1, 12245, '\P{Is_Radical=n}', "");
    Expect(0, 12245, '\P{^Is_Radical=n}', "");
    Expect(1, 12246, '\p{Is_Radical= N}', "");
    Expect(0, 12246, '\p{^Is_Radical= N}', "");
    Expect(0, 12246, '\P{Is_Radical= N}', "");
    Expect(1, 12246, '\P{^Is_Radical= N}', "");
    Expect(0, 12245, '\p{Is_Radical= N}', "");
    Expect(1, 12245, '\p{^Is_Radical= N}', "");
    Expect(1, 12245, '\P{Is_Radical= N}', "");
    Expect(0, 12245, '\P{^Is_Radical= N}', "");
    Error('\p{Radical=:=F}');
    Error('\P{Radical=:=F}');
    Expect(1, 12246, '\p{Radical=:\AF\z:}', "");;
    Expect(0, 12245, '\p{Radical=:\AF\z:}', "");;
    Expect(1, 12246, '\p{Radical=f}', "");
    Expect(0, 12246, '\p{^Radical=f}', "");
    Expect(0, 12246, '\P{Radical=f}', "");
    Expect(1, 12246, '\P{^Radical=f}', "");
    Expect(0, 12245, '\p{Radical=f}', "");
    Expect(1, 12245, '\p{^Radical=f}', "");
    Expect(1, 12245, '\P{Radical=f}', "");
    Expect(0, 12245, '\P{^Radical=f}', "");
    Expect(1, 12246, '\p{Radical=:\Af\z:}', "");;
    Expect(0, 12245, '\p{Radical=:\Af\z:}', "");;
    Expect(1, 12246, '\p{Radical=-	f}', "");
    Expect(0, 12246, '\p{^Radical=-	f}', "");
    Expect(0, 12246, '\P{Radical=-	f}', "");
    Expect(1, 12246, '\P{^Radical=-	f}', "");
    Expect(0, 12245, '\p{Radical=-	f}', "");
    Expect(1, 12245, '\p{^Radical=-	f}', "");
    Expect(1, 12245, '\P{Radical=-	f}', "");
    Expect(0, 12245, '\P{^Radical=-	f}', "");
    Error('\p{Is_Radical=/a/- FALSE}');
    Error('\P{Is_Radical=/a/- FALSE}');
    Expect(1, 12246, '\p{Is_Radical=false}', "");
    Expect(0, 12246, '\p{^Is_Radical=false}', "");
    Expect(0, 12246, '\P{Is_Radical=false}', "");
    Expect(1, 12246, '\P{^Is_Radical=false}', "");
    Expect(0, 12245, '\p{Is_Radical=false}', "");
    Expect(1, 12245, '\p{^Is_Radical=false}', "");
    Expect(1, 12245, '\P{Is_Radical=false}', "");
    Expect(0, 12245, '\P{^Is_Radical=false}', "");
    Expect(1, 12246, '\p{Is_Radical=  FALSE}', "");
    Expect(0, 12246, '\p{^Is_Radical=  FALSE}', "");
    Expect(0, 12246, '\P{Is_Radical=  FALSE}', "");
    Expect(1, 12246, '\P{^Is_Radical=  FALSE}', "");
    Expect(0, 12245, '\p{Is_Radical=  FALSE}', "");
    Expect(1, 12245, '\p{^Is_Radical=  FALSE}', "");
    Expect(1, 12245, '\P{Is_Radical=  FALSE}', "");
    Expect(0, 12245, '\P{^Is_Radical=  FALSE}', "");
    Error('\p{Radical=-:=Yes}');
    Error('\P{Radical=-:=Yes}');
    Expect(1, 12245, '\p{Radical=:\AYes\z:}', "");;
    Expect(0, 12246, '\p{Radical=:\AYes\z:}', "");;
    Expect(1, 12245, '\p{Radical=yes}', "");
    Expect(0, 12245, '\p{^Radical=yes}', "");
    Expect(0, 12245, '\P{Radical=yes}', "");
    Expect(1, 12245, '\P{^Radical=yes}', "");
    Expect(0, 12246, '\p{Radical=yes}', "");
    Expect(1, 12246, '\p{^Radical=yes}', "");
    Expect(1, 12246, '\P{Radical=yes}', "");
    Expect(0, 12246, '\P{^Radical=yes}', "");
    Expect(1, 12245, '\p{Radical=:\Ayes\z:}', "");;
    Expect(0, 12246, '\p{Radical=:\Ayes\z:}', "");;
    Expect(1, 12245, '\p{Radical= yes}', "");
    Expect(0, 12245, '\p{^Radical= yes}', "");
    Expect(0, 12245, '\P{Radical= yes}', "");
    Expect(1, 12245, '\P{^Radical= yes}', "");
    Expect(0, 12246, '\p{Radical= yes}', "");
    Expect(1, 12246, '\p{^Radical= yes}', "");
    Expect(1, 12246, '\P{Radical= yes}', "");
    Expect(0, 12246, '\P{^Radical= yes}', "");
    Error('\p{Is_Radical=:=-Y}');
    Error('\P{Is_Radical=:=-Y}');
    Expect(1, 12245, '\p{Is_Radical=y}', "");
    Expect(0, 12245, '\p{^Is_Radical=y}', "");
    Expect(0, 12245, '\P{Is_Radical=y}', "");
    Expect(1, 12245, '\P{^Is_Radical=y}', "");
    Expect(0, 12246, '\p{Is_Radical=y}', "");
    Expect(1, 12246, '\p{^Is_Radical=y}', "");
    Expect(1, 12246, '\P{Is_Radical=y}', "");
    Expect(0, 12246, '\P{^Is_Radical=y}', "");
    Expect(1, 12245, '\p{Is_Radical:_-Y}', "");
    Expect(0, 12245, '\p{^Is_Radical:_-Y}', "");
    Expect(0, 12245, '\P{Is_Radical:_-Y}', "");
    Expect(1, 12245, '\P{^Is_Radical:_-Y}', "");
    Expect(0, 12246, '\p{Is_Radical:_-Y}', "");
    Expect(1, 12246, '\p{^Is_Radical:_-Y}', "");
    Expect(1, 12246, '\P{Is_Radical:_-Y}', "");
    Expect(0, 12246, '\P{^Is_Radical:_-Y}', "");
    Error('\p{Radical= 	t/a/}');
    Error('\P{Radical= 	t/a/}');
    Expect(1, 12245, '\p{Radical=:\AT\z:}', "");;
    Expect(0, 12246, '\p{Radical=:\AT\z:}', "");;
    Expect(1, 12245, '\p{Radical:	t}', "");
    Expect(0, 12245, '\p{^Radical:	t}', "");
    Expect(0, 12245, '\P{Radical:	t}', "");
    Expect(1, 12245, '\P{^Radical:	t}', "");
    Expect(0, 12246, '\p{Radical:	t}', "");
    Expect(1, 12246, '\p{^Radical:	t}', "");
    Expect(1, 12246, '\P{Radical:	t}', "");
    Expect(0, 12246, '\P{^Radical:	t}', "");
    Expect(1, 12245, '\p{Radical=:\At\z:}', "");;
    Expect(0, 12246, '\p{Radical=:\At\z:}', "");;
    Expect(1, 12245, '\p{Radical=_	T}', "");
    Expect(0, 12245, '\p{^Radical=_	T}', "");
    Expect(0, 12245, '\P{Radical=_	T}', "");
    Expect(1, 12245, '\P{^Radical=_	T}', "");
    Expect(0, 12246, '\p{Radical=_	T}', "");
    Expect(1, 12246, '\p{^Radical=_	T}', "");
    Expect(1, 12246, '\P{Radical=_	T}', "");
    Expect(0, 12246, '\P{^Radical=_	T}', "");
    Error('\p{Is_Radical=:=	 TRUE}');
    Error('\P{Is_Radical=:=	 TRUE}');
    Expect(1, 12245, '\p{Is_Radical=true}', "");
    Expect(0, 12245, '\p{^Is_Radical=true}', "");
    Expect(0, 12245, '\P{Is_Radical=true}', "");
    Expect(1, 12245, '\P{^Is_Radical=true}', "");
    Expect(0, 12246, '\p{Is_Radical=true}', "");
    Expect(1, 12246, '\p{^Is_Radical=true}', "");
    Expect(1, 12246, '\P{Is_Radical=true}', "");
    Expect(0, 12246, '\P{^Is_Radical=true}', "");
    Expect(1, 12245, '\p{Is_Radical= 	True}', "");
    Expect(0, 12245, '\p{^Is_Radical= 	True}', "");
    Expect(0, 12245, '\P{Is_Radical= 	True}', "");
    Expect(1, 12245, '\P{^Is_Radical= 	True}', "");
    Expect(0, 12246, '\p{Is_Radical= 	True}', "");
    Expect(1, 12246, '\p{^Is_Radical= 	True}', "");
    Expect(1, 12246, '\P{Is_Radical= 	True}', "");
    Expect(0, 12246, '\P{^Is_Radical= 	True}', "");
    Error('\p{Regional_Indicator=	 NO/a/}');
    Error('\P{Regional_Indicator=	 NO/a/}');
    Expect(1, 127488, '\p{Regional_Indicator=:\ANo\z:}', "");;
    Expect(0, 127487, '\p{Regional_Indicator=:\ANo\z:}', "");;
    Expect(1, 127488, '\p{Regional_Indicator:   no}', "");
    Expect(0, 127488, '\p{^Regional_Indicator:   no}', "");
    Expect(0, 127488, '\P{Regional_Indicator:   no}', "");
    Expect(1, 127488, '\P{^Regional_Indicator:   no}', "");
    Expect(0, 127487, '\p{Regional_Indicator:   no}', "");
    Expect(1, 127487, '\p{^Regional_Indicator:   no}', "");
    Expect(1, 127487, '\P{Regional_Indicator:   no}', "");
    Expect(0, 127487, '\P{^Regional_Indicator:   no}', "");
    Expect(1, 127488, '\p{Regional_Indicator=:\Ano\z:}', "");;
    Expect(0, 127487, '\p{Regional_Indicator=:\Ano\z:}', "");;
    Expect(1, 127488, '\p{Regional_Indicator=_-No}', "");
    Expect(0, 127488, '\p{^Regional_Indicator=_-No}', "");
    Expect(0, 127488, '\P{Regional_Indicator=_-No}', "");
    Expect(1, 127488, '\P{^Regional_Indicator=_-No}', "");
    Expect(0, 127487, '\p{Regional_Indicator=_-No}', "");
    Expect(1, 127487, '\p{^Regional_Indicator=_-No}', "");
    Expect(1, 127487, '\P{Regional_Indicator=_-No}', "");
    Expect(0, 127487, '\P{^Regional_Indicator=_-No}', "");
    Error('\p{RI=-	N:=}');
    Error('\P{RI=-	N:=}');
    Expect(1, 127488, '\p{RI=:\AN\z:}', "");;
    Expect(0, 127487, '\p{RI=:\AN\z:}', "");;
    Expect(1, 127488, '\p{RI=n}', "");
    Expect(0, 127488, '\p{^RI=n}', "");
    Expect(0, 127488, '\P{RI=n}', "");
    Expect(1, 127488, '\P{^RI=n}', "");
    Expect(0, 127487, '\p{RI=n}', "");
    Expect(1, 127487, '\p{^RI=n}', "");
    Expect(1, 127487, '\P{RI=n}', "");
    Expect(0, 127487, '\P{^RI=n}', "");
    Expect(1, 127488, '\p{RI=:\An\z:}', "");;
    Expect(0, 127487, '\p{RI=:\An\z:}', "");;
    Expect(1, 127488, '\p{RI=	 N}', "");
    Expect(0, 127488, '\p{^RI=	 N}', "");
    Expect(0, 127488, '\P{RI=	 N}', "");
    Expect(1, 127488, '\P{^RI=	 N}', "");
    Expect(0, 127487, '\p{RI=	 N}', "");
    Expect(1, 127487, '\p{^RI=	 N}', "");
    Expect(1, 127487, '\P{RI=	 N}', "");
    Expect(0, 127487, '\P{^RI=	 N}', "");
    Error('\p{Is_Regional_Indicator= /a/F}');
    Error('\P{Is_Regional_Indicator= /a/F}');
    Expect(1, 127488, '\p{Is_Regional_Indicator=f}', "");
    Expect(0, 127488, '\p{^Is_Regional_Indicator=f}', "");
    Expect(0, 127488, '\P{Is_Regional_Indicator=f}', "");
    Expect(1, 127488, '\P{^Is_Regional_Indicator=f}', "");
    Expect(0, 127487, '\p{Is_Regional_Indicator=f}', "");
    Expect(1, 127487, '\p{^Is_Regional_Indicator=f}', "");
    Expect(1, 127487, '\P{Is_Regional_Indicator=f}', "");
    Expect(0, 127487, '\P{^Is_Regional_Indicator=f}', "");
    Expect(1, 127488, '\p{Is_Regional_Indicator=-	F}', "");
    Expect(0, 127488, '\p{^Is_Regional_Indicator=-	F}', "");
    Expect(0, 127488, '\P{Is_Regional_Indicator=-	F}', "");
    Expect(1, 127488, '\P{^Is_Regional_Indicator=-	F}', "");
    Expect(0, 127487, '\p{Is_Regional_Indicator=-	F}', "");
    Expect(1, 127487, '\p{^Is_Regional_Indicator=-	F}', "");
    Expect(1, 127487, '\P{Is_Regional_Indicator=-	F}', "");
    Expect(0, 127487, '\P{^Is_Regional_Indicator=-	F}', "");
    Error('\p{Is_RI=	/a/false}');
    Error('\P{Is_RI=	/a/false}');
    Expect(1, 127488, '\p{Is_RI:   false}', "");
    Expect(0, 127488, '\p{^Is_RI:   false}', "");
    Expect(0, 127488, '\P{Is_RI:   false}', "");
    Expect(1, 127488, '\P{^Is_RI:   false}', "");
    Expect(0, 127487, '\p{Is_RI:   false}', "");
    Expect(1, 127487, '\p{^Is_RI:   false}', "");
    Expect(1, 127487, '\P{Is_RI:   false}', "");
    Expect(0, 127487, '\P{^Is_RI:   false}', "");
    Expect(1, 127488, '\p{Is_RI=	false}', "");
    Expect(0, 127488, '\p{^Is_RI=	false}', "");
    Expect(0, 127488, '\P{Is_RI=	false}', "");
    Expect(1, 127488, '\P{^Is_RI=	false}', "");
    Expect(0, 127487, '\p{Is_RI=	false}', "");
    Expect(1, 127487, '\p{^Is_RI=	false}', "");
    Expect(1, 127487, '\P{Is_RI=	false}', "");
    Expect(0, 127487, '\P{^Is_RI=	false}', "");
    Error('\p{Regional_Indicator= yes/a/}');
    Error('\P{Regional_Indicator= yes/a/}');
    Expect(1, 127487, '\p{Regional_Indicator=:\AYes\z:}', "");;
    Expect(0, 127488, '\p{Regional_Indicator=:\AYes\z:}', "");;
    Expect(1, 127487, '\p{Regional_Indicator=yes}', "");
    Expect(0, 127487, '\p{^Regional_Indicator=yes}', "");
    Expect(0, 127487, '\P{Regional_Indicator=yes}', "");
    Expect(1, 127487, '\P{^Regional_Indicator=yes}', "");
    Expect(0, 127488, '\p{Regional_Indicator=yes}', "");
    Expect(1, 127488, '\p{^Regional_Indicator=yes}', "");
    Expect(1, 127488, '\P{Regional_Indicator=yes}', "");
    Expect(0, 127488, '\P{^Regional_Indicator=yes}', "");
    Expect(1, 127487, '\p{Regional_Indicator=:\Ayes\z:}', "");;
    Expect(0, 127488, '\p{Regional_Indicator=:\Ayes\z:}', "");;
    Expect(1, 127487, '\p{Regional_Indicator=  Yes}', "");
    Expect(0, 127487, '\p{^Regional_Indicator=  Yes}', "");
    Expect(0, 127487, '\P{Regional_Indicator=  Yes}', "");
    Expect(1, 127487, '\P{^Regional_Indicator=  Yes}', "");
    Expect(0, 127488, '\p{Regional_Indicator=  Yes}', "");
    Expect(1, 127488, '\p{^Regional_Indicator=  Yes}', "");
    Expect(1, 127488, '\P{Regional_Indicator=  Yes}', "");
    Expect(0, 127488, '\P{^Regional_Indicator=  Yes}', "");
    Error('\p{RI= Y:=}');
    Error('\P{RI= Y:=}');
    Expect(1, 127487, '\p{RI=:\AY\z:}', "");;
    Expect(0, 127488, '\p{RI=:\AY\z:}', "");;
    Expect(1, 127487, '\p{RI=y}', "");
    Expect(0, 127487, '\p{^RI=y}', "");
    Expect(0, 127487, '\P{RI=y}', "");
    Expect(1, 127487, '\P{^RI=y}', "");
    Expect(0, 127488, '\p{RI=y}', "");
    Expect(1, 127488, '\p{^RI=y}', "");
    Expect(1, 127488, '\P{RI=y}', "");
    Expect(0, 127488, '\P{^RI=y}', "");
    Expect(1, 127487, '\p{RI=:\Ay\z:}', "");;
    Expect(0, 127488, '\p{RI=:\Ay\z:}', "");;
    Expect(1, 127487, '\p{RI=	-Y}', "");
    Expect(0, 127487, '\p{^RI=	-Y}', "");
    Expect(0, 127487, '\P{RI=	-Y}', "");
    Expect(1, 127487, '\P{^RI=	-Y}', "");
    Expect(0, 127488, '\p{RI=	-Y}', "");
    Expect(1, 127488, '\p{^RI=	-Y}', "");
    Expect(1, 127488, '\P{RI=	-Y}', "");
    Expect(0, 127488, '\P{^RI=	-Y}', "");
    Error('\p{Is_Regional_Indicator=	:=t}');
    Error('\P{Is_Regional_Indicator=	:=t}');
    Expect(1, 127487, '\p{Is_Regional_Indicator=t}', "");
    Expect(0, 127487, '\p{^Is_Regional_Indicator=t}', "");
    Expect(0, 127487, '\P{Is_Regional_Indicator=t}', "");
    Expect(1, 127487, '\P{^Is_Regional_Indicator=t}', "");
    Expect(0, 127488, '\p{Is_Regional_Indicator=t}', "");
    Expect(1, 127488, '\p{^Is_Regional_Indicator=t}', "");
    Expect(1, 127488, '\P{Is_Regional_Indicator=t}', "");
    Expect(0, 127488, '\P{^Is_Regional_Indicator=t}', "");
    Expect(1, 127487, '\p{Is_Regional_Indicator:-T}', "");
    Expect(0, 127487, '\p{^Is_Regional_Indicator:-T}', "");
    Expect(0, 127487, '\P{Is_Regional_Indicator:-T}', "");
    Expect(1, 127487, '\P{^Is_Regional_Indicator:-T}', "");
    Expect(0, 127488, '\p{Is_Regional_Indicator:-T}', "");
    Expect(1, 127488, '\p{^Is_Regional_Indicator:-T}', "");
    Expect(1, 127488, '\P{Is_Regional_Indicator:-T}', "");
    Expect(0, 127488, '\P{^Is_Regional_Indicator:-T}', "");
    Error('\p{Is_RI=:=true}');
    Error('\P{Is_RI=:=true}');
    Expect(1, 127487, '\p{Is_RI=true}', "");
    Expect(0, 127487, '\p{^Is_RI=true}', "");
    Expect(0, 127487, '\P{Is_RI=true}', "");
    Expect(1, 127487, '\P{^Is_RI=true}', "");
    Expect(0, 127488, '\p{Is_RI=true}', "");
    Expect(1, 127488, '\p{^Is_RI=true}', "");
    Expect(1, 127488, '\P{Is_RI=true}', "");
    Expect(0, 127488, '\P{^Is_RI=true}', "");
    Expect(1, 127487, '\p{Is_RI=_ True}', "");
    Expect(0, 127487, '\p{^Is_RI=_ True}', "");
    Expect(0, 127487, '\P{Is_RI=_ True}', "");
    Expect(1, 127487, '\P{^Is_RI=_ True}', "");
    Expect(0, 127488, '\p{Is_RI=_ True}', "");
    Expect(1, 127488, '\p{^Is_RI=_ True}', "");
    Expect(1, 127488, '\P{Is_RI=_ True}', "");
    Expect(0, 127488, '\P{^Is_RI=_ True}', "");
    Error('\p{sentencebreak}');
    Error('\P{sentencebreak}');
    Error('\p{sb}');
    Error('\P{sb}');
    Error('\p{_perlsb}');
    Error('\P{_perlsb}');
    Error('\p{Sentence_Break=/a/_ATerm}');
    Error('\P{Sentence_Break=/a/_ATerm}');
    Expect(1, 65294, '\p{Sentence_Break=:\AATerm\z:}', "");;
    Expect(0, 65295, '\p{Sentence_Break=:\AATerm\z:}', "");;
    Expect(1, 65294, '\p{Sentence_Break=aterm}', "");
    Expect(0, 65294, '\p{^Sentence_Break=aterm}', "");
    Expect(0, 65294, '\P{Sentence_Break=aterm}', "");
    Expect(1, 65294, '\P{^Sentence_Break=aterm}', "");
    Expect(0, 65295, '\p{Sentence_Break=aterm}', "");
    Expect(1, 65295, '\p{^Sentence_Break=aterm}', "");
    Expect(1, 65295, '\P{Sentence_Break=aterm}', "");
    Expect(0, 65295, '\P{^Sentence_Break=aterm}', "");
    Expect(1, 65294, '\p{Sentence_Break=:\Aaterm\z:}', "");;
    Expect(0, 65295, '\p{Sentence_Break=:\Aaterm\z:}', "");;
    Expect(1, 65294, '\p{Sentence_Break=_ aterm}', "");
    Expect(0, 65294, '\p{^Sentence_Break=_ aterm}', "");
    Expect(0, 65294, '\P{Sentence_Break=_ aterm}', "");
    Expect(1, 65294, '\P{^Sentence_Break=_ aterm}', "");
    Expect(0, 65295, '\p{Sentence_Break=_ aterm}', "");
    Expect(1, 65295, '\p{^Sentence_Break=_ aterm}', "");
    Expect(1, 65295, '\P{Sentence_Break=_ aterm}', "");
    Expect(0, 65295, '\P{^Sentence_Break=_ aterm}', "");
    Error('\p{SB=:=- AT}');
    Error('\P{SB=:=- AT}');
    Expect(1, 65294, '\p{SB=:\AAT\z:}', "");;
    Expect(0, 65295, '\p{SB=:\AAT\z:}', "");;
    Expect(1, 65294, '\p{SB:	at}', "");
    Expect(0, 65294, '\p{^SB:	at}', "");
    Expect(0, 65294, '\P{SB:	at}', "");
    Expect(1, 65294, '\P{^SB:	at}', "");
    Expect(0, 65295, '\p{SB:	at}', "");
    Expect(1, 65295, '\p{^SB:	at}', "");
    Expect(1, 65295, '\P{SB:	at}', "");
    Expect(0, 65295, '\P{^SB:	at}', "");
    Expect(1, 65294, '\p{SB=:\Aat\z:}', "");;
    Expect(0, 65295, '\p{SB=:\Aat\z:}', "");;
    Expect(1, 65294, '\p{SB=	 at}', "");
    Expect(0, 65294, '\p{^SB=	 at}', "");
    Expect(0, 65294, '\P{SB=	 at}', "");
    Expect(1, 65294, '\P{^SB=	 at}', "");
    Expect(0, 65295, '\p{SB=	 at}', "");
    Expect(1, 65295, '\p{^SB=	 at}', "");
    Expect(1, 65295, '\P{SB=	 at}', "");
    Expect(0, 65295, '\P{^SB=	 at}', "");
    Error('\p{Is_Sentence_Break=__ATERM/a/}');
    Error('\P{Is_Sentence_Break=__ATERM/a/}');
    Expect(1, 65294, '\p{Is_Sentence_Break=aterm}', "");
    Expect(0, 65294, '\p{^Is_Sentence_Break=aterm}', "");
    Expect(0, 65294, '\P{Is_Sentence_Break=aterm}', "");
    Expect(1, 65294, '\P{^Is_Sentence_Break=aterm}', "");
    Expect(0, 65295, '\p{Is_Sentence_Break=aterm}', "");
    Expect(1, 65295, '\p{^Is_Sentence_Break=aterm}', "");
    Expect(1, 65295, '\P{Is_Sentence_Break=aterm}', "");
    Expect(0, 65295, '\P{^Is_Sentence_Break=aterm}', "");
    Expect(1, 65294, '\p{Is_Sentence_Break= _ATERM}', "");
    Expect(0, 65294, '\p{^Is_Sentence_Break= _ATERM}', "");
    Expect(0, 65294, '\P{Is_Sentence_Break= _ATERM}', "");
    Expect(1, 65294, '\P{^Is_Sentence_Break= _ATERM}', "");
    Expect(0, 65295, '\p{Is_Sentence_Break= _ATERM}', "");
    Expect(1, 65295, '\p{^Is_Sentence_Break= _ATERM}', "");
    Expect(1, 65295, '\P{Is_Sentence_Break= _ATERM}', "");
    Expect(0, 65295, '\P{^Is_Sentence_Break= _ATERM}', "");
    Error('\p{Is_SB=_/a/AT}');
    Error('\P{Is_SB=_/a/AT}');
    Expect(1, 65294, '\p{Is_SB=at}', "");
    Expect(0, 65294, '\p{^Is_SB=at}', "");
    Expect(0, 65294, '\P{Is_SB=at}', "");
    Expect(1, 65294, '\P{^Is_SB=at}', "");
    Expect(0, 65295, '\p{Is_SB=at}', "");
    Expect(1, 65295, '\p{^Is_SB=at}', "");
    Expect(1, 65295, '\P{Is_SB=at}', "");
    Expect(0, 65295, '\P{^Is_SB=at}', "");
    Expect(1, 65294, '\p{Is_SB=	at}', "");
    Expect(0, 65294, '\p{^Is_SB=	at}', "");
    Expect(0, 65294, '\P{Is_SB=	at}', "");
    Expect(1, 65294, '\P{^Is_SB=	at}', "");
    Expect(0, 65295, '\p{Is_SB=	at}', "");
    Expect(1, 65295, '\p{^Is_SB=	at}', "");
    Expect(1, 65295, '\P{Is_SB=	at}', "");
    Expect(0, 65295, '\P{^Is_SB=	at}', "");
    Error('\p{Sentence_Break:   -Close:=}');
    Error('\P{Sentence_Break:   -Close:=}');
    Expect(1, 128632, '\p{Sentence_Break=:\AClose\z:}', "");;
    Expect(0, 128633, '\p{Sentence_Break=:\AClose\z:}', "");;
    Expect(1, 128632, '\p{Sentence_Break=close}', "");
    Expect(0, 128632, '\p{^Sentence_Break=close}', "");
    Expect(0, 128632, '\P{Sentence_Break=close}', "");
    Expect(1, 128632, '\P{^Sentence_Break=close}', "");
    Expect(0, 128633, '\p{Sentence_Break=close}', "");
    Expect(1, 128633, '\p{^Sentence_Break=close}', "");
    Expect(1, 128633, '\P{Sentence_Break=close}', "");
    Expect(0, 128633, '\P{^Sentence_Break=close}', "");
    Expect(1, 128632, '\p{Sentence_Break=:\Aclose\z:}', "");;
    Expect(0, 128633, '\p{Sentence_Break=:\Aclose\z:}', "");;
    Expect(1, 128632, '\p{Sentence_Break=  CLOSE}', "");
    Expect(0, 128632, '\p{^Sentence_Break=  CLOSE}', "");
    Expect(0, 128632, '\P{Sentence_Break=  CLOSE}', "");
    Expect(1, 128632, '\P{^Sentence_Break=  CLOSE}', "");
    Expect(0, 128633, '\p{Sentence_Break=  CLOSE}', "");
    Expect(1, 128633, '\p{^Sentence_Break=  CLOSE}', "");
    Expect(1, 128633, '\P{Sentence_Break=  CLOSE}', "");
    Expect(0, 128633, '\P{^Sentence_Break=  CLOSE}', "");
    Error('\p{SB=	-cl:=}');
    Error('\P{SB=	-cl:=}');
    Expect(1, 128632, '\p{SB=:\ACL\z:}', "");;
    Expect(0, 128633, '\p{SB=:\ACL\z:}', "");;
    Expect(1, 128632, '\p{SB:cl}', "");
    Expect(0, 128632, '\p{^SB:cl}', "");
    Expect(0, 128632, '\P{SB:cl}', "");
    Expect(1, 128632, '\P{^SB:cl}', "");
    Expect(0, 128633, '\p{SB:cl}', "");
    Expect(1, 128633, '\p{^SB:cl}', "");
    Expect(1, 128633, '\P{SB:cl}', "");
    Expect(0, 128633, '\P{^SB:cl}', "");
    Expect(1, 128632, '\p{SB=:\Acl\z:}', "");;
    Expect(0, 128633, '\p{SB=:\Acl\z:}', "");;
    Expect(1, 128632, '\p{SB=CL}', "");
    Expect(0, 128632, '\p{^SB=CL}', "");
    Expect(0, 128632, '\P{SB=CL}', "");
    Expect(1, 128632, '\P{^SB=CL}', "");
    Expect(0, 128633, '\p{SB=CL}', "");
    Expect(1, 128633, '\p{^SB=CL}', "");
    Expect(1, 128633, '\P{SB=CL}', "");
    Expect(0, 128633, '\P{^SB=CL}', "");
    Error('\p{Is_Sentence_Break: _Close/a/}');
    Error('\P{Is_Sentence_Break: _Close/a/}');
    Expect(1, 128632, '\p{Is_Sentence_Break=close}', "");
    Expect(0, 128632, '\p{^Is_Sentence_Break=close}', "");
    Expect(0, 128632, '\P{Is_Sentence_Break=close}', "");
    Expect(1, 128632, '\P{^Is_Sentence_Break=close}', "");
    Expect(0, 128633, '\p{Is_Sentence_Break=close}', "");
    Expect(1, 128633, '\p{^Is_Sentence_Break=close}', "");
    Expect(1, 128633, '\P{Is_Sentence_Break=close}', "");
    Expect(0, 128633, '\P{^Is_Sentence_Break=close}', "");
    Expect(1, 128632, '\p{Is_Sentence_Break= Close}', "");
    Expect(0, 128632, '\p{^Is_Sentence_Break= Close}', "");
    Expect(0, 128632, '\P{Is_Sentence_Break= Close}', "");
    Expect(1, 128632, '\P{^Is_Sentence_Break= Close}', "");
    Expect(0, 128633, '\p{Is_Sentence_Break= Close}', "");
    Expect(1, 128633, '\p{^Is_Sentence_Break= Close}', "");
    Expect(1, 128633, '\P{Is_Sentence_Break= Close}', "");
    Expect(0, 128633, '\P{^Is_Sentence_Break= Close}', "");
    Error('\p{Is_SB=/a/	-CL}');
    Error('\P{Is_SB=/a/	-CL}');
    Expect(1, 128632, '\p{Is_SB:   cl}', "");
    Expect(0, 128632, '\p{^Is_SB:   cl}', "");
    Expect(0, 128632, '\P{Is_SB:   cl}', "");
    Expect(1, 128632, '\P{^Is_SB:   cl}', "");
    Expect(0, 128633, '\p{Is_SB:   cl}', "");
    Expect(1, 128633, '\p{^Is_SB:   cl}', "");
    Expect(1, 128633, '\P{Is_SB:   cl}', "");
    Expect(0, 128633, '\P{^Is_SB:   cl}', "");
    Expect(1, 128632, '\p{Is_SB=  cl}', "");
    Expect(0, 128632, '\p{^Is_SB=  cl}', "");
    Expect(0, 128632, '\P{Is_SB=  cl}', "");
    Expect(1, 128632, '\P{^Is_SB=  cl}', "");
    Expect(0, 128633, '\p{Is_SB=  cl}', "");
    Expect(1, 128633, '\p{^Is_SB=  cl}', "");
    Expect(1, 128633, '\P{Is_SB=  cl}', "");
    Expect(0, 128633, '\P{^Is_SB=  cl}', "");
    Error('\p{Sentence_Break=	_CR/a/}');
    Error('\P{Sentence_Break=	_CR/a/}');
    Expect(1, 13, '\p{Sentence_Break=:\ACR\z:}', "");;
    Expect(0, 14, '\p{Sentence_Break=:\ACR\z:}', "");;
    Expect(1, 13, '\p{Sentence_Break=cr}', "");
    Expect(0, 13, '\p{^Sentence_Break=cr}', "");
    Expect(0, 13, '\P{Sentence_Break=cr}', "");
    Expect(1, 13, '\P{^Sentence_Break=cr}', "");
    Expect(0, 14, '\p{Sentence_Break=cr}', "");
    Expect(1, 14, '\p{^Sentence_Break=cr}', "");
    Expect(1, 14, '\P{Sentence_Break=cr}', "");
    Expect(0, 14, '\P{^Sentence_Break=cr}', "");
    Expect(1, 13, '\p{Sentence_Break=:\Acr\z:}', "");;
    Expect(0, 14, '\p{Sentence_Break=:\Acr\z:}', "");;
    Expect(1, 13, '\p{Sentence_Break:_CR}', "");
    Expect(0, 13, '\p{^Sentence_Break:_CR}', "");
    Expect(0, 13, '\P{Sentence_Break:_CR}', "");
    Expect(1, 13, '\P{^Sentence_Break:_CR}', "");
    Expect(0, 14, '\p{Sentence_Break:_CR}', "");
    Expect(1, 14, '\p{^Sentence_Break:_CR}', "");
    Expect(1, 14, '\P{Sentence_Break:_CR}', "");
    Expect(0, 14, '\P{^Sentence_Break:_CR}', "");
    Error('\p{SB=cr/a/}');
    Error('\P{SB=cr/a/}');
    Expect(1, 13, '\p{SB=:\ACR\z:}', "");;
    Expect(0, 14, '\p{SB=:\ACR\z:}', "");;
    Expect(1, 13, '\p{SB: cr}', "");
    Expect(0, 13, '\p{^SB: cr}', "");
    Expect(0, 13, '\P{SB: cr}', "");
    Expect(1, 13, '\P{^SB: cr}', "");
    Expect(0, 14, '\p{SB: cr}', "");
    Expect(1, 14, '\p{^SB: cr}', "");
    Expect(1, 14, '\P{SB: cr}', "");
    Expect(0, 14, '\P{^SB: cr}', "");
    Expect(1, 13, '\p{SB=:\Acr\z:}', "");;
    Expect(0, 14, '\p{SB=:\Acr\z:}', "");;
    Expect(1, 13, '\p{SB:	_CR}', "");
    Expect(0, 13, '\p{^SB:	_CR}', "");
    Expect(0, 13, '\P{SB:	_CR}', "");
    Expect(1, 13, '\P{^SB:	_CR}', "");
    Expect(0, 14, '\p{SB:	_CR}', "");
    Expect(1, 14, '\p{^SB:	_CR}', "");
    Expect(1, 14, '\P{SB:	_CR}', "");
    Expect(0, 14, '\P{^SB:	_CR}', "");
    Error('\p{Is_Sentence_Break= -CR/a/}');
    Error('\P{Is_Sentence_Break= -CR/a/}');
    Expect(1, 13, '\p{Is_Sentence_Break=cr}', "");
    Expect(0, 13, '\p{^Is_Sentence_Break=cr}', "");
    Expect(0, 13, '\P{Is_Sentence_Break=cr}', "");
    Expect(1, 13, '\P{^Is_Sentence_Break=cr}', "");
    Expect(0, 14, '\p{Is_Sentence_Break=cr}', "");
    Expect(1, 14, '\p{^Is_Sentence_Break=cr}', "");
    Expect(1, 14, '\P{Is_Sentence_Break=cr}', "");
    Expect(0, 14, '\P{^Is_Sentence_Break=cr}', "");
    Expect(1, 13, '\p{Is_Sentence_Break=_CR}', "");
    Expect(0, 13, '\p{^Is_Sentence_Break=_CR}', "");
    Expect(0, 13, '\P{Is_Sentence_Break=_CR}', "");
    Expect(1, 13, '\P{^Is_Sentence_Break=_CR}', "");
    Expect(0, 14, '\p{Is_Sentence_Break=_CR}', "");
    Expect(1, 14, '\p{^Is_Sentence_Break=_CR}', "");
    Expect(1, 14, '\P{Is_Sentence_Break=_CR}', "");
    Expect(0, 14, '\P{^Is_Sentence_Break=_CR}', "");
    Error('\p{Is_SB=:=-CR}');
    Error('\P{Is_SB=:=-CR}');
    Expect(1, 13, '\p{Is_SB=cr}', "");
    Expect(0, 13, '\p{^Is_SB=cr}', "");
    Expect(0, 13, '\P{Is_SB=cr}', "");
    Expect(1, 13, '\P{^Is_SB=cr}', "");
    Expect(0, 14, '\p{Is_SB=cr}', "");
    Expect(1, 14, '\p{^Is_SB=cr}', "");
    Expect(1, 14, '\P{Is_SB=cr}', "");
    Expect(0, 14, '\P{^Is_SB=cr}', "");
    Expect(1, 13, '\p{Is_SB=	 CR}', "");
    Expect(0, 13, '\p{^Is_SB=	 CR}', "");
    Expect(0, 13, '\P{Is_SB=	 CR}', "");
    Expect(1, 13, '\P{^Is_SB=	 CR}', "");
    Expect(0, 14, '\p{Is_SB=	 CR}', "");
    Expect(1, 14, '\p{^Is_SB=	 CR}', "");
    Expect(1, 14, '\P{Is_SB=	 CR}', "");
    Expect(0, 14, '\P{^Is_SB=	 CR}', "");
    Error('\p{Sentence_Break=	Extend:=}');
    Error('\P{Sentence_Break=	Extend:=}');
    Expect(1, 917999, '\p{Sentence_Break=:\AExtend\z:}', "");;
    Expect(0, 918000, '\p{Sentence_Break=:\AExtend\z:}', "");;
    Expect(1, 917999, '\p{Sentence_Break=extend}', "");
    Expect(0, 917999, '\p{^Sentence_Break=extend}', "");
    Expect(0, 917999, '\P{Sentence_Break=extend}', "");
    Expect(1, 917999, '\P{^Sentence_Break=extend}', "");
    Expect(0, 918000, '\p{Sentence_Break=extend}', "");
    Expect(1, 918000, '\p{^Sentence_Break=extend}', "");
    Expect(1, 918000, '\P{Sentence_Break=extend}', "");
    Expect(0, 918000, '\P{^Sentence_Break=extend}', "");
    Expect(1, 917999, '\p{Sentence_Break=:\Aextend\z:}', "");;
    Expect(0, 918000, '\p{Sentence_Break=:\Aextend\z:}', "");;
    Expect(1, 917999, '\p{Sentence_Break=__EXTEND}', "");
    Expect(0, 917999, '\p{^Sentence_Break=__EXTEND}', "");
    Expect(0, 917999, '\P{Sentence_Break=__EXTEND}', "");
    Expect(1, 917999, '\P{^Sentence_Break=__EXTEND}', "");
    Expect(0, 918000, '\p{Sentence_Break=__EXTEND}', "");
    Expect(1, 918000, '\p{^Sentence_Break=__EXTEND}', "");
    Expect(1, 918000, '\P{Sentence_Break=__EXTEND}', "");
    Expect(0, 918000, '\P{^Sentence_Break=__EXTEND}', "");
    Error('\p{SB= /a/EX}');
    Error('\P{SB= /a/EX}');
    Expect(1, 917999, '\p{SB=:\AEX\z:}', "");;
    Expect(0, 918000, '\p{SB=:\AEX\z:}', "");;
    Expect(1, 917999, '\p{SB=ex}', "");
    Expect(0, 917999, '\p{^SB=ex}', "");
    Expect(0, 917999, '\P{SB=ex}', "");
    Expect(1, 917999, '\P{^SB=ex}', "");
    Expect(0, 918000, '\p{SB=ex}', "");
    Expect(1, 918000, '\p{^SB=ex}', "");
    Expect(1, 918000, '\P{SB=ex}', "");
    Expect(0, 918000, '\P{^SB=ex}', "");
    Expect(1, 917999, '\p{SB=:\Aex\z:}', "");;
    Expect(0, 918000, '\p{SB=:\Aex\z:}', "");;
    Expect(1, 917999, '\p{SB=--ex}', "");
    Expect(0, 917999, '\p{^SB=--ex}', "");
    Expect(0, 917999, '\P{SB=--ex}', "");
    Expect(1, 917999, '\P{^SB=--ex}', "");
    Expect(0, 918000, '\p{SB=--ex}', "");
    Expect(1, 918000, '\p{^SB=--ex}', "");
    Expect(1, 918000, '\P{SB=--ex}', "");
    Expect(0, 918000, '\P{^SB=--ex}', "");
    Error('\p{Is_Sentence_Break=_/a/Extend}');
    Error('\P{Is_Sentence_Break=_/a/Extend}');
    Expect(1, 917999, '\p{Is_Sentence_Break=extend}', "");
    Expect(0, 917999, '\p{^Is_Sentence_Break=extend}', "");
    Expect(0, 917999, '\P{Is_Sentence_Break=extend}', "");
    Expect(1, 917999, '\P{^Is_Sentence_Break=extend}', "");
    Expect(0, 918000, '\p{Is_Sentence_Break=extend}', "");
    Expect(1, 918000, '\p{^Is_Sentence_Break=extend}', "");
    Expect(1, 918000, '\P{Is_Sentence_Break=extend}', "");
    Expect(0, 918000, '\P{^Is_Sentence_Break=extend}', "");
    Expect(1, 917999, '\p{Is_Sentence_Break= Extend}', "");
    Expect(0, 917999, '\p{^Is_Sentence_Break= Extend}', "");
    Expect(0, 917999, '\P{Is_Sentence_Break= Extend}', "");
    Expect(1, 917999, '\P{^Is_Sentence_Break= Extend}', "");
    Expect(0, 918000, '\p{Is_Sentence_Break= Extend}', "");
    Expect(1, 918000, '\p{^Is_Sentence_Break= Extend}', "");
    Expect(1, 918000, '\P{Is_Sentence_Break= Extend}', "");
    Expect(0, 918000, '\P{^Is_Sentence_Break= Extend}', "");
    Error('\p{Is_SB:	_:=EX}');
    Error('\P{Is_SB:	_:=EX}');
    Expect(1, 917999, '\p{Is_SB=ex}', "");
    Expect(0, 917999, '\p{^Is_SB=ex}', "");
    Expect(0, 917999, '\P{Is_SB=ex}', "");
    Expect(1, 917999, '\P{^Is_SB=ex}', "");
    Expect(0, 918000, '\p{Is_SB=ex}', "");
    Expect(1, 918000, '\p{^Is_SB=ex}', "");
    Expect(1, 918000, '\P{Is_SB=ex}', "");
    Expect(0, 918000, '\P{^Is_SB=ex}', "");
    Expect(1, 917999, '\p{Is_SB=_	EX}', "");
    Expect(0, 917999, '\p{^Is_SB=_	EX}', "");
    Expect(0, 917999, '\P{Is_SB=_	EX}', "");
    Expect(1, 917999, '\P{^Is_SB=_	EX}', "");
    Expect(0, 918000, '\p{Is_SB=_	EX}', "");
    Expect(1, 918000, '\p{^Is_SB=_	EX}', "");
    Expect(1, 918000, '\P{Is_SB=_	EX}', "");
    Expect(0, 918000, '\P{^Is_SB=_	EX}', "");
    Error('\p{Sentence_Break=/a/FORMAT}');
    Error('\P{Sentence_Break=/a/FORMAT}');
    Expect(1, 917505, '\p{Sentence_Break=:\AFormat\z:}', "");;
    Expect(0, 917506, '\p{Sentence_Break=:\AFormat\z:}', "");;
    Expect(1, 917505, '\p{Sentence_Break=format}', "");
    Expect(0, 917505, '\p{^Sentence_Break=format}', "");
    Expect(0, 917505, '\P{Sentence_Break=format}', "");
    Expect(1, 917505, '\P{^Sentence_Break=format}', "");
    Expect(0, 917506, '\p{Sentence_Break=format}', "");
    Expect(1, 917506, '\p{^Sentence_Break=format}', "");
    Expect(1, 917506, '\P{Sentence_Break=format}', "");
    Expect(0, 917506, '\P{^Sentence_Break=format}', "");
    Expect(1, 917505, '\p{Sentence_Break=:\Aformat\z:}', "");;
    Expect(0, 917506, '\p{Sentence_Break=:\Aformat\z:}', "");;
    Expect(1, 917505, '\p{Sentence_Break: 		FORMAT}', "");
    Expect(0, 917505, '\p{^Sentence_Break: 		FORMAT}', "");
    Expect(0, 917505, '\P{Sentence_Break: 		FORMAT}', "");
    Expect(1, 917505, '\P{^Sentence_Break: 		FORMAT}', "");
    Expect(0, 917506, '\p{Sentence_Break: 		FORMAT}', "");
    Expect(1, 917506, '\p{^Sentence_Break: 		FORMAT}', "");
    Expect(1, 917506, '\P{Sentence_Break: 		FORMAT}', "");
    Expect(0, 917506, '\P{^Sentence_Break: 		FORMAT}', "");
    Error('\p{SB=	 fo:=}');
    Error('\P{SB=	 fo:=}');
    Expect(1, 917505, '\p{SB=:\AFO\z:}', "");;
    Expect(0, 917506, '\p{SB=:\AFO\z:}', "");;
    Expect(1, 917505, '\p{SB:fo}', "");
    Expect(0, 917505, '\p{^SB:fo}', "");
    Expect(0, 917505, '\P{SB:fo}', "");
    Expect(1, 917505, '\P{^SB:fo}', "");
    Expect(0, 917506, '\p{SB:fo}', "");
    Expect(1, 917506, '\p{^SB:fo}', "");
    Expect(1, 917506, '\P{SB:fo}', "");
    Expect(0, 917506, '\P{^SB:fo}', "");
    Expect(1, 917505, '\p{SB=:\Afo\z:}', "");;
    Expect(0, 917506, '\p{SB=:\Afo\z:}', "");;
    Expect(1, 917505, '\p{SB= 	FO}', "");
    Expect(0, 917505, '\p{^SB= 	FO}', "");
    Expect(0, 917505, '\P{SB= 	FO}', "");
    Expect(1, 917505, '\P{^SB= 	FO}', "");
    Expect(0, 917506, '\p{SB= 	FO}', "");
    Expect(1, 917506, '\p{^SB= 	FO}', "");
    Expect(1, 917506, '\P{SB= 	FO}', "");
    Expect(0, 917506, '\P{^SB= 	FO}', "");
    Error('\p{Is_Sentence_Break:	:=-Format}');
    Error('\P{Is_Sentence_Break:	:=-Format}');
    Expect(1, 917505, '\p{Is_Sentence_Break=format}', "");
    Expect(0, 917505, '\p{^Is_Sentence_Break=format}', "");
    Expect(0, 917505, '\P{Is_Sentence_Break=format}', "");
    Expect(1, 917505, '\P{^Is_Sentence_Break=format}', "");
    Expect(0, 917506, '\p{Is_Sentence_Break=format}', "");
    Expect(1, 917506, '\p{^Is_Sentence_Break=format}', "");
    Expect(1, 917506, '\P{Is_Sentence_Break=format}', "");
    Expect(0, 917506, '\P{^Is_Sentence_Break=format}', "");
    Expect(1, 917505, '\p{Is_Sentence_Break: Format}', "");
    Expect(0, 917505, '\p{^Is_Sentence_Break: Format}', "");
    Expect(0, 917505, '\P{Is_Sentence_Break: Format}', "");
    Expect(1, 917505, '\P{^Is_Sentence_Break: Format}', "");
    Expect(0, 917506, '\p{Is_Sentence_Break: Format}', "");
    Expect(1, 917506, '\p{^Is_Sentence_Break: Format}', "");
    Expect(1, 917506, '\P{Is_Sentence_Break: Format}', "");
    Expect(0, 917506, '\P{^Is_Sentence_Break: Format}', "");
    Error('\p{Is_SB=_ FO:=}');
    Error('\P{Is_SB=_ FO:=}');
    Expect(1, 917505, '\p{Is_SB=fo}', "");
    Expect(0, 917505, '\p{^Is_SB=fo}', "");
    Expect(0, 917505, '\P{Is_SB=fo}', "");
    Expect(1, 917505, '\P{^Is_SB=fo}', "");
    Expect(0, 917506, '\p{Is_SB=fo}', "");
    Expect(1, 917506, '\p{^Is_SB=fo}', "");
    Expect(1, 917506, '\P{Is_SB=fo}', "");
    Expect(0, 917506, '\P{^Is_SB=fo}', "");
    Expect(1, 917505, '\p{Is_SB=_fo}', "");
    Expect(0, 917505, '\p{^Is_SB=_fo}', "");
    Expect(0, 917505, '\P{Is_SB=_fo}', "");
    Expect(1, 917505, '\P{^Is_SB=_fo}', "");
    Expect(0, 917506, '\p{Is_SB=_fo}', "");
    Expect(1, 917506, '\p{^Is_SB=_fo}', "");
    Expect(1, 917506, '\P{Is_SB=_fo}', "");
    Expect(0, 917506, '\P{^Is_SB=_fo}', "");
    Error('\p{Sentence_Break=/a/	OLetter}');
    Error('\P{Sentence_Break=/a/	OLetter}');
    Expect(1, 201546, '\p{Sentence_Break=:\AOLetter\z:}', "");;
    Expect(0, 201547, '\p{Sentence_Break=:\AOLetter\z:}', "");;
    Expect(1, 201546, '\p{Sentence_Break=oletter}', "");
    Expect(0, 201546, '\p{^Sentence_Break=oletter}', "");
    Expect(0, 201546, '\P{Sentence_Break=oletter}', "");
    Expect(1, 201546, '\P{^Sentence_Break=oletter}', "");
    Expect(0, 201547, '\p{Sentence_Break=oletter}', "");
    Expect(1, 201547, '\p{^Sentence_Break=oletter}', "");
    Expect(1, 201547, '\P{Sentence_Break=oletter}', "");
    Expect(0, 201547, '\P{^Sentence_Break=oletter}', "");
    Expect(1, 201546, '\p{Sentence_Break=:\Aoletter\z:}', "");;
    Expect(0, 201547, '\p{Sentence_Break=:\Aoletter\z:}', "");;
    Expect(1, 201546, '\p{Sentence_Break=_-OLetter}', "");
    Expect(0, 201546, '\p{^Sentence_Break=_-OLetter}', "");
    Expect(0, 201546, '\P{Sentence_Break=_-OLetter}', "");
    Expect(1, 201546, '\P{^Sentence_Break=_-OLetter}', "");
    Expect(0, 201547, '\p{Sentence_Break=_-OLetter}', "");
    Expect(1, 201547, '\p{^Sentence_Break=_-OLetter}', "");
    Expect(1, 201547, '\P{Sentence_Break=_-OLetter}', "");
    Expect(0, 201547, '\P{^Sentence_Break=_-OLetter}', "");
    Error('\p{SB=__LE/a/}');
    Error('\P{SB=__LE/a/}');
    Expect(1, 201546, '\p{SB=:\ALE\z:}', "");;
    Expect(0, 201547, '\p{SB=:\ALE\z:}', "");;
    Expect(1, 201546, '\p{SB=le}', "");
    Expect(0, 201546, '\p{^SB=le}', "");
    Expect(0, 201546, '\P{SB=le}', "");
    Expect(1, 201546, '\P{^SB=le}', "");
    Expect(0, 201547, '\p{SB=le}', "");
    Expect(1, 201547, '\p{^SB=le}', "");
    Expect(1, 201547, '\P{SB=le}', "");
    Expect(0, 201547, '\P{^SB=le}', "");
    Expect(1, 201546, '\p{SB=:\Ale\z:}', "");;
    Expect(0, 201547, '\p{SB=:\Ale\z:}', "");;
    Expect(1, 201546, '\p{SB=_-LE}', "");
    Expect(0, 201546, '\p{^SB=_-LE}', "");
    Expect(0, 201546, '\P{SB=_-LE}', "");
    Expect(1, 201546, '\P{^SB=_-LE}', "");
    Expect(0, 201547, '\p{SB=_-LE}', "");
    Expect(1, 201547, '\p{^SB=_-LE}', "");
    Expect(1, 201547, '\P{SB=_-LE}', "");
    Expect(0, 201547, '\P{^SB=_-LE}', "");
    Error('\p{Is_Sentence_Break=:=oletter}');
    Error('\P{Is_Sentence_Break=:=oletter}');
    Expect(1, 201546, '\p{Is_Sentence_Break=oletter}', "");
    Expect(0, 201546, '\p{^Is_Sentence_Break=oletter}', "");
    Expect(0, 201546, '\P{Is_Sentence_Break=oletter}', "");
    Expect(1, 201546, '\P{^Is_Sentence_Break=oletter}', "");
    Expect(0, 201547, '\p{Is_Sentence_Break=oletter}', "");
    Expect(1, 201547, '\p{^Is_Sentence_Break=oletter}', "");
    Expect(1, 201547, '\P{Is_Sentence_Break=oletter}', "");
    Expect(0, 201547, '\P{^Is_Sentence_Break=oletter}', "");
    Expect(1, 201546, '\p{Is_Sentence_Break=	 OLETTER}', "");
    Expect(0, 201546, '\p{^Is_Sentence_Break=	 OLETTER}', "");
    Expect(0, 201546, '\P{Is_Sentence_Break=	 OLETTER}', "");
    Expect(1, 201546, '\P{^Is_Sentence_Break=	 OLETTER}', "");
    Expect(0, 201547, '\p{Is_Sentence_Break=	 OLETTER}', "");
    Expect(1, 201547, '\p{^Is_Sentence_Break=	 OLETTER}', "");
    Expect(1, 201547, '\P{Is_Sentence_Break=	 OLETTER}', "");
    Expect(0, 201547, '\P{^Is_Sentence_Break=	 OLETTER}', "");
    Error('\p{Is_SB=-:=LE}');
    Error('\P{Is_SB=-:=LE}');
    Expect(1, 201546, '\p{Is_SB=le}', "");
    Expect(0, 201546, '\p{^Is_SB=le}', "");
    Expect(0, 201546, '\P{Is_SB=le}', "");
    Expect(1, 201546, '\P{^Is_SB=le}', "");
    Expect(0, 201547, '\p{Is_SB=le}', "");
    Expect(1, 201547, '\p{^Is_SB=le}', "");
    Expect(1, 201547, '\P{Is_SB=le}', "");
    Expect(0, 201547, '\P{^Is_SB=le}', "");
    Expect(1, 201546, '\p{Is_SB=__LE}', "");
    Expect(0, 201546, '\p{^Is_SB=__LE}', "");
    Expect(0, 201546, '\P{Is_SB=__LE}', "");
    Expect(1, 201546, '\P{^Is_SB=__LE}', "");
    Expect(0, 201547, '\p{Is_SB=__LE}', "");
    Expect(1, 201547, '\p{^Is_SB=__LE}', "");
    Expect(1, 201547, '\P{Is_SB=__LE}', "");
    Expect(0, 201547, '\P{^Is_SB=__LE}', "");
    Error('\p{Sentence_Break=/a/ LF}');
    Error('\P{Sentence_Break=/a/ LF}');
    Expect(1, 10, '\p{Sentence_Break=:\ALF\z:}', "");;
    Expect(0, 11, '\p{Sentence_Break=:\ALF\z:}', "");;
    Expect(1, 10, '\p{Sentence_Break=lf}', "");
    Expect(0, 10, '\p{^Sentence_Break=lf}', "");
    Expect(0, 10, '\P{Sentence_Break=lf}', "");
    Expect(1, 10, '\P{^Sentence_Break=lf}', "");
    Expect(0, 11, '\p{Sentence_Break=lf}', "");
    Expect(1, 11, '\p{^Sentence_Break=lf}', "");
    Expect(1, 11, '\P{Sentence_Break=lf}', "");
    Expect(0, 11, '\P{^Sentence_Break=lf}', "");
    Expect(1, 10, '\p{Sentence_Break=:\Alf\z:}', "");;
    Expect(0, 11, '\p{Sentence_Break=:\Alf\z:}', "");;
    Expect(1, 10, '\p{Sentence_Break= 	LF}', "");
    Expect(0, 10, '\p{^Sentence_Break= 	LF}', "");
    Expect(0, 10, '\P{Sentence_Break= 	LF}', "");
    Expect(1, 10, '\P{^Sentence_Break= 	LF}', "");
    Expect(0, 11, '\p{Sentence_Break= 	LF}', "");
    Expect(1, 11, '\p{^Sentence_Break= 	LF}', "");
    Expect(1, 11, '\P{Sentence_Break= 	LF}', "");
    Expect(0, 11, '\P{^Sentence_Break= 	LF}', "");
    Error('\p{SB=/a/  LF}');
    Error('\P{SB=/a/  LF}');
    Expect(1, 10, '\p{SB=:\ALF\z:}', "");;
    Expect(0, 11, '\p{SB=:\ALF\z:}', "");;
    Expect(1, 10, '\p{SB=lf}', "");
    Expect(0, 10, '\p{^SB=lf}', "");
    Expect(0, 10, '\P{SB=lf}', "");
    Expect(1, 10, '\P{^SB=lf}', "");
    Expect(0, 11, '\p{SB=lf}', "");
    Expect(1, 11, '\p{^SB=lf}', "");
    Expect(1, 11, '\P{SB=lf}', "");
    Expect(0, 11, '\P{^SB=lf}', "");
    Expect(1, 10, '\p{SB=:\Alf\z:}', "");;
    Expect(0, 11, '\p{SB=:\Alf\z:}', "");;
    Expect(1, 10, '\p{SB=LF}', "");
    Expect(0, 10, '\p{^SB=LF}', "");
    Expect(0, 10, '\P{SB=LF}', "");
    Expect(1, 10, '\P{^SB=LF}', "");
    Expect(0, 11, '\p{SB=LF}', "");
    Expect(1, 11, '\p{^SB=LF}', "");
    Expect(1, 11, '\P{SB=LF}', "");
    Expect(0, 11, '\P{^SB=LF}', "");
    Error('\p{Is_Sentence_Break=-/a/LF}');
    Error('\P{Is_Sentence_Break=-/a/LF}');
    Expect(1, 10, '\p{Is_Sentence_Break=lf}', "");
    Expect(0, 10, '\p{^Is_Sentence_Break=lf}', "");
    Expect(0, 10, '\P{Is_Sentence_Break=lf}', "");
    Expect(1, 10, '\P{^Is_Sentence_Break=lf}', "");
    Expect(0, 11, '\p{Is_Sentence_Break=lf}', "");
    Expect(1, 11, '\p{^Is_Sentence_Break=lf}', "");
    Expect(1, 11, '\P{Is_Sentence_Break=lf}', "");
    Expect(0, 11, '\P{^Is_Sentence_Break=lf}', "");
    Expect(1, 10, '\p{Is_Sentence_Break=	_LF}', "");
    Expect(0, 10, '\p{^Is_Sentence_Break=	_LF}', "");
    Expect(0, 10, '\P{Is_Sentence_Break=	_LF}', "");
    Expect(1, 10, '\P{^Is_Sentence_Break=	_LF}', "");
    Expect(0, 11, '\p{Is_Sentence_Break=	_LF}', "");
    Expect(1, 11, '\p{^Is_Sentence_Break=	_LF}', "");
    Expect(1, 11, '\P{Is_Sentence_Break=	_LF}', "");
    Expect(0, 11, '\P{^Is_Sentence_Break=	_LF}', "");
    Error('\p{Is_SB=	LF:=}');
    Error('\P{Is_SB=	LF:=}');
    Expect(1, 10, '\p{Is_SB=lf}', "");
    Expect(0, 10, '\p{^Is_SB=lf}', "");
    Expect(0, 10, '\P{Is_SB=lf}', "");
    Expect(1, 10, '\P{^Is_SB=lf}', "");
    Expect(0, 11, '\p{Is_SB=lf}', "");
    Expect(1, 11, '\p{^Is_SB=lf}', "");
    Expect(1, 11, '\P{Is_SB=lf}', "");
    Expect(0, 11, '\P{^Is_SB=lf}', "");
    Expect(1, 10, '\p{Is_SB=	LF}', "");
    Expect(0, 10, '\p{^Is_SB=	LF}', "");
    Expect(0, 10, '\P{Is_SB=	LF}', "");
    Expect(1, 10, '\P{^Is_SB=	LF}', "");
    Expect(0, 11, '\p{Is_SB=	LF}', "");
    Expect(1, 11, '\p{^Is_SB=	LF}', "");
    Expect(1, 11, '\P{Is_SB=	LF}', "");
    Expect(0, 11, '\P{^Is_SB=	LF}', "");
    Error('\p{Sentence_Break= _Lower:=}');
    Error('\P{Sentence_Break= _Lower:=}');
    Expect(1, 125251, '\p{Sentence_Break=:\ALower\z:}', "");;
    Expect(0, 125252, '\p{Sentence_Break=:\ALower\z:}', "");;
    Expect(1, 125251, '\p{Sentence_Break=lower}', "");
    Expect(0, 125251, '\p{^Sentence_Break=lower}', "");
    Expect(0, 125251, '\P{Sentence_Break=lower}', "");
    Expect(1, 125251, '\P{^Sentence_Break=lower}', "");
    Expect(0, 125252, '\p{Sentence_Break=lower}', "");
    Expect(1, 125252, '\p{^Sentence_Break=lower}', "");
    Expect(1, 125252, '\P{Sentence_Break=lower}', "");
    Expect(0, 125252, '\P{^Sentence_Break=lower}', "");
    Expect(1, 125251, '\p{Sentence_Break=:\Alower\z:}', "");;
    Expect(0, 125252, '\p{Sentence_Break=:\Alower\z:}', "");;
    Expect(1, 125251, '\p{Sentence_Break=-Lower}', "");
    Expect(0, 125251, '\p{^Sentence_Break=-Lower}', "");
    Expect(0, 125251, '\P{Sentence_Break=-Lower}', "");
    Expect(1, 125251, '\P{^Sentence_Break=-Lower}', "");
    Expect(0, 125252, '\p{Sentence_Break=-Lower}', "");
    Expect(1, 125252, '\p{^Sentence_Break=-Lower}', "");
    Expect(1, 125252, '\P{Sentence_Break=-Lower}', "");
    Expect(0, 125252, '\P{^Sentence_Break=-Lower}', "");
    Error('\p{SB=:=lo}');
    Error('\P{SB=:=lo}');
    Expect(1, 125251, '\p{SB=:\ALO\z:}', "");;
    Expect(0, 125252, '\p{SB=:\ALO\z:}', "");;
    Expect(1, 125251, '\p{SB=lo}', "");
    Expect(0, 125251, '\p{^SB=lo}', "");
    Expect(0, 125251, '\P{SB=lo}', "");
    Expect(1, 125251, '\P{^SB=lo}', "");
    Expect(0, 125252, '\p{SB=lo}', "");
    Expect(1, 125252, '\p{^SB=lo}', "");
    Expect(1, 125252, '\P{SB=lo}', "");
    Expect(0, 125252, '\P{^SB=lo}', "");
    Expect(1, 125251, '\p{SB=:\Alo\z:}', "");;
    Expect(0, 125252, '\p{SB=:\Alo\z:}', "");;
    Expect(1, 125251, '\p{SB: 	LO}', "");
    Expect(0, 125251, '\p{^SB: 	LO}', "");
    Expect(0, 125251, '\P{SB: 	LO}', "");
    Expect(1, 125251, '\P{^SB: 	LO}', "");
    Expect(0, 125252, '\p{SB: 	LO}', "");
    Expect(1, 125252, '\p{^SB: 	LO}', "");
    Expect(1, 125252, '\P{SB: 	LO}', "");
    Expect(0, 125252, '\P{^SB: 	LO}', "");
    Error('\p{Is_Sentence_Break=:=	Lower}');
    Error('\P{Is_Sentence_Break=:=	Lower}');
    Expect(1, 125251, '\p{Is_Sentence_Break=lower}', "");
    Expect(0, 125251, '\p{^Is_Sentence_Break=lower}', "");
    Expect(0, 125251, '\P{Is_Sentence_Break=lower}', "");
    Expect(1, 125251, '\P{^Is_Sentence_Break=lower}', "");
    Expect(0, 125252, '\p{Is_Sentence_Break=lower}', "");
    Expect(1, 125252, '\p{^Is_Sentence_Break=lower}', "");
    Expect(1, 125252, '\P{Is_Sentence_Break=lower}', "");
    Expect(0, 125252, '\P{^Is_Sentence_Break=lower}', "");
    Expect(1, 125251, '\p{Is_Sentence_Break=- lower}', "");
    Expect(0, 125251, '\p{^Is_Sentence_Break=- lower}', "");
    Expect(0, 125251, '\P{Is_Sentence_Break=- lower}', "");
    Expect(1, 125251, '\P{^Is_Sentence_Break=- lower}', "");
    Expect(0, 125252, '\p{Is_Sentence_Break=- lower}', "");
    Expect(1, 125252, '\p{^Is_Sentence_Break=- lower}', "");
    Expect(1, 125252, '\P{Is_Sentence_Break=- lower}', "");
    Expect(0, 125252, '\P{^Is_Sentence_Break=- lower}', "");
    Error('\p{Is_SB=/a/__lo}');
    Error('\P{Is_SB=/a/__lo}');
    Expect(1, 125251, '\p{Is_SB=lo}', "");
    Expect(0, 125251, '\p{^Is_SB=lo}', "");
    Expect(0, 125251, '\P{Is_SB=lo}', "");
    Expect(1, 125251, '\P{^Is_SB=lo}', "");
    Expect(0, 125252, '\p{Is_SB=lo}', "");
    Expect(1, 125252, '\p{^Is_SB=lo}', "");
    Expect(1, 125252, '\P{Is_SB=lo}', "");
    Expect(0, 125252, '\P{^Is_SB=lo}', "");
    Expect(1, 125251, '\p{Is_SB=  lo}', "");
    Expect(0, 125251, '\p{^Is_SB=  lo}', "");
    Expect(0, 125251, '\P{Is_SB=  lo}', "");
    Expect(1, 125251, '\P{^Is_SB=  lo}', "");
    Expect(0, 125252, '\p{Is_SB=  lo}', "");
    Expect(1, 125252, '\p{^Is_SB=  lo}', "");
    Expect(1, 125252, '\P{Is_SB=  lo}', "");
    Expect(0, 125252, '\P{^Is_SB=  lo}', "");
    Error('\p{Sentence_Break=:=  Numeric}');
    Error('\P{Sentence_Break=:=  Numeric}');
    Expect(1, 130041, '\p{Sentence_Break=:\ANumeric\z:}', "");;
    Expect(0, 130042, '\p{Sentence_Break=:\ANumeric\z:}', "");;
    Expect(1, 130041, '\p{Sentence_Break=numeric}', "");
    Expect(0, 130041, '\p{^Sentence_Break=numeric}', "");
    Expect(0, 130041, '\P{Sentence_Break=numeric}', "");
    Expect(1, 130041, '\P{^Sentence_Break=numeric}', "");
    Expect(0, 130042, '\p{Sentence_Break=numeric}', "");
    Expect(1, 130042, '\p{^Sentence_Break=numeric}', "");
    Expect(1, 130042, '\P{Sentence_Break=numeric}', "");
    Expect(0, 130042, '\P{^Sentence_Break=numeric}', "");
    Expect(1, 130041, '\p{Sentence_Break=:\Anumeric\z:}', "");;
    Expect(0, 130042, '\p{Sentence_Break=:\Anumeric\z:}', "");;
    Expect(1, 130041, '\p{Sentence_Break=	-numeric}', "");
    Expect(0, 130041, '\p{^Sentence_Break=	-numeric}', "");
    Expect(0, 130041, '\P{Sentence_Break=	-numeric}', "");
    Expect(1, 130041, '\P{^Sentence_Break=	-numeric}', "");
    Expect(0, 130042, '\p{Sentence_Break=	-numeric}', "");
    Expect(1, 130042, '\p{^Sentence_Break=	-numeric}', "");
    Expect(1, 130042, '\P{Sentence_Break=	-numeric}', "");
    Expect(0, 130042, '\P{^Sentence_Break=	-numeric}', "");
    Error('\p{SB=:=-NU}');
    Error('\P{SB=:=-NU}');
    Expect(1, 130041, '\p{SB=:\ANU\z:}', "");;
    Expect(0, 130042, '\p{SB=:\ANU\z:}', "");;
    Expect(1, 130041, '\p{SB:nu}', "");
    Expect(0, 130041, '\p{^SB:nu}', "");
    Expect(0, 130041, '\P{SB:nu}', "");
    Expect(1, 130041, '\P{^SB:nu}', "");
    Expect(0, 130042, '\p{SB:nu}', "");
    Expect(1, 130042, '\p{^SB:nu}', "");
    Expect(1, 130042, '\P{SB:nu}', "");
    Expect(0, 130042, '\P{^SB:nu}', "");
    Expect(1, 130041, '\p{SB=:\Anu\z:}', "");;
    Expect(0, 130042, '\p{SB=:\Anu\z:}', "");;
    Expect(1, 130041, '\p{SB:  	NU}', "");
    Expect(0, 130041, '\p{^SB:  	NU}', "");
    Expect(0, 130041, '\P{SB:  	NU}', "");
    Expect(1, 130041, '\P{^SB:  	NU}', "");
    Expect(0, 130042, '\p{SB:  	NU}', "");
    Expect(1, 130042, '\p{^SB:  	NU}', "");
    Expect(1, 130042, '\P{SB:  	NU}', "");
    Expect(0, 130042, '\P{^SB:  	NU}', "");
    Error('\p{Is_Sentence_Break=:= -numeric}');
    Error('\P{Is_Sentence_Break=:= -numeric}');
    Expect(1, 130041, '\p{Is_Sentence_Break:numeric}', "");
    Expect(0, 130041, '\p{^Is_Sentence_Break:numeric}', "");
    Expect(0, 130041, '\P{Is_Sentence_Break:numeric}', "");
    Expect(1, 130041, '\P{^Is_Sentence_Break:numeric}', "");
    Expect(0, 130042, '\p{Is_Sentence_Break:numeric}', "");
    Expect(1, 130042, '\p{^Is_Sentence_Break:numeric}', "");
    Expect(1, 130042, '\P{Is_Sentence_Break:numeric}', "");
    Expect(0, 130042, '\P{^Is_Sentence_Break:numeric}', "");
    Expect(1, 130041, '\p{Is_Sentence_Break=  NUMERIC}', "");
    Expect(0, 130041, '\p{^Is_Sentence_Break=  NUMERIC}', "");
    Expect(0, 130041, '\P{Is_Sentence_Break=  NUMERIC}', "");
    Expect(1, 130041, '\P{^Is_Sentence_Break=  NUMERIC}', "");
    Expect(0, 130042, '\p{Is_Sentence_Break=  NUMERIC}', "");
    Expect(1, 130042, '\p{^Is_Sentence_Break=  NUMERIC}', "");
    Expect(1, 130042, '\P{Is_Sentence_Break=  NUMERIC}', "");
    Expect(0, 130042, '\P{^Is_Sentence_Break=  NUMERIC}', "");
    Error('\p{Is_SB= :=nu}');
    Error('\P{Is_SB= :=nu}');
    Expect(1, 130041, '\p{Is_SB=nu}', "");
    Expect(0, 130041, '\p{^Is_SB=nu}', "");
    Expect(0, 130041, '\P{Is_SB=nu}', "");
    Expect(1, 130041, '\P{^Is_SB=nu}', "");
    Expect(0, 130042, '\p{Is_SB=nu}', "");
    Expect(1, 130042, '\p{^Is_SB=nu}', "");
    Expect(1, 130042, '\P{Is_SB=nu}', "");
    Expect(0, 130042, '\P{^Is_SB=nu}', "");
    Expect(1, 130041, '\p{Is_SB=	NU}', "");
    Expect(0, 130041, '\p{^Is_SB=	NU}', "");
    Expect(0, 130041, '\P{Is_SB=	NU}', "");
    Expect(1, 130041, '\P{^Is_SB=	NU}', "");
    Expect(0, 130042, '\p{Is_SB=	NU}', "");
    Expect(1, 130042, '\p{^Is_SB=	NU}', "");
    Expect(1, 130042, '\P{Is_SB=	NU}', "");
    Expect(0, 130042, '\P{^Is_SB=	NU}', "");
    Error('\p{Sentence_Break=  SCONTINUE/a/}');
    Error('\P{Sentence_Break=  SCONTINUE/a/}');
    Expect(1, 65380, '\p{Sentence_Break=:\ASContinue\z:}', "");;
    Expect(0, 65381, '\p{Sentence_Break=:\ASContinue\z:}', "");;
    Expect(1, 65380, '\p{Sentence_Break=scontinue}', "");
    Expect(0, 65380, '\p{^Sentence_Break=scontinue}', "");
    Expect(0, 65380, '\P{Sentence_Break=scontinue}', "");
    Expect(1, 65380, '\P{^Sentence_Break=scontinue}', "");
    Expect(0, 65381, '\p{Sentence_Break=scontinue}', "");
    Expect(1, 65381, '\p{^Sentence_Break=scontinue}', "");
    Expect(1, 65381, '\P{Sentence_Break=scontinue}', "");
    Expect(0, 65381, '\P{^Sentence_Break=scontinue}', "");
    Expect(1, 65380, '\p{Sentence_Break=:\Ascontinue\z:}', "");;
    Expect(0, 65381, '\p{Sentence_Break=:\Ascontinue\z:}', "");;
    Expect(1, 65380, '\p{Sentence_Break= SCONTINUE}', "");
    Expect(0, 65380, '\p{^Sentence_Break= SCONTINUE}', "");
    Expect(0, 65380, '\P{Sentence_Break= SCONTINUE}', "");
    Expect(1, 65380, '\P{^Sentence_Break= SCONTINUE}', "");
    Expect(0, 65381, '\p{Sentence_Break= SCONTINUE}', "");
    Expect(1, 65381, '\p{^Sentence_Break= SCONTINUE}', "");
    Expect(1, 65381, '\P{Sentence_Break= SCONTINUE}', "");
    Expect(0, 65381, '\P{^Sentence_Break= SCONTINUE}', "");
    Error('\p{SB=_SC:=}');
    Error('\P{SB=_SC:=}');
    Expect(1, 65380, '\p{SB=:\ASC\z:}', "");;
    Expect(0, 65381, '\p{SB=:\ASC\z:}', "");;
    Expect(1, 65380, '\p{SB=sc}', "");
    Expect(0, 65380, '\p{^SB=sc}', "");
    Expect(0, 65380, '\P{SB=sc}', "");
    Expect(1, 65380, '\P{^SB=sc}', "");
    Expect(0, 65381, '\p{SB=sc}', "");
    Expect(1, 65381, '\p{^SB=sc}', "");
    Expect(1, 65381, '\P{SB=sc}', "");
    Expect(0, 65381, '\P{^SB=sc}', "");
    Expect(1, 65380, '\p{SB=:\Asc\z:}', "");;
    Expect(0, 65381, '\p{SB=:\Asc\z:}', "");;
    Expect(1, 65380, '\p{SB= 	SC}', "");
    Expect(0, 65380, '\p{^SB= 	SC}', "");
    Expect(0, 65380, '\P{SB= 	SC}', "");
    Expect(1, 65380, '\P{^SB= 	SC}', "");
    Expect(0, 65381, '\p{SB= 	SC}', "");
    Expect(1, 65381, '\p{^SB= 	SC}', "");
    Expect(1, 65381, '\P{SB= 	SC}', "");
    Expect(0, 65381, '\P{^SB= 	SC}', "");
    Error('\p{Is_Sentence_Break=_/a/SCONTINUE}');
    Error('\P{Is_Sentence_Break=_/a/SCONTINUE}');
    Expect(1, 65380, '\p{Is_Sentence_Break=scontinue}', "");
    Expect(0, 65380, '\p{^Is_Sentence_Break=scontinue}', "");
    Expect(0, 65380, '\P{Is_Sentence_Break=scontinue}', "");
    Expect(1, 65380, '\P{^Is_Sentence_Break=scontinue}', "");
    Expect(0, 65381, '\p{Is_Sentence_Break=scontinue}', "");
    Expect(1, 65381, '\p{^Is_Sentence_Break=scontinue}', "");
    Expect(1, 65381, '\P{Is_Sentence_Break=scontinue}', "");
    Expect(0, 65381, '\P{^Is_Sentence_Break=scontinue}', "");
    Expect(1, 65380, '\p{Is_Sentence_Break=- SContinue}', "");
    Expect(0, 65380, '\p{^Is_Sentence_Break=- SContinue}', "");
    Expect(0, 65380, '\P{Is_Sentence_Break=- SContinue}', "");
    Expect(1, 65380, '\P{^Is_Sentence_Break=- SContinue}', "");
    Expect(0, 65381, '\p{Is_Sentence_Break=- SContinue}', "");
    Expect(1, 65381, '\p{^Is_Sentence_Break=- SContinue}', "");
    Expect(1, 65381, '\P{Is_Sentence_Break=- SContinue}', "");
    Expect(0, 65381, '\P{^Is_Sentence_Break=- SContinue}', "");
    Error('\p{Is_SB=_/a/SC}');
    Error('\P{Is_SB=_/a/SC}');
    Expect(1, 65380, '\p{Is_SB=sc}', "");
    Expect(0, 65380, '\p{^Is_SB=sc}', "");
    Expect(0, 65380, '\P{Is_SB=sc}', "");
    Expect(1, 65380, '\P{^Is_SB=sc}', "");
    Expect(0, 65381, '\p{Is_SB=sc}', "");
    Expect(1, 65381, '\p{^Is_SB=sc}', "");
    Expect(1, 65381, '\P{Is_SB=sc}', "");
    Expect(0, 65381, '\P{^Is_SB=sc}', "");
    Expect(1, 65380, '\p{Is_SB=	SC}', "");
    Expect(0, 65380, '\p{^Is_SB=	SC}', "");
    Expect(0, 65380, '\P{Is_SB=	SC}', "");
    Expect(1, 65380, '\P{^Is_SB=	SC}', "");
    Expect(0, 65381, '\p{Is_SB=	SC}', "");
    Expect(1, 65381, '\p{^Is_SB=	SC}', "");
    Expect(1, 65381, '\P{Is_SB=	SC}', "");
    Expect(0, 65381, '\P{^Is_SB=	SC}', "");
    Error('\p{Sentence_Break=/a/	 sep}');
    Error('\P{Sentence_Break=/a/	 sep}');
    Expect(1, 8233, '\p{Sentence_Break=:\ASep\z:}', "");;
    Expect(0, 8234, '\p{Sentence_Break=:\ASep\z:}', "");;
    Expect(1, 8233, '\p{Sentence_Break=sep}', "");
    Expect(0, 8233, '\p{^Sentence_Break=sep}', "");
    Expect(0, 8233, '\P{Sentence_Break=sep}', "");
    Expect(1, 8233, '\P{^Sentence_Break=sep}', "");
    Expect(0, 8234, '\p{Sentence_Break=sep}', "");
    Expect(1, 8234, '\p{^Sentence_Break=sep}', "");
    Expect(1, 8234, '\P{Sentence_Break=sep}', "");
    Expect(0, 8234, '\P{^Sentence_Break=sep}', "");
    Expect(1, 8233, '\p{Sentence_Break=:\Asep\z:}', "");;
    Expect(0, 8234, '\p{Sentence_Break=:\Asep\z:}', "");;
    Expect(1, 8233, '\p{Sentence_Break: 	-Sep}', "");
    Expect(0, 8233, '\p{^Sentence_Break: 	-Sep}', "");
    Expect(0, 8233, '\P{Sentence_Break: 	-Sep}', "");
    Expect(1, 8233, '\P{^Sentence_Break: 	-Sep}', "");
    Expect(0, 8234, '\p{Sentence_Break: 	-Sep}', "");
    Expect(1, 8234, '\p{^Sentence_Break: 	-Sep}', "");
    Expect(1, 8234, '\P{Sentence_Break: 	-Sep}', "");
    Expect(0, 8234, '\P{^Sentence_Break: 	-Sep}', "");
    Error('\p{SB=:=_ SE}');
    Error('\P{SB=:=_ SE}');
    Expect(1, 8233, '\p{SB=:\ASE\z:}', "");;
    Expect(0, 8234, '\p{SB=:\ASE\z:}', "");;
    Expect(1, 8233, '\p{SB=se}', "");
    Expect(0, 8233, '\p{^SB=se}', "");
    Expect(0, 8233, '\P{SB=se}', "");
    Expect(1, 8233, '\P{^SB=se}', "");
    Expect(0, 8234, '\p{SB=se}', "");
    Expect(1, 8234, '\p{^SB=se}', "");
    Expect(1, 8234, '\P{SB=se}', "");
    Expect(0, 8234, '\P{^SB=se}', "");
    Expect(1, 8233, '\p{SB=:\Ase\z:}', "");;
    Expect(0, 8234, '\p{SB=:\Ase\z:}', "");;
    Expect(1, 8233, '\p{SB= -SE}', "");
    Expect(0, 8233, '\p{^SB= -SE}', "");
    Expect(0, 8233, '\P{SB= -SE}', "");
    Expect(1, 8233, '\P{^SB= -SE}', "");
    Expect(0, 8234, '\p{SB= -SE}', "");
    Expect(1, 8234, '\p{^SB= -SE}', "");
    Expect(1, 8234, '\P{SB= -SE}', "");
    Expect(0, 8234, '\P{^SB= -SE}', "");
    Error('\p{Is_Sentence_Break=		Sep:=}');
    Error('\P{Is_Sentence_Break=		Sep:=}');
    Expect(1, 8233, '\p{Is_Sentence_Break:   sep}', "");
    Expect(0, 8233, '\p{^Is_Sentence_Break:   sep}', "");
    Expect(0, 8233, '\P{Is_Sentence_Break:   sep}', "");
    Expect(1, 8233, '\P{^Is_Sentence_Break:   sep}', "");
    Expect(0, 8234, '\p{Is_Sentence_Break:   sep}', "");
    Expect(1, 8234, '\p{^Is_Sentence_Break:   sep}', "");
    Expect(1, 8234, '\P{Is_Sentence_Break:   sep}', "");
    Expect(0, 8234, '\P{^Is_Sentence_Break:   sep}', "");
    Expect(1, 8233, '\p{Is_Sentence_Break:   _ Sep}', "");
    Expect(0, 8233, '\p{^Is_Sentence_Break:   _ Sep}', "");
    Expect(0, 8233, '\P{Is_Sentence_Break:   _ Sep}', "");
    Expect(1, 8233, '\P{^Is_Sentence_Break:   _ Sep}', "");
    Expect(0, 8234, '\p{Is_Sentence_Break:   _ Sep}', "");
    Expect(1, 8234, '\p{^Is_Sentence_Break:   _ Sep}', "");
    Expect(1, 8234, '\P{Is_Sentence_Break:   _ Sep}', "");
    Expect(0, 8234, '\P{^Is_Sentence_Break:   _ Sep}', "");
    Error('\p{Is_SB=	/a/SE}');
    Error('\P{Is_SB=	/a/SE}');
    Expect(1, 8233, '\p{Is_SB=se}', "");
    Expect(0, 8233, '\p{^Is_SB=se}', "");
    Expect(0, 8233, '\P{Is_SB=se}', "");
    Expect(1, 8233, '\P{^Is_SB=se}', "");
    Expect(0, 8234, '\p{Is_SB=se}', "");
    Expect(1, 8234, '\p{^Is_SB=se}', "");
    Expect(1, 8234, '\P{Is_SB=se}', "");
    Expect(0, 8234, '\P{^Is_SB=se}', "");
    Expect(1, 8233, '\p{Is_SB=- SE}', "");
    Expect(0, 8233, '\p{^Is_SB=- SE}', "");
    Expect(0, 8233, '\P{Is_SB=- SE}', "");
    Expect(1, 8233, '\P{^Is_SB=- SE}', "");
    Expect(0, 8234, '\p{Is_SB=- SE}', "");
    Expect(1, 8234, '\p{^Is_SB=- SE}', "");
    Expect(1, 8234, '\P{Is_SB=- SE}', "");
    Expect(0, 8234, '\P{^Is_SB=- SE}', "");
    Error('\p{Sentence_Break=:=-sp}');
    Error('\P{Sentence_Break=:=-sp}');
    Expect(1, 12288, '\p{Sentence_Break=:\ASp\z:}', "");;
    Expect(0, 12289, '\p{Sentence_Break=:\ASp\z:}', "");;
    Expect(1, 12288, '\p{Sentence_Break=sp}', "");
    Expect(0, 12288, '\p{^Sentence_Break=sp}', "");
    Expect(0, 12288, '\P{Sentence_Break=sp}', "");
    Expect(1, 12288, '\P{^Sentence_Break=sp}', "");
    Expect(0, 12289, '\p{Sentence_Break=sp}', "");
    Expect(1, 12289, '\p{^Sentence_Break=sp}', "");
    Expect(1, 12289, '\P{Sentence_Break=sp}', "");
    Expect(0, 12289, '\P{^Sentence_Break=sp}', "");
    Expect(1, 12288, '\p{Sentence_Break=:\Asp\z:}', "");;
    Expect(0, 12289, '\p{Sentence_Break=:\Asp\z:}', "");;
    Expect(1, 12288, '\p{Sentence_Break=  SP}', "");
    Expect(0, 12288, '\p{^Sentence_Break=  SP}', "");
    Expect(0, 12288, '\P{Sentence_Break=  SP}', "");
    Expect(1, 12288, '\P{^Sentence_Break=  SP}', "");
    Expect(0, 12289, '\p{Sentence_Break=  SP}', "");
    Expect(1, 12289, '\p{^Sentence_Break=  SP}', "");
    Expect(1, 12289, '\P{Sentence_Break=  SP}', "");
    Expect(0, 12289, '\P{^Sentence_Break=  SP}', "");
    Error('\p{SB=:=-_Sp}');
    Error('\P{SB=:=-_Sp}');
    Expect(1, 12288, '\p{SB=:\ASp\z:}', "");;
    Expect(0, 12289, '\p{SB=:\ASp\z:}', "");;
    Expect(1, 12288, '\p{SB:	sp}', "");
    Expect(0, 12288, '\p{^SB:	sp}', "");
    Expect(0, 12288, '\P{SB:	sp}', "");
    Expect(1, 12288, '\P{^SB:	sp}', "");
    Expect(0, 12289, '\p{SB:	sp}', "");
    Expect(1, 12289, '\p{^SB:	sp}', "");
    Expect(1, 12289, '\P{SB:	sp}', "");
    Expect(0, 12289, '\P{^SB:	sp}', "");
    Expect(1, 12288, '\p{SB=:\Asp\z:}', "");;
    Expect(0, 12289, '\p{SB=:\Asp\z:}', "");;
    Expect(1, 12288, '\p{SB=-	Sp}', "");
    Expect(0, 12288, '\p{^SB=-	Sp}', "");
    Expect(0, 12288, '\P{SB=-	Sp}', "");
    Expect(1, 12288, '\P{^SB=-	Sp}', "");
    Expect(0, 12289, '\p{SB=-	Sp}', "");
    Expect(1, 12289, '\p{^SB=-	Sp}', "");
    Expect(1, 12289, '\P{SB=-	Sp}', "");
    Expect(0, 12289, '\P{^SB=-	Sp}', "");
    Error('\p{Is_Sentence_Break=- sp:=}');
    Error('\P{Is_Sentence_Break=- sp:=}');
    Expect(1, 12288, '\p{Is_Sentence_Break=sp}', "");
    Expect(0, 12288, '\p{^Is_Sentence_Break=sp}', "");
    Expect(0, 12288, '\P{Is_Sentence_Break=sp}', "");
    Expect(1, 12288, '\P{^Is_Sentence_Break=sp}', "");
    Expect(0, 12289, '\p{Is_Sentence_Break=sp}', "");
    Expect(1, 12289, '\p{^Is_Sentence_Break=sp}', "");
    Expect(1, 12289, '\P{Is_Sentence_Break=sp}', "");
    Expect(0, 12289, '\P{^Is_Sentence_Break=sp}', "");
    Expect(1, 12288, '\p{Is_Sentence_Break=_ SP}', "");
    Expect(0, 12288, '\p{^Is_Sentence_Break=_ SP}', "");
    Expect(0, 12288, '\P{Is_Sentence_Break=_ SP}', "");
    Expect(1, 12288, '\P{^Is_Sentence_Break=_ SP}', "");
    Expect(0, 12289, '\p{Is_Sentence_Break=_ SP}', "");
    Expect(1, 12289, '\p{^Is_Sentence_Break=_ SP}', "");
    Expect(1, 12289, '\P{Is_Sentence_Break=_ SP}', "");
    Expect(0, 12289, '\P{^Is_Sentence_Break=_ SP}', "");
    Error('\p{Is_SB=-SP:=}');
    Error('\P{Is_SB=-SP:=}');
    Expect(1, 12288, '\p{Is_SB=sp}', "");
    Expect(0, 12288, '\p{^Is_SB=sp}', "");
    Expect(0, 12288, '\P{Is_SB=sp}', "");
    Expect(1, 12288, '\P{^Is_SB=sp}', "");
    Expect(0, 12289, '\p{Is_SB=sp}', "");
    Expect(1, 12289, '\p{^Is_SB=sp}', "");
    Expect(1, 12289, '\P{Is_SB=sp}', "");
    Expect(0, 12289, '\P{^Is_SB=sp}', "");
    Expect(1, 12288, '\p{Is_SB=	_Sp}', "");
    Expect(0, 12288, '\p{^Is_SB=	_Sp}', "");
    Expect(0, 12288, '\P{Is_SB=	_Sp}', "");
    Expect(1, 12288, '\P{^Is_SB=	_Sp}', "");
    Expect(0, 12289, '\p{Is_SB=	_Sp}', "");
    Expect(1, 12289, '\p{^Is_SB=	_Sp}', "");
    Expect(1, 12289, '\P{Is_SB=	_Sp}', "");
    Expect(0, 12289, '\P{^Is_SB=	_Sp}', "");
    Error('\p{Sentence_Break=-/a/sterm}');
    Error('\P{Sentence_Break=-/a/sterm}');
    Expect(1, 121480, '\p{Sentence_Break=:\ASTerm\z:}', "");;
    Expect(0, 121481, '\p{Sentence_Break=:\ASTerm\z:}', "");;
    Expect(1, 121480, '\p{Sentence_Break=sterm}', "");
    Expect(0, 121480, '\p{^Sentence_Break=sterm}', "");
    Expect(0, 121480, '\P{Sentence_Break=sterm}', "");
    Expect(1, 121480, '\P{^Sentence_Break=sterm}', "");
    Expect(0, 121481, '\p{Sentence_Break=sterm}', "");
    Expect(1, 121481, '\p{^Sentence_Break=sterm}', "");
    Expect(1, 121481, '\P{Sentence_Break=sterm}', "");
    Expect(0, 121481, '\P{^Sentence_Break=sterm}', "");
    Expect(1, 121480, '\p{Sentence_Break=:\Asterm\z:}', "");;
    Expect(0, 121481, '\p{Sentence_Break=:\Asterm\z:}', "");;
    Expect(1, 121480, '\p{Sentence_Break=_ STerm}', "");
    Expect(0, 121480, '\p{^Sentence_Break=_ STerm}', "");
    Expect(0, 121480, '\P{Sentence_Break=_ STerm}', "");
    Expect(1, 121480, '\P{^Sentence_Break=_ STerm}', "");
    Expect(0, 121481, '\p{Sentence_Break=_ STerm}', "");
    Expect(1, 121481, '\p{^Sentence_Break=_ STerm}', "");
    Expect(1, 121481, '\P{Sentence_Break=_ STerm}', "");
    Expect(0, 121481, '\P{^Sentence_Break=_ STerm}', "");
    Error('\p{SB=/a/	_ST}');
    Error('\P{SB=/a/	_ST}');
    Expect(1, 121480, '\p{SB=:\AST\z:}', "");;
    Expect(0, 121481, '\p{SB=:\AST\z:}', "");;
    Expect(1, 121480, '\p{SB=st}', "");
    Expect(0, 121480, '\p{^SB=st}', "");
    Expect(0, 121480, '\P{SB=st}', "");
    Expect(1, 121480, '\P{^SB=st}', "");
    Expect(0, 121481, '\p{SB=st}', "");
    Expect(1, 121481, '\p{^SB=st}', "");
    Expect(1, 121481, '\P{SB=st}', "");
    Expect(0, 121481, '\P{^SB=st}', "");
    Expect(1, 121480, '\p{SB=:\Ast\z:}', "");;
    Expect(0, 121481, '\p{SB=:\Ast\z:}', "");;
    Expect(1, 121480, '\p{SB=		ST}', "");
    Expect(0, 121480, '\p{^SB=		ST}', "");
    Expect(0, 121480, '\P{SB=		ST}', "");
    Expect(1, 121480, '\P{^SB=		ST}', "");
    Expect(0, 121481, '\p{SB=		ST}', "");
    Expect(1, 121481, '\p{^SB=		ST}', "");
    Expect(1, 121481, '\P{SB=		ST}', "");
    Expect(0, 121481, '\P{^SB=		ST}', "");
    Error('\p{Is_Sentence_Break=/a/STerm}');
    Error('\P{Is_Sentence_Break=/a/STerm}');
    Expect(1, 121480, '\p{Is_Sentence_Break=sterm}', "");
    Expect(0, 121480, '\p{^Is_Sentence_Break=sterm}', "");
    Expect(0, 121480, '\P{Is_Sentence_Break=sterm}', "");
    Expect(1, 121480, '\P{^Is_Sentence_Break=sterm}', "");
    Expect(0, 121481, '\p{Is_Sentence_Break=sterm}', "");
    Expect(1, 121481, '\p{^Is_Sentence_Break=sterm}', "");
    Expect(1, 121481, '\P{Is_Sentence_Break=sterm}', "");
    Expect(0, 121481, '\P{^Is_Sentence_Break=sterm}', "");
    Expect(1, 121480, '\p{Is_Sentence_Break:    -STerm}', "");
    Expect(0, 121480, '\p{^Is_Sentence_Break:    -STerm}', "");
    Expect(0, 121480, '\P{Is_Sentence_Break:    -STerm}', "");
    Expect(1, 121480, '\P{^Is_Sentence_Break:    -STerm}', "");
    Expect(0, 121481, '\p{Is_Sentence_Break:    -STerm}', "");
    Expect(1, 121481, '\p{^Is_Sentence_Break:    -STerm}', "");
    Expect(1, 121481, '\P{Is_Sentence_Break:    -STerm}', "");
    Expect(0, 121481, '\P{^Is_Sentence_Break:    -STerm}', "");
    Error('\p{Is_SB=:=-ST}');
    Error('\P{Is_SB=:=-ST}');
    Expect(1, 121480, '\p{Is_SB=st}', "");
    Expect(0, 121480, '\p{^Is_SB=st}', "");
    Expect(0, 121480, '\P{Is_SB=st}', "");
    Expect(1, 121480, '\P{^Is_SB=st}', "");
    Expect(0, 121481, '\p{Is_SB=st}', "");
    Expect(1, 121481, '\p{^Is_SB=st}', "");
    Expect(1, 121481, '\P{Is_SB=st}', "");
    Expect(0, 121481, '\P{^Is_SB=st}', "");
    Expect(1, 121480, '\p{Is_SB= _ST}', "");
    Expect(0, 121480, '\p{^Is_SB= _ST}', "");
    Expect(0, 121480, '\P{Is_SB= _ST}', "");
    Expect(1, 121480, '\P{^Is_SB= _ST}', "");
    Expect(0, 121481, '\p{Is_SB= _ST}', "");
    Expect(1, 121481, '\p{^Is_SB= _ST}', "");
    Expect(1, 121481, '\P{Is_SB= _ST}', "");
    Expect(0, 121481, '\P{^Is_SB= _ST}', "");
    Error('\p{Sentence_Break:-:=upper}');
    Error('\P{Sentence_Break:-:=upper}');
    Expect(1, 127369, '\p{Sentence_Break=:\AUpper\z:}', "");;
    Expect(0, 127370, '\p{Sentence_Break=:\AUpper\z:}', "");;
    Expect(1, 127369, '\p{Sentence_Break=upper}', "");
    Expect(0, 127369, '\p{^Sentence_Break=upper}', "");
    Expect(0, 127369, '\P{Sentence_Break=upper}', "");
    Expect(1, 127369, '\P{^Sentence_Break=upper}', "");
    Expect(0, 127370, '\p{Sentence_Break=upper}', "");
    Expect(1, 127370, '\p{^Sentence_Break=upper}', "");
    Expect(1, 127370, '\P{Sentence_Break=upper}', "");
    Expect(0, 127370, '\P{^Sentence_Break=upper}', "");
    Expect(1, 127369, '\p{Sentence_Break=:\Aupper\z:}', "");;
    Expect(0, 127370, '\p{Sentence_Break=:\Aupper\z:}', "");;
    Expect(1, 127369, '\p{Sentence_Break=	 Upper}', "");
    Expect(0, 127369, '\p{^Sentence_Break=	 Upper}', "");
    Expect(0, 127369, '\P{Sentence_Break=	 Upper}', "");
    Expect(1, 127369, '\P{^Sentence_Break=	 Upper}', "");
    Expect(0, 127370, '\p{Sentence_Break=	 Upper}', "");
    Expect(1, 127370, '\p{^Sentence_Break=	 Upper}', "");
    Expect(1, 127370, '\P{Sentence_Break=	 Upper}', "");
    Expect(0, 127370, '\P{^Sentence_Break=	 Upper}', "");
    Error('\p{SB=/a/up}');
    Error('\P{SB=/a/up}');
    Expect(1, 127369, '\p{SB=:\AUP\z:}', "");;
    Expect(0, 127370, '\p{SB=:\AUP\z:}', "");;
    Expect(1, 127369, '\p{SB=up}', "");
    Expect(0, 127369, '\p{^SB=up}', "");
    Expect(0, 127369, '\P{SB=up}', "");
    Expect(1, 127369, '\P{^SB=up}', "");
    Expect(0, 127370, '\p{SB=up}', "");
    Expect(1, 127370, '\p{^SB=up}', "");
    Expect(1, 127370, '\P{SB=up}', "");
    Expect(0, 127370, '\P{^SB=up}', "");
    Expect(1, 127369, '\p{SB=:\Aup\z:}', "");;
    Expect(0, 127370, '\p{SB=:\Aup\z:}', "");;
    Expect(1, 127369, '\p{SB=	UP}', "");
    Expect(0, 127369, '\p{^SB=	UP}', "");
    Expect(0, 127369, '\P{SB=	UP}', "");
    Expect(1, 127369, '\P{^SB=	UP}', "");
    Expect(0, 127370, '\p{SB=	UP}', "");
    Expect(1, 127370, '\p{^SB=	UP}', "");
    Expect(1, 127370, '\P{SB=	UP}', "");
    Expect(0, 127370, '\P{^SB=	UP}', "");
    Error('\p{Is_Sentence_Break=_ upper/a/}');
    Error('\P{Is_Sentence_Break=_ upper/a/}');
    Expect(1, 127369, '\p{Is_Sentence_Break=upper}', "");
    Expect(0, 127369, '\p{^Is_Sentence_Break=upper}', "");
    Expect(0, 127369, '\P{Is_Sentence_Break=upper}', "");
    Expect(1, 127369, '\P{^Is_Sentence_Break=upper}', "");
    Expect(0, 127370, '\p{Is_Sentence_Break=upper}', "");
    Expect(1, 127370, '\p{^Is_Sentence_Break=upper}', "");
    Expect(1, 127370, '\P{Is_Sentence_Break=upper}', "");
    Expect(0, 127370, '\P{^Is_Sentence_Break=upper}', "");
    Expect(1, 127369, '\p{Is_Sentence_Break=-	upper}', "");
    Expect(0, 127369, '\p{^Is_Sentence_Break=-	upper}', "");
    Expect(0, 127369, '\P{Is_Sentence_Break=-	upper}', "");
    Expect(1, 127369, '\P{^Is_Sentence_Break=-	upper}', "");
    Expect(0, 127370, '\p{Is_Sentence_Break=-	upper}', "");
    Expect(1, 127370, '\p{^Is_Sentence_Break=-	upper}', "");
    Expect(1, 127370, '\P{Is_Sentence_Break=-	upper}', "");
    Expect(0, 127370, '\P{^Is_Sentence_Break=-	upper}', "");
    Error('\p{Is_SB=:=-UP}');
    Error('\P{Is_SB=:=-UP}');
    Expect(1, 127369, '\p{Is_SB=up}', "");
    Expect(0, 127369, '\p{^Is_SB=up}', "");
    Expect(0, 127369, '\P{Is_SB=up}', "");
    Expect(1, 127369, '\P{^Is_SB=up}', "");
    Expect(0, 127370, '\p{Is_SB=up}', "");
    Expect(1, 127370, '\p{^Is_SB=up}', "");
    Expect(1, 127370, '\P{Is_SB=up}', "");
    Expect(0, 127370, '\P{^Is_SB=up}', "");
    Expect(1, 127369, '\p{Is_SB=-UP}', "");
    Expect(0, 127369, '\p{^Is_SB=-UP}', "");
    Expect(0, 127369, '\P{Is_SB=-UP}', "");
    Expect(1, 127369, '\P{^Is_SB=-UP}', "");
    Expect(0, 127370, '\p{Is_SB=-UP}', "");
    Expect(1, 127370, '\p{^Is_SB=-UP}', "");
    Expect(1, 127370, '\P{Is_SB=-UP}', "");
    Expect(0, 127370, '\P{^Is_SB=-UP}', "");
    Error('\p{Sentence_Break=/a/other}');
    Error('\P{Sentence_Break=/a/other}');
    Expect(1, 918000, '\p{Sentence_Break=:\AOther\z:}', "");;
    Expect(0, 917999, '\p{Sentence_Break=:\AOther\z:}', "");;
    Expect(1, 918000, '\p{Sentence_Break=other}', "");
    Expect(0, 918000, '\p{^Sentence_Break=other}', "");
    Expect(0, 918000, '\P{Sentence_Break=other}', "");
    Expect(1, 918000, '\P{^Sentence_Break=other}', "");
    Expect(0, 917999, '\p{Sentence_Break=other}', "");
    Expect(1, 917999, '\p{^Sentence_Break=other}', "");
    Expect(1, 917999, '\P{Sentence_Break=other}', "");
    Expect(0, 917999, '\P{^Sentence_Break=other}', "");
    Expect(1, 918000, '\p{Sentence_Break=:\Aother\z:}', "");;
    Expect(0, 917999, '\p{Sentence_Break=:\Aother\z:}', "");;
    Expect(1, 918000, '\p{Sentence_Break=  other}', "");
    Expect(0, 918000, '\p{^Sentence_Break=  other}', "");
    Expect(0, 918000, '\P{Sentence_Break=  other}', "");
    Expect(1, 918000, '\P{^Sentence_Break=  other}', "");
    Expect(0, 917999, '\p{Sentence_Break=  other}', "");
    Expect(1, 917999, '\p{^Sentence_Break=  other}', "");
    Expect(1, 917999, '\P{Sentence_Break=  other}', "");
    Expect(0, 917999, '\P{^Sentence_Break=  other}', "");
    Error('\p{SB=/a/	 XX}');
    Error('\P{SB=/a/	 XX}');
    Expect(1, 918000, '\p{SB=:\AXX\z:}', "");;
    Expect(0, 917999, '\p{SB=:\AXX\z:}', "");;
    Expect(1, 918000, '\p{SB=xx}', "");
    Expect(0, 918000, '\p{^SB=xx}', "");
    Expect(0, 918000, '\P{SB=xx}', "");
    Expect(1, 918000, '\P{^SB=xx}', "");
    Expect(0, 917999, '\p{SB=xx}', "");
    Expect(1, 917999, '\p{^SB=xx}', "");
    Expect(1, 917999, '\P{SB=xx}', "");
    Expect(0, 917999, '\P{^SB=xx}', "");
    Expect(1, 918000, '\p{SB=:\Axx\z:}', "");;
    Expect(0, 917999, '\p{SB=:\Axx\z:}', "");;
    Expect(1, 918000, '\p{SB=_ XX}', "");
    Expect(0, 918000, '\p{^SB=_ XX}', "");
    Expect(0, 918000, '\P{SB=_ XX}', "");
    Expect(1, 918000, '\P{^SB=_ XX}', "");
    Expect(0, 917999, '\p{SB=_ XX}', "");
    Expect(1, 917999, '\p{^SB=_ XX}', "");
    Expect(1, 917999, '\P{SB=_ XX}', "");
    Expect(0, 917999, '\P{^SB=_ XX}', "");
    Error('\p{Is_Sentence_Break=/a/--Other}');
    Error('\P{Is_Sentence_Break=/a/--Other}');
    Expect(1, 918000, '\p{Is_Sentence_Break=other}', "");
    Expect(0, 918000, '\p{^Is_Sentence_Break=other}', "");
    Expect(0, 918000, '\P{Is_Sentence_Break=other}', "");
    Expect(1, 918000, '\P{^Is_Sentence_Break=other}', "");
    Expect(0, 917999, '\p{Is_Sentence_Break=other}', "");
    Expect(1, 917999, '\p{^Is_Sentence_Break=other}', "");
    Expect(1, 917999, '\P{Is_Sentence_Break=other}', "");
    Expect(0, 917999, '\P{^Is_Sentence_Break=other}', "");
    Expect(1, 918000, '\p{Is_Sentence_Break=-	Other}', "");
    Expect(0, 918000, '\p{^Is_Sentence_Break=-	Other}', "");
    Expect(0, 918000, '\P{Is_Sentence_Break=-	Other}', "");
    Expect(1, 918000, '\P{^Is_Sentence_Break=-	Other}', "");
    Expect(0, 917999, '\p{Is_Sentence_Break=-	Other}', "");
    Expect(1, 917999, '\p{^Is_Sentence_Break=-	Other}', "");
    Expect(1, 917999, '\P{Is_Sentence_Break=-	Other}', "");
    Expect(0, 917999, '\P{^Is_Sentence_Break=-	Other}', "");
    Error('\p{Is_SB=:=-	XX}');
    Error('\P{Is_SB=:=-	XX}');
    Expect(1, 918000, '\p{Is_SB=xx}', "");
    Expect(0, 918000, '\p{^Is_SB=xx}', "");
    Expect(0, 918000, '\P{Is_SB=xx}', "");
    Expect(1, 918000, '\P{^Is_SB=xx}', "");
    Expect(0, 917999, '\p{Is_SB=xx}', "");
    Expect(1, 917999, '\p{^Is_SB=xx}', "");
    Expect(1, 917999, '\P{Is_SB=xx}', "");
    Expect(0, 917999, '\P{^Is_SB=xx}', "");
    Expect(1, 918000, '\p{Is_SB=	xx}', "");
    Expect(0, 918000, '\p{^Is_SB=	xx}', "");
    Expect(0, 918000, '\P{Is_SB=	xx}', "");
    Expect(1, 918000, '\P{^Is_SB=	xx}', "");
    Expect(0, 917999, '\p{Is_SB=	xx}', "");
    Expect(1, 917999, '\p{^Is_SB=	xx}', "");
    Expect(1, 917999, '\P{Is_SB=	xx}', "");
    Expect(0, 917999, '\P{^Is_SB=	xx}', "");
    Error('\p{script}');
    Error('\P{script}');
    Error('\p{Script= :=Adlam}');
    Error('\P{Script= :=Adlam}');
    Expect(1, 125279, '\p{Script=:\AAdlam\z:}', "");;
    Expect(0, 125280, '\p{Script=:\AAdlam\z:}', "");;
    Expect(1, 125279, '\p{Script=adlam}', "");
    Expect(0, 125279, '\p{^Script=adlam}', "");
    Expect(0, 125279, '\P{Script=adlam}', "");
    Expect(1, 125279, '\P{^Script=adlam}', "");
    Expect(0, 125280, '\p{Script=adlam}', "");
    Expect(1, 125280, '\p{^Script=adlam}', "");
    Expect(1, 125280, '\P{Script=adlam}', "");
    Expect(0, 125280, '\P{^Script=adlam}', "");
    Expect(1, 125279, '\p{Script=:\Aadlam\z:}', "");;
    Expect(0, 125280, '\p{Script=:\Aadlam\z:}', "");;
    Expect(1, 125279, '\p{Script= _Adlam}', "");
    Expect(0, 125279, '\p{^Script= _Adlam}', "");
    Expect(0, 125279, '\P{Script= _Adlam}', "");
    Expect(1, 125279, '\P{^Script= _Adlam}', "");
    Expect(0, 125280, '\p{Script= _Adlam}', "");
    Expect(1, 125280, '\p{^Script= _Adlam}', "");
    Expect(1, 125280, '\P{Script= _Adlam}', "");
    Expect(0, 125280, '\P{^Script= _Adlam}', "");
    Error('\p{Sc:/a/Adlm}');
    Error('\P{Sc:/a/Adlm}');
    Expect(1, 125279, '\p{Sc=:\AAdlm\z:}', "");;
    Expect(0, 125280, '\p{Sc=:\AAdlm\z:}', "");;
    Expect(1, 125279, '\p{Sc:adlm}', "");
    Expect(0, 125279, '\p{^Sc:adlm}', "");
    Expect(0, 125279, '\P{Sc:adlm}', "");
    Expect(1, 125279, '\P{^Sc:adlm}', "");
    Expect(0, 125280, '\p{Sc:adlm}', "");
    Expect(1, 125280, '\p{^Sc:adlm}', "");
    Expect(1, 125280, '\P{Sc:adlm}', "");
    Expect(0, 125280, '\P{^Sc:adlm}', "");
    Expect(1, 125279, '\p{Sc=:\Aadlm\z:}', "");;
    Expect(0, 125280, '\p{Sc=:\Aadlm\z:}', "");;
    Expect(1, 125279, '\p{Sc:   adlm}', "");
    Expect(0, 125279, '\p{^Sc:   adlm}', "");
    Expect(0, 125279, '\P{Sc:   adlm}', "");
    Expect(1, 125279, '\P{^Sc:   adlm}', "");
    Expect(0, 125280, '\p{Sc:   adlm}', "");
    Expect(1, 125280, '\p{^Sc:   adlm}', "");
    Expect(1, 125280, '\P{Sc:   adlm}', "");
    Expect(0, 125280, '\P{^Sc:   adlm}', "");
    Error('\p{Is_Script: -	Adlam:=}');
    Error('\P{Is_Script: -	Adlam:=}');
    Expect(1, 125279, '\p{Is_Script:   adlam}', "");
    Expect(0, 125279, '\p{^Is_Script:   adlam}', "");
    Expect(0, 125279, '\P{Is_Script:   adlam}', "");
    Expect(1, 125279, '\P{^Is_Script:   adlam}', "");
    Expect(0, 125280, '\p{Is_Script:   adlam}', "");
    Expect(1, 125280, '\p{^Is_Script:   adlam}', "");
    Expect(1, 125280, '\P{Is_Script:   adlam}', "");
    Expect(0, 125280, '\P{^Is_Script:   adlam}', "");
    Expect(1, 125279, '\p{Is_Script=	_ADLAM}', "");
    Expect(0, 125279, '\p{^Is_Script=	_ADLAM}', "");
    Expect(0, 125279, '\P{Is_Script=	_ADLAM}', "");
    Expect(1, 125279, '\P{^Is_Script=	_ADLAM}', "");
    Expect(0, 125280, '\p{Is_Script=	_ADLAM}', "");
    Expect(1, 125280, '\p{^Is_Script=	_ADLAM}', "");
    Expect(1, 125280, '\P{Is_Script=	_ADLAM}', "");
    Expect(0, 125280, '\P{^Is_Script=	_ADLAM}', "");
    Error('\p{Is_Sc=	/a/ADLM}');
    Error('\P{Is_Sc=	/a/ADLM}');
    Expect(1, 125279, '\p{Is_Sc=adlm}', "");
    Expect(0, 125279, '\p{^Is_Sc=adlm}', "");
    Expect(0, 125279, '\P{Is_Sc=adlm}', "");
    Expect(1, 125279, '\P{^Is_Sc=adlm}', "");
    Expect(0, 125280, '\p{Is_Sc=adlm}', "");
    Expect(1, 125280, '\p{^Is_Sc=adlm}', "");
    Expect(1, 125280, '\P{Is_Sc=adlm}', "");
    Expect(0, 125280, '\P{^Is_Sc=adlm}', "");
    Expect(1, 125279, '\p{Is_Sc:   	 Adlm}', "");
    Expect(0, 125279, '\p{^Is_Sc:   	 Adlm}', "");
    Expect(0, 125279, '\P{Is_Sc:   	 Adlm}', "");
    Expect(1, 125279, '\P{^Is_Sc:   	 Adlm}', "");
    Expect(0, 125280, '\p{Is_Sc:   	 Adlm}', "");
    Expect(1, 125280, '\p{^Is_Sc:   	 Adlm}', "");
    Expect(1, 125280, '\P{Is_Sc:   	 Adlm}', "");
    Expect(0, 125280, '\P{^Is_Sc:   	 Adlm}', "");
    Error('\p{Script= /a/Caucasian_Albanian}');
    Error('\P{Script= /a/Caucasian_Albanian}');
    Expect(1, 66927, '\p{Script=:\ACaucasian_Albanian\z:}', "");;
    Expect(0, 66928, '\p{Script=:\ACaucasian_Albanian\z:}', "");;
    Expect(1, 66927, '\p{Script=caucasianalbanian}', "");
    Expect(0, 66927, '\p{^Script=caucasianalbanian}', "");
    Expect(0, 66927, '\P{Script=caucasianalbanian}', "");
    Expect(1, 66927, '\P{^Script=caucasianalbanian}', "");
    Expect(0, 66928, '\p{Script=caucasianalbanian}', "");
    Expect(1, 66928, '\p{^Script=caucasianalbanian}', "");
    Expect(1, 66928, '\P{Script=caucasianalbanian}', "");
    Expect(0, 66928, '\P{^Script=caucasianalbanian}', "");
    Expect(1, 66927, '\p{Script=:\Acaucasianalbanian\z:}', "");;
    Expect(0, 66928, '\p{Script=:\Acaucasianalbanian\z:}', "");;
    Expect(1, 66927, '\p{Script=_ Caucasian_Albanian}', "");
    Expect(0, 66927, '\p{^Script=_ Caucasian_Albanian}', "");
    Expect(0, 66927, '\P{Script=_ Caucasian_Albanian}', "");
    Expect(1, 66927, '\P{^Script=_ Caucasian_Albanian}', "");
    Expect(0, 66928, '\p{Script=_ Caucasian_Albanian}', "");
    Expect(1, 66928, '\p{^Script=_ Caucasian_Albanian}', "");
    Expect(1, 66928, '\P{Script=_ Caucasian_Albanian}', "");
    Expect(0, 66928, '\P{^Script=_ Caucasian_Albanian}', "");
    Error('\p{Sc:    :=Aghb}');
    Error('\P{Sc:    :=Aghb}');
    Expect(1, 66927, '\p{Sc=:\AAghb\z:}', "");;
    Expect(0, 66928, '\p{Sc=:\AAghb\z:}', "");;
    Expect(1, 66927, '\p{Sc=aghb}', "");
    Expect(0, 66927, '\p{^Sc=aghb}', "");
    Expect(0, 66927, '\P{Sc=aghb}', "");
    Expect(1, 66927, '\P{^Sc=aghb}', "");
    Expect(0, 66928, '\p{Sc=aghb}', "");
    Expect(1, 66928, '\p{^Sc=aghb}', "");
    Expect(1, 66928, '\P{Sc=aghb}', "");
    Expect(0, 66928, '\P{^Sc=aghb}', "");
    Expect(1, 66927, '\p{Sc=:\Aaghb\z:}', "");;
    Expect(0, 66928, '\p{Sc=:\Aaghb\z:}', "");;
    Expect(1, 66927, '\p{Sc:- Aghb}', "");
    Expect(0, 66927, '\p{^Sc:- Aghb}', "");
    Expect(0, 66927, '\P{Sc:- Aghb}', "");
    Expect(1, 66927, '\P{^Sc:- Aghb}', "");
    Expect(0, 66928, '\p{Sc:- Aghb}', "");
    Expect(1, 66928, '\p{^Sc:- Aghb}', "");
    Expect(1, 66928, '\P{Sc:- Aghb}', "");
    Expect(0, 66928, '\P{^Sc:- Aghb}', "");
    Error('\p{Is_Script=:=--CAUCASIAN_Albanian}');
    Error('\P{Is_Script=:=--CAUCASIAN_Albanian}');
    Expect(1, 66927, '\p{Is_Script=caucasianalbanian}', "");
    Expect(0, 66927, '\p{^Is_Script=caucasianalbanian}', "");
    Expect(0, 66927, '\P{Is_Script=caucasianalbanian}', "");
    Expect(1, 66927, '\P{^Is_Script=caucasianalbanian}', "");
    Expect(0, 66928, '\p{Is_Script=caucasianalbanian}', "");
    Expect(1, 66928, '\p{^Is_Script=caucasianalbanian}', "");
    Expect(1, 66928, '\P{Is_Script=caucasianalbanian}', "");
    Expect(0, 66928, '\P{^Is_Script=caucasianalbanian}', "");
    Expect(1, 66927, '\p{Is_Script=_Caucasian_albanian}', "");
    Expect(0, 66927, '\p{^Is_Script=_Caucasian_albanian}', "");
    Expect(0, 66927, '\P{Is_Script=_Caucasian_albanian}', "");
    Expect(1, 66927, '\P{^Is_Script=_Caucasian_albanian}', "");
    Expect(0, 66928, '\p{Is_Script=_Caucasian_albanian}', "");
    Expect(1, 66928, '\p{^Is_Script=_Caucasian_albanian}', "");
    Expect(1, 66928, '\P{Is_Script=_Caucasian_albanian}', "");
    Expect(0, 66928, '\P{^Is_Script=_Caucasian_albanian}', "");
    Error('\p{Is_Sc=/a/Aghb}');
    Error('\P{Is_Sc=/a/Aghb}');
    Expect(1, 66927, '\p{Is_Sc=aghb}', "");
    Expect(0, 66927, '\p{^Is_Sc=aghb}', "");
    Expect(0, 66927, '\P{Is_Sc=aghb}', "");
    Expect(1, 66927, '\P{^Is_Sc=aghb}', "");
    Expect(0, 66928, '\p{Is_Sc=aghb}', "");
    Expect(1, 66928, '\p{^Is_Sc=aghb}', "");
    Expect(1, 66928, '\P{Is_Sc=aghb}', "");
    Expect(0, 66928, '\P{^Is_Sc=aghb}', "");
    Expect(1, 66927, '\p{Is_Sc= -Aghb}', "");
    Expect(0, 66927, '\p{^Is_Sc= -Aghb}', "");
    Expect(0, 66927, '\P{Is_Sc= -Aghb}', "");
    Expect(1, 66927, '\P{^Is_Sc= -Aghb}', "");
    Expect(0, 66928, '\p{Is_Sc= -Aghb}', "");
    Expect(1, 66928, '\p{^Is_Sc= -Aghb}', "");
    Expect(1, 66928, '\P{Is_Sc= -Aghb}', "");
    Expect(0, 66928, '\P{^Is_Sc= -Aghb}', "");
    Error('\p{Script=-AHOM/a/}');
    Error('\P{Script=-AHOM/a/}');
    Expect(1, 71487, '\p{Script=:\AAhom\z:}', "");;
    Expect(0, 71488, '\p{Script=:\AAhom\z:}', "");;
    Expect(1, 71487, '\p{Script=ahom}', "");
    Expect(0, 71487, '\p{^Script=ahom}', "");
    Expect(0, 71487, '\P{Script=ahom}', "");
    Expect(1, 71487, '\P{^Script=ahom}', "");
    Expect(0, 71488, '\p{Script=ahom}', "");
    Expect(1, 71488, '\p{^Script=ahom}', "");
    Expect(1, 71488, '\P{Script=ahom}', "");
    Expect(0, 71488, '\P{^Script=ahom}', "");
    Expect(1, 71487, '\p{Script=:\Aahom\z:}', "");;
    Expect(0, 71488, '\p{Script=:\Aahom\z:}', "");;
    Expect(1, 71487, '\p{Script=-ahom}', "");
    Expect(0, 71487, '\p{^Script=-ahom}', "");
    Expect(0, 71487, '\P{Script=-ahom}', "");
    Expect(1, 71487, '\P{^Script=-ahom}', "");
    Expect(0, 71488, '\p{Script=-ahom}', "");
    Expect(1, 71488, '\p{^Script=-ahom}', "");
    Expect(1, 71488, '\P{Script=-ahom}', "");
    Expect(0, 71488, '\P{^Script=-ahom}', "");
    Error('\p{Sc=:=_Ahom}');
    Error('\P{Sc=:=_Ahom}');
    Expect(1, 71487, '\p{Sc=:\AAhom\z:}', "");;
    Expect(0, 71488, '\p{Sc=:\AAhom\z:}', "");;
    Expect(1, 71487, '\p{Sc=ahom}', "");
    Expect(0, 71487, '\p{^Sc=ahom}', "");
    Expect(0, 71487, '\P{Sc=ahom}', "");
    Expect(1, 71487, '\P{^Sc=ahom}', "");
    Expect(0, 71488, '\p{Sc=ahom}', "");
    Expect(1, 71488, '\p{^Sc=ahom}', "");
    Expect(1, 71488, '\P{Sc=ahom}', "");
    Expect(0, 71488, '\P{^Sc=ahom}', "");
    Expect(1, 71487, '\p{Sc=:\Aahom\z:}', "");;
    Expect(0, 71488, '\p{Sc=:\Aahom\z:}', "");;
    Expect(1, 71487, '\p{Sc= 	Ahom}', "");
    Expect(0, 71487, '\p{^Sc= 	Ahom}', "");
    Expect(0, 71487, '\P{Sc= 	Ahom}', "");
    Expect(1, 71487, '\P{^Sc= 	Ahom}', "");
    Expect(0, 71488, '\p{Sc= 	Ahom}', "");
    Expect(1, 71488, '\p{^Sc= 	Ahom}', "");
    Expect(1, 71488, '\P{Sc= 	Ahom}', "");
    Expect(0, 71488, '\P{^Sc= 	Ahom}', "");
    Error('\p{Is_Script=	:=ahom}');
    Error('\P{Is_Script=	:=ahom}');
    Expect(1, 71487, '\p{Is_Script=ahom}', "");
    Expect(0, 71487, '\p{^Is_Script=ahom}', "");
    Expect(0, 71487, '\P{Is_Script=ahom}', "");
    Expect(1, 71487, '\P{^Is_Script=ahom}', "");
    Expect(0, 71488, '\p{Is_Script=ahom}', "");
    Expect(1, 71488, '\p{^Is_Script=ahom}', "");
    Expect(1, 71488, '\P{Is_Script=ahom}', "");
    Expect(0, 71488, '\P{^Is_Script=ahom}', "");
    Expect(1, 71487, '\p{Is_Script=-	Ahom}', "");
    Expect(0, 71487, '\p{^Is_Script=-	Ahom}', "");
    Expect(0, 71487, '\P{Is_Script=-	Ahom}', "");
    Expect(1, 71487, '\P{^Is_Script=-	Ahom}', "");
    Expect(0, 71488, '\p{Is_Script=-	Ahom}', "");
    Expect(1, 71488, '\p{^Is_Script=-	Ahom}', "");
    Expect(1, 71488, '\P{Is_Script=-	Ahom}', "");
    Expect(0, 71488, '\P{^Is_Script=-	Ahom}', "");
    Error('\p{Is_Sc:	/a/ ahom}');
    Error('\P{Is_Sc:	/a/ ahom}');
    Expect(1, 71487, '\p{Is_Sc=ahom}', "");
    Expect(0, 71487, '\p{^Is_Sc=ahom}', "");
    Expect(0, 71487, '\P{Is_Sc=ahom}', "");
    Expect(1, 71487, '\P{^Is_Sc=ahom}', "");
    Expect(0, 71488, '\p{Is_Sc=ahom}', "");
    Expect(1, 71488, '\p{^Is_Sc=ahom}', "");
    Expect(1, 71488, '\P{Is_Sc=ahom}', "");
    Expect(0, 71488, '\P{^Is_Sc=ahom}', "");
    Expect(1, 71487, '\p{Is_Sc=	_Ahom}', "");
    Expect(0, 71487, '\p{^Is_Sc=	_Ahom}', "");
    Expect(0, 71487, '\P{Is_Sc=	_Ahom}', "");
    Expect(1, 71487, '\P{^Is_Sc=	_Ahom}', "");
    Expect(0, 71488, '\p{Is_Sc=	_Ahom}', "");
    Expect(1, 71488, '\p{^Is_Sc=	_Ahom}', "");
    Expect(1, 71488, '\P{Is_Sc=	_Ahom}', "");
    Expect(0, 71488, '\P{^Is_Sc=	_Ahom}', "");
    Error('\p{Script=_-ARABIC/a/}');
    Error('\P{Script=_-ARABIC/a/}');
    Expect(1, 126705, '\p{Script=:\AArabic\z:}', "");;
    Expect(0, 126706, '\p{Script=:\AArabic\z:}', "");;
    Expect(1, 126705, '\p{Script:arabic}', "");
    Expect(0, 126705, '\p{^Script:arabic}', "");
    Expect(0, 126705, '\P{Script:arabic}', "");
    Expect(1, 126705, '\P{^Script:arabic}', "");
    Expect(0, 126706, '\p{Script:arabic}', "");
    Expect(1, 126706, '\p{^Script:arabic}', "");
    Expect(1, 126706, '\P{Script:arabic}', "");
    Expect(0, 126706, '\P{^Script:arabic}', "");
    Expect(1, 126705, '\p{Script=:\Aarabic\z:}', "");;
    Expect(0, 126706, '\p{Script=:\Aarabic\z:}', "");;
    Expect(1, 126705, '\p{Script= 	Arabic}', "");
    Expect(0, 126705, '\p{^Script= 	Arabic}', "");
    Expect(0, 126705, '\P{Script= 	Arabic}', "");
    Expect(1, 126705, '\P{^Script= 	Arabic}', "");
    Expect(0, 126706, '\p{Script= 	Arabic}', "");
    Expect(1, 126706, '\p{^Script= 	Arabic}', "");
    Expect(1, 126706, '\P{Script= 	Arabic}', "");
    Expect(0, 126706, '\P{^Script= 	Arabic}', "");
    Error('\p{Sc=_ARAB/a/}');
    Error('\P{Sc=_ARAB/a/}');
    Expect(1, 126705, '\p{Sc=:\AArab\z:}', "");;
    Expect(0, 126706, '\p{Sc=:\AArab\z:}', "");;
    Expect(1, 126705, '\p{Sc=arab}', "");
    Expect(0, 126705, '\p{^Sc=arab}', "");
    Expect(0, 126705, '\P{Sc=arab}', "");
    Expect(1, 126705, '\P{^Sc=arab}', "");
    Expect(0, 126706, '\p{Sc=arab}', "");
    Expect(1, 126706, '\p{^Sc=arab}', "");
    Expect(1, 126706, '\P{Sc=arab}', "");
    Expect(0, 126706, '\P{^Sc=arab}', "");
    Expect(1, 126705, '\p{Sc=:\Aarab\z:}', "");;
    Expect(0, 126706, '\p{Sc=:\Aarab\z:}', "");;
    Expect(1, 126705, '\p{Sc=-_ARAB}', "");
    Expect(0, 126705, '\p{^Sc=-_ARAB}', "");
    Expect(0, 126705, '\P{Sc=-_ARAB}', "");
    Expect(1, 126705, '\P{^Sc=-_ARAB}', "");
    Expect(0, 126706, '\p{Sc=-_ARAB}', "");
    Expect(1, 126706, '\p{^Sc=-_ARAB}', "");
    Expect(1, 126706, '\P{Sc=-_ARAB}', "");
    Expect(0, 126706, '\P{^Sc=-_ARAB}', "");
    Error('\p{Is_Script=:=- arabic}');
    Error('\P{Is_Script=:=- arabic}');
    Expect(1, 126705, '\p{Is_Script=arabic}', "");
    Expect(0, 126705, '\p{^Is_Script=arabic}', "");
    Expect(0, 126705, '\P{Is_Script=arabic}', "");
    Expect(1, 126705, '\P{^Is_Script=arabic}', "");
    Expect(0, 126706, '\p{Is_Script=arabic}', "");
    Expect(1, 126706, '\p{^Is_Script=arabic}', "");
    Expect(1, 126706, '\P{Is_Script=arabic}', "");
    Expect(0, 126706, '\P{^Is_Script=arabic}', "");
    Expect(1, 126705, '\p{Is_Script=- arabic}', "");
    Expect(0, 126705, '\p{^Is_Script=- arabic}', "");
    Expect(0, 126705, '\P{Is_Script=- arabic}', "");
    Expect(1, 126705, '\P{^Is_Script=- arabic}', "");
    Expect(0, 126706, '\p{Is_Script=- arabic}', "");
    Expect(1, 126706, '\p{^Is_Script=- arabic}', "");
    Expect(1, 126706, '\P{Is_Script=- arabic}', "");
    Expect(0, 126706, '\P{^Is_Script=- arabic}', "");
    Error('\p{Is_Sc=:=  arab}');
    Error('\P{Is_Sc=:=  arab}');
    Expect(1, 126705, '\p{Is_Sc=arab}', "");
    Expect(0, 126705, '\p{^Is_Sc=arab}', "");
    Expect(0, 126705, '\P{Is_Sc=arab}', "");
    Expect(1, 126705, '\P{^Is_Sc=arab}', "");
    Expect(0, 126706, '\p{Is_Sc=arab}', "");
    Expect(1, 126706, '\p{^Is_Sc=arab}', "");
    Expect(1, 126706, '\P{Is_Sc=arab}', "");
    Expect(0, 126706, '\P{^Is_Sc=arab}', "");
    Expect(1, 126705, '\p{Is_Sc=- ARAB}', "");
    Expect(0, 126705, '\p{^Is_Sc=- ARAB}', "");
    Expect(0, 126705, '\P{Is_Sc=- ARAB}', "");
    Expect(1, 126705, '\P{^Is_Sc=- ARAB}', "");
    Expect(0, 126706, '\p{Is_Sc=- ARAB}', "");
    Expect(1, 126706, '\p{^Is_Sc=- ARAB}', "");
    Expect(1, 126706, '\P{Is_Sc=- ARAB}', "");
    Expect(0, 126706, '\P{^Is_Sc=- ARAB}', "");
    Error('\p{Script=:=-Imperial_ARAMAIC}');
    Error('\P{Script=:=-Imperial_ARAMAIC}');
    Expect(1, 67679, '\p{Script=:\AImperial_Aramaic\z:}', "");;
    Expect(0, 67680, '\p{Script=:\AImperial_Aramaic\z:}', "");;
    Expect(1, 67679, '\p{Script=imperialaramaic}', "");
    Expect(0, 67679, '\p{^Script=imperialaramaic}', "");
    Expect(0, 67679, '\P{Script=imperialaramaic}', "");
    Expect(1, 67679, '\P{^Script=imperialaramaic}', "");
    Expect(0, 67680, '\p{Script=imperialaramaic}', "");
    Expect(1, 67680, '\p{^Script=imperialaramaic}', "");
    Expect(1, 67680, '\P{Script=imperialaramaic}', "");
    Expect(0, 67680, '\P{^Script=imperialaramaic}', "");
    Expect(1, 67679, '\p{Script=:\Aimperialaramaic\z:}', "");;
    Expect(0, 67680, '\p{Script=:\Aimperialaramaic\z:}', "");;
    Expect(1, 67679, '\p{Script: 	imperial_ARAMAIC}', "");
    Expect(0, 67679, '\p{^Script: 	imperial_ARAMAIC}', "");
    Expect(0, 67679, '\P{Script: 	imperial_ARAMAIC}', "");
    Expect(1, 67679, '\P{^Script: 	imperial_ARAMAIC}', "");
    Expect(0, 67680, '\p{Script: 	imperial_ARAMAIC}', "");
    Expect(1, 67680, '\p{^Script: 	imperial_ARAMAIC}', "");
    Expect(1, 67680, '\P{Script: 	imperial_ARAMAIC}', "");
    Expect(0, 67680, '\P{^Script: 	imperial_ARAMAIC}', "");
    Error('\p{Sc=_:=Armi}');
    Error('\P{Sc=_:=Armi}');
    Expect(1, 67679, '\p{Sc=:\AArmi\z:}', "");;
    Expect(0, 67680, '\p{Sc=:\AArmi\z:}', "");;
    Expect(1, 67679, '\p{Sc=armi}', "");
    Expect(0, 67679, '\p{^Sc=armi}', "");
    Expect(0, 67679, '\P{Sc=armi}', "");
    Expect(1, 67679, '\P{^Sc=armi}', "");
    Expect(0, 67680, '\p{Sc=armi}', "");
    Expect(1, 67680, '\p{^Sc=armi}', "");
    Expect(1, 67680, '\P{Sc=armi}', "");
    Expect(0, 67680, '\P{^Sc=armi}', "");
    Expect(1, 67679, '\p{Sc=:\Aarmi\z:}', "");;
    Expect(0, 67680, '\p{Sc=:\Aarmi\z:}', "");;
    Expect(1, 67679, '\p{Sc=__ARMI}', "");
    Expect(0, 67679, '\p{^Sc=__ARMI}', "");
    Expect(0, 67679, '\P{Sc=__ARMI}', "");
    Expect(1, 67679, '\P{^Sc=__ARMI}', "");
    Expect(0, 67680, '\p{Sc=__ARMI}', "");
    Expect(1, 67680, '\p{^Sc=__ARMI}', "");
    Expect(1, 67680, '\P{Sc=__ARMI}', "");
    Expect(0, 67680, '\P{^Sc=__ARMI}', "");
    Error('\p{Is_Script=	_Imperial_aramaic:=}');
    Error('\P{Is_Script=	_Imperial_aramaic:=}');
    Expect(1, 67679, '\p{Is_Script=imperialaramaic}', "");
    Expect(0, 67679, '\p{^Is_Script=imperialaramaic}', "");
    Expect(0, 67679, '\P{Is_Script=imperialaramaic}', "");
    Expect(1, 67679, '\P{^Is_Script=imperialaramaic}', "");
    Expect(0, 67680, '\p{Is_Script=imperialaramaic}', "");
    Expect(1, 67680, '\p{^Is_Script=imperialaramaic}', "");
    Expect(1, 67680, '\P{Is_Script=imperialaramaic}', "");
    Expect(0, 67680, '\P{^Is_Script=imperialaramaic}', "");
    Expect(1, 67679, '\p{Is_Script=_-Imperial_aramaic}', "");
    Expect(0, 67679, '\p{^Is_Script=_-Imperial_aramaic}', "");
    Expect(0, 67679, '\P{Is_Script=_-Imperial_aramaic}', "");
    Expect(1, 67679, '\P{^Is_Script=_-Imperial_aramaic}', "");
    Expect(0, 67680, '\p{Is_Script=_-Imperial_aramaic}', "");
    Expect(1, 67680, '\p{^Is_Script=_-Imperial_aramaic}', "");
    Expect(1, 67680, '\P{Is_Script=_-Imperial_aramaic}', "");
    Expect(0, 67680, '\P{^Is_Script=_-Imperial_aramaic}', "");
    Error('\p{Is_Sc:	_armi:=}');
    Error('\P{Is_Sc:	_armi:=}');
    Expect(1, 67679, '\p{Is_Sc=armi}', "");
    Expect(0, 67679, '\p{^Is_Sc=armi}', "");
    Expect(0, 67679, '\P{Is_Sc=armi}', "");
    Expect(1, 67679, '\P{^Is_Sc=armi}', "");
    Expect(0, 67680, '\p{Is_Sc=armi}', "");
    Expect(1, 67680, '\p{^Is_Sc=armi}', "");
    Expect(1, 67680, '\P{Is_Sc=armi}', "");
    Expect(0, 67680, '\P{^Is_Sc=armi}', "");
    Expect(1, 67679, '\p{Is_Sc=	-Armi}', "");
    Expect(0, 67679, '\p{^Is_Sc=	-Armi}', "");
    Expect(0, 67679, '\P{Is_Sc=	-Armi}', "");
    Expect(1, 67679, '\P{^Is_Sc=	-Armi}', "");
    Expect(0, 67680, '\p{Is_Sc=	-Armi}', "");
    Expect(1, 67680, '\p{^Is_Sc=	-Armi}', "");
    Expect(1, 67680, '\P{Is_Sc=	-Armi}', "");
    Expect(0, 67680, '\P{^Is_Sc=	-Armi}', "");
    Error('\p{Script:  ARMENIAN:=}');
    Error('\P{Script:  ARMENIAN:=}');
    Expect(1, 64279, '\p{Script=:\AArmenian\z:}', "");;
    Expect(0, 64280, '\p{Script=:\AArmenian\z:}', "");;
    Expect(1, 64279, '\p{Script=armenian}', "");
    Expect(0, 64279, '\p{^Script=armenian}', "");
    Expect(0, 64279, '\P{Script=armenian}', "");
    Expect(1, 64279, '\P{^Script=armenian}', "");
    Expect(0, 64280, '\p{Script=armenian}', "");
    Expect(1, 64280, '\p{^Script=armenian}', "");
    Expect(1, 64280, '\P{Script=armenian}', "");
    Expect(0, 64280, '\P{^Script=armenian}', "");
    Expect(1, 64279, '\p{Script=:\Aarmenian\z:}', "");;
    Expect(0, 64280, '\p{Script=:\Aarmenian\z:}', "");;
    Expect(1, 64279, '\p{Script: -Armenian}', "");
    Expect(0, 64279, '\p{^Script: -Armenian}', "");
    Expect(0, 64279, '\P{Script: -Armenian}', "");
    Expect(1, 64279, '\P{^Script: -Armenian}', "");
    Expect(0, 64280, '\p{Script: -Armenian}', "");
    Expect(1, 64280, '\p{^Script: -Armenian}', "");
    Expect(1, 64280, '\P{Script: -Armenian}', "");
    Expect(0, 64280, '\P{^Script: -Armenian}', "");
    Error('\p{Sc: /a/Armn}');
    Error('\P{Sc: /a/Armn}');
    Expect(1, 64279, '\p{Sc=:\AArmn\z:}', "");;
    Expect(0, 64280, '\p{Sc=:\AArmn\z:}', "");;
    Expect(1, 64279, '\p{Sc=armn}', "");
    Expect(0, 64279, '\p{^Sc=armn}', "");
    Expect(0, 64279, '\P{Sc=armn}', "");
    Expect(1, 64279, '\P{^Sc=armn}', "");
    Expect(0, 64280, '\p{Sc=armn}', "");
    Expect(1, 64280, '\p{^Sc=armn}', "");
    Expect(1, 64280, '\P{Sc=armn}', "");
    Expect(0, 64280, '\P{^Sc=armn}', "");
    Expect(1, 64279, '\p{Sc=:\Aarmn\z:}', "");;
    Expect(0, 64280, '\p{Sc=:\Aarmn\z:}', "");;
    Expect(1, 64279, '\p{Sc:   		Armn}', "");
    Expect(0, 64279, '\p{^Sc:   		Armn}', "");
    Expect(0, 64279, '\P{Sc:   		Armn}', "");
    Expect(1, 64279, '\P{^Sc:   		Armn}', "");
    Expect(0, 64280, '\p{Sc:   		Armn}', "");
    Expect(1, 64280, '\p{^Sc:   		Armn}', "");
    Expect(1, 64280, '\P{Sc:   		Armn}', "");
    Expect(0, 64280, '\P{^Sc:   		Armn}', "");
    Error('\p{Is_Script=	/a/Armenian}');
    Error('\P{Is_Script=	/a/Armenian}');
    Expect(1, 64279, '\p{Is_Script:	armenian}', "");
    Expect(0, 64279, '\p{^Is_Script:	armenian}', "");
    Expect(0, 64279, '\P{Is_Script:	armenian}', "");
    Expect(1, 64279, '\P{^Is_Script:	armenian}', "");
    Expect(0, 64280, '\p{Is_Script:	armenian}', "");
    Expect(1, 64280, '\p{^Is_Script:	armenian}', "");
    Expect(1, 64280, '\P{Is_Script:	armenian}', "");
    Expect(0, 64280, '\P{^Is_Script:	armenian}', "");
    Expect(1, 64279, '\p{Is_Script=_Armenian}', "");
    Expect(0, 64279, '\p{^Is_Script=_Armenian}', "");
    Expect(0, 64279, '\P{Is_Script=_Armenian}', "");
    Expect(1, 64279, '\P{^Is_Script=_Armenian}', "");
    Expect(0, 64280, '\p{Is_Script=_Armenian}', "");
    Expect(1, 64280, '\p{^Is_Script=_Armenian}', "");
    Expect(1, 64280, '\P{Is_Script=_Armenian}', "");
    Expect(0, 64280, '\P{^Is_Script=_Armenian}', "");
    Error('\p{Is_Sc=	Armn/a/}');
    Error('\P{Is_Sc=	Armn/a/}');
    Expect(1, 64279, '\p{Is_Sc=armn}', "");
    Expect(0, 64279, '\p{^Is_Sc=armn}', "");
    Expect(0, 64279, '\P{Is_Sc=armn}', "");
    Expect(1, 64279, '\P{^Is_Sc=armn}', "");
    Expect(0, 64280, '\p{Is_Sc=armn}', "");
    Expect(1, 64280, '\p{^Is_Sc=armn}', "");
    Expect(1, 64280, '\P{Is_Sc=armn}', "");
    Expect(0, 64280, '\P{^Is_Sc=armn}', "");
    Expect(1, 64279, '\p{Is_Sc=	Armn}', "");
    Expect(0, 64279, '\p{^Is_Sc=	Armn}', "");
    Expect(0, 64279, '\P{Is_Sc=	Armn}', "");
    Expect(1, 64279, '\P{^Is_Sc=	Armn}', "");
    Expect(0, 64280, '\p{Is_Sc=	Armn}', "");
    Expect(1, 64280, '\p{^Is_Sc=	Armn}', "");
    Expect(1, 64280, '\P{Is_Sc=	Armn}', "");
    Expect(0, 64280, '\P{^Is_Sc=	Armn}', "");
    Error('\p{Script:  /a/avestan}');
    Error('\P{Script:  /a/avestan}');
    Expect(1, 68415, '\p{Script=:\AAvestan\z:}', "");;
    Expect(0, 68416, '\p{Script=:\AAvestan\z:}', "");;
    Expect(1, 68415, '\p{Script:	avestan}', "");
    Expect(0, 68415, '\p{^Script:	avestan}', "");
    Expect(0, 68415, '\P{Script:	avestan}', "");
    Expect(1, 68415, '\P{^Script:	avestan}', "");
    Expect(0, 68416, '\p{Script:	avestan}', "");
    Expect(1, 68416, '\p{^Script:	avestan}', "");
    Expect(1, 68416, '\P{Script:	avestan}', "");
    Expect(0, 68416, '\P{^Script:	avestan}', "");
    Expect(1, 68415, '\p{Script=:\Aavestan\z:}', "");;
    Expect(0, 68416, '\p{Script=:\Aavestan\z:}', "");;
    Expect(1, 68415, '\p{Script=	avestan}', "");
    Expect(0, 68415, '\p{^Script=	avestan}', "");
    Expect(0, 68415, '\P{Script=	avestan}', "");
    Expect(1, 68415, '\P{^Script=	avestan}', "");
    Expect(0, 68416, '\p{Script=	avestan}', "");
    Expect(1, 68416, '\p{^Script=	avestan}', "");
    Expect(1, 68416, '\P{Script=	avestan}', "");
    Expect(0, 68416, '\P{^Script=	avestan}', "");
    Error('\p{Sc= /a/Avst}');
    Error('\P{Sc= /a/Avst}');
    Expect(1, 68415, '\p{Sc=:\AAvst\z:}', "");;
    Expect(0, 68416, '\p{Sc=:\AAvst\z:}', "");;
    Expect(1, 68415, '\p{Sc=avst}', "");
    Expect(0, 68415, '\p{^Sc=avst}', "");
    Expect(0, 68415, '\P{Sc=avst}', "");
    Expect(1, 68415, '\P{^Sc=avst}', "");
    Expect(0, 68416, '\p{Sc=avst}', "");
    Expect(1, 68416, '\p{^Sc=avst}', "");
    Expect(1, 68416, '\P{Sc=avst}', "");
    Expect(0, 68416, '\P{^Sc=avst}', "");
    Expect(1, 68415, '\p{Sc=:\Aavst\z:}', "");;
    Expect(0, 68416, '\p{Sc=:\Aavst\z:}', "");;
    Expect(1, 68415, '\p{Sc=	Avst}', "");
    Expect(0, 68415, '\p{^Sc=	Avst}', "");
    Expect(0, 68415, '\P{Sc=	Avst}', "");
    Expect(1, 68415, '\P{^Sc=	Avst}', "");
    Expect(0, 68416, '\p{Sc=	Avst}', "");
    Expect(1, 68416, '\p{^Sc=	Avst}', "");
    Expect(1, 68416, '\P{Sc=	Avst}', "");
    Expect(0, 68416, '\P{^Sc=	Avst}', "");
    Error('\p{Is_Script=_/a/AVESTAN}');
    Error('\P{Is_Script=_/a/AVESTAN}');
    Expect(1, 68415, '\p{Is_Script=avestan}', "");
    Expect(0, 68415, '\p{^Is_Script=avestan}', "");
    Expect(0, 68415, '\P{Is_Script=avestan}', "");
    Expect(1, 68415, '\P{^Is_Script=avestan}', "");
    Expect(0, 68416, '\p{Is_Script=avestan}', "");
    Expect(1, 68416, '\p{^Is_Script=avestan}', "");
    Expect(1, 68416, '\P{Is_Script=avestan}', "");
    Expect(0, 68416, '\P{^Is_Script=avestan}', "");
    Expect(1, 68415, '\p{Is_Script=	_avestan}', "");
    Expect(0, 68415, '\p{^Is_Script=	_avestan}', "");
    Expect(0, 68415, '\P{Is_Script=	_avestan}', "");
    Expect(1, 68415, '\P{^Is_Script=	_avestan}', "");
    Expect(0, 68416, '\p{Is_Script=	_avestan}', "");
    Expect(1, 68416, '\p{^Is_Script=	_avestan}', "");
    Expect(1, 68416, '\P{Is_Script=	_avestan}', "");
    Expect(0, 68416, '\P{^Is_Script=	_avestan}', "");
    Error('\p{Is_Sc=:=	-Avst}');
    Error('\P{Is_Sc=:=	-Avst}');
    Expect(1, 68415, '\p{Is_Sc=avst}', "");
    Expect(0, 68415, '\p{^Is_Sc=avst}', "");
    Expect(0, 68415, '\P{Is_Sc=avst}', "");
    Expect(1, 68415, '\P{^Is_Sc=avst}', "");
    Expect(0, 68416, '\p{Is_Sc=avst}', "");
    Expect(1, 68416, '\p{^Is_Sc=avst}', "");
    Expect(1, 68416, '\P{Is_Sc=avst}', "");
    Expect(0, 68416, '\P{^Is_Sc=avst}', "");
    Expect(1, 68415, '\p{Is_Sc=	 Avst}', "");
    Expect(0, 68415, '\p{^Is_Sc=	 Avst}', "");
    Expect(0, 68415, '\P{Is_Sc=	 Avst}', "");
    Expect(1, 68415, '\P{^Is_Sc=	 Avst}', "");
    Expect(0, 68416, '\p{Is_Sc=	 Avst}', "");
    Expect(1, 68416, '\p{^Is_Sc=	 Avst}', "");
    Expect(1, 68416, '\P{Is_Sc=	 Avst}', "");
    Expect(0, 68416, '\P{^Is_Sc=	 Avst}', "");
    Error('\p{Script= balinese:=}');
    Error('\P{Script= balinese:=}');
    Expect(1, 7036, '\p{Script=:\ABalinese\z:}', "");;
    Expect(0, 7037, '\p{Script=:\ABalinese\z:}', "");;
    Expect(1, 7036, '\p{Script=balinese}', "");
    Expect(0, 7036, '\p{^Script=balinese}', "");
    Expect(0, 7036, '\P{Script=balinese}', "");
    Expect(1, 7036, '\P{^Script=balinese}', "");
    Expect(0, 7037, '\p{Script=balinese}', "");
    Expect(1, 7037, '\p{^Script=balinese}', "");
    Expect(1, 7037, '\P{Script=balinese}', "");
    Expect(0, 7037, '\P{^Script=balinese}', "");
    Expect(1, 7036, '\p{Script=:\Abalinese\z:}', "");;
    Expect(0, 7037, '\p{Script=:\Abalinese\z:}', "");;
    Expect(1, 7036, '\p{Script=_ Balinese}', "");
    Expect(0, 7036, '\p{^Script=_ Balinese}', "");
    Expect(0, 7036, '\P{Script=_ Balinese}', "");
    Expect(1, 7036, '\P{^Script=_ Balinese}', "");
    Expect(0, 7037, '\p{Script=_ Balinese}', "");
    Expect(1, 7037, '\p{^Script=_ Balinese}', "");
    Expect(1, 7037, '\P{Script=_ Balinese}', "");
    Expect(0, 7037, '\P{^Script=_ Balinese}', "");
    Error('\p{Sc=	-BALI:=}');
    Error('\P{Sc=	-BALI:=}');
    Expect(1, 7036, '\p{Sc=:\ABali\z:}', "");;
    Expect(0, 7037, '\p{Sc=:\ABali\z:}', "");;
    Expect(1, 7036, '\p{Sc=bali}', "");
    Expect(0, 7036, '\p{^Sc=bali}', "");
    Expect(0, 7036, '\P{Sc=bali}', "");
    Expect(1, 7036, '\P{^Sc=bali}', "");
    Expect(0, 7037, '\p{Sc=bali}', "");
    Expect(1, 7037, '\p{^Sc=bali}', "");
    Expect(1, 7037, '\P{Sc=bali}', "");
    Expect(0, 7037, '\P{^Sc=bali}', "");
    Expect(1, 7036, '\p{Sc=:\Abali\z:}', "");;
    Expect(0, 7037, '\p{Sc=:\Abali\z:}', "");;
    Expect(1, 7036, '\p{Sc=-bali}', "");
    Expect(0, 7036, '\p{^Sc=-bali}', "");
    Expect(0, 7036, '\P{Sc=-bali}', "");
    Expect(1, 7036, '\P{^Sc=-bali}', "");
    Expect(0, 7037, '\p{Sc=-bali}', "");
    Expect(1, 7037, '\p{^Sc=-bali}', "");
    Expect(1, 7037, '\P{Sc=-bali}', "");
    Expect(0, 7037, '\P{^Sc=-bali}', "");
    Error('\p{Is_Script=/a/_balinese}');
    Error('\P{Is_Script=/a/_balinese}');
    Expect(1, 7036, '\p{Is_Script:   balinese}', "");
    Expect(0, 7036, '\p{^Is_Script:   balinese}', "");
    Expect(0, 7036, '\P{Is_Script:   balinese}', "");
    Expect(1, 7036, '\P{^Is_Script:   balinese}', "");
    Expect(0, 7037, '\p{Is_Script:   balinese}', "");
    Expect(1, 7037, '\p{^Is_Script:   balinese}', "");
    Expect(1, 7037, '\P{Is_Script:   balinese}', "");
    Expect(0, 7037, '\P{^Is_Script:   balinese}', "");
    Expect(1, 7036, '\p{Is_Script=__balinese}', "");
    Expect(0, 7036, '\p{^Is_Script=__balinese}', "");
    Expect(0, 7036, '\P{Is_Script=__balinese}', "");
    Expect(1, 7036, '\P{^Is_Script=__balinese}', "");
    Expect(0, 7037, '\p{Is_Script=__balinese}', "");
    Expect(1, 7037, '\p{^Is_Script=__balinese}', "");
    Expect(1, 7037, '\P{Is_Script=__balinese}', "");
    Expect(0, 7037, '\P{^Is_Script=__balinese}', "");
    Error('\p{Is_Sc=  Bali:=}');
    Error('\P{Is_Sc=  Bali:=}');
    Expect(1, 7036, '\p{Is_Sc=bali}', "");
    Expect(0, 7036, '\p{^Is_Sc=bali}', "");
    Expect(0, 7036, '\P{Is_Sc=bali}', "");
    Expect(1, 7036, '\P{^Is_Sc=bali}', "");
    Expect(0, 7037, '\p{Is_Sc=bali}', "");
    Expect(1, 7037, '\p{^Is_Sc=bali}', "");
    Expect(1, 7037, '\P{Is_Sc=bali}', "");
    Expect(0, 7037, '\P{^Is_Sc=bali}', "");
    Expect(1, 7036, '\p{Is_Sc=_	bali}', "");
    Expect(0, 7036, '\p{^Is_Sc=_	bali}', "");
    Expect(0, 7036, '\P{Is_Sc=_	bali}', "");
    Expect(1, 7036, '\P{^Is_Sc=_	bali}', "");
    Expect(0, 7037, '\p{Is_Sc=_	bali}', "");
    Expect(1, 7037, '\p{^Is_Sc=_	bali}', "");
    Expect(1, 7037, '\P{Is_Sc=_	bali}', "");
    Expect(0, 7037, '\P{^Is_Sc=_	bali}', "");
    Error('\p{Script= :=Bamum}');
    Error('\P{Script= :=Bamum}');
    Expect(1, 92728, '\p{Script=:\ABamum\z:}', "");;
    Expect(0, 92729, '\p{Script=:\ABamum\z:}', "");;
    Expect(1, 92728, '\p{Script=bamum}', "");
    Expect(0, 92728, '\p{^Script=bamum}', "");
    Expect(0, 92728, '\P{Script=bamum}', "");
    Expect(1, 92728, '\P{^Script=bamum}', "");
    Expect(0, 92729, '\p{Script=bamum}', "");
    Expect(1, 92729, '\p{^Script=bamum}', "");
    Expect(1, 92729, '\P{Script=bamum}', "");
    Expect(0, 92729, '\P{^Script=bamum}', "");
    Expect(1, 92728, '\p{Script=:\Abamum\z:}', "");;
    Expect(0, 92729, '\p{Script=:\Abamum\z:}', "");;
    Expect(1, 92728, '\p{Script=	 BAMUM}', "");
    Expect(0, 92728, '\p{^Script=	 BAMUM}', "");
    Expect(0, 92728, '\P{Script=	 BAMUM}', "");
    Expect(1, 92728, '\P{^Script=	 BAMUM}', "");
    Expect(0, 92729, '\p{Script=	 BAMUM}', "");
    Expect(1, 92729, '\p{^Script=	 BAMUM}', "");
    Expect(1, 92729, '\P{Script=	 BAMUM}', "");
    Expect(0, 92729, '\P{^Script=	 BAMUM}', "");
    Error('\p{Sc=-/a/bamu}');
    Error('\P{Sc=-/a/bamu}');
    Expect(1, 92728, '\p{Sc=:\ABamu\z:}', "");;
    Expect(0, 92729, '\p{Sc=:\ABamu\z:}', "");;
    Expect(1, 92728, '\p{Sc=bamu}', "");
    Expect(0, 92728, '\p{^Sc=bamu}', "");
    Expect(0, 92728, '\P{Sc=bamu}', "");
    Expect(1, 92728, '\P{^Sc=bamu}', "");
    Expect(0, 92729, '\p{Sc=bamu}', "");
    Expect(1, 92729, '\p{^Sc=bamu}', "");
    Expect(1, 92729, '\P{Sc=bamu}', "");
    Expect(0, 92729, '\P{^Sc=bamu}', "");
    Expect(1, 92728, '\p{Sc=:\Abamu\z:}', "");;
    Expect(0, 92729, '\p{Sc=:\Abamu\z:}', "");;
    Expect(1, 92728, '\p{Sc=	_BAMU}', "");
    Expect(0, 92728, '\p{^Sc=	_BAMU}', "");
    Expect(0, 92728, '\P{Sc=	_BAMU}', "");
    Expect(1, 92728, '\P{^Sc=	_BAMU}', "");
    Expect(0, 92729, '\p{Sc=	_BAMU}', "");
    Expect(1, 92729, '\p{^Sc=	_BAMU}', "");
    Expect(1, 92729, '\P{Sc=	_BAMU}', "");
    Expect(0, 92729, '\P{^Sc=	_BAMU}', "");
    Error('\p{Is_Script=Bamum/a/}');
    Error('\P{Is_Script=Bamum/a/}');
    Expect(1, 92728, '\p{Is_Script=bamum}', "");
    Expect(0, 92728, '\p{^Is_Script=bamum}', "");
    Expect(0, 92728, '\P{Is_Script=bamum}', "");
    Expect(1, 92728, '\P{^Is_Script=bamum}', "");
    Expect(0, 92729, '\p{Is_Script=bamum}', "");
    Expect(1, 92729, '\p{^Is_Script=bamum}', "");
    Expect(1, 92729, '\P{Is_Script=bamum}', "");
    Expect(0, 92729, '\P{^Is_Script=bamum}', "");
    Expect(1, 92728, '\p{Is_Script=_-Bamum}', "");
    Expect(0, 92728, '\p{^Is_Script=_-Bamum}', "");
    Expect(0, 92728, '\P{Is_Script=_-Bamum}', "");
    Expect(1, 92728, '\P{^Is_Script=_-Bamum}', "");
    Expect(0, 92729, '\p{Is_Script=_-Bamum}', "");
    Expect(1, 92729, '\p{^Is_Script=_-Bamum}', "");
    Expect(1, 92729, '\P{Is_Script=_-Bamum}', "");
    Expect(0, 92729, '\P{^Is_Script=_-Bamum}', "");
    Error('\p{Is_Sc= bamu/a/}');
    Error('\P{Is_Sc= bamu/a/}');
    Expect(1, 92728, '\p{Is_Sc=bamu}', "");
    Expect(0, 92728, '\p{^Is_Sc=bamu}', "");
    Expect(0, 92728, '\P{Is_Sc=bamu}', "");
    Expect(1, 92728, '\P{^Is_Sc=bamu}', "");
    Expect(0, 92729, '\p{Is_Sc=bamu}', "");
    Expect(1, 92729, '\p{^Is_Sc=bamu}', "");
    Expect(1, 92729, '\P{Is_Sc=bamu}', "");
    Expect(0, 92729, '\P{^Is_Sc=bamu}', "");
    Expect(1, 92728, '\p{Is_Sc= _bamu}', "");
    Expect(0, 92728, '\p{^Is_Sc= _bamu}', "");
    Expect(0, 92728, '\P{Is_Sc= _bamu}', "");
    Expect(1, 92728, '\P{^Is_Sc= _bamu}', "");
    Expect(0, 92729, '\p{Is_Sc= _bamu}', "");
    Expect(1, 92729, '\p{^Is_Sc= _bamu}', "");
    Expect(1, 92729, '\P{Is_Sc= _bamu}', "");
    Expect(0, 92729, '\P{^Is_Sc= _bamu}', "");
    Error('\p{Script=/a/-	Bassa_VAH}');
    Error('\P{Script=/a/-	Bassa_VAH}');
    Expect(1, 92917, '\p{Script=:\ABassa_Vah\z:}', "");;
    Expect(0, 92918, '\p{Script=:\ABassa_Vah\z:}', "");;
    Expect(1, 92917, '\p{Script=bassavah}', "");
    Expect(0, 92917, '\p{^Script=bassavah}', "");
    Expect(0, 92917, '\P{Script=bassavah}', "");
    Expect(1, 92917, '\P{^Script=bassavah}', "");
    Expect(0, 92918, '\p{Script=bassavah}', "");
    Expect(1, 92918, '\p{^Script=bassavah}', "");
    Expect(1, 92918, '\P{Script=bassavah}', "");
    Expect(0, 92918, '\P{^Script=bassavah}', "");
    Expect(1, 92917, '\p{Script=:\Abassavah\z:}', "");;
    Expect(0, 92918, '\p{Script=:\Abassavah\z:}', "");;
    Expect(1, 92917, '\p{Script=-_bassa_Vah}', "");
    Expect(0, 92917, '\p{^Script=-_bassa_Vah}', "");
    Expect(0, 92917, '\P{Script=-_bassa_Vah}', "");
    Expect(1, 92917, '\P{^Script=-_bassa_Vah}', "");
    Expect(0, 92918, '\p{Script=-_bassa_Vah}', "");
    Expect(1, 92918, '\p{^Script=-_bassa_Vah}', "");
    Expect(1, 92918, '\P{Script=-_bassa_Vah}', "");
    Expect(0, 92918, '\P{^Script=-_bassa_Vah}', "");
    Error('\p{Sc=--Bass:=}');
    Error('\P{Sc=--Bass:=}');
    Expect(1, 92917, '\p{Sc=:\ABass\z:}', "");;
    Expect(0, 92918, '\p{Sc=:\ABass\z:}', "");;
    Expect(1, 92917, '\p{Sc=bass}', "");
    Expect(0, 92917, '\p{^Sc=bass}', "");
    Expect(0, 92917, '\P{Sc=bass}', "");
    Expect(1, 92917, '\P{^Sc=bass}', "");
    Expect(0, 92918, '\p{Sc=bass}', "");
    Expect(1, 92918, '\p{^Sc=bass}', "");
    Expect(1, 92918, '\P{Sc=bass}', "");
    Expect(0, 92918, '\P{^Sc=bass}', "");
    Expect(1, 92917, '\p{Sc=:\Abass\z:}', "");;
    Expect(0, 92918, '\p{Sc=:\Abass\z:}', "");;
    Expect(1, 92917, '\p{Sc=	 Bass}', "");
    Expect(0, 92917, '\p{^Sc=	 Bass}', "");
    Expect(0, 92917, '\P{Sc=	 Bass}', "");
    Expect(1, 92917, '\P{^Sc=	 Bass}', "");
    Expect(0, 92918, '\p{Sc=	 Bass}', "");
    Expect(1, 92918, '\p{^Sc=	 Bass}', "");
    Expect(1, 92918, '\P{Sc=	 Bass}', "");
    Expect(0, 92918, '\P{^Sc=	 Bass}', "");
    Error('\p{Is_Script=-:=BASSA_VAH}');
    Error('\P{Is_Script=-:=BASSA_VAH}');
    Expect(1, 92917, '\p{Is_Script=bassavah}', "");
    Expect(0, 92917, '\p{^Is_Script=bassavah}', "");
    Expect(0, 92917, '\P{Is_Script=bassavah}', "");
    Expect(1, 92917, '\P{^Is_Script=bassavah}', "");
    Expect(0, 92918, '\p{Is_Script=bassavah}', "");
    Expect(1, 92918, '\p{^Is_Script=bassavah}', "");
    Expect(1, 92918, '\P{Is_Script=bassavah}', "");
    Expect(0, 92918, '\P{^Is_Script=bassavah}', "");
    Expect(1, 92917, '\p{Is_Script:	__BASSA_Vah}', "");
    Expect(0, 92917, '\p{^Is_Script:	__BASSA_Vah}', "");
    Expect(0, 92917, '\P{Is_Script:	__BASSA_Vah}', "");
    Expect(1, 92917, '\P{^Is_Script:	__BASSA_Vah}', "");
    Expect(0, 92918, '\p{Is_Script:	__BASSA_Vah}', "");
    Expect(1, 92918, '\p{^Is_Script:	__BASSA_Vah}', "");
    Expect(1, 92918, '\P{Is_Script:	__BASSA_Vah}', "");
    Expect(0, 92918, '\P{^Is_Script:	__BASSA_Vah}', "");
    Error('\p{Is_Sc=/a/- BASS}');
    Error('\P{Is_Sc=/a/- BASS}');
    Expect(1, 92917, '\p{Is_Sc=bass}', "");
    Expect(0, 92917, '\p{^Is_Sc=bass}', "");
    Expect(0, 92917, '\P{Is_Sc=bass}', "");
    Expect(1, 92917, '\P{^Is_Sc=bass}', "");
    Expect(0, 92918, '\p{Is_Sc=bass}', "");
    Expect(1, 92918, '\p{^Is_Sc=bass}', "");
    Expect(1, 92918, '\P{Is_Sc=bass}', "");
    Expect(0, 92918, '\P{^Is_Sc=bass}', "");
    Expect(1, 92917, '\p{Is_Sc=	 BASS}', "");
    Expect(0, 92917, '\p{^Is_Sc=	 BASS}', "");
    Expect(0, 92917, '\P{Is_Sc=	 BASS}', "");
    Expect(1, 92917, '\P{^Is_Sc=	 BASS}', "");
    Expect(0, 92918, '\p{Is_Sc=	 BASS}', "");
    Expect(1, 92918, '\p{^Is_Sc=	 BASS}', "");
    Expect(1, 92918, '\P{Is_Sc=	 BASS}', "");
    Expect(0, 92918, '\P{^Is_Sc=	 BASS}', "");
    Error('\p{Script=-BATAK/a/}');
    Error('\P{Script=-BATAK/a/}');
    Expect(1, 7167, '\p{Script=:\ABatak\z:}', "");;
    Expect(0, 7168, '\p{Script=:\ABatak\z:}', "");;
    Expect(1, 7167, '\p{Script=batak}', "");
    Expect(0, 7167, '\p{^Script=batak}', "");
    Expect(0, 7167, '\P{Script=batak}', "");
    Expect(1, 7167, '\P{^Script=batak}', "");
    Expect(0, 7168, '\p{Script=batak}', "");
    Expect(1, 7168, '\p{^Script=batak}', "");
    Expect(1, 7168, '\P{Script=batak}', "");
    Expect(0, 7168, '\P{^Script=batak}', "");
    Expect(1, 7167, '\p{Script=:\Abatak\z:}', "");;
    Expect(0, 7168, '\p{Script=:\Abatak\z:}', "");;
    Expect(1, 7167, '\p{Script= -Batak}', "");
    Expect(0, 7167, '\p{^Script= -Batak}', "");
    Expect(0, 7167, '\P{Script= -Batak}', "");
    Expect(1, 7167, '\P{^Script= -Batak}', "");
    Expect(0, 7168, '\p{Script= -Batak}', "");
    Expect(1, 7168, '\p{^Script= -Batak}', "");
    Expect(1, 7168, '\P{Script= -Batak}', "");
    Expect(0, 7168, '\P{^Script= -Batak}', "");
    Error('\p{Sc= 	Batk/a/}');
    Error('\P{Sc= 	Batk/a/}');
    Expect(1, 7167, '\p{Sc=:\ABatk\z:}', "");;
    Expect(0, 7168, '\p{Sc=:\ABatk\z:}', "");;
    Expect(1, 7167, '\p{Sc=batk}', "");
    Expect(0, 7167, '\p{^Sc=batk}', "");
    Expect(0, 7167, '\P{Sc=batk}', "");
    Expect(1, 7167, '\P{^Sc=batk}', "");
    Expect(0, 7168, '\p{Sc=batk}', "");
    Expect(1, 7168, '\p{^Sc=batk}', "");
    Expect(1, 7168, '\P{Sc=batk}', "");
    Expect(0, 7168, '\P{^Sc=batk}', "");
    Expect(1, 7167, '\p{Sc=:\Abatk\z:}', "");;
    Expect(0, 7168, '\p{Sc=:\Abatk\z:}', "");;
    Expect(1, 7167, '\p{Sc:   	_batk}', "");
    Expect(0, 7167, '\p{^Sc:   	_batk}', "");
    Expect(0, 7167, '\P{Sc:   	_batk}', "");
    Expect(1, 7167, '\P{^Sc:   	_batk}', "");
    Expect(0, 7168, '\p{Sc:   	_batk}', "");
    Expect(1, 7168, '\p{^Sc:   	_batk}', "");
    Expect(1, 7168, '\P{Sc:   	_batk}', "");
    Expect(0, 7168, '\P{^Sc:   	_batk}', "");
    Error('\p{Is_Script=	:=BATAK}');
    Error('\P{Is_Script=	:=BATAK}');
    Expect(1, 7167, '\p{Is_Script=batak}', "");
    Expect(0, 7167, '\p{^Is_Script=batak}', "");
    Expect(0, 7167, '\P{Is_Script=batak}', "");
    Expect(1, 7167, '\P{^Is_Script=batak}', "");
    Expect(0, 7168, '\p{Is_Script=batak}', "");
    Expect(1, 7168, '\p{^Is_Script=batak}', "");
    Expect(1, 7168, '\P{Is_Script=batak}', "");
    Expect(0, 7168, '\P{^Is_Script=batak}', "");
    Expect(1, 7167, '\p{Is_Script= -Batak}', "");
    Expect(0, 7167, '\p{^Is_Script= -Batak}', "");
    Expect(0, 7167, '\P{Is_Script= -Batak}', "");
    Expect(1, 7167, '\P{^Is_Script= -Batak}', "");
    Expect(0, 7168, '\p{Is_Script= -Batak}', "");
    Expect(1, 7168, '\p{^Is_Script= -Batak}', "");
    Expect(1, 7168, '\P{Is_Script= -Batak}', "");
    Expect(0, 7168, '\P{^Is_Script= -Batak}', "");
    Error('\p{Is_Sc:	/a/Batk}');
    Error('\P{Is_Sc:	/a/Batk}');
    Expect(1, 7167, '\p{Is_Sc=batk}', "");
    Expect(0, 7167, '\p{^Is_Sc=batk}', "");
    Expect(0, 7167, '\P{Is_Sc=batk}', "");
    Expect(1, 7167, '\P{^Is_Sc=batk}', "");
    Expect(0, 7168, '\p{Is_Sc=batk}', "");
    Expect(1, 7168, '\p{^Is_Sc=batk}', "");
    Expect(1, 7168, '\P{Is_Sc=batk}', "");
    Expect(0, 7168, '\P{^Is_Sc=batk}', "");
    Expect(1, 7167, '\p{Is_Sc=__Batk}', "");
    Expect(0, 7167, '\p{^Is_Sc=__Batk}', "");
    Expect(0, 7167, '\P{Is_Sc=__Batk}', "");
    Expect(1, 7167, '\P{^Is_Sc=__Batk}', "");
    Expect(0, 7168, '\p{Is_Sc=__Batk}', "");
    Expect(1, 7168, '\p{^Is_Sc=__Batk}', "");
    Expect(1, 7168, '\P{Is_Sc=__Batk}', "");
    Expect(0, 7168, '\P{^Is_Sc=__Batk}', "");
    Error('\p{Script:_	Bengali/a/}');
    Error('\P{Script:_	Bengali/a/}');
    Expect(1, 2558, '\p{Script=:\ABengali\z:}', "");;
    Expect(0, 2559, '\p{Script=:\ABengali\z:}', "");;
    Expect(1, 2558, '\p{Script=bengali}', "");
    Expect(0, 2558, '\p{^Script=bengali}', "");
    Expect(0, 2558, '\P{Script=bengali}', "");
    Expect(1, 2558, '\P{^Script=bengali}', "");
    Expect(0, 2559, '\p{Script=bengali}', "");
    Expect(1, 2559, '\p{^Script=bengali}', "");
    Expect(1, 2559, '\P{Script=bengali}', "");
    Expect(0, 2559, '\P{^Script=bengali}', "");
    Expect(1, 2558, '\p{Script=:\Abengali\z:}', "");;
    Expect(0, 2559, '\p{Script=:\Abengali\z:}', "");;
    Expect(1, 2558, '\p{Script= _Bengali}', "");
    Expect(0, 2558, '\p{^Script= _Bengali}', "");
    Expect(0, 2558, '\P{Script= _Bengali}', "");
    Expect(1, 2558, '\P{^Script= _Bengali}', "");
    Expect(0, 2559, '\p{Script= _Bengali}', "");
    Expect(1, 2559, '\p{^Script= _Bengali}', "");
    Expect(1, 2559, '\P{Script= _Bengali}', "");
    Expect(0, 2559, '\P{^Script= _Bengali}', "");
    Error('\p{Sc=  Beng:=}');
    Error('\P{Sc=  Beng:=}');
    Expect(1, 2558, '\p{Sc=:\ABeng\z:}', "");;
    Expect(0, 2559, '\p{Sc=:\ABeng\z:}', "");;
    Expect(1, 2558, '\p{Sc=beng}', "");
    Expect(0, 2558, '\p{^Sc=beng}', "");
    Expect(0, 2558, '\P{Sc=beng}', "");
    Expect(1, 2558, '\P{^Sc=beng}', "");
    Expect(0, 2559, '\p{Sc=beng}', "");
    Expect(1, 2559, '\p{^Sc=beng}', "");
    Expect(1, 2559, '\P{Sc=beng}', "");
    Expect(0, 2559, '\P{^Sc=beng}', "");
    Expect(1, 2558, '\p{Sc=:\Abeng\z:}', "");;
    Expect(0, 2559, '\p{Sc=:\Abeng\z:}', "");;
    Expect(1, 2558, '\p{Sc=_Beng}', "");
    Expect(0, 2558, '\p{^Sc=_Beng}', "");
    Expect(0, 2558, '\P{Sc=_Beng}', "");
    Expect(1, 2558, '\P{^Sc=_Beng}', "");
    Expect(0, 2559, '\p{Sc=_Beng}', "");
    Expect(1, 2559, '\p{^Sc=_Beng}', "");
    Expect(1, 2559, '\P{Sc=_Beng}', "");
    Expect(0, 2559, '\P{^Sc=_Beng}', "");
    Error('\p{Is_Script=-BENGALI/a/}');
    Error('\P{Is_Script=-BENGALI/a/}');
    Expect(1, 2558, '\p{Is_Script=bengali}', "");
    Expect(0, 2558, '\p{^Is_Script=bengali}', "");
    Expect(0, 2558, '\P{Is_Script=bengali}', "");
    Expect(1, 2558, '\P{^Is_Script=bengali}', "");
    Expect(0, 2559, '\p{Is_Script=bengali}', "");
    Expect(1, 2559, '\p{^Is_Script=bengali}', "");
    Expect(1, 2559, '\P{Is_Script=bengali}', "");
    Expect(0, 2559, '\P{^Is_Script=bengali}', "");
    Expect(1, 2558, '\p{Is_Script=-Bengali}', "");
    Expect(0, 2558, '\p{^Is_Script=-Bengali}', "");
    Expect(0, 2558, '\P{Is_Script=-Bengali}', "");
    Expect(1, 2558, '\P{^Is_Script=-Bengali}', "");
    Expect(0, 2559, '\p{Is_Script=-Bengali}', "");
    Expect(1, 2559, '\p{^Is_Script=-Bengali}', "");
    Expect(1, 2559, '\P{Is_Script=-Bengali}', "");
    Expect(0, 2559, '\P{^Is_Script=-Bengali}', "");
    Error('\p{Is_Sc=:= Beng}');
    Error('\P{Is_Sc=:= Beng}');
    Expect(1, 2558, '\p{Is_Sc=beng}', "");
    Expect(0, 2558, '\p{^Is_Sc=beng}', "");
    Expect(0, 2558, '\P{Is_Sc=beng}', "");
    Expect(1, 2558, '\P{^Is_Sc=beng}', "");
    Expect(0, 2559, '\p{Is_Sc=beng}', "");
    Expect(1, 2559, '\p{^Is_Sc=beng}', "");
    Expect(1, 2559, '\P{Is_Sc=beng}', "");
    Expect(0, 2559, '\P{^Is_Sc=beng}', "");
    Expect(1, 2558, '\p{Is_Sc=	beng}', "");
    Expect(0, 2558, '\p{^Is_Sc=	beng}', "");
    Expect(0, 2558, '\P{Is_Sc=	beng}', "");
    Expect(1, 2558, '\P{^Is_Sc=	beng}', "");
    Expect(0, 2559, '\p{Is_Sc=	beng}', "");
    Expect(1, 2559, '\p{^Is_Sc=	beng}', "");
    Expect(1, 2559, '\P{Is_Sc=	beng}', "");
    Expect(0, 2559, '\P{^Is_Sc=	beng}', "");
    Error('\p{Script:_/a/Bhaiksuki}');
    Error('\P{Script:_/a/Bhaiksuki}');
    Expect(1, 72812, '\p{Script=:\ABhaiksuki\z:}', "");;
    Expect(0, 72813, '\p{Script=:\ABhaiksuki\z:}', "");;
    Expect(1, 72812, '\p{Script=bhaiksuki}', "");
    Expect(0, 72812, '\p{^Script=bhaiksuki}', "");
    Expect(0, 72812, '\P{Script=bhaiksuki}', "");
    Expect(1, 72812, '\P{^Script=bhaiksuki}', "");
    Expect(0, 72813, '\p{Script=bhaiksuki}', "");
    Expect(1, 72813, '\p{^Script=bhaiksuki}', "");
    Expect(1, 72813, '\P{Script=bhaiksuki}', "");
    Expect(0, 72813, '\P{^Script=bhaiksuki}', "");
    Expect(1, 72812, '\p{Script=:\Abhaiksuki\z:}', "");;
    Expect(0, 72813, '\p{Script=:\Abhaiksuki\z:}', "");;
    Expect(1, 72812, '\p{Script=-Bhaiksuki}', "");
    Expect(0, 72812, '\p{^Script=-Bhaiksuki}', "");
    Expect(0, 72812, '\P{Script=-Bhaiksuki}', "");
    Expect(1, 72812, '\P{^Script=-Bhaiksuki}', "");
    Expect(0, 72813, '\p{Script=-Bhaiksuki}', "");
    Expect(1, 72813, '\p{^Script=-Bhaiksuki}', "");
    Expect(1, 72813, '\P{Script=-Bhaiksuki}', "");
    Expect(0, 72813, '\P{^Script=-Bhaiksuki}', "");
    Error('\p{Sc=BHKS:=}');
    Error('\P{Sc=BHKS:=}');
    Expect(1, 72812, '\p{Sc=:\ABhks\z:}', "");;
    Expect(0, 72813, '\p{Sc=:\ABhks\z:}', "");;
    Expect(1, 72812, '\p{Sc=bhks}', "");
    Expect(0, 72812, '\p{^Sc=bhks}', "");
    Expect(0, 72812, '\P{Sc=bhks}', "");
    Expect(1, 72812, '\P{^Sc=bhks}', "");
    Expect(0, 72813, '\p{Sc=bhks}', "");
    Expect(1, 72813, '\p{^Sc=bhks}', "");
    Expect(1, 72813, '\P{Sc=bhks}', "");
    Expect(0, 72813, '\P{^Sc=bhks}', "");
    Expect(1, 72812, '\p{Sc=:\Abhks\z:}', "");;
    Expect(0, 72813, '\p{Sc=:\Abhks\z:}', "");;
    Expect(1, 72812, '\p{Sc=- BHKS}', "");
    Expect(0, 72812, '\p{^Sc=- BHKS}', "");
    Expect(0, 72812, '\P{Sc=- BHKS}', "");
    Expect(1, 72812, '\P{^Sc=- BHKS}', "");
    Expect(0, 72813, '\p{Sc=- BHKS}', "");
    Expect(1, 72813, '\p{^Sc=- BHKS}', "");
    Expect(1, 72813, '\P{Sc=- BHKS}', "");
    Expect(0, 72813, '\P{^Sc=- BHKS}', "");
    Error('\p{Is_Script= :=Bhaiksuki}');
    Error('\P{Is_Script= :=Bhaiksuki}');
    Expect(1, 72812, '\p{Is_Script=bhaiksuki}', "");
    Expect(0, 72812, '\p{^Is_Script=bhaiksuki}', "");
    Expect(0, 72812, '\P{Is_Script=bhaiksuki}', "");
    Expect(1, 72812, '\P{^Is_Script=bhaiksuki}', "");
    Expect(0, 72813, '\p{Is_Script=bhaiksuki}', "");
    Expect(1, 72813, '\p{^Is_Script=bhaiksuki}', "");
    Expect(1, 72813, '\P{Is_Script=bhaiksuki}', "");
    Expect(0, 72813, '\P{^Is_Script=bhaiksuki}', "");
    Expect(1, 72812, '\p{Is_Script= -bhaiksuki}', "");
    Expect(0, 72812, '\p{^Is_Script= -bhaiksuki}', "");
    Expect(0, 72812, '\P{Is_Script= -bhaiksuki}', "");
    Expect(1, 72812, '\P{^Is_Script= -bhaiksuki}', "");
    Expect(0, 72813, '\p{Is_Script= -bhaiksuki}', "");
    Expect(1, 72813, '\p{^Is_Script= -bhaiksuki}', "");
    Expect(1, 72813, '\P{Is_Script= -bhaiksuki}', "");
    Expect(0, 72813, '\P{^Is_Script= -bhaiksuki}', "");
    Error('\p{Is_Sc=--Bhks/a/}');
    Error('\P{Is_Sc=--Bhks/a/}');
    Expect(1, 72812, '\p{Is_Sc=bhks}', "");
    Expect(0, 72812, '\p{^Is_Sc=bhks}', "");
    Expect(0, 72812, '\P{Is_Sc=bhks}', "");
    Expect(1, 72812, '\P{^Is_Sc=bhks}', "");
    Expect(0, 72813, '\p{Is_Sc=bhks}', "");
    Expect(1, 72813, '\p{^Is_Sc=bhks}', "");
    Expect(1, 72813, '\P{Is_Sc=bhks}', "");
    Expect(0, 72813, '\P{^Is_Sc=bhks}', "");
    Expect(1, 72812, '\p{Is_Sc=_	bhks}', "");
    Expect(0, 72812, '\p{^Is_Sc=_	bhks}', "");
    Expect(0, 72812, '\P{Is_Sc=_	bhks}', "");
    Expect(1, 72812, '\P{^Is_Sc=_	bhks}', "");
    Expect(0, 72813, '\p{Is_Sc=_	bhks}', "");
    Expect(1, 72813, '\p{^Is_Sc=_	bhks}', "");
    Expect(1, 72813, '\P{Is_Sc=_	bhks}', "");
    Expect(0, 72813, '\P{^Is_Sc=_	bhks}', "");
    Error('\p{Script= :=bopomofo}');
    Error('\P{Script= :=bopomofo}');
    Expect(1, 12735, '\p{Script=:\ABopomofo\z:}', "");;
    Expect(0, 12736, '\p{Script=:\ABopomofo\z:}', "");;
    Expect(1, 12735, '\p{Script=bopomofo}', "");
    Expect(0, 12735, '\p{^Script=bopomofo}', "");
    Expect(0, 12735, '\P{Script=bopomofo}', "");
    Expect(1, 12735, '\P{^Script=bopomofo}', "");
    Expect(0, 12736, '\p{Script=bopomofo}', "");
    Expect(1, 12736, '\p{^Script=bopomofo}', "");
    Expect(1, 12736, '\P{Script=bopomofo}', "");
    Expect(0, 12736, '\P{^Script=bopomofo}', "");
    Expect(1, 12735, '\p{Script=:\Abopomofo\z:}', "");;
    Expect(0, 12736, '\p{Script=:\Abopomofo\z:}', "");;
    Expect(1, 12735, '\p{Script=__BOPOMOFO}', "");
    Expect(0, 12735, '\p{^Script=__BOPOMOFO}', "");
    Expect(0, 12735, '\P{Script=__BOPOMOFO}', "");
    Expect(1, 12735, '\P{^Script=__BOPOMOFO}', "");
    Expect(0, 12736, '\p{Script=__BOPOMOFO}', "");
    Expect(1, 12736, '\p{^Script=__BOPOMOFO}', "");
    Expect(1, 12736, '\P{Script=__BOPOMOFO}', "");
    Expect(0, 12736, '\P{^Script=__BOPOMOFO}', "");
    Error('\p{Sc=_/a/BOPO}');
    Error('\P{Sc=_/a/BOPO}');
    Expect(1, 12735, '\p{Sc=:\ABopo\z:}', "");;
    Expect(0, 12736, '\p{Sc=:\ABopo\z:}', "");;
    Expect(1, 12735, '\p{Sc:	bopo}', "");
    Expect(0, 12735, '\p{^Sc:	bopo}', "");
    Expect(0, 12735, '\P{Sc:	bopo}', "");
    Expect(1, 12735, '\P{^Sc:	bopo}', "");
    Expect(0, 12736, '\p{Sc:	bopo}', "");
    Expect(1, 12736, '\p{^Sc:	bopo}', "");
    Expect(1, 12736, '\P{Sc:	bopo}', "");
    Expect(0, 12736, '\P{^Sc:	bopo}', "");
    Expect(1, 12735, '\p{Sc=:\Abopo\z:}', "");;
    Expect(0, 12736, '\p{Sc=:\Abopo\z:}', "");;
    Expect(1, 12735, '\p{Sc: -_Bopo}', "");
    Expect(0, 12735, '\p{^Sc: -_Bopo}', "");
    Expect(0, 12735, '\P{Sc: -_Bopo}', "");
    Expect(1, 12735, '\P{^Sc: -_Bopo}', "");
    Expect(0, 12736, '\p{Sc: -_Bopo}', "");
    Expect(1, 12736, '\p{^Sc: -_Bopo}', "");
    Expect(1, 12736, '\P{Sc: -_Bopo}', "");
    Expect(0, 12736, '\P{^Sc: -_Bopo}', "");
    Error('\p{Is_Script=/a/ Bopomofo}');
    Error('\P{Is_Script=/a/ Bopomofo}');
    Expect(1, 12735, '\p{Is_Script=bopomofo}', "");
    Expect(0, 12735, '\p{^Is_Script=bopomofo}', "");
    Expect(0, 12735, '\P{Is_Script=bopomofo}', "");
    Expect(1, 12735, '\P{^Is_Script=bopomofo}', "");
    Expect(0, 12736, '\p{Is_Script=bopomofo}', "");
    Expect(1, 12736, '\p{^Is_Script=bopomofo}', "");
    Expect(1, 12736, '\P{Is_Script=bopomofo}', "");
    Expect(0, 12736, '\P{^Is_Script=bopomofo}', "");
    Expect(1, 12735, '\p{Is_Script=-bopomofo}', "");
    Expect(0, 12735, '\p{^Is_Script=-bopomofo}', "");
    Expect(0, 12735, '\P{Is_Script=-bopomofo}', "");
    Expect(1, 12735, '\P{^Is_Script=-bopomofo}', "");
    Expect(0, 12736, '\p{Is_Script=-bopomofo}', "");
    Expect(1, 12736, '\p{^Is_Script=-bopomofo}', "");
    Expect(1, 12736, '\P{Is_Script=-bopomofo}', "");
    Expect(0, 12736, '\P{^Is_Script=-bopomofo}', "");
    Error('\p{Is_Sc=:= bopo}');
    Error('\P{Is_Sc=:= bopo}');
    Expect(1, 12735, '\p{Is_Sc=bopo}', "");
    Expect(0, 12735, '\p{^Is_Sc=bopo}', "");
    Expect(0, 12735, '\P{Is_Sc=bopo}', "");
    Expect(1, 12735, '\P{^Is_Sc=bopo}', "");
    Expect(0, 12736, '\p{Is_Sc=bopo}', "");
    Expect(1, 12736, '\p{^Is_Sc=bopo}', "");
    Expect(1, 12736, '\P{Is_Sc=bopo}', "");
    Expect(0, 12736, '\P{^Is_Sc=bopo}', "");
    Expect(1, 12735, '\p{Is_Sc:	 	bopo}', "");
    Expect(0, 12735, '\p{^Is_Sc:	 	bopo}', "");
    Expect(0, 12735, '\P{Is_Sc:	 	bopo}', "");
    Expect(1, 12735, '\P{^Is_Sc:	 	bopo}', "");
    Expect(0, 12736, '\p{Is_Sc:	 	bopo}', "");
    Expect(1, 12736, '\p{^Is_Sc:	 	bopo}', "");
    Expect(1, 12736, '\P{Is_Sc:	 	bopo}', "");
    Expect(0, 12736, '\P{^Is_Sc:	 	bopo}', "");
    Error('\p{Script= BRAHMI:=}');
    Error('\P{Script= BRAHMI:=}');
    Expect(1, 69759, '\p{Script=:\ABrahmi\z:}', "");;
    Expect(0, 69760, '\p{Script=:\ABrahmi\z:}', "");;
    Expect(1, 69759, '\p{Script=brahmi}', "");
    Expect(0, 69759, '\p{^Script=brahmi}', "");
    Expect(0, 69759, '\P{Script=brahmi}', "");
    Expect(1, 69759, '\P{^Script=brahmi}', "");
    Expect(0, 69760, '\p{Script=brahmi}', "");
    Expect(1, 69760, '\p{^Script=brahmi}', "");
    Expect(1, 69760, '\P{Script=brahmi}', "");
    Expect(0, 69760, '\P{^Script=brahmi}', "");
    Expect(1, 69759, '\p{Script=:\Abrahmi\z:}', "");;
    Expect(0, 69760, '\p{Script=:\Abrahmi\z:}', "");;
    Expect(1, 69759, '\p{Script=-	BRAHMI}', "");
    Expect(0, 69759, '\p{^Script=-	BRAHMI}', "");
    Expect(0, 69759, '\P{Script=-	BRAHMI}', "");
    Expect(1, 69759, '\P{^Script=-	BRAHMI}', "");
    Expect(0, 69760, '\p{Script=-	BRAHMI}', "");
    Expect(1, 69760, '\p{^Script=-	BRAHMI}', "");
    Expect(1, 69760, '\P{Script=-	BRAHMI}', "");
    Expect(0, 69760, '\P{^Script=-	BRAHMI}', "");
    Error('\p{Sc=	 brah:=}');
    Error('\P{Sc=	 brah:=}');
    Expect(1, 69759, '\p{Sc=:\ABrah\z:}', "");;
    Expect(0, 69760, '\p{Sc=:\ABrah\z:}', "");;
    Expect(1, 69759, '\p{Sc: brah}', "");
    Expect(0, 69759, '\p{^Sc: brah}', "");
    Expect(0, 69759, '\P{Sc: brah}', "");
    Expect(1, 69759, '\P{^Sc: brah}', "");
    Expect(0, 69760, '\p{Sc: brah}', "");
    Expect(1, 69760, '\p{^Sc: brah}', "");
    Expect(1, 69760, '\P{Sc: brah}', "");
    Expect(0, 69760, '\P{^Sc: brah}', "");
    Expect(1, 69759, '\p{Sc=:\Abrah\z:}', "");;
    Expect(0, 69760, '\p{Sc=:\Abrah\z:}', "");;
    Expect(1, 69759, '\p{Sc=_ brah}', "");
    Expect(0, 69759, '\p{^Sc=_ brah}', "");
    Expect(0, 69759, '\P{Sc=_ brah}', "");
    Expect(1, 69759, '\P{^Sc=_ brah}', "");
    Expect(0, 69760, '\p{Sc=_ brah}', "");
    Expect(1, 69760, '\p{^Sc=_ brah}', "");
    Expect(1, 69760, '\P{Sc=_ brah}', "");
    Expect(0, 69760, '\P{^Sc=_ brah}', "");
    Error('\p{Is_Script=:=_Brahmi}');
    Error('\P{Is_Script=:=_Brahmi}');
    Expect(1, 69759, '\p{Is_Script=brahmi}', "");
    Expect(0, 69759, '\p{^Is_Script=brahmi}', "");
    Expect(0, 69759, '\P{Is_Script=brahmi}', "");
    Expect(1, 69759, '\P{^Is_Script=brahmi}', "");
    Expect(0, 69760, '\p{Is_Script=brahmi}', "");
    Expect(1, 69760, '\p{^Is_Script=brahmi}', "");
    Expect(1, 69760, '\P{Is_Script=brahmi}', "");
    Expect(0, 69760, '\P{^Is_Script=brahmi}', "");
    Expect(1, 69759, '\p{Is_Script=_ BRAHMI}', "");
    Expect(0, 69759, '\p{^Is_Script=_ BRAHMI}', "");
    Expect(0, 69759, '\P{Is_Script=_ BRAHMI}', "");
    Expect(1, 69759, '\P{^Is_Script=_ BRAHMI}', "");
    Expect(0, 69760, '\p{Is_Script=_ BRAHMI}', "");
    Expect(1, 69760, '\p{^Is_Script=_ BRAHMI}', "");
    Expect(1, 69760, '\P{Is_Script=_ BRAHMI}', "");
    Expect(0, 69760, '\P{^Is_Script=_ BRAHMI}', "");
    Error('\p{Is_Sc=	:=Brah}');
    Error('\P{Is_Sc=	:=Brah}');
    Expect(1, 69759, '\p{Is_Sc=brah}', "");
    Expect(0, 69759, '\p{^Is_Sc=brah}', "");
    Expect(0, 69759, '\P{Is_Sc=brah}', "");
    Expect(1, 69759, '\P{^Is_Sc=brah}', "");
    Expect(0, 69760, '\p{Is_Sc=brah}', "");
    Expect(1, 69760, '\p{^Is_Sc=brah}', "");
    Expect(1, 69760, '\P{Is_Sc=brah}', "");
    Expect(0, 69760, '\P{^Is_Sc=brah}', "");
    Expect(1, 69759, '\p{Is_Sc=		Brah}', "");
    Expect(0, 69759, '\p{^Is_Sc=		Brah}', "");
    Expect(0, 69759, '\P{Is_Sc=		Brah}', "");
    Expect(1, 69759, '\P{^Is_Sc=		Brah}', "");
    Expect(0, 69760, '\p{Is_Sc=		Brah}', "");
    Expect(1, 69760, '\p{^Is_Sc=		Brah}', "");
    Expect(1, 69760, '\P{Is_Sc=		Brah}', "");
    Expect(0, 69760, '\P{^Is_Sc=		Brah}', "");
    Error('\p{Script=:=- Braille}');
    Error('\P{Script=:=- Braille}');
    Expect(1, 10495, '\p{Script=:\ABraille\z:}', "");;
    Expect(0, 10496, '\p{Script=:\ABraille\z:}', "");;
    Expect(1, 10495, '\p{Script=braille}', "");
    Expect(0, 10495, '\p{^Script=braille}', "");
    Expect(0, 10495, '\P{Script=braille}', "");
    Expect(1, 10495, '\P{^Script=braille}', "");
    Expect(0, 10496, '\p{Script=braille}', "");
    Expect(1, 10496, '\p{^Script=braille}', "");
    Expect(1, 10496, '\P{Script=braille}', "");
    Expect(0, 10496, '\P{^Script=braille}', "");
    Expect(1, 10495, '\p{Script=:\Abraille\z:}', "");;
    Expect(0, 10496, '\p{Script=:\Abraille\z:}', "");;
    Expect(1, 10495, '\p{Script=-Braille}', "");
    Expect(0, 10495, '\p{^Script=-Braille}', "");
    Expect(0, 10495, '\P{Script=-Braille}', "");
    Expect(1, 10495, '\P{^Script=-Braille}', "");
    Expect(0, 10496, '\p{Script=-Braille}', "");
    Expect(1, 10496, '\p{^Script=-Braille}', "");
    Expect(1, 10496, '\P{Script=-Braille}', "");
    Expect(0, 10496, '\P{^Script=-Braille}', "");
    Error('\p{Sc= 	brai:=}');
    Error('\P{Sc= 	brai:=}');
    Expect(1, 10495, '\p{Sc=:\ABrai\z:}', "");;
    Expect(0, 10496, '\p{Sc=:\ABrai\z:}', "");;
    Expect(1, 10495, '\p{Sc=brai}', "");
    Expect(0, 10495, '\p{^Sc=brai}', "");
    Expect(0, 10495, '\P{Sc=brai}', "");
    Expect(1, 10495, '\P{^Sc=brai}', "");
    Expect(0, 10496, '\p{Sc=brai}', "");
    Expect(1, 10496, '\p{^Sc=brai}', "");
    Expect(1, 10496, '\P{Sc=brai}', "");
    Expect(0, 10496, '\P{^Sc=brai}', "");
    Expect(1, 10495, '\p{Sc=:\Abrai\z:}', "");;
    Expect(0, 10496, '\p{Sc=:\Abrai\z:}', "");;
    Expect(1, 10495, '\p{Sc=__brai}', "");
    Expect(0, 10495, '\p{^Sc=__brai}', "");
    Expect(0, 10495, '\P{Sc=__brai}', "");
    Expect(1, 10495, '\P{^Sc=__brai}', "");
    Expect(0, 10496, '\p{Sc=__brai}', "");
    Expect(1, 10496, '\p{^Sc=__brai}', "");
    Expect(1, 10496, '\P{Sc=__brai}', "");
    Expect(0, 10496, '\P{^Sc=__brai}', "");
    Error('\p{Is_Script= 	Braille/a/}');
    Error('\P{Is_Script= 	Braille/a/}');
    Expect(1, 10495, '\p{Is_Script: braille}', "");
    Expect(0, 10495, '\p{^Is_Script: braille}', "");
    Expect(0, 10495, '\P{Is_Script: braille}', "");
    Expect(1, 10495, '\P{^Is_Script: braille}', "");
    Expect(0, 10496, '\p{Is_Script: braille}', "");
    Expect(1, 10496, '\p{^Is_Script: braille}', "");
    Expect(1, 10496, '\P{Is_Script: braille}', "");
    Expect(0, 10496, '\P{^Is_Script: braille}', "");
    Expect(1, 10495, '\p{Is_Script=_-braille}', "");
    Expect(0, 10495, '\p{^Is_Script=_-braille}', "");
    Expect(0, 10495, '\P{Is_Script=_-braille}', "");
    Expect(1, 10495, '\P{^Is_Script=_-braille}', "");
    Expect(0, 10496, '\p{Is_Script=_-braille}', "");
    Expect(1, 10496, '\p{^Is_Script=_-braille}', "");
    Expect(1, 10496, '\P{Is_Script=_-braille}', "");
    Expect(0, 10496, '\P{^Is_Script=_-braille}', "");
    Error('\p{Is_Sc:	 _Brai/a/}');
    Error('\P{Is_Sc:	 _Brai/a/}');
    Expect(1, 10495, '\p{Is_Sc=brai}', "");
    Expect(0, 10495, '\p{^Is_Sc=brai}', "");
    Expect(0, 10495, '\P{Is_Sc=brai}', "");
    Expect(1, 10495, '\P{^Is_Sc=brai}', "");
    Expect(0, 10496, '\p{Is_Sc=brai}', "");
    Expect(1, 10496, '\p{^Is_Sc=brai}', "");
    Expect(1, 10496, '\P{Is_Sc=brai}', "");
    Expect(0, 10496, '\P{^Is_Sc=brai}', "");
    Expect(1, 10495, '\p{Is_Sc=-_Brai}', "");
    Expect(0, 10495, '\p{^Is_Sc=-_Brai}', "");
    Expect(0, 10495, '\P{Is_Sc=-_Brai}', "");
    Expect(1, 10495, '\P{^Is_Sc=-_Brai}', "");
    Expect(0, 10496, '\p{Is_Sc=-_Brai}', "");
    Expect(1, 10496, '\p{^Is_Sc=-_Brai}', "");
    Expect(1, 10496, '\P{Is_Sc=-_Brai}', "");
    Expect(0, 10496, '\P{^Is_Sc=-_Brai}', "");
    Error('\p{Script=-/a/Buginese}');
    Error('\P{Script=-/a/Buginese}');
    Expect(1, 6687, '\p{Script=:\ABuginese\z:}', "");;
    Expect(0, 6688, '\p{Script=:\ABuginese\z:}', "");;
    Expect(1, 6687, '\p{Script=buginese}', "");
    Expect(0, 6687, '\p{^Script=buginese}', "");
    Expect(0, 6687, '\P{Script=buginese}', "");
    Expect(1, 6687, '\P{^Script=buginese}', "");
    Expect(0, 6688, '\p{Script=buginese}', "");
    Expect(1, 6688, '\p{^Script=buginese}', "");
    Expect(1, 6688, '\P{Script=buginese}', "");
    Expect(0, 6688, '\P{^Script=buginese}', "");
    Expect(1, 6687, '\p{Script=:\Abuginese\z:}', "");;
    Expect(0, 6688, '\p{Script=:\Abuginese\z:}', "");;
    Expect(1, 6687, '\p{Script:	 BUGINESE}', "");
    Expect(0, 6687, '\p{^Script:	 BUGINESE}', "");
    Expect(0, 6687, '\P{Script:	 BUGINESE}', "");
    Expect(1, 6687, '\P{^Script:	 BUGINESE}', "");
    Expect(0, 6688, '\p{Script:	 BUGINESE}', "");
    Expect(1, 6688, '\p{^Script:	 BUGINESE}', "");
    Expect(1, 6688, '\P{Script:	 BUGINESE}', "");
    Expect(0, 6688, '\P{^Script:	 BUGINESE}', "");
    Error('\p{Sc=/a/_-Bugi}');
    Error('\P{Sc=/a/_-Bugi}');
    Expect(1, 6687, '\p{Sc=:\ABugi\z:}', "");;
    Expect(0, 6688, '\p{Sc=:\ABugi\z:}', "");;
    Expect(1, 6687, '\p{Sc=bugi}', "");
    Expect(0, 6687, '\p{^Sc=bugi}', "");
    Expect(0, 6687, '\P{Sc=bugi}', "");
    Expect(1, 6687, '\P{^Sc=bugi}', "");
    Expect(0, 6688, '\p{Sc=bugi}', "");
    Expect(1, 6688, '\p{^Sc=bugi}', "");
    Expect(1, 6688, '\P{Sc=bugi}', "");
    Expect(0, 6688, '\P{^Sc=bugi}', "");
    Expect(1, 6687, '\p{Sc=:\Abugi\z:}', "");;
    Expect(0, 6688, '\p{Sc=:\Abugi\z:}', "");;
    Expect(1, 6687, '\p{Sc:	 -Bugi}', "");
    Expect(0, 6687, '\p{^Sc:	 -Bugi}', "");
    Expect(0, 6687, '\P{Sc:	 -Bugi}', "");
    Expect(1, 6687, '\P{^Sc:	 -Bugi}', "");
    Expect(0, 6688, '\p{Sc:	 -Bugi}', "");
    Expect(1, 6688, '\p{^Sc:	 -Bugi}', "");
    Expect(1, 6688, '\P{Sc:	 -Bugi}', "");
    Expect(0, 6688, '\P{^Sc:	 -Bugi}', "");
    Error('\p{Is_Script=	-BUGINESE/a/}');
    Error('\P{Is_Script=	-BUGINESE/a/}');
    Expect(1, 6687, '\p{Is_Script=buginese}', "");
    Expect(0, 6687, '\p{^Is_Script=buginese}', "");
    Expect(0, 6687, '\P{Is_Script=buginese}', "");
    Expect(1, 6687, '\P{^Is_Script=buginese}', "");
    Expect(0, 6688, '\p{Is_Script=buginese}', "");
    Expect(1, 6688, '\p{^Is_Script=buginese}', "");
    Expect(1, 6688, '\P{Is_Script=buginese}', "");
    Expect(0, 6688, '\P{^Is_Script=buginese}', "");
    Expect(1, 6687, '\p{Is_Script=_ Buginese}', "");
    Expect(0, 6687, '\p{^Is_Script=_ Buginese}', "");
    Expect(0, 6687, '\P{Is_Script=_ Buginese}', "");
    Expect(1, 6687, '\P{^Is_Script=_ Buginese}', "");
    Expect(0, 6688, '\p{Is_Script=_ Buginese}', "");
    Expect(1, 6688, '\p{^Is_Script=_ Buginese}', "");
    Expect(1, 6688, '\P{Is_Script=_ Buginese}', "");
    Expect(0, 6688, '\P{^Is_Script=_ Buginese}', "");
    Error('\p{Is_Sc= :=BUGI}');
    Error('\P{Is_Sc= :=BUGI}');
    Expect(1, 6687, '\p{Is_Sc=bugi}', "");
    Expect(0, 6687, '\p{^Is_Sc=bugi}', "");
    Expect(0, 6687, '\P{Is_Sc=bugi}', "");
    Expect(1, 6687, '\P{^Is_Sc=bugi}', "");
    Expect(0, 6688, '\p{Is_Sc=bugi}', "");
    Expect(1, 6688, '\p{^Is_Sc=bugi}', "");
    Expect(1, 6688, '\P{Is_Sc=bugi}', "");
    Expect(0, 6688, '\P{^Is_Sc=bugi}', "");
    Expect(1, 6687, '\p{Is_Sc=_bugi}', "");
    Expect(0, 6687, '\p{^Is_Sc=_bugi}', "");
    Expect(0, 6687, '\P{Is_Sc=_bugi}', "");
    Expect(1, 6687, '\P{^Is_Sc=_bugi}', "");
    Expect(0, 6688, '\p{Is_Sc=_bugi}', "");
    Expect(1, 6688, '\p{^Is_Sc=_bugi}', "");
    Expect(1, 6688, '\P{Is_Sc=_bugi}', "");
    Expect(0, 6688, '\P{^Is_Sc=_bugi}', "");
    Error('\p{Script:   	:=buhid}');
    Error('\P{Script:   	:=buhid}');
    Expect(1, 5971, '\p{Script=:\ABuhid\z:}', "");;
    Expect(0, 5972, '\p{Script=:\ABuhid\z:}', "");;
    Expect(1, 5971, '\p{Script: buhid}', "");
    Expect(0, 5971, '\p{^Script: buhid}', "");
    Expect(0, 5971, '\P{Script: buhid}', "");
    Expect(1, 5971, '\P{^Script: buhid}', "");
    Expect(0, 5972, '\p{Script: buhid}', "");
    Expect(1, 5972, '\p{^Script: buhid}', "");
    Expect(1, 5972, '\P{Script: buhid}', "");
    Expect(0, 5972, '\P{^Script: buhid}', "");
    Expect(1, 5971, '\p{Script=:\Abuhid\z:}', "");;
    Expect(0, 5972, '\p{Script=:\Abuhid\z:}', "");;
    Expect(1, 5971, '\p{Script= 	BUHID}', "");
    Expect(0, 5971, '\p{^Script= 	BUHID}', "");
    Expect(0, 5971, '\P{Script= 	BUHID}', "");
    Expect(1, 5971, '\P{^Script= 	BUHID}', "");
    Expect(0, 5972, '\p{Script= 	BUHID}', "");
    Expect(1, 5972, '\p{^Script= 	BUHID}', "");
    Expect(1, 5972, '\P{Script= 	BUHID}', "");
    Expect(0, 5972, '\P{^Script= 	BUHID}', "");
    Error('\p{Sc= Buhd/a/}');
    Error('\P{Sc= Buhd/a/}');
    Expect(1, 5971, '\p{Sc=:\ABuhd\z:}', "");;
    Expect(0, 5972, '\p{Sc=:\ABuhd\z:}', "");;
    Expect(1, 5971, '\p{Sc=buhd}', "");
    Expect(0, 5971, '\p{^Sc=buhd}', "");
    Expect(0, 5971, '\P{Sc=buhd}', "");
    Expect(1, 5971, '\P{^Sc=buhd}', "");
    Expect(0, 5972, '\p{Sc=buhd}', "");
    Expect(1, 5972, '\p{^Sc=buhd}', "");
    Expect(1, 5972, '\P{Sc=buhd}', "");
    Expect(0, 5972, '\P{^Sc=buhd}', "");
    Expect(1, 5971, '\p{Sc=:\Abuhd\z:}', "");;
    Expect(0, 5972, '\p{Sc=:\Abuhd\z:}', "");;
    Expect(1, 5971, '\p{Sc=--Buhd}', "");
    Expect(0, 5971, '\p{^Sc=--Buhd}', "");
    Expect(0, 5971, '\P{Sc=--Buhd}', "");
    Expect(1, 5971, '\P{^Sc=--Buhd}', "");
    Expect(0, 5972, '\p{Sc=--Buhd}', "");
    Expect(1, 5972, '\p{^Sc=--Buhd}', "");
    Expect(1, 5972, '\P{Sc=--Buhd}', "");
    Expect(0, 5972, '\P{^Sc=--Buhd}', "");
    Error('\p{Is_Script=  Buhid/a/}');
    Error('\P{Is_Script=  Buhid/a/}');
    Expect(1, 5971, '\p{Is_Script=buhid}', "");
    Expect(0, 5971, '\p{^Is_Script=buhid}', "");
    Expect(0, 5971, '\P{Is_Script=buhid}', "");
    Expect(1, 5971, '\P{^Is_Script=buhid}', "");
    Expect(0, 5972, '\p{Is_Script=buhid}', "");
    Expect(1, 5972, '\p{^Is_Script=buhid}', "");
    Expect(1, 5972, '\P{Is_Script=buhid}', "");
    Expect(0, 5972, '\P{^Is_Script=buhid}', "");
    Expect(1, 5971, '\p{Is_Script=	BUHID}', "");
    Expect(0, 5971, '\p{^Is_Script=	BUHID}', "");
    Expect(0, 5971, '\P{Is_Script=	BUHID}', "");
    Expect(1, 5971, '\P{^Is_Script=	BUHID}', "");
    Expect(0, 5972, '\p{Is_Script=	BUHID}', "");
    Expect(1, 5972, '\p{^Is_Script=	BUHID}', "");
    Expect(1, 5972, '\P{Is_Script=	BUHID}', "");
    Expect(0, 5972, '\P{^Is_Script=	BUHID}', "");
    Error('\p{Is_Sc=:=  Buhd}');
    Error('\P{Is_Sc=:=  Buhd}');
    Expect(1, 5971, '\p{Is_Sc=buhd}', "");
    Expect(0, 5971, '\p{^Is_Sc=buhd}', "");
    Expect(0, 5971, '\P{Is_Sc=buhd}', "");
    Expect(1, 5971, '\P{^Is_Sc=buhd}', "");
    Expect(0, 5972, '\p{Is_Sc=buhd}', "");
    Expect(1, 5972, '\p{^Is_Sc=buhd}', "");
    Expect(1, 5972, '\P{Is_Sc=buhd}', "");
    Expect(0, 5972, '\P{^Is_Sc=buhd}', "");
    Expect(1, 5971, '\p{Is_Sc=	Buhd}', "");
    Expect(0, 5971, '\p{^Is_Sc=	Buhd}', "");
    Expect(0, 5971, '\P{Is_Sc=	Buhd}', "");
    Expect(1, 5971, '\P{^Is_Sc=	Buhd}', "");
    Expect(0, 5972, '\p{Is_Sc=	Buhd}', "");
    Expect(1, 5972, '\p{^Is_Sc=	Buhd}', "");
    Expect(1, 5972, '\P{Is_Sc=	Buhd}', "");
    Expect(0, 5972, '\P{^Is_Sc=	Buhd}', "");
    Error('\p{Script:	CHAKMA/a/}');
    Error('\P{Script:	CHAKMA/a/}');
    Expect(1, 69959, '\p{Script=:\AChakma\z:}', "");;
    Expect(0, 69960, '\p{Script=:\AChakma\z:}', "");;
    Expect(1, 69959, '\p{Script=chakma}', "");
    Expect(0, 69959, '\p{^Script=chakma}', "");
    Expect(0, 69959, '\P{Script=chakma}', "");
    Expect(1, 69959, '\P{^Script=chakma}', "");
    Expect(0, 69960, '\p{Script=chakma}', "");
    Expect(1, 69960, '\p{^Script=chakma}', "");
    Expect(1, 69960, '\P{Script=chakma}', "");
    Expect(0, 69960, '\P{^Script=chakma}', "");
    Expect(1, 69959, '\p{Script=:\Achakma\z:}', "");;
    Expect(0, 69960, '\p{Script=:\Achakma\z:}', "");;
    Expect(1, 69959, '\p{Script=_	chakma}', "");
    Expect(0, 69959, '\p{^Script=_	chakma}', "");
    Expect(0, 69959, '\P{Script=_	chakma}', "");
    Expect(1, 69959, '\P{^Script=_	chakma}', "");
    Expect(0, 69960, '\p{Script=_	chakma}', "");
    Expect(1, 69960, '\p{^Script=_	chakma}', "");
    Expect(1, 69960, '\P{Script=_	chakma}', "");
    Expect(0, 69960, '\P{^Script=_	chakma}', "");
    Error('\p{Sc=/a/Cakm}');
    Error('\P{Sc=/a/Cakm}');
    Expect(1, 69959, '\p{Sc=:\ACakm\z:}', "");;
    Expect(0, 69960, '\p{Sc=:\ACakm\z:}', "");;
    Expect(1, 69959, '\p{Sc=cakm}', "");
    Expect(0, 69959, '\p{^Sc=cakm}', "");
    Expect(0, 69959, '\P{Sc=cakm}', "");
    Expect(1, 69959, '\P{^Sc=cakm}', "");
    Expect(0, 69960, '\p{Sc=cakm}', "");
    Expect(1, 69960, '\p{^Sc=cakm}', "");
    Expect(1, 69960, '\P{Sc=cakm}', "");
    Expect(0, 69960, '\P{^Sc=cakm}', "");
    Expect(1, 69959, '\p{Sc=:\Acakm\z:}', "");;
    Expect(0, 69960, '\p{Sc=:\Acakm\z:}', "");;
    Expect(1, 69959, '\p{Sc=-cakm}', "");
    Expect(0, 69959, '\p{^Sc=-cakm}', "");
    Expect(0, 69959, '\P{Sc=-cakm}', "");
    Expect(1, 69959, '\P{^Sc=-cakm}', "");
    Expect(0, 69960, '\p{Sc=-cakm}', "");
    Expect(1, 69960, '\p{^Sc=-cakm}', "");
    Expect(1, 69960, '\P{Sc=-cakm}', "");
    Expect(0, 69960, '\P{^Sc=-cakm}', "");
    Error('\p{Is_Script=	 CHAKMA/a/}');
    Error('\P{Is_Script=	 CHAKMA/a/}');
    Expect(1, 69959, '\p{Is_Script=chakma}', "");
    Expect(0, 69959, '\p{^Is_Script=chakma}', "");
    Expect(0, 69959, '\P{Is_Script=chakma}', "");
    Expect(1, 69959, '\P{^Is_Script=chakma}', "");
    Expect(0, 69960, '\p{Is_Script=chakma}', "");
    Expect(1, 69960, '\p{^Is_Script=chakma}', "");
    Expect(1, 69960, '\P{Is_Script=chakma}', "");
    Expect(0, 69960, '\P{^Is_Script=chakma}', "");
    Expect(1, 69959, '\p{Is_Script=_	CHAKMA}', "");
    Expect(0, 69959, '\p{^Is_Script=_	CHAKMA}', "");
    Expect(0, 69959, '\P{Is_Script=_	CHAKMA}', "");
    Expect(1, 69959, '\P{^Is_Script=_	CHAKMA}', "");
    Expect(0, 69960, '\p{Is_Script=_	CHAKMA}', "");
    Expect(1, 69960, '\p{^Is_Script=_	CHAKMA}', "");
    Expect(1, 69960, '\P{Is_Script=_	CHAKMA}', "");
    Expect(0, 69960, '\P{^Is_Script=_	CHAKMA}', "");
    Error('\p{Is_Sc=-_Cakm/a/}');
    Error('\P{Is_Sc=-_Cakm/a/}');
    Expect(1, 69959, '\p{Is_Sc=cakm}', "");
    Expect(0, 69959, '\p{^Is_Sc=cakm}', "");
    Expect(0, 69959, '\P{Is_Sc=cakm}', "");
    Expect(1, 69959, '\P{^Is_Sc=cakm}', "");
    Expect(0, 69960, '\p{Is_Sc=cakm}', "");
    Expect(1, 69960, '\p{^Is_Sc=cakm}', "");
    Expect(1, 69960, '\P{Is_Sc=cakm}', "");
    Expect(0, 69960, '\P{^Is_Sc=cakm}', "");
    Expect(1, 69959, '\p{Is_Sc=	_cakm}', "");
    Expect(0, 69959, '\p{^Is_Sc=	_cakm}', "");
    Expect(0, 69959, '\P{Is_Sc=	_cakm}', "");
    Expect(1, 69959, '\P{^Is_Sc=	_cakm}', "");
    Expect(0, 69960, '\p{Is_Sc=	_cakm}', "");
    Expect(1, 69960, '\p{^Is_Sc=	_cakm}', "");
    Expect(1, 69960, '\P{Is_Sc=	_cakm}', "");
    Expect(0, 69960, '\P{^Is_Sc=	_cakm}', "");
    Error('\p{Script=/a/--CANADIAN_Aboriginal}');
    Error('\P{Script=/a/--CANADIAN_Aboriginal}');
    Expect(1, 6389, '\p{Script=:\ACanadian_Aboriginal\z:}', "");;
    Expect(0, 6390, '\p{Script=:\ACanadian_Aboriginal\z:}', "");;
    Expect(1, 6389, '\p{Script=canadianaboriginal}', "");
    Expect(0, 6389, '\p{^Script=canadianaboriginal}', "");
    Expect(0, 6389, '\P{Script=canadianaboriginal}', "");
    Expect(1, 6389, '\P{^Script=canadianaboriginal}', "");
    Expect(0, 6390, '\p{Script=canadianaboriginal}', "");
    Expect(1, 6390, '\p{^Script=canadianaboriginal}', "");
    Expect(1, 6390, '\P{Script=canadianaboriginal}', "");
    Expect(0, 6390, '\P{^Script=canadianaboriginal}', "");
    Expect(1, 6389, '\p{Script=:\Acanadianaboriginal\z:}', "");;
    Expect(0, 6390, '\p{Script=:\Acanadianaboriginal\z:}', "");;
    Expect(1, 6389, '\p{Script=-Canadian_Aboriginal}', "");
    Expect(0, 6389, '\p{^Script=-Canadian_Aboriginal}', "");
    Expect(0, 6389, '\P{Script=-Canadian_Aboriginal}', "");
    Expect(1, 6389, '\P{^Script=-Canadian_Aboriginal}', "");
    Expect(0, 6390, '\p{Script=-Canadian_Aboriginal}', "");
    Expect(1, 6390, '\p{^Script=-Canadian_Aboriginal}', "");
    Expect(1, 6390, '\P{Script=-Canadian_Aboriginal}', "");
    Expect(0, 6390, '\P{^Script=-Canadian_Aboriginal}', "");
    Error('\p{Sc:		/a/Cans}');
    Error('\P{Sc:		/a/Cans}');
    Expect(1, 6389, '\p{Sc=:\ACans\z:}', "");;
    Expect(0, 6390, '\p{Sc=:\ACans\z:}', "");;
    Expect(1, 6389, '\p{Sc=cans}', "");
    Expect(0, 6389, '\p{^Sc=cans}', "");
    Expect(0, 6389, '\P{Sc=cans}', "");
    Expect(1, 6389, '\P{^Sc=cans}', "");
    Expect(0, 6390, '\p{Sc=cans}', "");
    Expect(1, 6390, '\p{^Sc=cans}', "");
    Expect(1, 6390, '\P{Sc=cans}', "");
    Expect(0, 6390, '\P{^Sc=cans}', "");
    Expect(1, 6389, '\p{Sc=:\Acans\z:}', "");;
    Expect(0, 6390, '\p{Sc=:\Acans\z:}', "");;
    Expect(1, 6389, '\p{Sc=__cans}', "");
    Expect(0, 6389, '\p{^Sc=__cans}', "");
    Expect(0, 6389, '\P{Sc=__cans}', "");
    Expect(1, 6389, '\P{^Sc=__cans}', "");
    Expect(0, 6390, '\p{Sc=__cans}', "");
    Expect(1, 6390, '\p{^Sc=__cans}', "");
    Expect(1, 6390, '\P{Sc=__cans}', "");
    Expect(0, 6390, '\P{^Sc=__cans}', "");
    Error('\p{Is_Script=_:=CANADIAN_aboriginal}');
    Error('\P{Is_Script=_:=CANADIAN_aboriginal}');
    Expect(1, 6389, '\p{Is_Script=canadianaboriginal}', "");
    Expect(0, 6389, '\p{^Is_Script=canadianaboriginal}', "");
    Expect(0, 6389, '\P{Is_Script=canadianaboriginal}', "");
    Expect(1, 6389, '\P{^Is_Script=canadianaboriginal}', "");
    Expect(0, 6390, '\p{Is_Script=canadianaboriginal}', "");
    Expect(1, 6390, '\p{^Is_Script=canadianaboriginal}', "");
    Expect(1, 6390, '\P{Is_Script=canadianaboriginal}', "");
    Expect(0, 6390, '\P{^Is_Script=canadianaboriginal}', "");
    Expect(1, 6389, '\p{Is_Script=-Canadian_Aboriginal}', "");
    Expect(0, 6389, '\p{^Is_Script=-Canadian_Aboriginal}', "");
    Expect(0, 6389, '\P{Is_Script=-Canadian_Aboriginal}', "");
    Expect(1, 6389, '\P{^Is_Script=-Canadian_Aboriginal}', "");
    Expect(0, 6390, '\p{Is_Script=-Canadian_Aboriginal}', "");
    Expect(1, 6390, '\p{^Is_Script=-Canadian_Aboriginal}', "");
    Expect(1, 6390, '\P{Is_Script=-Canadian_Aboriginal}', "");
    Expect(0, 6390, '\P{^Is_Script=-Canadian_Aboriginal}', "");
    Error('\p{Is_Sc= -CANS:=}');
    Error('\P{Is_Sc= -CANS:=}');
    Expect(1, 6389, '\p{Is_Sc=cans}', "");
    Expect(0, 6389, '\p{^Is_Sc=cans}', "");
    Expect(0, 6389, '\P{Is_Sc=cans}', "");
    Expect(1, 6389, '\P{^Is_Sc=cans}', "");
    Expect(0, 6390, '\p{Is_Sc=cans}', "");
    Expect(1, 6390, '\p{^Is_Sc=cans}', "");
    Expect(1, 6390, '\P{Is_Sc=cans}', "");
    Expect(0, 6390, '\P{^Is_Sc=cans}', "");
    Expect(1, 6389, '\p{Is_Sc=	_Cans}', "");
    Expect(0, 6389, '\p{^Is_Sc=	_Cans}', "");
    Expect(0, 6389, '\P{Is_Sc=	_Cans}', "");
    Expect(1, 6389, '\P{^Is_Sc=	_Cans}', "");
    Expect(0, 6390, '\p{Is_Sc=	_Cans}', "");
    Expect(1, 6390, '\p{^Is_Sc=	_Cans}', "");
    Expect(1, 6390, '\P{Is_Sc=	_Cans}', "");
    Expect(0, 6390, '\P{^Is_Sc=	_Cans}', "");
    Error('\p{Script=-:=CARIAN}');
    Error('\P{Script=-:=CARIAN}');
    Expect(1, 66256, '\p{Script=:\ACarian\z:}', "");;
    Expect(0, 66257, '\p{Script=:\ACarian\z:}', "");;
    Expect(1, 66256, '\p{Script:carian}', "");
    Expect(0, 66256, '\p{^Script:carian}', "");
    Expect(0, 66256, '\P{Script:carian}', "");
    Expect(1, 66256, '\P{^Script:carian}', "");
    Expect(0, 66257, '\p{Script:carian}', "");
    Expect(1, 66257, '\p{^Script:carian}', "");
    Expect(1, 66257, '\P{Script:carian}', "");
    Expect(0, 66257, '\P{^Script:carian}', "");
    Expect(1, 66256, '\p{Script=:\Acarian\z:}', "");;
    Expect(0, 66257, '\p{Script=:\Acarian\z:}', "");;
    Expect(1, 66256, '\p{Script= _CARIAN}', "");
    Expect(0, 66256, '\p{^Script= _CARIAN}', "");
    Expect(0, 66256, '\P{Script= _CARIAN}', "");
    Expect(1, 66256, '\P{^Script= _CARIAN}', "");
    Expect(0, 66257, '\p{Script= _CARIAN}', "");
    Expect(1, 66257, '\p{^Script= _CARIAN}', "");
    Expect(1, 66257, '\P{Script= _CARIAN}', "");
    Expect(0, 66257, '\P{^Script= _CARIAN}', "");
    Error('\p{Sc=_Cari:=}');
    Error('\P{Sc=_Cari:=}');
    Expect(1, 66256, '\p{Sc=:\ACari\z:}', "");;
    Expect(0, 66257, '\p{Sc=:\ACari\z:}', "");;
    Expect(1, 66256, '\p{Sc=cari}', "");
    Expect(0, 66256, '\p{^Sc=cari}', "");
    Expect(0, 66256, '\P{Sc=cari}', "");
    Expect(1, 66256, '\P{^Sc=cari}', "");
    Expect(0, 66257, '\p{Sc=cari}', "");
    Expect(1, 66257, '\p{^Sc=cari}', "");
    Expect(1, 66257, '\P{Sc=cari}', "");
    Expect(0, 66257, '\P{^Sc=cari}', "");
    Expect(1, 66256, '\p{Sc=:\Acari\z:}', "");;
    Expect(0, 66257, '\p{Sc=:\Acari\z:}', "");;
    Expect(1, 66256, '\p{Sc=--Cari}', "");
    Expect(0, 66256, '\p{^Sc=--Cari}', "");
    Expect(0, 66256, '\P{Sc=--Cari}', "");
    Expect(1, 66256, '\P{^Sc=--Cari}', "");
    Expect(0, 66257, '\p{Sc=--Cari}', "");
    Expect(1, 66257, '\p{^Sc=--Cari}', "");
    Expect(1, 66257, '\P{Sc=--Cari}', "");
    Expect(0, 66257, '\P{^Sc=--Cari}', "");
    Error('\p{Is_Script= carian:=}');
    Error('\P{Is_Script= carian:=}');
    Expect(1, 66256, '\p{Is_Script=carian}', "");
    Expect(0, 66256, '\p{^Is_Script=carian}', "");
    Expect(0, 66256, '\P{Is_Script=carian}', "");
    Expect(1, 66256, '\P{^Is_Script=carian}', "");
    Expect(0, 66257, '\p{Is_Script=carian}', "");
    Expect(1, 66257, '\p{^Is_Script=carian}', "");
    Expect(1, 66257, '\P{Is_Script=carian}', "");
    Expect(0, 66257, '\P{^Is_Script=carian}', "");
    Expect(1, 66256, '\p{Is_Script=	_Carian}', "");
    Expect(0, 66256, '\p{^Is_Script=	_Carian}', "");
    Expect(0, 66256, '\P{Is_Script=	_Carian}', "");
    Expect(1, 66256, '\P{^Is_Script=	_Carian}', "");
    Expect(0, 66257, '\p{Is_Script=	_Carian}', "");
    Expect(1, 66257, '\p{^Is_Script=	_Carian}', "");
    Expect(1, 66257, '\P{Is_Script=	_Carian}', "");
    Expect(0, 66257, '\P{^Is_Script=	_Carian}', "");
    Error('\p{Is_Sc=/a/cari}');
    Error('\P{Is_Sc=/a/cari}');
    Expect(1, 66256, '\p{Is_Sc=cari}', "");
    Expect(0, 66256, '\p{^Is_Sc=cari}', "");
    Expect(0, 66256, '\P{Is_Sc=cari}', "");
    Expect(1, 66256, '\P{^Is_Sc=cari}', "");
    Expect(0, 66257, '\p{Is_Sc=cari}', "");
    Expect(1, 66257, '\p{^Is_Sc=cari}', "");
    Expect(1, 66257, '\P{Is_Sc=cari}', "");
    Expect(0, 66257, '\P{^Is_Sc=cari}', "");
    Expect(1, 66256, '\p{Is_Sc=Cari}', "");
    Expect(0, 66256, '\p{^Is_Sc=Cari}', "");
    Expect(0, 66256, '\P{Is_Sc=Cari}', "");
    Expect(1, 66256, '\P{^Is_Sc=Cari}', "");
    Expect(0, 66257, '\p{Is_Sc=Cari}', "");
    Expect(1, 66257, '\p{^Is_Sc=Cari}', "");
    Expect(1, 66257, '\P{Is_Sc=Cari}', "");
    Expect(0, 66257, '\P{^Is_Sc=Cari}', "");
    Error('\p{Script:	_:=Cham}');
    Error('\P{Script:	_:=Cham}');
    Expect(1, 43615, '\p{Script=:\ACham\z:}', "");;
    Expect(0, 43616, '\p{Script=:\ACham\z:}', "");;
    Expect(1, 43615, '\p{Script=cham}', "");
    Expect(0, 43615, '\p{^Script=cham}', "");
    Expect(0, 43615, '\P{Script=cham}', "");
    Expect(1, 43615, '\P{^Script=cham}', "");
    Expect(0, 43616, '\p{Script=cham}', "");
    Expect(1, 43616, '\p{^Script=cham}', "");
    Expect(1, 43616, '\P{Script=cham}', "");
    Expect(0, 43616, '\P{^Script=cham}', "");
    Expect(1, 43615, '\p{Script=:\Acham\z:}', "");;
    Expect(0, 43616, '\p{Script=:\Acham\z:}', "");;
    Expect(1, 43615, '\p{Script=_-CHAM}', "");
    Expect(0, 43615, '\p{^Script=_-CHAM}', "");
    Expect(0, 43615, '\P{Script=_-CHAM}', "");
    Expect(1, 43615, '\P{^Script=_-CHAM}', "");
    Expect(0, 43616, '\p{Script=_-CHAM}', "");
    Expect(1, 43616, '\p{^Script=_-CHAM}', "");
    Expect(1, 43616, '\P{Script=_-CHAM}', "");
    Expect(0, 43616, '\P{^Script=_-CHAM}', "");
    Error('\p{Sc=	Cham/a/}');
    Error('\P{Sc=	Cham/a/}');
    Expect(1, 43615, '\p{Sc=:\ACham\z:}', "");;
    Expect(0, 43616, '\p{Sc=:\ACham\z:}', "");;
    Expect(1, 43615, '\p{Sc:	cham}', "");
    Expect(0, 43615, '\p{^Sc:	cham}', "");
    Expect(0, 43615, '\P{Sc:	cham}', "");
    Expect(1, 43615, '\P{^Sc:	cham}', "");
    Expect(0, 43616, '\p{Sc:	cham}', "");
    Expect(1, 43616, '\p{^Sc:	cham}', "");
    Expect(1, 43616, '\P{Sc:	cham}', "");
    Expect(0, 43616, '\P{^Sc:	cham}', "");
    Expect(1, 43615, '\p{Sc=:\Acham\z:}', "");;
    Expect(0, 43616, '\p{Sc=:\Acham\z:}', "");;
    Expect(1, 43615, '\p{Sc=	 Cham}', "");
    Expect(0, 43615, '\p{^Sc=	 Cham}', "");
    Expect(0, 43615, '\P{Sc=	 Cham}', "");
    Expect(1, 43615, '\P{^Sc=	 Cham}', "");
    Expect(0, 43616, '\p{Sc=	 Cham}', "");
    Expect(1, 43616, '\p{^Sc=	 Cham}', "");
    Expect(1, 43616, '\P{Sc=	 Cham}', "");
    Expect(0, 43616, '\P{^Sc=	 Cham}', "");
    Error('\p{Is_Script=_/a/Cham}');
    Error('\P{Is_Script=_/a/Cham}');
    Expect(1, 43615, '\p{Is_Script=cham}', "");
    Expect(0, 43615, '\p{^Is_Script=cham}', "");
    Expect(0, 43615, '\P{Is_Script=cham}', "");
    Expect(1, 43615, '\P{^Is_Script=cham}', "");
    Expect(0, 43616, '\p{Is_Script=cham}', "");
    Expect(1, 43616, '\p{^Is_Script=cham}', "");
    Expect(1, 43616, '\P{Is_Script=cham}', "");
    Expect(0, 43616, '\P{^Is_Script=cham}', "");
    Expect(1, 43615, '\p{Is_Script= CHAM}', "");
    Expect(0, 43615, '\p{^Is_Script= CHAM}', "");
    Expect(0, 43615, '\P{Is_Script= CHAM}', "");
    Expect(1, 43615, '\P{^Is_Script= CHAM}', "");
    Expect(0, 43616, '\p{Is_Script= CHAM}', "");
    Expect(1, 43616, '\p{^Is_Script= CHAM}', "");
    Expect(1, 43616, '\P{Is_Script= CHAM}', "");
    Expect(0, 43616, '\P{^Is_Script= CHAM}', "");
    Error('\p{Is_Sc=  cham:=}');
    Error('\P{Is_Sc=  cham:=}');
    Expect(1, 43615, '\p{Is_Sc=cham}', "");
    Expect(0, 43615, '\p{^Is_Sc=cham}', "");
    Expect(0, 43615, '\P{Is_Sc=cham}', "");
    Expect(1, 43615, '\P{^Is_Sc=cham}', "");
    Expect(0, 43616, '\p{Is_Sc=cham}', "");
    Expect(1, 43616, '\p{^Is_Sc=cham}', "");
    Expect(1, 43616, '\P{Is_Sc=cham}', "");
    Expect(0, 43616, '\P{^Is_Sc=cham}', "");
    Expect(1, 43615, '\p{Is_Sc=-Cham}', "");
    Expect(0, 43615, '\p{^Is_Sc=-Cham}', "");
    Expect(0, 43615, '\P{Is_Sc=-Cham}', "");
    Expect(1, 43615, '\P{^Is_Sc=-Cham}', "");
    Expect(0, 43616, '\p{Is_Sc=-Cham}', "");
    Expect(1, 43616, '\p{^Is_Sc=-Cham}', "");
    Expect(1, 43616, '\P{Is_Sc=-Cham}', "");
    Expect(0, 43616, '\P{^Is_Sc=-Cham}', "");
    Error('\p{Script=:= Cherokee}');
    Error('\P{Script=:= Cherokee}');
    Expect(1, 43967, '\p{Script=:\ACherokee\z:}', "");;
    Expect(0, 43968, '\p{Script=:\ACherokee\z:}', "");;
    Expect(1, 43967, '\p{Script=cherokee}', "");
    Expect(0, 43967, '\p{^Script=cherokee}', "");
    Expect(0, 43967, '\P{Script=cherokee}', "");
    Expect(1, 43967, '\P{^Script=cherokee}', "");
    Expect(0, 43968, '\p{Script=cherokee}', "");
    Expect(1, 43968, '\p{^Script=cherokee}', "");
    Expect(1, 43968, '\P{Script=cherokee}', "");
    Expect(0, 43968, '\P{^Script=cherokee}', "");
    Expect(1, 43967, '\p{Script=:\Acherokee\z:}', "");;
    Expect(0, 43968, '\p{Script=:\Acherokee\z:}', "");;
    Expect(1, 43967, '\p{Script=- CHEROKEE}', "");
    Expect(0, 43967, '\p{^Script=- CHEROKEE}', "");
    Expect(0, 43967, '\P{Script=- CHEROKEE}', "");
    Expect(1, 43967, '\P{^Script=- CHEROKEE}', "");
    Expect(0, 43968, '\p{Script=- CHEROKEE}', "");
    Expect(1, 43968, '\p{^Script=- CHEROKEE}', "");
    Expect(1, 43968, '\P{Script=- CHEROKEE}', "");
    Expect(0, 43968, '\P{^Script=- CHEROKEE}', "");
    Error('\p{Sc=		CHER/a/}');
    Error('\P{Sc=		CHER/a/}');
    Expect(1, 43967, '\p{Sc=:\ACher\z:}', "");;
    Expect(0, 43968, '\p{Sc=:\ACher\z:}', "");;
    Expect(1, 43967, '\p{Sc:   cher}', "");
    Expect(0, 43967, '\p{^Sc:   cher}', "");
    Expect(0, 43967, '\P{Sc:   cher}', "");
    Expect(1, 43967, '\P{^Sc:   cher}', "");
    Expect(0, 43968, '\p{Sc:   cher}', "");
    Expect(1, 43968, '\p{^Sc:   cher}', "");
    Expect(1, 43968, '\P{Sc:   cher}', "");
    Expect(0, 43968, '\P{^Sc:   cher}', "");
    Expect(1, 43967, '\p{Sc=:\Acher\z:}', "");;
    Expect(0, 43968, '\p{Sc=:\Acher\z:}', "");;
    Expect(1, 43967, '\p{Sc=-Cher}', "");
    Expect(0, 43967, '\p{^Sc=-Cher}', "");
    Expect(0, 43967, '\P{Sc=-Cher}', "");
    Expect(1, 43967, '\P{^Sc=-Cher}', "");
    Expect(0, 43968, '\p{Sc=-Cher}', "");
    Expect(1, 43968, '\p{^Sc=-Cher}', "");
    Expect(1, 43968, '\P{Sc=-Cher}', "");
    Expect(0, 43968, '\P{^Sc=-Cher}', "");
    Error('\p{Is_Script= _CHEROKEE:=}');
    Error('\P{Is_Script= _CHEROKEE:=}');
    Expect(1, 43967, '\p{Is_Script=cherokee}', "");
    Expect(0, 43967, '\p{^Is_Script=cherokee}', "");
    Expect(0, 43967, '\P{Is_Script=cherokee}', "");
    Expect(1, 43967, '\P{^Is_Script=cherokee}', "");
    Expect(0, 43968, '\p{Is_Script=cherokee}', "");
    Expect(1, 43968, '\p{^Is_Script=cherokee}', "");
    Expect(1, 43968, '\P{Is_Script=cherokee}', "");
    Expect(0, 43968, '\P{^Is_Script=cherokee}', "");
    Expect(1, 43967, '\p{Is_Script: _Cherokee}', "");
    Expect(0, 43967, '\p{^Is_Script: _Cherokee}', "");
    Expect(0, 43967, '\P{Is_Script: _Cherokee}', "");
    Expect(1, 43967, '\P{^Is_Script: _Cherokee}', "");
    Expect(0, 43968, '\p{Is_Script: _Cherokee}', "");
    Expect(1, 43968, '\p{^Is_Script: _Cherokee}', "");
    Expect(1, 43968, '\P{Is_Script: _Cherokee}', "");
    Expect(0, 43968, '\P{^Is_Script: _Cherokee}', "");
    Error('\p{Is_Sc=-CHER/a/}');
    Error('\P{Is_Sc=-CHER/a/}');
    Expect(1, 43967, '\p{Is_Sc=cher}', "");
    Expect(0, 43967, '\p{^Is_Sc=cher}', "");
    Expect(0, 43967, '\P{Is_Sc=cher}', "");
    Expect(1, 43967, '\P{^Is_Sc=cher}', "");
    Expect(0, 43968, '\p{Is_Sc=cher}', "");
    Expect(1, 43968, '\p{^Is_Sc=cher}', "");
    Expect(1, 43968, '\P{Is_Sc=cher}', "");
    Expect(0, 43968, '\P{^Is_Sc=cher}', "");
    Expect(1, 43967, '\p{Is_Sc=	_cher}', "");
    Expect(0, 43967, '\p{^Is_Sc=	_cher}', "");
    Expect(0, 43967, '\P{Is_Sc=	_cher}', "");
    Expect(1, 43967, '\P{^Is_Sc=	_cher}', "");
    Expect(0, 43968, '\p{Is_Sc=	_cher}', "");
    Expect(1, 43968, '\p{^Is_Sc=	_cher}', "");
    Expect(1, 43968, '\P{Is_Sc=	_cher}', "");
    Expect(0, 43968, '\P{^Is_Sc=	_cher}', "");
    Error('\p{Script:   _:=Chorasmian}');
    Error('\P{Script:   _:=Chorasmian}');
    Expect(1, 69579, '\p{Script=:\AChorasmian\z:}', "");;
    Expect(0, 69580, '\p{Script=:\AChorasmian\z:}', "");;
    Expect(1, 69579, '\p{Script=chorasmian}', "");
    Expect(0, 69579, '\p{^Script=chorasmian}', "");
    Expect(0, 69579, '\P{Script=chorasmian}', "");
    Expect(1, 69579, '\P{^Script=chorasmian}', "");
    Expect(0, 69580, '\p{Script=chorasmian}', "");
    Expect(1, 69580, '\p{^Script=chorasmian}', "");
    Expect(1, 69580, '\P{Script=chorasmian}', "");
    Expect(0, 69580, '\P{^Script=chorasmian}', "");
    Expect(1, 69579, '\p{Script=:\Achorasmian\z:}', "");;
    Expect(0, 69580, '\p{Script=:\Achorasmian\z:}', "");;
    Expect(1, 69579, '\p{Script=-_Chorasmian}', "");
    Expect(0, 69579, '\p{^Script=-_Chorasmian}', "");
    Expect(0, 69579, '\P{Script=-_Chorasmian}', "");
    Expect(1, 69579, '\P{^Script=-_Chorasmian}', "");
    Expect(0, 69580, '\p{Script=-_Chorasmian}', "");
    Expect(1, 69580, '\p{^Script=-_Chorasmian}', "");
    Expect(1, 69580, '\P{Script=-_Chorasmian}', "");
    Expect(0, 69580, '\P{^Script=-_Chorasmian}', "");
    Error('\p{Sc= :=CHRS}');
    Error('\P{Sc= :=CHRS}');
    Expect(1, 69579, '\p{Sc=:\AChrs\z:}', "");;
    Expect(0, 69580, '\p{Sc=:\AChrs\z:}', "");;
    Expect(1, 69579, '\p{Sc:chrs}', "");
    Expect(0, 69579, '\p{^Sc:chrs}', "");
    Expect(0, 69579, '\P{Sc:chrs}', "");
    Expect(1, 69579, '\P{^Sc:chrs}', "");
    Expect(0, 69580, '\p{Sc:chrs}', "");
    Expect(1, 69580, '\p{^Sc:chrs}', "");
    Expect(1, 69580, '\P{Sc:chrs}', "");
    Expect(0, 69580, '\P{^Sc:chrs}', "");
    Expect(1, 69579, '\p{Sc=:\Achrs\z:}', "");;
    Expect(0, 69580, '\p{Sc=:\Achrs\z:}', "");;
    Expect(1, 69579, '\p{Sc=	 CHRS}', "");
    Expect(0, 69579, '\p{^Sc=	 CHRS}', "");
    Expect(0, 69579, '\P{Sc=	 CHRS}', "");
    Expect(1, 69579, '\P{^Sc=	 CHRS}', "");
    Expect(0, 69580, '\p{Sc=	 CHRS}', "");
    Expect(1, 69580, '\p{^Sc=	 CHRS}', "");
    Expect(1, 69580, '\P{Sc=	 CHRS}', "");
    Expect(0, 69580, '\P{^Sc=	 CHRS}', "");
    Error('\p{Is_Script=Chorasmian/a/}');
    Error('\P{Is_Script=Chorasmian/a/}');
    Expect(1, 69579, '\p{Is_Script=chorasmian}', "");
    Expect(0, 69579, '\p{^Is_Script=chorasmian}', "");
    Expect(0, 69579, '\P{Is_Script=chorasmian}', "");
    Expect(1, 69579, '\P{^Is_Script=chorasmian}', "");
    Expect(0, 69580, '\p{Is_Script=chorasmian}', "");
    Expect(1, 69580, '\p{^Is_Script=chorasmian}', "");
    Expect(1, 69580, '\P{Is_Script=chorasmian}', "");
    Expect(0, 69580, '\P{^Is_Script=chorasmian}', "");
    Expect(1, 69579, '\p{Is_Script=		Chorasmian}', "");
    Expect(0, 69579, '\p{^Is_Script=		Chorasmian}', "");
    Expect(0, 69579, '\P{Is_Script=		Chorasmian}', "");
    Expect(1, 69579, '\P{^Is_Script=		Chorasmian}', "");
    Expect(0, 69580, '\p{Is_Script=		Chorasmian}', "");
    Expect(1, 69580, '\p{^Is_Script=		Chorasmian}', "");
    Expect(1, 69580, '\P{Is_Script=		Chorasmian}', "");
    Expect(0, 69580, '\P{^Is_Script=		Chorasmian}', "");
    Error('\p{Is_Sc=/a/ -Chrs}');
    Error('\P{Is_Sc=/a/ -Chrs}');
    Expect(1, 69579, '\p{Is_Sc=chrs}', "");
    Expect(0, 69579, '\p{^Is_Sc=chrs}', "");
    Expect(0, 69579, '\P{Is_Sc=chrs}', "");
    Expect(1, 69579, '\P{^Is_Sc=chrs}', "");
    Expect(0, 69580, '\p{Is_Sc=chrs}', "");
    Expect(1, 69580, '\p{^Is_Sc=chrs}', "");
    Expect(1, 69580, '\P{Is_Sc=chrs}', "");
    Expect(0, 69580, '\P{^Is_Sc=chrs}', "");
    Expect(1, 69579, '\p{Is_Sc:    _Chrs}', "");
    Expect(0, 69579, '\p{^Is_Sc:    _Chrs}', "");
    Expect(0, 69579, '\P{Is_Sc:    _Chrs}', "");
    Expect(1, 69579, '\P{^Is_Sc:    _Chrs}', "");
    Expect(0, 69580, '\p{Is_Sc:    _Chrs}', "");
    Expect(1, 69580, '\p{^Is_Sc:    _Chrs}', "");
    Expect(1, 69580, '\P{Is_Sc:    _Chrs}', "");
    Expect(0, 69580, '\P{^Is_Sc:    _Chrs}', "");
    Error('\p{Script=:=Coptic}');
    Error('\P{Script=:=Coptic}');
    Expect(1, 11519, '\p{Script=:\ACoptic\z:}', "");;
    Expect(0, 11520, '\p{Script=:\ACoptic\z:}', "");;
    Expect(1, 11519, '\p{Script=coptic}', "");
    Expect(0, 11519, '\p{^Script=coptic}', "");
    Expect(0, 11519, '\P{Script=coptic}', "");
    Expect(1, 11519, '\P{^Script=coptic}', "");
    Expect(0, 11520, '\p{Script=coptic}', "");
    Expect(1, 11520, '\p{^Script=coptic}', "");
    Expect(1, 11520, '\P{Script=coptic}', "");
    Expect(0, 11520, '\P{^Script=coptic}', "");
    Expect(1, 11519, '\p{Script=:\Acoptic\z:}', "");;
    Expect(0, 11520, '\p{Script=:\Acoptic\z:}', "");;
    Expect(1, 11519, '\p{Script: -	Coptic}', "");
    Expect(0, 11519, '\p{^Script: -	Coptic}', "");
    Expect(0, 11519, '\P{Script: -	Coptic}', "");
    Expect(1, 11519, '\P{^Script: -	Coptic}', "");
    Expect(0, 11520, '\p{Script: -	Coptic}', "");
    Expect(1, 11520, '\p{^Script: -	Coptic}', "");
    Expect(1, 11520, '\P{Script: -	Coptic}', "");
    Expect(0, 11520, '\P{^Script: -	Coptic}', "");
    Error('\p{Sc=:= Copt}');
    Error('\P{Sc=:= Copt}');
    Expect(1, 11519, '\p{Sc=:\ACopt\z:}', "");;
    Expect(0, 11520, '\p{Sc=:\ACopt\z:}', "");;
    Expect(1, 11519, '\p{Sc=copt}', "");
    Expect(0, 11519, '\p{^Sc=copt}', "");
    Expect(0, 11519, '\P{Sc=copt}', "");
    Expect(1, 11519, '\P{^Sc=copt}', "");
    Expect(0, 11520, '\p{Sc=copt}', "");
    Expect(1, 11520, '\p{^Sc=copt}', "");
    Expect(1, 11520, '\P{Sc=copt}', "");
    Expect(0, 11520, '\P{^Sc=copt}', "");
    Expect(1, 11519, '\p{Sc=:\Acopt\z:}', "");;
    Expect(0, 11520, '\p{Sc=:\Acopt\z:}', "");;
    Expect(1, 11519, '\p{Sc=-	Copt}', "");
    Expect(0, 11519, '\p{^Sc=-	Copt}', "");
    Expect(0, 11519, '\P{Sc=-	Copt}', "");
    Expect(1, 11519, '\P{^Sc=-	Copt}', "");
    Expect(0, 11520, '\p{Sc=-	Copt}', "");
    Expect(1, 11520, '\p{^Sc=-	Copt}', "");
    Expect(1, 11520, '\P{Sc=-	Copt}', "");
    Expect(0, 11520, '\P{^Sc=-	Copt}', "");
    Error('\p{Is_Script=/a/ QAAC}');
    Error('\P{Is_Script=/a/ QAAC}');
    Expect(1, 11519, '\p{Is_Script=qaac}', "");
    Expect(0, 11519, '\p{^Is_Script=qaac}', "");
    Expect(0, 11519, '\P{Is_Script=qaac}', "");
    Expect(1, 11519, '\P{^Is_Script=qaac}', "");
    Expect(0, 11520, '\p{Is_Script=qaac}', "");
    Expect(1, 11520, '\p{^Is_Script=qaac}', "");
    Expect(1, 11520, '\P{Is_Script=qaac}', "");
    Expect(0, 11520, '\P{^Is_Script=qaac}', "");
    Expect(1, 11519, '\p{Is_Script=_qaac}', "");
    Expect(0, 11519, '\p{^Is_Script=_qaac}', "");
    Expect(0, 11519, '\P{Is_Script=_qaac}', "");
    Expect(1, 11519, '\P{^Is_Script=_qaac}', "");
    Expect(0, 11520, '\p{Is_Script=_qaac}', "");
    Expect(1, 11520, '\p{^Is_Script=_qaac}', "");
    Expect(1, 11520, '\P{Is_Script=_qaac}', "");
    Expect(0, 11520, '\P{^Is_Script=_qaac}', "");
    Error('\p{Is_Sc=	coptic/a/}');
    Error('\P{Is_Sc=	coptic/a/}');
    Expect(1, 11519, '\p{Is_Sc=coptic}', "");
    Expect(0, 11519, '\p{^Is_Sc=coptic}', "");
    Expect(0, 11519, '\P{Is_Sc=coptic}', "");
    Expect(1, 11519, '\P{^Is_Sc=coptic}', "");
    Expect(0, 11520, '\p{Is_Sc=coptic}', "");
    Expect(1, 11520, '\p{^Is_Sc=coptic}', "");
    Expect(1, 11520, '\P{Is_Sc=coptic}', "");
    Expect(0, 11520, '\P{^Is_Sc=coptic}', "");
    Expect(1, 11519, '\p{Is_Sc=	coptic}', "");
    Expect(0, 11519, '\p{^Is_Sc=	coptic}', "");
    Expect(0, 11519, '\P{Is_Sc=	coptic}', "");
    Expect(1, 11519, '\P{^Is_Sc=	coptic}', "");
    Expect(0, 11520, '\p{Is_Sc=	coptic}', "");
    Expect(1, 11520, '\p{^Is_Sc=	coptic}', "");
    Expect(1, 11520, '\P{Is_Sc=	coptic}', "");
    Expect(0, 11520, '\P{^Is_Sc=	coptic}', "");
    Error('\p{Script= 	Cypriot/a/}');
    Error('\P{Script= 	Cypriot/a/}');
    Expect(1, 67647, '\p{Script=:\ACypriot\z:}', "");;
    Expect(0, 67648, '\p{Script=:\ACypriot\z:}', "");;
    Expect(1, 67647, '\p{Script=cypriot}', "");
    Expect(0, 67647, '\p{^Script=cypriot}', "");
    Expect(0, 67647, '\P{Script=cypriot}', "");
    Expect(1, 67647, '\P{^Script=cypriot}', "");
    Expect(0, 67648, '\p{Script=cypriot}', "");
    Expect(1, 67648, '\p{^Script=cypriot}', "");
    Expect(1, 67648, '\P{Script=cypriot}', "");
    Expect(0, 67648, '\P{^Script=cypriot}', "");
    Expect(1, 67647, '\p{Script=:\Acypriot\z:}', "");;
    Expect(0, 67648, '\p{Script=:\Acypriot\z:}', "");;
    Expect(1, 67647, '\p{Script=_cypriot}', "");
    Expect(0, 67647, '\p{^Script=_cypriot}', "");
    Expect(0, 67647, '\P{Script=_cypriot}', "");
    Expect(1, 67647, '\P{^Script=_cypriot}', "");
    Expect(0, 67648, '\p{Script=_cypriot}', "");
    Expect(1, 67648, '\p{^Script=_cypriot}', "");
    Expect(1, 67648, '\P{Script=_cypriot}', "");
    Expect(0, 67648, '\P{^Script=_cypriot}', "");
    Error('\p{Sc=	_cprt:=}');
    Error('\P{Sc=	_cprt:=}');
    Expect(1, 67647, '\p{Sc=:\ACprt\z:}', "");;
    Expect(0, 67648, '\p{Sc=:\ACprt\z:}', "");;
    Expect(1, 67647, '\p{Sc=cprt}', "");
    Expect(0, 67647, '\p{^Sc=cprt}', "");
    Expect(0, 67647, '\P{Sc=cprt}', "");
    Expect(1, 67647, '\P{^Sc=cprt}', "");
    Expect(0, 67648, '\p{Sc=cprt}', "");
    Expect(1, 67648, '\p{^Sc=cprt}', "");
    Expect(1, 67648, '\P{Sc=cprt}', "");
    Expect(0, 67648, '\P{^Sc=cprt}', "");
    Expect(1, 67647, '\p{Sc=:\Acprt\z:}', "");;
    Expect(0, 67648, '\p{Sc=:\Acprt\z:}', "");;
    Expect(1, 67647, '\p{Sc= -CPRT}', "");
    Expect(0, 67647, '\p{^Sc= -CPRT}', "");
    Expect(0, 67647, '\P{Sc= -CPRT}', "");
    Expect(1, 67647, '\P{^Sc= -CPRT}', "");
    Expect(0, 67648, '\p{Sc= -CPRT}', "");
    Expect(1, 67648, '\p{^Sc= -CPRT}', "");
    Expect(1, 67648, '\P{Sc= -CPRT}', "");
    Expect(0, 67648, '\P{^Sc= -CPRT}', "");
    Error('\p{Is_Script=/a/Cypriot}');
    Error('\P{Is_Script=/a/Cypriot}');
    Expect(1, 67647, '\p{Is_Script:   cypriot}', "");
    Expect(0, 67647, '\p{^Is_Script:   cypriot}', "");
    Expect(0, 67647, '\P{Is_Script:   cypriot}', "");
    Expect(1, 67647, '\P{^Is_Script:   cypriot}', "");
    Expect(0, 67648, '\p{Is_Script:   cypriot}', "");
    Expect(1, 67648, '\p{^Is_Script:   cypriot}', "");
    Expect(1, 67648, '\P{Is_Script:   cypriot}', "");
    Expect(0, 67648, '\P{^Is_Script:   cypriot}', "");
    Expect(1, 67647, '\p{Is_Script=__Cypriot}', "");
    Expect(0, 67647, '\p{^Is_Script=__Cypriot}', "");
    Expect(0, 67647, '\P{Is_Script=__Cypriot}', "");
    Expect(1, 67647, '\P{^Is_Script=__Cypriot}', "");
    Expect(0, 67648, '\p{Is_Script=__Cypriot}', "");
    Expect(1, 67648, '\p{^Is_Script=__Cypriot}', "");
    Expect(1, 67648, '\P{Is_Script=__Cypriot}', "");
    Expect(0, 67648, '\P{^Is_Script=__Cypriot}', "");
    Error('\p{Is_Sc=_:=cprt}');
    Error('\P{Is_Sc=_:=cprt}');
    Expect(1, 67647, '\p{Is_Sc=cprt}', "");
    Expect(0, 67647, '\p{^Is_Sc=cprt}', "");
    Expect(0, 67647, '\P{Is_Sc=cprt}', "");
    Expect(1, 67647, '\P{^Is_Sc=cprt}', "");
    Expect(0, 67648, '\p{Is_Sc=cprt}', "");
    Expect(1, 67648, '\p{^Is_Sc=cprt}', "");
    Expect(1, 67648, '\P{Is_Sc=cprt}', "");
    Expect(0, 67648, '\P{^Is_Sc=cprt}', "");
    Expect(1, 67647, '\p{Is_Sc=- Cprt}', "");
    Expect(0, 67647, '\p{^Is_Sc=- Cprt}', "");
    Expect(0, 67647, '\P{Is_Sc=- Cprt}', "");
    Expect(1, 67647, '\P{^Is_Sc=- Cprt}', "");
    Expect(0, 67648, '\p{Is_Sc=- Cprt}', "");
    Expect(1, 67648, '\p{^Is_Sc=- Cprt}', "");
    Expect(1, 67648, '\P{Is_Sc=- Cprt}', "");
    Expect(0, 67648, '\P{^Is_Sc=- Cprt}', "");
    Error('\p{Script: :=Cyrillic}');
    Error('\P{Script: :=Cyrillic}');
    Expect(1, 65071, '\p{Script=:\ACyrillic\z:}', "");;
    Expect(0, 65072, '\p{Script=:\ACyrillic\z:}', "");;
    Expect(1, 65071, '\p{Script=cyrillic}', "");
    Expect(0, 65071, '\p{^Script=cyrillic}', "");
    Expect(0, 65071, '\P{Script=cyrillic}', "");
    Expect(1, 65071, '\P{^Script=cyrillic}', "");
    Expect(0, 65072, '\p{Script=cyrillic}', "");
    Expect(1, 65072, '\p{^Script=cyrillic}', "");
    Expect(1, 65072, '\P{Script=cyrillic}', "");
    Expect(0, 65072, '\P{^Script=cyrillic}', "");
    Expect(1, 65071, '\p{Script=:\Acyrillic\z:}', "");;
    Expect(0, 65072, '\p{Script=:\Acyrillic\z:}', "");;
    Expect(1, 65071, '\p{Script=-_Cyrillic}', "");
    Expect(0, 65071, '\p{^Script=-_Cyrillic}', "");
    Expect(0, 65071, '\P{Script=-_Cyrillic}', "");
    Expect(1, 65071, '\P{^Script=-_Cyrillic}', "");
    Expect(0, 65072, '\p{Script=-_Cyrillic}', "");
    Expect(1, 65072, '\p{^Script=-_Cyrillic}', "");
    Expect(1, 65072, '\P{Script=-_Cyrillic}', "");
    Expect(0, 65072, '\P{^Script=-_Cyrillic}', "");
    Error('\p{Sc= _Cyrl:=}');
    Error('\P{Sc= _Cyrl:=}');
    Expect(1, 65071, '\p{Sc=:\ACyrl\z:}', "");;
    Expect(0, 65072, '\p{Sc=:\ACyrl\z:}', "");;
    Expect(1, 65071, '\p{Sc=cyrl}', "");
    Expect(0, 65071, '\p{^Sc=cyrl}', "");
    Expect(0, 65071, '\P{Sc=cyrl}', "");
    Expect(1, 65071, '\P{^Sc=cyrl}', "");
    Expect(0, 65072, '\p{Sc=cyrl}', "");
    Expect(1, 65072, '\p{^Sc=cyrl}', "");
    Expect(1, 65072, '\P{Sc=cyrl}', "");
    Expect(0, 65072, '\P{^Sc=cyrl}', "");
    Expect(1, 65071, '\p{Sc=:\Acyrl\z:}', "");;
    Expect(0, 65072, '\p{Sc=:\Acyrl\z:}', "");;
    Expect(1, 65071, '\p{Sc=		CYRL}', "");
    Expect(0, 65071, '\p{^Sc=		CYRL}', "");
    Expect(0, 65071, '\P{Sc=		CYRL}', "");
    Expect(1, 65071, '\P{^Sc=		CYRL}', "");
    Expect(0, 65072, '\p{Sc=		CYRL}', "");
    Expect(1, 65072, '\p{^Sc=		CYRL}', "");
    Expect(1, 65072, '\P{Sc=		CYRL}', "");
    Expect(0, 65072, '\P{^Sc=		CYRL}', "");
    Error('\p{Is_Script= _CYRILLIC:=}');
    Error('\P{Is_Script= _CYRILLIC:=}');
    Expect(1, 65071, '\p{Is_Script:   cyrillic}', "");
    Expect(0, 65071, '\p{^Is_Script:   cyrillic}', "");
    Expect(0, 65071, '\P{Is_Script:   cyrillic}', "");
    Expect(1, 65071, '\P{^Is_Script:   cyrillic}', "");
    Expect(0, 65072, '\p{Is_Script:   cyrillic}', "");
    Expect(1, 65072, '\p{^Is_Script:   cyrillic}', "");
    Expect(1, 65072, '\P{Is_Script:   cyrillic}', "");
    Expect(0, 65072, '\P{^Is_Script:   cyrillic}', "");
    Expect(1, 65071, '\p{Is_Script= -Cyrillic}', "");
    Expect(0, 65071, '\p{^Is_Script= -Cyrillic}', "");
    Expect(0, 65071, '\P{Is_Script= -Cyrillic}', "");
    Expect(1, 65071, '\P{^Is_Script= -Cyrillic}', "");
    Expect(0, 65072, '\p{Is_Script= -Cyrillic}', "");
    Expect(1, 65072, '\p{^Is_Script= -Cyrillic}', "");
    Expect(1, 65072, '\P{Is_Script= -Cyrillic}', "");
    Expect(0, 65072, '\P{^Is_Script= -Cyrillic}', "");
    Error('\p{Is_Sc=	-Cyrl:=}');
    Error('\P{Is_Sc=	-Cyrl:=}');
    Expect(1, 65071, '\p{Is_Sc: cyrl}', "");
    Expect(0, 65071, '\p{^Is_Sc: cyrl}', "");
    Expect(0, 65071, '\P{Is_Sc: cyrl}', "");
    Expect(1, 65071, '\P{^Is_Sc: cyrl}', "");
    Expect(0, 65072, '\p{Is_Sc: cyrl}', "");
    Expect(1, 65072, '\p{^Is_Sc: cyrl}', "");
    Expect(1, 65072, '\P{Is_Sc: cyrl}', "");
    Expect(0, 65072, '\P{^Is_Sc: cyrl}', "");
    Expect(1, 65071, '\p{Is_Sc=_Cyrl}', "");
    Expect(0, 65071, '\p{^Is_Sc=_Cyrl}', "");
    Expect(0, 65071, '\P{Is_Sc=_Cyrl}', "");
    Expect(1, 65071, '\P{^Is_Sc=_Cyrl}', "");
    Expect(0, 65072, '\p{Is_Sc=_Cyrl}', "");
    Expect(1, 65072, '\p{^Is_Sc=_Cyrl}', "");
    Expect(1, 65072, '\P{Is_Sc=_Cyrl}', "");
    Expect(0, 65072, '\P{^Is_Sc=_Cyrl}', "");
    Error('\p{Script=/a/_	Devanagari}');
    Error('\P{Script=/a/_	Devanagari}');
    Expect(1, 43263, '\p{Script=:\ADevanagari\z:}', "");;
    Expect(0, 43264, '\p{Script=:\ADevanagari\z:}', "");;
    Expect(1, 43263, '\p{Script=devanagari}', "");
    Expect(0, 43263, '\p{^Script=devanagari}', "");
    Expect(0, 43263, '\P{Script=devanagari}', "");
    Expect(1, 43263, '\P{^Script=devanagari}', "");
    Expect(0, 43264, '\p{Script=devanagari}', "");
    Expect(1, 43264, '\p{^Script=devanagari}', "");
    Expect(1, 43264, '\P{Script=devanagari}', "");
    Expect(0, 43264, '\P{^Script=devanagari}', "");
    Expect(1, 43263, '\p{Script=:\Adevanagari\z:}', "");;
    Expect(0, 43264, '\p{Script=:\Adevanagari\z:}', "");;
    Expect(1, 43263, '\p{Script=	 Devanagari}', "");
    Expect(0, 43263, '\p{^Script=	 Devanagari}', "");
    Expect(0, 43263, '\P{Script=	 Devanagari}', "");
    Expect(1, 43263, '\P{^Script=	 Devanagari}', "");
    Expect(0, 43264, '\p{Script=	 Devanagari}', "");
    Expect(1, 43264, '\p{^Script=	 Devanagari}', "");
    Expect(1, 43264, '\P{Script=	 Devanagari}', "");
    Expect(0, 43264, '\P{^Script=	 Devanagari}', "");
    Error('\p{Sc=-Deva:=}');
    Error('\P{Sc=-Deva:=}');
    Expect(1, 43263, '\p{Sc=:\ADeva\z:}', "");;
    Expect(0, 43264, '\p{Sc=:\ADeva\z:}', "");;
    Expect(1, 43263, '\p{Sc=deva}', "");
    Expect(0, 43263, '\p{^Sc=deva}', "");
    Expect(0, 43263, '\P{Sc=deva}', "");
    Expect(1, 43263, '\P{^Sc=deva}', "");
    Expect(0, 43264, '\p{Sc=deva}', "");
    Expect(1, 43264, '\p{^Sc=deva}', "");
    Expect(1, 43264, '\P{Sc=deva}', "");
    Expect(0, 43264, '\P{^Sc=deva}', "");
    Expect(1, 43263, '\p{Sc=:\Adeva\z:}', "");;
    Expect(0, 43264, '\p{Sc=:\Adeva\z:}', "");;
    Expect(1, 43263, '\p{Sc=--DEVA}', "");
    Expect(0, 43263, '\p{^Sc=--DEVA}', "");
    Expect(0, 43263, '\P{Sc=--DEVA}', "");
    Expect(1, 43263, '\P{^Sc=--DEVA}', "");
    Expect(0, 43264, '\p{Sc=--DEVA}', "");
    Expect(1, 43264, '\p{^Sc=--DEVA}', "");
    Expect(1, 43264, '\P{Sc=--DEVA}', "");
    Expect(0, 43264, '\P{^Sc=--DEVA}', "");
    Error('\p{Is_Script=	-devanagari:=}');
    Error('\P{Is_Script=	-devanagari:=}');
    Expect(1, 43263, '\p{Is_Script=devanagari}', "");
    Expect(0, 43263, '\p{^Is_Script=devanagari}', "");
    Expect(0, 43263, '\P{Is_Script=devanagari}', "");
    Expect(1, 43263, '\P{^Is_Script=devanagari}', "");
    Expect(0, 43264, '\p{Is_Script=devanagari}', "");
    Expect(1, 43264, '\p{^Is_Script=devanagari}', "");
    Expect(1, 43264, '\P{Is_Script=devanagari}', "");
    Expect(0, 43264, '\P{^Is_Script=devanagari}', "");
    Expect(1, 43263, '\p{Is_Script: 	-Devanagari}', "");
    Expect(0, 43263, '\p{^Is_Script: 	-Devanagari}', "");
    Expect(0, 43263, '\P{Is_Script: 	-Devanagari}', "");
    Expect(1, 43263, '\P{^Is_Script: 	-Devanagari}', "");
    Expect(0, 43264, '\p{Is_Script: 	-Devanagari}', "");
    Expect(1, 43264, '\p{^Is_Script: 	-Devanagari}', "");
    Expect(1, 43264, '\P{Is_Script: 	-Devanagari}', "");
    Expect(0, 43264, '\P{^Is_Script: 	-Devanagari}', "");
    Error('\p{Is_Sc=_ DEVA/a/}');
    Error('\P{Is_Sc=_ DEVA/a/}');
    Expect(1, 43263, '\p{Is_Sc=deva}', "");
    Expect(0, 43263, '\p{^Is_Sc=deva}', "");
    Expect(0, 43263, '\P{Is_Sc=deva}', "");
    Expect(1, 43263, '\P{^Is_Sc=deva}', "");
    Expect(0, 43264, '\p{Is_Sc=deva}', "");
    Expect(1, 43264, '\p{^Is_Sc=deva}', "");
    Expect(1, 43264, '\P{Is_Sc=deva}', "");
    Expect(0, 43264, '\P{^Is_Sc=deva}', "");
    Expect(1, 43263, '\p{Is_Sc=-deva}', "");
    Expect(0, 43263, '\p{^Is_Sc=-deva}', "");
    Expect(0, 43263, '\P{Is_Sc=-deva}', "");
    Expect(1, 43263, '\P{^Is_Sc=-deva}', "");
    Expect(0, 43264, '\p{Is_Sc=-deva}', "");
    Expect(1, 43264, '\p{^Is_Sc=-deva}', "");
    Expect(1, 43264, '\P{Is_Sc=-deva}', "");
    Expect(0, 43264, '\P{^Is_Sc=-deva}', "");
    Error('\p{Script=-_dives_akuru:=}');
    Error('\P{Script=-_dives_akuru:=}');
    Expect(1, 72025, '\p{Script=:\ADives_Akuru\z:}', "");;
    Expect(0, 72026, '\p{Script=:\ADives_Akuru\z:}', "");;
    Expect(1, 72025, '\p{Script=divesakuru}', "");
    Expect(0, 72025, '\p{^Script=divesakuru}', "");
    Expect(0, 72025, '\P{Script=divesakuru}', "");
    Expect(1, 72025, '\P{^Script=divesakuru}', "");
    Expect(0, 72026, '\p{Script=divesakuru}', "");
    Expect(1, 72026, '\p{^Script=divesakuru}', "");
    Expect(1, 72026, '\P{Script=divesakuru}', "");
    Expect(0, 72026, '\P{^Script=divesakuru}', "");
    Expect(1, 72025, '\p{Script=:\Adivesakuru\z:}', "");;
    Expect(0, 72026, '\p{Script=:\Adivesakuru\z:}', "");;
    Expect(1, 72025, '\p{Script=_DIVES_akuru}', "");
    Expect(0, 72025, '\p{^Script=_DIVES_akuru}', "");
    Expect(0, 72025, '\P{Script=_DIVES_akuru}', "");
    Expect(1, 72025, '\P{^Script=_DIVES_akuru}', "");
    Expect(0, 72026, '\p{Script=_DIVES_akuru}', "");
    Expect(1, 72026, '\p{^Script=_DIVES_akuru}', "");
    Expect(1, 72026, '\P{Script=_DIVES_akuru}', "");
    Expect(0, 72026, '\P{^Script=_DIVES_akuru}', "");
    Error('\p{Sc= /a/Diak}');
    Error('\P{Sc= /a/Diak}');
    Expect(1, 72025, '\p{Sc=:\ADiak\z:}', "");;
    Expect(0, 72026, '\p{Sc=:\ADiak\z:}', "");;
    Expect(1, 72025, '\p{Sc=diak}', "");
    Expect(0, 72025, '\p{^Sc=diak}', "");
    Expect(0, 72025, '\P{Sc=diak}', "");
    Expect(1, 72025, '\P{^Sc=diak}', "");
    Expect(0, 72026, '\p{Sc=diak}', "");
    Expect(1, 72026, '\p{^Sc=diak}', "");
    Expect(1, 72026, '\P{Sc=diak}', "");
    Expect(0, 72026, '\P{^Sc=diak}', "");
    Expect(1, 72025, '\p{Sc=:\Adiak\z:}', "");;
    Expect(0, 72026, '\p{Sc=:\Adiak\z:}', "");;
    Expect(1, 72025, '\p{Sc= 	Diak}', "");
    Expect(0, 72025, '\p{^Sc= 	Diak}', "");
    Expect(0, 72025, '\P{Sc= 	Diak}', "");
    Expect(1, 72025, '\P{^Sc= 	Diak}', "");
    Expect(0, 72026, '\p{Sc= 	Diak}', "");
    Expect(1, 72026, '\p{^Sc= 	Diak}', "");
    Expect(1, 72026, '\P{Sc= 	Diak}', "");
    Expect(0, 72026, '\P{^Sc= 	Diak}', "");
    Error('\p{Is_Script=-/a/DIVES_AKURU}');
    Error('\P{Is_Script=-/a/DIVES_AKURU}');
    Expect(1, 72025, '\p{Is_Script=divesakuru}', "");
    Expect(0, 72025, '\p{^Is_Script=divesakuru}', "");
    Expect(0, 72025, '\P{Is_Script=divesakuru}', "");
    Expect(1, 72025, '\P{^Is_Script=divesakuru}', "");
    Expect(0, 72026, '\p{Is_Script=divesakuru}', "");
    Expect(1, 72026, '\p{^Is_Script=divesakuru}', "");
    Expect(1, 72026, '\P{Is_Script=divesakuru}', "");
    Expect(0, 72026, '\P{^Is_Script=divesakuru}', "");
    Expect(1, 72025, '\p{Is_Script=		Dives_Akuru}', "");
    Expect(0, 72025, '\p{^Is_Script=		Dives_Akuru}', "");
    Expect(0, 72025, '\P{Is_Script=		Dives_Akuru}', "");
    Expect(1, 72025, '\P{^Is_Script=		Dives_Akuru}', "");
    Expect(0, 72026, '\p{Is_Script=		Dives_Akuru}', "");
    Expect(1, 72026, '\p{^Is_Script=		Dives_Akuru}', "");
    Expect(1, 72026, '\P{Is_Script=		Dives_Akuru}', "");
    Expect(0, 72026, '\P{^Is_Script=		Dives_Akuru}', "");
    Error('\p{Is_Sc= 	diak:=}');
    Error('\P{Is_Sc= 	diak:=}');
    Expect(1, 72025, '\p{Is_Sc=diak}', "");
    Expect(0, 72025, '\p{^Is_Sc=diak}', "");
    Expect(0, 72025, '\P{Is_Sc=diak}', "");
    Expect(1, 72025, '\P{^Is_Sc=diak}', "");
    Expect(0, 72026, '\p{Is_Sc=diak}', "");
    Expect(1, 72026, '\p{^Is_Sc=diak}', "");
    Expect(1, 72026, '\P{Is_Sc=diak}', "");
    Expect(0, 72026, '\P{^Is_Sc=diak}', "");
    Expect(1, 72025, '\p{Is_Sc=DIAK}', "");
    Expect(0, 72025, '\p{^Is_Sc=DIAK}', "");
    Expect(0, 72025, '\P{Is_Sc=DIAK}', "");
    Expect(1, 72025, '\P{^Is_Sc=DIAK}', "");
    Expect(0, 72026, '\p{Is_Sc=DIAK}', "");
    Expect(1, 72026, '\p{^Is_Sc=DIAK}', "");
    Expect(1, 72026, '\P{Is_Sc=DIAK}', "");
    Expect(0, 72026, '\P{^Is_Sc=DIAK}', "");
    Error('\p{Script:   :=-	dogra}');
    Error('\P{Script:   :=-	dogra}');
    Expect(1, 71739, '\p{Script=:\ADogra\z:}', "");;
    Expect(0, 71740, '\p{Script=:\ADogra\z:}', "");;
    Expect(1, 71739, '\p{Script=dogra}', "");
    Expect(0, 71739, '\p{^Script=dogra}', "");
    Expect(0, 71739, '\P{Script=dogra}', "");
    Expect(1, 71739, '\P{^Script=dogra}', "");
    Expect(0, 71740, '\p{Script=dogra}', "");
    Expect(1, 71740, '\p{^Script=dogra}', "");
    Expect(1, 71740, '\P{Script=dogra}', "");
    Expect(0, 71740, '\P{^Script=dogra}', "");
    Expect(1, 71739, '\p{Script=:\Adogra\z:}', "");;
    Expect(0, 71740, '\p{Script=:\Adogra\z:}', "");;
    Expect(1, 71739, '\p{Script= Dogra}', "");
    Expect(0, 71739, '\p{^Script= Dogra}', "");
    Expect(0, 71739, '\P{Script= Dogra}', "");
    Expect(1, 71739, '\P{^Script= Dogra}', "");
    Expect(0, 71740, '\p{Script= Dogra}', "");
    Expect(1, 71740, '\p{^Script= Dogra}', "");
    Expect(1, 71740, '\P{Script= Dogra}', "");
    Expect(0, 71740, '\P{^Script= Dogra}', "");
    Error('\p{Sc=_/a/Dogr}');
    Error('\P{Sc=_/a/Dogr}');
    Expect(1, 71739, '\p{Sc=:\ADogr\z:}', "");;
    Expect(0, 71740, '\p{Sc=:\ADogr\z:}', "");;
    Expect(1, 71739, '\p{Sc=dogr}', "");
    Expect(0, 71739, '\p{^Sc=dogr}', "");
    Expect(0, 71739, '\P{Sc=dogr}', "");
    Expect(1, 71739, '\P{^Sc=dogr}', "");
    Expect(0, 71740, '\p{Sc=dogr}', "");
    Expect(1, 71740, '\p{^Sc=dogr}', "");
    Expect(1, 71740, '\P{Sc=dogr}', "");
    Expect(0, 71740, '\P{^Sc=dogr}', "");
    Expect(1, 71739, '\p{Sc=:\Adogr\z:}', "");;
    Expect(0, 71740, '\p{Sc=:\Adogr\z:}', "");;
    Expect(1, 71739, '\p{Sc=Dogr}', "");
    Expect(0, 71739, '\p{^Sc=Dogr}', "");
    Expect(0, 71739, '\P{Sc=Dogr}', "");
    Expect(1, 71739, '\P{^Sc=Dogr}', "");
    Expect(0, 71740, '\p{Sc=Dogr}', "");
    Expect(1, 71740, '\p{^Sc=Dogr}', "");
    Expect(1, 71740, '\P{Sc=Dogr}', "");
    Expect(0, 71740, '\P{^Sc=Dogr}', "");
    Error('\p{Is_Script=:=Dogra}');
    Error('\P{Is_Script=:=Dogra}');
    Expect(1, 71739, '\p{Is_Script=dogra}', "");
    Expect(0, 71739, '\p{^Is_Script=dogra}', "");
    Expect(0, 71739, '\P{Is_Script=dogra}', "");
    Expect(1, 71739, '\P{^Is_Script=dogra}', "");
    Expect(0, 71740, '\p{Is_Script=dogra}', "");
    Expect(1, 71740, '\p{^Is_Script=dogra}', "");
    Expect(1, 71740, '\P{Is_Script=dogra}', "");
    Expect(0, 71740, '\P{^Is_Script=dogra}', "");
    Error('\p{Is_Sc=:= -dogr}');
    Error('\P{Is_Sc=:= -dogr}');
    Expect(1, 71739, '\p{Is_Sc:	dogr}', "");
    Expect(0, 71739, '\p{^Is_Sc:	dogr}', "");
    Expect(0, 71739, '\P{Is_Sc:	dogr}', "");
    Expect(1, 71739, '\P{^Is_Sc:	dogr}', "");
    Expect(0, 71740, '\p{Is_Sc:	dogr}', "");
    Expect(1, 71740, '\p{^Is_Sc:	dogr}', "");
    Expect(1, 71740, '\P{Is_Sc:	dogr}', "");
    Expect(0, 71740, '\P{^Is_Sc:	dogr}', "");
    Expect(1, 71739, '\p{Is_Sc=  Dogr}', "");
    Expect(0, 71739, '\p{^Is_Sc=  Dogr}', "");
    Expect(0, 71739, '\P{Is_Sc=  Dogr}', "");
    Expect(1, 71739, '\P{^Is_Sc=  Dogr}', "");
    Expect(0, 71740, '\p{Is_Sc=  Dogr}', "");
    Expect(1, 71740, '\p{^Is_Sc=  Dogr}', "");
    Expect(1, 71740, '\P{Is_Sc=  Dogr}', "");
    Expect(0, 71740, '\P{^Is_Sc=  Dogr}', "");
    Error('\p{Script=Deseret:=}');
    Error('\P{Script=Deseret:=}');
    Expect(1, 66639, '\p{Script=:\ADeseret\z:}', "");;
    Expect(0, 66640, '\p{Script=:\ADeseret\z:}', "");;
    Expect(1, 66639, '\p{Script: deseret}', "");
    Expect(0, 66639, '\p{^Script: deseret}', "");
    Expect(0, 66639, '\P{Script: deseret}', "");
    Expect(1, 66639, '\P{^Script: deseret}', "");
    Expect(0, 66640, '\p{Script: deseret}', "");
    Expect(1, 66640, '\p{^Script: deseret}', "");
    Expect(1, 66640, '\P{Script: deseret}', "");
    Expect(0, 66640, '\P{^Script: deseret}', "");
    Expect(1, 66639, '\p{Script=:\Adeseret\z:}', "");;
    Expect(0, 66640, '\p{Script=:\Adeseret\z:}', "");;
    Expect(1, 66639, '\p{Script= deseret}', "");
    Expect(0, 66639, '\p{^Script= deseret}', "");
    Expect(0, 66639, '\P{Script= deseret}', "");
    Expect(1, 66639, '\P{^Script= deseret}', "");
    Expect(0, 66640, '\p{Script= deseret}', "");
    Expect(1, 66640, '\p{^Script= deseret}', "");
    Expect(1, 66640, '\P{Script= deseret}', "");
    Expect(0, 66640, '\P{^Script= deseret}', "");
    Error('\p{Sc=	/a/Dsrt}');
    Error('\P{Sc=	/a/Dsrt}');
    Expect(1, 66639, '\p{Sc=:\ADsrt\z:}', "");;
    Expect(0, 66640, '\p{Sc=:\ADsrt\z:}', "");;
    Expect(1, 66639, '\p{Sc:dsrt}', "");
    Expect(0, 66639, '\p{^Sc:dsrt}', "");
    Expect(0, 66639, '\P{Sc:dsrt}', "");
    Expect(1, 66639, '\P{^Sc:dsrt}', "");
    Expect(0, 66640, '\p{Sc:dsrt}', "");
    Expect(1, 66640, '\p{^Sc:dsrt}', "");
    Expect(1, 66640, '\P{Sc:dsrt}', "");
    Expect(0, 66640, '\P{^Sc:dsrt}', "");
    Expect(1, 66639, '\p{Sc=:\Adsrt\z:}', "");;
    Expect(0, 66640, '\p{Sc=:\Adsrt\z:}', "");;
    Expect(1, 66639, '\p{Sc=		Dsrt}', "");
    Expect(0, 66639, '\p{^Sc=		Dsrt}', "");
    Expect(0, 66639, '\P{Sc=		Dsrt}', "");
    Expect(1, 66639, '\P{^Sc=		Dsrt}', "");
    Expect(0, 66640, '\p{Sc=		Dsrt}', "");
    Expect(1, 66640, '\p{^Sc=		Dsrt}', "");
    Expect(1, 66640, '\P{Sc=		Dsrt}', "");
    Expect(0, 66640, '\P{^Sc=		Dsrt}', "");
    Error('\p{Is_Script:	:=Deseret}');
    Error('\P{Is_Script:	:=Deseret}');
    Expect(1, 66639, '\p{Is_Script=deseret}', "");
    Expect(0, 66639, '\p{^Is_Script=deseret}', "");
    Expect(0, 66639, '\P{Is_Script=deseret}', "");
    Expect(1, 66639, '\P{^Is_Script=deseret}', "");
    Expect(0, 66640, '\p{Is_Script=deseret}', "");
    Expect(1, 66640, '\p{^Is_Script=deseret}', "");
    Expect(1, 66640, '\P{Is_Script=deseret}', "");
    Expect(0, 66640, '\P{^Is_Script=deseret}', "");
    Expect(1, 66639, '\p{Is_Script=__Deseret}', "");
    Expect(0, 66639, '\p{^Is_Script=__Deseret}', "");
    Expect(0, 66639, '\P{Is_Script=__Deseret}', "");
    Expect(1, 66639, '\P{^Is_Script=__Deseret}', "");
    Expect(0, 66640, '\p{Is_Script=__Deseret}', "");
    Expect(1, 66640, '\p{^Is_Script=__Deseret}', "");
    Expect(1, 66640, '\P{Is_Script=__Deseret}', "");
    Expect(0, 66640, '\P{^Is_Script=__Deseret}', "");
    Error('\p{Is_Sc=-	dsrt:=}');
    Error('\P{Is_Sc=-	dsrt:=}');
    Expect(1, 66639, '\p{Is_Sc=dsrt}', "");
    Expect(0, 66639, '\p{^Is_Sc=dsrt}', "");
    Expect(0, 66639, '\P{Is_Sc=dsrt}', "");
    Expect(1, 66639, '\P{^Is_Sc=dsrt}', "");
    Expect(0, 66640, '\p{Is_Sc=dsrt}', "");
    Expect(1, 66640, '\p{^Is_Sc=dsrt}', "");
    Expect(1, 66640, '\P{Is_Sc=dsrt}', "");
    Expect(0, 66640, '\P{^Is_Sc=dsrt}', "");
    Expect(1, 66639, '\p{Is_Sc= DSRT}', "");
    Expect(0, 66639, '\p{^Is_Sc= DSRT}', "");
    Expect(0, 66639, '\P{Is_Sc= DSRT}', "");
    Expect(1, 66639, '\P{^Is_Sc= DSRT}', "");
    Expect(0, 66640, '\p{Is_Sc= DSRT}', "");
    Expect(1, 66640, '\p{^Is_Sc= DSRT}', "");
    Expect(1, 66640, '\P{Is_Sc= DSRT}', "");
    Expect(0, 66640, '\P{^Is_Sc= DSRT}', "");
    Error('\p{Script=-/a/Duployan}');
    Error('\P{Script=-/a/Duployan}');
    Expect(1, 113823, '\p{Script=:\ADuployan\z:}', "");;
    Expect(0, 113824, '\p{Script=:\ADuployan\z:}', "");;
    Expect(1, 113823, '\p{Script=duployan}', "");
    Expect(0, 113823, '\p{^Script=duployan}', "");
    Expect(0, 113823, '\P{Script=duployan}', "");
    Expect(1, 113823, '\P{^Script=duployan}', "");
    Expect(0, 113824, '\p{Script=duployan}', "");
    Expect(1, 113824, '\p{^Script=duployan}', "");
    Expect(1, 113824, '\P{Script=duployan}', "");
    Expect(0, 113824, '\P{^Script=duployan}', "");
    Expect(1, 113823, '\p{Script=:\Aduployan\z:}', "");;
    Expect(0, 113824, '\p{Script=:\Aduployan\z:}', "");;
    Expect(1, 113823, '\p{Script= Duployan}', "");
    Expect(0, 113823, '\p{^Script= Duployan}', "");
    Expect(0, 113823, '\P{Script= Duployan}', "");
    Expect(1, 113823, '\P{^Script= Duployan}', "");
    Expect(0, 113824, '\p{Script= Duployan}', "");
    Expect(1, 113824, '\p{^Script= Duployan}', "");
    Expect(1, 113824, '\P{Script= Duployan}', "");
    Expect(0, 113824, '\P{^Script= Duployan}', "");
    Error('\p{Sc=  DUPL:=}');
    Error('\P{Sc=  DUPL:=}');
    Expect(1, 113823, '\p{Sc=:\ADupl\z:}', "");;
    Expect(0, 113824, '\p{Sc=:\ADupl\z:}', "");;
    Expect(1, 113823, '\p{Sc: dupl}', "");
    Expect(0, 113823, '\p{^Sc: dupl}', "");
    Expect(0, 113823, '\P{Sc: dupl}', "");
    Expect(1, 113823, '\P{^Sc: dupl}', "");
    Expect(0, 113824, '\p{Sc: dupl}', "");
    Expect(1, 113824, '\p{^Sc: dupl}', "");
    Expect(1, 113824, '\P{Sc: dupl}', "");
    Expect(0, 113824, '\P{^Sc: dupl}', "");
    Expect(1, 113823, '\p{Sc=:\Adupl\z:}', "");;
    Expect(0, 113824, '\p{Sc=:\Adupl\z:}', "");;
    Expect(1, 113823, '\p{Sc=_	DUPL}', "");
    Expect(0, 113823, '\p{^Sc=_	DUPL}', "");
    Expect(0, 113823, '\P{Sc=_	DUPL}', "");
    Expect(1, 113823, '\P{^Sc=_	DUPL}', "");
    Expect(0, 113824, '\p{Sc=_	DUPL}', "");
    Expect(1, 113824, '\p{^Sc=_	DUPL}', "");
    Expect(1, 113824, '\P{Sc=_	DUPL}', "");
    Expect(0, 113824, '\P{^Sc=_	DUPL}', "");
    Error('\p{Is_Script=/a/- duployan}');
    Error('\P{Is_Script=/a/- duployan}');
    Expect(1, 113823, '\p{Is_Script=duployan}', "");
    Expect(0, 113823, '\p{^Is_Script=duployan}', "");
    Expect(0, 113823, '\P{Is_Script=duployan}', "");
    Expect(1, 113823, '\P{^Is_Script=duployan}', "");
    Expect(0, 113824, '\p{Is_Script=duployan}', "");
    Expect(1, 113824, '\p{^Is_Script=duployan}', "");
    Expect(1, 113824, '\P{Is_Script=duployan}', "");
    Expect(0, 113824, '\P{^Is_Script=duployan}', "");
    Expect(1, 113823, '\p{Is_Script=		DUPLOYAN}', "");
    Expect(0, 113823, '\p{^Is_Script=		DUPLOYAN}', "");
    Expect(0, 113823, '\P{Is_Script=		DUPLOYAN}', "");
    Expect(1, 113823, '\P{^Is_Script=		DUPLOYAN}', "");
    Expect(0, 113824, '\p{Is_Script=		DUPLOYAN}', "");
    Expect(1, 113824, '\p{^Is_Script=		DUPLOYAN}', "");
    Expect(1, 113824, '\P{Is_Script=		DUPLOYAN}', "");
    Expect(0, 113824, '\P{^Is_Script=		DUPLOYAN}', "");
    Error('\p{Is_Sc=	/a/Dupl}');
    Error('\P{Is_Sc=	/a/Dupl}');
    Expect(1, 113823, '\p{Is_Sc:dupl}', "");
    Expect(0, 113823, '\p{^Is_Sc:dupl}', "");
    Expect(0, 113823, '\P{Is_Sc:dupl}', "");
    Expect(1, 113823, '\P{^Is_Sc:dupl}', "");
    Expect(0, 113824, '\p{Is_Sc:dupl}', "");
    Expect(1, 113824, '\p{^Is_Sc:dupl}', "");
    Expect(1, 113824, '\P{Is_Sc:dupl}', "");
    Expect(0, 113824, '\P{^Is_Sc:dupl}', "");
    Expect(1, 113823, '\p{Is_Sc:   -dupl}', "");
    Expect(0, 113823, '\p{^Is_Sc:   -dupl}', "");
    Expect(0, 113823, '\P{Is_Sc:   -dupl}', "");
    Expect(1, 113823, '\P{^Is_Sc:   -dupl}', "");
    Expect(0, 113824, '\p{Is_Sc:   -dupl}', "");
    Expect(1, 113824, '\p{^Is_Sc:   -dupl}', "");
    Expect(1, 113824, '\P{Is_Sc:   -dupl}', "");
    Expect(0, 113824, '\P{^Is_Sc:   -dupl}', "");
    Error('\p{Script=:=_Egyptian_hieroglyphs}');
    Error('\P{Script=:=_Egyptian_hieroglyphs}');
    Expect(1, 78904, '\p{Script=:\AEgyptian_Hieroglyphs\z:}', "");;
    Expect(0, 78905, '\p{Script=:\AEgyptian_Hieroglyphs\z:}', "");;
    Expect(1, 78904, '\p{Script=egyptianhieroglyphs}', "");
    Expect(0, 78904, '\p{^Script=egyptianhieroglyphs}', "");
    Expect(0, 78904, '\P{Script=egyptianhieroglyphs}', "");
    Expect(1, 78904, '\P{^Script=egyptianhieroglyphs}', "");
    Expect(0, 78905, '\p{Script=egyptianhieroglyphs}', "");
    Expect(1, 78905, '\p{^Script=egyptianhieroglyphs}', "");
    Expect(1, 78905, '\P{Script=egyptianhieroglyphs}', "");
    Expect(0, 78905, '\P{^Script=egyptianhieroglyphs}', "");
    Expect(1, 78904, '\p{Script=:\Aegyptianhieroglyphs\z:}', "");;
    Expect(0, 78905, '\p{Script=:\Aegyptianhieroglyphs\z:}', "");;
    Expect(1, 78904, '\p{Script= Egyptian_HIEROGLYPHS}', "");
    Expect(0, 78904, '\p{^Script= Egyptian_HIEROGLYPHS}', "");
    Expect(0, 78904, '\P{Script= Egyptian_HIEROGLYPHS}', "");
    Expect(1, 78904, '\P{^Script= Egyptian_HIEROGLYPHS}', "");
    Expect(0, 78905, '\p{Script= Egyptian_HIEROGLYPHS}', "");
    Expect(1, 78905, '\p{^Script= Egyptian_HIEROGLYPHS}', "");
    Expect(1, 78905, '\P{Script= Egyptian_HIEROGLYPHS}', "");
    Expect(0, 78905, '\P{^Script= Egyptian_HIEROGLYPHS}', "");
    Error('\p{Sc=	-EGYP:=}');
    Error('\P{Sc=	-EGYP:=}');
    Expect(1, 78904, '\p{Sc=:\AEgyp\z:}', "");;
    Expect(0, 78905, '\p{Sc=:\AEgyp\z:}', "");;
    Expect(1, 78904, '\p{Sc:	egyp}', "");
    Expect(0, 78904, '\p{^Sc:	egyp}', "");
    Expect(0, 78904, '\P{Sc:	egyp}', "");
    Expect(1, 78904, '\P{^Sc:	egyp}', "");
    Expect(0, 78905, '\p{Sc:	egyp}', "");
    Expect(1, 78905, '\p{^Sc:	egyp}', "");
    Expect(1, 78905, '\P{Sc:	egyp}', "");
    Expect(0, 78905, '\P{^Sc:	egyp}', "");
    Expect(1, 78904, '\p{Sc=:\Aegyp\z:}', "");;
    Expect(0, 78905, '\p{Sc=:\Aegyp\z:}', "");;
    Expect(1, 78904, '\p{Sc=--Egyp}', "");
    Expect(0, 78904, '\p{^Sc=--Egyp}', "");
    Expect(0, 78904, '\P{Sc=--Egyp}', "");
    Expect(1, 78904, '\P{^Sc=--Egyp}', "");
    Expect(0, 78905, '\p{Sc=--Egyp}', "");
    Expect(1, 78905, '\p{^Sc=--Egyp}', "");
    Expect(1, 78905, '\P{Sc=--Egyp}', "");
    Expect(0, 78905, '\P{^Sc=--Egyp}', "");
    Error('\p{Is_Script=EGYPTIAN_HIEROGLYPHS:=}');
    Error('\P{Is_Script=EGYPTIAN_HIEROGLYPHS:=}');
    Expect(1, 78904, '\p{Is_Script=egyptianhieroglyphs}', "");
    Expect(0, 78904, '\p{^Is_Script=egyptianhieroglyphs}', "");
    Expect(0, 78904, '\P{Is_Script=egyptianhieroglyphs}', "");
    Expect(1, 78904, '\P{^Is_Script=egyptianhieroglyphs}', "");
    Expect(0, 78905, '\p{Is_Script=egyptianhieroglyphs}', "");
    Expect(1, 78905, '\p{^Is_Script=egyptianhieroglyphs}', "");
    Expect(1, 78905, '\P{Is_Script=egyptianhieroglyphs}', "");
    Expect(0, 78905, '\P{^Is_Script=egyptianhieroglyphs}', "");
    Expect(1, 78904, '\p{Is_Script:  _EGYPTIAN_HIEROGLYPHS}', "");
    Expect(0, 78904, '\p{^Is_Script:  _EGYPTIAN_HIEROGLYPHS}', "");
    Expect(0, 78904, '\P{Is_Script:  _EGYPTIAN_HIEROGLYPHS}', "");
    Expect(1, 78904, '\P{^Is_Script:  _EGYPTIAN_HIEROGLYPHS}', "");
    Expect(0, 78905, '\p{Is_Script:  _EGYPTIAN_HIEROGLYPHS}', "");
    Expect(1, 78905, '\p{^Is_Script:  _EGYPTIAN_HIEROGLYPHS}', "");
    Expect(1, 78905, '\P{Is_Script:  _EGYPTIAN_HIEROGLYPHS}', "");
    Expect(0, 78905, '\P{^Is_Script:  _EGYPTIAN_HIEROGLYPHS}', "");
    Error('\p{Is_Sc=_-egyp:=}');
    Error('\P{Is_Sc=_-egyp:=}');
    Expect(1, 78904, '\p{Is_Sc=egyp}', "");
    Expect(0, 78904, '\p{^Is_Sc=egyp}', "");
    Expect(0, 78904, '\P{Is_Sc=egyp}', "");
    Expect(1, 78904, '\P{^Is_Sc=egyp}', "");
    Expect(0, 78905, '\p{Is_Sc=egyp}', "");
    Expect(1, 78905, '\p{^Is_Sc=egyp}', "");
    Expect(1, 78905, '\P{Is_Sc=egyp}', "");
    Expect(0, 78905, '\P{^Is_Sc=egyp}', "");
    Expect(1, 78904, '\p{Is_Sc=	egyp}', "");
    Expect(0, 78904, '\p{^Is_Sc=	egyp}', "");
    Expect(0, 78904, '\P{Is_Sc=	egyp}', "");
    Expect(1, 78904, '\P{^Is_Sc=	egyp}', "");
    Expect(0, 78905, '\p{Is_Sc=	egyp}', "");
    Expect(1, 78905, '\p{^Is_Sc=	egyp}', "");
    Expect(1, 78905, '\P{Is_Sc=	egyp}', "");
    Expect(0, 78905, '\P{^Is_Sc=	egyp}', "");
    Error('\p{Script=/a/-_Elbasan}');
    Error('\P{Script=/a/-_Elbasan}');
    Expect(1, 66855, '\p{Script=:\AElbasan\z:}', "");;
    Expect(0, 66856, '\p{Script=:\AElbasan\z:}', "");;
    Expect(1, 66855, '\p{Script=elbasan}', "");
    Expect(0, 66855, '\p{^Script=elbasan}', "");
    Expect(0, 66855, '\P{Script=elbasan}', "");
    Expect(1, 66855, '\P{^Script=elbasan}', "");
    Expect(0, 66856, '\p{Script=elbasan}', "");
    Expect(1, 66856, '\p{^Script=elbasan}', "");
    Expect(1, 66856, '\P{Script=elbasan}', "");
    Expect(0, 66856, '\P{^Script=elbasan}', "");
    Expect(1, 66855, '\p{Script=:\Aelbasan\z:}', "");;
    Expect(0, 66856, '\p{Script=:\Aelbasan\z:}', "");;
    Expect(1, 66855, '\p{Script=-_ELBASAN}', "");
    Expect(0, 66855, '\p{^Script=-_ELBASAN}', "");
    Expect(0, 66855, '\P{Script=-_ELBASAN}', "");
    Expect(1, 66855, '\P{^Script=-_ELBASAN}', "");
    Expect(0, 66856, '\p{Script=-_ELBASAN}', "");
    Expect(1, 66856, '\p{^Script=-_ELBASAN}', "");
    Expect(1, 66856, '\P{Script=-_ELBASAN}', "");
    Expect(0, 66856, '\P{^Script=-_ELBASAN}', "");
    Error('\p{Sc=/a/		elba}');
    Error('\P{Sc=/a/		elba}');
    Expect(1, 66855, '\p{Sc=:\AElba\z:}', "");;
    Expect(0, 66856, '\p{Sc=:\AElba\z:}', "");;
    Expect(1, 66855, '\p{Sc=elba}', "");
    Expect(0, 66855, '\p{^Sc=elba}', "");
    Expect(0, 66855, '\P{Sc=elba}', "");
    Expect(1, 66855, '\P{^Sc=elba}', "");
    Expect(0, 66856, '\p{Sc=elba}', "");
    Expect(1, 66856, '\p{^Sc=elba}', "");
    Expect(1, 66856, '\P{Sc=elba}', "");
    Expect(0, 66856, '\P{^Sc=elba}', "");
    Expect(1, 66855, '\p{Sc=:\Aelba\z:}', "");;
    Expect(0, 66856, '\p{Sc=:\Aelba\z:}', "");;
    Error('\p{Is_Script=	Elbasan/a/}');
    Error('\P{Is_Script=	Elbasan/a/}');
    Expect(1, 66855, '\p{Is_Script=elbasan}', "");
    Expect(0, 66855, '\p{^Is_Script=elbasan}', "");
    Expect(0, 66855, '\P{Is_Script=elbasan}', "");
    Expect(1, 66855, '\P{^Is_Script=elbasan}', "");
    Expect(0, 66856, '\p{Is_Script=elbasan}', "");
    Expect(1, 66856, '\p{^Is_Script=elbasan}', "");
    Expect(1, 66856, '\P{Is_Script=elbasan}', "");
    Expect(0, 66856, '\P{^Is_Script=elbasan}', "");
    Expect(1, 66855, '\p{Is_Script=-ELBASAN}', "");
    Expect(0, 66855, '\p{^Is_Script=-ELBASAN}', "");
    Expect(0, 66855, '\P{Is_Script=-ELBASAN}', "");
    Expect(1, 66855, '\P{^Is_Script=-ELBASAN}', "");
    Expect(0, 66856, '\p{Is_Script=-ELBASAN}', "");
    Expect(1, 66856, '\p{^Is_Script=-ELBASAN}', "");
    Expect(1, 66856, '\P{Is_Script=-ELBASAN}', "");
    Expect(0, 66856, '\P{^Is_Script=-ELBASAN}', "");
    Error('\p{Is_Sc=:=	elba}');
    Error('\P{Is_Sc=:=	elba}');
    Expect(1, 66855, '\p{Is_Sc=elba}', "");
    Expect(0, 66855, '\p{^Is_Sc=elba}', "");
    Expect(0, 66855, '\P{Is_Sc=elba}', "");
    Expect(1, 66855, '\P{^Is_Sc=elba}', "");
    Expect(0, 66856, '\p{Is_Sc=elba}', "");
    Expect(1, 66856, '\p{^Is_Sc=elba}', "");
    Expect(1, 66856, '\P{Is_Sc=elba}', "");
    Expect(0, 66856, '\P{^Is_Sc=elba}', "");
    Expect(1, 66855, '\p{Is_Sc=	elba}', "");
    Expect(0, 66855, '\p{^Is_Sc=	elba}', "");
    Expect(0, 66855, '\P{Is_Sc=	elba}', "");
    Expect(1, 66855, '\P{^Is_Sc=	elba}', "");
    Expect(0, 66856, '\p{Is_Sc=	elba}', "");
    Expect(1, 66856, '\p{^Is_Sc=	elba}', "");
    Expect(1, 66856, '\P{Is_Sc=	elba}', "");
    Expect(0, 66856, '\P{^Is_Sc=	elba}', "");
    Error('\p{Script=	ELYMAIC/a/}');
    Error('\P{Script=	ELYMAIC/a/}');
    Expect(1, 69622, '\p{Script=:\AElymaic\z:}', "");;
    Expect(0, 69623, '\p{Script=:\AElymaic\z:}', "");;
    Expect(1, 69622, '\p{Script=elymaic}', "");
    Expect(0, 69622, '\p{^Script=elymaic}', "");
    Expect(0, 69622, '\P{Script=elymaic}', "");
    Expect(1, 69622, '\P{^Script=elymaic}', "");
    Expect(0, 69623, '\p{Script=elymaic}', "");
    Expect(1, 69623, '\p{^Script=elymaic}', "");
    Expect(1, 69623, '\P{Script=elymaic}', "");
    Expect(0, 69623, '\P{^Script=elymaic}', "");
    Expect(1, 69622, '\p{Script=:\Aelymaic\z:}', "");;
    Expect(0, 69623, '\p{Script=:\Aelymaic\z:}', "");;
    Expect(1, 69622, '\p{Script= Elymaic}', "");
    Expect(0, 69622, '\p{^Script= Elymaic}', "");
    Expect(0, 69622, '\P{Script= Elymaic}', "");
    Expect(1, 69622, '\P{^Script= Elymaic}', "");
    Expect(0, 69623, '\p{Script= Elymaic}', "");
    Expect(1, 69623, '\p{^Script= Elymaic}', "");
    Expect(1, 69623, '\P{Script= Elymaic}', "");
    Expect(0, 69623, '\P{^Script= Elymaic}', "");
    Error('\p{Sc=_/a/Elym}');
    Error('\P{Sc=_/a/Elym}');
    Expect(1, 69622, '\p{Sc=:\AElym\z:}', "");;
    Expect(0, 69623, '\p{Sc=:\AElym\z:}', "");;
    Expect(1, 69622, '\p{Sc=elym}', "");
    Expect(0, 69622, '\p{^Sc=elym}', "");
    Expect(0, 69622, '\P{Sc=elym}', "");
    Expect(1, 69622, '\P{^Sc=elym}', "");
    Expect(0, 69623, '\p{Sc=elym}', "");
    Expect(1, 69623, '\p{^Sc=elym}', "");
    Expect(1, 69623, '\P{Sc=elym}', "");
    Expect(0, 69623, '\P{^Sc=elym}', "");
    Expect(1, 69622, '\p{Sc=:\Aelym\z:}', "");;
    Expect(0, 69623, '\p{Sc=:\Aelym\z:}', "");;
    Expect(1, 69622, '\p{Sc=	Elym}', "");
    Expect(0, 69622, '\p{^Sc=	Elym}', "");
    Expect(0, 69622, '\P{Sc=	Elym}', "");
    Expect(1, 69622, '\P{^Sc=	Elym}', "");
    Expect(0, 69623, '\p{Sc=	Elym}', "");
    Expect(1, 69623, '\p{^Sc=	Elym}', "");
    Expect(1, 69623, '\P{Sc=	Elym}', "");
    Expect(0, 69623, '\P{^Sc=	Elym}', "");
    Error('\p{Is_Script= :=ELYMAIC}');
    Error('\P{Is_Script= :=ELYMAIC}');
    Expect(1, 69622, '\p{Is_Script=elymaic}', "");
    Expect(0, 69622, '\p{^Is_Script=elymaic}', "");
    Expect(0, 69622, '\P{Is_Script=elymaic}', "");
    Expect(1, 69622, '\P{^Is_Script=elymaic}', "");
    Expect(0, 69623, '\p{Is_Script=elymaic}', "");
    Expect(1, 69623, '\p{^Is_Script=elymaic}', "");
    Expect(1, 69623, '\P{Is_Script=elymaic}', "");
    Expect(0, 69623, '\P{^Is_Script=elymaic}', "");
    Expect(1, 69622, '\p{Is_Script= 	Elymaic}', "");
    Expect(0, 69622, '\p{^Is_Script= 	Elymaic}', "");
    Expect(0, 69622, '\P{Is_Script= 	Elymaic}', "");
    Expect(1, 69622, '\P{^Is_Script= 	Elymaic}', "");
    Expect(0, 69623, '\p{Is_Script= 	Elymaic}', "");
    Expect(1, 69623, '\p{^Is_Script= 	Elymaic}', "");
    Expect(1, 69623, '\P{Is_Script= 	Elymaic}', "");
    Expect(0, 69623, '\P{^Is_Script= 	Elymaic}', "");
    Error('\p{Is_Sc=:= _Elym}');
    Error('\P{Is_Sc=:= _Elym}');
    Expect(1, 69622, '\p{Is_Sc=elym}', "");
    Expect(0, 69622, '\p{^Is_Sc=elym}', "");
    Expect(0, 69622, '\P{Is_Sc=elym}', "");
    Expect(1, 69622, '\P{^Is_Sc=elym}', "");
    Expect(0, 69623, '\p{Is_Sc=elym}', "");
    Expect(1, 69623, '\p{^Is_Sc=elym}', "");
    Expect(1, 69623, '\P{Is_Sc=elym}', "");
    Expect(0, 69623, '\P{^Is_Sc=elym}', "");
    Expect(1, 69622, '\p{Is_Sc=	Elym}', "");
    Expect(0, 69622, '\p{^Is_Sc=	Elym}', "");
    Expect(0, 69622, '\P{Is_Sc=	Elym}', "");
    Expect(1, 69622, '\P{^Is_Sc=	Elym}', "");
    Expect(0, 69623, '\p{Is_Sc=	Elym}', "");
    Expect(1, 69623, '\p{^Is_Sc=	Elym}', "");
    Expect(1, 69623, '\P{Is_Sc=	Elym}', "");
    Expect(0, 69623, '\P{^Is_Sc=	Elym}', "");
    Error('\p{Script=:=Ethiopic}');
    Error('\P{Script=:=Ethiopic}');
    Expect(1, 43822, '\p{Script=:\AEthiopic\z:}', "");;
    Expect(0, 43823, '\p{Script=:\AEthiopic\z:}', "");;
    Expect(1, 43822, '\p{Script=ethiopic}', "");
    Expect(0, 43822, '\p{^Script=ethiopic}', "");
    Expect(0, 43822, '\P{Script=ethiopic}', "");
    Expect(1, 43822, '\P{^Script=ethiopic}', "");
    Expect(0, 43823, '\p{Script=ethiopic}', "");
    Expect(1, 43823, '\p{^Script=ethiopic}', "");
    Expect(1, 43823, '\P{Script=ethiopic}', "");
    Expect(0, 43823, '\P{^Script=ethiopic}', "");
    Expect(1, 43822, '\p{Script=:\Aethiopic\z:}', "");;
    Expect(0, 43823, '\p{Script=:\Aethiopic\z:}', "");;
    Expect(1, 43822, '\p{Script=	Ethiopic}', "");
    Expect(0, 43822, '\p{^Script=	Ethiopic}', "");
    Expect(0, 43822, '\P{Script=	Ethiopic}', "");
    Expect(1, 43822, '\P{^Script=	Ethiopic}', "");
    Expect(0, 43823, '\p{Script=	Ethiopic}', "");
    Expect(1, 43823, '\p{^Script=	Ethiopic}', "");
    Expect(1, 43823, '\P{Script=	Ethiopic}', "");
    Expect(0, 43823, '\P{^Script=	Ethiopic}', "");
    Error('\p{Sc=	:=ETHI}');
    Error('\P{Sc=	:=ETHI}');
    Expect(1, 43822, '\p{Sc=:\AEthi\z:}', "");;
    Expect(0, 43823, '\p{Sc=:\AEthi\z:}', "");;
    Expect(1, 43822, '\p{Sc=ethi}', "");
    Expect(0, 43822, '\p{^Sc=ethi}', "");
    Expect(0, 43822, '\P{Sc=ethi}', "");
    Expect(1, 43822, '\P{^Sc=ethi}', "");
    Expect(0, 43823, '\p{Sc=ethi}', "");
    Expect(1, 43823, '\p{^Sc=ethi}', "");
    Expect(1, 43823, '\P{Sc=ethi}', "");
    Expect(0, 43823, '\P{^Sc=ethi}', "");
    Expect(1, 43822, '\p{Sc=:\Aethi\z:}', "");;
    Expect(0, 43823, '\p{Sc=:\Aethi\z:}', "");;
    Expect(1, 43822, '\p{Sc:-_Ethi}', "");
    Expect(0, 43822, '\p{^Sc:-_Ethi}', "");
    Expect(0, 43822, '\P{Sc:-_Ethi}', "");
    Expect(1, 43822, '\P{^Sc:-_Ethi}', "");
    Expect(0, 43823, '\p{Sc:-_Ethi}', "");
    Expect(1, 43823, '\p{^Sc:-_Ethi}', "");
    Expect(1, 43823, '\P{Sc:-_Ethi}', "");
    Expect(0, 43823, '\P{^Sc:-_Ethi}', "");
    Error('\p{Is_Script=-ETHIOPIC/a/}');
    Error('\P{Is_Script=-ETHIOPIC/a/}');
    Expect(1, 43822, '\p{Is_Script=ethiopic}', "");
    Expect(0, 43822, '\p{^Is_Script=ethiopic}', "");
    Expect(0, 43822, '\P{Is_Script=ethiopic}', "");
    Expect(1, 43822, '\P{^Is_Script=ethiopic}', "");
    Expect(0, 43823, '\p{Is_Script=ethiopic}', "");
    Expect(1, 43823, '\p{^Is_Script=ethiopic}', "");
    Expect(1, 43823, '\P{Is_Script=ethiopic}', "");
    Expect(0, 43823, '\P{^Is_Script=ethiopic}', "");
    Expect(1, 43822, '\p{Is_Script= -ethiopic}', "");
    Expect(0, 43822, '\p{^Is_Script= -ethiopic}', "");
    Expect(0, 43822, '\P{Is_Script= -ethiopic}', "");
    Expect(1, 43822, '\P{^Is_Script= -ethiopic}', "");
    Expect(0, 43823, '\p{Is_Script= -ethiopic}', "");
    Expect(1, 43823, '\p{^Is_Script= -ethiopic}', "");
    Expect(1, 43823, '\P{Is_Script= -ethiopic}', "");
    Expect(0, 43823, '\P{^Is_Script= -ethiopic}', "");
    Error('\p{Is_Sc=/a/_ETHI}');
    Error('\P{Is_Sc=/a/_ETHI}');
    Expect(1, 43822, '\p{Is_Sc=ethi}', "");
    Expect(0, 43822, '\p{^Is_Sc=ethi}', "");
    Expect(0, 43822, '\P{Is_Sc=ethi}', "");
    Expect(1, 43822, '\P{^Is_Sc=ethi}', "");
    Expect(0, 43823, '\p{Is_Sc=ethi}', "");
    Expect(1, 43823, '\p{^Is_Sc=ethi}', "");
    Expect(1, 43823, '\P{Is_Sc=ethi}', "");
    Expect(0, 43823, '\P{^Is_Sc=ethi}', "");
    Expect(1, 43822, '\p{Is_Sc=--ETHI}', "");
    Expect(0, 43822, '\p{^Is_Sc=--ETHI}', "");
    Expect(0, 43822, '\P{Is_Sc=--ETHI}', "");
    Expect(1, 43822, '\P{^Is_Sc=--ETHI}', "");
    Expect(0, 43823, '\p{Is_Sc=--ETHI}', "");
    Expect(1, 43823, '\p{^Is_Sc=--ETHI}', "");
    Expect(1, 43823, '\P{Is_Sc=--ETHI}', "");
    Expect(0, 43823, '\P{^Is_Sc=--ETHI}', "");
    Error('\p{Script=_:=Georgian}');
    Error('\P{Script=_:=Georgian}');
    Expect(1, 11565, '\p{Script=:\AGeorgian\z:}', "");;
    Expect(0, 11566, '\p{Script=:\AGeorgian\z:}', "");;
    Expect(1, 11565, '\p{Script=georgian}', "");
    Expect(0, 11565, '\p{^Script=georgian}', "");
    Expect(0, 11565, '\P{Script=georgian}', "");
    Expect(1, 11565, '\P{^Script=georgian}', "");
    Expect(0, 11566, '\p{Script=georgian}', "");
    Expect(1, 11566, '\p{^Script=georgian}', "");
    Expect(1, 11566, '\P{Script=georgian}', "");
    Expect(0, 11566, '\P{^Script=georgian}', "");
    Expect(1, 11565, '\p{Script=:\Ageorgian\z:}', "");;
    Expect(0, 11566, '\p{Script=:\Ageorgian\z:}', "");;
    Expect(1, 11565, '\p{Script=-Georgian}', "");
    Expect(0, 11565, '\p{^Script=-Georgian}', "");
    Expect(0, 11565, '\P{Script=-Georgian}', "");
    Expect(1, 11565, '\P{^Script=-Georgian}', "");
    Expect(0, 11566, '\p{Script=-Georgian}', "");
    Expect(1, 11566, '\p{^Script=-Georgian}', "");
    Expect(1, 11566, '\P{Script=-Georgian}', "");
    Expect(0, 11566, '\P{^Script=-Georgian}', "");
    Error('\p{Sc=	_GEOR/a/}');
    Error('\P{Sc=	_GEOR/a/}');
    Expect(1, 11565, '\p{Sc=:\AGeor\z:}', "");;
    Expect(0, 11566, '\p{Sc=:\AGeor\z:}', "");;
    Expect(1, 11565, '\p{Sc=geor}', "");
    Expect(0, 11565, '\p{^Sc=geor}', "");
    Expect(0, 11565, '\P{Sc=geor}', "");
    Expect(1, 11565, '\P{^Sc=geor}', "");
    Expect(0, 11566, '\p{Sc=geor}', "");
    Expect(1, 11566, '\p{^Sc=geor}', "");
    Expect(1, 11566, '\P{Sc=geor}', "");
    Expect(0, 11566, '\P{^Sc=geor}', "");
    Expect(1, 11565, '\p{Sc=:\Ageor\z:}', "");;
    Expect(0, 11566, '\p{Sc=:\Ageor\z:}', "");;
    Expect(1, 11565, '\p{Sc=--Geor}', "");
    Expect(0, 11565, '\p{^Sc=--Geor}', "");
    Expect(0, 11565, '\P{Sc=--Geor}', "");
    Expect(1, 11565, '\P{^Sc=--Geor}', "");
    Expect(0, 11566, '\p{Sc=--Geor}', "");
    Expect(1, 11566, '\p{^Sc=--Geor}', "");
    Expect(1, 11566, '\P{Sc=--Geor}', "");
    Expect(0, 11566, '\P{^Sc=--Geor}', "");
    Error('\p{Is_Script=/a/	georgian}');
    Error('\P{Is_Script=/a/	georgian}');
    Expect(1, 11565, '\p{Is_Script=georgian}', "");
    Expect(0, 11565, '\p{^Is_Script=georgian}', "");
    Expect(0, 11565, '\P{Is_Script=georgian}', "");
    Expect(1, 11565, '\P{^Is_Script=georgian}', "");
    Expect(0, 11566, '\p{Is_Script=georgian}', "");
    Expect(1, 11566, '\p{^Is_Script=georgian}', "");
    Expect(1, 11566, '\P{Is_Script=georgian}', "");
    Expect(0, 11566, '\P{^Is_Script=georgian}', "");
    Expect(1, 11565, '\p{Is_Script=	georgian}', "");
    Expect(0, 11565, '\p{^Is_Script=	georgian}', "");
    Expect(0, 11565, '\P{Is_Script=	georgian}', "");
    Expect(1, 11565, '\P{^Is_Script=	georgian}', "");
    Expect(0, 11566, '\p{Is_Script=	georgian}', "");
    Expect(1, 11566, '\p{^Is_Script=	georgian}', "");
    Expect(1, 11566, '\P{Is_Script=	georgian}', "");
    Expect(0, 11566, '\P{^Is_Script=	georgian}', "");
    Error('\p{Is_Sc=--geor/a/}');
    Error('\P{Is_Sc=--geor/a/}');
    Expect(1, 11565, '\p{Is_Sc=geor}', "");
    Expect(0, 11565, '\p{^Is_Sc=geor}', "");
    Expect(0, 11565, '\P{Is_Sc=geor}', "");
    Expect(1, 11565, '\P{^Is_Sc=geor}', "");
    Expect(0, 11566, '\p{Is_Sc=geor}', "");
    Expect(1, 11566, '\p{^Is_Sc=geor}', "");
    Expect(1, 11566, '\P{Is_Sc=geor}', "");
    Expect(0, 11566, '\P{^Is_Sc=geor}', "");
    Expect(1, 11565, '\p{Is_Sc=--Geor}', "");
    Expect(0, 11565, '\p{^Is_Sc=--Geor}', "");
    Expect(0, 11565, '\P{Is_Sc=--Geor}', "");
    Expect(1, 11565, '\P{^Is_Sc=--Geor}', "");
    Expect(0, 11566, '\p{Is_Sc=--Geor}', "");
    Expect(1, 11566, '\p{^Is_Sc=--Geor}', "");
    Expect(1, 11566, '\P{Is_Sc=--Geor}', "");
    Expect(0, 11566, '\P{^Is_Sc=--Geor}', "");
    Error('\p{Script=_/a/glagolitic}');
    Error('\P{Script=_/a/glagolitic}');
    Expect(1, 122922, '\p{Script=:\AGlagolitic\z:}', "");;
    Expect(0, 122923, '\p{Script=:\AGlagolitic\z:}', "");;
    Expect(1, 122922, '\p{Script=glagolitic}', "");
    Expect(0, 122922, '\p{^Script=glagolitic}', "");
    Expect(0, 122922, '\P{Script=glagolitic}', "");
    Expect(1, 122922, '\P{^Script=glagolitic}', "");
    Expect(0, 122923, '\p{Script=glagolitic}', "");
    Expect(1, 122923, '\p{^Script=glagolitic}', "");
    Expect(1, 122923, '\P{Script=glagolitic}', "");
    Expect(0, 122923, '\P{^Script=glagolitic}', "");
    Expect(1, 122922, '\p{Script=:\Aglagolitic\z:}', "");;
    Expect(0, 122923, '\p{Script=:\Aglagolitic\z:}', "");;
    Expect(1, 122922, '\p{Script:-	Glagolitic}', "");
    Expect(0, 122922, '\p{^Script:-	Glagolitic}', "");
    Expect(0, 122922, '\P{Script:-	Glagolitic}', "");
    Expect(1, 122922, '\P{^Script:-	Glagolitic}', "");
    Expect(0, 122923, '\p{Script:-	Glagolitic}', "");
    Expect(1, 122923, '\p{^Script:-	Glagolitic}', "");
    Expect(1, 122923, '\P{Script:-	Glagolitic}', "");
    Expect(0, 122923, '\P{^Script:-	Glagolitic}', "");
    Error('\p{Sc=	glag:=}');
    Error('\P{Sc=	glag:=}');
    Expect(1, 122922, '\p{Sc=:\AGlag\z:}', "");;
    Expect(0, 122923, '\p{Sc=:\AGlag\z:}', "");;
    Expect(1, 122922, '\p{Sc: glag}', "");
    Expect(0, 122922, '\p{^Sc: glag}', "");
    Expect(0, 122922, '\P{Sc: glag}', "");
    Expect(1, 122922, '\P{^Sc: glag}', "");
    Expect(0, 122923, '\p{Sc: glag}', "");
    Expect(1, 122923, '\p{^Sc: glag}', "");
    Expect(1, 122923, '\P{Sc: glag}', "");
    Expect(0, 122923, '\P{^Sc: glag}', "");
    Expect(1, 122922, '\p{Sc=:\Aglag\z:}', "");;
    Expect(0, 122923, '\p{Sc=:\Aglag\z:}', "");;
    Expect(1, 122922, '\p{Sc=--Glag}', "");
    Expect(0, 122922, '\p{^Sc=--Glag}', "");
    Expect(0, 122922, '\P{Sc=--Glag}', "");
    Expect(1, 122922, '\P{^Sc=--Glag}', "");
    Expect(0, 122923, '\p{Sc=--Glag}', "");
    Expect(1, 122923, '\p{^Sc=--Glag}', "");
    Expect(1, 122923, '\P{Sc=--Glag}', "");
    Expect(0, 122923, '\P{^Sc=--Glag}', "");
    Error('\p{Is_Script:   := -Glagolitic}');
    Error('\P{Is_Script:   := -Glagolitic}');
    Expect(1, 122922, '\p{Is_Script=glagolitic}', "");
    Expect(0, 122922, '\p{^Is_Script=glagolitic}', "");
    Expect(0, 122922, '\P{Is_Script=glagolitic}', "");
    Expect(1, 122922, '\P{^Is_Script=glagolitic}', "");
    Expect(0, 122923, '\p{Is_Script=glagolitic}', "");
    Expect(1, 122923, '\p{^Is_Script=glagolitic}', "");
    Expect(1, 122923, '\P{Is_Script=glagolitic}', "");
    Expect(0, 122923, '\P{^Is_Script=glagolitic}', "");
    Expect(1, 122922, '\p{Is_Script=-Glagolitic}', "");
    Expect(0, 122922, '\p{^Is_Script=-Glagolitic}', "");
    Expect(0, 122922, '\P{Is_Script=-Glagolitic}', "");
    Expect(1, 122922, '\P{^Is_Script=-Glagolitic}', "");
    Expect(0, 122923, '\p{Is_Script=-Glagolitic}', "");
    Expect(1, 122923, '\p{^Is_Script=-Glagolitic}', "");
    Expect(1, 122923, '\P{Is_Script=-Glagolitic}', "");
    Expect(0, 122923, '\P{^Is_Script=-Glagolitic}', "");
    Error('\p{Is_Sc=  GLAG/a/}');
    Error('\P{Is_Sc=  GLAG/a/}');
    Expect(1, 122922, '\p{Is_Sc=glag}', "");
    Expect(0, 122922, '\p{^Is_Sc=glag}', "");
    Expect(0, 122922, '\P{Is_Sc=glag}', "");
    Expect(1, 122922, '\P{^Is_Sc=glag}', "");
    Expect(0, 122923, '\p{Is_Sc=glag}', "");
    Expect(1, 122923, '\p{^Is_Sc=glag}', "");
    Expect(1, 122923, '\P{Is_Sc=glag}', "");
    Expect(0, 122923, '\P{^Is_Sc=glag}', "");
    Expect(1, 122922, '\p{Is_Sc= glag}', "");
    Expect(0, 122922, '\p{^Is_Sc= glag}', "");
    Expect(0, 122922, '\P{Is_Sc= glag}', "");
    Expect(1, 122922, '\P{^Is_Sc= glag}', "");
    Expect(0, 122923, '\p{Is_Sc= glag}', "");
    Expect(1, 122923, '\p{^Is_Sc= glag}', "");
    Expect(1, 122923, '\P{Is_Sc= glag}', "");
    Expect(0, 122923, '\P{^Is_Sc= glag}', "");
    Error('\p{Script= :=Gunjala_gondi}');
    Error('\P{Script= :=Gunjala_gondi}');
    Expect(1, 73129, '\p{Script=:\AGunjala_Gondi\z:}', "");;
    Expect(0, 73130, '\p{Script=:\AGunjala_Gondi\z:}', "");;
    Expect(1, 73129, '\p{Script=gunjalagondi}', "");
    Expect(0, 73129, '\p{^Script=gunjalagondi}', "");
    Expect(0, 73129, '\P{Script=gunjalagondi}', "");
    Expect(1, 73129, '\P{^Script=gunjalagondi}', "");
    Expect(0, 73130, '\p{Script=gunjalagondi}', "");
    Expect(1, 73130, '\p{^Script=gunjalagondi}', "");
    Expect(1, 73130, '\P{Script=gunjalagondi}', "");
    Expect(0, 73130, '\P{^Script=gunjalagondi}', "");
    Expect(1, 73129, '\p{Script=:\Agunjalagondi\z:}', "");;
    Expect(0, 73130, '\p{Script=:\Agunjalagondi\z:}', "");;
    Expect(1, 73129, '\p{Script=	-Gunjala_Gondi}', "");
    Expect(0, 73129, '\p{^Script=	-Gunjala_Gondi}', "");
    Expect(0, 73129, '\P{Script=	-Gunjala_Gondi}', "");
    Expect(1, 73129, '\P{^Script=	-Gunjala_Gondi}', "");
    Expect(0, 73130, '\p{Script=	-Gunjala_Gondi}', "");
    Expect(1, 73130, '\p{^Script=	-Gunjala_Gondi}', "");
    Expect(1, 73130, '\P{Script=	-Gunjala_Gondi}', "");
    Expect(0, 73130, '\P{^Script=	-Gunjala_Gondi}', "");
    Error('\p{Sc=/a/Gong}');
    Error('\P{Sc=/a/Gong}');
    Expect(1, 73129, '\p{Sc=:\AGong\z:}', "");;
    Expect(0, 73130, '\p{Sc=:\AGong\z:}', "");;
    Expect(1, 73129, '\p{Sc=gong}', "");
    Expect(0, 73129, '\p{^Sc=gong}', "");
    Expect(0, 73129, '\P{Sc=gong}', "");
    Expect(1, 73129, '\P{^Sc=gong}', "");
    Expect(0, 73130, '\p{Sc=gong}', "");
    Expect(1, 73130, '\p{^Sc=gong}', "");
    Expect(1, 73130, '\P{Sc=gong}', "");
    Expect(0, 73130, '\P{^Sc=gong}', "");
    Expect(1, 73129, '\p{Sc=:\Agong\z:}', "");;
    Expect(0, 73130, '\p{Sc=:\Agong\z:}', "");;
    Expect(1, 73129, '\p{Sc: _	Gong}', "");
    Expect(0, 73129, '\p{^Sc: _	Gong}', "");
    Expect(0, 73129, '\P{Sc: _	Gong}', "");
    Expect(1, 73129, '\P{^Sc: _	Gong}', "");
    Expect(0, 73130, '\p{Sc: _	Gong}', "");
    Expect(1, 73130, '\p{^Sc: _	Gong}', "");
    Expect(1, 73130, '\P{Sc: _	Gong}', "");
    Expect(0, 73130, '\P{^Sc: _	Gong}', "");
    Error('\p{Is_Script=:=  Gunjala_Gondi}');
    Error('\P{Is_Script=:=  Gunjala_Gondi}');
    Expect(1, 73129, '\p{Is_Script=gunjalagondi}', "");
    Expect(0, 73129, '\p{^Is_Script=gunjalagondi}', "");
    Expect(0, 73129, '\P{Is_Script=gunjalagondi}', "");
    Expect(1, 73129, '\P{^Is_Script=gunjalagondi}', "");
    Expect(0, 73130, '\p{Is_Script=gunjalagondi}', "");
    Expect(1, 73130, '\p{^Is_Script=gunjalagondi}', "");
    Expect(1, 73130, '\P{Is_Script=gunjalagondi}', "");
    Expect(0, 73130, '\P{^Is_Script=gunjalagondi}', "");
    Expect(1, 73129, '\p{Is_Script=	_gunjala_Gondi}', "");
    Expect(0, 73129, '\p{^Is_Script=	_gunjala_Gondi}', "");
    Expect(0, 73129, '\P{Is_Script=	_gunjala_Gondi}', "");
    Expect(1, 73129, '\P{^Is_Script=	_gunjala_Gondi}', "");
    Expect(0, 73130, '\p{Is_Script=	_gunjala_Gondi}', "");
    Expect(1, 73130, '\p{^Is_Script=	_gunjala_Gondi}', "");
    Expect(1, 73130, '\P{Is_Script=	_gunjala_Gondi}', "");
    Expect(0, 73130, '\P{^Is_Script=	_gunjala_Gondi}', "");
    Error('\p{Is_Sc=_	gong:=}');
    Error('\P{Is_Sc=_	gong:=}');
    Expect(1, 73129, '\p{Is_Sc=gong}', "");
    Expect(0, 73129, '\p{^Is_Sc=gong}', "");
    Expect(0, 73129, '\P{Is_Sc=gong}', "");
    Expect(1, 73129, '\P{^Is_Sc=gong}', "");
    Expect(0, 73130, '\p{Is_Sc=gong}', "");
    Expect(1, 73130, '\p{^Is_Sc=gong}', "");
    Expect(1, 73130, '\P{Is_Sc=gong}', "");
    Expect(0, 73130, '\P{^Is_Sc=gong}', "");
    Expect(1, 73129, '\p{Is_Sc= gong}', "");
    Expect(0, 73129, '\p{^Is_Sc= gong}', "");
    Expect(0, 73129, '\P{Is_Sc= gong}', "");
    Expect(1, 73129, '\P{^Is_Sc= gong}', "");
    Expect(0, 73130, '\p{Is_Sc= gong}', "");
    Expect(1, 73130, '\p{^Is_Sc= gong}', "");
    Expect(1, 73130, '\P{Is_Sc= gong}', "");
    Expect(0, 73130, '\P{^Is_Sc= gong}', "");
    Error('\p{Script= 	Masaram_gondi:=}');
    Error('\P{Script= 	Masaram_gondi:=}');
    Expect(1, 73049, '\p{Script=:\AMasaram_Gondi\z:}', "");;
    Expect(0, 73050, '\p{Script=:\AMasaram_Gondi\z:}', "");;
    Expect(1, 73049, '\p{Script=masaramgondi}', "");
    Expect(0, 73049, '\p{^Script=masaramgondi}', "");
    Expect(0, 73049, '\P{Script=masaramgondi}', "");
    Expect(1, 73049, '\P{^Script=masaramgondi}', "");
    Expect(0, 73050, '\p{Script=masaramgondi}', "");
    Expect(1, 73050, '\p{^Script=masaramgondi}', "");
    Expect(1, 73050, '\P{Script=masaramgondi}', "");
    Expect(0, 73050, '\P{^Script=masaramgondi}', "");
    Expect(1, 73049, '\p{Script=:\Amasaramgondi\z:}', "");;
    Expect(0, 73050, '\p{Script=:\Amasaramgondi\z:}', "");;
    Expect(1, 73049, '\p{Script=_ masaram_GONDI}', "");
    Expect(0, 73049, '\p{^Script=_ masaram_GONDI}', "");
    Expect(0, 73049, '\P{Script=_ masaram_GONDI}', "");
    Expect(1, 73049, '\P{^Script=_ masaram_GONDI}', "");
    Expect(0, 73050, '\p{Script=_ masaram_GONDI}', "");
    Expect(1, 73050, '\p{^Script=_ masaram_GONDI}', "");
    Expect(1, 73050, '\P{Script=_ masaram_GONDI}', "");
    Expect(0, 73050, '\P{^Script=_ masaram_GONDI}', "");
    Error('\p{Sc=_ gonm/a/}');
    Error('\P{Sc=_ gonm/a/}');
    Expect(1, 73049, '\p{Sc=:\AGonm\z:}', "");;
    Expect(0, 73050, '\p{Sc=:\AGonm\z:}', "");;
    Expect(1, 73049, '\p{Sc=gonm}', "");
    Expect(0, 73049, '\p{^Sc=gonm}', "");
    Expect(0, 73049, '\P{Sc=gonm}', "");
    Expect(1, 73049, '\P{^Sc=gonm}', "");
    Expect(0, 73050, '\p{Sc=gonm}', "");
    Expect(1, 73050, '\p{^Sc=gonm}', "");
    Expect(1, 73050, '\P{Sc=gonm}', "");
    Expect(0, 73050, '\P{^Sc=gonm}', "");
    Expect(1, 73049, '\p{Sc=:\Agonm\z:}', "");;
    Expect(0, 73050, '\p{Sc=:\Agonm\z:}', "");;
    Expect(1, 73049, '\p{Sc=_	Gonm}', "");
    Expect(0, 73049, '\p{^Sc=_	Gonm}', "");
    Expect(0, 73049, '\P{Sc=_	Gonm}', "");
    Expect(1, 73049, '\P{^Sc=_	Gonm}', "");
    Expect(0, 73050, '\p{Sc=_	Gonm}', "");
    Expect(1, 73050, '\p{^Sc=_	Gonm}', "");
    Expect(1, 73050, '\P{Sc=_	Gonm}', "");
    Expect(0, 73050, '\P{^Sc=_	Gonm}', "");
    Error('\p{Is_Script=/a/	-Masaram_Gondi}');
    Error('\P{Is_Script=/a/	-Masaram_Gondi}');
    Expect(1, 73049, '\p{Is_Script=masaramgondi}', "");
    Expect(0, 73049, '\p{^Is_Script=masaramgondi}', "");
    Expect(0, 73049, '\P{Is_Script=masaramgondi}', "");
    Expect(1, 73049, '\P{^Is_Script=masaramgondi}', "");
    Expect(0, 73050, '\p{Is_Script=masaramgondi}', "");
    Expect(1, 73050, '\p{^Is_Script=masaramgondi}', "");
    Expect(1, 73050, '\P{Is_Script=masaramgondi}', "");
    Expect(0, 73050, '\P{^Is_Script=masaramgondi}', "");
    Expect(1, 73049, '\p{Is_Script=__masaram_gondi}', "");
    Expect(0, 73049, '\p{^Is_Script=__masaram_gondi}', "");
    Expect(0, 73049, '\P{Is_Script=__masaram_gondi}', "");
    Expect(1, 73049, '\P{^Is_Script=__masaram_gondi}', "");
    Expect(0, 73050, '\p{Is_Script=__masaram_gondi}', "");
    Expect(1, 73050, '\p{^Is_Script=__masaram_gondi}', "");
    Expect(1, 73050, '\P{Is_Script=__masaram_gondi}', "");
    Expect(0, 73050, '\P{^Is_Script=__masaram_gondi}', "");
    Error('\p{Is_Sc=	/a/Gonm}');
    Error('\P{Is_Sc=	/a/Gonm}');
    Expect(1, 73049, '\p{Is_Sc=gonm}', "");
    Expect(0, 73049, '\p{^Is_Sc=gonm}', "");
    Expect(0, 73049, '\P{Is_Sc=gonm}', "");
    Expect(1, 73049, '\P{^Is_Sc=gonm}', "");
    Expect(0, 73050, '\p{Is_Sc=gonm}', "");
    Expect(1, 73050, '\p{^Is_Sc=gonm}', "");
    Expect(1, 73050, '\P{Is_Sc=gonm}', "");
    Expect(0, 73050, '\P{^Is_Sc=gonm}', "");
    Expect(1, 73049, '\p{Is_Sc=-Gonm}', "");
    Expect(0, 73049, '\p{^Is_Sc=-Gonm}', "");
    Expect(0, 73049, '\P{Is_Sc=-Gonm}', "");
    Expect(1, 73049, '\P{^Is_Sc=-Gonm}', "");
    Expect(0, 73050, '\p{Is_Sc=-Gonm}', "");
    Expect(1, 73050, '\p{^Is_Sc=-Gonm}', "");
    Expect(1, 73050, '\P{Is_Sc=-Gonm}', "");
    Expect(0, 73050, '\P{^Is_Sc=-Gonm}', "");
    Error('\p{Script= :=Gothic}');
    Error('\P{Script= :=Gothic}');
    Expect(1, 66378, '\p{Script=:\AGothic\z:}', "");;
    Expect(0, 66379, '\p{Script=:\AGothic\z:}', "");;
    Expect(1, 66378, '\p{Script=gothic}', "");
    Expect(0, 66378, '\p{^Script=gothic}', "");
    Expect(0, 66378, '\P{Script=gothic}', "");
    Expect(1, 66378, '\P{^Script=gothic}', "");
    Expect(0, 66379, '\p{Script=gothic}', "");
    Expect(1, 66379, '\p{^Script=gothic}', "");
    Expect(1, 66379, '\P{Script=gothic}', "");
    Expect(0, 66379, '\P{^Script=gothic}', "");
    Expect(1, 66378, '\p{Script=:\Agothic\z:}', "");;
    Expect(0, 66379, '\p{Script=:\Agothic\z:}', "");;
    Expect(1, 66378, '\p{Script= GOTHIC}', "");
    Expect(0, 66378, '\p{^Script= GOTHIC}', "");
    Expect(0, 66378, '\P{Script= GOTHIC}', "");
    Expect(1, 66378, '\P{^Script= GOTHIC}', "");
    Expect(0, 66379, '\p{Script= GOTHIC}', "");
    Expect(1, 66379, '\p{^Script= GOTHIC}', "");
    Expect(1, 66379, '\P{Script= GOTHIC}', "");
    Expect(0, 66379, '\P{^Script= GOTHIC}', "");
    Error('\p{Sc=	/a/Goth}');
    Error('\P{Sc=	/a/Goth}');
    Expect(1, 66378, '\p{Sc=:\AGoth\z:}', "");;
    Expect(0, 66379, '\p{Sc=:\AGoth\z:}', "");;
    Expect(1, 66378, '\p{Sc=goth}', "");
    Expect(0, 66378, '\p{^Sc=goth}', "");
    Expect(0, 66378, '\P{Sc=goth}', "");
    Expect(1, 66378, '\P{^Sc=goth}', "");
    Expect(0, 66379, '\p{Sc=goth}', "");
    Expect(1, 66379, '\p{^Sc=goth}', "");
    Expect(1, 66379, '\P{Sc=goth}', "");
    Expect(0, 66379, '\P{^Sc=goth}', "");
    Expect(1, 66378, '\p{Sc=:\Agoth\z:}', "");;
    Expect(0, 66379, '\p{Sc=:\Agoth\z:}', "");;
    Expect(1, 66378, '\p{Sc:   GOTH}', "");
    Expect(0, 66378, '\p{^Sc:   GOTH}', "");
    Expect(0, 66378, '\P{Sc:   GOTH}', "");
    Expect(1, 66378, '\P{^Sc:   GOTH}', "");
    Expect(0, 66379, '\p{Sc:   GOTH}', "");
    Expect(1, 66379, '\p{^Sc:   GOTH}', "");
    Expect(1, 66379, '\P{Sc:   GOTH}', "");
    Expect(0, 66379, '\P{^Sc:   GOTH}', "");
    Error('\p{Is_Script: _Gothic/a/}');
    Error('\P{Is_Script: _Gothic/a/}');
    Expect(1, 66378, '\p{Is_Script=gothic}', "");
    Expect(0, 66378, '\p{^Is_Script=gothic}', "");
    Expect(0, 66378, '\P{Is_Script=gothic}', "");
    Expect(1, 66378, '\P{^Is_Script=gothic}', "");
    Expect(0, 66379, '\p{Is_Script=gothic}', "");
    Expect(1, 66379, '\p{^Is_Script=gothic}', "");
    Expect(1, 66379, '\P{Is_Script=gothic}', "");
    Expect(0, 66379, '\P{^Is_Script=gothic}', "");
    Expect(1, 66378, '\p{Is_Script=	 gothic}', "");
    Expect(0, 66378, '\p{^Is_Script=	 gothic}', "");
    Expect(0, 66378, '\P{Is_Script=	 gothic}', "");
    Expect(1, 66378, '\P{^Is_Script=	 gothic}', "");
    Expect(0, 66379, '\p{Is_Script=	 gothic}', "");
    Expect(1, 66379, '\p{^Is_Script=	 gothic}', "");
    Expect(1, 66379, '\P{Is_Script=	 gothic}', "");
    Expect(0, 66379, '\P{^Is_Script=	 gothic}', "");
    Error('\p{Is_Sc=	GOTH/a/}');
    Error('\P{Is_Sc=	GOTH/a/}');
    Expect(1, 66378, '\p{Is_Sc=goth}', "");
    Expect(0, 66378, '\p{^Is_Sc=goth}', "");
    Expect(0, 66378, '\P{Is_Sc=goth}', "");
    Expect(1, 66378, '\P{^Is_Sc=goth}', "");
    Expect(0, 66379, '\p{Is_Sc=goth}', "");
    Expect(1, 66379, '\p{^Is_Sc=goth}', "");
    Expect(1, 66379, '\P{Is_Sc=goth}', "");
    Expect(0, 66379, '\P{^Is_Sc=goth}', "");
    Expect(1, 66378, '\p{Is_Sc=-Goth}', "");
    Expect(0, 66378, '\p{^Is_Sc=-Goth}', "");
    Expect(0, 66378, '\P{Is_Sc=-Goth}', "");
    Expect(1, 66378, '\P{^Is_Sc=-Goth}', "");
    Expect(0, 66379, '\p{Is_Sc=-Goth}', "");
    Expect(1, 66379, '\p{^Is_Sc=-Goth}', "");
    Expect(1, 66379, '\P{Is_Sc=-Goth}', "");
    Expect(0, 66379, '\P{^Is_Sc=-Goth}', "");
    Error('\p{Script:__grantha/a/}');
    Error('\P{Script:__grantha/a/}');
    Expect(1, 70516, '\p{Script=:\AGrantha\z:}', "");;
    Expect(0, 70517, '\p{Script=:\AGrantha\z:}', "");;
    Expect(1, 70516, '\p{Script=grantha}', "");
    Expect(0, 70516, '\p{^Script=grantha}', "");
    Expect(0, 70516, '\P{Script=grantha}', "");
    Expect(1, 70516, '\P{^Script=grantha}', "");
    Expect(0, 70517, '\p{Script=grantha}', "");
    Expect(1, 70517, '\p{^Script=grantha}', "");
    Expect(1, 70517, '\P{Script=grantha}', "");
    Expect(0, 70517, '\P{^Script=grantha}', "");
    Expect(1, 70516, '\p{Script=:\Agrantha\z:}', "");;
    Expect(0, 70517, '\p{Script=:\Agrantha\z:}', "");;
    Expect(1, 70516, '\p{Script=	-Grantha}', "");
    Expect(0, 70516, '\p{^Script=	-Grantha}', "");
    Expect(0, 70516, '\P{Script=	-Grantha}', "");
    Expect(1, 70516, '\P{^Script=	-Grantha}', "");
    Expect(0, 70517, '\p{Script=	-Grantha}', "");
    Expect(1, 70517, '\p{^Script=	-Grantha}', "");
    Expect(1, 70517, '\P{Script=	-Grantha}', "");
    Expect(0, 70517, '\P{^Script=	-Grantha}', "");
    Error('\p{Sc=-/a/GRAN}');
    Error('\P{Sc=-/a/GRAN}');
    Expect(1, 70516, '\p{Sc=:\AGran\z:}', "");;
    Expect(0, 70517, '\p{Sc=:\AGran\z:}', "");;
    Expect(1, 70516, '\p{Sc=gran}', "");
    Expect(0, 70516, '\p{^Sc=gran}', "");
    Expect(0, 70516, '\P{Sc=gran}', "");
    Expect(1, 70516, '\P{^Sc=gran}', "");
    Expect(0, 70517, '\p{Sc=gran}', "");
    Expect(1, 70517, '\p{^Sc=gran}', "");
    Expect(1, 70517, '\P{Sc=gran}', "");
    Expect(0, 70517, '\P{^Sc=gran}', "");
    Expect(1, 70516, '\p{Sc=:\Agran\z:}', "");;
    Expect(0, 70517, '\p{Sc=:\Agran\z:}', "");;
    Expect(1, 70516, '\p{Sc=-_GRAN}', "");
    Expect(0, 70516, '\p{^Sc=-_GRAN}', "");
    Expect(0, 70516, '\P{Sc=-_GRAN}', "");
    Expect(1, 70516, '\P{^Sc=-_GRAN}', "");
    Expect(0, 70517, '\p{Sc=-_GRAN}', "");
    Expect(1, 70517, '\p{^Sc=-_GRAN}', "");
    Expect(1, 70517, '\P{Sc=-_GRAN}', "");
    Expect(0, 70517, '\P{^Sc=-_GRAN}', "");
    Error('\p{Is_Script=/a/__Grantha}');
    Error('\P{Is_Script=/a/__Grantha}');
    Expect(1, 70516, '\p{Is_Script=grantha}', "");
    Expect(0, 70516, '\p{^Is_Script=grantha}', "");
    Expect(0, 70516, '\P{Is_Script=grantha}', "");
    Expect(1, 70516, '\P{^Is_Script=grantha}', "");
    Expect(0, 70517, '\p{Is_Script=grantha}', "");
    Expect(1, 70517, '\p{^Is_Script=grantha}', "");
    Expect(1, 70517, '\P{Is_Script=grantha}', "");
    Expect(0, 70517, '\P{^Is_Script=grantha}', "");
    Expect(1, 70516, '\p{Is_Script:   -Grantha}', "");
    Expect(0, 70516, '\p{^Is_Script:   -Grantha}', "");
    Expect(0, 70516, '\P{Is_Script:   -Grantha}', "");
    Expect(1, 70516, '\P{^Is_Script:   -Grantha}', "");
    Expect(0, 70517, '\p{Is_Script:   -Grantha}', "");
    Expect(1, 70517, '\p{^Is_Script:   -Grantha}', "");
    Expect(1, 70517, '\P{Is_Script:   -Grantha}', "");
    Expect(0, 70517, '\P{^Is_Script:   -Grantha}', "");
    Error('\p{Is_Sc=:=Gran}');
    Error('\P{Is_Sc=:=Gran}');
    Expect(1, 70516, '\p{Is_Sc:	gran}', "");
    Expect(0, 70516, '\p{^Is_Sc:	gran}', "");
    Expect(0, 70516, '\P{Is_Sc:	gran}', "");
    Expect(1, 70516, '\P{^Is_Sc:	gran}', "");
    Expect(0, 70517, '\p{Is_Sc:	gran}', "");
    Expect(1, 70517, '\p{^Is_Sc:	gran}', "");
    Expect(1, 70517, '\P{Is_Sc:	gran}', "");
    Expect(0, 70517, '\P{^Is_Sc:	gran}', "");
    Expect(1, 70516, '\p{Is_Sc=--Gran}', "");
    Expect(0, 70516, '\p{^Is_Sc=--Gran}', "");
    Expect(0, 70516, '\P{Is_Sc=--Gran}', "");
    Expect(1, 70516, '\P{^Is_Sc=--Gran}', "");
    Expect(0, 70517, '\p{Is_Sc=--Gran}', "");
    Expect(1, 70517, '\p{^Is_Sc=--Gran}', "");
    Expect(1, 70517, '\P{Is_Sc=--Gran}', "");
    Expect(0, 70517, '\P{^Is_Sc=--Gran}', "");
    Error('\p{Script=	/a/GREEK}');
    Error('\P{Script=	/a/GREEK}');
    Expect(1, 119365, '\p{Script=:\AGreek\z:}', "");;
    Expect(0, 119366, '\p{Script=:\AGreek\z:}', "");;
    Expect(1, 119365, '\p{Script=greek}', "");
    Expect(0, 119365, '\p{^Script=greek}', "");
    Expect(0, 119365, '\P{Script=greek}', "");
    Expect(1, 119365, '\P{^Script=greek}', "");
    Expect(0, 119366, '\p{Script=greek}', "");
    Expect(1, 119366, '\p{^Script=greek}', "");
    Expect(1, 119366, '\P{Script=greek}', "");
    Expect(0, 119366, '\P{^Script=greek}', "");
    Expect(1, 119365, '\p{Script=:\Agreek\z:}', "");;
    Expect(0, 119366, '\p{Script=:\Agreek\z:}', "");;
    Expect(1, 119365, '\p{Script=  Greek}', "");
    Expect(0, 119365, '\p{^Script=  Greek}', "");
    Expect(0, 119365, '\P{Script=  Greek}', "");
    Expect(1, 119365, '\P{^Script=  Greek}', "");
    Expect(0, 119366, '\p{Script=  Greek}', "");
    Expect(1, 119366, '\p{^Script=  Greek}', "");
    Expect(1, 119366, '\P{Script=  Greek}', "");
    Expect(0, 119366, '\P{^Script=  Greek}', "");
    Error('\p{Sc=:= 	GREK}');
    Error('\P{Sc=:= 	GREK}');
    Expect(1, 119365, '\p{Sc=:\AGrek\z:}', "");;
    Expect(0, 119366, '\p{Sc=:\AGrek\z:}', "");;
    Expect(1, 119365, '\p{Sc=grek}', "");
    Expect(0, 119365, '\p{^Sc=grek}', "");
    Expect(0, 119365, '\P{Sc=grek}', "");
    Expect(1, 119365, '\P{^Sc=grek}', "");
    Expect(0, 119366, '\p{Sc=grek}', "");
    Expect(1, 119366, '\p{^Sc=grek}', "");
    Expect(1, 119366, '\P{Sc=grek}', "");
    Expect(0, 119366, '\P{^Sc=grek}', "");
    Expect(1, 119365, '\p{Sc=:\Agrek\z:}', "");;
    Expect(0, 119366, '\p{Sc=:\Agrek\z:}', "");;
    Expect(1, 119365, '\p{Sc=	-Grek}', "");
    Expect(0, 119365, '\p{^Sc=	-Grek}', "");
    Expect(0, 119365, '\P{Sc=	-Grek}', "");
    Expect(1, 119365, '\P{^Sc=	-Grek}', "");
    Expect(0, 119366, '\p{Sc=	-Grek}', "");
    Expect(1, 119366, '\p{^Sc=	-Grek}', "");
    Expect(1, 119366, '\P{Sc=	-Grek}', "");
    Expect(0, 119366, '\P{^Sc=	-Grek}', "");
    Error('\p{Is_Script=/a/ 	Greek}');
    Error('\P{Is_Script=/a/ 	Greek}');
    Expect(1, 119365, '\p{Is_Script=greek}', "");
    Expect(0, 119365, '\p{^Is_Script=greek}', "");
    Expect(0, 119365, '\P{Is_Script=greek}', "");
    Expect(1, 119365, '\P{^Is_Script=greek}', "");
    Expect(0, 119366, '\p{Is_Script=greek}', "");
    Expect(1, 119366, '\p{^Is_Script=greek}', "");
    Expect(1, 119366, '\P{Is_Script=greek}', "");
    Expect(0, 119366, '\P{^Is_Script=greek}', "");
    Expect(1, 119365, '\p{Is_Script=__Greek}', "");
    Expect(0, 119365, '\p{^Is_Script=__Greek}', "");
    Expect(0, 119365, '\P{Is_Script=__Greek}', "");
    Expect(1, 119365, '\P{^Is_Script=__Greek}', "");
    Expect(0, 119366, '\p{Is_Script=__Greek}', "");
    Expect(1, 119366, '\p{^Is_Script=__Greek}', "");
    Expect(1, 119366, '\P{Is_Script=__Greek}', "");
    Expect(0, 119366, '\P{^Is_Script=__Greek}', "");
    Error('\p{Is_Sc=	:=Grek}');
    Error('\P{Is_Sc=	:=Grek}');
    Expect(1, 119365, '\p{Is_Sc=grek}', "");
    Expect(0, 119365, '\p{^Is_Sc=grek}', "");
    Expect(0, 119365, '\P{Is_Sc=grek}', "");
    Expect(1, 119365, '\P{^Is_Sc=grek}', "");
    Expect(0, 119366, '\p{Is_Sc=grek}', "");
    Expect(1, 119366, '\p{^Is_Sc=grek}', "");
    Expect(1, 119366, '\P{Is_Sc=grek}', "");
    Expect(0, 119366, '\P{^Is_Sc=grek}', "");
    Expect(1, 119365, '\p{Is_Sc=	-Grek}', "");
    Expect(0, 119365, '\p{^Is_Sc=	-Grek}', "");
    Expect(0, 119365, '\P{Is_Sc=	-Grek}', "");
    Expect(1, 119365, '\P{^Is_Sc=	-Grek}', "");
    Expect(0, 119366, '\p{Is_Sc=	-Grek}', "");
    Expect(1, 119366, '\p{^Is_Sc=	-Grek}', "");
    Expect(1, 119366, '\P{Is_Sc=	-Grek}', "");
    Expect(0, 119366, '\P{^Is_Sc=	-Grek}', "");
    Error('\p{Script=:=-Gujarati}');
    Error('\P{Script=:=-Gujarati}');
    Expect(1, 2815, '\p{Script=:\AGujarati\z:}', "");;
    Expect(0, 2816, '\p{Script=:\AGujarati\z:}', "");;
    Expect(1, 2815, '\p{Script=gujarati}', "");
    Expect(0, 2815, '\p{^Script=gujarati}', "");
    Expect(0, 2815, '\P{Script=gujarati}', "");
    Expect(1, 2815, '\P{^Script=gujarati}', "");
    Expect(0, 2816, '\p{Script=gujarati}', "");
    Expect(1, 2816, '\p{^Script=gujarati}', "");
    Expect(1, 2816, '\P{Script=gujarati}', "");
    Expect(0, 2816, '\P{^Script=gujarati}', "");
    Expect(1, 2815, '\p{Script=:\Agujarati\z:}', "");;
    Expect(0, 2816, '\p{Script=:\Agujarati\z:}', "");;
    Expect(1, 2815, '\p{Script:   -Gujarati}', "");
    Expect(0, 2815, '\p{^Script:   -Gujarati}', "");
    Expect(0, 2815, '\P{Script:   -Gujarati}', "");
    Expect(1, 2815, '\P{^Script:   -Gujarati}', "");
    Expect(0, 2816, '\p{Script:   -Gujarati}', "");
    Expect(1, 2816, '\p{^Script:   -Gujarati}', "");
    Expect(1, 2816, '\P{Script:   -Gujarati}', "");
    Expect(0, 2816, '\P{^Script:   -Gujarati}', "");
    Error('\p{Sc=	GUJR/a/}');
    Error('\P{Sc=	GUJR/a/}');
    Expect(1, 2815, '\p{Sc=:\AGujr\z:}', "");;
    Expect(0, 2816, '\p{Sc=:\AGujr\z:}', "");;
    Expect(1, 2815, '\p{Sc=gujr}', "");
    Expect(0, 2815, '\p{^Sc=gujr}', "");
    Expect(0, 2815, '\P{Sc=gujr}', "");
    Expect(1, 2815, '\P{^Sc=gujr}', "");
    Expect(0, 2816, '\p{Sc=gujr}', "");
    Expect(1, 2816, '\p{^Sc=gujr}', "");
    Expect(1, 2816, '\P{Sc=gujr}', "");
    Expect(0, 2816, '\P{^Sc=gujr}', "");
    Expect(1, 2815, '\p{Sc=:\Agujr\z:}', "");;
    Expect(0, 2816, '\p{Sc=:\Agujr\z:}', "");;
    Expect(1, 2815, '\p{Sc=_-GUJR}', "");
    Expect(0, 2815, '\p{^Sc=_-GUJR}', "");
    Expect(0, 2815, '\P{Sc=_-GUJR}', "");
    Expect(1, 2815, '\P{^Sc=_-GUJR}', "");
    Expect(0, 2816, '\p{Sc=_-GUJR}', "");
    Expect(1, 2816, '\p{^Sc=_-GUJR}', "");
    Expect(1, 2816, '\P{Sc=_-GUJR}', "");
    Expect(0, 2816, '\P{^Sc=_-GUJR}', "");
    Error('\p{Is_Script=_gujarati/a/}');
    Error('\P{Is_Script=_gujarati/a/}');
    Expect(1, 2815, '\p{Is_Script=gujarati}', "");
    Expect(0, 2815, '\p{^Is_Script=gujarati}', "");
    Expect(0, 2815, '\P{Is_Script=gujarati}', "");
    Expect(1, 2815, '\P{^Is_Script=gujarati}', "");
    Expect(0, 2816, '\p{Is_Script=gujarati}', "");
    Expect(1, 2816, '\p{^Is_Script=gujarati}', "");
    Expect(1, 2816, '\P{Is_Script=gujarati}', "");
    Expect(0, 2816, '\P{^Is_Script=gujarati}', "");
    Expect(1, 2815, '\p{Is_Script: __Gujarati}', "");
    Expect(0, 2815, '\p{^Is_Script: __Gujarati}', "");
    Expect(0, 2815, '\P{Is_Script: __Gujarati}', "");
    Expect(1, 2815, '\P{^Is_Script: __Gujarati}', "");
    Expect(0, 2816, '\p{Is_Script: __Gujarati}', "");
    Expect(1, 2816, '\p{^Is_Script: __Gujarati}', "");
    Expect(1, 2816, '\P{Is_Script: __Gujarati}', "");
    Expect(0, 2816, '\P{^Is_Script: __Gujarati}', "");
    Error('\p{Is_Sc=	Gujr:=}');
    Error('\P{Is_Sc=	Gujr:=}');
    Expect(1, 2815, '\p{Is_Sc=gujr}', "");
    Expect(0, 2815, '\p{^Is_Sc=gujr}', "");
    Expect(0, 2815, '\P{Is_Sc=gujr}', "");
    Expect(1, 2815, '\P{^Is_Sc=gujr}', "");
    Expect(0, 2816, '\p{Is_Sc=gujr}', "");
    Expect(1, 2816, '\p{^Is_Sc=gujr}', "");
    Expect(1, 2816, '\P{Is_Sc=gujr}', "");
    Expect(0, 2816, '\P{^Is_Sc=gujr}', "");
    Expect(1, 2815, '\p{Is_Sc:	 	GUJR}', "");
    Expect(0, 2815, '\p{^Is_Sc:	 	GUJR}', "");
    Expect(0, 2815, '\P{Is_Sc:	 	GUJR}', "");
    Expect(1, 2815, '\P{^Is_Sc:	 	GUJR}', "");
    Expect(0, 2816, '\p{Is_Sc:	 	GUJR}', "");
    Expect(1, 2816, '\p{^Is_Sc:	 	GUJR}', "");
    Expect(1, 2816, '\P{Is_Sc:	 	GUJR}', "");
    Expect(0, 2816, '\P{^Is_Sc:	 	GUJR}', "");
    Error('\p{Script=_Gurmukhi/a/}');
    Error('\P{Script=_Gurmukhi/a/}');
    Expect(1, 2678, '\p{Script=:\AGurmukhi\z:}', "");;
    Expect(0, 2679, '\p{Script=:\AGurmukhi\z:}', "");;
    Expect(1, 2678, '\p{Script=gurmukhi}', "");
    Expect(0, 2678, '\p{^Script=gurmukhi}', "");
    Expect(0, 2678, '\P{Script=gurmukhi}', "");
    Expect(1, 2678, '\P{^Script=gurmukhi}', "");
    Expect(0, 2679, '\p{Script=gurmukhi}', "");
    Expect(1, 2679, '\p{^Script=gurmukhi}', "");
    Expect(1, 2679, '\P{Script=gurmukhi}', "");
    Expect(0, 2679, '\P{^Script=gurmukhi}', "");
    Expect(1, 2678, '\p{Script=:\Agurmukhi\z:}', "");;
    Expect(0, 2679, '\p{Script=:\Agurmukhi\z:}', "");;
    Expect(1, 2678, '\p{Script=_GURMUKHI}', "");
    Expect(0, 2678, '\p{^Script=_GURMUKHI}', "");
    Expect(0, 2678, '\P{Script=_GURMUKHI}', "");
    Expect(1, 2678, '\P{^Script=_GURMUKHI}', "");
    Expect(0, 2679, '\p{Script=_GURMUKHI}', "");
    Expect(1, 2679, '\p{^Script=_GURMUKHI}', "");
    Expect(1, 2679, '\P{Script=_GURMUKHI}', "");
    Expect(0, 2679, '\P{^Script=_GURMUKHI}', "");
    Error('\p{Sc=/a/_	Guru}');
    Error('\P{Sc=/a/_	Guru}');
    Expect(1, 2678, '\p{Sc=:\AGuru\z:}', "");;
    Expect(0, 2679, '\p{Sc=:\AGuru\z:}', "");;
    Expect(1, 2678, '\p{Sc=guru}', "");
    Expect(0, 2678, '\p{^Sc=guru}', "");
    Expect(0, 2678, '\P{Sc=guru}', "");
    Expect(1, 2678, '\P{^Sc=guru}', "");
    Expect(0, 2679, '\p{Sc=guru}', "");
    Expect(1, 2679, '\p{^Sc=guru}', "");
    Expect(1, 2679, '\P{Sc=guru}', "");
    Expect(0, 2679, '\P{^Sc=guru}', "");
    Expect(1, 2678, '\p{Sc=:\Aguru\z:}', "");;
    Expect(0, 2679, '\p{Sc=:\Aguru\z:}', "");;
    Expect(1, 2678, '\p{Sc=	-Guru}', "");
    Expect(0, 2678, '\p{^Sc=	-Guru}', "");
    Expect(0, 2678, '\P{Sc=	-Guru}', "");
    Expect(1, 2678, '\P{^Sc=	-Guru}', "");
    Expect(0, 2679, '\p{Sc=	-Guru}', "");
    Expect(1, 2679, '\p{^Sc=	-Guru}', "");
    Expect(1, 2679, '\P{Sc=	-Guru}', "");
    Expect(0, 2679, '\P{^Sc=	-Guru}', "");
    Error('\p{Is_Script=_	Gurmukhi/a/}');
    Error('\P{Is_Script=_	Gurmukhi/a/}');
    Expect(1, 2678, '\p{Is_Script=gurmukhi}', "");
    Expect(0, 2678, '\p{^Is_Script=gurmukhi}', "");
    Expect(0, 2678, '\P{Is_Script=gurmukhi}', "");
    Expect(1, 2678, '\P{^Is_Script=gurmukhi}', "");
    Expect(0, 2679, '\p{Is_Script=gurmukhi}', "");
    Expect(1, 2679, '\p{^Is_Script=gurmukhi}', "");
    Expect(1, 2679, '\P{Is_Script=gurmukhi}', "");
    Expect(0, 2679, '\P{^Is_Script=gurmukhi}', "");
    Expect(1, 2678, '\p{Is_Script=_ Gurmukhi}', "");
    Expect(0, 2678, '\p{^Is_Script=_ Gurmukhi}', "");
    Expect(0, 2678, '\P{Is_Script=_ Gurmukhi}', "");
    Expect(1, 2678, '\P{^Is_Script=_ Gurmukhi}', "");
    Expect(0, 2679, '\p{Is_Script=_ Gurmukhi}', "");
    Expect(1, 2679, '\p{^Is_Script=_ Gurmukhi}', "");
    Expect(1, 2679, '\P{Is_Script=_ Gurmukhi}', "");
    Expect(0, 2679, '\P{^Is_Script=_ Gurmukhi}', "");
    Error('\p{Is_Sc=_:=Guru}');
    Error('\P{Is_Sc=_:=Guru}');
    Expect(1, 2678, '\p{Is_Sc=guru}', "");
    Expect(0, 2678, '\p{^Is_Sc=guru}', "");
    Expect(0, 2678, '\P{Is_Sc=guru}', "");
    Expect(1, 2678, '\P{^Is_Sc=guru}', "");
    Expect(0, 2679, '\p{Is_Sc=guru}', "");
    Expect(1, 2679, '\p{^Is_Sc=guru}', "");
    Expect(1, 2679, '\P{Is_Sc=guru}', "");
    Expect(0, 2679, '\P{^Is_Sc=guru}', "");
    Expect(1, 2678, '\p{Is_Sc=-	guru}', "");
    Expect(0, 2678, '\p{^Is_Sc=-	guru}', "");
    Expect(0, 2678, '\P{Is_Sc=-	guru}', "");
    Expect(1, 2678, '\P{^Is_Sc=-	guru}', "");
    Expect(0, 2679, '\p{Is_Sc=-	guru}', "");
    Expect(1, 2679, '\p{^Is_Sc=-	guru}', "");
    Expect(1, 2679, '\P{Is_Sc=-	guru}', "");
    Expect(0, 2679, '\P{^Is_Sc=-	guru}', "");
    Error('\p{Script=	Hangul:=}');
    Error('\P{Script=	Hangul:=}');
    Expect(1, 65500, '\p{Script=:\AHangul\z:}', "");;
    Expect(0, 65501, '\p{Script=:\AHangul\z:}', "");;
    Expect(1, 65500, '\p{Script=hangul}', "");
    Expect(0, 65500, '\p{^Script=hangul}', "");
    Expect(0, 65500, '\P{Script=hangul}', "");
    Expect(1, 65500, '\P{^Script=hangul}', "");
    Expect(0, 65501, '\p{Script=hangul}', "");
    Expect(1, 65501, '\p{^Script=hangul}', "");
    Expect(1, 65501, '\P{Script=hangul}', "");
    Expect(0, 65501, '\P{^Script=hangul}', "");
    Expect(1, 65500, '\p{Script=:\Ahangul\z:}', "");;
    Expect(0, 65501, '\p{Script=:\Ahangul\z:}', "");;
    Expect(1, 65500, '\p{Script=	hangul}', "");
    Expect(0, 65500, '\p{^Script=	hangul}', "");
    Expect(0, 65500, '\P{Script=	hangul}', "");
    Expect(1, 65500, '\P{^Script=	hangul}', "");
    Expect(0, 65501, '\p{Script=	hangul}', "");
    Expect(1, 65501, '\p{^Script=	hangul}', "");
    Expect(1, 65501, '\P{Script=	hangul}', "");
    Expect(0, 65501, '\P{^Script=	hangul}', "");
    Error('\p{Sc=	_Hang:=}');
    Error('\P{Sc=	_Hang:=}');
    Expect(1, 65500, '\p{Sc=:\AHang\z:}', "");;
    Expect(0, 65501, '\p{Sc=:\AHang\z:}', "");;
    Expect(1, 65500, '\p{Sc=hang}', "");
    Expect(0, 65500, '\p{^Sc=hang}', "");
    Expect(0, 65500, '\P{Sc=hang}', "");
    Expect(1, 65500, '\P{^Sc=hang}', "");
    Expect(0, 65501, '\p{Sc=hang}', "");
    Expect(1, 65501, '\p{^Sc=hang}', "");
    Expect(1, 65501, '\P{Sc=hang}', "");
    Expect(0, 65501, '\P{^Sc=hang}', "");
    Expect(1, 65500, '\p{Sc=:\Ahang\z:}', "");;
    Expect(0, 65501, '\p{Sc=:\Ahang\z:}', "");;
    Expect(1, 65500, '\p{Sc:-_Hang}', "");
    Expect(0, 65500, '\p{^Sc:-_Hang}', "");
    Expect(0, 65500, '\P{Sc:-_Hang}', "");
    Expect(1, 65500, '\P{^Sc:-_Hang}', "");
    Expect(0, 65501, '\p{Sc:-_Hang}', "");
    Expect(1, 65501, '\p{^Sc:-_Hang}', "");
    Expect(1, 65501, '\P{Sc:-_Hang}', "");
    Expect(0, 65501, '\P{^Sc:-_Hang}', "");
    Error('\p{Is_Script=:=hangul}');
    Error('\P{Is_Script=:=hangul}');
    Expect(1, 65500, '\p{Is_Script=hangul}', "");
    Expect(0, 65500, '\p{^Is_Script=hangul}', "");
    Expect(0, 65500, '\P{Is_Script=hangul}', "");
    Expect(1, 65500, '\P{^Is_Script=hangul}', "");
    Expect(0, 65501, '\p{Is_Script=hangul}', "");
    Expect(1, 65501, '\p{^Is_Script=hangul}', "");
    Expect(1, 65501, '\P{Is_Script=hangul}', "");
    Expect(0, 65501, '\P{^Is_Script=hangul}', "");
    Expect(1, 65500, '\p{Is_Script=_ Hangul}', "");
    Expect(0, 65500, '\p{^Is_Script=_ Hangul}', "");
    Expect(0, 65500, '\P{Is_Script=_ Hangul}', "");
    Expect(1, 65500, '\P{^Is_Script=_ Hangul}', "");
    Expect(0, 65501, '\p{Is_Script=_ Hangul}', "");
    Expect(1, 65501, '\p{^Is_Script=_ Hangul}', "");
    Expect(1, 65501, '\P{Is_Script=_ Hangul}', "");
    Expect(0, 65501, '\P{^Is_Script=_ Hangul}', "");
    Error('\p{Is_Sc= 	Hang:=}');
    Error('\P{Is_Sc= 	Hang:=}');
    Expect(1, 65500, '\p{Is_Sc: hang}', "");
    Expect(0, 65500, '\p{^Is_Sc: hang}', "");
    Expect(0, 65500, '\P{Is_Sc: hang}', "");
    Expect(1, 65500, '\P{^Is_Sc: hang}', "");
    Expect(0, 65501, '\p{Is_Sc: hang}', "");
    Expect(1, 65501, '\p{^Is_Sc: hang}', "");
    Expect(1, 65501, '\P{Is_Sc: hang}', "");
    Expect(0, 65501, '\P{^Is_Sc: hang}', "");
    Expect(1, 65500, '\p{Is_Sc=	-Hang}', "");
    Expect(0, 65500, '\p{^Is_Sc=	-Hang}', "");
    Expect(0, 65500, '\P{Is_Sc=	-Hang}', "");
    Expect(1, 65500, '\P{^Is_Sc=	-Hang}', "");
    Expect(0, 65501, '\p{Is_Sc=	-Hang}', "");
    Expect(1, 65501, '\p{^Is_Sc=	-Hang}', "");
    Expect(1, 65501, '\P{Is_Sc=	-Hang}', "");
    Expect(0, 65501, '\P{^Is_Sc=	-Hang}', "");
    Error('\p{Script=:=Han}');
    Error('\P{Script=:=Han}');
    Expect(1, 201546, '\p{Script=:\AHan\z:}', "");;
    Expect(0, 201547, '\p{Script=:\AHan\z:}', "");;
    Expect(1, 201546, '\p{Script=han}', "");
    Expect(0, 201546, '\p{^Script=han}', "");
    Expect(0, 201546, '\P{Script=han}', "");
    Expect(1, 201546, '\P{^Script=han}', "");
    Expect(0, 201547, '\p{Script=han}', "");
    Expect(1, 201547, '\p{^Script=han}', "");
    Expect(1, 201547, '\P{Script=han}', "");
    Expect(0, 201547, '\P{^Script=han}', "");
    Expect(1, 201546, '\p{Script=:\Ahan\z:}', "");;
    Expect(0, 201547, '\p{Script=:\Ahan\z:}', "");;
    Expect(1, 201546, '\p{Script=_	han}', "");
    Expect(0, 201546, '\p{^Script=_	han}', "");
    Expect(0, 201546, '\P{Script=_	han}', "");
    Expect(1, 201546, '\P{^Script=_	han}', "");
    Expect(0, 201547, '\p{Script=_	han}', "");
    Expect(1, 201547, '\p{^Script=_	han}', "");
    Expect(1, 201547, '\P{Script=_	han}', "");
    Expect(0, 201547, '\P{^Script=_	han}', "");
    Error('\p{Sc=_ hani:=}');
    Error('\P{Sc=_ hani:=}');
    Expect(1, 201546, '\p{Sc=:\AHani\z:}', "");;
    Expect(0, 201547, '\p{Sc=:\AHani\z:}', "");;
    Expect(1, 201546, '\p{Sc=hani}', "");
    Expect(0, 201546, '\p{^Sc=hani}', "");
    Expect(0, 201546, '\P{Sc=hani}', "");
    Expect(1, 201546, '\P{^Sc=hani}', "");
    Expect(0, 201547, '\p{Sc=hani}', "");
    Expect(1, 201547, '\p{^Sc=hani}', "");
    Expect(1, 201547, '\P{Sc=hani}', "");
    Expect(0, 201547, '\P{^Sc=hani}', "");
    Expect(1, 201546, '\p{Sc=:\Ahani\z:}', "");;
    Expect(0, 201547, '\p{Sc=:\Ahani\z:}', "");;
    Expect(1, 201546, '\p{Sc=__Hani}', "");
    Expect(0, 201546, '\p{^Sc=__Hani}', "");
    Expect(0, 201546, '\P{Sc=__Hani}', "");
    Expect(1, 201546, '\P{^Sc=__Hani}', "");
    Expect(0, 201547, '\p{Sc=__Hani}', "");
    Expect(1, 201547, '\p{^Sc=__Hani}', "");
    Expect(1, 201547, '\P{Sc=__Hani}', "");
    Expect(0, 201547, '\P{^Sc=__Hani}', "");
    Error('\p{Is_Script:_/a/han}');
    Error('\P{Is_Script:_/a/han}');
    Expect(1, 201546, '\p{Is_Script=han}', "");
    Expect(0, 201546, '\p{^Is_Script=han}', "");
    Expect(0, 201546, '\P{Is_Script=han}', "");
    Expect(1, 201546, '\P{^Is_Script=han}', "");
    Expect(0, 201547, '\p{Is_Script=han}', "");
    Expect(1, 201547, '\p{^Is_Script=han}', "");
    Expect(1, 201547, '\P{Is_Script=han}', "");
    Expect(0, 201547, '\P{^Is_Script=han}', "");
    Expect(1, 201546, '\p{Is_Script=	-Han}', "");
    Expect(0, 201546, '\p{^Is_Script=	-Han}', "");
    Expect(0, 201546, '\P{Is_Script=	-Han}', "");
    Expect(1, 201546, '\P{^Is_Script=	-Han}', "");
    Expect(0, 201547, '\p{Is_Script=	-Han}', "");
    Expect(1, 201547, '\p{^Is_Script=	-Han}', "");
    Expect(1, 201547, '\P{Is_Script=	-Han}', "");
    Expect(0, 201547, '\P{^Is_Script=	-Han}', "");
    Error('\p{Is_Sc=-	HANI/a/}');
    Error('\P{Is_Sc=-	HANI/a/}');
    Expect(1, 201546, '\p{Is_Sc=hani}', "");
    Expect(0, 201546, '\p{^Is_Sc=hani}', "");
    Expect(0, 201546, '\P{Is_Sc=hani}', "");
    Expect(1, 201546, '\P{^Is_Sc=hani}', "");
    Expect(0, 201547, '\p{Is_Sc=hani}', "");
    Expect(1, 201547, '\p{^Is_Sc=hani}', "");
    Expect(1, 201547, '\P{Is_Sc=hani}', "");
    Expect(0, 201547, '\P{^Is_Sc=hani}', "");
    Expect(1, 201546, '\p{Is_Sc= hani}', "");
    Expect(0, 201546, '\p{^Is_Sc= hani}', "");
    Expect(0, 201546, '\P{Is_Sc= hani}', "");
    Expect(1, 201546, '\P{^Is_Sc= hani}', "");
    Expect(0, 201547, '\p{Is_Sc= hani}', "");
    Expect(1, 201547, '\p{^Is_Sc= hani}', "");
    Expect(1, 201547, '\P{Is_Sc= hani}', "");
    Expect(0, 201547, '\P{^Is_Sc= hani}', "");
    Error('\p{Script=-_hanunoo/a/}');
    Error('\P{Script=-_hanunoo/a/}');
    Expect(1, 5940, '\p{Script=:\AHanunoo\z:}', "");;
    Expect(0, 5941, '\p{Script=:\AHanunoo\z:}', "");;
    Expect(1, 5940, '\p{Script=hanunoo}', "");
    Expect(0, 5940, '\p{^Script=hanunoo}', "");
    Expect(0, 5940, '\P{Script=hanunoo}', "");
    Expect(1, 5940, '\P{^Script=hanunoo}', "");
    Expect(0, 5941, '\p{Script=hanunoo}', "");
    Expect(1, 5941, '\p{^Script=hanunoo}', "");
    Expect(1, 5941, '\P{Script=hanunoo}', "");
    Expect(0, 5941, '\P{^Script=hanunoo}', "");
    Expect(1, 5940, '\p{Script=:\Ahanunoo\z:}', "");;
    Expect(0, 5941, '\p{Script=:\Ahanunoo\z:}', "");;
    Expect(1, 5940, '\p{Script=	 HANUNOO}', "");
    Expect(0, 5940, '\p{^Script=	 HANUNOO}', "");
    Expect(0, 5940, '\P{Script=	 HANUNOO}', "");
    Expect(1, 5940, '\P{^Script=	 HANUNOO}', "");
    Expect(0, 5941, '\p{Script=	 HANUNOO}', "");
    Expect(1, 5941, '\p{^Script=	 HANUNOO}', "");
    Expect(1, 5941, '\P{Script=	 HANUNOO}', "");
    Expect(0, 5941, '\P{^Script=	 HANUNOO}', "");
    Error('\p{Sc=--Hano:=}');
    Error('\P{Sc=--Hano:=}');
    Expect(1, 5940, '\p{Sc=:\AHano\z:}', "");;
    Expect(0, 5941, '\p{Sc=:\AHano\z:}', "");;
    Expect(1, 5940, '\p{Sc:   hano}', "");
    Expect(0, 5940, '\p{^Sc:   hano}', "");
    Expect(0, 5940, '\P{Sc:   hano}', "");
    Expect(1, 5940, '\P{^Sc:   hano}', "");
    Expect(0, 5941, '\p{Sc:   hano}', "");
    Expect(1, 5941, '\p{^Sc:   hano}', "");
    Expect(1, 5941, '\P{Sc:   hano}', "");
    Expect(0, 5941, '\P{^Sc:   hano}', "");
    Expect(1, 5940, '\p{Sc=:\Ahano\z:}', "");;
    Expect(0, 5941, '\p{Sc=:\Ahano\z:}', "");;
    Expect(1, 5940, '\p{Sc: _-Hano}', "");
    Expect(0, 5940, '\p{^Sc: _-Hano}', "");
    Expect(0, 5940, '\P{Sc: _-Hano}', "");
    Expect(1, 5940, '\P{^Sc: _-Hano}', "");
    Expect(0, 5941, '\p{Sc: _-Hano}', "");
    Expect(1, 5941, '\p{^Sc: _-Hano}', "");
    Expect(1, 5941, '\P{Sc: _-Hano}', "");
    Expect(0, 5941, '\P{^Sc: _-Hano}', "");
    Error('\p{Is_Script=:= Hanunoo}');
    Error('\P{Is_Script=:= Hanunoo}');
    Expect(1, 5940, '\p{Is_Script=hanunoo}', "");
    Expect(0, 5940, '\p{^Is_Script=hanunoo}', "");
    Expect(0, 5940, '\P{Is_Script=hanunoo}', "");
    Expect(1, 5940, '\P{^Is_Script=hanunoo}', "");
    Expect(0, 5941, '\p{Is_Script=hanunoo}', "");
    Expect(1, 5941, '\p{^Is_Script=hanunoo}', "");
    Expect(1, 5941, '\P{Is_Script=hanunoo}', "");
    Expect(0, 5941, '\P{^Is_Script=hanunoo}', "");
    Expect(1, 5940, '\p{Is_Script=-Hanunoo}', "");
    Expect(0, 5940, '\p{^Is_Script=-Hanunoo}', "");
    Expect(0, 5940, '\P{Is_Script=-Hanunoo}', "");
    Expect(1, 5940, '\P{^Is_Script=-Hanunoo}', "");
    Expect(0, 5941, '\p{Is_Script=-Hanunoo}', "");
    Expect(1, 5941, '\p{^Is_Script=-Hanunoo}', "");
    Expect(1, 5941, '\P{Is_Script=-Hanunoo}', "");
    Expect(0, 5941, '\P{^Is_Script=-Hanunoo}', "");
    Error('\p{Is_Sc=_/a/HANO}');
    Error('\P{Is_Sc=_/a/HANO}');
    Expect(1, 5940, '\p{Is_Sc=hano}', "");
    Expect(0, 5940, '\p{^Is_Sc=hano}', "");
    Expect(0, 5940, '\P{Is_Sc=hano}', "");
    Expect(1, 5940, '\P{^Is_Sc=hano}', "");
    Expect(0, 5941, '\p{Is_Sc=hano}', "");
    Expect(1, 5941, '\p{^Is_Sc=hano}', "");
    Expect(1, 5941, '\P{Is_Sc=hano}', "");
    Expect(0, 5941, '\P{^Is_Sc=hano}', "");
    Expect(1, 5940, '\p{Is_Sc=-HANO}', "");
    Expect(0, 5940, '\p{^Is_Sc=-HANO}', "");
    Expect(0, 5940, '\P{Is_Sc=-HANO}', "");
    Expect(1, 5940, '\P{^Is_Sc=-HANO}', "");
    Expect(0, 5941, '\p{Is_Sc=-HANO}', "");
    Expect(1, 5941, '\p{^Is_Sc=-HANO}', "");
    Expect(1, 5941, '\P{Is_Sc=-HANO}', "");
    Expect(0, 5941, '\P{^Is_Sc=-HANO}', "");
    Error('\p{Script=-:=Hatran}');
    Error('\P{Script=-:=Hatran}');
    Expect(1, 67839, '\p{Script=:\AHatran\z:}', "");;
    Expect(0, 67840, '\p{Script=:\AHatran\z:}', "");;
    Expect(1, 67839, '\p{Script=hatran}', "");
    Expect(0, 67839, '\p{^Script=hatran}', "");
    Expect(0, 67839, '\P{Script=hatran}', "");
    Expect(1, 67839, '\P{^Script=hatran}', "");
    Expect(0, 67840, '\p{Script=hatran}', "");
    Expect(1, 67840, '\p{^Script=hatran}', "");
    Expect(1, 67840, '\P{Script=hatran}', "");
    Expect(0, 67840, '\P{^Script=hatran}', "");
    Expect(1, 67839, '\p{Script=:\Ahatran\z:}', "");;
    Expect(0, 67840, '\p{Script=:\Ahatran\z:}', "");;
    Expect(1, 67839, '\p{Script=_	Hatran}', "");
    Expect(0, 67839, '\p{^Script=_	Hatran}', "");
    Expect(0, 67839, '\P{Script=_	Hatran}', "");
    Expect(1, 67839, '\P{^Script=_	Hatran}', "");
    Expect(0, 67840, '\p{Script=_	Hatran}', "");
    Expect(1, 67840, '\p{^Script=_	Hatran}', "");
    Expect(1, 67840, '\P{Script=_	Hatran}', "");
    Expect(0, 67840, '\P{^Script=_	Hatran}', "");
    Error('\p{Sc=:=_	HATR}');
    Error('\P{Sc=:=_	HATR}');
    Expect(1, 67839, '\p{Sc=:\AHatr\z:}', "");;
    Expect(0, 67840, '\p{Sc=:\AHatr\z:}', "");;
    Expect(1, 67839, '\p{Sc=hatr}', "");
    Expect(0, 67839, '\p{^Sc=hatr}', "");
    Expect(0, 67839, '\P{Sc=hatr}', "");
    Expect(1, 67839, '\P{^Sc=hatr}', "");
    Expect(0, 67840, '\p{Sc=hatr}', "");
    Expect(1, 67840, '\p{^Sc=hatr}', "");
    Expect(1, 67840, '\P{Sc=hatr}', "");
    Expect(0, 67840, '\P{^Sc=hatr}', "");
    Expect(1, 67839, '\p{Sc=:\Ahatr\z:}', "");;
    Expect(0, 67840, '\p{Sc=:\Ahatr\z:}', "");;
    Expect(1, 67839, '\p{Sc= _HATR}', "");
    Expect(0, 67839, '\p{^Sc= _HATR}', "");
    Expect(0, 67839, '\P{Sc= _HATR}', "");
    Expect(1, 67839, '\P{^Sc= _HATR}', "");
    Expect(0, 67840, '\p{Sc= _HATR}', "");
    Expect(1, 67840, '\p{^Sc= _HATR}', "");
    Expect(1, 67840, '\P{Sc= _HATR}', "");
    Expect(0, 67840, '\P{^Sc= _HATR}', "");
    Error('\p{Is_Script=:=Hatran}');
    Error('\P{Is_Script=:=Hatran}');
    Expect(1, 67839, '\p{Is_Script=hatran}', "");
    Expect(0, 67839, '\p{^Is_Script=hatran}', "");
    Expect(0, 67839, '\P{Is_Script=hatran}', "");
    Expect(1, 67839, '\P{^Is_Script=hatran}', "");
    Expect(0, 67840, '\p{Is_Script=hatran}', "");
    Expect(1, 67840, '\p{^Is_Script=hatran}', "");
    Expect(1, 67840, '\P{Is_Script=hatran}', "");
    Expect(0, 67840, '\P{^Is_Script=hatran}', "");
    Expect(1, 67839, '\p{Is_Script=-Hatran}', "");
    Expect(0, 67839, '\p{^Is_Script=-Hatran}', "");
    Expect(0, 67839, '\P{Is_Script=-Hatran}', "");
    Expect(1, 67839, '\P{^Is_Script=-Hatran}', "");
    Expect(0, 67840, '\p{Is_Script=-Hatran}', "");
    Expect(1, 67840, '\p{^Is_Script=-Hatran}', "");
    Expect(1, 67840, '\P{Is_Script=-Hatran}', "");
    Expect(0, 67840, '\P{^Is_Script=-Hatran}', "");
    Error('\p{Is_Sc=	HATR/a/}');
    Error('\P{Is_Sc=	HATR/a/}');
    Expect(1, 67839, '\p{Is_Sc=hatr}', "");
    Expect(0, 67839, '\p{^Is_Sc=hatr}', "");
    Expect(0, 67839, '\P{Is_Sc=hatr}', "");
    Expect(1, 67839, '\P{^Is_Sc=hatr}', "");
    Expect(0, 67840, '\p{Is_Sc=hatr}', "");
    Expect(1, 67840, '\p{^Is_Sc=hatr}', "");
    Expect(1, 67840, '\P{Is_Sc=hatr}', "");
    Expect(0, 67840, '\P{^Is_Sc=hatr}', "");
    Expect(1, 67839, '\p{Is_Sc=_ Hatr}', "");
    Expect(0, 67839, '\p{^Is_Sc=_ Hatr}', "");
    Expect(0, 67839, '\P{Is_Sc=_ Hatr}', "");
    Expect(1, 67839, '\P{^Is_Sc=_ Hatr}', "");
    Expect(0, 67840, '\p{Is_Sc=_ Hatr}', "");
    Expect(1, 67840, '\p{^Is_Sc=_ Hatr}', "");
    Expect(1, 67840, '\P{Is_Sc=_ Hatr}', "");
    Expect(0, 67840, '\P{^Is_Sc=_ Hatr}', "");
    Error('\p{Script:_-HEBREW:=}');
    Error('\P{Script:_-HEBREW:=}');
    Expect(1, 64335, '\p{Script=:\AHebrew\z:}', "");;
    Expect(0, 64336, '\p{Script=:\AHebrew\z:}', "");;
    Expect(1, 64335, '\p{Script=hebrew}', "");
    Expect(0, 64335, '\p{^Script=hebrew}', "");
    Expect(0, 64335, '\P{Script=hebrew}', "");
    Expect(1, 64335, '\P{^Script=hebrew}', "");
    Expect(0, 64336, '\p{Script=hebrew}', "");
    Expect(1, 64336, '\p{^Script=hebrew}', "");
    Expect(1, 64336, '\P{Script=hebrew}', "");
    Expect(0, 64336, '\P{^Script=hebrew}', "");
    Expect(1, 64335, '\p{Script=:\Ahebrew\z:}', "");;
    Expect(0, 64336, '\p{Script=:\Ahebrew\z:}', "");;
    Expect(1, 64335, '\p{Script=--HEBREW}', "");
    Expect(0, 64335, '\p{^Script=--HEBREW}', "");
    Expect(0, 64335, '\P{Script=--HEBREW}', "");
    Expect(1, 64335, '\P{^Script=--HEBREW}', "");
    Expect(0, 64336, '\p{Script=--HEBREW}', "");
    Expect(1, 64336, '\p{^Script=--HEBREW}', "");
    Expect(1, 64336, '\P{Script=--HEBREW}', "");
    Expect(0, 64336, '\P{^Script=--HEBREW}', "");
    Error('\p{Sc=/a/	HEBR}');
    Error('\P{Sc=/a/	HEBR}');
    Expect(1, 64335, '\p{Sc=:\AHebr\z:}', "");;
    Expect(0, 64336, '\p{Sc=:\AHebr\z:}', "");;
    Expect(1, 64335, '\p{Sc=hebr}', "");
    Expect(0, 64335, '\p{^Sc=hebr}', "");
    Expect(0, 64335, '\P{Sc=hebr}', "");
    Expect(1, 64335, '\P{^Sc=hebr}', "");
    Expect(0, 64336, '\p{Sc=hebr}', "");
    Expect(1, 64336, '\p{^Sc=hebr}', "");
    Expect(1, 64336, '\P{Sc=hebr}', "");
    Expect(0, 64336, '\P{^Sc=hebr}', "");
    Expect(1, 64335, '\p{Sc=:\Ahebr\z:}', "");;
    Expect(0, 64336, '\p{Sc=:\Ahebr\z:}', "");;
    Expect(1, 64335, '\p{Sc=__Hebr}', "");
    Expect(0, 64335, '\p{^Sc=__Hebr}', "");
    Expect(0, 64335, '\P{Sc=__Hebr}', "");
    Expect(1, 64335, '\P{^Sc=__Hebr}', "");
    Expect(0, 64336, '\p{Sc=__Hebr}', "");
    Expect(1, 64336, '\p{^Sc=__Hebr}', "");
    Expect(1, 64336, '\P{Sc=__Hebr}', "");
    Expect(0, 64336, '\P{^Sc=__Hebr}', "");
    Error('\p{Is_Script=_:=Hebrew}');
    Error('\P{Is_Script=_:=Hebrew}');
    Expect(1, 64335, '\p{Is_Script=hebrew}', "");
    Expect(0, 64335, '\p{^Is_Script=hebrew}', "");
    Expect(0, 64335, '\P{Is_Script=hebrew}', "");
    Expect(1, 64335, '\P{^Is_Script=hebrew}', "");
    Expect(0, 64336, '\p{Is_Script=hebrew}', "");
    Expect(1, 64336, '\p{^Is_Script=hebrew}', "");
    Expect(1, 64336, '\P{Is_Script=hebrew}', "");
    Expect(0, 64336, '\P{^Is_Script=hebrew}', "");
    Expect(1, 64335, '\p{Is_Script=  hebrew}', "");
    Expect(0, 64335, '\p{^Is_Script=  hebrew}', "");
    Expect(0, 64335, '\P{Is_Script=  hebrew}', "");
    Expect(1, 64335, '\P{^Is_Script=  hebrew}', "");
    Expect(0, 64336, '\p{Is_Script=  hebrew}', "");
    Expect(1, 64336, '\p{^Is_Script=  hebrew}', "");
    Expect(1, 64336, '\P{Is_Script=  hebrew}', "");
    Expect(0, 64336, '\P{^Is_Script=  hebrew}', "");
    Error('\p{Is_Sc=	/a/HEBR}');
    Error('\P{Is_Sc=	/a/HEBR}');
    Expect(1, 64335, '\p{Is_Sc:hebr}', "");
    Expect(0, 64335, '\p{^Is_Sc:hebr}', "");
    Expect(0, 64335, '\P{Is_Sc:hebr}', "");
    Expect(1, 64335, '\P{^Is_Sc:hebr}', "");
    Expect(0, 64336, '\p{Is_Sc:hebr}', "");
    Expect(1, 64336, '\p{^Is_Sc:hebr}', "");
    Expect(1, 64336, '\P{Is_Sc:hebr}', "");
    Expect(0, 64336, '\P{^Is_Sc:hebr}', "");
    Expect(1, 64335, '\p{Is_Sc=--HEBR}', "");
    Expect(0, 64335, '\p{^Is_Sc=--HEBR}', "");
    Expect(0, 64335, '\P{Is_Sc=--HEBR}', "");
    Expect(1, 64335, '\P{^Is_Sc=--HEBR}', "");
    Expect(0, 64336, '\p{Is_Sc=--HEBR}', "");
    Expect(1, 64336, '\p{^Is_Sc=--HEBR}', "");
    Expect(1, 64336, '\P{Is_Sc=--HEBR}', "");
    Expect(0, 64336, '\P{^Is_Sc=--HEBR}', "");
    Error('\p{Script:	 HIRAGANA/a/}');
    Error('\P{Script:	 HIRAGANA/a/}');
    Expect(1, 127488, '\p{Script=:\AHiragana\z:}', "");;
    Expect(0, 127489, '\p{Script=:\AHiragana\z:}', "");;
    Expect(1, 127488, '\p{Script=hiragana}', "");
    Expect(0, 127488, '\p{^Script=hiragana}', "");
    Expect(0, 127488, '\P{Script=hiragana}', "");
    Expect(1, 127488, '\P{^Script=hiragana}', "");
    Expect(0, 127489, '\p{Script=hiragana}', "");
    Expect(1, 127489, '\p{^Script=hiragana}', "");
    Expect(1, 127489, '\P{Script=hiragana}', "");
    Expect(0, 127489, '\P{^Script=hiragana}', "");
    Expect(1, 127488, '\p{Script=:\Ahiragana\z:}', "");;
    Expect(0, 127489, '\p{Script=:\Ahiragana\z:}', "");;
    Expect(1, 127488, '\p{Script=  hiragana}', "");
    Expect(0, 127488, '\p{^Script=  hiragana}', "");
    Expect(0, 127488, '\P{Script=  hiragana}', "");
    Expect(1, 127488, '\P{^Script=  hiragana}', "");
    Expect(0, 127489, '\p{Script=  hiragana}', "");
    Expect(1, 127489, '\p{^Script=  hiragana}', "");
    Expect(1, 127489, '\P{Script=  hiragana}', "");
    Expect(0, 127489, '\P{^Script=  hiragana}', "");
    Error('\p{Sc=/a/HIRA}');
    Error('\P{Sc=/a/HIRA}');
    Expect(1, 127488, '\p{Sc=:\AHira\z:}', "");;
    Expect(0, 127489, '\p{Sc=:\AHira\z:}', "");;
    Expect(1, 127488, '\p{Sc=hira}', "");
    Expect(0, 127488, '\p{^Sc=hira}', "");
    Expect(0, 127488, '\P{Sc=hira}', "");
    Expect(1, 127488, '\P{^Sc=hira}', "");
    Expect(0, 127489, '\p{Sc=hira}', "");
    Expect(1, 127489, '\p{^Sc=hira}', "");
    Expect(1, 127489, '\P{Sc=hira}', "");
    Expect(0, 127489, '\P{^Sc=hira}', "");
    Expect(1, 127488, '\p{Sc=:\Ahira\z:}', "");;
    Expect(0, 127489, '\p{Sc=:\Ahira\z:}', "");;
    Expect(1, 127488, '\p{Sc= 	Hira}', "");
    Expect(0, 127488, '\p{^Sc= 	Hira}', "");
    Expect(0, 127488, '\P{Sc= 	Hira}', "");
    Expect(1, 127488, '\P{^Sc= 	Hira}', "");
    Expect(0, 127489, '\p{Sc= 	Hira}', "");
    Expect(1, 127489, '\p{^Sc= 	Hira}', "");
    Expect(1, 127489, '\P{Sc= 	Hira}', "");
    Expect(0, 127489, '\P{^Sc= 	Hira}', "");
    Error('\p{Is_Script=:=-HIRAGANA}');
    Error('\P{Is_Script=:=-HIRAGANA}');
    Expect(1, 127488, '\p{Is_Script=hiragana}', "");
    Expect(0, 127488, '\p{^Is_Script=hiragana}', "");
    Expect(0, 127488, '\P{Is_Script=hiragana}', "");
    Expect(1, 127488, '\P{^Is_Script=hiragana}', "");
    Expect(0, 127489, '\p{Is_Script=hiragana}', "");
    Expect(1, 127489, '\p{^Is_Script=hiragana}', "");
    Expect(1, 127489, '\P{Is_Script=hiragana}', "");
    Expect(0, 127489, '\P{^Is_Script=hiragana}', "");
    Expect(1, 127488, '\p{Is_Script= HIRAGANA}', "");
    Expect(0, 127488, '\p{^Is_Script= HIRAGANA}', "");
    Expect(0, 127488, '\P{Is_Script= HIRAGANA}', "");
    Expect(1, 127488, '\P{^Is_Script= HIRAGANA}', "");
    Expect(0, 127489, '\p{Is_Script= HIRAGANA}', "");
    Expect(1, 127489, '\p{^Is_Script= HIRAGANA}', "");
    Expect(1, 127489, '\P{Is_Script= HIRAGANA}', "");
    Expect(0, 127489, '\P{^Is_Script= HIRAGANA}', "");
    Error('\p{Is_Sc=	_HIRA/a/}');
    Error('\P{Is_Sc=	_HIRA/a/}');
    Expect(1, 127488, '\p{Is_Sc=hira}', "");
    Expect(0, 127488, '\p{^Is_Sc=hira}', "");
    Expect(0, 127488, '\P{Is_Sc=hira}', "");
    Expect(1, 127488, '\P{^Is_Sc=hira}', "");
    Expect(0, 127489, '\p{Is_Sc=hira}', "");
    Expect(1, 127489, '\p{^Is_Sc=hira}', "");
    Expect(1, 127489, '\P{Is_Sc=hira}', "");
    Expect(0, 127489, '\P{^Is_Sc=hira}', "");
    Expect(1, 127488, '\p{Is_Sc=	-HIRA}', "");
    Expect(0, 127488, '\p{^Is_Sc=	-HIRA}', "");
    Expect(0, 127488, '\P{Is_Sc=	-HIRA}', "");
    Expect(1, 127488, '\P{^Is_Sc=	-HIRA}', "");
    Expect(0, 127489, '\p{Is_Sc=	-HIRA}', "");
    Expect(1, 127489, '\p{^Is_Sc=	-HIRA}', "");
    Expect(1, 127489, '\P{Is_Sc=	-HIRA}', "");
    Expect(0, 127489, '\P{^Is_Sc=	-HIRA}', "");
    Error('\p{Script= anatolian_HIEROGLYPHS/a/}');
    Error('\P{Script= anatolian_HIEROGLYPHS/a/}');
    Expect(1, 83526, '\p{Script=:\AAnatolian_Hieroglyphs\z:}', "");;
    Expect(0, 83527, '\p{Script=:\AAnatolian_Hieroglyphs\z:}', "");;
    Expect(1, 83526, '\p{Script=anatolianhieroglyphs}', "");
    Expect(0, 83526, '\p{^Script=anatolianhieroglyphs}', "");
    Expect(0, 83526, '\P{Script=anatolianhieroglyphs}', "");
    Expect(1, 83526, '\P{^Script=anatolianhieroglyphs}', "");
    Expect(0, 83527, '\p{Script=anatolianhieroglyphs}', "");
    Expect(1, 83527, '\p{^Script=anatolianhieroglyphs}', "");
    Expect(1, 83527, '\P{Script=anatolianhieroglyphs}', "");
    Expect(0, 83527, '\P{^Script=anatolianhieroglyphs}', "");
    Expect(1, 83526, '\p{Script=:\Aanatolianhieroglyphs\z:}', "");;
    Expect(0, 83527, '\p{Script=:\Aanatolianhieroglyphs\z:}', "");;
    Expect(1, 83526, '\p{Script=-	anatolian_hieroglyphs}', "");
    Expect(0, 83526, '\p{^Script=-	anatolian_hieroglyphs}', "");
    Expect(0, 83526, '\P{Script=-	anatolian_hieroglyphs}', "");
    Expect(1, 83526, '\P{^Script=-	anatolian_hieroglyphs}', "");
    Expect(0, 83527, '\p{Script=-	anatolian_hieroglyphs}', "");
    Expect(1, 83527, '\p{^Script=-	anatolian_hieroglyphs}', "");
    Expect(1, 83527, '\P{Script=-	anatolian_hieroglyphs}', "");
    Expect(0, 83527, '\P{^Script=-	anatolian_hieroglyphs}', "");
    Error('\p{Sc=/a/-Hluw}');
    Error('\P{Sc=/a/-Hluw}');
    Expect(1, 83526, '\p{Sc=:\AHluw\z:}', "");;
    Expect(0, 83527, '\p{Sc=:\AHluw\z:}', "");;
    Expect(1, 83526, '\p{Sc=hluw}', "");
    Expect(0, 83526, '\p{^Sc=hluw}', "");
    Expect(0, 83526, '\P{Sc=hluw}', "");
    Expect(1, 83526, '\P{^Sc=hluw}', "");
    Expect(0, 83527, '\p{Sc=hluw}', "");
    Expect(1, 83527, '\p{^Sc=hluw}', "");
    Expect(1, 83527, '\P{Sc=hluw}', "");
    Expect(0, 83527, '\P{^Sc=hluw}', "");
    Expect(1, 83526, '\p{Sc=:\Ahluw\z:}', "");;
    Expect(0, 83527, '\p{Sc=:\Ahluw\z:}', "");;
    Expect(1, 83526, '\p{Sc: -HLUW}', "");
    Expect(0, 83526, '\p{^Sc: -HLUW}', "");
    Expect(0, 83526, '\P{Sc: -HLUW}', "");
    Expect(1, 83526, '\P{^Sc: -HLUW}', "");
    Expect(0, 83527, '\p{Sc: -HLUW}', "");
    Expect(1, 83527, '\p{^Sc: -HLUW}', "");
    Expect(1, 83527, '\P{Sc: -HLUW}', "");
    Expect(0, 83527, '\P{^Sc: -HLUW}', "");
    Error('\p{Is_Script=	-ANATOLIAN_hieroglyphs/a/}');
    Error('\P{Is_Script=	-ANATOLIAN_hieroglyphs/a/}');
    Expect(1, 83526, '\p{Is_Script=anatolianhieroglyphs}', "");
    Expect(0, 83526, '\p{^Is_Script=anatolianhieroglyphs}', "");
    Expect(0, 83526, '\P{Is_Script=anatolianhieroglyphs}', "");
    Expect(1, 83526, '\P{^Is_Script=anatolianhieroglyphs}', "");
    Expect(0, 83527, '\p{Is_Script=anatolianhieroglyphs}', "");
    Expect(1, 83527, '\p{^Is_Script=anatolianhieroglyphs}', "");
    Expect(1, 83527, '\P{Is_Script=anatolianhieroglyphs}', "");
    Expect(0, 83527, '\P{^Is_Script=anatolianhieroglyphs}', "");
    Expect(1, 83526, '\p{Is_Script=_	anatolian_hieroglyphs}', "");
    Expect(0, 83526, '\p{^Is_Script=_	anatolian_hieroglyphs}', "");
    Expect(0, 83526, '\P{Is_Script=_	anatolian_hieroglyphs}', "");
    Expect(1, 83526, '\P{^Is_Script=_	anatolian_hieroglyphs}', "");
    Expect(0, 83527, '\p{Is_Script=_	anatolian_hieroglyphs}', "");
    Expect(1, 83527, '\p{^Is_Script=_	anatolian_hieroglyphs}', "");
    Expect(1, 83527, '\P{Is_Script=_	anatolian_hieroglyphs}', "");
    Expect(0, 83527, '\P{^Is_Script=_	anatolian_hieroglyphs}', "");
    Error('\p{Is_Sc=		Hluw:=}');
    Error('\P{Is_Sc=		Hluw:=}');
    Expect(1, 83526, '\p{Is_Sc=hluw}', "");
    Expect(0, 83526, '\p{^Is_Sc=hluw}', "");
    Expect(0, 83526, '\P{Is_Sc=hluw}', "");
    Expect(1, 83526, '\P{^Is_Sc=hluw}', "");
    Expect(0, 83527, '\p{Is_Sc=hluw}', "");
    Expect(1, 83527, '\p{^Is_Sc=hluw}', "");
    Expect(1, 83527, '\P{Is_Sc=hluw}', "");
    Expect(0, 83527, '\P{^Is_Sc=hluw}', "");
    Expect(1, 83526, '\p{Is_Sc=	_HLUW}', "");
    Expect(0, 83526, '\p{^Is_Sc=	_HLUW}', "");
    Expect(0, 83526, '\P{Is_Sc=	_HLUW}', "");
    Expect(1, 83526, '\P{^Is_Sc=	_HLUW}', "");
    Expect(0, 83527, '\p{Is_Sc=	_HLUW}', "");
    Expect(1, 83527, '\p{^Is_Sc=	_HLUW}', "");
    Expect(1, 83527, '\P{Is_Sc=	_HLUW}', "");
    Expect(0, 83527, '\P{^Is_Sc=	_HLUW}', "");
    Error('\p{Script=-PAHAWH_hmong:=}');
    Error('\P{Script=-PAHAWH_hmong:=}');
    Expect(1, 93071, '\p{Script=:\APahawh_Hmong\z:}', "");;
    Expect(0, 93072, '\p{Script=:\APahawh_Hmong\z:}', "");;
    Expect(1, 93071, '\p{Script=pahawhhmong}', "");
    Expect(0, 93071, '\p{^Script=pahawhhmong}', "");
    Expect(0, 93071, '\P{Script=pahawhhmong}', "");
    Expect(1, 93071, '\P{^Script=pahawhhmong}', "");
    Expect(0, 93072, '\p{Script=pahawhhmong}', "");
    Expect(1, 93072, '\p{^Script=pahawhhmong}', "");
    Expect(1, 93072, '\P{Script=pahawhhmong}', "");
    Expect(0, 93072, '\P{^Script=pahawhhmong}', "");
    Expect(1, 93071, '\p{Script=:\Apahawhhmong\z:}', "");;
    Expect(0, 93072, '\p{Script=:\Apahawhhmong\z:}', "");;
    Expect(1, 93071, '\p{Script=-PAHAWH_HMONG}', "");
    Expect(0, 93071, '\p{^Script=-PAHAWH_HMONG}', "");
    Expect(0, 93071, '\P{Script=-PAHAWH_HMONG}', "");
    Expect(1, 93071, '\P{^Script=-PAHAWH_HMONG}', "");
    Expect(0, 93072, '\p{Script=-PAHAWH_HMONG}', "");
    Expect(1, 93072, '\p{^Script=-PAHAWH_HMONG}', "");
    Expect(1, 93072, '\P{Script=-PAHAWH_HMONG}', "");
    Expect(0, 93072, '\P{^Script=-PAHAWH_HMONG}', "");
    Error('\p{Sc=/a/-_Hmng}');
    Error('\P{Sc=/a/-_Hmng}');
    Expect(1, 93071, '\p{Sc=:\AHmng\z:}', "");;
    Expect(0, 93072, '\p{Sc=:\AHmng\z:}', "");;
    Expect(1, 93071, '\p{Sc=hmng}', "");
    Expect(0, 93071, '\p{^Sc=hmng}', "");
    Expect(0, 93071, '\P{Sc=hmng}', "");
    Expect(1, 93071, '\P{^Sc=hmng}', "");
    Expect(0, 93072, '\p{Sc=hmng}', "");
    Expect(1, 93072, '\p{^Sc=hmng}', "");
    Expect(1, 93072, '\P{Sc=hmng}', "");
    Expect(0, 93072, '\P{^Sc=hmng}', "");
    Expect(1, 93071, '\p{Sc=:\Ahmng\z:}', "");;
    Expect(0, 93072, '\p{Sc=:\Ahmng\z:}', "");;
    Expect(1, 93071, '\p{Sc=_hmng}', "");
    Expect(0, 93071, '\p{^Sc=_hmng}', "");
    Expect(0, 93071, '\P{Sc=_hmng}', "");
    Expect(1, 93071, '\P{^Sc=_hmng}', "");
    Expect(0, 93072, '\p{Sc=_hmng}', "");
    Expect(1, 93072, '\p{^Sc=_hmng}', "");
    Expect(1, 93072, '\P{Sc=_hmng}', "");
    Expect(0, 93072, '\P{^Sc=_hmng}', "");
    Error('\p{Is_Script=	:=Pahawh_hmong}');
    Error('\P{Is_Script=	:=Pahawh_hmong}');
    Expect(1, 93071, '\p{Is_Script=pahawhhmong}', "");
    Expect(0, 93071, '\p{^Is_Script=pahawhhmong}', "");
    Expect(0, 93071, '\P{Is_Script=pahawhhmong}', "");
    Expect(1, 93071, '\P{^Is_Script=pahawhhmong}', "");
    Expect(0, 93072, '\p{Is_Script=pahawhhmong}', "");
    Expect(1, 93072, '\p{^Is_Script=pahawhhmong}', "");
    Expect(1, 93072, '\P{Is_Script=pahawhhmong}', "");
    Expect(0, 93072, '\P{^Is_Script=pahawhhmong}', "");
    Expect(1, 93071, '\p{Is_Script=  pahawh_Hmong}', "");
    Expect(0, 93071, '\p{^Is_Script=  pahawh_Hmong}', "");
    Expect(0, 93071, '\P{Is_Script=  pahawh_Hmong}', "");
    Expect(1, 93071, '\P{^Is_Script=  pahawh_Hmong}', "");
    Expect(0, 93072, '\p{Is_Script=  pahawh_Hmong}', "");
    Expect(1, 93072, '\p{^Is_Script=  pahawh_Hmong}', "");
    Expect(1, 93072, '\P{Is_Script=  pahawh_Hmong}', "");
    Expect(0, 93072, '\P{^Is_Script=  pahawh_Hmong}', "");
    Error('\p{Is_Sc=	/a/Hmng}');
    Error('\P{Is_Sc=	/a/Hmng}');
    Expect(1, 93071, '\p{Is_Sc=hmng}', "");
    Expect(0, 93071, '\p{^Is_Sc=hmng}', "");
    Expect(0, 93071, '\P{Is_Sc=hmng}', "");
    Expect(1, 93071, '\P{^Is_Sc=hmng}', "");
    Expect(0, 93072, '\p{Is_Sc=hmng}', "");
    Expect(1, 93072, '\p{^Is_Sc=hmng}', "");
    Expect(1, 93072, '\P{Is_Sc=hmng}', "");
    Expect(0, 93072, '\P{^Is_Sc=hmng}', "");
    Expect(1, 93071, '\p{Is_Sc:	_	Hmng}', "");
    Expect(0, 93071, '\p{^Is_Sc:	_	Hmng}', "");
    Expect(0, 93071, '\P{Is_Sc:	_	Hmng}', "");
    Expect(1, 93071, '\P{^Is_Sc:	_	Hmng}', "");
    Expect(0, 93072, '\p{Is_Sc:	_	Hmng}', "");
    Expect(1, 93072, '\p{^Is_Sc:	_	Hmng}', "");
    Expect(1, 93072, '\P{Is_Sc:	_	Hmng}', "");
    Expect(0, 93072, '\P{^Is_Sc:	_	Hmng}', "");
    Error('\p{Script= nyiakeng_puachue_Hmong:=}');
    Error('\P{Script= nyiakeng_puachue_Hmong:=}');
    Expect(1, 123215, '\p{Script=:\ANyiakeng_Puachue_Hmong\z:}', "");;
    Expect(0, 123216, '\p{Script=:\ANyiakeng_Puachue_Hmong\z:}', "");;
    Expect(1, 123215, '\p{Script:nyiakengpuachuehmong}', "");
    Expect(0, 123215, '\p{^Script:nyiakengpuachuehmong}', "");
    Expect(0, 123215, '\P{Script:nyiakengpuachuehmong}', "");
    Expect(1, 123215, '\P{^Script:nyiakengpuachuehmong}', "");
    Expect(0, 123216, '\p{Script:nyiakengpuachuehmong}', "");
    Expect(1, 123216, '\p{^Script:nyiakengpuachuehmong}', "");
    Expect(1, 123216, '\P{Script:nyiakengpuachuehmong}', "");
    Expect(0, 123216, '\P{^Script:nyiakengpuachuehmong}', "");
    Expect(1, 123215, '\p{Script=:\Anyiakengpuachuehmong\z:}', "");;
    Expect(0, 123216, '\p{Script=:\Anyiakengpuachuehmong\z:}', "");;
    Expect(1, 123215, '\p{Script=  nyiakeng_Puachue_hmong}', "");
    Expect(0, 123215, '\p{^Script=  nyiakeng_Puachue_hmong}', "");
    Expect(0, 123215, '\P{Script=  nyiakeng_Puachue_hmong}', "");
    Expect(1, 123215, '\P{^Script=  nyiakeng_Puachue_hmong}', "");
    Expect(0, 123216, '\p{Script=  nyiakeng_Puachue_hmong}', "");
    Expect(1, 123216, '\p{^Script=  nyiakeng_Puachue_hmong}', "");
    Expect(1, 123216, '\P{Script=  nyiakeng_Puachue_hmong}', "");
    Expect(0, 123216, '\P{^Script=  nyiakeng_Puachue_hmong}', "");
    Error('\p{Sc=:=_	Hmnp}');
    Error('\P{Sc=:=_	Hmnp}');
    Expect(1, 123215, '\p{Sc=:\AHmnp\z:}', "");;
    Expect(0, 123216, '\p{Sc=:\AHmnp\z:}', "");;
    Expect(1, 123215, '\p{Sc=hmnp}', "");
    Expect(0, 123215, '\p{^Sc=hmnp}', "");
    Expect(0, 123215, '\P{Sc=hmnp}', "");
    Expect(1, 123215, '\P{^Sc=hmnp}', "");
    Expect(0, 123216, '\p{Sc=hmnp}', "");
    Expect(1, 123216, '\p{^Sc=hmnp}', "");
    Expect(1, 123216, '\P{Sc=hmnp}', "");
    Expect(0, 123216, '\P{^Sc=hmnp}', "");
    Expect(1, 123215, '\p{Sc=:\Ahmnp\z:}', "");;
    Expect(0, 123216, '\p{Sc=:\Ahmnp\z:}', "");;
    Expect(1, 123215, '\p{Sc= -Hmnp}', "");
    Expect(0, 123215, '\p{^Sc= -Hmnp}', "");
    Expect(0, 123215, '\P{Sc= -Hmnp}', "");
    Expect(1, 123215, '\P{^Sc= -Hmnp}', "");
    Expect(0, 123216, '\p{Sc= -Hmnp}', "");
    Expect(1, 123216, '\p{^Sc= -Hmnp}', "");
    Expect(1, 123216, '\P{Sc= -Hmnp}', "");
    Expect(0, 123216, '\P{^Sc= -Hmnp}', "");
    Error('\p{Is_Script=/a/ 	NYIAKENG_Puachue_Hmong}');
    Error('\P{Is_Script=/a/ 	NYIAKENG_Puachue_Hmong}');
    Expect(1, 123215, '\p{Is_Script=nyiakengpuachuehmong}', "");
    Expect(0, 123215, '\p{^Is_Script=nyiakengpuachuehmong}', "");
    Expect(0, 123215, '\P{Is_Script=nyiakengpuachuehmong}', "");
    Expect(1, 123215, '\P{^Is_Script=nyiakengpuachuehmong}', "");
    Expect(0, 123216, '\p{Is_Script=nyiakengpuachuehmong}', "");
    Expect(1, 123216, '\p{^Is_Script=nyiakengpuachuehmong}', "");
    Expect(1, 123216, '\P{Is_Script=nyiakengpuachuehmong}', "");
    Expect(0, 123216, '\P{^Is_Script=nyiakengpuachuehmong}', "");
    Expect(1, 123215, '\p{Is_Script=-nyiakeng_Puachue_HMONG}', "");
    Expect(0, 123215, '\p{^Is_Script=-nyiakeng_Puachue_HMONG}', "");
    Expect(0, 123215, '\P{Is_Script=-nyiakeng_Puachue_HMONG}', "");
    Expect(1, 123215, '\P{^Is_Script=-nyiakeng_Puachue_HMONG}', "");
    Expect(0, 123216, '\p{Is_Script=-nyiakeng_Puachue_HMONG}', "");
    Expect(1, 123216, '\p{^Is_Script=-nyiakeng_Puachue_HMONG}', "");
    Expect(1, 123216, '\P{Is_Script=-nyiakeng_Puachue_HMONG}', "");
    Expect(0, 123216, '\P{^Is_Script=-nyiakeng_Puachue_HMONG}', "");
    Error('\p{Is_Sc:   := hmnp}');
    Error('\P{Is_Sc:   := hmnp}');
    Expect(1, 123215, '\p{Is_Sc=hmnp}', "");
    Expect(0, 123215, '\p{^Is_Sc=hmnp}', "");
    Expect(0, 123215, '\P{Is_Sc=hmnp}', "");
    Expect(1, 123215, '\P{^Is_Sc=hmnp}', "");
    Expect(0, 123216, '\p{Is_Sc=hmnp}', "");
    Expect(1, 123216, '\p{^Is_Sc=hmnp}', "");
    Expect(1, 123216, '\P{Is_Sc=hmnp}', "");
    Expect(0, 123216, '\P{^Is_Sc=hmnp}', "");
    Expect(1, 123215, '\p{Is_Sc=	Hmnp}', "");
    Expect(0, 123215, '\p{^Is_Sc=	Hmnp}', "");
    Expect(0, 123215, '\P{Is_Sc=	Hmnp}', "");
    Expect(1, 123215, '\P{^Is_Sc=	Hmnp}', "");
    Expect(0, 123216, '\p{Is_Sc=	Hmnp}', "");
    Expect(1, 123216, '\p{^Is_Sc=	Hmnp}', "");
    Expect(1, 123216, '\P{Is_Sc=	Hmnp}', "");
    Expect(0, 123216, '\P{^Is_Sc=	Hmnp}', "");
    Error('\p{Script=Katakana_Or_Hiragana}');
    Error('\P{Script=Katakana_Or_Hiragana}');
    Error('\p{Sc=Hrkt}');
    Error('\P{Sc=Hrkt}');
    Error('\p{Is_Script=Katakana_Or_Hiragana}');
    Error('\P{Is_Script=Katakana_Or_Hiragana}');
    Error('\p{Is_Sc=Hrkt}');
    Error('\P{Is_Sc=Hrkt}');
    Error('\p{Script= Old_Hungarian:=}');
    Error('\P{Script= Old_Hungarian:=}');
    Expect(1, 68863, '\p{Script=:\AOld_Hungarian\z:}', "");;
    Expect(0, 68864, '\p{Script=:\AOld_Hungarian\z:}', "");;
    Expect(1, 68863, '\p{Script=oldhungarian}', "");
    Expect(0, 68863, '\p{^Script=oldhungarian}', "");
    Expect(0, 68863, '\P{Script=oldhungarian}', "");
    Expect(1, 68863, '\P{^Script=oldhungarian}', "");
    Expect(0, 68864, '\p{Script=oldhungarian}', "");
    Expect(1, 68864, '\p{^Script=oldhungarian}', "");
    Expect(1, 68864, '\P{Script=oldhungarian}', "");
    Expect(0, 68864, '\P{^Script=oldhungarian}', "");
    Expect(1, 68863, '\p{Script=:\Aoldhungarian\z:}', "");;
    Expect(0, 68864, '\p{Script=:\Aoldhungarian\z:}', "");;
    Expect(1, 68863, '\p{Script= Old_Hungarian}', "");
    Expect(0, 68863, '\p{^Script= Old_Hungarian}', "");
    Expect(0, 68863, '\P{Script= Old_Hungarian}', "");
    Expect(1, 68863, '\P{^Script= Old_Hungarian}', "");
    Expect(0, 68864, '\p{Script= Old_Hungarian}', "");
    Expect(1, 68864, '\p{^Script= Old_Hungarian}', "");
    Expect(1, 68864, '\P{Script= Old_Hungarian}', "");
    Expect(0, 68864, '\P{^Script= Old_Hungarian}', "");
    Error('\p{Sc=/a/ _HUNG}');
    Error('\P{Sc=/a/ _HUNG}');
    Expect(1, 68863, '\p{Sc=:\AHung\z:}', "");;
    Expect(0, 68864, '\p{Sc=:\AHung\z:}', "");;
    Expect(1, 68863, '\p{Sc: hung}', "");
    Expect(0, 68863, '\p{^Sc: hung}', "");
    Expect(0, 68863, '\P{Sc: hung}', "");
    Expect(1, 68863, '\P{^Sc: hung}', "");
    Expect(0, 68864, '\p{Sc: hung}', "");
    Expect(1, 68864, '\p{^Sc: hung}', "");
    Expect(1, 68864, '\P{Sc: hung}', "");
    Expect(0, 68864, '\P{^Sc: hung}', "");
    Expect(1, 68863, '\p{Sc=:\Ahung\z:}', "");;
    Expect(0, 68864, '\p{Sc=:\Ahung\z:}', "");;
    Expect(1, 68863, '\p{Sc:Hung}', "");
    Expect(0, 68863, '\p{^Sc:Hung}', "");
    Expect(0, 68863, '\P{Sc:Hung}', "");
    Expect(1, 68863, '\P{^Sc:Hung}', "");
    Expect(0, 68864, '\p{Sc:Hung}', "");
    Expect(1, 68864, '\p{^Sc:Hung}', "");
    Expect(1, 68864, '\P{Sc:Hung}', "");
    Expect(0, 68864, '\P{^Sc:Hung}', "");
    Error('\p{Is_Script=_/a/OLD_hungarian}');
    Error('\P{Is_Script=_/a/OLD_hungarian}');
    Expect(1, 68863, '\p{Is_Script=oldhungarian}', "");
    Expect(0, 68863, '\p{^Is_Script=oldhungarian}', "");
    Expect(0, 68863, '\P{Is_Script=oldhungarian}', "");
    Expect(1, 68863, '\P{^Is_Script=oldhungarian}', "");
    Expect(0, 68864, '\p{Is_Script=oldhungarian}', "");
    Expect(1, 68864, '\p{^Is_Script=oldhungarian}', "");
    Expect(1, 68864, '\P{Is_Script=oldhungarian}', "");
    Expect(0, 68864, '\P{^Is_Script=oldhungarian}', "");
    Expect(1, 68863, '\p{Is_Script: 	old_Hungarian}', "");
    Expect(0, 68863, '\p{^Is_Script: 	old_Hungarian}', "");
    Expect(0, 68863, '\P{Is_Script: 	old_Hungarian}', "");
    Expect(1, 68863, '\P{^Is_Script: 	old_Hungarian}', "");
    Expect(0, 68864, '\p{Is_Script: 	old_Hungarian}', "");
    Expect(1, 68864, '\p{^Is_Script: 	old_Hungarian}', "");
    Expect(1, 68864, '\P{Is_Script: 	old_Hungarian}', "");
    Expect(0, 68864, '\P{^Is_Script: 	old_Hungarian}', "");
    Error('\p{Is_Sc=	-Hung:=}');
    Error('\P{Is_Sc=	-Hung:=}');
    Expect(1, 68863, '\p{Is_Sc:   hung}', "");
    Expect(0, 68863, '\p{^Is_Sc:   hung}', "");
    Expect(0, 68863, '\P{Is_Sc:   hung}', "");
    Expect(1, 68863, '\P{^Is_Sc:   hung}', "");
    Expect(0, 68864, '\p{Is_Sc:   hung}', "");
    Expect(1, 68864, '\p{^Is_Sc:   hung}', "");
    Expect(1, 68864, '\P{Is_Sc:   hung}', "");
    Expect(0, 68864, '\P{^Is_Sc:   hung}', "");
    Expect(1, 68863, '\p{Is_Sc=_-Hung}', "");
    Expect(0, 68863, '\p{^Is_Sc=_-Hung}', "");
    Expect(0, 68863, '\P{Is_Sc=_-Hung}', "");
    Expect(1, 68863, '\P{^Is_Sc=_-Hung}', "");
    Expect(0, 68864, '\p{Is_Sc=_-Hung}', "");
    Expect(1, 68864, '\p{^Is_Sc=_-Hung}', "");
    Expect(1, 68864, '\P{Is_Sc=_-Hung}', "");
    Expect(0, 68864, '\P{^Is_Sc=_-Hung}', "");
    Error('\p{Script=	-old_italic/a/}');
    Error('\P{Script=	-old_italic/a/}');
    Expect(1, 66351, '\p{Script=:\AOld_Italic\z:}', "");;
    Expect(0, 66352, '\p{Script=:\AOld_Italic\z:}', "");;
    Expect(1, 66351, '\p{Script=olditalic}', "");
    Expect(0, 66351, '\p{^Script=olditalic}', "");
    Expect(0, 66351, '\P{Script=olditalic}', "");
    Expect(1, 66351, '\P{^Script=olditalic}', "");
    Expect(0, 66352, '\p{Script=olditalic}', "");
    Expect(1, 66352, '\p{^Script=olditalic}', "");
    Expect(1, 66352, '\P{Script=olditalic}', "");
    Expect(0, 66352, '\P{^Script=olditalic}', "");
    Expect(1, 66351, '\p{Script=:\Aolditalic\z:}', "");;
    Expect(0, 66352, '\p{Script=:\Aolditalic\z:}', "");;
    Expect(1, 66351, '\p{Script=-old_Italic}', "");
    Expect(0, 66351, '\p{^Script=-old_Italic}', "");
    Expect(0, 66351, '\P{Script=-old_Italic}', "");
    Expect(1, 66351, '\P{^Script=-old_Italic}', "");
    Expect(0, 66352, '\p{Script=-old_Italic}', "");
    Expect(1, 66352, '\p{^Script=-old_Italic}', "");
    Expect(1, 66352, '\P{Script=-old_Italic}', "");
    Expect(0, 66352, '\P{^Script=-old_Italic}', "");
    Error('\p{Sc=	/a/ital}');
    Error('\P{Sc=	/a/ital}');
    Expect(1, 66351, '\p{Sc=:\AItal\z:}', "");;
    Expect(0, 66352, '\p{Sc=:\AItal\z:}', "");;
    Expect(1, 66351, '\p{Sc: ital}', "");
    Expect(0, 66351, '\p{^Sc: ital}', "");
    Expect(0, 66351, '\P{Sc: ital}', "");
    Expect(1, 66351, '\P{^Sc: ital}', "");
    Expect(0, 66352, '\p{Sc: ital}', "");
    Expect(1, 66352, '\p{^Sc: ital}', "");
    Expect(1, 66352, '\P{Sc: ital}', "");
    Expect(0, 66352, '\P{^Sc: ital}', "");
    Expect(1, 66351, '\p{Sc=:\Aital\z:}', "");;
    Expect(0, 66352, '\p{Sc=:\Aital\z:}', "");;
    Expect(1, 66351, '\p{Sc=-	ITAL}', "");
    Expect(0, 66351, '\p{^Sc=-	ITAL}', "");
    Expect(0, 66351, '\P{Sc=-	ITAL}', "");
    Expect(1, 66351, '\P{^Sc=-	ITAL}', "");
    Expect(0, 66352, '\p{Sc=-	ITAL}', "");
    Expect(1, 66352, '\p{^Sc=-	ITAL}', "");
    Expect(1, 66352, '\P{Sc=-	ITAL}', "");
    Expect(0, 66352, '\P{^Sc=-	ITAL}', "");
    Error('\p{Is_Script:	old_ITALIC/a/}');
    Error('\P{Is_Script:	old_ITALIC/a/}');
    Expect(1, 66351, '\p{Is_Script=olditalic}', "");
    Expect(0, 66351, '\p{^Is_Script=olditalic}', "");
    Expect(0, 66351, '\P{Is_Script=olditalic}', "");
    Expect(1, 66351, '\P{^Is_Script=olditalic}', "");
    Expect(0, 66352, '\p{Is_Script=olditalic}', "");
    Expect(1, 66352, '\p{^Is_Script=olditalic}', "");
    Expect(1, 66352, '\P{Is_Script=olditalic}', "");
    Expect(0, 66352, '\P{^Is_Script=olditalic}', "");
    Expect(1, 66351, '\p{Is_Script=-old_ITALIC}', "");
    Expect(0, 66351, '\p{^Is_Script=-old_ITALIC}', "");
    Expect(0, 66351, '\P{Is_Script=-old_ITALIC}', "");
    Expect(1, 66351, '\P{^Is_Script=-old_ITALIC}', "");
    Expect(0, 66352, '\p{Is_Script=-old_ITALIC}', "");
    Expect(1, 66352, '\p{^Is_Script=-old_ITALIC}', "");
    Expect(1, 66352, '\P{Is_Script=-old_ITALIC}', "");
    Expect(0, 66352, '\P{^Is_Script=-old_ITALIC}', "");
    Error('\p{Is_Sc=_ Ital:=}');
    Error('\P{Is_Sc=_ Ital:=}');
    Expect(1, 66351, '\p{Is_Sc=ital}', "");
    Expect(0, 66351, '\p{^Is_Sc=ital}', "");
    Expect(0, 66351, '\P{Is_Sc=ital}', "");
    Expect(1, 66351, '\P{^Is_Sc=ital}', "");
    Expect(0, 66352, '\p{Is_Sc=ital}', "");
    Expect(1, 66352, '\p{^Is_Sc=ital}', "");
    Expect(1, 66352, '\P{Is_Sc=ital}', "");
    Expect(0, 66352, '\P{^Is_Sc=ital}', "");
    Expect(1, 66351, '\p{Is_Sc= -Ital}', "");
    Expect(0, 66351, '\p{^Is_Sc= -Ital}', "");
    Expect(0, 66351, '\P{Is_Sc= -Ital}', "");
    Expect(1, 66351, '\P{^Is_Sc= -Ital}', "");
    Expect(0, 66352, '\p{Is_Sc= -Ital}', "");
    Expect(1, 66352, '\p{^Is_Sc= -Ital}', "");
    Expect(1, 66352, '\P{Is_Sc= -Ital}', "");
    Expect(0, 66352, '\P{^Is_Sc= -Ital}', "");
    Error('\p{Script=	 javanese:=}');
    Error('\P{Script=	 javanese:=}');
    Expect(1, 43487, '\p{Script=:\AJavanese\z:}', "");;
    Expect(0, 43488, '\p{Script=:\AJavanese\z:}', "");;
    Expect(1, 43487, '\p{Script=javanese}', "");
    Expect(0, 43487, '\p{^Script=javanese}', "");
    Expect(0, 43487, '\P{Script=javanese}', "");
    Expect(1, 43487, '\P{^Script=javanese}', "");
    Expect(0, 43488, '\p{Script=javanese}', "");
    Expect(1, 43488, '\p{^Script=javanese}', "");
    Expect(1, 43488, '\P{Script=javanese}', "");
    Expect(0, 43488, '\P{^Script=javanese}', "");
    Expect(1, 43487, '\p{Script=:\Ajavanese\z:}', "");;
    Expect(0, 43488, '\p{Script=:\Ajavanese\z:}', "");;
    Expect(1, 43487, '\p{Script= -javanese}', "");
    Expect(0, 43487, '\p{^Script= -javanese}', "");
    Expect(0, 43487, '\P{Script= -javanese}', "");
    Expect(1, 43487, '\P{^Script= -javanese}', "");
    Expect(0, 43488, '\p{Script= -javanese}', "");
    Expect(1, 43488, '\p{^Script= -javanese}', "");
    Expect(1, 43488, '\P{Script= -javanese}', "");
    Expect(0, 43488, '\P{^Script= -javanese}', "");
    Error('\p{Sc= /a/JAVA}');
    Error('\P{Sc= /a/JAVA}');
    Expect(1, 43487, '\p{Sc=:\AJava\z:}', "");;
    Expect(0, 43488, '\p{Sc=:\AJava\z:}', "");;
    Expect(1, 43487, '\p{Sc=java}', "");
    Expect(0, 43487, '\p{^Sc=java}', "");
    Expect(0, 43487, '\P{Sc=java}', "");
    Expect(1, 43487, '\P{^Sc=java}', "");
    Expect(0, 43488, '\p{Sc=java}', "");
    Expect(1, 43488, '\p{^Sc=java}', "");
    Expect(1, 43488, '\P{Sc=java}', "");
    Expect(0, 43488, '\P{^Sc=java}', "");
    Expect(1, 43487, '\p{Sc=:\Ajava\z:}', "");;
    Expect(0, 43488, '\p{Sc=:\Ajava\z:}', "");;
    Expect(1, 43487, '\p{Sc= Java}', "");
    Expect(0, 43487, '\p{^Sc= Java}', "");
    Expect(0, 43487, '\P{Sc= Java}', "");
    Expect(1, 43487, '\P{^Sc= Java}', "");
    Expect(0, 43488, '\p{Sc= Java}', "");
    Expect(1, 43488, '\p{^Sc= Java}', "");
    Expect(1, 43488, '\P{Sc= Java}', "");
    Expect(0, 43488, '\P{^Sc= Java}', "");
    Error('\p{Is_Script=:=	 JAVANESE}');
    Error('\P{Is_Script=:=	 JAVANESE}');
    Expect(1, 43487, '\p{Is_Script=javanese}', "");
    Expect(0, 43487, '\p{^Is_Script=javanese}', "");
    Expect(0, 43487, '\P{Is_Script=javanese}', "");
    Expect(1, 43487, '\P{^Is_Script=javanese}', "");
    Expect(0, 43488, '\p{Is_Script=javanese}', "");
    Expect(1, 43488, '\p{^Is_Script=javanese}', "");
    Expect(1, 43488, '\P{Is_Script=javanese}', "");
    Expect(0, 43488, '\P{^Is_Script=javanese}', "");
    Expect(1, 43487, '\p{Is_Script:-	Javanese}', "");
    Expect(0, 43487, '\p{^Is_Script:-	Javanese}', "");
    Expect(0, 43487, '\P{Is_Script:-	Javanese}', "");
    Expect(1, 43487, '\P{^Is_Script:-	Javanese}', "");
    Expect(0, 43488, '\p{Is_Script:-	Javanese}', "");
    Expect(1, 43488, '\p{^Is_Script:-	Javanese}', "");
    Expect(1, 43488, '\P{Is_Script:-	Javanese}', "");
    Expect(0, 43488, '\P{^Is_Script:-	Javanese}', "");
    Error('\p{Is_Sc=/a/Java}');
    Error('\P{Is_Sc=/a/Java}');
    Expect(1, 43487, '\p{Is_Sc:	java}', "");
    Expect(0, 43487, '\p{^Is_Sc:	java}', "");
    Expect(0, 43487, '\P{Is_Sc:	java}', "");
    Expect(1, 43487, '\P{^Is_Sc:	java}', "");
    Expect(0, 43488, '\p{Is_Sc:	java}', "");
    Expect(1, 43488, '\p{^Is_Sc:	java}', "");
    Expect(1, 43488, '\P{Is_Sc:	java}', "");
    Expect(0, 43488, '\P{^Is_Sc:	java}', "");
    Expect(1, 43487, '\p{Is_Sc=	Java}', "");
    Expect(0, 43487, '\p{^Is_Sc=	Java}', "");
    Expect(0, 43487, '\P{Is_Sc=	Java}', "");
    Expect(1, 43487, '\P{^Is_Sc=	Java}', "");
    Expect(0, 43488, '\p{Is_Sc=	Java}', "");
    Expect(1, 43488, '\p{^Is_Sc=	Java}', "");
    Expect(1, 43488, '\P{Is_Sc=	Java}', "");
    Expect(0, 43488, '\P{^Is_Sc=	Java}', "");
    Error('\p{Script=/a/Kayah_li}');
    Error('\P{Script=/a/Kayah_li}');
    Expect(1, 43311, '\p{Script=:\AKayah_Li\z:}', "");;
    Expect(0, 43312, '\p{Script=:\AKayah_Li\z:}', "");;
    Expect(1, 43311, '\p{Script=kayahli}', "");
    Expect(0, 43311, '\p{^Script=kayahli}', "");
    Expect(0, 43311, '\P{Script=kayahli}', "");
    Expect(1, 43311, '\P{^Script=kayahli}', "");
    Expect(0, 43312, '\p{Script=kayahli}', "");
    Expect(1, 43312, '\p{^Script=kayahli}', "");
    Expect(1, 43312, '\P{Script=kayahli}', "");
    Expect(0, 43312, '\P{^Script=kayahli}', "");
    Expect(1, 43311, '\p{Script=:\Akayahli\z:}', "");;
    Expect(0, 43312, '\p{Script=:\Akayahli\z:}', "");;
    Expect(1, 43311, '\p{Script=	 kayah_Li}', "");
    Expect(0, 43311, '\p{^Script=	 kayah_Li}', "");
    Expect(0, 43311, '\P{Script=	 kayah_Li}', "");
    Expect(1, 43311, '\P{^Script=	 kayah_Li}', "");
    Expect(0, 43312, '\p{Script=	 kayah_Li}', "");
    Expect(1, 43312, '\p{^Script=	 kayah_Li}', "");
    Expect(1, 43312, '\P{Script=	 kayah_Li}', "");
    Expect(0, 43312, '\P{^Script=	 kayah_Li}', "");
    Error('\p{Sc=_:=KALI}');
    Error('\P{Sc=_:=KALI}');
    Expect(1, 43311, '\p{Sc=:\AKali\z:}', "");;
    Expect(0, 43312, '\p{Sc=:\AKali\z:}', "");;
    Expect(1, 43311, '\p{Sc=kali}', "");
    Expect(0, 43311, '\p{^Sc=kali}', "");
    Expect(0, 43311, '\P{Sc=kali}', "");
    Expect(1, 43311, '\P{^Sc=kali}', "");
    Expect(0, 43312, '\p{Sc=kali}', "");
    Expect(1, 43312, '\p{^Sc=kali}', "");
    Expect(1, 43312, '\P{Sc=kali}', "");
    Expect(0, 43312, '\P{^Sc=kali}', "");
    Expect(1, 43311, '\p{Sc=:\Akali\z:}', "");;
    Expect(0, 43312, '\p{Sc=:\Akali\z:}', "");;
    Expect(1, 43311, '\p{Sc=_ kali}', "");
    Expect(0, 43311, '\p{^Sc=_ kali}', "");
    Expect(0, 43311, '\P{Sc=_ kali}', "");
    Expect(1, 43311, '\P{^Sc=_ kali}', "");
    Expect(0, 43312, '\p{Sc=_ kali}', "");
    Expect(1, 43312, '\p{^Sc=_ kali}', "");
    Expect(1, 43312, '\P{Sc=_ kali}', "");
    Expect(0, 43312, '\P{^Sc=_ kali}', "");
    Error('\p{Is_Script= :=Kayah_LI}');
    Error('\P{Is_Script= :=Kayah_LI}');
    Expect(1, 43311, '\p{Is_Script=kayahli}', "");
    Expect(0, 43311, '\p{^Is_Script=kayahli}', "");
    Expect(0, 43311, '\P{Is_Script=kayahli}', "");
    Expect(1, 43311, '\P{^Is_Script=kayahli}', "");
    Expect(0, 43312, '\p{Is_Script=kayahli}', "");
    Expect(1, 43312, '\p{^Is_Script=kayahli}', "");
    Expect(1, 43312, '\P{Is_Script=kayahli}', "");
    Expect(0, 43312, '\P{^Is_Script=kayahli}', "");
    Expect(1, 43311, '\p{Is_Script=	kayah_Li}', "");
    Expect(0, 43311, '\p{^Is_Script=	kayah_Li}', "");
    Expect(0, 43311, '\P{Is_Script=	kayah_Li}', "");
    Expect(1, 43311, '\P{^Is_Script=	kayah_Li}', "");
    Expect(0, 43312, '\p{Is_Script=	kayah_Li}', "");
    Expect(1, 43312, '\p{^Is_Script=	kayah_Li}', "");
    Expect(1, 43312, '\P{Is_Script=	kayah_Li}', "");
    Expect(0, 43312, '\P{^Is_Script=	kayah_Li}', "");
    Error('\p{Is_Sc=		Kali:=}');
    Error('\P{Is_Sc=		Kali:=}');
    Expect(1, 43311, '\p{Is_Sc=kali}', "");
    Expect(0, 43311, '\p{^Is_Sc=kali}', "");
    Expect(0, 43311, '\P{Is_Sc=kali}', "");
    Expect(1, 43311, '\P{^Is_Sc=kali}', "");
    Expect(0, 43312, '\p{Is_Sc=kali}', "");
    Expect(1, 43312, '\p{^Is_Sc=kali}', "");
    Expect(1, 43312, '\P{Is_Sc=kali}', "");
    Expect(0, 43312, '\P{^Is_Sc=kali}', "");
    Expect(1, 43311, '\p{Is_Sc=-Kali}', "");
    Expect(0, 43311, '\p{^Is_Sc=-Kali}', "");
    Expect(0, 43311, '\P{Is_Sc=-Kali}', "");
    Expect(1, 43311, '\P{^Is_Sc=-Kali}', "");
    Expect(0, 43312, '\p{Is_Sc=-Kali}', "");
    Expect(1, 43312, '\p{^Is_Sc=-Kali}', "");
    Expect(1, 43312, '\P{Is_Sc=-Kali}', "");
    Expect(0, 43312, '\P{^Is_Sc=-Kali}', "");
    Error('\p{Script=:= _KATAKANA}');
    Error('\P{Script=:= _KATAKANA}');
    Expect(1, 110951, '\p{Script=:\AKatakana\z:}', "");;
    Expect(0, 110952, '\p{Script=:\AKatakana\z:}', "");;
    Expect(1, 110951, '\p{Script=katakana}', "");
    Expect(0, 110951, '\p{^Script=katakana}', "");
    Expect(0, 110951, '\P{Script=katakana}', "");
    Expect(1, 110951, '\P{^Script=katakana}', "");
    Expect(0, 110952, '\p{Script=katakana}', "");
    Expect(1, 110952, '\p{^Script=katakana}', "");
    Expect(1, 110952, '\P{Script=katakana}', "");
    Expect(0, 110952, '\P{^Script=katakana}', "");
    Expect(1, 110951, '\p{Script=:\Akatakana\z:}', "");;
    Expect(0, 110952, '\p{Script=:\Akatakana\z:}', "");;
    Expect(1, 110951, '\p{Script=Katakana}', "");
    Expect(0, 110951, '\p{^Script=Katakana}', "");
    Expect(0, 110951, '\P{Script=Katakana}', "");
    Expect(1, 110951, '\P{^Script=Katakana}', "");
    Expect(0, 110952, '\p{Script=Katakana}', "");
    Expect(1, 110952, '\p{^Script=Katakana}', "");
    Expect(1, 110952, '\P{Script=Katakana}', "");
    Expect(0, 110952, '\P{^Script=Katakana}', "");
    Error('\p{Sc=_/a/KANA}');
    Error('\P{Sc=_/a/KANA}');
    Expect(1, 110951, '\p{Sc=:\AKana\z:}', "");;
    Expect(0, 110952, '\p{Sc=:\AKana\z:}', "");;
    Expect(1, 110951, '\p{Sc=kana}', "");
    Expect(0, 110951, '\p{^Sc=kana}', "");
    Expect(0, 110951, '\P{Sc=kana}', "");
    Expect(1, 110951, '\P{^Sc=kana}', "");
    Expect(0, 110952, '\p{Sc=kana}', "");
    Expect(1, 110952, '\p{^Sc=kana}', "");
    Expect(1, 110952, '\P{Sc=kana}', "");
    Expect(0, 110952, '\P{^Sc=kana}', "");
    Expect(1, 110951, '\p{Sc=:\Akana\z:}', "");;
    Expect(0, 110952, '\p{Sc=:\Akana\z:}', "");;
    Expect(1, 110951, '\p{Sc=Kana}', "");
    Expect(0, 110951, '\p{^Sc=Kana}', "");
    Expect(0, 110951, '\P{Sc=Kana}', "");
    Expect(1, 110951, '\P{^Sc=Kana}', "");
    Expect(0, 110952, '\p{Sc=Kana}', "");
    Expect(1, 110952, '\p{^Sc=Kana}', "");
    Expect(1, 110952, '\P{Sc=Kana}', "");
    Expect(0, 110952, '\P{^Sc=Kana}', "");
    Error('\p{Is_Script= _KATAKANA:=}');
    Error('\P{Is_Script= _KATAKANA:=}');
    Expect(1, 110951, '\p{Is_Script=katakana}', "");
    Expect(0, 110951, '\p{^Is_Script=katakana}', "");
    Expect(0, 110951, '\P{Is_Script=katakana}', "");
    Expect(1, 110951, '\P{^Is_Script=katakana}', "");
    Expect(0, 110952, '\p{Is_Script=katakana}', "");
    Expect(1, 110952, '\p{^Is_Script=katakana}', "");
    Expect(1, 110952, '\P{Is_Script=katakana}', "");
    Expect(0, 110952, '\P{^Is_Script=katakana}', "");
    Expect(1, 110951, '\p{Is_Script=	Katakana}', "");
    Expect(0, 110951, '\p{^Is_Script=	Katakana}', "");
    Expect(0, 110951, '\P{Is_Script=	Katakana}', "");
    Expect(1, 110951, '\P{^Is_Script=	Katakana}', "");
    Expect(0, 110952, '\p{Is_Script=	Katakana}', "");
    Expect(1, 110952, '\p{^Is_Script=	Katakana}', "");
    Expect(1, 110952, '\P{Is_Script=	Katakana}', "");
    Expect(0, 110952, '\P{^Is_Script=	Katakana}', "");
    Error('\p{Is_Sc= /a/Kana}');
    Error('\P{Is_Sc= /a/Kana}');
    Expect(1, 110951, '\p{Is_Sc=kana}', "");
    Expect(0, 110951, '\p{^Is_Sc=kana}', "");
    Expect(0, 110951, '\P{Is_Sc=kana}', "");
    Expect(1, 110951, '\P{^Is_Sc=kana}', "");
    Expect(0, 110952, '\p{Is_Sc=kana}', "");
    Expect(1, 110952, '\p{^Is_Sc=kana}', "");
    Expect(1, 110952, '\P{Is_Sc=kana}', "");
    Expect(0, 110952, '\P{^Is_Sc=kana}', "");
    Expect(1, 110951, '\p{Is_Sc= Kana}', "");
    Expect(0, 110951, '\p{^Is_Sc= Kana}', "");
    Expect(0, 110951, '\P{Is_Sc= Kana}', "");
    Expect(1, 110951, '\P{^Is_Sc= Kana}', "");
    Expect(0, 110952, '\p{Is_Sc= Kana}', "");
    Expect(1, 110952, '\p{^Is_Sc= Kana}', "");
    Expect(1, 110952, '\P{Is_Sc= Kana}', "");
    Expect(0, 110952, '\P{^Is_Sc= Kana}', "");
    Error('\p{Script=:=- KHAROSHTHI}');
    Error('\P{Script=:=- KHAROSHTHI}');
    Expect(1, 68184, '\p{Script=:\AKharoshthi\z:}', "");;
    Expect(0, 68185, '\p{Script=:\AKharoshthi\z:}', "");;
    Expect(1, 68184, '\p{Script=kharoshthi}', "");
    Expect(0, 68184, '\p{^Script=kharoshthi}', "");
    Expect(0, 68184, '\P{Script=kharoshthi}', "");
    Expect(1, 68184, '\P{^Script=kharoshthi}', "");
    Expect(0, 68185, '\p{Script=kharoshthi}', "");
    Expect(1, 68185, '\p{^Script=kharoshthi}', "");
    Expect(1, 68185, '\P{Script=kharoshthi}', "");
    Expect(0, 68185, '\P{^Script=kharoshthi}', "");
    Expect(1, 68184, '\p{Script=:\Akharoshthi\z:}', "");;
    Expect(0, 68185, '\p{Script=:\Akharoshthi\z:}', "");;
    Expect(1, 68184, '\p{Script=KHAROSHTHI}', "");
    Expect(0, 68184, '\p{^Script=KHAROSHTHI}', "");
    Expect(0, 68184, '\P{Script=KHAROSHTHI}', "");
    Expect(1, 68184, '\P{^Script=KHAROSHTHI}', "");
    Expect(0, 68185, '\p{Script=KHAROSHTHI}', "");
    Expect(1, 68185, '\p{^Script=KHAROSHTHI}', "");
    Expect(1, 68185, '\P{Script=KHAROSHTHI}', "");
    Expect(0, 68185, '\P{^Script=KHAROSHTHI}', "");
    Error('\p{Sc=/a/		KHAR}');
    Error('\P{Sc=/a/		KHAR}');
    Expect(1, 68184, '\p{Sc=:\AKhar\z:}', "");;
    Expect(0, 68185, '\p{Sc=:\AKhar\z:}', "");;
    Expect(1, 68184, '\p{Sc=khar}', "");
    Expect(0, 68184, '\p{^Sc=khar}', "");
    Expect(0, 68184, '\P{Sc=khar}', "");
    Expect(1, 68184, '\P{^Sc=khar}', "");
    Expect(0, 68185, '\p{Sc=khar}', "");
    Expect(1, 68185, '\p{^Sc=khar}', "");
    Expect(1, 68185, '\P{Sc=khar}', "");
    Expect(0, 68185, '\P{^Sc=khar}', "");
    Expect(1, 68184, '\p{Sc=:\Akhar\z:}', "");;
    Expect(0, 68185, '\p{Sc=:\Akhar\z:}', "");;
    Expect(1, 68184, '\p{Sc=_Khar}', "");
    Expect(0, 68184, '\p{^Sc=_Khar}', "");
    Expect(0, 68184, '\P{Sc=_Khar}', "");
    Expect(1, 68184, '\P{^Sc=_Khar}', "");
    Expect(0, 68185, '\p{Sc=_Khar}', "");
    Expect(1, 68185, '\p{^Sc=_Khar}', "");
    Expect(1, 68185, '\P{Sc=_Khar}', "");
    Expect(0, 68185, '\P{^Sc=_Khar}', "");
    Error('\p{Is_Script=/a/ _kharoshthi}');
    Error('\P{Is_Script=/a/ _kharoshthi}');
    Expect(1, 68184, '\p{Is_Script=kharoshthi}', "");
    Expect(0, 68184, '\p{^Is_Script=kharoshthi}', "");
    Expect(0, 68184, '\P{Is_Script=kharoshthi}', "");
    Expect(1, 68184, '\P{^Is_Script=kharoshthi}', "");
    Expect(0, 68185, '\p{Is_Script=kharoshthi}', "");
    Expect(1, 68185, '\p{^Is_Script=kharoshthi}', "");
    Expect(1, 68185, '\P{Is_Script=kharoshthi}', "");
    Expect(0, 68185, '\P{^Is_Script=kharoshthi}', "");
    Expect(1, 68184, '\p{Is_Script=	 kharoshthi}', "");
    Expect(0, 68184, '\p{^Is_Script=	 kharoshthi}', "");
    Expect(0, 68184, '\P{Is_Script=	 kharoshthi}', "");
    Expect(1, 68184, '\P{^Is_Script=	 kharoshthi}', "");
    Expect(0, 68185, '\p{Is_Script=	 kharoshthi}', "");
    Expect(1, 68185, '\p{^Is_Script=	 kharoshthi}', "");
    Expect(1, 68185, '\P{Is_Script=	 kharoshthi}', "");
    Expect(0, 68185, '\P{^Is_Script=	 kharoshthi}', "");
    Error('\p{Is_Sc=_:=KHAR}');
    Error('\P{Is_Sc=_:=KHAR}');
    Expect(1, 68184, '\p{Is_Sc=khar}', "");
    Expect(0, 68184, '\p{^Is_Sc=khar}', "");
    Expect(0, 68184, '\P{Is_Sc=khar}', "");
    Expect(1, 68184, '\P{^Is_Sc=khar}', "");
    Expect(0, 68185, '\p{Is_Sc=khar}', "");
    Expect(1, 68185, '\p{^Is_Sc=khar}', "");
    Expect(1, 68185, '\P{Is_Sc=khar}', "");
    Expect(0, 68185, '\P{^Is_Sc=khar}', "");
    Expect(1, 68184, '\p{Is_Sc=	 Khar}', "");
    Expect(0, 68184, '\p{^Is_Sc=	 Khar}', "");
    Expect(0, 68184, '\P{Is_Sc=	 Khar}', "");
    Expect(1, 68184, '\P{^Is_Sc=	 Khar}', "");
    Expect(0, 68185, '\p{Is_Sc=	 Khar}', "");
    Expect(1, 68185, '\p{^Is_Sc=	 Khar}', "");
    Expect(1, 68185, '\P{Is_Sc=	 Khar}', "");
    Expect(0, 68185, '\P{^Is_Sc=	 Khar}', "");
    Error('\p{Script=/a/_Khmer}');
    Error('\P{Script=/a/_Khmer}');
    Expect(1, 6655, '\p{Script=:\AKhmer\z:}', "");;
    Expect(0, 6656, '\p{Script=:\AKhmer\z:}', "");;
    Expect(1, 6655, '\p{Script=khmer}', "");
    Expect(0, 6655, '\p{^Script=khmer}', "");
    Expect(0, 6655, '\P{Script=khmer}', "");
    Expect(1, 6655, '\P{^Script=khmer}', "");
    Expect(0, 6656, '\p{Script=khmer}', "");
    Expect(1, 6656, '\p{^Script=khmer}', "");
    Expect(1, 6656, '\P{Script=khmer}', "");
    Expect(0, 6656, '\P{^Script=khmer}', "");
    Expect(1, 6655, '\p{Script=:\Akhmer\z:}', "");;
    Expect(0, 6656, '\p{Script=:\Akhmer\z:}', "");;
    Expect(1, 6655, '\p{Script: 	-khmer}', "");
    Expect(0, 6655, '\p{^Script: 	-khmer}', "");
    Expect(0, 6655, '\P{Script: 	-khmer}', "");
    Expect(1, 6655, '\P{^Script: 	-khmer}', "");
    Expect(0, 6656, '\p{Script: 	-khmer}', "");
    Expect(1, 6656, '\p{^Script: 	-khmer}', "");
    Expect(1, 6656, '\P{Script: 	-khmer}', "");
    Expect(0, 6656, '\P{^Script: 	-khmer}', "");
    Error('\p{Sc=/a/	khmr}');
    Error('\P{Sc=/a/	khmr}');
    Expect(1, 6655, '\p{Sc=:\AKhmr\z:}', "");;
    Expect(0, 6656, '\p{Sc=:\AKhmr\z:}', "");;
    Expect(1, 6655, '\p{Sc=khmr}', "");
    Expect(0, 6655, '\p{^Sc=khmr}', "");
    Expect(0, 6655, '\P{Sc=khmr}', "");
    Expect(1, 6655, '\P{^Sc=khmr}', "");
    Expect(0, 6656, '\p{Sc=khmr}', "");
    Expect(1, 6656, '\p{^Sc=khmr}', "");
    Expect(1, 6656, '\P{Sc=khmr}', "");
    Expect(0, 6656, '\P{^Sc=khmr}', "");
    Expect(1, 6655, '\p{Sc=:\Akhmr\z:}', "");;
    Expect(0, 6656, '\p{Sc=:\Akhmr\z:}', "");;
    Expect(1, 6655, '\p{Sc=_Khmr}', "");
    Expect(0, 6655, '\p{^Sc=_Khmr}', "");
    Expect(0, 6655, '\P{Sc=_Khmr}', "");
    Expect(1, 6655, '\P{^Sc=_Khmr}', "");
    Expect(0, 6656, '\p{Sc=_Khmr}', "");
    Expect(1, 6656, '\p{^Sc=_Khmr}', "");
    Expect(1, 6656, '\P{Sc=_Khmr}', "");
    Expect(0, 6656, '\P{^Sc=_Khmr}', "");
    Error('\p{Is_Script:	-/a/khmer}');
    Error('\P{Is_Script:	-/a/khmer}');
    Expect(1, 6655, '\p{Is_Script=khmer}', "");
    Expect(0, 6655, '\p{^Is_Script=khmer}', "");
    Expect(0, 6655, '\P{Is_Script=khmer}', "");
    Expect(1, 6655, '\P{^Is_Script=khmer}', "");
    Expect(0, 6656, '\p{Is_Script=khmer}', "");
    Expect(1, 6656, '\p{^Is_Script=khmer}', "");
    Expect(1, 6656, '\P{Is_Script=khmer}', "");
    Expect(0, 6656, '\P{^Is_Script=khmer}', "");
    Expect(1, 6655, '\p{Is_Script=_	Khmer}', "");
    Expect(0, 6655, '\p{^Is_Script=_	Khmer}', "");
    Expect(0, 6655, '\P{Is_Script=_	Khmer}', "");
    Expect(1, 6655, '\P{^Is_Script=_	Khmer}', "");
    Expect(0, 6656, '\p{Is_Script=_	Khmer}', "");
    Expect(1, 6656, '\p{^Is_Script=_	Khmer}', "");
    Expect(1, 6656, '\P{Is_Script=_	Khmer}', "");
    Expect(0, 6656, '\P{^Is_Script=_	Khmer}', "");
    Error('\p{Is_Sc:    -Khmr:=}');
    Error('\P{Is_Sc:    -Khmr:=}');
    Expect(1, 6655, '\p{Is_Sc=khmr}', "");
    Expect(0, 6655, '\p{^Is_Sc=khmr}', "");
    Expect(0, 6655, '\P{Is_Sc=khmr}', "");
    Expect(1, 6655, '\P{^Is_Sc=khmr}', "");
    Expect(0, 6656, '\p{Is_Sc=khmr}', "");
    Expect(1, 6656, '\p{^Is_Sc=khmr}', "");
    Expect(1, 6656, '\P{Is_Sc=khmr}', "");
    Expect(0, 6656, '\P{^Is_Sc=khmr}', "");
    Expect(1, 6655, '\p{Is_Sc:  Khmr}', "");
    Expect(0, 6655, '\p{^Is_Sc:  Khmr}', "");
    Expect(0, 6655, '\P{Is_Sc:  Khmr}', "");
    Expect(1, 6655, '\P{^Is_Sc:  Khmr}', "");
    Expect(0, 6656, '\p{Is_Sc:  Khmr}', "");
    Expect(1, 6656, '\p{^Is_Sc:  Khmr}', "");
    Expect(1, 6656, '\P{Is_Sc:  Khmr}', "");
    Expect(0, 6656, '\P{^Is_Sc:  Khmr}', "");
    Error('\p{Script=	-Khojki/a/}');
    Error('\P{Script=	-Khojki/a/}');
    Expect(1, 70206, '\p{Script=:\AKhojki\z:}', "");;
    Expect(0, 70207, '\p{Script=:\AKhojki\z:}', "");;
    Expect(1, 70206, '\p{Script:khojki}', "");
    Expect(0, 70206, '\p{^Script:khojki}', "");
    Expect(0, 70206, '\P{Script:khojki}', "");
    Expect(1, 70206, '\P{^Script:khojki}', "");
    Expect(0, 70207, '\p{Script:khojki}', "");
    Expect(1, 70207, '\p{^Script:khojki}', "");
    Expect(1, 70207, '\P{Script:khojki}', "");
    Expect(0, 70207, '\P{^Script:khojki}', "");
    Expect(1, 70206, '\p{Script=:\Akhojki\z:}', "");;
    Expect(0, 70207, '\p{Script=:\Akhojki\z:}', "");;
    Expect(1, 70206, '\p{Script=  khojki}', "");
    Expect(0, 70206, '\p{^Script=  khojki}', "");
    Expect(0, 70206, '\P{Script=  khojki}', "");
    Expect(1, 70206, '\P{^Script=  khojki}', "");
    Expect(0, 70207, '\p{Script=  khojki}', "");
    Expect(1, 70207, '\p{^Script=  khojki}', "");
    Expect(1, 70207, '\P{Script=  khojki}', "");
    Expect(0, 70207, '\P{^Script=  khojki}', "");
    Error('\p{Sc= :=KHOJ}');
    Error('\P{Sc= :=KHOJ}');
    Expect(1, 70206, '\p{Sc=:\AKhoj\z:}', "");;
    Expect(0, 70207, '\p{Sc=:\AKhoj\z:}', "");;
    Expect(1, 70206, '\p{Sc=khoj}', "");
    Expect(0, 70206, '\p{^Sc=khoj}', "");
    Expect(0, 70206, '\P{Sc=khoj}', "");
    Expect(1, 70206, '\P{^Sc=khoj}', "");
    Expect(0, 70207, '\p{Sc=khoj}', "");
    Expect(1, 70207, '\p{^Sc=khoj}', "");
    Expect(1, 70207, '\P{Sc=khoj}', "");
    Expect(0, 70207, '\P{^Sc=khoj}', "");
    Expect(1, 70206, '\p{Sc=:\Akhoj\z:}', "");;
    Expect(0, 70207, '\p{Sc=:\Akhoj\z:}', "");;
    Expect(1, 70206, '\p{Sc= KHOJ}', "");
    Expect(0, 70206, '\p{^Sc= KHOJ}', "");
    Expect(0, 70206, '\P{Sc= KHOJ}', "");
    Expect(1, 70206, '\P{^Sc= KHOJ}', "");
    Expect(0, 70207, '\p{Sc= KHOJ}', "");
    Expect(1, 70207, '\p{^Sc= KHOJ}', "");
    Expect(1, 70207, '\P{Sc= KHOJ}', "");
    Expect(0, 70207, '\P{^Sc= KHOJ}', "");
    Error('\p{Is_Script=- Khojki/a/}');
    Error('\P{Is_Script=- Khojki/a/}');
    Expect(1, 70206, '\p{Is_Script=khojki}', "");
    Expect(0, 70206, '\p{^Is_Script=khojki}', "");
    Expect(0, 70206, '\P{Is_Script=khojki}', "");
    Expect(1, 70206, '\P{^Is_Script=khojki}', "");
    Expect(0, 70207, '\p{Is_Script=khojki}', "");
    Expect(1, 70207, '\p{^Is_Script=khojki}', "");
    Expect(1, 70207, '\P{Is_Script=khojki}', "");
    Expect(0, 70207, '\P{^Is_Script=khojki}', "");
    Expect(1, 70206, '\p{Is_Script= 	Khojki}', "");
    Expect(0, 70206, '\p{^Is_Script= 	Khojki}', "");
    Expect(0, 70206, '\P{Is_Script= 	Khojki}', "");
    Expect(1, 70206, '\P{^Is_Script= 	Khojki}', "");
    Expect(0, 70207, '\p{Is_Script= 	Khojki}', "");
    Expect(1, 70207, '\p{^Is_Script= 	Khojki}', "");
    Expect(1, 70207, '\P{Is_Script= 	Khojki}', "");
    Expect(0, 70207, '\P{^Is_Script= 	Khojki}', "");
    Error('\p{Is_Sc=-Khoj:=}');
    Error('\P{Is_Sc=-Khoj:=}');
    Expect(1, 70206, '\p{Is_Sc=khoj}', "");
    Expect(0, 70206, '\p{^Is_Sc=khoj}', "");
    Expect(0, 70206, '\P{Is_Sc=khoj}', "");
    Expect(1, 70206, '\P{^Is_Sc=khoj}', "");
    Expect(0, 70207, '\p{Is_Sc=khoj}', "");
    Expect(1, 70207, '\p{^Is_Sc=khoj}', "");
    Expect(1, 70207, '\P{Is_Sc=khoj}', "");
    Expect(0, 70207, '\P{^Is_Sc=khoj}', "");
    Expect(1, 70206, '\p{Is_Sc=  khoj}', "");
    Expect(0, 70206, '\p{^Is_Sc=  khoj}', "");
    Expect(0, 70206, '\P{Is_Sc=  khoj}', "");
    Expect(1, 70206, '\P{^Is_Sc=  khoj}', "");
    Expect(0, 70207, '\p{Is_Sc=  khoj}', "");
    Expect(1, 70207, '\p{^Is_Sc=  khoj}', "");
    Expect(1, 70207, '\P{Is_Sc=  khoj}', "");
    Expect(0, 70207, '\P{^Is_Sc=  khoj}', "");
    Error('\p{Script= :=Khitan_SMALL_script}');
    Error('\P{Script= :=Khitan_SMALL_script}');
    Expect(1, 101589, '\p{Script=:\AKhitan_Small_Script\z:}', "");;
    Expect(0, 101590, '\p{Script=:\AKhitan_Small_Script\z:}', "");;
    Expect(1, 101589, '\p{Script=khitansmallscript}', "");
    Expect(0, 101589, '\p{^Script=khitansmallscript}', "");
    Expect(0, 101589, '\P{Script=khitansmallscript}', "");
    Expect(1, 101589, '\P{^Script=khitansmallscript}', "");
    Expect(0, 101590, '\p{Script=khitansmallscript}', "");
    Expect(1, 101590, '\p{^Script=khitansmallscript}', "");
    Expect(1, 101590, '\P{Script=khitansmallscript}', "");
    Expect(0, 101590, '\P{^Script=khitansmallscript}', "");
    Expect(1, 101589, '\p{Script=:\Akhitansmallscript\z:}', "");;
    Expect(0, 101590, '\p{Script=:\Akhitansmallscript\z:}', "");;
    Expect(1, 101589, '\p{Script= _Khitan_small_SCRIPT}', "");
    Expect(0, 101589, '\p{^Script= _Khitan_small_SCRIPT}', "");
    Expect(0, 101589, '\P{Script= _Khitan_small_SCRIPT}', "");
    Expect(1, 101589, '\P{^Script= _Khitan_small_SCRIPT}', "");
    Expect(0, 101590, '\p{Script= _Khitan_small_SCRIPT}', "");
    Expect(1, 101590, '\p{^Script= _Khitan_small_SCRIPT}', "");
    Expect(1, 101590, '\P{Script= _Khitan_small_SCRIPT}', "");
    Expect(0, 101590, '\P{^Script= _Khitan_small_SCRIPT}', "");
    Error('\p{Sc=:=	_kits}');
    Error('\P{Sc=:=	_kits}');
    Expect(1, 101589, '\p{Sc=:\AKits\z:}', "");;
    Expect(0, 101590, '\p{Sc=:\AKits\z:}', "");;
    Expect(1, 101589, '\p{Sc=kits}', "");
    Expect(0, 101589, '\p{^Sc=kits}', "");
    Expect(0, 101589, '\P{Sc=kits}', "");
    Expect(1, 101589, '\P{^Sc=kits}', "");
    Expect(0, 101590, '\p{Sc=kits}', "");
    Expect(1, 101590, '\p{^Sc=kits}', "");
    Expect(1, 101590, '\P{Sc=kits}', "");
    Expect(0, 101590, '\P{^Sc=kits}', "");
    Expect(1, 101589, '\p{Sc=:\Akits\z:}', "");;
    Expect(0, 101590, '\p{Sc=:\Akits\z:}', "");;
    Expect(1, 101589, '\p{Sc=-_Kits}', "");
    Expect(0, 101589, '\p{^Sc=-_Kits}', "");
    Expect(0, 101589, '\P{Sc=-_Kits}', "");
    Expect(1, 101589, '\P{^Sc=-_Kits}', "");
    Expect(0, 101590, '\p{Sc=-_Kits}', "");
    Expect(1, 101590, '\p{^Sc=-_Kits}', "");
    Expect(1, 101590, '\P{Sc=-_Kits}', "");
    Expect(0, 101590, '\P{^Sc=-_Kits}', "");
    Error('\p{Is_Script=:=-KHITAN_small_script}');
    Error('\P{Is_Script=:=-KHITAN_small_script}');
    Expect(1, 101589, '\p{Is_Script=khitansmallscript}', "");
    Expect(0, 101589, '\p{^Is_Script=khitansmallscript}', "");
    Expect(0, 101589, '\P{Is_Script=khitansmallscript}', "");
    Expect(1, 101589, '\P{^Is_Script=khitansmallscript}', "");
    Expect(0, 101590, '\p{Is_Script=khitansmallscript}', "");
    Expect(1, 101590, '\p{^Is_Script=khitansmallscript}', "");
    Expect(1, 101590, '\P{Is_Script=khitansmallscript}', "");
    Expect(0, 101590, '\P{^Is_Script=khitansmallscript}', "");
    Expect(1, 101589, '\p{Is_Script=	-KHITAN_Small_Script}', "");
    Expect(0, 101589, '\p{^Is_Script=	-KHITAN_Small_Script}', "");
    Expect(0, 101589, '\P{Is_Script=	-KHITAN_Small_Script}', "");
    Expect(1, 101589, '\P{^Is_Script=	-KHITAN_Small_Script}', "");
    Expect(0, 101590, '\p{Is_Script=	-KHITAN_Small_Script}', "");
    Expect(1, 101590, '\p{^Is_Script=	-KHITAN_Small_Script}', "");
    Expect(1, 101590, '\P{Is_Script=	-KHITAN_Small_Script}', "");
    Expect(0, 101590, '\P{^Is_Script=	-KHITAN_Small_Script}', "");
    Error('\p{Is_Sc:	_-Kits:=}');
    Error('\P{Is_Sc:	_-Kits:=}');
    Expect(1, 101589, '\p{Is_Sc=kits}', "");
    Expect(0, 101589, '\p{^Is_Sc=kits}', "");
    Expect(0, 101589, '\P{Is_Sc=kits}', "");
    Expect(1, 101589, '\P{^Is_Sc=kits}', "");
    Expect(0, 101590, '\p{Is_Sc=kits}', "");
    Expect(1, 101590, '\p{^Is_Sc=kits}', "");
    Expect(1, 101590, '\P{Is_Sc=kits}', "");
    Expect(0, 101590, '\P{^Is_Sc=kits}', "");
    Expect(1, 101589, '\p{Is_Sc=-_Kits}', "");
    Expect(0, 101589, '\p{^Is_Sc=-_Kits}', "");
    Expect(0, 101589, '\P{Is_Sc=-_Kits}', "");
    Expect(1, 101589, '\P{^Is_Sc=-_Kits}', "");
    Expect(0, 101590, '\p{Is_Sc=-_Kits}', "");
    Expect(1, 101590, '\p{^Is_Sc=-_Kits}', "");
    Expect(1, 101590, '\P{Is_Sc=-_Kits}', "");
    Expect(0, 101590, '\P{^Is_Sc=-_Kits}', "");
    Error('\p{Script: --Kannada/a/}');
    Error('\P{Script: --Kannada/a/}');
    Expect(1, 3314, '\p{Script=:\AKannada\z:}', "");;
    Expect(0, 3315, '\p{Script=:\AKannada\z:}', "");;
    Expect(1, 3314, '\p{Script=kannada}', "");
    Expect(0, 3314, '\p{^Script=kannada}', "");
    Expect(0, 3314, '\P{Script=kannada}', "");
    Expect(1, 3314, '\P{^Script=kannada}', "");
    Expect(0, 3315, '\p{Script=kannada}', "");
    Expect(1, 3315, '\p{^Script=kannada}', "");
    Expect(1, 3315, '\P{Script=kannada}', "");
    Expect(0, 3315, '\P{^Script=kannada}', "");
    Expect(1, 3314, '\p{Script=:\Akannada\z:}', "");;
    Expect(0, 3315, '\p{Script=:\Akannada\z:}', "");;
    Expect(1, 3314, '\p{Script= Kannada}', "");
    Expect(0, 3314, '\p{^Script= Kannada}', "");
    Expect(0, 3314, '\P{Script= Kannada}', "");
    Expect(1, 3314, '\P{^Script= Kannada}', "");
    Expect(0, 3315, '\p{Script= Kannada}', "");
    Expect(1, 3315, '\p{^Script= Kannada}', "");
    Expect(1, 3315, '\P{Script= Kannada}', "");
    Expect(0, 3315, '\P{^Script= Kannada}', "");
    Error('\p{Sc=/a/ -Knda}');
    Error('\P{Sc=/a/ -Knda}');
    Expect(1, 3314, '\p{Sc=:\AKnda\z:}', "");;
    Expect(0, 3315, '\p{Sc=:\AKnda\z:}', "");;
    Expect(1, 3314, '\p{Sc=knda}', "");
    Expect(0, 3314, '\p{^Sc=knda}', "");
    Expect(0, 3314, '\P{Sc=knda}', "");
    Expect(1, 3314, '\P{^Sc=knda}', "");
    Expect(0, 3315, '\p{Sc=knda}', "");
    Expect(1, 3315, '\p{^Sc=knda}', "");
    Expect(1, 3315, '\P{Sc=knda}', "");
    Expect(0, 3315, '\P{^Sc=knda}', "");
    Expect(1, 3314, '\p{Sc=:\Aknda\z:}', "");;
    Expect(0, 3315, '\p{Sc=:\Aknda\z:}', "");;
    Expect(1, 3314, '\p{Sc=  Knda}', "");
    Expect(0, 3314, '\p{^Sc=  Knda}', "");
    Expect(0, 3314, '\P{Sc=  Knda}', "");
    Expect(1, 3314, '\P{^Sc=  Knda}', "");
    Expect(0, 3315, '\p{Sc=  Knda}', "");
    Expect(1, 3315, '\p{^Sc=  Knda}', "");
    Expect(1, 3315, '\P{Sc=  Knda}', "");
    Expect(0, 3315, '\P{^Sc=  Knda}', "");
    Error('\p{Is_Script= :=Kannada}');
    Error('\P{Is_Script= :=Kannada}');
    Expect(1, 3314, '\p{Is_Script=kannada}', "");
    Expect(0, 3314, '\p{^Is_Script=kannada}', "");
    Expect(0, 3314, '\P{Is_Script=kannada}', "");
    Expect(1, 3314, '\P{^Is_Script=kannada}', "");
    Expect(0, 3315, '\p{Is_Script=kannada}', "");
    Expect(1, 3315, '\p{^Is_Script=kannada}', "");
    Expect(1, 3315, '\P{Is_Script=kannada}', "");
    Expect(0, 3315, '\P{^Is_Script=kannada}', "");
    Expect(1, 3314, '\p{Is_Script=__kannada}', "");
    Expect(0, 3314, '\p{^Is_Script=__kannada}', "");
    Expect(0, 3314, '\P{Is_Script=__kannada}', "");
    Expect(1, 3314, '\P{^Is_Script=__kannada}', "");
    Expect(0, 3315, '\p{Is_Script=__kannada}', "");
    Expect(1, 3315, '\p{^Is_Script=__kannada}', "");
    Expect(1, 3315, '\P{Is_Script=__kannada}', "");
    Expect(0, 3315, '\P{^Is_Script=__kannada}', "");
    Error('\p{Is_Sc::=-_knda}');
    Error('\P{Is_Sc::=-_knda}');
    Expect(1, 3314, '\p{Is_Sc=knda}', "");
    Expect(0, 3314, '\p{^Is_Sc=knda}', "");
    Expect(0, 3314, '\P{Is_Sc=knda}', "");
    Expect(1, 3314, '\P{^Is_Sc=knda}', "");
    Expect(0, 3315, '\p{Is_Sc=knda}', "");
    Expect(1, 3315, '\p{^Is_Sc=knda}', "");
    Expect(1, 3315, '\P{Is_Sc=knda}', "");
    Expect(0, 3315, '\P{^Is_Sc=knda}', "");
    Expect(1, 3314, '\p{Is_Sc= -KNDA}', "");
    Expect(0, 3314, '\p{^Is_Sc= -KNDA}', "");
    Expect(0, 3314, '\P{Is_Sc= -KNDA}', "");
    Expect(1, 3314, '\P{^Is_Sc= -KNDA}', "");
    Expect(0, 3315, '\p{Is_Sc= -KNDA}', "");
    Expect(1, 3315, '\p{^Is_Sc= -KNDA}', "");
    Expect(1, 3315, '\P{Is_Sc= -KNDA}', "");
    Expect(0, 3315, '\P{^Is_Sc= -KNDA}', "");
    Error('\p{Script=-Kaithi/a/}');
    Error('\P{Script=-Kaithi/a/}');
    Expect(1, 69837, '\p{Script=:\AKaithi\z:}', "");;
    Expect(0, 69838, '\p{Script=:\AKaithi\z:}', "");;
    Expect(1, 69837, '\p{Script=kaithi}', "");
    Expect(0, 69837, '\p{^Script=kaithi}', "");
    Expect(0, 69837, '\P{Script=kaithi}', "");
    Expect(1, 69837, '\P{^Script=kaithi}', "");
    Expect(0, 69838, '\p{Script=kaithi}', "");
    Expect(1, 69838, '\p{^Script=kaithi}', "");
    Expect(1, 69838, '\P{Script=kaithi}', "");
    Expect(0, 69838, '\P{^Script=kaithi}', "");
    Expect(1, 69837, '\p{Script=:\Akaithi\z:}', "");;
    Expect(0, 69838, '\p{Script=:\Akaithi\z:}', "");;
    Expect(1, 69837, '\p{Script=_KAITHI}', "");
    Expect(0, 69837, '\p{^Script=_KAITHI}', "");
    Expect(0, 69837, '\P{Script=_KAITHI}', "");
    Expect(1, 69837, '\P{^Script=_KAITHI}', "");
    Expect(0, 69838, '\p{Script=_KAITHI}', "");
    Expect(1, 69838, '\p{^Script=_KAITHI}', "");
    Expect(1, 69838, '\P{Script=_KAITHI}', "");
    Expect(0, 69838, '\P{^Script=_KAITHI}', "");
    Error('\p{Sc=kthi:=}');
    Error('\P{Sc=kthi:=}');
    Expect(1, 69837, '\p{Sc=:\AKthi\z:}', "");;
    Expect(0, 69838, '\p{Sc=:\AKthi\z:}', "");;
    Expect(1, 69837, '\p{Sc=kthi}', "");
    Expect(0, 69837, '\p{^Sc=kthi}', "");
    Expect(0, 69837, '\P{Sc=kthi}', "");
    Expect(1, 69837, '\P{^Sc=kthi}', "");
    Expect(0, 69838, '\p{Sc=kthi}', "");
    Expect(1, 69838, '\p{^Sc=kthi}', "");
    Expect(1, 69838, '\P{Sc=kthi}', "");
    Expect(0, 69838, '\P{^Sc=kthi}', "");
    Expect(1, 69837, '\p{Sc=:\Akthi\z:}', "");;
    Expect(0, 69838, '\p{Sc=:\Akthi\z:}', "");;
    Expect(1, 69837, '\p{Sc=-	KTHI}', "");
    Expect(0, 69837, '\p{^Sc=-	KTHI}', "");
    Expect(0, 69837, '\P{Sc=-	KTHI}', "");
    Expect(1, 69837, '\P{^Sc=-	KTHI}', "");
    Expect(0, 69838, '\p{Sc=-	KTHI}', "");
    Expect(1, 69838, '\p{^Sc=-	KTHI}', "");
    Expect(1, 69838, '\P{Sc=-	KTHI}', "");
    Expect(0, 69838, '\P{^Sc=-	KTHI}', "");
    Error('\p{Is_Script=-/a/Kaithi}');
    Error('\P{Is_Script=-/a/Kaithi}');
    Expect(1, 69837, '\p{Is_Script=kaithi}', "");
    Expect(0, 69837, '\p{^Is_Script=kaithi}', "");
    Expect(0, 69837, '\P{Is_Script=kaithi}', "");
    Expect(1, 69837, '\P{^Is_Script=kaithi}', "");
    Expect(0, 69838, '\p{Is_Script=kaithi}', "");
    Expect(1, 69838, '\p{^Is_Script=kaithi}', "");
    Expect(1, 69838, '\P{Is_Script=kaithi}', "");
    Expect(0, 69838, '\P{^Is_Script=kaithi}', "");
    Expect(1, 69837, '\p{Is_Script=- Kaithi}', "");
    Expect(0, 69837, '\p{^Is_Script=- Kaithi}', "");
    Expect(0, 69837, '\P{Is_Script=- Kaithi}', "");
    Expect(1, 69837, '\P{^Is_Script=- Kaithi}', "");
    Expect(0, 69838, '\p{Is_Script=- Kaithi}', "");
    Expect(1, 69838, '\p{^Is_Script=- Kaithi}', "");
    Expect(1, 69838, '\P{Is_Script=- Kaithi}', "");
    Expect(0, 69838, '\P{^Is_Script=- Kaithi}', "");
    Error('\p{Is_Sc=-	kthi/a/}');
    Error('\P{Is_Sc=-	kthi/a/}');
    Expect(1, 69837, '\p{Is_Sc=kthi}', "");
    Expect(0, 69837, '\p{^Is_Sc=kthi}', "");
    Expect(0, 69837, '\P{Is_Sc=kthi}', "");
    Expect(1, 69837, '\P{^Is_Sc=kthi}', "");
    Expect(0, 69838, '\p{Is_Sc=kthi}', "");
    Expect(1, 69838, '\p{^Is_Sc=kthi}', "");
    Expect(1, 69838, '\P{Is_Sc=kthi}', "");
    Expect(0, 69838, '\P{^Is_Sc=kthi}', "");
    Error('\p{Script=/a/ -Tai_tham}');
    Error('\P{Script=/a/ -Tai_tham}');
    Expect(1, 6829, '\p{Script=:\ATai_Tham\z:}', "");;
    Expect(0, 6830, '\p{Script=:\ATai_Tham\z:}', "");;
    Expect(1, 6829, '\p{Script:taitham}', "");
    Expect(0, 6829, '\p{^Script:taitham}', "");
    Expect(0, 6829, '\P{Script:taitham}', "");
    Expect(1, 6829, '\P{^Script:taitham}', "");
    Expect(0, 6830, '\p{Script:taitham}', "");
    Expect(1, 6830, '\p{^Script:taitham}', "");
    Expect(1, 6830, '\P{Script:taitham}', "");
    Expect(0, 6830, '\P{^Script:taitham}', "");
    Expect(1, 6829, '\p{Script=:\Ataitham\z:}', "");;
    Expect(0, 6830, '\p{Script=:\Ataitham\z:}', "");;
    Expect(1, 6829, '\p{Script=	 tai_tham}', "");
    Expect(0, 6829, '\p{^Script=	 tai_tham}', "");
    Expect(0, 6829, '\P{Script=	 tai_tham}', "");
    Expect(1, 6829, '\P{^Script=	 tai_tham}', "");
    Expect(0, 6830, '\p{Script=	 tai_tham}', "");
    Expect(1, 6830, '\p{^Script=	 tai_tham}', "");
    Expect(1, 6830, '\P{Script=	 tai_tham}', "");
    Expect(0, 6830, '\P{^Script=	 tai_tham}', "");
    Error('\p{Sc=_/a/lana}');
    Error('\P{Sc=_/a/lana}');
    Expect(1, 6829, '\p{Sc=:\ALana\z:}', "");;
    Expect(0, 6830, '\p{Sc=:\ALana\z:}', "");;
    Expect(1, 6829, '\p{Sc=lana}', "");
    Expect(0, 6829, '\p{^Sc=lana}', "");
    Expect(0, 6829, '\P{Sc=lana}', "");
    Expect(1, 6829, '\P{^Sc=lana}', "");
    Expect(0, 6830, '\p{Sc=lana}', "");
    Expect(1, 6830, '\p{^Sc=lana}', "");
    Expect(1, 6830, '\P{Sc=lana}', "");
    Expect(0, 6830, '\P{^Sc=lana}', "");
    Expect(1, 6829, '\p{Sc=:\Alana\z:}', "");;
    Expect(0, 6830, '\p{Sc=:\Alana\z:}', "");;
    Expect(1, 6829, '\p{Sc=__LANA}', "");
    Expect(0, 6829, '\p{^Sc=__LANA}', "");
    Expect(0, 6829, '\P{Sc=__LANA}', "");
    Expect(1, 6829, '\P{^Sc=__LANA}', "");
    Expect(0, 6830, '\p{Sc=__LANA}', "");
    Expect(1, 6830, '\p{^Sc=__LANA}', "");
    Expect(1, 6830, '\P{Sc=__LANA}', "");
    Expect(0, 6830, '\P{^Sc=__LANA}', "");
    Error('\p{Is_Script= /a/Tai_Tham}');
    Error('\P{Is_Script= /a/Tai_Tham}');
    Expect(1, 6829, '\p{Is_Script=taitham}', "");
    Expect(0, 6829, '\p{^Is_Script=taitham}', "");
    Expect(0, 6829, '\P{Is_Script=taitham}', "");
    Expect(1, 6829, '\P{^Is_Script=taitham}', "");
    Expect(0, 6830, '\p{Is_Script=taitham}', "");
    Expect(1, 6830, '\p{^Is_Script=taitham}', "");
    Expect(1, 6830, '\P{Is_Script=taitham}', "");
    Expect(0, 6830, '\P{^Is_Script=taitham}', "");
    Expect(1, 6829, '\p{Is_Script=	TAI_THAM}', "");
    Expect(0, 6829, '\p{^Is_Script=	TAI_THAM}', "");
    Expect(0, 6829, '\P{Is_Script=	TAI_THAM}', "");
    Expect(1, 6829, '\P{^Is_Script=	TAI_THAM}', "");
    Expect(0, 6830, '\p{Is_Script=	TAI_THAM}', "");
    Expect(1, 6830, '\p{^Is_Script=	TAI_THAM}', "");
    Expect(1, 6830, '\P{Is_Script=	TAI_THAM}', "");
    Expect(0, 6830, '\P{^Is_Script=	TAI_THAM}', "");
    Error('\p{Is_Sc=Lana/a/}');
    Error('\P{Is_Sc=Lana/a/}');
    Expect(1, 6829, '\p{Is_Sc=lana}', "");
    Expect(0, 6829, '\p{^Is_Sc=lana}', "");
    Expect(0, 6829, '\P{Is_Sc=lana}', "");
    Expect(1, 6829, '\P{^Is_Sc=lana}', "");
    Expect(0, 6830, '\p{Is_Sc=lana}', "");
    Expect(1, 6830, '\p{^Is_Sc=lana}', "");
    Expect(1, 6830, '\P{Is_Sc=lana}', "");
    Expect(0, 6830, '\P{^Is_Sc=lana}', "");
    Expect(1, 6829, '\p{Is_Sc= 	Lana}', "");
    Expect(0, 6829, '\p{^Is_Sc= 	Lana}', "");
    Expect(0, 6829, '\P{Is_Sc= 	Lana}', "");
    Expect(1, 6829, '\P{^Is_Sc= 	Lana}', "");
    Expect(0, 6830, '\p{Is_Sc= 	Lana}', "");
    Expect(1, 6830, '\p{^Is_Sc= 	Lana}', "");
    Expect(1, 6830, '\P{Is_Sc= 	Lana}', "");
    Expect(0, 6830, '\P{^Is_Sc= 	Lana}', "");
    Error('\p{Script=/a/_Lao}');
    Error('\P{Script=/a/_Lao}');
    Expect(1, 3807, '\p{Script=:\ALao\z:}', "");;
    Expect(0, 3808, '\p{Script=:\ALao\z:}', "");;
    Expect(1, 3807, '\p{Script=lao}', "");
    Expect(0, 3807, '\p{^Script=lao}', "");
    Expect(0, 3807, '\P{Script=lao}', "");
    Expect(1, 3807, '\P{^Script=lao}', "");
    Expect(0, 3808, '\p{Script=lao}', "");
    Expect(1, 3808, '\p{^Script=lao}', "");
    Expect(1, 3808, '\P{Script=lao}', "");
    Expect(0, 3808, '\P{^Script=lao}', "");
    Expect(1, 3807, '\p{Script=:\Alao\z:}', "");;
    Expect(0, 3808, '\p{Script=:\Alao\z:}', "");;
    Expect(1, 3807, '\p{Script=_-LAO}', "");
    Expect(0, 3807, '\p{^Script=_-LAO}', "");
    Expect(0, 3807, '\P{Script=_-LAO}', "");
    Expect(1, 3807, '\P{^Script=_-LAO}', "");
    Expect(0, 3808, '\p{Script=_-LAO}', "");
    Expect(1, 3808, '\p{^Script=_-LAO}', "");
    Expect(1, 3808, '\P{Script=_-LAO}', "");
    Expect(0, 3808, '\P{^Script=_-LAO}', "");
    Error('\p{Sc::= laoo}');
    Error('\P{Sc::= laoo}');
    Expect(1, 3807, '\p{Sc=:\ALaoo\z:}', "");;
    Expect(0, 3808, '\p{Sc=:\ALaoo\z:}', "");;
    Expect(1, 3807, '\p{Sc=laoo}', "");
    Expect(0, 3807, '\p{^Sc=laoo}', "");
    Expect(0, 3807, '\P{Sc=laoo}', "");
    Expect(1, 3807, '\P{^Sc=laoo}', "");
    Expect(0, 3808, '\p{Sc=laoo}', "");
    Expect(1, 3808, '\p{^Sc=laoo}', "");
    Expect(1, 3808, '\P{Sc=laoo}', "");
    Expect(0, 3808, '\P{^Sc=laoo}', "");
    Expect(1, 3807, '\p{Sc=:\Alaoo\z:}', "");;
    Expect(0, 3808, '\p{Sc=:\Alaoo\z:}', "");;
    Expect(1, 3807, '\p{Sc=__LAOO}', "");
    Expect(0, 3807, '\p{^Sc=__LAOO}', "");
    Expect(0, 3807, '\P{Sc=__LAOO}', "");
    Expect(1, 3807, '\P{^Sc=__LAOO}', "");
    Expect(0, 3808, '\p{Sc=__LAOO}', "");
    Expect(1, 3808, '\p{^Sc=__LAOO}', "");
    Expect(1, 3808, '\P{Sc=__LAOO}', "");
    Expect(0, 3808, '\P{^Sc=__LAOO}', "");
    Error('\p{Is_Script=-lao:=}');
    Error('\P{Is_Script=-lao:=}');
    Expect(1, 3807, '\p{Is_Script=lao}', "");
    Expect(0, 3807, '\p{^Is_Script=lao}', "");
    Expect(0, 3807, '\P{Is_Script=lao}', "");
    Expect(1, 3807, '\P{^Is_Script=lao}', "");
    Expect(0, 3808, '\p{Is_Script=lao}', "");
    Expect(1, 3808, '\p{^Is_Script=lao}', "");
    Expect(1, 3808, '\P{Is_Script=lao}', "");
    Expect(0, 3808, '\P{^Is_Script=lao}', "");
    Expect(1, 3807, '\p{Is_Script=- Lao}', "");
    Expect(0, 3807, '\p{^Is_Script=- Lao}', "");
    Expect(0, 3807, '\P{Is_Script=- Lao}', "");
    Expect(1, 3807, '\P{^Is_Script=- Lao}', "");
    Expect(0, 3808, '\p{Is_Script=- Lao}', "");
    Expect(1, 3808, '\p{^Is_Script=- Lao}', "");
    Expect(1, 3808, '\P{Is_Script=- Lao}', "");
    Expect(0, 3808, '\P{^Is_Script=- Lao}', "");
    Error('\p{Is_Sc= Laoo/a/}');
    Error('\P{Is_Sc= Laoo/a/}');
    Expect(1, 3807, '\p{Is_Sc=laoo}', "");
    Expect(0, 3807, '\p{^Is_Sc=laoo}', "");
    Expect(0, 3807, '\P{Is_Sc=laoo}', "");
    Expect(1, 3807, '\P{^Is_Sc=laoo}', "");
    Expect(0, 3808, '\p{Is_Sc=laoo}', "");
    Expect(1, 3808, '\p{^Is_Sc=laoo}', "");
    Expect(1, 3808, '\P{Is_Sc=laoo}', "");
    Expect(0, 3808, '\P{^Is_Sc=laoo}', "");
    Expect(1, 3807, '\p{Is_Sc=- laoo}', "");
    Expect(0, 3807, '\p{^Is_Sc=- laoo}', "");
    Expect(0, 3807, '\P{Is_Sc=- laoo}', "");
    Expect(1, 3807, '\P{^Is_Sc=- laoo}', "");
    Expect(0, 3808, '\p{Is_Sc=- laoo}', "");
    Expect(1, 3808, '\p{^Is_Sc=- laoo}', "");
    Expect(1, 3808, '\P{Is_Sc=- laoo}', "");
    Expect(0, 3808, '\P{^Is_Sc=- laoo}', "");
    Error('\p{Script=/a/Latin}');
    Error('\P{Script=/a/Latin}');
    Expect(1, 65370, '\p{Script=:\ALatin\z:}', "");;
    Expect(0, 65371, '\p{Script=:\ALatin\z:}', "");;
    Expect(1, 65370, '\p{Script:   latin}', "");
    Expect(0, 65370, '\p{^Script:   latin}', "");
    Expect(0, 65370, '\P{Script:   latin}', "");
    Expect(1, 65370, '\P{^Script:   latin}', "");
    Expect(0, 65371, '\p{Script:   latin}', "");
    Expect(1, 65371, '\p{^Script:   latin}', "");
    Expect(1, 65371, '\P{Script:   latin}', "");
    Expect(0, 65371, '\P{^Script:   latin}', "");
    Expect(1, 65370, '\p{Script=:\Alatin\z:}', "");;
    Expect(0, 65371, '\p{Script=:\Alatin\z:}', "");;
    Expect(1, 65370, '\p{Script=	Latin}', "");
    Expect(0, 65370, '\p{^Script=	Latin}', "");
    Expect(0, 65370, '\P{Script=	Latin}', "");
    Expect(1, 65370, '\P{^Script=	Latin}', "");
    Expect(0, 65371, '\p{Script=	Latin}', "");
    Expect(1, 65371, '\p{^Script=	Latin}', "");
    Expect(1, 65371, '\P{Script=	Latin}', "");
    Expect(0, 65371, '\P{^Script=	Latin}', "");
    Error('\p{Sc=_/a/LATN}');
    Error('\P{Sc=_/a/LATN}');
    Expect(1, 65370, '\p{Sc=:\ALatn\z:}', "");;
    Expect(0, 65371, '\p{Sc=:\ALatn\z:}', "");;
    Expect(1, 65370, '\p{Sc=latn}', "");
    Expect(0, 65370, '\p{^Sc=latn}', "");
    Expect(0, 65370, '\P{Sc=latn}', "");
    Expect(1, 65370, '\P{^Sc=latn}', "");
    Expect(0, 65371, '\p{Sc=latn}', "");
    Expect(1, 65371, '\p{^Sc=latn}', "");
    Expect(1, 65371, '\P{Sc=latn}', "");
    Expect(0, 65371, '\P{^Sc=latn}', "");
    Expect(1, 65370, '\p{Sc=:\Alatn\z:}', "");;
    Expect(0, 65371, '\p{Sc=:\Alatn\z:}', "");;
    Expect(1, 65370, '\p{Sc=	_Latn}', "");
    Expect(0, 65370, '\p{^Sc=	_Latn}', "");
    Expect(0, 65370, '\P{Sc=	_Latn}', "");
    Expect(1, 65370, '\P{^Sc=	_Latn}', "");
    Expect(0, 65371, '\p{Sc=	_Latn}', "");
    Expect(1, 65371, '\p{^Sc=	_Latn}', "");
    Expect(1, 65371, '\P{Sc=	_Latn}', "");
    Expect(0, 65371, '\P{^Sc=	_Latn}', "");
    Error('\p{Is_Script=-_latin/a/}');
    Error('\P{Is_Script=-_latin/a/}');
    Expect(1, 65370, '\p{Is_Script=latin}', "");
    Expect(0, 65370, '\p{^Is_Script=latin}', "");
    Expect(0, 65370, '\P{Is_Script=latin}', "");
    Expect(1, 65370, '\P{^Is_Script=latin}', "");
    Expect(0, 65371, '\p{Is_Script=latin}', "");
    Expect(1, 65371, '\p{^Is_Script=latin}', "");
    Expect(1, 65371, '\P{Is_Script=latin}', "");
    Expect(0, 65371, '\P{^Is_Script=latin}', "");
    Expect(1, 65370, '\p{Is_Script=-_Latin}', "");
    Expect(0, 65370, '\p{^Is_Script=-_Latin}', "");
    Expect(0, 65370, '\P{Is_Script=-_Latin}', "");
    Expect(1, 65370, '\P{^Is_Script=-_Latin}', "");
    Expect(0, 65371, '\p{Is_Script=-_Latin}', "");
    Expect(1, 65371, '\p{^Is_Script=-_Latin}', "");
    Expect(1, 65371, '\P{Is_Script=-_Latin}', "");
    Expect(0, 65371, '\P{^Is_Script=-_Latin}', "");
    Error('\p{Is_Sc=:=latn}');
    Error('\P{Is_Sc=:=latn}');
    Expect(1, 65370, '\p{Is_Sc:	latn}', "");
    Expect(0, 65370, '\p{^Is_Sc:	latn}', "");
    Expect(0, 65370, '\P{Is_Sc:	latn}', "");
    Expect(1, 65370, '\P{^Is_Sc:	latn}', "");
    Expect(0, 65371, '\p{Is_Sc:	latn}', "");
    Expect(1, 65371, '\p{^Is_Sc:	latn}', "");
    Expect(1, 65371, '\P{Is_Sc:	latn}', "");
    Expect(0, 65371, '\P{^Is_Sc:	latn}', "");
    Expect(1, 65370, '\p{Is_Sc=	 Latn}', "");
    Expect(0, 65370, '\p{^Is_Sc=	 Latn}', "");
    Expect(0, 65370, '\P{Is_Sc=	 Latn}', "");
    Expect(1, 65370, '\P{^Is_Sc=	 Latn}', "");
    Expect(0, 65371, '\p{Is_Sc=	 Latn}', "");
    Expect(1, 65371, '\p{^Is_Sc=	 Latn}', "");
    Expect(1, 65371, '\P{Is_Sc=	 Latn}', "");
    Expect(0, 65371, '\P{^Is_Sc=	 Latn}', "");
    Error('\p{Script=_ LEPCHA:=}');
    Error('\P{Script=_ LEPCHA:=}');
    Expect(1, 7247, '\p{Script=:\ALepcha\z:}', "");;
    Expect(0, 7248, '\p{Script=:\ALepcha\z:}', "");;
    Expect(1, 7247, '\p{Script=lepcha}', "");
    Expect(0, 7247, '\p{^Script=lepcha}', "");
    Expect(0, 7247, '\P{Script=lepcha}', "");
    Expect(1, 7247, '\P{^Script=lepcha}', "");
    Expect(0, 7248, '\p{Script=lepcha}', "");
    Expect(1, 7248, '\p{^Script=lepcha}', "");
    Expect(1, 7248, '\P{Script=lepcha}', "");
    Expect(0, 7248, '\P{^Script=lepcha}', "");
    Expect(1, 7247, '\p{Script=:\Alepcha\z:}', "");;
    Expect(0, 7248, '\p{Script=:\Alepcha\z:}', "");;
    Expect(1, 7247, '\p{Script=-Lepcha}', "");
    Expect(0, 7247, '\p{^Script=-Lepcha}', "");
    Expect(0, 7247, '\P{Script=-Lepcha}', "");
    Expect(1, 7247, '\P{^Script=-Lepcha}', "");
    Expect(0, 7248, '\p{Script=-Lepcha}', "");
    Expect(1, 7248, '\p{^Script=-Lepcha}', "");
    Expect(1, 7248, '\P{Script=-Lepcha}', "");
    Expect(0, 7248, '\P{^Script=-Lepcha}', "");
    Error('\p{Sc=__LEPC/a/}');
    Error('\P{Sc=__LEPC/a/}');
    Expect(1, 7247, '\p{Sc=:\ALepc\z:}', "");;
    Expect(0, 7248, '\p{Sc=:\ALepc\z:}', "");;
    Expect(1, 7247, '\p{Sc=lepc}', "");
    Expect(0, 7247, '\p{^Sc=lepc}', "");
    Expect(0, 7247, '\P{Sc=lepc}', "");
    Expect(1, 7247, '\P{^Sc=lepc}', "");
    Expect(0, 7248, '\p{Sc=lepc}', "");
    Expect(1, 7248, '\p{^Sc=lepc}', "");
    Expect(1, 7248, '\P{Sc=lepc}', "");
    Expect(0, 7248, '\P{^Sc=lepc}', "");
    Expect(1, 7247, '\p{Sc=:\Alepc\z:}', "");;
    Expect(0, 7248, '\p{Sc=:\Alepc\z:}', "");;
    Expect(1, 7247, '\p{Sc=	Lepc}', "");
    Expect(0, 7247, '\p{^Sc=	Lepc}', "");
    Expect(0, 7247, '\P{Sc=	Lepc}', "");
    Expect(1, 7247, '\P{^Sc=	Lepc}', "");
    Expect(0, 7248, '\p{Sc=	Lepc}', "");
    Expect(1, 7248, '\p{^Sc=	Lepc}', "");
    Expect(1, 7248, '\P{Sc=	Lepc}', "");
    Expect(0, 7248, '\P{^Sc=	Lepc}', "");
    Error('\p{Is_Script=/a/		LEPCHA}');
    Error('\P{Is_Script=/a/		LEPCHA}');
    Expect(1, 7247, '\p{Is_Script=lepcha}', "");
    Expect(0, 7247, '\p{^Is_Script=lepcha}', "");
    Expect(0, 7247, '\P{Is_Script=lepcha}', "");
    Expect(1, 7247, '\P{^Is_Script=lepcha}', "");
    Expect(0, 7248, '\p{Is_Script=lepcha}', "");
    Expect(1, 7248, '\p{^Is_Script=lepcha}', "");
    Expect(1, 7248, '\P{Is_Script=lepcha}', "");
    Expect(0, 7248, '\P{^Is_Script=lepcha}', "");
    Expect(1, 7247, '\p{Is_Script=_ lepcha}', "");
    Expect(0, 7247, '\p{^Is_Script=_ lepcha}', "");
    Expect(0, 7247, '\P{Is_Script=_ lepcha}', "");
    Expect(1, 7247, '\P{^Is_Script=_ lepcha}', "");
    Expect(0, 7248, '\p{Is_Script=_ lepcha}', "");
    Expect(1, 7248, '\p{^Is_Script=_ lepcha}', "");
    Expect(1, 7248, '\P{Is_Script=_ lepcha}', "");
    Expect(0, 7248, '\P{^Is_Script=_ lepcha}', "");
    Error('\p{Is_Sc=:=-LEPC}');
    Error('\P{Is_Sc=:=-LEPC}');
    Expect(1, 7247, '\p{Is_Sc=lepc}', "");
    Expect(0, 7247, '\p{^Is_Sc=lepc}', "");
    Expect(0, 7247, '\P{Is_Sc=lepc}', "");
    Expect(1, 7247, '\P{^Is_Sc=lepc}', "");
    Expect(0, 7248, '\p{Is_Sc=lepc}', "");
    Expect(1, 7248, '\p{^Is_Sc=lepc}', "");
    Expect(1, 7248, '\P{Is_Sc=lepc}', "");
    Expect(0, 7248, '\P{^Is_Sc=lepc}', "");
    Expect(1, 7247, '\p{Is_Sc=LEPC}', "");
    Expect(0, 7247, '\p{^Is_Sc=LEPC}', "");
    Expect(0, 7247, '\P{Is_Sc=LEPC}', "");
    Expect(1, 7247, '\P{^Is_Sc=LEPC}', "");
    Expect(0, 7248, '\p{Is_Sc=LEPC}', "");
    Expect(1, 7248, '\p{^Is_Sc=LEPC}', "");
    Expect(1, 7248, '\P{Is_Sc=LEPC}', "");
    Expect(0, 7248, '\P{^Is_Sc=LEPC}', "");
    Error('\p{Script=	-LIMBU/a/}');
    Error('\P{Script=	-LIMBU/a/}');
    Expect(1, 6479, '\p{Script=:\ALimbu\z:}', "");;
    Expect(0, 6480, '\p{Script=:\ALimbu\z:}', "");;
    Expect(1, 6479, '\p{Script=limbu}', "");
    Expect(0, 6479, '\p{^Script=limbu}', "");
    Expect(0, 6479, '\P{Script=limbu}', "");
    Expect(1, 6479, '\P{^Script=limbu}', "");
    Expect(0, 6480, '\p{Script=limbu}', "");
    Expect(1, 6480, '\p{^Script=limbu}', "");
    Expect(1, 6480, '\P{Script=limbu}', "");
    Expect(0, 6480, '\P{^Script=limbu}', "");
    Expect(1, 6479, '\p{Script=:\Alimbu\z:}', "");;
    Expect(0, 6480, '\p{Script=:\Alimbu\z:}', "");;
    Expect(1, 6479, '\p{Script: Limbu}', "");
    Expect(0, 6479, '\p{^Script: Limbu}', "");
    Expect(0, 6479, '\P{Script: Limbu}', "");
    Expect(1, 6479, '\P{^Script: Limbu}', "");
    Expect(0, 6480, '\p{Script: Limbu}', "");
    Expect(1, 6480, '\p{^Script: Limbu}', "");
    Expect(1, 6480, '\P{Script: Limbu}', "");
    Expect(0, 6480, '\P{^Script: Limbu}', "");
    Error('\p{Sc=-:=Limb}');
    Error('\P{Sc=-:=Limb}');
    Expect(1, 6479, '\p{Sc=:\ALimb\z:}', "");;
    Expect(0, 6480, '\p{Sc=:\ALimb\z:}', "");;
    Expect(1, 6479, '\p{Sc=limb}', "");
    Expect(0, 6479, '\p{^Sc=limb}', "");
    Expect(0, 6479, '\P{Sc=limb}', "");
    Expect(1, 6479, '\P{^Sc=limb}', "");
    Expect(0, 6480, '\p{Sc=limb}', "");
    Expect(1, 6480, '\p{^Sc=limb}', "");
    Expect(1, 6480, '\P{Sc=limb}', "");
    Expect(0, 6480, '\P{^Sc=limb}', "");
    Expect(1, 6479, '\p{Sc=:\Alimb\z:}', "");;
    Expect(0, 6480, '\p{Sc=:\Alimb\z:}', "");;
    Expect(1, 6479, '\p{Sc=Limb}', "");
    Expect(0, 6479, '\p{^Sc=Limb}', "");
    Expect(0, 6479, '\P{Sc=Limb}', "");
    Expect(1, 6479, '\P{^Sc=Limb}', "");
    Expect(0, 6480, '\p{Sc=Limb}', "");
    Expect(1, 6480, '\p{^Sc=Limb}', "");
    Expect(1, 6480, '\P{Sc=Limb}', "");
    Expect(0, 6480, '\P{^Sc=Limb}', "");
    Error('\p{Is_Script=:=-_Limbu}');
    Error('\P{Is_Script=:=-_Limbu}');
    Expect(1, 6479, '\p{Is_Script=limbu}', "");
    Expect(0, 6479, '\p{^Is_Script=limbu}', "");
    Expect(0, 6479, '\P{Is_Script=limbu}', "");
    Expect(1, 6479, '\P{^Is_Script=limbu}', "");
    Expect(0, 6480, '\p{Is_Script=limbu}', "");
    Expect(1, 6480, '\p{^Is_Script=limbu}', "");
    Expect(1, 6480, '\P{Is_Script=limbu}', "");
    Expect(0, 6480, '\P{^Is_Script=limbu}', "");
    Expect(1, 6479, '\p{Is_Script=		Limbu}', "");
    Expect(0, 6479, '\p{^Is_Script=		Limbu}', "");
    Expect(0, 6479, '\P{Is_Script=		Limbu}', "");
    Expect(1, 6479, '\P{^Is_Script=		Limbu}', "");
    Expect(0, 6480, '\p{Is_Script=		Limbu}', "");
    Expect(1, 6480, '\p{^Is_Script=		Limbu}', "");
    Expect(1, 6480, '\P{Is_Script=		Limbu}', "");
    Expect(0, 6480, '\P{^Is_Script=		Limbu}', "");
    Error('\p{Is_Sc=/a/_limb}');
    Error('\P{Is_Sc=/a/_limb}');
    Expect(1, 6479, '\p{Is_Sc=limb}', "");
    Expect(0, 6479, '\p{^Is_Sc=limb}', "");
    Expect(0, 6479, '\P{Is_Sc=limb}', "");
    Expect(1, 6479, '\P{^Is_Sc=limb}', "");
    Expect(0, 6480, '\p{Is_Sc=limb}', "");
    Expect(1, 6480, '\p{^Is_Sc=limb}', "");
    Expect(1, 6480, '\P{Is_Sc=limb}', "");
    Expect(0, 6480, '\P{^Is_Sc=limb}', "");
    Expect(1, 6479, '\p{Is_Sc=	-LIMB}', "");
    Expect(0, 6479, '\p{^Is_Sc=	-LIMB}', "");
    Expect(0, 6479, '\P{Is_Sc=	-LIMB}', "");
    Expect(1, 6479, '\P{^Is_Sc=	-LIMB}', "");
    Expect(0, 6480, '\p{Is_Sc=	-LIMB}', "");
    Expect(1, 6480, '\p{^Is_Sc=	-LIMB}', "");
    Expect(1, 6480, '\P{Is_Sc=	-LIMB}', "");
    Expect(0, 6480, '\P{^Is_Sc=	-LIMB}', "");
    Error('\p{Script= 	Linear_A/a/}');
    Error('\P{Script= 	Linear_A/a/}');
    Expect(1, 67431, '\p{Script=:\ALinear_A\z:}', "");;
    Expect(0, 67432, '\p{Script=:\ALinear_A\z:}', "");;
    Expect(1, 67431, '\p{Script=lineara}', "");
    Expect(0, 67431, '\p{^Script=lineara}', "");
    Expect(0, 67431, '\P{Script=lineara}', "");
    Expect(1, 67431, '\P{^Script=lineara}', "");
    Expect(0, 67432, '\p{Script=lineara}', "");
    Expect(1, 67432, '\p{^Script=lineara}', "");
    Expect(1, 67432, '\P{Script=lineara}', "");
    Expect(0, 67432, '\P{^Script=lineara}', "");
    Expect(1, 67431, '\p{Script=:\Alineara\z:}', "");;
    Expect(0, 67432, '\p{Script=:\Alineara\z:}', "");;
    Expect(1, 67431, '\p{Script:LINEAR_A}', "");
    Expect(0, 67431, '\p{^Script:LINEAR_A}', "");
    Expect(0, 67431, '\P{Script:LINEAR_A}', "");
    Expect(1, 67431, '\P{^Script:LINEAR_A}', "");
    Expect(0, 67432, '\p{Script:LINEAR_A}', "");
    Expect(1, 67432, '\p{^Script:LINEAR_A}', "");
    Expect(1, 67432, '\P{Script:LINEAR_A}', "");
    Expect(0, 67432, '\P{^Script:LINEAR_A}', "");
    Error('\p{Sc=	:=LINA}');
    Error('\P{Sc=	:=LINA}');
    Expect(1, 67431, '\p{Sc=:\ALina\z:}', "");;
    Expect(0, 67432, '\p{Sc=:\ALina\z:}', "");;
    Expect(1, 67431, '\p{Sc=lina}', "");
    Expect(0, 67431, '\p{^Sc=lina}', "");
    Expect(0, 67431, '\P{Sc=lina}', "");
    Expect(1, 67431, '\P{^Sc=lina}', "");
    Expect(0, 67432, '\p{Sc=lina}', "");
    Expect(1, 67432, '\p{^Sc=lina}', "");
    Expect(1, 67432, '\P{Sc=lina}', "");
    Expect(0, 67432, '\P{^Sc=lina}', "");
    Expect(1, 67431, '\p{Sc=:\Alina\z:}', "");;
    Expect(0, 67432, '\p{Sc=:\Alina\z:}', "");;
    Expect(1, 67431, '\p{Sc=-Lina}', "");
    Expect(0, 67431, '\p{^Sc=-Lina}', "");
    Expect(0, 67431, '\P{Sc=-Lina}', "");
    Expect(1, 67431, '\P{^Sc=-Lina}', "");
    Expect(0, 67432, '\p{Sc=-Lina}', "");
    Expect(1, 67432, '\p{^Sc=-Lina}', "");
    Expect(1, 67432, '\P{Sc=-Lina}', "");
    Expect(0, 67432, '\P{^Sc=-Lina}', "");
    Error('\p{Is_Script=/a/	linear_A}');
    Error('\P{Is_Script=/a/	linear_A}');
    Expect(1, 67431, '\p{Is_Script=lineara}', "");
    Expect(0, 67431, '\p{^Is_Script=lineara}', "");
    Expect(0, 67431, '\P{Is_Script=lineara}', "");
    Expect(1, 67431, '\P{^Is_Script=lineara}', "");
    Expect(0, 67432, '\p{Is_Script=lineara}', "");
    Expect(1, 67432, '\p{^Is_Script=lineara}', "");
    Expect(1, 67432, '\P{Is_Script=lineara}', "");
    Expect(0, 67432, '\P{^Is_Script=lineara}', "");
    Expect(1, 67431, '\p{Is_Script=- linear_A}', "");
    Expect(0, 67431, '\p{^Is_Script=- linear_A}', "");
    Expect(0, 67431, '\P{Is_Script=- linear_A}', "");
    Expect(1, 67431, '\P{^Is_Script=- linear_A}', "");
    Expect(0, 67432, '\p{Is_Script=- linear_A}', "");
    Expect(1, 67432, '\p{^Is_Script=- linear_A}', "");
    Expect(1, 67432, '\P{Is_Script=- linear_A}', "");
    Expect(0, 67432, '\P{^Is_Script=- linear_A}', "");
    Error('\p{Is_Sc=:= 	Lina}');
    Error('\P{Is_Sc=:= 	Lina}');
    Expect(1, 67431, '\p{Is_Sc=lina}', "");
    Expect(0, 67431, '\p{^Is_Sc=lina}', "");
    Expect(0, 67431, '\P{Is_Sc=lina}', "");
    Expect(1, 67431, '\P{^Is_Sc=lina}', "");
    Expect(0, 67432, '\p{Is_Sc=lina}', "");
    Expect(1, 67432, '\p{^Is_Sc=lina}', "");
    Expect(1, 67432, '\P{Is_Sc=lina}', "");
    Expect(0, 67432, '\P{^Is_Sc=lina}', "");
    Expect(1, 67431, '\p{Is_Sc= -lina}', "");
    Expect(0, 67431, '\p{^Is_Sc= -lina}', "");
    Expect(0, 67431, '\P{Is_Sc= -lina}', "");
    Expect(1, 67431, '\P{^Is_Sc= -lina}', "");
    Expect(0, 67432, '\p{Is_Sc= -lina}', "");
    Expect(1, 67432, '\p{^Is_Sc= -lina}', "");
    Expect(1, 67432, '\P{Is_Sc= -lina}', "");
    Expect(0, 67432, '\P{^Is_Sc= -lina}', "");
    Error('\p{Script=_:=linear_b}');
    Error('\P{Script=_:=linear_b}');
    Expect(1, 65786, '\p{Script=:\ALinear_B\z:}', "");;
    Expect(0, 65787, '\p{Script=:\ALinear_B\z:}', "");;
    Expect(1, 65786, '\p{Script=linearb}', "");
    Expect(0, 65786, '\p{^Script=linearb}', "");
    Expect(0, 65786, '\P{Script=linearb}', "");
    Expect(1, 65786, '\P{^Script=linearb}', "");
    Expect(0, 65787, '\p{Script=linearb}', "");
    Expect(1, 65787, '\p{^Script=linearb}', "");
    Expect(1, 65787, '\P{Script=linearb}', "");
    Expect(0, 65787, '\P{^Script=linearb}', "");
    Expect(1, 65786, '\p{Script=:\Alinearb\z:}', "");;
    Expect(0, 65787, '\p{Script=:\Alinearb\z:}', "");;
    Expect(1, 65786, '\p{Script=LINEAR_B}', "");
    Expect(0, 65786, '\p{^Script=LINEAR_B}', "");
    Expect(0, 65786, '\P{Script=LINEAR_B}', "");
    Expect(1, 65786, '\P{^Script=LINEAR_B}', "");
    Expect(0, 65787, '\p{Script=LINEAR_B}', "");
    Expect(1, 65787, '\p{^Script=LINEAR_B}', "");
    Expect(1, 65787, '\P{Script=LINEAR_B}', "");
    Expect(0, 65787, '\P{^Script=LINEAR_B}', "");
    Error('\p{Sc=:=-_Linb}');
    Error('\P{Sc=:=-_Linb}');
    Expect(1, 65786, '\p{Sc=:\ALinb\z:}', "");;
    Expect(0, 65787, '\p{Sc=:\ALinb\z:}', "");;
    Expect(1, 65786, '\p{Sc=linb}', "");
    Expect(0, 65786, '\p{^Sc=linb}', "");
    Expect(0, 65786, '\P{Sc=linb}', "");
    Expect(1, 65786, '\P{^Sc=linb}', "");
    Expect(0, 65787, '\p{Sc=linb}', "");
    Expect(1, 65787, '\p{^Sc=linb}', "");
    Expect(1, 65787, '\P{Sc=linb}', "");
    Expect(0, 65787, '\P{^Sc=linb}', "");
    Expect(1, 65786, '\p{Sc=:\Alinb\z:}', "");;
    Expect(0, 65787, '\p{Sc=:\Alinb\z:}', "");;
    Expect(1, 65786, '\p{Sc=-_Linb}', "");
    Expect(0, 65786, '\p{^Sc=-_Linb}', "");
    Expect(0, 65786, '\P{Sc=-_Linb}', "");
    Expect(1, 65786, '\P{^Sc=-_Linb}', "");
    Expect(0, 65787, '\p{Sc=-_Linb}', "");
    Expect(1, 65787, '\p{^Sc=-_Linb}', "");
    Expect(1, 65787, '\P{Sc=-_Linb}', "");
    Expect(0, 65787, '\P{^Sc=-_Linb}', "");
    Error('\p{Is_Script=_	Linear_B/a/}');
    Error('\P{Is_Script=_	Linear_B/a/}');
    Expect(1, 65786, '\p{Is_Script=linearb}', "");
    Expect(0, 65786, '\p{^Is_Script=linearb}', "");
    Expect(0, 65786, '\P{Is_Script=linearb}', "");
    Expect(1, 65786, '\P{^Is_Script=linearb}', "");
    Expect(0, 65787, '\p{Is_Script=linearb}', "");
    Expect(1, 65787, '\p{^Is_Script=linearb}', "");
    Expect(1, 65787, '\P{Is_Script=linearb}', "");
    Expect(0, 65787, '\P{^Is_Script=linearb}', "");
    Expect(1, 65786, '\p{Is_Script=-LINEAR_B}', "");
    Expect(0, 65786, '\p{^Is_Script=-LINEAR_B}', "");
    Expect(0, 65786, '\P{Is_Script=-LINEAR_B}', "");
    Expect(1, 65786, '\P{^Is_Script=-LINEAR_B}', "");
    Expect(0, 65787, '\p{Is_Script=-LINEAR_B}', "");
    Expect(1, 65787, '\p{^Is_Script=-LINEAR_B}', "");
    Expect(1, 65787, '\P{Is_Script=-LINEAR_B}', "");
    Expect(0, 65787, '\P{^Is_Script=-LINEAR_B}', "");
    Error('\p{Is_Sc=__Linb/a/}');
    Error('\P{Is_Sc=__Linb/a/}');
    Expect(1, 65786, '\p{Is_Sc=linb}', "");
    Expect(0, 65786, '\p{^Is_Sc=linb}', "");
    Expect(0, 65786, '\P{Is_Sc=linb}', "");
    Expect(1, 65786, '\P{^Is_Sc=linb}', "");
    Expect(0, 65787, '\p{Is_Sc=linb}', "");
    Expect(1, 65787, '\p{^Is_Sc=linb}', "");
    Expect(1, 65787, '\P{Is_Sc=linb}', "");
    Expect(0, 65787, '\P{^Is_Sc=linb}', "");
    Expect(1, 65786, '\p{Is_Sc=		linb}', "");
    Expect(0, 65786, '\p{^Is_Sc=		linb}', "");
    Expect(0, 65786, '\P{Is_Sc=		linb}', "");
    Expect(1, 65786, '\P{^Is_Sc=		linb}', "");
    Expect(0, 65787, '\p{Is_Sc=		linb}', "");
    Expect(1, 65787, '\p{^Is_Sc=		linb}', "");
    Expect(1, 65787, '\P{Is_Sc=		linb}', "");
    Expect(0, 65787, '\P{^Is_Sc=		linb}', "");
    Error('\p{Script= /a/LISU}');
    Error('\P{Script= /a/LISU}');
    Expect(1, 73648, '\p{Script=:\ALisu\z:}', "");;
    Expect(0, 73649, '\p{Script=:\ALisu\z:}', "");;
    Expect(1, 73648, '\p{Script=lisu}', "");
    Expect(0, 73648, '\p{^Script=lisu}', "");
    Expect(0, 73648, '\P{Script=lisu}', "");
    Expect(1, 73648, '\P{^Script=lisu}', "");
    Expect(0, 73649, '\p{Script=lisu}', "");
    Expect(1, 73649, '\p{^Script=lisu}', "");
    Expect(1, 73649, '\P{Script=lisu}', "");
    Expect(0, 73649, '\P{^Script=lisu}', "");
    Expect(1, 73648, '\p{Script=:\Alisu\z:}', "");;
    Expect(0, 73649, '\p{Script=:\Alisu\z:}', "");;
    Expect(1, 73648, '\p{Script= 	LISU}', "");
    Expect(0, 73648, '\p{^Script= 	LISU}', "");
    Expect(0, 73648, '\P{Script= 	LISU}', "");
    Expect(1, 73648, '\P{^Script= 	LISU}', "");
    Expect(0, 73649, '\p{Script= 	LISU}', "");
    Expect(1, 73649, '\p{^Script= 	LISU}', "");
    Expect(1, 73649, '\P{Script= 	LISU}', "");
    Expect(0, 73649, '\P{^Script= 	LISU}', "");
    Error('\p{Sc=_ lisu/a/}');
    Error('\P{Sc=_ lisu/a/}');
    Expect(1, 73648, '\p{Sc=:\ALisu\z:}', "");;
    Expect(0, 73649, '\p{Sc=:\ALisu\z:}', "");;
    Expect(1, 73648, '\p{Sc=lisu}', "");
    Expect(0, 73648, '\p{^Sc=lisu}', "");
    Expect(0, 73648, '\P{Sc=lisu}', "");
    Expect(1, 73648, '\P{^Sc=lisu}', "");
    Expect(0, 73649, '\p{Sc=lisu}', "");
    Expect(1, 73649, '\p{^Sc=lisu}', "");
    Expect(1, 73649, '\P{Sc=lisu}', "");
    Expect(0, 73649, '\P{^Sc=lisu}', "");
    Expect(1, 73648, '\p{Sc=:\Alisu\z:}', "");;
    Expect(0, 73649, '\p{Sc=:\Alisu\z:}', "");;
    Expect(1, 73648, '\p{Sc=Lisu}', "");
    Expect(0, 73648, '\p{^Sc=Lisu}', "");
    Expect(0, 73648, '\P{Sc=Lisu}', "");
    Expect(1, 73648, '\P{^Sc=Lisu}', "");
    Expect(0, 73649, '\p{Sc=Lisu}', "");
    Expect(1, 73649, '\p{^Sc=Lisu}', "");
    Expect(1, 73649, '\P{Sc=Lisu}', "");
    Expect(0, 73649, '\P{^Sc=Lisu}', "");
    Error('\p{Is_Script:	_	Lisu/a/}');
    Error('\P{Is_Script:	_	Lisu/a/}');
    Expect(1, 73648, '\p{Is_Script=lisu}', "");
    Expect(0, 73648, '\p{^Is_Script=lisu}', "");
    Expect(0, 73648, '\P{Is_Script=lisu}', "");
    Expect(1, 73648, '\P{^Is_Script=lisu}', "");
    Expect(0, 73649, '\p{Is_Script=lisu}', "");
    Expect(1, 73649, '\p{^Is_Script=lisu}', "");
    Expect(1, 73649, '\P{Is_Script=lisu}', "");
    Expect(0, 73649, '\P{^Is_Script=lisu}', "");
    Expect(1, 73648, '\p{Is_Script:   __Lisu}', "");
    Expect(0, 73648, '\p{^Is_Script:   __Lisu}', "");
    Expect(0, 73648, '\P{Is_Script:   __Lisu}', "");
    Expect(1, 73648, '\P{^Is_Script:   __Lisu}', "");
    Expect(0, 73649, '\p{Is_Script:   __Lisu}', "");
    Expect(1, 73649, '\p{^Is_Script:   __Lisu}', "");
    Expect(1, 73649, '\P{Is_Script:   __Lisu}', "");
    Expect(0, 73649, '\P{^Is_Script:   __Lisu}', "");
    Error('\p{Is_Sc=-/a/LISU}');
    Error('\P{Is_Sc=-/a/LISU}');
    Expect(1, 73648, '\p{Is_Sc=lisu}', "");
    Expect(0, 73648, '\p{^Is_Sc=lisu}', "");
    Expect(0, 73648, '\P{Is_Sc=lisu}', "");
    Expect(1, 73648, '\P{^Is_Sc=lisu}', "");
    Expect(0, 73649, '\p{Is_Sc=lisu}', "");
    Expect(1, 73649, '\p{^Is_Sc=lisu}', "");
    Expect(1, 73649, '\P{Is_Sc=lisu}', "");
    Expect(0, 73649, '\P{^Is_Sc=lisu}', "");
    Expect(1, 73648, '\p{Is_Sc=	 Lisu}', "");
    Expect(0, 73648, '\p{^Is_Sc=	 Lisu}', "");
    Expect(0, 73648, '\P{Is_Sc=	 Lisu}', "");
    Expect(1, 73648, '\P{^Is_Sc=	 Lisu}', "");
    Expect(0, 73649, '\p{Is_Sc=	 Lisu}', "");
    Expect(1, 73649, '\p{^Is_Sc=	 Lisu}', "");
    Expect(1, 73649, '\P{Is_Sc=	 Lisu}', "");
    Expect(0, 73649, '\P{^Is_Sc=	 Lisu}', "");
    Error('\p{Script=/a/	_LYCIAN}');
    Error('\P{Script=/a/	_LYCIAN}');
    Expect(1, 66204, '\p{Script=:\ALycian\z:}', "");;
    Expect(0, 66205, '\p{Script=:\ALycian\z:}', "");;
    Expect(1, 66204, '\p{Script=lycian}', "");
    Expect(0, 66204, '\p{^Script=lycian}', "");
    Expect(0, 66204, '\P{Script=lycian}', "");
    Expect(1, 66204, '\P{^Script=lycian}', "");
    Expect(0, 66205, '\p{Script=lycian}', "");
    Expect(1, 66205, '\p{^Script=lycian}', "");
    Expect(1, 66205, '\P{Script=lycian}', "");
    Expect(0, 66205, '\P{^Script=lycian}', "");
    Expect(1, 66204, '\p{Script=:\Alycian\z:}', "");;
    Expect(0, 66205, '\p{Script=:\Alycian\z:}', "");;
    Expect(1, 66204, '\p{Script= 	LYCIAN}', "");
    Expect(0, 66204, '\p{^Script= 	LYCIAN}', "");
    Expect(0, 66204, '\P{Script= 	LYCIAN}', "");
    Expect(1, 66204, '\P{^Script= 	LYCIAN}', "");
    Expect(0, 66205, '\p{Script= 	LYCIAN}', "");
    Expect(1, 66205, '\p{^Script= 	LYCIAN}', "");
    Expect(1, 66205, '\P{Script= 	LYCIAN}', "");
    Expect(0, 66205, '\P{^Script= 	LYCIAN}', "");
    Error('\p{Sc=:=-Lyci}');
    Error('\P{Sc=:=-Lyci}');
    Expect(1, 66204, '\p{Sc=:\ALyci\z:}', "");;
    Expect(0, 66205, '\p{Sc=:\ALyci\z:}', "");;
    Expect(1, 66204, '\p{Sc=lyci}', "");
    Expect(0, 66204, '\p{^Sc=lyci}', "");
    Expect(0, 66204, '\P{Sc=lyci}', "");
    Expect(1, 66204, '\P{^Sc=lyci}', "");
    Expect(0, 66205, '\p{Sc=lyci}', "");
    Expect(1, 66205, '\p{^Sc=lyci}', "");
    Expect(1, 66205, '\P{Sc=lyci}', "");
    Expect(0, 66205, '\P{^Sc=lyci}', "");
    Expect(1, 66204, '\p{Sc=:\Alyci\z:}', "");;
    Expect(0, 66205, '\p{Sc=:\Alyci\z:}', "");;
    Expect(1, 66204, '\p{Sc= LYCI}', "");
    Expect(0, 66204, '\p{^Sc= LYCI}', "");
    Expect(0, 66204, '\P{Sc= LYCI}', "");
    Expect(1, 66204, '\P{^Sc= LYCI}', "");
    Expect(0, 66205, '\p{Sc= LYCI}', "");
    Expect(1, 66205, '\p{^Sc= LYCI}', "");
    Expect(1, 66205, '\P{Sc= LYCI}', "");
    Expect(0, 66205, '\P{^Sc= LYCI}', "");
    Error('\p{Is_Script=/a/-Lycian}');
    Error('\P{Is_Script=/a/-Lycian}');
    Expect(1, 66204, '\p{Is_Script=lycian}', "");
    Expect(0, 66204, '\p{^Is_Script=lycian}', "");
    Expect(0, 66204, '\P{Is_Script=lycian}', "");
    Expect(1, 66204, '\P{^Is_Script=lycian}', "");
    Expect(0, 66205, '\p{Is_Script=lycian}', "");
    Expect(1, 66205, '\p{^Is_Script=lycian}', "");
    Expect(1, 66205, '\P{Is_Script=lycian}', "");
    Expect(0, 66205, '\P{^Is_Script=lycian}', "");
    Error('\p{Is_Sc=:= -Lyci}');
    Error('\P{Is_Sc=:= -Lyci}');
    Expect(1, 66204, '\p{Is_Sc=lyci}', "");
    Expect(0, 66204, '\p{^Is_Sc=lyci}', "");
    Expect(0, 66204, '\P{Is_Sc=lyci}', "");
    Expect(1, 66204, '\P{^Is_Sc=lyci}', "");
    Expect(0, 66205, '\p{Is_Sc=lyci}', "");
    Expect(1, 66205, '\p{^Is_Sc=lyci}', "");
    Expect(1, 66205, '\P{Is_Sc=lyci}', "");
    Expect(0, 66205, '\P{^Is_Sc=lyci}', "");
    Expect(1, 66204, '\p{Is_Sc=	-Lyci}', "");
    Expect(0, 66204, '\p{^Is_Sc=	-Lyci}', "");
    Expect(0, 66204, '\P{Is_Sc=	-Lyci}', "");
    Expect(1, 66204, '\P{^Is_Sc=	-Lyci}', "");
    Expect(0, 66205, '\p{Is_Sc=	-Lyci}', "");
    Expect(1, 66205, '\p{^Is_Sc=	-Lyci}', "");
    Expect(1, 66205, '\P{Is_Sc=	-Lyci}', "");
    Expect(0, 66205, '\P{^Is_Sc=	-Lyci}', "");
    Error('\p{Script=-/a/lydian}');
    Error('\P{Script=-/a/lydian}');
    Expect(1, 67903, '\p{Script=:\ALydian\z:}', "");;
    Expect(0, 67904, '\p{Script=:\ALydian\z:}', "");;
    Expect(1, 67903, '\p{Script=lydian}', "");
    Expect(0, 67903, '\p{^Script=lydian}', "");
    Expect(0, 67903, '\P{Script=lydian}', "");
    Expect(1, 67903, '\P{^Script=lydian}', "");
    Expect(0, 67904, '\p{Script=lydian}', "");
    Expect(1, 67904, '\p{^Script=lydian}', "");
    Expect(1, 67904, '\P{Script=lydian}', "");
    Expect(0, 67904, '\P{^Script=lydian}', "");
    Expect(1, 67903, '\p{Script=:\Alydian\z:}', "");;
    Expect(0, 67904, '\p{Script=:\Alydian\z:}', "");;
    Expect(1, 67903, '\p{Script=	_Lydian}', "");
    Expect(0, 67903, '\p{^Script=	_Lydian}', "");
    Expect(0, 67903, '\P{Script=	_Lydian}', "");
    Expect(1, 67903, '\P{^Script=	_Lydian}', "");
    Expect(0, 67904, '\p{Script=	_Lydian}', "");
    Expect(1, 67904, '\p{^Script=	_Lydian}', "");
    Expect(1, 67904, '\P{Script=	_Lydian}', "");
    Expect(0, 67904, '\P{^Script=	_Lydian}', "");
    Error('\p{Sc=_	Lydi:=}');
    Error('\P{Sc=_	Lydi:=}');
    Expect(1, 67903, '\p{Sc=:\ALydi\z:}', "");;
    Expect(0, 67904, '\p{Sc=:\ALydi\z:}', "");;
    Expect(1, 67903, '\p{Sc=lydi}', "");
    Expect(0, 67903, '\p{^Sc=lydi}', "");
    Expect(0, 67903, '\P{Sc=lydi}', "");
    Expect(1, 67903, '\P{^Sc=lydi}', "");
    Expect(0, 67904, '\p{Sc=lydi}', "");
    Expect(1, 67904, '\p{^Sc=lydi}', "");
    Expect(1, 67904, '\P{Sc=lydi}', "");
    Expect(0, 67904, '\P{^Sc=lydi}', "");
    Expect(1, 67903, '\p{Sc=:\Alydi\z:}', "");;
    Expect(0, 67904, '\p{Sc=:\Alydi\z:}', "");;
    Expect(1, 67903, '\p{Sc=--LYDI}', "");
    Expect(0, 67903, '\p{^Sc=--LYDI}', "");
    Expect(0, 67903, '\P{Sc=--LYDI}', "");
    Expect(1, 67903, '\P{^Sc=--LYDI}', "");
    Expect(0, 67904, '\p{Sc=--LYDI}', "");
    Expect(1, 67904, '\p{^Sc=--LYDI}', "");
    Expect(1, 67904, '\P{Sc=--LYDI}', "");
    Expect(0, 67904, '\P{^Sc=--LYDI}', "");
    Error('\p{Is_Script=/a/- Lydian}');
    Error('\P{Is_Script=/a/- Lydian}');
    Expect(1, 67903, '\p{Is_Script=lydian}', "");
    Expect(0, 67903, '\p{^Is_Script=lydian}', "");
    Expect(0, 67903, '\P{Is_Script=lydian}', "");
    Expect(1, 67903, '\P{^Is_Script=lydian}', "");
    Expect(0, 67904, '\p{Is_Script=lydian}', "");
    Expect(1, 67904, '\p{^Is_Script=lydian}', "");
    Expect(1, 67904, '\P{Is_Script=lydian}', "");
    Expect(0, 67904, '\P{^Is_Script=lydian}', "");
    Expect(1, 67903, '\p{Is_Script=_Lydian}', "");
    Expect(0, 67903, '\p{^Is_Script=_Lydian}', "");
    Expect(0, 67903, '\P{Is_Script=_Lydian}', "");
    Expect(1, 67903, '\P{^Is_Script=_Lydian}', "");
    Expect(0, 67904, '\p{Is_Script=_Lydian}', "");
    Expect(1, 67904, '\p{^Is_Script=_Lydian}', "");
    Expect(1, 67904, '\P{Is_Script=_Lydian}', "");
    Expect(0, 67904, '\P{^Is_Script=_Lydian}', "");
    Error('\p{Is_Sc=:=LYDI}');
    Error('\P{Is_Sc=:=LYDI}');
    Expect(1, 67903, '\p{Is_Sc=lydi}', "");
    Expect(0, 67903, '\p{^Is_Sc=lydi}', "");
    Expect(0, 67903, '\P{Is_Sc=lydi}', "");
    Expect(1, 67903, '\P{^Is_Sc=lydi}', "");
    Expect(0, 67904, '\p{Is_Sc=lydi}', "");
    Expect(1, 67904, '\p{^Is_Sc=lydi}', "");
    Expect(1, 67904, '\P{Is_Sc=lydi}', "");
    Expect(0, 67904, '\P{^Is_Sc=lydi}', "");
    Expect(1, 67903, '\p{Is_Sc=--lydi}', "");
    Expect(0, 67903, '\p{^Is_Sc=--lydi}', "");
    Expect(0, 67903, '\P{Is_Sc=--lydi}', "");
    Expect(1, 67903, '\P{^Is_Sc=--lydi}', "");
    Expect(0, 67904, '\p{Is_Sc=--lydi}', "");
    Expect(1, 67904, '\p{^Is_Sc=--lydi}', "");
    Expect(1, 67904, '\P{Is_Sc=--lydi}', "");
    Expect(0, 67904, '\P{^Is_Sc=--lydi}', "");
    Error('\p{Script=:= _Mahajani}');
    Error('\P{Script=:= _Mahajani}');
    Expect(1, 70006, '\p{Script=:\AMahajani\z:}', "");;
    Expect(0, 70007, '\p{Script=:\AMahajani\z:}', "");;
    Expect(1, 70006, '\p{Script: mahajani}', "");
    Expect(0, 70006, '\p{^Script: mahajani}', "");
    Expect(0, 70006, '\P{Script: mahajani}', "");
    Expect(1, 70006, '\P{^Script: mahajani}', "");
    Expect(0, 70007, '\p{Script: mahajani}', "");
    Expect(1, 70007, '\p{^Script: mahajani}', "");
    Expect(1, 70007, '\P{Script: mahajani}', "");
    Expect(0, 70007, '\P{^Script: mahajani}', "");
    Expect(1, 70006, '\p{Script=:\Amahajani\z:}', "");;
    Expect(0, 70007, '\p{Script=:\Amahajani\z:}', "");;
    Expect(1, 70006, '\p{Script:   __Mahajani}', "");
    Expect(0, 70006, '\p{^Script:   __Mahajani}', "");
    Expect(0, 70006, '\P{Script:   __Mahajani}', "");
    Expect(1, 70006, '\P{^Script:   __Mahajani}', "");
    Expect(0, 70007, '\p{Script:   __Mahajani}', "");
    Expect(1, 70007, '\p{^Script:   __Mahajani}', "");
    Expect(1, 70007, '\P{Script:   __Mahajani}', "");
    Expect(0, 70007, '\P{^Script:   __Mahajani}', "");
    Error('\p{Sc=/a/ -Mahj}');
    Error('\P{Sc=/a/ -Mahj}');
    Expect(1, 70006, '\p{Sc=:\AMahj\z:}', "");;
    Expect(0, 70007, '\p{Sc=:\AMahj\z:}', "");;
    Expect(1, 70006, '\p{Sc=mahj}', "");
    Expect(0, 70006, '\p{^Sc=mahj}', "");
    Expect(0, 70006, '\P{Sc=mahj}', "");
    Expect(1, 70006, '\P{^Sc=mahj}', "");
    Expect(0, 70007, '\p{Sc=mahj}', "");
    Expect(1, 70007, '\p{^Sc=mahj}', "");
    Expect(1, 70007, '\P{Sc=mahj}', "");
    Expect(0, 70007, '\P{^Sc=mahj}', "");
    Expect(1, 70006, '\p{Sc=:\Amahj\z:}', "");;
    Expect(0, 70007, '\p{Sc=:\Amahj\z:}', "");;
    Expect(1, 70006, '\p{Sc=_Mahj}', "");
    Expect(0, 70006, '\p{^Sc=_Mahj}', "");
    Expect(0, 70006, '\P{Sc=_Mahj}', "");
    Expect(1, 70006, '\P{^Sc=_Mahj}', "");
    Expect(0, 70007, '\p{Sc=_Mahj}', "");
    Expect(1, 70007, '\p{^Sc=_Mahj}', "");
    Expect(1, 70007, '\P{Sc=_Mahj}', "");
    Expect(0, 70007, '\P{^Sc=_Mahj}', "");
    Error('\p{Is_Script=__MAHAJANI:=}');
    Error('\P{Is_Script=__MAHAJANI:=}');
    Expect(1, 70006, '\p{Is_Script:mahajani}', "");
    Expect(0, 70006, '\p{^Is_Script:mahajani}', "");
    Expect(0, 70006, '\P{Is_Script:mahajani}', "");
    Expect(1, 70006, '\P{^Is_Script:mahajani}', "");
    Expect(0, 70007, '\p{Is_Script:mahajani}', "");
    Expect(1, 70007, '\p{^Is_Script:mahajani}', "");
    Expect(1, 70007, '\P{Is_Script:mahajani}', "");
    Expect(0, 70007, '\P{^Is_Script:mahajani}', "");
    Expect(1, 70006, '\p{Is_Script=_Mahajani}', "");
    Expect(0, 70006, '\p{^Is_Script=_Mahajani}', "");
    Expect(0, 70006, '\P{Is_Script=_Mahajani}', "");
    Expect(1, 70006, '\P{^Is_Script=_Mahajani}', "");
    Expect(0, 70007, '\p{Is_Script=_Mahajani}', "");
    Expect(1, 70007, '\p{^Is_Script=_Mahajani}', "");
    Expect(1, 70007, '\P{Is_Script=_Mahajani}', "");
    Expect(0, 70007, '\P{^Is_Script=_Mahajani}', "");
    Error('\p{Is_Sc=-:=Mahj}');
    Error('\P{Is_Sc=-:=Mahj}');
    Expect(1, 70006, '\p{Is_Sc=mahj}', "");
    Expect(0, 70006, '\p{^Is_Sc=mahj}', "");
    Expect(0, 70006, '\P{Is_Sc=mahj}', "");
    Expect(1, 70006, '\P{^Is_Sc=mahj}', "");
    Expect(0, 70007, '\p{Is_Sc=mahj}', "");
    Expect(1, 70007, '\p{^Is_Sc=mahj}', "");
    Expect(1, 70007, '\P{Is_Sc=mahj}', "");
    Expect(0, 70007, '\P{^Is_Sc=mahj}', "");
    Expect(1, 70006, '\p{Is_Sc=_MAHJ}', "");
    Expect(0, 70006, '\p{^Is_Sc=_MAHJ}', "");
    Expect(0, 70006, '\P{Is_Sc=_MAHJ}', "");
    Expect(1, 70006, '\P{^Is_Sc=_MAHJ}', "");
    Expect(0, 70007, '\p{Is_Sc=_MAHJ}', "");
    Expect(1, 70007, '\p{^Is_Sc=_MAHJ}', "");
    Expect(1, 70007, '\P{Is_Sc=_MAHJ}', "");
    Expect(0, 70007, '\P{^Is_Sc=_MAHJ}', "");
    Error('\p{Script=_	Makasar/a/}');
    Error('\P{Script=_	Makasar/a/}');
    Expect(1, 73464, '\p{Script=:\AMakasar\z:}', "");;
    Expect(0, 73465, '\p{Script=:\AMakasar\z:}', "");;
    Expect(1, 73464, '\p{Script=makasar}', "");
    Expect(0, 73464, '\p{^Script=makasar}', "");
    Expect(0, 73464, '\P{Script=makasar}', "");
    Expect(1, 73464, '\P{^Script=makasar}', "");
    Expect(0, 73465, '\p{Script=makasar}', "");
    Expect(1, 73465, '\p{^Script=makasar}', "");
    Expect(1, 73465, '\P{Script=makasar}', "");
    Expect(0, 73465, '\P{^Script=makasar}', "");
    Expect(1, 73464, '\p{Script=:\Amakasar\z:}', "");;
    Expect(0, 73465, '\p{Script=:\Amakasar\z:}', "");;
    Expect(1, 73464, '\p{Script=		makasar}', "");
    Expect(0, 73464, '\p{^Script=		makasar}', "");
    Expect(0, 73464, '\P{Script=		makasar}', "");
    Expect(1, 73464, '\P{^Script=		makasar}', "");
    Expect(0, 73465, '\p{Script=		makasar}', "");
    Expect(1, 73465, '\p{^Script=		makasar}', "");
    Expect(1, 73465, '\P{Script=		makasar}', "");
    Expect(0, 73465, '\P{^Script=		makasar}', "");
    Error('\p{Sc:	/a/--Maka}');
    Error('\P{Sc:	/a/--Maka}');
    Expect(1, 73464, '\p{Sc=:\AMaka\z:}', "");;
    Expect(0, 73465, '\p{Sc=:\AMaka\z:}', "");;
    Expect(1, 73464, '\p{Sc=maka}', "");
    Expect(0, 73464, '\p{^Sc=maka}', "");
    Expect(0, 73464, '\P{Sc=maka}', "");
    Expect(1, 73464, '\P{^Sc=maka}', "");
    Expect(0, 73465, '\p{Sc=maka}', "");
    Expect(1, 73465, '\p{^Sc=maka}', "");
    Expect(1, 73465, '\P{Sc=maka}', "");
    Expect(0, 73465, '\P{^Sc=maka}', "");
    Expect(1, 73464, '\p{Sc=:\Amaka\z:}', "");;
    Expect(0, 73465, '\p{Sc=:\Amaka\z:}', "");;
    Expect(1, 73464, '\p{Sc=__MAKA}', "");
    Expect(0, 73464, '\p{^Sc=__MAKA}', "");
    Expect(0, 73464, '\P{Sc=__MAKA}', "");
    Expect(1, 73464, '\P{^Sc=__MAKA}', "");
    Expect(0, 73465, '\p{Sc=__MAKA}', "");
    Expect(1, 73465, '\p{^Sc=__MAKA}', "");
    Expect(1, 73465, '\P{Sc=__MAKA}', "");
    Expect(0, 73465, '\P{^Sc=__MAKA}', "");
    Error('\p{Is_Script=-_makasar:=}');
    Error('\P{Is_Script=-_makasar:=}');
    Expect(1, 73464, '\p{Is_Script=makasar}', "");
    Expect(0, 73464, '\p{^Is_Script=makasar}', "");
    Expect(0, 73464, '\P{Is_Script=makasar}', "");
    Expect(1, 73464, '\P{^Is_Script=makasar}', "");
    Expect(0, 73465, '\p{Is_Script=makasar}', "");
    Expect(1, 73465, '\p{^Is_Script=makasar}', "");
    Expect(1, 73465, '\P{Is_Script=makasar}', "");
    Expect(0, 73465, '\P{^Is_Script=makasar}', "");
    Expect(1, 73464, '\p{Is_Script=	 Makasar}', "");
    Expect(0, 73464, '\p{^Is_Script=	 Makasar}', "");
    Expect(0, 73464, '\P{Is_Script=	 Makasar}', "");
    Expect(1, 73464, '\P{^Is_Script=	 Makasar}', "");
    Expect(0, 73465, '\p{Is_Script=	 Makasar}', "");
    Expect(1, 73465, '\p{^Is_Script=	 Makasar}', "");
    Expect(1, 73465, '\P{Is_Script=	 Makasar}', "");
    Expect(0, 73465, '\P{^Is_Script=	 Makasar}', "");
    Error('\p{Is_Sc: 	/a/maka}');
    Error('\P{Is_Sc: 	/a/maka}');
    Expect(1, 73464, '\p{Is_Sc:maka}', "");
    Expect(0, 73464, '\p{^Is_Sc:maka}', "");
    Expect(0, 73464, '\P{Is_Sc:maka}', "");
    Expect(1, 73464, '\P{^Is_Sc:maka}', "");
    Expect(0, 73465, '\p{Is_Sc:maka}', "");
    Expect(1, 73465, '\p{^Is_Sc:maka}', "");
    Expect(1, 73465, '\P{Is_Sc:maka}', "");
    Expect(0, 73465, '\P{^Is_Sc:maka}', "");
    Expect(1, 73464, '\p{Is_Sc= -Maka}', "");
    Expect(0, 73464, '\p{^Is_Sc= -Maka}', "");
    Expect(0, 73464, '\P{Is_Sc= -Maka}', "");
    Expect(1, 73464, '\P{^Is_Sc= -Maka}', "");
    Expect(0, 73465, '\p{Is_Sc= -Maka}', "");
    Expect(1, 73465, '\p{^Is_Sc= -Maka}', "");
    Expect(1, 73465, '\P{Is_Sc= -Maka}', "");
    Expect(0, 73465, '\P{^Is_Sc= -Maka}', "");
    Error('\p{Script=/a/mandaic}');
    Error('\P{Script=/a/mandaic}');
    Expect(1, 2142, '\p{Script=:\AMandaic\z:}', "");;
    Expect(0, 2143, '\p{Script=:\AMandaic\z:}', "");;
    Expect(1, 2142, '\p{Script=mandaic}', "");
    Expect(0, 2142, '\p{^Script=mandaic}', "");
    Expect(0, 2142, '\P{Script=mandaic}', "");
    Expect(1, 2142, '\P{^Script=mandaic}', "");
    Expect(0, 2143, '\p{Script=mandaic}', "");
    Expect(1, 2143, '\p{^Script=mandaic}', "");
    Expect(1, 2143, '\P{Script=mandaic}', "");
    Expect(0, 2143, '\P{^Script=mandaic}', "");
    Expect(1, 2142, '\p{Script=:\Amandaic\z:}', "");;
    Expect(0, 2143, '\p{Script=:\Amandaic\z:}', "");;
    Expect(1, 2142, '\p{Script=_	mandaic}', "");
    Expect(0, 2142, '\p{^Script=_	mandaic}', "");
    Expect(0, 2142, '\P{Script=_	mandaic}', "");
    Expect(1, 2142, '\P{^Script=_	mandaic}', "");
    Expect(0, 2143, '\p{Script=_	mandaic}', "");
    Expect(1, 2143, '\p{^Script=_	mandaic}', "");
    Expect(1, 2143, '\P{Script=_	mandaic}', "");
    Expect(0, 2143, '\P{^Script=_	mandaic}', "");
    Error('\p{Sc=-_MAND:=}');
    Error('\P{Sc=-_MAND:=}');
    Expect(1, 2142, '\p{Sc=:\AMand\z:}', "");;
    Expect(0, 2143, '\p{Sc=:\AMand\z:}', "");;
    Expect(1, 2142, '\p{Sc=mand}', "");
    Expect(0, 2142, '\p{^Sc=mand}', "");
    Expect(0, 2142, '\P{Sc=mand}', "");
    Expect(1, 2142, '\P{^Sc=mand}', "");
    Expect(0, 2143, '\p{Sc=mand}', "");
    Expect(1, 2143, '\p{^Sc=mand}', "");
    Expect(1, 2143, '\P{Sc=mand}', "");
    Expect(0, 2143, '\P{^Sc=mand}', "");
    Expect(1, 2142, '\p{Sc=:\Amand\z:}', "");;
    Expect(0, 2143, '\p{Sc=:\Amand\z:}', "");;
    Expect(1, 2142, '\p{Sc=		mand}', "");
    Expect(0, 2142, '\p{^Sc=		mand}', "");
    Expect(0, 2142, '\P{Sc=		mand}', "");
    Expect(1, 2142, '\P{^Sc=		mand}', "");
    Expect(0, 2143, '\p{Sc=		mand}', "");
    Expect(1, 2143, '\p{^Sc=		mand}', "");
    Expect(1, 2143, '\P{Sc=		mand}', "");
    Expect(0, 2143, '\P{^Sc=		mand}', "");
    Error('\p{Is_Script=_:=Mandaic}');
    Error('\P{Is_Script=_:=Mandaic}');
    Expect(1, 2142, '\p{Is_Script=mandaic}', "");
    Expect(0, 2142, '\p{^Is_Script=mandaic}', "");
    Expect(0, 2142, '\P{Is_Script=mandaic}', "");
    Expect(1, 2142, '\P{^Is_Script=mandaic}', "");
    Expect(0, 2143, '\p{Is_Script=mandaic}', "");
    Expect(1, 2143, '\p{^Is_Script=mandaic}', "");
    Expect(1, 2143, '\P{Is_Script=mandaic}', "");
    Expect(0, 2143, '\P{^Is_Script=mandaic}', "");
    Expect(1, 2142, '\p{Is_Script:	mandaic}', "");
    Expect(0, 2142, '\p{^Is_Script:	mandaic}', "");
    Expect(0, 2142, '\P{Is_Script:	mandaic}', "");
    Expect(1, 2142, '\P{^Is_Script:	mandaic}', "");
    Expect(0, 2143, '\p{Is_Script:	mandaic}', "");
    Expect(1, 2143, '\p{^Is_Script:	mandaic}', "");
    Expect(1, 2143, '\P{Is_Script:	mandaic}', "");
    Expect(0, 2143, '\P{^Is_Script:	mandaic}', "");
    Error('\p{Is_Sc=/a/ -mand}');
    Error('\P{Is_Sc=/a/ -mand}');
    Expect(1, 2142, '\p{Is_Sc=mand}', "");
    Expect(0, 2142, '\p{^Is_Sc=mand}', "");
    Expect(0, 2142, '\P{Is_Sc=mand}', "");
    Expect(1, 2142, '\P{^Is_Sc=mand}', "");
    Expect(0, 2143, '\p{Is_Sc=mand}', "");
    Expect(1, 2143, '\p{^Is_Sc=mand}', "");
    Expect(1, 2143, '\P{Is_Sc=mand}', "");
    Expect(0, 2143, '\P{^Is_Sc=mand}', "");
    Expect(1, 2142, '\p{Is_Sc:   -	Mand}', "");
    Expect(0, 2142, '\p{^Is_Sc:   -	Mand}', "");
    Expect(0, 2142, '\P{Is_Sc:   -	Mand}', "");
    Expect(1, 2142, '\P{^Is_Sc:   -	Mand}', "");
    Expect(0, 2143, '\p{Is_Sc:   -	Mand}', "");
    Expect(1, 2143, '\p{^Is_Sc:   -	Mand}', "");
    Expect(1, 2143, '\P{Is_Sc:   -	Mand}', "");
    Expect(0, 2143, '\P{^Is_Sc:   -	Mand}', "");
    Error('\p{Script=-/a/MANICHAEAN}');
    Error('\P{Script=-/a/MANICHAEAN}');
    Expect(1, 68342, '\p{Script=:\AManichaean\z:}', "");;
    Expect(0, 68343, '\p{Script=:\AManichaean\z:}', "");;
    Expect(1, 68342, '\p{Script=manichaean}', "");
    Expect(0, 68342, '\p{^Script=manichaean}', "");
    Expect(0, 68342, '\P{Script=manichaean}', "");
    Expect(1, 68342, '\P{^Script=manichaean}', "");
    Expect(0, 68343, '\p{Script=manichaean}', "");
    Expect(1, 68343, '\p{^Script=manichaean}', "");
    Expect(1, 68343, '\P{Script=manichaean}', "");
    Expect(0, 68343, '\P{^Script=manichaean}', "");
    Expect(1, 68342, '\p{Script=:\Amanichaean\z:}', "");;
    Expect(0, 68343, '\p{Script=:\Amanichaean\z:}', "");;
    Expect(1, 68342, '\p{Script=	-Manichaean}', "");
    Expect(0, 68342, '\p{^Script=	-Manichaean}', "");
    Expect(0, 68342, '\P{Script=	-Manichaean}', "");
    Expect(1, 68342, '\P{^Script=	-Manichaean}', "");
    Expect(0, 68343, '\p{Script=	-Manichaean}', "");
    Expect(1, 68343, '\p{^Script=	-Manichaean}', "");
    Expect(1, 68343, '\P{Script=	-Manichaean}', "");
    Expect(0, 68343, '\P{^Script=	-Manichaean}', "");
    Error('\p{Sc=	MANI/a/}');
    Error('\P{Sc=	MANI/a/}');
    Expect(1, 68342, '\p{Sc=:\AMani\z:}', "");;
    Expect(0, 68343, '\p{Sc=:\AMani\z:}', "");;
    Expect(1, 68342, '\p{Sc=mani}', "");
    Expect(0, 68342, '\p{^Sc=mani}', "");
    Expect(0, 68342, '\P{Sc=mani}', "");
    Expect(1, 68342, '\P{^Sc=mani}', "");
    Expect(0, 68343, '\p{Sc=mani}', "");
    Expect(1, 68343, '\p{^Sc=mani}', "");
    Expect(1, 68343, '\P{Sc=mani}', "");
    Expect(0, 68343, '\P{^Sc=mani}', "");
    Expect(1, 68342, '\p{Sc=:\Amani\z:}', "");;
    Expect(0, 68343, '\p{Sc=:\Amani\z:}', "");;
    Expect(1, 68342, '\p{Sc=_Mani}', "");
    Expect(0, 68342, '\p{^Sc=_Mani}', "");
    Expect(0, 68342, '\P{Sc=_Mani}', "");
    Expect(1, 68342, '\P{^Sc=_Mani}', "");
    Expect(0, 68343, '\p{Sc=_Mani}', "");
    Expect(1, 68343, '\p{^Sc=_Mani}', "");
    Expect(1, 68343, '\P{Sc=_Mani}', "");
    Expect(0, 68343, '\P{^Sc=_Mani}', "");
    Error('\p{Is_Script=/a/	_MANICHAEAN}');
    Error('\P{Is_Script=/a/	_MANICHAEAN}');
    Expect(1, 68342, '\p{Is_Script=manichaean}', "");
    Expect(0, 68342, '\p{^Is_Script=manichaean}', "");
    Expect(0, 68342, '\P{Is_Script=manichaean}', "");
    Expect(1, 68342, '\P{^Is_Script=manichaean}', "");
    Expect(0, 68343, '\p{Is_Script=manichaean}', "");
    Expect(1, 68343, '\p{^Is_Script=manichaean}', "");
    Expect(1, 68343, '\P{Is_Script=manichaean}', "");
    Expect(0, 68343, '\P{^Is_Script=manichaean}', "");
    Expect(1, 68342, '\p{Is_Script:   -_Manichaean}', "");
    Expect(0, 68342, '\p{^Is_Script:   -_Manichaean}', "");
    Expect(0, 68342, '\P{Is_Script:   -_Manichaean}', "");
    Expect(1, 68342, '\P{^Is_Script:   -_Manichaean}', "");
    Expect(0, 68343, '\p{Is_Script:   -_Manichaean}', "");
    Expect(1, 68343, '\p{^Is_Script:   -_Manichaean}', "");
    Expect(1, 68343, '\P{Is_Script:   -_Manichaean}', "");
    Expect(0, 68343, '\P{^Is_Script:   -_Manichaean}', "");
    Error('\p{Is_Sc=/a/__Mani}');
    Error('\P{Is_Sc=/a/__Mani}');
    Expect(1, 68342, '\p{Is_Sc=mani}', "");
    Expect(0, 68342, '\p{^Is_Sc=mani}', "");
    Expect(0, 68342, '\P{Is_Sc=mani}', "");
    Expect(1, 68342, '\P{^Is_Sc=mani}', "");
    Expect(0, 68343, '\p{Is_Sc=mani}', "");
    Expect(1, 68343, '\p{^Is_Sc=mani}', "");
    Expect(1, 68343, '\P{Is_Sc=mani}', "");
    Expect(0, 68343, '\P{^Is_Sc=mani}', "");
    Expect(1, 68342, '\p{Is_Sc=-mani}', "");
    Expect(0, 68342, '\p{^Is_Sc=-mani}', "");
    Expect(0, 68342, '\P{Is_Sc=-mani}', "");
    Expect(1, 68342, '\P{^Is_Sc=-mani}', "");
    Expect(0, 68343, '\p{Is_Sc=-mani}', "");
    Expect(1, 68343, '\p{^Is_Sc=-mani}', "");
    Expect(1, 68343, '\P{Is_Sc=-mani}', "");
    Expect(0, 68343, '\P{^Is_Sc=-mani}', "");
    Error('\p{Script= Marchen/a/}');
    Error('\P{Script= Marchen/a/}');
    Expect(1, 72886, '\p{Script=:\AMarchen\z:}', "");;
    Expect(0, 72887, '\p{Script=:\AMarchen\z:}', "");;
    Expect(1, 72886, '\p{Script=marchen}', "");
    Expect(0, 72886, '\p{^Script=marchen}', "");
    Expect(0, 72886, '\P{Script=marchen}', "");
    Expect(1, 72886, '\P{^Script=marchen}', "");
    Expect(0, 72887, '\p{Script=marchen}', "");
    Expect(1, 72887, '\p{^Script=marchen}', "");
    Expect(1, 72887, '\P{Script=marchen}', "");
    Expect(0, 72887, '\P{^Script=marchen}', "");
    Expect(1, 72886, '\p{Script=:\Amarchen\z:}', "");;
    Expect(0, 72887, '\p{Script=:\Amarchen\z:}', "");;
    Expect(1, 72886, '\p{Script=_Marchen}', "");
    Expect(0, 72886, '\p{^Script=_Marchen}', "");
    Expect(0, 72886, '\P{Script=_Marchen}', "");
    Expect(1, 72886, '\P{^Script=_Marchen}', "");
    Expect(0, 72887, '\p{Script=_Marchen}', "");
    Expect(1, 72887, '\p{^Script=_Marchen}', "");
    Expect(1, 72887, '\P{Script=_Marchen}', "");
    Expect(0, 72887, '\P{^Script=_Marchen}', "");
    Error('\p{Sc::=- marc}');
    Error('\P{Sc::=- marc}');
    Expect(1, 72886, '\p{Sc=:\AMarc\z:}', "");;
    Expect(0, 72887, '\p{Sc=:\AMarc\z:}', "");;
    Expect(1, 72886, '\p{Sc=marc}', "");
    Expect(0, 72886, '\p{^Sc=marc}', "");
    Expect(0, 72886, '\P{Sc=marc}', "");
    Expect(1, 72886, '\P{^Sc=marc}', "");
    Expect(0, 72887, '\p{Sc=marc}', "");
    Expect(1, 72887, '\p{^Sc=marc}', "");
    Expect(1, 72887, '\P{Sc=marc}', "");
    Expect(0, 72887, '\P{^Sc=marc}', "");
    Expect(1, 72886, '\p{Sc=:\Amarc\z:}', "");;
    Expect(0, 72887, '\p{Sc=:\Amarc\z:}', "");;
    Expect(1, 72886, '\p{Sc=	_Marc}', "");
    Expect(0, 72886, '\p{^Sc=	_Marc}', "");
    Expect(0, 72886, '\P{Sc=	_Marc}', "");
    Expect(1, 72886, '\P{^Sc=	_Marc}', "");
    Expect(0, 72887, '\p{Sc=	_Marc}', "");
    Expect(1, 72887, '\p{^Sc=	_Marc}', "");
    Expect(1, 72887, '\P{Sc=	_Marc}', "");
    Expect(0, 72887, '\P{^Sc=	_Marc}', "");
    Error('\p{Is_Script=--MARCHEN:=}');
    Error('\P{Is_Script=--MARCHEN:=}');
    Expect(1, 72886, '\p{Is_Script: marchen}', "");
    Expect(0, 72886, '\p{^Is_Script: marchen}', "");
    Expect(0, 72886, '\P{Is_Script: marchen}', "");
    Expect(1, 72886, '\P{^Is_Script: marchen}', "");
    Expect(0, 72887, '\p{Is_Script: marchen}', "");
    Expect(1, 72887, '\p{^Is_Script: marchen}', "");
    Expect(1, 72887, '\P{Is_Script: marchen}', "");
    Expect(0, 72887, '\P{^Is_Script: marchen}', "");
    Expect(1, 72886, '\p{Is_Script= 	Marchen}', "");
    Expect(0, 72886, '\p{^Is_Script= 	Marchen}', "");
    Expect(0, 72886, '\P{Is_Script= 	Marchen}', "");
    Expect(1, 72886, '\P{^Is_Script= 	Marchen}', "");
    Expect(0, 72887, '\p{Is_Script= 	Marchen}', "");
    Expect(1, 72887, '\p{^Is_Script= 	Marchen}', "");
    Expect(1, 72887, '\P{Is_Script= 	Marchen}', "");
    Expect(0, 72887, '\P{^Is_Script= 	Marchen}', "");
    Error('\p{Is_Sc= /a/Marc}');
    Error('\P{Is_Sc= /a/Marc}');
    Expect(1, 72886, '\p{Is_Sc=marc}', "");
    Expect(0, 72886, '\p{^Is_Sc=marc}', "");
    Expect(0, 72886, '\P{Is_Sc=marc}', "");
    Expect(1, 72886, '\P{^Is_Sc=marc}', "");
    Expect(0, 72887, '\p{Is_Sc=marc}', "");
    Expect(1, 72887, '\p{^Is_Sc=marc}', "");
    Expect(1, 72887, '\P{Is_Sc=marc}', "");
    Expect(0, 72887, '\P{^Is_Sc=marc}', "");
    Expect(1, 72886, '\p{Is_Sc=__Marc}', "");
    Expect(0, 72886, '\p{^Is_Sc=__Marc}', "");
    Expect(0, 72886, '\P{Is_Sc=__Marc}', "");
    Expect(1, 72886, '\P{^Is_Sc=__Marc}', "");
    Expect(0, 72887, '\p{Is_Sc=__Marc}', "");
    Expect(1, 72887, '\p{^Is_Sc=__Marc}', "");
    Expect(1, 72887, '\P{Is_Sc=__Marc}', "");
    Expect(0, 72887, '\P{^Is_Sc=__Marc}', "");
    Error('\p{Script= -MEDEFAIDRIN:=}');
    Error('\P{Script= -MEDEFAIDRIN:=}');
    Expect(1, 93850, '\p{Script=:\AMedefaidrin\z:}', "");;
    Expect(0, 93851, '\p{Script=:\AMedefaidrin\z:}', "");;
    Expect(1, 93850, '\p{Script=medefaidrin}', "");
    Expect(0, 93850, '\p{^Script=medefaidrin}', "");
    Expect(0, 93850, '\P{Script=medefaidrin}', "");
    Expect(1, 93850, '\P{^Script=medefaidrin}', "");
    Expect(0, 93851, '\p{Script=medefaidrin}', "");
    Expect(1, 93851, '\p{^Script=medefaidrin}', "");
    Expect(1, 93851, '\P{Script=medefaidrin}', "");
    Expect(0, 93851, '\P{^Script=medefaidrin}', "");
    Expect(1, 93850, '\p{Script=:\Amedefaidrin\z:}', "");;
    Expect(0, 93851, '\p{Script=:\Amedefaidrin\z:}', "");;
    Expect(1, 93850, '\p{Script=	Medefaidrin}', "");
    Expect(0, 93850, '\p{^Script=	Medefaidrin}', "");
    Expect(0, 93850, '\P{Script=	Medefaidrin}', "");
    Expect(1, 93850, '\P{^Script=	Medefaidrin}', "");
    Expect(0, 93851, '\p{Script=	Medefaidrin}', "");
    Expect(1, 93851, '\p{^Script=	Medefaidrin}', "");
    Expect(1, 93851, '\P{Script=	Medefaidrin}', "");
    Expect(0, 93851, '\P{^Script=	Medefaidrin}', "");
    Error('\p{Sc=-/a/Medf}');
    Error('\P{Sc=-/a/Medf}');
    Expect(1, 93850, '\p{Sc=:\AMedf\z:}', "");;
    Expect(0, 93851, '\p{Sc=:\AMedf\z:}', "");;
    Expect(1, 93850, '\p{Sc=medf}', "");
    Expect(0, 93850, '\p{^Sc=medf}', "");
    Expect(0, 93850, '\P{Sc=medf}', "");
    Expect(1, 93850, '\P{^Sc=medf}', "");
    Expect(0, 93851, '\p{Sc=medf}', "");
    Expect(1, 93851, '\p{^Sc=medf}', "");
    Expect(1, 93851, '\P{Sc=medf}', "");
    Expect(0, 93851, '\P{^Sc=medf}', "");
    Expect(1, 93850, '\p{Sc=:\Amedf\z:}', "");;
    Expect(0, 93851, '\p{Sc=:\Amedf\z:}', "");;
    Expect(1, 93850, '\p{Sc:-Medf}', "");
    Expect(0, 93850, '\p{^Sc:-Medf}', "");
    Expect(0, 93850, '\P{Sc:-Medf}', "");
    Expect(1, 93850, '\P{^Sc:-Medf}', "");
    Expect(0, 93851, '\p{Sc:-Medf}', "");
    Expect(1, 93851, '\p{^Sc:-Medf}', "");
    Expect(1, 93851, '\P{Sc:-Medf}', "");
    Expect(0, 93851, '\P{^Sc:-Medf}', "");
    Error('\p{Is_Script=/a/_-Medefaidrin}');
    Error('\P{Is_Script=/a/_-Medefaidrin}');
    Expect(1, 93850, '\p{Is_Script=medefaidrin}', "");
    Expect(0, 93850, '\p{^Is_Script=medefaidrin}', "");
    Expect(0, 93850, '\P{Is_Script=medefaidrin}', "");
    Expect(1, 93850, '\P{^Is_Script=medefaidrin}', "");
    Expect(0, 93851, '\p{Is_Script=medefaidrin}', "");
    Expect(1, 93851, '\p{^Is_Script=medefaidrin}', "");
    Expect(1, 93851, '\P{Is_Script=medefaidrin}', "");
    Expect(0, 93851, '\P{^Is_Script=medefaidrin}', "");
    Expect(1, 93850, '\p{Is_Script=-	medefaidrin}', "");
    Expect(0, 93850, '\p{^Is_Script=-	medefaidrin}', "");
    Expect(0, 93850, '\P{Is_Script=-	medefaidrin}', "");
    Expect(1, 93850, '\P{^Is_Script=-	medefaidrin}', "");
    Expect(0, 93851, '\p{Is_Script=-	medefaidrin}', "");
    Expect(1, 93851, '\p{^Is_Script=-	medefaidrin}', "");
    Expect(1, 93851, '\P{Is_Script=-	medefaidrin}', "");
    Expect(0, 93851, '\P{^Is_Script=-	medefaidrin}', "");
    Error('\p{Is_Sc=_/a/medf}');
    Error('\P{Is_Sc=_/a/medf}');
    Expect(1, 93850, '\p{Is_Sc=medf}', "");
    Expect(0, 93850, '\p{^Is_Sc=medf}', "");
    Expect(0, 93850, '\P{Is_Sc=medf}', "");
    Expect(1, 93850, '\P{^Is_Sc=medf}', "");
    Expect(0, 93851, '\p{Is_Sc=medf}', "");
    Expect(1, 93851, '\p{^Is_Sc=medf}', "");
    Expect(1, 93851, '\P{Is_Sc=medf}', "");
    Expect(0, 93851, '\P{^Is_Sc=medf}', "");
    Expect(1, 93850, '\p{Is_Sc=Medf}', "");
    Expect(0, 93850, '\p{^Is_Sc=Medf}', "");
    Expect(0, 93850, '\P{Is_Sc=Medf}', "");
    Expect(1, 93850, '\P{^Is_Sc=Medf}', "");
    Expect(0, 93851, '\p{Is_Sc=Medf}', "");
    Expect(1, 93851, '\p{^Is_Sc=Medf}', "");
    Expect(1, 93851, '\P{Is_Sc=Medf}', "");
    Expect(0, 93851, '\P{^Is_Sc=Medf}', "");
    Error('\p{Script=	:=MENDE_Kikakui}');
    Error('\P{Script=	:=MENDE_Kikakui}');
    Expect(1, 125142, '\p{Script=:\AMende_Kikakui\z:}', "");;
    Expect(0, 125143, '\p{Script=:\AMende_Kikakui\z:}', "");;
    Expect(1, 125142, '\p{Script=mendekikakui}', "");
    Expect(0, 125142, '\p{^Script=mendekikakui}', "");
    Expect(0, 125142, '\P{Script=mendekikakui}', "");
    Expect(1, 125142, '\P{^Script=mendekikakui}', "");
    Expect(0, 125143, '\p{Script=mendekikakui}', "");
    Expect(1, 125143, '\p{^Script=mendekikakui}', "");
    Expect(1, 125143, '\P{Script=mendekikakui}', "");
    Expect(0, 125143, '\P{^Script=mendekikakui}', "");
    Expect(1, 125142, '\p{Script=:\Amendekikakui\z:}', "");;
    Expect(0, 125143, '\p{Script=:\Amendekikakui\z:}', "");;
    Expect(1, 125142, '\p{Script=_ Mende_Kikakui}', "");
    Expect(0, 125142, '\p{^Script=_ Mende_Kikakui}', "");
    Expect(0, 125142, '\P{Script=_ Mende_Kikakui}', "");
    Expect(1, 125142, '\P{^Script=_ Mende_Kikakui}', "");
    Expect(0, 125143, '\p{Script=_ Mende_Kikakui}', "");
    Expect(1, 125143, '\p{^Script=_ Mende_Kikakui}', "");
    Expect(1, 125143, '\P{Script=_ Mende_Kikakui}', "");
    Expect(0, 125143, '\P{^Script=_ Mende_Kikakui}', "");
    Error('\p{Sc:   _mend/a/}');
    Error('\P{Sc:   _mend/a/}');
    Expect(1, 125142, '\p{Sc=:\AMend\z:}', "");;
    Expect(0, 125143, '\p{Sc=:\AMend\z:}', "");;
    Expect(1, 125142, '\p{Sc=mend}', "");
    Expect(0, 125142, '\p{^Sc=mend}', "");
    Expect(0, 125142, '\P{Sc=mend}', "");
    Expect(1, 125142, '\P{^Sc=mend}', "");
    Expect(0, 125143, '\p{Sc=mend}', "");
    Expect(1, 125143, '\p{^Sc=mend}', "");
    Expect(1, 125143, '\P{Sc=mend}', "");
    Expect(0, 125143, '\P{^Sc=mend}', "");
    Expect(1, 125142, '\p{Sc=:\Amend\z:}', "");;
    Expect(0, 125143, '\p{Sc=:\Amend\z:}', "");;
    Expect(1, 125142, '\p{Sc=-	Mend}', "");
    Expect(0, 125142, '\p{^Sc=-	Mend}', "");
    Expect(0, 125142, '\P{Sc=-	Mend}', "");
    Expect(1, 125142, '\P{^Sc=-	Mend}', "");
    Expect(0, 125143, '\p{Sc=-	Mend}', "");
    Expect(1, 125143, '\p{^Sc=-	Mend}', "");
    Expect(1, 125143, '\P{Sc=-	Mend}', "");
    Expect(0, 125143, '\P{^Sc=-	Mend}', "");
    Error('\p{Is_Script=:=_Mende_kikakui}');
    Error('\P{Is_Script=:=_Mende_kikakui}');
    Expect(1, 125142, '\p{Is_Script=mendekikakui}', "");
    Expect(0, 125142, '\p{^Is_Script=mendekikakui}', "");
    Expect(0, 125142, '\P{Is_Script=mendekikakui}', "");
    Expect(1, 125142, '\P{^Is_Script=mendekikakui}', "");
    Expect(0, 125143, '\p{Is_Script=mendekikakui}', "");
    Expect(1, 125143, '\p{^Is_Script=mendekikakui}', "");
    Expect(1, 125143, '\P{Is_Script=mendekikakui}', "");
    Expect(0, 125143, '\P{^Is_Script=mendekikakui}', "");
    Expect(1, 125142, '\p{Is_Script= _Mende_Kikakui}', "");
    Expect(0, 125142, '\p{^Is_Script= _Mende_Kikakui}', "");
    Expect(0, 125142, '\P{Is_Script= _Mende_Kikakui}', "");
    Expect(1, 125142, '\P{^Is_Script= _Mende_Kikakui}', "");
    Expect(0, 125143, '\p{Is_Script= _Mende_Kikakui}', "");
    Expect(1, 125143, '\p{^Is_Script= _Mende_Kikakui}', "");
    Expect(1, 125143, '\P{Is_Script= _Mende_Kikakui}', "");
    Expect(0, 125143, '\P{^Is_Script= _Mende_Kikakui}', "");
    Error('\p{Is_Sc=:=- Mend}');
    Error('\P{Is_Sc=:=- Mend}');
    Expect(1, 125142, '\p{Is_Sc:	mend}', "");
    Expect(0, 125142, '\p{^Is_Sc:	mend}', "");
    Expect(0, 125142, '\P{Is_Sc:	mend}', "");
    Expect(1, 125142, '\P{^Is_Sc:	mend}', "");
    Expect(0, 125143, '\p{Is_Sc:	mend}', "");
    Expect(1, 125143, '\p{^Is_Sc:	mend}', "");
    Expect(1, 125143, '\P{Is_Sc:	mend}', "");
    Expect(0, 125143, '\P{^Is_Sc:	mend}', "");
    Expect(1, 125142, '\p{Is_Sc= Mend}', "");
    Expect(0, 125142, '\p{^Is_Sc= Mend}', "");
    Expect(0, 125142, '\P{Is_Sc= Mend}', "");
    Expect(1, 125142, '\P{^Is_Sc= Mend}', "");
    Expect(0, 125143, '\p{Is_Sc= Mend}', "");
    Expect(1, 125143, '\p{^Is_Sc= Mend}', "");
    Expect(1, 125143, '\P{Is_Sc= Mend}', "");
    Expect(0, 125143, '\P{^Is_Sc= Mend}', "");
    Error('\p{Script=	Meroitic_CURSIVE/a/}');
    Error('\P{Script=	Meroitic_CURSIVE/a/}');
    Expect(1, 68095, '\p{Script=:\AMeroitic_Cursive\z:}', "");;
    Expect(0, 68096, '\p{Script=:\AMeroitic_Cursive\z:}', "");;
    Expect(1, 68095, '\p{Script:	meroiticcursive}', "");
    Expect(0, 68095, '\p{^Script:	meroiticcursive}', "");
    Expect(0, 68095, '\P{Script:	meroiticcursive}', "");
    Expect(1, 68095, '\P{^Script:	meroiticcursive}', "");
    Expect(0, 68096, '\p{Script:	meroiticcursive}', "");
    Expect(1, 68096, '\p{^Script:	meroiticcursive}', "");
    Expect(1, 68096, '\P{Script:	meroiticcursive}', "");
    Expect(0, 68096, '\P{^Script:	meroiticcursive}', "");
    Expect(1, 68095, '\p{Script=:\Ameroiticcursive\z:}', "");;
    Expect(0, 68096, '\p{Script=:\Ameroiticcursive\z:}', "");;
    Expect(1, 68095, '\p{Script= MEROITIC_CURSIVE}', "");
    Expect(0, 68095, '\p{^Script= MEROITIC_CURSIVE}', "");
    Expect(0, 68095, '\P{Script= MEROITIC_CURSIVE}', "");
    Expect(1, 68095, '\P{^Script= MEROITIC_CURSIVE}', "");
    Expect(0, 68096, '\p{Script= MEROITIC_CURSIVE}', "");
    Expect(1, 68096, '\p{^Script= MEROITIC_CURSIVE}', "");
    Expect(1, 68096, '\P{Script= MEROITIC_CURSIVE}', "");
    Expect(0, 68096, '\P{^Script= MEROITIC_CURSIVE}', "");
    Error('\p{Sc=- Merc:=}');
    Error('\P{Sc=- Merc:=}');
    Expect(1, 68095, '\p{Sc=:\AMerc\z:}', "");;
    Expect(0, 68096, '\p{Sc=:\AMerc\z:}', "");;
    Expect(1, 68095, '\p{Sc=merc}', "");
    Expect(0, 68095, '\p{^Sc=merc}', "");
    Expect(0, 68095, '\P{Sc=merc}', "");
    Expect(1, 68095, '\P{^Sc=merc}', "");
    Expect(0, 68096, '\p{Sc=merc}', "");
    Expect(1, 68096, '\p{^Sc=merc}', "");
    Expect(1, 68096, '\P{Sc=merc}', "");
    Expect(0, 68096, '\P{^Sc=merc}', "");
    Expect(1, 68095, '\p{Sc=:\Amerc\z:}', "");;
    Expect(0, 68096, '\p{Sc=:\Amerc\z:}', "");;
    Expect(1, 68095, '\p{Sc=_ Merc}', "");
    Expect(0, 68095, '\p{^Sc=_ Merc}', "");
    Expect(0, 68095, '\P{Sc=_ Merc}', "");
    Expect(1, 68095, '\P{^Sc=_ Merc}', "");
    Expect(0, 68096, '\p{Sc=_ Merc}', "");
    Expect(1, 68096, '\p{^Sc=_ Merc}', "");
    Expect(1, 68096, '\P{Sc=_ Merc}', "");
    Expect(0, 68096, '\P{^Sc=_ Merc}', "");
    Error('\p{Is_Script=/a/	_Meroitic_Cursive}');
    Error('\P{Is_Script=/a/	_Meroitic_Cursive}');
    Expect(1, 68095, '\p{Is_Script=meroiticcursive}', "");
    Expect(0, 68095, '\p{^Is_Script=meroiticcursive}', "");
    Expect(0, 68095, '\P{Is_Script=meroiticcursive}', "");
    Expect(1, 68095, '\P{^Is_Script=meroiticcursive}', "");
    Expect(0, 68096, '\p{Is_Script=meroiticcursive}', "");
    Expect(1, 68096, '\p{^Is_Script=meroiticcursive}', "");
    Expect(1, 68096, '\P{Is_Script=meroiticcursive}', "");
    Expect(0, 68096, '\P{^Is_Script=meroiticcursive}', "");
    Expect(1, 68095, '\p{Is_Script=-	Meroitic_Cursive}', "");
    Expect(0, 68095, '\p{^Is_Script=-	Meroitic_Cursive}', "");
    Expect(0, 68095, '\P{Is_Script=-	Meroitic_Cursive}', "");
    Expect(1, 68095, '\P{^Is_Script=-	Meroitic_Cursive}', "");
    Expect(0, 68096, '\p{Is_Script=-	Meroitic_Cursive}', "");
    Expect(1, 68096, '\p{^Is_Script=-	Meroitic_Cursive}', "");
    Expect(1, 68096, '\P{Is_Script=-	Meroitic_Cursive}', "");
    Expect(0, 68096, '\P{^Is_Script=-	Meroitic_Cursive}', "");
    Error('\p{Is_Sc= :=MERC}');
    Error('\P{Is_Sc= :=MERC}');
    Expect(1, 68095, '\p{Is_Sc=merc}', "");
    Expect(0, 68095, '\p{^Is_Sc=merc}', "");
    Expect(0, 68095, '\P{Is_Sc=merc}', "");
    Expect(1, 68095, '\P{^Is_Sc=merc}', "");
    Expect(0, 68096, '\p{Is_Sc=merc}', "");
    Expect(1, 68096, '\p{^Is_Sc=merc}', "");
    Expect(1, 68096, '\P{Is_Sc=merc}', "");
    Expect(0, 68096, '\P{^Is_Sc=merc}', "");
    Expect(1, 68095, '\p{Is_Sc=__MERC}', "");
    Expect(0, 68095, '\p{^Is_Sc=__MERC}', "");
    Expect(0, 68095, '\P{Is_Sc=__MERC}', "");
    Expect(1, 68095, '\P{^Is_Sc=__MERC}', "");
    Expect(0, 68096, '\p{Is_Sc=__MERC}', "");
    Expect(1, 68096, '\p{^Is_Sc=__MERC}', "");
    Expect(1, 68096, '\P{Is_Sc=__MERC}', "");
    Expect(0, 68096, '\P{^Is_Sc=__MERC}', "");
    Error('\p{Script=_:=Meroitic_Hieroglyphs}');
    Error('\P{Script=_:=Meroitic_Hieroglyphs}');
    Expect(1, 67999, '\p{Script=:\AMeroitic_Hieroglyphs\z:}', "");;
    Expect(0, 68000, '\p{Script=:\AMeroitic_Hieroglyphs\z:}', "");;
    Expect(1, 67999, '\p{Script=meroitichieroglyphs}', "");
    Expect(0, 67999, '\p{^Script=meroitichieroglyphs}', "");
    Expect(0, 67999, '\P{Script=meroitichieroglyphs}', "");
    Expect(1, 67999, '\P{^Script=meroitichieroglyphs}', "");
    Expect(0, 68000, '\p{Script=meroitichieroglyphs}', "");
    Expect(1, 68000, '\p{^Script=meroitichieroglyphs}', "");
    Expect(1, 68000, '\P{Script=meroitichieroglyphs}', "");
    Expect(0, 68000, '\P{^Script=meroitichieroglyphs}', "");
    Expect(1, 67999, '\p{Script=:\Ameroitichieroglyphs\z:}', "");;
    Expect(0, 68000, '\p{Script=:\Ameroitichieroglyphs\z:}', "");;
    Expect(1, 67999, '\p{Script=	Meroitic_Hieroglyphs}', "");
    Expect(0, 67999, '\p{^Script=	Meroitic_Hieroglyphs}', "");
    Expect(0, 67999, '\P{Script=	Meroitic_Hieroglyphs}', "");
    Expect(1, 67999, '\P{^Script=	Meroitic_Hieroglyphs}', "");
    Expect(0, 68000, '\p{Script=	Meroitic_Hieroglyphs}', "");
    Expect(1, 68000, '\p{^Script=	Meroitic_Hieroglyphs}', "");
    Expect(1, 68000, '\P{Script=	Meroitic_Hieroglyphs}', "");
    Expect(0, 68000, '\P{^Script=	Meroitic_Hieroglyphs}', "");
    Error('\p{Sc=:=-	mero}');
    Error('\P{Sc=:=-	mero}');
    Expect(1, 67999, '\p{Sc=:\AMero\z:}', "");;
    Expect(0, 68000, '\p{Sc=:\AMero\z:}', "");;
    Expect(1, 67999, '\p{Sc=mero}', "");
    Expect(0, 67999, '\p{^Sc=mero}', "");
    Expect(0, 67999, '\P{Sc=mero}', "");
    Expect(1, 67999, '\P{^Sc=mero}', "");
    Expect(0, 68000, '\p{Sc=mero}', "");
    Expect(1, 68000, '\p{^Sc=mero}', "");
    Expect(1, 68000, '\P{Sc=mero}', "");
    Expect(0, 68000, '\P{^Sc=mero}', "");
    Expect(1, 67999, '\p{Sc=:\Amero\z:}', "");;
    Expect(0, 68000, '\p{Sc=:\Amero\z:}', "");;
    Expect(1, 67999, '\p{Sc=	_mero}', "");
    Expect(0, 67999, '\p{^Sc=	_mero}', "");
    Expect(0, 67999, '\P{Sc=	_mero}', "");
    Expect(1, 67999, '\P{^Sc=	_mero}', "");
    Expect(0, 68000, '\p{Sc=	_mero}', "");
    Expect(1, 68000, '\p{^Sc=	_mero}', "");
    Expect(1, 68000, '\P{Sc=	_mero}', "");
    Expect(0, 68000, '\P{^Sc=	_mero}', "");
    Error('\p{Is_Script=_Meroitic_hieroglyphs/a/}');
    Error('\P{Is_Script=_Meroitic_hieroglyphs/a/}');
    Expect(1, 67999, '\p{Is_Script=meroitichieroglyphs}', "");
    Expect(0, 67999, '\p{^Is_Script=meroitichieroglyphs}', "");
    Expect(0, 67999, '\P{Is_Script=meroitichieroglyphs}', "");
    Expect(1, 67999, '\P{^Is_Script=meroitichieroglyphs}', "");
    Expect(0, 68000, '\p{Is_Script=meroitichieroglyphs}', "");
    Expect(1, 68000, '\p{^Is_Script=meroitichieroglyphs}', "");
    Expect(1, 68000, '\P{Is_Script=meroitichieroglyphs}', "");
    Expect(0, 68000, '\P{^Is_Script=meroitichieroglyphs}', "");
    Expect(1, 67999, '\p{Is_Script=Meroitic_hieroglyphs}', "");
    Expect(0, 67999, '\p{^Is_Script=Meroitic_hieroglyphs}', "");
    Expect(0, 67999, '\P{Is_Script=Meroitic_hieroglyphs}', "");
    Expect(1, 67999, '\P{^Is_Script=Meroitic_hieroglyphs}', "");
    Expect(0, 68000, '\p{Is_Script=Meroitic_hieroglyphs}', "");
    Expect(1, 68000, '\p{^Is_Script=Meroitic_hieroglyphs}', "");
    Expect(1, 68000, '\P{Is_Script=Meroitic_hieroglyphs}', "");
    Expect(0, 68000, '\P{^Is_Script=Meroitic_hieroglyphs}', "");
    Error('\p{Is_Sc=	/a/Mero}');
    Error('\P{Is_Sc=	/a/Mero}');
    Expect(1, 67999, '\p{Is_Sc=mero}', "");
    Expect(0, 67999, '\p{^Is_Sc=mero}', "");
    Expect(0, 67999, '\P{Is_Sc=mero}', "");
    Expect(1, 67999, '\P{^Is_Sc=mero}', "");
    Expect(0, 68000, '\p{Is_Sc=mero}', "");
    Expect(1, 68000, '\p{^Is_Sc=mero}', "");
    Expect(1, 68000, '\P{Is_Sc=mero}', "");
    Expect(0, 68000, '\P{^Is_Sc=mero}', "");
    Expect(1, 67999, '\p{Is_Sc:	--mero}', "");
    Expect(0, 67999, '\p{^Is_Sc:	--mero}', "");
    Expect(0, 67999, '\P{Is_Sc:	--mero}', "");
    Expect(1, 67999, '\P{^Is_Sc:	--mero}', "");
    Expect(0, 68000, '\p{Is_Sc:	--mero}', "");
    Expect(1, 68000, '\p{^Is_Sc:	--mero}', "");
    Expect(1, 68000, '\P{Is_Sc:	--mero}', "");
    Expect(0, 68000, '\P{^Is_Sc:	--mero}', "");
    Error('\p{Script=:=_Malayalam}');
    Error('\P{Script=:=_Malayalam}');
    Expect(1, 3455, '\p{Script=:\AMalayalam\z:}', "");;
    Expect(0, 3456, '\p{Script=:\AMalayalam\z:}', "");;
    Expect(1, 3455, '\p{Script=malayalam}', "");
    Expect(0, 3455, '\p{^Script=malayalam}', "");
    Expect(0, 3455, '\P{Script=malayalam}', "");
    Expect(1, 3455, '\P{^Script=malayalam}', "");
    Expect(0, 3456, '\p{Script=malayalam}', "");
    Expect(1, 3456, '\p{^Script=malayalam}', "");
    Expect(1, 3456, '\P{Script=malayalam}', "");
    Expect(0, 3456, '\P{^Script=malayalam}', "");
    Expect(1, 3455, '\p{Script=:\Amalayalam\z:}', "");;
    Expect(0, 3456, '\p{Script=:\Amalayalam\z:}', "");;
    Expect(1, 3455, '\p{Script=_malayalam}', "");
    Expect(0, 3455, '\p{^Script=_malayalam}', "");
    Expect(0, 3455, '\P{Script=_malayalam}', "");
    Expect(1, 3455, '\P{^Script=_malayalam}', "");
    Expect(0, 3456, '\p{Script=_malayalam}', "");
    Expect(1, 3456, '\p{^Script=_malayalam}', "");
    Expect(1, 3456, '\P{Script=_malayalam}', "");
    Expect(0, 3456, '\P{^Script=_malayalam}', "");
    Error('\p{Sc=_:=MLYM}');
    Error('\P{Sc=_:=MLYM}');
    Expect(1, 3455, '\p{Sc=:\AMlym\z:}', "");;
    Expect(0, 3456, '\p{Sc=:\AMlym\z:}', "");;
    Expect(1, 3455, '\p{Sc=mlym}', "");
    Expect(0, 3455, '\p{^Sc=mlym}', "");
    Expect(0, 3455, '\P{Sc=mlym}', "");
    Expect(1, 3455, '\P{^Sc=mlym}', "");
    Expect(0, 3456, '\p{Sc=mlym}', "");
    Expect(1, 3456, '\p{^Sc=mlym}', "");
    Expect(1, 3456, '\P{Sc=mlym}', "");
    Expect(0, 3456, '\P{^Sc=mlym}', "");
    Expect(1, 3455, '\p{Sc=:\Amlym\z:}', "");;
    Expect(0, 3456, '\p{Sc=:\Amlym\z:}', "");;
    Expect(1, 3455, '\p{Sc=_ Mlym}', "");
    Expect(0, 3455, '\p{^Sc=_ Mlym}', "");
    Expect(0, 3455, '\P{Sc=_ Mlym}', "");
    Expect(1, 3455, '\P{^Sc=_ Mlym}', "");
    Expect(0, 3456, '\p{Sc=_ Mlym}', "");
    Expect(1, 3456, '\p{^Sc=_ Mlym}', "");
    Expect(1, 3456, '\P{Sc=_ Mlym}', "");
    Expect(0, 3456, '\P{^Sc=_ Mlym}', "");
    Error('\p{Is_Script=:=_Malayalam}');
    Error('\P{Is_Script=:=_Malayalam}');
    Expect(1, 3455, '\p{Is_Script=malayalam}', "");
    Expect(0, 3455, '\p{^Is_Script=malayalam}', "");
    Expect(0, 3455, '\P{Is_Script=malayalam}', "");
    Expect(1, 3455, '\P{^Is_Script=malayalam}', "");
    Expect(0, 3456, '\p{Is_Script=malayalam}', "");
    Expect(1, 3456, '\p{^Is_Script=malayalam}', "");
    Expect(1, 3456, '\P{Is_Script=malayalam}', "");
    Expect(0, 3456, '\P{^Is_Script=malayalam}', "");
    Expect(1, 3455, '\p{Is_Script=_	malayalam}', "");
    Expect(0, 3455, '\p{^Is_Script=_	malayalam}', "");
    Expect(0, 3455, '\P{Is_Script=_	malayalam}', "");
    Expect(1, 3455, '\P{^Is_Script=_	malayalam}', "");
    Expect(0, 3456, '\p{Is_Script=_	malayalam}', "");
    Expect(1, 3456, '\p{^Is_Script=_	malayalam}', "");
    Expect(1, 3456, '\P{Is_Script=_	malayalam}', "");
    Expect(0, 3456, '\P{^Is_Script=_	malayalam}', "");
    Error('\p{Is_Sc=	 Mlym/a/}');
    Error('\P{Is_Sc=	 Mlym/a/}');
    Expect(1, 3455, '\p{Is_Sc=mlym}', "");
    Expect(0, 3455, '\p{^Is_Sc=mlym}', "");
    Expect(0, 3455, '\P{Is_Sc=mlym}', "");
    Expect(1, 3455, '\P{^Is_Sc=mlym}', "");
    Expect(0, 3456, '\p{Is_Sc=mlym}', "");
    Expect(1, 3456, '\p{^Is_Sc=mlym}', "");
    Expect(1, 3456, '\P{Is_Sc=mlym}', "");
    Expect(0, 3456, '\P{^Is_Sc=mlym}', "");
    Expect(1, 3455, '\p{Is_Sc= _MLYM}', "");
    Expect(0, 3455, '\p{^Is_Sc= _MLYM}', "");
    Expect(0, 3455, '\P{Is_Sc= _MLYM}', "");
    Expect(1, 3455, '\P{^Is_Sc= _MLYM}', "");
    Expect(0, 3456, '\p{Is_Sc= _MLYM}', "");
    Expect(1, 3456, '\p{^Is_Sc= _MLYM}', "");
    Expect(1, 3456, '\P{Is_Sc= _MLYM}', "");
    Expect(0, 3456, '\P{^Is_Sc= _MLYM}', "");
    Error('\p{Script=/a/_	MODI}');
    Error('\P{Script=/a/_	MODI}');
    Expect(1, 71257, '\p{Script=:\AModi\z:}', "");;
    Expect(0, 71258, '\p{Script=:\AModi\z:}', "");;
    Expect(1, 71257, '\p{Script=modi}', "");
    Expect(0, 71257, '\p{^Script=modi}', "");
    Expect(0, 71257, '\P{Script=modi}', "");
    Expect(1, 71257, '\P{^Script=modi}', "");
    Expect(0, 71258, '\p{Script=modi}', "");
    Expect(1, 71258, '\p{^Script=modi}', "");
    Expect(1, 71258, '\P{Script=modi}', "");
    Expect(0, 71258, '\P{^Script=modi}', "");
    Expect(1, 71257, '\p{Script=:\Amodi\z:}', "");;
    Expect(0, 71258, '\p{Script=:\Amodi\z:}', "");;
    Expect(1, 71257, '\p{Script=_	Modi}', "");
    Expect(0, 71257, '\p{^Script=_	Modi}', "");
    Expect(0, 71257, '\P{Script=_	Modi}', "");
    Expect(1, 71257, '\P{^Script=_	Modi}', "");
    Expect(0, 71258, '\p{Script=_	Modi}', "");
    Expect(1, 71258, '\p{^Script=_	Modi}', "");
    Expect(1, 71258, '\P{Script=_	Modi}', "");
    Expect(0, 71258, '\P{^Script=_	Modi}', "");
    Error('\p{Sc:   :=_ Modi}');
    Error('\P{Sc:   :=_ Modi}');
    Expect(1, 71257, '\p{Sc=:\AModi\z:}', "");;
    Expect(0, 71258, '\p{Sc=:\AModi\z:}', "");;
    Expect(1, 71257, '\p{Sc=modi}', "");
    Expect(0, 71257, '\p{^Sc=modi}', "");
    Expect(0, 71257, '\P{Sc=modi}', "");
    Expect(1, 71257, '\P{^Sc=modi}', "");
    Expect(0, 71258, '\p{Sc=modi}', "");
    Expect(1, 71258, '\p{^Sc=modi}', "");
    Expect(1, 71258, '\P{Sc=modi}', "");
    Expect(0, 71258, '\P{^Sc=modi}', "");
    Expect(1, 71257, '\p{Sc=:\Amodi\z:}', "");;
    Expect(0, 71258, '\p{Sc=:\Amodi\z:}', "");;
    Expect(1, 71257, '\p{Sc=-	MODI}', "");
    Expect(0, 71257, '\p{^Sc=-	MODI}', "");
    Expect(0, 71257, '\P{Sc=-	MODI}', "");
    Expect(1, 71257, '\P{^Sc=-	MODI}', "");
    Expect(0, 71258, '\p{Sc=-	MODI}', "");
    Expect(1, 71258, '\p{^Sc=-	MODI}', "");
    Expect(1, 71258, '\P{Sc=-	MODI}', "");
    Expect(0, 71258, '\P{^Sc=-	MODI}', "");
    Error('\p{Is_Script=/a/_MODI}');
    Error('\P{Is_Script=/a/_MODI}');
    Expect(1, 71257, '\p{Is_Script=modi}', "");
    Expect(0, 71257, '\p{^Is_Script=modi}', "");
    Expect(0, 71257, '\P{Is_Script=modi}', "");
    Expect(1, 71257, '\P{^Is_Script=modi}', "");
    Expect(0, 71258, '\p{Is_Script=modi}', "");
    Expect(1, 71258, '\p{^Is_Script=modi}', "");
    Expect(1, 71258, '\P{Is_Script=modi}', "");
    Expect(0, 71258, '\P{^Is_Script=modi}', "");
    Expect(1, 71257, '\p{Is_Script=	_modi}', "");
    Expect(0, 71257, '\p{^Is_Script=	_modi}', "");
    Expect(0, 71257, '\P{Is_Script=	_modi}', "");
    Expect(1, 71257, '\P{^Is_Script=	_modi}', "");
    Expect(0, 71258, '\p{Is_Script=	_modi}', "");
    Expect(1, 71258, '\p{^Is_Script=	_modi}', "");
    Expect(1, 71258, '\P{Is_Script=	_modi}', "");
    Expect(0, 71258, '\P{^Is_Script=	_modi}', "");
    Error('\p{Is_Sc=/a/_Modi}');
    Error('\P{Is_Sc=/a/_Modi}');
    Expect(1, 71257, '\p{Is_Sc=modi}', "");
    Expect(0, 71257, '\p{^Is_Sc=modi}', "");
    Expect(0, 71257, '\P{Is_Sc=modi}', "");
    Expect(1, 71257, '\P{^Is_Sc=modi}', "");
    Expect(0, 71258, '\p{Is_Sc=modi}', "");
    Expect(1, 71258, '\p{^Is_Sc=modi}', "");
    Expect(1, 71258, '\P{Is_Sc=modi}', "");
    Expect(0, 71258, '\P{^Is_Sc=modi}', "");
    Expect(1, 71257, '\p{Is_Sc=	_Modi}', "");
    Expect(0, 71257, '\p{^Is_Sc=	_Modi}', "");
    Expect(0, 71257, '\P{Is_Sc=	_Modi}', "");
    Expect(1, 71257, '\P{^Is_Sc=	_Modi}', "");
    Expect(0, 71258, '\p{Is_Sc=	_Modi}', "");
    Expect(1, 71258, '\p{^Is_Sc=	_Modi}', "");
    Expect(1, 71258, '\P{Is_Sc=	_Modi}', "");
    Expect(0, 71258, '\P{^Is_Sc=	_Modi}', "");
    Error('\p{Script=:=	_Mongolian}');
    Error('\P{Script=:=	_Mongolian}');
    Expect(1, 71276, '\p{Script=:\AMongolian\z:}', "");;
    Expect(0, 71277, '\p{Script=:\AMongolian\z:}', "");;
    Expect(1, 71276, '\p{Script=mongolian}', "");
    Expect(0, 71276, '\p{^Script=mongolian}', "");
    Expect(0, 71276, '\P{Script=mongolian}', "");
    Expect(1, 71276, '\P{^Script=mongolian}', "");
    Expect(0, 71277, '\p{Script=mongolian}', "");
    Expect(1, 71277, '\p{^Script=mongolian}', "");
    Expect(1, 71277, '\P{Script=mongolian}', "");
    Expect(0, 71277, '\P{^Script=mongolian}', "");
    Expect(1, 71276, '\p{Script=:\Amongolian\z:}', "");;
    Expect(0, 71277, '\p{Script=:\Amongolian\z:}', "");;
    Expect(1, 71276, '\p{Script= _MONGOLIAN}', "");
    Expect(0, 71276, '\p{^Script= _MONGOLIAN}', "");
    Expect(0, 71276, '\P{Script= _MONGOLIAN}', "");
    Expect(1, 71276, '\P{^Script= _MONGOLIAN}', "");
    Expect(0, 71277, '\p{Script= _MONGOLIAN}', "");
    Expect(1, 71277, '\p{^Script= _MONGOLIAN}', "");
    Expect(1, 71277, '\P{Script= _MONGOLIAN}', "");
    Expect(0, 71277, '\P{^Script= _MONGOLIAN}', "");
    Error('\p{Sc:		-Mong:=}');
    Error('\P{Sc:		-Mong:=}');
    Expect(1, 71276, '\p{Sc=:\AMong\z:}', "");;
    Expect(0, 71277, '\p{Sc=:\AMong\z:}', "");;
    Expect(1, 71276, '\p{Sc:	mong}', "");
    Expect(0, 71276, '\p{^Sc:	mong}', "");
    Expect(0, 71276, '\P{Sc:	mong}', "");
    Expect(1, 71276, '\P{^Sc:	mong}', "");
    Expect(0, 71277, '\p{Sc:	mong}', "");
    Expect(1, 71277, '\p{^Sc:	mong}', "");
    Expect(1, 71277, '\P{Sc:	mong}', "");
    Expect(0, 71277, '\P{^Sc:	mong}', "");
    Expect(1, 71276, '\p{Sc=:\Among\z:}', "");;
    Expect(0, 71277, '\p{Sc=:\Among\z:}', "");;
    Expect(1, 71276, '\p{Sc=	Mong}', "");
    Expect(0, 71276, '\p{^Sc=	Mong}', "");
    Expect(0, 71276, '\P{Sc=	Mong}', "");
    Expect(1, 71276, '\P{^Sc=	Mong}', "");
    Expect(0, 71277, '\p{Sc=	Mong}', "");
    Expect(1, 71277, '\p{^Sc=	Mong}', "");
    Expect(1, 71277, '\P{Sc=	Mong}', "");
    Expect(0, 71277, '\P{^Sc=	Mong}', "");
    Error('\p{Is_Script=/a/_Mongolian}');
    Error('\P{Is_Script=/a/_Mongolian}');
    Expect(1, 71276, '\p{Is_Script=mongolian}', "");
    Expect(0, 71276, '\p{^Is_Script=mongolian}', "");
    Expect(0, 71276, '\P{Is_Script=mongolian}', "");
    Expect(1, 71276, '\P{^Is_Script=mongolian}', "");
    Expect(0, 71277, '\p{Is_Script=mongolian}', "");
    Expect(1, 71277, '\p{^Is_Script=mongolian}', "");
    Expect(1, 71277, '\P{Is_Script=mongolian}', "");
    Expect(0, 71277, '\P{^Is_Script=mongolian}', "");
    Expect(1, 71276, '\p{Is_Script:			Mongolian}', "");
    Expect(0, 71276, '\p{^Is_Script:			Mongolian}', "");
    Expect(0, 71276, '\P{Is_Script:			Mongolian}', "");
    Expect(1, 71276, '\P{^Is_Script:			Mongolian}', "");
    Expect(0, 71277, '\p{Is_Script:			Mongolian}', "");
    Expect(1, 71277, '\p{^Is_Script:			Mongolian}', "");
    Expect(1, 71277, '\P{Is_Script:			Mongolian}', "");
    Expect(0, 71277, '\P{^Is_Script:			Mongolian}', "");
    Error('\p{Is_Sc=:=Mong}');
    Error('\P{Is_Sc=:=Mong}');
    Expect(1, 71276, '\p{Is_Sc=mong}', "");
    Expect(0, 71276, '\p{^Is_Sc=mong}', "");
    Expect(0, 71276, '\P{Is_Sc=mong}', "");
    Expect(1, 71276, '\P{^Is_Sc=mong}', "");
    Expect(0, 71277, '\p{Is_Sc=mong}', "");
    Expect(1, 71277, '\p{^Is_Sc=mong}', "");
    Expect(1, 71277, '\P{Is_Sc=mong}', "");
    Expect(0, 71277, '\P{^Is_Sc=mong}', "");
    Expect(1, 71276, '\p{Is_Sc= -mong}', "");
    Expect(0, 71276, '\p{^Is_Sc= -mong}', "");
    Expect(0, 71276, '\P{Is_Sc= -mong}', "");
    Expect(1, 71276, '\P{^Is_Sc= -mong}', "");
    Expect(0, 71277, '\p{Is_Sc= -mong}', "");
    Expect(1, 71277, '\p{^Is_Sc= -mong}', "");
    Expect(1, 71277, '\P{Is_Sc= -mong}', "");
    Expect(0, 71277, '\P{^Is_Sc= -mong}', "");
    Error('\p{Script=/a/_ MRO}');
    Error('\P{Script=/a/_ MRO}');
    Expect(1, 92783, '\p{Script=:\AMro\z:}', "");;
    Expect(0, 92784, '\p{Script=:\AMro\z:}', "");;
    Expect(1, 92783, '\p{Script=mro}', "");
    Expect(0, 92783, '\p{^Script=mro}', "");
    Expect(0, 92783, '\P{Script=mro}', "");
    Expect(1, 92783, '\P{^Script=mro}', "");
    Expect(0, 92784, '\p{Script=mro}', "");
    Expect(1, 92784, '\p{^Script=mro}', "");
    Expect(1, 92784, '\P{Script=mro}', "");
    Expect(0, 92784, '\P{^Script=mro}', "");
    Expect(1, 92783, '\p{Script=:\Amro\z:}', "");;
    Expect(0, 92784, '\p{Script=:\Amro\z:}', "");;
    Expect(1, 92783, '\p{Script= Mro}', "");
    Expect(0, 92783, '\p{^Script= Mro}', "");
    Expect(0, 92783, '\P{Script= Mro}', "");
    Expect(1, 92783, '\P{^Script= Mro}', "");
    Expect(0, 92784, '\p{Script= Mro}', "");
    Expect(1, 92784, '\p{^Script= Mro}', "");
    Expect(1, 92784, '\P{Script= Mro}', "");
    Expect(0, 92784, '\P{^Script= Mro}', "");
    Error('\p{Sc=	:=Mroo}');
    Error('\P{Sc=	:=Mroo}');
    Expect(1, 92783, '\p{Sc=:\AMroo\z:}', "");;
    Expect(0, 92784, '\p{Sc=:\AMroo\z:}', "");;
    Expect(1, 92783, '\p{Sc=mroo}', "");
    Expect(0, 92783, '\p{^Sc=mroo}', "");
    Expect(0, 92783, '\P{Sc=mroo}', "");
    Expect(1, 92783, '\P{^Sc=mroo}', "");
    Expect(0, 92784, '\p{Sc=mroo}', "");
    Expect(1, 92784, '\p{^Sc=mroo}', "");
    Expect(1, 92784, '\P{Sc=mroo}', "");
    Expect(0, 92784, '\P{^Sc=mroo}', "");
    Expect(1, 92783, '\p{Sc=:\Amroo\z:}', "");;
    Expect(0, 92784, '\p{Sc=:\Amroo\z:}', "");;
    Expect(1, 92783, '\p{Sc=	Mroo}', "");
    Expect(0, 92783, '\p{^Sc=	Mroo}', "");
    Expect(0, 92783, '\P{Sc=	Mroo}', "");
    Expect(1, 92783, '\P{^Sc=	Mroo}', "");
    Expect(0, 92784, '\p{Sc=	Mroo}', "");
    Expect(1, 92784, '\p{^Sc=	Mroo}', "");
    Expect(1, 92784, '\P{Sc=	Mroo}', "");
    Expect(0, 92784, '\P{^Sc=	Mroo}', "");
    Error('\p{Is_Script=/a/ -mro}');
    Error('\P{Is_Script=/a/ -mro}');
    Expect(1, 92783, '\p{Is_Script=mro}', "");
    Expect(0, 92783, '\p{^Is_Script=mro}', "");
    Expect(0, 92783, '\P{Is_Script=mro}', "");
    Expect(1, 92783, '\P{^Is_Script=mro}', "");
    Expect(0, 92784, '\p{Is_Script=mro}', "");
    Expect(1, 92784, '\p{^Is_Script=mro}', "");
    Expect(1, 92784, '\P{Is_Script=mro}', "");
    Expect(0, 92784, '\P{^Is_Script=mro}', "");
    Expect(1, 92783, '\p{Is_Script= 	MRO}', "");
    Expect(0, 92783, '\p{^Is_Script= 	MRO}', "");
    Expect(0, 92783, '\P{Is_Script= 	MRO}', "");
    Expect(1, 92783, '\P{^Is_Script= 	MRO}', "");
    Expect(0, 92784, '\p{Is_Script= 	MRO}', "");
    Expect(1, 92784, '\p{^Is_Script= 	MRO}', "");
    Expect(1, 92784, '\P{Is_Script= 	MRO}', "");
    Expect(0, 92784, '\P{^Is_Script= 	MRO}', "");
    Error('\p{Is_Sc=:=	Mroo}');
    Error('\P{Is_Sc=:=	Mroo}');
    Expect(1, 92783, '\p{Is_Sc=mroo}', "");
    Expect(0, 92783, '\p{^Is_Sc=mroo}', "");
    Expect(0, 92783, '\P{Is_Sc=mroo}', "");
    Expect(1, 92783, '\P{^Is_Sc=mroo}', "");
    Expect(0, 92784, '\p{Is_Sc=mroo}', "");
    Expect(1, 92784, '\p{^Is_Sc=mroo}', "");
    Expect(1, 92784, '\P{Is_Sc=mroo}', "");
    Expect(0, 92784, '\P{^Is_Sc=mroo}', "");
    Expect(1, 92783, '\p{Is_Sc= mroo}', "");
    Expect(0, 92783, '\p{^Is_Sc= mroo}', "");
    Expect(0, 92783, '\P{Is_Sc= mroo}', "");
    Expect(1, 92783, '\P{^Is_Sc= mroo}', "");
    Expect(0, 92784, '\p{Is_Sc= mroo}', "");
    Expect(1, 92784, '\p{^Is_Sc= mroo}', "");
    Expect(1, 92784, '\P{Is_Sc= mroo}', "");
    Expect(0, 92784, '\P{^Is_Sc= mroo}', "");
    Error('\p{Script=Meetei_Mayek:=}');
    Error('\P{Script=Meetei_Mayek:=}');
    Expect(1, 44025, '\p{Script=:\AMeetei_Mayek\z:}', "");;
    Expect(0, 44026, '\p{Script=:\AMeetei_Mayek\z:}', "");;
    Expect(1, 44025, '\p{Script=meeteimayek}', "");
    Expect(0, 44025, '\p{^Script=meeteimayek}', "");
    Expect(0, 44025, '\P{Script=meeteimayek}', "");
    Expect(1, 44025, '\P{^Script=meeteimayek}', "");
    Expect(0, 44026, '\p{Script=meeteimayek}', "");
    Expect(1, 44026, '\p{^Script=meeteimayek}', "");
    Expect(1, 44026, '\P{Script=meeteimayek}', "");
    Expect(0, 44026, '\P{^Script=meeteimayek}', "");
    Expect(1, 44025, '\p{Script=:\Ameeteimayek\z:}', "");;
    Expect(0, 44026, '\p{Script=:\Ameeteimayek\z:}', "");;
    Expect(1, 44025, '\p{Script=_	MEETEI_mayek}', "");
    Expect(0, 44025, '\p{^Script=_	MEETEI_mayek}', "");
    Expect(0, 44025, '\P{Script=_	MEETEI_mayek}', "");
    Expect(1, 44025, '\P{^Script=_	MEETEI_mayek}', "");
    Expect(0, 44026, '\p{Script=_	MEETEI_mayek}', "");
    Expect(1, 44026, '\p{^Script=_	MEETEI_mayek}', "");
    Expect(1, 44026, '\P{Script=_	MEETEI_mayek}', "");
    Expect(0, 44026, '\P{^Script=_	MEETEI_mayek}', "");
    Error('\p{Sc=-Mtei/a/}');
    Error('\P{Sc=-Mtei/a/}');
    Expect(1, 44025, '\p{Sc=:\AMtei\z:}', "");;
    Expect(0, 44026, '\p{Sc=:\AMtei\z:}', "");;
    Expect(1, 44025, '\p{Sc=mtei}', "");
    Expect(0, 44025, '\p{^Sc=mtei}', "");
    Expect(0, 44025, '\P{Sc=mtei}', "");
    Expect(1, 44025, '\P{^Sc=mtei}', "");
    Expect(0, 44026, '\p{Sc=mtei}', "");
    Expect(1, 44026, '\p{^Sc=mtei}', "");
    Expect(1, 44026, '\P{Sc=mtei}', "");
    Expect(0, 44026, '\P{^Sc=mtei}', "");
    Expect(1, 44025, '\p{Sc=:\Amtei\z:}', "");;
    Expect(0, 44026, '\p{Sc=:\Amtei\z:}', "");;
    Expect(1, 44025, '\p{Sc=	-Mtei}', "");
    Expect(0, 44025, '\p{^Sc=	-Mtei}', "");
    Expect(0, 44025, '\P{Sc=	-Mtei}', "");
    Expect(1, 44025, '\P{^Sc=	-Mtei}', "");
    Expect(0, 44026, '\p{Sc=	-Mtei}', "");
    Expect(1, 44026, '\p{^Sc=	-Mtei}', "");
    Expect(1, 44026, '\P{Sc=	-Mtei}', "");
    Expect(0, 44026, '\P{^Sc=	-Mtei}', "");
    Error('\p{Is_Script=	 MEETEI_Mayek:=}');
    Error('\P{Is_Script=	 MEETEI_Mayek:=}');
    Expect(1, 44025, '\p{Is_Script=meeteimayek}', "");
    Expect(0, 44025, '\p{^Is_Script=meeteimayek}', "");
    Expect(0, 44025, '\P{Is_Script=meeteimayek}', "");
    Expect(1, 44025, '\P{^Is_Script=meeteimayek}', "");
    Expect(0, 44026, '\p{Is_Script=meeteimayek}', "");
    Expect(1, 44026, '\p{^Is_Script=meeteimayek}', "");
    Expect(1, 44026, '\P{Is_Script=meeteimayek}', "");
    Expect(0, 44026, '\P{^Is_Script=meeteimayek}', "");
    Expect(1, 44025, '\p{Is_Script=	-Meetei_Mayek}', "");
    Expect(0, 44025, '\p{^Is_Script=	-Meetei_Mayek}', "");
    Expect(0, 44025, '\P{Is_Script=	-Meetei_Mayek}', "");
    Expect(1, 44025, '\P{^Is_Script=	-Meetei_Mayek}', "");
    Expect(0, 44026, '\p{Is_Script=	-Meetei_Mayek}', "");
    Expect(1, 44026, '\p{^Is_Script=	-Meetei_Mayek}', "");
    Expect(1, 44026, '\P{Is_Script=	-Meetei_Mayek}', "");
    Expect(0, 44026, '\P{^Is_Script=	-Meetei_Mayek}', "");
    Error('\p{Is_Sc=:=_	Mtei}');
    Error('\P{Is_Sc=:=_	Mtei}');
    Expect(1, 44025, '\p{Is_Sc=mtei}', "");
    Expect(0, 44025, '\p{^Is_Sc=mtei}', "");
    Expect(0, 44025, '\P{Is_Sc=mtei}', "");
    Expect(1, 44025, '\P{^Is_Sc=mtei}', "");
    Expect(0, 44026, '\p{Is_Sc=mtei}', "");
    Expect(1, 44026, '\p{^Is_Sc=mtei}', "");
    Expect(1, 44026, '\P{Is_Sc=mtei}', "");
    Expect(0, 44026, '\P{^Is_Sc=mtei}', "");
    Expect(1, 44025, '\p{Is_Sc=-mtei}', "");
    Expect(0, 44025, '\p{^Is_Sc=-mtei}', "");
    Expect(0, 44025, '\P{Is_Sc=-mtei}', "");
    Expect(1, 44025, '\P{^Is_Sc=-mtei}', "");
    Expect(0, 44026, '\p{Is_Sc=-mtei}', "");
    Expect(1, 44026, '\p{^Is_Sc=-mtei}', "");
    Expect(1, 44026, '\P{Is_Sc=-mtei}', "");
    Expect(0, 44026, '\P{^Is_Sc=-mtei}', "");
    Error('\p{Script=/a/- MULTANI}');
    Error('\P{Script=/a/- MULTANI}');
    Expect(1, 70313, '\p{Script=:\AMultani\z:}', "");;
    Expect(0, 70314, '\p{Script=:\AMultani\z:}', "");;
    Expect(1, 70313, '\p{Script=multani}', "");
    Expect(0, 70313, '\p{^Script=multani}', "");
    Expect(0, 70313, '\P{Script=multani}', "");
    Expect(1, 70313, '\P{^Script=multani}', "");
    Expect(0, 70314, '\p{Script=multani}', "");
    Expect(1, 70314, '\p{^Script=multani}', "");
    Expect(1, 70314, '\P{Script=multani}', "");
    Expect(0, 70314, '\P{^Script=multani}', "");
    Expect(1, 70313, '\p{Script=:\Amultani\z:}', "");;
    Expect(0, 70314, '\p{Script=:\Amultani\z:}', "");;
    Expect(1, 70313, '\p{Script=_-multani}', "");
    Expect(0, 70313, '\p{^Script=_-multani}', "");
    Expect(0, 70313, '\P{Script=_-multani}', "");
    Expect(1, 70313, '\P{^Script=_-multani}', "");
    Expect(0, 70314, '\p{Script=_-multani}', "");
    Expect(1, 70314, '\p{^Script=_-multani}', "");
    Expect(1, 70314, '\P{Script=_-multani}', "");
    Expect(0, 70314, '\P{^Script=_-multani}', "");
    Error('\p{Sc=_MULT/a/}');
    Error('\P{Sc=_MULT/a/}');
    Expect(1, 70313, '\p{Sc=:\AMult\z:}', "");;
    Expect(0, 70314, '\p{Sc=:\AMult\z:}', "");;
    Expect(1, 70313, '\p{Sc=mult}', "");
    Expect(0, 70313, '\p{^Sc=mult}', "");
    Expect(0, 70313, '\P{Sc=mult}', "");
    Expect(1, 70313, '\P{^Sc=mult}', "");
    Expect(0, 70314, '\p{Sc=mult}', "");
    Expect(1, 70314, '\p{^Sc=mult}', "");
    Expect(1, 70314, '\P{Sc=mult}', "");
    Expect(0, 70314, '\P{^Sc=mult}', "");
    Expect(1, 70313, '\p{Sc=:\Amult\z:}', "");;
    Expect(0, 70314, '\p{Sc=:\Amult\z:}', "");;
    Expect(1, 70313, '\p{Sc=Mult}', "");
    Expect(0, 70313, '\p{^Sc=Mult}', "");
    Expect(0, 70313, '\P{Sc=Mult}', "");
    Expect(1, 70313, '\P{^Sc=Mult}', "");
    Expect(0, 70314, '\p{Sc=Mult}', "");
    Expect(1, 70314, '\p{^Sc=Mult}', "");
    Expect(1, 70314, '\P{Sc=Mult}', "");
    Expect(0, 70314, '\P{^Sc=Mult}', "");
    Error('\p{Is_Script=/a/	-multani}');
    Error('\P{Is_Script=/a/	-multani}');
    Expect(1, 70313, '\p{Is_Script=multani}', "");
    Expect(0, 70313, '\p{^Is_Script=multani}', "");
    Expect(0, 70313, '\P{Is_Script=multani}', "");
    Expect(1, 70313, '\P{^Is_Script=multani}', "");
    Expect(0, 70314, '\p{Is_Script=multani}', "");
    Expect(1, 70314, '\p{^Is_Script=multani}', "");
    Expect(1, 70314, '\P{Is_Script=multani}', "");
    Expect(0, 70314, '\P{^Is_Script=multani}', "");
    Expect(1, 70313, '\p{Is_Script=	MULTANI}', "");
    Expect(0, 70313, '\p{^Is_Script=	MULTANI}', "");
    Expect(0, 70313, '\P{Is_Script=	MULTANI}', "");
    Expect(1, 70313, '\P{^Is_Script=	MULTANI}', "");
    Expect(0, 70314, '\p{Is_Script=	MULTANI}', "");
    Expect(1, 70314, '\p{^Is_Script=	MULTANI}', "");
    Expect(1, 70314, '\P{Is_Script=	MULTANI}', "");
    Expect(0, 70314, '\P{^Is_Script=	MULTANI}', "");
    Error('\p{Is_Sc=-_MULT:=}');
    Error('\P{Is_Sc=-_MULT:=}');
    Expect(1, 70313, '\p{Is_Sc=mult}', "");
    Expect(0, 70313, '\p{^Is_Sc=mult}', "");
    Expect(0, 70313, '\P{Is_Sc=mult}', "");
    Expect(1, 70313, '\P{^Is_Sc=mult}', "");
    Expect(0, 70314, '\p{Is_Sc=mult}', "");
    Expect(1, 70314, '\p{^Is_Sc=mult}', "");
    Expect(1, 70314, '\P{Is_Sc=mult}', "");
    Expect(0, 70314, '\P{^Is_Sc=mult}', "");
    Expect(1, 70313, '\p{Is_Sc=-mult}', "");
    Expect(0, 70313, '\p{^Is_Sc=-mult}', "");
    Expect(0, 70313, '\P{Is_Sc=-mult}', "");
    Expect(1, 70313, '\P{^Is_Sc=-mult}', "");
    Expect(0, 70314, '\p{Is_Sc=-mult}', "");
    Expect(1, 70314, '\p{^Is_Sc=-mult}', "");
    Expect(1, 70314, '\P{Is_Sc=-mult}', "");
    Expect(0, 70314, '\P{^Is_Sc=-mult}', "");
    Error('\p{Script=-:=Myanmar}');
    Error('\P{Script=-:=Myanmar}');
    Expect(1, 43647, '\p{Script=:\AMyanmar\z:}', "");;
    Expect(0, 43648, '\p{Script=:\AMyanmar\z:}', "");;
    Expect(1, 43647, '\p{Script=myanmar}', "");
    Expect(0, 43647, '\p{^Script=myanmar}', "");
    Expect(0, 43647, '\P{Script=myanmar}', "");
    Expect(1, 43647, '\P{^Script=myanmar}', "");
    Expect(0, 43648, '\p{Script=myanmar}', "");
    Expect(1, 43648, '\p{^Script=myanmar}', "");
    Expect(1, 43648, '\P{Script=myanmar}', "");
    Expect(0, 43648, '\P{^Script=myanmar}', "");
    Expect(1, 43647, '\p{Script=:\Amyanmar\z:}', "");;
    Expect(0, 43648, '\p{Script=:\Amyanmar\z:}', "");;
    Expect(1, 43647, '\p{Script=_ myanmar}', "");
    Expect(0, 43647, '\p{^Script=_ myanmar}', "");
    Expect(0, 43647, '\P{Script=_ myanmar}', "");
    Expect(1, 43647, '\P{^Script=_ myanmar}', "");
    Expect(0, 43648, '\p{Script=_ myanmar}', "");
    Expect(1, 43648, '\p{^Script=_ myanmar}', "");
    Expect(1, 43648, '\P{Script=_ myanmar}', "");
    Expect(0, 43648, '\P{^Script=_ myanmar}', "");
    Error('\p{Sc=_Mymr:=}');
    Error('\P{Sc=_Mymr:=}');
    Expect(1, 43647, '\p{Sc=:\AMymr\z:}', "");;
    Expect(0, 43648, '\p{Sc=:\AMymr\z:}', "");;
    Expect(1, 43647, '\p{Sc=mymr}', "");
    Expect(0, 43647, '\p{^Sc=mymr}', "");
    Expect(0, 43647, '\P{Sc=mymr}', "");
    Expect(1, 43647, '\P{^Sc=mymr}', "");
    Expect(0, 43648, '\p{Sc=mymr}', "");
    Expect(1, 43648, '\p{^Sc=mymr}', "");
    Expect(1, 43648, '\P{Sc=mymr}', "");
    Expect(0, 43648, '\P{^Sc=mymr}', "");
    Expect(1, 43647, '\p{Sc=:\Amymr\z:}', "");;
    Expect(0, 43648, '\p{Sc=:\Amymr\z:}', "");;
    Expect(1, 43647, '\p{Sc=_ Mymr}', "");
    Expect(0, 43647, '\p{^Sc=_ Mymr}', "");
    Expect(0, 43647, '\P{Sc=_ Mymr}', "");
    Expect(1, 43647, '\P{^Sc=_ Mymr}', "");
    Expect(0, 43648, '\p{Sc=_ Mymr}', "");
    Expect(1, 43648, '\p{^Sc=_ Mymr}', "");
    Expect(1, 43648, '\P{Sc=_ Mymr}', "");
    Expect(0, 43648, '\P{^Sc=_ Mymr}', "");
    Error('\p{Is_Script=:=	MYANMAR}');
    Error('\P{Is_Script=:=	MYANMAR}');
    Expect(1, 43647, '\p{Is_Script:	myanmar}', "");
    Expect(0, 43647, '\p{^Is_Script:	myanmar}', "");
    Expect(0, 43647, '\P{Is_Script:	myanmar}', "");
    Expect(1, 43647, '\P{^Is_Script:	myanmar}', "");
    Expect(0, 43648, '\p{Is_Script:	myanmar}', "");
    Expect(1, 43648, '\p{^Is_Script:	myanmar}', "");
    Expect(1, 43648, '\P{Is_Script:	myanmar}', "");
    Expect(0, 43648, '\P{^Is_Script:	myanmar}', "");
    Expect(1, 43647, '\p{Is_Script=-MYANMAR}', "");
    Expect(0, 43647, '\p{^Is_Script=-MYANMAR}', "");
    Expect(0, 43647, '\P{Is_Script=-MYANMAR}', "");
    Expect(1, 43647, '\P{^Is_Script=-MYANMAR}', "");
    Expect(0, 43648, '\p{Is_Script=-MYANMAR}', "");
    Expect(1, 43648, '\p{^Is_Script=-MYANMAR}', "");
    Expect(1, 43648, '\P{Is_Script=-MYANMAR}', "");
    Expect(0, 43648, '\P{^Is_Script=-MYANMAR}', "");
    Error('\p{Is_Sc=-/a/mymr}');
    Error('\P{Is_Sc=-/a/mymr}');
    Expect(1, 43647, '\p{Is_Sc=mymr}', "");
    Expect(0, 43647, '\p{^Is_Sc=mymr}', "");
    Expect(0, 43647, '\P{Is_Sc=mymr}', "");
    Expect(1, 43647, '\P{^Is_Sc=mymr}', "");
    Expect(0, 43648, '\p{Is_Sc=mymr}', "");
    Expect(1, 43648, '\p{^Is_Sc=mymr}', "");
    Expect(1, 43648, '\P{Is_Sc=mymr}', "");
    Expect(0, 43648, '\P{^Is_Sc=mymr}', "");
    Expect(1, 43647, '\p{Is_Sc= -Mymr}', "");
    Expect(0, 43647, '\p{^Is_Sc= -Mymr}', "");
    Expect(0, 43647, '\P{Is_Sc= -Mymr}', "");
    Expect(1, 43647, '\P{^Is_Sc= -Mymr}', "");
    Expect(0, 43648, '\p{Is_Sc= -Mymr}', "");
    Expect(1, 43648, '\p{^Is_Sc= -Mymr}', "");
    Expect(1, 43648, '\P{Is_Sc= -Mymr}', "");
    Expect(0, 43648, '\P{^Is_Sc= -Mymr}', "");
    Error('\p{Script=/a/nandinagari}');
    Error('\P{Script=/a/nandinagari}');
    Expect(1, 72164, '\p{Script=:\ANandinagari\z:}', "");;
    Expect(0, 72165, '\p{Script=:\ANandinagari\z:}', "");;
    Expect(1, 72164, '\p{Script=nandinagari}', "");
    Expect(0, 72164, '\p{^Script=nandinagari}', "");
    Expect(0, 72164, '\P{Script=nandinagari}', "");
    Expect(1, 72164, '\P{^Script=nandinagari}', "");
    Expect(0, 72165, '\p{Script=nandinagari}', "");
    Expect(1, 72165, '\p{^Script=nandinagari}', "");
    Expect(1, 72165, '\P{Script=nandinagari}', "");
    Expect(0, 72165, '\P{^Script=nandinagari}', "");
    Expect(1, 72164, '\p{Script=:\Anandinagari\z:}', "");;
    Expect(0, 72165, '\p{Script=:\Anandinagari\z:}', "");;
    Expect(1, 72164, '\p{Script:--nandinagari}', "");
    Expect(0, 72164, '\p{^Script:--nandinagari}', "");
    Expect(0, 72164, '\P{Script:--nandinagari}', "");
    Expect(1, 72164, '\P{^Script:--nandinagari}', "");
    Expect(0, 72165, '\p{Script:--nandinagari}', "");
    Expect(1, 72165, '\p{^Script:--nandinagari}', "");
    Expect(1, 72165, '\P{Script:--nandinagari}', "");
    Expect(0, 72165, '\P{^Script:--nandinagari}', "");
    Error('\p{Sc=/a/ NAND}');
    Error('\P{Sc=/a/ NAND}');
    Expect(1, 72164, '\p{Sc=:\ANand\z:}', "");;
    Expect(0, 72165, '\p{Sc=:\ANand\z:}', "");;
    Expect(1, 72164, '\p{Sc=nand}', "");
    Expect(0, 72164, '\p{^Sc=nand}', "");
    Expect(0, 72164, '\P{Sc=nand}', "");
    Expect(1, 72164, '\P{^Sc=nand}', "");
    Expect(0, 72165, '\p{Sc=nand}', "");
    Expect(1, 72165, '\p{^Sc=nand}', "");
    Expect(1, 72165, '\P{Sc=nand}', "");
    Expect(0, 72165, '\P{^Sc=nand}', "");
    Expect(1, 72164, '\p{Sc=:\Anand\z:}', "");;
    Expect(0, 72165, '\p{Sc=:\Anand\z:}', "");;
    Expect(1, 72164, '\p{Sc= -NAND}', "");
    Expect(0, 72164, '\p{^Sc= -NAND}', "");
    Expect(0, 72164, '\P{Sc= -NAND}', "");
    Expect(1, 72164, '\P{^Sc= -NAND}', "");
    Expect(0, 72165, '\p{Sc= -NAND}', "");
    Expect(1, 72165, '\p{^Sc= -NAND}', "");
    Expect(1, 72165, '\P{Sc= -NAND}', "");
    Expect(0, 72165, '\P{^Sc= -NAND}', "");
    Error('\p{Is_Script=:= _nandinagari}');
    Error('\P{Is_Script=:= _nandinagari}');
    Expect(1, 72164, '\p{Is_Script=nandinagari}', "");
    Expect(0, 72164, '\p{^Is_Script=nandinagari}', "");
    Expect(0, 72164, '\P{Is_Script=nandinagari}', "");
    Expect(1, 72164, '\P{^Is_Script=nandinagari}', "");
    Expect(0, 72165, '\p{Is_Script=nandinagari}', "");
    Expect(1, 72165, '\p{^Is_Script=nandinagari}', "");
    Expect(1, 72165, '\P{Is_Script=nandinagari}', "");
    Expect(0, 72165, '\P{^Is_Script=nandinagari}', "");
    Expect(1, 72164, '\p{Is_Script=_-Nandinagari}', "");
    Expect(0, 72164, '\p{^Is_Script=_-Nandinagari}', "");
    Expect(0, 72164, '\P{Is_Script=_-Nandinagari}', "");
    Expect(1, 72164, '\P{^Is_Script=_-Nandinagari}', "");
    Expect(0, 72165, '\p{Is_Script=_-Nandinagari}', "");
    Expect(1, 72165, '\p{^Is_Script=_-Nandinagari}', "");
    Expect(1, 72165, '\P{Is_Script=_-Nandinagari}', "");
    Expect(0, 72165, '\P{^Is_Script=_-Nandinagari}', "");
    Error('\p{Is_Sc=-:=NAND}');
    Error('\P{Is_Sc=-:=NAND}');
    Expect(1, 72164, '\p{Is_Sc=nand}', "");
    Expect(0, 72164, '\p{^Is_Sc=nand}', "");
    Expect(0, 72164, '\P{Is_Sc=nand}', "");
    Expect(1, 72164, '\P{^Is_Sc=nand}', "");
    Expect(0, 72165, '\p{Is_Sc=nand}', "");
    Expect(1, 72165, '\p{^Is_Sc=nand}', "");
    Expect(1, 72165, '\P{Is_Sc=nand}', "");
    Expect(0, 72165, '\P{^Is_Sc=nand}', "");
    Expect(1, 72164, '\p{Is_Sc:	_-Nand}', "");
    Expect(0, 72164, '\p{^Is_Sc:	_-Nand}', "");
    Expect(0, 72164, '\P{Is_Sc:	_-Nand}', "");
    Expect(1, 72164, '\P{^Is_Sc:	_-Nand}', "");
    Expect(0, 72165, '\p{Is_Sc:	_-Nand}', "");
    Expect(1, 72165, '\p{^Is_Sc:	_-Nand}', "");
    Expect(1, 72165, '\P{Is_Sc:	_-Nand}', "");
    Expect(0, 72165, '\P{^Is_Sc:	_-Nand}', "");
    Error('\p{Script=/a/  Old_North_Arabian}');
    Error('\P{Script=/a/  Old_North_Arabian}');
    Expect(1, 68255, '\p{Script=:\AOld_North_Arabian\z:}', "");;
    Expect(0, 68256, '\p{Script=:\AOld_North_Arabian\z:}', "");;
    Expect(1, 68255, '\p{Script=oldnortharabian}', "");
    Expect(0, 68255, '\p{^Script=oldnortharabian}', "");
    Expect(0, 68255, '\P{Script=oldnortharabian}', "");
    Expect(1, 68255, '\P{^Script=oldnortharabian}', "");
    Expect(0, 68256, '\p{Script=oldnortharabian}', "");
    Expect(1, 68256, '\p{^Script=oldnortharabian}', "");
    Expect(1, 68256, '\P{Script=oldnortharabian}', "");
    Expect(0, 68256, '\P{^Script=oldnortharabian}', "");
    Expect(1, 68255, '\p{Script=:\Aoldnortharabian\z:}', "");;
    Expect(0, 68256, '\p{Script=:\Aoldnortharabian\z:}', "");;
    Expect(1, 68255, '\p{Script=  old_North_Arabian}', "");
    Expect(0, 68255, '\p{^Script=  old_North_Arabian}', "");
    Expect(0, 68255, '\P{Script=  old_North_Arabian}', "");
    Expect(1, 68255, '\P{^Script=  old_North_Arabian}', "");
    Expect(0, 68256, '\p{Script=  old_North_Arabian}', "");
    Expect(1, 68256, '\p{^Script=  old_North_Arabian}', "");
    Expect(1, 68256, '\P{Script=  old_North_Arabian}', "");
    Expect(0, 68256, '\P{^Script=  old_North_Arabian}', "");
    Error('\p{Sc=-/a/NARB}');
    Error('\P{Sc=-/a/NARB}');
    Expect(1, 68255, '\p{Sc=:\ANarb\z:}', "");;
    Expect(0, 68256, '\p{Sc=:\ANarb\z:}', "");;
    Expect(1, 68255, '\p{Sc:   narb}', "");
    Expect(0, 68255, '\p{^Sc:   narb}', "");
    Expect(0, 68255, '\P{Sc:   narb}', "");
    Expect(1, 68255, '\P{^Sc:   narb}', "");
    Expect(0, 68256, '\p{Sc:   narb}', "");
    Expect(1, 68256, '\p{^Sc:   narb}', "");
    Expect(1, 68256, '\P{Sc:   narb}', "");
    Expect(0, 68256, '\P{^Sc:   narb}', "");
    Expect(1, 68255, '\p{Sc=:\Anarb\z:}', "");;
    Expect(0, 68256, '\p{Sc=:\Anarb\z:}', "");;
    Expect(1, 68255, '\p{Sc:	-Narb}', "");
    Expect(0, 68255, '\p{^Sc:	-Narb}', "");
    Expect(0, 68255, '\P{Sc:	-Narb}', "");
    Expect(1, 68255, '\P{^Sc:	-Narb}', "");
    Expect(0, 68256, '\p{Sc:	-Narb}', "");
    Expect(1, 68256, '\p{^Sc:	-Narb}', "");
    Expect(1, 68256, '\P{Sc:	-Narb}', "");
    Expect(0, 68256, '\P{^Sc:	-Narb}', "");
    Error('\p{Is_Script=__OLD_north_arabian:=}');
    Error('\P{Is_Script=__OLD_north_arabian:=}');
    Expect(1, 68255, '\p{Is_Script:   oldnortharabian}', "");
    Expect(0, 68255, '\p{^Is_Script:   oldnortharabian}', "");
    Expect(0, 68255, '\P{Is_Script:   oldnortharabian}', "");
    Expect(1, 68255, '\P{^Is_Script:   oldnortharabian}', "");
    Expect(0, 68256, '\p{Is_Script:   oldnortharabian}', "");
    Expect(1, 68256, '\p{^Is_Script:   oldnortharabian}', "");
    Expect(1, 68256, '\P{Is_Script:   oldnortharabian}', "");
    Expect(0, 68256, '\P{^Is_Script:   oldnortharabian}', "");
    Expect(1, 68255, '\p{Is_Script= 	Old_North_Arabian}', "");
    Expect(0, 68255, '\p{^Is_Script= 	Old_North_Arabian}', "");
    Expect(0, 68255, '\P{Is_Script= 	Old_North_Arabian}', "");
    Expect(1, 68255, '\P{^Is_Script= 	Old_North_Arabian}', "");
    Expect(0, 68256, '\p{Is_Script= 	Old_North_Arabian}', "");
    Expect(1, 68256, '\p{^Is_Script= 	Old_North_Arabian}', "");
    Expect(1, 68256, '\P{Is_Script= 	Old_North_Arabian}', "");
    Expect(0, 68256, '\P{^Is_Script= 	Old_North_Arabian}', "");
    Error('\p{Is_Sc= -Narb:=}');
    Error('\P{Is_Sc= -Narb:=}');
    Expect(1, 68255, '\p{Is_Sc=narb}', "");
    Expect(0, 68255, '\p{^Is_Sc=narb}', "");
    Expect(0, 68255, '\P{Is_Sc=narb}', "");
    Expect(1, 68255, '\P{^Is_Sc=narb}', "");
    Expect(0, 68256, '\p{Is_Sc=narb}', "");
    Expect(1, 68256, '\p{^Is_Sc=narb}', "");
    Expect(1, 68256, '\P{Is_Sc=narb}', "");
    Expect(0, 68256, '\P{^Is_Sc=narb}', "");
    Expect(1, 68255, '\p{Is_Sc=_Narb}', "");
    Expect(0, 68255, '\p{^Is_Sc=_Narb}', "");
    Expect(0, 68255, '\P{Is_Sc=_Narb}', "");
    Expect(1, 68255, '\P{^Is_Sc=_Narb}', "");
    Expect(0, 68256, '\p{Is_Sc=_Narb}', "");
    Expect(1, 68256, '\p{^Is_Sc=_Narb}', "");
    Expect(1, 68256, '\P{Is_Sc=_Narb}', "");
    Expect(0, 68256, '\P{^Is_Sc=_Narb}', "");
    Error('\p{Script:   _:=nabataean}');
    Error('\P{Script:   _:=nabataean}');
    Expect(1, 67759, '\p{Script=:\ANabataean\z:}', "");;
    Expect(0, 67760, '\p{Script=:\ANabataean\z:}', "");;
    Expect(1, 67759, '\p{Script=nabataean}', "");
    Expect(0, 67759, '\p{^Script=nabataean}', "");
    Expect(0, 67759, '\P{Script=nabataean}', "");
    Expect(1, 67759, '\P{^Script=nabataean}', "");
    Expect(0, 67760, '\p{Script=nabataean}', "");
    Expect(1, 67760, '\p{^Script=nabataean}', "");
    Expect(1, 67760, '\P{Script=nabataean}', "");
    Expect(0, 67760, '\P{^Script=nabataean}', "");
    Expect(1, 67759, '\p{Script=:\Anabataean\z:}', "");;
    Expect(0, 67760, '\p{Script=:\Anabataean\z:}', "");;
    Expect(1, 67759, '\p{Script=-_NABATAEAN}', "");
    Expect(0, 67759, '\p{^Script=-_NABATAEAN}', "");
    Expect(0, 67759, '\P{Script=-_NABATAEAN}', "");
    Expect(1, 67759, '\P{^Script=-_NABATAEAN}', "");
    Expect(0, 67760, '\p{Script=-_NABATAEAN}', "");
    Expect(1, 67760, '\p{^Script=-_NABATAEAN}', "");
    Expect(1, 67760, '\P{Script=-_NABATAEAN}', "");
    Expect(0, 67760, '\P{^Script=-_NABATAEAN}', "");
    Error('\p{Sc=:=  Nbat}');
    Error('\P{Sc=:=  Nbat}');
    Expect(1, 67759, '\p{Sc=:\ANbat\z:}', "");;
    Expect(0, 67760, '\p{Sc=:\ANbat\z:}', "");;
    Expect(1, 67759, '\p{Sc=nbat}', "");
    Expect(0, 67759, '\p{^Sc=nbat}', "");
    Expect(0, 67759, '\P{Sc=nbat}', "");
    Expect(1, 67759, '\P{^Sc=nbat}', "");
    Expect(0, 67760, '\p{Sc=nbat}', "");
    Expect(1, 67760, '\p{^Sc=nbat}', "");
    Expect(1, 67760, '\P{Sc=nbat}', "");
    Expect(0, 67760, '\P{^Sc=nbat}', "");
    Expect(1, 67759, '\p{Sc=:\Anbat\z:}', "");;
    Expect(0, 67760, '\p{Sc=:\Anbat\z:}', "");;
    Expect(1, 67759, '\p{Sc=-Nbat}', "");
    Expect(0, 67759, '\p{^Sc=-Nbat}', "");
    Expect(0, 67759, '\P{Sc=-Nbat}', "");
    Expect(1, 67759, '\P{^Sc=-Nbat}', "");
    Expect(0, 67760, '\p{Sc=-Nbat}', "");
    Expect(1, 67760, '\p{^Sc=-Nbat}', "");
    Expect(1, 67760, '\P{Sc=-Nbat}', "");
    Expect(0, 67760, '\P{^Sc=-Nbat}', "");
    Error('\p{Is_Script:	/a/-nabataean}');
    Error('\P{Is_Script:	/a/-nabataean}');
    Expect(1, 67759, '\p{Is_Script=nabataean}', "");
    Expect(0, 67759, '\p{^Is_Script=nabataean}', "");
    Expect(0, 67759, '\P{Is_Script=nabataean}', "");
    Expect(1, 67759, '\P{^Is_Script=nabataean}', "");
    Expect(0, 67760, '\p{Is_Script=nabataean}', "");
    Expect(1, 67760, '\p{^Is_Script=nabataean}', "");
    Expect(1, 67760, '\P{Is_Script=nabataean}', "");
    Expect(0, 67760, '\P{^Is_Script=nabataean}', "");
    Expect(1, 67759, '\p{Is_Script=-_NABATAEAN}', "");
    Expect(0, 67759, '\p{^Is_Script=-_NABATAEAN}', "");
    Expect(0, 67759, '\P{Is_Script=-_NABATAEAN}', "");
    Expect(1, 67759, '\P{^Is_Script=-_NABATAEAN}', "");
    Expect(0, 67760, '\p{Is_Script=-_NABATAEAN}', "");
    Expect(1, 67760, '\p{^Is_Script=-_NABATAEAN}', "");
    Expect(1, 67760, '\P{Is_Script=-_NABATAEAN}', "");
    Expect(0, 67760, '\P{^Is_Script=-_NABATAEAN}', "");
    Error('\p{Is_Sc=/a/	 Nbat}');
    Error('\P{Is_Sc=/a/	 Nbat}');
    Expect(1, 67759, '\p{Is_Sc=nbat}', "");
    Expect(0, 67759, '\p{^Is_Sc=nbat}', "");
    Expect(0, 67759, '\P{Is_Sc=nbat}', "");
    Expect(1, 67759, '\P{^Is_Sc=nbat}', "");
    Expect(0, 67760, '\p{Is_Sc=nbat}', "");
    Expect(1, 67760, '\p{^Is_Sc=nbat}', "");
    Expect(1, 67760, '\P{Is_Sc=nbat}', "");
    Expect(0, 67760, '\P{^Is_Sc=nbat}', "");
    Expect(1, 67759, '\p{Is_Sc=--NBAT}', "");
    Expect(0, 67759, '\p{^Is_Sc=--NBAT}', "");
    Expect(0, 67759, '\P{Is_Sc=--NBAT}', "");
    Expect(1, 67759, '\P{^Is_Sc=--NBAT}', "");
    Expect(0, 67760, '\p{Is_Sc=--NBAT}', "");
    Expect(1, 67760, '\p{^Is_Sc=--NBAT}', "");
    Expect(1, 67760, '\P{Is_Sc=--NBAT}', "");
    Expect(0, 67760, '\P{^Is_Sc=--NBAT}', "");
    Error('\p{Script=/a/	NEWA}');
    Error('\P{Script=/a/	NEWA}');
    Expect(1, 70753, '\p{Script=:\ANewa\z:}', "");;
    Expect(0, 70754, '\p{Script=:\ANewa\z:}', "");;
    Expect(1, 70753, '\p{Script=newa}', "");
    Expect(0, 70753, '\p{^Script=newa}', "");
    Expect(0, 70753, '\P{Script=newa}', "");
    Expect(1, 70753, '\P{^Script=newa}', "");
    Expect(0, 70754, '\p{Script=newa}', "");
    Expect(1, 70754, '\p{^Script=newa}', "");
    Expect(1, 70754, '\P{Script=newa}', "");
    Expect(0, 70754, '\P{^Script=newa}', "");
    Expect(1, 70753, '\p{Script=:\Anewa\z:}', "");;
    Expect(0, 70754, '\p{Script=:\Anewa\z:}', "");;
    Expect(1, 70753, '\p{Script= 	Newa}', "");
    Expect(0, 70753, '\p{^Script= 	Newa}', "");
    Expect(0, 70753, '\P{Script= 	Newa}', "");
    Expect(1, 70753, '\P{^Script= 	Newa}', "");
    Expect(0, 70754, '\p{Script= 	Newa}', "");
    Expect(1, 70754, '\p{^Script= 	Newa}', "");
    Expect(1, 70754, '\P{Script= 	Newa}', "");
    Expect(0, 70754, '\P{^Script= 	Newa}', "");
    Error('\p{Sc=-Newa:=}');
    Error('\P{Sc=-Newa:=}');
    Expect(1, 70753, '\p{Sc=:\ANewa\z:}', "");;
    Expect(0, 70754, '\p{Sc=:\ANewa\z:}', "");;
    Expect(1, 70753, '\p{Sc=newa}', "");
    Expect(0, 70753, '\p{^Sc=newa}', "");
    Expect(0, 70753, '\P{Sc=newa}', "");
    Expect(1, 70753, '\P{^Sc=newa}', "");
    Expect(0, 70754, '\p{Sc=newa}', "");
    Expect(1, 70754, '\p{^Sc=newa}', "");
    Expect(1, 70754, '\P{Sc=newa}', "");
    Expect(0, 70754, '\P{^Sc=newa}', "");
    Expect(1, 70753, '\p{Sc=:\Anewa\z:}', "");;
    Expect(0, 70754, '\p{Sc=:\Anewa\z:}', "");;
    Expect(1, 70753, '\p{Sc=  Newa}', "");
    Expect(0, 70753, '\p{^Sc=  Newa}', "");
    Expect(0, 70753, '\P{Sc=  Newa}', "");
    Expect(1, 70753, '\P{^Sc=  Newa}', "");
    Expect(0, 70754, '\p{Sc=  Newa}', "");
    Expect(1, 70754, '\p{^Sc=  Newa}', "");
    Expect(1, 70754, '\P{Sc=  Newa}', "");
    Expect(0, 70754, '\P{^Sc=  Newa}', "");
    Error('\p{Is_Script= /a/newa}');
    Error('\P{Is_Script= /a/newa}');
    Expect(1, 70753, '\p{Is_Script=newa}', "");
    Expect(0, 70753, '\p{^Is_Script=newa}', "");
    Expect(0, 70753, '\P{Is_Script=newa}', "");
    Expect(1, 70753, '\P{^Is_Script=newa}', "");
    Expect(0, 70754, '\p{Is_Script=newa}', "");
    Expect(1, 70754, '\p{^Is_Script=newa}', "");
    Expect(1, 70754, '\P{Is_Script=newa}', "");
    Expect(0, 70754, '\P{^Is_Script=newa}', "");
    Expect(1, 70753, '\p{Is_Script=	_NEWA}', "");
    Expect(0, 70753, '\p{^Is_Script=	_NEWA}', "");
    Expect(0, 70753, '\P{Is_Script=	_NEWA}', "");
    Expect(1, 70753, '\P{^Is_Script=	_NEWA}', "");
    Expect(0, 70754, '\p{Is_Script=	_NEWA}', "");
    Expect(1, 70754, '\p{^Is_Script=	_NEWA}', "");
    Expect(1, 70754, '\P{Is_Script=	_NEWA}', "");
    Expect(0, 70754, '\P{^Is_Script=	_NEWA}', "");
    Error('\p{Is_Sc=/a/_-NEWA}');
    Error('\P{Is_Sc=/a/_-NEWA}');
    Expect(1, 70753, '\p{Is_Sc=newa}', "");
    Expect(0, 70753, '\p{^Is_Sc=newa}', "");
    Expect(0, 70753, '\P{Is_Sc=newa}', "");
    Expect(1, 70753, '\P{^Is_Sc=newa}', "");
    Expect(0, 70754, '\p{Is_Sc=newa}', "");
    Expect(1, 70754, '\p{^Is_Sc=newa}', "");
    Expect(1, 70754, '\P{Is_Sc=newa}', "");
    Expect(0, 70754, '\P{^Is_Sc=newa}', "");
    Expect(1, 70753, '\p{Is_Sc=	 newa}', "");
    Expect(0, 70753, '\p{^Is_Sc=	 newa}', "");
    Expect(0, 70753, '\P{Is_Sc=	 newa}', "");
    Expect(1, 70753, '\P{^Is_Sc=	 newa}', "");
    Expect(0, 70754, '\p{Is_Sc=	 newa}', "");
    Expect(1, 70754, '\p{^Is_Sc=	 newa}', "");
    Expect(1, 70754, '\P{Is_Sc=	 newa}', "");
    Expect(0, 70754, '\P{^Is_Sc=	 newa}', "");
    Error('\p{Script=:=_-Nko}');
    Error('\P{Script=:=_-Nko}');
    Expect(1, 2047, '\p{Script=:\ANko\z:}', "");;
    Expect(0, 2048, '\p{Script=:\ANko\z:}', "");;
    Expect(1, 2047, '\p{Script=nko}', "");
    Expect(0, 2047, '\p{^Script=nko}', "");
    Expect(0, 2047, '\P{Script=nko}', "");
    Expect(1, 2047, '\P{^Script=nko}', "");
    Expect(0, 2048, '\p{Script=nko}', "");
    Expect(1, 2048, '\p{^Script=nko}', "");
    Expect(1, 2048, '\P{Script=nko}', "");
    Expect(0, 2048, '\P{^Script=nko}', "");
    Expect(1, 2047, '\p{Script=:\Anko\z:}', "");;
    Expect(0, 2048, '\p{Script=:\Anko\z:}', "");;
    Expect(1, 2047, '\p{Script=__Nko}', "");
    Expect(0, 2047, '\p{^Script=__Nko}', "");
    Expect(0, 2047, '\P{Script=__Nko}', "");
    Expect(1, 2047, '\P{^Script=__Nko}', "");
    Expect(0, 2048, '\p{Script=__Nko}', "");
    Expect(1, 2048, '\p{^Script=__Nko}', "");
    Expect(1, 2048, '\P{Script=__Nko}', "");
    Expect(0, 2048, '\P{^Script=__Nko}', "");
    Error('\p{Sc=:=Nkoo}');
    Error('\P{Sc=:=Nkoo}');
    Expect(1, 2047, '\p{Sc=:\ANkoo\z:}', "");;
    Expect(0, 2048, '\p{Sc=:\ANkoo\z:}', "");;
    Expect(1, 2047, '\p{Sc:	nkoo}', "");
    Expect(0, 2047, '\p{^Sc:	nkoo}', "");
    Expect(0, 2047, '\P{Sc:	nkoo}', "");
    Expect(1, 2047, '\P{^Sc:	nkoo}', "");
    Expect(0, 2048, '\p{Sc:	nkoo}', "");
    Expect(1, 2048, '\p{^Sc:	nkoo}', "");
    Expect(1, 2048, '\P{Sc:	nkoo}', "");
    Expect(0, 2048, '\P{^Sc:	nkoo}', "");
    Expect(1, 2047, '\p{Sc=:\Ankoo\z:}', "");;
    Expect(0, 2048, '\p{Sc=:\Ankoo\z:}', "");;
    Expect(1, 2047, '\p{Sc= Nkoo}', "");
    Expect(0, 2047, '\p{^Sc= Nkoo}', "");
    Expect(0, 2047, '\P{Sc= Nkoo}', "");
    Expect(1, 2047, '\P{^Sc= Nkoo}', "");
    Expect(0, 2048, '\p{Sc= Nkoo}', "");
    Expect(1, 2048, '\p{^Sc= Nkoo}', "");
    Expect(1, 2048, '\P{Sc= Nkoo}', "");
    Expect(0, 2048, '\P{^Sc= Nkoo}', "");
    Error('\p{Is_Script= Nko/a/}');
    Error('\P{Is_Script= Nko/a/}');
    Expect(1, 2047, '\p{Is_Script:	nko}', "");
    Expect(0, 2047, '\p{^Is_Script:	nko}', "");
    Expect(0, 2047, '\P{Is_Script:	nko}', "");
    Expect(1, 2047, '\P{^Is_Script:	nko}', "");
    Expect(0, 2048, '\p{Is_Script:	nko}', "");
    Expect(1, 2048, '\p{^Is_Script:	nko}', "");
    Expect(1, 2048, '\P{Is_Script:	nko}', "");
    Expect(0, 2048, '\P{^Is_Script:	nko}', "");
    Expect(1, 2047, '\p{Is_Script:	 NKO}', "");
    Expect(0, 2047, '\p{^Is_Script:	 NKO}', "");
    Expect(0, 2047, '\P{Is_Script:	 NKO}', "");
    Expect(1, 2047, '\P{^Is_Script:	 NKO}', "");
    Expect(0, 2048, '\p{Is_Script:	 NKO}', "");
    Expect(1, 2048, '\p{^Is_Script:	 NKO}', "");
    Expect(1, 2048, '\P{Is_Script:	 NKO}', "");
    Expect(0, 2048, '\P{^Is_Script:	 NKO}', "");
    Error('\p{Is_Sc=/a/	_nkoo}');
    Error('\P{Is_Sc=/a/	_nkoo}');
    Expect(1, 2047, '\p{Is_Sc=nkoo}', "");
    Expect(0, 2047, '\p{^Is_Sc=nkoo}', "");
    Expect(0, 2047, '\P{Is_Sc=nkoo}', "");
    Expect(1, 2047, '\P{^Is_Sc=nkoo}', "");
    Expect(0, 2048, '\p{Is_Sc=nkoo}', "");
    Expect(1, 2048, '\p{^Is_Sc=nkoo}', "");
    Expect(1, 2048, '\P{Is_Sc=nkoo}', "");
    Expect(0, 2048, '\P{^Is_Sc=nkoo}', "");
    Expect(1, 2047, '\p{Is_Sc=-nkoo}', "");
    Expect(0, 2047, '\p{^Is_Sc=-nkoo}', "");
    Expect(0, 2047, '\P{Is_Sc=-nkoo}', "");
    Expect(1, 2047, '\P{^Is_Sc=-nkoo}', "");
    Expect(0, 2048, '\p{Is_Sc=-nkoo}', "");
    Expect(1, 2048, '\p{^Is_Sc=-nkoo}', "");
    Expect(1, 2048, '\P{Is_Sc=-nkoo}', "");
    Expect(0, 2048, '\P{^Is_Sc=-nkoo}', "");
    Error('\p{Script=/a/-Nushu}');
    Error('\P{Script=/a/-Nushu}');
    Expect(1, 111355, '\p{Script=:\ANushu\z:}', "");;
    Expect(0, 111356, '\p{Script=:\ANushu\z:}', "");;
    Expect(1, 111355, '\p{Script=nushu}', "");
    Expect(0, 111355, '\p{^Script=nushu}', "");
    Expect(0, 111355, '\P{Script=nushu}', "");
    Expect(1, 111355, '\P{^Script=nushu}', "");
    Expect(0, 111356, '\p{Script=nushu}', "");
    Expect(1, 111356, '\p{^Script=nushu}', "");
    Expect(1, 111356, '\P{Script=nushu}', "");
    Expect(0, 111356, '\P{^Script=nushu}', "");
    Expect(1, 111355, '\p{Script=:\Anushu\z:}', "");;
    Expect(0, 111356, '\p{Script=:\Anushu\z:}', "");;
    Expect(1, 111355, '\p{Script=	 NUSHU}', "");
    Expect(0, 111355, '\p{^Script=	 NUSHU}', "");
    Expect(0, 111355, '\P{Script=	 NUSHU}', "");
    Expect(1, 111355, '\P{^Script=	 NUSHU}', "");
    Expect(0, 111356, '\p{Script=	 NUSHU}', "");
    Expect(1, 111356, '\p{^Script=	 NUSHU}', "");
    Expect(1, 111356, '\P{Script=	 NUSHU}', "");
    Expect(0, 111356, '\P{^Script=	 NUSHU}', "");
    Error('\p{Sc=/a/	 nshu}');
    Error('\P{Sc=/a/	 nshu}');
    Expect(1, 111355, '\p{Sc=:\ANshu\z:}', "");;
    Expect(0, 111356, '\p{Sc=:\ANshu\z:}', "");;
    Expect(1, 111355, '\p{Sc=nshu}', "");
    Expect(0, 111355, '\p{^Sc=nshu}', "");
    Expect(0, 111355, '\P{Sc=nshu}', "");
    Expect(1, 111355, '\P{^Sc=nshu}', "");
    Expect(0, 111356, '\p{Sc=nshu}', "");
    Expect(1, 111356, '\p{^Sc=nshu}', "");
    Expect(1, 111356, '\P{Sc=nshu}', "");
    Expect(0, 111356, '\P{^Sc=nshu}', "");
    Expect(1, 111355, '\p{Sc=:\Anshu\z:}', "");;
    Expect(0, 111356, '\p{Sc=:\Anshu\z:}', "");;
    Expect(1, 111355, '\p{Sc:_ Nshu}', "");
    Expect(0, 111355, '\p{^Sc:_ Nshu}', "");
    Expect(0, 111355, '\P{Sc:_ Nshu}', "");
    Expect(1, 111355, '\P{^Sc:_ Nshu}', "");
    Expect(0, 111356, '\p{Sc:_ Nshu}', "");
    Expect(1, 111356, '\p{^Sc:_ Nshu}', "");
    Expect(1, 111356, '\P{Sc:_ Nshu}', "");
    Expect(0, 111356, '\P{^Sc:_ Nshu}', "");
    Error('\p{Is_Script=--nushu:=}');
    Error('\P{Is_Script=--nushu:=}');
    Expect(1, 111355, '\p{Is_Script=nushu}', "");
    Expect(0, 111355, '\p{^Is_Script=nushu}', "");
    Expect(0, 111355, '\P{Is_Script=nushu}', "");
    Expect(1, 111355, '\P{^Is_Script=nushu}', "");
    Expect(0, 111356, '\p{Is_Script=nushu}', "");
    Expect(1, 111356, '\p{^Is_Script=nushu}', "");
    Expect(1, 111356, '\P{Is_Script=nushu}', "");
    Expect(0, 111356, '\P{^Is_Script=nushu}', "");
    Expect(1, 111355, '\p{Is_Script=_ Nushu}', "");
    Expect(0, 111355, '\p{^Is_Script=_ Nushu}', "");
    Expect(0, 111355, '\P{Is_Script=_ Nushu}', "");
    Expect(1, 111355, '\P{^Is_Script=_ Nushu}', "");
    Expect(0, 111356, '\p{Is_Script=_ Nushu}', "");
    Expect(1, 111356, '\p{^Is_Script=_ Nushu}', "");
    Expect(1, 111356, '\P{Is_Script=_ Nushu}', "");
    Expect(0, 111356, '\P{^Is_Script=_ Nushu}', "");
    Error('\p{Is_Sc=:= _Nshu}');
    Error('\P{Is_Sc=:= _Nshu}');
    Expect(1, 111355, '\p{Is_Sc=nshu}', "");
    Expect(0, 111355, '\p{^Is_Sc=nshu}', "");
    Expect(0, 111355, '\P{Is_Sc=nshu}', "");
    Expect(1, 111355, '\P{^Is_Sc=nshu}', "");
    Expect(0, 111356, '\p{Is_Sc=nshu}', "");
    Expect(1, 111356, '\p{^Is_Sc=nshu}', "");
    Expect(1, 111356, '\P{Is_Sc=nshu}', "");
    Expect(0, 111356, '\P{^Is_Sc=nshu}', "");
    Expect(1, 111355, '\p{Is_Sc=-Nshu}', "");
    Expect(0, 111355, '\p{^Is_Sc=-Nshu}', "");
    Expect(0, 111355, '\P{Is_Sc=-Nshu}', "");
    Expect(1, 111355, '\P{^Is_Sc=-Nshu}', "");
    Expect(0, 111356, '\p{Is_Sc=-Nshu}', "");
    Expect(1, 111356, '\p{^Is_Sc=-Nshu}', "");
    Expect(1, 111356, '\P{Is_Sc=-Nshu}', "");
    Expect(0, 111356, '\P{^Is_Sc=-Nshu}', "");
    Error('\p{Script=		Ogham:=}');
    Error('\P{Script=		Ogham:=}');
    Expect(1, 5788, '\p{Script=:\AOgham\z:}', "");;
    Expect(0, 5789, '\p{Script=:\AOgham\z:}', "");;
    Expect(1, 5788, '\p{Script:ogham}', "");
    Expect(0, 5788, '\p{^Script:ogham}', "");
    Expect(0, 5788, '\P{Script:ogham}', "");
    Expect(1, 5788, '\P{^Script:ogham}', "");
    Expect(0, 5789, '\p{Script:ogham}', "");
    Expect(1, 5789, '\p{^Script:ogham}', "");
    Expect(1, 5789, '\P{Script:ogham}', "");
    Expect(0, 5789, '\P{^Script:ogham}', "");
    Expect(1, 5788, '\p{Script=:\Aogham\z:}', "");;
    Expect(0, 5789, '\p{Script=:\Aogham\z:}', "");;
    Expect(1, 5788, '\p{Script=	OGHAM}', "");
    Expect(0, 5788, '\p{^Script=	OGHAM}', "");
    Expect(0, 5788, '\P{Script=	OGHAM}', "");
    Expect(1, 5788, '\P{^Script=	OGHAM}', "");
    Expect(0, 5789, '\p{Script=	OGHAM}', "");
    Expect(1, 5789, '\p{^Script=	OGHAM}', "");
    Expect(1, 5789, '\P{Script=	OGHAM}', "");
    Expect(0, 5789, '\P{^Script=	OGHAM}', "");
    Error('\p{Sc=-Ogam/a/}');
    Error('\P{Sc=-Ogam/a/}');
    Expect(1, 5788, '\p{Sc=:\AOgam\z:}', "");;
    Expect(0, 5789, '\p{Sc=:\AOgam\z:}', "");;
    Expect(1, 5788, '\p{Sc=ogam}', "");
    Expect(0, 5788, '\p{^Sc=ogam}', "");
    Expect(0, 5788, '\P{Sc=ogam}', "");
    Expect(1, 5788, '\P{^Sc=ogam}', "");
    Expect(0, 5789, '\p{Sc=ogam}', "");
    Expect(1, 5789, '\p{^Sc=ogam}', "");
    Expect(1, 5789, '\P{Sc=ogam}', "");
    Expect(0, 5789, '\P{^Sc=ogam}', "");
    Expect(1, 5788, '\p{Sc=:\Aogam\z:}', "");;
    Expect(0, 5789, '\p{Sc=:\Aogam\z:}', "");;
    Expect(1, 5788, '\p{Sc: _-Ogam}', "");
    Expect(0, 5788, '\p{^Sc: _-Ogam}', "");
    Expect(0, 5788, '\P{Sc: _-Ogam}', "");
    Expect(1, 5788, '\P{^Sc: _-Ogam}', "");
    Expect(0, 5789, '\p{Sc: _-Ogam}', "");
    Expect(1, 5789, '\p{^Sc: _-Ogam}', "");
    Expect(1, 5789, '\P{Sc: _-Ogam}', "");
    Expect(0, 5789, '\P{^Sc: _-Ogam}', "");
    Error('\p{Is_Script=	:=Ogham}');
    Error('\P{Is_Script=	:=Ogham}');
    Expect(1, 5788, '\p{Is_Script=ogham}', "");
    Expect(0, 5788, '\p{^Is_Script=ogham}', "");
    Expect(0, 5788, '\P{Is_Script=ogham}', "");
    Expect(1, 5788, '\P{^Is_Script=ogham}', "");
    Expect(0, 5789, '\p{Is_Script=ogham}', "");
    Expect(1, 5789, '\p{^Is_Script=ogham}', "");
    Expect(1, 5789, '\P{Is_Script=ogham}', "");
    Expect(0, 5789, '\P{^Is_Script=ogham}', "");
    Expect(1, 5788, '\p{Is_Script= ogham}', "");
    Expect(0, 5788, '\p{^Is_Script= ogham}', "");
    Expect(0, 5788, '\P{Is_Script= ogham}', "");
    Expect(1, 5788, '\P{^Is_Script= ogham}', "");
    Expect(0, 5789, '\p{Is_Script= ogham}', "");
    Expect(1, 5789, '\p{^Is_Script= ogham}', "");
    Expect(1, 5789, '\P{Is_Script= ogham}', "");
    Expect(0, 5789, '\P{^Is_Script= ogham}', "");
    Error('\p{Is_Sc=/a/-	Ogam}');
    Error('\P{Is_Sc=/a/-	Ogam}');
    Expect(1, 5788, '\p{Is_Sc: ogam}', "");
    Expect(0, 5788, '\p{^Is_Sc: ogam}', "");
    Expect(0, 5788, '\P{Is_Sc: ogam}', "");
    Expect(1, 5788, '\P{^Is_Sc: ogam}', "");
    Expect(0, 5789, '\p{Is_Sc: ogam}', "");
    Expect(1, 5789, '\p{^Is_Sc: ogam}', "");
    Expect(1, 5789, '\P{Is_Sc: ogam}', "");
    Expect(0, 5789, '\P{^Is_Sc: ogam}', "");
    Expect(1, 5788, '\p{Is_Sc=		Ogam}', "");
    Expect(0, 5788, '\p{^Is_Sc=		Ogam}', "");
    Expect(0, 5788, '\P{Is_Sc=		Ogam}', "");
    Expect(1, 5788, '\P{^Is_Sc=		Ogam}', "");
    Expect(0, 5789, '\p{Is_Sc=		Ogam}', "");
    Expect(1, 5789, '\p{^Is_Sc=		Ogam}', "");
    Expect(1, 5789, '\P{Is_Sc=		Ogam}', "");
    Expect(0, 5789, '\P{^Is_Sc=		Ogam}', "");
    Error('\p{Script=-/a/OL_chiki}');
    Error('\P{Script=-/a/OL_chiki}');
    Expect(1, 7295, '\p{Script=:\AOl_Chiki\z:}', "");;
    Expect(0, 7296, '\p{Script=:\AOl_Chiki\z:}', "");;
    Expect(1, 7295, '\p{Script=olchiki}', "");
    Expect(0, 7295, '\p{^Script=olchiki}', "");
    Expect(0, 7295, '\P{Script=olchiki}', "");
    Expect(1, 7295, '\P{^Script=olchiki}', "");
    Expect(0, 7296, '\p{Script=olchiki}', "");
    Expect(1, 7296, '\p{^Script=olchiki}', "");
    Expect(1, 7296, '\P{Script=olchiki}', "");
    Expect(0, 7296, '\P{^Script=olchiki}', "");
    Expect(1, 7295, '\p{Script=:\Aolchiki\z:}', "");;
    Expect(0, 7296, '\p{Script=:\Aolchiki\z:}', "");;
    Expect(1, 7295, '\p{Script=-_Ol_Chiki}', "");
    Expect(0, 7295, '\p{^Script=-_Ol_Chiki}', "");
    Expect(0, 7295, '\P{Script=-_Ol_Chiki}', "");
    Expect(1, 7295, '\P{^Script=-_Ol_Chiki}', "");
    Expect(0, 7296, '\p{Script=-_Ol_Chiki}', "");
    Expect(1, 7296, '\p{^Script=-_Ol_Chiki}', "");
    Expect(1, 7296, '\P{Script=-_Ol_Chiki}', "");
    Expect(0, 7296, '\P{^Script=-_Ol_Chiki}', "");
    Error('\p{Sc=:=	 OLCK}');
    Error('\P{Sc=:=	 OLCK}');
    Expect(1, 7295, '\p{Sc=:\AOlck\z:}', "");;
    Expect(0, 7296, '\p{Sc=:\AOlck\z:}', "");;
    Expect(1, 7295, '\p{Sc:	olck}', "");
    Expect(0, 7295, '\p{^Sc:	olck}', "");
    Expect(0, 7295, '\P{Sc:	olck}', "");
    Expect(1, 7295, '\P{^Sc:	olck}', "");
    Expect(0, 7296, '\p{Sc:	olck}', "");
    Expect(1, 7296, '\p{^Sc:	olck}', "");
    Expect(1, 7296, '\P{Sc:	olck}', "");
    Expect(0, 7296, '\P{^Sc:	olck}', "");
    Expect(1, 7295, '\p{Sc=:\Aolck\z:}', "");;
    Expect(0, 7296, '\p{Sc=:\Aolck\z:}', "");;
    Expect(1, 7295, '\p{Sc= olck}', "");
    Expect(0, 7295, '\p{^Sc= olck}', "");
    Expect(0, 7295, '\P{Sc= olck}', "");
    Expect(1, 7295, '\P{^Sc= olck}', "");
    Expect(0, 7296, '\p{Sc= olck}', "");
    Expect(1, 7296, '\p{^Sc= olck}', "");
    Expect(1, 7296, '\P{Sc= olck}', "");
    Expect(0, 7296, '\P{^Sc= olck}', "");
    Error('\p{Is_Script=_:=Ol_CHIKI}');
    Error('\P{Is_Script=_:=Ol_CHIKI}');
    Expect(1, 7295, '\p{Is_Script=olchiki}', "");
    Expect(0, 7295, '\p{^Is_Script=olchiki}', "");
    Expect(0, 7295, '\P{Is_Script=olchiki}', "");
    Expect(1, 7295, '\P{^Is_Script=olchiki}', "");
    Expect(0, 7296, '\p{Is_Script=olchiki}', "");
    Expect(1, 7296, '\p{^Is_Script=olchiki}', "");
    Expect(1, 7296, '\P{Is_Script=olchiki}', "");
    Expect(0, 7296, '\P{^Is_Script=olchiki}', "");
    Expect(1, 7295, '\p{Is_Script= _Ol_chiki}', "");
    Expect(0, 7295, '\p{^Is_Script= _Ol_chiki}', "");
    Expect(0, 7295, '\P{Is_Script= _Ol_chiki}', "");
    Expect(1, 7295, '\P{^Is_Script= _Ol_chiki}', "");
    Expect(0, 7296, '\p{Is_Script= _Ol_chiki}', "");
    Expect(1, 7296, '\p{^Is_Script= _Ol_chiki}', "");
    Expect(1, 7296, '\P{Is_Script= _Ol_chiki}', "");
    Expect(0, 7296, '\P{^Is_Script= _Ol_chiki}', "");
    Error('\p{Is_Sc::=_ Olck}');
    Error('\P{Is_Sc::=_ Olck}');
    Expect(1, 7295, '\p{Is_Sc=olck}', "");
    Expect(0, 7295, '\p{^Is_Sc=olck}', "");
    Expect(0, 7295, '\P{Is_Sc=olck}', "");
    Expect(1, 7295, '\P{^Is_Sc=olck}', "");
    Expect(0, 7296, '\p{Is_Sc=olck}', "");
    Expect(1, 7296, '\p{^Is_Sc=olck}', "");
    Expect(1, 7296, '\P{Is_Sc=olck}', "");
    Expect(0, 7296, '\P{^Is_Sc=olck}', "");
    Expect(1, 7295, '\p{Is_Sc=	 olck}', "");
    Expect(0, 7295, '\p{^Is_Sc=	 olck}', "");
    Expect(0, 7295, '\P{Is_Sc=	 olck}', "");
    Expect(1, 7295, '\P{^Is_Sc=	 olck}', "");
    Expect(0, 7296, '\p{Is_Sc=	 olck}', "");
    Expect(1, 7296, '\p{^Is_Sc=	 olck}', "");
    Expect(1, 7296, '\P{Is_Sc=	 olck}', "");
    Expect(0, 7296, '\P{^Is_Sc=	 olck}', "");
    Error('\p{Script=:=-	Old_TURKIC}');
    Error('\P{Script=:=-	Old_TURKIC}');
    Expect(1, 68680, '\p{Script=:\AOld_Turkic\z:}', "");;
    Expect(0, 68681, '\p{Script=:\AOld_Turkic\z:}', "");;
    Expect(1, 68680, '\p{Script=oldturkic}', "");
    Expect(0, 68680, '\p{^Script=oldturkic}', "");
    Expect(0, 68680, '\P{Script=oldturkic}', "");
    Expect(1, 68680, '\P{^Script=oldturkic}', "");
    Expect(0, 68681, '\p{Script=oldturkic}', "");
    Expect(1, 68681, '\p{^Script=oldturkic}', "");
    Expect(1, 68681, '\P{Script=oldturkic}', "");
    Expect(0, 68681, '\P{^Script=oldturkic}', "");
    Expect(1, 68680, '\p{Script=:\Aoldturkic\z:}', "");;
    Expect(0, 68681, '\p{Script=:\Aoldturkic\z:}', "");;
    Expect(1, 68680, '\p{Script=_-OLD_Turkic}', "");
    Expect(0, 68680, '\p{^Script=_-OLD_Turkic}', "");
    Expect(0, 68680, '\P{Script=_-OLD_Turkic}', "");
    Expect(1, 68680, '\P{^Script=_-OLD_Turkic}', "");
    Expect(0, 68681, '\p{Script=_-OLD_Turkic}', "");
    Expect(1, 68681, '\p{^Script=_-OLD_Turkic}', "");
    Expect(1, 68681, '\P{Script=_-OLD_Turkic}', "");
    Expect(0, 68681, '\P{^Script=_-OLD_Turkic}', "");
    Error('\p{Sc=:=_	ORKH}');
    Error('\P{Sc=:=_	ORKH}');
    Expect(1, 68680, '\p{Sc=:\AOrkh\z:}', "");;
    Expect(0, 68681, '\p{Sc=:\AOrkh\z:}', "");;
    Expect(1, 68680, '\p{Sc:   orkh}', "");
    Expect(0, 68680, '\p{^Sc:   orkh}', "");
    Expect(0, 68680, '\P{Sc:   orkh}', "");
    Expect(1, 68680, '\P{^Sc:   orkh}', "");
    Expect(0, 68681, '\p{Sc:   orkh}', "");
    Expect(1, 68681, '\p{^Sc:   orkh}', "");
    Expect(1, 68681, '\P{Sc:   orkh}', "");
    Expect(0, 68681, '\P{^Sc:   orkh}', "");
    Expect(1, 68680, '\p{Sc=:\Aorkh\z:}', "");;
    Expect(0, 68681, '\p{Sc=:\Aorkh\z:}', "");;
    Expect(1, 68680, '\p{Sc=ORKH}', "");
    Expect(0, 68680, '\p{^Sc=ORKH}', "");
    Expect(0, 68680, '\P{Sc=ORKH}', "");
    Expect(1, 68680, '\P{^Sc=ORKH}', "");
    Expect(0, 68681, '\p{Sc=ORKH}', "");
    Expect(1, 68681, '\p{^Sc=ORKH}', "");
    Expect(1, 68681, '\P{Sc=ORKH}', "");
    Expect(0, 68681, '\P{^Sc=ORKH}', "");
    Error('\p{Is_Script=/a/- Old_TURKIC}');
    Error('\P{Is_Script=/a/- Old_TURKIC}');
    Expect(1, 68680, '\p{Is_Script=oldturkic}', "");
    Expect(0, 68680, '\p{^Is_Script=oldturkic}', "");
    Expect(0, 68680, '\P{Is_Script=oldturkic}', "");
    Expect(1, 68680, '\P{^Is_Script=oldturkic}', "");
    Expect(0, 68681, '\p{Is_Script=oldturkic}', "");
    Expect(1, 68681, '\p{^Is_Script=oldturkic}', "");
    Expect(1, 68681, '\P{Is_Script=oldturkic}', "");
    Expect(0, 68681, '\P{^Is_Script=oldturkic}', "");
    Expect(1, 68680, '\p{Is_Script= Old_Turkic}', "");
    Expect(0, 68680, '\p{^Is_Script= Old_Turkic}', "");
    Expect(0, 68680, '\P{Is_Script= Old_Turkic}', "");
    Expect(1, 68680, '\P{^Is_Script= Old_Turkic}', "");
    Expect(0, 68681, '\p{Is_Script= Old_Turkic}', "");
    Expect(1, 68681, '\p{^Is_Script= Old_Turkic}', "");
    Expect(1, 68681, '\P{Is_Script= Old_Turkic}', "");
    Expect(0, 68681, '\P{^Is_Script= Old_Turkic}', "");
    Error('\p{Is_Sc= :=orkh}');
    Error('\P{Is_Sc= :=orkh}');
    Expect(1, 68680, '\p{Is_Sc=orkh}', "");
    Expect(0, 68680, '\p{^Is_Sc=orkh}', "");
    Expect(0, 68680, '\P{Is_Sc=orkh}', "");
    Expect(1, 68680, '\P{^Is_Sc=orkh}', "");
    Expect(0, 68681, '\p{Is_Sc=orkh}', "");
    Expect(1, 68681, '\p{^Is_Sc=orkh}', "");
    Expect(1, 68681, '\P{Is_Sc=orkh}', "");
    Expect(0, 68681, '\P{^Is_Sc=orkh}', "");
    Expect(1, 68680, '\p{Is_Sc=Orkh}', "");
    Expect(0, 68680, '\p{^Is_Sc=Orkh}', "");
    Expect(0, 68680, '\P{Is_Sc=Orkh}', "");
    Expect(1, 68680, '\P{^Is_Sc=Orkh}', "");
    Expect(0, 68681, '\p{Is_Sc=Orkh}', "");
    Expect(1, 68681, '\p{^Is_Sc=Orkh}', "");
    Expect(1, 68681, '\P{Is_Sc=Orkh}', "");
    Expect(0, 68681, '\P{^Is_Sc=Orkh}', "");
    Error('\p{Script:   /a/ -Oriya}');
    Error('\P{Script:   /a/ -Oriya}');
    Expect(1, 2935, '\p{Script=:\AOriya\z:}', "");;
    Expect(0, 2936, '\p{Script=:\AOriya\z:}', "");;
    Expect(1, 2935, '\p{Script=oriya}', "");
    Expect(0, 2935, '\p{^Script=oriya}', "");
    Expect(0, 2935, '\P{Script=oriya}', "");
    Expect(1, 2935, '\P{^Script=oriya}', "");
    Expect(0, 2936, '\p{Script=oriya}', "");
    Expect(1, 2936, '\p{^Script=oriya}', "");
    Expect(1, 2936, '\P{Script=oriya}', "");
    Expect(0, 2936, '\P{^Script=oriya}', "");
    Expect(1, 2935, '\p{Script=:\Aoriya\z:}', "");;
    Expect(0, 2936, '\p{Script=:\Aoriya\z:}', "");;
    Expect(1, 2935, '\p{Script=  ORIYA}', "");
    Expect(0, 2935, '\p{^Script=  ORIYA}', "");
    Expect(0, 2935, '\P{Script=  ORIYA}', "");
    Expect(1, 2935, '\P{^Script=  ORIYA}', "");
    Expect(0, 2936, '\p{Script=  ORIYA}', "");
    Expect(1, 2936, '\p{^Script=  ORIYA}', "");
    Expect(1, 2936, '\P{Script=  ORIYA}', "");
    Expect(0, 2936, '\P{^Script=  ORIYA}', "");
    Error('\p{Sc=	ORYA:=}');
    Error('\P{Sc=	ORYA:=}');
    Expect(1, 2935, '\p{Sc=:\AOrya\z:}', "");;
    Expect(0, 2936, '\p{Sc=:\AOrya\z:}', "");;
    Expect(1, 2935, '\p{Sc=orya}', "");
    Expect(0, 2935, '\p{^Sc=orya}', "");
    Expect(0, 2935, '\P{Sc=orya}', "");
    Expect(1, 2935, '\P{^Sc=orya}', "");
    Expect(0, 2936, '\p{Sc=orya}', "");
    Expect(1, 2936, '\p{^Sc=orya}', "");
    Expect(1, 2936, '\P{Sc=orya}', "");
    Expect(0, 2936, '\P{^Sc=orya}', "");
    Expect(1, 2935, '\p{Sc=:\Aorya\z:}', "");;
    Expect(0, 2936, '\p{Sc=:\Aorya\z:}', "");;
    Expect(1, 2935, '\p{Sc=-Orya}', "");
    Expect(0, 2935, '\p{^Sc=-Orya}', "");
    Expect(0, 2935, '\P{Sc=-Orya}', "");
    Expect(1, 2935, '\P{^Sc=-Orya}', "");
    Expect(0, 2936, '\p{Sc=-Orya}', "");
    Expect(1, 2936, '\p{^Sc=-Orya}', "");
    Expect(1, 2936, '\P{Sc=-Orya}', "");
    Expect(0, 2936, '\P{^Sc=-Orya}', "");
    Error('\p{Is_Script= /a/ORIYA}');
    Error('\P{Is_Script= /a/ORIYA}');
    Expect(1, 2935, '\p{Is_Script=oriya}', "");
    Expect(0, 2935, '\p{^Is_Script=oriya}', "");
    Expect(0, 2935, '\P{Is_Script=oriya}', "");
    Expect(1, 2935, '\P{^Is_Script=oriya}', "");
    Expect(0, 2936, '\p{Is_Script=oriya}', "");
    Expect(1, 2936, '\p{^Is_Script=oriya}', "");
    Expect(1, 2936, '\P{Is_Script=oriya}', "");
    Expect(0, 2936, '\P{^Is_Script=oriya}', "");
    Expect(1, 2935, '\p{Is_Script= Oriya}', "");
    Expect(0, 2935, '\p{^Is_Script= Oriya}', "");
    Expect(0, 2935, '\P{Is_Script= Oriya}', "");
    Expect(1, 2935, '\P{^Is_Script= Oriya}', "");
    Expect(0, 2936, '\p{Is_Script= Oriya}', "");
    Expect(1, 2936, '\p{^Is_Script= Oriya}', "");
    Expect(1, 2936, '\P{Is_Script= Oriya}', "");
    Expect(0, 2936, '\P{^Is_Script= Oriya}', "");
    Error('\p{Is_Sc=:=ORYA}');
    Error('\P{Is_Sc=:=ORYA}');
    Expect(1, 2935, '\p{Is_Sc=orya}', "");
    Expect(0, 2935, '\p{^Is_Sc=orya}', "");
    Expect(0, 2935, '\P{Is_Sc=orya}', "");
    Expect(1, 2935, '\P{^Is_Sc=orya}', "");
    Expect(0, 2936, '\p{Is_Sc=orya}', "");
    Expect(1, 2936, '\p{^Is_Sc=orya}', "");
    Expect(1, 2936, '\P{Is_Sc=orya}', "");
    Expect(0, 2936, '\P{^Is_Sc=orya}', "");
    Expect(1, 2935, '\p{Is_Sc=- ORYA}', "");
    Expect(0, 2935, '\p{^Is_Sc=- ORYA}', "");
    Expect(0, 2935, '\P{Is_Sc=- ORYA}', "");
    Expect(1, 2935, '\P{^Is_Sc=- ORYA}', "");
    Expect(0, 2936, '\p{Is_Sc=- ORYA}', "");
    Expect(1, 2936, '\p{^Is_Sc=- ORYA}', "");
    Expect(1, 2936, '\P{Is_Sc=- ORYA}', "");
    Expect(0, 2936, '\P{^Is_Sc=- ORYA}', "");
    Error('\p{Script=/a/Osage}');
    Error('\P{Script=/a/Osage}');
    Expect(1, 66811, '\p{Script=:\AOsage\z:}', "");;
    Expect(0, 66812, '\p{Script=:\AOsage\z:}', "");;
    Expect(1, 66811, '\p{Script=osage}', "");
    Expect(0, 66811, '\p{^Script=osage}', "");
    Expect(0, 66811, '\P{Script=osage}', "");
    Expect(1, 66811, '\P{^Script=osage}', "");
    Expect(0, 66812, '\p{Script=osage}', "");
    Expect(1, 66812, '\p{^Script=osage}', "");
    Expect(1, 66812, '\P{Script=osage}', "");
    Expect(0, 66812, '\P{^Script=osage}', "");
    Expect(1, 66811, '\p{Script=:\Aosage\z:}', "");;
    Expect(0, 66812, '\p{Script=:\Aosage\z:}', "");;
    Expect(1, 66811, '\p{Script= Osage}', "");
    Expect(0, 66811, '\p{^Script= Osage}', "");
    Expect(0, 66811, '\P{Script= Osage}', "");
    Expect(1, 66811, '\P{^Script= Osage}', "");
    Expect(0, 66812, '\p{Script= Osage}', "");
    Expect(1, 66812, '\p{^Script= Osage}', "");
    Expect(1, 66812, '\P{Script= Osage}', "");
    Expect(0, 66812, '\P{^Script= Osage}', "");
    Error('\p{Sc=-:=Osge}');
    Error('\P{Sc=-:=Osge}');
    Expect(1, 66811, '\p{Sc=:\AOsge\z:}', "");;
    Expect(0, 66812, '\p{Sc=:\AOsge\z:}', "");;
    Expect(1, 66811, '\p{Sc=osge}', "");
    Expect(0, 66811, '\p{^Sc=osge}', "");
    Expect(0, 66811, '\P{Sc=osge}', "");
    Expect(1, 66811, '\P{^Sc=osge}', "");
    Expect(0, 66812, '\p{Sc=osge}', "");
    Expect(1, 66812, '\p{^Sc=osge}', "");
    Expect(1, 66812, '\P{Sc=osge}', "");
    Expect(0, 66812, '\P{^Sc=osge}', "");
    Expect(1, 66811, '\p{Sc=:\Aosge\z:}', "");;
    Expect(0, 66812, '\p{Sc=:\Aosge\z:}', "");;
    Expect(1, 66811, '\p{Sc=Osge}', "");
    Expect(0, 66811, '\p{^Sc=Osge}', "");
    Expect(0, 66811, '\P{Sc=Osge}', "");
    Expect(1, 66811, '\P{^Sc=Osge}', "");
    Expect(0, 66812, '\p{Sc=Osge}', "");
    Expect(1, 66812, '\p{^Sc=Osge}', "");
    Expect(1, 66812, '\P{Sc=Osge}', "");
    Expect(0, 66812, '\P{^Sc=Osge}', "");
    Error('\p{Is_Script=/a/_Osage}');
    Error('\P{Is_Script=/a/_Osage}');
    Expect(1, 66811, '\p{Is_Script=osage}', "");
    Expect(0, 66811, '\p{^Is_Script=osage}', "");
    Expect(0, 66811, '\P{Is_Script=osage}', "");
    Expect(1, 66811, '\P{^Is_Script=osage}', "");
    Expect(0, 66812, '\p{Is_Script=osage}', "");
    Expect(1, 66812, '\p{^Is_Script=osage}', "");
    Expect(1, 66812, '\P{Is_Script=osage}', "");
    Expect(0, 66812, '\P{^Is_Script=osage}', "");
    Expect(1, 66811, '\p{Is_Script=_osage}', "");
    Expect(0, 66811, '\p{^Is_Script=_osage}', "");
    Expect(0, 66811, '\P{Is_Script=_osage}', "");
    Expect(1, 66811, '\P{^Is_Script=_osage}', "");
    Expect(0, 66812, '\p{Is_Script=_osage}', "");
    Expect(1, 66812, '\p{^Is_Script=_osage}', "");
    Expect(1, 66812, '\P{Is_Script=_osage}', "");
    Expect(0, 66812, '\P{^Is_Script=_osage}', "");
    Error('\p{Is_Sc=/a/ OSGE}');
    Error('\P{Is_Sc=/a/ OSGE}');
    Expect(1, 66811, '\p{Is_Sc=osge}', "");
    Expect(0, 66811, '\p{^Is_Sc=osge}', "");
    Expect(0, 66811, '\P{Is_Sc=osge}', "");
    Expect(1, 66811, '\P{^Is_Sc=osge}', "");
    Expect(0, 66812, '\p{Is_Sc=osge}', "");
    Expect(1, 66812, '\p{^Is_Sc=osge}', "");
    Expect(1, 66812, '\P{Is_Sc=osge}', "");
    Expect(0, 66812, '\P{^Is_Sc=osge}', "");
    Expect(1, 66811, '\p{Is_Sc=- OSGE}', "");
    Expect(0, 66811, '\p{^Is_Sc=- OSGE}', "");
    Expect(0, 66811, '\P{Is_Sc=- OSGE}', "");
    Expect(1, 66811, '\P{^Is_Sc=- OSGE}', "");
    Expect(0, 66812, '\p{Is_Sc=- OSGE}', "");
    Expect(1, 66812, '\p{^Is_Sc=- OSGE}', "");
    Expect(1, 66812, '\P{Is_Sc=- OSGE}', "");
    Expect(0, 66812, '\P{^Is_Sc=- OSGE}', "");
    Error('\p{Script=-OSMANYA:=}');
    Error('\P{Script=-OSMANYA:=}');
    Expect(1, 66729, '\p{Script=:\AOsmanya\z:}', "");;
    Expect(0, 66730, '\p{Script=:\AOsmanya\z:}', "");;
    Expect(1, 66729, '\p{Script: osmanya}', "");
    Expect(0, 66729, '\p{^Script: osmanya}', "");
    Expect(0, 66729, '\P{Script: osmanya}', "");
    Expect(1, 66729, '\P{^Script: osmanya}', "");
    Expect(0, 66730, '\p{Script: osmanya}', "");
    Expect(1, 66730, '\p{^Script: osmanya}', "");
    Expect(1, 66730, '\P{Script: osmanya}', "");
    Expect(0, 66730, '\P{^Script: osmanya}', "");
    Expect(1, 66729, '\p{Script=:\Aosmanya\z:}', "");;
    Expect(0, 66730, '\p{Script=:\Aosmanya\z:}', "");;
    Expect(1, 66729, '\p{Script=-	OSMANYA}', "");
    Expect(0, 66729, '\p{^Script=-	OSMANYA}', "");
    Expect(0, 66729, '\P{Script=-	OSMANYA}', "");
    Expect(1, 66729, '\P{^Script=-	OSMANYA}', "");
    Expect(0, 66730, '\p{Script=-	OSMANYA}', "");
    Expect(1, 66730, '\p{^Script=-	OSMANYA}', "");
    Expect(1, 66730, '\P{Script=-	OSMANYA}', "");
    Expect(0, 66730, '\P{^Script=-	OSMANYA}', "");
    Error('\p{Sc=		osma/a/}');
    Error('\P{Sc=		osma/a/}');
    Expect(1, 66729, '\p{Sc=:\AOsma\z:}', "");;
    Expect(0, 66730, '\p{Sc=:\AOsma\z:}', "");;
    Expect(1, 66729, '\p{Sc=osma}', "");
    Expect(0, 66729, '\p{^Sc=osma}', "");
    Expect(0, 66729, '\P{Sc=osma}', "");
    Expect(1, 66729, '\P{^Sc=osma}', "");
    Expect(0, 66730, '\p{Sc=osma}', "");
    Expect(1, 66730, '\p{^Sc=osma}', "");
    Expect(1, 66730, '\P{Sc=osma}', "");
    Expect(0, 66730, '\P{^Sc=osma}', "");
    Expect(1, 66729, '\p{Sc=:\Aosma\z:}', "");;
    Expect(0, 66730, '\p{Sc=:\Aosma\z:}', "");;
    Expect(1, 66729, '\p{Sc=  osma}', "");
    Expect(0, 66729, '\p{^Sc=  osma}', "");
    Expect(0, 66729, '\P{Sc=  osma}', "");
    Expect(1, 66729, '\P{^Sc=  osma}', "");
    Expect(0, 66730, '\p{Sc=  osma}', "");
    Expect(1, 66730, '\p{^Sc=  osma}', "");
    Expect(1, 66730, '\P{Sc=  osma}', "");
    Expect(0, 66730, '\P{^Sc=  osma}', "");
    Error('\p{Is_Script=/a/	_osmanya}');
    Error('\P{Is_Script=/a/	_osmanya}');
    Expect(1, 66729, '\p{Is_Script=osmanya}', "");
    Expect(0, 66729, '\p{^Is_Script=osmanya}', "");
    Expect(0, 66729, '\P{Is_Script=osmanya}', "");
    Expect(1, 66729, '\P{^Is_Script=osmanya}', "");
    Expect(0, 66730, '\p{Is_Script=osmanya}', "");
    Expect(1, 66730, '\p{^Is_Script=osmanya}', "");
    Expect(1, 66730, '\P{Is_Script=osmanya}', "");
    Expect(0, 66730, '\P{^Is_Script=osmanya}', "");
    Expect(1, 66729, '\p{Is_Script=- osmanya}', "");
    Expect(0, 66729, '\p{^Is_Script=- osmanya}', "");
    Expect(0, 66729, '\P{Is_Script=- osmanya}', "");
    Expect(1, 66729, '\P{^Is_Script=- osmanya}', "");
    Expect(0, 66730, '\p{Is_Script=- osmanya}', "");
    Expect(1, 66730, '\p{^Is_Script=- osmanya}', "");
    Expect(1, 66730, '\P{Is_Script=- osmanya}', "");
    Expect(0, 66730, '\P{^Is_Script=- osmanya}', "");
    Error('\p{Is_Sc=_/a/osma}');
    Error('\P{Is_Sc=_/a/osma}');
    Expect(1, 66729, '\p{Is_Sc=osma}', "");
    Expect(0, 66729, '\p{^Is_Sc=osma}', "");
    Expect(0, 66729, '\P{Is_Sc=osma}', "");
    Expect(1, 66729, '\P{^Is_Sc=osma}', "");
    Expect(0, 66730, '\p{Is_Sc=osma}', "");
    Expect(1, 66730, '\p{^Is_Sc=osma}', "");
    Expect(1, 66730, '\P{Is_Sc=osma}', "");
    Expect(0, 66730, '\P{^Is_Sc=osma}', "");
    Expect(1, 66729, '\p{Is_Sc=-	Osma}', "");
    Expect(0, 66729, '\p{^Is_Sc=-	Osma}', "");
    Expect(0, 66729, '\P{Is_Sc=-	Osma}', "");
    Expect(1, 66729, '\P{^Is_Sc=-	Osma}', "");
    Expect(0, 66730, '\p{Is_Sc=-	Osma}', "");
    Expect(1, 66730, '\p{^Is_Sc=-	Osma}', "");
    Expect(1, 66730, '\P{Is_Sc=-	Osma}', "");
    Expect(0, 66730, '\P{^Is_Sc=-	Osma}', "");
    Error('\p{Script=-:=palmyrene}');
    Error('\P{Script=-:=palmyrene}');
    Expect(1, 67711, '\p{Script=:\APalmyrene\z:}', "");;
    Expect(0, 67712, '\p{Script=:\APalmyrene\z:}', "");;
    Expect(1, 67711, '\p{Script=palmyrene}', "");
    Expect(0, 67711, '\p{^Script=palmyrene}', "");
    Expect(0, 67711, '\P{Script=palmyrene}', "");
    Expect(1, 67711, '\P{^Script=palmyrene}', "");
    Expect(0, 67712, '\p{Script=palmyrene}', "");
    Expect(1, 67712, '\p{^Script=palmyrene}', "");
    Expect(1, 67712, '\P{Script=palmyrene}', "");
    Expect(0, 67712, '\P{^Script=palmyrene}', "");
    Expect(1, 67711, '\p{Script=:\Apalmyrene\z:}', "");;
    Expect(0, 67712, '\p{Script=:\Apalmyrene\z:}', "");;
    Expect(1, 67711, '\p{Script=_ PALMYRENE}', "");
    Expect(0, 67711, '\p{^Script=_ PALMYRENE}', "");
    Expect(0, 67711, '\P{Script=_ PALMYRENE}', "");
    Expect(1, 67711, '\P{^Script=_ PALMYRENE}', "");
    Expect(0, 67712, '\p{Script=_ PALMYRENE}', "");
    Expect(1, 67712, '\p{^Script=_ PALMYRENE}', "");
    Expect(1, 67712, '\P{Script=_ PALMYRENE}', "");
    Expect(0, 67712, '\P{^Script=_ PALMYRENE}', "");
    Error('\p{Sc=/a/PALM}');
    Error('\P{Sc=/a/PALM}');
    Expect(1, 67711, '\p{Sc=:\APalm\z:}', "");;
    Expect(0, 67712, '\p{Sc=:\APalm\z:}', "");;
    Expect(1, 67711, '\p{Sc=palm}', "");
    Expect(0, 67711, '\p{^Sc=palm}', "");
    Expect(0, 67711, '\P{Sc=palm}', "");
    Expect(1, 67711, '\P{^Sc=palm}', "");
    Expect(0, 67712, '\p{Sc=palm}', "");
    Expect(1, 67712, '\p{^Sc=palm}', "");
    Expect(1, 67712, '\P{Sc=palm}', "");
    Expect(0, 67712, '\P{^Sc=palm}', "");
    Expect(1, 67711, '\p{Sc=:\Apalm\z:}', "");;
    Expect(0, 67712, '\p{Sc=:\Apalm\z:}', "");;
    Expect(1, 67711, '\p{Sc=	 Palm}', "");
    Expect(0, 67711, '\p{^Sc=	 Palm}', "");
    Expect(0, 67711, '\P{Sc=	 Palm}', "");
    Expect(1, 67711, '\P{^Sc=	 Palm}', "");
    Expect(0, 67712, '\p{Sc=	 Palm}', "");
    Expect(1, 67712, '\p{^Sc=	 Palm}', "");
    Expect(1, 67712, '\P{Sc=	 Palm}', "");
    Expect(0, 67712, '\P{^Sc=	 Palm}', "");
    Error('\p{Is_Script:	:=_	Palmyrene}');
    Error('\P{Is_Script:	:=_	Palmyrene}');
    Expect(1, 67711, '\p{Is_Script=palmyrene}', "");
    Expect(0, 67711, '\p{^Is_Script=palmyrene}', "");
    Expect(0, 67711, '\P{Is_Script=palmyrene}', "");
    Expect(1, 67711, '\P{^Is_Script=palmyrene}', "");
    Expect(0, 67712, '\p{Is_Script=palmyrene}', "");
    Expect(1, 67712, '\p{^Is_Script=palmyrene}', "");
    Expect(1, 67712, '\P{Is_Script=palmyrene}', "");
    Expect(0, 67712, '\P{^Is_Script=palmyrene}', "");
    Expect(1, 67711, '\p{Is_Script= PALMYRENE}', "");
    Expect(0, 67711, '\p{^Is_Script= PALMYRENE}', "");
    Expect(0, 67711, '\P{Is_Script= PALMYRENE}', "");
    Expect(1, 67711, '\P{^Is_Script= PALMYRENE}', "");
    Expect(0, 67712, '\p{Is_Script= PALMYRENE}', "");
    Expect(1, 67712, '\p{^Is_Script= PALMYRENE}', "");
    Expect(1, 67712, '\P{Is_Script= PALMYRENE}', "");
    Expect(0, 67712, '\P{^Is_Script= PALMYRENE}', "");
    Error('\p{Is_Sc=-	Palm/a/}');
    Error('\P{Is_Sc=-	Palm/a/}');
    Expect(1, 67711, '\p{Is_Sc=palm}', "");
    Expect(0, 67711, '\p{^Is_Sc=palm}', "");
    Expect(0, 67711, '\P{Is_Sc=palm}', "");
    Expect(1, 67711, '\P{^Is_Sc=palm}', "");
    Expect(0, 67712, '\p{Is_Sc=palm}', "");
    Expect(1, 67712, '\p{^Is_Sc=palm}', "");
    Expect(1, 67712, '\P{Is_Sc=palm}', "");
    Expect(0, 67712, '\P{^Is_Sc=palm}', "");
    Expect(1, 67711, '\p{Is_Sc=_-PALM}', "");
    Expect(0, 67711, '\p{^Is_Sc=_-PALM}', "");
    Expect(0, 67711, '\P{Is_Sc=_-PALM}', "");
    Expect(1, 67711, '\P{^Is_Sc=_-PALM}', "");
    Expect(0, 67712, '\p{Is_Sc=_-PALM}', "");
    Expect(1, 67712, '\p{^Is_Sc=_-PALM}', "");
    Expect(1, 67712, '\P{Is_Sc=_-PALM}', "");
    Expect(0, 67712, '\P{^Is_Sc=_-PALM}', "");
    Error('\p{Script=_	PAU_Cin_HAU/a/}');
    Error('\P{Script=_	PAU_Cin_HAU/a/}');
    Expect(1, 72440, '\p{Script=:\APau_Cin_Hau\z:}', "");;
    Expect(0, 72441, '\p{Script=:\APau_Cin_Hau\z:}', "");;
    Expect(1, 72440, '\p{Script=paucinhau}', "");
    Expect(0, 72440, '\p{^Script=paucinhau}', "");
    Expect(0, 72440, '\P{Script=paucinhau}', "");
    Expect(1, 72440, '\P{^Script=paucinhau}', "");
    Expect(0, 72441, '\p{Script=paucinhau}', "");
    Expect(1, 72441, '\p{^Script=paucinhau}', "");
    Expect(1, 72441, '\P{Script=paucinhau}', "");
    Expect(0, 72441, '\P{^Script=paucinhau}', "");
    Expect(1, 72440, '\p{Script=:\Apaucinhau\z:}', "");;
    Expect(0, 72441, '\p{Script=:\Apaucinhau\z:}', "");;
    Expect(1, 72440, '\p{Script=	pau_CIN_HAU}', "");
    Expect(0, 72440, '\p{^Script=	pau_CIN_HAU}', "");
    Expect(0, 72440, '\P{Script=	pau_CIN_HAU}', "");
    Expect(1, 72440, '\P{^Script=	pau_CIN_HAU}', "");
    Expect(0, 72441, '\p{Script=	pau_CIN_HAU}', "");
    Expect(1, 72441, '\p{^Script=	pau_CIN_HAU}', "");
    Expect(1, 72441, '\P{Script=	pau_CIN_HAU}', "");
    Expect(0, 72441, '\P{^Script=	pau_CIN_HAU}', "");
    Error('\p{Sc=:=-	Pauc}');
    Error('\P{Sc=:=-	Pauc}');
    Expect(1, 72440, '\p{Sc=:\APauc\z:}', "");;
    Expect(0, 72441, '\p{Sc=:\APauc\z:}', "");;
    Expect(1, 72440, '\p{Sc=pauc}', "");
    Expect(0, 72440, '\p{^Sc=pauc}', "");
    Expect(0, 72440, '\P{Sc=pauc}', "");
    Expect(1, 72440, '\P{^Sc=pauc}', "");
    Expect(0, 72441, '\p{Sc=pauc}', "");
    Expect(1, 72441, '\p{^Sc=pauc}', "");
    Expect(1, 72441, '\P{Sc=pauc}', "");
    Expect(0, 72441, '\P{^Sc=pauc}', "");
    Expect(1, 72440, '\p{Sc=:\Apauc\z:}', "");;
    Expect(0, 72441, '\p{Sc=:\Apauc\z:}', "");;
    Expect(1, 72440, '\p{Sc=__pauc}', "");
    Expect(0, 72440, '\p{^Sc=__pauc}', "");
    Expect(0, 72440, '\P{Sc=__pauc}', "");
    Expect(1, 72440, '\P{^Sc=__pauc}', "");
    Expect(0, 72441, '\p{Sc=__pauc}', "");
    Expect(1, 72441, '\p{^Sc=__pauc}', "");
    Expect(1, 72441, '\P{Sc=__pauc}', "");
    Expect(0, 72441, '\P{^Sc=__pauc}', "");
    Error('\p{Is_Script=--PAU_Cin_Hau:=}');
    Error('\P{Is_Script=--PAU_Cin_Hau:=}');
    Expect(1, 72440, '\p{Is_Script=paucinhau}', "");
    Expect(0, 72440, '\p{^Is_Script=paucinhau}', "");
    Expect(0, 72440, '\P{Is_Script=paucinhau}', "");
    Expect(1, 72440, '\P{^Is_Script=paucinhau}', "");
    Expect(0, 72441, '\p{Is_Script=paucinhau}', "");
    Expect(1, 72441, '\p{^Is_Script=paucinhau}', "");
    Expect(1, 72441, '\P{Is_Script=paucinhau}', "");
    Expect(0, 72441, '\P{^Is_Script=paucinhau}', "");
    Expect(1, 72440, '\p{Is_Script=_-Pau_cin_Hau}', "");
    Expect(0, 72440, '\p{^Is_Script=_-Pau_cin_Hau}', "");
    Expect(0, 72440, '\P{Is_Script=_-Pau_cin_Hau}', "");
    Expect(1, 72440, '\P{^Is_Script=_-Pau_cin_Hau}', "");
    Expect(0, 72441, '\p{Is_Script=_-Pau_cin_Hau}', "");
    Expect(1, 72441, '\p{^Is_Script=_-Pau_cin_Hau}', "");
    Expect(1, 72441, '\P{Is_Script=_-Pau_cin_Hau}', "");
    Expect(0, 72441, '\P{^Is_Script=_-Pau_cin_Hau}', "");
    Error('\p{Is_Sc=:= _PAUC}');
    Error('\P{Is_Sc=:= _PAUC}');
    Expect(1, 72440, '\p{Is_Sc=pauc}', "");
    Expect(0, 72440, '\p{^Is_Sc=pauc}', "");
    Expect(0, 72440, '\P{Is_Sc=pauc}', "");
    Expect(1, 72440, '\P{^Is_Sc=pauc}', "");
    Expect(0, 72441, '\p{Is_Sc=pauc}', "");
    Expect(1, 72441, '\p{^Is_Sc=pauc}', "");
    Expect(1, 72441, '\P{Is_Sc=pauc}', "");
    Expect(0, 72441, '\P{^Is_Sc=pauc}', "");
    Expect(1, 72440, '\p{Is_Sc=	 Pauc}', "");
    Expect(0, 72440, '\p{^Is_Sc=	 Pauc}', "");
    Expect(0, 72440, '\P{Is_Sc=	 Pauc}', "");
    Expect(1, 72440, '\P{^Is_Sc=	 Pauc}', "");
    Expect(0, 72441, '\p{Is_Sc=	 Pauc}', "");
    Expect(1, 72441, '\p{^Is_Sc=	 Pauc}', "");
    Expect(1, 72441, '\P{Is_Sc=	 Pauc}', "");
    Expect(0, 72441, '\P{^Is_Sc=	 Pauc}', "");
    Error('\p{Script=:=	old_PERMIC}');
    Error('\P{Script=:=	old_PERMIC}');
    Expect(1, 66426, '\p{Script=:\AOld_Permic\z:}', "");;
    Expect(0, 66427, '\p{Script=:\AOld_Permic\z:}', "");;
    Expect(1, 66426, '\p{Script=oldpermic}', "");
    Expect(0, 66426, '\p{^Script=oldpermic}', "");
    Expect(0, 66426, '\P{Script=oldpermic}', "");
    Expect(1, 66426, '\P{^Script=oldpermic}', "");
    Expect(0, 66427, '\p{Script=oldpermic}', "");
    Expect(1, 66427, '\p{^Script=oldpermic}', "");
    Expect(1, 66427, '\P{Script=oldpermic}', "");
    Expect(0, 66427, '\P{^Script=oldpermic}', "");
    Expect(1, 66426, '\p{Script=:\Aoldpermic\z:}', "");;
    Expect(0, 66427, '\p{Script=:\Aoldpermic\z:}', "");;
    Expect(1, 66426, '\p{Script=	Old_Permic}', "");
    Expect(0, 66426, '\p{^Script=	Old_Permic}', "");
    Expect(0, 66426, '\P{Script=	Old_Permic}', "");
    Expect(1, 66426, '\P{^Script=	Old_Permic}', "");
    Expect(0, 66427, '\p{Script=	Old_Permic}', "");
    Expect(1, 66427, '\p{^Script=	Old_Permic}', "");
    Expect(1, 66427, '\P{Script=	Old_Permic}', "");
    Expect(0, 66427, '\P{^Script=	Old_Permic}', "");
    Error('\p{Sc=-_Perm/a/}');
    Error('\P{Sc=-_Perm/a/}');
    Expect(1, 66426, '\p{Sc=:\APerm\z:}', "");;
    Expect(0, 66427, '\p{Sc=:\APerm\z:}', "");;
    Expect(1, 66426, '\p{Sc=perm}', "");
    Expect(0, 66426, '\p{^Sc=perm}', "");
    Expect(0, 66426, '\P{Sc=perm}', "");
    Expect(1, 66426, '\P{^Sc=perm}', "");
    Expect(0, 66427, '\p{Sc=perm}', "");
    Expect(1, 66427, '\p{^Sc=perm}', "");
    Expect(1, 66427, '\P{Sc=perm}', "");
    Expect(0, 66427, '\P{^Sc=perm}', "");
    Expect(1, 66426, '\p{Sc=:\Aperm\z:}', "");;
    Expect(0, 66427, '\p{Sc=:\Aperm\z:}', "");;
    Expect(1, 66426, '\p{Sc:		Perm}', "");
    Expect(0, 66426, '\p{^Sc:		Perm}', "");
    Expect(0, 66426, '\P{Sc:		Perm}', "");
    Expect(1, 66426, '\P{^Sc:		Perm}', "");
    Expect(0, 66427, '\p{Sc:		Perm}', "");
    Expect(1, 66427, '\p{^Sc:		Perm}', "");
    Expect(1, 66427, '\P{Sc:		Perm}', "");
    Expect(0, 66427, '\P{^Sc:		Perm}', "");
    Error('\p{Is_Script= Old_Permic/a/}');
    Error('\P{Is_Script= Old_Permic/a/}');
    Expect(1, 66426, '\p{Is_Script=oldpermic}', "");
    Expect(0, 66426, '\p{^Is_Script=oldpermic}', "");
    Expect(0, 66426, '\P{Is_Script=oldpermic}', "");
    Expect(1, 66426, '\P{^Is_Script=oldpermic}', "");
    Expect(0, 66427, '\p{Is_Script=oldpermic}', "");
    Expect(1, 66427, '\p{^Is_Script=oldpermic}', "");
    Expect(1, 66427, '\P{Is_Script=oldpermic}', "");
    Expect(0, 66427, '\P{^Is_Script=oldpermic}', "");
    Expect(1, 66426, '\p{Is_Script=	Old_permic}', "");
    Expect(0, 66426, '\p{^Is_Script=	Old_permic}', "");
    Expect(0, 66426, '\P{Is_Script=	Old_permic}', "");
    Expect(1, 66426, '\P{^Is_Script=	Old_permic}', "");
    Expect(0, 66427, '\p{Is_Script=	Old_permic}', "");
    Expect(1, 66427, '\p{^Is_Script=	Old_permic}', "");
    Expect(1, 66427, '\P{Is_Script=	Old_permic}', "");
    Expect(0, 66427, '\P{^Is_Script=	Old_permic}', "");
    Error('\p{Is_Sc= :=PERM}');
    Error('\P{Is_Sc= :=PERM}');
    Expect(1, 66426, '\p{Is_Sc=perm}', "");
    Expect(0, 66426, '\p{^Is_Sc=perm}', "");
    Expect(0, 66426, '\P{Is_Sc=perm}', "");
    Expect(1, 66426, '\P{^Is_Sc=perm}', "");
    Expect(0, 66427, '\p{Is_Sc=perm}', "");
    Expect(1, 66427, '\p{^Is_Sc=perm}', "");
    Expect(1, 66427, '\P{Is_Sc=perm}', "");
    Expect(0, 66427, '\P{^Is_Sc=perm}', "");
    Expect(1, 66426, '\p{Is_Sc=--Perm}', "");
    Expect(0, 66426, '\p{^Is_Sc=--Perm}', "");
    Expect(0, 66426, '\P{Is_Sc=--Perm}', "");
    Expect(1, 66426, '\P{^Is_Sc=--Perm}', "");
    Expect(0, 66427, '\p{Is_Sc=--Perm}', "");
    Expect(1, 66427, '\p{^Is_Sc=--Perm}', "");
    Expect(1, 66427, '\P{Is_Sc=--Perm}', "");
    Expect(0, 66427, '\P{^Is_Sc=--Perm}', "");
    Error('\p{Script=/a/	-Phags_Pa}');
    Error('\P{Script=/a/	-Phags_Pa}');
    Expect(1, 43127, '\p{Script=:\APhags_Pa\z:}', "");;
    Expect(0, 43128, '\p{Script=:\APhags_Pa\z:}', "");;
    Expect(1, 43127, '\p{Script=phagspa}', "");
    Expect(0, 43127, '\p{^Script=phagspa}', "");
    Expect(0, 43127, '\P{Script=phagspa}', "");
    Expect(1, 43127, '\P{^Script=phagspa}', "");
    Expect(0, 43128, '\p{Script=phagspa}', "");
    Expect(1, 43128, '\p{^Script=phagspa}', "");
    Expect(1, 43128, '\P{Script=phagspa}', "");
    Expect(0, 43128, '\P{^Script=phagspa}', "");
    Expect(1, 43127, '\p{Script=:\Aphagspa\z:}', "");;
    Expect(0, 43128, '\p{Script=:\Aphagspa\z:}', "");;
    Expect(1, 43127, '\p{Script=_phags_pa}', "");
    Expect(0, 43127, '\p{^Script=_phags_pa}', "");
    Expect(0, 43127, '\P{Script=_phags_pa}', "");
    Expect(1, 43127, '\P{^Script=_phags_pa}', "");
    Expect(0, 43128, '\p{Script=_phags_pa}', "");
    Expect(1, 43128, '\p{^Script=_phags_pa}', "");
    Expect(1, 43128, '\P{Script=_phags_pa}', "");
    Expect(0, 43128, '\P{^Script=_phags_pa}', "");
    Error('\p{Sc: /a/PHAG}');
    Error('\P{Sc: /a/PHAG}');
    Expect(1, 43127, '\p{Sc=:\APhag\z:}', "");;
    Expect(0, 43128, '\p{Sc=:\APhag\z:}', "");;
    Expect(1, 43127, '\p{Sc=phag}', "");
    Expect(0, 43127, '\p{^Sc=phag}', "");
    Expect(0, 43127, '\P{Sc=phag}', "");
    Expect(1, 43127, '\P{^Sc=phag}', "");
    Expect(0, 43128, '\p{Sc=phag}', "");
    Expect(1, 43128, '\p{^Sc=phag}', "");
    Expect(1, 43128, '\P{Sc=phag}', "");
    Expect(0, 43128, '\P{^Sc=phag}', "");
    Expect(1, 43127, '\p{Sc=:\Aphag\z:}', "");;
    Expect(0, 43128, '\p{Sc=:\Aphag\z:}', "");;
    Expect(1, 43127, '\p{Sc= PHAG}', "");
    Expect(0, 43127, '\p{^Sc= PHAG}', "");
    Expect(0, 43127, '\P{Sc= PHAG}', "");
    Expect(1, 43127, '\P{^Sc= PHAG}', "");
    Expect(0, 43128, '\p{Sc= PHAG}', "");
    Expect(1, 43128, '\p{^Sc= PHAG}', "");
    Expect(1, 43128, '\P{Sc= PHAG}', "");
    Expect(0, 43128, '\P{^Sc= PHAG}', "");
    Error('\p{Is_Script=_ Phags_Pa/a/}');
    Error('\P{Is_Script=_ Phags_Pa/a/}');
    Expect(1, 43127, '\p{Is_Script:phagspa}', "");
    Expect(0, 43127, '\p{^Is_Script:phagspa}', "");
    Expect(0, 43127, '\P{Is_Script:phagspa}', "");
    Expect(1, 43127, '\P{^Is_Script:phagspa}', "");
    Expect(0, 43128, '\p{Is_Script:phagspa}', "");
    Expect(1, 43128, '\p{^Is_Script:phagspa}', "");
    Expect(1, 43128, '\P{Is_Script:phagspa}', "");
    Expect(0, 43128, '\P{^Is_Script:phagspa}', "");
    Expect(1, 43127, '\p{Is_Script=phags_Pa}', "");
    Expect(0, 43127, '\p{^Is_Script=phags_Pa}', "");
    Expect(0, 43127, '\P{Is_Script=phags_Pa}', "");
    Expect(1, 43127, '\P{^Is_Script=phags_Pa}', "");
    Expect(0, 43128, '\p{Is_Script=phags_Pa}', "");
    Expect(1, 43128, '\p{^Is_Script=phags_Pa}', "");
    Expect(1, 43128, '\P{Is_Script=phags_Pa}', "");
    Expect(0, 43128, '\P{^Is_Script=phags_Pa}', "");
    Error('\p{Is_Sc=_/a/phag}');
    Error('\P{Is_Sc=_/a/phag}');
    Expect(1, 43127, '\p{Is_Sc=phag}', "");
    Expect(0, 43127, '\p{^Is_Sc=phag}', "");
    Expect(0, 43127, '\P{Is_Sc=phag}', "");
    Expect(1, 43127, '\P{^Is_Sc=phag}', "");
    Expect(0, 43128, '\p{Is_Sc=phag}', "");
    Expect(1, 43128, '\p{^Is_Sc=phag}', "");
    Expect(1, 43128, '\P{Is_Sc=phag}', "");
    Expect(0, 43128, '\P{^Is_Sc=phag}', "");
    Expect(1, 43127, '\p{Is_Sc=	 PHAG}', "");
    Expect(0, 43127, '\p{^Is_Sc=	 PHAG}', "");
    Expect(0, 43127, '\P{Is_Sc=	 PHAG}', "");
    Expect(1, 43127, '\P{^Is_Sc=	 PHAG}', "");
    Expect(0, 43128, '\p{Is_Sc=	 PHAG}', "");
    Expect(1, 43128, '\p{^Is_Sc=	 PHAG}', "");
    Expect(1, 43128, '\P{Is_Sc=	 PHAG}', "");
    Expect(0, 43128, '\P{^Is_Sc=	 PHAG}', "");
    Error('\p{Script=_	Inscriptional_Pahlavi/a/}');
    Error('\P{Script=_	Inscriptional_Pahlavi/a/}');
    Expect(1, 68479, '\p{Script=:\AInscriptional_Pahlavi\z:}', "");;
    Expect(0, 68480, '\p{Script=:\AInscriptional_Pahlavi\z:}', "");;
    Expect(1, 68479, '\p{Script=inscriptionalpahlavi}', "");
    Expect(0, 68479, '\p{^Script=inscriptionalpahlavi}', "");
    Expect(0, 68479, '\P{Script=inscriptionalpahlavi}', "");
    Expect(1, 68479, '\P{^Script=inscriptionalpahlavi}', "");
    Expect(0, 68480, '\p{Script=inscriptionalpahlavi}', "");
    Expect(1, 68480, '\p{^Script=inscriptionalpahlavi}', "");
    Expect(1, 68480, '\P{Script=inscriptionalpahlavi}', "");
    Expect(0, 68480, '\P{^Script=inscriptionalpahlavi}', "");
    Expect(1, 68479, '\p{Script=:\Ainscriptionalpahlavi\z:}', "");;
    Expect(0, 68480, '\p{Script=:\Ainscriptionalpahlavi\z:}', "");;
    Expect(1, 68479, '\p{Script=Inscriptional_pahlavi}', "");
    Expect(0, 68479, '\p{^Script=Inscriptional_pahlavi}', "");
    Expect(0, 68479, '\P{Script=Inscriptional_pahlavi}', "");
    Expect(1, 68479, '\P{^Script=Inscriptional_pahlavi}', "");
    Expect(0, 68480, '\p{Script=Inscriptional_pahlavi}', "");
    Expect(1, 68480, '\p{^Script=Inscriptional_pahlavi}', "");
    Expect(1, 68480, '\P{Script=Inscriptional_pahlavi}', "");
    Expect(0, 68480, '\P{^Script=Inscriptional_pahlavi}', "");
    Error('\p{Sc=/a/phli}');
    Error('\P{Sc=/a/phli}');
    Expect(1, 68479, '\p{Sc=:\APhli\z:}', "");;
    Expect(0, 68480, '\p{Sc=:\APhli\z:}', "");;
    Expect(1, 68479, '\p{Sc=phli}', "");
    Expect(0, 68479, '\p{^Sc=phli}', "");
    Expect(0, 68479, '\P{Sc=phli}', "");
    Expect(1, 68479, '\P{^Sc=phli}', "");
    Expect(0, 68480, '\p{Sc=phli}', "");
    Expect(1, 68480, '\p{^Sc=phli}', "");
    Expect(1, 68480, '\P{Sc=phli}', "");
    Expect(0, 68480, '\P{^Sc=phli}', "");
    Expect(1, 68479, '\p{Sc=:\Aphli\z:}', "");;
    Expect(0, 68480, '\p{Sc=:\Aphli\z:}', "");;
    Expect(1, 68479, '\p{Sc= PHLI}', "");
    Expect(0, 68479, '\p{^Sc= PHLI}', "");
    Expect(0, 68479, '\P{Sc= PHLI}', "");
    Expect(1, 68479, '\P{^Sc= PHLI}', "");
    Expect(0, 68480, '\p{Sc= PHLI}', "");
    Expect(1, 68480, '\p{^Sc= PHLI}', "");
    Expect(1, 68480, '\P{Sc= PHLI}', "");
    Expect(0, 68480, '\P{^Sc= PHLI}', "");
    Error('\p{Is_Script=:= _inscriptional_Pahlavi}');
    Error('\P{Is_Script=:= _inscriptional_Pahlavi}');
    Expect(1, 68479, '\p{Is_Script=inscriptionalpahlavi}', "");
    Expect(0, 68479, '\p{^Is_Script=inscriptionalpahlavi}', "");
    Expect(0, 68479, '\P{Is_Script=inscriptionalpahlavi}', "");
    Expect(1, 68479, '\P{^Is_Script=inscriptionalpahlavi}', "");
    Expect(0, 68480, '\p{Is_Script=inscriptionalpahlavi}', "");
    Expect(1, 68480, '\p{^Is_Script=inscriptionalpahlavi}', "");
    Expect(1, 68480, '\P{Is_Script=inscriptionalpahlavi}', "");
    Expect(0, 68480, '\P{^Is_Script=inscriptionalpahlavi}', "");
    Expect(1, 68479, '\p{Is_Script= -inscriptional_PAHLAVI}', "");
    Expect(0, 68479, '\p{^Is_Script= -inscriptional_PAHLAVI}', "");
    Expect(0, 68479, '\P{Is_Script= -inscriptional_PAHLAVI}', "");
    Expect(1, 68479, '\P{^Is_Script= -inscriptional_PAHLAVI}', "");
    Expect(0, 68480, '\p{Is_Script= -inscriptional_PAHLAVI}', "");
    Expect(1, 68480, '\p{^Is_Script= -inscriptional_PAHLAVI}', "");
    Expect(1, 68480, '\P{Is_Script= -inscriptional_PAHLAVI}', "");
    Expect(0, 68480, '\P{^Is_Script= -inscriptional_PAHLAVI}', "");
    Error('\p{Is_Sc=:= -Phli}');
    Error('\P{Is_Sc=:= -Phli}');
    Expect(1, 68479, '\p{Is_Sc=phli}', "");
    Expect(0, 68479, '\p{^Is_Sc=phli}', "");
    Expect(0, 68479, '\P{Is_Sc=phli}', "");
    Expect(1, 68479, '\P{^Is_Sc=phli}', "");
    Expect(0, 68480, '\p{Is_Sc=phli}', "");
    Expect(1, 68480, '\p{^Is_Sc=phli}', "");
    Expect(1, 68480, '\P{Is_Sc=phli}', "");
    Expect(0, 68480, '\P{^Is_Sc=phli}', "");
    Expect(1, 68479, '\p{Is_Sc=  Phli}', "");
    Expect(0, 68479, '\p{^Is_Sc=  Phli}', "");
    Expect(0, 68479, '\P{Is_Sc=  Phli}', "");
    Expect(1, 68479, '\P{^Is_Sc=  Phli}', "");
    Expect(0, 68480, '\p{Is_Sc=  Phli}', "");
    Expect(1, 68480, '\p{^Is_Sc=  Phli}', "");
    Expect(1, 68480, '\P{Is_Sc=  Phli}', "");
    Expect(0, 68480, '\P{^Is_Sc=  Phli}', "");
    Error('\p{Script=_	psalter_Pahlavi/a/}');
    Error('\P{Script=_	psalter_Pahlavi/a/}');
    Expect(1, 68527, '\p{Script=:\APsalter_Pahlavi\z:}', "");;
    Expect(0, 68528, '\p{Script=:\APsalter_Pahlavi\z:}', "");;
    Expect(1, 68527, '\p{Script=psalterpahlavi}', "");
    Expect(0, 68527, '\p{^Script=psalterpahlavi}', "");
    Expect(0, 68527, '\P{Script=psalterpahlavi}', "");
    Expect(1, 68527, '\P{^Script=psalterpahlavi}', "");
    Expect(0, 68528, '\p{Script=psalterpahlavi}', "");
    Expect(1, 68528, '\p{^Script=psalterpahlavi}', "");
    Expect(1, 68528, '\P{Script=psalterpahlavi}', "");
    Expect(0, 68528, '\P{^Script=psalterpahlavi}', "");
    Expect(1, 68527, '\p{Script=:\Apsalterpahlavi\z:}', "");;
    Expect(0, 68528, '\p{Script=:\Apsalterpahlavi\z:}', "");;
    Expect(1, 68527, '\p{Script=	_Psalter_PAHLAVI}', "");
    Expect(0, 68527, '\p{^Script=	_Psalter_PAHLAVI}', "");
    Expect(0, 68527, '\P{Script=	_Psalter_PAHLAVI}', "");
    Expect(1, 68527, '\P{^Script=	_Psalter_PAHLAVI}', "");
    Expect(0, 68528, '\p{Script=	_Psalter_PAHLAVI}', "");
    Expect(1, 68528, '\p{^Script=	_Psalter_PAHLAVI}', "");
    Expect(1, 68528, '\P{Script=	_Psalter_PAHLAVI}', "");
    Expect(0, 68528, '\P{^Script=	_Psalter_PAHLAVI}', "");
    Error('\p{Sc=	Phlp:=}');
    Error('\P{Sc=	Phlp:=}');
    Expect(1, 68527, '\p{Sc=:\APhlp\z:}', "");;
    Expect(0, 68528, '\p{Sc=:\APhlp\z:}', "");;
    Expect(1, 68527, '\p{Sc=phlp}', "");
    Expect(0, 68527, '\p{^Sc=phlp}', "");
    Expect(0, 68527, '\P{Sc=phlp}', "");
    Expect(1, 68527, '\P{^Sc=phlp}', "");
    Expect(0, 68528, '\p{Sc=phlp}', "");
    Expect(1, 68528, '\p{^Sc=phlp}', "");
    Expect(1, 68528, '\P{Sc=phlp}', "");
    Expect(0, 68528, '\P{^Sc=phlp}', "");
    Expect(1, 68527, '\p{Sc=:\Aphlp\z:}', "");;
    Expect(0, 68528, '\p{Sc=:\Aphlp\z:}', "");;
    Expect(1, 68527, '\p{Sc=-PHLP}', "");
    Expect(0, 68527, '\p{^Sc=-PHLP}', "");
    Expect(0, 68527, '\P{Sc=-PHLP}', "");
    Expect(1, 68527, '\P{^Sc=-PHLP}', "");
    Expect(0, 68528, '\p{Sc=-PHLP}', "");
    Expect(1, 68528, '\p{^Sc=-PHLP}', "");
    Expect(1, 68528, '\P{Sc=-PHLP}', "");
    Expect(0, 68528, '\P{^Sc=-PHLP}', "");
    Error('\p{Is_Script= /a/PSALTER_PAHLAVI}');
    Error('\P{Is_Script= /a/PSALTER_PAHLAVI}');
    Expect(1, 68527, '\p{Is_Script=psalterpahlavi}', "");
    Expect(0, 68527, '\p{^Is_Script=psalterpahlavi}', "");
    Expect(0, 68527, '\P{Is_Script=psalterpahlavi}', "");
    Expect(1, 68527, '\P{^Is_Script=psalterpahlavi}', "");
    Expect(0, 68528, '\p{Is_Script=psalterpahlavi}', "");
    Expect(1, 68528, '\p{^Is_Script=psalterpahlavi}', "");
    Expect(1, 68528, '\P{Is_Script=psalterpahlavi}', "");
    Expect(0, 68528, '\P{^Is_Script=psalterpahlavi}', "");
    Expect(1, 68527, '\p{Is_Script=- Psalter_Pahlavi}', "");
    Expect(0, 68527, '\p{^Is_Script=- Psalter_Pahlavi}', "");
    Expect(0, 68527, '\P{Is_Script=- Psalter_Pahlavi}', "");
    Expect(1, 68527, '\P{^Is_Script=- Psalter_Pahlavi}', "");
    Expect(0, 68528, '\p{Is_Script=- Psalter_Pahlavi}', "");
    Expect(1, 68528, '\p{^Is_Script=- Psalter_Pahlavi}', "");
    Expect(1, 68528, '\P{Is_Script=- Psalter_Pahlavi}', "");
    Expect(0, 68528, '\P{^Is_Script=- Psalter_Pahlavi}', "");
    Error('\p{Is_Sc=:= Phlp}');
    Error('\P{Is_Sc=:= Phlp}');
    Expect(1, 68527, '\p{Is_Sc:   phlp}', "");
    Expect(0, 68527, '\p{^Is_Sc:   phlp}', "");
    Expect(0, 68527, '\P{Is_Sc:   phlp}', "");
    Expect(1, 68527, '\P{^Is_Sc:   phlp}', "");
    Expect(0, 68528, '\p{Is_Sc:   phlp}', "");
    Expect(1, 68528, '\p{^Is_Sc:   phlp}', "");
    Expect(1, 68528, '\P{Is_Sc:   phlp}', "");
    Expect(0, 68528, '\P{^Is_Sc:   phlp}', "");
    Expect(1, 68527, '\p{Is_Sc= Phlp}', "");
    Expect(0, 68527, '\p{^Is_Sc= Phlp}', "");
    Expect(0, 68527, '\P{Is_Sc= Phlp}', "");
    Expect(1, 68527, '\P{^Is_Sc= Phlp}', "");
    Expect(0, 68528, '\p{Is_Sc= Phlp}', "");
    Expect(1, 68528, '\p{^Is_Sc= Phlp}', "");
    Expect(1, 68528, '\P{Is_Sc= Phlp}', "");
    Expect(0, 68528, '\P{^Is_Sc= Phlp}', "");
    Error('\p{Script= phoenician/a/}');
    Error('\P{Script= phoenician/a/}');
    Expect(1, 67871, '\p{Script=:\APhoenician\z:}', "");;
    Expect(0, 67872, '\p{Script=:\APhoenician\z:}', "");;
    Expect(1, 67871, '\p{Script=phoenician}', "");
    Expect(0, 67871, '\p{^Script=phoenician}', "");
    Expect(0, 67871, '\P{Script=phoenician}', "");
    Expect(1, 67871, '\P{^Script=phoenician}', "");
    Expect(0, 67872, '\p{Script=phoenician}', "");
    Expect(1, 67872, '\p{^Script=phoenician}', "");
    Expect(1, 67872, '\P{Script=phoenician}', "");
    Expect(0, 67872, '\P{^Script=phoenician}', "");
    Expect(1, 67871, '\p{Script=:\Aphoenician\z:}', "");;
    Expect(0, 67872, '\p{Script=:\Aphoenician\z:}', "");;
    Expect(1, 67871, '\p{Script= -Phoenician}', "");
    Expect(0, 67871, '\p{^Script= -Phoenician}', "");
    Expect(0, 67871, '\P{Script= -Phoenician}', "");
    Expect(1, 67871, '\P{^Script= -Phoenician}', "");
    Expect(0, 67872, '\p{Script= -Phoenician}', "");
    Expect(1, 67872, '\p{^Script= -Phoenician}', "");
    Expect(1, 67872, '\P{Script= -Phoenician}', "");
    Expect(0, 67872, '\P{^Script= -Phoenician}', "");
    Error('\p{Sc= :=Phnx}');
    Error('\P{Sc= :=Phnx}');
    Expect(1, 67871, '\p{Sc=:\APhnx\z:}', "");;
    Expect(0, 67872, '\p{Sc=:\APhnx\z:}', "");;
    Expect(1, 67871, '\p{Sc=phnx}', "");
    Expect(0, 67871, '\p{^Sc=phnx}', "");
    Expect(0, 67871, '\P{Sc=phnx}', "");
    Expect(1, 67871, '\P{^Sc=phnx}', "");
    Expect(0, 67872, '\p{Sc=phnx}', "");
    Expect(1, 67872, '\p{^Sc=phnx}', "");
    Expect(1, 67872, '\P{Sc=phnx}', "");
    Expect(0, 67872, '\P{^Sc=phnx}', "");
    Expect(1, 67871, '\p{Sc=:\Aphnx\z:}', "");;
    Expect(0, 67872, '\p{Sc=:\Aphnx\z:}', "");;
    Expect(1, 67871, '\p{Sc=_	phnx}', "");
    Expect(0, 67871, '\p{^Sc=_	phnx}', "");
    Expect(0, 67871, '\P{Sc=_	phnx}', "");
    Expect(1, 67871, '\P{^Sc=_	phnx}', "");
    Expect(0, 67872, '\p{Sc=_	phnx}', "");
    Expect(1, 67872, '\p{^Sc=_	phnx}', "");
    Expect(1, 67872, '\P{Sc=_	phnx}', "");
    Expect(0, 67872, '\P{^Sc=_	phnx}', "");
    Error('\p{Is_Script=-phoenician/a/}');
    Error('\P{Is_Script=-phoenician/a/}');
    Expect(1, 67871, '\p{Is_Script: phoenician}', "");
    Expect(0, 67871, '\p{^Is_Script: phoenician}', "");
    Expect(0, 67871, '\P{Is_Script: phoenician}', "");
    Expect(1, 67871, '\P{^Is_Script: phoenician}', "");
    Expect(0, 67872, '\p{Is_Script: phoenician}', "");
    Expect(1, 67872, '\p{^Is_Script: phoenician}', "");
    Expect(1, 67872, '\P{Is_Script: phoenician}', "");
    Expect(0, 67872, '\P{^Is_Script: phoenician}', "");
    Expect(1, 67871, '\p{Is_Script=_-phoenician}', "");
    Expect(0, 67871, '\p{^Is_Script=_-phoenician}', "");
    Expect(0, 67871, '\P{Is_Script=_-phoenician}', "");
    Expect(1, 67871, '\P{^Is_Script=_-phoenician}', "");
    Expect(0, 67872, '\p{Is_Script=_-phoenician}', "");
    Expect(1, 67872, '\p{^Is_Script=_-phoenician}', "");
    Expect(1, 67872, '\P{Is_Script=_-phoenician}', "");
    Expect(0, 67872, '\P{^Is_Script=_-phoenician}', "");
    Error('\p{Is_Sc=_PHNX/a/}');
    Error('\P{Is_Sc=_PHNX/a/}');
    Expect(1, 67871, '\p{Is_Sc:phnx}', "");
    Expect(0, 67871, '\p{^Is_Sc:phnx}', "");
    Expect(0, 67871, '\P{Is_Sc:phnx}', "");
    Expect(1, 67871, '\P{^Is_Sc:phnx}', "");
    Expect(0, 67872, '\p{Is_Sc:phnx}', "");
    Expect(1, 67872, '\p{^Is_Sc:phnx}', "");
    Expect(1, 67872, '\P{Is_Sc:phnx}', "");
    Expect(0, 67872, '\P{^Is_Sc:phnx}', "");
    Expect(1, 67871, '\p{Is_Sc= -Phnx}', "");
    Expect(0, 67871, '\p{^Is_Sc= -Phnx}', "");
    Expect(0, 67871, '\P{Is_Sc= -Phnx}', "");
    Expect(1, 67871, '\P{^Is_Sc= -Phnx}', "");
    Expect(0, 67872, '\p{Is_Sc= -Phnx}', "");
    Expect(1, 67872, '\p{^Is_Sc= -Phnx}', "");
    Expect(1, 67872, '\P{Is_Sc= -Phnx}', "");
    Expect(0, 67872, '\P{^Is_Sc= -Phnx}', "");
    Error('\p{Script=_:=miao}');
    Error('\P{Script=_:=miao}');
    Expect(1, 94111, '\p{Script=:\AMiao\z:}', "");;
    Expect(0, 94112, '\p{Script=:\AMiao\z:}', "");;
    Expect(1, 94111, '\p{Script=miao}', "");
    Expect(0, 94111, '\p{^Script=miao}', "");
    Expect(0, 94111, '\P{Script=miao}', "");
    Expect(1, 94111, '\P{^Script=miao}', "");
    Expect(0, 94112, '\p{Script=miao}', "");
    Expect(1, 94112, '\p{^Script=miao}', "");
    Expect(1, 94112, '\P{Script=miao}', "");
    Expect(0, 94112, '\P{^Script=miao}', "");
    Expect(1, 94111, '\p{Script=:\Amiao\z:}', "");;
    Expect(0, 94112, '\p{Script=:\Amiao\z:}', "");;
    Expect(1, 94111, '\p{Script=_ MIAO}', "");
    Expect(0, 94111, '\p{^Script=_ MIAO}', "");
    Expect(0, 94111, '\P{Script=_ MIAO}', "");
    Expect(1, 94111, '\P{^Script=_ MIAO}', "");
    Expect(0, 94112, '\p{Script=_ MIAO}', "");
    Expect(1, 94112, '\p{^Script=_ MIAO}', "");
    Expect(1, 94112, '\P{Script=_ MIAO}', "");
    Expect(0, 94112, '\P{^Script=_ MIAO}', "");
    Error('\p{Sc=-_Plrd:=}');
    Error('\P{Sc=-_Plrd:=}');
    Expect(1, 94111, '\p{Sc=:\APlrd\z:}', "");;
    Expect(0, 94112, '\p{Sc=:\APlrd\z:}', "");;
    Expect(1, 94111, '\p{Sc=plrd}', "");
    Expect(0, 94111, '\p{^Sc=plrd}', "");
    Expect(0, 94111, '\P{Sc=plrd}', "");
    Expect(1, 94111, '\P{^Sc=plrd}', "");
    Expect(0, 94112, '\p{Sc=plrd}', "");
    Expect(1, 94112, '\p{^Sc=plrd}', "");
    Expect(1, 94112, '\P{Sc=plrd}', "");
    Expect(0, 94112, '\P{^Sc=plrd}', "");
    Expect(1, 94111, '\p{Sc=:\Aplrd\z:}', "");;
    Expect(0, 94112, '\p{Sc=:\Aplrd\z:}', "");;
    Expect(1, 94111, '\p{Sc= _PLRD}', "");
    Expect(0, 94111, '\p{^Sc= _PLRD}', "");
    Expect(0, 94111, '\P{Sc= _PLRD}', "");
    Expect(1, 94111, '\P{^Sc= _PLRD}', "");
    Expect(0, 94112, '\p{Sc= _PLRD}', "");
    Expect(1, 94112, '\p{^Sc= _PLRD}', "");
    Expect(1, 94112, '\P{Sc= _PLRD}', "");
    Expect(0, 94112, '\P{^Sc= _PLRD}', "");
    Error('\p{Is_Script=- Miao/a/}');
    Error('\P{Is_Script=- Miao/a/}');
    Expect(1, 94111, '\p{Is_Script=miao}', "");
    Expect(0, 94111, '\p{^Is_Script=miao}', "");
    Expect(0, 94111, '\P{Is_Script=miao}', "");
    Expect(1, 94111, '\P{^Is_Script=miao}', "");
    Expect(0, 94112, '\p{Is_Script=miao}', "");
    Expect(1, 94112, '\p{^Is_Script=miao}', "");
    Expect(1, 94112, '\P{Is_Script=miao}', "");
    Expect(0, 94112, '\P{^Is_Script=miao}', "");
    Expect(1, 94111, '\p{Is_Script=__MIAO}', "");
    Expect(0, 94111, '\p{^Is_Script=__MIAO}', "");
    Expect(0, 94111, '\P{Is_Script=__MIAO}', "");
    Expect(1, 94111, '\P{^Is_Script=__MIAO}', "");
    Expect(0, 94112, '\p{Is_Script=__MIAO}', "");
    Expect(1, 94112, '\p{^Is_Script=__MIAO}', "");
    Expect(1, 94112, '\P{Is_Script=__MIAO}', "");
    Expect(0, 94112, '\P{^Is_Script=__MIAO}', "");
    Error('\p{Is_Sc=:=-_PLRD}');
    Error('\P{Is_Sc=:=-_PLRD}');
    Expect(1, 94111, '\p{Is_Sc=plrd}', "");
    Expect(0, 94111, '\p{^Is_Sc=plrd}', "");
    Expect(0, 94111, '\P{Is_Sc=plrd}', "");
    Expect(1, 94111, '\P{^Is_Sc=plrd}', "");
    Expect(0, 94112, '\p{Is_Sc=plrd}', "");
    Expect(1, 94112, '\p{^Is_Sc=plrd}', "");
    Expect(1, 94112, '\P{Is_Sc=plrd}', "");
    Expect(0, 94112, '\P{^Is_Sc=plrd}', "");
    Expect(1, 94111, '\p{Is_Sc=	PLRD}', "");
    Expect(0, 94111, '\p{^Is_Sc=	PLRD}', "");
    Expect(0, 94111, '\P{Is_Sc=	PLRD}', "");
    Expect(1, 94111, '\P{^Is_Sc=	PLRD}', "");
    Expect(0, 94112, '\p{Is_Sc=	PLRD}', "");
    Expect(1, 94112, '\p{^Is_Sc=	PLRD}', "");
    Expect(1, 94112, '\P{Is_Sc=	PLRD}', "");
    Expect(0, 94112, '\P{^Is_Sc=	PLRD}', "");
    Error('\p{Script=_Inscriptional_Parthian:=}');
    Error('\P{Script=_Inscriptional_Parthian:=}');
    Expect(1, 68447, '\p{Script=:\AInscriptional_Parthian\z:}', "");;
    Expect(0, 68448, '\p{Script=:\AInscriptional_Parthian\z:}', "");;
    Expect(1, 68447, '\p{Script:	inscriptionalparthian}', "");
    Expect(0, 68447, '\p{^Script:	inscriptionalparthian}', "");
    Expect(0, 68447, '\P{Script:	inscriptionalparthian}', "");
    Expect(1, 68447, '\P{^Script:	inscriptionalparthian}', "");
    Expect(0, 68448, '\p{Script:	inscriptionalparthian}', "");
    Expect(1, 68448, '\p{^Script:	inscriptionalparthian}', "");
    Expect(1, 68448, '\P{Script:	inscriptionalparthian}', "");
    Expect(0, 68448, '\P{^Script:	inscriptionalparthian}', "");
    Expect(1, 68447, '\p{Script=:\Ainscriptionalparthian\z:}', "");;
    Expect(0, 68448, '\p{Script=:\Ainscriptionalparthian\z:}', "");;
    Expect(1, 68447, '\p{Script=--Inscriptional_Parthian}', "");
    Expect(0, 68447, '\p{^Script=--Inscriptional_Parthian}', "");
    Expect(0, 68447, '\P{Script=--Inscriptional_Parthian}', "");
    Expect(1, 68447, '\P{^Script=--Inscriptional_Parthian}', "");
    Expect(0, 68448, '\p{Script=--Inscriptional_Parthian}', "");
    Expect(1, 68448, '\p{^Script=--Inscriptional_Parthian}', "");
    Expect(1, 68448, '\P{Script=--Inscriptional_Parthian}', "");
    Expect(0, 68448, '\P{^Script=--Inscriptional_Parthian}', "");
    Error('\p{Sc=-/a/prti}');
    Error('\P{Sc=-/a/prti}');
    Expect(1, 68447, '\p{Sc=:\APrti\z:}', "");;
    Expect(0, 68448, '\p{Sc=:\APrti\z:}', "");;
    Expect(1, 68447, '\p{Sc=prti}', "");
    Expect(0, 68447, '\p{^Sc=prti}', "");
    Expect(0, 68447, '\P{Sc=prti}', "");
    Expect(1, 68447, '\P{^Sc=prti}', "");
    Expect(0, 68448, '\p{Sc=prti}', "");
    Expect(1, 68448, '\p{^Sc=prti}', "");
    Expect(1, 68448, '\P{Sc=prti}', "");
    Expect(0, 68448, '\P{^Sc=prti}', "");
    Expect(1, 68447, '\p{Sc=:\Aprti\z:}', "");;
    Expect(0, 68448, '\p{Sc=:\Aprti\z:}', "");;
    Expect(1, 68447, '\p{Sc=		PRTI}', "");
    Expect(0, 68447, '\p{^Sc=		PRTI}', "");
    Expect(0, 68447, '\P{Sc=		PRTI}', "");
    Expect(1, 68447, '\P{^Sc=		PRTI}', "");
    Expect(0, 68448, '\p{Sc=		PRTI}', "");
    Expect(1, 68448, '\p{^Sc=		PRTI}', "");
    Expect(1, 68448, '\P{Sc=		PRTI}', "");
    Expect(0, 68448, '\P{^Sc=		PRTI}', "");
    Error('\p{Is_Script=-:=Inscriptional_Parthian}');
    Error('\P{Is_Script=-:=Inscriptional_Parthian}');
    Expect(1, 68447, '\p{Is_Script=inscriptionalparthian}', "");
    Expect(0, 68447, '\p{^Is_Script=inscriptionalparthian}', "");
    Expect(0, 68447, '\P{Is_Script=inscriptionalparthian}', "");
    Expect(1, 68447, '\P{^Is_Script=inscriptionalparthian}', "");
    Expect(0, 68448, '\p{Is_Script=inscriptionalparthian}', "");
    Expect(1, 68448, '\p{^Is_Script=inscriptionalparthian}', "");
    Expect(1, 68448, '\P{Is_Script=inscriptionalparthian}', "");
    Expect(0, 68448, '\P{^Is_Script=inscriptionalparthian}', "");
    Expect(1, 68447, '\p{Is_Script=	-Inscriptional_PARTHIAN}', "");
    Expect(0, 68447, '\p{^Is_Script=	-Inscriptional_PARTHIAN}', "");
    Expect(0, 68447, '\P{Is_Script=	-Inscriptional_PARTHIAN}', "");
    Expect(1, 68447, '\P{^Is_Script=	-Inscriptional_PARTHIAN}', "");
    Expect(0, 68448, '\p{Is_Script=	-Inscriptional_PARTHIAN}', "");
    Expect(1, 68448, '\p{^Is_Script=	-Inscriptional_PARTHIAN}', "");
    Expect(1, 68448, '\P{Is_Script=	-Inscriptional_PARTHIAN}', "");
    Expect(0, 68448, '\P{^Is_Script=	-Inscriptional_PARTHIAN}', "");
    Error('\p{Is_Sc=/a/_Prti}');
    Error('\P{Is_Sc=/a/_Prti}');
    Expect(1, 68447, '\p{Is_Sc=prti}', "");
    Expect(0, 68447, '\p{^Is_Sc=prti}', "");
    Expect(0, 68447, '\P{Is_Sc=prti}', "");
    Expect(1, 68447, '\P{^Is_Sc=prti}', "");
    Expect(0, 68448, '\p{Is_Sc=prti}', "");
    Expect(1, 68448, '\p{^Is_Sc=prti}', "");
    Expect(1, 68448, '\P{Is_Sc=prti}', "");
    Expect(0, 68448, '\P{^Is_Sc=prti}', "");
    Expect(1, 68447, '\p{Is_Sc= Prti}', "");
    Expect(0, 68447, '\p{^Is_Sc= Prti}', "");
    Expect(0, 68447, '\P{Is_Sc= Prti}', "");
    Expect(1, 68447, '\P{^Is_Sc= Prti}', "");
    Expect(0, 68448, '\p{Is_Sc= Prti}', "");
    Expect(1, 68448, '\p{^Is_Sc= Prti}', "");
    Expect(1, 68448, '\P{Is_Sc= Prti}', "");
    Expect(0, 68448, '\P{^Is_Sc= Prti}', "");
    Error('\p{Script:		/a/Rejang}');
    Error('\P{Script:		/a/Rejang}');
    Expect(1, 43359, '\p{Script=:\ARejang\z:}', "");;
    Expect(0, 43360, '\p{Script=:\ARejang\z:}', "");;
    Expect(1, 43359, '\p{Script=rejang}', "");
    Expect(0, 43359, '\p{^Script=rejang}', "");
    Expect(0, 43359, '\P{Script=rejang}', "");
    Expect(1, 43359, '\P{^Script=rejang}', "");
    Expect(0, 43360, '\p{Script=rejang}', "");
    Expect(1, 43360, '\p{^Script=rejang}', "");
    Expect(1, 43360, '\P{Script=rejang}', "");
    Expect(0, 43360, '\P{^Script=rejang}', "");
    Expect(1, 43359, '\p{Script=:\Arejang\z:}', "");;
    Expect(0, 43360, '\p{Script=:\Arejang\z:}', "");;
    Expect(1, 43359, '\p{Script= Rejang}', "");
    Expect(0, 43359, '\p{^Script= Rejang}', "");
    Expect(0, 43359, '\P{Script= Rejang}', "");
    Expect(1, 43359, '\P{^Script= Rejang}', "");
    Expect(0, 43360, '\p{Script= Rejang}', "");
    Expect(1, 43360, '\p{^Script= Rejang}', "");
    Expect(1, 43360, '\P{Script= Rejang}', "");
    Expect(0, 43360, '\P{^Script= Rejang}', "");
    Error('\p{Sc:		 RJNG/a/}');
    Error('\P{Sc:		 RJNG/a/}');
    Expect(1, 43359, '\p{Sc=:\ARjng\z:}', "");;
    Expect(0, 43360, '\p{Sc=:\ARjng\z:}', "");;
    Expect(1, 43359, '\p{Sc:	rjng}', "");
    Expect(0, 43359, '\p{^Sc:	rjng}', "");
    Expect(0, 43359, '\P{Sc:	rjng}', "");
    Expect(1, 43359, '\P{^Sc:	rjng}', "");
    Expect(0, 43360, '\p{Sc:	rjng}', "");
    Expect(1, 43360, '\p{^Sc:	rjng}', "");
    Expect(1, 43360, '\P{Sc:	rjng}', "");
    Expect(0, 43360, '\P{^Sc:	rjng}', "");
    Expect(1, 43359, '\p{Sc=:\Arjng\z:}', "");;
    Expect(0, 43360, '\p{Sc=:\Arjng\z:}', "");;
    Expect(1, 43359, '\p{Sc= 	rjng}', "");
    Expect(0, 43359, '\p{^Sc= 	rjng}', "");
    Expect(0, 43359, '\P{Sc= 	rjng}', "");
    Expect(1, 43359, '\P{^Sc= 	rjng}', "");
    Expect(0, 43360, '\p{Sc= 	rjng}', "");
    Expect(1, 43360, '\p{^Sc= 	rjng}', "");
    Expect(1, 43360, '\P{Sc= 	rjng}', "");
    Expect(0, 43360, '\P{^Sc= 	rjng}', "");
    Error('\p{Is_Script= :=REJANG}');
    Error('\P{Is_Script= :=REJANG}');
    Expect(1, 43359, '\p{Is_Script=rejang}', "");
    Expect(0, 43359, '\p{^Is_Script=rejang}', "");
    Expect(0, 43359, '\P{Is_Script=rejang}', "");
    Expect(1, 43359, '\P{^Is_Script=rejang}', "");
    Expect(0, 43360, '\p{Is_Script=rejang}', "");
    Expect(1, 43360, '\p{^Is_Script=rejang}', "");
    Expect(1, 43360, '\P{Is_Script=rejang}', "");
    Expect(0, 43360, '\P{^Is_Script=rejang}', "");
    Expect(1, 43359, '\p{Is_Script=__Rejang}', "");
    Expect(0, 43359, '\p{^Is_Script=__Rejang}', "");
    Expect(0, 43359, '\P{Is_Script=__Rejang}', "");
    Expect(1, 43359, '\P{^Is_Script=__Rejang}', "");
    Expect(0, 43360, '\p{Is_Script=__Rejang}', "");
    Expect(1, 43360, '\p{^Is_Script=__Rejang}', "");
    Expect(1, 43360, '\P{Is_Script=__Rejang}', "");
    Expect(0, 43360, '\P{^Is_Script=__Rejang}', "");
    Error('\p{Is_Sc=		rjng:=}');
    Error('\P{Is_Sc=		rjng:=}');
    Expect(1, 43359, '\p{Is_Sc=rjng}', "");
    Expect(0, 43359, '\p{^Is_Sc=rjng}', "");
    Expect(0, 43359, '\P{Is_Sc=rjng}', "");
    Expect(1, 43359, '\P{^Is_Sc=rjng}', "");
    Expect(0, 43360, '\p{Is_Sc=rjng}', "");
    Expect(1, 43360, '\p{^Is_Sc=rjng}', "");
    Expect(1, 43360, '\P{Is_Sc=rjng}', "");
    Expect(0, 43360, '\P{^Is_Sc=rjng}', "");
    Expect(1, 43359, '\p{Is_Sc:	-_Rjng}', "");
    Expect(0, 43359, '\p{^Is_Sc:	-_Rjng}', "");
    Expect(0, 43359, '\P{Is_Sc:	-_Rjng}', "");
    Expect(1, 43359, '\P{^Is_Sc:	-_Rjng}', "");
    Expect(0, 43360, '\p{Is_Sc:	-_Rjng}', "");
    Expect(1, 43360, '\p{^Is_Sc:	-_Rjng}', "");
    Expect(1, 43360, '\P{Is_Sc:	-_Rjng}', "");
    Expect(0, 43360, '\P{^Is_Sc:	-_Rjng}', "");
    Error('\p{Script= :=Hanifi_ROHINGYA}');
    Error('\P{Script= :=Hanifi_ROHINGYA}');
    Expect(1, 68921, '\p{Script=:\AHanifi_Rohingya\z:}', "");;
    Expect(0, 68922, '\p{Script=:\AHanifi_Rohingya\z:}', "");;
    Expect(1, 68921, '\p{Script=hanifirohingya}', "");
    Expect(0, 68921, '\p{^Script=hanifirohingya}', "");
    Expect(0, 68921, '\P{Script=hanifirohingya}', "");
    Expect(1, 68921, '\P{^Script=hanifirohingya}', "");
    Expect(0, 68922, '\p{Script=hanifirohingya}', "");
    Expect(1, 68922, '\p{^Script=hanifirohingya}', "");
    Expect(1, 68922, '\P{Script=hanifirohingya}', "");
    Expect(0, 68922, '\P{^Script=hanifirohingya}', "");
    Expect(1, 68921, '\p{Script=:\Ahanifirohingya\z:}', "");;
    Expect(0, 68922, '\p{Script=:\Ahanifirohingya\z:}', "");;
    Expect(1, 68921, '\p{Script=__hanifi_Rohingya}', "");
    Expect(0, 68921, '\p{^Script=__hanifi_Rohingya}', "");
    Expect(0, 68921, '\P{Script=__hanifi_Rohingya}', "");
    Expect(1, 68921, '\P{^Script=__hanifi_Rohingya}', "");
    Expect(0, 68922, '\p{Script=__hanifi_Rohingya}', "");
    Expect(1, 68922, '\p{^Script=__hanifi_Rohingya}', "");
    Expect(1, 68922, '\P{Script=__hanifi_Rohingya}', "");
    Expect(0, 68922, '\P{^Script=__hanifi_Rohingya}', "");
    Error('\p{Sc=/a/ 	Rohg}');
    Error('\P{Sc=/a/ 	Rohg}');
    Expect(1, 68921, '\p{Sc=:\ARohg\z:}', "");;
    Expect(0, 68922, '\p{Sc=:\ARohg\z:}', "");;
    Expect(1, 68921, '\p{Sc=rohg}', "");
    Expect(0, 68921, '\p{^Sc=rohg}', "");
    Expect(0, 68921, '\P{Sc=rohg}', "");
    Expect(1, 68921, '\P{^Sc=rohg}', "");
    Expect(0, 68922, '\p{Sc=rohg}', "");
    Expect(1, 68922, '\p{^Sc=rohg}', "");
    Expect(1, 68922, '\P{Sc=rohg}', "");
    Expect(0, 68922, '\P{^Sc=rohg}', "");
    Expect(1, 68921, '\p{Sc=:\Arohg\z:}', "");;
    Expect(0, 68922, '\p{Sc=:\Arohg\z:}', "");;
    Expect(1, 68921, '\p{Sc=- Rohg}', "");
    Expect(0, 68921, '\p{^Sc=- Rohg}', "");
    Expect(0, 68921, '\P{Sc=- Rohg}', "");
    Expect(1, 68921, '\P{^Sc=- Rohg}', "");
    Expect(0, 68922, '\p{Sc=- Rohg}', "");
    Expect(1, 68922, '\p{^Sc=- Rohg}', "");
    Expect(1, 68922, '\P{Sc=- Rohg}', "");
    Expect(0, 68922, '\P{^Sc=- Rohg}', "");
    Error('\p{Is_Script=-_HANIFI_ROHINGYA/a/}');
    Error('\P{Is_Script=-_HANIFI_ROHINGYA/a/}');
    Expect(1, 68921, '\p{Is_Script=hanifirohingya}', "");
    Expect(0, 68921, '\p{^Is_Script=hanifirohingya}', "");
    Expect(0, 68921, '\P{Is_Script=hanifirohingya}', "");
    Expect(1, 68921, '\P{^Is_Script=hanifirohingya}', "");
    Expect(0, 68922, '\p{Is_Script=hanifirohingya}', "");
    Expect(1, 68922, '\p{^Is_Script=hanifirohingya}', "");
    Expect(1, 68922, '\P{Is_Script=hanifirohingya}', "");
    Expect(0, 68922, '\P{^Is_Script=hanifirohingya}', "");
    Expect(1, 68921, '\p{Is_Script=_	hanifi_Rohingya}', "");
    Expect(0, 68921, '\p{^Is_Script=_	hanifi_Rohingya}', "");
    Expect(0, 68921, '\P{Is_Script=_	hanifi_Rohingya}', "");
    Expect(1, 68921, '\P{^Is_Script=_	hanifi_Rohingya}', "");
    Expect(0, 68922, '\p{Is_Script=_	hanifi_Rohingya}', "");
    Expect(1, 68922, '\p{^Is_Script=_	hanifi_Rohingya}', "");
    Expect(1, 68922, '\P{Is_Script=_	hanifi_Rohingya}', "");
    Expect(0, 68922, '\P{^Is_Script=_	hanifi_Rohingya}', "");
    Error('\p{Is_Sc=--Rohg:=}');
    Error('\P{Is_Sc=--Rohg:=}');
    Expect(1, 68921, '\p{Is_Sc=rohg}', "");
    Expect(0, 68921, '\p{^Is_Sc=rohg}', "");
    Expect(0, 68921, '\P{Is_Sc=rohg}', "");
    Expect(1, 68921, '\P{^Is_Sc=rohg}', "");
    Expect(0, 68922, '\p{Is_Sc=rohg}', "");
    Expect(1, 68922, '\p{^Is_Sc=rohg}', "");
    Expect(1, 68922, '\P{Is_Sc=rohg}', "");
    Expect(0, 68922, '\P{^Is_Sc=rohg}', "");
    Expect(1, 68921, '\p{Is_Sc=--rohg}', "");
    Expect(0, 68921, '\p{^Is_Sc=--rohg}', "");
    Expect(0, 68921, '\P{Is_Sc=--rohg}', "");
    Expect(1, 68921, '\P{^Is_Sc=--rohg}', "");
    Expect(0, 68922, '\p{Is_Sc=--rohg}', "");
    Expect(1, 68922, '\p{^Is_Sc=--rohg}', "");
    Expect(1, 68922, '\P{Is_Sc=--rohg}', "");
    Expect(0, 68922, '\P{^Is_Sc=--rohg}', "");
    Error('\p{Script=:=_ Runic}');
    Error('\P{Script=:=_ Runic}');
    Expect(1, 5880, '\p{Script=:\ARunic\z:}', "");;
    Expect(0, 5881, '\p{Script=:\ARunic\z:}', "");;
    Expect(1, 5880, '\p{Script=runic}', "");
    Expect(0, 5880, '\p{^Script=runic}', "");
    Expect(0, 5880, '\P{Script=runic}', "");
    Expect(1, 5880, '\P{^Script=runic}', "");
    Expect(0, 5881, '\p{Script=runic}', "");
    Expect(1, 5881, '\p{^Script=runic}', "");
    Expect(1, 5881, '\P{Script=runic}', "");
    Expect(0, 5881, '\P{^Script=runic}', "");
    Expect(1, 5880, '\p{Script=:\Arunic\z:}', "");;
    Expect(0, 5881, '\p{Script=:\Arunic\z:}', "");;
    Expect(1, 5880, '\p{Script=		RUNIC}', "");
    Expect(0, 5880, '\p{^Script=		RUNIC}', "");
    Expect(0, 5880, '\P{Script=		RUNIC}', "");
    Expect(1, 5880, '\P{^Script=		RUNIC}', "");
    Expect(0, 5881, '\p{Script=		RUNIC}', "");
    Expect(1, 5881, '\p{^Script=		RUNIC}', "");
    Expect(1, 5881, '\P{Script=		RUNIC}', "");
    Expect(0, 5881, '\P{^Script=		RUNIC}', "");
    Error('\p{Sc=  runr/a/}');
    Error('\P{Sc=  runr/a/}');
    Expect(1, 5880, '\p{Sc=:\ARunr\z:}', "");;
    Expect(0, 5881, '\p{Sc=:\ARunr\z:}', "");;
    Expect(1, 5880, '\p{Sc=runr}', "");
    Expect(0, 5880, '\p{^Sc=runr}', "");
    Expect(0, 5880, '\P{Sc=runr}', "");
    Expect(1, 5880, '\P{^Sc=runr}', "");
    Expect(0, 5881, '\p{Sc=runr}', "");
    Expect(1, 5881, '\p{^Sc=runr}', "");
    Expect(1, 5881, '\P{Sc=runr}', "");
    Expect(0, 5881, '\P{^Sc=runr}', "");
    Expect(1, 5880, '\p{Sc=:\Arunr\z:}', "");;
    Expect(0, 5881, '\p{Sc=:\Arunr\z:}', "");;
    Expect(1, 5880, '\p{Sc=-RUNR}', "");
    Expect(0, 5880, '\p{^Sc=-RUNR}', "");
    Expect(0, 5880, '\P{Sc=-RUNR}', "");
    Expect(1, 5880, '\P{^Sc=-RUNR}', "");
    Expect(0, 5881, '\p{Sc=-RUNR}', "");
    Expect(1, 5881, '\p{^Sc=-RUNR}', "");
    Expect(1, 5881, '\P{Sc=-RUNR}', "");
    Expect(0, 5881, '\P{^Sc=-RUNR}', "");
    Error('\p{Is_Script=_-Runic:=}');
    Error('\P{Is_Script=_-Runic:=}');
    Expect(1, 5880, '\p{Is_Script=runic}', "");
    Expect(0, 5880, '\p{^Is_Script=runic}', "");
    Expect(0, 5880, '\P{Is_Script=runic}', "");
    Expect(1, 5880, '\P{^Is_Script=runic}', "");
    Expect(0, 5881, '\p{Is_Script=runic}', "");
    Expect(1, 5881, '\p{^Is_Script=runic}', "");
    Expect(1, 5881, '\P{Is_Script=runic}', "");
    Expect(0, 5881, '\P{^Is_Script=runic}', "");
    Expect(1, 5880, '\p{Is_Script= 	RUNIC}', "");
    Expect(0, 5880, '\p{^Is_Script= 	RUNIC}', "");
    Expect(0, 5880, '\P{Is_Script= 	RUNIC}', "");
    Expect(1, 5880, '\P{^Is_Script= 	RUNIC}', "");
    Expect(0, 5881, '\p{Is_Script= 	RUNIC}', "");
    Expect(1, 5881, '\p{^Is_Script= 	RUNIC}', "");
    Expect(1, 5881, '\P{Is_Script= 	RUNIC}', "");
    Expect(0, 5881, '\P{^Is_Script= 	RUNIC}', "");
    Error('\p{Is_Sc=/a/_ runr}');
    Error('\P{Is_Sc=/a/_ runr}');
    Expect(1, 5880, '\p{Is_Sc=runr}', "");
    Expect(0, 5880, '\p{^Is_Sc=runr}', "");
    Expect(0, 5880, '\P{Is_Sc=runr}', "");
    Expect(1, 5880, '\P{^Is_Sc=runr}', "");
    Expect(0, 5881, '\p{Is_Sc=runr}', "");
    Expect(1, 5881, '\p{^Is_Sc=runr}', "");
    Expect(1, 5881, '\P{Is_Sc=runr}', "");
    Expect(0, 5881, '\P{^Is_Sc=runr}', "");
    Expect(1, 5880, '\p{Is_Sc= 	Runr}', "");
    Expect(0, 5880, '\p{^Is_Sc= 	Runr}', "");
    Expect(0, 5880, '\P{Is_Sc= 	Runr}', "");
    Expect(1, 5880, '\P{^Is_Sc= 	Runr}', "");
    Expect(0, 5881, '\p{Is_Sc= 	Runr}', "");
    Expect(1, 5881, '\p{^Is_Sc= 	Runr}', "");
    Expect(1, 5881, '\P{Is_Sc= 	Runr}', "");
    Expect(0, 5881, '\P{^Is_Sc= 	Runr}', "");
    Error('\p{Script=	Samaritan:=}');
    Error('\P{Script=	Samaritan:=}');
    Expect(1, 2110, '\p{Script=:\ASamaritan\z:}', "");;
    Expect(0, 2111, '\p{Script=:\ASamaritan\z:}', "");;
    Expect(1, 2110, '\p{Script=samaritan}', "");
    Expect(0, 2110, '\p{^Script=samaritan}', "");
    Expect(0, 2110, '\P{Script=samaritan}', "");
    Expect(1, 2110, '\P{^Script=samaritan}', "");
    Expect(0, 2111, '\p{Script=samaritan}', "");
    Expect(1, 2111, '\p{^Script=samaritan}', "");
    Expect(1, 2111, '\P{Script=samaritan}', "");
    Expect(0, 2111, '\P{^Script=samaritan}', "");
    Expect(1, 2110, '\p{Script=:\Asamaritan\z:}', "");;
    Expect(0, 2111, '\p{Script=:\Asamaritan\z:}', "");;
    Expect(1, 2110, '\p{Script=_	Samaritan}', "");
    Expect(0, 2110, '\p{^Script=_	Samaritan}', "");
    Expect(0, 2110, '\P{Script=_	Samaritan}', "");
    Expect(1, 2110, '\P{^Script=_	Samaritan}', "");
    Expect(0, 2111, '\p{Script=_	Samaritan}', "");
    Expect(1, 2111, '\p{^Script=_	Samaritan}', "");
    Expect(1, 2111, '\P{Script=_	Samaritan}', "");
    Expect(0, 2111, '\P{^Script=_	Samaritan}', "");
    Error('\p{Sc=--samr/a/}');
    Error('\P{Sc=--samr/a/}');
    Expect(1, 2110, '\p{Sc=:\ASamr\z:}', "");;
    Expect(0, 2111, '\p{Sc=:\ASamr\z:}', "");;
    Expect(1, 2110, '\p{Sc=samr}', "");
    Expect(0, 2110, '\p{^Sc=samr}', "");
    Expect(0, 2110, '\P{Sc=samr}', "");
    Expect(1, 2110, '\P{^Sc=samr}', "");
    Expect(0, 2111, '\p{Sc=samr}', "");
    Expect(1, 2111, '\p{^Sc=samr}', "");
    Expect(1, 2111, '\P{Sc=samr}', "");
    Expect(0, 2111, '\P{^Sc=samr}', "");
    Expect(1, 2110, '\p{Sc=:\Asamr\z:}', "");;
    Expect(0, 2111, '\p{Sc=:\Asamr\z:}', "");;
    Expect(1, 2110, '\p{Sc=_-Samr}', "");
    Expect(0, 2110, '\p{^Sc=_-Samr}', "");
    Expect(0, 2110, '\P{Sc=_-Samr}', "");
    Expect(1, 2110, '\P{^Sc=_-Samr}', "");
    Expect(0, 2111, '\p{Sc=_-Samr}', "");
    Expect(1, 2111, '\p{^Sc=_-Samr}', "");
    Expect(1, 2111, '\P{Sc=_-Samr}', "");
    Expect(0, 2111, '\P{^Sc=_-Samr}', "");
    Error('\p{Is_Script=- Samaritan/a/}');
    Error('\P{Is_Script=- Samaritan/a/}');
    Expect(1, 2110, '\p{Is_Script=samaritan}', "");
    Expect(0, 2110, '\p{^Is_Script=samaritan}', "");
    Expect(0, 2110, '\P{Is_Script=samaritan}', "");
    Expect(1, 2110, '\P{^Is_Script=samaritan}', "");
    Expect(0, 2111, '\p{Is_Script=samaritan}', "");
    Expect(1, 2111, '\p{^Is_Script=samaritan}', "");
    Expect(1, 2111, '\P{Is_Script=samaritan}', "");
    Expect(0, 2111, '\P{^Is_Script=samaritan}', "");
    Expect(1, 2110, '\p{Is_Script=		samaritan}', "");
    Expect(0, 2110, '\p{^Is_Script=		samaritan}', "");
    Expect(0, 2110, '\P{Is_Script=		samaritan}', "");
    Expect(1, 2110, '\P{^Is_Script=		samaritan}', "");
    Expect(0, 2111, '\p{Is_Script=		samaritan}', "");
    Expect(1, 2111, '\p{^Is_Script=		samaritan}', "");
    Expect(1, 2111, '\P{Is_Script=		samaritan}', "");
    Expect(0, 2111, '\P{^Is_Script=		samaritan}', "");
    Error('\p{Is_Sc=:=	-Samr}');
    Error('\P{Is_Sc=:=	-Samr}');
    Expect(1, 2110, '\p{Is_Sc: samr}', "");
    Expect(0, 2110, '\p{^Is_Sc: samr}', "");
    Expect(0, 2110, '\P{Is_Sc: samr}', "");
    Expect(1, 2110, '\P{^Is_Sc: samr}', "");
    Expect(0, 2111, '\p{Is_Sc: samr}', "");
    Expect(1, 2111, '\p{^Is_Sc: samr}', "");
    Expect(1, 2111, '\P{Is_Sc: samr}', "");
    Expect(0, 2111, '\P{^Is_Sc: samr}', "");
    Expect(1, 2110, '\p{Is_Sc=		Samr}', "");
    Expect(0, 2110, '\p{^Is_Sc=		Samr}', "");
    Expect(0, 2110, '\P{Is_Sc=		Samr}', "");
    Expect(1, 2110, '\P{^Is_Sc=		Samr}', "");
    Expect(0, 2111, '\p{Is_Sc=		Samr}', "");
    Expect(1, 2111, '\p{^Is_Sc=		Samr}', "");
    Expect(1, 2111, '\P{Is_Sc=		Samr}', "");
    Expect(0, 2111, '\P{^Is_Sc=		Samr}', "");
    Error('\p{Script:	:=old_South_ARABIAN}');
    Error('\P{Script:	:=old_South_ARABIAN}');
    Expect(1, 68223, '\p{Script=:\AOld_South_Arabian\z:}', "");;
    Expect(0, 68224, '\p{Script=:\AOld_South_Arabian\z:}', "");;
    Expect(1, 68223, '\p{Script:   oldsoutharabian}', "");
    Expect(0, 68223, '\p{^Script:   oldsoutharabian}', "");
    Expect(0, 68223, '\P{Script:   oldsoutharabian}', "");
    Expect(1, 68223, '\P{^Script:   oldsoutharabian}', "");
    Expect(0, 68224, '\p{Script:   oldsoutharabian}', "");
    Expect(1, 68224, '\p{^Script:   oldsoutharabian}', "");
    Expect(1, 68224, '\P{Script:   oldsoutharabian}', "");
    Expect(0, 68224, '\P{^Script:   oldsoutharabian}', "");
    Expect(1, 68223, '\p{Script=:\Aoldsoutharabian\z:}', "");;
    Expect(0, 68224, '\p{Script=:\Aoldsoutharabian\z:}', "");;
    Expect(1, 68223, '\p{Script=--OLD_SOUTH_Arabian}', "");
    Expect(0, 68223, '\p{^Script=--OLD_SOUTH_Arabian}', "");
    Expect(0, 68223, '\P{Script=--OLD_SOUTH_Arabian}', "");
    Expect(1, 68223, '\P{^Script=--OLD_SOUTH_Arabian}', "");
    Expect(0, 68224, '\p{Script=--OLD_SOUTH_Arabian}', "");
    Expect(1, 68224, '\p{^Script=--OLD_SOUTH_Arabian}', "");
    Expect(1, 68224, '\P{Script=--OLD_SOUTH_Arabian}', "");
    Expect(0, 68224, '\P{^Script=--OLD_SOUTH_Arabian}', "");
    Error('\p{Sc:			Sarb/a/}');
    Error('\P{Sc:			Sarb/a/}');
    Expect(1, 68223, '\p{Sc=:\ASarb\z:}', "");;
    Expect(0, 68224, '\p{Sc=:\ASarb\z:}', "");;
    Expect(1, 68223, '\p{Sc=sarb}', "");
    Expect(0, 68223, '\p{^Sc=sarb}', "");
    Expect(0, 68223, '\P{Sc=sarb}', "");
    Expect(1, 68223, '\P{^Sc=sarb}', "");
    Expect(0, 68224, '\p{Sc=sarb}', "");
    Expect(1, 68224, '\p{^Sc=sarb}', "");
    Expect(1, 68224, '\P{Sc=sarb}', "");
    Expect(0, 68224, '\P{^Sc=sarb}', "");
    Expect(1, 68223, '\p{Sc=:\Asarb\z:}', "");;
    Expect(0, 68224, '\p{Sc=:\Asarb\z:}', "");;
    Expect(1, 68223, '\p{Sc= SARB}', "");
    Expect(0, 68223, '\p{^Sc= SARB}', "");
    Expect(0, 68223, '\P{Sc= SARB}', "");
    Expect(1, 68223, '\P{^Sc= SARB}', "");
    Expect(0, 68224, '\p{Sc= SARB}', "");
    Expect(1, 68224, '\p{^Sc= SARB}', "");
    Expect(1, 68224, '\P{Sc= SARB}', "");
    Expect(0, 68224, '\P{^Sc= SARB}', "");
    Error('\p{Is_Script=	Old_SOUTH_ARABIAN:=}');
    Error('\P{Is_Script=	Old_SOUTH_ARABIAN:=}');
    Expect(1, 68223, '\p{Is_Script=oldsoutharabian}', "");
    Expect(0, 68223, '\p{^Is_Script=oldsoutharabian}', "");
    Expect(0, 68223, '\P{Is_Script=oldsoutharabian}', "");
    Expect(1, 68223, '\P{^Is_Script=oldsoutharabian}', "");
    Expect(0, 68224, '\p{Is_Script=oldsoutharabian}', "");
    Expect(1, 68224, '\p{^Is_Script=oldsoutharabian}', "");
    Expect(1, 68224, '\P{Is_Script=oldsoutharabian}', "");
    Expect(0, 68224, '\P{^Is_Script=oldsoutharabian}', "");
    Expect(1, 68223, '\p{Is_Script=_ OLD_South_Arabian}', "");
    Expect(0, 68223, '\p{^Is_Script=_ OLD_South_Arabian}', "");
    Expect(0, 68223, '\P{Is_Script=_ OLD_South_Arabian}', "");
    Expect(1, 68223, '\P{^Is_Script=_ OLD_South_Arabian}', "");
    Expect(0, 68224, '\p{Is_Script=_ OLD_South_Arabian}', "");
    Expect(1, 68224, '\p{^Is_Script=_ OLD_South_Arabian}', "");
    Expect(1, 68224, '\P{Is_Script=_ OLD_South_Arabian}', "");
    Expect(0, 68224, '\P{^Is_Script=_ OLD_South_Arabian}', "");
    Error('\p{Is_Sc=:= Sarb}');
    Error('\P{Is_Sc=:= Sarb}');
    Expect(1, 68223, '\p{Is_Sc=sarb}', "");
    Expect(0, 68223, '\p{^Is_Sc=sarb}', "");
    Expect(0, 68223, '\P{Is_Sc=sarb}', "");
    Expect(1, 68223, '\P{^Is_Sc=sarb}', "");
    Expect(0, 68224, '\p{Is_Sc=sarb}', "");
    Expect(1, 68224, '\p{^Is_Sc=sarb}', "");
    Expect(1, 68224, '\P{Is_Sc=sarb}', "");
    Expect(0, 68224, '\P{^Is_Sc=sarb}', "");
    Expect(1, 68223, '\p{Is_Sc=-	sarb}', "");
    Expect(0, 68223, '\p{^Is_Sc=-	sarb}', "");
    Expect(0, 68223, '\P{Is_Sc=-	sarb}', "");
    Expect(1, 68223, '\P{^Is_Sc=-	sarb}', "");
    Expect(0, 68224, '\p{Is_Sc=-	sarb}', "");
    Expect(1, 68224, '\p{^Is_Sc=-	sarb}', "");
    Expect(1, 68224, '\P{Is_Sc=-	sarb}', "");
    Expect(0, 68224, '\P{^Is_Sc=-	sarb}', "");
    Error('\p{Script=_	saurashtra/a/}');
    Error('\P{Script=_	saurashtra/a/}');
    Expect(1, 43225, '\p{Script=:\ASaurashtra\z:}', "");;
    Expect(0, 43226, '\p{Script=:\ASaurashtra\z:}', "");;
    Expect(1, 43225, '\p{Script=saurashtra}', "");
    Expect(0, 43225, '\p{^Script=saurashtra}', "");
    Expect(0, 43225, '\P{Script=saurashtra}', "");
    Expect(1, 43225, '\P{^Script=saurashtra}', "");
    Expect(0, 43226, '\p{Script=saurashtra}', "");
    Expect(1, 43226, '\p{^Script=saurashtra}', "");
    Expect(1, 43226, '\P{Script=saurashtra}', "");
    Expect(0, 43226, '\P{^Script=saurashtra}', "");
    Expect(1, 43225, '\p{Script=:\Asaurashtra\z:}', "");;
    Expect(0, 43226, '\p{Script=:\Asaurashtra\z:}', "");;
    Expect(1, 43225, '\p{Script=--Saurashtra}', "");
    Expect(0, 43225, '\p{^Script=--Saurashtra}', "");
    Expect(0, 43225, '\P{Script=--Saurashtra}', "");
    Expect(1, 43225, '\P{^Script=--Saurashtra}', "");
    Expect(0, 43226, '\p{Script=--Saurashtra}', "");
    Expect(1, 43226, '\p{^Script=--Saurashtra}', "");
    Expect(1, 43226, '\P{Script=--Saurashtra}', "");
    Expect(0, 43226, '\P{^Script=--Saurashtra}', "");
    Error('\p{Sc=	:=Saur}');
    Error('\P{Sc=	:=Saur}');
    Expect(1, 43225, '\p{Sc=:\ASaur\z:}', "");;
    Expect(0, 43226, '\p{Sc=:\ASaur\z:}', "");;
    Expect(1, 43225, '\p{Sc=saur}', "");
    Expect(0, 43225, '\p{^Sc=saur}', "");
    Expect(0, 43225, '\P{Sc=saur}', "");
    Expect(1, 43225, '\P{^Sc=saur}', "");
    Expect(0, 43226, '\p{Sc=saur}', "");
    Expect(1, 43226, '\p{^Sc=saur}', "");
    Expect(1, 43226, '\P{Sc=saur}', "");
    Expect(0, 43226, '\P{^Sc=saur}', "");
    Expect(1, 43225, '\p{Sc=:\Asaur\z:}', "");;
    Expect(0, 43226, '\p{Sc=:\Asaur\z:}', "");;
    Expect(1, 43225, '\p{Sc:  	Saur}', "");
    Expect(0, 43225, '\p{^Sc:  	Saur}', "");
    Expect(0, 43225, '\P{Sc:  	Saur}', "");
    Expect(1, 43225, '\P{^Sc:  	Saur}', "");
    Expect(0, 43226, '\p{Sc:  	Saur}', "");
    Expect(1, 43226, '\p{^Sc:  	Saur}', "");
    Expect(1, 43226, '\P{Sc:  	Saur}', "");
    Expect(0, 43226, '\P{^Sc:  	Saur}', "");
    Error('\p{Is_Script=	 Saurashtra/a/}');
    Error('\P{Is_Script=	 Saurashtra/a/}');
    Expect(1, 43225, '\p{Is_Script=saurashtra}', "");
    Expect(0, 43225, '\p{^Is_Script=saurashtra}', "");
    Expect(0, 43225, '\P{Is_Script=saurashtra}', "");
    Expect(1, 43225, '\P{^Is_Script=saurashtra}', "");
    Expect(0, 43226, '\p{Is_Script=saurashtra}', "");
    Expect(1, 43226, '\p{^Is_Script=saurashtra}', "");
    Expect(1, 43226, '\P{Is_Script=saurashtra}', "");
    Expect(0, 43226, '\P{^Is_Script=saurashtra}', "");
    Expect(1, 43225, '\p{Is_Script:   _Saurashtra}', "");
    Expect(0, 43225, '\p{^Is_Script:   _Saurashtra}', "");
    Expect(0, 43225, '\P{Is_Script:   _Saurashtra}', "");
    Expect(1, 43225, '\P{^Is_Script:   _Saurashtra}', "");
    Expect(0, 43226, '\p{Is_Script:   _Saurashtra}', "");
    Expect(1, 43226, '\p{^Is_Script:   _Saurashtra}', "");
    Expect(1, 43226, '\P{Is_Script:   _Saurashtra}', "");
    Expect(0, 43226, '\P{^Is_Script:   _Saurashtra}', "");
    Error('\p{Is_Sc=:= 	Saur}');
    Error('\P{Is_Sc=:= 	Saur}');
    Expect(1, 43225, '\p{Is_Sc=saur}', "");
    Expect(0, 43225, '\p{^Is_Sc=saur}', "");
    Expect(0, 43225, '\P{Is_Sc=saur}', "");
    Expect(1, 43225, '\P{^Is_Sc=saur}', "");
    Expect(0, 43226, '\p{Is_Sc=saur}', "");
    Expect(1, 43226, '\p{^Is_Sc=saur}', "");
    Expect(1, 43226, '\P{Is_Sc=saur}', "");
    Expect(0, 43226, '\P{^Is_Sc=saur}', "");
    Expect(1, 43225, '\p{Is_Sc=- saur}', "");
    Expect(0, 43225, '\p{^Is_Sc=- saur}', "");
    Expect(0, 43225, '\P{Is_Sc=- saur}', "");
    Expect(1, 43225, '\P{^Is_Sc=- saur}', "");
    Expect(0, 43226, '\p{Is_Sc=- saur}', "");
    Expect(1, 43226, '\p{^Is_Sc=- saur}', "");
    Expect(1, 43226, '\P{Is_Sc=- saur}', "");
    Expect(0, 43226, '\P{^Is_Sc=- saur}', "");
    Error('\p{Script: _:=signwriting}');
    Error('\P{Script: _:=signwriting}');
    Expect(1, 121519, '\p{Script=:\ASignWriting\z:}', "");;
    Expect(0, 121520, '\p{Script=:\ASignWriting\z:}', "");;
    Expect(1, 121519, '\p{Script=signwriting}', "");
    Expect(0, 121519, '\p{^Script=signwriting}', "");
    Expect(0, 121519, '\P{Script=signwriting}', "");
    Expect(1, 121519, '\P{^Script=signwriting}', "");
    Expect(0, 121520, '\p{Script=signwriting}', "");
    Expect(1, 121520, '\p{^Script=signwriting}', "");
    Expect(1, 121520, '\P{Script=signwriting}', "");
    Expect(0, 121520, '\P{^Script=signwriting}', "");
    Expect(1, 121519, '\p{Script=:\Asignwriting\z:}', "");;
    Expect(0, 121520, '\p{Script=:\Asignwriting\z:}', "");;
    Expect(1, 121519, '\p{Script=	-signwriting}', "");
    Expect(0, 121519, '\p{^Script=	-signwriting}', "");
    Expect(0, 121519, '\P{Script=	-signwriting}', "");
    Expect(1, 121519, '\P{^Script=	-signwriting}', "");
    Expect(0, 121520, '\p{Script=	-signwriting}', "");
    Expect(1, 121520, '\p{^Script=	-signwriting}', "");
    Expect(1, 121520, '\P{Script=	-signwriting}', "");
    Expect(0, 121520, '\P{^Script=	-signwriting}', "");
    Error('\p{Sc:	SGNW/a/}');
    Error('\P{Sc:	SGNW/a/}');
    Expect(1, 121519, '\p{Sc=:\ASgnw\z:}', "");;
    Expect(0, 121520, '\p{Sc=:\ASgnw\z:}', "");;
    Expect(1, 121519, '\p{Sc=sgnw}', "");
    Expect(0, 121519, '\p{^Sc=sgnw}', "");
    Expect(0, 121519, '\P{Sc=sgnw}', "");
    Expect(1, 121519, '\P{^Sc=sgnw}', "");
    Expect(0, 121520, '\p{Sc=sgnw}', "");
    Expect(1, 121520, '\p{^Sc=sgnw}', "");
    Expect(1, 121520, '\P{Sc=sgnw}', "");
    Expect(0, 121520, '\P{^Sc=sgnw}', "");
    Expect(1, 121519, '\p{Sc=:\Asgnw\z:}', "");;
    Expect(0, 121520, '\p{Sc=:\Asgnw\z:}', "");;
    Expect(1, 121519, '\p{Sc=-_SGNW}', "");
    Expect(0, 121519, '\p{^Sc=-_SGNW}', "");
    Expect(0, 121519, '\P{Sc=-_SGNW}', "");
    Expect(1, 121519, '\P{^Sc=-_SGNW}', "");
    Expect(0, 121520, '\p{Sc=-_SGNW}', "");
    Expect(1, 121520, '\p{^Sc=-_SGNW}', "");
    Expect(1, 121520, '\P{Sc=-_SGNW}', "");
    Expect(0, 121520, '\P{^Sc=-_SGNW}', "");
    Error('\p{Is_Script:   :=_	SIGNWRITING}');
    Error('\P{Is_Script:   :=_	SIGNWRITING}');
    Expect(1, 121519, '\p{Is_Script=signwriting}', "");
    Expect(0, 121519, '\p{^Is_Script=signwriting}', "");
    Expect(0, 121519, '\P{Is_Script=signwriting}', "");
    Expect(1, 121519, '\P{^Is_Script=signwriting}', "");
    Expect(0, 121520, '\p{Is_Script=signwriting}', "");
    Expect(1, 121520, '\p{^Is_Script=signwriting}', "");
    Expect(1, 121520, '\P{Is_Script=signwriting}', "");
    Expect(0, 121520, '\P{^Is_Script=signwriting}', "");
    Expect(1, 121519, '\p{Is_Script= -SignWriting}', "");
    Expect(0, 121519, '\p{^Is_Script= -SignWriting}', "");
    Expect(0, 121519, '\P{Is_Script= -SignWriting}', "");
    Expect(1, 121519, '\P{^Is_Script= -SignWriting}', "");
    Expect(0, 121520, '\p{Is_Script= -SignWriting}', "");
    Expect(1, 121520, '\p{^Is_Script= -SignWriting}', "");
    Expect(1, 121520, '\P{Is_Script= -SignWriting}', "");
    Expect(0, 121520, '\P{^Is_Script= -SignWriting}', "");
    Error('\p{Is_Sc=/a/SGNW}');
    Error('\P{Is_Sc=/a/SGNW}');
    Expect(1, 121519, '\p{Is_Sc=sgnw}', "");
    Expect(0, 121519, '\p{^Is_Sc=sgnw}', "");
    Expect(0, 121519, '\P{Is_Sc=sgnw}', "");
    Expect(1, 121519, '\P{^Is_Sc=sgnw}', "");
    Expect(0, 121520, '\p{Is_Sc=sgnw}', "");
    Expect(1, 121520, '\p{^Is_Sc=sgnw}', "");
    Expect(1, 121520, '\P{Is_Sc=sgnw}', "");
    Expect(0, 121520, '\P{^Is_Sc=sgnw}', "");
    Expect(1, 121519, '\p{Is_Sc=-SGNW}', "");
    Expect(0, 121519, '\p{^Is_Sc=-SGNW}', "");
    Expect(0, 121519, '\P{Is_Sc=-SGNW}', "");
    Expect(1, 121519, '\P{^Is_Sc=-SGNW}', "");
    Expect(0, 121520, '\p{Is_Sc=-SGNW}', "");
    Expect(1, 121520, '\p{^Is_Sc=-SGNW}', "");
    Expect(1, 121520, '\P{Is_Sc=-SGNW}', "");
    Expect(0, 121520, '\P{^Is_Sc=-SGNW}', "");
    Error('\p{Script= -Shavian:=}');
    Error('\P{Script= -Shavian:=}');
    Expect(1, 66687, '\p{Script=:\AShavian\z:}', "");;
    Expect(0, 66688, '\p{Script=:\AShavian\z:}', "");;
    Expect(1, 66687, '\p{Script=shavian}', "");
    Expect(0, 66687, '\p{^Script=shavian}', "");
    Expect(0, 66687, '\P{Script=shavian}', "");
    Expect(1, 66687, '\P{^Script=shavian}', "");
    Expect(0, 66688, '\p{Script=shavian}', "");
    Expect(1, 66688, '\p{^Script=shavian}', "");
    Expect(1, 66688, '\P{Script=shavian}', "");
    Expect(0, 66688, '\P{^Script=shavian}', "");
    Expect(1, 66687, '\p{Script=:\Ashavian\z:}', "");;
    Expect(0, 66688, '\p{Script=:\Ashavian\z:}', "");;
    Expect(1, 66687, '\p{Script=-	Shavian}', "");
    Expect(0, 66687, '\p{^Script=-	Shavian}', "");
    Expect(0, 66687, '\P{Script=-	Shavian}', "");
    Expect(1, 66687, '\P{^Script=-	Shavian}', "");
    Expect(0, 66688, '\p{Script=-	Shavian}', "");
    Expect(1, 66688, '\p{^Script=-	Shavian}', "");
    Expect(1, 66688, '\P{Script=-	Shavian}', "");
    Expect(0, 66688, '\P{^Script=-	Shavian}', "");
    Error('\p{Sc=:=Shaw}');
    Error('\P{Sc=:=Shaw}');
    Expect(1, 66687, '\p{Sc=:\AShaw\z:}', "");;
    Expect(0, 66688, '\p{Sc=:\AShaw\z:}', "");;
    Expect(1, 66687, '\p{Sc=shaw}', "");
    Expect(0, 66687, '\p{^Sc=shaw}', "");
    Expect(0, 66687, '\P{Sc=shaw}', "");
    Expect(1, 66687, '\P{^Sc=shaw}', "");
    Expect(0, 66688, '\p{Sc=shaw}', "");
    Expect(1, 66688, '\p{^Sc=shaw}', "");
    Expect(1, 66688, '\P{Sc=shaw}', "");
    Expect(0, 66688, '\P{^Sc=shaw}', "");
    Expect(1, 66687, '\p{Sc=:\Ashaw\z:}', "");;
    Expect(0, 66688, '\p{Sc=:\Ashaw\z:}', "");;
    Expect(1, 66687, '\p{Sc=-	Shaw}', "");
    Expect(0, 66687, '\p{^Sc=-	Shaw}', "");
    Expect(0, 66687, '\P{Sc=-	Shaw}', "");
    Expect(1, 66687, '\P{^Sc=-	Shaw}', "");
    Expect(0, 66688, '\p{Sc=-	Shaw}', "");
    Expect(1, 66688, '\p{^Sc=-	Shaw}', "");
    Expect(1, 66688, '\P{Sc=-	Shaw}', "");
    Expect(0, 66688, '\P{^Sc=-	Shaw}', "");
    Error('\p{Is_Script=--Shavian:=}');
    Error('\P{Is_Script=--Shavian:=}');
    Expect(1, 66687, '\p{Is_Script=shavian}', "");
    Expect(0, 66687, '\p{^Is_Script=shavian}', "");
    Expect(0, 66687, '\P{Is_Script=shavian}', "");
    Expect(1, 66687, '\P{^Is_Script=shavian}', "");
    Expect(0, 66688, '\p{Is_Script=shavian}', "");
    Expect(1, 66688, '\p{^Is_Script=shavian}', "");
    Expect(1, 66688, '\P{Is_Script=shavian}', "");
    Expect(0, 66688, '\P{^Is_Script=shavian}', "");
    Expect(1, 66687, '\p{Is_Script=--SHAVIAN}', "");
    Expect(0, 66687, '\p{^Is_Script=--SHAVIAN}', "");
    Expect(0, 66687, '\P{Is_Script=--SHAVIAN}', "");
    Expect(1, 66687, '\P{^Is_Script=--SHAVIAN}', "");
    Expect(0, 66688, '\p{Is_Script=--SHAVIAN}', "");
    Expect(1, 66688, '\p{^Is_Script=--SHAVIAN}', "");
    Expect(1, 66688, '\P{Is_Script=--SHAVIAN}', "");
    Expect(0, 66688, '\P{^Is_Script=--SHAVIAN}', "");
    Error('\p{Is_Sc=-_Shaw:=}');
    Error('\P{Is_Sc=-_Shaw:=}');
    Expect(1, 66687, '\p{Is_Sc=shaw}', "");
    Expect(0, 66687, '\p{^Is_Sc=shaw}', "");
    Expect(0, 66687, '\P{Is_Sc=shaw}', "");
    Expect(1, 66687, '\P{^Is_Sc=shaw}', "");
    Expect(0, 66688, '\p{Is_Sc=shaw}', "");
    Expect(1, 66688, '\p{^Is_Sc=shaw}', "");
    Expect(1, 66688, '\P{Is_Sc=shaw}', "");
    Expect(0, 66688, '\P{^Is_Sc=shaw}', "");
    Expect(1, 66687, '\p{Is_Sc=_Shaw}', "");
    Expect(0, 66687, '\p{^Is_Sc=_Shaw}', "");
    Expect(0, 66687, '\P{Is_Sc=_Shaw}', "");
    Expect(1, 66687, '\P{^Is_Sc=_Shaw}', "");
    Expect(0, 66688, '\p{Is_Sc=_Shaw}', "");
    Expect(1, 66688, '\p{^Is_Sc=_Shaw}', "");
    Expect(1, 66688, '\P{Is_Sc=_Shaw}', "");
    Expect(0, 66688, '\P{^Is_Sc=_Shaw}', "");
    Error('\p{Script= /a/Sharada}');
    Error('\P{Script= /a/Sharada}');
    Expect(1, 70111, '\p{Script=:\ASharada\z:}', "");;
    Expect(0, 70112, '\p{Script=:\ASharada\z:}', "");;
    Expect(1, 70111, '\p{Script=sharada}', "");
    Expect(0, 70111, '\p{^Script=sharada}', "");
    Expect(0, 70111, '\P{Script=sharada}', "");
    Expect(1, 70111, '\P{^Script=sharada}', "");
    Expect(0, 70112, '\p{Script=sharada}', "");
    Expect(1, 70112, '\p{^Script=sharada}', "");
    Expect(1, 70112, '\P{Script=sharada}', "");
    Expect(0, 70112, '\P{^Script=sharada}', "");
    Expect(1, 70111, '\p{Script=:\Asharada\z:}', "");;
    Expect(0, 70112, '\p{Script=:\Asharada\z:}', "");;
    Expect(1, 70111, '\p{Script=-Sharada}', "");
    Expect(0, 70111, '\p{^Script=-Sharada}', "");
    Expect(0, 70111, '\P{Script=-Sharada}', "");
    Expect(1, 70111, '\P{^Script=-Sharada}', "");
    Expect(0, 70112, '\p{Script=-Sharada}', "");
    Expect(1, 70112, '\p{^Script=-Sharada}', "");
    Expect(1, 70112, '\P{Script=-Sharada}', "");
    Expect(0, 70112, '\P{^Script=-Sharada}', "");
    Error('\p{Sc=:=shrd}');
    Error('\P{Sc=:=shrd}');
    Expect(1, 70111, '\p{Sc=:\AShrd\z:}', "");;
    Expect(0, 70112, '\p{Sc=:\AShrd\z:}', "");;
    Expect(1, 70111, '\p{Sc=shrd}', "");
    Expect(0, 70111, '\p{^Sc=shrd}', "");
    Expect(0, 70111, '\P{Sc=shrd}', "");
    Expect(1, 70111, '\P{^Sc=shrd}', "");
    Expect(0, 70112, '\p{Sc=shrd}', "");
    Expect(1, 70112, '\p{^Sc=shrd}', "");
    Expect(1, 70112, '\P{Sc=shrd}', "");
    Expect(0, 70112, '\P{^Sc=shrd}', "");
    Expect(1, 70111, '\p{Sc=:\Ashrd\z:}', "");;
    Expect(0, 70112, '\p{Sc=:\Ashrd\z:}', "");;
    Expect(1, 70111, '\p{Sc= shrd}', "");
    Expect(0, 70111, '\p{^Sc= shrd}', "");
    Expect(0, 70111, '\P{Sc= shrd}', "");
    Expect(1, 70111, '\P{^Sc= shrd}', "");
    Expect(0, 70112, '\p{Sc= shrd}', "");
    Expect(1, 70112, '\p{^Sc= shrd}', "");
    Expect(1, 70112, '\P{Sc= shrd}', "");
    Expect(0, 70112, '\P{^Sc= shrd}', "");
    Error('\p{Is_Script=	/a/SHARADA}');
    Error('\P{Is_Script=	/a/SHARADA}');
    Expect(1, 70111, '\p{Is_Script=sharada}', "");
    Expect(0, 70111, '\p{^Is_Script=sharada}', "");
    Expect(0, 70111, '\P{Is_Script=sharada}', "");
    Expect(1, 70111, '\P{^Is_Script=sharada}', "");
    Expect(0, 70112, '\p{Is_Script=sharada}', "");
    Expect(1, 70112, '\p{^Is_Script=sharada}', "");
    Expect(1, 70112, '\P{Is_Script=sharada}', "");
    Expect(0, 70112, '\P{^Is_Script=sharada}', "");
    Expect(1, 70111, '\p{Is_Script=-	Sharada}', "");
    Expect(0, 70111, '\p{^Is_Script=-	Sharada}', "");
    Expect(0, 70111, '\P{Is_Script=-	Sharada}', "");
    Expect(1, 70111, '\P{^Is_Script=-	Sharada}', "");
    Expect(0, 70112, '\p{Is_Script=-	Sharada}', "");
    Expect(1, 70112, '\p{^Is_Script=-	Sharada}', "");
    Expect(1, 70112, '\P{Is_Script=-	Sharada}', "");
    Expect(0, 70112, '\P{^Is_Script=-	Sharada}', "");
    Error('\p{Is_Sc= Shrd:=}');
    Error('\P{Is_Sc= Shrd:=}');
    Expect(1, 70111, '\p{Is_Sc=shrd}', "");
    Expect(0, 70111, '\p{^Is_Sc=shrd}', "");
    Expect(0, 70111, '\P{Is_Sc=shrd}', "");
    Expect(1, 70111, '\P{^Is_Sc=shrd}', "");
    Expect(0, 70112, '\p{Is_Sc=shrd}', "");
    Expect(1, 70112, '\p{^Is_Sc=shrd}', "");
    Expect(1, 70112, '\P{Is_Sc=shrd}', "");
    Expect(0, 70112, '\P{^Is_Sc=shrd}', "");
    Expect(1, 70111, '\p{Is_Sc=Shrd}', "");
    Expect(0, 70111, '\p{^Is_Sc=Shrd}', "");
    Expect(0, 70111, '\P{Is_Sc=Shrd}', "");
    Expect(1, 70111, '\P{^Is_Sc=Shrd}', "");
    Expect(0, 70112, '\p{Is_Sc=Shrd}', "");
    Expect(1, 70112, '\p{^Is_Sc=Shrd}', "");
    Expect(1, 70112, '\P{Is_Sc=Shrd}', "");
    Expect(0, 70112, '\P{^Is_Sc=Shrd}', "");
    Error('\p{Script=:=_SIDDHAM}');
    Error('\P{Script=:=_SIDDHAM}');
    Expect(1, 71133, '\p{Script=:\ASiddham\z:}', "");;
    Expect(0, 71134, '\p{Script=:\ASiddham\z:}', "");;
    Expect(1, 71133, '\p{Script:siddham}', "");
    Expect(0, 71133, '\p{^Script:siddham}', "");
    Expect(0, 71133, '\P{Script:siddham}', "");
    Expect(1, 71133, '\P{^Script:siddham}', "");
    Expect(0, 71134, '\p{Script:siddham}', "");
    Expect(1, 71134, '\p{^Script:siddham}', "");
    Expect(1, 71134, '\P{Script:siddham}', "");
    Expect(0, 71134, '\P{^Script:siddham}', "");
    Expect(1, 71133, '\p{Script=:\Asiddham\z:}', "");;
    Expect(0, 71134, '\p{Script=:\Asiddham\z:}', "");;
    Expect(1, 71133, '\p{Script= -siddham}', "");
    Expect(0, 71133, '\p{^Script= -siddham}', "");
    Expect(0, 71133, '\P{Script= -siddham}', "");
    Expect(1, 71133, '\P{^Script= -siddham}', "");
    Expect(0, 71134, '\p{Script= -siddham}', "");
    Expect(1, 71134, '\p{^Script= -siddham}', "");
    Expect(1, 71134, '\P{Script= -siddham}', "");
    Expect(0, 71134, '\P{^Script= -siddham}', "");
    Error('\p{Sc= :=sidd}');
    Error('\P{Sc= :=sidd}');
    Expect(1, 71133, '\p{Sc=:\ASidd\z:}', "");;
    Expect(0, 71134, '\p{Sc=:\ASidd\z:}', "");;
    Expect(1, 71133, '\p{Sc:sidd}', "");
    Expect(0, 71133, '\p{^Sc:sidd}', "");
    Expect(0, 71133, '\P{Sc:sidd}', "");
    Expect(1, 71133, '\P{^Sc:sidd}', "");
    Expect(0, 71134, '\p{Sc:sidd}', "");
    Expect(1, 71134, '\p{^Sc:sidd}', "");
    Expect(1, 71134, '\P{Sc:sidd}', "");
    Expect(0, 71134, '\P{^Sc:sidd}', "");
    Expect(1, 71133, '\p{Sc=:\Asidd\z:}', "");;
    Expect(0, 71134, '\p{Sc=:\Asidd\z:}', "");;
    Expect(1, 71133, '\p{Sc=  SIDD}', "");
    Expect(0, 71133, '\p{^Sc=  SIDD}', "");
    Expect(0, 71133, '\P{Sc=  SIDD}', "");
    Expect(1, 71133, '\P{^Sc=  SIDD}', "");
    Expect(0, 71134, '\p{Sc=  SIDD}', "");
    Expect(1, 71134, '\p{^Sc=  SIDD}', "");
    Expect(1, 71134, '\P{Sc=  SIDD}', "");
    Expect(0, 71134, '\P{^Sc=  SIDD}', "");
    Error('\p{Is_Script=-:=SIDDHAM}');
    Error('\P{Is_Script=-:=SIDDHAM}');
    Expect(1, 71133, '\p{Is_Script:   siddham}', "");
    Expect(0, 71133, '\p{^Is_Script:   siddham}', "");
    Expect(0, 71133, '\P{Is_Script:   siddham}', "");
    Expect(1, 71133, '\P{^Is_Script:   siddham}', "");
    Expect(0, 71134, '\p{Is_Script:   siddham}', "");
    Expect(1, 71134, '\p{^Is_Script:   siddham}', "");
    Expect(1, 71134, '\P{Is_Script:   siddham}', "");
    Expect(0, 71134, '\P{^Is_Script:   siddham}', "");
    Expect(1, 71133, '\p{Is_Script= _SIDDHAM}', "");
    Expect(0, 71133, '\p{^Is_Script= _SIDDHAM}', "");
    Expect(0, 71133, '\P{Is_Script= _SIDDHAM}', "");
    Expect(1, 71133, '\P{^Is_Script= _SIDDHAM}', "");
    Expect(0, 71134, '\p{Is_Script= _SIDDHAM}', "");
    Expect(1, 71134, '\p{^Is_Script= _SIDDHAM}', "");
    Expect(1, 71134, '\P{Is_Script= _SIDDHAM}', "");
    Expect(0, 71134, '\P{^Is_Script= _SIDDHAM}', "");
    Error('\p{Is_Sc=/a/_Sidd}');
    Error('\P{Is_Sc=/a/_Sidd}');
    Expect(1, 71133, '\p{Is_Sc=sidd}', "");
    Expect(0, 71133, '\p{^Is_Sc=sidd}', "");
    Expect(0, 71133, '\P{Is_Sc=sidd}', "");
    Expect(1, 71133, '\P{^Is_Sc=sidd}', "");
    Expect(0, 71134, '\p{Is_Sc=sidd}', "");
    Expect(1, 71134, '\p{^Is_Sc=sidd}', "");
    Expect(1, 71134, '\P{Is_Sc=sidd}', "");
    Expect(0, 71134, '\P{^Is_Sc=sidd}', "");
    Expect(1, 71133, '\p{Is_Sc=_Sidd}', "");
    Expect(0, 71133, '\p{^Is_Sc=_Sidd}', "");
    Expect(0, 71133, '\P{Is_Sc=_Sidd}', "");
    Expect(1, 71133, '\P{^Is_Sc=_Sidd}', "");
    Expect(0, 71134, '\p{Is_Sc=_Sidd}', "");
    Expect(1, 71134, '\p{^Is_Sc=_Sidd}', "");
    Expect(1, 71134, '\P{Is_Sc=_Sidd}', "");
    Expect(0, 71134, '\P{^Is_Sc=_Sidd}', "");
    Error('\p{Script=-/a/KHUDAWADI}');
    Error('\P{Script=-/a/KHUDAWADI}');
    Expect(1, 70393, '\p{Script=:\AKhudawadi\z:}', "");;
    Expect(0, 70394, '\p{Script=:\AKhudawadi\z:}', "");;
    Expect(1, 70393, '\p{Script=khudawadi}', "");
    Expect(0, 70393, '\p{^Script=khudawadi}', "");
    Expect(0, 70393, '\P{Script=khudawadi}', "");
    Expect(1, 70393, '\P{^Script=khudawadi}', "");
    Expect(0, 70394, '\p{Script=khudawadi}', "");
    Expect(1, 70394, '\p{^Script=khudawadi}', "");
    Expect(1, 70394, '\P{Script=khudawadi}', "");
    Expect(0, 70394, '\P{^Script=khudawadi}', "");
    Expect(1, 70393, '\p{Script=:\Akhudawadi\z:}', "");;
    Expect(0, 70394, '\p{Script=:\Akhudawadi\z:}', "");;
    Expect(1, 70393, '\p{Script=_ Khudawadi}', "");
    Expect(0, 70393, '\p{^Script=_ Khudawadi}', "");
    Expect(0, 70393, '\P{Script=_ Khudawadi}', "");
    Expect(1, 70393, '\P{^Script=_ Khudawadi}', "");
    Expect(0, 70394, '\p{Script=_ Khudawadi}', "");
    Expect(1, 70394, '\p{^Script=_ Khudawadi}', "");
    Expect(1, 70394, '\P{Script=_ Khudawadi}', "");
    Expect(0, 70394, '\P{^Script=_ Khudawadi}', "");
    Error('\p{Sc=/a/Sind}');
    Error('\P{Sc=/a/Sind}');
    Expect(1, 70393, '\p{Sc=:\ASind\z:}', "");;
    Expect(0, 70394, '\p{Sc=:\ASind\z:}', "");;
    Expect(1, 70393, '\p{Sc=sind}', "");
    Expect(0, 70393, '\p{^Sc=sind}', "");
    Expect(0, 70393, '\P{Sc=sind}', "");
    Expect(1, 70393, '\P{^Sc=sind}', "");
    Expect(0, 70394, '\p{Sc=sind}', "");
    Expect(1, 70394, '\p{^Sc=sind}', "");
    Expect(1, 70394, '\P{Sc=sind}', "");
    Expect(0, 70394, '\P{^Sc=sind}', "");
    Expect(1, 70393, '\p{Sc=:\Asind\z:}', "");;
    Expect(0, 70394, '\p{Sc=:\Asind\z:}', "");;
    Expect(1, 70393, '\p{Sc=- SIND}', "");
    Expect(0, 70393, '\p{^Sc=- SIND}', "");
    Expect(0, 70393, '\P{Sc=- SIND}', "");
    Expect(1, 70393, '\P{^Sc=- SIND}', "");
    Expect(0, 70394, '\p{Sc=- SIND}', "");
    Expect(1, 70394, '\p{^Sc=- SIND}', "");
    Expect(1, 70394, '\P{Sc=- SIND}', "");
    Expect(0, 70394, '\P{^Sc=- SIND}', "");
    Error('\p{Is_Script= Khudawadi:=}');
    Error('\P{Is_Script= Khudawadi:=}');
    Expect(1, 70393, '\p{Is_Script=khudawadi}', "");
    Expect(0, 70393, '\p{^Is_Script=khudawadi}', "");
    Expect(0, 70393, '\P{Is_Script=khudawadi}', "");
    Expect(1, 70393, '\P{^Is_Script=khudawadi}', "");
    Expect(0, 70394, '\p{Is_Script=khudawadi}', "");
    Expect(1, 70394, '\p{^Is_Script=khudawadi}', "");
    Expect(1, 70394, '\P{Is_Script=khudawadi}', "");
    Expect(0, 70394, '\P{^Is_Script=khudawadi}', "");
    Expect(1, 70393, '\p{Is_Script=Khudawadi}', "");
    Expect(0, 70393, '\p{^Is_Script=Khudawadi}', "");
    Expect(0, 70393, '\P{Is_Script=Khudawadi}', "");
    Expect(1, 70393, '\P{^Is_Script=Khudawadi}', "");
    Expect(0, 70394, '\p{Is_Script=Khudawadi}', "");
    Expect(1, 70394, '\p{^Is_Script=Khudawadi}', "");
    Expect(1, 70394, '\P{Is_Script=Khudawadi}', "");
    Expect(0, 70394, '\P{^Is_Script=Khudawadi}', "");
    Error('\p{Is_Sc=_-Sind:=}');
    Error('\P{Is_Sc=_-Sind:=}');
    Expect(1, 70393, '\p{Is_Sc=sind}', "");
    Expect(0, 70393, '\p{^Is_Sc=sind}', "");
    Expect(0, 70393, '\P{Is_Sc=sind}', "");
    Expect(1, 70393, '\P{^Is_Sc=sind}', "");
    Expect(0, 70394, '\p{Is_Sc=sind}', "");
    Expect(1, 70394, '\p{^Is_Sc=sind}', "");
    Expect(1, 70394, '\P{Is_Sc=sind}', "");
    Expect(0, 70394, '\P{^Is_Sc=sind}', "");
    Expect(1, 70393, '\p{Is_Sc=	_Sind}', "");
    Expect(0, 70393, '\p{^Is_Sc=	_Sind}', "");
    Expect(0, 70393, '\P{Is_Sc=	_Sind}', "");
    Expect(1, 70393, '\P{^Is_Sc=	_Sind}', "");
    Expect(0, 70394, '\p{Is_Sc=	_Sind}', "");
    Expect(1, 70394, '\p{^Is_Sc=	_Sind}', "");
    Expect(1, 70394, '\P{Is_Sc=	_Sind}', "");
    Expect(0, 70394, '\P{^Is_Sc=	_Sind}', "");
    Error('\p{Script=_-SINHALA/a/}');
    Error('\P{Script=_-SINHALA/a/}');
    Expect(1, 70132, '\p{Script=:\ASinhala\z:}', "");;
    Expect(0, 70133, '\p{Script=:\ASinhala\z:}', "");;
    Expect(1, 70132, '\p{Script=sinhala}', "");
    Expect(0, 70132, '\p{^Script=sinhala}', "");
    Expect(0, 70132, '\P{Script=sinhala}', "");
    Expect(1, 70132, '\P{^Script=sinhala}', "");
    Expect(0, 70133, '\p{Script=sinhala}', "");
    Expect(1, 70133, '\p{^Script=sinhala}', "");
    Expect(1, 70133, '\P{Script=sinhala}', "");
    Expect(0, 70133, '\P{^Script=sinhala}', "");
    Expect(1, 70132, '\p{Script=:\Asinhala\z:}', "");;
    Expect(0, 70133, '\p{Script=:\Asinhala\z:}', "");;
    Expect(1, 70132, '\p{Script:		-sinhala}', "");
    Expect(0, 70132, '\p{^Script:		-sinhala}', "");
    Expect(0, 70132, '\P{Script:		-sinhala}', "");
    Expect(1, 70132, '\P{^Script:		-sinhala}', "");
    Expect(0, 70133, '\p{Script:		-sinhala}', "");
    Expect(1, 70133, '\p{^Script:		-sinhala}', "");
    Expect(1, 70133, '\P{Script:		-sinhala}', "");
    Expect(0, 70133, '\P{^Script:		-sinhala}', "");
    Error('\p{Sc=/a/_	SINH}');
    Error('\P{Sc=/a/_	SINH}');
    Expect(1, 70132, '\p{Sc=:\ASinh\z:}', "");;
    Expect(0, 70133, '\p{Sc=:\ASinh\z:}', "");;
    Expect(1, 70132, '\p{Sc:   sinh}', "");
    Expect(0, 70132, '\p{^Sc:   sinh}', "");
    Expect(0, 70132, '\P{Sc:   sinh}', "");
    Expect(1, 70132, '\P{^Sc:   sinh}', "");
    Expect(0, 70133, '\p{Sc:   sinh}', "");
    Expect(1, 70133, '\p{^Sc:   sinh}', "");
    Expect(1, 70133, '\P{Sc:   sinh}', "");
    Expect(0, 70133, '\P{^Sc:   sinh}', "");
    Expect(1, 70132, '\p{Sc=:\Asinh\z:}', "");;
    Expect(0, 70133, '\p{Sc=:\Asinh\z:}', "");;
    Expect(1, 70132, '\p{Sc=-_SINH}', "");
    Expect(0, 70132, '\p{^Sc=-_SINH}', "");
    Expect(0, 70132, '\P{Sc=-_SINH}', "");
    Expect(1, 70132, '\P{^Sc=-_SINH}', "");
    Expect(0, 70133, '\p{Sc=-_SINH}', "");
    Expect(1, 70133, '\p{^Sc=-_SINH}', "");
    Expect(1, 70133, '\P{Sc=-_SINH}', "");
    Expect(0, 70133, '\P{^Sc=-_SINH}', "");
    Error('\p{Is_Script: :=_-SINHALA}');
    Error('\P{Is_Script: :=_-SINHALA}');
    Expect(1, 70132, '\p{Is_Script=sinhala}', "");
    Expect(0, 70132, '\p{^Is_Script=sinhala}', "");
    Expect(0, 70132, '\P{Is_Script=sinhala}', "");
    Expect(1, 70132, '\P{^Is_Script=sinhala}', "");
    Expect(0, 70133, '\p{Is_Script=sinhala}', "");
    Expect(1, 70133, '\p{^Is_Script=sinhala}', "");
    Expect(1, 70133, '\P{Is_Script=sinhala}', "");
    Expect(0, 70133, '\P{^Is_Script=sinhala}', "");
    Expect(1, 70132, '\p{Is_Script=_ sinhala}', "");
    Expect(0, 70132, '\p{^Is_Script=_ sinhala}', "");
    Expect(0, 70132, '\P{Is_Script=_ sinhala}', "");
    Expect(1, 70132, '\P{^Is_Script=_ sinhala}', "");
    Expect(0, 70133, '\p{Is_Script=_ sinhala}', "");
    Expect(1, 70133, '\p{^Is_Script=_ sinhala}', "");
    Expect(1, 70133, '\P{Is_Script=_ sinhala}', "");
    Expect(0, 70133, '\P{^Is_Script=_ sinhala}', "");
    Error('\p{Is_Sc=	_sinh/a/}');
    Error('\P{Is_Sc=	_sinh/a/}');
    Expect(1, 70132, '\p{Is_Sc:	sinh}', "");
    Expect(0, 70132, '\p{^Is_Sc:	sinh}', "");
    Expect(0, 70132, '\P{Is_Sc:	sinh}', "");
    Expect(1, 70132, '\P{^Is_Sc:	sinh}', "");
    Expect(0, 70133, '\p{Is_Sc:	sinh}', "");
    Expect(1, 70133, '\p{^Is_Sc:	sinh}', "");
    Expect(1, 70133, '\P{Is_Sc:	sinh}', "");
    Expect(0, 70133, '\P{^Is_Sc:	sinh}', "");
    Expect(1, 70132, '\p{Is_Sc=_SINH}', "");
    Expect(0, 70132, '\p{^Is_Sc=_SINH}', "");
    Expect(0, 70132, '\P{Is_Sc=_SINH}', "");
    Expect(1, 70132, '\P{^Is_Sc=_SINH}', "");
    Expect(0, 70133, '\p{Is_Sc=_SINH}', "");
    Expect(1, 70133, '\p{^Is_Sc=_SINH}', "");
    Expect(1, 70133, '\P{Is_Sc=_SINH}', "");
    Expect(0, 70133, '\P{^Is_Sc=_SINH}', "");
    Error('\p{Script=:=SOGDIAN}');
    Error('\P{Script=:=SOGDIAN}');
    Expect(1, 69465, '\p{Script=:\ASogdian\z:}', "");;
    Expect(0, 69466, '\p{Script=:\ASogdian\z:}', "");;
    Expect(1, 69465, '\p{Script=sogdian}', "");
    Expect(0, 69465, '\p{^Script=sogdian}', "");
    Expect(0, 69465, '\P{Script=sogdian}', "");
    Expect(1, 69465, '\P{^Script=sogdian}', "");
    Expect(0, 69466, '\p{Script=sogdian}', "");
    Expect(1, 69466, '\p{^Script=sogdian}', "");
    Expect(1, 69466, '\P{Script=sogdian}', "");
    Expect(0, 69466, '\P{^Script=sogdian}', "");
    Expect(1, 69465, '\p{Script=:\Asogdian\z:}', "");;
    Expect(0, 69466, '\p{Script=:\Asogdian\z:}', "");;
    Expect(1, 69465, '\p{Script=		SOGDIAN}', "");
    Expect(0, 69465, '\p{^Script=		SOGDIAN}', "");
    Expect(0, 69465, '\P{Script=		SOGDIAN}', "");
    Expect(1, 69465, '\P{^Script=		SOGDIAN}', "");
    Expect(0, 69466, '\p{Script=		SOGDIAN}', "");
    Expect(1, 69466, '\p{^Script=		SOGDIAN}', "");
    Expect(1, 69466, '\P{Script=		SOGDIAN}', "");
    Expect(0, 69466, '\P{^Script=		SOGDIAN}', "");
    Error('\p{Sc=:=_Sogd}');
    Error('\P{Sc=:=_Sogd}');
    Expect(1, 69465, '\p{Sc=:\ASogd\z:}', "");;
    Expect(0, 69466, '\p{Sc=:\ASogd\z:}', "");;
    Expect(1, 69465, '\p{Sc=sogd}', "");
    Expect(0, 69465, '\p{^Sc=sogd}', "");
    Expect(0, 69465, '\P{Sc=sogd}', "");
    Expect(1, 69465, '\P{^Sc=sogd}', "");
    Expect(0, 69466, '\p{Sc=sogd}', "");
    Expect(1, 69466, '\p{^Sc=sogd}', "");
    Expect(1, 69466, '\P{Sc=sogd}', "");
    Expect(0, 69466, '\P{^Sc=sogd}', "");
    Expect(1, 69465, '\p{Sc=:\Asogd\z:}', "");;
    Expect(0, 69466, '\p{Sc=:\Asogd\z:}', "");;
    Expect(1, 69465, '\p{Sc=- Sogd}', "");
    Expect(0, 69465, '\p{^Sc=- Sogd}', "");
    Expect(0, 69465, '\P{Sc=- Sogd}', "");
    Expect(1, 69465, '\P{^Sc=- Sogd}', "");
    Expect(0, 69466, '\p{Sc=- Sogd}', "");
    Expect(1, 69466, '\p{^Sc=- Sogd}', "");
    Expect(1, 69466, '\P{Sc=- Sogd}', "");
    Expect(0, 69466, '\P{^Sc=- Sogd}', "");
    Error('\p{Is_Script=sogdian/a/}');
    Error('\P{Is_Script=sogdian/a/}');
    Expect(1, 69465, '\p{Is_Script=sogdian}', "");
    Expect(0, 69465, '\p{^Is_Script=sogdian}', "");
    Expect(0, 69465, '\P{Is_Script=sogdian}', "");
    Expect(1, 69465, '\P{^Is_Script=sogdian}', "");
    Expect(0, 69466, '\p{Is_Script=sogdian}', "");
    Expect(1, 69466, '\p{^Is_Script=sogdian}', "");
    Expect(1, 69466, '\P{Is_Script=sogdian}', "");
    Expect(0, 69466, '\P{^Is_Script=sogdian}', "");
    Expect(1, 69465, '\p{Is_Script=SOGDIAN}', "");
    Expect(0, 69465, '\p{^Is_Script=SOGDIAN}', "");
    Expect(0, 69465, '\P{Is_Script=SOGDIAN}', "");
    Expect(1, 69465, '\P{^Is_Script=SOGDIAN}', "");
    Expect(0, 69466, '\p{Is_Script=SOGDIAN}', "");
    Expect(1, 69466, '\p{^Is_Script=SOGDIAN}', "");
    Expect(1, 69466, '\P{Is_Script=SOGDIAN}', "");
    Expect(0, 69466, '\P{^Is_Script=SOGDIAN}', "");
    Error('\p{Is_Sc=/a/		Sogd}');
    Error('\P{Is_Sc=/a/		Sogd}');
    Expect(1, 69465, '\p{Is_Sc=sogd}', "");
    Expect(0, 69465, '\p{^Is_Sc=sogd}', "");
    Expect(0, 69465, '\P{Is_Sc=sogd}', "");
    Expect(1, 69465, '\P{^Is_Sc=sogd}', "");
    Expect(0, 69466, '\p{Is_Sc=sogd}', "");
    Expect(1, 69466, '\p{^Is_Sc=sogd}', "");
    Expect(1, 69466, '\P{Is_Sc=sogd}', "");
    Expect(0, 69466, '\P{^Is_Sc=sogd}', "");
    Expect(1, 69465, '\p{Is_Sc=SOGD}', "");
    Expect(0, 69465, '\p{^Is_Sc=SOGD}', "");
    Expect(0, 69465, '\P{Is_Sc=SOGD}', "");
    Expect(1, 69465, '\P{^Is_Sc=SOGD}', "");
    Expect(0, 69466, '\p{Is_Sc=SOGD}', "");
    Expect(1, 69466, '\p{^Is_Sc=SOGD}', "");
    Expect(1, 69466, '\P{Is_Sc=SOGD}', "");
    Expect(0, 69466, '\P{^Is_Sc=SOGD}', "");
    Error('\p{Script=/a/old_sogdian}');
    Error('\P{Script=/a/old_sogdian}');
    Expect(1, 69415, '\p{Script=:\AOld_Sogdian\z:}', "");;
    Expect(0, 69416, '\p{Script=:\AOld_Sogdian\z:}', "");;
    Expect(1, 69415, '\p{Script=oldsogdian}', "");
    Expect(0, 69415, '\p{^Script=oldsogdian}', "");
    Expect(0, 69415, '\P{Script=oldsogdian}', "");
    Expect(1, 69415, '\P{^Script=oldsogdian}', "");
    Expect(0, 69416, '\p{Script=oldsogdian}', "");
    Expect(1, 69416, '\p{^Script=oldsogdian}', "");
    Expect(1, 69416, '\P{Script=oldsogdian}', "");
    Expect(0, 69416, '\P{^Script=oldsogdian}', "");
    Expect(1, 69415, '\p{Script=:\Aoldsogdian\z:}', "");;
    Expect(0, 69416, '\p{Script=:\Aoldsogdian\z:}', "");;
    Expect(1, 69415, '\p{Script=	_old_SOGDIAN}', "");
    Expect(0, 69415, '\p{^Script=	_old_SOGDIAN}', "");
    Expect(0, 69415, '\P{Script=	_old_SOGDIAN}', "");
    Expect(1, 69415, '\P{^Script=	_old_SOGDIAN}', "");
    Expect(0, 69416, '\p{Script=	_old_SOGDIAN}', "");
    Expect(1, 69416, '\p{^Script=	_old_SOGDIAN}', "");
    Expect(1, 69416, '\P{Script=	_old_SOGDIAN}', "");
    Expect(0, 69416, '\P{^Script=	_old_SOGDIAN}', "");
    Error('\p{Sc=:=SOGO}');
    Error('\P{Sc=:=SOGO}');
    Expect(1, 69415, '\p{Sc=:\ASogo\z:}', "");;
    Expect(0, 69416, '\p{Sc=:\ASogo\z:}', "");;
    Expect(1, 69415, '\p{Sc=sogo}', "");
    Expect(0, 69415, '\p{^Sc=sogo}', "");
    Expect(0, 69415, '\P{Sc=sogo}', "");
    Expect(1, 69415, '\P{^Sc=sogo}', "");
    Expect(0, 69416, '\p{Sc=sogo}', "");
    Expect(1, 69416, '\p{^Sc=sogo}', "");
    Expect(1, 69416, '\P{Sc=sogo}', "");
    Expect(0, 69416, '\P{^Sc=sogo}', "");
    Expect(1, 69415, '\p{Sc=:\Asogo\z:}', "");;
    Expect(0, 69416, '\p{Sc=:\Asogo\z:}', "");;
    Expect(1, 69415, '\p{Sc=-	sogo}', "");
    Expect(0, 69415, '\p{^Sc=-	sogo}', "");
    Expect(0, 69415, '\P{Sc=-	sogo}', "");
    Expect(1, 69415, '\P{^Sc=-	sogo}', "");
    Expect(0, 69416, '\p{Sc=-	sogo}', "");
    Expect(1, 69416, '\p{^Sc=-	sogo}', "");
    Expect(1, 69416, '\P{Sc=-	sogo}', "");
    Expect(0, 69416, '\P{^Sc=-	sogo}', "");
    Error('\p{Is_Script=	/a/old_SOGDIAN}');
    Error('\P{Is_Script=	/a/old_SOGDIAN}');
    Expect(1, 69415, '\p{Is_Script=oldsogdian}', "");
    Expect(0, 69415, '\p{^Is_Script=oldsogdian}', "");
    Expect(0, 69415, '\P{Is_Script=oldsogdian}', "");
    Expect(1, 69415, '\P{^Is_Script=oldsogdian}', "");
    Expect(0, 69416, '\p{Is_Script=oldsogdian}', "");
    Expect(1, 69416, '\p{^Is_Script=oldsogdian}', "");
    Expect(1, 69416, '\P{Is_Script=oldsogdian}', "");
    Expect(0, 69416, '\P{^Is_Script=oldsogdian}', "");
    Expect(1, 69415, '\p{Is_Script=	Old_sogdian}', "");
    Expect(0, 69415, '\p{^Is_Script=	Old_sogdian}', "");
    Expect(0, 69415, '\P{Is_Script=	Old_sogdian}', "");
    Expect(1, 69415, '\P{^Is_Script=	Old_sogdian}', "");
    Expect(0, 69416, '\p{Is_Script=	Old_sogdian}', "");
    Expect(1, 69416, '\p{^Is_Script=	Old_sogdian}', "");
    Expect(1, 69416, '\P{Is_Script=	Old_sogdian}', "");
    Expect(0, 69416, '\P{^Is_Script=	Old_sogdian}', "");
    Error('\p{Is_Sc=/a/	 SOGO}');
    Error('\P{Is_Sc=/a/	 SOGO}');
    Expect(1, 69415, '\p{Is_Sc=sogo}', "");
    Expect(0, 69415, '\p{^Is_Sc=sogo}', "");
    Expect(0, 69415, '\P{Is_Sc=sogo}', "");
    Expect(1, 69415, '\P{^Is_Sc=sogo}', "");
    Expect(0, 69416, '\p{Is_Sc=sogo}', "");
    Expect(1, 69416, '\p{^Is_Sc=sogo}', "");
    Expect(1, 69416, '\P{Is_Sc=sogo}', "");
    Expect(0, 69416, '\P{^Is_Sc=sogo}', "");
    Expect(1, 69415, '\p{Is_Sc= SOGO}', "");
    Expect(0, 69415, '\p{^Is_Sc= SOGO}', "");
    Expect(0, 69415, '\P{Is_Sc= SOGO}', "");
    Expect(1, 69415, '\P{^Is_Sc= SOGO}', "");
    Expect(0, 69416, '\p{Is_Sc= SOGO}', "");
    Expect(1, 69416, '\p{^Is_Sc= SOGO}', "");
    Expect(1, 69416, '\P{Is_Sc= SOGO}', "");
    Expect(0, 69416, '\P{^Is_Sc= SOGO}', "");
    Error('\p{Script=/a/ _Sora_Sompeng}');
    Error('\P{Script=/a/ _Sora_Sompeng}');
    Expect(1, 69881, '\p{Script=:\ASora_Sompeng\z:}', "");;
    Expect(0, 69882, '\p{Script=:\ASora_Sompeng\z:}', "");;
    Expect(1, 69881, '\p{Script=sorasompeng}', "");
    Expect(0, 69881, '\p{^Script=sorasompeng}', "");
    Expect(0, 69881, '\P{Script=sorasompeng}', "");
    Expect(1, 69881, '\P{^Script=sorasompeng}', "");
    Expect(0, 69882, '\p{Script=sorasompeng}', "");
    Expect(1, 69882, '\p{^Script=sorasompeng}', "");
    Expect(1, 69882, '\P{Script=sorasompeng}', "");
    Expect(0, 69882, '\P{^Script=sorasompeng}', "");
    Expect(1, 69881, '\p{Script=:\Asorasompeng\z:}', "");;
    Expect(0, 69882, '\p{Script=:\Asorasompeng\z:}', "");;
    Expect(1, 69881, '\p{Script=	_Sora_Sompeng}', "");
    Expect(0, 69881, '\p{^Script=	_Sora_Sompeng}', "");
    Expect(0, 69881, '\P{Script=	_Sora_Sompeng}', "");
    Expect(1, 69881, '\P{^Script=	_Sora_Sompeng}', "");
    Expect(0, 69882, '\p{Script=	_Sora_Sompeng}', "");
    Expect(1, 69882, '\p{^Script=	_Sora_Sompeng}', "");
    Expect(1, 69882, '\P{Script=	_Sora_Sompeng}', "");
    Expect(0, 69882, '\P{^Script=	_Sora_Sompeng}', "");
    Error('\p{Sc=	_sora/a/}');
    Error('\P{Sc=	_sora/a/}');
    Expect(1, 69881, '\p{Sc=:\ASora\z:}', "");;
    Expect(0, 69882, '\p{Sc=:\ASora\z:}', "");;
    Expect(1, 69881, '\p{Sc=sora}', "");
    Expect(0, 69881, '\p{^Sc=sora}', "");
    Expect(0, 69881, '\P{Sc=sora}', "");
    Expect(1, 69881, '\P{^Sc=sora}', "");
    Expect(0, 69882, '\p{Sc=sora}', "");
    Expect(1, 69882, '\p{^Sc=sora}', "");
    Expect(1, 69882, '\P{Sc=sora}', "");
    Expect(0, 69882, '\P{^Sc=sora}', "");
    Expect(1, 69881, '\p{Sc=:\Asora\z:}', "");;
    Expect(0, 69882, '\p{Sc=:\Asora\z:}', "");;
    Expect(1, 69881, '\p{Sc=-sora}', "");
    Expect(0, 69881, '\p{^Sc=-sora}', "");
    Expect(0, 69881, '\P{Sc=-sora}', "");
    Expect(1, 69881, '\P{^Sc=-sora}', "");
    Expect(0, 69882, '\p{Sc=-sora}', "");
    Expect(1, 69882, '\p{^Sc=-sora}', "");
    Expect(1, 69882, '\P{Sc=-sora}', "");
    Expect(0, 69882, '\P{^Sc=-sora}', "");
    Error('\p{Is_Script=	:=Sora_SOMPENG}');
    Error('\P{Is_Script=	:=Sora_SOMPENG}');
    Expect(1, 69881, '\p{Is_Script=sorasompeng}', "");
    Expect(0, 69881, '\p{^Is_Script=sorasompeng}', "");
    Expect(0, 69881, '\P{Is_Script=sorasompeng}', "");
    Expect(1, 69881, '\P{^Is_Script=sorasompeng}', "");
    Expect(0, 69882, '\p{Is_Script=sorasompeng}', "");
    Expect(1, 69882, '\p{^Is_Script=sorasompeng}', "");
    Expect(1, 69882, '\P{Is_Script=sorasompeng}', "");
    Expect(0, 69882, '\P{^Is_Script=sorasompeng}', "");
    Expect(1, 69881, '\p{Is_Script:   -Sora_sompeng}', "");
    Expect(0, 69881, '\p{^Is_Script:   -Sora_sompeng}', "");
    Expect(0, 69881, '\P{Is_Script:   -Sora_sompeng}', "");
    Expect(1, 69881, '\P{^Is_Script:   -Sora_sompeng}', "");
    Expect(0, 69882, '\p{Is_Script:   -Sora_sompeng}', "");
    Expect(1, 69882, '\p{^Is_Script:   -Sora_sompeng}', "");
    Expect(1, 69882, '\P{Is_Script:   -Sora_sompeng}', "");
    Expect(0, 69882, '\P{^Is_Script:   -Sora_sompeng}', "");
    Error('\p{Is_Sc= /a/SORA}');
    Error('\P{Is_Sc= /a/SORA}');
    Expect(1, 69881, '\p{Is_Sc=sora}', "");
    Expect(0, 69881, '\p{^Is_Sc=sora}', "");
    Expect(0, 69881, '\P{Is_Sc=sora}', "");
    Expect(1, 69881, '\P{^Is_Sc=sora}', "");
    Expect(0, 69882, '\p{Is_Sc=sora}', "");
    Expect(1, 69882, '\p{^Is_Sc=sora}', "");
    Expect(1, 69882, '\P{Is_Sc=sora}', "");
    Expect(0, 69882, '\P{^Is_Sc=sora}', "");
    Expect(1, 69881, '\p{Is_Sc=_-SORA}', "");
    Expect(0, 69881, '\p{^Is_Sc=_-SORA}', "");
    Expect(0, 69881, '\P{Is_Sc=_-SORA}', "");
    Expect(1, 69881, '\P{^Is_Sc=_-SORA}', "");
    Expect(0, 69882, '\p{Is_Sc=_-SORA}', "");
    Expect(1, 69882, '\p{^Is_Sc=_-SORA}', "");
    Expect(1, 69882, '\P{Is_Sc=_-SORA}', "");
    Expect(0, 69882, '\P{^Is_Sc=_-SORA}', "");
    Error('\p{Script=/a/_Soyombo}');
    Error('\P{Script=/a/_Soyombo}');
    Expect(1, 72354, '\p{Script=:\ASoyombo\z:}', "");;
    Expect(0, 72355, '\p{Script=:\ASoyombo\z:}', "");;
    Expect(1, 72354, '\p{Script=soyombo}', "");
    Expect(0, 72354, '\p{^Script=soyombo}', "");
    Expect(0, 72354, '\P{Script=soyombo}', "");
    Expect(1, 72354, '\P{^Script=soyombo}', "");
    Expect(0, 72355, '\p{Script=soyombo}', "");
    Expect(1, 72355, '\p{^Script=soyombo}', "");
    Expect(1, 72355, '\P{Script=soyombo}', "");
    Expect(0, 72355, '\P{^Script=soyombo}', "");
    Expect(1, 72354, '\p{Script=:\Asoyombo\z:}', "");;
    Expect(0, 72355, '\p{Script=:\Asoyombo\z:}', "");;
    Expect(1, 72354, '\p{Script=  Soyombo}', "");
    Expect(0, 72354, '\p{^Script=  Soyombo}', "");
    Expect(0, 72354, '\P{Script=  Soyombo}', "");
    Expect(1, 72354, '\P{^Script=  Soyombo}', "");
    Expect(0, 72355, '\p{Script=  Soyombo}', "");
    Expect(1, 72355, '\p{^Script=  Soyombo}', "");
    Expect(1, 72355, '\P{Script=  Soyombo}', "");
    Expect(0, 72355, '\P{^Script=  Soyombo}', "");
    Error('\p{Sc=	 Soyo:=}');
    Error('\P{Sc=	 Soyo:=}');
    Expect(1, 72354, '\p{Sc=:\ASoyo\z:}', "");;
    Expect(0, 72355, '\p{Sc=:\ASoyo\z:}', "");;
    Expect(1, 72354, '\p{Sc=soyo}', "");
    Expect(0, 72354, '\p{^Sc=soyo}', "");
    Expect(0, 72354, '\P{Sc=soyo}', "");
    Expect(1, 72354, '\P{^Sc=soyo}', "");
    Expect(0, 72355, '\p{Sc=soyo}', "");
    Expect(1, 72355, '\p{^Sc=soyo}', "");
    Expect(1, 72355, '\P{Sc=soyo}', "");
    Expect(0, 72355, '\P{^Sc=soyo}', "");
    Expect(1, 72354, '\p{Sc=:\Asoyo\z:}', "");;
    Expect(0, 72355, '\p{Sc=:\Asoyo\z:}', "");;
    Expect(1, 72354, '\p{Sc= -Soyo}', "");
    Expect(0, 72354, '\p{^Sc= -Soyo}', "");
    Expect(0, 72354, '\P{Sc= -Soyo}', "");
    Expect(1, 72354, '\P{^Sc= -Soyo}', "");
    Expect(0, 72355, '\p{Sc= -Soyo}', "");
    Expect(1, 72355, '\p{^Sc= -Soyo}', "");
    Expect(1, 72355, '\P{Sc= -Soyo}', "");
    Expect(0, 72355, '\P{^Sc= -Soyo}', "");
    Error('\p{Is_Script=:=SOYOMBO}');
    Error('\P{Is_Script=:=SOYOMBO}');
    Expect(1, 72354, '\p{Is_Script=soyombo}', "");
    Expect(0, 72354, '\p{^Is_Script=soyombo}', "");
    Expect(0, 72354, '\P{Is_Script=soyombo}', "");
    Expect(1, 72354, '\P{^Is_Script=soyombo}', "");
    Expect(0, 72355, '\p{Is_Script=soyombo}', "");
    Expect(1, 72355, '\p{^Is_Script=soyombo}', "");
    Expect(1, 72355, '\P{Is_Script=soyombo}', "");
    Expect(0, 72355, '\P{^Is_Script=soyombo}', "");
    Expect(1, 72354, '\p{Is_Script=-	Soyombo}', "");
    Expect(0, 72354, '\p{^Is_Script=-	Soyombo}', "");
    Expect(0, 72354, '\P{Is_Script=-	Soyombo}', "");
    Expect(1, 72354, '\P{^Is_Script=-	Soyombo}', "");
    Expect(0, 72355, '\p{Is_Script=-	Soyombo}', "");
    Expect(1, 72355, '\p{^Is_Script=-	Soyombo}', "");
    Expect(1, 72355, '\P{Is_Script=-	Soyombo}', "");
    Expect(0, 72355, '\P{^Is_Script=-	Soyombo}', "");
    Error('\p{Is_Sc=:= Soyo}');
    Error('\P{Is_Sc=:= Soyo}');
    Expect(1, 72354, '\p{Is_Sc=soyo}', "");
    Expect(0, 72354, '\p{^Is_Sc=soyo}', "");
    Expect(0, 72354, '\P{Is_Sc=soyo}', "");
    Expect(1, 72354, '\P{^Is_Sc=soyo}', "");
    Expect(0, 72355, '\p{Is_Sc=soyo}', "");
    Expect(1, 72355, '\p{^Is_Sc=soyo}', "");
    Expect(1, 72355, '\P{Is_Sc=soyo}', "");
    Expect(0, 72355, '\P{^Is_Sc=soyo}', "");
    Expect(1, 72354, '\p{Is_Sc=-SOYO}', "");
    Expect(0, 72354, '\p{^Is_Sc=-SOYO}', "");
    Expect(0, 72354, '\P{Is_Sc=-SOYO}', "");
    Expect(1, 72354, '\P{^Is_Sc=-SOYO}', "");
    Expect(0, 72355, '\p{Is_Sc=-SOYO}', "");
    Expect(1, 72355, '\p{^Is_Sc=-SOYO}', "");
    Expect(1, 72355, '\P{Is_Sc=-SOYO}', "");
    Expect(0, 72355, '\P{^Is_Sc=-SOYO}', "");
    Error('\p{Script=:=Sundanese}');
    Error('\P{Script=:=Sundanese}');
    Expect(1, 7367, '\p{Script=:\ASundanese\z:}', "");;
    Expect(0, 7368, '\p{Script=:\ASundanese\z:}', "");;
    Expect(1, 7367, '\p{Script=sundanese}', "");
    Expect(0, 7367, '\p{^Script=sundanese}', "");
    Expect(0, 7367, '\P{Script=sundanese}', "");
    Expect(1, 7367, '\P{^Script=sundanese}', "");
    Expect(0, 7368, '\p{Script=sundanese}', "");
    Expect(1, 7368, '\p{^Script=sundanese}', "");
    Expect(1, 7368, '\P{Script=sundanese}', "");
    Expect(0, 7368, '\P{^Script=sundanese}', "");
    Expect(1, 7367, '\p{Script=:\Asundanese\z:}', "");;
    Expect(0, 7368, '\p{Script=:\Asundanese\z:}', "");;
    Expect(1, 7367, '\p{Script=SUNDANESE}', "");
    Expect(0, 7367, '\p{^Script=SUNDANESE}', "");
    Expect(0, 7367, '\P{Script=SUNDANESE}', "");
    Expect(1, 7367, '\P{^Script=SUNDANESE}', "");
    Expect(0, 7368, '\p{Script=SUNDANESE}', "");
    Expect(1, 7368, '\p{^Script=SUNDANESE}', "");
    Expect(1, 7368, '\P{Script=SUNDANESE}', "");
    Expect(0, 7368, '\P{^Script=SUNDANESE}', "");
    Error('\p{Sc=_:=sund}');
    Error('\P{Sc=_:=sund}');
    Expect(1, 7367, '\p{Sc=:\ASund\z:}', "");;
    Expect(0, 7368, '\p{Sc=:\ASund\z:}', "");;
    Expect(1, 7367, '\p{Sc:sund}', "");
    Expect(0, 7367, '\p{^Sc:sund}', "");
    Expect(0, 7367, '\P{Sc:sund}', "");
    Expect(1, 7367, '\P{^Sc:sund}', "");
    Expect(0, 7368, '\p{Sc:sund}', "");
    Expect(1, 7368, '\p{^Sc:sund}', "");
    Expect(1, 7368, '\P{Sc:sund}', "");
    Expect(0, 7368, '\P{^Sc:sund}', "");
    Expect(1, 7367, '\p{Sc=:\Asund\z:}', "");;
    Expect(0, 7368, '\p{Sc=:\Asund\z:}', "");;
    Expect(1, 7367, '\p{Sc=  Sund}', "");
    Expect(0, 7367, '\p{^Sc=  Sund}', "");
    Expect(0, 7367, '\P{Sc=  Sund}', "");
    Expect(1, 7367, '\P{^Sc=  Sund}', "");
    Expect(0, 7368, '\p{Sc=  Sund}', "");
    Expect(1, 7368, '\p{^Sc=  Sund}', "");
    Expect(1, 7368, '\P{Sc=  Sund}', "");
    Expect(0, 7368, '\P{^Sc=  Sund}', "");
    Error('\p{Is_Script=-Sundanese:=}');
    Error('\P{Is_Script=-Sundanese:=}');
    Expect(1, 7367, '\p{Is_Script=sundanese}', "");
    Expect(0, 7367, '\p{^Is_Script=sundanese}', "");
    Expect(0, 7367, '\P{Is_Script=sundanese}', "");
    Expect(1, 7367, '\P{^Is_Script=sundanese}', "");
    Expect(0, 7368, '\p{Is_Script=sundanese}', "");
    Expect(1, 7368, '\p{^Is_Script=sundanese}', "");
    Expect(1, 7368, '\P{Is_Script=sundanese}', "");
    Expect(0, 7368, '\P{^Is_Script=sundanese}', "");
    Expect(1, 7367, '\p{Is_Script=-sundanese}', "");
    Expect(0, 7367, '\p{^Is_Script=-sundanese}', "");
    Expect(0, 7367, '\P{Is_Script=-sundanese}', "");
    Expect(1, 7367, '\P{^Is_Script=-sundanese}', "");
    Expect(0, 7368, '\p{Is_Script=-sundanese}', "");
    Expect(1, 7368, '\p{^Is_Script=-sundanese}', "");
    Expect(1, 7368, '\P{Is_Script=-sundanese}', "");
    Expect(0, 7368, '\P{^Is_Script=-sundanese}', "");
    Error('\p{Is_Sc=-:=sund}');
    Error('\P{Is_Sc=-:=sund}');
    Expect(1, 7367, '\p{Is_Sc=sund}', "");
    Expect(0, 7367, '\p{^Is_Sc=sund}', "");
    Expect(0, 7367, '\P{Is_Sc=sund}', "");
    Expect(1, 7367, '\P{^Is_Sc=sund}', "");
    Expect(0, 7368, '\p{Is_Sc=sund}', "");
    Expect(1, 7368, '\p{^Is_Sc=sund}', "");
    Expect(1, 7368, '\P{Is_Sc=sund}', "");
    Expect(0, 7368, '\P{^Is_Sc=sund}', "");
    Expect(1, 7367, '\p{Is_Sc=__Sund}', "");
    Expect(0, 7367, '\p{^Is_Sc=__Sund}', "");
    Expect(0, 7367, '\P{Is_Sc=__Sund}', "");
    Expect(1, 7367, '\P{^Is_Sc=__Sund}', "");
    Expect(0, 7368, '\p{Is_Sc=__Sund}', "");
    Expect(1, 7368, '\p{^Is_Sc=__Sund}', "");
    Expect(1, 7368, '\P{Is_Sc=__Sund}', "");
    Expect(0, 7368, '\P{^Is_Sc=__Sund}', "");
    Error('\p{Script=:=	syloti_Nagri}');
    Error('\P{Script=:=	syloti_Nagri}');
    Expect(1, 43052, '\p{Script=:\ASyloti_Nagri\z:}', "");;
    Expect(0, 43053, '\p{Script=:\ASyloti_Nagri\z:}', "");;
    Expect(1, 43052, '\p{Script=sylotinagri}', "");
    Expect(0, 43052, '\p{^Script=sylotinagri}', "");
    Expect(0, 43052, '\P{Script=sylotinagri}', "");
    Expect(1, 43052, '\P{^Script=sylotinagri}', "");
    Expect(0, 43053, '\p{Script=sylotinagri}', "");
    Expect(1, 43053, '\p{^Script=sylotinagri}', "");
    Expect(1, 43053, '\P{Script=sylotinagri}', "");
    Expect(0, 43053, '\P{^Script=sylotinagri}', "");
    Expect(1, 43052, '\p{Script=:\Asylotinagri\z:}', "");;
    Expect(0, 43053, '\p{Script=:\Asylotinagri\z:}', "");;
    Expect(1, 43052, '\p{Script=_	syloti_Nagri}', "");
    Expect(0, 43052, '\p{^Script=_	syloti_Nagri}', "");
    Expect(0, 43052, '\P{Script=_	syloti_Nagri}', "");
    Expect(1, 43052, '\P{^Script=_	syloti_Nagri}', "");
    Expect(0, 43053, '\p{Script=_	syloti_Nagri}', "");
    Expect(1, 43053, '\p{^Script=_	syloti_Nagri}', "");
    Expect(1, 43053, '\P{Script=_	syloti_Nagri}', "");
    Expect(0, 43053, '\P{^Script=_	syloti_Nagri}', "");
    Error('\p{Sc=/a/ 	Sylo}');
    Error('\P{Sc=/a/ 	Sylo}');
    Expect(1, 43052, '\p{Sc=:\ASylo\z:}', "");;
    Expect(0, 43053, '\p{Sc=:\ASylo\z:}', "");;
    Expect(1, 43052, '\p{Sc=sylo}', "");
    Expect(0, 43052, '\p{^Sc=sylo}', "");
    Expect(0, 43052, '\P{Sc=sylo}', "");
    Expect(1, 43052, '\P{^Sc=sylo}', "");
    Expect(0, 43053, '\p{Sc=sylo}', "");
    Expect(1, 43053, '\p{^Sc=sylo}', "");
    Expect(1, 43053, '\P{Sc=sylo}', "");
    Expect(0, 43053, '\P{^Sc=sylo}', "");
    Expect(1, 43052, '\p{Sc=:\Asylo\z:}', "");;
    Expect(0, 43053, '\p{Sc=:\Asylo\z:}', "");;
    Expect(1, 43052, '\p{Sc=-SYLO}', "");
    Expect(0, 43052, '\p{^Sc=-SYLO}', "");
    Expect(0, 43052, '\P{Sc=-SYLO}', "");
    Expect(1, 43052, '\P{^Sc=-SYLO}', "");
    Expect(0, 43053, '\p{Sc=-SYLO}', "");
    Expect(1, 43053, '\p{^Sc=-SYLO}', "");
    Expect(1, 43053, '\P{Sc=-SYLO}', "");
    Expect(0, 43053, '\P{^Sc=-SYLO}', "");
    Error('\p{Is_Script=  syloti_Nagri:=}');
    Error('\P{Is_Script=  syloti_Nagri:=}');
    Expect(1, 43052, '\p{Is_Script=sylotinagri}', "");
    Expect(0, 43052, '\p{^Is_Script=sylotinagri}', "");
    Expect(0, 43052, '\P{Is_Script=sylotinagri}', "");
    Expect(1, 43052, '\P{^Is_Script=sylotinagri}', "");
    Expect(0, 43053, '\p{Is_Script=sylotinagri}', "");
    Expect(1, 43053, '\p{^Is_Script=sylotinagri}', "");
    Expect(1, 43053, '\P{Is_Script=sylotinagri}', "");
    Expect(0, 43053, '\P{^Is_Script=sylotinagri}', "");
    Expect(1, 43052, '\p{Is_Script=_SYLOTI_nagri}', "");
    Expect(0, 43052, '\p{^Is_Script=_SYLOTI_nagri}', "");
    Expect(0, 43052, '\P{Is_Script=_SYLOTI_nagri}', "");
    Expect(1, 43052, '\P{^Is_Script=_SYLOTI_nagri}', "");
    Expect(0, 43053, '\p{Is_Script=_SYLOTI_nagri}', "");
    Expect(1, 43053, '\p{^Is_Script=_SYLOTI_nagri}', "");
    Expect(1, 43053, '\P{Is_Script=_SYLOTI_nagri}', "");
    Expect(0, 43053, '\P{^Is_Script=_SYLOTI_nagri}', "");
    Error('\p{Is_Sc=-SYLO/a/}');
    Error('\P{Is_Sc=-SYLO/a/}');
    Expect(1, 43052, '\p{Is_Sc=sylo}', "");
    Expect(0, 43052, '\p{^Is_Sc=sylo}', "");
    Expect(0, 43052, '\P{Is_Sc=sylo}', "");
    Expect(1, 43052, '\P{^Is_Sc=sylo}', "");
    Expect(0, 43053, '\p{Is_Sc=sylo}', "");
    Expect(1, 43053, '\p{^Is_Sc=sylo}', "");
    Expect(1, 43053, '\P{Is_Sc=sylo}', "");
    Expect(0, 43053, '\P{^Is_Sc=sylo}', "");
    Expect(1, 43052, '\p{Is_Sc:    sylo}', "");
    Expect(0, 43052, '\p{^Is_Sc:    sylo}', "");
    Expect(0, 43052, '\P{Is_Sc:    sylo}', "");
    Expect(1, 43052, '\P{^Is_Sc:    sylo}', "");
    Expect(0, 43053, '\p{Is_Sc:    sylo}', "");
    Expect(1, 43053, '\p{^Is_Sc:    sylo}', "");
    Expect(1, 43053, '\P{Is_Sc:    sylo}', "");
    Expect(0, 43053, '\P{^Is_Sc:    sylo}', "");
    Error('\p{Script: /a/SYRIAC}');
    Error('\P{Script: /a/SYRIAC}');
    Expect(1, 2154, '\p{Script=:\ASyriac\z:}', "");;
    Expect(0, 2155, '\p{Script=:\ASyriac\z:}', "");;
    Expect(1, 2154, '\p{Script:   syriac}', "");
    Expect(0, 2154, '\p{^Script:   syriac}', "");
    Expect(0, 2154, '\P{Script:   syriac}', "");
    Expect(1, 2154, '\P{^Script:   syriac}', "");
    Expect(0, 2155, '\p{Script:   syriac}', "");
    Expect(1, 2155, '\p{^Script:   syriac}', "");
    Expect(1, 2155, '\P{Script:   syriac}', "");
    Expect(0, 2155, '\P{^Script:   syriac}', "");
    Expect(1, 2154, '\p{Script=:\Asyriac\z:}', "");;
    Expect(0, 2155, '\p{Script=:\Asyriac\z:}', "");;
    Expect(1, 2154, '\p{Script= _SYRIAC}', "");
    Expect(0, 2154, '\p{^Script= _SYRIAC}', "");
    Expect(0, 2154, '\P{Script= _SYRIAC}', "");
    Expect(1, 2154, '\P{^Script= _SYRIAC}', "");
    Expect(0, 2155, '\p{Script= _SYRIAC}', "");
    Expect(1, 2155, '\p{^Script= _SYRIAC}', "");
    Expect(1, 2155, '\P{Script= _SYRIAC}', "");
    Expect(0, 2155, '\P{^Script= _SYRIAC}', "");
    Error('\p{Sc=-Syrc:=}');
    Error('\P{Sc=-Syrc:=}');
    Expect(1, 2154, '\p{Sc=:\ASyrc\z:}', "");;
    Expect(0, 2155, '\p{Sc=:\ASyrc\z:}', "");;
    Expect(1, 2154, '\p{Sc=syrc}', "");
    Expect(0, 2154, '\p{^Sc=syrc}', "");
    Expect(0, 2154, '\P{Sc=syrc}', "");
    Expect(1, 2154, '\P{^Sc=syrc}', "");
    Expect(0, 2155, '\p{Sc=syrc}', "");
    Expect(1, 2155, '\p{^Sc=syrc}', "");
    Expect(1, 2155, '\P{Sc=syrc}', "");
    Expect(0, 2155, '\P{^Sc=syrc}', "");
    Expect(1, 2154, '\p{Sc=:\Asyrc\z:}', "");;
    Expect(0, 2155, '\p{Sc=:\Asyrc\z:}', "");;
    Expect(1, 2154, '\p{Sc=_syrc}', "");
    Expect(0, 2154, '\p{^Sc=_syrc}', "");
    Expect(0, 2154, '\P{Sc=_syrc}', "");
    Expect(1, 2154, '\P{^Sc=_syrc}', "");
    Expect(0, 2155, '\p{Sc=_syrc}', "");
    Expect(1, 2155, '\p{^Sc=_syrc}', "");
    Expect(1, 2155, '\P{Sc=_syrc}', "");
    Expect(0, 2155, '\P{^Sc=_syrc}', "");
    Error('\p{Is_Script=_:=Syriac}');
    Error('\P{Is_Script=_:=Syriac}');
    Expect(1, 2154, '\p{Is_Script=syriac}', "");
    Expect(0, 2154, '\p{^Is_Script=syriac}', "");
    Expect(0, 2154, '\P{Is_Script=syriac}', "");
    Expect(1, 2154, '\P{^Is_Script=syriac}', "");
    Expect(0, 2155, '\p{Is_Script=syriac}', "");
    Expect(1, 2155, '\p{^Is_Script=syriac}', "");
    Expect(1, 2155, '\P{Is_Script=syriac}', "");
    Expect(0, 2155, '\P{^Is_Script=syriac}', "");
    Expect(1, 2154, '\p{Is_Script=-_Syriac}', "");
    Expect(0, 2154, '\p{^Is_Script=-_Syriac}', "");
    Expect(0, 2154, '\P{Is_Script=-_Syriac}', "");
    Expect(1, 2154, '\P{^Is_Script=-_Syriac}', "");
    Expect(0, 2155, '\p{Is_Script=-_Syriac}', "");
    Expect(1, 2155, '\p{^Is_Script=-_Syriac}', "");
    Expect(1, 2155, '\P{Is_Script=-_Syriac}', "");
    Expect(0, 2155, '\P{^Is_Script=-_Syriac}', "");
    Error('\p{Is_Sc= Syrc:=}');
    Error('\P{Is_Sc= Syrc:=}');
    Expect(1, 2154, '\p{Is_Sc=syrc}', "");
    Expect(0, 2154, '\p{^Is_Sc=syrc}', "");
    Expect(0, 2154, '\P{Is_Sc=syrc}', "");
    Expect(1, 2154, '\P{^Is_Sc=syrc}', "");
    Expect(0, 2155, '\p{Is_Sc=syrc}', "");
    Expect(1, 2155, '\p{^Is_Sc=syrc}', "");
    Expect(1, 2155, '\P{Is_Sc=syrc}', "");
    Expect(0, 2155, '\P{^Is_Sc=syrc}', "");
    Expect(1, 2154, '\p{Is_Sc:   -Syrc}', "");
    Expect(0, 2154, '\p{^Is_Sc:   -Syrc}', "");
    Expect(0, 2154, '\P{Is_Sc:   -Syrc}', "");
    Expect(1, 2154, '\P{^Is_Sc:   -Syrc}', "");
    Expect(0, 2155, '\p{Is_Sc:   -Syrc}', "");
    Expect(1, 2155, '\p{^Is_Sc:   -Syrc}', "");
    Expect(1, 2155, '\P{Is_Sc:   -Syrc}', "");
    Expect(0, 2155, '\P{^Is_Sc:   -Syrc}', "");
    Error('\p{Script=:=_TAGBANWA}');
    Error('\P{Script=:=_TAGBANWA}');
    Expect(1, 6003, '\p{Script=:\ATagbanwa\z:}', "");;
    Expect(0, 6004, '\p{Script=:\ATagbanwa\z:}', "");;
    Expect(1, 6003, '\p{Script=tagbanwa}', "");
    Expect(0, 6003, '\p{^Script=tagbanwa}', "");
    Expect(0, 6003, '\P{Script=tagbanwa}', "");
    Expect(1, 6003, '\P{^Script=tagbanwa}', "");
    Expect(0, 6004, '\p{Script=tagbanwa}', "");
    Expect(1, 6004, '\p{^Script=tagbanwa}', "");
    Expect(1, 6004, '\P{Script=tagbanwa}', "");
    Expect(0, 6004, '\P{^Script=tagbanwa}', "");
    Expect(1, 6003, '\p{Script=:\Atagbanwa\z:}', "");;
    Expect(0, 6004, '\p{Script=:\Atagbanwa\z:}', "");;
    Expect(1, 6003, '\p{Script=	tagbanwa}', "");
    Expect(0, 6003, '\p{^Script=	tagbanwa}', "");
    Expect(0, 6003, '\P{Script=	tagbanwa}', "");
    Expect(1, 6003, '\P{^Script=	tagbanwa}', "");
    Expect(0, 6004, '\p{Script=	tagbanwa}', "");
    Expect(1, 6004, '\p{^Script=	tagbanwa}', "");
    Expect(1, 6004, '\P{Script=	tagbanwa}', "");
    Expect(0, 6004, '\P{^Script=	tagbanwa}', "");
    Error('\p{Sc=_ TAGB:=}');
    Error('\P{Sc=_ TAGB:=}');
    Expect(1, 6003, '\p{Sc=:\ATagb\z:}', "");;
    Expect(0, 6004, '\p{Sc=:\ATagb\z:}', "");;
    Expect(1, 6003, '\p{Sc:	tagb}', "");
    Expect(0, 6003, '\p{^Sc:	tagb}', "");
    Expect(0, 6003, '\P{Sc:	tagb}', "");
    Expect(1, 6003, '\P{^Sc:	tagb}', "");
    Expect(0, 6004, '\p{Sc:	tagb}', "");
    Expect(1, 6004, '\p{^Sc:	tagb}', "");
    Expect(1, 6004, '\P{Sc:	tagb}', "");
    Expect(0, 6004, '\P{^Sc:	tagb}', "");
    Expect(1, 6003, '\p{Sc=:\Atagb\z:}', "");;
    Expect(0, 6004, '\p{Sc=:\Atagb\z:}', "");;
    Expect(1, 6003, '\p{Sc=	TAGB}', "");
    Expect(0, 6003, '\p{^Sc=	TAGB}', "");
    Expect(0, 6003, '\P{Sc=	TAGB}', "");
    Expect(1, 6003, '\P{^Sc=	TAGB}', "");
    Expect(0, 6004, '\p{Sc=	TAGB}', "");
    Expect(1, 6004, '\p{^Sc=	TAGB}', "");
    Expect(1, 6004, '\P{Sc=	TAGB}', "");
    Expect(0, 6004, '\P{^Sc=	TAGB}', "");
    Error('\p{Is_Script=	_TAGBANWA:=}');
    Error('\P{Is_Script=	_TAGBANWA:=}');
    Expect(1, 6003, '\p{Is_Script: tagbanwa}', "");
    Expect(0, 6003, '\p{^Is_Script: tagbanwa}', "");
    Expect(0, 6003, '\P{Is_Script: tagbanwa}', "");
    Expect(1, 6003, '\P{^Is_Script: tagbanwa}', "");
    Expect(0, 6004, '\p{Is_Script: tagbanwa}', "");
    Expect(1, 6004, '\p{^Is_Script: tagbanwa}', "");
    Expect(1, 6004, '\P{Is_Script: tagbanwa}', "");
    Expect(0, 6004, '\P{^Is_Script: tagbanwa}', "");
    Expect(1, 6003, '\p{Is_Script=- tagbanwa}', "");
    Expect(0, 6003, '\p{^Is_Script=- tagbanwa}', "");
    Expect(0, 6003, '\P{Is_Script=- tagbanwa}', "");
    Expect(1, 6003, '\P{^Is_Script=- tagbanwa}', "");
    Expect(0, 6004, '\p{Is_Script=- tagbanwa}', "");
    Expect(1, 6004, '\p{^Is_Script=- tagbanwa}', "");
    Expect(1, 6004, '\P{Is_Script=- tagbanwa}', "");
    Expect(0, 6004, '\P{^Is_Script=- tagbanwa}', "");
    Error('\p{Is_Sc=	Tagb:=}');
    Error('\P{Is_Sc=	Tagb:=}');
    Expect(1, 6003, '\p{Is_Sc=tagb}', "");
    Expect(0, 6003, '\p{^Is_Sc=tagb}', "");
    Expect(0, 6003, '\P{Is_Sc=tagb}', "");
    Expect(1, 6003, '\P{^Is_Sc=tagb}', "");
    Expect(0, 6004, '\p{Is_Sc=tagb}', "");
    Expect(1, 6004, '\p{^Is_Sc=tagb}', "");
    Expect(1, 6004, '\P{Is_Sc=tagb}', "");
    Expect(0, 6004, '\P{^Is_Sc=tagb}', "");
    Expect(1, 6003, '\p{Is_Sc=	Tagb}', "");
    Expect(0, 6003, '\p{^Is_Sc=	Tagb}', "");
    Expect(0, 6003, '\P{Is_Sc=	Tagb}', "");
    Expect(1, 6003, '\P{^Is_Sc=	Tagb}', "");
    Expect(0, 6004, '\p{Is_Sc=	Tagb}', "");
    Expect(1, 6004, '\p{^Is_Sc=	Tagb}', "");
    Expect(1, 6004, '\P{Is_Sc=	Tagb}', "");
    Expect(0, 6004, '\P{^Is_Sc=	Tagb}', "");
    Error('\p{Script=/a/	takri}');
    Error('\P{Script=/a/	takri}');
    Expect(1, 71369, '\p{Script=:\ATakri\z:}', "");;
    Expect(0, 71370, '\p{Script=:\ATakri\z:}', "");;
    Expect(1, 71369, '\p{Script:   takri}', "");
    Expect(0, 71369, '\p{^Script:   takri}', "");
    Expect(0, 71369, '\P{Script:   takri}', "");
    Expect(1, 71369, '\P{^Script:   takri}', "");
    Expect(0, 71370, '\p{Script:   takri}', "");
    Expect(1, 71370, '\p{^Script:   takri}', "");
    Expect(1, 71370, '\P{Script:   takri}', "");
    Expect(0, 71370, '\P{^Script:   takri}', "");
    Expect(1, 71369, '\p{Script=:\Atakri\z:}', "");;
    Expect(0, 71370, '\p{Script=:\Atakri\z:}', "");;
    Expect(1, 71369, '\p{Script= takri}', "");
    Expect(0, 71369, '\p{^Script= takri}', "");
    Expect(0, 71369, '\P{Script= takri}', "");
    Expect(1, 71369, '\P{^Script= takri}', "");
    Expect(0, 71370, '\p{Script= takri}', "");
    Expect(1, 71370, '\p{^Script= takri}', "");
    Expect(1, 71370, '\P{Script= takri}', "");
    Expect(0, 71370, '\P{^Script= takri}', "");
    Error('\p{Sc=:=TAKR}');
    Error('\P{Sc=:=TAKR}');
    Expect(1, 71369, '\p{Sc=:\ATakr\z:}', "");;
    Expect(0, 71370, '\p{Sc=:\ATakr\z:}', "");;
    Expect(1, 71369, '\p{Sc=takr}', "");
    Expect(0, 71369, '\p{^Sc=takr}', "");
    Expect(0, 71369, '\P{Sc=takr}', "");
    Expect(1, 71369, '\P{^Sc=takr}', "");
    Expect(0, 71370, '\p{Sc=takr}', "");
    Expect(1, 71370, '\p{^Sc=takr}', "");
    Expect(1, 71370, '\P{Sc=takr}', "");
    Expect(0, 71370, '\P{^Sc=takr}', "");
    Expect(1, 71369, '\p{Sc=:\Atakr\z:}', "");;
    Expect(0, 71370, '\p{Sc=:\Atakr\z:}', "");;
    Expect(1, 71369, '\p{Sc=	 Takr}', "");
    Expect(0, 71369, '\p{^Sc=	 Takr}', "");
    Expect(0, 71369, '\P{Sc=	 Takr}', "");
    Expect(1, 71369, '\P{^Sc=	 Takr}', "");
    Expect(0, 71370, '\p{Sc=	 Takr}', "");
    Expect(1, 71370, '\p{^Sc=	 Takr}', "");
    Expect(1, 71370, '\P{Sc=	 Takr}', "");
    Expect(0, 71370, '\P{^Sc=	 Takr}', "");
    Error('\p{Is_Script=_-Takri/a/}');
    Error('\P{Is_Script=_-Takri/a/}');
    Expect(1, 71369, '\p{Is_Script=takri}', "");
    Expect(0, 71369, '\p{^Is_Script=takri}', "");
    Expect(0, 71369, '\P{Is_Script=takri}', "");
    Expect(1, 71369, '\P{^Is_Script=takri}', "");
    Expect(0, 71370, '\p{Is_Script=takri}', "");
    Expect(1, 71370, '\p{^Is_Script=takri}', "");
    Expect(1, 71370, '\P{Is_Script=takri}', "");
    Expect(0, 71370, '\P{^Is_Script=takri}', "");
    Expect(1, 71369, '\p{Is_Script=	Takri}', "");
    Expect(0, 71369, '\p{^Is_Script=	Takri}', "");
    Expect(0, 71369, '\P{Is_Script=	Takri}', "");
    Expect(1, 71369, '\P{^Is_Script=	Takri}', "");
    Expect(0, 71370, '\p{Is_Script=	Takri}', "");
    Expect(1, 71370, '\p{^Is_Script=	Takri}', "");
    Expect(1, 71370, '\P{Is_Script=	Takri}', "");
    Expect(0, 71370, '\P{^Is_Script=	Takri}', "");
    Error('\p{Is_Sc=:=	 Takr}');
    Error('\P{Is_Sc=:=	 Takr}');
    Expect(1, 71369, '\p{Is_Sc=takr}', "");
    Expect(0, 71369, '\p{^Is_Sc=takr}', "");
    Expect(0, 71369, '\P{Is_Sc=takr}', "");
    Expect(1, 71369, '\P{^Is_Sc=takr}', "");
    Expect(0, 71370, '\p{Is_Sc=takr}', "");
    Expect(1, 71370, '\p{^Is_Sc=takr}', "");
    Expect(1, 71370, '\P{Is_Sc=takr}', "");
    Expect(0, 71370, '\P{^Is_Sc=takr}', "");
    Expect(1, 71369, '\p{Is_Sc=-_TAKR}', "");
    Expect(0, 71369, '\p{^Is_Sc=-_TAKR}', "");
    Expect(0, 71369, '\P{Is_Sc=-_TAKR}', "");
    Expect(1, 71369, '\P{^Is_Sc=-_TAKR}', "");
    Expect(0, 71370, '\p{Is_Sc=-_TAKR}', "");
    Expect(1, 71370, '\p{^Is_Sc=-_TAKR}', "");
    Expect(1, 71370, '\P{Is_Sc=-_TAKR}', "");
    Expect(0, 71370, '\P{^Is_Sc=-_TAKR}', "");
    Error('\p{Script=_ TAI_Le/a/}');
    Error('\P{Script=_ TAI_Le/a/}');
    Expect(1, 6516, '\p{Script=:\ATai_Le\z:}', "");;
    Expect(0, 6517, '\p{Script=:\ATai_Le\z:}', "");;
    Expect(1, 6516, '\p{Script=taile}', "");
    Expect(0, 6516, '\p{^Script=taile}', "");
    Expect(0, 6516, '\P{Script=taile}', "");
    Expect(1, 6516, '\P{^Script=taile}', "");
    Expect(0, 6517, '\p{Script=taile}', "");
    Expect(1, 6517, '\p{^Script=taile}', "");
    Expect(1, 6517, '\P{Script=taile}', "");
    Expect(0, 6517, '\P{^Script=taile}', "");
    Expect(1, 6516, '\p{Script=:\Ataile\z:}', "");;
    Expect(0, 6517, '\p{Script=:\Ataile\z:}', "");;
    Expect(1, 6516, '\p{Script:  Tai_le}', "");
    Expect(0, 6516, '\p{^Script:  Tai_le}', "");
    Expect(0, 6516, '\P{Script:  Tai_le}', "");
    Expect(1, 6516, '\P{^Script:  Tai_le}', "");
    Expect(0, 6517, '\p{Script:  Tai_le}', "");
    Expect(1, 6517, '\p{^Script:  Tai_le}', "");
    Expect(1, 6517, '\P{Script:  Tai_le}', "");
    Expect(0, 6517, '\P{^Script:  Tai_le}', "");
    Error('\p{Sc=/a/--Tale}');
    Error('\P{Sc=/a/--Tale}');
    Expect(1, 6516, '\p{Sc=:\ATale\z:}', "");;
    Expect(0, 6517, '\p{Sc=:\ATale\z:}', "");;
    Expect(1, 6516, '\p{Sc=tale}', "");
    Expect(0, 6516, '\p{^Sc=tale}', "");
    Expect(0, 6516, '\P{Sc=tale}', "");
    Expect(1, 6516, '\P{^Sc=tale}', "");
    Expect(0, 6517, '\p{Sc=tale}', "");
    Expect(1, 6517, '\p{^Sc=tale}', "");
    Expect(1, 6517, '\P{Sc=tale}', "");
    Expect(0, 6517, '\P{^Sc=tale}', "");
    Expect(1, 6516, '\p{Sc=:\Atale\z:}', "");;
    Expect(0, 6517, '\p{Sc=:\Atale\z:}', "");;
    Expect(1, 6516, '\p{Sc=	tale}', "");
    Expect(0, 6516, '\p{^Sc=	tale}', "");
    Expect(0, 6516, '\P{Sc=	tale}', "");
    Expect(1, 6516, '\P{^Sc=	tale}', "");
    Expect(0, 6517, '\p{Sc=	tale}', "");
    Expect(1, 6517, '\p{^Sc=	tale}', "");
    Expect(1, 6517, '\P{Sc=	tale}', "");
    Expect(0, 6517, '\P{^Sc=	tale}', "");
    Error('\p{Is_Script=:=TAI_Le}');
    Error('\P{Is_Script=:=TAI_Le}');
    Expect(1, 6516, '\p{Is_Script=taile}', "");
    Expect(0, 6516, '\p{^Is_Script=taile}', "");
    Expect(0, 6516, '\P{Is_Script=taile}', "");
    Expect(1, 6516, '\P{^Is_Script=taile}', "");
    Expect(0, 6517, '\p{Is_Script=taile}', "");
    Expect(1, 6517, '\p{^Is_Script=taile}', "");
    Expect(1, 6517, '\P{Is_Script=taile}', "");
    Expect(0, 6517, '\P{^Is_Script=taile}', "");
    Expect(1, 6516, '\p{Is_Script=-_tai_LE}', "");
    Expect(0, 6516, '\p{^Is_Script=-_tai_LE}', "");
    Expect(0, 6516, '\P{Is_Script=-_tai_LE}', "");
    Expect(1, 6516, '\P{^Is_Script=-_tai_LE}', "");
    Expect(0, 6517, '\p{Is_Script=-_tai_LE}', "");
    Expect(1, 6517, '\p{^Is_Script=-_tai_LE}', "");
    Expect(1, 6517, '\P{Is_Script=-_tai_LE}', "");
    Expect(0, 6517, '\P{^Is_Script=-_tai_LE}', "");
    Error('\p{Is_Sc=/a/-	TALE}');
    Error('\P{Is_Sc=/a/-	TALE}');
    Expect(1, 6516, '\p{Is_Sc=tale}', "");
    Expect(0, 6516, '\p{^Is_Sc=tale}', "");
    Expect(0, 6516, '\P{Is_Sc=tale}', "");
    Expect(1, 6516, '\P{^Is_Sc=tale}', "");
    Expect(0, 6517, '\p{Is_Sc=tale}', "");
    Expect(1, 6517, '\p{^Is_Sc=tale}', "");
    Expect(1, 6517, '\P{Is_Sc=tale}', "");
    Expect(0, 6517, '\P{^Is_Sc=tale}', "");
    Expect(1, 6516, '\p{Is_Sc=_Tale}', "");
    Expect(0, 6516, '\p{^Is_Sc=_Tale}', "");
    Expect(0, 6516, '\P{Is_Sc=_Tale}', "");
    Expect(1, 6516, '\P{^Is_Sc=_Tale}', "");
    Expect(0, 6517, '\p{Is_Sc=_Tale}', "");
    Expect(1, 6517, '\p{^Is_Sc=_Tale}', "");
    Expect(1, 6517, '\P{Is_Sc=_Tale}', "");
    Expect(0, 6517, '\P{^Is_Sc=_Tale}', "");
    Error('\p{Script=_/a/new_tai_Lue}');
    Error('\P{Script=_/a/new_tai_Lue}');
    Expect(1, 6623, '\p{Script=:\ANew_Tai_Lue\z:}', "");;
    Expect(0, 6624, '\p{Script=:\ANew_Tai_Lue\z:}', "");;
    Expect(1, 6623, '\p{Script=newtailue}', "");
    Expect(0, 6623, '\p{^Script=newtailue}', "");
    Expect(0, 6623, '\P{Script=newtailue}', "");
    Expect(1, 6623, '\P{^Script=newtailue}', "");
    Expect(0, 6624, '\p{Script=newtailue}', "");
    Expect(1, 6624, '\p{^Script=newtailue}', "");
    Expect(1, 6624, '\P{Script=newtailue}', "");
    Expect(0, 6624, '\P{^Script=newtailue}', "");
    Expect(1, 6623, '\p{Script=:\Anewtailue\z:}', "");;
    Expect(0, 6624, '\p{Script=:\Anewtailue\z:}', "");;
    Expect(1, 6623, '\p{Script=	New_Tai_lue}', "");
    Expect(0, 6623, '\p{^Script=	New_Tai_lue}', "");
    Expect(0, 6623, '\P{Script=	New_Tai_lue}', "");
    Expect(1, 6623, '\P{^Script=	New_Tai_lue}', "");
    Expect(0, 6624, '\p{Script=	New_Tai_lue}', "");
    Expect(1, 6624, '\p{^Script=	New_Tai_lue}', "");
    Expect(1, 6624, '\P{Script=	New_Tai_lue}', "");
    Expect(0, 6624, '\P{^Script=	New_Tai_lue}', "");
    Error('\p{Sc=	:=Talu}');
    Error('\P{Sc=	:=Talu}');
    Expect(1, 6623, '\p{Sc=:\ATalu\z:}', "");;
    Expect(0, 6624, '\p{Sc=:\ATalu\z:}', "");;
    Expect(1, 6623, '\p{Sc=talu}', "");
    Expect(0, 6623, '\p{^Sc=talu}', "");
    Expect(0, 6623, '\P{Sc=talu}', "");
    Expect(1, 6623, '\P{^Sc=talu}', "");
    Expect(0, 6624, '\p{Sc=talu}', "");
    Expect(1, 6624, '\p{^Sc=talu}', "");
    Expect(1, 6624, '\P{Sc=talu}', "");
    Expect(0, 6624, '\P{^Sc=talu}', "");
    Expect(1, 6623, '\p{Sc=:\Atalu\z:}', "");;
    Expect(0, 6624, '\p{Sc=:\Atalu\z:}', "");;
    Expect(1, 6623, '\p{Sc=_-talu}', "");
    Expect(0, 6623, '\p{^Sc=_-talu}', "");
    Expect(0, 6623, '\P{Sc=_-talu}', "");
    Expect(1, 6623, '\P{^Sc=_-talu}', "");
    Expect(0, 6624, '\p{Sc=_-talu}', "");
    Expect(1, 6624, '\p{^Sc=_-talu}', "");
    Expect(1, 6624, '\P{Sc=_-talu}', "");
    Expect(0, 6624, '\P{^Sc=_-talu}', "");
    Error('\p{Is_Script=:=New_Tai_lue}');
    Error('\P{Is_Script=:=New_Tai_lue}');
    Expect(1, 6623, '\p{Is_Script=newtailue}', "");
    Expect(0, 6623, '\p{^Is_Script=newtailue}', "");
    Expect(0, 6623, '\P{Is_Script=newtailue}', "");
    Expect(1, 6623, '\P{^Is_Script=newtailue}', "");
    Expect(0, 6624, '\p{Is_Script=newtailue}', "");
    Expect(1, 6624, '\p{^Is_Script=newtailue}', "");
    Expect(1, 6624, '\P{Is_Script=newtailue}', "");
    Expect(0, 6624, '\P{^Is_Script=newtailue}', "");
    Expect(1, 6623, '\p{Is_Script: 	New_TAI_Lue}', "");
    Expect(0, 6623, '\p{^Is_Script: 	New_TAI_Lue}', "");
    Expect(0, 6623, '\P{Is_Script: 	New_TAI_Lue}', "");
    Expect(1, 6623, '\P{^Is_Script: 	New_TAI_Lue}', "");
    Expect(0, 6624, '\p{Is_Script: 	New_TAI_Lue}', "");
    Expect(1, 6624, '\p{^Is_Script: 	New_TAI_Lue}', "");
    Expect(1, 6624, '\P{Is_Script: 	New_TAI_Lue}', "");
    Expect(0, 6624, '\P{^Is_Script: 	New_TAI_Lue}', "");
    Error('\p{Is_Sc= -Talu/a/}');
    Error('\P{Is_Sc= -Talu/a/}');
    Expect(1, 6623, '\p{Is_Sc=talu}', "");
    Expect(0, 6623, '\p{^Is_Sc=talu}', "");
    Expect(0, 6623, '\P{Is_Sc=talu}', "");
    Expect(1, 6623, '\P{^Is_Sc=talu}', "");
    Expect(0, 6624, '\p{Is_Sc=talu}', "");
    Expect(1, 6624, '\p{^Is_Sc=talu}', "");
    Expect(1, 6624, '\P{Is_Sc=talu}', "");
    Expect(0, 6624, '\P{^Is_Sc=talu}', "");
    Expect(1, 6623, '\p{Is_Sc: _Talu}', "");
    Expect(0, 6623, '\p{^Is_Sc: _Talu}', "");
    Expect(0, 6623, '\P{Is_Sc: _Talu}', "");
    Expect(1, 6623, '\P{^Is_Sc: _Talu}', "");
    Expect(0, 6624, '\p{Is_Sc: _Talu}', "");
    Expect(1, 6624, '\p{^Is_Sc: _Talu}', "");
    Expect(1, 6624, '\P{Is_Sc: _Talu}', "");
    Expect(0, 6624, '\P{^Is_Sc: _Talu}', "");
    Error('\p{Script=/a/__Tamil}');
    Error('\P{Script=/a/__Tamil}');
    Expect(1, 73727, '\p{Script=:\ATamil\z:}', "");;
    Expect(0, 73728, '\p{Script=:\ATamil\z:}', "");;
    Expect(1, 73727, '\p{Script=tamil}', "");
    Expect(0, 73727, '\p{^Script=tamil}', "");
    Expect(0, 73727, '\P{Script=tamil}', "");
    Expect(1, 73727, '\P{^Script=tamil}', "");
    Expect(0, 73728, '\p{Script=tamil}', "");
    Expect(1, 73728, '\p{^Script=tamil}', "");
    Expect(1, 73728, '\P{Script=tamil}', "");
    Expect(0, 73728, '\P{^Script=tamil}', "");
    Expect(1, 73727, '\p{Script=:\Atamil\z:}', "");;
    Expect(0, 73728, '\p{Script=:\Atamil\z:}', "");;
    Expect(1, 73727, '\p{Script= TAMIL}', "");
    Expect(0, 73727, '\p{^Script= TAMIL}', "");
    Expect(0, 73727, '\P{Script= TAMIL}', "");
    Expect(1, 73727, '\P{^Script= TAMIL}', "");
    Expect(0, 73728, '\p{Script= TAMIL}', "");
    Expect(1, 73728, '\p{^Script= TAMIL}', "");
    Expect(1, 73728, '\P{Script= TAMIL}', "");
    Expect(0, 73728, '\P{^Script= TAMIL}', "");
    Error('\p{Sc=_ TAML/a/}');
    Error('\P{Sc=_ TAML/a/}');
    Expect(1, 73727, '\p{Sc=:\ATaml\z:}', "");;
    Expect(0, 73728, '\p{Sc=:\ATaml\z:}', "");;
    Expect(1, 73727, '\p{Sc=taml}', "");
    Expect(0, 73727, '\p{^Sc=taml}', "");
    Expect(0, 73727, '\P{Sc=taml}', "");
    Expect(1, 73727, '\P{^Sc=taml}', "");
    Expect(0, 73728, '\p{Sc=taml}', "");
    Expect(1, 73728, '\p{^Sc=taml}', "");
    Expect(1, 73728, '\P{Sc=taml}', "");
    Expect(0, 73728, '\P{^Sc=taml}', "");
    Expect(1, 73727, '\p{Sc=:\Ataml\z:}', "");;
    Expect(0, 73728, '\p{Sc=:\Ataml\z:}', "");;
    Expect(1, 73727, '\p{Sc=- TAML}', "");
    Expect(0, 73727, '\p{^Sc=- TAML}', "");
    Expect(0, 73727, '\P{Sc=- TAML}', "");
    Expect(1, 73727, '\P{^Sc=- TAML}', "");
    Expect(0, 73728, '\p{Sc=- TAML}', "");
    Expect(1, 73728, '\p{^Sc=- TAML}', "");
    Expect(1, 73728, '\P{Sc=- TAML}', "");
    Expect(0, 73728, '\P{^Sc=- TAML}', "");
    Error('\p{Is_Script=/a/TAMIL}');
    Error('\P{Is_Script=/a/TAMIL}');
    Expect(1, 73727, '\p{Is_Script=tamil}', "");
    Expect(0, 73727, '\p{^Is_Script=tamil}', "");
    Expect(0, 73727, '\P{Is_Script=tamil}', "");
    Expect(1, 73727, '\P{^Is_Script=tamil}', "");
    Expect(0, 73728, '\p{Is_Script=tamil}', "");
    Expect(1, 73728, '\p{^Is_Script=tamil}', "");
    Expect(1, 73728, '\P{Is_Script=tamil}', "");
    Expect(0, 73728, '\P{^Is_Script=tamil}', "");
    Expect(1, 73727, '\p{Is_Script=_Tamil}', "");
    Expect(0, 73727, '\p{^Is_Script=_Tamil}', "");
    Expect(0, 73727, '\P{Is_Script=_Tamil}', "");
    Expect(1, 73727, '\P{^Is_Script=_Tamil}', "");
    Expect(0, 73728, '\p{Is_Script=_Tamil}', "");
    Expect(1, 73728, '\p{^Is_Script=_Tamil}', "");
    Expect(1, 73728, '\P{Is_Script=_Tamil}', "");
    Expect(0, 73728, '\P{^Is_Script=_Tamil}', "");
    Error('\p{Is_Sc=:= TAML}');
    Error('\P{Is_Sc=:= TAML}');
    Expect(1, 73727, '\p{Is_Sc=taml}', "");
    Expect(0, 73727, '\p{^Is_Sc=taml}', "");
    Expect(0, 73727, '\P{Is_Sc=taml}', "");
    Expect(1, 73727, '\P{^Is_Sc=taml}', "");
    Expect(0, 73728, '\p{Is_Sc=taml}', "");
    Expect(1, 73728, '\p{^Is_Sc=taml}', "");
    Expect(1, 73728, '\P{Is_Sc=taml}', "");
    Expect(0, 73728, '\P{^Is_Sc=taml}', "");
    Expect(1, 73727, '\p{Is_Sc=__TAML}', "");
    Expect(0, 73727, '\p{^Is_Sc=__TAML}', "");
    Expect(0, 73727, '\P{Is_Sc=__TAML}', "");
    Expect(1, 73727, '\P{^Is_Sc=__TAML}', "");
    Expect(0, 73728, '\p{Is_Sc=__TAML}', "");
    Expect(1, 73728, '\p{^Is_Sc=__TAML}', "");
    Expect(1, 73728, '\P{Is_Sc=__TAML}', "");
    Expect(0, 73728, '\P{^Is_Sc=__TAML}', "");
    Error('\p{Script=_Tangut:=}');
    Error('\P{Script=_Tangut:=}');
    Expect(1, 101640, '\p{Script=:\ATangut\z:}', "");;
    Expect(0, 101641, '\p{Script=:\ATangut\z:}', "");;
    Expect(1, 101640, '\p{Script=tangut}', "");
    Expect(0, 101640, '\p{^Script=tangut}', "");
    Expect(0, 101640, '\P{Script=tangut}', "");
    Expect(1, 101640, '\P{^Script=tangut}', "");
    Expect(0, 101641, '\p{Script=tangut}', "");
    Expect(1, 101641, '\p{^Script=tangut}', "");
    Expect(1, 101641, '\P{Script=tangut}', "");
    Expect(0, 101641, '\P{^Script=tangut}', "");
    Expect(1, 101640, '\p{Script=:\Atangut\z:}', "");;
    Expect(0, 101641, '\p{Script=:\Atangut\z:}', "");;
    Expect(1, 101640, '\p{Script=	-Tangut}', "");
    Expect(0, 101640, '\p{^Script=	-Tangut}', "");
    Expect(0, 101640, '\P{Script=	-Tangut}', "");
    Expect(1, 101640, '\P{^Script=	-Tangut}', "");
    Expect(0, 101641, '\p{Script=	-Tangut}', "");
    Expect(1, 101641, '\p{^Script=	-Tangut}', "");
    Expect(1, 101641, '\P{Script=	-Tangut}', "");
    Expect(0, 101641, '\P{^Script=	-Tangut}', "");
    Error('\p{Sc=:=		tang}');
    Error('\P{Sc=:=		tang}');
    Expect(1, 101640, '\p{Sc=:\ATang\z:}', "");;
    Expect(0, 101641, '\p{Sc=:\ATang\z:}', "");;
    Expect(1, 101640, '\p{Sc=tang}', "");
    Expect(0, 101640, '\p{^Sc=tang}', "");
    Expect(0, 101640, '\P{Sc=tang}', "");
    Expect(1, 101640, '\P{^Sc=tang}', "");
    Expect(0, 101641, '\p{Sc=tang}', "");
    Expect(1, 101641, '\p{^Sc=tang}', "");
    Expect(1, 101641, '\P{Sc=tang}', "");
    Expect(0, 101641, '\P{^Sc=tang}', "");
    Expect(1, 101640, '\p{Sc=:\Atang\z:}', "");;
    Expect(0, 101641, '\p{Sc=:\Atang\z:}', "");;
    Expect(1, 101640, '\p{Sc:   --tang}', "");
    Expect(0, 101640, '\p{^Sc:   --tang}', "");
    Expect(0, 101640, '\P{Sc:   --tang}', "");
    Expect(1, 101640, '\P{^Sc:   --tang}', "");
    Expect(0, 101641, '\p{Sc:   --tang}', "");
    Expect(1, 101641, '\p{^Sc:   --tang}', "");
    Expect(1, 101641, '\P{Sc:   --tang}', "");
    Expect(0, 101641, '\P{^Sc:   --tang}', "");
    Error('\p{Is_Script:   	 Tangut/a/}');
    Error('\P{Is_Script:   	 Tangut/a/}');
    Expect(1, 101640, '\p{Is_Script=tangut}', "");
    Expect(0, 101640, '\p{^Is_Script=tangut}', "");
    Expect(0, 101640, '\P{Is_Script=tangut}', "");
    Expect(1, 101640, '\P{^Is_Script=tangut}', "");
    Expect(0, 101641, '\p{Is_Script=tangut}', "");
    Expect(1, 101641, '\p{^Is_Script=tangut}', "");
    Expect(1, 101641, '\P{Is_Script=tangut}', "");
    Expect(0, 101641, '\P{^Is_Script=tangut}', "");
    Expect(1, 101640, '\p{Is_Script= 	Tangut}', "");
    Expect(0, 101640, '\p{^Is_Script= 	Tangut}', "");
    Expect(0, 101640, '\P{Is_Script= 	Tangut}', "");
    Expect(1, 101640, '\P{^Is_Script= 	Tangut}', "");
    Expect(0, 101641, '\p{Is_Script= 	Tangut}', "");
    Expect(1, 101641, '\p{^Is_Script= 	Tangut}', "");
    Expect(1, 101641, '\P{Is_Script= 	Tangut}', "");
    Expect(0, 101641, '\P{^Is_Script= 	Tangut}', "");
    Error('\p{Is_Sc=_	Tang/a/}');
    Error('\P{Is_Sc=_	Tang/a/}');
    Expect(1, 101640, '\p{Is_Sc=tang}', "");
    Expect(0, 101640, '\p{^Is_Sc=tang}', "");
    Expect(0, 101640, '\P{Is_Sc=tang}', "");
    Expect(1, 101640, '\P{^Is_Sc=tang}', "");
    Expect(0, 101641, '\p{Is_Sc=tang}', "");
    Expect(1, 101641, '\p{^Is_Sc=tang}', "");
    Expect(1, 101641, '\P{Is_Sc=tang}', "");
    Expect(0, 101641, '\P{^Is_Sc=tang}', "");
    Expect(1, 101640, '\p{Is_Sc=	_Tang}', "");
    Expect(0, 101640, '\p{^Is_Sc=	_Tang}', "");
    Expect(0, 101640, '\P{Is_Sc=	_Tang}', "");
    Expect(1, 101640, '\P{^Is_Sc=	_Tang}', "");
    Expect(0, 101641, '\p{Is_Sc=	_Tang}', "");
    Expect(1, 101641, '\p{^Is_Sc=	_Tang}', "");
    Expect(1, 101641, '\P{Is_Sc=	_Tang}', "");
    Expect(0, 101641, '\P{^Is_Sc=	_Tang}', "");
    Error('\p{Script=-/a/Tai_Viet}');
    Error('\P{Script=-/a/Tai_Viet}');
    Expect(1, 43743, '\p{Script=:\ATai_Viet\z:}', "");;
    Expect(0, 43744, '\p{Script=:\ATai_Viet\z:}', "");;
    Expect(1, 43743, '\p{Script=taiviet}', "");
    Expect(0, 43743, '\p{^Script=taiviet}', "");
    Expect(0, 43743, '\P{Script=taiviet}', "");
    Expect(1, 43743, '\P{^Script=taiviet}', "");
    Expect(0, 43744, '\p{Script=taiviet}', "");
    Expect(1, 43744, '\p{^Script=taiviet}', "");
    Expect(1, 43744, '\P{Script=taiviet}', "");
    Expect(0, 43744, '\P{^Script=taiviet}', "");
    Expect(1, 43743, '\p{Script=:\Ataiviet\z:}', "");;
    Expect(0, 43744, '\p{Script=:\Ataiviet\z:}', "");;
    Expect(1, 43743, '\p{Script=-tai_Viet}', "");
    Expect(0, 43743, '\p{^Script=-tai_Viet}', "");
    Expect(0, 43743, '\P{Script=-tai_Viet}', "");
    Expect(1, 43743, '\P{^Script=-tai_Viet}', "");
    Expect(0, 43744, '\p{Script=-tai_Viet}', "");
    Expect(1, 43744, '\p{^Script=-tai_Viet}', "");
    Expect(1, 43744, '\P{Script=-tai_Viet}', "");
    Expect(0, 43744, '\P{^Script=-tai_Viet}', "");
    Error('\p{Sc=:=		Tavt}');
    Error('\P{Sc=:=		Tavt}');
    Expect(1, 43743, '\p{Sc=:\ATavt\z:}', "");;
    Expect(0, 43744, '\p{Sc=:\ATavt\z:}', "");;
    Expect(1, 43743, '\p{Sc: tavt}', "");
    Expect(0, 43743, '\p{^Sc: tavt}', "");
    Expect(0, 43743, '\P{Sc: tavt}', "");
    Expect(1, 43743, '\P{^Sc: tavt}', "");
    Expect(0, 43744, '\p{Sc: tavt}', "");
    Expect(1, 43744, '\p{^Sc: tavt}', "");
    Expect(1, 43744, '\P{Sc: tavt}', "");
    Expect(0, 43744, '\P{^Sc: tavt}', "");
    Expect(1, 43743, '\p{Sc=:\Atavt\z:}', "");;
    Expect(0, 43744, '\p{Sc=:\Atavt\z:}', "");;
    Expect(1, 43743, '\p{Sc=	TAVT}', "");
    Expect(0, 43743, '\p{^Sc=	TAVT}', "");
    Expect(0, 43743, '\P{Sc=	TAVT}', "");
    Expect(1, 43743, '\P{^Sc=	TAVT}', "");
    Expect(0, 43744, '\p{Sc=	TAVT}', "");
    Expect(1, 43744, '\p{^Sc=	TAVT}', "");
    Expect(1, 43744, '\P{Sc=	TAVT}', "");
    Expect(0, 43744, '\P{^Sc=	TAVT}', "");
    Error('\p{Is_Script=-/a/Tai_VIET}');
    Error('\P{Is_Script=-/a/Tai_VIET}');
    Expect(1, 43743, '\p{Is_Script=taiviet}', "");
    Expect(0, 43743, '\p{^Is_Script=taiviet}', "");
    Expect(0, 43743, '\P{Is_Script=taiviet}', "");
    Expect(1, 43743, '\P{^Is_Script=taiviet}', "");
    Expect(0, 43744, '\p{Is_Script=taiviet}', "");
    Expect(1, 43744, '\p{^Is_Script=taiviet}', "");
    Expect(1, 43744, '\P{Is_Script=taiviet}', "");
    Expect(0, 43744, '\P{^Is_Script=taiviet}', "");
    Expect(1, 43743, '\p{Is_Script=--tai_VIET}', "");
    Expect(0, 43743, '\p{^Is_Script=--tai_VIET}', "");
    Expect(0, 43743, '\P{Is_Script=--tai_VIET}', "");
    Expect(1, 43743, '\P{^Is_Script=--tai_VIET}', "");
    Expect(0, 43744, '\p{Is_Script=--tai_VIET}', "");
    Expect(1, 43744, '\p{^Is_Script=--tai_VIET}', "");
    Expect(1, 43744, '\P{Is_Script=--tai_VIET}', "");
    Expect(0, 43744, '\P{^Is_Script=--tai_VIET}', "");
    Error('\p{Is_Sc=:=TAVT}');
    Error('\P{Is_Sc=:=TAVT}');
    Expect(1, 43743, '\p{Is_Sc=tavt}', "");
    Expect(0, 43743, '\p{^Is_Sc=tavt}', "");
    Expect(0, 43743, '\P{Is_Sc=tavt}', "");
    Expect(1, 43743, '\P{^Is_Sc=tavt}', "");
    Expect(0, 43744, '\p{Is_Sc=tavt}', "");
    Expect(1, 43744, '\p{^Is_Sc=tavt}', "");
    Expect(1, 43744, '\P{Is_Sc=tavt}', "");
    Expect(0, 43744, '\P{^Is_Sc=tavt}', "");
    Expect(1, 43743, '\p{Is_Sc=	TAVT}', "");
    Expect(0, 43743, '\p{^Is_Sc=	TAVT}', "");
    Expect(0, 43743, '\P{Is_Sc=	TAVT}', "");
    Expect(1, 43743, '\P{^Is_Sc=	TAVT}', "");
    Expect(0, 43744, '\p{Is_Sc=	TAVT}', "");
    Expect(1, 43744, '\p{^Is_Sc=	TAVT}', "");
    Expect(1, 43744, '\P{Is_Sc=	TAVT}', "");
    Expect(0, 43744, '\P{^Is_Sc=	TAVT}', "");
    Error('\p{Script:/a/__Telugu}');
    Error('\P{Script:/a/__Telugu}');
    Expect(1, 3199, '\p{Script=:\ATelugu\z:}', "");;
    Expect(0, 3200, '\p{Script=:\ATelugu\z:}', "");;
    Expect(1, 3199, '\p{Script:	telugu}', "");
    Expect(0, 3199, '\p{^Script:	telugu}', "");
    Expect(0, 3199, '\P{Script:	telugu}', "");
    Expect(1, 3199, '\P{^Script:	telugu}', "");
    Expect(0, 3200, '\p{Script:	telugu}', "");
    Expect(1, 3200, '\p{^Script:	telugu}', "");
    Expect(1, 3200, '\P{Script:	telugu}', "");
    Expect(0, 3200, '\P{^Script:	telugu}', "");
    Expect(1, 3199, '\p{Script=:\Atelugu\z:}', "");;
    Expect(0, 3200, '\p{Script=:\Atelugu\z:}', "");;
    Expect(1, 3199, '\p{Script:   --Telugu}', "");
    Expect(0, 3199, '\p{^Script:   --Telugu}', "");
    Expect(0, 3199, '\P{Script:   --Telugu}', "");
    Expect(1, 3199, '\P{^Script:   --Telugu}', "");
    Expect(0, 3200, '\p{Script:   --Telugu}', "");
    Expect(1, 3200, '\p{^Script:   --Telugu}', "");
    Expect(1, 3200, '\P{Script:   --Telugu}', "");
    Expect(0, 3200, '\P{^Script:   --Telugu}', "");
    Error('\p{Sc=-/a/Telu}');
    Error('\P{Sc=-/a/Telu}');
    Expect(1, 3199, '\p{Sc=:\ATelu\z:}', "");;
    Expect(0, 3200, '\p{Sc=:\ATelu\z:}', "");;
    Expect(1, 3199, '\p{Sc=telu}', "");
    Expect(0, 3199, '\p{^Sc=telu}', "");
    Expect(0, 3199, '\P{Sc=telu}', "");
    Expect(1, 3199, '\P{^Sc=telu}', "");
    Expect(0, 3200, '\p{Sc=telu}', "");
    Expect(1, 3200, '\p{^Sc=telu}', "");
    Expect(1, 3200, '\P{Sc=telu}', "");
    Expect(0, 3200, '\P{^Sc=telu}', "");
    Expect(1, 3199, '\p{Sc=:\Atelu\z:}', "");;
    Expect(0, 3200, '\p{Sc=:\Atelu\z:}', "");;
    Expect(1, 3199, '\p{Sc=  Telu}', "");
    Expect(0, 3199, '\p{^Sc=  Telu}', "");
    Expect(0, 3199, '\P{Sc=  Telu}', "");
    Expect(1, 3199, '\P{^Sc=  Telu}', "");
    Expect(0, 3200, '\p{Sc=  Telu}', "");
    Expect(1, 3200, '\p{^Sc=  Telu}', "");
    Expect(1, 3200, '\P{Sc=  Telu}', "");
    Expect(0, 3200, '\P{^Sc=  Telu}', "");
    Error('\p{Is_Script=_telugu:=}');
    Error('\P{Is_Script=_telugu:=}');
    Expect(1, 3199, '\p{Is_Script=telugu}', "");
    Expect(0, 3199, '\p{^Is_Script=telugu}', "");
    Expect(0, 3199, '\P{Is_Script=telugu}', "");
    Expect(1, 3199, '\P{^Is_Script=telugu}', "");
    Expect(0, 3200, '\p{Is_Script=telugu}', "");
    Expect(1, 3200, '\p{^Is_Script=telugu}', "");
    Expect(1, 3200, '\P{Is_Script=telugu}', "");
    Expect(0, 3200, '\P{^Is_Script=telugu}', "");
    Expect(1, 3199, '\p{Is_Script:	_	Telugu}', "");
    Expect(0, 3199, '\p{^Is_Script:	_	Telugu}', "");
    Expect(0, 3199, '\P{Is_Script:	_	Telugu}', "");
    Expect(1, 3199, '\P{^Is_Script:	_	Telugu}', "");
    Expect(0, 3200, '\p{Is_Script:	_	Telugu}', "");
    Expect(1, 3200, '\p{^Is_Script:	_	Telugu}', "");
    Expect(1, 3200, '\P{Is_Script:	_	Telugu}', "");
    Expect(0, 3200, '\P{^Is_Script:	_	Telugu}', "");
    Error('\p{Is_Sc: --telu/a/}');
    Error('\P{Is_Sc: --telu/a/}');
    Expect(1, 3199, '\p{Is_Sc=telu}', "");
    Expect(0, 3199, '\p{^Is_Sc=telu}', "");
    Expect(0, 3199, '\P{Is_Sc=telu}', "");
    Expect(1, 3199, '\P{^Is_Sc=telu}', "");
    Expect(0, 3200, '\p{Is_Sc=telu}', "");
    Expect(1, 3200, '\p{^Is_Sc=telu}', "");
    Expect(1, 3200, '\P{Is_Sc=telu}', "");
    Expect(0, 3200, '\P{^Is_Sc=telu}', "");
    Expect(1, 3199, '\p{Is_Sc= TELU}', "");
    Expect(0, 3199, '\p{^Is_Sc= TELU}', "");
    Expect(0, 3199, '\P{Is_Sc= TELU}', "");
    Expect(1, 3199, '\P{^Is_Sc= TELU}', "");
    Expect(0, 3200, '\p{Is_Sc= TELU}', "");
    Expect(1, 3200, '\p{^Is_Sc= TELU}', "");
    Expect(1, 3200, '\P{Is_Sc= TELU}', "");
    Expect(0, 3200, '\P{^Is_Sc= TELU}', "");
    Error('\p{Script=_-tifinagh:=}');
    Error('\P{Script=_-tifinagh:=}');
    Expect(1, 11647, '\p{Script=:\ATifinagh\z:}', "");;
    Expect(0, 11648, '\p{Script=:\ATifinagh\z:}', "");;
    Expect(1, 11647, '\p{Script=tifinagh}', "");
    Expect(0, 11647, '\p{^Script=tifinagh}', "");
    Expect(0, 11647, '\P{Script=tifinagh}', "");
    Expect(1, 11647, '\P{^Script=tifinagh}', "");
    Expect(0, 11648, '\p{Script=tifinagh}', "");
    Expect(1, 11648, '\p{^Script=tifinagh}', "");
    Expect(1, 11648, '\P{Script=tifinagh}', "");
    Expect(0, 11648, '\P{^Script=tifinagh}', "");
    Expect(1, 11647, '\p{Script=:\Atifinagh\z:}', "");;
    Expect(0, 11648, '\p{Script=:\Atifinagh\z:}', "");;
    Expect(1, 11647, '\p{Script=_	TIFINAGH}', "");
    Expect(0, 11647, '\p{^Script=_	TIFINAGH}', "");
    Expect(0, 11647, '\P{Script=_	TIFINAGH}', "");
    Expect(1, 11647, '\P{^Script=_	TIFINAGH}', "");
    Expect(0, 11648, '\p{Script=_	TIFINAGH}', "");
    Expect(1, 11648, '\p{^Script=_	TIFINAGH}', "");
    Expect(1, 11648, '\P{Script=_	TIFINAGH}', "");
    Expect(0, 11648, '\P{^Script=_	TIFINAGH}', "");
    Error('\p{Sc:--Tfng/a/}');
    Error('\P{Sc:--Tfng/a/}');
    Expect(1, 11647, '\p{Sc=:\ATfng\z:}', "");;
    Expect(0, 11648, '\p{Sc=:\ATfng\z:}', "");;
    Expect(1, 11647, '\p{Sc=tfng}', "");
    Expect(0, 11647, '\p{^Sc=tfng}', "");
    Expect(0, 11647, '\P{Sc=tfng}', "");
    Expect(1, 11647, '\P{^Sc=tfng}', "");
    Expect(0, 11648, '\p{Sc=tfng}', "");
    Expect(1, 11648, '\p{^Sc=tfng}', "");
    Expect(1, 11648, '\P{Sc=tfng}', "");
    Expect(0, 11648, '\P{^Sc=tfng}', "");
    Expect(1, 11647, '\p{Sc=:\Atfng\z:}', "");;
    Expect(0, 11648, '\p{Sc=:\Atfng\z:}', "");;
    Expect(1, 11647, '\p{Sc=__tfng}', "");
    Expect(0, 11647, '\p{^Sc=__tfng}', "");
    Expect(0, 11647, '\P{Sc=__tfng}', "");
    Expect(1, 11647, '\P{^Sc=__tfng}', "");
    Expect(0, 11648, '\p{Sc=__tfng}', "");
    Expect(1, 11648, '\p{^Sc=__tfng}', "");
    Expect(1, 11648, '\P{Sc=__tfng}', "");
    Expect(0, 11648, '\P{^Sc=__tfng}', "");
    Error('\p{Is_Script=_:=tifinagh}');
    Error('\P{Is_Script=_:=tifinagh}');
    Expect(1, 11647, '\p{Is_Script=tifinagh}', "");
    Expect(0, 11647, '\p{^Is_Script=tifinagh}', "");
    Expect(0, 11647, '\P{Is_Script=tifinagh}', "");
    Expect(1, 11647, '\P{^Is_Script=tifinagh}', "");
    Expect(0, 11648, '\p{Is_Script=tifinagh}', "");
    Expect(1, 11648, '\p{^Is_Script=tifinagh}', "");
    Expect(1, 11648, '\P{Is_Script=tifinagh}', "");
    Expect(0, 11648, '\P{^Is_Script=tifinagh}', "");
    Expect(1, 11647, '\p{Is_Script= Tifinagh}', "");
    Expect(0, 11647, '\p{^Is_Script= Tifinagh}', "");
    Expect(0, 11647, '\P{Is_Script= Tifinagh}', "");
    Expect(1, 11647, '\P{^Is_Script= Tifinagh}', "");
    Expect(0, 11648, '\p{Is_Script= Tifinagh}', "");
    Expect(1, 11648, '\p{^Is_Script= Tifinagh}', "");
    Expect(1, 11648, '\P{Is_Script= Tifinagh}', "");
    Expect(0, 11648, '\P{^Is_Script= Tifinagh}', "");
    Error('\p{Is_Sc=  Tfng:=}');
    Error('\P{Is_Sc=  Tfng:=}');
    Expect(1, 11647, '\p{Is_Sc=tfng}', "");
    Expect(0, 11647, '\p{^Is_Sc=tfng}', "");
    Expect(0, 11647, '\P{Is_Sc=tfng}', "");
    Expect(1, 11647, '\P{^Is_Sc=tfng}', "");
    Expect(0, 11648, '\p{Is_Sc=tfng}', "");
    Expect(1, 11648, '\p{^Is_Sc=tfng}', "");
    Expect(1, 11648, '\P{Is_Sc=tfng}', "");
    Expect(0, 11648, '\P{^Is_Sc=tfng}', "");
    Expect(1, 11647, '\p{Is_Sc=	-TFNG}', "");
    Expect(0, 11647, '\p{^Is_Sc=	-TFNG}', "");
    Expect(0, 11647, '\P{Is_Sc=	-TFNG}', "");
    Expect(1, 11647, '\P{^Is_Sc=	-TFNG}', "");
    Expect(0, 11648, '\p{Is_Sc=	-TFNG}', "");
    Expect(1, 11648, '\p{^Is_Sc=	-TFNG}', "");
    Expect(1, 11648, '\P{Is_Sc=	-TFNG}', "");
    Expect(0, 11648, '\P{^Is_Sc=	-TFNG}', "");
    Error('\p{Script=	/a/Tagalog}');
    Error('\P{Script=	/a/Tagalog}');
    Expect(1, 5908, '\p{Script=:\ATagalog\z:}', "");;
    Expect(0, 5909, '\p{Script=:\ATagalog\z:}', "");;
    Expect(1, 5908, '\p{Script=tagalog}', "");
    Expect(0, 5908, '\p{^Script=tagalog}', "");
    Expect(0, 5908, '\P{Script=tagalog}', "");
    Expect(1, 5908, '\P{^Script=tagalog}', "");
    Expect(0, 5909, '\p{Script=tagalog}', "");
    Expect(1, 5909, '\p{^Script=tagalog}', "");
    Expect(1, 5909, '\P{Script=tagalog}', "");
    Expect(0, 5909, '\P{^Script=tagalog}', "");
    Expect(1, 5908, '\p{Script=:\Atagalog\z:}', "");;
    Expect(0, 5909, '\p{Script=:\Atagalog\z:}', "");;
    Expect(1, 5908, '\p{Script= tagalog}', "");
    Expect(0, 5908, '\p{^Script= tagalog}', "");
    Expect(0, 5908, '\P{Script= tagalog}', "");
    Expect(1, 5908, '\P{^Script= tagalog}', "");
    Expect(0, 5909, '\p{Script= tagalog}', "");
    Expect(1, 5909, '\p{^Script= tagalog}', "");
    Expect(1, 5909, '\P{Script= tagalog}', "");
    Expect(0, 5909, '\P{^Script= tagalog}', "");
    Error('\p{Sc=	tglg:=}');
    Error('\P{Sc=	tglg:=}');
    Expect(1, 5908, '\p{Sc=:\ATglg\z:}', "");;
    Expect(0, 5909, '\p{Sc=:\ATglg\z:}', "");;
    Expect(1, 5908, '\p{Sc=tglg}', "");
    Expect(0, 5908, '\p{^Sc=tglg}', "");
    Expect(0, 5908, '\P{Sc=tglg}', "");
    Expect(1, 5908, '\P{^Sc=tglg}', "");
    Expect(0, 5909, '\p{Sc=tglg}', "");
    Expect(1, 5909, '\p{^Sc=tglg}', "");
    Expect(1, 5909, '\P{Sc=tglg}', "");
    Expect(0, 5909, '\P{^Sc=tglg}', "");
    Expect(1, 5908, '\p{Sc=:\Atglg\z:}', "");;
    Expect(0, 5909, '\p{Sc=:\Atglg\z:}', "");;
    Expect(1, 5908, '\p{Sc=_TGLG}', "");
    Expect(0, 5908, '\p{^Sc=_TGLG}', "");
    Expect(0, 5908, '\P{Sc=_TGLG}', "");
    Expect(1, 5908, '\P{^Sc=_TGLG}', "");
    Expect(0, 5909, '\p{Sc=_TGLG}', "");
    Expect(1, 5909, '\p{^Sc=_TGLG}', "");
    Expect(1, 5909, '\P{Sc=_TGLG}', "");
    Expect(0, 5909, '\P{^Sc=_TGLG}', "");
    Error('\p{Is_Script=_-TAGALOG/a/}');
    Error('\P{Is_Script=_-TAGALOG/a/}');
    Expect(1, 5908, '\p{Is_Script=tagalog}', "");
    Expect(0, 5908, '\p{^Is_Script=tagalog}', "");
    Expect(0, 5908, '\P{Is_Script=tagalog}', "");
    Expect(1, 5908, '\P{^Is_Script=tagalog}', "");
    Expect(0, 5909, '\p{Is_Script=tagalog}', "");
    Expect(1, 5909, '\p{^Is_Script=tagalog}', "");
    Expect(1, 5909, '\P{Is_Script=tagalog}', "");
    Expect(0, 5909, '\P{^Is_Script=tagalog}', "");
    Expect(1, 5908, '\p{Is_Script=	TAGALOG}', "");
    Expect(0, 5908, '\p{^Is_Script=	TAGALOG}', "");
    Expect(0, 5908, '\P{Is_Script=	TAGALOG}', "");
    Expect(1, 5908, '\P{^Is_Script=	TAGALOG}', "");
    Expect(0, 5909, '\p{Is_Script=	TAGALOG}', "");
    Expect(1, 5909, '\p{^Is_Script=	TAGALOG}', "");
    Expect(1, 5909, '\P{Is_Script=	TAGALOG}', "");
    Expect(0, 5909, '\P{^Is_Script=	TAGALOG}', "");
    Error('\p{Is_Sc=	-tglg:=}');
    Error('\P{Is_Sc=	-tglg:=}');
    Expect(1, 5908, '\p{Is_Sc=tglg}', "");
    Expect(0, 5908, '\p{^Is_Sc=tglg}', "");
    Expect(0, 5908, '\P{Is_Sc=tglg}', "");
    Expect(1, 5908, '\P{^Is_Sc=tglg}', "");
    Expect(0, 5909, '\p{Is_Sc=tglg}', "");
    Expect(1, 5909, '\p{^Is_Sc=tglg}', "");
    Expect(1, 5909, '\P{Is_Sc=tglg}', "");
    Expect(0, 5909, '\P{^Is_Sc=tglg}', "");
    Expect(1, 5908, '\p{Is_Sc: -_Tglg}', "");
    Expect(0, 5908, '\p{^Is_Sc: -_Tglg}', "");
    Expect(0, 5908, '\P{Is_Sc: -_Tglg}', "");
    Expect(1, 5908, '\P{^Is_Sc: -_Tglg}', "");
    Expect(0, 5909, '\p{Is_Sc: -_Tglg}', "");
    Expect(1, 5909, '\p{^Is_Sc: -_Tglg}', "");
    Expect(1, 5909, '\P{Is_Sc: -_Tglg}', "");
    Expect(0, 5909, '\P{^Is_Sc: -_Tglg}', "");
    Error('\p{Script= _Thaana:=}');
    Error('\P{Script= _Thaana:=}');
    Expect(1, 1969, '\p{Script=:\AThaana\z:}', "");;
    Expect(0, 1970, '\p{Script=:\AThaana\z:}', "");;
    Expect(1, 1969, '\p{Script: thaana}', "");
    Expect(0, 1969, '\p{^Script: thaana}', "");
    Expect(0, 1969, '\P{Script: thaana}', "");
    Expect(1, 1969, '\P{^Script: thaana}', "");
    Expect(0, 1970, '\p{Script: thaana}', "");
    Expect(1, 1970, '\p{^Script: thaana}', "");
    Expect(1, 1970, '\P{Script: thaana}', "");
    Expect(0, 1970, '\P{^Script: thaana}', "");
    Expect(1, 1969, '\p{Script=:\Athaana\z:}', "");;
    Expect(0, 1970, '\p{Script=:\Athaana\z:}', "");;
    Expect(1, 1969, '\p{Script=-	Thaana}', "");
    Expect(0, 1969, '\p{^Script=-	Thaana}', "");
    Expect(0, 1969, '\P{Script=-	Thaana}', "");
    Expect(1, 1969, '\P{^Script=-	Thaana}', "");
    Expect(0, 1970, '\p{Script=-	Thaana}', "");
    Expect(1, 1970, '\p{^Script=-	Thaana}', "");
    Expect(1, 1970, '\P{Script=-	Thaana}', "");
    Expect(0, 1970, '\P{^Script=-	Thaana}', "");
    Error('\p{Sc=-Thaa/a/}');
    Error('\P{Sc=-Thaa/a/}');
    Expect(1, 1969, '\p{Sc=:\AThaa\z:}', "");;
    Expect(0, 1970, '\p{Sc=:\AThaa\z:}', "");;
    Expect(1, 1969, '\p{Sc=thaa}', "");
    Expect(0, 1969, '\p{^Sc=thaa}', "");
    Expect(0, 1969, '\P{Sc=thaa}', "");
    Expect(1, 1969, '\P{^Sc=thaa}', "");
    Expect(0, 1970, '\p{Sc=thaa}', "");
    Expect(1, 1970, '\p{^Sc=thaa}', "");
    Expect(1, 1970, '\P{Sc=thaa}', "");
    Expect(0, 1970, '\P{^Sc=thaa}', "");
    Expect(1, 1969, '\p{Sc=:\Athaa\z:}', "");;
    Expect(0, 1970, '\p{Sc=:\Athaa\z:}', "");;
    Expect(1, 1969, '\p{Sc=_-Thaa}', "");
    Expect(0, 1969, '\p{^Sc=_-Thaa}', "");
    Expect(0, 1969, '\P{Sc=_-Thaa}', "");
    Expect(1, 1969, '\P{^Sc=_-Thaa}', "");
    Expect(0, 1970, '\p{Sc=_-Thaa}', "");
    Expect(1, 1970, '\p{^Sc=_-Thaa}', "");
    Expect(1, 1970, '\P{Sc=_-Thaa}', "");
    Expect(0, 1970, '\P{^Sc=_-Thaa}', "");
    Error('\p{Is_Script=	THAANA:=}');
    Error('\P{Is_Script=	THAANA:=}');
    Expect(1, 1969, '\p{Is_Script=thaana}', "");
    Expect(0, 1969, '\p{^Is_Script=thaana}', "");
    Expect(0, 1969, '\P{Is_Script=thaana}', "");
    Expect(1, 1969, '\P{^Is_Script=thaana}', "");
    Expect(0, 1970, '\p{Is_Script=thaana}', "");
    Expect(1, 1970, '\p{^Is_Script=thaana}', "");
    Expect(1, 1970, '\P{Is_Script=thaana}', "");
    Expect(0, 1970, '\P{^Is_Script=thaana}', "");
    Expect(1, 1969, '\p{Is_Script=	_THAANA}', "");
    Expect(0, 1969, '\p{^Is_Script=	_THAANA}', "");
    Expect(0, 1969, '\P{Is_Script=	_THAANA}', "");
    Expect(1, 1969, '\P{^Is_Script=	_THAANA}', "");
    Expect(0, 1970, '\p{Is_Script=	_THAANA}', "");
    Expect(1, 1970, '\p{^Is_Script=	_THAANA}', "");
    Expect(1, 1970, '\P{Is_Script=	_THAANA}', "");
    Expect(0, 1970, '\P{^Is_Script=	_THAANA}', "");
    Error('\p{Is_Sc= /a/THAA}');
    Error('\P{Is_Sc= /a/THAA}');
    Expect(1, 1969, '\p{Is_Sc=thaa}', "");
    Expect(0, 1969, '\p{^Is_Sc=thaa}', "");
    Expect(0, 1969, '\P{Is_Sc=thaa}', "");
    Expect(1, 1969, '\P{^Is_Sc=thaa}', "");
    Expect(0, 1970, '\p{Is_Sc=thaa}', "");
    Expect(1, 1970, '\p{^Is_Sc=thaa}', "");
    Expect(1, 1970, '\P{Is_Sc=thaa}', "");
    Expect(0, 1970, '\P{^Is_Sc=thaa}', "");
    Expect(1, 1969, '\p{Is_Sc=	 Thaa}', "");
    Expect(0, 1969, '\p{^Is_Sc=	 Thaa}', "");
    Expect(0, 1969, '\P{Is_Sc=	 Thaa}', "");
    Expect(1, 1969, '\P{^Is_Sc=	 Thaa}', "");
    Expect(0, 1970, '\p{Is_Sc=	 Thaa}', "");
    Expect(1, 1970, '\p{^Is_Sc=	 Thaa}', "");
    Expect(1, 1970, '\P{Is_Sc=	 Thaa}', "");
    Expect(0, 1970, '\P{^Is_Sc=	 Thaa}', "");
    Error('\p{Script=:=-_thai}');
    Error('\P{Script=:=-_thai}');
    Expect(1, 3675, '\p{Script=:\AThai\z:}', "");;
    Expect(0, 3676, '\p{Script=:\AThai\z:}', "");;
    Expect(1, 3675, '\p{Script: thai}', "");
    Expect(0, 3675, '\p{^Script: thai}', "");
    Expect(0, 3675, '\P{Script: thai}', "");
    Expect(1, 3675, '\P{^Script: thai}', "");
    Expect(0, 3676, '\p{Script: thai}', "");
    Expect(1, 3676, '\p{^Script: thai}', "");
    Expect(1, 3676, '\P{Script: thai}', "");
    Expect(0, 3676, '\P{^Script: thai}', "");
    Expect(1, 3675, '\p{Script=:\Athai\z:}', "");;
    Expect(0, 3676, '\p{Script=:\Athai\z:}', "");;
    Expect(1, 3675, '\p{Script:	-THAI}', "");
    Expect(0, 3675, '\p{^Script:	-THAI}', "");
    Expect(0, 3675, '\P{Script:	-THAI}', "");
    Expect(1, 3675, '\P{^Script:	-THAI}', "");
    Expect(0, 3676, '\p{Script:	-THAI}', "");
    Expect(1, 3676, '\p{^Script:	-THAI}', "");
    Expect(1, 3676, '\P{Script:	-THAI}', "");
    Expect(0, 3676, '\P{^Script:	-THAI}', "");
    Error('\p{Sc=:=THAI}');
    Error('\P{Sc=:=THAI}');
    Expect(1, 3675, '\p{Sc=:\AThai\z:}', "");;
    Expect(0, 3676, '\p{Sc=:\AThai\z:}', "");;
    Expect(1, 3675, '\p{Sc=thai}', "");
    Expect(0, 3675, '\p{^Sc=thai}', "");
    Expect(0, 3675, '\P{Sc=thai}', "");
    Expect(1, 3675, '\P{^Sc=thai}', "");
    Expect(0, 3676, '\p{Sc=thai}', "");
    Expect(1, 3676, '\p{^Sc=thai}', "");
    Expect(1, 3676, '\P{Sc=thai}', "");
    Expect(0, 3676, '\P{^Sc=thai}', "");
    Expect(1, 3675, '\p{Sc=:\Athai\z:}', "");;
    Expect(0, 3676, '\p{Sc=:\Athai\z:}', "");;
    Expect(1, 3675, '\p{Sc: _ Thai}', "");
    Expect(0, 3675, '\p{^Sc: _ Thai}', "");
    Expect(0, 3675, '\P{Sc: _ Thai}', "");
    Expect(1, 3675, '\P{^Sc: _ Thai}', "");
    Expect(0, 3676, '\p{Sc: _ Thai}', "");
    Expect(1, 3676, '\p{^Sc: _ Thai}', "");
    Expect(1, 3676, '\P{Sc: _ Thai}', "");
    Expect(0, 3676, '\P{^Sc: _ Thai}', "");
    Error('\p{Is_Script:/a/ 	Thai}');
    Error('\P{Is_Script:/a/ 	Thai}');
    Expect(1, 3675, '\p{Is_Script=thai}', "");
    Expect(0, 3675, '\p{^Is_Script=thai}', "");
    Expect(0, 3675, '\P{Is_Script=thai}', "");
    Expect(1, 3675, '\P{^Is_Script=thai}', "");
    Expect(0, 3676, '\p{Is_Script=thai}', "");
    Expect(1, 3676, '\p{^Is_Script=thai}', "");
    Expect(1, 3676, '\P{Is_Script=thai}', "");
    Expect(0, 3676, '\P{^Is_Script=thai}', "");
    Expect(1, 3675, '\p{Is_Script= -THAI}', "");
    Expect(0, 3675, '\p{^Is_Script= -THAI}', "");
    Expect(0, 3675, '\P{Is_Script= -THAI}', "");
    Expect(1, 3675, '\P{^Is_Script= -THAI}', "");
    Expect(0, 3676, '\p{Is_Script= -THAI}', "");
    Expect(1, 3676, '\p{^Is_Script= -THAI}', "");
    Expect(1, 3676, '\P{Is_Script= -THAI}', "");
    Expect(0, 3676, '\P{^Is_Script= -THAI}', "");
    Error('\p{Is_Sc=-_Thai:=}');
    Error('\P{Is_Sc=-_Thai:=}');
    Expect(1, 3675, '\p{Is_Sc:   thai}', "");
    Expect(0, 3675, '\p{^Is_Sc:   thai}', "");
    Expect(0, 3675, '\P{Is_Sc:   thai}', "");
    Expect(1, 3675, '\P{^Is_Sc:   thai}', "");
    Expect(0, 3676, '\p{Is_Sc:   thai}', "");
    Expect(1, 3676, '\p{^Is_Sc:   thai}', "");
    Expect(1, 3676, '\P{Is_Sc:   thai}', "");
    Expect(0, 3676, '\P{^Is_Sc:   thai}', "");
    Expect(1, 3675, '\p{Is_Sc=_thai}', "");
    Expect(0, 3675, '\p{^Is_Sc=_thai}', "");
    Expect(0, 3675, '\P{Is_Sc=_thai}', "");
    Expect(1, 3675, '\P{^Is_Sc=_thai}', "");
    Expect(0, 3676, '\p{Is_Sc=_thai}', "");
    Expect(1, 3676, '\p{^Is_Sc=_thai}', "");
    Expect(1, 3676, '\P{Is_Sc=_thai}', "");
    Expect(0, 3676, '\P{^Is_Sc=_thai}', "");
    Error('\p{Script=	:=Tibetan}');
    Error('\P{Script=	:=Tibetan}');
    Expect(1, 4058, '\p{Script=:\ATibetan\z:}', "");;
    Expect(0, 4059, '\p{Script=:\ATibetan\z:}', "");;
    Expect(1, 4058, '\p{Script=tibetan}', "");
    Expect(0, 4058, '\p{^Script=tibetan}', "");
    Expect(0, 4058, '\P{Script=tibetan}', "");
    Expect(1, 4058, '\P{^Script=tibetan}', "");
    Expect(0, 4059, '\p{Script=tibetan}', "");
    Expect(1, 4059, '\p{^Script=tibetan}', "");
    Expect(1, 4059, '\P{Script=tibetan}', "");
    Expect(0, 4059, '\P{^Script=tibetan}', "");
    Expect(1, 4058, '\p{Script=:\Atibetan\z:}', "");;
    Expect(0, 4059, '\p{Script=:\Atibetan\z:}', "");;
    Expect(1, 4058, '\p{Script=	TIBETAN}', "");
    Expect(0, 4058, '\p{^Script=	TIBETAN}', "");
    Expect(0, 4058, '\P{Script=	TIBETAN}', "");
    Expect(1, 4058, '\P{^Script=	TIBETAN}', "");
    Expect(0, 4059, '\p{Script=	TIBETAN}', "");
    Expect(1, 4059, '\p{^Script=	TIBETAN}', "");
    Expect(1, 4059, '\P{Script=	TIBETAN}', "");
    Expect(0, 4059, '\P{^Script=	TIBETAN}', "");
    Error('\p{Sc=:=TIBT}');
    Error('\P{Sc=:=TIBT}');
    Expect(1, 4058, '\p{Sc=:\ATibt\z:}', "");;
    Expect(0, 4059, '\p{Sc=:\ATibt\z:}', "");;
    Expect(1, 4058, '\p{Sc=tibt}', "");
    Expect(0, 4058, '\p{^Sc=tibt}', "");
    Expect(0, 4058, '\P{Sc=tibt}', "");
    Expect(1, 4058, '\P{^Sc=tibt}', "");
    Expect(0, 4059, '\p{Sc=tibt}', "");
    Expect(1, 4059, '\p{^Sc=tibt}', "");
    Expect(1, 4059, '\P{Sc=tibt}', "");
    Expect(0, 4059, '\P{^Sc=tibt}', "");
    Expect(1, 4058, '\p{Sc=:\Atibt\z:}', "");;
    Expect(0, 4059, '\p{Sc=:\Atibt\z:}', "");;
    Expect(1, 4058, '\p{Sc=-Tibt}', "");
    Expect(0, 4058, '\p{^Sc=-Tibt}', "");
    Expect(0, 4058, '\P{Sc=-Tibt}', "");
    Expect(1, 4058, '\P{^Sc=-Tibt}', "");
    Expect(0, 4059, '\p{Sc=-Tibt}', "");
    Expect(1, 4059, '\p{^Sc=-Tibt}', "");
    Expect(1, 4059, '\P{Sc=-Tibt}', "");
    Expect(0, 4059, '\P{^Sc=-Tibt}', "");
    Error('\p{Is_Script=	 tibetan:=}');
    Error('\P{Is_Script=	 tibetan:=}');
    Expect(1, 4058, '\p{Is_Script=tibetan}', "");
    Expect(0, 4058, '\p{^Is_Script=tibetan}', "");
    Expect(0, 4058, '\P{Is_Script=tibetan}', "");
    Expect(1, 4058, '\P{^Is_Script=tibetan}', "");
    Expect(0, 4059, '\p{Is_Script=tibetan}', "");
    Expect(1, 4059, '\p{^Is_Script=tibetan}', "");
    Expect(1, 4059, '\P{Is_Script=tibetan}', "");
    Expect(0, 4059, '\P{^Is_Script=tibetan}', "");
    Expect(1, 4058, '\p{Is_Script=  Tibetan}', "");
    Expect(0, 4058, '\p{^Is_Script=  Tibetan}', "");
    Expect(0, 4058, '\P{Is_Script=  Tibetan}', "");
    Expect(1, 4058, '\P{^Is_Script=  Tibetan}', "");
    Expect(0, 4059, '\p{Is_Script=  Tibetan}', "");
    Expect(1, 4059, '\p{^Is_Script=  Tibetan}', "");
    Expect(1, 4059, '\P{Is_Script=  Tibetan}', "");
    Expect(0, 4059, '\P{^Is_Script=  Tibetan}', "");
    Error('\p{Is_Sc=/a/_Tibt}');
    Error('\P{Is_Sc=/a/_Tibt}');
    Expect(1, 4058, '\p{Is_Sc=tibt}', "");
    Expect(0, 4058, '\p{^Is_Sc=tibt}', "");
    Expect(0, 4058, '\P{Is_Sc=tibt}', "");
    Expect(1, 4058, '\P{^Is_Sc=tibt}', "");
    Expect(0, 4059, '\p{Is_Sc=tibt}', "");
    Expect(1, 4059, '\p{^Is_Sc=tibt}', "");
    Expect(1, 4059, '\P{Is_Sc=tibt}', "");
    Expect(0, 4059, '\P{^Is_Sc=tibt}', "");
    Expect(1, 4058, '\p{Is_Sc: 	 TIBT}', "");
    Expect(0, 4058, '\p{^Is_Sc: 	 TIBT}', "");
    Expect(0, 4058, '\P{Is_Sc: 	 TIBT}', "");
    Expect(1, 4058, '\P{^Is_Sc: 	 TIBT}', "");
    Expect(0, 4059, '\p{Is_Sc: 	 TIBT}', "");
    Expect(1, 4059, '\p{^Is_Sc: 	 TIBT}', "");
    Expect(1, 4059, '\P{Is_Sc: 	 TIBT}', "");
    Expect(0, 4059, '\P{^Is_Sc: 	 TIBT}', "");
    Error('\p{Script=:=_Tirhuta}');
    Error('\P{Script=:=_Tirhuta}');
    Expect(1, 70873, '\p{Script=:\ATirhuta\z:}', "");;
    Expect(0, 70874, '\p{Script=:\ATirhuta\z:}', "");;
    Expect(1, 70873, '\p{Script=tirhuta}', "");
    Expect(0, 70873, '\p{^Script=tirhuta}', "");
    Expect(0, 70873, '\P{Script=tirhuta}', "");
    Expect(1, 70873, '\P{^Script=tirhuta}', "");
    Expect(0, 70874, '\p{Script=tirhuta}', "");
    Expect(1, 70874, '\p{^Script=tirhuta}', "");
    Expect(1, 70874, '\P{Script=tirhuta}', "");
    Expect(0, 70874, '\P{^Script=tirhuta}', "");
    Expect(1, 70873, '\p{Script=:\Atirhuta\z:}', "");;
    Expect(0, 70874, '\p{Script=:\Atirhuta\z:}', "");;
    Expect(1, 70873, '\p{Script=	Tirhuta}', "");
    Expect(0, 70873, '\p{^Script=	Tirhuta}', "");
    Expect(0, 70873, '\P{Script=	Tirhuta}', "");
    Expect(1, 70873, '\P{^Script=	Tirhuta}', "");
    Expect(0, 70874, '\p{Script=	Tirhuta}', "");
    Expect(1, 70874, '\p{^Script=	Tirhuta}', "");
    Expect(1, 70874, '\P{Script=	Tirhuta}', "");
    Expect(0, 70874, '\P{^Script=	Tirhuta}', "");
    Error('\p{Sc=/a/Tirh}');
    Error('\P{Sc=/a/Tirh}');
    Expect(1, 70873, '\p{Sc=:\ATirh\z:}', "");;
    Expect(0, 70874, '\p{Sc=:\ATirh\z:}', "");;
    Expect(1, 70873, '\p{Sc=tirh}', "");
    Expect(0, 70873, '\p{^Sc=tirh}', "");
    Expect(0, 70873, '\P{Sc=tirh}', "");
    Expect(1, 70873, '\P{^Sc=tirh}', "");
    Expect(0, 70874, '\p{Sc=tirh}', "");
    Expect(1, 70874, '\p{^Sc=tirh}', "");
    Expect(1, 70874, '\P{Sc=tirh}', "");
    Expect(0, 70874, '\P{^Sc=tirh}', "");
    Expect(1, 70873, '\p{Sc=:\Atirh\z:}', "");;
    Expect(0, 70874, '\p{Sc=:\Atirh\z:}', "");;
    Expect(1, 70873, '\p{Sc=TIRH}', "");
    Expect(0, 70873, '\p{^Sc=TIRH}', "");
    Expect(0, 70873, '\P{Sc=TIRH}', "");
    Expect(1, 70873, '\P{^Sc=TIRH}', "");
    Expect(0, 70874, '\p{Sc=TIRH}', "");
    Expect(1, 70874, '\p{^Sc=TIRH}', "");
    Expect(1, 70874, '\P{Sc=TIRH}', "");
    Expect(0, 70874, '\P{^Sc=TIRH}', "");
    Error('\p{Is_Script=/a/__Tirhuta}');
    Error('\P{Is_Script=/a/__Tirhuta}');
    Expect(1, 70873, '\p{Is_Script=tirhuta}', "");
    Expect(0, 70873, '\p{^Is_Script=tirhuta}', "");
    Expect(0, 70873, '\P{Is_Script=tirhuta}', "");
    Expect(1, 70873, '\P{^Is_Script=tirhuta}', "");
    Expect(0, 70874, '\p{Is_Script=tirhuta}', "");
    Expect(1, 70874, '\p{^Is_Script=tirhuta}', "");
    Expect(1, 70874, '\P{Is_Script=tirhuta}', "");
    Expect(0, 70874, '\P{^Is_Script=tirhuta}', "");
    Expect(1, 70873, '\p{Is_Script=	-Tirhuta}', "");
    Expect(0, 70873, '\p{^Is_Script=	-Tirhuta}', "");
    Expect(0, 70873, '\P{Is_Script=	-Tirhuta}', "");
    Expect(1, 70873, '\P{^Is_Script=	-Tirhuta}', "");
    Expect(0, 70874, '\p{Is_Script=	-Tirhuta}', "");
    Expect(1, 70874, '\p{^Is_Script=	-Tirhuta}', "");
    Expect(1, 70874, '\P{Is_Script=	-Tirhuta}', "");
    Expect(0, 70874, '\P{^Is_Script=	-Tirhuta}', "");
    Error('\p{Is_Sc=-	Tirh/a/}');
    Error('\P{Is_Sc=-	Tirh/a/}');
    Expect(1, 70873, '\p{Is_Sc=tirh}', "");
    Expect(0, 70873, '\p{^Is_Sc=tirh}', "");
    Expect(0, 70873, '\P{Is_Sc=tirh}', "");
    Expect(1, 70873, '\P{^Is_Sc=tirh}', "");
    Expect(0, 70874, '\p{Is_Sc=tirh}', "");
    Expect(1, 70874, '\p{^Is_Sc=tirh}', "");
    Expect(1, 70874, '\P{Is_Sc=tirh}', "");
    Expect(0, 70874, '\P{^Is_Sc=tirh}', "");
    Error('\p{Script=:=Ugaritic}');
    Error('\P{Script=:=Ugaritic}');
    Expect(1, 66463, '\p{Script=:\AUgaritic\z:}', "");;
    Expect(0, 66464, '\p{Script=:\AUgaritic\z:}', "");;
    Expect(1, 66463, '\p{Script=ugaritic}', "");
    Expect(0, 66463, '\p{^Script=ugaritic}', "");
    Expect(0, 66463, '\P{Script=ugaritic}', "");
    Expect(1, 66463, '\P{^Script=ugaritic}', "");
    Expect(0, 66464, '\p{Script=ugaritic}', "");
    Expect(1, 66464, '\p{^Script=ugaritic}', "");
    Expect(1, 66464, '\P{Script=ugaritic}', "");
    Expect(0, 66464, '\P{^Script=ugaritic}', "");
    Expect(1, 66463, '\p{Script=:\Augaritic\z:}', "");;
    Expect(0, 66464, '\p{Script=:\Augaritic\z:}', "");;
    Expect(1, 66463, '\p{Script=_	ugaritic}', "");
    Expect(0, 66463, '\p{^Script=_	ugaritic}', "");
    Expect(0, 66463, '\P{Script=_	ugaritic}', "");
    Expect(1, 66463, '\P{^Script=_	ugaritic}', "");
    Expect(0, 66464, '\p{Script=_	ugaritic}', "");
    Expect(1, 66464, '\p{^Script=_	ugaritic}', "");
    Expect(1, 66464, '\P{Script=_	ugaritic}', "");
    Expect(0, 66464, '\P{^Script=_	ugaritic}', "");
    Error('\p{Sc=:=	Ugar}');
    Error('\P{Sc=:=	Ugar}');
    Expect(1, 66463, '\p{Sc=:\AUgar\z:}', "");;
    Expect(0, 66464, '\p{Sc=:\AUgar\z:}', "");;
    Expect(1, 66463, '\p{Sc=ugar}', "");
    Expect(0, 66463, '\p{^Sc=ugar}', "");
    Expect(0, 66463, '\P{Sc=ugar}', "");
    Expect(1, 66463, '\P{^Sc=ugar}', "");
    Expect(0, 66464, '\p{Sc=ugar}', "");
    Expect(1, 66464, '\p{^Sc=ugar}', "");
    Expect(1, 66464, '\P{Sc=ugar}', "");
    Expect(0, 66464, '\P{^Sc=ugar}', "");
    Expect(1, 66463, '\p{Sc=:\Augar\z:}', "");;
    Expect(0, 66464, '\p{Sc=:\Augar\z:}', "");;
    Expect(1, 66463, '\p{Sc= -ugar}', "");
    Expect(0, 66463, '\p{^Sc= -ugar}', "");
    Expect(0, 66463, '\P{Sc= -ugar}', "");
    Expect(1, 66463, '\P{^Sc= -ugar}', "");
    Expect(0, 66464, '\p{Sc= -ugar}', "");
    Expect(1, 66464, '\p{^Sc= -ugar}', "");
    Expect(1, 66464, '\P{Sc= -ugar}', "");
    Expect(0, 66464, '\P{^Sc= -ugar}', "");
    Error('\p{Is_Script=/a/		Ugaritic}');
    Error('\P{Is_Script=/a/		Ugaritic}');
    Expect(1, 66463, '\p{Is_Script=ugaritic}', "");
    Expect(0, 66463, '\p{^Is_Script=ugaritic}', "");
    Expect(0, 66463, '\P{Is_Script=ugaritic}', "");
    Expect(1, 66463, '\P{^Is_Script=ugaritic}', "");
    Expect(0, 66464, '\p{Is_Script=ugaritic}', "");
    Expect(1, 66464, '\p{^Is_Script=ugaritic}', "");
    Expect(1, 66464, '\P{Is_Script=ugaritic}', "");
    Expect(0, 66464, '\P{^Is_Script=ugaritic}', "");
    Expect(1, 66463, '\p{Is_Script=	 ugaritic}', "");
    Expect(0, 66463, '\p{^Is_Script=	 ugaritic}', "");
    Expect(0, 66463, '\P{Is_Script=	 ugaritic}', "");
    Expect(1, 66463, '\P{^Is_Script=	 ugaritic}', "");
    Expect(0, 66464, '\p{Is_Script=	 ugaritic}', "");
    Expect(1, 66464, '\p{^Is_Script=	 ugaritic}', "");
    Expect(1, 66464, '\P{Is_Script=	 ugaritic}', "");
    Expect(0, 66464, '\P{^Is_Script=	 ugaritic}', "");
    Error('\p{Is_Sc=/a/ugar}');
    Error('\P{Is_Sc=/a/ugar}');
    Expect(1, 66463, '\p{Is_Sc: ugar}', "");
    Expect(0, 66463, '\p{^Is_Sc: ugar}', "");
    Expect(0, 66463, '\P{Is_Sc: ugar}', "");
    Expect(1, 66463, '\P{^Is_Sc: ugar}', "");
    Expect(0, 66464, '\p{Is_Sc: ugar}', "");
    Expect(1, 66464, '\p{^Is_Sc: ugar}', "");
    Expect(1, 66464, '\P{Is_Sc: ugar}', "");
    Expect(0, 66464, '\P{^Is_Sc: ugar}', "");
    Expect(1, 66463, '\p{Is_Sc= Ugar}', "");
    Expect(0, 66463, '\p{^Is_Sc= Ugar}', "");
    Expect(0, 66463, '\P{Is_Sc= Ugar}', "");
    Expect(1, 66463, '\P{^Is_Sc= Ugar}', "");
    Expect(0, 66464, '\p{Is_Sc= Ugar}', "");
    Expect(1, 66464, '\p{^Is_Sc= Ugar}', "");
    Expect(1, 66464, '\P{Is_Sc= Ugar}', "");
    Expect(0, 66464, '\P{^Is_Sc= Ugar}', "");
    Error('\p{Script: /a/vai}');
    Error('\P{Script: /a/vai}');
    Expect(1, 42539, '\p{Script=:\AVai\z:}', "");;
    Expect(0, 42540, '\p{Script=:\AVai\z:}', "");;
    Expect(1, 42539, '\p{Script=vai}', "");
    Expect(0, 42539, '\p{^Script=vai}', "");
    Expect(0, 42539, '\P{Script=vai}', "");
    Expect(1, 42539, '\P{^Script=vai}', "");
    Expect(0, 42540, '\p{Script=vai}', "");
    Expect(1, 42540, '\p{^Script=vai}', "");
    Expect(1, 42540, '\P{Script=vai}', "");
    Expect(0, 42540, '\P{^Script=vai}', "");
    Expect(1, 42539, '\p{Script=:\Avai\z:}', "");;
    Expect(0, 42540, '\p{Script=:\Avai\z:}', "");;
    Expect(1, 42539, '\p{Script=__Vai}', "");
    Expect(0, 42539, '\p{^Script=__Vai}', "");
    Expect(0, 42539, '\P{Script=__Vai}', "");
    Expect(1, 42539, '\P{^Script=__Vai}', "");
    Expect(0, 42540, '\p{Script=__Vai}', "");
    Expect(1, 42540, '\p{^Script=__Vai}', "");
    Expect(1, 42540, '\P{Script=__Vai}', "");
    Expect(0, 42540, '\P{^Script=__Vai}', "");
    Error('\p{Sc=:=--Vaii}');
    Error('\P{Sc=:=--Vaii}');
    Expect(1, 42539, '\p{Sc=:\AVaii\z:}', "");;
    Expect(0, 42540, '\p{Sc=:\AVaii\z:}', "");;
    Expect(1, 42539, '\p{Sc:	vaii}', "");
    Expect(0, 42539, '\p{^Sc:	vaii}', "");
    Expect(0, 42539, '\P{Sc:	vaii}', "");
    Expect(1, 42539, '\P{^Sc:	vaii}', "");
    Expect(0, 42540, '\p{Sc:	vaii}', "");
    Expect(1, 42540, '\p{^Sc:	vaii}', "");
    Expect(1, 42540, '\P{Sc:	vaii}', "");
    Expect(0, 42540, '\P{^Sc:	vaii}', "");
    Expect(1, 42539, '\p{Sc=:\Avaii\z:}', "");;
    Expect(0, 42540, '\p{Sc=:\Avaii\z:}', "");;
    Expect(1, 42539, '\p{Sc=_	vaii}', "");
    Expect(0, 42539, '\p{^Sc=_	vaii}', "");
    Expect(0, 42539, '\P{Sc=_	vaii}', "");
    Expect(1, 42539, '\P{^Sc=_	vaii}', "");
    Expect(0, 42540, '\p{Sc=_	vaii}', "");
    Expect(1, 42540, '\p{^Sc=_	vaii}', "");
    Expect(1, 42540, '\P{Sc=_	vaii}', "");
    Expect(0, 42540, '\P{^Sc=_	vaii}', "");
    Error('\p{Is_Script= vai/a/}');
    Error('\P{Is_Script= vai/a/}');
    Expect(1, 42539, '\p{Is_Script=vai}', "");
    Expect(0, 42539, '\p{^Is_Script=vai}', "");
    Expect(0, 42539, '\P{Is_Script=vai}', "");
    Expect(1, 42539, '\P{^Is_Script=vai}', "");
    Expect(0, 42540, '\p{Is_Script=vai}', "");
    Expect(1, 42540, '\p{^Is_Script=vai}', "");
    Expect(1, 42540, '\P{Is_Script=vai}', "");
    Expect(0, 42540, '\P{^Is_Script=vai}', "");
    Expect(1, 42539, '\p{Is_Script= _vai}', "");
    Expect(0, 42539, '\p{^Is_Script= _vai}', "");
    Expect(0, 42539, '\P{Is_Script= _vai}', "");
    Expect(1, 42539, '\P{^Is_Script= _vai}', "");
    Expect(0, 42540, '\p{Is_Script= _vai}', "");
    Expect(1, 42540, '\p{^Is_Script= _vai}', "");
    Expect(1, 42540, '\P{Is_Script= _vai}', "");
    Expect(0, 42540, '\P{^Is_Script= _vai}', "");
    Error('\p{Is_Sc=	/a/Vaii}');
    Error('\P{Is_Sc=	/a/Vaii}');
    Expect(1, 42539, '\p{Is_Sc:vaii}', "");
    Expect(0, 42539, '\p{^Is_Sc:vaii}', "");
    Expect(0, 42539, '\P{Is_Sc:vaii}', "");
    Expect(1, 42539, '\P{^Is_Sc:vaii}', "");
    Expect(0, 42540, '\p{Is_Sc:vaii}', "");
    Expect(1, 42540, '\p{^Is_Sc:vaii}', "");
    Expect(1, 42540, '\P{Is_Sc:vaii}', "");
    Expect(0, 42540, '\P{^Is_Sc:vaii}', "");
    Expect(1, 42539, '\p{Is_Sc=--VAII}', "");
    Expect(0, 42539, '\p{^Is_Sc=--VAII}', "");
    Expect(0, 42539, '\P{Is_Sc=--VAII}', "");
    Expect(1, 42539, '\P{^Is_Sc=--VAII}', "");
    Expect(0, 42540, '\p{Is_Sc=--VAII}', "");
    Expect(1, 42540, '\p{^Is_Sc=--VAII}', "");
    Expect(1, 42540, '\P{Is_Sc=--VAII}', "");
    Expect(0, 42540, '\P{^Is_Sc=--VAII}', "");
    Error('\p{Script=:=	 Warang_Citi}');
    Error('\P{Script=:=	 Warang_Citi}');
    Expect(1, 71935, '\p{Script=:\AWarang_Citi\z:}', "");;
    Expect(0, 71936, '\p{Script=:\AWarang_Citi\z:}', "");;
    Expect(1, 71935, '\p{Script=warangciti}', "");
    Expect(0, 71935, '\p{^Script=warangciti}', "");
    Expect(0, 71935, '\P{Script=warangciti}', "");
    Expect(1, 71935, '\P{^Script=warangciti}', "");
    Expect(0, 71936, '\p{Script=warangciti}', "");
    Expect(1, 71936, '\p{^Script=warangciti}', "");
    Expect(1, 71936, '\P{Script=warangciti}', "");
    Expect(0, 71936, '\P{^Script=warangciti}', "");
    Expect(1, 71935, '\p{Script=:\Awarangciti\z:}', "");;
    Expect(0, 71936, '\p{Script=:\Awarangciti\z:}', "");;
    Expect(1, 71935, '\p{Script=-Warang_citi}', "");
    Expect(0, 71935, '\p{^Script=-Warang_citi}', "");
    Expect(0, 71935, '\P{Script=-Warang_citi}', "");
    Expect(1, 71935, '\P{^Script=-Warang_citi}', "");
    Expect(0, 71936, '\p{Script=-Warang_citi}', "");
    Expect(1, 71936, '\p{^Script=-Warang_citi}', "");
    Expect(1, 71936, '\P{Script=-Warang_citi}', "");
    Expect(0, 71936, '\P{^Script=-Warang_citi}', "");
    Error('\p{Sc=/a/	_Wara}');
    Error('\P{Sc=/a/	_Wara}');
    Expect(1, 71935, '\p{Sc=:\AWara\z:}', "");;
    Expect(0, 71936, '\p{Sc=:\AWara\z:}', "");;
    Expect(1, 71935, '\p{Sc: wara}', "");
    Expect(0, 71935, '\p{^Sc: wara}', "");
    Expect(0, 71935, '\P{Sc: wara}', "");
    Expect(1, 71935, '\P{^Sc: wara}', "");
    Expect(0, 71936, '\p{Sc: wara}', "");
    Expect(1, 71936, '\p{^Sc: wara}', "");
    Expect(1, 71936, '\P{Sc: wara}', "");
    Expect(0, 71936, '\P{^Sc: wara}', "");
    Expect(1, 71935, '\p{Sc=:\Awara\z:}', "");;
    Expect(0, 71936, '\p{Sc=:\Awara\z:}', "");;
    Expect(1, 71935, '\p{Sc=-	WARA}', "");
    Expect(0, 71935, '\p{^Sc=-	WARA}', "");
    Expect(0, 71935, '\P{Sc=-	WARA}', "");
    Expect(1, 71935, '\P{^Sc=-	WARA}', "");
    Expect(0, 71936, '\p{Sc=-	WARA}', "");
    Expect(1, 71936, '\p{^Sc=-	WARA}', "");
    Expect(1, 71936, '\P{Sc=-	WARA}', "");
    Expect(0, 71936, '\P{^Sc=-	WARA}', "");
    Error('\p{Is_Script=/a/warang_Citi}');
    Error('\P{Is_Script=/a/warang_Citi}');
    Expect(1, 71935, '\p{Is_Script=warangciti}', "");
    Expect(0, 71935, '\p{^Is_Script=warangciti}', "");
    Expect(0, 71935, '\P{Is_Script=warangciti}', "");
    Expect(1, 71935, '\P{^Is_Script=warangciti}', "");
    Expect(0, 71936, '\p{Is_Script=warangciti}', "");
    Expect(1, 71936, '\p{^Is_Script=warangciti}', "");
    Expect(1, 71936, '\P{Is_Script=warangciti}', "");
    Expect(0, 71936, '\P{^Is_Script=warangciti}', "");
    Expect(1, 71935, '\p{Is_Script=--warang_Citi}', "");
    Expect(0, 71935, '\p{^Is_Script=--warang_Citi}', "");
    Expect(0, 71935, '\P{Is_Script=--warang_Citi}', "");
    Expect(1, 71935, '\P{^Is_Script=--warang_Citi}', "");
    Expect(0, 71936, '\p{Is_Script=--warang_Citi}', "");
    Expect(1, 71936, '\p{^Is_Script=--warang_Citi}', "");
    Expect(1, 71936, '\P{Is_Script=--warang_Citi}', "");
    Expect(0, 71936, '\P{^Is_Script=--warang_Citi}', "");
    Error('\p{Is_Sc=_-Wara:=}');
    Error('\P{Is_Sc=_-Wara:=}');
    Expect(1, 71935, '\p{Is_Sc=wara}', "");
    Expect(0, 71935, '\p{^Is_Sc=wara}', "");
    Expect(0, 71935, '\P{Is_Sc=wara}', "");
    Expect(1, 71935, '\P{^Is_Sc=wara}', "");
    Expect(0, 71936, '\p{Is_Sc=wara}', "");
    Expect(1, 71936, '\p{^Is_Sc=wara}', "");
    Expect(1, 71936, '\P{Is_Sc=wara}', "");
    Expect(0, 71936, '\P{^Is_Sc=wara}', "");
    Expect(1, 71935, '\p{Is_Sc=-	WARA}', "");
    Expect(0, 71935, '\p{^Is_Sc=-	WARA}', "");
    Expect(0, 71935, '\P{Is_Sc=-	WARA}', "");
    Expect(1, 71935, '\P{^Is_Sc=-	WARA}', "");
    Expect(0, 71936, '\p{Is_Sc=-	WARA}', "");
    Expect(1, 71936, '\p{^Is_Sc=-	WARA}', "");
    Expect(1, 71936, '\P{Is_Sc=-	WARA}', "");
    Expect(0, 71936, '\P{^Is_Sc=-	WARA}', "");
    Error('\p{Script=	_WANCHO/a/}');
    Error('\P{Script=	_WANCHO/a/}');
    Expect(1, 123647, '\p{Script=:\AWancho\z:}', "");;
    Expect(0, 123648, '\p{Script=:\AWancho\z:}', "");;
    Expect(1, 123647, '\p{Script=wancho}', "");
    Expect(0, 123647, '\p{^Script=wancho}', "");
    Expect(0, 123647, '\P{Script=wancho}', "");
    Expect(1, 123647, '\P{^Script=wancho}', "");
    Expect(0, 123648, '\p{Script=wancho}', "");
    Expect(1, 123648, '\p{^Script=wancho}', "");
    Expect(1, 123648, '\P{Script=wancho}', "");
    Expect(0, 123648, '\P{^Script=wancho}', "");
    Expect(1, 123647, '\p{Script=:\Awancho\z:}', "");;
    Expect(0, 123648, '\p{Script=:\Awancho\z:}', "");;
    Expect(1, 123647, '\p{Script:	-Wancho}', "");
    Expect(0, 123647, '\p{^Script:	-Wancho}', "");
    Expect(0, 123647, '\P{Script:	-Wancho}', "");
    Expect(1, 123647, '\P{^Script:	-Wancho}', "");
    Expect(0, 123648, '\p{Script:	-Wancho}', "");
    Expect(1, 123648, '\p{^Script:	-Wancho}', "");
    Expect(1, 123648, '\P{Script:	-Wancho}', "");
    Expect(0, 123648, '\P{^Script:	-Wancho}', "");
    Error('\p{Sc=:=	 wcho}');
    Error('\P{Sc=:=	 wcho}');
    Expect(1, 123647, '\p{Sc=:\AWcho\z:}', "");;
    Expect(0, 123648, '\p{Sc=:\AWcho\z:}', "");;
    Expect(1, 123647, '\p{Sc=wcho}', "");
    Expect(0, 123647, '\p{^Sc=wcho}', "");
    Expect(0, 123647, '\P{Sc=wcho}', "");
    Expect(1, 123647, '\P{^Sc=wcho}', "");
    Expect(0, 123648, '\p{Sc=wcho}', "");
    Expect(1, 123648, '\p{^Sc=wcho}', "");
    Expect(1, 123648, '\P{Sc=wcho}', "");
    Expect(0, 123648, '\P{^Sc=wcho}', "");
    Expect(1, 123647, '\p{Sc=:\Awcho\z:}', "");;
    Expect(0, 123648, '\p{Sc=:\Awcho\z:}', "");;
    Expect(1, 123647, '\p{Sc=  Wcho}', "");
    Expect(0, 123647, '\p{^Sc=  Wcho}', "");
    Expect(0, 123647, '\P{Sc=  Wcho}', "");
    Expect(1, 123647, '\P{^Sc=  Wcho}', "");
    Expect(0, 123648, '\p{Sc=  Wcho}', "");
    Expect(1, 123648, '\p{^Sc=  Wcho}', "");
    Expect(1, 123648, '\P{Sc=  Wcho}', "");
    Expect(0, 123648, '\P{^Sc=  Wcho}', "");
    Error('\p{Is_Script=/a/--Wancho}');
    Error('\P{Is_Script=/a/--Wancho}');
    Expect(1, 123647, '\p{Is_Script=wancho}', "");
    Expect(0, 123647, '\p{^Is_Script=wancho}', "");
    Expect(0, 123647, '\P{Is_Script=wancho}', "");
    Expect(1, 123647, '\P{^Is_Script=wancho}', "");
    Expect(0, 123648, '\p{Is_Script=wancho}', "");
    Expect(1, 123648, '\p{^Is_Script=wancho}', "");
    Expect(1, 123648, '\P{Is_Script=wancho}', "");
    Expect(0, 123648, '\P{^Is_Script=wancho}', "");
    Expect(1, 123647, '\p{Is_Script= wancho}', "");
    Expect(0, 123647, '\p{^Is_Script= wancho}', "");
    Expect(0, 123647, '\P{Is_Script= wancho}', "");
    Expect(1, 123647, '\P{^Is_Script= wancho}', "");
    Expect(0, 123648, '\p{Is_Script= wancho}', "");
    Expect(1, 123648, '\p{^Is_Script= wancho}', "");
    Expect(1, 123648, '\P{Is_Script= wancho}', "");
    Expect(0, 123648, '\P{^Is_Script= wancho}', "");
    Error('\p{Is_Sc= :=wcho}');
    Error('\P{Is_Sc= :=wcho}');
    Expect(1, 123647, '\p{Is_Sc=wcho}', "");
    Expect(0, 123647, '\p{^Is_Sc=wcho}', "");
    Expect(0, 123647, '\P{Is_Sc=wcho}', "");
    Expect(1, 123647, '\P{^Is_Sc=wcho}', "");
    Expect(0, 123648, '\p{Is_Sc=wcho}', "");
    Expect(1, 123648, '\p{^Is_Sc=wcho}', "");
    Expect(1, 123648, '\P{Is_Sc=wcho}', "");
    Expect(0, 123648, '\P{^Is_Sc=wcho}', "");
    Expect(1, 123647, '\p{Is_Sc=_wcho}', "");
    Expect(0, 123647, '\p{^Is_Sc=_wcho}', "");
    Expect(0, 123647, '\P{Is_Sc=_wcho}', "");
    Expect(1, 123647, '\P{^Is_Sc=_wcho}', "");
    Expect(0, 123648, '\p{Is_Sc=_wcho}', "");
    Expect(1, 123648, '\p{^Is_Sc=_wcho}', "");
    Expect(1, 123648, '\P{Is_Sc=_wcho}', "");
    Expect(0, 123648, '\P{^Is_Sc=_wcho}', "");
    Error('\p{Script=	/a/Old_persian}');
    Error('\P{Script=	/a/Old_persian}');
    Expect(1, 66517, '\p{Script=:\AOld_Persian\z:}', "");;
    Expect(0, 66518, '\p{Script=:\AOld_Persian\z:}', "");;
    Expect(1, 66517, '\p{Script:	oldpersian}', "");
    Expect(0, 66517, '\p{^Script:	oldpersian}', "");
    Expect(0, 66517, '\P{Script:	oldpersian}', "");
    Expect(1, 66517, '\P{^Script:	oldpersian}', "");
    Expect(0, 66518, '\p{Script:	oldpersian}', "");
    Expect(1, 66518, '\p{^Script:	oldpersian}', "");
    Expect(1, 66518, '\P{Script:	oldpersian}', "");
    Expect(0, 66518, '\P{^Script:	oldpersian}', "");
    Expect(1, 66517, '\p{Script=:\Aoldpersian\z:}', "");;
    Expect(0, 66518, '\p{Script=:\Aoldpersian\z:}', "");;
    Expect(1, 66517, '\p{Script=_OLD_persian}', "");
    Expect(0, 66517, '\p{^Script=_OLD_persian}', "");
    Expect(0, 66517, '\P{Script=_OLD_persian}', "");
    Expect(1, 66517, '\P{^Script=_OLD_persian}', "");
    Expect(0, 66518, '\p{Script=_OLD_persian}', "");
    Expect(1, 66518, '\p{^Script=_OLD_persian}', "");
    Expect(1, 66518, '\P{Script=_OLD_persian}', "");
    Expect(0, 66518, '\P{^Script=_OLD_persian}', "");
    Error('\p{Sc=_/a/Xpeo}');
    Error('\P{Sc=_/a/Xpeo}');
    Expect(1, 66517, '\p{Sc=:\AXpeo\z:}', "");;
    Expect(0, 66518, '\p{Sc=:\AXpeo\z:}', "");;
    Expect(1, 66517, '\p{Sc:   xpeo}', "");
    Expect(0, 66517, '\p{^Sc:   xpeo}', "");
    Expect(0, 66517, '\P{Sc:   xpeo}', "");
    Expect(1, 66517, '\P{^Sc:   xpeo}', "");
    Expect(0, 66518, '\p{Sc:   xpeo}', "");
    Expect(1, 66518, '\p{^Sc:   xpeo}', "");
    Expect(1, 66518, '\P{Sc:   xpeo}', "");
    Expect(0, 66518, '\P{^Sc:   xpeo}', "");
    Expect(1, 66517, '\p{Sc=:\Axpeo\z:}', "");;
    Expect(0, 66518, '\p{Sc=:\Axpeo\z:}', "");;
    Expect(1, 66517, '\p{Sc= xpeo}', "");
    Expect(0, 66517, '\p{^Sc= xpeo}', "");
    Expect(0, 66517, '\P{Sc= xpeo}', "");
    Expect(1, 66517, '\P{^Sc= xpeo}', "");
    Expect(0, 66518, '\p{Sc= xpeo}', "");
    Expect(1, 66518, '\p{^Sc= xpeo}', "");
    Expect(1, 66518, '\P{Sc= xpeo}', "");
    Expect(0, 66518, '\P{^Sc= xpeo}', "");
    Error('\p{Is_Script=	:=OLD_Persian}');
    Error('\P{Is_Script=	:=OLD_Persian}');
    Expect(1, 66517, '\p{Is_Script=oldpersian}', "");
    Expect(0, 66517, '\p{^Is_Script=oldpersian}', "");
    Expect(0, 66517, '\P{Is_Script=oldpersian}', "");
    Expect(1, 66517, '\P{^Is_Script=oldpersian}', "");
    Expect(0, 66518, '\p{Is_Script=oldpersian}', "");
    Expect(1, 66518, '\p{^Is_Script=oldpersian}', "");
    Expect(1, 66518, '\P{Is_Script=oldpersian}', "");
    Expect(0, 66518, '\P{^Is_Script=oldpersian}', "");
    Expect(1, 66517, '\p{Is_Script=_-old_Persian}', "");
    Expect(0, 66517, '\p{^Is_Script=_-old_Persian}', "");
    Expect(0, 66517, '\P{Is_Script=_-old_Persian}', "");
    Expect(1, 66517, '\P{^Is_Script=_-old_Persian}', "");
    Expect(0, 66518, '\p{Is_Script=_-old_Persian}', "");
    Expect(1, 66518, '\p{^Is_Script=_-old_Persian}', "");
    Expect(1, 66518, '\P{Is_Script=_-old_Persian}', "");
    Expect(0, 66518, '\P{^Is_Script=_-old_Persian}', "");
    Error('\p{Is_Sc=	/a/Xpeo}');
    Error('\P{Is_Sc=	/a/Xpeo}');
    Expect(1, 66517, '\p{Is_Sc=xpeo}', "");
    Expect(0, 66517, '\p{^Is_Sc=xpeo}', "");
    Expect(0, 66517, '\P{Is_Sc=xpeo}', "");
    Expect(1, 66517, '\P{^Is_Sc=xpeo}', "");
    Expect(0, 66518, '\p{Is_Sc=xpeo}', "");
    Expect(1, 66518, '\p{^Is_Sc=xpeo}', "");
    Expect(1, 66518, '\P{Is_Sc=xpeo}', "");
    Expect(0, 66518, '\P{^Is_Sc=xpeo}', "");
    Expect(1, 66517, '\p{Is_Sc=--Xpeo}', "");
    Expect(0, 66517, '\p{^Is_Sc=--Xpeo}', "");
    Expect(0, 66517, '\P{Is_Sc=--Xpeo}', "");
    Expect(1, 66517, '\P{^Is_Sc=--Xpeo}', "");
    Expect(0, 66518, '\p{Is_Sc=--Xpeo}', "");
    Expect(1, 66518, '\p{^Is_Sc=--Xpeo}', "");
    Expect(1, 66518, '\P{Is_Sc=--Xpeo}', "");
    Expect(0, 66518, '\P{^Is_Sc=--Xpeo}', "");
    Error('\p{Script=-CUNEIFORM/a/}');
    Error('\P{Script=-CUNEIFORM/a/}');
    Expect(1, 75075, '\p{Script=:\ACuneiform\z:}', "");;
    Expect(0, 75076, '\p{Script=:\ACuneiform\z:}', "");;
    Expect(1, 75075, '\p{Script=cuneiform}', "");
    Expect(0, 75075, '\p{^Script=cuneiform}', "");
    Expect(0, 75075, '\P{Script=cuneiform}', "");
    Expect(1, 75075, '\P{^Script=cuneiform}', "");
    Expect(0, 75076, '\p{Script=cuneiform}', "");
    Expect(1, 75076, '\p{^Script=cuneiform}', "");
    Expect(1, 75076, '\P{Script=cuneiform}', "");
    Expect(0, 75076, '\P{^Script=cuneiform}', "");
    Expect(1, 75075, '\p{Script=:\Acuneiform\z:}', "");;
    Expect(0, 75076, '\p{Script=:\Acuneiform\z:}', "");;
    Expect(1, 75075, '\p{Script=	_cuneiform}', "");
    Expect(0, 75075, '\p{^Script=	_cuneiform}', "");
    Expect(0, 75075, '\P{Script=	_cuneiform}', "");
    Expect(1, 75075, '\P{^Script=	_cuneiform}', "");
    Expect(0, 75076, '\p{Script=	_cuneiform}', "");
    Expect(1, 75076, '\p{^Script=	_cuneiform}', "");
    Expect(1, 75076, '\P{Script=	_cuneiform}', "");
    Expect(0, 75076, '\P{^Script=	_cuneiform}', "");
    Error('\p{Sc=/a/		Xsux}');
    Error('\P{Sc=/a/		Xsux}');
    Expect(1, 75075, '\p{Sc=:\AXsux\z:}', "");;
    Expect(0, 75076, '\p{Sc=:\AXsux\z:}', "");;
    Expect(1, 75075, '\p{Sc=xsux}', "");
    Expect(0, 75075, '\p{^Sc=xsux}', "");
    Expect(0, 75075, '\P{Sc=xsux}', "");
    Expect(1, 75075, '\P{^Sc=xsux}', "");
    Expect(0, 75076, '\p{Sc=xsux}', "");
    Expect(1, 75076, '\p{^Sc=xsux}', "");
    Expect(1, 75076, '\P{Sc=xsux}', "");
    Expect(0, 75076, '\P{^Sc=xsux}', "");
    Expect(1, 75075, '\p{Sc=:\Axsux\z:}', "");;
    Expect(0, 75076, '\p{Sc=:\Axsux\z:}', "");;
    Expect(1, 75075, '\p{Sc=  Xsux}', "");
    Expect(0, 75075, '\p{^Sc=  Xsux}', "");
    Expect(0, 75075, '\P{Sc=  Xsux}', "");
    Expect(1, 75075, '\P{^Sc=  Xsux}', "");
    Expect(0, 75076, '\p{Sc=  Xsux}', "");
    Expect(1, 75076, '\p{^Sc=  Xsux}', "");
    Expect(1, 75076, '\P{Sc=  Xsux}', "");
    Expect(0, 75076, '\P{^Sc=  Xsux}', "");
    Error('\p{Is_Script=:=_-Cuneiform}');
    Error('\P{Is_Script=:=_-Cuneiform}');
    Expect(1, 75075, '\p{Is_Script=cuneiform}', "");
    Expect(0, 75075, '\p{^Is_Script=cuneiform}', "");
    Expect(0, 75075, '\P{Is_Script=cuneiform}', "");
    Expect(1, 75075, '\P{^Is_Script=cuneiform}', "");
    Expect(0, 75076, '\p{Is_Script=cuneiform}', "");
    Expect(1, 75076, '\p{^Is_Script=cuneiform}', "");
    Expect(1, 75076, '\P{Is_Script=cuneiform}', "");
    Expect(0, 75076, '\P{^Is_Script=cuneiform}', "");
    Expect(1, 75075, '\p{Is_Script: -	Cuneiform}', "");
    Expect(0, 75075, '\p{^Is_Script: -	Cuneiform}', "");
    Expect(0, 75075, '\P{Is_Script: -	Cuneiform}', "");
    Expect(1, 75075, '\P{^Is_Script: -	Cuneiform}', "");
    Expect(0, 75076, '\p{Is_Script: -	Cuneiform}', "");
    Expect(1, 75076, '\p{^Is_Script: -	Cuneiform}', "");
    Expect(1, 75076, '\P{Is_Script: -	Cuneiform}', "");
    Expect(0, 75076, '\P{^Is_Script: -	Cuneiform}', "");
    Error('\p{Is_Sc=	:=Xsux}');
    Error('\P{Is_Sc=	:=Xsux}');
    Expect(1, 75075, '\p{Is_Sc=xsux}', "");
    Expect(0, 75075, '\p{^Is_Sc=xsux}', "");
    Expect(0, 75075, '\P{Is_Sc=xsux}', "");
    Expect(1, 75075, '\P{^Is_Sc=xsux}', "");
    Expect(0, 75076, '\p{Is_Sc=xsux}', "");
    Expect(1, 75076, '\p{^Is_Sc=xsux}', "");
    Expect(1, 75076, '\P{Is_Sc=xsux}', "");
    Expect(0, 75076, '\P{^Is_Sc=xsux}', "");
    Expect(1, 75075, '\p{Is_Sc= _Xsux}', "");
    Expect(0, 75075, '\p{^Is_Sc= _Xsux}', "");
    Expect(0, 75075, '\P{Is_Sc= _Xsux}', "");
    Expect(1, 75075, '\P{^Is_Sc= _Xsux}', "");
    Expect(0, 75076, '\p{Is_Sc= _Xsux}', "");
    Expect(1, 75076, '\p{^Is_Sc= _Xsux}', "");
    Expect(1, 75076, '\P{Is_Sc= _Xsux}', "");
    Expect(0, 75076, '\P{^Is_Sc= _Xsux}', "");
    Error('\p{Script=/a/-	Yezidi}');
    Error('\P{Script=/a/-	Yezidi}');
    Expect(1, 69297, '\p{Script=:\AYezidi\z:}', "");;
    Expect(0, 69298, '\p{Script=:\AYezidi\z:}', "");;
    Expect(1, 69297, '\p{Script=yezidi}', "");
    Expect(0, 69297, '\p{^Script=yezidi}', "");
    Expect(0, 69297, '\P{Script=yezidi}', "");
    Expect(1, 69297, '\P{^Script=yezidi}', "");
    Expect(0, 69298, '\p{Script=yezidi}', "");
    Expect(1, 69298, '\p{^Script=yezidi}', "");
    Expect(1, 69298, '\P{Script=yezidi}', "");
    Expect(0, 69298, '\P{^Script=yezidi}', "");
    Expect(1, 69297, '\p{Script=:\Ayezidi\z:}', "");;
    Expect(0, 69298, '\p{Script=:\Ayezidi\z:}', "");;
    Expect(1, 69297, '\p{Script= _yezidi}', "");
    Expect(0, 69297, '\p{^Script= _yezidi}', "");
    Expect(0, 69297, '\P{Script= _yezidi}', "");
    Expect(1, 69297, '\P{^Script= _yezidi}', "");
    Expect(0, 69298, '\p{Script= _yezidi}', "");
    Expect(1, 69298, '\p{^Script= _yezidi}', "");
    Expect(1, 69298, '\P{Script= _yezidi}', "");
    Expect(0, 69298, '\P{^Script= _yezidi}', "");
    Error('\p{Sc=:=yezi}');
    Error('\P{Sc=:=yezi}');
    Expect(1, 69297, '\p{Sc=:\AYezi\z:}', "");;
    Expect(0, 69298, '\p{Sc=:\AYezi\z:}', "");;
    Expect(1, 69297, '\p{Sc=yezi}', "");
    Expect(0, 69297, '\p{^Sc=yezi}', "");
    Expect(0, 69297, '\P{Sc=yezi}', "");
    Expect(1, 69297, '\P{^Sc=yezi}', "");
    Expect(0, 69298, '\p{Sc=yezi}', "");
    Expect(1, 69298, '\p{^Sc=yezi}', "");
    Expect(1, 69298, '\P{Sc=yezi}', "");
    Expect(0, 69298, '\P{^Sc=yezi}', "");
    Expect(1, 69297, '\p{Sc=:\Ayezi\z:}', "");;
    Expect(0, 69298, '\p{Sc=:\Ayezi\z:}', "");;
    Expect(1, 69297, '\p{Sc=	_yezi}', "");
    Expect(0, 69297, '\p{^Sc=	_yezi}', "");
    Expect(0, 69297, '\P{Sc=	_yezi}', "");
    Expect(1, 69297, '\P{^Sc=	_yezi}', "");
    Expect(0, 69298, '\p{Sc=	_yezi}', "");
    Expect(1, 69298, '\p{^Sc=	_yezi}', "");
    Expect(1, 69298, '\P{Sc=	_yezi}', "");
    Expect(0, 69298, '\P{^Sc=	_yezi}', "");
    Error('\p{Is_Script=	:=Yezidi}');
    Error('\P{Is_Script=	:=Yezidi}');
    Expect(1, 69297, '\p{Is_Script=yezidi}', "");
    Expect(0, 69297, '\p{^Is_Script=yezidi}', "");
    Expect(0, 69297, '\P{Is_Script=yezidi}', "");
    Expect(1, 69297, '\P{^Is_Script=yezidi}', "");
    Expect(0, 69298, '\p{Is_Script=yezidi}', "");
    Expect(1, 69298, '\p{^Is_Script=yezidi}', "");
    Expect(1, 69298, '\P{Is_Script=yezidi}', "");
    Expect(0, 69298, '\P{^Is_Script=yezidi}', "");
    Expect(1, 69297, '\p{Is_Script= _yezidi}', "");
    Expect(0, 69297, '\p{^Is_Script= _yezidi}', "");
    Expect(0, 69297, '\P{Is_Script= _yezidi}', "");
    Expect(1, 69297, '\P{^Is_Script= _yezidi}', "");
    Expect(0, 69298, '\p{Is_Script= _yezidi}', "");
    Expect(1, 69298, '\p{^Is_Script= _yezidi}', "");
    Expect(1, 69298, '\P{Is_Script= _yezidi}', "");
    Expect(0, 69298, '\P{^Is_Script= _yezidi}', "");
    Error('\p{Is_Sc=_YEZI:=}');
    Error('\P{Is_Sc=_YEZI:=}');
    Expect(1, 69297, '\p{Is_Sc:yezi}', "");
    Expect(0, 69297, '\p{^Is_Sc:yezi}', "");
    Expect(0, 69297, '\P{Is_Sc:yezi}', "");
    Expect(1, 69297, '\P{^Is_Sc:yezi}', "");
    Expect(0, 69298, '\p{Is_Sc:yezi}', "");
    Expect(1, 69298, '\p{^Is_Sc:yezi}', "");
    Expect(1, 69298, '\P{Is_Sc:yezi}', "");
    Expect(0, 69298, '\P{^Is_Sc:yezi}', "");
    Expect(1, 69297, '\p{Is_Sc=-YEZI}', "");
    Expect(0, 69297, '\p{^Is_Sc=-YEZI}', "");
    Expect(0, 69297, '\P{Is_Sc=-YEZI}', "");
    Expect(1, 69297, '\P{^Is_Sc=-YEZI}', "");
    Expect(0, 69298, '\p{Is_Sc=-YEZI}', "");
    Expect(1, 69298, '\p{^Is_Sc=-YEZI}', "");
    Expect(1, 69298, '\P{Is_Sc=-YEZI}', "");
    Expect(0, 69298, '\P{^Is_Sc=-YEZI}', "");
    Error('\p{Script=		yi/a/}');
    Error('\P{Script=		yi/a/}');
    Expect(1, 42182, '\p{Script=:\AYi\z:}', "");;
    Expect(0, 42183, '\p{Script=:\AYi\z:}', "");;
    Expect(1, 42182, '\p{Script=yi}', "");
    Expect(0, 42182, '\p{^Script=yi}', "");
    Expect(0, 42182, '\P{Script=yi}', "");
    Expect(1, 42182, '\P{^Script=yi}', "");
    Expect(0, 42183, '\p{Script=yi}', "");
    Expect(1, 42183, '\p{^Script=yi}', "");
    Expect(1, 42183, '\P{Script=yi}', "");
    Expect(0, 42183, '\P{^Script=yi}', "");
    Expect(1, 42182, '\p{Script=:\Ayi\z:}', "");;
    Expect(0, 42183, '\p{Script=:\Ayi\z:}', "");;
    Expect(1, 42182, '\p{Script=-Yi}', "");
    Expect(0, 42182, '\p{^Script=-Yi}', "");
    Expect(0, 42182, '\P{Script=-Yi}', "");
    Expect(1, 42182, '\P{^Script=-Yi}', "");
    Expect(0, 42183, '\p{Script=-Yi}', "");
    Expect(1, 42183, '\p{^Script=-Yi}', "");
    Expect(1, 42183, '\P{Script=-Yi}', "");
    Expect(0, 42183, '\P{^Script=-Yi}', "");
    Error('\p{Sc=	-yiii/a/}');
    Error('\P{Sc=	-yiii/a/}');
    Expect(1, 42182, '\p{Sc=:\AYiii\z:}', "");;
    Expect(0, 42183, '\p{Sc=:\AYiii\z:}', "");;
    Expect(1, 42182, '\p{Sc=yiii}', "");
    Expect(0, 42182, '\p{^Sc=yiii}', "");
    Expect(0, 42182, '\P{Sc=yiii}', "");
    Expect(1, 42182, '\P{^Sc=yiii}', "");
    Expect(0, 42183, '\p{Sc=yiii}', "");
    Expect(1, 42183, '\p{^Sc=yiii}', "");
    Expect(1, 42183, '\P{Sc=yiii}', "");
    Expect(0, 42183, '\P{^Sc=yiii}', "");
    Expect(1, 42182, '\p{Sc=:\Ayiii\z:}', "");;
    Expect(0, 42183, '\p{Sc=:\Ayiii\z:}', "");;
    Expect(1, 42182, '\p{Sc=--yiii}', "");
    Expect(0, 42182, '\p{^Sc=--yiii}', "");
    Expect(0, 42182, '\P{Sc=--yiii}', "");
    Expect(1, 42182, '\P{^Sc=--yiii}', "");
    Expect(0, 42183, '\p{Sc=--yiii}', "");
    Expect(1, 42183, '\p{^Sc=--yiii}', "");
    Expect(1, 42183, '\P{Sc=--yiii}', "");
    Expect(0, 42183, '\P{^Sc=--yiii}', "");
    Error('\p{Is_Script=:=Yi}');
    Error('\P{Is_Script=:=Yi}');
    Expect(1, 42182, '\p{Is_Script=yi}', "");
    Expect(0, 42182, '\p{^Is_Script=yi}', "");
    Expect(0, 42182, '\P{Is_Script=yi}', "");
    Expect(1, 42182, '\P{^Is_Script=yi}', "");
    Expect(0, 42183, '\p{Is_Script=yi}', "");
    Expect(1, 42183, '\p{^Is_Script=yi}', "");
    Expect(1, 42183, '\P{Is_Script=yi}', "");
    Expect(0, 42183, '\P{^Is_Script=yi}', "");
    Expect(1, 42182, '\p{Is_Script=-_Yi}', "");
    Expect(0, 42182, '\p{^Is_Script=-_Yi}', "");
    Expect(0, 42182, '\P{Is_Script=-_Yi}', "");
    Expect(1, 42182, '\P{^Is_Script=-_Yi}', "");
    Expect(0, 42183, '\p{Is_Script=-_Yi}', "");
    Expect(1, 42183, '\p{^Is_Script=-_Yi}', "");
    Expect(1, 42183, '\P{Is_Script=-_Yi}', "");
    Expect(0, 42183, '\P{^Is_Script=-_Yi}', "");
    Error('\p{Is_Sc=_:=YIII}');
    Error('\P{Is_Sc=_:=YIII}');
    Expect(1, 42182, '\p{Is_Sc=yiii}', "");
    Expect(0, 42182, '\p{^Is_Sc=yiii}', "");
    Expect(0, 42182, '\P{Is_Sc=yiii}', "");
    Expect(1, 42182, '\P{^Is_Sc=yiii}', "");
    Expect(0, 42183, '\p{Is_Sc=yiii}', "");
    Expect(1, 42183, '\p{^Is_Sc=yiii}', "");
    Expect(1, 42183, '\P{Is_Sc=yiii}', "");
    Expect(0, 42183, '\P{^Is_Sc=yiii}', "");
    Expect(1, 42182, '\p{Is_Sc=__YIII}', "");
    Expect(0, 42182, '\p{^Is_Sc=__YIII}', "");
    Expect(0, 42182, '\P{Is_Sc=__YIII}', "");
    Expect(1, 42182, '\P{^Is_Sc=__YIII}', "");
    Expect(0, 42183, '\p{Is_Sc=__YIII}', "");
    Expect(1, 42183, '\p{^Is_Sc=__YIII}', "");
    Expect(1, 42183, '\P{Is_Sc=__YIII}', "");
    Expect(0, 42183, '\P{^Is_Sc=__YIII}', "");
    Error('\p{Script=	 zanabazar_Square/a/}');
    Error('\P{Script=	 zanabazar_Square/a/}');
    Expect(1, 72263, '\p{Script=:\AZanabazar_Square\z:}', "");;
    Expect(0, 72264, '\p{Script=:\AZanabazar_Square\z:}', "");;
    Expect(1, 72263, '\p{Script=zanabazarsquare}', "");
    Expect(0, 72263, '\p{^Script=zanabazarsquare}', "");
    Expect(0, 72263, '\P{Script=zanabazarsquare}', "");
    Expect(1, 72263, '\P{^Script=zanabazarsquare}', "");
    Expect(0, 72264, '\p{Script=zanabazarsquare}', "");
    Expect(1, 72264, '\p{^Script=zanabazarsquare}', "");
    Expect(1, 72264, '\P{Script=zanabazarsquare}', "");
    Expect(0, 72264, '\P{^Script=zanabazarsquare}', "");
    Expect(1, 72263, '\p{Script=:\Azanabazarsquare\z:}', "");;
    Expect(0, 72264, '\p{Script=:\Azanabazarsquare\z:}', "");;
    Expect(1, 72263, '\p{Script=_ZANABAZAR_square}', "");
    Expect(0, 72263, '\p{^Script=_ZANABAZAR_square}', "");
    Expect(0, 72263, '\P{Script=_ZANABAZAR_square}', "");
    Expect(1, 72263, '\P{^Script=_ZANABAZAR_square}', "");
    Expect(0, 72264, '\p{Script=_ZANABAZAR_square}', "");
    Expect(1, 72264, '\p{^Script=_ZANABAZAR_square}', "");
    Expect(1, 72264, '\P{Script=_ZANABAZAR_square}', "");
    Expect(0, 72264, '\P{^Script=_ZANABAZAR_square}', "");
    Error('\p{Sc=/a/zanb}');
    Error('\P{Sc=/a/zanb}');
    Expect(1, 72263, '\p{Sc=:\AZanb\z:}', "");;
    Expect(0, 72264, '\p{Sc=:\AZanb\z:}', "");;
    Expect(1, 72263, '\p{Sc=zanb}', "");
    Expect(0, 72263, '\p{^Sc=zanb}', "");
    Expect(0, 72263, '\P{Sc=zanb}', "");
    Expect(1, 72263, '\P{^Sc=zanb}', "");
    Expect(0, 72264, '\p{Sc=zanb}', "");
    Expect(1, 72264, '\p{^Sc=zanb}', "");
    Expect(1, 72264, '\P{Sc=zanb}', "");
    Expect(0, 72264, '\P{^Sc=zanb}', "");
    Expect(1, 72263, '\p{Sc=:\Azanb\z:}', "");;
    Expect(0, 72264, '\p{Sc=:\Azanb\z:}', "");;
    Expect(1, 72263, '\p{Sc=__Zanb}', "");
    Expect(0, 72263, '\p{^Sc=__Zanb}', "");
    Expect(0, 72263, '\P{Sc=__Zanb}', "");
    Expect(1, 72263, '\P{^Sc=__Zanb}', "");
    Expect(0, 72264, '\p{Sc=__Zanb}', "");
    Expect(1, 72264, '\p{^Sc=__Zanb}', "");
    Expect(1, 72264, '\P{Sc=__Zanb}', "");
    Expect(0, 72264, '\P{^Sc=__Zanb}', "");
    Error('\p{Is_Script=_Zanabazar_SQUARE:=}');
    Error('\P{Is_Script=_Zanabazar_SQUARE:=}');
    Expect(1, 72263, '\p{Is_Script=zanabazarsquare}', "");
    Expect(0, 72263, '\p{^Is_Script=zanabazarsquare}', "");
    Expect(0, 72263, '\P{Is_Script=zanabazarsquare}', "");
    Expect(1, 72263, '\P{^Is_Script=zanabazarsquare}', "");
    Expect(0, 72264, '\p{Is_Script=zanabazarsquare}', "");
    Expect(1, 72264, '\p{^Is_Script=zanabazarsquare}', "");
    Expect(1, 72264, '\P{Is_Script=zanabazarsquare}', "");
    Expect(0, 72264, '\P{^Is_Script=zanabazarsquare}', "");
    Expect(1, 72263, '\p{Is_Script=_ZANABAZAR_Square}', "");
    Expect(0, 72263, '\p{^Is_Script=_ZANABAZAR_Square}', "");
    Expect(0, 72263, '\P{Is_Script=_ZANABAZAR_Square}', "");
    Expect(1, 72263, '\P{^Is_Script=_ZANABAZAR_Square}', "");
    Expect(0, 72264, '\p{Is_Script=_ZANABAZAR_Square}', "");
    Expect(1, 72264, '\p{^Is_Script=_ZANABAZAR_Square}', "");
    Expect(1, 72264, '\P{Is_Script=_ZANABAZAR_Square}', "");
    Expect(0, 72264, '\P{^Is_Script=_ZANABAZAR_Square}', "");
    Error('\p{Is_Sc=:=_	Zanb}');
    Error('\P{Is_Sc=:=_	Zanb}');
    Expect(1, 72263, '\p{Is_Sc:   zanb}', "");
    Expect(0, 72263, '\p{^Is_Sc:   zanb}', "");
    Expect(0, 72263, '\P{Is_Sc:   zanb}', "");
    Expect(1, 72263, '\P{^Is_Sc:   zanb}', "");
    Expect(0, 72264, '\p{Is_Sc:   zanb}', "");
    Expect(1, 72264, '\p{^Is_Sc:   zanb}', "");
    Expect(1, 72264, '\P{Is_Sc:   zanb}', "");
    Expect(0, 72264, '\P{^Is_Sc:   zanb}', "");
    Expect(1, 72263, '\p{Is_Sc:-	Zanb}', "");
    Expect(0, 72263, '\p{^Is_Sc:-	Zanb}', "");
    Expect(0, 72263, '\P{Is_Sc:-	Zanb}', "");
    Expect(1, 72263, '\P{^Is_Sc:-	Zanb}', "");
    Expect(0, 72264, '\p{Is_Sc:-	Zanb}', "");
    Expect(1, 72264, '\p{^Is_Sc:-	Zanb}', "");
    Expect(1, 72264, '\P{Is_Sc:-	Zanb}', "");
    Expect(0, 72264, '\P{^Is_Sc:-	Zanb}', "");
    Error('\p{Script=/a/_	Inherited}');
    Error('\P{Script=/a/_	Inherited}');
    Expect(1, 917999, '\p{Script=:\AInherited\z:}', "");;
    Expect(0, 918000, '\p{Script=:\AInherited\z:}', "");;
    Expect(1, 917999, '\p{Script=inherited}', "");
    Expect(0, 917999, '\p{^Script=inherited}', "");
    Expect(0, 917999, '\P{Script=inherited}', "");
    Expect(1, 917999, '\P{^Script=inherited}', "");
    Expect(0, 918000, '\p{Script=inherited}', "");
    Expect(1, 918000, '\p{^Script=inherited}', "");
    Expect(1, 918000, '\P{Script=inherited}', "");
    Expect(0, 918000, '\P{^Script=inherited}', "");
    Expect(1, 917999, '\p{Script=:\Ainherited\z:}', "");;
    Expect(0, 918000, '\p{Script=:\Ainherited\z:}', "");;
    Expect(1, 917999, '\p{Script= inherited}', "");
    Expect(0, 917999, '\p{^Script= inherited}', "");
    Expect(0, 917999, '\P{Script= inherited}', "");
    Expect(1, 917999, '\P{^Script= inherited}', "");
    Expect(0, 918000, '\p{Script= inherited}', "");
    Expect(1, 918000, '\p{^Script= inherited}', "");
    Expect(1, 918000, '\P{Script= inherited}', "");
    Expect(0, 918000, '\P{^Script= inherited}', "");
    Error('\p{Sc=/a/zinh}');
    Error('\P{Sc=/a/zinh}');
    Expect(1, 917999, '\p{Sc=:\AZinh\z:}', "");;
    Expect(0, 918000, '\p{Sc=:\AZinh\z:}', "");;
    Expect(1, 917999, '\p{Sc=zinh}', "");
    Expect(0, 917999, '\p{^Sc=zinh}', "");
    Expect(0, 917999, '\P{Sc=zinh}', "");
    Expect(1, 917999, '\P{^Sc=zinh}', "");
    Expect(0, 918000, '\p{Sc=zinh}', "");
    Expect(1, 918000, '\p{^Sc=zinh}', "");
    Expect(1, 918000, '\P{Sc=zinh}', "");
    Expect(0, 918000, '\P{^Sc=zinh}', "");
    Expect(1, 917999, '\p{Sc=:\Azinh\z:}', "");;
    Expect(0, 918000, '\p{Sc=:\Azinh\z:}', "");;
    Expect(1, 917999, '\p{Sc=-zinh}', "");
    Expect(0, 917999, '\p{^Sc=-zinh}', "");
    Expect(0, 917999, '\P{Sc=-zinh}', "");
    Expect(1, 917999, '\P{^Sc=-zinh}', "");
    Expect(0, 918000, '\p{Sc=-zinh}', "");
    Expect(1, 918000, '\p{^Sc=-zinh}', "");
    Expect(1, 918000, '\P{Sc=-zinh}', "");
    Expect(0, 918000, '\P{^Sc=-zinh}', "");
    Error('\p{Is_Script=_Qaai/a/}');
    Error('\P{Is_Script=_Qaai/a/}');
    Expect(1, 917999, '\p{Is_Script=qaai}', "");
    Expect(0, 917999, '\p{^Is_Script=qaai}', "");
    Expect(0, 917999, '\P{Is_Script=qaai}', "");
    Expect(1, 917999, '\P{^Is_Script=qaai}', "");
    Expect(0, 918000, '\p{Is_Script=qaai}', "");
    Expect(1, 918000, '\p{^Is_Script=qaai}', "");
    Expect(1, 918000, '\P{Is_Script=qaai}', "");
    Expect(0, 918000, '\P{^Is_Script=qaai}', "");
    Expect(1, 917999, '\p{Is_Script= -qaai}', "");
    Expect(0, 917999, '\p{^Is_Script= -qaai}', "");
    Expect(0, 917999, '\P{Is_Script= -qaai}', "");
    Expect(1, 917999, '\P{^Is_Script= -qaai}', "");
    Expect(0, 918000, '\p{Is_Script= -qaai}', "");
    Expect(1, 918000, '\p{^Is_Script= -qaai}', "");
    Expect(1, 918000, '\P{Is_Script= -qaai}', "");
    Expect(0, 918000, '\P{^Is_Script= -qaai}', "");
    Error('\p{Is_Sc=	/a/Inherited}');
    Error('\P{Is_Sc=	/a/Inherited}');
    Expect(1, 917999, '\p{Is_Sc=inherited}', "");
    Expect(0, 917999, '\p{^Is_Sc=inherited}', "");
    Expect(0, 917999, '\P{Is_Sc=inherited}', "");
    Expect(1, 917999, '\P{^Is_Sc=inherited}', "");
    Expect(0, 918000, '\p{Is_Sc=inherited}', "");
    Expect(1, 918000, '\p{^Is_Sc=inherited}', "");
    Expect(1, 918000, '\P{Is_Sc=inherited}', "");
    Expect(0, 918000, '\P{^Is_Sc=inherited}', "");
    Expect(1, 917999, '\p{Is_Sc=_Inherited}', "");
    Expect(0, 917999, '\p{^Is_Sc=_Inherited}', "");
    Expect(0, 917999, '\P{Is_Sc=_Inherited}', "");
    Expect(1, 917999, '\P{^Is_Sc=_Inherited}', "");
    Expect(0, 918000, '\p{Is_Sc=_Inherited}', "");
    Expect(1, 918000, '\p{^Is_Sc=_Inherited}', "");
    Expect(1, 918000, '\P{Is_Sc=_Inherited}', "");
    Expect(0, 918000, '\P{^Is_Sc=_Inherited}', "");
    Error('\p{Script: /a/_ Common}');
    Error('\P{Script: /a/_ Common}');
    Expect(1, 917631, '\p{Script=:\ACommon\z:}', "");;
    Expect(0, 917632, '\p{Script=:\ACommon\z:}', "");;
    Expect(1, 917631, '\p{Script=common}', "");
    Expect(0, 917631, '\p{^Script=common}', "");
    Expect(0, 917631, '\P{Script=common}', "");
    Expect(1, 917631, '\P{^Script=common}', "");
    Expect(0, 917632, '\p{Script=common}', "");
    Expect(1, 917632, '\p{^Script=common}', "");
    Expect(1, 917632, '\P{Script=common}', "");
    Expect(0, 917632, '\P{^Script=common}', "");
    Expect(1, 917631, '\p{Script=:\Acommon\z:}', "");;
    Expect(0, 917632, '\p{Script=:\Acommon\z:}', "");;
    Expect(1, 917631, '\p{Script= common}', "");
    Expect(0, 917631, '\p{^Script= common}', "");
    Expect(0, 917631, '\P{Script= common}', "");
    Expect(1, 917631, '\P{^Script= common}', "");
    Expect(0, 917632, '\p{Script= common}', "");
    Expect(1, 917632, '\p{^Script= common}', "");
    Expect(1, 917632, '\P{Script= common}', "");
    Expect(0, 917632, '\P{^Script= common}', "");
    Error('\p{Sc=/a/Zyyy}');
    Error('\P{Sc=/a/Zyyy}');
    Expect(1, 917631, '\p{Sc=:\AZyyy\z:}', "");;
    Expect(0, 917632, '\p{Sc=:\AZyyy\z:}', "");;
    Expect(1, 917631, '\p{Sc=zyyy}', "");
    Expect(0, 917631, '\p{^Sc=zyyy}', "");
    Expect(0, 917631, '\P{Sc=zyyy}', "");
    Expect(1, 917631, '\P{^Sc=zyyy}', "");
    Expect(0, 917632, '\p{Sc=zyyy}', "");
    Expect(1, 917632, '\p{^Sc=zyyy}', "");
    Expect(1, 917632, '\P{Sc=zyyy}', "");
    Expect(0, 917632, '\P{^Sc=zyyy}', "");
    Expect(1, 917631, '\p{Sc=:\Azyyy\z:}', "");;
    Expect(0, 917632, '\p{Sc=:\Azyyy\z:}', "");;
    Expect(1, 917631, '\p{Sc=- zyyy}', "");
    Expect(0, 917631, '\p{^Sc=- zyyy}', "");
    Expect(0, 917631, '\P{Sc=- zyyy}', "");
    Expect(1, 917631, '\P{^Sc=- zyyy}', "");
    Expect(0, 917632, '\p{Sc=- zyyy}', "");
    Expect(1, 917632, '\p{^Sc=- zyyy}', "");
    Expect(1, 917632, '\P{Sc=- zyyy}', "");
    Expect(0, 917632, '\P{^Sc=- zyyy}', "");
    Error('\p{Is_Script=	_Common/a/}');
    Error('\P{Is_Script=	_Common/a/}');
    Expect(1, 917631, '\p{Is_Script=common}', "");
    Expect(0, 917631, '\p{^Is_Script=common}', "");
    Expect(0, 917631, '\P{Is_Script=common}', "");
    Expect(1, 917631, '\P{^Is_Script=common}', "");
    Expect(0, 917632, '\p{Is_Script=common}', "");
    Expect(1, 917632, '\p{^Is_Script=common}', "");
    Expect(1, 917632, '\P{Is_Script=common}', "");
    Expect(0, 917632, '\P{^Is_Script=common}', "");
    Expect(1, 917631, '\p{Is_Script=_Common}', "");
    Expect(0, 917631, '\p{^Is_Script=_Common}', "");
    Expect(0, 917631, '\P{Is_Script=_Common}', "");
    Expect(1, 917631, '\P{^Is_Script=_Common}', "");
    Expect(0, 917632, '\p{Is_Script=_Common}', "");
    Expect(1, 917632, '\p{^Is_Script=_Common}', "");
    Expect(1, 917632, '\P{Is_Script=_Common}', "");
    Expect(0, 917632, '\P{^Is_Script=_Common}', "");
    Error('\p{Is_Sc=_Zyyy/a/}');
    Error('\P{Is_Sc=_Zyyy/a/}');
    Expect(1, 917631, '\p{Is_Sc=zyyy}', "");
    Expect(0, 917631, '\p{^Is_Sc=zyyy}', "");
    Expect(0, 917631, '\P{Is_Sc=zyyy}', "");
    Expect(1, 917631, '\P{^Is_Sc=zyyy}', "");
    Expect(0, 917632, '\p{Is_Sc=zyyy}', "");
    Expect(1, 917632, '\p{^Is_Sc=zyyy}', "");
    Expect(1, 917632, '\P{Is_Sc=zyyy}', "");
    Expect(0, 917632, '\P{^Is_Sc=zyyy}', "");
    Expect(1, 917631, '\p{Is_Sc:	-_ZYYY}', "");
    Expect(0, 917631, '\p{^Is_Sc:	-_ZYYY}', "");
    Expect(0, 917631, '\P{Is_Sc:	-_ZYYY}', "");
    Expect(1, 917631, '\P{^Is_Sc:	-_ZYYY}', "");
    Expect(0, 917632, '\p{Is_Sc:	-_ZYYY}', "");
    Expect(1, 917632, '\p{^Is_Sc:	-_ZYYY}', "");
    Expect(1, 917632, '\P{Is_Sc:	-_ZYYY}', "");
    Expect(0, 917632, '\P{^Is_Sc:	-_ZYYY}', "");
    Error('\p{Script:/a/ Unknown}');
    Error('\P{Script:/a/ Unknown}');
    Expect(1, 918000, '\p{Script=:\AUnknown\z:}', "");;
    Expect(0, 917999, '\p{Script=:\AUnknown\z:}', "");;
    Expect(1, 918000, '\p{Script=unknown}', "");
    Expect(0, 918000, '\p{^Script=unknown}', "");
    Expect(0, 918000, '\P{Script=unknown}', "");
    Expect(1, 918000, '\P{^Script=unknown}', "");
    Expect(0, 917999, '\p{Script=unknown}', "");
    Expect(1, 917999, '\p{^Script=unknown}', "");
    Expect(1, 917999, '\P{Script=unknown}', "");
    Expect(0, 917999, '\P{^Script=unknown}', "");
    Expect(1, 918000, '\p{Script=:\Aunknown\z:}', "");;
    Expect(0, 917999, '\p{Script=:\Aunknown\z:}', "");;
    Expect(1, 918000, '\p{Script=_	UNKNOWN}', "");
    Expect(0, 918000, '\p{^Script=_	UNKNOWN}', "");
    Expect(0, 918000, '\P{Script=_	UNKNOWN}', "");
    Expect(1, 918000, '\P{^Script=_	UNKNOWN}', "");
    Expect(0, 917999, '\p{Script=_	UNKNOWN}', "");
    Expect(1, 917999, '\p{^Script=_	UNKNOWN}', "");
    Expect(1, 917999, '\P{Script=_	UNKNOWN}', "");
    Expect(0, 917999, '\P{^Script=_	UNKNOWN}', "");
    Error('\p{Sc:   /a/_-Zzzz}');
    Error('\P{Sc:   /a/_-Zzzz}');
    Expect(1, 918000, '\p{Sc=:\AZzzz\z:}', "");;
    Expect(0, 917999, '\p{Sc=:\AZzzz\z:}', "");;
    Expect(1, 918000, '\p{Sc=zzzz}', "");
    Expect(0, 918000, '\p{^Sc=zzzz}', "");
    Expect(0, 918000, '\P{Sc=zzzz}', "");
    Expect(1, 918000, '\P{^Sc=zzzz}', "");
    Expect(0, 917999, '\p{Sc=zzzz}', "");
    Expect(1, 917999, '\p{^Sc=zzzz}', "");
    Expect(1, 917999, '\P{Sc=zzzz}', "");
    Expect(0, 917999, '\P{^Sc=zzzz}', "");
    Expect(1, 918000, '\p{Sc=:\Azzzz\z:}', "");;
    Expect(0, 917999, '\p{Sc=:\Azzzz\z:}', "");;
    Expect(1, 918000, '\p{Sc= _ZZZZ}', "");
    Expect(0, 918000, '\p{^Sc= _ZZZZ}', "");
    Expect(0, 918000, '\P{Sc= _ZZZZ}', "");
    Expect(1, 918000, '\P{^Sc= _ZZZZ}', "");
    Expect(0, 917999, '\p{Sc= _ZZZZ}', "");
    Expect(1, 917999, '\p{^Sc= _ZZZZ}', "");
    Expect(1, 917999, '\P{Sc= _ZZZZ}', "");
    Expect(0, 917999, '\P{^Sc= _ZZZZ}', "");
    Error('\p{Is_Script=	-Unknown/a/}');
    Error('\P{Is_Script=	-Unknown/a/}');
    Expect(1, 918000, '\p{Is_Script=unknown}', "");
    Expect(0, 918000, '\p{^Is_Script=unknown}', "");
    Expect(0, 918000, '\P{Is_Script=unknown}', "");
    Expect(1, 918000, '\P{^Is_Script=unknown}', "");
    Expect(0, 917999, '\p{Is_Script=unknown}', "");
    Expect(1, 917999, '\p{^Is_Script=unknown}', "");
    Expect(1, 917999, '\P{Is_Script=unknown}', "");
    Expect(0, 917999, '\P{^Is_Script=unknown}', "");
    Expect(1, 918000, '\p{Is_Script=_UNKNOWN}', "");
    Expect(0, 918000, '\p{^Is_Script=_UNKNOWN}', "");
    Expect(0, 918000, '\P{Is_Script=_UNKNOWN}', "");
    Expect(1, 918000, '\P{^Is_Script=_UNKNOWN}', "");
    Expect(0, 917999, '\p{Is_Script=_UNKNOWN}', "");
    Expect(1, 917999, '\p{^Is_Script=_UNKNOWN}', "");
    Expect(1, 917999, '\P{Is_Script=_UNKNOWN}', "");
    Expect(0, 917999, '\P{^Is_Script=_UNKNOWN}', "");
    Error('\p{Is_Sc=/a/-_ZZZZ}');
    Error('\P{Is_Sc=/a/-_ZZZZ}');
    Expect(1, 918000, '\p{Is_Sc=zzzz}', "");
    Expect(0, 918000, '\p{^Is_Sc=zzzz}', "");
    Expect(0, 918000, '\P{Is_Sc=zzzz}', "");
    Expect(1, 918000, '\P{^Is_Sc=zzzz}', "");
    Expect(0, 917999, '\p{Is_Sc=zzzz}', "");
    Expect(1, 917999, '\p{^Is_Sc=zzzz}', "");
    Expect(1, 917999, '\P{Is_Sc=zzzz}', "");
    Expect(0, 917999, '\P{^Is_Sc=zzzz}', "");
    Expect(1, 918000, '\p{Is_Sc=-Zzzz}', "");
    Expect(0, 918000, '\p{^Is_Sc=-Zzzz}', "");
    Expect(0, 918000, '\P{Is_Sc=-Zzzz}', "");
    Expect(1, 918000, '\P{^Is_Sc=-Zzzz}', "");
    Expect(0, 917999, '\p{Is_Sc=-Zzzz}', "");
    Expect(1, 917999, '\p{^Is_Sc=-Zzzz}', "");
    Expect(1, 917999, '\P{Is_Sc=-Zzzz}', "");
    Expect(0, 917999, '\P{^Is_Sc=-Zzzz}', "");
    Error('\p{simplecasefolding}');
    Error('\P{simplecasefolding}');
    Error('\p{scf}');
    Error('\P{scf}');
    Error('\p{sfc}');
    Error('\P{sfc}');
    Error('\p{scriptextensions}');
    Error('\P{scriptextensions}');
    Error('\p{scx}');
    Error('\P{scx}');
    Error('\p{Script_Extensions=_:=adlam}');
    Error('\P{Script_Extensions=_:=adlam}');
    Expect(1, 125279, '\p{Script_Extensions=:\AAdlam\z:}', "");;
    Expect(0, 125280, '\p{Script_Extensions=:\AAdlam\z:}', "");;
    Expect(1, 125279, '\p{Script_Extensions=adlam}', "");
    Expect(0, 125279, '\p{^Script_Extensions=adlam}', "");
    Expect(0, 125279, '\P{Script_Extensions=adlam}', "");
    Expect(1, 125279, '\P{^Script_Extensions=adlam}', "");
    Expect(0, 125280, '\p{Script_Extensions=adlam}', "");
    Expect(1, 125280, '\p{^Script_Extensions=adlam}', "");
    Expect(1, 125280, '\P{Script_Extensions=adlam}', "");
    Expect(0, 125280, '\P{^Script_Extensions=adlam}', "");
    Expect(1, 125279, '\p{Script_Extensions=:\Aadlam\z:}', "");;
    Expect(0, 125280, '\p{Script_Extensions=:\Aadlam\z:}', "");;
    Expect(1, 125279, '\p{Script_Extensions= Adlam}', "");
    Expect(0, 125279, '\p{^Script_Extensions= Adlam}', "");
    Expect(0, 125279, '\P{Script_Extensions= Adlam}', "");
    Expect(1, 125279, '\P{^Script_Extensions= Adlam}', "");
    Expect(0, 125280, '\p{Script_Extensions= Adlam}', "");
    Expect(1, 125280, '\p{^Script_Extensions= Adlam}', "");
    Expect(1, 125280, '\P{Script_Extensions= Adlam}', "");
    Expect(0, 125280, '\P{^Script_Extensions= Adlam}', "");
    Error('\p{Scx:	/a/-	ADLM}');
    Error('\P{Scx:	/a/-	ADLM}');
    Expect(1, 125279, '\p{Scx=:\AAdlm\z:}', "");;
    Expect(0, 125280, '\p{Scx=:\AAdlm\z:}', "");;
    Expect(1, 125279, '\p{Scx=adlm}', "");
    Expect(0, 125279, '\p{^Scx=adlm}', "");
    Expect(0, 125279, '\P{Scx=adlm}', "");
    Expect(1, 125279, '\P{^Scx=adlm}', "");
    Expect(0, 125280, '\p{Scx=adlm}', "");
    Expect(1, 125280, '\p{^Scx=adlm}', "");
    Expect(1, 125280, '\P{Scx=adlm}', "");
    Expect(0, 125280, '\P{^Scx=adlm}', "");
    Expect(1, 125279, '\p{Scx=:\Aadlm\z:}', "");;
    Expect(0, 125280, '\p{Scx=:\Aadlm\z:}', "");;
    Expect(1, 125279, '\p{Scx=_Adlm}', "");
    Expect(0, 125279, '\p{^Scx=_Adlm}', "");
    Expect(0, 125279, '\P{Scx=_Adlm}', "");
    Expect(1, 125279, '\P{^Scx=_Adlm}', "");
    Expect(0, 125280, '\p{Scx=_Adlm}', "");
    Expect(1, 125280, '\p{^Scx=_Adlm}', "");
    Expect(1, 125280, '\P{Scx=_Adlm}', "");
    Expect(0, 125280, '\P{^Scx=_Adlm}', "");
    Error('\p{Is_Script_Extensions=	/a/ADLAM}');
    Error('\P{Is_Script_Extensions=	/a/ADLAM}');
    Expect(1, 125279, '\p{Is_Script_Extensions=adlam}', "");
    Expect(0, 125279, '\p{^Is_Script_Extensions=adlam}', "");
    Expect(0, 125279, '\P{Is_Script_Extensions=adlam}', "");
    Expect(1, 125279, '\P{^Is_Script_Extensions=adlam}', "");
    Expect(0, 125280, '\p{Is_Script_Extensions=adlam}', "");
    Expect(1, 125280, '\p{^Is_Script_Extensions=adlam}', "");
    Expect(1, 125280, '\P{Is_Script_Extensions=adlam}', "");
    Expect(0, 125280, '\P{^Is_Script_Extensions=adlam}', "");
    Expect(1, 125279, '\p{Is_Script_Extensions=-Adlam}', "");
    Expect(0, 125279, '\p{^Is_Script_Extensions=-Adlam}', "");
    Expect(0, 125279, '\P{Is_Script_Extensions=-Adlam}', "");
    Expect(1, 125279, '\P{^Is_Script_Extensions=-Adlam}', "");
    Expect(0, 125280, '\p{Is_Script_Extensions=-Adlam}', "");
    Expect(1, 125280, '\p{^Is_Script_Extensions=-Adlam}', "");
    Expect(1, 125280, '\P{Is_Script_Extensions=-Adlam}', "");
    Expect(0, 125280, '\P{^Is_Script_Extensions=-Adlam}', "");
    Error('\p{Is_Scx=_Adlm/a/}');
    Error('\P{Is_Scx=_Adlm/a/}');
    Expect(1, 125279, '\p{Is_Scx=adlm}', "");
    Expect(0, 125279, '\p{^Is_Scx=adlm}', "");
    Expect(0, 125279, '\P{Is_Scx=adlm}', "");
    Expect(1, 125279, '\P{^Is_Scx=adlm}', "");
    Expect(0, 125280, '\p{Is_Scx=adlm}', "");
    Expect(1, 125280, '\p{^Is_Scx=adlm}', "");
    Expect(1, 125280, '\P{Is_Scx=adlm}', "");
    Expect(0, 125280, '\P{^Is_Scx=adlm}', "");
    Expect(1, 125279, '\p{Is_Scx=	Adlm}', "");
    Expect(0, 125279, '\p{^Is_Scx=	Adlm}', "");
    Expect(0, 125279, '\P{Is_Scx=	Adlm}', "");
    Expect(1, 125279, '\P{^Is_Scx=	Adlm}', "");
    Expect(0, 125280, '\p{Is_Scx=	Adlm}', "");
    Expect(1, 125280, '\p{^Is_Scx=	Adlm}', "");
    Expect(1, 125280, '\P{Is_Scx=	Adlm}', "");
    Expect(0, 125280, '\P{^Is_Scx=	Adlm}', "");
    Error('\p{Script_Extensions=_CAUCASIAN_ALBANIAN/a/}');
    Error('\P{Script_Extensions=_CAUCASIAN_ALBANIAN/a/}');
    Expect(1, 66927, '\p{Script_Extensions=:\ACaucasian_Albanian\z:}', "");;
    Expect(0, 66928, '\p{Script_Extensions=:\ACaucasian_Albanian\z:}', "");;
    Expect(1, 66927, '\p{Script_Extensions=caucasianalbanian}', "");
    Expect(0, 66927, '\p{^Script_Extensions=caucasianalbanian}', "");
    Expect(0, 66927, '\P{Script_Extensions=caucasianalbanian}', "");
    Expect(1, 66927, '\P{^Script_Extensions=caucasianalbanian}', "");
    Expect(0, 66928, '\p{Script_Extensions=caucasianalbanian}', "");
    Expect(1, 66928, '\p{^Script_Extensions=caucasianalbanian}', "");
    Expect(1, 66928, '\P{Script_Extensions=caucasianalbanian}', "");
    Expect(0, 66928, '\P{^Script_Extensions=caucasianalbanian}', "");
    Expect(1, 66927, '\p{Script_Extensions=:\Acaucasianalbanian\z:}', "");;
    Expect(0, 66928, '\p{Script_Extensions=:\Acaucasianalbanian\z:}', "");;
    Expect(1, 66927, '\p{Script_Extensions=	caucasian_Albanian}', "");
    Expect(0, 66927, '\p{^Script_Extensions=	caucasian_Albanian}', "");
    Expect(0, 66927, '\P{Script_Extensions=	caucasian_Albanian}', "");
    Expect(1, 66927, '\P{^Script_Extensions=	caucasian_Albanian}', "");
    Expect(0, 66928, '\p{Script_Extensions=	caucasian_Albanian}', "");
    Expect(1, 66928, '\p{^Script_Extensions=	caucasian_Albanian}', "");
    Expect(1, 66928, '\P{Script_Extensions=	caucasian_Albanian}', "");
    Expect(0, 66928, '\P{^Script_Extensions=	caucasian_Albanian}', "");
    Error('\p{Scx=/a/-Aghb}');
    Error('\P{Scx=/a/-Aghb}');
    Expect(1, 66927, '\p{Scx=:\AAghb\z:}', "");;
    Expect(0, 66928, '\p{Scx=:\AAghb\z:}', "");;
    Expect(1, 66927, '\p{Scx=aghb}', "");
    Expect(0, 66927, '\p{^Scx=aghb}', "");
    Expect(0, 66927, '\P{Scx=aghb}', "");
    Expect(1, 66927, '\P{^Scx=aghb}', "");
    Expect(0, 66928, '\p{Scx=aghb}', "");
    Expect(1, 66928, '\p{^Scx=aghb}', "");
    Expect(1, 66928, '\P{Scx=aghb}', "");
    Expect(0, 66928, '\P{^Scx=aghb}', "");
    Expect(1, 66927, '\p{Scx=:\Aaghb\z:}', "");;
    Expect(0, 66928, '\p{Scx=:\Aaghb\z:}', "");;
    Expect(1, 66927, '\p{Scx=-Aghb}', "");
    Expect(0, 66927, '\p{^Scx=-Aghb}', "");
    Expect(0, 66927, '\P{Scx=-Aghb}', "");
    Expect(1, 66927, '\P{^Scx=-Aghb}', "");
    Expect(0, 66928, '\p{Scx=-Aghb}', "");
    Expect(1, 66928, '\p{^Scx=-Aghb}', "");
    Expect(1, 66928, '\P{Scx=-Aghb}', "");
    Expect(0, 66928, '\P{^Scx=-Aghb}', "");
    Error('\p{Is_Script_Extensions= caucasian_Albanian/a/}');
    Error('\P{Is_Script_Extensions= caucasian_Albanian/a/}');
    Expect(1, 66927, '\p{Is_Script_Extensions=caucasianalbanian}', "");
    Expect(0, 66927, '\p{^Is_Script_Extensions=caucasianalbanian}', "");
    Expect(0, 66927, '\P{Is_Script_Extensions=caucasianalbanian}', "");
    Expect(1, 66927, '\P{^Is_Script_Extensions=caucasianalbanian}', "");
    Expect(0, 66928, '\p{Is_Script_Extensions=caucasianalbanian}', "");
    Expect(1, 66928, '\p{^Is_Script_Extensions=caucasianalbanian}', "");
    Expect(1, 66928, '\P{Is_Script_Extensions=caucasianalbanian}', "");
    Expect(0, 66928, '\P{^Is_Script_Extensions=caucasianalbanian}', "");
    Expect(1, 66927, '\p{Is_Script_Extensions: _caucasian_Albanian}', "");
    Expect(0, 66927, '\p{^Is_Script_Extensions: _caucasian_Albanian}', "");
    Expect(0, 66927, '\P{Is_Script_Extensions: _caucasian_Albanian}', "");
    Expect(1, 66927, '\P{^Is_Script_Extensions: _caucasian_Albanian}', "");
    Expect(0, 66928, '\p{Is_Script_Extensions: _caucasian_Albanian}', "");
    Expect(1, 66928, '\p{^Is_Script_Extensions: _caucasian_Albanian}', "");
    Expect(1, 66928, '\P{Is_Script_Extensions: _caucasian_Albanian}', "");
    Expect(0, 66928, '\P{^Is_Script_Extensions: _caucasian_Albanian}', "");
    Error('\p{Is_Scx=		Aghb:=}');
    Error('\P{Is_Scx=		Aghb:=}');
    Expect(1, 66927, '\p{Is_Scx=aghb}', "");
    Expect(0, 66927, '\p{^Is_Scx=aghb}', "");
    Expect(0, 66927, '\P{Is_Scx=aghb}', "");
    Expect(1, 66927, '\P{^Is_Scx=aghb}', "");
    Expect(0, 66928, '\p{Is_Scx=aghb}', "");
    Expect(1, 66928, '\p{^Is_Scx=aghb}', "");
    Expect(1, 66928, '\P{Is_Scx=aghb}', "");
    Expect(0, 66928, '\P{^Is_Scx=aghb}', "");
    Expect(1, 66927, '\p{Is_Scx:_Aghb}', "");
    Expect(0, 66927, '\p{^Is_Scx:_Aghb}', "");
    Expect(0, 66927, '\P{Is_Scx:_Aghb}', "");
    Expect(1, 66927, '\P{^Is_Scx:_Aghb}', "");
    Expect(0, 66928, '\p{Is_Scx:_Aghb}', "");
    Expect(1, 66928, '\p{^Is_Scx:_Aghb}', "");
    Expect(1, 66928, '\P{Is_Scx:_Aghb}', "");
    Expect(0, 66928, '\P{^Is_Scx:_Aghb}', "");
    Error('\p{Script_Extensions=/a/	-Ahom}');
    Error('\P{Script_Extensions=/a/	-Ahom}');
    Expect(1, 71487, '\p{Script_Extensions=:\AAhom\z:}', "");;
    Expect(0, 71488, '\p{Script_Extensions=:\AAhom\z:}', "");;
    Expect(1, 71487, '\p{Script_Extensions=ahom}', "");
    Expect(0, 71487, '\p{^Script_Extensions=ahom}', "");
    Expect(0, 71487, '\P{Script_Extensions=ahom}', "");
    Expect(1, 71487, '\P{^Script_Extensions=ahom}', "");
    Expect(0, 71488, '\p{Script_Extensions=ahom}', "");
    Expect(1, 71488, '\p{^Script_Extensions=ahom}', "");
    Expect(1, 71488, '\P{Script_Extensions=ahom}', "");
    Expect(0, 71488, '\P{^Script_Extensions=ahom}', "");
    Expect(1, 71487, '\p{Script_Extensions=:\Aahom\z:}', "");;
    Expect(0, 71488, '\p{Script_Extensions=:\Aahom\z:}', "");;
    Expect(1, 71487, '\p{Script_Extensions=	Ahom}', "");
    Expect(0, 71487, '\p{^Script_Extensions=	Ahom}', "");
    Expect(0, 71487, '\P{Script_Extensions=	Ahom}', "");
    Expect(1, 71487, '\P{^Script_Extensions=	Ahom}', "");
    Expect(0, 71488, '\p{Script_Extensions=	Ahom}', "");
    Expect(1, 71488, '\p{^Script_Extensions=	Ahom}', "");
    Expect(1, 71488, '\P{Script_Extensions=	Ahom}', "");
    Expect(0, 71488, '\P{^Script_Extensions=	Ahom}', "");
    Error('\p{Scx=:=	_Ahom}');
    Error('\P{Scx=:=	_Ahom}');
    Expect(1, 71487, '\p{Scx=:\AAhom\z:}', "");;
    Expect(0, 71488, '\p{Scx=:\AAhom\z:}', "");;
    Expect(1, 71487, '\p{Scx=ahom}', "");
    Expect(0, 71487, '\p{^Scx=ahom}', "");
    Expect(0, 71487, '\P{Scx=ahom}', "");
    Expect(1, 71487, '\P{^Scx=ahom}', "");
    Expect(0, 71488, '\p{Scx=ahom}', "");
    Expect(1, 71488, '\p{^Scx=ahom}', "");
    Expect(1, 71488, '\P{Scx=ahom}', "");
    Expect(0, 71488, '\P{^Scx=ahom}', "");
    Expect(1, 71487, '\p{Scx=:\Aahom\z:}', "");;
    Expect(0, 71488, '\p{Scx=:\Aahom\z:}', "");;
    Expect(1, 71487, '\p{Scx= _AHOM}', "");
    Expect(0, 71487, '\p{^Scx= _AHOM}', "");
    Expect(0, 71487, '\P{Scx= _AHOM}', "");
    Expect(1, 71487, '\P{^Scx= _AHOM}', "");
    Expect(0, 71488, '\p{Scx= _AHOM}', "");
    Expect(1, 71488, '\p{^Scx= _AHOM}', "");
    Expect(1, 71488, '\P{Scx= _AHOM}', "");
    Expect(0, 71488, '\P{^Scx= _AHOM}', "");
    Error('\p{Is_Script_Extensions=/a/-AHOM}');
    Error('\P{Is_Script_Extensions=/a/-AHOM}');
    Expect(1, 71487, '\p{Is_Script_Extensions=ahom}', "");
    Expect(0, 71487, '\p{^Is_Script_Extensions=ahom}', "");
    Expect(0, 71487, '\P{Is_Script_Extensions=ahom}', "");
    Expect(1, 71487, '\P{^Is_Script_Extensions=ahom}', "");
    Expect(0, 71488, '\p{Is_Script_Extensions=ahom}', "");
    Expect(1, 71488, '\p{^Is_Script_Extensions=ahom}', "");
    Expect(1, 71488, '\P{Is_Script_Extensions=ahom}', "");
    Expect(0, 71488, '\P{^Is_Script_Extensions=ahom}', "");
    Expect(1, 71487, '\p{Is_Script_Extensions=--AHOM}', "");
    Expect(0, 71487, '\p{^Is_Script_Extensions=--AHOM}', "");
    Expect(0, 71487, '\P{Is_Script_Extensions=--AHOM}', "");
    Expect(1, 71487, '\P{^Is_Script_Extensions=--AHOM}', "");
    Expect(0, 71488, '\p{Is_Script_Extensions=--AHOM}', "");
    Expect(1, 71488, '\p{^Is_Script_Extensions=--AHOM}', "");
    Expect(1, 71488, '\P{Is_Script_Extensions=--AHOM}', "");
    Expect(0, 71488, '\P{^Is_Script_Extensions=--AHOM}', "");
    Error('\p{Is_Scx:   :=Ahom}');
    Error('\P{Is_Scx:   :=Ahom}');
    Expect(1, 71487, '\p{Is_Scx=ahom}', "");
    Expect(0, 71487, '\p{^Is_Scx=ahom}', "");
    Expect(0, 71487, '\P{Is_Scx=ahom}', "");
    Expect(1, 71487, '\P{^Is_Scx=ahom}', "");
    Expect(0, 71488, '\p{Is_Scx=ahom}', "");
    Expect(1, 71488, '\p{^Is_Scx=ahom}', "");
    Expect(1, 71488, '\P{Is_Scx=ahom}', "");
    Expect(0, 71488, '\P{^Is_Scx=ahom}', "");
    Expect(1, 71487, '\p{Is_Scx=_Ahom}', "");
    Expect(0, 71487, '\p{^Is_Scx=_Ahom}', "");
    Expect(0, 71487, '\P{Is_Scx=_Ahom}', "");
    Expect(1, 71487, '\P{^Is_Scx=_Ahom}', "");
    Expect(0, 71488, '\p{Is_Scx=_Ahom}', "");
    Expect(1, 71488, '\p{^Is_Scx=_Ahom}', "");
    Expect(1, 71488, '\P{Is_Scx=_Ahom}', "");
    Expect(0, 71488, '\P{^Is_Scx=_Ahom}', "");
    Error('\p{Script_Extensions=__arabic/a/}');
    Error('\P{Script_Extensions=__arabic/a/}');
    Expect(1, 126705, '\p{Script_Extensions=:\AArabic\z:}', "");;
    Expect(0, 126706, '\p{Script_Extensions=:\AArabic\z:}', "");;
    Expect(1, 126705, '\p{Script_Extensions=arabic}', "");
    Expect(0, 126705, '\p{^Script_Extensions=arabic}', "");
    Expect(0, 126705, '\P{Script_Extensions=arabic}', "");
    Expect(1, 126705, '\P{^Script_Extensions=arabic}', "");
    Expect(0, 126706, '\p{Script_Extensions=arabic}', "");
    Expect(1, 126706, '\p{^Script_Extensions=arabic}', "");
    Expect(1, 126706, '\P{Script_Extensions=arabic}', "");
    Expect(0, 126706, '\P{^Script_Extensions=arabic}', "");
    Expect(1, 126705, '\p{Script_Extensions=:\Aarabic\z:}', "");;
    Expect(0, 126706, '\p{Script_Extensions=:\Aarabic\z:}', "");;
    Expect(1, 126705, '\p{Script_Extensions=--ARABIC}', "");
    Expect(0, 126705, '\p{^Script_Extensions=--ARABIC}', "");
    Expect(0, 126705, '\P{Script_Extensions=--ARABIC}', "");
    Expect(1, 126705, '\P{^Script_Extensions=--ARABIC}', "");
    Expect(0, 126706, '\p{Script_Extensions=--ARABIC}', "");
    Expect(1, 126706, '\p{^Script_Extensions=--ARABIC}', "");
    Expect(1, 126706, '\P{Script_Extensions=--ARABIC}', "");
    Expect(0, 126706, '\P{^Script_Extensions=--ARABIC}', "");
    Error('\p{Scx= /a/Arab}');
    Error('\P{Scx= /a/Arab}');
    Expect(1, 126705, '\p{Scx=:\AArab\z:}', "");;
    Expect(0, 126706, '\p{Scx=:\AArab\z:}', "");;
    Expect(1, 126705, '\p{Scx=arab}', "");
    Expect(0, 126705, '\p{^Scx=arab}', "");
    Expect(0, 126705, '\P{Scx=arab}', "");
    Expect(1, 126705, '\P{^Scx=arab}', "");
    Expect(0, 126706, '\p{Scx=arab}', "");
    Expect(1, 126706, '\p{^Scx=arab}', "");
    Expect(1, 126706, '\P{Scx=arab}', "");
    Expect(0, 126706, '\P{^Scx=arab}', "");
    Expect(1, 126705, '\p{Scx=:\Aarab\z:}', "");;
    Expect(0, 126706, '\p{Scx=:\Aarab\z:}', "");;
    Expect(1, 126705, '\p{Scx=	-Arab}', "");
    Expect(0, 126705, '\p{^Scx=	-Arab}', "");
    Expect(0, 126705, '\P{Scx=	-Arab}', "");
    Expect(1, 126705, '\P{^Scx=	-Arab}', "");
    Expect(0, 126706, '\p{Scx=	-Arab}', "");
    Expect(1, 126706, '\p{^Scx=	-Arab}', "");
    Expect(1, 126706, '\P{Scx=	-Arab}', "");
    Expect(0, 126706, '\P{^Scx=	-Arab}', "");
    Error('\p{Is_Script_Extensions=_/a/arabic}');
    Error('\P{Is_Script_Extensions=_/a/arabic}');
    Expect(1, 126705, '\p{Is_Script_Extensions=arabic}', "");
    Expect(0, 126705, '\p{^Is_Script_Extensions=arabic}', "");
    Expect(0, 126705, '\P{Is_Script_Extensions=arabic}', "");
    Expect(1, 126705, '\P{^Is_Script_Extensions=arabic}', "");
    Expect(0, 126706, '\p{Is_Script_Extensions=arabic}', "");
    Expect(1, 126706, '\p{^Is_Script_Extensions=arabic}', "");
    Expect(1, 126706, '\P{Is_Script_Extensions=arabic}', "");
    Expect(0, 126706, '\P{^Is_Script_Extensions=arabic}', "");
    Expect(1, 126705, '\p{Is_Script_Extensions=_arabic}', "");
    Expect(0, 126705, '\p{^Is_Script_Extensions=_arabic}', "");
    Expect(0, 126705, '\P{Is_Script_Extensions=_arabic}', "");
    Expect(1, 126705, '\P{^Is_Script_Extensions=_arabic}', "");
    Expect(0, 126706, '\p{Is_Script_Extensions=_arabic}', "");
    Expect(1, 126706, '\p{^Is_Script_Extensions=_arabic}', "");
    Expect(1, 126706, '\P{Is_Script_Extensions=_arabic}', "");
    Expect(0, 126706, '\P{^Is_Script_Extensions=_arabic}', "");
    Error('\p{Is_Scx=/a/ARAB}');
    Error('\P{Is_Scx=/a/ARAB}');
    Expect(1, 126705, '\p{Is_Scx=arab}', "");
    Expect(0, 126705, '\p{^Is_Scx=arab}', "");
    Expect(0, 126705, '\P{Is_Scx=arab}', "");
    Expect(1, 126705, '\P{^Is_Scx=arab}', "");
    Expect(0, 126706, '\p{Is_Scx=arab}', "");
    Expect(1, 126706, '\p{^Is_Scx=arab}', "");
    Expect(1, 126706, '\P{Is_Scx=arab}', "");
    Expect(0, 126706, '\P{^Is_Scx=arab}', "");
    Expect(1, 126705, '\p{Is_Scx=	 ARAB}', "");
    Expect(0, 126705, '\p{^Is_Scx=	 ARAB}', "");
    Expect(0, 126705, '\P{Is_Scx=	 ARAB}', "");
    Expect(1, 126705, '\P{^Is_Scx=	 ARAB}', "");
    Expect(0, 126706, '\p{Is_Scx=	 ARAB}', "");
    Expect(1, 126706, '\p{^Is_Scx=	 ARAB}', "");
    Expect(1, 126706, '\P{Is_Scx=	 ARAB}', "");
    Expect(0, 126706, '\P{^Is_Scx=	 ARAB}', "");
    Error('\p{Script_Extensions=	imperial_aramaic:=}');
    Error('\P{Script_Extensions=	imperial_aramaic:=}');
    Expect(1, 67679, '\p{Script_Extensions=:\AImperial_Aramaic\z:}', "");;
    Expect(0, 67680, '\p{Script_Extensions=:\AImperial_Aramaic\z:}', "");;
    Expect(1, 67679, '\p{Script_Extensions=imperialaramaic}', "");
    Expect(0, 67679, '\p{^Script_Extensions=imperialaramaic}', "");
    Expect(0, 67679, '\P{Script_Extensions=imperialaramaic}', "");
    Expect(1, 67679, '\P{^Script_Extensions=imperialaramaic}', "");
    Expect(0, 67680, '\p{Script_Extensions=imperialaramaic}', "");
    Expect(1, 67680, '\p{^Script_Extensions=imperialaramaic}', "");
    Expect(1, 67680, '\P{Script_Extensions=imperialaramaic}', "");
    Expect(0, 67680, '\P{^Script_Extensions=imperialaramaic}', "");
    Expect(1, 67679, '\p{Script_Extensions=:\Aimperialaramaic\z:}', "");;
    Expect(0, 67680, '\p{Script_Extensions=:\Aimperialaramaic\z:}', "");;
    Expect(1, 67679, '\p{Script_Extensions=-Imperial_ARAMAIC}', "");
    Expect(0, 67679, '\p{^Script_Extensions=-Imperial_ARAMAIC}', "");
    Expect(0, 67679, '\P{Script_Extensions=-Imperial_ARAMAIC}', "");
    Expect(1, 67679, '\P{^Script_Extensions=-Imperial_ARAMAIC}', "");
    Expect(0, 67680, '\p{Script_Extensions=-Imperial_ARAMAIC}', "");
    Expect(1, 67680, '\p{^Script_Extensions=-Imperial_ARAMAIC}', "");
    Expect(1, 67680, '\P{Script_Extensions=-Imperial_ARAMAIC}', "");
    Expect(0, 67680, '\P{^Script_Extensions=-Imperial_ARAMAIC}', "");
    Error('\p{Scx: -:=Armi}');
    Error('\P{Scx: -:=Armi}');
    Expect(1, 67679, '\p{Scx=:\AArmi\z:}', "");;
    Expect(0, 67680, '\p{Scx=:\AArmi\z:}', "");;
    Expect(1, 67679, '\p{Scx=armi}', "");
    Expect(0, 67679, '\p{^Scx=armi}', "");
    Expect(0, 67679, '\P{Scx=armi}', "");
    Expect(1, 67679, '\P{^Scx=armi}', "");
    Expect(0, 67680, '\p{Scx=armi}', "");
    Expect(1, 67680, '\p{^Scx=armi}', "");
    Expect(1, 67680, '\P{Scx=armi}', "");
    Expect(0, 67680, '\P{^Scx=armi}', "");
    Expect(1, 67679, '\p{Scx=:\Aarmi\z:}', "");;
    Expect(0, 67680, '\p{Scx=:\Aarmi\z:}', "");;
    Expect(1, 67679, '\p{Scx:   --ARMI}', "");
    Expect(0, 67679, '\p{^Scx:   --ARMI}', "");
    Expect(0, 67679, '\P{Scx:   --ARMI}', "");
    Expect(1, 67679, '\P{^Scx:   --ARMI}', "");
    Expect(0, 67680, '\p{Scx:   --ARMI}', "");
    Expect(1, 67680, '\p{^Scx:   --ARMI}', "");
    Expect(1, 67680, '\P{Scx:   --ARMI}', "");
    Expect(0, 67680, '\P{^Scx:   --ARMI}', "");
    Error('\p{Is_Script_Extensions=_/a/IMPERIAL_Aramaic}');
    Error('\P{Is_Script_Extensions=_/a/IMPERIAL_Aramaic}');
    Expect(1, 67679, '\p{Is_Script_Extensions=imperialaramaic}', "");
    Expect(0, 67679, '\p{^Is_Script_Extensions=imperialaramaic}', "");
    Expect(0, 67679, '\P{Is_Script_Extensions=imperialaramaic}', "");
    Expect(1, 67679, '\P{^Is_Script_Extensions=imperialaramaic}', "");
    Expect(0, 67680, '\p{Is_Script_Extensions=imperialaramaic}', "");
    Expect(1, 67680, '\p{^Is_Script_Extensions=imperialaramaic}', "");
    Expect(1, 67680, '\P{Is_Script_Extensions=imperialaramaic}', "");
    Expect(0, 67680, '\P{^Is_Script_Extensions=imperialaramaic}', "");
    Expect(1, 67679, '\p{Is_Script_Extensions= 	IMPERIAL_Aramaic}', "");
    Expect(0, 67679, '\p{^Is_Script_Extensions= 	IMPERIAL_Aramaic}', "");
    Expect(0, 67679, '\P{Is_Script_Extensions= 	IMPERIAL_Aramaic}', "");
    Expect(1, 67679, '\P{^Is_Script_Extensions= 	IMPERIAL_Aramaic}', "");
    Expect(0, 67680, '\p{Is_Script_Extensions= 	IMPERIAL_Aramaic}', "");
    Expect(1, 67680, '\p{^Is_Script_Extensions= 	IMPERIAL_Aramaic}', "");
    Expect(1, 67680, '\P{Is_Script_Extensions= 	IMPERIAL_Aramaic}', "");
    Expect(0, 67680, '\P{^Is_Script_Extensions= 	IMPERIAL_Aramaic}', "");
    Error('\p{Is_Scx:   -/a/ARMI}');
    Error('\P{Is_Scx:   -/a/ARMI}');
    Expect(1, 67679, '\p{Is_Scx=armi}', "");
    Expect(0, 67679, '\p{^Is_Scx=armi}', "");
    Expect(0, 67679, '\P{Is_Scx=armi}', "");
    Expect(1, 67679, '\P{^Is_Scx=armi}', "");
    Expect(0, 67680, '\p{Is_Scx=armi}', "");
    Expect(1, 67680, '\p{^Is_Scx=armi}', "");
    Expect(1, 67680, '\P{Is_Scx=armi}', "");
    Expect(0, 67680, '\P{^Is_Scx=armi}', "");
    Expect(1, 67679, '\p{Is_Scx= 	Armi}', "");
    Expect(0, 67679, '\p{^Is_Scx= 	Armi}', "");
    Expect(0, 67679, '\P{Is_Scx= 	Armi}', "");
    Expect(1, 67679, '\P{^Is_Scx= 	Armi}', "");
    Expect(0, 67680, '\p{Is_Scx= 	Armi}', "");
    Expect(1, 67680, '\p{^Is_Scx= 	Armi}', "");
    Expect(1, 67680, '\P{Is_Scx= 	Armi}', "");
    Expect(0, 67680, '\P{^Is_Scx= 	Armi}', "");
    Error('\p{Script_Extensions=:=-Armenian}');
    Error('\P{Script_Extensions=:=-Armenian}');
    Expect(1, 64279, '\p{Script_Extensions=:\AArmenian\z:}', "");;
    Expect(0, 64280, '\p{Script_Extensions=:\AArmenian\z:}', "");;
    Expect(1, 64279, '\p{Script_Extensions=armenian}', "");
    Expect(0, 64279, '\p{^Script_Extensions=armenian}', "");
    Expect(0, 64279, '\P{Script_Extensions=armenian}', "");
    Expect(1, 64279, '\P{^Script_Extensions=armenian}', "");
    Expect(0, 64280, '\p{Script_Extensions=armenian}', "");
    Expect(1, 64280, '\p{^Script_Extensions=armenian}', "");
    Expect(1, 64280, '\P{Script_Extensions=armenian}', "");
    Expect(0, 64280, '\P{^Script_Extensions=armenian}', "");
    Expect(1, 64279, '\p{Script_Extensions=:\Aarmenian\z:}', "");;
    Expect(0, 64280, '\p{Script_Extensions=:\Aarmenian\z:}', "");;
    Expect(1, 64279, '\p{Script_Extensions=_	Armenian}', "");
    Expect(0, 64279, '\p{^Script_Extensions=_	Armenian}', "");
    Expect(0, 64279, '\P{Script_Extensions=_	Armenian}', "");
    Expect(1, 64279, '\P{^Script_Extensions=_	Armenian}', "");
    Expect(0, 64280, '\p{Script_Extensions=_	Armenian}', "");
    Expect(1, 64280, '\p{^Script_Extensions=_	Armenian}', "");
    Expect(1, 64280, '\P{Script_Extensions=_	Armenian}', "");
    Expect(0, 64280, '\P{^Script_Extensions=_	Armenian}', "");
    Error('\p{Scx=:=_	Armn}');
    Error('\P{Scx=:=_	Armn}');
    Expect(1, 64279, '\p{Scx=:\AArmn\z:}', "");;
    Expect(0, 64280, '\p{Scx=:\AArmn\z:}', "");;
    Expect(1, 64279, '\p{Scx=armn}', "");
    Expect(0, 64279, '\p{^Scx=armn}', "");
    Expect(0, 64279, '\P{Scx=armn}', "");
    Expect(1, 64279, '\P{^Scx=armn}', "");
    Expect(0, 64280, '\p{Scx=armn}', "");
    Expect(1, 64280, '\p{^Scx=armn}', "");
    Expect(1, 64280, '\P{Scx=armn}', "");
    Expect(0, 64280, '\P{^Scx=armn}', "");
    Expect(1, 64279, '\p{Scx=:\Aarmn\z:}', "");;
    Expect(0, 64280, '\p{Scx=:\Aarmn\z:}', "");;
    Expect(1, 64279, '\p{Scx=_ARMN}', "");
    Expect(0, 64279, '\p{^Scx=_ARMN}', "");
    Expect(0, 64279, '\P{Scx=_ARMN}', "");
    Expect(1, 64279, '\P{^Scx=_ARMN}', "");
    Expect(0, 64280, '\p{Scx=_ARMN}', "");
    Expect(1, 64280, '\p{^Scx=_ARMN}', "");
    Expect(1, 64280, '\P{Scx=_ARMN}', "");
    Expect(0, 64280, '\P{^Scx=_ARMN}', "");
    Error('\p{Is_Script_Extensions=_	ARMENIAN/a/}');
    Error('\P{Is_Script_Extensions=_	ARMENIAN/a/}');
    Expect(1, 64279, '\p{Is_Script_Extensions=armenian}', "");
    Expect(0, 64279, '\p{^Is_Script_Extensions=armenian}', "");
    Expect(0, 64279, '\P{Is_Script_Extensions=armenian}', "");
    Expect(1, 64279, '\P{^Is_Script_Extensions=armenian}', "");
    Expect(0, 64280, '\p{Is_Script_Extensions=armenian}', "");
    Expect(1, 64280, '\p{^Is_Script_Extensions=armenian}', "");
    Expect(1, 64280, '\P{Is_Script_Extensions=armenian}', "");
    Expect(0, 64280, '\P{^Is_Script_Extensions=armenian}', "");
    Expect(1, 64279, '\p{Is_Script_Extensions=-ARMENIAN}', "");
    Expect(0, 64279, '\p{^Is_Script_Extensions=-ARMENIAN}', "");
    Expect(0, 64279, '\P{Is_Script_Extensions=-ARMENIAN}', "");
    Expect(1, 64279, '\P{^Is_Script_Extensions=-ARMENIAN}', "");
    Expect(0, 64280, '\p{Is_Script_Extensions=-ARMENIAN}', "");
    Expect(1, 64280, '\p{^Is_Script_Extensions=-ARMENIAN}', "");
    Expect(1, 64280, '\P{Is_Script_Extensions=-ARMENIAN}', "");
    Expect(0, 64280, '\P{^Is_Script_Extensions=-ARMENIAN}', "");
    Error('\p{Is_Scx=-/a/armn}');
    Error('\P{Is_Scx=-/a/armn}');
    Expect(1, 64279, '\p{Is_Scx=armn}', "");
    Expect(0, 64279, '\p{^Is_Scx=armn}', "");
    Expect(0, 64279, '\P{Is_Scx=armn}', "");
    Expect(1, 64279, '\P{^Is_Scx=armn}', "");
    Expect(0, 64280, '\p{Is_Scx=armn}', "");
    Expect(1, 64280, '\p{^Is_Scx=armn}', "");
    Expect(1, 64280, '\P{Is_Scx=armn}', "");
    Expect(0, 64280, '\P{^Is_Scx=armn}', "");
    Expect(1, 64279, '\p{Is_Scx=	armn}', "");
    Expect(0, 64279, '\p{^Is_Scx=	armn}', "");
    Expect(0, 64279, '\P{Is_Scx=	armn}', "");
    Expect(1, 64279, '\P{^Is_Scx=	armn}', "");
    Expect(0, 64280, '\p{Is_Scx=	armn}', "");
    Expect(1, 64280, '\p{^Is_Scx=	armn}', "");
    Expect(1, 64280, '\P{Is_Scx=	armn}', "");
    Expect(0, 64280, '\P{^Is_Scx=	armn}', "");
    Error('\p{Script_Extensions=-/a/avestan}');
    Error('\P{Script_Extensions=-/a/avestan}');
    Expect(1, 68415, '\p{Script_Extensions=:\AAvestan\z:}', "");;
    Expect(0, 68416, '\p{Script_Extensions=:\AAvestan\z:}', "");;
    Expect(1, 68415, '\p{Script_Extensions=avestan}', "");
    Expect(0, 68415, '\p{^Script_Extensions=avestan}', "");
    Expect(0, 68415, '\P{Script_Extensions=avestan}', "");
    Expect(1, 68415, '\P{^Script_Extensions=avestan}', "");
    Expect(0, 68416, '\p{Script_Extensions=avestan}', "");
    Expect(1, 68416, '\p{^Script_Extensions=avestan}', "");
    Expect(1, 68416, '\P{Script_Extensions=avestan}', "");
    Expect(0, 68416, '\P{^Script_Extensions=avestan}', "");
    Expect(1, 68415, '\p{Script_Extensions=:\Aavestan\z:}', "");;
    Expect(0, 68416, '\p{Script_Extensions=:\Aavestan\z:}', "");;
    Expect(1, 68415, '\p{Script_Extensions=_-avestan}', "");
    Expect(0, 68415, '\p{^Script_Extensions=_-avestan}', "");
    Expect(0, 68415, '\P{Script_Extensions=_-avestan}', "");
    Expect(1, 68415, '\P{^Script_Extensions=_-avestan}', "");
    Expect(0, 68416, '\p{Script_Extensions=_-avestan}', "");
    Expect(1, 68416, '\p{^Script_Extensions=_-avestan}', "");
    Expect(1, 68416, '\P{Script_Extensions=_-avestan}', "");
    Expect(0, 68416, '\P{^Script_Extensions=_-avestan}', "");
    Error('\p{Scx=/a/avst}');
    Error('\P{Scx=/a/avst}');
    Expect(1, 68415, '\p{Scx=:\AAvst\z:}', "");;
    Expect(0, 68416, '\p{Scx=:\AAvst\z:}', "");;
    Expect(1, 68415, '\p{Scx=avst}', "");
    Expect(0, 68415, '\p{^Scx=avst}', "");
    Expect(0, 68415, '\P{Scx=avst}', "");
    Expect(1, 68415, '\P{^Scx=avst}', "");
    Expect(0, 68416, '\p{Scx=avst}', "");
    Expect(1, 68416, '\p{^Scx=avst}', "");
    Expect(1, 68416, '\P{Scx=avst}', "");
    Expect(0, 68416, '\P{^Scx=avst}', "");
    Expect(1, 68415, '\p{Scx=:\Aavst\z:}', "");;
    Expect(0, 68416, '\p{Scx=:\Aavst\z:}', "");;
    Expect(1, 68415, '\p{Scx=	avst}', "");
    Expect(0, 68415, '\p{^Scx=	avst}', "");
    Expect(0, 68415, '\P{Scx=	avst}', "");
    Expect(1, 68415, '\P{^Scx=	avst}', "");
    Expect(0, 68416, '\p{Scx=	avst}', "");
    Expect(1, 68416, '\p{^Scx=	avst}', "");
    Expect(1, 68416, '\P{Scx=	avst}', "");
    Expect(0, 68416, '\P{^Scx=	avst}', "");
    Error('\p{Is_Script_Extensions=:=avestan}');
    Error('\P{Is_Script_Extensions=:=avestan}');
    Expect(1, 68415, '\p{Is_Script_Extensions=avestan}', "");
    Expect(0, 68415, '\p{^Is_Script_Extensions=avestan}', "");
    Expect(0, 68415, '\P{Is_Script_Extensions=avestan}', "");
    Expect(1, 68415, '\P{^Is_Script_Extensions=avestan}', "");
    Expect(0, 68416, '\p{Is_Script_Extensions=avestan}', "");
    Expect(1, 68416, '\p{^Is_Script_Extensions=avestan}', "");
    Expect(1, 68416, '\P{Is_Script_Extensions=avestan}', "");
    Expect(0, 68416, '\P{^Is_Script_Extensions=avestan}', "");
    Expect(1, 68415, '\p{Is_Script_Extensions=-_AVESTAN}', "");
    Expect(0, 68415, '\p{^Is_Script_Extensions=-_AVESTAN}', "");
    Expect(0, 68415, '\P{Is_Script_Extensions=-_AVESTAN}', "");
    Expect(1, 68415, '\P{^Is_Script_Extensions=-_AVESTAN}', "");
    Expect(0, 68416, '\p{Is_Script_Extensions=-_AVESTAN}', "");
    Expect(1, 68416, '\p{^Is_Script_Extensions=-_AVESTAN}', "");
    Expect(1, 68416, '\P{Is_Script_Extensions=-_AVESTAN}', "");
    Expect(0, 68416, '\P{^Is_Script_Extensions=-_AVESTAN}', "");
    Error('\p{Is_Scx=/a/_-AVST}');
    Error('\P{Is_Scx=/a/_-AVST}');
    Expect(1, 68415, '\p{Is_Scx=avst}', "");
    Expect(0, 68415, '\p{^Is_Scx=avst}', "");
    Expect(0, 68415, '\P{Is_Scx=avst}', "");
    Expect(1, 68415, '\P{^Is_Scx=avst}', "");
    Expect(0, 68416, '\p{Is_Scx=avst}', "");
    Expect(1, 68416, '\p{^Is_Scx=avst}', "");
    Expect(1, 68416, '\P{Is_Scx=avst}', "");
    Expect(0, 68416, '\P{^Is_Scx=avst}', "");
    Expect(1, 68415, '\p{Is_Scx=_ AVST}', "");
    Expect(0, 68415, '\p{^Is_Scx=_ AVST}', "");
    Expect(0, 68415, '\P{Is_Scx=_ AVST}', "");
    Expect(1, 68415, '\P{^Is_Scx=_ AVST}', "");
    Expect(0, 68416, '\p{Is_Scx=_ AVST}', "");
    Expect(1, 68416, '\p{^Is_Scx=_ AVST}', "");
    Expect(1, 68416, '\P{Is_Scx=_ AVST}', "");
    Expect(0, 68416, '\P{^Is_Scx=_ AVST}', "");
    Error('\p{Script_Extensions=/a/_Balinese}');
    Error('\P{Script_Extensions=/a/_Balinese}');
    Expect(1, 7036, '\p{Script_Extensions=:\ABalinese\z:}', "");;
    Expect(0, 7037, '\p{Script_Extensions=:\ABalinese\z:}', "");;
    Expect(1, 7036, '\p{Script_Extensions:balinese}', "");
    Expect(0, 7036, '\p{^Script_Extensions:balinese}', "");
    Expect(0, 7036, '\P{Script_Extensions:balinese}', "");
    Expect(1, 7036, '\P{^Script_Extensions:balinese}', "");
    Expect(0, 7037, '\p{Script_Extensions:balinese}', "");
    Expect(1, 7037, '\p{^Script_Extensions:balinese}', "");
    Expect(1, 7037, '\P{Script_Extensions:balinese}', "");
    Expect(0, 7037, '\P{^Script_Extensions:balinese}', "");
    Expect(1, 7036, '\p{Script_Extensions=:\Abalinese\z:}', "");;
    Expect(0, 7037, '\p{Script_Extensions=:\Abalinese\z:}', "");;
    Expect(1, 7036, '\p{Script_Extensions=--Balinese}', "");
    Expect(0, 7036, '\p{^Script_Extensions=--Balinese}', "");
    Expect(0, 7036, '\P{Script_Extensions=--Balinese}', "");
    Expect(1, 7036, '\P{^Script_Extensions=--Balinese}', "");
    Expect(0, 7037, '\p{Script_Extensions=--Balinese}', "");
    Expect(1, 7037, '\p{^Script_Extensions=--Balinese}', "");
    Expect(1, 7037, '\P{Script_Extensions=--Balinese}', "");
    Expect(0, 7037, '\P{^Script_Extensions=--Balinese}', "");
    Error('\p{Scx=_bali/a/}');
    Error('\P{Scx=_bali/a/}');
    Expect(1, 7036, '\p{Scx=:\ABali\z:}', "");;
    Expect(0, 7037, '\p{Scx=:\ABali\z:}', "");;
    Expect(1, 7036, '\p{Scx=bali}', "");
    Expect(0, 7036, '\p{^Scx=bali}', "");
    Expect(0, 7036, '\P{Scx=bali}', "");
    Expect(1, 7036, '\P{^Scx=bali}', "");
    Expect(0, 7037, '\p{Scx=bali}', "");
    Expect(1, 7037, '\p{^Scx=bali}', "");
    Expect(1, 7037, '\P{Scx=bali}', "");
    Expect(0, 7037, '\P{^Scx=bali}', "");
    Expect(1, 7036, '\p{Scx=:\Abali\z:}', "");;
    Expect(0, 7037, '\p{Scx=:\Abali\z:}', "");;
    Expect(1, 7036, '\p{Scx=  BALI}', "");
    Expect(0, 7036, '\p{^Scx=  BALI}', "");
    Expect(0, 7036, '\P{Scx=  BALI}', "");
    Expect(1, 7036, '\P{^Scx=  BALI}', "");
    Expect(0, 7037, '\p{Scx=  BALI}', "");
    Expect(1, 7037, '\p{^Scx=  BALI}', "");
    Expect(1, 7037, '\P{Scx=  BALI}', "");
    Expect(0, 7037, '\P{^Scx=  BALI}', "");
    Error('\p{Is_Script_Extensions=:=--Balinese}');
    Error('\P{Is_Script_Extensions=:=--Balinese}');
    Expect(1, 7036, '\p{Is_Script_Extensions=balinese}', "");
    Expect(0, 7036, '\p{^Is_Script_Extensions=balinese}', "");
    Expect(0, 7036, '\P{Is_Script_Extensions=balinese}', "");
    Expect(1, 7036, '\P{^Is_Script_Extensions=balinese}', "");
    Expect(0, 7037, '\p{Is_Script_Extensions=balinese}', "");
    Expect(1, 7037, '\p{^Is_Script_Extensions=balinese}', "");
    Expect(1, 7037, '\P{Is_Script_Extensions=balinese}', "");
    Expect(0, 7037, '\P{^Is_Script_Extensions=balinese}', "");
    Expect(1, 7036, '\p{Is_Script_Extensions= Balinese}', "");
    Expect(0, 7036, '\p{^Is_Script_Extensions= Balinese}', "");
    Expect(0, 7036, '\P{Is_Script_Extensions= Balinese}', "");
    Expect(1, 7036, '\P{^Is_Script_Extensions= Balinese}', "");
    Expect(0, 7037, '\p{Is_Script_Extensions= Balinese}', "");
    Expect(1, 7037, '\p{^Is_Script_Extensions= Balinese}', "");
    Expect(1, 7037, '\P{Is_Script_Extensions= Balinese}', "");
    Expect(0, 7037, '\P{^Is_Script_Extensions= Balinese}', "");
    Error('\p{Is_Scx=	-Bali/a/}');
    Error('\P{Is_Scx=	-Bali/a/}');
    Expect(1, 7036, '\p{Is_Scx=bali}', "");
    Expect(0, 7036, '\p{^Is_Scx=bali}', "");
    Expect(0, 7036, '\P{Is_Scx=bali}', "");
    Expect(1, 7036, '\P{^Is_Scx=bali}', "");
    Expect(0, 7037, '\p{Is_Scx=bali}', "");
    Expect(1, 7037, '\p{^Is_Scx=bali}', "");
    Expect(1, 7037, '\P{Is_Scx=bali}', "");
    Expect(0, 7037, '\P{^Is_Scx=bali}', "");
    Expect(1, 7036, '\p{Is_Scx=_	Bali}', "");
    Expect(0, 7036, '\p{^Is_Scx=_	Bali}', "");
    Expect(0, 7036, '\P{Is_Scx=_	Bali}', "");
    Expect(1, 7036, '\P{^Is_Scx=_	Bali}', "");
    Expect(0, 7037, '\p{Is_Scx=_	Bali}', "");
    Expect(1, 7037, '\p{^Is_Scx=_	Bali}', "");
    Expect(1, 7037, '\P{Is_Scx=_	Bali}', "");
    Expect(0, 7037, '\P{^Is_Scx=_	Bali}', "");
    Error('\p{Script_Extensions=:= 	Bamum}');
    Error('\P{Script_Extensions=:= 	Bamum}');
    Expect(1, 92728, '\p{Script_Extensions=:\ABamum\z:}', "");;
    Expect(0, 92729, '\p{Script_Extensions=:\ABamum\z:}', "");;
    Expect(1, 92728, '\p{Script_Extensions=bamum}', "");
    Expect(0, 92728, '\p{^Script_Extensions=bamum}', "");
    Expect(0, 92728, '\P{Script_Extensions=bamum}', "");
    Expect(1, 92728, '\P{^Script_Extensions=bamum}', "");
    Expect(0, 92729, '\p{Script_Extensions=bamum}', "");
    Expect(1, 92729, '\p{^Script_Extensions=bamum}', "");
    Expect(1, 92729, '\P{Script_Extensions=bamum}', "");
    Expect(0, 92729, '\P{^Script_Extensions=bamum}', "");
    Expect(1, 92728, '\p{Script_Extensions=:\Abamum\z:}', "");;
    Expect(0, 92729, '\p{Script_Extensions=:\Abamum\z:}', "");;
    Expect(1, 92728, '\p{Script_Extensions= bamum}', "");
    Expect(0, 92728, '\p{^Script_Extensions= bamum}', "");
    Expect(0, 92728, '\P{Script_Extensions= bamum}', "");
    Expect(1, 92728, '\P{^Script_Extensions= bamum}', "");
    Expect(0, 92729, '\p{Script_Extensions= bamum}', "");
    Expect(1, 92729, '\p{^Script_Extensions= bamum}', "");
    Expect(1, 92729, '\P{Script_Extensions= bamum}', "");
    Expect(0, 92729, '\P{^Script_Extensions= bamum}', "");
    Error('\p{Scx=_ Bamu/a/}');
    Error('\P{Scx=_ Bamu/a/}');
    Expect(1, 92728, '\p{Scx=:\ABamu\z:}', "");;
    Expect(0, 92729, '\p{Scx=:\ABamu\z:}', "");;
    Expect(1, 92728, '\p{Scx=bamu}', "");
    Expect(0, 92728, '\p{^Scx=bamu}', "");
    Expect(0, 92728, '\P{Scx=bamu}', "");
    Expect(1, 92728, '\P{^Scx=bamu}', "");
    Expect(0, 92729, '\p{Scx=bamu}', "");
    Expect(1, 92729, '\p{^Scx=bamu}', "");
    Expect(1, 92729, '\P{Scx=bamu}', "");
    Expect(0, 92729, '\P{^Scx=bamu}', "");
    Expect(1, 92728, '\p{Scx=:\Abamu\z:}', "");;
    Expect(0, 92729, '\p{Scx=:\Abamu\z:}', "");;
    Expect(1, 92728, '\p{Scx=-Bamu}', "");
    Expect(0, 92728, '\p{^Scx=-Bamu}', "");
    Expect(0, 92728, '\P{Scx=-Bamu}', "");
    Expect(1, 92728, '\P{^Scx=-Bamu}', "");
    Expect(0, 92729, '\p{Scx=-Bamu}', "");
    Expect(1, 92729, '\p{^Scx=-Bamu}', "");
    Expect(1, 92729, '\P{Scx=-Bamu}', "");
    Expect(0, 92729, '\P{^Scx=-Bamu}', "");
    Error('\p{Is_Script_Extensions=-:=Bamum}');
    Error('\P{Is_Script_Extensions=-:=Bamum}');
    Expect(1, 92728, '\p{Is_Script_Extensions=bamum}', "");
    Expect(0, 92728, '\p{^Is_Script_Extensions=bamum}', "");
    Expect(0, 92728, '\P{Is_Script_Extensions=bamum}', "");
    Expect(1, 92728, '\P{^Is_Script_Extensions=bamum}', "");
    Expect(0, 92729, '\p{Is_Script_Extensions=bamum}', "");
    Expect(1, 92729, '\p{^Is_Script_Extensions=bamum}', "");
    Expect(1, 92729, '\P{Is_Script_Extensions=bamum}', "");
    Expect(0, 92729, '\P{^Is_Script_Extensions=bamum}', "");
    Expect(1, 92728, '\p{Is_Script_Extensions=		bamum}', "");
    Expect(0, 92728, '\p{^Is_Script_Extensions=		bamum}', "");
    Expect(0, 92728, '\P{Is_Script_Extensions=		bamum}', "");
    Expect(1, 92728, '\P{^Is_Script_Extensions=		bamum}', "");
    Expect(0, 92729, '\p{Is_Script_Extensions=		bamum}', "");
    Expect(1, 92729, '\p{^Is_Script_Extensions=		bamum}', "");
    Expect(1, 92729, '\P{Is_Script_Extensions=		bamum}', "");
    Expect(0, 92729, '\P{^Is_Script_Extensions=		bamum}', "");
    Error('\p{Is_Scx=_ BAMU:=}');
    Error('\P{Is_Scx=_ BAMU:=}');
    Expect(1, 92728, '\p{Is_Scx:bamu}', "");
    Expect(0, 92728, '\p{^Is_Scx:bamu}', "");
    Expect(0, 92728, '\P{Is_Scx:bamu}', "");
    Expect(1, 92728, '\P{^Is_Scx:bamu}', "");
    Expect(0, 92729, '\p{Is_Scx:bamu}', "");
    Expect(1, 92729, '\p{^Is_Scx:bamu}', "");
    Expect(1, 92729, '\P{Is_Scx:bamu}', "");
    Expect(0, 92729, '\P{^Is_Scx:bamu}', "");
    Expect(1, 92728, '\p{Is_Scx=--Bamu}', "");
    Expect(0, 92728, '\p{^Is_Scx=--Bamu}', "");
    Expect(0, 92728, '\P{Is_Scx=--Bamu}', "");
    Expect(1, 92728, '\P{^Is_Scx=--Bamu}', "");
    Expect(0, 92729, '\p{Is_Scx=--Bamu}', "");
    Expect(1, 92729, '\p{^Is_Scx=--Bamu}', "");
    Expect(1, 92729, '\P{Is_Scx=--Bamu}', "");
    Expect(0, 92729, '\P{^Is_Scx=--Bamu}', "");
    Error('\p{Script_Extensions=:=	Bassa_Vah}');
    Error('\P{Script_Extensions=:=	Bassa_Vah}');
    Expect(1, 92917, '\p{Script_Extensions=:\ABassa_Vah\z:}', "");;
    Expect(0, 92918, '\p{Script_Extensions=:\ABassa_Vah\z:}', "");;
    Expect(1, 92917, '\p{Script_Extensions:	bassavah}', "");
    Expect(0, 92917, '\p{^Script_Extensions:	bassavah}', "");
    Expect(0, 92917, '\P{Script_Extensions:	bassavah}', "");
    Expect(1, 92917, '\P{^Script_Extensions:	bassavah}', "");
    Expect(0, 92918, '\p{Script_Extensions:	bassavah}', "");
    Expect(1, 92918, '\p{^Script_Extensions:	bassavah}', "");
    Expect(1, 92918, '\P{Script_Extensions:	bassavah}', "");
    Expect(0, 92918, '\P{^Script_Extensions:	bassavah}', "");
    Expect(1, 92917, '\p{Script_Extensions=:\Abassavah\z:}', "");;
    Expect(0, 92918, '\p{Script_Extensions=:\Abassavah\z:}', "");;
    Expect(1, 92917, '\p{Script_Extensions=--bassa_vah}', "");
    Expect(0, 92917, '\p{^Script_Extensions=--bassa_vah}', "");
    Expect(0, 92917, '\P{Script_Extensions=--bassa_vah}', "");
    Expect(1, 92917, '\P{^Script_Extensions=--bassa_vah}', "");
    Expect(0, 92918, '\p{Script_Extensions=--bassa_vah}', "");
    Expect(1, 92918, '\p{^Script_Extensions=--bassa_vah}', "");
    Expect(1, 92918, '\P{Script_Extensions=--bassa_vah}', "");
    Expect(0, 92918, '\P{^Script_Extensions=--bassa_vah}', "");
    Error('\p{Scx=/a/ _Bass}');
    Error('\P{Scx=/a/ _Bass}');
    Expect(1, 92917, '\p{Scx=:\ABass\z:}', "");;
    Expect(0, 92918, '\p{Scx=:\ABass\z:}', "");;
    Expect(1, 92917, '\p{Scx=bass}', "");
    Expect(0, 92917, '\p{^Scx=bass}', "");
    Expect(0, 92917, '\P{Scx=bass}', "");
    Expect(1, 92917, '\P{^Scx=bass}', "");
    Expect(0, 92918, '\p{Scx=bass}', "");
    Expect(1, 92918, '\p{^Scx=bass}', "");
    Expect(1, 92918, '\P{Scx=bass}', "");
    Expect(0, 92918, '\P{^Scx=bass}', "");
    Expect(1, 92917, '\p{Scx=:\Abass\z:}', "");;
    Expect(0, 92918, '\p{Scx=:\Abass\z:}', "");;
    Expect(1, 92917, '\p{Scx=		BASS}', "");
    Expect(0, 92917, '\p{^Scx=		BASS}', "");
    Expect(0, 92917, '\P{Scx=		BASS}', "");
    Expect(1, 92917, '\P{^Scx=		BASS}', "");
    Expect(0, 92918, '\p{Scx=		BASS}', "");
    Expect(1, 92918, '\p{^Scx=		BASS}', "");
    Expect(1, 92918, '\P{Scx=		BASS}', "");
    Expect(0, 92918, '\P{^Scx=		BASS}', "");
    Error('\p{Is_Script_Extensions= /a/Bassa_vah}');
    Error('\P{Is_Script_Extensions= /a/Bassa_vah}');
    Expect(1, 92917, '\p{Is_Script_Extensions:	bassavah}', "");
    Expect(0, 92917, '\p{^Is_Script_Extensions:	bassavah}', "");
    Expect(0, 92917, '\P{Is_Script_Extensions:	bassavah}', "");
    Expect(1, 92917, '\P{^Is_Script_Extensions:	bassavah}', "");
    Expect(0, 92918, '\p{Is_Script_Extensions:	bassavah}', "");
    Expect(1, 92918, '\p{^Is_Script_Extensions:	bassavah}', "");
    Expect(1, 92918, '\P{Is_Script_Extensions:	bassavah}', "");
    Expect(0, 92918, '\P{^Is_Script_Extensions:	bassavah}', "");
    Expect(1, 92917, '\p{Is_Script_Extensions=	-Bassa_Vah}', "");
    Expect(0, 92917, '\p{^Is_Script_Extensions=	-Bassa_Vah}', "");
    Expect(0, 92917, '\P{Is_Script_Extensions=	-Bassa_Vah}', "");
    Expect(1, 92917, '\P{^Is_Script_Extensions=	-Bassa_Vah}', "");
    Expect(0, 92918, '\p{Is_Script_Extensions=	-Bassa_Vah}', "");
    Expect(1, 92918, '\p{^Is_Script_Extensions=	-Bassa_Vah}', "");
    Expect(1, 92918, '\P{Is_Script_Extensions=	-Bassa_Vah}', "");
    Expect(0, 92918, '\P{^Is_Script_Extensions=	-Bassa_Vah}', "");
    Error('\p{Is_Scx=:=_Bass}');
    Error('\P{Is_Scx=:=_Bass}');
    Expect(1, 92917, '\p{Is_Scx=bass}', "");
    Expect(0, 92917, '\p{^Is_Scx=bass}', "");
    Expect(0, 92917, '\P{Is_Scx=bass}', "");
    Expect(1, 92917, '\P{^Is_Scx=bass}', "");
    Expect(0, 92918, '\p{Is_Scx=bass}', "");
    Expect(1, 92918, '\p{^Is_Scx=bass}', "");
    Expect(1, 92918, '\P{Is_Scx=bass}', "");
    Expect(0, 92918, '\P{^Is_Scx=bass}', "");
    Expect(1, 92917, '\p{Is_Scx= -bass}', "");
    Expect(0, 92917, '\p{^Is_Scx= -bass}', "");
    Expect(0, 92917, '\P{Is_Scx= -bass}', "");
    Expect(1, 92917, '\P{^Is_Scx= -bass}', "");
    Expect(0, 92918, '\p{Is_Scx= -bass}', "");
    Expect(1, 92918, '\p{^Is_Scx= -bass}', "");
    Expect(1, 92918, '\P{Is_Scx= -bass}', "");
    Expect(0, 92918, '\P{^Is_Scx= -bass}', "");
    Error('\p{Script_Extensions= _BATAK/a/}');
    Error('\P{Script_Extensions= _BATAK/a/}');
    Expect(1, 7167, '\p{Script_Extensions=:\ABatak\z:}', "");;
    Expect(0, 7168, '\p{Script_Extensions=:\ABatak\z:}', "");;
    Expect(1, 7167, '\p{Script_Extensions=batak}', "");
    Expect(0, 7167, '\p{^Script_Extensions=batak}', "");
    Expect(0, 7167, '\P{Script_Extensions=batak}', "");
    Expect(1, 7167, '\P{^Script_Extensions=batak}', "");
    Expect(0, 7168, '\p{Script_Extensions=batak}', "");
    Expect(1, 7168, '\p{^Script_Extensions=batak}', "");
    Expect(1, 7168, '\P{Script_Extensions=batak}', "");
    Expect(0, 7168, '\P{^Script_Extensions=batak}', "");
    Expect(1, 7167, '\p{Script_Extensions=:\Abatak\z:}', "");;
    Expect(0, 7168, '\p{Script_Extensions=:\Abatak\z:}', "");;
    Expect(1, 7167, '\p{Script_Extensions= batak}', "");
    Expect(0, 7167, '\p{^Script_Extensions= batak}', "");
    Expect(0, 7167, '\P{Script_Extensions= batak}', "");
    Expect(1, 7167, '\P{^Script_Extensions= batak}', "");
    Expect(0, 7168, '\p{Script_Extensions= batak}', "");
    Expect(1, 7168, '\p{^Script_Extensions= batak}', "");
    Expect(1, 7168, '\P{Script_Extensions= batak}', "");
    Expect(0, 7168, '\P{^Script_Extensions= batak}', "");
    Error('\p{Scx:   -:=batk}');
    Error('\P{Scx:   -:=batk}');
    Expect(1, 7167, '\p{Scx=:\ABatk\z:}', "");;
    Expect(0, 7168, '\p{Scx=:\ABatk\z:}', "");;
    Expect(1, 7167, '\p{Scx=batk}', "");
    Expect(0, 7167, '\p{^Scx=batk}', "");
    Expect(0, 7167, '\P{Scx=batk}', "");
    Expect(1, 7167, '\P{^Scx=batk}', "");
    Expect(0, 7168, '\p{Scx=batk}', "");
    Expect(1, 7168, '\p{^Scx=batk}', "");
    Expect(1, 7168, '\P{Scx=batk}', "");
    Expect(0, 7168, '\P{^Scx=batk}', "");
    Expect(1, 7167, '\p{Scx=:\Abatk\z:}', "");;
    Expect(0, 7168, '\p{Scx=:\Abatk\z:}', "");;
    Expect(1, 7167, '\p{Scx=	batk}', "");
    Expect(0, 7167, '\p{^Scx=	batk}', "");
    Expect(0, 7167, '\P{Scx=	batk}', "");
    Expect(1, 7167, '\P{^Scx=	batk}', "");
    Expect(0, 7168, '\p{Scx=	batk}', "");
    Expect(1, 7168, '\p{^Scx=	batk}', "");
    Expect(1, 7168, '\P{Scx=	batk}', "");
    Expect(0, 7168, '\P{^Scx=	batk}', "");
    Error('\p{Is_Script_Extensions=- BATAK/a/}');
    Error('\P{Is_Script_Extensions=- BATAK/a/}');
    Expect(1, 7167, '\p{Is_Script_Extensions=batak}', "");
    Expect(0, 7167, '\p{^Is_Script_Extensions=batak}', "");
    Expect(0, 7167, '\P{Is_Script_Extensions=batak}', "");
    Expect(1, 7167, '\P{^Is_Script_Extensions=batak}', "");
    Expect(0, 7168, '\p{Is_Script_Extensions=batak}', "");
    Expect(1, 7168, '\p{^Is_Script_Extensions=batak}', "");
    Expect(1, 7168, '\P{Is_Script_Extensions=batak}', "");
    Expect(0, 7168, '\P{^Is_Script_Extensions=batak}', "");
    Expect(1, 7167, '\p{Is_Script_Extensions=Batak}', "");
    Expect(0, 7167, '\p{^Is_Script_Extensions=Batak}', "");
    Expect(0, 7167, '\P{Is_Script_Extensions=Batak}', "");
    Expect(1, 7167, '\P{^Is_Script_Extensions=Batak}', "");
    Expect(0, 7168, '\p{Is_Script_Extensions=Batak}', "");
    Expect(1, 7168, '\p{^Is_Script_Extensions=Batak}', "");
    Expect(1, 7168, '\P{Is_Script_Extensions=Batak}', "");
    Expect(0, 7168, '\P{^Is_Script_Extensions=Batak}', "");
    Error('\p{Is_Scx: :=Batk}');
    Error('\P{Is_Scx: :=Batk}');
    Expect(1, 7167, '\p{Is_Scx=batk}', "");
    Expect(0, 7167, '\p{^Is_Scx=batk}', "");
    Expect(0, 7167, '\P{Is_Scx=batk}', "");
    Expect(1, 7167, '\P{^Is_Scx=batk}', "");
    Expect(0, 7168, '\p{Is_Scx=batk}', "");
    Expect(1, 7168, '\p{^Is_Scx=batk}', "");
    Expect(1, 7168, '\P{Is_Scx=batk}', "");
    Expect(0, 7168, '\P{^Is_Scx=batk}', "");
    Expect(1, 7167, '\p{Is_Scx=Batk}', "");
    Expect(0, 7167, '\p{^Is_Scx=Batk}', "");
    Expect(0, 7167, '\P{Is_Scx=Batk}', "");
    Expect(1, 7167, '\P{^Is_Scx=Batk}', "");
    Expect(0, 7168, '\p{Is_Scx=Batk}', "");
    Expect(1, 7168, '\p{^Is_Scx=Batk}', "");
    Expect(1, 7168, '\P{Is_Scx=Batk}', "");
    Expect(0, 7168, '\P{^Is_Scx=Batk}', "");
    Error('\p{Script_Extensions=-/a/bengali}');
    Error('\P{Script_Extensions=-/a/bengali}');
    Expect(1, 43249, '\p{Script_Extensions=:\ABengali\z:}', "");;
    Expect(0, 43250, '\p{Script_Extensions=:\ABengali\z:}', "");;
    Expect(1, 43249, '\p{Script_Extensions=bengali}', "");
    Expect(0, 43249, '\p{^Script_Extensions=bengali}', "");
    Expect(0, 43249, '\P{Script_Extensions=bengali}', "");
    Expect(1, 43249, '\P{^Script_Extensions=bengali}', "");
    Expect(0, 43250, '\p{Script_Extensions=bengali}', "");
    Expect(1, 43250, '\p{^Script_Extensions=bengali}', "");
    Expect(1, 43250, '\P{Script_Extensions=bengali}', "");
    Expect(0, 43250, '\P{^Script_Extensions=bengali}', "");
    Expect(1, 43249, '\p{Script_Extensions=:\Abengali\z:}', "");;
    Expect(0, 43250, '\p{Script_Extensions=:\Abengali\z:}', "");;
    Expect(1, 43249, '\p{Script_Extensions=	 Bengali}', "");
    Expect(0, 43249, '\p{^Script_Extensions=	 Bengali}', "");
    Expect(0, 43249, '\P{Script_Extensions=	 Bengali}', "");
    Expect(1, 43249, '\P{^Script_Extensions=	 Bengali}', "");
    Expect(0, 43250, '\p{Script_Extensions=	 Bengali}', "");
    Expect(1, 43250, '\p{^Script_Extensions=	 Bengali}', "");
    Expect(1, 43250, '\P{Script_Extensions=	 Bengali}', "");
    Expect(0, 43250, '\P{^Script_Extensions=	 Bengali}', "");
    Error('\p{Scx=:=_ Beng}');
    Error('\P{Scx=:=_ Beng}');
    Expect(1, 43249, '\p{Scx=:\ABeng\z:}', "");;
    Expect(0, 43250, '\p{Scx=:\ABeng\z:}', "");;
    Expect(1, 43249, '\p{Scx=beng}', "");
    Expect(0, 43249, '\p{^Scx=beng}', "");
    Expect(0, 43249, '\P{Scx=beng}', "");
    Expect(1, 43249, '\P{^Scx=beng}', "");
    Expect(0, 43250, '\p{Scx=beng}', "");
    Expect(1, 43250, '\p{^Scx=beng}', "");
    Expect(1, 43250, '\P{Scx=beng}', "");
    Expect(0, 43250, '\P{^Scx=beng}', "");
    Expect(1, 43249, '\p{Scx=:\Abeng\z:}', "");;
    Expect(0, 43250, '\p{Scx=:\Abeng\z:}', "");;
    Expect(1, 43249, '\p{Scx:  Beng}', "");
    Expect(0, 43249, '\p{^Scx:  Beng}', "");
    Expect(0, 43249, '\P{Scx:  Beng}', "");
    Expect(1, 43249, '\P{^Scx:  Beng}', "");
    Expect(0, 43250, '\p{Scx:  Beng}', "");
    Expect(1, 43250, '\p{^Scx:  Beng}', "");
    Expect(1, 43250, '\P{Scx:  Beng}', "");
    Expect(0, 43250, '\P{^Scx:  Beng}', "");
    Error('\p{Is_Script_Extensions:	_/a/Bengali}');
    Error('\P{Is_Script_Extensions:	_/a/Bengali}');
    Expect(1, 43249, '\p{Is_Script_Extensions: bengali}', "");
    Expect(0, 43249, '\p{^Is_Script_Extensions: bengali}', "");
    Expect(0, 43249, '\P{Is_Script_Extensions: bengali}', "");
    Expect(1, 43249, '\P{^Is_Script_Extensions: bengali}', "");
    Expect(0, 43250, '\p{Is_Script_Extensions: bengali}', "");
    Expect(1, 43250, '\p{^Is_Script_Extensions: bengali}', "");
    Expect(1, 43250, '\P{Is_Script_Extensions: bengali}', "");
    Expect(0, 43250, '\P{^Is_Script_Extensions: bengali}', "");
    Expect(1, 43249, '\p{Is_Script_Extensions= Bengali}', "");
    Expect(0, 43249, '\p{^Is_Script_Extensions= Bengali}', "");
    Expect(0, 43249, '\P{Is_Script_Extensions= Bengali}', "");
    Expect(1, 43249, '\P{^Is_Script_Extensions= Bengali}', "");
    Expect(0, 43250, '\p{Is_Script_Extensions= Bengali}', "");
    Expect(1, 43250, '\p{^Is_Script_Extensions= Bengali}', "");
    Expect(1, 43250, '\P{Is_Script_Extensions= Bengali}', "");
    Expect(0, 43250, '\P{^Is_Script_Extensions= Bengali}', "");
    Error('\p{Is_Scx=--Beng:=}');
    Error('\P{Is_Scx=--Beng:=}');
    Expect(1, 43249, '\p{Is_Scx=beng}', "");
    Expect(0, 43249, '\p{^Is_Scx=beng}', "");
    Expect(0, 43249, '\P{Is_Scx=beng}', "");
    Expect(1, 43249, '\P{^Is_Scx=beng}', "");
    Expect(0, 43250, '\p{Is_Scx=beng}', "");
    Expect(1, 43250, '\p{^Is_Scx=beng}', "");
    Expect(1, 43250, '\P{Is_Scx=beng}', "");
    Expect(0, 43250, '\P{^Is_Scx=beng}', "");
    Expect(1, 43249, '\p{Is_Scx=-Beng}', "");
    Expect(0, 43249, '\p{^Is_Scx=-Beng}', "");
    Expect(0, 43249, '\P{Is_Scx=-Beng}', "");
    Expect(1, 43249, '\P{^Is_Scx=-Beng}', "");
    Expect(0, 43250, '\p{Is_Scx=-Beng}', "");
    Expect(1, 43250, '\p{^Is_Scx=-Beng}', "");
    Expect(1, 43250, '\P{Is_Scx=-Beng}', "");
    Expect(0, 43250, '\P{^Is_Scx=-Beng}', "");
    Error('\p{Script_Extensions=- Bhaiksuki:=}');
    Error('\P{Script_Extensions=- Bhaiksuki:=}');
    Expect(1, 72812, '\p{Script_Extensions=:\ABhaiksuki\z:}', "");;
    Expect(0, 72813, '\p{Script_Extensions=:\ABhaiksuki\z:}', "");;
    Expect(1, 72812, '\p{Script_Extensions=bhaiksuki}', "");
    Expect(0, 72812, '\p{^Script_Extensions=bhaiksuki}', "");
    Expect(0, 72812, '\P{Script_Extensions=bhaiksuki}', "");
    Expect(1, 72812, '\P{^Script_Extensions=bhaiksuki}', "");
    Expect(0, 72813, '\p{Script_Extensions=bhaiksuki}', "");
    Expect(1, 72813, '\p{^Script_Extensions=bhaiksuki}', "");
    Expect(1, 72813, '\P{Script_Extensions=bhaiksuki}', "");
    Expect(0, 72813, '\P{^Script_Extensions=bhaiksuki}', "");
    Expect(1, 72812, '\p{Script_Extensions=:\Abhaiksuki\z:}', "");;
    Expect(0, 72813, '\p{Script_Extensions=:\Abhaiksuki\z:}', "");;
    Error('\p{Scx= :=BHKS}');
    Error('\P{Scx= :=BHKS}');
    Expect(1, 72812, '\p{Scx=:\ABhks\z:}', "");;
    Expect(0, 72813, '\p{Scx=:\ABhks\z:}', "");;
    Expect(1, 72812, '\p{Scx:   bhks}', "");
    Expect(0, 72812, '\p{^Scx:   bhks}', "");
    Expect(0, 72812, '\P{Scx:   bhks}', "");
    Expect(1, 72812, '\P{^Scx:   bhks}', "");
    Expect(0, 72813, '\p{Scx:   bhks}', "");
    Expect(1, 72813, '\p{^Scx:   bhks}', "");
    Expect(1, 72813, '\P{Scx:   bhks}', "");
    Expect(0, 72813, '\P{^Scx:   bhks}', "");
    Expect(1, 72812, '\p{Scx=:\Abhks\z:}', "");;
    Expect(0, 72813, '\p{Scx=:\Abhks\z:}', "");;
    Expect(1, 72812, '\p{Scx=_Bhks}', "");
    Expect(0, 72812, '\p{^Scx=_Bhks}', "");
    Expect(0, 72812, '\P{Scx=_Bhks}', "");
    Expect(1, 72812, '\P{^Scx=_Bhks}', "");
    Expect(0, 72813, '\p{Scx=_Bhks}', "");
    Expect(1, 72813, '\p{^Scx=_Bhks}', "");
    Expect(1, 72813, '\P{Scx=_Bhks}', "");
    Expect(0, 72813, '\P{^Scx=_Bhks}', "");
    Error('\p{Is_Script_Extensions=	 BHAIKSUKI:=}');
    Error('\P{Is_Script_Extensions=	 BHAIKSUKI:=}');
    Expect(1, 72812, '\p{Is_Script_Extensions=bhaiksuki}', "");
    Expect(0, 72812, '\p{^Is_Script_Extensions=bhaiksuki}', "");
    Expect(0, 72812, '\P{Is_Script_Extensions=bhaiksuki}', "");
    Expect(1, 72812, '\P{^Is_Script_Extensions=bhaiksuki}', "");
    Expect(0, 72813, '\p{Is_Script_Extensions=bhaiksuki}', "");
    Expect(1, 72813, '\p{^Is_Script_Extensions=bhaiksuki}', "");
    Expect(1, 72813, '\P{Is_Script_Extensions=bhaiksuki}', "");
    Expect(0, 72813, '\P{^Is_Script_Extensions=bhaiksuki}', "");
    Expect(1, 72812, '\p{Is_Script_Extensions=	Bhaiksuki}', "");
    Expect(0, 72812, '\p{^Is_Script_Extensions=	Bhaiksuki}', "");
    Expect(0, 72812, '\P{Is_Script_Extensions=	Bhaiksuki}', "");
    Expect(1, 72812, '\P{^Is_Script_Extensions=	Bhaiksuki}', "");
    Expect(0, 72813, '\p{Is_Script_Extensions=	Bhaiksuki}', "");
    Expect(1, 72813, '\p{^Is_Script_Extensions=	Bhaiksuki}', "");
    Expect(1, 72813, '\P{Is_Script_Extensions=	Bhaiksuki}', "");
    Expect(0, 72813, '\P{^Is_Script_Extensions=	Bhaiksuki}', "");
    Error('\p{Is_Scx: _:=BHKS}');
    Error('\P{Is_Scx: _:=BHKS}');
    Expect(1, 72812, '\p{Is_Scx=bhks}', "");
    Expect(0, 72812, '\p{^Is_Scx=bhks}', "");
    Expect(0, 72812, '\P{Is_Scx=bhks}', "");
    Expect(1, 72812, '\P{^Is_Scx=bhks}', "");
    Expect(0, 72813, '\p{Is_Scx=bhks}', "");
    Expect(1, 72813, '\p{^Is_Scx=bhks}', "");
    Expect(1, 72813, '\P{Is_Scx=bhks}', "");
    Expect(0, 72813, '\P{^Is_Scx=bhks}', "");
    Expect(1, 72812, '\p{Is_Scx=_	BHKS}', "");
    Expect(0, 72812, '\p{^Is_Scx=_	BHKS}', "");
    Expect(0, 72812, '\P{Is_Scx=_	BHKS}', "");
    Expect(1, 72812, '\P{^Is_Scx=_	BHKS}', "");
    Expect(0, 72813, '\p{Is_Scx=_	BHKS}', "");
    Expect(1, 72813, '\p{^Is_Scx=_	BHKS}', "");
    Expect(1, 72813, '\P{Is_Scx=_	BHKS}', "");
    Expect(0, 72813, '\P{^Is_Scx=_	BHKS}', "");
    Error('\p{Script_Extensions= BOPOMOFO:=}');
    Error('\P{Script_Extensions= BOPOMOFO:=}');
    Expect(1, 65381, '\p{Script_Extensions=:\ABopomofo\z:}', "");;
    Expect(0, 65382, '\p{Script_Extensions=:\ABopomofo\z:}', "");;
    Expect(1, 65381, '\p{Script_Extensions=bopomofo}', "");
    Expect(0, 65381, '\p{^Script_Extensions=bopomofo}', "");
    Expect(0, 65381, '\P{Script_Extensions=bopomofo}', "");
    Expect(1, 65381, '\P{^Script_Extensions=bopomofo}', "");
    Expect(0, 65382, '\p{Script_Extensions=bopomofo}', "");
    Expect(1, 65382, '\p{^Script_Extensions=bopomofo}', "");
    Expect(1, 65382, '\P{Script_Extensions=bopomofo}', "");
    Expect(0, 65382, '\P{^Script_Extensions=bopomofo}', "");
    Expect(1, 65381, '\p{Script_Extensions=:\Abopomofo\z:}', "");;
    Expect(0, 65382, '\p{Script_Extensions=:\Abopomofo\z:}', "");;
    Expect(1, 65381, '\p{Script_Extensions=		BOPOMOFO}', "");
    Expect(0, 65381, '\p{^Script_Extensions=		BOPOMOFO}', "");
    Expect(0, 65381, '\P{Script_Extensions=		BOPOMOFO}', "");
    Expect(1, 65381, '\P{^Script_Extensions=		BOPOMOFO}', "");
    Expect(0, 65382, '\p{Script_Extensions=		BOPOMOFO}', "");
    Expect(1, 65382, '\p{^Script_Extensions=		BOPOMOFO}', "");
    Expect(1, 65382, '\P{Script_Extensions=		BOPOMOFO}', "");
    Expect(0, 65382, '\P{^Script_Extensions=		BOPOMOFO}', "");
    Error('\p{Scx=/a/ -Bopo}');
    Error('\P{Scx=/a/ -Bopo}');
    Expect(1, 65381, '\p{Scx=:\ABopo\z:}', "");;
    Expect(0, 65382, '\p{Scx=:\ABopo\z:}', "");;
    Expect(1, 65381, '\p{Scx=bopo}', "");
    Expect(0, 65381, '\p{^Scx=bopo}', "");
    Expect(0, 65381, '\P{Scx=bopo}', "");
    Expect(1, 65381, '\P{^Scx=bopo}', "");
    Expect(0, 65382, '\p{Scx=bopo}', "");
    Expect(1, 65382, '\p{^Scx=bopo}', "");
    Expect(1, 65382, '\P{Scx=bopo}', "");
    Expect(0, 65382, '\P{^Scx=bopo}', "");
    Expect(1, 65381, '\p{Scx=:\Abopo\z:}', "");;
    Expect(0, 65382, '\p{Scx=:\Abopo\z:}', "");;
    Expect(1, 65381, '\p{Scx= -bopo}', "");
    Expect(0, 65381, '\p{^Scx= -bopo}', "");
    Expect(0, 65381, '\P{Scx= -bopo}', "");
    Expect(1, 65381, '\P{^Scx= -bopo}', "");
    Expect(0, 65382, '\p{Scx= -bopo}', "");
    Expect(1, 65382, '\p{^Scx= -bopo}', "");
    Expect(1, 65382, '\P{Scx= -bopo}', "");
    Expect(0, 65382, '\P{^Scx= -bopo}', "");
    Error('\p{Is_Script_Extensions=_:=bopomofo}');
    Error('\P{Is_Script_Extensions=_:=bopomofo}');
    Expect(1, 65381, '\p{Is_Script_Extensions: bopomofo}', "");
    Expect(0, 65381, '\p{^Is_Script_Extensions: bopomofo}', "");
    Expect(0, 65381, '\P{Is_Script_Extensions: bopomofo}', "");
    Expect(1, 65381, '\P{^Is_Script_Extensions: bopomofo}', "");
    Expect(0, 65382, '\p{Is_Script_Extensions: bopomofo}', "");
    Expect(1, 65382, '\p{^Is_Script_Extensions: bopomofo}', "");
    Expect(1, 65382, '\P{Is_Script_Extensions: bopomofo}', "");
    Expect(0, 65382, '\P{^Is_Script_Extensions: bopomofo}', "");
    Expect(1, 65381, '\p{Is_Script_Extensions=	 Bopomofo}', "");
    Expect(0, 65381, '\p{^Is_Script_Extensions=	 Bopomofo}', "");
    Expect(0, 65381, '\P{Is_Script_Extensions=	 Bopomofo}', "");
    Expect(1, 65381, '\P{^Is_Script_Extensions=	 Bopomofo}', "");
    Expect(0, 65382, '\p{Is_Script_Extensions=	 Bopomofo}', "");
    Expect(1, 65382, '\p{^Is_Script_Extensions=	 Bopomofo}', "");
    Expect(1, 65382, '\P{Is_Script_Extensions=	 Bopomofo}', "");
    Expect(0, 65382, '\P{^Is_Script_Extensions=	 Bopomofo}', "");
    Error('\p{Is_Scx=:=-BOPO}');
    Error('\P{Is_Scx=:=-BOPO}');
    Expect(1, 65381, '\p{Is_Scx=bopo}', "");
    Expect(0, 65381, '\p{^Is_Scx=bopo}', "");
    Expect(0, 65381, '\P{Is_Scx=bopo}', "");
    Expect(1, 65381, '\P{^Is_Scx=bopo}', "");
    Expect(0, 65382, '\p{Is_Scx=bopo}', "");
    Expect(1, 65382, '\p{^Is_Scx=bopo}', "");
    Expect(1, 65382, '\P{Is_Scx=bopo}', "");
    Expect(0, 65382, '\P{^Is_Scx=bopo}', "");
    Expect(1, 65381, '\p{Is_Scx:		_Bopo}', "");
    Expect(0, 65381, '\p{^Is_Scx:		_Bopo}', "");
    Expect(0, 65381, '\P{Is_Scx:		_Bopo}', "");
    Expect(1, 65381, '\P{^Is_Scx:		_Bopo}', "");
    Expect(0, 65382, '\p{Is_Scx:		_Bopo}', "");
    Expect(1, 65382, '\p{^Is_Scx:		_Bopo}', "");
    Expect(1, 65382, '\P{Is_Scx:		_Bopo}', "");
    Expect(0, 65382, '\P{^Is_Scx:		_Bopo}', "");
    Error('\p{Script_Extensions=		BRAHMI/a/}');
    Error('\P{Script_Extensions=		BRAHMI/a/}');
    Expect(1, 69759, '\p{Script_Extensions=:\ABrahmi\z:}', "");;
    Expect(0, 69760, '\p{Script_Extensions=:\ABrahmi\z:}', "");;
    Expect(1, 69759, '\p{Script_Extensions=brahmi}', "");
    Expect(0, 69759, '\p{^Script_Extensions=brahmi}', "");
    Expect(0, 69759, '\P{Script_Extensions=brahmi}', "");
    Expect(1, 69759, '\P{^Script_Extensions=brahmi}', "");
    Expect(0, 69760, '\p{Script_Extensions=brahmi}', "");
    Expect(1, 69760, '\p{^Script_Extensions=brahmi}', "");
    Expect(1, 69760, '\P{Script_Extensions=brahmi}', "");
    Expect(0, 69760, '\P{^Script_Extensions=brahmi}', "");
    Expect(1, 69759, '\p{Script_Extensions=:\Abrahmi\z:}', "");;
    Expect(0, 69760, '\p{Script_Extensions=:\Abrahmi\z:}', "");;
    Expect(1, 69759, '\p{Script_Extensions=-	BRAHMI}', "");
    Expect(0, 69759, '\p{^Script_Extensions=-	BRAHMI}', "");
    Expect(0, 69759, '\P{Script_Extensions=-	BRAHMI}', "");
    Expect(1, 69759, '\P{^Script_Extensions=-	BRAHMI}', "");
    Expect(0, 69760, '\p{Script_Extensions=-	BRAHMI}', "");
    Expect(1, 69760, '\p{^Script_Extensions=-	BRAHMI}', "");
    Expect(1, 69760, '\P{Script_Extensions=-	BRAHMI}', "");
    Expect(0, 69760, '\P{^Script_Extensions=-	BRAHMI}', "");
    Error('\p{Scx=:=-_Brah}');
    Error('\P{Scx=:=-_Brah}');
    Expect(1, 69759, '\p{Scx=:\ABrah\z:}', "");;
    Expect(0, 69760, '\p{Scx=:\ABrah\z:}', "");;
    Expect(1, 69759, '\p{Scx=brah}', "");
    Expect(0, 69759, '\p{^Scx=brah}', "");
    Expect(0, 69759, '\P{Scx=brah}', "");
    Expect(1, 69759, '\P{^Scx=brah}', "");
    Expect(0, 69760, '\p{Scx=brah}', "");
    Expect(1, 69760, '\p{^Scx=brah}', "");
    Expect(1, 69760, '\P{Scx=brah}', "");
    Expect(0, 69760, '\P{^Scx=brah}', "");
    Expect(1, 69759, '\p{Scx=:\Abrah\z:}', "");;
    Expect(0, 69760, '\p{Scx=:\Abrah\z:}', "");;
    Expect(1, 69759, '\p{Scx=__BRAH}', "");
    Expect(0, 69759, '\p{^Scx=__BRAH}', "");
    Expect(0, 69759, '\P{Scx=__BRAH}', "");
    Expect(1, 69759, '\P{^Scx=__BRAH}', "");
    Expect(0, 69760, '\p{Scx=__BRAH}', "");
    Expect(1, 69760, '\p{^Scx=__BRAH}', "");
    Expect(1, 69760, '\P{Scx=__BRAH}', "");
    Expect(0, 69760, '\P{^Scx=__BRAH}', "");
    Error('\p{Is_Script_Extensions:-:=Brahmi}');
    Error('\P{Is_Script_Extensions:-:=Brahmi}');
    Expect(1, 69759, '\p{Is_Script_Extensions=brahmi}', "");
    Expect(0, 69759, '\p{^Is_Script_Extensions=brahmi}', "");
    Expect(0, 69759, '\P{Is_Script_Extensions=brahmi}', "");
    Expect(1, 69759, '\P{^Is_Script_Extensions=brahmi}', "");
    Expect(0, 69760, '\p{Is_Script_Extensions=brahmi}', "");
    Expect(1, 69760, '\p{^Is_Script_Extensions=brahmi}', "");
    Expect(1, 69760, '\P{Is_Script_Extensions=brahmi}', "");
    Expect(0, 69760, '\P{^Is_Script_Extensions=brahmi}', "");
    Expect(1, 69759, '\p{Is_Script_Extensions= Brahmi}', "");
    Expect(0, 69759, '\p{^Is_Script_Extensions= Brahmi}', "");
    Expect(0, 69759, '\P{Is_Script_Extensions= Brahmi}', "");
    Expect(1, 69759, '\P{^Is_Script_Extensions= Brahmi}', "");
    Expect(0, 69760, '\p{Is_Script_Extensions= Brahmi}', "");
    Expect(1, 69760, '\p{^Is_Script_Extensions= Brahmi}', "");
    Expect(1, 69760, '\P{Is_Script_Extensions= Brahmi}', "");
    Expect(0, 69760, '\P{^Is_Script_Extensions= Brahmi}', "");
    Error('\p{Is_Scx=_	Brah/a/}');
    Error('\P{Is_Scx=_	Brah/a/}');
    Expect(1, 69759, '\p{Is_Scx=brah}', "");
    Expect(0, 69759, '\p{^Is_Scx=brah}', "");
    Expect(0, 69759, '\P{Is_Scx=brah}', "");
    Expect(1, 69759, '\P{^Is_Scx=brah}', "");
    Expect(0, 69760, '\p{Is_Scx=brah}', "");
    Expect(1, 69760, '\p{^Is_Scx=brah}', "");
    Expect(1, 69760, '\P{Is_Scx=brah}', "");
    Expect(0, 69760, '\P{^Is_Scx=brah}', "");
    Expect(1, 69759, '\p{Is_Scx=	 brah}', "");
    Expect(0, 69759, '\p{^Is_Scx=	 brah}', "");
    Expect(0, 69759, '\P{Is_Scx=	 brah}', "");
    Expect(1, 69759, '\P{^Is_Scx=	 brah}', "");
    Expect(0, 69760, '\p{Is_Scx=	 brah}', "");
    Expect(1, 69760, '\p{^Is_Scx=	 brah}', "");
    Expect(1, 69760, '\P{Is_Scx=	 brah}', "");
    Expect(0, 69760, '\P{^Is_Scx=	 brah}', "");
    Error('\p{Script_Extensions=-_Braille/a/}');
    Error('\P{Script_Extensions=-_Braille/a/}');
    Expect(1, 10495, '\p{Script_Extensions=:\ABraille\z:}', "");;
    Expect(0, 10496, '\p{Script_Extensions=:\ABraille\z:}', "");;
    Expect(1, 10495, '\p{Script_Extensions=braille}', "");
    Expect(0, 10495, '\p{^Script_Extensions=braille}', "");
    Expect(0, 10495, '\P{Script_Extensions=braille}', "");
    Expect(1, 10495, '\P{^Script_Extensions=braille}', "");
    Expect(0, 10496, '\p{Script_Extensions=braille}', "");
    Expect(1, 10496, '\p{^Script_Extensions=braille}', "");
    Expect(1, 10496, '\P{Script_Extensions=braille}', "");
    Expect(0, 10496, '\P{^Script_Extensions=braille}', "");
    Expect(1, 10495, '\p{Script_Extensions=:\Abraille\z:}', "");;
    Expect(0, 10496, '\p{Script_Extensions=:\Abraille\z:}', "");;
    Expect(1, 10495, '\p{Script_Extensions=  braille}', "");
    Expect(0, 10495, '\p{^Script_Extensions=  braille}', "");
    Expect(0, 10495, '\P{Script_Extensions=  braille}', "");
    Expect(1, 10495, '\P{^Script_Extensions=  braille}', "");
    Expect(0, 10496, '\p{Script_Extensions=  braille}', "");
    Expect(1, 10496, '\p{^Script_Extensions=  braille}', "");
    Expect(1, 10496, '\P{Script_Extensions=  braille}', "");
    Expect(0, 10496, '\P{^Script_Extensions=  braille}', "");
    Error('\p{Scx=/a/_-brai}');
    Error('\P{Scx=/a/_-brai}');
    Expect(1, 10495, '\p{Scx=:\ABrai\z:}', "");;
    Expect(0, 10496, '\p{Scx=:\ABrai\z:}', "");;
    Expect(1, 10495, '\p{Scx=brai}', "");
    Expect(0, 10495, '\p{^Scx=brai}', "");
    Expect(0, 10495, '\P{Scx=brai}', "");
    Expect(1, 10495, '\P{^Scx=brai}', "");
    Expect(0, 10496, '\p{Scx=brai}', "");
    Expect(1, 10496, '\p{^Scx=brai}', "");
    Expect(1, 10496, '\P{Scx=brai}', "");
    Expect(0, 10496, '\P{^Scx=brai}', "");
    Expect(1, 10495, '\p{Scx=:\Abrai\z:}', "");;
    Expect(0, 10496, '\p{Scx=:\Abrai\z:}', "");;
    Expect(1, 10495, '\p{Scx=-brai}', "");
    Expect(0, 10495, '\p{^Scx=-brai}', "");
    Expect(0, 10495, '\P{Scx=-brai}', "");
    Expect(1, 10495, '\P{^Scx=-brai}', "");
    Expect(0, 10496, '\p{Scx=-brai}', "");
    Expect(1, 10496, '\p{^Scx=-brai}', "");
    Expect(1, 10496, '\P{Scx=-brai}', "");
    Expect(0, 10496, '\P{^Scx=-brai}', "");
    Error('\p{Is_Script_Extensions=-:=BRAILLE}');
    Error('\P{Is_Script_Extensions=-:=BRAILLE}');
    Expect(1, 10495, '\p{Is_Script_Extensions=braille}', "");
    Expect(0, 10495, '\p{^Is_Script_Extensions=braille}', "");
    Expect(0, 10495, '\P{Is_Script_Extensions=braille}', "");
    Expect(1, 10495, '\P{^Is_Script_Extensions=braille}', "");
    Expect(0, 10496, '\p{Is_Script_Extensions=braille}', "");
    Expect(1, 10496, '\p{^Is_Script_Extensions=braille}', "");
    Expect(1, 10496, '\P{Is_Script_Extensions=braille}', "");
    Expect(0, 10496, '\P{^Is_Script_Extensions=braille}', "");
    Expect(1, 10495, '\p{Is_Script_Extensions=-_braille}', "");
    Expect(0, 10495, '\p{^Is_Script_Extensions=-_braille}', "");
    Expect(0, 10495, '\P{Is_Script_Extensions=-_braille}', "");
    Expect(1, 10495, '\P{^Is_Script_Extensions=-_braille}', "");
    Expect(0, 10496, '\p{Is_Script_Extensions=-_braille}', "");
    Expect(1, 10496, '\p{^Is_Script_Extensions=-_braille}', "");
    Expect(1, 10496, '\P{Is_Script_Extensions=-_braille}', "");
    Expect(0, 10496, '\P{^Is_Script_Extensions=-_braille}', "");
    Error('\p{Is_Scx=:=	Brai}');
    Error('\P{Is_Scx=:=	Brai}');
    Expect(1, 10495, '\p{Is_Scx:   brai}', "");
    Expect(0, 10495, '\p{^Is_Scx:   brai}', "");
    Expect(0, 10495, '\P{Is_Scx:   brai}', "");
    Expect(1, 10495, '\P{^Is_Scx:   brai}', "");
    Expect(0, 10496, '\p{Is_Scx:   brai}', "");
    Expect(1, 10496, '\p{^Is_Scx:   brai}', "");
    Expect(1, 10496, '\P{Is_Scx:   brai}', "");
    Expect(0, 10496, '\P{^Is_Scx:   brai}', "");
    Expect(1, 10495, '\p{Is_Scx=-_Brai}', "");
    Expect(0, 10495, '\p{^Is_Scx=-_Brai}', "");
    Expect(0, 10495, '\P{Is_Scx=-_Brai}', "");
    Expect(1, 10495, '\P{^Is_Scx=-_Brai}', "");
    Expect(0, 10496, '\p{Is_Scx=-_Brai}', "");
    Expect(1, 10496, '\p{^Is_Scx=-_Brai}', "");
    Expect(1, 10496, '\P{Is_Scx=-_Brai}', "");
    Expect(0, 10496, '\P{^Is_Scx=-_Brai}', "");
    Error('\p{Script_Extensions: 	_Buginese/a/}');
    Error('\P{Script_Extensions: 	_Buginese/a/}');
    Expect(1, 43471, '\p{Script_Extensions=:\ABuginese\z:}', "");;
    Expect(0, 43472, '\p{Script_Extensions=:\ABuginese\z:}', "");;
    Expect(1, 43471, '\p{Script_Extensions=buginese}', "");
    Expect(0, 43471, '\p{^Script_Extensions=buginese}', "");
    Expect(0, 43471, '\P{Script_Extensions=buginese}', "");
    Expect(1, 43471, '\P{^Script_Extensions=buginese}', "");
    Expect(0, 43472, '\p{Script_Extensions=buginese}', "");
    Expect(1, 43472, '\p{^Script_Extensions=buginese}', "");
    Expect(1, 43472, '\P{Script_Extensions=buginese}', "");
    Expect(0, 43472, '\P{^Script_Extensions=buginese}', "");
    Expect(1, 43471, '\p{Script_Extensions=:\Abuginese\z:}', "");;
    Expect(0, 43472, '\p{Script_Extensions=:\Abuginese\z:}', "");;
    Error('\p{Scx=/a/bugi}');
    Error('\P{Scx=/a/bugi}');
    Expect(1, 43471, '\p{Scx=:\ABugi\z:}', "");;
    Expect(0, 43472, '\p{Scx=:\ABugi\z:}', "");;
    Expect(1, 43471, '\p{Scx=bugi}', "");
    Expect(0, 43471, '\p{^Scx=bugi}', "");
    Expect(0, 43471, '\P{Scx=bugi}', "");
    Expect(1, 43471, '\P{^Scx=bugi}', "");
    Expect(0, 43472, '\p{Scx=bugi}', "");
    Expect(1, 43472, '\p{^Scx=bugi}', "");
    Expect(1, 43472, '\P{Scx=bugi}', "");
    Expect(0, 43472, '\P{^Scx=bugi}', "");
    Expect(1, 43471, '\p{Scx=:\Abugi\z:}', "");;
    Expect(0, 43472, '\p{Scx=:\Abugi\z:}', "");;
    Expect(1, 43471, '\p{Scx=_Bugi}', "");
    Expect(0, 43471, '\p{^Scx=_Bugi}', "");
    Expect(0, 43471, '\P{Scx=_Bugi}', "");
    Expect(1, 43471, '\P{^Scx=_Bugi}', "");
    Expect(0, 43472, '\p{Scx=_Bugi}', "");
    Expect(1, 43472, '\p{^Scx=_Bugi}', "");
    Expect(1, 43472, '\P{Scx=_Bugi}', "");
    Expect(0, 43472, '\P{^Scx=_Bugi}', "");
    Error('\p{Is_Script_Extensions=-BUGINESE/a/}');
    Error('\P{Is_Script_Extensions=-BUGINESE/a/}');
    Expect(1, 43471, '\p{Is_Script_Extensions=buginese}', "");
    Expect(0, 43471, '\p{^Is_Script_Extensions=buginese}', "");
    Expect(0, 43471, '\P{Is_Script_Extensions=buginese}', "");
    Expect(1, 43471, '\P{^Is_Script_Extensions=buginese}', "");
    Expect(0, 43472, '\p{Is_Script_Extensions=buginese}', "");
    Expect(1, 43472, '\p{^Is_Script_Extensions=buginese}', "");
    Expect(1, 43472, '\P{Is_Script_Extensions=buginese}', "");
    Expect(0, 43472, '\P{^Is_Script_Extensions=buginese}', "");
    Expect(1, 43471, '\p{Is_Script_Extensions:   _Buginese}', "");
    Expect(0, 43471, '\p{^Is_Script_Extensions:   _Buginese}', "");
    Expect(0, 43471, '\P{Is_Script_Extensions:   _Buginese}', "");
    Expect(1, 43471, '\P{^Is_Script_Extensions:   _Buginese}', "");
    Expect(0, 43472, '\p{Is_Script_Extensions:   _Buginese}', "");
    Expect(1, 43472, '\p{^Is_Script_Extensions:   _Buginese}', "");
    Expect(1, 43472, '\P{Is_Script_Extensions:   _Buginese}', "");
    Expect(0, 43472, '\P{^Is_Script_Extensions:   _Buginese}', "");
    Error('\p{Is_Scx=-/a/BUGI}');
    Error('\P{Is_Scx=-/a/BUGI}');
    Expect(1, 43471, '\p{Is_Scx=bugi}', "");
    Expect(0, 43471, '\p{^Is_Scx=bugi}', "");
    Expect(0, 43471, '\P{Is_Scx=bugi}', "");
    Expect(1, 43471, '\P{^Is_Scx=bugi}', "");
    Expect(0, 43472, '\p{Is_Scx=bugi}', "");
    Expect(1, 43472, '\p{^Is_Scx=bugi}', "");
    Expect(1, 43472, '\P{Is_Scx=bugi}', "");
    Expect(0, 43472, '\P{^Is_Scx=bugi}', "");
    Expect(1, 43471, '\p{Is_Scx= _Bugi}', "");
    Expect(0, 43471, '\p{^Is_Scx= _Bugi}', "");
    Expect(0, 43471, '\P{Is_Scx= _Bugi}', "");
    Expect(1, 43471, '\P{^Is_Scx= _Bugi}', "");
    Expect(0, 43472, '\p{Is_Scx= _Bugi}', "");
    Expect(1, 43472, '\p{^Is_Scx= _Bugi}', "");
    Expect(1, 43472, '\P{Is_Scx= _Bugi}', "");
    Expect(0, 43472, '\P{^Is_Scx= _Bugi}', "");
    Error('\p{Script_Extensions=:=- Buhid}');
    Error('\P{Script_Extensions=:=- Buhid}');
    Expect(1, 5971, '\p{Script_Extensions=:\ABuhid\z:}', "");;
    Expect(0, 5972, '\p{Script_Extensions=:\ABuhid\z:}', "");;
    Expect(1, 5971, '\p{Script_Extensions=buhid}', "");
    Expect(0, 5971, '\p{^Script_Extensions=buhid}', "");
    Expect(0, 5971, '\P{Script_Extensions=buhid}', "");
    Expect(1, 5971, '\P{^Script_Extensions=buhid}', "");
    Expect(0, 5972, '\p{Script_Extensions=buhid}', "");
    Expect(1, 5972, '\p{^Script_Extensions=buhid}', "");
    Expect(1, 5972, '\P{Script_Extensions=buhid}', "");
    Expect(0, 5972, '\P{^Script_Extensions=buhid}', "");
    Expect(1, 5971, '\p{Script_Extensions=:\Abuhid\z:}', "");;
    Expect(0, 5972, '\p{Script_Extensions=:\Abuhid\z:}', "");;
    Expect(1, 5971, '\p{Script_Extensions=	 buhid}', "");
    Expect(0, 5971, '\p{^Script_Extensions=	 buhid}', "");
    Expect(0, 5971, '\P{Script_Extensions=	 buhid}', "");
    Expect(1, 5971, '\P{^Script_Extensions=	 buhid}', "");
    Expect(0, 5972, '\p{Script_Extensions=	 buhid}', "");
    Expect(1, 5972, '\p{^Script_Extensions=	 buhid}', "");
    Expect(1, 5972, '\P{Script_Extensions=	 buhid}', "");
    Expect(0, 5972, '\P{^Script_Extensions=	 buhid}', "");
    Error('\p{Scx=-_BUHD/a/}');
    Error('\P{Scx=-_BUHD/a/}');
    Expect(1, 5971, '\p{Scx=:\ABuhd\z:}', "");;
    Expect(0, 5972, '\p{Scx=:\ABuhd\z:}', "");;
    Expect(1, 5971, '\p{Scx:   buhd}', "");
    Expect(0, 5971, '\p{^Scx:   buhd}', "");
    Expect(0, 5971, '\P{Scx:   buhd}', "");
    Expect(1, 5971, '\P{^Scx:   buhd}', "");
    Expect(0, 5972, '\p{Scx:   buhd}', "");
    Expect(1, 5972, '\p{^Scx:   buhd}', "");
    Expect(1, 5972, '\P{Scx:   buhd}', "");
    Expect(0, 5972, '\P{^Scx:   buhd}', "");
    Expect(1, 5971, '\p{Scx=:\Abuhd\z:}', "");;
    Expect(0, 5972, '\p{Scx=:\Abuhd\z:}', "");;
    Expect(1, 5971, '\p{Scx= _BUHD}', "");
    Expect(0, 5971, '\p{^Scx= _BUHD}', "");
    Expect(0, 5971, '\P{Scx= _BUHD}', "");
    Expect(1, 5971, '\P{^Scx= _BUHD}', "");
    Expect(0, 5972, '\p{Scx= _BUHD}', "");
    Expect(1, 5972, '\p{^Scx= _BUHD}', "");
    Expect(1, 5972, '\P{Scx= _BUHD}', "");
    Expect(0, 5972, '\P{^Scx= _BUHD}', "");
    Error('\p{Is_Script_Extensions=Buhid/a/}');
    Error('\P{Is_Script_Extensions=Buhid/a/}');
    Expect(1, 5971, '\p{Is_Script_Extensions=buhid}', "");
    Expect(0, 5971, '\p{^Is_Script_Extensions=buhid}', "");
    Expect(0, 5971, '\P{Is_Script_Extensions=buhid}', "");
    Expect(1, 5971, '\P{^Is_Script_Extensions=buhid}', "");
    Expect(0, 5972, '\p{Is_Script_Extensions=buhid}', "");
    Expect(1, 5972, '\p{^Is_Script_Extensions=buhid}', "");
    Expect(1, 5972, '\P{Is_Script_Extensions=buhid}', "");
    Expect(0, 5972, '\P{^Is_Script_Extensions=buhid}', "");
    Expect(1, 5971, '\p{Is_Script_Extensions=_-Buhid}', "");
    Expect(0, 5971, '\p{^Is_Script_Extensions=_-Buhid}', "");
    Expect(0, 5971, '\P{Is_Script_Extensions=_-Buhid}', "");
    Expect(1, 5971, '\P{^Is_Script_Extensions=_-Buhid}', "");
    Expect(0, 5972, '\p{Is_Script_Extensions=_-Buhid}', "");
    Expect(1, 5972, '\p{^Is_Script_Extensions=_-Buhid}', "");
    Expect(1, 5972, '\P{Is_Script_Extensions=_-Buhid}', "");
    Expect(0, 5972, '\P{^Is_Script_Extensions=_-Buhid}', "");
    Error('\p{Is_Scx=_/a/Buhd}');
    Error('\P{Is_Scx=_/a/Buhd}');
    Expect(1, 5971, '\p{Is_Scx=buhd}', "");
    Expect(0, 5971, '\p{^Is_Scx=buhd}', "");
    Expect(0, 5971, '\P{Is_Scx=buhd}', "");
    Expect(1, 5971, '\P{^Is_Scx=buhd}', "");
    Expect(0, 5972, '\p{Is_Scx=buhd}', "");
    Expect(1, 5972, '\p{^Is_Scx=buhd}', "");
    Expect(1, 5972, '\P{Is_Scx=buhd}', "");
    Expect(0, 5972, '\P{^Is_Scx=buhd}', "");
    Expect(1, 5971, '\p{Is_Scx=	Buhd}', "");
    Expect(0, 5971, '\p{^Is_Scx=	Buhd}', "");
    Expect(0, 5971, '\P{Is_Scx=	Buhd}', "");
    Expect(1, 5971, '\P{^Is_Scx=	Buhd}', "");
    Expect(0, 5972, '\p{Is_Scx=	Buhd}', "");
    Expect(1, 5972, '\p{^Is_Scx=	Buhd}', "");
    Expect(1, 5972, '\P{Is_Scx=	Buhd}', "");
    Expect(0, 5972, '\P{^Is_Scx=	Buhd}', "");
    Error('\p{Script_Extensions=/a/_-CHAKMA}');
    Error('\P{Script_Extensions=/a/_-CHAKMA}');
    Expect(1, 69959, '\p{Script_Extensions=:\AChakma\z:}', "");;
    Expect(0, 69960, '\p{Script_Extensions=:\AChakma\z:}', "");;
    Expect(1, 69959, '\p{Script_Extensions=chakma}', "");
    Expect(0, 69959, '\p{^Script_Extensions=chakma}', "");
    Expect(0, 69959, '\P{Script_Extensions=chakma}', "");
    Expect(1, 69959, '\P{^Script_Extensions=chakma}', "");
    Expect(0, 69960, '\p{Script_Extensions=chakma}', "");
    Expect(1, 69960, '\p{^Script_Extensions=chakma}', "");
    Expect(1, 69960, '\P{Script_Extensions=chakma}', "");
    Expect(0, 69960, '\P{^Script_Extensions=chakma}', "");
    Expect(1, 69959, '\p{Script_Extensions=:\Achakma\z:}', "");;
    Expect(0, 69960, '\p{Script_Extensions=:\Achakma\z:}', "");;
    Expect(1, 69959, '\p{Script_Extensions=_-CHAKMA}', "");
    Expect(0, 69959, '\p{^Script_Extensions=_-CHAKMA}', "");
    Expect(0, 69959, '\P{Script_Extensions=_-CHAKMA}', "");
    Expect(1, 69959, '\P{^Script_Extensions=_-CHAKMA}', "");
    Expect(0, 69960, '\p{Script_Extensions=_-CHAKMA}', "");
    Expect(1, 69960, '\p{^Script_Extensions=_-CHAKMA}', "");
    Expect(1, 69960, '\P{Script_Extensions=_-CHAKMA}', "");
    Expect(0, 69960, '\P{^Script_Extensions=_-CHAKMA}', "");
    Error('\p{Scx=-Cakm/a/}');
    Error('\P{Scx=-Cakm/a/}');
    Expect(1, 69959, '\p{Scx=:\ACakm\z:}', "");;
    Expect(0, 69960, '\p{Scx=:\ACakm\z:}', "");;
    Expect(1, 69959, '\p{Scx=cakm}', "");
    Expect(0, 69959, '\p{^Scx=cakm}', "");
    Expect(0, 69959, '\P{Scx=cakm}', "");
    Expect(1, 69959, '\P{^Scx=cakm}', "");
    Expect(0, 69960, '\p{Scx=cakm}', "");
    Expect(1, 69960, '\p{^Scx=cakm}', "");
    Expect(1, 69960, '\P{Scx=cakm}', "");
    Expect(0, 69960, '\P{^Scx=cakm}', "");
    Expect(1, 69959, '\p{Scx=:\Acakm\z:}', "");;
    Expect(0, 69960, '\p{Scx=:\Acakm\z:}', "");;
    Expect(1, 69959, '\p{Scx=		cakm}', "");
    Expect(0, 69959, '\p{^Scx=		cakm}', "");
    Expect(0, 69959, '\P{Scx=		cakm}', "");
    Expect(1, 69959, '\P{^Scx=		cakm}', "");
    Expect(0, 69960, '\p{Scx=		cakm}', "");
    Expect(1, 69960, '\p{^Scx=		cakm}', "");
    Expect(1, 69960, '\P{Scx=		cakm}', "");
    Expect(0, 69960, '\P{^Scx=		cakm}', "");
    Error('\p{Is_Script_Extensions=/a/ _Chakma}');
    Error('\P{Is_Script_Extensions=/a/ _Chakma}');
    Expect(1, 69959, '\p{Is_Script_Extensions:chakma}', "");
    Expect(0, 69959, '\p{^Is_Script_Extensions:chakma}', "");
    Expect(0, 69959, '\P{Is_Script_Extensions:chakma}', "");
    Expect(1, 69959, '\P{^Is_Script_Extensions:chakma}', "");
    Expect(0, 69960, '\p{Is_Script_Extensions:chakma}', "");
    Expect(1, 69960, '\p{^Is_Script_Extensions:chakma}', "");
    Expect(1, 69960, '\P{Is_Script_Extensions:chakma}', "");
    Expect(0, 69960, '\P{^Is_Script_Extensions:chakma}', "");
    Expect(1, 69959, '\p{Is_Script_Extensions=	Chakma}', "");
    Expect(0, 69959, '\p{^Is_Script_Extensions=	Chakma}', "");
    Expect(0, 69959, '\P{Is_Script_Extensions=	Chakma}', "");
    Expect(1, 69959, '\P{^Is_Script_Extensions=	Chakma}', "");
    Expect(0, 69960, '\p{Is_Script_Extensions=	Chakma}', "");
    Expect(1, 69960, '\p{^Is_Script_Extensions=	Chakma}', "");
    Expect(1, 69960, '\P{Is_Script_Extensions=	Chakma}', "");
    Expect(0, 69960, '\P{^Is_Script_Extensions=	Chakma}', "");
    Error('\p{Is_Scx=-:=Cakm}');
    Error('\P{Is_Scx=-:=Cakm}');
    Expect(1, 69959, '\p{Is_Scx=cakm}', "");
    Expect(0, 69959, '\p{^Is_Scx=cakm}', "");
    Expect(0, 69959, '\P{Is_Scx=cakm}', "");
    Expect(1, 69959, '\P{^Is_Scx=cakm}', "");
    Expect(0, 69960, '\p{Is_Scx=cakm}', "");
    Expect(1, 69960, '\p{^Is_Scx=cakm}', "");
    Expect(1, 69960, '\P{Is_Scx=cakm}', "");
    Expect(0, 69960, '\P{^Is_Scx=cakm}', "");
    Expect(1, 69959, '\p{Is_Scx=__cakm}', "");
    Expect(0, 69959, '\p{^Is_Scx=__cakm}', "");
    Expect(0, 69959, '\P{Is_Scx=__cakm}', "");
    Expect(1, 69959, '\P{^Is_Scx=__cakm}', "");
    Expect(0, 69960, '\p{Is_Scx=__cakm}', "");
    Expect(1, 69960, '\p{^Is_Scx=__cakm}', "");
    Expect(1, 69960, '\P{Is_Scx=__cakm}', "");
    Expect(0, 69960, '\P{^Is_Scx=__cakm}', "");
    Error('\p{Script_Extensions=:=-	Canadian_ABORIGINAL}');
    Error('\P{Script_Extensions=:=-	Canadian_ABORIGINAL}');
    Expect(1, 6389, '\p{Script_Extensions=:\ACanadian_Aboriginal\z:}', "");;
    Expect(0, 6390, '\p{Script_Extensions=:\ACanadian_Aboriginal\z:}', "");;
    Expect(1, 6389, '\p{Script_Extensions=canadianaboriginal}', "");
    Expect(0, 6389, '\p{^Script_Extensions=canadianaboriginal}', "");
    Expect(0, 6389, '\P{Script_Extensions=canadianaboriginal}', "");
    Expect(1, 6389, '\P{^Script_Extensions=canadianaboriginal}', "");
    Expect(0, 6390, '\p{Script_Extensions=canadianaboriginal}', "");
    Expect(1, 6390, '\p{^Script_Extensions=canadianaboriginal}', "");
    Expect(1, 6390, '\P{Script_Extensions=canadianaboriginal}', "");
    Expect(0, 6390, '\P{^Script_Extensions=canadianaboriginal}', "");
    Expect(1, 6389, '\p{Script_Extensions=:\Acanadianaboriginal\z:}', "");;
    Expect(0, 6390, '\p{Script_Extensions=:\Acanadianaboriginal\z:}', "");;
    Expect(1, 6389, '\p{Script_Extensions= 	canadian_aboriginal}', "");
    Expect(0, 6389, '\p{^Script_Extensions= 	canadian_aboriginal}', "");
    Expect(0, 6389, '\P{Script_Extensions= 	canadian_aboriginal}', "");
    Expect(1, 6389, '\P{^Script_Extensions= 	canadian_aboriginal}', "");
    Expect(0, 6390, '\p{Script_Extensions= 	canadian_aboriginal}', "");
    Expect(1, 6390, '\p{^Script_Extensions= 	canadian_aboriginal}', "");
    Expect(1, 6390, '\P{Script_Extensions= 	canadian_aboriginal}', "");
    Expect(0, 6390, '\P{^Script_Extensions= 	canadian_aboriginal}', "");
    Error('\p{Scx=_:=cans}');
    Error('\P{Scx=_:=cans}');
    Expect(1, 6389, '\p{Scx=:\ACans\z:}', "");;
    Expect(0, 6390, '\p{Scx=:\ACans\z:}', "");;
    Expect(1, 6389, '\p{Scx: cans}', "");
    Expect(0, 6389, '\p{^Scx: cans}', "");
    Expect(0, 6389, '\P{Scx: cans}', "");
    Expect(1, 6389, '\P{^Scx: cans}', "");
    Expect(0, 6390, '\p{Scx: cans}', "");
    Expect(1, 6390, '\p{^Scx: cans}', "");
    Expect(1, 6390, '\P{Scx: cans}', "");
    Expect(0, 6390, '\P{^Scx: cans}', "");
    Expect(1, 6389, '\p{Scx=:\Acans\z:}', "");;
    Expect(0, 6390, '\p{Scx=:\Acans\z:}', "");;
    Expect(1, 6389, '\p{Scx=  cans}', "");
    Expect(0, 6389, '\p{^Scx=  cans}', "");
    Expect(0, 6389, '\P{Scx=  cans}', "");
    Expect(1, 6389, '\P{^Scx=  cans}', "");
    Expect(0, 6390, '\p{Scx=  cans}', "");
    Expect(1, 6390, '\p{^Scx=  cans}', "");
    Expect(1, 6390, '\P{Scx=  cans}', "");
    Expect(0, 6390, '\P{^Scx=  cans}', "");
    Error('\p{Is_Script_Extensions=_/a/Canadian_ABORIGINAL}');
    Error('\P{Is_Script_Extensions=_/a/Canadian_ABORIGINAL}');
    Expect(1, 6389, '\p{Is_Script_Extensions=canadianaboriginal}', "");
    Expect(0, 6389, '\p{^Is_Script_Extensions=canadianaboriginal}', "");
    Expect(0, 6389, '\P{Is_Script_Extensions=canadianaboriginal}', "");
    Expect(1, 6389, '\P{^Is_Script_Extensions=canadianaboriginal}', "");
    Expect(0, 6390, '\p{Is_Script_Extensions=canadianaboriginal}', "");
    Expect(1, 6390, '\p{^Is_Script_Extensions=canadianaboriginal}', "");
    Expect(1, 6390, '\P{Is_Script_Extensions=canadianaboriginal}', "");
    Expect(0, 6390, '\P{^Is_Script_Extensions=canadianaboriginal}', "");
    Expect(1, 6389, '\p{Is_Script_Extensions=_-CANADIAN_Aboriginal}', "");
    Expect(0, 6389, '\p{^Is_Script_Extensions=_-CANADIAN_Aboriginal}', "");
    Expect(0, 6389, '\P{Is_Script_Extensions=_-CANADIAN_Aboriginal}', "");
    Expect(1, 6389, '\P{^Is_Script_Extensions=_-CANADIAN_Aboriginal}', "");
    Expect(0, 6390, '\p{Is_Script_Extensions=_-CANADIAN_Aboriginal}', "");
    Expect(1, 6390, '\p{^Is_Script_Extensions=_-CANADIAN_Aboriginal}', "");
    Expect(1, 6390, '\P{Is_Script_Extensions=_-CANADIAN_Aboriginal}', "");
    Expect(0, 6390, '\P{^Is_Script_Extensions=_-CANADIAN_Aboriginal}', "");
    Error('\p{Is_Scx=:=	-Cans}');
    Error('\P{Is_Scx=:=	-Cans}');
    Expect(1, 6389, '\p{Is_Scx=cans}', "");
    Expect(0, 6389, '\p{^Is_Scx=cans}', "");
    Expect(0, 6389, '\P{Is_Scx=cans}', "");
    Expect(1, 6389, '\P{^Is_Scx=cans}', "");
    Expect(0, 6390, '\p{Is_Scx=cans}', "");
    Expect(1, 6390, '\p{^Is_Scx=cans}', "");
    Expect(1, 6390, '\P{Is_Scx=cans}', "");
    Expect(0, 6390, '\P{^Is_Scx=cans}', "");
    Expect(1, 6389, '\p{Is_Scx=--Cans}', "");
    Expect(0, 6389, '\p{^Is_Scx=--Cans}', "");
    Expect(0, 6389, '\P{Is_Scx=--Cans}', "");
    Expect(1, 6389, '\P{^Is_Scx=--Cans}', "");
    Expect(0, 6390, '\p{Is_Scx=--Cans}', "");
    Expect(1, 6390, '\p{^Is_Scx=--Cans}', "");
    Expect(1, 6390, '\P{Is_Scx=--Cans}', "");
    Expect(0, 6390, '\P{^Is_Scx=--Cans}', "");
    Error('\p{Script_Extensions=_	carian:=}');
    Error('\P{Script_Extensions=_	carian:=}');
    Expect(1, 66256, '\p{Script_Extensions=:\ACarian\z:}', "");;
    Expect(0, 66257, '\p{Script_Extensions=:\ACarian\z:}', "");;
    Expect(1, 66256, '\p{Script_Extensions=carian}', "");
    Expect(0, 66256, '\p{^Script_Extensions=carian}', "");
    Expect(0, 66256, '\P{Script_Extensions=carian}', "");
    Expect(1, 66256, '\P{^Script_Extensions=carian}', "");
    Expect(0, 66257, '\p{Script_Extensions=carian}', "");
    Expect(1, 66257, '\p{^Script_Extensions=carian}', "");
    Expect(1, 66257, '\P{Script_Extensions=carian}', "");
    Expect(0, 66257, '\P{^Script_Extensions=carian}', "");
    Expect(1, 66256, '\p{Script_Extensions=:\Acarian\z:}', "");;
    Expect(0, 66257, '\p{Script_Extensions=:\Acarian\z:}', "");;
    Expect(1, 66256, '\p{Script_Extensions=	_carian}', "");
    Expect(0, 66256, '\p{^Script_Extensions=	_carian}', "");
    Expect(0, 66256, '\P{Script_Extensions=	_carian}', "");
    Expect(1, 66256, '\P{^Script_Extensions=	_carian}', "");
    Expect(0, 66257, '\p{Script_Extensions=	_carian}', "");
    Expect(1, 66257, '\p{^Script_Extensions=	_carian}', "");
    Expect(1, 66257, '\P{Script_Extensions=	_carian}', "");
    Expect(0, 66257, '\P{^Script_Extensions=	_carian}', "");
    Error('\p{Scx=:=	Cari}');
    Error('\P{Scx=:=	Cari}');
    Expect(1, 66256, '\p{Scx=:\ACari\z:}', "");;
    Expect(0, 66257, '\p{Scx=:\ACari\z:}', "");;
    Expect(1, 66256, '\p{Scx=cari}', "");
    Expect(0, 66256, '\p{^Scx=cari}', "");
    Expect(0, 66256, '\P{Scx=cari}', "");
    Expect(1, 66256, '\P{^Scx=cari}', "");
    Expect(0, 66257, '\p{Scx=cari}', "");
    Expect(1, 66257, '\p{^Scx=cari}', "");
    Expect(1, 66257, '\P{Scx=cari}', "");
    Expect(0, 66257, '\P{^Scx=cari}', "");
    Expect(1, 66256, '\p{Scx=:\Acari\z:}', "");;
    Expect(0, 66257, '\p{Scx=:\Acari\z:}', "");;
    Expect(1, 66256, '\p{Scx= Cari}', "");
    Expect(0, 66256, '\p{^Scx= Cari}', "");
    Expect(0, 66256, '\P{Scx= Cari}', "");
    Expect(1, 66256, '\P{^Scx= Cari}', "");
    Expect(0, 66257, '\p{Scx= Cari}', "");
    Expect(1, 66257, '\p{^Scx= Cari}', "");
    Expect(1, 66257, '\P{Scx= Cari}', "");
    Expect(0, 66257, '\P{^Scx= Cari}', "");
    Error('\p{Is_Script_Extensions:/a/-Carian}');
    Error('\P{Is_Script_Extensions:/a/-Carian}');
    Expect(1, 66256, '\p{Is_Script_Extensions=carian}', "");
    Expect(0, 66256, '\p{^Is_Script_Extensions=carian}', "");
    Expect(0, 66256, '\P{Is_Script_Extensions=carian}', "");
    Expect(1, 66256, '\P{^Is_Script_Extensions=carian}', "");
    Expect(0, 66257, '\p{Is_Script_Extensions=carian}', "");
    Expect(1, 66257, '\p{^Is_Script_Extensions=carian}', "");
    Expect(1, 66257, '\P{Is_Script_Extensions=carian}', "");
    Expect(0, 66257, '\P{^Is_Script_Extensions=carian}', "");
    Expect(1, 66256, '\p{Is_Script_Extensions=-_Carian}', "");
    Expect(0, 66256, '\p{^Is_Script_Extensions=-_Carian}', "");
    Expect(0, 66256, '\P{Is_Script_Extensions=-_Carian}', "");
    Expect(1, 66256, '\P{^Is_Script_Extensions=-_Carian}', "");
    Expect(0, 66257, '\p{Is_Script_Extensions=-_Carian}', "");
    Expect(1, 66257, '\p{^Is_Script_Extensions=-_Carian}', "");
    Expect(1, 66257, '\P{Is_Script_Extensions=-_Carian}', "");
    Expect(0, 66257, '\P{^Is_Script_Extensions=-_Carian}', "");
    Error('\p{Is_Scx=/a/		Cari}');
    Error('\P{Is_Scx=/a/		Cari}');
    Expect(1, 66256, '\p{Is_Scx:cari}', "");
    Expect(0, 66256, '\p{^Is_Scx:cari}', "");
    Expect(0, 66256, '\P{Is_Scx:cari}', "");
    Expect(1, 66256, '\P{^Is_Scx:cari}', "");
    Expect(0, 66257, '\p{Is_Scx:cari}', "");
    Expect(1, 66257, '\p{^Is_Scx:cari}', "");
    Expect(1, 66257, '\P{Is_Scx:cari}', "");
    Expect(0, 66257, '\P{^Is_Scx:cari}', "");
    Expect(1, 66256, '\p{Is_Scx=		Cari}', "");
    Expect(0, 66256, '\p{^Is_Scx=		Cari}', "");
    Expect(0, 66256, '\P{Is_Scx=		Cari}', "");
    Expect(1, 66256, '\P{^Is_Scx=		Cari}', "");
    Expect(0, 66257, '\p{Is_Scx=		Cari}', "");
    Expect(1, 66257, '\p{^Is_Scx=		Cari}', "");
    Expect(1, 66257, '\P{Is_Scx=		Cari}', "");
    Expect(0, 66257, '\P{^Is_Scx=		Cari}', "");
    Error('\p{Script_Extensions=_Cham/a/}');
    Error('\P{Script_Extensions=_Cham/a/}');
    Expect(1, 43615, '\p{Script_Extensions=:\ACham\z:}', "");;
    Expect(0, 43616, '\p{Script_Extensions=:\ACham\z:}', "");;
    Expect(1, 43615, '\p{Script_Extensions=cham}', "");
    Expect(0, 43615, '\p{^Script_Extensions=cham}', "");
    Expect(0, 43615, '\P{Script_Extensions=cham}', "");
    Expect(1, 43615, '\P{^Script_Extensions=cham}', "");
    Expect(0, 43616, '\p{Script_Extensions=cham}', "");
    Expect(1, 43616, '\p{^Script_Extensions=cham}', "");
    Expect(1, 43616, '\P{Script_Extensions=cham}', "");
    Expect(0, 43616, '\P{^Script_Extensions=cham}', "");
    Expect(1, 43615, '\p{Script_Extensions=:\Acham\z:}', "");;
    Expect(0, 43616, '\p{Script_Extensions=:\Acham\z:}', "");;
    Expect(1, 43615, '\p{Script_Extensions=	cham}', "");
    Expect(0, 43615, '\p{^Script_Extensions=	cham}', "");
    Expect(0, 43615, '\P{Script_Extensions=	cham}', "");
    Expect(1, 43615, '\P{^Script_Extensions=	cham}', "");
    Expect(0, 43616, '\p{Script_Extensions=	cham}', "");
    Expect(1, 43616, '\p{^Script_Extensions=	cham}', "");
    Expect(1, 43616, '\P{Script_Extensions=	cham}', "");
    Expect(0, 43616, '\P{^Script_Extensions=	cham}', "");
    Error('\p{Scx=-cham/a/}');
    Error('\P{Scx=-cham/a/}');
    Expect(1, 43615, '\p{Scx=:\ACham\z:}', "");;
    Expect(0, 43616, '\p{Scx=:\ACham\z:}', "");;
    Expect(1, 43615, '\p{Scx=cham}', "");
    Expect(0, 43615, '\p{^Scx=cham}', "");
    Expect(0, 43615, '\P{Scx=cham}', "");
    Expect(1, 43615, '\P{^Scx=cham}', "");
    Expect(0, 43616, '\p{Scx=cham}', "");
    Expect(1, 43616, '\p{^Scx=cham}', "");
    Expect(1, 43616, '\P{Scx=cham}', "");
    Expect(0, 43616, '\P{^Scx=cham}', "");
    Expect(1, 43615, '\p{Scx=:\Acham\z:}', "");;
    Expect(0, 43616, '\p{Scx=:\Acham\z:}', "");;
    Expect(1, 43615, '\p{Scx=-_Cham}', "");
    Expect(0, 43615, '\p{^Scx=-_Cham}', "");
    Expect(0, 43615, '\P{Scx=-_Cham}', "");
    Expect(1, 43615, '\P{^Scx=-_Cham}', "");
    Expect(0, 43616, '\p{Scx=-_Cham}', "");
    Expect(1, 43616, '\p{^Scx=-_Cham}', "");
    Expect(1, 43616, '\P{Scx=-_Cham}', "");
    Expect(0, 43616, '\P{^Scx=-_Cham}', "");
    Error('\p{Is_Script_Extensions=:=-Cham}');
    Error('\P{Is_Script_Extensions=:=-Cham}');
    Expect(1, 43615, '\p{Is_Script_Extensions=cham}', "");
    Expect(0, 43615, '\p{^Is_Script_Extensions=cham}', "");
    Expect(0, 43615, '\P{Is_Script_Extensions=cham}', "");
    Expect(1, 43615, '\P{^Is_Script_Extensions=cham}', "");
    Expect(0, 43616, '\p{Is_Script_Extensions=cham}', "");
    Expect(1, 43616, '\p{^Is_Script_Extensions=cham}', "");
    Expect(1, 43616, '\P{Is_Script_Extensions=cham}', "");
    Expect(0, 43616, '\P{^Is_Script_Extensions=cham}', "");
    Expect(1, 43615, '\p{Is_Script_Extensions=- cham}', "");
    Expect(0, 43615, '\p{^Is_Script_Extensions=- cham}', "");
    Expect(0, 43615, '\P{Is_Script_Extensions=- cham}', "");
    Expect(1, 43615, '\P{^Is_Script_Extensions=- cham}', "");
    Expect(0, 43616, '\p{Is_Script_Extensions=- cham}', "");
    Expect(1, 43616, '\p{^Is_Script_Extensions=- cham}', "");
    Expect(1, 43616, '\P{Is_Script_Extensions=- cham}', "");
    Expect(0, 43616, '\P{^Is_Script_Extensions=- cham}', "");
    Error('\p{Is_Scx=/a/ 	Cham}');
    Error('\P{Is_Scx=/a/ 	Cham}');
    Expect(1, 43615, '\p{Is_Scx=cham}', "");
    Expect(0, 43615, '\p{^Is_Scx=cham}', "");
    Expect(0, 43615, '\P{Is_Scx=cham}', "");
    Expect(1, 43615, '\P{^Is_Scx=cham}', "");
    Expect(0, 43616, '\p{Is_Scx=cham}', "");
    Expect(1, 43616, '\p{^Is_Scx=cham}', "");
    Expect(1, 43616, '\P{Is_Scx=cham}', "");
    Expect(0, 43616, '\P{^Is_Scx=cham}', "");
    Expect(1, 43615, '\p{Is_Scx=--Cham}', "");
    Expect(0, 43615, '\p{^Is_Scx=--Cham}', "");
    Expect(0, 43615, '\P{Is_Scx=--Cham}', "");
    Expect(1, 43615, '\P{^Is_Scx=--Cham}', "");
    Expect(0, 43616, '\p{Is_Scx=--Cham}', "");
    Expect(1, 43616, '\p{^Is_Scx=--Cham}', "");
    Expect(1, 43616, '\P{Is_Scx=--Cham}', "");
    Expect(0, 43616, '\P{^Is_Scx=--Cham}', "");
    Error('\p{Script_Extensions=/a/--Cherokee}');
    Error('\P{Script_Extensions=/a/--Cherokee}');
    Expect(1, 43967, '\p{Script_Extensions=:\ACherokee\z:}', "");;
    Expect(0, 43968, '\p{Script_Extensions=:\ACherokee\z:}', "");;
    Expect(1, 43967, '\p{Script_Extensions:	cherokee}', "");
    Expect(0, 43967, '\p{^Script_Extensions:	cherokee}', "");
    Expect(0, 43967, '\P{Script_Extensions:	cherokee}', "");
    Expect(1, 43967, '\P{^Script_Extensions:	cherokee}', "");
    Expect(0, 43968, '\p{Script_Extensions:	cherokee}', "");
    Expect(1, 43968, '\p{^Script_Extensions:	cherokee}', "");
    Expect(1, 43968, '\P{Script_Extensions:	cherokee}', "");
    Expect(0, 43968, '\P{^Script_Extensions:	cherokee}', "");
    Expect(1, 43967, '\p{Script_Extensions=:\Acherokee\z:}', "");;
    Expect(0, 43968, '\p{Script_Extensions=:\Acherokee\z:}', "");;
    Expect(1, 43967, '\p{Script_Extensions=	 Cherokee}', "");
    Expect(0, 43967, '\p{^Script_Extensions=	 Cherokee}', "");
    Expect(0, 43967, '\P{Script_Extensions=	 Cherokee}', "");
    Expect(1, 43967, '\P{^Script_Extensions=	 Cherokee}', "");
    Expect(0, 43968, '\p{Script_Extensions=	 Cherokee}', "");
    Expect(1, 43968, '\p{^Script_Extensions=	 Cherokee}', "");
    Expect(1, 43968, '\P{Script_Extensions=	 Cherokee}', "");
    Expect(0, 43968, '\P{^Script_Extensions=	 Cherokee}', "");
    Error('\p{Scx=/a/_ Cher}');
    Error('\P{Scx=/a/_ Cher}');
    Expect(1, 43967, '\p{Scx=:\ACher\z:}', "");;
    Expect(0, 43968, '\p{Scx=:\ACher\z:}', "");;
    Expect(1, 43967, '\p{Scx=cher}', "");
    Expect(0, 43967, '\p{^Scx=cher}', "");
    Expect(0, 43967, '\P{Scx=cher}', "");
    Expect(1, 43967, '\P{^Scx=cher}', "");
    Expect(0, 43968, '\p{Scx=cher}', "");
    Expect(1, 43968, '\p{^Scx=cher}', "");
    Expect(1, 43968, '\P{Scx=cher}', "");
    Expect(0, 43968, '\P{^Scx=cher}', "");
    Expect(1, 43967, '\p{Scx=:\Acher\z:}', "");;
    Expect(0, 43968, '\p{Scx=:\Acher\z:}', "");;
    Expect(1, 43967, '\p{Scx=-CHER}', "");
    Expect(0, 43967, '\p{^Scx=-CHER}', "");
    Expect(0, 43967, '\P{Scx=-CHER}', "");
    Expect(1, 43967, '\P{^Scx=-CHER}', "");
    Expect(0, 43968, '\p{Scx=-CHER}', "");
    Expect(1, 43968, '\p{^Scx=-CHER}', "");
    Expect(1, 43968, '\P{Scx=-CHER}', "");
    Expect(0, 43968, '\P{^Scx=-CHER}', "");
    Error('\p{Is_Script_Extensions=:=  cherokee}');
    Error('\P{Is_Script_Extensions=:=  cherokee}');
    Expect(1, 43967, '\p{Is_Script_Extensions=cherokee}', "");
    Expect(0, 43967, '\p{^Is_Script_Extensions=cherokee}', "");
    Expect(0, 43967, '\P{Is_Script_Extensions=cherokee}', "");
    Expect(1, 43967, '\P{^Is_Script_Extensions=cherokee}', "");
    Expect(0, 43968, '\p{Is_Script_Extensions=cherokee}', "");
    Expect(1, 43968, '\p{^Is_Script_Extensions=cherokee}', "");
    Expect(1, 43968, '\P{Is_Script_Extensions=cherokee}', "");
    Expect(0, 43968, '\P{^Is_Script_Extensions=cherokee}', "");
    Expect(1, 43967, '\p{Is_Script_Extensions=	 cherokee}', "");
    Expect(0, 43967, '\p{^Is_Script_Extensions=	 cherokee}', "");
    Expect(0, 43967, '\P{Is_Script_Extensions=	 cherokee}', "");
    Expect(1, 43967, '\P{^Is_Script_Extensions=	 cherokee}', "");
    Expect(0, 43968, '\p{Is_Script_Extensions=	 cherokee}', "");
    Expect(1, 43968, '\p{^Is_Script_Extensions=	 cherokee}', "");
    Expect(1, 43968, '\P{Is_Script_Extensions=	 cherokee}', "");
    Expect(0, 43968, '\P{^Is_Script_Extensions=	 cherokee}', "");
    Error('\p{Is_Scx=/a/_CHER}');
    Error('\P{Is_Scx=/a/_CHER}');
    Expect(1, 43967, '\p{Is_Scx=cher}', "");
    Expect(0, 43967, '\p{^Is_Scx=cher}', "");
    Expect(0, 43967, '\P{Is_Scx=cher}', "");
    Expect(1, 43967, '\P{^Is_Scx=cher}', "");
    Expect(0, 43968, '\p{Is_Scx=cher}', "");
    Expect(1, 43968, '\p{^Is_Scx=cher}', "");
    Expect(1, 43968, '\P{Is_Scx=cher}', "");
    Expect(0, 43968, '\P{^Is_Scx=cher}', "");
    Expect(1, 43967, '\p{Is_Scx=_ Cher}', "");
    Expect(0, 43967, '\p{^Is_Scx=_ Cher}', "");
    Expect(0, 43967, '\P{Is_Scx=_ Cher}', "");
    Expect(1, 43967, '\P{^Is_Scx=_ Cher}', "");
    Expect(0, 43968, '\p{Is_Scx=_ Cher}', "");
    Expect(1, 43968, '\p{^Is_Scx=_ Cher}', "");
    Expect(1, 43968, '\P{Is_Scx=_ Cher}', "");
    Expect(0, 43968, '\P{^Is_Scx=_ Cher}', "");
    Error('\p{Script_Extensions=-Chorasmian/a/}');
    Error('\P{Script_Extensions=-Chorasmian/a/}');
    Expect(1, 69579, '\p{Script_Extensions=:\AChorasmian\z:}', "");;
    Expect(0, 69580, '\p{Script_Extensions=:\AChorasmian\z:}', "");;
    Expect(1, 69579, '\p{Script_Extensions=chorasmian}', "");
    Expect(0, 69579, '\p{^Script_Extensions=chorasmian}', "");
    Expect(0, 69579, '\P{Script_Extensions=chorasmian}', "");
    Expect(1, 69579, '\P{^Script_Extensions=chorasmian}', "");
    Expect(0, 69580, '\p{Script_Extensions=chorasmian}', "");
    Expect(1, 69580, '\p{^Script_Extensions=chorasmian}', "");
    Expect(1, 69580, '\P{Script_Extensions=chorasmian}', "");
    Expect(0, 69580, '\P{^Script_Extensions=chorasmian}', "");
    Expect(1, 69579, '\p{Script_Extensions=:\Achorasmian\z:}', "");;
    Expect(0, 69580, '\p{Script_Extensions=:\Achorasmian\z:}', "");;
    Expect(1, 69579, '\p{Script_Extensions:    -Chorasmian}', "");
    Expect(0, 69579, '\p{^Script_Extensions:    -Chorasmian}', "");
    Expect(0, 69579, '\P{Script_Extensions:    -Chorasmian}', "");
    Expect(1, 69579, '\P{^Script_Extensions:    -Chorasmian}', "");
    Expect(0, 69580, '\p{Script_Extensions:    -Chorasmian}', "");
    Expect(1, 69580, '\p{^Script_Extensions:    -Chorasmian}', "");
    Expect(1, 69580, '\P{Script_Extensions:    -Chorasmian}', "");
    Expect(0, 69580, '\P{^Script_Extensions:    -Chorasmian}', "");
    Error('\p{Scx=-/a/CHRS}');
    Error('\P{Scx=-/a/CHRS}');
    Expect(1, 69579, '\p{Scx=:\AChrs\z:}', "");;
    Expect(0, 69580, '\p{Scx=:\AChrs\z:}', "");;
    Expect(1, 69579, '\p{Scx=chrs}', "");
    Expect(0, 69579, '\p{^Scx=chrs}', "");
    Expect(0, 69579, '\P{Scx=chrs}', "");
    Expect(1, 69579, '\P{^Scx=chrs}', "");
    Expect(0, 69580, '\p{Scx=chrs}', "");
    Expect(1, 69580, '\p{^Scx=chrs}', "");
    Expect(1, 69580, '\P{Scx=chrs}', "");
    Expect(0, 69580, '\P{^Scx=chrs}', "");
    Expect(1, 69579, '\p{Scx=:\Achrs\z:}', "");;
    Expect(0, 69580, '\p{Scx=:\Achrs\z:}', "");;
    Expect(1, 69579, '\p{Scx=_ chrs}', "");
    Expect(0, 69579, '\p{^Scx=_ chrs}', "");
    Expect(0, 69579, '\P{Scx=_ chrs}', "");
    Expect(1, 69579, '\P{^Scx=_ chrs}', "");
    Expect(0, 69580, '\p{Scx=_ chrs}', "");
    Expect(1, 69580, '\p{^Scx=_ chrs}', "");
    Expect(1, 69580, '\P{Scx=_ chrs}', "");
    Expect(0, 69580, '\P{^Scx=_ chrs}', "");
    Error('\p{Is_Script_Extensions=_:=CHORASMIAN}');
    Error('\P{Is_Script_Extensions=_:=CHORASMIAN}');
    Expect(1, 69579, '\p{Is_Script_Extensions=chorasmian}', "");
    Expect(0, 69579, '\p{^Is_Script_Extensions=chorasmian}', "");
    Expect(0, 69579, '\P{Is_Script_Extensions=chorasmian}', "");
    Expect(1, 69579, '\P{^Is_Script_Extensions=chorasmian}', "");
    Expect(0, 69580, '\p{Is_Script_Extensions=chorasmian}', "");
    Expect(1, 69580, '\p{^Is_Script_Extensions=chorasmian}', "");
    Expect(1, 69580, '\P{Is_Script_Extensions=chorasmian}', "");
    Expect(0, 69580, '\P{^Is_Script_Extensions=chorasmian}', "");
    Expect(1, 69579, '\p{Is_Script_Extensions=		chorasmian}', "");
    Expect(0, 69579, '\p{^Is_Script_Extensions=		chorasmian}', "");
    Expect(0, 69579, '\P{Is_Script_Extensions=		chorasmian}', "");
    Expect(1, 69579, '\P{^Is_Script_Extensions=		chorasmian}', "");
    Expect(0, 69580, '\p{Is_Script_Extensions=		chorasmian}', "");
    Expect(1, 69580, '\p{^Is_Script_Extensions=		chorasmian}', "");
    Expect(1, 69580, '\P{Is_Script_Extensions=		chorasmian}', "");
    Expect(0, 69580, '\P{^Is_Script_Extensions=		chorasmian}', "");
    Error('\p{Is_Scx=/a/ _Chrs}');
    Error('\P{Is_Scx=/a/ _Chrs}');
    Expect(1, 69579, '\p{Is_Scx=chrs}', "");
    Expect(0, 69579, '\p{^Is_Scx=chrs}', "");
    Expect(0, 69579, '\P{Is_Scx=chrs}', "");
    Expect(1, 69579, '\P{^Is_Scx=chrs}', "");
    Expect(0, 69580, '\p{Is_Scx=chrs}', "");
    Expect(1, 69580, '\p{^Is_Scx=chrs}', "");
    Expect(1, 69580, '\P{Is_Scx=chrs}', "");
    Expect(0, 69580, '\P{^Is_Scx=chrs}', "");
    Expect(1, 69579, '\p{Is_Scx=	Chrs}', "");
    Expect(0, 69579, '\p{^Is_Scx=	Chrs}', "");
    Expect(0, 69579, '\P{Is_Scx=	Chrs}', "");
    Expect(1, 69579, '\P{^Is_Scx=	Chrs}', "");
    Expect(0, 69580, '\p{Is_Scx=	Chrs}', "");
    Expect(1, 69580, '\p{^Is_Scx=	Chrs}', "");
    Expect(1, 69580, '\P{Is_Scx=	Chrs}', "");
    Expect(0, 69580, '\P{^Is_Scx=	Chrs}', "");
    Error('\p{Script_Extensions=	Coptic:=}');
    Error('\P{Script_Extensions=	Coptic:=}');
    Expect(1, 66299, '\p{Script_Extensions=:\ACoptic\z:}', "");;
    Expect(0, 66300, '\p{Script_Extensions=:\ACoptic\z:}', "");;
    Expect(1, 66299, '\p{Script_Extensions=coptic}', "");
    Expect(0, 66299, '\p{^Script_Extensions=coptic}', "");
    Expect(0, 66299, '\P{Script_Extensions=coptic}', "");
    Expect(1, 66299, '\P{^Script_Extensions=coptic}', "");
    Expect(0, 66300, '\p{Script_Extensions=coptic}', "");
    Expect(1, 66300, '\p{^Script_Extensions=coptic}', "");
    Expect(1, 66300, '\P{Script_Extensions=coptic}', "");
    Expect(0, 66300, '\P{^Script_Extensions=coptic}', "");
    Expect(1, 66299, '\p{Script_Extensions=:\Acoptic\z:}', "");;
    Expect(0, 66300, '\p{Script_Extensions=:\Acoptic\z:}', "");;
    Expect(1, 66299, '\p{Script_Extensions=	 Coptic}', "");
    Expect(0, 66299, '\p{^Script_Extensions=	 Coptic}', "");
    Expect(0, 66299, '\P{Script_Extensions=	 Coptic}', "");
    Expect(1, 66299, '\P{^Script_Extensions=	 Coptic}', "");
    Expect(0, 66300, '\p{Script_Extensions=	 Coptic}', "");
    Expect(1, 66300, '\p{^Script_Extensions=	 Coptic}', "");
    Expect(1, 66300, '\P{Script_Extensions=	 Coptic}', "");
    Expect(0, 66300, '\P{^Script_Extensions=	 Coptic}', "");
    Error('\p{Scx=/a/-copt}');
    Error('\P{Scx=/a/-copt}');
    Expect(1, 66299, '\p{Scx=:\ACopt\z:}', "");;
    Expect(0, 66300, '\p{Scx=:\ACopt\z:}', "");;
    Expect(1, 66299, '\p{Scx=copt}', "");
    Expect(0, 66299, '\p{^Scx=copt}', "");
    Expect(0, 66299, '\P{Scx=copt}', "");
    Expect(1, 66299, '\P{^Scx=copt}', "");
    Expect(0, 66300, '\p{Scx=copt}', "");
    Expect(1, 66300, '\p{^Scx=copt}', "");
    Expect(1, 66300, '\P{Scx=copt}', "");
    Expect(0, 66300, '\P{^Scx=copt}', "");
    Expect(1, 66299, '\p{Scx=:\Acopt\z:}', "");;
    Expect(0, 66300, '\p{Scx=:\Acopt\z:}', "");;
    Expect(1, 66299, '\p{Scx=-Copt}', "");
    Expect(0, 66299, '\p{^Scx=-Copt}', "");
    Expect(0, 66299, '\P{Scx=-Copt}', "");
    Expect(1, 66299, '\P{^Scx=-Copt}', "");
    Expect(0, 66300, '\p{Scx=-Copt}', "");
    Expect(1, 66300, '\p{^Scx=-Copt}', "");
    Expect(1, 66300, '\P{Scx=-Copt}', "");
    Expect(0, 66300, '\P{^Scx=-Copt}', "");
    Error('\p{Is_Script_Extensions=:=- qaac}');
    Error('\P{Is_Script_Extensions=:=- qaac}');
    Expect(1, 66299, '\p{Is_Script_Extensions=qaac}', "");
    Expect(0, 66299, '\p{^Is_Script_Extensions=qaac}', "");
    Expect(0, 66299, '\P{Is_Script_Extensions=qaac}', "");
    Expect(1, 66299, '\P{^Is_Script_Extensions=qaac}', "");
    Expect(0, 66300, '\p{Is_Script_Extensions=qaac}', "");
    Expect(1, 66300, '\p{^Is_Script_Extensions=qaac}', "");
    Expect(1, 66300, '\P{Is_Script_Extensions=qaac}', "");
    Expect(0, 66300, '\P{^Is_Script_Extensions=qaac}', "");
    Expect(1, 66299, '\p{Is_Script_Extensions= _QAAC}', "");
    Expect(0, 66299, '\p{^Is_Script_Extensions= _QAAC}', "");
    Expect(0, 66299, '\P{Is_Script_Extensions= _QAAC}', "");
    Expect(1, 66299, '\P{^Is_Script_Extensions= _QAAC}', "");
    Expect(0, 66300, '\p{Is_Script_Extensions= _QAAC}', "");
    Expect(1, 66300, '\p{^Is_Script_Extensions= _QAAC}', "");
    Expect(1, 66300, '\P{Is_Script_Extensions= _QAAC}', "");
    Expect(0, 66300, '\P{^Is_Script_Extensions= _QAAC}', "");
    Error('\p{Is_Scx=/a/		coptic}');
    Error('\P{Is_Scx=/a/		coptic}');
    Expect(1, 66299, '\p{Is_Scx:   coptic}', "");
    Expect(0, 66299, '\p{^Is_Scx:   coptic}', "");
    Expect(0, 66299, '\P{Is_Scx:   coptic}', "");
    Expect(1, 66299, '\P{^Is_Scx:   coptic}', "");
    Expect(0, 66300, '\p{Is_Scx:   coptic}', "");
    Expect(1, 66300, '\p{^Is_Scx:   coptic}', "");
    Expect(1, 66300, '\P{Is_Scx:   coptic}', "");
    Expect(0, 66300, '\P{^Is_Scx:   coptic}', "");
    Expect(1, 66299, '\p{Is_Scx=--Coptic}', "");
    Expect(0, 66299, '\p{^Is_Scx=--Coptic}', "");
    Expect(0, 66299, '\P{Is_Scx=--Coptic}', "");
    Expect(1, 66299, '\P{^Is_Scx=--Coptic}', "");
    Expect(0, 66300, '\p{Is_Scx=--Coptic}', "");
    Expect(1, 66300, '\p{^Is_Scx=--Coptic}', "");
    Expect(1, 66300, '\P{Is_Scx=--Coptic}', "");
    Expect(0, 66300, '\P{^Is_Scx=--Coptic}', "");
    Error('\p{Script_Extensions=-/a/Cypriot}');
    Error('\P{Script_Extensions=-/a/Cypriot}');
    Expect(1, 67647, '\p{Script_Extensions=:\ACypriot\z:}', "");;
    Expect(0, 67648, '\p{Script_Extensions=:\ACypriot\z:}', "");;
    Expect(1, 67647, '\p{Script_Extensions=cypriot}', "");
    Expect(0, 67647, '\p{^Script_Extensions=cypriot}', "");
    Expect(0, 67647, '\P{Script_Extensions=cypriot}', "");
    Expect(1, 67647, '\P{^Script_Extensions=cypriot}', "");
    Expect(0, 67648, '\p{Script_Extensions=cypriot}', "");
    Expect(1, 67648, '\p{^Script_Extensions=cypriot}', "");
    Expect(1, 67648, '\P{Script_Extensions=cypriot}', "");
    Expect(0, 67648, '\P{^Script_Extensions=cypriot}', "");
    Expect(1, 67647, '\p{Script_Extensions=:\Acypriot\z:}', "");;
    Expect(0, 67648, '\p{Script_Extensions=:\Acypriot\z:}', "");;
    Expect(1, 67647, '\p{Script_Extensions= Cypriot}', "");
    Expect(0, 67647, '\p{^Script_Extensions= Cypriot}', "");
    Expect(0, 67647, '\P{Script_Extensions= Cypriot}', "");
    Expect(1, 67647, '\P{^Script_Extensions= Cypriot}', "");
    Expect(0, 67648, '\p{Script_Extensions= Cypriot}', "");
    Expect(1, 67648, '\p{^Script_Extensions= Cypriot}', "");
    Expect(1, 67648, '\P{Script_Extensions= Cypriot}', "");
    Expect(0, 67648, '\P{^Script_Extensions= Cypriot}', "");
    Error('\p{Scx=:=	-Cprt}');
    Error('\P{Scx=:=	-Cprt}');
    Expect(1, 67647, '\p{Scx=:\ACprt\z:}', "");;
    Expect(0, 67648, '\p{Scx=:\ACprt\z:}', "");;
    Expect(1, 67647, '\p{Scx=cprt}', "");
    Expect(0, 67647, '\p{^Scx=cprt}', "");
    Expect(0, 67647, '\P{Scx=cprt}', "");
    Expect(1, 67647, '\P{^Scx=cprt}', "");
    Expect(0, 67648, '\p{Scx=cprt}', "");
    Expect(1, 67648, '\p{^Scx=cprt}', "");
    Expect(1, 67648, '\P{Scx=cprt}', "");
    Expect(0, 67648, '\P{^Scx=cprt}', "");
    Expect(1, 67647, '\p{Scx=:\Acprt\z:}', "");;
    Expect(0, 67648, '\p{Scx=:\Acprt\z:}', "");;
    Expect(1, 67647, '\p{Scx=- cprt}', "");
    Expect(0, 67647, '\p{^Scx=- cprt}', "");
    Expect(0, 67647, '\P{Scx=- cprt}', "");
    Expect(1, 67647, '\P{^Scx=- cprt}', "");
    Expect(0, 67648, '\p{Scx=- cprt}', "");
    Expect(1, 67648, '\p{^Scx=- cprt}', "");
    Expect(1, 67648, '\P{Scx=- cprt}', "");
    Expect(0, 67648, '\P{^Scx=- cprt}', "");
    Error('\p{Is_Script_Extensions=-:=Cypriot}');
    Error('\P{Is_Script_Extensions=-:=Cypriot}');
    Expect(1, 67647, '\p{Is_Script_Extensions=cypriot}', "");
    Expect(0, 67647, '\p{^Is_Script_Extensions=cypriot}', "");
    Expect(0, 67647, '\P{Is_Script_Extensions=cypriot}', "");
    Expect(1, 67647, '\P{^Is_Script_Extensions=cypriot}', "");
    Expect(0, 67648, '\p{Is_Script_Extensions=cypriot}', "");
    Expect(1, 67648, '\p{^Is_Script_Extensions=cypriot}', "");
    Expect(1, 67648, '\P{Is_Script_Extensions=cypriot}', "");
    Expect(0, 67648, '\P{^Is_Script_Extensions=cypriot}', "");
    Expect(1, 67647, '\p{Is_Script_Extensions:	Cypriot}', "");
    Expect(0, 67647, '\p{^Is_Script_Extensions:	Cypriot}', "");
    Expect(0, 67647, '\P{Is_Script_Extensions:	Cypriot}', "");
    Expect(1, 67647, '\P{^Is_Script_Extensions:	Cypriot}', "");
    Expect(0, 67648, '\p{Is_Script_Extensions:	Cypriot}', "");
    Expect(1, 67648, '\p{^Is_Script_Extensions:	Cypriot}', "");
    Expect(1, 67648, '\P{Is_Script_Extensions:	Cypriot}', "");
    Expect(0, 67648, '\P{^Is_Script_Extensions:	Cypriot}', "");
    Error('\p{Is_Scx=	_Cprt/a/}');
    Error('\P{Is_Scx=	_Cprt/a/}');
    Expect(1, 67647, '\p{Is_Scx=cprt}', "");
    Expect(0, 67647, '\p{^Is_Scx=cprt}', "");
    Expect(0, 67647, '\P{Is_Scx=cprt}', "");
    Expect(1, 67647, '\P{^Is_Scx=cprt}', "");
    Expect(0, 67648, '\p{Is_Scx=cprt}', "");
    Expect(1, 67648, '\p{^Is_Scx=cprt}', "");
    Expect(1, 67648, '\P{Is_Scx=cprt}', "");
    Expect(0, 67648, '\P{^Is_Scx=cprt}', "");
    Expect(1, 67647, '\p{Is_Scx:	_cprt}', "");
    Expect(0, 67647, '\p{^Is_Scx:	_cprt}', "");
    Expect(0, 67647, '\P{Is_Scx:	_cprt}', "");
    Expect(1, 67647, '\P{^Is_Scx:	_cprt}', "");
    Expect(0, 67648, '\p{Is_Scx:	_cprt}', "");
    Expect(1, 67648, '\p{^Is_Scx:	_cprt}', "");
    Expect(1, 67648, '\P{Is_Scx:	_cprt}', "");
    Expect(0, 67648, '\P{^Is_Scx:	_cprt}', "");
    Error('\p{Script_Extensions=:=_	cyrillic}');
    Error('\P{Script_Extensions=:=_	cyrillic}');
    Expect(1, 65071, '\p{Script_Extensions=:\ACyrillic\z:}', "");;
    Expect(0, 65072, '\p{Script_Extensions=:\ACyrillic\z:}', "");;
    Expect(1, 65071, '\p{Script_Extensions=cyrillic}', "");
    Expect(0, 65071, '\p{^Script_Extensions=cyrillic}', "");
    Expect(0, 65071, '\P{Script_Extensions=cyrillic}', "");
    Expect(1, 65071, '\P{^Script_Extensions=cyrillic}', "");
    Expect(0, 65072, '\p{Script_Extensions=cyrillic}', "");
    Expect(1, 65072, '\p{^Script_Extensions=cyrillic}', "");
    Expect(1, 65072, '\P{Script_Extensions=cyrillic}', "");
    Expect(0, 65072, '\P{^Script_Extensions=cyrillic}', "");
    Expect(1, 65071, '\p{Script_Extensions=:\Acyrillic\z:}', "");;
    Expect(0, 65072, '\p{Script_Extensions=:\Acyrillic\z:}', "");;
    Expect(1, 65071, '\p{Script_Extensions= 	Cyrillic}', "");
    Expect(0, 65071, '\p{^Script_Extensions= 	Cyrillic}', "");
    Expect(0, 65071, '\P{Script_Extensions= 	Cyrillic}', "");
    Expect(1, 65071, '\P{^Script_Extensions= 	Cyrillic}', "");
    Expect(0, 65072, '\p{Script_Extensions= 	Cyrillic}', "");
    Expect(1, 65072, '\p{^Script_Extensions= 	Cyrillic}', "");
    Expect(1, 65072, '\P{Script_Extensions= 	Cyrillic}', "");
    Expect(0, 65072, '\P{^Script_Extensions= 	Cyrillic}', "");
    Error('\p{Scx= Cyrl:=}');
    Error('\P{Scx= Cyrl:=}');
    Expect(1, 65071, '\p{Scx=:\ACyrl\z:}', "");;
    Expect(0, 65072, '\p{Scx=:\ACyrl\z:}', "");;
    Expect(1, 65071, '\p{Scx=cyrl}', "");
    Expect(0, 65071, '\p{^Scx=cyrl}', "");
    Expect(0, 65071, '\P{Scx=cyrl}', "");
    Expect(1, 65071, '\P{^Scx=cyrl}', "");
    Expect(0, 65072, '\p{Scx=cyrl}', "");
    Expect(1, 65072, '\p{^Scx=cyrl}', "");
    Expect(1, 65072, '\P{Scx=cyrl}', "");
    Expect(0, 65072, '\P{^Scx=cyrl}', "");
    Expect(1, 65071, '\p{Scx=:\Acyrl\z:}', "");;
    Expect(0, 65072, '\p{Scx=:\Acyrl\z:}', "");;
    Expect(1, 65071, '\p{Scx= Cyrl}', "");
    Expect(0, 65071, '\p{^Scx= Cyrl}', "");
    Expect(0, 65071, '\P{Scx= Cyrl}', "");
    Expect(1, 65071, '\P{^Scx= Cyrl}', "");
    Expect(0, 65072, '\p{Scx= Cyrl}', "");
    Expect(1, 65072, '\p{^Scx= Cyrl}', "");
    Expect(1, 65072, '\P{Scx= Cyrl}', "");
    Expect(0, 65072, '\P{^Scx= Cyrl}', "");
    Error('\p{Is_Script_Extensions=-:=CYRILLIC}');
    Error('\P{Is_Script_Extensions=-:=CYRILLIC}');
    Expect(1, 65071, '\p{Is_Script_Extensions: cyrillic}', "");
    Expect(0, 65071, '\p{^Is_Script_Extensions: cyrillic}', "");
    Expect(0, 65071, '\P{Is_Script_Extensions: cyrillic}', "");
    Expect(1, 65071, '\P{^Is_Script_Extensions: cyrillic}', "");
    Expect(0, 65072, '\p{Is_Script_Extensions: cyrillic}', "");
    Expect(1, 65072, '\p{^Is_Script_Extensions: cyrillic}', "");
    Expect(1, 65072, '\P{Is_Script_Extensions: cyrillic}', "");
    Expect(0, 65072, '\P{^Is_Script_Extensions: cyrillic}', "");
    Expect(1, 65071, '\p{Is_Script_Extensions=--CYRILLIC}', "");
    Expect(0, 65071, '\p{^Is_Script_Extensions=--CYRILLIC}', "");
    Expect(0, 65071, '\P{Is_Script_Extensions=--CYRILLIC}', "");
    Expect(1, 65071, '\P{^Is_Script_Extensions=--CYRILLIC}', "");
    Expect(0, 65072, '\p{Is_Script_Extensions=--CYRILLIC}', "");
    Expect(1, 65072, '\p{^Is_Script_Extensions=--CYRILLIC}', "");
    Expect(1, 65072, '\P{Is_Script_Extensions=--CYRILLIC}', "");
    Expect(0, 65072, '\P{^Is_Script_Extensions=--CYRILLIC}', "");
    Error('\p{Is_Scx=:=	CYRL}');
    Error('\P{Is_Scx=:=	CYRL}');
    Expect(1, 65071, '\p{Is_Scx: cyrl}', "");
    Expect(0, 65071, '\p{^Is_Scx: cyrl}', "");
    Expect(0, 65071, '\P{Is_Scx: cyrl}', "");
    Expect(1, 65071, '\P{^Is_Scx: cyrl}', "");
    Expect(0, 65072, '\p{Is_Scx: cyrl}', "");
    Expect(1, 65072, '\p{^Is_Scx: cyrl}', "");
    Expect(1, 65072, '\P{Is_Scx: cyrl}', "");
    Expect(0, 65072, '\P{^Is_Scx: cyrl}', "");
    Expect(1, 65071, '\p{Is_Scx=_-Cyrl}', "");
    Expect(0, 65071, '\p{^Is_Scx=_-Cyrl}', "");
    Expect(0, 65071, '\P{Is_Scx=_-Cyrl}', "");
    Expect(1, 65071, '\P{^Is_Scx=_-Cyrl}', "");
    Expect(0, 65072, '\p{Is_Scx=_-Cyrl}', "");
    Expect(1, 65072, '\p{^Is_Scx=_-Cyrl}', "");
    Expect(1, 65072, '\P{Is_Scx=_-Cyrl}', "");
    Expect(0, 65072, '\P{^Is_Scx=_-Cyrl}', "");
    Error('\p{Script_Extensions=_-DEVANAGARI/a/}');
    Error('\P{Script_Extensions=_-DEVANAGARI/a/}');
    Expect(1, 43263, '\p{Script_Extensions=:\ADevanagari\z:}', "");;
    Expect(0, 43264, '\p{Script_Extensions=:\ADevanagari\z:}', "");;
    Expect(1, 43263, '\p{Script_Extensions: devanagari}', "");
    Expect(0, 43263, '\p{^Script_Extensions: devanagari}', "");
    Expect(0, 43263, '\P{Script_Extensions: devanagari}', "");
    Expect(1, 43263, '\P{^Script_Extensions: devanagari}', "");
    Expect(0, 43264, '\p{Script_Extensions: devanagari}', "");
    Expect(1, 43264, '\p{^Script_Extensions: devanagari}', "");
    Expect(1, 43264, '\P{Script_Extensions: devanagari}', "");
    Expect(0, 43264, '\P{^Script_Extensions: devanagari}', "");
    Expect(1, 43263, '\p{Script_Extensions=:\Adevanagari\z:}', "");;
    Expect(0, 43264, '\p{Script_Extensions=:\Adevanagari\z:}', "");;
    Expect(1, 43263, '\p{Script_Extensions=		Devanagari}', "");
    Expect(0, 43263, '\p{^Script_Extensions=		Devanagari}', "");
    Expect(0, 43263, '\P{Script_Extensions=		Devanagari}', "");
    Expect(1, 43263, '\P{^Script_Extensions=		Devanagari}', "");
    Expect(0, 43264, '\p{Script_Extensions=		Devanagari}', "");
    Expect(1, 43264, '\p{^Script_Extensions=		Devanagari}', "");
    Expect(1, 43264, '\P{Script_Extensions=		Devanagari}', "");
    Expect(0, 43264, '\P{^Script_Extensions=		Devanagari}', "");
    Error('\p{Scx=_:=DEVA}');
    Error('\P{Scx=_:=DEVA}');
    Expect(1, 43263, '\p{Scx=:\ADeva\z:}', "");;
    Expect(0, 43264, '\p{Scx=:\ADeva\z:}', "");;
    Expect(1, 43263, '\p{Scx=deva}', "");
    Expect(0, 43263, '\p{^Scx=deva}', "");
    Expect(0, 43263, '\P{Scx=deva}', "");
    Expect(1, 43263, '\P{^Scx=deva}', "");
    Expect(0, 43264, '\p{Scx=deva}', "");
    Expect(1, 43264, '\p{^Scx=deva}', "");
    Expect(1, 43264, '\P{Scx=deva}', "");
    Expect(0, 43264, '\P{^Scx=deva}', "");
    Expect(1, 43263, '\p{Scx=:\Adeva\z:}', "");;
    Expect(0, 43264, '\p{Scx=:\Adeva\z:}', "");;
    Expect(1, 43263, '\p{Scx= deva}', "");
    Expect(0, 43263, '\p{^Scx= deva}', "");
    Expect(0, 43263, '\P{Scx= deva}', "");
    Expect(1, 43263, '\P{^Scx= deva}', "");
    Expect(0, 43264, '\p{Scx= deva}', "");
    Expect(1, 43264, '\p{^Scx= deva}', "");
    Expect(1, 43264, '\P{Scx= deva}', "");
    Expect(0, 43264, '\P{^Scx= deva}', "");
    Error('\p{Is_Script_Extensions=_devanagari/a/}');
    Error('\P{Is_Script_Extensions=_devanagari/a/}');
    Expect(1, 43263, '\p{Is_Script_Extensions=devanagari}', "");
    Expect(0, 43263, '\p{^Is_Script_Extensions=devanagari}', "");
    Expect(0, 43263, '\P{Is_Script_Extensions=devanagari}', "");
    Expect(1, 43263, '\P{^Is_Script_Extensions=devanagari}', "");
    Expect(0, 43264, '\p{Is_Script_Extensions=devanagari}', "");
    Expect(1, 43264, '\p{^Is_Script_Extensions=devanagari}', "");
    Expect(1, 43264, '\P{Is_Script_Extensions=devanagari}', "");
    Expect(0, 43264, '\P{^Is_Script_Extensions=devanagari}', "");
    Expect(1, 43263, '\p{Is_Script_Extensions= devanagari}', "");
    Expect(0, 43263, '\p{^Is_Script_Extensions= devanagari}', "");
    Expect(0, 43263, '\P{Is_Script_Extensions= devanagari}', "");
    Expect(1, 43263, '\P{^Is_Script_Extensions= devanagari}', "");
    Expect(0, 43264, '\p{Is_Script_Extensions= devanagari}', "");
    Expect(1, 43264, '\p{^Is_Script_Extensions= devanagari}', "");
    Expect(1, 43264, '\P{Is_Script_Extensions= devanagari}', "");
    Expect(0, 43264, '\P{^Is_Script_Extensions= devanagari}', "");
    Error('\p{Is_Scx=-_Deva/a/}');
    Error('\P{Is_Scx=-_Deva/a/}');
    Expect(1, 43263, '\p{Is_Scx=deva}', "");
    Expect(0, 43263, '\p{^Is_Scx=deva}', "");
    Expect(0, 43263, '\P{Is_Scx=deva}', "");
    Expect(1, 43263, '\P{^Is_Scx=deva}', "");
    Expect(0, 43264, '\p{Is_Scx=deva}', "");
    Expect(1, 43264, '\p{^Is_Scx=deva}', "");
    Expect(1, 43264, '\P{Is_Scx=deva}', "");
    Expect(0, 43264, '\P{^Is_Scx=deva}', "");
    Expect(1, 43263, '\p{Is_Scx= Deva}', "");
    Expect(0, 43263, '\p{^Is_Scx= Deva}', "");
    Expect(0, 43263, '\P{Is_Scx= Deva}', "");
    Expect(1, 43263, '\P{^Is_Scx= Deva}', "");
    Expect(0, 43264, '\p{Is_Scx= Deva}', "");
    Expect(1, 43264, '\p{^Is_Scx= Deva}', "");
    Expect(1, 43264, '\P{Is_Scx= Deva}', "");
    Expect(0, 43264, '\P{^Is_Scx= Deva}', "");
    Error('\p{Script_Extensions=_:=dives_akuru}');
    Error('\P{Script_Extensions=_:=dives_akuru}');
    Expect(1, 72025, '\p{Script_Extensions=:\ADives_Akuru\z:}', "");;
    Expect(0, 72026, '\p{Script_Extensions=:\ADives_Akuru\z:}', "");;
    Expect(1, 72025, '\p{Script_Extensions=divesakuru}', "");
    Expect(0, 72025, '\p{^Script_Extensions=divesakuru}', "");
    Expect(0, 72025, '\P{Script_Extensions=divesakuru}', "");
    Expect(1, 72025, '\P{^Script_Extensions=divesakuru}', "");
    Expect(0, 72026, '\p{Script_Extensions=divesakuru}', "");
    Expect(1, 72026, '\p{^Script_Extensions=divesakuru}', "");
    Expect(1, 72026, '\P{Script_Extensions=divesakuru}', "");
    Expect(0, 72026, '\P{^Script_Extensions=divesakuru}', "");
    Expect(1, 72025, '\p{Script_Extensions=:\Adivesakuru\z:}', "");;
    Expect(0, 72026, '\p{Script_Extensions=:\Adivesakuru\z:}', "");;
    Expect(1, 72025, '\p{Script_Extensions=-dives_akuru}', "");
    Expect(0, 72025, '\p{^Script_Extensions=-dives_akuru}', "");
    Expect(0, 72025, '\P{Script_Extensions=-dives_akuru}', "");
    Expect(1, 72025, '\P{^Script_Extensions=-dives_akuru}', "");
    Expect(0, 72026, '\p{Script_Extensions=-dives_akuru}', "");
    Expect(1, 72026, '\p{^Script_Extensions=-dives_akuru}', "");
    Expect(1, 72026, '\P{Script_Extensions=-dives_akuru}', "");
    Expect(0, 72026, '\P{^Script_Extensions=-dives_akuru}', "");
    Error('\p{Scx=:=-_diak}');
    Error('\P{Scx=:=-_diak}');
    Expect(1, 72025, '\p{Scx=:\ADiak\z:}', "");;
    Expect(0, 72026, '\p{Scx=:\ADiak\z:}', "");;
    Expect(1, 72025, '\p{Scx:   diak}', "");
    Expect(0, 72025, '\p{^Scx:   diak}', "");
    Expect(0, 72025, '\P{Scx:   diak}', "");
    Expect(1, 72025, '\P{^Scx:   diak}', "");
    Expect(0, 72026, '\p{Scx:   diak}', "");
    Expect(1, 72026, '\p{^Scx:   diak}', "");
    Expect(1, 72026, '\P{Scx:   diak}', "");
    Expect(0, 72026, '\P{^Scx:   diak}', "");
    Expect(1, 72025, '\p{Scx=:\Adiak\z:}', "");;
    Expect(0, 72026, '\p{Scx=:\Adiak\z:}', "");;
    Expect(1, 72025, '\p{Scx=_Diak}', "");
    Expect(0, 72025, '\p{^Scx=_Diak}', "");
    Expect(0, 72025, '\P{Scx=_Diak}', "");
    Expect(1, 72025, '\P{^Scx=_Diak}', "");
    Expect(0, 72026, '\p{Scx=_Diak}', "");
    Expect(1, 72026, '\p{^Scx=_Diak}', "");
    Expect(1, 72026, '\P{Scx=_Diak}', "");
    Expect(0, 72026, '\P{^Scx=_Diak}', "");
    Error('\p{Is_Script_Extensions=:=_-Dives_Akuru}');
    Error('\P{Is_Script_Extensions=:=_-Dives_Akuru}');
    Expect(1, 72025, '\p{Is_Script_Extensions=divesakuru}', "");
    Expect(0, 72025, '\p{^Is_Script_Extensions=divesakuru}', "");
    Expect(0, 72025, '\P{Is_Script_Extensions=divesakuru}', "");
    Expect(1, 72025, '\P{^Is_Script_Extensions=divesakuru}', "");
    Expect(0, 72026, '\p{Is_Script_Extensions=divesakuru}', "");
    Expect(1, 72026, '\p{^Is_Script_Extensions=divesakuru}', "");
    Expect(1, 72026, '\P{Is_Script_Extensions=divesakuru}', "");
    Expect(0, 72026, '\P{^Is_Script_Extensions=divesakuru}', "");
    Expect(1, 72025, '\p{Is_Script_Extensions:	 dives_AKURU}', "");
    Expect(0, 72025, '\p{^Is_Script_Extensions:	 dives_AKURU}', "");
    Expect(0, 72025, '\P{Is_Script_Extensions:	 dives_AKURU}', "");
    Expect(1, 72025, '\P{^Is_Script_Extensions:	 dives_AKURU}', "");
    Expect(0, 72026, '\p{Is_Script_Extensions:	 dives_AKURU}', "");
    Expect(1, 72026, '\p{^Is_Script_Extensions:	 dives_AKURU}', "");
    Expect(1, 72026, '\P{Is_Script_Extensions:	 dives_AKURU}', "");
    Expect(0, 72026, '\P{^Is_Script_Extensions:	 dives_AKURU}', "");
    Error('\p{Is_Scx=-:=DIAK}');
    Error('\P{Is_Scx=-:=DIAK}');
    Expect(1, 72025, '\p{Is_Scx=diak}', "");
    Expect(0, 72025, '\p{^Is_Scx=diak}', "");
    Expect(0, 72025, '\P{Is_Scx=diak}', "");
    Expect(1, 72025, '\P{^Is_Scx=diak}', "");
    Expect(0, 72026, '\p{Is_Scx=diak}', "");
    Expect(1, 72026, '\p{^Is_Scx=diak}', "");
    Expect(1, 72026, '\P{Is_Scx=diak}', "");
    Expect(0, 72026, '\P{^Is_Scx=diak}', "");
    Expect(1, 72025, '\p{Is_Scx:-DIAK}', "");
    Expect(0, 72025, '\p{^Is_Scx:-DIAK}', "");
    Expect(0, 72025, '\P{Is_Scx:-DIAK}', "");
    Expect(1, 72025, '\P{^Is_Scx:-DIAK}', "");
    Expect(0, 72026, '\p{Is_Scx:-DIAK}', "");
    Expect(1, 72026, '\p{^Is_Scx:-DIAK}', "");
    Expect(1, 72026, '\P{Is_Scx:-DIAK}', "");
    Expect(0, 72026, '\P{^Is_Scx:-DIAK}', "");
    Error('\p{Script_Extensions=:=Dogra}');
    Error('\P{Script_Extensions=:=Dogra}');
    Expect(1, 71739, '\p{Script_Extensions=:\ADogra\z:}', "");;
    Expect(0, 71740, '\p{Script_Extensions=:\ADogra\z:}', "");;
    Expect(1, 71739, '\p{Script_Extensions=dogra}', "");
    Expect(0, 71739, '\p{^Script_Extensions=dogra}', "");
    Expect(0, 71739, '\P{Script_Extensions=dogra}', "");
    Expect(1, 71739, '\P{^Script_Extensions=dogra}', "");
    Expect(0, 71740, '\p{Script_Extensions=dogra}', "");
    Expect(1, 71740, '\p{^Script_Extensions=dogra}', "");
    Expect(1, 71740, '\P{Script_Extensions=dogra}', "");
    Expect(0, 71740, '\P{^Script_Extensions=dogra}', "");
    Expect(1, 71739, '\p{Script_Extensions=:\Adogra\z:}', "");;
    Expect(0, 71740, '\p{Script_Extensions=:\Adogra\z:}', "");;
    Expect(1, 71739, '\p{Script_Extensions=_-DOGRA}', "");
    Expect(0, 71739, '\p{^Script_Extensions=_-DOGRA}', "");
    Expect(0, 71739, '\P{Script_Extensions=_-DOGRA}', "");
    Expect(1, 71739, '\P{^Script_Extensions=_-DOGRA}', "");
    Expect(0, 71740, '\p{Script_Extensions=_-DOGRA}', "");
    Expect(1, 71740, '\p{^Script_Extensions=_-DOGRA}', "");
    Expect(1, 71740, '\P{Script_Extensions=_-DOGRA}', "");
    Expect(0, 71740, '\P{^Script_Extensions=_-DOGRA}', "");
    Error('\p{Scx:	_/a/DOGR}');
    Error('\P{Scx:	_/a/DOGR}');
    Expect(1, 71739, '\p{Scx=:\ADogr\z:}', "");;
    Expect(0, 71740, '\p{Scx=:\ADogr\z:}', "");;
    Expect(1, 71739, '\p{Scx=dogr}', "");
    Expect(0, 71739, '\p{^Scx=dogr}', "");
    Expect(0, 71739, '\P{Scx=dogr}', "");
    Expect(1, 71739, '\P{^Scx=dogr}', "");
    Expect(0, 71740, '\p{Scx=dogr}', "");
    Expect(1, 71740, '\p{^Scx=dogr}', "");
    Expect(1, 71740, '\P{Scx=dogr}', "");
    Expect(0, 71740, '\P{^Scx=dogr}', "");
    Expect(1, 71739, '\p{Scx=:\Adogr\z:}', "");;
    Expect(0, 71740, '\p{Scx=:\Adogr\z:}', "");;
    Expect(1, 71739, '\p{Scx=_ Dogr}', "");
    Expect(0, 71739, '\p{^Scx=_ Dogr}', "");
    Expect(0, 71739, '\P{Scx=_ Dogr}', "");
    Expect(1, 71739, '\P{^Scx=_ Dogr}', "");
    Expect(0, 71740, '\p{Scx=_ Dogr}', "");
    Expect(1, 71740, '\p{^Scx=_ Dogr}', "");
    Expect(1, 71740, '\P{Scx=_ Dogr}', "");
    Expect(0, 71740, '\P{^Scx=_ Dogr}', "");
    Error('\p{Is_Script_Extensions:	_-dogra:=}');
    Error('\P{Is_Script_Extensions:	_-dogra:=}');
    Expect(1, 71739, '\p{Is_Script_Extensions=dogra}', "");
    Expect(0, 71739, '\p{^Is_Script_Extensions=dogra}', "");
    Expect(0, 71739, '\P{Is_Script_Extensions=dogra}', "");
    Expect(1, 71739, '\P{^Is_Script_Extensions=dogra}', "");
    Expect(0, 71740, '\p{Is_Script_Extensions=dogra}', "");
    Expect(1, 71740, '\p{^Is_Script_Extensions=dogra}', "");
    Expect(1, 71740, '\P{Is_Script_Extensions=dogra}', "");
    Expect(0, 71740, '\P{^Is_Script_Extensions=dogra}', "");
    Expect(1, 71739, '\p{Is_Script_Extensions=	-Dogra}', "");
    Expect(0, 71739, '\p{^Is_Script_Extensions=	-Dogra}', "");
    Expect(0, 71739, '\P{Is_Script_Extensions=	-Dogra}', "");
    Expect(1, 71739, '\P{^Is_Script_Extensions=	-Dogra}', "");
    Expect(0, 71740, '\p{Is_Script_Extensions=	-Dogra}', "");
    Expect(1, 71740, '\p{^Is_Script_Extensions=	-Dogra}', "");
    Expect(1, 71740, '\P{Is_Script_Extensions=	-Dogra}', "");
    Expect(0, 71740, '\P{^Is_Script_Extensions=	-Dogra}', "");
    Error('\p{Is_Scx=/a/- Dogr}');
    Error('\P{Is_Scx=/a/- Dogr}');
    Expect(1, 71739, '\p{Is_Scx=dogr}', "");
    Expect(0, 71739, '\p{^Is_Scx=dogr}', "");
    Expect(0, 71739, '\P{Is_Scx=dogr}', "");
    Expect(1, 71739, '\P{^Is_Scx=dogr}', "");
    Expect(0, 71740, '\p{Is_Scx=dogr}', "");
    Expect(1, 71740, '\p{^Is_Scx=dogr}', "");
    Expect(1, 71740, '\P{Is_Scx=dogr}', "");
    Expect(0, 71740, '\P{^Is_Scx=dogr}', "");
    Expect(1, 71739, '\p{Is_Scx= DOGR}', "");
    Expect(0, 71739, '\p{^Is_Scx= DOGR}', "");
    Expect(0, 71739, '\P{Is_Scx= DOGR}', "");
    Expect(1, 71739, '\P{^Is_Scx= DOGR}', "");
    Expect(0, 71740, '\p{Is_Scx= DOGR}', "");
    Expect(1, 71740, '\p{^Is_Scx= DOGR}', "");
    Expect(1, 71740, '\P{Is_Scx= DOGR}', "");
    Expect(0, 71740, '\P{^Is_Scx= DOGR}', "");
    Error('\p{Script_Extensions=  Deseret:=}');
    Error('\P{Script_Extensions=  Deseret:=}');
    Expect(1, 66639, '\p{Script_Extensions=:\ADeseret\z:}', "");;
    Expect(0, 66640, '\p{Script_Extensions=:\ADeseret\z:}', "");;
    Expect(1, 66639, '\p{Script_Extensions=deseret}', "");
    Expect(0, 66639, '\p{^Script_Extensions=deseret}', "");
    Expect(0, 66639, '\P{Script_Extensions=deseret}', "");
    Expect(1, 66639, '\P{^Script_Extensions=deseret}', "");
    Expect(0, 66640, '\p{Script_Extensions=deseret}', "");
    Expect(1, 66640, '\p{^Script_Extensions=deseret}', "");
    Expect(1, 66640, '\P{Script_Extensions=deseret}', "");
    Expect(0, 66640, '\P{^Script_Extensions=deseret}', "");
    Expect(1, 66639, '\p{Script_Extensions=:\Adeseret\z:}', "");;
    Expect(0, 66640, '\p{Script_Extensions=:\Adeseret\z:}', "");;
    Expect(1, 66639, '\p{Script_Extensions:--deseret}', "");
    Expect(0, 66639, '\p{^Script_Extensions:--deseret}', "");
    Expect(0, 66639, '\P{Script_Extensions:--deseret}', "");
    Expect(1, 66639, '\P{^Script_Extensions:--deseret}', "");
    Expect(0, 66640, '\p{Script_Extensions:--deseret}', "");
    Expect(1, 66640, '\p{^Script_Extensions:--deseret}', "");
    Expect(1, 66640, '\P{Script_Extensions:--deseret}', "");
    Expect(0, 66640, '\P{^Script_Extensions:--deseret}', "");
    Error('\p{Scx=:=Dsrt}');
    Error('\P{Scx=:=Dsrt}');
    Expect(1, 66639, '\p{Scx=:\ADsrt\z:}', "");;
    Expect(0, 66640, '\p{Scx=:\ADsrt\z:}', "");;
    Expect(1, 66639, '\p{Scx=dsrt}', "");
    Expect(0, 66639, '\p{^Scx=dsrt}', "");
    Expect(0, 66639, '\P{Scx=dsrt}', "");
    Expect(1, 66639, '\P{^Scx=dsrt}', "");
    Expect(0, 66640, '\p{Scx=dsrt}', "");
    Expect(1, 66640, '\p{^Scx=dsrt}', "");
    Expect(1, 66640, '\P{Scx=dsrt}', "");
    Expect(0, 66640, '\P{^Scx=dsrt}', "");
    Expect(1, 66639, '\p{Scx=:\Adsrt\z:}', "");;
    Expect(0, 66640, '\p{Scx=:\Adsrt\z:}', "");;
    Expect(1, 66639, '\p{Scx=__DSRT}', "");
    Expect(0, 66639, '\p{^Scx=__DSRT}', "");
    Expect(0, 66639, '\P{Scx=__DSRT}', "");
    Expect(1, 66639, '\P{^Scx=__DSRT}', "");
    Expect(0, 66640, '\p{Scx=__DSRT}', "");
    Expect(1, 66640, '\p{^Scx=__DSRT}', "");
    Expect(1, 66640, '\P{Scx=__DSRT}', "");
    Expect(0, 66640, '\P{^Scx=__DSRT}', "");
    Error('\p{Is_Script_Extensions:   - Deseret/a/}');
    Error('\P{Is_Script_Extensions:   - Deseret/a/}');
    Expect(1, 66639, '\p{Is_Script_Extensions=deseret}', "");
    Expect(0, 66639, '\p{^Is_Script_Extensions=deseret}', "");
    Expect(0, 66639, '\P{Is_Script_Extensions=deseret}', "");
    Expect(1, 66639, '\P{^Is_Script_Extensions=deseret}', "");
    Expect(0, 66640, '\p{Is_Script_Extensions=deseret}', "");
    Expect(1, 66640, '\p{^Is_Script_Extensions=deseret}', "");
    Expect(1, 66640, '\P{Is_Script_Extensions=deseret}', "");
    Expect(0, 66640, '\P{^Is_Script_Extensions=deseret}', "");
    Expect(1, 66639, '\p{Is_Script_Extensions:	deseret}', "");
    Expect(0, 66639, '\p{^Is_Script_Extensions:	deseret}', "");
    Expect(0, 66639, '\P{Is_Script_Extensions:	deseret}', "");
    Expect(1, 66639, '\P{^Is_Script_Extensions:	deseret}', "");
    Expect(0, 66640, '\p{Is_Script_Extensions:	deseret}', "");
    Expect(1, 66640, '\p{^Is_Script_Extensions:	deseret}', "");
    Expect(1, 66640, '\P{Is_Script_Extensions:	deseret}', "");
    Expect(0, 66640, '\P{^Is_Script_Extensions:	deseret}', "");
    Error('\p{Is_Scx=/a/-dsrt}');
    Error('\P{Is_Scx=/a/-dsrt}');
    Expect(1, 66639, '\p{Is_Scx=dsrt}', "");
    Expect(0, 66639, '\p{^Is_Scx=dsrt}', "");
    Expect(0, 66639, '\P{Is_Scx=dsrt}', "");
    Expect(1, 66639, '\P{^Is_Scx=dsrt}', "");
    Expect(0, 66640, '\p{Is_Scx=dsrt}', "");
    Expect(1, 66640, '\p{^Is_Scx=dsrt}', "");
    Expect(1, 66640, '\P{Is_Scx=dsrt}', "");
    Expect(0, 66640, '\P{^Is_Scx=dsrt}', "");
    Expect(1, 66639, '\p{Is_Scx=	Dsrt}', "");
    Expect(0, 66639, '\p{^Is_Scx=	Dsrt}', "");
    Expect(0, 66639, '\P{Is_Scx=	Dsrt}', "");
    Expect(1, 66639, '\P{^Is_Scx=	Dsrt}', "");
    Expect(0, 66640, '\p{Is_Scx=	Dsrt}', "");
    Expect(1, 66640, '\p{^Is_Scx=	Dsrt}', "");
    Expect(1, 66640, '\P{Is_Scx=	Dsrt}', "");
    Expect(0, 66640, '\P{^Is_Scx=	Dsrt}', "");
    Error('\p{Script_Extensions=/a/ duployan}');
    Error('\P{Script_Extensions=/a/ duployan}');
    Expect(1, 113827, '\p{Script_Extensions=:\ADuployan\z:}', "");;
    Expect(0, 113828, '\p{Script_Extensions=:\ADuployan\z:}', "");;
    Expect(1, 113827, '\p{Script_Extensions=duployan}', "");
    Expect(0, 113827, '\p{^Script_Extensions=duployan}', "");
    Expect(0, 113827, '\P{Script_Extensions=duployan}', "");
    Expect(1, 113827, '\P{^Script_Extensions=duployan}', "");
    Expect(0, 113828, '\p{Script_Extensions=duployan}', "");
    Expect(1, 113828, '\p{^Script_Extensions=duployan}', "");
    Expect(1, 113828, '\P{Script_Extensions=duployan}', "");
    Expect(0, 113828, '\P{^Script_Extensions=duployan}', "");
    Expect(1, 113827, '\p{Script_Extensions=:\Aduployan\z:}', "");;
    Expect(0, 113828, '\p{Script_Extensions=:\Aduployan\z:}', "");;
    Expect(1, 113827, '\p{Script_Extensions= 	Duployan}', "");
    Expect(0, 113827, '\p{^Script_Extensions= 	Duployan}', "");
    Expect(0, 113827, '\P{Script_Extensions= 	Duployan}', "");
    Expect(1, 113827, '\P{^Script_Extensions= 	Duployan}', "");
    Expect(0, 113828, '\p{Script_Extensions= 	Duployan}', "");
    Expect(1, 113828, '\p{^Script_Extensions= 	Duployan}', "");
    Expect(1, 113828, '\P{Script_Extensions= 	Duployan}', "");
    Expect(0, 113828, '\P{^Script_Extensions= 	Duployan}', "");
    Error('\p{Scx=/a/ _Dupl}');
    Error('\P{Scx=/a/ _Dupl}');
    Expect(1, 113827, '\p{Scx=:\ADupl\z:}', "");;
    Expect(0, 113828, '\p{Scx=:\ADupl\z:}', "");;
    Expect(1, 113827, '\p{Scx=dupl}', "");
    Expect(0, 113827, '\p{^Scx=dupl}', "");
    Expect(0, 113827, '\P{Scx=dupl}', "");
    Expect(1, 113827, '\P{^Scx=dupl}', "");
    Expect(0, 113828, '\p{Scx=dupl}', "");
    Expect(1, 113828, '\p{^Scx=dupl}', "");
    Expect(1, 113828, '\P{Scx=dupl}', "");
    Expect(0, 113828, '\P{^Scx=dupl}', "");
    Expect(1, 113827, '\p{Scx=:\Adupl\z:}', "");;
    Expect(0, 113828, '\p{Scx=:\Adupl\z:}', "");;
    Expect(1, 113827, '\p{Scx= -Dupl}', "");
    Expect(0, 113827, '\p{^Scx= -Dupl}', "");
    Expect(0, 113827, '\P{Scx= -Dupl}', "");
    Expect(1, 113827, '\P{^Scx= -Dupl}', "");
    Expect(0, 113828, '\p{Scx= -Dupl}', "");
    Expect(1, 113828, '\p{^Scx= -Dupl}', "");
    Expect(1, 113828, '\P{Scx= -Dupl}', "");
    Expect(0, 113828, '\P{^Scx= -Dupl}', "");
    Error('\p{Is_Script_Extensions= /a/Duployan}');
    Error('\P{Is_Script_Extensions= /a/Duployan}');
    Expect(1, 113827, '\p{Is_Script_Extensions=duployan}', "");
    Expect(0, 113827, '\p{^Is_Script_Extensions=duployan}', "");
    Expect(0, 113827, '\P{Is_Script_Extensions=duployan}', "");
    Expect(1, 113827, '\P{^Is_Script_Extensions=duployan}', "");
    Expect(0, 113828, '\p{Is_Script_Extensions=duployan}', "");
    Expect(1, 113828, '\p{^Is_Script_Extensions=duployan}', "");
    Expect(1, 113828, '\P{Is_Script_Extensions=duployan}', "");
    Expect(0, 113828, '\P{^Is_Script_Extensions=duployan}', "");
    Expect(1, 113827, '\p{Is_Script_Extensions=_-Duployan}', "");
    Expect(0, 113827, '\p{^Is_Script_Extensions=_-Duployan}', "");
    Expect(0, 113827, '\P{Is_Script_Extensions=_-Duployan}', "");
    Expect(1, 113827, '\P{^Is_Script_Extensions=_-Duployan}', "");
    Expect(0, 113828, '\p{Is_Script_Extensions=_-Duployan}', "");
    Expect(1, 113828, '\p{^Is_Script_Extensions=_-Duployan}', "");
    Expect(1, 113828, '\P{Is_Script_Extensions=_-Duployan}', "");
    Expect(0, 113828, '\P{^Is_Script_Extensions=_-Duployan}', "");
    Error('\p{Is_Scx=:= _dupl}');
    Error('\P{Is_Scx=:= _dupl}');
    Expect(1, 113827, '\p{Is_Scx=dupl}', "");
    Expect(0, 113827, '\p{^Is_Scx=dupl}', "");
    Expect(0, 113827, '\P{Is_Scx=dupl}', "");
    Expect(1, 113827, '\P{^Is_Scx=dupl}', "");
    Expect(0, 113828, '\p{Is_Scx=dupl}', "");
    Expect(1, 113828, '\p{^Is_Scx=dupl}', "");
    Expect(1, 113828, '\P{Is_Scx=dupl}', "");
    Expect(0, 113828, '\P{^Is_Scx=dupl}', "");
    Expect(1, 113827, '\p{Is_Scx=-Dupl}', "");
    Expect(0, 113827, '\p{^Is_Scx=-Dupl}', "");
    Expect(0, 113827, '\P{Is_Scx=-Dupl}', "");
    Expect(1, 113827, '\P{^Is_Scx=-Dupl}', "");
    Expect(0, 113828, '\p{Is_Scx=-Dupl}', "");
    Expect(1, 113828, '\p{^Is_Scx=-Dupl}', "");
    Expect(1, 113828, '\P{Is_Scx=-Dupl}', "");
    Expect(0, 113828, '\P{^Is_Scx=-Dupl}', "");
    Error('\p{Script_Extensions= :=egyptian_HIEROGLYPHS}');
    Error('\P{Script_Extensions= :=egyptian_HIEROGLYPHS}');
    Expect(1, 78904, '\p{Script_Extensions=:\AEgyptian_Hieroglyphs\z:}', "");;
    Expect(0, 78905, '\p{Script_Extensions=:\AEgyptian_Hieroglyphs\z:}', "");;
    Expect(1, 78904, '\p{Script_Extensions=egyptianhieroglyphs}', "");
    Expect(0, 78904, '\p{^Script_Extensions=egyptianhieroglyphs}', "");
    Expect(0, 78904, '\P{Script_Extensions=egyptianhieroglyphs}', "");
    Expect(1, 78904, '\P{^Script_Extensions=egyptianhieroglyphs}', "");
    Expect(0, 78905, '\p{Script_Extensions=egyptianhieroglyphs}', "");
    Expect(1, 78905, '\p{^Script_Extensions=egyptianhieroglyphs}', "");
    Expect(1, 78905, '\P{Script_Extensions=egyptianhieroglyphs}', "");
    Expect(0, 78905, '\P{^Script_Extensions=egyptianhieroglyphs}', "");
    Expect(1, 78904, '\p{Script_Extensions=:\Aegyptianhieroglyphs\z:}', "");;
    Expect(0, 78905, '\p{Script_Extensions=:\Aegyptianhieroglyphs\z:}', "");;
    Expect(1, 78904, '\p{Script_Extensions=_-egyptian_Hieroglyphs}', "");
    Expect(0, 78904, '\p{^Script_Extensions=_-egyptian_Hieroglyphs}', "");
    Expect(0, 78904, '\P{Script_Extensions=_-egyptian_Hieroglyphs}', "");
    Expect(1, 78904, '\P{^Script_Extensions=_-egyptian_Hieroglyphs}', "");
    Expect(0, 78905, '\p{Script_Extensions=_-egyptian_Hieroglyphs}', "");
    Expect(1, 78905, '\p{^Script_Extensions=_-egyptian_Hieroglyphs}', "");
    Expect(1, 78905, '\P{Script_Extensions=_-egyptian_Hieroglyphs}', "");
    Expect(0, 78905, '\P{^Script_Extensions=_-egyptian_Hieroglyphs}', "");
    Error('\p{Scx=-:=Egyp}');
    Error('\P{Scx=-:=Egyp}');
    Expect(1, 78904, '\p{Scx=:\AEgyp\z:}', "");;
    Expect(0, 78905, '\p{Scx=:\AEgyp\z:}', "");;
    Expect(1, 78904, '\p{Scx=egyp}', "");
    Expect(0, 78904, '\p{^Scx=egyp}', "");
    Expect(0, 78904, '\P{Scx=egyp}', "");
    Expect(1, 78904, '\P{^Scx=egyp}', "");
    Expect(0, 78905, '\p{Scx=egyp}', "");
    Expect(1, 78905, '\p{^Scx=egyp}', "");
    Expect(1, 78905, '\P{Scx=egyp}', "");
    Expect(0, 78905, '\P{^Scx=egyp}', "");
    Expect(1, 78904, '\p{Scx=:\Aegyp\z:}', "");;
    Expect(0, 78905, '\p{Scx=:\Aegyp\z:}', "");;
    Expect(1, 78904, '\p{Scx=__egyp}', "");
    Expect(0, 78904, '\p{^Scx=__egyp}', "");
    Expect(0, 78904, '\P{Scx=__egyp}', "");
    Expect(1, 78904, '\P{^Scx=__egyp}', "");
    Expect(0, 78905, '\p{Scx=__egyp}', "");
    Expect(1, 78905, '\p{^Scx=__egyp}', "");
    Expect(1, 78905, '\P{Scx=__egyp}', "");
    Expect(0, 78905, '\P{^Scx=__egyp}', "");
    Error('\p{Is_Script_Extensions=_EGYPTIAN_Hieroglyphs:=}');
    Error('\P{Is_Script_Extensions=_EGYPTIAN_Hieroglyphs:=}');
    Expect(1, 78904, '\p{Is_Script_Extensions=egyptianhieroglyphs}', "");
    Expect(0, 78904, '\p{^Is_Script_Extensions=egyptianhieroglyphs}', "");
    Expect(0, 78904, '\P{Is_Script_Extensions=egyptianhieroglyphs}', "");
    Expect(1, 78904, '\P{^Is_Script_Extensions=egyptianhieroglyphs}', "");
    Expect(0, 78905, '\p{Is_Script_Extensions=egyptianhieroglyphs}', "");
    Expect(1, 78905, '\p{^Is_Script_Extensions=egyptianhieroglyphs}', "");
    Expect(1, 78905, '\P{Is_Script_Extensions=egyptianhieroglyphs}', "");
    Expect(0, 78905, '\P{^Is_Script_Extensions=egyptianhieroglyphs}', "");
    Expect(1, 78904, '\p{Is_Script_Extensions=egyptian_HIEROGLYPHS}', "");
    Expect(0, 78904, '\p{^Is_Script_Extensions=egyptian_HIEROGLYPHS}', "");
    Expect(0, 78904, '\P{Is_Script_Extensions=egyptian_HIEROGLYPHS}', "");
    Expect(1, 78904, '\P{^Is_Script_Extensions=egyptian_HIEROGLYPHS}', "");
    Expect(0, 78905, '\p{Is_Script_Extensions=egyptian_HIEROGLYPHS}', "");
    Expect(1, 78905, '\p{^Is_Script_Extensions=egyptian_HIEROGLYPHS}', "");
    Expect(1, 78905, '\P{Is_Script_Extensions=egyptian_HIEROGLYPHS}', "");
    Expect(0, 78905, '\P{^Is_Script_Extensions=egyptian_HIEROGLYPHS}', "");
    Error('\p{Is_Scx=/a/_	Egyp}');
    Error('\P{Is_Scx=/a/_	Egyp}');
    Expect(1, 78904, '\p{Is_Scx=egyp}', "");
    Expect(0, 78904, '\p{^Is_Scx=egyp}', "");
    Expect(0, 78904, '\P{Is_Scx=egyp}', "");
    Expect(1, 78904, '\P{^Is_Scx=egyp}', "");
    Expect(0, 78905, '\p{Is_Scx=egyp}', "");
    Expect(1, 78905, '\p{^Is_Scx=egyp}', "");
    Expect(1, 78905, '\P{Is_Scx=egyp}', "");
    Expect(0, 78905, '\P{^Is_Scx=egyp}', "");
    Expect(1, 78904, '\p{Is_Scx=_	EGYP}', "");
    Expect(0, 78904, '\p{^Is_Scx=_	EGYP}', "");
    Expect(0, 78904, '\P{Is_Scx=_	EGYP}', "");
    Expect(1, 78904, '\P{^Is_Scx=_	EGYP}', "");
    Expect(0, 78905, '\p{Is_Scx=_	EGYP}', "");
    Expect(1, 78905, '\p{^Is_Scx=_	EGYP}', "");
    Expect(1, 78905, '\P{Is_Scx=_	EGYP}', "");
    Expect(0, 78905, '\P{^Is_Scx=_	EGYP}', "");
    Error('\p{Script_Extensions= :=elbasan}');
    Error('\P{Script_Extensions= :=elbasan}');
    Expect(1, 66855, '\p{Script_Extensions=:\AElbasan\z:}', "");;
    Expect(0, 66856, '\p{Script_Extensions=:\AElbasan\z:}', "");;
    Expect(1, 66855, '\p{Script_Extensions=elbasan}', "");
    Expect(0, 66855, '\p{^Script_Extensions=elbasan}', "");
    Expect(0, 66855, '\P{Script_Extensions=elbasan}', "");
    Expect(1, 66855, '\P{^Script_Extensions=elbasan}', "");
    Expect(0, 66856, '\p{Script_Extensions=elbasan}', "");
    Expect(1, 66856, '\p{^Script_Extensions=elbasan}', "");
    Expect(1, 66856, '\P{Script_Extensions=elbasan}', "");
    Expect(0, 66856, '\P{^Script_Extensions=elbasan}', "");
    Expect(1, 66855, '\p{Script_Extensions=:\Aelbasan\z:}', "");;
    Expect(0, 66856, '\p{Script_Extensions=:\Aelbasan\z:}', "");;
    Expect(1, 66855, '\p{Script_Extensions= _Elbasan}', "");
    Expect(0, 66855, '\p{^Script_Extensions= _Elbasan}', "");
    Expect(0, 66855, '\P{Script_Extensions= _Elbasan}', "");
    Expect(1, 66855, '\P{^Script_Extensions= _Elbasan}', "");
    Expect(0, 66856, '\p{Script_Extensions= _Elbasan}', "");
    Expect(1, 66856, '\p{^Script_Extensions= _Elbasan}', "");
    Expect(1, 66856, '\P{Script_Extensions= _Elbasan}', "");
    Expect(0, 66856, '\P{^Script_Extensions= _Elbasan}', "");
    Error('\p{Scx=-	ELBA:=}');
    Error('\P{Scx=-	ELBA:=}');
    Expect(1, 66855, '\p{Scx=:\AElba\z:}', "");;
    Expect(0, 66856, '\p{Scx=:\AElba\z:}', "");;
    Expect(1, 66855, '\p{Scx:elba}', "");
    Expect(0, 66855, '\p{^Scx:elba}', "");
    Expect(0, 66855, '\P{Scx:elba}', "");
    Expect(1, 66855, '\P{^Scx:elba}', "");
    Expect(0, 66856, '\p{Scx:elba}', "");
    Expect(1, 66856, '\p{^Scx:elba}', "");
    Expect(1, 66856, '\P{Scx:elba}', "");
    Expect(0, 66856, '\P{^Scx:elba}', "");
    Expect(1, 66855, '\p{Scx=:\Aelba\z:}', "");;
    Expect(0, 66856, '\p{Scx=:\Aelba\z:}', "");;
    Expect(1, 66855, '\p{Scx=-_Elba}', "");
    Expect(0, 66855, '\p{^Scx=-_Elba}', "");
    Expect(0, 66855, '\P{Scx=-_Elba}', "");
    Expect(1, 66855, '\P{^Scx=-_Elba}', "");
    Expect(0, 66856, '\p{Scx=-_Elba}', "");
    Expect(1, 66856, '\p{^Scx=-_Elba}', "");
    Expect(1, 66856, '\P{Scx=-_Elba}', "");
    Expect(0, 66856, '\P{^Scx=-_Elba}', "");
    Error('\p{Is_Script_Extensions=-:=elbasan}');
    Error('\P{Is_Script_Extensions=-:=elbasan}');
    Expect(1, 66855, '\p{Is_Script_Extensions: elbasan}', "");
    Expect(0, 66855, '\p{^Is_Script_Extensions: elbasan}', "");
    Expect(0, 66855, '\P{Is_Script_Extensions: elbasan}', "");
    Expect(1, 66855, '\P{^Is_Script_Extensions: elbasan}', "");
    Expect(0, 66856, '\p{Is_Script_Extensions: elbasan}', "");
    Expect(1, 66856, '\p{^Is_Script_Extensions: elbasan}', "");
    Expect(1, 66856, '\P{Is_Script_Extensions: elbasan}', "");
    Expect(0, 66856, '\P{^Is_Script_Extensions: elbasan}', "");
    Expect(1, 66855, '\p{Is_Script_Extensions=-Elbasan}', "");
    Expect(0, 66855, '\p{^Is_Script_Extensions=-Elbasan}', "");
    Expect(0, 66855, '\P{Is_Script_Extensions=-Elbasan}', "");
    Expect(1, 66855, '\P{^Is_Script_Extensions=-Elbasan}', "");
    Expect(0, 66856, '\p{Is_Script_Extensions=-Elbasan}', "");
    Expect(1, 66856, '\p{^Is_Script_Extensions=-Elbasan}', "");
    Expect(1, 66856, '\P{Is_Script_Extensions=-Elbasan}', "");
    Expect(0, 66856, '\P{^Is_Script_Extensions=-Elbasan}', "");
    Error('\p{Is_Scx=_/a/Elba}');
    Error('\P{Is_Scx=_/a/Elba}');
    Expect(1, 66855, '\p{Is_Scx=elba}', "");
    Expect(0, 66855, '\p{^Is_Scx=elba}', "");
    Expect(0, 66855, '\P{Is_Scx=elba}', "");
    Expect(1, 66855, '\P{^Is_Scx=elba}', "");
    Expect(0, 66856, '\p{Is_Scx=elba}', "");
    Expect(1, 66856, '\p{^Is_Scx=elba}', "");
    Expect(1, 66856, '\P{Is_Scx=elba}', "");
    Expect(0, 66856, '\P{^Is_Scx=elba}', "");
    Expect(1, 66855, '\p{Is_Scx=_Elba}', "");
    Expect(0, 66855, '\p{^Is_Scx=_Elba}', "");
    Expect(0, 66855, '\P{Is_Scx=_Elba}', "");
    Expect(1, 66855, '\P{^Is_Scx=_Elba}', "");
    Expect(0, 66856, '\p{Is_Scx=_Elba}', "");
    Expect(1, 66856, '\p{^Is_Scx=_Elba}', "");
    Expect(1, 66856, '\P{Is_Scx=_Elba}', "");
    Expect(0, 66856, '\P{^Is_Scx=_Elba}', "");
    Error('\p{Script_Extensions=--ELYMAIC:=}');
    Error('\P{Script_Extensions=--ELYMAIC:=}');
    Expect(1, 69622, '\p{Script_Extensions=:\AElymaic\z:}', "");;
    Expect(0, 69623, '\p{Script_Extensions=:\AElymaic\z:}', "");;
    Expect(1, 69622, '\p{Script_Extensions=elymaic}', "");
    Expect(0, 69622, '\p{^Script_Extensions=elymaic}', "");
    Expect(0, 69622, '\P{Script_Extensions=elymaic}', "");
    Expect(1, 69622, '\P{^Script_Extensions=elymaic}', "");
    Expect(0, 69623, '\p{Script_Extensions=elymaic}', "");
    Expect(1, 69623, '\p{^Script_Extensions=elymaic}', "");
    Expect(1, 69623, '\P{Script_Extensions=elymaic}', "");
    Expect(0, 69623, '\P{^Script_Extensions=elymaic}', "");
    Expect(1, 69622, '\p{Script_Extensions=:\Aelymaic\z:}', "");;
    Expect(0, 69623, '\p{Script_Extensions=:\Aelymaic\z:}', "");;
    Expect(1, 69622, '\p{Script_Extensions= -Elymaic}', "");
    Expect(0, 69622, '\p{^Script_Extensions= -Elymaic}', "");
    Expect(0, 69622, '\P{Script_Extensions= -Elymaic}', "");
    Expect(1, 69622, '\P{^Script_Extensions= -Elymaic}', "");
    Expect(0, 69623, '\p{Script_Extensions= -Elymaic}', "");
    Expect(1, 69623, '\p{^Script_Extensions= -Elymaic}', "");
    Expect(1, 69623, '\P{Script_Extensions= -Elymaic}', "");
    Expect(0, 69623, '\P{^Script_Extensions= -Elymaic}', "");
    Error('\p{Scx=/a/_-elym}');
    Error('\P{Scx=/a/_-elym}');
    Expect(1, 69622, '\p{Scx=:\AElym\z:}', "");;
    Expect(0, 69623, '\p{Scx=:\AElym\z:}', "");;
    Expect(1, 69622, '\p{Scx=elym}', "");
    Expect(0, 69622, '\p{^Scx=elym}', "");
    Expect(0, 69622, '\P{Scx=elym}', "");
    Expect(1, 69622, '\P{^Scx=elym}', "");
    Expect(0, 69623, '\p{Scx=elym}', "");
    Expect(1, 69623, '\p{^Scx=elym}', "");
    Expect(1, 69623, '\P{Scx=elym}', "");
    Expect(0, 69623, '\P{^Scx=elym}', "");
    Expect(1, 69622, '\p{Scx=:\Aelym\z:}', "");;
    Expect(0, 69623, '\p{Scx=:\Aelym\z:}', "");;
    Expect(1, 69622, '\p{Scx=	_Elym}', "");
    Expect(0, 69622, '\p{^Scx=	_Elym}', "");
    Expect(0, 69622, '\P{Scx=	_Elym}', "");
    Expect(1, 69622, '\P{^Scx=	_Elym}', "");
    Expect(0, 69623, '\p{Scx=	_Elym}', "");
    Expect(1, 69623, '\p{^Scx=	_Elym}', "");
    Expect(1, 69623, '\P{Scx=	_Elym}', "");
    Expect(0, 69623, '\P{^Scx=	_Elym}', "");
    Error('\p{Is_Script_Extensions=_ Elymaic:=}');
    Error('\P{Is_Script_Extensions=_ Elymaic:=}');
    Expect(1, 69622, '\p{Is_Script_Extensions=elymaic}', "");
    Expect(0, 69622, '\p{^Is_Script_Extensions=elymaic}', "");
    Expect(0, 69622, '\P{Is_Script_Extensions=elymaic}', "");
    Expect(1, 69622, '\P{^Is_Script_Extensions=elymaic}', "");
    Expect(0, 69623, '\p{Is_Script_Extensions=elymaic}', "");
    Expect(1, 69623, '\p{^Is_Script_Extensions=elymaic}', "");
    Expect(1, 69623, '\P{Is_Script_Extensions=elymaic}', "");
    Expect(0, 69623, '\P{^Is_Script_Extensions=elymaic}', "");
    Expect(1, 69622, '\p{Is_Script_Extensions:_-elymaic}', "");
    Expect(0, 69622, '\p{^Is_Script_Extensions:_-elymaic}', "");
    Expect(0, 69622, '\P{Is_Script_Extensions:_-elymaic}', "");
    Expect(1, 69622, '\P{^Is_Script_Extensions:_-elymaic}', "");
    Expect(0, 69623, '\p{Is_Script_Extensions:_-elymaic}', "");
    Expect(1, 69623, '\p{^Is_Script_Extensions:_-elymaic}', "");
    Expect(1, 69623, '\P{Is_Script_Extensions:_-elymaic}', "");
    Expect(0, 69623, '\P{^Is_Script_Extensions:_-elymaic}', "");
    Error('\p{Is_Scx=	 ELYM/a/}');
    Error('\P{Is_Scx=	 ELYM/a/}');
    Expect(1, 69622, '\p{Is_Scx=elym}', "");
    Expect(0, 69622, '\p{^Is_Scx=elym}', "");
    Expect(0, 69622, '\P{Is_Scx=elym}', "");
    Expect(1, 69622, '\P{^Is_Scx=elym}', "");
    Expect(0, 69623, '\p{Is_Scx=elym}', "");
    Expect(1, 69623, '\p{^Is_Scx=elym}', "");
    Expect(1, 69623, '\P{Is_Scx=elym}', "");
    Expect(0, 69623, '\P{^Is_Scx=elym}', "");
    Expect(1, 69622, '\p{Is_Scx:   __Elym}', "");
    Expect(0, 69622, '\p{^Is_Scx:   __Elym}', "");
    Expect(0, 69622, '\P{Is_Scx:   __Elym}', "");
    Expect(1, 69622, '\P{^Is_Scx:   __Elym}', "");
    Expect(0, 69623, '\p{Is_Scx:   __Elym}', "");
    Expect(1, 69623, '\p{^Is_Scx:   __Elym}', "");
    Expect(1, 69623, '\P{Is_Scx:   __Elym}', "");
    Expect(0, 69623, '\P{^Is_Scx:   __Elym}', "");
    Error('\p{Script_Extensions=/a/-Ethiopic}');
    Error('\P{Script_Extensions=/a/-Ethiopic}');
    Expect(1, 43822, '\p{Script_Extensions=:\AEthiopic\z:}', "");;
    Expect(0, 43823, '\p{Script_Extensions=:\AEthiopic\z:}', "");;
    Expect(1, 43822, '\p{Script_Extensions=ethiopic}', "");
    Expect(0, 43822, '\p{^Script_Extensions=ethiopic}', "");
    Expect(0, 43822, '\P{Script_Extensions=ethiopic}', "");
    Expect(1, 43822, '\P{^Script_Extensions=ethiopic}', "");
    Expect(0, 43823, '\p{Script_Extensions=ethiopic}', "");
    Expect(1, 43823, '\p{^Script_Extensions=ethiopic}', "");
    Expect(1, 43823, '\P{Script_Extensions=ethiopic}', "");
    Expect(0, 43823, '\P{^Script_Extensions=ethiopic}', "");
    Expect(1, 43822, '\p{Script_Extensions=:\Aethiopic\z:}', "");;
    Expect(0, 43823, '\p{Script_Extensions=:\Aethiopic\z:}', "");;
    Expect(1, 43822, '\p{Script_Extensions=_ Ethiopic}', "");
    Expect(0, 43822, '\p{^Script_Extensions=_ Ethiopic}', "");
    Expect(0, 43822, '\P{Script_Extensions=_ Ethiopic}', "");
    Expect(1, 43822, '\P{^Script_Extensions=_ Ethiopic}', "");
    Expect(0, 43823, '\p{Script_Extensions=_ Ethiopic}', "");
    Expect(1, 43823, '\p{^Script_Extensions=_ Ethiopic}', "");
    Expect(1, 43823, '\P{Script_Extensions=_ Ethiopic}', "");
    Expect(0, 43823, '\P{^Script_Extensions=_ Ethiopic}', "");
    Error('\p{Scx=	/a/Ethi}');
    Error('\P{Scx=	/a/Ethi}');
    Expect(1, 43822, '\p{Scx=:\AEthi\z:}', "");;
    Expect(0, 43823, '\p{Scx=:\AEthi\z:}', "");;
    Expect(1, 43822, '\p{Scx=ethi}', "");
    Expect(0, 43822, '\p{^Scx=ethi}', "");
    Expect(0, 43822, '\P{Scx=ethi}', "");
    Expect(1, 43822, '\P{^Scx=ethi}', "");
    Expect(0, 43823, '\p{Scx=ethi}', "");
    Expect(1, 43823, '\p{^Scx=ethi}', "");
    Expect(1, 43823, '\P{Scx=ethi}', "");
    Expect(0, 43823, '\P{^Scx=ethi}', "");
    Expect(1, 43822, '\p{Scx=:\Aethi\z:}', "");;
    Expect(0, 43823, '\p{Scx=:\Aethi\z:}', "");;
    Expect(1, 43822, '\p{Scx=_ ETHI}', "");
    Expect(0, 43822, '\p{^Scx=_ ETHI}', "");
    Expect(0, 43822, '\P{Scx=_ ETHI}', "");
    Expect(1, 43822, '\P{^Scx=_ ETHI}', "");
    Expect(0, 43823, '\p{Scx=_ ETHI}', "");
    Expect(1, 43823, '\p{^Scx=_ ETHI}', "");
    Expect(1, 43823, '\P{Scx=_ ETHI}', "");
    Expect(0, 43823, '\P{^Scx=_ ETHI}', "");
    Error('\p{Is_Script_Extensions=-_ethiopic:=}');
    Error('\P{Is_Script_Extensions=-_ethiopic:=}');
    Expect(1, 43822, '\p{Is_Script_Extensions=ethiopic}', "");
    Expect(0, 43822, '\p{^Is_Script_Extensions=ethiopic}', "");
    Expect(0, 43822, '\P{Is_Script_Extensions=ethiopic}', "");
    Expect(1, 43822, '\P{^Is_Script_Extensions=ethiopic}', "");
    Expect(0, 43823, '\p{Is_Script_Extensions=ethiopic}', "");
    Expect(1, 43823, '\p{^Is_Script_Extensions=ethiopic}', "");
    Expect(1, 43823, '\P{Is_Script_Extensions=ethiopic}', "");
    Expect(0, 43823, '\P{^Is_Script_Extensions=ethiopic}', "");
    Expect(1, 43822, '\p{Is_Script_Extensions=	 Ethiopic}', "");
    Expect(0, 43822, '\p{^Is_Script_Extensions=	 Ethiopic}', "");
    Expect(0, 43822, '\P{Is_Script_Extensions=	 Ethiopic}', "");
    Expect(1, 43822, '\P{^Is_Script_Extensions=	 Ethiopic}', "");
    Expect(0, 43823, '\p{Is_Script_Extensions=	 Ethiopic}', "");
    Expect(1, 43823, '\p{^Is_Script_Extensions=	 Ethiopic}', "");
    Expect(1, 43823, '\P{Is_Script_Extensions=	 Ethiopic}', "");
    Expect(0, 43823, '\P{^Is_Script_Extensions=	 Ethiopic}', "");
    Error('\p{Is_Scx=/a/ 	ethi}');
    Error('\P{Is_Scx=/a/ 	ethi}');
    Expect(1, 43822, '\p{Is_Scx=ethi}', "");
    Expect(0, 43822, '\p{^Is_Scx=ethi}', "");
    Expect(0, 43822, '\P{Is_Scx=ethi}', "");
    Expect(1, 43822, '\P{^Is_Scx=ethi}', "");
    Expect(0, 43823, '\p{Is_Scx=ethi}', "");
    Expect(1, 43823, '\p{^Is_Scx=ethi}', "");
    Expect(1, 43823, '\P{Is_Scx=ethi}', "");
    Expect(0, 43823, '\P{^Is_Scx=ethi}', "");
    Expect(1, 43822, '\p{Is_Scx:   -ETHI}', "");
    Expect(0, 43822, '\p{^Is_Scx:   -ETHI}', "");
    Expect(0, 43822, '\P{Is_Scx:   -ETHI}', "");
    Expect(1, 43822, '\P{^Is_Scx:   -ETHI}', "");
    Expect(0, 43823, '\p{Is_Scx:   -ETHI}', "");
    Expect(1, 43823, '\p{^Is_Scx:   -ETHI}', "");
    Expect(1, 43823, '\P{Is_Scx:   -ETHI}', "");
    Expect(0, 43823, '\P{^Is_Scx:   -ETHI}', "");
    Error('\p{Script_Extensions= :=georgian}');
    Error('\P{Script_Extensions= :=georgian}');
    Expect(1, 11565, '\p{Script_Extensions=:\AGeorgian\z:}', "");;
    Expect(0, 11566, '\p{Script_Extensions=:\AGeorgian\z:}', "");;
    Expect(1, 11565, '\p{Script_Extensions=georgian}', "");
    Expect(0, 11565, '\p{^Script_Extensions=georgian}', "");
    Expect(0, 11565, '\P{Script_Extensions=georgian}', "");
    Expect(1, 11565, '\P{^Script_Extensions=georgian}', "");
    Expect(0, 11566, '\p{Script_Extensions=georgian}', "");
    Expect(1, 11566, '\p{^Script_Extensions=georgian}', "");
    Expect(1, 11566, '\P{Script_Extensions=georgian}', "");
    Expect(0, 11566, '\P{^Script_Extensions=georgian}', "");
    Expect(1, 11565, '\p{Script_Extensions=:\Ageorgian\z:}', "");;
    Expect(0, 11566, '\p{Script_Extensions=:\Ageorgian\z:}', "");;
    Expect(1, 11565, '\p{Script_Extensions=_	Georgian}', "");
    Expect(0, 11565, '\p{^Script_Extensions=_	Georgian}', "");
    Expect(0, 11565, '\P{Script_Extensions=_	Georgian}', "");
    Expect(1, 11565, '\P{^Script_Extensions=_	Georgian}', "");
    Expect(0, 11566, '\p{Script_Extensions=_	Georgian}', "");
    Expect(1, 11566, '\p{^Script_Extensions=_	Georgian}', "");
    Expect(1, 11566, '\P{Script_Extensions=_	Georgian}', "");
    Expect(0, 11566, '\P{^Script_Extensions=_	Georgian}', "");
    Error('\p{Scx=_/a/Geor}');
    Error('\P{Scx=_/a/Geor}');
    Expect(1, 11565, '\p{Scx=:\AGeor\z:}', "");;
    Expect(0, 11566, '\p{Scx=:\AGeor\z:}', "");;
    Expect(1, 11565, '\p{Scx=geor}', "");
    Expect(0, 11565, '\p{^Scx=geor}', "");
    Expect(0, 11565, '\P{Scx=geor}', "");
    Expect(1, 11565, '\P{^Scx=geor}', "");
    Expect(0, 11566, '\p{Scx=geor}', "");
    Expect(1, 11566, '\p{^Scx=geor}', "");
    Expect(1, 11566, '\P{Scx=geor}', "");
    Expect(0, 11566, '\P{^Scx=geor}', "");
    Expect(1, 11565, '\p{Scx=:\Ageor\z:}', "");;
    Expect(0, 11566, '\p{Scx=:\Ageor\z:}', "");;
    Expect(1, 11565, '\p{Scx=-Geor}', "");
    Expect(0, 11565, '\p{^Scx=-Geor}', "");
    Expect(0, 11565, '\P{Scx=-Geor}', "");
    Expect(1, 11565, '\P{^Scx=-Geor}', "");
    Expect(0, 11566, '\p{Scx=-Geor}', "");
    Expect(1, 11566, '\p{^Scx=-Geor}', "");
    Expect(1, 11566, '\P{Scx=-Geor}', "");
    Expect(0, 11566, '\P{^Scx=-Geor}', "");
    Error('\p{Is_Script_Extensions:--Georgian/a/}');
    Error('\P{Is_Script_Extensions:--Georgian/a/}');
    Expect(1, 11565, '\p{Is_Script_Extensions=georgian}', "");
    Expect(0, 11565, '\p{^Is_Script_Extensions=georgian}', "");
    Expect(0, 11565, '\P{Is_Script_Extensions=georgian}', "");
    Expect(1, 11565, '\P{^Is_Script_Extensions=georgian}', "");
    Expect(0, 11566, '\p{Is_Script_Extensions=georgian}', "");
    Expect(1, 11566, '\p{^Is_Script_Extensions=georgian}', "");
    Expect(1, 11566, '\P{Is_Script_Extensions=georgian}', "");
    Expect(0, 11566, '\P{^Is_Script_Extensions=georgian}', "");
    Expect(1, 11565, '\p{Is_Script_Extensions=-Georgian}', "");
    Expect(0, 11565, '\p{^Is_Script_Extensions=-Georgian}', "");
    Expect(0, 11565, '\P{Is_Script_Extensions=-Georgian}', "");
    Expect(1, 11565, '\P{^Is_Script_Extensions=-Georgian}', "");
    Expect(0, 11566, '\p{Is_Script_Extensions=-Georgian}', "");
    Expect(1, 11566, '\p{^Is_Script_Extensions=-Georgian}', "");
    Expect(1, 11566, '\P{Is_Script_Extensions=-Georgian}', "");
    Expect(0, 11566, '\P{^Is_Script_Extensions=-Georgian}', "");
    Error('\p{Is_Scx:   :=Geor}');
    Error('\P{Is_Scx:   :=Geor}');
    Expect(1, 11565, '\p{Is_Scx:	geor}', "");
    Expect(0, 11565, '\p{^Is_Scx:	geor}', "");
    Expect(0, 11565, '\P{Is_Scx:	geor}', "");
    Expect(1, 11565, '\P{^Is_Scx:	geor}', "");
    Expect(0, 11566, '\p{Is_Scx:	geor}', "");
    Expect(1, 11566, '\p{^Is_Scx:	geor}', "");
    Expect(1, 11566, '\P{Is_Scx:	geor}', "");
    Expect(0, 11566, '\P{^Is_Scx:	geor}', "");
    Expect(1, 11565, '\p{Is_Scx=	Geor}', "");
    Expect(0, 11565, '\p{^Is_Scx=	Geor}', "");
    Expect(0, 11565, '\P{Is_Scx=	Geor}', "");
    Expect(1, 11565, '\P{^Is_Scx=	Geor}', "");
    Expect(0, 11566, '\p{Is_Scx=	Geor}', "");
    Expect(1, 11566, '\p{^Is_Scx=	Geor}', "");
    Expect(1, 11566, '\P{Is_Scx=	Geor}', "");
    Expect(0, 11566, '\P{^Is_Scx=	Geor}', "");
    Error('\p{Script_Extensions:   /a/_-glagolitic}');
    Error('\P{Script_Extensions:   /a/_-glagolitic}');
    Expect(1, 122922, '\p{Script_Extensions=:\AGlagolitic\z:}', "");;
    Expect(0, 122923, '\p{Script_Extensions=:\AGlagolitic\z:}', "");;
    Expect(1, 122922, '\p{Script_Extensions=glagolitic}', "");
    Expect(0, 122922, '\p{^Script_Extensions=glagolitic}', "");
    Expect(0, 122922, '\P{Script_Extensions=glagolitic}', "");
    Expect(1, 122922, '\P{^Script_Extensions=glagolitic}', "");
    Expect(0, 122923, '\p{Script_Extensions=glagolitic}', "");
    Expect(1, 122923, '\p{^Script_Extensions=glagolitic}', "");
    Expect(1, 122923, '\P{Script_Extensions=glagolitic}', "");
    Expect(0, 122923, '\P{^Script_Extensions=glagolitic}', "");
    Expect(1, 122922, '\p{Script_Extensions=:\Aglagolitic\z:}', "");;
    Expect(0, 122923, '\p{Script_Extensions=:\Aglagolitic\z:}', "");;
    Expect(1, 122922, '\p{Script_Extensions: 	GLAGOLITIC}', "");
    Expect(0, 122922, '\p{^Script_Extensions: 	GLAGOLITIC}', "");
    Expect(0, 122922, '\P{Script_Extensions: 	GLAGOLITIC}', "");
    Expect(1, 122922, '\P{^Script_Extensions: 	GLAGOLITIC}', "");
    Expect(0, 122923, '\p{Script_Extensions: 	GLAGOLITIC}', "");
    Expect(1, 122923, '\p{^Script_Extensions: 	GLAGOLITIC}', "");
    Expect(1, 122923, '\P{Script_Extensions: 	GLAGOLITIC}', "");
    Expect(0, 122923, '\P{^Script_Extensions: 	GLAGOLITIC}', "");
    Error('\p{Scx=- Glag/a/}');
    Error('\P{Scx=- Glag/a/}');
    Expect(1, 122922, '\p{Scx=:\AGlag\z:}', "");;
    Expect(0, 122923, '\p{Scx=:\AGlag\z:}', "");;
    Expect(1, 122922, '\p{Scx=glag}', "");
    Expect(0, 122922, '\p{^Scx=glag}', "");
    Expect(0, 122922, '\P{Scx=glag}', "");
    Expect(1, 122922, '\P{^Scx=glag}', "");
    Expect(0, 122923, '\p{Scx=glag}', "");
    Expect(1, 122923, '\p{^Scx=glag}', "");
    Expect(1, 122923, '\P{Scx=glag}', "");
    Expect(0, 122923, '\P{^Scx=glag}', "");
    Expect(1, 122922, '\p{Scx=:\Aglag\z:}', "");;
    Expect(0, 122923, '\p{Scx=:\Aglag\z:}', "");;
    Expect(1, 122922, '\p{Scx=Glag}', "");
    Expect(0, 122922, '\p{^Scx=Glag}', "");
    Expect(0, 122922, '\P{Scx=Glag}', "");
    Expect(1, 122922, '\P{^Scx=Glag}', "");
    Expect(0, 122923, '\p{Scx=Glag}', "");
    Expect(1, 122923, '\p{^Scx=Glag}', "");
    Expect(1, 122923, '\P{Scx=Glag}', "");
    Expect(0, 122923, '\P{^Scx=Glag}', "");
    Error('\p{Is_Script_Extensions=- Glagolitic/a/}');
    Error('\P{Is_Script_Extensions=- Glagolitic/a/}');
    Expect(1, 122922, '\p{Is_Script_Extensions=glagolitic}', "");
    Expect(0, 122922, '\p{^Is_Script_Extensions=glagolitic}', "");
    Expect(0, 122922, '\P{Is_Script_Extensions=glagolitic}', "");
    Expect(1, 122922, '\P{^Is_Script_Extensions=glagolitic}', "");
    Expect(0, 122923, '\p{Is_Script_Extensions=glagolitic}', "");
    Expect(1, 122923, '\p{^Is_Script_Extensions=glagolitic}', "");
    Expect(1, 122923, '\P{Is_Script_Extensions=glagolitic}', "");
    Expect(0, 122923, '\P{^Is_Script_Extensions=glagolitic}', "");
    Expect(1, 122922, '\p{Is_Script_Extensions= -Glagolitic}', "");
    Expect(0, 122922, '\p{^Is_Script_Extensions= -Glagolitic}', "");
    Expect(0, 122922, '\P{Is_Script_Extensions= -Glagolitic}', "");
    Expect(1, 122922, '\P{^Is_Script_Extensions= -Glagolitic}', "");
    Expect(0, 122923, '\p{Is_Script_Extensions= -Glagolitic}', "");
    Expect(1, 122923, '\p{^Is_Script_Extensions= -Glagolitic}', "");
    Expect(1, 122923, '\P{Is_Script_Extensions= -Glagolitic}', "");
    Expect(0, 122923, '\P{^Is_Script_Extensions= -Glagolitic}', "");
    Error('\p{Is_Scx=/a/		Glag}');
    Error('\P{Is_Scx=/a/		Glag}');
    Expect(1, 122922, '\p{Is_Scx=glag}', "");
    Expect(0, 122922, '\p{^Is_Scx=glag}', "");
    Expect(0, 122922, '\P{Is_Scx=glag}', "");
    Expect(1, 122922, '\P{^Is_Scx=glag}', "");
    Expect(0, 122923, '\p{Is_Scx=glag}', "");
    Expect(1, 122923, '\p{^Is_Scx=glag}', "");
    Expect(1, 122923, '\P{Is_Scx=glag}', "");
    Expect(0, 122923, '\P{^Is_Scx=glag}', "");
    Expect(1, 122922, '\p{Is_Scx=	 GLAG}', "");
    Expect(0, 122922, '\p{^Is_Scx=	 GLAG}', "");
    Expect(0, 122922, '\P{Is_Scx=	 GLAG}', "");
    Expect(1, 122922, '\P{^Is_Scx=	 GLAG}', "");
    Expect(0, 122923, '\p{Is_Scx=	 GLAG}', "");
    Expect(1, 122923, '\p{^Is_Scx=	 GLAG}', "");
    Expect(1, 122923, '\P{Is_Scx=	 GLAG}', "");
    Expect(0, 122923, '\P{^Is_Scx=	 GLAG}', "");
    Error('\p{Script_Extensions=-_Gunjala_Gondi/a/}');
    Error('\P{Script_Extensions=-_Gunjala_Gondi/a/}');
    Expect(1, 73129, '\p{Script_Extensions=:\AGunjala_Gondi\z:}', "");;
    Expect(0, 73130, '\p{Script_Extensions=:\AGunjala_Gondi\z:}', "");;
    Expect(1, 73129, '\p{Script_Extensions=gunjalagondi}', "");
    Expect(0, 73129, '\p{^Script_Extensions=gunjalagondi}', "");
    Expect(0, 73129, '\P{Script_Extensions=gunjalagondi}', "");
    Expect(1, 73129, '\P{^Script_Extensions=gunjalagondi}', "");
    Expect(0, 73130, '\p{Script_Extensions=gunjalagondi}', "");
    Expect(1, 73130, '\p{^Script_Extensions=gunjalagondi}', "");
    Expect(1, 73130, '\P{Script_Extensions=gunjalagondi}', "");
    Expect(0, 73130, '\P{^Script_Extensions=gunjalagondi}', "");
    Expect(1, 73129, '\p{Script_Extensions=:\Agunjalagondi\z:}', "");;
    Expect(0, 73130, '\p{Script_Extensions=:\Agunjalagondi\z:}', "");;
    Expect(1, 73129, '\p{Script_Extensions=_Gunjala_Gondi}', "");
    Expect(0, 73129, '\p{^Script_Extensions=_Gunjala_Gondi}', "");
    Expect(0, 73129, '\P{Script_Extensions=_Gunjala_Gondi}', "");
    Expect(1, 73129, '\P{^Script_Extensions=_Gunjala_Gondi}', "");
    Expect(0, 73130, '\p{Script_Extensions=_Gunjala_Gondi}', "");
    Expect(1, 73130, '\p{^Script_Extensions=_Gunjala_Gondi}', "");
    Expect(1, 73130, '\P{Script_Extensions=_Gunjala_Gondi}', "");
    Expect(0, 73130, '\P{^Script_Extensions=_Gunjala_Gondi}', "");
    Error('\p{Scx=-	GONG:=}');
    Error('\P{Scx=-	GONG:=}');
    Expect(1, 73129, '\p{Scx=:\AGong\z:}', "");;
    Expect(0, 73130, '\p{Scx=:\AGong\z:}', "");;
    Expect(1, 73129, '\p{Scx=gong}', "");
    Expect(0, 73129, '\p{^Scx=gong}', "");
    Expect(0, 73129, '\P{Scx=gong}', "");
    Expect(1, 73129, '\P{^Scx=gong}', "");
    Expect(0, 73130, '\p{Scx=gong}', "");
    Expect(1, 73130, '\p{^Scx=gong}', "");
    Expect(1, 73130, '\P{Scx=gong}', "");
    Expect(0, 73130, '\P{^Scx=gong}', "");
    Expect(1, 73129, '\p{Scx=:\Agong\z:}', "");;
    Expect(0, 73130, '\p{Scx=:\Agong\z:}', "");;
    Expect(1, 73129, '\p{Scx=	gong}', "");
    Expect(0, 73129, '\p{^Scx=	gong}', "");
    Expect(0, 73129, '\P{Scx=	gong}', "");
    Expect(1, 73129, '\P{^Scx=	gong}', "");
    Expect(0, 73130, '\p{Scx=	gong}', "");
    Expect(1, 73130, '\p{^Scx=	gong}', "");
    Expect(1, 73130, '\P{Scx=	gong}', "");
    Expect(0, 73130, '\P{^Scx=	gong}', "");
    Error('\p{Is_Script_Extensions=:=_	gunjala_Gondi}');
    Error('\P{Is_Script_Extensions=:=_	gunjala_Gondi}');
    Expect(1, 73129, '\p{Is_Script_Extensions=gunjalagondi}', "");
    Expect(0, 73129, '\p{^Is_Script_Extensions=gunjalagondi}', "");
    Expect(0, 73129, '\P{Is_Script_Extensions=gunjalagondi}', "");
    Expect(1, 73129, '\P{^Is_Script_Extensions=gunjalagondi}', "");
    Expect(0, 73130, '\p{Is_Script_Extensions=gunjalagondi}', "");
    Expect(1, 73130, '\p{^Is_Script_Extensions=gunjalagondi}', "");
    Expect(1, 73130, '\P{Is_Script_Extensions=gunjalagondi}', "");
    Expect(0, 73130, '\P{^Is_Script_Extensions=gunjalagondi}', "");
    Expect(1, 73129, '\p{Is_Script_Extensions=-GUNJALA_gondi}', "");
    Expect(0, 73129, '\p{^Is_Script_Extensions=-GUNJALA_gondi}', "");
    Expect(0, 73129, '\P{Is_Script_Extensions=-GUNJALA_gondi}', "");
    Expect(1, 73129, '\P{^Is_Script_Extensions=-GUNJALA_gondi}', "");
    Expect(0, 73130, '\p{Is_Script_Extensions=-GUNJALA_gondi}', "");
    Expect(1, 73130, '\p{^Is_Script_Extensions=-GUNJALA_gondi}', "");
    Expect(1, 73130, '\P{Is_Script_Extensions=-GUNJALA_gondi}', "");
    Expect(0, 73130, '\P{^Is_Script_Extensions=-GUNJALA_gondi}', "");
    Error('\p{Is_Scx=-/a/Gong}');
    Error('\P{Is_Scx=-/a/Gong}');
    Expect(1, 73129, '\p{Is_Scx=gong}', "");
    Expect(0, 73129, '\p{^Is_Scx=gong}', "");
    Expect(0, 73129, '\P{Is_Scx=gong}', "");
    Expect(1, 73129, '\P{^Is_Scx=gong}', "");
    Expect(0, 73130, '\p{Is_Scx=gong}', "");
    Expect(1, 73130, '\p{^Is_Scx=gong}', "");
    Expect(1, 73130, '\P{Is_Scx=gong}', "");
    Expect(0, 73130, '\P{^Is_Scx=gong}', "");
    Expect(1, 73129, '\p{Is_Scx=__GONG}', "");
    Expect(0, 73129, '\p{^Is_Scx=__GONG}', "");
    Expect(0, 73129, '\P{Is_Scx=__GONG}', "");
    Expect(1, 73129, '\P{^Is_Scx=__GONG}', "");
    Expect(0, 73130, '\p{Is_Scx=__GONG}', "");
    Expect(1, 73130, '\p{^Is_Scx=__GONG}', "");
    Expect(1, 73130, '\P{Is_Scx=__GONG}', "");
    Expect(0, 73130, '\P{^Is_Scx=__GONG}', "");
    Error('\p{Script_Extensions=/a/--Masaram_GONDI}');
    Error('\P{Script_Extensions=/a/--Masaram_GONDI}');
    Expect(1, 73049, '\p{Script_Extensions=:\AMasaram_Gondi\z:}', "");;
    Expect(0, 73050, '\p{Script_Extensions=:\AMasaram_Gondi\z:}', "");;
    Expect(1, 73049, '\p{Script_Extensions=masaramgondi}', "");
    Expect(0, 73049, '\p{^Script_Extensions=masaramgondi}', "");
    Expect(0, 73049, '\P{Script_Extensions=masaramgondi}', "");
    Expect(1, 73049, '\P{^Script_Extensions=masaramgondi}', "");
    Expect(0, 73050, '\p{Script_Extensions=masaramgondi}', "");
    Expect(1, 73050, '\p{^Script_Extensions=masaramgondi}', "");
    Expect(1, 73050, '\P{Script_Extensions=masaramgondi}', "");
    Expect(0, 73050, '\P{^Script_Extensions=masaramgondi}', "");
    Expect(1, 73049, '\p{Script_Extensions=:\Amasaramgondi\z:}', "");;
    Expect(0, 73050, '\p{Script_Extensions=:\Amasaramgondi\z:}', "");;
    Expect(1, 73049, '\p{Script_Extensions:  _Masaram_gondi}', "");
    Expect(0, 73049, '\p{^Script_Extensions:  _Masaram_gondi}', "");
    Expect(0, 73049, '\P{Script_Extensions:  _Masaram_gondi}', "");
    Expect(1, 73049, '\P{^Script_Extensions:  _Masaram_gondi}', "");
    Expect(0, 73050, '\p{Script_Extensions:  _Masaram_gondi}', "");
    Expect(1, 73050, '\p{^Script_Extensions:  _Masaram_gondi}', "");
    Expect(1, 73050, '\P{Script_Extensions:  _Masaram_gondi}', "");
    Expect(0, 73050, '\P{^Script_Extensions:  _Masaram_gondi}', "");
    Error('\p{Scx=- Gonm:=}');
    Error('\P{Scx=- Gonm:=}');
    Expect(1, 73049, '\p{Scx=:\AGonm\z:}', "");;
    Expect(0, 73050, '\p{Scx=:\AGonm\z:}', "");;
    Expect(1, 73049, '\p{Scx=gonm}', "");
    Expect(0, 73049, '\p{^Scx=gonm}', "");
    Expect(0, 73049, '\P{Scx=gonm}', "");
    Expect(1, 73049, '\P{^Scx=gonm}', "");
    Expect(0, 73050, '\p{Scx=gonm}', "");
    Expect(1, 73050, '\p{^Scx=gonm}', "");
    Expect(1, 73050, '\P{Scx=gonm}', "");
    Expect(0, 73050, '\P{^Scx=gonm}', "");
    Expect(1, 73049, '\p{Scx=:\Agonm\z:}', "");;
    Expect(0, 73050, '\p{Scx=:\Agonm\z:}', "");;
    Expect(1, 73049, '\p{Scx=-_Gonm}', "");
    Expect(0, 73049, '\p{^Scx=-_Gonm}', "");
    Expect(0, 73049, '\P{Scx=-_Gonm}', "");
    Expect(1, 73049, '\P{^Scx=-_Gonm}', "");
    Expect(0, 73050, '\p{Scx=-_Gonm}', "");
    Expect(1, 73050, '\p{^Scx=-_Gonm}', "");
    Expect(1, 73050, '\P{Scx=-_Gonm}', "");
    Expect(0, 73050, '\P{^Scx=-_Gonm}', "");
    Error('\p{Is_Script_Extensions=-:=MASARAM_gondi}');
    Error('\P{Is_Script_Extensions=-:=MASARAM_gondi}');
    Expect(1, 73049, '\p{Is_Script_Extensions=masaramgondi}', "");
    Expect(0, 73049, '\p{^Is_Script_Extensions=masaramgondi}', "");
    Expect(0, 73049, '\P{Is_Script_Extensions=masaramgondi}', "");
    Expect(1, 73049, '\P{^Is_Script_Extensions=masaramgondi}', "");
    Expect(0, 73050, '\p{Is_Script_Extensions=masaramgondi}', "");
    Expect(1, 73050, '\p{^Is_Script_Extensions=masaramgondi}', "");
    Expect(1, 73050, '\P{Is_Script_Extensions=masaramgondi}', "");
    Expect(0, 73050, '\P{^Is_Script_Extensions=masaramgondi}', "");
    Expect(1, 73049, '\p{Is_Script_Extensions= 	Masaram_gondi}', "");
    Expect(0, 73049, '\p{^Is_Script_Extensions= 	Masaram_gondi}', "");
    Expect(0, 73049, '\P{Is_Script_Extensions= 	Masaram_gondi}', "");
    Expect(1, 73049, '\P{^Is_Script_Extensions= 	Masaram_gondi}', "");
    Expect(0, 73050, '\p{Is_Script_Extensions= 	Masaram_gondi}', "");
    Expect(1, 73050, '\p{^Is_Script_Extensions= 	Masaram_gondi}', "");
    Expect(1, 73050, '\P{Is_Script_Extensions= 	Masaram_gondi}', "");
    Expect(0, 73050, '\P{^Is_Script_Extensions= 	Masaram_gondi}', "");
    Error('\p{Is_Scx=	Gonm:=}');
    Error('\P{Is_Scx=	Gonm:=}');
    Expect(1, 73049, '\p{Is_Scx:	gonm}', "");
    Expect(0, 73049, '\p{^Is_Scx:	gonm}', "");
    Expect(0, 73049, '\P{Is_Scx:	gonm}', "");
    Expect(1, 73049, '\P{^Is_Scx:	gonm}', "");
    Expect(0, 73050, '\p{Is_Scx:	gonm}', "");
    Expect(1, 73050, '\p{^Is_Scx:	gonm}', "");
    Expect(1, 73050, '\P{Is_Scx:	gonm}', "");
    Expect(0, 73050, '\P{^Is_Scx:	gonm}', "");
    Expect(1, 73049, '\p{Is_Scx=_ GONM}', "");
    Expect(0, 73049, '\p{^Is_Scx=_ GONM}', "");
    Expect(0, 73049, '\P{Is_Scx=_ GONM}', "");
    Expect(1, 73049, '\P{^Is_Scx=_ GONM}', "");
    Expect(0, 73050, '\p{Is_Scx=_ GONM}', "");
    Expect(1, 73050, '\p{^Is_Scx=_ GONM}', "");
    Expect(1, 73050, '\P{Is_Scx=_ GONM}', "");
    Expect(0, 73050, '\P{^Is_Scx=_ GONM}', "");
    Error('\p{Script_Extensions= 	gothic/a/}');
    Error('\P{Script_Extensions= 	gothic/a/}');
    Expect(1, 66378, '\p{Script_Extensions=:\AGothic\z:}', "");;
    Expect(0, 66379, '\p{Script_Extensions=:\AGothic\z:}', "");;
    Expect(1, 66378, '\p{Script_Extensions:	gothic}', "");
    Expect(0, 66378, '\p{^Script_Extensions:	gothic}', "");
    Expect(0, 66378, '\P{Script_Extensions:	gothic}', "");
    Expect(1, 66378, '\P{^Script_Extensions:	gothic}', "");
    Expect(0, 66379, '\p{Script_Extensions:	gothic}', "");
    Expect(1, 66379, '\p{^Script_Extensions:	gothic}', "");
    Expect(1, 66379, '\P{Script_Extensions:	gothic}', "");
    Expect(0, 66379, '\P{^Script_Extensions:	gothic}', "");
    Expect(1, 66378, '\p{Script_Extensions=:\Agothic\z:}', "");;
    Expect(0, 66379, '\p{Script_Extensions=:\Agothic\z:}', "");;
    Expect(1, 66378, '\p{Script_Extensions=-Gothic}', "");
    Expect(0, 66378, '\p{^Script_Extensions=-Gothic}', "");
    Expect(0, 66378, '\P{Script_Extensions=-Gothic}', "");
    Expect(1, 66378, '\P{^Script_Extensions=-Gothic}', "");
    Expect(0, 66379, '\p{Script_Extensions=-Gothic}', "");
    Expect(1, 66379, '\p{^Script_Extensions=-Gothic}', "");
    Expect(1, 66379, '\P{Script_Extensions=-Gothic}', "");
    Expect(0, 66379, '\P{^Script_Extensions=-Gothic}', "");
    Error('\p{Scx=_	GOTH/a/}');
    Error('\P{Scx=_	GOTH/a/}');
    Expect(1, 66378, '\p{Scx=:\AGoth\z:}', "");;
    Expect(0, 66379, '\p{Scx=:\AGoth\z:}', "");;
    Expect(1, 66378, '\p{Scx=goth}', "");
    Expect(0, 66378, '\p{^Scx=goth}', "");
    Expect(0, 66378, '\P{Scx=goth}', "");
    Expect(1, 66378, '\P{^Scx=goth}', "");
    Expect(0, 66379, '\p{Scx=goth}', "");
    Expect(1, 66379, '\p{^Scx=goth}', "");
    Expect(1, 66379, '\P{Scx=goth}', "");
    Expect(0, 66379, '\P{^Scx=goth}', "");
    Expect(1, 66378, '\p{Scx=:\Agoth\z:}', "");;
    Expect(0, 66379, '\p{Scx=:\Agoth\z:}', "");;
    Expect(1, 66378, '\p{Scx=__Goth}', "");
    Expect(0, 66378, '\p{^Scx=__Goth}', "");
    Expect(0, 66378, '\P{Scx=__Goth}', "");
    Expect(1, 66378, '\P{^Scx=__Goth}', "");
    Expect(0, 66379, '\p{Scx=__Goth}', "");
    Expect(1, 66379, '\p{^Scx=__Goth}', "");
    Expect(1, 66379, '\P{Scx=__Goth}', "");
    Expect(0, 66379, '\P{^Scx=__Goth}', "");
    Error('\p{Is_Script_Extensions=	 GOTHIC/a/}');
    Error('\P{Is_Script_Extensions=	 GOTHIC/a/}');
    Expect(1, 66378, '\p{Is_Script_Extensions=gothic}', "");
    Expect(0, 66378, '\p{^Is_Script_Extensions=gothic}', "");
    Expect(0, 66378, '\P{Is_Script_Extensions=gothic}', "");
    Expect(1, 66378, '\P{^Is_Script_Extensions=gothic}', "");
    Expect(0, 66379, '\p{Is_Script_Extensions=gothic}', "");
    Expect(1, 66379, '\p{^Is_Script_Extensions=gothic}', "");
    Expect(1, 66379, '\P{Is_Script_Extensions=gothic}', "");
    Expect(0, 66379, '\P{^Is_Script_Extensions=gothic}', "");
    Expect(1, 66378, '\p{Is_Script_Extensions=	 gothic}', "");
    Expect(0, 66378, '\p{^Is_Script_Extensions=	 gothic}', "");
    Expect(0, 66378, '\P{Is_Script_Extensions=	 gothic}', "");
    Expect(1, 66378, '\P{^Is_Script_Extensions=	 gothic}', "");
    Expect(0, 66379, '\p{Is_Script_Extensions=	 gothic}', "");
    Expect(1, 66379, '\p{^Is_Script_Extensions=	 gothic}', "");
    Expect(1, 66379, '\P{Is_Script_Extensions=	 gothic}', "");
    Expect(0, 66379, '\P{^Is_Script_Extensions=	 gothic}', "");
    Error('\p{Is_Scx=--Goth:=}');
    Error('\P{Is_Scx=--Goth:=}');
    Expect(1, 66378, '\p{Is_Scx=goth}', "");
    Expect(0, 66378, '\p{^Is_Scx=goth}', "");
    Expect(0, 66378, '\P{Is_Scx=goth}', "");
    Expect(1, 66378, '\P{^Is_Scx=goth}', "");
    Expect(0, 66379, '\p{Is_Scx=goth}', "");
    Expect(1, 66379, '\p{^Is_Scx=goth}', "");
    Expect(1, 66379, '\P{Is_Scx=goth}', "");
    Expect(0, 66379, '\P{^Is_Scx=goth}', "");
    Expect(1, 66378, '\p{Is_Scx= _GOTH}', "");
    Expect(0, 66378, '\p{^Is_Scx= _GOTH}', "");
    Expect(0, 66378, '\P{Is_Scx= _GOTH}', "");
    Expect(1, 66378, '\P{^Is_Scx= _GOTH}', "");
    Expect(0, 66379, '\p{Is_Scx= _GOTH}', "");
    Expect(1, 66379, '\p{^Is_Scx= _GOTH}', "");
    Expect(1, 66379, '\P{Is_Scx= _GOTH}', "");
    Expect(0, 66379, '\P{^Is_Scx= _GOTH}', "");
    Error('\p{Script_Extensions=/a/ grantha}');
    Error('\P{Script_Extensions=/a/ grantha}');
    Expect(1, 73683, '\p{Script_Extensions=:\AGrantha\z:}', "");;
    Expect(0, 73684, '\p{Script_Extensions=:\AGrantha\z:}', "");;
    Expect(1, 73683, '\p{Script_Extensions=grantha}', "");
    Expect(0, 73683, '\p{^Script_Extensions=grantha}', "");
    Expect(0, 73683, '\P{Script_Extensions=grantha}', "");
    Expect(1, 73683, '\P{^Script_Extensions=grantha}', "");
    Expect(0, 73684, '\p{Script_Extensions=grantha}', "");
    Expect(1, 73684, '\p{^Script_Extensions=grantha}', "");
    Expect(1, 73684, '\P{Script_Extensions=grantha}', "");
    Expect(0, 73684, '\P{^Script_Extensions=grantha}', "");
    Expect(1, 73683, '\p{Script_Extensions=:\Agrantha\z:}', "");;
    Expect(0, 73684, '\p{Script_Extensions=:\Agrantha\z:}', "");;
    Expect(1, 73683, '\p{Script_Extensions=-	Grantha}', "");
    Expect(0, 73683, '\p{^Script_Extensions=-	Grantha}', "");
    Expect(0, 73683, '\P{Script_Extensions=-	Grantha}', "");
    Expect(1, 73683, '\P{^Script_Extensions=-	Grantha}', "");
    Expect(0, 73684, '\p{Script_Extensions=-	Grantha}', "");
    Expect(1, 73684, '\p{^Script_Extensions=-	Grantha}', "");
    Expect(1, 73684, '\P{Script_Extensions=-	Grantha}', "");
    Expect(0, 73684, '\P{^Script_Extensions=-	Grantha}', "");
    Error('\p{Scx= :=Gran}');
    Error('\P{Scx= :=Gran}');
    Expect(1, 73683, '\p{Scx=:\AGran\z:}', "");;
    Expect(0, 73684, '\p{Scx=:\AGran\z:}', "");;
    Expect(1, 73683, '\p{Scx=gran}', "");
    Expect(0, 73683, '\p{^Scx=gran}', "");
    Expect(0, 73683, '\P{Scx=gran}', "");
    Expect(1, 73683, '\P{^Scx=gran}', "");
    Expect(0, 73684, '\p{Scx=gran}', "");
    Expect(1, 73684, '\p{^Scx=gran}', "");
    Expect(1, 73684, '\P{Scx=gran}', "");
    Expect(0, 73684, '\P{^Scx=gran}', "");
    Expect(1, 73683, '\p{Scx=:\Agran\z:}', "");;
    Expect(0, 73684, '\p{Scx=:\Agran\z:}', "");;
    Expect(1, 73683, '\p{Scx= GRAN}', "");
    Expect(0, 73683, '\p{^Scx= GRAN}', "");
    Expect(0, 73683, '\P{Scx= GRAN}', "");
    Expect(1, 73683, '\P{^Scx= GRAN}', "");
    Expect(0, 73684, '\p{Scx= GRAN}', "");
    Expect(1, 73684, '\p{^Scx= GRAN}', "");
    Expect(1, 73684, '\P{Scx= GRAN}', "");
    Expect(0, 73684, '\P{^Scx= GRAN}', "");
    Error('\p{Is_Script_Extensions=:=  GRANTHA}');
    Error('\P{Is_Script_Extensions=:=  GRANTHA}');
    Expect(1, 73683, '\p{Is_Script_Extensions=grantha}', "");
    Expect(0, 73683, '\p{^Is_Script_Extensions=grantha}', "");
    Expect(0, 73683, '\P{Is_Script_Extensions=grantha}', "");
    Expect(1, 73683, '\P{^Is_Script_Extensions=grantha}', "");
    Expect(0, 73684, '\p{Is_Script_Extensions=grantha}', "");
    Expect(1, 73684, '\p{^Is_Script_Extensions=grantha}', "");
    Expect(1, 73684, '\P{Is_Script_Extensions=grantha}', "");
    Expect(0, 73684, '\P{^Is_Script_Extensions=grantha}', "");
    Expect(1, 73683, '\p{Is_Script_Extensions=_-Grantha}', "");
    Expect(0, 73683, '\p{^Is_Script_Extensions=_-Grantha}', "");
    Expect(0, 73683, '\P{Is_Script_Extensions=_-Grantha}', "");
    Expect(1, 73683, '\P{^Is_Script_Extensions=_-Grantha}', "");
    Expect(0, 73684, '\p{Is_Script_Extensions=_-Grantha}', "");
    Expect(1, 73684, '\p{^Is_Script_Extensions=_-Grantha}', "");
    Expect(1, 73684, '\P{Is_Script_Extensions=_-Grantha}', "");
    Expect(0, 73684, '\P{^Is_Script_Extensions=_-Grantha}', "");
    Error('\p{Is_Scx=	/a/gran}');
    Error('\P{Is_Scx=	/a/gran}');
    Expect(1, 73683, '\p{Is_Scx=gran}', "");
    Expect(0, 73683, '\p{^Is_Scx=gran}', "");
    Expect(0, 73683, '\P{Is_Scx=gran}', "");
    Expect(1, 73683, '\P{^Is_Scx=gran}', "");
    Expect(0, 73684, '\p{Is_Scx=gran}', "");
    Expect(1, 73684, '\p{^Is_Scx=gran}', "");
    Expect(1, 73684, '\P{Is_Scx=gran}', "");
    Expect(0, 73684, '\P{^Is_Scx=gran}', "");
    Expect(1, 73683, '\p{Is_Scx=-	gran}', "");
    Expect(0, 73683, '\p{^Is_Scx=-	gran}', "");
    Expect(0, 73683, '\P{Is_Scx=-	gran}', "");
    Expect(1, 73683, '\P{^Is_Scx=-	gran}', "");
    Expect(0, 73684, '\p{Is_Scx=-	gran}', "");
    Expect(1, 73684, '\p{^Is_Scx=-	gran}', "");
    Expect(1, 73684, '\P{Is_Scx=-	gran}', "");
    Expect(0, 73684, '\P{^Is_Scx=-	gran}', "");
    Error('\p{Script_Extensions=-Greek:=}');
    Error('\P{Script_Extensions=-Greek:=}');
    Expect(1, 119365, '\p{Script_Extensions=:\AGreek\z:}', "");;
    Expect(0, 119366, '\p{Script_Extensions=:\AGreek\z:}', "");;
    Expect(1, 119365, '\p{Script_Extensions=greek}', "");
    Expect(0, 119365, '\p{^Script_Extensions=greek}', "");
    Expect(0, 119365, '\P{Script_Extensions=greek}', "");
    Expect(1, 119365, '\P{^Script_Extensions=greek}', "");
    Expect(0, 119366, '\p{Script_Extensions=greek}', "");
    Expect(1, 119366, '\p{^Script_Extensions=greek}', "");
    Expect(1, 119366, '\P{Script_Extensions=greek}', "");
    Expect(0, 119366, '\P{^Script_Extensions=greek}', "");
    Expect(1, 119365, '\p{Script_Extensions=:\Agreek\z:}', "");;
    Expect(0, 119366, '\p{Script_Extensions=:\Agreek\z:}', "");;
    Expect(1, 119365, '\p{Script_Extensions= Greek}', "");
    Expect(0, 119365, '\p{^Script_Extensions= Greek}', "");
    Expect(0, 119365, '\P{Script_Extensions= Greek}', "");
    Expect(1, 119365, '\P{^Script_Extensions= Greek}', "");
    Expect(0, 119366, '\p{Script_Extensions= Greek}', "");
    Expect(1, 119366, '\p{^Script_Extensions= Greek}', "");
    Expect(1, 119366, '\P{Script_Extensions= Greek}', "");
    Expect(0, 119366, '\P{^Script_Extensions= Greek}', "");
    Error('\p{Scx=:=	_Grek}');
    Error('\P{Scx=:=	_Grek}');
    Expect(1, 119365, '\p{Scx=:\AGrek\z:}', "");;
    Expect(0, 119366, '\p{Scx=:\AGrek\z:}', "");;
    Expect(1, 119365, '\p{Scx=grek}', "");
    Expect(0, 119365, '\p{^Scx=grek}', "");
    Expect(0, 119365, '\P{Scx=grek}', "");
    Expect(1, 119365, '\P{^Scx=grek}', "");
    Expect(0, 119366, '\p{Scx=grek}', "");
    Expect(1, 119366, '\p{^Scx=grek}', "");
    Expect(1, 119366, '\P{Scx=grek}', "");
    Expect(0, 119366, '\P{^Scx=grek}', "");
    Expect(1, 119365, '\p{Scx=:\Agrek\z:}', "");;
    Expect(0, 119366, '\p{Scx=:\Agrek\z:}', "");;
    Expect(1, 119365, '\p{Scx=	 Grek}', "");
    Expect(0, 119365, '\p{^Scx=	 Grek}', "");
    Expect(0, 119365, '\P{Scx=	 Grek}', "");
    Expect(1, 119365, '\P{^Scx=	 Grek}', "");
    Expect(0, 119366, '\p{Scx=	 Grek}', "");
    Expect(1, 119366, '\p{^Scx=	 Grek}', "");
    Expect(1, 119366, '\P{Scx=	 Grek}', "");
    Expect(0, 119366, '\P{^Scx=	 Grek}', "");
    Error('\p{Is_Script_Extensions=	/a/GREEK}');
    Error('\P{Is_Script_Extensions=	/a/GREEK}');
    Expect(1, 119365, '\p{Is_Script_Extensions=greek}', "");
    Expect(0, 119365, '\p{^Is_Script_Extensions=greek}', "");
    Expect(0, 119365, '\P{Is_Script_Extensions=greek}', "");
    Expect(1, 119365, '\P{^Is_Script_Extensions=greek}', "");
    Expect(0, 119366, '\p{Is_Script_Extensions=greek}', "");
    Expect(1, 119366, '\p{^Is_Script_Extensions=greek}', "");
    Expect(1, 119366, '\P{Is_Script_Extensions=greek}', "");
    Expect(0, 119366, '\P{^Is_Script_Extensions=greek}', "");
    Expect(1, 119365, '\p{Is_Script_Extensions=_-Greek}', "");
    Expect(0, 119365, '\p{^Is_Script_Extensions=_-Greek}', "");
    Expect(0, 119365, '\P{Is_Script_Extensions=_-Greek}', "");
    Expect(1, 119365, '\P{^Is_Script_Extensions=_-Greek}', "");
    Expect(0, 119366, '\p{Is_Script_Extensions=_-Greek}', "");
    Expect(1, 119366, '\p{^Is_Script_Extensions=_-Greek}', "");
    Expect(1, 119366, '\P{Is_Script_Extensions=_-Greek}', "");
    Expect(0, 119366, '\P{^Is_Script_Extensions=_-Greek}', "");
    Error('\p{Is_Scx=	-Grek/a/}');
    Error('\P{Is_Scx=	-Grek/a/}');
    Expect(1, 119365, '\p{Is_Scx=grek}', "");
    Expect(0, 119365, '\p{^Is_Scx=grek}', "");
    Expect(0, 119365, '\P{Is_Scx=grek}', "");
    Expect(1, 119365, '\P{^Is_Scx=grek}', "");
    Expect(0, 119366, '\p{Is_Scx=grek}', "");
    Expect(1, 119366, '\p{^Is_Scx=grek}', "");
    Expect(1, 119366, '\P{Is_Scx=grek}', "");
    Expect(0, 119366, '\P{^Is_Scx=grek}', "");
    Expect(1, 119365, '\p{Is_Scx= -Grek}', "");
    Expect(0, 119365, '\p{^Is_Scx= -Grek}', "");
    Expect(0, 119365, '\P{Is_Scx= -Grek}', "");
    Expect(1, 119365, '\P{^Is_Scx= -Grek}', "");
    Expect(0, 119366, '\p{Is_Scx= -Grek}', "");
    Expect(1, 119366, '\p{^Is_Scx= -Grek}', "");
    Expect(1, 119366, '\P{Is_Scx= -Grek}', "");
    Expect(0, 119366, '\P{^Is_Scx= -Grek}', "");
    Error('\p{Script_Extensions=:=_	Gujarati}');
    Error('\P{Script_Extensions=:=_	Gujarati}');
    Expect(1, 43065, '\p{Script_Extensions=:\AGujarati\z:}', "");;
    Expect(0, 43066, '\p{Script_Extensions=:\AGujarati\z:}', "");;
    Expect(1, 43065, '\p{Script_Extensions=gujarati}', "");
    Expect(0, 43065, '\p{^Script_Extensions=gujarati}', "");
    Expect(0, 43065, '\P{Script_Extensions=gujarati}', "");
    Expect(1, 43065, '\P{^Script_Extensions=gujarati}', "");
    Expect(0, 43066, '\p{Script_Extensions=gujarati}', "");
    Expect(1, 43066, '\p{^Script_Extensions=gujarati}', "");
    Expect(1, 43066, '\P{Script_Extensions=gujarati}', "");
    Expect(0, 43066, '\P{^Script_Extensions=gujarati}', "");
    Expect(1, 43065, '\p{Script_Extensions=:\Agujarati\z:}', "");;
    Expect(0, 43066, '\p{Script_Extensions=:\Agujarati\z:}', "");;
    Expect(1, 43065, '\p{Script_Extensions: __Gujarati}', "");
    Expect(0, 43065, '\p{^Script_Extensions: __Gujarati}', "");
    Expect(0, 43065, '\P{Script_Extensions: __Gujarati}', "");
    Expect(1, 43065, '\P{^Script_Extensions: __Gujarati}', "");
    Expect(0, 43066, '\p{Script_Extensions: __Gujarati}', "");
    Expect(1, 43066, '\p{^Script_Extensions: __Gujarati}', "");
    Expect(1, 43066, '\P{Script_Extensions: __Gujarati}', "");
    Expect(0, 43066, '\P{^Script_Extensions: __Gujarati}', "");
    Error('\p{Scx= Gujr/a/}');
    Error('\P{Scx= Gujr/a/}');
    Expect(1, 43065, '\p{Scx=:\AGujr\z:}', "");;
    Expect(0, 43066, '\p{Scx=:\AGujr\z:}', "");;
    Expect(1, 43065, '\p{Scx=gujr}', "");
    Expect(0, 43065, '\p{^Scx=gujr}', "");
    Expect(0, 43065, '\P{Scx=gujr}', "");
    Expect(1, 43065, '\P{^Scx=gujr}', "");
    Expect(0, 43066, '\p{Scx=gujr}', "");
    Expect(1, 43066, '\p{^Scx=gujr}', "");
    Expect(1, 43066, '\P{Scx=gujr}', "");
    Expect(0, 43066, '\P{^Scx=gujr}', "");
    Expect(1, 43065, '\p{Scx=:\Agujr\z:}', "");;
    Expect(0, 43066, '\p{Scx=:\Agujr\z:}', "");;
    Expect(1, 43065, '\p{Scx: _-GUJR}', "");
    Expect(0, 43065, '\p{^Scx: _-GUJR}', "");
    Expect(0, 43065, '\P{Scx: _-GUJR}', "");
    Expect(1, 43065, '\P{^Scx: _-GUJR}', "");
    Expect(0, 43066, '\p{Scx: _-GUJR}', "");
    Expect(1, 43066, '\p{^Scx: _-GUJR}', "");
    Expect(1, 43066, '\P{Scx: _-GUJR}', "");
    Expect(0, 43066, '\P{^Scx: _-GUJR}', "");
    Error('\p{Is_Script_Extensions=/a/__GUJARATI}');
    Error('\P{Is_Script_Extensions=/a/__GUJARATI}');
    Expect(1, 43065, '\p{Is_Script_Extensions=gujarati}', "");
    Expect(0, 43065, '\p{^Is_Script_Extensions=gujarati}', "");
    Expect(0, 43065, '\P{Is_Script_Extensions=gujarati}', "");
    Expect(1, 43065, '\P{^Is_Script_Extensions=gujarati}', "");
    Expect(0, 43066, '\p{Is_Script_Extensions=gujarati}', "");
    Expect(1, 43066, '\p{^Is_Script_Extensions=gujarati}', "");
    Expect(1, 43066, '\P{Is_Script_Extensions=gujarati}', "");
    Expect(0, 43066, '\P{^Is_Script_Extensions=gujarati}', "");
    Expect(1, 43065, '\p{Is_Script_Extensions=		Gujarati}', "");
    Expect(0, 43065, '\p{^Is_Script_Extensions=		Gujarati}', "");
    Expect(0, 43065, '\P{Is_Script_Extensions=		Gujarati}', "");
    Expect(1, 43065, '\P{^Is_Script_Extensions=		Gujarati}', "");
    Expect(0, 43066, '\p{Is_Script_Extensions=		Gujarati}', "");
    Expect(1, 43066, '\p{^Is_Script_Extensions=		Gujarati}', "");
    Expect(1, 43066, '\P{Is_Script_Extensions=		Gujarati}', "");
    Expect(0, 43066, '\P{^Is_Script_Extensions=		Gujarati}', "");
    Error('\p{Is_Scx=:=-Gujr}');
    Error('\P{Is_Scx=:=-Gujr}');
    Expect(1, 43065, '\p{Is_Scx=gujr}', "");
    Expect(0, 43065, '\p{^Is_Scx=gujr}', "");
    Expect(0, 43065, '\P{Is_Scx=gujr}', "");
    Expect(1, 43065, '\P{^Is_Scx=gujr}', "");
    Expect(0, 43066, '\p{Is_Scx=gujr}', "");
    Expect(1, 43066, '\p{^Is_Scx=gujr}', "");
    Expect(1, 43066, '\P{Is_Scx=gujr}', "");
    Expect(0, 43066, '\P{^Is_Scx=gujr}', "");
    Expect(1, 43065, '\p{Is_Scx= 	GUJR}', "");
    Expect(0, 43065, '\p{^Is_Scx= 	GUJR}', "");
    Expect(0, 43065, '\P{Is_Scx= 	GUJR}', "");
    Expect(1, 43065, '\P{^Is_Scx= 	GUJR}', "");
    Expect(0, 43066, '\p{Is_Scx= 	GUJR}', "");
    Expect(1, 43066, '\p{^Is_Scx= 	GUJR}', "");
    Expect(1, 43066, '\P{Is_Scx= 	GUJR}', "");
    Expect(0, 43066, '\P{^Is_Scx= 	GUJR}', "");
    Error('\p{Script_Extensions=/a/_Gurmukhi}');
    Error('\P{Script_Extensions=/a/_Gurmukhi}');
    Expect(1, 43065, '\p{Script_Extensions=:\AGurmukhi\z:}', "");;
    Expect(0, 43066, '\p{Script_Extensions=:\AGurmukhi\z:}', "");;
    Expect(1, 43065, '\p{Script_Extensions=gurmukhi}', "");
    Expect(0, 43065, '\p{^Script_Extensions=gurmukhi}', "");
    Expect(0, 43065, '\P{Script_Extensions=gurmukhi}', "");
    Expect(1, 43065, '\P{^Script_Extensions=gurmukhi}', "");
    Expect(0, 43066, '\p{Script_Extensions=gurmukhi}', "");
    Expect(1, 43066, '\p{^Script_Extensions=gurmukhi}', "");
    Expect(1, 43066, '\P{Script_Extensions=gurmukhi}', "");
    Expect(0, 43066, '\P{^Script_Extensions=gurmukhi}', "");
    Expect(1, 43065, '\p{Script_Extensions=:\Agurmukhi\z:}', "");;
    Expect(0, 43066, '\p{Script_Extensions=:\Agurmukhi\z:}', "");;
    Expect(1, 43065, '\p{Script_Extensions=__gurmukhi}', "");
    Expect(0, 43065, '\p{^Script_Extensions=__gurmukhi}', "");
    Expect(0, 43065, '\P{Script_Extensions=__gurmukhi}', "");
    Expect(1, 43065, '\P{^Script_Extensions=__gurmukhi}', "");
    Expect(0, 43066, '\p{Script_Extensions=__gurmukhi}', "");
    Expect(1, 43066, '\p{^Script_Extensions=__gurmukhi}', "");
    Expect(1, 43066, '\P{Script_Extensions=__gurmukhi}', "");
    Expect(0, 43066, '\P{^Script_Extensions=__gurmukhi}', "");
    Error('\p{Scx=_:=guru}');
    Error('\P{Scx=_:=guru}');
    Expect(1, 43065, '\p{Scx=:\AGuru\z:}', "");;
    Expect(0, 43066, '\p{Scx=:\AGuru\z:}', "");;
    Expect(1, 43065, '\p{Scx=guru}', "");
    Expect(0, 43065, '\p{^Scx=guru}', "");
    Expect(0, 43065, '\P{Scx=guru}', "");
    Expect(1, 43065, '\P{^Scx=guru}', "");
    Expect(0, 43066, '\p{Scx=guru}', "");
    Expect(1, 43066, '\p{^Scx=guru}', "");
    Expect(1, 43066, '\P{Scx=guru}', "");
    Expect(0, 43066, '\P{^Scx=guru}', "");
    Expect(1, 43065, '\p{Scx=:\Aguru\z:}', "");;
    Expect(0, 43066, '\p{Scx=:\Aguru\z:}', "");;
    Expect(1, 43065, '\p{Scx=-guru}', "");
    Expect(0, 43065, '\p{^Scx=-guru}', "");
    Expect(0, 43065, '\P{Scx=-guru}', "");
    Expect(1, 43065, '\P{^Scx=-guru}', "");
    Expect(0, 43066, '\p{Scx=-guru}', "");
    Expect(1, 43066, '\p{^Scx=-guru}', "");
    Expect(1, 43066, '\P{Scx=-guru}', "");
    Expect(0, 43066, '\P{^Scx=-guru}', "");
    Error('\p{Is_Script_Extensions=:=gurmukhi}');
    Error('\P{Is_Script_Extensions=:=gurmukhi}');
    Expect(1, 43065, '\p{Is_Script_Extensions=gurmukhi}', "");
    Expect(0, 43065, '\p{^Is_Script_Extensions=gurmukhi}', "");
    Expect(0, 43065, '\P{Is_Script_Extensions=gurmukhi}', "");
    Expect(1, 43065, '\P{^Is_Script_Extensions=gurmukhi}', "");
    Expect(0, 43066, '\p{Is_Script_Extensions=gurmukhi}', "");
    Expect(1, 43066, '\p{^Is_Script_Extensions=gurmukhi}', "");
    Expect(1, 43066, '\P{Is_Script_Extensions=gurmukhi}', "");
    Expect(0, 43066, '\P{^Is_Script_Extensions=gurmukhi}', "");
    Expect(1, 43065, '\p{Is_Script_Extensions= Gurmukhi}', "");
    Expect(0, 43065, '\p{^Is_Script_Extensions= Gurmukhi}', "");
    Expect(0, 43065, '\P{Is_Script_Extensions= Gurmukhi}', "");
    Expect(1, 43065, '\P{^Is_Script_Extensions= Gurmukhi}', "");
    Expect(0, 43066, '\p{Is_Script_Extensions= Gurmukhi}', "");
    Expect(1, 43066, '\p{^Is_Script_Extensions= Gurmukhi}', "");
    Expect(1, 43066, '\P{Is_Script_Extensions= Gurmukhi}', "");
    Expect(0, 43066, '\P{^Is_Script_Extensions= Gurmukhi}', "");
    Error('\p{Is_Scx=/a/-GURU}');
    Error('\P{Is_Scx=/a/-GURU}');
    Expect(1, 43065, '\p{Is_Scx=guru}', "");
    Expect(0, 43065, '\p{^Is_Scx=guru}', "");
    Expect(0, 43065, '\P{Is_Scx=guru}', "");
    Expect(1, 43065, '\P{^Is_Scx=guru}', "");
    Expect(0, 43066, '\p{Is_Scx=guru}', "");
    Expect(1, 43066, '\p{^Is_Scx=guru}', "");
    Expect(1, 43066, '\P{Is_Scx=guru}', "");
    Expect(0, 43066, '\P{^Is_Scx=guru}', "");
    Expect(1, 43065, '\p{Is_Scx=_-Guru}', "");
    Expect(0, 43065, '\p{^Is_Scx=_-Guru}', "");
    Expect(0, 43065, '\P{Is_Scx=_-Guru}', "");
    Expect(1, 43065, '\P{^Is_Scx=_-Guru}', "");
    Expect(0, 43066, '\p{Is_Scx=_-Guru}', "");
    Expect(1, 43066, '\p{^Is_Scx=_-Guru}', "");
    Expect(1, 43066, '\P{Is_Scx=_-Guru}', "");
    Expect(0, 43066, '\P{^Is_Scx=_-Guru}', "");
    Error('\p{Script_Extensions: 	Hangul/a/}');
    Error('\P{Script_Extensions: 	Hangul/a/}');
    Expect(1, 65500, '\p{Script_Extensions=:\AHangul\z:}', "");;
    Expect(0, 65501, '\p{Script_Extensions=:\AHangul\z:}', "");;
    Expect(1, 65500, '\p{Script_Extensions=hangul}', "");
    Expect(0, 65500, '\p{^Script_Extensions=hangul}', "");
    Expect(0, 65500, '\P{Script_Extensions=hangul}', "");
    Expect(1, 65500, '\P{^Script_Extensions=hangul}', "");
    Expect(0, 65501, '\p{Script_Extensions=hangul}', "");
    Expect(1, 65501, '\p{^Script_Extensions=hangul}', "");
    Expect(1, 65501, '\P{Script_Extensions=hangul}', "");
    Expect(0, 65501, '\P{^Script_Extensions=hangul}', "");
    Expect(1, 65500, '\p{Script_Extensions=:\Ahangul\z:}', "");;
    Expect(0, 65501, '\p{Script_Extensions=:\Ahangul\z:}', "");;
    Expect(1, 65500, '\p{Script_Extensions=  HANGUL}', "");
    Expect(0, 65500, '\p{^Script_Extensions=  HANGUL}', "");
    Expect(0, 65500, '\P{Script_Extensions=  HANGUL}', "");
    Expect(1, 65500, '\P{^Script_Extensions=  HANGUL}', "");
    Expect(0, 65501, '\p{Script_Extensions=  HANGUL}', "");
    Expect(1, 65501, '\p{^Script_Extensions=  HANGUL}', "");
    Expect(1, 65501, '\P{Script_Extensions=  HANGUL}', "");
    Expect(0, 65501, '\P{^Script_Extensions=  HANGUL}', "");
    Error('\p{Scx=:=Hang}');
    Error('\P{Scx=:=Hang}');
    Expect(1, 65500, '\p{Scx=:\AHang\z:}', "");;
    Expect(0, 65501, '\p{Scx=:\AHang\z:}', "");;
    Expect(1, 65500, '\p{Scx=hang}', "");
    Expect(0, 65500, '\p{^Scx=hang}', "");
    Expect(0, 65500, '\P{Scx=hang}', "");
    Expect(1, 65500, '\P{^Scx=hang}', "");
    Expect(0, 65501, '\p{Scx=hang}', "");
    Expect(1, 65501, '\p{^Scx=hang}', "");
    Expect(1, 65501, '\P{Scx=hang}', "");
    Expect(0, 65501, '\P{^Scx=hang}', "");
    Expect(1, 65500, '\p{Scx=:\Ahang\z:}', "");;
    Expect(0, 65501, '\p{Scx=:\Ahang\z:}', "");;
    Expect(1, 65500, '\p{Scx=		Hang}', "");
    Expect(0, 65500, '\p{^Scx=		Hang}', "");
    Expect(0, 65500, '\P{Scx=		Hang}', "");
    Expect(1, 65500, '\P{^Scx=		Hang}', "");
    Expect(0, 65501, '\p{Scx=		Hang}', "");
    Expect(1, 65501, '\p{^Scx=		Hang}', "");
    Expect(1, 65501, '\P{Scx=		Hang}', "");
    Expect(0, 65501, '\P{^Scx=		Hang}', "");
    Error('\p{Is_Script_Extensions:   /a/-_Hangul}');
    Error('\P{Is_Script_Extensions:   /a/-_Hangul}');
    Expect(1, 65500, '\p{Is_Script_Extensions=hangul}', "");
    Expect(0, 65500, '\p{^Is_Script_Extensions=hangul}', "");
    Expect(0, 65500, '\P{Is_Script_Extensions=hangul}', "");
    Expect(1, 65500, '\P{^Is_Script_Extensions=hangul}', "");
    Expect(0, 65501, '\p{Is_Script_Extensions=hangul}', "");
    Expect(1, 65501, '\p{^Is_Script_Extensions=hangul}', "");
    Expect(1, 65501, '\P{Is_Script_Extensions=hangul}', "");
    Expect(0, 65501, '\P{^Is_Script_Extensions=hangul}', "");
    Expect(1, 65500, '\p{Is_Script_Extensions=Hangul}', "");
    Expect(0, 65500, '\p{^Is_Script_Extensions=Hangul}', "");
    Expect(0, 65500, '\P{Is_Script_Extensions=Hangul}', "");
    Expect(1, 65500, '\P{^Is_Script_Extensions=Hangul}', "");
    Expect(0, 65501, '\p{Is_Script_Extensions=Hangul}', "");
    Expect(1, 65501, '\p{^Is_Script_Extensions=Hangul}', "");
    Expect(1, 65501, '\P{Is_Script_Extensions=Hangul}', "");
    Expect(0, 65501, '\P{^Is_Script_Extensions=Hangul}', "");
    Error('\p{Is_Scx=:=	HANG}');
    Error('\P{Is_Scx=:=	HANG}');
    Expect(1, 65500, '\p{Is_Scx=hang}', "");
    Expect(0, 65500, '\p{^Is_Scx=hang}', "");
    Expect(0, 65500, '\P{Is_Scx=hang}', "");
    Expect(1, 65500, '\P{^Is_Scx=hang}', "");
    Expect(0, 65501, '\p{Is_Scx=hang}', "");
    Expect(1, 65501, '\p{^Is_Scx=hang}', "");
    Expect(1, 65501, '\P{Is_Scx=hang}', "");
    Expect(0, 65501, '\P{^Is_Scx=hang}', "");
    Expect(1, 65500, '\p{Is_Scx= HANG}', "");
    Expect(0, 65500, '\p{^Is_Scx= HANG}', "");
    Expect(0, 65500, '\P{Is_Scx= HANG}', "");
    Expect(1, 65500, '\P{^Is_Scx= HANG}', "");
    Expect(0, 65501, '\p{Is_Scx= HANG}', "");
    Expect(1, 65501, '\p{^Is_Scx= HANG}', "");
    Expect(1, 65501, '\P{Is_Scx= HANG}', "");
    Expect(0, 65501, '\P{^Is_Scx= HANG}', "");
    Error('\p{Script_Extensions=/a/Han}');
    Error('\P{Script_Extensions=/a/Han}');
    Expect(1, 201546, '\p{Script_Extensions=:\AHan\z:}', "");;
    Expect(0, 201547, '\p{Script_Extensions=:\AHan\z:}', "");;
    Expect(1, 201546, '\p{Script_Extensions=han}', "");
    Expect(0, 201546, '\p{^Script_Extensions=han}', "");
    Expect(0, 201546, '\P{Script_Extensions=han}', "");
    Expect(1, 201546, '\P{^Script_Extensions=han}', "");
    Expect(0, 201547, '\p{Script_Extensions=han}', "");
    Expect(1, 201547, '\p{^Script_Extensions=han}', "");
    Expect(1, 201547, '\P{Script_Extensions=han}', "");
    Expect(0, 201547, '\P{^Script_Extensions=han}', "");
    Expect(1, 201546, '\p{Script_Extensions=:\Ahan\z:}', "");;
    Expect(0, 201547, '\p{Script_Extensions=:\Ahan\z:}', "");;
    Expect(1, 201546, '\p{Script_Extensions=_han}', "");
    Expect(0, 201546, '\p{^Script_Extensions=_han}', "");
    Expect(0, 201546, '\P{Script_Extensions=_han}', "");
    Expect(1, 201546, '\P{^Script_Extensions=_han}', "");
    Expect(0, 201547, '\p{Script_Extensions=_han}', "");
    Expect(1, 201547, '\p{^Script_Extensions=_han}', "");
    Expect(1, 201547, '\P{Script_Extensions=_han}', "");
    Expect(0, 201547, '\P{^Script_Extensions=_han}', "");
    Error('\p{Scx=_/a/Hani}');
    Error('\P{Scx=_/a/Hani}');
    Expect(1, 201546, '\p{Scx=:\AHani\z:}', "");;
    Expect(0, 201547, '\p{Scx=:\AHani\z:}', "");;
    Expect(1, 201546, '\p{Scx=hani}', "");
    Expect(0, 201546, '\p{^Scx=hani}', "");
    Expect(0, 201546, '\P{Scx=hani}', "");
    Expect(1, 201546, '\P{^Scx=hani}', "");
    Expect(0, 201547, '\p{Scx=hani}', "");
    Expect(1, 201547, '\p{^Scx=hani}', "");
    Expect(1, 201547, '\P{Scx=hani}', "");
    Expect(0, 201547, '\P{^Scx=hani}', "");
    Expect(1, 201546, '\p{Scx=:\Ahani\z:}', "");;
    Expect(0, 201547, '\p{Scx=:\Ahani\z:}', "");;
    Expect(1, 201546, '\p{Scx= 	hani}', "");
    Expect(0, 201546, '\p{^Scx= 	hani}', "");
    Expect(0, 201546, '\P{Scx= 	hani}', "");
    Expect(1, 201546, '\P{^Scx= 	hani}', "");
    Expect(0, 201547, '\p{Scx= 	hani}', "");
    Expect(1, 201547, '\p{^Scx= 	hani}', "");
    Expect(1, 201547, '\P{Scx= 	hani}', "");
    Expect(0, 201547, '\P{^Scx= 	hani}', "");
    Error('\p{Is_Script_Extensions=  han:=}');
    Error('\P{Is_Script_Extensions=  han:=}');
    Expect(1, 201546, '\p{Is_Script_Extensions=han}', "");
    Expect(0, 201546, '\p{^Is_Script_Extensions=han}', "");
    Expect(0, 201546, '\P{Is_Script_Extensions=han}', "");
    Expect(1, 201546, '\P{^Is_Script_Extensions=han}', "");
    Expect(0, 201547, '\p{Is_Script_Extensions=han}', "");
    Expect(1, 201547, '\p{^Is_Script_Extensions=han}', "");
    Expect(1, 201547, '\P{Is_Script_Extensions=han}', "");
    Expect(0, 201547, '\P{^Is_Script_Extensions=han}', "");
    Expect(1, 201546, '\p{Is_Script_Extensions=-han}', "");
    Expect(0, 201546, '\p{^Is_Script_Extensions=-han}', "");
    Expect(0, 201546, '\P{Is_Script_Extensions=-han}', "");
    Expect(1, 201546, '\P{^Is_Script_Extensions=-han}', "");
    Expect(0, 201547, '\p{Is_Script_Extensions=-han}', "");
    Expect(1, 201547, '\p{^Is_Script_Extensions=-han}', "");
    Expect(1, 201547, '\P{Is_Script_Extensions=-han}', "");
    Expect(0, 201547, '\P{^Is_Script_Extensions=-han}', "");
    Error('\p{Is_Scx=	-HANI:=}');
    Error('\P{Is_Scx=	-HANI:=}');
    Expect(1, 201546, '\p{Is_Scx=hani}', "");
    Expect(0, 201546, '\p{^Is_Scx=hani}', "");
    Expect(0, 201546, '\P{Is_Scx=hani}', "");
    Expect(1, 201546, '\P{^Is_Scx=hani}', "");
    Expect(0, 201547, '\p{Is_Scx=hani}', "");
    Expect(1, 201547, '\p{^Is_Scx=hani}', "");
    Expect(1, 201547, '\P{Is_Scx=hani}', "");
    Expect(0, 201547, '\P{^Is_Scx=hani}', "");
    Expect(1, 201546, '\p{Is_Scx: _ hani}', "");
    Expect(0, 201546, '\p{^Is_Scx: _ hani}', "");
    Expect(0, 201546, '\P{Is_Scx: _ hani}', "");
    Expect(1, 201546, '\P{^Is_Scx: _ hani}', "");
    Expect(0, 201547, '\p{Is_Scx: _ hani}', "");
    Expect(1, 201547, '\p{^Is_Scx: _ hani}', "");
    Expect(1, 201547, '\P{Is_Scx: _ hani}', "");
    Expect(0, 201547, '\P{^Is_Scx: _ hani}', "");
    Error('\p{Script_Extensions=_hanunoo/a/}');
    Error('\P{Script_Extensions=_hanunoo/a/}');
    Expect(1, 5942, '\p{Script_Extensions=:\AHanunoo\z:}', "");;
    Expect(0, 5943, '\p{Script_Extensions=:\AHanunoo\z:}', "");;
    Expect(1, 5942, '\p{Script_Extensions=hanunoo}', "");
    Expect(0, 5942, '\p{^Script_Extensions=hanunoo}', "");
    Expect(0, 5942, '\P{Script_Extensions=hanunoo}', "");
    Expect(1, 5942, '\P{^Script_Extensions=hanunoo}', "");
    Expect(0, 5943, '\p{Script_Extensions=hanunoo}', "");
    Expect(1, 5943, '\p{^Script_Extensions=hanunoo}', "");
    Expect(1, 5943, '\P{Script_Extensions=hanunoo}', "");
    Expect(0, 5943, '\P{^Script_Extensions=hanunoo}', "");
    Expect(1, 5942, '\p{Script_Extensions=:\Ahanunoo\z:}', "");;
    Expect(0, 5943, '\p{Script_Extensions=:\Ahanunoo\z:}', "");;
    Expect(1, 5942, '\p{Script_Extensions=	-Hanunoo}', "");
    Expect(0, 5942, '\p{^Script_Extensions=	-Hanunoo}', "");
    Expect(0, 5942, '\P{Script_Extensions=	-Hanunoo}', "");
    Expect(1, 5942, '\P{^Script_Extensions=	-Hanunoo}', "");
    Expect(0, 5943, '\p{Script_Extensions=	-Hanunoo}', "");
    Expect(1, 5943, '\p{^Script_Extensions=	-Hanunoo}', "");
    Expect(1, 5943, '\P{Script_Extensions=	-Hanunoo}', "");
    Expect(0, 5943, '\P{^Script_Extensions=	-Hanunoo}', "");
    Error('\p{Scx=-hano:=}');
    Error('\P{Scx=-hano:=}');
    Expect(1, 5942, '\p{Scx=:\AHano\z:}', "");;
    Expect(0, 5943, '\p{Scx=:\AHano\z:}', "");;
    Expect(1, 5942, '\p{Scx=hano}', "");
    Expect(0, 5942, '\p{^Scx=hano}', "");
    Expect(0, 5942, '\P{Scx=hano}', "");
    Expect(1, 5942, '\P{^Scx=hano}', "");
    Expect(0, 5943, '\p{Scx=hano}', "");
    Expect(1, 5943, '\p{^Scx=hano}', "");
    Expect(1, 5943, '\P{Scx=hano}', "");
    Expect(0, 5943, '\P{^Scx=hano}', "");
    Expect(1, 5942, '\p{Scx=:\Ahano\z:}', "");;
    Expect(0, 5943, '\p{Scx=:\Ahano\z:}', "");;
    Expect(1, 5942, '\p{Scx=_HANO}', "");
    Expect(0, 5942, '\p{^Scx=_HANO}', "");
    Expect(0, 5942, '\P{Scx=_HANO}', "");
    Expect(1, 5942, '\P{^Scx=_HANO}', "");
    Expect(0, 5943, '\p{Scx=_HANO}', "");
    Expect(1, 5943, '\p{^Scx=_HANO}', "");
    Expect(1, 5943, '\P{Scx=_HANO}', "");
    Expect(0, 5943, '\P{^Scx=_HANO}', "");
    Error('\p{Is_Script_Extensions=:=HANUNOO}');
    Error('\P{Is_Script_Extensions=:=HANUNOO}');
    Expect(1, 5942, '\p{Is_Script_Extensions=hanunoo}', "");
    Expect(0, 5942, '\p{^Is_Script_Extensions=hanunoo}', "");
    Expect(0, 5942, '\P{Is_Script_Extensions=hanunoo}', "");
    Expect(1, 5942, '\P{^Is_Script_Extensions=hanunoo}', "");
    Expect(0, 5943, '\p{Is_Script_Extensions=hanunoo}', "");
    Expect(1, 5943, '\p{^Is_Script_Extensions=hanunoo}', "");
    Expect(1, 5943, '\P{Is_Script_Extensions=hanunoo}', "");
    Expect(0, 5943, '\P{^Is_Script_Extensions=hanunoo}', "");
    Expect(1, 5942, '\p{Is_Script_Extensions= Hanunoo}', "");
    Expect(0, 5942, '\p{^Is_Script_Extensions= Hanunoo}', "");
    Expect(0, 5942, '\P{Is_Script_Extensions= Hanunoo}', "");
    Expect(1, 5942, '\P{^Is_Script_Extensions= Hanunoo}', "");
    Expect(0, 5943, '\p{Is_Script_Extensions= Hanunoo}', "");
    Expect(1, 5943, '\p{^Is_Script_Extensions= Hanunoo}', "");
    Expect(1, 5943, '\P{Is_Script_Extensions= Hanunoo}', "");
    Expect(0, 5943, '\P{^Is_Script_Extensions= Hanunoo}', "");
    Error('\p{Is_Scx=/a/hano}');
    Error('\P{Is_Scx=/a/hano}');
    Expect(1, 5942, '\p{Is_Scx=hano}', "");
    Expect(0, 5942, '\p{^Is_Scx=hano}', "");
    Expect(0, 5942, '\P{Is_Scx=hano}', "");
    Expect(1, 5942, '\P{^Is_Scx=hano}', "");
    Expect(0, 5943, '\p{Is_Scx=hano}', "");
    Expect(1, 5943, '\p{^Is_Scx=hano}', "");
    Expect(1, 5943, '\P{Is_Scx=hano}', "");
    Expect(0, 5943, '\P{^Is_Scx=hano}', "");
    Expect(1, 5942, '\p{Is_Scx=	 hano}', "");
    Expect(0, 5942, '\p{^Is_Scx=	 hano}', "");
    Expect(0, 5942, '\P{Is_Scx=	 hano}', "");
    Expect(1, 5942, '\P{^Is_Scx=	 hano}', "");
    Expect(0, 5943, '\p{Is_Scx=	 hano}', "");
    Expect(1, 5943, '\p{^Is_Scx=	 hano}', "");
    Expect(1, 5943, '\P{Is_Scx=	 hano}', "");
    Expect(0, 5943, '\P{^Is_Scx=	 hano}', "");
    Error('\p{Script_Extensions=/a/HATRAN}');
    Error('\P{Script_Extensions=/a/HATRAN}');
    Expect(1, 67839, '\p{Script_Extensions=:\AHatran\z:}', "");;
    Expect(0, 67840, '\p{Script_Extensions=:\AHatran\z:}', "");;
    Expect(1, 67839, '\p{Script_Extensions=hatran}', "");
    Expect(0, 67839, '\p{^Script_Extensions=hatran}', "");
    Expect(0, 67839, '\P{Script_Extensions=hatran}', "");
    Expect(1, 67839, '\P{^Script_Extensions=hatran}', "");
    Expect(0, 67840, '\p{Script_Extensions=hatran}', "");
    Expect(1, 67840, '\p{^Script_Extensions=hatran}', "");
    Expect(1, 67840, '\P{Script_Extensions=hatran}', "");
    Expect(0, 67840, '\P{^Script_Extensions=hatran}', "");
    Expect(1, 67839, '\p{Script_Extensions=:\Ahatran\z:}', "");;
    Expect(0, 67840, '\p{Script_Extensions=:\Ahatran\z:}', "");;
    Expect(1, 67839, '\p{Script_Extensions:	_ HATRAN}', "");
    Expect(0, 67839, '\p{^Script_Extensions:	_ HATRAN}', "");
    Expect(0, 67839, '\P{Script_Extensions:	_ HATRAN}', "");
    Expect(1, 67839, '\P{^Script_Extensions:	_ HATRAN}', "");
    Expect(0, 67840, '\p{Script_Extensions:	_ HATRAN}', "");
    Expect(1, 67840, '\p{^Script_Extensions:	_ HATRAN}', "");
    Expect(1, 67840, '\P{Script_Extensions:	_ HATRAN}', "");
    Expect(0, 67840, '\P{^Script_Extensions:	_ HATRAN}', "");
    Error('\p{Scx=:= 	Hatr}');
    Error('\P{Scx=:= 	Hatr}');
    Expect(1, 67839, '\p{Scx=:\AHatr\z:}', "");;
    Expect(0, 67840, '\p{Scx=:\AHatr\z:}', "");;
    Expect(1, 67839, '\p{Scx=hatr}', "");
    Expect(0, 67839, '\p{^Scx=hatr}', "");
    Expect(0, 67839, '\P{Scx=hatr}', "");
    Expect(1, 67839, '\P{^Scx=hatr}', "");
    Expect(0, 67840, '\p{Scx=hatr}', "");
    Expect(1, 67840, '\p{^Scx=hatr}', "");
    Expect(1, 67840, '\P{Scx=hatr}', "");
    Expect(0, 67840, '\P{^Scx=hatr}', "");
    Expect(1, 67839, '\p{Scx=:\Ahatr\z:}', "");;
    Expect(0, 67840, '\p{Scx=:\Ahatr\z:}', "");;
    Expect(1, 67839, '\p{Scx:HATR}', "");
    Expect(0, 67839, '\p{^Scx:HATR}', "");
    Expect(0, 67839, '\P{Scx:HATR}', "");
    Expect(1, 67839, '\P{^Scx:HATR}', "");
    Expect(0, 67840, '\p{Scx:HATR}', "");
    Expect(1, 67840, '\p{^Scx:HATR}', "");
    Expect(1, 67840, '\P{Scx:HATR}', "");
    Expect(0, 67840, '\P{^Scx:HATR}', "");
    Error('\p{Is_Script_Extensions=-/a/HATRAN}');
    Error('\P{Is_Script_Extensions=-/a/HATRAN}');
    Expect(1, 67839, '\p{Is_Script_Extensions=hatran}', "");
    Expect(0, 67839, '\p{^Is_Script_Extensions=hatran}', "");
    Expect(0, 67839, '\P{Is_Script_Extensions=hatran}', "");
    Expect(1, 67839, '\P{^Is_Script_Extensions=hatran}', "");
    Expect(0, 67840, '\p{Is_Script_Extensions=hatran}', "");
    Expect(1, 67840, '\p{^Is_Script_Extensions=hatran}', "");
    Expect(1, 67840, '\P{Is_Script_Extensions=hatran}', "");
    Expect(0, 67840, '\P{^Is_Script_Extensions=hatran}', "");
    Expect(1, 67839, '\p{Is_Script_Extensions:	hatran}', "");
    Expect(0, 67839, '\p{^Is_Script_Extensions:	hatran}', "");
    Expect(0, 67839, '\P{Is_Script_Extensions:	hatran}', "");
    Expect(1, 67839, '\P{^Is_Script_Extensions:	hatran}', "");
    Expect(0, 67840, '\p{Is_Script_Extensions:	hatran}', "");
    Expect(1, 67840, '\p{^Is_Script_Extensions:	hatran}', "");
    Expect(1, 67840, '\P{Is_Script_Extensions:	hatran}', "");
    Expect(0, 67840, '\P{^Is_Script_Extensions:	hatran}', "");
    Error('\p{Is_Scx= /a/HATR}');
    Error('\P{Is_Scx= /a/HATR}');
    Expect(1, 67839, '\p{Is_Scx=hatr}', "");
    Expect(0, 67839, '\p{^Is_Scx=hatr}', "");
    Expect(0, 67839, '\P{Is_Scx=hatr}', "");
    Expect(1, 67839, '\P{^Is_Scx=hatr}', "");
    Expect(0, 67840, '\p{Is_Scx=hatr}', "");
    Expect(1, 67840, '\p{^Is_Scx=hatr}', "");
    Expect(1, 67840, '\P{Is_Scx=hatr}', "");
    Expect(0, 67840, '\P{^Is_Scx=hatr}', "");
    Expect(1, 67839, '\p{Is_Scx=--hatr}', "");
    Expect(0, 67839, '\p{^Is_Scx=--hatr}', "");
    Expect(0, 67839, '\P{Is_Scx=--hatr}', "");
    Expect(1, 67839, '\P{^Is_Scx=--hatr}', "");
    Expect(0, 67840, '\p{Is_Scx=--hatr}', "");
    Expect(1, 67840, '\p{^Is_Scx=--hatr}', "");
    Expect(1, 67840, '\P{Is_Scx=--hatr}', "");
    Expect(0, 67840, '\P{^Is_Scx=--hatr}', "");
    Error('\p{Script_Extensions=:=_Hebrew}');
    Error('\P{Script_Extensions=:=_Hebrew}');
    Expect(1, 64335, '\p{Script_Extensions=:\AHebrew\z:}', "");;
    Expect(0, 64336, '\p{Script_Extensions=:\AHebrew\z:}', "");;
    Expect(1, 64335, '\p{Script_Extensions=hebrew}', "");
    Expect(0, 64335, '\p{^Script_Extensions=hebrew}', "");
    Expect(0, 64335, '\P{Script_Extensions=hebrew}', "");
    Expect(1, 64335, '\P{^Script_Extensions=hebrew}', "");
    Expect(0, 64336, '\p{Script_Extensions=hebrew}', "");
    Expect(1, 64336, '\p{^Script_Extensions=hebrew}', "");
    Expect(1, 64336, '\P{Script_Extensions=hebrew}', "");
    Expect(0, 64336, '\P{^Script_Extensions=hebrew}', "");
    Expect(1, 64335, '\p{Script_Extensions=:\Ahebrew\z:}', "");;
    Expect(0, 64336, '\p{Script_Extensions=:\Ahebrew\z:}', "");;
    Expect(1, 64335, '\p{Script_Extensions=-_hebrew}', "");
    Expect(0, 64335, '\p{^Script_Extensions=-_hebrew}', "");
    Expect(0, 64335, '\P{Script_Extensions=-_hebrew}', "");
    Expect(1, 64335, '\P{^Script_Extensions=-_hebrew}', "");
    Expect(0, 64336, '\p{Script_Extensions=-_hebrew}', "");
    Expect(1, 64336, '\p{^Script_Extensions=-_hebrew}', "");
    Expect(1, 64336, '\P{Script_Extensions=-_hebrew}', "");
    Expect(0, 64336, '\P{^Script_Extensions=-_hebrew}', "");
    Error('\p{Scx=/a/  hebr}');
    Error('\P{Scx=/a/  hebr}');
    Expect(1, 64335, '\p{Scx=:\AHebr\z:}', "");;
    Expect(0, 64336, '\p{Scx=:\AHebr\z:}', "");;
    Expect(1, 64335, '\p{Scx=hebr}', "");
    Expect(0, 64335, '\p{^Scx=hebr}', "");
    Expect(0, 64335, '\P{Scx=hebr}', "");
    Expect(1, 64335, '\P{^Scx=hebr}', "");
    Expect(0, 64336, '\p{Scx=hebr}', "");
    Expect(1, 64336, '\p{^Scx=hebr}', "");
    Expect(1, 64336, '\P{Scx=hebr}', "");
    Expect(0, 64336, '\P{^Scx=hebr}', "");
    Expect(1, 64335, '\p{Scx=:\Ahebr\z:}', "");;
    Expect(0, 64336, '\p{Scx=:\Ahebr\z:}', "");;
    Expect(1, 64335, '\p{Scx=- HEBR}', "");
    Expect(0, 64335, '\p{^Scx=- HEBR}', "");
    Expect(0, 64335, '\P{Scx=- HEBR}', "");
    Expect(1, 64335, '\P{^Scx=- HEBR}', "");
    Expect(0, 64336, '\p{Scx=- HEBR}', "");
    Expect(1, 64336, '\p{^Scx=- HEBR}', "");
    Expect(1, 64336, '\P{Scx=- HEBR}', "");
    Expect(0, 64336, '\P{^Scx=- HEBR}', "");
    Error('\p{Is_Script_Extensions=:=  hebrew}');
    Error('\P{Is_Script_Extensions=:=  hebrew}');
    Expect(1, 64335, '\p{Is_Script_Extensions=hebrew}', "");
    Expect(0, 64335, '\p{^Is_Script_Extensions=hebrew}', "");
    Expect(0, 64335, '\P{Is_Script_Extensions=hebrew}', "");
    Expect(1, 64335, '\P{^Is_Script_Extensions=hebrew}', "");
    Expect(0, 64336, '\p{Is_Script_Extensions=hebrew}', "");
    Expect(1, 64336, '\p{^Is_Script_Extensions=hebrew}', "");
    Expect(1, 64336, '\P{Is_Script_Extensions=hebrew}', "");
    Expect(0, 64336, '\P{^Is_Script_Extensions=hebrew}', "");
    Expect(1, 64335, '\p{Is_Script_Extensions=	hebrew}', "");
    Expect(0, 64335, '\p{^Is_Script_Extensions=	hebrew}', "");
    Expect(0, 64335, '\P{Is_Script_Extensions=	hebrew}', "");
    Expect(1, 64335, '\P{^Is_Script_Extensions=	hebrew}', "");
    Expect(0, 64336, '\p{Is_Script_Extensions=	hebrew}', "");
    Expect(1, 64336, '\p{^Is_Script_Extensions=	hebrew}', "");
    Expect(1, 64336, '\P{Is_Script_Extensions=	hebrew}', "");
    Expect(0, 64336, '\P{^Is_Script_Extensions=	hebrew}', "");
    Error('\p{Is_Scx=:=__hebr}');
    Error('\P{Is_Scx=:=__hebr}');
    Expect(1, 64335, '\p{Is_Scx=hebr}', "");
    Expect(0, 64335, '\p{^Is_Scx=hebr}', "");
    Expect(0, 64335, '\P{Is_Scx=hebr}', "");
    Expect(1, 64335, '\P{^Is_Scx=hebr}', "");
    Expect(0, 64336, '\p{Is_Scx=hebr}', "");
    Expect(1, 64336, '\p{^Is_Scx=hebr}', "");
    Expect(1, 64336, '\P{Is_Scx=hebr}', "");
    Expect(0, 64336, '\P{^Is_Scx=hebr}', "");
    Expect(1, 64335, '\p{Is_Scx= HEBR}', "");
    Expect(0, 64335, '\p{^Is_Scx= HEBR}', "");
    Expect(0, 64335, '\P{Is_Scx= HEBR}', "");
    Expect(1, 64335, '\P{^Is_Scx= HEBR}', "");
    Expect(0, 64336, '\p{Is_Scx= HEBR}', "");
    Expect(1, 64336, '\p{^Is_Scx= HEBR}', "");
    Expect(1, 64336, '\P{Is_Scx= HEBR}', "");
    Expect(0, 64336, '\P{^Is_Scx= HEBR}', "");
    Error('\p{Script_Extensions=	Hiragana:=}');
    Error('\P{Script_Extensions=	Hiragana:=}');
    Expect(1, 127488, '\p{Script_Extensions=:\AHiragana\z:}', "");;
    Expect(0, 127489, '\p{Script_Extensions=:\AHiragana\z:}', "");;
    Expect(1, 127488, '\p{Script_Extensions=hiragana}', "");
    Expect(0, 127488, '\p{^Script_Extensions=hiragana}', "");
    Expect(0, 127488, '\P{Script_Extensions=hiragana}', "");
    Expect(1, 127488, '\P{^Script_Extensions=hiragana}', "");
    Expect(0, 127489, '\p{Script_Extensions=hiragana}', "");
    Expect(1, 127489, '\p{^Script_Extensions=hiragana}', "");
    Expect(1, 127489, '\P{Script_Extensions=hiragana}', "");
    Expect(0, 127489, '\P{^Script_Extensions=hiragana}', "");
    Expect(1, 127488, '\p{Script_Extensions=:\Ahiragana\z:}', "");;
    Expect(0, 127489, '\p{Script_Extensions=:\Ahiragana\z:}', "");;
    Expect(1, 127488, '\p{Script_Extensions=_HIRAGANA}', "");
    Expect(0, 127488, '\p{^Script_Extensions=_HIRAGANA}', "");
    Expect(0, 127488, '\P{Script_Extensions=_HIRAGANA}', "");
    Expect(1, 127488, '\P{^Script_Extensions=_HIRAGANA}', "");
    Expect(0, 127489, '\p{Script_Extensions=_HIRAGANA}', "");
    Expect(1, 127489, '\p{^Script_Extensions=_HIRAGANA}', "");
    Expect(1, 127489, '\P{Script_Extensions=_HIRAGANA}', "");
    Expect(0, 127489, '\P{^Script_Extensions=_HIRAGANA}', "");
    Error('\p{Scx=		hira/a/}');
    Error('\P{Scx=		hira/a/}');
    Expect(1, 127488, '\p{Scx=:\AHira\z:}', "");;
    Expect(0, 127489, '\p{Scx=:\AHira\z:}', "");;
    Expect(1, 127488, '\p{Scx:   hira}', "");
    Expect(0, 127488, '\p{^Scx:   hira}', "");
    Expect(0, 127488, '\P{Scx:   hira}', "");
    Expect(1, 127488, '\P{^Scx:   hira}', "");
    Expect(0, 127489, '\p{Scx:   hira}', "");
    Expect(1, 127489, '\p{^Scx:   hira}', "");
    Expect(1, 127489, '\P{Scx:   hira}', "");
    Expect(0, 127489, '\P{^Scx:   hira}', "");
    Expect(1, 127488, '\p{Scx=:\Ahira\z:}', "");;
    Expect(0, 127489, '\p{Scx=:\Ahira\z:}', "");;
    Expect(1, 127488, '\p{Scx=_-Hira}', "");
    Expect(0, 127488, '\p{^Scx=_-Hira}', "");
    Expect(0, 127488, '\P{Scx=_-Hira}', "");
    Expect(1, 127488, '\P{^Scx=_-Hira}', "");
    Expect(0, 127489, '\p{Scx=_-Hira}', "");
    Expect(1, 127489, '\p{^Scx=_-Hira}', "");
    Expect(1, 127489, '\P{Scx=_-Hira}', "");
    Expect(0, 127489, '\P{^Scx=_-Hira}', "");
    Error('\p{Is_Script_Extensions=/a/- Hiragana}');
    Error('\P{Is_Script_Extensions=/a/- Hiragana}');
    Expect(1, 127488, '\p{Is_Script_Extensions=hiragana}', "");
    Expect(0, 127488, '\p{^Is_Script_Extensions=hiragana}', "");
    Expect(0, 127488, '\P{Is_Script_Extensions=hiragana}', "");
    Expect(1, 127488, '\P{^Is_Script_Extensions=hiragana}', "");
    Expect(0, 127489, '\p{Is_Script_Extensions=hiragana}', "");
    Expect(1, 127489, '\p{^Is_Script_Extensions=hiragana}', "");
    Expect(1, 127489, '\P{Is_Script_Extensions=hiragana}', "");
    Expect(0, 127489, '\P{^Is_Script_Extensions=hiragana}', "");
    Expect(1, 127488, '\p{Is_Script_Extensions=-Hiragana}', "");
    Expect(0, 127488, '\p{^Is_Script_Extensions=-Hiragana}', "");
    Expect(0, 127488, '\P{Is_Script_Extensions=-Hiragana}', "");
    Expect(1, 127488, '\P{^Is_Script_Extensions=-Hiragana}', "");
    Expect(0, 127489, '\p{Is_Script_Extensions=-Hiragana}', "");
    Expect(1, 127489, '\p{^Is_Script_Extensions=-Hiragana}', "");
    Expect(1, 127489, '\P{Is_Script_Extensions=-Hiragana}', "");
    Expect(0, 127489, '\P{^Is_Script_Extensions=-Hiragana}', "");
    Error('\p{Is_Scx=	/a/HIRA}');
    Error('\P{Is_Scx=	/a/HIRA}');
    Expect(1, 127488, '\p{Is_Scx=hira}', "");
    Expect(0, 127488, '\p{^Is_Scx=hira}', "");
    Expect(0, 127488, '\P{Is_Scx=hira}', "");
    Expect(1, 127488, '\P{^Is_Scx=hira}', "");
    Expect(0, 127489, '\p{Is_Scx=hira}', "");
    Expect(1, 127489, '\p{^Is_Scx=hira}', "");
    Expect(1, 127489, '\P{Is_Scx=hira}', "");
    Expect(0, 127489, '\P{^Is_Scx=hira}', "");
    Expect(1, 127488, '\p{Is_Scx=--HIRA}', "");
    Expect(0, 127488, '\p{^Is_Scx=--HIRA}', "");
    Expect(0, 127488, '\P{Is_Scx=--HIRA}', "");
    Expect(1, 127488, '\P{^Is_Scx=--HIRA}', "");
    Expect(0, 127489, '\p{Is_Scx=--HIRA}', "");
    Expect(1, 127489, '\p{^Is_Scx=--HIRA}', "");
    Expect(1, 127489, '\P{Is_Scx=--HIRA}', "");
    Expect(0, 127489, '\P{^Is_Scx=--HIRA}', "");
    Error('\p{Script_Extensions=	 ANATOLIAN_HIEROGLYPHS:=}');
    Error('\P{Script_Extensions=	 ANATOLIAN_HIEROGLYPHS:=}');
    Expect(1, 83526, '\p{Script_Extensions=:\AAnatolian_Hieroglyphs\z:}', "");;
    Expect(0, 83527, '\p{Script_Extensions=:\AAnatolian_Hieroglyphs\z:}', "");;
    Expect(1, 83526, '\p{Script_Extensions=anatolianhieroglyphs}', "");
    Expect(0, 83526, '\p{^Script_Extensions=anatolianhieroglyphs}', "");
    Expect(0, 83526, '\P{Script_Extensions=anatolianhieroglyphs}', "");
    Expect(1, 83526, '\P{^Script_Extensions=anatolianhieroglyphs}', "");
    Expect(0, 83527, '\p{Script_Extensions=anatolianhieroglyphs}', "");
    Expect(1, 83527, '\p{^Script_Extensions=anatolianhieroglyphs}', "");
    Expect(1, 83527, '\P{Script_Extensions=anatolianhieroglyphs}', "");
    Expect(0, 83527, '\P{^Script_Extensions=anatolianhieroglyphs}', "");
    Expect(1, 83526, '\p{Script_Extensions=:\Aanatolianhieroglyphs\z:}', "");;
    Expect(0, 83527, '\p{Script_Extensions=:\Aanatolianhieroglyphs\z:}', "");;
    Expect(1, 83526, '\p{Script_Extensions=_ Anatolian_HIEROGLYPHS}', "");
    Expect(0, 83526, '\p{^Script_Extensions=_ Anatolian_HIEROGLYPHS}', "");
    Expect(0, 83526, '\P{Script_Extensions=_ Anatolian_HIEROGLYPHS}', "");
    Expect(1, 83526, '\P{^Script_Extensions=_ Anatolian_HIEROGLYPHS}', "");
    Expect(0, 83527, '\p{Script_Extensions=_ Anatolian_HIEROGLYPHS}', "");
    Expect(1, 83527, '\p{^Script_Extensions=_ Anatolian_HIEROGLYPHS}', "");
    Expect(1, 83527, '\P{Script_Extensions=_ Anatolian_HIEROGLYPHS}', "");
    Expect(0, 83527, '\P{^Script_Extensions=_ Anatolian_HIEROGLYPHS}', "");
    Error('\p{Scx=/a/	-Hluw}');
    Error('\P{Scx=/a/	-Hluw}');
    Expect(1, 83526, '\p{Scx=:\AHluw\z:}', "");;
    Expect(0, 83527, '\p{Scx=:\AHluw\z:}', "");;
    Expect(1, 83526, '\p{Scx=hluw}', "");
    Expect(0, 83526, '\p{^Scx=hluw}', "");
    Expect(0, 83526, '\P{Scx=hluw}', "");
    Expect(1, 83526, '\P{^Scx=hluw}', "");
    Expect(0, 83527, '\p{Scx=hluw}', "");
    Expect(1, 83527, '\p{^Scx=hluw}', "");
    Expect(1, 83527, '\P{Scx=hluw}', "");
    Expect(0, 83527, '\P{^Scx=hluw}', "");
    Expect(1, 83526, '\p{Scx=:\Ahluw\z:}', "");;
    Expect(0, 83527, '\p{Scx=:\Ahluw\z:}', "");;
    Expect(1, 83526, '\p{Scx=-_hluw}', "");
    Expect(0, 83526, '\p{^Scx=-_hluw}', "");
    Expect(0, 83526, '\P{Scx=-_hluw}', "");
    Expect(1, 83526, '\P{^Scx=-_hluw}', "");
    Expect(0, 83527, '\p{Scx=-_hluw}', "");
    Expect(1, 83527, '\p{^Scx=-_hluw}', "");
    Expect(1, 83527, '\P{Scx=-_hluw}', "");
    Expect(0, 83527, '\P{^Scx=-_hluw}', "");
    Error('\p{Is_Script_Extensions=_-ANATOLIAN_Hieroglyphs:=}');
    Error('\P{Is_Script_Extensions=_-ANATOLIAN_Hieroglyphs:=}');
    Expect(1, 83526, '\p{Is_Script_Extensions=anatolianhieroglyphs}', "");
    Expect(0, 83526, '\p{^Is_Script_Extensions=anatolianhieroglyphs}', "");
    Expect(0, 83526, '\P{Is_Script_Extensions=anatolianhieroglyphs}', "");
    Expect(1, 83526, '\P{^Is_Script_Extensions=anatolianhieroglyphs}', "");
    Expect(0, 83527, '\p{Is_Script_Extensions=anatolianhieroglyphs}', "");
    Expect(1, 83527, '\p{^Is_Script_Extensions=anatolianhieroglyphs}', "");
    Expect(1, 83527, '\P{Is_Script_Extensions=anatolianhieroglyphs}', "");
    Expect(0, 83527, '\P{^Is_Script_Extensions=anatolianhieroglyphs}', "");
    Expect(1, 83526, '\p{Is_Script_Extensions=_ anatolian_HIEROGLYPHS}', "");
    Expect(0, 83526, '\p{^Is_Script_Extensions=_ anatolian_HIEROGLYPHS}', "");
    Expect(0, 83526, '\P{Is_Script_Extensions=_ anatolian_HIEROGLYPHS}', "");
    Expect(1, 83526, '\P{^Is_Script_Extensions=_ anatolian_HIEROGLYPHS}', "");
    Expect(0, 83527, '\p{Is_Script_Extensions=_ anatolian_HIEROGLYPHS}', "");
    Expect(1, 83527, '\p{^Is_Script_Extensions=_ anatolian_HIEROGLYPHS}', "");
    Expect(1, 83527, '\P{Is_Script_Extensions=_ anatolian_HIEROGLYPHS}', "");
    Expect(0, 83527, '\P{^Is_Script_Extensions=_ anatolian_HIEROGLYPHS}', "");
    Error('\p{Is_Scx=	-Hluw/a/}');
    Error('\P{Is_Scx=	-Hluw/a/}');
    Expect(1, 83526, '\p{Is_Scx=hluw}', "");
    Expect(0, 83526, '\p{^Is_Scx=hluw}', "");
    Expect(0, 83526, '\P{Is_Scx=hluw}', "");
    Expect(1, 83526, '\P{^Is_Scx=hluw}', "");
    Expect(0, 83527, '\p{Is_Scx=hluw}', "");
    Expect(1, 83527, '\p{^Is_Scx=hluw}', "");
    Expect(1, 83527, '\P{Is_Scx=hluw}', "");
    Expect(0, 83527, '\P{^Is_Scx=hluw}', "");
    Expect(1, 83526, '\p{Is_Scx=-Hluw}', "");
    Expect(0, 83526, '\p{^Is_Scx=-Hluw}', "");
    Expect(0, 83526, '\P{Is_Scx=-Hluw}', "");
    Expect(1, 83526, '\P{^Is_Scx=-Hluw}', "");
    Expect(0, 83527, '\p{Is_Scx=-Hluw}', "");
    Expect(1, 83527, '\p{^Is_Scx=-Hluw}', "");
    Expect(1, 83527, '\P{Is_Scx=-Hluw}', "");
    Expect(0, 83527, '\P{^Is_Scx=-Hluw}', "");
    Error('\p{Script_Extensions=/a/ -Pahawh_hmong}');
    Error('\P{Script_Extensions=/a/ -Pahawh_hmong}');
    Expect(1, 93071, '\p{Script_Extensions=:\APahawh_Hmong\z:}', "");;
    Expect(0, 93072, '\p{Script_Extensions=:\APahawh_Hmong\z:}', "");;
    Expect(1, 93071, '\p{Script_Extensions=pahawhhmong}', "");
    Expect(0, 93071, '\p{^Script_Extensions=pahawhhmong}', "");
    Expect(0, 93071, '\P{Script_Extensions=pahawhhmong}', "");
    Expect(1, 93071, '\P{^Script_Extensions=pahawhhmong}', "");
    Expect(0, 93072, '\p{Script_Extensions=pahawhhmong}', "");
    Expect(1, 93072, '\p{^Script_Extensions=pahawhhmong}', "");
    Expect(1, 93072, '\P{Script_Extensions=pahawhhmong}', "");
    Expect(0, 93072, '\P{^Script_Extensions=pahawhhmong}', "");
    Expect(1, 93071, '\p{Script_Extensions=:\Apahawhhmong\z:}', "");;
    Expect(0, 93072, '\p{Script_Extensions=:\Apahawhhmong\z:}', "");;
    Expect(1, 93071, '\p{Script_Extensions=		Pahawh_Hmong}', "");
    Expect(0, 93071, '\p{^Script_Extensions=		Pahawh_Hmong}', "");
    Expect(0, 93071, '\P{Script_Extensions=		Pahawh_Hmong}', "");
    Expect(1, 93071, '\P{^Script_Extensions=		Pahawh_Hmong}', "");
    Expect(0, 93072, '\p{Script_Extensions=		Pahawh_Hmong}', "");
    Expect(1, 93072, '\p{^Script_Extensions=		Pahawh_Hmong}', "");
    Expect(1, 93072, '\P{Script_Extensions=		Pahawh_Hmong}', "");
    Expect(0, 93072, '\P{^Script_Extensions=		Pahawh_Hmong}', "");
    Error('\p{Scx=	/a/Hmng}');
    Error('\P{Scx=	/a/Hmng}');
    Expect(1, 93071, '\p{Scx=:\AHmng\z:}', "");;
    Expect(0, 93072, '\p{Scx=:\AHmng\z:}', "");;
    Expect(1, 93071, '\p{Scx=hmng}', "");
    Expect(0, 93071, '\p{^Scx=hmng}', "");
    Expect(0, 93071, '\P{Scx=hmng}', "");
    Expect(1, 93071, '\P{^Scx=hmng}', "");
    Expect(0, 93072, '\p{Scx=hmng}', "");
    Expect(1, 93072, '\p{^Scx=hmng}', "");
    Expect(1, 93072, '\P{Scx=hmng}', "");
    Expect(0, 93072, '\P{^Scx=hmng}', "");
    Expect(1, 93071, '\p{Scx=:\Ahmng\z:}', "");;
    Expect(0, 93072, '\p{Scx=:\Ahmng\z:}', "");;
    Expect(1, 93071, '\p{Scx=__hmng}', "");
    Expect(0, 93071, '\p{^Scx=__hmng}', "");
    Expect(0, 93071, '\P{Scx=__hmng}', "");
    Expect(1, 93071, '\P{^Scx=__hmng}', "");
    Expect(0, 93072, '\p{Scx=__hmng}', "");
    Expect(1, 93072, '\p{^Scx=__hmng}', "");
    Expect(1, 93072, '\P{Scx=__hmng}', "");
    Expect(0, 93072, '\P{^Scx=__hmng}', "");
    Error('\p{Is_Script_Extensions=	/a/Pahawh_Hmong}');
    Error('\P{Is_Script_Extensions=	/a/Pahawh_Hmong}');
    Expect(1, 93071, '\p{Is_Script_Extensions=pahawhhmong}', "");
    Expect(0, 93071, '\p{^Is_Script_Extensions=pahawhhmong}', "");
    Expect(0, 93071, '\P{Is_Script_Extensions=pahawhhmong}', "");
    Expect(1, 93071, '\P{^Is_Script_Extensions=pahawhhmong}', "");
    Expect(0, 93072, '\p{Is_Script_Extensions=pahawhhmong}', "");
    Expect(1, 93072, '\p{^Is_Script_Extensions=pahawhhmong}', "");
    Expect(1, 93072, '\P{Is_Script_Extensions=pahawhhmong}', "");
    Expect(0, 93072, '\P{^Is_Script_Extensions=pahawhhmong}', "");
    Expect(1, 93071, '\p{Is_Script_Extensions=-Pahawh_hmong}', "");
    Expect(0, 93071, '\p{^Is_Script_Extensions=-Pahawh_hmong}', "");
    Expect(0, 93071, '\P{Is_Script_Extensions=-Pahawh_hmong}', "");
    Expect(1, 93071, '\P{^Is_Script_Extensions=-Pahawh_hmong}', "");
    Expect(0, 93072, '\p{Is_Script_Extensions=-Pahawh_hmong}', "");
    Expect(1, 93072, '\p{^Is_Script_Extensions=-Pahawh_hmong}', "");
    Expect(1, 93072, '\P{Is_Script_Extensions=-Pahawh_hmong}', "");
    Expect(0, 93072, '\P{^Is_Script_Extensions=-Pahawh_hmong}', "");
    Error('\p{Is_Scx=/a/ hmng}');
    Error('\P{Is_Scx=/a/ hmng}');
    Expect(1, 93071, '\p{Is_Scx=hmng}', "");
    Expect(0, 93071, '\p{^Is_Scx=hmng}', "");
    Expect(0, 93071, '\P{Is_Scx=hmng}', "");
    Expect(1, 93071, '\P{^Is_Scx=hmng}', "");
    Expect(0, 93072, '\p{Is_Scx=hmng}', "");
    Expect(1, 93072, '\p{^Is_Scx=hmng}', "");
    Expect(1, 93072, '\P{Is_Scx=hmng}', "");
    Expect(0, 93072, '\P{^Is_Scx=hmng}', "");
    Expect(1, 93071, '\p{Is_Scx=Hmng}', "");
    Expect(0, 93071, '\p{^Is_Scx=Hmng}', "");
    Expect(0, 93071, '\P{Is_Scx=Hmng}', "");
    Expect(1, 93071, '\P{^Is_Scx=Hmng}', "");
    Expect(0, 93072, '\p{Is_Scx=Hmng}', "");
    Expect(1, 93072, '\p{^Is_Scx=Hmng}', "");
    Expect(1, 93072, '\P{Is_Scx=Hmng}', "");
    Expect(0, 93072, '\P{^Is_Scx=Hmng}', "");
    Error('\p{Script_Extensions=:=  Nyiakeng_puachue_hmong}');
    Error('\P{Script_Extensions=:=  Nyiakeng_puachue_hmong}');
    Expect(1, 123215, '\p{Script_Extensions=:\ANyiakeng_Puachue_Hmong\z:}', "");;
    Expect(0, 123216, '\p{Script_Extensions=:\ANyiakeng_Puachue_Hmong\z:}', "");;
    Expect(1, 123215, '\p{Script_Extensions=nyiakengpuachuehmong}', "");
    Expect(0, 123215, '\p{^Script_Extensions=nyiakengpuachuehmong}', "");
    Expect(0, 123215, '\P{Script_Extensions=nyiakengpuachuehmong}', "");
    Expect(1, 123215, '\P{^Script_Extensions=nyiakengpuachuehmong}', "");
    Expect(0, 123216, '\p{Script_Extensions=nyiakengpuachuehmong}', "");
    Expect(1, 123216, '\p{^Script_Extensions=nyiakengpuachuehmong}', "");
    Expect(1, 123216, '\P{Script_Extensions=nyiakengpuachuehmong}', "");
    Expect(0, 123216, '\P{^Script_Extensions=nyiakengpuachuehmong}', "");
    Expect(1, 123215, '\p{Script_Extensions=:\Anyiakengpuachuehmong\z:}', "");;
    Expect(0, 123216, '\p{Script_Extensions=:\Anyiakengpuachuehmong\z:}', "");;
    Expect(1, 123215, '\p{Script_Extensions=_Nyiakeng_PUACHUE_HMONG}', "");
    Expect(0, 123215, '\p{^Script_Extensions=_Nyiakeng_PUACHUE_HMONG}', "");
    Expect(0, 123215, '\P{Script_Extensions=_Nyiakeng_PUACHUE_HMONG}', "");
    Expect(1, 123215, '\P{^Script_Extensions=_Nyiakeng_PUACHUE_HMONG}', "");
    Expect(0, 123216, '\p{Script_Extensions=_Nyiakeng_PUACHUE_HMONG}', "");
    Expect(1, 123216, '\p{^Script_Extensions=_Nyiakeng_PUACHUE_HMONG}', "");
    Expect(1, 123216, '\P{Script_Extensions=_Nyiakeng_PUACHUE_HMONG}', "");
    Expect(0, 123216, '\P{^Script_Extensions=_Nyiakeng_PUACHUE_HMONG}', "");
    Error('\p{Scx= :=HMNP}');
    Error('\P{Scx= :=HMNP}');
    Expect(1, 123215, '\p{Scx=:\AHmnp\z:}', "");;
    Expect(0, 123216, '\p{Scx=:\AHmnp\z:}', "");;
    Expect(1, 123215, '\p{Scx=hmnp}', "");
    Expect(0, 123215, '\p{^Scx=hmnp}', "");
    Expect(0, 123215, '\P{Scx=hmnp}', "");
    Expect(1, 123215, '\P{^Scx=hmnp}', "");
    Expect(0, 123216, '\p{Scx=hmnp}', "");
    Expect(1, 123216, '\p{^Scx=hmnp}', "");
    Expect(1, 123216, '\P{Scx=hmnp}', "");
    Expect(0, 123216, '\P{^Scx=hmnp}', "");
    Expect(1, 123215, '\p{Scx=:\Ahmnp\z:}', "");;
    Expect(0, 123216, '\p{Scx=:\Ahmnp\z:}', "");;
    Expect(1, 123215, '\p{Scx=  hmnp}', "");
    Expect(0, 123215, '\p{^Scx=  hmnp}', "");
    Expect(0, 123215, '\P{Scx=  hmnp}', "");
    Expect(1, 123215, '\P{^Scx=  hmnp}', "");
    Expect(0, 123216, '\p{Scx=  hmnp}', "");
    Expect(1, 123216, '\p{^Scx=  hmnp}', "");
    Expect(1, 123216, '\P{Scx=  hmnp}', "");
    Expect(0, 123216, '\P{^Scx=  hmnp}', "");
    Error('\p{Is_Script_Extensions=_/a/Nyiakeng_Puachue_Hmong}');
    Error('\P{Is_Script_Extensions=_/a/Nyiakeng_Puachue_Hmong}');
    Expect(1, 123215, '\p{Is_Script_Extensions: nyiakengpuachuehmong}', "");
    Expect(0, 123215, '\p{^Is_Script_Extensions: nyiakengpuachuehmong}', "");
    Expect(0, 123215, '\P{Is_Script_Extensions: nyiakengpuachuehmong}', "");
    Expect(1, 123215, '\P{^Is_Script_Extensions: nyiakengpuachuehmong}', "");
    Expect(0, 123216, '\p{Is_Script_Extensions: nyiakengpuachuehmong}', "");
    Expect(1, 123216, '\p{^Is_Script_Extensions: nyiakengpuachuehmong}', "");
    Expect(1, 123216, '\P{Is_Script_Extensions: nyiakengpuachuehmong}', "");
    Expect(0, 123216, '\P{^Is_Script_Extensions: nyiakengpuachuehmong}', "");
    Expect(1, 123215, '\p{Is_Script_Extensions= 	nyiakeng_Puachue_HMONG}', "");
    Expect(0, 123215, '\p{^Is_Script_Extensions= 	nyiakeng_Puachue_HMONG}', "");
    Expect(0, 123215, '\P{Is_Script_Extensions= 	nyiakeng_Puachue_HMONG}', "");
    Expect(1, 123215, '\P{^Is_Script_Extensions= 	nyiakeng_Puachue_HMONG}', "");
    Expect(0, 123216, '\p{Is_Script_Extensions= 	nyiakeng_Puachue_HMONG}', "");
    Expect(1, 123216, '\p{^Is_Script_Extensions= 	nyiakeng_Puachue_HMONG}', "");
    Expect(1, 123216, '\P{Is_Script_Extensions= 	nyiakeng_Puachue_HMONG}', "");
    Expect(0, 123216, '\P{^Is_Script_Extensions= 	nyiakeng_Puachue_HMONG}', "");
    Error('\p{Is_Scx=/a/-HMNP}');
    Error('\P{Is_Scx=/a/-HMNP}');
    Expect(1, 123215, '\p{Is_Scx=hmnp}', "");
    Expect(0, 123215, '\p{^Is_Scx=hmnp}', "");
    Expect(0, 123215, '\P{Is_Scx=hmnp}', "");
    Expect(1, 123215, '\P{^Is_Scx=hmnp}', "");
    Expect(0, 123216, '\p{Is_Scx=hmnp}', "");
    Expect(1, 123216, '\p{^Is_Scx=hmnp}', "");
    Expect(1, 123216, '\P{Is_Scx=hmnp}', "");
    Expect(0, 123216, '\P{^Is_Scx=hmnp}', "");
    Expect(1, 123215, '\p{Is_Scx=	 Hmnp}', "");
    Expect(0, 123215, '\p{^Is_Scx=	 Hmnp}', "");
    Expect(0, 123215, '\P{Is_Scx=	 Hmnp}', "");
    Expect(1, 123215, '\P{^Is_Scx=	 Hmnp}', "");
    Expect(0, 123216, '\p{Is_Scx=	 Hmnp}', "");
    Expect(1, 123216, '\p{^Is_Scx=	 Hmnp}', "");
    Expect(1, 123216, '\P{Is_Scx=	 Hmnp}', "");
    Expect(0, 123216, '\P{^Is_Scx=	 Hmnp}', "");
    Error('\p{Script_Extensions=Katakana_Or_Hiragana}');
    Error('\P{Script_Extensions=Katakana_Or_Hiragana}');
    Error('\p{Scx=Hrkt}');
    Error('\P{Scx=Hrkt}');
    Error('\p{Is_Script_Extensions=Katakana_Or_Hiragana}');
    Error('\P{Is_Script_Extensions=Katakana_Or_Hiragana}');
    Error('\p{Is_Scx=Hrkt}');
    Error('\P{Is_Scx=Hrkt}');
    Error('\p{Script_Extensions= /a/Old_Hungarian}');
    Error('\P{Script_Extensions= /a/Old_Hungarian}');
    Expect(1, 68863, '\p{Script_Extensions=:\AOld_Hungarian\z:}', "");;
    Expect(0, 68864, '\p{Script_Extensions=:\AOld_Hungarian\z:}', "");;
    Expect(1, 68863, '\p{Script_Extensions=oldhungarian}', "");
    Expect(0, 68863, '\p{^Script_Extensions=oldhungarian}', "");
    Expect(0, 68863, '\P{Script_Extensions=oldhungarian}', "");
    Expect(1, 68863, '\P{^Script_Extensions=oldhungarian}', "");
    Expect(0, 68864, '\p{Script_Extensions=oldhungarian}', "");
    Expect(1, 68864, '\p{^Script_Extensions=oldhungarian}', "");
    Expect(1, 68864, '\P{Script_Extensions=oldhungarian}', "");
    Expect(0, 68864, '\P{^Script_Extensions=oldhungarian}', "");
    Expect(1, 68863, '\p{Script_Extensions=:\Aoldhungarian\z:}', "");;
    Expect(0, 68864, '\p{Script_Extensions=:\Aoldhungarian\z:}', "");;
    Expect(1, 68863, '\p{Script_Extensions=_-old_hungarian}', "");
    Expect(0, 68863, '\p{^Script_Extensions=_-old_hungarian}', "");
    Expect(0, 68863, '\P{Script_Extensions=_-old_hungarian}', "");
    Expect(1, 68863, '\P{^Script_Extensions=_-old_hungarian}', "");
    Expect(0, 68864, '\p{Script_Extensions=_-old_hungarian}', "");
    Expect(1, 68864, '\p{^Script_Extensions=_-old_hungarian}', "");
    Expect(1, 68864, '\P{Script_Extensions=_-old_hungarian}', "");
    Expect(0, 68864, '\P{^Script_Extensions=_-old_hungarian}', "");
    Error('\p{Scx=-_Hung/a/}');
    Error('\P{Scx=-_Hung/a/}');
    Expect(1, 68863, '\p{Scx=:\AHung\z:}', "");;
    Expect(0, 68864, '\p{Scx=:\AHung\z:}', "");;
    Expect(1, 68863, '\p{Scx=hung}', "");
    Expect(0, 68863, '\p{^Scx=hung}', "");
    Expect(0, 68863, '\P{Scx=hung}', "");
    Expect(1, 68863, '\P{^Scx=hung}', "");
    Expect(0, 68864, '\p{Scx=hung}', "");
    Expect(1, 68864, '\p{^Scx=hung}', "");
    Expect(1, 68864, '\P{Scx=hung}', "");
    Expect(0, 68864, '\P{^Scx=hung}', "");
    Expect(1, 68863, '\p{Scx=:\Ahung\z:}', "");;
    Expect(0, 68864, '\p{Scx=:\Ahung\z:}', "");;
    Expect(1, 68863, '\p{Scx=--Hung}', "");
    Expect(0, 68863, '\p{^Scx=--Hung}', "");
    Expect(0, 68863, '\P{Scx=--Hung}', "");
    Expect(1, 68863, '\P{^Scx=--Hung}', "");
    Expect(0, 68864, '\p{Scx=--Hung}', "");
    Expect(1, 68864, '\p{^Scx=--Hung}', "");
    Expect(1, 68864, '\P{Scx=--Hung}', "");
    Expect(0, 68864, '\P{^Scx=--Hung}', "");
    Error('\p{Is_Script_Extensions:   __OLD_Hungarian:=}');
    Error('\P{Is_Script_Extensions:   __OLD_Hungarian:=}');
    Expect(1, 68863, '\p{Is_Script_Extensions=oldhungarian}', "");
    Expect(0, 68863, '\p{^Is_Script_Extensions=oldhungarian}', "");
    Expect(0, 68863, '\P{Is_Script_Extensions=oldhungarian}', "");
    Expect(1, 68863, '\P{^Is_Script_Extensions=oldhungarian}', "");
    Expect(0, 68864, '\p{Is_Script_Extensions=oldhungarian}', "");
    Expect(1, 68864, '\p{^Is_Script_Extensions=oldhungarian}', "");
    Expect(1, 68864, '\P{Is_Script_Extensions=oldhungarian}', "");
    Expect(0, 68864, '\P{^Is_Script_Extensions=oldhungarian}', "");
    Expect(1, 68863, '\p{Is_Script_Extensions=--Old_Hungarian}', "");
    Expect(0, 68863, '\p{^Is_Script_Extensions=--Old_Hungarian}', "");
    Expect(0, 68863, '\P{Is_Script_Extensions=--Old_Hungarian}', "");
    Expect(1, 68863, '\P{^Is_Script_Extensions=--Old_Hungarian}', "");
    Expect(0, 68864, '\p{Is_Script_Extensions=--Old_Hungarian}', "");
    Expect(1, 68864, '\p{^Is_Script_Extensions=--Old_Hungarian}', "");
    Expect(1, 68864, '\P{Is_Script_Extensions=--Old_Hungarian}', "");
    Expect(0, 68864, '\P{^Is_Script_Extensions=--Old_Hungarian}', "");
    Error('\p{Is_Scx=/a/_-hung}');
    Error('\P{Is_Scx=/a/_-hung}');
    Expect(1, 68863, '\p{Is_Scx=hung}', "");
    Expect(0, 68863, '\p{^Is_Scx=hung}', "");
    Expect(0, 68863, '\P{Is_Scx=hung}', "");
    Expect(1, 68863, '\P{^Is_Scx=hung}', "");
    Expect(0, 68864, '\p{Is_Scx=hung}', "");
    Expect(1, 68864, '\p{^Is_Scx=hung}', "");
    Expect(1, 68864, '\P{Is_Scx=hung}', "");
    Expect(0, 68864, '\P{^Is_Scx=hung}', "");
    Expect(1, 68863, '\p{Is_Scx= _Hung}', "");
    Expect(0, 68863, '\p{^Is_Scx= _Hung}', "");
    Expect(0, 68863, '\P{Is_Scx= _Hung}', "");
    Expect(1, 68863, '\P{^Is_Scx= _Hung}', "");
    Expect(0, 68864, '\p{Is_Scx= _Hung}', "");
    Expect(1, 68864, '\p{^Is_Scx= _Hung}', "");
    Expect(1, 68864, '\P{Is_Scx= _Hung}', "");
    Expect(0, 68864, '\P{^Is_Scx= _Hung}', "");
    Error('\p{Script_Extensions=_:=Old_italic}');
    Error('\P{Script_Extensions=_:=Old_italic}');
    Expect(1, 66351, '\p{Script_Extensions=:\AOld_Italic\z:}', "");;
    Expect(0, 66352, '\p{Script_Extensions=:\AOld_Italic\z:}', "");;
    Expect(1, 66351, '\p{Script_Extensions=olditalic}', "");
    Expect(0, 66351, '\p{^Script_Extensions=olditalic}', "");
    Expect(0, 66351, '\P{Script_Extensions=olditalic}', "");
    Expect(1, 66351, '\P{^Script_Extensions=olditalic}', "");
    Expect(0, 66352, '\p{Script_Extensions=olditalic}', "");
    Expect(1, 66352, '\p{^Script_Extensions=olditalic}', "");
    Expect(1, 66352, '\P{Script_Extensions=olditalic}', "");
    Expect(0, 66352, '\P{^Script_Extensions=olditalic}', "");
    Expect(1, 66351, '\p{Script_Extensions=:\Aolditalic\z:}', "");;
    Expect(0, 66352, '\p{Script_Extensions=:\Aolditalic\z:}', "");;
    Expect(1, 66351, '\p{Script_Extensions=	-Old_Italic}', "");
    Expect(0, 66351, '\p{^Script_Extensions=	-Old_Italic}', "");
    Expect(0, 66351, '\P{Script_Extensions=	-Old_Italic}', "");
    Expect(1, 66351, '\P{^Script_Extensions=	-Old_Italic}', "");
    Expect(0, 66352, '\p{Script_Extensions=	-Old_Italic}', "");
    Expect(1, 66352, '\p{^Script_Extensions=	-Old_Italic}', "");
    Expect(1, 66352, '\P{Script_Extensions=	-Old_Italic}', "");
    Expect(0, 66352, '\P{^Script_Extensions=	-Old_Italic}', "");
    Error('\p{Scx:   _:=Ital}');
    Error('\P{Scx:   _:=Ital}');
    Expect(1, 66351, '\p{Scx=:\AItal\z:}', "");;
    Expect(0, 66352, '\p{Scx=:\AItal\z:}', "");;
    Expect(1, 66351, '\p{Scx=ital}', "");
    Expect(0, 66351, '\p{^Scx=ital}', "");
    Expect(0, 66351, '\P{Scx=ital}', "");
    Expect(1, 66351, '\P{^Scx=ital}', "");
    Expect(0, 66352, '\p{Scx=ital}', "");
    Expect(1, 66352, '\p{^Scx=ital}', "");
    Expect(1, 66352, '\P{Scx=ital}', "");
    Expect(0, 66352, '\P{^Scx=ital}', "");
    Expect(1, 66351, '\p{Scx=:\Aital\z:}', "");;
    Expect(0, 66352, '\p{Scx=:\Aital\z:}', "");;
    Expect(1, 66351, '\p{Scx=-	Ital}', "");
    Expect(0, 66351, '\p{^Scx=-	Ital}', "");
    Expect(0, 66351, '\P{Scx=-	Ital}', "");
    Expect(1, 66351, '\P{^Scx=-	Ital}', "");
    Expect(0, 66352, '\p{Scx=-	Ital}', "");
    Expect(1, 66352, '\p{^Scx=-	Ital}', "");
    Expect(1, 66352, '\P{Scx=-	Ital}', "");
    Expect(0, 66352, '\P{^Scx=-	Ital}', "");
    Error('\p{Is_Script_Extensions=:=-old_Italic}');
    Error('\P{Is_Script_Extensions=:=-old_Italic}');
    Expect(1, 66351, '\p{Is_Script_Extensions=olditalic}', "");
    Expect(0, 66351, '\p{^Is_Script_Extensions=olditalic}', "");
    Expect(0, 66351, '\P{Is_Script_Extensions=olditalic}', "");
    Expect(1, 66351, '\P{^Is_Script_Extensions=olditalic}', "");
    Expect(0, 66352, '\p{Is_Script_Extensions=olditalic}', "");
    Expect(1, 66352, '\p{^Is_Script_Extensions=olditalic}', "");
    Expect(1, 66352, '\P{Is_Script_Extensions=olditalic}', "");
    Expect(0, 66352, '\P{^Is_Script_Extensions=olditalic}', "");
    Expect(1, 66351, '\p{Is_Script_Extensions=_Old_italic}', "");
    Expect(0, 66351, '\p{^Is_Script_Extensions=_Old_italic}', "");
    Expect(0, 66351, '\P{Is_Script_Extensions=_Old_italic}', "");
    Expect(1, 66351, '\P{^Is_Script_Extensions=_Old_italic}', "");
    Expect(0, 66352, '\p{Is_Script_Extensions=_Old_italic}', "");
    Expect(1, 66352, '\p{^Is_Script_Extensions=_Old_italic}', "");
    Expect(1, 66352, '\P{Is_Script_Extensions=_Old_italic}', "");
    Expect(0, 66352, '\P{^Is_Script_Extensions=_Old_italic}', "");
    Error('\p{Is_Scx: _/a/ITAL}');
    Error('\P{Is_Scx: _/a/ITAL}');
    Expect(1, 66351, '\p{Is_Scx=ital}', "");
    Expect(0, 66351, '\p{^Is_Scx=ital}', "");
    Expect(0, 66351, '\P{Is_Scx=ital}', "");
    Expect(1, 66351, '\P{^Is_Scx=ital}', "");
    Expect(0, 66352, '\p{Is_Scx=ital}', "");
    Expect(1, 66352, '\p{^Is_Scx=ital}', "");
    Expect(1, 66352, '\P{Is_Scx=ital}', "");
    Expect(0, 66352, '\P{^Is_Scx=ital}', "");
    Expect(1, 66351, '\p{Is_Scx=  Ital}', "");
    Expect(0, 66351, '\p{^Is_Scx=  Ital}', "");
    Expect(0, 66351, '\P{Is_Scx=  Ital}', "");
    Expect(1, 66351, '\P{^Is_Scx=  Ital}', "");
    Expect(0, 66352, '\p{Is_Scx=  Ital}', "");
    Expect(1, 66352, '\p{^Is_Scx=  Ital}', "");
    Expect(1, 66352, '\P{Is_Scx=  Ital}', "");
    Expect(0, 66352, '\P{^Is_Scx=  Ital}', "");
    Error('\p{Script_Extensions=:=	Javanese}');
    Error('\P{Script_Extensions=:=	Javanese}');
    Expect(1, 43487, '\p{Script_Extensions=:\AJavanese\z:}', "");;
    Expect(0, 43488, '\p{Script_Extensions=:\AJavanese\z:}', "");;
    Expect(1, 43487, '\p{Script_Extensions=javanese}', "");
    Expect(0, 43487, '\p{^Script_Extensions=javanese}', "");
    Expect(0, 43487, '\P{Script_Extensions=javanese}', "");
    Expect(1, 43487, '\P{^Script_Extensions=javanese}', "");
    Expect(0, 43488, '\p{Script_Extensions=javanese}', "");
    Expect(1, 43488, '\p{^Script_Extensions=javanese}', "");
    Expect(1, 43488, '\P{Script_Extensions=javanese}', "");
    Expect(0, 43488, '\P{^Script_Extensions=javanese}', "");
    Expect(1, 43487, '\p{Script_Extensions=:\Ajavanese\z:}', "");;
    Expect(0, 43488, '\p{Script_Extensions=:\Ajavanese\z:}', "");;
    Expect(1, 43487, '\p{Script_Extensions=__Javanese}', "");
    Expect(0, 43487, '\p{^Script_Extensions=__Javanese}', "");
    Expect(0, 43487, '\P{Script_Extensions=__Javanese}', "");
    Expect(1, 43487, '\P{^Script_Extensions=__Javanese}', "");
    Expect(0, 43488, '\p{Script_Extensions=__Javanese}', "");
    Expect(1, 43488, '\p{^Script_Extensions=__Javanese}', "");
    Expect(1, 43488, '\P{Script_Extensions=__Javanese}', "");
    Expect(0, 43488, '\P{^Script_Extensions=__Javanese}', "");
    Error('\p{Scx=/a/ _Java}');
    Error('\P{Scx=/a/ _Java}');
    Expect(1, 43487, '\p{Scx=:\AJava\z:}', "");;
    Expect(0, 43488, '\p{Scx=:\AJava\z:}', "");;
    Expect(1, 43487, '\p{Scx=java}', "");
    Expect(0, 43487, '\p{^Scx=java}', "");
    Expect(0, 43487, '\P{Scx=java}', "");
    Expect(1, 43487, '\P{^Scx=java}', "");
    Expect(0, 43488, '\p{Scx=java}', "");
    Expect(1, 43488, '\p{^Scx=java}', "");
    Expect(1, 43488, '\P{Scx=java}', "");
    Expect(0, 43488, '\P{^Scx=java}', "");
    Expect(1, 43487, '\p{Scx=:\Ajava\z:}', "");;
    Expect(0, 43488, '\p{Scx=:\Ajava\z:}', "");;
    Expect(1, 43487, '\p{Scx= 	JAVA}', "");
    Expect(0, 43487, '\p{^Scx= 	JAVA}', "");
    Expect(0, 43487, '\P{Scx= 	JAVA}', "");
    Expect(1, 43487, '\P{^Scx= 	JAVA}', "");
    Expect(0, 43488, '\p{Scx= 	JAVA}', "");
    Expect(1, 43488, '\p{^Scx= 	JAVA}', "");
    Expect(1, 43488, '\P{Scx= 	JAVA}', "");
    Expect(0, 43488, '\P{^Scx= 	JAVA}', "");
    Error('\p{Is_Script_Extensions=:=_JAVANESE}');
    Error('\P{Is_Script_Extensions=:=_JAVANESE}');
    Expect(1, 43487, '\p{Is_Script_Extensions=javanese}', "");
    Expect(0, 43487, '\p{^Is_Script_Extensions=javanese}', "");
    Expect(0, 43487, '\P{Is_Script_Extensions=javanese}', "");
    Expect(1, 43487, '\P{^Is_Script_Extensions=javanese}', "");
    Expect(0, 43488, '\p{Is_Script_Extensions=javanese}', "");
    Expect(1, 43488, '\p{^Is_Script_Extensions=javanese}', "");
    Expect(1, 43488, '\P{Is_Script_Extensions=javanese}', "");
    Expect(0, 43488, '\P{^Is_Script_Extensions=javanese}', "");
    Expect(1, 43487, '\p{Is_Script_Extensions: 	JAVANESE}', "");
    Expect(0, 43487, '\p{^Is_Script_Extensions: 	JAVANESE}', "");
    Expect(0, 43487, '\P{Is_Script_Extensions: 	JAVANESE}', "");
    Expect(1, 43487, '\P{^Is_Script_Extensions: 	JAVANESE}', "");
    Expect(0, 43488, '\p{Is_Script_Extensions: 	JAVANESE}', "");
    Expect(1, 43488, '\p{^Is_Script_Extensions: 	JAVANESE}', "");
    Expect(1, 43488, '\P{Is_Script_Extensions: 	JAVANESE}', "");
    Expect(0, 43488, '\P{^Is_Script_Extensions: 	JAVANESE}', "");
    Error('\p{Is_Scx=	:=JAVA}');
    Error('\P{Is_Scx=	:=JAVA}');
    Expect(1, 43487, '\p{Is_Scx=java}', "");
    Expect(0, 43487, '\p{^Is_Scx=java}', "");
    Expect(0, 43487, '\P{Is_Scx=java}', "");
    Expect(1, 43487, '\P{^Is_Scx=java}', "");
    Expect(0, 43488, '\p{Is_Scx=java}', "");
    Expect(1, 43488, '\p{^Is_Scx=java}', "");
    Expect(1, 43488, '\P{Is_Scx=java}', "");
    Expect(0, 43488, '\P{^Is_Scx=java}', "");
    Expect(1, 43487, '\p{Is_Scx=	JAVA}', "");
    Expect(0, 43487, '\p{^Is_Scx=	JAVA}', "");
    Expect(0, 43487, '\P{Is_Scx=	JAVA}', "");
    Expect(1, 43487, '\P{^Is_Scx=	JAVA}', "");
    Expect(0, 43488, '\p{Is_Scx=	JAVA}', "");
    Expect(1, 43488, '\p{^Is_Scx=	JAVA}', "");
    Expect(1, 43488, '\P{Is_Scx=	JAVA}', "");
    Expect(0, 43488, '\P{^Is_Scx=	JAVA}', "");
    Error('\p{Script_Extensions=Kayah_LI:=}');
    Error('\P{Script_Extensions=Kayah_LI:=}');
    Expect(1, 43311, '\p{Script_Extensions=:\AKayah_Li\z:}', "");;
    Expect(0, 43312, '\p{Script_Extensions=:\AKayah_Li\z:}', "");;
    Expect(1, 43311, '\p{Script_Extensions=kayahli}', "");
    Expect(0, 43311, '\p{^Script_Extensions=kayahli}', "");
    Expect(0, 43311, '\P{Script_Extensions=kayahli}', "");
    Expect(1, 43311, '\P{^Script_Extensions=kayahli}', "");
    Expect(0, 43312, '\p{Script_Extensions=kayahli}', "");
    Expect(1, 43312, '\p{^Script_Extensions=kayahli}', "");
    Expect(1, 43312, '\P{Script_Extensions=kayahli}', "");
    Expect(0, 43312, '\P{^Script_Extensions=kayahli}', "");
    Expect(1, 43311, '\p{Script_Extensions=:\Akayahli\z:}', "");;
    Expect(0, 43312, '\p{Script_Extensions=:\Akayahli\z:}', "");;
    Expect(1, 43311, '\p{Script_Extensions:   		KAYAH_LI}', "");
    Expect(0, 43311, '\p{^Script_Extensions:   		KAYAH_LI}', "");
    Expect(0, 43311, '\P{Script_Extensions:   		KAYAH_LI}', "");
    Expect(1, 43311, '\P{^Script_Extensions:   		KAYAH_LI}', "");
    Expect(0, 43312, '\p{Script_Extensions:   		KAYAH_LI}', "");
    Expect(1, 43312, '\p{^Script_Extensions:   		KAYAH_LI}', "");
    Expect(1, 43312, '\P{Script_Extensions:   		KAYAH_LI}', "");
    Expect(0, 43312, '\P{^Script_Extensions:   		KAYAH_LI}', "");
    Error('\p{Scx:   :=	_kali}');
    Error('\P{Scx:   :=	_kali}');
    Expect(1, 43311, '\p{Scx=:\AKali\z:}', "");;
    Expect(0, 43312, '\p{Scx=:\AKali\z:}', "");;
    Expect(1, 43311, '\p{Scx=kali}', "");
    Expect(0, 43311, '\p{^Scx=kali}', "");
    Expect(0, 43311, '\P{Scx=kali}', "");
    Expect(1, 43311, '\P{^Scx=kali}', "");
    Expect(0, 43312, '\p{Scx=kali}', "");
    Expect(1, 43312, '\p{^Scx=kali}', "");
    Expect(1, 43312, '\P{Scx=kali}', "");
    Expect(0, 43312, '\P{^Scx=kali}', "");
    Expect(1, 43311, '\p{Scx=:\Akali\z:}', "");;
    Expect(0, 43312, '\p{Scx=:\Akali\z:}', "");;
    Expect(1, 43311, '\p{Scx= _Kali}', "");
    Expect(0, 43311, '\p{^Scx= _Kali}', "");
    Expect(0, 43311, '\P{Scx= _Kali}', "");
    Expect(1, 43311, '\P{^Scx= _Kali}', "");
    Expect(0, 43312, '\p{Scx= _Kali}', "");
    Expect(1, 43312, '\p{^Scx= _Kali}', "");
    Expect(1, 43312, '\P{Scx= _Kali}', "");
    Expect(0, 43312, '\P{^Scx= _Kali}', "");
    Error('\p{Is_Script_Extensions=/a/kayah_Li}');
    Error('\P{Is_Script_Extensions=/a/kayah_Li}');
    Expect(1, 43311, '\p{Is_Script_Extensions=kayahli}', "");
    Expect(0, 43311, '\p{^Is_Script_Extensions=kayahli}', "");
    Expect(0, 43311, '\P{Is_Script_Extensions=kayahli}', "");
    Expect(1, 43311, '\P{^Is_Script_Extensions=kayahli}', "");
    Expect(0, 43312, '\p{Is_Script_Extensions=kayahli}', "");
    Expect(1, 43312, '\p{^Is_Script_Extensions=kayahli}', "");
    Expect(1, 43312, '\P{Is_Script_Extensions=kayahli}', "");
    Expect(0, 43312, '\P{^Is_Script_Extensions=kayahli}', "");
    Expect(1, 43311, '\p{Is_Script_Extensions=__KAYAH_li}', "");
    Expect(0, 43311, '\p{^Is_Script_Extensions=__KAYAH_li}', "");
    Expect(0, 43311, '\P{Is_Script_Extensions=__KAYAH_li}', "");
    Expect(1, 43311, '\P{^Is_Script_Extensions=__KAYAH_li}', "");
    Expect(0, 43312, '\p{Is_Script_Extensions=__KAYAH_li}', "");
    Expect(1, 43312, '\p{^Is_Script_Extensions=__KAYAH_li}', "");
    Expect(1, 43312, '\P{Is_Script_Extensions=__KAYAH_li}', "");
    Expect(0, 43312, '\P{^Is_Script_Extensions=__KAYAH_li}', "");
    Error('\p{Is_Scx=/a/-	Kali}');
    Error('\P{Is_Scx=/a/-	Kali}');
    Expect(1, 43311, '\p{Is_Scx=kali}', "");
    Expect(0, 43311, '\p{^Is_Scx=kali}', "");
    Expect(0, 43311, '\P{Is_Scx=kali}', "");
    Expect(1, 43311, '\P{^Is_Scx=kali}', "");
    Expect(0, 43312, '\p{Is_Scx=kali}', "");
    Expect(1, 43312, '\p{^Is_Scx=kali}', "");
    Expect(1, 43312, '\P{Is_Scx=kali}', "");
    Expect(0, 43312, '\P{^Is_Scx=kali}', "");
    Expect(1, 43311, '\p{Is_Scx=-	KALI}', "");
    Expect(0, 43311, '\p{^Is_Scx=-	KALI}', "");
    Expect(0, 43311, '\P{Is_Scx=-	KALI}', "");
    Expect(1, 43311, '\P{^Is_Scx=-	KALI}', "");
    Expect(0, 43312, '\p{Is_Scx=-	KALI}', "");
    Expect(1, 43312, '\p{^Is_Scx=-	KALI}', "");
    Expect(1, 43312, '\P{Is_Scx=-	KALI}', "");
    Expect(0, 43312, '\P{^Is_Scx=-	KALI}', "");
    Error('\p{Script_Extensions=/a/katakana}');
    Error('\P{Script_Extensions=/a/katakana}');
    Expect(1, 110951, '\p{Script_Extensions=:\AKatakana\z:}', "");;
    Expect(0, 110952, '\p{Script_Extensions=:\AKatakana\z:}', "");;
    Expect(1, 110951, '\p{Script_Extensions=katakana}', "");
    Expect(0, 110951, '\p{^Script_Extensions=katakana}', "");
    Expect(0, 110951, '\P{Script_Extensions=katakana}', "");
    Expect(1, 110951, '\P{^Script_Extensions=katakana}', "");
    Expect(0, 110952, '\p{Script_Extensions=katakana}', "");
    Expect(1, 110952, '\p{^Script_Extensions=katakana}', "");
    Expect(1, 110952, '\P{Script_Extensions=katakana}', "");
    Expect(0, 110952, '\P{^Script_Extensions=katakana}', "");
    Expect(1, 110951, '\p{Script_Extensions=:\Akatakana\z:}', "");;
    Expect(0, 110952, '\p{Script_Extensions=:\Akatakana\z:}', "");;
    Expect(1, 110951, '\p{Script_Extensions=_ Katakana}', "");
    Expect(0, 110951, '\p{^Script_Extensions=_ Katakana}', "");
    Expect(0, 110951, '\P{Script_Extensions=_ Katakana}', "");
    Expect(1, 110951, '\P{^Script_Extensions=_ Katakana}', "");
    Expect(0, 110952, '\p{Script_Extensions=_ Katakana}', "");
    Expect(1, 110952, '\p{^Script_Extensions=_ Katakana}', "");
    Expect(1, 110952, '\P{Script_Extensions=_ Katakana}', "");
    Expect(0, 110952, '\P{^Script_Extensions=_ Katakana}', "");
    Error('\p{Scx=/a/_	Kana}');
    Error('\P{Scx=/a/_	Kana}');
    Expect(1, 110951, '\p{Scx=:\AKana\z:}', "");;
    Expect(0, 110952, '\p{Scx=:\AKana\z:}', "");;
    Expect(1, 110951, '\p{Scx=kana}', "");
    Expect(0, 110951, '\p{^Scx=kana}', "");
    Expect(0, 110951, '\P{Scx=kana}', "");
    Expect(1, 110951, '\P{^Scx=kana}', "");
    Expect(0, 110952, '\p{Scx=kana}', "");
    Expect(1, 110952, '\p{^Scx=kana}', "");
    Expect(1, 110952, '\P{Scx=kana}', "");
    Expect(0, 110952, '\P{^Scx=kana}', "");
    Expect(1, 110951, '\p{Scx=:\Akana\z:}', "");;
    Expect(0, 110952, '\p{Scx=:\Akana\z:}', "");;
    Expect(1, 110951, '\p{Scx= -KANA}', "");
    Expect(0, 110951, '\p{^Scx= -KANA}', "");
    Expect(0, 110951, '\P{Scx= -KANA}', "");
    Expect(1, 110951, '\P{^Scx= -KANA}', "");
    Expect(0, 110952, '\p{Scx= -KANA}', "");
    Expect(1, 110952, '\p{^Scx= -KANA}', "");
    Expect(1, 110952, '\P{Scx= -KANA}', "");
    Expect(0, 110952, '\P{^Scx= -KANA}', "");
    Error('\p{Is_Script_Extensions=_-Katakana/a/}');
    Error('\P{Is_Script_Extensions=_-Katakana/a/}');
    Expect(1, 110951, '\p{Is_Script_Extensions=katakana}', "");
    Expect(0, 110951, '\p{^Is_Script_Extensions=katakana}', "");
    Expect(0, 110951, '\P{Is_Script_Extensions=katakana}', "");
    Expect(1, 110951, '\P{^Is_Script_Extensions=katakana}', "");
    Expect(0, 110952, '\p{Is_Script_Extensions=katakana}', "");
    Expect(1, 110952, '\p{^Is_Script_Extensions=katakana}', "");
    Expect(1, 110952, '\P{Is_Script_Extensions=katakana}', "");
    Expect(0, 110952, '\P{^Is_Script_Extensions=katakana}', "");
    Expect(1, 110951, '\p{Is_Script_Extensions= -Katakana}', "");
    Expect(0, 110951, '\p{^Is_Script_Extensions= -Katakana}', "");
    Expect(0, 110951, '\P{Is_Script_Extensions= -Katakana}', "");
    Expect(1, 110951, '\P{^Is_Script_Extensions= -Katakana}', "");
    Expect(0, 110952, '\p{Is_Script_Extensions= -Katakana}', "");
    Expect(1, 110952, '\p{^Is_Script_Extensions= -Katakana}', "");
    Expect(1, 110952, '\P{Is_Script_Extensions= -Katakana}', "");
    Expect(0, 110952, '\P{^Is_Script_Extensions= -Katakana}', "");
    Error('\p{Is_Scx=:= -Kana}');
    Error('\P{Is_Scx=:= -Kana}');
    Expect(1, 110951, '\p{Is_Scx=kana}', "");
    Expect(0, 110951, '\p{^Is_Scx=kana}', "");
    Expect(0, 110951, '\P{Is_Scx=kana}', "");
    Expect(1, 110951, '\P{^Is_Scx=kana}', "");
    Expect(0, 110952, '\p{Is_Scx=kana}', "");
    Expect(1, 110952, '\p{^Is_Scx=kana}', "");
    Expect(1, 110952, '\P{Is_Scx=kana}', "");
    Expect(0, 110952, '\P{^Is_Scx=kana}', "");
    Expect(1, 110951, '\p{Is_Scx: _ KANA}', "");
    Expect(0, 110951, '\p{^Is_Scx: _ KANA}', "");
    Expect(0, 110951, '\P{Is_Scx: _ KANA}', "");
    Expect(1, 110951, '\P{^Is_Scx: _ KANA}', "");
    Expect(0, 110952, '\p{Is_Scx: _ KANA}', "");
    Expect(1, 110952, '\p{^Is_Scx: _ KANA}', "");
    Expect(1, 110952, '\P{Is_Scx: _ KANA}', "");
    Expect(0, 110952, '\P{^Is_Scx: _ KANA}', "");
    Error('\p{Script_Extensions=/a/Kharoshthi}');
    Error('\P{Script_Extensions=/a/Kharoshthi}');
    Expect(1, 68184, '\p{Script_Extensions=:\AKharoshthi\z:}', "");;
    Expect(0, 68185, '\p{Script_Extensions=:\AKharoshthi\z:}', "");;
    Expect(1, 68184, '\p{Script_Extensions=kharoshthi}', "");
    Expect(0, 68184, '\p{^Script_Extensions=kharoshthi}', "");
    Expect(0, 68184, '\P{Script_Extensions=kharoshthi}', "");
    Expect(1, 68184, '\P{^Script_Extensions=kharoshthi}', "");
    Expect(0, 68185, '\p{Script_Extensions=kharoshthi}', "");
    Expect(1, 68185, '\p{^Script_Extensions=kharoshthi}', "");
    Expect(1, 68185, '\P{Script_Extensions=kharoshthi}', "");
    Expect(0, 68185, '\P{^Script_Extensions=kharoshthi}', "");
    Expect(1, 68184, '\p{Script_Extensions=:\Akharoshthi\z:}', "");;
    Expect(0, 68185, '\p{Script_Extensions=:\Akharoshthi\z:}', "");;
    Expect(1, 68184, '\p{Script_Extensions=- Kharoshthi}', "");
    Expect(0, 68184, '\p{^Script_Extensions=- Kharoshthi}', "");
    Expect(0, 68184, '\P{Script_Extensions=- Kharoshthi}', "");
    Expect(1, 68184, '\P{^Script_Extensions=- Kharoshthi}', "");
    Expect(0, 68185, '\p{Script_Extensions=- Kharoshthi}', "");
    Expect(1, 68185, '\p{^Script_Extensions=- Kharoshthi}', "");
    Expect(1, 68185, '\P{Script_Extensions=- Kharoshthi}', "");
    Expect(0, 68185, '\P{^Script_Extensions=- Kharoshthi}', "");
    Error('\p{Scx=_	KHAR:=}');
    Error('\P{Scx=_	KHAR:=}');
    Expect(1, 68184, '\p{Scx=:\AKhar\z:}', "");;
    Expect(0, 68185, '\p{Scx=:\AKhar\z:}', "");;
    Expect(1, 68184, '\p{Scx=khar}', "");
    Expect(0, 68184, '\p{^Scx=khar}', "");
    Expect(0, 68184, '\P{Scx=khar}', "");
    Expect(1, 68184, '\P{^Scx=khar}', "");
    Expect(0, 68185, '\p{Scx=khar}', "");
    Expect(1, 68185, '\p{^Scx=khar}', "");
    Expect(1, 68185, '\P{Scx=khar}', "");
    Expect(0, 68185, '\P{^Scx=khar}', "");
    Expect(1, 68184, '\p{Scx=:\Akhar\z:}', "");;
    Expect(0, 68185, '\p{Scx=:\Akhar\z:}', "");;
    Expect(1, 68184, '\p{Scx= khar}', "");
    Expect(0, 68184, '\p{^Scx= khar}', "");
    Expect(0, 68184, '\P{Scx= khar}', "");
    Expect(1, 68184, '\P{^Scx= khar}', "");
    Expect(0, 68185, '\p{Scx= khar}', "");
    Expect(1, 68185, '\p{^Scx= khar}', "");
    Expect(1, 68185, '\P{Scx= khar}', "");
    Expect(0, 68185, '\P{^Scx= khar}', "");
    Error('\p{Is_Script_Extensions=_:=KHAROSHTHI}');
    Error('\P{Is_Script_Extensions=_:=KHAROSHTHI}');
    Expect(1, 68184, '\p{Is_Script_Extensions=kharoshthi}', "");
    Expect(0, 68184, '\p{^Is_Script_Extensions=kharoshthi}', "");
    Expect(0, 68184, '\P{Is_Script_Extensions=kharoshthi}', "");
    Expect(1, 68184, '\P{^Is_Script_Extensions=kharoshthi}', "");
    Expect(0, 68185, '\p{Is_Script_Extensions=kharoshthi}', "");
    Expect(1, 68185, '\p{^Is_Script_Extensions=kharoshthi}', "");
    Expect(1, 68185, '\P{Is_Script_Extensions=kharoshthi}', "");
    Expect(0, 68185, '\P{^Is_Script_Extensions=kharoshthi}', "");
    Expect(1, 68184, '\p{Is_Script_Extensions=	 Kharoshthi}', "");
    Expect(0, 68184, '\p{^Is_Script_Extensions=	 Kharoshthi}', "");
    Expect(0, 68184, '\P{Is_Script_Extensions=	 Kharoshthi}', "");
    Expect(1, 68184, '\P{^Is_Script_Extensions=	 Kharoshthi}', "");
    Expect(0, 68185, '\p{Is_Script_Extensions=	 Kharoshthi}', "");
    Expect(1, 68185, '\p{^Is_Script_Extensions=	 Kharoshthi}', "");
    Expect(1, 68185, '\P{Is_Script_Extensions=	 Kharoshthi}', "");
    Expect(0, 68185, '\P{^Is_Script_Extensions=	 Kharoshthi}', "");
    Error('\p{Is_Scx=/a/Khar}');
    Error('\P{Is_Scx=/a/Khar}');
    Expect(1, 68184, '\p{Is_Scx=khar}', "");
    Expect(0, 68184, '\p{^Is_Scx=khar}', "");
    Expect(0, 68184, '\P{Is_Scx=khar}', "");
    Expect(1, 68184, '\P{^Is_Scx=khar}', "");
    Expect(0, 68185, '\p{Is_Scx=khar}', "");
    Expect(1, 68185, '\p{^Is_Scx=khar}', "");
    Expect(1, 68185, '\P{Is_Scx=khar}', "");
    Expect(0, 68185, '\P{^Is_Scx=khar}', "");
    Expect(1, 68184, '\p{Is_Scx=- Khar}', "");
    Expect(0, 68184, '\p{^Is_Scx=- Khar}', "");
    Expect(0, 68184, '\P{Is_Scx=- Khar}', "");
    Expect(1, 68184, '\P{^Is_Scx=- Khar}', "");
    Expect(0, 68185, '\p{Is_Scx=- Khar}', "");
    Expect(1, 68185, '\p{^Is_Scx=- Khar}', "");
    Expect(1, 68185, '\P{Is_Scx=- Khar}', "");
    Expect(0, 68185, '\P{^Is_Scx=- Khar}', "");
    Error('\p{Script_Extensions=:=__Khmer}');
    Error('\P{Script_Extensions=:=__Khmer}');
    Expect(1, 6655, '\p{Script_Extensions=:\AKhmer\z:}', "");;
    Expect(0, 6656, '\p{Script_Extensions=:\AKhmer\z:}', "");;
    Expect(1, 6655, '\p{Script_Extensions=khmer}', "");
    Expect(0, 6655, '\p{^Script_Extensions=khmer}', "");
    Expect(0, 6655, '\P{Script_Extensions=khmer}', "");
    Expect(1, 6655, '\P{^Script_Extensions=khmer}', "");
    Expect(0, 6656, '\p{Script_Extensions=khmer}', "");
    Expect(1, 6656, '\p{^Script_Extensions=khmer}', "");
    Expect(1, 6656, '\P{Script_Extensions=khmer}', "");
    Expect(0, 6656, '\P{^Script_Extensions=khmer}', "");
    Expect(1, 6655, '\p{Script_Extensions=:\Akhmer\z:}', "");;
    Expect(0, 6656, '\p{Script_Extensions=:\Akhmer\z:}', "");;
    Expect(1, 6655, '\p{Script_Extensions=-Khmer}', "");
    Expect(0, 6655, '\p{^Script_Extensions=-Khmer}', "");
    Expect(0, 6655, '\P{Script_Extensions=-Khmer}', "");
    Expect(1, 6655, '\P{^Script_Extensions=-Khmer}', "");
    Expect(0, 6656, '\p{Script_Extensions=-Khmer}', "");
    Expect(1, 6656, '\p{^Script_Extensions=-Khmer}', "");
    Expect(1, 6656, '\P{Script_Extensions=-Khmer}', "");
    Expect(0, 6656, '\P{^Script_Extensions=-Khmer}', "");
    Error('\p{Scx=:=_KHMR}');
    Error('\P{Scx=:=_KHMR}');
    Expect(1, 6655, '\p{Scx=:\AKhmr\z:}', "");;
    Expect(0, 6656, '\p{Scx=:\AKhmr\z:}', "");;
    Expect(1, 6655, '\p{Scx:khmr}', "");
    Expect(0, 6655, '\p{^Scx:khmr}', "");
    Expect(0, 6655, '\P{Scx:khmr}', "");
    Expect(1, 6655, '\P{^Scx:khmr}', "");
    Expect(0, 6656, '\p{Scx:khmr}', "");
    Expect(1, 6656, '\p{^Scx:khmr}', "");
    Expect(1, 6656, '\P{Scx:khmr}', "");
    Expect(0, 6656, '\P{^Scx:khmr}', "");
    Expect(1, 6655, '\p{Scx=:\Akhmr\z:}', "");;
    Expect(0, 6656, '\p{Scx=:\Akhmr\z:}', "");;
    Expect(1, 6655, '\p{Scx= khmr}', "");
    Expect(0, 6655, '\p{^Scx= khmr}', "");
    Expect(0, 6655, '\P{Scx= khmr}', "");
    Expect(1, 6655, '\P{^Scx= khmr}', "");
    Expect(0, 6656, '\p{Scx= khmr}', "");
    Expect(1, 6656, '\p{^Scx= khmr}', "");
    Expect(1, 6656, '\P{Scx= khmr}', "");
    Expect(0, 6656, '\P{^Scx= khmr}', "");
    Error('\p{Is_Script_Extensions=/a/KHMER}');
    Error('\P{Is_Script_Extensions=/a/KHMER}');
    Expect(1, 6655, '\p{Is_Script_Extensions=khmer}', "");
    Expect(0, 6655, '\p{^Is_Script_Extensions=khmer}', "");
    Expect(0, 6655, '\P{Is_Script_Extensions=khmer}', "");
    Expect(1, 6655, '\P{^Is_Script_Extensions=khmer}', "");
    Expect(0, 6656, '\p{Is_Script_Extensions=khmer}', "");
    Expect(1, 6656, '\p{^Is_Script_Extensions=khmer}', "");
    Expect(1, 6656, '\P{Is_Script_Extensions=khmer}', "");
    Expect(0, 6656, '\P{^Is_Script_Extensions=khmer}', "");
    Expect(1, 6655, '\p{Is_Script_Extensions=- Khmer}', "");
    Expect(0, 6655, '\p{^Is_Script_Extensions=- Khmer}', "");
    Expect(0, 6655, '\P{Is_Script_Extensions=- Khmer}', "");
    Expect(1, 6655, '\P{^Is_Script_Extensions=- Khmer}', "");
    Expect(0, 6656, '\p{Is_Script_Extensions=- Khmer}', "");
    Expect(1, 6656, '\p{^Is_Script_Extensions=- Khmer}', "");
    Expect(1, 6656, '\P{Is_Script_Extensions=- Khmer}', "");
    Expect(0, 6656, '\P{^Is_Script_Extensions=- Khmer}', "");
    Error('\p{Is_Scx=/a/	-khmr}');
    Error('\P{Is_Scx=/a/	-khmr}');
    Expect(1, 6655, '\p{Is_Scx=khmr}', "");
    Expect(0, 6655, '\p{^Is_Scx=khmr}', "");
    Expect(0, 6655, '\P{Is_Scx=khmr}', "");
    Expect(1, 6655, '\P{^Is_Scx=khmr}', "");
    Expect(0, 6656, '\p{Is_Scx=khmr}', "");
    Expect(1, 6656, '\p{^Is_Scx=khmr}', "");
    Expect(1, 6656, '\P{Is_Scx=khmr}', "");
    Expect(0, 6656, '\P{^Is_Scx=khmr}', "");
    Expect(1, 6655, '\p{Is_Scx=_Khmr}', "");
    Expect(0, 6655, '\p{^Is_Scx=_Khmr}', "");
    Expect(0, 6655, '\P{Is_Scx=_Khmr}', "");
    Expect(1, 6655, '\P{^Is_Scx=_Khmr}', "");
    Expect(0, 6656, '\p{Is_Scx=_Khmr}', "");
    Expect(1, 6656, '\p{^Is_Scx=_Khmr}', "");
    Expect(1, 6656, '\P{Is_Scx=_Khmr}', "");
    Expect(0, 6656, '\P{^Is_Scx=_Khmr}', "");
    Error('\p{Script_Extensions: -/a/Khojki}');
    Error('\P{Script_Extensions: -/a/Khojki}');
    Expect(1, 70206, '\p{Script_Extensions=:\AKhojki\z:}', "");;
    Expect(0, 70207, '\p{Script_Extensions=:\AKhojki\z:}', "");;
    Expect(1, 70206, '\p{Script_Extensions=khojki}', "");
    Expect(0, 70206, '\p{^Script_Extensions=khojki}', "");
    Expect(0, 70206, '\P{Script_Extensions=khojki}', "");
    Expect(1, 70206, '\P{^Script_Extensions=khojki}', "");
    Expect(0, 70207, '\p{Script_Extensions=khojki}', "");
    Expect(1, 70207, '\p{^Script_Extensions=khojki}', "");
    Expect(1, 70207, '\P{Script_Extensions=khojki}', "");
    Expect(0, 70207, '\P{^Script_Extensions=khojki}', "");
    Expect(1, 70206, '\p{Script_Extensions=:\Akhojki\z:}', "");;
    Expect(0, 70207, '\p{Script_Extensions=:\Akhojki\z:}', "");;
    Expect(1, 70206, '\p{Script_Extensions=-Khojki}', "");
    Expect(0, 70206, '\p{^Script_Extensions=-Khojki}', "");
    Expect(0, 70206, '\P{Script_Extensions=-Khojki}', "");
    Expect(1, 70206, '\P{^Script_Extensions=-Khojki}', "");
    Expect(0, 70207, '\p{Script_Extensions=-Khojki}', "");
    Expect(1, 70207, '\p{^Script_Extensions=-Khojki}', "");
    Expect(1, 70207, '\P{Script_Extensions=-Khojki}', "");
    Expect(0, 70207, '\P{^Script_Extensions=-Khojki}', "");
    Error('\p{Scx=	KHOJ:=}');
    Error('\P{Scx=	KHOJ:=}');
    Expect(1, 70206, '\p{Scx=:\AKhoj\z:}', "");;
    Expect(0, 70207, '\p{Scx=:\AKhoj\z:}', "");;
    Expect(1, 70206, '\p{Scx:khoj}', "");
    Expect(0, 70206, '\p{^Scx:khoj}', "");
    Expect(0, 70206, '\P{Scx:khoj}', "");
    Expect(1, 70206, '\P{^Scx:khoj}', "");
    Expect(0, 70207, '\p{Scx:khoj}', "");
    Expect(1, 70207, '\p{^Scx:khoj}', "");
    Expect(1, 70207, '\P{Scx:khoj}', "");
    Expect(0, 70207, '\P{^Scx:khoj}', "");
    Expect(1, 70206, '\p{Scx=:\Akhoj\z:}', "");;
    Expect(0, 70207, '\p{Scx=:\Akhoj\z:}', "");;
    Expect(1, 70206, '\p{Scx= -KHOJ}', "");
    Expect(0, 70206, '\p{^Scx= -KHOJ}', "");
    Expect(0, 70206, '\P{Scx= -KHOJ}', "");
    Expect(1, 70206, '\P{^Scx= -KHOJ}', "");
    Expect(0, 70207, '\p{Scx= -KHOJ}', "");
    Expect(1, 70207, '\p{^Scx= -KHOJ}', "");
    Expect(1, 70207, '\P{Scx= -KHOJ}', "");
    Expect(0, 70207, '\P{^Scx= -KHOJ}', "");
    Error('\p{Is_Script_Extensions=/a/_Khojki}');
    Error('\P{Is_Script_Extensions=/a/_Khojki}');
    Expect(1, 70206, '\p{Is_Script_Extensions=khojki}', "");
    Expect(0, 70206, '\p{^Is_Script_Extensions=khojki}', "");
    Expect(0, 70206, '\P{Is_Script_Extensions=khojki}', "");
    Expect(1, 70206, '\P{^Is_Script_Extensions=khojki}', "");
    Expect(0, 70207, '\p{Is_Script_Extensions=khojki}', "");
    Expect(1, 70207, '\p{^Is_Script_Extensions=khojki}', "");
    Expect(1, 70207, '\P{Is_Script_Extensions=khojki}', "");
    Expect(0, 70207, '\P{^Is_Script_Extensions=khojki}', "");
    Expect(1, 70206, '\p{Is_Script_Extensions= 	Khojki}', "");
    Expect(0, 70206, '\p{^Is_Script_Extensions= 	Khojki}', "");
    Expect(0, 70206, '\P{Is_Script_Extensions= 	Khojki}', "");
    Expect(1, 70206, '\P{^Is_Script_Extensions= 	Khojki}', "");
    Expect(0, 70207, '\p{Is_Script_Extensions= 	Khojki}', "");
    Expect(1, 70207, '\p{^Is_Script_Extensions= 	Khojki}', "");
    Expect(1, 70207, '\P{Is_Script_Extensions= 	Khojki}', "");
    Expect(0, 70207, '\P{^Is_Script_Extensions= 	Khojki}', "");
    Error('\p{Is_Scx=:=		Khoj}');
    Error('\P{Is_Scx=:=		Khoj}');
    Expect(1, 70206, '\p{Is_Scx=khoj}', "");
    Expect(0, 70206, '\p{^Is_Scx=khoj}', "");
    Expect(0, 70206, '\P{Is_Scx=khoj}', "");
    Expect(1, 70206, '\P{^Is_Scx=khoj}', "");
    Expect(0, 70207, '\p{Is_Scx=khoj}', "");
    Expect(1, 70207, '\p{^Is_Scx=khoj}', "");
    Expect(1, 70207, '\P{Is_Scx=khoj}', "");
    Expect(0, 70207, '\P{^Is_Scx=khoj}', "");
    Expect(1, 70206, '\p{Is_Scx: _Khoj}', "");
    Expect(0, 70206, '\p{^Is_Scx: _Khoj}', "");
    Expect(0, 70206, '\P{Is_Scx: _Khoj}', "");
    Expect(1, 70206, '\P{^Is_Scx: _Khoj}', "");
    Expect(0, 70207, '\p{Is_Scx: _Khoj}', "");
    Expect(1, 70207, '\p{^Is_Scx: _Khoj}', "");
    Expect(1, 70207, '\P{Is_Scx: _Khoj}', "");
    Expect(0, 70207, '\P{^Is_Scx: _Khoj}', "");
    Error('\p{Script_Extensions=/a/-	khitan_SMALL_Script}');
    Error('\P{Script_Extensions=/a/-	khitan_SMALL_Script}');
    Expect(1, 101589, '\p{Script_Extensions=:\AKhitan_Small_Script\z:}', "");;
    Expect(0, 101590, '\p{Script_Extensions=:\AKhitan_Small_Script\z:}', "");;
    Expect(1, 101589, '\p{Script_Extensions:khitansmallscript}', "");
    Expect(0, 101589, '\p{^Script_Extensions:khitansmallscript}', "");
    Expect(0, 101589, '\P{Script_Extensions:khitansmallscript}', "");
    Expect(1, 101589, '\P{^Script_Extensions:khitansmallscript}', "");
    Expect(0, 101590, '\p{Script_Extensions:khitansmallscript}', "");
    Expect(1, 101590, '\p{^Script_Extensions:khitansmallscript}', "");
    Expect(1, 101590, '\P{Script_Extensions:khitansmallscript}', "");
    Expect(0, 101590, '\P{^Script_Extensions:khitansmallscript}', "");
    Expect(1, 101589, '\p{Script_Extensions=:\Akhitansmallscript\z:}', "");;
    Expect(0, 101590, '\p{Script_Extensions=:\Akhitansmallscript\z:}', "");;
    Expect(1, 101589, '\p{Script_Extensions= KHITAN_SMALL_SCRIPT}', "");
    Expect(0, 101589, '\p{^Script_Extensions= KHITAN_SMALL_SCRIPT}', "");
    Expect(0, 101589, '\P{Script_Extensions= KHITAN_SMALL_SCRIPT}', "");
    Expect(1, 101589, '\P{^Script_Extensions= KHITAN_SMALL_SCRIPT}', "");
    Expect(0, 101590, '\p{Script_Extensions= KHITAN_SMALL_SCRIPT}', "");
    Expect(1, 101590, '\p{^Script_Extensions= KHITAN_SMALL_SCRIPT}', "");
    Expect(1, 101590, '\P{Script_Extensions= KHITAN_SMALL_SCRIPT}', "");
    Expect(0, 101590, '\P{^Script_Extensions= KHITAN_SMALL_SCRIPT}', "");
    Error('\p{Scx=	/a/kits}');
    Error('\P{Scx=	/a/kits}');
    Expect(1, 101589, '\p{Scx=:\AKits\z:}', "");;
    Expect(0, 101590, '\p{Scx=:\AKits\z:}', "");;
    Expect(1, 101589, '\p{Scx=kits}', "");
    Expect(0, 101589, '\p{^Scx=kits}', "");
    Expect(0, 101589, '\P{Scx=kits}', "");
    Expect(1, 101589, '\P{^Scx=kits}', "");
    Expect(0, 101590, '\p{Scx=kits}', "");
    Expect(1, 101590, '\p{^Scx=kits}', "");
    Expect(1, 101590, '\P{Scx=kits}', "");
    Expect(0, 101590, '\P{^Scx=kits}', "");
    Expect(1, 101589, '\p{Scx=:\Akits\z:}', "");;
    Expect(0, 101590, '\p{Scx=:\Akits\z:}', "");;
    Expect(1, 101589, '\p{Scx=_	Kits}', "");
    Expect(0, 101589, '\p{^Scx=_	Kits}', "");
    Expect(0, 101589, '\P{Scx=_	Kits}', "");
    Expect(1, 101589, '\P{^Scx=_	Kits}', "");
    Expect(0, 101590, '\p{Scx=_	Kits}', "");
    Expect(1, 101590, '\p{^Scx=_	Kits}', "");
    Expect(1, 101590, '\P{Scx=_	Kits}', "");
    Expect(0, 101590, '\P{^Scx=_	Kits}', "");
    Error('\p{Is_Script_Extensions=:=	Khitan_Small_Script}');
    Error('\P{Is_Script_Extensions=:=	Khitan_Small_Script}');
    Expect(1, 101589, '\p{Is_Script_Extensions=khitansmallscript}', "");
    Expect(0, 101589, '\p{^Is_Script_Extensions=khitansmallscript}', "");
    Expect(0, 101589, '\P{Is_Script_Extensions=khitansmallscript}', "");
    Expect(1, 101589, '\P{^Is_Script_Extensions=khitansmallscript}', "");
    Expect(0, 101590, '\p{Is_Script_Extensions=khitansmallscript}', "");
    Expect(1, 101590, '\p{^Is_Script_Extensions=khitansmallscript}', "");
    Expect(1, 101590, '\P{Is_Script_Extensions=khitansmallscript}', "");
    Expect(0, 101590, '\P{^Is_Script_Extensions=khitansmallscript}', "");
    Expect(1, 101589, '\p{Is_Script_Extensions=Khitan_Small_Script}', "");
    Expect(0, 101589, '\p{^Is_Script_Extensions=Khitan_Small_Script}', "");
    Expect(0, 101589, '\P{Is_Script_Extensions=Khitan_Small_Script}', "");
    Expect(1, 101589, '\P{^Is_Script_Extensions=Khitan_Small_Script}', "");
    Expect(0, 101590, '\p{Is_Script_Extensions=Khitan_Small_Script}', "");
    Expect(1, 101590, '\p{^Is_Script_Extensions=Khitan_Small_Script}', "");
    Expect(1, 101590, '\P{Is_Script_Extensions=Khitan_Small_Script}', "");
    Expect(0, 101590, '\P{^Is_Script_Extensions=Khitan_Small_Script}', "");
    Error('\p{Is_Scx=:=-	KITS}');
    Error('\P{Is_Scx=:=-	KITS}');
    Expect(1, 101589, '\p{Is_Scx=kits}', "");
    Expect(0, 101589, '\p{^Is_Scx=kits}', "");
    Expect(0, 101589, '\P{Is_Scx=kits}', "");
    Expect(1, 101589, '\P{^Is_Scx=kits}', "");
    Expect(0, 101590, '\p{Is_Scx=kits}', "");
    Expect(1, 101590, '\p{^Is_Scx=kits}', "");
    Expect(1, 101590, '\P{Is_Scx=kits}', "");
    Expect(0, 101590, '\P{^Is_Scx=kits}', "");
    Expect(1, 101589, '\p{Is_Scx: _KITS}', "");
    Expect(0, 101589, '\p{^Is_Scx: _KITS}', "");
    Expect(0, 101589, '\P{Is_Scx: _KITS}', "");
    Expect(1, 101589, '\P{^Is_Scx: _KITS}', "");
    Expect(0, 101590, '\p{Is_Scx: _KITS}', "");
    Expect(1, 101590, '\p{^Is_Scx: _KITS}', "");
    Expect(1, 101590, '\P{Is_Scx: _KITS}', "");
    Expect(0, 101590, '\P{^Is_Scx: _KITS}', "");
    Error('\p{Script_Extensions=:=	KANNADA}');
    Error('\P{Script_Extensions=:=	KANNADA}');
    Expect(1, 43061, '\p{Script_Extensions=:\AKannada\z:}', "");;
    Expect(0, 43062, '\p{Script_Extensions=:\AKannada\z:}', "");;
    Expect(1, 43061, '\p{Script_Extensions:   kannada}', "");
    Expect(0, 43061, '\p{^Script_Extensions:   kannada}', "");
    Expect(0, 43061, '\P{Script_Extensions:   kannada}', "");
    Expect(1, 43061, '\P{^Script_Extensions:   kannada}', "");
    Expect(0, 43062, '\p{Script_Extensions:   kannada}', "");
    Expect(1, 43062, '\p{^Script_Extensions:   kannada}', "");
    Expect(1, 43062, '\P{Script_Extensions:   kannada}', "");
    Expect(0, 43062, '\P{^Script_Extensions:   kannada}', "");
    Expect(1, 43061, '\p{Script_Extensions=:\Akannada\z:}', "");;
    Expect(0, 43062, '\p{Script_Extensions=:\Akannada\z:}', "");;
    Expect(1, 43061, '\p{Script_Extensions=_ Kannada}', "");
    Expect(0, 43061, '\p{^Script_Extensions=_ Kannada}', "");
    Expect(0, 43061, '\P{Script_Extensions=_ Kannada}', "");
    Expect(1, 43061, '\P{^Script_Extensions=_ Kannada}', "");
    Expect(0, 43062, '\p{Script_Extensions=_ Kannada}', "");
    Expect(1, 43062, '\p{^Script_Extensions=_ Kannada}', "");
    Expect(1, 43062, '\P{Script_Extensions=_ Kannada}', "");
    Expect(0, 43062, '\P{^Script_Extensions=_ Kannada}', "");
    Error('\p{Scx=/a/_Knda}');
    Error('\P{Scx=/a/_Knda}');
    Expect(1, 43061, '\p{Scx=:\AKnda\z:}', "");;
    Expect(0, 43062, '\p{Scx=:\AKnda\z:}', "");;
    Expect(1, 43061, '\p{Scx=knda}', "");
    Expect(0, 43061, '\p{^Scx=knda}', "");
    Expect(0, 43061, '\P{Scx=knda}', "");
    Expect(1, 43061, '\P{^Scx=knda}', "");
    Expect(0, 43062, '\p{Scx=knda}', "");
    Expect(1, 43062, '\p{^Scx=knda}', "");
    Expect(1, 43062, '\P{Scx=knda}', "");
    Expect(0, 43062, '\P{^Scx=knda}', "");
    Expect(1, 43061, '\p{Scx=:\Aknda\z:}', "");;
    Expect(0, 43062, '\p{Scx=:\Aknda\z:}', "");;
    Expect(1, 43061, '\p{Scx= 	Knda}', "");
    Expect(0, 43061, '\p{^Scx= 	Knda}', "");
    Expect(0, 43061, '\P{Scx= 	Knda}', "");
    Expect(1, 43061, '\P{^Scx= 	Knda}', "");
    Expect(0, 43062, '\p{Scx= 	Knda}', "");
    Expect(1, 43062, '\p{^Scx= 	Knda}', "");
    Expect(1, 43062, '\P{Scx= 	Knda}', "");
    Expect(0, 43062, '\P{^Scx= 	Knda}', "");
    Error('\p{Is_Script_Extensions=:=KANNADA}');
    Error('\P{Is_Script_Extensions=:=KANNADA}');
    Expect(1, 43061, '\p{Is_Script_Extensions=kannada}', "");
    Expect(0, 43061, '\p{^Is_Script_Extensions=kannada}', "");
    Expect(0, 43061, '\P{Is_Script_Extensions=kannada}', "");
    Expect(1, 43061, '\P{^Is_Script_Extensions=kannada}', "");
    Expect(0, 43062, '\p{Is_Script_Extensions=kannada}', "");
    Expect(1, 43062, '\p{^Is_Script_Extensions=kannada}', "");
    Expect(1, 43062, '\P{Is_Script_Extensions=kannada}', "");
    Expect(0, 43062, '\P{^Is_Script_Extensions=kannada}', "");
    Expect(1, 43061, '\p{Is_Script_Extensions=_KANNADA}', "");
    Expect(0, 43061, '\p{^Is_Script_Extensions=_KANNADA}', "");
    Expect(0, 43061, '\P{Is_Script_Extensions=_KANNADA}', "");
    Expect(1, 43061, '\P{^Is_Script_Extensions=_KANNADA}', "");
    Expect(0, 43062, '\p{Is_Script_Extensions=_KANNADA}', "");
    Expect(1, 43062, '\p{^Is_Script_Extensions=_KANNADA}', "");
    Expect(1, 43062, '\P{Is_Script_Extensions=_KANNADA}', "");
    Expect(0, 43062, '\P{^Is_Script_Extensions=_KANNADA}', "");
    Error('\p{Is_Scx=  KNDA/a/}');
    Error('\P{Is_Scx=  KNDA/a/}');
    Expect(1, 43061, '\p{Is_Scx=knda}', "");
    Expect(0, 43061, '\p{^Is_Scx=knda}', "");
    Expect(0, 43061, '\P{Is_Scx=knda}', "");
    Expect(1, 43061, '\P{^Is_Scx=knda}', "");
    Expect(0, 43062, '\p{Is_Scx=knda}', "");
    Expect(1, 43062, '\p{^Is_Scx=knda}', "");
    Expect(1, 43062, '\P{Is_Scx=knda}', "");
    Expect(0, 43062, '\P{^Is_Scx=knda}', "");
    Expect(1, 43061, '\p{Is_Scx=--Knda}', "");
    Expect(0, 43061, '\p{^Is_Scx=--Knda}', "");
    Expect(0, 43061, '\P{Is_Scx=--Knda}', "");
    Expect(1, 43061, '\P{^Is_Scx=--Knda}', "");
    Expect(0, 43062, '\p{Is_Scx=--Knda}', "");
    Expect(1, 43062, '\p{^Is_Scx=--Knda}', "");
    Expect(1, 43062, '\P{Is_Scx=--Knda}', "");
    Expect(0, 43062, '\P{^Is_Scx=--Knda}', "");
    Error('\p{Script_Extensions=:=	Kaithi}');
    Error('\P{Script_Extensions=:=	Kaithi}');
    Expect(1, 69837, '\p{Script_Extensions=:\AKaithi\z:}', "");;
    Expect(0, 69838, '\p{Script_Extensions=:\AKaithi\z:}', "");;
    Expect(1, 69837, '\p{Script_Extensions=kaithi}', "");
    Expect(0, 69837, '\p{^Script_Extensions=kaithi}', "");
    Expect(0, 69837, '\P{Script_Extensions=kaithi}', "");
    Expect(1, 69837, '\P{^Script_Extensions=kaithi}', "");
    Expect(0, 69838, '\p{Script_Extensions=kaithi}', "");
    Expect(1, 69838, '\p{^Script_Extensions=kaithi}', "");
    Expect(1, 69838, '\P{Script_Extensions=kaithi}', "");
    Expect(0, 69838, '\P{^Script_Extensions=kaithi}', "");
    Expect(1, 69837, '\p{Script_Extensions=:\Akaithi\z:}', "");;
    Expect(0, 69838, '\p{Script_Extensions=:\Akaithi\z:}', "");;
    Expect(1, 69837, '\p{Script_Extensions=  Kaithi}', "");
    Expect(0, 69837, '\p{^Script_Extensions=  Kaithi}', "");
    Expect(0, 69837, '\P{Script_Extensions=  Kaithi}', "");
    Expect(1, 69837, '\P{^Script_Extensions=  Kaithi}', "");
    Expect(0, 69838, '\p{Script_Extensions=  Kaithi}', "");
    Expect(1, 69838, '\p{^Script_Extensions=  Kaithi}', "");
    Expect(1, 69838, '\P{Script_Extensions=  Kaithi}', "");
    Expect(0, 69838, '\P{^Script_Extensions=  Kaithi}', "");
    Error('\p{Scx=/a/		kthi}');
    Error('\P{Scx=/a/		kthi}');
    Expect(1, 69837, '\p{Scx=:\AKthi\z:}', "");;
    Expect(0, 69838, '\p{Scx=:\AKthi\z:}', "");;
    Expect(1, 69837, '\p{Scx=kthi}', "");
    Expect(0, 69837, '\p{^Scx=kthi}', "");
    Expect(0, 69837, '\P{Scx=kthi}', "");
    Expect(1, 69837, '\P{^Scx=kthi}', "");
    Expect(0, 69838, '\p{Scx=kthi}', "");
    Expect(1, 69838, '\p{^Scx=kthi}', "");
    Expect(1, 69838, '\P{Scx=kthi}', "");
    Expect(0, 69838, '\P{^Scx=kthi}', "");
    Expect(1, 69837, '\p{Scx=:\Akthi\z:}', "");;
    Expect(0, 69838, '\p{Scx=:\Akthi\z:}', "");;
    Expect(1, 69837, '\p{Scx:    	Kthi}', "");
    Expect(0, 69837, '\p{^Scx:    	Kthi}', "");
    Expect(0, 69837, '\P{Scx:    	Kthi}', "");
    Expect(1, 69837, '\P{^Scx:    	Kthi}', "");
    Expect(0, 69838, '\p{Scx:    	Kthi}', "");
    Expect(1, 69838, '\p{^Scx:    	Kthi}', "");
    Expect(1, 69838, '\P{Scx:    	Kthi}', "");
    Expect(0, 69838, '\P{^Scx:    	Kthi}', "");
    Error('\p{Is_Script_Extensions=_/a/Kaithi}');
    Error('\P{Is_Script_Extensions=_/a/Kaithi}');
    Expect(1, 69837, '\p{Is_Script_Extensions=kaithi}', "");
    Expect(0, 69837, '\p{^Is_Script_Extensions=kaithi}', "");
    Expect(0, 69837, '\P{Is_Script_Extensions=kaithi}', "");
    Expect(1, 69837, '\P{^Is_Script_Extensions=kaithi}', "");
    Expect(0, 69838, '\p{Is_Script_Extensions=kaithi}', "");
    Expect(1, 69838, '\p{^Is_Script_Extensions=kaithi}', "");
    Expect(1, 69838, '\P{Is_Script_Extensions=kaithi}', "");
    Expect(0, 69838, '\P{^Is_Script_Extensions=kaithi}', "");
    Expect(1, 69837, '\p{Is_Script_Extensions=_-Kaithi}', "");
    Expect(0, 69837, '\p{^Is_Script_Extensions=_-Kaithi}', "");
    Expect(0, 69837, '\P{Is_Script_Extensions=_-Kaithi}', "");
    Expect(1, 69837, '\P{^Is_Script_Extensions=_-Kaithi}', "");
    Expect(0, 69838, '\p{Is_Script_Extensions=_-Kaithi}', "");
    Expect(1, 69838, '\p{^Is_Script_Extensions=_-Kaithi}', "");
    Expect(1, 69838, '\P{Is_Script_Extensions=_-Kaithi}', "");
    Expect(0, 69838, '\P{^Is_Script_Extensions=_-Kaithi}', "");
    Error('\p{Is_Scx=/a/Kthi}');
    Error('\P{Is_Scx=/a/Kthi}');
    Expect(1, 69837, '\p{Is_Scx=kthi}', "");
    Expect(0, 69837, '\p{^Is_Scx=kthi}', "");
    Expect(0, 69837, '\P{Is_Scx=kthi}', "");
    Expect(1, 69837, '\P{^Is_Scx=kthi}', "");
    Expect(0, 69838, '\p{Is_Scx=kthi}', "");
    Expect(1, 69838, '\p{^Is_Scx=kthi}', "");
    Expect(1, 69838, '\P{Is_Scx=kthi}', "");
    Expect(0, 69838, '\P{^Is_Scx=kthi}', "");
    Expect(1, 69837, '\p{Is_Scx=		Kthi}', "");
    Expect(0, 69837, '\p{^Is_Scx=		Kthi}', "");
    Expect(0, 69837, '\P{Is_Scx=		Kthi}', "");
    Expect(1, 69837, '\P{^Is_Scx=		Kthi}', "");
    Expect(0, 69838, '\p{Is_Scx=		Kthi}', "");
    Expect(1, 69838, '\p{^Is_Scx=		Kthi}', "");
    Expect(1, 69838, '\P{Is_Scx=		Kthi}', "");
    Expect(0, 69838, '\P{^Is_Scx=		Kthi}', "");
    Error('\p{Script_Extensions=_ Tai_Tham/a/}');
    Error('\P{Script_Extensions=_ Tai_Tham/a/}');
    Expect(1, 6829, '\p{Script_Extensions=:\ATai_Tham\z:}', "");;
    Expect(0, 6830, '\p{Script_Extensions=:\ATai_Tham\z:}', "");;
    Expect(1, 6829, '\p{Script_Extensions=taitham}', "");
    Expect(0, 6829, '\p{^Script_Extensions=taitham}', "");
    Expect(0, 6829, '\P{Script_Extensions=taitham}', "");
    Expect(1, 6829, '\P{^Script_Extensions=taitham}', "");
    Expect(0, 6830, '\p{Script_Extensions=taitham}', "");
    Expect(1, 6830, '\p{^Script_Extensions=taitham}', "");
    Expect(1, 6830, '\P{Script_Extensions=taitham}', "");
    Expect(0, 6830, '\P{^Script_Extensions=taitham}', "");
    Expect(1, 6829, '\p{Script_Extensions=:\Ataitham\z:}', "");;
    Expect(0, 6830, '\p{Script_Extensions=:\Ataitham\z:}', "");;
    Expect(1, 6829, '\p{Script_Extensions=	 Tai_Tham}', "");
    Expect(0, 6829, '\p{^Script_Extensions=	 Tai_Tham}', "");
    Expect(0, 6829, '\P{Script_Extensions=	 Tai_Tham}', "");
    Expect(1, 6829, '\P{^Script_Extensions=	 Tai_Tham}', "");
    Expect(0, 6830, '\p{Script_Extensions=	 Tai_Tham}', "");
    Expect(1, 6830, '\p{^Script_Extensions=	 Tai_Tham}', "");
    Expect(1, 6830, '\P{Script_Extensions=	 Tai_Tham}', "");
    Expect(0, 6830, '\P{^Script_Extensions=	 Tai_Tham}', "");
    Error('\p{Scx=- Lana:=}');
    Error('\P{Scx=- Lana:=}');
    Expect(1, 6829, '\p{Scx=:\ALana\z:}', "");;
    Expect(0, 6830, '\p{Scx=:\ALana\z:}', "");;
    Expect(1, 6829, '\p{Scx=lana}', "");
    Expect(0, 6829, '\p{^Scx=lana}', "");
    Expect(0, 6829, '\P{Scx=lana}', "");
    Expect(1, 6829, '\P{^Scx=lana}', "");
    Expect(0, 6830, '\p{Scx=lana}', "");
    Expect(1, 6830, '\p{^Scx=lana}', "");
    Expect(1, 6830, '\P{Scx=lana}', "");
    Expect(0, 6830, '\P{^Scx=lana}', "");
    Expect(1, 6829, '\p{Scx=:\Alana\z:}', "");;
    Expect(0, 6830, '\p{Scx=:\Alana\z:}', "");;
    Expect(1, 6829, '\p{Scx=_	LANA}', "");
    Expect(0, 6829, '\p{^Scx=_	LANA}', "");
    Expect(0, 6829, '\P{Scx=_	LANA}', "");
    Expect(1, 6829, '\P{^Scx=_	LANA}', "");
    Expect(0, 6830, '\p{Scx=_	LANA}', "");
    Expect(1, 6830, '\p{^Scx=_	LANA}', "");
    Expect(1, 6830, '\P{Scx=_	LANA}', "");
    Expect(0, 6830, '\P{^Scx=_	LANA}', "");
    Error('\p{Is_Script_Extensions=/a/tai_Tham}');
    Error('\P{Is_Script_Extensions=/a/tai_Tham}');
    Expect(1, 6829, '\p{Is_Script_Extensions=taitham}', "");
    Expect(0, 6829, '\p{^Is_Script_Extensions=taitham}', "");
    Expect(0, 6829, '\P{Is_Script_Extensions=taitham}', "");
    Expect(1, 6829, '\P{^Is_Script_Extensions=taitham}', "");
    Expect(0, 6830, '\p{Is_Script_Extensions=taitham}', "");
    Expect(1, 6830, '\p{^Is_Script_Extensions=taitham}', "");
    Expect(1, 6830, '\P{Is_Script_Extensions=taitham}', "");
    Expect(0, 6830, '\P{^Is_Script_Extensions=taitham}', "");
    Expect(1, 6829, '\p{Is_Script_Extensions=_Tai_THAM}', "");
    Expect(0, 6829, '\p{^Is_Script_Extensions=_Tai_THAM}', "");
    Expect(0, 6829, '\P{Is_Script_Extensions=_Tai_THAM}', "");
    Expect(1, 6829, '\P{^Is_Script_Extensions=_Tai_THAM}', "");
    Expect(0, 6830, '\p{Is_Script_Extensions=_Tai_THAM}', "");
    Expect(1, 6830, '\p{^Is_Script_Extensions=_Tai_THAM}', "");
    Expect(1, 6830, '\P{Is_Script_Extensions=_Tai_THAM}', "");
    Expect(0, 6830, '\P{^Is_Script_Extensions=_Tai_THAM}', "");
    Error('\p{Is_Scx=-lana/a/}');
    Error('\P{Is_Scx=-lana/a/}');
    Expect(1, 6829, '\p{Is_Scx=lana}', "");
    Expect(0, 6829, '\p{^Is_Scx=lana}', "");
    Expect(0, 6829, '\P{Is_Scx=lana}', "");
    Expect(1, 6829, '\P{^Is_Scx=lana}', "");
    Expect(0, 6830, '\p{Is_Scx=lana}', "");
    Expect(1, 6830, '\p{^Is_Scx=lana}', "");
    Expect(1, 6830, '\P{Is_Scx=lana}', "");
    Expect(0, 6830, '\P{^Is_Scx=lana}', "");
    Expect(1, 6829, '\p{Is_Scx=-lana}', "");
    Expect(0, 6829, '\p{^Is_Scx=-lana}', "");
    Expect(0, 6829, '\P{Is_Scx=-lana}', "");
    Expect(1, 6829, '\P{^Is_Scx=-lana}', "");
    Expect(0, 6830, '\p{Is_Scx=-lana}', "");
    Expect(1, 6830, '\p{^Is_Scx=-lana}', "");
    Expect(1, 6830, '\P{Is_Scx=-lana}', "");
    Expect(0, 6830, '\P{^Is_Scx=-lana}', "");
    Error('\p{Script_Extensions=-:=LAO}');
    Error('\P{Script_Extensions=-:=LAO}');
    Expect(1, 3807, '\p{Script_Extensions=:\ALao\z:}', "");;
    Expect(0, 3808, '\p{Script_Extensions=:\ALao\z:}', "");;
    Expect(1, 3807, '\p{Script_Extensions=lao}', "");
    Expect(0, 3807, '\p{^Script_Extensions=lao}', "");
    Expect(0, 3807, '\P{Script_Extensions=lao}', "");
    Expect(1, 3807, '\P{^Script_Extensions=lao}', "");
    Expect(0, 3808, '\p{Script_Extensions=lao}', "");
    Expect(1, 3808, '\p{^Script_Extensions=lao}', "");
    Expect(1, 3808, '\P{Script_Extensions=lao}', "");
    Expect(0, 3808, '\P{^Script_Extensions=lao}', "");
    Expect(1, 3807, '\p{Script_Extensions=:\Alao\z:}', "");;
    Expect(0, 3808, '\p{Script_Extensions=:\Alao\z:}', "");;
    Expect(1, 3807, '\p{Script_Extensions:	 LAO}', "");
    Expect(0, 3807, '\p{^Script_Extensions:	 LAO}', "");
    Expect(0, 3807, '\P{Script_Extensions:	 LAO}', "");
    Expect(1, 3807, '\P{^Script_Extensions:	 LAO}', "");
    Expect(0, 3808, '\p{Script_Extensions:	 LAO}', "");
    Expect(1, 3808, '\p{^Script_Extensions:	 LAO}', "");
    Expect(1, 3808, '\P{Script_Extensions:	 LAO}', "");
    Expect(0, 3808, '\P{^Script_Extensions:	 LAO}', "");
    Error('\p{Scx=_laoo/a/}');
    Error('\P{Scx=_laoo/a/}');
    Expect(1, 3807, '\p{Scx=:\ALaoo\z:}', "");;
    Expect(0, 3808, '\p{Scx=:\ALaoo\z:}', "");;
    Expect(1, 3807, '\p{Scx=laoo}', "");
    Expect(0, 3807, '\p{^Scx=laoo}', "");
    Expect(0, 3807, '\P{Scx=laoo}', "");
    Expect(1, 3807, '\P{^Scx=laoo}', "");
    Expect(0, 3808, '\p{Scx=laoo}', "");
    Expect(1, 3808, '\p{^Scx=laoo}', "");
    Expect(1, 3808, '\P{Scx=laoo}', "");
    Expect(0, 3808, '\P{^Scx=laoo}', "");
    Expect(1, 3807, '\p{Scx=:\Alaoo\z:}', "");;
    Expect(0, 3808, '\p{Scx=:\Alaoo\z:}', "");;
    Expect(1, 3807, '\p{Scx= -Laoo}', "");
    Expect(0, 3807, '\p{^Scx= -Laoo}', "");
    Expect(0, 3807, '\P{Scx= -Laoo}', "");
    Expect(1, 3807, '\P{^Scx= -Laoo}', "");
    Expect(0, 3808, '\p{Scx= -Laoo}', "");
    Expect(1, 3808, '\p{^Scx= -Laoo}', "");
    Expect(1, 3808, '\P{Scx= -Laoo}', "");
    Expect(0, 3808, '\P{^Scx= -Laoo}', "");
    Error('\p{Is_Script_Extensions=:=lao}');
    Error('\P{Is_Script_Extensions=:=lao}');
    Expect(1, 3807, '\p{Is_Script_Extensions=lao}', "");
    Expect(0, 3807, '\p{^Is_Script_Extensions=lao}', "");
    Expect(0, 3807, '\P{Is_Script_Extensions=lao}', "");
    Expect(1, 3807, '\P{^Is_Script_Extensions=lao}', "");
    Expect(0, 3808, '\p{Is_Script_Extensions=lao}', "");
    Expect(1, 3808, '\p{^Is_Script_Extensions=lao}', "");
    Expect(1, 3808, '\P{Is_Script_Extensions=lao}', "");
    Expect(0, 3808, '\P{^Is_Script_Extensions=lao}', "");
    Expect(1, 3807, '\p{Is_Script_Extensions=_-Lao}', "");
    Expect(0, 3807, '\p{^Is_Script_Extensions=_-Lao}', "");
    Expect(0, 3807, '\P{Is_Script_Extensions=_-Lao}', "");
    Expect(1, 3807, '\P{^Is_Script_Extensions=_-Lao}', "");
    Expect(0, 3808, '\p{Is_Script_Extensions=_-Lao}', "");
    Expect(1, 3808, '\p{^Is_Script_Extensions=_-Lao}', "");
    Expect(1, 3808, '\P{Is_Script_Extensions=_-Lao}', "");
    Expect(0, 3808, '\P{^Is_Script_Extensions=_-Lao}', "");
    Error('\p{Is_Scx=/a/	-Laoo}');
    Error('\P{Is_Scx=/a/	-Laoo}');
    Expect(1, 3807, '\p{Is_Scx=laoo}', "");
    Expect(0, 3807, '\p{^Is_Scx=laoo}', "");
    Expect(0, 3807, '\P{Is_Scx=laoo}', "");
    Expect(1, 3807, '\P{^Is_Scx=laoo}', "");
    Expect(0, 3808, '\p{Is_Scx=laoo}', "");
    Expect(1, 3808, '\p{^Is_Scx=laoo}', "");
    Expect(1, 3808, '\P{Is_Scx=laoo}', "");
    Expect(0, 3808, '\P{^Is_Scx=laoo}', "");
    Expect(1, 3807, '\p{Is_Scx= -laoo}', "");
    Expect(0, 3807, '\p{^Is_Scx= -laoo}', "");
    Expect(0, 3807, '\P{Is_Scx= -laoo}', "");
    Expect(1, 3807, '\P{^Is_Scx= -laoo}', "");
    Expect(0, 3808, '\p{Is_Scx= -laoo}', "");
    Expect(1, 3808, '\p{^Is_Scx= -laoo}', "");
    Expect(1, 3808, '\P{Is_Scx= -laoo}', "");
    Expect(0, 3808, '\P{^Is_Scx= -laoo}', "");
    Error('\p{Script_Extensions=	/a/Latin}');
    Error('\P{Script_Extensions=	/a/Latin}');
    Expect(1, 65370, '\p{Script_Extensions=:\ALatin\z:}', "");;
    Expect(0, 65371, '\p{Script_Extensions=:\ALatin\z:}', "");;
    Expect(1, 65370, '\p{Script_Extensions=latin}', "");
    Expect(0, 65370, '\p{^Script_Extensions=latin}', "");
    Expect(0, 65370, '\P{Script_Extensions=latin}', "");
    Expect(1, 65370, '\P{^Script_Extensions=latin}', "");
    Expect(0, 65371, '\p{Script_Extensions=latin}', "");
    Expect(1, 65371, '\p{^Script_Extensions=latin}', "");
    Expect(1, 65371, '\P{Script_Extensions=latin}', "");
    Expect(0, 65371, '\P{^Script_Extensions=latin}', "");
    Expect(1, 65370, '\p{Script_Extensions=:\Alatin\z:}', "");;
    Expect(0, 65371, '\p{Script_Extensions=:\Alatin\z:}', "");;
    Expect(1, 65370, '\p{Script_Extensions= LATIN}', "");
    Expect(0, 65370, '\p{^Script_Extensions= LATIN}', "");
    Expect(0, 65370, '\P{Script_Extensions= LATIN}', "");
    Expect(1, 65370, '\P{^Script_Extensions= LATIN}', "");
    Expect(0, 65371, '\p{Script_Extensions= LATIN}', "");
    Expect(1, 65371, '\p{^Script_Extensions= LATIN}', "");
    Expect(1, 65371, '\P{Script_Extensions= LATIN}', "");
    Expect(0, 65371, '\P{^Script_Extensions= LATIN}', "");
    Error('\p{Scx:   	_Latn/a/}');
    Error('\P{Scx:   	_Latn/a/}');
    Expect(1, 65370, '\p{Scx=:\ALatn\z:}', "");;
    Expect(0, 65371, '\p{Scx=:\ALatn\z:}', "");;
    Expect(1, 65370, '\p{Scx=latn}', "");
    Expect(0, 65370, '\p{^Scx=latn}', "");
    Expect(0, 65370, '\P{Scx=latn}', "");
    Expect(1, 65370, '\P{^Scx=latn}', "");
    Expect(0, 65371, '\p{Scx=latn}', "");
    Expect(1, 65371, '\p{^Scx=latn}', "");
    Expect(1, 65371, '\P{Scx=latn}', "");
    Expect(0, 65371, '\P{^Scx=latn}', "");
    Expect(1, 65370, '\p{Scx=:\Alatn\z:}', "");;
    Expect(0, 65371, '\p{Scx=:\Alatn\z:}', "");;
    Expect(1, 65370, '\p{Scx= latn}', "");
    Expect(0, 65370, '\p{^Scx= latn}', "");
    Expect(0, 65370, '\P{Scx= latn}', "");
    Expect(1, 65370, '\P{^Scx= latn}', "");
    Expect(0, 65371, '\p{Scx= latn}', "");
    Expect(1, 65371, '\p{^Scx= latn}', "");
    Expect(1, 65371, '\P{Scx= latn}', "");
    Expect(0, 65371, '\P{^Scx= latn}', "");
    Error('\p{Is_Script_Extensions=/a/	-Latin}');
    Error('\P{Is_Script_Extensions=/a/	-Latin}');
    Expect(1, 65370, '\p{Is_Script_Extensions=latin}', "");
    Expect(0, 65370, '\p{^Is_Script_Extensions=latin}', "");
    Expect(0, 65370, '\P{Is_Script_Extensions=latin}', "");
    Expect(1, 65370, '\P{^Is_Script_Extensions=latin}', "");
    Expect(0, 65371, '\p{Is_Script_Extensions=latin}', "");
    Expect(1, 65371, '\p{^Is_Script_Extensions=latin}', "");
    Expect(1, 65371, '\P{Is_Script_Extensions=latin}', "");
    Expect(0, 65371, '\P{^Is_Script_Extensions=latin}', "");
    Expect(1, 65370, '\p{Is_Script_Extensions= -Latin}', "");
    Expect(0, 65370, '\p{^Is_Script_Extensions= -Latin}', "");
    Expect(0, 65370, '\P{Is_Script_Extensions= -Latin}', "");
    Expect(1, 65370, '\P{^Is_Script_Extensions= -Latin}', "");
    Expect(0, 65371, '\p{Is_Script_Extensions= -Latin}', "");
    Expect(1, 65371, '\p{^Is_Script_Extensions= -Latin}', "");
    Expect(1, 65371, '\P{Is_Script_Extensions= -Latin}', "");
    Expect(0, 65371, '\P{^Is_Script_Extensions= -Latin}', "");
    Error('\p{Is_Scx=-:=Latn}');
    Error('\P{Is_Scx=-:=Latn}');
    Expect(1, 65370, '\p{Is_Scx=latn}', "");
    Expect(0, 65370, '\p{^Is_Scx=latn}', "");
    Expect(0, 65370, '\P{Is_Scx=latn}', "");
    Expect(1, 65370, '\P{^Is_Scx=latn}', "");
    Expect(0, 65371, '\p{Is_Scx=latn}', "");
    Expect(1, 65371, '\p{^Is_Scx=latn}', "");
    Expect(1, 65371, '\P{Is_Scx=latn}', "");
    Expect(0, 65371, '\P{^Is_Scx=latn}', "");
    Expect(1, 65370, '\p{Is_Scx=_ Latn}', "");
    Expect(0, 65370, '\p{^Is_Scx=_ Latn}', "");
    Expect(0, 65370, '\P{Is_Scx=_ Latn}', "");
    Expect(1, 65370, '\P{^Is_Scx=_ Latn}', "");
    Expect(0, 65371, '\p{Is_Scx=_ Latn}', "");
    Expect(1, 65371, '\p{^Is_Scx=_ Latn}', "");
    Expect(1, 65371, '\P{Is_Scx=_ Latn}', "");
    Expect(0, 65371, '\P{^Is_Scx=_ Latn}', "");
    Error('\p{Script_Extensions=:=lepcha}');
    Error('\P{Script_Extensions=:=lepcha}');
    Expect(1, 7247, '\p{Script_Extensions=:\ALepcha\z:}', "");;
    Expect(0, 7248, '\p{Script_Extensions=:\ALepcha\z:}', "");;
    Expect(1, 7247, '\p{Script_Extensions=lepcha}', "");
    Expect(0, 7247, '\p{^Script_Extensions=lepcha}', "");
    Expect(0, 7247, '\P{Script_Extensions=lepcha}', "");
    Expect(1, 7247, '\P{^Script_Extensions=lepcha}', "");
    Expect(0, 7248, '\p{Script_Extensions=lepcha}', "");
    Expect(1, 7248, '\p{^Script_Extensions=lepcha}', "");
    Expect(1, 7248, '\P{Script_Extensions=lepcha}', "");
    Expect(0, 7248, '\P{^Script_Extensions=lepcha}', "");
    Expect(1, 7247, '\p{Script_Extensions=:\Alepcha\z:}', "");;
    Expect(0, 7248, '\p{Script_Extensions=:\Alepcha\z:}', "");;
    Expect(1, 7247, '\p{Script_Extensions=	Lepcha}', "");
    Expect(0, 7247, '\p{^Script_Extensions=	Lepcha}', "");
    Expect(0, 7247, '\P{Script_Extensions=	Lepcha}', "");
    Expect(1, 7247, '\P{^Script_Extensions=	Lepcha}', "");
    Expect(0, 7248, '\p{Script_Extensions=	Lepcha}', "");
    Expect(1, 7248, '\p{^Script_Extensions=	Lepcha}', "");
    Expect(1, 7248, '\P{Script_Extensions=	Lepcha}', "");
    Expect(0, 7248, '\P{^Script_Extensions=	Lepcha}', "");
    Error('\p{Scx=	/a/lepc}');
    Error('\P{Scx=	/a/lepc}');
    Expect(1, 7247, '\p{Scx=:\ALepc\z:}', "");;
    Expect(0, 7248, '\p{Scx=:\ALepc\z:}', "");;
    Expect(1, 7247, '\p{Scx=lepc}', "");
    Expect(0, 7247, '\p{^Scx=lepc}', "");
    Expect(0, 7247, '\P{Scx=lepc}', "");
    Expect(1, 7247, '\P{^Scx=lepc}', "");
    Expect(0, 7248, '\p{Scx=lepc}', "");
    Expect(1, 7248, '\p{^Scx=lepc}', "");
    Expect(1, 7248, '\P{Scx=lepc}', "");
    Expect(0, 7248, '\P{^Scx=lepc}', "");
    Expect(1, 7247, '\p{Scx=:\Alepc\z:}', "");;
    Expect(0, 7248, '\p{Scx=:\Alepc\z:}', "");;
    Expect(1, 7247, '\p{Scx=-	lepc}', "");
    Expect(0, 7247, '\p{^Scx=-	lepc}', "");
    Expect(0, 7247, '\P{Scx=-	lepc}', "");
    Expect(1, 7247, '\P{^Scx=-	lepc}', "");
    Expect(0, 7248, '\p{Scx=-	lepc}', "");
    Expect(1, 7248, '\p{^Scx=-	lepc}', "");
    Expect(1, 7248, '\P{Scx=-	lepc}', "");
    Expect(0, 7248, '\P{^Scx=-	lepc}', "");
    Error('\p{Is_Script_Extensions=/a/-lepcha}');
    Error('\P{Is_Script_Extensions=/a/-lepcha}');
    Expect(1, 7247, '\p{Is_Script_Extensions: lepcha}', "");
    Expect(0, 7247, '\p{^Is_Script_Extensions: lepcha}', "");
    Expect(0, 7247, '\P{Is_Script_Extensions: lepcha}', "");
    Expect(1, 7247, '\P{^Is_Script_Extensions: lepcha}', "");
    Expect(0, 7248, '\p{Is_Script_Extensions: lepcha}', "");
    Expect(1, 7248, '\p{^Is_Script_Extensions: lepcha}', "");
    Expect(1, 7248, '\P{Is_Script_Extensions: lepcha}', "");
    Expect(0, 7248, '\P{^Is_Script_Extensions: lepcha}', "");
    Expect(1, 7247, '\p{Is_Script_Extensions=	LEPCHA}', "");
    Expect(0, 7247, '\p{^Is_Script_Extensions=	LEPCHA}', "");
    Expect(0, 7247, '\P{Is_Script_Extensions=	LEPCHA}', "");
    Expect(1, 7247, '\P{^Is_Script_Extensions=	LEPCHA}', "");
    Expect(0, 7248, '\p{Is_Script_Extensions=	LEPCHA}', "");
    Expect(1, 7248, '\p{^Is_Script_Extensions=	LEPCHA}', "");
    Expect(1, 7248, '\P{Is_Script_Extensions=	LEPCHA}', "");
    Expect(0, 7248, '\P{^Is_Script_Extensions=	LEPCHA}', "");
    Error('\p{Is_Scx:	_	lepc:=}');
    Error('\P{Is_Scx:	_	lepc:=}');
    Expect(1, 7247, '\p{Is_Scx=lepc}', "");
    Expect(0, 7247, '\p{^Is_Scx=lepc}', "");
    Expect(0, 7247, '\P{Is_Scx=lepc}', "");
    Expect(1, 7247, '\P{^Is_Scx=lepc}', "");
    Expect(0, 7248, '\p{Is_Scx=lepc}', "");
    Expect(1, 7248, '\p{^Is_Scx=lepc}', "");
    Expect(1, 7248, '\P{Is_Scx=lepc}', "");
    Expect(0, 7248, '\P{^Is_Scx=lepc}', "");
    Expect(1, 7247, '\p{Is_Scx=--Lepc}', "");
    Expect(0, 7247, '\p{^Is_Scx=--Lepc}', "");
    Expect(0, 7247, '\P{Is_Scx=--Lepc}', "");
    Expect(1, 7247, '\P{^Is_Scx=--Lepc}', "");
    Expect(0, 7248, '\p{Is_Scx=--Lepc}', "");
    Expect(1, 7248, '\p{^Is_Scx=--Lepc}', "");
    Expect(1, 7248, '\P{Is_Scx=--Lepc}', "");
    Expect(0, 7248, '\P{^Is_Scx=--Lepc}', "");
    Error('\p{Script_Extensions=_	Limbu:=}');
    Error('\P{Script_Extensions=_	Limbu:=}');
    Expect(1, 6479, '\p{Script_Extensions=:\ALimbu\z:}', "");;
    Expect(0, 6480, '\p{Script_Extensions=:\ALimbu\z:}', "");;
    Expect(1, 6479, '\p{Script_Extensions=limbu}', "");
    Expect(0, 6479, '\p{^Script_Extensions=limbu}', "");
    Expect(0, 6479, '\P{Script_Extensions=limbu}', "");
    Expect(1, 6479, '\P{^Script_Extensions=limbu}', "");
    Expect(0, 6480, '\p{Script_Extensions=limbu}', "");
    Expect(1, 6480, '\p{^Script_Extensions=limbu}', "");
    Expect(1, 6480, '\P{Script_Extensions=limbu}', "");
    Expect(0, 6480, '\P{^Script_Extensions=limbu}', "");
    Expect(1, 6479, '\p{Script_Extensions=:\Alimbu\z:}', "");;
    Expect(0, 6480, '\p{Script_Extensions=:\Alimbu\z:}', "");;
    Expect(1, 6479, '\p{Script_Extensions=  Limbu}', "");
    Expect(0, 6479, '\p{^Script_Extensions=  Limbu}', "");
    Expect(0, 6479, '\P{Script_Extensions=  Limbu}', "");
    Expect(1, 6479, '\P{^Script_Extensions=  Limbu}', "");
    Expect(0, 6480, '\p{Script_Extensions=  Limbu}', "");
    Expect(1, 6480, '\p{^Script_Extensions=  Limbu}', "");
    Expect(1, 6480, '\P{Script_Extensions=  Limbu}', "");
    Expect(0, 6480, '\P{^Script_Extensions=  Limbu}', "");
    Error('\p{Scx=/a/	 limb}');
    Error('\P{Scx=/a/	 limb}');
    Expect(1, 6479, '\p{Scx=:\ALimb\z:}', "");;
    Expect(0, 6480, '\p{Scx=:\ALimb\z:}', "");;
    Expect(1, 6479, '\p{Scx=limb}', "");
    Expect(0, 6479, '\p{^Scx=limb}', "");
    Expect(0, 6479, '\P{Scx=limb}', "");
    Expect(1, 6479, '\P{^Scx=limb}', "");
    Expect(0, 6480, '\p{Scx=limb}', "");
    Expect(1, 6480, '\p{^Scx=limb}', "");
    Expect(1, 6480, '\P{Scx=limb}', "");
    Expect(0, 6480, '\P{^Scx=limb}', "");
    Expect(1, 6479, '\p{Scx=:\Alimb\z:}', "");;
    Expect(0, 6480, '\p{Scx=:\Alimb\z:}', "");;
    Expect(1, 6479, '\p{Scx=-LIMB}', "");
    Expect(0, 6479, '\p{^Scx=-LIMB}', "");
    Expect(0, 6479, '\P{Scx=-LIMB}', "");
    Expect(1, 6479, '\P{^Scx=-LIMB}', "");
    Expect(0, 6480, '\p{Scx=-LIMB}', "");
    Expect(1, 6480, '\p{^Scx=-LIMB}', "");
    Expect(1, 6480, '\P{Scx=-LIMB}', "");
    Expect(0, 6480, '\P{^Scx=-LIMB}', "");
    Error('\p{Is_Script_Extensions=:=Limbu}');
    Error('\P{Is_Script_Extensions=:=Limbu}');
    Expect(1, 6479, '\p{Is_Script_Extensions=limbu}', "");
    Expect(0, 6479, '\p{^Is_Script_Extensions=limbu}', "");
    Expect(0, 6479, '\P{Is_Script_Extensions=limbu}', "");
    Expect(1, 6479, '\P{^Is_Script_Extensions=limbu}', "");
    Expect(0, 6480, '\p{Is_Script_Extensions=limbu}', "");
    Expect(1, 6480, '\p{^Is_Script_Extensions=limbu}', "");
    Expect(1, 6480, '\P{Is_Script_Extensions=limbu}', "");
    Expect(0, 6480, '\P{^Is_Script_Extensions=limbu}', "");
    Expect(1, 6479, '\p{Is_Script_Extensions=	-LIMBU}', "");
    Expect(0, 6479, '\p{^Is_Script_Extensions=	-LIMBU}', "");
    Expect(0, 6479, '\P{Is_Script_Extensions=	-LIMBU}', "");
    Expect(1, 6479, '\P{^Is_Script_Extensions=	-LIMBU}', "");
    Expect(0, 6480, '\p{Is_Script_Extensions=	-LIMBU}', "");
    Expect(1, 6480, '\p{^Is_Script_Extensions=	-LIMBU}', "");
    Expect(1, 6480, '\P{Is_Script_Extensions=	-LIMBU}', "");
    Expect(0, 6480, '\P{^Is_Script_Extensions=	-LIMBU}', "");
    Error('\p{Is_Scx=:=__Limb}');
    Error('\P{Is_Scx=:=__Limb}');
    Expect(1, 6479, '\p{Is_Scx=limb}', "");
    Expect(0, 6479, '\p{^Is_Scx=limb}', "");
    Expect(0, 6479, '\P{Is_Scx=limb}', "");
    Expect(1, 6479, '\P{^Is_Scx=limb}', "");
    Expect(0, 6480, '\p{Is_Scx=limb}', "");
    Expect(1, 6480, '\p{^Is_Scx=limb}', "");
    Expect(1, 6480, '\P{Is_Scx=limb}', "");
    Expect(0, 6480, '\P{^Is_Scx=limb}', "");
    Expect(1, 6479, '\p{Is_Scx=	Limb}', "");
    Expect(0, 6479, '\p{^Is_Scx=	Limb}', "");
    Expect(0, 6479, '\P{Is_Scx=	Limb}', "");
    Expect(1, 6479, '\P{^Is_Scx=	Limb}', "");
    Expect(0, 6480, '\p{Is_Scx=	Limb}', "");
    Expect(1, 6480, '\p{^Is_Scx=	Limb}', "");
    Expect(1, 6480, '\P{Is_Scx=	Limb}', "");
    Expect(0, 6480, '\P{^Is_Scx=	Limb}', "");
    Error('\p{Script_Extensions:   :=	_Linear_A}');
    Error('\P{Script_Extensions:   :=	_Linear_A}');
    Expect(1, 67431, '\p{Script_Extensions=:\ALinear_A\z:}', "");;
    Expect(0, 67432, '\p{Script_Extensions=:\ALinear_A\z:}', "");;
    Expect(1, 67431, '\p{Script_Extensions=lineara}', "");
    Expect(0, 67431, '\p{^Script_Extensions=lineara}', "");
    Expect(0, 67431, '\P{Script_Extensions=lineara}', "");
    Expect(1, 67431, '\P{^Script_Extensions=lineara}', "");
    Expect(0, 67432, '\p{Script_Extensions=lineara}', "");
    Expect(1, 67432, '\p{^Script_Extensions=lineara}', "");
    Expect(1, 67432, '\P{Script_Extensions=lineara}', "");
    Expect(0, 67432, '\P{^Script_Extensions=lineara}', "");
    Expect(1, 67431, '\p{Script_Extensions=:\Alineara\z:}', "");;
    Expect(0, 67432, '\p{Script_Extensions=:\Alineara\z:}', "");;
    Expect(1, 67431, '\p{Script_Extensions=_-linear_A}', "");
    Expect(0, 67431, '\p{^Script_Extensions=_-linear_A}', "");
    Expect(0, 67431, '\P{Script_Extensions=_-linear_A}', "");
    Expect(1, 67431, '\P{^Script_Extensions=_-linear_A}', "");
    Expect(0, 67432, '\p{Script_Extensions=_-linear_A}', "");
    Expect(1, 67432, '\p{^Script_Extensions=_-linear_A}', "");
    Expect(1, 67432, '\P{Script_Extensions=_-linear_A}', "");
    Expect(0, 67432, '\P{^Script_Extensions=_-linear_A}', "");
    Error('\p{Scx: _:=LINA}');
    Error('\P{Scx: _:=LINA}');
    Expect(1, 67431, '\p{Scx=:\ALina\z:}', "");;
    Expect(0, 67432, '\p{Scx=:\ALina\z:}', "");;
    Expect(1, 67431, '\p{Scx=lina}', "");
    Expect(0, 67431, '\p{^Scx=lina}', "");
    Expect(0, 67431, '\P{Scx=lina}', "");
    Expect(1, 67431, '\P{^Scx=lina}', "");
    Expect(0, 67432, '\p{Scx=lina}', "");
    Expect(1, 67432, '\p{^Scx=lina}', "");
    Expect(1, 67432, '\P{Scx=lina}', "");
    Expect(0, 67432, '\P{^Scx=lina}', "");
    Expect(1, 67431, '\p{Scx=:\Alina\z:}', "");;
    Expect(0, 67432, '\p{Scx=:\Alina\z:}', "");;
    Expect(1, 67431, '\p{Scx=	-lina}', "");
    Expect(0, 67431, '\p{^Scx=	-lina}', "");
    Expect(0, 67431, '\P{Scx=	-lina}', "");
    Expect(1, 67431, '\P{^Scx=	-lina}', "");
    Expect(0, 67432, '\p{Scx=	-lina}', "");
    Expect(1, 67432, '\p{^Scx=	-lina}', "");
    Expect(1, 67432, '\P{Scx=	-lina}', "");
    Expect(0, 67432, '\P{^Scx=	-lina}', "");
    Error('\p{Is_Script_Extensions=-:=Linear_A}');
    Error('\P{Is_Script_Extensions=-:=Linear_A}');
    Expect(1, 67431, '\p{Is_Script_Extensions=lineara}', "");
    Expect(0, 67431, '\p{^Is_Script_Extensions=lineara}', "");
    Expect(0, 67431, '\P{Is_Script_Extensions=lineara}', "");
    Expect(1, 67431, '\P{^Is_Script_Extensions=lineara}', "");
    Expect(0, 67432, '\p{Is_Script_Extensions=lineara}', "");
    Expect(1, 67432, '\p{^Is_Script_Extensions=lineara}', "");
    Expect(1, 67432, '\P{Is_Script_Extensions=lineara}', "");
    Expect(0, 67432, '\P{^Is_Script_Extensions=lineara}', "");
    Expect(1, 67431, '\p{Is_Script_Extensions=_linear_A}', "");
    Expect(0, 67431, '\p{^Is_Script_Extensions=_linear_A}', "");
    Expect(0, 67431, '\P{Is_Script_Extensions=_linear_A}', "");
    Expect(1, 67431, '\P{^Is_Script_Extensions=_linear_A}', "");
    Expect(0, 67432, '\p{Is_Script_Extensions=_linear_A}', "");
    Expect(1, 67432, '\p{^Is_Script_Extensions=_linear_A}', "");
    Expect(1, 67432, '\P{Is_Script_Extensions=_linear_A}', "");
    Expect(0, 67432, '\P{^Is_Script_Extensions=_linear_A}', "");
    Error('\p{Is_Scx=	 Lina/a/}');
    Error('\P{Is_Scx=	 Lina/a/}');
    Expect(1, 67431, '\p{Is_Scx=lina}', "");
    Expect(0, 67431, '\p{^Is_Scx=lina}', "");
    Expect(0, 67431, '\P{Is_Scx=lina}', "");
    Expect(1, 67431, '\P{^Is_Scx=lina}', "");
    Expect(0, 67432, '\p{Is_Scx=lina}', "");
    Expect(1, 67432, '\p{^Is_Scx=lina}', "");
    Expect(1, 67432, '\P{Is_Scx=lina}', "");
    Expect(0, 67432, '\P{^Is_Scx=lina}', "");
    Expect(1, 67431, '\p{Is_Scx=  Lina}', "");
    Expect(0, 67431, '\p{^Is_Scx=  Lina}', "");
    Expect(0, 67431, '\P{Is_Scx=  Lina}', "");
    Expect(1, 67431, '\P{^Is_Scx=  Lina}', "");
    Expect(0, 67432, '\p{Is_Scx=  Lina}', "");
    Expect(1, 67432, '\p{^Is_Scx=  Lina}', "");
    Expect(1, 67432, '\P{Is_Scx=  Lina}', "");
    Expect(0, 67432, '\P{^Is_Scx=  Lina}', "");
    Error('\p{Script_Extensions=	Linear_b:=}');
    Error('\P{Script_Extensions=	Linear_b:=}');
    Expect(1, 65855, '\p{Script_Extensions=:\ALinear_B\z:}', "");;
    Expect(0, 65856, '\p{Script_Extensions=:\ALinear_B\z:}', "");;
    Expect(1, 65855, '\p{Script_Extensions=linearb}', "");
    Expect(0, 65855, '\p{^Script_Extensions=linearb}', "");
    Expect(0, 65855, '\P{Script_Extensions=linearb}', "");
    Expect(1, 65855, '\P{^Script_Extensions=linearb}', "");
    Expect(0, 65856, '\p{Script_Extensions=linearb}', "");
    Expect(1, 65856, '\p{^Script_Extensions=linearb}', "");
    Expect(1, 65856, '\P{Script_Extensions=linearb}', "");
    Expect(0, 65856, '\P{^Script_Extensions=linearb}', "");
    Expect(1, 65855, '\p{Script_Extensions=:\Alinearb\z:}', "");;
    Expect(0, 65856, '\p{Script_Extensions=:\Alinearb\z:}', "");;
    Expect(1, 65855, '\p{Script_Extensions=Linear_B}', "");
    Expect(0, 65855, '\p{^Script_Extensions=Linear_B}', "");
    Expect(0, 65855, '\P{Script_Extensions=Linear_B}', "");
    Expect(1, 65855, '\P{^Script_Extensions=Linear_B}', "");
    Expect(0, 65856, '\p{Script_Extensions=Linear_B}', "");
    Expect(1, 65856, '\p{^Script_Extensions=Linear_B}', "");
    Expect(1, 65856, '\P{Script_Extensions=Linear_B}', "");
    Expect(0, 65856, '\P{^Script_Extensions=Linear_B}', "");
    Error('\p{Scx=- linb:=}');
    Error('\P{Scx=- linb:=}');
    Expect(1, 65855, '\p{Scx=:\ALinb\z:}', "");;
    Expect(0, 65856, '\p{Scx=:\ALinb\z:}', "");;
    Expect(1, 65855, '\p{Scx=linb}', "");
    Expect(0, 65855, '\p{^Scx=linb}', "");
    Expect(0, 65855, '\P{Scx=linb}', "");
    Expect(1, 65855, '\P{^Scx=linb}', "");
    Expect(0, 65856, '\p{Scx=linb}', "");
    Expect(1, 65856, '\p{^Scx=linb}', "");
    Expect(1, 65856, '\P{Scx=linb}', "");
    Expect(0, 65856, '\P{^Scx=linb}', "");
    Expect(1, 65855, '\p{Scx=:\Alinb\z:}', "");;
    Expect(0, 65856, '\p{Scx=:\Alinb\z:}', "");;
    Expect(1, 65855, '\p{Scx= -LINB}', "");
    Expect(0, 65855, '\p{^Scx= -LINB}', "");
    Expect(0, 65855, '\P{Scx= -LINB}', "");
    Expect(1, 65855, '\P{^Scx= -LINB}', "");
    Expect(0, 65856, '\p{Scx= -LINB}', "");
    Expect(1, 65856, '\p{^Scx= -LINB}', "");
    Expect(1, 65856, '\P{Scx= -LINB}', "");
    Expect(0, 65856, '\P{^Scx= -LINB}', "");
    Error('\p{Is_Script_Extensions=:=linear_B}');
    Error('\P{Is_Script_Extensions=:=linear_B}');
    Expect(1, 65855, '\p{Is_Script_Extensions=linearb}', "");
    Expect(0, 65855, '\p{^Is_Script_Extensions=linearb}', "");
    Expect(0, 65855, '\P{Is_Script_Extensions=linearb}', "");
    Expect(1, 65855, '\P{^Is_Script_Extensions=linearb}', "");
    Expect(0, 65856, '\p{Is_Script_Extensions=linearb}', "");
    Expect(1, 65856, '\p{^Is_Script_Extensions=linearb}', "");
    Expect(1, 65856, '\P{Is_Script_Extensions=linearb}', "");
    Expect(0, 65856, '\P{^Is_Script_Extensions=linearb}', "");
    Expect(1, 65855, '\p{Is_Script_Extensions=_Linear_B}', "");
    Expect(0, 65855, '\p{^Is_Script_Extensions=_Linear_B}', "");
    Expect(0, 65855, '\P{Is_Script_Extensions=_Linear_B}', "");
    Expect(1, 65855, '\P{^Is_Script_Extensions=_Linear_B}', "");
    Expect(0, 65856, '\p{Is_Script_Extensions=_Linear_B}', "");
    Expect(1, 65856, '\p{^Is_Script_Extensions=_Linear_B}', "");
    Expect(1, 65856, '\P{Is_Script_Extensions=_Linear_B}', "");
    Expect(0, 65856, '\P{^Is_Script_Extensions=_Linear_B}', "");
    Error('\p{Is_Scx=/a/-Linb}');
    Error('\P{Is_Scx=/a/-Linb}');
    Expect(1, 65855, '\p{Is_Scx=linb}', "");
    Expect(0, 65855, '\p{^Is_Scx=linb}', "");
    Expect(0, 65855, '\P{Is_Scx=linb}', "");
    Expect(1, 65855, '\P{^Is_Scx=linb}', "");
    Expect(0, 65856, '\p{Is_Scx=linb}', "");
    Expect(1, 65856, '\p{^Is_Scx=linb}', "");
    Expect(1, 65856, '\P{Is_Scx=linb}', "");
    Expect(0, 65856, '\P{^Is_Scx=linb}', "");
    Expect(1, 65855, '\p{Is_Scx= -linb}', "");
    Expect(0, 65855, '\p{^Is_Scx= -linb}', "");
    Expect(0, 65855, '\P{Is_Scx= -linb}', "");
    Expect(1, 65855, '\P{^Is_Scx= -linb}', "");
    Expect(0, 65856, '\p{Is_Scx= -linb}', "");
    Expect(1, 65856, '\p{^Is_Scx= -linb}', "");
    Expect(1, 65856, '\P{Is_Scx= -linb}', "");
    Expect(0, 65856, '\P{^Is_Scx= -linb}', "");
    Error('\p{Script_Extensions=	:=lisu}');
    Error('\P{Script_Extensions=	:=lisu}');
    Expect(1, 73648, '\p{Script_Extensions=:\ALisu\z:}', "");;
    Expect(0, 73649, '\p{Script_Extensions=:\ALisu\z:}', "");;
    Expect(1, 73648, '\p{Script_Extensions=lisu}', "");
    Expect(0, 73648, '\p{^Script_Extensions=lisu}', "");
    Expect(0, 73648, '\P{Script_Extensions=lisu}', "");
    Expect(1, 73648, '\P{^Script_Extensions=lisu}', "");
    Expect(0, 73649, '\p{Script_Extensions=lisu}', "");
    Expect(1, 73649, '\p{^Script_Extensions=lisu}', "");
    Expect(1, 73649, '\P{Script_Extensions=lisu}', "");
    Expect(0, 73649, '\P{^Script_Extensions=lisu}', "");
    Expect(1, 73648, '\p{Script_Extensions=:\Alisu\z:}', "");;
    Expect(0, 73649, '\p{Script_Extensions=:\Alisu\z:}', "");;
    Expect(1, 73648, '\p{Script_Extensions= lisu}', "");
    Expect(0, 73648, '\p{^Script_Extensions= lisu}', "");
    Expect(0, 73648, '\P{Script_Extensions= lisu}', "");
    Expect(1, 73648, '\P{^Script_Extensions= lisu}', "");
    Expect(0, 73649, '\p{Script_Extensions= lisu}', "");
    Expect(1, 73649, '\p{^Script_Extensions= lisu}', "");
    Expect(1, 73649, '\P{Script_Extensions= lisu}', "");
    Expect(0, 73649, '\P{^Script_Extensions= lisu}', "");
    Error('\p{Scx=:=	Lisu}');
    Error('\P{Scx=:=	Lisu}');
    Expect(1, 73648, '\p{Scx=:\ALisu\z:}', "");;
    Expect(0, 73649, '\p{Scx=:\ALisu\z:}', "");;
    Expect(1, 73648, '\p{Scx: lisu}', "");
    Expect(0, 73648, '\p{^Scx: lisu}', "");
    Expect(0, 73648, '\P{Scx: lisu}', "");
    Expect(1, 73648, '\P{^Scx: lisu}', "");
    Expect(0, 73649, '\p{Scx: lisu}', "");
    Expect(1, 73649, '\p{^Scx: lisu}', "");
    Expect(1, 73649, '\P{Scx: lisu}', "");
    Expect(0, 73649, '\P{^Scx: lisu}', "");
    Expect(1, 73648, '\p{Scx=:\Alisu\z:}', "");;
    Expect(0, 73649, '\p{Scx=:\Alisu\z:}', "");;
    Expect(1, 73648, '\p{Scx=	Lisu}', "");
    Expect(0, 73648, '\p{^Scx=	Lisu}', "");
    Expect(0, 73648, '\P{Scx=	Lisu}', "");
    Expect(1, 73648, '\P{^Scx=	Lisu}', "");
    Expect(0, 73649, '\p{Scx=	Lisu}', "");
    Expect(1, 73649, '\p{^Scx=	Lisu}', "");
    Expect(1, 73649, '\P{Scx=	Lisu}', "");
    Expect(0, 73649, '\P{^Scx=	Lisu}', "");
    Error('\p{Is_Script_Extensions=/a/-	Lisu}');
    Error('\P{Is_Script_Extensions=/a/-	Lisu}');
    Expect(1, 73648, '\p{Is_Script_Extensions:   lisu}', "");
    Expect(0, 73648, '\p{^Is_Script_Extensions:   lisu}', "");
    Expect(0, 73648, '\P{Is_Script_Extensions:   lisu}', "");
    Expect(1, 73648, '\P{^Is_Script_Extensions:   lisu}', "");
    Expect(0, 73649, '\p{Is_Script_Extensions:   lisu}', "");
    Expect(1, 73649, '\p{^Is_Script_Extensions:   lisu}', "");
    Expect(1, 73649, '\P{Is_Script_Extensions:   lisu}', "");
    Expect(0, 73649, '\P{^Is_Script_Extensions:   lisu}', "");
    Expect(1, 73648, '\p{Is_Script_Extensions=_	Lisu}', "");
    Expect(0, 73648, '\p{^Is_Script_Extensions=_	Lisu}', "");
    Expect(0, 73648, '\P{Is_Script_Extensions=_	Lisu}', "");
    Expect(1, 73648, '\P{^Is_Script_Extensions=_	Lisu}', "");
    Expect(0, 73649, '\p{Is_Script_Extensions=_	Lisu}', "");
    Expect(1, 73649, '\p{^Is_Script_Extensions=_	Lisu}', "");
    Expect(1, 73649, '\P{Is_Script_Extensions=_	Lisu}', "");
    Expect(0, 73649, '\P{^Is_Script_Extensions=_	Lisu}', "");
    Error('\p{Is_Scx=/a/-	lisu}');
    Error('\P{Is_Scx=/a/-	lisu}');
    Expect(1, 73648, '\p{Is_Scx:   lisu}', "");
    Expect(0, 73648, '\p{^Is_Scx:   lisu}', "");
    Expect(0, 73648, '\P{Is_Scx:   lisu}', "");
    Expect(1, 73648, '\P{^Is_Scx:   lisu}', "");
    Expect(0, 73649, '\p{Is_Scx:   lisu}', "");
    Expect(1, 73649, '\p{^Is_Scx:   lisu}', "");
    Expect(1, 73649, '\P{Is_Scx:   lisu}', "");
    Expect(0, 73649, '\P{^Is_Scx:   lisu}', "");
    Expect(1, 73648, '\p{Is_Scx=-	Lisu}', "");
    Expect(0, 73648, '\p{^Is_Scx=-	Lisu}', "");
    Expect(0, 73648, '\P{Is_Scx=-	Lisu}', "");
    Expect(1, 73648, '\P{^Is_Scx=-	Lisu}', "");
    Expect(0, 73649, '\p{Is_Scx=-	Lisu}', "");
    Expect(1, 73649, '\p{^Is_Scx=-	Lisu}', "");
    Expect(1, 73649, '\P{Is_Scx=-	Lisu}', "");
    Expect(0, 73649, '\P{^Is_Scx=-	Lisu}', "");
    Error('\p{Script_Extensions=/a/-_LYCIAN}');
    Error('\P{Script_Extensions=/a/-_LYCIAN}');
    Expect(1, 66204, '\p{Script_Extensions=:\ALycian\z:}', "");;
    Expect(0, 66205, '\p{Script_Extensions=:\ALycian\z:}', "");;
    Expect(1, 66204, '\p{Script_Extensions=lycian}', "");
    Expect(0, 66204, '\p{^Script_Extensions=lycian}', "");
    Expect(0, 66204, '\P{Script_Extensions=lycian}', "");
    Expect(1, 66204, '\P{^Script_Extensions=lycian}', "");
    Expect(0, 66205, '\p{Script_Extensions=lycian}', "");
    Expect(1, 66205, '\p{^Script_Extensions=lycian}', "");
    Expect(1, 66205, '\P{Script_Extensions=lycian}', "");
    Expect(0, 66205, '\P{^Script_Extensions=lycian}', "");
    Expect(1, 66204, '\p{Script_Extensions=:\Alycian\z:}', "");;
    Expect(0, 66205, '\p{Script_Extensions=:\Alycian\z:}', "");;
    Expect(1, 66204, '\p{Script_Extensions=	-Lycian}', "");
    Expect(0, 66204, '\p{^Script_Extensions=	-Lycian}', "");
    Expect(0, 66204, '\P{Script_Extensions=	-Lycian}', "");
    Expect(1, 66204, '\P{^Script_Extensions=	-Lycian}', "");
    Expect(0, 66205, '\p{Script_Extensions=	-Lycian}', "");
    Expect(1, 66205, '\p{^Script_Extensions=	-Lycian}', "");
    Expect(1, 66205, '\P{Script_Extensions=	-Lycian}', "");
    Expect(0, 66205, '\P{^Script_Extensions=	-Lycian}', "");
    Error('\p{Scx=		Lyci/a/}');
    Error('\P{Scx=		Lyci/a/}');
    Expect(1, 66204, '\p{Scx=:\ALyci\z:}', "");;
    Expect(0, 66205, '\p{Scx=:\ALyci\z:}', "");;
    Expect(1, 66204, '\p{Scx=lyci}', "");
    Expect(0, 66204, '\p{^Scx=lyci}', "");
    Expect(0, 66204, '\P{Scx=lyci}', "");
    Expect(1, 66204, '\P{^Scx=lyci}', "");
    Expect(0, 66205, '\p{Scx=lyci}', "");
    Expect(1, 66205, '\p{^Scx=lyci}', "");
    Expect(1, 66205, '\P{Scx=lyci}', "");
    Expect(0, 66205, '\P{^Scx=lyci}', "");
    Expect(1, 66204, '\p{Scx=:\Alyci\z:}', "");;
    Expect(0, 66205, '\p{Scx=:\Alyci\z:}', "");;
    Expect(1, 66204, '\p{Scx=_ lyci}', "");
    Expect(0, 66204, '\p{^Scx=_ lyci}', "");
    Expect(0, 66204, '\P{Scx=_ lyci}', "");
    Expect(1, 66204, '\P{^Scx=_ lyci}', "");
    Expect(0, 66205, '\p{Scx=_ lyci}', "");
    Expect(1, 66205, '\p{^Scx=_ lyci}', "");
    Expect(1, 66205, '\P{Scx=_ lyci}', "");
    Expect(0, 66205, '\P{^Scx=_ lyci}', "");
    Error('\p{Is_Script_Extensions=_:=Lycian}');
    Error('\P{Is_Script_Extensions=_:=Lycian}');
    Expect(1, 66204, '\p{Is_Script_Extensions: lycian}', "");
    Expect(0, 66204, '\p{^Is_Script_Extensions: lycian}', "");
    Expect(0, 66204, '\P{Is_Script_Extensions: lycian}', "");
    Expect(1, 66204, '\P{^Is_Script_Extensions: lycian}', "");
    Expect(0, 66205, '\p{Is_Script_Extensions: lycian}', "");
    Expect(1, 66205, '\p{^Is_Script_Extensions: lycian}', "");
    Expect(1, 66205, '\P{Is_Script_Extensions: lycian}', "");
    Expect(0, 66205, '\P{^Is_Script_Extensions: lycian}', "");
    Expect(1, 66204, '\p{Is_Script_Extensions=	lycian}', "");
    Expect(0, 66204, '\p{^Is_Script_Extensions=	lycian}', "");
    Expect(0, 66204, '\P{Is_Script_Extensions=	lycian}', "");
    Expect(1, 66204, '\P{^Is_Script_Extensions=	lycian}', "");
    Expect(0, 66205, '\p{Is_Script_Extensions=	lycian}', "");
    Expect(1, 66205, '\p{^Is_Script_Extensions=	lycian}', "");
    Expect(1, 66205, '\P{Is_Script_Extensions=	lycian}', "");
    Expect(0, 66205, '\P{^Is_Script_Extensions=	lycian}', "");
    Error('\p{Is_Scx= 	Lyci:=}');
    Error('\P{Is_Scx= 	Lyci:=}');
    Expect(1, 66204, '\p{Is_Scx=lyci}', "");
    Expect(0, 66204, '\p{^Is_Scx=lyci}', "");
    Expect(0, 66204, '\P{Is_Scx=lyci}', "");
    Expect(1, 66204, '\P{^Is_Scx=lyci}', "");
    Expect(0, 66205, '\p{Is_Scx=lyci}', "");
    Expect(1, 66205, '\p{^Is_Scx=lyci}', "");
    Expect(1, 66205, '\P{Is_Scx=lyci}', "");
    Expect(0, 66205, '\P{^Is_Scx=lyci}', "");
    Expect(1, 66204, '\p{Is_Scx=_LYCI}', "");
    Expect(0, 66204, '\p{^Is_Scx=_LYCI}', "");
    Expect(0, 66204, '\P{Is_Scx=_LYCI}', "");
    Expect(1, 66204, '\P{^Is_Scx=_LYCI}', "");
    Expect(0, 66205, '\p{Is_Scx=_LYCI}', "");
    Expect(1, 66205, '\p{^Is_Scx=_LYCI}', "");
    Expect(1, 66205, '\P{Is_Scx=_LYCI}', "");
    Expect(0, 66205, '\P{^Is_Scx=_LYCI}', "");
    Error('\p{Script_Extensions=	:=lydian}');
    Error('\P{Script_Extensions=	:=lydian}');
    Expect(1, 67903, '\p{Script_Extensions=:\ALydian\z:}', "");;
    Expect(0, 67904, '\p{Script_Extensions=:\ALydian\z:}', "");;
    Expect(1, 67903, '\p{Script_Extensions=lydian}', "");
    Expect(0, 67903, '\p{^Script_Extensions=lydian}', "");
    Expect(0, 67903, '\P{Script_Extensions=lydian}', "");
    Expect(1, 67903, '\P{^Script_Extensions=lydian}', "");
    Expect(0, 67904, '\p{Script_Extensions=lydian}', "");
    Expect(1, 67904, '\p{^Script_Extensions=lydian}', "");
    Expect(1, 67904, '\P{Script_Extensions=lydian}', "");
    Expect(0, 67904, '\P{^Script_Extensions=lydian}', "");
    Expect(1, 67903, '\p{Script_Extensions=:\Alydian\z:}', "");;
    Expect(0, 67904, '\p{Script_Extensions=:\Alydian\z:}', "");;
    Expect(1, 67903, '\p{Script_Extensions=Lydian}', "");
    Expect(0, 67903, '\p{^Script_Extensions=Lydian}', "");
    Expect(0, 67903, '\P{Script_Extensions=Lydian}', "");
    Expect(1, 67903, '\P{^Script_Extensions=Lydian}', "");
    Expect(0, 67904, '\p{Script_Extensions=Lydian}', "");
    Expect(1, 67904, '\p{^Script_Extensions=Lydian}', "");
    Expect(1, 67904, '\P{Script_Extensions=Lydian}', "");
    Expect(0, 67904, '\P{^Script_Extensions=Lydian}', "");
    Error('\p{Scx= /a/LYDI}');
    Error('\P{Scx= /a/LYDI}');
    Expect(1, 67903, '\p{Scx=:\ALydi\z:}', "");;
    Expect(0, 67904, '\p{Scx=:\ALydi\z:}', "");;
    Expect(1, 67903, '\p{Scx=lydi}', "");
    Expect(0, 67903, '\p{^Scx=lydi}', "");
    Expect(0, 67903, '\P{Scx=lydi}', "");
    Expect(1, 67903, '\P{^Scx=lydi}', "");
    Expect(0, 67904, '\p{Scx=lydi}', "");
    Expect(1, 67904, '\p{^Scx=lydi}', "");
    Expect(1, 67904, '\P{Scx=lydi}', "");
    Expect(0, 67904, '\P{^Scx=lydi}', "");
    Expect(1, 67903, '\p{Scx=:\Alydi\z:}', "");;
    Expect(0, 67904, '\p{Scx=:\Alydi\z:}', "");;
    Expect(1, 67903, '\p{Scx:Lydi}', "");
    Expect(0, 67903, '\p{^Scx:Lydi}', "");
    Expect(0, 67903, '\P{Scx:Lydi}', "");
    Expect(1, 67903, '\P{^Scx:Lydi}', "");
    Expect(0, 67904, '\p{Scx:Lydi}', "");
    Expect(1, 67904, '\p{^Scx:Lydi}', "");
    Expect(1, 67904, '\P{Scx:Lydi}', "");
    Expect(0, 67904, '\P{^Scx:Lydi}', "");
    Error('\p{Is_Script_Extensions= _Lydian/a/}');
    Error('\P{Is_Script_Extensions= _Lydian/a/}');
    Expect(1, 67903, '\p{Is_Script_Extensions=lydian}', "");
    Expect(0, 67903, '\p{^Is_Script_Extensions=lydian}', "");
    Expect(0, 67903, '\P{Is_Script_Extensions=lydian}', "");
    Expect(1, 67903, '\P{^Is_Script_Extensions=lydian}', "");
    Expect(0, 67904, '\p{Is_Script_Extensions=lydian}', "");
    Expect(1, 67904, '\p{^Is_Script_Extensions=lydian}', "");
    Expect(1, 67904, '\P{Is_Script_Extensions=lydian}', "");
    Expect(0, 67904, '\P{^Is_Script_Extensions=lydian}', "");
    Expect(1, 67903, '\p{Is_Script_Extensions= Lydian}', "");
    Expect(0, 67903, '\p{^Is_Script_Extensions= Lydian}', "");
    Expect(0, 67903, '\P{Is_Script_Extensions= Lydian}', "");
    Expect(1, 67903, '\P{^Is_Script_Extensions= Lydian}', "");
    Expect(0, 67904, '\p{Is_Script_Extensions= Lydian}', "");
    Expect(1, 67904, '\p{^Is_Script_Extensions= Lydian}', "");
    Expect(1, 67904, '\P{Is_Script_Extensions= Lydian}', "");
    Expect(0, 67904, '\P{^Is_Script_Extensions= Lydian}', "");
    Error('\p{Is_Scx=/a/_ LYDI}');
    Error('\P{Is_Scx=/a/_ LYDI}');
    Expect(1, 67903, '\p{Is_Scx=lydi}', "");
    Expect(0, 67903, '\p{^Is_Scx=lydi}', "");
    Expect(0, 67903, '\P{Is_Scx=lydi}', "");
    Expect(1, 67903, '\P{^Is_Scx=lydi}', "");
    Expect(0, 67904, '\p{Is_Scx=lydi}', "");
    Expect(1, 67904, '\p{^Is_Scx=lydi}', "");
    Expect(1, 67904, '\P{Is_Scx=lydi}', "");
    Expect(0, 67904, '\P{^Is_Scx=lydi}', "");
    Expect(1, 67903, '\p{Is_Scx=	_LYDI}', "");
    Expect(0, 67903, '\p{^Is_Scx=	_LYDI}', "");
    Expect(0, 67903, '\P{Is_Scx=	_LYDI}', "");
    Expect(1, 67903, '\P{^Is_Scx=	_LYDI}', "");
    Expect(0, 67904, '\p{Is_Scx=	_LYDI}', "");
    Expect(1, 67904, '\p{^Is_Scx=	_LYDI}', "");
    Expect(1, 67904, '\P{Is_Scx=	_LYDI}', "");
    Expect(0, 67904, '\P{^Is_Scx=	_LYDI}', "");
    Error('\p{Script_Extensions:    _MAHAJANI/a/}');
    Error('\P{Script_Extensions:    _MAHAJANI/a/}');
    Expect(1, 70006, '\p{Script_Extensions=:\AMahajani\z:}', "");;
    Expect(0, 70007, '\p{Script_Extensions=:\AMahajani\z:}', "");;
    Expect(1, 70006, '\p{Script_Extensions=mahajani}', "");
    Expect(0, 70006, '\p{^Script_Extensions=mahajani}', "");
    Expect(0, 70006, '\P{Script_Extensions=mahajani}', "");
    Expect(1, 70006, '\P{^Script_Extensions=mahajani}', "");
    Expect(0, 70007, '\p{Script_Extensions=mahajani}', "");
    Expect(1, 70007, '\p{^Script_Extensions=mahajani}', "");
    Expect(1, 70007, '\P{Script_Extensions=mahajani}', "");
    Expect(0, 70007, '\P{^Script_Extensions=mahajani}', "");
    Expect(1, 70006, '\p{Script_Extensions=:\Amahajani\z:}', "");;
    Expect(0, 70007, '\p{Script_Extensions=:\Amahajani\z:}', "");;
    Expect(1, 70006, '\p{Script_Extensions=--Mahajani}', "");
    Expect(0, 70006, '\p{^Script_Extensions=--Mahajani}', "");
    Expect(0, 70006, '\P{Script_Extensions=--Mahajani}', "");
    Expect(1, 70006, '\P{^Script_Extensions=--Mahajani}', "");
    Expect(0, 70007, '\p{Script_Extensions=--Mahajani}', "");
    Expect(1, 70007, '\p{^Script_Extensions=--Mahajani}', "");
    Expect(1, 70007, '\P{Script_Extensions=--Mahajani}', "");
    Expect(0, 70007, '\P{^Script_Extensions=--Mahajani}', "");
    Error('\p{Scx=-Mahj:=}');
    Error('\P{Scx=-Mahj:=}');
    Expect(1, 70006, '\p{Scx=:\AMahj\z:}', "");;
    Expect(0, 70007, '\p{Scx=:\AMahj\z:}', "");;
    Expect(1, 70006, '\p{Scx=mahj}', "");
    Expect(0, 70006, '\p{^Scx=mahj}', "");
    Expect(0, 70006, '\P{Scx=mahj}', "");
    Expect(1, 70006, '\P{^Scx=mahj}', "");
    Expect(0, 70007, '\p{Scx=mahj}', "");
    Expect(1, 70007, '\p{^Scx=mahj}', "");
    Expect(1, 70007, '\P{Scx=mahj}', "");
    Expect(0, 70007, '\P{^Scx=mahj}', "");
    Expect(1, 70006, '\p{Scx=:\Amahj\z:}', "");;
    Expect(0, 70007, '\p{Scx=:\Amahj\z:}', "");;
    Expect(1, 70006, '\p{Scx=_	Mahj}', "");
    Expect(0, 70006, '\p{^Scx=_	Mahj}', "");
    Expect(0, 70006, '\P{Scx=_	Mahj}', "");
    Expect(1, 70006, '\P{^Scx=_	Mahj}', "");
    Expect(0, 70007, '\p{Scx=_	Mahj}', "");
    Expect(1, 70007, '\p{^Scx=_	Mahj}', "");
    Expect(1, 70007, '\P{Scx=_	Mahj}', "");
    Expect(0, 70007, '\P{^Scx=_	Mahj}', "");
    Error('\p{Is_Script_Extensions=-/a/Mahajani}');
    Error('\P{Is_Script_Extensions=-/a/Mahajani}');
    Expect(1, 70006, '\p{Is_Script_Extensions=mahajani}', "");
    Expect(0, 70006, '\p{^Is_Script_Extensions=mahajani}', "");
    Expect(0, 70006, '\P{Is_Script_Extensions=mahajani}', "");
    Expect(1, 70006, '\P{^Is_Script_Extensions=mahajani}', "");
    Expect(0, 70007, '\p{Is_Script_Extensions=mahajani}', "");
    Expect(1, 70007, '\p{^Is_Script_Extensions=mahajani}', "");
    Expect(1, 70007, '\P{Is_Script_Extensions=mahajani}', "");
    Expect(0, 70007, '\P{^Is_Script_Extensions=mahajani}', "");
    Expect(1, 70006, '\p{Is_Script_Extensions=__mahajani}', "");
    Expect(0, 70006, '\p{^Is_Script_Extensions=__mahajani}', "");
    Expect(0, 70006, '\P{Is_Script_Extensions=__mahajani}', "");
    Expect(1, 70006, '\P{^Is_Script_Extensions=__mahajani}', "");
    Expect(0, 70007, '\p{Is_Script_Extensions=__mahajani}', "");
    Expect(1, 70007, '\p{^Is_Script_Extensions=__mahajani}', "");
    Expect(1, 70007, '\P{Is_Script_Extensions=__mahajani}', "");
    Expect(0, 70007, '\P{^Is_Script_Extensions=__mahajani}', "");
    Error('\p{Is_Scx=:=_ mahj}');
    Error('\P{Is_Scx=:=_ mahj}');
    Expect(1, 70006, '\p{Is_Scx=mahj}', "");
    Expect(0, 70006, '\p{^Is_Scx=mahj}', "");
    Expect(0, 70006, '\P{Is_Scx=mahj}', "");
    Expect(1, 70006, '\P{^Is_Scx=mahj}', "");
    Expect(0, 70007, '\p{Is_Scx=mahj}', "");
    Expect(1, 70007, '\p{^Is_Scx=mahj}', "");
    Expect(1, 70007, '\P{Is_Scx=mahj}', "");
    Expect(0, 70007, '\P{^Is_Scx=mahj}', "");
    Expect(1, 70006, '\p{Is_Scx: 	 mahj}', "");
    Expect(0, 70006, '\p{^Is_Scx: 	 mahj}', "");
    Expect(0, 70006, '\P{Is_Scx: 	 mahj}', "");
    Expect(1, 70006, '\P{^Is_Scx: 	 mahj}', "");
    Expect(0, 70007, '\p{Is_Scx: 	 mahj}', "");
    Expect(1, 70007, '\p{^Is_Scx: 	 mahj}', "");
    Expect(1, 70007, '\P{Is_Scx: 	 mahj}', "");
    Expect(0, 70007, '\P{^Is_Scx: 	 mahj}', "");
    Error('\p{Script_Extensions=_:=Makasar}');
    Error('\P{Script_Extensions=_:=Makasar}');
    Expect(1, 73464, '\p{Script_Extensions=:\AMakasar\z:}', "");;
    Expect(0, 73465, '\p{Script_Extensions=:\AMakasar\z:}', "");;
    Expect(1, 73464, '\p{Script_Extensions:	makasar}', "");
    Expect(0, 73464, '\p{^Script_Extensions:	makasar}', "");
    Expect(0, 73464, '\P{Script_Extensions:	makasar}', "");
    Expect(1, 73464, '\P{^Script_Extensions:	makasar}', "");
    Expect(0, 73465, '\p{Script_Extensions:	makasar}', "");
    Expect(1, 73465, '\p{^Script_Extensions:	makasar}', "");
    Expect(1, 73465, '\P{Script_Extensions:	makasar}', "");
    Expect(0, 73465, '\P{^Script_Extensions:	makasar}', "");
    Expect(1, 73464, '\p{Script_Extensions=:\Amakasar\z:}', "");;
    Expect(0, 73465, '\p{Script_Extensions=:\Amakasar\z:}', "");;
    Expect(1, 73464, '\p{Script_Extensions=_	MAKASAR}', "");
    Expect(0, 73464, '\p{^Script_Extensions=_	MAKASAR}', "");
    Expect(0, 73464, '\P{Script_Extensions=_	MAKASAR}', "");
    Expect(1, 73464, '\P{^Script_Extensions=_	MAKASAR}', "");
    Expect(0, 73465, '\p{Script_Extensions=_	MAKASAR}', "");
    Expect(1, 73465, '\p{^Script_Extensions=_	MAKASAR}', "");
    Expect(1, 73465, '\P{Script_Extensions=_	MAKASAR}', "");
    Expect(0, 73465, '\P{^Script_Extensions=_	MAKASAR}', "");
    Error('\p{Scx:	_maka/a/}');
    Error('\P{Scx:	_maka/a/}');
    Expect(1, 73464, '\p{Scx=:\AMaka\z:}', "");;
    Expect(0, 73465, '\p{Scx=:\AMaka\z:}', "");;
    Expect(1, 73464, '\p{Scx=maka}', "");
    Expect(0, 73464, '\p{^Scx=maka}', "");
    Expect(0, 73464, '\P{Scx=maka}', "");
    Expect(1, 73464, '\P{^Scx=maka}', "");
    Expect(0, 73465, '\p{Scx=maka}', "");
    Expect(1, 73465, '\p{^Scx=maka}', "");
    Expect(1, 73465, '\P{Scx=maka}', "");
    Expect(0, 73465, '\P{^Scx=maka}', "");
    Expect(1, 73464, '\p{Scx=:\Amaka\z:}', "");;
    Expect(0, 73465, '\p{Scx=:\Amaka\z:}', "");;
    Expect(1, 73464, '\p{Scx=__MAKA}', "");
    Expect(0, 73464, '\p{^Scx=__MAKA}', "");
    Expect(0, 73464, '\P{Scx=__MAKA}', "");
    Expect(1, 73464, '\P{^Scx=__MAKA}', "");
    Expect(0, 73465, '\p{Scx=__MAKA}', "");
    Expect(1, 73465, '\p{^Scx=__MAKA}', "");
    Expect(1, 73465, '\P{Scx=__MAKA}', "");
    Expect(0, 73465, '\P{^Scx=__MAKA}', "");
    Error('\p{Is_Script_Extensions= 	makasar:=}');
    Error('\P{Is_Script_Extensions= 	makasar:=}');
    Expect(1, 73464, '\p{Is_Script_Extensions=makasar}', "");
    Expect(0, 73464, '\p{^Is_Script_Extensions=makasar}', "");
    Expect(0, 73464, '\P{Is_Script_Extensions=makasar}', "");
    Expect(1, 73464, '\P{^Is_Script_Extensions=makasar}', "");
    Expect(0, 73465, '\p{Is_Script_Extensions=makasar}', "");
    Expect(1, 73465, '\p{^Is_Script_Extensions=makasar}', "");
    Expect(1, 73465, '\P{Is_Script_Extensions=makasar}', "");
    Expect(0, 73465, '\P{^Is_Script_Extensions=makasar}', "");
    Expect(1, 73464, '\p{Is_Script_Extensions:-makasar}', "");
    Expect(0, 73464, '\p{^Is_Script_Extensions:-makasar}', "");
    Expect(0, 73464, '\P{Is_Script_Extensions:-makasar}', "");
    Expect(1, 73464, '\P{^Is_Script_Extensions:-makasar}', "");
    Expect(0, 73465, '\p{Is_Script_Extensions:-makasar}', "");
    Expect(1, 73465, '\p{^Is_Script_Extensions:-makasar}', "");
    Expect(1, 73465, '\P{Is_Script_Extensions:-makasar}', "");
    Expect(0, 73465, '\P{^Is_Script_Extensions:-makasar}', "");
    Error('\p{Is_Scx=/a/_Maka}');
    Error('\P{Is_Scx=/a/_Maka}');
    Expect(1, 73464, '\p{Is_Scx=maka}', "");
    Expect(0, 73464, '\p{^Is_Scx=maka}', "");
    Expect(0, 73464, '\P{Is_Scx=maka}', "");
    Expect(1, 73464, '\P{^Is_Scx=maka}', "");
    Expect(0, 73465, '\p{Is_Scx=maka}', "");
    Expect(1, 73465, '\p{^Is_Scx=maka}', "");
    Expect(1, 73465, '\P{Is_Scx=maka}', "");
    Expect(0, 73465, '\P{^Is_Scx=maka}', "");
    Expect(1, 73464, '\p{Is_Scx=_ Maka}', "");
    Expect(0, 73464, '\p{^Is_Scx=_ Maka}', "");
    Expect(0, 73464, '\P{Is_Scx=_ Maka}', "");
    Expect(1, 73464, '\P{^Is_Scx=_ Maka}', "");
    Expect(0, 73465, '\p{Is_Scx=_ Maka}', "");
    Expect(1, 73465, '\p{^Is_Scx=_ Maka}', "");
    Expect(1, 73465, '\P{Is_Scx=_ Maka}', "");
    Expect(0, 73465, '\P{^Is_Scx=_ Maka}', "");
    Error('\p{Script_Extensions= /a/mandaic}');
    Error('\P{Script_Extensions= /a/mandaic}');
    Expect(1, 2142, '\p{Script_Extensions=:\AMandaic\z:}', "");;
    Expect(0, 2143, '\p{Script_Extensions=:\AMandaic\z:}', "");;
    Expect(1, 2142, '\p{Script_Extensions:	mandaic}', "");
    Expect(0, 2142, '\p{^Script_Extensions:	mandaic}', "");
    Expect(0, 2142, '\P{Script_Extensions:	mandaic}', "");
    Expect(1, 2142, '\P{^Script_Extensions:	mandaic}', "");
    Expect(0, 2143, '\p{Script_Extensions:	mandaic}', "");
    Expect(1, 2143, '\p{^Script_Extensions:	mandaic}', "");
    Expect(1, 2143, '\P{Script_Extensions:	mandaic}', "");
    Expect(0, 2143, '\P{^Script_Extensions:	mandaic}', "");
    Expect(1, 2142, '\p{Script_Extensions=:\Amandaic\z:}', "");;
    Expect(0, 2143, '\p{Script_Extensions=:\Amandaic\z:}', "");;
    Expect(1, 2142, '\p{Script_Extensions= -Mandaic}', "");
    Expect(0, 2142, '\p{^Script_Extensions= -Mandaic}', "");
    Expect(0, 2142, '\P{Script_Extensions= -Mandaic}', "");
    Expect(1, 2142, '\P{^Script_Extensions= -Mandaic}', "");
    Expect(0, 2143, '\p{Script_Extensions= -Mandaic}', "");
    Expect(1, 2143, '\p{^Script_Extensions= -Mandaic}', "");
    Expect(1, 2143, '\P{Script_Extensions= -Mandaic}', "");
    Expect(0, 2143, '\P{^Script_Extensions= -Mandaic}', "");
    Error('\p{Scx=-	mand:=}');
    Error('\P{Scx=-	mand:=}');
    Expect(1, 2142, '\p{Scx=:\AMand\z:}', "");;
    Expect(0, 2143, '\p{Scx=:\AMand\z:}', "");;
    Expect(1, 2142, '\p{Scx=mand}', "");
    Expect(0, 2142, '\p{^Scx=mand}', "");
    Expect(0, 2142, '\P{Scx=mand}', "");
    Expect(1, 2142, '\P{^Scx=mand}', "");
    Expect(0, 2143, '\p{Scx=mand}', "");
    Expect(1, 2143, '\p{^Scx=mand}', "");
    Expect(1, 2143, '\P{Scx=mand}', "");
    Expect(0, 2143, '\P{^Scx=mand}', "");
    Expect(1, 2142, '\p{Scx=:\Amand\z:}', "");;
    Expect(0, 2143, '\p{Scx=:\Amand\z:}', "");;
    Expect(1, 2142, '\p{Scx=-_Mand}', "");
    Expect(0, 2142, '\p{^Scx=-_Mand}', "");
    Expect(0, 2142, '\P{Scx=-_Mand}', "");
    Expect(1, 2142, '\P{^Scx=-_Mand}', "");
    Expect(0, 2143, '\p{Scx=-_Mand}', "");
    Expect(1, 2143, '\p{^Scx=-_Mand}', "");
    Expect(1, 2143, '\P{Scx=-_Mand}', "");
    Expect(0, 2143, '\P{^Scx=-_Mand}', "");
    Error('\p{Is_Script_Extensions=-MANDAIC/a/}');
    Error('\P{Is_Script_Extensions=-MANDAIC/a/}');
    Expect(1, 2142, '\p{Is_Script_Extensions:	mandaic}', "");
    Expect(0, 2142, '\p{^Is_Script_Extensions:	mandaic}', "");
    Expect(0, 2142, '\P{Is_Script_Extensions:	mandaic}', "");
    Expect(1, 2142, '\P{^Is_Script_Extensions:	mandaic}', "");
    Expect(0, 2143, '\p{Is_Script_Extensions:	mandaic}', "");
    Expect(1, 2143, '\p{^Is_Script_Extensions:	mandaic}', "");
    Expect(1, 2143, '\P{Is_Script_Extensions:	mandaic}', "");
    Expect(0, 2143, '\P{^Is_Script_Extensions:	mandaic}', "");
    Expect(1, 2142, '\p{Is_Script_Extensions=- Mandaic}', "");
    Expect(0, 2142, '\p{^Is_Script_Extensions=- Mandaic}', "");
    Expect(0, 2142, '\P{Is_Script_Extensions=- Mandaic}', "");
    Expect(1, 2142, '\P{^Is_Script_Extensions=- Mandaic}', "");
    Expect(0, 2143, '\p{Is_Script_Extensions=- Mandaic}', "");
    Expect(1, 2143, '\p{^Is_Script_Extensions=- Mandaic}', "");
    Expect(1, 2143, '\P{Is_Script_Extensions=- Mandaic}', "");
    Expect(0, 2143, '\P{^Is_Script_Extensions=- Mandaic}', "");
    Error('\p{Is_Scx=/a/_-MAND}');
    Error('\P{Is_Scx=/a/_-MAND}');
    Expect(1, 2142, '\p{Is_Scx=mand}', "");
    Expect(0, 2142, '\p{^Is_Scx=mand}', "");
    Expect(0, 2142, '\P{Is_Scx=mand}', "");
    Expect(1, 2142, '\P{^Is_Scx=mand}', "");
    Expect(0, 2143, '\p{Is_Scx=mand}', "");
    Expect(1, 2143, '\p{^Is_Scx=mand}', "");
    Expect(1, 2143, '\P{Is_Scx=mand}', "");
    Expect(0, 2143, '\P{^Is_Scx=mand}', "");
    Expect(1, 2142, '\p{Is_Scx: 		Mand}', "");
    Expect(0, 2142, '\p{^Is_Scx: 		Mand}', "");
    Expect(0, 2142, '\P{Is_Scx: 		Mand}', "");
    Expect(1, 2142, '\P{^Is_Scx: 		Mand}', "");
    Expect(0, 2143, '\p{Is_Scx: 		Mand}', "");
    Expect(1, 2143, '\p{^Is_Scx: 		Mand}', "");
    Expect(1, 2143, '\P{Is_Scx: 		Mand}', "");
    Expect(0, 2143, '\P{^Is_Scx: 		Mand}', "");
    Error('\p{Script_Extensions=/a/_	Manichaean}');
    Error('\P{Script_Extensions=/a/_	Manichaean}');
    Expect(1, 68342, '\p{Script_Extensions=:\AManichaean\z:}', "");;
    Expect(0, 68343, '\p{Script_Extensions=:\AManichaean\z:}', "");;
    Expect(1, 68342, '\p{Script_Extensions=manichaean}', "");
    Expect(0, 68342, '\p{^Script_Extensions=manichaean}', "");
    Expect(0, 68342, '\P{Script_Extensions=manichaean}', "");
    Expect(1, 68342, '\P{^Script_Extensions=manichaean}', "");
    Expect(0, 68343, '\p{Script_Extensions=manichaean}', "");
    Expect(1, 68343, '\p{^Script_Extensions=manichaean}', "");
    Expect(1, 68343, '\P{Script_Extensions=manichaean}', "");
    Expect(0, 68343, '\P{^Script_Extensions=manichaean}', "");
    Expect(1, 68342, '\p{Script_Extensions=:\Amanichaean\z:}', "");;
    Expect(0, 68343, '\p{Script_Extensions=:\Amanichaean\z:}', "");;
    Expect(1, 68342, '\p{Script_Extensions=_-MANICHAEAN}', "");
    Expect(0, 68342, '\p{^Script_Extensions=_-MANICHAEAN}', "");
    Expect(0, 68342, '\P{Script_Extensions=_-MANICHAEAN}', "");
    Expect(1, 68342, '\P{^Script_Extensions=_-MANICHAEAN}', "");
    Expect(0, 68343, '\p{Script_Extensions=_-MANICHAEAN}', "");
    Expect(1, 68343, '\p{^Script_Extensions=_-MANICHAEAN}', "");
    Expect(1, 68343, '\P{Script_Extensions=_-MANICHAEAN}', "");
    Expect(0, 68343, '\P{^Script_Extensions=_-MANICHAEAN}', "");
    Error('\p{Scx=:= Mani}');
    Error('\P{Scx=:= Mani}');
    Expect(1, 68342, '\p{Scx=:\AMani\z:}', "");;
    Expect(0, 68343, '\p{Scx=:\AMani\z:}', "");;
    Expect(1, 68342, '\p{Scx=mani}', "");
    Expect(0, 68342, '\p{^Scx=mani}', "");
    Expect(0, 68342, '\P{Scx=mani}', "");
    Expect(1, 68342, '\P{^Scx=mani}', "");
    Expect(0, 68343, '\p{Scx=mani}', "");
    Expect(1, 68343, '\p{^Scx=mani}', "");
    Expect(1, 68343, '\P{Scx=mani}', "");
    Expect(0, 68343, '\P{^Scx=mani}', "");
    Expect(1, 68342, '\p{Scx=:\Amani\z:}', "");;
    Expect(0, 68343, '\p{Scx=:\Amani\z:}', "");;
    Expect(1, 68342, '\p{Scx=- mani}', "");
    Expect(0, 68342, '\p{^Scx=- mani}', "");
    Expect(0, 68342, '\P{Scx=- mani}', "");
    Expect(1, 68342, '\P{^Scx=- mani}', "");
    Expect(0, 68343, '\p{Scx=- mani}', "");
    Expect(1, 68343, '\p{^Scx=- mani}', "");
    Expect(1, 68343, '\P{Scx=- mani}', "");
    Expect(0, 68343, '\P{^Scx=- mani}', "");
    Error('\p{Is_Script_Extensions=/a/	 Manichaean}');
    Error('\P{Is_Script_Extensions=/a/	 Manichaean}');
    Expect(1, 68342, '\p{Is_Script_Extensions=manichaean}', "");
    Expect(0, 68342, '\p{^Is_Script_Extensions=manichaean}', "");
    Expect(0, 68342, '\P{Is_Script_Extensions=manichaean}', "");
    Expect(1, 68342, '\P{^Is_Script_Extensions=manichaean}', "");
    Expect(0, 68343, '\p{Is_Script_Extensions=manichaean}', "");
    Expect(1, 68343, '\p{^Is_Script_Extensions=manichaean}', "");
    Expect(1, 68343, '\P{Is_Script_Extensions=manichaean}', "");
    Expect(0, 68343, '\P{^Is_Script_Extensions=manichaean}', "");
    Expect(1, 68342, '\p{Is_Script_Extensions=_MANICHAEAN}', "");
    Expect(0, 68342, '\p{^Is_Script_Extensions=_MANICHAEAN}', "");
    Expect(0, 68342, '\P{Is_Script_Extensions=_MANICHAEAN}', "");
    Expect(1, 68342, '\P{^Is_Script_Extensions=_MANICHAEAN}', "");
    Expect(0, 68343, '\p{Is_Script_Extensions=_MANICHAEAN}', "");
    Expect(1, 68343, '\p{^Is_Script_Extensions=_MANICHAEAN}', "");
    Expect(1, 68343, '\P{Is_Script_Extensions=_MANICHAEAN}', "");
    Expect(0, 68343, '\P{^Is_Script_Extensions=_MANICHAEAN}', "");
    Error('\p{Is_Scx=:=Mani}');
    Error('\P{Is_Scx=:=Mani}');
    Expect(1, 68342, '\p{Is_Scx=mani}', "");
    Expect(0, 68342, '\p{^Is_Scx=mani}', "");
    Expect(0, 68342, '\P{Is_Scx=mani}', "");
    Expect(1, 68342, '\P{^Is_Scx=mani}', "");
    Expect(0, 68343, '\p{Is_Scx=mani}', "");
    Expect(1, 68343, '\p{^Is_Scx=mani}', "");
    Expect(1, 68343, '\P{Is_Scx=mani}', "");
    Expect(0, 68343, '\P{^Is_Scx=mani}', "");
    Expect(1, 68342, '\p{Is_Scx= _mani}', "");
    Expect(0, 68342, '\p{^Is_Scx= _mani}', "");
    Expect(0, 68342, '\P{Is_Scx= _mani}', "");
    Expect(1, 68342, '\P{^Is_Scx= _mani}', "");
    Expect(0, 68343, '\p{Is_Scx= _mani}', "");
    Expect(1, 68343, '\p{^Is_Scx= _mani}', "");
    Expect(1, 68343, '\P{Is_Scx= _mani}', "");
    Expect(0, 68343, '\P{^Is_Scx= _mani}', "");
    Error('\p{Script_Extensions=/a/_Marchen}');
    Error('\P{Script_Extensions=/a/_Marchen}');
    Expect(1, 72886, '\p{Script_Extensions=:\AMarchen\z:}', "");;
    Expect(0, 72887, '\p{Script_Extensions=:\AMarchen\z:}', "");;
    Expect(1, 72886, '\p{Script_Extensions=marchen}', "");
    Expect(0, 72886, '\p{^Script_Extensions=marchen}', "");
    Expect(0, 72886, '\P{Script_Extensions=marchen}', "");
    Expect(1, 72886, '\P{^Script_Extensions=marchen}', "");
    Expect(0, 72887, '\p{Script_Extensions=marchen}', "");
    Expect(1, 72887, '\p{^Script_Extensions=marchen}', "");
    Expect(1, 72887, '\P{Script_Extensions=marchen}', "");
    Expect(0, 72887, '\P{^Script_Extensions=marchen}', "");
    Expect(1, 72886, '\p{Script_Extensions=:\Amarchen\z:}', "");;
    Expect(0, 72887, '\p{Script_Extensions=:\Amarchen\z:}', "");;
    Expect(1, 72886, '\p{Script_Extensions=  marchen}', "");
    Expect(0, 72886, '\p{^Script_Extensions=  marchen}', "");
    Expect(0, 72886, '\P{Script_Extensions=  marchen}', "");
    Expect(1, 72886, '\P{^Script_Extensions=  marchen}', "");
    Expect(0, 72887, '\p{Script_Extensions=  marchen}', "");
    Expect(1, 72887, '\p{^Script_Extensions=  marchen}', "");
    Expect(1, 72887, '\P{Script_Extensions=  marchen}', "");
    Expect(0, 72887, '\P{^Script_Extensions=  marchen}', "");
    Error('\p{Scx=/a/	-marc}');
    Error('\P{Scx=/a/	-marc}');
    Expect(1, 72886, '\p{Scx=:\AMarc\z:}', "");;
    Expect(0, 72887, '\p{Scx=:\AMarc\z:}', "");;
    Expect(1, 72886, '\p{Scx=marc}', "");
    Expect(0, 72886, '\p{^Scx=marc}', "");
    Expect(0, 72886, '\P{Scx=marc}', "");
    Expect(1, 72886, '\P{^Scx=marc}', "");
    Expect(0, 72887, '\p{Scx=marc}', "");
    Expect(1, 72887, '\p{^Scx=marc}', "");
    Expect(1, 72887, '\P{Scx=marc}', "");
    Expect(0, 72887, '\P{^Scx=marc}', "");
    Expect(1, 72886, '\p{Scx=:\Amarc\z:}', "");;
    Expect(0, 72887, '\p{Scx=:\Amarc\z:}', "");;
    Expect(1, 72886, '\p{Scx=Marc}', "");
    Expect(0, 72886, '\p{^Scx=Marc}', "");
    Expect(0, 72886, '\P{Scx=Marc}', "");
    Expect(1, 72886, '\P{^Scx=Marc}', "");
    Expect(0, 72887, '\p{Scx=Marc}', "");
    Expect(1, 72887, '\p{^Scx=Marc}', "");
    Expect(1, 72887, '\P{Scx=Marc}', "");
    Expect(0, 72887, '\P{^Scx=Marc}', "");
    Error('\p{Is_Script_Extensions=:=Marchen}');
    Error('\P{Is_Script_Extensions=:=Marchen}');
    Expect(1, 72886, '\p{Is_Script_Extensions=marchen}', "");
    Expect(0, 72886, '\p{^Is_Script_Extensions=marchen}', "");
    Expect(0, 72886, '\P{Is_Script_Extensions=marchen}', "");
    Expect(1, 72886, '\P{^Is_Script_Extensions=marchen}', "");
    Expect(0, 72887, '\p{Is_Script_Extensions=marchen}', "");
    Expect(1, 72887, '\p{^Is_Script_Extensions=marchen}', "");
    Expect(1, 72887, '\P{Is_Script_Extensions=marchen}', "");
    Expect(0, 72887, '\P{^Is_Script_Extensions=marchen}', "");
    Expect(1, 72886, '\p{Is_Script_Extensions=_-marchen}', "");
    Expect(0, 72886, '\p{^Is_Script_Extensions=_-marchen}', "");
    Expect(0, 72886, '\P{Is_Script_Extensions=_-marchen}', "");
    Expect(1, 72886, '\P{^Is_Script_Extensions=_-marchen}', "");
    Expect(0, 72887, '\p{Is_Script_Extensions=_-marchen}', "");
    Expect(1, 72887, '\p{^Is_Script_Extensions=_-marchen}', "");
    Expect(1, 72887, '\P{Is_Script_Extensions=_-marchen}', "");
    Expect(0, 72887, '\P{^Is_Script_Extensions=_-marchen}', "");
    Error('\p{Is_Scx= Marc:=}');
    Error('\P{Is_Scx= Marc:=}');
    Expect(1, 72886, '\p{Is_Scx: marc}', "");
    Expect(0, 72886, '\p{^Is_Scx: marc}', "");
    Expect(0, 72886, '\P{Is_Scx: marc}', "");
    Expect(1, 72886, '\P{^Is_Scx: marc}', "");
    Expect(0, 72887, '\p{Is_Scx: marc}', "");
    Expect(1, 72887, '\p{^Is_Scx: marc}', "");
    Expect(1, 72887, '\P{Is_Scx: marc}', "");
    Expect(0, 72887, '\P{^Is_Scx: marc}', "");
    Expect(1, 72886, '\p{Is_Scx=_-MARC}', "");
    Expect(0, 72886, '\p{^Is_Scx=_-MARC}', "");
    Expect(0, 72886, '\P{Is_Scx=_-MARC}', "");
    Expect(1, 72886, '\P{^Is_Scx=_-MARC}', "");
    Expect(0, 72887, '\p{Is_Scx=_-MARC}', "");
    Expect(1, 72887, '\p{^Is_Scx=_-MARC}', "");
    Expect(1, 72887, '\P{Is_Scx=_-MARC}', "");
    Expect(0, 72887, '\P{^Is_Scx=_-MARC}', "");
    Error('\p{Script_Extensions= :=Medefaidrin}');
    Error('\P{Script_Extensions= :=Medefaidrin}');
    Expect(1, 93850, '\p{Script_Extensions=:\AMedefaidrin\z:}', "");;
    Expect(0, 93851, '\p{Script_Extensions=:\AMedefaidrin\z:}', "");;
    Expect(1, 93850, '\p{Script_Extensions=medefaidrin}', "");
    Expect(0, 93850, '\p{^Script_Extensions=medefaidrin}', "");
    Expect(0, 93850, '\P{Script_Extensions=medefaidrin}', "");
    Expect(1, 93850, '\P{^Script_Extensions=medefaidrin}', "");
    Expect(0, 93851, '\p{Script_Extensions=medefaidrin}', "");
    Expect(1, 93851, '\p{^Script_Extensions=medefaidrin}', "");
    Expect(1, 93851, '\P{Script_Extensions=medefaidrin}', "");
    Expect(0, 93851, '\P{^Script_Extensions=medefaidrin}', "");
    Expect(1, 93850, '\p{Script_Extensions=:\Amedefaidrin\z:}', "");;
    Expect(0, 93851, '\p{Script_Extensions=:\Amedefaidrin\z:}', "");;
    Expect(1, 93850, '\p{Script_Extensions=	-Medefaidrin}', "");
    Expect(0, 93850, '\p{^Script_Extensions=	-Medefaidrin}', "");
    Expect(0, 93850, '\P{Script_Extensions=	-Medefaidrin}', "");
    Expect(1, 93850, '\P{^Script_Extensions=	-Medefaidrin}', "");
    Expect(0, 93851, '\p{Script_Extensions=	-Medefaidrin}', "");
    Expect(1, 93851, '\p{^Script_Extensions=	-Medefaidrin}', "");
    Expect(1, 93851, '\P{Script_Extensions=	-Medefaidrin}', "");
    Expect(0, 93851, '\P{^Script_Extensions=	-Medefaidrin}', "");
    Error('\p{Scx=_/a/medf}');
    Error('\P{Scx=_/a/medf}');
    Expect(1, 93850, '\p{Scx=:\AMedf\z:}', "");;
    Expect(0, 93851, '\p{Scx=:\AMedf\z:}', "");;
    Expect(1, 93850, '\p{Scx=medf}', "");
    Expect(0, 93850, '\p{^Scx=medf}', "");
    Expect(0, 93850, '\P{Scx=medf}', "");
    Expect(1, 93850, '\P{^Scx=medf}', "");
    Expect(0, 93851, '\p{Scx=medf}', "");
    Expect(1, 93851, '\p{^Scx=medf}', "");
    Expect(1, 93851, '\P{Scx=medf}', "");
    Expect(0, 93851, '\P{^Scx=medf}', "");
    Expect(1, 93850, '\p{Scx=:\Amedf\z:}', "");;
    Expect(0, 93851, '\p{Scx=:\Amedf\z:}', "");;
    Expect(1, 93850, '\p{Scx:	- medf}', "");
    Expect(0, 93850, '\p{^Scx:	- medf}', "");
    Expect(0, 93850, '\P{Scx:	- medf}', "");
    Expect(1, 93850, '\P{^Scx:	- medf}', "");
    Expect(0, 93851, '\p{Scx:	- medf}', "");
    Expect(1, 93851, '\p{^Scx:	- medf}', "");
    Expect(1, 93851, '\P{Scx:	- medf}', "");
    Expect(0, 93851, '\P{^Scx:	- medf}', "");
    Error('\p{Is_Script_Extensions=:= medefaidrin}');
    Error('\P{Is_Script_Extensions=:= medefaidrin}');
    Expect(1, 93850, '\p{Is_Script_Extensions=medefaidrin}', "");
    Expect(0, 93850, '\p{^Is_Script_Extensions=medefaidrin}', "");
    Expect(0, 93850, '\P{Is_Script_Extensions=medefaidrin}', "");
    Expect(1, 93850, '\P{^Is_Script_Extensions=medefaidrin}', "");
    Expect(0, 93851, '\p{Is_Script_Extensions=medefaidrin}', "");
    Expect(1, 93851, '\p{^Is_Script_Extensions=medefaidrin}', "");
    Expect(1, 93851, '\P{Is_Script_Extensions=medefaidrin}', "");
    Expect(0, 93851, '\P{^Is_Script_Extensions=medefaidrin}', "");
    Expect(1, 93850, '\p{Is_Script_Extensions= -Medefaidrin}', "");
    Expect(0, 93850, '\p{^Is_Script_Extensions= -Medefaidrin}', "");
    Expect(0, 93850, '\P{Is_Script_Extensions= -Medefaidrin}', "");
    Expect(1, 93850, '\P{^Is_Script_Extensions= -Medefaidrin}', "");
    Expect(0, 93851, '\p{Is_Script_Extensions= -Medefaidrin}', "");
    Expect(1, 93851, '\p{^Is_Script_Extensions= -Medefaidrin}', "");
    Expect(1, 93851, '\P{Is_Script_Extensions= -Medefaidrin}', "");
    Expect(0, 93851, '\P{^Is_Script_Extensions= -Medefaidrin}', "");
    Error('\p{Is_Scx=/a/MEDF}');
    Error('\P{Is_Scx=/a/MEDF}');
    Expect(1, 93850, '\p{Is_Scx=medf}', "");
    Expect(0, 93850, '\p{^Is_Scx=medf}', "");
    Expect(0, 93850, '\P{Is_Scx=medf}', "");
    Expect(1, 93850, '\P{^Is_Scx=medf}', "");
    Expect(0, 93851, '\p{Is_Scx=medf}', "");
    Expect(1, 93851, '\p{^Is_Scx=medf}', "");
    Expect(1, 93851, '\P{Is_Scx=medf}', "");
    Expect(0, 93851, '\P{^Is_Scx=medf}', "");
    Expect(1, 93850, '\p{Is_Scx=	Medf}', "");
    Expect(0, 93850, '\p{^Is_Scx=	Medf}', "");
    Expect(0, 93850, '\P{Is_Scx=	Medf}', "");
    Expect(1, 93850, '\P{^Is_Scx=	Medf}', "");
    Expect(0, 93851, '\p{Is_Scx=	Medf}', "");
    Expect(1, 93851, '\p{^Is_Scx=	Medf}', "");
    Expect(1, 93851, '\P{Is_Scx=	Medf}', "");
    Expect(0, 93851, '\P{^Is_Scx=	Medf}', "");
    Error('\p{Script_Extensions= MENDE_Kikakui:=}');
    Error('\P{Script_Extensions= MENDE_Kikakui:=}');
    Expect(1, 125142, '\p{Script_Extensions=:\AMende_Kikakui\z:}', "");;
    Expect(0, 125143, '\p{Script_Extensions=:\AMende_Kikakui\z:}', "");;
    Expect(1, 125142, '\p{Script_Extensions:   mendekikakui}', "");
    Expect(0, 125142, '\p{^Script_Extensions:   mendekikakui}', "");
    Expect(0, 125142, '\P{Script_Extensions:   mendekikakui}', "");
    Expect(1, 125142, '\P{^Script_Extensions:   mendekikakui}', "");
    Expect(0, 125143, '\p{Script_Extensions:   mendekikakui}', "");
    Expect(1, 125143, '\p{^Script_Extensions:   mendekikakui}', "");
    Expect(1, 125143, '\P{Script_Extensions:   mendekikakui}', "");
    Expect(0, 125143, '\P{^Script_Extensions:   mendekikakui}', "");
    Expect(1, 125142, '\p{Script_Extensions=:\Amendekikakui\z:}', "");;
    Expect(0, 125143, '\p{Script_Extensions=:\Amendekikakui\z:}', "");;
    Expect(1, 125142, '\p{Script_Extensions=- MENDE_Kikakui}', "");
    Expect(0, 125142, '\p{^Script_Extensions=- MENDE_Kikakui}', "");
    Expect(0, 125142, '\P{Script_Extensions=- MENDE_Kikakui}', "");
    Expect(1, 125142, '\P{^Script_Extensions=- MENDE_Kikakui}', "");
    Expect(0, 125143, '\p{Script_Extensions=- MENDE_Kikakui}', "");
    Expect(1, 125143, '\p{^Script_Extensions=- MENDE_Kikakui}', "");
    Expect(1, 125143, '\P{Script_Extensions=- MENDE_Kikakui}', "");
    Expect(0, 125143, '\P{^Script_Extensions=- MENDE_Kikakui}', "");
    Error('\p{Scx=_ mend:=}');
    Error('\P{Scx=_ mend:=}');
    Expect(1, 125142, '\p{Scx=:\AMend\z:}', "");;
    Expect(0, 125143, '\p{Scx=:\AMend\z:}', "");;
    Expect(1, 125142, '\p{Scx=mend}', "");
    Expect(0, 125142, '\p{^Scx=mend}', "");
    Expect(0, 125142, '\P{Scx=mend}', "");
    Expect(1, 125142, '\P{^Scx=mend}', "");
    Expect(0, 125143, '\p{Scx=mend}', "");
    Expect(1, 125143, '\p{^Scx=mend}', "");
    Expect(1, 125143, '\P{Scx=mend}', "");
    Expect(0, 125143, '\P{^Scx=mend}', "");
    Expect(1, 125142, '\p{Scx=:\Amend\z:}', "");;
    Expect(0, 125143, '\p{Scx=:\Amend\z:}', "");;
    Expect(1, 125142, '\p{Scx=_	Mend}', "");
    Expect(0, 125142, '\p{^Scx=_	Mend}', "");
    Expect(0, 125142, '\P{Scx=_	Mend}', "");
    Expect(1, 125142, '\P{^Scx=_	Mend}', "");
    Expect(0, 125143, '\p{Scx=_	Mend}', "");
    Expect(1, 125143, '\p{^Scx=_	Mend}', "");
    Expect(1, 125143, '\P{Scx=_	Mend}', "");
    Expect(0, 125143, '\P{^Scx=_	Mend}', "");
    Error('\p{Is_Script_Extensions=Mende_Kikakui/a/}');
    Error('\P{Is_Script_Extensions=Mende_Kikakui/a/}');
    Expect(1, 125142, '\p{Is_Script_Extensions=mendekikakui}', "");
    Expect(0, 125142, '\p{^Is_Script_Extensions=mendekikakui}', "");
    Expect(0, 125142, '\P{Is_Script_Extensions=mendekikakui}', "");
    Expect(1, 125142, '\P{^Is_Script_Extensions=mendekikakui}', "");
    Expect(0, 125143, '\p{Is_Script_Extensions=mendekikakui}', "");
    Expect(1, 125143, '\p{^Is_Script_Extensions=mendekikakui}', "");
    Expect(1, 125143, '\P{Is_Script_Extensions=mendekikakui}', "");
    Expect(0, 125143, '\P{^Is_Script_Extensions=mendekikakui}', "");
    Expect(1, 125142, '\p{Is_Script_Extensions:   _ MENDE_KIKAKUI}', "");
    Expect(0, 125142, '\p{^Is_Script_Extensions:   _ MENDE_KIKAKUI}', "");
    Expect(0, 125142, '\P{Is_Script_Extensions:   _ MENDE_KIKAKUI}', "");
    Expect(1, 125142, '\P{^Is_Script_Extensions:   _ MENDE_KIKAKUI}', "");
    Expect(0, 125143, '\p{Is_Script_Extensions:   _ MENDE_KIKAKUI}', "");
    Expect(1, 125143, '\p{^Is_Script_Extensions:   _ MENDE_KIKAKUI}', "");
    Expect(1, 125143, '\P{Is_Script_Extensions:   _ MENDE_KIKAKUI}', "");
    Expect(0, 125143, '\P{^Is_Script_Extensions:   _ MENDE_KIKAKUI}', "");
    Error('\p{Is_Scx=:=Mend}');
    Error('\P{Is_Scx=:=Mend}');
    Expect(1, 125142, '\p{Is_Scx=mend}', "");
    Expect(0, 125142, '\p{^Is_Scx=mend}', "");
    Expect(0, 125142, '\P{Is_Scx=mend}', "");
    Expect(1, 125142, '\P{^Is_Scx=mend}', "");
    Expect(0, 125143, '\p{Is_Scx=mend}', "");
    Expect(1, 125143, '\p{^Is_Scx=mend}', "");
    Expect(1, 125143, '\P{Is_Scx=mend}', "");
    Expect(0, 125143, '\P{^Is_Scx=mend}', "");
    Expect(1, 125142, '\p{Is_Scx:	 	Mend}', "");
    Expect(0, 125142, '\p{^Is_Scx:	 	Mend}', "");
    Expect(0, 125142, '\P{Is_Scx:	 	Mend}', "");
    Expect(1, 125142, '\P{^Is_Scx:	 	Mend}', "");
    Expect(0, 125143, '\p{Is_Scx:	 	Mend}', "");
    Expect(1, 125143, '\p{^Is_Scx:	 	Mend}', "");
    Expect(1, 125143, '\P{Is_Scx:	 	Mend}', "");
    Expect(0, 125143, '\P{^Is_Scx:	 	Mend}', "");
    Error('\p{Script_Extensions=	_Meroitic_cursive/a/}');
    Error('\P{Script_Extensions=	_Meroitic_cursive/a/}');
    Expect(1, 68095, '\p{Script_Extensions=:\AMeroitic_Cursive\z:}', "");;
    Expect(0, 68096, '\p{Script_Extensions=:\AMeroitic_Cursive\z:}', "");;
    Expect(1, 68095, '\p{Script_Extensions=meroiticcursive}', "");
    Expect(0, 68095, '\p{^Script_Extensions=meroiticcursive}', "");
    Expect(0, 68095, '\P{Script_Extensions=meroiticcursive}', "");
    Expect(1, 68095, '\P{^Script_Extensions=meroiticcursive}', "");
    Expect(0, 68096, '\p{Script_Extensions=meroiticcursive}', "");
    Expect(1, 68096, '\p{^Script_Extensions=meroiticcursive}', "");
    Expect(1, 68096, '\P{Script_Extensions=meroiticcursive}', "");
    Expect(0, 68096, '\P{^Script_Extensions=meroiticcursive}', "");
    Expect(1, 68095, '\p{Script_Extensions=:\Ameroiticcursive\z:}', "");;
    Expect(0, 68096, '\p{Script_Extensions=:\Ameroiticcursive\z:}', "");;
    Expect(1, 68095, '\p{Script_Extensions=- Meroitic_Cursive}', "");
    Expect(0, 68095, '\p{^Script_Extensions=- Meroitic_Cursive}', "");
    Expect(0, 68095, '\P{Script_Extensions=- Meroitic_Cursive}', "");
    Expect(1, 68095, '\P{^Script_Extensions=- Meroitic_Cursive}', "");
    Expect(0, 68096, '\p{Script_Extensions=- Meroitic_Cursive}', "");
    Expect(1, 68096, '\p{^Script_Extensions=- Meroitic_Cursive}', "");
    Expect(1, 68096, '\P{Script_Extensions=- Meroitic_Cursive}', "");
    Expect(0, 68096, '\P{^Script_Extensions=- Meroitic_Cursive}', "");
    Error('\p{Scx=:=_ MERC}');
    Error('\P{Scx=:=_ MERC}');
    Expect(1, 68095, '\p{Scx=:\AMerc\z:}', "");;
    Expect(0, 68096, '\p{Scx=:\AMerc\z:}', "");;
    Expect(1, 68095, '\p{Scx=merc}', "");
    Expect(0, 68095, '\p{^Scx=merc}', "");
    Expect(0, 68095, '\P{Scx=merc}', "");
    Expect(1, 68095, '\P{^Scx=merc}', "");
    Expect(0, 68096, '\p{Scx=merc}', "");
    Expect(1, 68096, '\p{^Scx=merc}', "");
    Expect(1, 68096, '\P{Scx=merc}', "");
    Expect(0, 68096, '\P{^Scx=merc}', "");
    Expect(1, 68095, '\p{Scx=:\Amerc\z:}', "");;
    Expect(0, 68096, '\p{Scx=:\Amerc\z:}', "");;
    Expect(1, 68095, '\p{Scx=_Merc}', "");
    Expect(0, 68095, '\p{^Scx=_Merc}', "");
    Expect(0, 68095, '\P{Scx=_Merc}', "");
    Expect(1, 68095, '\P{^Scx=_Merc}', "");
    Expect(0, 68096, '\p{Scx=_Merc}', "");
    Expect(1, 68096, '\p{^Scx=_Merc}', "");
    Expect(1, 68096, '\P{Scx=_Merc}', "");
    Expect(0, 68096, '\P{^Scx=_Merc}', "");
    Error('\p{Is_Script_Extensions:	/a/	 meroitic_Cursive}');
    Error('\P{Is_Script_Extensions:	/a/	 meroitic_Cursive}');
    Expect(1, 68095, '\p{Is_Script_Extensions=meroiticcursive}', "");
    Expect(0, 68095, '\p{^Is_Script_Extensions=meroiticcursive}', "");
    Expect(0, 68095, '\P{Is_Script_Extensions=meroiticcursive}', "");
    Expect(1, 68095, '\P{^Is_Script_Extensions=meroiticcursive}', "");
    Expect(0, 68096, '\p{Is_Script_Extensions=meroiticcursive}', "");
    Expect(1, 68096, '\p{^Is_Script_Extensions=meroiticcursive}', "");
    Expect(1, 68096, '\P{Is_Script_Extensions=meroiticcursive}', "");
    Expect(0, 68096, '\P{^Is_Script_Extensions=meroiticcursive}', "");
    Expect(1, 68095, '\p{Is_Script_Extensions=	 meroitic_Cursive}', "");
    Expect(0, 68095, '\p{^Is_Script_Extensions=	 meroitic_Cursive}', "");
    Expect(0, 68095, '\P{Is_Script_Extensions=	 meroitic_Cursive}', "");
    Expect(1, 68095, '\P{^Is_Script_Extensions=	 meroitic_Cursive}', "");
    Expect(0, 68096, '\p{Is_Script_Extensions=	 meroitic_Cursive}', "");
    Expect(1, 68096, '\p{^Is_Script_Extensions=	 meroitic_Cursive}', "");
    Expect(1, 68096, '\P{Is_Script_Extensions=	 meroitic_Cursive}', "");
    Expect(0, 68096, '\P{^Is_Script_Extensions=	 meroitic_Cursive}', "");
    Error('\p{Is_Scx: /a/	-merc}');
    Error('\P{Is_Scx: /a/	-merc}');
    Expect(1, 68095, '\p{Is_Scx=merc}', "");
    Expect(0, 68095, '\p{^Is_Scx=merc}', "");
    Expect(0, 68095, '\P{Is_Scx=merc}', "");
    Expect(1, 68095, '\P{^Is_Scx=merc}', "");
    Expect(0, 68096, '\p{Is_Scx=merc}', "");
    Expect(1, 68096, '\p{^Is_Scx=merc}', "");
    Expect(1, 68096, '\P{Is_Scx=merc}', "");
    Expect(0, 68096, '\P{^Is_Scx=merc}', "");
    Expect(1, 68095, '\p{Is_Scx=_	merc}', "");
    Expect(0, 68095, '\p{^Is_Scx=_	merc}', "");
    Expect(0, 68095, '\P{Is_Scx=_	merc}', "");
    Expect(1, 68095, '\P{^Is_Scx=_	merc}', "");
    Expect(0, 68096, '\p{Is_Scx=_	merc}', "");
    Expect(1, 68096, '\p{^Is_Scx=_	merc}', "");
    Expect(1, 68096, '\P{Is_Scx=_	merc}', "");
    Expect(0, 68096, '\P{^Is_Scx=_	merc}', "");
    Error('\p{Script_Extensions:		/a/Meroitic_hieroglyphs}');
    Error('\P{Script_Extensions:		/a/Meroitic_hieroglyphs}');
    Expect(1, 67999, '\p{Script_Extensions=:\AMeroitic_Hieroglyphs\z:}', "");;
    Expect(0, 68000, '\p{Script_Extensions=:\AMeroitic_Hieroglyphs\z:}', "");;
    Expect(1, 67999, '\p{Script_Extensions=meroitichieroglyphs}', "");
    Expect(0, 67999, '\p{^Script_Extensions=meroitichieroglyphs}', "");
    Expect(0, 67999, '\P{Script_Extensions=meroitichieroglyphs}', "");
    Expect(1, 67999, '\P{^Script_Extensions=meroitichieroglyphs}', "");
    Expect(0, 68000, '\p{Script_Extensions=meroitichieroglyphs}', "");
    Expect(1, 68000, '\p{^Script_Extensions=meroitichieroglyphs}', "");
    Expect(1, 68000, '\P{Script_Extensions=meroitichieroglyphs}', "");
    Expect(0, 68000, '\P{^Script_Extensions=meroitichieroglyphs}', "");
    Expect(1, 67999, '\p{Script_Extensions=:\Ameroitichieroglyphs\z:}', "");;
    Expect(0, 68000, '\p{Script_Extensions=:\Ameroitichieroglyphs\z:}', "");;
    Expect(1, 67999, '\p{Script_Extensions= 	Meroitic_Hieroglyphs}', "");
    Expect(0, 67999, '\p{^Script_Extensions= 	Meroitic_Hieroglyphs}', "");
    Expect(0, 67999, '\P{Script_Extensions= 	Meroitic_Hieroglyphs}', "");
    Expect(1, 67999, '\P{^Script_Extensions= 	Meroitic_Hieroglyphs}', "");
    Expect(0, 68000, '\p{Script_Extensions= 	Meroitic_Hieroglyphs}', "");
    Expect(1, 68000, '\p{^Script_Extensions= 	Meroitic_Hieroglyphs}', "");
    Expect(1, 68000, '\P{Script_Extensions= 	Meroitic_Hieroglyphs}', "");
    Expect(0, 68000, '\P{^Script_Extensions= 	Meroitic_Hieroglyphs}', "");
    Error('\p{Scx=_ Mero/a/}');
    Error('\P{Scx=_ Mero/a/}');
    Expect(1, 67999, '\p{Scx=:\AMero\z:}', "");;
    Expect(0, 68000, '\p{Scx=:\AMero\z:}', "");;
    Expect(1, 67999, '\p{Scx=mero}', "");
    Expect(0, 67999, '\p{^Scx=mero}', "");
    Expect(0, 67999, '\P{Scx=mero}', "");
    Expect(1, 67999, '\P{^Scx=mero}', "");
    Expect(0, 68000, '\p{Scx=mero}', "");
    Expect(1, 68000, '\p{^Scx=mero}', "");
    Expect(1, 68000, '\P{Scx=mero}', "");
    Expect(0, 68000, '\P{^Scx=mero}', "");
    Expect(1, 67999, '\p{Scx=:\Amero\z:}', "");;
    Expect(0, 68000, '\p{Scx=:\Amero\z:}', "");;
    Expect(1, 67999, '\p{Scx=	 Mero}', "");
    Expect(0, 67999, '\p{^Scx=	 Mero}', "");
    Expect(0, 67999, '\P{Scx=	 Mero}', "");
    Expect(1, 67999, '\P{^Scx=	 Mero}', "");
    Expect(0, 68000, '\p{Scx=	 Mero}', "");
    Expect(1, 68000, '\p{^Scx=	 Mero}', "");
    Expect(1, 68000, '\P{Scx=	 Mero}', "");
    Expect(0, 68000, '\P{^Scx=	 Mero}', "");
    Error('\p{Is_Script_Extensions=-/a/meroitic_hieroglyphs}');
    Error('\P{Is_Script_Extensions=-/a/meroitic_hieroglyphs}');
    Expect(1, 67999, '\p{Is_Script_Extensions=meroitichieroglyphs}', "");
    Expect(0, 67999, '\p{^Is_Script_Extensions=meroitichieroglyphs}', "");
    Expect(0, 67999, '\P{Is_Script_Extensions=meroitichieroglyphs}', "");
    Expect(1, 67999, '\P{^Is_Script_Extensions=meroitichieroglyphs}', "");
    Expect(0, 68000, '\p{Is_Script_Extensions=meroitichieroglyphs}', "");
    Expect(1, 68000, '\p{^Is_Script_Extensions=meroitichieroglyphs}', "");
    Expect(1, 68000, '\P{Is_Script_Extensions=meroitichieroglyphs}', "");
    Expect(0, 68000, '\P{^Is_Script_Extensions=meroitichieroglyphs}', "");
    Expect(1, 67999, '\p{Is_Script_Extensions= MEROITIC_Hieroglyphs}', "");
    Expect(0, 67999, '\p{^Is_Script_Extensions= MEROITIC_Hieroglyphs}', "");
    Expect(0, 67999, '\P{Is_Script_Extensions= MEROITIC_Hieroglyphs}', "");
    Expect(1, 67999, '\P{^Is_Script_Extensions= MEROITIC_Hieroglyphs}', "");
    Expect(0, 68000, '\p{Is_Script_Extensions= MEROITIC_Hieroglyphs}', "");
    Expect(1, 68000, '\p{^Is_Script_Extensions= MEROITIC_Hieroglyphs}', "");
    Expect(1, 68000, '\P{Is_Script_Extensions= MEROITIC_Hieroglyphs}', "");
    Expect(0, 68000, '\P{^Is_Script_Extensions= MEROITIC_Hieroglyphs}', "");
    Error('\p{Is_Scx=-:=mero}');
    Error('\P{Is_Scx=-:=mero}');
    Expect(1, 67999, '\p{Is_Scx=mero}', "");
    Expect(0, 67999, '\p{^Is_Scx=mero}', "");
    Expect(0, 67999, '\P{Is_Scx=mero}', "");
    Expect(1, 67999, '\P{^Is_Scx=mero}', "");
    Expect(0, 68000, '\p{Is_Scx=mero}', "");
    Expect(1, 68000, '\p{^Is_Scx=mero}', "");
    Expect(1, 68000, '\P{Is_Scx=mero}', "");
    Expect(0, 68000, '\P{^Is_Scx=mero}', "");
    Expect(1, 67999, '\p{Is_Scx=__Mero}', "");
    Expect(0, 67999, '\p{^Is_Scx=__Mero}', "");
    Expect(0, 67999, '\P{Is_Scx=__Mero}', "");
    Expect(1, 67999, '\P{^Is_Scx=__Mero}', "");
    Expect(0, 68000, '\p{Is_Scx=__Mero}', "");
    Expect(1, 68000, '\p{^Is_Scx=__Mero}', "");
    Expect(1, 68000, '\P{Is_Scx=__Mero}', "");
    Expect(0, 68000, '\P{^Is_Scx=__Mero}', "");
    Error('\p{Script_Extensions=-/a/malayalam}');
    Error('\P{Script_Extensions=-/a/malayalam}');
    Expect(1, 43058, '\p{Script_Extensions=:\AMalayalam\z:}', "");;
    Expect(0, 43059, '\p{Script_Extensions=:\AMalayalam\z:}', "");;
    Expect(1, 43058, '\p{Script_Extensions=malayalam}', "");
    Expect(0, 43058, '\p{^Script_Extensions=malayalam}', "");
    Expect(0, 43058, '\P{Script_Extensions=malayalam}', "");
    Expect(1, 43058, '\P{^Script_Extensions=malayalam}', "");
    Expect(0, 43059, '\p{Script_Extensions=malayalam}', "");
    Expect(1, 43059, '\p{^Script_Extensions=malayalam}', "");
    Expect(1, 43059, '\P{Script_Extensions=malayalam}', "");
    Expect(0, 43059, '\P{^Script_Extensions=malayalam}', "");
    Expect(1, 43058, '\p{Script_Extensions=:\Amalayalam\z:}', "");;
    Expect(0, 43059, '\p{Script_Extensions=:\Amalayalam\z:}', "");;
    Expect(1, 43058, '\p{Script_Extensions=-Malayalam}', "");
    Expect(0, 43058, '\p{^Script_Extensions=-Malayalam}', "");
    Expect(0, 43058, '\P{Script_Extensions=-Malayalam}', "");
    Expect(1, 43058, '\P{^Script_Extensions=-Malayalam}', "");
    Expect(0, 43059, '\p{Script_Extensions=-Malayalam}', "");
    Expect(1, 43059, '\p{^Script_Extensions=-Malayalam}', "");
    Expect(1, 43059, '\P{Script_Extensions=-Malayalam}', "");
    Expect(0, 43059, '\P{^Script_Extensions=-Malayalam}', "");
    Error('\p{Scx=-Mlym:=}');
    Error('\P{Scx=-Mlym:=}');
    Expect(1, 43058, '\p{Scx=:\AMlym\z:}', "");;
    Expect(0, 43059, '\p{Scx=:\AMlym\z:}', "");;
    Expect(1, 43058, '\p{Scx:	mlym}', "");
    Expect(0, 43058, '\p{^Scx:	mlym}', "");
    Expect(0, 43058, '\P{Scx:	mlym}', "");
    Expect(1, 43058, '\P{^Scx:	mlym}', "");
    Expect(0, 43059, '\p{Scx:	mlym}', "");
    Expect(1, 43059, '\p{^Scx:	mlym}', "");
    Expect(1, 43059, '\P{Scx:	mlym}', "");
    Expect(0, 43059, '\P{^Scx:	mlym}', "");
    Expect(1, 43058, '\p{Scx=:\Amlym\z:}', "");;
    Expect(0, 43059, '\p{Scx=:\Amlym\z:}', "");;
    Expect(1, 43058, '\p{Scx=	 Mlym}', "");
    Expect(0, 43058, '\p{^Scx=	 Mlym}', "");
    Expect(0, 43058, '\P{Scx=	 Mlym}', "");
    Expect(1, 43058, '\P{^Scx=	 Mlym}', "");
    Expect(0, 43059, '\p{Scx=	 Mlym}', "");
    Expect(1, 43059, '\p{^Scx=	 Mlym}', "");
    Expect(1, 43059, '\P{Scx=	 Mlym}', "");
    Expect(0, 43059, '\P{^Scx=	 Mlym}', "");
    Error('\p{Is_Script_Extensions= malayalam:=}');
    Error('\P{Is_Script_Extensions= malayalam:=}');
    Expect(1, 43058, '\p{Is_Script_Extensions=malayalam}', "");
    Expect(0, 43058, '\p{^Is_Script_Extensions=malayalam}', "");
    Expect(0, 43058, '\P{Is_Script_Extensions=malayalam}', "");
    Expect(1, 43058, '\P{^Is_Script_Extensions=malayalam}', "");
    Expect(0, 43059, '\p{Is_Script_Extensions=malayalam}', "");
    Expect(1, 43059, '\p{^Is_Script_Extensions=malayalam}', "");
    Expect(1, 43059, '\P{Is_Script_Extensions=malayalam}', "");
    Expect(0, 43059, '\P{^Is_Script_Extensions=malayalam}', "");
    Expect(1, 43058, '\p{Is_Script_Extensions:	-	malayalam}', "");
    Expect(0, 43058, '\p{^Is_Script_Extensions:	-	malayalam}', "");
    Expect(0, 43058, '\P{Is_Script_Extensions:	-	malayalam}', "");
    Expect(1, 43058, '\P{^Is_Script_Extensions:	-	malayalam}', "");
    Expect(0, 43059, '\p{Is_Script_Extensions:	-	malayalam}', "");
    Expect(1, 43059, '\p{^Is_Script_Extensions:	-	malayalam}', "");
    Expect(1, 43059, '\P{Is_Script_Extensions:	-	malayalam}', "");
    Expect(0, 43059, '\P{^Is_Script_Extensions:	-	malayalam}', "");
    Error('\p{Is_Scx=/a/_Mlym}');
    Error('\P{Is_Scx=/a/_Mlym}');
    Expect(1, 43058, '\p{Is_Scx=mlym}', "");
    Expect(0, 43058, '\p{^Is_Scx=mlym}', "");
    Expect(0, 43058, '\P{Is_Scx=mlym}', "");
    Expect(1, 43058, '\P{^Is_Scx=mlym}', "");
    Expect(0, 43059, '\p{Is_Scx=mlym}', "");
    Expect(1, 43059, '\p{^Is_Scx=mlym}', "");
    Expect(1, 43059, '\P{Is_Scx=mlym}', "");
    Expect(0, 43059, '\P{^Is_Scx=mlym}', "");
    Expect(1, 43058, '\p{Is_Scx=-MLYM}', "");
    Expect(0, 43058, '\p{^Is_Scx=-MLYM}', "");
    Expect(0, 43058, '\P{Is_Scx=-MLYM}', "");
    Expect(1, 43058, '\P{^Is_Scx=-MLYM}', "");
    Expect(0, 43059, '\p{Is_Scx=-MLYM}', "");
    Expect(1, 43059, '\p{^Is_Scx=-MLYM}', "");
    Expect(1, 43059, '\P{Is_Scx=-MLYM}', "");
    Expect(0, 43059, '\P{^Is_Scx=-MLYM}', "");
    Error('\p{Script_Extensions= /a/modi}');
    Error('\P{Script_Extensions= /a/modi}');
    Expect(1, 71257, '\p{Script_Extensions=:\AModi\z:}', "");;
    Expect(0, 71258, '\p{Script_Extensions=:\AModi\z:}', "");;
    Expect(1, 71257, '\p{Script_Extensions=modi}', "");
    Expect(0, 71257, '\p{^Script_Extensions=modi}', "");
    Expect(0, 71257, '\P{Script_Extensions=modi}', "");
    Expect(1, 71257, '\P{^Script_Extensions=modi}', "");
    Expect(0, 71258, '\p{Script_Extensions=modi}', "");
    Expect(1, 71258, '\p{^Script_Extensions=modi}', "");
    Expect(1, 71258, '\P{Script_Extensions=modi}', "");
    Expect(0, 71258, '\P{^Script_Extensions=modi}', "");
    Expect(1, 71257, '\p{Script_Extensions=:\Amodi\z:}', "");;
    Expect(0, 71258, '\p{Script_Extensions=:\Amodi\z:}', "");;
    Error('\p{Scx=:=		Modi}');
    Error('\P{Scx=:=		Modi}');
    Expect(1, 71257, '\p{Scx=:\AModi\z:}', "");;
    Expect(0, 71258, '\p{Scx=:\AModi\z:}', "");;
    Expect(1, 71257, '\p{Scx=modi}', "");
    Expect(0, 71257, '\p{^Scx=modi}', "");
    Expect(0, 71257, '\P{Scx=modi}', "");
    Expect(1, 71257, '\P{^Scx=modi}', "");
    Expect(0, 71258, '\p{Scx=modi}', "");
    Expect(1, 71258, '\p{^Scx=modi}', "");
    Expect(1, 71258, '\P{Scx=modi}', "");
    Expect(0, 71258, '\P{^Scx=modi}', "");
    Expect(1, 71257, '\p{Scx=:\Amodi\z:}', "");;
    Expect(0, 71258, '\p{Scx=:\Amodi\z:}', "");;
    Expect(1, 71257, '\p{Scx=	MODI}', "");
    Expect(0, 71257, '\p{^Scx=	MODI}', "");
    Expect(0, 71257, '\P{Scx=	MODI}', "");
    Expect(1, 71257, '\P{^Scx=	MODI}', "");
    Expect(0, 71258, '\p{Scx=	MODI}', "");
    Expect(1, 71258, '\p{^Scx=	MODI}', "");
    Expect(1, 71258, '\P{Scx=	MODI}', "");
    Expect(0, 71258, '\P{^Scx=	MODI}', "");
    Error('\p{Is_Script_Extensions=-:=Modi}');
    Error('\P{Is_Script_Extensions=-:=Modi}');
    Expect(1, 71257, '\p{Is_Script_Extensions=modi}', "");
    Expect(0, 71257, '\p{^Is_Script_Extensions=modi}', "");
    Expect(0, 71257, '\P{Is_Script_Extensions=modi}', "");
    Expect(1, 71257, '\P{^Is_Script_Extensions=modi}', "");
    Expect(0, 71258, '\p{Is_Script_Extensions=modi}', "");
    Expect(1, 71258, '\p{^Is_Script_Extensions=modi}', "");
    Expect(1, 71258, '\P{Is_Script_Extensions=modi}', "");
    Expect(0, 71258, '\P{^Is_Script_Extensions=modi}', "");
    Expect(1, 71257, '\p{Is_Script_Extensions=	_Modi}', "");
    Expect(0, 71257, '\p{^Is_Script_Extensions=	_Modi}', "");
    Expect(0, 71257, '\P{Is_Script_Extensions=	_Modi}', "");
    Expect(1, 71257, '\P{^Is_Script_Extensions=	_Modi}', "");
    Expect(0, 71258, '\p{Is_Script_Extensions=	_Modi}', "");
    Expect(1, 71258, '\p{^Is_Script_Extensions=	_Modi}', "");
    Expect(1, 71258, '\P{Is_Script_Extensions=	_Modi}', "");
    Expect(0, 71258, '\P{^Is_Script_Extensions=	_Modi}', "");
    Error('\p{Is_Scx:- Modi:=}');
    Error('\P{Is_Scx:- Modi:=}');
    Expect(1, 71257, '\p{Is_Scx:modi}', "");
    Expect(0, 71257, '\p{^Is_Scx:modi}', "");
    Expect(0, 71257, '\P{Is_Scx:modi}', "");
    Expect(1, 71257, '\P{^Is_Scx:modi}', "");
    Expect(0, 71258, '\p{Is_Scx:modi}', "");
    Expect(1, 71258, '\p{^Is_Scx:modi}', "");
    Expect(1, 71258, '\P{Is_Scx:modi}', "");
    Expect(0, 71258, '\P{^Is_Scx:modi}', "");
    Expect(1, 71257, '\p{Is_Scx=_ MODI}', "");
    Expect(0, 71257, '\p{^Is_Scx=_ MODI}', "");
    Expect(0, 71257, '\P{Is_Scx=_ MODI}', "");
    Expect(1, 71257, '\P{^Is_Scx=_ MODI}', "");
    Expect(0, 71258, '\p{Is_Scx=_ MODI}', "");
    Expect(1, 71258, '\p{^Is_Scx=_ MODI}', "");
    Expect(1, 71258, '\P{Is_Scx=_ MODI}', "");
    Expect(0, 71258, '\P{^Is_Scx=_ MODI}', "");
    Error('\p{Script_Extensions=	:=MONGOLIAN}');
    Error('\P{Script_Extensions=	:=MONGOLIAN}');
    Expect(1, 71276, '\p{Script_Extensions=:\AMongolian\z:}', "");;
    Expect(0, 71277, '\p{Script_Extensions=:\AMongolian\z:}', "");;
    Expect(1, 71276, '\p{Script_Extensions=mongolian}', "");
    Expect(0, 71276, '\p{^Script_Extensions=mongolian}', "");
    Expect(0, 71276, '\P{Script_Extensions=mongolian}', "");
    Expect(1, 71276, '\P{^Script_Extensions=mongolian}', "");
    Expect(0, 71277, '\p{Script_Extensions=mongolian}', "");
    Expect(1, 71277, '\p{^Script_Extensions=mongolian}', "");
    Expect(1, 71277, '\P{Script_Extensions=mongolian}', "");
    Expect(0, 71277, '\P{^Script_Extensions=mongolian}', "");
    Expect(1, 71276, '\p{Script_Extensions=:\Amongolian\z:}', "");;
    Expect(0, 71277, '\p{Script_Extensions=:\Amongolian\z:}', "");;
    Expect(1, 71276, '\p{Script_Extensions= -Mongolian}', "");
    Expect(0, 71276, '\p{^Script_Extensions= -Mongolian}', "");
    Expect(0, 71276, '\P{Script_Extensions= -Mongolian}', "");
    Expect(1, 71276, '\P{^Script_Extensions= -Mongolian}', "");
    Expect(0, 71277, '\p{Script_Extensions= -Mongolian}', "");
    Expect(1, 71277, '\p{^Script_Extensions= -Mongolian}', "");
    Expect(1, 71277, '\P{Script_Extensions= -Mongolian}', "");
    Expect(0, 71277, '\P{^Script_Extensions= -Mongolian}', "");
    Error('\p{Scx=:=	-MONG}');
    Error('\P{Scx=:=	-MONG}');
    Expect(1, 71276, '\p{Scx=:\AMong\z:}', "");;
    Expect(0, 71277, '\p{Scx=:\AMong\z:}', "");;
    Expect(1, 71276, '\p{Scx=mong}', "");
    Expect(0, 71276, '\p{^Scx=mong}', "");
    Expect(0, 71276, '\P{Scx=mong}', "");
    Expect(1, 71276, '\P{^Scx=mong}', "");
    Expect(0, 71277, '\p{Scx=mong}', "");
    Expect(1, 71277, '\p{^Scx=mong}', "");
    Expect(1, 71277, '\P{Scx=mong}', "");
    Expect(0, 71277, '\P{^Scx=mong}', "");
    Expect(1, 71276, '\p{Scx=:\Among\z:}', "");;
    Expect(0, 71277, '\p{Scx=:\Among\z:}', "");;
    Expect(1, 71276, '\p{Scx=_ MONG}', "");
    Expect(0, 71276, '\p{^Scx=_ MONG}', "");
    Expect(0, 71276, '\P{Scx=_ MONG}', "");
    Expect(1, 71276, '\P{^Scx=_ MONG}', "");
    Expect(0, 71277, '\p{Scx=_ MONG}', "");
    Expect(1, 71277, '\p{^Scx=_ MONG}', "");
    Expect(1, 71277, '\P{Scx=_ MONG}', "");
    Expect(0, 71277, '\P{^Scx=_ MONG}', "");
    Error('\p{Is_Script_Extensions=  Mongolian/a/}');
    Error('\P{Is_Script_Extensions=  Mongolian/a/}');
    Expect(1, 71276, '\p{Is_Script_Extensions=mongolian}', "");
    Expect(0, 71276, '\p{^Is_Script_Extensions=mongolian}', "");
    Expect(0, 71276, '\P{Is_Script_Extensions=mongolian}', "");
    Expect(1, 71276, '\P{^Is_Script_Extensions=mongolian}', "");
    Expect(0, 71277, '\p{Is_Script_Extensions=mongolian}', "");
    Expect(1, 71277, '\p{^Is_Script_Extensions=mongolian}', "");
    Expect(1, 71277, '\P{Is_Script_Extensions=mongolian}', "");
    Expect(0, 71277, '\P{^Is_Script_Extensions=mongolian}', "");
    Expect(1, 71276, '\p{Is_Script_Extensions: 	_MONGOLIAN}', "");
    Expect(0, 71276, '\p{^Is_Script_Extensions: 	_MONGOLIAN}', "");
    Expect(0, 71276, '\P{Is_Script_Extensions: 	_MONGOLIAN}', "");
    Expect(1, 71276, '\P{^Is_Script_Extensions: 	_MONGOLIAN}', "");
    Expect(0, 71277, '\p{Is_Script_Extensions: 	_MONGOLIAN}', "");
    Expect(1, 71277, '\p{^Is_Script_Extensions: 	_MONGOLIAN}', "");
    Expect(1, 71277, '\P{Is_Script_Extensions: 	_MONGOLIAN}', "");
    Expect(0, 71277, '\P{^Is_Script_Extensions: 	_MONGOLIAN}', "");
    Error('\p{Is_Scx=:=MONG}');
    Error('\P{Is_Scx=:=MONG}');
    Expect(1, 71276, '\p{Is_Scx=mong}', "");
    Expect(0, 71276, '\p{^Is_Scx=mong}', "");
    Expect(0, 71276, '\P{Is_Scx=mong}', "");
    Expect(1, 71276, '\P{^Is_Scx=mong}', "");
    Expect(0, 71277, '\p{Is_Scx=mong}', "");
    Expect(1, 71277, '\p{^Is_Scx=mong}', "");
    Expect(1, 71277, '\P{Is_Scx=mong}', "");
    Expect(0, 71277, '\P{^Is_Scx=mong}', "");
    Expect(1, 71276, '\p{Is_Scx=_mong}', "");
    Expect(0, 71276, '\p{^Is_Scx=_mong}', "");
    Expect(0, 71276, '\P{Is_Scx=_mong}', "");
    Expect(1, 71276, '\P{^Is_Scx=_mong}', "");
    Expect(0, 71277, '\p{Is_Scx=_mong}', "");
    Expect(1, 71277, '\p{^Is_Scx=_mong}', "");
    Expect(1, 71277, '\P{Is_Scx=_mong}', "");
    Expect(0, 71277, '\P{^Is_Scx=_mong}', "");
    Error('\p{Script_Extensions:	/a/ 	Mro}');
    Error('\P{Script_Extensions:	/a/ 	Mro}');
    Expect(1, 92783, '\p{Script_Extensions=:\AMro\z:}', "");;
    Expect(0, 92784, '\p{Script_Extensions=:\AMro\z:}', "");;
    Expect(1, 92783, '\p{Script_Extensions=mro}', "");
    Expect(0, 92783, '\p{^Script_Extensions=mro}', "");
    Expect(0, 92783, '\P{Script_Extensions=mro}', "");
    Expect(1, 92783, '\P{^Script_Extensions=mro}', "");
    Expect(0, 92784, '\p{Script_Extensions=mro}', "");
    Expect(1, 92784, '\p{^Script_Extensions=mro}', "");
    Expect(1, 92784, '\P{Script_Extensions=mro}', "");
    Expect(0, 92784, '\P{^Script_Extensions=mro}', "");
    Expect(1, 92783, '\p{Script_Extensions=:\Amro\z:}', "");;
    Expect(0, 92784, '\p{Script_Extensions=:\Amro\z:}', "");;
    Expect(1, 92783, '\p{Script_Extensions: 		Mro}', "");
    Expect(0, 92783, '\p{^Script_Extensions: 		Mro}', "");
    Expect(0, 92783, '\P{Script_Extensions: 		Mro}', "");
    Expect(1, 92783, '\P{^Script_Extensions: 		Mro}', "");
    Expect(0, 92784, '\p{Script_Extensions: 		Mro}', "");
    Expect(1, 92784, '\p{^Script_Extensions: 		Mro}', "");
    Expect(1, 92784, '\P{Script_Extensions: 		Mro}', "");
    Expect(0, 92784, '\P{^Script_Extensions: 		Mro}', "");
    Error('\p{Scx=	/a/Mroo}');
    Error('\P{Scx=	/a/Mroo}');
    Expect(1, 92783, '\p{Scx=:\AMroo\z:}', "");;
    Expect(0, 92784, '\p{Scx=:\AMroo\z:}', "");;
    Expect(1, 92783, '\p{Scx=mroo}', "");
    Expect(0, 92783, '\p{^Scx=mroo}', "");
    Expect(0, 92783, '\P{Scx=mroo}', "");
    Expect(1, 92783, '\P{^Scx=mroo}', "");
    Expect(0, 92784, '\p{Scx=mroo}', "");
    Expect(1, 92784, '\p{^Scx=mroo}', "");
    Expect(1, 92784, '\P{Scx=mroo}', "");
    Expect(0, 92784, '\P{^Scx=mroo}', "");
    Expect(1, 92783, '\p{Scx=:\Amroo\z:}', "");;
    Expect(0, 92784, '\p{Scx=:\Amroo\z:}', "");;
    Expect(1, 92783, '\p{Scx=-Mroo}', "");
    Expect(0, 92783, '\p{^Scx=-Mroo}', "");
    Expect(0, 92783, '\P{Scx=-Mroo}', "");
    Expect(1, 92783, '\P{^Scx=-Mroo}', "");
    Expect(0, 92784, '\p{Scx=-Mroo}', "");
    Expect(1, 92784, '\p{^Scx=-Mroo}', "");
    Expect(1, 92784, '\P{Scx=-Mroo}', "");
    Expect(0, 92784, '\P{^Scx=-Mroo}', "");
    Error('\p{Is_Script_Extensions=/a/MRO}');
    Error('\P{Is_Script_Extensions=/a/MRO}');
    Expect(1, 92783, '\p{Is_Script_Extensions=mro}', "");
    Expect(0, 92783, '\p{^Is_Script_Extensions=mro}', "");
    Expect(0, 92783, '\P{Is_Script_Extensions=mro}', "");
    Expect(1, 92783, '\P{^Is_Script_Extensions=mro}', "");
    Expect(0, 92784, '\p{Is_Script_Extensions=mro}', "");
    Expect(1, 92784, '\p{^Is_Script_Extensions=mro}', "");
    Expect(1, 92784, '\P{Is_Script_Extensions=mro}', "");
    Expect(0, 92784, '\P{^Is_Script_Extensions=mro}', "");
    Expect(1, 92783, '\p{Is_Script_Extensions= 	MRO}', "");
    Expect(0, 92783, '\p{^Is_Script_Extensions= 	MRO}', "");
    Expect(0, 92783, '\P{Is_Script_Extensions= 	MRO}', "");
    Expect(1, 92783, '\P{^Is_Script_Extensions= 	MRO}', "");
    Expect(0, 92784, '\p{Is_Script_Extensions= 	MRO}', "");
    Expect(1, 92784, '\p{^Is_Script_Extensions= 	MRO}', "");
    Expect(1, 92784, '\P{Is_Script_Extensions= 	MRO}', "");
    Expect(0, 92784, '\P{^Is_Script_Extensions= 	MRO}', "");
    Error('\p{Is_Scx=:=_MROO}');
    Error('\P{Is_Scx=:=_MROO}');
    Expect(1, 92783, '\p{Is_Scx:   mroo}', "");
    Expect(0, 92783, '\p{^Is_Scx:   mroo}', "");
    Expect(0, 92783, '\P{Is_Scx:   mroo}', "");
    Expect(1, 92783, '\P{^Is_Scx:   mroo}', "");
    Expect(0, 92784, '\p{Is_Scx:   mroo}', "");
    Expect(1, 92784, '\p{^Is_Scx:   mroo}', "");
    Expect(1, 92784, '\P{Is_Scx:   mroo}', "");
    Expect(0, 92784, '\P{^Is_Scx:   mroo}', "");
    Expect(1, 92783, '\p{Is_Scx=	Mroo}', "");
    Expect(0, 92783, '\p{^Is_Scx=	Mroo}', "");
    Expect(0, 92783, '\P{Is_Scx=	Mroo}', "");
    Expect(1, 92783, '\P{^Is_Scx=	Mroo}', "");
    Expect(0, 92784, '\p{Is_Scx=	Mroo}', "");
    Expect(1, 92784, '\p{^Is_Scx=	Mroo}', "");
    Expect(1, 92784, '\P{Is_Scx=	Mroo}', "");
    Expect(0, 92784, '\P{^Is_Scx=	Mroo}', "");
    Error('\p{Script_Extensions=:=-_Meetei_MAYEK}');
    Error('\P{Script_Extensions=:=-_Meetei_MAYEK}');
    Expect(1, 44025, '\p{Script_Extensions=:\AMeetei_Mayek\z:}', "");;
    Expect(0, 44026, '\p{Script_Extensions=:\AMeetei_Mayek\z:}', "");;
    Expect(1, 44025, '\p{Script_Extensions=meeteimayek}', "");
    Expect(0, 44025, '\p{^Script_Extensions=meeteimayek}', "");
    Expect(0, 44025, '\P{Script_Extensions=meeteimayek}', "");
    Expect(1, 44025, '\P{^Script_Extensions=meeteimayek}', "");
    Expect(0, 44026, '\p{Script_Extensions=meeteimayek}', "");
    Expect(1, 44026, '\p{^Script_Extensions=meeteimayek}', "");
    Expect(1, 44026, '\P{Script_Extensions=meeteimayek}', "");
    Expect(0, 44026, '\P{^Script_Extensions=meeteimayek}', "");
    Expect(1, 44025, '\p{Script_Extensions=:\Ameeteimayek\z:}', "");;
    Expect(0, 44026, '\p{Script_Extensions=:\Ameeteimayek\z:}', "");;
    Expect(1, 44025, '\p{Script_Extensions:			meetei_Mayek}', "");
    Expect(0, 44025, '\p{^Script_Extensions:			meetei_Mayek}', "");
    Expect(0, 44025, '\P{Script_Extensions:			meetei_Mayek}', "");
    Expect(1, 44025, '\P{^Script_Extensions:			meetei_Mayek}', "");
    Expect(0, 44026, '\p{Script_Extensions:			meetei_Mayek}', "");
    Expect(1, 44026, '\p{^Script_Extensions:			meetei_Mayek}', "");
    Expect(1, 44026, '\P{Script_Extensions:			meetei_Mayek}', "");
    Expect(0, 44026, '\P{^Script_Extensions:			meetei_Mayek}', "");
    Error('\p{Scx=/a/mtei}');
    Error('\P{Scx=/a/mtei}');
    Expect(1, 44025, '\p{Scx=:\AMtei\z:}', "");;
    Expect(0, 44026, '\p{Scx=:\AMtei\z:}', "");;
    Expect(1, 44025, '\p{Scx=mtei}', "");
    Expect(0, 44025, '\p{^Scx=mtei}', "");
    Expect(0, 44025, '\P{Scx=mtei}', "");
    Expect(1, 44025, '\P{^Scx=mtei}', "");
    Expect(0, 44026, '\p{Scx=mtei}', "");
    Expect(1, 44026, '\p{^Scx=mtei}', "");
    Expect(1, 44026, '\P{Scx=mtei}', "");
    Expect(0, 44026, '\P{^Scx=mtei}', "");
    Expect(1, 44025, '\p{Scx=:\Amtei\z:}', "");;
    Expect(0, 44026, '\p{Scx=:\Amtei\z:}', "");;
    Expect(1, 44025, '\p{Scx=_ MTEI}', "");
    Expect(0, 44025, '\p{^Scx=_ MTEI}', "");
    Expect(0, 44025, '\P{Scx=_ MTEI}', "");
    Expect(1, 44025, '\P{^Scx=_ MTEI}', "");
    Expect(0, 44026, '\p{Scx=_ MTEI}', "");
    Expect(1, 44026, '\p{^Scx=_ MTEI}', "");
    Expect(1, 44026, '\P{Scx=_ MTEI}', "");
    Expect(0, 44026, '\P{^Scx=_ MTEI}', "");
    Error('\p{Is_Script_Extensions= _MEETEI_mayek:=}');
    Error('\P{Is_Script_Extensions= _MEETEI_mayek:=}');
    Expect(1, 44025, '\p{Is_Script_Extensions=meeteimayek}', "");
    Expect(0, 44025, '\p{^Is_Script_Extensions=meeteimayek}', "");
    Expect(0, 44025, '\P{Is_Script_Extensions=meeteimayek}', "");
    Expect(1, 44025, '\P{^Is_Script_Extensions=meeteimayek}', "");
    Expect(0, 44026, '\p{Is_Script_Extensions=meeteimayek}', "");
    Expect(1, 44026, '\p{^Is_Script_Extensions=meeteimayek}', "");
    Expect(1, 44026, '\P{Is_Script_Extensions=meeteimayek}', "");
    Expect(0, 44026, '\P{^Is_Script_Extensions=meeteimayek}', "");
    Expect(1, 44025, '\p{Is_Script_Extensions= MEETEI_mayek}', "");
    Expect(0, 44025, '\p{^Is_Script_Extensions= MEETEI_mayek}', "");
    Expect(0, 44025, '\P{Is_Script_Extensions= MEETEI_mayek}', "");
    Expect(1, 44025, '\P{^Is_Script_Extensions= MEETEI_mayek}', "");
    Expect(0, 44026, '\p{Is_Script_Extensions= MEETEI_mayek}', "");
    Expect(1, 44026, '\p{^Is_Script_Extensions= MEETEI_mayek}', "");
    Expect(1, 44026, '\P{Is_Script_Extensions= MEETEI_mayek}', "");
    Expect(0, 44026, '\P{^Is_Script_Extensions= MEETEI_mayek}', "");
    Error('\p{Is_Scx=/a/_	Mtei}');
    Error('\P{Is_Scx=/a/_	Mtei}');
    Expect(1, 44025, '\p{Is_Scx=mtei}', "");
    Expect(0, 44025, '\p{^Is_Scx=mtei}', "");
    Expect(0, 44025, '\P{Is_Scx=mtei}', "");
    Expect(1, 44025, '\P{^Is_Scx=mtei}', "");
    Expect(0, 44026, '\p{Is_Scx=mtei}', "");
    Expect(1, 44026, '\p{^Is_Scx=mtei}', "");
    Expect(1, 44026, '\P{Is_Scx=mtei}', "");
    Expect(0, 44026, '\P{^Is_Scx=mtei}', "");
    Expect(1, 44025, '\p{Is_Scx=	-Mtei}', "");
    Expect(0, 44025, '\p{^Is_Scx=	-Mtei}', "");
    Expect(0, 44025, '\P{Is_Scx=	-Mtei}', "");
    Expect(1, 44025, '\P{^Is_Scx=	-Mtei}', "");
    Expect(0, 44026, '\p{Is_Scx=	-Mtei}', "");
    Expect(1, 44026, '\p{^Is_Scx=	-Mtei}', "");
    Expect(1, 44026, '\P{Is_Scx=	-Mtei}', "");
    Expect(0, 44026, '\P{^Is_Scx=	-Mtei}', "");
    Error('\p{Script_Extensions=	/a/MULTANI}');
    Error('\P{Script_Extensions=	/a/MULTANI}');
    Expect(1, 70313, '\p{Script_Extensions=:\AMultani\z:}', "");;
    Expect(0, 70314, '\p{Script_Extensions=:\AMultani\z:}', "");;
    Expect(1, 70313, '\p{Script_Extensions: multani}', "");
    Expect(0, 70313, '\p{^Script_Extensions: multani}', "");
    Expect(0, 70313, '\P{Script_Extensions: multani}', "");
    Expect(1, 70313, '\P{^Script_Extensions: multani}', "");
    Expect(0, 70314, '\p{Script_Extensions: multani}', "");
    Expect(1, 70314, '\p{^Script_Extensions: multani}', "");
    Expect(1, 70314, '\P{Script_Extensions: multani}', "");
    Expect(0, 70314, '\P{^Script_Extensions: multani}', "");
    Expect(1, 70313, '\p{Script_Extensions=:\Amultani\z:}', "");;
    Expect(0, 70314, '\p{Script_Extensions=:\Amultani\z:}', "");;
    Expect(1, 70313, '\p{Script_Extensions:	 MULTANI}', "");
    Expect(0, 70313, '\p{^Script_Extensions:	 MULTANI}', "");
    Expect(0, 70313, '\P{Script_Extensions:	 MULTANI}', "");
    Expect(1, 70313, '\P{^Script_Extensions:	 MULTANI}', "");
    Expect(0, 70314, '\p{Script_Extensions:	 MULTANI}', "");
    Expect(1, 70314, '\p{^Script_Extensions:	 MULTANI}', "");
    Expect(1, 70314, '\P{Script_Extensions:	 MULTANI}', "");
    Expect(0, 70314, '\P{^Script_Extensions:	 MULTANI}', "");
    Error('\p{Scx=/a/	Mult}');
    Error('\P{Scx=/a/	Mult}');
    Expect(1, 70313, '\p{Scx=:\AMult\z:}', "");;
    Expect(0, 70314, '\p{Scx=:\AMult\z:}', "");;
    Expect(1, 70313, '\p{Scx=mult}', "");
    Expect(0, 70313, '\p{^Scx=mult}', "");
    Expect(0, 70313, '\P{Scx=mult}', "");
    Expect(1, 70313, '\P{^Scx=mult}', "");
    Expect(0, 70314, '\p{Scx=mult}', "");
    Expect(1, 70314, '\p{^Scx=mult}', "");
    Expect(1, 70314, '\P{Scx=mult}', "");
    Expect(0, 70314, '\P{^Scx=mult}', "");
    Expect(1, 70313, '\p{Scx=:\Amult\z:}', "");;
    Expect(0, 70314, '\p{Scx=:\Amult\z:}', "");;
    Expect(1, 70313, '\p{Scx=-_MULT}', "");
    Expect(0, 70313, '\p{^Scx=-_MULT}', "");
    Expect(0, 70313, '\P{Scx=-_MULT}', "");
    Expect(1, 70313, '\P{^Scx=-_MULT}', "");
    Expect(0, 70314, '\p{Scx=-_MULT}', "");
    Expect(1, 70314, '\p{^Scx=-_MULT}', "");
    Expect(1, 70314, '\P{Scx=-_MULT}', "");
    Expect(0, 70314, '\P{^Scx=-_MULT}', "");
    Error('\p{Is_Script_Extensions:/a/ Multani}');
    Error('\P{Is_Script_Extensions:/a/ Multani}');
    Expect(1, 70313, '\p{Is_Script_Extensions=multani}', "");
    Expect(0, 70313, '\p{^Is_Script_Extensions=multani}', "");
    Expect(0, 70313, '\P{Is_Script_Extensions=multani}', "");
    Expect(1, 70313, '\P{^Is_Script_Extensions=multani}', "");
    Expect(0, 70314, '\p{Is_Script_Extensions=multani}', "");
    Expect(1, 70314, '\p{^Is_Script_Extensions=multani}', "");
    Expect(1, 70314, '\P{Is_Script_Extensions=multani}', "");
    Expect(0, 70314, '\P{^Is_Script_Extensions=multani}', "");
    Error('\p{Is_Scx=- MULT/a/}');
    Error('\P{Is_Scx=- MULT/a/}');
    Expect(1, 70313, '\p{Is_Scx=mult}', "");
    Expect(0, 70313, '\p{^Is_Scx=mult}', "");
    Expect(0, 70313, '\P{Is_Scx=mult}', "");
    Expect(1, 70313, '\P{^Is_Scx=mult}', "");
    Expect(0, 70314, '\p{Is_Scx=mult}', "");
    Expect(1, 70314, '\p{^Is_Scx=mult}', "");
    Expect(1, 70314, '\P{Is_Scx=mult}', "");
    Expect(0, 70314, '\P{^Is_Scx=mult}', "");
    Expect(1, 70313, '\p{Is_Scx:   - Mult}', "");
    Expect(0, 70313, '\p{^Is_Scx:   - Mult}', "");
    Expect(0, 70313, '\P{Is_Scx:   - Mult}', "");
    Expect(1, 70313, '\P{^Is_Scx:   - Mult}', "");
    Expect(0, 70314, '\p{Is_Scx:   - Mult}', "");
    Expect(1, 70314, '\p{^Is_Scx:   - Mult}', "");
    Expect(1, 70314, '\P{Is_Scx:   - Mult}', "");
    Expect(0, 70314, '\P{^Is_Scx:   - Mult}', "");
    Error('\p{Script_Extensions=/a/Myanmar}');
    Error('\P{Script_Extensions=/a/Myanmar}');
    Expect(1, 43647, '\p{Script_Extensions=:\AMyanmar\z:}', "");;
    Expect(0, 43648, '\p{Script_Extensions=:\AMyanmar\z:}', "");;
    Expect(1, 43647, '\p{Script_Extensions=myanmar}', "");
    Expect(0, 43647, '\p{^Script_Extensions=myanmar}', "");
    Expect(0, 43647, '\P{Script_Extensions=myanmar}', "");
    Expect(1, 43647, '\P{^Script_Extensions=myanmar}', "");
    Expect(0, 43648, '\p{Script_Extensions=myanmar}', "");
    Expect(1, 43648, '\p{^Script_Extensions=myanmar}', "");
    Expect(1, 43648, '\P{Script_Extensions=myanmar}', "");
    Expect(0, 43648, '\P{^Script_Extensions=myanmar}', "");
    Expect(1, 43647, '\p{Script_Extensions=:\Amyanmar\z:}', "");;
    Expect(0, 43648, '\p{Script_Extensions=:\Amyanmar\z:}', "");;
    Expect(1, 43647, '\p{Script_Extensions=  Myanmar}', "");
    Expect(0, 43647, '\p{^Script_Extensions=  Myanmar}', "");
    Expect(0, 43647, '\P{Script_Extensions=  Myanmar}', "");
    Expect(1, 43647, '\P{^Script_Extensions=  Myanmar}', "");
    Expect(0, 43648, '\p{Script_Extensions=  Myanmar}', "");
    Expect(1, 43648, '\p{^Script_Extensions=  Myanmar}', "");
    Expect(1, 43648, '\P{Script_Extensions=  Myanmar}', "");
    Expect(0, 43648, '\P{^Script_Extensions=  Myanmar}', "");
    Error('\p{Scx=:=	_MYMR}');
    Error('\P{Scx=:=	_MYMR}');
    Expect(1, 43647, '\p{Scx=:\AMymr\z:}', "");;
    Expect(0, 43648, '\p{Scx=:\AMymr\z:}', "");;
    Expect(1, 43647, '\p{Scx=mymr}', "");
    Expect(0, 43647, '\p{^Scx=mymr}', "");
    Expect(0, 43647, '\P{Scx=mymr}', "");
    Expect(1, 43647, '\P{^Scx=mymr}', "");
    Expect(0, 43648, '\p{Scx=mymr}', "");
    Expect(1, 43648, '\p{^Scx=mymr}', "");
    Expect(1, 43648, '\P{Scx=mymr}', "");
    Expect(0, 43648, '\P{^Scx=mymr}', "");
    Expect(1, 43647, '\p{Scx=:\Amymr\z:}', "");;
    Expect(0, 43648, '\p{Scx=:\Amymr\z:}', "");;
    Expect(1, 43647, '\p{Scx=--Mymr}', "");
    Expect(0, 43647, '\p{^Scx=--Mymr}', "");
    Expect(0, 43647, '\P{Scx=--Mymr}', "");
    Expect(1, 43647, '\P{^Scx=--Mymr}', "");
    Expect(0, 43648, '\p{Scx=--Mymr}', "");
    Expect(1, 43648, '\p{^Scx=--Mymr}', "");
    Expect(1, 43648, '\P{Scx=--Mymr}', "");
    Expect(0, 43648, '\P{^Scx=--Mymr}', "");
    Error('\p{Is_Script_Extensions= -Myanmar:=}');
    Error('\P{Is_Script_Extensions= -Myanmar:=}');
    Expect(1, 43647, '\p{Is_Script_Extensions=myanmar}', "");
    Expect(0, 43647, '\p{^Is_Script_Extensions=myanmar}', "");
    Expect(0, 43647, '\P{Is_Script_Extensions=myanmar}', "");
    Expect(1, 43647, '\P{^Is_Script_Extensions=myanmar}', "");
    Expect(0, 43648, '\p{Is_Script_Extensions=myanmar}', "");
    Expect(1, 43648, '\p{^Is_Script_Extensions=myanmar}', "");
    Expect(1, 43648, '\P{Is_Script_Extensions=myanmar}', "");
    Expect(0, 43648, '\P{^Is_Script_Extensions=myanmar}', "");
    Expect(1, 43647, '\p{Is_Script_Extensions:   --Myanmar}', "");
    Expect(0, 43647, '\p{^Is_Script_Extensions:   --Myanmar}', "");
    Expect(0, 43647, '\P{Is_Script_Extensions:   --Myanmar}', "");
    Expect(1, 43647, '\P{^Is_Script_Extensions:   --Myanmar}', "");
    Expect(0, 43648, '\p{Is_Script_Extensions:   --Myanmar}', "");
    Expect(1, 43648, '\p{^Is_Script_Extensions:   --Myanmar}', "");
    Expect(1, 43648, '\P{Is_Script_Extensions:   --Myanmar}', "");
    Expect(0, 43648, '\P{^Is_Script_Extensions:   --Myanmar}', "");
    Error('\p{Is_Scx=MYMR/a/}');
    Error('\P{Is_Scx=MYMR/a/}');
    Expect(1, 43647, '\p{Is_Scx=mymr}', "");
    Expect(0, 43647, '\p{^Is_Scx=mymr}', "");
    Expect(0, 43647, '\P{Is_Scx=mymr}', "");
    Expect(1, 43647, '\P{^Is_Scx=mymr}', "");
    Expect(0, 43648, '\p{Is_Scx=mymr}', "");
    Expect(1, 43648, '\p{^Is_Scx=mymr}', "");
    Expect(1, 43648, '\P{Is_Scx=mymr}', "");
    Expect(0, 43648, '\P{^Is_Scx=mymr}', "");
    Expect(1, 43647, '\p{Is_Scx= -MYMR}', "");
    Expect(0, 43647, '\p{^Is_Scx= -MYMR}', "");
    Expect(0, 43647, '\P{Is_Scx= -MYMR}', "");
    Expect(1, 43647, '\P{^Is_Scx= -MYMR}', "");
    Expect(0, 43648, '\p{Is_Scx= -MYMR}', "");
    Expect(1, 43648, '\p{^Is_Scx= -MYMR}', "");
    Expect(1, 43648, '\P{Is_Scx= -MYMR}', "");
    Expect(0, 43648, '\P{^Is_Scx= -MYMR}', "");
    Error('\p{Script_Extensions=		NANDINAGARI/a/}');
    Error('\P{Script_Extensions=		NANDINAGARI/a/}');
    Expect(1, 72164, '\p{Script_Extensions=:\ANandinagari\z:}', "");;
    Expect(0, 72165, '\p{Script_Extensions=:\ANandinagari\z:}', "");;
    Expect(1, 72164, '\p{Script_Extensions:	nandinagari}', "");
    Expect(0, 72164, '\p{^Script_Extensions:	nandinagari}', "");
    Expect(0, 72164, '\P{Script_Extensions:	nandinagari}', "");
    Expect(1, 72164, '\P{^Script_Extensions:	nandinagari}', "");
    Expect(0, 72165, '\p{Script_Extensions:	nandinagari}', "");
    Expect(1, 72165, '\p{^Script_Extensions:	nandinagari}', "");
    Expect(1, 72165, '\P{Script_Extensions:	nandinagari}', "");
    Expect(0, 72165, '\P{^Script_Extensions:	nandinagari}', "");
    Expect(1, 72164, '\p{Script_Extensions=:\Anandinagari\z:}', "");;
    Expect(0, 72165, '\p{Script_Extensions=:\Anandinagari\z:}', "");;
    Expect(1, 72164, '\p{Script_Extensions=_ NANDINAGARI}', "");
    Expect(0, 72164, '\p{^Script_Extensions=_ NANDINAGARI}', "");
    Expect(0, 72164, '\P{Script_Extensions=_ NANDINAGARI}', "");
    Expect(1, 72164, '\P{^Script_Extensions=_ NANDINAGARI}', "");
    Expect(0, 72165, '\p{Script_Extensions=_ NANDINAGARI}', "");
    Expect(1, 72165, '\p{^Script_Extensions=_ NANDINAGARI}', "");
    Expect(1, 72165, '\P{Script_Extensions=_ NANDINAGARI}', "");
    Expect(0, 72165, '\P{^Script_Extensions=_ NANDINAGARI}', "");
    Error('\p{Scx=	 nand:=}');
    Error('\P{Scx=	 nand:=}');
    Expect(1, 72164, '\p{Scx=:\ANand\z:}', "");;
    Expect(0, 72165, '\p{Scx=:\ANand\z:}', "");;
    Expect(1, 72164, '\p{Scx=nand}', "");
    Expect(0, 72164, '\p{^Scx=nand}', "");
    Expect(0, 72164, '\P{Scx=nand}', "");
    Expect(1, 72164, '\P{^Scx=nand}', "");
    Expect(0, 72165, '\p{Scx=nand}', "");
    Expect(1, 72165, '\p{^Scx=nand}', "");
    Expect(1, 72165, '\P{Scx=nand}', "");
    Expect(0, 72165, '\P{^Scx=nand}', "");
    Expect(1, 72164, '\p{Scx=:\Anand\z:}', "");;
    Expect(0, 72165, '\p{Scx=:\Anand\z:}', "");;
    Expect(1, 72164, '\p{Scx= 	Nand}', "");
    Expect(0, 72164, '\p{^Scx= 	Nand}', "");
    Expect(0, 72164, '\P{Scx= 	Nand}', "");
    Expect(1, 72164, '\P{^Scx= 	Nand}', "");
    Expect(0, 72165, '\p{Scx= 	Nand}', "");
    Expect(1, 72165, '\p{^Scx= 	Nand}', "");
    Expect(1, 72165, '\P{Scx= 	Nand}', "");
    Expect(0, 72165, '\P{^Scx= 	Nand}', "");
    Error('\p{Is_Script_Extensions=:=_	Nandinagari}');
    Error('\P{Is_Script_Extensions=:=_	Nandinagari}');
    Expect(1, 72164, '\p{Is_Script_Extensions=nandinagari}', "");
    Expect(0, 72164, '\p{^Is_Script_Extensions=nandinagari}', "");
    Expect(0, 72164, '\P{Is_Script_Extensions=nandinagari}', "");
    Expect(1, 72164, '\P{^Is_Script_Extensions=nandinagari}', "");
    Expect(0, 72165, '\p{Is_Script_Extensions=nandinagari}', "");
    Expect(1, 72165, '\p{^Is_Script_Extensions=nandinagari}', "");
    Expect(1, 72165, '\P{Is_Script_Extensions=nandinagari}', "");
    Expect(0, 72165, '\P{^Is_Script_Extensions=nandinagari}', "");
    Expect(1, 72164, '\p{Is_Script_Extensions=__Nandinagari}', "");
    Expect(0, 72164, '\p{^Is_Script_Extensions=__Nandinagari}', "");
    Expect(0, 72164, '\P{Is_Script_Extensions=__Nandinagari}', "");
    Expect(1, 72164, '\P{^Is_Script_Extensions=__Nandinagari}', "");
    Expect(0, 72165, '\p{Is_Script_Extensions=__Nandinagari}', "");
    Expect(1, 72165, '\p{^Is_Script_Extensions=__Nandinagari}', "");
    Expect(1, 72165, '\P{Is_Script_Extensions=__Nandinagari}', "");
    Expect(0, 72165, '\P{^Is_Script_Extensions=__Nandinagari}', "");
    Error('\p{Is_Scx=:=_Nand}');
    Error('\P{Is_Scx=:=_Nand}');
    Expect(1, 72164, '\p{Is_Scx=nand}', "");
    Expect(0, 72164, '\p{^Is_Scx=nand}', "");
    Expect(0, 72164, '\P{Is_Scx=nand}', "");
    Expect(1, 72164, '\P{^Is_Scx=nand}', "");
    Expect(0, 72165, '\p{Is_Scx=nand}', "");
    Expect(1, 72165, '\p{^Is_Scx=nand}', "");
    Expect(1, 72165, '\P{Is_Scx=nand}', "");
    Expect(0, 72165, '\P{^Is_Scx=nand}', "");
    Expect(1, 72164, '\p{Is_Scx=	-NAND}', "");
    Expect(0, 72164, '\p{^Is_Scx=	-NAND}', "");
    Expect(0, 72164, '\P{Is_Scx=	-NAND}', "");
    Expect(1, 72164, '\P{^Is_Scx=	-NAND}', "");
    Expect(0, 72165, '\p{Is_Scx=	-NAND}', "");
    Expect(1, 72165, '\p{^Is_Scx=	-NAND}', "");
    Expect(1, 72165, '\P{Is_Scx=	-NAND}', "");
    Expect(0, 72165, '\P{^Is_Scx=	-NAND}', "");
    Error('\p{Script_Extensions=/a/ 	old_North_Arabian}');
    Error('\P{Script_Extensions=/a/ 	old_North_Arabian}');
    Expect(1, 68255, '\p{Script_Extensions=:\AOld_North_Arabian\z:}', "");;
    Expect(0, 68256, '\p{Script_Extensions=:\AOld_North_Arabian\z:}', "");;
    Expect(1, 68255, '\p{Script_Extensions=oldnortharabian}', "");
    Expect(0, 68255, '\p{^Script_Extensions=oldnortharabian}', "");
    Expect(0, 68255, '\P{Script_Extensions=oldnortharabian}', "");
    Expect(1, 68255, '\P{^Script_Extensions=oldnortharabian}', "");
    Expect(0, 68256, '\p{Script_Extensions=oldnortharabian}', "");
    Expect(1, 68256, '\p{^Script_Extensions=oldnortharabian}', "");
    Expect(1, 68256, '\P{Script_Extensions=oldnortharabian}', "");
    Expect(0, 68256, '\P{^Script_Extensions=oldnortharabian}', "");
    Expect(1, 68255, '\p{Script_Extensions=:\Aoldnortharabian\z:}', "");;
    Expect(0, 68256, '\p{Script_Extensions=:\Aoldnortharabian\z:}', "");;
    Expect(1, 68255, '\p{Script_Extensions= 	old_North_arabian}', "");
    Expect(0, 68255, '\p{^Script_Extensions= 	old_North_arabian}', "");
    Expect(0, 68255, '\P{Script_Extensions= 	old_North_arabian}', "");
    Expect(1, 68255, '\P{^Script_Extensions= 	old_North_arabian}', "");
    Expect(0, 68256, '\p{Script_Extensions= 	old_North_arabian}', "");
    Expect(1, 68256, '\p{^Script_Extensions= 	old_North_arabian}', "");
    Expect(1, 68256, '\P{Script_Extensions= 	old_North_arabian}', "");
    Expect(0, 68256, '\P{^Script_Extensions= 	old_North_arabian}', "");
    Error('\p{Scx=_NARB/a/}');
    Error('\P{Scx=_NARB/a/}');
    Expect(1, 68255, '\p{Scx=:\ANarb\z:}', "");;
    Expect(0, 68256, '\p{Scx=:\ANarb\z:}', "");;
    Expect(1, 68255, '\p{Scx=narb}', "");
    Expect(0, 68255, '\p{^Scx=narb}', "");
    Expect(0, 68255, '\P{Scx=narb}', "");
    Expect(1, 68255, '\P{^Scx=narb}', "");
    Expect(0, 68256, '\p{Scx=narb}', "");
    Expect(1, 68256, '\p{^Scx=narb}', "");
    Expect(1, 68256, '\P{Scx=narb}', "");
    Expect(0, 68256, '\P{^Scx=narb}', "");
    Expect(1, 68255, '\p{Scx=:\Anarb\z:}', "");;
    Expect(0, 68256, '\p{Scx=:\Anarb\z:}', "");;
    Expect(1, 68255, '\p{Scx= _NARB}', "");
    Expect(0, 68255, '\p{^Scx= _NARB}', "");
    Expect(0, 68255, '\P{Scx= _NARB}', "");
    Expect(1, 68255, '\P{^Scx= _NARB}', "");
    Expect(0, 68256, '\p{Scx= _NARB}', "");
    Expect(1, 68256, '\p{^Scx= _NARB}', "");
    Expect(1, 68256, '\P{Scx= _NARB}', "");
    Expect(0, 68256, '\P{^Scx= _NARB}', "");
    Error('\p{Is_Script_Extensions=/a/-OLD_north_Arabian}');
    Error('\P{Is_Script_Extensions=/a/-OLD_north_Arabian}');
    Expect(1, 68255, '\p{Is_Script_Extensions=oldnortharabian}', "");
    Expect(0, 68255, '\p{^Is_Script_Extensions=oldnortharabian}', "");
    Expect(0, 68255, '\P{Is_Script_Extensions=oldnortharabian}', "");
    Expect(1, 68255, '\P{^Is_Script_Extensions=oldnortharabian}', "");
    Expect(0, 68256, '\p{Is_Script_Extensions=oldnortharabian}', "");
    Expect(1, 68256, '\p{^Is_Script_Extensions=oldnortharabian}', "");
    Expect(1, 68256, '\P{Is_Script_Extensions=oldnortharabian}', "");
    Expect(0, 68256, '\P{^Is_Script_Extensions=oldnortharabian}', "");
    Expect(1, 68255, '\p{Is_Script_Extensions=-OLD_North_Arabian}', "");
    Expect(0, 68255, '\p{^Is_Script_Extensions=-OLD_North_Arabian}', "");
    Expect(0, 68255, '\P{Is_Script_Extensions=-OLD_North_Arabian}', "");
    Expect(1, 68255, '\P{^Is_Script_Extensions=-OLD_North_Arabian}', "");
    Expect(0, 68256, '\p{Is_Script_Extensions=-OLD_North_Arabian}', "");
    Expect(1, 68256, '\p{^Is_Script_Extensions=-OLD_North_Arabian}', "");
    Expect(1, 68256, '\P{Is_Script_Extensions=-OLD_North_Arabian}', "");
    Expect(0, 68256, '\P{^Is_Script_Extensions=-OLD_North_Arabian}', "");
    Error('\p{Is_Scx= /a/Narb}');
    Error('\P{Is_Scx= /a/Narb}');
    Expect(1, 68255, '\p{Is_Scx=narb}', "");
    Expect(0, 68255, '\p{^Is_Scx=narb}', "");
    Expect(0, 68255, '\P{Is_Scx=narb}', "");
    Expect(1, 68255, '\P{^Is_Scx=narb}', "");
    Expect(0, 68256, '\p{Is_Scx=narb}', "");
    Expect(1, 68256, '\p{^Is_Scx=narb}', "");
    Expect(1, 68256, '\P{Is_Scx=narb}', "");
    Expect(0, 68256, '\P{^Is_Scx=narb}', "");
    Expect(1, 68255, '\p{Is_Scx=	NARB}', "");
    Expect(0, 68255, '\p{^Is_Scx=	NARB}', "");
    Expect(0, 68255, '\P{Is_Scx=	NARB}', "");
    Expect(1, 68255, '\P{^Is_Scx=	NARB}', "");
    Expect(0, 68256, '\p{Is_Scx=	NARB}', "");
    Expect(1, 68256, '\p{^Is_Scx=	NARB}', "");
    Expect(1, 68256, '\P{Is_Scx=	NARB}', "");
    Expect(0, 68256, '\P{^Is_Scx=	NARB}', "");
    Error('\p{Script_Extensions=	/a/nabataean}');
    Error('\P{Script_Extensions=	/a/nabataean}');
    Expect(1, 67759, '\p{Script_Extensions=:\ANabataean\z:}', "");;
    Expect(0, 67760, '\p{Script_Extensions=:\ANabataean\z:}', "");;
    Expect(1, 67759, '\p{Script_Extensions=nabataean}', "");
    Expect(0, 67759, '\p{^Script_Extensions=nabataean}', "");
    Expect(0, 67759, '\P{Script_Extensions=nabataean}', "");
    Expect(1, 67759, '\P{^Script_Extensions=nabataean}', "");
    Expect(0, 67760, '\p{Script_Extensions=nabataean}', "");
    Expect(1, 67760, '\p{^Script_Extensions=nabataean}', "");
    Expect(1, 67760, '\P{Script_Extensions=nabataean}', "");
    Expect(0, 67760, '\P{^Script_Extensions=nabataean}', "");
    Expect(1, 67759, '\p{Script_Extensions=:\Anabataean\z:}', "");;
    Expect(0, 67760, '\p{Script_Extensions=:\Anabataean\z:}', "");;
    Expect(1, 67759, '\p{Script_Extensions=-nabataean}', "");
    Expect(0, 67759, '\p{^Script_Extensions=-nabataean}', "");
    Expect(0, 67759, '\P{Script_Extensions=-nabataean}', "");
    Expect(1, 67759, '\P{^Script_Extensions=-nabataean}', "");
    Expect(0, 67760, '\p{Script_Extensions=-nabataean}', "");
    Expect(1, 67760, '\p{^Script_Extensions=-nabataean}', "");
    Expect(1, 67760, '\P{Script_Extensions=-nabataean}', "");
    Expect(0, 67760, '\P{^Script_Extensions=-nabataean}', "");
    Error('\p{Scx=/a/ NBAT}');
    Error('\P{Scx=/a/ NBAT}');
    Expect(1, 67759, '\p{Scx=:\ANbat\z:}', "");;
    Expect(0, 67760, '\p{Scx=:\ANbat\z:}', "");;
    Expect(1, 67759, '\p{Scx=nbat}', "");
    Expect(0, 67759, '\p{^Scx=nbat}', "");
    Expect(0, 67759, '\P{Scx=nbat}', "");
    Expect(1, 67759, '\P{^Scx=nbat}', "");
    Expect(0, 67760, '\p{Scx=nbat}', "");
    Expect(1, 67760, '\p{^Scx=nbat}', "");
    Expect(1, 67760, '\P{Scx=nbat}', "");
    Expect(0, 67760, '\P{^Scx=nbat}', "");
    Expect(1, 67759, '\p{Scx=:\Anbat\z:}', "");;
    Expect(0, 67760, '\p{Scx=:\Anbat\z:}', "");;
    Expect(1, 67759, '\p{Scx=__nbat}', "");
    Expect(0, 67759, '\p{^Scx=__nbat}', "");
    Expect(0, 67759, '\P{Scx=__nbat}', "");
    Expect(1, 67759, '\P{^Scx=__nbat}', "");
    Expect(0, 67760, '\p{Scx=__nbat}', "");
    Expect(1, 67760, '\p{^Scx=__nbat}', "");
    Expect(1, 67760, '\P{Scx=__nbat}', "");
    Expect(0, 67760, '\P{^Scx=__nbat}', "");
    Error('\p{Is_Script_Extensions=:=	Nabataean}');
    Error('\P{Is_Script_Extensions=:=	Nabataean}');
    Expect(1, 67759, '\p{Is_Script_Extensions=nabataean}', "");
    Expect(0, 67759, '\p{^Is_Script_Extensions=nabataean}', "");
    Expect(0, 67759, '\P{Is_Script_Extensions=nabataean}', "");
    Expect(1, 67759, '\P{^Is_Script_Extensions=nabataean}', "");
    Expect(0, 67760, '\p{Is_Script_Extensions=nabataean}', "");
    Expect(1, 67760, '\p{^Is_Script_Extensions=nabataean}', "");
    Expect(1, 67760, '\P{Is_Script_Extensions=nabataean}', "");
    Expect(0, 67760, '\P{^Is_Script_Extensions=nabataean}', "");
    Expect(1, 67759, '\p{Is_Script_Extensions=	 Nabataean}', "");
    Expect(0, 67759, '\p{^Is_Script_Extensions=	 Nabataean}', "");
    Expect(0, 67759, '\P{Is_Script_Extensions=	 Nabataean}', "");
    Expect(1, 67759, '\P{^Is_Script_Extensions=	 Nabataean}', "");
    Expect(0, 67760, '\p{Is_Script_Extensions=	 Nabataean}', "");
    Expect(1, 67760, '\p{^Is_Script_Extensions=	 Nabataean}', "");
    Expect(1, 67760, '\P{Is_Script_Extensions=	 Nabataean}', "");
    Expect(0, 67760, '\P{^Is_Script_Extensions=	 Nabataean}', "");
    Error('\p{Is_Scx=:=NBAT}');
    Error('\P{Is_Scx=:=NBAT}');
    Expect(1, 67759, '\p{Is_Scx=nbat}', "");
    Expect(0, 67759, '\p{^Is_Scx=nbat}', "");
    Expect(0, 67759, '\P{Is_Scx=nbat}', "");
    Expect(1, 67759, '\P{^Is_Scx=nbat}', "");
    Expect(0, 67760, '\p{Is_Scx=nbat}', "");
    Expect(1, 67760, '\p{^Is_Scx=nbat}', "");
    Expect(1, 67760, '\P{Is_Scx=nbat}', "");
    Expect(0, 67760, '\P{^Is_Scx=nbat}', "");
    Expect(1, 67759, '\p{Is_Scx=		NBAT}', "");
    Expect(0, 67759, '\p{^Is_Scx=		NBAT}', "");
    Expect(0, 67759, '\P{Is_Scx=		NBAT}', "");
    Expect(1, 67759, '\P{^Is_Scx=		NBAT}', "");
    Expect(0, 67760, '\p{Is_Scx=		NBAT}', "");
    Expect(1, 67760, '\p{^Is_Scx=		NBAT}', "");
    Expect(1, 67760, '\P{Is_Scx=		NBAT}', "");
    Expect(0, 67760, '\P{^Is_Scx=		NBAT}', "");
    Error('\p{Script_Extensions=	_NEWA:=}');
    Error('\P{Script_Extensions=	_NEWA:=}');
    Expect(1, 70753, '\p{Script_Extensions=:\ANewa\z:}', "");;
    Expect(0, 70754, '\p{Script_Extensions=:\ANewa\z:}', "");;
    Expect(1, 70753, '\p{Script_Extensions=newa}', "");
    Expect(0, 70753, '\p{^Script_Extensions=newa}', "");
    Expect(0, 70753, '\P{Script_Extensions=newa}', "");
    Expect(1, 70753, '\P{^Script_Extensions=newa}', "");
    Expect(0, 70754, '\p{Script_Extensions=newa}', "");
    Expect(1, 70754, '\p{^Script_Extensions=newa}', "");
    Expect(1, 70754, '\P{Script_Extensions=newa}', "");
    Expect(0, 70754, '\P{^Script_Extensions=newa}', "");
    Expect(1, 70753, '\p{Script_Extensions=:\Anewa\z:}', "");;
    Expect(0, 70754, '\p{Script_Extensions=:\Anewa\z:}', "");;
    Expect(1, 70753, '\p{Script_Extensions=__newa}', "");
    Expect(0, 70753, '\p{^Script_Extensions=__newa}', "");
    Expect(0, 70753, '\P{Script_Extensions=__newa}', "");
    Expect(1, 70753, '\P{^Script_Extensions=__newa}', "");
    Expect(0, 70754, '\p{Script_Extensions=__newa}', "");
    Expect(1, 70754, '\p{^Script_Extensions=__newa}', "");
    Expect(1, 70754, '\P{Script_Extensions=__newa}', "");
    Expect(0, 70754, '\P{^Script_Extensions=__newa}', "");
    Error('\p{Scx= _newa/a/}');
    Error('\P{Scx= _newa/a/}');
    Expect(1, 70753, '\p{Scx=:\ANewa\z:}', "");;
    Expect(0, 70754, '\p{Scx=:\ANewa\z:}', "");;
    Expect(1, 70753, '\p{Scx=newa}', "");
    Expect(0, 70753, '\p{^Scx=newa}', "");
    Expect(0, 70753, '\P{Scx=newa}', "");
    Expect(1, 70753, '\P{^Scx=newa}', "");
    Expect(0, 70754, '\p{Scx=newa}', "");
    Expect(1, 70754, '\p{^Scx=newa}', "");
    Expect(1, 70754, '\P{Scx=newa}', "");
    Expect(0, 70754, '\P{^Scx=newa}', "");
    Expect(1, 70753, '\p{Scx=:\Anewa\z:}', "");;
    Expect(0, 70754, '\p{Scx=:\Anewa\z:}', "");;
    Expect(1, 70753, '\p{Scx:	 -Newa}', "");
    Expect(0, 70753, '\p{^Scx:	 -Newa}', "");
    Expect(0, 70753, '\P{Scx:	 -Newa}', "");
    Expect(1, 70753, '\P{^Scx:	 -Newa}', "");
    Expect(0, 70754, '\p{Scx:	 -Newa}', "");
    Expect(1, 70754, '\p{^Scx:	 -Newa}', "");
    Expect(1, 70754, '\P{Scx:	 -Newa}', "");
    Expect(0, 70754, '\P{^Scx:	 -Newa}', "");
    Error('\p{Is_Script_Extensions=_:=Newa}');
    Error('\P{Is_Script_Extensions=_:=Newa}');
    Expect(1, 70753, '\p{Is_Script_Extensions=newa}', "");
    Expect(0, 70753, '\p{^Is_Script_Extensions=newa}', "");
    Expect(0, 70753, '\P{Is_Script_Extensions=newa}', "");
    Expect(1, 70753, '\P{^Is_Script_Extensions=newa}', "");
    Expect(0, 70754, '\p{Is_Script_Extensions=newa}', "");
    Expect(1, 70754, '\p{^Is_Script_Extensions=newa}', "");
    Expect(1, 70754, '\P{Is_Script_Extensions=newa}', "");
    Expect(0, 70754, '\P{^Is_Script_Extensions=newa}', "");
    Expect(1, 70753, '\p{Is_Script_Extensions= _newa}', "");
    Expect(0, 70753, '\p{^Is_Script_Extensions= _newa}', "");
    Expect(0, 70753, '\P{Is_Script_Extensions= _newa}', "");
    Expect(1, 70753, '\P{^Is_Script_Extensions= _newa}', "");
    Expect(0, 70754, '\p{Is_Script_Extensions= _newa}', "");
    Expect(1, 70754, '\p{^Is_Script_Extensions= _newa}', "");
    Expect(1, 70754, '\P{Is_Script_Extensions= _newa}', "");
    Expect(0, 70754, '\P{^Is_Script_Extensions= _newa}', "");
    Error('\p{Is_Scx:	-_Newa/a/}');
    Error('\P{Is_Scx:	-_Newa/a/}');
    Expect(1, 70753, '\p{Is_Scx=newa}', "");
    Expect(0, 70753, '\p{^Is_Scx=newa}', "");
    Expect(0, 70753, '\P{Is_Scx=newa}', "");
    Expect(1, 70753, '\P{^Is_Scx=newa}', "");
    Expect(0, 70754, '\p{Is_Scx=newa}', "");
    Expect(1, 70754, '\p{^Is_Scx=newa}', "");
    Expect(1, 70754, '\P{Is_Scx=newa}', "");
    Expect(0, 70754, '\P{^Is_Scx=newa}', "");
    Expect(1, 70753, '\p{Is_Scx=--Newa}', "");
    Expect(0, 70753, '\p{^Is_Scx=--Newa}', "");
    Expect(0, 70753, '\P{Is_Scx=--Newa}', "");
    Expect(1, 70753, '\P{^Is_Scx=--Newa}', "");
    Expect(0, 70754, '\p{Is_Scx=--Newa}', "");
    Expect(1, 70754, '\p{^Is_Scx=--Newa}', "");
    Expect(1, 70754, '\P{Is_Scx=--Newa}', "");
    Expect(0, 70754, '\P{^Is_Scx=--Newa}', "");
    Error('\p{Script_Extensions=/a/	nko}');
    Error('\P{Script_Extensions=/a/	nko}');
    Expect(1, 2047, '\p{Script_Extensions=:\ANko\z:}', "");;
    Expect(0, 2048, '\p{Script_Extensions=:\ANko\z:}', "");;
    Expect(1, 2047, '\p{Script_Extensions=nko}', "");
    Expect(0, 2047, '\p{^Script_Extensions=nko}', "");
    Expect(0, 2047, '\P{Script_Extensions=nko}', "");
    Expect(1, 2047, '\P{^Script_Extensions=nko}', "");
    Expect(0, 2048, '\p{Script_Extensions=nko}', "");
    Expect(1, 2048, '\p{^Script_Extensions=nko}', "");
    Expect(1, 2048, '\P{Script_Extensions=nko}', "");
    Expect(0, 2048, '\P{^Script_Extensions=nko}', "");
    Expect(1, 2047, '\p{Script_Extensions=:\Anko\z:}', "");;
    Expect(0, 2048, '\p{Script_Extensions=:\Anko\z:}', "");;
    Expect(1, 2047, '\p{Script_Extensions=	NKO}', "");
    Expect(0, 2047, '\p{^Script_Extensions=	NKO}', "");
    Expect(0, 2047, '\P{Script_Extensions=	NKO}', "");
    Expect(1, 2047, '\P{^Script_Extensions=	NKO}', "");
    Expect(0, 2048, '\p{Script_Extensions=	NKO}', "");
    Expect(1, 2048, '\p{^Script_Extensions=	NKO}', "");
    Expect(1, 2048, '\P{Script_Extensions=	NKO}', "");
    Expect(0, 2048, '\P{^Script_Extensions=	NKO}', "");
    Error('\p{Scx=-/a/Nkoo}');
    Error('\P{Scx=-/a/Nkoo}');
    Expect(1, 2047, '\p{Scx=:\ANkoo\z:}', "");;
    Expect(0, 2048, '\p{Scx=:\ANkoo\z:}', "");;
    Expect(1, 2047, '\p{Scx=nkoo}', "");
    Expect(0, 2047, '\p{^Scx=nkoo}', "");
    Expect(0, 2047, '\P{Scx=nkoo}', "");
    Expect(1, 2047, '\P{^Scx=nkoo}', "");
    Expect(0, 2048, '\p{Scx=nkoo}', "");
    Expect(1, 2048, '\p{^Scx=nkoo}', "");
    Expect(1, 2048, '\P{Scx=nkoo}', "");
    Expect(0, 2048, '\P{^Scx=nkoo}', "");
    Expect(1, 2047, '\p{Scx=:\Ankoo\z:}', "");;
    Expect(0, 2048, '\p{Scx=:\Ankoo\z:}', "");;
    Expect(1, 2047, '\p{Scx: 	_nkoo}', "");
    Expect(0, 2047, '\p{^Scx: 	_nkoo}', "");
    Expect(0, 2047, '\P{Scx: 	_nkoo}', "");
    Expect(1, 2047, '\P{^Scx: 	_nkoo}', "");
    Expect(0, 2048, '\p{Scx: 	_nkoo}', "");
    Expect(1, 2048, '\p{^Scx: 	_nkoo}', "");
    Expect(1, 2048, '\P{Scx: 	_nkoo}', "");
    Expect(0, 2048, '\P{^Scx: 	_nkoo}', "");
    Error('\p{Is_Script_Extensions=:= 	nko}');
    Error('\P{Is_Script_Extensions=:= 	nko}');
    Expect(1, 2047, '\p{Is_Script_Extensions=nko}', "");
    Expect(0, 2047, '\p{^Is_Script_Extensions=nko}', "");
    Expect(0, 2047, '\P{Is_Script_Extensions=nko}', "");
    Expect(1, 2047, '\P{^Is_Script_Extensions=nko}', "");
    Expect(0, 2048, '\p{Is_Script_Extensions=nko}', "");
    Expect(1, 2048, '\p{^Is_Script_Extensions=nko}', "");
    Expect(1, 2048, '\P{Is_Script_Extensions=nko}', "");
    Expect(0, 2048, '\P{^Is_Script_Extensions=nko}', "");
    Expect(1, 2047, '\p{Is_Script_Extensions=-	Nko}', "");
    Expect(0, 2047, '\p{^Is_Script_Extensions=-	Nko}', "");
    Expect(0, 2047, '\P{Is_Script_Extensions=-	Nko}', "");
    Expect(1, 2047, '\P{^Is_Script_Extensions=-	Nko}', "");
    Expect(0, 2048, '\p{Is_Script_Extensions=-	Nko}', "");
    Expect(1, 2048, '\p{^Is_Script_Extensions=-	Nko}', "");
    Expect(1, 2048, '\P{Is_Script_Extensions=-	Nko}', "");
    Expect(0, 2048, '\P{^Is_Script_Extensions=-	Nko}', "");
    Error('\p{Is_Scx=-_Nkoo/a/}');
    Error('\P{Is_Scx=-_Nkoo/a/}');
    Expect(1, 2047, '\p{Is_Scx=nkoo}', "");
    Expect(0, 2047, '\p{^Is_Scx=nkoo}', "");
    Expect(0, 2047, '\P{Is_Scx=nkoo}', "");
    Expect(1, 2047, '\P{^Is_Scx=nkoo}', "");
    Expect(0, 2048, '\p{Is_Scx=nkoo}', "");
    Expect(1, 2048, '\p{^Is_Scx=nkoo}', "");
    Expect(1, 2048, '\P{Is_Scx=nkoo}', "");
    Expect(0, 2048, '\P{^Is_Scx=nkoo}', "");
    Expect(1, 2047, '\p{Is_Scx:   	-Nkoo}', "");
    Expect(0, 2047, '\p{^Is_Scx:   	-Nkoo}', "");
    Expect(0, 2047, '\P{Is_Scx:   	-Nkoo}', "");
    Expect(1, 2047, '\P{^Is_Scx:   	-Nkoo}', "");
    Expect(0, 2048, '\p{Is_Scx:   	-Nkoo}', "");
    Expect(1, 2048, '\p{^Is_Scx:   	-Nkoo}', "");
    Expect(1, 2048, '\P{Is_Scx:   	-Nkoo}', "");
    Expect(0, 2048, '\P{^Is_Scx:   	-Nkoo}', "");
    Error('\p{Script_Extensions=__Nushu:=}');
    Error('\P{Script_Extensions=__Nushu:=}');
    Expect(1, 111355, '\p{Script_Extensions=:\ANushu\z:}', "");;
    Expect(0, 111356, '\p{Script_Extensions=:\ANushu\z:}', "");;
    Expect(1, 111355, '\p{Script_Extensions:   nushu}', "");
    Expect(0, 111355, '\p{^Script_Extensions:   nushu}', "");
    Expect(0, 111355, '\P{Script_Extensions:   nushu}', "");
    Expect(1, 111355, '\P{^Script_Extensions:   nushu}', "");
    Expect(0, 111356, '\p{Script_Extensions:   nushu}', "");
    Expect(1, 111356, '\p{^Script_Extensions:   nushu}', "");
    Expect(1, 111356, '\P{Script_Extensions:   nushu}', "");
    Expect(0, 111356, '\P{^Script_Extensions:   nushu}', "");
    Expect(1, 111355, '\p{Script_Extensions=:\Anushu\z:}', "");;
    Expect(0, 111356, '\p{Script_Extensions=:\Anushu\z:}', "");;
    Expect(1, 111355, '\p{Script_Extensions=_NUSHU}', "");
    Expect(0, 111355, '\p{^Script_Extensions=_NUSHU}', "");
    Expect(0, 111355, '\P{Script_Extensions=_NUSHU}', "");
    Expect(1, 111355, '\P{^Script_Extensions=_NUSHU}', "");
    Expect(0, 111356, '\p{Script_Extensions=_NUSHU}', "");
    Expect(1, 111356, '\p{^Script_Extensions=_NUSHU}', "");
    Expect(1, 111356, '\P{Script_Extensions=_NUSHU}', "");
    Expect(0, 111356, '\P{^Script_Extensions=_NUSHU}', "");
    Error('\p{Scx=/a/_NSHU}');
    Error('\P{Scx=/a/_NSHU}');
    Expect(1, 111355, '\p{Scx=:\ANshu\z:}', "");;
    Expect(0, 111356, '\p{Scx=:\ANshu\z:}', "");;
    Expect(1, 111355, '\p{Scx=nshu}', "");
    Expect(0, 111355, '\p{^Scx=nshu}', "");
    Expect(0, 111355, '\P{Scx=nshu}', "");
    Expect(1, 111355, '\P{^Scx=nshu}', "");
    Expect(0, 111356, '\p{Scx=nshu}', "");
    Expect(1, 111356, '\p{^Scx=nshu}', "");
    Expect(1, 111356, '\P{Scx=nshu}', "");
    Expect(0, 111356, '\P{^Scx=nshu}', "");
    Expect(1, 111355, '\p{Scx=:\Anshu\z:}', "");;
    Expect(0, 111356, '\p{Scx=:\Anshu\z:}', "");;
    Expect(1, 111355, '\p{Scx=		Nshu}', "");
    Expect(0, 111355, '\p{^Scx=		Nshu}', "");
    Expect(0, 111355, '\P{Scx=		Nshu}', "");
    Expect(1, 111355, '\P{^Scx=		Nshu}', "");
    Expect(0, 111356, '\p{Scx=		Nshu}', "");
    Expect(1, 111356, '\p{^Scx=		Nshu}', "");
    Expect(1, 111356, '\P{Scx=		Nshu}', "");
    Expect(0, 111356, '\P{^Scx=		Nshu}', "");
    Error('\p{Is_Script_Extensions= /a/nushu}');
    Error('\P{Is_Script_Extensions= /a/nushu}');
    Expect(1, 111355, '\p{Is_Script_Extensions=nushu}', "");
    Expect(0, 111355, '\p{^Is_Script_Extensions=nushu}', "");
    Expect(0, 111355, '\P{Is_Script_Extensions=nushu}', "");
    Expect(1, 111355, '\P{^Is_Script_Extensions=nushu}', "");
    Expect(0, 111356, '\p{Is_Script_Extensions=nushu}', "");
    Expect(1, 111356, '\p{^Is_Script_Extensions=nushu}', "");
    Expect(1, 111356, '\P{Is_Script_Extensions=nushu}', "");
    Expect(0, 111356, '\P{^Is_Script_Extensions=nushu}', "");
    Expect(1, 111355, '\p{Is_Script_Extensions=		nushu}', "");
    Expect(0, 111355, '\p{^Is_Script_Extensions=		nushu}', "");
    Expect(0, 111355, '\P{Is_Script_Extensions=		nushu}', "");
    Expect(1, 111355, '\P{^Is_Script_Extensions=		nushu}', "");
    Expect(0, 111356, '\p{Is_Script_Extensions=		nushu}', "");
    Expect(1, 111356, '\p{^Is_Script_Extensions=		nushu}', "");
    Expect(1, 111356, '\P{Is_Script_Extensions=		nushu}', "");
    Expect(0, 111356, '\P{^Is_Script_Extensions=		nushu}', "");
    Error('\p{Is_Scx=_Nshu/a/}');
    Error('\P{Is_Scx=_Nshu/a/}');
    Expect(1, 111355, '\p{Is_Scx=nshu}', "");
    Expect(0, 111355, '\p{^Is_Scx=nshu}', "");
    Expect(0, 111355, '\P{Is_Scx=nshu}', "");
    Expect(1, 111355, '\P{^Is_Scx=nshu}', "");
    Expect(0, 111356, '\p{Is_Scx=nshu}', "");
    Expect(1, 111356, '\p{^Is_Scx=nshu}', "");
    Expect(1, 111356, '\P{Is_Scx=nshu}', "");
    Expect(0, 111356, '\P{^Is_Scx=nshu}', "");
    Expect(1, 111355, '\p{Is_Scx=	-Nshu}', "");
    Expect(0, 111355, '\p{^Is_Scx=	-Nshu}', "");
    Expect(0, 111355, '\P{Is_Scx=	-Nshu}', "");
    Expect(1, 111355, '\P{^Is_Scx=	-Nshu}', "");
    Expect(0, 111356, '\p{Is_Scx=	-Nshu}', "");
    Expect(1, 111356, '\p{^Is_Scx=	-Nshu}', "");
    Expect(1, 111356, '\P{Is_Scx=	-Nshu}', "");
    Expect(0, 111356, '\P{^Is_Scx=	-Nshu}', "");
    Error('\p{Script_Extensions=	/a/OGHAM}');
    Error('\P{Script_Extensions=	/a/OGHAM}');
    Expect(1, 5788, '\p{Script_Extensions=:\AOgham\z:}', "");;
    Expect(0, 5789, '\p{Script_Extensions=:\AOgham\z:}', "");;
    Expect(1, 5788, '\p{Script_Extensions:   ogham}', "");
    Expect(0, 5788, '\p{^Script_Extensions:   ogham}', "");
    Expect(0, 5788, '\P{Script_Extensions:   ogham}', "");
    Expect(1, 5788, '\P{^Script_Extensions:   ogham}', "");
    Expect(0, 5789, '\p{Script_Extensions:   ogham}', "");
    Expect(1, 5789, '\p{^Script_Extensions:   ogham}', "");
    Expect(1, 5789, '\P{Script_Extensions:   ogham}', "");
    Expect(0, 5789, '\P{^Script_Extensions:   ogham}', "");
    Expect(1, 5788, '\p{Script_Extensions=:\Aogham\z:}', "");;
    Expect(0, 5789, '\p{Script_Extensions=:\Aogham\z:}', "");;
    Expect(1, 5788, '\p{Script_Extensions:  	OGHAM}', "");
    Expect(0, 5788, '\p{^Script_Extensions:  	OGHAM}', "");
    Expect(0, 5788, '\P{Script_Extensions:  	OGHAM}', "");
    Expect(1, 5788, '\P{^Script_Extensions:  	OGHAM}', "");
    Expect(0, 5789, '\p{Script_Extensions:  	OGHAM}', "");
    Expect(1, 5789, '\p{^Script_Extensions:  	OGHAM}', "");
    Expect(1, 5789, '\P{Script_Extensions:  	OGHAM}', "");
    Expect(0, 5789, '\P{^Script_Extensions:  	OGHAM}', "");
    Error('\p{Scx=:=_Ogam}');
    Error('\P{Scx=:=_Ogam}');
    Expect(1, 5788, '\p{Scx=:\AOgam\z:}', "");;
    Expect(0, 5789, '\p{Scx=:\AOgam\z:}', "");;
    Expect(1, 5788, '\p{Scx=ogam}', "");
    Expect(0, 5788, '\p{^Scx=ogam}', "");
    Expect(0, 5788, '\P{Scx=ogam}', "");
    Expect(1, 5788, '\P{^Scx=ogam}', "");
    Expect(0, 5789, '\p{Scx=ogam}', "");
    Expect(1, 5789, '\p{^Scx=ogam}', "");
    Expect(1, 5789, '\P{Scx=ogam}', "");
    Expect(0, 5789, '\P{^Scx=ogam}', "");
    Expect(1, 5788, '\p{Scx=:\Aogam\z:}', "");;
    Expect(0, 5789, '\p{Scx=:\Aogam\z:}', "");;
    Expect(1, 5788, '\p{Scx=- Ogam}', "");
    Expect(0, 5788, '\p{^Scx=- Ogam}', "");
    Expect(0, 5788, '\P{Scx=- Ogam}', "");
    Expect(1, 5788, '\P{^Scx=- Ogam}', "");
    Expect(0, 5789, '\p{Scx=- Ogam}', "");
    Expect(1, 5789, '\p{^Scx=- Ogam}', "");
    Expect(1, 5789, '\P{Scx=- Ogam}', "");
    Expect(0, 5789, '\P{^Scx=- Ogam}', "");
    Error('\p{Is_Script_Extensions=-	ogham:=}');
    Error('\P{Is_Script_Extensions=-	ogham:=}');
    Expect(1, 5788, '\p{Is_Script_Extensions=ogham}', "");
    Expect(0, 5788, '\p{^Is_Script_Extensions=ogham}', "");
    Expect(0, 5788, '\P{Is_Script_Extensions=ogham}', "");
    Expect(1, 5788, '\P{^Is_Script_Extensions=ogham}', "");
    Expect(0, 5789, '\p{Is_Script_Extensions=ogham}', "");
    Expect(1, 5789, '\p{^Is_Script_Extensions=ogham}', "");
    Expect(1, 5789, '\P{Is_Script_Extensions=ogham}', "");
    Expect(0, 5789, '\P{^Is_Script_Extensions=ogham}', "");
    Expect(1, 5788, '\p{Is_Script_Extensions:	_ Ogham}', "");
    Expect(0, 5788, '\p{^Is_Script_Extensions:	_ Ogham}', "");
    Expect(0, 5788, '\P{Is_Script_Extensions:	_ Ogham}', "");
    Expect(1, 5788, '\P{^Is_Script_Extensions:	_ Ogham}', "");
    Expect(0, 5789, '\p{Is_Script_Extensions:	_ Ogham}', "");
    Expect(1, 5789, '\p{^Is_Script_Extensions:	_ Ogham}', "");
    Expect(1, 5789, '\P{Is_Script_Extensions:	_ Ogham}', "");
    Expect(0, 5789, '\P{^Is_Script_Extensions:	_ Ogham}', "");
    Error('\p{Is_Scx=_ogam/a/}');
    Error('\P{Is_Scx=_ogam/a/}');
    Expect(1, 5788, '\p{Is_Scx=ogam}', "");
    Expect(0, 5788, '\p{^Is_Scx=ogam}', "");
    Expect(0, 5788, '\P{Is_Scx=ogam}', "");
    Expect(1, 5788, '\P{^Is_Scx=ogam}', "");
    Expect(0, 5789, '\p{Is_Scx=ogam}', "");
    Expect(1, 5789, '\p{^Is_Scx=ogam}', "");
    Expect(1, 5789, '\P{Is_Scx=ogam}', "");
    Expect(0, 5789, '\P{^Is_Scx=ogam}', "");
    Expect(1, 5788, '\p{Is_Scx=-ogam}', "");
    Expect(0, 5788, '\p{^Is_Scx=-ogam}', "");
    Expect(0, 5788, '\P{Is_Scx=-ogam}', "");
    Expect(1, 5788, '\P{^Is_Scx=-ogam}', "");
    Expect(0, 5789, '\p{Is_Scx=-ogam}', "");
    Expect(1, 5789, '\p{^Is_Scx=-ogam}', "");
    Expect(1, 5789, '\P{Is_Scx=-ogam}', "");
    Expect(0, 5789, '\P{^Is_Scx=-ogam}', "");
    Error('\p{Script_Extensions:/a/-	OL_CHIKI}');
    Error('\P{Script_Extensions:/a/-	OL_CHIKI}');
    Expect(1, 7295, '\p{Script_Extensions=:\AOl_Chiki\z:}', "");;
    Expect(0, 7296, '\p{Script_Extensions=:\AOl_Chiki\z:}', "");;
    Expect(1, 7295, '\p{Script_Extensions:	olchiki}', "");
    Expect(0, 7295, '\p{^Script_Extensions:	olchiki}', "");
    Expect(0, 7295, '\P{Script_Extensions:	olchiki}', "");
    Expect(1, 7295, '\P{^Script_Extensions:	olchiki}', "");
    Expect(0, 7296, '\p{Script_Extensions:	olchiki}', "");
    Expect(1, 7296, '\p{^Script_Extensions:	olchiki}', "");
    Expect(1, 7296, '\P{Script_Extensions:	olchiki}', "");
    Expect(0, 7296, '\P{^Script_Extensions:	olchiki}', "");
    Expect(1, 7295, '\p{Script_Extensions=:\Aolchiki\z:}', "");;
    Expect(0, 7296, '\p{Script_Extensions=:\Aolchiki\z:}', "");;
    Expect(1, 7295, '\p{Script_Extensions= Ol_chiki}', "");
    Expect(0, 7295, '\p{^Script_Extensions= Ol_chiki}', "");
    Expect(0, 7295, '\P{Script_Extensions= Ol_chiki}', "");
    Expect(1, 7295, '\P{^Script_Extensions= Ol_chiki}', "");
    Expect(0, 7296, '\p{Script_Extensions= Ol_chiki}', "");
    Expect(1, 7296, '\p{^Script_Extensions= Ol_chiki}', "");
    Expect(1, 7296, '\P{Script_Extensions= Ol_chiki}', "");
    Expect(0, 7296, '\P{^Script_Extensions= Ol_chiki}', "");
    Error('\p{Scx=:=Olck}');
    Error('\P{Scx=:=Olck}');
    Expect(1, 7295, '\p{Scx=:\AOlck\z:}', "");;
    Expect(0, 7296, '\p{Scx=:\AOlck\z:}', "");;
    Expect(1, 7295, '\p{Scx: olck}', "");
    Expect(0, 7295, '\p{^Scx: olck}', "");
    Expect(0, 7295, '\P{Scx: olck}', "");
    Expect(1, 7295, '\P{^Scx: olck}', "");
    Expect(0, 7296, '\p{Scx: olck}', "");
    Expect(1, 7296, '\p{^Scx: olck}', "");
    Expect(1, 7296, '\P{Scx: olck}', "");
    Expect(0, 7296, '\P{^Scx: olck}', "");
    Expect(1, 7295, '\p{Scx=:\Aolck\z:}', "");;
    Expect(0, 7296, '\p{Scx=:\Aolck\z:}', "");;
    Expect(1, 7295, '\p{Scx=  OLCK}', "");
    Expect(0, 7295, '\p{^Scx=  OLCK}', "");
    Expect(0, 7295, '\P{Scx=  OLCK}', "");
    Expect(1, 7295, '\P{^Scx=  OLCK}', "");
    Expect(0, 7296, '\p{Scx=  OLCK}', "");
    Expect(1, 7296, '\p{^Scx=  OLCK}', "");
    Expect(1, 7296, '\P{Scx=  OLCK}', "");
    Expect(0, 7296, '\P{^Scx=  OLCK}', "");
    Error('\p{Is_Script_Extensions: _/a/ol_Chiki}');
    Error('\P{Is_Script_Extensions: _/a/ol_Chiki}');
    Expect(1, 7295, '\p{Is_Script_Extensions=olchiki}', "");
    Expect(0, 7295, '\p{^Is_Script_Extensions=olchiki}', "");
    Expect(0, 7295, '\P{Is_Script_Extensions=olchiki}', "");
    Expect(1, 7295, '\P{^Is_Script_Extensions=olchiki}', "");
    Expect(0, 7296, '\p{Is_Script_Extensions=olchiki}', "");
    Expect(1, 7296, '\p{^Is_Script_Extensions=olchiki}', "");
    Expect(1, 7296, '\P{Is_Script_Extensions=olchiki}', "");
    Expect(0, 7296, '\P{^Is_Script_Extensions=olchiki}', "");
    Expect(1, 7295, '\p{Is_Script_Extensions= _Ol_Chiki}', "");
    Expect(0, 7295, '\p{^Is_Script_Extensions= _Ol_Chiki}', "");
    Expect(0, 7295, '\P{Is_Script_Extensions= _Ol_Chiki}', "");
    Expect(1, 7295, '\P{^Is_Script_Extensions= _Ol_Chiki}', "");
    Expect(0, 7296, '\p{Is_Script_Extensions= _Ol_Chiki}', "");
    Expect(1, 7296, '\p{^Is_Script_Extensions= _Ol_Chiki}', "");
    Expect(1, 7296, '\P{Is_Script_Extensions= _Ol_Chiki}', "");
    Expect(0, 7296, '\P{^Is_Script_Extensions= _Ol_Chiki}', "");
    Error('\p{Is_Scx=- Olck/a/}');
    Error('\P{Is_Scx=- Olck/a/}');
    Expect(1, 7295, '\p{Is_Scx=olck}', "");
    Expect(0, 7295, '\p{^Is_Scx=olck}', "");
    Expect(0, 7295, '\P{Is_Scx=olck}', "");
    Expect(1, 7295, '\P{^Is_Scx=olck}', "");
    Expect(0, 7296, '\p{Is_Scx=olck}', "");
    Expect(1, 7296, '\p{^Is_Scx=olck}', "");
    Expect(1, 7296, '\P{Is_Scx=olck}', "");
    Expect(0, 7296, '\P{^Is_Scx=olck}', "");
    Expect(1, 7295, '\p{Is_Scx= 	Olck}', "");
    Expect(0, 7295, '\p{^Is_Scx= 	Olck}', "");
    Expect(0, 7295, '\P{Is_Scx= 	Olck}', "");
    Expect(1, 7295, '\P{^Is_Scx= 	Olck}', "");
    Expect(0, 7296, '\p{Is_Scx= 	Olck}', "");
    Expect(1, 7296, '\p{^Is_Scx= 	Olck}', "");
    Expect(1, 7296, '\P{Is_Scx= 	Olck}', "");
    Expect(0, 7296, '\P{^Is_Scx= 	Olck}', "");
    Error('\p{Script_Extensions=	:=Old_turkic}');
    Error('\P{Script_Extensions=	:=Old_turkic}');
    Expect(1, 68680, '\p{Script_Extensions=:\AOld_Turkic\z:}', "");;
    Expect(0, 68681, '\p{Script_Extensions=:\AOld_Turkic\z:}', "");;
    Expect(1, 68680, '\p{Script_Extensions=oldturkic}', "");
    Expect(0, 68680, '\p{^Script_Extensions=oldturkic}', "");
    Expect(0, 68680, '\P{Script_Extensions=oldturkic}', "");
    Expect(1, 68680, '\P{^Script_Extensions=oldturkic}', "");
    Expect(0, 68681, '\p{Script_Extensions=oldturkic}', "");
    Expect(1, 68681, '\p{^Script_Extensions=oldturkic}', "");
    Expect(1, 68681, '\P{Script_Extensions=oldturkic}', "");
    Expect(0, 68681, '\P{^Script_Extensions=oldturkic}', "");
    Expect(1, 68680, '\p{Script_Extensions=:\Aoldturkic\z:}', "");;
    Expect(0, 68681, '\p{Script_Extensions=:\Aoldturkic\z:}', "");;
    Expect(1, 68680, '\p{Script_Extensions= 	Old_TURKIC}', "");
    Expect(0, 68680, '\p{^Script_Extensions= 	Old_TURKIC}', "");
    Expect(0, 68680, '\P{Script_Extensions= 	Old_TURKIC}', "");
    Expect(1, 68680, '\P{^Script_Extensions= 	Old_TURKIC}', "");
    Expect(0, 68681, '\p{Script_Extensions= 	Old_TURKIC}', "");
    Expect(1, 68681, '\p{^Script_Extensions= 	Old_TURKIC}', "");
    Expect(1, 68681, '\P{Script_Extensions= 	Old_TURKIC}', "");
    Expect(0, 68681, '\P{^Script_Extensions= 	Old_TURKIC}', "");
    Error('\p{Scx=/a/	-Orkh}');
    Error('\P{Scx=/a/	-Orkh}');
    Expect(1, 68680, '\p{Scx=:\AOrkh\z:}', "");;
    Expect(0, 68681, '\p{Scx=:\AOrkh\z:}', "");;
    Expect(1, 68680, '\p{Scx:	orkh}', "");
    Expect(0, 68680, '\p{^Scx:	orkh}', "");
    Expect(0, 68680, '\P{Scx:	orkh}', "");
    Expect(1, 68680, '\P{^Scx:	orkh}', "");
    Expect(0, 68681, '\p{Scx:	orkh}', "");
    Expect(1, 68681, '\p{^Scx:	orkh}', "");
    Expect(1, 68681, '\P{Scx:	orkh}', "");
    Expect(0, 68681, '\P{^Scx:	orkh}', "");
    Expect(1, 68680, '\p{Scx=:\Aorkh\z:}', "");;
    Expect(0, 68681, '\p{Scx=:\Aorkh\z:}', "");;
    Expect(1, 68680, '\p{Scx=	_Orkh}', "");
    Expect(0, 68680, '\p{^Scx=	_Orkh}', "");
    Expect(0, 68680, '\P{Scx=	_Orkh}', "");
    Expect(1, 68680, '\P{^Scx=	_Orkh}', "");
    Expect(0, 68681, '\p{Scx=	_Orkh}', "");
    Expect(1, 68681, '\p{^Scx=	_Orkh}', "");
    Expect(1, 68681, '\P{Scx=	_Orkh}', "");
    Expect(0, 68681, '\P{^Scx=	_Orkh}', "");
    Error('\p{Is_Script_Extensions=_ OLD_Turkic/a/}');
    Error('\P{Is_Script_Extensions=_ OLD_Turkic/a/}');
    Expect(1, 68680, '\p{Is_Script_Extensions=oldturkic}', "");
    Expect(0, 68680, '\p{^Is_Script_Extensions=oldturkic}', "");
    Expect(0, 68680, '\P{Is_Script_Extensions=oldturkic}', "");
    Expect(1, 68680, '\P{^Is_Script_Extensions=oldturkic}', "");
    Expect(0, 68681, '\p{Is_Script_Extensions=oldturkic}', "");
    Expect(1, 68681, '\p{^Is_Script_Extensions=oldturkic}', "");
    Expect(1, 68681, '\P{Is_Script_Extensions=oldturkic}', "");
    Expect(0, 68681, '\P{^Is_Script_Extensions=oldturkic}', "");
    Expect(1, 68680, '\p{Is_Script_Extensions=  old_Turkic}', "");
    Expect(0, 68680, '\p{^Is_Script_Extensions=  old_Turkic}', "");
    Expect(0, 68680, '\P{Is_Script_Extensions=  old_Turkic}', "");
    Expect(1, 68680, '\P{^Is_Script_Extensions=  old_Turkic}', "");
    Expect(0, 68681, '\p{Is_Script_Extensions=  old_Turkic}', "");
    Expect(1, 68681, '\p{^Is_Script_Extensions=  old_Turkic}', "");
    Expect(1, 68681, '\P{Is_Script_Extensions=  old_Turkic}', "");
    Expect(0, 68681, '\P{^Is_Script_Extensions=  old_Turkic}', "");
    Error('\p{Is_Scx=	_Orkh:=}');
    Error('\P{Is_Scx=	_Orkh:=}');
    Expect(1, 68680, '\p{Is_Scx=orkh}', "");
    Expect(0, 68680, '\p{^Is_Scx=orkh}', "");
    Expect(0, 68680, '\P{Is_Scx=orkh}', "");
    Expect(1, 68680, '\P{^Is_Scx=orkh}', "");
    Expect(0, 68681, '\p{Is_Scx=orkh}', "");
    Expect(1, 68681, '\p{^Is_Scx=orkh}', "");
    Expect(1, 68681, '\P{Is_Scx=orkh}', "");
    Expect(0, 68681, '\P{^Is_Scx=orkh}', "");
    Expect(1, 68680, '\p{Is_Scx=	 ORKH}', "");
    Expect(0, 68680, '\p{^Is_Scx=	 ORKH}', "");
    Expect(0, 68680, '\P{Is_Scx=	 ORKH}', "");
    Expect(1, 68680, '\P{^Is_Scx=	 ORKH}', "");
    Expect(0, 68681, '\p{Is_Scx=	 ORKH}', "");
    Expect(1, 68681, '\p{^Is_Scx=	 ORKH}', "");
    Expect(1, 68681, '\P{Is_Scx=	 ORKH}', "");
    Expect(0, 68681, '\P{^Is_Scx=	 ORKH}', "");
    Error('\p{Script_Extensions:  Oriya/a/}');
    Error('\P{Script_Extensions:  Oriya/a/}');
    Expect(1, 7410, '\p{Script_Extensions=:\AOriya\z:}', "");;
    Expect(0, 7411, '\p{Script_Extensions=:\AOriya\z:}', "");;
    Expect(1, 7410, '\p{Script_Extensions=oriya}', "");
    Expect(0, 7410, '\p{^Script_Extensions=oriya}', "");
    Expect(0, 7410, '\P{Script_Extensions=oriya}', "");
    Expect(1, 7410, '\P{^Script_Extensions=oriya}', "");
    Expect(0, 7411, '\p{Script_Extensions=oriya}', "");
    Expect(1, 7411, '\p{^Script_Extensions=oriya}', "");
    Expect(1, 7411, '\P{Script_Extensions=oriya}', "");
    Expect(0, 7411, '\P{^Script_Extensions=oriya}', "");
    Expect(1, 7410, '\p{Script_Extensions=:\Aoriya\z:}', "");;
    Expect(0, 7411, '\p{Script_Extensions=:\Aoriya\z:}', "");;
    Expect(1, 7410, '\p{Script_Extensions:- Oriya}', "");
    Expect(0, 7410, '\p{^Script_Extensions:- Oriya}', "");
    Expect(0, 7410, '\P{Script_Extensions:- Oriya}', "");
    Expect(1, 7410, '\P{^Script_Extensions:- Oriya}', "");
    Expect(0, 7411, '\p{Script_Extensions:- Oriya}', "");
    Expect(1, 7411, '\p{^Script_Extensions:- Oriya}', "");
    Expect(1, 7411, '\P{Script_Extensions:- Oriya}', "");
    Expect(0, 7411, '\P{^Script_Extensions:- Oriya}', "");
    Error('\p{Scx=:=	-Orya}');
    Error('\P{Scx=:=	-Orya}');
    Expect(1, 7410, '\p{Scx=:\AOrya\z:}', "");;
    Expect(0, 7411, '\p{Scx=:\AOrya\z:}', "");;
    Expect(1, 7410, '\p{Scx=orya}', "");
    Expect(0, 7410, '\p{^Scx=orya}', "");
    Expect(0, 7410, '\P{Scx=orya}', "");
    Expect(1, 7410, '\P{^Scx=orya}', "");
    Expect(0, 7411, '\p{Scx=orya}', "");
    Expect(1, 7411, '\p{^Scx=orya}', "");
    Expect(1, 7411, '\P{Scx=orya}', "");
    Expect(0, 7411, '\P{^Scx=orya}', "");
    Expect(1, 7410, '\p{Scx=:\Aorya\z:}', "");;
    Expect(0, 7411, '\p{Scx=:\Aorya\z:}', "");;
    Expect(1, 7410, '\p{Scx= -Orya}', "");
    Expect(0, 7410, '\p{^Scx= -Orya}', "");
    Expect(0, 7410, '\P{Scx= -Orya}', "");
    Expect(1, 7410, '\P{^Scx= -Orya}', "");
    Expect(0, 7411, '\p{Scx= -Orya}', "");
    Expect(1, 7411, '\p{^Scx= -Orya}', "");
    Expect(1, 7411, '\P{Scx= -Orya}', "");
    Expect(0, 7411, '\P{^Scx= -Orya}', "");
    Error('\p{Is_Script_Extensions=-/a/oriya}');
    Error('\P{Is_Script_Extensions=-/a/oriya}');
    Expect(1, 7410, '\p{Is_Script_Extensions=oriya}', "");
    Expect(0, 7410, '\p{^Is_Script_Extensions=oriya}', "");
    Expect(0, 7410, '\P{Is_Script_Extensions=oriya}', "");
    Expect(1, 7410, '\P{^Is_Script_Extensions=oriya}', "");
    Expect(0, 7411, '\p{Is_Script_Extensions=oriya}', "");
    Expect(1, 7411, '\p{^Is_Script_Extensions=oriya}', "");
    Expect(1, 7411, '\P{Is_Script_Extensions=oriya}', "");
    Expect(0, 7411, '\P{^Is_Script_Extensions=oriya}', "");
    Expect(1, 7410, '\p{Is_Script_Extensions=	ORIYA}', "");
    Expect(0, 7410, '\p{^Is_Script_Extensions=	ORIYA}', "");
    Expect(0, 7410, '\P{Is_Script_Extensions=	ORIYA}', "");
    Expect(1, 7410, '\P{^Is_Script_Extensions=	ORIYA}', "");
    Expect(0, 7411, '\p{Is_Script_Extensions=	ORIYA}', "");
    Expect(1, 7411, '\p{^Is_Script_Extensions=	ORIYA}', "");
    Expect(1, 7411, '\P{Is_Script_Extensions=	ORIYA}', "");
    Expect(0, 7411, '\P{^Is_Script_Extensions=	ORIYA}', "");
    Error('\p{Is_Scx:		-Orya:=}');
    Error('\P{Is_Scx:		-Orya:=}');
    Expect(1, 7410, '\p{Is_Scx=orya}', "");
    Expect(0, 7410, '\p{^Is_Scx=orya}', "");
    Expect(0, 7410, '\P{Is_Scx=orya}', "");
    Expect(1, 7410, '\P{^Is_Scx=orya}', "");
    Expect(0, 7411, '\p{Is_Scx=orya}', "");
    Expect(1, 7411, '\p{^Is_Scx=orya}', "");
    Expect(1, 7411, '\P{Is_Scx=orya}', "");
    Expect(0, 7411, '\P{^Is_Scx=orya}', "");
    Expect(1, 7410, '\p{Is_Scx= ORYA}', "");
    Expect(0, 7410, '\p{^Is_Scx= ORYA}', "");
    Expect(0, 7410, '\P{Is_Scx= ORYA}', "");
    Expect(1, 7410, '\P{^Is_Scx= ORYA}', "");
    Expect(0, 7411, '\p{Is_Scx= ORYA}', "");
    Expect(1, 7411, '\p{^Is_Scx= ORYA}', "");
    Expect(1, 7411, '\P{Is_Scx= ORYA}', "");
    Expect(0, 7411, '\P{^Is_Scx= ORYA}', "");
    Error('\p{Script_Extensions=:=	-osage}');
    Error('\P{Script_Extensions=:=	-osage}');
    Expect(1, 66811, '\p{Script_Extensions=:\AOsage\z:}', "");;
    Expect(0, 66812, '\p{Script_Extensions=:\AOsage\z:}', "");;
    Expect(1, 66811, '\p{Script_Extensions=osage}', "");
    Expect(0, 66811, '\p{^Script_Extensions=osage}', "");
    Expect(0, 66811, '\P{Script_Extensions=osage}', "");
    Expect(1, 66811, '\P{^Script_Extensions=osage}', "");
    Expect(0, 66812, '\p{Script_Extensions=osage}', "");
    Expect(1, 66812, '\p{^Script_Extensions=osage}', "");
    Expect(1, 66812, '\P{Script_Extensions=osage}', "");
    Expect(0, 66812, '\P{^Script_Extensions=osage}', "");
    Expect(1, 66811, '\p{Script_Extensions=:\Aosage\z:}', "");;
    Expect(0, 66812, '\p{Script_Extensions=:\Aosage\z:}', "");;
    Expect(1, 66811, '\p{Script_Extensions=-	Osage}', "");
    Expect(0, 66811, '\p{^Script_Extensions=-	Osage}', "");
    Expect(0, 66811, '\P{Script_Extensions=-	Osage}', "");
    Expect(1, 66811, '\P{^Script_Extensions=-	Osage}', "");
    Expect(0, 66812, '\p{Script_Extensions=-	Osage}', "");
    Expect(1, 66812, '\p{^Script_Extensions=-	Osage}', "");
    Expect(1, 66812, '\P{Script_Extensions=-	Osage}', "");
    Expect(0, 66812, '\P{^Script_Extensions=-	Osage}', "");
    Error('\p{Scx=_	osge:=}');
    Error('\P{Scx=_	osge:=}');
    Expect(1, 66811, '\p{Scx=:\AOsge\z:}', "");;
    Expect(0, 66812, '\p{Scx=:\AOsge\z:}', "");;
    Expect(1, 66811, '\p{Scx=osge}', "");
    Expect(0, 66811, '\p{^Scx=osge}', "");
    Expect(0, 66811, '\P{Scx=osge}', "");
    Expect(1, 66811, '\P{^Scx=osge}', "");
    Expect(0, 66812, '\p{Scx=osge}', "");
    Expect(1, 66812, '\p{^Scx=osge}', "");
    Expect(1, 66812, '\P{Scx=osge}', "");
    Expect(0, 66812, '\P{^Scx=osge}', "");
    Expect(1, 66811, '\p{Scx=:\Aosge\z:}', "");;
    Expect(0, 66812, '\p{Scx=:\Aosge\z:}', "");;
    Expect(1, 66811, '\p{Scx=-	Osge}', "");
    Expect(0, 66811, '\p{^Scx=-	Osge}', "");
    Expect(0, 66811, '\P{Scx=-	Osge}', "");
    Expect(1, 66811, '\P{^Scx=-	Osge}', "");
    Expect(0, 66812, '\p{Scx=-	Osge}', "");
    Expect(1, 66812, '\p{^Scx=-	Osge}', "");
    Expect(1, 66812, '\P{Scx=-	Osge}', "");
    Expect(0, 66812, '\P{^Scx=-	Osge}', "");
    Error('\p{Is_Script_Extensions:   /a/ _Osage}');
    Error('\P{Is_Script_Extensions:   /a/ _Osage}');
    Expect(1, 66811, '\p{Is_Script_Extensions=osage}', "");
    Expect(0, 66811, '\p{^Is_Script_Extensions=osage}', "");
    Expect(0, 66811, '\P{Is_Script_Extensions=osage}', "");
    Expect(1, 66811, '\P{^Is_Script_Extensions=osage}', "");
    Expect(0, 66812, '\p{Is_Script_Extensions=osage}', "");
    Expect(1, 66812, '\p{^Is_Script_Extensions=osage}', "");
    Expect(1, 66812, '\P{Is_Script_Extensions=osage}', "");
    Expect(0, 66812, '\P{^Is_Script_Extensions=osage}', "");
    Expect(1, 66811, '\p{Is_Script_Extensions=		OSAGE}', "");
    Expect(0, 66811, '\p{^Is_Script_Extensions=		OSAGE}', "");
    Expect(0, 66811, '\P{Is_Script_Extensions=		OSAGE}', "");
    Expect(1, 66811, '\P{^Is_Script_Extensions=		OSAGE}', "");
    Expect(0, 66812, '\p{Is_Script_Extensions=		OSAGE}', "");
    Expect(1, 66812, '\p{^Is_Script_Extensions=		OSAGE}', "");
    Expect(1, 66812, '\P{Is_Script_Extensions=		OSAGE}', "");
    Expect(0, 66812, '\P{^Is_Script_Extensions=		OSAGE}', "");
    Error('\p{Is_Scx=/a/ Osge}');
    Error('\P{Is_Scx=/a/ Osge}');
    Expect(1, 66811, '\p{Is_Scx=osge}', "");
    Expect(0, 66811, '\p{^Is_Scx=osge}', "");
    Expect(0, 66811, '\P{Is_Scx=osge}', "");
    Expect(1, 66811, '\P{^Is_Scx=osge}', "");
    Expect(0, 66812, '\p{Is_Scx=osge}', "");
    Expect(1, 66812, '\p{^Is_Scx=osge}', "");
    Expect(1, 66812, '\P{Is_Scx=osge}', "");
    Expect(0, 66812, '\P{^Is_Scx=osge}', "");
    Expect(1, 66811, '\p{Is_Scx=	osge}', "");
    Expect(0, 66811, '\p{^Is_Scx=	osge}', "");
    Expect(0, 66811, '\P{Is_Scx=	osge}', "");
    Expect(1, 66811, '\P{^Is_Scx=	osge}', "");
    Expect(0, 66812, '\p{Is_Scx=	osge}', "");
    Expect(1, 66812, '\p{^Is_Scx=	osge}', "");
    Expect(1, 66812, '\P{Is_Scx=	osge}', "");
    Expect(0, 66812, '\P{^Is_Scx=	osge}', "");
    Error('\p{Script_Extensions=	_osmanya/a/}');
    Error('\P{Script_Extensions=	_osmanya/a/}');
    Expect(1, 66729, '\p{Script_Extensions=:\AOsmanya\z:}', "");;
    Expect(0, 66730, '\p{Script_Extensions=:\AOsmanya\z:}', "");;
    Expect(1, 66729, '\p{Script_Extensions=osmanya}', "");
    Expect(0, 66729, '\p{^Script_Extensions=osmanya}', "");
    Expect(0, 66729, '\P{Script_Extensions=osmanya}', "");
    Expect(1, 66729, '\P{^Script_Extensions=osmanya}', "");
    Expect(0, 66730, '\p{Script_Extensions=osmanya}', "");
    Expect(1, 66730, '\p{^Script_Extensions=osmanya}', "");
    Expect(1, 66730, '\P{Script_Extensions=osmanya}', "");
    Expect(0, 66730, '\P{^Script_Extensions=osmanya}', "");
    Expect(1, 66729, '\p{Script_Extensions=:\Aosmanya\z:}', "");;
    Expect(0, 66730, '\p{Script_Extensions=:\Aosmanya\z:}', "");;
    Expect(1, 66729, '\p{Script_Extensions=	 osmanya}', "");
    Expect(0, 66729, '\p{^Script_Extensions=	 osmanya}', "");
    Expect(0, 66729, '\P{Script_Extensions=	 osmanya}', "");
    Expect(1, 66729, '\P{^Script_Extensions=	 osmanya}', "");
    Expect(0, 66730, '\p{Script_Extensions=	 osmanya}', "");
    Expect(1, 66730, '\p{^Script_Extensions=	 osmanya}', "");
    Expect(1, 66730, '\P{Script_Extensions=	 osmanya}', "");
    Expect(0, 66730, '\P{^Script_Extensions=	 osmanya}', "");
    Error('\p{Scx=/a/Osma}');
    Error('\P{Scx=/a/Osma}');
    Expect(1, 66729, '\p{Scx=:\AOsma\z:}', "");;
    Expect(0, 66730, '\p{Scx=:\AOsma\z:}', "");;
    Expect(1, 66729, '\p{Scx=osma}', "");
    Expect(0, 66729, '\p{^Scx=osma}', "");
    Expect(0, 66729, '\P{Scx=osma}', "");
    Expect(1, 66729, '\P{^Scx=osma}', "");
    Expect(0, 66730, '\p{Scx=osma}', "");
    Expect(1, 66730, '\p{^Scx=osma}', "");
    Expect(1, 66730, '\P{Scx=osma}', "");
    Expect(0, 66730, '\P{^Scx=osma}', "");
    Expect(1, 66729, '\p{Scx=:\Aosma\z:}', "");;
    Expect(0, 66730, '\p{Scx=:\Aosma\z:}', "");;
    Expect(1, 66729, '\p{Scx=-	Osma}', "");
    Expect(0, 66729, '\p{^Scx=-	Osma}', "");
    Expect(0, 66729, '\P{Scx=-	Osma}', "");
    Expect(1, 66729, '\P{^Scx=-	Osma}', "");
    Expect(0, 66730, '\p{Scx=-	Osma}', "");
    Expect(1, 66730, '\p{^Scx=-	Osma}', "");
    Expect(1, 66730, '\P{Scx=-	Osma}', "");
    Expect(0, 66730, '\P{^Scx=-	Osma}', "");
    Error('\p{Is_Script_Extensions=:=__Osmanya}');
    Error('\P{Is_Script_Extensions=:=__Osmanya}');
    Expect(1, 66729, '\p{Is_Script_Extensions=osmanya}', "");
    Expect(0, 66729, '\p{^Is_Script_Extensions=osmanya}', "");
    Expect(0, 66729, '\P{Is_Script_Extensions=osmanya}', "");
    Expect(1, 66729, '\P{^Is_Script_Extensions=osmanya}', "");
    Expect(0, 66730, '\p{Is_Script_Extensions=osmanya}', "");
    Expect(1, 66730, '\p{^Is_Script_Extensions=osmanya}', "");
    Expect(1, 66730, '\P{Is_Script_Extensions=osmanya}', "");
    Expect(0, 66730, '\P{^Is_Script_Extensions=osmanya}', "");
    Expect(1, 66729, '\p{Is_Script_Extensions:   -osmanya}', "");
    Expect(0, 66729, '\p{^Is_Script_Extensions:   -osmanya}', "");
    Expect(0, 66729, '\P{Is_Script_Extensions:   -osmanya}', "");
    Expect(1, 66729, '\P{^Is_Script_Extensions:   -osmanya}', "");
    Expect(0, 66730, '\p{Is_Script_Extensions:   -osmanya}', "");
    Expect(1, 66730, '\p{^Is_Script_Extensions:   -osmanya}', "");
    Expect(1, 66730, '\P{Is_Script_Extensions:   -osmanya}', "");
    Expect(0, 66730, '\P{^Is_Script_Extensions:   -osmanya}', "");
    Error('\p{Is_Scx=:=	 OSMA}');
    Error('\P{Is_Scx=:=	 OSMA}');
    Expect(1, 66729, '\p{Is_Scx=osma}', "");
    Expect(0, 66729, '\p{^Is_Scx=osma}', "");
    Expect(0, 66729, '\P{Is_Scx=osma}', "");
    Expect(1, 66729, '\P{^Is_Scx=osma}', "");
    Expect(0, 66730, '\p{Is_Scx=osma}', "");
    Expect(1, 66730, '\p{^Is_Scx=osma}', "");
    Expect(1, 66730, '\P{Is_Scx=osma}', "");
    Expect(0, 66730, '\P{^Is_Scx=osma}', "");
    Expect(1, 66729, '\p{Is_Scx=--Osma}', "");
    Expect(0, 66729, '\p{^Is_Scx=--Osma}', "");
    Expect(0, 66729, '\P{Is_Scx=--Osma}', "");
    Expect(1, 66729, '\P{^Is_Scx=--Osma}', "");
    Expect(0, 66730, '\p{Is_Scx=--Osma}', "");
    Expect(1, 66730, '\p{^Is_Scx=--Osma}', "");
    Expect(1, 66730, '\P{Is_Scx=--Osma}', "");
    Expect(0, 66730, '\P{^Is_Scx=--Osma}', "");
    Error('\p{Script_Extensions=:= 	palmyrene}');
    Error('\P{Script_Extensions=:= 	palmyrene}');
    Expect(1, 67711, '\p{Script_Extensions=:\APalmyrene\z:}', "");;
    Expect(0, 67712, '\p{Script_Extensions=:\APalmyrene\z:}', "");;
    Expect(1, 67711, '\p{Script_Extensions=palmyrene}', "");
    Expect(0, 67711, '\p{^Script_Extensions=palmyrene}', "");
    Expect(0, 67711, '\P{Script_Extensions=palmyrene}', "");
    Expect(1, 67711, '\P{^Script_Extensions=palmyrene}', "");
    Expect(0, 67712, '\p{Script_Extensions=palmyrene}', "");
    Expect(1, 67712, '\p{^Script_Extensions=palmyrene}', "");
    Expect(1, 67712, '\P{Script_Extensions=palmyrene}', "");
    Expect(0, 67712, '\P{^Script_Extensions=palmyrene}', "");
    Expect(1, 67711, '\p{Script_Extensions=:\Apalmyrene\z:}', "");;
    Expect(0, 67712, '\p{Script_Extensions=:\Apalmyrene\z:}', "");;
    Expect(1, 67711, '\p{Script_Extensions:	_Palmyrene}', "");
    Expect(0, 67711, '\p{^Script_Extensions:	_Palmyrene}', "");
    Expect(0, 67711, '\P{Script_Extensions:	_Palmyrene}', "");
    Expect(1, 67711, '\P{^Script_Extensions:	_Palmyrene}', "");
    Expect(0, 67712, '\p{Script_Extensions:	_Palmyrene}', "");
    Expect(1, 67712, '\p{^Script_Extensions:	_Palmyrene}', "");
    Expect(1, 67712, '\P{Script_Extensions:	_Palmyrene}', "");
    Expect(0, 67712, '\P{^Script_Extensions:	_Palmyrene}', "");
    Error('\p{Scx= /a/palm}');
    Error('\P{Scx= /a/palm}');
    Expect(1, 67711, '\p{Scx=:\APalm\z:}', "");;
    Expect(0, 67712, '\p{Scx=:\APalm\z:}', "");;
    Expect(1, 67711, '\p{Scx=palm}', "");
    Expect(0, 67711, '\p{^Scx=palm}', "");
    Expect(0, 67711, '\P{Scx=palm}', "");
    Expect(1, 67711, '\P{^Scx=palm}', "");
    Expect(0, 67712, '\p{Scx=palm}', "");
    Expect(1, 67712, '\p{^Scx=palm}', "");
    Expect(1, 67712, '\P{Scx=palm}', "");
    Expect(0, 67712, '\P{^Scx=palm}', "");
    Expect(1, 67711, '\p{Scx=:\Apalm\z:}', "");;
    Expect(0, 67712, '\p{Scx=:\Apalm\z:}', "");;
    Expect(1, 67711, '\p{Scx=--palm}', "");
    Expect(0, 67711, '\p{^Scx=--palm}', "");
    Expect(0, 67711, '\P{Scx=--palm}', "");
    Expect(1, 67711, '\P{^Scx=--palm}', "");
    Expect(0, 67712, '\p{Scx=--palm}', "");
    Expect(1, 67712, '\p{^Scx=--palm}', "");
    Expect(1, 67712, '\P{Scx=--palm}', "");
    Expect(0, 67712, '\P{^Scx=--palm}', "");
    Error('\p{Is_Script_Extensions=-Palmyrene/a/}');
    Error('\P{Is_Script_Extensions=-Palmyrene/a/}');
    Expect(1, 67711, '\p{Is_Script_Extensions=palmyrene}', "");
    Expect(0, 67711, '\p{^Is_Script_Extensions=palmyrene}', "");
    Expect(0, 67711, '\P{Is_Script_Extensions=palmyrene}', "");
    Expect(1, 67711, '\P{^Is_Script_Extensions=palmyrene}', "");
    Expect(0, 67712, '\p{Is_Script_Extensions=palmyrene}', "");
    Expect(1, 67712, '\p{^Is_Script_Extensions=palmyrene}', "");
    Expect(1, 67712, '\P{Is_Script_Extensions=palmyrene}', "");
    Expect(0, 67712, '\P{^Is_Script_Extensions=palmyrene}', "");
    Expect(1, 67711, '\p{Is_Script_Extensions=_PALMYRENE}', "");
    Expect(0, 67711, '\p{^Is_Script_Extensions=_PALMYRENE}', "");
    Expect(0, 67711, '\P{Is_Script_Extensions=_PALMYRENE}', "");
    Expect(1, 67711, '\P{^Is_Script_Extensions=_PALMYRENE}', "");
    Expect(0, 67712, '\p{Is_Script_Extensions=_PALMYRENE}', "");
    Expect(1, 67712, '\p{^Is_Script_Extensions=_PALMYRENE}', "");
    Expect(1, 67712, '\P{Is_Script_Extensions=_PALMYRENE}', "");
    Expect(0, 67712, '\P{^Is_Script_Extensions=_PALMYRENE}', "");
    Error('\p{Is_Scx:_:=palm}');
    Error('\P{Is_Scx:_:=palm}');
    Expect(1, 67711, '\p{Is_Scx=palm}', "");
    Expect(0, 67711, '\p{^Is_Scx=palm}', "");
    Expect(0, 67711, '\P{Is_Scx=palm}', "");
    Expect(1, 67711, '\P{^Is_Scx=palm}', "");
    Expect(0, 67712, '\p{Is_Scx=palm}', "");
    Expect(1, 67712, '\p{^Is_Scx=palm}', "");
    Expect(1, 67712, '\P{Is_Scx=palm}', "");
    Expect(0, 67712, '\P{^Is_Scx=palm}', "");
    Expect(1, 67711, '\p{Is_Scx=		palm}', "");
    Expect(0, 67711, '\p{^Is_Scx=		palm}', "");
    Expect(0, 67711, '\P{Is_Scx=		palm}', "");
    Expect(1, 67711, '\P{^Is_Scx=		palm}', "");
    Expect(0, 67712, '\p{Is_Scx=		palm}', "");
    Expect(1, 67712, '\p{^Is_Scx=		palm}', "");
    Expect(1, 67712, '\P{Is_Scx=		palm}', "");
    Expect(0, 67712, '\P{^Is_Scx=		palm}', "");
    Error('\p{Script_Extensions=-pau_CIN_Hau:=}');
    Error('\P{Script_Extensions=-pau_CIN_Hau:=}');
    Expect(1, 72440, '\p{Script_Extensions=:\APau_Cin_Hau\z:}', "");;
    Expect(0, 72441, '\p{Script_Extensions=:\APau_Cin_Hau\z:}', "");;
    Expect(1, 72440, '\p{Script_Extensions=paucinhau}', "");
    Expect(0, 72440, '\p{^Script_Extensions=paucinhau}', "");
    Expect(0, 72440, '\P{Script_Extensions=paucinhau}', "");
    Expect(1, 72440, '\P{^Script_Extensions=paucinhau}', "");
    Expect(0, 72441, '\p{Script_Extensions=paucinhau}', "");
    Expect(1, 72441, '\p{^Script_Extensions=paucinhau}', "");
    Expect(1, 72441, '\P{Script_Extensions=paucinhau}', "");
    Expect(0, 72441, '\P{^Script_Extensions=paucinhau}', "");
    Expect(1, 72440, '\p{Script_Extensions=:\Apaucinhau\z:}', "");;
    Expect(0, 72441, '\p{Script_Extensions=:\Apaucinhau\z:}', "");;
    Expect(1, 72440, '\p{Script_Extensions=		PAU_Cin_Hau}', "");
    Expect(0, 72440, '\p{^Script_Extensions=		PAU_Cin_Hau}', "");
    Expect(0, 72440, '\P{Script_Extensions=		PAU_Cin_Hau}', "");
    Expect(1, 72440, '\P{^Script_Extensions=		PAU_Cin_Hau}', "");
    Expect(0, 72441, '\p{Script_Extensions=		PAU_Cin_Hau}', "");
    Expect(1, 72441, '\p{^Script_Extensions=		PAU_Cin_Hau}', "");
    Expect(1, 72441, '\P{Script_Extensions=		PAU_Cin_Hau}', "");
    Expect(0, 72441, '\P{^Script_Extensions=		PAU_Cin_Hau}', "");
    Error('\p{Scx:  _pauc/a/}');
    Error('\P{Scx:  _pauc/a/}');
    Expect(1, 72440, '\p{Scx=:\APauc\z:}', "");;
    Expect(0, 72441, '\p{Scx=:\APauc\z:}', "");;
    Expect(1, 72440, '\p{Scx=pauc}', "");
    Expect(0, 72440, '\p{^Scx=pauc}', "");
    Expect(0, 72440, '\P{Scx=pauc}', "");
    Expect(1, 72440, '\P{^Scx=pauc}', "");
    Expect(0, 72441, '\p{Scx=pauc}', "");
    Expect(1, 72441, '\p{^Scx=pauc}', "");
    Expect(1, 72441, '\P{Scx=pauc}', "");
    Expect(0, 72441, '\P{^Scx=pauc}', "");
    Expect(1, 72440, '\p{Scx=:\Apauc\z:}', "");;
    Expect(0, 72441, '\p{Scx=:\Apauc\z:}', "");;
    Expect(1, 72440, '\p{Scx=  Pauc}', "");
    Expect(0, 72440, '\p{^Scx=  Pauc}', "");
    Expect(0, 72440, '\P{Scx=  Pauc}', "");
    Expect(1, 72440, '\P{^Scx=  Pauc}', "");
    Expect(0, 72441, '\p{Scx=  Pauc}', "");
    Expect(1, 72441, '\p{^Scx=  Pauc}', "");
    Expect(1, 72441, '\P{Scx=  Pauc}', "");
    Expect(0, 72441, '\P{^Scx=  Pauc}', "");
    Error('\p{Is_Script_Extensions=--Pau_cin_hau/a/}');
    Error('\P{Is_Script_Extensions=--Pau_cin_hau/a/}');
    Expect(1, 72440, '\p{Is_Script_Extensions=paucinhau}', "");
    Expect(0, 72440, '\p{^Is_Script_Extensions=paucinhau}', "");
    Expect(0, 72440, '\P{Is_Script_Extensions=paucinhau}', "");
    Expect(1, 72440, '\P{^Is_Script_Extensions=paucinhau}', "");
    Expect(0, 72441, '\p{Is_Script_Extensions=paucinhau}', "");
    Expect(1, 72441, '\p{^Is_Script_Extensions=paucinhau}', "");
    Expect(1, 72441, '\P{Is_Script_Extensions=paucinhau}', "");
    Expect(0, 72441, '\P{^Is_Script_Extensions=paucinhau}', "");
    Expect(1, 72440, '\p{Is_Script_Extensions:	_Pau_Cin_hau}', "");
    Expect(0, 72440, '\p{^Is_Script_Extensions:	_Pau_Cin_hau}', "");
    Expect(0, 72440, '\P{Is_Script_Extensions:	_Pau_Cin_hau}', "");
    Expect(1, 72440, '\P{^Is_Script_Extensions:	_Pau_Cin_hau}', "");
    Expect(0, 72441, '\p{Is_Script_Extensions:	_Pau_Cin_hau}', "");
    Expect(1, 72441, '\p{^Is_Script_Extensions:	_Pau_Cin_hau}', "");
    Expect(1, 72441, '\P{Is_Script_Extensions:	_Pau_Cin_hau}', "");
    Expect(0, 72441, '\P{^Is_Script_Extensions:	_Pau_Cin_hau}', "");
    Error('\p{Is_Scx=-/a/Pauc}');
    Error('\P{Is_Scx=-/a/Pauc}');
    Expect(1, 72440, '\p{Is_Scx=pauc}', "");
    Expect(0, 72440, '\p{^Is_Scx=pauc}', "");
    Expect(0, 72440, '\P{Is_Scx=pauc}', "");
    Expect(1, 72440, '\P{^Is_Scx=pauc}', "");
    Expect(0, 72441, '\p{Is_Scx=pauc}', "");
    Expect(1, 72441, '\p{^Is_Scx=pauc}', "");
    Expect(1, 72441, '\P{Is_Scx=pauc}', "");
    Expect(0, 72441, '\P{^Is_Scx=pauc}', "");
    Expect(1, 72440, '\p{Is_Scx=-Pauc}', "");
    Expect(0, 72440, '\p{^Is_Scx=-Pauc}', "");
    Expect(0, 72440, '\P{Is_Scx=-Pauc}', "");
    Expect(1, 72440, '\P{^Is_Scx=-Pauc}', "");
    Expect(0, 72441, '\p{Is_Scx=-Pauc}', "");
    Expect(1, 72441, '\p{^Is_Scx=-Pauc}', "");
    Expect(1, 72441, '\P{Is_Scx=-Pauc}', "");
    Expect(0, 72441, '\P{^Is_Scx=-Pauc}', "");
    Error('\p{Script_Extensions=_:=Old_permic}');
    Error('\P{Script_Extensions=_:=Old_permic}');
    Expect(1, 66426, '\p{Script_Extensions=:\AOld_Permic\z:}', "");;
    Expect(0, 66427, '\p{Script_Extensions=:\AOld_Permic\z:}', "");;
    Expect(1, 66426, '\p{Script_Extensions=oldpermic}', "");
    Expect(0, 66426, '\p{^Script_Extensions=oldpermic}', "");
    Expect(0, 66426, '\P{Script_Extensions=oldpermic}', "");
    Expect(1, 66426, '\P{^Script_Extensions=oldpermic}', "");
    Expect(0, 66427, '\p{Script_Extensions=oldpermic}', "");
    Expect(1, 66427, '\p{^Script_Extensions=oldpermic}', "");
    Expect(1, 66427, '\P{Script_Extensions=oldpermic}', "");
    Expect(0, 66427, '\P{^Script_Extensions=oldpermic}', "");
    Expect(1, 66426, '\p{Script_Extensions=:\Aoldpermic\z:}', "");;
    Expect(0, 66427, '\p{Script_Extensions=:\Aoldpermic\z:}', "");;
    Expect(1, 66426, '\p{Script_Extensions= _Old_Permic}', "");
    Expect(0, 66426, '\p{^Script_Extensions= _Old_Permic}', "");
    Expect(0, 66426, '\P{Script_Extensions= _Old_Permic}', "");
    Expect(1, 66426, '\P{^Script_Extensions= _Old_Permic}', "");
    Expect(0, 66427, '\p{Script_Extensions= _Old_Permic}', "");
    Expect(1, 66427, '\p{^Script_Extensions= _Old_Permic}', "");
    Expect(1, 66427, '\P{Script_Extensions= _Old_Permic}', "");
    Expect(0, 66427, '\P{^Script_Extensions= _Old_Permic}', "");
    Error('\p{Scx:- Perm:=}');
    Error('\P{Scx:- Perm:=}');
    Expect(1, 66426, '\p{Scx=:\APerm\z:}', "");;
    Expect(0, 66427, '\p{Scx=:\APerm\z:}', "");;
    Expect(1, 66426, '\p{Scx=perm}', "");
    Expect(0, 66426, '\p{^Scx=perm}', "");
    Expect(0, 66426, '\P{Scx=perm}', "");
    Expect(1, 66426, '\P{^Scx=perm}', "");
    Expect(0, 66427, '\p{Scx=perm}', "");
    Expect(1, 66427, '\p{^Scx=perm}', "");
    Expect(1, 66427, '\P{Scx=perm}', "");
    Expect(0, 66427, '\P{^Scx=perm}', "");
    Expect(1, 66426, '\p{Scx=:\Aperm\z:}', "");;
    Expect(0, 66427, '\p{Scx=:\Aperm\z:}', "");;
    Expect(1, 66426, '\p{Scx=-Perm}', "");
    Expect(0, 66426, '\p{^Scx=-Perm}', "");
    Expect(0, 66426, '\P{Scx=-Perm}', "");
    Expect(1, 66426, '\P{^Scx=-Perm}', "");
    Expect(0, 66427, '\p{Scx=-Perm}', "");
    Expect(1, 66427, '\p{^Scx=-Perm}', "");
    Expect(1, 66427, '\P{Scx=-Perm}', "");
    Expect(0, 66427, '\P{^Scx=-Perm}', "");
    Error('\p{Is_Script_Extensions=	Old_permic/a/}');
    Error('\P{Is_Script_Extensions=	Old_permic/a/}');
    Expect(1, 66426, '\p{Is_Script_Extensions=oldpermic}', "");
    Expect(0, 66426, '\p{^Is_Script_Extensions=oldpermic}', "");
    Expect(0, 66426, '\P{Is_Script_Extensions=oldpermic}', "");
    Expect(1, 66426, '\P{^Is_Script_Extensions=oldpermic}', "");
    Expect(0, 66427, '\p{Is_Script_Extensions=oldpermic}', "");
    Expect(1, 66427, '\p{^Is_Script_Extensions=oldpermic}', "");
    Expect(1, 66427, '\P{Is_Script_Extensions=oldpermic}', "");
    Expect(0, 66427, '\P{^Is_Script_Extensions=oldpermic}', "");
    Expect(1, 66426, '\p{Is_Script_Extensions=_-old_Permic}', "");
    Expect(0, 66426, '\p{^Is_Script_Extensions=_-old_Permic}', "");
    Expect(0, 66426, '\P{Is_Script_Extensions=_-old_Permic}', "");
    Expect(1, 66426, '\P{^Is_Script_Extensions=_-old_Permic}', "");
    Expect(0, 66427, '\p{Is_Script_Extensions=_-old_Permic}', "");
    Expect(1, 66427, '\p{^Is_Script_Extensions=_-old_Permic}', "");
    Expect(1, 66427, '\P{Is_Script_Extensions=_-old_Permic}', "");
    Expect(0, 66427, '\P{^Is_Script_Extensions=_-old_Permic}', "");
    Error('\p{Is_Scx= PERM:=}');
    Error('\P{Is_Scx= PERM:=}');
    Expect(1, 66426, '\p{Is_Scx=perm}', "");
    Expect(0, 66426, '\p{^Is_Scx=perm}', "");
    Expect(0, 66426, '\P{Is_Scx=perm}', "");
    Expect(1, 66426, '\P{^Is_Scx=perm}', "");
    Expect(0, 66427, '\p{Is_Scx=perm}', "");
    Expect(1, 66427, '\p{^Is_Scx=perm}', "");
    Expect(1, 66427, '\P{Is_Scx=perm}', "");
    Expect(0, 66427, '\P{^Is_Scx=perm}', "");
    Expect(1, 66426, '\p{Is_Scx=_-PERM}', "");
    Expect(0, 66426, '\p{^Is_Scx=_-PERM}', "");
    Expect(0, 66426, '\P{Is_Scx=_-PERM}', "");
    Expect(1, 66426, '\P{^Is_Scx=_-PERM}', "");
    Expect(0, 66427, '\p{Is_Scx=_-PERM}', "");
    Expect(1, 66427, '\p{^Is_Scx=_-PERM}', "");
    Expect(1, 66427, '\P{Is_Scx=_-PERM}', "");
    Expect(0, 66427, '\P{^Is_Scx=_-PERM}', "");
    Error('\p{Script_Extensions=-_PHAGS_PA/a/}');
    Error('\P{Script_Extensions=-_PHAGS_PA/a/}');
    Expect(1, 43127, '\p{Script_Extensions=:\APhags_Pa\z:}', "");;
    Expect(0, 43128, '\p{Script_Extensions=:\APhags_Pa\z:}', "");;
    Expect(1, 43127, '\p{Script_Extensions=phagspa}', "");
    Expect(0, 43127, '\p{^Script_Extensions=phagspa}', "");
    Expect(0, 43127, '\P{Script_Extensions=phagspa}', "");
    Expect(1, 43127, '\P{^Script_Extensions=phagspa}', "");
    Expect(0, 43128, '\p{Script_Extensions=phagspa}', "");
    Expect(1, 43128, '\p{^Script_Extensions=phagspa}', "");
    Expect(1, 43128, '\P{Script_Extensions=phagspa}', "");
    Expect(0, 43128, '\P{^Script_Extensions=phagspa}', "");
    Expect(1, 43127, '\p{Script_Extensions=:\Aphagspa\z:}', "");;
    Expect(0, 43128, '\p{Script_Extensions=:\Aphagspa\z:}', "");;
    Expect(1, 43127, '\p{Script_Extensions=-	phags_PA}', "");
    Expect(0, 43127, '\p{^Script_Extensions=-	phags_PA}', "");
    Expect(0, 43127, '\P{Script_Extensions=-	phags_PA}', "");
    Expect(1, 43127, '\P{^Script_Extensions=-	phags_PA}', "");
    Expect(0, 43128, '\p{Script_Extensions=-	phags_PA}', "");
    Expect(1, 43128, '\p{^Script_Extensions=-	phags_PA}', "");
    Expect(1, 43128, '\P{Script_Extensions=-	phags_PA}', "");
    Expect(0, 43128, '\P{^Script_Extensions=-	phags_PA}', "");
    Error('\p{Scx=/a/_Phag}');
    Error('\P{Scx=/a/_Phag}');
    Expect(1, 43127, '\p{Scx=:\APhag\z:}', "");;
    Expect(0, 43128, '\p{Scx=:\APhag\z:}', "");;
    Expect(1, 43127, '\p{Scx=phag}', "");
    Expect(0, 43127, '\p{^Scx=phag}', "");
    Expect(0, 43127, '\P{Scx=phag}', "");
    Expect(1, 43127, '\P{^Scx=phag}', "");
    Expect(0, 43128, '\p{Scx=phag}', "");
    Expect(1, 43128, '\p{^Scx=phag}', "");
    Expect(1, 43128, '\P{Scx=phag}', "");
    Expect(0, 43128, '\P{^Scx=phag}', "");
    Expect(1, 43127, '\p{Scx=:\Aphag\z:}', "");;
    Expect(0, 43128, '\p{Scx=:\Aphag\z:}', "");;
    Expect(1, 43127, '\p{Scx:  _Phag}', "");
    Expect(0, 43127, '\p{^Scx:  _Phag}', "");
    Expect(0, 43127, '\P{Scx:  _Phag}', "");
    Expect(1, 43127, '\P{^Scx:  _Phag}', "");
    Expect(0, 43128, '\p{Scx:  _Phag}', "");
    Expect(1, 43128, '\p{^Scx:  _Phag}', "");
    Expect(1, 43128, '\P{Scx:  _Phag}', "");
    Expect(0, 43128, '\P{^Scx:  _Phag}', "");
    Error('\p{Is_Script_Extensions=-_PHAGS_pa:=}');
    Error('\P{Is_Script_Extensions=-_PHAGS_pa:=}');
    Expect(1, 43127, '\p{Is_Script_Extensions=phagspa}', "");
    Expect(0, 43127, '\p{^Is_Script_Extensions=phagspa}', "");
    Expect(0, 43127, '\P{Is_Script_Extensions=phagspa}', "");
    Expect(1, 43127, '\P{^Is_Script_Extensions=phagspa}', "");
    Expect(0, 43128, '\p{Is_Script_Extensions=phagspa}', "");
    Expect(1, 43128, '\p{^Is_Script_Extensions=phagspa}', "");
    Expect(1, 43128, '\P{Is_Script_Extensions=phagspa}', "");
    Expect(0, 43128, '\P{^Is_Script_Extensions=phagspa}', "");
    Expect(1, 43127, '\p{Is_Script_Extensions=PHAGS_Pa}', "");
    Expect(0, 43127, '\p{^Is_Script_Extensions=PHAGS_Pa}', "");
    Expect(0, 43127, '\P{Is_Script_Extensions=PHAGS_Pa}', "");
    Expect(1, 43127, '\P{^Is_Script_Extensions=PHAGS_Pa}', "");
    Expect(0, 43128, '\p{Is_Script_Extensions=PHAGS_Pa}', "");
    Expect(1, 43128, '\p{^Is_Script_Extensions=PHAGS_Pa}', "");
    Expect(1, 43128, '\P{Is_Script_Extensions=PHAGS_Pa}', "");
    Expect(0, 43128, '\P{^Is_Script_Extensions=PHAGS_Pa}', "");
    Error('\p{Is_Scx=/a/ -PHAG}');
    Error('\P{Is_Scx=/a/ -PHAG}');
    Expect(1, 43127, '\p{Is_Scx=phag}', "");
    Expect(0, 43127, '\p{^Is_Scx=phag}', "");
    Expect(0, 43127, '\P{Is_Scx=phag}', "");
    Expect(1, 43127, '\P{^Is_Scx=phag}', "");
    Expect(0, 43128, '\p{Is_Scx=phag}', "");
    Expect(1, 43128, '\p{^Is_Scx=phag}', "");
    Expect(1, 43128, '\P{Is_Scx=phag}', "");
    Expect(0, 43128, '\P{^Is_Scx=phag}', "");
    Expect(1, 43127, '\p{Is_Scx=-_Phag}', "");
    Expect(0, 43127, '\p{^Is_Scx=-_Phag}', "");
    Expect(0, 43127, '\P{Is_Scx=-_Phag}', "");
    Expect(1, 43127, '\P{^Is_Scx=-_Phag}', "");
    Expect(0, 43128, '\p{Is_Scx=-_Phag}', "");
    Expect(1, 43128, '\p{^Is_Scx=-_Phag}', "");
    Expect(1, 43128, '\P{Is_Scx=-_Phag}', "");
    Expect(0, 43128, '\P{^Is_Scx=-_Phag}', "");
    Error('\p{Script_Extensions=	 inscriptional_Pahlavi:=}');
    Error('\P{Script_Extensions=	 inscriptional_Pahlavi:=}');
    Expect(1, 68479, '\p{Script_Extensions=:\AInscriptional_Pahlavi\z:}', "");;
    Expect(0, 68480, '\p{Script_Extensions=:\AInscriptional_Pahlavi\z:}', "");;
    Expect(1, 68479, '\p{Script_Extensions=inscriptionalpahlavi}', "");
    Expect(0, 68479, '\p{^Script_Extensions=inscriptionalpahlavi}', "");
    Expect(0, 68479, '\P{Script_Extensions=inscriptionalpahlavi}', "");
    Expect(1, 68479, '\P{^Script_Extensions=inscriptionalpahlavi}', "");
    Expect(0, 68480, '\p{Script_Extensions=inscriptionalpahlavi}', "");
    Expect(1, 68480, '\p{^Script_Extensions=inscriptionalpahlavi}', "");
    Expect(1, 68480, '\P{Script_Extensions=inscriptionalpahlavi}', "");
    Expect(0, 68480, '\P{^Script_Extensions=inscriptionalpahlavi}', "");
    Expect(1, 68479, '\p{Script_Extensions=:\Ainscriptionalpahlavi\z:}', "");;
    Expect(0, 68480, '\p{Script_Extensions=:\Ainscriptionalpahlavi\z:}', "");;
    Expect(1, 68479, '\p{Script_Extensions:	 Inscriptional_Pahlavi}', "");
    Expect(0, 68479, '\p{^Script_Extensions:	 Inscriptional_Pahlavi}', "");
    Expect(0, 68479, '\P{Script_Extensions:	 Inscriptional_Pahlavi}', "");
    Expect(1, 68479, '\P{^Script_Extensions:	 Inscriptional_Pahlavi}', "");
    Expect(0, 68480, '\p{Script_Extensions:	 Inscriptional_Pahlavi}', "");
    Expect(1, 68480, '\p{^Script_Extensions:	 Inscriptional_Pahlavi}', "");
    Expect(1, 68480, '\P{Script_Extensions:	 Inscriptional_Pahlavi}', "");
    Expect(0, 68480, '\P{^Script_Extensions:	 Inscriptional_Pahlavi}', "");
    Error('\p{Scx= PHLI/a/}');
    Error('\P{Scx= PHLI/a/}');
    Expect(1, 68479, '\p{Scx=:\APhli\z:}', "");;
    Expect(0, 68480, '\p{Scx=:\APhli\z:}', "");;
    Expect(1, 68479, '\p{Scx=phli}', "");
    Expect(0, 68479, '\p{^Scx=phli}', "");
    Expect(0, 68479, '\P{Scx=phli}', "");
    Expect(1, 68479, '\P{^Scx=phli}', "");
    Expect(0, 68480, '\p{Scx=phli}', "");
    Expect(1, 68480, '\p{^Scx=phli}', "");
    Expect(1, 68480, '\P{Scx=phli}', "");
    Expect(0, 68480, '\P{^Scx=phli}', "");
    Expect(1, 68479, '\p{Scx=:\Aphli\z:}', "");;
    Expect(0, 68480, '\p{Scx=:\Aphli\z:}', "");;
    Expect(1, 68479, '\p{Scx=PHLI}', "");
    Expect(0, 68479, '\p{^Scx=PHLI}', "");
    Expect(0, 68479, '\P{Scx=PHLI}', "");
    Expect(1, 68479, '\P{^Scx=PHLI}', "");
    Expect(0, 68480, '\p{Scx=PHLI}', "");
    Expect(1, 68480, '\p{^Scx=PHLI}', "");
    Expect(1, 68480, '\P{Scx=PHLI}', "");
    Expect(0, 68480, '\P{^Scx=PHLI}', "");
    Error('\p{Is_Script_Extensions=/a/_inscriptional_Pahlavi}');
    Error('\P{Is_Script_Extensions=/a/_inscriptional_Pahlavi}');
    Expect(1, 68479, '\p{Is_Script_Extensions=inscriptionalpahlavi}', "");
    Expect(0, 68479, '\p{^Is_Script_Extensions=inscriptionalpahlavi}', "");
    Expect(0, 68479, '\P{Is_Script_Extensions=inscriptionalpahlavi}', "");
    Expect(1, 68479, '\P{^Is_Script_Extensions=inscriptionalpahlavi}', "");
    Expect(0, 68480, '\p{Is_Script_Extensions=inscriptionalpahlavi}', "");
    Expect(1, 68480, '\p{^Is_Script_Extensions=inscriptionalpahlavi}', "");
    Expect(1, 68480, '\P{Is_Script_Extensions=inscriptionalpahlavi}', "");
    Expect(0, 68480, '\P{^Is_Script_Extensions=inscriptionalpahlavi}', "");
    Expect(1, 68479, '\p{Is_Script_Extensions=-	INSCRIPTIONAL_Pahlavi}', "");
    Expect(0, 68479, '\p{^Is_Script_Extensions=-	INSCRIPTIONAL_Pahlavi}', "");
    Expect(0, 68479, '\P{Is_Script_Extensions=-	INSCRIPTIONAL_Pahlavi}', "");
    Expect(1, 68479, '\P{^Is_Script_Extensions=-	INSCRIPTIONAL_Pahlavi}', "");
    Expect(0, 68480, '\p{Is_Script_Extensions=-	INSCRIPTIONAL_Pahlavi}', "");
    Expect(1, 68480, '\p{^Is_Script_Extensions=-	INSCRIPTIONAL_Pahlavi}', "");
    Expect(1, 68480, '\P{Is_Script_Extensions=-	INSCRIPTIONAL_Pahlavi}', "");
    Expect(0, 68480, '\P{^Is_Script_Extensions=-	INSCRIPTIONAL_Pahlavi}', "");
    Error('\p{Is_Scx=_/a/Phli}');
    Error('\P{Is_Scx=_/a/Phli}');
    Expect(1, 68479, '\p{Is_Scx=phli}', "");
    Expect(0, 68479, '\p{^Is_Scx=phli}', "");
    Expect(0, 68479, '\P{Is_Scx=phli}', "");
    Expect(1, 68479, '\P{^Is_Scx=phli}', "");
    Expect(0, 68480, '\p{Is_Scx=phli}', "");
    Expect(1, 68480, '\p{^Is_Scx=phli}', "");
    Expect(1, 68480, '\P{Is_Scx=phli}', "");
    Expect(0, 68480, '\P{^Is_Scx=phli}', "");
    Expect(1, 68479, '\p{Is_Scx=	-Phli}', "");
    Expect(0, 68479, '\p{^Is_Scx=	-Phli}', "");
    Expect(0, 68479, '\P{Is_Scx=	-Phli}', "");
    Expect(1, 68479, '\P{^Is_Scx=	-Phli}', "");
    Expect(0, 68480, '\p{Is_Scx=	-Phli}', "");
    Expect(1, 68480, '\p{^Is_Scx=	-Phli}', "");
    Expect(1, 68480, '\P{Is_Scx=	-Phli}', "");
    Expect(0, 68480, '\P{^Is_Scx=	-Phli}', "");
    Error('\p{Script_Extensions=:=	psalter_Pahlavi}');
    Error('\P{Script_Extensions=:=	psalter_Pahlavi}');
    Expect(1, 68527, '\p{Script_Extensions=:\APsalter_Pahlavi\z:}', "");;
    Expect(0, 68528, '\p{Script_Extensions=:\APsalter_Pahlavi\z:}', "");;
    Expect(1, 68527, '\p{Script_Extensions=psalterpahlavi}', "");
    Expect(0, 68527, '\p{^Script_Extensions=psalterpahlavi}', "");
    Expect(0, 68527, '\P{Script_Extensions=psalterpahlavi}', "");
    Expect(1, 68527, '\P{^Script_Extensions=psalterpahlavi}', "");
    Expect(0, 68528, '\p{Script_Extensions=psalterpahlavi}', "");
    Expect(1, 68528, '\p{^Script_Extensions=psalterpahlavi}', "");
    Expect(1, 68528, '\P{Script_Extensions=psalterpahlavi}', "");
    Expect(0, 68528, '\P{^Script_Extensions=psalterpahlavi}', "");
    Expect(1, 68527, '\p{Script_Extensions=:\Apsalterpahlavi\z:}', "");;
    Expect(0, 68528, '\p{Script_Extensions=:\Apsalterpahlavi\z:}', "");;
    Expect(1, 68527, '\p{Script_Extensions=-PSALTER_Pahlavi}', "");
    Expect(0, 68527, '\p{^Script_Extensions=-PSALTER_Pahlavi}', "");
    Expect(0, 68527, '\P{Script_Extensions=-PSALTER_Pahlavi}', "");
    Expect(1, 68527, '\P{^Script_Extensions=-PSALTER_Pahlavi}', "");
    Expect(0, 68528, '\p{Script_Extensions=-PSALTER_Pahlavi}', "");
    Expect(1, 68528, '\p{^Script_Extensions=-PSALTER_Pahlavi}', "");
    Expect(1, 68528, '\P{Script_Extensions=-PSALTER_Pahlavi}', "");
    Expect(0, 68528, '\P{^Script_Extensions=-PSALTER_Pahlavi}', "");
    Error('\p{Scx= /a/Phlp}');
    Error('\P{Scx= /a/Phlp}');
    Expect(1, 68527, '\p{Scx=:\APhlp\z:}', "");;
    Expect(0, 68528, '\p{Scx=:\APhlp\z:}', "");;
    Expect(1, 68527, '\p{Scx:phlp}', "");
    Expect(0, 68527, '\p{^Scx:phlp}', "");
    Expect(0, 68527, '\P{Scx:phlp}', "");
    Expect(1, 68527, '\P{^Scx:phlp}', "");
    Expect(0, 68528, '\p{Scx:phlp}', "");
    Expect(1, 68528, '\p{^Scx:phlp}', "");
    Expect(1, 68528, '\P{Scx:phlp}', "");
    Expect(0, 68528, '\P{^Scx:phlp}', "");
    Expect(1, 68527, '\p{Scx=:\Aphlp\z:}', "");;
    Expect(0, 68528, '\p{Scx=:\Aphlp\z:}', "");;
    Expect(1, 68527, '\p{Scx= Phlp}', "");
    Expect(0, 68527, '\p{^Scx= Phlp}', "");
    Expect(0, 68527, '\P{Scx= Phlp}', "");
    Expect(1, 68527, '\P{^Scx= Phlp}', "");
    Expect(0, 68528, '\p{Scx= Phlp}', "");
    Expect(1, 68528, '\p{^Scx= Phlp}', "");
    Expect(1, 68528, '\P{Scx= Phlp}', "");
    Expect(0, 68528, '\P{^Scx= Phlp}', "");
    Error('\p{Is_Script_Extensions=-psalter_pahlavi/a/}');
    Error('\P{Is_Script_Extensions=-psalter_pahlavi/a/}');
    Expect(1, 68527, '\p{Is_Script_Extensions=psalterpahlavi}', "");
    Expect(0, 68527, '\p{^Is_Script_Extensions=psalterpahlavi}', "");
    Expect(0, 68527, '\P{Is_Script_Extensions=psalterpahlavi}', "");
    Expect(1, 68527, '\P{^Is_Script_Extensions=psalterpahlavi}', "");
    Expect(0, 68528, '\p{Is_Script_Extensions=psalterpahlavi}', "");
    Expect(1, 68528, '\p{^Is_Script_Extensions=psalterpahlavi}', "");
    Expect(1, 68528, '\P{Is_Script_Extensions=psalterpahlavi}', "");
    Expect(0, 68528, '\P{^Is_Script_Extensions=psalterpahlavi}', "");
    Expect(1, 68527, '\p{Is_Script_Extensions:	 -psalter_Pahlavi}', "");
    Expect(0, 68527, '\p{^Is_Script_Extensions:	 -psalter_Pahlavi}', "");
    Expect(0, 68527, '\P{Is_Script_Extensions:	 -psalter_Pahlavi}', "");
    Expect(1, 68527, '\P{^Is_Script_Extensions:	 -psalter_Pahlavi}', "");
    Expect(0, 68528, '\p{Is_Script_Extensions:	 -psalter_Pahlavi}', "");
    Expect(1, 68528, '\p{^Is_Script_Extensions:	 -psalter_Pahlavi}', "");
    Expect(1, 68528, '\P{Is_Script_Extensions:	 -psalter_Pahlavi}', "");
    Expect(0, 68528, '\P{^Is_Script_Extensions:	 -psalter_Pahlavi}', "");
    Error('\p{Is_Scx=_	phlp:=}');
    Error('\P{Is_Scx=_	phlp:=}');
    Expect(1, 68527, '\p{Is_Scx=phlp}', "");
    Expect(0, 68527, '\p{^Is_Scx=phlp}', "");
    Expect(0, 68527, '\P{Is_Scx=phlp}', "");
    Expect(1, 68527, '\P{^Is_Scx=phlp}', "");
    Expect(0, 68528, '\p{Is_Scx=phlp}', "");
    Expect(1, 68528, '\p{^Is_Scx=phlp}', "");
    Expect(1, 68528, '\P{Is_Scx=phlp}', "");
    Expect(0, 68528, '\P{^Is_Scx=phlp}', "");
    Expect(1, 68527, '\p{Is_Scx=	_PHLP}', "");
    Expect(0, 68527, '\p{^Is_Scx=	_PHLP}', "");
    Expect(0, 68527, '\P{Is_Scx=	_PHLP}', "");
    Expect(1, 68527, '\P{^Is_Scx=	_PHLP}', "");
    Expect(0, 68528, '\p{Is_Scx=	_PHLP}', "");
    Expect(1, 68528, '\p{^Is_Scx=	_PHLP}', "");
    Expect(1, 68528, '\P{Is_Scx=	_PHLP}', "");
    Expect(0, 68528, '\P{^Is_Scx=	_PHLP}', "");
    Error('\p{Script_Extensions=	Phoenician:=}');
    Error('\P{Script_Extensions=	Phoenician:=}');
    Expect(1, 67871, '\p{Script_Extensions=:\APhoenician\z:}', "");;
    Expect(0, 67872, '\p{Script_Extensions=:\APhoenician\z:}', "");;
    Expect(1, 67871, '\p{Script_Extensions=phoenician}', "");
    Expect(0, 67871, '\p{^Script_Extensions=phoenician}', "");
    Expect(0, 67871, '\P{Script_Extensions=phoenician}', "");
    Expect(1, 67871, '\P{^Script_Extensions=phoenician}', "");
    Expect(0, 67872, '\p{Script_Extensions=phoenician}', "");
    Expect(1, 67872, '\p{^Script_Extensions=phoenician}', "");
    Expect(1, 67872, '\P{Script_Extensions=phoenician}', "");
    Expect(0, 67872, '\P{^Script_Extensions=phoenician}', "");
    Expect(1, 67871, '\p{Script_Extensions=:\Aphoenician\z:}', "");;
    Expect(0, 67872, '\p{Script_Extensions=:\Aphoenician\z:}', "");;
    Expect(1, 67871, '\p{Script_Extensions=-Phoenician}', "");
    Expect(0, 67871, '\p{^Script_Extensions=-Phoenician}', "");
    Expect(0, 67871, '\P{Script_Extensions=-Phoenician}', "");
    Expect(1, 67871, '\P{^Script_Extensions=-Phoenician}', "");
    Expect(0, 67872, '\p{Script_Extensions=-Phoenician}', "");
    Expect(1, 67872, '\p{^Script_Extensions=-Phoenician}', "");
    Expect(1, 67872, '\P{Script_Extensions=-Phoenician}', "");
    Expect(0, 67872, '\P{^Script_Extensions=-Phoenician}', "");
    Error('\p{Scx=/a/-_PHNX}');
    Error('\P{Scx=/a/-_PHNX}');
    Expect(1, 67871, '\p{Scx=:\APhnx\z:}', "");;
    Expect(0, 67872, '\p{Scx=:\APhnx\z:}', "");;
    Expect(1, 67871, '\p{Scx=phnx}', "");
    Expect(0, 67871, '\p{^Scx=phnx}', "");
    Expect(0, 67871, '\P{Scx=phnx}', "");
    Expect(1, 67871, '\P{^Scx=phnx}', "");
    Expect(0, 67872, '\p{Scx=phnx}', "");
    Expect(1, 67872, '\p{^Scx=phnx}', "");
    Expect(1, 67872, '\P{Scx=phnx}', "");
    Expect(0, 67872, '\P{^Scx=phnx}', "");
    Expect(1, 67871, '\p{Scx=:\Aphnx\z:}', "");;
    Expect(0, 67872, '\p{Scx=:\Aphnx\z:}', "");;
    Expect(1, 67871, '\p{Scx:-	PHNX}', "");
    Expect(0, 67871, '\p{^Scx:-	PHNX}', "");
    Expect(0, 67871, '\P{Scx:-	PHNX}', "");
    Expect(1, 67871, '\P{^Scx:-	PHNX}', "");
    Expect(0, 67872, '\p{Scx:-	PHNX}', "");
    Expect(1, 67872, '\p{^Scx:-	PHNX}', "");
    Expect(1, 67872, '\P{Scx:-	PHNX}', "");
    Expect(0, 67872, '\P{^Scx:-	PHNX}', "");
    Error('\p{Is_Script_Extensions=:= Phoenician}');
    Error('\P{Is_Script_Extensions=:= Phoenician}');
    Expect(1, 67871, '\p{Is_Script_Extensions:phoenician}', "");
    Expect(0, 67871, '\p{^Is_Script_Extensions:phoenician}', "");
    Expect(0, 67871, '\P{Is_Script_Extensions:phoenician}', "");
    Expect(1, 67871, '\P{^Is_Script_Extensions:phoenician}', "");
    Expect(0, 67872, '\p{Is_Script_Extensions:phoenician}', "");
    Expect(1, 67872, '\p{^Is_Script_Extensions:phoenician}', "");
    Expect(1, 67872, '\P{Is_Script_Extensions:phoenician}', "");
    Expect(0, 67872, '\P{^Is_Script_Extensions:phoenician}', "");
    Expect(1, 67871, '\p{Is_Script_Extensions=-phoenician}', "");
    Expect(0, 67871, '\p{^Is_Script_Extensions=-phoenician}', "");
    Expect(0, 67871, '\P{Is_Script_Extensions=-phoenician}', "");
    Expect(1, 67871, '\P{^Is_Script_Extensions=-phoenician}', "");
    Expect(0, 67872, '\p{Is_Script_Extensions=-phoenician}', "");
    Expect(1, 67872, '\p{^Is_Script_Extensions=-phoenician}', "");
    Expect(1, 67872, '\P{Is_Script_Extensions=-phoenician}', "");
    Expect(0, 67872, '\P{^Is_Script_Extensions=-phoenician}', "");
    Error('\p{Is_Scx=_/a/PHNX}');
    Error('\P{Is_Scx=_/a/PHNX}');
    Expect(1, 67871, '\p{Is_Scx=phnx}', "");
    Expect(0, 67871, '\p{^Is_Scx=phnx}', "");
    Expect(0, 67871, '\P{Is_Scx=phnx}', "");
    Expect(1, 67871, '\P{^Is_Scx=phnx}', "");
    Expect(0, 67872, '\p{Is_Scx=phnx}', "");
    Expect(1, 67872, '\p{^Is_Scx=phnx}', "");
    Expect(1, 67872, '\P{Is_Scx=phnx}', "");
    Expect(0, 67872, '\P{^Is_Scx=phnx}', "");
    Expect(1, 67871, '\p{Is_Scx=	-PHNX}', "");
    Expect(0, 67871, '\p{^Is_Scx=	-PHNX}', "");
    Expect(0, 67871, '\P{Is_Scx=	-PHNX}', "");
    Expect(1, 67871, '\P{^Is_Scx=	-PHNX}', "");
    Expect(0, 67872, '\p{Is_Scx=	-PHNX}', "");
    Expect(1, 67872, '\p{^Is_Scx=	-PHNX}', "");
    Expect(1, 67872, '\P{Is_Scx=	-PHNX}', "");
    Expect(0, 67872, '\P{^Is_Scx=	-PHNX}', "");
    Error('\p{Script_Extensions=- miao:=}');
    Error('\P{Script_Extensions=- miao:=}');
    Expect(1, 94111, '\p{Script_Extensions=:\AMiao\z:}', "");;
    Expect(0, 94112, '\p{Script_Extensions=:\AMiao\z:}', "");;
    Expect(1, 94111, '\p{Script_Extensions=miao}', "");
    Expect(0, 94111, '\p{^Script_Extensions=miao}', "");
    Expect(0, 94111, '\P{Script_Extensions=miao}', "");
    Expect(1, 94111, '\P{^Script_Extensions=miao}', "");
    Expect(0, 94112, '\p{Script_Extensions=miao}', "");
    Expect(1, 94112, '\p{^Script_Extensions=miao}', "");
    Expect(1, 94112, '\P{Script_Extensions=miao}', "");
    Expect(0, 94112, '\P{^Script_Extensions=miao}', "");
    Expect(1, 94111, '\p{Script_Extensions=:\Amiao\z:}', "");;
    Expect(0, 94112, '\p{Script_Extensions=:\Amiao\z:}', "");;
    Expect(1, 94111, '\p{Script_Extensions=	 miao}', "");
    Expect(0, 94111, '\p{^Script_Extensions=	 miao}', "");
    Expect(0, 94111, '\P{Script_Extensions=	 miao}', "");
    Expect(1, 94111, '\P{^Script_Extensions=	 miao}', "");
    Expect(0, 94112, '\p{Script_Extensions=	 miao}', "");
    Expect(1, 94112, '\p{^Script_Extensions=	 miao}', "");
    Expect(1, 94112, '\P{Script_Extensions=	 miao}', "");
    Expect(0, 94112, '\P{^Script_Extensions=	 miao}', "");
    Error('\p{Scx=-/a/plrd}');
    Error('\P{Scx=-/a/plrd}');
    Expect(1, 94111, '\p{Scx=:\APlrd\z:}', "");;
    Expect(0, 94112, '\p{Scx=:\APlrd\z:}', "");;
    Expect(1, 94111, '\p{Scx:plrd}', "");
    Expect(0, 94111, '\p{^Scx:plrd}', "");
    Expect(0, 94111, '\P{Scx:plrd}', "");
    Expect(1, 94111, '\P{^Scx:plrd}', "");
    Expect(0, 94112, '\p{Scx:plrd}', "");
    Expect(1, 94112, '\p{^Scx:plrd}', "");
    Expect(1, 94112, '\P{Scx:plrd}', "");
    Expect(0, 94112, '\P{^Scx:plrd}', "");
    Expect(1, 94111, '\p{Scx=:\Aplrd\z:}', "");;
    Expect(0, 94112, '\p{Scx=:\Aplrd\z:}', "");;
    Expect(1, 94111, '\p{Scx=	Plrd}', "");
    Expect(0, 94111, '\p{^Scx=	Plrd}', "");
    Expect(0, 94111, '\P{Scx=	Plrd}', "");
    Expect(1, 94111, '\P{^Scx=	Plrd}', "");
    Expect(0, 94112, '\p{Scx=	Plrd}', "");
    Expect(1, 94112, '\p{^Scx=	Plrd}', "");
    Expect(1, 94112, '\P{Scx=	Plrd}', "");
    Expect(0, 94112, '\P{^Scx=	Plrd}', "");
    Error('\p{Is_Script_Extensions=_-MIAO/a/}');
    Error('\P{Is_Script_Extensions=_-MIAO/a/}');
    Expect(1, 94111, '\p{Is_Script_Extensions=miao}', "");
    Expect(0, 94111, '\p{^Is_Script_Extensions=miao}', "");
    Expect(0, 94111, '\P{Is_Script_Extensions=miao}', "");
    Expect(1, 94111, '\P{^Is_Script_Extensions=miao}', "");
    Expect(0, 94112, '\p{Is_Script_Extensions=miao}', "");
    Expect(1, 94112, '\p{^Is_Script_Extensions=miao}', "");
    Expect(1, 94112, '\P{Is_Script_Extensions=miao}', "");
    Expect(0, 94112, '\P{^Is_Script_Extensions=miao}', "");
    Expect(1, 94111, '\p{Is_Script_Extensions=	MIAO}', "");
    Expect(0, 94111, '\p{^Is_Script_Extensions=	MIAO}', "");
    Expect(0, 94111, '\P{Is_Script_Extensions=	MIAO}', "");
    Expect(1, 94111, '\P{^Is_Script_Extensions=	MIAO}', "");
    Expect(0, 94112, '\p{Is_Script_Extensions=	MIAO}', "");
    Expect(1, 94112, '\p{^Is_Script_Extensions=	MIAO}', "");
    Expect(1, 94112, '\P{Is_Script_Extensions=	MIAO}', "");
    Expect(0, 94112, '\P{^Is_Script_Extensions=	MIAO}', "");
    Error('\p{Is_Scx=:=_-plrd}');
    Error('\P{Is_Scx=:=_-plrd}');
    Expect(1, 94111, '\p{Is_Scx=plrd}', "");
    Expect(0, 94111, '\p{^Is_Scx=plrd}', "");
    Expect(0, 94111, '\P{Is_Scx=plrd}', "");
    Expect(1, 94111, '\P{^Is_Scx=plrd}', "");
    Expect(0, 94112, '\p{Is_Scx=plrd}', "");
    Expect(1, 94112, '\p{^Is_Scx=plrd}', "");
    Expect(1, 94112, '\P{Is_Scx=plrd}', "");
    Expect(0, 94112, '\P{^Is_Scx=plrd}', "");
    Expect(1, 94111, '\p{Is_Scx=-PLRD}', "");
    Expect(0, 94111, '\p{^Is_Scx=-PLRD}', "");
    Expect(0, 94111, '\P{Is_Scx=-PLRD}', "");
    Expect(1, 94111, '\P{^Is_Scx=-PLRD}', "");
    Expect(0, 94112, '\p{Is_Scx=-PLRD}', "");
    Expect(1, 94112, '\p{^Is_Scx=-PLRD}', "");
    Expect(1, 94112, '\P{Is_Scx=-PLRD}', "");
    Expect(0, 94112, '\P{^Is_Scx=-PLRD}', "");
    Error('\p{Script_Extensions=/a/Inscriptional_parthian}');
    Error('\P{Script_Extensions=/a/Inscriptional_parthian}');
    Expect(1, 68447, '\p{Script_Extensions=:\AInscriptional_Parthian\z:}', "");;
    Expect(0, 68448, '\p{Script_Extensions=:\AInscriptional_Parthian\z:}', "");;
    Expect(1, 68447, '\p{Script_Extensions: inscriptionalparthian}', "");
    Expect(0, 68447, '\p{^Script_Extensions: inscriptionalparthian}', "");
    Expect(0, 68447, '\P{Script_Extensions: inscriptionalparthian}', "");
    Expect(1, 68447, '\P{^Script_Extensions: inscriptionalparthian}', "");
    Expect(0, 68448, '\p{Script_Extensions: inscriptionalparthian}', "");
    Expect(1, 68448, '\p{^Script_Extensions: inscriptionalparthian}', "");
    Expect(1, 68448, '\P{Script_Extensions: inscriptionalparthian}', "");
    Expect(0, 68448, '\P{^Script_Extensions: inscriptionalparthian}', "");
    Expect(1, 68447, '\p{Script_Extensions=:\Ainscriptionalparthian\z:}', "");;
    Expect(0, 68448, '\p{Script_Extensions=:\Ainscriptionalparthian\z:}', "");;
    Expect(1, 68447, '\p{Script_Extensions=_-INSCRIPTIONAL_parthian}', "");
    Expect(0, 68447, '\p{^Script_Extensions=_-INSCRIPTIONAL_parthian}', "");
    Expect(0, 68447, '\P{Script_Extensions=_-INSCRIPTIONAL_parthian}', "");
    Expect(1, 68447, '\P{^Script_Extensions=_-INSCRIPTIONAL_parthian}', "");
    Expect(0, 68448, '\p{Script_Extensions=_-INSCRIPTIONAL_parthian}', "");
    Expect(1, 68448, '\p{^Script_Extensions=_-INSCRIPTIONAL_parthian}', "");
    Expect(1, 68448, '\P{Script_Extensions=_-INSCRIPTIONAL_parthian}', "");
    Expect(0, 68448, '\P{^Script_Extensions=_-INSCRIPTIONAL_parthian}', "");
    Error('\p{Scx=		prti/a/}');
    Error('\P{Scx=		prti/a/}');
    Expect(1, 68447, '\p{Scx=:\APrti\z:}', "");;
    Expect(0, 68448, '\p{Scx=:\APrti\z:}', "");;
    Expect(1, 68447, '\p{Scx:prti}', "");
    Expect(0, 68447, '\p{^Scx:prti}', "");
    Expect(0, 68447, '\P{Scx:prti}', "");
    Expect(1, 68447, '\P{^Scx:prti}', "");
    Expect(0, 68448, '\p{Scx:prti}', "");
    Expect(1, 68448, '\p{^Scx:prti}', "");
    Expect(1, 68448, '\P{Scx:prti}', "");
    Expect(0, 68448, '\P{^Scx:prti}', "");
    Expect(1, 68447, '\p{Scx=:\Aprti\z:}', "");;
    Expect(0, 68448, '\p{Scx=:\Aprti\z:}', "");;
    Expect(1, 68447, '\p{Scx=--Prti}', "");
    Expect(0, 68447, '\p{^Scx=--Prti}', "");
    Expect(0, 68447, '\P{Scx=--Prti}', "");
    Expect(1, 68447, '\P{^Scx=--Prti}', "");
    Expect(0, 68448, '\p{Scx=--Prti}', "");
    Expect(1, 68448, '\p{^Scx=--Prti}', "");
    Expect(1, 68448, '\P{Scx=--Prti}', "");
    Expect(0, 68448, '\P{^Scx=--Prti}', "");
    Error('\p{Is_Script_Extensions= :=inscriptional_Parthian}');
    Error('\P{Is_Script_Extensions= :=inscriptional_Parthian}');
    Expect(1, 68447, '\p{Is_Script_Extensions=inscriptionalparthian}', "");
    Expect(0, 68447, '\p{^Is_Script_Extensions=inscriptionalparthian}', "");
    Expect(0, 68447, '\P{Is_Script_Extensions=inscriptionalparthian}', "");
    Expect(1, 68447, '\P{^Is_Script_Extensions=inscriptionalparthian}', "");
    Expect(0, 68448, '\p{Is_Script_Extensions=inscriptionalparthian}', "");
    Expect(1, 68448, '\p{^Is_Script_Extensions=inscriptionalparthian}', "");
    Expect(1, 68448, '\P{Is_Script_Extensions=inscriptionalparthian}', "");
    Expect(0, 68448, '\P{^Is_Script_Extensions=inscriptionalparthian}', "");
    Expect(1, 68447, '\p{Is_Script_Extensions= INSCRIPTIONAL_PARTHIAN}', "");
    Expect(0, 68447, '\p{^Is_Script_Extensions= INSCRIPTIONAL_PARTHIAN}', "");
    Expect(0, 68447, '\P{Is_Script_Extensions= INSCRIPTIONAL_PARTHIAN}', "");
    Expect(1, 68447, '\P{^Is_Script_Extensions= INSCRIPTIONAL_PARTHIAN}', "");
    Expect(0, 68448, '\p{Is_Script_Extensions= INSCRIPTIONAL_PARTHIAN}', "");
    Expect(1, 68448, '\p{^Is_Script_Extensions= INSCRIPTIONAL_PARTHIAN}', "");
    Expect(1, 68448, '\P{Is_Script_Extensions= INSCRIPTIONAL_PARTHIAN}', "");
    Expect(0, 68448, '\P{^Is_Script_Extensions= INSCRIPTIONAL_PARTHIAN}', "");
    Error('\p{Is_Scx=	:=PRTI}');
    Error('\P{Is_Scx=	:=PRTI}');
    Expect(1, 68447, '\p{Is_Scx=prti}', "");
    Expect(0, 68447, '\p{^Is_Scx=prti}', "");
    Expect(0, 68447, '\P{Is_Scx=prti}', "");
    Expect(1, 68447, '\P{^Is_Scx=prti}', "");
    Expect(0, 68448, '\p{Is_Scx=prti}', "");
    Expect(1, 68448, '\p{^Is_Scx=prti}', "");
    Expect(1, 68448, '\P{Is_Scx=prti}', "");
    Expect(0, 68448, '\P{^Is_Scx=prti}', "");
    Expect(1, 68447, '\p{Is_Scx=__Prti}', "");
    Expect(0, 68447, '\p{^Is_Scx=__Prti}', "");
    Expect(0, 68447, '\P{Is_Scx=__Prti}', "");
    Expect(1, 68447, '\P{^Is_Scx=__Prti}', "");
    Expect(0, 68448, '\p{Is_Scx=__Prti}', "");
    Expect(1, 68448, '\p{^Is_Scx=__Prti}', "");
    Expect(1, 68448, '\P{Is_Scx=__Prti}', "");
    Expect(0, 68448, '\P{^Is_Scx=__Prti}', "");
    Error('\p{Script_Extensions=	:=Rejang}');
    Error('\P{Script_Extensions=	:=Rejang}');
    Expect(1, 43359, '\p{Script_Extensions=:\ARejang\z:}', "");;
    Expect(0, 43360, '\p{Script_Extensions=:\ARejang\z:}', "");;
    Expect(1, 43359, '\p{Script_Extensions=rejang}', "");
    Expect(0, 43359, '\p{^Script_Extensions=rejang}', "");
    Expect(0, 43359, '\P{Script_Extensions=rejang}', "");
    Expect(1, 43359, '\P{^Script_Extensions=rejang}', "");
    Expect(0, 43360, '\p{Script_Extensions=rejang}', "");
    Expect(1, 43360, '\p{^Script_Extensions=rejang}', "");
    Expect(1, 43360, '\P{Script_Extensions=rejang}', "");
    Expect(0, 43360, '\P{^Script_Extensions=rejang}', "");
    Expect(1, 43359, '\p{Script_Extensions=:\Arejang\z:}', "");;
    Expect(0, 43360, '\p{Script_Extensions=:\Arejang\z:}', "");;
    Expect(1, 43359, '\p{Script_Extensions=Rejang}', "");
    Expect(0, 43359, '\p{^Script_Extensions=Rejang}', "");
    Expect(0, 43359, '\P{Script_Extensions=Rejang}', "");
    Expect(1, 43359, '\P{^Script_Extensions=Rejang}', "");
    Expect(0, 43360, '\p{Script_Extensions=Rejang}', "");
    Expect(1, 43360, '\p{^Script_Extensions=Rejang}', "");
    Expect(1, 43360, '\P{Script_Extensions=Rejang}', "");
    Expect(0, 43360, '\P{^Script_Extensions=Rejang}', "");
    Error('\p{Scx=	:=Rjng}');
    Error('\P{Scx=	:=Rjng}');
    Expect(1, 43359, '\p{Scx=:\ARjng\z:}', "");;
    Expect(0, 43360, '\p{Scx=:\ARjng\z:}', "");;
    Expect(1, 43359, '\p{Scx=rjng}', "");
    Expect(0, 43359, '\p{^Scx=rjng}', "");
    Expect(0, 43359, '\P{Scx=rjng}', "");
    Expect(1, 43359, '\P{^Scx=rjng}', "");
    Expect(0, 43360, '\p{Scx=rjng}', "");
    Expect(1, 43360, '\p{^Scx=rjng}', "");
    Expect(1, 43360, '\P{Scx=rjng}', "");
    Expect(0, 43360, '\P{^Scx=rjng}', "");
    Expect(1, 43359, '\p{Scx=:\Arjng\z:}', "");;
    Expect(0, 43360, '\p{Scx=:\Arjng\z:}', "");;
    Expect(1, 43359, '\p{Scx=- Rjng}', "");
    Expect(0, 43359, '\p{^Scx=- Rjng}', "");
    Expect(0, 43359, '\P{Scx=- Rjng}', "");
    Expect(1, 43359, '\P{^Scx=- Rjng}', "");
    Expect(0, 43360, '\p{Scx=- Rjng}', "");
    Expect(1, 43360, '\p{^Scx=- Rjng}', "");
    Expect(1, 43360, '\P{Scx=- Rjng}', "");
    Expect(0, 43360, '\P{^Scx=- Rjng}', "");
    Error('\p{Is_Script_Extensions=-:=REJANG}');
    Error('\P{Is_Script_Extensions=-:=REJANG}');
    Expect(1, 43359, '\p{Is_Script_Extensions=rejang}', "");
    Expect(0, 43359, '\p{^Is_Script_Extensions=rejang}', "");
    Expect(0, 43359, '\P{Is_Script_Extensions=rejang}', "");
    Expect(1, 43359, '\P{^Is_Script_Extensions=rejang}', "");
    Expect(0, 43360, '\p{Is_Script_Extensions=rejang}', "");
    Expect(1, 43360, '\p{^Is_Script_Extensions=rejang}', "");
    Expect(1, 43360, '\P{Is_Script_Extensions=rejang}', "");
    Expect(0, 43360, '\P{^Is_Script_Extensions=rejang}', "");
    Expect(1, 43359, '\p{Is_Script_Extensions= rejang}', "");
    Expect(0, 43359, '\p{^Is_Script_Extensions= rejang}', "");
    Expect(0, 43359, '\P{Is_Script_Extensions= rejang}', "");
    Expect(1, 43359, '\P{^Is_Script_Extensions= rejang}', "");
    Expect(0, 43360, '\p{Is_Script_Extensions= rejang}', "");
    Expect(1, 43360, '\p{^Is_Script_Extensions= rejang}', "");
    Expect(1, 43360, '\P{Is_Script_Extensions= rejang}', "");
    Expect(0, 43360, '\P{^Is_Script_Extensions= rejang}', "");
    Error('\p{Is_Scx: :=Rjng}');
    Error('\P{Is_Scx: :=Rjng}');
    Expect(1, 43359, '\p{Is_Scx=rjng}', "");
    Expect(0, 43359, '\p{^Is_Scx=rjng}', "");
    Expect(0, 43359, '\P{Is_Scx=rjng}', "");
    Expect(1, 43359, '\P{^Is_Scx=rjng}', "");
    Expect(0, 43360, '\p{Is_Scx=rjng}', "");
    Expect(1, 43360, '\p{^Is_Scx=rjng}', "");
    Expect(1, 43360, '\P{Is_Scx=rjng}', "");
    Expect(0, 43360, '\P{^Is_Scx=rjng}', "");
    Expect(1, 43359, '\p{Is_Scx=  Rjng}', "");
    Expect(0, 43359, '\p{^Is_Scx=  Rjng}', "");
    Expect(0, 43359, '\P{Is_Scx=  Rjng}', "");
    Expect(1, 43359, '\P{^Is_Scx=  Rjng}', "");
    Expect(0, 43360, '\p{Is_Scx=  Rjng}', "");
    Expect(1, 43360, '\p{^Is_Scx=  Rjng}', "");
    Expect(1, 43360, '\P{Is_Scx=  Rjng}', "");
    Expect(0, 43360, '\P{^Is_Scx=  Rjng}', "");
    Error('\p{Script_Extensions=/a/-	HANIFI_ROHINGYA}');
    Error('\P{Script_Extensions=/a/-	HANIFI_ROHINGYA}');
    Expect(1, 68921, '\p{Script_Extensions=:\AHanifi_Rohingya\z:}', "");;
    Expect(0, 68922, '\p{Script_Extensions=:\AHanifi_Rohingya\z:}', "");;
    Expect(1, 68921, '\p{Script_Extensions=hanifirohingya}', "");
    Expect(0, 68921, '\p{^Script_Extensions=hanifirohingya}', "");
    Expect(0, 68921, '\P{Script_Extensions=hanifirohingya}', "");
    Expect(1, 68921, '\P{^Script_Extensions=hanifirohingya}', "");
    Expect(0, 68922, '\p{Script_Extensions=hanifirohingya}', "");
    Expect(1, 68922, '\p{^Script_Extensions=hanifirohingya}', "");
    Expect(1, 68922, '\P{Script_Extensions=hanifirohingya}', "");
    Expect(0, 68922, '\P{^Script_Extensions=hanifirohingya}', "");
    Expect(1, 68921, '\p{Script_Extensions=:\Ahanifirohingya\z:}', "");;
    Expect(0, 68922, '\p{Script_Extensions=:\Ahanifirohingya\z:}', "");;
    Expect(1, 68921, '\p{Script_Extensions=_-Hanifi_Rohingya}', "");
    Expect(0, 68921, '\p{^Script_Extensions=_-Hanifi_Rohingya}', "");
    Expect(0, 68921, '\P{Script_Extensions=_-Hanifi_Rohingya}', "");
    Expect(1, 68921, '\P{^Script_Extensions=_-Hanifi_Rohingya}', "");
    Expect(0, 68922, '\p{Script_Extensions=_-Hanifi_Rohingya}', "");
    Expect(1, 68922, '\p{^Script_Extensions=_-Hanifi_Rohingya}', "");
    Expect(1, 68922, '\P{Script_Extensions=_-Hanifi_Rohingya}', "");
    Expect(0, 68922, '\P{^Script_Extensions=_-Hanifi_Rohingya}', "");
    Error('\p{Scx=	:=rohg}');
    Error('\P{Scx=	:=rohg}');
    Expect(1, 68921, '\p{Scx=:\ARohg\z:}', "");;
    Expect(0, 68922, '\p{Scx=:\ARohg\z:}', "");;
    Expect(1, 68921, '\p{Scx=rohg}', "");
    Expect(0, 68921, '\p{^Scx=rohg}', "");
    Expect(0, 68921, '\P{Scx=rohg}', "");
    Expect(1, 68921, '\P{^Scx=rohg}', "");
    Expect(0, 68922, '\p{Scx=rohg}', "");
    Expect(1, 68922, '\p{^Scx=rohg}', "");
    Expect(1, 68922, '\P{Scx=rohg}', "");
    Expect(0, 68922, '\P{^Scx=rohg}', "");
    Expect(1, 68921, '\p{Scx=:\Arohg\z:}', "");;
    Expect(0, 68922, '\p{Scx=:\Arohg\z:}', "");;
    Expect(1, 68921, '\p{Scx:		-ROHG}', "");
    Expect(0, 68921, '\p{^Scx:		-ROHG}', "");
    Expect(0, 68921, '\P{Scx:		-ROHG}', "");
    Expect(1, 68921, '\P{^Scx:		-ROHG}', "");
    Expect(0, 68922, '\p{Scx:		-ROHG}', "");
    Expect(1, 68922, '\p{^Scx:		-ROHG}', "");
    Expect(1, 68922, '\P{Scx:		-ROHG}', "");
    Expect(0, 68922, '\P{^Scx:		-ROHG}', "");
    Error('\p{Is_Script_Extensions=_/a/hanifi_ROHINGYA}');
    Error('\P{Is_Script_Extensions=_/a/hanifi_ROHINGYA}');
    Expect(1, 68921, '\p{Is_Script_Extensions=hanifirohingya}', "");
    Expect(0, 68921, '\p{^Is_Script_Extensions=hanifirohingya}', "");
    Expect(0, 68921, '\P{Is_Script_Extensions=hanifirohingya}', "");
    Expect(1, 68921, '\P{^Is_Script_Extensions=hanifirohingya}', "");
    Expect(0, 68922, '\p{Is_Script_Extensions=hanifirohingya}', "");
    Expect(1, 68922, '\p{^Is_Script_Extensions=hanifirohingya}', "");
    Expect(1, 68922, '\P{Is_Script_Extensions=hanifirohingya}', "");
    Expect(0, 68922, '\P{^Is_Script_Extensions=hanifirohingya}', "");
    Expect(1, 68921, '\p{Is_Script_Extensions=--Hanifi_Rohingya}', "");
    Expect(0, 68921, '\p{^Is_Script_Extensions=--Hanifi_Rohingya}', "");
    Expect(0, 68921, '\P{Is_Script_Extensions=--Hanifi_Rohingya}', "");
    Expect(1, 68921, '\P{^Is_Script_Extensions=--Hanifi_Rohingya}', "");
    Expect(0, 68922, '\p{Is_Script_Extensions=--Hanifi_Rohingya}', "");
    Expect(1, 68922, '\p{^Is_Script_Extensions=--Hanifi_Rohingya}', "");
    Expect(1, 68922, '\P{Is_Script_Extensions=--Hanifi_Rohingya}', "");
    Expect(0, 68922, '\P{^Is_Script_Extensions=--Hanifi_Rohingya}', "");
    Error('\p{Is_Scx=	 rohg/a/}');
    Error('\P{Is_Scx=	 rohg/a/}');
    Expect(1, 68921, '\p{Is_Scx=rohg}', "");
    Expect(0, 68921, '\p{^Is_Scx=rohg}', "");
    Expect(0, 68921, '\P{Is_Scx=rohg}', "");
    Expect(1, 68921, '\P{^Is_Scx=rohg}', "");
    Expect(0, 68922, '\p{Is_Scx=rohg}', "");
    Expect(1, 68922, '\p{^Is_Scx=rohg}', "");
    Expect(1, 68922, '\P{Is_Scx=rohg}', "");
    Expect(0, 68922, '\P{^Is_Scx=rohg}', "");
    Expect(1, 68921, '\p{Is_Scx: 	 Rohg}', "");
    Expect(0, 68921, '\p{^Is_Scx: 	 Rohg}', "");
    Expect(0, 68921, '\P{Is_Scx: 	 Rohg}', "");
    Expect(1, 68921, '\P{^Is_Scx: 	 Rohg}', "");
    Expect(0, 68922, '\p{Is_Scx: 	 Rohg}', "");
    Expect(1, 68922, '\p{^Is_Scx: 	 Rohg}', "");
    Expect(1, 68922, '\P{Is_Scx: 	 Rohg}', "");
    Expect(0, 68922, '\P{^Is_Scx: 	 Rohg}', "");
    Error('\p{Script_Extensions=/a/	RUNIC}');
    Error('\P{Script_Extensions=/a/	RUNIC}');
    Expect(1, 5880, '\p{Script_Extensions=:\ARunic\z:}', "");;
    Expect(0, 5881, '\p{Script_Extensions=:\ARunic\z:}', "");;
    Expect(1, 5880, '\p{Script_Extensions=runic}', "");
    Expect(0, 5880, '\p{^Script_Extensions=runic}', "");
    Expect(0, 5880, '\P{Script_Extensions=runic}', "");
    Expect(1, 5880, '\P{^Script_Extensions=runic}', "");
    Expect(0, 5881, '\p{Script_Extensions=runic}', "");
    Expect(1, 5881, '\p{^Script_Extensions=runic}', "");
    Expect(1, 5881, '\P{Script_Extensions=runic}', "");
    Expect(0, 5881, '\P{^Script_Extensions=runic}', "");
    Expect(1, 5880, '\p{Script_Extensions=:\Arunic\z:}', "");;
    Expect(0, 5881, '\p{Script_Extensions=:\Arunic\z:}', "");;
    Expect(1, 5880, '\p{Script_Extensions=	-Runic}', "");
    Expect(0, 5880, '\p{^Script_Extensions=	-Runic}', "");
    Expect(0, 5880, '\P{Script_Extensions=	-Runic}', "");
    Expect(1, 5880, '\P{^Script_Extensions=	-Runic}', "");
    Expect(0, 5881, '\p{Script_Extensions=	-Runic}', "");
    Expect(1, 5881, '\p{^Script_Extensions=	-Runic}', "");
    Expect(1, 5881, '\P{Script_Extensions=	-Runic}', "");
    Expect(0, 5881, '\P{^Script_Extensions=	-Runic}', "");
    Error('\p{Scx=- Runr:=}');
    Error('\P{Scx=- Runr:=}');
    Expect(1, 5880, '\p{Scx=:\ARunr\z:}', "");;
    Expect(0, 5881, '\p{Scx=:\ARunr\z:}', "");;
    Expect(1, 5880, '\p{Scx:	runr}', "");
    Expect(0, 5880, '\p{^Scx:	runr}', "");
    Expect(0, 5880, '\P{Scx:	runr}', "");
    Expect(1, 5880, '\P{^Scx:	runr}', "");
    Expect(0, 5881, '\p{Scx:	runr}', "");
    Expect(1, 5881, '\p{^Scx:	runr}', "");
    Expect(1, 5881, '\P{Scx:	runr}', "");
    Expect(0, 5881, '\P{^Scx:	runr}', "");
    Expect(1, 5880, '\p{Scx=:\Arunr\z:}', "");;
    Expect(0, 5881, '\p{Scx=:\Arunr\z:}', "");;
    Expect(1, 5880, '\p{Scx= _Runr}', "");
    Expect(0, 5880, '\p{^Scx= _Runr}', "");
    Expect(0, 5880, '\P{Scx= _Runr}', "");
    Expect(1, 5880, '\P{^Scx= _Runr}', "");
    Expect(0, 5881, '\p{Scx= _Runr}', "");
    Expect(1, 5881, '\p{^Scx= _Runr}', "");
    Expect(1, 5881, '\P{Scx= _Runr}', "");
    Expect(0, 5881, '\P{^Scx= _Runr}', "");
    Error('\p{Is_Script_Extensions= Runic:=}');
    Error('\P{Is_Script_Extensions= Runic:=}');
    Expect(1, 5880, '\p{Is_Script_Extensions=runic}', "");
    Expect(0, 5880, '\p{^Is_Script_Extensions=runic}', "");
    Expect(0, 5880, '\P{Is_Script_Extensions=runic}', "");
    Expect(1, 5880, '\P{^Is_Script_Extensions=runic}', "");
    Expect(0, 5881, '\p{Is_Script_Extensions=runic}', "");
    Expect(1, 5881, '\p{^Is_Script_Extensions=runic}', "");
    Expect(1, 5881, '\P{Is_Script_Extensions=runic}', "");
    Expect(0, 5881, '\P{^Is_Script_Extensions=runic}', "");
    Expect(1, 5880, '\p{Is_Script_Extensions:   	Runic}', "");
    Expect(0, 5880, '\p{^Is_Script_Extensions:   	Runic}', "");
    Expect(0, 5880, '\P{Is_Script_Extensions:   	Runic}', "");
    Expect(1, 5880, '\P{^Is_Script_Extensions:   	Runic}', "");
    Expect(0, 5881, '\p{Is_Script_Extensions:   	Runic}', "");
    Expect(1, 5881, '\p{^Is_Script_Extensions:   	Runic}', "");
    Expect(1, 5881, '\P{Is_Script_Extensions:   	Runic}', "");
    Expect(0, 5881, '\P{^Is_Script_Extensions:   	Runic}', "");
    Error('\p{Is_Scx=	RUNR:=}');
    Error('\P{Is_Scx=	RUNR:=}');
    Expect(1, 5880, '\p{Is_Scx=runr}', "");
    Expect(0, 5880, '\p{^Is_Scx=runr}', "");
    Expect(0, 5880, '\P{Is_Scx=runr}', "");
    Expect(1, 5880, '\P{^Is_Scx=runr}', "");
    Expect(0, 5881, '\p{Is_Scx=runr}', "");
    Expect(1, 5881, '\p{^Is_Scx=runr}', "");
    Expect(1, 5881, '\P{Is_Scx=runr}', "");
    Expect(0, 5881, '\P{^Is_Scx=runr}', "");
    Expect(1, 5880, '\p{Is_Scx=		runr}', "");
    Expect(0, 5880, '\p{^Is_Scx=		runr}', "");
    Expect(0, 5880, '\P{Is_Scx=		runr}', "");
    Expect(1, 5880, '\P{^Is_Scx=		runr}', "");
    Expect(0, 5881, '\p{Is_Scx=		runr}', "");
    Expect(1, 5881, '\p{^Is_Scx=		runr}', "");
    Expect(1, 5881, '\P{Is_Scx=		runr}', "");
    Expect(0, 5881, '\P{^Is_Scx=		runr}', "");
    Error('\p{Script_Extensions=:=_ SAMARITAN}');
    Error('\P{Script_Extensions=:=_ SAMARITAN}');
    Expect(1, 2110, '\p{Script_Extensions=:\ASamaritan\z:}', "");;
    Expect(0, 2111, '\p{Script_Extensions=:\ASamaritan\z:}', "");;
    Expect(1, 2110, '\p{Script_Extensions=samaritan}', "");
    Expect(0, 2110, '\p{^Script_Extensions=samaritan}', "");
    Expect(0, 2110, '\P{Script_Extensions=samaritan}', "");
    Expect(1, 2110, '\P{^Script_Extensions=samaritan}', "");
    Expect(0, 2111, '\p{Script_Extensions=samaritan}', "");
    Expect(1, 2111, '\p{^Script_Extensions=samaritan}', "");
    Expect(1, 2111, '\P{Script_Extensions=samaritan}', "");
    Expect(0, 2111, '\P{^Script_Extensions=samaritan}', "");
    Expect(1, 2110, '\p{Script_Extensions=:\Asamaritan\z:}', "");;
    Expect(0, 2111, '\p{Script_Extensions=:\Asamaritan\z:}', "");;
    Expect(1, 2110, '\p{Script_Extensions=_Samaritan}', "");
    Expect(0, 2110, '\p{^Script_Extensions=_Samaritan}', "");
    Expect(0, 2110, '\P{Script_Extensions=_Samaritan}', "");
    Expect(1, 2110, '\P{^Script_Extensions=_Samaritan}', "");
    Expect(0, 2111, '\p{Script_Extensions=_Samaritan}', "");
    Expect(1, 2111, '\p{^Script_Extensions=_Samaritan}', "");
    Expect(1, 2111, '\P{Script_Extensions=_Samaritan}', "");
    Expect(0, 2111, '\P{^Script_Extensions=_Samaritan}', "");
    Error('\p{Scx=/a/_samr}');
    Error('\P{Scx=/a/_samr}');
    Expect(1, 2110, '\p{Scx=:\ASamr\z:}', "");;
    Expect(0, 2111, '\p{Scx=:\ASamr\z:}', "");;
    Expect(1, 2110, '\p{Scx=samr}', "");
    Expect(0, 2110, '\p{^Scx=samr}', "");
    Expect(0, 2110, '\P{Scx=samr}', "");
    Expect(1, 2110, '\P{^Scx=samr}', "");
    Expect(0, 2111, '\p{Scx=samr}', "");
    Expect(1, 2111, '\p{^Scx=samr}', "");
    Expect(1, 2111, '\P{Scx=samr}', "");
    Expect(0, 2111, '\P{^Scx=samr}', "");
    Expect(1, 2110, '\p{Scx=:\Asamr\z:}', "");;
    Expect(0, 2111, '\p{Scx=:\Asamr\z:}', "");;
    Expect(1, 2110, '\p{Scx=_ SAMR}', "");
    Expect(0, 2110, '\p{^Scx=_ SAMR}', "");
    Expect(0, 2110, '\P{Scx=_ SAMR}', "");
    Expect(1, 2110, '\P{^Scx=_ SAMR}', "");
    Expect(0, 2111, '\p{Scx=_ SAMR}', "");
    Expect(1, 2111, '\p{^Scx=_ SAMR}', "");
    Expect(1, 2111, '\P{Scx=_ SAMR}', "");
    Expect(0, 2111, '\P{^Scx=_ SAMR}', "");
    Error('\p{Is_Script_Extensions=_/a/Samaritan}');
    Error('\P{Is_Script_Extensions=_/a/Samaritan}');
    Expect(1, 2110, '\p{Is_Script_Extensions:   samaritan}', "");
    Expect(0, 2110, '\p{^Is_Script_Extensions:   samaritan}', "");
    Expect(0, 2110, '\P{Is_Script_Extensions:   samaritan}', "");
    Expect(1, 2110, '\P{^Is_Script_Extensions:   samaritan}', "");
    Expect(0, 2111, '\p{Is_Script_Extensions:   samaritan}', "");
    Expect(1, 2111, '\p{^Is_Script_Extensions:   samaritan}', "");
    Expect(1, 2111, '\P{Is_Script_Extensions:   samaritan}', "");
    Expect(0, 2111, '\P{^Is_Script_Extensions:   samaritan}', "");
    Expect(1, 2110, '\p{Is_Script_Extensions=	 Samaritan}', "");
    Expect(0, 2110, '\p{^Is_Script_Extensions=	 Samaritan}', "");
    Expect(0, 2110, '\P{Is_Script_Extensions=	 Samaritan}', "");
    Expect(1, 2110, '\P{^Is_Script_Extensions=	 Samaritan}', "");
    Expect(0, 2111, '\p{Is_Script_Extensions=	 Samaritan}', "");
    Expect(1, 2111, '\p{^Is_Script_Extensions=	 Samaritan}', "");
    Expect(1, 2111, '\P{Is_Script_Extensions=	 Samaritan}', "");
    Expect(0, 2111, '\P{^Is_Script_Extensions=	 Samaritan}', "");
    Error('\p{Is_Scx=/a/		SAMR}');
    Error('\P{Is_Scx=/a/		SAMR}');
    Expect(1, 2110, '\p{Is_Scx=samr}', "");
    Expect(0, 2110, '\p{^Is_Scx=samr}', "");
    Expect(0, 2110, '\P{Is_Scx=samr}', "");
    Expect(1, 2110, '\P{^Is_Scx=samr}', "");
    Expect(0, 2111, '\p{Is_Scx=samr}', "");
    Expect(1, 2111, '\p{^Is_Scx=samr}', "");
    Expect(1, 2111, '\P{Is_Scx=samr}', "");
    Expect(0, 2111, '\P{^Is_Scx=samr}', "");
    Expect(1, 2110, '\p{Is_Scx=_Samr}', "");
    Expect(0, 2110, '\p{^Is_Scx=_Samr}', "");
    Expect(0, 2110, '\P{Is_Scx=_Samr}', "");
    Expect(1, 2110, '\P{^Is_Scx=_Samr}', "");
    Expect(0, 2111, '\p{Is_Scx=_Samr}', "");
    Expect(1, 2111, '\p{^Is_Scx=_Samr}', "");
    Expect(1, 2111, '\P{Is_Scx=_Samr}', "");
    Expect(0, 2111, '\P{^Is_Scx=_Samr}', "");
    Error('\p{Script_Extensions=/a/-	old_south_Arabian}');
    Error('\P{Script_Extensions=/a/-	old_south_Arabian}');
    Expect(1, 68223, '\p{Script_Extensions=:\AOld_South_Arabian\z:}', "");;
    Expect(0, 68224, '\p{Script_Extensions=:\AOld_South_Arabian\z:}', "");;
    Expect(1, 68223, '\p{Script_Extensions=oldsoutharabian}', "");
    Expect(0, 68223, '\p{^Script_Extensions=oldsoutharabian}', "");
    Expect(0, 68223, '\P{Script_Extensions=oldsoutharabian}', "");
    Expect(1, 68223, '\P{^Script_Extensions=oldsoutharabian}', "");
    Expect(0, 68224, '\p{Script_Extensions=oldsoutharabian}', "");
    Expect(1, 68224, '\p{^Script_Extensions=oldsoutharabian}', "");
    Expect(1, 68224, '\P{Script_Extensions=oldsoutharabian}', "");
    Expect(0, 68224, '\P{^Script_Extensions=oldsoutharabian}', "");
    Expect(1, 68223, '\p{Script_Extensions=:\Aoldsoutharabian\z:}', "");;
    Expect(0, 68224, '\p{Script_Extensions=:\Aoldsoutharabian\z:}', "");;
    Expect(1, 68223, '\p{Script_Extensions= -Old_south_Arabian}', "");
    Expect(0, 68223, '\p{^Script_Extensions= -Old_south_Arabian}', "");
    Expect(0, 68223, '\P{Script_Extensions= -Old_south_Arabian}', "");
    Expect(1, 68223, '\P{^Script_Extensions= -Old_south_Arabian}', "");
    Expect(0, 68224, '\p{Script_Extensions= -Old_south_Arabian}', "");
    Expect(1, 68224, '\p{^Script_Extensions= -Old_south_Arabian}', "");
    Expect(1, 68224, '\P{Script_Extensions= -Old_south_Arabian}', "");
    Expect(0, 68224, '\P{^Script_Extensions= -Old_south_Arabian}', "");
    Error('\p{Scx= _SARB/a/}');
    Error('\P{Scx= _SARB/a/}');
    Expect(1, 68223, '\p{Scx=:\ASarb\z:}', "");;
    Expect(0, 68224, '\p{Scx=:\ASarb\z:}', "");;
    Expect(1, 68223, '\p{Scx:	sarb}', "");
    Expect(0, 68223, '\p{^Scx:	sarb}', "");
    Expect(0, 68223, '\P{Scx:	sarb}', "");
    Expect(1, 68223, '\P{^Scx:	sarb}', "");
    Expect(0, 68224, '\p{Scx:	sarb}', "");
    Expect(1, 68224, '\p{^Scx:	sarb}', "");
    Expect(1, 68224, '\P{Scx:	sarb}', "");
    Expect(0, 68224, '\P{^Scx:	sarb}', "");
    Expect(1, 68223, '\p{Scx=:\Asarb\z:}', "");;
    Expect(0, 68224, '\p{Scx=:\Asarb\z:}', "");;
    Expect(1, 68223, '\p{Scx=	sarb}', "");
    Expect(0, 68223, '\p{^Scx=	sarb}', "");
    Expect(0, 68223, '\P{Scx=	sarb}', "");
    Expect(1, 68223, '\P{^Scx=	sarb}', "");
    Expect(0, 68224, '\p{Scx=	sarb}', "");
    Expect(1, 68224, '\p{^Scx=	sarb}', "");
    Expect(1, 68224, '\P{Scx=	sarb}', "");
    Expect(0, 68224, '\P{^Scx=	sarb}', "");
    Error('\p{Is_Script_Extensions=:=_-OLD_South_Arabian}');
    Error('\P{Is_Script_Extensions=:=_-OLD_South_Arabian}');
    Expect(1, 68223, '\p{Is_Script_Extensions=oldsoutharabian}', "");
    Expect(0, 68223, '\p{^Is_Script_Extensions=oldsoutharabian}', "");
    Expect(0, 68223, '\P{Is_Script_Extensions=oldsoutharabian}', "");
    Expect(1, 68223, '\P{^Is_Script_Extensions=oldsoutharabian}', "");
    Expect(0, 68224, '\p{Is_Script_Extensions=oldsoutharabian}', "");
    Expect(1, 68224, '\p{^Is_Script_Extensions=oldsoutharabian}', "");
    Expect(1, 68224, '\P{Is_Script_Extensions=oldsoutharabian}', "");
    Expect(0, 68224, '\P{^Is_Script_Extensions=oldsoutharabian}', "");
    Expect(1, 68223, '\p{Is_Script_Extensions= old_SOUTH_Arabian}', "");
    Expect(0, 68223, '\p{^Is_Script_Extensions= old_SOUTH_Arabian}', "");
    Expect(0, 68223, '\P{Is_Script_Extensions= old_SOUTH_Arabian}', "");
    Expect(1, 68223, '\P{^Is_Script_Extensions= old_SOUTH_Arabian}', "");
    Expect(0, 68224, '\p{Is_Script_Extensions= old_SOUTH_Arabian}', "");
    Expect(1, 68224, '\p{^Is_Script_Extensions= old_SOUTH_Arabian}', "");
    Expect(1, 68224, '\P{Is_Script_Extensions= old_SOUTH_Arabian}', "");
    Expect(0, 68224, '\P{^Is_Script_Extensions= old_SOUTH_Arabian}', "");
    Error('\p{Is_Scx=:= 	sarb}');
    Error('\P{Is_Scx=:= 	sarb}');
    Expect(1, 68223, '\p{Is_Scx=sarb}', "");
    Expect(0, 68223, '\p{^Is_Scx=sarb}', "");
    Expect(0, 68223, '\P{Is_Scx=sarb}', "");
    Expect(1, 68223, '\P{^Is_Scx=sarb}', "");
    Expect(0, 68224, '\p{Is_Scx=sarb}', "");
    Expect(1, 68224, '\p{^Is_Scx=sarb}', "");
    Expect(1, 68224, '\P{Is_Scx=sarb}', "");
    Expect(0, 68224, '\P{^Is_Scx=sarb}', "");
    Expect(1, 68223, '\p{Is_Scx= _Sarb}', "");
    Expect(0, 68223, '\p{^Is_Scx= _Sarb}', "");
    Expect(0, 68223, '\P{Is_Scx= _Sarb}', "");
    Expect(1, 68223, '\P{^Is_Scx= _Sarb}', "");
    Expect(0, 68224, '\p{Is_Scx= _Sarb}', "");
    Expect(1, 68224, '\p{^Is_Scx= _Sarb}', "");
    Expect(1, 68224, '\P{Is_Scx= _Sarb}', "");
    Expect(0, 68224, '\P{^Is_Scx= _Sarb}', "");
    Error('\p{Script_Extensions= 	saurashtra:=}');
    Error('\P{Script_Extensions= 	saurashtra:=}');
    Expect(1, 43225, '\p{Script_Extensions=:\ASaurashtra\z:}', "");;
    Expect(0, 43226, '\p{Script_Extensions=:\ASaurashtra\z:}', "");;
    Expect(1, 43225, '\p{Script_Extensions:saurashtra}', "");
    Expect(0, 43225, '\p{^Script_Extensions:saurashtra}', "");
    Expect(0, 43225, '\P{Script_Extensions:saurashtra}', "");
    Expect(1, 43225, '\P{^Script_Extensions:saurashtra}', "");
    Expect(0, 43226, '\p{Script_Extensions:saurashtra}', "");
    Expect(1, 43226, '\p{^Script_Extensions:saurashtra}', "");
    Expect(1, 43226, '\P{Script_Extensions:saurashtra}', "");
    Expect(0, 43226, '\P{^Script_Extensions:saurashtra}', "");
    Expect(1, 43225, '\p{Script_Extensions=:\Asaurashtra\z:}', "");;
    Expect(0, 43226, '\p{Script_Extensions=:\Asaurashtra\z:}', "");;
    Expect(1, 43225, '\p{Script_Extensions=  Saurashtra}', "");
    Expect(0, 43225, '\p{^Script_Extensions=  Saurashtra}', "");
    Expect(0, 43225, '\P{Script_Extensions=  Saurashtra}', "");
    Expect(1, 43225, '\P{^Script_Extensions=  Saurashtra}', "");
    Expect(0, 43226, '\p{Script_Extensions=  Saurashtra}', "");
    Expect(1, 43226, '\p{^Script_Extensions=  Saurashtra}', "");
    Expect(1, 43226, '\P{Script_Extensions=  Saurashtra}', "");
    Expect(0, 43226, '\P{^Script_Extensions=  Saurashtra}', "");
    Error('\p{Scx: 	-Saur:=}');
    Error('\P{Scx: 	-Saur:=}');
    Expect(1, 43225, '\p{Scx=:\ASaur\z:}', "");;
    Expect(0, 43226, '\p{Scx=:\ASaur\z:}', "");;
    Expect(1, 43225, '\p{Scx=saur}', "");
    Expect(0, 43225, '\p{^Scx=saur}', "");
    Expect(0, 43225, '\P{Scx=saur}', "");
    Expect(1, 43225, '\P{^Scx=saur}', "");
    Expect(0, 43226, '\p{Scx=saur}', "");
    Expect(1, 43226, '\p{^Scx=saur}', "");
    Expect(1, 43226, '\P{Scx=saur}', "");
    Expect(0, 43226, '\P{^Scx=saur}', "");
    Expect(1, 43225, '\p{Scx=:\Asaur\z:}', "");;
    Expect(0, 43226, '\p{Scx=:\Asaur\z:}', "");;
    Expect(1, 43225, '\p{Scx=_ SAUR}', "");
    Expect(0, 43225, '\p{^Scx=_ SAUR}', "");
    Expect(0, 43225, '\P{Scx=_ SAUR}', "");
    Expect(1, 43225, '\P{^Scx=_ SAUR}', "");
    Expect(0, 43226, '\p{Scx=_ SAUR}', "");
    Expect(1, 43226, '\p{^Scx=_ SAUR}', "");
    Expect(1, 43226, '\P{Scx=_ SAUR}', "");
    Expect(0, 43226, '\P{^Scx=_ SAUR}', "");
    Error('\p{Is_Script_Extensions= 	saurashtra:=}');
    Error('\P{Is_Script_Extensions= 	saurashtra:=}');
    Expect(1, 43225, '\p{Is_Script_Extensions=saurashtra}', "");
    Expect(0, 43225, '\p{^Is_Script_Extensions=saurashtra}', "");
    Expect(0, 43225, '\P{Is_Script_Extensions=saurashtra}', "");
    Expect(1, 43225, '\P{^Is_Script_Extensions=saurashtra}', "");
    Expect(0, 43226, '\p{Is_Script_Extensions=saurashtra}', "");
    Expect(1, 43226, '\p{^Is_Script_Extensions=saurashtra}', "");
    Expect(1, 43226, '\P{Is_Script_Extensions=saurashtra}', "");
    Expect(0, 43226, '\P{^Is_Script_Extensions=saurashtra}', "");
    Expect(1, 43225, '\p{Is_Script_Extensions=	saurashtra}', "");
    Expect(0, 43225, '\p{^Is_Script_Extensions=	saurashtra}', "");
    Expect(0, 43225, '\P{Is_Script_Extensions=	saurashtra}', "");
    Expect(1, 43225, '\P{^Is_Script_Extensions=	saurashtra}', "");
    Expect(0, 43226, '\p{Is_Script_Extensions=	saurashtra}', "");
    Expect(1, 43226, '\p{^Is_Script_Extensions=	saurashtra}', "");
    Expect(1, 43226, '\P{Is_Script_Extensions=	saurashtra}', "");
    Expect(0, 43226, '\P{^Is_Script_Extensions=	saurashtra}', "");
    Error('\p{Is_Scx=:=Saur}');
    Error('\P{Is_Scx=:=Saur}');
    Expect(1, 43225, '\p{Is_Scx=saur}', "");
    Expect(0, 43225, '\p{^Is_Scx=saur}', "");
    Expect(0, 43225, '\P{Is_Scx=saur}', "");
    Expect(1, 43225, '\P{^Is_Scx=saur}', "");
    Expect(0, 43226, '\p{Is_Scx=saur}', "");
    Expect(1, 43226, '\p{^Is_Scx=saur}', "");
    Expect(1, 43226, '\P{Is_Scx=saur}', "");
    Expect(0, 43226, '\P{^Is_Scx=saur}', "");
    Expect(1, 43225, '\p{Is_Scx=	SAUR}', "");
    Expect(0, 43225, '\p{^Is_Scx=	SAUR}', "");
    Expect(0, 43225, '\P{Is_Scx=	SAUR}', "");
    Expect(1, 43225, '\P{^Is_Scx=	SAUR}', "");
    Expect(0, 43226, '\p{Is_Scx=	SAUR}', "");
    Expect(1, 43226, '\p{^Is_Scx=	SAUR}', "");
    Expect(1, 43226, '\P{Is_Scx=	SAUR}', "");
    Expect(0, 43226, '\P{^Is_Scx=	SAUR}', "");
    Error('\p{Script_Extensions=	/a/SignWriting}');
    Error('\P{Script_Extensions=	/a/SignWriting}');
    Expect(1, 121519, '\p{Script_Extensions=:\ASignWriting\z:}', "");;
    Expect(0, 121520, '\p{Script_Extensions=:\ASignWriting\z:}', "");;
    Expect(1, 121519, '\p{Script_Extensions:signwriting}', "");
    Expect(0, 121519, '\p{^Script_Extensions:signwriting}', "");
    Expect(0, 121519, '\P{Script_Extensions:signwriting}', "");
    Expect(1, 121519, '\P{^Script_Extensions:signwriting}', "");
    Expect(0, 121520, '\p{Script_Extensions:signwriting}', "");
    Expect(1, 121520, '\p{^Script_Extensions:signwriting}', "");
    Expect(1, 121520, '\P{Script_Extensions:signwriting}', "");
    Expect(0, 121520, '\P{^Script_Extensions:signwriting}', "");
    Expect(1, 121519, '\p{Script_Extensions=:\Asignwriting\z:}', "");;
    Expect(0, 121520, '\p{Script_Extensions=:\Asignwriting\z:}', "");;
    Expect(1, 121519, '\p{Script_Extensions= signwriting}', "");
    Expect(0, 121519, '\p{^Script_Extensions= signwriting}', "");
    Expect(0, 121519, '\P{Script_Extensions= signwriting}', "");
    Expect(1, 121519, '\P{^Script_Extensions= signwriting}', "");
    Expect(0, 121520, '\p{Script_Extensions= signwriting}', "");
    Expect(1, 121520, '\p{^Script_Extensions= signwriting}', "");
    Expect(1, 121520, '\P{Script_Extensions= signwriting}', "");
    Expect(0, 121520, '\P{^Script_Extensions= signwriting}', "");
    Error('\p{Scx=	/a/sgnw}');
    Error('\P{Scx=	/a/sgnw}');
    Expect(1, 121519, '\p{Scx=:\ASgnw\z:}', "");;
    Expect(0, 121520, '\p{Scx=:\ASgnw\z:}', "");;
    Expect(1, 121519, '\p{Scx=sgnw}', "");
    Expect(0, 121519, '\p{^Scx=sgnw}', "");
    Expect(0, 121519, '\P{Scx=sgnw}', "");
    Expect(1, 121519, '\P{^Scx=sgnw}', "");
    Expect(0, 121520, '\p{Scx=sgnw}', "");
    Expect(1, 121520, '\p{^Scx=sgnw}', "");
    Expect(1, 121520, '\P{Scx=sgnw}', "");
    Expect(0, 121520, '\P{^Scx=sgnw}', "");
    Expect(1, 121519, '\p{Scx=:\Asgnw\z:}', "");;
    Expect(0, 121520, '\p{Scx=:\Asgnw\z:}', "");;
    Expect(1, 121519, '\p{Scx=	Sgnw}', "");
    Expect(0, 121519, '\p{^Scx=	Sgnw}', "");
    Expect(0, 121519, '\P{Scx=	Sgnw}', "");
    Expect(1, 121519, '\P{^Scx=	Sgnw}', "");
    Expect(0, 121520, '\p{Scx=	Sgnw}', "");
    Expect(1, 121520, '\p{^Scx=	Sgnw}', "");
    Expect(1, 121520, '\P{Scx=	Sgnw}', "");
    Expect(0, 121520, '\P{^Scx=	Sgnw}', "");
    Error('\p{Is_Script_Extensions=_:=SIGNWRITING}');
    Error('\P{Is_Script_Extensions=_:=SIGNWRITING}');
    Expect(1, 121519, '\p{Is_Script_Extensions=signwriting}', "");
    Expect(0, 121519, '\p{^Is_Script_Extensions=signwriting}', "");
    Expect(0, 121519, '\P{Is_Script_Extensions=signwriting}', "");
    Expect(1, 121519, '\P{^Is_Script_Extensions=signwriting}', "");
    Expect(0, 121520, '\p{Is_Script_Extensions=signwriting}', "");
    Expect(1, 121520, '\p{^Is_Script_Extensions=signwriting}', "");
    Expect(1, 121520, '\P{Is_Script_Extensions=signwriting}', "");
    Expect(0, 121520, '\P{^Is_Script_Extensions=signwriting}', "");
    Expect(1, 121519, '\p{Is_Script_Extensions=_signwriting}', "");
    Expect(0, 121519, '\p{^Is_Script_Extensions=_signwriting}', "");
    Expect(0, 121519, '\P{Is_Script_Extensions=_signwriting}', "");
    Expect(1, 121519, '\P{^Is_Script_Extensions=_signwriting}', "");
    Expect(0, 121520, '\p{Is_Script_Extensions=_signwriting}', "");
    Expect(1, 121520, '\p{^Is_Script_Extensions=_signwriting}', "");
    Expect(1, 121520, '\P{Is_Script_Extensions=_signwriting}', "");
    Expect(0, 121520, '\P{^Is_Script_Extensions=_signwriting}', "");
    Error('\p{Is_Scx=:= 	Sgnw}');
    Error('\P{Is_Scx=:= 	Sgnw}');
    Expect(1, 121519, '\p{Is_Scx:   sgnw}', "");
    Expect(0, 121519, '\p{^Is_Scx:   sgnw}', "");
    Expect(0, 121519, '\P{Is_Scx:   sgnw}', "");
    Expect(1, 121519, '\P{^Is_Scx:   sgnw}', "");
    Expect(0, 121520, '\p{Is_Scx:   sgnw}', "");
    Expect(1, 121520, '\p{^Is_Scx:   sgnw}', "");
    Expect(1, 121520, '\P{Is_Scx:   sgnw}', "");
    Expect(0, 121520, '\P{^Is_Scx:   sgnw}', "");
    Expect(1, 121519, '\p{Is_Scx=_-sgnw}', "");
    Expect(0, 121519, '\p{^Is_Scx=_-sgnw}', "");
    Expect(0, 121519, '\P{Is_Scx=_-sgnw}', "");
    Expect(1, 121519, '\P{^Is_Scx=_-sgnw}', "");
    Expect(0, 121520, '\p{Is_Scx=_-sgnw}', "");
    Expect(1, 121520, '\p{^Is_Scx=_-sgnw}', "");
    Expect(1, 121520, '\P{Is_Scx=_-sgnw}', "");
    Expect(0, 121520, '\P{^Is_Scx=_-sgnw}', "");
    Error('\p{Script_Extensions=_SHAVIAN/a/}');
    Error('\P{Script_Extensions=_SHAVIAN/a/}');
    Expect(1, 66687, '\p{Script_Extensions=:\AShavian\z:}', "");;
    Expect(0, 66688, '\p{Script_Extensions=:\AShavian\z:}', "");;
    Expect(1, 66687, '\p{Script_Extensions=shavian}', "");
    Expect(0, 66687, '\p{^Script_Extensions=shavian}', "");
    Expect(0, 66687, '\P{Script_Extensions=shavian}', "");
    Expect(1, 66687, '\P{^Script_Extensions=shavian}', "");
    Expect(0, 66688, '\p{Script_Extensions=shavian}', "");
    Expect(1, 66688, '\p{^Script_Extensions=shavian}', "");
    Expect(1, 66688, '\P{Script_Extensions=shavian}', "");
    Expect(0, 66688, '\P{^Script_Extensions=shavian}', "");
    Expect(1, 66687, '\p{Script_Extensions=:\Ashavian\z:}', "");;
    Expect(0, 66688, '\p{Script_Extensions=:\Ashavian\z:}', "");;
    Expect(1, 66687, '\p{Script_Extensions=_shavian}', "");
    Expect(0, 66687, '\p{^Script_Extensions=_shavian}', "");
    Expect(0, 66687, '\P{Script_Extensions=_shavian}', "");
    Expect(1, 66687, '\P{^Script_Extensions=_shavian}', "");
    Expect(0, 66688, '\p{Script_Extensions=_shavian}', "");
    Expect(1, 66688, '\p{^Script_Extensions=_shavian}', "");
    Expect(1, 66688, '\P{Script_Extensions=_shavian}', "");
    Expect(0, 66688, '\P{^Script_Extensions=_shavian}', "");
    Error('\p{Scx=/a/	-shaw}');
    Error('\P{Scx=/a/	-shaw}');
    Expect(1, 66687, '\p{Scx=:\AShaw\z:}', "");;
    Expect(0, 66688, '\p{Scx=:\AShaw\z:}', "");;
    Expect(1, 66687, '\p{Scx=shaw}', "");
    Expect(0, 66687, '\p{^Scx=shaw}', "");
    Expect(0, 66687, '\P{Scx=shaw}', "");
    Expect(1, 66687, '\P{^Scx=shaw}', "");
    Expect(0, 66688, '\p{Scx=shaw}', "");
    Expect(1, 66688, '\p{^Scx=shaw}', "");
    Expect(1, 66688, '\P{Scx=shaw}', "");
    Expect(0, 66688, '\P{^Scx=shaw}', "");
    Expect(1, 66687, '\p{Scx=:\Ashaw\z:}', "");;
    Expect(0, 66688, '\p{Scx=:\Ashaw\z:}', "");;
    Expect(1, 66687, '\p{Scx=_-SHAW}', "");
    Expect(0, 66687, '\p{^Scx=_-SHAW}', "");
    Expect(0, 66687, '\P{Scx=_-SHAW}', "");
    Expect(1, 66687, '\P{^Scx=_-SHAW}', "");
    Expect(0, 66688, '\p{Scx=_-SHAW}', "");
    Expect(1, 66688, '\p{^Scx=_-SHAW}', "");
    Expect(1, 66688, '\P{Scx=_-SHAW}', "");
    Expect(0, 66688, '\P{^Scx=_-SHAW}', "");
    Error('\p{Is_Script_Extensions=-/a/shavian}');
    Error('\P{Is_Script_Extensions=-/a/shavian}');
    Expect(1, 66687, '\p{Is_Script_Extensions=shavian}', "");
    Expect(0, 66687, '\p{^Is_Script_Extensions=shavian}', "");
    Expect(0, 66687, '\P{Is_Script_Extensions=shavian}', "");
    Expect(1, 66687, '\P{^Is_Script_Extensions=shavian}', "");
    Expect(0, 66688, '\p{Is_Script_Extensions=shavian}', "");
    Expect(1, 66688, '\p{^Is_Script_Extensions=shavian}', "");
    Expect(1, 66688, '\P{Is_Script_Extensions=shavian}', "");
    Expect(0, 66688, '\P{^Is_Script_Extensions=shavian}', "");
    Expect(1, 66687, '\p{Is_Script_Extensions=-	SHAVIAN}', "");
    Expect(0, 66687, '\p{^Is_Script_Extensions=-	SHAVIAN}', "");
    Expect(0, 66687, '\P{Is_Script_Extensions=-	SHAVIAN}', "");
    Expect(1, 66687, '\P{^Is_Script_Extensions=-	SHAVIAN}', "");
    Expect(0, 66688, '\p{Is_Script_Extensions=-	SHAVIAN}', "");
    Expect(1, 66688, '\p{^Is_Script_Extensions=-	SHAVIAN}', "");
    Expect(1, 66688, '\P{Is_Script_Extensions=-	SHAVIAN}', "");
    Expect(0, 66688, '\P{^Is_Script_Extensions=-	SHAVIAN}', "");
    Error('\p{Is_Scx=__Shaw:=}');
    Error('\P{Is_Scx=__Shaw:=}');
    Expect(1, 66687, '\p{Is_Scx=shaw}', "");
    Expect(0, 66687, '\p{^Is_Scx=shaw}', "");
    Expect(0, 66687, '\P{Is_Scx=shaw}', "");
    Expect(1, 66687, '\P{^Is_Scx=shaw}', "");
    Expect(0, 66688, '\p{Is_Scx=shaw}', "");
    Expect(1, 66688, '\p{^Is_Scx=shaw}', "");
    Expect(1, 66688, '\P{Is_Scx=shaw}', "");
    Expect(0, 66688, '\P{^Is_Scx=shaw}', "");
    Expect(1, 66687, '\p{Is_Scx= shaw}', "");
    Expect(0, 66687, '\p{^Is_Scx= shaw}', "");
    Expect(0, 66687, '\P{Is_Scx= shaw}', "");
    Expect(1, 66687, '\P{^Is_Scx= shaw}', "");
    Expect(0, 66688, '\p{Is_Scx= shaw}', "");
    Expect(1, 66688, '\p{^Is_Scx= shaw}', "");
    Expect(1, 66688, '\P{Is_Scx= shaw}', "");
    Expect(0, 66688, '\P{^Is_Scx= shaw}', "");
    Error('\p{Script_Extensions=sharada:=}');
    Error('\P{Script_Extensions=sharada:=}');
    Expect(1, 70111, '\p{Script_Extensions=:\ASharada\z:}', "");;
    Expect(0, 70112, '\p{Script_Extensions=:\ASharada\z:}', "");;
    Expect(1, 70111, '\p{Script_Extensions=sharada}', "");
    Expect(0, 70111, '\p{^Script_Extensions=sharada}', "");
    Expect(0, 70111, '\P{Script_Extensions=sharada}', "");
    Expect(1, 70111, '\P{^Script_Extensions=sharada}', "");
    Expect(0, 70112, '\p{Script_Extensions=sharada}', "");
    Expect(1, 70112, '\p{^Script_Extensions=sharada}', "");
    Expect(1, 70112, '\P{Script_Extensions=sharada}', "");
    Expect(0, 70112, '\P{^Script_Extensions=sharada}', "");
    Expect(1, 70111, '\p{Script_Extensions=:\Asharada\z:}', "");;
    Expect(0, 70112, '\p{Script_Extensions=:\Asharada\z:}', "");;
    Expect(1, 70111, '\p{Script_Extensions=- sharada}', "");
    Expect(0, 70111, '\p{^Script_Extensions=- sharada}', "");
    Expect(0, 70111, '\P{Script_Extensions=- sharada}', "");
    Expect(1, 70111, '\P{^Script_Extensions=- sharada}', "");
    Expect(0, 70112, '\p{Script_Extensions=- sharada}', "");
    Expect(1, 70112, '\p{^Script_Extensions=- sharada}', "");
    Expect(1, 70112, '\P{Script_Extensions=- sharada}', "");
    Expect(0, 70112, '\P{^Script_Extensions=- sharada}', "");
    Error('\p{Scx= :=Shrd}');
    Error('\P{Scx= :=Shrd}');
    Expect(1, 70111, '\p{Scx=:\AShrd\z:}', "");;
    Expect(0, 70112, '\p{Scx=:\AShrd\z:}', "");;
    Expect(1, 70111, '\p{Scx=shrd}', "");
    Expect(0, 70111, '\p{^Scx=shrd}', "");
    Expect(0, 70111, '\P{Scx=shrd}', "");
    Expect(1, 70111, '\P{^Scx=shrd}', "");
    Expect(0, 70112, '\p{Scx=shrd}', "");
    Expect(1, 70112, '\p{^Scx=shrd}', "");
    Expect(1, 70112, '\P{Scx=shrd}', "");
    Expect(0, 70112, '\P{^Scx=shrd}', "");
    Expect(1, 70111, '\p{Scx=:\Ashrd\z:}', "");;
    Expect(0, 70112, '\p{Scx=:\Ashrd\z:}', "");;
    Expect(1, 70111, '\p{Scx=	_shrd}', "");
    Expect(0, 70111, '\p{^Scx=	_shrd}', "");
    Expect(0, 70111, '\P{Scx=	_shrd}', "");
    Expect(1, 70111, '\P{^Scx=	_shrd}', "");
    Expect(0, 70112, '\p{Scx=	_shrd}', "");
    Expect(1, 70112, '\p{^Scx=	_shrd}', "");
    Expect(1, 70112, '\P{Scx=	_shrd}', "");
    Expect(0, 70112, '\P{^Scx=	_shrd}', "");
    Error('\p{Is_Script_Extensions=  SHARADA/a/}');
    Error('\P{Is_Script_Extensions=  SHARADA/a/}');
    Expect(1, 70111, '\p{Is_Script_Extensions:   sharada}', "");
    Expect(0, 70111, '\p{^Is_Script_Extensions:   sharada}', "");
    Expect(0, 70111, '\P{Is_Script_Extensions:   sharada}', "");
    Expect(1, 70111, '\P{^Is_Script_Extensions:   sharada}', "");
    Expect(0, 70112, '\p{Is_Script_Extensions:   sharada}', "");
    Expect(1, 70112, '\p{^Is_Script_Extensions:   sharada}', "");
    Expect(1, 70112, '\P{Is_Script_Extensions:   sharada}', "");
    Expect(0, 70112, '\P{^Is_Script_Extensions:   sharada}', "");
    Expect(1, 70111, '\p{Is_Script_Extensions=-_Sharada}', "");
    Expect(0, 70111, '\p{^Is_Script_Extensions=-_Sharada}', "");
    Expect(0, 70111, '\P{Is_Script_Extensions=-_Sharada}', "");
    Expect(1, 70111, '\P{^Is_Script_Extensions=-_Sharada}', "");
    Expect(0, 70112, '\p{Is_Script_Extensions=-_Sharada}', "");
    Expect(1, 70112, '\p{^Is_Script_Extensions=-_Sharada}', "");
    Expect(1, 70112, '\P{Is_Script_Extensions=-_Sharada}', "");
    Expect(0, 70112, '\P{^Is_Script_Extensions=-_Sharada}', "");
    Error('\p{Is_Scx=	/a/shrd}');
    Error('\P{Is_Scx=	/a/shrd}');
    Expect(1, 70111, '\p{Is_Scx=shrd}', "");
    Expect(0, 70111, '\p{^Is_Scx=shrd}', "");
    Expect(0, 70111, '\P{Is_Scx=shrd}', "");
    Expect(1, 70111, '\P{^Is_Scx=shrd}', "");
    Expect(0, 70112, '\p{Is_Scx=shrd}', "");
    Expect(1, 70112, '\p{^Is_Scx=shrd}', "");
    Expect(1, 70112, '\P{Is_Scx=shrd}', "");
    Expect(0, 70112, '\P{^Is_Scx=shrd}', "");
    Expect(1, 70111, '\p{Is_Scx=Shrd}', "");
    Expect(0, 70111, '\p{^Is_Scx=Shrd}', "");
    Expect(0, 70111, '\P{Is_Scx=Shrd}', "");
    Expect(1, 70111, '\P{^Is_Scx=Shrd}', "");
    Expect(0, 70112, '\p{Is_Scx=Shrd}', "");
    Expect(1, 70112, '\p{^Is_Scx=Shrd}', "");
    Expect(1, 70112, '\P{Is_Scx=Shrd}', "");
    Expect(0, 70112, '\P{^Is_Scx=Shrd}', "");
    Error('\p{Script_Extensions::= SIDDHAM}');
    Error('\P{Script_Extensions::= SIDDHAM}');
    Expect(1, 71133, '\p{Script_Extensions=:\ASiddham\z:}', "");;
    Expect(0, 71134, '\p{Script_Extensions=:\ASiddham\z:}', "");;
    Expect(1, 71133, '\p{Script_Extensions=siddham}', "");
    Expect(0, 71133, '\p{^Script_Extensions=siddham}', "");
    Expect(0, 71133, '\P{Script_Extensions=siddham}', "");
    Expect(1, 71133, '\P{^Script_Extensions=siddham}', "");
    Expect(0, 71134, '\p{Script_Extensions=siddham}', "");
    Expect(1, 71134, '\p{^Script_Extensions=siddham}', "");
    Expect(1, 71134, '\P{Script_Extensions=siddham}', "");
    Expect(0, 71134, '\P{^Script_Extensions=siddham}', "");
    Expect(1, 71133, '\p{Script_Extensions=:\Asiddham\z:}', "");;
    Expect(0, 71134, '\p{Script_Extensions=:\Asiddham\z:}', "");;
    Expect(1, 71133, '\p{Script_Extensions=	_Siddham}', "");
    Expect(0, 71133, '\p{^Script_Extensions=	_Siddham}', "");
    Expect(0, 71133, '\P{Script_Extensions=	_Siddham}', "");
    Expect(1, 71133, '\P{^Script_Extensions=	_Siddham}', "");
    Expect(0, 71134, '\p{Script_Extensions=	_Siddham}', "");
    Expect(1, 71134, '\p{^Script_Extensions=	_Siddham}', "");
    Expect(1, 71134, '\P{Script_Extensions=	_Siddham}', "");
    Expect(0, 71134, '\P{^Script_Extensions=	_Siddham}', "");
    Error('\p{Scx=/a/SIDD}');
    Error('\P{Scx=/a/SIDD}');
    Expect(1, 71133, '\p{Scx=:\ASidd\z:}', "");;
    Expect(0, 71134, '\p{Scx=:\ASidd\z:}', "");;
    Expect(1, 71133, '\p{Scx:   sidd}', "");
    Expect(0, 71133, '\p{^Scx:   sidd}', "");
    Expect(0, 71133, '\P{Scx:   sidd}', "");
    Expect(1, 71133, '\P{^Scx:   sidd}', "");
    Expect(0, 71134, '\p{Scx:   sidd}', "");
    Expect(1, 71134, '\p{^Scx:   sidd}', "");
    Expect(1, 71134, '\P{Scx:   sidd}', "");
    Expect(0, 71134, '\P{^Scx:   sidd}', "");
    Expect(1, 71133, '\p{Scx=:\Asidd\z:}', "");;
    Expect(0, 71134, '\p{Scx=:\Asidd\z:}', "");;
    Expect(1, 71133, '\p{Scx=	Sidd}', "");
    Expect(0, 71133, '\p{^Scx=	Sidd}', "");
    Expect(0, 71133, '\P{Scx=	Sidd}', "");
    Expect(1, 71133, '\P{^Scx=	Sidd}', "");
    Expect(0, 71134, '\p{Scx=	Sidd}', "");
    Expect(1, 71134, '\p{^Scx=	Sidd}', "");
    Expect(1, 71134, '\P{Scx=	Sidd}', "");
    Expect(0, 71134, '\P{^Scx=	Sidd}', "");
    Error('\p{Is_Script_Extensions: 	siddham/a/}');
    Error('\P{Is_Script_Extensions: 	siddham/a/}');
    Expect(1, 71133, '\p{Is_Script_Extensions=siddham}', "");
    Expect(0, 71133, '\p{^Is_Script_Extensions=siddham}', "");
    Expect(0, 71133, '\P{Is_Script_Extensions=siddham}', "");
    Expect(1, 71133, '\P{^Is_Script_Extensions=siddham}', "");
    Expect(0, 71134, '\p{Is_Script_Extensions=siddham}', "");
    Expect(1, 71134, '\p{^Is_Script_Extensions=siddham}', "");
    Expect(1, 71134, '\P{Is_Script_Extensions=siddham}', "");
    Expect(0, 71134, '\P{^Is_Script_Extensions=siddham}', "");
    Expect(1, 71133, '\p{Is_Script_Extensions=-_siddham}', "");
    Expect(0, 71133, '\p{^Is_Script_Extensions=-_siddham}', "");
    Expect(0, 71133, '\P{Is_Script_Extensions=-_siddham}', "");
    Expect(1, 71133, '\P{^Is_Script_Extensions=-_siddham}', "");
    Expect(0, 71134, '\p{Is_Script_Extensions=-_siddham}', "");
    Expect(1, 71134, '\p{^Is_Script_Extensions=-_siddham}', "");
    Expect(1, 71134, '\P{Is_Script_Extensions=-_siddham}', "");
    Expect(0, 71134, '\P{^Is_Script_Extensions=-_siddham}', "");
    Error('\p{Is_Scx=:=_ SIDD}');
    Error('\P{Is_Scx=:=_ SIDD}');
    Expect(1, 71133, '\p{Is_Scx=sidd}', "");
    Expect(0, 71133, '\p{^Is_Scx=sidd}', "");
    Expect(0, 71133, '\P{Is_Scx=sidd}', "");
    Expect(1, 71133, '\P{^Is_Scx=sidd}', "");
    Expect(0, 71134, '\p{Is_Scx=sidd}', "");
    Expect(1, 71134, '\p{^Is_Scx=sidd}', "");
    Expect(1, 71134, '\P{Is_Scx=sidd}', "");
    Expect(0, 71134, '\P{^Is_Scx=sidd}', "");
    Expect(1, 71133, '\p{Is_Scx=-_Sidd}', "");
    Expect(0, 71133, '\p{^Is_Scx=-_Sidd}', "");
    Expect(0, 71133, '\P{Is_Scx=-_Sidd}', "");
    Expect(1, 71133, '\P{^Is_Scx=-_Sidd}', "");
    Expect(0, 71134, '\p{Is_Scx=-_Sidd}', "");
    Expect(1, 71134, '\p{^Is_Scx=-_Sidd}', "");
    Expect(1, 71134, '\P{Is_Scx=-_Sidd}', "");
    Expect(0, 71134, '\P{^Is_Scx=-_Sidd}', "");
    Error('\p{Script_Extensions=:=	_khudawadi}');
    Error('\P{Script_Extensions=:=	_khudawadi}');
    Expect(1, 70393, '\p{Script_Extensions=:\AKhudawadi\z:}', "");;
    Expect(0, 70394, '\p{Script_Extensions=:\AKhudawadi\z:}', "");;
    Expect(1, 70393, '\p{Script_Extensions=khudawadi}', "");
    Expect(0, 70393, '\p{^Script_Extensions=khudawadi}', "");
    Expect(0, 70393, '\P{Script_Extensions=khudawadi}', "");
    Expect(1, 70393, '\P{^Script_Extensions=khudawadi}', "");
    Expect(0, 70394, '\p{Script_Extensions=khudawadi}', "");
    Expect(1, 70394, '\p{^Script_Extensions=khudawadi}', "");
    Expect(1, 70394, '\P{Script_Extensions=khudawadi}', "");
    Expect(0, 70394, '\P{^Script_Extensions=khudawadi}', "");
    Expect(1, 70393, '\p{Script_Extensions=:\Akhudawadi\z:}', "");;
    Expect(0, 70394, '\p{Script_Extensions=:\Akhudawadi\z:}', "");;
    Expect(1, 70393, '\p{Script_Extensions=  KHUDAWADI}', "");
    Expect(0, 70393, '\p{^Script_Extensions=  KHUDAWADI}', "");
    Expect(0, 70393, '\P{Script_Extensions=  KHUDAWADI}', "");
    Expect(1, 70393, '\P{^Script_Extensions=  KHUDAWADI}', "");
    Expect(0, 70394, '\p{Script_Extensions=  KHUDAWADI}', "");
    Expect(1, 70394, '\p{^Script_Extensions=  KHUDAWADI}', "");
    Expect(1, 70394, '\P{Script_Extensions=  KHUDAWADI}', "");
    Expect(0, 70394, '\P{^Script_Extensions=  KHUDAWADI}', "");
    Error('\p{Scx=--sind:=}');
    Error('\P{Scx=--sind:=}');
    Expect(1, 70393, '\p{Scx=:\ASind\z:}', "");;
    Expect(0, 70394, '\p{Scx=:\ASind\z:}', "");;
    Expect(1, 70393, '\p{Scx:   sind}', "");
    Expect(0, 70393, '\p{^Scx:   sind}', "");
    Expect(0, 70393, '\P{Scx:   sind}', "");
    Expect(1, 70393, '\P{^Scx:   sind}', "");
    Expect(0, 70394, '\p{Scx:   sind}', "");
    Expect(1, 70394, '\p{^Scx:   sind}', "");
    Expect(1, 70394, '\P{Scx:   sind}', "");
    Expect(0, 70394, '\P{^Scx:   sind}', "");
    Expect(1, 70393, '\p{Scx=:\Asind\z:}', "");;
    Expect(0, 70394, '\p{Scx=:\Asind\z:}', "");;
    Expect(1, 70393, '\p{Scx=_-SIND}', "");
    Expect(0, 70393, '\p{^Scx=_-SIND}', "");
    Expect(0, 70393, '\P{Scx=_-SIND}', "");
    Expect(1, 70393, '\P{^Scx=_-SIND}', "");
    Expect(0, 70394, '\p{Scx=_-SIND}', "");
    Expect(1, 70394, '\p{^Scx=_-SIND}', "");
    Expect(1, 70394, '\P{Scx=_-SIND}', "");
    Expect(0, 70394, '\P{^Scx=_-SIND}', "");
    Error('\p{Is_Script_Extensions=/a/ -Khudawadi}');
    Error('\P{Is_Script_Extensions=/a/ -Khudawadi}');
    Expect(1, 70393, '\p{Is_Script_Extensions=khudawadi}', "");
    Expect(0, 70393, '\p{^Is_Script_Extensions=khudawadi}', "");
    Expect(0, 70393, '\P{Is_Script_Extensions=khudawadi}', "");
    Expect(1, 70393, '\P{^Is_Script_Extensions=khudawadi}', "");
    Expect(0, 70394, '\p{Is_Script_Extensions=khudawadi}', "");
    Expect(1, 70394, '\p{^Is_Script_Extensions=khudawadi}', "");
    Expect(1, 70394, '\P{Is_Script_Extensions=khudawadi}', "");
    Expect(0, 70394, '\P{^Is_Script_Extensions=khudawadi}', "");
    Expect(1, 70393, '\p{Is_Script_Extensions:	_ Khudawadi}', "");
    Expect(0, 70393, '\p{^Is_Script_Extensions:	_ Khudawadi}', "");
    Expect(0, 70393, '\P{Is_Script_Extensions:	_ Khudawadi}', "");
    Expect(1, 70393, '\P{^Is_Script_Extensions:	_ Khudawadi}', "");
    Expect(0, 70394, '\p{Is_Script_Extensions:	_ Khudawadi}', "");
    Expect(1, 70394, '\p{^Is_Script_Extensions:	_ Khudawadi}', "");
    Expect(1, 70394, '\P{Is_Script_Extensions:	_ Khudawadi}', "");
    Expect(0, 70394, '\P{^Is_Script_Extensions:	_ Khudawadi}', "");
    Error('\p{Is_Scx=/a/		Sind}');
    Error('\P{Is_Scx=/a/		Sind}');
    Expect(1, 70393, '\p{Is_Scx=sind}', "");
    Expect(0, 70393, '\p{^Is_Scx=sind}', "");
    Expect(0, 70393, '\P{Is_Scx=sind}', "");
    Expect(1, 70393, '\P{^Is_Scx=sind}', "");
    Expect(0, 70394, '\p{Is_Scx=sind}', "");
    Expect(1, 70394, '\p{^Is_Scx=sind}', "");
    Expect(1, 70394, '\P{Is_Scx=sind}', "");
    Expect(0, 70394, '\P{^Is_Scx=sind}', "");
    Expect(1, 70393, '\p{Is_Scx=	 Sind}', "");
    Expect(0, 70393, '\p{^Is_Scx=	 Sind}', "");
    Expect(0, 70393, '\P{Is_Scx=	 Sind}', "");
    Expect(1, 70393, '\P{^Is_Scx=	 Sind}', "");
    Expect(0, 70394, '\p{Is_Scx=	 Sind}', "");
    Expect(1, 70394, '\p{^Is_Scx=	 Sind}', "");
    Expect(1, 70394, '\P{Is_Scx=	 Sind}', "");
    Expect(0, 70394, '\P{^Is_Scx=	 Sind}', "");
    Error('\p{Script_Extensions=:=-SINHALA}');
    Error('\P{Script_Extensions=:=-SINHALA}');
    Expect(1, 70132, '\p{Script_Extensions=:\ASinhala\z:}', "");;
    Expect(0, 70133, '\p{Script_Extensions=:\ASinhala\z:}', "");;
    Expect(1, 70132, '\p{Script_Extensions=sinhala}', "");
    Expect(0, 70132, '\p{^Script_Extensions=sinhala}', "");
    Expect(0, 70132, '\P{Script_Extensions=sinhala}', "");
    Expect(1, 70132, '\P{^Script_Extensions=sinhala}', "");
    Expect(0, 70133, '\p{Script_Extensions=sinhala}', "");
    Expect(1, 70133, '\p{^Script_Extensions=sinhala}', "");
    Expect(1, 70133, '\P{Script_Extensions=sinhala}', "");
    Expect(0, 70133, '\P{^Script_Extensions=sinhala}', "");
    Expect(1, 70132, '\p{Script_Extensions=:\Asinhala\z:}', "");;
    Expect(0, 70133, '\p{Script_Extensions=:\Asinhala\z:}', "");;
    Expect(1, 70132, '\p{Script_Extensions=Sinhala}', "");
    Expect(0, 70132, '\p{^Script_Extensions=Sinhala}', "");
    Expect(0, 70132, '\P{Script_Extensions=Sinhala}', "");
    Expect(1, 70132, '\P{^Script_Extensions=Sinhala}', "");
    Expect(0, 70133, '\p{Script_Extensions=Sinhala}', "");
    Expect(1, 70133, '\p{^Script_Extensions=Sinhala}', "");
    Expect(1, 70133, '\P{Script_Extensions=Sinhala}', "");
    Expect(0, 70133, '\P{^Script_Extensions=Sinhala}', "");
    Error('\p{Scx= /a/Sinh}');
    Error('\P{Scx= /a/Sinh}');
    Expect(1, 70132, '\p{Scx=:\ASinh\z:}', "");;
    Expect(0, 70133, '\p{Scx=:\ASinh\z:}', "");;
    Expect(1, 70132, '\p{Scx=sinh}', "");
    Expect(0, 70132, '\p{^Scx=sinh}', "");
    Expect(0, 70132, '\P{Scx=sinh}', "");
    Expect(1, 70132, '\P{^Scx=sinh}', "");
    Expect(0, 70133, '\p{Scx=sinh}', "");
    Expect(1, 70133, '\p{^Scx=sinh}', "");
    Expect(1, 70133, '\P{Scx=sinh}', "");
    Expect(0, 70133, '\P{^Scx=sinh}', "");
    Expect(1, 70132, '\p{Scx=:\Asinh\z:}', "");;
    Expect(0, 70133, '\p{Scx=:\Asinh\z:}', "");;
    Expect(1, 70132, '\p{Scx=- Sinh}', "");
    Expect(0, 70132, '\p{^Scx=- Sinh}', "");
    Expect(0, 70132, '\P{Scx=- Sinh}', "");
    Expect(1, 70132, '\P{^Scx=- Sinh}', "");
    Expect(0, 70133, '\p{Scx=- Sinh}', "");
    Expect(1, 70133, '\p{^Scx=- Sinh}', "");
    Expect(1, 70133, '\P{Scx=- Sinh}', "");
    Expect(0, 70133, '\P{^Scx=- Sinh}', "");
    Error('\p{Is_Script_Extensions=_Sinhala:=}');
    Error('\P{Is_Script_Extensions=_Sinhala:=}');
    Expect(1, 70132, '\p{Is_Script_Extensions=sinhala}', "");
    Expect(0, 70132, '\p{^Is_Script_Extensions=sinhala}', "");
    Expect(0, 70132, '\P{Is_Script_Extensions=sinhala}', "");
    Expect(1, 70132, '\P{^Is_Script_Extensions=sinhala}', "");
    Expect(0, 70133, '\p{Is_Script_Extensions=sinhala}', "");
    Expect(1, 70133, '\p{^Is_Script_Extensions=sinhala}', "");
    Expect(1, 70133, '\P{Is_Script_Extensions=sinhala}', "");
    Expect(0, 70133, '\P{^Is_Script_Extensions=sinhala}', "");
    Expect(1, 70132, '\p{Is_Script_Extensions= -Sinhala}', "");
    Expect(0, 70132, '\p{^Is_Script_Extensions= -Sinhala}', "");
    Expect(0, 70132, '\P{Is_Script_Extensions= -Sinhala}', "");
    Expect(1, 70132, '\P{^Is_Script_Extensions= -Sinhala}', "");
    Expect(0, 70133, '\p{Is_Script_Extensions= -Sinhala}', "");
    Expect(1, 70133, '\p{^Is_Script_Extensions= -Sinhala}', "");
    Expect(1, 70133, '\P{Is_Script_Extensions= -Sinhala}', "");
    Expect(0, 70133, '\P{^Is_Script_Extensions= -Sinhala}', "");
    Error('\p{Is_Scx=  sinh:=}');
    Error('\P{Is_Scx=  sinh:=}');
    Expect(1, 70132, '\p{Is_Scx=sinh}', "");
    Expect(0, 70132, '\p{^Is_Scx=sinh}', "");
    Expect(0, 70132, '\P{Is_Scx=sinh}', "");
    Expect(1, 70132, '\P{^Is_Scx=sinh}', "");
    Expect(0, 70133, '\p{Is_Scx=sinh}', "");
    Expect(1, 70133, '\p{^Is_Scx=sinh}', "");
    Expect(1, 70133, '\P{Is_Scx=sinh}', "");
    Expect(0, 70133, '\P{^Is_Scx=sinh}', "");
    Expect(1, 70132, '\p{Is_Scx= Sinh}', "");
    Expect(0, 70132, '\p{^Is_Scx= Sinh}', "");
    Expect(0, 70132, '\P{Is_Scx= Sinh}', "");
    Expect(1, 70132, '\P{^Is_Scx= Sinh}', "");
    Expect(0, 70133, '\p{Is_Scx= Sinh}', "");
    Expect(1, 70133, '\p{^Is_Scx= Sinh}', "");
    Expect(1, 70133, '\P{Is_Scx= Sinh}', "");
    Expect(0, 70133, '\P{^Is_Scx= Sinh}', "");
    Error('\p{Script_Extensions=:=_-Sogdian}');
    Error('\P{Script_Extensions=:=_-Sogdian}');
    Expect(1, 69465, '\p{Script_Extensions=:\ASogdian\z:}', "");;
    Expect(0, 69466, '\p{Script_Extensions=:\ASogdian\z:}', "");;
    Expect(1, 69465, '\p{Script_Extensions=sogdian}', "");
    Expect(0, 69465, '\p{^Script_Extensions=sogdian}', "");
    Expect(0, 69465, '\P{Script_Extensions=sogdian}', "");
    Expect(1, 69465, '\P{^Script_Extensions=sogdian}', "");
    Expect(0, 69466, '\p{Script_Extensions=sogdian}', "");
    Expect(1, 69466, '\p{^Script_Extensions=sogdian}', "");
    Expect(1, 69466, '\P{Script_Extensions=sogdian}', "");
    Expect(0, 69466, '\P{^Script_Extensions=sogdian}', "");
    Expect(1, 69465, '\p{Script_Extensions=:\Asogdian\z:}', "");;
    Expect(0, 69466, '\p{Script_Extensions=:\Asogdian\z:}', "");;
    Expect(1, 69465, '\p{Script_Extensions=	_SOGDIAN}', "");
    Expect(0, 69465, '\p{^Script_Extensions=	_SOGDIAN}', "");
    Expect(0, 69465, '\P{Script_Extensions=	_SOGDIAN}', "");
    Expect(1, 69465, '\P{^Script_Extensions=	_SOGDIAN}', "");
    Expect(0, 69466, '\p{Script_Extensions=	_SOGDIAN}', "");
    Expect(1, 69466, '\p{^Script_Extensions=	_SOGDIAN}', "");
    Expect(1, 69466, '\P{Script_Extensions=	_SOGDIAN}', "");
    Expect(0, 69466, '\P{^Script_Extensions=	_SOGDIAN}', "");
    Error('\p{Scx=/a/ 	SOGD}');
    Error('\P{Scx=/a/ 	SOGD}');
    Expect(1, 69465, '\p{Scx=:\ASogd\z:}', "");;
    Expect(0, 69466, '\p{Scx=:\ASogd\z:}', "");;
    Expect(1, 69465, '\p{Scx=sogd}', "");
    Expect(0, 69465, '\p{^Scx=sogd}', "");
    Expect(0, 69465, '\P{Scx=sogd}', "");
    Expect(1, 69465, '\P{^Scx=sogd}', "");
    Expect(0, 69466, '\p{Scx=sogd}', "");
    Expect(1, 69466, '\p{^Scx=sogd}', "");
    Expect(1, 69466, '\P{Scx=sogd}', "");
    Expect(0, 69466, '\P{^Scx=sogd}', "");
    Expect(1, 69465, '\p{Scx=:\Asogd\z:}', "");;
    Expect(0, 69466, '\p{Scx=:\Asogd\z:}', "");;
    Expect(1, 69465, '\p{Scx= sogd}', "");
    Expect(0, 69465, '\p{^Scx= sogd}', "");
    Expect(0, 69465, '\P{Scx= sogd}', "");
    Expect(1, 69465, '\P{^Scx= sogd}', "");
    Expect(0, 69466, '\p{Scx= sogd}', "");
    Expect(1, 69466, '\p{^Scx= sogd}', "");
    Expect(1, 69466, '\P{Scx= sogd}', "");
    Expect(0, 69466, '\P{^Scx= sogd}', "");
    Error('\p{Is_Script_Extensions=	Sogdian/a/}');
    Error('\P{Is_Script_Extensions=	Sogdian/a/}');
    Expect(1, 69465, '\p{Is_Script_Extensions=sogdian}', "");
    Expect(0, 69465, '\p{^Is_Script_Extensions=sogdian}', "");
    Expect(0, 69465, '\P{Is_Script_Extensions=sogdian}', "");
    Expect(1, 69465, '\P{^Is_Script_Extensions=sogdian}', "");
    Expect(0, 69466, '\p{Is_Script_Extensions=sogdian}', "");
    Expect(1, 69466, '\p{^Is_Script_Extensions=sogdian}', "");
    Expect(1, 69466, '\P{Is_Script_Extensions=sogdian}', "");
    Expect(0, 69466, '\P{^Is_Script_Extensions=sogdian}', "");
    Expect(1, 69465, '\p{Is_Script_Extensions=-	Sogdian}', "");
    Expect(0, 69465, '\p{^Is_Script_Extensions=-	Sogdian}', "");
    Expect(0, 69465, '\P{Is_Script_Extensions=-	Sogdian}', "");
    Expect(1, 69465, '\P{^Is_Script_Extensions=-	Sogdian}', "");
    Expect(0, 69466, '\p{Is_Script_Extensions=-	Sogdian}', "");
    Expect(1, 69466, '\p{^Is_Script_Extensions=-	Sogdian}', "");
    Expect(1, 69466, '\P{Is_Script_Extensions=-	Sogdian}', "");
    Expect(0, 69466, '\P{^Is_Script_Extensions=-	Sogdian}', "");
    Error('\p{Is_Scx=_:=SOGD}');
    Error('\P{Is_Scx=_:=SOGD}');
    Expect(1, 69465, '\p{Is_Scx=sogd}', "");
    Expect(0, 69465, '\p{^Is_Scx=sogd}', "");
    Expect(0, 69465, '\P{Is_Scx=sogd}', "");
    Expect(1, 69465, '\P{^Is_Scx=sogd}', "");
    Expect(0, 69466, '\p{Is_Scx=sogd}', "");
    Expect(1, 69466, '\p{^Is_Scx=sogd}', "");
    Expect(1, 69466, '\P{Is_Scx=sogd}', "");
    Expect(0, 69466, '\P{^Is_Scx=sogd}', "");
    Expect(1, 69465, '\p{Is_Scx= Sogd}', "");
    Expect(0, 69465, '\p{^Is_Scx= Sogd}', "");
    Expect(0, 69465, '\P{Is_Scx= Sogd}', "");
    Expect(1, 69465, '\P{^Is_Scx= Sogd}', "");
    Expect(0, 69466, '\p{Is_Scx= Sogd}', "");
    Expect(1, 69466, '\p{^Is_Scx= Sogd}', "");
    Expect(1, 69466, '\P{Is_Scx= Sogd}', "");
    Expect(0, 69466, '\P{^Is_Scx= Sogd}', "");
    Error('\p{Script_Extensions=- OLD_sogdian/a/}');
    Error('\P{Script_Extensions=- OLD_sogdian/a/}');
    Expect(1, 69415, '\p{Script_Extensions=:\AOld_Sogdian\z:}', "");;
    Expect(0, 69416, '\p{Script_Extensions=:\AOld_Sogdian\z:}', "");;
    Expect(1, 69415, '\p{Script_Extensions=oldsogdian}', "");
    Expect(0, 69415, '\p{^Script_Extensions=oldsogdian}', "");
    Expect(0, 69415, '\P{Script_Extensions=oldsogdian}', "");
    Expect(1, 69415, '\P{^Script_Extensions=oldsogdian}', "");
    Expect(0, 69416, '\p{Script_Extensions=oldsogdian}', "");
    Expect(1, 69416, '\p{^Script_Extensions=oldsogdian}', "");
    Expect(1, 69416, '\P{Script_Extensions=oldsogdian}', "");
    Expect(0, 69416, '\P{^Script_Extensions=oldsogdian}', "");
    Expect(1, 69415, '\p{Script_Extensions=:\Aoldsogdian\z:}', "");;
    Expect(0, 69416, '\p{Script_Extensions=:\Aoldsogdian\z:}', "");;
    Expect(1, 69415, '\p{Script_Extensions=--Old_Sogdian}', "");
    Expect(0, 69415, '\p{^Script_Extensions=--Old_Sogdian}', "");
    Expect(0, 69415, '\P{Script_Extensions=--Old_Sogdian}', "");
    Expect(1, 69415, '\P{^Script_Extensions=--Old_Sogdian}', "");
    Expect(0, 69416, '\p{Script_Extensions=--Old_Sogdian}', "");
    Expect(1, 69416, '\p{^Script_Extensions=--Old_Sogdian}', "");
    Expect(1, 69416, '\P{Script_Extensions=--Old_Sogdian}', "");
    Expect(0, 69416, '\P{^Script_Extensions=--Old_Sogdian}', "");
    Error('\p{Scx:   -_Sogo/a/}');
    Error('\P{Scx:   -_Sogo/a/}');
    Expect(1, 69415, '\p{Scx=:\ASogo\z:}', "");;
    Expect(0, 69416, '\p{Scx=:\ASogo\z:}', "");;
    Expect(1, 69415, '\p{Scx=sogo}', "");
    Expect(0, 69415, '\p{^Scx=sogo}', "");
    Expect(0, 69415, '\P{Scx=sogo}', "");
    Expect(1, 69415, '\P{^Scx=sogo}', "");
    Expect(0, 69416, '\p{Scx=sogo}', "");
    Expect(1, 69416, '\p{^Scx=sogo}', "");
    Expect(1, 69416, '\P{Scx=sogo}', "");
    Expect(0, 69416, '\P{^Scx=sogo}', "");
    Expect(1, 69415, '\p{Scx=:\Asogo\z:}', "");;
    Expect(0, 69416, '\p{Scx=:\Asogo\z:}', "");;
    Expect(1, 69415, '\p{Scx=		Sogo}', "");
    Expect(0, 69415, '\p{^Scx=		Sogo}', "");
    Expect(0, 69415, '\P{Scx=		Sogo}', "");
    Expect(1, 69415, '\P{^Scx=		Sogo}', "");
    Expect(0, 69416, '\p{Scx=		Sogo}', "");
    Expect(1, 69416, '\p{^Scx=		Sogo}', "");
    Expect(1, 69416, '\P{Scx=		Sogo}', "");
    Expect(0, 69416, '\P{^Scx=		Sogo}', "");
    Error('\p{Is_Script_Extensions=:=-_Old_Sogdian}');
    Error('\P{Is_Script_Extensions=:=-_Old_Sogdian}');
    Expect(1, 69415, '\p{Is_Script_Extensions=oldsogdian}', "");
    Expect(0, 69415, '\p{^Is_Script_Extensions=oldsogdian}', "");
    Expect(0, 69415, '\P{Is_Script_Extensions=oldsogdian}', "");
    Expect(1, 69415, '\P{^Is_Script_Extensions=oldsogdian}', "");
    Expect(0, 69416, '\p{Is_Script_Extensions=oldsogdian}', "");
    Expect(1, 69416, '\p{^Is_Script_Extensions=oldsogdian}', "");
    Expect(1, 69416, '\P{Is_Script_Extensions=oldsogdian}', "");
    Expect(0, 69416, '\P{^Is_Script_Extensions=oldsogdian}', "");
    Expect(1, 69415, '\p{Is_Script_Extensions=		Old_SOGDIAN}', "");
    Expect(0, 69415, '\p{^Is_Script_Extensions=		Old_SOGDIAN}', "");
    Expect(0, 69415, '\P{Is_Script_Extensions=		Old_SOGDIAN}', "");
    Expect(1, 69415, '\P{^Is_Script_Extensions=		Old_SOGDIAN}', "");
    Expect(0, 69416, '\p{Is_Script_Extensions=		Old_SOGDIAN}', "");
    Expect(1, 69416, '\p{^Is_Script_Extensions=		Old_SOGDIAN}', "");
    Expect(1, 69416, '\P{Is_Script_Extensions=		Old_SOGDIAN}', "");
    Expect(0, 69416, '\P{^Is_Script_Extensions=		Old_SOGDIAN}', "");
    Error('\p{Is_Scx=/a/Sogo}');
    Error('\P{Is_Scx=/a/Sogo}');
    Expect(1, 69415, '\p{Is_Scx=sogo}', "");
    Expect(0, 69415, '\p{^Is_Scx=sogo}', "");
    Expect(0, 69415, '\P{Is_Scx=sogo}', "");
    Expect(1, 69415, '\P{^Is_Scx=sogo}', "");
    Expect(0, 69416, '\p{Is_Scx=sogo}', "");
    Expect(1, 69416, '\p{^Is_Scx=sogo}', "");
    Expect(1, 69416, '\P{Is_Scx=sogo}', "");
    Expect(0, 69416, '\P{^Is_Scx=sogo}', "");
    Expect(1, 69415, '\p{Is_Scx=-	sogo}', "");
    Expect(0, 69415, '\p{^Is_Scx=-	sogo}', "");
    Expect(0, 69415, '\P{Is_Scx=-	sogo}', "");
    Expect(1, 69415, '\P{^Is_Scx=-	sogo}', "");
    Expect(0, 69416, '\p{Is_Scx=-	sogo}', "");
    Expect(1, 69416, '\p{^Is_Scx=-	sogo}', "");
    Expect(1, 69416, '\P{Is_Scx=-	sogo}', "");
    Expect(0, 69416, '\P{^Is_Scx=-	sogo}', "");
    Error('\p{Script_Extensions=/a/		Sora_sompeng}');
    Error('\P{Script_Extensions=/a/		Sora_sompeng}');
    Expect(1, 69881, '\p{Script_Extensions=:\ASora_Sompeng\z:}', "");;
    Expect(0, 69882, '\p{Script_Extensions=:\ASora_Sompeng\z:}', "");;
    Expect(1, 69881, '\p{Script_Extensions=sorasompeng}', "");
    Expect(0, 69881, '\p{^Script_Extensions=sorasompeng}', "");
    Expect(0, 69881, '\P{Script_Extensions=sorasompeng}', "");
    Expect(1, 69881, '\P{^Script_Extensions=sorasompeng}', "");
    Expect(0, 69882, '\p{Script_Extensions=sorasompeng}', "");
    Expect(1, 69882, '\p{^Script_Extensions=sorasompeng}', "");
    Expect(1, 69882, '\P{Script_Extensions=sorasompeng}', "");
    Expect(0, 69882, '\P{^Script_Extensions=sorasompeng}', "");
    Expect(1, 69881, '\p{Script_Extensions=:\Asorasompeng\z:}', "");;
    Expect(0, 69882, '\p{Script_Extensions=:\Asorasompeng\z:}', "");;
    Expect(1, 69881, '\p{Script_Extensions=-	Sora_SOMPENG}', "");
    Expect(0, 69881, '\p{^Script_Extensions=-	Sora_SOMPENG}', "");
    Expect(0, 69881, '\P{Script_Extensions=-	Sora_SOMPENG}', "");
    Expect(1, 69881, '\P{^Script_Extensions=-	Sora_SOMPENG}', "");
    Expect(0, 69882, '\p{Script_Extensions=-	Sora_SOMPENG}', "");
    Expect(1, 69882, '\p{^Script_Extensions=-	Sora_SOMPENG}', "");
    Expect(1, 69882, '\P{Script_Extensions=-	Sora_SOMPENG}', "");
    Expect(0, 69882, '\P{^Script_Extensions=-	Sora_SOMPENG}', "");
    Error('\p{Scx=	Sora:=}');
    Error('\P{Scx=	Sora:=}');
    Expect(1, 69881, '\p{Scx=:\ASora\z:}', "");;
    Expect(0, 69882, '\p{Scx=:\ASora\z:}', "");;
    Expect(1, 69881, '\p{Scx=sora}', "");
    Expect(0, 69881, '\p{^Scx=sora}', "");
    Expect(0, 69881, '\P{Scx=sora}', "");
    Expect(1, 69881, '\P{^Scx=sora}', "");
    Expect(0, 69882, '\p{Scx=sora}', "");
    Expect(1, 69882, '\p{^Scx=sora}', "");
    Expect(1, 69882, '\P{Scx=sora}', "");
    Expect(0, 69882, '\P{^Scx=sora}', "");
    Expect(1, 69881, '\p{Scx=:\Asora\z:}', "");;
    Expect(0, 69882, '\p{Scx=:\Asora\z:}', "");;
    Expect(1, 69881, '\p{Scx=_-sora}', "");
    Expect(0, 69881, '\p{^Scx=_-sora}', "");
    Expect(0, 69881, '\P{Scx=_-sora}', "");
    Expect(1, 69881, '\P{^Scx=_-sora}', "");
    Expect(0, 69882, '\p{Scx=_-sora}', "");
    Expect(1, 69882, '\p{^Scx=_-sora}', "");
    Expect(1, 69882, '\P{Scx=_-sora}', "");
    Expect(0, 69882, '\P{^Scx=_-sora}', "");
    Error('\p{Is_Script_Extensions=/a/__SORA_Sompeng}');
    Error('\P{Is_Script_Extensions=/a/__SORA_Sompeng}');
    Expect(1, 69881, '\p{Is_Script_Extensions=sorasompeng}', "");
    Expect(0, 69881, '\p{^Is_Script_Extensions=sorasompeng}', "");
    Expect(0, 69881, '\P{Is_Script_Extensions=sorasompeng}', "");
    Expect(1, 69881, '\P{^Is_Script_Extensions=sorasompeng}', "");
    Expect(0, 69882, '\p{Is_Script_Extensions=sorasompeng}', "");
    Expect(1, 69882, '\p{^Is_Script_Extensions=sorasompeng}', "");
    Expect(1, 69882, '\P{Is_Script_Extensions=sorasompeng}', "");
    Expect(0, 69882, '\P{^Is_Script_Extensions=sorasompeng}', "");
    Expect(1, 69881, '\p{Is_Script_Extensions=	Sora_Sompeng}', "");
    Expect(0, 69881, '\p{^Is_Script_Extensions=	Sora_Sompeng}', "");
    Expect(0, 69881, '\P{Is_Script_Extensions=	Sora_Sompeng}', "");
    Expect(1, 69881, '\P{^Is_Script_Extensions=	Sora_Sompeng}', "");
    Expect(0, 69882, '\p{Is_Script_Extensions=	Sora_Sompeng}', "");
    Expect(1, 69882, '\p{^Is_Script_Extensions=	Sora_Sompeng}', "");
    Expect(1, 69882, '\P{Is_Script_Extensions=	Sora_Sompeng}', "");
    Expect(0, 69882, '\P{^Is_Script_Extensions=	Sora_Sompeng}', "");
    Error('\p{Is_Scx=_ SORA:=}');
    Error('\P{Is_Scx=_ SORA:=}');
    Expect(1, 69881, '\p{Is_Scx=sora}', "");
    Expect(0, 69881, '\p{^Is_Scx=sora}', "");
    Expect(0, 69881, '\P{Is_Scx=sora}', "");
    Expect(1, 69881, '\P{^Is_Scx=sora}', "");
    Expect(0, 69882, '\p{Is_Scx=sora}', "");
    Expect(1, 69882, '\p{^Is_Scx=sora}', "");
    Expect(1, 69882, '\P{Is_Scx=sora}', "");
    Expect(0, 69882, '\P{^Is_Scx=sora}', "");
    Expect(1, 69881, '\p{Is_Scx: _sora}', "");
    Expect(0, 69881, '\p{^Is_Scx: _sora}', "");
    Expect(0, 69881, '\P{Is_Scx: _sora}', "");
    Expect(1, 69881, '\P{^Is_Scx: _sora}', "");
    Expect(0, 69882, '\p{Is_Scx: _sora}', "");
    Expect(1, 69882, '\p{^Is_Scx: _sora}', "");
    Expect(1, 69882, '\P{Is_Scx: _sora}', "");
    Expect(0, 69882, '\P{^Is_Scx: _sora}', "");
    Error('\p{Script_Extensions=_/a/SOYOMBO}');
    Error('\P{Script_Extensions=_/a/SOYOMBO}');
    Expect(1, 72354, '\p{Script_Extensions=:\ASoyombo\z:}', "");;
    Expect(0, 72355, '\p{Script_Extensions=:\ASoyombo\z:}', "");;
    Expect(1, 72354, '\p{Script_Extensions=soyombo}', "");
    Expect(0, 72354, '\p{^Script_Extensions=soyombo}', "");
    Expect(0, 72354, '\P{Script_Extensions=soyombo}', "");
    Expect(1, 72354, '\P{^Script_Extensions=soyombo}', "");
    Expect(0, 72355, '\p{Script_Extensions=soyombo}', "");
    Expect(1, 72355, '\p{^Script_Extensions=soyombo}', "");
    Expect(1, 72355, '\P{Script_Extensions=soyombo}', "");
    Expect(0, 72355, '\P{^Script_Extensions=soyombo}', "");
    Expect(1, 72354, '\p{Script_Extensions=:\Asoyombo\z:}', "");;
    Expect(0, 72355, '\p{Script_Extensions=:\Asoyombo\z:}', "");;
    Expect(1, 72354, '\p{Script_Extensions=_SOYOMBO}', "");
    Expect(0, 72354, '\p{^Script_Extensions=_SOYOMBO}', "");
    Expect(0, 72354, '\P{Script_Extensions=_SOYOMBO}', "");
    Expect(1, 72354, '\P{^Script_Extensions=_SOYOMBO}', "");
    Expect(0, 72355, '\p{Script_Extensions=_SOYOMBO}', "");
    Expect(1, 72355, '\p{^Script_Extensions=_SOYOMBO}', "");
    Expect(1, 72355, '\P{Script_Extensions=_SOYOMBO}', "");
    Expect(0, 72355, '\P{^Script_Extensions=_SOYOMBO}', "");
    Error('\p{Scx=_Soyo/a/}');
    Error('\P{Scx=_Soyo/a/}');
    Expect(1, 72354, '\p{Scx=:\ASoyo\z:}', "");;
    Expect(0, 72355, '\p{Scx=:\ASoyo\z:}', "");;
    Expect(1, 72354, '\p{Scx=soyo}', "");
    Expect(0, 72354, '\p{^Scx=soyo}', "");
    Expect(0, 72354, '\P{Scx=soyo}', "");
    Expect(1, 72354, '\P{^Scx=soyo}', "");
    Expect(0, 72355, '\p{Scx=soyo}', "");
    Expect(1, 72355, '\p{^Scx=soyo}', "");
    Expect(1, 72355, '\P{Scx=soyo}', "");
    Expect(0, 72355, '\P{^Scx=soyo}', "");
    Expect(1, 72354, '\p{Scx=:\Asoyo\z:}', "");;
    Expect(0, 72355, '\p{Scx=:\Asoyo\z:}', "");;
    Expect(1, 72354, '\p{Scx=	Soyo}', "");
    Expect(0, 72354, '\p{^Scx=	Soyo}', "");
    Expect(0, 72354, '\P{Scx=	Soyo}', "");
    Expect(1, 72354, '\P{^Scx=	Soyo}', "");
    Expect(0, 72355, '\p{Scx=	Soyo}', "");
    Expect(1, 72355, '\p{^Scx=	Soyo}', "");
    Expect(1, 72355, '\P{Scx=	Soyo}', "");
    Expect(0, 72355, '\P{^Scx=	Soyo}', "");
    Error('\p{Is_Script_Extensions=_	Soyombo:=}');
    Error('\P{Is_Script_Extensions=_	Soyombo:=}');
    Expect(1, 72354, '\p{Is_Script_Extensions=soyombo}', "");
    Expect(0, 72354, '\p{^Is_Script_Extensions=soyombo}', "");
    Expect(0, 72354, '\P{Is_Script_Extensions=soyombo}', "");
    Expect(1, 72354, '\P{^Is_Script_Extensions=soyombo}', "");
    Expect(0, 72355, '\p{Is_Script_Extensions=soyombo}', "");
    Expect(1, 72355, '\p{^Is_Script_Extensions=soyombo}', "");
    Expect(1, 72355, '\P{Is_Script_Extensions=soyombo}', "");
    Expect(0, 72355, '\P{^Is_Script_Extensions=soyombo}', "");
    Expect(1, 72354, '\p{Is_Script_Extensions=		SOYOMBO}', "");
    Expect(0, 72354, '\p{^Is_Script_Extensions=		SOYOMBO}', "");
    Expect(0, 72354, '\P{Is_Script_Extensions=		SOYOMBO}', "");
    Expect(1, 72354, '\P{^Is_Script_Extensions=		SOYOMBO}', "");
    Expect(0, 72355, '\p{Is_Script_Extensions=		SOYOMBO}', "");
    Expect(1, 72355, '\p{^Is_Script_Extensions=		SOYOMBO}', "");
    Expect(1, 72355, '\P{Is_Script_Extensions=		SOYOMBO}', "");
    Expect(0, 72355, '\P{^Is_Script_Extensions=		SOYOMBO}', "");
    Error('\p{Is_Scx=/a/	Soyo}');
    Error('\P{Is_Scx=/a/	Soyo}');
    Expect(1, 72354, '\p{Is_Scx=soyo}', "");
    Expect(0, 72354, '\p{^Is_Scx=soyo}', "");
    Expect(0, 72354, '\P{Is_Scx=soyo}', "");
    Expect(1, 72354, '\P{^Is_Scx=soyo}', "");
    Expect(0, 72355, '\p{Is_Scx=soyo}', "");
    Expect(1, 72355, '\p{^Is_Scx=soyo}', "");
    Expect(1, 72355, '\P{Is_Scx=soyo}', "");
    Expect(0, 72355, '\P{^Is_Scx=soyo}', "");
    Expect(1, 72354, '\p{Is_Scx=--SOYO}', "");
    Expect(0, 72354, '\p{^Is_Scx=--SOYO}', "");
    Expect(0, 72354, '\P{Is_Scx=--SOYO}', "");
    Expect(1, 72354, '\P{^Is_Scx=--SOYO}', "");
    Expect(0, 72355, '\p{Is_Scx=--SOYO}', "");
    Expect(1, 72355, '\p{^Is_Scx=--SOYO}', "");
    Expect(1, 72355, '\P{Is_Scx=--SOYO}', "");
    Expect(0, 72355, '\P{^Is_Scx=--SOYO}', "");
    Error('\p{Script_Extensions=/a/		sundanese}');
    Error('\P{Script_Extensions=/a/		sundanese}');
    Expect(1, 7367, '\p{Script_Extensions=:\ASundanese\z:}', "");;
    Expect(0, 7368, '\p{Script_Extensions=:\ASundanese\z:}', "");;
    Expect(1, 7367, '\p{Script_Extensions=sundanese}', "");
    Expect(0, 7367, '\p{^Script_Extensions=sundanese}', "");
    Expect(0, 7367, '\P{Script_Extensions=sundanese}', "");
    Expect(1, 7367, '\P{^Script_Extensions=sundanese}', "");
    Expect(0, 7368, '\p{Script_Extensions=sundanese}', "");
    Expect(1, 7368, '\p{^Script_Extensions=sundanese}', "");
    Expect(1, 7368, '\P{Script_Extensions=sundanese}', "");
    Expect(0, 7368, '\P{^Script_Extensions=sundanese}', "");
    Expect(1, 7367, '\p{Script_Extensions=:\Asundanese\z:}', "");;
    Expect(0, 7368, '\p{Script_Extensions=:\Asundanese\z:}', "");;
    Expect(1, 7367, '\p{Script_Extensions:   _SUNDANESE}', "");
    Expect(0, 7367, '\p{^Script_Extensions:   _SUNDANESE}', "");
    Expect(0, 7367, '\P{Script_Extensions:   _SUNDANESE}', "");
    Expect(1, 7367, '\P{^Script_Extensions:   _SUNDANESE}', "");
    Expect(0, 7368, '\p{Script_Extensions:   _SUNDANESE}', "");
    Expect(1, 7368, '\p{^Script_Extensions:   _SUNDANESE}', "");
    Expect(1, 7368, '\P{Script_Extensions:   _SUNDANESE}', "");
    Expect(0, 7368, '\P{^Script_Extensions:   _SUNDANESE}', "");
    Error('\p{Scx=/a/- sund}');
    Error('\P{Scx=/a/- sund}');
    Expect(1, 7367, '\p{Scx=:\ASund\z:}', "");;
    Expect(0, 7368, '\p{Scx=:\ASund\z:}', "");;
    Expect(1, 7367, '\p{Scx=sund}', "");
    Expect(0, 7367, '\p{^Scx=sund}', "");
    Expect(0, 7367, '\P{Scx=sund}', "");
    Expect(1, 7367, '\P{^Scx=sund}', "");
    Expect(0, 7368, '\p{Scx=sund}', "");
    Expect(1, 7368, '\p{^Scx=sund}', "");
    Expect(1, 7368, '\P{Scx=sund}', "");
    Expect(0, 7368, '\P{^Scx=sund}', "");
    Expect(1, 7367, '\p{Scx=:\Asund\z:}', "");;
    Expect(0, 7368, '\p{Scx=:\Asund\z:}', "");;
    Expect(1, 7367, '\p{Scx=--Sund}', "");
    Expect(0, 7367, '\p{^Scx=--Sund}', "");
    Expect(0, 7367, '\P{Scx=--Sund}', "");
    Expect(1, 7367, '\P{^Scx=--Sund}', "");
    Expect(0, 7368, '\p{Scx=--Sund}', "");
    Expect(1, 7368, '\p{^Scx=--Sund}', "");
    Expect(1, 7368, '\P{Scx=--Sund}', "");
    Expect(0, 7368, '\P{^Scx=--Sund}', "");
    Error('\p{Is_Script_Extensions= 	sundanese:=}');
    Error('\P{Is_Script_Extensions= 	sundanese:=}');
    Expect(1, 7367, '\p{Is_Script_Extensions=sundanese}', "");
    Expect(0, 7367, '\p{^Is_Script_Extensions=sundanese}', "");
    Expect(0, 7367, '\P{Is_Script_Extensions=sundanese}', "");
    Expect(1, 7367, '\P{^Is_Script_Extensions=sundanese}', "");
    Expect(0, 7368, '\p{Is_Script_Extensions=sundanese}', "");
    Expect(1, 7368, '\p{^Is_Script_Extensions=sundanese}', "");
    Expect(1, 7368, '\P{Is_Script_Extensions=sundanese}', "");
    Expect(0, 7368, '\P{^Is_Script_Extensions=sundanese}', "");
    Expect(1, 7367, '\p{Is_Script_Extensions=_Sundanese}', "");
    Expect(0, 7367, '\p{^Is_Script_Extensions=_Sundanese}', "");
    Expect(0, 7367, '\P{Is_Script_Extensions=_Sundanese}', "");
    Expect(1, 7367, '\P{^Is_Script_Extensions=_Sundanese}', "");
    Expect(0, 7368, '\p{Is_Script_Extensions=_Sundanese}', "");
    Expect(1, 7368, '\p{^Is_Script_Extensions=_Sundanese}', "");
    Expect(1, 7368, '\P{Is_Script_Extensions=_Sundanese}', "");
    Expect(0, 7368, '\P{^Is_Script_Extensions=_Sundanese}', "");
    Error('\p{Is_Scx=:= sund}');
    Error('\P{Is_Scx=:= sund}');
    Expect(1, 7367, '\p{Is_Scx:   sund}', "");
    Expect(0, 7367, '\p{^Is_Scx:   sund}', "");
    Expect(0, 7367, '\P{Is_Scx:   sund}', "");
    Expect(1, 7367, '\P{^Is_Scx:   sund}', "");
    Expect(0, 7368, '\p{Is_Scx:   sund}', "");
    Expect(1, 7368, '\p{^Is_Scx:   sund}', "");
    Expect(1, 7368, '\P{Is_Scx:   sund}', "");
    Expect(0, 7368, '\P{^Is_Scx:   sund}', "");
    Expect(1, 7367, '\p{Is_Scx=-_Sund}', "");
    Expect(0, 7367, '\p{^Is_Scx=-_Sund}', "");
    Expect(0, 7367, '\P{Is_Scx=-_Sund}', "");
    Expect(1, 7367, '\P{^Is_Scx=-_Sund}', "");
    Expect(0, 7368, '\p{Is_Scx=-_Sund}', "");
    Expect(1, 7368, '\p{^Is_Scx=-_Sund}', "");
    Expect(1, 7368, '\P{Is_Scx=-_Sund}', "");
    Expect(0, 7368, '\P{^Is_Scx=-_Sund}', "");
    Error('\p{Script_Extensions=_	Syloti_nagri/a/}');
    Error('\P{Script_Extensions=_	Syloti_nagri/a/}');
    Expect(1, 43052, '\p{Script_Extensions=:\ASyloti_Nagri\z:}', "");;
    Expect(0, 43053, '\p{Script_Extensions=:\ASyloti_Nagri\z:}', "");;
    Expect(1, 43052, '\p{Script_Extensions=sylotinagri}', "");
    Expect(0, 43052, '\p{^Script_Extensions=sylotinagri}', "");
    Expect(0, 43052, '\P{Script_Extensions=sylotinagri}', "");
    Expect(1, 43052, '\P{^Script_Extensions=sylotinagri}', "");
    Expect(0, 43053, '\p{Script_Extensions=sylotinagri}', "");
    Expect(1, 43053, '\p{^Script_Extensions=sylotinagri}', "");
    Expect(1, 43053, '\P{Script_Extensions=sylotinagri}', "");
    Expect(0, 43053, '\P{^Script_Extensions=sylotinagri}', "");
    Expect(1, 43052, '\p{Script_Extensions=:\Asylotinagri\z:}', "");;
    Expect(0, 43053, '\p{Script_Extensions=:\Asylotinagri\z:}', "");;
    Expect(1, 43052, '\p{Script_Extensions:	Syloti_Nagri}', "");
    Expect(0, 43052, '\p{^Script_Extensions:	Syloti_Nagri}', "");
    Expect(0, 43052, '\P{Script_Extensions:	Syloti_Nagri}', "");
    Expect(1, 43052, '\P{^Script_Extensions:	Syloti_Nagri}', "");
    Expect(0, 43053, '\p{Script_Extensions:	Syloti_Nagri}', "");
    Expect(1, 43053, '\p{^Script_Extensions:	Syloti_Nagri}', "");
    Expect(1, 43053, '\P{Script_Extensions:	Syloti_Nagri}', "");
    Expect(0, 43053, '\P{^Script_Extensions:	Syloti_Nagri}', "");
    Error('\p{Scx= :=sylo}');
    Error('\P{Scx= :=sylo}');
    Expect(1, 43052, '\p{Scx=:\ASylo\z:}', "");;
    Expect(0, 43053, '\p{Scx=:\ASylo\z:}', "");;
    Expect(1, 43052, '\p{Scx=sylo}', "");
    Expect(0, 43052, '\p{^Scx=sylo}', "");
    Expect(0, 43052, '\P{Scx=sylo}', "");
    Expect(1, 43052, '\P{^Scx=sylo}', "");
    Expect(0, 43053, '\p{Scx=sylo}', "");
    Expect(1, 43053, '\p{^Scx=sylo}', "");
    Expect(1, 43053, '\P{Scx=sylo}', "");
    Expect(0, 43053, '\P{^Scx=sylo}', "");
    Expect(1, 43052, '\p{Scx=:\Asylo\z:}', "");;
    Expect(0, 43053, '\p{Scx=:\Asylo\z:}', "");;
    Expect(1, 43052, '\p{Scx=_	Sylo}', "");
    Expect(0, 43052, '\p{^Scx=_	Sylo}', "");
    Expect(0, 43052, '\P{Scx=_	Sylo}', "");
    Expect(1, 43052, '\P{^Scx=_	Sylo}', "");
    Expect(0, 43053, '\p{Scx=_	Sylo}', "");
    Expect(1, 43053, '\p{^Scx=_	Sylo}', "");
    Expect(1, 43053, '\P{Scx=_	Sylo}', "");
    Expect(0, 43053, '\P{^Scx=_	Sylo}', "");
    Error('\p{Is_Script_Extensions=	-SYLOTI_nagri:=}');
    Error('\P{Is_Script_Extensions=	-SYLOTI_nagri:=}');
    Expect(1, 43052, '\p{Is_Script_Extensions=sylotinagri}', "");
    Expect(0, 43052, '\p{^Is_Script_Extensions=sylotinagri}', "");
    Expect(0, 43052, '\P{Is_Script_Extensions=sylotinagri}', "");
    Expect(1, 43052, '\P{^Is_Script_Extensions=sylotinagri}', "");
    Expect(0, 43053, '\p{Is_Script_Extensions=sylotinagri}', "");
    Expect(1, 43053, '\p{^Is_Script_Extensions=sylotinagri}', "");
    Expect(1, 43053, '\P{Is_Script_Extensions=sylotinagri}', "");
    Expect(0, 43053, '\P{^Is_Script_Extensions=sylotinagri}', "");
    Expect(1, 43052, '\p{Is_Script_Extensions=-	Syloti_NAGRI}', "");
    Expect(0, 43052, '\p{^Is_Script_Extensions=-	Syloti_NAGRI}', "");
    Expect(0, 43052, '\P{Is_Script_Extensions=-	Syloti_NAGRI}', "");
    Expect(1, 43052, '\P{^Is_Script_Extensions=-	Syloti_NAGRI}', "");
    Expect(0, 43053, '\p{Is_Script_Extensions=-	Syloti_NAGRI}', "");
    Expect(1, 43053, '\p{^Is_Script_Extensions=-	Syloti_NAGRI}', "");
    Expect(1, 43053, '\P{Is_Script_Extensions=-	Syloti_NAGRI}', "");
    Expect(0, 43053, '\P{^Is_Script_Extensions=-	Syloti_NAGRI}', "");
    Error('\p{Is_Scx=-/a/Sylo}');
    Error('\P{Is_Scx=-/a/Sylo}');
    Expect(1, 43052, '\p{Is_Scx=sylo}', "");
    Expect(0, 43052, '\p{^Is_Scx=sylo}', "");
    Expect(0, 43052, '\P{Is_Scx=sylo}', "");
    Expect(1, 43052, '\P{^Is_Scx=sylo}', "");
    Expect(0, 43053, '\p{Is_Scx=sylo}', "");
    Expect(1, 43053, '\p{^Is_Scx=sylo}', "");
    Expect(1, 43053, '\P{Is_Scx=sylo}', "");
    Expect(0, 43053, '\P{^Is_Scx=sylo}', "");
    Expect(1, 43052, '\p{Is_Scx=-SYLO}', "");
    Expect(0, 43052, '\p{^Is_Scx=-SYLO}', "");
    Expect(0, 43052, '\P{Is_Scx=-SYLO}', "");
    Expect(1, 43052, '\P{^Is_Scx=-SYLO}', "");
    Expect(0, 43053, '\p{Is_Scx=-SYLO}', "");
    Expect(1, 43053, '\p{^Is_Scx=-SYLO}', "");
    Expect(1, 43053, '\P{Is_Scx=-SYLO}', "");
    Expect(0, 43053, '\P{^Is_Scx=-SYLO}', "");
    Error('\p{Script_Extensions=	-SYRIAC/a/}');
    Error('\P{Script_Extensions=	-SYRIAC/a/}');
    Expect(1, 7672, '\p{Script_Extensions=:\ASyriac\z:}', "");;
    Expect(0, 7673, '\p{Script_Extensions=:\ASyriac\z:}', "");;
    Expect(1, 7672, '\p{Script_Extensions=syriac}', "");
    Expect(0, 7672, '\p{^Script_Extensions=syriac}', "");
    Expect(0, 7672, '\P{Script_Extensions=syriac}', "");
    Expect(1, 7672, '\P{^Script_Extensions=syriac}', "");
    Expect(0, 7673, '\p{Script_Extensions=syriac}', "");
    Expect(1, 7673, '\p{^Script_Extensions=syriac}', "");
    Expect(1, 7673, '\P{Script_Extensions=syriac}', "");
    Expect(0, 7673, '\P{^Script_Extensions=syriac}', "");
    Expect(1, 7672, '\p{Script_Extensions=:\Asyriac\z:}', "");;
    Expect(0, 7673, '\p{Script_Extensions=:\Asyriac\z:}', "");;
    Expect(1, 7672, '\p{Script_Extensions:- Syriac}', "");
    Expect(0, 7672, '\p{^Script_Extensions:- Syriac}', "");
    Expect(0, 7672, '\P{Script_Extensions:- Syriac}', "");
    Expect(1, 7672, '\P{^Script_Extensions:- Syriac}', "");
    Expect(0, 7673, '\p{Script_Extensions:- Syriac}', "");
    Expect(1, 7673, '\p{^Script_Extensions:- Syriac}', "");
    Expect(1, 7673, '\P{Script_Extensions:- Syriac}', "");
    Expect(0, 7673, '\P{^Script_Extensions:- Syriac}', "");
    Error('\p{Scx=_	syrc/a/}');
    Error('\P{Scx=_	syrc/a/}');
    Expect(1, 7672, '\p{Scx=:\ASyrc\z:}', "");;
    Expect(0, 7673, '\p{Scx=:\ASyrc\z:}', "");;
    Expect(1, 7672, '\p{Scx=syrc}', "");
    Expect(0, 7672, '\p{^Scx=syrc}', "");
    Expect(0, 7672, '\P{Scx=syrc}', "");
    Expect(1, 7672, '\P{^Scx=syrc}', "");
    Expect(0, 7673, '\p{Scx=syrc}', "");
    Expect(1, 7673, '\p{^Scx=syrc}', "");
    Expect(1, 7673, '\P{Scx=syrc}', "");
    Expect(0, 7673, '\P{^Scx=syrc}', "");
    Expect(1, 7672, '\p{Scx=:\Asyrc\z:}', "");;
    Expect(0, 7673, '\p{Scx=:\Asyrc\z:}', "");;
    Expect(1, 7672, '\p{Scx=--Syrc}', "");
    Expect(0, 7672, '\p{^Scx=--Syrc}', "");
    Expect(0, 7672, '\P{Scx=--Syrc}', "");
    Expect(1, 7672, '\P{^Scx=--Syrc}', "");
    Expect(0, 7673, '\p{Scx=--Syrc}', "");
    Expect(1, 7673, '\p{^Scx=--Syrc}', "");
    Expect(1, 7673, '\P{Scx=--Syrc}', "");
    Expect(0, 7673, '\P{^Scx=--Syrc}', "");
    Error('\p{Is_Script_Extensions=	/a/syriac}');
    Error('\P{Is_Script_Extensions=	/a/syriac}');
    Expect(1, 7672, '\p{Is_Script_Extensions=syriac}', "");
    Expect(0, 7672, '\p{^Is_Script_Extensions=syriac}', "");
    Expect(0, 7672, '\P{Is_Script_Extensions=syriac}', "");
    Expect(1, 7672, '\P{^Is_Script_Extensions=syriac}', "");
    Expect(0, 7673, '\p{Is_Script_Extensions=syriac}', "");
    Expect(1, 7673, '\p{^Is_Script_Extensions=syriac}', "");
    Expect(1, 7673, '\P{Is_Script_Extensions=syriac}', "");
    Expect(0, 7673, '\P{^Is_Script_Extensions=syriac}', "");
    Expect(1, 7672, '\p{Is_Script_Extensions=--Syriac}', "");
    Expect(0, 7672, '\p{^Is_Script_Extensions=--Syriac}', "");
    Expect(0, 7672, '\P{Is_Script_Extensions=--Syriac}', "");
    Expect(1, 7672, '\P{^Is_Script_Extensions=--Syriac}', "");
    Expect(0, 7673, '\p{Is_Script_Extensions=--Syriac}', "");
    Expect(1, 7673, '\p{^Is_Script_Extensions=--Syriac}', "");
    Expect(1, 7673, '\P{Is_Script_Extensions=--Syriac}', "");
    Expect(0, 7673, '\P{^Is_Script_Extensions=--Syriac}', "");
    Error('\p{Is_Scx=:= Syrc}');
    Error('\P{Is_Scx=:= Syrc}');
    Expect(1, 7672, '\p{Is_Scx=syrc}', "");
    Expect(0, 7672, '\p{^Is_Scx=syrc}', "");
    Expect(0, 7672, '\P{Is_Scx=syrc}', "");
    Expect(1, 7672, '\P{^Is_Scx=syrc}', "");
    Expect(0, 7673, '\p{Is_Scx=syrc}', "");
    Expect(1, 7673, '\p{^Is_Scx=syrc}', "");
    Expect(1, 7673, '\P{Is_Scx=syrc}', "");
    Expect(0, 7673, '\P{^Is_Scx=syrc}', "");
    Expect(1, 7672, '\p{Is_Scx= _Syrc}', "");
    Expect(0, 7672, '\p{^Is_Scx= _Syrc}', "");
    Expect(0, 7672, '\P{Is_Scx= _Syrc}', "");
    Expect(1, 7672, '\P{^Is_Scx= _Syrc}', "");
    Expect(0, 7673, '\p{Is_Scx= _Syrc}', "");
    Expect(1, 7673, '\p{^Is_Scx= _Syrc}', "");
    Expect(1, 7673, '\P{Is_Scx= _Syrc}', "");
    Expect(0, 7673, '\P{^Is_Scx= _Syrc}', "");
    Error('\p{Script_Extensions=	:=Tagbanwa}');
    Error('\P{Script_Extensions=	:=Tagbanwa}');
    Expect(1, 6003, '\p{Script_Extensions=:\ATagbanwa\z:}', "");;
    Expect(0, 6004, '\p{Script_Extensions=:\ATagbanwa\z:}', "");;
    Expect(1, 6003, '\p{Script_Extensions=tagbanwa}', "");
    Expect(0, 6003, '\p{^Script_Extensions=tagbanwa}', "");
    Expect(0, 6003, '\P{Script_Extensions=tagbanwa}', "");
    Expect(1, 6003, '\P{^Script_Extensions=tagbanwa}', "");
    Expect(0, 6004, '\p{Script_Extensions=tagbanwa}', "");
    Expect(1, 6004, '\p{^Script_Extensions=tagbanwa}', "");
    Expect(1, 6004, '\P{Script_Extensions=tagbanwa}', "");
    Expect(0, 6004, '\P{^Script_Extensions=tagbanwa}', "");
    Expect(1, 6003, '\p{Script_Extensions=:\Atagbanwa\z:}', "");;
    Expect(0, 6004, '\p{Script_Extensions=:\Atagbanwa\z:}', "");;
    Expect(1, 6003, '\p{Script_Extensions= _TAGBANWA}', "");
    Expect(0, 6003, '\p{^Script_Extensions= _TAGBANWA}', "");
    Expect(0, 6003, '\P{Script_Extensions= _TAGBANWA}', "");
    Expect(1, 6003, '\P{^Script_Extensions= _TAGBANWA}', "");
    Expect(0, 6004, '\p{Script_Extensions= _TAGBANWA}', "");
    Expect(1, 6004, '\p{^Script_Extensions= _TAGBANWA}', "");
    Expect(1, 6004, '\P{Script_Extensions= _TAGBANWA}', "");
    Expect(0, 6004, '\P{^Script_Extensions= _TAGBANWA}', "");
    Error('\p{Scx:    :=TAGB}');
    Error('\P{Scx:    :=TAGB}');
    Expect(1, 6003, '\p{Scx=:\ATagb\z:}', "");;
    Expect(0, 6004, '\p{Scx=:\ATagb\z:}', "");;
    Expect(1, 6003, '\p{Scx=tagb}', "");
    Expect(0, 6003, '\p{^Scx=tagb}', "");
    Expect(0, 6003, '\P{Scx=tagb}', "");
    Expect(1, 6003, '\P{^Scx=tagb}', "");
    Expect(0, 6004, '\p{Scx=tagb}', "");
    Expect(1, 6004, '\p{^Scx=tagb}', "");
    Expect(1, 6004, '\P{Scx=tagb}', "");
    Expect(0, 6004, '\P{^Scx=tagb}', "");
    Expect(1, 6003, '\p{Scx=:\Atagb\z:}', "");;
    Expect(0, 6004, '\p{Scx=:\Atagb\z:}', "");;
    Expect(1, 6003, '\p{Scx=	TAGB}', "");
    Expect(0, 6003, '\p{^Scx=	TAGB}', "");
    Expect(0, 6003, '\P{Scx=	TAGB}', "");
    Expect(1, 6003, '\P{^Scx=	TAGB}', "");
    Expect(0, 6004, '\p{Scx=	TAGB}', "");
    Expect(1, 6004, '\p{^Scx=	TAGB}', "");
    Expect(1, 6004, '\P{Scx=	TAGB}', "");
    Expect(0, 6004, '\P{^Scx=	TAGB}', "");
    Error('\p{Is_Script_Extensions=-tagbanwa:=}');
    Error('\P{Is_Script_Extensions=-tagbanwa:=}');
    Expect(1, 6003, '\p{Is_Script_Extensions=tagbanwa}', "");
    Expect(0, 6003, '\p{^Is_Script_Extensions=tagbanwa}', "");
    Expect(0, 6003, '\P{Is_Script_Extensions=tagbanwa}', "");
    Expect(1, 6003, '\P{^Is_Script_Extensions=tagbanwa}', "");
    Expect(0, 6004, '\p{Is_Script_Extensions=tagbanwa}', "");
    Expect(1, 6004, '\p{^Is_Script_Extensions=tagbanwa}', "");
    Expect(1, 6004, '\P{Is_Script_Extensions=tagbanwa}', "");
    Expect(0, 6004, '\P{^Is_Script_Extensions=tagbanwa}', "");
    Expect(1, 6003, '\p{Is_Script_Extensions= -Tagbanwa}', "");
    Expect(0, 6003, '\p{^Is_Script_Extensions= -Tagbanwa}', "");
    Expect(0, 6003, '\P{Is_Script_Extensions= -Tagbanwa}', "");
    Expect(1, 6003, '\P{^Is_Script_Extensions= -Tagbanwa}', "");
    Expect(0, 6004, '\p{Is_Script_Extensions= -Tagbanwa}', "");
    Expect(1, 6004, '\p{^Is_Script_Extensions= -Tagbanwa}', "");
    Expect(1, 6004, '\P{Is_Script_Extensions= -Tagbanwa}', "");
    Expect(0, 6004, '\P{^Is_Script_Extensions= -Tagbanwa}', "");
    Error('\p{Is_Scx=-TAGB:=}');
    Error('\P{Is_Scx=-TAGB:=}');
    Expect(1, 6003, '\p{Is_Scx=tagb}', "");
    Expect(0, 6003, '\p{^Is_Scx=tagb}', "");
    Expect(0, 6003, '\P{Is_Scx=tagb}', "");
    Expect(1, 6003, '\P{^Is_Scx=tagb}', "");
    Expect(0, 6004, '\p{Is_Scx=tagb}', "");
    Expect(1, 6004, '\p{^Is_Scx=tagb}', "");
    Expect(1, 6004, '\P{Is_Scx=tagb}', "");
    Expect(0, 6004, '\P{^Is_Scx=tagb}', "");
    Expect(1, 6003, '\p{Is_Scx=	_tagb}', "");
    Expect(0, 6003, '\p{^Is_Scx=	_tagb}', "");
    Expect(0, 6003, '\P{Is_Scx=	_tagb}', "");
    Expect(1, 6003, '\P{^Is_Scx=	_tagb}', "");
    Expect(0, 6004, '\p{Is_Scx=	_tagb}', "");
    Expect(1, 6004, '\p{^Is_Scx=	_tagb}', "");
    Expect(1, 6004, '\P{Is_Scx=	_tagb}', "");
    Expect(0, 6004, '\P{^Is_Scx=	_tagb}', "");
    Error('\p{Script_Extensions:_-TAKRI:=}');
    Error('\P{Script_Extensions:_-TAKRI:=}');
    Expect(1, 71369, '\p{Script_Extensions=:\ATakri\z:}', "");;
    Expect(0, 71370, '\p{Script_Extensions=:\ATakri\z:}', "");;
    Expect(1, 71369, '\p{Script_Extensions=takri}', "");
    Expect(0, 71369, '\p{^Script_Extensions=takri}', "");
    Expect(0, 71369, '\P{Script_Extensions=takri}', "");
    Expect(1, 71369, '\P{^Script_Extensions=takri}', "");
    Expect(0, 71370, '\p{Script_Extensions=takri}', "");
    Expect(1, 71370, '\p{^Script_Extensions=takri}', "");
    Expect(1, 71370, '\P{Script_Extensions=takri}', "");
    Expect(0, 71370, '\P{^Script_Extensions=takri}', "");
    Expect(1, 71369, '\p{Script_Extensions=:\Atakri\z:}', "");;
    Expect(0, 71370, '\p{Script_Extensions=:\Atakri\z:}', "");;
    Expect(1, 71369, '\p{Script_Extensions=		takri}', "");
    Expect(0, 71369, '\p{^Script_Extensions=		takri}', "");
    Expect(0, 71369, '\P{Script_Extensions=		takri}', "");
    Expect(1, 71369, '\P{^Script_Extensions=		takri}', "");
    Expect(0, 71370, '\p{Script_Extensions=		takri}', "");
    Expect(1, 71370, '\p{^Script_Extensions=		takri}', "");
    Expect(1, 71370, '\P{Script_Extensions=		takri}', "");
    Expect(0, 71370, '\P{^Script_Extensions=		takri}', "");
    Error('\p{Scx=__Takr:=}');
    Error('\P{Scx=__Takr:=}');
    Expect(1, 71369, '\p{Scx=:\ATakr\z:}', "");;
    Expect(0, 71370, '\p{Scx=:\ATakr\z:}', "");;
    Expect(1, 71369, '\p{Scx=takr}', "");
    Expect(0, 71369, '\p{^Scx=takr}', "");
    Expect(0, 71369, '\P{Scx=takr}', "");
    Expect(1, 71369, '\P{^Scx=takr}', "");
    Expect(0, 71370, '\p{Scx=takr}', "");
    Expect(1, 71370, '\p{^Scx=takr}', "");
    Expect(1, 71370, '\P{Scx=takr}', "");
    Expect(0, 71370, '\P{^Scx=takr}', "");
    Expect(1, 71369, '\p{Scx=:\Atakr\z:}', "");;
    Expect(0, 71370, '\p{Scx=:\Atakr\z:}', "");;
    Expect(1, 71369, '\p{Scx=  Takr}', "");
    Expect(0, 71369, '\p{^Scx=  Takr}', "");
    Expect(0, 71369, '\P{Scx=  Takr}', "");
    Expect(1, 71369, '\P{^Scx=  Takr}', "");
    Expect(0, 71370, '\p{Scx=  Takr}', "");
    Expect(1, 71370, '\p{^Scx=  Takr}', "");
    Expect(1, 71370, '\P{Scx=  Takr}', "");
    Expect(0, 71370, '\P{^Scx=  Takr}', "");
    Error('\p{Is_Script_Extensions=-_takri/a/}');
    Error('\P{Is_Script_Extensions=-_takri/a/}');
    Expect(1, 71369, '\p{Is_Script_Extensions=takri}', "");
    Expect(0, 71369, '\p{^Is_Script_Extensions=takri}', "");
    Expect(0, 71369, '\P{Is_Script_Extensions=takri}', "");
    Expect(1, 71369, '\P{^Is_Script_Extensions=takri}', "");
    Expect(0, 71370, '\p{Is_Script_Extensions=takri}', "");
    Expect(1, 71370, '\p{^Is_Script_Extensions=takri}', "");
    Expect(1, 71370, '\P{Is_Script_Extensions=takri}', "");
    Expect(0, 71370, '\P{^Is_Script_Extensions=takri}', "");
    Expect(1, 71369, '\p{Is_Script_Extensions=	-Takri}', "");
    Expect(0, 71369, '\p{^Is_Script_Extensions=	-Takri}', "");
    Expect(0, 71369, '\P{Is_Script_Extensions=	-Takri}', "");
    Expect(1, 71369, '\P{^Is_Script_Extensions=	-Takri}', "");
    Expect(0, 71370, '\p{Is_Script_Extensions=	-Takri}', "");
    Expect(1, 71370, '\p{^Is_Script_Extensions=	-Takri}', "");
    Expect(1, 71370, '\P{Is_Script_Extensions=	-Takri}', "");
    Expect(0, 71370, '\P{^Is_Script_Extensions=	-Takri}', "");
    Error('\p{Is_Scx=/a/takr}');
    Error('\P{Is_Scx=/a/takr}');
    Expect(1, 71369, '\p{Is_Scx=takr}', "");
    Expect(0, 71369, '\p{^Is_Scx=takr}', "");
    Expect(0, 71369, '\P{Is_Scx=takr}', "");
    Expect(1, 71369, '\P{^Is_Scx=takr}', "");
    Expect(0, 71370, '\p{Is_Scx=takr}', "");
    Expect(1, 71370, '\p{^Is_Scx=takr}', "");
    Expect(1, 71370, '\P{Is_Scx=takr}', "");
    Expect(0, 71370, '\P{^Is_Scx=takr}', "");
    Expect(1, 71369, '\p{Is_Scx= -Takr}', "");
    Expect(0, 71369, '\p{^Is_Scx= -Takr}', "");
    Expect(0, 71369, '\P{Is_Scx= -Takr}', "");
    Expect(1, 71369, '\P{^Is_Scx= -Takr}', "");
    Expect(0, 71370, '\p{Is_Scx= -Takr}', "");
    Expect(1, 71370, '\p{^Is_Scx= -Takr}', "");
    Expect(1, 71370, '\P{Is_Scx= -Takr}', "");
    Expect(0, 71370, '\P{^Is_Scx= -Takr}', "");
    Error('\p{Script_Extensions=:= Tai_Le}');
    Error('\P{Script_Extensions=:= Tai_Le}');
    Expect(1, 6516, '\p{Script_Extensions=:\ATai_Le\z:}', "");;
    Expect(0, 6517, '\p{Script_Extensions=:\ATai_Le\z:}', "");;
    Expect(1, 6516, '\p{Script_Extensions=taile}', "");
    Expect(0, 6516, '\p{^Script_Extensions=taile}', "");
    Expect(0, 6516, '\P{Script_Extensions=taile}', "");
    Expect(1, 6516, '\P{^Script_Extensions=taile}', "");
    Expect(0, 6517, '\p{Script_Extensions=taile}', "");
    Expect(1, 6517, '\p{^Script_Extensions=taile}', "");
    Expect(1, 6517, '\P{Script_Extensions=taile}', "");
    Expect(0, 6517, '\P{^Script_Extensions=taile}', "");
    Expect(1, 6516, '\p{Script_Extensions=:\Ataile\z:}', "");;
    Expect(0, 6517, '\p{Script_Extensions=:\Ataile\z:}', "");;
    Expect(1, 6516, '\p{Script_Extensions=	tai_Le}', "");
    Expect(0, 6516, '\p{^Script_Extensions=	tai_Le}', "");
    Expect(0, 6516, '\P{Script_Extensions=	tai_Le}', "");
    Expect(1, 6516, '\P{^Script_Extensions=	tai_Le}', "");
    Expect(0, 6517, '\p{Script_Extensions=	tai_Le}', "");
    Expect(1, 6517, '\p{^Script_Extensions=	tai_Le}', "");
    Expect(1, 6517, '\P{Script_Extensions=	tai_Le}', "");
    Expect(0, 6517, '\P{^Script_Extensions=	tai_Le}', "");
    Error('\p{Scx=/a/-	TALE}');
    Error('\P{Scx=/a/-	TALE}');
    Expect(1, 6516, '\p{Scx=:\ATale\z:}', "");;
    Expect(0, 6517, '\p{Scx=:\ATale\z:}', "");;
    Expect(1, 6516, '\p{Scx=tale}', "");
    Expect(0, 6516, '\p{^Scx=tale}', "");
    Expect(0, 6516, '\P{Scx=tale}', "");
    Expect(1, 6516, '\P{^Scx=tale}', "");
    Expect(0, 6517, '\p{Scx=tale}', "");
    Expect(1, 6517, '\p{^Scx=tale}', "");
    Expect(1, 6517, '\P{Scx=tale}', "");
    Expect(0, 6517, '\P{^Scx=tale}', "");
    Expect(1, 6516, '\p{Scx=:\Atale\z:}', "");;
    Expect(0, 6517, '\p{Scx=:\Atale\z:}', "");;
    Expect(1, 6516, '\p{Scx=	 tale}', "");
    Expect(0, 6516, '\p{^Scx=	 tale}', "");
    Expect(0, 6516, '\P{Scx=	 tale}', "");
    Expect(1, 6516, '\P{^Scx=	 tale}', "");
    Expect(0, 6517, '\p{Scx=	 tale}', "");
    Expect(1, 6517, '\p{^Scx=	 tale}', "");
    Expect(1, 6517, '\P{Scx=	 tale}', "");
    Expect(0, 6517, '\P{^Scx=	 tale}', "");
    Error('\p{Is_Script_Extensions:		-tai_LE:=}');
    Error('\P{Is_Script_Extensions:		-tai_LE:=}');
    Expect(1, 6516, '\p{Is_Script_Extensions=taile}', "");
    Expect(0, 6516, '\p{^Is_Script_Extensions=taile}', "");
    Expect(0, 6516, '\P{Is_Script_Extensions=taile}', "");
    Expect(1, 6516, '\P{^Is_Script_Extensions=taile}', "");
    Expect(0, 6517, '\p{Is_Script_Extensions=taile}', "");
    Expect(1, 6517, '\p{^Is_Script_Extensions=taile}', "");
    Expect(1, 6517, '\P{Is_Script_Extensions=taile}', "");
    Expect(0, 6517, '\P{^Is_Script_Extensions=taile}', "");
    Expect(1, 6516, '\p{Is_Script_Extensions=	 Tai_le}', "");
    Expect(0, 6516, '\p{^Is_Script_Extensions=	 Tai_le}', "");
    Expect(0, 6516, '\P{Is_Script_Extensions=	 Tai_le}', "");
    Expect(1, 6516, '\P{^Is_Script_Extensions=	 Tai_le}', "");
    Expect(0, 6517, '\p{Is_Script_Extensions=	 Tai_le}', "");
    Expect(1, 6517, '\p{^Is_Script_Extensions=	 Tai_le}', "");
    Expect(1, 6517, '\P{Is_Script_Extensions=	 Tai_le}', "");
    Expect(0, 6517, '\P{^Is_Script_Extensions=	 Tai_le}', "");
    Error('\p{Is_Scx=:=	-Tale}');
    Error('\P{Is_Scx=:=	-Tale}');
    Expect(1, 6516, '\p{Is_Scx=tale}', "");
    Expect(0, 6516, '\p{^Is_Scx=tale}', "");
    Expect(0, 6516, '\P{Is_Scx=tale}', "");
    Expect(1, 6516, '\P{^Is_Scx=tale}', "");
    Expect(0, 6517, '\p{Is_Scx=tale}', "");
    Expect(1, 6517, '\p{^Is_Scx=tale}', "");
    Expect(1, 6517, '\P{Is_Scx=tale}', "");
    Expect(0, 6517, '\P{^Is_Scx=tale}', "");
    Expect(1, 6516, '\p{Is_Scx=	-Tale}', "");
    Expect(0, 6516, '\p{^Is_Scx=	-Tale}', "");
    Expect(0, 6516, '\P{Is_Scx=	-Tale}', "");
    Expect(1, 6516, '\P{^Is_Scx=	-Tale}', "");
    Expect(0, 6517, '\p{Is_Scx=	-Tale}', "");
    Expect(1, 6517, '\p{^Is_Scx=	-Tale}', "");
    Expect(1, 6517, '\P{Is_Scx=	-Tale}', "");
    Expect(0, 6517, '\P{^Is_Scx=	-Tale}', "");
    Error('\p{Script_Extensions=/a/	 NEW_tai_lue}');
    Error('\P{Script_Extensions=/a/	 NEW_tai_lue}');
    Expect(1, 6623, '\p{Script_Extensions=:\ANew_Tai_Lue\z:}', "");;
    Expect(0, 6624, '\p{Script_Extensions=:\ANew_Tai_Lue\z:}', "");;
    Expect(1, 6623, '\p{Script_Extensions:	newtailue}', "");
    Expect(0, 6623, '\p{^Script_Extensions:	newtailue}', "");
    Expect(0, 6623, '\P{Script_Extensions:	newtailue}', "");
    Expect(1, 6623, '\P{^Script_Extensions:	newtailue}', "");
    Expect(0, 6624, '\p{Script_Extensions:	newtailue}', "");
    Expect(1, 6624, '\p{^Script_Extensions:	newtailue}', "");
    Expect(1, 6624, '\P{Script_Extensions:	newtailue}', "");
    Expect(0, 6624, '\P{^Script_Extensions:	newtailue}', "");
    Expect(1, 6623, '\p{Script_Extensions=:\Anewtailue\z:}', "");;
    Expect(0, 6624, '\p{Script_Extensions=:\Anewtailue\z:}', "");;
    Expect(1, 6623, '\p{Script_Extensions= 	NEW_Tai_LUE}', "");
    Expect(0, 6623, '\p{^Script_Extensions= 	NEW_Tai_LUE}', "");
    Expect(0, 6623, '\P{Script_Extensions= 	NEW_Tai_LUE}', "");
    Expect(1, 6623, '\P{^Script_Extensions= 	NEW_Tai_LUE}', "");
    Expect(0, 6624, '\p{Script_Extensions= 	NEW_Tai_LUE}', "");
    Expect(1, 6624, '\p{^Script_Extensions= 	NEW_Tai_LUE}', "");
    Expect(1, 6624, '\P{Script_Extensions= 	NEW_Tai_LUE}', "");
    Expect(0, 6624, '\P{^Script_Extensions= 	NEW_Tai_LUE}', "");
    Error('\p{Scx=/a/	 talu}');
    Error('\P{Scx=/a/	 talu}');
    Expect(1, 6623, '\p{Scx=:\ATalu\z:}', "");;
    Expect(0, 6624, '\p{Scx=:\ATalu\z:}', "");;
    Expect(1, 6623, '\p{Scx=talu}', "");
    Expect(0, 6623, '\p{^Scx=talu}', "");
    Expect(0, 6623, '\P{Scx=talu}', "");
    Expect(1, 6623, '\P{^Scx=talu}', "");
    Expect(0, 6624, '\p{Scx=talu}', "");
    Expect(1, 6624, '\p{^Scx=talu}', "");
    Expect(1, 6624, '\P{Scx=talu}', "");
    Expect(0, 6624, '\P{^Scx=talu}', "");
    Expect(1, 6623, '\p{Scx=:\Atalu\z:}', "");;
    Expect(0, 6624, '\p{Scx=:\Atalu\z:}', "");;
    Expect(1, 6623, '\p{Scx=_-Talu}', "");
    Expect(0, 6623, '\p{^Scx=_-Talu}', "");
    Expect(0, 6623, '\P{Scx=_-Talu}', "");
    Expect(1, 6623, '\P{^Scx=_-Talu}', "");
    Expect(0, 6624, '\p{Scx=_-Talu}', "");
    Expect(1, 6624, '\p{^Scx=_-Talu}', "");
    Expect(1, 6624, '\P{Scx=_-Talu}', "");
    Expect(0, 6624, '\P{^Scx=_-Talu}', "");
    Error('\p{Is_Script_Extensions=-_New_Tai_LUE/a/}');
    Error('\P{Is_Script_Extensions=-_New_Tai_LUE/a/}');
    Expect(1, 6623, '\p{Is_Script_Extensions=newtailue}', "");
    Expect(0, 6623, '\p{^Is_Script_Extensions=newtailue}', "");
    Expect(0, 6623, '\P{Is_Script_Extensions=newtailue}', "");
    Expect(1, 6623, '\P{^Is_Script_Extensions=newtailue}', "");
    Expect(0, 6624, '\p{Is_Script_Extensions=newtailue}', "");
    Expect(1, 6624, '\p{^Is_Script_Extensions=newtailue}', "");
    Expect(1, 6624, '\P{Is_Script_Extensions=newtailue}', "");
    Expect(0, 6624, '\P{^Is_Script_Extensions=newtailue}', "");
    Expect(1, 6623, '\p{Is_Script_Extensions=--NEW_Tai_lue}', "");
    Expect(0, 6623, '\p{^Is_Script_Extensions=--NEW_Tai_lue}', "");
    Expect(0, 6623, '\P{Is_Script_Extensions=--NEW_Tai_lue}', "");
    Expect(1, 6623, '\P{^Is_Script_Extensions=--NEW_Tai_lue}', "");
    Expect(0, 6624, '\p{Is_Script_Extensions=--NEW_Tai_lue}', "");
    Expect(1, 6624, '\p{^Is_Script_Extensions=--NEW_Tai_lue}', "");
    Expect(1, 6624, '\P{Is_Script_Extensions=--NEW_Tai_lue}', "");
    Expect(0, 6624, '\P{^Is_Script_Extensions=--NEW_Tai_lue}', "");
    Error('\p{Is_Scx=:=Talu}');
    Error('\P{Is_Scx=:=Talu}');
    Expect(1, 6623, '\p{Is_Scx=talu}', "");
    Expect(0, 6623, '\p{^Is_Scx=talu}', "");
    Expect(0, 6623, '\P{Is_Scx=talu}', "");
    Expect(1, 6623, '\P{^Is_Scx=talu}', "");
    Expect(0, 6624, '\p{Is_Scx=talu}', "");
    Expect(1, 6624, '\p{^Is_Scx=talu}', "");
    Expect(1, 6624, '\P{Is_Scx=talu}', "");
    Expect(0, 6624, '\P{^Is_Scx=talu}', "");
    Expect(1, 6623, '\p{Is_Scx:	TALU}', "");
    Expect(0, 6623, '\p{^Is_Scx:	TALU}', "");
    Expect(0, 6623, '\P{Is_Scx:	TALU}', "");
    Expect(1, 6623, '\P{^Is_Scx:	TALU}', "");
    Expect(0, 6624, '\p{Is_Scx:	TALU}', "");
    Expect(1, 6624, '\p{^Is_Scx:	TALU}', "");
    Expect(1, 6624, '\P{Is_Scx:	TALU}', "");
    Expect(0, 6624, '\P{^Is_Scx:	TALU}', "");
    Error('\p{Script_Extensions=_Tamil/a/}');
    Error('\P{Script_Extensions=_Tamil/a/}');
    Expect(1, 73727, '\p{Script_Extensions=:\ATamil\z:}', "");;
    Expect(0, 73728, '\p{Script_Extensions=:\ATamil\z:}', "");;
    Expect(1, 73727, '\p{Script_Extensions=tamil}', "");
    Expect(0, 73727, '\p{^Script_Extensions=tamil}', "");
    Expect(0, 73727, '\P{Script_Extensions=tamil}', "");
    Expect(1, 73727, '\P{^Script_Extensions=tamil}', "");
    Expect(0, 73728, '\p{Script_Extensions=tamil}', "");
    Expect(1, 73728, '\p{^Script_Extensions=tamil}', "");
    Expect(1, 73728, '\P{Script_Extensions=tamil}', "");
    Expect(0, 73728, '\P{^Script_Extensions=tamil}', "");
    Expect(1, 73727, '\p{Script_Extensions=:\Atamil\z:}', "");;
    Expect(0, 73728, '\p{Script_Extensions=:\Atamil\z:}', "");;
    Expect(1, 73727, '\p{Script_Extensions:   	 Tamil}', "");
    Expect(0, 73727, '\p{^Script_Extensions:   	 Tamil}', "");
    Expect(0, 73727, '\P{Script_Extensions:   	 Tamil}', "");
    Expect(1, 73727, '\P{^Script_Extensions:   	 Tamil}', "");
    Expect(0, 73728, '\p{Script_Extensions:   	 Tamil}', "");
    Expect(1, 73728, '\p{^Script_Extensions:   	 Tamil}', "");
    Expect(1, 73728, '\P{Script_Extensions:   	 Tamil}', "");
    Expect(0, 73728, '\P{^Script_Extensions:   	 Tamil}', "");
    Error('\p{Scx=:=TAML}');
    Error('\P{Scx=:=TAML}');
    Expect(1, 73727, '\p{Scx=:\ATaml\z:}', "");;
    Expect(0, 73728, '\p{Scx=:\ATaml\z:}', "");;
    Expect(1, 73727, '\p{Scx=taml}', "");
    Expect(0, 73727, '\p{^Scx=taml}', "");
    Expect(0, 73727, '\P{Scx=taml}', "");
    Expect(1, 73727, '\P{^Scx=taml}', "");
    Expect(0, 73728, '\p{Scx=taml}', "");
    Expect(1, 73728, '\p{^Scx=taml}', "");
    Expect(1, 73728, '\P{Scx=taml}', "");
    Expect(0, 73728, '\P{^Scx=taml}', "");
    Expect(1, 73727, '\p{Scx=:\Ataml\z:}', "");;
    Expect(0, 73728, '\p{Scx=:\Ataml\z:}', "");;
    Expect(1, 73727, '\p{Scx=Taml}', "");
    Expect(0, 73727, '\p{^Scx=Taml}', "");
    Expect(0, 73727, '\P{Scx=Taml}', "");
    Expect(1, 73727, '\P{^Scx=Taml}', "");
    Expect(0, 73728, '\p{Scx=Taml}', "");
    Expect(1, 73728, '\p{^Scx=Taml}', "");
    Expect(1, 73728, '\P{Scx=Taml}', "");
    Expect(0, 73728, '\P{^Scx=Taml}', "");
    Error('\p{Is_Script_Extensions=_	Tamil/a/}');
    Error('\P{Is_Script_Extensions=_	Tamil/a/}');
    Expect(1, 73727, '\p{Is_Script_Extensions=tamil}', "");
    Expect(0, 73727, '\p{^Is_Script_Extensions=tamil}', "");
    Expect(0, 73727, '\P{Is_Script_Extensions=tamil}', "");
    Expect(1, 73727, '\P{^Is_Script_Extensions=tamil}', "");
    Expect(0, 73728, '\p{Is_Script_Extensions=tamil}', "");
    Expect(1, 73728, '\p{^Is_Script_Extensions=tamil}', "");
    Expect(1, 73728, '\P{Is_Script_Extensions=tamil}', "");
    Expect(0, 73728, '\P{^Is_Script_Extensions=tamil}', "");
    Expect(1, 73727, '\p{Is_Script_Extensions= 	Tamil}', "");
    Expect(0, 73727, '\p{^Is_Script_Extensions= 	Tamil}', "");
    Expect(0, 73727, '\P{Is_Script_Extensions= 	Tamil}', "");
    Expect(1, 73727, '\P{^Is_Script_Extensions= 	Tamil}', "");
    Expect(0, 73728, '\p{Is_Script_Extensions= 	Tamil}', "");
    Expect(1, 73728, '\p{^Is_Script_Extensions= 	Tamil}', "");
    Expect(1, 73728, '\P{Is_Script_Extensions= 	Tamil}', "");
    Expect(0, 73728, '\P{^Is_Script_Extensions= 	Tamil}', "");
    Error('\p{Is_Scx:    /a/Taml}');
    Error('\P{Is_Scx:    /a/Taml}');
    Expect(1, 73727, '\p{Is_Scx=taml}', "");
    Expect(0, 73727, '\p{^Is_Scx=taml}', "");
    Expect(0, 73727, '\P{Is_Scx=taml}', "");
    Expect(1, 73727, '\P{^Is_Scx=taml}', "");
    Expect(0, 73728, '\p{Is_Scx=taml}', "");
    Expect(1, 73728, '\p{^Is_Scx=taml}', "");
    Expect(1, 73728, '\P{Is_Scx=taml}', "");
    Expect(0, 73728, '\P{^Is_Scx=taml}', "");
    Expect(1, 73727, '\p{Is_Scx= 	Taml}', "");
    Expect(0, 73727, '\p{^Is_Scx= 	Taml}', "");
    Expect(0, 73727, '\P{Is_Scx= 	Taml}', "");
    Expect(1, 73727, '\P{^Is_Scx= 	Taml}', "");
    Expect(0, 73728, '\p{Is_Scx= 	Taml}', "");
    Expect(1, 73728, '\p{^Is_Scx= 	Taml}', "");
    Expect(1, 73728, '\P{Is_Scx= 	Taml}', "");
    Expect(0, 73728, '\P{^Is_Scx= 	Taml}', "");
    Error('\p{Script_Extensions= 	Tangut:=}');
    Error('\P{Script_Extensions= 	Tangut:=}');
    Expect(1, 101640, '\p{Script_Extensions=:\ATangut\z:}', "");;
    Expect(0, 101641, '\p{Script_Extensions=:\ATangut\z:}', "");;
    Expect(1, 101640, '\p{Script_Extensions=tangut}', "");
    Expect(0, 101640, '\p{^Script_Extensions=tangut}', "");
    Expect(0, 101640, '\P{Script_Extensions=tangut}', "");
    Expect(1, 101640, '\P{^Script_Extensions=tangut}', "");
    Expect(0, 101641, '\p{Script_Extensions=tangut}', "");
    Expect(1, 101641, '\p{^Script_Extensions=tangut}', "");
    Expect(1, 101641, '\P{Script_Extensions=tangut}', "");
    Expect(0, 101641, '\P{^Script_Extensions=tangut}', "");
    Expect(1, 101640, '\p{Script_Extensions=:\Atangut\z:}', "");;
    Expect(0, 101641, '\p{Script_Extensions=:\Atangut\z:}', "");;
    Expect(1, 101640, '\p{Script_Extensions=  Tangut}', "");
    Expect(0, 101640, '\p{^Script_Extensions=  Tangut}', "");
    Expect(0, 101640, '\P{Script_Extensions=  Tangut}', "");
    Expect(1, 101640, '\P{^Script_Extensions=  Tangut}', "");
    Expect(0, 101641, '\p{Script_Extensions=  Tangut}', "");
    Expect(1, 101641, '\p{^Script_Extensions=  Tangut}', "");
    Expect(1, 101641, '\P{Script_Extensions=  Tangut}', "");
    Expect(0, 101641, '\P{^Script_Extensions=  Tangut}', "");
    Error('\p{Scx=	_tang/a/}');
    Error('\P{Scx=	_tang/a/}');
    Expect(1, 101640, '\p{Scx=:\ATang\z:}', "");;
    Expect(0, 101641, '\p{Scx=:\ATang\z:}', "");;
    Expect(1, 101640, '\p{Scx:   tang}', "");
    Expect(0, 101640, '\p{^Scx:   tang}', "");
    Expect(0, 101640, '\P{Scx:   tang}', "");
    Expect(1, 101640, '\P{^Scx:   tang}', "");
    Expect(0, 101641, '\p{Scx:   tang}', "");
    Expect(1, 101641, '\p{^Scx:   tang}', "");
    Expect(1, 101641, '\P{Scx:   tang}', "");
    Expect(0, 101641, '\P{^Scx:   tang}', "");
    Expect(1, 101640, '\p{Scx=:\Atang\z:}', "");;
    Expect(0, 101641, '\p{Scx=:\Atang\z:}', "");;
    Expect(1, 101640, '\p{Scx= Tang}', "");
    Expect(0, 101640, '\p{^Scx= Tang}', "");
    Expect(0, 101640, '\P{Scx= Tang}', "");
    Expect(1, 101640, '\P{^Scx= Tang}', "");
    Expect(0, 101641, '\p{Scx= Tang}', "");
    Expect(1, 101641, '\p{^Scx= Tang}', "");
    Expect(1, 101641, '\P{Scx= Tang}', "");
    Expect(0, 101641, '\P{^Scx= Tang}', "");
    Error('\p{Is_Script_Extensions=:=-tangut}');
    Error('\P{Is_Script_Extensions=:=-tangut}');
    Expect(1, 101640, '\p{Is_Script_Extensions=tangut}', "");
    Expect(0, 101640, '\p{^Is_Script_Extensions=tangut}', "");
    Expect(0, 101640, '\P{Is_Script_Extensions=tangut}', "");
    Expect(1, 101640, '\P{^Is_Script_Extensions=tangut}', "");
    Expect(0, 101641, '\p{Is_Script_Extensions=tangut}', "");
    Expect(1, 101641, '\p{^Is_Script_Extensions=tangut}', "");
    Expect(1, 101641, '\P{Is_Script_Extensions=tangut}', "");
    Expect(0, 101641, '\P{^Is_Script_Extensions=tangut}', "");
    Expect(1, 101640, '\p{Is_Script_Extensions= tangut}', "");
    Expect(0, 101640, '\p{^Is_Script_Extensions= tangut}', "");
    Expect(0, 101640, '\P{Is_Script_Extensions= tangut}', "");
    Expect(1, 101640, '\P{^Is_Script_Extensions= tangut}', "");
    Expect(0, 101641, '\p{Is_Script_Extensions= tangut}', "");
    Expect(1, 101641, '\p{^Is_Script_Extensions= tangut}', "");
    Expect(1, 101641, '\P{Is_Script_Extensions= tangut}', "");
    Expect(0, 101641, '\P{^Is_Script_Extensions= tangut}', "");
    Error('\p{Is_Scx= :=Tang}');
    Error('\P{Is_Scx= :=Tang}');
    Expect(1, 101640, '\p{Is_Scx=tang}', "");
    Expect(0, 101640, '\p{^Is_Scx=tang}', "");
    Expect(0, 101640, '\P{Is_Scx=tang}', "");
    Expect(1, 101640, '\P{^Is_Scx=tang}', "");
    Expect(0, 101641, '\p{Is_Scx=tang}', "");
    Expect(1, 101641, '\p{^Is_Scx=tang}', "");
    Expect(1, 101641, '\P{Is_Scx=tang}', "");
    Expect(0, 101641, '\P{^Is_Scx=tang}', "");
    Expect(1, 101640, '\p{Is_Scx=  Tang}', "");
    Expect(0, 101640, '\p{^Is_Scx=  Tang}', "");
    Expect(0, 101640, '\P{Is_Scx=  Tang}', "");
    Expect(1, 101640, '\P{^Is_Scx=  Tang}', "");
    Expect(0, 101641, '\p{Is_Scx=  Tang}', "");
    Expect(1, 101641, '\p{^Is_Scx=  Tang}', "");
    Expect(1, 101641, '\P{Is_Scx=  Tang}', "");
    Expect(0, 101641, '\P{^Is_Scx=  Tang}', "");
    Error('\p{Script_Extensions=/a/__tai_Viet}');
    Error('\P{Script_Extensions=/a/__tai_Viet}');
    Expect(1, 43743, '\p{Script_Extensions=:\ATai_Viet\z:}', "");;
    Expect(0, 43744, '\p{Script_Extensions=:\ATai_Viet\z:}', "");;
    Expect(1, 43743, '\p{Script_Extensions=taiviet}', "");
    Expect(0, 43743, '\p{^Script_Extensions=taiviet}', "");
    Expect(0, 43743, '\P{Script_Extensions=taiviet}', "");
    Expect(1, 43743, '\P{^Script_Extensions=taiviet}', "");
    Expect(0, 43744, '\p{Script_Extensions=taiviet}', "");
    Expect(1, 43744, '\p{^Script_Extensions=taiviet}', "");
    Expect(1, 43744, '\P{Script_Extensions=taiviet}', "");
    Expect(0, 43744, '\P{^Script_Extensions=taiviet}', "");
    Expect(1, 43743, '\p{Script_Extensions=:\Ataiviet\z:}', "");;
    Expect(0, 43744, '\p{Script_Extensions=:\Ataiviet\z:}', "");;
    Expect(1, 43743, '\p{Script_Extensions= Tai_Viet}', "");
    Expect(0, 43743, '\p{^Script_Extensions= Tai_Viet}', "");
    Expect(0, 43743, '\P{Script_Extensions= Tai_Viet}', "");
    Expect(1, 43743, '\P{^Script_Extensions= Tai_Viet}', "");
    Expect(0, 43744, '\p{Script_Extensions= Tai_Viet}', "");
    Expect(1, 43744, '\p{^Script_Extensions= Tai_Viet}', "");
    Expect(1, 43744, '\P{Script_Extensions= Tai_Viet}', "");
    Expect(0, 43744, '\P{^Script_Extensions= Tai_Viet}', "");
    Error('\p{Scx=	/a/Tavt}');
    Error('\P{Scx=	/a/Tavt}');
    Expect(1, 43743, '\p{Scx=:\ATavt\z:}', "");;
    Expect(0, 43744, '\p{Scx=:\ATavt\z:}', "");;
    Expect(1, 43743, '\p{Scx=tavt}', "");
    Expect(0, 43743, '\p{^Scx=tavt}', "");
    Expect(0, 43743, '\P{Scx=tavt}', "");
    Expect(1, 43743, '\P{^Scx=tavt}', "");
    Expect(0, 43744, '\p{Scx=tavt}', "");
    Expect(1, 43744, '\p{^Scx=tavt}', "");
    Expect(1, 43744, '\P{Scx=tavt}', "");
    Expect(0, 43744, '\P{^Scx=tavt}', "");
    Expect(1, 43743, '\p{Scx=:\Atavt\z:}', "");;
    Expect(0, 43744, '\p{Scx=:\Atavt\z:}', "");;
    Expect(1, 43743, '\p{Scx= _TAVT}', "");
    Expect(0, 43743, '\p{^Scx= _TAVT}', "");
    Expect(0, 43743, '\P{Scx= _TAVT}', "");
    Expect(1, 43743, '\P{^Scx= _TAVT}', "");
    Expect(0, 43744, '\p{Scx= _TAVT}', "");
    Expect(1, 43744, '\p{^Scx= _TAVT}', "");
    Expect(1, 43744, '\P{Scx= _TAVT}', "");
    Expect(0, 43744, '\P{^Scx= _TAVT}', "");
    Error('\p{Is_Script_Extensions=/a/__Tai_VIET}');
    Error('\P{Is_Script_Extensions=/a/__Tai_VIET}');
    Expect(1, 43743, '\p{Is_Script_Extensions=taiviet}', "");
    Expect(0, 43743, '\p{^Is_Script_Extensions=taiviet}', "");
    Expect(0, 43743, '\P{Is_Script_Extensions=taiviet}', "");
    Expect(1, 43743, '\P{^Is_Script_Extensions=taiviet}', "");
    Expect(0, 43744, '\p{Is_Script_Extensions=taiviet}', "");
    Expect(1, 43744, '\p{^Is_Script_Extensions=taiviet}', "");
    Expect(1, 43744, '\P{Is_Script_Extensions=taiviet}', "");
    Expect(0, 43744, '\P{^Is_Script_Extensions=taiviet}', "");
    Expect(1, 43743, '\p{Is_Script_Extensions:		 Tai_VIET}', "");
    Expect(0, 43743, '\p{^Is_Script_Extensions:		 Tai_VIET}', "");
    Expect(0, 43743, '\P{Is_Script_Extensions:		 Tai_VIET}', "");
    Expect(1, 43743, '\P{^Is_Script_Extensions:		 Tai_VIET}', "");
    Expect(0, 43744, '\p{Is_Script_Extensions:		 Tai_VIET}', "");
    Expect(1, 43744, '\p{^Is_Script_Extensions:		 Tai_VIET}', "");
    Expect(1, 43744, '\P{Is_Script_Extensions:		 Tai_VIET}', "");
    Expect(0, 43744, '\P{^Is_Script_Extensions:		 Tai_VIET}', "");
    Error('\p{Is_Scx=	:=tavt}');
    Error('\P{Is_Scx=	:=tavt}');
    Expect(1, 43743, '\p{Is_Scx=tavt}', "");
    Expect(0, 43743, '\p{^Is_Scx=tavt}', "");
    Expect(0, 43743, '\P{Is_Scx=tavt}', "");
    Expect(1, 43743, '\P{^Is_Scx=tavt}', "");
    Expect(0, 43744, '\p{Is_Scx=tavt}', "");
    Expect(1, 43744, '\p{^Is_Scx=tavt}', "");
    Expect(1, 43744, '\P{Is_Scx=tavt}', "");
    Expect(0, 43744, '\P{^Is_Scx=tavt}', "");
    Expect(1, 43743, '\p{Is_Scx=	_TAVT}', "");
    Expect(0, 43743, '\p{^Is_Scx=	_TAVT}', "");
    Expect(0, 43743, '\P{Is_Scx=	_TAVT}', "");
    Expect(1, 43743, '\P{^Is_Scx=	_TAVT}', "");
    Expect(0, 43744, '\p{Is_Scx=	_TAVT}', "");
    Expect(1, 43744, '\p{^Is_Scx=	_TAVT}', "");
    Expect(1, 43744, '\P{Is_Scx=	_TAVT}', "");
    Expect(0, 43744, '\P{^Is_Scx=	_TAVT}', "");
    Error('\p{Script_Extensions=	_TELUGU/a/}');
    Error('\P{Script_Extensions=	_TELUGU/a/}');
    Expect(1, 7410, '\p{Script_Extensions=:\ATelugu\z:}', "");;
    Expect(0, 7411, '\p{Script_Extensions=:\ATelugu\z:}', "");;
    Expect(1, 7410, '\p{Script_Extensions:telugu}', "");
    Expect(0, 7410, '\p{^Script_Extensions:telugu}', "");
    Expect(0, 7410, '\P{Script_Extensions:telugu}', "");
    Expect(1, 7410, '\P{^Script_Extensions:telugu}', "");
    Expect(0, 7411, '\p{Script_Extensions:telugu}', "");
    Expect(1, 7411, '\p{^Script_Extensions:telugu}', "");
    Expect(1, 7411, '\P{Script_Extensions:telugu}', "");
    Expect(0, 7411, '\P{^Script_Extensions:telugu}', "");
    Expect(1, 7410, '\p{Script_Extensions=:\Atelugu\z:}', "");;
    Expect(0, 7411, '\p{Script_Extensions=:\Atelugu\z:}', "");;
    Expect(1, 7410, '\p{Script_Extensions:	  telugu}', "");
    Expect(0, 7410, '\p{^Script_Extensions:	  telugu}', "");
    Expect(0, 7410, '\P{Script_Extensions:	  telugu}', "");
    Expect(1, 7410, '\P{^Script_Extensions:	  telugu}', "");
    Expect(0, 7411, '\p{Script_Extensions:	  telugu}', "");
    Expect(1, 7411, '\p{^Script_Extensions:	  telugu}', "");
    Expect(1, 7411, '\P{Script_Extensions:	  telugu}', "");
    Expect(0, 7411, '\P{^Script_Extensions:	  telugu}', "");
    Error('\p{Scx=	TELU:=}');
    Error('\P{Scx=	TELU:=}');
    Expect(1, 7410, '\p{Scx=:\ATelu\z:}', "");;
    Expect(0, 7411, '\p{Scx=:\ATelu\z:}', "");;
    Expect(1, 7410, '\p{Scx=telu}', "");
    Expect(0, 7410, '\p{^Scx=telu}', "");
    Expect(0, 7410, '\P{Scx=telu}', "");
    Expect(1, 7410, '\P{^Scx=telu}', "");
    Expect(0, 7411, '\p{Scx=telu}', "");
    Expect(1, 7411, '\p{^Scx=telu}', "");
    Expect(1, 7411, '\P{Scx=telu}', "");
    Expect(0, 7411, '\P{^Scx=telu}', "");
    Expect(1, 7410, '\p{Scx=:\Atelu\z:}', "");;
    Expect(0, 7411, '\p{Scx=:\Atelu\z:}', "");;
    Expect(1, 7410, '\p{Scx:   	telu}', "");
    Expect(0, 7410, '\p{^Scx:   	telu}', "");
    Expect(0, 7410, '\P{Scx:   	telu}', "");
    Expect(1, 7410, '\P{^Scx:   	telu}', "");
    Expect(0, 7411, '\p{Scx:   	telu}', "");
    Expect(1, 7411, '\p{^Scx:   	telu}', "");
    Expect(1, 7411, '\P{Scx:   	telu}', "");
    Expect(0, 7411, '\P{^Scx:   	telu}', "");
    Error('\p{Is_Script_Extensions=-	telugu/a/}');
    Error('\P{Is_Script_Extensions=-	telugu/a/}');
    Expect(1, 7410, '\p{Is_Script_Extensions=telugu}', "");
    Expect(0, 7410, '\p{^Is_Script_Extensions=telugu}', "");
    Expect(0, 7410, '\P{Is_Script_Extensions=telugu}', "");
    Expect(1, 7410, '\P{^Is_Script_Extensions=telugu}', "");
    Expect(0, 7411, '\p{Is_Script_Extensions=telugu}', "");
    Expect(1, 7411, '\p{^Is_Script_Extensions=telugu}', "");
    Expect(1, 7411, '\P{Is_Script_Extensions=telugu}', "");
    Expect(0, 7411, '\P{^Is_Script_Extensions=telugu}', "");
    Expect(1, 7410, '\p{Is_Script_Extensions=_	Telugu}', "");
    Expect(0, 7410, '\p{^Is_Script_Extensions=_	Telugu}', "");
    Expect(0, 7410, '\P{Is_Script_Extensions=_	Telugu}', "");
    Expect(1, 7410, '\P{^Is_Script_Extensions=_	Telugu}', "");
    Expect(0, 7411, '\p{Is_Script_Extensions=_	Telugu}', "");
    Expect(1, 7411, '\p{^Is_Script_Extensions=_	Telugu}', "");
    Expect(1, 7411, '\P{Is_Script_Extensions=_	Telugu}', "");
    Expect(0, 7411, '\P{^Is_Script_Extensions=_	Telugu}', "");
    Error('\p{Is_Scx=:=_	TELU}');
    Error('\P{Is_Scx=:=_	TELU}');
    Expect(1, 7410, '\p{Is_Scx=telu}', "");
    Expect(0, 7410, '\p{^Is_Scx=telu}', "");
    Expect(0, 7410, '\P{Is_Scx=telu}', "");
    Expect(1, 7410, '\P{^Is_Scx=telu}', "");
    Expect(0, 7411, '\p{Is_Scx=telu}', "");
    Expect(1, 7411, '\p{^Is_Scx=telu}', "");
    Expect(1, 7411, '\P{Is_Scx=telu}', "");
    Expect(0, 7411, '\P{^Is_Scx=telu}', "");
    Expect(1, 7410, '\p{Is_Scx=	_TELU}', "");
    Expect(0, 7410, '\p{^Is_Scx=	_TELU}', "");
    Expect(0, 7410, '\P{Is_Scx=	_TELU}', "");
    Expect(1, 7410, '\P{^Is_Scx=	_TELU}', "");
    Expect(0, 7411, '\p{Is_Scx=	_TELU}', "");
    Expect(1, 7411, '\p{^Is_Scx=	_TELU}', "");
    Expect(1, 7411, '\P{Is_Scx=	_TELU}', "");
    Expect(0, 7411, '\P{^Is_Scx=	_TELU}', "");
    Error('\p{Script_Extensions=:=	 Tifinagh}');
    Error('\P{Script_Extensions=:=	 Tifinagh}');
    Expect(1, 11647, '\p{Script_Extensions=:\ATifinagh\z:}', "");;
    Expect(0, 11648, '\p{Script_Extensions=:\ATifinagh\z:}', "");;
    Expect(1, 11647, '\p{Script_Extensions=tifinagh}', "");
    Expect(0, 11647, '\p{^Script_Extensions=tifinagh}', "");
    Expect(0, 11647, '\P{Script_Extensions=tifinagh}', "");
    Expect(1, 11647, '\P{^Script_Extensions=tifinagh}', "");
    Expect(0, 11648, '\p{Script_Extensions=tifinagh}', "");
    Expect(1, 11648, '\p{^Script_Extensions=tifinagh}', "");
    Expect(1, 11648, '\P{Script_Extensions=tifinagh}', "");
    Expect(0, 11648, '\P{^Script_Extensions=tifinagh}', "");
    Expect(1, 11647, '\p{Script_Extensions=:\Atifinagh\z:}', "");;
    Expect(0, 11648, '\p{Script_Extensions=:\Atifinagh\z:}', "");;
    Expect(1, 11647, '\p{Script_Extensions=-TIFINAGH}', "");
    Expect(0, 11647, '\p{^Script_Extensions=-TIFINAGH}', "");
    Expect(0, 11647, '\P{Script_Extensions=-TIFINAGH}', "");
    Expect(1, 11647, '\P{^Script_Extensions=-TIFINAGH}', "");
    Expect(0, 11648, '\p{Script_Extensions=-TIFINAGH}', "");
    Expect(1, 11648, '\p{^Script_Extensions=-TIFINAGH}', "");
    Expect(1, 11648, '\P{Script_Extensions=-TIFINAGH}', "");
    Expect(0, 11648, '\P{^Script_Extensions=-TIFINAGH}', "");
    Error('\p{Scx=_:=TFNG}');
    Error('\P{Scx=_:=TFNG}');
    Expect(1, 11647, '\p{Scx=:\ATfng\z:}', "");;
    Expect(0, 11648, '\p{Scx=:\ATfng\z:}', "");;
    Expect(1, 11647, '\p{Scx=tfng}', "");
    Expect(0, 11647, '\p{^Scx=tfng}', "");
    Expect(0, 11647, '\P{Scx=tfng}', "");
    Expect(1, 11647, '\P{^Scx=tfng}', "");
    Expect(0, 11648, '\p{Scx=tfng}', "");
    Expect(1, 11648, '\p{^Scx=tfng}', "");
    Expect(1, 11648, '\P{Scx=tfng}', "");
    Expect(0, 11648, '\P{^Scx=tfng}', "");
    Expect(1, 11647, '\p{Scx=:\Atfng\z:}', "");;
    Expect(0, 11648, '\p{Scx=:\Atfng\z:}', "");;
    Expect(1, 11647, '\p{Scx=  TFNG}', "");
    Expect(0, 11647, '\p{^Scx=  TFNG}', "");
    Expect(0, 11647, '\P{Scx=  TFNG}', "");
    Expect(1, 11647, '\P{^Scx=  TFNG}', "");
    Expect(0, 11648, '\p{Scx=  TFNG}', "");
    Expect(1, 11648, '\p{^Scx=  TFNG}', "");
    Expect(1, 11648, '\P{Scx=  TFNG}', "");
    Expect(0, 11648, '\P{^Scx=  TFNG}', "");
    Error('\p{Is_Script_Extensions=/a/tifinagh}');
    Error('\P{Is_Script_Extensions=/a/tifinagh}');
    Expect(1, 11647, '\p{Is_Script_Extensions=tifinagh}', "");
    Expect(0, 11647, '\p{^Is_Script_Extensions=tifinagh}', "");
    Expect(0, 11647, '\P{Is_Script_Extensions=tifinagh}', "");
    Expect(1, 11647, '\P{^Is_Script_Extensions=tifinagh}', "");
    Expect(0, 11648, '\p{Is_Script_Extensions=tifinagh}', "");
    Expect(1, 11648, '\p{^Is_Script_Extensions=tifinagh}', "");
    Expect(1, 11648, '\P{Is_Script_Extensions=tifinagh}', "");
    Expect(0, 11648, '\P{^Is_Script_Extensions=tifinagh}', "");
    Expect(1, 11647, '\p{Is_Script_Extensions= _Tifinagh}', "");
    Expect(0, 11647, '\p{^Is_Script_Extensions= _Tifinagh}', "");
    Expect(0, 11647, '\P{Is_Script_Extensions= _Tifinagh}', "");
    Expect(1, 11647, '\P{^Is_Script_Extensions= _Tifinagh}', "");
    Expect(0, 11648, '\p{Is_Script_Extensions= _Tifinagh}', "");
    Expect(1, 11648, '\p{^Is_Script_Extensions= _Tifinagh}', "");
    Expect(1, 11648, '\P{Is_Script_Extensions= _Tifinagh}', "");
    Expect(0, 11648, '\P{^Is_Script_Extensions= _Tifinagh}', "");
    Error('\p{Is_Scx=/a/	-Tfng}');
    Error('\P{Is_Scx=/a/	-Tfng}');
    Expect(1, 11647, '\p{Is_Scx=tfng}', "");
    Expect(0, 11647, '\p{^Is_Scx=tfng}', "");
    Expect(0, 11647, '\P{Is_Scx=tfng}', "");
    Expect(1, 11647, '\P{^Is_Scx=tfng}', "");
    Expect(0, 11648, '\p{Is_Scx=tfng}', "");
    Expect(1, 11648, '\p{^Is_Scx=tfng}', "");
    Expect(1, 11648, '\P{Is_Scx=tfng}', "");
    Expect(0, 11648, '\P{^Is_Scx=tfng}', "");
    Expect(1, 11647, '\p{Is_Scx=-tfng}', "");
    Expect(0, 11647, '\p{^Is_Scx=-tfng}', "");
    Expect(0, 11647, '\P{Is_Scx=-tfng}', "");
    Expect(1, 11647, '\P{^Is_Scx=-tfng}', "");
    Expect(0, 11648, '\p{Is_Scx=-tfng}', "");
    Expect(1, 11648, '\p{^Is_Scx=-tfng}', "");
    Expect(1, 11648, '\P{Is_Scx=-tfng}', "");
    Expect(0, 11648, '\P{^Is_Scx=-tfng}', "");
    Error('\p{Script_Extensions=TAGALOG:=}');
    Error('\P{Script_Extensions=TAGALOG:=}');
    Expect(1, 5942, '\p{Script_Extensions=:\ATagalog\z:}', "");;
    Expect(0, 5943, '\p{Script_Extensions=:\ATagalog\z:}', "");;
    Expect(1, 5942, '\p{Script_Extensions=tagalog}', "");
    Expect(0, 5942, '\p{^Script_Extensions=tagalog}', "");
    Expect(0, 5942, '\P{Script_Extensions=tagalog}', "");
    Expect(1, 5942, '\P{^Script_Extensions=tagalog}', "");
    Expect(0, 5943, '\p{Script_Extensions=tagalog}', "");
    Expect(1, 5943, '\p{^Script_Extensions=tagalog}', "");
    Expect(1, 5943, '\P{Script_Extensions=tagalog}', "");
    Expect(0, 5943, '\P{^Script_Extensions=tagalog}', "");
    Expect(1, 5942, '\p{Script_Extensions=:\Atagalog\z:}', "");;
    Expect(0, 5943, '\p{Script_Extensions=:\Atagalog\z:}', "");;
    Expect(1, 5942, '\p{Script_Extensions=_-TAGALOG}', "");
    Expect(0, 5942, '\p{^Script_Extensions=_-TAGALOG}', "");
    Expect(0, 5942, '\P{Script_Extensions=_-TAGALOG}', "");
    Expect(1, 5942, '\P{^Script_Extensions=_-TAGALOG}', "");
    Expect(0, 5943, '\p{Script_Extensions=_-TAGALOG}', "");
    Expect(1, 5943, '\p{^Script_Extensions=_-TAGALOG}', "");
    Expect(1, 5943, '\P{Script_Extensions=_-TAGALOG}', "");
    Expect(0, 5943, '\P{^Script_Extensions=_-TAGALOG}', "");
    Error('\p{Scx=_	tglg:=}');
    Error('\P{Scx=_	tglg:=}');
    Expect(1, 5942, '\p{Scx=:\ATglg\z:}', "");;
    Expect(0, 5943, '\p{Scx=:\ATglg\z:}', "");;
    Expect(1, 5942, '\p{Scx=tglg}', "");
    Expect(0, 5942, '\p{^Scx=tglg}', "");
    Expect(0, 5942, '\P{Scx=tglg}', "");
    Expect(1, 5942, '\P{^Scx=tglg}', "");
    Expect(0, 5943, '\p{Scx=tglg}', "");
    Expect(1, 5943, '\p{^Scx=tglg}', "");
    Expect(1, 5943, '\P{Scx=tglg}', "");
    Expect(0, 5943, '\P{^Scx=tglg}', "");
    Expect(1, 5942, '\p{Scx=:\Atglg\z:}', "");;
    Expect(0, 5943, '\p{Scx=:\Atglg\z:}', "");;
    Expect(1, 5942, '\p{Scx:   __TGLG}', "");
    Expect(0, 5942, '\p{^Scx:   __TGLG}', "");
    Expect(0, 5942, '\P{Scx:   __TGLG}', "");
    Expect(1, 5942, '\P{^Scx:   __TGLG}', "");
    Expect(0, 5943, '\p{Scx:   __TGLG}', "");
    Expect(1, 5943, '\p{^Scx:   __TGLG}', "");
    Expect(1, 5943, '\P{Scx:   __TGLG}', "");
    Expect(0, 5943, '\P{^Scx:   __TGLG}', "");
    Error('\p{Is_Script_Extensions=:=  tagalog}');
    Error('\P{Is_Script_Extensions=:=  tagalog}');
    Expect(1, 5942, '\p{Is_Script_Extensions=tagalog}', "");
    Expect(0, 5942, '\p{^Is_Script_Extensions=tagalog}', "");
    Expect(0, 5942, '\P{Is_Script_Extensions=tagalog}', "");
    Expect(1, 5942, '\P{^Is_Script_Extensions=tagalog}', "");
    Expect(0, 5943, '\p{Is_Script_Extensions=tagalog}', "");
    Expect(1, 5943, '\p{^Is_Script_Extensions=tagalog}', "");
    Expect(1, 5943, '\P{Is_Script_Extensions=tagalog}', "");
    Expect(0, 5943, '\P{^Is_Script_Extensions=tagalog}', "");
    Expect(1, 5942, '\p{Is_Script_Extensions=  Tagalog}', "");
    Expect(0, 5942, '\p{^Is_Script_Extensions=  Tagalog}', "");
    Expect(0, 5942, '\P{Is_Script_Extensions=  Tagalog}', "");
    Expect(1, 5942, '\P{^Is_Script_Extensions=  Tagalog}', "");
    Expect(0, 5943, '\p{Is_Script_Extensions=  Tagalog}', "");
    Expect(1, 5943, '\p{^Is_Script_Extensions=  Tagalog}', "");
    Expect(1, 5943, '\P{Is_Script_Extensions=  Tagalog}', "");
    Expect(0, 5943, '\P{^Is_Script_Extensions=  Tagalog}', "");
    Error('\p{Is_Scx=:= 	Tglg}');
    Error('\P{Is_Scx=:= 	Tglg}');
    Expect(1, 5942, '\p{Is_Scx=tglg}', "");
    Expect(0, 5942, '\p{^Is_Scx=tglg}', "");
    Expect(0, 5942, '\P{Is_Scx=tglg}', "");
    Expect(1, 5942, '\P{^Is_Scx=tglg}', "");
    Expect(0, 5943, '\p{Is_Scx=tglg}', "");
    Expect(1, 5943, '\p{^Is_Scx=tglg}', "");
    Expect(1, 5943, '\P{Is_Scx=tglg}', "");
    Expect(0, 5943, '\P{^Is_Scx=tglg}', "");
    Expect(1, 5942, '\p{Is_Scx=	_Tglg}', "");
    Expect(0, 5942, '\p{^Is_Scx=	_Tglg}', "");
    Expect(0, 5942, '\P{Is_Scx=	_Tglg}', "");
    Expect(1, 5942, '\P{^Is_Scx=	_Tglg}', "");
    Expect(0, 5943, '\p{Is_Scx=	_Tglg}', "");
    Expect(1, 5943, '\p{^Is_Scx=	_Tglg}', "");
    Expect(1, 5943, '\P{Is_Scx=	_Tglg}', "");
    Expect(0, 5943, '\P{^Is_Scx=	_Tglg}', "");
    Error('\p{Script_Extensions=:=	-Thaana}');
    Error('\P{Script_Extensions=:=	-Thaana}');
    Expect(1, 65021, '\p{Script_Extensions=:\AThaana\z:}', "");;
    Expect(0, 65022, '\p{Script_Extensions=:\AThaana\z:}', "");;
    Expect(1, 65021, '\p{Script_Extensions=thaana}', "");
    Expect(0, 65021, '\p{^Script_Extensions=thaana}', "");
    Expect(0, 65021, '\P{Script_Extensions=thaana}', "");
    Expect(1, 65021, '\P{^Script_Extensions=thaana}', "");
    Expect(0, 65022, '\p{Script_Extensions=thaana}', "");
    Expect(1, 65022, '\p{^Script_Extensions=thaana}', "");
    Expect(1, 65022, '\P{Script_Extensions=thaana}', "");
    Expect(0, 65022, '\P{^Script_Extensions=thaana}', "");
    Expect(1, 65021, '\p{Script_Extensions=:\Athaana\z:}', "");;
    Expect(0, 65022, '\p{Script_Extensions=:\Athaana\z:}', "");;
    Expect(1, 65021, '\p{Script_Extensions=- THAANA}', "");
    Expect(0, 65021, '\p{^Script_Extensions=- THAANA}', "");
    Expect(0, 65021, '\P{Script_Extensions=- THAANA}', "");
    Expect(1, 65021, '\P{^Script_Extensions=- THAANA}', "");
    Expect(0, 65022, '\p{Script_Extensions=- THAANA}', "");
    Expect(1, 65022, '\p{^Script_Extensions=- THAANA}', "");
    Expect(1, 65022, '\P{Script_Extensions=- THAANA}', "");
    Expect(0, 65022, '\P{^Script_Extensions=- THAANA}', "");
    Error('\p{Scx:	:= thaa}');
    Error('\P{Scx:	:= thaa}');
    Expect(1, 65021, '\p{Scx=:\AThaa\z:}', "");;
    Expect(0, 65022, '\p{Scx=:\AThaa\z:}', "");;
    Expect(1, 65021, '\p{Scx=thaa}', "");
    Expect(0, 65021, '\p{^Scx=thaa}', "");
    Expect(0, 65021, '\P{Scx=thaa}', "");
    Expect(1, 65021, '\P{^Scx=thaa}', "");
    Expect(0, 65022, '\p{Scx=thaa}', "");
    Expect(1, 65022, '\p{^Scx=thaa}', "");
    Expect(1, 65022, '\P{Scx=thaa}', "");
    Expect(0, 65022, '\P{^Scx=thaa}', "");
    Expect(1, 65021, '\p{Scx=:\Athaa\z:}', "");;
    Expect(0, 65022, '\p{Scx=:\Athaa\z:}', "");;
    Expect(1, 65021, '\p{Scx=-Thaa}', "");
    Expect(0, 65021, '\p{^Scx=-Thaa}', "");
    Expect(0, 65021, '\P{Scx=-Thaa}', "");
    Expect(1, 65021, '\P{^Scx=-Thaa}', "");
    Expect(0, 65022, '\p{Scx=-Thaa}', "");
    Expect(1, 65022, '\p{^Scx=-Thaa}', "");
    Expect(1, 65022, '\P{Scx=-Thaa}', "");
    Expect(0, 65022, '\P{^Scx=-Thaa}', "");
    Error('\p{Is_Script_Extensions=_:=Thaana}');
    Error('\P{Is_Script_Extensions=_:=Thaana}');
    Expect(1, 65021, '\p{Is_Script_Extensions=thaana}', "");
    Expect(0, 65021, '\p{^Is_Script_Extensions=thaana}', "");
    Expect(0, 65021, '\P{Is_Script_Extensions=thaana}', "");
    Expect(1, 65021, '\P{^Is_Script_Extensions=thaana}', "");
    Expect(0, 65022, '\p{Is_Script_Extensions=thaana}', "");
    Expect(1, 65022, '\p{^Is_Script_Extensions=thaana}', "");
    Expect(1, 65022, '\P{Is_Script_Extensions=thaana}', "");
    Expect(0, 65022, '\P{^Is_Script_Extensions=thaana}', "");
    Expect(1, 65021, '\p{Is_Script_Extensions=- thaana}', "");
    Expect(0, 65021, '\p{^Is_Script_Extensions=- thaana}', "");
    Expect(0, 65021, '\P{Is_Script_Extensions=- thaana}', "");
    Expect(1, 65021, '\P{^Is_Script_Extensions=- thaana}', "");
    Expect(0, 65022, '\p{Is_Script_Extensions=- thaana}', "");
    Expect(1, 65022, '\p{^Is_Script_Extensions=- thaana}', "");
    Expect(1, 65022, '\P{Is_Script_Extensions=- thaana}', "");
    Expect(0, 65022, '\P{^Is_Script_Extensions=- thaana}', "");
    Error('\p{Is_Scx=-_THAA/a/}');
    Error('\P{Is_Scx=-_THAA/a/}');
    Expect(1, 65021, '\p{Is_Scx=thaa}', "");
    Expect(0, 65021, '\p{^Is_Scx=thaa}', "");
    Expect(0, 65021, '\P{Is_Scx=thaa}', "");
    Expect(1, 65021, '\P{^Is_Scx=thaa}', "");
    Expect(0, 65022, '\p{Is_Scx=thaa}', "");
    Expect(1, 65022, '\p{^Is_Scx=thaa}', "");
    Expect(1, 65022, '\P{Is_Scx=thaa}', "");
    Expect(0, 65022, '\P{^Is_Scx=thaa}', "");
    Expect(1, 65021, '\p{Is_Scx:	-	Thaa}', "");
    Expect(0, 65021, '\p{^Is_Scx:	-	Thaa}', "");
    Expect(0, 65021, '\P{Is_Scx:	-	Thaa}', "");
    Expect(1, 65021, '\P{^Is_Scx:	-	Thaa}', "");
    Expect(0, 65022, '\p{Is_Scx:	-	Thaa}', "");
    Expect(1, 65022, '\p{^Is_Scx:	-	Thaa}', "");
    Expect(1, 65022, '\P{Is_Scx:	-	Thaa}', "");
    Expect(0, 65022, '\P{^Is_Scx:	-	Thaa}', "");
    Error('\p{Script_Extensions=__Thai/a/}');
    Error('\P{Script_Extensions=__Thai/a/}');
    Expect(1, 3675, '\p{Script_Extensions=:\AThai\z:}', "");;
    Expect(0, 3676, '\p{Script_Extensions=:\AThai\z:}', "");;
    Expect(1, 3675, '\p{Script_Extensions=thai}', "");
    Expect(0, 3675, '\p{^Script_Extensions=thai}', "");
    Expect(0, 3675, '\P{Script_Extensions=thai}', "");
    Expect(1, 3675, '\P{^Script_Extensions=thai}', "");
    Expect(0, 3676, '\p{Script_Extensions=thai}', "");
    Expect(1, 3676, '\p{^Script_Extensions=thai}', "");
    Expect(1, 3676, '\P{Script_Extensions=thai}', "");
    Expect(0, 3676, '\P{^Script_Extensions=thai}', "");
    Expect(1, 3675, '\p{Script_Extensions=:\Athai\z:}', "");;
    Expect(0, 3676, '\p{Script_Extensions=:\Athai\z:}', "");;
    Expect(1, 3675, '\p{Script_Extensions:__Thai}', "");
    Expect(0, 3675, '\p{^Script_Extensions:__Thai}', "");
    Expect(0, 3675, '\P{Script_Extensions:__Thai}', "");
    Expect(1, 3675, '\P{^Script_Extensions:__Thai}', "");
    Expect(0, 3676, '\p{Script_Extensions:__Thai}', "");
    Expect(1, 3676, '\p{^Script_Extensions:__Thai}', "");
    Expect(1, 3676, '\P{Script_Extensions:__Thai}', "");
    Expect(0, 3676, '\P{^Script_Extensions:__Thai}', "");
    Error('\p{Scx=	:=Thai}');
    Error('\P{Scx=	:=Thai}');
    Expect(1, 3675, '\p{Scx=:\AThai\z:}', "");;
    Expect(0, 3676, '\p{Scx=:\AThai\z:}', "");;
    Expect(1, 3675, '\p{Scx: thai}', "");
    Expect(0, 3675, '\p{^Scx: thai}', "");
    Expect(0, 3675, '\P{Scx: thai}', "");
    Expect(1, 3675, '\P{^Scx: thai}', "");
    Expect(0, 3676, '\p{Scx: thai}', "");
    Expect(1, 3676, '\p{^Scx: thai}', "");
    Expect(1, 3676, '\P{Scx: thai}', "");
    Expect(0, 3676, '\P{^Scx: thai}', "");
    Expect(1, 3675, '\p{Scx=:\Athai\z:}', "");;
    Expect(0, 3676, '\p{Scx=:\Athai\z:}', "");;
    Expect(1, 3675, '\p{Scx=-	THAI}', "");
    Expect(0, 3675, '\p{^Scx=-	THAI}', "");
    Expect(0, 3675, '\P{Scx=-	THAI}', "");
    Expect(1, 3675, '\P{^Scx=-	THAI}', "");
    Expect(0, 3676, '\p{Scx=-	THAI}', "");
    Expect(1, 3676, '\p{^Scx=-	THAI}', "");
    Expect(1, 3676, '\P{Scx=-	THAI}', "");
    Expect(0, 3676, '\P{^Scx=-	THAI}', "");
    Error('\p{Is_Script_Extensions=_	thai/a/}');
    Error('\P{Is_Script_Extensions=_	thai/a/}');
    Expect(1, 3675, '\p{Is_Script_Extensions=thai}', "");
    Expect(0, 3675, '\p{^Is_Script_Extensions=thai}', "");
    Expect(0, 3675, '\P{Is_Script_Extensions=thai}', "");
    Expect(1, 3675, '\P{^Is_Script_Extensions=thai}', "");
    Expect(0, 3676, '\p{Is_Script_Extensions=thai}', "");
    Expect(1, 3676, '\p{^Is_Script_Extensions=thai}', "");
    Expect(1, 3676, '\P{Is_Script_Extensions=thai}', "");
    Expect(0, 3676, '\P{^Is_Script_Extensions=thai}', "");
    Expect(1, 3675, '\p{Is_Script_Extensions= 	Thai}', "");
    Expect(0, 3675, '\p{^Is_Script_Extensions= 	Thai}', "");
    Expect(0, 3675, '\P{Is_Script_Extensions= 	Thai}', "");
    Expect(1, 3675, '\P{^Is_Script_Extensions= 	Thai}', "");
    Expect(0, 3676, '\p{Is_Script_Extensions= 	Thai}', "");
    Expect(1, 3676, '\p{^Is_Script_Extensions= 	Thai}', "");
    Expect(1, 3676, '\P{Is_Script_Extensions= 	Thai}', "");
    Expect(0, 3676, '\P{^Is_Script_Extensions= 	Thai}', "");
    Error('\p{Is_Scx: -_Thai/a/}');
    Error('\P{Is_Scx: -_Thai/a/}');
    Expect(1, 3675, '\p{Is_Scx=thai}', "");
    Expect(0, 3675, '\p{^Is_Scx=thai}', "");
    Expect(0, 3675, '\P{Is_Scx=thai}', "");
    Expect(1, 3675, '\P{^Is_Scx=thai}', "");
    Expect(0, 3676, '\p{Is_Scx=thai}', "");
    Expect(1, 3676, '\p{^Is_Scx=thai}', "");
    Expect(1, 3676, '\P{Is_Scx=thai}', "");
    Expect(0, 3676, '\P{^Is_Scx=thai}', "");
    Expect(1, 3675, '\p{Is_Scx=-_Thai}', "");
    Expect(0, 3675, '\p{^Is_Scx=-_Thai}', "");
    Expect(0, 3675, '\P{Is_Scx=-_Thai}', "");
    Expect(1, 3675, '\P{^Is_Scx=-_Thai}', "");
    Expect(0, 3676, '\p{Is_Scx=-_Thai}', "");
    Expect(1, 3676, '\p{^Is_Scx=-_Thai}', "");
    Expect(1, 3676, '\P{Is_Scx=-_Thai}', "");
    Expect(0, 3676, '\P{^Is_Scx=-_Thai}', "");
    Error('\p{Script_Extensions=:= -Tibetan}');
    Error('\P{Script_Extensions=:= -Tibetan}');
    Expect(1, 4058, '\p{Script_Extensions=:\ATibetan\z:}', "");;
    Expect(0, 4059, '\p{Script_Extensions=:\ATibetan\z:}', "");;
    Expect(1, 4058, '\p{Script_Extensions: tibetan}', "");
    Expect(0, 4058, '\p{^Script_Extensions: tibetan}', "");
    Expect(0, 4058, '\P{Script_Extensions: tibetan}', "");
    Expect(1, 4058, '\P{^Script_Extensions: tibetan}', "");
    Expect(0, 4059, '\p{Script_Extensions: tibetan}', "");
    Expect(1, 4059, '\p{^Script_Extensions: tibetan}', "");
    Expect(1, 4059, '\P{Script_Extensions: tibetan}', "");
    Expect(0, 4059, '\P{^Script_Extensions: tibetan}', "");
    Expect(1, 4058, '\p{Script_Extensions=:\Atibetan\z:}', "");;
    Expect(0, 4059, '\p{Script_Extensions=:\Atibetan\z:}', "");;
    Expect(1, 4058, '\p{Script_Extensions=__Tibetan}', "");
    Expect(0, 4058, '\p{^Script_Extensions=__Tibetan}', "");
    Expect(0, 4058, '\P{Script_Extensions=__Tibetan}', "");
    Expect(1, 4058, '\P{^Script_Extensions=__Tibetan}', "");
    Expect(0, 4059, '\p{Script_Extensions=__Tibetan}', "");
    Expect(1, 4059, '\p{^Script_Extensions=__Tibetan}', "");
    Expect(1, 4059, '\P{Script_Extensions=__Tibetan}', "");
    Expect(0, 4059, '\P{^Script_Extensions=__Tibetan}', "");
    Error('\p{Scx= Tibt:=}');
    Error('\P{Scx= Tibt:=}');
    Expect(1, 4058, '\p{Scx=:\ATibt\z:}', "");;
    Expect(0, 4059, '\p{Scx=:\ATibt\z:}', "");;
    Expect(1, 4058, '\p{Scx=tibt}', "");
    Expect(0, 4058, '\p{^Scx=tibt}', "");
    Expect(0, 4058, '\P{Scx=tibt}', "");
    Expect(1, 4058, '\P{^Scx=tibt}', "");
    Expect(0, 4059, '\p{Scx=tibt}', "");
    Expect(1, 4059, '\p{^Scx=tibt}', "");
    Expect(1, 4059, '\P{Scx=tibt}', "");
    Expect(0, 4059, '\P{^Scx=tibt}', "");
    Expect(1, 4058, '\p{Scx=:\Atibt\z:}', "");;
    Expect(0, 4059, '\p{Scx=:\Atibt\z:}', "");;
    Expect(1, 4058, '\p{Scx=	tibt}', "");
    Expect(0, 4058, '\p{^Scx=	tibt}', "");
    Expect(0, 4058, '\P{Scx=	tibt}', "");
    Expect(1, 4058, '\P{^Scx=	tibt}', "");
    Expect(0, 4059, '\p{Scx=	tibt}', "");
    Expect(1, 4059, '\p{^Scx=	tibt}', "");
    Expect(1, 4059, '\P{Scx=	tibt}', "");
    Expect(0, 4059, '\P{^Scx=	tibt}', "");
    Error('\p{Is_Script_Extensions=-/a/tibetan}');
    Error('\P{Is_Script_Extensions=-/a/tibetan}');
    Expect(1, 4058, '\p{Is_Script_Extensions=tibetan}', "");
    Expect(0, 4058, '\p{^Is_Script_Extensions=tibetan}', "");
    Expect(0, 4058, '\P{Is_Script_Extensions=tibetan}', "");
    Expect(1, 4058, '\P{^Is_Script_Extensions=tibetan}', "");
    Expect(0, 4059, '\p{Is_Script_Extensions=tibetan}', "");
    Expect(1, 4059, '\p{^Is_Script_Extensions=tibetan}', "");
    Expect(1, 4059, '\P{Is_Script_Extensions=tibetan}', "");
    Expect(0, 4059, '\P{^Is_Script_Extensions=tibetan}', "");
    Expect(1, 4058, '\p{Is_Script_Extensions=	Tibetan}', "");
    Expect(0, 4058, '\p{^Is_Script_Extensions=	Tibetan}', "");
    Expect(0, 4058, '\P{Is_Script_Extensions=	Tibetan}', "");
    Expect(1, 4058, '\P{^Is_Script_Extensions=	Tibetan}', "");
    Expect(0, 4059, '\p{Is_Script_Extensions=	Tibetan}', "");
    Expect(1, 4059, '\p{^Is_Script_Extensions=	Tibetan}', "");
    Expect(1, 4059, '\P{Is_Script_Extensions=	Tibetan}', "");
    Expect(0, 4059, '\P{^Is_Script_Extensions=	Tibetan}', "");
    Error('\p{Is_Scx=:=--TIBT}');
    Error('\P{Is_Scx=:=--TIBT}');
    Expect(1, 4058, '\p{Is_Scx=tibt}', "");
    Expect(0, 4058, '\p{^Is_Scx=tibt}', "");
    Expect(0, 4058, '\P{Is_Scx=tibt}', "");
    Expect(1, 4058, '\P{^Is_Scx=tibt}', "");
    Expect(0, 4059, '\p{Is_Scx=tibt}', "");
    Expect(1, 4059, '\p{^Is_Scx=tibt}', "");
    Expect(1, 4059, '\P{Is_Scx=tibt}', "");
    Expect(0, 4059, '\P{^Is_Scx=tibt}', "");
    Expect(1, 4058, '\p{Is_Scx=	Tibt}', "");
    Expect(0, 4058, '\p{^Is_Scx=	Tibt}', "");
    Expect(0, 4058, '\P{Is_Scx=	Tibt}', "");
    Expect(1, 4058, '\P{^Is_Scx=	Tibt}', "");
    Expect(0, 4059, '\p{Is_Scx=	Tibt}', "");
    Expect(1, 4059, '\p{^Is_Scx=	Tibt}', "");
    Expect(1, 4059, '\P{Is_Scx=	Tibt}', "");
    Expect(0, 4059, '\P{^Is_Scx=	Tibt}', "");
    Error('\p{Script_Extensions=-Tirhuta:=}');
    Error('\P{Script_Extensions=-Tirhuta:=}');
    Expect(1, 70873, '\p{Script_Extensions=:\ATirhuta\z:}', "");;
    Expect(0, 70874, '\p{Script_Extensions=:\ATirhuta\z:}', "");;
    Expect(1, 70873, '\p{Script_Extensions=tirhuta}', "");
    Expect(0, 70873, '\p{^Script_Extensions=tirhuta}', "");
    Expect(0, 70873, '\P{Script_Extensions=tirhuta}', "");
    Expect(1, 70873, '\P{^Script_Extensions=tirhuta}', "");
    Expect(0, 70874, '\p{Script_Extensions=tirhuta}', "");
    Expect(1, 70874, '\p{^Script_Extensions=tirhuta}', "");
    Expect(1, 70874, '\P{Script_Extensions=tirhuta}', "");
    Expect(0, 70874, '\P{^Script_Extensions=tirhuta}', "");
    Expect(1, 70873, '\p{Script_Extensions=:\Atirhuta\z:}', "");;
    Expect(0, 70874, '\p{Script_Extensions=:\Atirhuta\z:}', "");;
    Expect(1, 70873, '\p{Script_Extensions=	-Tirhuta}', "");
    Expect(0, 70873, '\p{^Script_Extensions=	-Tirhuta}', "");
    Expect(0, 70873, '\P{Script_Extensions=	-Tirhuta}', "");
    Expect(1, 70873, '\P{^Script_Extensions=	-Tirhuta}', "");
    Expect(0, 70874, '\p{Script_Extensions=	-Tirhuta}', "");
    Expect(1, 70874, '\p{^Script_Extensions=	-Tirhuta}', "");
    Expect(1, 70874, '\P{Script_Extensions=	-Tirhuta}', "");
    Expect(0, 70874, '\P{^Script_Extensions=	-Tirhuta}', "");
    Error('\p{Scx=_:=TIRH}');
    Error('\P{Scx=_:=TIRH}');
    Expect(1, 70873, '\p{Scx=:\ATirh\z:}', "");;
    Expect(0, 70874, '\p{Scx=:\ATirh\z:}', "");;
    Expect(1, 70873, '\p{Scx=tirh}', "");
    Expect(0, 70873, '\p{^Scx=tirh}', "");
    Expect(0, 70873, '\P{Scx=tirh}', "");
    Expect(1, 70873, '\P{^Scx=tirh}', "");
    Expect(0, 70874, '\p{Scx=tirh}', "");
    Expect(1, 70874, '\p{^Scx=tirh}', "");
    Expect(1, 70874, '\P{Scx=tirh}', "");
    Expect(0, 70874, '\P{^Scx=tirh}', "");
    Expect(1, 70873, '\p{Scx=:\Atirh\z:}', "");;
    Expect(0, 70874, '\p{Scx=:\Atirh\z:}', "");;
    Expect(1, 70873, '\p{Scx=Tirh}', "");
    Expect(0, 70873, '\p{^Scx=Tirh}', "");
    Expect(0, 70873, '\P{Scx=Tirh}', "");
    Expect(1, 70873, '\P{^Scx=Tirh}', "");
    Expect(0, 70874, '\p{Scx=Tirh}', "");
    Expect(1, 70874, '\p{^Scx=Tirh}', "");
    Expect(1, 70874, '\P{Scx=Tirh}', "");
    Expect(0, 70874, '\P{^Scx=Tirh}', "");
    Error('\p{Is_Script_Extensions=:= -Tirhuta}');
    Error('\P{Is_Script_Extensions=:= -Tirhuta}');
    Expect(1, 70873, '\p{Is_Script_Extensions=tirhuta}', "");
    Expect(0, 70873, '\p{^Is_Script_Extensions=tirhuta}', "");
    Expect(0, 70873, '\P{Is_Script_Extensions=tirhuta}', "");
    Expect(1, 70873, '\P{^Is_Script_Extensions=tirhuta}', "");
    Expect(0, 70874, '\p{Is_Script_Extensions=tirhuta}', "");
    Expect(1, 70874, '\p{^Is_Script_Extensions=tirhuta}', "");
    Expect(1, 70874, '\P{Is_Script_Extensions=tirhuta}', "");
    Expect(0, 70874, '\P{^Is_Script_Extensions=tirhuta}', "");
    Expect(1, 70873, '\p{Is_Script_Extensions=-	Tirhuta}', "");
    Expect(0, 70873, '\p{^Is_Script_Extensions=-	Tirhuta}', "");
    Expect(0, 70873, '\P{Is_Script_Extensions=-	Tirhuta}', "");
    Expect(1, 70873, '\P{^Is_Script_Extensions=-	Tirhuta}', "");
    Expect(0, 70874, '\p{Is_Script_Extensions=-	Tirhuta}', "");
    Expect(1, 70874, '\p{^Is_Script_Extensions=-	Tirhuta}', "");
    Expect(1, 70874, '\P{Is_Script_Extensions=-	Tirhuta}', "");
    Expect(0, 70874, '\P{^Is_Script_Extensions=-	Tirhuta}', "");
    Error('\p{Is_Scx:		 Tirh/a/}');
    Error('\P{Is_Scx:		 Tirh/a/}');
    Expect(1, 70873, '\p{Is_Scx=tirh}', "");
    Expect(0, 70873, '\p{^Is_Scx=tirh}', "");
    Expect(0, 70873, '\P{Is_Scx=tirh}', "");
    Expect(1, 70873, '\P{^Is_Scx=tirh}', "");
    Expect(0, 70874, '\p{Is_Scx=tirh}', "");
    Expect(1, 70874, '\p{^Is_Scx=tirh}', "");
    Expect(1, 70874, '\P{Is_Scx=tirh}', "");
    Expect(0, 70874, '\P{^Is_Scx=tirh}', "");
    Expect(1, 70873, '\p{Is_Scx=_ tirh}', "");
    Expect(0, 70873, '\p{^Is_Scx=_ tirh}', "");
    Expect(0, 70873, '\P{Is_Scx=_ tirh}', "");
    Expect(1, 70873, '\P{^Is_Scx=_ tirh}', "");
    Expect(0, 70874, '\p{Is_Scx=_ tirh}', "");
    Expect(1, 70874, '\p{^Is_Scx=_ tirh}', "");
    Expect(1, 70874, '\P{Is_Scx=_ tirh}', "");
    Expect(0, 70874, '\P{^Is_Scx=_ tirh}', "");
    Error('\p{Script_Extensions=/a/ 	UGARITIC}');
    Error('\P{Script_Extensions=/a/ 	UGARITIC}');
    Expect(1, 66463, '\p{Script_Extensions=:\AUgaritic\z:}', "");;
    Expect(0, 66464, '\p{Script_Extensions=:\AUgaritic\z:}', "");;
    Expect(1, 66463, '\p{Script_Extensions=ugaritic}', "");
    Expect(0, 66463, '\p{^Script_Extensions=ugaritic}', "");
    Expect(0, 66463, '\P{Script_Extensions=ugaritic}', "");
    Expect(1, 66463, '\P{^Script_Extensions=ugaritic}', "");
    Expect(0, 66464, '\p{Script_Extensions=ugaritic}', "");
    Expect(1, 66464, '\p{^Script_Extensions=ugaritic}', "");
    Expect(1, 66464, '\P{Script_Extensions=ugaritic}', "");
    Expect(0, 66464, '\P{^Script_Extensions=ugaritic}', "");
    Expect(1, 66463, '\p{Script_Extensions=:\Augaritic\z:}', "");;
    Expect(0, 66464, '\p{Script_Extensions=:\Augaritic\z:}', "");;
    Expect(1, 66463, '\p{Script_Extensions= 	ugaritic}', "");
    Expect(0, 66463, '\p{^Script_Extensions= 	ugaritic}', "");
    Expect(0, 66463, '\P{Script_Extensions= 	ugaritic}', "");
    Expect(1, 66463, '\P{^Script_Extensions= 	ugaritic}', "");
    Expect(0, 66464, '\p{Script_Extensions= 	ugaritic}', "");
    Expect(1, 66464, '\p{^Script_Extensions= 	ugaritic}', "");
    Expect(1, 66464, '\P{Script_Extensions= 	ugaritic}', "");
    Expect(0, 66464, '\P{^Script_Extensions= 	ugaritic}', "");
    Error('\p{Scx=-	UGAR:=}');
    Error('\P{Scx=-	UGAR:=}');
    Expect(1, 66463, '\p{Scx=:\AUgar\z:}', "");;
    Expect(0, 66464, '\p{Scx=:\AUgar\z:}', "");;
    Expect(1, 66463, '\p{Scx=ugar}', "");
    Expect(0, 66463, '\p{^Scx=ugar}', "");
    Expect(0, 66463, '\P{Scx=ugar}', "");
    Expect(1, 66463, '\P{^Scx=ugar}', "");
    Expect(0, 66464, '\p{Scx=ugar}', "");
    Expect(1, 66464, '\p{^Scx=ugar}', "");
    Expect(1, 66464, '\P{Scx=ugar}', "");
    Expect(0, 66464, '\P{^Scx=ugar}', "");
    Expect(1, 66463, '\p{Scx=:\Augar\z:}', "");;
    Expect(0, 66464, '\p{Scx=:\Augar\z:}', "");;
    Expect(1, 66463, '\p{Scx=__Ugar}', "");
    Expect(0, 66463, '\p{^Scx=__Ugar}', "");
    Expect(0, 66463, '\P{Scx=__Ugar}', "");
    Expect(1, 66463, '\P{^Scx=__Ugar}', "");
    Expect(0, 66464, '\p{Scx=__Ugar}', "");
    Expect(1, 66464, '\p{^Scx=__Ugar}', "");
    Expect(1, 66464, '\P{Scx=__Ugar}', "");
    Expect(0, 66464, '\P{^Scx=__Ugar}', "");
    Error('\p{Is_Script_Extensions=/a/Ugaritic}');
    Error('\P{Is_Script_Extensions=/a/Ugaritic}');
    Expect(1, 66463, '\p{Is_Script_Extensions=ugaritic}', "");
    Expect(0, 66463, '\p{^Is_Script_Extensions=ugaritic}', "");
    Expect(0, 66463, '\P{Is_Script_Extensions=ugaritic}', "");
    Expect(1, 66463, '\P{^Is_Script_Extensions=ugaritic}', "");
    Expect(0, 66464, '\p{Is_Script_Extensions=ugaritic}', "");
    Expect(1, 66464, '\p{^Is_Script_Extensions=ugaritic}', "");
    Expect(1, 66464, '\P{Is_Script_Extensions=ugaritic}', "");
    Expect(0, 66464, '\P{^Is_Script_Extensions=ugaritic}', "");
    Expect(1, 66463, '\p{Is_Script_Extensions= -ugaritic}', "");
    Expect(0, 66463, '\p{^Is_Script_Extensions= -ugaritic}', "");
    Expect(0, 66463, '\P{Is_Script_Extensions= -ugaritic}', "");
    Expect(1, 66463, '\P{^Is_Script_Extensions= -ugaritic}', "");
    Expect(0, 66464, '\p{Is_Script_Extensions= -ugaritic}', "");
    Expect(1, 66464, '\p{^Is_Script_Extensions= -ugaritic}', "");
    Expect(1, 66464, '\P{Is_Script_Extensions= -ugaritic}', "");
    Expect(0, 66464, '\P{^Is_Script_Extensions= -ugaritic}', "");
    Error('\p{Is_Scx=:=-Ugar}');
    Error('\P{Is_Scx=:=-Ugar}');
    Expect(1, 66463, '\p{Is_Scx=ugar}', "");
    Expect(0, 66463, '\p{^Is_Scx=ugar}', "");
    Expect(0, 66463, '\P{Is_Scx=ugar}', "");
    Expect(1, 66463, '\P{^Is_Scx=ugar}', "");
    Expect(0, 66464, '\p{Is_Scx=ugar}', "");
    Expect(1, 66464, '\p{^Is_Scx=ugar}', "");
    Expect(1, 66464, '\P{Is_Scx=ugar}', "");
    Expect(0, 66464, '\P{^Is_Scx=ugar}', "");
    Expect(1, 66463, '\p{Is_Scx= -Ugar}', "");
    Expect(0, 66463, '\p{^Is_Scx= -Ugar}', "");
    Expect(0, 66463, '\P{Is_Scx= -Ugar}', "");
    Expect(1, 66463, '\P{^Is_Scx= -Ugar}', "");
    Expect(0, 66464, '\p{Is_Scx= -Ugar}', "");
    Expect(1, 66464, '\p{^Is_Scx= -Ugar}', "");
    Expect(1, 66464, '\P{Is_Scx= -Ugar}', "");
    Expect(0, 66464, '\P{^Is_Scx= -Ugar}', "");
    Error('\p{Script_Extensions=--Vai:=}');
    Error('\P{Script_Extensions=--Vai:=}');
    Expect(1, 42539, '\p{Script_Extensions=:\AVai\z:}', "");;
    Expect(0, 42540, '\p{Script_Extensions=:\AVai\z:}', "");;
    Expect(1, 42539, '\p{Script_Extensions=vai}', "");
    Expect(0, 42539, '\p{^Script_Extensions=vai}', "");
    Expect(0, 42539, '\P{Script_Extensions=vai}', "");
    Expect(1, 42539, '\P{^Script_Extensions=vai}', "");
    Expect(0, 42540, '\p{Script_Extensions=vai}', "");
    Expect(1, 42540, '\p{^Script_Extensions=vai}', "");
    Expect(1, 42540, '\P{Script_Extensions=vai}', "");
    Expect(0, 42540, '\P{^Script_Extensions=vai}', "");
    Expect(1, 42539, '\p{Script_Extensions=:\Avai\z:}', "");;
    Expect(0, 42540, '\p{Script_Extensions=:\Avai\z:}', "");;
    Expect(1, 42539, '\p{Script_Extensions=-vai}', "");
    Expect(0, 42539, '\p{^Script_Extensions=-vai}', "");
    Expect(0, 42539, '\P{Script_Extensions=-vai}', "");
    Expect(1, 42539, '\P{^Script_Extensions=-vai}', "");
    Expect(0, 42540, '\p{Script_Extensions=-vai}', "");
    Expect(1, 42540, '\p{^Script_Extensions=-vai}', "");
    Expect(1, 42540, '\P{Script_Extensions=-vai}', "");
    Expect(0, 42540, '\P{^Script_Extensions=-vai}', "");
    Error('\p{Scx=-VAII:=}');
    Error('\P{Scx=-VAII:=}');
    Expect(1, 42539, '\p{Scx=:\AVaii\z:}', "");;
    Expect(0, 42540, '\p{Scx=:\AVaii\z:}', "");;
    Expect(1, 42539, '\p{Scx=vaii}', "");
    Expect(0, 42539, '\p{^Scx=vaii}', "");
    Expect(0, 42539, '\P{Scx=vaii}', "");
    Expect(1, 42539, '\P{^Scx=vaii}', "");
    Expect(0, 42540, '\p{Scx=vaii}', "");
    Expect(1, 42540, '\p{^Scx=vaii}', "");
    Expect(1, 42540, '\P{Scx=vaii}', "");
    Expect(0, 42540, '\P{^Scx=vaii}', "");
    Expect(1, 42539, '\p{Scx=:\Avaii\z:}', "");;
    Expect(0, 42540, '\p{Scx=:\Avaii\z:}', "");;
    Expect(1, 42539, '\p{Scx= Vaii}', "");
    Expect(0, 42539, '\p{^Scx= Vaii}', "");
    Expect(0, 42539, '\P{Scx= Vaii}', "");
    Expect(1, 42539, '\P{^Scx= Vaii}', "");
    Expect(0, 42540, '\p{Scx= Vaii}', "");
    Expect(1, 42540, '\p{^Scx= Vaii}', "");
    Expect(1, 42540, '\P{Scx= Vaii}', "");
    Expect(0, 42540, '\P{^Scx= Vaii}', "");
    Error('\p{Is_Script_Extensions=:=Vai}');
    Error('\P{Is_Script_Extensions=:=Vai}');
    Expect(1, 42539, '\p{Is_Script_Extensions=vai}', "");
    Expect(0, 42539, '\p{^Is_Script_Extensions=vai}', "");
    Expect(0, 42539, '\P{Is_Script_Extensions=vai}', "");
    Expect(1, 42539, '\P{^Is_Script_Extensions=vai}', "");
    Expect(0, 42540, '\p{Is_Script_Extensions=vai}', "");
    Expect(1, 42540, '\p{^Is_Script_Extensions=vai}', "");
    Expect(1, 42540, '\P{Is_Script_Extensions=vai}', "");
    Expect(0, 42540, '\P{^Is_Script_Extensions=vai}', "");
    Expect(1, 42539, '\p{Is_Script_Extensions=_-vai}', "");
    Expect(0, 42539, '\p{^Is_Script_Extensions=_-vai}', "");
    Expect(0, 42539, '\P{Is_Script_Extensions=_-vai}', "");
    Expect(1, 42539, '\P{^Is_Script_Extensions=_-vai}', "");
    Expect(0, 42540, '\p{Is_Script_Extensions=_-vai}', "");
    Expect(1, 42540, '\p{^Is_Script_Extensions=_-vai}', "");
    Expect(1, 42540, '\P{Is_Script_Extensions=_-vai}', "");
    Expect(0, 42540, '\P{^Is_Script_Extensions=_-vai}', "");
    Error('\p{Is_Scx=	-Vaii/a/}');
    Error('\P{Is_Scx=	-Vaii/a/}');
    Expect(1, 42539, '\p{Is_Scx=vaii}', "");
    Expect(0, 42539, '\p{^Is_Scx=vaii}', "");
    Expect(0, 42539, '\P{Is_Scx=vaii}', "");
    Expect(1, 42539, '\P{^Is_Scx=vaii}', "");
    Expect(0, 42540, '\p{Is_Scx=vaii}', "");
    Expect(1, 42540, '\p{^Is_Scx=vaii}', "");
    Expect(1, 42540, '\P{Is_Scx=vaii}', "");
    Expect(0, 42540, '\P{^Is_Scx=vaii}', "");
    Expect(1, 42539, '\p{Is_Scx=_VAII}', "");
    Expect(0, 42539, '\p{^Is_Scx=_VAII}', "");
    Expect(0, 42539, '\P{Is_Scx=_VAII}', "");
    Expect(1, 42539, '\P{^Is_Scx=_VAII}', "");
    Expect(0, 42540, '\p{Is_Scx=_VAII}', "");
    Expect(1, 42540, '\p{^Is_Scx=_VAII}', "");
    Expect(1, 42540, '\P{Is_Scx=_VAII}', "");
    Expect(0, 42540, '\P{^Is_Scx=_VAII}', "");
    Error('\p{Script_Extensions=	 Warang_Citi:=}');
    Error('\P{Script_Extensions=	 Warang_Citi:=}');
    Expect(1, 71935, '\p{Script_Extensions=:\AWarang_Citi\z:}', "");;
    Expect(0, 71936, '\p{Script_Extensions=:\AWarang_Citi\z:}', "");;
    Expect(1, 71935, '\p{Script_Extensions=warangciti}', "");
    Expect(0, 71935, '\p{^Script_Extensions=warangciti}', "");
    Expect(0, 71935, '\P{Script_Extensions=warangciti}', "");
    Expect(1, 71935, '\P{^Script_Extensions=warangciti}', "");
    Expect(0, 71936, '\p{Script_Extensions=warangciti}', "");
    Expect(1, 71936, '\p{^Script_Extensions=warangciti}', "");
    Expect(1, 71936, '\P{Script_Extensions=warangciti}', "");
    Expect(0, 71936, '\P{^Script_Extensions=warangciti}', "");
    Expect(1, 71935, '\p{Script_Extensions=:\Awarangciti\z:}', "");;
    Expect(0, 71936, '\p{Script_Extensions=:\Awarangciti\z:}', "");;
    Expect(1, 71935, '\p{Script_Extensions= WARANG_Citi}', "");
    Expect(0, 71935, '\p{^Script_Extensions= WARANG_Citi}', "");
    Expect(0, 71935, '\P{Script_Extensions= WARANG_Citi}', "");
    Expect(1, 71935, '\P{^Script_Extensions= WARANG_Citi}', "");
    Expect(0, 71936, '\p{Script_Extensions= WARANG_Citi}', "");
    Expect(1, 71936, '\p{^Script_Extensions= WARANG_Citi}', "");
    Expect(1, 71936, '\P{Script_Extensions= WARANG_Citi}', "");
    Expect(0, 71936, '\P{^Script_Extensions= WARANG_Citi}', "");
    Error('\p{Scx=-	WARA/a/}');
    Error('\P{Scx=-	WARA/a/}');
    Expect(1, 71935, '\p{Scx=:\AWara\z:}', "");;
    Expect(0, 71936, '\p{Scx=:\AWara\z:}', "");;
    Expect(1, 71935, '\p{Scx:   wara}', "");
    Expect(0, 71935, '\p{^Scx:   wara}', "");
    Expect(0, 71935, '\P{Scx:   wara}', "");
    Expect(1, 71935, '\P{^Scx:   wara}', "");
    Expect(0, 71936, '\p{Scx:   wara}', "");
    Expect(1, 71936, '\p{^Scx:   wara}', "");
    Expect(1, 71936, '\P{Scx:   wara}', "");
    Expect(0, 71936, '\P{^Scx:   wara}', "");
    Expect(1, 71935, '\p{Scx=:\Awara\z:}', "");;
    Expect(0, 71936, '\p{Scx=:\Awara\z:}', "");;
    Expect(1, 71935, '\p{Scx=- Wara}', "");
    Expect(0, 71935, '\p{^Scx=- Wara}', "");
    Expect(0, 71935, '\P{Scx=- Wara}', "");
    Expect(1, 71935, '\P{^Scx=- Wara}', "");
    Expect(0, 71936, '\p{Scx=- Wara}', "");
    Expect(1, 71936, '\p{^Scx=- Wara}', "");
    Expect(1, 71936, '\P{Scx=- Wara}', "");
    Expect(0, 71936, '\P{^Scx=- Wara}', "");
    Error('\p{Is_Script_Extensions=/a/_warang_citi}');
    Error('\P{Is_Script_Extensions=/a/_warang_citi}');
    Expect(1, 71935, '\p{Is_Script_Extensions=warangciti}', "");
    Expect(0, 71935, '\p{^Is_Script_Extensions=warangciti}', "");
    Expect(0, 71935, '\P{Is_Script_Extensions=warangciti}', "");
    Expect(1, 71935, '\P{^Is_Script_Extensions=warangciti}', "");
    Expect(0, 71936, '\p{Is_Script_Extensions=warangciti}', "");
    Expect(1, 71936, '\p{^Is_Script_Extensions=warangciti}', "");
    Expect(1, 71936, '\P{Is_Script_Extensions=warangciti}', "");
    Expect(0, 71936, '\P{^Is_Script_Extensions=warangciti}', "");
    Expect(1, 71935, '\p{Is_Script_Extensions=__WARANG_Citi}', "");
    Expect(0, 71935, '\p{^Is_Script_Extensions=__WARANG_Citi}', "");
    Expect(0, 71935, '\P{Is_Script_Extensions=__WARANG_Citi}', "");
    Expect(1, 71935, '\P{^Is_Script_Extensions=__WARANG_Citi}', "");
    Expect(0, 71936, '\p{Is_Script_Extensions=__WARANG_Citi}', "");
    Expect(1, 71936, '\p{^Is_Script_Extensions=__WARANG_Citi}', "");
    Expect(1, 71936, '\P{Is_Script_Extensions=__WARANG_Citi}', "");
    Expect(0, 71936, '\P{^Is_Script_Extensions=__WARANG_Citi}', "");
    Error('\p{Is_Scx:	-Wara/a/}');
    Error('\P{Is_Scx:	-Wara/a/}');
    Expect(1, 71935, '\p{Is_Scx=wara}', "");
    Expect(0, 71935, '\p{^Is_Scx=wara}', "");
    Expect(0, 71935, '\P{Is_Scx=wara}', "");
    Expect(1, 71935, '\P{^Is_Scx=wara}', "");
    Expect(0, 71936, '\p{Is_Scx=wara}', "");
    Expect(1, 71936, '\p{^Is_Scx=wara}', "");
    Expect(1, 71936, '\P{Is_Scx=wara}', "");
    Expect(0, 71936, '\P{^Is_Scx=wara}', "");
    Expect(1, 71935, '\p{Is_Scx=	-WARA}', "");
    Expect(0, 71935, '\p{^Is_Scx=	-WARA}', "");
    Expect(0, 71935, '\P{Is_Scx=	-WARA}', "");
    Expect(1, 71935, '\P{^Is_Scx=	-WARA}', "");
    Expect(0, 71936, '\p{Is_Scx=	-WARA}', "");
    Expect(1, 71936, '\p{^Is_Scx=	-WARA}', "");
    Expect(1, 71936, '\P{Is_Scx=	-WARA}', "");
    Expect(0, 71936, '\P{^Is_Scx=	-WARA}', "");
    Error('\p{Script_Extensions=-Wancho/a/}');
    Error('\P{Script_Extensions=-Wancho/a/}');
    Expect(1, 123647, '\p{Script_Extensions=:\AWancho\z:}', "");;
    Expect(0, 123648, '\p{Script_Extensions=:\AWancho\z:}', "");;
    Expect(1, 123647, '\p{Script_Extensions:	wancho}', "");
    Expect(0, 123647, '\p{^Script_Extensions:	wancho}', "");
    Expect(0, 123647, '\P{Script_Extensions:	wancho}', "");
    Expect(1, 123647, '\P{^Script_Extensions:	wancho}', "");
    Expect(0, 123648, '\p{Script_Extensions:	wancho}', "");
    Expect(1, 123648, '\p{^Script_Extensions:	wancho}', "");
    Expect(1, 123648, '\P{Script_Extensions:	wancho}', "");
    Expect(0, 123648, '\P{^Script_Extensions:	wancho}', "");
    Expect(1, 123647, '\p{Script_Extensions=:\Awancho\z:}', "");;
    Expect(0, 123648, '\p{Script_Extensions=:\Awancho\z:}', "");;
    Expect(1, 123647, '\p{Script_Extensions=--Wancho}', "");
    Expect(0, 123647, '\p{^Script_Extensions=--Wancho}', "");
    Expect(0, 123647, '\P{Script_Extensions=--Wancho}', "");
    Expect(1, 123647, '\P{^Script_Extensions=--Wancho}', "");
    Expect(0, 123648, '\p{Script_Extensions=--Wancho}', "");
    Expect(1, 123648, '\p{^Script_Extensions=--Wancho}', "");
    Expect(1, 123648, '\P{Script_Extensions=--Wancho}', "");
    Expect(0, 123648, '\P{^Script_Extensions=--Wancho}', "");
    Error('\p{Scx=:= wcho}');
    Error('\P{Scx=:= wcho}');
    Expect(1, 123647, '\p{Scx=:\AWcho\z:}', "");;
    Expect(0, 123648, '\p{Scx=:\AWcho\z:}', "");;
    Expect(1, 123647, '\p{Scx: wcho}', "");
    Expect(0, 123647, '\p{^Scx: wcho}', "");
    Expect(0, 123647, '\P{Scx: wcho}', "");
    Expect(1, 123647, '\P{^Scx: wcho}', "");
    Expect(0, 123648, '\p{Scx: wcho}', "");
    Expect(1, 123648, '\p{^Scx: wcho}', "");
    Expect(1, 123648, '\P{Scx: wcho}', "");
    Expect(0, 123648, '\P{^Scx: wcho}', "");
    Expect(1, 123647, '\p{Scx=:\Awcho\z:}', "");;
    Expect(0, 123648, '\p{Scx=:\Awcho\z:}', "");;
    Expect(1, 123647, '\p{Scx=_ Wcho}', "");
    Expect(0, 123647, '\p{^Scx=_ Wcho}', "");
    Expect(0, 123647, '\P{Scx=_ Wcho}', "");
    Expect(1, 123647, '\P{^Scx=_ Wcho}', "");
    Expect(0, 123648, '\p{Scx=_ Wcho}', "");
    Expect(1, 123648, '\p{^Scx=_ Wcho}', "");
    Expect(1, 123648, '\P{Scx=_ Wcho}', "");
    Expect(0, 123648, '\P{^Scx=_ Wcho}', "");
    Error('\p{Is_Script_Extensions=/a/__Wancho}');
    Error('\P{Is_Script_Extensions=/a/__Wancho}');
    Expect(1, 123647, '\p{Is_Script_Extensions: wancho}', "");
    Expect(0, 123647, '\p{^Is_Script_Extensions: wancho}', "");
    Expect(0, 123647, '\P{Is_Script_Extensions: wancho}', "");
    Expect(1, 123647, '\P{^Is_Script_Extensions: wancho}', "");
    Expect(0, 123648, '\p{Is_Script_Extensions: wancho}', "");
    Expect(1, 123648, '\p{^Is_Script_Extensions: wancho}', "");
    Expect(1, 123648, '\P{Is_Script_Extensions: wancho}', "");
    Expect(0, 123648, '\P{^Is_Script_Extensions: wancho}', "");
    Expect(1, 123647, '\p{Is_Script_Extensions=	 wancho}', "");
    Expect(0, 123647, '\p{^Is_Script_Extensions=	 wancho}', "");
    Expect(0, 123647, '\P{Is_Script_Extensions=	 wancho}', "");
    Expect(1, 123647, '\P{^Is_Script_Extensions=	 wancho}', "");
    Expect(0, 123648, '\p{Is_Script_Extensions=	 wancho}', "");
    Expect(1, 123648, '\p{^Is_Script_Extensions=	 wancho}', "");
    Expect(1, 123648, '\P{Is_Script_Extensions=	 wancho}', "");
    Expect(0, 123648, '\P{^Is_Script_Extensions=	 wancho}', "");
    Error('\p{Is_Scx=/a/__WCHO}');
    Error('\P{Is_Scx=/a/__WCHO}');
    Expect(1, 123647, '\p{Is_Scx=wcho}', "");
    Expect(0, 123647, '\p{^Is_Scx=wcho}', "");
    Expect(0, 123647, '\P{Is_Scx=wcho}', "");
    Expect(1, 123647, '\P{^Is_Scx=wcho}', "");
    Expect(0, 123648, '\p{Is_Scx=wcho}', "");
    Expect(1, 123648, '\p{^Is_Scx=wcho}', "");
    Expect(1, 123648, '\P{Is_Scx=wcho}', "");
    Expect(0, 123648, '\P{^Is_Scx=wcho}', "");
    Expect(1, 123647, '\p{Is_Scx=_wcho}', "");
    Expect(0, 123647, '\p{^Is_Scx=_wcho}', "");
    Expect(0, 123647, '\P{Is_Scx=_wcho}', "");
    Expect(1, 123647, '\P{^Is_Scx=_wcho}', "");
    Expect(0, 123648, '\p{Is_Scx=_wcho}', "");
    Expect(1, 123648, '\p{^Is_Scx=_wcho}', "");
    Expect(1, 123648, '\P{Is_Scx=_wcho}', "");
    Expect(0, 123648, '\P{^Is_Scx=_wcho}', "");
    Error('\p{Script_Extensions: _	OLD_Persian/a/}');
    Error('\P{Script_Extensions: _	OLD_Persian/a/}');
    Expect(1, 66517, '\p{Script_Extensions=:\AOld_Persian\z:}', "");;
    Expect(0, 66518, '\p{Script_Extensions=:\AOld_Persian\z:}', "");;
    Expect(1, 66517, '\p{Script_Extensions=oldpersian}', "");
    Expect(0, 66517, '\p{^Script_Extensions=oldpersian}', "");
    Expect(0, 66517, '\P{Script_Extensions=oldpersian}', "");
    Expect(1, 66517, '\P{^Script_Extensions=oldpersian}', "");
    Expect(0, 66518, '\p{Script_Extensions=oldpersian}', "");
    Expect(1, 66518, '\p{^Script_Extensions=oldpersian}', "");
    Expect(1, 66518, '\P{Script_Extensions=oldpersian}', "");
    Expect(0, 66518, '\P{^Script_Extensions=oldpersian}', "");
    Expect(1, 66517, '\p{Script_Extensions=:\Aoldpersian\z:}', "");;
    Expect(0, 66518, '\p{Script_Extensions=:\Aoldpersian\z:}', "");;
    Expect(1, 66517, '\p{Script_Extensions= old_PERSIAN}', "");
    Expect(0, 66517, '\p{^Script_Extensions= old_PERSIAN}', "");
    Expect(0, 66517, '\P{Script_Extensions= old_PERSIAN}', "");
    Expect(1, 66517, '\P{^Script_Extensions= old_PERSIAN}', "");
    Expect(0, 66518, '\p{Script_Extensions= old_PERSIAN}', "");
    Expect(1, 66518, '\p{^Script_Extensions= old_PERSIAN}', "");
    Expect(1, 66518, '\P{Script_Extensions= old_PERSIAN}', "");
    Expect(0, 66518, '\P{^Script_Extensions= old_PERSIAN}', "");
    Error('\p{Scx=:= -Xpeo}');
    Error('\P{Scx=:= -Xpeo}');
    Expect(1, 66517, '\p{Scx=:\AXpeo\z:}', "");;
    Expect(0, 66518, '\p{Scx=:\AXpeo\z:}', "");;
    Expect(1, 66517, '\p{Scx=xpeo}', "");
    Expect(0, 66517, '\p{^Scx=xpeo}', "");
    Expect(0, 66517, '\P{Scx=xpeo}', "");
    Expect(1, 66517, '\P{^Scx=xpeo}', "");
    Expect(0, 66518, '\p{Scx=xpeo}', "");
    Expect(1, 66518, '\p{^Scx=xpeo}', "");
    Expect(1, 66518, '\P{Scx=xpeo}', "");
    Expect(0, 66518, '\P{^Scx=xpeo}', "");
    Expect(1, 66517, '\p{Scx=:\Axpeo\z:}', "");;
    Expect(0, 66518, '\p{Scx=:\Axpeo\z:}', "");;
    Expect(1, 66517, '\p{Scx=-Xpeo}', "");
    Expect(0, 66517, '\p{^Scx=-Xpeo}', "");
    Expect(0, 66517, '\P{Scx=-Xpeo}', "");
    Expect(1, 66517, '\P{^Scx=-Xpeo}', "");
    Expect(0, 66518, '\p{Scx=-Xpeo}', "");
    Expect(1, 66518, '\p{^Scx=-Xpeo}', "");
    Expect(1, 66518, '\P{Scx=-Xpeo}', "");
    Expect(0, 66518, '\P{^Scx=-Xpeo}', "");
    Error('\p{Is_Script_Extensions=_:=old_Persian}');
    Error('\P{Is_Script_Extensions=_:=old_Persian}');
    Expect(1, 66517, '\p{Is_Script_Extensions=oldpersian}', "");
    Expect(0, 66517, '\p{^Is_Script_Extensions=oldpersian}', "");
    Expect(0, 66517, '\P{Is_Script_Extensions=oldpersian}', "");
    Expect(1, 66517, '\P{^Is_Script_Extensions=oldpersian}', "");
    Expect(0, 66518, '\p{Is_Script_Extensions=oldpersian}', "");
    Expect(1, 66518, '\p{^Is_Script_Extensions=oldpersian}', "");
    Expect(1, 66518, '\P{Is_Script_Extensions=oldpersian}', "");
    Expect(0, 66518, '\P{^Is_Script_Extensions=oldpersian}', "");
    Expect(1, 66517, '\p{Is_Script_Extensions= OLD_persian}', "");
    Expect(0, 66517, '\p{^Is_Script_Extensions= OLD_persian}', "");
    Expect(0, 66517, '\P{Is_Script_Extensions= OLD_persian}', "");
    Expect(1, 66517, '\P{^Is_Script_Extensions= OLD_persian}', "");
    Expect(0, 66518, '\p{Is_Script_Extensions= OLD_persian}', "");
    Expect(1, 66518, '\p{^Is_Script_Extensions= OLD_persian}', "");
    Expect(1, 66518, '\P{Is_Script_Extensions= OLD_persian}', "");
    Expect(0, 66518, '\P{^Is_Script_Extensions= OLD_persian}', "");
    Error('\p{Is_Scx= Xpeo:=}');
    Error('\P{Is_Scx= Xpeo:=}');
    Expect(1, 66517, '\p{Is_Scx=xpeo}', "");
    Expect(0, 66517, '\p{^Is_Scx=xpeo}', "");
    Expect(0, 66517, '\P{Is_Scx=xpeo}', "");
    Expect(1, 66517, '\P{^Is_Scx=xpeo}', "");
    Expect(0, 66518, '\p{Is_Scx=xpeo}', "");
    Expect(1, 66518, '\p{^Is_Scx=xpeo}', "");
    Expect(1, 66518, '\P{Is_Scx=xpeo}', "");
    Expect(0, 66518, '\P{^Is_Scx=xpeo}', "");
    Expect(1, 66517, '\p{Is_Scx=-_Xpeo}', "");
    Expect(0, 66517, '\p{^Is_Scx=-_Xpeo}', "");
    Expect(0, 66517, '\P{Is_Scx=-_Xpeo}', "");
    Expect(1, 66517, '\P{^Is_Scx=-_Xpeo}', "");
    Expect(0, 66518, '\p{Is_Scx=-_Xpeo}', "");
    Expect(1, 66518, '\p{^Is_Scx=-_Xpeo}', "");
    Expect(1, 66518, '\P{Is_Scx=-_Xpeo}', "");
    Expect(0, 66518, '\P{^Is_Scx=-_Xpeo}', "");
    Error('\p{Script_Extensions= /a/Cuneiform}');
    Error('\P{Script_Extensions= /a/Cuneiform}');
    Expect(1, 75075, '\p{Script_Extensions=:\ACuneiform\z:}', "");;
    Expect(0, 75076, '\p{Script_Extensions=:\ACuneiform\z:}', "");;
    Expect(1, 75075, '\p{Script_Extensions=cuneiform}', "");
    Expect(0, 75075, '\p{^Script_Extensions=cuneiform}', "");
    Expect(0, 75075, '\P{Script_Extensions=cuneiform}', "");
    Expect(1, 75075, '\P{^Script_Extensions=cuneiform}', "");
    Expect(0, 75076, '\p{Script_Extensions=cuneiform}', "");
    Expect(1, 75076, '\p{^Script_Extensions=cuneiform}', "");
    Expect(1, 75076, '\P{Script_Extensions=cuneiform}', "");
    Expect(0, 75076, '\P{^Script_Extensions=cuneiform}', "");
    Expect(1, 75075, '\p{Script_Extensions=:\Acuneiform\z:}', "");;
    Expect(0, 75076, '\p{Script_Extensions=:\Acuneiform\z:}', "");;
    Expect(1, 75075, '\p{Script_Extensions=__Cuneiform}', "");
    Expect(0, 75075, '\p{^Script_Extensions=__Cuneiform}', "");
    Expect(0, 75075, '\P{Script_Extensions=__Cuneiform}', "");
    Expect(1, 75075, '\P{^Script_Extensions=__Cuneiform}', "");
    Expect(0, 75076, '\p{Script_Extensions=__Cuneiform}', "");
    Expect(1, 75076, '\p{^Script_Extensions=__Cuneiform}', "");
    Expect(1, 75076, '\P{Script_Extensions=__Cuneiform}', "");
    Expect(0, 75076, '\P{^Script_Extensions=__Cuneiform}', "");
    Error('\p{Scx=/a/_	xsux}');
    Error('\P{Scx=/a/_	xsux}');
    Expect(1, 75075, '\p{Scx=:\AXsux\z:}', "");;
    Expect(0, 75076, '\p{Scx=:\AXsux\z:}', "");;
    Expect(1, 75075, '\p{Scx=xsux}', "");
    Expect(0, 75075, '\p{^Scx=xsux}', "");
    Expect(0, 75075, '\P{Scx=xsux}', "");
    Expect(1, 75075, '\P{^Scx=xsux}', "");
    Expect(0, 75076, '\p{Scx=xsux}', "");
    Expect(1, 75076, '\p{^Scx=xsux}', "");
    Expect(1, 75076, '\P{Scx=xsux}', "");
    Expect(0, 75076, '\P{^Scx=xsux}', "");
    Expect(1, 75075, '\p{Scx=:\Axsux\z:}', "");;
    Expect(0, 75076, '\p{Scx=:\Axsux\z:}', "");;
    Expect(1, 75075, '\p{Scx=_	Xsux}', "");
    Expect(0, 75075, '\p{^Scx=_	Xsux}', "");
    Expect(0, 75075, '\P{Scx=_	Xsux}', "");
    Expect(1, 75075, '\P{^Scx=_	Xsux}', "");
    Expect(0, 75076, '\p{Scx=_	Xsux}', "");
    Expect(1, 75076, '\p{^Scx=_	Xsux}', "");
    Expect(1, 75076, '\P{Scx=_	Xsux}', "");
    Expect(0, 75076, '\P{^Scx=_	Xsux}', "");
    Error('\p{Is_Script_Extensions:-Cuneiform/a/}');
    Error('\P{Is_Script_Extensions:-Cuneiform/a/}');
    Expect(1, 75075, '\p{Is_Script_Extensions=cuneiform}', "");
    Expect(0, 75075, '\p{^Is_Script_Extensions=cuneiform}', "");
    Expect(0, 75075, '\P{Is_Script_Extensions=cuneiform}', "");
    Expect(1, 75075, '\P{^Is_Script_Extensions=cuneiform}', "");
    Expect(0, 75076, '\p{Is_Script_Extensions=cuneiform}', "");
    Expect(1, 75076, '\p{^Is_Script_Extensions=cuneiform}', "");
    Expect(1, 75076, '\P{Is_Script_Extensions=cuneiform}', "");
    Expect(0, 75076, '\P{^Is_Script_Extensions=cuneiform}', "");
    Expect(1, 75075, '\p{Is_Script_Extensions=_	cuneiform}', "");
    Expect(0, 75075, '\p{^Is_Script_Extensions=_	cuneiform}', "");
    Expect(0, 75075, '\P{Is_Script_Extensions=_	cuneiform}', "");
    Expect(1, 75075, '\P{^Is_Script_Extensions=_	cuneiform}', "");
    Expect(0, 75076, '\p{Is_Script_Extensions=_	cuneiform}', "");
    Expect(1, 75076, '\p{^Is_Script_Extensions=_	cuneiform}', "");
    Expect(1, 75076, '\P{Is_Script_Extensions=_	cuneiform}', "");
    Expect(0, 75076, '\P{^Is_Script_Extensions=_	cuneiform}', "");
    Error('\p{Is_Scx= /a/XSUX}');
    Error('\P{Is_Scx= /a/XSUX}');
    Expect(1, 75075, '\p{Is_Scx=xsux}', "");
    Expect(0, 75075, '\p{^Is_Scx=xsux}', "");
    Expect(0, 75075, '\P{Is_Scx=xsux}', "");
    Expect(1, 75075, '\P{^Is_Scx=xsux}', "");
    Expect(0, 75076, '\p{Is_Scx=xsux}', "");
    Expect(1, 75076, '\p{^Is_Scx=xsux}', "");
    Expect(1, 75076, '\P{Is_Scx=xsux}', "");
    Expect(0, 75076, '\P{^Is_Scx=xsux}', "");
    Expect(1, 75075, '\p{Is_Scx:  	xsux}', "");
    Expect(0, 75075, '\p{^Is_Scx:  	xsux}', "");
    Expect(0, 75075, '\P{Is_Scx:  	xsux}', "");
    Expect(1, 75075, '\P{^Is_Scx:  	xsux}', "");
    Expect(0, 75076, '\p{Is_Scx:  	xsux}', "");
    Expect(1, 75076, '\p{^Is_Scx:  	xsux}', "");
    Expect(1, 75076, '\P{Is_Scx:  	xsux}', "");
    Expect(0, 75076, '\P{^Is_Scx:  	xsux}', "");
    Error('\p{Script_Extensions=/a/_	YEZIDI}');
    Error('\P{Script_Extensions=/a/_	YEZIDI}');
    Expect(1, 69297, '\p{Script_Extensions=:\AYezidi\z:}', "");;
    Expect(0, 69298, '\p{Script_Extensions=:\AYezidi\z:}', "");;
    Expect(1, 69297, '\p{Script_Extensions=yezidi}', "");
    Expect(0, 69297, '\p{^Script_Extensions=yezidi}', "");
    Expect(0, 69297, '\P{Script_Extensions=yezidi}', "");
    Expect(1, 69297, '\P{^Script_Extensions=yezidi}', "");
    Expect(0, 69298, '\p{Script_Extensions=yezidi}', "");
    Expect(1, 69298, '\p{^Script_Extensions=yezidi}', "");
    Expect(1, 69298, '\P{Script_Extensions=yezidi}', "");
    Expect(0, 69298, '\P{^Script_Extensions=yezidi}', "");
    Expect(1, 69297, '\p{Script_Extensions=:\Ayezidi\z:}', "");;
    Expect(0, 69298, '\p{Script_Extensions=:\Ayezidi\z:}', "");;
    Expect(1, 69297, '\p{Script_Extensions=__Yezidi}', "");
    Expect(0, 69297, '\p{^Script_Extensions=__Yezidi}', "");
    Expect(0, 69297, '\P{Script_Extensions=__Yezidi}', "");
    Expect(1, 69297, '\P{^Script_Extensions=__Yezidi}', "");
    Expect(0, 69298, '\p{Script_Extensions=__Yezidi}', "");
    Expect(1, 69298, '\p{^Script_Extensions=__Yezidi}', "");
    Expect(1, 69298, '\P{Script_Extensions=__Yezidi}', "");
    Expect(0, 69298, '\P{^Script_Extensions=__Yezidi}', "");
    Error('\p{Scx=/a/ yezi}');
    Error('\P{Scx=/a/ yezi}');
    Expect(1, 69297, '\p{Scx=:\AYezi\z:}', "");;
    Expect(0, 69298, '\p{Scx=:\AYezi\z:}', "");;
    Expect(1, 69297, '\p{Scx=yezi}', "");
    Expect(0, 69297, '\p{^Scx=yezi}', "");
    Expect(0, 69297, '\P{Scx=yezi}', "");
    Expect(1, 69297, '\P{^Scx=yezi}', "");
    Expect(0, 69298, '\p{Scx=yezi}', "");
    Expect(1, 69298, '\p{^Scx=yezi}', "");
    Expect(1, 69298, '\P{Scx=yezi}', "");
    Expect(0, 69298, '\P{^Scx=yezi}', "");
    Expect(1, 69297, '\p{Scx=:\Ayezi\z:}', "");;
    Expect(0, 69298, '\p{Scx=:\Ayezi\z:}', "");;
    Expect(1, 69297, '\p{Scx=  Yezi}', "");
    Expect(0, 69297, '\p{^Scx=  Yezi}', "");
    Expect(0, 69297, '\P{Scx=  Yezi}', "");
    Expect(1, 69297, '\P{^Scx=  Yezi}', "");
    Expect(0, 69298, '\p{Scx=  Yezi}', "");
    Expect(1, 69298, '\p{^Scx=  Yezi}', "");
    Expect(1, 69298, '\P{Scx=  Yezi}', "");
    Expect(0, 69298, '\P{^Scx=  Yezi}', "");
    Error('\p{Is_Script_Extensions=/a/	-YEZIDI}');
    Error('\P{Is_Script_Extensions=/a/	-YEZIDI}');
    Expect(1, 69297, '\p{Is_Script_Extensions=yezidi}', "");
    Expect(0, 69297, '\p{^Is_Script_Extensions=yezidi}', "");
    Expect(0, 69297, '\P{Is_Script_Extensions=yezidi}', "");
    Expect(1, 69297, '\P{^Is_Script_Extensions=yezidi}', "");
    Expect(0, 69298, '\p{Is_Script_Extensions=yezidi}', "");
    Expect(1, 69298, '\p{^Is_Script_Extensions=yezidi}', "");
    Expect(1, 69298, '\P{Is_Script_Extensions=yezidi}', "");
    Expect(0, 69298, '\P{^Is_Script_Extensions=yezidi}', "");
    Expect(1, 69297, '\p{Is_Script_Extensions:	- YEZIDI}', "");
    Expect(0, 69297, '\p{^Is_Script_Extensions:	- YEZIDI}', "");
    Expect(0, 69297, '\P{Is_Script_Extensions:	- YEZIDI}', "");
    Expect(1, 69297, '\P{^Is_Script_Extensions:	- YEZIDI}', "");
    Expect(0, 69298, '\p{Is_Script_Extensions:	- YEZIDI}', "");
    Expect(1, 69298, '\p{^Is_Script_Extensions:	- YEZIDI}', "");
    Expect(1, 69298, '\P{Is_Script_Extensions:	- YEZIDI}', "");
    Expect(0, 69298, '\P{^Is_Script_Extensions:	- YEZIDI}', "");
    Error('\p{Is_Scx=-Yezi:=}');
    Error('\P{Is_Scx=-Yezi:=}');
    Expect(1, 69297, '\p{Is_Scx=yezi}', "");
    Expect(0, 69297, '\p{^Is_Scx=yezi}', "");
    Expect(0, 69297, '\P{Is_Scx=yezi}', "");
    Expect(1, 69297, '\P{^Is_Scx=yezi}', "");
    Expect(0, 69298, '\p{Is_Scx=yezi}', "");
    Expect(1, 69298, '\p{^Is_Scx=yezi}', "");
    Expect(1, 69298, '\P{Is_Scx=yezi}', "");
    Expect(0, 69298, '\P{^Is_Scx=yezi}', "");
    Expect(1, 69297, '\p{Is_Scx:     Yezi}', "");
    Expect(0, 69297, '\p{^Is_Scx:     Yezi}', "");
    Expect(0, 69297, '\P{Is_Scx:     Yezi}', "");
    Expect(1, 69297, '\P{^Is_Scx:     Yezi}', "");
    Expect(0, 69298, '\p{Is_Scx:     Yezi}', "");
    Expect(1, 69298, '\p{^Is_Scx:     Yezi}', "");
    Expect(1, 69298, '\P{Is_Scx:     Yezi}', "");
    Expect(0, 69298, '\P{^Is_Scx:     Yezi}', "");
    Error('\p{Script_Extensions=-/a/Yi}');
    Error('\P{Script_Extensions=-/a/Yi}');
    Expect(1, 65381, '\p{Script_Extensions=:\AYi\z:}', "");;
    Expect(0, 65382, '\p{Script_Extensions=:\AYi\z:}', "");;
    Expect(1, 65381, '\p{Script_Extensions=yi}', "");
    Expect(0, 65381, '\p{^Script_Extensions=yi}', "");
    Expect(0, 65381, '\P{Script_Extensions=yi}', "");
    Expect(1, 65381, '\P{^Script_Extensions=yi}', "");
    Expect(0, 65382, '\p{Script_Extensions=yi}', "");
    Expect(1, 65382, '\p{^Script_Extensions=yi}', "");
    Expect(1, 65382, '\P{Script_Extensions=yi}', "");
    Expect(0, 65382, '\P{^Script_Extensions=yi}', "");
    Expect(1, 65381, '\p{Script_Extensions=:\Ayi\z:}', "");;
    Expect(0, 65382, '\p{Script_Extensions=:\Ayi\z:}', "");;
    Expect(1, 65381, '\p{Script_Extensions=	 yi}', "");
    Expect(0, 65381, '\p{^Script_Extensions=	 yi}', "");
    Expect(0, 65381, '\P{Script_Extensions=	 yi}', "");
    Expect(1, 65381, '\P{^Script_Extensions=	 yi}', "");
    Expect(0, 65382, '\p{Script_Extensions=	 yi}', "");
    Expect(1, 65382, '\p{^Script_Extensions=	 yi}', "");
    Expect(1, 65382, '\P{Script_Extensions=	 yi}', "");
    Expect(0, 65382, '\P{^Script_Extensions=	 yi}', "");
    Error('\p{Scx: --yiii/a/}');
    Error('\P{Scx: --yiii/a/}');
    Expect(1, 65381, '\p{Scx=:\AYiii\z:}', "");;
    Expect(0, 65382, '\p{Scx=:\AYiii\z:}', "");;
    Expect(1, 65381, '\p{Scx:   yiii}', "");
    Expect(0, 65381, '\p{^Scx:   yiii}', "");
    Expect(0, 65381, '\P{Scx:   yiii}', "");
    Expect(1, 65381, '\P{^Scx:   yiii}', "");
    Expect(0, 65382, '\p{Scx:   yiii}', "");
    Expect(1, 65382, '\p{^Scx:   yiii}', "");
    Expect(1, 65382, '\P{Scx:   yiii}', "");
    Expect(0, 65382, '\P{^Scx:   yiii}', "");
    Expect(1, 65381, '\p{Scx=:\Ayiii\z:}', "");;
    Expect(0, 65382, '\p{Scx=:\Ayiii\z:}', "");;
    Expect(1, 65381, '\p{Scx= -YIII}', "");
    Expect(0, 65381, '\p{^Scx= -YIII}', "");
    Expect(0, 65381, '\P{Scx= -YIII}', "");
    Expect(1, 65381, '\P{^Scx= -YIII}', "");
    Expect(0, 65382, '\p{Scx= -YIII}', "");
    Expect(1, 65382, '\p{^Scx= -YIII}', "");
    Expect(1, 65382, '\P{Scx= -YIII}', "");
    Expect(0, 65382, '\P{^Scx= -YIII}', "");
    Error('\p{Is_Script_Extensions=:=-	Yi}');
    Error('\P{Is_Script_Extensions=:=-	Yi}');
    Expect(1, 65381, '\p{Is_Script_Extensions:yi}', "");
    Expect(0, 65381, '\p{^Is_Script_Extensions:yi}', "");
    Expect(0, 65381, '\P{Is_Script_Extensions:yi}', "");
    Expect(1, 65381, '\P{^Is_Script_Extensions:yi}', "");
    Expect(0, 65382, '\p{Is_Script_Extensions:yi}', "");
    Expect(1, 65382, '\p{^Is_Script_Extensions:yi}', "");
    Expect(1, 65382, '\P{Is_Script_Extensions:yi}', "");
    Expect(0, 65382, '\P{^Is_Script_Extensions:yi}', "");
    Expect(1, 65381, '\p{Is_Script_Extensions=-yi}', "");
    Expect(0, 65381, '\p{^Is_Script_Extensions=-yi}', "");
    Expect(0, 65381, '\P{Is_Script_Extensions=-yi}', "");
    Expect(1, 65381, '\P{^Is_Script_Extensions=-yi}', "");
    Expect(0, 65382, '\p{Is_Script_Extensions=-yi}', "");
    Expect(1, 65382, '\p{^Is_Script_Extensions=-yi}', "");
    Expect(1, 65382, '\P{Is_Script_Extensions=-yi}', "");
    Expect(0, 65382, '\P{^Is_Script_Extensions=-yi}', "");
    Error('\p{Is_Scx=:=		yiii}');
    Error('\P{Is_Scx=:=		yiii}');
    Expect(1, 65381, '\p{Is_Scx=yiii}', "");
    Expect(0, 65381, '\p{^Is_Scx=yiii}', "");
    Expect(0, 65381, '\P{Is_Scx=yiii}', "");
    Expect(1, 65381, '\P{^Is_Scx=yiii}', "");
    Expect(0, 65382, '\p{Is_Scx=yiii}', "");
    Expect(1, 65382, '\p{^Is_Scx=yiii}', "");
    Expect(1, 65382, '\P{Is_Scx=yiii}', "");
    Expect(0, 65382, '\P{^Is_Scx=yiii}', "");
    Expect(1, 65381, '\p{Is_Scx= _YIII}', "");
    Expect(0, 65381, '\p{^Is_Scx= _YIII}', "");
    Expect(0, 65381, '\P{Is_Scx= _YIII}', "");
    Expect(1, 65381, '\P{^Is_Scx= _YIII}', "");
    Expect(0, 65382, '\p{Is_Scx= _YIII}', "");
    Expect(1, 65382, '\p{^Is_Scx= _YIII}', "");
    Expect(1, 65382, '\P{Is_Scx= _YIII}', "");
    Expect(0, 65382, '\P{^Is_Scx= _YIII}', "");
    Error('\p{Script_Extensions=:=__ZANABAZAR_square}');
    Error('\P{Script_Extensions=:=__ZANABAZAR_square}');
    Expect(1, 72263, '\p{Script_Extensions=:\AZanabazar_Square\z:}', "");;
    Expect(0, 72264, '\p{Script_Extensions=:\AZanabazar_Square\z:}', "");;
    Expect(1, 72263, '\p{Script_Extensions=zanabazarsquare}', "");
    Expect(0, 72263, '\p{^Script_Extensions=zanabazarsquare}', "");
    Expect(0, 72263, '\P{Script_Extensions=zanabazarsquare}', "");
    Expect(1, 72263, '\P{^Script_Extensions=zanabazarsquare}', "");
    Expect(0, 72264, '\p{Script_Extensions=zanabazarsquare}', "");
    Expect(1, 72264, '\p{^Script_Extensions=zanabazarsquare}', "");
    Expect(1, 72264, '\P{Script_Extensions=zanabazarsquare}', "");
    Expect(0, 72264, '\P{^Script_Extensions=zanabazarsquare}', "");
    Expect(1, 72263, '\p{Script_Extensions=:\Azanabazarsquare\z:}', "");;
    Expect(0, 72264, '\p{Script_Extensions=:\Azanabazarsquare\z:}', "");;
    Expect(1, 72263, '\p{Script_Extensions=-_Zanabazar_Square}', "");
    Expect(0, 72263, '\p{^Script_Extensions=-_Zanabazar_Square}', "");
    Expect(0, 72263, '\P{Script_Extensions=-_Zanabazar_Square}', "");
    Expect(1, 72263, '\P{^Script_Extensions=-_Zanabazar_Square}', "");
    Expect(0, 72264, '\p{Script_Extensions=-_Zanabazar_Square}', "");
    Expect(1, 72264, '\p{^Script_Extensions=-_Zanabazar_Square}', "");
    Expect(1, 72264, '\P{Script_Extensions=-_Zanabazar_Square}', "");
    Expect(0, 72264, '\P{^Script_Extensions=-_Zanabazar_Square}', "");
    Error('\p{Scx=:=	_Zanb}');
    Error('\P{Scx=:=	_Zanb}');
    Expect(1, 72263, '\p{Scx=:\AZanb\z:}', "");;
    Expect(0, 72264, '\p{Scx=:\AZanb\z:}', "");;
    Expect(1, 72263, '\p{Scx=zanb}', "");
    Expect(0, 72263, '\p{^Scx=zanb}', "");
    Expect(0, 72263, '\P{Scx=zanb}', "");
    Expect(1, 72263, '\P{^Scx=zanb}', "");
    Expect(0, 72264, '\p{Scx=zanb}', "");
    Expect(1, 72264, '\p{^Scx=zanb}', "");
    Expect(1, 72264, '\P{Scx=zanb}', "");
    Expect(0, 72264, '\P{^Scx=zanb}', "");
    Expect(1, 72263, '\p{Scx=:\Azanb\z:}', "");;
    Expect(0, 72264, '\p{Scx=:\Azanb\z:}', "");;
    Expect(1, 72263, '\p{Scx= _Zanb}', "");
    Expect(0, 72263, '\p{^Scx= _Zanb}', "");
    Expect(0, 72263, '\P{Scx= _Zanb}', "");
    Expect(1, 72263, '\P{^Scx= _Zanb}', "");
    Expect(0, 72264, '\p{Scx= _Zanb}', "");
    Expect(1, 72264, '\p{^Scx= _Zanb}', "");
    Expect(1, 72264, '\P{Scx= _Zanb}', "");
    Expect(0, 72264, '\P{^Scx= _Zanb}', "");
    Error('\p{Is_Script_Extensions= /a/Zanabazar_Square}');
    Error('\P{Is_Script_Extensions= /a/Zanabazar_Square}');
    Expect(1, 72263, '\p{Is_Script_Extensions=zanabazarsquare}', "");
    Expect(0, 72263, '\p{^Is_Script_Extensions=zanabazarsquare}', "");
    Expect(0, 72263, '\P{Is_Script_Extensions=zanabazarsquare}', "");
    Expect(1, 72263, '\P{^Is_Script_Extensions=zanabazarsquare}', "");
    Expect(0, 72264, '\p{Is_Script_Extensions=zanabazarsquare}', "");
    Expect(1, 72264, '\p{^Is_Script_Extensions=zanabazarsquare}', "");
    Expect(1, 72264, '\P{Is_Script_Extensions=zanabazarsquare}', "");
    Expect(0, 72264, '\P{^Is_Script_Extensions=zanabazarsquare}', "");
    Expect(1, 72263, '\p{Is_Script_Extensions=	-zanabazar_Square}', "");
    Expect(0, 72263, '\p{^Is_Script_Extensions=	-zanabazar_Square}', "");
    Expect(0, 72263, '\P{Is_Script_Extensions=	-zanabazar_Square}', "");
    Expect(1, 72263, '\P{^Is_Script_Extensions=	-zanabazar_Square}', "");
    Expect(0, 72264, '\p{Is_Script_Extensions=	-zanabazar_Square}', "");
    Expect(1, 72264, '\p{^Is_Script_Extensions=	-zanabazar_Square}', "");
    Expect(1, 72264, '\P{Is_Script_Extensions=	-zanabazar_Square}', "");
    Expect(0, 72264, '\P{^Is_Script_Extensions=	-zanabazar_Square}', "");
    Error('\p{Is_Scx=/a/zanb}');
    Error('\P{Is_Scx=/a/zanb}');
    Expect(1, 72263, '\p{Is_Scx=zanb}', "");
    Expect(0, 72263, '\p{^Is_Scx=zanb}', "");
    Expect(0, 72263, '\P{Is_Scx=zanb}', "");
    Expect(1, 72263, '\P{^Is_Scx=zanb}', "");
    Expect(0, 72264, '\p{Is_Scx=zanb}', "");
    Expect(1, 72264, '\p{^Is_Scx=zanb}', "");
    Expect(1, 72264, '\P{Is_Scx=zanb}', "");
    Expect(0, 72264, '\P{^Is_Scx=zanb}', "");
    Expect(1, 72263, '\p{Is_Scx:   -_zanb}', "");
    Expect(0, 72263, '\p{^Is_Scx:   -_zanb}', "");
    Expect(0, 72263, '\P{Is_Scx:   -_zanb}', "");
    Expect(1, 72263, '\P{^Is_Scx:   -_zanb}', "");
    Expect(0, 72264, '\p{Is_Scx:   -_zanb}', "");
    Expect(1, 72264, '\p{^Is_Scx:   -_zanb}', "");
    Expect(1, 72264, '\P{Is_Scx:   -_zanb}', "");
    Expect(0, 72264, '\P{^Is_Scx:   -_zanb}', "");
    Error('\p{Script_Extensions=:=Inherited}');
    Error('\P{Script_Extensions=:=Inherited}');
    Expect(1, 917999, '\p{Script_Extensions=:\AInherited\z:}', "");;
    Expect(0, 918000, '\p{Script_Extensions=:\AInherited\z:}', "");;
    Expect(1, 917999, '\p{Script_Extensions: inherited}', "");
    Expect(0, 917999, '\p{^Script_Extensions: inherited}', "");
    Expect(0, 917999, '\P{Script_Extensions: inherited}', "");
    Expect(1, 917999, '\P{^Script_Extensions: inherited}', "");
    Expect(0, 918000, '\p{Script_Extensions: inherited}', "");
    Expect(1, 918000, '\p{^Script_Extensions: inherited}', "");
    Expect(1, 918000, '\P{Script_Extensions: inherited}', "");
    Expect(0, 918000, '\P{^Script_Extensions: inherited}', "");
    Expect(1, 917999, '\p{Script_Extensions=:\Ainherited\z:}', "");;
    Expect(0, 918000, '\p{Script_Extensions=:\Ainherited\z:}', "");;
    Expect(1, 917999, '\p{Script_Extensions=	INHERITED}', "");
    Expect(0, 917999, '\p{^Script_Extensions=	INHERITED}', "");
    Expect(0, 917999, '\P{Script_Extensions=	INHERITED}', "");
    Expect(1, 917999, '\P{^Script_Extensions=	INHERITED}', "");
    Expect(0, 918000, '\p{Script_Extensions=	INHERITED}', "");
    Expect(1, 918000, '\p{^Script_Extensions=	INHERITED}', "");
    Expect(1, 918000, '\P{Script_Extensions=	INHERITED}', "");
    Expect(0, 918000, '\P{^Script_Extensions=	INHERITED}', "");
    Error('\p{Scx=/a/_	zinh}');
    Error('\P{Scx=/a/_	zinh}');
    Expect(1, 917999, '\p{Scx=:\AZinh\z:}', "");;
    Expect(0, 918000, '\p{Scx=:\AZinh\z:}', "");;
    Expect(1, 917999, '\p{Scx=zinh}', "");
    Expect(0, 917999, '\p{^Scx=zinh}', "");
    Expect(0, 917999, '\P{Scx=zinh}', "");
    Expect(1, 917999, '\P{^Scx=zinh}', "");
    Expect(0, 918000, '\p{Scx=zinh}', "");
    Expect(1, 918000, '\p{^Scx=zinh}', "");
    Expect(1, 918000, '\P{Scx=zinh}', "");
    Expect(0, 918000, '\P{^Scx=zinh}', "");
    Expect(1, 917999, '\p{Scx=:\Azinh\z:}', "");;
    Expect(0, 918000, '\p{Scx=:\Azinh\z:}', "");;
    Expect(1, 917999, '\p{Scx=-	Zinh}', "");
    Expect(0, 917999, '\p{^Scx=-	Zinh}', "");
    Expect(0, 917999, '\P{Scx=-	Zinh}', "");
    Expect(1, 917999, '\P{^Scx=-	Zinh}', "");
    Expect(0, 918000, '\p{Scx=-	Zinh}', "");
    Expect(1, 918000, '\p{^Scx=-	Zinh}', "");
    Expect(1, 918000, '\P{Scx=-	Zinh}', "");
    Expect(0, 918000, '\P{^Scx=-	Zinh}', "");
    Error('\p{Is_Script_Extensions=/a/ -qaai}');
    Error('\P{Is_Script_Extensions=/a/ -qaai}');
    Expect(1, 917999, '\p{Is_Script_Extensions=qaai}', "");
    Expect(0, 917999, '\p{^Is_Script_Extensions=qaai}', "");
    Expect(0, 917999, '\P{Is_Script_Extensions=qaai}', "");
    Expect(1, 917999, '\P{^Is_Script_Extensions=qaai}', "");
    Expect(0, 918000, '\p{Is_Script_Extensions=qaai}', "");
    Expect(1, 918000, '\p{^Is_Script_Extensions=qaai}', "");
    Expect(1, 918000, '\P{Is_Script_Extensions=qaai}', "");
    Expect(0, 918000, '\P{^Is_Script_Extensions=qaai}', "");
    Expect(1, 917999, '\p{Is_Script_Extensions= 	Qaai}', "");
    Expect(0, 917999, '\p{^Is_Script_Extensions= 	Qaai}', "");
    Expect(0, 917999, '\P{Is_Script_Extensions= 	Qaai}', "");
    Expect(1, 917999, '\P{^Is_Script_Extensions= 	Qaai}', "");
    Expect(0, 918000, '\p{Is_Script_Extensions= 	Qaai}', "");
    Expect(1, 918000, '\p{^Is_Script_Extensions= 	Qaai}', "");
    Expect(1, 918000, '\P{Is_Script_Extensions= 	Qaai}', "");
    Expect(0, 918000, '\P{^Is_Script_Extensions= 	Qaai}', "");
    Error('\p{Is_Scx=-:=INHERITED}');
    Error('\P{Is_Scx=-:=INHERITED}');
    Expect(1, 917999, '\p{Is_Scx=inherited}', "");
    Expect(0, 917999, '\p{^Is_Scx=inherited}', "");
    Expect(0, 917999, '\P{Is_Scx=inherited}', "");
    Expect(1, 917999, '\P{^Is_Scx=inherited}', "");
    Expect(0, 918000, '\p{Is_Scx=inherited}', "");
    Expect(1, 918000, '\p{^Is_Scx=inherited}', "");
    Expect(1, 918000, '\P{Is_Scx=inherited}', "");
    Expect(0, 918000, '\P{^Is_Scx=inherited}', "");
    Expect(1, 917999, '\p{Is_Scx=	 inherited}', "");
    Expect(0, 917999, '\p{^Is_Scx=	 inherited}', "");
    Expect(0, 917999, '\P{Is_Scx=	 inherited}', "");
    Expect(1, 917999, '\P{^Is_Scx=	 inherited}', "");
    Expect(0, 918000, '\p{Is_Scx=	 inherited}', "");
    Expect(1, 918000, '\p{^Is_Scx=	 inherited}', "");
    Expect(1, 918000, '\P{Is_Scx=	 inherited}', "");
    Expect(0, 918000, '\P{^Is_Scx=	 inherited}', "");
    Error('\p{Script_Extensions=:=	Common}');
    Error('\P{Script_Extensions=:=	Common}');
    Expect(1, 917631, '\p{Script_Extensions=:\ACommon\z:}', "");;
    Expect(0, 917632, '\p{Script_Extensions=:\ACommon\z:}', "");;
    Expect(1, 917631, '\p{Script_Extensions=common}', "");
    Expect(0, 917631, '\p{^Script_Extensions=common}', "");
    Expect(0, 917631, '\P{Script_Extensions=common}', "");
    Expect(1, 917631, '\P{^Script_Extensions=common}', "");
    Expect(0, 917632, '\p{Script_Extensions=common}', "");
    Expect(1, 917632, '\p{^Script_Extensions=common}', "");
    Expect(1, 917632, '\P{Script_Extensions=common}', "");
    Expect(0, 917632, '\P{^Script_Extensions=common}', "");
    Expect(1, 917631, '\p{Script_Extensions=:\Acommon\z:}', "");;
    Expect(0, 917632, '\p{Script_Extensions=:\Acommon\z:}', "");;
    Expect(1, 917631, '\p{Script_Extensions:   -_common}', "");
    Expect(0, 917631, '\p{^Script_Extensions:   -_common}', "");
    Expect(0, 917631, '\P{Script_Extensions:   -_common}', "");
    Expect(1, 917631, '\P{^Script_Extensions:   -_common}', "");
    Expect(0, 917632, '\p{Script_Extensions:   -_common}', "");
    Expect(1, 917632, '\p{^Script_Extensions:   -_common}', "");
    Expect(1, 917632, '\P{Script_Extensions:   -_common}', "");
    Expect(0, 917632, '\P{^Script_Extensions:   -_common}', "");
    Error('\p{Scx=:=	ZYYY}');
    Error('\P{Scx=:=	ZYYY}');
    Expect(1, 917631, '\p{Scx=:\AZyyy\z:}', "");;
    Expect(0, 917632, '\p{Scx=:\AZyyy\z:}', "");;
    Expect(1, 917631, '\p{Scx=zyyy}', "");
    Expect(0, 917631, '\p{^Scx=zyyy}', "");
    Expect(0, 917631, '\P{Scx=zyyy}', "");
    Expect(1, 917631, '\P{^Scx=zyyy}', "");
    Expect(0, 917632, '\p{Scx=zyyy}', "");
    Expect(1, 917632, '\p{^Scx=zyyy}', "");
    Expect(1, 917632, '\P{Scx=zyyy}', "");
    Expect(0, 917632, '\P{^Scx=zyyy}', "");
    Expect(1, 917631, '\p{Scx=:\Azyyy\z:}', "");;
    Expect(0, 917632, '\p{Scx=:\Azyyy\z:}', "");;
    Expect(1, 917631, '\p{Scx=_ ZYYY}', "");
    Expect(0, 917631, '\p{^Scx=_ ZYYY}', "");
    Expect(0, 917631, '\P{Scx=_ ZYYY}', "");
    Expect(1, 917631, '\P{^Scx=_ ZYYY}', "");
    Expect(0, 917632, '\p{Scx=_ ZYYY}', "");
    Expect(1, 917632, '\p{^Scx=_ ZYYY}', "");
    Expect(1, 917632, '\P{Scx=_ ZYYY}', "");
    Expect(0, 917632, '\P{^Scx=_ ZYYY}', "");
    Error('\p{Is_Script_Extensions=/a/ 	Common}');
    Error('\P{Is_Script_Extensions=/a/ 	Common}');
    Expect(1, 917631, '\p{Is_Script_Extensions:	common}', "");
    Expect(0, 917631, '\p{^Is_Script_Extensions:	common}', "");
    Expect(0, 917631, '\P{Is_Script_Extensions:	common}', "");
    Expect(1, 917631, '\P{^Is_Script_Extensions:	common}', "");
    Expect(0, 917632, '\p{Is_Script_Extensions:	common}', "");
    Expect(1, 917632, '\p{^Is_Script_Extensions:	common}', "");
    Expect(1, 917632, '\P{Is_Script_Extensions:	common}', "");
    Expect(0, 917632, '\P{^Is_Script_Extensions:	common}', "");
    Expect(1, 917631, '\p{Is_Script_Extensions= COMMON}', "");
    Expect(0, 917631, '\p{^Is_Script_Extensions= COMMON}', "");
    Expect(0, 917631, '\P{Is_Script_Extensions= COMMON}', "");
    Expect(1, 917631, '\P{^Is_Script_Extensions= COMMON}', "");
    Expect(0, 917632, '\p{Is_Script_Extensions= COMMON}', "");
    Expect(1, 917632, '\p{^Is_Script_Extensions= COMMON}', "");
    Expect(1, 917632, '\P{Is_Script_Extensions= COMMON}', "");
    Expect(0, 917632, '\P{^Is_Script_Extensions= COMMON}', "");
    Error('\p{Is_Scx=/a/Zyyy}');
    Error('\P{Is_Scx=/a/Zyyy}');
    Expect(1, 917631, '\p{Is_Scx=zyyy}', "");
    Expect(0, 917631, '\p{^Is_Scx=zyyy}', "");
    Expect(0, 917631, '\P{Is_Scx=zyyy}', "");
    Expect(1, 917631, '\P{^Is_Scx=zyyy}', "");
    Expect(0, 917632, '\p{Is_Scx=zyyy}', "");
    Expect(1, 917632, '\p{^Is_Scx=zyyy}', "");
    Expect(1, 917632, '\P{Is_Scx=zyyy}', "");
    Expect(0, 917632, '\P{^Is_Scx=zyyy}', "");
    Expect(1, 917631, '\p{Is_Scx: __zyyy}', "");
    Expect(0, 917631, '\p{^Is_Scx: __zyyy}', "");
    Expect(0, 917631, '\P{Is_Scx: __zyyy}', "");
    Expect(1, 917631, '\P{^Is_Scx: __zyyy}', "");
    Expect(0, 917632, '\p{Is_Scx: __zyyy}', "");
    Expect(1, 917632, '\p{^Is_Scx: __zyyy}', "");
    Expect(1, 917632, '\P{Is_Scx: __zyyy}', "");
    Expect(0, 917632, '\P{^Is_Scx: __zyyy}', "");
    Error('\p{Script_Extensions=__UNKNOWN/a/}');
    Error('\P{Script_Extensions=__UNKNOWN/a/}');
    Expect(1, 918000, '\p{Script_Extensions=:\AUnknown\z:}', "");;
    Expect(0, 917999, '\p{Script_Extensions=:\AUnknown\z:}', "");;
    Expect(1, 918000, '\p{Script_Extensions=unknown}', "");
    Expect(0, 918000, '\p{^Script_Extensions=unknown}', "");
    Expect(0, 918000, '\P{Script_Extensions=unknown}', "");
    Expect(1, 918000, '\P{^Script_Extensions=unknown}', "");
    Expect(0, 917999, '\p{Script_Extensions=unknown}', "");
    Expect(1, 917999, '\p{^Script_Extensions=unknown}', "");
    Expect(1, 917999, '\P{Script_Extensions=unknown}', "");
    Expect(0, 917999, '\P{^Script_Extensions=unknown}', "");
    Expect(1, 918000, '\p{Script_Extensions=:\Aunknown\z:}', "");;
    Expect(0, 917999, '\p{Script_Extensions=:\Aunknown\z:}', "");;
    Expect(1, 918000, '\p{Script_Extensions= _Unknown}', "");
    Expect(0, 918000, '\p{^Script_Extensions= _Unknown}', "");
    Expect(0, 918000, '\P{Script_Extensions= _Unknown}', "");
    Expect(1, 918000, '\P{^Script_Extensions= _Unknown}', "");
    Expect(0, 917999, '\p{Script_Extensions= _Unknown}', "");
    Expect(1, 917999, '\p{^Script_Extensions= _Unknown}', "");
    Expect(1, 917999, '\P{Script_Extensions= _Unknown}', "");
    Expect(0, 917999, '\P{^Script_Extensions= _Unknown}', "");
    Error('\p{Scx=_-zzzz:=}');
    Error('\P{Scx=_-zzzz:=}');
    Expect(1, 918000, '\p{Scx=:\AZzzz\z:}', "");;
    Expect(0, 917999, '\p{Scx=:\AZzzz\z:}', "");;
    Expect(1, 918000, '\p{Scx=zzzz}', "");
    Expect(0, 918000, '\p{^Scx=zzzz}', "");
    Expect(0, 918000, '\P{Scx=zzzz}', "");
    Expect(1, 918000, '\P{^Scx=zzzz}', "");
    Expect(0, 917999, '\p{Scx=zzzz}', "");
    Expect(1, 917999, '\p{^Scx=zzzz}', "");
    Expect(1, 917999, '\P{Scx=zzzz}', "");
    Expect(0, 917999, '\P{^Scx=zzzz}', "");
    Expect(1, 918000, '\p{Scx=:\Azzzz\z:}', "");;
    Expect(0, 917999, '\p{Scx=:\Azzzz\z:}', "");;
    Expect(1, 918000, '\p{Scx=	zzzz}', "");
    Expect(0, 918000, '\p{^Scx=	zzzz}', "");
    Expect(0, 918000, '\P{Scx=	zzzz}', "");
    Expect(1, 918000, '\P{^Scx=	zzzz}', "");
    Expect(0, 917999, '\p{Scx=	zzzz}', "");
    Expect(1, 917999, '\p{^Scx=	zzzz}', "");
    Expect(1, 917999, '\P{Scx=	zzzz}', "");
    Expect(0, 917999, '\P{^Scx=	zzzz}', "");
    Error('\p{Is_Script_Extensions:_ UNKNOWN:=}');
    Error('\P{Is_Script_Extensions:_ UNKNOWN:=}');
    Expect(1, 918000, '\p{Is_Script_Extensions=unknown}', "");
    Expect(0, 918000, '\p{^Is_Script_Extensions=unknown}', "");
    Expect(0, 918000, '\P{Is_Script_Extensions=unknown}', "");
    Expect(1, 918000, '\P{^Is_Script_Extensions=unknown}', "");
    Expect(0, 917999, '\p{Is_Script_Extensions=unknown}', "");
    Expect(1, 917999, '\p{^Is_Script_Extensions=unknown}', "");
    Expect(1, 917999, '\P{Is_Script_Extensions=unknown}', "");
    Expect(0, 917999, '\P{^Is_Script_Extensions=unknown}', "");
    Expect(1, 918000, '\p{Is_Script_Extensions=	UNKNOWN}', "");
    Expect(0, 918000, '\p{^Is_Script_Extensions=	UNKNOWN}', "");
    Expect(0, 918000, '\P{Is_Script_Extensions=	UNKNOWN}', "");
    Expect(1, 918000, '\P{^Is_Script_Extensions=	UNKNOWN}', "");
    Expect(0, 917999, '\p{Is_Script_Extensions=	UNKNOWN}', "");
    Expect(1, 917999, '\p{^Is_Script_Extensions=	UNKNOWN}', "");
    Expect(1, 917999, '\P{Is_Script_Extensions=	UNKNOWN}', "");
    Expect(0, 917999, '\P{^Is_Script_Extensions=	UNKNOWN}', "");
    Error('\p{Is_Scx= :=Zzzz}');
    Error('\P{Is_Scx= :=Zzzz}');
    Expect(1, 918000, '\p{Is_Scx=zzzz}', "");
    Expect(0, 918000, '\p{^Is_Scx=zzzz}', "");
    Expect(0, 918000, '\P{Is_Scx=zzzz}', "");
    Expect(1, 918000, '\P{^Is_Scx=zzzz}', "");
    Expect(0, 917999, '\p{Is_Scx=zzzz}', "");
    Expect(1, 917999, '\p{^Is_Scx=zzzz}', "");
    Expect(1, 917999, '\P{Is_Scx=zzzz}', "");
    Expect(0, 917999, '\P{^Is_Scx=zzzz}', "");
    Expect(1, 918000, '\p{Is_Scx=-_Zzzz}', "");
    Expect(0, 918000, '\p{^Is_Scx=-_Zzzz}', "");
    Expect(0, 918000, '\P{Is_Scx=-_Zzzz}', "");
    Expect(1, 918000, '\P{^Is_Scx=-_Zzzz}', "");
    Expect(0, 917999, '\p{Is_Scx=-_Zzzz}', "");
    Expect(1, 917999, '\p{^Is_Scx=-_Zzzz}', "");
    Expect(1, 917999, '\P{Is_Scx=-_Zzzz}', "");
    Expect(0, 917999, '\P{^Is_Scx=-_Zzzz}', "");
    Error('\p{Soft_Dotted:/a/ 	no}');
    Error('\P{Soft_Dotted:/a/ 	no}');
    Expect(1, 120468, '\p{Soft_Dotted=:\ANo\z:}', "");;
    Expect(0, 120467, '\p{Soft_Dotted=:\ANo\z:}', "");;
    Expect(1, 120468, '\p{Soft_Dotted=no}', "");
    Expect(0, 120468, '\p{^Soft_Dotted=no}', "");
    Expect(0, 120468, '\P{Soft_Dotted=no}', "");
    Expect(1, 120468, '\P{^Soft_Dotted=no}', "");
    Expect(0, 120467, '\p{Soft_Dotted=no}', "");
    Expect(1, 120467, '\p{^Soft_Dotted=no}', "");
    Expect(1, 120467, '\P{Soft_Dotted=no}', "");
    Expect(0, 120467, '\P{^Soft_Dotted=no}', "");
    Expect(1, 120468, '\p{Soft_Dotted=:\Ano\z:}', "");;
    Expect(0, 120467, '\p{Soft_Dotted=:\Ano\z:}', "");;
    Expect(1, 120468, '\p{Soft_Dotted= _No}', "");
    Expect(0, 120468, '\p{^Soft_Dotted= _No}', "");
    Expect(0, 120468, '\P{Soft_Dotted= _No}', "");
    Expect(1, 120468, '\P{^Soft_Dotted= _No}', "");
    Expect(0, 120467, '\p{Soft_Dotted= _No}', "");
    Expect(1, 120467, '\p{^Soft_Dotted= _No}', "");
    Expect(1, 120467, '\P{Soft_Dotted= _No}', "");
    Expect(0, 120467, '\P{^Soft_Dotted= _No}', "");
    Error('\p{SD:_/a/n}');
    Error('\P{SD:_/a/n}');
    Expect(1, 120468, '\p{SD=:\AN\z:}', "");;
    Expect(0, 120467, '\p{SD=:\AN\z:}', "");;
    Expect(1, 120468, '\p{SD=n}', "");
    Expect(0, 120468, '\p{^SD=n}', "");
    Expect(0, 120468, '\P{SD=n}', "");
    Expect(1, 120468, '\P{^SD=n}', "");
    Expect(0, 120467, '\p{SD=n}', "");
    Expect(1, 120467, '\p{^SD=n}', "");
    Expect(1, 120467, '\P{SD=n}', "");
    Expect(0, 120467, '\P{^SD=n}', "");
    Expect(1, 120468, '\p{SD=:\An\z:}', "");;
    Expect(0, 120467, '\p{SD=:\An\z:}', "");;
    Expect(1, 120468, '\p{SD=__N}', "");
    Expect(0, 120468, '\p{^SD=__N}', "");
    Expect(0, 120468, '\P{SD=__N}', "");
    Expect(1, 120468, '\P{^SD=__N}', "");
    Expect(0, 120467, '\p{SD=__N}', "");
    Expect(1, 120467, '\p{^SD=__N}', "");
    Expect(1, 120467, '\P{SD=__N}', "");
    Expect(0, 120467, '\P{^SD=__N}', "");
    Error('\p{Is_Soft_Dotted:   /a/-f}');
    Error('\P{Is_Soft_Dotted:   /a/-f}');
    Expect(1, 120468, '\p{Is_Soft_Dotted=f}', "");
    Expect(0, 120468, '\p{^Is_Soft_Dotted=f}', "");
    Expect(0, 120468, '\P{Is_Soft_Dotted=f}', "");
    Expect(1, 120468, '\P{^Is_Soft_Dotted=f}', "");
    Expect(0, 120467, '\p{Is_Soft_Dotted=f}', "");
    Expect(1, 120467, '\p{^Is_Soft_Dotted=f}', "");
    Expect(1, 120467, '\P{Is_Soft_Dotted=f}', "");
    Expect(0, 120467, '\P{^Is_Soft_Dotted=f}', "");
    Expect(1, 120468, '\p{Is_Soft_Dotted=_ F}', "");
    Expect(0, 120468, '\p{^Is_Soft_Dotted=_ F}', "");
    Expect(0, 120468, '\P{Is_Soft_Dotted=_ F}', "");
    Expect(1, 120468, '\P{^Is_Soft_Dotted=_ F}', "");
    Expect(0, 120467, '\p{Is_Soft_Dotted=_ F}', "");
    Expect(1, 120467, '\p{^Is_Soft_Dotted=_ F}', "");
    Expect(1, 120467, '\P{Is_Soft_Dotted=_ F}', "");
    Expect(0, 120467, '\P{^Is_Soft_Dotted=_ F}', "");
    Error('\p{Is_SD= /a/False}');
    Error('\P{Is_SD= /a/False}');
    Expect(1, 120468, '\p{Is_SD=false}', "");
    Expect(0, 120468, '\p{^Is_SD=false}', "");
    Expect(0, 120468, '\P{Is_SD=false}', "");
    Expect(1, 120468, '\P{^Is_SD=false}', "");
    Expect(0, 120467, '\p{Is_SD=false}', "");
    Expect(1, 120467, '\p{^Is_SD=false}', "");
    Expect(1, 120467, '\P{Is_SD=false}', "");
    Expect(0, 120467, '\P{^Is_SD=false}', "");
    Expect(1, 120468, '\p{Is_SD= false}', "");
    Expect(0, 120468, '\p{^Is_SD= false}', "");
    Expect(0, 120468, '\P{Is_SD= false}', "");
    Expect(1, 120468, '\P{^Is_SD= false}', "");
    Expect(0, 120467, '\p{Is_SD= false}', "");
    Expect(1, 120467, '\p{^Is_SD= false}', "");
    Expect(1, 120467, '\P{Is_SD= false}', "");
    Expect(0, 120467, '\P{^Is_SD= false}', "");
    Error('\p{Soft_Dotted=:=_ Yes}');
    Error('\P{Soft_Dotted=:=_ Yes}');
    Expect(1, 120467, '\p{Soft_Dotted=:\AYes\z:}', "");;
    Expect(0, 120468, '\p{Soft_Dotted=:\AYes\z:}', "");;
    Expect(1, 120467, '\p{Soft_Dotted=yes}', "");
    Expect(0, 120467, '\p{^Soft_Dotted=yes}', "");
    Expect(0, 120467, '\P{Soft_Dotted=yes}', "");
    Expect(1, 120467, '\P{^Soft_Dotted=yes}', "");
    Expect(0, 120468, '\p{Soft_Dotted=yes}', "");
    Expect(1, 120468, '\p{^Soft_Dotted=yes}', "");
    Expect(1, 120468, '\P{Soft_Dotted=yes}', "");
    Expect(0, 120468, '\P{^Soft_Dotted=yes}', "");
    Expect(1, 120467, '\p{Soft_Dotted=:\Ayes\z:}', "");;
    Expect(0, 120468, '\p{Soft_Dotted=:\Ayes\z:}', "");;
    Expect(1, 120467, '\p{Soft_Dotted=	Yes}', "");
    Expect(0, 120467, '\p{^Soft_Dotted=	Yes}', "");
    Expect(0, 120467, '\P{Soft_Dotted=	Yes}', "");
    Expect(1, 120467, '\P{^Soft_Dotted=	Yes}', "");
    Expect(0, 120468, '\p{Soft_Dotted=	Yes}', "");
    Expect(1, 120468, '\p{^Soft_Dotted=	Yes}', "");
    Expect(1, 120468, '\P{Soft_Dotted=	Yes}', "");
    Expect(0, 120468, '\P{^Soft_Dotted=	Yes}', "");
    Error('\p{SD: 	_Y:=}');
    Error('\P{SD: 	_Y:=}');
    Expect(1, 120467, '\p{SD=:\AY\z:}', "");;
    Expect(0, 120468, '\p{SD=:\AY\z:}', "");;
    Expect(1, 120467, '\p{SD=y}', "");
    Expect(0, 120467, '\p{^SD=y}', "");
    Expect(0, 120467, '\P{SD=y}', "");
    Expect(1, 120467, '\P{^SD=y}', "");
    Expect(0, 120468, '\p{SD=y}', "");
    Expect(1, 120468, '\p{^SD=y}', "");
    Expect(1, 120468, '\P{SD=y}', "");
    Expect(0, 120468, '\P{^SD=y}', "");
    Expect(1, 120467, '\p{SD=:\Ay\z:}', "");;
    Expect(0, 120468, '\p{SD=:\Ay\z:}', "");;
    Expect(1, 120467, '\p{SD=	Y}', "");
    Expect(0, 120467, '\p{^SD=	Y}', "");
    Expect(0, 120467, '\P{SD=	Y}', "");
    Expect(1, 120467, '\P{^SD=	Y}', "");
    Expect(0, 120468, '\p{SD=	Y}', "");
    Expect(1, 120468, '\p{^SD=	Y}', "");
    Expect(1, 120468, '\P{SD=	Y}', "");
    Expect(0, 120468, '\P{^SD=	Y}', "");
    Error('\p{Is_Soft_Dotted=	:=T}');
    Error('\P{Is_Soft_Dotted=	:=T}');
    Expect(1, 120467, '\p{Is_Soft_Dotted=t}', "");
    Expect(0, 120467, '\p{^Is_Soft_Dotted=t}', "");
    Expect(0, 120467, '\P{Is_Soft_Dotted=t}', "");
    Expect(1, 120467, '\P{^Is_Soft_Dotted=t}', "");
    Expect(0, 120468, '\p{Is_Soft_Dotted=t}', "");
    Expect(1, 120468, '\p{^Is_Soft_Dotted=t}', "");
    Expect(1, 120468, '\P{Is_Soft_Dotted=t}', "");
    Expect(0, 120468, '\P{^Is_Soft_Dotted=t}', "");
    Expect(1, 120467, '\p{Is_Soft_Dotted=- T}', "");
    Expect(0, 120467, '\p{^Is_Soft_Dotted=- T}', "");
    Expect(0, 120467, '\P{Is_Soft_Dotted=- T}', "");
    Expect(1, 120467, '\P{^Is_Soft_Dotted=- T}', "");
    Expect(0, 120468, '\p{Is_Soft_Dotted=- T}', "");
    Expect(1, 120468, '\p{^Is_Soft_Dotted=- T}', "");
    Expect(1, 120468, '\P{Is_Soft_Dotted=- T}', "");
    Expect(0, 120468, '\P{^Is_Soft_Dotted=- T}', "");
    Error('\p{Is_SD=/a/True}');
    Error('\P{Is_SD=/a/True}');
    Expect(1, 120467, '\p{Is_SD=true}', "");
    Expect(0, 120467, '\p{^Is_SD=true}', "");
    Expect(0, 120467, '\P{Is_SD=true}', "");
    Expect(1, 120467, '\P{^Is_SD=true}', "");
    Expect(0, 120468, '\p{Is_SD=true}', "");
    Expect(1, 120468, '\p{^Is_SD=true}', "");
    Expect(1, 120468, '\P{Is_SD=true}', "");
    Expect(0, 120468, '\P{^Is_SD=true}', "");
    Expect(1, 120467, '\p{Is_SD= -true}', "");
    Expect(0, 120467, '\p{^Is_SD= -true}', "");
    Expect(0, 120467, '\P{Is_SD= -true}', "");
    Expect(1, 120467, '\P{^Is_SD= -true}', "");
    Expect(0, 120468, '\p{Is_SD= -true}', "");
    Expect(1, 120468, '\p{^Is_SD= -true}', "");
    Expect(1, 120468, '\P{Is_SD= -true}', "");
    Expect(0, 120468, '\P{^Is_SD= -true}', "");
    Error('\p{simplelowercasemapping}');
    Error('\P{simplelowercasemapping}');
    Error('\p{slc}');
    Error('\P{slc}');
    Error('\p{simpletitlecasemapping}');
    Error('\P{simpletitlecasemapping}');
    Error('\p{stc}');
    Error('\P{stc}');
    Error('\p{Sentence_Terminal=-No/a/}');
    Error('\P{Sentence_Terminal=-No/a/}');
    Expect(1, 121481, '\p{Sentence_Terminal=:\ANo\z:}', "");;
    Expect(0, 121480, '\p{Sentence_Terminal=:\ANo\z:}', "");;
    Expect(1, 121481, '\p{Sentence_Terminal=no}', "");
    Expect(0, 121481, '\p{^Sentence_Terminal=no}', "");
    Expect(0, 121481, '\P{Sentence_Terminal=no}', "");
    Expect(1, 121481, '\P{^Sentence_Terminal=no}', "");
    Expect(0, 121480, '\p{Sentence_Terminal=no}', "");
    Expect(1, 121480, '\p{^Sentence_Terminal=no}', "");
    Expect(1, 121480, '\P{Sentence_Terminal=no}', "");
    Expect(0, 121480, '\P{^Sentence_Terminal=no}', "");
    Expect(1, 121481, '\p{Sentence_Terminal=:\Ano\z:}', "");;
    Expect(0, 121480, '\p{Sentence_Terminal=:\Ano\z:}', "");;
    Expect(1, 121481, '\p{Sentence_Terminal=_-no}', "");
    Expect(0, 121481, '\p{^Sentence_Terminal=_-no}', "");
    Expect(0, 121481, '\P{Sentence_Terminal=_-no}', "");
    Expect(1, 121481, '\P{^Sentence_Terminal=_-no}', "");
    Expect(0, 121480, '\p{Sentence_Terminal=_-no}', "");
    Expect(1, 121480, '\p{^Sentence_Terminal=_-no}', "");
    Expect(1, 121480, '\P{Sentence_Terminal=_-no}', "");
    Expect(0, 121480, '\P{^Sentence_Terminal=_-no}', "");
    Error('\p{STerm=_	n/a/}');
    Error('\P{STerm=_	n/a/}');
    Expect(1, 121481, '\p{STerm=:\AN\z:}', "");;
    Expect(0, 121480, '\p{STerm=:\AN\z:}', "");;
    Expect(1, 121481, '\p{STerm=n}', "");
    Expect(0, 121481, '\p{^STerm=n}', "");
    Expect(0, 121481, '\P{STerm=n}', "");
    Expect(1, 121481, '\P{^STerm=n}', "");
    Expect(0, 121480, '\p{STerm=n}', "");
    Expect(1, 121480, '\p{^STerm=n}', "");
    Expect(1, 121480, '\P{STerm=n}', "");
    Expect(0, 121480, '\P{^STerm=n}', "");
    Expect(1, 121481, '\p{STerm=:\An\z:}', "");;
    Expect(0, 121480, '\p{STerm=:\An\z:}', "");;
    Expect(1, 121481, '\p{STerm=--N}', "");
    Expect(0, 121481, '\p{^STerm=--N}', "");
    Expect(0, 121481, '\P{STerm=--N}', "");
    Expect(1, 121481, '\P{^STerm=--N}', "");
    Expect(0, 121480, '\p{STerm=--N}', "");
    Expect(1, 121480, '\p{^STerm=--N}', "");
    Expect(1, 121480, '\P{STerm=--N}', "");
    Expect(0, 121480, '\P{^STerm=--N}', "");
    Error('\p{Is_Sentence_Terminal= :=f}');
    Error('\P{Is_Sentence_Terminal= :=f}');
    Expect(1, 121481, '\p{Is_Sentence_Terminal=f}', "");
    Expect(0, 121481, '\p{^Is_Sentence_Terminal=f}', "");
    Expect(0, 121481, '\P{Is_Sentence_Terminal=f}', "");
    Expect(1, 121481, '\P{^Is_Sentence_Terminal=f}', "");
    Expect(0, 121480, '\p{Is_Sentence_Terminal=f}', "");
    Expect(1, 121480, '\p{^Is_Sentence_Terminal=f}', "");
    Expect(1, 121480, '\P{Is_Sentence_Terminal=f}', "");
    Expect(0, 121480, '\P{^Is_Sentence_Terminal=f}', "");
    Expect(1, 121481, '\p{Is_Sentence_Terminal=-F}', "");
    Expect(0, 121481, '\p{^Is_Sentence_Terminal=-F}', "");
    Expect(0, 121481, '\P{Is_Sentence_Terminal=-F}', "");
    Expect(1, 121481, '\P{^Is_Sentence_Terminal=-F}', "");
    Expect(0, 121480, '\p{Is_Sentence_Terminal=-F}', "");
    Expect(1, 121480, '\p{^Is_Sentence_Terminal=-F}', "");
    Expect(1, 121480, '\P{Is_Sentence_Terminal=-F}', "");
    Expect(0, 121480, '\P{^Is_Sentence_Terminal=-F}', "");
    Error('\p{Is_STerm=	False:=}');
    Error('\P{Is_STerm=	False:=}');
    Expect(1, 121481, '\p{Is_STerm=false}', "");
    Expect(0, 121481, '\p{^Is_STerm=false}', "");
    Expect(0, 121481, '\P{Is_STerm=false}', "");
    Expect(1, 121481, '\P{^Is_STerm=false}', "");
    Expect(0, 121480, '\p{Is_STerm=false}', "");
    Expect(1, 121480, '\p{^Is_STerm=false}', "");
    Expect(1, 121480, '\P{Is_STerm=false}', "");
    Expect(0, 121480, '\P{^Is_STerm=false}', "");
    Expect(1, 121481, '\p{Is_STerm=	false}', "");
    Expect(0, 121481, '\p{^Is_STerm=	false}', "");
    Expect(0, 121481, '\P{Is_STerm=	false}', "");
    Expect(1, 121481, '\P{^Is_STerm=	false}', "");
    Expect(0, 121480, '\p{Is_STerm=	false}', "");
    Expect(1, 121480, '\p{^Is_STerm=	false}', "");
    Expect(1, 121480, '\P{Is_STerm=	false}', "");
    Expect(0, 121480, '\P{^Is_STerm=	false}', "");
    Error('\p{Sentence_Terminal=/a/ YES}');
    Error('\P{Sentence_Terminal=/a/ YES}');
    Expect(1, 121480, '\p{Sentence_Terminal=:\AYes\z:}', "");;
    Expect(0, 121481, '\p{Sentence_Terminal=:\AYes\z:}', "");;
    Expect(1, 121480, '\p{Sentence_Terminal=yes}', "");
    Expect(0, 121480, '\p{^Sentence_Terminal=yes}', "");
    Expect(0, 121480, '\P{Sentence_Terminal=yes}', "");
    Expect(1, 121480, '\P{^Sentence_Terminal=yes}', "");
    Expect(0, 121481, '\p{Sentence_Terminal=yes}', "");
    Expect(1, 121481, '\p{^Sentence_Terminal=yes}', "");
    Expect(1, 121481, '\P{Sentence_Terminal=yes}', "");
    Expect(0, 121481, '\P{^Sentence_Terminal=yes}', "");
    Expect(1, 121480, '\p{Sentence_Terminal=:\Ayes\z:}', "");;
    Expect(0, 121481, '\p{Sentence_Terminal=:\Ayes\z:}', "");;
    Error('\p{STerm=_y/a/}');
    Error('\P{STerm=_y/a/}');
    Expect(1, 121480, '\p{STerm=:\AY\z:}', "");;
    Expect(0, 121481, '\p{STerm=:\AY\z:}', "");;
    Expect(1, 121480, '\p{STerm=y}', "");
    Expect(0, 121480, '\p{^STerm=y}', "");
    Expect(0, 121480, '\P{STerm=y}', "");
    Expect(1, 121480, '\P{^STerm=y}', "");
    Expect(0, 121481, '\p{STerm=y}', "");
    Expect(1, 121481, '\p{^STerm=y}', "");
    Expect(1, 121481, '\P{STerm=y}', "");
    Expect(0, 121481, '\P{^STerm=y}', "");
    Expect(1, 121480, '\p{STerm=:\Ay\z:}', "");;
    Expect(0, 121481, '\p{STerm=:\Ay\z:}', "");;
    Expect(1, 121480, '\p{STerm=_	y}', "");
    Expect(0, 121480, '\p{^STerm=_	y}', "");
    Expect(0, 121480, '\P{STerm=_	y}', "");
    Expect(1, 121480, '\P{^STerm=_	y}', "");
    Expect(0, 121481, '\p{STerm=_	y}', "");
    Expect(1, 121481, '\p{^STerm=_	y}', "");
    Expect(1, 121481, '\P{STerm=_	y}', "");
    Expect(0, 121481, '\P{^STerm=_	y}', "");
    Error('\p{Is_Sentence_Terminal=:= 	T}');
    Error('\P{Is_Sentence_Terminal=:= 	T}');
    Expect(1, 121480, '\p{Is_Sentence_Terminal:	t}', "");
    Expect(0, 121480, '\p{^Is_Sentence_Terminal:	t}', "");
    Expect(0, 121480, '\P{Is_Sentence_Terminal:	t}', "");
    Expect(1, 121480, '\P{^Is_Sentence_Terminal:	t}', "");
    Expect(0, 121481, '\p{Is_Sentence_Terminal:	t}', "");
    Expect(1, 121481, '\p{^Is_Sentence_Terminal:	t}', "");
    Expect(1, 121481, '\P{Is_Sentence_Terminal:	t}', "");
    Expect(0, 121481, '\P{^Is_Sentence_Terminal:	t}', "");
    Expect(1, 121480, '\p{Is_Sentence_Terminal= T}', "");
    Expect(0, 121480, '\p{^Is_Sentence_Terminal= T}', "");
    Expect(0, 121480, '\P{Is_Sentence_Terminal= T}', "");
    Expect(1, 121480, '\P{^Is_Sentence_Terminal= T}', "");
    Expect(0, 121481, '\p{Is_Sentence_Terminal= T}', "");
    Expect(1, 121481, '\p{^Is_Sentence_Terminal= T}', "");
    Expect(1, 121481, '\P{Is_Sentence_Terminal= T}', "");
    Expect(0, 121481, '\P{^Is_Sentence_Terminal= T}', "");
    Error('\p{Is_STerm=_:=True}');
    Error('\P{Is_STerm=_:=True}');
    Expect(1, 121480, '\p{Is_STerm=true}', "");
    Expect(0, 121480, '\p{^Is_STerm=true}', "");
    Expect(0, 121480, '\P{Is_STerm=true}', "");
    Expect(1, 121480, '\P{^Is_STerm=true}', "");
    Expect(0, 121481, '\p{Is_STerm=true}', "");
    Expect(1, 121481, '\p{^Is_STerm=true}', "");
    Expect(1, 121481, '\P{Is_STerm=true}', "");
    Expect(0, 121481, '\P{^Is_STerm=true}', "");
    Expect(1, 121480, '\p{Is_STerm= _TRUE}', "");
    Expect(0, 121480, '\p{^Is_STerm= _TRUE}', "");
    Expect(0, 121480, '\P{Is_STerm= _TRUE}', "");
    Expect(1, 121480, '\P{^Is_STerm= _TRUE}', "");
    Expect(0, 121481, '\p{Is_STerm= _TRUE}', "");
    Expect(1, 121481, '\p{^Is_STerm= _TRUE}', "");
    Expect(1, 121481, '\P{Is_STerm= _TRUE}', "");
    Expect(0, 121481, '\P{^Is_STerm= _TRUE}', "");
    Error('\p{simpleuppercasemapping}');
    Error('\P{simpleuppercasemapping}');
    Error('\p{suc}');
    Error('\P{suc}');
    Error('\p{titlecasemapping}');
    Error('\P{titlecasemapping}');
    Error('\p{tc}');
    Error('\P{tc}');
    Error('\p{Terminal_Punctuation=-_no:=}');
    Error('\P{Terminal_Punctuation=-_no:=}');
    Expect(1, 121483, '\p{Terminal_Punctuation=:\ANo\z:}', "");;
    Expect(0, 121482, '\p{Terminal_Punctuation=:\ANo\z:}', "");;
    Expect(1, 121483, '\p{Terminal_Punctuation=no}', "");
    Expect(0, 121483, '\p{^Terminal_Punctuation=no}', "");
    Expect(0, 121483, '\P{Terminal_Punctuation=no}', "");
    Expect(1, 121483, '\P{^Terminal_Punctuation=no}', "");
    Expect(0, 121482, '\p{Terminal_Punctuation=no}', "");
    Expect(1, 121482, '\p{^Terminal_Punctuation=no}', "");
    Expect(1, 121482, '\P{Terminal_Punctuation=no}', "");
    Expect(0, 121482, '\P{^Terminal_Punctuation=no}', "");
    Expect(1, 121483, '\p{Terminal_Punctuation=:\Ano\z:}', "");;
    Expect(0, 121482, '\p{Terminal_Punctuation=:\Ano\z:}', "");;
    Expect(1, 121483, '\p{Terminal_Punctuation=- no}', "");
    Expect(0, 121483, '\p{^Terminal_Punctuation=- no}', "");
    Expect(0, 121483, '\P{Terminal_Punctuation=- no}', "");
    Expect(1, 121483, '\P{^Terminal_Punctuation=- no}', "");
    Expect(0, 121482, '\p{Terminal_Punctuation=- no}', "");
    Expect(1, 121482, '\p{^Terminal_Punctuation=- no}', "");
    Expect(1, 121482, '\P{Terminal_Punctuation=- no}', "");
    Expect(0, 121482, '\P{^Terminal_Punctuation=- no}', "");
    Error('\p{Term=	/a/N}');
    Error('\P{Term=	/a/N}');
    Expect(1, 121483, '\p{Term=:\AN\z:}', "");;
    Expect(0, 121482, '\p{Term=:\AN\z:}', "");;
    Expect(1, 121483, '\p{Term=n}', "");
    Expect(0, 121483, '\p{^Term=n}', "");
    Expect(0, 121483, '\P{Term=n}', "");
    Expect(1, 121483, '\P{^Term=n}', "");
    Expect(0, 121482, '\p{Term=n}', "");
    Expect(1, 121482, '\p{^Term=n}', "");
    Expect(1, 121482, '\P{Term=n}', "");
    Expect(0, 121482, '\P{^Term=n}', "");
    Expect(1, 121483, '\p{Term=:\An\z:}', "");;
    Expect(0, 121482, '\p{Term=:\An\z:}', "");;
    Expect(1, 121483, '\p{Term=	 n}', "");
    Expect(0, 121483, '\p{^Term=	 n}', "");
    Expect(0, 121483, '\P{Term=	 n}', "");
    Expect(1, 121483, '\P{^Term=	 n}', "");
    Expect(0, 121482, '\p{Term=	 n}', "");
    Expect(1, 121482, '\p{^Term=	 n}', "");
    Expect(1, 121482, '\P{Term=	 n}', "");
    Expect(0, 121482, '\P{^Term=	 n}', "");
    Error('\p{Is_Terminal_Punctuation=:= -F}');
    Error('\P{Is_Terminal_Punctuation=:= -F}');
    Expect(1, 121483, '\p{Is_Terminal_Punctuation: f}', "");
    Expect(0, 121483, '\p{^Is_Terminal_Punctuation: f}', "");
    Expect(0, 121483, '\P{Is_Terminal_Punctuation: f}', "");
    Expect(1, 121483, '\P{^Is_Terminal_Punctuation: f}', "");
    Expect(0, 121482, '\p{Is_Terminal_Punctuation: f}', "");
    Expect(1, 121482, '\p{^Is_Terminal_Punctuation: f}', "");
    Expect(1, 121482, '\P{Is_Terminal_Punctuation: f}', "");
    Expect(0, 121482, '\P{^Is_Terminal_Punctuation: f}', "");
    Expect(1, 121483, '\p{Is_Terminal_Punctuation=-F}', "");
    Expect(0, 121483, '\p{^Is_Terminal_Punctuation=-F}', "");
    Expect(0, 121483, '\P{Is_Terminal_Punctuation=-F}', "");
    Expect(1, 121483, '\P{^Is_Terminal_Punctuation=-F}', "");
    Expect(0, 121482, '\p{Is_Terminal_Punctuation=-F}', "");
    Expect(1, 121482, '\p{^Is_Terminal_Punctuation=-F}', "");
    Expect(1, 121482, '\P{Is_Terminal_Punctuation=-F}', "");
    Expect(0, 121482, '\P{^Is_Terminal_Punctuation=-F}', "");
    Error('\p{Is_Term= 	False/a/}');
    Error('\P{Is_Term= 	False/a/}');
    Expect(1, 121483, '\p{Is_Term:   false}', "");
    Expect(0, 121483, '\p{^Is_Term:   false}', "");
    Expect(0, 121483, '\P{Is_Term:   false}', "");
    Expect(1, 121483, '\P{^Is_Term:   false}', "");
    Expect(0, 121482, '\p{Is_Term:   false}', "");
    Expect(1, 121482, '\p{^Is_Term:   false}', "");
    Expect(1, 121482, '\P{Is_Term:   false}', "");
    Expect(0, 121482, '\P{^Is_Term:   false}', "");
    Error('\p{Terminal_Punctuation=	/a/Yes}');
    Error('\P{Terminal_Punctuation=	/a/Yes}');
    Expect(1, 121482, '\p{Terminal_Punctuation=:\AYes\z:}', "");;
    Expect(0, 121483, '\p{Terminal_Punctuation=:\AYes\z:}', "");;
    Expect(1, 121482, '\p{Terminal_Punctuation:   yes}', "");
    Expect(0, 121482, '\p{^Terminal_Punctuation:   yes}', "");
    Expect(0, 121482, '\P{Terminal_Punctuation:   yes}', "");
    Expect(1, 121482, '\P{^Terminal_Punctuation:   yes}', "");
    Expect(0, 121483, '\p{Terminal_Punctuation:   yes}', "");
    Expect(1, 121483, '\p{^Terminal_Punctuation:   yes}', "");
    Expect(1, 121483, '\P{Terminal_Punctuation:   yes}', "");
    Expect(0, 121483, '\P{^Terminal_Punctuation:   yes}', "");
    Expect(1, 121482, '\p{Terminal_Punctuation=:\Ayes\z:}', "");;
    Expect(0, 121483, '\p{Terminal_Punctuation=:\Ayes\z:}', "");;
    Expect(1, 121482, '\p{Terminal_Punctuation=-	Yes}', "");
    Expect(0, 121482, '\p{^Terminal_Punctuation=-	Yes}', "");
    Expect(0, 121482, '\P{Terminal_Punctuation=-	Yes}', "");
    Expect(1, 121482, '\P{^Terminal_Punctuation=-	Yes}', "");
    Expect(0, 121483, '\p{Terminal_Punctuation=-	Yes}', "");
    Expect(1, 121483, '\p{^Terminal_Punctuation=-	Yes}', "");
    Expect(1, 121483, '\P{Terminal_Punctuation=-	Yes}', "");
    Expect(0, 121483, '\P{^Terminal_Punctuation=-	Yes}', "");
    Error('\p{Term=Y/a/}');
    Error('\P{Term=Y/a/}');
    Expect(1, 121482, '\p{Term=:\AY\z:}', "");;
    Expect(0, 121483, '\p{Term=:\AY\z:}', "");;
    Expect(1, 121482, '\p{Term=y}', "");
    Expect(0, 121482, '\p{^Term=y}', "");
    Expect(0, 121482, '\P{Term=y}', "");
    Expect(1, 121482, '\P{^Term=y}', "");
    Expect(0, 121483, '\p{Term=y}', "");
    Expect(1, 121483, '\p{^Term=y}', "");
    Expect(1, 121483, '\P{Term=y}', "");
    Expect(0, 121483, '\P{^Term=y}', "");
    Expect(1, 121482, '\p{Term=:\Ay\z:}', "");;
    Expect(0, 121483, '\p{Term=:\Ay\z:}', "");;
    Expect(1, 121482, '\p{Term=_-Y}', "");
    Expect(0, 121482, '\p{^Term=_-Y}', "");
    Expect(0, 121482, '\P{Term=_-Y}', "");
    Expect(1, 121482, '\P{^Term=_-Y}', "");
    Expect(0, 121483, '\p{Term=_-Y}', "");
    Expect(1, 121483, '\p{^Term=_-Y}', "");
    Expect(1, 121483, '\P{Term=_-Y}', "");
    Expect(0, 121483, '\P{^Term=_-Y}', "");
    Error('\p{Is_Terminal_Punctuation:	 T/a/}');
    Error('\P{Is_Terminal_Punctuation:	 T/a/}');
    Expect(1, 121482, '\p{Is_Terminal_Punctuation=t}', "");
    Expect(0, 121482, '\p{^Is_Terminal_Punctuation=t}', "");
    Expect(0, 121482, '\P{Is_Terminal_Punctuation=t}', "");
    Expect(1, 121482, '\P{^Is_Terminal_Punctuation=t}', "");
    Expect(0, 121483, '\p{Is_Terminal_Punctuation=t}', "");
    Expect(1, 121483, '\p{^Is_Terminal_Punctuation=t}', "");
    Expect(1, 121483, '\P{Is_Terminal_Punctuation=t}', "");
    Expect(0, 121483, '\P{^Is_Terminal_Punctuation=t}', "");
    Expect(1, 121482, '\p{Is_Terminal_Punctuation= 	T}', "");
    Expect(0, 121482, '\p{^Is_Terminal_Punctuation= 	T}', "");
    Expect(0, 121482, '\P{Is_Terminal_Punctuation= 	T}', "");
    Expect(1, 121482, '\P{^Is_Terminal_Punctuation= 	T}', "");
    Expect(0, 121483, '\p{Is_Terminal_Punctuation= 	T}', "");
    Expect(1, 121483, '\p{^Is_Terminal_Punctuation= 	T}', "");
    Expect(1, 121483, '\P{Is_Terminal_Punctuation= 	T}', "");
    Expect(0, 121483, '\P{^Is_Terminal_Punctuation= 	T}', "");
    Error('\p{Is_Term=_:=TRUE}');
    Error('\P{Is_Term=_:=TRUE}');
    Expect(1, 121482, '\p{Is_Term=true}', "");
    Expect(0, 121482, '\p{^Is_Term=true}', "");
    Expect(0, 121482, '\P{Is_Term=true}', "");
    Expect(1, 121482, '\P{^Is_Term=true}', "");
    Expect(0, 121483, '\p{Is_Term=true}', "");
    Expect(1, 121483, '\p{^Is_Term=true}', "");
    Expect(1, 121483, '\P{Is_Term=true}', "");
    Expect(0, 121483, '\P{^Is_Term=true}', "");
    Expect(1, 121482, '\p{Is_Term= -TRUE}', "");
    Expect(0, 121482, '\p{^Is_Term= -TRUE}', "");
    Expect(0, 121482, '\P{Is_Term= -TRUE}', "");
    Expect(1, 121482, '\P{^Is_Term= -TRUE}', "");
    Expect(0, 121483, '\p{Is_Term= -TRUE}', "");
    Expect(1, 121483, '\p{^Is_Term= -TRUE}', "");
    Expect(1, 121483, '\P{Is_Term= -TRUE}', "");
    Expect(0, 121483, '\P{^Is_Term= -TRUE}', "");
    Error('\p{uppercasemapping}');
    Error('\P{uppercasemapping}');
    Error('\p{uc}');
    Error('\P{uc}');
    Error('\p{Unified_Ideograph=-_No/a/}');
    Error('\P{Unified_Ideograph=-_No/a/}');
    Expect(1, 201547, '\p{Unified_Ideograph=:\ANo\z:}', "");;
    Expect(0, 201546, '\p{Unified_Ideograph=:\ANo\z:}', "");;
    Expect(1, 201547, '\p{Unified_Ideograph:no}', "");
    Expect(0, 201547, '\p{^Unified_Ideograph:no}', "");
    Expect(0, 201547, '\P{Unified_Ideograph:no}', "");
    Expect(1, 201547, '\P{^Unified_Ideograph:no}', "");
    Expect(0, 201546, '\p{Unified_Ideograph:no}', "");
    Expect(1, 201546, '\p{^Unified_Ideograph:no}', "");
    Expect(1, 201546, '\P{Unified_Ideograph:no}', "");
    Expect(0, 201546, '\P{^Unified_Ideograph:no}', "");
    Expect(1, 201547, '\p{Unified_Ideograph=:\Ano\z:}', "");;
    Expect(0, 201546, '\p{Unified_Ideograph=:\Ano\z:}', "");;
    Expect(1, 201547, '\p{Unified_Ideograph= No}', "");
    Expect(0, 201547, '\p{^Unified_Ideograph= No}', "");
    Expect(0, 201547, '\P{Unified_Ideograph= No}', "");
    Expect(1, 201547, '\P{^Unified_Ideograph= No}', "");
    Expect(0, 201546, '\p{Unified_Ideograph= No}', "");
    Expect(1, 201546, '\p{^Unified_Ideograph= No}', "");
    Expect(1, 201546, '\P{Unified_Ideograph= No}', "");
    Expect(0, 201546, '\P{^Unified_Ideograph= No}', "");
    Error('\p{UIdeo=__N:=}');
    Error('\P{UIdeo=__N:=}');
    Expect(1, 201547, '\p{UIdeo=:\AN\z:}', "");;
    Expect(0, 201546, '\p{UIdeo=:\AN\z:}', "");;
    Expect(1, 201547, '\p{UIdeo=n}', "");
    Expect(0, 201547, '\p{^UIdeo=n}', "");
    Expect(0, 201547, '\P{UIdeo=n}', "");
    Expect(1, 201547, '\P{^UIdeo=n}', "");
    Expect(0, 201546, '\p{UIdeo=n}', "");
    Expect(1, 201546, '\p{^UIdeo=n}', "");
    Expect(1, 201546, '\P{UIdeo=n}', "");
    Expect(0, 201546, '\P{^UIdeo=n}', "");
    Expect(1, 201547, '\p{UIdeo=:\An\z:}', "");;
    Expect(0, 201546, '\p{UIdeo=:\An\z:}', "");;
    Expect(1, 201547, '\p{UIdeo=-N}', "");
    Expect(0, 201547, '\p{^UIdeo=-N}', "");
    Expect(0, 201547, '\P{UIdeo=-N}', "");
    Expect(1, 201547, '\P{^UIdeo=-N}', "");
    Expect(0, 201546, '\p{UIdeo=-N}', "");
    Expect(1, 201546, '\p{^UIdeo=-N}', "");
    Expect(1, 201546, '\P{UIdeo=-N}', "");
    Expect(0, 201546, '\P{^UIdeo=-N}', "");
    Error('\p{Is_Unified_Ideograph=	/a/f}');
    Error('\P{Is_Unified_Ideograph=	/a/f}');
    Expect(1, 201547, '\p{Is_Unified_Ideograph=f}', "");
    Expect(0, 201547, '\p{^Is_Unified_Ideograph=f}', "");
    Expect(0, 201547, '\P{Is_Unified_Ideograph=f}', "");
    Expect(1, 201547, '\P{^Is_Unified_Ideograph=f}', "");
    Expect(0, 201546, '\p{Is_Unified_Ideograph=f}', "");
    Expect(1, 201546, '\p{^Is_Unified_Ideograph=f}', "");
    Expect(1, 201546, '\P{Is_Unified_Ideograph=f}', "");
    Expect(0, 201546, '\P{^Is_Unified_Ideograph=f}', "");
    Expect(1, 201547, '\p{Is_Unified_Ideograph=	 F}', "");
    Expect(0, 201547, '\p{^Is_Unified_Ideograph=	 F}', "");
    Expect(0, 201547, '\P{Is_Unified_Ideograph=	 F}', "");
    Expect(1, 201547, '\P{^Is_Unified_Ideograph=	 F}', "");
    Expect(0, 201546, '\p{Is_Unified_Ideograph=	 F}', "");
    Expect(1, 201546, '\p{^Is_Unified_Ideograph=	 F}', "");
    Expect(1, 201546, '\P{Is_Unified_Ideograph=	 F}', "");
    Expect(0, 201546, '\P{^Is_Unified_Ideograph=	 F}', "");
    Error('\p{Is_UIdeo=-:=False}');
    Error('\P{Is_UIdeo=-:=False}');
    Expect(1, 201547, '\p{Is_UIdeo=false}', "");
    Expect(0, 201547, '\p{^Is_UIdeo=false}', "");
    Expect(0, 201547, '\P{Is_UIdeo=false}', "");
    Expect(1, 201547, '\P{^Is_UIdeo=false}', "");
    Expect(0, 201546, '\p{Is_UIdeo=false}', "");
    Expect(1, 201546, '\p{^Is_UIdeo=false}', "");
    Expect(1, 201546, '\P{Is_UIdeo=false}', "");
    Expect(0, 201546, '\P{^Is_UIdeo=false}', "");
    Expect(1, 201547, '\p{Is_UIdeo=	_False}', "");
    Expect(0, 201547, '\p{^Is_UIdeo=	_False}', "");
    Expect(0, 201547, '\P{Is_UIdeo=	_False}', "");
    Expect(1, 201547, '\P{^Is_UIdeo=	_False}', "");
    Expect(0, 201546, '\p{Is_UIdeo=	_False}', "");
    Expect(1, 201546, '\p{^Is_UIdeo=	_False}', "");
    Expect(1, 201546, '\P{Is_UIdeo=	_False}', "");
    Expect(0, 201546, '\P{^Is_UIdeo=	_False}', "");
    Error('\p{Unified_Ideograph=-yes/a/}');
    Error('\P{Unified_Ideograph=-yes/a/}');
    Expect(1, 201546, '\p{Unified_Ideograph=:\AYes\z:}', "");;
    Expect(0, 201547, '\p{Unified_Ideograph=:\AYes\z:}', "");;
    Expect(1, 201546, '\p{Unified_Ideograph=yes}', "");
    Expect(0, 201546, '\p{^Unified_Ideograph=yes}', "");
    Expect(0, 201546, '\P{Unified_Ideograph=yes}', "");
    Expect(1, 201546, '\P{^Unified_Ideograph=yes}', "");
    Expect(0, 201547, '\p{Unified_Ideograph=yes}', "");
    Expect(1, 201547, '\p{^Unified_Ideograph=yes}', "");
    Expect(1, 201547, '\P{Unified_Ideograph=yes}', "");
    Expect(0, 201547, '\P{^Unified_Ideograph=yes}', "");
    Expect(1, 201546, '\p{Unified_Ideograph=:\Ayes\z:}', "");;
    Expect(0, 201547, '\p{Unified_Ideograph=:\Ayes\z:}', "");;
    Expect(1, 201546, '\p{Unified_Ideograph=-_YES}', "");
    Expect(0, 201546, '\p{^Unified_Ideograph=-_YES}', "");
    Expect(0, 201546, '\P{Unified_Ideograph=-_YES}', "");
    Expect(1, 201546, '\P{^Unified_Ideograph=-_YES}', "");
    Expect(0, 201547, '\p{Unified_Ideograph=-_YES}', "");
    Expect(1, 201547, '\p{^Unified_Ideograph=-_YES}', "");
    Expect(1, 201547, '\P{Unified_Ideograph=-_YES}', "");
    Expect(0, 201547, '\P{^Unified_Ideograph=-_YES}', "");
    Error('\p{UIdeo=/a/ 	Y}');
    Error('\P{UIdeo=/a/ 	Y}');
    Expect(1, 201546, '\p{UIdeo=:\AY\z:}', "");;
    Expect(0, 201547, '\p{UIdeo=:\AY\z:}', "");;
    Expect(1, 201546, '\p{UIdeo=y}', "");
    Expect(0, 201546, '\p{^UIdeo=y}', "");
    Expect(0, 201546, '\P{UIdeo=y}', "");
    Expect(1, 201546, '\P{^UIdeo=y}', "");
    Expect(0, 201547, '\p{UIdeo=y}', "");
    Expect(1, 201547, '\p{^UIdeo=y}', "");
    Expect(1, 201547, '\P{UIdeo=y}', "");
    Expect(0, 201547, '\P{^UIdeo=y}', "");
    Expect(1, 201546, '\p{UIdeo=:\Ay\z:}', "");;
    Expect(0, 201547, '\p{UIdeo=:\Ay\z:}', "");;
    Expect(1, 201546, '\p{UIdeo=-_Y}', "");
    Expect(0, 201546, '\p{^UIdeo=-_Y}', "");
    Expect(0, 201546, '\P{UIdeo=-_Y}', "");
    Expect(1, 201546, '\P{^UIdeo=-_Y}', "");
    Expect(0, 201547, '\p{UIdeo=-_Y}', "");
    Expect(1, 201547, '\p{^UIdeo=-_Y}', "");
    Expect(1, 201547, '\P{UIdeo=-_Y}', "");
    Expect(0, 201547, '\P{^UIdeo=-_Y}', "");
    Error('\p{Is_Unified_Ideograph=/a/ T}');
    Error('\P{Is_Unified_Ideograph=/a/ T}');
    Expect(1, 201546, '\p{Is_Unified_Ideograph=t}', "");
    Expect(0, 201546, '\p{^Is_Unified_Ideograph=t}', "");
    Expect(0, 201546, '\P{Is_Unified_Ideograph=t}', "");
    Expect(1, 201546, '\P{^Is_Unified_Ideograph=t}', "");
    Expect(0, 201547, '\p{Is_Unified_Ideograph=t}', "");
    Expect(1, 201547, '\p{^Is_Unified_Ideograph=t}', "");
    Expect(1, 201547, '\P{Is_Unified_Ideograph=t}', "");
    Expect(0, 201547, '\P{^Is_Unified_Ideograph=t}', "");
    Expect(1, 201546, '\p{Is_Unified_Ideograph=	 T}', "");
    Expect(0, 201546, '\p{^Is_Unified_Ideograph=	 T}', "");
    Expect(0, 201546, '\P{Is_Unified_Ideograph=	 T}', "");
    Expect(1, 201546, '\P{^Is_Unified_Ideograph=	 T}', "");
    Expect(0, 201547, '\p{Is_Unified_Ideograph=	 T}', "");
    Expect(1, 201547, '\p{^Is_Unified_Ideograph=	 T}', "");
    Expect(1, 201547, '\P{Is_Unified_Ideograph=	 T}', "");
    Expect(0, 201547, '\P{^Is_Unified_Ideograph=	 T}', "");
    Error('\p{Is_UIdeo=_ True/a/}');
    Error('\P{Is_UIdeo=_ True/a/}');
    Expect(1, 201546, '\p{Is_UIdeo=true}', "");
    Expect(0, 201546, '\p{^Is_UIdeo=true}', "");
    Expect(0, 201546, '\P{Is_UIdeo=true}', "");
    Expect(1, 201546, '\P{^Is_UIdeo=true}', "");
    Expect(0, 201547, '\p{Is_UIdeo=true}', "");
    Expect(1, 201547, '\p{^Is_UIdeo=true}', "");
    Expect(1, 201547, '\P{Is_UIdeo=true}', "");
    Expect(0, 201547, '\P{^Is_UIdeo=true}', "");
    Expect(1, 201546, '\p{Is_UIdeo=  TRUE}', "");
    Expect(0, 201546, '\p{^Is_UIdeo=  TRUE}', "");
    Expect(0, 201546, '\P{Is_UIdeo=  TRUE}', "");
    Expect(1, 201546, '\P{^Is_UIdeo=  TRUE}', "");
    Expect(0, 201547, '\p{Is_UIdeo=  TRUE}', "");
    Expect(1, 201547, '\p{^Is_UIdeo=  TRUE}', "");
    Expect(1, 201547, '\P{Is_UIdeo=  TRUE}', "");
    Expect(0, 201547, '\P{^Is_UIdeo=  TRUE}', "");
    Error('\p{Uppercase=/a/	_NO}');
    Error('\P{Uppercase=/a/	_NO}');
    Expect(1, 127370, '\p{Uppercase=:\ANo\z:}', "");;
    Expect(0, 127369, '\p{Uppercase=:\ANo\z:}', "");;
    Expect(1, 127370, '\p{Uppercase=no}', "");
    Expect(0, 127370, '\p{^Uppercase=no}', "");
    Expect(0, 127370, '\P{Uppercase=no}', "");
    Expect(1, 127370, '\P{^Uppercase=no}', "");
    Expect(0, 127369, '\p{Uppercase=no}', "");
    Expect(1, 127369, '\p{^Uppercase=no}', "");
    Expect(1, 127369, '\P{Uppercase=no}', "");
    Expect(0, 127369, '\P{^Uppercase=no}', "");
    Expect(1, 127370, '\p{Uppercase=:\Ano\z:}', "");;
    Expect(0, 127369, '\p{Uppercase=:\Ano\z:}', "");;
    Expect(1, 127370, '\p{Uppercase=_NO}', "");
    Expect(0, 127370, '\p{^Uppercase=_NO}', "");
    Expect(0, 127370, '\P{Uppercase=_NO}', "");
    Expect(1, 127370, '\P{^Uppercase=_NO}', "");
    Expect(0, 127369, '\p{Uppercase=_NO}', "");
    Expect(1, 127369, '\p{^Uppercase=_NO}', "");
    Expect(1, 127369, '\P{Uppercase=_NO}', "");
    Expect(0, 127369, '\P{^Uppercase=_NO}', "");
    Error('\p{Upper= /a/n}');
    Error('\P{Upper= /a/n}');
    Expect(1, 127370, '\p{Upper=:\AN\z:}', "");;
    Expect(0, 127369, '\p{Upper=:\AN\z:}', "");;
    Expect(1, 127370, '\p{Upper=n}', "");
    Expect(0, 127370, '\p{^Upper=n}', "");
    Expect(0, 127370, '\P{Upper=n}', "");
    Expect(1, 127370, '\P{^Upper=n}', "");
    Expect(0, 127369, '\p{Upper=n}', "");
    Expect(1, 127369, '\p{^Upper=n}', "");
    Expect(1, 127369, '\P{Upper=n}', "");
    Expect(0, 127369, '\P{^Upper=n}', "");
    Expect(1, 127370, '\p{Upper=:\An\z:}', "");;
    Expect(0, 127369, '\p{Upper=:\An\z:}', "");;
    Expect(1, 127370, '\p{Upper=-	N}', "");
    Expect(0, 127370, '\p{^Upper=-	N}', "");
    Expect(0, 127370, '\P{Upper=-	N}', "");
    Expect(1, 127370, '\P{^Upper=-	N}', "");
    Expect(0, 127369, '\p{Upper=-	N}', "");
    Expect(1, 127369, '\p{^Upper=-	N}', "");
    Expect(1, 127369, '\P{Upper=-	N}', "");
    Expect(0, 127369, '\P{^Upper=-	N}', "");
    Error('\p{Is_Uppercase=__F/a/}');
    Error('\P{Is_Uppercase=__F/a/}');
    Expect(1, 127370, '\p{Is_Uppercase=f}', "");
    Expect(0, 127370, '\p{^Is_Uppercase=f}', "");
    Expect(0, 127370, '\P{Is_Uppercase=f}', "");
    Expect(1, 127370, '\P{^Is_Uppercase=f}', "");
    Expect(0, 127369, '\p{Is_Uppercase=f}', "");
    Expect(1, 127369, '\p{^Is_Uppercase=f}', "");
    Expect(1, 127369, '\P{Is_Uppercase=f}', "");
    Expect(0, 127369, '\P{^Is_Uppercase=f}', "");
    Expect(1, 127370, '\p{Is_Uppercase= 	F}', "");
    Expect(0, 127370, '\p{^Is_Uppercase= 	F}', "");
    Expect(0, 127370, '\P{Is_Uppercase= 	F}', "");
    Expect(1, 127370, '\P{^Is_Uppercase= 	F}', "");
    Expect(0, 127369, '\p{Is_Uppercase= 	F}', "");
    Expect(1, 127369, '\p{^Is_Uppercase= 	F}', "");
    Expect(1, 127369, '\P{Is_Uppercase= 	F}', "");
    Expect(0, 127369, '\P{^Is_Uppercase= 	F}', "");
    Error('\p{Is_Upper=:=_-False}');
    Error('\P{Is_Upper=:=_-False}');
    Expect(1, 127370, '\p{Is_Upper=false}', "");
    Expect(0, 127370, '\p{^Is_Upper=false}', "");
    Expect(0, 127370, '\P{Is_Upper=false}', "");
    Expect(1, 127370, '\P{^Is_Upper=false}', "");
    Expect(0, 127369, '\p{Is_Upper=false}', "");
    Expect(1, 127369, '\p{^Is_Upper=false}', "");
    Expect(1, 127369, '\P{Is_Upper=false}', "");
    Expect(0, 127369, '\P{^Is_Upper=false}', "");
    Expect(1, 127370, '\p{Is_Upper= _False}', "");
    Expect(0, 127370, '\p{^Is_Upper= _False}', "");
    Expect(0, 127370, '\P{Is_Upper= _False}', "");
    Expect(1, 127370, '\P{^Is_Upper= _False}', "");
    Expect(0, 127369, '\p{Is_Upper= _False}', "");
    Expect(1, 127369, '\p{^Is_Upper= _False}', "");
    Expect(1, 127369, '\P{Is_Upper= _False}', "");
    Expect(0, 127369, '\P{^Is_Upper= _False}', "");
    Error('\p{Uppercase=:=--Yes}');
    Error('\P{Uppercase=:=--Yes}');
    Expect(1, 127369, '\p{Uppercase=:\AYes\z:}', "");;
    Expect(0, 127370, '\p{Uppercase=:\AYes\z:}', "");;
    Expect(1, 127369, '\p{Uppercase=yes}', "");
    Expect(0, 127369, '\p{^Uppercase=yes}', "");
    Expect(0, 127369, '\P{Uppercase=yes}', "");
    Expect(1, 127369, '\P{^Uppercase=yes}', "");
    Expect(0, 127370, '\p{Uppercase=yes}', "");
    Expect(1, 127370, '\p{^Uppercase=yes}', "");
    Expect(1, 127370, '\P{Uppercase=yes}', "");
    Expect(0, 127370, '\P{^Uppercase=yes}', "");
    Expect(1, 127369, '\p{Uppercase=:\Ayes\z:}', "");;
    Expect(0, 127370, '\p{Uppercase=:\Ayes\z:}', "");;
    Expect(1, 127369, '\p{Uppercase=	yes}', "");
    Expect(0, 127369, '\p{^Uppercase=	yes}', "");
    Expect(0, 127369, '\P{Uppercase=	yes}', "");
    Expect(1, 127369, '\P{^Uppercase=	yes}', "");
    Expect(0, 127370, '\p{Uppercase=	yes}', "");
    Expect(1, 127370, '\p{^Uppercase=	yes}', "");
    Expect(1, 127370, '\P{Uppercase=	yes}', "");
    Expect(0, 127370, '\P{^Uppercase=	yes}', "");
    Error('\p{Upper=/a/- Y}');
    Error('\P{Upper=/a/- Y}');
    Expect(1, 127369, '\p{Upper=:\AY\z:}', "");;
    Expect(0, 127370, '\p{Upper=:\AY\z:}', "");;
    Expect(1, 127369, '\p{Upper=y}', "");
    Expect(0, 127369, '\p{^Upper=y}', "");
    Expect(0, 127369, '\P{Upper=y}', "");
    Expect(1, 127369, '\P{^Upper=y}', "");
    Expect(0, 127370, '\p{Upper=y}', "");
    Expect(1, 127370, '\p{^Upper=y}', "");
    Expect(1, 127370, '\P{Upper=y}', "");
    Expect(0, 127370, '\P{^Upper=y}', "");
    Expect(1, 127369, '\p{Upper=:\Ay\z:}', "");;
    Expect(0, 127370, '\p{Upper=:\Ay\z:}', "");;
    Expect(1, 127369, '\p{Upper=	Y}', "");
    Expect(0, 127369, '\p{^Upper=	Y}', "");
    Expect(0, 127369, '\P{Upper=	Y}', "");
    Expect(1, 127369, '\P{^Upper=	Y}', "");
    Expect(0, 127370, '\p{Upper=	Y}', "");
    Expect(1, 127370, '\p{^Upper=	Y}', "");
    Expect(1, 127370, '\P{Upper=	Y}', "");
    Expect(0, 127370, '\P{^Upper=	Y}', "");
    Error('\p{Is_Uppercase=/a/- T}');
    Error('\P{Is_Uppercase=/a/- T}');
    Expect(1, 127369, '\p{Is_Uppercase=t}', "");
    Expect(0, 127369, '\p{^Is_Uppercase=t}', "");
    Expect(0, 127369, '\P{Is_Uppercase=t}', "");
    Expect(1, 127369, '\P{^Is_Uppercase=t}', "");
    Expect(0, 127370, '\p{Is_Uppercase=t}', "");
    Expect(1, 127370, '\p{^Is_Uppercase=t}', "");
    Expect(1, 127370, '\P{Is_Uppercase=t}', "");
    Expect(0, 127370, '\P{^Is_Uppercase=t}', "");
    Expect(1, 127369, '\p{Is_Uppercase:  T}', "");
    Expect(0, 127369, '\p{^Is_Uppercase:  T}', "");
    Expect(0, 127369, '\P{Is_Uppercase:  T}', "");
    Expect(1, 127369, '\P{^Is_Uppercase:  T}', "");
    Expect(0, 127370, '\p{Is_Uppercase:  T}', "");
    Expect(1, 127370, '\p{^Is_Uppercase:  T}', "");
    Expect(1, 127370, '\P{Is_Uppercase:  T}', "");
    Expect(0, 127370, '\P{^Is_Uppercase:  T}', "");
    Error('\p{Is_Upper=:=-_True}');
    Error('\P{Is_Upper=:=-_True}');
    Expect(1, 127369, '\p{Is_Upper=true}', "");
    Expect(0, 127369, '\p{^Is_Upper=true}', "");
    Expect(0, 127369, '\P{Is_Upper=true}', "");
    Expect(1, 127369, '\P{^Is_Upper=true}', "");
    Expect(0, 127370, '\p{Is_Upper=true}', "");
    Expect(1, 127370, '\p{^Is_Upper=true}', "");
    Expect(1, 127370, '\P{Is_Upper=true}', "");
    Expect(0, 127370, '\P{^Is_Upper=true}', "");
    Expect(1, 127369, '\p{Is_Upper=_TRUE}', "");
    Expect(0, 127369, '\p{^Is_Upper=_TRUE}', "");
    Expect(0, 127369, '\P{Is_Upper=_TRUE}', "");
    Expect(1, 127369, '\P{^Is_Upper=_TRUE}', "");
    Expect(0, 127370, '\p{Is_Upper=_TRUE}', "");
    Expect(1, 127370, '\p{^Is_Upper=_TRUE}', "");
    Expect(1, 127370, '\P{Is_Upper=_TRUE}', "");
    Expect(0, 127370, '\P{^Is_Upper=_TRUE}', "");
    Error('\p{verticalorientation}');
    Error('\P{verticalorientation}');
    Error('\p{vo}');
    Error('\P{vo}');
    Error('\p{Vertical_Orientation=_:=Rotated}');
    Error('\P{Vertical_Orientation=_:=Rotated}');
    Expect(1, 262144, '\p{Vertical_Orientation=:\ARotated\z:}', "");;
    Expect(0, 1114109, '\p{Vertical_Orientation=:\ARotated\z:}', "");;
    Expect(1, 262144, '\p{Vertical_Orientation=rotated}', "");
    Expect(0, 262144, '\p{^Vertical_Orientation=rotated}', "");
    Expect(0, 262144, '\P{Vertical_Orientation=rotated}', "");
    Expect(1, 262144, '\P{^Vertical_Orientation=rotated}', "");
    Expect(0, 1114109, '\p{Vertical_Orientation=rotated}', "");
    Expect(1, 1114109, '\p{^Vertical_Orientation=rotated}', "");
    Expect(1, 1114109, '\P{Vertical_Orientation=rotated}', "");
    Expect(0, 1114109, '\P{^Vertical_Orientation=rotated}', "");
    Expect(1, 262144, '\p{Vertical_Orientation=:\Arotated\z:}', "");;
    Expect(0, 1114109, '\p{Vertical_Orientation=:\Arotated\z:}', "");;
    Expect(1, 262144, '\p{Vertical_Orientation=  Rotated}', "");
    Expect(0, 262144, '\p{^Vertical_Orientation=  Rotated}', "");
    Expect(0, 262144, '\P{Vertical_Orientation=  Rotated}', "");
    Expect(1, 262144, '\P{^Vertical_Orientation=  Rotated}', "");
    Expect(0, 1114109, '\p{Vertical_Orientation=  Rotated}', "");
    Expect(1, 1114109, '\p{^Vertical_Orientation=  Rotated}', "");
    Expect(1, 1114109, '\P{Vertical_Orientation=  Rotated}', "");
    Expect(0, 1114109, '\P{^Vertical_Orientation=  Rotated}', "");
    Error('\p{Vo=/a/_ R}');
    Error('\P{Vo=/a/_ R}');
    Expect(1, 262144, '\p{Vo=:\AR\z:}', "");;
    Expect(0, 1114109, '\p{Vo=:\AR\z:}', "");;
    Expect(1, 262144, '\p{Vo=r}', "");
    Expect(0, 262144, '\p{^Vo=r}', "");
    Expect(0, 262144, '\P{Vo=r}', "");
    Expect(1, 262144, '\P{^Vo=r}', "");
    Expect(0, 1114109, '\p{Vo=r}', "");
    Expect(1, 1114109, '\p{^Vo=r}', "");
    Expect(1, 1114109, '\P{Vo=r}', "");
    Expect(0, 1114109, '\P{^Vo=r}', "");
    Expect(1, 262144, '\p{Vo=:\Ar\z:}', "");;
    Expect(0, 1114109, '\p{Vo=:\Ar\z:}', "");;
    Expect(1, 262144, '\p{Vo=_R}', "");
    Expect(0, 262144, '\p{^Vo=_R}', "");
    Expect(0, 262144, '\P{Vo=_R}', "");
    Expect(1, 262144, '\P{^Vo=_R}', "");
    Expect(0, 1114109, '\p{Vo=_R}', "");
    Expect(1, 1114109, '\p{^Vo=_R}', "");
    Expect(1, 1114109, '\P{Vo=_R}', "");
    Expect(0, 1114109, '\P{^Vo=_R}', "");
    Error('\p{Is_Vertical_Orientation=  Rotated:=}');
    Error('\P{Is_Vertical_Orientation=  Rotated:=}');
    Expect(1, 262144, '\p{Is_Vertical_Orientation=rotated}', "");
    Expect(0, 262144, '\p{^Is_Vertical_Orientation=rotated}', "");
    Expect(0, 262144, '\P{Is_Vertical_Orientation=rotated}', "");
    Expect(1, 262144, '\P{^Is_Vertical_Orientation=rotated}', "");
    Expect(0, 1114109, '\p{Is_Vertical_Orientation=rotated}', "");
    Expect(1, 1114109, '\p{^Is_Vertical_Orientation=rotated}', "");
    Expect(1, 1114109, '\P{Is_Vertical_Orientation=rotated}', "");
    Expect(0, 1114109, '\P{^Is_Vertical_Orientation=rotated}', "");
    Expect(1, 262144, '\p{Is_Vertical_Orientation=Rotated}', "");
    Expect(0, 262144, '\p{^Is_Vertical_Orientation=Rotated}', "");
    Expect(0, 262144, '\P{Is_Vertical_Orientation=Rotated}', "");
    Expect(1, 262144, '\P{^Is_Vertical_Orientation=Rotated}', "");
    Expect(0, 1114109, '\p{Is_Vertical_Orientation=Rotated}', "");
    Expect(1, 1114109, '\p{^Is_Vertical_Orientation=Rotated}', "");
    Expect(1, 1114109, '\P{Is_Vertical_Orientation=Rotated}', "");
    Expect(0, 1114109, '\P{^Is_Vertical_Orientation=Rotated}', "");
    Error('\p{Is_Vo=	/a/R}');
    Error('\P{Is_Vo=	/a/R}');
    Expect(1, 262144, '\p{Is_Vo=r}', "");
    Expect(0, 262144, '\p{^Is_Vo=r}', "");
    Expect(0, 262144, '\P{Is_Vo=r}', "");
    Expect(1, 262144, '\P{^Is_Vo=r}', "");
    Expect(0, 1114109, '\p{Is_Vo=r}', "");
    Expect(1, 1114109, '\p{^Is_Vo=r}', "");
    Expect(1, 1114109, '\P{Is_Vo=r}', "");
    Expect(0, 1114109, '\P{^Is_Vo=r}', "");
    Expect(1, 262144, '\p{Is_Vo=__R}', "");
    Expect(0, 262144, '\p{^Is_Vo=__R}', "");
    Expect(0, 262144, '\P{Is_Vo=__R}', "");
    Expect(1, 262144, '\P{^Is_Vo=__R}', "");
    Expect(0, 1114109, '\p{Is_Vo=__R}', "");
    Expect(1, 1114109, '\p{^Is_Vo=__R}', "");
    Expect(1, 1114109, '\P{Is_Vo=__R}', "");
    Expect(0, 1114109, '\P{^Is_Vo=__R}', "");
    Error('\p{Vertical_Orientation=	:=Transformed_Rotated}');
    Error('\P{Vertical_Orientation=	:=Transformed_Rotated}');
    Expect(1, 65507, '\p{Vertical_Orientation=:\ATransformed_Rotated\z:}', "");;
    Expect(0, 65508, '\p{Vertical_Orientation=:\ATransformed_Rotated\z:}', "");;
    Expect(1, 65507, '\p{Vertical_Orientation=transformedrotated}', "");
    Expect(0, 65507, '\p{^Vertical_Orientation=transformedrotated}', "");
    Expect(0, 65507, '\P{Vertical_Orientation=transformedrotated}', "");
    Expect(1, 65507, '\P{^Vertical_Orientation=transformedrotated}', "");
    Expect(0, 65508, '\p{Vertical_Orientation=transformedrotated}', "");
    Expect(1, 65508, '\p{^Vertical_Orientation=transformedrotated}', "");
    Expect(1, 65508, '\P{Vertical_Orientation=transformedrotated}', "");
    Expect(0, 65508, '\P{^Vertical_Orientation=transformedrotated}', "");
    Expect(1, 65507, '\p{Vertical_Orientation=:\Atransformedrotated\z:}', "");;
    Expect(0, 65508, '\p{Vertical_Orientation=:\Atransformedrotated\z:}', "");;
    Expect(1, 65507, '\p{Vertical_Orientation=-	Transformed_Rotated}', "");
    Expect(0, 65507, '\p{^Vertical_Orientation=-	Transformed_Rotated}', "");
    Expect(0, 65507, '\P{Vertical_Orientation=-	Transformed_Rotated}', "");
    Expect(1, 65507, '\P{^Vertical_Orientation=-	Transformed_Rotated}', "");
    Expect(0, 65508, '\p{Vertical_Orientation=-	Transformed_Rotated}', "");
    Expect(1, 65508, '\p{^Vertical_Orientation=-	Transformed_Rotated}', "");
    Expect(1, 65508, '\P{Vertical_Orientation=-	Transformed_Rotated}', "");
    Expect(0, 65508, '\P{^Vertical_Orientation=-	Transformed_Rotated}', "");
    Error('\p{Vo=/a/_TR}');
    Error('\P{Vo=/a/_TR}');
    Expect(1, 65507, '\p{Vo=:\ATr\z:}', "");;
    Expect(0, 65508, '\p{Vo=:\ATr\z:}', "");;
    Expect(1, 65507, '\p{Vo=tr}', "");
    Expect(0, 65507, '\p{^Vo=tr}', "");
    Expect(0, 65507, '\P{Vo=tr}', "");
    Expect(1, 65507, '\P{^Vo=tr}', "");
    Expect(0, 65508, '\p{Vo=tr}', "");
    Expect(1, 65508, '\p{^Vo=tr}', "");
    Expect(1, 65508, '\P{Vo=tr}', "");
    Expect(0, 65508, '\P{^Vo=tr}', "");
    Expect(1, 65507, '\p{Vo=:\Atr\z:}', "");;
    Expect(0, 65508, '\p{Vo=:\Atr\z:}', "");;
    Expect(1, 65507, '\p{Vo=	_TR}', "");
    Expect(0, 65507, '\p{^Vo=	_TR}', "");
    Expect(0, 65507, '\P{Vo=	_TR}', "");
    Expect(1, 65507, '\P{^Vo=	_TR}', "");
    Expect(0, 65508, '\p{Vo=	_TR}', "");
    Expect(1, 65508, '\p{^Vo=	_TR}', "");
    Expect(1, 65508, '\P{Vo=	_TR}', "");
    Expect(0, 65508, '\P{^Vo=	_TR}', "");
    Error('\p{Is_Vertical_Orientation= :=Transformed_rotated}');
    Error('\P{Is_Vertical_Orientation= :=Transformed_rotated}');
    Expect(1, 65507, '\p{Is_Vertical_Orientation=transformedrotated}', "");
    Expect(0, 65507, '\p{^Is_Vertical_Orientation=transformedrotated}', "");
    Expect(0, 65507, '\P{Is_Vertical_Orientation=transformedrotated}', "");
    Expect(1, 65507, '\P{^Is_Vertical_Orientation=transformedrotated}', "");
    Expect(0, 65508, '\p{Is_Vertical_Orientation=transformedrotated}', "");
    Expect(1, 65508, '\p{^Is_Vertical_Orientation=transformedrotated}', "");
    Expect(1, 65508, '\P{Is_Vertical_Orientation=transformedrotated}', "");
    Expect(0, 65508, '\P{^Is_Vertical_Orientation=transformedrotated}', "");
    Expect(1, 65507, '\p{Is_Vertical_Orientation=__transformed_Rotated}', "");
    Expect(0, 65507, '\p{^Is_Vertical_Orientation=__transformed_Rotated}', "");
    Expect(0, 65507, '\P{Is_Vertical_Orientation=__transformed_Rotated}', "");
    Expect(1, 65507, '\P{^Is_Vertical_Orientation=__transformed_Rotated}', "");
    Expect(0, 65508, '\p{Is_Vertical_Orientation=__transformed_Rotated}', "");
    Expect(1, 65508, '\p{^Is_Vertical_Orientation=__transformed_Rotated}', "");
    Expect(1, 65508, '\P{Is_Vertical_Orientation=__transformed_Rotated}', "");
    Expect(0, 65508, '\P{^Is_Vertical_Orientation=__transformed_Rotated}', "");
    Error('\p{Is_Vo=_ tr/a/}');
    Error('\P{Is_Vo=_ tr/a/}');
    Expect(1, 65507, '\p{Is_Vo=tr}', "");
    Expect(0, 65507, '\p{^Is_Vo=tr}', "");
    Expect(0, 65507, '\P{Is_Vo=tr}', "");
    Expect(1, 65507, '\P{^Is_Vo=tr}', "");
    Expect(0, 65508, '\p{Is_Vo=tr}', "");
    Expect(1, 65508, '\p{^Is_Vo=tr}', "");
    Expect(1, 65508, '\P{Is_Vo=tr}', "");
    Expect(0, 65508, '\P{^Is_Vo=tr}', "");
    Expect(1, 65507, '\p{Is_Vo= -tr}', "");
    Expect(0, 65507, '\p{^Is_Vo= -tr}', "");
    Expect(0, 65507, '\P{Is_Vo= -tr}', "");
    Expect(1, 65507, '\P{^Is_Vo= -tr}', "");
    Expect(0, 65508, '\p{Is_Vo= -tr}', "");
    Expect(1, 65508, '\p{^Is_Vo= -tr}', "");
    Expect(1, 65508, '\P{Is_Vo= -tr}', "");
    Expect(0, 65508, '\P{^Is_Vo= -tr}', "");
    Error('\p{Vertical_Orientation=/a/  TRANSFORMED_Upright}');
    Error('\P{Vertical_Orientation=/a/  TRANSFORMED_Upright}');
    Expect(1, 127489, '\p{Vertical_Orientation=:\ATransformed_Upright\z:}', "");;
    Expect(0, 127490, '\p{Vertical_Orientation=:\ATransformed_Upright\z:}', "");;
    Expect(1, 127489, '\p{Vertical_Orientation:transformedupright}', "");
    Expect(0, 127489, '\p{^Vertical_Orientation:transformedupright}', "");
    Expect(0, 127489, '\P{Vertical_Orientation:transformedupright}', "");
    Expect(1, 127489, '\P{^Vertical_Orientation:transformedupright}', "");
    Expect(0, 127490, '\p{Vertical_Orientation:transformedupright}', "");
    Expect(1, 127490, '\p{^Vertical_Orientation:transformedupright}', "");
    Expect(1, 127490, '\P{Vertical_Orientation:transformedupright}', "");
    Expect(0, 127490, '\P{^Vertical_Orientation:transformedupright}', "");
    Expect(1, 127489, '\p{Vertical_Orientation=:\Atransformedupright\z:}', "");;
    Expect(0, 127490, '\p{Vertical_Orientation=:\Atransformedupright\z:}', "");;
    Expect(1, 127489, '\p{Vertical_Orientation= -TRANSFORMED_upright}', "");
    Expect(0, 127489, '\p{^Vertical_Orientation= -TRANSFORMED_upright}', "");
    Expect(0, 127489, '\P{Vertical_Orientation= -TRANSFORMED_upright}', "");
    Expect(1, 127489, '\P{^Vertical_Orientation= -TRANSFORMED_upright}', "");
    Expect(0, 127490, '\p{Vertical_Orientation= -TRANSFORMED_upright}', "");
    Expect(1, 127490, '\p{^Vertical_Orientation= -TRANSFORMED_upright}', "");
    Expect(1, 127490, '\P{Vertical_Orientation= -TRANSFORMED_upright}', "");
    Expect(0, 127490, '\P{^Vertical_Orientation= -TRANSFORMED_upright}', "");
    Error('\p{Vo=/a/	-tu}');
    Error('\P{Vo=/a/	-tu}');
    Expect(1, 127489, '\p{Vo=:\ATu\z:}', "");;
    Expect(0, 127490, '\p{Vo=:\ATu\z:}', "");;
    Expect(1, 127489, '\p{Vo=tu}', "");
    Expect(0, 127489, '\p{^Vo=tu}', "");
    Expect(0, 127489, '\P{Vo=tu}', "");
    Expect(1, 127489, '\P{^Vo=tu}', "");
    Expect(0, 127490, '\p{Vo=tu}', "");
    Expect(1, 127490, '\p{^Vo=tu}', "");
    Expect(1, 127490, '\P{Vo=tu}', "");
    Expect(0, 127490, '\P{^Vo=tu}', "");
    Expect(1, 127489, '\p{Vo=:\Atu\z:}', "");;
    Expect(0, 127490, '\p{Vo=:\Atu\z:}', "");;
    Expect(1, 127489, '\p{Vo= 	Tu}', "");
    Expect(0, 127489, '\p{^Vo= 	Tu}', "");
    Expect(0, 127489, '\P{Vo= 	Tu}', "");
    Expect(1, 127489, '\P{^Vo= 	Tu}', "");
    Expect(0, 127490, '\p{Vo= 	Tu}', "");
    Expect(1, 127490, '\p{^Vo= 	Tu}', "");
    Expect(1, 127490, '\P{Vo= 	Tu}', "");
    Expect(0, 127490, '\P{^Vo= 	Tu}', "");
    Error('\p{Is_Vertical_Orientation=/a/_transformed_Upright}');
    Error('\P{Is_Vertical_Orientation=/a/_transformed_Upright}');
    Expect(1, 127489, '\p{Is_Vertical_Orientation=transformedupright}', "");
    Expect(0, 127489, '\p{^Is_Vertical_Orientation=transformedupright}', "");
    Expect(0, 127489, '\P{Is_Vertical_Orientation=transformedupright}', "");
    Expect(1, 127489, '\P{^Is_Vertical_Orientation=transformedupright}', "");
    Expect(0, 127490, '\p{Is_Vertical_Orientation=transformedupright}', "");
    Expect(1, 127490, '\p{^Is_Vertical_Orientation=transformedupright}', "");
    Expect(1, 127490, '\P{Is_Vertical_Orientation=transformedupright}', "");
    Expect(0, 127490, '\P{^Is_Vertical_Orientation=transformedupright}', "");
    Expect(1, 127489, '\p{Is_Vertical_Orientation=- TRANSFORMED_Upright}', "");
    Expect(0, 127489, '\p{^Is_Vertical_Orientation=- TRANSFORMED_Upright}', "");
    Expect(0, 127489, '\P{Is_Vertical_Orientation=- TRANSFORMED_Upright}', "");
    Expect(1, 127489, '\P{^Is_Vertical_Orientation=- TRANSFORMED_Upright}', "");
    Expect(0, 127490, '\p{Is_Vertical_Orientation=- TRANSFORMED_Upright}', "");
    Expect(1, 127490, '\p{^Is_Vertical_Orientation=- TRANSFORMED_Upright}', "");
    Expect(1, 127490, '\P{Is_Vertical_Orientation=- TRANSFORMED_Upright}', "");
    Expect(0, 127490, '\P{^Is_Vertical_Orientation=- TRANSFORMED_Upright}', "");
    Error('\p{Is_Vo=:=Tu}');
    Error('\P{Is_Vo=:=Tu}');
    Expect(1, 127489, '\p{Is_Vo=tu}', "");
    Expect(0, 127489, '\p{^Is_Vo=tu}', "");
    Expect(0, 127489, '\P{Is_Vo=tu}', "");
    Expect(1, 127489, '\P{^Is_Vo=tu}', "");
    Expect(0, 127490, '\p{Is_Vo=tu}', "");
    Expect(1, 127490, '\p{^Is_Vo=tu}', "");
    Expect(1, 127490, '\P{Is_Vo=tu}', "");
    Expect(0, 127490, '\P{^Is_Vo=tu}', "");
    Expect(1, 127489, '\p{Is_Vo=	Tu}', "");
    Expect(0, 127489, '\p{^Is_Vo=	Tu}', "");
    Expect(0, 127489, '\P{Is_Vo=	Tu}', "");
    Expect(1, 127489, '\P{^Is_Vo=	Tu}', "");
    Expect(0, 127490, '\p{Is_Vo=	Tu}', "");
    Expect(1, 127490, '\p{^Is_Vo=	Tu}', "");
    Expect(1, 127490, '\P{Is_Vo=	Tu}', "");
    Expect(0, 127490, '\P{^Is_Vo=	Tu}', "");
    Error('\p{Vertical_Orientation=:=-UPRIGHT}');
    Error('\P{Vertical_Orientation=:=-UPRIGHT}');
    Expect(1, 1114109, '\p{Vertical_Orientation=:\AUpright\z:}', "");;
    Expect(0, 262144, '\p{Vertical_Orientation=:\AUpright\z:}', "");;
    Expect(1, 1114109, '\p{Vertical_Orientation=upright}', "");
    Expect(0, 1114109, '\p{^Vertical_Orientation=upright}', "");
    Expect(0, 1114109, '\P{Vertical_Orientation=upright}', "");
    Expect(1, 1114109, '\P{^Vertical_Orientation=upright}', "");
    Expect(0, 262144, '\p{Vertical_Orientation=upright}', "");
    Expect(1, 262144, '\p{^Vertical_Orientation=upright}', "");
    Expect(1, 262144, '\P{Vertical_Orientation=upright}', "");
    Expect(0, 262144, '\P{^Vertical_Orientation=upright}', "");
    Expect(1, 1114109, '\p{Vertical_Orientation=:\Aupright\z:}', "");;
    Expect(0, 262144, '\p{Vertical_Orientation=:\Aupright\z:}', "");;
    Expect(1, 1114109, '\p{Vertical_Orientation= -Upright}', "");
    Expect(0, 1114109, '\p{^Vertical_Orientation= -Upright}', "");
    Expect(0, 1114109, '\P{Vertical_Orientation= -Upright}', "");
    Expect(1, 1114109, '\P{^Vertical_Orientation= -Upright}', "");
    Expect(0, 262144, '\p{Vertical_Orientation= -Upright}', "");
    Expect(1, 262144, '\p{^Vertical_Orientation= -Upright}', "");
    Expect(1, 262144, '\P{Vertical_Orientation= -Upright}', "");
    Expect(0, 262144, '\P{^Vertical_Orientation= -Upright}', "");
    Error('\p{Vo= :=U}');
    Error('\P{Vo= :=U}');
    Expect(1, 1114109, '\p{Vo=:\AU\z:}', "");;
    Expect(0, 262144, '\p{Vo=:\AU\z:}', "");;
    Expect(1, 1114109, '\p{Vo=u}', "");
    Expect(0, 1114109, '\p{^Vo=u}', "");
    Expect(0, 1114109, '\P{Vo=u}', "");
    Expect(1, 1114109, '\P{^Vo=u}', "");
    Expect(0, 262144, '\p{Vo=u}', "");
    Expect(1, 262144, '\p{^Vo=u}', "");
    Expect(1, 262144, '\P{Vo=u}', "");
    Expect(0, 262144, '\P{^Vo=u}', "");
    Expect(1, 1114109, '\p{Vo=:\Au\z:}', "");;
    Expect(0, 262144, '\p{Vo=:\Au\z:}', "");;
    Expect(1, 1114109, '\p{Vo=-u}', "");
    Expect(0, 1114109, '\p{^Vo=-u}', "");
    Expect(0, 1114109, '\P{Vo=-u}', "");
    Expect(1, 1114109, '\P{^Vo=-u}', "");
    Expect(0, 262144, '\p{Vo=-u}', "");
    Expect(1, 262144, '\p{^Vo=-u}', "");
    Expect(1, 262144, '\P{Vo=-u}', "");
    Expect(0, 262144, '\P{^Vo=-u}', "");
    Error('\p{Is_Vertical_Orientation=:=-Upright}');
    Error('\P{Is_Vertical_Orientation=:=-Upright}');
    Expect(1, 1114109, '\p{Is_Vertical_Orientation=upright}', "");
    Expect(0, 1114109, '\p{^Is_Vertical_Orientation=upright}', "");
    Expect(0, 1114109, '\P{Is_Vertical_Orientation=upright}', "");
    Expect(1, 1114109, '\P{^Is_Vertical_Orientation=upright}', "");
    Expect(0, 262144, '\p{Is_Vertical_Orientation=upright}', "");
    Expect(1, 262144, '\p{^Is_Vertical_Orientation=upright}', "");
    Expect(1, 262144, '\P{Is_Vertical_Orientation=upright}', "");
    Expect(0, 262144, '\P{^Is_Vertical_Orientation=upright}', "");
    Expect(1, 1114109, '\p{Is_Vertical_Orientation=_-Upright}', "");
    Expect(0, 1114109, '\p{^Is_Vertical_Orientation=_-Upright}', "");
    Expect(0, 1114109, '\P{Is_Vertical_Orientation=_-Upright}', "");
    Expect(1, 1114109, '\P{^Is_Vertical_Orientation=_-Upright}', "");
    Expect(0, 262144, '\p{Is_Vertical_Orientation=_-Upright}', "");
    Expect(1, 262144, '\p{^Is_Vertical_Orientation=_-Upright}', "");
    Expect(1, 262144, '\P{Is_Vertical_Orientation=_-Upright}', "");
    Expect(0, 262144, '\P{^Is_Vertical_Orientation=_-Upright}', "");
    Error('\p{Is_Vo=/a/	u}');
    Error('\P{Is_Vo=/a/	u}');
    Expect(1, 1114109, '\p{Is_Vo: u}', "");
    Expect(0, 1114109, '\p{^Is_Vo: u}', "");
    Expect(0, 1114109, '\P{Is_Vo: u}', "");
    Expect(1, 1114109, '\P{^Is_Vo: u}', "");
    Expect(0, 262144, '\p{Is_Vo: u}', "");
    Expect(1, 262144, '\p{^Is_Vo: u}', "");
    Expect(1, 262144, '\P{Is_Vo: u}', "");
    Expect(0, 262144, '\P{^Is_Vo: u}', "");
    Expect(1, 1114109, '\p{Is_Vo=-	u}', "");
    Expect(0, 1114109, '\p{^Is_Vo=-	u}', "");
    Expect(0, 1114109, '\P{Is_Vo=-	u}', "");
    Expect(1, 1114109, '\P{^Is_Vo=-	u}', "");
    Expect(0, 262144, '\p{Is_Vo=-	u}', "");
    Expect(1, 262144, '\p{^Is_Vo=-	u}', "");
    Expect(1, 262144, '\P{Is_Vo=-	u}', "");
    Expect(0, 262144, '\P{^Is_Vo=-	u}', "");
    Error('\p{Variation_Selector=no:=}');
    Error('\P{Variation_Selector=no:=}');
    Expect(1, 918000, '\p{Variation_Selector=:\ANo\z:}', "");;
    Expect(0, 917999, '\p{Variation_Selector=:\ANo\z:}', "");;
    Expect(1, 918000, '\p{Variation_Selector=no}', "");
    Expect(0, 918000, '\p{^Variation_Selector=no}', "");
    Expect(0, 918000, '\P{Variation_Selector=no}', "");
    Expect(1, 918000, '\P{^Variation_Selector=no}', "");
    Expect(0, 917999, '\p{Variation_Selector=no}', "");
    Expect(1, 917999, '\p{^Variation_Selector=no}', "");
    Expect(1, 917999, '\P{Variation_Selector=no}', "");
    Expect(0, 917999, '\P{^Variation_Selector=no}', "");
    Expect(1, 918000, '\p{Variation_Selector=:\Ano\z:}', "");;
    Expect(0, 917999, '\p{Variation_Selector=:\Ano\z:}', "");;
    Expect(1, 918000, '\p{Variation_Selector:	--NO}', "");
    Expect(0, 918000, '\p{^Variation_Selector:	--NO}', "");
    Expect(0, 918000, '\P{Variation_Selector:	--NO}', "");
    Expect(1, 918000, '\P{^Variation_Selector:	--NO}', "");
    Expect(0, 917999, '\p{Variation_Selector:	--NO}', "");
    Expect(1, 917999, '\p{^Variation_Selector:	--NO}', "");
    Expect(1, 917999, '\P{Variation_Selector:	--NO}', "");
    Expect(0, 917999, '\P{^Variation_Selector:	--NO}', "");
    Error('\p{VS=-:=N}');
    Error('\P{VS=-:=N}');
    Expect(1, 918000, '\p{VS=:\AN\z:}', "");;
    Expect(0, 917999, '\p{VS=:\AN\z:}', "");;
    Expect(1, 918000, '\p{VS=n}', "");
    Expect(0, 918000, '\p{^VS=n}', "");
    Expect(0, 918000, '\P{VS=n}', "");
    Expect(1, 918000, '\P{^VS=n}', "");
    Expect(0, 917999, '\p{VS=n}', "");
    Expect(1, 917999, '\p{^VS=n}', "");
    Expect(1, 917999, '\P{VS=n}', "");
    Expect(0, 917999, '\P{^VS=n}', "");
    Expect(1, 918000, '\p{VS=:\An\z:}', "");;
    Expect(0, 917999, '\p{VS=:\An\z:}', "");;
    Expect(1, 918000, '\p{VS=-N}', "");
    Expect(0, 918000, '\p{^VS=-N}', "");
    Expect(0, 918000, '\P{VS=-N}', "");
    Expect(1, 918000, '\P{^VS=-N}', "");
    Expect(0, 917999, '\p{VS=-N}', "");
    Expect(1, 917999, '\p{^VS=-N}', "");
    Expect(1, 917999, '\P{VS=-N}', "");
    Expect(0, 917999, '\P{^VS=-N}', "");
    Error('\p{Is_Variation_Selector=_-f/a/}');
    Error('\P{Is_Variation_Selector=_-f/a/}');
    Expect(1, 918000, '\p{Is_Variation_Selector=f}', "");
    Expect(0, 918000, '\p{^Is_Variation_Selector=f}', "");
    Expect(0, 918000, '\P{Is_Variation_Selector=f}', "");
    Expect(1, 918000, '\P{^Is_Variation_Selector=f}', "");
    Expect(0, 917999, '\p{Is_Variation_Selector=f}', "");
    Expect(1, 917999, '\p{^Is_Variation_Selector=f}', "");
    Expect(1, 917999, '\P{Is_Variation_Selector=f}', "");
    Expect(0, 917999, '\P{^Is_Variation_Selector=f}', "");
    Expect(1, 918000, '\p{Is_Variation_Selector=_ F}', "");
    Expect(0, 918000, '\p{^Is_Variation_Selector=_ F}', "");
    Expect(0, 918000, '\P{Is_Variation_Selector=_ F}', "");
    Expect(1, 918000, '\P{^Is_Variation_Selector=_ F}', "");
    Expect(0, 917999, '\p{Is_Variation_Selector=_ F}', "");
    Expect(1, 917999, '\p{^Is_Variation_Selector=_ F}', "");
    Expect(1, 917999, '\P{Is_Variation_Selector=_ F}', "");
    Expect(0, 917999, '\P{^Is_Variation_Selector=_ F}', "");
    Error('\p{Is_VS=_ False/a/}');
    Error('\P{Is_VS=_ False/a/}');
    Expect(1, 918000, '\p{Is_VS=false}', "");
    Expect(0, 918000, '\p{^Is_VS=false}', "");
    Expect(0, 918000, '\P{Is_VS=false}', "");
    Expect(1, 918000, '\P{^Is_VS=false}', "");
    Expect(0, 917999, '\p{Is_VS=false}', "");
    Expect(1, 917999, '\p{^Is_VS=false}', "");
    Expect(1, 917999, '\P{Is_VS=false}', "");
    Expect(0, 917999, '\P{^Is_VS=false}', "");
    Expect(1, 918000, '\p{Is_VS=		FALSE}', "");
    Expect(0, 918000, '\p{^Is_VS=		FALSE}', "");
    Expect(0, 918000, '\P{Is_VS=		FALSE}', "");
    Expect(1, 918000, '\P{^Is_VS=		FALSE}', "");
    Expect(0, 917999, '\p{Is_VS=		FALSE}', "");
    Expect(1, 917999, '\p{^Is_VS=		FALSE}', "");
    Expect(1, 917999, '\P{Is_VS=		FALSE}', "");
    Expect(0, 917999, '\P{^Is_VS=		FALSE}', "");
    Error('\p{Variation_Selector=/a/_	YES}');
    Error('\P{Variation_Selector=/a/_	YES}');
    Expect(1, 917999, '\p{Variation_Selector=:\AYes\z:}', "");;
    Expect(0, 918000, '\p{Variation_Selector=:\AYes\z:}', "");;
    Expect(1, 917999, '\p{Variation_Selector=yes}', "");
    Expect(0, 917999, '\p{^Variation_Selector=yes}', "");
    Expect(0, 917999, '\P{Variation_Selector=yes}', "");
    Expect(1, 917999, '\P{^Variation_Selector=yes}', "");
    Expect(0, 918000, '\p{Variation_Selector=yes}', "");
    Expect(1, 918000, '\p{^Variation_Selector=yes}', "");
    Expect(1, 918000, '\P{Variation_Selector=yes}', "");
    Expect(0, 918000, '\P{^Variation_Selector=yes}', "");
    Expect(1, 917999, '\p{Variation_Selector=:\Ayes\z:}', "");;
    Expect(0, 918000, '\p{Variation_Selector=:\Ayes\z:}', "");;
    Expect(1, 917999, '\p{Variation_Selector=Yes}', "");
    Expect(0, 917999, '\p{^Variation_Selector=Yes}', "");
    Expect(0, 917999, '\P{Variation_Selector=Yes}', "");
    Expect(1, 917999, '\P{^Variation_Selector=Yes}', "");
    Expect(0, 918000, '\p{Variation_Selector=Yes}', "");
    Expect(1, 918000, '\p{^Variation_Selector=Yes}', "");
    Expect(1, 918000, '\P{Variation_Selector=Yes}', "");
    Expect(0, 918000, '\P{^Variation_Selector=Yes}', "");
    Error('\p{VS=	y/a/}');
    Error('\P{VS=	y/a/}');
    Expect(1, 917999, '\p{VS=:\AY\z:}', "");;
    Expect(0, 918000, '\p{VS=:\AY\z:}', "");;
    Expect(1, 917999, '\p{VS=y}', "");
    Expect(0, 917999, '\p{^VS=y}', "");
    Expect(0, 917999, '\P{VS=y}', "");
    Expect(1, 917999, '\P{^VS=y}', "");
    Expect(0, 918000, '\p{VS=y}', "");
    Expect(1, 918000, '\p{^VS=y}', "");
    Expect(1, 918000, '\P{VS=y}', "");
    Expect(0, 918000, '\P{^VS=y}', "");
    Expect(1, 917999, '\p{VS=:\Ay\z:}', "");;
    Expect(0, 918000, '\p{VS=:\Ay\z:}', "");;
    Expect(1, 917999, '\p{VS=_ Y}', "");
    Expect(0, 917999, '\p{^VS=_ Y}', "");
    Expect(0, 917999, '\P{VS=_ Y}', "");
    Expect(1, 917999, '\P{^VS=_ Y}', "");
    Expect(0, 918000, '\p{VS=_ Y}', "");
    Expect(1, 918000, '\p{^VS=_ Y}', "");
    Expect(1, 918000, '\P{VS=_ Y}', "");
    Expect(0, 918000, '\P{^VS=_ Y}', "");
    Error('\p{Is_Variation_Selector=:=-T}');
    Error('\P{Is_Variation_Selector=:=-T}');
    Expect(1, 917999, '\p{Is_Variation_Selector=t}', "");
    Expect(0, 917999, '\p{^Is_Variation_Selector=t}', "");
    Expect(0, 917999, '\P{Is_Variation_Selector=t}', "");
    Expect(1, 917999, '\P{^Is_Variation_Selector=t}', "");
    Expect(0, 918000, '\p{Is_Variation_Selector=t}', "");
    Expect(1, 918000, '\p{^Is_Variation_Selector=t}', "");
    Expect(1, 918000, '\P{Is_Variation_Selector=t}', "");
    Expect(0, 918000, '\P{^Is_Variation_Selector=t}', "");
    Expect(1, 917999, '\p{Is_Variation_Selector= T}', "");
    Expect(0, 917999, '\p{^Is_Variation_Selector= T}', "");
    Expect(0, 917999, '\P{Is_Variation_Selector= T}', "");
    Expect(1, 917999, '\P{^Is_Variation_Selector= T}', "");
    Expect(0, 918000, '\p{Is_Variation_Selector= T}', "");
    Expect(1, 918000, '\p{^Is_Variation_Selector= T}', "");
    Expect(1, 918000, '\P{Is_Variation_Selector= T}', "");
    Expect(0, 918000, '\P{^Is_Variation_Selector= T}', "");
    Error('\p{Is_VS= :=TRUE}');
    Error('\P{Is_VS= :=TRUE}');
    Expect(1, 917999, '\p{Is_VS=true}', "");
    Expect(0, 917999, '\p{^Is_VS=true}', "");
    Expect(0, 917999, '\P{Is_VS=true}', "");
    Expect(1, 917999, '\P{^Is_VS=true}', "");
    Expect(0, 918000, '\p{Is_VS=true}', "");
    Expect(1, 918000, '\p{^Is_VS=true}', "");
    Expect(1, 918000, '\P{Is_VS=true}', "");
    Expect(0, 918000, '\P{^Is_VS=true}', "");
    Expect(1, 917999, '\p{Is_VS=-_True}', "");
    Expect(0, 917999, '\p{^Is_VS=-_True}', "");
    Expect(0, 917999, '\P{Is_VS=-_True}', "");
    Expect(1, 917999, '\P{^Is_VS=-_True}', "");
    Expect(0, 918000, '\p{Is_VS=-_True}', "");
    Expect(1, 918000, '\p{^Is_VS=-_True}', "");
    Expect(1, 918000, '\P{Is_VS=-_True}', "");
    Expect(0, 918000, '\P{^Is_VS=-_True}', "");
    Error('\p{wordbreak}');
    Error('\P{wordbreak}');
    Error('\p{wb}');
    Error('\P{wb}');
    Error('\p{_perlwb}');
    Error('\P{_perlwb}');
    Error('\p{Word_Break= /a/CR}');
    Error('\P{Word_Break= /a/CR}');
    Expect(1, 13, '\p{Word_Break=:\ACR\z:}', "");;
    Expect(0, 14, '\p{Word_Break=:\ACR\z:}', "");;
    Expect(1, 13, '\p{Word_Break=cr}', "");
    Expect(0, 13, '\p{^Word_Break=cr}', "");
    Expect(0, 13, '\P{Word_Break=cr}', "");
    Expect(1, 13, '\P{^Word_Break=cr}', "");
    Expect(0, 14, '\p{Word_Break=cr}', "");
    Expect(1, 14, '\p{^Word_Break=cr}', "");
    Expect(1, 14, '\P{Word_Break=cr}', "");
    Expect(0, 14, '\P{^Word_Break=cr}', "");
    Expect(1, 13, '\p{Word_Break=:\Acr\z:}', "");;
    Expect(0, 14, '\p{Word_Break=:\Acr\z:}', "");;
    Expect(1, 13, '\p{Word_Break=	 CR}', "");
    Expect(0, 13, '\p{^Word_Break=	 CR}', "");
    Expect(0, 13, '\P{Word_Break=	 CR}', "");
    Expect(1, 13, '\P{^Word_Break=	 CR}', "");
    Expect(0, 14, '\p{Word_Break=	 CR}', "");
    Expect(1, 14, '\p{^Word_Break=	 CR}', "");
    Expect(1, 14, '\P{Word_Break=	 CR}', "");
    Expect(0, 14, '\P{^Word_Break=	 CR}', "");
    Error('\p{WB=_/a/cr}');
    Error('\P{WB=_/a/cr}');
    Expect(1, 13, '\p{WB=:\ACR\z:}', "");;
    Expect(0, 14, '\p{WB=:\ACR\z:}', "");;
    Expect(1, 13, '\p{WB=cr}', "");
    Expect(0, 13, '\p{^WB=cr}', "");
    Expect(0, 13, '\P{WB=cr}', "");
    Expect(1, 13, '\P{^WB=cr}', "");
    Expect(0, 14, '\p{WB=cr}', "");
    Expect(1, 14, '\p{^WB=cr}', "");
    Expect(1, 14, '\P{WB=cr}', "");
    Expect(0, 14, '\P{^WB=cr}', "");
    Expect(1, 13, '\p{WB=:\Acr\z:}', "");;
    Expect(0, 14, '\p{WB=:\Acr\z:}', "");;
    Expect(1, 13, '\p{WB=_-CR}', "");
    Expect(0, 13, '\p{^WB=_-CR}', "");
    Expect(0, 13, '\P{WB=_-CR}', "");
    Expect(1, 13, '\P{^WB=_-CR}', "");
    Expect(0, 14, '\p{WB=_-CR}', "");
    Expect(1, 14, '\p{^WB=_-CR}', "");
    Expect(1, 14, '\P{WB=_-CR}', "");
    Expect(0, 14, '\P{^WB=_-CR}', "");
    Error('\p{Is_Word_Break=:=	CR}');
    Error('\P{Is_Word_Break=:=	CR}');
    Expect(1, 13, '\p{Is_Word_Break=cr}', "");
    Expect(0, 13, '\p{^Is_Word_Break=cr}', "");
    Expect(0, 13, '\P{Is_Word_Break=cr}', "");
    Expect(1, 13, '\P{^Is_Word_Break=cr}', "");
    Expect(0, 14, '\p{Is_Word_Break=cr}', "");
    Expect(1, 14, '\p{^Is_Word_Break=cr}', "");
    Expect(1, 14, '\P{Is_Word_Break=cr}', "");
    Expect(0, 14, '\P{^Is_Word_Break=cr}', "");
    Expect(1, 13, '\p{Is_Word_Break=-	CR}', "");
    Expect(0, 13, '\p{^Is_Word_Break=-	CR}', "");
    Expect(0, 13, '\P{Is_Word_Break=-	CR}', "");
    Expect(1, 13, '\P{^Is_Word_Break=-	CR}', "");
    Expect(0, 14, '\p{Is_Word_Break=-	CR}', "");
    Expect(1, 14, '\p{^Is_Word_Break=-	CR}', "");
    Expect(1, 14, '\P{Is_Word_Break=-	CR}', "");
    Expect(0, 14, '\P{^Is_Word_Break=-	CR}', "");
    Error('\p{Is_WB=	/a/CR}');
    Error('\P{Is_WB=	/a/CR}');
    Expect(1, 13, '\p{Is_WB=cr}', "");
    Expect(0, 13, '\p{^Is_WB=cr}', "");
    Expect(0, 13, '\P{Is_WB=cr}', "");
    Expect(1, 13, '\P{^Is_WB=cr}', "");
    Expect(0, 14, '\p{Is_WB=cr}', "");
    Expect(1, 14, '\p{^Is_WB=cr}', "");
    Expect(1, 14, '\P{Is_WB=cr}', "");
    Expect(0, 14, '\P{^Is_WB=cr}', "");
    Expect(1, 13, '\p{Is_WB=	-cr}', "");
    Expect(0, 13, '\p{^Is_WB=	-cr}', "");
    Expect(0, 13, '\P{Is_WB=	-cr}', "");
    Expect(1, 13, '\P{^Is_WB=	-cr}', "");
    Expect(0, 14, '\p{Is_WB=	-cr}', "");
    Expect(1, 14, '\p{^Is_WB=	-cr}', "");
    Expect(1, 14, '\P{Is_WB=	-cr}', "");
    Expect(0, 14, '\P{^Is_WB=	-cr}', "");
    Error('\p{Word_Break: /a/_-DOUBLE_quote}');
    Error('\P{Word_Break: /a/_-DOUBLE_quote}');
    Expect(1, 34, '\p{Word_Break=:\ADouble_Quote\z:}', "");;
    Expect(0, 35, '\p{Word_Break=:\ADouble_Quote\z:}', "");;
    Expect(1, 34, '\p{Word_Break=doublequote}', "");
    Expect(0, 34, '\p{^Word_Break=doublequote}', "");
    Expect(0, 34, '\P{Word_Break=doublequote}', "");
    Expect(1, 34, '\P{^Word_Break=doublequote}', "");
    Expect(0, 35, '\p{Word_Break=doublequote}', "");
    Expect(1, 35, '\p{^Word_Break=doublequote}', "");
    Expect(1, 35, '\P{Word_Break=doublequote}', "");
    Expect(0, 35, '\P{^Word_Break=doublequote}', "");
    Expect(1, 34, '\p{Word_Break=:\Adoublequote\z:}', "");;
    Expect(0, 35, '\p{Word_Break=:\Adoublequote\z:}', "");;
    Expect(1, 34, '\p{Word_Break=	DOUBLE_quote}', "");
    Expect(0, 34, '\p{^Word_Break=	DOUBLE_quote}', "");
    Expect(0, 34, '\P{Word_Break=	DOUBLE_quote}', "");
    Expect(1, 34, '\P{^Word_Break=	DOUBLE_quote}', "");
    Expect(0, 35, '\p{Word_Break=	DOUBLE_quote}', "");
    Expect(1, 35, '\p{^Word_Break=	DOUBLE_quote}', "");
    Expect(1, 35, '\P{Word_Break=	DOUBLE_quote}', "");
    Expect(0, 35, '\P{^Word_Break=	DOUBLE_quote}', "");
    Error('\p{WB=:=-DQ}');
    Error('\P{WB=:=-DQ}');
    Expect(1, 34, '\p{WB=:\ADQ\z:}', "");;
    Expect(0, 35, '\p{WB=:\ADQ\z:}', "");;
    Expect(1, 34, '\p{WB:dq}', "");
    Expect(0, 34, '\p{^WB:dq}', "");
    Expect(0, 34, '\P{WB:dq}', "");
    Expect(1, 34, '\P{^WB:dq}', "");
    Expect(0, 35, '\p{WB:dq}', "");
    Expect(1, 35, '\p{^WB:dq}', "");
    Expect(1, 35, '\P{WB:dq}', "");
    Expect(0, 35, '\P{^WB:dq}', "");
    Expect(1, 34, '\p{WB=:\Adq\z:}', "");;
    Expect(0, 35, '\p{WB=:\Adq\z:}', "");;
    Expect(1, 34, '\p{WB=_DQ}', "");
    Expect(0, 34, '\p{^WB=_DQ}', "");
    Expect(0, 34, '\P{WB=_DQ}', "");
    Expect(1, 34, '\P{^WB=_DQ}', "");
    Expect(0, 35, '\p{WB=_DQ}', "");
    Expect(1, 35, '\p{^WB=_DQ}', "");
    Expect(1, 35, '\P{WB=_DQ}', "");
    Expect(0, 35, '\P{^WB=_DQ}', "");
    Error('\p{Is_Word_Break= Double_QUOTE/a/}');
    Error('\P{Is_Word_Break= Double_QUOTE/a/}');
    Expect(1, 34, '\p{Is_Word_Break=doublequote}', "");
    Expect(0, 34, '\p{^Is_Word_Break=doublequote}', "");
    Expect(0, 34, '\P{Is_Word_Break=doublequote}', "");
    Expect(1, 34, '\P{^Is_Word_Break=doublequote}', "");
    Expect(0, 35, '\p{Is_Word_Break=doublequote}', "");
    Expect(1, 35, '\p{^Is_Word_Break=doublequote}', "");
    Expect(1, 35, '\P{Is_Word_Break=doublequote}', "");
    Expect(0, 35, '\P{^Is_Word_Break=doublequote}', "");
    Expect(1, 34, '\p{Is_Word_Break= -Double_Quote}', "");
    Expect(0, 34, '\p{^Is_Word_Break= -Double_Quote}', "");
    Expect(0, 34, '\P{Is_Word_Break= -Double_Quote}', "");
    Expect(1, 34, '\P{^Is_Word_Break= -Double_Quote}', "");
    Expect(0, 35, '\p{Is_Word_Break= -Double_Quote}', "");
    Expect(1, 35, '\p{^Is_Word_Break= -Double_Quote}', "");
    Expect(1, 35, '\P{Is_Word_Break= -Double_Quote}', "");
    Expect(0, 35, '\P{^Is_Word_Break= -Double_Quote}', "");
    Error('\p{Is_WB=_-dq:=}');
    Error('\P{Is_WB=_-dq:=}');
    Expect(1, 34, '\p{Is_WB=dq}', "");
    Expect(0, 34, '\p{^Is_WB=dq}', "");
    Expect(0, 34, '\P{Is_WB=dq}', "");
    Expect(1, 34, '\P{^Is_WB=dq}', "");
    Expect(0, 35, '\p{Is_WB=dq}', "");
    Expect(1, 35, '\p{^Is_WB=dq}', "");
    Expect(1, 35, '\P{Is_WB=dq}', "");
    Expect(0, 35, '\P{^Is_WB=dq}', "");
    Expect(1, 34, '\p{Is_WB= -dq}', "");
    Expect(0, 34, '\p{^Is_WB= -dq}', "");
    Expect(0, 34, '\P{Is_WB= -dq}', "");
    Expect(1, 34, '\P{^Is_WB= -dq}', "");
    Expect(0, 35, '\p{Is_WB= -dq}', "");
    Expect(1, 35, '\p{^Is_WB= -dq}', "");
    Expect(1, 35, '\P{Is_WB= -dq}', "");
    Expect(0, 35, '\P{^Is_WB= -dq}', "");
    Error('\p{Word_Break= /a/E_Base}');
    Error('\P{Word_Break= /a/E_Base}');
    Expect(0, 1, '\p{Word_Break=:\AE_Base\z:}', "");;
    Expect(0, 1, '\p{Word_Break=ebase}', "");
    Expect(1, 1, '\p{^Word_Break=ebase}', "");
    Expect(1, 1, '\P{Word_Break=ebase}', "");
    Expect(0, 1, '\P{^Word_Break=ebase}', "");
    Expect(0, 1, '\p{Word_Break=:\Aebase\z:}', "");;
    Expect(0, 1, '\p{Word_Break=e_base}', "");
    Expect(1, 1, '\p{^Word_Break=e_base}', "");
    Expect(1, 1, '\P{Word_Break=e_base}', "");
    Expect(0, 1, '\P{^Word_Break=e_base}', "");
    Error('\p{WB=	:=EB}');
    Error('\P{WB=	:=EB}');
    Expect(0, 1, '\p{WB=:\AEB\z:}', "");;
    Expect(0, 1, '\p{WB=eb}', "");
    Expect(1, 1, '\p{^WB=eb}', "");
    Expect(1, 1, '\P{WB=eb}', "");
    Expect(0, 1, '\P{^WB=eb}', "");
    Expect(0, 1, '\p{WB=:\Aeb\z:}', "");;
    Expect(0, 1, '\p{WB=_-EB}', "");
    Expect(1, 1, '\p{^WB=_-EB}', "");
    Expect(1, 1, '\P{WB=_-EB}', "");
    Expect(0, 1, '\P{^WB=_-EB}', "");
    Error('\p{Is_Word_Break=_/a/e_base}');
    Error('\P{Is_Word_Break=_/a/e_base}');
    Expect(0, 1, '\p{Is_Word_Break=ebase}', "");
    Expect(1, 1, '\p{^Is_Word_Break=ebase}', "");
    Expect(1, 1, '\P{Is_Word_Break=ebase}', "");
    Expect(0, 1, '\P{^Is_Word_Break=ebase}', "");
    Expect(0, 1, '\p{Is_Word_Break= _e_Base}', "");
    Expect(1, 1, '\p{^Is_Word_Break= _e_Base}', "");
    Expect(1, 1, '\P{Is_Word_Break= _e_Base}', "");
    Expect(0, 1, '\P{^Is_Word_Break= _e_Base}', "");
    Error('\p{Is_WB= /a/EB}');
    Error('\P{Is_WB= /a/EB}');
    Expect(0, 1, '\p{Is_WB=eb}', "");
    Expect(1, 1, '\p{^Is_WB=eb}', "");
    Expect(1, 1, '\P{Is_WB=eb}', "");
    Expect(0, 1, '\P{^Is_WB=eb}', "");
    Expect(0, 1, '\p{Is_WB=  eb}', "");
    Expect(1, 1, '\p{^Is_WB=  eb}', "");
    Expect(1, 1, '\P{Is_WB=  eb}', "");
    Expect(0, 1, '\P{^Is_WB=  eb}', "");
    Error('\p{Word_Break=:=E_Base_gaz}');
    Error('\P{Word_Break=:=E_Base_gaz}');
    Expect(0, 1, '\p{Word_Break=:\AE_Base_GAZ\z:}', "");;
    Expect(0, 1, '\p{Word_Break=ebasegaz}', "");
    Expect(1, 1, '\p{^Word_Break=ebasegaz}', "");
    Expect(1, 1, '\P{Word_Break=ebasegaz}', "");
    Expect(0, 1, '\P{^Word_Break=ebasegaz}', "");
    Expect(0, 1, '\p{Word_Break=:\Aebasegaz\z:}', "");;
    Expect(0, 1, '\p{Word_Break=--e_Base_gaz}', "");
    Expect(1, 1, '\p{^Word_Break=--e_Base_gaz}', "");
    Expect(1, 1, '\P{Word_Break=--e_Base_gaz}', "");
    Expect(0, 1, '\P{^Word_Break=--e_Base_gaz}', "");
    Error('\p{WB=/a/  EBG}');
    Error('\P{WB=/a/  EBG}');
    Expect(0, 1, '\p{WB=:\AEBG\z:}', "");;
    Expect(0, 1, '\p{WB=ebg}', "");
    Expect(1, 1, '\p{^WB=ebg}', "");
    Expect(1, 1, '\P{WB=ebg}', "");
    Expect(0, 1, '\P{^WB=ebg}', "");
    Expect(0, 1, '\p{WB=:\Aebg\z:}', "");;
    Expect(0, 1, '\p{WB=-	EBG}', "");
    Expect(1, 1, '\p{^WB=-	EBG}', "");
    Expect(1, 1, '\P{WB=-	EBG}', "");
    Expect(0, 1, '\P{^WB=-	EBG}', "");
    Error('\p{Is_Word_Break= /a/E_Base_GAZ}');
    Error('\P{Is_Word_Break= /a/E_Base_GAZ}');
    Expect(0, 1, '\p{Is_Word_Break=ebasegaz}', "");
    Expect(1, 1, '\p{^Is_Word_Break=ebasegaz}', "");
    Expect(1, 1, '\P{Is_Word_Break=ebasegaz}', "");
    Expect(0, 1, '\P{^Is_Word_Break=ebasegaz}', "");
    Expect(0, 1, '\p{Is_Word_Break=-	E_base_GAZ}', "");
    Expect(1, 1, '\p{^Is_Word_Break=-	E_base_GAZ}', "");
    Expect(1, 1, '\P{Is_Word_Break=-	E_base_GAZ}', "");
    Expect(0, 1, '\P{^Is_Word_Break=-	E_base_GAZ}', "");
    Error('\p{Is_WB=/a/		ebg}');
    Error('\P{Is_WB=/a/		ebg}');
    Expect(0, 1, '\p{Is_WB=ebg}', "");
    Expect(1, 1, '\p{^Is_WB=ebg}', "");
    Expect(1, 1, '\P{Is_WB=ebg}', "");
    Expect(0, 1, '\P{^Is_WB=ebg}', "");
    Expect(0, 1, '\p{Is_WB=  EBG}', "");
    Expect(1, 1, '\p{^Is_WB=  EBG}', "");
    Expect(1, 1, '\P{Is_WB=  EBG}', "");
    Expect(0, 1, '\P{^Is_WB=  EBG}', "");
    Error('\p{Word_Break:	 :=E_MODIFIER}');
    Error('\P{Word_Break:	 :=E_MODIFIER}');
    Expect(0, 1, '\p{Word_Break=:\AE_Modifier\z:}', "");;
    Expect(0, 1, '\p{Word_Break=emodifier}', "");
    Expect(1, 1, '\p{^Word_Break=emodifier}', "");
    Expect(1, 1, '\P{Word_Break=emodifier}', "");
    Expect(0, 1, '\P{^Word_Break=emodifier}', "");
    Expect(0, 1, '\p{Word_Break=:\Aemodifier\z:}', "");;
    Expect(0, 1, '\p{Word_Break=-_E_MODIFIER}', "");
    Expect(1, 1, '\p{^Word_Break=-_E_MODIFIER}', "");
    Expect(1, 1, '\P{Word_Break=-_E_MODIFIER}', "");
    Expect(0, 1, '\P{^Word_Break=-_E_MODIFIER}', "");
    Error('\p{WB=	em:=}');
    Error('\P{WB=	em:=}');
    Expect(0, 1, '\p{WB=:\AEM\z:}', "");;
    Expect(0, 1, '\p{WB=em}', "");
    Expect(1, 1, '\p{^WB=em}', "");
    Expect(1, 1, '\P{WB=em}', "");
    Expect(0, 1, '\P{^WB=em}', "");
    Expect(0, 1, '\p{WB=:\Aem\z:}', "");;
    Expect(0, 1, '\p{WB=- em}', "");
    Expect(1, 1, '\p{^WB=- em}', "");
    Expect(1, 1, '\P{WB=- em}', "");
    Expect(0, 1, '\P{^WB=- em}', "");
    Error('\p{Is_Word_Break=__E_Modifier/a/}');
    Error('\P{Is_Word_Break=__E_Modifier/a/}');
    Expect(0, 1, '\p{Is_Word_Break=emodifier}', "");
    Expect(1, 1, '\p{^Is_Word_Break=emodifier}', "");
    Expect(1, 1, '\P{Is_Word_Break=emodifier}', "");
    Expect(0, 1, '\P{^Is_Word_Break=emodifier}', "");
    Expect(0, 1, '\p{Is_Word_Break=	 E_MODIFIER}', "");
    Expect(1, 1, '\p{^Is_Word_Break=	 E_MODIFIER}', "");
    Expect(1, 1, '\P{Is_Word_Break=	 E_MODIFIER}', "");
    Expect(0, 1, '\P{^Is_Word_Break=	 E_MODIFIER}', "");
    Error('\p{Is_WB:   :=  EM}');
    Error('\P{Is_WB:   :=  EM}');
    Expect(0, 1, '\p{Is_WB=em}', "");
    Expect(1, 1, '\p{^Is_WB=em}', "");
    Expect(1, 1, '\P{Is_WB=em}', "");
    Expect(0, 1, '\P{^Is_WB=em}', "");
    Error('\p{Word_Break=:=_EXTENDNUMLET}');
    Error('\P{Word_Break=:=_EXTENDNUMLET}');
    Expect(1, 65343, '\p{Word_Break=:\AExtendNumLet\z:}', "");;
    Expect(0, 65344, '\p{Word_Break=:\AExtendNumLet\z:}', "");;
    Expect(1, 65343, '\p{Word_Break:	extendnumlet}', "");
    Expect(0, 65343, '\p{^Word_Break:	extendnumlet}', "");
    Expect(0, 65343, '\P{Word_Break:	extendnumlet}', "");
    Expect(1, 65343, '\P{^Word_Break:	extendnumlet}', "");
    Expect(0, 65344, '\p{Word_Break:	extendnumlet}', "");
    Expect(1, 65344, '\p{^Word_Break:	extendnumlet}', "");
    Expect(1, 65344, '\P{Word_Break:	extendnumlet}', "");
    Expect(0, 65344, '\P{^Word_Break:	extendnumlet}', "");
    Expect(1, 65343, '\p{Word_Break=:\Aextendnumlet\z:}', "");;
    Expect(0, 65344, '\p{Word_Break=:\Aextendnumlet\z:}', "");;
    Expect(1, 65343, '\p{Word_Break=-_EXTENDNUMLET}', "");
    Expect(0, 65343, '\p{^Word_Break=-_EXTENDNUMLET}', "");
    Expect(0, 65343, '\P{Word_Break=-_EXTENDNUMLET}', "");
    Expect(1, 65343, '\P{^Word_Break=-_EXTENDNUMLET}', "");
    Expect(0, 65344, '\p{Word_Break=-_EXTENDNUMLET}', "");
    Expect(1, 65344, '\p{^Word_Break=-_EXTENDNUMLET}', "");
    Expect(1, 65344, '\P{Word_Break=-_EXTENDNUMLET}', "");
    Expect(0, 65344, '\P{^Word_Break=-_EXTENDNUMLET}', "");
    Error('\p{WB=/a/ 	EX}');
    Error('\P{WB=/a/ 	EX}');
    Expect(1, 65343, '\p{WB=:\AEX\z:}', "");;
    Expect(0, 65344, '\p{WB=:\AEX\z:}', "");;
    Expect(1, 65343, '\p{WB=ex}', "");
    Expect(0, 65343, '\p{^WB=ex}', "");
    Expect(0, 65343, '\P{WB=ex}', "");
    Expect(1, 65343, '\P{^WB=ex}', "");
    Expect(0, 65344, '\p{WB=ex}', "");
    Expect(1, 65344, '\p{^WB=ex}', "");
    Expect(1, 65344, '\P{WB=ex}', "");
    Expect(0, 65344, '\P{^WB=ex}', "");
    Expect(1, 65343, '\p{WB=:\Aex\z:}', "");;
    Expect(0, 65344, '\p{WB=:\Aex\z:}', "");;
    Expect(1, 65343, '\p{WB= 	EX}', "");
    Expect(0, 65343, '\p{^WB= 	EX}', "");
    Expect(0, 65343, '\P{WB= 	EX}', "");
    Expect(1, 65343, '\P{^WB= 	EX}', "");
    Expect(0, 65344, '\p{WB= 	EX}', "");
    Expect(1, 65344, '\p{^WB= 	EX}', "");
    Expect(1, 65344, '\P{WB= 	EX}', "");
    Expect(0, 65344, '\P{^WB= 	EX}', "");
    Error('\p{Is_Word_Break=/a/--ExtendNumLet}');
    Error('\P{Is_Word_Break=/a/--ExtendNumLet}');
    Expect(1, 65343, '\p{Is_Word_Break=extendnumlet}', "");
    Expect(0, 65343, '\p{^Is_Word_Break=extendnumlet}', "");
    Expect(0, 65343, '\P{Is_Word_Break=extendnumlet}', "");
    Expect(1, 65343, '\P{^Is_Word_Break=extendnumlet}', "");
    Expect(0, 65344, '\p{Is_Word_Break=extendnumlet}', "");
    Expect(1, 65344, '\p{^Is_Word_Break=extendnumlet}', "");
    Expect(1, 65344, '\P{Is_Word_Break=extendnumlet}', "");
    Expect(0, 65344, '\P{^Is_Word_Break=extendnumlet}', "");
    Expect(1, 65343, '\p{Is_Word_Break=	ExtendNumLet}', "");
    Expect(0, 65343, '\p{^Is_Word_Break=	ExtendNumLet}', "");
    Expect(0, 65343, '\P{Is_Word_Break=	ExtendNumLet}', "");
    Expect(1, 65343, '\P{^Is_Word_Break=	ExtendNumLet}', "");
    Expect(0, 65344, '\p{Is_Word_Break=	ExtendNumLet}', "");
    Expect(1, 65344, '\p{^Is_Word_Break=	ExtendNumLet}', "");
    Expect(1, 65344, '\P{Is_Word_Break=	ExtendNumLet}', "");
    Expect(0, 65344, '\P{^Is_Word_Break=	ExtendNumLet}', "");
    Error('\p{Is_WB=:=- ex}');
    Error('\P{Is_WB=:=- ex}');
    Expect(1, 65343, '\p{Is_WB=ex}', "");
    Expect(0, 65343, '\p{^Is_WB=ex}', "");
    Expect(0, 65343, '\P{Is_WB=ex}', "");
    Expect(1, 65343, '\P{^Is_WB=ex}', "");
    Expect(0, 65344, '\p{Is_WB=ex}', "");
    Expect(1, 65344, '\p{^Is_WB=ex}', "");
    Expect(1, 65344, '\P{Is_WB=ex}', "");
    Expect(0, 65344, '\P{^Is_WB=ex}', "");
    Expect(1, 65343, '\p{Is_WB= -EX}', "");
    Expect(0, 65343, '\p{^Is_WB= -EX}', "");
    Expect(0, 65343, '\P{Is_WB= -EX}', "");
    Expect(1, 65343, '\P{^Is_WB= -EX}', "");
    Expect(0, 65344, '\p{Is_WB= -EX}', "");
    Expect(1, 65344, '\p{^Is_WB= -EX}', "");
    Expect(1, 65344, '\P{Is_WB= -EX}', "");
    Expect(0, 65344, '\P{^Is_WB= -EX}', "");
    Error('\p{Word_Break::=-extend}');
    Error('\P{Word_Break::=-extend}');
    Expect(1, 917999, '\p{Word_Break=:\AExtend\z:}', "");;
    Expect(0, 918000, '\p{Word_Break=:\AExtend\z:}', "");;
    Expect(1, 917999, '\p{Word_Break=extend}', "");
    Expect(0, 917999, '\p{^Word_Break=extend}', "");
    Expect(0, 917999, '\P{Word_Break=extend}', "");
    Expect(1, 917999, '\P{^Word_Break=extend}', "");
    Expect(0, 918000, '\p{Word_Break=extend}', "");
    Expect(1, 918000, '\p{^Word_Break=extend}', "");
    Expect(1, 918000, '\P{Word_Break=extend}', "");
    Expect(0, 918000, '\P{^Word_Break=extend}', "");
    Expect(1, 917999, '\p{Word_Break=:\Aextend\z:}', "");;
    Expect(0, 918000, '\p{Word_Break=:\Aextend\z:}', "");;
    Expect(1, 917999, '\p{Word_Break=		EXTEND}', "");
    Expect(0, 917999, '\p{^Word_Break=		EXTEND}', "");
    Expect(0, 917999, '\P{Word_Break=		EXTEND}', "");
    Expect(1, 917999, '\P{^Word_Break=		EXTEND}', "");
    Expect(0, 918000, '\p{Word_Break=		EXTEND}', "");
    Expect(1, 918000, '\p{^Word_Break=		EXTEND}', "");
    Expect(1, 918000, '\P{Word_Break=		EXTEND}', "");
    Expect(0, 918000, '\P{^Word_Break=		EXTEND}', "");
    Error('\p{WB: /a/_ EXTEND}');
    Error('\P{WB: /a/_ EXTEND}');
    Expect(1, 917999, '\p{WB=:\AExtend\z:}', "");;
    Expect(0, 918000, '\p{WB=:\AExtend\z:}', "");;
    Expect(1, 917999, '\p{WB=extend}', "");
    Expect(0, 917999, '\p{^WB=extend}', "");
    Expect(0, 917999, '\P{WB=extend}', "");
    Expect(1, 917999, '\P{^WB=extend}', "");
    Expect(0, 918000, '\p{WB=extend}', "");
    Expect(1, 918000, '\p{^WB=extend}', "");
    Expect(1, 918000, '\P{WB=extend}', "");
    Expect(0, 918000, '\P{^WB=extend}', "");
    Expect(1, 917999, '\p{WB=:\Aextend\z:}', "");;
    Expect(0, 918000, '\p{WB=:\Aextend\z:}', "");;
    Expect(1, 917999, '\p{WB=__extend}', "");
    Expect(0, 917999, '\p{^WB=__extend}', "");
    Expect(0, 917999, '\P{WB=__extend}', "");
    Expect(1, 917999, '\P{^WB=__extend}', "");
    Expect(0, 918000, '\p{WB=__extend}', "");
    Expect(1, 918000, '\p{^WB=__extend}', "");
    Expect(1, 918000, '\P{WB=__extend}', "");
    Expect(0, 918000, '\P{^WB=__extend}', "");
    Error('\p{Is_Word_Break=/a/		Extend}');
    Error('\P{Is_Word_Break=/a/		Extend}');
    Expect(1, 917999, '\p{Is_Word_Break=extend}', "");
    Expect(0, 917999, '\p{^Is_Word_Break=extend}', "");
    Expect(0, 917999, '\P{Is_Word_Break=extend}', "");
    Expect(1, 917999, '\P{^Is_Word_Break=extend}', "");
    Expect(0, 918000, '\p{Is_Word_Break=extend}', "");
    Expect(1, 918000, '\p{^Is_Word_Break=extend}', "");
    Expect(1, 918000, '\P{Is_Word_Break=extend}', "");
    Expect(0, 918000, '\P{^Is_Word_Break=extend}', "");
    Expect(1, 917999, '\p{Is_Word_Break=	Extend}', "");
    Expect(0, 917999, '\p{^Is_Word_Break=	Extend}', "");
    Expect(0, 917999, '\P{Is_Word_Break=	Extend}', "");
    Expect(1, 917999, '\P{^Is_Word_Break=	Extend}', "");
    Expect(0, 918000, '\p{Is_Word_Break=	Extend}', "");
    Expect(1, 918000, '\p{^Is_Word_Break=	Extend}', "");
    Expect(1, 918000, '\P{Is_Word_Break=	Extend}', "");
    Expect(0, 918000, '\P{^Is_Word_Break=	Extend}', "");
    Error('\p{Is_WB= :=Extend}');
    Error('\P{Is_WB= :=Extend}');
    Expect(1, 917999, '\p{Is_WB=extend}', "");
    Expect(0, 917999, '\p{^Is_WB=extend}', "");
    Expect(0, 917999, '\P{Is_WB=extend}', "");
    Expect(1, 917999, '\P{^Is_WB=extend}', "");
    Expect(0, 918000, '\p{Is_WB=extend}', "");
    Expect(1, 918000, '\p{^Is_WB=extend}', "");
    Expect(1, 918000, '\P{Is_WB=extend}', "");
    Expect(0, 918000, '\P{^Is_WB=extend}', "");
    Expect(1, 917999, '\p{Is_WB:		_Extend}', "");
    Expect(0, 917999, '\p{^Is_WB:		_Extend}', "");
    Expect(0, 917999, '\P{Is_WB:		_Extend}', "");
    Expect(1, 917999, '\P{^Is_WB:		_Extend}', "");
    Expect(0, 918000, '\p{Is_WB:		_Extend}', "");
    Expect(1, 918000, '\p{^Is_WB:		_Extend}', "");
    Expect(1, 918000, '\P{Is_WB:		_Extend}', "");
    Expect(0, 918000, '\P{^Is_WB:		_Extend}', "");
    Error('\p{Word_Break=_-format:=}');
    Error('\P{Word_Break=_-format:=}');
    Expect(1, 917505, '\p{Word_Break=:\AFormat\z:}', "");;
    Expect(0, 917506, '\p{Word_Break=:\AFormat\z:}', "");;
    Expect(1, 917505, '\p{Word_Break=format}', "");
    Expect(0, 917505, '\p{^Word_Break=format}', "");
    Expect(0, 917505, '\P{Word_Break=format}', "");
    Expect(1, 917505, '\P{^Word_Break=format}', "");
    Expect(0, 917506, '\p{Word_Break=format}', "");
    Expect(1, 917506, '\p{^Word_Break=format}', "");
    Expect(1, 917506, '\P{Word_Break=format}', "");
    Expect(0, 917506, '\P{^Word_Break=format}', "");
    Expect(1, 917505, '\p{Word_Break=:\Aformat\z:}', "");;
    Expect(0, 917506, '\p{Word_Break=:\Aformat\z:}', "");;
    Expect(1, 917505, '\p{Word_Break=_ FORMAT}', "");
    Expect(0, 917505, '\p{^Word_Break=_ FORMAT}', "");
    Expect(0, 917505, '\P{Word_Break=_ FORMAT}', "");
    Expect(1, 917505, '\P{^Word_Break=_ FORMAT}', "");
    Expect(0, 917506, '\p{Word_Break=_ FORMAT}', "");
    Expect(1, 917506, '\p{^Word_Break=_ FORMAT}', "");
    Expect(1, 917506, '\P{Word_Break=_ FORMAT}', "");
    Expect(0, 917506, '\P{^Word_Break=_ FORMAT}', "");
    Error('\p{WB=:=_FO}');
    Error('\P{WB=:=_FO}');
    Expect(1, 917505, '\p{WB=:\AFO\z:}', "");;
    Expect(0, 917506, '\p{WB=:\AFO\z:}', "");;
    Expect(1, 917505, '\p{WB=fo}', "");
    Expect(0, 917505, '\p{^WB=fo}', "");
    Expect(0, 917505, '\P{WB=fo}', "");
    Expect(1, 917505, '\P{^WB=fo}', "");
    Expect(0, 917506, '\p{WB=fo}', "");
    Expect(1, 917506, '\p{^WB=fo}', "");
    Expect(1, 917506, '\P{WB=fo}', "");
    Expect(0, 917506, '\P{^WB=fo}', "");
    Expect(1, 917505, '\p{WB=:\Afo\z:}', "");;
    Expect(0, 917506, '\p{WB=:\Afo\z:}', "");;
    Expect(1, 917505, '\p{WB=_FO}', "");
    Expect(0, 917505, '\p{^WB=_FO}', "");
    Expect(0, 917505, '\P{WB=_FO}', "");
    Expect(1, 917505, '\P{^WB=_FO}', "");
    Expect(0, 917506, '\p{WB=_FO}', "");
    Expect(1, 917506, '\p{^WB=_FO}', "");
    Expect(1, 917506, '\P{WB=_FO}', "");
    Expect(0, 917506, '\P{^WB=_FO}', "");
    Error('\p{Is_Word_Break=-_format:=}');
    Error('\P{Is_Word_Break=-_format:=}');
    Expect(1, 917505, '\p{Is_Word_Break=format}', "");
    Expect(0, 917505, '\p{^Is_Word_Break=format}', "");
    Expect(0, 917505, '\P{Is_Word_Break=format}', "");
    Expect(1, 917505, '\P{^Is_Word_Break=format}', "");
    Expect(0, 917506, '\p{Is_Word_Break=format}', "");
    Expect(1, 917506, '\p{^Is_Word_Break=format}', "");
    Expect(1, 917506, '\P{Is_Word_Break=format}', "");
    Expect(0, 917506, '\P{^Is_Word_Break=format}', "");
    Expect(1, 917505, '\p{Is_Word_Break=	Format}', "");
    Expect(0, 917505, '\p{^Is_Word_Break=	Format}', "");
    Expect(0, 917505, '\P{Is_Word_Break=	Format}', "");
    Expect(1, 917505, '\P{^Is_Word_Break=	Format}', "");
    Expect(0, 917506, '\p{Is_Word_Break=	Format}', "");
    Expect(1, 917506, '\p{^Is_Word_Break=	Format}', "");
    Expect(1, 917506, '\P{Is_Word_Break=	Format}', "");
    Expect(0, 917506, '\P{^Is_Word_Break=	Format}', "");
    Error('\p{Is_WB=	FO:=}');
    Error('\P{Is_WB=	FO:=}');
    Expect(1, 917505, '\p{Is_WB=fo}', "");
    Expect(0, 917505, '\p{^Is_WB=fo}', "");
    Expect(0, 917505, '\P{Is_WB=fo}', "");
    Expect(1, 917505, '\P{^Is_WB=fo}', "");
    Expect(0, 917506, '\p{Is_WB=fo}', "");
    Expect(1, 917506, '\p{^Is_WB=fo}', "");
    Expect(1, 917506, '\P{Is_WB=fo}', "");
    Expect(0, 917506, '\P{^Is_WB=fo}', "");
    Expect(1, 917505, '\p{Is_WB= fo}', "");
    Expect(0, 917505, '\p{^Is_WB= fo}', "");
    Expect(0, 917505, '\P{Is_WB= fo}', "");
    Expect(1, 917505, '\P{^Is_WB= fo}', "");
    Expect(0, 917506, '\p{Is_WB= fo}', "");
    Expect(1, 917506, '\p{^Is_WB= fo}', "");
    Expect(1, 917506, '\P{Is_WB= fo}', "");
    Expect(0, 917506, '\P{^Is_WB= fo}', "");
    Error('\p{Word_Break=:=	glue_after_zwj}');
    Error('\P{Word_Break=:=	glue_after_zwj}');
    Expect(0, 1, '\p{Word_Break=:\AGlue_After_Zwj\z:}', "");;
    Expect(0, 1, '\p{Word_Break: glueafterzwj}', "");
    Expect(1, 1, '\p{^Word_Break: glueafterzwj}', "");
    Expect(1, 1, '\P{Word_Break: glueafterzwj}', "");
    Expect(0, 1, '\P{^Word_Break: glueafterzwj}', "");
    Expect(0, 1, '\p{Word_Break=:\Aglueafterzwj\z:}', "");;
    Expect(0, 1, '\p{Word_Break=	 Glue_After_zwj}', "");
    Expect(1, 1, '\p{^Word_Break=	 Glue_After_zwj}', "");
    Expect(1, 1, '\P{Word_Break=	 Glue_After_zwj}', "");
    Expect(0, 1, '\P{^Word_Break=	 Glue_After_zwj}', "");
    Error('\p{WB=/a/-gaz}');
    Error('\P{WB=/a/-gaz}');
    Expect(0, 1, '\p{WB=:\AGAZ\z:}', "");;
    Expect(0, 1, '\p{WB=gaz}', "");
    Expect(1, 1, '\p{^WB=gaz}', "");
    Expect(1, 1, '\P{WB=gaz}', "");
    Expect(0, 1, '\P{^WB=gaz}', "");
    Expect(0, 1, '\p{WB=:\Agaz\z:}', "");;
    Expect(0, 1, '\p{WB=GAZ}', "");
    Expect(1, 1, '\p{^WB=GAZ}', "");
    Expect(1, 1, '\P{WB=GAZ}', "");
    Expect(0, 1, '\P{^WB=GAZ}', "");
    Error('\p{Is_Word_Break=-:=glue_After_ZWJ}');
    Error('\P{Is_Word_Break=-:=glue_After_ZWJ}');
    Expect(0, 1, '\p{Is_Word_Break=glueafterzwj}', "");
    Expect(1, 1, '\p{^Is_Word_Break=glueafterzwj}', "");
    Expect(1, 1, '\P{Is_Word_Break=glueafterzwj}', "");
    Expect(0, 1, '\P{^Is_Word_Break=glueafterzwj}', "");
    Expect(0, 1, '\p{Is_Word_Break=_GLUE_after_Zwj}', "");
    Expect(1, 1, '\p{^Is_Word_Break=_GLUE_after_Zwj}', "");
    Expect(1, 1, '\P{Is_Word_Break=_GLUE_after_Zwj}', "");
    Expect(0, 1, '\P{^Is_Word_Break=_GLUE_after_Zwj}', "");
    Error('\p{Is_WB=_ GAZ:=}');
    Error('\P{Is_WB=_ GAZ:=}');
    Expect(0, 1, '\p{Is_WB=gaz}', "");
    Expect(1, 1, '\p{^Is_WB=gaz}', "");
    Expect(1, 1, '\P{Is_WB=gaz}', "");
    Expect(0, 1, '\P{^Is_WB=gaz}', "");
    Expect(0, 1, '\p{Is_WB=__GAZ}', "");
    Expect(1, 1, '\p{^Is_WB=__GAZ}', "");
    Expect(1, 1, '\P{Is_WB=__GAZ}', "");
    Expect(0, 1, '\P{^Is_WB=__GAZ}', "");
    Error('\p{Word_Break=		Hebrew_Letter:=}');
    Error('\P{Word_Break=		Hebrew_Letter:=}');
    Expect(1, 64335, '\p{Word_Break=:\AHebrew_Letter\z:}', "");;
    Expect(0, 64336, '\p{Word_Break=:\AHebrew_Letter\z:}', "");;
    Expect(1, 64335, '\p{Word_Break=hebrewletter}', "");
    Expect(0, 64335, '\p{^Word_Break=hebrewletter}', "");
    Expect(0, 64335, '\P{Word_Break=hebrewletter}', "");
    Expect(1, 64335, '\P{^Word_Break=hebrewletter}', "");
    Expect(0, 64336, '\p{Word_Break=hebrewletter}', "");
    Expect(1, 64336, '\p{^Word_Break=hebrewletter}', "");
    Expect(1, 64336, '\P{Word_Break=hebrewletter}', "");
    Expect(0, 64336, '\P{^Word_Break=hebrewletter}', "");
    Expect(1, 64335, '\p{Word_Break=:\Ahebrewletter\z:}', "");;
    Expect(0, 64336, '\p{Word_Break=:\Ahebrewletter\z:}', "");;
    Expect(1, 64335, '\p{Word_Break=- hebrew_letter}', "");
    Expect(0, 64335, '\p{^Word_Break=- hebrew_letter}', "");
    Expect(0, 64335, '\P{Word_Break=- hebrew_letter}', "");
    Expect(1, 64335, '\P{^Word_Break=- hebrew_letter}', "");
    Expect(0, 64336, '\p{Word_Break=- hebrew_letter}', "");
    Expect(1, 64336, '\p{^Word_Break=- hebrew_letter}', "");
    Expect(1, 64336, '\P{Word_Break=- hebrew_letter}', "");
    Expect(0, 64336, '\P{^Word_Break=- hebrew_letter}', "");
    Error('\p{WB= /a/HL}');
    Error('\P{WB= /a/HL}');
    Expect(1, 64335, '\p{WB=:\AHL\z:}', "");;
    Expect(0, 64336, '\p{WB=:\AHL\z:}', "");;
    Expect(1, 64335, '\p{WB=hl}', "");
    Expect(0, 64335, '\p{^WB=hl}', "");
    Expect(0, 64335, '\P{WB=hl}', "");
    Expect(1, 64335, '\P{^WB=hl}', "");
    Expect(0, 64336, '\p{WB=hl}', "");
    Expect(1, 64336, '\p{^WB=hl}', "");
    Expect(1, 64336, '\P{WB=hl}', "");
    Expect(0, 64336, '\P{^WB=hl}', "");
    Expect(1, 64335, '\p{WB=:\Ahl\z:}', "");;
    Expect(0, 64336, '\p{WB=:\Ahl\z:}', "");;
    Expect(1, 64335, '\p{WB=_HL}', "");
    Expect(0, 64335, '\p{^WB=_HL}', "");
    Expect(0, 64335, '\P{WB=_HL}', "");
    Expect(1, 64335, '\P{^WB=_HL}', "");
    Expect(0, 64336, '\p{WB=_HL}', "");
    Expect(1, 64336, '\p{^WB=_HL}', "");
    Expect(1, 64336, '\P{WB=_HL}', "");
    Expect(0, 64336, '\P{^WB=_HL}', "");
    Error('\p{Is_Word_Break=-/a/hebrew_Letter}');
    Error('\P{Is_Word_Break=-/a/hebrew_Letter}');
    Expect(1, 64335, '\p{Is_Word_Break=hebrewletter}', "");
    Expect(0, 64335, '\p{^Is_Word_Break=hebrewletter}', "");
    Expect(0, 64335, '\P{Is_Word_Break=hebrewletter}', "");
    Expect(1, 64335, '\P{^Is_Word_Break=hebrewletter}', "");
    Expect(0, 64336, '\p{Is_Word_Break=hebrewletter}', "");
    Expect(1, 64336, '\p{^Is_Word_Break=hebrewletter}', "");
    Expect(1, 64336, '\P{Is_Word_Break=hebrewletter}', "");
    Expect(0, 64336, '\P{^Is_Word_Break=hebrewletter}', "");
    Expect(1, 64335, '\p{Is_Word_Break=	_Hebrew_letter}', "");
    Expect(0, 64335, '\p{^Is_Word_Break=	_Hebrew_letter}', "");
    Expect(0, 64335, '\P{Is_Word_Break=	_Hebrew_letter}', "");
    Expect(1, 64335, '\P{^Is_Word_Break=	_Hebrew_letter}', "");
    Expect(0, 64336, '\p{Is_Word_Break=	_Hebrew_letter}', "");
    Expect(1, 64336, '\p{^Is_Word_Break=	_Hebrew_letter}', "");
    Expect(1, 64336, '\P{Is_Word_Break=	_Hebrew_letter}', "");
    Expect(0, 64336, '\P{^Is_Word_Break=	_Hebrew_letter}', "");
    Error('\p{Is_WB=-	HL:=}');
    Error('\P{Is_WB=-	HL:=}');
    Expect(1, 64335, '\p{Is_WB=hl}', "");
    Expect(0, 64335, '\p{^Is_WB=hl}', "");
    Expect(0, 64335, '\P{Is_WB=hl}', "");
    Expect(1, 64335, '\P{^Is_WB=hl}', "");
    Expect(0, 64336, '\p{Is_WB=hl}', "");
    Expect(1, 64336, '\p{^Is_WB=hl}', "");
    Expect(1, 64336, '\P{Is_WB=hl}', "");
    Expect(0, 64336, '\P{^Is_WB=hl}', "");
    Expect(1, 64335, '\p{Is_WB=_-hl}', "");
    Expect(0, 64335, '\p{^Is_WB=_-hl}', "");
    Expect(0, 64335, '\P{Is_WB=_-hl}', "");
    Expect(1, 64335, '\P{^Is_WB=_-hl}', "");
    Expect(0, 64336, '\p{Is_WB=_-hl}', "");
    Expect(1, 64336, '\p{^Is_WB=_-hl}', "");
    Expect(1, 64336, '\P{Is_WB=_-hl}', "");
    Expect(0, 64336, '\P{^Is_WB=_-hl}', "");
    Error('\p{Word_Break= -katakana/a/}');
    Error('\P{Word_Break= -katakana/a/}');
    Expect(1, 110951, '\p{Word_Break=:\AKatakana\z:}', "");;
    Expect(0, 110952, '\p{Word_Break=:\AKatakana\z:}', "");;
    Expect(1, 110951, '\p{Word_Break=katakana}', "");
    Expect(0, 110951, '\p{^Word_Break=katakana}', "");
    Expect(0, 110951, '\P{Word_Break=katakana}', "");
    Expect(1, 110951, '\P{^Word_Break=katakana}', "");
    Expect(0, 110952, '\p{Word_Break=katakana}', "");
    Expect(1, 110952, '\p{^Word_Break=katakana}', "");
    Expect(1, 110952, '\P{Word_Break=katakana}', "");
    Expect(0, 110952, '\P{^Word_Break=katakana}', "");
    Expect(1, 110951, '\p{Word_Break=:\Akatakana\z:}', "");;
    Expect(0, 110952, '\p{Word_Break=:\Akatakana\z:}', "");;
    Expect(1, 110951, '\p{Word_Break=__KATAKANA}', "");
    Expect(0, 110951, '\p{^Word_Break=__KATAKANA}', "");
    Expect(0, 110951, '\P{Word_Break=__KATAKANA}', "");
    Expect(1, 110951, '\P{^Word_Break=__KATAKANA}', "");
    Expect(0, 110952, '\p{Word_Break=__KATAKANA}', "");
    Expect(1, 110952, '\p{^Word_Break=__KATAKANA}', "");
    Expect(1, 110952, '\P{Word_Break=__KATAKANA}', "");
    Expect(0, 110952, '\P{^Word_Break=__KATAKANA}', "");
    Error('\p{WB=		KA/a/}');
    Error('\P{WB=		KA/a/}');
    Expect(1, 110951, '\p{WB=:\AKA\z:}', "");;
    Expect(0, 110952, '\p{WB=:\AKA\z:}', "");;
    Expect(1, 110951, '\p{WB=ka}', "");
    Expect(0, 110951, '\p{^WB=ka}', "");
    Expect(0, 110951, '\P{WB=ka}', "");
    Expect(1, 110951, '\P{^WB=ka}', "");
    Expect(0, 110952, '\p{WB=ka}', "");
    Expect(1, 110952, '\p{^WB=ka}', "");
    Expect(1, 110952, '\P{WB=ka}', "");
    Expect(0, 110952, '\P{^WB=ka}', "");
    Expect(1, 110951, '\p{WB=:\Aka\z:}', "");;
    Expect(0, 110952, '\p{WB=:\Aka\z:}', "");;
    Expect(1, 110951, '\p{WB=	KA}', "");
    Expect(0, 110951, '\p{^WB=	KA}', "");
    Expect(0, 110951, '\P{WB=	KA}', "");
    Expect(1, 110951, '\P{^WB=	KA}', "");
    Expect(0, 110952, '\p{WB=	KA}', "");
    Expect(1, 110952, '\p{^WB=	KA}', "");
    Expect(1, 110952, '\P{WB=	KA}', "");
    Expect(0, 110952, '\P{^WB=	KA}', "");
    Error('\p{Is_Word_Break=/a/	 KATAKANA}');
    Error('\P{Is_Word_Break=/a/	 KATAKANA}');
    Expect(1, 110951, '\p{Is_Word_Break=katakana}', "");
    Expect(0, 110951, '\p{^Is_Word_Break=katakana}', "");
    Expect(0, 110951, '\P{Is_Word_Break=katakana}', "");
    Expect(1, 110951, '\P{^Is_Word_Break=katakana}', "");
    Expect(0, 110952, '\p{Is_Word_Break=katakana}', "");
    Expect(1, 110952, '\p{^Is_Word_Break=katakana}', "");
    Expect(1, 110952, '\P{Is_Word_Break=katakana}', "");
    Expect(0, 110952, '\P{^Is_Word_Break=katakana}', "");
    Expect(1, 110951, '\p{Is_Word_Break=		katakana}', "");
    Expect(0, 110951, '\p{^Is_Word_Break=		katakana}', "");
    Expect(0, 110951, '\P{Is_Word_Break=		katakana}', "");
    Expect(1, 110951, '\P{^Is_Word_Break=		katakana}', "");
    Expect(0, 110952, '\p{Is_Word_Break=		katakana}', "");
    Expect(1, 110952, '\p{^Is_Word_Break=		katakana}', "");
    Expect(1, 110952, '\P{Is_Word_Break=		katakana}', "");
    Expect(0, 110952, '\P{^Is_Word_Break=		katakana}', "");
    Error('\p{Is_WB= :=ka}');
    Error('\P{Is_WB= :=ka}');
    Expect(1, 110951, '\p{Is_WB=ka}', "");
    Expect(0, 110951, '\p{^Is_WB=ka}', "");
    Expect(0, 110951, '\P{Is_WB=ka}', "");
    Expect(1, 110951, '\P{^Is_WB=ka}', "");
    Expect(0, 110952, '\p{Is_WB=ka}', "");
    Expect(1, 110952, '\p{^Is_WB=ka}', "");
    Expect(1, 110952, '\P{Is_WB=ka}', "");
    Expect(0, 110952, '\P{^Is_WB=ka}', "");
    Expect(1, 110951, '\p{Is_WB= _ka}', "");
    Expect(0, 110951, '\p{^Is_WB= _ka}', "");
    Expect(0, 110951, '\P{Is_WB= _ka}', "");
    Expect(1, 110951, '\P{^Is_WB= _ka}', "");
    Expect(0, 110952, '\p{Is_WB= _ka}', "");
    Expect(1, 110952, '\p{^Is_WB= _ka}', "");
    Expect(1, 110952, '\P{Is_WB= _ka}', "");
    Expect(0, 110952, '\P{^Is_WB= _ka}', "");
    Error('\p{Word_Break=_:=ALETTER}');
    Error('\P{Word_Break=_:=ALETTER}');
    Expect(1, 127369, '\p{Word_Break=:\AALetter\z:}', "");;
    Expect(0, 127370, '\p{Word_Break=:\AALetter\z:}', "");;
    Expect(1, 127369, '\p{Word_Break=aletter}', "");
    Expect(0, 127369, '\p{^Word_Break=aletter}', "");
    Expect(0, 127369, '\P{Word_Break=aletter}', "");
    Expect(1, 127369, '\P{^Word_Break=aletter}', "");
    Expect(0, 127370, '\p{Word_Break=aletter}', "");
    Expect(1, 127370, '\p{^Word_Break=aletter}', "");
    Expect(1, 127370, '\P{Word_Break=aletter}', "");
    Expect(0, 127370, '\P{^Word_Break=aletter}', "");
    Expect(1, 127369, '\p{Word_Break=:\Aaletter\z:}', "");;
    Expect(0, 127370, '\p{Word_Break=:\Aaletter\z:}', "");;
    Expect(1, 127369, '\p{Word_Break=_	aletter}', "");
    Expect(0, 127369, '\p{^Word_Break=_	aletter}', "");
    Expect(0, 127369, '\P{Word_Break=_	aletter}', "");
    Expect(1, 127369, '\P{^Word_Break=_	aletter}', "");
    Expect(0, 127370, '\p{Word_Break=_	aletter}', "");
    Expect(1, 127370, '\p{^Word_Break=_	aletter}', "");
    Expect(1, 127370, '\P{Word_Break=_	aletter}', "");
    Expect(0, 127370, '\P{^Word_Break=_	aletter}', "");
    Error('\p{WB= -le:=}');
    Error('\P{WB= -le:=}');
    Expect(1, 127369, '\p{WB=:\ALE\z:}', "");;
    Expect(0, 127370, '\p{WB=:\ALE\z:}', "");;
    Expect(1, 127369, '\p{WB=le}', "");
    Expect(0, 127369, '\p{^WB=le}', "");
    Expect(0, 127369, '\P{WB=le}', "");
    Expect(1, 127369, '\P{^WB=le}', "");
    Expect(0, 127370, '\p{WB=le}', "");
    Expect(1, 127370, '\p{^WB=le}', "");
    Expect(1, 127370, '\P{WB=le}', "");
    Expect(0, 127370, '\P{^WB=le}', "");
    Expect(1, 127369, '\p{WB=:\Ale\z:}', "");;
    Expect(0, 127370, '\p{WB=:\Ale\z:}', "");;
    Expect(1, 127369, '\p{WB=_le}', "");
    Expect(0, 127369, '\p{^WB=_le}', "");
    Expect(0, 127369, '\P{WB=_le}', "");
    Expect(1, 127369, '\P{^WB=_le}', "");
    Expect(0, 127370, '\p{WB=_le}', "");
    Expect(1, 127370, '\p{^WB=_le}', "");
    Expect(1, 127370, '\P{WB=_le}', "");
    Expect(0, 127370, '\P{^WB=_le}', "");
    Error('\p{Is_Word_Break= ALETTER:=}');
    Error('\P{Is_Word_Break= ALETTER:=}');
    Expect(1, 127369, '\p{Is_Word_Break=aletter}', "");
    Expect(0, 127369, '\p{^Is_Word_Break=aletter}', "");
    Expect(0, 127369, '\P{Is_Word_Break=aletter}', "");
    Expect(1, 127369, '\P{^Is_Word_Break=aletter}', "");
    Expect(0, 127370, '\p{Is_Word_Break=aletter}', "");
    Expect(1, 127370, '\p{^Is_Word_Break=aletter}', "");
    Expect(1, 127370, '\P{Is_Word_Break=aletter}', "");
    Expect(0, 127370, '\P{^Is_Word_Break=aletter}', "");
    Expect(1, 127369, '\p{Is_Word_Break= -aletter}', "");
    Expect(0, 127369, '\p{^Is_Word_Break= -aletter}', "");
    Expect(0, 127369, '\P{Is_Word_Break= -aletter}', "");
    Expect(1, 127369, '\P{^Is_Word_Break= -aletter}', "");
    Expect(0, 127370, '\p{Is_Word_Break= -aletter}', "");
    Expect(1, 127370, '\p{^Is_Word_Break= -aletter}', "");
    Expect(1, 127370, '\P{Is_Word_Break= -aletter}', "");
    Expect(0, 127370, '\P{^Is_Word_Break= -aletter}', "");
    Error('\p{Is_WB:     le:=}');
    Error('\P{Is_WB:     le:=}');
    Expect(1, 127369, '\p{Is_WB:le}', "");
    Expect(0, 127369, '\p{^Is_WB:le}', "");
    Expect(0, 127369, '\P{Is_WB:le}', "");
    Expect(1, 127369, '\P{^Is_WB:le}', "");
    Expect(0, 127370, '\p{Is_WB:le}', "");
    Expect(1, 127370, '\p{^Is_WB:le}', "");
    Expect(1, 127370, '\P{Is_WB:le}', "");
    Expect(0, 127370, '\P{^Is_WB:le}', "");
    Expect(1, 127369, '\p{Is_WB=_	LE}', "");
    Expect(0, 127369, '\p{^Is_WB=_	LE}', "");
    Expect(0, 127369, '\P{Is_WB=_	LE}', "");
    Expect(1, 127369, '\P{^Is_WB=_	LE}', "");
    Expect(0, 127370, '\p{Is_WB=_	LE}', "");
    Expect(1, 127370, '\p{^Is_WB=_	LE}', "");
    Expect(1, 127370, '\P{Is_WB=_	LE}', "");
    Expect(0, 127370, '\P{^Is_WB=_	LE}', "");
    Error('\p{Word_Break: 	LF:=}');
    Error('\P{Word_Break: 	LF:=}');
    Expect(1, 10, '\p{Word_Break=:\ALF\z:}', "");;
    Expect(0, 11, '\p{Word_Break=:\ALF\z:}', "");;
    Expect(1, 10, '\p{Word_Break=lf}', "");
    Expect(0, 10, '\p{^Word_Break=lf}', "");
    Expect(0, 10, '\P{Word_Break=lf}', "");
    Expect(1, 10, '\P{^Word_Break=lf}', "");
    Expect(0, 11, '\p{Word_Break=lf}', "");
    Expect(1, 11, '\p{^Word_Break=lf}', "");
    Expect(1, 11, '\P{Word_Break=lf}', "");
    Expect(0, 11, '\P{^Word_Break=lf}', "");
    Expect(1, 10, '\p{Word_Break=:\Alf\z:}', "");;
    Expect(0, 11, '\p{Word_Break=:\Alf\z:}', "");;
    Expect(1, 10, '\p{Word_Break= -lf}', "");
    Expect(0, 10, '\p{^Word_Break= -lf}', "");
    Expect(0, 10, '\P{Word_Break= -lf}', "");
    Expect(1, 10, '\P{^Word_Break= -lf}', "");
    Expect(0, 11, '\p{Word_Break= -lf}', "");
    Expect(1, 11, '\p{^Word_Break= -lf}', "");
    Expect(1, 11, '\P{Word_Break= -lf}', "");
    Expect(0, 11, '\P{^Word_Break= -lf}', "");
    Error('\p{WB=/a/  lf}');
    Error('\P{WB=/a/  lf}');
    Expect(1, 10, '\p{WB=:\ALF\z:}', "");;
    Expect(0, 11, '\p{WB=:\ALF\z:}', "");;
    Expect(1, 10, '\p{WB=lf}', "");
    Expect(0, 10, '\p{^WB=lf}', "");
    Expect(0, 10, '\P{WB=lf}', "");
    Expect(1, 10, '\P{^WB=lf}', "");
    Expect(0, 11, '\p{WB=lf}', "");
    Expect(1, 11, '\p{^WB=lf}', "");
    Expect(1, 11, '\P{WB=lf}', "");
    Expect(0, 11, '\P{^WB=lf}', "");
    Expect(1, 10, '\p{WB=:\Alf\z:}', "");;
    Expect(0, 11, '\p{WB=:\Alf\z:}', "");;
    Expect(1, 10, '\p{WB=	 LF}', "");
    Expect(0, 10, '\p{^WB=	 LF}', "");
    Expect(0, 10, '\P{WB=	 LF}', "");
    Expect(1, 10, '\P{^WB=	 LF}', "");
    Expect(0, 11, '\p{WB=	 LF}', "");
    Expect(1, 11, '\p{^WB=	 LF}', "");
    Expect(1, 11, '\P{WB=	 LF}', "");
    Expect(0, 11, '\P{^WB=	 LF}', "");
    Error('\p{Is_Word_Break=_LF:=}');
    Error('\P{Is_Word_Break=_LF:=}');
    Expect(1, 10, '\p{Is_Word_Break=lf}', "");
    Expect(0, 10, '\p{^Is_Word_Break=lf}', "");
    Expect(0, 10, '\P{Is_Word_Break=lf}', "");
    Expect(1, 10, '\P{^Is_Word_Break=lf}', "");
    Expect(0, 11, '\p{Is_Word_Break=lf}', "");
    Expect(1, 11, '\p{^Is_Word_Break=lf}', "");
    Expect(1, 11, '\P{Is_Word_Break=lf}', "");
    Expect(0, 11, '\P{^Is_Word_Break=lf}', "");
    Expect(1, 10, '\p{Is_Word_Break=	_lf}', "");
    Expect(0, 10, '\p{^Is_Word_Break=	_lf}', "");
    Expect(0, 10, '\P{Is_Word_Break=	_lf}', "");
    Expect(1, 10, '\P{^Is_Word_Break=	_lf}', "");
    Expect(0, 11, '\p{Is_Word_Break=	_lf}', "");
    Expect(1, 11, '\p{^Is_Word_Break=	_lf}', "");
    Expect(1, 11, '\P{Is_Word_Break=	_lf}', "");
    Expect(0, 11, '\P{^Is_Word_Break=	_lf}', "");
    Error('\p{Is_WB=--lf:=}');
    Error('\P{Is_WB=--lf:=}');
    Expect(1, 10, '\p{Is_WB=lf}', "");
    Expect(0, 10, '\p{^Is_WB=lf}', "");
    Expect(0, 10, '\P{Is_WB=lf}', "");
    Expect(1, 10, '\P{^Is_WB=lf}', "");
    Expect(0, 11, '\p{Is_WB=lf}', "");
    Expect(1, 11, '\p{^Is_WB=lf}', "");
    Expect(1, 11, '\P{Is_WB=lf}', "");
    Expect(0, 11, '\P{^Is_WB=lf}', "");
    Expect(1, 10, '\p{Is_WB=	lf}', "");
    Expect(0, 10, '\p{^Is_WB=	lf}', "");
    Expect(0, 10, '\P{Is_WB=	lf}', "");
    Expect(1, 10, '\P{^Is_WB=	lf}', "");
    Expect(0, 11, '\p{Is_WB=	lf}', "");
    Expect(1, 11, '\p{^Is_WB=	lf}', "");
    Expect(1, 11, '\P{Is_WB=	lf}', "");
    Expect(0, 11, '\P{^Is_WB=	lf}', "");
    Error('\p{Word_Break=_ midnumlet/a/}');
    Error('\P{Word_Break=_ midnumlet/a/}');
    Expect(1, 65294, '\p{Word_Break=:\AMidNumLet\z:}', "");;
    Expect(0, 65295, '\p{Word_Break=:\AMidNumLet\z:}', "");;
    Expect(1, 65294, '\p{Word_Break=midnumlet}', "");
    Expect(0, 65294, '\p{^Word_Break=midnumlet}', "");
    Expect(0, 65294, '\P{Word_Break=midnumlet}', "");
    Expect(1, 65294, '\P{^Word_Break=midnumlet}', "");
    Expect(0, 65295, '\p{Word_Break=midnumlet}', "");
    Expect(1, 65295, '\p{^Word_Break=midnumlet}', "");
    Expect(1, 65295, '\P{Word_Break=midnumlet}', "");
    Expect(0, 65295, '\P{^Word_Break=midnumlet}', "");
    Expect(1, 65294, '\p{Word_Break=:\Amidnumlet\z:}', "");;
    Expect(0, 65295, '\p{Word_Break=:\Amidnumlet\z:}', "");;
    Expect(1, 65294, '\p{Word_Break= MIDNUMLET}', "");
    Expect(0, 65294, '\p{^Word_Break= MIDNUMLET}', "");
    Expect(0, 65294, '\P{Word_Break= MIDNUMLET}', "");
    Expect(1, 65294, '\P{^Word_Break= MIDNUMLET}', "");
    Expect(0, 65295, '\p{Word_Break= MIDNUMLET}', "");
    Expect(1, 65295, '\p{^Word_Break= MIDNUMLET}', "");
    Expect(1, 65295, '\P{Word_Break= MIDNUMLET}', "");
    Expect(0, 65295, '\P{^Word_Break= MIDNUMLET}', "");
    Error('\p{WB=	MB:=}');
    Error('\P{WB=	MB:=}');
    Expect(1, 65294, '\p{WB=:\AMB\z:}', "");;
    Expect(0, 65295, '\p{WB=:\AMB\z:}', "");;
    Expect(1, 65294, '\p{WB=mb}', "");
    Expect(0, 65294, '\p{^WB=mb}', "");
    Expect(0, 65294, '\P{WB=mb}', "");
    Expect(1, 65294, '\P{^WB=mb}', "");
    Expect(0, 65295, '\p{WB=mb}', "");
    Expect(1, 65295, '\p{^WB=mb}', "");
    Expect(1, 65295, '\P{WB=mb}', "");
    Expect(0, 65295, '\P{^WB=mb}', "");
    Expect(1, 65294, '\p{WB=:\Amb\z:}', "");;
    Expect(0, 65295, '\p{WB=:\Amb\z:}', "");;
    Expect(1, 65294, '\p{WB=__MB}', "");
    Expect(0, 65294, '\p{^WB=__MB}', "");
    Expect(0, 65294, '\P{WB=__MB}', "");
    Expect(1, 65294, '\P{^WB=__MB}', "");
    Expect(0, 65295, '\p{WB=__MB}', "");
    Expect(1, 65295, '\p{^WB=__MB}', "");
    Expect(1, 65295, '\P{WB=__MB}', "");
    Expect(0, 65295, '\P{^WB=__MB}', "");
    Error('\p{Is_Word_Break:	:=	 midnumlet}');
    Error('\P{Is_Word_Break:	:=	 midnumlet}');
    Expect(1, 65294, '\p{Is_Word_Break=midnumlet}', "");
    Expect(0, 65294, '\p{^Is_Word_Break=midnumlet}', "");
    Expect(0, 65294, '\P{Is_Word_Break=midnumlet}', "");
    Expect(1, 65294, '\P{^Is_Word_Break=midnumlet}', "");
    Expect(0, 65295, '\p{Is_Word_Break=midnumlet}', "");
    Expect(1, 65295, '\p{^Is_Word_Break=midnumlet}', "");
    Expect(1, 65295, '\P{Is_Word_Break=midnumlet}', "");
    Expect(0, 65295, '\P{^Is_Word_Break=midnumlet}', "");
    Expect(1, 65294, '\p{Is_Word_Break=-MidNumLet}', "");
    Expect(0, 65294, '\p{^Is_Word_Break=-MidNumLet}', "");
    Expect(0, 65294, '\P{Is_Word_Break=-MidNumLet}', "");
    Expect(1, 65294, '\P{^Is_Word_Break=-MidNumLet}', "");
    Expect(0, 65295, '\p{Is_Word_Break=-MidNumLet}', "");
    Expect(1, 65295, '\p{^Is_Word_Break=-MidNumLet}', "");
    Expect(1, 65295, '\P{Is_Word_Break=-MidNumLet}', "");
    Expect(0, 65295, '\P{^Is_Word_Break=-MidNumLet}', "");
    Error('\p{Is_WB:	 /a/MB}');
    Error('\P{Is_WB:	 /a/MB}');
    Expect(1, 65294, '\p{Is_WB: mb}', "");
    Expect(0, 65294, '\p{^Is_WB: mb}', "");
    Expect(0, 65294, '\P{Is_WB: mb}', "");
    Expect(1, 65294, '\P{^Is_WB: mb}', "");
    Expect(0, 65295, '\p{Is_WB: mb}', "");
    Expect(1, 65295, '\p{^Is_WB: mb}', "");
    Expect(1, 65295, '\P{Is_WB: mb}', "");
    Expect(0, 65295, '\P{^Is_WB: mb}', "");
    Expect(1, 65294, '\p{Is_WB=MB}', "");
    Expect(0, 65294, '\p{^Is_WB=MB}', "");
    Expect(0, 65294, '\P{Is_WB=MB}', "");
    Expect(1, 65294, '\P{^Is_WB=MB}', "");
    Expect(0, 65295, '\p{Is_WB=MB}', "");
    Expect(1, 65295, '\p{^Is_WB=MB}', "");
    Expect(1, 65295, '\P{Is_WB=MB}', "");
    Expect(0, 65295, '\P{^Is_WB=MB}', "");
    Error('\p{Word_Break=-MidLetter:=}');
    Error('\P{Word_Break=-MidLetter:=}');
    Expect(1, 65306, '\p{Word_Break=:\AMidLetter\z:}', "");;
    Expect(0, 65307, '\p{Word_Break=:\AMidLetter\z:}', "");;
    Expect(1, 65306, '\p{Word_Break=midletter}', "");
    Expect(0, 65306, '\p{^Word_Break=midletter}', "");
    Expect(0, 65306, '\P{Word_Break=midletter}', "");
    Expect(1, 65306, '\P{^Word_Break=midletter}', "");
    Expect(0, 65307, '\p{Word_Break=midletter}', "");
    Expect(1, 65307, '\p{^Word_Break=midletter}', "");
    Expect(1, 65307, '\P{Word_Break=midletter}', "");
    Expect(0, 65307, '\P{^Word_Break=midletter}', "");
    Expect(1, 65306, '\p{Word_Break=:\Amidletter\z:}', "");;
    Expect(0, 65307, '\p{Word_Break=:\Amidletter\z:}', "");;
    Expect(1, 65306, '\p{Word_Break= -MidLetter}', "");
    Expect(0, 65306, '\p{^Word_Break= -MidLetter}', "");
    Expect(0, 65306, '\P{Word_Break= -MidLetter}', "");
    Expect(1, 65306, '\P{^Word_Break= -MidLetter}', "");
    Expect(0, 65307, '\p{Word_Break= -MidLetter}', "");
    Expect(1, 65307, '\p{^Word_Break= -MidLetter}', "");
    Expect(1, 65307, '\P{Word_Break= -MidLetter}', "");
    Expect(0, 65307, '\P{^Word_Break= -MidLetter}', "");
    Error('\p{WB= /a/ML}');
    Error('\P{WB= /a/ML}');
    Expect(1, 65306, '\p{WB=:\AML\z:}', "");;
    Expect(0, 65307, '\p{WB=:\AML\z:}', "");;
    Expect(1, 65306, '\p{WB:   ml}', "");
    Expect(0, 65306, '\p{^WB:   ml}', "");
    Expect(0, 65306, '\P{WB:   ml}', "");
    Expect(1, 65306, '\P{^WB:   ml}', "");
    Expect(0, 65307, '\p{WB:   ml}', "");
    Expect(1, 65307, '\p{^WB:   ml}', "");
    Expect(1, 65307, '\P{WB:   ml}', "");
    Expect(0, 65307, '\P{^WB:   ml}', "");
    Expect(1, 65306, '\p{WB=:\Aml\z:}', "");;
    Expect(0, 65307, '\p{WB=:\Aml\z:}', "");;
    Expect(1, 65306, '\p{WB=_ML}', "");
    Expect(0, 65306, '\p{^WB=_ML}', "");
    Expect(0, 65306, '\P{WB=_ML}', "");
    Expect(1, 65306, '\P{^WB=_ML}', "");
    Expect(0, 65307, '\p{WB=_ML}', "");
    Expect(1, 65307, '\p{^WB=_ML}', "");
    Expect(1, 65307, '\P{WB=_ML}', "");
    Expect(0, 65307, '\P{^WB=_ML}', "");
    Error('\p{Is_Word_Break::=_midletter}');
    Error('\P{Is_Word_Break::=_midletter}');
    Expect(1, 65306, '\p{Is_Word_Break=midletter}', "");
    Expect(0, 65306, '\p{^Is_Word_Break=midletter}', "");
    Expect(0, 65306, '\P{Is_Word_Break=midletter}', "");
    Expect(1, 65306, '\P{^Is_Word_Break=midletter}', "");
    Expect(0, 65307, '\p{Is_Word_Break=midletter}', "");
    Expect(1, 65307, '\p{^Is_Word_Break=midletter}', "");
    Expect(1, 65307, '\P{Is_Word_Break=midletter}', "");
    Expect(0, 65307, '\P{^Is_Word_Break=midletter}', "");
    Expect(1, 65306, '\p{Is_Word_Break=	MidLetter}', "");
    Expect(0, 65306, '\p{^Is_Word_Break=	MidLetter}', "");
    Expect(0, 65306, '\P{Is_Word_Break=	MidLetter}', "");
    Expect(1, 65306, '\P{^Is_Word_Break=	MidLetter}', "");
    Expect(0, 65307, '\p{Is_Word_Break=	MidLetter}', "");
    Expect(1, 65307, '\p{^Is_Word_Break=	MidLetter}', "");
    Expect(1, 65307, '\P{Is_Word_Break=	MidLetter}', "");
    Expect(0, 65307, '\P{^Is_Word_Break=	MidLetter}', "");
    Error('\p{Is_WB=:=- ML}');
    Error('\P{Is_WB=:=- ML}');
    Expect(1, 65306, '\p{Is_WB:ml}', "");
    Expect(0, 65306, '\p{^Is_WB:ml}', "");
    Expect(0, 65306, '\P{Is_WB:ml}', "");
    Expect(1, 65306, '\P{^Is_WB:ml}', "");
    Expect(0, 65307, '\p{Is_WB:ml}', "");
    Expect(1, 65307, '\p{^Is_WB:ml}', "");
    Expect(1, 65307, '\P{Is_WB:ml}', "");
    Expect(0, 65307, '\P{^Is_WB:ml}', "");
    Expect(1, 65306, '\p{Is_WB=-ML}', "");
    Expect(0, 65306, '\p{^Is_WB=-ML}', "");
    Expect(0, 65306, '\P{Is_WB=-ML}', "");
    Expect(1, 65306, '\P{^Is_WB=-ML}', "");
    Expect(0, 65307, '\p{Is_WB=-ML}', "");
    Expect(1, 65307, '\p{^Is_WB=-ML}', "");
    Expect(1, 65307, '\P{Is_WB=-ML}', "");
    Expect(0, 65307, '\P{^Is_WB=-ML}', "");
    Error('\p{Word_Break=_ midnum:=}');
    Error('\P{Word_Break=_ midnum:=}');
    Expect(1, 65307, '\p{Word_Break=:\AMidNum\z:}', "");;
    Expect(0, 65308, '\p{Word_Break=:\AMidNum\z:}', "");;
    Expect(1, 65307, '\p{Word_Break=midnum}', "");
    Expect(0, 65307, '\p{^Word_Break=midnum}', "");
    Expect(0, 65307, '\P{Word_Break=midnum}', "");
    Expect(1, 65307, '\P{^Word_Break=midnum}', "");
    Expect(0, 65308, '\p{Word_Break=midnum}', "");
    Expect(1, 65308, '\p{^Word_Break=midnum}', "");
    Expect(1, 65308, '\P{Word_Break=midnum}', "");
    Expect(0, 65308, '\P{^Word_Break=midnum}', "");
    Expect(1, 65307, '\p{Word_Break=:\Amidnum\z:}', "");;
    Expect(0, 65308, '\p{Word_Break=:\Amidnum\z:}', "");;
    Expect(1, 65307, '\p{Word_Break=_midnum}', "");
    Expect(0, 65307, '\p{^Word_Break=_midnum}', "");
    Expect(0, 65307, '\P{Word_Break=_midnum}', "");
    Expect(1, 65307, '\P{^Word_Break=_midnum}', "");
    Expect(0, 65308, '\p{Word_Break=_midnum}', "");
    Expect(1, 65308, '\p{^Word_Break=_midnum}', "");
    Expect(1, 65308, '\P{Word_Break=_midnum}', "");
    Expect(0, 65308, '\P{^Word_Break=_midnum}', "");
    Error('\p{WB=/a/	_MN}');
    Error('\P{WB=/a/	_MN}');
    Expect(1, 65307, '\p{WB=:\AMN\z:}', "");;
    Expect(0, 65308, '\p{WB=:\AMN\z:}', "");;
    Expect(1, 65307, '\p{WB=mn}', "");
    Expect(0, 65307, '\p{^WB=mn}', "");
    Expect(0, 65307, '\P{WB=mn}', "");
    Expect(1, 65307, '\P{^WB=mn}', "");
    Expect(0, 65308, '\p{WB=mn}', "");
    Expect(1, 65308, '\p{^WB=mn}', "");
    Expect(1, 65308, '\P{WB=mn}', "");
    Expect(0, 65308, '\P{^WB=mn}', "");
    Expect(1, 65307, '\p{WB=:\Amn\z:}', "");;
    Expect(0, 65308, '\p{WB=:\Amn\z:}', "");;
    Expect(1, 65307, '\p{WB=	mn}', "");
    Expect(0, 65307, '\p{^WB=	mn}', "");
    Expect(0, 65307, '\P{WB=	mn}', "");
    Expect(1, 65307, '\P{^WB=	mn}', "");
    Expect(0, 65308, '\p{WB=	mn}', "");
    Expect(1, 65308, '\p{^WB=	mn}', "");
    Expect(1, 65308, '\P{WB=	mn}', "");
    Expect(0, 65308, '\P{^WB=	mn}', "");
    Error('\p{Is_Word_Break= -midnum:=}');
    Error('\P{Is_Word_Break= -midnum:=}');
    Expect(1, 65307, '\p{Is_Word_Break=midnum}', "");
    Expect(0, 65307, '\p{^Is_Word_Break=midnum}', "");
    Expect(0, 65307, '\P{Is_Word_Break=midnum}', "");
    Expect(1, 65307, '\P{^Is_Word_Break=midnum}', "");
    Expect(0, 65308, '\p{Is_Word_Break=midnum}', "");
    Expect(1, 65308, '\p{^Is_Word_Break=midnum}', "");
    Expect(1, 65308, '\P{Is_Word_Break=midnum}', "");
    Expect(0, 65308, '\P{^Is_Word_Break=midnum}', "");
    Expect(1, 65307, '\p{Is_Word_Break=	-MidNum}', "");
    Expect(0, 65307, '\p{^Is_Word_Break=	-MidNum}', "");
    Expect(0, 65307, '\P{Is_Word_Break=	-MidNum}', "");
    Expect(1, 65307, '\P{^Is_Word_Break=	-MidNum}', "");
    Expect(0, 65308, '\p{Is_Word_Break=	-MidNum}', "");
    Expect(1, 65308, '\p{^Is_Word_Break=	-MidNum}', "");
    Expect(1, 65308, '\P{Is_Word_Break=	-MidNum}', "");
    Expect(0, 65308, '\P{^Is_Word_Break=	-MidNum}', "");
    Error('\p{Is_WB=-/a/MN}');
    Error('\P{Is_WB=-/a/MN}');
    Expect(1, 65307, '\p{Is_WB=mn}', "");
    Expect(0, 65307, '\p{^Is_WB=mn}', "");
    Expect(0, 65307, '\P{Is_WB=mn}', "");
    Expect(1, 65307, '\P{^Is_WB=mn}', "");
    Expect(0, 65308, '\p{Is_WB=mn}', "");
    Expect(1, 65308, '\p{^Is_WB=mn}', "");
    Expect(1, 65308, '\P{Is_WB=mn}', "");
    Expect(0, 65308, '\P{^Is_WB=mn}', "");
    Expect(1, 65307, '\p{Is_WB=  MN}', "");
    Expect(0, 65307, '\p{^Is_WB=  MN}', "");
    Expect(0, 65307, '\P{Is_WB=  MN}', "");
    Expect(1, 65307, '\P{^Is_WB=  MN}', "");
    Expect(0, 65308, '\p{Is_WB=  MN}', "");
    Expect(1, 65308, '\p{^Is_WB=  MN}', "");
    Expect(1, 65308, '\P{Is_WB=  MN}', "");
    Expect(0, 65308, '\P{^Is_WB=  MN}', "");
    Error('\p{Word_Break=:= Newline}');
    Error('\P{Word_Break=:= Newline}');
    Expect(1, 8233, '\p{Word_Break=:\ANewline\z:}', "");;
    Expect(0, 8234, '\p{Word_Break=:\ANewline\z:}', "");;
    Expect(1, 8233, '\p{Word_Break=newline}', "");
    Expect(0, 8233, '\p{^Word_Break=newline}', "");
    Expect(0, 8233, '\P{Word_Break=newline}', "");
    Expect(1, 8233, '\P{^Word_Break=newline}', "");
    Expect(0, 8234, '\p{Word_Break=newline}', "");
    Expect(1, 8234, '\p{^Word_Break=newline}', "");
    Expect(1, 8234, '\P{Word_Break=newline}', "");
    Expect(0, 8234, '\P{^Word_Break=newline}', "");
    Expect(1, 8233, '\p{Word_Break=:\Anewline\z:}', "");;
    Expect(0, 8234, '\p{Word_Break=:\Anewline\z:}', "");;
    Expect(1, 8233, '\p{Word_Break=	Newline}', "");
    Expect(0, 8233, '\p{^Word_Break=	Newline}', "");
    Expect(0, 8233, '\P{Word_Break=	Newline}', "");
    Expect(1, 8233, '\P{^Word_Break=	Newline}', "");
    Expect(0, 8234, '\p{Word_Break=	Newline}', "");
    Expect(1, 8234, '\p{^Word_Break=	Newline}', "");
    Expect(1, 8234, '\P{Word_Break=	Newline}', "");
    Expect(0, 8234, '\P{^Word_Break=	Newline}', "");
    Error('\p{WB=_-NL:=}');
    Error('\P{WB=_-NL:=}');
    Expect(1, 8233, '\p{WB=:\ANL\z:}', "");;
    Expect(0, 8234, '\p{WB=:\ANL\z:}', "");;
    Expect(1, 8233, '\p{WB:	nl}', "");
    Expect(0, 8233, '\p{^WB:	nl}', "");
    Expect(0, 8233, '\P{WB:	nl}', "");
    Expect(1, 8233, '\P{^WB:	nl}', "");
    Expect(0, 8234, '\p{WB:	nl}', "");
    Expect(1, 8234, '\p{^WB:	nl}', "");
    Expect(1, 8234, '\P{WB:	nl}', "");
    Expect(0, 8234, '\P{^WB:	nl}', "");
    Expect(1, 8233, '\p{WB=:\Anl\z:}', "");;
    Expect(0, 8234, '\p{WB=:\Anl\z:}', "");;
    Expect(1, 8233, '\p{WB= -NL}', "");
    Expect(0, 8233, '\p{^WB= -NL}', "");
    Expect(0, 8233, '\P{WB= -NL}', "");
    Expect(1, 8233, '\P{^WB= -NL}', "");
    Expect(0, 8234, '\p{WB= -NL}', "");
    Expect(1, 8234, '\p{^WB= -NL}', "");
    Expect(1, 8234, '\P{WB= -NL}', "");
    Expect(0, 8234, '\P{^WB= -NL}', "");
    Error('\p{Is_Word_Break:/a/	_Newline}');
    Error('\P{Is_Word_Break:/a/	_Newline}');
    Expect(1, 8233, '\p{Is_Word_Break=newline}', "");
    Expect(0, 8233, '\p{^Is_Word_Break=newline}', "");
    Expect(0, 8233, '\P{Is_Word_Break=newline}', "");
    Expect(1, 8233, '\P{^Is_Word_Break=newline}', "");
    Expect(0, 8234, '\p{Is_Word_Break=newline}', "");
    Expect(1, 8234, '\p{^Is_Word_Break=newline}', "");
    Expect(1, 8234, '\P{Is_Word_Break=newline}', "");
    Expect(0, 8234, '\P{^Is_Word_Break=newline}', "");
    Expect(1, 8233, '\p{Is_Word_Break=		Newline}', "");
    Expect(0, 8233, '\p{^Is_Word_Break=		Newline}', "");
    Expect(0, 8233, '\P{Is_Word_Break=		Newline}', "");
    Expect(1, 8233, '\P{^Is_Word_Break=		Newline}', "");
    Expect(0, 8234, '\p{Is_Word_Break=		Newline}', "");
    Expect(1, 8234, '\p{^Is_Word_Break=		Newline}', "");
    Expect(1, 8234, '\P{Is_Word_Break=		Newline}', "");
    Expect(0, 8234, '\P{^Is_Word_Break=		Newline}', "");
    Error('\p{Is_WB=-:=NL}');
    Error('\P{Is_WB=-:=NL}');
    Expect(1, 8233, '\p{Is_WB=nl}', "");
    Expect(0, 8233, '\p{^Is_WB=nl}', "");
    Expect(0, 8233, '\P{Is_WB=nl}', "");
    Expect(1, 8233, '\P{^Is_WB=nl}', "");
    Expect(0, 8234, '\p{Is_WB=nl}', "");
    Expect(1, 8234, '\p{^Is_WB=nl}', "");
    Expect(1, 8234, '\P{Is_WB=nl}', "");
    Expect(0, 8234, '\P{^Is_WB=nl}', "");
    Expect(1, 8233, '\p{Is_WB=_nl}', "");
    Expect(0, 8233, '\p{^Is_WB=_nl}', "");
    Expect(0, 8233, '\P{Is_WB=_nl}', "");
    Expect(1, 8233, '\P{^Is_WB=_nl}', "");
    Expect(0, 8234, '\p{Is_WB=_nl}', "");
    Expect(1, 8234, '\p{^Is_WB=_nl}', "");
    Expect(1, 8234, '\P{Is_WB=_nl}', "");
    Expect(0, 8234, '\P{^Is_WB=_nl}', "");
    Error('\p{Word_Break=/a/Numeric}');
    Error('\P{Word_Break=/a/Numeric}');
    Expect(1, 130041, '\p{Word_Break=:\ANumeric\z:}', "");;
    Expect(0, 130042, '\p{Word_Break=:\ANumeric\z:}', "");;
    Expect(1, 130041, '\p{Word_Break=numeric}', "");
    Expect(0, 130041, '\p{^Word_Break=numeric}', "");
    Expect(0, 130041, '\P{Word_Break=numeric}', "");
    Expect(1, 130041, '\P{^Word_Break=numeric}', "");
    Expect(0, 130042, '\p{Word_Break=numeric}', "");
    Expect(1, 130042, '\p{^Word_Break=numeric}', "");
    Expect(1, 130042, '\P{Word_Break=numeric}', "");
    Expect(0, 130042, '\P{^Word_Break=numeric}', "");
    Expect(1, 130041, '\p{Word_Break=:\Anumeric\z:}', "");;
    Expect(0, 130042, '\p{Word_Break=:\Anumeric\z:}', "");;
    Expect(1, 130041, '\p{Word_Break=-Numeric}', "");
    Expect(0, 130041, '\p{^Word_Break=-Numeric}', "");
    Expect(0, 130041, '\P{Word_Break=-Numeric}', "");
    Expect(1, 130041, '\P{^Word_Break=-Numeric}', "");
    Expect(0, 130042, '\p{Word_Break=-Numeric}', "");
    Expect(1, 130042, '\p{^Word_Break=-Numeric}', "");
    Expect(1, 130042, '\P{Word_Break=-Numeric}', "");
    Expect(0, 130042, '\P{^Word_Break=-Numeric}', "");
    Error('\p{WB=__nu/a/}');
    Error('\P{WB=__nu/a/}');
    Expect(1, 130041, '\p{WB=:\ANU\z:}', "");;
    Expect(0, 130042, '\p{WB=:\ANU\z:}', "");;
    Expect(1, 130041, '\p{WB=nu}', "");
    Expect(0, 130041, '\p{^WB=nu}', "");
    Expect(0, 130041, '\P{WB=nu}', "");
    Expect(1, 130041, '\P{^WB=nu}', "");
    Expect(0, 130042, '\p{WB=nu}', "");
    Expect(1, 130042, '\p{^WB=nu}', "");
    Expect(1, 130042, '\P{WB=nu}', "");
    Expect(0, 130042, '\P{^WB=nu}', "");
    Expect(1, 130041, '\p{WB=:\Anu\z:}', "");;
    Expect(0, 130042, '\p{WB=:\Anu\z:}', "");;
    Expect(1, 130041, '\p{WB=		NU}', "");
    Expect(0, 130041, '\p{^WB=		NU}', "");
    Expect(0, 130041, '\P{WB=		NU}', "");
    Expect(1, 130041, '\P{^WB=		NU}', "");
    Expect(0, 130042, '\p{WB=		NU}', "");
    Expect(1, 130042, '\p{^WB=		NU}', "");
    Expect(1, 130042, '\P{WB=		NU}', "");
    Expect(0, 130042, '\P{^WB=		NU}', "");
    Error('\p{Is_Word_Break=:=Numeric}');
    Error('\P{Is_Word_Break=:=Numeric}');
    Expect(1, 130041, '\p{Is_Word_Break=numeric}', "");
    Expect(0, 130041, '\p{^Is_Word_Break=numeric}', "");
    Expect(0, 130041, '\P{Is_Word_Break=numeric}', "");
    Expect(1, 130041, '\P{^Is_Word_Break=numeric}', "");
    Expect(0, 130042, '\p{Is_Word_Break=numeric}', "");
    Expect(1, 130042, '\p{^Is_Word_Break=numeric}', "");
    Expect(1, 130042, '\P{Is_Word_Break=numeric}', "");
    Expect(0, 130042, '\P{^Is_Word_Break=numeric}', "");
    Expect(1, 130041, '\p{Is_Word_Break=_ Numeric}', "");
    Expect(0, 130041, '\p{^Is_Word_Break=_ Numeric}', "");
    Expect(0, 130041, '\P{Is_Word_Break=_ Numeric}', "");
    Expect(1, 130041, '\P{^Is_Word_Break=_ Numeric}', "");
    Expect(0, 130042, '\p{Is_Word_Break=_ Numeric}', "");
    Expect(1, 130042, '\p{^Is_Word_Break=_ Numeric}', "");
    Expect(1, 130042, '\P{Is_Word_Break=_ Numeric}', "");
    Expect(0, 130042, '\P{^Is_Word_Break=_ Numeric}', "");
    Error('\p{Is_WB:	_-nu:=}');
    Error('\P{Is_WB:	_-nu:=}');
    Expect(1, 130041, '\p{Is_WB=nu}', "");
    Expect(0, 130041, '\p{^Is_WB=nu}', "");
    Expect(0, 130041, '\P{Is_WB=nu}', "");
    Expect(1, 130041, '\P{^Is_WB=nu}', "");
    Expect(0, 130042, '\p{Is_WB=nu}', "");
    Expect(1, 130042, '\p{^Is_WB=nu}', "");
    Expect(1, 130042, '\P{Is_WB=nu}', "");
    Expect(0, 130042, '\P{^Is_WB=nu}', "");
    Expect(1, 130041, '\p{Is_WB:   _ NU}', "");
    Expect(0, 130041, '\p{^Is_WB:   _ NU}', "");
    Expect(0, 130041, '\P{Is_WB:   _ NU}', "");
    Expect(1, 130041, '\P{^Is_WB:   _ NU}', "");
    Expect(0, 130042, '\p{Is_WB:   _ NU}', "");
    Expect(1, 130042, '\p{^Is_WB:   _ NU}', "");
    Expect(1, 130042, '\P{Is_WB:   _ NU}', "");
    Expect(0, 130042, '\P{^Is_WB:   _ NU}', "");
    Error('\p{Word_Break: /a/-Regional_Indicator}');
    Error('\P{Word_Break: /a/-Regional_Indicator}');
    Expect(1, 127487, '\p{Word_Break=:\ARegional_Indicator\z:}', "");;
    Expect(0, 127488, '\p{Word_Break=:\ARegional_Indicator\z:}', "");;
    Expect(1, 127487, '\p{Word_Break=regionalindicator}', "");
    Expect(0, 127487, '\p{^Word_Break=regionalindicator}', "");
    Expect(0, 127487, '\P{Word_Break=regionalindicator}', "");
    Expect(1, 127487, '\P{^Word_Break=regionalindicator}', "");
    Expect(0, 127488, '\p{Word_Break=regionalindicator}', "");
    Expect(1, 127488, '\p{^Word_Break=regionalindicator}', "");
    Expect(1, 127488, '\P{Word_Break=regionalindicator}', "");
    Expect(0, 127488, '\P{^Word_Break=regionalindicator}', "");
    Expect(1, 127487, '\p{Word_Break=:\Aregionalindicator\z:}', "");;
    Expect(0, 127488, '\p{Word_Break=:\Aregionalindicator\z:}', "");;
    Expect(1, 127487, '\p{Word_Break=_regional_Indicator}', "");
    Expect(0, 127487, '\p{^Word_Break=_regional_Indicator}', "");
    Expect(0, 127487, '\P{Word_Break=_regional_Indicator}', "");
    Expect(1, 127487, '\P{^Word_Break=_regional_Indicator}', "");
    Expect(0, 127488, '\p{Word_Break=_regional_Indicator}', "");
    Expect(1, 127488, '\p{^Word_Break=_regional_Indicator}', "");
    Expect(1, 127488, '\P{Word_Break=_regional_Indicator}', "");
    Expect(0, 127488, '\P{^Word_Break=_regional_Indicator}', "");
    Error('\p{WB=/a/ri}');
    Error('\P{WB=/a/ri}');
    Expect(1, 127487, '\p{WB=:\ARI\z:}', "");;
    Expect(0, 127488, '\p{WB=:\ARI\z:}', "");;
    Expect(1, 127487, '\p{WB=ri}', "");
    Expect(0, 127487, '\p{^WB=ri}', "");
    Expect(0, 127487, '\P{WB=ri}', "");
    Expect(1, 127487, '\P{^WB=ri}', "");
    Expect(0, 127488, '\p{WB=ri}', "");
    Expect(1, 127488, '\p{^WB=ri}', "");
    Expect(1, 127488, '\P{WB=ri}', "");
    Expect(0, 127488, '\P{^WB=ri}', "");
    Expect(1, 127487, '\p{WB=:\Ari\z:}', "");;
    Expect(0, 127488, '\p{WB=:\Ari\z:}', "");;
    Expect(1, 127487, '\p{WB=	-RI}', "");
    Expect(0, 127487, '\p{^WB=	-RI}', "");
    Expect(0, 127487, '\P{WB=	-RI}', "");
    Expect(1, 127487, '\P{^WB=	-RI}', "");
    Expect(0, 127488, '\p{WB=	-RI}', "");
    Expect(1, 127488, '\p{^WB=	-RI}', "");
    Expect(1, 127488, '\P{WB=	-RI}', "");
    Expect(0, 127488, '\P{^WB=	-RI}', "");
    Error('\p{Is_Word_Break=	REGIONAL_INDICATOR/a/}');
    Error('\P{Is_Word_Break=	REGIONAL_INDICATOR/a/}');
    Expect(1, 127487, '\p{Is_Word_Break=regionalindicator}', "");
    Expect(0, 127487, '\p{^Is_Word_Break=regionalindicator}', "");
    Expect(0, 127487, '\P{Is_Word_Break=regionalindicator}', "");
    Expect(1, 127487, '\P{^Is_Word_Break=regionalindicator}', "");
    Expect(0, 127488, '\p{Is_Word_Break=regionalindicator}', "");
    Expect(1, 127488, '\p{^Is_Word_Break=regionalindicator}', "");
    Expect(1, 127488, '\P{Is_Word_Break=regionalindicator}', "");
    Expect(0, 127488, '\P{^Is_Word_Break=regionalindicator}', "");
    Expect(1, 127487, '\p{Is_Word_Break=	Regional_Indicator}', "");
    Expect(0, 127487, '\p{^Is_Word_Break=	Regional_Indicator}', "");
    Expect(0, 127487, '\P{Is_Word_Break=	Regional_Indicator}', "");
    Expect(1, 127487, '\P{^Is_Word_Break=	Regional_Indicator}', "");
    Expect(0, 127488, '\p{Is_Word_Break=	Regional_Indicator}', "");
    Expect(1, 127488, '\p{^Is_Word_Break=	Regional_Indicator}', "");
    Expect(1, 127488, '\P{Is_Word_Break=	Regional_Indicator}', "");
    Expect(0, 127488, '\P{^Is_Word_Break=	Regional_Indicator}', "");
    Error('\p{Is_WB:   	 RI:=}');
    Error('\P{Is_WB:   	 RI:=}');
    Expect(1, 127487, '\p{Is_WB=ri}', "");
    Expect(0, 127487, '\p{^Is_WB=ri}', "");
    Expect(0, 127487, '\P{Is_WB=ri}', "");
    Expect(1, 127487, '\P{^Is_WB=ri}', "");
    Expect(0, 127488, '\p{Is_WB=ri}', "");
    Expect(1, 127488, '\p{^Is_WB=ri}', "");
    Expect(1, 127488, '\P{Is_WB=ri}', "");
    Expect(0, 127488, '\P{^Is_WB=ri}', "");
    Expect(1, 127487, '\p{Is_WB=	ri}', "");
    Expect(0, 127487, '\p{^Is_WB=	ri}', "");
    Expect(0, 127487, '\P{Is_WB=	ri}', "");
    Expect(1, 127487, '\P{^Is_WB=	ri}', "");
    Expect(0, 127488, '\p{Is_WB=	ri}', "");
    Expect(1, 127488, '\p{^Is_WB=	ri}', "");
    Expect(1, 127488, '\P{Is_WB=	ri}', "");
    Expect(0, 127488, '\P{^Is_WB=	ri}', "");
    Error('\p{Word_Break=_:=SINGLE_QUOTE}');
    Error('\P{Word_Break=_:=SINGLE_QUOTE}');
    Expect(1, 39, '\p{Word_Break=:\ASingle_Quote\z:}', "");;
    Expect(0, 40, '\p{Word_Break=:\ASingle_Quote\z:}', "");;
    Expect(1, 39, '\p{Word_Break=singlequote}', "");
    Expect(0, 39, '\p{^Word_Break=singlequote}', "");
    Expect(0, 39, '\P{Word_Break=singlequote}', "");
    Expect(1, 39, '\P{^Word_Break=singlequote}', "");
    Expect(0, 40, '\p{Word_Break=singlequote}', "");
    Expect(1, 40, '\p{^Word_Break=singlequote}', "");
    Expect(1, 40, '\P{Word_Break=singlequote}', "");
    Expect(0, 40, '\P{^Word_Break=singlequote}', "");
    Expect(1, 39, '\p{Word_Break=:\Asinglequote\z:}', "");;
    Expect(0, 40, '\p{Word_Break=:\Asinglequote\z:}', "");;
    Expect(1, 39, '\p{Word_Break=__Single_Quote}', "");
    Expect(0, 39, '\p{^Word_Break=__Single_Quote}', "");
    Expect(0, 39, '\P{Word_Break=__Single_Quote}', "");
    Expect(1, 39, '\P{^Word_Break=__Single_Quote}', "");
    Expect(0, 40, '\p{Word_Break=__Single_Quote}', "");
    Expect(1, 40, '\p{^Word_Break=__Single_Quote}', "");
    Expect(1, 40, '\P{Word_Break=__Single_Quote}', "");
    Expect(0, 40, '\P{^Word_Break=__Single_Quote}', "");
    Error('\p{WB=	sq/a/}');
    Error('\P{WB=	sq/a/}');
    Expect(1, 39, '\p{WB=:\ASQ\z:}', "");;
    Expect(0, 40, '\p{WB=:\ASQ\z:}', "");;
    Expect(1, 39, '\p{WB=sq}', "");
    Expect(0, 39, '\p{^WB=sq}', "");
    Expect(0, 39, '\P{WB=sq}', "");
    Expect(1, 39, '\P{^WB=sq}', "");
    Expect(0, 40, '\p{WB=sq}', "");
    Expect(1, 40, '\p{^WB=sq}', "");
    Expect(1, 40, '\P{WB=sq}', "");
    Expect(0, 40, '\P{^WB=sq}', "");
    Expect(1, 39, '\p{WB=:\Asq\z:}', "");;
    Expect(0, 40, '\p{WB=:\Asq\z:}', "");;
    Expect(1, 39, '\p{WB= sq}', "");
    Expect(0, 39, '\p{^WB= sq}', "");
    Expect(0, 39, '\P{WB= sq}', "");
    Expect(1, 39, '\P{^WB= sq}', "");
    Expect(0, 40, '\p{WB= sq}', "");
    Expect(1, 40, '\p{^WB= sq}', "");
    Expect(1, 40, '\P{WB= sq}', "");
    Expect(0, 40, '\P{^WB= sq}', "");
    Error('\p{Is_Word_Break=:=Single_Quote}');
    Error('\P{Is_Word_Break=:=Single_Quote}');
    Expect(1, 39, '\p{Is_Word_Break=singlequote}', "");
    Expect(0, 39, '\p{^Is_Word_Break=singlequote}', "");
    Expect(0, 39, '\P{Is_Word_Break=singlequote}', "");
    Expect(1, 39, '\P{^Is_Word_Break=singlequote}', "");
    Expect(0, 40, '\p{Is_Word_Break=singlequote}', "");
    Expect(1, 40, '\p{^Is_Word_Break=singlequote}', "");
    Expect(1, 40, '\P{Is_Word_Break=singlequote}', "");
    Expect(0, 40, '\P{^Is_Word_Break=singlequote}', "");
    Expect(1, 39, '\p{Is_Word_Break=-_SINGLE_Quote}', "");
    Expect(0, 39, '\p{^Is_Word_Break=-_SINGLE_Quote}', "");
    Expect(0, 39, '\P{Is_Word_Break=-_SINGLE_Quote}', "");
    Expect(1, 39, '\P{^Is_Word_Break=-_SINGLE_Quote}', "");
    Expect(0, 40, '\p{Is_Word_Break=-_SINGLE_Quote}', "");
    Expect(1, 40, '\p{^Is_Word_Break=-_SINGLE_Quote}', "");
    Expect(1, 40, '\P{Is_Word_Break=-_SINGLE_Quote}', "");
    Expect(0, 40, '\P{^Is_Word_Break=-_SINGLE_Quote}', "");
    Error('\p{Is_WB= SQ:=}');
    Error('\P{Is_WB= SQ:=}');
    Expect(1, 39, '\p{Is_WB=sq}', "");
    Expect(0, 39, '\p{^Is_WB=sq}', "");
    Expect(0, 39, '\P{Is_WB=sq}', "");
    Expect(1, 39, '\P{^Is_WB=sq}', "");
    Expect(0, 40, '\p{Is_WB=sq}', "");
    Expect(1, 40, '\p{^Is_WB=sq}', "");
    Expect(1, 40, '\P{Is_WB=sq}', "");
    Expect(0, 40, '\P{^Is_WB=sq}', "");
    Expect(1, 39, '\p{Is_WB=	-SQ}', "");
    Expect(0, 39, '\p{^Is_WB=	-SQ}', "");
    Expect(0, 39, '\P{Is_WB=	-SQ}', "");
    Expect(1, 39, '\P{^Is_WB=	-SQ}', "");
    Expect(0, 40, '\p{Is_WB=	-SQ}', "");
    Expect(1, 40, '\p{^Is_WB=	-SQ}', "");
    Expect(1, 40, '\P{Is_WB=	-SQ}', "");
    Expect(0, 40, '\P{^Is_WB=	-SQ}', "");
    Error('\p{Word_Break:   /a/WSegSpace}');
    Error('\P{Word_Break:   /a/WSegSpace}');
    Expect(1, 12288, '\p{Word_Break=:\AWSegSpace\z:}', "");;
    Expect(0, 12289, '\p{Word_Break=:\AWSegSpace\z:}', "");;
    Expect(1, 12288, '\p{Word_Break=wsegspace}', "");
    Expect(0, 12288, '\p{^Word_Break=wsegspace}', "");
    Expect(0, 12288, '\P{Word_Break=wsegspace}', "");
    Expect(1, 12288, '\P{^Word_Break=wsegspace}', "");
    Expect(0, 12289, '\p{Word_Break=wsegspace}', "");
    Expect(1, 12289, '\p{^Word_Break=wsegspace}', "");
    Expect(1, 12289, '\P{Word_Break=wsegspace}', "");
    Expect(0, 12289, '\P{^Word_Break=wsegspace}', "");
    Expect(1, 12288, '\p{Word_Break=:\Awsegspace\z:}', "");;
    Expect(0, 12289, '\p{Word_Break=:\Awsegspace\z:}', "");;
    Expect(1, 12288, '\p{Word_Break=--WSEGSPACE}', "");
    Expect(0, 12288, '\p{^Word_Break=--WSEGSPACE}', "");
    Expect(0, 12288, '\P{Word_Break=--WSEGSPACE}', "");
    Expect(1, 12288, '\P{^Word_Break=--WSEGSPACE}', "");
    Expect(0, 12289, '\p{Word_Break=--WSEGSPACE}', "");
    Expect(1, 12289, '\p{^Word_Break=--WSEGSPACE}', "");
    Expect(1, 12289, '\P{Word_Break=--WSEGSPACE}', "");
    Expect(0, 12289, '\P{^Word_Break=--WSEGSPACE}', "");
    Error('\p{WB=	/a/wsegspace}');
    Error('\P{WB=	/a/wsegspace}');
    Expect(1, 12288, '\p{WB=:\AWSegSpace\z:}', "");;
    Expect(0, 12289, '\p{WB=:\AWSegSpace\z:}', "");;
    Expect(1, 12288, '\p{WB=wsegspace}', "");
    Expect(0, 12288, '\p{^WB=wsegspace}', "");
    Expect(0, 12288, '\P{WB=wsegspace}', "");
    Expect(1, 12288, '\P{^WB=wsegspace}', "");
    Expect(0, 12289, '\p{WB=wsegspace}', "");
    Expect(1, 12289, '\p{^WB=wsegspace}', "");
    Expect(1, 12289, '\P{WB=wsegspace}', "");
    Expect(0, 12289, '\P{^WB=wsegspace}', "");
    Expect(1, 12288, '\p{WB=:\Awsegspace\z:}', "");;
    Expect(0, 12289, '\p{WB=:\Awsegspace\z:}', "");;
    Expect(1, 12288, '\p{WB=  wsegspace}', "");
    Expect(0, 12288, '\p{^WB=  wsegspace}', "");
    Expect(0, 12288, '\P{WB=  wsegspace}', "");
    Expect(1, 12288, '\P{^WB=  wsegspace}', "");
    Expect(0, 12289, '\p{WB=  wsegspace}', "");
    Expect(1, 12289, '\p{^WB=  wsegspace}', "");
    Expect(1, 12289, '\P{WB=  wsegspace}', "");
    Expect(0, 12289, '\P{^WB=  wsegspace}', "");
    Error('\p{Is_Word_Break:   	WSEGSPACE:=}');
    Error('\P{Is_Word_Break:   	WSEGSPACE:=}');
    Expect(1, 12288, '\p{Is_Word_Break:	wsegspace}', "");
    Expect(0, 12288, '\p{^Is_Word_Break:	wsegspace}', "");
    Expect(0, 12288, '\P{Is_Word_Break:	wsegspace}', "");
    Expect(1, 12288, '\P{^Is_Word_Break:	wsegspace}', "");
    Expect(0, 12289, '\p{Is_Word_Break:	wsegspace}', "");
    Expect(1, 12289, '\p{^Is_Word_Break:	wsegspace}', "");
    Expect(1, 12289, '\P{Is_Word_Break:	wsegspace}', "");
    Expect(0, 12289, '\P{^Is_Word_Break:	wsegspace}', "");
    Expect(1, 12288, '\p{Is_Word_Break:    WSEGSPACE}', "");
    Expect(0, 12288, '\p{^Is_Word_Break:    WSEGSPACE}', "");
    Expect(0, 12288, '\P{Is_Word_Break:    WSEGSPACE}', "");
    Expect(1, 12288, '\P{^Is_Word_Break:    WSEGSPACE}', "");
    Expect(0, 12289, '\p{Is_Word_Break:    WSEGSPACE}', "");
    Expect(1, 12289, '\p{^Is_Word_Break:    WSEGSPACE}', "");
    Expect(1, 12289, '\P{Is_Word_Break:    WSEGSPACE}', "");
    Expect(0, 12289, '\P{^Is_Word_Break:    WSEGSPACE}', "");
    Error('\p{Is_WB=/a/	_WSEGSPACE}');
    Error('\P{Is_WB=/a/	_WSEGSPACE}');
    Expect(1, 12288, '\p{Is_WB=wsegspace}', "");
    Expect(0, 12288, '\p{^Is_WB=wsegspace}', "");
    Expect(0, 12288, '\P{Is_WB=wsegspace}', "");
    Expect(1, 12288, '\P{^Is_WB=wsegspace}', "");
    Expect(0, 12289, '\p{Is_WB=wsegspace}', "");
    Expect(1, 12289, '\p{^Is_WB=wsegspace}', "");
    Expect(1, 12289, '\P{Is_WB=wsegspace}', "");
    Expect(0, 12289, '\P{^Is_WB=wsegspace}', "");
    Expect(1, 12288, '\p{Is_WB:   _WSegSpace}', "");
    Expect(0, 12288, '\p{^Is_WB:   _WSegSpace}', "");
    Expect(0, 12288, '\P{Is_WB:   _WSegSpace}', "");
    Expect(1, 12288, '\P{^Is_WB:   _WSegSpace}', "");
    Expect(0, 12289, '\p{Is_WB:   _WSegSpace}', "");
    Expect(1, 12289, '\p{^Is_WB:   _WSegSpace}', "");
    Expect(1, 12289, '\P{Is_WB:   _WSegSpace}', "");
    Expect(0, 12289, '\P{^Is_WB:   _WSegSpace}', "");
    Error('\p{Word_Break:    other/a/}');
    Error('\P{Word_Break:    other/a/}');
    Expect(1, 918000, '\p{Word_Break=:\AOther\z:}', "");;
    Expect(0, 917999, '\p{Word_Break=:\AOther\z:}', "");;
    Expect(1, 918000, '\p{Word_Break:   other}', "");
    Expect(0, 918000, '\p{^Word_Break:   other}', "");
    Expect(0, 918000, '\P{Word_Break:   other}', "");
    Expect(1, 918000, '\P{^Word_Break:   other}', "");
    Expect(0, 917999, '\p{Word_Break:   other}', "");
    Expect(1, 917999, '\p{^Word_Break:   other}', "");
    Expect(1, 917999, '\P{Word_Break:   other}', "");
    Expect(0, 917999, '\P{^Word_Break:   other}', "");
    Expect(1, 918000, '\p{Word_Break=:\Aother\z:}', "");;
    Expect(0, 917999, '\p{Word_Break=:\Aother\z:}', "");;
    Expect(1, 918000, '\p{Word_Break=-_OTHER}', "");
    Expect(0, 918000, '\p{^Word_Break=-_OTHER}', "");
    Expect(0, 918000, '\P{Word_Break=-_OTHER}', "");
    Expect(1, 918000, '\P{^Word_Break=-_OTHER}', "");
    Expect(0, 917999, '\p{Word_Break=-_OTHER}', "");
    Expect(1, 917999, '\p{^Word_Break=-_OTHER}', "");
    Expect(1, 917999, '\P{Word_Break=-_OTHER}', "");
    Expect(0, 917999, '\P{^Word_Break=-_OTHER}', "");
    Error('\p{WB= XX/a/}');
    Error('\P{WB= XX/a/}');
    Expect(1, 918000, '\p{WB=:\AXX\z:}', "");;
    Expect(0, 917999, '\p{WB=:\AXX\z:}', "");;
    Expect(1, 918000, '\p{WB=xx}', "");
    Expect(0, 918000, '\p{^WB=xx}', "");
    Expect(0, 918000, '\P{WB=xx}', "");
    Expect(1, 918000, '\P{^WB=xx}', "");
    Expect(0, 917999, '\p{WB=xx}', "");
    Expect(1, 917999, '\p{^WB=xx}', "");
    Expect(1, 917999, '\P{WB=xx}', "");
    Expect(0, 917999, '\P{^WB=xx}', "");
    Expect(1, 918000, '\p{WB=:\Axx\z:}', "");;
    Expect(0, 917999, '\p{WB=:\Axx\z:}', "");;
    Expect(1, 918000, '\p{WB=_XX}', "");
    Expect(0, 918000, '\p{^WB=_XX}', "");
    Expect(0, 918000, '\P{WB=_XX}', "");
    Expect(1, 918000, '\P{^WB=_XX}', "");
    Expect(0, 917999, '\p{WB=_XX}', "");
    Expect(1, 917999, '\p{^WB=_XX}', "");
    Expect(1, 917999, '\P{WB=_XX}', "");
    Expect(0, 917999, '\P{^WB=_XX}', "");
    Error('\p{Is_Word_Break=:=_ OTHER}');
    Error('\P{Is_Word_Break=:=_ OTHER}');
    Expect(1, 918000, '\p{Is_Word_Break=other}', "");
    Expect(0, 918000, '\p{^Is_Word_Break=other}', "");
    Expect(0, 918000, '\P{Is_Word_Break=other}', "");
    Expect(1, 918000, '\P{^Is_Word_Break=other}', "");
    Expect(0, 917999, '\p{Is_Word_Break=other}', "");
    Expect(1, 917999, '\p{^Is_Word_Break=other}', "");
    Expect(1, 917999, '\P{Is_Word_Break=other}', "");
    Expect(0, 917999, '\P{^Is_Word_Break=other}', "");
    Expect(1, 918000, '\p{Is_Word_Break=-OTHER}', "");
    Expect(0, 918000, '\p{^Is_Word_Break=-OTHER}', "");
    Expect(0, 918000, '\P{Is_Word_Break=-OTHER}', "");
    Expect(1, 918000, '\P{^Is_Word_Break=-OTHER}', "");
    Expect(0, 917999, '\p{Is_Word_Break=-OTHER}', "");
    Expect(1, 917999, '\p{^Is_Word_Break=-OTHER}', "");
    Expect(1, 917999, '\P{Is_Word_Break=-OTHER}', "");
    Expect(0, 917999, '\P{^Is_Word_Break=-OTHER}', "");
    Error('\p{Is_WB= 	XX/a/}');
    Error('\P{Is_WB= 	XX/a/}');
    Expect(1, 918000, '\p{Is_WB: xx}', "");
    Expect(0, 918000, '\p{^Is_WB: xx}', "");
    Expect(0, 918000, '\P{Is_WB: xx}', "");
    Expect(1, 918000, '\P{^Is_WB: xx}', "");
    Expect(0, 917999, '\p{Is_WB: xx}', "");
    Expect(1, 917999, '\p{^Is_WB: xx}', "");
    Expect(1, 917999, '\P{Is_WB: xx}', "");
    Expect(0, 917999, '\P{^Is_WB: xx}', "");
    Expect(1, 918000, '\p{Is_WB=_	xx}', "");
    Expect(0, 918000, '\p{^Is_WB=_	xx}', "");
    Expect(0, 918000, '\P{Is_WB=_	xx}', "");
    Expect(1, 918000, '\P{^Is_WB=_	xx}', "");
    Expect(0, 917999, '\p{Is_WB=_	xx}', "");
    Expect(1, 917999, '\p{^Is_WB=_	xx}', "");
    Expect(1, 917999, '\P{Is_WB=_	xx}', "");
    Expect(0, 917999, '\P{^Is_WB=_	xx}', "");
    Error('\p{Word_Break=	/a/ZWJ}');
    Error('\P{Word_Break=	/a/ZWJ}');
    Expect(1, 8205, '\p{Word_Break=:\AZWJ\z:}', "");;
    Expect(0, 8206, '\p{Word_Break=:\AZWJ\z:}', "");;
    Expect(1, 8205, '\p{Word_Break=zwj}', "");
    Expect(0, 8205, '\p{^Word_Break=zwj}', "");
    Expect(0, 8205, '\P{Word_Break=zwj}', "");
    Expect(1, 8205, '\P{^Word_Break=zwj}', "");
    Expect(0, 8206, '\p{Word_Break=zwj}', "");
    Expect(1, 8206, '\p{^Word_Break=zwj}', "");
    Expect(1, 8206, '\P{Word_Break=zwj}', "");
    Expect(0, 8206, '\P{^Word_Break=zwj}', "");
    Expect(1, 8205, '\p{Word_Break=:\Azwj\z:}', "");;
    Expect(0, 8206, '\p{Word_Break=:\Azwj\z:}', "");;
    Expect(1, 8205, '\p{Word_Break=_ ZWJ}', "");
    Expect(0, 8205, '\p{^Word_Break=_ ZWJ}', "");
    Expect(0, 8205, '\P{Word_Break=_ ZWJ}', "");
    Expect(1, 8205, '\P{^Word_Break=_ ZWJ}', "");
    Expect(0, 8206, '\p{Word_Break=_ ZWJ}', "");
    Expect(1, 8206, '\p{^Word_Break=_ ZWJ}', "");
    Expect(1, 8206, '\P{Word_Break=_ ZWJ}', "");
    Expect(0, 8206, '\P{^Word_Break=_ ZWJ}', "");
    Error('\p{WB=	:=zwj}');
    Error('\P{WB=	:=zwj}');
    Expect(1, 8205, '\p{WB=:\AZWJ\z:}', "");;
    Expect(0, 8206, '\p{WB=:\AZWJ\z:}', "");;
    Expect(1, 8205, '\p{WB=zwj}', "");
    Expect(0, 8205, '\p{^WB=zwj}', "");
    Expect(0, 8205, '\P{WB=zwj}', "");
    Expect(1, 8205, '\P{^WB=zwj}', "");
    Expect(0, 8206, '\p{WB=zwj}', "");
    Expect(1, 8206, '\p{^WB=zwj}', "");
    Expect(1, 8206, '\P{WB=zwj}', "");
    Expect(0, 8206, '\P{^WB=zwj}', "");
    Expect(1, 8205, '\p{WB=:\Azwj\z:}', "");;
    Expect(0, 8206, '\p{WB=:\Azwj\z:}', "");;
    Expect(1, 8205, '\p{WB=	 ZWJ}', "");
    Expect(0, 8205, '\p{^WB=	 ZWJ}', "");
    Expect(0, 8205, '\P{WB=	 ZWJ}', "");
    Expect(1, 8205, '\P{^WB=	 ZWJ}', "");
    Expect(0, 8206, '\p{WB=	 ZWJ}', "");
    Expect(1, 8206, '\p{^WB=	 ZWJ}', "");
    Expect(1, 8206, '\P{WB=	 ZWJ}', "");
    Expect(0, 8206, '\P{^WB=	 ZWJ}', "");
    Error('\p{Is_Word_Break=	-ZWJ/a/}');
    Error('\P{Is_Word_Break=	-ZWJ/a/}');
    Expect(1, 8205, '\p{Is_Word_Break:	zwj}', "");
    Expect(0, 8205, '\p{^Is_Word_Break:	zwj}', "");
    Expect(0, 8205, '\P{Is_Word_Break:	zwj}', "");
    Expect(1, 8205, '\P{^Is_Word_Break:	zwj}', "");
    Expect(0, 8206, '\p{Is_Word_Break:	zwj}', "");
    Expect(1, 8206, '\p{^Is_Word_Break:	zwj}', "");
    Expect(1, 8206, '\P{Is_Word_Break:	zwj}', "");
    Expect(0, 8206, '\P{^Is_Word_Break:	zwj}', "");
    Expect(1, 8205, '\p{Is_Word_Break=_-ZWJ}', "");
    Expect(0, 8205, '\p{^Is_Word_Break=_-ZWJ}', "");
    Expect(0, 8205, '\P{Is_Word_Break=_-ZWJ}', "");
    Expect(1, 8205, '\P{^Is_Word_Break=_-ZWJ}', "");
    Expect(0, 8206, '\p{Is_Word_Break=_-ZWJ}', "");
    Expect(1, 8206, '\p{^Is_Word_Break=_-ZWJ}', "");
    Expect(1, 8206, '\P{Is_Word_Break=_-ZWJ}', "");
    Expect(0, 8206, '\P{^Is_Word_Break=_-ZWJ}', "");
    Error('\p{Is_WB=/a/  zwj}');
    Error('\P{Is_WB=/a/  zwj}');
    Expect(1, 8205, '\p{Is_WB=zwj}', "");
    Expect(0, 8205, '\p{^Is_WB=zwj}', "");
    Expect(0, 8205, '\P{Is_WB=zwj}', "");
    Expect(1, 8205, '\P{^Is_WB=zwj}', "");
    Expect(0, 8206, '\p{Is_WB=zwj}', "");
    Expect(1, 8206, '\p{^Is_WB=zwj}', "");
    Expect(1, 8206, '\P{Is_WB=zwj}', "");
    Expect(0, 8206, '\P{^Is_WB=zwj}', "");
    Expect(1, 8205, '\p{Is_WB= zwj}', "");
    Expect(0, 8205, '\p{^Is_WB= zwj}', "");
    Expect(0, 8205, '\P{Is_WB= zwj}', "");
    Expect(1, 8205, '\P{^Is_WB= zwj}', "");
    Expect(0, 8206, '\p{Is_WB= zwj}', "");
    Expect(1, 8206, '\p{^Is_WB= zwj}', "");
    Expect(1, 8206, '\P{Is_WB= zwj}', "");
    Expect(0, 8206, '\P{^Is_WB= zwj}', "");
    Error('\p{White_Space=/a/ _No}');
    Error('\P{White_Space=/a/ _No}');
    Expect(1, 12289, '\p{White_Space=:\ANo\z:}', "");;
    Expect(0, 12288, '\p{White_Space=:\ANo\z:}', "");;
    Expect(1, 12289, '\p{White_Space=no}', "");
    Expect(0, 12289, '\p{^White_Space=no}', "");
    Expect(0, 12289, '\P{White_Space=no}', "");
    Expect(1, 12289, '\P{^White_Space=no}', "");
    Expect(0, 12288, '\p{White_Space=no}', "");
    Expect(1, 12288, '\p{^White_Space=no}', "");
    Expect(1, 12288, '\P{White_Space=no}', "");
    Expect(0, 12288, '\P{^White_Space=no}', "");
    Expect(1, 12289, '\p{White_Space=:\Ano\z:}', "");;
    Expect(0, 12288, '\p{White_Space=:\Ano\z:}', "");;
    Expect(1, 12289, '\p{White_Space=	-No}', "");
    Expect(0, 12289, '\p{^White_Space=	-No}', "");
    Expect(0, 12289, '\P{White_Space=	-No}', "");
    Expect(1, 12289, '\P{^White_Space=	-No}', "");
    Expect(0, 12288, '\p{White_Space=	-No}', "");
    Expect(1, 12288, '\p{^White_Space=	-No}', "");
    Expect(1, 12288, '\P{White_Space=	-No}', "");
    Expect(0, 12288, '\P{^White_Space=	-No}', "");
    Error('\p{WSpace=_-n/a/}');
    Error('\P{WSpace=_-n/a/}');
    Expect(1, 12289, '\p{WSpace=:\AN\z:}', "");;
    Expect(0, 12288, '\p{WSpace=:\AN\z:}', "");;
    Expect(1, 12289, '\p{WSpace=n}', "");
    Expect(0, 12289, '\p{^WSpace=n}', "");
    Expect(0, 12289, '\P{WSpace=n}', "");
    Expect(1, 12289, '\P{^WSpace=n}', "");
    Expect(0, 12288, '\p{WSpace=n}', "");
    Expect(1, 12288, '\p{^WSpace=n}', "");
    Expect(1, 12288, '\P{WSpace=n}', "");
    Expect(0, 12288, '\P{^WSpace=n}', "");
    Expect(1, 12289, '\p{WSpace=:\An\z:}', "");;
    Expect(0, 12288, '\p{WSpace=:\An\z:}', "");;
    Expect(1, 12289, '\p{WSpace=	_N}', "");
    Expect(0, 12289, '\p{^WSpace=	_N}', "");
    Expect(0, 12289, '\P{WSpace=	_N}', "");
    Expect(1, 12289, '\P{^WSpace=	_N}', "");
    Expect(0, 12288, '\p{WSpace=	_N}', "");
    Expect(1, 12288, '\p{^WSpace=	_N}', "");
    Expect(1, 12288, '\P{WSpace=	_N}', "");
    Expect(0, 12288, '\P{^WSpace=	_N}', "");
    Error('\p{Space: -/a/f}');
    Error('\P{Space: -/a/f}');
    Expect(1, 12289, '\p{Space=:\AF\z:}', "");;
    Expect(0, 12288, '\p{Space=:\AF\z:}', "");;
    Expect(1, 12289, '\p{Space=f}', "");
    Expect(0, 12289, '\p{^Space=f}', "");
    Expect(0, 12289, '\P{Space=f}', "");
    Expect(1, 12289, '\P{^Space=f}', "");
    Expect(0, 12288, '\p{Space=f}', "");
    Expect(1, 12288, '\p{^Space=f}', "");
    Expect(1, 12288, '\P{Space=f}', "");
    Expect(0, 12288, '\P{^Space=f}', "");
    Expect(1, 12289, '\p{Space=:\Af\z:}', "");;
    Expect(0, 12288, '\p{Space=:\Af\z:}', "");;
    Expect(1, 12289, '\p{Space=- F}', "");
    Expect(0, 12289, '\p{^Space=- F}', "");
    Expect(0, 12289, '\P{Space=- F}', "");
    Expect(1, 12289, '\P{^Space=- F}', "");
    Expect(0, 12288, '\p{Space=- F}', "");
    Expect(1, 12288, '\p{^Space=- F}', "");
    Expect(1, 12288, '\P{Space=- F}', "");
    Expect(0, 12288, '\P{^Space=- F}', "");
    Error('\p{Is_White_Space:	_:=False}');
    Error('\P{Is_White_Space:	_:=False}');
    Expect(1, 12289, '\p{Is_White_Space=false}', "");
    Expect(0, 12289, '\p{^Is_White_Space=false}', "");
    Expect(0, 12289, '\P{Is_White_Space=false}', "");
    Expect(1, 12289, '\P{^Is_White_Space=false}', "");
    Expect(0, 12288, '\p{Is_White_Space=false}', "");
    Expect(1, 12288, '\p{^Is_White_Space=false}', "");
    Expect(1, 12288, '\P{Is_White_Space=false}', "");
    Expect(0, 12288, '\P{^Is_White_Space=false}', "");
    Expect(1, 12289, '\p{Is_White_Space= False}', "");
    Expect(0, 12289, '\p{^Is_White_Space= False}', "");
    Expect(0, 12289, '\P{Is_White_Space= False}', "");
    Expect(1, 12289, '\P{^Is_White_Space= False}', "");
    Expect(0, 12288, '\p{Is_White_Space= False}', "");
    Expect(1, 12288, '\p{^Is_White_Space= False}', "");
    Expect(1, 12288, '\P{Is_White_Space= False}', "");
    Expect(0, 12288, '\P{^Is_White_Space= False}', "");
    Error('\p{Is_WSpace=		No:=}');
    Error('\P{Is_WSpace=		No:=}');
    Expect(1, 12289, '\p{Is_WSpace=no}', "");
    Expect(0, 12289, '\p{^Is_WSpace=no}', "");
    Expect(0, 12289, '\P{Is_WSpace=no}', "");
    Expect(1, 12289, '\P{^Is_WSpace=no}', "");
    Expect(0, 12288, '\p{Is_WSpace=no}', "");
    Expect(1, 12288, '\p{^Is_WSpace=no}', "");
    Expect(1, 12288, '\P{Is_WSpace=no}', "");
    Expect(0, 12288, '\P{^Is_WSpace=no}', "");
    Expect(1, 12289, '\p{Is_WSpace:  	no}', "");
    Expect(0, 12289, '\p{^Is_WSpace:  	no}', "");
    Expect(0, 12289, '\P{Is_WSpace:  	no}', "");
    Expect(1, 12289, '\P{^Is_WSpace:  	no}', "");
    Expect(0, 12288, '\p{Is_WSpace:  	no}', "");
    Expect(1, 12288, '\p{^Is_WSpace:  	no}', "");
    Expect(1, 12288, '\P{Is_WSpace:  	no}', "");
    Expect(0, 12288, '\P{^Is_WSpace:  	no}', "");
    Error('\p{Is_Space=	:=N}');
    Error('\P{Is_Space=	:=N}');
    Expect(1, 12289, '\p{Is_Space=n}', "");
    Expect(0, 12289, '\p{^Is_Space=n}', "");
    Expect(0, 12289, '\P{Is_Space=n}', "");
    Expect(1, 12289, '\P{^Is_Space=n}', "");
    Expect(0, 12288, '\p{Is_Space=n}', "");
    Expect(1, 12288, '\p{^Is_Space=n}', "");
    Expect(1, 12288, '\P{Is_Space=n}', "");
    Expect(0, 12288, '\P{^Is_Space=n}', "");
    Expect(1, 12289, '\p{Is_Space=  N}', "");
    Expect(0, 12289, '\p{^Is_Space=  N}', "");
    Expect(0, 12289, '\P{Is_Space=  N}', "");
    Expect(1, 12289, '\P{^Is_Space=  N}', "");
    Expect(0, 12288, '\p{Is_Space=  N}', "");
    Expect(1, 12288, '\p{^Is_Space=  N}', "");
    Expect(1, 12288, '\P{Is_Space=  N}', "");
    Expect(0, 12288, '\P{^Is_Space=  N}', "");
    Error('\p{White_Space=_/a/yes}');
    Error('\P{White_Space=_/a/yes}');
    Expect(1, 12288, '\p{White_Space=:\AYes\z:}', "");;
    Expect(0, 12289, '\p{White_Space=:\AYes\z:}', "");;
    Expect(1, 12288, '\p{White_Space: yes}', "");
    Expect(0, 12288, '\p{^White_Space: yes}', "");
    Expect(0, 12288, '\P{White_Space: yes}', "");
    Expect(1, 12288, '\P{^White_Space: yes}', "");
    Expect(0, 12289, '\p{White_Space: yes}', "");
    Expect(1, 12289, '\p{^White_Space: yes}', "");
    Expect(1, 12289, '\P{White_Space: yes}', "");
    Expect(0, 12289, '\P{^White_Space: yes}', "");
    Expect(1, 12288, '\p{White_Space=:\Ayes\z:}', "");;
    Expect(0, 12289, '\p{White_Space=:\Ayes\z:}', "");;
    Expect(1, 12288, '\p{White_Space=	Yes}', "");
    Expect(0, 12288, '\p{^White_Space=	Yes}', "");
    Expect(0, 12288, '\P{White_Space=	Yes}', "");
    Expect(1, 12288, '\P{^White_Space=	Yes}', "");
    Expect(0, 12289, '\p{White_Space=	Yes}', "");
    Expect(1, 12289, '\p{^White_Space=	Yes}', "");
    Expect(1, 12289, '\P{White_Space=	Yes}', "");
    Expect(0, 12289, '\P{^White_Space=	Yes}', "");
    Error('\p{WSpace=/a/	 Y}');
    Error('\P{WSpace=/a/	 Y}');
    Expect(1, 12288, '\p{WSpace=:\AY\z:}', "");;
    Expect(0, 12289, '\p{WSpace=:\AY\z:}', "");;
    Expect(1, 12288, '\p{WSpace=y}', "");
    Expect(0, 12288, '\p{^WSpace=y}', "");
    Expect(0, 12288, '\P{WSpace=y}', "");
    Expect(1, 12288, '\P{^WSpace=y}', "");
    Expect(0, 12289, '\p{WSpace=y}', "");
    Expect(1, 12289, '\p{^WSpace=y}', "");
    Expect(1, 12289, '\P{WSpace=y}', "");
    Expect(0, 12289, '\P{^WSpace=y}', "");
    Expect(1, 12288, '\p{WSpace=:\Ay\z:}', "");;
    Expect(0, 12289, '\p{WSpace=:\Ay\z:}', "");;
    Expect(1, 12288, '\p{WSpace=_y}', "");
    Expect(0, 12288, '\p{^WSpace=_y}', "");
    Expect(0, 12288, '\P{WSpace=_y}', "");
    Expect(1, 12288, '\P{^WSpace=_y}', "");
    Expect(0, 12289, '\p{WSpace=_y}', "");
    Expect(1, 12289, '\p{^WSpace=_y}', "");
    Expect(1, 12289, '\P{WSpace=_y}', "");
    Expect(0, 12289, '\P{^WSpace=_y}', "");
    Error('\p{Space=	T/a/}');
    Error('\P{Space=	T/a/}');
    Expect(1, 12288, '\p{Space=:\AT\z:}', "");;
    Expect(0, 12289, '\p{Space=:\AT\z:}', "");;
    Expect(1, 12288, '\p{Space=t}', "");
    Expect(0, 12288, '\p{^Space=t}', "");
    Expect(0, 12288, '\P{Space=t}', "");
    Expect(1, 12288, '\P{^Space=t}', "");
    Expect(0, 12289, '\p{Space=t}', "");
    Expect(1, 12289, '\p{^Space=t}', "");
    Expect(1, 12289, '\P{Space=t}', "");
    Expect(0, 12289, '\P{^Space=t}', "");
    Expect(1, 12288, '\p{Space=:\At\z:}', "");;
    Expect(0, 12289, '\p{Space=:\At\z:}', "");;
    Expect(1, 12288, '\p{Space=	_T}', "");
    Expect(0, 12288, '\p{^Space=	_T}', "");
    Expect(0, 12288, '\P{Space=	_T}', "");
    Expect(1, 12288, '\P{^Space=	_T}', "");
    Expect(0, 12289, '\p{Space=	_T}', "");
    Expect(1, 12289, '\p{^Space=	_T}', "");
    Expect(1, 12289, '\P{Space=	_T}', "");
    Expect(0, 12289, '\P{^Space=	_T}', "");
    Error('\p{Is_White_Space=_-True:=}');
    Error('\P{Is_White_Space=_-True:=}');
    Expect(1, 12288, '\p{Is_White_Space=true}', "");
    Expect(0, 12288, '\p{^Is_White_Space=true}', "");
    Expect(0, 12288, '\P{Is_White_Space=true}', "");
    Expect(1, 12288, '\P{^Is_White_Space=true}', "");
    Expect(0, 12289, '\p{Is_White_Space=true}', "");
    Expect(1, 12289, '\p{^Is_White_Space=true}', "");
    Expect(1, 12289, '\P{Is_White_Space=true}', "");
    Expect(0, 12289, '\P{^Is_White_Space=true}', "");
    Expect(1, 12288, '\p{Is_White_Space= true}', "");
    Expect(0, 12288, '\p{^Is_White_Space= true}', "");
    Expect(0, 12288, '\P{Is_White_Space= true}', "");
    Expect(1, 12288, '\P{^Is_White_Space= true}', "");
    Expect(0, 12289, '\p{Is_White_Space= true}', "");
    Expect(1, 12289, '\p{^Is_White_Space= true}', "");
    Expect(1, 12289, '\P{Is_White_Space= true}', "");
    Expect(0, 12289, '\P{^Is_White_Space= true}', "");
    Error('\p{Is_WSpace=:=__YES}');
    Error('\P{Is_WSpace=:=__YES}');
    Expect(1, 12288, '\p{Is_WSpace: yes}', "");
    Expect(0, 12288, '\p{^Is_WSpace: yes}', "");
    Expect(0, 12288, '\P{Is_WSpace: yes}', "");
    Expect(1, 12288, '\P{^Is_WSpace: yes}', "");
    Expect(0, 12289, '\p{Is_WSpace: yes}', "");
    Expect(1, 12289, '\p{^Is_WSpace: yes}', "");
    Expect(1, 12289, '\P{Is_WSpace: yes}', "");
    Expect(0, 12289, '\P{^Is_WSpace: yes}', "");
    Expect(1, 12288, '\p{Is_WSpace:   _	Yes}', "");
    Expect(0, 12288, '\p{^Is_WSpace:   _	Yes}', "");
    Expect(0, 12288, '\P{Is_WSpace:   _	Yes}', "");
    Expect(1, 12288, '\P{^Is_WSpace:   _	Yes}', "");
    Expect(0, 12289, '\p{Is_WSpace:   _	Yes}', "");
    Expect(1, 12289, '\p{^Is_WSpace:   _	Yes}', "");
    Expect(1, 12289, '\P{Is_WSpace:   _	Yes}', "");
    Expect(0, 12289, '\P{^Is_WSpace:   _	Yes}', "");
    Error('\p{Is_Space:	 :=Y}');
    Error('\P{Is_Space:	 :=Y}');
    Expect(1, 12288, '\p{Is_Space=y}', "");
    Expect(0, 12288, '\p{^Is_Space=y}', "");
    Expect(0, 12288, '\P{Is_Space=y}', "");
    Expect(1, 12288, '\P{^Is_Space=y}', "");
    Expect(0, 12289, '\p{Is_Space=y}', "");
    Expect(1, 12289, '\p{^Is_Space=y}', "");
    Expect(1, 12289, '\P{Is_Space=y}', "");
    Expect(0, 12289, '\P{^Is_Space=y}', "");
    Expect(1, 12288, '\p{Is_Space=--Y}', "");
    Expect(0, 12288, '\p{^Is_Space=--Y}', "");
    Expect(0, 12288, '\P{Is_Space=--Y}', "");
    Expect(1, 12288, '\P{^Is_Space=--Y}', "");
    Expect(0, 12289, '\p{Is_Space=--Y}', "");
    Expect(1, 12289, '\p{^Is_Space=--Y}', "");
    Expect(1, 12289, '\P{Is_Space=--Y}', "");
    Expect(0, 12289, '\P{^Is_Space=--Y}', "");
    Error('\p{XID_Continue=:=  NO}');
    Error('\P{XID_Continue=:=  NO}');
    Expect(1, 918000, '\p{XID_Continue=:\ANo\z:}', "");;
    Expect(0, 917999, '\p{XID_Continue=:\ANo\z:}', "");;
    Expect(1, 918000, '\p{XID_Continue=no}', "");
    Expect(0, 918000, '\p{^XID_Continue=no}', "");
    Expect(0, 918000, '\P{XID_Continue=no}', "");
    Expect(1, 918000, '\P{^XID_Continue=no}', "");
    Expect(0, 917999, '\p{XID_Continue=no}', "");
    Expect(1, 917999, '\p{^XID_Continue=no}', "");
    Expect(1, 917999, '\P{XID_Continue=no}', "");
    Expect(0, 917999, '\P{^XID_Continue=no}', "");
    Expect(1, 918000, '\p{XID_Continue=:\Ano\z:}', "");;
    Expect(0, 917999, '\p{XID_Continue=:\Ano\z:}', "");;
    Expect(1, 918000, '\p{XID_Continue=-_No}', "");
    Expect(0, 918000, '\p{^XID_Continue=-_No}', "");
    Expect(0, 918000, '\P{XID_Continue=-_No}', "");
    Expect(1, 918000, '\P{^XID_Continue=-_No}', "");
    Expect(0, 917999, '\p{XID_Continue=-_No}', "");
    Expect(1, 917999, '\p{^XID_Continue=-_No}', "");
    Expect(1, 917999, '\P{XID_Continue=-_No}', "");
    Expect(0, 917999, '\P{^XID_Continue=-_No}', "");
    Error('\p{XIDC=_:=N}');
    Error('\P{XIDC=_:=N}');
    Expect(1, 918000, '\p{XIDC=:\AN\z:}', "");;
    Expect(0, 917999, '\p{XIDC=:\AN\z:}', "");;
    Expect(1, 918000, '\p{XIDC=n}', "");
    Expect(0, 918000, '\p{^XIDC=n}', "");
    Expect(0, 918000, '\P{XIDC=n}', "");
    Expect(1, 918000, '\P{^XIDC=n}', "");
    Expect(0, 917999, '\p{XIDC=n}', "");
    Expect(1, 917999, '\p{^XIDC=n}', "");
    Expect(1, 917999, '\P{XIDC=n}', "");
    Expect(0, 917999, '\P{^XIDC=n}', "");
    Expect(1, 918000, '\p{XIDC=:\An\z:}', "");;
    Expect(0, 917999, '\p{XIDC=:\An\z:}', "");;
    Expect(1, 918000, '\p{XIDC:		N}', "");
    Expect(0, 918000, '\p{^XIDC:		N}', "");
    Expect(0, 918000, '\P{XIDC:		N}', "");
    Expect(1, 918000, '\P{^XIDC:		N}', "");
    Expect(0, 917999, '\p{XIDC:		N}', "");
    Expect(1, 917999, '\p{^XIDC:		N}', "");
    Expect(1, 917999, '\P{XIDC:		N}', "");
    Expect(0, 917999, '\P{^XIDC:		N}', "");
    Error('\p{Is_XID_Continue:    	F/a/}');
    Error('\P{Is_XID_Continue:    	F/a/}');
    Expect(1, 918000, '\p{Is_XID_Continue=f}', "");
    Expect(0, 918000, '\p{^Is_XID_Continue=f}', "");
    Expect(0, 918000, '\P{Is_XID_Continue=f}', "");
    Expect(1, 918000, '\P{^Is_XID_Continue=f}', "");
    Expect(0, 917999, '\p{Is_XID_Continue=f}', "");
    Expect(1, 917999, '\p{^Is_XID_Continue=f}', "");
    Expect(1, 917999, '\P{Is_XID_Continue=f}', "");
    Expect(0, 917999, '\P{^Is_XID_Continue=f}', "");
    Expect(1, 918000, '\p{Is_XID_Continue=	f}', "");
    Expect(0, 918000, '\p{^Is_XID_Continue=	f}', "");
    Expect(0, 918000, '\P{Is_XID_Continue=	f}', "");
    Expect(1, 918000, '\P{^Is_XID_Continue=	f}', "");
    Expect(0, 917999, '\p{Is_XID_Continue=	f}', "");
    Expect(1, 917999, '\p{^Is_XID_Continue=	f}', "");
    Expect(1, 917999, '\P{Is_XID_Continue=	f}', "");
    Expect(0, 917999, '\P{^Is_XID_Continue=	f}', "");
    Error('\p{Is_XIDC= False:=}');
    Error('\P{Is_XIDC= False:=}');
    Expect(1, 918000, '\p{Is_XIDC=false}', "");
    Expect(0, 918000, '\p{^Is_XIDC=false}', "");
    Expect(0, 918000, '\P{Is_XIDC=false}', "");
    Expect(1, 918000, '\P{^Is_XIDC=false}', "");
    Expect(0, 917999, '\p{Is_XIDC=false}', "");
    Expect(1, 917999, '\p{^Is_XIDC=false}', "");
    Expect(1, 917999, '\P{Is_XIDC=false}', "");
    Expect(0, 917999, '\P{^Is_XIDC=false}', "");
    Expect(1, 918000, '\p{Is_XIDC:	 false}', "");
    Expect(0, 918000, '\p{^Is_XIDC:	 false}', "");
    Expect(0, 918000, '\P{Is_XIDC:	 false}', "");
    Expect(1, 918000, '\P{^Is_XIDC:	 false}', "");
    Expect(0, 917999, '\p{Is_XIDC:	 false}', "");
    Expect(1, 917999, '\p{^Is_XIDC:	 false}', "");
    Expect(1, 917999, '\P{Is_XIDC:	 false}', "");
    Expect(0, 917999, '\P{^Is_XIDC:	 false}', "");
    Error('\p{XID_Continue=	_yes:=}');
    Error('\P{XID_Continue=	_yes:=}');
    Expect(1, 917999, '\p{XID_Continue=:\AYes\z:}', "");;
    Expect(0, 918000, '\p{XID_Continue=:\AYes\z:}', "");;
    Expect(1, 917999, '\p{XID_Continue=yes}', "");
    Expect(0, 917999, '\p{^XID_Continue=yes}', "");
    Expect(0, 917999, '\P{XID_Continue=yes}', "");
    Expect(1, 917999, '\P{^XID_Continue=yes}', "");
    Expect(0, 918000, '\p{XID_Continue=yes}', "");
    Expect(1, 918000, '\p{^XID_Continue=yes}', "");
    Expect(1, 918000, '\P{XID_Continue=yes}', "");
    Expect(0, 918000, '\P{^XID_Continue=yes}', "");
    Expect(1, 917999, '\p{XID_Continue=:\Ayes\z:}', "");;
    Expect(0, 918000, '\p{XID_Continue=:\Ayes\z:}', "");;
    Expect(1, 917999, '\p{XID_Continue: _Yes}', "");
    Expect(0, 917999, '\p{^XID_Continue: _Yes}', "");
    Expect(0, 917999, '\P{XID_Continue: _Yes}', "");
    Expect(1, 917999, '\P{^XID_Continue: _Yes}', "");
    Expect(0, 918000, '\p{XID_Continue: _Yes}', "");
    Expect(1, 918000, '\p{^XID_Continue: _Yes}', "");
    Expect(1, 918000, '\P{XID_Continue: _Yes}', "");
    Expect(0, 918000, '\P{^XID_Continue: _Yes}', "");
    Error('\p{XIDC=/a/--Y}');
    Error('\P{XIDC=/a/--Y}');
    Expect(1, 917999, '\p{XIDC=:\AY\z:}', "");;
    Expect(0, 918000, '\p{XIDC=:\AY\z:}', "");;
    Expect(1, 917999, '\p{XIDC=y}', "");
    Expect(0, 917999, '\p{^XIDC=y}', "");
    Expect(0, 917999, '\P{XIDC=y}', "");
    Expect(1, 917999, '\P{^XIDC=y}', "");
    Expect(0, 918000, '\p{XIDC=y}', "");
    Expect(1, 918000, '\p{^XIDC=y}', "");
    Expect(1, 918000, '\P{XIDC=y}', "");
    Expect(0, 918000, '\P{^XIDC=y}', "");
    Expect(1, 917999, '\p{XIDC=:\Ay\z:}', "");;
    Expect(0, 918000, '\p{XIDC=:\Ay\z:}', "");;
    Expect(1, 917999, '\p{XIDC:--Y}', "");
    Expect(0, 917999, '\p{^XIDC:--Y}', "");
    Expect(0, 917999, '\P{XIDC:--Y}', "");
    Expect(1, 917999, '\P{^XIDC:--Y}', "");
    Expect(0, 918000, '\p{XIDC:--Y}', "");
    Expect(1, 918000, '\p{^XIDC:--Y}', "");
    Expect(1, 918000, '\P{XIDC:--Y}', "");
    Expect(0, 918000, '\P{^XIDC:--Y}', "");
    Error('\p{Is_XID_Continue=/a/ T}');
    Error('\P{Is_XID_Continue=/a/ T}');
    Expect(1, 917999, '\p{Is_XID_Continue=t}', "");
    Expect(0, 917999, '\p{^Is_XID_Continue=t}', "");
    Expect(0, 917999, '\P{Is_XID_Continue=t}', "");
    Expect(1, 917999, '\P{^Is_XID_Continue=t}', "");
    Expect(0, 918000, '\p{Is_XID_Continue=t}', "");
    Expect(1, 918000, '\p{^Is_XID_Continue=t}', "");
    Expect(1, 918000, '\P{Is_XID_Continue=t}', "");
    Expect(0, 918000, '\P{^Is_XID_Continue=t}', "");
    Expect(1, 917999, '\p{Is_XID_Continue= -t}', "");
    Expect(0, 917999, '\p{^Is_XID_Continue= -t}', "");
    Expect(0, 917999, '\P{Is_XID_Continue= -t}', "");
    Expect(1, 917999, '\P{^Is_XID_Continue= -t}', "");
    Expect(0, 918000, '\p{Is_XID_Continue= -t}', "");
    Expect(1, 918000, '\p{^Is_XID_Continue= -t}', "");
    Expect(1, 918000, '\P{Is_XID_Continue= -t}', "");
    Expect(0, 918000, '\P{^Is_XID_Continue= -t}', "");
    Error('\p{Is_XIDC: :=- True}');
    Error('\P{Is_XIDC: :=- True}');
    Expect(1, 917999, '\p{Is_XIDC=true}', "");
    Expect(0, 917999, '\p{^Is_XIDC=true}', "");
    Expect(0, 917999, '\P{Is_XIDC=true}', "");
    Expect(1, 917999, '\P{^Is_XIDC=true}', "");
    Expect(0, 918000, '\p{Is_XIDC=true}', "");
    Expect(1, 918000, '\p{^Is_XIDC=true}', "");
    Expect(1, 918000, '\P{Is_XIDC=true}', "");
    Expect(0, 918000, '\P{^Is_XIDC=true}', "");
    Expect(1, 917999, '\p{Is_XIDC=_	TRUE}', "");
    Expect(0, 917999, '\p{^Is_XIDC=_	TRUE}', "");
    Expect(0, 917999, '\P{Is_XIDC=_	TRUE}', "");
    Expect(1, 917999, '\P{^Is_XIDC=_	TRUE}', "");
    Expect(0, 918000, '\p{Is_XIDC=_	TRUE}', "");
    Expect(1, 918000, '\p{^Is_XIDC=_	TRUE}', "");
    Expect(1, 918000, '\P{Is_XIDC=_	TRUE}', "");
    Expect(0, 918000, '\P{^Is_XIDC=_	TRUE}', "");
    Error('\p{XID_Start=/a/--No}');
    Error('\P{XID_Start=/a/--No}');
    Expect(1, 201547, '\p{XID_Start=:\ANo\z:}', "");;
    Expect(0, 201546, '\p{XID_Start=:\ANo\z:}', "");;
    Expect(1, 201547, '\p{XID_Start=no}', "");
    Expect(0, 201547, '\p{^XID_Start=no}', "");
    Expect(0, 201547, '\P{XID_Start=no}', "");
    Expect(1, 201547, '\P{^XID_Start=no}', "");
    Expect(0, 201546, '\p{XID_Start=no}', "");
    Expect(1, 201546, '\p{^XID_Start=no}', "");
    Expect(1, 201546, '\P{XID_Start=no}', "");
    Expect(0, 201546, '\P{^XID_Start=no}', "");
    Expect(1, 201547, '\p{XID_Start=:\Ano\z:}', "");;
    Expect(0, 201546, '\p{XID_Start=:\Ano\z:}', "");;
    Expect(1, 201547, '\p{XID_Start=-	no}', "");
    Expect(0, 201547, '\p{^XID_Start=-	no}', "");
    Expect(0, 201547, '\P{XID_Start=-	no}', "");
    Expect(1, 201547, '\P{^XID_Start=-	no}', "");
    Expect(0, 201546, '\p{XID_Start=-	no}', "");
    Expect(1, 201546, '\p{^XID_Start=-	no}', "");
    Expect(1, 201546, '\P{XID_Start=-	no}', "");
    Expect(0, 201546, '\P{^XID_Start=-	no}', "");
    Error('\p{XIDS=-:=N}');
    Error('\P{XIDS=-:=N}');
    Expect(1, 201547, '\p{XIDS=:\AN\z:}', "");;
    Expect(0, 201546, '\p{XIDS=:\AN\z:}', "");;
    Expect(1, 201547, '\p{XIDS=n}', "");
    Expect(0, 201547, '\p{^XIDS=n}', "");
    Expect(0, 201547, '\P{XIDS=n}', "");
    Expect(1, 201547, '\P{^XIDS=n}', "");
    Expect(0, 201546, '\p{XIDS=n}', "");
    Expect(1, 201546, '\p{^XIDS=n}', "");
    Expect(1, 201546, '\P{XIDS=n}', "");
    Expect(0, 201546, '\P{^XIDS=n}', "");
    Expect(1, 201547, '\p{XIDS=:\An\z:}', "");;
    Expect(0, 201546, '\p{XIDS=:\An\z:}', "");;
    Expect(1, 201547, '\p{XIDS=--N}', "");
    Expect(0, 201547, '\p{^XIDS=--N}', "");
    Expect(0, 201547, '\P{XIDS=--N}', "");
    Expect(1, 201547, '\P{^XIDS=--N}', "");
    Expect(0, 201546, '\p{XIDS=--N}', "");
    Expect(1, 201546, '\p{^XIDS=--N}', "");
    Expect(1, 201546, '\P{XIDS=--N}', "");
    Expect(0, 201546, '\P{^XIDS=--N}', "");
    Error('\p{Is_XID_Start=-/a/F}');
    Error('\P{Is_XID_Start=-/a/F}');
    Expect(1, 201547, '\p{Is_XID_Start:	f}', "");
    Expect(0, 201547, '\p{^Is_XID_Start:	f}', "");
    Expect(0, 201547, '\P{Is_XID_Start:	f}', "");
    Expect(1, 201547, '\P{^Is_XID_Start:	f}', "");
    Expect(0, 201546, '\p{Is_XID_Start:	f}', "");
    Expect(1, 201546, '\p{^Is_XID_Start:	f}', "");
    Expect(1, 201546, '\P{Is_XID_Start:	f}', "");
    Expect(0, 201546, '\P{^Is_XID_Start:	f}', "");
    Expect(1, 201547, '\p{Is_XID_Start=	f}', "");
    Expect(0, 201547, '\p{^Is_XID_Start=	f}', "");
    Expect(0, 201547, '\P{Is_XID_Start=	f}', "");
    Expect(1, 201547, '\P{^Is_XID_Start=	f}', "");
    Expect(0, 201546, '\p{Is_XID_Start=	f}', "");
    Expect(1, 201546, '\p{^Is_XID_Start=	f}', "");
    Expect(1, 201546, '\P{Is_XID_Start=	f}', "");
    Expect(0, 201546, '\P{^Is_XID_Start=	f}', "");
    Error('\p{Is_XIDS=/a/_ False}');
    Error('\P{Is_XIDS=/a/_ False}');
    Expect(1, 201547, '\p{Is_XIDS=false}', "");
    Expect(0, 201547, '\p{^Is_XIDS=false}', "");
    Expect(0, 201547, '\P{Is_XIDS=false}', "");
    Expect(1, 201547, '\P{^Is_XIDS=false}', "");
    Expect(0, 201546, '\p{Is_XIDS=false}', "");
    Expect(1, 201546, '\p{^Is_XIDS=false}', "");
    Expect(1, 201546, '\P{Is_XIDS=false}', "");
    Expect(0, 201546, '\P{^Is_XIDS=false}', "");
    Expect(1, 201547, '\p{Is_XIDS=	-False}', "");
    Expect(0, 201547, '\p{^Is_XIDS=	-False}', "");
    Expect(0, 201547, '\P{Is_XIDS=	-False}', "");
    Expect(1, 201547, '\P{^Is_XIDS=	-False}', "");
    Expect(0, 201546, '\p{Is_XIDS=	-False}', "");
    Expect(1, 201546, '\p{^Is_XIDS=	-False}', "");
    Expect(1, 201546, '\P{Is_XIDS=	-False}', "");
    Expect(0, 201546, '\P{^Is_XIDS=	-False}', "");
    Error('\p{XID_Start=/a/ -Yes}');
    Error('\P{XID_Start=/a/ -Yes}');
    Expect(1, 201546, '\p{XID_Start=:\AYes\z:}', "");;
    Expect(0, 201547, '\p{XID_Start=:\AYes\z:}', "");;
    Expect(1, 201546, '\p{XID_Start=yes}', "");
    Expect(0, 201546, '\p{^XID_Start=yes}', "");
    Expect(0, 201546, '\P{XID_Start=yes}', "");
    Expect(1, 201546, '\P{^XID_Start=yes}', "");
    Expect(0, 201547, '\p{XID_Start=yes}', "");
    Expect(1, 201547, '\p{^XID_Start=yes}', "");
    Expect(1, 201547, '\P{XID_Start=yes}', "");
    Expect(0, 201547, '\P{^XID_Start=yes}', "");
    Expect(1, 201546, '\p{XID_Start=:\Ayes\z:}', "");;
    Expect(0, 201547, '\p{XID_Start=:\Ayes\z:}', "");;
    Expect(1, 201546, '\p{XID_Start=		yes}', "");
    Expect(0, 201546, '\p{^XID_Start=		yes}', "");
    Expect(0, 201546, '\P{XID_Start=		yes}', "");
    Expect(1, 201546, '\P{^XID_Start=		yes}', "");
    Expect(0, 201547, '\p{XID_Start=		yes}', "");
    Expect(1, 201547, '\p{^XID_Start=		yes}', "");
    Expect(1, 201547, '\P{XID_Start=		yes}', "");
    Expect(0, 201547, '\P{^XID_Start=		yes}', "");
    Error('\p{XIDS:	 /a/Y}');
    Error('\P{XIDS:	 /a/Y}');
    Expect(1, 201546, '\p{XIDS=:\AY\z:}', "");;
    Expect(0, 201547, '\p{XIDS=:\AY\z:}', "");;
    Expect(1, 201546, '\p{XIDS:	y}', "");
    Expect(0, 201546, '\p{^XIDS:	y}', "");
    Expect(0, 201546, '\P{XIDS:	y}', "");
    Expect(1, 201546, '\P{^XIDS:	y}', "");
    Expect(0, 201547, '\p{XIDS:	y}', "");
    Expect(1, 201547, '\p{^XIDS:	y}', "");
    Expect(1, 201547, '\P{XIDS:	y}', "");
    Expect(0, 201547, '\P{^XIDS:	y}', "");
    Expect(1, 201546, '\p{XIDS=:\Ay\z:}', "");;
    Expect(0, 201547, '\p{XIDS=:\Ay\z:}', "");;
    Expect(1, 201546, '\p{XIDS:	-Y}', "");
    Expect(0, 201546, '\p{^XIDS:	-Y}', "");
    Expect(0, 201546, '\P{XIDS:	-Y}', "");
    Expect(1, 201546, '\P{^XIDS:	-Y}', "");
    Expect(0, 201547, '\p{XIDS:	-Y}', "");
    Expect(1, 201547, '\p{^XIDS:	-Y}', "");
    Expect(1, 201547, '\P{XIDS:	-Y}', "");
    Expect(0, 201547, '\P{^XIDS:	-Y}', "");
    Error('\p{Is_XID_Start=/a/T}');
    Error('\P{Is_XID_Start=/a/T}');
    Expect(1, 201546, '\p{Is_XID_Start=t}', "");
    Expect(0, 201546, '\p{^Is_XID_Start=t}', "");
    Expect(0, 201546, '\P{Is_XID_Start=t}', "");
    Expect(1, 201546, '\P{^Is_XID_Start=t}', "");
    Expect(0, 201547, '\p{Is_XID_Start=t}', "");
    Expect(1, 201547, '\p{^Is_XID_Start=t}', "");
    Expect(1, 201547, '\P{Is_XID_Start=t}', "");
    Expect(0, 201547, '\P{^Is_XID_Start=t}', "");
    Expect(1, 201546, '\p{Is_XID_Start=	-T}', "");
    Expect(0, 201546, '\p{^Is_XID_Start=	-T}', "");
    Expect(0, 201546, '\P{Is_XID_Start=	-T}', "");
    Expect(1, 201546, '\P{^Is_XID_Start=	-T}', "");
    Expect(0, 201547, '\p{Is_XID_Start=	-T}', "");
    Expect(1, 201547, '\p{^Is_XID_Start=	-T}', "");
    Expect(1, 201547, '\P{Is_XID_Start=	-T}', "");
    Expect(0, 201547, '\P{^Is_XID_Start=	-T}', "");
    Error('\p{Is_XIDS=:=	true}');
    Error('\P{Is_XIDS=:=	true}');
    Expect(1, 201546, '\p{Is_XIDS=true}', "");
    Expect(0, 201546, '\p{^Is_XIDS=true}', "");
    Expect(0, 201546, '\P{Is_XIDS=true}', "");
    Expect(1, 201546, '\P{^Is_XIDS=true}', "");
    Expect(0, 201547, '\p{Is_XIDS=true}', "");
    Expect(1, 201547, '\p{^Is_XIDS=true}', "");
    Expect(1, 201547, '\P{Is_XIDS=true}', "");
    Expect(0, 201547, '\P{^Is_XIDS=true}', "");
    Expect(1, 201546, '\p{Is_XIDS:		-true}', "");
    Expect(0, 201546, '\p{^Is_XIDS:		-true}', "");
    Expect(0, 201546, '\P{Is_XIDS:		-true}', "");
    Expect(1, 201546, '\P{^Is_XIDS:		-true}', "");
    Expect(0, 201547, '\p{Is_XIDS:		-true}', "");
    Expect(1, 201547, '\p{^Is_XIDS:		-true}', "");
    Expect(1, 201547, '\P{Is_XIDS:		-true}', "");
    Expect(0, 201547, '\P{^Is_XIDS:		-true}', "");
    Error('\p{Expands_On_NFC=No}');
    Error('\P{Expands_On_NFC=No}');
    Error('\p{XO_NFC=N}');
    Error('\P{XO_NFC=N}');
    Error('\p{Is_Expands_On_NFC=F}');
    Error('\P{Is_Expands_On_NFC=F}');
    Error('\p{Is_XO_NFC=False}');
    Error('\P{Is_XO_NFC=False}');
    Error('\p{Expands_On_NFC=Yes}');
    Error('\P{Expands_On_NFC=Yes}');
    Error('\p{XO_NFC=Y}');
    Error('\P{XO_NFC=Y}');
    Error('\p{Is_Expands_On_NFC=T}');
    Error('\P{Is_Expands_On_NFC=T}');
    Error('\p{Is_XO_NFC=True}');
    Error('\P{Is_XO_NFC=True}');
    Error('\p{Expands_On_NFD=No}');
    Error('\P{Expands_On_NFD=No}');
    Error('\p{XO_NFD=N}');
    Error('\P{XO_NFD=N}');
    Error('\p{Is_Expands_On_NFD=F}');
    Error('\P{Is_Expands_On_NFD=F}');
    Error('\p{Is_XO_NFD=False}');
    Error('\P{Is_XO_NFD=False}');
    Error('\p{Expands_On_NFD=Yes}');
    Error('\P{Expands_On_NFD=Yes}');
    Error('\p{XO_NFD=Y}');
    Error('\P{XO_NFD=Y}');
    Error('\p{Is_Expands_On_NFD=T}');
    Error('\P{Is_Expands_On_NFD=T}');
    Error('\p{Is_XO_NFD=True}');
    Error('\P{Is_XO_NFD=True}');
    Error('\p{Expands_On_NFKC=No}');
    Error('\P{Expands_On_NFKC=No}');
    Error('\p{XO_NFKC:   N}');
    Error('\P{XO_NFKC:   N}');
    Error('\p{Is_Expands_On_NFKC=F}');
    Error('\P{Is_Expands_On_NFKC=F}');
    Error('\p{Is_XO_NFKC=False}');
    Error('\P{Is_XO_NFKC=False}');
    Error('\p{Expands_On_NFKC=Yes}');
    Error('\P{Expands_On_NFKC=Yes}');
    Error('\p{XO_NFKC=Y}');
    Error('\P{XO_NFKC=Y}');
    Error('\p{Is_Expands_On_NFKC=T}');
    Error('\P{Is_Expands_On_NFKC=T}');
    Error('\p{Is_XO_NFKC:   True}');
    Error('\P{Is_XO_NFKC:   True}');
    Error('\p{Expands_On_NFKD=No}');
    Error('\P{Expands_On_NFKD=No}');
    Error('\p{XO_NFKD:	N}');
    Error('\P{XO_NFKD:	N}');
    Error('\p{Is_Expands_On_NFKD=F}');
    Error('\P{Is_Expands_On_NFKD=F}');
    Error('\p{Is_XO_NFKD=False}');
    Error('\P{Is_XO_NFKD=False}');
    Error('\p{Expands_On_NFKD=Yes}');
    Error('\P{Expands_On_NFKD=Yes}');
    Error('\p{XO_NFKD=Y}');
    Error('\P{XO_NFKD=Y}');
    Error('\p{Is_Expands_On_NFKD=T}');
    Error('\P{Is_Expands_On_NFKD=T}');
    Error('\p{Is_XO_NFKD=True}');
    Error('\P{Is_XO_NFKD=True}');
}
if (!$::TESTCHUNK or $::TESTCHUNK == 5) {
    Test_GCB('÷ 0020 ÷ 0020 ÷	#  ÷ [0.2] SPACE (Other) ÷ [999.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ 0020 × 0308 ÷ 0020 ÷	#  ÷ [0.2] SPACE (Other) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ 0020 ÷ 000D ÷	#  ÷ [0.2] SPACE (Other) ÷ [5.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ 0020 × 0308 ÷ 000D ÷	#  ÷ [0.2] SPACE (Other) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ 0020 ÷ 000A ÷	#  ÷ [0.2] SPACE (Other) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ 0020 × 0308 ÷ 000A ÷	#  ÷ [0.2] SPACE (Other) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ 0020 ÷ 0001 ÷	#  ÷ [0.2] SPACE (Other) ÷ [5.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ 0020 × 0308 ÷ 0001 ÷	#  ÷ [0.2] SPACE (Other) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ 0020 × 034F ÷	#  ÷ [0.2] SPACE (Other) × [9.0] COMBINING GRAPHEME JOINER (Extend) ÷ [0.3]');
    Test_GCB('÷ 0020 × 0308 × 034F ÷	#  ÷ [0.2] SPACE (Other) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] COMBINING GRAPHEME JOINER (Extend) ÷ [0.3]');
    Test_GCB('÷ 0020 ÷ 1F1E6 ÷	#  ÷ [0.2] SPACE (Other) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ 0020 × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] SPACE (Other) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ 0020 ÷ 0600 ÷	#  ÷ [0.2] SPACE (Other) ÷ [999.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ 0020 × 0308 ÷ 0600 ÷	#  ÷ [0.2] SPACE (Other) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ 0020 × 0903 ÷	#  ÷ [0.2] SPACE (Other) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ 0020 × 0308 × 0903 ÷	#  ÷ [0.2] SPACE (Other) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ 0020 ÷ 1100 ÷	#  ÷ [0.2] SPACE (Other) ÷ [999.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ 0020 × 0308 ÷ 1100 ÷	#  ÷ [0.2] SPACE (Other) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ 0020 ÷ 1160 ÷	#  ÷ [0.2] SPACE (Other) ÷ [999.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ 0020 × 0308 ÷ 1160 ÷	#  ÷ [0.2] SPACE (Other) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ 0020 ÷ 11A8 ÷	#  ÷ [0.2] SPACE (Other) ÷ [999.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ 0020 × 0308 ÷ 11A8 ÷	#  ÷ [0.2] SPACE (Other) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ 0020 ÷ AC00 ÷	#  ÷ [0.2] SPACE (Other) ÷ [999.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ 0020 × 0308 ÷ AC00 ÷	#  ÷ [0.2] SPACE (Other) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ 0020 ÷ AC01 ÷	#  ÷ [0.2] SPACE (Other) ÷ [999.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ 0020 × 0308 ÷ AC01 ÷	#  ÷ [0.2] SPACE (Other) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ 0020 ÷ 231A ÷	#  ÷ [0.2] SPACE (Other) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_GCB('÷ 0020 × 0308 ÷ 231A ÷	#  ÷ [0.2] SPACE (Other) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_GCB('÷ 0020 × 0300 ÷	#  ÷ [0.2] SPACE (Other) × [9.0] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 0020 × 0308 × 0300 ÷	#  ÷ [0.2] SPACE (Other) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 0020 × 200D ÷	#  ÷ [0.2] SPACE (Other) × [9.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 0020 × 0308 × 200D ÷	#  ÷ [0.2] SPACE (Other) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 0020 ÷ 0378 ÷	#  ÷ [0.2] SPACE (Other) ÷ [999.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ 0020 × 0308 ÷ 0378 ÷	#  ÷ [0.2] SPACE (Other) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ 0020 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ 0308 ÷ 0020 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ 000D ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ 0308 ÷ 000D ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ 000D × 000A ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) × [3.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ 0308 ÷ 000A ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ 0001 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ 0308 ÷ 0001 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ 034F ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING GRAPHEME JOINER (Extend) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ 0308 × 034F ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] COMBINING GRAPHEME JOINER (Extend) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ 1F1E6 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ 0600 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ 0308 ÷ 0600 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ 0903 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ 0308 × 0903 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ 1100 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ 0308 ÷ 1100 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ 1160 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ 0308 ÷ 1160 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ 11A8 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ 0308 ÷ 11A8 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ AC00 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ 0308 ÷ AC00 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ AC01 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ 0308 ÷ AC01 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ 231A ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] WATCH (ExtPict) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ 0308 ÷ 231A ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ 0300 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ 0308 × 0300 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ 200D ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ 0308 × 200D ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ 0378 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ 0308 ÷ 0378 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 0020 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 0308 ÷ 0020 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 000D ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 0308 ÷ 000D ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 000A ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 0308 ÷ 000A ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 0001 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 0308 ÷ 0001 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 034F ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING GRAPHEME JOINER (Extend) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 0308 × 034F ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] COMBINING GRAPHEME JOINER (Extend) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 1F1E6 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 0600 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 0308 ÷ 0600 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 0903 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 0308 × 0903 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 1100 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 0308 ÷ 1100 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 1160 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 0308 ÷ 1160 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 11A8 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 0308 ÷ 11A8 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ AC00 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 0308 ÷ AC00 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ AC01 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 0308 ÷ AC01 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 231A ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] WATCH (ExtPict) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 0308 ÷ 231A ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 0300 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 0308 × 0300 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 200D ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 0308 × 200D ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 0378 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 0308 ÷ 0378 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 0020 ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 0308 ÷ 0020 ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 000D ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 0308 ÷ 000D ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 000A ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 0308 ÷ 000A ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 0001 ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 0308 ÷ 0001 ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 034F ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] COMBINING GRAPHEME JOINER (Extend) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 0308 × 034F ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] COMBINING GRAPHEME JOINER (Extend) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 1F1E6 ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 0600 ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 0308 ÷ 0600 ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 0903 ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 0308 × 0903 ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 1100 ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 0308 ÷ 1100 ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 1160 ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 0308 ÷ 1160 ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 11A8 ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 0308 ÷ 11A8 ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ AC00 ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 0308 ÷ AC00 ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ AC01 ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 0308 ÷ AC01 ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 231A ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] WATCH (ExtPict) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 0308 ÷ 231A ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 0300 ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 0308 × 0300 ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 200D ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 0308 × 200D ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 0378 ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 0308 ÷ 0378 ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ 034F ÷ 0020 ÷	#  ÷ [0.2] COMBINING GRAPHEME JOINER (Extend) ÷ [999.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ 034F × 0308 ÷ 0020 ÷	#  ÷ [0.2] COMBINING GRAPHEME JOINER (Extend) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ 034F ÷ 000D ÷	#  ÷ [0.2] COMBINING GRAPHEME JOINER (Extend) ÷ [5.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ 034F × 0308 ÷ 000D ÷	#  ÷ [0.2] COMBINING GRAPHEME JOINER (Extend) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ 034F ÷ 000A ÷	#  ÷ [0.2] COMBINING GRAPHEME JOINER (Extend) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ 034F × 0308 ÷ 000A ÷	#  ÷ [0.2] COMBINING GRAPHEME JOINER (Extend) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ 034F ÷ 0001 ÷	#  ÷ [0.2] COMBINING GRAPHEME JOINER (Extend) ÷ [5.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ 034F × 0308 ÷ 0001 ÷	#  ÷ [0.2] COMBINING GRAPHEME JOINER (Extend) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ 034F × 034F ÷	#  ÷ [0.2] COMBINING GRAPHEME JOINER (Extend) × [9.0] COMBINING GRAPHEME JOINER (Extend) ÷ [0.3]');
    Test_GCB('÷ 034F × 0308 × 034F ÷	#  ÷ [0.2] COMBINING GRAPHEME JOINER (Extend) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] COMBINING GRAPHEME JOINER (Extend) ÷ [0.3]');
    Test_GCB('÷ 034F ÷ 1F1E6 ÷	#  ÷ [0.2] COMBINING GRAPHEME JOINER (Extend) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ 034F × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] COMBINING GRAPHEME JOINER (Extend) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ 034F ÷ 0600 ÷	#  ÷ [0.2] COMBINING GRAPHEME JOINER (Extend) ÷ [999.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ 034F × 0308 ÷ 0600 ÷	#  ÷ [0.2] COMBINING GRAPHEME JOINER (Extend) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ 034F × 0903 ÷	#  ÷ [0.2] COMBINING GRAPHEME JOINER (Extend) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ 034F × 0308 × 0903 ÷	#  ÷ [0.2] COMBINING GRAPHEME JOINER (Extend) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ 034F ÷ 1100 ÷	#  ÷ [0.2] COMBINING GRAPHEME JOINER (Extend) ÷ [999.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ 034F × 0308 ÷ 1100 ÷	#  ÷ [0.2] COMBINING GRAPHEME JOINER (Extend) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ 034F ÷ 1160 ÷	#  ÷ [0.2] COMBINING GRAPHEME JOINER (Extend) ÷ [999.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ 034F × 0308 ÷ 1160 ÷	#  ÷ [0.2] COMBINING GRAPHEME JOINER (Extend) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ 034F ÷ 11A8 ÷	#  ÷ [0.2] COMBINING GRAPHEME JOINER (Extend) ÷ [999.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ 034F × 0308 ÷ 11A8 ÷	#  ÷ [0.2] COMBINING GRAPHEME JOINER (Extend) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ 034F ÷ AC00 ÷	#  ÷ [0.2] COMBINING GRAPHEME JOINER (Extend) ÷ [999.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ 034F × 0308 ÷ AC00 ÷	#  ÷ [0.2] COMBINING GRAPHEME JOINER (Extend) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ 034F ÷ AC01 ÷	#  ÷ [0.2] COMBINING GRAPHEME JOINER (Extend) ÷ [999.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ 034F × 0308 ÷ AC01 ÷	#  ÷ [0.2] COMBINING GRAPHEME JOINER (Extend) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ 034F ÷ 231A ÷	#  ÷ [0.2] COMBINING GRAPHEME JOINER (Extend) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_GCB('÷ 034F × 0308 ÷ 231A ÷	#  ÷ [0.2] COMBINING GRAPHEME JOINER (Extend) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_GCB('÷ 034F × 0300 ÷	#  ÷ [0.2] COMBINING GRAPHEME JOINER (Extend) × [9.0] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 034F × 0308 × 0300 ÷	#  ÷ [0.2] COMBINING GRAPHEME JOINER (Extend) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 034F × 200D ÷	#  ÷ [0.2] COMBINING GRAPHEME JOINER (Extend) × [9.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 034F × 0308 × 200D ÷	#  ÷ [0.2] COMBINING GRAPHEME JOINER (Extend) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 034F ÷ 0378 ÷	#  ÷ [0.2] COMBINING GRAPHEME JOINER (Extend) ÷ [999.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ 034F × 0308 ÷ 0378 ÷	#  ÷ [0.2] COMBINING GRAPHEME JOINER (Extend) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 ÷ 0020 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 × 0308 ÷ 0020 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 ÷ 000D ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [5.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 × 0308 ÷ 000D ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 ÷ 000A ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 × 0308 ÷ 000A ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 ÷ 0001 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [5.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 × 0308 ÷ 0001 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 × 034F ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING GRAPHEME JOINER (Extend) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 × 0308 × 034F ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] COMBINING GRAPHEME JOINER (Extend) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 × 1F1E6 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [12.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 ÷ 0600 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 × 0308 ÷ 0600 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 × 0903 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 × 0308 × 0903 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 ÷ 1100 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 × 0308 ÷ 1100 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 ÷ 1160 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 × 0308 ÷ 1160 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 ÷ 11A8 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 × 0308 ÷ 11A8 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 ÷ AC00 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 × 0308 ÷ AC00 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 ÷ AC01 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 × 0308 ÷ AC01 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 ÷ 231A ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 × 0308 ÷ 231A ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 × 0300 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 × 0308 × 0300 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 × 200D ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 × 0308 × 200D ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 ÷ 0378 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 × 0308 ÷ 0378 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ 0600 × 0020 ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) × [9.2] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ 0600 × 0308 ÷ 0020 ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ 0600 ÷ 000D ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) ÷ [5.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ 0600 × 0308 ÷ 000D ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ 0600 ÷ 000A ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ 0600 × 0308 ÷ 000A ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ 0600 ÷ 0001 ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) ÷ [5.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ 0600 × 0308 ÷ 0001 ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ 0600 × 034F ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) × [9.0] COMBINING GRAPHEME JOINER (Extend) ÷ [0.3]');
    Test_GCB('÷ 0600 × 0308 × 034F ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] COMBINING GRAPHEME JOINER (Extend) ÷ [0.3]');
    Test_GCB('÷ 0600 × 1F1E6 ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) × [9.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ 0600 × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ 0600 × 0600 ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) × [9.2] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ 0600 × 0308 ÷ 0600 ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ 0600 × 0903 ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ 0600 × 0308 × 0903 ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ 0600 × 1100 ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) × [9.2] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ 0600 × 0308 ÷ 1100 ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ 0600 × 1160 ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) × [9.2] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ 0600 × 0308 ÷ 1160 ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ 0600 × 11A8 ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) × [9.2] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ 0600 × 0308 ÷ 11A8 ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ 0600 × AC00 ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) × [9.2] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ 0600 × 0308 ÷ AC00 ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ 0600 × AC01 ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) × [9.2] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ 0600 × 0308 ÷ AC01 ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ 0600 × 231A ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) × [9.2] WATCH (ExtPict) ÷ [0.3]');
    Test_GCB('÷ 0600 × 0308 ÷ 231A ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_GCB('÷ 0600 × 0300 ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) × [9.0] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 0600 × 0308 × 0300 ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 0600 × 200D ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) × [9.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 0600 × 0308 × 200D ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 0600 × 0378 ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) × [9.2] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ 0600 × 0308 ÷ 0378 ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ 0903 ÷ 0020 ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [999.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ 0903 × 0308 ÷ 0020 ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ 0903 ÷ 000D ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [5.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ 0903 × 0308 ÷ 000D ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ 0903 ÷ 000A ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ 0903 × 0308 ÷ 000A ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ 0903 ÷ 0001 ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [5.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ 0903 × 0308 ÷ 0001 ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ 0903 × 034F ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) × [9.0] COMBINING GRAPHEME JOINER (Extend) ÷ [0.3]');
    Test_GCB('÷ 0903 × 0308 × 034F ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] COMBINING GRAPHEME JOINER (Extend) ÷ [0.3]');
    Test_GCB('÷ 0903 ÷ 1F1E6 ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ 0903 × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ 0903 ÷ 0600 ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [999.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ 0903 × 0308 ÷ 0600 ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ 0903 × 0903 ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ 0903 × 0308 × 0903 ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ 0903 ÷ 1100 ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [999.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ 0903 × 0308 ÷ 1100 ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ 0903 ÷ 1160 ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [999.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ 0903 × 0308 ÷ 1160 ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ 0903 ÷ 11A8 ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [999.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ 0903 × 0308 ÷ 11A8 ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ 0903 ÷ AC00 ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [999.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ 0903 × 0308 ÷ AC00 ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ 0903 ÷ AC01 ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [999.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ 0903 × 0308 ÷ AC01 ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ 0903 ÷ 231A ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_GCB('÷ 0903 × 0308 ÷ 231A ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_GCB('÷ 0903 × 0300 ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) × [9.0] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 0903 × 0308 × 0300 ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 0903 × 200D ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) × [9.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 0903 × 0308 × 200D ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 0903 ÷ 0378 ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [999.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ 0903 × 0308 ÷ 0378 ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ 1100 ÷ 0020 ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) ÷ [999.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ 1100 × 0308 ÷ 0020 ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ 1100 ÷ 000D ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) ÷ [5.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ 1100 × 0308 ÷ 000D ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ 1100 ÷ 000A ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ 1100 × 0308 ÷ 000A ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ 1100 ÷ 0001 ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) ÷ [5.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ 1100 × 0308 ÷ 0001 ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ 1100 × 034F ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) × [9.0] COMBINING GRAPHEME JOINER (Extend) ÷ [0.3]');
    Test_GCB('÷ 1100 × 0308 × 034F ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] COMBINING GRAPHEME JOINER (Extend) ÷ [0.3]');
    Test_GCB('÷ 1100 ÷ 1F1E6 ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ 1100 × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ 1100 ÷ 0600 ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) ÷ [999.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ 1100 × 0308 ÷ 0600 ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ 1100 × 0903 ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ 1100 × 0308 × 0903 ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ 1100 × 1100 ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) × [6.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ 1100 × 0308 ÷ 1100 ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ 1100 × 1160 ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) × [6.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ 1100 × 0308 ÷ 1160 ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ 1100 ÷ 11A8 ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) ÷ [999.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ 1100 × 0308 ÷ 11A8 ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ 1100 × AC00 ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) × [6.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ 1100 × 0308 ÷ AC00 ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ 1100 × AC01 ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) × [6.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ 1100 × 0308 ÷ AC01 ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ 1100 ÷ 231A ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_GCB('÷ 1100 × 0308 ÷ 231A ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_GCB('÷ 1100 × 0300 ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) × [9.0] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 1100 × 0308 × 0300 ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 1100 × 200D ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) × [9.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 1100 × 0308 × 200D ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 1100 ÷ 0378 ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) ÷ [999.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ 1100 × 0308 ÷ 0378 ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ 1160 ÷ 0020 ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) ÷ [999.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ 1160 × 0308 ÷ 0020 ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ 1160 ÷ 000D ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) ÷ [5.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ 1160 × 0308 ÷ 000D ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ 1160 ÷ 000A ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ 1160 × 0308 ÷ 000A ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ 1160 ÷ 0001 ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) ÷ [5.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ 1160 × 0308 ÷ 0001 ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ 1160 × 034F ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) × [9.0] COMBINING GRAPHEME JOINER (Extend) ÷ [0.3]');
    Test_GCB('÷ 1160 × 0308 × 034F ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] COMBINING GRAPHEME JOINER (Extend) ÷ [0.3]');
    Test_GCB('÷ 1160 ÷ 1F1E6 ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ 1160 × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ 1160 ÷ 0600 ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) ÷ [999.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ 1160 × 0308 ÷ 0600 ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ 1160 × 0903 ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ 1160 × 0308 × 0903 ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ 1160 ÷ 1100 ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) ÷ [999.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ 1160 × 0308 ÷ 1100 ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ 1160 × 1160 ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) × [7.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ 1160 × 0308 ÷ 1160 ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ 1160 × 11A8 ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) × [7.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ 1160 × 0308 ÷ 11A8 ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ 1160 ÷ AC00 ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) ÷ [999.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ 1160 × 0308 ÷ AC00 ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ 1160 ÷ AC01 ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) ÷ [999.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ 1160 × 0308 ÷ AC01 ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ 1160 ÷ 231A ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_GCB('÷ 1160 × 0308 ÷ 231A ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_GCB('÷ 1160 × 0300 ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) × [9.0] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 1160 × 0308 × 0300 ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 1160 × 200D ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) × [9.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 1160 × 0308 × 200D ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 1160 ÷ 0378 ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) ÷ [999.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ 1160 × 0308 ÷ 0378 ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ 11A8 ÷ 0020 ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) ÷ [999.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ 11A8 × 0308 ÷ 0020 ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ 11A8 ÷ 000D ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) ÷ [5.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ 11A8 × 0308 ÷ 000D ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ 11A8 ÷ 000A ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ 11A8 × 0308 ÷ 000A ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ 11A8 ÷ 0001 ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) ÷ [5.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ 11A8 × 0308 ÷ 0001 ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ 11A8 × 034F ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) × [9.0] COMBINING GRAPHEME JOINER (Extend) ÷ [0.3]');
    Test_GCB('÷ 11A8 × 0308 × 034F ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] COMBINING GRAPHEME JOINER (Extend) ÷ [0.3]');
    Test_GCB('÷ 11A8 ÷ 1F1E6 ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ 11A8 × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ 11A8 ÷ 0600 ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) ÷ [999.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ 11A8 × 0308 ÷ 0600 ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ 11A8 × 0903 ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ 11A8 × 0308 × 0903 ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ 11A8 ÷ 1100 ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) ÷ [999.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ 11A8 × 0308 ÷ 1100 ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ 11A8 ÷ 1160 ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) ÷ [999.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ 11A8 × 0308 ÷ 1160 ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ 11A8 × 11A8 ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) × [8.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ 11A8 × 0308 ÷ 11A8 ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ 11A8 ÷ AC00 ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) ÷ [999.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ 11A8 × 0308 ÷ AC00 ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ 11A8 ÷ AC01 ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) ÷ [999.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ 11A8 × 0308 ÷ AC01 ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ 11A8 ÷ 231A ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_GCB('÷ 11A8 × 0308 ÷ 231A ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_GCB('÷ 11A8 × 0300 ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) × [9.0] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 11A8 × 0308 × 0300 ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 11A8 × 200D ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) × [9.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 11A8 × 0308 × 200D ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 11A8 ÷ 0378 ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) ÷ [999.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ 11A8 × 0308 ÷ 0378 ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ AC00 ÷ 0020 ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) ÷ [999.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ AC00 × 0308 ÷ 0020 ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ AC00 ÷ 000D ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) ÷ [5.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ AC00 × 0308 ÷ 000D ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ AC00 ÷ 000A ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ AC00 × 0308 ÷ 000A ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ AC00 ÷ 0001 ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) ÷ [5.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ AC00 × 0308 ÷ 0001 ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ AC00 × 034F ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) × [9.0] COMBINING GRAPHEME JOINER (Extend) ÷ [0.3]');
    Test_GCB('÷ AC00 × 0308 × 034F ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] COMBINING GRAPHEME JOINER (Extend) ÷ [0.3]');
    Test_GCB('÷ AC00 ÷ 1F1E6 ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ AC00 × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ AC00 ÷ 0600 ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) ÷ [999.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ AC00 × 0308 ÷ 0600 ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ AC00 × 0903 ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ AC00 × 0308 × 0903 ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ AC00 ÷ 1100 ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) ÷ [999.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ AC00 × 0308 ÷ 1100 ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ AC00 × 1160 ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) × [7.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ AC00 × 0308 ÷ 1160 ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ AC00 × 11A8 ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) × [7.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ AC00 × 0308 ÷ 11A8 ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ AC00 ÷ AC00 ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) ÷ [999.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ AC00 × 0308 ÷ AC00 ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ AC00 ÷ AC01 ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) ÷ [999.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ AC00 × 0308 ÷ AC01 ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ AC00 ÷ 231A ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_GCB('÷ AC00 × 0308 ÷ 231A ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_GCB('÷ AC00 × 0300 ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) × [9.0] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ AC00 × 0308 × 0300 ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ AC00 × 200D ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) × [9.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ AC00 × 0308 × 200D ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ AC00 ÷ 0378 ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) ÷ [999.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ AC00 × 0308 ÷ 0378 ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ AC01 ÷ 0020 ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) ÷ [999.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ AC01 × 0308 ÷ 0020 ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ AC01 ÷ 000D ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) ÷ [5.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ AC01 × 0308 ÷ 000D ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ AC01 ÷ 000A ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ AC01 × 0308 ÷ 000A ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ AC01 ÷ 0001 ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) ÷ [5.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ AC01 × 0308 ÷ 0001 ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ AC01 × 034F ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) × [9.0] COMBINING GRAPHEME JOINER (Extend) ÷ [0.3]');
    Test_GCB('÷ AC01 × 0308 × 034F ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] COMBINING GRAPHEME JOINER (Extend) ÷ [0.3]');
    Test_GCB('÷ AC01 ÷ 1F1E6 ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ AC01 × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ AC01 ÷ 0600 ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) ÷ [999.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ AC01 × 0308 ÷ 0600 ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ AC01 × 0903 ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ AC01 × 0308 × 0903 ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ AC01 ÷ 1100 ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) ÷ [999.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ AC01 × 0308 ÷ 1100 ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ AC01 ÷ 1160 ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) ÷ [999.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ AC01 × 0308 ÷ 1160 ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ AC01 × 11A8 ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) × [8.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ AC01 × 0308 ÷ 11A8 ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ AC01 ÷ AC00 ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) ÷ [999.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ AC01 × 0308 ÷ AC00 ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ AC01 ÷ AC01 ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) ÷ [999.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ AC01 × 0308 ÷ AC01 ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ AC01 ÷ 231A ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_GCB('÷ AC01 × 0308 ÷ 231A ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_GCB('÷ AC01 × 0300 ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) × [9.0] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ AC01 × 0308 × 0300 ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ AC01 × 200D ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) × [9.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ AC01 × 0308 × 200D ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ AC01 ÷ 0378 ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) ÷ [999.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ AC01 × 0308 ÷ 0378 ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ 231A ÷ 0020 ÷	#  ÷ [0.2] WATCH (ExtPict) ÷ [999.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ 231A × 0308 ÷ 0020 ÷	#  ÷ [0.2] WATCH (ExtPict) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ 231A ÷ 000D ÷	#  ÷ [0.2] WATCH (ExtPict) ÷ [5.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ 231A × 0308 ÷ 000D ÷	#  ÷ [0.2] WATCH (ExtPict) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ 231A ÷ 000A ÷	#  ÷ [0.2] WATCH (ExtPict) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ 231A × 0308 ÷ 000A ÷	#  ÷ [0.2] WATCH (ExtPict) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ 231A ÷ 0001 ÷	#  ÷ [0.2] WATCH (ExtPict) ÷ [5.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ 231A × 0308 ÷ 0001 ÷	#  ÷ [0.2] WATCH (ExtPict) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ 231A × 034F ÷	#  ÷ [0.2] WATCH (ExtPict) × [9.0] COMBINING GRAPHEME JOINER (Extend) ÷ [0.3]');
    Test_GCB('÷ 231A × 0308 × 034F ÷	#  ÷ [0.2] WATCH (ExtPict) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] COMBINING GRAPHEME JOINER (Extend) ÷ [0.3]');
    Test_GCB('÷ 231A ÷ 1F1E6 ÷	#  ÷ [0.2] WATCH (ExtPict) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ 231A × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] WATCH (ExtPict) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ 231A ÷ 0600 ÷	#  ÷ [0.2] WATCH (ExtPict) ÷ [999.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ 231A × 0308 ÷ 0600 ÷	#  ÷ [0.2] WATCH (ExtPict) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ 231A × 0903 ÷	#  ÷ [0.2] WATCH (ExtPict) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ 231A × 0308 × 0903 ÷	#  ÷ [0.2] WATCH (ExtPict) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ 231A ÷ 1100 ÷	#  ÷ [0.2] WATCH (ExtPict) ÷ [999.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ 231A × 0308 ÷ 1100 ÷	#  ÷ [0.2] WATCH (ExtPict) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ 231A ÷ 1160 ÷	#  ÷ [0.2] WATCH (ExtPict) ÷ [999.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ 231A × 0308 ÷ 1160 ÷	#  ÷ [0.2] WATCH (ExtPict) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ 231A ÷ 11A8 ÷	#  ÷ [0.2] WATCH (ExtPict) ÷ [999.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ 231A × 0308 ÷ 11A8 ÷	#  ÷ [0.2] WATCH (ExtPict) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ 231A ÷ AC00 ÷	#  ÷ [0.2] WATCH (ExtPict) ÷ [999.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ 231A × 0308 ÷ AC00 ÷	#  ÷ [0.2] WATCH (ExtPict) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ 231A ÷ AC01 ÷	#  ÷ [0.2] WATCH (ExtPict) ÷ [999.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ 231A × 0308 ÷ AC01 ÷	#  ÷ [0.2] WATCH (ExtPict) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ 231A ÷ 231A ÷	#  ÷ [0.2] WATCH (ExtPict) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_GCB('÷ 231A × 0308 ÷ 231A ÷	#  ÷ [0.2] WATCH (ExtPict) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_GCB('÷ 231A × 0300 ÷	#  ÷ [0.2] WATCH (ExtPict) × [9.0] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 231A × 0308 × 0300 ÷	#  ÷ [0.2] WATCH (ExtPict) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 231A × 200D ÷	#  ÷ [0.2] WATCH (ExtPict) × [9.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 231A × 0308 × 200D ÷	#  ÷ [0.2] WATCH (ExtPict) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 231A ÷ 0378 ÷	#  ÷ [0.2] WATCH (ExtPict) ÷ [999.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ 231A × 0308 ÷ 0378 ÷	#  ÷ [0.2] WATCH (ExtPict) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ 0300 ÷ 0020 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [999.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ 0300 × 0308 ÷ 0020 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ 0300 ÷ 000D ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [5.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ 0300 × 0308 ÷ 000D ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ 0300 ÷ 000A ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ 0300 × 0308 ÷ 000A ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ 0300 ÷ 0001 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [5.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ 0300 × 0308 ÷ 0001 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ 0300 × 034F ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) × [9.0] COMBINING GRAPHEME JOINER (Extend) ÷ [0.3]');
    Test_GCB('÷ 0300 × 0308 × 034F ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] COMBINING GRAPHEME JOINER (Extend) ÷ [0.3]');
    Test_GCB('÷ 0300 ÷ 1F1E6 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ 0300 × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ 0300 ÷ 0600 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [999.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ 0300 × 0308 ÷ 0600 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ 0300 × 0903 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ 0300 × 0308 × 0903 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ 0300 ÷ 1100 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [999.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ 0300 × 0308 ÷ 1100 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ 0300 ÷ 1160 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [999.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ 0300 × 0308 ÷ 1160 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ 0300 ÷ 11A8 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [999.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ 0300 × 0308 ÷ 11A8 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ 0300 ÷ AC00 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [999.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ 0300 × 0308 ÷ AC00 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ 0300 ÷ AC01 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [999.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ 0300 × 0308 ÷ AC01 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ 0300 ÷ 231A ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_GCB('÷ 0300 × 0308 ÷ 231A ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_GCB('÷ 0300 × 0300 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) × [9.0] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 0300 × 0308 × 0300 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 0300 × 200D ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) × [9.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 0300 × 0308 × 200D ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 0300 ÷ 0378 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [999.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ 0300 × 0308 ÷ 0378 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ 200D ÷ 0020 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [999.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ 200D × 0308 ÷ 0020 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ 200D ÷ 000D ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [5.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ 200D × 0308 ÷ 000D ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ 200D ÷ 000A ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ 200D × 0308 ÷ 000A ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ 200D ÷ 0001 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [5.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ 200D × 0308 ÷ 0001 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ 200D × 034F ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) × [9.0] COMBINING GRAPHEME JOINER (Extend) ÷ [0.3]');
    Test_GCB('÷ 200D × 0308 × 034F ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] COMBINING GRAPHEME JOINER (Extend) ÷ [0.3]');
    Test_GCB('÷ 200D ÷ 1F1E6 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ 200D × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ 200D ÷ 0600 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [999.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ 200D × 0308 ÷ 0600 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ 200D × 0903 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ 200D × 0308 × 0903 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ 200D ÷ 1100 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [999.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ 200D × 0308 ÷ 1100 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ 200D ÷ 1160 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [999.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ 200D × 0308 ÷ 1160 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ 200D ÷ 11A8 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [999.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ 200D × 0308 ÷ 11A8 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ 200D ÷ AC00 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [999.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ 200D × 0308 ÷ AC00 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ 200D ÷ AC01 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [999.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ 200D × 0308 ÷ AC01 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ 200D ÷ 231A ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_GCB('÷ 200D × 0308 ÷ 231A ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_GCB('÷ 200D × 0300 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) × [9.0] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 200D × 0308 × 0300 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 200D × 200D ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) × [9.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 200D × 0308 × 200D ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 200D ÷ 0378 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [999.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ 200D × 0308 ÷ 0378 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ 0378 ÷ 0020 ÷	#  ÷ [0.2] <reserved-0378> (Other) ÷ [999.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ 0378 × 0308 ÷ 0020 ÷	#  ÷ [0.2] <reserved-0378> (Other) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ 0378 ÷ 000D ÷	#  ÷ [0.2] <reserved-0378> (Other) ÷ [5.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ 0378 × 0308 ÷ 000D ÷	#  ÷ [0.2] <reserved-0378> (Other) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ 0378 ÷ 000A ÷	#  ÷ [0.2] <reserved-0378> (Other) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ 0378 × 0308 ÷ 000A ÷	#  ÷ [0.2] <reserved-0378> (Other) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ 0378 ÷ 0001 ÷	#  ÷ [0.2] <reserved-0378> (Other) ÷ [5.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ 0378 × 0308 ÷ 0001 ÷	#  ÷ [0.2] <reserved-0378> (Other) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ 0378 × 034F ÷	#  ÷ [0.2] <reserved-0378> (Other) × [9.0] COMBINING GRAPHEME JOINER (Extend) ÷ [0.3]');
    Test_GCB('÷ 0378 × 0308 × 034F ÷	#  ÷ [0.2] <reserved-0378> (Other) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] COMBINING GRAPHEME JOINER (Extend) ÷ [0.3]');
    Test_GCB('÷ 0378 ÷ 1F1E6 ÷	#  ÷ [0.2] <reserved-0378> (Other) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ 0378 × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] <reserved-0378> (Other) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ 0378 ÷ 0600 ÷	#  ÷ [0.2] <reserved-0378> (Other) ÷ [999.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ 0378 × 0308 ÷ 0600 ÷	#  ÷ [0.2] <reserved-0378> (Other) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ 0378 × 0903 ÷	#  ÷ [0.2] <reserved-0378> (Other) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ 0378 × 0308 × 0903 ÷	#  ÷ [0.2] <reserved-0378> (Other) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ 0378 ÷ 1100 ÷	#  ÷ [0.2] <reserved-0378> (Other) ÷ [999.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ 0378 × 0308 ÷ 1100 ÷	#  ÷ [0.2] <reserved-0378> (Other) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ 0378 ÷ 1160 ÷	#  ÷ [0.2] <reserved-0378> (Other) ÷ [999.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ 0378 × 0308 ÷ 1160 ÷	#  ÷ [0.2] <reserved-0378> (Other) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ 0378 ÷ 11A8 ÷	#  ÷ [0.2] <reserved-0378> (Other) ÷ [999.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ 0378 × 0308 ÷ 11A8 ÷	#  ÷ [0.2] <reserved-0378> (Other) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ 0378 ÷ AC00 ÷	#  ÷ [0.2] <reserved-0378> (Other) ÷ [999.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ 0378 × 0308 ÷ AC00 ÷	#  ÷ [0.2] <reserved-0378> (Other) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ 0378 ÷ AC01 ÷	#  ÷ [0.2] <reserved-0378> (Other) ÷ [999.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ 0378 × 0308 ÷ AC01 ÷	#  ÷ [0.2] <reserved-0378> (Other) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ 0378 ÷ 231A ÷	#  ÷ [0.2] <reserved-0378> (Other) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_GCB('÷ 0378 × 0308 ÷ 231A ÷	#  ÷ [0.2] <reserved-0378> (Other) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_GCB('÷ 0378 × 0300 ÷	#  ÷ [0.2] <reserved-0378> (Other) × [9.0] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 0378 × 0308 × 0300 ÷	#  ÷ [0.2] <reserved-0378> (Other) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 0378 × 200D ÷	#  ÷ [0.2] <reserved-0378> (Other) × [9.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 0378 × 0308 × 200D ÷	#  ÷ [0.2] <reserved-0378> (Other) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 0378 ÷ 0378 ÷	#  ÷ [0.2] <reserved-0378> (Other) ÷ [999.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ 0378 × 0308 ÷ 0378 ÷	#  ÷ [0.2] <reserved-0378> (Other) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ 000D × 000A ÷ 0061 ÷ 000A ÷ 0308 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) × [3.0] <LINE FEED (LF)> (LF) ÷ [4.0] LATIN SMALL LETTER A (Other) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 0061 × 0308 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Other) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 0020 × 200D ÷ 0646 ÷	#  ÷ [0.2] SPACE (Other) × [9.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [999.0] ARABIC LETTER NOON (Other) ÷ [0.3]');
    Test_GCB('÷ 0646 × 200D ÷ 0020 ÷	#  ÷ [0.2] ARABIC LETTER NOON (Other) × [9.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [999.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ 1100 × 1100 ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) × [6.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ AC00 × 11A8 ÷ 1100 ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) × [7.0] HANGUL JONGSEONG KIYEOK (T) ÷ [999.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ AC01 × 11A8 ÷ 1100 ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) × [8.0] HANGUL JONGSEONG KIYEOK (T) ÷ [999.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 × 1F1E7 ÷ 1F1E8 ÷ 0062 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [12.0] REGIONAL INDICATOR SYMBOL LETTER B (RI) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER C (RI) ÷ [999.0] LATIN SMALL LETTER B (Other) ÷ [0.3]');
    Test_GCB('÷ 0061 ÷ 1F1E6 × 1F1E7 ÷ 1F1E8 ÷ 0062 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Other) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [13.0] REGIONAL INDICATOR SYMBOL LETTER B (RI) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER C (RI) ÷ [999.0] LATIN SMALL LETTER B (Other) ÷ [0.3]');
    Test_GCB('÷ 0061 ÷ 1F1E6 × 1F1E7 × 200D ÷ 1F1E8 ÷ 0062 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Other) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [13.0] REGIONAL INDICATOR SYMBOL LETTER B (RI) × [9.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER C (RI) ÷ [999.0] LATIN SMALL LETTER B (Other) ÷ [0.3]');
    Test_GCB('÷ 0061 ÷ 1F1E6 × 200D ÷ 1F1E7 × 1F1E8 ÷ 0062 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Other) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER B (RI) × [13.0] REGIONAL INDICATOR SYMBOL LETTER C (RI) ÷ [999.0] LATIN SMALL LETTER B (Other) ÷ [0.3]');
    Test_GCB('÷ 0061 ÷ 1F1E6 × 1F1E7 ÷ 1F1E8 × 1F1E9 ÷ 0062 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Other) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [13.0] REGIONAL INDICATOR SYMBOL LETTER B (RI) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER C (RI) × [13.0] REGIONAL INDICATOR SYMBOL LETTER D (RI) ÷ [999.0] LATIN SMALL LETTER B (Other) ÷ [0.3]');
    Test_GCB('÷ 0061 × 200D ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Other) × [9.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 0061 × 0308 ÷ 0062 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Other) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] LATIN SMALL LETTER B (Other) ÷ [0.3]');
    Test_GCB('÷ 0061 × 0903 ÷ 0062 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Other) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [999.0] LATIN SMALL LETTER B (Other) ÷ [0.3]');
    Test_GCB('÷ 0061 ÷ 0600 × 0062 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Other) ÷ [999.0] ARABIC NUMBER SIGN (Prepend) × [9.2] LATIN SMALL LETTER B (Other) ÷ [0.3]');
    Test_GCB('÷ 1F476 × 1F3FF ÷ 1F476 ÷	#  ÷ [0.2] BABY (ExtPict) × [9.0] EMOJI MODIFIER FITZPATRICK TYPE-6 (Extend) ÷ [999.0] BABY (ExtPict) ÷ [0.3]');
    Test_GCB('÷ 0061 × 1F3FF ÷ 1F476 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Other) × [9.0] EMOJI MODIFIER FITZPATRICK TYPE-6 (Extend) ÷ [999.0] BABY (ExtPict) ÷ [0.3]');
    Test_GCB('÷ 0061 × 1F3FF ÷ 1F476 × 200D × 1F6D1 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Other) × [9.0] EMOJI MODIFIER FITZPATRICK TYPE-6 (Extend) ÷ [999.0] BABY (ExtPict) × [9.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) × [11.0] OCTAGONAL SIGN (ExtPict) ÷ [0.3]');
    Test_GCB('÷ 1F476 × 1F3FF × 0308 × 200D × 1F476 × 1F3FF ÷	#  ÷ [0.2] BABY (ExtPict) × [9.0] EMOJI MODIFIER FITZPATRICK TYPE-6 (Extend) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) × [11.0] BABY (ExtPict) × [9.0] EMOJI MODIFIER FITZPATRICK TYPE-6 (Extend) ÷ [0.3]');
    Test_GCB('÷ 1F6D1 × 200D × 1F6D1 ÷	#  ÷ [0.2] OCTAGONAL SIGN (ExtPict) × [9.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) × [11.0] OCTAGONAL SIGN (ExtPict) ÷ [0.3]');
    Test_GCB('÷ 0061 × 200D ÷ 1F6D1 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Other) × [9.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [999.0] OCTAGONAL SIGN (ExtPict) ÷ [0.3]');
    Test_GCB('÷ 2701 × 200D × 2701 ÷	#  ÷ [0.2] UPPER BLADE SCISSORS (Other) × [9.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) × [11.0] UPPER BLADE SCISSORS (Other) ÷ [0.3]');
    Test_GCB('÷ 0061 × 200D ÷ 2701 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Other) × [9.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [999.0] UPPER BLADE SCISSORS (Other) ÷ [0.3]');
    Test_SB('÷ 0001 × 0001 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [998.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_SB('÷ 0001 × 0308 × 0001 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_SB('÷ 0001 × 000D ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [998.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_SB('÷ 0001 × 0308 × 000D ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_SB('÷ 0001 × 000A ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [998.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_SB('÷ 0001 × 0308 × 000A ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_SB('÷ 0001 × 0085 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [998.0] <NEXT LINE (NEL)> (Sep) ÷ [0.3]');
    Test_SB('÷ 0001 × 0308 × 0085 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <NEXT LINE (NEL)> (Sep) ÷ [0.3]');
    Test_SB('÷ 0001 × 0009 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [998.0] <CHARACTER TABULATION> (Sp) ÷ [0.3]');
    Test_SB('÷ 0001 × 0308 × 0009 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <CHARACTER TABULATION> (Sp) ÷ [0.3]');
    Test_SB('÷ 0001 × 0061 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [998.0] LATIN SMALL LETTER A (Lower) ÷ [0.3]');
    Test_SB('÷ 0001 × 0308 × 0061 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN SMALL LETTER A (Lower) ÷ [0.3]');
    Test_SB('÷ 0001 × 0041 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [998.0] LATIN CAPITAL LETTER A (Upper) ÷ [0.3]');
    Test_SB('÷ 0001 × 0308 × 0041 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN CAPITAL LETTER A (Upper) ÷ [0.3]');
    Test_SB('÷ 0001 × 01BB ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [998.0] LATIN LETTER TWO WITH STROKE (OLetter) ÷ [0.3]');
    Test_SB('÷ 0001 × 0308 × 01BB ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN LETTER TWO WITH STROKE (OLetter) ÷ [0.3]');
    Test_SB('÷ 0001 × 0030 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [998.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_SB('÷ 0001 × 0308 × 0030 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_SB('÷ 0001 × 002E ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [998.0] FULL STOP (ATerm) ÷ [0.3]');
    Test_SB('÷ 0001 × 0308 × 002E ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] FULL STOP (ATerm) ÷ [0.3]');
    Test_SB('÷ 0001 × 0021 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [998.0] EXCLAMATION MARK (STerm) ÷ [0.3]');
    Test_SB('÷ 0001 × 0308 × 0021 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] EXCLAMATION MARK (STerm) ÷ [0.3]');
    Test_SB('÷ 0001 × 0022 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [998.0] QUOTATION MARK (Close) ÷ [0.3]');
    Test_SB('÷ 0001 × 0308 × 0022 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] QUOTATION MARK (Close) ÷ [0.3]');
    Test_SB('÷ 0001 × 002C ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [998.0] COMMA (SContinue) ÷ [0.3]');
    Test_SB('÷ 0001 × 0308 × 002C ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] COMMA (SContinue) ÷ [0.3]');
    Test_SB('÷ 0001 × 00AD ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [5.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_SB('÷ 0001 × 0308 × 00AD ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [5.0] COMBINING DIAERESIS (Extend_FE) × [5.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_SB('÷ 0001 × 0300 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [5.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_SB('÷ 0001 × 0308 × 0300 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [5.0] COMBINING DIAERESIS (Extend_FE) × [5.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_SB('÷ 000D ÷ 0001 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_SB('÷ 000D ÷ 0308 × 0001 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_SB('÷ 000D ÷ 000D ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_SB('÷ 000D ÷ 0308 × 000D ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_SB('÷ 000D × 000A ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) × [3.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_SB('÷ 000D ÷ 0308 × 000A ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_SB('÷ 000D ÷ 0085 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] <NEXT LINE (NEL)> (Sep) ÷ [0.3]');
    Test_SB('÷ 000D ÷ 0308 × 0085 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <NEXT LINE (NEL)> (Sep) ÷ [0.3]');
    Test_SB('÷ 000D ÷ 0009 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] <CHARACTER TABULATION> (Sp) ÷ [0.3]');
    Test_SB('÷ 000D ÷ 0308 × 0009 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <CHARACTER TABULATION> (Sp) ÷ [0.3]');
    Test_SB('÷ 000D ÷ 0061 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] LATIN SMALL LETTER A (Lower) ÷ [0.3]');
    Test_SB('÷ 000D ÷ 0308 × 0061 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN SMALL LETTER A (Lower) ÷ [0.3]');
    Test_SB('÷ 000D ÷ 0041 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] LATIN CAPITAL LETTER A (Upper) ÷ [0.3]');
    Test_SB('÷ 000D ÷ 0308 × 0041 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN CAPITAL LETTER A (Upper) ÷ [0.3]');
    Test_SB('÷ 000D ÷ 01BB ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] LATIN LETTER TWO WITH STROKE (OLetter) ÷ [0.3]');
    Test_SB('÷ 000D ÷ 0308 × 01BB ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN LETTER TWO WITH STROKE (OLetter) ÷ [0.3]');
    Test_SB('÷ 000D ÷ 0030 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_SB('÷ 000D ÷ 0308 × 0030 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_SB('÷ 000D ÷ 002E ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] FULL STOP (ATerm) ÷ [0.3]');
    Test_SB('÷ 000D ÷ 0308 × 002E ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] FULL STOP (ATerm) ÷ [0.3]');
    Test_SB('÷ 000D ÷ 0021 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] EXCLAMATION MARK (STerm) ÷ [0.3]');
    Test_SB('÷ 000D ÷ 0308 × 0021 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] EXCLAMATION MARK (STerm) ÷ [0.3]');
    Test_SB('÷ 000D ÷ 0022 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] QUOTATION MARK (Close) ÷ [0.3]');
    Test_SB('÷ 000D ÷ 0308 × 0022 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] QUOTATION MARK (Close) ÷ [0.3]');
    Test_SB('÷ 000D ÷ 002C ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMMA (SContinue) ÷ [0.3]');
    Test_SB('÷ 000D ÷ 0308 × 002C ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] COMMA (SContinue) ÷ [0.3]');
    Test_SB('÷ 000D ÷ 00AD ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_SB('÷ 000D ÷ 0308 × 00AD ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [5.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_SB('÷ 000D ÷ 0300 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_SB('÷ 000D ÷ 0308 × 0300 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [5.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_SB('÷ 000A ÷ 0001 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_SB('÷ 000A ÷ 0308 × 0001 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_SB('÷ 000A ÷ 000D ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_SB('÷ 000A ÷ 0308 × 000D ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_SB('÷ 000A ÷ 000A ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_SB('÷ 000A ÷ 0308 × 000A ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_SB('÷ 000A ÷ 0085 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] <NEXT LINE (NEL)> (Sep) ÷ [0.3]');
    Test_SB('÷ 000A ÷ 0308 × 0085 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <NEXT LINE (NEL)> (Sep) ÷ [0.3]');
    Test_SB('÷ 000A ÷ 0009 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] <CHARACTER TABULATION> (Sp) ÷ [0.3]');
    Test_SB('÷ 000A ÷ 0308 × 0009 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <CHARACTER TABULATION> (Sp) ÷ [0.3]');
    Test_SB('÷ 000A ÷ 0061 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] LATIN SMALL LETTER A (Lower) ÷ [0.3]');
    Test_SB('÷ 000A ÷ 0308 × 0061 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN SMALL LETTER A (Lower) ÷ [0.3]');
    Test_SB('÷ 000A ÷ 0041 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] LATIN CAPITAL LETTER A (Upper) ÷ [0.3]');
    Test_SB('÷ 000A ÷ 0308 × 0041 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN CAPITAL LETTER A (Upper) ÷ [0.3]');
    Test_SB('÷ 000A ÷ 01BB ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] LATIN LETTER TWO WITH STROKE (OLetter) ÷ [0.3]');
    Test_SB('÷ 000A ÷ 0308 × 01BB ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN LETTER TWO WITH STROKE (OLetter) ÷ [0.3]');
    Test_SB('÷ 000A ÷ 0030 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_SB('÷ 000A ÷ 0308 × 0030 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_SB('÷ 000A ÷ 002E ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] FULL STOP (ATerm) ÷ [0.3]');
    Test_SB('÷ 000A ÷ 0308 × 002E ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] FULL STOP (ATerm) ÷ [0.3]');
    Test_SB('÷ 000A ÷ 0021 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] EXCLAMATION MARK (STerm) ÷ [0.3]');
    Test_SB('÷ 000A ÷ 0308 × 0021 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] EXCLAMATION MARK (STerm) ÷ [0.3]');
    Test_SB('÷ 000A ÷ 0022 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] QUOTATION MARK (Close) ÷ [0.3]');
    Test_SB('÷ 000A ÷ 0308 × 0022 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] QUOTATION MARK (Close) ÷ [0.3]');
    Test_SB('÷ 000A ÷ 002C ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMMA (SContinue) ÷ [0.3]');
    Test_SB('÷ 000A ÷ 0308 × 002C ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] COMMA (SContinue) ÷ [0.3]');
    Test_SB('÷ 000A ÷ 00AD ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_SB('÷ 000A ÷ 0308 × 00AD ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [5.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_SB('÷ 000A ÷ 0300 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_SB('÷ 000A ÷ 0308 × 0300 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [5.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_SB('÷ 0085 ÷ 0001 ÷	#  ÷ [0.2] <NEXT LINE (NEL)> (Sep) ÷ [4.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_SB('÷ 0085 ÷ 0308 × 0001 ÷	#  ÷ [0.2] <NEXT LINE (NEL)> (Sep) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_SB('÷ 0085 ÷ 000D ÷	#  ÷ [0.2] <NEXT LINE (NEL)> (Sep) ÷ [4.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_SB('÷ 0085 ÷ 0308 × 000D ÷	#  ÷ [0.2] <NEXT LINE (NEL)> (Sep) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_SB('÷ 0085 ÷ 000A ÷	#  ÷ [0.2] <NEXT LINE (NEL)> (Sep) ÷ [4.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_SB('÷ 0085 ÷ 0308 × 000A ÷	#  ÷ [0.2] <NEXT LINE (NEL)> (Sep) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_SB('÷ 0085 ÷ 0085 ÷	#  ÷ [0.2] <NEXT LINE (NEL)> (Sep) ÷ [4.0] <NEXT LINE (NEL)> (Sep) ÷ [0.3]');
    Test_SB('÷ 0085 ÷ 0308 × 0085 ÷	#  ÷ [0.2] <NEXT LINE (NEL)> (Sep) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <NEXT LINE (NEL)> (Sep) ÷ [0.3]');
    Test_SB('÷ 0085 ÷ 0009 ÷	#  ÷ [0.2] <NEXT LINE (NEL)> (Sep) ÷ [4.0] <CHARACTER TABULATION> (Sp) ÷ [0.3]');
    Test_SB('÷ 0085 ÷ 0308 × 0009 ÷	#  ÷ [0.2] <NEXT LINE (NEL)> (Sep) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <CHARACTER TABULATION> (Sp) ÷ [0.3]');
    Test_SB('÷ 0085 ÷ 0061 ÷	#  ÷ [0.2] <NEXT LINE (NEL)> (Sep) ÷ [4.0] LATIN SMALL LETTER A (Lower) ÷ [0.3]');
    Test_SB('÷ 0085 ÷ 0308 × 0061 ÷	#  ÷ [0.2] <NEXT LINE (NEL)> (Sep) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN SMALL LETTER A (Lower) ÷ [0.3]');
    Test_SB('÷ 0085 ÷ 0041 ÷	#  ÷ [0.2] <NEXT LINE (NEL)> (Sep) ÷ [4.0] LATIN CAPITAL LETTER A (Upper) ÷ [0.3]');
    Test_SB('÷ 0085 ÷ 0308 × 0041 ÷	#  ÷ [0.2] <NEXT LINE (NEL)> (Sep) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN CAPITAL LETTER A (Upper) ÷ [0.3]');
    Test_SB('÷ 0085 ÷ 01BB ÷	#  ÷ [0.2] <NEXT LINE (NEL)> (Sep) ÷ [4.0] LATIN LETTER TWO WITH STROKE (OLetter) ÷ [0.3]');
    Test_SB('÷ 0085 ÷ 0308 × 01BB ÷	#  ÷ [0.2] <NEXT LINE (NEL)> (Sep) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN LETTER TWO WITH STROKE (OLetter) ÷ [0.3]');
    Test_SB('÷ 0085 ÷ 0030 ÷	#  ÷ [0.2] <NEXT LINE (NEL)> (Sep) ÷ [4.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_SB('÷ 0085 ÷ 0308 × 0030 ÷	#  ÷ [0.2] <NEXT LINE (NEL)> (Sep) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_SB('÷ 0085 ÷ 002E ÷	#  ÷ [0.2] <NEXT LINE (NEL)> (Sep) ÷ [4.0] FULL STOP (ATerm) ÷ [0.3]');
    Test_SB('÷ 0085 ÷ 0308 × 002E ÷	#  ÷ [0.2] <NEXT LINE (NEL)> (Sep) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] FULL STOP (ATerm) ÷ [0.3]');
    Test_SB('÷ 0085 ÷ 0021 ÷	#  ÷ [0.2] <NEXT LINE (NEL)> (Sep) ÷ [4.0] EXCLAMATION MARK (STerm) ÷ [0.3]');
    Test_SB('÷ 0085 ÷ 0308 × 0021 ÷	#  ÷ [0.2] <NEXT LINE (NEL)> (Sep) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] EXCLAMATION MARK (STerm) ÷ [0.3]');
    Test_SB('÷ 0085 ÷ 0022 ÷	#  ÷ [0.2] <NEXT LINE (NEL)> (Sep) ÷ [4.0] QUOTATION MARK (Close) ÷ [0.3]');
    Test_SB('÷ 0085 ÷ 0308 × 0022 ÷	#  ÷ [0.2] <NEXT LINE (NEL)> (Sep) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] QUOTATION MARK (Close) ÷ [0.3]');
    Test_SB('÷ 0085 ÷ 002C ÷	#  ÷ [0.2] <NEXT LINE (NEL)> (Sep) ÷ [4.0] COMMA (SContinue) ÷ [0.3]');
    Test_SB('÷ 0085 ÷ 0308 × 002C ÷	#  ÷ [0.2] <NEXT LINE (NEL)> (Sep) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] COMMA (SContinue) ÷ [0.3]');
    Test_SB('÷ 0085 ÷ 00AD ÷	#  ÷ [0.2] <NEXT LINE (NEL)> (Sep) ÷ [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_SB('÷ 0085 ÷ 0308 × 00AD ÷	#  ÷ [0.2] <NEXT LINE (NEL)> (Sep) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [5.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_SB('÷ 0085 ÷ 0300 ÷	#  ÷ [0.2] <NEXT LINE (NEL)> (Sep) ÷ [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_SB('÷ 0085 ÷ 0308 × 0300 ÷	#  ÷ [0.2] <NEXT LINE (NEL)> (Sep) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [5.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_SB('÷ 0009 × 0001 ÷	#  ÷ [0.2] <CHARACTER TABULATION> (Sp) × [998.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_SB('÷ 0009 × 0308 × 0001 ÷	#  ÷ [0.2] <CHARACTER TABULATION> (Sp) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_SB('÷ 0009 × 000D ÷	#  ÷ [0.2] <CHARACTER TABULATION> (Sp) × [998.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_SB('÷ 0009 × 0308 × 000D ÷	#  ÷ [0.2] <CHARACTER TABULATION> (Sp) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_SB('÷ 0009 × 000A ÷	#  ÷ [0.2] <CHARACTER TABULATION> (Sp) × [998.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_SB('÷ 0009 × 0308 × 000A ÷	#  ÷ [0.2] <CHARACTER TABULATION> (Sp) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_SB('÷ 0009 × 0085 ÷	#  ÷ [0.2] <CHARACTER TABULATION> (Sp) × [998.0] <NEXT LINE (NEL)> (Sep) ÷ [0.3]');
    Test_SB('÷ 0009 × 0308 × 0085 ÷	#  ÷ [0.2] <CHARACTER TABULATION> (Sp) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <NEXT LINE (NEL)> (Sep) ÷ [0.3]');
    Test_SB('÷ 0009 × 0009 ÷	#  ÷ [0.2] <CHARACTER TABULATION> (Sp) × [998.0] <CHARACTER TABULATION> (Sp) ÷ [0.3]');
    Test_SB('÷ 0009 × 0308 × 0009 ÷	#  ÷ [0.2] <CHARACTER TABULATION> (Sp) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <CHARACTER TABULATION> (Sp) ÷ [0.3]');
    Test_SB('÷ 0009 × 0061 ÷	#  ÷ [0.2] <CHARACTER TABULATION> (Sp) × [998.0] LATIN SMALL LETTER A (Lower) ÷ [0.3]');
    Test_SB('÷ 0009 × 0308 × 0061 ÷	#  ÷ [0.2] <CHARACTER TABULATION> (Sp) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN SMALL LETTER A (Lower) ÷ [0.3]');
    Test_SB('÷ 0009 × 0041 ÷	#  ÷ [0.2] <CHARACTER TABULATION> (Sp) × [998.0] LATIN CAPITAL LETTER A (Upper) ÷ [0.3]');
    Test_SB('÷ 0009 × 0308 × 0041 ÷	#  ÷ [0.2] <CHARACTER TABULATION> (Sp) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN CAPITAL LETTER A (Upper) ÷ [0.3]');
    Test_SB('÷ 0009 × 01BB ÷	#  ÷ [0.2] <CHARACTER TABULATION> (Sp) × [998.0] LATIN LETTER TWO WITH STROKE (OLetter) ÷ [0.3]');
    Test_SB('÷ 0009 × 0308 × 01BB ÷	#  ÷ [0.2] <CHARACTER TABULATION> (Sp) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN LETTER TWO WITH STROKE (OLetter) ÷ [0.3]');
    Test_SB('÷ 0009 × 0030 ÷	#  ÷ [0.2] <CHARACTER TABULATION> (Sp) × [998.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_SB('÷ 0009 × 0308 × 0030 ÷	#  ÷ [0.2] <CHARACTER TABULATION> (Sp) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_SB('÷ 0009 × 002E ÷	#  ÷ [0.2] <CHARACTER TABULATION> (Sp) × [998.0] FULL STOP (ATerm) ÷ [0.3]');
    Test_SB('÷ 0009 × 0308 × 002E ÷	#  ÷ [0.2] <CHARACTER TABULATION> (Sp) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] FULL STOP (ATerm) ÷ [0.3]');
    Test_SB('÷ 0009 × 0021 ÷	#  ÷ [0.2] <CHARACTER TABULATION> (Sp) × [998.0] EXCLAMATION MARK (STerm) ÷ [0.3]');
    Test_SB('÷ 0009 × 0308 × 0021 ÷	#  ÷ [0.2] <CHARACTER TABULATION> (Sp) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] EXCLAMATION MARK (STerm) ÷ [0.3]');
    Test_SB('÷ 0009 × 0022 ÷	#  ÷ [0.2] <CHARACTER TABULATION> (Sp) × [998.0] QUOTATION MARK (Close) ÷ [0.3]');
    Test_SB('÷ 0009 × 0308 × 0022 ÷	#  ÷ [0.2] <CHARACTER TABULATION> (Sp) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] QUOTATION MARK (Close) ÷ [0.3]');
    Test_SB('÷ 0009 × 002C ÷	#  ÷ [0.2] <CHARACTER TABULATION> (Sp) × [998.0] COMMA (SContinue) ÷ [0.3]');
    Test_SB('÷ 0009 × 0308 × 002C ÷	#  ÷ [0.2] <CHARACTER TABULATION> (Sp) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] COMMA (SContinue) ÷ [0.3]');
    Test_SB('÷ 0009 × 00AD ÷	#  ÷ [0.2] <CHARACTER TABULATION> (Sp) × [5.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_SB('÷ 0009 × 0308 × 00AD ÷	#  ÷ [0.2] <CHARACTER TABULATION> (Sp) × [5.0] COMBINING DIAERESIS (Extend_FE) × [5.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_SB('÷ 0009 × 0300 ÷	#  ÷ [0.2] <CHARACTER TABULATION> (Sp) × [5.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_SB('÷ 0009 × 0308 × 0300 ÷	#  ÷ [0.2] <CHARACTER TABULATION> (Sp) × [5.0] COMBINING DIAERESIS (Extend_FE) × [5.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_SB('÷ 0061 × 0001 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Lower) × [998.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_SB('÷ 0061 × 0308 × 0001 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Lower) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_SB('÷ 0061 × 000D ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Lower) × [998.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_SB('÷ 0061 × 0308 × 000D ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Lower) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_SB('÷ 0061 × 000A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Lower) × [998.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_SB('÷ 0061 × 0308 × 000A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Lower) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_SB('÷ 0061 × 0085 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Lower) × [998.0] <NEXT LINE (NEL)> (Sep) ÷ [0.3]');
    Test_SB('÷ 0061 × 0308 × 0085 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Lower) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <NEXT LINE (NEL)> (Sep) ÷ [0.3]');
    Test_SB('÷ 0061 × 0009 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Lower) × [998.0] <CHARACTER TABULATION> (Sp) ÷ [0.3]');
    Test_SB('÷ 0061 × 0308 × 0009 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Lower) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <CHARACTER TABULATION> (Sp) ÷ [0.3]');
    Test_SB('÷ 0061 × 0061 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Lower) × [998.0] LATIN SMALL LETTER A (Lower) ÷ [0.3]');
    Test_SB('÷ 0061 × 0308 × 0061 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Lower) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN SMALL LETTER A (Lower) ÷ [0.3]');
    Test_SB('÷ 0061 × 0041 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Lower) × [998.0] LATIN CAPITAL LETTER A (Upper) ÷ [0.3]');
    Test_SB('÷ 0061 × 0308 × 0041 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Lower) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN CAPITAL LETTER A (Upper) ÷ [0.3]');
    Test_SB('÷ 0061 × 01BB ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Lower) × [998.0] LATIN LETTER TWO WITH STROKE (OLetter) ÷ [0.3]');
    Test_SB('÷ 0061 × 0308 × 01BB ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Lower) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN LETTER TWO WITH STROKE (OLetter) ÷ [0.3]');
    Test_SB('÷ 0061 × 0030 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Lower) × [998.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_SB('÷ 0061 × 0308 × 0030 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Lower) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_SB('÷ 0061 × 002E ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Lower) × [998.0] FULL STOP (ATerm) ÷ [0.3]');
    Test_SB('÷ 0061 × 0308 × 002E ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Lower) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] FULL STOP (ATerm) ÷ [0.3]');
    Test_SB('÷ 0061 × 0021 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Lower) × [998.0] EXCLAMATION MARK (STerm) ÷ [0.3]');
    Test_SB('÷ 0061 × 0308 × 0021 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Lower) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] EXCLAMATION MARK (STerm) ÷ [0.3]');
    Test_SB('÷ 0061 × 0022 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Lower) × [998.0] QUOTATION MARK (Close) ÷ [0.3]');
    Test_SB('÷ 0061 × 0308 × 0022 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Lower) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] QUOTATION MARK (Close) ÷ [0.3]');
    Test_SB('÷ 0061 × 002C ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Lower) × [998.0] COMMA (SContinue) ÷ [0.3]');
    Test_SB('÷ 0061 × 0308 × 002C ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Lower) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] COMMA (SContinue) ÷ [0.3]');
    Test_SB('÷ 0061 × 00AD ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Lower) × [5.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_SB('÷ 0061 × 0308 × 00AD ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Lower) × [5.0] COMBINING DIAERESIS (Extend_FE) × [5.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_SB('÷ 0061 × 0300 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Lower) × [5.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_SB('÷ 0061 × 0308 × 0300 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Lower) × [5.0] COMBINING DIAERESIS (Extend_FE) × [5.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_SB('÷ 0041 × 0001 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (Upper) × [998.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_SB('÷ 0041 × 0308 × 0001 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (Upper) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_SB('÷ 0041 × 000D ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (Upper) × [998.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_SB('÷ 0041 × 0308 × 000D ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (Upper) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_SB('÷ 0041 × 000A ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (Upper) × [998.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_SB('÷ 0041 × 0308 × 000A ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (Upper) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_SB('÷ 0041 × 0085 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (Upper) × [998.0] <NEXT LINE (NEL)> (Sep) ÷ [0.3]');
    Test_SB('÷ 0041 × 0308 × 0085 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (Upper) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <NEXT LINE (NEL)> (Sep) ÷ [0.3]');
    Test_SB('÷ 0041 × 0009 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (Upper) × [998.0] <CHARACTER TABULATION> (Sp) ÷ [0.3]');
    Test_SB('÷ 0041 × 0308 × 0009 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (Upper) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <CHARACTER TABULATION> (Sp) ÷ [0.3]');
    Test_SB('÷ 0041 × 0061 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (Upper) × [998.0] LATIN SMALL LETTER A (Lower) ÷ [0.3]');
    Test_SB('÷ 0041 × 0308 × 0061 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (Upper) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN SMALL LETTER A (Lower) ÷ [0.3]');
    Test_SB('÷ 0041 × 0041 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (Upper) × [998.0] LATIN CAPITAL LETTER A (Upper) ÷ [0.3]');
    Test_SB('÷ 0041 × 0308 × 0041 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (Upper) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN CAPITAL LETTER A (Upper) ÷ [0.3]');
    Test_SB('÷ 0041 × 01BB ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (Upper) × [998.0] LATIN LETTER TWO WITH STROKE (OLetter) ÷ [0.3]');
    Test_SB('÷ 0041 × 0308 × 01BB ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (Upper) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN LETTER TWO WITH STROKE (OLetter) ÷ [0.3]');
    Test_SB('÷ 0041 × 0030 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (Upper) × [998.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_SB('÷ 0041 × 0308 × 0030 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (Upper) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_SB('÷ 0041 × 002E ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (Upper) × [998.0] FULL STOP (ATerm) ÷ [0.3]');
    Test_SB('÷ 0041 × 0308 × 002E ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (Upper) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] FULL STOP (ATerm) ÷ [0.3]');
    Test_SB('÷ 0041 × 0021 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (Upper) × [998.0] EXCLAMATION MARK (STerm) ÷ [0.3]');
    Test_SB('÷ 0041 × 0308 × 0021 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (Upper) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] EXCLAMATION MARK (STerm) ÷ [0.3]');
    Test_SB('÷ 0041 × 0022 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (Upper) × [998.0] QUOTATION MARK (Close) ÷ [0.3]');
    Test_SB('÷ 0041 × 0308 × 0022 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (Upper) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] QUOTATION MARK (Close) ÷ [0.3]');
    Test_SB('÷ 0041 × 002C ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (Upper) × [998.0] COMMA (SContinue) ÷ [0.3]');
    Test_SB('÷ 0041 × 0308 × 002C ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (Upper) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] COMMA (SContinue) ÷ [0.3]');
    Test_SB('÷ 0041 × 00AD ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (Upper) × [5.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_SB('÷ 0041 × 0308 × 00AD ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (Upper) × [5.0] COMBINING DIAERESIS (Extend_FE) × [5.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_SB('÷ 0041 × 0300 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (Upper) × [5.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_SB('÷ 0041 × 0308 × 0300 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (Upper) × [5.0] COMBINING DIAERESIS (Extend_FE) × [5.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_SB('÷ 01BB × 0001 ÷	#  ÷ [0.2] LATIN LETTER TWO WITH STROKE (OLetter) × [998.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_SB('÷ 01BB × 0308 × 0001 ÷	#  ÷ [0.2] LATIN LETTER TWO WITH STROKE (OLetter) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_SB('÷ 01BB × 000D ÷	#  ÷ [0.2] LATIN LETTER TWO WITH STROKE (OLetter) × [998.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_SB('÷ 01BB × 0308 × 000D ÷	#  ÷ [0.2] LATIN LETTER TWO WITH STROKE (OLetter) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_SB('÷ 01BB × 000A ÷	#  ÷ [0.2] LATIN LETTER TWO WITH STROKE (OLetter) × [998.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_SB('÷ 01BB × 0308 × 000A ÷	#  ÷ [0.2] LATIN LETTER TWO WITH STROKE (OLetter) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_SB('÷ 01BB × 0085 ÷	#  ÷ [0.2] LATIN LETTER TWO WITH STROKE (OLetter) × [998.0] <NEXT LINE (NEL)> (Sep) ÷ [0.3]');
    Test_SB('÷ 01BB × 0308 × 0085 ÷	#  ÷ [0.2] LATIN LETTER TWO WITH STROKE (OLetter) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <NEXT LINE (NEL)> (Sep) ÷ [0.3]');
    Test_SB('÷ 01BB × 0009 ÷	#  ÷ [0.2] LATIN LETTER TWO WITH STROKE (OLetter) × [998.0] <CHARACTER TABULATION> (Sp) ÷ [0.3]');
    Test_SB('÷ 01BB × 0308 × 0009 ÷	#  ÷ [0.2] LATIN LETTER TWO WITH STROKE (OLetter) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <CHARACTER TABULATION> (Sp) ÷ [0.3]');
    Test_SB('÷ 01BB × 0061 ÷	#  ÷ [0.2] LATIN LETTER TWO WITH STROKE (OLetter) × [998.0] LATIN SMALL LETTER A (Lower) ÷ [0.3]');
    Test_SB('÷ 01BB × 0308 × 0061 ÷	#  ÷ [0.2] LATIN LETTER TWO WITH STROKE (OLetter) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN SMALL LETTER A (Lower) ÷ [0.3]');
    Test_SB('÷ 01BB × 0041 ÷	#  ÷ [0.2] LATIN LETTER TWO WITH STROKE (OLetter) × [998.0] LATIN CAPITAL LETTER A (Upper) ÷ [0.3]');
    Test_SB('÷ 01BB × 0308 × 0041 ÷	#  ÷ [0.2] LATIN LETTER TWO WITH STROKE (OLetter) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN CAPITAL LETTER A (Upper) ÷ [0.3]');
    Test_SB('÷ 01BB × 01BB ÷	#  ÷ [0.2] LATIN LETTER TWO WITH STROKE (OLetter) × [998.0] LATIN LETTER TWO WITH STROKE (OLetter) ÷ [0.3]');
    Test_SB('÷ 01BB × 0308 × 01BB ÷	#  ÷ [0.2] LATIN LETTER TWO WITH STROKE (OLetter) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN LETTER TWO WITH STROKE (OLetter) ÷ [0.3]');
    Test_SB('÷ 01BB × 0030 ÷	#  ÷ [0.2] LATIN LETTER TWO WITH STROKE (OLetter) × [998.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_SB('÷ 01BB × 0308 × 0030 ÷	#  ÷ [0.2] LATIN LETTER TWO WITH STROKE (OLetter) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_SB('÷ 01BB × 002E ÷	#  ÷ [0.2] LATIN LETTER TWO WITH STROKE (OLetter) × [998.0] FULL STOP (ATerm) ÷ [0.3]');
    Test_SB('÷ 01BB × 0308 × 002E ÷	#  ÷ [0.2] LATIN LETTER TWO WITH STROKE (OLetter) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] FULL STOP (ATerm) ÷ [0.3]');
    Test_SB('÷ 01BB × 0021 ÷	#  ÷ [0.2] LATIN LETTER TWO WITH STROKE (OLetter) × [998.0] EXCLAMATION MARK (STerm) ÷ [0.3]');
    Test_SB('÷ 01BB × 0308 × 0021 ÷	#  ÷ [0.2] LATIN LETTER TWO WITH STROKE (OLetter) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] EXCLAMATION MARK (STerm) ÷ [0.3]');
    Test_SB('÷ 01BB × 0022 ÷	#  ÷ [0.2] LATIN LETTER TWO WITH STROKE (OLetter) × [998.0] QUOTATION MARK (Close) ÷ [0.3]');
    Test_SB('÷ 01BB × 0308 × 0022 ÷	#  ÷ [0.2] LATIN LETTER TWO WITH STROKE (OLetter) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] QUOTATION MARK (Close) ÷ [0.3]');
    Test_SB('÷ 01BB × 002C ÷	#  ÷ [0.2] LATIN LETTER TWO WITH STROKE (OLetter) × [998.0] COMMA (SContinue) ÷ [0.3]');
    Test_SB('÷ 01BB × 0308 × 002C ÷	#  ÷ [0.2] LATIN LETTER TWO WITH STROKE (OLetter) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] COMMA (SContinue) ÷ [0.3]');
    Test_SB('÷ 01BB × 00AD ÷	#  ÷ [0.2] LATIN LETTER TWO WITH STROKE (OLetter) × [5.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_SB('÷ 01BB × 0308 × 00AD ÷	#  ÷ [0.2] LATIN LETTER TWO WITH STROKE (OLetter) × [5.0] COMBINING DIAERESIS (Extend_FE) × [5.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_SB('÷ 01BB × 0300 ÷	#  ÷ [0.2] LATIN LETTER TWO WITH STROKE (OLetter) × [5.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_SB('÷ 01BB × 0308 × 0300 ÷	#  ÷ [0.2] LATIN LETTER TWO WITH STROKE (OLetter) × [5.0] COMBINING DIAERESIS (Extend_FE) × [5.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_SB('÷ 0030 × 0001 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [998.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_SB('÷ 0030 × 0308 × 0001 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_SB('÷ 0030 × 000D ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [998.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_SB('÷ 0030 × 0308 × 000D ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_SB('÷ 0030 × 000A ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [998.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_SB('÷ 0030 × 0308 × 000A ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_SB('÷ 0030 × 0085 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [998.0] <NEXT LINE (NEL)> (Sep) ÷ [0.3]');
    Test_SB('÷ 0030 × 0308 × 0085 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <NEXT LINE (NEL)> (Sep) ÷ [0.3]');
    Test_SB('÷ 0030 × 0009 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [998.0] <CHARACTER TABULATION> (Sp) ÷ [0.3]');
    Test_SB('÷ 0030 × 0308 × 0009 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <CHARACTER TABULATION> (Sp) ÷ [0.3]');
    Test_SB('÷ 0030 × 0061 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [998.0] LATIN SMALL LETTER A (Lower) ÷ [0.3]');
    Test_SB('÷ 0030 × 0308 × 0061 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN SMALL LETTER A (Lower) ÷ [0.3]');
    Test_SB('÷ 0030 × 0041 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [998.0] LATIN CAPITAL LETTER A (Upper) ÷ [0.3]');
    Test_SB('÷ 0030 × 0308 × 0041 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN CAPITAL LETTER A (Upper) ÷ [0.3]');
    Test_SB('÷ 0030 × 01BB ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [998.0] LATIN LETTER TWO WITH STROKE (OLetter) ÷ [0.3]');
    Test_SB('÷ 0030 × 0308 × 01BB ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN LETTER TWO WITH STROKE (OLetter) ÷ [0.3]');
    Test_SB('÷ 0030 × 0030 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [998.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_SB('÷ 0030 × 0308 × 0030 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_SB('÷ 0030 × 002E ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [998.0] FULL STOP (ATerm) ÷ [0.3]');
    Test_SB('÷ 0030 × 0308 × 002E ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] FULL STOP (ATerm) ÷ [0.3]');
    Test_SB('÷ 0030 × 0021 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [998.0] EXCLAMATION MARK (STerm) ÷ [0.3]');
    Test_SB('÷ 0030 × 0308 × 0021 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] EXCLAMATION MARK (STerm) ÷ [0.3]');
    Test_SB('÷ 0030 × 0022 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [998.0] QUOTATION MARK (Close) ÷ [0.3]');
    Test_SB('÷ 0030 × 0308 × 0022 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] QUOTATION MARK (Close) ÷ [0.3]');
    Test_SB('÷ 0030 × 002C ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [998.0] COMMA (SContinue) ÷ [0.3]');
    Test_SB('÷ 0030 × 0308 × 002C ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] COMMA (SContinue) ÷ [0.3]');
    Test_SB('÷ 0030 × 00AD ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [5.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_SB('÷ 0030 × 0308 × 00AD ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [5.0] COMBINING DIAERESIS (Extend_FE) × [5.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_SB('÷ 0030 × 0300 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [5.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_SB('÷ 0030 × 0308 × 0300 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [5.0] COMBINING DIAERESIS (Extend_FE) × [5.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_SB('÷ 002E ÷ 0001 ÷	#  ÷ [0.2] FULL STOP (ATerm) ÷ [11.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_SB('÷ 002E × 0308 ÷ 0001 ÷	#  ÷ [0.2] FULL STOP (ATerm) × [5.0] COMBINING DIAERESIS (Extend_FE) ÷ [11.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_SB('÷ 002E × 000D ÷	#  ÷ [0.2] FULL STOP (ATerm) × [9.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_SB('÷ 002E × 0308 × 000D ÷	#  ÷ [0.2] FULL STOP (ATerm) × [5.0] COMBINING DIAERESIS (Extend_FE) × [9.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_SB('÷ 002E × 000A ÷	#  ÷ [0.2] FULL STOP (ATerm) × [9.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_SB('÷ 002E × 0308 × 000A ÷	#  ÷ [0.2] FULL STOP (ATerm) × [5.0] COMBINING DIAERESIS (Extend_FE) × [9.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_SB('÷ 002E × 0085 ÷	#  ÷ [0.2] FULL STOP (ATerm) × [9.0] <NEXT LINE (NEL)> (Sep) ÷ [0.3]');
    Test_SB('÷ 002E × 0308 × 0085 ÷	#  ÷ [0.2] FULL STOP (ATerm) × [5.0] COMBINING DIAERESIS (Extend_FE) × [9.0] <NEXT LINE (NEL)> (Sep) ÷ [0.3]');
    Test_SB('÷ 002E × 0009 ÷	#  ÷ [0.2] FULL STOP (ATerm) × [9.0] <CHARACTER TABULATION> (Sp) ÷ [0.3]');
    Test_SB('÷ 002E × 0308 × 0009 ÷	#  ÷ [0.2] FULL STOP (ATerm) × [5.0] COMBINING DIAERESIS (Extend_FE) × [9.0] <CHARACTER TABULATION> (Sp) ÷ [0.3]');
    Test_SB('÷ 002E × 0061 ÷	#  ÷ [0.2] FULL STOP (ATerm) × [8.0] LATIN SMALL LETTER A (Lower) ÷ [0.3]');
    Test_SB('÷ 002E × 0308 × 0061 ÷	#  ÷ [0.2] FULL STOP (ATerm) × [5.0] COMBINING DIAERESIS (Extend_FE) × [8.0] LATIN SMALL LETTER A (Lower) ÷ [0.3]');
    Test_SB('÷ 002E ÷ 0041 ÷	#  ÷ [0.2] FULL STOP (ATerm) ÷ [11.0] LATIN CAPITAL LETTER A (Upper) ÷ [0.3]');
    Test_SB('÷ 002E × 0308 ÷ 0041 ÷	#  ÷ [0.2] FULL STOP (ATerm) × [5.0] COMBINING DIAERESIS (Extend_FE) ÷ [11.0] LATIN CAPITAL LETTER A (Upper) ÷ [0.3]');
    Test_SB('÷ 002E ÷ 01BB ÷	#  ÷ [0.2] FULL STOP (ATerm) ÷ [11.0] LATIN LETTER TWO WITH STROKE (OLetter) ÷ [0.3]');
    Test_SB('÷ 002E × 0308 ÷ 01BB ÷	#  ÷ [0.2] FULL STOP (ATerm) × [5.0] COMBINING DIAERESIS (Extend_FE) ÷ [11.0] LATIN LETTER TWO WITH STROKE (OLetter) ÷ [0.3]');
    Test_SB('÷ 002E × 0030 ÷	#  ÷ [0.2] FULL STOP (ATerm) × [6.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_SB('÷ 002E × 0308 × 0030 ÷	#  ÷ [0.2] FULL STOP (ATerm) × [5.0] COMBINING DIAERESIS (Extend_FE) × [6.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_SB('÷ 002E × 002E ÷	#  ÷ [0.2] FULL STOP (ATerm) × [8.1] FULL STOP (ATerm) ÷ [0.3]');
    Test_SB('÷ 002E × 0308 × 002E ÷	#  ÷ [0.2] FULL STOP (ATerm) × [5.0] COMBINING DIAERESIS (Extend_FE) × [8.1] FULL STOP (ATerm) ÷ [0.3]');
    Test_SB('÷ 002E × 0021 ÷	#  ÷ [0.2] FULL STOP (ATerm) × [8.1] EXCLAMATION MARK (STerm) ÷ [0.3]');
    Test_SB('÷ 002E × 0308 × 0021 ÷	#  ÷ [0.2] FULL STOP (ATerm) × [5.0] COMBINING DIAERESIS (Extend_FE) × [8.1] EXCLAMATION MARK (STerm) ÷ [0.3]');
    Test_SB('÷ 002E × 0022 ÷	#  ÷ [0.2] FULL STOP (ATerm) × [9.0] QUOTATION MARK (Close) ÷ [0.3]');
    Test_SB('÷ 002E × 0308 × 0022 ÷	#  ÷ [0.2] FULL STOP (ATerm) × [5.0] COMBINING DIAERESIS (Extend_FE) × [9.0] QUOTATION MARK (Close) ÷ [0.3]');
    Test_SB('÷ 002E × 002C ÷	#  ÷ [0.2] FULL STOP (ATerm) × [8.1] COMMA (SContinue) ÷ [0.3]');
    Test_SB('÷ 002E × 0308 × 002C ÷	#  ÷ [0.2] FULL STOP (ATerm) × [5.0] COMBINING DIAERESIS (Extend_FE) × [8.1] COMMA (SContinue) ÷ [0.3]');
    Test_SB('÷ 002E × 00AD ÷	#  ÷ [0.2] FULL STOP (ATerm) × [5.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_SB('÷ 002E × 0308 × 00AD ÷	#  ÷ [0.2] FULL STOP (ATerm) × [5.0] COMBINING DIAERESIS (Extend_FE) × [5.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_SB('÷ 002E × 0300 ÷	#  ÷ [0.2] FULL STOP (ATerm) × [5.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_SB('÷ 002E × 0308 × 0300 ÷	#  ÷ [0.2] FULL STOP (ATerm) × [5.0] COMBINING DIAERESIS (Extend_FE) × [5.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_SB('÷ 0021 ÷ 0001 ÷	#  ÷ [0.2] EXCLAMATION MARK (STerm) ÷ [11.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_SB('÷ 0021 × 0308 ÷ 0001 ÷	#  ÷ [0.2] EXCLAMATION MARK (STerm) × [5.0] COMBINING DIAERESIS (Extend_FE) ÷ [11.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_SB('÷ 0021 × 000D ÷	#  ÷ [0.2] EXCLAMATION MARK (STerm) × [9.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_SB('÷ 0021 × 0308 × 000D ÷	#  ÷ [0.2] EXCLAMATION MARK (STerm) × [5.0] COMBINING DIAERESIS (Extend_FE) × [9.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_SB('÷ 0021 × 000A ÷	#  ÷ [0.2] EXCLAMATION MARK (STerm) × [9.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_SB('÷ 0021 × 0308 × 000A ÷	#  ÷ [0.2] EXCLAMATION MARK (STerm) × [5.0] COMBINING DIAERESIS (Extend_FE) × [9.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_SB('÷ 0021 × 0085 ÷	#  ÷ [0.2] EXCLAMATION MARK (STerm) × [9.0] <NEXT LINE (NEL)> (Sep) ÷ [0.3]');
    Test_SB('÷ 0021 × 0308 × 0085 ÷	#  ÷ [0.2] EXCLAMATION MARK (STerm) × [5.0] COMBINING DIAERESIS (Extend_FE) × [9.0] <NEXT LINE (NEL)> (Sep) ÷ [0.3]');
    Test_SB('÷ 0021 × 0009 ÷	#  ÷ [0.2] EXCLAMATION MARK (STerm) × [9.0] <CHARACTER TABULATION> (Sp) ÷ [0.3]');
    Test_SB('÷ 0021 × 0308 × 0009 ÷	#  ÷ [0.2] EXCLAMATION MARK (STerm) × [5.0] COMBINING DIAERESIS (Extend_FE) × [9.0] <CHARACTER TABULATION> (Sp) ÷ [0.3]');
    Test_SB('÷ 0021 ÷ 0061 ÷	#  ÷ [0.2] EXCLAMATION MARK (STerm) ÷ [11.0] LATIN SMALL LETTER A (Lower) ÷ [0.3]');
    Test_SB('÷ 0021 × 0308 ÷ 0061 ÷	#  ÷ [0.2] EXCLAMATION MARK (STerm) × [5.0] COMBINING DIAERESIS (Extend_FE) ÷ [11.0] LATIN SMALL LETTER A (Lower) ÷ [0.3]');
    Test_SB('÷ 0021 ÷ 0041 ÷	#  ÷ [0.2] EXCLAMATION MARK (STerm) ÷ [11.0] LATIN CAPITAL LETTER A (Upper) ÷ [0.3]');
    Test_SB('÷ 0021 × 0308 ÷ 0041 ÷	#  ÷ [0.2] EXCLAMATION MARK (STerm) × [5.0] COMBINING DIAERESIS (Extend_FE) ÷ [11.0] LATIN CAPITAL LETTER A (Upper) ÷ [0.3]');
    Test_SB('÷ 0021 ÷ 01BB ÷	#  ÷ [0.2] EXCLAMATION MARK (STerm) ÷ [11.0] LATIN LETTER TWO WITH STROKE (OLetter) ÷ [0.3]');
    Test_SB('÷ 0021 × 0308 ÷ 01BB ÷	#  ÷ [0.2] EXCLAMATION MARK (STerm) × [5.0] COMBINING DIAERESIS (Extend_FE) ÷ [11.0] LATIN LETTER TWO WITH STROKE (OLetter) ÷ [0.3]');
    Test_SB('÷ 0021 ÷ 0030 ÷	#  ÷ [0.2] EXCLAMATION MARK (STerm) ÷ [11.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_SB('÷ 0021 × 0308 ÷ 0030 ÷	#  ÷ [0.2] EXCLAMATION MARK (STerm) × [5.0] COMBINING DIAERESIS (Extend_FE) ÷ [11.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_SB('÷ 0021 × 002E ÷	#  ÷ [0.2] EXCLAMATION MARK (STerm) × [8.1] FULL STOP (ATerm) ÷ [0.3]');
    Test_SB('÷ 0021 × 0308 × 002E ÷	#  ÷ [0.2] EXCLAMATION MARK (STerm) × [5.0] COMBINING DIAERESIS (Extend_FE) × [8.1] FULL STOP (ATerm) ÷ [0.3]');
    Test_SB('÷ 0021 × 0021 ÷	#  ÷ [0.2] EXCLAMATION MARK (STerm) × [8.1] EXCLAMATION MARK (STerm) ÷ [0.3]');
    Test_SB('÷ 0021 × 0308 × 0021 ÷	#  ÷ [0.2] EXCLAMATION MARK (STerm) × [5.0] COMBINING DIAERESIS (Extend_FE) × [8.1] EXCLAMATION MARK (STerm) ÷ [0.3]');
    Test_SB('÷ 0021 × 0022 ÷	#  ÷ [0.2] EXCLAMATION MARK (STerm) × [9.0] QUOTATION MARK (Close) ÷ [0.3]');
    Test_SB('÷ 0021 × 0308 × 0022 ÷	#  ÷ [0.2] EXCLAMATION MARK (STerm) × [5.0] COMBINING DIAERESIS (Extend_FE) × [9.0] QUOTATION MARK (Close) ÷ [0.3]');
    Test_SB('÷ 0021 × 002C ÷	#  ÷ [0.2] EXCLAMATION MARK (STerm) × [8.1] COMMA (SContinue) ÷ [0.3]');
    Test_SB('÷ 0021 × 0308 × 002C ÷	#  ÷ [0.2] EXCLAMATION MARK (STerm) × [5.0] COMBINING DIAERESIS (Extend_FE) × [8.1] COMMA (SContinue) ÷ [0.3]');
    Test_SB('÷ 0021 × 00AD ÷	#  ÷ [0.2] EXCLAMATION MARK (STerm) × [5.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_SB('÷ 0021 × 0308 × 00AD ÷	#  ÷ [0.2] EXCLAMATION MARK (STerm) × [5.0] COMBINING DIAERESIS (Extend_FE) × [5.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_SB('÷ 0021 × 0300 ÷	#  ÷ [0.2] EXCLAMATION MARK (STerm) × [5.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_SB('÷ 0021 × 0308 × 0300 ÷	#  ÷ [0.2] EXCLAMATION MARK (STerm) × [5.0] COMBINING DIAERESIS (Extend_FE) × [5.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_SB('÷ 0022 × 0001 ÷	#  ÷ [0.2] QUOTATION MARK (Close) × [998.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_SB('÷ 0022 × 0308 × 0001 ÷	#  ÷ [0.2] QUOTATION MARK (Close) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_SB('÷ 0022 × 000D ÷	#  ÷ [0.2] QUOTATION MARK (Close) × [998.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_SB('÷ 0022 × 0308 × 000D ÷	#  ÷ [0.2] QUOTATION MARK (Close) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_SB('÷ 0022 × 000A ÷	#  ÷ [0.2] QUOTATION MARK (Close) × [998.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_SB('÷ 0022 × 0308 × 000A ÷	#  ÷ [0.2] QUOTATION MARK (Close) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_SB('÷ 0022 × 0085 ÷	#  ÷ [0.2] QUOTATION MARK (Close) × [998.0] <NEXT LINE (NEL)> (Sep) ÷ [0.3]');
    Test_SB('÷ 0022 × 0308 × 0085 ÷	#  ÷ [0.2] QUOTATION MARK (Close) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <NEXT LINE (NEL)> (Sep) ÷ [0.3]');
    Test_SB('÷ 0022 × 0009 ÷	#  ÷ [0.2] QUOTATION MARK (Close) × [998.0] <CHARACTER TABULATION> (Sp) ÷ [0.3]');
    Test_SB('÷ 0022 × 0308 × 0009 ÷	#  ÷ [0.2] QUOTATION MARK (Close) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <CHARACTER TABULATION> (Sp) ÷ [0.3]');
    Test_SB('÷ 0022 × 0061 ÷	#  ÷ [0.2] QUOTATION MARK (Close) × [998.0] LATIN SMALL LETTER A (Lower) ÷ [0.3]');
    Test_SB('÷ 0022 × 0308 × 0061 ÷	#  ÷ [0.2] QUOTATION MARK (Close) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN SMALL LETTER A (Lower) ÷ [0.3]');
    Test_SB('÷ 0022 × 0041 ÷	#  ÷ [0.2] QUOTATION MARK (Close) × [998.0] LATIN CAPITAL LETTER A (Upper) ÷ [0.3]');
    Test_SB('÷ 0022 × 0308 × 0041 ÷	#  ÷ [0.2] QUOTATION MARK (Close) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN CAPITAL LETTER A (Upper) ÷ [0.3]');
    Test_SB('÷ 0022 × 01BB ÷	#  ÷ [0.2] QUOTATION MARK (Close) × [998.0] LATIN LETTER TWO WITH STROKE (OLetter) ÷ [0.3]');
    Test_SB('÷ 0022 × 0308 × 01BB ÷	#  ÷ [0.2] QUOTATION MARK (Close) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN LETTER TWO WITH STROKE (OLetter) ÷ [0.3]');
    Test_SB('÷ 0022 × 0030 ÷	#  ÷ [0.2] QUOTATION MARK (Close) × [998.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_SB('÷ 0022 × 0308 × 0030 ÷	#  ÷ [0.2] QUOTATION MARK (Close) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_SB('÷ 0022 × 002E ÷	#  ÷ [0.2] QUOTATION MARK (Close) × [998.0] FULL STOP (ATerm) ÷ [0.3]');
    Test_SB('÷ 0022 × 0308 × 002E ÷	#  ÷ [0.2] QUOTATION MARK (Close) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] FULL STOP (ATerm) ÷ [0.3]');
    Test_SB('÷ 0022 × 0021 ÷	#  ÷ [0.2] QUOTATION MARK (Close) × [998.0] EXCLAMATION MARK (STerm) ÷ [0.3]');
    Test_SB('÷ 0022 × 0308 × 0021 ÷	#  ÷ [0.2] QUOTATION MARK (Close) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] EXCLAMATION MARK (STerm) ÷ [0.3]');
    Test_SB('÷ 0022 × 0022 ÷	#  ÷ [0.2] QUOTATION MARK (Close) × [998.0] QUOTATION MARK (Close) ÷ [0.3]');
    Test_SB('÷ 0022 × 0308 × 0022 ÷	#  ÷ [0.2] QUOTATION MARK (Close) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] QUOTATION MARK (Close) ÷ [0.3]');
    Test_SB('÷ 0022 × 002C ÷	#  ÷ [0.2] QUOTATION MARK (Close) × [998.0] COMMA (SContinue) ÷ [0.3]');
    Test_SB('÷ 0022 × 0308 × 002C ÷	#  ÷ [0.2] QUOTATION MARK (Close) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] COMMA (SContinue) ÷ [0.3]');
    Test_SB('÷ 0022 × 00AD ÷	#  ÷ [0.2] QUOTATION MARK (Close) × [5.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_SB('÷ 0022 × 0308 × 00AD ÷	#  ÷ [0.2] QUOTATION MARK (Close) × [5.0] COMBINING DIAERESIS (Extend_FE) × [5.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_SB('÷ 0022 × 0300 ÷	#  ÷ [0.2] QUOTATION MARK (Close) × [5.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_SB('÷ 0022 × 0308 × 0300 ÷	#  ÷ [0.2] QUOTATION MARK (Close) × [5.0] COMBINING DIAERESIS (Extend_FE) × [5.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_SB('÷ 002C × 0001 ÷	#  ÷ [0.2] COMMA (SContinue) × [998.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_SB('÷ 002C × 0308 × 0001 ÷	#  ÷ [0.2] COMMA (SContinue) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_SB('÷ 002C × 000D ÷	#  ÷ [0.2] COMMA (SContinue) × [998.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_SB('÷ 002C × 0308 × 000D ÷	#  ÷ [0.2] COMMA (SContinue) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_SB('÷ 002C × 000A ÷	#  ÷ [0.2] COMMA (SContinue) × [998.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_SB('÷ 002C × 0308 × 000A ÷	#  ÷ [0.2] COMMA (SContinue) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_SB('÷ 002C × 0085 ÷	#  ÷ [0.2] COMMA (SContinue) × [998.0] <NEXT LINE (NEL)> (Sep) ÷ [0.3]');
    Test_SB('÷ 002C × 0308 × 0085 ÷	#  ÷ [0.2] COMMA (SContinue) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <NEXT LINE (NEL)> (Sep) ÷ [0.3]');
    Test_SB('÷ 002C × 0009 ÷	#  ÷ [0.2] COMMA (SContinue) × [998.0] <CHARACTER TABULATION> (Sp) ÷ [0.3]');
    Test_SB('÷ 002C × 0308 × 0009 ÷	#  ÷ [0.2] COMMA (SContinue) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <CHARACTER TABULATION> (Sp) ÷ [0.3]');
    Test_SB('÷ 002C × 0061 ÷	#  ÷ [0.2] COMMA (SContinue) × [998.0] LATIN SMALL LETTER A (Lower) ÷ [0.3]');
    Test_SB('÷ 002C × 0308 × 0061 ÷	#  ÷ [0.2] COMMA (SContinue) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN SMALL LETTER A (Lower) ÷ [0.3]');
    Test_SB('÷ 002C × 0041 ÷	#  ÷ [0.2] COMMA (SContinue) × [998.0] LATIN CAPITAL LETTER A (Upper) ÷ [0.3]');
    Test_SB('÷ 002C × 0308 × 0041 ÷	#  ÷ [0.2] COMMA (SContinue) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN CAPITAL LETTER A (Upper) ÷ [0.3]');
    Test_SB('÷ 002C × 01BB ÷	#  ÷ [0.2] COMMA (SContinue) × [998.0] LATIN LETTER TWO WITH STROKE (OLetter) ÷ [0.3]');
    Test_SB('÷ 002C × 0308 × 01BB ÷	#  ÷ [0.2] COMMA (SContinue) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN LETTER TWO WITH STROKE (OLetter) ÷ [0.3]');
    Test_SB('÷ 002C × 0030 ÷	#  ÷ [0.2] COMMA (SContinue) × [998.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_SB('÷ 002C × 0308 × 0030 ÷	#  ÷ [0.2] COMMA (SContinue) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_SB('÷ 002C × 002E ÷	#  ÷ [0.2] COMMA (SContinue) × [998.0] FULL STOP (ATerm) ÷ [0.3]');
    Test_SB('÷ 002C × 0308 × 002E ÷	#  ÷ [0.2] COMMA (SContinue) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] FULL STOP (ATerm) ÷ [0.3]');
    Test_SB('÷ 002C × 0021 ÷	#  ÷ [0.2] COMMA (SContinue) × [998.0] EXCLAMATION MARK (STerm) ÷ [0.3]');
    Test_SB('÷ 002C × 0308 × 0021 ÷	#  ÷ [0.2] COMMA (SContinue) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] EXCLAMATION MARK (STerm) ÷ [0.3]');
    Test_SB('÷ 002C × 0022 ÷	#  ÷ [0.2] COMMA (SContinue) × [998.0] QUOTATION MARK (Close) ÷ [0.3]');
    Test_SB('÷ 002C × 0308 × 0022 ÷	#  ÷ [0.2] COMMA (SContinue) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] QUOTATION MARK (Close) ÷ [0.3]');
    Test_SB('÷ 002C × 002C ÷	#  ÷ [0.2] COMMA (SContinue) × [998.0] COMMA (SContinue) ÷ [0.3]');
    Test_SB('÷ 002C × 0308 × 002C ÷	#  ÷ [0.2] COMMA (SContinue) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] COMMA (SContinue) ÷ [0.3]');
    Test_SB('÷ 002C × 00AD ÷	#  ÷ [0.2] COMMA (SContinue) × [5.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_SB('÷ 002C × 0308 × 00AD ÷	#  ÷ [0.2] COMMA (SContinue) × [5.0] COMBINING DIAERESIS (Extend_FE) × [5.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_SB('÷ 002C × 0300 ÷	#  ÷ [0.2] COMMA (SContinue) × [5.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_SB('÷ 002C × 0308 × 0300 ÷	#  ÷ [0.2] COMMA (SContinue) × [5.0] COMBINING DIAERESIS (Extend_FE) × [5.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_SB('÷ 00AD × 0001 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [998.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_SB('÷ 00AD × 0308 × 0001 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_SB('÷ 00AD × 000D ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [998.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_SB('÷ 00AD × 0308 × 000D ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_SB('÷ 00AD × 000A ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [998.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_SB('÷ 00AD × 0308 × 000A ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_SB('÷ 00AD × 0085 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [998.0] <NEXT LINE (NEL)> (Sep) ÷ [0.3]');
    Test_SB('÷ 00AD × 0308 × 0085 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <NEXT LINE (NEL)> (Sep) ÷ [0.3]');
    Test_SB('÷ 00AD × 0009 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [998.0] <CHARACTER TABULATION> (Sp) ÷ [0.3]');
    Test_SB('÷ 00AD × 0308 × 0009 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <CHARACTER TABULATION> (Sp) ÷ [0.3]');
    Test_SB('÷ 00AD × 0061 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [998.0] LATIN SMALL LETTER A (Lower) ÷ [0.3]');
    Test_SB('÷ 00AD × 0308 × 0061 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN SMALL LETTER A (Lower) ÷ [0.3]');
    Test_SB('÷ 00AD × 0041 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [998.0] LATIN CAPITAL LETTER A (Upper) ÷ [0.3]');
    Test_SB('÷ 00AD × 0308 × 0041 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN CAPITAL LETTER A (Upper) ÷ [0.3]');
    Test_SB('÷ 00AD × 01BB ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [998.0] LATIN LETTER TWO WITH STROKE (OLetter) ÷ [0.3]');
    Test_SB('÷ 00AD × 0308 × 01BB ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN LETTER TWO WITH STROKE (OLetter) ÷ [0.3]');
    Test_SB('÷ 00AD × 0030 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [998.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_SB('÷ 00AD × 0308 × 0030 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_SB('÷ 00AD × 002E ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [998.0] FULL STOP (ATerm) ÷ [0.3]');
    Test_SB('÷ 00AD × 0308 × 002E ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] FULL STOP (ATerm) ÷ [0.3]');
    Test_SB('÷ 00AD × 0021 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [998.0] EXCLAMATION MARK (STerm) ÷ [0.3]');
    Test_SB('÷ 00AD × 0308 × 0021 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] EXCLAMATION MARK (STerm) ÷ [0.3]');
    Test_SB('÷ 00AD × 0022 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [998.0] QUOTATION MARK (Close) ÷ [0.3]');
    Test_SB('÷ 00AD × 0308 × 0022 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] QUOTATION MARK (Close) ÷ [0.3]');
    Test_SB('÷ 00AD × 002C ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [998.0] COMMA (SContinue) ÷ [0.3]');
    Test_SB('÷ 00AD × 0308 × 002C ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] COMMA (SContinue) ÷ [0.3]');
    Test_SB('÷ 00AD × 00AD ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [5.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_SB('÷ 00AD × 0308 × 00AD ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) × [5.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_SB('÷ 00AD × 0300 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [5.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_SB('÷ 00AD × 0308 × 0300 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) × [5.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_SB('÷ 0300 × 0001 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [998.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_SB('÷ 0300 × 0308 × 0001 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_SB('÷ 0300 × 000D ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [998.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_SB('÷ 0300 × 0308 × 000D ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_SB('÷ 0300 × 000A ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [998.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_SB('÷ 0300 × 0308 × 000A ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_SB('÷ 0300 × 0085 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [998.0] <NEXT LINE (NEL)> (Sep) ÷ [0.3]');
    Test_SB('÷ 0300 × 0308 × 0085 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <NEXT LINE (NEL)> (Sep) ÷ [0.3]');
    Test_SB('÷ 0300 × 0009 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [998.0] <CHARACTER TABULATION> (Sp) ÷ [0.3]');
    Test_SB('÷ 0300 × 0308 × 0009 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <CHARACTER TABULATION> (Sp) ÷ [0.3]');
    Test_SB('÷ 0300 × 0061 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [998.0] LATIN SMALL LETTER A (Lower) ÷ [0.3]');
    Test_SB('÷ 0300 × 0308 × 0061 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN SMALL LETTER A (Lower) ÷ [0.3]');
    Test_SB('÷ 0300 × 0041 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [998.0] LATIN CAPITAL LETTER A (Upper) ÷ [0.3]');
    Test_SB('÷ 0300 × 0308 × 0041 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN CAPITAL LETTER A (Upper) ÷ [0.3]');
    Test_SB('÷ 0300 × 01BB ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [998.0] LATIN LETTER TWO WITH STROKE (OLetter) ÷ [0.3]');
    Test_SB('÷ 0300 × 0308 × 01BB ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN LETTER TWO WITH STROKE (OLetter) ÷ [0.3]');
    Test_SB('÷ 0300 × 0030 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [998.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_SB('÷ 0300 × 0308 × 0030 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_SB('÷ 0300 × 002E ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [998.0] FULL STOP (ATerm) ÷ [0.3]');
    Test_SB('÷ 0300 × 0308 × 002E ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] FULL STOP (ATerm) ÷ [0.3]');
    Test_SB('÷ 0300 × 0021 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [998.0] EXCLAMATION MARK (STerm) ÷ [0.3]');
    Test_SB('÷ 0300 × 0308 × 0021 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] EXCLAMATION MARK (STerm) ÷ [0.3]');
    Test_SB('÷ 0300 × 0022 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [998.0] QUOTATION MARK (Close) ÷ [0.3]');
    Test_SB('÷ 0300 × 0308 × 0022 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] QUOTATION MARK (Close) ÷ [0.3]');
    Test_SB('÷ 0300 × 002C ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [998.0] COMMA (SContinue) ÷ [0.3]');
    Test_SB('÷ 0300 × 0308 × 002C ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] COMMA (SContinue) ÷ [0.3]');
    Test_SB('÷ 0300 × 00AD ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [5.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_SB('÷ 0300 × 0308 × 00AD ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) × [5.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_SB('÷ 0300 × 0300 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [5.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_SB('÷ 0300 × 0308 × 0300 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) × [5.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_SB('÷ 000D × 000A ÷ 0061 × 000A ÷ 0308 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) × [3.0] <LINE FEED (LF)> (LF) ÷ [4.0] LATIN SMALL LETTER A (Lower) × [998.0] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [0.3]');
    Test_SB('÷ 0061 × 0308 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Lower) × [5.0] COMBINING DIAERESIS (Extend_FE) ÷ [0.3]');
    Test_SB('÷ 0020 × 200D × 0646 ÷	#  ÷ [0.2] SPACE (Sp) × [5.0] ZERO WIDTH JOINER (Extend_FE) × [998.0] ARABIC LETTER NOON (OLetter) ÷ [0.3]');
    Test_SB('÷ 0646 × 200D × 0020 ÷	#  ÷ [0.2] ARABIC LETTER NOON (OLetter) × [5.0] ZERO WIDTH JOINER (Extend_FE) × [998.0] SPACE (Sp) ÷ [0.3]');
    Test_SB('÷ 0028 × 0022 × 0047 × 006F × 002E × 0022 × 0029 × 0020 ÷ 0028 × 0048 × 0065 × 0020 × 0064 × 0069 × 0064 × 002E × 0029 ÷	#  ÷ [0.2] LEFT PARENTHESIS (Close) × [998.0] QUOTATION MARK (Close) × [998.0] LATIN CAPITAL LETTER G (Upper) × [998.0] LATIN SMALL LETTER O (Lower) × [998.0] FULL STOP (ATerm) × [9.0] QUOTATION MARK (Close) × [9.0] RIGHT PARENTHESIS (Close) × [9.0] SPACE (Sp) ÷ [11.0] LEFT PARENTHESIS (Close) × [998.0] LATIN CAPITAL LETTER H (Upper) × [998.0] LATIN SMALL LETTER E (Lower) × [998.0] SPACE (Sp) × [998.0] LATIN SMALL LETTER D (Lower) × [998.0] LATIN SMALL LETTER I (Lower) × [998.0] LATIN SMALL LETTER D (Lower) × [998.0] FULL STOP (ATerm) × [9.0] RIGHT PARENTHESIS (Close) ÷ [0.3]');
    Test_SB('÷ 0028 × 201C × 0047 × 006F × 003F × 201D × 0029 × 0020 ÷ 0028 × 0048 × 0065 × 0020 × 0064 × 0069 × 0064 × 002E × 0029 ÷	#  ÷ [0.2] LEFT PARENTHESIS (Close) × [998.0] LEFT DOUBLE QUOTATION MARK (Close) × [998.0] LATIN CAPITAL LETTER G (Upper) × [998.0] LATIN SMALL LETTER O (Lower) × [998.0] QUESTION MARK (STerm) × [9.0] RIGHT DOUBLE QUOTATION MARK (Close) × [9.0] RIGHT PARENTHESIS (Close) × [9.0] SPACE (Sp) ÷ [11.0] LEFT PARENTHESIS (Close) × [998.0] LATIN CAPITAL LETTER H (Upper) × [998.0] LATIN SMALL LETTER E (Lower) × [998.0] SPACE (Sp) × [998.0] LATIN SMALL LETTER D (Lower) × [998.0] LATIN SMALL LETTER I (Lower) × [998.0] LATIN SMALL LETTER D (Lower) × [998.0] FULL STOP (ATerm) × [9.0] RIGHT PARENTHESIS (Close) ÷ [0.3]');
    Test_SB('÷ 0055 × 002E × 0053 × 002E × 0041 × 0300 × 002E × 0020 × 0069 × 0073 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER U (Upper) × [998.0] FULL STOP (ATerm) × [7.0] LATIN CAPITAL LETTER S (Upper) × [998.0] FULL STOP (ATerm) × [7.0] LATIN CAPITAL LETTER A (Upper) × [5.0] COMBINING GRAVE ACCENT (Extend_FE) × [998.0] FULL STOP (ATerm) × [8.0] SPACE (Sp) × [8.0] LATIN SMALL LETTER I (Lower) × [998.0] LATIN SMALL LETTER S (Lower) ÷ [0.3]');
    Test_SB('÷ 0055 × 002E × 0053 × 002E × 0041 × 0300 × 003F × 0020 ÷ 0048 × 0065 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER U (Upper) × [998.0] FULL STOP (ATerm) × [7.0] LATIN CAPITAL LETTER S (Upper) × [998.0] FULL STOP (ATerm) × [7.0] LATIN CAPITAL LETTER A (Upper) × [5.0] COMBINING GRAVE ACCENT (Extend_FE) × [998.0] QUESTION MARK (STerm) × [9.0] SPACE (Sp) ÷ [11.0] LATIN CAPITAL LETTER H (Upper) × [998.0] LATIN SMALL LETTER E (Lower) ÷ [0.3]');
    Test_SB('÷ 0055 × 002E × 0053 × 002E × 0041 × 0300 × 002E ÷	#  ÷ [0.2] LATIN CAPITAL LETTER U (Upper) × [998.0] FULL STOP (ATerm) × [7.0] LATIN CAPITAL LETTER S (Upper) × [998.0] FULL STOP (ATerm) × [7.0] LATIN CAPITAL LETTER A (Upper) × [5.0] COMBINING GRAVE ACCENT (Extend_FE) × [998.0] FULL STOP (ATerm) ÷ [0.3]');
    Test_SB('÷ 0033 × 002E × 0034 ÷	#  ÷ [0.2] DIGIT THREE (Numeric) × [998.0] FULL STOP (ATerm) × [6.0] DIGIT FOUR (Numeric) ÷ [0.3]');
    Test_SB('÷ 0063 × 002E × 0064 ÷	#  ÷ [0.2] LATIN SMALL LETTER C (Lower) × [998.0] FULL STOP (ATerm) × [8.0] LATIN SMALL LETTER D (Lower) ÷ [0.3]');
    Test_SB('÷ 0043 × 002E × 0064 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER C (Upper) × [998.0] FULL STOP (ATerm) × [8.0] LATIN SMALL LETTER D (Lower) ÷ [0.3]');
    Test_SB('÷ 0063 × 002E × 0044 ÷	#  ÷ [0.2] LATIN SMALL LETTER C (Lower) × [998.0] FULL STOP (ATerm) × [7.0] LATIN CAPITAL LETTER D (Upper) ÷ [0.3]');
    Test_SB('÷ 0043 × 002E × 0044 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER C (Upper) × [998.0] FULL STOP (ATerm) × [7.0] LATIN CAPITAL LETTER D (Upper) ÷ [0.3]');
    Test_SB('÷ 0065 × 0074 × 0063 × 002E × 0029 × 2019 × 00A0 × 0074 × 0068 × 0065 ÷	#  ÷ [0.2] LATIN SMALL LETTER E (Lower) × [998.0] LATIN SMALL LETTER T (Lower) × [998.0] LATIN SMALL LETTER C (Lower) × [998.0] FULL STOP (ATerm) × [8.0] RIGHT PARENTHESIS (Close) × [8.0] RIGHT SINGLE QUOTATION MARK (Close) × [8.0] NO-BREAK SPACE (Sp) × [8.0] LATIN SMALL LETTER T (Lower) × [998.0] LATIN SMALL LETTER H (Lower) × [998.0] LATIN SMALL LETTER E (Lower) ÷ [0.3]');
    Test_SB('÷ 0065 × 0074 × 0063 × 002E × 0029 × 2019 × 00A0 ÷ 0054 × 0068 × 0065 ÷	#  ÷ [0.2] LATIN SMALL LETTER E (Lower) × [998.0] LATIN SMALL LETTER T (Lower) × [998.0] LATIN SMALL LETTER C (Lower) × [998.0] FULL STOP (ATerm) × [9.0] RIGHT PARENTHESIS (Close) × [9.0] RIGHT SINGLE QUOTATION MARK (Close) × [9.0] NO-BREAK SPACE (Sp) ÷ [11.0] LATIN CAPITAL LETTER T (Upper) × [998.0] LATIN SMALL LETTER H (Lower) × [998.0] LATIN SMALL LETTER E (Lower) ÷ [0.3]');
    Test_SB('÷ 0065 × 0074 × 0063 × 002E × 0029 × 2019 × 00A0 × 2018 × 0028 × 0074 × 0068 × 0065 ÷	#  ÷ [0.2] LATIN SMALL LETTER E (Lower) × [998.0] LATIN SMALL LETTER T (Lower) × [998.0] LATIN SMALL LETTER C (Lower) × [998.0] FULL STOP (ATerm) × [8.0] RIGHT PARENTHESIS (Close) × [8.0] RIGHT SINGLE QUOTATION MARK (Close) × [8.0] NO-BREAK SPACE (Sp) × [8.0] LEFT SINGLE QUOTATION MARK (Close) × [998.0] LEFT PARENTHESIS (Close) × [998.0] LATIN SMALL LETTER T (Lower) × [998.0] LATIN SMALL LETTER H (Lower) × [998.0] LATIN SMALL LETTER E (Lower) ÷ [0.3]');
    Test_SB('÷ 0065 × 0074 × 0063 × 002E × 0029 × 2019 × 00A0 ÷ 2018 × 0028 × 0054 × 0068 × 0065 ÷	#  ÷ [0.2] LATIN SMALL LETTER E (Lower) × [998.0] LATIN SMALL LETTER T (Lower) × [998.0] LATIN SMALL LETTER C (Lower) × [998.0] FULL STOP (ATerm) × [9.0] RIGHT PARENTHESIS (Close) × [9.0] RIGHT SINGLE QUOTATION MARK (Close) × [9.0] NO-BREAK SPACE (Sp) ÷ [11.0] LEFT SINGLE QUOTATION MARK (Close) × [998.0] LEFT PARENTHESIS (Close) × [998.0] LATIN CAPITAL LETTER T (Upper) × [998.0] LATIN SMALL LETTER H (Lower) × [998.0] LATIN SMALL LETTER E (Lower) ÷ [0.3]');
    Test_SB('÷ 0065 × 0074 × 0063 × 002E × 0029 × 2019 × 00A0 × 0308 × 0074 × 0068 × 0065 ÷	#  ÷ [0.2] LATIN SMALL LETTER E (Lower) × [998.0] LATIN SMALL LETTER T (Lower) × [998.0] LATIN SMALL LETTER C (Lower) × [998.0] FULL STOP (ATerm) × [8.0] RIGHT PARENTHESIS (Close) × [8.0] RIGHT SINGLE QUOTATION MARK (Close) × [8.0] NO-BREAK SPACE (Sp) × [5.0] COMBINING DIAERESIS (Extend_FE) × [8.0] LATIN SMALL LETTER T (Lower) × [998.0] LATIN SMALL LETTER H (Lower) × [998.0] LATIN SMALL LETTER E (Lower) ÷ [0.3]');
    Test_SB('÷ 0065 × 0074 × 0063 × 002E × 0029 × 2019 × 00A0 × 0308 ÷ 0054 × 0068 × 0065 ÷	#  ÷ [0.2] LATIN SMALL LETTER E (Lower) × [998.0] LATIN SMALL LETTER T (Lower) × [998.0] LATIN SMALL LETTER C (Lower) × [998.0] FULL STOP (ATerm) × [9.0] RIGHT PARENTHESIS (Close) × [9.0] RIGHT SINGLE QUOTATION MARK (Close) × [9.0] NO-BREAK SPACE (Sp) × [5.0] COMBINING DIAERESIS (Extend_FE) ÷ [11.0] LATIN CAPITAL LETTER T (Upper) × [998.0] LATIN SMALL LETTER H (Lower) × [998.0] LATIN SMALL LETTER E (Lower) ÷ [0.3]');
    Test_SB('÷ 0065 × 0074 × 0063 × 002E × 0029 × 2019 × 0308 ÷ 0054 × 0068 × 0065 ÷	#  ÷ [0.2] LATIN SMALL LETTER E (Lower) × [998.0] LATIN SMALL LETTER T (Lower) × [998.0] LATIN SMALL LETTER C (Lower) × [998.0] FULL STOP (ATerm) × [9.0] RIGHT PARENTHESIS (Close) × [9.0] RIGHT SINGLE QUOTATION MARK (Close) × [5.0] COMBINING DIAERESIS (Extend_FE) ÷ [11.0] LATIN CAPITAL LETTER T (Upper) × [998.0] LATIN SMALL LETTER H (Lower) × [998.0] LATIN SMALL LETTER E (Lower) ÷ [0.3]');
    Test_SB('÷ 0065 × 0074 × 0063 × 002E × 0029 × 000A ÷ 0308 × 0054 × 0068 × 0065 ÷	#  ÷ [0.2] LATIN SMALL LETTER E (Lower) × [998.0] LATIN SMALL LETTER T (Lower) × [998.0] LATIN SMALL LETTER C (Lower) × [998.0] FULL STOP (ATerm) × [9.0] RIGHT PARENTHESIS (Close) × [9.0] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN CAPITAL LETTER T (Upper) × [998.0] LATIN SMALL LETTER H (Lower) × [998.0] LATIN SMALL LETTER E (Lower) ÷ [0.3]');
    Test_SB('÷ 0074 × 0068 × 0065 × 0020 × 0072 × 0065 × 0073 × 0070 × 002E × 0020 × 006C × 0065 × 0061 × 0064 × 0065 × 0072 × 0073 × 0020 × 0061 × 0072 × 0065 ÷	#  ÷ [0.2] LATIN SMALL LETTER T (Lower) × [998.0] LATIN SMALL LETTER H (Lower) × [998.0] LATIN SMALL LETTER E (Lower) × [998.0] SPACE (Sp) × [998.0] LATIN SMALL LETTER R (Lower) × [998.0] LATIN SMALL LETTER E (Lower) × [998.0] LATIN SMALL LETTER S (Lower) × [998.0] LATIN SMALL LETTER P (Lower) × [998.0] FULL STOP (ATerm) × [8.0] SPACE (Sp) × [8.0] LATIN SMALL LETTER L (Lower) × [998.0] LATIN SMALL LETTER E (Lower) × [998.0] LATIN SMALL LETTER A (Lower) × [998.0] LATIN SMALL LETTER D (Lower) × [998.0] LATIN SMALL LETTER E (Lower) × [998.0] LATIN SMALL LETTER R (Lower) × [998.0] LATIN SMALL LETTER S (Lower) × [998.0] SPACE (Sp) × [998.0] LATIN SMALL LETTER A (Lower) × [998.0] LATIN SMALL LETTER R (Lower) × [998.0] LATIN SMALL LETTER E (Lower) ÷ [0.3]');
    Test_SB('÷ 5B57 × 002E ÷ 5B57 ÷	#  ÷ [0.2] CJK UNIFIED IDEOGRAPH-5B57 (OLetter) × [998.0] FULL STOP (ATerm) ÷ [11.0] CJK UNIFIED IDEOGRAPH-5B57 (OLetter) ÷ [0.3]');
    Test_SB('÷ 0065 × 0074 × 0063 × 002E ÷ 5B83 ÷	#  ÷ [0.2] LATIN SMALL LETTER E (Lower) × [998.0] LATIN SMALL LETTER T (Lower) × [998.0] LATIN SMALL LETTER C (Lower) × [998.0] FULL STOP (ATerm) ÷ [11.0] CJK UNIFIED IDEOGRAPH-5B83 (OLetter) ÷ [0.3]');
    Test_SB('÷ 0065 × 0074 × 0063 × 002E × 3002 ÷	#  ÷ [0.2] LATIN SMALL LETTER E (Lower) × [998.0] LATIN SMALL LETTER T (Lower) × [998.0] LATIN SMALL LETTER C (Lower) × [998.0] FULL STOP (ATerm) × [8.1] IDEOGRAPHIC FULL STOP (STerm) ÷ [0.3]');
    Test_SB('÷ 5B57 × 3002 ÷ 5B83 ÷	#  ÷ [0.2] CJK UNIFIED IDEOGRAPH-5B57 (OLetter) × [998.0] IDEOGRAPHIC FULL STOP (STerm) ÷ [11.0] CJK UNIFIED IDEOGRAPH-5B83 (OLetter) ÷ [0.3]');
    Test_SB('÷ 0021 × 0020 × 0020 ÷	#  ÷ [0.2] EXCLAMATION MARK (STerm) × [9.0] SPACE (Sp) × [10.0] SPACE (Sp) ÷ [0.3]');
    Test_SB('÷ 2060 × 0028 × 2060 × 0022 × 2060 × 0047 × 2060 × 006F × 2060 × 002E × 2060 × 0022 × 2060 × 0029 × 2060 × 0020 × 2060 ÷ 0028 × 2060 × 0048 × 2060 × 0065 × 2060 × 0020 × 2060 × 0064 × 2060 × 0069 × 2060 × 0064 × 2060 × 002E × 2060 × 0029 × 2060 × 2060 ÷	#  ÷ [0.2] WORD JOINER (Format_FE) × [998.0] LEFT PARENTHESIS (Close) × [5.0] WORD JOINER (Format_FE) × [998.0] QUOTATION MARK (Close) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN CAPITAL LETTER G (Upper) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER O (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] FULL STOP (ATerm) × [5.0] WORD JOINER (Format_FE) × [9.0] QUOTATION MARK (Close) × [5.0] WORD JOINER (Format_FE) × [9.0] RIGHT PARENTHESIS (Close) × [5.0] WORD JOINER (Format_FE) × [9.0] SPACE (Sp) × [5.0] WORD JOINER (Format_FE) ÷ [11.0] LEFT PARENTHESIS (Close) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN CAPITAL LETTER H (Upper) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER E (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] SPACE (Sp) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER D (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER I (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER D (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] FULL STOP (ATerm) × [5.0] WORD JOINER (Format_FE) × [9.0] RIGHT PARENTHESIS (Close) × [5.0] WORD JOINER (Format_FE) × [5.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_SB('÷ 2060 × 0028 × 2060 × 201C × 2060 × 0047 × 2060 × 006F × 2060 × 003F × 2060 × 201D × 2060 × 0029 × 2060 × 0020 × 2060 ÷ 0028 × 2060 × 0048 × 2060 × 0065 × 2060 × 0020 × 2060 × 0064 × 2060 × 0069 × 2060 × 0064 × 2060 × 002E × 2060 × 0029 × 2060 × 2060 ÷	#  ÷ [0.2] WORD JOINER (Format_FE) × [998.0] LEFT PARENTHESIS (Close) × [5.0] WORD JOINER (Format_FE) × [998.0] LEFT DOUBLE QUOTATION MARK (Close) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN CAPITAL LETTER G (Upper) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER O (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] QUESTION MARK (STerm) × [5.0] WORD JOINER (Format_FE) × [9.0] RIGHT DOUBLE QUOTATION MARK (Close) × [5.0] WORD JOINER (Format_FE) × [9.0] RIGHT PARENTHESIS (Close) × [5.0] WORD JOINER (Format_FE) × [9.0] SPACE (Sp) × [5.0] WORD JOINER (Format_FE) ÷ [11.0] LEFT PARENTHESIS (Close) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN CAPITAL LETTER H (Upper) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER E (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] SPACE (Sp) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER D (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER I (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER D (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] FULL STOP (ATerm) × [5.0] WORD JOINER (Format_FE) × [9.0] RIGHT PARENTHESIS (Close) × [5.0] WORD JOINER (Format_FE) × [5.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_SB('÷ 2060 × 0055 × 2060 × 002E × 2060 × 0053 × 2060 × 002E × 2060 × 0041 × 2060 × 0300 × 002E × 2060 × 0020 × 2060 × 0069 × 2060 × 0073 × 2060 × 2060 ÷	#  ÷ [0.2] WORD JOINER (Format_FE) × [998.0] LATIN CAPITAL LETTER U (Upper) × [5.0] WORD JOINER (Format_FE) × [998.0] FULL STOP (ATerm) × [5.0] WORD JOINER (Format_FE) × [7.0] LATIN CAPITAL LETTER S (Upper) × [5.0] WORD JOINER (Format_FE) × [998.0] FULL STOP (ATerm) × [5.0] WORD JOINER (Format_FE) × [7.0] LATIN CAPITAL LETTER A (Upper) × [5.0] WORD JOINER (Format_FE) × [5.0] COMBINING GRAVE ACCENT (Extend_FE) × [998.0] FULL STOP (ATerm) × [5.0] WORD JOINER (Format_FE) × [8.0] SPACE (Sp) × [5.0] WORD JOINER (Format_FE) × [8.0] LATIN SMALL LETTER I (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER S (Lower) × [5.0] WORD JOINER (Format_FE) × [5.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_SB('÷ 2060 × 0055 × 2060 × 002E × 2060 × 0053 × 2060 × 002E × 2060 × 0041 × 2060 × 0300 × 003F × 2060 × 0020 × 2060 ÷ 0048 × 2060 × 0065 × 2060 × 2060 ÷	#  ÷ [0.2] WORD JOINER (Format_FE) × [998.0] LATIN CAPITAL LETTER U (Upper) × [5.0] WORD JOINER (Format_FE) × [998.0] FULL STOP (ATerm) × [5.0] WORD JOINER (Format_FE) × [7.0] LATIN CAPITAL LETTER S (Upper) × [5.0] WORD JOINER (Format_FE) × [998.0] FULL STOP (ATerm) × [5.0] WORD JOINER (Format_FE) × [7.0] LATIN CAPITAL LETTER A (Upper) × [5.0] WORD JOINER (Format_FE) × [5.0] COMBINING GRAVE ACCENT (Extend_FE) × [998.0] QUESTION MARK (STerm) × [5.0] WORD JOINER (Format_FE) × [9.0] SPACE (Sp) × [5.0] WORD JOINER (Format_FE) ÷ [11.0] LATIN CAPITAL LETTER H (Upper) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER E (Lower) × [5.0] WORD JOINER (Format_FE) × [5.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_SB('÷ 2060 × 0055 × 2060 × 002E × 2060 × 0053 × 2060 × 002E × 2060 × 0041 × 2060 × 0300 × 002E × 2060 × 2060 ÷	#  ÷ [0.2] WORD JOINER (Format_FE) × [998.0] LATIN CAPITAL LETTER U (Upper) × [5.0] WORD JOINER (Format_FE) × [998.0] FULL STOP (ATerm) × [5.0] WORD JOINER (Format_FE) × [7.0] LATIN CAPITAL LETTER S (Upper) × [5.0] WORD JOINER (Format_FE) × [998.0] FULL STOP (ATerm) × [5.0] WORD JOINER (Format_FE) × [7.0] LATIN CAPITAL LETTER A (Upper) × [5.0] WORD JOINER (Format_FE) × [5.0] COMBINING GRAVE ACCENT (Extend_FE) × [998.0] FULL STOP (ATerm) × [5.0] WORD JOINER (Format_FE) × [5.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_SB('÷ 2060 × 0033 × 2060 × 002E × 2060 × 0034 × 2060 × 2060 ÷	#  ÷ [0.2] WORD JOINER (Format_FE) × [998.0] DIGIT THREE (Numeric) × [5.0] WORD JOINER (Format_FE) × [998.0] FULL STOP (ATerm) × [5.0] WORD JOINER (Format_FE) × [6.0] DIGIT FOUR (Numeric) × [5.0] WORD JOINER (Format_FE) × [5.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_SB('÷ 2060 × 0063 × 2060 × 002E × 2060 × 0064 × 2060 × 2060 ÷	#  ÷ [0.2] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER C (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] FULL STOP (ATerm) × [5.0] WORD JOINER (Format_FE) × [8.0] LATIN SMALL LETTER D (Lower) × [5.0] WORD JOINER (Format_FE) × [5.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_SB('÷ 2060 × 0043 × 2060 × 002E × 2060 × 0064 × 2060 × 2060 ÷	#  ÷ [0.2] WORD JOINER (Format_FE) × [998.0] LATIN CAPITAL LETTER C (Upper) × [5.0] WORD JOINER (Format_FE) × [998.0] FULL STOP (ATerm) × [5.0] WORD JOINER (Format_FE) × [8.0] LATIN SMALL LETTER D (Lower) × [5.0] WORD JOINER (Format_FE) × [5.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_SB('÷ 2060 × 0063 × 2060 × 002E × 2060 × 0044 × 2060 × 2060 ÷	#  ÷ [0.2] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER C (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] FULL STOP (ATerm) × [5.0] WORD JOINER (Format_FE) × [7.0] LATIN CAPITAL LETTER D (Upper) × [5.0] WORD JOINER (Format_FE) × [5.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_SB('÷ 2060 × 0043 × 2060 × 002E × 2060 × 0044 × 2060 × 2060 ÷	#  ÷ [0.2] WORD JOINER (Format_FE) × [998.0] LATIN CAPITAL LETTER C (Upper) × [5.0] WORD JOINER (Format_FE) × [998.0] FULL STOP (ATerm) × [5.0] WORD JOINER (Format_FE) × [7.0] LATIN CAPITAL LETTER D (Upper) × [5.0] WORD JOINER (Format_FE) × [5.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_SB('÷ 2060 × 0065 × 2060 × 0074 × 2060 × 0063 × 2060 × 002E × 2060 × 0029 × 2060 × 2019 × 2060 × 00A0 × 2060 × 0074 × 2060 × 0068 × 2060 × 0065 × 2060 × 2060 ÷	#  ÷ [0.2] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER E (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER T (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER C (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] FULL STOP (ATerm) × [5.0] WORD JOINER (Format_FE) × [8.0] RIGHT PARENTHESIS (Close) × [5.0] WORD JOINER (Format_FE) × [8.0] RIGHT SINGLE QUOTATION MARK (Close) × [5.0] WORD JOINER (Format_FE) × [8.0] NO-BREAK SPACE (Sp) × [5.0] WORD JOINER (Format_FE) × [8.0] LATIN SMALL LETTER T (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER H (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER E (Lower) × [5.0] WORD JOINER (Format_FE) × [5.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_SB('÷ 2060 × 0065 × 2060 × 0074 × 2060 × 0063 × 2060 × 002E × 2060 × 0029 × 2060 × 2019 × 2060 × 00A0 × 2060 ÷ 0054 × 2060 × 0068 × 2060 × 0065 × 2060 × 2060 ÷	#  ÷ [0.2] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER E (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER T (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER C (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] FULL STOP (ATerm) × [5.0] WORD JOINER (Format_FE) × [9.0] RIGHT PARENTHESIS (Close) × [5.0] WORD JOINER (Format_FE) × [9.0] RIGHT SINGLE QUOTATION MARK (Close) × [5.0] WORD JOINER (Format_FE) × [9.0] NO-BREAK SPACE (Sp) × [5.0] WORD JOINER (Format_FE) ÷ [11.0] LATIN CAPITAL LETTER T (Upper) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER H (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER E (Lower) × [5.0] WORD JOINER (Format_FE) × [5.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_SB('÷ 2060 × 0065 × 2060 × 0074 × 2060 × 0063 × 2060 × 002E × 2060 × 0029 × 2060 × 2019 × 2060 × 00A0 × 2060 × 2018 × 2060 × 0028 × 2060 × 0074 × 2060 × 0068 × 2060 × 0065 × 2060 × 2060 ÷	#  ÷ [0.2] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER E (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER T (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER C (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] FULL STOP (ATerm) × [5.0] WORD JOINER (Format_FE) × [8.0] RIGHT PARENTHESIS (Close) × [5.0] WORD JOINER (Format_FE) × [8.0] RIGHT SINGLE QUOTATION MARK (Close) × [5.0] WORD JOINER (Format_FE) × [8.0] NO-BREAK SPACE (Sp) × [5.0] WORD JOINER (Format_FE) × [8.0] LEFT SINGLE QUOTATION MARK (Close) × [5.0] WORD JOINER (Format_FE) × [998.0] LEFT PARENTHESIS (Close) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER T (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER H (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER E (Lower) × [5.0] WORD JOINER (Format_FE) × [5.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_SB('÷ 2060 × 0065 × 2060 × 0074 × 2060 × 0063 × 2060 × 002E × 2060 × 0029 × 2060 × 2019 × 2060 × 00A0 × 2060 ÷ 2018 × 2060 × 0028 × 2060 × 0054 × 2060 × 0068 × 2060 × 0065 × 2060 × 2060 ÷	#  ÷ [0.2] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER E (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER T (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER C (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] FULL STOP (ATerm) × [5.0] WORD JOINER (Format_FE) × [9.0] RIGHT PARENTHESIS (Close) × [5.0] WORD JOINER (Format_FE) × [9.0] RIGHT SINGLE QUOTATION MARK (Close) × [5.0] WORD JOINER (Format_FE) × [9.0] NO-BREAK SPACE (Sp) × [5.0] WORD JOINER (Format_FE) ÷ [11.0] LEFT SINGLE QUOTATION MARK (Close) × [5.0] WORD JOINER (Format_FE) × [998.0] LEFT PARENTHESIS (Close) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN CAPITAL LETTER T (Upper) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER H (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER E (Lower) × [5.0] WORD JOINER (Format_FE) × [5.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_SB('÷ 2060 × 0065 × 2060 × 0074 × 2060 × 0063 × 2060 × 002E × 2060 × 0029 × 2060 × 2019 × 2060 × 00A0 × 2060 × 0308 × 0074 × 2060 × 0068 × 2060 × 0065 × 2060 × 2060 ÷	#  ÷ [0.2] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER E (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER T (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER C (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] FULL STOP (ATerm) × [5.0] WORD JOINER (Format_FE) × [8.0] RIGHT PARENTHESIS (Close) × [5.0] WORD JOINER (Format_FE) × [8.0] RIGHT SINGLE QUOTATION MARK (Close) × [5.0] WORD JOINER (Format_FE) × [8.0] NO-BREAK SPACE (Sp) × [5.0] WORD JOINER (Format_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) × [8.0] LATIN SMALL LETTER T (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER H (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER E (Lower) × [5.0] WORD JOINER (Format_FE) × [5.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_SB('÷ 2060 × 0065 × 2060 × 0074 × 2060 × 0063 × 2060 × 002E × 2060 × 0029 × 2060 × 2019 × 2060 × 00A0 × 2060 × 0308 ÷ 0054 × 2060 × 0068 × 2060 × 0065 × 2060 × 2060 ÷	#  ÷ [0.2] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER E (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER T (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER C (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] FULL STOP (ATerm) × [5.0] WORD JOINER (Format_FE) × [9.0] RIGHT PARENTHESIS (Close) × [5.0] WORD JOINER (Format_FE) × [9.0] RIGHT SINGLE QUOTATION MARK (Close) × [5.0] WORD JOINER (Format_FE) × [9.0] NO-BREAK SPACE (Sp) × [5.0] WORD JOINER (Format_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) ÷ [11.0] LATIN CAPITAL LETTER T (Upper) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER H (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER E (Lower) × [5.0] WORD JOINER (Format_FE) × [5.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_SB('÷ 2060 × 0065 × 2060 × 0074 × 2060 × 0063 × 2060 × 002E × 2060 × 0029 × 2060 × 2019 × 2060 × 0308 ÷ 0054 × 2060 × 0068 × 2060 × 0065 × 2060 × 2060 ÷	#  ÷ [0.2] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER E (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER T (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER C (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] FULL STOP (ATerm) × [5.0] WORD JOINER (Format_FE) × [9.0] RIGHT PARENTHESIS (Close) × [5.0] WORD JOINER (Format_FE) × [9.0] RIGHT SINGLE QUOTATION MARK (Close) × [5.0] WORD JOINER (Format_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) ÷ [11.0] LATIN CAPITAL LETTER T (Upper) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER H (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER E (Lower) × [5.0] WORD JOINER (Format_FE) × [5.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_SB('÷ 2060 × 0065 × 2060 × 0074 × 2060 × 0063 × 2060 × 002E × 2060 × 0029 × 2060 × 000A ÷ 2060 × 0308 × 2060 × 0054 × 2060 × 0068 × 2060 × 0065 × 2060 × 2060 ÷	#  ÷ [0.2] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER E (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER T (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER C (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] FULL STOP (ATerm) × [5.0] WORD JOINER (Format_FE) × [9.0] RIGHT PARENTHESIS (Close) × [5.0] WORD JOINER (Format_FE) × [9.0] <LINE FEED (LF)> (LF) ÷ [4.0] WORD JOINER (Format_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN CAPITAL LETTER T (Upper) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER H (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER E (Lower) × [5.0] WORD JOINER (Format_FE) × [5.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_SB('÷ 2060 × 0074 × 2060 × 0068 × 2060 × 0065 × 2060 × 0020 × 2060 × 0072 × 2060 × 0065 × 2060 × 0073 × 2060 × 0070 × 2060 × 002E × 2060 × 0020 × 2060 × 006C × 2060 × 0065 × 2060 × 0061 × 2060 × 0064 × 2060 × 0065 × 2060 × 0072 × 2060 × 0073 × 2060 × 0020 × 2060 × 0061 × 2060 × 0072 × 2060 × 0065 × 2060 × 2060 ÷	#  ÷ [0.2] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER T (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER H (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER E (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] SPACE (Sp) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER R (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER E (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER S (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER P (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] FULL STOP (ATerm) × [5.0] WORD JOINER (Format_FE) × [8.0] SPACE (Sp) × [5.0] WORD JOINER (Format_FE) × [8.0] LATIN SMALL LETTER L (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER E (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER A (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER D (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER E (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER R (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER S (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] SPACE (Sp) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER A (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER R (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER E (Lower) × [5.0] WORD JOINER (Format_FE) × [5.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_SB('÷ 2060 × 5B57 × 2060 × 002E × 2060 ÷ 5B57 × 2060 × 2060 ÷	#  ÷ [0.2] WORD JOINER (Format_FE) × [998.0] CJK UNIFIED IDEOGRAPH-5B57 (OLetter) × [5.0] WORD JOINER (Format_FE) × [998.0] FULL STOP (ATerm) × [5.0] WORD JOINER (Format_FE) ÷ [11.0] CJK UNIFIED IDEOGRAPH-5B57 (OLetter) × [5.0] WORD JOINER (Format_FE) × [5.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_SB('÷ 2060 × 0065 × 2060 × 0074 × 2060 × 0063 × 2060 × 002E × 2060 ÷ 5B83 × 2060 × 2060 ÷	#  ÷ [0.2] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER E (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER T (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER C (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] FULL STOP (ATerm) × [5.0] WORD JOINER (Format_FE) ÷ [11.0] CJK UNIFIED IDEOGRAPH-5B83 (OLetter) × [5.0] WORD JOINER (Format_FE) × [5.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_SB('÷ 2060 × 0065 × 2060 × 0074 × 2060 × 0063 × 2060 × 002E × 2060 × 3002 × 2060 × 2060 ÷	#  ÷ [0.2] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER E (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER T (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER C (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] FULL STOP (ATerm) × [5.0] WORD JOINER (Format_FE) × [8.1] IDEOGRAPHIC FULL STOP (STerm) × [5.0] WORD JOINER (Format_FE) × [5.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_SB('÷ 2060 × 5B57 × 2060 × 3002 × 2060 ÷ 5B83 × 2060 × 2060 ÷	#  ÷ [0.2] WORD JOINER (Format_FE) × [998.0] CJK UNIFIED IDEOGRAPH-5B57 (OLetter) × [5.0] WORD JOINER (Format_FE) × [998.0] IDEOGRAPHIC FULL STOP (STerm) × [5.0] WORD JOINER (Format_FE) ÷ [11.0] CJK UNIFIED IDEOGRAPH-5B83 (OLetter) × [5.0] WORD JOINER (Format_FE) × [5.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_SB('÷ 2060 × 0021 × 2060 × 0020 × 2060 × 0020 × 2060 × 2060 ÷	#  ÷ [0.2] WORD JOINER (Format_FE) × [998.0] EXCLAMATION MARK (STerm) × [5.0] WORD JOINER (Format_FE) × [9.0] SPACE (Sp) × [5.0] WORD JOINER (Format_FE) × [10.0] SPACE (Sp) × [5.0] WORD JOINER (Format_FE) × [5.0] WORD JOINER (Format_FE) ÷ [0.3]');
}
if (!$::TESTCHUNK or $::TESTCHUNK == 6) {
    Test_LB('× 0023 × 0023 ÷	#  × [0.3] NUMBER SIGN (AL) × [28.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0023 × 0020 ÷ 0023 ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0023 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [28.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0023 ÷ 2014 ÷	#  × [0.3] NUMBER SIGN (AL) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0023 × 0020 ÷ 2014 ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0023 × 0308 ÷ 2014 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0023 × 0009 ÷	#  × [0.3] NUMBER SIGN (AL) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0023 × 0020 ÷ 0009 ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0009 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0023 ÷ 00B4 ÷	#  × [0.3] NUMBER SIGN (AL) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0023 × 0020 ÷ 00B4 ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0023 × 0308 ÷ 00B4 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0023 × 000B ÷	#  × [0.3] NUMBER SIGN (AL) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0023 × 0020 × 000B ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 000B ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 × 000B ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0023 ÷ FFFC ÷	#  × [0.3] NUMBER SIGN (AL) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0023 × 0020 ÷ FFFC ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0023 × 0308 ÷ FFFC ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0023 × 007D ÷	#  × [0.3] NUMBER SIGN (AL) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0023 × 0020 × 007D ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 007D ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 × 007D ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0023 × 000D ÷	#  × [0.3] NUMBER SIGN (AL) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0023 × 0020 × 000D ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 000D ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 × 000D ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0023 × 0021 ÷	#  × [0.3] NUMBER SIGN (AL) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0023 × 0020 × 0021 ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0021 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 × 0021 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0023 × 00A0 ÷	#  × [0.3] NUMBER SIGN (AL) × [12.1] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0023 × 0020 ÷ 00A0 ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 00A0 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0023 ÷ AC00 ÷	#  × [0.3] NUMBER SIGN (AL) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0023 × 0020 ÷ AC00 ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0023 × 0308 ÷ AC00 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0023 ÷ AC01 ÷	#  × [0.3] NUMBER SIGN (AL) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0023 × 0020 ÷ AC01 ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0023 × 0308 ÷ AC01 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0023 × 05D0 ÷	#  × [0.3] NUMBER SIGN (AL) × [28.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0023 × 0020 ÷ 05D0 ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 05D0 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [28.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0023 × 002D ÷	#  × [0.3] NUMBER SIGN (AL) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0023 × 0020 ÷ 002D ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 002D ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 ÷ 002D ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0023 ÷ 231A ÷	#  × [0.3] NUMBER SIGN (AL) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0023 × 0020 ÷ 231A ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0023 × 0308 ÷ 231A ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 ÷ 231A ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0023 × 2024 ÷	#  × [0.3] NUMBER SIGN (AL) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0023 × 0020 ÷ 2024 ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 2024 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0023 × 002C ÷	#  × [0.3] NUMBER SIGN (AL) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0023 × 0020 × 002C ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 002C ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 × 002C ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0023 ÷ 1100 ÷	#  × [0.3] NUMBER SIGN (AL) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0023 × 0020 ÷ 1100 ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0023 × 0308 ÷ 1100 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0023 ÷ 11A8 ÷	#  × [0.3] NUMBER SIGN (AL) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0023 × 0020 ÷ 11A8 ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0023 × 0308 ÷ 11A8 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0023 ÷ 1160 ÷	#  × [0.3] NUMBER SIGN (AL) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0023 × 0020 ÷ 1160 ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0023 × 0308 ÷ 1160 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0023 × 000A ÷	#  × [0.3] NUMBER SIGN (AL) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0023 × 0020 × 000A ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 000A ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 × 000A ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0023 × 0085 ÷	#  × [0.3] NUMBER SIGN (AL) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0023 × 0020 × 0085 ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0085 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 × 0085 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0023 × 17D6 ÷	#  × [0.3] NUMBER SIGN (AL) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0023 × 0020 ÷ 17D6 ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 17D6 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0023 × 0030 ÷	#  × [0.3] NUMBER SIGN (AL) × [23.02] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0023 × 0020 ÷ 0030 ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0030 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [23.02] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0023 ÷ 2329 ÷	#  × [0.3] NUMBER SIGN (AL) ÷ [999.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 0023 × 0020 ÷ 2329 ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 0023 × 0308 ÷ 2329 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 ÷ 2329 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 0023 × 0025 ÷	#  × [0.3] NUMBER SIGN (AL) × [24.03] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0023 × 0020 ÷ 0025 ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0025 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [24.03] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0023 × 0024 ÷	#  × [0.3] NUMBER SIGN (AL) × [24.03] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0023 × 0020 ÷ 0024 ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0024 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [24.03] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0023 × 0022 ÷	#  × [0.3] NUMBER SIGN (AL) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0023 × 0020 ÷ 0022 ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0022 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0023 × 0020 ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0023 × 0020 × 0020 ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 × 0020 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0023 × 002F ÷	#  × [0.3] NUMBER SIGN (AL) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0023 × 0020 × 002F ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 002F ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 × 002F ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0023 × 2060 ÷	#  × [0.3] NUMBER SIGN (AL) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0023 × 0020 × 2060 ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 2060 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 × 2060 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0023 × 200B ÷	#  × [0.3] NUMBER SIGN (AL) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0023 × 0020 × 200B ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 200B ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 × 200B ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0023 ÷ 1F1E6 ÷	#  × [0.3] NUMBER SIGN (AL) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0023 × 0020 ÷ 1F1E6 ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0023 × 0308 ÷ 1F1E6 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0023 ÷ 261D ÷	#  × [0.3] NUMBER SIGN (AL) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0023 × 0020 ÷ 261D ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0023 × 0308 ÷ 261D ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 ÷ 261D ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0023 ÷ 1F3FB ÷	#  × [0.3] NUMBER SIGN (AL) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0023 × 0020 ÷ 1F3FB ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0023 × 0308 ÷ 1F3FB ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0023 × 0029 ÷	#  × [0.3] NUMBER SIGN (AL) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0023 × 0020 × 0029 ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0029 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 × 0029 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0023 × 0028 ÷	#  × [0.3] NUMBER SIGN (AL) × [30.01] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 0023 × 0020 ÷ 0028 ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0028 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [30.01] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 0023 × 0001 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0023 × 0020 ÷ 0001 ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0001 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0023 × 200D ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0023 × 0020 ÷ 200D ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 200D ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 ÷ 200D ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0023 × 00A7 ÷	#  × [0.3] NUMBER SIGN (AL) × [28.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0023 × 0020 ÷ 00A7 ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 00A7 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [28.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0023 × 50005 ÷	#  × [0.3] NUMBER SIGN (AL) × [28.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0023 × 0020 ÷ 50005 ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 50005 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [28.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0023 × 0E01 ÷	#  × [0.3] NUMBER SIGN (AL) × [28.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0023 × 0020 ÷ 0E01 ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0E01 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [28.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0023 × 3041 ÷	#  × [0.3] NUMBER SIGN (AL) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0023 × 0020 ÷ 3041 ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 3041 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 ÷ 3041 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 2014 ÷ 0023 ÷	#  × [0.3] EM DASH (B2) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 2014 × 0020 ÷ 0023 ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 2014 × 0308 ÷ 0023 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 2014 × 2014 ÷	#  × [0.3] EM DASH (B2) × [17.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 2014 × 0020 × 2014 ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) × [17.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 2014 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [17.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 × 2014 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [17.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 2014 × 0009 ÷	#  × [0.3] EM DASH (B2) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 2014 × 0020 ÷ 0009 ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0009 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 2014 ÷ 00B4 ÷	#  × [0.3] EM DASH (B2) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 2014 × 0020 ÷ 00B4 ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 2014 × 0308 ÷ 00B4 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 2014 × 000B ÷	#  × [0.3] EM DASH (B2) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 2014 × 0020 × 000B ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 000B ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 × 000B ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 2014 ÷ FFFC ÷	#  × [0.3] EM DASH (B2) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 2014 × 0020 ÷ FFFC ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 2014 × 0308 ÷ FFFC ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 2014 × 007D ÷	#  × [0.3] EM DASH (B2) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 2014 × 0020 × 007D ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 007D ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 × 007D ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 2014 × 000D ÷	#  × [0.3] EM DASH (B2) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 2014 × 0020 × 000D ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 000D ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 × 000D ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 2014 × 0021 ÷	#  × [0.3] EM DASH (B2) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 2014 × 0020 × 0021 ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0021 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 × 0021 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 2014 × 00A0 ÷	#  × [0.3] EM DASH (B2) × [12.1] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 2014 × 0020 ÷ 00A0 ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 00A0 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 2014 ÷ AC00 ÷	#  × [0.3] EM DASH (B2) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 2014 × 0020 ÷ AC00 ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 2014 × 0308 ÷ AC00 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 2014 ÷ AC01 ÷	#  × [0.3] EM DASH (B2) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 2014 × 0020 ÷ AC01 ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 2014 × 0308 ÷ AC01 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 2014 ÷ 05D0 ÷	#  × [0.3] EM DASH (B2) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 2014 × 0020 ÷ 05D0 ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 2014 × 0308 ÷ 05D0 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 2014 × 002D ÷	#  × [0.3] EM DASH (B2) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 2014 × 0020 ÷ 002D ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 002D ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 ÷ 002D ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 2014 ÷ 231A ÷	#  × [0.3] EM DASH (B2) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 2014 × 0020 ÷ 231A ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 2014 × 0308 ÷ 231A ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 ÷ 231A ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 2014 × 2024 ÷	#  × [0.3] EM DASH (B2) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 2014 × 0020 ÷ 2024 ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 2024 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 2014 × 002C ÷	#  × [0.3] EM DASH (B2) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 2014 × 0020 × 002C ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 002C ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 × 002C ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 2014 ÷ 1100 ÷	#  × [0.3] EM DASH (B2) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 2014 × 0020 ÷ 1100 ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 2014 × 0308 ÷ 1100 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 2014 ÷ 11A8 ÷	#  × [0.3] EM DASH (B2) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 2014 × 0020 ÷ 11A8 ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 2014 × 0308 ÷ 11A8 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 2014 ÷ 1160 ÷	#  × [0.3] EM DASH (B2) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 2014 × 0020 ÷ 1160 ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 2014 × 0308 ÷ 1160 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 2014 × 000A ÷	#  × [0.3] EM DASH (B2) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 2014 × 0020 × 000A ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 000A ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 × 000A ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 2014 × 0085 ÷	#  × [0.3] EM DASH (B2) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 2014 × 0020 × 0085 ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0085 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 × 0085 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 2014 × 17D6 ÷	#  × [0.3] EM DASH (B2) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 2014 × 0020 ÷ 17D6 ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 17D6 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 2014 ÷ 0030 ÷	#  × [0.3] EM DASH (B2) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 2014 × 0020 ÷ 0030 ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 2014 × 0308 ÷ 0030 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 2014 ÷ 2329 ÷	#  × [0.3] EM DASH (B2) ÷ [999.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 2014 × 0020 ÷ 2329 ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 2014 × 0308 ÷ 2329 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 ÷ 2329 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 2014 ÷ 0025 ÷	#  × [0.3] EM DASH (B2) ÷ [999.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 2014 × 0020 ÷ 0025 ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 2014 × 0308 ÷ 0025 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 2014 ÷ 0024 ÷	#  × [0.3] EM DASH (B2) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 2014 × 0020 ÷ 0024 ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 2014 × 0308 ÷ 0024 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 2014 × 0022 ÷	#  × [0.3] EM DASH (B2) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 2014 × 0020 ÷ 0022 ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0022 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 2014 × 0020 ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 2014 × 0020 × 0020 ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 × 0020 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 2014 × 002F ÷	#  × [0.3] EM DASH (B2) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 2014 × 0020 × 002F ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 002F ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 × 002F ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 2014 × 2060 ÷	#  × [0.3] EM DASH (B2) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 2014 × 0020 × 2060 ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 2060 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 × 2060 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 2014 × 200B ÷	#  × [0.3] EM DASH (B2) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 2014 × 0020 × 200B ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 200B ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 × 200B ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 2014 ÷ 1F1E6 ÷	#  × [0.3] EM DASH (B2) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 2014 × 0020 ÷ 1F1E6 ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 2014 × 0308 ÷ 1F1E6 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 2014 ÷ 261D ÷	#  × [0.3] EM DASH (B2) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 2014 × 0020 ÷ 261D ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 2014 × 0308 ÷ 261D ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 ÷ 261D ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 2014 ÷ 1F3FB ÷	#  × [0.3] EM DASH (B2) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 2014 × 0020 ÷ 1F3FB ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 2014 × 0308 ÷ 1F3FB ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 2014 × 0029 ÷	#  × [0.3] EM DASH (B2) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 2014 × 0020 × 0029 ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0029 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 × 0029 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 2014 ÷ 0028 ÷	#  × [0.3] EM DASH (B2) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 2014 × 0020 ÷ 0028 ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 2014 × 0308 ÷ 0028 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 2014 × 0001 ÷	#  × [0.3] EM DASH (B2) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 2014 × 0020 ÷ 0001 ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0001 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 2014 × 200D ÷	#  × [0.3] EM DASH (B2) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 2014 × 0020 ÷ 200D ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 200D ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 ÷ 200D ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 2014 ÷ 00A7 ÷	#  × [0.3] EM DASH (B2) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 2014 × 0020 ÷ 00A7 ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 2014 × 0308 ÷ 00A7 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 2014 ÷ 50005 ÷	#  × [0.3] EM DASH (B2) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 2014 × 0020 ÷ 50005 ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 2014 × 0308 ÷ 50005 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 2014 ÷ 0E01 ÷	#  × [0.3] EM DASH (B2) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 2014 × 0020 ÷ 0E01 ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 2014 × 0308 ÷ 0E01 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 2014 × 3041 ÷	#  × [0.3] EM DASH (B2) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 2014 × 0020 ÷ 3041 ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 3041 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 ÷ 3041 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0009 ÷ 0023 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0009 × 0020 ÷ 0023 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0009 × 0308 ÷ 0023 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0009 ÷ 2014 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0009 × 0020 ÷ 2014 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0009 × 0308 ÷ 2014 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0009 × 0009 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0009 × 0020 ÷ 0009 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0009 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0009 ÷ 00B4 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0009 × 0020 ÷ 00B4 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0009 × 0308 ÷ 00B4 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0009 × 000B ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0009 × 0020 × 000B ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 000B ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 × 000B ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0009 ÷ FFFC ÷	#  × [0.3] <CHARACTER TABULATION> (BA) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0009 × 0020 ÷ FFFC ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0009 × 0308 ÷ FFFC ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0009 × 007D ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0009 × 0020 × 007D ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 007D ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 × 007D ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0009 × 000D ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0009 × 0020 × 000D ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 000D ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 × 000D ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0009 × 0021 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0009 × 0020 × 0021 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0021 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 × 0021 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0009 ÷ 00A0 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) ÷ [999.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0009 × 0020 ÷ 00A0 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0009 × 0308 ÷ 00A0 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0009 ÷ AC00 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0009 × 0020 ÷ AC00 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0009 × 0308 ÷ AC00 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0009 ÷ AC01 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0009 × 0020 ÷ AC01 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0009 × 0308 ÷ AC01 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0009 ÷ 05D0 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0009 × 0020 ÷ 05D0 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0009 × 0308 ÷ 05D0 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0009 × 002D ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0009 × 0020 ÷ 002D ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 002D ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 ÷ 002D ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0009 ÷ 231A ÷	#  × [0.3] <CHARACTER TABULATION> (BA) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0009 × 0020 ÷ 231A ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0009 × 0308 ÷ 231A ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 ÷ 231A ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0009 × 2024 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0009 × 0020 ÷ 2024 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 2024 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0009 × 002C ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0009 × 0020 × 002C ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 002C ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 × 002C ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0009 ÷ 1100 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0009 × 0020 ÷ 1100 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0009 × 0308 ÷ 1100 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0009 ÷ 11A8 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0009 × 0020 ÷ 11A8 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0009 × 0308 ÷ 11A8 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0009 ÷ 1160 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0009 × 0020 ÷ 1160 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0009 × 0308 ÷ 1160 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0009 × 000A ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0009 × 0020 × 000A ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 000A ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 × 000A ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0009 × 0085 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0009 × 0020 × 0085 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0085 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 × 0085 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0009 × 17D6 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0009 × 0020 ÷ 17D6 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 17D6 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0009 ÷ 0030 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0009 × 0020 ÷ 0030 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0009 × 0308 ÷ 0030 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0009 ÷ 2329 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) ÷ [999.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 0009 × 0020 ÷ 2329 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 0009 × 0308 ÷ 2329 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 ÷ 2329 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 0009 ÷ 0025 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) ÷ [999.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0009 × 0020 ÷ 0025 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0009 × 0308 ÷ 0025 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0009 ÷ 0024 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0009 × 0020 ÷ 0024 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0009 × 0308 ÷ 0024 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0009 × 0022 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0009 × 0020 ÷ 0022 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0022 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0009 × 0020 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0009 × 0020 × 0020 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 × 0020 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0009 × 002F ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0009 × 0020 × 002F ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 002F ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 × 002F ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0009 × 2060 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0009 × 0020 × 2060 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 2060 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 × 2060 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0009 × 200B ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0009 × 0020 × 200B ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 200B ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 × 200B ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0009 ÷ 1F1E6 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0009 × 0020 ÷ 1F1E6 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0009 × 0308 ÷ 1F1E6 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0009 ÷ 261D ÷	#  × [0.3] <CHARACTER TABULATION> (BA) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0009 × 0020 ÷ 261D ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0009 × 0308 ÷ 261D ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 ÷ 261D ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0009 ÷ 1F3FB ÷	#  × [0.3] <CHARACTER TABULATION> (BA) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0009 × 0020 ÷ 1F3FB ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0009 × 0308 ÷ 1F3FB ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0009 × 0029 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0009 × 0020 × 0029 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0029 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 × 0029 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0009 ÷ 0028 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 0009 × 0020 ÷ 0028 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 0009 × 0308 ÷ 0028 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 0009 × 0001 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0009 × 0020 ÷ 0001 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0001 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0009 × 200D ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0009 × 0020 ÷ 200D ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 200D ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 ÷ 200D ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0009 ÷ 00A7 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0009 × 0020 ÷ 00A7 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0009 × 0308 ÷ 00A7 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0009 ÷ 50005 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0009 × 0020 ÷ 50005 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0009 × 0308 ÷ 50005 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0009 ÷ 0E01 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0009 × 0020 ÷ 0E01 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0009 × 0308 ÷ 0E01 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0009 × 3041 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0009 × 0020 ÷ 3041 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 3041 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 ÷ 3041 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 00B4 × 0023 ÷	#  × [0.3] ACUTE ACCENT (BB) × [21.04] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 ÷ 0023 ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0023 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.04] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 00B4 × 2014 ÷	#  × [0.3] ACUTE ACCENT (BB) × [21.04] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 ÷ 2014 ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 2014 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.04] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 00B4 × 0009 ÷	#  × [0.3] ACUTE ACCENT (BB) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 ÷ 0009 ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0009 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 00B4 × 00B4 ÷	#  × [0.3] ACUTE ACCENT (BB) × [21.04] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 ÷ 00B4 ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 00B4 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.04] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 00B4 × 000B ÷	#  × [0.3] ACUTE ACCENT (BB) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 × 000B ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 000B ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 × 000B ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 00B4 ÷ FFFC ÷	#  × [0.3] ACUTE ACCENT (BB) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 ÷ FFFC ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 ÷ FFFC ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 00B4 × 007D ÷	#  × [0.3] ACUTE ACCENT (BB) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 × 007D ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 007D ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 × 007D ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 00B4 × 000D ÷	#  × [0.3] ACUTE ACCENT (BB) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 × 000D ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 000D ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 × 000D ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 00B4 × 0021 ÷	#  × [0.3] ACUTE ACCENT (BB) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 × 0021 ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0021 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 × 0021 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 00B4 × 00A0 ÷	#  × [0.3] ACUTE ACCENT (BB) × [12.1] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 ÷ 00A0 ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 00A0 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 00B4 × AC00 ÷	#  × [0.3] ACUTE ACCENT (BB) × [21.04] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 ÷ AC00 ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × AC00 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.04] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 00B4 × AC01 ÷	#  × [0.3] ACUTE ACCENT (BB) × [21.04] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 ÷ AC01 ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × AC01 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.04] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 00B4 × 05D0 ÷	#  × [0.3] ACUTE ACCENT (BB) × [21.04] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 ÷ 05D0 ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 05D0 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.04] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 00B4 × 002D ÷	#  × [0.3] ACUTE ACCENT (BB) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 ÷ 002D ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 002D ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 ÷ 002D ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 00B4 × 231A ÷	#  × [0.3] ACUTE ACCENT (BB) × [21.04] WATCH (ID) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 ÷ 231A ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 231A ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.04] WATCH (ID) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 ÷ 231A ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 00B4 × 2024 ÷	#  × [0.3] ACUTE ACCENT (BB) × [21.04] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 ÷ 2024 ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 2024 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.04] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 00B4 × 002C ÷	#  × [0.3] ACUTE ACCENT (BB) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 × 002C ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 002C ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 × 002C ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 00B4 × 1100 ÷	#  × [0.3] ACUTE ACCENT (BB) × [21.04] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 ÷ 1100 ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 1100 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.04] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 00B4 × 11A8 ÷	#  × [0.3] ACUTE ACCENT (BB) × [21.04] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 ÷ 11A8 ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 11A8 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.04] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 00B4 × 1160 ÷	#  × [0.3] ACUTE ACCENT (BB) × [21.04] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 ÷ 1160 ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 1160 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.04] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 00B4 × 000A ÷	#  × [0.3] ACUTE ACCENT (BB) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 × 000A ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 000A ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 × 000A ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 00B4 × 0085 ÷	#  × [0.3] ACUTE ACCENT (BB) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 × 0085 ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0085 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 × 0085 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 00B4 × 17D6 ÷	#  × [0.3] ACUTE ACCENT (BB) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 ÷ 17D6 ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 17D6 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 00B4 × 0030 ÷	#  × [0.3] ACUTE ACCENT (BB) × [21.04] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 ÷ 0030 ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0030 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.04] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 00B4 × 2329 ÷	#  × [0.3] ACUTE ACCENT (BB) × [21.04] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 ÷ 2329 ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 2329 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.04] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 ÷ 2329 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 00B4 × 0025 ÷	#  × [0.3] ACUTE ACCENT (BB) × [21.04] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 ÷ 0025 ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0025 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.04] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 00B4 × 0024 ÷	#  × [0.3] ACUTE ACCENT (BB) × [21.04] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 ÷ 0024 ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0024 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.04] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 00B4 × 0022 ÷	#  × [0.3] ACUTE ACCENT (BB) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 ÷ 0022 ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0022 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 × 0020 ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 × 0020 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 00B4 × 002F ÷	#  × [0.3] ACUTE ACCENT (BB) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 × 002F ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 002F ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 × 002F ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 00B4 × 2060 ÷	#  × [0.3] ACUTE ACCENT (BB) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 × 2060 ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 2060 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 × 2060 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 00B4 × 200B ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 × 200B ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 200B ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 × 200B ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 00B4 × 1F1E6 ÷	#  × [0.3] ACUTE ACCENT (BB) × [21.04] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 ÷ 1F1E6 ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 1F1E6 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.04] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 00B4 × 261D ÷	#  × [0.3] ACUTE ACCENT (BB) × [21.04] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 ÷ 261D ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 261D ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.04] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 ÷ 261D ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 00B4 × 1F3FB ÷	#  × [0.3] ACUTE ACCENT (BB) × [21.04] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 ÷ 1F3FB ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 1F3FB ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.04] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 00B4 × 0029 ÷	#  × [0.3] ACUTE ACCENT (BB) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 × 0029 ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0029 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 × 0029 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 00B4 × 0028 ÷	#  × [0.3] ACUTE ACCENT (BB) × [21.04] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 ÷ 0028 ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0028 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.04] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 00B4 × 0001 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 ÷ 0001 ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0001 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 00B4 × 200D ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 ÷ 200D ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 200D ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 ÷ 200D ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 00B4 × 00A7 ÷	#  × [0.3] ACUTE ACCENT (BB) × [21.04] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 ÷ 00A7 ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 00A7 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.04] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 00B4 × 50005 ÷	#  × [0.3] ACUTE ACCENT (BB) × [21.04] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 ÷ 50005 ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 50005 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.04] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 00B4 × 0E01 ÷	#  × [0.3] ACUTE ACCENT (BB) × [21.04] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 ÷ 0E01 ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0E01 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.04] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 00B4 × 3041 ÷	#  × [0.3] ACUTE ACCENT (BB) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 ÷ 3041 ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 3041 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 ÷ 3041 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 000B ÷ 0023 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 ÷ 0023 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0023 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [28.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 ÷ 0023 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 000B ÷ 2014 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 ÷ 2014 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 ÷ 2014 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 ÷ 2014 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 000B ÷ 0009 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 ÷ 0009 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0009 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 ÷ 0009 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 000B ÷ 00B4 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 ÷ 00B4 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 ÷ 00B4 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 000B ÷ 000B ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 × 000B ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 000B ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 × 000B ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 000B ÷ FFFC ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 ÷ FFFC ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 ÷ FFFC ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 ÷ FFFC ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 000B ÷ 007D ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 × 007D ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 007D ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 × 007D ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 000B ÷ 000D ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 × 000D ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 000D ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 × 000D ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 000B ÷ 0021 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 × 0021 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0021 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 × 0021 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 000B ÷ 00A0 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 ÷ 00A0 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 00A0 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 000B ÷ AC00 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 ÷ AC00 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 ÷ AC00 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 ÷ AC00 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 000B ÷ AC01 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 ÷ AC01 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 ÷ AC01 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 ÷ AC01 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 000B ÷ 05D0 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 ÷ 05D0 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 05D0 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [28.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 000B ÷ 002D ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 ÷ 002D ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 002D ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 ÷ 002D ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 000B ÷ 231A ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 ÷ 231A ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 ÷ 231A ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 ÷ 231A ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 000B ÷ 2024 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 ÷ 2024 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 2024 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 ÷ 2024 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 000B ÷ 002C ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMMA (IS) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 × 002C ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 002C ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 × 002C ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 000B ÷ 1100 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 ÷ 1100 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 ÷ 1100 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 ÷ 1100 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 000B ÷ 11A8 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 ÷ 11A8 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 ÷ 11A8 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 000B ÷ 1160 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 ÷ 1160 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 ÷ 1160 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 ÷ 1160 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 000B ÷ 000A ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 × 000A ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 000A ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 × 000A ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 000B ÷ 0085 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 × 0085 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0085 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 × 0085 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 000B ÷ 17D6 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 ÷ 17D6 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 17D6 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 000B ÷ 0030 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 ÷ 0030 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0030 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [23.02] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 ÷ 0030 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 000B ÷ 2329 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 ÷ 2329 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 ÷ 2329 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 ÷ 2329 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 000B ÷ 0025 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 ÷ 0025 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0025 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [24.03] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 ÷ 0025 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 000B ÷ 0024 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 ÷ 0024 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0024 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [24.03] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 ÷ 0024 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 000B ÷ 0022 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 ÷ 0022 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0022 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 ÷ 0022 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 × 0020 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 × 0020 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 000B ÷ 002F ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 × 002F ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 002F ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 × 002F ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 000B ÷ 2060 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 × 2060 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 2060 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 × 2060 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 000B ÷ 200B ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 × 200B ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 200B ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 × 200B ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 000B ÷ 1F1E6 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 ÷ 1F1E6 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 ÷ 1F1E6 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 000B ÷ 261D ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 ÷ 261D ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 ÷ 261D ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 ÷ 261D ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 000B ÷ 1F3FB ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 ÷ 1F3FB ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 ÷ 1F3FB ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 000B ÷ 0029 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 × 0029 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0029 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 × 0029 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 000B ÷ 0028 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 ÷ 0028 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0028 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [30.01] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 ÷ 0028 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 000B ÷ 0001 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 ÷ 0001 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0001 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 ÷ 0001 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 000B ÷ 200D ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 ÷ 200D ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 200D ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 ÷ 200D ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 000B ÷ 00A7 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 ÷ 00A7 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 00A7 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [28.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 000B ÷ 50005 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 ÷ 50005 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 50005 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [28.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 ÷ 50005 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 000B ÷ 0E01 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 ÷ 0E01 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0E01 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [28.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 000B ÷ 3041 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 ÷ 3041 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 3041 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 ÷ 3041 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× FFFC ÷ 0023 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) ÷ [20.02] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× FFFC × 0020 ÷ 0023 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× FFFC × 0308 ÷ 0023 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.02] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× FFFC ÷ 2014 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) ÷ [20.02] EM DASH (B2) ÷ [0.3]');
    Test_LB('× FFFC × 0020 ÷ 2014 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× FFFC × 0308 ÷ 2014 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.02] EM DASH (B2) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× FFFC ÷ 0009 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) ÷ [20.02] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× FFFC × 0020 ÷ 0009 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× FFFC × 0308 ÷ 0009 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.02] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× FFFC ÷ 00B4 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) ÷ [20.02] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× FFFC × 0020 ÷ 00B4 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× FFFC × 0308 ÷ 00B4 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.02] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× FFFC × 000B ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× FFFC × 0020 × 000B ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 000B ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 × 000B ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× FFFC ÷ FFFC ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× FFFC × 0020 ÷ FFFC ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× FFFC × 0308 ÷ FFFC ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× FFFC × 007D ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× FFFC × 0020 × 007D ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 007D ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 × 007D ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× FFFC × 000D ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× FFFC × 0020 × 000D ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 000D ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 × 000D ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× FFFC × 0021 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× FFFC × 0020 × 0021 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0021 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 × 0021 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× FFFC × 00A0 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [12.1] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× FFFC × 0020 ÷ 00A0 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 00A0 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× FFFC ÷ AC00 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) ÷ [20.02] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× FFFC × 0020 ÷ AC00 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× FFFC × 0308 ÷ AC00 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.02] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× FFFC ÷ AC01 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) ÷ [20.02] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× FFFC × 0020 ÷ AC01 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× FFFC × 0308 ÷ AC01 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.02] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× FFFC ÷ 05D0 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) ÷ [20.02] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× FFFC × 0020 ÷ 05D0 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× FFFC × 0308 ÷ 05D0 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.02] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× FFFC ÷ 002D ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) ÷ [20.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× FFFC × 0020 ÷ 002D ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× FFFC × 0308 ÷ 002D ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 ÷ 002D ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× FFFC ÷ 231A ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) ÷ [20.02] WATCH (ID) ÷ [0.3]');
    Test_LB('× FFFC × 0020 ÷ 231A ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× FFFC × 0308 ÷ 231A ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.02] WATCH (ID) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 ÷ 231A ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× FFFC ÷ 2024 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) ÷ [20.02] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× FFFC × 0020 ÷ 2024 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× FFFC × 0308 ÷ 2024 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.02] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× FFFC × 002C ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× FFFC × 0020 × 002C ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 002C ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 × 002C ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× FFFC ÷ 1100 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) ÷ [20.02] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× FFFC × 0020 ÷ 1100 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× FFFC × 0308 ÷ 1100 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.02] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× FFFC ÷ 11A8 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) ÷ [20.02] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× FFFC × 0020 ÷ 11A8 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× FFFC × 0308 ÷ 11A8 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.02] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× FFFC ÷ 1160 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) ÷ [20.02] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× FFFC × 0020 ÷ 1160 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× FFFC × 0308 ÷ 1160 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.02] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× FFFC × 000A ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× FFFC × 0020 × 000A ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 000A ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 × 000A ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× FFFC × 0085 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× FFFC × 0020 × 0085 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0085 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 × 0085 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× FFFC ÷ 17D6 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) ÷ [20.02] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× FFFC × 0020 ÷ 17D6 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× FFFC × 0308 ÷ 17D6 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.02] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× FFFC ÷ 0030 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) ÷ [20.02] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× FFFC × 0020 ÷ 0030 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× FFFC × 0308 ÷ 0030 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.02] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× FFFC ÷ 2329 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) ÷ [20.02] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× FFFC × 0020 ÷ 2329 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× FFFC × 0308 ÷ 2329 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.02] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 ÷ 2329 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× FFFC ÷ 0025 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) ÷ [20.02] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× FFFC × 0020 ÷ 0025 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× FFFC × 0308 ÷ 0025 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.02] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× FFFC ÷ 0024 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) ÷ [20.02] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× FFFC × 0020 ÷ 0024 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× FFFC × 0308 ÷ 0024 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.02] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× FFFC × 0022 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× FFFC × 0020 ÷ 0022 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0022 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× FFFC × 0020 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× FFFC × 0020 × 0020 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 × 0020 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× FFFC × 002F ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× FFFC × 0020 × 002F ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 002F ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 × 002F ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× FFFC × 2060 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× FFFC × 0020 × 2060 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 2060 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 × 2060 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× FFFC × 200B ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× FFFC × 0020 × 200B ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 200B ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 × 200B ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× FFFC ÷ 1F1E6 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) ÷ [20.02] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× FFFC × 0020 ÷ 1F1E6 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× FFFC × 0308 ÷ 1F1E6 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.02] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× FFFC ÷ 261D ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) ÷ [20.02] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× FFFC × 0020 ÷ 261D ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× FFFC × 0308 ÷ 261D ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.02] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 ÷ 261D ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× FFFC ÷ 1F3FB ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) ÷ [20.02] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× FFFC × 0020 ÷ 1F3FB ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× FFFC × 0308 ÷ 1F3FB ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.02] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× FFFC × 0029 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× FFFC × 0020 × 0029 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0029 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 × 0029 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× FFFC ÷ 0028 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) ÷ [20.02] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× FFFC × 0020 ÷ 0028 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× FFFC × 0308 ÷ 0028 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.02] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× FFFC × 0001 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× FFFC × 0020 ÷ 0001 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0001 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× FFFC × 200D ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× FFFC × 0020 ÷ 200D ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 200D ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 ÷ 200D ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× FFFC ÷ 00A7 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) ÷ [20.02] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× FFFC × 0020 ÷ 00A7 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× FFFC × 0308 ÷ 00A7 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.02] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× FFFC ÷ 50005 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) ÷ [20.02] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× FFFC × 0020 ÷ 50005 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× FFFC × 0308 ÷ 50005 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.02] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× FFFC ÷ 0E01 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) ÷ [20.02] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× FFFC × 0020 ÷ 0E01 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× FFFC × 0308 ÷ 0E01 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.02] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× FFFC ÷ 3041 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) ÷ [20.02] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× FFFC × 0020 ÷ 3041 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× FFFC × 0308 ÷ 3041 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.02] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 ÷ 3041 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 007D ÷ 0023 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 007D × 0020 ÷ 0023 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 007D × 0308 ÷ 0023 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 007D ÷ 2014 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 007D × 0020 ÷ 2014 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 007D × 0308 ÷ 2014 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 007D × 0009 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 007D × 0020 ÷ 0009 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0009 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 007D ÷ 00B4 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 007D × 0020 ÷ 00B4 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 007D × 0308 ÷ 00B4 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 007D × 000B ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 007D × 0020 × 000B ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 000B ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 × 000B ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 007D ÷ FFFC ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 007D × 0020 ÷ FFFC ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 007D × 0308 ÷ FFFC ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 007D × 007D ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 007D × 0020 × 007D ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 007D ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 × 007D ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 007D × 000D ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 007D × 0020 × 000D ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 000D ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 × 000D ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 007D × 0021 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 007D × 0020 × 0021 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0021 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 × 0021 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 007D × 00A0 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [12.1] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 007D × 0020 ÷ 00A0 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 00A0 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 007D ÷ AC00 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 007D × 0020 ÷ AC00 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 007D × 0308 ÷ AC00 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 007D ÷ AC01 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 007D × 0020 ÷ AC01 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 007D × 0308 ÷ AC01 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 007D ÷ 05D0 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 007D × 0020 ÷ 05D0 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 007D × 0308 ÷ 05D0 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 007D × 002D ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 007D × 0020 ÷ 002D ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 002D ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 ÷ 002D ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 007D ÷ 231A ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 007D × 0020 ÷ 231A ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 007D × 0308 ÷ 231A ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 ÷ 231A ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 007D × 2024 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 007D × 0020 ÷ 2024 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 2024 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 007D × 002C ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 007D × 0020 × 002C ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 002C ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 × 002C ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 007D ÷ 1100 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 007D × 0020 ÷ 1100 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 007D × 0308 ÷ 1100 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 007D ÷ 11A8 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 007D × 0020 ÷ 11A8 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 007D × 0308 ÷ 11A8 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 007D ÷ 1160 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 007D × 0020 ÷ 1160 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 007D × 0308 ÷ 1160 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 007D × 000A ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 007D × 0020 × 000A ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 000A ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 × 000A ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 007D × 0085 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 007D × 0020 × 0085 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0085 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 × 0085 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 007D × 17D6 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [16.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 007D × 0020 × 17D6 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) × [16.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 17D6 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [16.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 × 17D6 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [16.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 007D ÷ 0030 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 007D × 0020 ÷ 0030 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 007D × 0308 ÷ 0030 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 007D ÷ 2329 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) ÷ [999.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 007D × 0020 ÷ 2329 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 007D × 0308 ÷ 2329 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 ÷ 2329 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 007D ÷ 0025 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) ÷ [999.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 007D × 0020 ÷ 0025 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 007D × 0308 ÷ 0025 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 007D ÷ 0024 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 007D × 0020 ÷ 0024 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 007D × 0308 ÷ 0024 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 007D × 0022 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 007D × 0020 ÷ 0022 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0022 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 007D × 0020 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 007D × 0020 × 0020 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 × 0020 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 007D × 002F ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 007D × 0020 × 002F ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 002F ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 × 002F ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 007D × 2060 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 007D × 0020 × 2060 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 2060 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 × 2060 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 007D × 200B ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 007D × 0020 × 200B ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 200B ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 × 200B ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 007D ÷ 1F1E6 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 007D × 0020 ÷ 1F1E6 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 007D × 0308 ÷ 1F1E6 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 007D ÷ 261D ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 007D × 0020 ÷ 261D ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 007D × 0308 ÷ 261D ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 ÷ 261D ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 007D ÷ 1F3FB ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 007D × 0020 ÷ 1F3FB ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 007D × 0308 ÷ 1F3FB ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 007D × 0029 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 007D × 0020 × 0029 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0029 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 × 0029 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 007D ÷ 0028 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 007D × 0020 ÷ 0028 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 007D × 0308 ÷ 0028 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 007D × 0001 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 007D × 0020 ÷ 0001 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0001 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 007D × 200D ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 007D × 0020 ÷ 200D ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 200D ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 ÷ 200D ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 007D ÷ 00A7 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 007D × 0020 ÷ 00A7 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 007D × 0308 ÷ 00A7 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 007D ÷ 50005 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 007D × 0020 ÷ 50005 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 007D × 0308 ÷ 50005 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 007D ÷ 0E01 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 007D × 0020 ÷ 0E01 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 007D × 0308 ÷ 0E01 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 007D × 3041 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [16.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 007D × 0020 × 3041 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) × [16.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 3041 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [16.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 × 3041 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [16.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 000D ÷ 0023 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 ÷ 0023 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0023 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [28.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 ÷ 0023 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 000D ÷ 2014 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 ÷ 2014 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 ÷ 2014 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 ÷ 2014 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 000D ÷ 0009 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 ÷ 0009 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0009 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 ÷ 0009 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 000D ÷ 00B4 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 ÷ 00B4 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 ÷ 00B4 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 000D ÷ 000B ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 × 000B ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 000B ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 × 000B ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 000D ÷ FFFC ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 ÷ FFFC ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 ÷ FFFC ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 ÷ FFFC ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 000D ÷ 007D ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 × 007D ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 007D ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 × 007D ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 000D ÷ 000D ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 × 000D ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 000D ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 × 000D ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 000D ÷ 0021 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 × 0021 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0021 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 × 0021 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 000D ÷ 00A0 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 ÷ 00A0 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 00A0 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 000D ÷ AC00 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 ÷ AC00 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 ÷ AC00 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 ÷ AC00 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 000D ÷ AC01 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 ÷ AC01 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 ÷ AC01 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 ÷ AC01 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 000D ÷ 05D0 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 ÷ 05D0 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 05D0 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [28.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 000D ÷ 002D ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 ÷ 002D ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 002D ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 ÷ 002D ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 000D ÷ 231A ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] WATCH (ID) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 ÷ 231A ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 ÷ 231A ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 ÷ 231A ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 000D ÷ 2024 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 ÷ 2024 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 2024 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 ÷ 2024 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 000D ÷ 002C ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 × 002C ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 002C ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 × 002C ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 000D ÷ 1100 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 ÷ 1100 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 ÷ 1100 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 ÷ 1100 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 000D ÷ 11A8 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 ÷ 11A8 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 ÷ 11A8 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 000D ÷ 1160 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 ÷ 1160 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 ÷ 1160 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 ÷ 1160 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 000D × 000A ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) × [5.01] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 × 000A ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 000A ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 × 000A ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 000D ÷ 0085 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 × 0085 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0085 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 × 0085 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 000D ÷ 17D6 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 ÷ 17D6 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 17D6 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 000D ÷ 0030 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 ÷ 0030 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0030 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [23.02] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 ÷ 0030 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 000D ÷ 2329 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 ÷ 2329 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 ÷ 2329 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 ÷ 2329 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 000D ÷ 0025 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 ÷ 0025 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0025 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [24.03] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 ÷ 0025 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 000D ÷ 0024 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 ÷ 0024 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0024 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [24.03] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 ÷ 0024 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 000D ÷ 0022 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 ÷ 0022 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0022 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 ÷ 0022 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 × 0020 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 × 0020 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 000D ÷ 002F ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 × 002F ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 002F ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 × 002F ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 000D ÷ 2060 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 × 2060 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 2060 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 × 2060 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 000D ÷ 200B ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 × 200B ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 200B ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 × 200B ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 000D ÷ 1F1E6 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 ÷ 1F1E6 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 ÷ 1F1E6 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 000D ÷ 261D ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 ÷ 261D ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 ÷ 261D ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 ÷ 261D ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 000D ÷ 1F3FB ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 ÷ 1F3FB ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 ÷ 1F3FB ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 000D ÷ 0029 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 × 0029 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0029 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 × 0029 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 000D ÷ 0028 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 ÷ 0028 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0028 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [30.01] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 ÷ 0028 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 000D ÷ 0001 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 ÷ 0001 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0001 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 ÷ 0001 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 000D ÷ 200D ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 ÷ 200D ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 200D ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 ÷ 200D ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 000D ÷ 00A7 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 ÷ 00A7 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 00A7 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [28.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 000D ÷ 50005 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 ÷ 50005 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 50005 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [28.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 ÷ 50005 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 000D ÷ 0E01 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 ÷ 0E01 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0E01 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [28.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 000D ÷ 3041 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 ÷ 3041 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 3041 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 ÷ 3041 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0021 ÷ 0023 ÷	#  × [0.3] EXCLAMATION MARK (EX) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0021 × 0020 ÷ 0023 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0021 × 0308 ÷ 0023 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0021 ÷ 2014 ÷	#  × [0.3] EXCLAMATION MARK (EX) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0021 × 0020 ÷ 2014 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0021 × 0308 ÷ 2014 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0021 × 0009 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0021 × 0020 ÷ 0009 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0009 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0021 ÷ 00B4 ÷	#  × [0.3] EXCLAMATION MARK (EX) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0021 × 0020 ÷ 00B4 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0021 × 0308 ÷ 00B4 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0021 × 000B ÷	#  × [0.3] EXCLAMATION MARK (EX) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0021 × 0020 × 000B ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 000B ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 × 000B ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0021 ÷ FFFC ÷	#  × [0.3] EXCLAMATION MARK (EX) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0021 × 0020 ÷ FFFC ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0021 × 0308 ÷ FFFC ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0021 × 007D ÷	#  × [0.3] EXCLAMATION MARK (EX) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0021 × 0020 × 007D ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 007D ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 × 007D ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0021 × 000D ÷	#  × [0.3] EXCLAMATION MARK (EX) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0021 × 0020 × 000D ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 000D ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 × 000D ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0021 × 0021 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0021 × 0020 × 0021 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0021 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 × 0021 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0021 × 00A0 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [12.1] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0021 × 0020 ÷ 00A0 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 00A0 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0021 ÷ AC00 ÷	#  × [0.3] EXCLAMATION MARK (EX) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0021 × 0020 ÷ AC00 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0021 × 0308 ÷ AC00 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0021 ÷ AC01 ÷	#  × [0.3] EXCLAMATION MARK (EX) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0021 × 0020 ÷ AC01 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0021 × 0308 ÷ AC01 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0021 ÷ 05D0 ÷	#  × [0.3] EXCLAMATION MARK (EX) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0021 × 0020 ÷ 05D0 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0021 × 0308 ÷ 05D0 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0021 × 002D ÷	#  × [0.3] EXCLAMATION MARK (EX) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0021 × 0020 ÷ 002D ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 002D ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 ÷ 002D ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0021 ÷ 231A ÷	#  × [0.3] EXCLAMATION MARK (EX) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0021 × 0020 ÷ 231A ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0021 × 0308 ÷ 231A ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 ÷ 231A ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0021 × 2024 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0021 × 0020 ÷ 2024 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 2024 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0021 × 002C ÷	#  × [0.3] EXCLAMATION MARK (EX) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0021 × 0020 × 002C ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 002C ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 × 002C ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0021 ÷ 1100 ÷	#  × [0.3] EXCLAMATION MARK (EX) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0021 × 0020 ÷ 1100 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0021 × 0308 ÷ 1100 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0021 ÷ 11A8 ÷	#  × [0.3] EXCLAMATION MARK (EX) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0021 × 0020 ÷ 11A8 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0021 × 0308 ÷ 11A8 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0021 ÷ 1160 ÷	#  × [0.3] EXCLAMATION MARK (EX) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0021 × 0020 ÷ 1160 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0021 × 0308 ÷ 1160 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0021 × 000A ÷	#  × [0.3] EXCLAMATION MARK (EX) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0021 × 0020 × 000A ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 000A ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 × 000A ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0021 × 0085 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0021 × 0020 × 0085 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0085 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 × 0085 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0021 × 17D6 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0021 × 0020 ÷ 17D6 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 17D6 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0021 ÷ 0030 ÷	#  × [0.3] EXCLAMATION MARK (EX) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0021 × 0020 ÷ 0030 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0021 × 0308 ÷ 0030 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0021 ÷ 2329 ÷	#  × [0.3] EXCLAMATION MARK (EX) ÷ [999.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 0021 × 0020 ÷ 2329 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 0021 × 0308 ÷ 2329 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 ÷ 2329 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 0021 ÷ 0025 ÷	#  × [0.3] EXCLAMATION MARK (EX) ÷ [999.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0021 × 0020 ÷ 0025 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0021 × 0308 ÷ 0025 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0021 ÷ 0024 ÷	#  × [0.3] EXCLAMATION MARK (EX) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0021 × 0020 ÷ 0024 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0021 × 0308 ÷ 0024 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0021 × 0022 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0021 × 0020 ÷ 0022 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0022 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0021 × 0020 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0021 × 0020 × 0020 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 × 0020 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0021 × 002F ÷	#  × [0.3] EXCLAMATION MARK (EX) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0021 × 0020 × 002F ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 002F ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 × 002F ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0021 × 2060 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0021 × 0020 × 2060 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 2060 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 × 2060 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0021 × 200B ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0021 × 0020 × 200B ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 200B ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 × 200B ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0021 ÷ 1F1E6 ÷	#  × [0.3] EXCLAMATION MARK (EX) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0021 × 0020 ÷ 1F1E6 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0021 × 0308 ÷ 1F1E6 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0021 ÷ 261D ÷	#  × [0.3] EXCLAMATION MARK (EX) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0021 × 0020 ÷ 261D ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0021 × 0308 ÷ 261D ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 ÷ 261D ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0021 ÷ 1F3FB ÷	#  × [0.3] EXCLAMATION MARK (EX) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0021 × 0020 ÷ 1F3FB ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0021 × 0308 ÷ 1F3FB ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0021 × 0029 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0021 × 0020 × 0029 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0029 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 × 0029 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0021 ÷ 0028 ÷	#  × [0.3] EXCLAMATION MARK (EX) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 0021 × 0020 ÷ 0028 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 0021 × 0308 ÷ 0028 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 0021 × 0001 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0021 × 0020 ÷ 0001 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0001 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0021 × 200D ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0021 × 0020 ÷ 200D ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 200D ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 ÷ 200D ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0021 ÷ 00A7 ÷	#  × [0.3] EXCLAMATION MARK (EX) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0021 × 0020 ÷ 00A7 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0021 × 0308 ÷ 00A7 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0021 ÷ 50005 ÷	#  × [0.3] EXCLAMATION MARK (EX) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0021 × 0020 ÷ 50005 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0021 × 0308 ÷ 50005 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0021 ÷ 0E01 ÷	#  × [0.3] EXCLAMATION MARK (EX) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0021 × 0020 ÷ 0E01 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0021 × 0308 ÷ 0E01 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0021 × 3041 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0021 × 0020 ÷ 3041 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 3041 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 ÷ 3041 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 00A0 × 0023 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 ÷ 0023 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0023 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 00A0 × 2014 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 ÷ 2014 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 2014 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 00A0 × 0009 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 ÷ 0009 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0009 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 00A0 × 00B4 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 ÷ 00B4 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 00B4 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 00A0 × 000B ÷	#  × [0.3] NO-BREAK SPACE (GL) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 × 000B ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 000B ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 × 000B ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 00A0 × FFFC ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 ÷ FFFC ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × FFFC ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 00A0 × 007D ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 × 007D ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 007D ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 × 007D ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 00A0 × 000D ÷	#  × [0.3] NO-BREAK SPACE (GL) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 × 000D ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 000D ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 × 000D ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 00A0 × 0021 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 × 0021 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0021 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 × 0021 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 00A0 × 00A0 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 ÷ 00A0 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 00A0 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 00A0 × AC00 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 ÷ AC00 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × AC00 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 00A0 × AC01 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 ÷ AC01 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × AC01 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 00A0 × 05D0 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 ÷ 05D0 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 05D0 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 00A0 × 002D ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 ÷ 002D ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 002D ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 ÷ 002D ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 00A0 × 231A ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 ÷ 231A ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 231A ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 ÷ 231A ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 00A0 × 2024 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 ÷ 2024 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 2024 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 00A0 × 002C ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] COMMA (IS) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 × 002C ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 002C ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] COMMA (IS) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 × 002C ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 00A0 × 1100 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 ÷ 1100 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 1100 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 00A0 × 11A8 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 ÷ 11A8 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 11A8 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 00A0 × 1160 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 ÷ 1160 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 1160 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 00A0 × 000A ÷	#  × [0.3] NO-BREAK SPACE (GL) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 × 000A ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 000A ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 × 000A ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 00A0 × 0085 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 × 0085 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0085 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 × 0085 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 00A0 × 17D6 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 ÷ 17D6 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 17D6 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 00A0 × 0030 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 ÷ 0030 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0030 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 00A0 × 2329 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 ÷ 2329 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 2329 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 ÷ 2329 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 00A0 × 0025 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 ÷ 0025 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0025 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 00A0 × 0024 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 ÷ 0024 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0024 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 00A0 × 0022 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 ÷ 0022 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0022 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 × 0020 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 × 0020 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 00A0 × 002F ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 × 002F ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 002F ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 × 002F ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 00A0 × 2060 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 × 2060 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 2060 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 × 2060 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 00A0 × 200B ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 × 200B ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 200B ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 × 200B ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 00A0 × 1F1E6 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 ÷ 1F1E6 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 1F1E6 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 00A0 × 261D ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 ÷ 261D ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 261D ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 ÷ 261D ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 00A0 × 1F3FB ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 ÷ 1F3FB ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 1F3FB ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 00A0 × 0029 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 × 0029 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0029 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 × 0029 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 00A0 × 0028 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 ÷ 0028 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0028 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 00A0 × 0001 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 ÷ 0001 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0001 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 00A0 × 200D ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 ÷ 200D ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 200D ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 ÷ 200D ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 00A0 × 00A7 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 ÷ 00A7 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 00A7 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 00A0 × 50005 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 ÷ 50005 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 50005 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 00A0 × 0E01 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 ÷ 0E01 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0E01 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 00A0 × 3041 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 ÷ 3041 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 3041 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 ÷ 3041 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× AC00 ÷ 0023 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× AC00 × 0020 ÷ 0023 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× AC00 × 0308 ÷ 0023 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× AC00 ÷ 2014 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× AC00 × 0020 ÷ 2014 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× AC00 × 0308 ÷ 2014 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× AC00 × 0009 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× AC00 × 0020 ÷ 0009 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0009 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× AC00 ÷ 00B4 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× AC00 × 0020 ÷ 00B4 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× AC00 × 0308 ÷ 00B4 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× AC00 × 000B ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× AC00 × 0020 × 000B ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 000B ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 × 000B ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× AC00 ÷ FFFC ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× AC00 × 0020 ÷ FFFC ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× AC00 × 0308 ÷ FFFC ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× AC00 × 007D ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× AC00 × 0020 × 007D ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 007D ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 × 007D ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× AC00 × 000D ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× AC00 × 0020 × 000D ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 000D ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 × 000D ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× AC00 × 0021 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× AC00 × 0020 × 0021 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0021 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 × 0021 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× AC00 × 00A0 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [12.1] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× AC00 × 0020 ÷ 00A0 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 00A0 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× AC00 ÷ AC00 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× AC00 × 0020 ÷ AC00 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× AC00 × 0308 ÷ AC00 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× AC00 ÷ AC01 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× AC00 × 0020 ÷ AC01 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× AC00 × 0308 ÷ AC01 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× AC00 ÷ 05D0 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× AC00 × 0020 ÷ 05D0 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× AC00 × 0308 ÷ 05D0 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× AC00 × 002D ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× AC00 × 0020 ÷ 002D ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 002D ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 ÷ 002D ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× AC00 ÷ 231A ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× AC00 × 0020 ÷ 231A ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× AC00 × 0308 ÷ 231A ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 ÷ 231A ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× AC00 × 2024 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× AC00 × 0020 ÷ 2024 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 2024 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× AC00 × 002C ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× AC00 × 0020 × 002C ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 002C ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 × 002C ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× AC00 ÷ 1100 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× AC00 × 0020 ÷ 1100 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× AC00 × 0308 ÷ 1100 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× AC00 × 11A8 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [26.02] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× AC00 × 0020 ÷ 11A8 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 11A8 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [26.02] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× AC00 × 1160 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [26.02] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× AC00 × 0020 ÷ 1160 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 1160 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [26.02] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× AC00 × 000A ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× AC00 × 0020 × 000A ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 000A ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 × 000A ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× AC00 × 0085 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× AC00 × 0020 × 0085 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0085 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 × 0085 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× AC00 × 17D6 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× AC00 × 0020 ÷ 17D6 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 17D6 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× AC00 ÷ 0030 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× AC00 × 0020 ÷ 0030 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× AC00 × 0308 ÷ 0030 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× AC00 ÷ 2329 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) ÷ [999.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× AC00 × 0020 ÷ 2329 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× AC00 × 0308 ÷ 2329 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 ÷ 2329 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× AC00 × 0025 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [27.02] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× AC00 × 0020 ÷ 0025 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0025 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [27.02] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× AC00 ÷ 0024 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× AC00 × 0020 ÷ 0024 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× AC00 × 0308 ÷ 0024 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× AC00 × 0022 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× AC00 × 0020 ÷ 0022 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0022 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× AC00 × 0020 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× AC00 × 0020 × 0020 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 × 0020 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× AC00 × 002F ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× AC00 × 0020 × 002F ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 002F ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 × 002F ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× AC00 × 2060 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× AC00 × 0020 × 2060 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 2060 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 × 2060 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× AC00 × 200B ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× AC00 × 0020 × 200B ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 200B ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 × 200B ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× AC00 ÷ 1F1E6 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× AC00 × 0020 ÷ 1F1E6 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× AC00 × 0308 ÷ 1F1E6 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× AC00 ÷ 261D ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× AC00 × 0020 ÷ 261D ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× AC00 × 0308 ÷ 261D ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 ÷ 261D ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× AC00 ÷ 1F3FB ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× AC00 × 0020 ÷ 1F3FB ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× AC00 × 0308 ÷ 1F3FB ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× AC00 × 0029 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× AC00 × 0020 × 0029 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0029 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 × 0029 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× AC00 ÷ 0028 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× AC00 × 0020 ÷ 0028 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× AC00 × 0308 ÷ 0028 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× AC00 × 0001 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× AC00 × 0020 ÷ 0001 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0001 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× AC00 × 200D ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× AC00 × 0020 ÷ 200D ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 200D ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 ÷ 200D ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× AC00 ÷ 00A7 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× AC00 × 0020 ÷ 00A7 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× AC00 × 0308 ÷ 00A7 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× AC00 ÷ 50005 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× AC00 × 0020 ÷ 50005 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× AC00 × 0308 ÷ 50005 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× AC00 ÷ 0E01 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× AC00 × 0020 ÷ 0E01 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× AC00 × 0308 ÷ 0E01 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× AC00 × 3041 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× AC00 × 0020 ÷ 3041 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 3041 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 ÷ 3041 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× AC01 ÷ 0023 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× AC01 × 0020 ÷ 0023 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× AC01 × 0308 ÷ 0023 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× AC01 ÷ 2014 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× AC01 × 0020 ÷ 2014 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× AC01 × 0308 ÷ 2014 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× AC01 × 0009 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× AC01 × 0020 ÷ 0009 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0009 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× AC01 ÷ 00B4 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× AC01 × 0020 ÷ 00B4 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× AC01 × 0308 ÷ 00B4 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× AC01 × 000B ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× AC01 × 0020 × 000B ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 000B ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 × 000B ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× AC01 ÷ FFFC ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× AC01 × 0020 ÷ FFFC ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
}
if (!$::TESTCHUNK or $::TESTCHUNK == 7) {
    Test_LB('× AC01 × 0308 ÷ FFFC ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× AC01 × 007D ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× AC01 × 0020 × 007D ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 007D ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 × 007D ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× AC01 × 000D ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× AC01 × 0020 × 000D ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 000D ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 × 000D ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× AC01 × 0021 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× AC01 × 0020 × 0021 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0021 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 × 0021 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× AC01 × 00A0 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [12.1] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× AC01 × 0020 ÷ 00A0 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 00A0 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× AC01 ÷ AC00 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× AC01 × 0020 ÷ AC00 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× AC01 × 0308 ÷ AC00 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× AC01 ÷ AC01 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× AC01 × 0020 ÷ AC01 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× AC01 × 0308 ÷ AC01 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× AC01 ÷ 05D0 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× AC01 × 0020 ÷ 05D0 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× AC01 × 0308 ÷ 05D0 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× AC01 × 002D ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× AC01 × 0020 ÷ 002D ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 002D ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 ÷ 002D ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× AC01 ÷ 231A ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× AC01 × 0020 ÷ 231A ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× AC01 × 0308 ÷ 231A ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 ÷ 231A ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× AC01 × 2024 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× AC01 × 0020 ÷ 2024 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 2024 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× AC01 × 002C ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× AC01 × 0020 × 002C ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 002C ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 × 002C ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× AC01 ÷ 1100 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× AC01 × 0020 ÷ 1100 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× AC01 × 0308 ÷ 1100 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× AC01 × 11A8 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [26.03] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× AC01 × 0020 ÷ 11A8 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 11A8 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [26.03] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× AC01 ÷ 1160 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× AC01 × 0020 ÷ 1160 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× AC01 × 0308 ÷ 1160 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× AC01 × 000A ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× AC01 × 0020 × 000A ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 000A ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 × 000A ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× AC01 × 0085 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× AC01 × 0020 × 0085 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0085 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 × 0085 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× AC01 × 17D6 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× AC01 × 0020 ÷ 17D6 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 17D6 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× AC01 ÷ 0030 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× AC01 × 0020 ÷ 0030 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× AC01 × 0308 ÷ 0030 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× AC01 ÷ 2329 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) ÷ [999.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× AC01 × 0020 ÷ 2329 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× AC01 × 0308 ÷ 2329 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 ÷ 2329 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× AC01 × 0025 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [27.02] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× AC01 × 0020 ÷ 0025 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0025 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [27.02] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× AC01 ÷ 0024 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× AC01 × 0020 ÷ 0024 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× AC01 × 0308 ÷ 0024 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× AC01 × 0022 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× AC01 × 0020 ÷ 0022 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0022 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× AC01 × 0020 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× AC01 × 0020 × 0020 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 × 0020 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× AC01 × 002F ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× AC01 × 0020 × 002F ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 002F ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 × 002F ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× AC01 × 2060 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× AC01 × 0020 × 2060 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 2060 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 × 2060 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× AC01 × 200B ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× AC01 × 0020 × 200B ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 200B ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 × 200B ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× AC01 ÷ 1F1E6 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× AC01 × 0020 ÷ 1F1E6 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× AC01 × 0308 ÷ 1F1E6 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× AC01 ÷ 261D ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× AC01 × 0020 ÷ 261D ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× AC01 × 0308 ÷ 261D ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 ÷ 261D ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× AC01 ÷ 1F3FB ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× AC01 × 0020 ÷ 1F3FB ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× AC01 × 0308 ÷ 1F3FB ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× AC01 × 0029 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× AC01 × 0020 × 0029 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0029 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 × 0029 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× AC01 ÷ 0028 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× AC01 × 0020 ÷ 0028 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× AC01 × 0308 ÷ 0028 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× AC01 × 0001 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× AC01 × 0020 ÷ 0001 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0001 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× AC01 × 200D ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× AC01 × 0020 ÷ 200D ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 200D ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 ÷ 200D ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× AC01 ÷ 00A7 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× AC01 × 0020 ÷ 00A7 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× AC01 × 0308 ÷ 00A7 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× AC01 ÷ 50005 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× AC01 × 0020 ÷ 50005 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× AC01 × 0308 ÷ 50005 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× AC01 ÷ 0E01 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× AC01 × 0020 ÷ 0E01 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× AC01 × 0308 ÷ 0E01 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× AC01 × 3041 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× AC01 × 0020 ÷ 3041 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 3041 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 ÷ 3041 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 05D0 × 0023 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [28.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 ÷ 0023 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0023 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [28.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 05D0 ÷ 2014 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 ÷ 2014 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 ÷ 2014 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 05D0 × 0009 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 ÷ 0009 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0009 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 05D0 ÷ 00B4 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 ÷ 00B4 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 ÷ 00B4 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 05D0 × 000B ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 × 000B ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 000B ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 × 000B ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 05D0 ÷ FFFC ÷	#  × [0.3] HEBREW LETTER ALEF (HL) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 ÷ FFFC ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 ÷ FFFC ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 05D0 × 007D ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 × 007D ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 007D ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 × 007D ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 05D0 × 000D ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 × 000D ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 000D ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 × 000D ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 05D0 × 0021 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 × 0021 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0021 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 × 0021 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 05D0 × 00A0 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [12.1] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 ÷ 00A0 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 00A0 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 05D0 ÷ AC00 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 ÷ AC00 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 ÷ AC00 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 05D0 ÷ AC01 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 ÷ AC01 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 ÷ AC01 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 05D0 × 05D0 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [28.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 ÷ 05D0 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 05D0 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [28.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 05D0 × 002D ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 ÷ 002D ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 002D ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 ÷ 002D ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 05D0 ÷ 231A ÷	#  × [0.3] HEBREW LETTER ALEF (HL) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 ÷ 231A ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 ÷ 231A ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 ÷ 231A ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 05D0 × 2024 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 ÷ 2024 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 2024 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 05D0 × 002C ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 × 002C ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 002C ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 × 002C ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 05D0 ÷ 1100 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 ÷ 1100 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 ÷ 1100 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 05D0 ÷ 11A8 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 ÷ 11A8 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 ÷ 11A8 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 05D0 ÷ 1160 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 ÷ 1160 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 ÷ 1160 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 05D0 × 000A ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 × 000A ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 000A ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 × 000A ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 05D0 × 0085 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 × 0085 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0085 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 × 0085 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 05D0 × 17D6 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 ÷ 17D6 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 17D6 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 05D0 × 0030 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [23.02] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 ÷ 0030 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0030 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [23.02] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 05D0 ÷ 2329 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) ÷ [999.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 ÷ 2329 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 ÷ 2329 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 ÷ 2329 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 05D0 × 0025 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [24.03] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 ÷ 0025 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0025 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [24.03] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 05D0 × 0024 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [24.03] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 ÷ 0024 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0024 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [24.03] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 05D0 × 0022 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 ÷ 0022 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0022 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 × 0020 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 × 0020 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 05D0 × 002F ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 × 002F ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 002F ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 × 002F ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 05D0 × 2060 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 × 2060 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 2060 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 × 2060 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 05D0 × 200B ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 × 200B ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 200B ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 × 200B ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 05D0 ÷ 1F1E6 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 ÷ 1F1E6 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 ÷ 1F1E6 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 05D0 ÷ 261D ÷	#  × [0.3] HEBREW LETTER ALEF (HL) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 ÷ 261D ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 ÷ 261D ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 ÷ 261D ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 05D0 ÷ 1F3FB ÷	#  × [0.3] HEBREW LETTER ALEF (HL) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 ÷ 1F3FB ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 ÷ 1F3FB ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 05D0 × 0029 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 × 0029 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0029 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 × 0029 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 05D0 × 0028 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [30.01] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 ÷ 0028 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0028 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [30.01] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 05D0 × 0001 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 ÷ 0001 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0001 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 05D0 × 200D ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 ÷ 200D ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 200D ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 ÷ 200D ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 05D0 × 00A7 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [28.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 ÷ 00A7 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 00A7 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [28.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 05D0 × 50005 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [28.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 ÷ 50005 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 50005 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [28.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 05D0 × 0E01 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [28.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 ÷ 0E01 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0E01 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [28.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 05D0 × 3041 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 ÷ 3041 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 3041 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 ÷ 3041 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 002D ÷ 0023 ÷	#  × [0.3] HYPHEN-MINUS (HY) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 002D × 0020 ÷ 0023 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 002D × 0308 ÷ 0023 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 002D ÷ 2014 ÷	#  × [0.3] HYPHEN-MINUS (HY) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 002D × 0020 ÷ 2014 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 002D × 0308 ÷ 2014 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 002D × 0009 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 002D × 0020 ÷ 0009 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0009 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 002D ÷ 00B4 ÷	#  × [0.3] HYPHEN-MINUS (HY) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 002D × 0020 ÷ 00B4 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 002D × 0308 ÷ 00B4 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 002D × 000B ÷	#  × [0.3] HYPHEN-MINUS (HY) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 002D × 0020 × 000B ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 000B ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 × 000B ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 002D ÷ FFFC ÷	#  × [0.3] HYPHEN-MINUS (HY) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 002D × 0020 ÷ FFFC ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 002D × 0308 ÷ FFFC ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 002D × 007D ÷	#  × [0.3] HYPHEN-MINUS (HY) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 002D × 0020 × 007D ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 007D ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 × 007D ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 002D × 000D ÷	#  × [0.3] HYPHEN-MINUS (HY) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 002D × 0020 × 000D ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 000D ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 × 000D ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 002D × 0021 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 002D × 0020 × 0021 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0021 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 × 0021 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 002D ÷ 00A0 ÷	#  × [0.3] HYPHEN-MINUS (HY) ÷ [999.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 002D × 0020 ÷ 00A0 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 002D × 0308 ÷ 00A0 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 002D ÷ AC00 ÷	#  × [0.3] HYPHEN-MINUS (HY) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 002D × 0020 ÷ AC00 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 002D × 0308 ÷ AC00 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 002D ÷ AC01 ÷	#  × [0.3] HYPHEN-MINUS (HY) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 002D × 0020 ÷ AC01 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 002D × 0308 ÷ AC01 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 002D ÷ 05D0 ÷	#  × [0.3] HYPHEN-MINUS (HY) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 002D × 0020 ÷ 05D0 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 002D × 0308 ÷ 05D0 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 002D × 002D ÷	#  × [0.3] HYPHEN-MINUS (HY) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 002D × 0020 ÷ 002D ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 002D ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 ÷ 002D ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 002D ÷ 231A ÷	#  × [0.3] HYPHEN-MINUS (HY) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 002D × 0020 ÷ 231A ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 002D × 0308 ÷ 231A ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 ÷ 231A ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 002D × 2024 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 002D × 0020 ÷ 2024 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 2024 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 002D × 002C ÷	#  × [0.3] HYPHEN-MINUS (HY) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 002D × 0020 × 002C ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 002C ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 × 002C ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 002D ÷ 1100 ÷	#  × [0.3] HYPHEN-MINUS (HY) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 002D × 0020 ÷ 1100 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 002D × 0308 ÷ 1100 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 002D ÷ 11A8 ÷	#  × [0.3] HYPHEN-MINUS (HY) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 002D × 0020 ÷ 11A8 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 002D × 0308 ÷ 11A8 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 002D ÷ 1160 ÷	#  × [0.3] HYPHEN-MINUS (HY) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 002D × 0020 ÷ 1160 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 002D × 0308 ÷ 1160 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 002D × 000A ÷	#  × [0.3] HYPHEN-MINUS (HY) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 002D × 0020 × 000A ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 000A ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 × 000A ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 002D × 0085 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 002D × 0020 × 0085 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0085 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 × 0085 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 002D × 17D6 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 002D × 0020 ÷ 17D6 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 17D6 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 002D × 0030 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [25.02] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 002D × 0020 ÷ 0030 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0030 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [25.02] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 002D ÷ 2329 ÷	#  × [0.3] HYPHEN-MINUS (HY) ÷ [999.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 002D × 0020 ÷ 2329 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 002D × 0308 ÷ 2329 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 ÷ 2329 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 002D ÷ 0025 ÷	#  × [0.3] HYPHEN-MINUS (HY) ÷ [999.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 002D × 0020 ÷ 0025 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 002D × 0308 ÷ 0025 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 002D ÷ 0024 ÷	#  × [0.3] HYPHEN-MINUS (HY) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 002D × 0020 ÷ 0024 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 002D × 0308 ÷ 0024 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 002D × 0022 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 002D × 0020 ÷ 0022 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0022 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 002D × 0020 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 002D × 0020 × 0020 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 × 0020 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 002D × 002F ÷	#  × [0.3] HYPHEN-MINUS (HY) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 002D × 0020 × 002F ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 002F ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 × 002F ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 002D × 2060 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 002D × 0020 × 2060 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 2060 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 × 2060 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 002D × 200B ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 002D × 0020 × 200B ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 200B ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 × 200B ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 002D ÷ 1F1E6 ÷	#  × [0.3] HYPHEN-MINUS (HY) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 002D × 0020 ÷ 1F1E6 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 002D × 0308 ÷ 1F1E6 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 002D ÷ 261D ÷	#  × [0.3] HYPHEN-MINUS (HY) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 002D × 0020 ÷ 261D ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 002D × 0308 ÷ 261D ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 ÷ 261D ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 002D ÷ 1F3FB ÷	#  × [0.3] HYPHEN-MINUS (HY) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 002D × 0020 ÷ 1F3FB ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 002D × 0308 ÷ 1F3FB ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 002D × 0029 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 002D × 0020 × 0029 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0029 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 × 0029 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 002D ÷ 0028 ÷	#  × [0.3] HYPHEN-MINUS (HY) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 002D × 0020 ÷ 0028 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 002D × 0308 ÷ 0028 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 002D × 0001 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 002D × 0020 ÷ 0001 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0001 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 002D × 200D ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 002D × 0020 ÷ 200D ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 200D ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 ÷ 200D ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 002D ÷ 00A7 ÷	#  × [0.3] HYPHEN-MINUS (HY) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 002D × 0020 ÷ 00A7 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 002D × 0308 ÷ 00A7 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 002D ÷ 50005 ÷	#  × [0.3] HYPHEN-MINUS (HY) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 002D × 0020 ÷ 50005 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 002D × 0308 ÷ 50005 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 002D ÷ 0E01 ÷	#  × [0.3] HYPHEN-MINUS (HY) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 002D × 0020 ÷ 0E01 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 002D × 0308 ÷ 0E01 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 002D × 3041 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 002D × 0020 ÷ 3041 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 3041 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 ÷ 3041 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 231A ÷ 0023 ÷	#  × [0.3] WATCH (ID) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 231A × 0020 ÷ 0023 ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 231A × 0308 ÷ 0023 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 231A ÷ 2014 ÷	#  × [0.3] WATCH (ID) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 231A × 0020 ÷ 2014 ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 231A × 0308 ÷ 2014 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 231A × 0009 ÷	#  × [0.3] WATCH (ID) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 231A × 0020 ÷ 0009 ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0009 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 231A ÷ 00B4 ÷	#  × [0.3] WATCH (ID) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 231A × 0020 ÷ 00B4 ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 231A × 0308 ÷ 00B4 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 231A × 000B ÷	#  × [0.3] WATCH (ID) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 231A × 0020 × 000B ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 000B ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 × 000B ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 231A ÷ FFFC ÷	#  × [0.3] WATCH (ID) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 231A × 0020 ÷ FFFC ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 231A × 0308 ÷ FFFC ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 231A × 007D ÷	#  × [0.3] WATCH (ID) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 231A × 0020 × 007D ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 007D ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 × 007D ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 231A × 000D ÷	#  × [0.3] WATCH (ID) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 231A × 0020 × 000D ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 000D ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 × 000D ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 231A × 0021 ÷	#  × [0.3] WATCH (ID) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 231A × 0020 × 0021 ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0021 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 × 0021 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 231A × 00A0 ÷	#  × [0.3] WATCH (ID) × [12.1] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 231A × 0020 ÷ 00A0 ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 00A0 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 231A ÷ AC00 ÷	#  × [0.3] WATCH (ID) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 231A × 0020 ÷ AC00 ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 231A × 0308 ÷ AC00 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 231A ÷ AC01 ÷	#  × [0.3] WATCH (ID) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 231A × 0020 ÷ AC01 ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 231A × 0308 ÷ AC01 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 231A ÷ 05D0 ÷	#  × [0.3] WATCH (ID) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 231A × 0020 ÷ 05D0 ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 231A × 0308 ÷ 05D0 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 231A × 002D ÷	#  × [0.3] WATCH (ID) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 231A × 0020 ÷ 002D ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 002D ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 ÷ 002D ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 231A ÷ 231A ÷	#  × [0.3] WATCH (ID) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 231A × 0020 ÷ 231A ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 231A × 0308 ÷ 231A ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 ÷ 231A ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 231A × 2024 ÷	#  × [0.3] WATCH (ID) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 231A × 0020 ÷ 2024 ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 2024 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 231A × 002C ÷	#  × [0.3] WATCH (ID) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 231A × 0020 × 002C ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 002C ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 × 002C ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 231A ÷ 1100 ÷	#  × [0.3] WATCH (ID) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 231A × 0020 ÷ 1100 ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 231A × 0308 ÷ 1100 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 231A ÷ 11A8 ÷	#  × [0.3] WATCH (ID) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 231A × 0020 ÷ 11A8 ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 231A × 0308 ÷ 11A8 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 231A ÷ 1160 ÷	#  × [0.3] WATCH (ID) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 231A × 0020 ÷ 1160 ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 231A × 0308 ÷ 1160 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 231A × 000A ÷	#  × [0.3] WATCH (ID) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 231A × 0020 × 000A ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 000A ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 × 000A ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 231A × 0085 ÷	#  × [0.3] WATCH (ID) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 231A × 0020 × 0085 ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0085 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 × 0085 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 231A × 17D6 ÷	#  × [0.3] WATCH (ID) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 231A × 0020 ÷ 17D6 ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 17D6 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 231A ÷ 0030 ÷	#  × [0.3] WATCH (ID) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 231A × 0020 ÷ 0030 ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 231A × 0308 ÷ 0030 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 231A ÷ 2329 ÷	#  × [0.3] WATCH (ID) ÷ [999.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 231A × 0020 ÷ 2329 ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 231A × 0308 ÷ 2329 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 ÷ 2329 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 231A × 0025 ÷	#  × [0.3] WATCH (ID) × [23.13] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 231A × 0020 ÷ 0025 ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0025 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [23.13] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 231A ÷ 0024 ÷	#  × [0.3] WATCH (ID) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 231A × 0020 ÷ 0024 ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 231A × 0308 ÷ 0024 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 231A × 0022 ÷	#  × [0.3] WATCH (ID) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 231A × 0020 ÷ 0022 ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0022 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 231A × 0020 ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 231A × 0020 × 0020 ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 × 0020 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 231A × 002F ÷	#  × [0.3] WATCH (ID) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 231A × 0020 × 002F ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 002F ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 × 002F ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 231A × 2060 ÷	#  × [0.3] WATCH (ID) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 231A × 0020 × 2060 ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 2060 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 × 2060 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 231A × 200B ÷	#  × [0.3] WATCH (ID) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 231A × 0020 × 200B ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 200B ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 × 200B ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 231A ÷ 1F1E6 ÷	#  × [0.3] WATCH (ID) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 231A × 0020 ÷ 1F1E6 ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 231A × 0308 ÷ 1F1E6 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 231A ÷ 261D ÷	#  × [0.3] WATCH (ID) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 231A × 0020 ÷ 261D ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 231A × 0308 ÷ 261D ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 ÷ 261D ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 231A ÷ 1F3FB ÷	#  × [0.3] WATCH (ID) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 231A × 0020 ÷ 1F3FB ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 231A × 0308 ÷ 1F3FB ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 231A × 0029 ÷	#  × [0.3] WATCH (ID) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 231A × 0020 × 0029 ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0029 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 × 0029 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 231A ÷ 0028 ÷	#  × [0.3] WATCH (ID) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 231A × 0020 ÷ 0028 ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 231A × 0308 ÷ 0028 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 231A × 0001 ÷	#  × [0.3] WATCH (ID) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 231A × 0020 ÷ 0001 ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0001 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 231A × 200D ÷	#  × [0.3] WATCH (ID) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 231A × 0020 ÷ 200D ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 200D ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 ÷ 200D ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 231A ÷ 00A7 ÷	#  × [0.3] WATCH (ID) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 231A × 0020 ÷ 00A7 ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 231A × 0308 ÷ 00A7 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 231A ÷ 50005 ÷	#  × [0.3] WATCH (ID) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 231A × 0020 ÷ 50005 ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 231A × 0308 ÷ 50005 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 231A ÷ 0E01 ÷	#  × [0.3] WATCH (ID) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 231A × 0020 ÷ 0E01 ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 231A × 0308 ÷ 0E01 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 231A × 3041 ÷	#  × [0.3] WATCH (ID) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 231A × 0020 ÷ 3041 ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 3041 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 ÷ 3041 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 2024 ÷ 0023 ÷	#  × [0.3] ONE DOT LEADER (IN) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 2024 × 0020 ÷ 0023 ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 2024 × 0308 ÷ 0023 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 2024 ÷ 2014 ÷	#  × [0.3] ONE DOT LEADER (IN) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 2024 × 0020 ÷ 2014 ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 2024 × 0308 ÷ 2014 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 2024 × 0009 ÷	#  × [0.3] ONE DOT LEADER (IN) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 2024 × 0020 ÷ 0009 ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0009 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 2024 ÷ 00B4 ÷	#  × [0.3] ONE DOT LEADER (IN) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 2024 × 0020 ÷ 00B4 ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 2024 × 0308 ÷ 00B4 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 2024 × 000B ÷	#  × [0.3] ONE DOT LEADER (IN) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 2024 × 0020 × 000B ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 000B ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 × 000B ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 2024 ÷ FFFC ÷	#  × [0.3] ONE DOT LEADER (IN) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 2024 × 0020 ÷ FFFC ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 2024 × 0308 ÷ FFFC ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 2024 × 007D ÷	#  × [0.3] ONE DOT LEADER (IN) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 2024 × 0020 × 007D ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 007D ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 × 007D ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 2024 × 000D ÷	#  × [0.3] ONE DOT LEADER (IN) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 2024 × 0020 × 000D ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 000D ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 × 000D ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 2024 × 0021 ÷	#  × [0.3] ONE DOT LEADER (IN) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 2024 × 0020 × 0021 ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0021 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 × 0021 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 2024 × 00A0 ÷	#  × [0.3] ONE DOT LEADER (IN) × [12.1] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 2024 × 0020 ÷ 00A0 ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 00A0 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 2024 ÷ AC00 ÷	#  × [0.3] ONE DOT LEADER (IN) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 2024 × 0020 ÷ AC00 ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 2024 × 0308 ÷ AC00 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 2024 ÷ AC01 ÷	#  × [0.3] ONE DOT LEADER (IN) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 2024 × 0020 ÷ AC01 ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 2024 × 0308 ÷ AC01 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 2024 ÷ 05D0 ÷	#  × [0.3] ONE DOT LEADER (IN) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 2024 × 0020 ÷ 05D0 ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 2024 × 0308 ÷ 05D0 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 2024 × 002D ÷	#  × [0.3] ONE DOT LEADER (IN) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 2024 × 0020 ÷ 002D ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 002D ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 ÷ 002D ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 2024 ÷ 231A ÷	#  × [0.3] ONE DOT LEADER (IN) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 2024 × 0020 ÷ 231A ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 2024 × 0308 ÷ 231A ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 ÷ 231A ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 2024 × 2024 ÷	#  × [0.3] ONE DOT LEADER (IN) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 2024 × 0020 ÷ 2024 ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 2024 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 2024 × 002C ÷	#  × [0.3] ONE DOT LEADER (IN) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 2024 × 0020 × 002C ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 002C ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 × 002C ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 2024 ÷ 1100 ÷	#  × [0.3] ONE DOT LEADER (IN) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 2024 × 0020 ÷ 1100 ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 2024 × 0308 ÷ 1100 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 2024 ÷ 11A8 ÷	#  × [0.3] ONE DOT LEADER (IN) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 2024 × 0020 ÷ 11A8 ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 2024 × 0308 ÷ 11A8 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 2024 ÷ 1160 ÷	#  × [0.3] ONE DOT LEADER (IN) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 2024 × 0020 ÷ 1160 ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 2024 × 0308 ÷ 1160 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 2024 × 000A ÷	#  × [0.3] ONE DOT LEADER (IN) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 2024 × 0020 × 000A ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 000A ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 × 000A ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 2024 × 0085 ÷	#  × [0.3] ONE DOT LEADER (IN) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 2024 × 0020 × 0085 ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0085 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 × 0085 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 2024 × 17D6 ÷	#  × [0.3] ONE DOT LEADER (IN) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 2024 × 0020 ÷ 17D6 ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 17D6 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 2024 ÷ 0030 ÷	#  × [0.3] ONE DOT LEADER (IN) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 2024 × 0020 ÷ 0030 ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 2024 × 0308 ÷ 0030 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 2024 ÷ 2329 ÷	#  × [0.3] ONE DOT LEADER (IN) ÷ [999.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 2024 × 0020 ÷ 2329 ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 2024 × 0308 ÷ 2329 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 ÷ 2329 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 2024 ÷ 0025 ÷	#  × [0.3] ONE DOT LEADER (IN) ÷ [999.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 2024 × 0020 ÷ 0025 ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 2024 × 0308 ÷ 0025 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 2024 ÷ 0024 ÷	#  × [0.3] ONE DOT LEADER (IN) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 2024 × 0020 ÷ 0024 ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 2024 × 0308 ÷ 0024 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 2024 × 0022 ÷	#  × [0.3] ONE DOT LEADER (IN) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 2024 × 0020 ÷ 0022 ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0022 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 2024 × 0020 ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 2024 × 0020 × 0020 ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 × 0020 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 2024 × 002F ÷	#  × [0.3] ONE DOT LEADER (IN) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 2024 × 0020 × 002F ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 002F ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 × 002F ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 2024 × 2060 ÷	#  × [0.3] ONE DOT LEADER (IN) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 2024 × 0020 × 2060 ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 2060 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 × 2060 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 2024 × 200B ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 2024 × 0020 × 200B ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 200B ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 × 200B ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 2024 ÷ 1F1E6 ÷	#  × [0.3] ONE DOT LEADER (IN) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 2024 × 0020 ÷ 1F1E6 ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 2024 × 0308 ÷ 1F1E6 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 2024 ÷ 261D ÷	#  × [0.3] ONE DOT LEADER (IN) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 2024 × 0020 ÷ 261D ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 2024 × 0308 ÷ 261D ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 ÷ 261D ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 2024 ÷ 1F3FB ÷	#  × [0.3] ONE DOT LEADER (IN) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 2024 × 0020 ÷ 1F3FB ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 2024 × 0308 ÷ 1F3FB ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 2024 × 0029 ÷	#  × [0.3] ONE DOT LEADER (IN) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 2024 × 0020 × 0029 ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0029 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 × 0029 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 2024 ÷ 0028 ÷	#  × [0.3] ONE DOT LEADER (IN) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 2024 × 0020 ÷ 0028 ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 2024 × 0308 ÷ 0028 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 2024 × 0001 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 2024 × 0020 ÷ 0001 ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0001 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 2024 × 200D ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 2024 × 0020 ÷ 200D ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 200D ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 ÷ 200D ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 2024 ÷ 00A7 ÷	#  × [0.3] ONE DOT LEADER (IN) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 2024 × 0020 ÷ 00A7 ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 2024 × 0308 ÷ 00A7 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 2024 ÷ 50005 ÷	#  × [0.3] ONE DOT LEADER (IN) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 2024 × 0020 ÷ 50005 ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 2024 × 0308 ÷ 50005 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 2024 ÷ 0E01 ÷	#  × [0.3] ONE DOT LEADER (IN) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 2024 × 0020 ÷ 0E01 ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 2024 × 0308 ÷ 0E01 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 2024 × 3041 ÷	#  × [0.3] ONE DOT LEADER (IN) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 2024 × 0020 ÷ 3041 ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 3041 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 ÷ 3041 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 002C × 0023 ÷	#  × [0.3] COMMA (IS) × [29.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 002C × 0020 ÷ 0023 ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0023 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [29.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 002C ÷ 2014 ÷	#  × [0.3] COMMA (IS) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 002C × 0020 ÷ 2014 ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 002C × 0308 ÷ 2014 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 002C × 0009 ÷	#  × [0.3] COMMA (IS) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 002C × 0020 ÷ 0009 ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0009 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 002C ÷ 00B4 ÷	#  × [0.3] COMMA (IS) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 002C × 0020 ÷ 00B4 ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 002C × 0308 ÷ 00B4 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 002C × 000B ÷	#  × [0.3] COMMA (IS) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 002C × 0020 × 000B ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 000B ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 × 000B ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 002C ÷ FFFC ÷	#  × [0.3] COMMA (IS) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 002C × 0020 ÷ FFFC ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 002C × 0308 ÷ FFFC ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 002C × 007D ÷	#  × [0.3] COMMA (IS) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 002C × 0020 × 007D ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 007D ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 × 007D ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 002C × 000D ÷	#  × [0.3] COMMA (IS) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 002C × 0020 × 000D ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 000D ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 × 000D ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 002C × 0021 ÷	#  × [0.3] COMMA (IS) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 002C × 0020 × 0021 ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0021 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 × 0021 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 002C × 00A0 ÷	#  × [0.3] COMMA (IS) × [12.1] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 002C × 0020 ÷ 00A0 ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 00A0 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 002C ÷ AC00 ÷	#  × [0.3] COMMA (IS) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 002C × 0020 ÷ AC00 ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 002C × 0308 ÷ AC00 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 002C ÷ AC01 ÷	#  × [0.3] COMMA (IS) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 002C × 0020 ÷ AC01 ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 002C × 0308 ÷ AC01 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 002C × 05D0 ÷	#  × [0.3] COMMA (IS) × [29.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 002C × 0020 ÷ 05D0 ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 05D0 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [29.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 002C × 002D ÷	#  × [0.3] COMMA (IS) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 002C × 0020 ÷ 002D ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 002D ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 ÷ 002D ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 002C ÷ 231A ÷	#  × [0.3] COMMA (IS) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 002C × 0020 ÷ 231A ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 002C × 0308 ÷ 231A ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 ÷ 231A ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 002C × 2024 ÷	#  × [0.3] COMMA (IS) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 002C × 0020 ÷ 2024 ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 2024 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 002C × 002C ÷	#  × [0.3] COMMA (IS) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 002C × 0020 × 002C ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 002C ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 × 002C ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 002C ÷ 1100 ÷	#  × [0.3] COMMA (IS) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 002C × 0020 ÷ 1100 ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 002C × 0308 ÷ 1100 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 002C ÷ 11A8 ÷	#  × [0.3] COMMA (IS) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 002C × 0020 ÷ 11A8 ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 002C × 0308 ÷ 11A8 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 002C ÷ 1160 ÷	#  × [0.3] COMMA (IS) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 002C × 0020 ÷ 1160 ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 002C × 0308 ÷ 1160 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 002C × 000A ÷	#  × [0.3] COMMA (IS) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 002C × 0020 × 000A ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 000A ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 × 000A ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 002C × 0085 ÷	#  × [0.3] COMMA (IS) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 002C × 0020 × 0085 ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0085 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 × 0085 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 002C × 17D6 ÷	#  × [0.3] COMMA (IS) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 002C × 0020 ÷ 17D6 ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 17D6 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 002C ÷ 0030 ÷	#  × [0.3] COMMA (IS) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 002C × 0020 ÷ 0030 ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 002C × 0308 ÷ 0030 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 002C ÷ 2329 ÷	#  × [0.3] COMMA (IS) ÷ [999.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 002C × 0020 ÷ 2329 ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 002C × 0308 ÷ 2329 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 ÷ 2329 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 002C ÷ 0025 ÷	#  × [0.3] COMMA (IS) ÷ [999.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 002C × 0020 ÷ 0025 ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 002C × 0308 ÷ 0025 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 002C ÷ 0024 ÷	#  × [0.3] COMMA (IS) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 002C × 0020 ÷ 0024 ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 002C × 0308 ÷ 0024 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 002C × 0022 ÷	#  × [0.3] COMMA (IS) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 002C × 0020 ÷ 0022 ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0022 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 002C × 0020 ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 002C × 0020 × 0020 ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 × 0020 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 002C × 002F ÷	#  × [0.3] COMMA (IS) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 002C × 0020 × 002F ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 002F ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 × 002F ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 002C × 2060 ÷	#  × [0.3] COMMA (IS) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 002C × 0020 × 2060 ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 2060 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 × 2060 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 002C × 200B ÷	#  × [0.3] COMMA (IS) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 002C × 0020 × 200B ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 200B ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 × 200B ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 002C ÷ 1F1E6 ÷	#  × [0.3] COMMA (IS) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 002C × 0020 ÷ 1F1E6 ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 002C × 0308 ÷ 1F1E6 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 002C ÷ 261D ÷	#  × [0.3] COMMA (IS) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 002C × 0020 ÷ 261D ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 002C × 0308 ÷ 261D ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 ÷ 261D ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 002C ÷ 1F3FB ÷	#  × [0.3] COMMA (IS) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 002C × 0020 ÷ 1F3FB ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 002C × 0308 ÷ 1F3FB ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 002C × 0029 ÷	#  × [0.3] COMMA (IS) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 002C × 0020 × 0029 ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0029 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 × 0029 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 002C ÷ 0028 ÷	#  × [0.3] COMMA (IS) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 002C × 0020 ÷ 0028 ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 002C × 0308 ÷ 0028 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 002C × 0001 ÷	#  × [0.3] COMMA (IS) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 002C × 0020 ÷ 0001 ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0001 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 002C × 200D ÷	#  × [0.3] COMMA (IS) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 002C × 0020 ÷ 200D ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 200D ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 ÷ 200D ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 002C × 00A7 ÷	#  × [0.3] COMMA (IS) × [29.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 002C × 0020 ÷ 00A7 ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 00A7 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [29.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 002C × 50005 ÷	#  × [0.3] COMMA (IS) × [29.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 002C × 0020 ÷ 50005 ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 50005 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [29.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 002C × 0E01 ÷	#  × [0.3] COMMA (IS) × [29.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 002C × 0020 ÷ 0E01 ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0E01 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [29.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 002C × 3041 ÷	#  × [0.3] COMMA (IS) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 002C × 0020 ÷ 3041 ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 3041 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 ÷ 3041 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 1100 ÷ 0023 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 1100 × 0020 ÷ 0023 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 1100 × 0308 ÷ 0023 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 1100 ÷ 2014 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 1100 × 0020 ÷ 2014 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 1100 × 0308 ÷ 2014 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 1100 × 0009 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 1100 × 0020 ÷ 0009 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0009 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 1100 ÷ 00B4 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 1100 × 0020 ÷ 00B4 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 1100 × 0308 ÷ 00B4 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 1100 × 000B ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 1100 × 0020 × 000B ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 000B ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 × 000B ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 1100 ÷ FFFC ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 1100 × 0020 ÷ FFFC ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 1100 × 0308 ÷ FFFC ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 1100 × 007D ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 1100 × 0020 × 007D ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 007D ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 × 007D ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 1100 × 000D ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 1100 × 0020 × 000D ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 000D ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 × 000D ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 1100 × 0021 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 1100 × 0020 × 0021 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0021 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 × 0021 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 1100 × 00A0 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [12.1] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 1100 × 0020 ÷ 00A0 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 00A0 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 1100 × AC00 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [26.01] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 1100 × 0020 ÷ AC00 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × AC00 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [26.01] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 1100 × AC01 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [26.01] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 1100 × 0020 ÷ AC01 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × AC01 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [26.01] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 1100 ÷ 05D0 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 1100 × 0020 ÷ 05D0 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 1100 × 0308 ÷ 05D0 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 1100 × 002D ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 1100 × 0020 ÷ 002D ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 002D ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 ÷ 002D ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 1100 ÷ 231A ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 1100 × 0020 ÷ 231A ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 1100 × 0308 ÷ 231A ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 ÷ 231A ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 1100 × 2024 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 1100 × 0020 ÷ 2024 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 2024 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 1100 × 002C ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 1100 × 0020 × 002C ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 002C ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 × 002C ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 1100 × 1100 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [26.01] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 1100 × 0020 ÷ 1100 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 1100 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [26.01] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 1100 ÷ 11A8 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 1100 × 0020 ÷ 11A8 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 1100 × 0308 ÷ 11A8 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 1100 × 1160 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [26.01] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 1100 × 0020 ÷ 1160 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 1160 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [26.01] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 1100 × 000A ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 1100 × 0020 × 000A ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 000A ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 × 000A ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 1100 × 0085 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 1100 × 0020 × 0085 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0085 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 × 0085 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 1100 × 17D6 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 1100 × 0020 ÷ 17D6 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 17D6 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 1100 ÷ 0030 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 1100 × 0020 ÷ 0030 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 1100 × 0308 ÷ 0030 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 1100 ÷ 2329 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) ÷ [999.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 1100 × 0020 ÷ 2329 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 1100 × 0308 ÷ 2329 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 ÷ 2329 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 1100 × 0025 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [27.02] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 1100 × 0020 ÷ 0025 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0025 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [27.02] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 1100 ÷ 0024 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 1100 × 0020 ÷ 0024 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 1100 × 0308 ÷ 0024 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 1100 × 0022 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 1100 × 0020 ÷ 0022 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0022 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 1100 × 0020 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 1100 × 0020 × 0020 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 × 0020 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 1100 × 002F ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 1100 × 0020 × 002F ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 002F ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 × 002F ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 1100 × 2060 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 1100 × 0020 × 2060 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 2060 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 × 2060 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 1100 × 200B ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 1100 × 0020 × 200B ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 200B ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 × 200B ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 1100 ÷ 1F1E6 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 1100 × 0020 ÷ 1F1E6 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 1100 × 0308 ÷ 1F1E6 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 1100 ÷ 261D ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 1100 × 0020 ÷ 261D ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 1100 × 0308 ÷ 261D ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 ÷ 261D ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 1100 ÷ 1F3FB ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 1100 × 0020 ÷ 1F3FB ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 1100 × 0308 ÷ 1F3FB ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 1100 × 0029 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 1100 × 0020 × 0029 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0029 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 × 0029 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 1100 ÷ 0028 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 1100 × 0020 ÷ 0028 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 1100 × 0308 ÷ 0028 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 1100 × 0001 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 1100 × 0020 ÷ 0001 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0001 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 1100 × 200D ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 1100 × 0020 ÷ 200D ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 200D ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 ÷ 200D ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 1100 ÷ 00A7 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 1100 × 0020 ÷ 00A7 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 1100 × 0308 ÷ 00A7 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 1100 ÷ 50005 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 1100 × 0020 ÷ 50005 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 1100 × 0308 ÷ 50005 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 1100 ÷ 0E01 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 1100 × 0020 ÷ 0E01 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 1100 × 0308 ÷ 0E01 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 1100 × 3041 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 1100 × 0020 ÷ 3041 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 3041 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 ÷ 3041 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 11A8 ÷ 0023 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 ÷ 0023 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 ÷ 0023 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 11A8 ÷ 2014 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 ÷ 2014 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 ÷ 2014 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 11A8 × 0009 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 ÷ 0009 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0009 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 11A8 ÷ 00B4 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 ÷ 00B4 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 ÷ 00B4 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 11A8 × 000B ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 × 000B ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 000B ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 × 000B ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 11A8 ÷ FFFC ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 ÷ FFFC ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 ÷ FFFC ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 11A8 × 007D ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 × 007D ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 007D ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 × 007D ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 11A8 × 000D ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 × 000D ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 000D ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 × 000D ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 11A8 × 0021 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 × 0021 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0021 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 × 0021 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 11A8 × 00A0 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [12.1] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 ÷ 00A0 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 00A0 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 11A8 ÷ AC00 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 ÷ AC00 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 ÷ AC00 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 11A8 ÷ AC01 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 ÷ AC01 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 ÷ AC01 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 11A8 ÷ 05D0 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 ÷ 05D0 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 ÷ 05D0 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 11A8 × 002D ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 ÷ 002D ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 002D ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 ÷ 002D ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 11A8 ÷ 231A ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 ÷ 231A ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 ÷ 231A ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 ÷ 231A ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 11A8 × 2024 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 ÷ 2024 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 2024 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 11A8 × 002C ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 × 002C ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 002C ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 × 002C ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 11A8 ÷ 1100 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 ÷ 1100 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 ÷ 1100 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 11A8 × 11A8 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [26.03] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 ÷ 11A8 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 11A8 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [26.03] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 11A8 ÷ 1160 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 ÷ 1160 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 ÷ 1160 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 11A8 × 000A ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 × 000A ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 000A ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 × 000A ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 11A8 × 0085 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 × 0085 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0085 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 × 0085 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 11A8 × 17D6 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 ÷ 17D6 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 17D6 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 11A8 ÷ 0030 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 ÷ 0030 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 ÷ 0030 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 11A8 ÷ 2329 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) ÷ [999.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 ÷ 2329 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 ÷ 2329 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 ÷ 2329 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 11A8 × 0025 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [27.02] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 ÷ 0025 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0025 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [27.02] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 11A8 ÷ 0024 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 ÷ 0024 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 ÷ 0024 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 11A8 × 0022 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 ÷ 0022 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0022 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 × 0020 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 × 0020 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 11A8 × 002F ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 × 002F ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 002F ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 × 002F ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 11A8 × 2060 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 × 2060 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 2060 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 × 2060 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 11A8 × 200B ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 × 200B ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 200B ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 × 200B ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 11A8 ÷ 1F1E6 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 ÷ 1F1E6 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 ÷ 1F1E6 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 11A8 ÷ 261D ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 ÷ 261D ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 ÷ 261D ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 ÷ 261D ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 11A8 ÷ 1F3FB ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 ÷ 1F3FB ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 ÷ 1F3FB ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 11A8 × 0029 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 × 0029 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0029 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 × 0029 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 11A8 ÷ 0028 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 ÷ 0028 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 ÷ 0028 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 11A8 × 0001 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 ÷ 0001 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0001 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 11A8 × 200D ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 ÷ 200D ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 200D ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 ÷ 200D ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 11A8 ÷ 00A7 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 ÷ 00A7 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 ÷ 00A7 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 11A8 ÷ 50005 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 ÷ 50005 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 ÷ 50005 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 11A8 ÷ 0E01 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 ÷ 0E01 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 ÷ 0E01 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 11A8 × 3041 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 ÷ 3041 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 3041 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 ÷ 3041 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 1160 ÷ 0023 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 1160 × 0020 ÷ 0023 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 1160 × 0308 ÷ 0023 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 1160 ÷ 2014 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 1160 × 0020 ÷ 2014 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 1160 × 0308 ÷ 2014 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 1160 × 0009 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 1160 × 0020 ÷ 0009 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0009 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 1160 ÷ 00B4 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 1160 × 0020 ÷ 00B4 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 1160 × 0308 ÷ 00B4 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 1160 × 000B ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 1160 × 0020 × 000B ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 000B ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 × 000B ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 1160 ÷ FFFC ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 1160 × 0020 ÷ FFFC ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 1160 × 0308 ÷ FFFC ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 1160 × 007D ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 1160 × 0020 × 007D ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 007D ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 × 007D ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 1160 × 000D ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 1160 × 0020 × 000D ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 000D ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 × 000D ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 1160 × 0021 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 1160 × 0020 × 0021 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0021 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 × 0021 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 1160 × 00A0 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [12.1] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 1160 × 0020 ÷ 00A0 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 00A0 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 1160 ÷ AC00 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 1160 × 0020 ÷ AC00 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 1160 × 0308 ÷ AC00 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 1160 ÷ AC01 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 1160 × 0020 ÷ AC01 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 1160 × 0308 ÷ AC01 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 1160 ÷ 05D0 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 1160 × 0020 ÷ 05D0 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 1160 × 0308 ÷ 05D0 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 1160 × 002D ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 1160 × 0020 ÷ 002D ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 002D ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 ÷ 002D ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 1160 ÷ 231A ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 1160 × 0020 ÷ 231A ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 1160 × 0308 ÷ 231A ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 ÷ 231A ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 1160 × 2024 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 1160 × 0020 ÷ 2024 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 2024 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 1160 × 002C ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 1160 × 0020 × 002C ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 002C ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 × 002C ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 1160 ÷ 1100 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 1160 × 0020 ÷ 1100 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 1160 × 0308 ÷ 1100 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 1160 × 11A8 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [26.02] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 1160 × 0020 ÷ 11A8 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 11A8 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [26.02] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 1160 × 1160 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [26.02] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 1160 × 0020 ÷ 1160 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 1160 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [26.02] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 1160 × 000A ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 1160 × 0020 × 000A ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 000A ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 × 000A ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 1160 × 0085 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 1160 × 0020 × 0085 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0085 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 × 0085 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 1160 × 17D6 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 1160 × 0020 ÷ 17D6 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 17D6 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 1160 ÷ 0030 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 1160 × 0020 ÷ 0030 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 1160 × 0308 ÷ 0030 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 1160 ÷ 2329 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) ÷ [999.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 1160 × 0020 ÷ 2329 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 1160 × 0308 ÷ 2329 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 ÷ 2329 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 1160 × 0025 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [27.02] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 1160 × 0020 ÷ 0025 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0025 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [27.02] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 1160 ÷ 0024 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 1160 × 0020 ÷ 0024 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 1160 × 0308 ÷ 0024 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 1160 × 0022 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 1160 × 0020 ÷ 0022 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0022 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 1160 × 0020 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 1160 × 0020 × 0020 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 × 0020 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 1160 × 002F ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 1160 × 0020 × 002F ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 002F ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 × 002F ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 1160 × 2060 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 1160 × 0020 × 2060 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 2060 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 × 2060 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 1160 × 200B ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 1160 × 0020 × 200B ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 200B ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 × 200B ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 1160 ÷ 1F1E6 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 1160 × 0020 ÷ 1F1E6 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 1160 × 0308 ÷ 1F1E6 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 1160 ÷ 261D ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 1160 × 0020 ÷ 261D ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 1160 × 0308 ÷ 261D ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 ÷ 261D ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 1160 ÷ 1F3FB ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 1160 × 0020 ÷ 1F3FB ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 1160 × 0308 ÷ 1F3FB ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 1160 × 0029 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 1160 × 0020 × 0029 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0029 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 × 0029 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 1160 ÷ 0028 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 1160 × 0020 ÷ 0028 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 1160 × 0308 ÷ 0028 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 1160 × 0001 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 1160 × 0020 ÷ 0001 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0001 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 1160 × 200D ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 1160 × 0020 ÷ 200D ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 200D ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 ÷ 200D ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 1160 ÷ 00A7 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 1160 × 0020 ÷ 00A7 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 1160 × 0308 ÷ 00A7 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 1160 ÷ 50005 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 1160 × 0020 ÷ 50005 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 1160 × 0308 ÷ 50005 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 1160 ÷ 0E01 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 1160 × 0020 ÷ 0E01 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 1160 × 0308 ÷ 0E01 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 1160 × 3041 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 1160 × 0020 ÷ 3041 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 3041 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 ÷ 3041 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 000A ÷ 0023 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 ÷ 0023 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0023 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [28.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 ÷ 0023 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 000A ÷ 2014 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 ÷ 2014 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 ÷ 2014 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 ÷ 2014 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 000A ÷ 0009 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 ÷ 0009 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0009 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 ÷ 0009 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 000A ÷ 00B4 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 ÷ 00B4 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 ÷ 00B4 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 000A ÷ 000B ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 × 000B ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 000B ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 × 000B ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 000A ÷ FFFC ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 ÷ FFFC ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 ÷ FFFC ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 ÷ FFFC ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 000A ÷ 007D ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 × 007D ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 007D ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 × 007D ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 000A ÷ 000D ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 × 000D ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 000D ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 × 000D ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 000A ÷ 0021 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 × 0021 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0021 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 × 0021 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 000A ÷ 00A0 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 ÷ 00A0 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 00A0 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 000A ÷ AC00 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 ÷ AC00 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 ÷ AC00 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 ÷ AC00 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 000A ÷ AC01 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 ÷ AC01 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 ÷ AC01 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 ÷ AC01 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 000A ÷ 05D0 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 ÷ 05D0 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 05D0 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [28.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 000A ÷ 002D ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 ÷ 002D ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 002D ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 ÷ 002D ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 000A ÷ 231A ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] WATCH (ID) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 ÷ 231A ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 ÷ 231A ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 ÷ 231A ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 000A ÷ 2024 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 ÷ 2024 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 2024 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 ÷ 2024 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 000A ÷ 002C ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 × 002C ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 002C ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 × 002C ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 000A ÷ 1100 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 ÷ 1100 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 ÷ 1100 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 ÷ 1100 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 000A ÷ 11A8 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 ÷ 11A8 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 ÷ 11A8 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 000A ÷ 1160 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 ÷ 1160 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 ÷ 1160 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 ÷ 1160 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 000A ÷ 000A ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 × 000A ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 000A ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 × 000A ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 000A ÷ 0085 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 × 0085 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0085 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 × 0085 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 000A ÷ 17D6 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 ÷ 17D6 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 17D6 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 000A ÷ 0030 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 ÷ 0030 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0030 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [23.02] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 ÷ 0030 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 000A ÷ 2329 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 ÷ 2329 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 ÷ 2329 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 ÷ 2329 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 000A ÷ 0025 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 ÷ 0025 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0025 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [24.03] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 ÷ 0025 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 000A ÷ 0024 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 ÷ 0024 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0024 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [24.03] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 ÷ 0024 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 000A ÷ 0022 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 ÷ 0022 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0022 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 ÷ 0022 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 × 0020 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 × 0020 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 000A ÷ 002F ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 × 002F ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 002F ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 × 002F ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 000A ÷ 2060 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 × 2060 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 2060 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 × 2060 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 000A ÷ 200B ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 × 200B ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 200B ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 × 200B ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 000A ÷ 1F1E6 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 ÷ 1F1E6 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 ÷ 1F1E6 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 000A ÷ 261D ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 ÷ 261D ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 ÷ 261D ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 ÷ 261D ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 000A ÷ 1F3FB ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 ÷ 1F3FB ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 ÷ 1F3FB ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 000A ÷ 0029 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 × 0029 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0029 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 × 0029 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 000A ÷ 0028 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 ÷ 0028 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0028 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [30.01] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 ÷ 0028 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 000A ÷ 0001 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 ÷ 0001 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0001 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 ÷ 0001 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 000A ÷ 200D ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 ÷ 200D ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 200D ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 ÷ 200D ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 000A ÷ 00A7 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 ÷ 00A7 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 00A7 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [28.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 000A ÷ 50005 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 ÷ 50005 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 50005 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [28.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 ÷ 50005 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 000A ÷ 0E01 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 ÷ 0E01 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0E01 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [28.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 000A ÷ 3041 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 ÷ 3041 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 3041 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 ÷ 3041 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0023 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 ÷ 0023 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0023 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [28.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 ÷ 0023 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 2014 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 ÷ 2014 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 ÷ 2014 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 ÷ 2014 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0009 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 ÷ 0009 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0009 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 ÷ 0009 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0085 ÷ 00B4 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 ÷ 00B4 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 ÷ 00B4 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0085 ÷ 000B ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 × 000B ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 000B ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 × 000B ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0085 ÷ FFFC ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 ÷ FFFC ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 ÷ FFFC ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 ÷ FFFC ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0085 ÷ 007D ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 × 007D ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 007D ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 × 007D ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 000D ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 × 000D ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 000D ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 × 000D ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0021 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 × 0021 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0021 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 × 0021 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0085 ÷ 00A0 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 ÷ 00A0 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 00A0 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0085 ÷ AC00 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 ÷ AC00 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 ÷ AC00 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 ÷ AC00 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0085 ÷ AC01 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 ÷ AC01 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 ÷ AC01 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 ÷ AC01 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0085 ÷ 05D0 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 ÷ 05D0 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 05D0 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [28.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 002D ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 ÷ 002D ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 002D ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 ÷ 002D ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0085 ÷ 231A ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 ÷ 231A ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 ÷ 231A ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 ÷ 231A ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0085 ÷ 2024 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 ÷ 2024 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 2024 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 ÷ 2024 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0085 ÷ 002C ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 × 002C ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 002C ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 × 002C ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0085 ÷ 1100 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 ÷ 1100 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 ÷ 1100 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 ÷ 1100 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 11A8 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 ÷ 11A8 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 ÷ 11A8 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0085 ÷ 1160 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 ÷ 1160 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 ÷ 1160 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 ÷ 1160 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0085 ÷ 000A ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 × 000A ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 000A ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 × 000A ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0085 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 × 0085 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0085 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 × 0085 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 17D6 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 ÷ 17D6 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 17D6 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0030 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 ÷ 0030 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0030 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [23.02] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 ÷ 0030 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0085 ÷ 2329 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 ÷ 2329 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 ÷ 2329 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 ÷ 2329 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0025 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 ÷ 0025 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0025 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [24.03] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 ÷ 0025 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0024 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 ÷ 0024 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0024 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [24.03] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 ÷ 0024 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0022 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 ÷ 0022 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0022 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 ÷ 0022 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 × 0020 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 × 0020 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0085 ÷ 002F ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 × 002F ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 002F ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 × 002F ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0085 ÷ 2060 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 × 2060 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 2060 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 × 2060 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0085 ÷ 200B ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 × 200B ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 200B ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 × 200B ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0085 ÷ 1F1E6 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 ÷ 1F1E6 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 ÷ 1F1E6 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0085 ÷ 261D ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 ÷ 261D ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 ÷ 261D ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 ÷ 261D ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0085 ÷ 1F3FB ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 ÷ 1F3FB ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 ÷ 1F3FB ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0029 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 × 0029 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0029 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 × 0029 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0028 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 ÷ 0028 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0028 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [30.01] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 ÷ 0028 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0001 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 ÷ 0001 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0001 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 ÷ 0001 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0085 ÷ 200D ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 ÷ 200D ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 200D ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 ÷ 200D ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0085 ÷ 00A7 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 ÷ 00A7 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 00A7 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [28.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 50005 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 ÷ 50005 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 50005 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [28.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 ÷ 50005 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0E01 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 ÷ 0E01 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0E01 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [28.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 3041 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 ÷ 3041 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 3041 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 ÷ 3041 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 17D6 ÷ 0023 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 ÷ 0023 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 ÷ 0023 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 17D6 ÷ 2014 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 ÷ 2014 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 ÷ 2014 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 17D6 × 0009 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 ÷ 0009 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0009 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 17D6 ÷ 00B4 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 ÷ 00B4 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 ÷ 00B4 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 17D6 × 000B ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 × 000B ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 000B ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 × 000B ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 17D6 ÷ FFFC ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 ÷ FFFC ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 ÷ FFFC ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 17D6 × 007D ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 × 007D ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 007D ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 × 007D ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 17D6 × 000D ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 × 000D ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 000D ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 × 000D ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 17D6 × 0021 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 × 0021 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0021 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 × 0021 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 17D6 × 00A0 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [12.1] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 ÷ 00A0 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 00A0 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 17D6 ÷ AC00 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 ÷ AC00 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 ÷ AC00 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
}
if (!$::TESTCHUNK or $::TESTCHUNK == 8) {
    Test_LB('× 17D6 ÷ AC01 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 ÷ AC01 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 ÷ AC01 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 17D6 ÷ 05D0 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 ÷ 05D0 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 ÷ 05D0 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 17D6 × 002D ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 ÷ 002D ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 002D ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 ÷ 002D ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 17D6 ÷ 231A ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 ÷ 231A ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 ÷ 231A ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 ÷ 231A ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 17D6 × 2024 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 ÷ 2024 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 2024 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 17D6 × 002C ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 × 002C ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 002C ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 × 002C ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 17D6 ÷ 1100 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 ÷ 1100 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 ÷ 1100 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 17D6 ÷ 11A8 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 ÷ 11A8 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 ÷ 11A8 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 17D6 ÷ 1160 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 ÷ 1160 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 ÷ 1160 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 17D6 × 000A ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 × 000A ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 000A ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 × 000A ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 17D6 × 0085 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 × 0085 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0085 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 × 0085 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 17D6 × 17D6 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 ÷ 17D6 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 17D6 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 17D6 ÷ 0030 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 ÷ 0030 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 ÷ 0030 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 17D6 ÷ 2329 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [999.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 ÷ 2329 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 ÷ 2329 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 ÷ 2329 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 17D6 ÷ 0025 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [999.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 ÷ 0025 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 ÷ 0025 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 17D6 ÷ 0024 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 ÷ 0024 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 ÷ 0024 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 17D6 × 0022 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 ÷ 0022 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0022 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 × 0020 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 × 0020 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 17D6 × 002F ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 × 002F ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 002F ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 × 002F ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 17D6 × 2060 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 × 2060 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 2060 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 × 2060 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 17D6 × 200B ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 × 200B ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 200B ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 × 200B ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 17D6 ÷ 1F1E6 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 ÷ 1F1E6 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 ÷ 1F1E6 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 17D6 ÷ 261D ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 ÷ 261D ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 ÷ 261D ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 ÷ 261D ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 17D6 ÷ 1F3FB ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 ÷ 1F3FB ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 ÷ 1F3FB ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 17D6 × 0029 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 × 0029 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0029 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 × 0029 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 17D6 ÷ 0028 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 ÷ 0028 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 ÷ 0028 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 17D6 × 0001 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 ÷ 0001 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0001 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 17D6 × 200D ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 ÷ 200D ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 200D ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 ÷ 200D ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 17D6 ÷ 00A7 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 ÷ 00A7 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 ÷ 00A7 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 17D6 ÷ 50005 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 ÷ 50005 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 ÷ 50005 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 17D6 ÷ 0E01 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 ÷ 0E01 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 ÷ 0E01 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 17D6 × 3041 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 ÷ 3041 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 3041 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 ÷ 3041 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0030 × 0023 ÷	#  × [0.3] DIGIT ZERO (NU) × [23.03] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0030 × 0020 ÷ 0023 ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0023 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [23.03] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0030 ÷ 2014 ÷	#  × [0.3] DIGIT ZERO (NU) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0030 × 0020 ÷ 2014 ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0030 × 0308 ÷ 2014 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0030 × 0009 ÷	#  × [0.3] DIGIT ZERO (NU) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0030 × 0020 ÷ 0009 ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0009 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0030 ÷ 00B4 ÷	#  × [0.3] DIGIT ZERO (NU) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0030 × 0020 ÷ 00B4 ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0030 × 0308 ÷ 00B4 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0030 × 000B ÷	#  × [0.3] DIGIT ZERO (NU) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0030 × 0020 × 000B ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 000B ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 × 000B ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0030 ÷ FFFC ÷	#  × [0.3] DIGIT ZERO (NU) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0030 × 0020 ÷ FFFC ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0030 × 0308 ÷ FFFC ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0030 × 007D ÷	#  × [0.3] DIGIT ZERO (NU) × [25.04] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0030 × 0020 × 007D ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 007D ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [25.04] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 × 007D ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0030 × 000D ÷	#  × [0.3] DIGIT ZERO (NU) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0030 × 0020 × 000D ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 000D ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 × 000D ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0030 × 0021 ÷	#  × [0.3] DIGIT ZERO (NU) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0030 × 0020 × 0021 ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0021 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 × 0021 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0030 × 00A0 ÷	#  × [0.3] DIGIT ZERO (NU) × [12.1] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0030 × 0020 ÷ 00A0 ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 00A0 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0030 ÷ AC00 ÷	#  × [0.3] DIGIT ZERO (NU) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0030 × 0020 ÷ AC00 ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0030 × 0308 ÷ AC00 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0030 ÷ AC01 ÷	#  × [0.3] DIGIT ZERO (NU) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0030 × 0020 ÷ AC01 ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0030 × 0308 ÷ AC01 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0030 × 05D0 ÷	#  × [0.3] DIGIT ZERO (NU) × [23.03] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0030 × 0020 ÷ 05D0 ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 05D0 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [23.03] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0030 × 002D ÷	#  × [0.3] DIGIT ZERO (NU) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0030 × 0020 ÷ 002D ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 002D ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 ÷ 002D ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0030 ÷ 231A ÷	#  × [0.3] DIGIT ZERO (NU) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0030 × 0020 ÷ 231A ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0030 × 0308 ÷ 231A ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 ÷ 231A ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0030 × 2024 ÷	#  × [0.3] DIGIT ZERO (NU) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0030 × 0020 ÷ 2024 ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 2024 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0030 × 002C ÷	#  × [0.3] DIGIT ZERO (NU) × [25.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0030 × 0020 × 002C ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 002C ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [25.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 × 002C ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0030 ÷ 1100 ÷	#  × [0.3] DIGIT ZERO (NU) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0030 × 0020 ÷ 1100 ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0030 × 0308 ÷ 1100 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0030 ÷ 11A8 ÷	#  × [0.3] DIGIT ZERO (NU) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0030 × 0020 ÷ 11A8 ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0030 × 0308 ÷ 11A8 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0030 ÷ 1160 ÷	#  × [0.3] DIGIT ZERO (NU) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0030 × 0020 ÷ 1160 ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0030 × 0308 ÷ 1160 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0030 × 000A ÷	#  × [0.3] DIGIT ZERO (NU) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0030 × 0020 × 000A ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 000A ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 × 000A ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0030 × 0085 ÷	#  × [0.3] DIGIT ZERO (NU) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0030 × 0020 × 0085 ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0085 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 × 0085 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0030 × 17D6 ÷	#  × [0.3] DIGIT ZERO (NU) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0030 × 0020 ÷ 17D6 ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 17D6 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0030 × 0030 ÷	#  × [0.3] DIGIT ZERO (NU) × [25.03] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0030 × 0020 ÷ 0030 ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0030 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [25.03] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0030 ÷ 2329 ÷	#  × [0.3] DIGIT ZERO (NU) ÷ [999.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 0030 × 0020 ÷ 2329 ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 0030 × 0308 ÷ 2329 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 ÷ 2329 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 0030 × 0025 ÷	#  × [0.3] DIGIT ZERO (NU) × [25.05] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0030 × 0020 ÷ 0025 ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0025 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [25.05] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0030 × 0024 ÷	#  × [0.3] DIGIT ZERO (NU) × [25.05] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0030 × 0020 ÷ 0024 ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0024 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [25.05] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0030 × 0022 ÷	#  × [0.3] DIGIT ZERO (NU) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0030 × 0020 ÷ 0022 ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0022 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0030 × 0020 ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0030 × 0020 × 0020 ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 × 0020 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0030 × 002F ÷	#  × [0.3] DIGIT ZERO (NU) × [25.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0030 × 0020 × 002F ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 002F ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [25.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 × 002F ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0030 × 2060 ÷	#  × [0.3] DIGIT ZERO (NU) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0030 × 0020 × 2060 ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 2060 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 × 2060 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0030 × 200B ÷	#  × [0.3] DIGIT ZERO (NU) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0030 × 0020 × 200B ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 200B ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 × 200B ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0030 ÷ 1F1E6 ÷	#  × [0.3] DIGIT ZERO (NU) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0030 × 0020 ÷ 1F1E6 ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0030 × 0308 ÷ 1F1E6 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0030 ÷ 261D ÷	#  × [0.3] DIGIT ZERO (NU) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0030 × 0020 ÷ 261D ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0030 × 0308 ÷ 261D ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 ÷ 261D ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0030 ÷ 1F3FB ÷	#  × [0.3] DIGIT ZERO (NU) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0030 × 0020 ÷ 1F3FB ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0030 × 0308 ÷ 1F3FB ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0030 × 0029 ÷	#  × [0.3] DIGIT ZERO (NU) × [25.04] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0030 × 0020 × 0029 ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0029 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [25.04] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 × 0029 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0030 × 0028 ÷	#  × [0.3] DIGIT ZERO (NU) × [30.01] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 0030 × 0020 ÷ 0028 ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0028 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [30.01] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 0030 × 0001 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0030 × 0020 ÷ 0001 ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0001 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0030 × 200D ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0030 × 0020 ÷ 200D ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 200D ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 ÷ 200D ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0030 × 00A7 ÷	#  × [0.3] DIGIT ZERO (NU) × [23.03] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0030 × 0020 ÷ 00A7 ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 00A7 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [23.03] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0030 × 50005 ÷	#  × [0.3] DIGIT ZERO (NU) × [23.03] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0030 × 0020 ÷ 50005 ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 50005 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [23.03] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0030 × 0E01 ÷	#  × [0.3] DIGIT ZERO (NU) × [23.03] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0030 × 0020 ÷ 0E01 ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0E01 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [23.03] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0030 × 3041 ÷	#  × [0.3] DIGIT ZERO (NU) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0030 × 0020 ÷ 3041 ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 3041 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 ÷ 3041 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 2329 × 0023 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [14.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 2329 × 0020 × 0023 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [7.01] SPACE (SP) × [14.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 0023 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 0020 × 0023 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 2329 × 2014 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [14.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 2329 × 0020 × 2014 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [7.01] SPACE (SP) × [14.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 2014 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 0020 × 2014 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 2329 × 0009 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [14.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 2329 × 0020 × 0009 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [7.01] SPACE (SP) × [14.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 0009 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 0020 × 0009 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 2329 × 00B4 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [14.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 2329 × 0020 × 00B4 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [7.01] SPACE (SP) × [14.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 00B4 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 0020 × 00B4 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 2329 × 000B ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 2329 × 0020 × 000B ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 000B ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 0020 × 000B ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 2329 × FFFC ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [14.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 2329 × 0020 × FFFC ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [7.01] SPACE (SP) × [14.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × FFFC ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 0020 × FFFC ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 2329 × 007D ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 2329 × 0020 × 007D ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 007D ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 0020 × 007D ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 2329 × 000D ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 2329 × 0020 × 000D ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 000D ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 0020 × 000D ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 2329 × 0021 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 2329 × 0020 × 0021 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 0021 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 0020 × 0021 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 2329 × 00A0 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [12.1] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 2329 × 0020 × 00A0 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [7.01] SPACE (SP) × [14.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 00A0 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 0020 × 00A0 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 2329 × AC00 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [14.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 2329 × 0020 × AC00 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [7.01] SPACE (SP) × [14.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × AC00 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 0020 × AC00 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 2329 × AC01 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [14.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 2329 × 0020 × AC01 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [7.01] SPACE (SP) × [14.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × AC01 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 0020 × AC01 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 2329 × 05D0 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [14.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 2329 × 0020 × 05D0 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [7.01] SPACE (SP) × [14.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 05D0 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 0020 × 05D0 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 2329 × 002D ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [14.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 2329 × 0020 × 002D ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [7.01] SPACE (SP) × [14.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 002D ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 0020 × 002D ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 2329 × 231A ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [14.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 2329 × 0020 × 231A ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [7.01] SPACE (SP) × [14.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 231A ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 0020 × 231A ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 2329 × 2024 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [14.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 2329 × 0020 × 2024 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [7.01] SPACE (SP) × [14.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 2024 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 0020 × 2024 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 2329 × 002C ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 2329 × 0020 × 002C ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 002C ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 0020 × 002C ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 2329 × 1100 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [14.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 2329 × 0020 × 1100 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [7.01] SPACE (SP) × [14.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 1100 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 0020 × 1100 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 2329 × 11A8 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [14.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 2329 × 0020 × 11A8 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [7.01] SPACE (SP) × [14.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 11A8 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 0020 × 11A8 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 2329 × 1160 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [14.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 2329 × 0020 × 1160 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [7.01] SPACE (SP) × [14.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 1160 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 0020 × 1160 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 2329 × 000A ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 2329 × 0020 × 000A ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 000A ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 0020 × 000A ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 2329 × 0085 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 2329 × 0020 × 0085 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 0085 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 0020 × 0085 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 2329 × 17D6 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [14.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 2329 × 0020 × 17D6 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [7.01] SPACE (SP) × [14.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 17D6 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 0020 × 17D6 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 2329 × 0030 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [14.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 2329 × 0020 × 0030 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [7.01] SPACE (SP) × [14.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 0030 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 0020 × 0030 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 2329 × 2329 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [14.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 2329 × 0020 × 2329 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [7.01] SPACE (SP) × [14.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 2329 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 0020 × 2329 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 2329 × 0025 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [14.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 2329 × 0020 × 0025 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [7.01] SPACE (SP) × [14.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 0025 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 0020 × 0025 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 2329 × 0024 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [14.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 2329 × 0020 × 0024 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [7.01] SPACE (SP) × [14.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 0024 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 0020 × 0024 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 2329 × 0022 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [14.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 2329 × 0020 × 0022 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [7.01] SPACE (SP) × [14.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 0022 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 0020 × 0022 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 2329 × 0020 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 2329 × 0020 × 0020 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 0020 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 0020 × 0020 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 2329 × 002F ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 2329 × 0020 × 002F ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 002F ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 0020 × 002F ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 2329 × 2060 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 2329 × 0020 × 2060 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 2060 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 0020 × 2060 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 2329 × 200B ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 2329 × 0020 × 200B ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 200B ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 0020 × 200B ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 2329 × 1F1E6 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [14.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 2329 × 0020 × 1F1E6 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [7.01] SPACE (SP) × [14.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 1F1E6 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 0020 × 1F1E6 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 2329 × 261D ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [14.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 2329 × 0020 × 261D ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [7.01] SPACE (SP) × [14.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 261D ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 0020 × 261D ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 2329 × 1F3FB ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [14.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 2329 × 0020 × 1F3FB ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [7.01] SPACE (SP) × [14.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 1F3FB ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 0020 × 1F3FB ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 2329 × 0029 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 2329 × 0020 × 0029 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 0029 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 0020 × 0029 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 2329 × 0028 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [14.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 2329 × 0020 × 0028 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [7.01] SPACE (SP) × [14.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 0028 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 0020 × 0028 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 2329 × 0001 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 2329 × 0020 × 0001 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [7.01] SPACE (SP) × [14.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 0001 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 0020 × 0001 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 2329 × 200D ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 2329 × 0020 × 200D ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [7.01] SPACE (SP) × [14.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 200D ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 0020 × 200D ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 2329 × 00A7 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [14.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 2329 × 0020 × 00A7 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [7.01] SPACE (SP) × [14.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 00A7 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 0020 × 00A7 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 2329 × 50005 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [14.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 2329 × 0020 × 50005 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [7.01] SPACE (SP) × [14.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 50005 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 0020 × 50005 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 2329 × 0E01 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [14.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 2329 × 0020 × 0E01 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [7.01] SPACE (SP) × [14.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 0E01 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 0020 × 0E01 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 2329 × 3041 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [14.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 2329 × 0020 × 3041 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [7.01] SPACE (SP) × [14.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 3041 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 2329 × 0308 × 0020 × 3041 ÷	#  × [0.3] LEFT-POINTING ANGLE BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0025 × 0023 ÷	#  × [0.3] PERCENT SIGN (PO) × [24.02] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0025 × 0020 ÷ 0023 ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0023 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [24.02] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0025 ÷ 2014 ÷	#  × [0.3] PERCENT SIGN (PO) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0025 × 0020 ÷ 2014 ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0025 × 0308 ÷ 2014 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0025 × 0009 ÷	#  × [0.3] PERCENT SIGN (PO) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0025 × 0020 ÷ 0009 ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0009 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0025 ÷ 00B4 ÷	#  × [0.3] PERCENT SIGN (PO) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0025 × 0020 ÷ 00B4 ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0025 × 0308 ÷ 00B4 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0025 × 000B ÷	#  × [0.3] PERCENT SIGN (PO) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0025 × 0020 × 000B ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 000B ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 × 000B ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0025 ÷ FFFC ÷	#  × [0.3] PERCENT SIGN (PO) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0025 × 0020 ÷ FFFC ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0025 × 0308 ÷ FFFC ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0025 × 007D ÷	#  × [0.3] PERCENT SIGN (PO) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0025 × 0020 × 007D ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 007D ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 × 007D ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0025 × 000D ÷	#  × [0.3] PERCENT SIGN (PO) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0025 × 0020 × 000D ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 000D ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 × 000D ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0025 × 0021 ÷	#  × [0.3] PERCENT SIGN (PO) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0025 × 0020 × 0021 ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0021 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 × 0021 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0025 × 00A0 ÷	#  × [0.3] PERCENT SIGN (PO) × [12.1] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0025 × 0020 ÷ 00A0 ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 00A0 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0025 ÷ AC00 ÷	#  × [0.3] PERCENT SIGN (PO) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0025 × 0020 ÷ AC00 ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0025 × 0308 ÷ AC00 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0025 ÷ AC01 ÷	#  × [0.3] PERCENT SIGN (PO) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0025 × 0020 ÷ AC01 ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0025 × 0308 ÷ AC01 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0025 × 05D0 ÷	#  × [0.3] PERCENT SIGN (PO) × [24.02] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0025 × 0020 ÷ 05D0 ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 05D0 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [24.02] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0025 × 002D ÷	#  × [0.3] PERCENT SIGN (PO) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0025 × 0020 ÷ 002D ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 002D ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 ÷ 002D ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0025 ÷ 231A ÷	#  × [0.3] PERCENT SIGN (PO) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0025 × 0020 ÷ 231A ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0025 × 0308 ÷ 231A ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 ÷ 231A ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0025 × 2024 ÷	#  × [0.3] PERCENT SIGN (PO) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0025 × 0020 ÷ 2024 ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 2024 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0025 × 002C ÷	#  × [0.3] PERCENT SIGN (PO) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0025 × 0020 × 002C ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 002C ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 × 002C ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0025 ÷ 1100 ÷	#  × [0.3] PERCENT SIGN (PO) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0025 × 0020 ÷ 1100 ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0025 × 0308 ÷ 1100 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0025 ÷ 11A8 ÷	#  × [0.3] PERCENT SIGN (PO) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0025 × 0020 ÷ 11A8 ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0025 × 0308 ÷ 11A8 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0025 ÷ 1160 ÷	#  × [0.3] PERCENT SIGN (PO) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0025 × 0020 ÷ 1160 ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0025 × 0308 ÷ 1160 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0025 × 000A ÷	#  × [0.3] PERCENT SIGN (PO) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0025 × 0020 × 000A ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 000A ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 × 000A ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0025 × 0085 ÷	#  × [0.3] PERCENT SIGN (PO) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0025 × 0020 × 0085 ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0085 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 × 0085 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0025 × 17D6 ÷	#  × [0.3] PERCENT SIGN (PO) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0025 × 0020 ÷ 17D6 ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 17D6 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0025 × 0030 ÷	#  × [0.3] PERCENT SIGN (PO) × [25.01] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0025 × 0020 ÷ 0030 ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0030 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [25.01] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0025 ÷ 2329 ÷	#  × [0.3] PERCENT SIGN (PO) ÷ [999.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 0025 × 0020 ÷ 2329 ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 0025 × 0308 ÷ 2329 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 ÷ 2329 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 0025 ÷ 0025 ÷	#  × [0.3] PERCENT SIGN (PO) ÷ [999.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0025 × 0020 ÷ 0025 ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0025 × 0308 ÷ 0025 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0025 ÷ 0024 ÷	#  × [0.3] PERCENT SIGN (PO) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0025 × 0020 ÷ 0024 ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0025 × 0308 ÷ 0024 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0025 × 0022 ÷	#  × [0.3] PERCENT SIGN (PO) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0025 × 0020 ÷ 0022 ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0022 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0025 × 0020 ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0025 × 0020 × 0020 ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 × 0020 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0025 × 002F ÷	#  × [0.3] PERCENT SIGN (PO) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0025 × 0020 × 002F ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 002F ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 × 002F ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0025 × 2060 ÷	#  × [0.3] PERCENT SIGN (PO) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0025 × 0020 × 2060 ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 2060 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 × 2060 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0025 × 200B ÷	#  × [0.3] PERCENT SIGN (PO) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0025 × 0020 × 200B ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 200B ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 × 200B ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0025 ÷ 1F1E6 ÷	#  × [0.3] PERCENT SIGN (PO) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0025 × 0020 ÷ 1F1E6 ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0025 × 0308 ÷ 1F1E6 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0025 ÷ 261D ÷	#  × [0.3] PERCENT SIGN (PO) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0025 × 0020 ÷ 261D ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0025 × 0308 ÷ 261D ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 ÷ 261D ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0025 ÷ 1F3FB ÷	#  × [0.3] PERCENT SIGN (PO) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0025 × 0020 ÷ 1F3FB ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0025 × 0308 ÷ 1F3FB ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0025 × 0029 ÷	#  × [0.3] PERCENT SIGN (PO) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0025 × 0020 × 0029 ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0029 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 × 0029 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0025 ÷ 0028 ÷	#  × [0.3] PERCENT SIGN (PO) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 0025 × 0020 ÷ 0028 ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 0025 × 0308 ÷ 0028 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 0025 × 0001 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0025 × 0020 ÷ 0001 ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0001 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0025 × 200D ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0025 × 0020 ÷ 200D ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 200D ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 ÷ 200D ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0025 × 00A7 ÷	#  × [0.3] PERCENT SIGN (PO) × [24.02] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0025 × 0020 ÷ 00A7 ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 00A7 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [24.02] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0025 × 50005 ÷	#  × [0.3] PERCENT SIGN (PO) × [24.02] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0025 × 0020 ÷ 50005 ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 50005 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [24.02] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0025 × 0E01 ÷	#  × [0.3] PERCENT SIGN (PO) × [24.02] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0025 × 0020 ÷ 0E01 ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0E01 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [24.02] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0025 × 3041 ÷	#  × [0.3] PERCENT SIGN (PO) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0025 × 0020 ÷ 3041 ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 3041 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 ÷ 3041 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0024 × 0023 ÷	#  × [0.3] DOLLAR SIGN (PR) × [24.02] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0024 × 0020 ÷ 0023 ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0023 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [24.02] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0024 ÷ 2014 ÷	#  × [0.3] DOLLAR SIGN (PR) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0024 × 0020 ÷ 2014 ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0024 × 0308 ÷ 2014 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0024 × 0009 ÷	#  × [0.3] DOLLAR SIGN (PR) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0024 × 0020 ÷ 0009 ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0009 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0024 ÷ 00B4 ÷	#  × [0.3] DOLLAR SIGN (PR) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0024 × 0020 ÷ 00B4 ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0024 × 0308 ÷ 00B4 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0024 × 000B ÷	#  × [0.3] DOLLAR SIGN (PR) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0024 × 0020 × 000B ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 000B ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 × 000B ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0024 ÷ FFFC ÷	#  × [0.3] DOLLAR SIGN (PR) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0024 × 0020 ÷ FFFC ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0024 × 0308 ÷ FFFC ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0024 × 007D ÷	#  × [0.3] DOLLAR SIGN (PR) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0024 × 0020 × 007D ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 007D ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 × 007D ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0024 × 000D ÷	#  × [0.3] DOLLAR SIGN (PR) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0024 × 0020 × 000D ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 000D ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 × 000D ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0024 × 0021 ÷	#  × [0.3] DOLLAR SIGN (PR) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0024 × 0020 × 0021 ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0021 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 × 0021 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0024 × 00A0 ÷	#  × [0.3] DOLLAR SIGN (PR) × [12.1] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0024 × 0020 ÷ 00A0 ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 00A0 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0024 × AC00 ÷	#  × [0.3] DOLLAR SIGN (PR) × [27.03] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0024 × 0020 ÷ AC00 ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × AC00 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [27.03] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0024 × AC01 ÷	#  × [0.3] DOLLAR SIGN (PR) × [27.03] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0024 × 0020 ÷ AC01 ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × AC01 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [27.03] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0024 × 05D0 ÷	#  × [0.3] DOLLAR SIGN (PR) × [24.02] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0024 × 0020 ÷ 05D0 ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 05D0 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [24.02] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0024 × 002D ÷	#  × [0.3] DOLLAR SIGN (PR) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0024 × 0020 ÷ 002D ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 002D ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 ÷ 002D ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0024 × 231A ÷	#  × [0.3] DOLLAR SIGN (PR) × [23.12] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0024 × 0020 ÷ 231A ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 231A ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [23.12] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 ÷ 231A ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0024 × 2024 ÷	#  × [0.3] DOLLAR SIGN (PR) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0024 × 0020 ÷ 2024 ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 2024 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0024 × 002C ÷	#  × [0.3] DOLLAR SIGN (PR) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0024 × 0020 × 002C ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 002C ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 × 002C ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0024 × 1100 ÷	#  × [0.3] DOLLAR SIGN (PR) × [27.03] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0024 × 0020 ÷ 1100 ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 1100 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [27.03] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0024 × 11A8 ÷	#  × [0.3] DOLLAR SIGN (PR) × [27.03] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0024 × 0020 ÷ 11A8 ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 11A8 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [27.03] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0024 × 1160 ÷	#  × [0.3] DOLLAR SIGN (PR) × [27.03] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0024 × 0020 ÷ 1160 ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 1160 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [27.03] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0024 × 000A ÷	#  × [0.3] DOLLAR SIGN (PR) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0024 × 0020 × 000A ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 000A ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 × 000A ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0024 × 0085 ÷	#  × [0.3] DOLLAR SIGN (PR) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0024 × 0020 × 0085 ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0085 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 × 0085 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0024 × 17D6 ÷	#  × [0.3] DOLLAR SIGN (PR) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0024 × 0020 ÷ 17D6 ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 17D6 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0024 × 0030 ÷	#  × [0.3] DOLLAR SIGN (PR) × [25.01] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0024 × 0020 ÷ 0030 ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0030 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [25.01] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0024 ÷ 2329 ÷	#  × [0.3] DOLLAR SIGN (PR) ÷ [999.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 0024 × 0020 ÷ 2329 ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 0024 × 0308 ÷ 2329 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 ÷ 2329 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 0024 ÷ 0025 ÷	#  × [0.3] DOLLAR SIGN (PR) ÷ [999.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0024 × 0020 ÷ 0025 ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0024 × 0308 ÷ 0025 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0024 ÷ 0024 ÷	#  × [0.3] DOLLAR SIGN (PR) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0024 × 0020 ÷ 0024 ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0024 × 0308 ÷ 0024 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0024 × 0022 ÷	#  × [0.3] DOLLAR SIGN (PR) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0024 × 0020 ÷ 0022 ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0022 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0024 × 0020 ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0024 × 0020 × 0020 ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 × 0020 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0024 × 002F ÷	#  × [0.3] DOLLAR SIGN (PR) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0024 × 0020 × 002F ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 002F ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 × 002F ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0024 × 2060 ÷	#  × [0.3] DOLLAR SIGN (PR) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0024 × 0020 × 2060 ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 2060 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 × 2060 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0024 × 200B ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0024 × 0020 × 200B ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 200B ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 × 200B ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0024 ÷ 1F1E6 ÷	#  × [0.3] DOLLAR SIGN (PR) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0024 × 0020 ÷ 1F1E6 ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0024 × 0308 ÷ 1F1E6 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0024 × 261D ÷	#  × [0.3] DOLLAR SIGN (PR) × [23.12] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0024 × 0020 ÷ 261D ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 261D ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [23.12] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 ÷ 261D ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0024 × 1F3FB ÷	#  × [0.3] DOLLAR SIGN (PR) × [23.12] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0024 × 0020 ÷ 1F3FB ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 1F3FB ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [23.12] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0024 × 0029 ÷	#  × [0.3] DOLLAR SIGN (PR) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0024 × 0020 × 0029 ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0029 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 × 0029 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0024 ÷ 0028 ÷	#  × [0.3] DOLLAR SIGN (PR) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 0024 × 0020 ÷ 0028 ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 0024 × 0308 ÷ 0028 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 0024 × 0001 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0024 × 0020 ÷ 0001 ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0001 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0024 × 200D ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0024 × 0020 ÷ 200D ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 200D ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 ÷ 200D ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0024 × 00A7 ÷	#  × [0.3] DOLLAR SIGN (PR) × [24.02] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0024 × 0020 ÷ 00A7 ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 00A7 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [24.02] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0024 × 50005 ÷	#  × [0.3] DOLLAR SIGN (PR) × [24.02] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0024 × 0020 ÷ 50005 ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 50005 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [24.02] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0024 × 0E01 ÷	#  × [0.3] DOLLAR SIGN (PR) × [24.02] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0024 × 0020 ÷ 0E01 ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0E01 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [24.02] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0024 × 3041 ÷	#  × [0.3] DOLLAR SIGN (PR) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0024 × 0020 ÷ 3041 ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 3041 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 ÷ 3041 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0022 × 0023 ÷	#  × [0.3] QUOTATION MARK (QU) × [19.02] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0022 × 0020 ÷ 0023 ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0023 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.02] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0022 × 2014 ÷	#  × [0.3] QUOTATION MARK (QU) × [19.02] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0022 × 0020 ÷ 2014 ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 2014 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.02] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0022 × 0009 ÷	#  × [0.3] QUOTATION MARK (QU) × [19.02] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0022 × 0020 ÷ 0009 ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0009 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.02] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0022 × 00B4 ÷	#  × [0.3] QUOTATION MARK (QU) × [19.02] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0022 × 0020 ÷ 00B4 ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 00B4 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.02] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0022 × 000B ÷	#  × [0.3] QUOTATION MARK (QU) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0022 × 0020 × 000B ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 000B ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 × 000B ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0022 × FFFC ÷	#  × [0.3] QUOTATION MARK (QU) × [19.02] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0022 × 0020 ÷ FFFC ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × FFFC ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.02] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0022 × 007D ÷	#  × [0.3] QUOTATION MARK (QU) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0022 × 0020 × 007D ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 007D ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 × 007D ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0022 × 000D ÷	#  × [0.3] QUOTATION MARK (QU) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0022 × 0020 × 000D ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 000D ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 × 000D ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0022 × 0021 ÷	#  × [0.3] QUOTATION MARK (QU) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0022 × 0020 × 0021 ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0021 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 × 0021 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0022 × 00A0 ÷	#  × [0.3] QUOTATION MARK (QU) × [12.1] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0022 × 0020 ÷ 00A0 ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 00A0 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0022 × AC00 ÷	#  × [0.3] QUOTATION MARK (QU) × [19.02] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0022 × 0020 ÷ AC00 ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × AC00 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.02] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0022 × AC01 ÷	#  × [0.3] QUOTATION MARK (QU) × [19.02] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0022 × 0020 ÷ AC01 ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × AC01 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.02] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0022 × 05D0 ÷	#  × [0.3] QUOTATION MARK (QU) × [19.02] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0022 × 0020 ÷ 05D0 ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 05D0 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.02] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0022 × 002D ÷	#  × [0.3] QUOTATION MARK (QU) × [19.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0022 × 0020 ÷ 002D ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 002D ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 ÷ 002D ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0022 × 231A ÷	#  × [0.3] QUOTATION MARK (QU) × [19.02] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0022 × 0020 ÷ 231A ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 231A ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.02] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 ÷ 231A ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0022 × 2024 ÷	#  × [0.3] QUOTATION MARK (QU) × [19.02] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0022 × 0020 ÷ 2024 ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 2024 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.02] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0022 × 002C ÷	#  × [0.3] QUOTATION MARK (QU) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0022 × 0020 × 002C ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 002C ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 × 002C ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0022 × 1100 ÷	#  × [0.3] QUOTATION MARK (QU) × [19.02] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0022 × 0020 ÷ 1100 ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 1100 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.02] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0022 × 11A8 ÷	#  × [0.3] QUOTATION MARK (QU) × [19.02] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0022 × 0020 ÷ 11A8 ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 11A8 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.02] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0022 × 1160 ÷	#  × [0.3] QUOTATION MARK (QU) × [19.02] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0022 × 0020 ÷ 1160 ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 1160 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.02] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0022 × 000A ÷	#  × [0.3] QUOTATION MARK (QU) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0022 × 0020 × 000A ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 000A ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 × 000A ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0022 × 0085 ÷	#  × [0.3] QUOTATION MARK (QU) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0022 × 0020 × 0085 ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0085 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 × 0085 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0022 × 17D6 ÷	#  × [0.3] QUOTATION MARK (QU) × [19.02] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0022 × 0020 ÷ 17D6 ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 17D6 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.02] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0022 × 0030 ÷	#  × [0.3] QUOTATION MARK (QU) × [19.02] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0022 × 0020 ÷ 0030 ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0030 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.02] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0022 × 2329 ÷	#  × [0.3] QUOTATION MARK (QU) × [15.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 0022 × 0020 × 2329 ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) × [15.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 2329 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [15.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 × 2329 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [15.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 0022 × 0025 ÷	#  × [0.3] QUOTATION MARK (QU) × [19.02] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0022 × 0020 ÷ 0025 ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0025 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.02] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0022 × 0024 ÷	#  × [0.3] QUOTATION MARK (QU) × [19.02] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0022 × 0020 ÷ 0024 ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0024 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.02] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0022 × 0022 ÷	#  × [0.3] QUOTATION MARK (QU) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0022 × 0020 ÷ 0022 ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0022 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0022 × 0020 ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0022 × 0020 × 0020 ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 × 0020 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0022 × 002F ÷	#  × [0.3] QUOTATION MARK (QU) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0022 × 0020 × 002F ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 002F ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 × 002F ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0022 × 2060 ÷	#  × [0.3] QUOTATION MARK (QU) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0022 × 0020 × 2060 ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 2060 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 × 2060 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0022 × 200B ÷	#  × [0.3] QUOTATION MARK (QU) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0022 × 0020 × 200B ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 200B ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 × 200B ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0022 × 1F1E6 ÷	#  × [0.3] QUOTATION MARK (QU) × [19.02] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0022 × 0020 ÷ 1F1E6 ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 1F1E6 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.02] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0022 × 261D ÷	#  × [0.3] QUOTATION MARK (QU) × [19.02] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0022 × 0020 ÷ 261D ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 261D ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.02] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 ÷ 261D ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0022 × 1F3FB ÷	#  × [0.3] QUOTATION MARK (QU) × [19.02] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0022 × 0020 ÷ 1F3FB ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 1F3FB ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.02] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0022 × 0029 ÷	#  × [0.3] QUOTATION MARK (QU) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0022 × 0020 × 0029 ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0029 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 × 0029 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0022 × 0028 ÷	#  × [0.3] QUOTATION MARK (QU) × [15.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 0022 × 0020 × 0028 ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) × [15.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0028 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [15.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 × 0028 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [15.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 0022 × 0001 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0022 × 0020 ÷ 0001 ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0001 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0022 × 200D ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0022 × 0020 ÷ 200D ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 200D ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 ÷ 200D ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0022 × 00A7 ÷	#  × [0.3] QUOTATION MARK (QU) × [19.02] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0022 × 0020 ÷ 00A7 ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 00A7 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.02] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0022 × 50005 ÷	#  × [0.3] QUOTATION MARK (QU) × [19.02] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0022 × 0020 ÷ 50005 ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 50005 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.02] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0022 × 0E01 ÷	#  × [0.3] QUOTATION MARK (QU) × [19.02] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0022 × 0020 ÷ 0E01 ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0E01 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.02] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0022 × 3041 ÷	#  × [0.3] QUOTATION MARK (QU) × [19.02] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0022 × 0020 ÷ 3041 ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 3041 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.02] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 ÷ 3041 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0023 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0020 × 0020 ÷ 0023 ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0023 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [28.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 ÷ 0023 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0020 ÷ 2014 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0020 × 0020 ÷ 2014 ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 ÷ 2014 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 ÷ 2014 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0009 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0020 × 0020 ÷ 0009 ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0009 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 ÷ 0009 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0020 ÷ 00B4 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0020 × 0020 ÷ 00B4 ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 ÷ 00B4 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0020 × 000B ÷	#  × [0.3] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0020 × 0020 × 000B ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 000B ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 × 000B ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0020 ÷ FFFC ÷	#  × [0.3] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0020 × 0020 ÷ FFFC ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 ÷ FFFC ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 ÷ FFFC ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0020 × 007D ÷	#  × [0.3] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0020 × 0020 × 007D ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 007D ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 × 007D ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0020 × 000D ÷	#  × [0.3] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0020 × 0020 × 000D ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 000D ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 × 000D ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0020 × 0021 ÷	#  × [0.3] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0020 × 0020 × 0021 ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0021 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 × 0021 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0020 ÷ 00A0 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0020 × 0020 ÷ 00A0 ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 00A0 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0020 ÷ AC00 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0020 × 0020 ÷ AC00 ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 ÷ AC00 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 ÷ AC00 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0020 ÷ AC01 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0020 × 0020 ÷ AC01 ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 ÷ AC01 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 ÷ AC01 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0020 ÷ 05D0 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0020 × 0020 ÷ 05D0 ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 05D0 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [28.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0020 ÷ 002D ÷	#  × [0.3] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0020 × 0020 ÷ 002D ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 002D ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 ÷ 002D ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0020 ÷ 231A ÷	#  × [0.3] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0020 × 0020 ÷ 231A ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 ÷ 231A ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 ÷ 231A ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0020 ÷ 2024 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0020 × 0020 ÷ 2024 ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 2024 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 ÷ 2024 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0020 × 002C ÷	#  × [0.3] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0020 × 0020 × 002C ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 002C ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 × 002C ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0020 ÷ 1100 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0020 × 0020 ÷ 1100 ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 ÷ 1100 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 ÷ 1100 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0020 ÷ 11A8 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0020 × 0020 ÷ 11A8 ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 ÷ 11A8 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0020 ÷ 1160 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0020 × 0020 ÷ 1160 ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 ÷ 1160 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 ÷ 1160 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0020 × 000A ÷	#  × [0.3] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0020 × 0020 × 000A ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 000A ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 × 000A ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0020 × 0085 ÷	#  × [0.3] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0020 × 0020 × 0085 ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0085 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 × 0085 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0020 ÷ 17D6 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0020 × 0020 ÷ 17D6 ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 17D6 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0030 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0020 × 0020 ÷ 0030 ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0030 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [23.02] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 ÷ 0030 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0020 ÷ 2329 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 0020 × 0020 ÷ 2329 ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 ÷ 2329 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 ÷ 2329 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0025 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0020 × 0020 ÷ 0025 ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0025 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [24.03] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 ÷ 0025 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0024 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0020 × 0020 ÷ 0024 ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0024 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [24.03] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 ÷ 0024 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0022 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0020 × 0020 ÷ 0022 ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0022 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 ÷ 0022 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0020 × 0020 ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0020 × 0020 × 0020 ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 × 0020 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0020 × 002F ÷	#  × [0.3] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0020 × 0020 × 002F ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 002F ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 × 002F ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0020 × 2060 ÷	#  × [0.3] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0020 × 0020 × 2060 ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 2060 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 × 2060 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0020 × 200B ÷	#  × [0.3] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0020 × 0020 × 200B ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 200B ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 × 200B ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0020 ÷ 1F1E6 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0020 × 0020 ÷ 1F1E6 ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 ÷ 1F1E6 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0020 ÷ 261D ÷	#  × [0.3] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0020 × 0020 ÷ 261D ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 ÷ 261D ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 ÷ 261D ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0020 ÷ 1F3FB ÷	#  × [0.3] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0020 × 0020 ÷ 1F3FB ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 ÷ 1F3FB ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0020 × 0029 ÷	#  × [0.3] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0020 × 0020 × 0029 ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0029 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 × 0029 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0028 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 0020 × 0020 ÷ 0028 ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0028 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [30.01] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 ÷ 0028 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0001 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0020 × 0020 ÷ 0001 ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0001 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 ÷ 0001 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0020 ÷ 200D ÷	#  × [0.3] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0020 × 0020 ÷ 200D ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 200D ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 ÷ 200D ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0020 ÷ 00A7 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0020 × 0020 ÷ 00A7 ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 00A7 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [28.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0020 ÷ 50005 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0020 × 0020 ÷ 50005 ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 50005 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [28.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 ÷ 50005 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0E01 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0020 × 0020 ÷ 0E01 ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0E01 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [28.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0020 ÷ 3041 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0020 × 0020 ÷ 3041 ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 3041 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 ÷ 3041 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 002F ÷ 0023 ÷	#  × [0.3] SOLIDUS (SY) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 002F × 0020 ÷ 0023 ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 002F × 0308 ÷ 0023 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 002F ÷ 2014 ÷	#  × [0.3] SOLIDUS (SY) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 002F × 0020 ÷ 2014 ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 002F × 0308 ÷ 2014 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 002F × 0009 ÷	#  × [0.3] SOLIDUS (SY) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 002F × 0020 ÷ 0009 ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0009 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 002F ÷ 00B4 ÷	#  × [0.3] SOLIDUS (SY) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 002F × 0020 ÷ 00B4 ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 002F × 0308 ÷ 00B4 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 002F × 000B ÷	#  × [0.3] SOLIDUS (SY) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 002F × 0020 × 000B ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 000B ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 × 000B ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 002F ÷ FFFC ÷	#  × [0.3] SOLIDUS (SY) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 002F × 0020 ÷ FFFC ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 002F × 0308 ÷ FFFC ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 002F × 007D ÷	#  × [0.3] SOLIDUS (SY) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 002F × 0020 × 007D ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 007D ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 × 007D ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 002F × 000D ÷	#  × [0.3] SOLIDUS (SY) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 002F × 0020 × 000D ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 000D ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 × 000D ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 002F × 0021 ÷	#  × [0.3] SOLIDUS (SY) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 002F × 0020 × 0021 ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0021 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 × 0021 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 002F × 00A0 ÷	#  × [0.3] SOLIDUS (SY) × [12.1] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 002F × 0020 ÷ 00A0 ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 00A0 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 002F ÷ AC00 ÷	#  × [0.3] SOLIDUS (SY) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 002F × 0020 ÷ AC00 ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 002F × 0308 ÷ AC00 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 002F ÷ AC01 ÷	#  × [0.3] SOLIDUS (SY) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 002F × 0020 ÷ AC01 ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 002F × 0308 ÷ AC01 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 002F × 05D0 ÷	#  × [0.3] SOLIDUS (SY) × [21.2] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 002F × 0020 ÷ 05D0 ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 05D0 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.2] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 002F × 002D ÷	#  × [0.3] SOLIDUS (SY) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 002F × 0020 ÷ 002D ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 002D ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 ÷ 002D ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 002F ÷ 231A ÷	#  × [0.3] SOLIDUS (SY) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 002F × 0020 ÷ 231A ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 002F × 0308 ÷ 231A ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 ÷ 231A ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 002F × 2024 ÷	#  × [0.3] SOLIDUS (SY) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 002F × 0020 ÷ 2024 ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 2024 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 002F × 002C ÷	#  × [0.3] SOLIDUS (SY) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 002F × 0020 × 002C ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 002C ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 × 002C ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 002F ÷ 1100 ÷	#  × [0.3] SOLIDUS (SY) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 002F × 0020 ÷ 1100 ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 002F × 0308 ÷ 1100 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 002F ÷ 11A8 ÷	#  × [0.3] SOLIDUS (SY) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 002F × 0020 ÷ 11A8 ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 002F × 0308 ÷ 11A8 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 002F ÷ 1160 ÷	#  × [0.3] SOLIDUS (SY) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 002F × 0020 ÷ 1160 ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 002F × 0308 ÷ 1160 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 002F × 000A ÷	#  × [0.3] SOLIDUS (SY) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 002F × 0020 × 000A ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 000A ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 × 000A ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 002F × 0085 ÷	#  × [0.3] SOLIDUS (SY) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 002F × 0020 × 0085 ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0085 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 × 0085 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 002F × 17D6 ÷	#  × [0.3] SOLIDUS (SY) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 002F × 0020 ÷ 17D6 ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 17D6 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 002F ÷ 0030 ÷	#  × [0.3] SOLIDUS (SY) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 002F × 0020 ÷ 0030 ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 002F × 0308 ÷ 0030 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 002F ÷ 2329 ÷	#  × [0.3] SOLIDUS (SY) ÷ [999.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 002F × 0020 ÷ 2329 ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 002F × 0308 ÷ 2329 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 ÷ 2329 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 002F ÷ 0025 ÷	#  × [0.3] SOLIDUS (SY) ÷ [999.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 002F × 0020 ÷ 0025 ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 002F × 0308 ÷ 0025 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 002F ÷ 0024 ÷	#  × [0.3] SOLIDUS (SY) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 002F × 0020 ÷ 0024 ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 002F × 0308 ÷ 0024 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 002F × 0022 ÷	#  × [0.3] SOLIDUS (SY) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 002F × 0020 ÷ 0022 ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0022 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 002F × 0020 ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 002F × 0020 × 0020 ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 × 0020 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 002F × 002F ÷	#  × [0.3] SOLIDUS (SY) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 002F × 0020 × 002F ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 002F ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 × 002F ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 002F × 2060 ÷	#  × [0.3] SOLIDUS (SY) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 002F × 0020 × 2060 ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 2060 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 × 2060 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 002F × 200B ÷	#  × [0.3] SOLIDUS (SY) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 002F × 0020 × 200B ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 200B ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 × 200B ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 002F ÷ 1F1E6 ÷	#  × [0.3] SOLIDUS (SY) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 002F × 0020 ÷ 1F1E6 ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 002F × 0308 ÷ 1F1E6 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 002F ÷ 261D ÷	#  × [0.3] SOLIDUS (SY) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 002F × 0020 ÷ 261D ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 002F × 0308 ÷ 261D ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 ÷ 261D ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 002F ÷ 1F3FB ÷	#  × [0.3] SOLIDUS (SY) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 002F × 0020 ÷ 1F3FB ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 002F × 0308 ÷ 1F3FB ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 002F × 0029 ÷	#  × [0.3] SOLIDUS (SY) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 002F × 0020 × 0029 ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0029 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 × 0029 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 002F ÷ 0028 ÷	#  × [0.3] SOLIDUS (SY) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 002F × 0020 ÷ 0028 ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 002F × 0308 ÷ 0028 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 002F × 0001 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 002F × 0020 ÷ 0001 ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0001 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 002F × 200D ÷	#  × [0.3] SOLIDUS (SY) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 002F × 0020 ÷ 200D ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 200D ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 ÷ 200D ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 002F ÷ 00A7 ÷	#  × [0.3] SOLIDUS (SY) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 002F × 0020 ÷ 00A7 ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 002F × 0308 ÷ 00A7 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 002F ÷ 50005 ÷	#  × [0.3] SOLIDUS (SY) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 002F × 0020 ÷ 50005 ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 002F × 0308 ÷ 50005 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 002F ÷ 0E01 ÷	#  × [0.3] SOLIDUS (SY) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 002F × 0020 ÷ 0E01 ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 002F × 0308 ÷ 0E01 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 002F × 3041 ÷	#  × [0.3] SOLIDUS (SY) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 002F × 0020 ÷ 3041 ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 3041 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 ÷ 3041 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 2060 × 0023 ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 2060 × 0020 ÷ 0023 ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0023 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 2060 × 2014 ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 2060 × 0020 ÷ 2014 ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 2014 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 2060 × 0009 ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 2060 × 0020 ÷ 0009 ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0009 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 2060 × 00B4 ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 2060 × 0020 ÷ 00B4 ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 00B4 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 2060 × 000B ÷	#  × [0.3] WORD JOINER (WJ) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 2060 × 0020 × 000B ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 000B ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 × 000B ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 2060 × FFFC ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 2060 × 0020 ÷ FFFC ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × FFFC ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 2060 × 007D ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 2060 × 0020 × 007D ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 007D ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 × 007D ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 2060 × 000D ÷	#  × [0.3] WORD JOINER (WJ) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 2060 × 0020 × 000D ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 000D ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 × 000D ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 2060 × 0021 ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 2060 × 0020 × 0021 ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0021 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 × 0021 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 2060 × 00A0 ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 2060 × 0020 ÷ 00A0 ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 00A0 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 2060 × AC00 ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 2060 × 0020 ÷ AC00 ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × AC00 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 2060 × AC01 ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 2060 × 0020 ÷ AC01 ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × AC01 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 2060 × 05D0 ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 2060 × 0020 ÷ 05D0 ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 05D0 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 2060 × 002D ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 2060 × 0020 ÷ 002D ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 002D ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 ÷ 002D ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 2060 × 231A ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] WATCH (ID) ÷ [0.3]');
    Test_LB('× 2060 × 0020 ÷ 231A ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 231A ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] WATCH (ID) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 ÷ 231A ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 2060 × 2024 ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 2060 × 0020 ÷ 2024 ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 2024 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 2060 × 002C ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 2060 × 0020 × 002C ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 002C ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 × 002C ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 2060 × 1100 ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 2060 × 0020 ÷ 1100 ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 1100 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 2060 × 11A8 ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 2060 × 0020 ÷ 11A8 ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 11A8 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 2060 × 1160 ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 2060 × 0020 ÷ 1160 ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 1160 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 2060 × 000A ÷	#  × [0.3] WORD JOINER (WJ) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 2060 × 0020 × 000A ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 000A ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 × 000A ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 2060 × 0085 ÷	#  × [0.3] WORD JOINER (WJ) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 2060 × 0020 × 0085 ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0085 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 × 0085 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 2060 × 17D6 ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 2060 × 0020 ÷ 17D6 ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 17D6 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 2060 × 0030 ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 2060 × 0020 ÷ 0030 ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0030 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 2060 × 2329 ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 2060 × 0020 ÷ 2329 ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 2329 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 ÷ 2329 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 2060 × 0025 ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 2060 × 0020 ÷ 0025 ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0025 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 2060 × 0024 ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 2060 × 0020 ÷ 0024 ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0024 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 2060 × 0022 ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 2060 × 0020 ÷ 0022 ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0022 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 2060 × 0020 ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 2060 × 0020 × 0020 ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 × 0020 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 2060 × 002F ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 2060 × 0020 × 002F ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 002F ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 × 002F ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 2060 × 2060 ÷	#  × [0.3] WORD JOINER (WJ) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 2060 × 0020 × 2060 ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 2060 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 × 2060 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 2060 × 200B ÷	#  × [0.3] WORD JOINER (WJ) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 2060 × 0020 × 200B ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 200B ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 × 200B ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 2060 × 1F1E6 ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 2060 × 0020 ÷ 1F1E6 ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 1F1E6 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 2060 × 261D ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 2060 × 0020 ÷ 261D ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 261D ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 ÷ 261D ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 2060 × 1F3FB ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 2060 × 0020 ÷ 1F3FB ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 1F3FB ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 2060 × 0029 ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 2060 × 0020 × 0029 ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0029 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 × 0029 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 2060 × 0028 ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 2060 × 0020 ÷ 0028 ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0028 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 2060 × 0001 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 2060 × 0020 ÷ 0001 ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0001 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 2060 × 200D ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 2060 × 0020 ÷ 200D ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 200D ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 ÷ 200D ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 2060 × 00A7 ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 2060 × 0020 ÷ 00A7 ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 00A7 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 2060 × 50005 ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 2060 × 0020 ÷ 50005 ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 50005 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 2060 × 0E01 ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 2060 × 0020 ÷ 0E01 ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0E01 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 2060 × 3041 ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 2060 × 0020 ÷ 3041 ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 3041 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 ÷ 3041 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 200B ÷ 0023 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 0023 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0023 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [28.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 ÷ 0023 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 200B ÷ 2014 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 2014 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 ÷ 2014 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 ÷ 2014 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 200B ÷ 0009 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 0009 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0009 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 ÷ 0009 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 200B ÷ 00B4 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 00B4 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 ÷ 00B4 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 200B × 000B ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 200B × 0020 × 000B ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 000B ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 × 000B ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 200B ÷ FFFC ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ FFFC ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 ÷ FFFC ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 ÷ FFFC ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 200B ÷ 007D ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 007D ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 007D ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 × 007D ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 200B × 000D ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 200B × 0020 × 000D ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 000D ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 × 000D ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 200B ÷ 0021 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 0021 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0021 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 × 0021 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 200B ÷ 00A0 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 00A0 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 00A0 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 200B ÷ AC00 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ AC00 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 ÷ AC00 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 ÷ AC00 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 200B ÷ AC01 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ AC01 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 ÷ AC01 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 ÷ AC01 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 200B ÷ 05D0 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 05D0 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 05D0 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [28.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 200B ÷ 002D ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 002D ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 002D ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 ÷ 002D ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 200B ÷ 231A ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 231A ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 ÷ 231A ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 ÷ 231A ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 200B ÷ 2024 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 2024 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 2024 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 ÷ 2024 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 200B ÷ 002C ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMMA (IS) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 002C ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] COMMA (IS) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 002C ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 × 002C ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 200B ÷ 1100 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 1100 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 ÷ 1100 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 ÷ 1100 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 200B ÷ 11A8 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 11A8 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 ÷ 11A8 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 200B ÷ 1160 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 1160 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 ÷ 1160 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 ÷ 1160 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 200B × 000A ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 200B × 0020 × 000A ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 000A ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 × 000A ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 200B × 0085 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 200B × 0020 × 0085 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0085 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 × 0085 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 200B ÷ 17D6 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 17D6 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 17D6 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 200B ÷ 0030 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 0030 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0030 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [23.02] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 ÷ 0030 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 200B ÷ 2329 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 2329 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 ÷ 2329 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 ÷ 2329 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 200B ÷ 0025 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 0025 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0025 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [24.03] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 ÷ 0025 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 200B ÷ 0024 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 0024 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0024 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [24.03] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 ÷ 0024 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 200B ÷ 0022 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 0022 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0022 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 ÷ 0022 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 200B × 0020 × 0020 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 × 0020 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 200B ÷ 002F ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 002F ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 002F ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 × 002F ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 200B ÷ 2060 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 2060 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 2060 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 × 2060 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 200B × 200B ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 200B × 0020 × 200B ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 200B ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 × 200B ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 200B ÷ 1F1E6 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 1F1E6 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 ÷ 1F1E6 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 200B ÷ 261D ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 261D ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 ÷ 261D ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 ÷ 261D ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 200B ÷ 1F3FB ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 1F3FB ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 ÷ 1F3FB ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 200B ÷ 0029 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 0029 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0029 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 × 0029 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 200B ÷ 0028 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 0028 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0028 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [30.01] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 ÷ 0028 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 200B ÷ 0001 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 0001 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0001 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 ÷ 0001 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 200B ÷ 200D ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 200D ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 200D ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 ÷ 200D ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 200B ÷ 00A7 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 00A7 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 00A7 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [28.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 200B ÷ 50005 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 50005 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 50005 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [28.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 ÷ 50005 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 200B ÷ 0E01 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 0E01 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0E01 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [28.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 200B ÷ 3041 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 3041 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 3041 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 ÷ 3041 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 1F1E6 ÷ 0023 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 ÷ 0023 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 ÷ 0023 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 1F1E6 ÷ 2014 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 ÷ 2014 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 ÷ 2014 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0009 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 ÷ 0009 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0009 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 1F1E6 ÷ 00B4 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 ÷ 00B4 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 ÷ 00B4 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 1F1E6 × 000B ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 × 000B ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 000B ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 × 000B ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 1F1E6 ÷ FFFC ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 ÷ FFFC ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 ÷ FFFC ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 1F1E6 × 007D ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 × 007D ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 007D ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 × 007D ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 1F1E6 × 000D ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 × 000D ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 000D ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 × 000D ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0021 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 × 0021 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0021 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 × 0021 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 1F1E6 × 00A0 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [12.1] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 ÷ 00A0 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 00A0 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 1F1E6 ÷ AC00 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 ÷ AC00 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 ÷ AC00 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 1F1E6 ÷ AC01 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 ÷ AC01 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 ÷ AC01 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 1F1E6 ÷ 05D0 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 ÷ 05D0 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 ÷ 05D0 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 1F1E6 × 002D ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 ÷ 002D ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 002D ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 ÷ 002D ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 1F1E6 ÷ 231A ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 ÷ 231A ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 ÷ 231A ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 ÷ 231A ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 1F1E6 × 2024 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 ÷ 2024 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 2024 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 1F1E6 × 002C ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 × 002C ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 002C ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 × 002C ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 1F1E6 ÷ 1100 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 ÷ 1100 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 ÷ 1100 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 1F1E6 ÷ 11A8 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 ÷ 11A8 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 ÷ 11A8 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 1F1E6 ÷ 1160 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 ÷ 1160 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 ÷ 1160 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 1F1E6 × 000A ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 × 000A ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 000A ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 × 000A ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0085 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 × 0085 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0085 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 × 0085 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 1F1E6 × 17D6 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 ÷ 17D6 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 17D6 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 1F1E6 ÷ 0030 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 ÷ 0030 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 ÷ 0030 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 1F1E6 ÷ 2329 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 ÷ 2329 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 ÷ 2329 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 ÷ 2329 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 1F1E6 ÷ 0025 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 ÷ 0025 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 ÷ 0025 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 1F1E6 ÷ 0024 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 ÷ 0024 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 ÷ 0024 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0022 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 ÷ 0022 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0022 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 × 0020 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 × 0020 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 1F1E6 × 002F ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 × 002F ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 002F ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 × 002F ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 1F1E6 × 2060 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 × 2060 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 2060 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 × 2060 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 1F1E6 × 200B ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 × 200B ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 200B ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 × 200B ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 1F1E6 × 1F1E6 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [30.11] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 ÷ 1F1E6 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 1F1E6 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [30.11] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 1F1E6 ÷ 261D ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 ÷ 261D ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 ÷ 261D ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 ÷ 261D ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 1F1E6 ÷ 1F3FB ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 ÷ 1F3FB ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 ÷ 1F3FB ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0029 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 × 0029 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0029 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 × 0029 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 1F1E6 ÷ 0028 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 ÷ 0028 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 ÷ 0028 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0001 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 ÷ 0001 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0001 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 1F1E6 × 200D ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 ÷ 200D ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 200D ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 ÷ 200D ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 1F1E6 ÷ 00A7 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 ÷ 00A7 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 ÷ 00A7 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 1F1E6 ÷ 50005 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 ÷ 50005 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 ÷ 50005 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 1F1E6 ÷ 0E01 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 ÷ 0E01 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 ÷ 0E01 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 1F1E6 × 3041 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 ÷ 3041 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 3041 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 ÷ 3041 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 261D ÷ 0023 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 261D × 0020 ÷ 0023 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 261D × 0308 ÷ 0023 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 261D ÷ 2014 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 261D × 0020 ÷ 2014 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 261D × 0308 ÷ 2014 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 261D × 0009 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 261D × 0020 ÷ 0009 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0009 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 261D ÷ 00B4 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 261D × 0020 ÷ 00B4 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 261D × 0308 ÷ 00B4 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 261D × 000B ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 261D × 0020 × 000B ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 000B ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 × 000B ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 261D ÷ FFFC ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 261D × 0020 ÷ FFFC ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 261D × 0308 ÷ FFFC ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 261D × 007D ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 261D × 0020 × 007D ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 007D ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 × 007D ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 261D × 000D ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 261D × 0020 × 000D ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 000D ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 × 000D ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 261D × 0021 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 261D × 0020 × 0021 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0021 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 × 0021 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 261D × 00A0 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [12.1] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 261D × 0020 ÷ 00A0 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 00A0 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 261D ÷ AC00 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 261D × 0020 ÷ AC00 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 261D × 0308 ÷ AC00 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 261D ÷ AC01 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 261D × 0020 ÷ AC01 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 261D × 0308 ÷ AC01 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 261D ÷ 05D0 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 261D × 0020 ÷ 05D0 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 261D × 0308 ÷ 05D0 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 261D × 002D ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 261D × 0020 ÷ 002D ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 002D ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 ÷ 002D ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 261D ÷ 231A ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 261D × 0020 ÷ 231A ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 261D × 0308 ÷ 231A ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 ÷ 231A ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 261D × 2024 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 261D × 0020 ÷ 2024 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 2024 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 261D × 002C ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 261D × 0020 × 002C ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
}
if (!$::TESTCHUNK or $::TESTCHUNK == 9) {
    Test_LB('× 261D × 0308 × 002C ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 × 002C ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 261D ÷ 1100 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 261D × 0020 ÷ 1100 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 261D × 0308 ÷ 1100 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 261D ÷ 11A8 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 261D × 0020 ÷ 11A8 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 261D × 0308 ÷ 11A8 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 261D ÷ 1160 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 261D × 0020 ÷ 1160 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 261D × 0308 ÷ 1160 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 261D × 000A ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 261D × 0020 × 000A ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 000A ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 × 000A ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 261D × 0085 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 261D × 0020 × 0085 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0085 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 × 0085 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 261D × 17D6 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 261D × 0020 ÷ 17D6 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 17D6 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 261D ÷ 0030 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 261D × 0020 ÷ 0030 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 261D × 0308 ÷ 0030 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 261D ÷ 2329 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) ÷ [999.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 261D × 0020 ÷ 2329 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 261D × 0308 ÷ 2329 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 ÷ 2329 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 261D × 0025 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [23.13] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 261D × 0020 ÷ 0025 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0025 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [23.13] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 261D ÷ 0024 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 261D × 0020 ÷ 0024 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 261D × 0308 ÷ 0024 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 261D × 0022 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 261D × 0020 ÷ 0022 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0022 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 261D × 0020 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 261D × 0020 × 0020 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 × 0020 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 261D × 002F ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 261D × 0020 × 002F ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 002F ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 × 002F ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 261D × 2060 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 261D × 0020 × 2060 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 2060 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 × 2060 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 261D × 200B ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 261D × 0020 × 200B ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 200B ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 × 200B ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 261D ÷ 1F1E6 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 261D × 0020 ÷ 1F1E6 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 261D × 0308 ÷ 1F1E6 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 261D ÷ 261D ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 261D × 0020 ÷ 261D ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 261D × 0308 ÷ 261D ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 ÷ 261D ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 261D × 1F3FB ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [30.2] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 261D × 0020 ÷ 1F3FB ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 1F3FB ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [30.2] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 261D × 0029 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 261D × 0020 × 0029 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0029 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 × 0029 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 261D ÷ 0028 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 261D × 0020 ÷ 0028 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 261D × 0308 ÷ 0028 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 261D × 0001 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 261D × 0020 ÷ 0001 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0001 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 261D × 200D ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 261D × 0020 ÷ 200D ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 200D ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 ÷ 200D ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 261D ÷ 00A7 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 261D × 0020 ÷ 00A7 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 261D × 0308 ÷ 00A7 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 261D ÷ 50005 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 261D × 0020 ÷ 50005 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 261D × 0308 ÷ 50005 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 261D ÷ 0E01 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 261D × 0020 ÷ 0E01 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 261D × 0308 ÷ 0E01 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 261D × 3041 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 261D × 0020 ÷ 3041 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 3041 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 ÷ 3041 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 1F3FB ÷ 0023 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 ÷ 0023 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 ÷ 0023 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 1F3FB ÷ 2014 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 ÷ 2014 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 ÷ 2014 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 1F3FB × 0009 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 ÷ 0009 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0009 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 1F3FB ÷ 00B4 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 ÷ 00B4 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 ÷ 00B4 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 1F3FB × 000B ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 × 000B ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 000B ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 × 000B ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 1F3FB ÷ FFFC ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 ÷ FFFC ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 ÷ FFFC ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 1F3FB × 007D ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 × 007D ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 007D ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 × 007D ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 1F3FB × 000D ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 × 000D ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 000D ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 × 000D ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 1F3FB × 0021 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 × 0021 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0021 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 × 0021 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 1F3FB × 00A0 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [12.1] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 ÷ 00A0 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 00A0 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 1F3FB ÷ AC00 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 ÷ AC00 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 ÷ AC00 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 1F3FB ÷ AC01 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 ÷ AC01 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 ÷ AC01 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 1F3FB ÷ 05D0 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 ÷ 05D0 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 ÷ 05D0 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 1F3FB × 002D ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 ÷ 002D ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 002D ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 ÷ 002D ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 1F3FB ÷ 231A ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 ÷ 231A ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 ÷ 231A ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 ÷ 231A ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 1F3FB × 2024 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 ÷ 2024 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 2024 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 1F3FB × 002C ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 × 002C ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 002C ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 × 002C ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 1F3FB ÷ 1100 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 ÷ 1100 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 ÷ 1100 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 1F3FB ÷ 11A8 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 ÷ 11A8 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 ÷ 11A8 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 1F3FB ÷ 1160 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 ÷ 1160 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 ÷ 1160 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 1F3FB × 000A ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 × 000A ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 000A ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 × 000A ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 1F3FB × 0085 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 × 0085 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0085 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 × 0085 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 1F3FB × 17D6 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 ÷ 17D6 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 17D6 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 1F3FB ÷ 0030 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 ÷ 0030 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 ÷ 0030 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 1F3FB ÷ 2329 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [999.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 ÷ 2329 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 ÷ 2329 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 ÷ 2329 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 1F3FB × 0025 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [23.13] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 ÷ 0025 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0025 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [23.13] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 1F3FB ÷ 0024 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 ÷ 0024 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 ÷ 0024 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 1F3FB × 0022 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 ÷ 0022 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0022 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 × 0020 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 × 0020 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 1F3FB × 002F ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 × 002F ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 002F ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 × 002F ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 1F3FB × 2060 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 × 2060 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 2060 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 × 2060 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 1F3FB × 200B ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 × 200B ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 200B ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 × 200B ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 1F3FB ÷ 1F1E6 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 ÷ 1F1E6 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 ÷ 1F1E6 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 1F3FB ÷ 261D ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 ÷ 261D ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 ÷ 261D ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 ÷ 261D ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 1F3FB ÷ 1F3FB ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 ÷ 1F3FB ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 ÷ 1F3FB ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 1F3FB × 0029 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 × 0029 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0029 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 × 0029 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 1F3FB ÷ 0028 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 ÷ 0028 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 ÷ 0028 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 1F3FB × 0001 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 ÷ 0001 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0001 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 1F3FB × 200D ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 ÷ 200D ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 200D ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 ÷ 200D ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 1F3FB ÷ 00A7 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 ÷ 00A7 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 ÷ 00A7 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 1F3FB ÷ 50005 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 ÷ 50005 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 ÷ 50005 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 1F3FB ÷ 0E01 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 ÷ 0E01 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 ÷ 0E01 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 1F3FB × 3041 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 ÷ 3041 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 3041 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 ÷ 3041 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0029 × 0023 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [30.02] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0029 × 0020 ÷ 0023 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0023 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [30.02] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0029 ÷ 2014 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0029 × 0020 ÷ 2014 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0029 × 0308 ÷ 2014 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0029 × 0009 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0029 × 0020 ÷ 0009 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0009 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0029 ÷ 00B4 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0029 × 0020 ÷ 00B4 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0029 × 0308 ÷ 00B4 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0029 × 000B ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0029 × 0020 × 000B ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 000B ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 × 000B ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0029 ÷ FFFC ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0029 × 0020 ÷ FFFC ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0029 × 0308 ÷ FFFC ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0029 × 007D ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0029 × 0020 × 007D ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 007D ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 × 007D ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0029 × 000D ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0029 × 0020 × 000D ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 000D ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 × 000D ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0029 × 0021 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0029 × 0020 × 0021 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0021 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 × 0021 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0029 × 00A0 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [12.1] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0029 × 0020 ÷ 00A0 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 00A0 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0029 ÷ AC00 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0029 × 0020 ÷ AC00 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0029 × 0308 ÷ AC00 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0029 ÷ AC01 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0029 × 0020 ÷ AC01 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0029 × 0308 ÷ AC01 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0029 × 05D0 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [30.02] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0029 × 0020 ÷ 05D0 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 05D0 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [30.02] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0029 × 002D ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0029 × 0020 ÷ 002D ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 002D ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 ÷ 002D ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0029 ÷ 231A ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0029 × 0020 ÷ 231A ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0029 × 0308 ÷ 231A ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 ÷ 231A ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0029 × 2024 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0029 × 0020 ÷ 2024 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 2024 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0029 × 002C ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0029 × 0020 × 002C ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 002C ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 × 002C ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0029 ÷ 1100 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0029 × 0020 ÷ 1100 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0029 × 0308 ÷ 1100 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0029 ÷ 11A8 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0029 × 0020 ÷ 11A8 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0029 × 0308 ÷ 11A8 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0029 ÷ 1160 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0029 × 0020 ÷ 1160 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0029 × 0308 ÷ 1160 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0029 × 000A ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0029 × 0020 × 000A ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 000A ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 × 000A ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0029 × 0085 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0029 × 0020 × 0085 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0085 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 × 0085 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0029 × 17D6 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [16.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0029 × 0020 × 17D6 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [7.01] SPACE (SP) × [16.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 17D6 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [16.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 × 17D6 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [16.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0029 × 0030 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [30.02] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0029 × 0020 ÷ 0030 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0030 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [30.02] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0029 ÷ 2329 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) ÷ [999.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 0029 × 0020 ÷ 2329 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 0029 × 0308 ÷ 2329 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 ÷ 2329 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 0029 ÷ 0025 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) ÷ [999.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0029 × 0020 ÷ 0025 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0029 × 0308 ÷ 0025 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0029 ÷ 0024 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0029 × 0020 ÷ 0024 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0029 × 0308 ÷ 0024 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0029 × 0022 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0029 × 0020 ÷ 0022 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0022 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0029 × 0020 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0029 × 0020 × 0020 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 × 0020 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0029 × 002F ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0029 × 0020 × 002F ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 002F ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 × 002F ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0029 × 2060 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0029 × 0020 × 2060 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 2060 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 × 2060 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0029 × 200B ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0029 × 0020 × 200B ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 200B ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 × 200B ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0029 ÷ 1F1E6 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0029 × 0020 ÷ 1F1E6 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0029 × 0308 ÷ 1F1E6 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0029 ÷ 261D ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0029 × 0020 ÷ 261D ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0029 × 0308 ÷ 261D ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 ÷ 261D ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0029 ÷ 1F3FB ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0029 × 0020 ÷ 1F3FB ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0029 × 0308 ÷ 1F3FB ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0029 × 0029 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0029 × 0020 × 0029 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0029 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 × 0029 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0029 ÷ 0028 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 0029 × 0020 ÷ 0028 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 0029 × 0308 ÷ 0028 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 0029 × 0001 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0029 × 0020 ÷ 0001 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0001 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0029 × 200D ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0029 × 0020 ÷ 200D ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 200D ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 ÷ 200D ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0029 × 00A7 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [30.02] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0029 × 0020 ÷ 00A7 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 00A7 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [30.02] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0029 × 50005 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [30.02] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0029 × 0020 ÷ 50005 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 50005 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [30.02] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0029 × 0E01 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [30.02] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0029 × 0020 ÷ 0E01 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0E01 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [30.02] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0029 × 3041 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [16.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0029 × 0020 × 3041 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [7.01] SPACE (SP) × [16.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 3041 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [16.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 × 3041 ÷	#  × [0.3] RIGHT PARENTHESIS (CP_CP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [16.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0028 × 0023 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [14.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 0023 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [7.01] SPACE (SP) × [14.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0023 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 0023 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0028 × 2014 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [14.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 2014 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [7.01] SPACE (SP) × [14.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 2014 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 2014 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0028 × 0009 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [14.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 0009 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [7.01] SPACE (SP) × [14.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0009 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 0009 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0028 × 00B4 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [14.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 00B4 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [7.01] SPACE (SP) × [14.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 00B4 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 00B4 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0028 × 000B ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 000B ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 000B ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 000B ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0028 × FFFC ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [14.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × FFFC ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [7.01] SPACE (SP) × [14.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × FFFC ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × FFFC ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0028 × 007D ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 007D ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 007D ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 007D ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0028 × 000D ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 000D ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 000D ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 000D ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0028 × 0021 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 0021 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0021 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 0021 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0028 × 00A0 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [12.1] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 00A0 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [7.01] SPACE (SP) × [14.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 00A0 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 00A0 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0028 × AC00 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [14.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × AC00 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [7.01] SPACE (SP) × [14.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × AC00 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × AC00 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0028 × AC01 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [14.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × AC01 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [7.01] SPACE (SP) × [14.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × AC01 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × AC01 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0028 × 05D0 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [14.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 05D0 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [7.01] SPACE (SP) × [14.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 05D0 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 05D0 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0028 × 002D ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [14.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 002D ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [7.01] SPACE (SP) × [14.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 002D ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 002D ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0028 × 231A ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [14.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 231A ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [7.01] SPACE (SP) × [14.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 231A ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 231A ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0028 × 2024 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [14.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 2024 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [7.01] SPACE (SP) × [14.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 2024 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 2024 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0028 × 002C ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 002C ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 002C ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 002C ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0028 × 1100 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [14.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 1100 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [7.01] SPACE (SP) × [14.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 1100 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 1100 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0028 × 11A8 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [14.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 11A8 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [7.01] SPACE (SP) × [14.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 11A8 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 11A8 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0028 × 1160 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [14.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 1160 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [7.01] SPACE (SP) × [14.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 1160 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 1160 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0028 × 000A ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 000A ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 000A ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 000A ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0028 × 0085 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 0085 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0085 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 0085 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0028 × 17D6 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [14.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 17D6 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [7.01] SPACE (SP) × [14.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 17D6 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 17D6 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0028 × 0030 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [14.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 0030 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [7.01] SPACE (SP) × [14.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0030 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 0030 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0028 × 2329 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [14.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 2329 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [7.01] SPACE (SP) × [14.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 2329 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 2329 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 0028 × 0025 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [14.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 0025 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [7.01] SPACE (SP) × [14.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0025 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 0025 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0028 × 0024 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [14.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 0024 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [7.01] SPACE (SP) × [14.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0024 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 0024 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0028 × 0022 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [14.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 0022 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [7.01] SPACE (SP) × [14.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0022 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 0022 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0028 × 0020 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 0020 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 0020 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0028 × 002F ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 002F ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 002F ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 002F ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0028 × 2060 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 2060 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 2060 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 2060 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0028 × 200B ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 200B ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 200B ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 200B ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0028 × 1F1E6 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [14.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 1F1E6 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [7.01] SPACE (SP) × [14.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 1F1E6 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 1F1E6 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0028 × 261D ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [14.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 261D ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [7.01] SPACE (SP) × [14.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 261D ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 261D ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0028 × 1F3FB ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [14.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 1F3FB ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [7.01] SPACE (SP) × [14.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 1F3FB ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 1F3FB ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0028 × 0029 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 0029 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0029 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 0029 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0028 × 0028 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [14.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 0028 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [7.01] SPACE (SP) × [14.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0028 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 0028 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 0028 × 0001 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 0001 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [7.01] SPACE (SP) × [14.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0001 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 0001 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0028 × 200D ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 200D ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [7.01] SPACE (SP) × [14.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 200D ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 200D ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0028 × 00A7 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [14.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 00A7 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [7.01] SPACE (SP) × [14.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 00A7 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 00A7 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0028 × 50005 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [14.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 50005 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [7.01] SPACE (SP) × [14.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 50005 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 50005 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0028 × 0E01 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [14.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 0E01 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [7.01] SPACE (SP) × [14.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0E01 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 0E01 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0028 × 3041 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [14.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 3041 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [7.01] SPACE (SP) × [14.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 3041 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 3041 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0001 × 0023 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [28.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0001 × 0020 ÷ 0023 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0023 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [28.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0001 ÷ 2014 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0001 × 0020 ÷ 2014 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0001 × 0308 ÷ 2014 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0001 × 0009 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0001 × 0020 ÷ 0009 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0009 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0001 ÷ 00B4 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0001 × 0020 ÷ 00B4 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0001 × 0308 ÷ 00B4 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0001 × 000B ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0001 × 0020 × 000B ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 000B ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 × 000B ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0001 ÷ FFFC ÷	#  × [0.3] <START OF HEADING> (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0001 × 0020 ÷ FFFC ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0001 × 0308 ÷ FFFC ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0001 × 007D ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [13.04] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0001 × 0020 × 007D ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 007D ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.04] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 × 007D ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0001 × 000D ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0001 × 0020 × 000D ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 000D ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 × 000D ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0001 × 0021 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0001 × 0020 × 0021 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0021 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 × 0021 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0001 × 00A0 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [12.3] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0001 × 0020 ÷ 00A0 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 00A0 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.3] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0001 ÷ AC00 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0001 × 0020 ÷ AC00 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0001 × 0308 ÷ AC00 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0001 ÷ AC01 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0001 × 0020 ÷ AC01 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0001 × 0308 ÷ AC01 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0001 × 05D0 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [28.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0001 × 0020 ÷ 05D0 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 05D0 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [28.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0001 × 002D ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0001 × 0020 ÷ 002D ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 002D ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 ÷ 002D ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0001 ÷ 231A ÷	#  × [0.3] <START OF HEADING> (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0001 × 0020 ÷ 231A ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0001 × 0308 ÷ 231A ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 ÷ 231A ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0001 × 2024 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0001 × 0020 ÷ 2024 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 2024 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0001 × 002C ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [13.04] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0001 × 0020 × 002C ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 002C ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.04] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 × 002C ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0001 ÷ 1100 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0001 × 0020 ÷ 1100 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0001 × 0308 ÷ 1100 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0001 ÷ 11A8 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0001 × 0020 ÷ 11A8 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0001 × 0308 ÷ 11A8 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0001 ÷ 1160 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0001 × 0020 ÷ 1160 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0001 × 0308 ÷ 1160 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0001 × 000A ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0001 × 0020 × 000A ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 000A ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 × 000A ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0001 × 0085 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0001 × 0020 × 0085 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0085 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 × 0085 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0001 × 17D6 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0001 × 0020 ÷ 17D6 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 17D6 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0001 × 0030 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [23.02] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0001 × 0020 ÷ 0030 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0030 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [23.02] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0001 ÷ 2329 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) ÷ [999.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 0001 × 0020 ÷ 2329 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 0001 × 0308 ÷ 2329 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 ÷ 2329 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 0001 × 0025 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [24.03] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0001 × 0020 ÷ 0025 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0025 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [24.03] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0001 × 0024 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [24.03] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0001 × 0020 ÷ 0024 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0024 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [24.03] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0001 × 0022 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0001 × 0020 ÷ 0022 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0022 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0001 × 0020 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0001 × 0020 × 0020 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 × 0020 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0001 × 002F ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [13.04] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0001 × 0020 × 002F ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 002F ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.04] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 × 002F ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0001 × 2060 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0001 × 0020 × 2060 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 2060 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 × 2060 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0001 × 200B ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0001 × 0020 × 200B ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 200B ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 × 200B ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0001 ÷ 1F1E6 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0001 × 0020 ÷ 1F1E6 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0001 × 0308 ÷ 1F1E6 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0001 ÷ 261D ÷	#  × [0.3] <START OF HEADING> (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0001 × 0020 ÷ 261D ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0001 × 0308 ÷ 261D ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 ÷ 261D ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0001 ÷ 1F3FB ÷	#  × [0.3] <START OF HEADING> (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0001 × 0020 ÷ 1F3FB ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0001 × 0308 ÷ 1F3FB ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0001 × 0029 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [13.04] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0001 × 0020 × 0029 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0029 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.04] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 × 0029 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0001 × 0028 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [30.01] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 0001 × 0020 ÷ 0028 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0028 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [30.01] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 0001 × 0001 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0001 × 0020 ÷ 0001 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0001 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0001 × 200D ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0001 × 0020 ÷ 200D ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 200D ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 ÷ 200D ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0001 × 00A7 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [28.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0001 × 0020 ÷ 00A7 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 00A7 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [28.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0001 × 50005 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [28.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0001 × 0020 ÷ 50005 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 50005 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [28.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0001 × 0E01 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [28.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0001 × 0020 ÷ 0E01 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0E01 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [28.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0001 × 3041 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0001 × 0020 ÷ 3041 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 3041 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 ÷ 3041 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 200D × 0023 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 200D × 0020 ÷ 0023 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0023 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [28.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 200D × 2014 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 200D × 0020 ÷ 2014 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 200D × 0308 ÷ 2014 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 200D × 0009 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 200D × 0020 ÷ 0009 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0009 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 200D × 00B4 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 200D × 0020 ÷ 00B4 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 200D × 0308 ÷ 00B4 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 200D × 000B ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 200D × 0020 × 000B ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 000B ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 × 000B ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 200D × FFFC ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 200D × 0020 ÷ FFFC ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 200D × 0308 ÷ FFFC ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 200D × 007D ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 200D × 0020 × 007D ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 007D ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [13.04] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 × 007D ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 200D × 000D ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 200D × 0020 × 000D ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 000D ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 × 000D ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 200D × 0021 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 200D × 0020 × 0021 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0021 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 × 0021 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 200D × 00A0 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 200D × 0020 ÷ 00A0 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 00A0 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [12.3] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 200D × AC00 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 200D × 0020 ÷ AC00 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 200D × 0308 ÷ AC00 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 200D × AC01 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 200D × 0020 ÷ AC01 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 200D × 0308 ÷ AC01 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 200D × 05D0 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 200D × 0020 ÷ 05D0 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 05D0 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [28.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 200D × 002D ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 200D × 0020 ÷ 002D ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 002D ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 ÷ 002D ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 200D × 231A ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] WATCH (ID) ÷ [0.3]');
    Test_LB('× 200D × 0020 ÷ 231A ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 200D × 0308 ÷ 231A ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 ÷ 231A ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 200D × 2024 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 200D × 0020 ÷ 2024 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 2024 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 200D × 002C ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMMA (IS) ÷ [0.3]');
    Test_LB('× 200D × 0020 × 002C ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 002C ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [13.04] COMMA (IS) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 × 002C ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 200D × 1100 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 200D × 0020 ÷ 1100 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 200D × 0308 ÷ 1100 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 200D × 11A8 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 200D × 0020 ÷ 11A8 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 200D × 0308 ÷ 11A8 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 200D × 1160 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 200D × 0020 ÷ 1160 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 200D × 0308 ÷ 1160 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 200D × 000A ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 200D × 0020 × 000A ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 000A ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 × 000A ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 200D × 0085 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 200D × 0020 × 0085 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0085 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 × 0085 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 200D × 17D6 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 200D × 0020 ÷ 17D6 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 17D6 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 200D × 0030 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 200D × 0020 ÷ 0030 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0030 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [23.02] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 200D × 2329 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 200D × 0020 ÷ 2329 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 200D × 0308 ÷ 2329 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 ÷ 2329 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 200D × 0025 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 200D × 0020 ÷ 0025 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0025 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [24.03] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 200D × 0024 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 200D × 0020 ÷ 0024 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0024 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [24.03] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 200D × 0022 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 200D × 0020 ÷ 0022 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0022 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 200D × 0020 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 200D × 0020 × 0020 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 × 0020 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 200D × 002F ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 200D × 0020 × 002F ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 002F ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [13.04] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 × 002F ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 200D × 2060 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 200D × 0020 × 2060 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 2060 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 × 2060 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 200D × 200B ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 200D × 0020 × 200B ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 200B ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 × 200B ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 200D × 1F1E6 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 200D × 0020 ÷ 1F1E6 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 200D × 0308 ÷ 1F1E6 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 200D × 261D ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 200D × 0020 ÷ 261D ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 200D × 0308 ÷ 261D ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 ÷ 261D ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 200D × 1F3FB ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 200D × 0020 ÷ 1F3FB ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 200D × 0308 ÷ 1F3FB ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 200D × 0029 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 200D × 0020 × 0029 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0029 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [13.04] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 × 0029 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 200D × 0028 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 200D × 0020 ÷ 0028 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0028 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [30.01] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 200D × 0001 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 200D × 0020 ÷ 0001 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0001 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 200D × 200D ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 200D × 0020 ÷ 200D ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 200D ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 ÷ 200D ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 200D × 00A7 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 200D × 0020 ÷ 00A7 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 00A7 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [28.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 200D × 50005 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 200D × 0020 ÷ 50005 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 50005 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [28.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 200D × 0E01 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 200D × 0020 ÷ 0E01 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0E01 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [28.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 200D × 3041 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 200D × 0020 ÷ 3041 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 3041 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 ÷ 3041 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 00A7 × 0023 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [28.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 ÷ 0023 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0023 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [28.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 00A7 ÷ 2014 ÷	#  × [0.3] SECTION SIGN (AI_AL) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 ÷ 2014 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 ÷ 2014 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 00A7 × 0009 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 ÷ 0009 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0009 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 00A7 ÷ 00B4 ÷	#  × [0.3] SECTION SIGN (AI_AL) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 ÷ 00B4 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 ÷ 00B4 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 00A7 × 000B ÷	#  × [0.3] SECTION SIGN (AI_AL) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 × 000B ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 000B ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 × 000B ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 00A7 ÷ FFFC ÷	#  × [0.3] SECTION SIGN (AI_AL) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 ÷ FFFC ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 ÷ FFFC ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 00A7 × 007D ÷	#  × [0.3] SECTION SIGN (AI_AL) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 × 007D ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 007D ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 × 007D ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 00A7 × 000D ÷	#  × [0.3] SECTION SIGN (AI_AL) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 × 000D ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 000D ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 × 000D ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 00A7 × 0021 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 × 0021 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0021 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 × 0021 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 00A7 × 00A0 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [12.1] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 ÷ 00A0 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 00A0 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 00A7 ÷ AC00 ÷	#  × [0.3] SECTION SIGN (AI_AL) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 ÷ AC00 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 ÷ AC00 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 00A7 ÷ AC01 ÷	#  × [0.3] SECTION SIGN (AI_AL) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 ÷ AC01 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 ÷ AC01 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 00A7 × 05D0 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [28.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 ÷ 05D0 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 05D0 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [28.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 00A7 × 002D ÷	#  × [0.3] SECTION SIGN (AI_AL) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 ÷ 002D ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 002D ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 ÷ 002D ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 00A7 ÷ 231A ÷	#  × [0.3] SECTION SIGN (AI_AL) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 ÷ 231A ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 ÷ 231A ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 ÷ 231A ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 00A7 × 2024 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 ÷ 2024 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 2024 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 00A7 × 002C ÷	#  × [0.3] SECTION SIGN (AI_AL) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 × 002C ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 002C ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 × 002C ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 00A7 ÷ 1100 ÷	#  × [0.3] SECTION SIGN (AI_AL) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 ÷ 1100 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 ÷ 1100 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 00A7 ÷ 11A8 ÷	#  × [0.3] SECTION SIGN (AI_AL) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 ÷ 11A8 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 ÷ 11A8 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 00A7 ÷ 1160 ÷	#  × [0.3] SECTION SIGN (AI_AL) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 ÷ 1160 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 ÷ 1160 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 00A7 × 000A ÷	#  × [0.3] SECTION SIGN (AI_AL) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 × 000A ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 000A ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 × 000A ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 00A7 × 0085 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 × 0085 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0085 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 × 0085 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 00A7 × 17D6 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 ÷ 17D6 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 17D6 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 00A7 × 0030 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [23.02] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 ÷ 0030 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0030 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [23.02] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 00A7 ÷ 2329 ÷	#  × [0.3] SECTION SIGN (AI_AL) ÷ [999.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 ÷ 2329 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 ÷ 2329 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 ÷ 2329 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 00A7 × 0025 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [24.03] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 ÷ 0025 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0025 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [24.03] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 00A7 × 0024 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [24.03] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 ÷ 0024 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0024 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [24.03] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 00A7 × 0022 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 ÷ 0022 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0022 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 × 0020 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 × 0020 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 00A7 × 002F ÷	#  × [0.3] SECTION SIGN (AI_AL) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 × 002F ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 002F ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 × 002F ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 00A7 × 2060 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 × 2060 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 2060 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 × 2060 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 00A7 × 200B ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 × 200B ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 200B ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 × 200B ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 00A7 ÷ 1F1E6 ÷	#  × [0.3] SECTION SIGN (AI_AL) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 ÷ 1F1E6 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 ÷ 1F1E6 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 00A7 ÷ 261D ÷	#  × [0.3] SECTION SIGN (AI_AL) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 ÷ 261D ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 ÷ 261D ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 ÷ 261D ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 00A7 ÷ 1F3FB ÷	#  × [0.3] SECTION SIGN (AI_AL) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 ÷ 1F3FB ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 ÷ 1F3FB ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 00A7 × 0029 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 × 0029 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0029 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 × 0029 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 00A7 × 0028 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [30.01] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 ÷ 0028 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0028 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [30.01] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 00A7 × 0001 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 ÷ 0001 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0001 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 00A7 × 200D ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 ÷ 200D ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 200D ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 ÷ 200D ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 00A7 × 00A7 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [28.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 ÷ 00A7 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 00A7 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [28.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 00A7 × 50005 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [28.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 ÷ 50005 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 50005 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [28.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 00A7 × 0E01 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [28.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 ÷ 0E01 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0E01 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [28.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 00A7 × 3041 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 ÷ 3041 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 3041 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 ÷ 3041 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 50005 × 0023 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [28.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 50005 × 0020 ÷ 0023 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0023 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [28.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 50005 ÷ 2014 ÷	#  × [0.3] <reserved-50005> (XX_AL) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 50005 × 0020 ÷ 2014 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 50005 × 0308 ÷ 2014 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 50005 × 0009 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 50005 × 0020 ÷ 0009 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0009 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 50005 ÷ 00B4 ÷	#  × [0.3] <reserved-50005> (XX_AL) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 50005 × 0020 ÷ 00B4 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 50005 × 0308 ÷ 00B4 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 50005 × 000B ÷	#  × [0.3] <reserved-50005> (XX_AL) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 50005 × 0020 × 000B ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 000B ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 × 000B ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 50005 ÷ FFFC ÷	#  × [0.3] <reserved-50005> (XX_AL) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 50005 × 0020 ÷ FFFC ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 50005 × 0308 ÷ FFFC ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 50005 × 007D ÷	#  × [0.3] <reserved-50005> (XX_AL) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 50005 × 0020 × 007D ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 007D ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 × 007D ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 50005 × 000D ÷	#  × [0.3] <reserved-50005> (XX_AL) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 50005 × 0020 × 000D ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 000D ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 × 000D ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 50005 × 0021 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 50005 × 0020 × 0021 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0021 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 × 0021 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 50005 × 00A0 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [12.1] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 50005 × 0020 ÷ 00A0 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 00A0 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 50005 ÷ AC00 ÷	#  × [0.3] <reserved-50005> (XX_AL) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 50005 × 0020 ÷ AC00 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 50005 × 0308 ÷ AC00 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 50005 ÷ AC01 ÷	#  × [0.3] <reserved-50005> (XX_AL) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 50005 × 0020 ÷ AC01 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 50005 × 0308 ÷ AC01 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 50005 × 05D0 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [28.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 50005 × 0020 ÷ 05D0 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 05D0 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [28.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 50005 × 002D ÷	#  × [0.3] <reserved-50005> (XX_AL) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 50005 × 0020 ÷ 002D ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 002D ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 ÷ 002D ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 50005 ÷ 231A ÷	#  × [0.3] <reserved-50005> (XX_AL) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 50005 × 0020 ÷ 231A ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 50005 × 0308 ÷ 231A ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 ÷ 231A ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 50005 × 2024 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 50005 × 0020 ÷ 2024 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 2024 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 50005 × 002C ÷	#  × [0.3] <reserved-50005> (XX_AL) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 50005 × 0020 × 002C ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 002C ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 × 002C ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 50005 ÷ 1100 ÷	#  × [0.3] <reserved-50005> (XX_AL) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 50005 × 0020 ÷ 1100 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 50005 × 0308 ÷ 1100 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 50005 ÷ 11A8 ÷	#  × [0.3] <reserved-50005> (XX_AL) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 50005 × 0020 ÷ 11A8 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 50005 × 0308 ÷ 11A8 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 50005 ÷ 1160 ÷	#  × [0.3] <reserved-50005> (XX_AL) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 50005 × 0020 ÷ 1160 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 50005 × 0308 ÷ 1160 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 50005 × 000A ÷	#  × [0.3] <reserved-50005> (XX_AL) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 50005 × 0020 × 000A ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 000A ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 × 000A ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 50005 × 0085 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 50005 × 0020 × 0085 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0085 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 × 0085 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 50005 × 17D6 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 50005 × 0020 ÷ 17D6 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 17D6 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 50005 × 0030 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [23.02] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 50005 × 0020 ÷ 0030 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0030 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [23.02] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 50005 ÷ 2329 ÷	#  × [0.3] <reserved-50005> (XX_AL) ÷ [999.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 50005 × 0020 ÷ 2329 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 50005 × 0308 ÷ 2329 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 ÷ 2329 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 50005 × 0025 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [24.03] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 50005 × 0020 ÷ 0025 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0025 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [24.03] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 50005 × 0024 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [24.03] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 50005 × 0020 ÷ 0024 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0024 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [24.03] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 50005 × 0022 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 50005 × 0020 ÷ 0022 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0022 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 50005 × 0020 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 50005 × 0020 × 0020 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 × 0020 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 50005 × 002F ÷	#  × [0.3] <reserved-50005> (XX_AL) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 50005 × 0020 × 002F ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 002F ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 × 002F ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 50005 × 2060 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 50005 × 0020 × 2060 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 2060 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 × 2060 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 50005 × 200B ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 50005 × 0020 × 200B ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 200B ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 × 200B ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 50005 ÷ 1F1E6 ÷	#  × [0.3] <reserved-50005> (XX_AL) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 50005 × 0020 ÷ 1F1E6 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 50005 × 0308 ÷ 1F1E6 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 50005 ÷ 261D ÷	#  × [0.3] <reserved-50005> (XX_AL) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 50005 × 0020 ÷ 261D ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 50005 × 0308 ÷ 261D ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 ÷ 261D ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 50005 ÷ 1F3FB ÷	#  × [0.3] <reserved-50005> (XX_AL) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 50005 × 0020 ÷ 1F3FB ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 50005 × 0308 ÷ 1F3FB ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 50005 × 0029 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 50005 × 0020 × 0029 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0029 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 × 0029 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 50005 × 0028 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [30.01] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 50005 × 0020 ÷ 0028 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0028 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [30.01] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 50005 × 0001 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 50005 × 0020 ÷ 0001 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0001 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 50005 × 200D ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 50005 × 0020 ÷ 200D ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 200D ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 ÷ 200D ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 50005 × 00A7 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [28.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 50005 × 0020 ÷ 00A7 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 00A7 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [28.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 50005 × 50005 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [28.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 50005 × 0020 ÷ 50005 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 50005 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [28.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 50005 × 0E01 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [28.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 50005 × 0020 ÷ 0E01 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0E01 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [28.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 50005 × 3041 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 50005 × 0020 ÷ 3041 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 3041 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 ÷ 3041 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0E01 × 0023 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [28.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 ÷ 0023 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0023 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [28.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0E01 ÷ 2014 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 ÷ 2014 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 ÷ 2014 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0E01 × 0009 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 ÷ 0009 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0009 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0E01 ÷ 00B4 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 ÷ 00B4 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 ÷ 00B4 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0E01 × 000B ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 × 000B ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 000B ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 × 000B ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0E01 ÷ FFFC ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 ÷ FFFC ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 ÷ FFFC ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0E01 × 007D ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 × 007D ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 007D ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 × 007D ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0E01 × 000D ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 × 000D ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 000D ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 × 000D ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0E01 × 0021 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 × 0021 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0021 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 × 0021 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0E01 × 00A0 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [12.1] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 ÷ 00A0 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 00A0 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0E01 ÷ AC00 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 ÷ AC00 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 ÷ AC00 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0E01 ÷ AC01 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 ÷ AC01 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 ÷ AC01 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0E01 × 05D0 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [28.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 ÷ 05D0 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 05D0 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [28.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0E01 × 002D ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 ÷ 002D ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 002D ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 ÷ 002D ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0E01 ÷ 231A ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 ÷ 231A ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 ÷ 231A ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 ÷ 231A ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0E01 × 2024 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 ÷ 2024 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 2024 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0E01 × 002C ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 × 002C ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 002C ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 × 002C ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0E01 ÷ 1100 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 ÷ 1100 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 ÷ 1100 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0E01 ÷ 11A8 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 ÷ 11A8 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 ÷ 11A8 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0E01 ÷ 1160 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 ÷ 1160 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 ÷ 1160 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0E01 × 000A ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 × 000A ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 000A ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 × 000A ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0E01 × 0085 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 × 0085 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0085 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 × 0085 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0E01 × 17D6 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 ÷ 17D6 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 17D6 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0E01 × 0030 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [23.02] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 ÷ 0030 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0030 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [23.02] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0E01 ÷ 2329 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) ÷ [999.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 ÷ 2329 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 ÷ 2329 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 ÷ 2329 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 0E01 × 0025 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [24.03] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 ÷ 0025 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0025 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [24.03] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0E01 × 0024 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [24.03] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 ÷ 0024 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0024 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [24.03] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0E01 × 0022 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 ÷ 0022 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0022 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 × 0020 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 × 0020 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0E01 × 002F ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 × 002F ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 002F ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 × 002F ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0E01 × 2060 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 × 2060 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 2060 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 × 2060 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0E01 × 200B ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 × 200B ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 200B ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 × 200B ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0E01 ÷ 1F1E6 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 ÷ 1F1E6 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 ÷ 1F1E6 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0E01 ÷ 261D ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 ÷ 261D ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 ÷ 261D ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 ÷ 261D ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0E01 ÷ 1F3FB ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 ÷ 1F3FB ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 ÷ 1F3FB ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0E01 × 0029 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 × 0029 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0029 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 × 0029 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0E01 × 0028 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [30.01] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 ÷ 0028 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0028 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [30.01] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 0E01 × 0001 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 ÷ 0001 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0001 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0E01 × 200D ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 ÷ 200D ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 200D ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 ÷ 200D ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0E01 × 00A7 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [28.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 ÷ 00A7 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 00A7 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [28.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0E01 × 50005 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [28.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 ÷ 50005 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 50005 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [28.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0E01 × 0E01 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [28.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 ÷ 0E01 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0E01 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [28.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0E01 × 3041 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 ÷ 3041 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 3041 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 ÷ 3041 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 3041 ÷ 0023 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 3041 × 0020 ÷ 0023 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 3041 × 0308 ÷ 0023 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 3041 ÷ 2014 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 3041 × 0020 ÷ 2014 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 3041 × 0308 ÷ 2014 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 3041 × 0009 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 3041 × 0020 ÷ 0009 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0009 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 3041 ÷ 00B4 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 3041 × 0020 ÷ 00B4 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 3041 × 0308 ÷ 00B4 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 3041 × 000B ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 3041 × 0020 × 000B ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 000B ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 × 000B ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 3041 ÷ FFFC ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 3041 × 0020 ÷ FFFC ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 3041 × 0308 ÷ FFFC ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 3041 × 007D ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 3041 × 0020 × 007D ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 007D ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 × 007D ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 3041 × 000D ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 3041 × 0020 × 000D ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 000D ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 × 000D ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 3041 × 0021 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 3041 × 0020 × 0021 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0021 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 × 0021 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 3041 × 00A0 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [12.1] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 3041 × 0020 ÷ 00A0 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 00A0 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 3041 ÷ AC00 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 3041 × 0020 ÷ AC00 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 3041 × 0308 ÷ AC00 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 3041 ÷ AC01 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 3041 × 0020 ÷ AC01 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 3041 × 0308 ÷ AC01 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 3041 ÷ 05D0 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 3041 × 0020 ÷ 05D0 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 3041 × 0308 ÷ 05D0 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 3041 × 002D ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 3041 × 0020 ÷ 002D ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 002D ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 ÷ 002D ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 3041 ÷ 231A ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 3041 × 0020 ÷ 231A ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 3041 × 0308 ÷ 231A ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 ÷ 231A ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 3041 × 2024 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 3041 × 0020 ÷ 2024 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 2024 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 3041 × 002C ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 3041 × 0020 × 002C ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 002C ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 × 002C ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 3041 ÷ 1100 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 3041 × 0020 ÷ 1100 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 3041 × 0308 ÷ 1100 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 3041 ÷ 11A8 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 3041 × 0020 ÷ 11A8 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 3041 × 0308 ÷ 11A8 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 3041 ÷ 1160 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 3041 × 0020 ÷ 1160 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 3041 × 0308 ÷ 1160 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 3041 × 000A ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 3041 × 0020 × 000A ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 000A ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 × 000A ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 3041 × 0085 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 3041 × 0020 × 0085 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0085 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 × 0085 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 3041 × 17D6 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 3041 × 0020 ÷ 17D6 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 17D6 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 3041 ÷ 0030 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 3041 × 0020 ÷ 0030 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 3041 × 0308 ÷ 0030 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 3041 ÷ 2329 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [999.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 3041 × 0020 ÷ 2329 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 3041 × 0308 ÷ 2329 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 ÷ 2329 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT-POINTING ANGLE BRACKET (OP) ÷ [0.3]');
    Test_LB('× 3041 ÷ 0025 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [999.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 3041 × 0020 ÷ 0025 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 3041 × 0308 ÷ 0025 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 3041 ÷ 0024 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 3041 × 0020 ÷ 0024 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 3041 × 0308 ÷ 0024 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 3041 × 0022 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 3041 × 0020 ÷ 0022 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0022 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 3041 × 0020 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 3041 × 0020 × 0020 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 × 0020 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 3041 × 002F ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 3041 × 0020 × 002F ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 002F ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 × 002F ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 3041 × 2060 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 3041 × 0020 × 2060 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 2060 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 × 2060 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 3041 × 200B ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 3041 × 0020 × 200B ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 200B ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 × 200B ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 3041 ÷ 1F1E6 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 3041 × 0020 ÷ 1F1E6 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 3041 × 0308 ÷ 1F1E6 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 3041 ÷ 261D ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 3041 × 0020 ÷ 261D ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 3041 × 0308 ÷ 261D ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 ÷ 261D ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 3041 ÷ 1F3FB ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 3041 × 0020 ÷ 1F3FB ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 3041 × 0308 ÷ 1F3FB ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 3041 × 0029 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 3041 × 0020 × 0029 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0029 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 × 0029 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 3041 ÷ 0028 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 3041 × 0020 ÷ 0028 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 3041 × 0308 ÷ 0028 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) ÷ [0.3]');
    Test_LB('× 3041 × 0001 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 3041 × 0020 ÷ 0001 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0001 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 3041 × 200D ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 3041 × 0020 ÷ 200D ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 200D ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 ÷ 200D ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 3041 ÷ 00A7 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 3041 × 0020 ÷ 00A7 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 3041 × 0308 ÷ 00A7 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 3041 ÷ 50005 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 3041 × 0020 ÷ 50005 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 3041 × 0308 ÷ 50005 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 3041 ÷ 0E01 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 3041 × 0020 ÷ 0E01 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 3041 × 0308 ÷ 0E01 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 3041 × 3041 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 3041 × 0020 ÷ 3041 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 3041 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 ÷ 3041 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 000D × 000A ÷ 0061 × 000A ÷ 0308 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) × [5.01] <LINE FEED (LF)> (LF) ÷ [5.03] LATIN SMALL LETTER A (AL) × [6.0] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) ÷ [0.3]');
    Test_LB('× 0061 × 0308 ÷	#  × [0.3] LATIN SMALL LETTER A (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [0.3]');
    Test_LB('× 0020 ÷ 200D × 0646 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] ARABIC LETTER NOON (AL) ÷ [0.3]');
    Test_LB('× 0646 × 200D × 0020 ÷	#  × [0.3] ARABIC LETTER NOON (AL) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 000B ÷ 3041 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 000D ÷ 3041 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0085 ÷ 3041 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 200D × 261D ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 3041 × 2060 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 2060 × 3041 ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 00A0 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 200D × 00A0 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 200D × 002F ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 2014 × 2014 ÷	#  × [0.3] EM DASH (B2) × [17.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 3041 ÷ FFFC ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× FFFC ÷ 3041 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) ÷ [20.02] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 3041 × 002D ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0E01 × 2024 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0021 × 2024 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 2024 × 2024 ÷	#  × [0.3] ONE DOT LEADER (IN) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0030 × 2024 ÷	#  × [0.3] DIGIT ZERO (NU) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 261D × 0025 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [23.13] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0E01 × 0030 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [23.02] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0024 × 261D ÷	#  × [0.3] DOLLAR SIGN (PR) × [23.12] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0024 × 0E01 ÷	#  × [0.3] DOLLAR SIGN (PR) × [24.02] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0025 × 0E01 ÷	#  × [0.3] PERCENT SIGN (PO) × [24.02] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 1100 × 1160 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [26.01] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 1160 × 1160 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [26.02] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 11A8 × 11A8 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [26.03] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 1160 × 2024 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [22.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 1160 × 0025 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [27.02] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0024 × 1160 ÷	#  × [0.3] DOLLAR SIGN (PR) × [27.03] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 261D × 1F3FB ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [30.2] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0066 × 0069 × 006E × 0061 × 006C ÷	#  × [0.3] LATIN SMALL LETTER F (AL) × [28.0] LATIN SMALL LETTER I (AL) × [28.0] LATIN SMALL LETTER N (AL) × [28.0] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER L (AL) ÷ [0.3]');
    Test_LB('× 0063 × 0061 × 006E × 0027 × 0074 ÷	#  × [0.3] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER N (AL) × [19.01] APOSTROPHE (QU) × [19.02] LATIN SMALL LETTER T (AL) ÷ [0.3]');
    Test_LB('× 0063 × 0061 × 006E × 2019 × 0074 ÷	#  × [0.3] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER N (AL) × [19.01] RIGHT SINGLE QUOTATION MARK (QU) × [19.02] LATIN SMALL LETTER T (AL) ÷ [0.3]');
    Test_LB('× 0027 × 0063 × 0061 × 006E × 0027 × 0020 ÷ 006E × 006F × 0074 ÷	#  × [0.3] APOSTROPHE (QU) × [19.02] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER N (AL) × [19.01] APOSTROPHE (QU) × [7.01] SPACE (SP) ÷ [18.0] LATIN SMALL LETTER N (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER T (AL) ÷ [0.3]');
    Test_LB('× 0063 × 0061 × 006E × 0020 ÷ 0027 × 006E × 006F × 0074 × 0027 ÷	#  × [0.3] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER N (AL) × [7.01] SPACE (SP) ÷ [18.0] APOSTROPHE (QU) × [19.02] LATIN SMALL LETTER N (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER T (AL) × [19.01] APOSTROPHE (QU) ÷ [0.3]');
    Test_LB('× 0062 × 0075 × 0067 × 0028 × 0073 × 0029 × 0020 × 0020 × 0020 × 0020 × 0020 ÷	#  × [0.3] LATIN SMALL LETTER B (AL) × [28.0] LATIN SMALL LETTER U (AL) × [28.0] LATIN SMALL LETTER G (AL) × [30.01] LEFT PARENTHESIS (OP_OP30) × [14.0] LATIN SMALL LETTER S (AL) × [13.02] RIGHT PARENTHESIS (CP_CP30) × [7.01] SPACE (SP) × [7.01] SPACE (SP) × [7.01] SPACE (SP) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0062 × 0075 × 0067 × 0028 × 0073 × 0029 × 00A0 × 0020 × 0020 × 0020 × 0020 × 0020 ÷	#  × [0.3] LATIN SMALL LETTER B (AL) × [28.0] LATIN SMALL LETTER U (AL) × [28.0] LATIN SMALL LETTER G (AL) × [30.01] LEFT PARENTHESIS (OP_OP30) × [14.0] LATIN SMALL LETTER S (AL) × [13.02] RIGHT PARENTHESIS (CP_CP30) × [12.1] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) × [7.01] SPACE (SP) × [7.01] SPACE (SP) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 002E × 002E ÷ 307E ÷ 3059 × 3002 ÷ 0058 × 004D × 004C ÷ 306E × 002E × 002E ÷	#  × [0.3] FULL STOP (IS) × [13.02] FULL STOP (IS) ÷ [999.0] HIRAGANA LETTER MA (ID) ÷ [999.0] HIRAGANA LETTER SU (ID) × [13.02] IDEOGRAPHIC FULL STOP (CL) ÷ [999.0] LATIN CAPITAL LETTER X (AL) × [28.0] LATIN CAPITAL LETTER M (AL) × [28.0] LATIN CAPITAL LETTER L (AL) ÷ [999.0] HIRAGANA LETTER NO (ID) × [13.02] FULL STOP (IS) × [13.02] FULL STOP (IS) ÷ [0.3]');
    Test_LB('× 0061 × 0062 × 00AD ÷ 0062 × 0079 ÷	#  × [0.3] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER B (AL) × [21.01] SOFT HYPHEN (BA) ÷ [999.0] LATIN SMALL LETTER B (AL) × [28.0] LATIN SMALL LETTER Y (AL) ÷ [0.3]');
    Test_LB('× 002D × 0033 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [25.02] DIGIT THREE (NU) ÷ [0.3]');
    Test_LB('× 0065 × 002E × 0067 × 002E ÷	#  × [0.3] LATIN SMALL LETTER E (AL) × [13.02] FULL STOP (IS) × [29.0] LATIN SMALL LETTER G (AL) × [13.02] FULL STOP (IS) ÷ [0.3]');
    Test_LB('× 4E00 × 002E ÷ 4E00 × 002E ÷	#  × [0.3] CJK UNIFIED IDEOGRAPH-4E00 (ID) × [13.02] FULL STOP (IS) ÷ [999.0] CJK UNIFIED IDEOGRAPH-4E00 (ID) × [13.02] FULL STOP (IS) ÷ [0.3]');
    Test_LB('× 0061 × 0020 × 0020 ÷ 0062 ÷	#  × [0.3] LATIN SMALL LETTER A (AL) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [18.0] LATIN SMALL LETTER B (AL) ÷ [0.3]');
    Test_LB('× 0061 × 0020 × 0020 × 200B ÷ 0062 ÷	#  × [0.3] LATIN SMALL LETTER A (AL) × [7.01] SPACE (SP) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [8.0] LATIN SMALL LETTER B (AL) ÷ [0.3]');
    Test_LB('× 0061 × 0020 ÷ 0308 × 0062 ÷	#  × [0.3] LATIN SMALL LETTER A (AL) × [7.01] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [28.0] LATIN SMALL LETTER B (AL) ÷ [0.3]');
    Test_LB('× 0031 × 0308 × 0062 × 0028 × 0061 × 0029 × 002D ÷ 0028 × 0062 × 0029 ÷	#  × [0.3] DIGIT ONE (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [23.03] LATIN SMALL LETTER B (AL) × [30.01] LEFT PARENTHESIS (OP_OP30) × [14.0] LATIN SMALL LETTER A (AL) × [13.02] RIGHT PARENTHESIS (CP_CP30) × [21.02] HYPHEN-MINUS (HY) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) × [14.0] LATIN SMALL LETTER B (AL) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0067 × 0069 × 0076 × 0065 × 0020 ÷ 0062 × 006F × 006F × 006B × 0028 × 0073 × 0029 × 002E ÷	#  × [0.3] LATIN SMALL LETTER G (AL) × [28.0] LATIN SMALL LETTER I (AL) × [28.0] LATIN SMALL LETTER V (AL) × [28.0] LATIN SMALL LETTER E (AL) × [7.01] SPACE (SP) ÷ [18.0] LATIN SMALL LETTER B (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER K (AL) × [30.01] LEFT PARENTHESIS (OP_OP30) × [14.0] LATIN SMALL LETTER S (AL) × [13.02] RIGHT PARENTHESIS (CP_CP30) × [13.02] FULL STOP (IS) ÷ [0.3]');
    Test_LB('× 307E ÷ 0028 × 3059 × 0029 ÷	#  × [0.3] HIRAGANA LETTER MA (ID) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) × [14.0] HIRAGANA LETTER SU (ID) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0066 × 0069 × 006E × 0064 × 0020 × 002E × 0063 × 006F × 006D ÷	#  × [0.3] LATIN SMALL LETTER F (AL) × [28.0] LATIN SMALL LETTER I (AL) × [28.0] LATIN SMALL LETTER N (AL) × [28.0] LATIN SMALL LETTER D (AL) × [7.01] SPACE (SP) × [13.02] FULL STOP (IS) × [29.0] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER M (AL) ÷ [0.3]');
    Test_LB('× 0065 × 0071 × 0075 × 0061 × 006C × 0073 × 0020 × 002E ÷ 0033 × 0035 × 0020 ÷ 0063 × 0065 × 006E × 0074 × 0073 ÷	#  × [0.3] LATIN SMALL LETTER E (AL) × [28.0] LATIN SMALL LETTER Q (AL) × [28.0] LATIN SMALL LETTER U (AL) × [28.0] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER L (AL) × [28.0] LATIN SMALL LETTER S (AL) × [7.01] SPACE (SP) × [13.02] FULL STOP (IS) ÷ [999.0] DIGIT THREE (NU) × [25.03] DIGIT FIVE (NU) × [7.01] SPACE (SP) ÷ [18.0] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER E (AL) × [28.0] LATIN SMALL LETTER N (AL) × [28.0] LATIN SMALL LETTER T (AL) × [28.0] LATIN SMALL LETTER S (AL) ÷ [0.3]');
    Test_LB('× 0028 × 0073 × 0029 × 0068 × 0065 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [14.0] LATIN SMALL LETTER S (AL) × [13.02] RIGHT PARENTHESIS (CP_CP30) × [30.02] LATIN SMALL LETTER H (AL) × [28.0] LATIN SMALL LETTER E (AL) ÷ [0.3]');
    Test_LB('× 007B × 0073 × 007D ÷ 0068 × 0065 ÷	#  × [0.3] LEFT CURLY BRACKET (OP_OP30) × [14.0] LATIN SMALL LETTER S (AL) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [999.0] LATIN SMALL LETTER H (AL) × [28.0] LATIN SMALL LETTER E (AL) ÷ [0.3]');
    Test_LB('× 02C8 × 0073 × 0049 × 006C × 0259 × 0062 × 0028 × 0259 × 0029 × 006C ÷	#  × [0.3] MODIFIER LETTER VERTICAL LINE (BB) × [21.04] LATIN SMALL LETTER S (AL) × [28.0] LATIN CAPITAL LETTER I (AL) × [28.0] LATIN SMALL LETTER L (AL) × [28.0] LATIN SMALL LETTER SCHWA (AL) × [28.0] LATIN SMALL LETTER B (AL) × [30.01] LEFT PARENTHESIS (OP_OP30) × [14.0] LATIN SMALL LETTER SCHWA (AL) × [13.02] RIGHT PARENTHESIS (CP_CP30) × [30.02] LATIN SMALL LETTER L (AL) ÷ [0.3]');
    Test_LB('× 02C8 × 0073 × 0049 × 006C × 0259 × 0062 × 007B × 0259 × 007D ÷ 006C ÷	#  × [0.3] MODIFIER LETTER VERTICAL LINE (BB) × [21.04] LATIN SMALL LETTER S (AL) × [28.0] LATIN CAPITAL LETTER I (AL) × [28.0] LATIN SMALL LETTER L (AL) × [28.0] LATIN SMALL LETTER SCHWA (AL) × [28.0] LATIN SMALL LETTER B (AL) × [30.01] LEFT CURLY BRACKET (OP_OP30) × [14.0] LATIN SMALL LETTER SCHWA (AL) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [999.0] LATIN SMALL LETTER L (AL) ÷ [0.3]');
    Test_LB('× 0063 × 006F × 0064 × 0065 × 0028 × 0073 × 0029 × 002E ÷	#  × [0.3] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER D (AL) × [28.0] LATIN SMALL LETTER E (AL) × [30.01] LEFT PARENTHESIS (OP_OP30) × [14.0] LATIN SMALL LETTER S (AL) × [13.02] RIGHT PARENTHESIS (CP_CP30) × [13.02] FULL STOP (IS) ÷ [0.3]');
    Test_LB('× 0063 × 006F × 0064 × 0065 × 0028 × 0073 × 002E × 0029 ÷	#  × [0.3] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER D (AL) × [28.0] LATIN SMALL LETTER E (AL) × [30.01] LEFT PARENTHESIS (OP_OP30) × [14.0] LATIN SMALL LETTER S (AL) × [13.02] FULL STOP (IS) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0063 × 006F × 0064 × 0065 × 0028 × 0073 × 0029 × 0021 ÷	#  × [0.3] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER D (AL) × [28.0] LATIN SMALL LETTER E (AL) × [30.01] LEFT PARENTHESIS (OP_OP30) × [14.0] LATIN SMALL LETTER S (AL) × [13.02] RIGHT PARENTHESIS (CP_CP30) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0063 × 006F × 0064 × 0065 × 0028 × 0073 × 0021 × 0029 ÷	#  × [0.3] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER D (AL) × [28.0] LATIN SMALL LETTER E (AL) × [30.01] LEFT PARENTHESIS (OP_OP30) × [14.0] LATIN SMALL LETTER S (AL) × [13.01] EXCLAMATION MARK (EX) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0063 × 006F × 0064 × 0065 × 005C ÷ 0028 × 0073 × 005C × 0029 ÷	#  × [0.3] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER D (AL) × [28.0] LATIN SMALL LETTER E (AL) × [24.03] REVERSE SOLIDUS (PR) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) × [14.0] LATIN SMALL LETTER S (AL) × [24.03] REVERSE SOLIDUS (PR) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0063 × 006F × 0064 × 0065 × 0028 × 0020 × 0073 × 0020 × 0029 ÷	#  × [0.3] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER D (AL) × [28.0] LATIN SMALL LETTER E (AL) × [30.01] LEFT PARENTHESIS (OP_OP30) × [7.01] SPACE (SP) × [14.0] LATIN SMALL LETTER S (AL) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0063 × 006F × 0064 × 0065 × 007B × 0073 × 007D ÷	#  × [0.3] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER D (AL) × [28.0] LATIN SMALL LETTER E (AL) × [30.01] LEFT CURLY BRACKET (OP_OP30) × [14.0] LATIN SMALL LETTER S (AL) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0063 × 006F × 0064 × 0065 × 007B × 0073 × 007D × 002E ÷	#  × [0.3] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER D (AL) × [28.0] LATIN SMALL LETTER E (AL) × [30.01] LEFT CURLY BRACKET (OP_OP30) × [14.0] LATIN SMALL LETTER S (AL) × [13.02] RIGHT CURLY BRACKET (CL) × [13.02] FULL STOP (IS) ÷ [0.3]');
    Test_LB('× 0063 × 006F × 0064 × 0065 × 007B × 0073 × 007D × 0021 ÷	#  × [0.3] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER D (AL) × [28.0] LATIN SMALL LETTER E (AL) × [30.01] LEFT CURLY BRACKET (OP_OP30) × [14.0] LATIN SMALL LETTER S (AL) × [13.02] RIGHT CURLY BRACKET (CL) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0063 × 006F × 0064 × 0065 × 005C ÷ 007B × 0073 × 005C × 007D ÷	#  × [0.3] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER D (AL) × [28.0] LATIN SMALL LETTER E (AL) × [24.03] REVERSE SOLIDUS (PR) ÷ [999.0] LEFT CURLY BRACKET (OP_OP30) × [14.0] LATIN SMALL LETTER S (AL) × [24.03] REVERSE SOLIDUS (PR) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0063 × 006F × 0064 × 0065 × 007B × 0020 × 0073 × 0020 × 007D ÷	#  × [0.3] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER D (AL) × [28.0] LATIN SMALL LETTER E (AL) × [30.01] LEFT CURLY BRACKET (OP_OP30) × [7.01] SPACE (SP) × [14.0] LATIN SMALL LETTER S (AL) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0063 × 006F × 0064 × 0028 × 0065 × 0029 × 2026 ÷ 0028 × 0073 × 0029 ÷	#  × [0.3] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER D (AL) × [30.01] LEFT PARENTHESIS (OP_OP30) × [14.0] LATIN SMALL LETTER E (AL) × [13.02] RIGHT PARENTHESIS (CP_CP30) × [22.0] HORIZONTAL ELLIPSIS (IN) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) × [14.0] LATIN SMALL LETTER S (AL) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0028 × 0063 × 006F × 0064 × 0028 × 0065 × 0029 × 2026 × 0029 × 0073 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [14.0] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER D (AL) × [30.01] LEFT PARENTHESIS (OP_OP30) × [14.0] LATIN SMALL LETTER E (AL) × [13.02] RIGHT PARENTHESIS (CP_CP30) × [22.0] HORIZONTAL ELLIPSIS (IN) × [13.02] RIGHT PARENTHESIS (CP_CP30) × [30.02] LATIN SMALL LETTER S (AL) ÷ [0.3]');
    Test_LB('× 0063 × 006F × 0064 × 007B × 0065 × 007D × 2026 ÷ 007B × 0073 × 007D ÷	#  × [0.3] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER D (AL) × [30.01] LEFT CURLY BRACKET (OP_OP30) × [14.0] LATIN SMALL LETTER E (AL) × [13.02] RIGHT CURLY BRACKET (CL) × [22.0] HORIZONTAL ELLIPSIS (IN) ÷ [999.0] LEFT CURLY BRACKET (OP_OP30) × [14.0] LATIN SMALL LETTER S (AL) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 007B × 0063 × 006F × 0064 × 007B × 0065 × 007D × 2026 × 007D ÷ 0073 ÷	#  × [0.3] LEFT CURLY BRACKET (OP_OP30) × [14.0] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER D (AL) × [30.01] LEFT CURLY BRACKET (OP_OP30) × [14.0] LATIN SMALL LETTER E (AL) × [13.02] RIGHT CURLY BRACKET (CL) × [22.0] HORIZONTAL ELLIPSIS (IN) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [999.0] LATIN SMALL LETTER S (AL) ÷ [0.3]');
    Test_LB('× 0028 × 0063 × 006F × 006E × 002D × 0029 × 006C × 0061 × 006E × 0067 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [14.0] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER N (AL) × [21.02] HYPHEN-MINUS (HY) × [13.02] RIGHT PARENTHESIS (CP_CP30) × [30.02] LATIN SMALL LETTER L (AL) × [28.0] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER N (AL) × [28.0] LATIN SMALL LETTER G (AL) ÷ [0.3]');
    Test_LB('× 0028 × 0063 × 006F × 006E × 00AD × 0029 × 006C × 0061 × 006E × 0067 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [14.0] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER N (AL) × [21.01] SOFT HYPHEN (BA) × [13.02] RIGHT PARENTHESIS (CP_CP30) × [30.02] LATIN SMALL LETTER L (AL) × [28.0] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER N (AL) × [28.0] LATIN SMALL LETTER G (AL) ÷ [0.3]');
    Test_LB('× 0028 × 0063 × 006F × 006E × 2011 × 0029 × 006C × 0061 × 006E × 0067 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [14.0] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER N (AL) × [12.1] NON-BREAKING HYPHEN (GL) × [12.0] RIGHT PARENTHESIS (CP_CP30) × [30.02] LATIN SMALL LETTER L (AL) × [28.0] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER N (AL) × [28.0] LATIN SMALL LETTER G (AL) ÷ [0.3]');
    Test_LB('× 0028 × 0063 × 006F × 006E × 0029 × 002D ÷ 006C × 0061 × 006E × 0067 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [14.0] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER N (AL) × [13.02] RIGHT PARENTHESIS (CP_CP30) × [21.02] HYPHEN-MINUS (HY) ÷ [999.0] LATIN SMALL LETTER L (AL) × [28.0] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER N (AL) × [28.0] LATIN SMALL LETTER G (AL) ÷ [0.3]');
    Test_LB('× 0028 × 0063 × 006F × 006E × 0029 × 00AD ÷ 006C × 0061 × 006E × 0067 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [14.0] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER N (AL) × [13.02] RIGHT PARENTHESIS (CP_CP30) × [21.01] SOFT HYPHEN (BA) ÷ [999.0] LATIN SMALL LETTER L (AL) × [28.0] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER N (AL) × [28.0] LATIN SMALL LETTER G (AL) ÷ [0.3]');
    Test_LB('× 0028 × 0063 × 006F × 006E × 0029 × 2011 × 006C × 0061 × 006E × 0067 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [14.0] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER N (AL) × [13.02] RIGHT PARENTHESIS (CP_CP30) × [12.1] NON-BREAKING HYPHEN (GL) × [12.0] LATIN SMALL LETTER L (AL) × [28.0] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER N (AL) × [28.0] LATIN SMALL LETTER G (AL) ÷ [0.3]');
    Test_LB('× 007B × 0063 × 006F × 006E × 002D × 007D ÷ 006C × 0061 × 006E × 0067 ÷	#  × [0.3] LEFT CURLY BRACKET (OP_OP30) × [14.0] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER N (AL) × [21.02] HYPHEN-MINUS (HY) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [999.0] LATIN SMALL LETTER L (AL) × [28.0] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER N (AL) × [28.0] LATIN SMALL LETTER G (AL) ÷ [0.3]');
    Test_LB('× 007B × 0063 × 006F × 006E × 00AD × 007D ÷ 006C × 0061 × 006E × 0067 ÷	#  × [0.3] LEFT CURLY BRACKET (OP_OP30) × [14.0] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER N (AL) × [21.01] SOFT HYPHEN (BA) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [999.0] LATIN SMALL LETTER L (AL) × [28.0] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER N (AL) × [28.0] LATIN SMALL LETTER G (AL) ÷ [0.3]');
    Test_LB('× 007B × 0063 × 006F × 006E × 2011 × 007D ÷ 006C × 0061 × 006E × 0067 ÷	#  × [0.3] LEFT CURLY BRACKET (OP_OP30) × [14.0] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER N (AL) × [12.1] NON-BREAKING HYPHEN (GL) × [12.0] RIGHT CURLY BRACKET (CL) ÷ [999.0] LATIN SMALL LETTER L (AL) × [28.0] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER N (AL) × [28.0] LATIN SMALL LETTER G (AL) ÷ [0.3]');
    Test_LB('× 007B × 0063 × 006F × 006E × 007D × 002D ÷ 006C × 0061 × 006E × 0067 ÷	#  × [0.3] LEFT CURLY BRACKET (OP_OP30) × [14.0] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER N (AL) × [13.02] RIGHT CURLY BRACKET (CL) × [21.02] HYPHEN-MINUS (HY) ÷ [999.0] LATIN SMALL LETTER L (AL) × [28.0] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER N (AL) × [28.0] LATIN SMALL LETTER G (AL) ÷ [0.3]');
    Test_LB('× 007B × 0063 × 006F × 006E × 007D × 00AD ÷ 006C × 0061 × 006E × 0067 ÷	#  × [0.3] LEFT CURLY BRACKET (OP_OP30) × [14.0] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER N (AL) × [13.02] RIGHT CURLY BRACKET (CL) × [21.01] SOFT HYPHEN (BA) ÷ [999.0] LATIN SMALL LETTER L (AL) × [28.0] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER N (AL) × [28.0] LATIN SMALL LETTER G (AL) ÷ [0.3]');
    Test_LB('× 007B × 0063 × 006F × 006E × 007D × 2011 × 006C × 0061 × 006E × 0067 ÷	#  × [0.3] LEFT CURLY BRACKET (OP_OP30) × [14.0] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER N (AL) × [13.02] RIGHT CURLY BRACKET (CL) × [12.1] NON-BREAKING HYPHEN (GL) × [12.0] LATIN SMALL LETTER L (AL) × [28.0] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER N (AL) × [28.0] LATIN SMALL LETTER G (AL) ÷ [0.3]');
    Test_LB('× 0063 × 0072 × 0065 × 0301 × 0028 × 0065 × 0301 × 0029 ÷ 0028 × 0065 × 0029 ÷	#  × [0.3] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER R (AL) × [28.0] LATIN SMALL LETTER E (AL) × [9.0] COMBINING ACUTE ACCENT (CM1_CM) × [30.01] LEFT PARENTHESIS (OP_OP30) × [14.0] LATIN SMALL LETTER E (AL) × [9.0] COMBINING ACUTE ACCENT (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP_CP30) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) × [14.0] LATIN SMALL LETTER E (AL) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0063 × 0072 × 0065 × 0301 × 005B × 0065 × 0072 × 007C ÷ 0065 × 0301 × 0028 × 0065 × 0029 ÷ 0028 × 0073 × 0029 × 005D ÷	#  × [0.3] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER R (AL) × [28.0] LATIN SMALL LETTER E (AL) × [9.0] COMBINING ACUTE ACCENT (CM1_CM) × [30.01] LEFT SQUARE BRACKET (OP_OP30) × [14.0] LATIN SMALL LETTER E (AL) × [28.0] LATIN SMALL LETTER R (AL) × [21.01] VERTICAL LINE (BA) ÷ [999.0] LATIN SMALL LETTER E (AL) × [9.0] COMBINING ACUTE ACCENT (CM1_CM) × [30.01] LEFT PARENTHESIS (OP_OP30) × [14.0] LATIN SMALL LETTER E (AL) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) × [14.0] LATIN SMALL LETTER S (AL) × [13.02] RIGHT PARENTHESIS (CP_CP30) × [13.02] RIGHT SQUARE BRACKET (CP_CP30) ÷ [0.3]');
    Test_LB('× 0063 × 0072 × 0065 × 0301 × 007B × 0065 × 0072 × 007C ÷ 0065 × 0301 × 0028 × 0065 × 0029 ÷ 0028 × 0073 × 0029 × 007D ÷	#  × [0.3] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER R (AL) × [28.0] LATIN SMALL LETTER E (AL) × [9.0] COMBINING ACUTE ACCENT (CM1_CM) × [30.01] LEFT CURLY BRACKET (OP_OP30) × [14.0] LATIN SMALL LETTER E (AL) × [28.0] LATIN SMALL LETTER R (AL) × [21.01] VERTICAL LINE (BA) ÷ [999.0] LATIN SMALL LETTER E (AL) × [9.0] COMBINING ACUTE ACCENT (CM1_CM) × [30.01] LEFT PARENTHESIS (OP_OP30) × [14.0] LATIN SMALL LETTER E (AL) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) × [14.0] LATIN SMALL LETTER S (AL) × [13.02] RIGHT PARENTHESIS (CP_CP30) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0061 × 006D × 0062 × 0069 × 0067 × 0075 × 0028 × 0308 × 0029 ÷ 0028 × 0065 × 0308 × 0029 ÷	#  × [0.3] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER M (AL) × [28.0] LATIN SMALL LETTER B (AL) × [28.0] LATIN SMALL LETTER I (AL) × [28.0] LATIN SMALL LETTER G (AL) × [28.0] LATIN SMALL LETTER U (AL) × [30.01] LEFT PARENTHESIS (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP_CP30) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) × [14.0] LATIN SMALL LETTER E (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0061 × 006D × 0062 × 0069 × 0067 × 0075 × 0028 × 00AB × 0308 × 00BB × 0029 ÷ 0028 × 0065 × 0308 × 0029 ÷	#  × [0.3] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER M (AL) × [28.0] LATIN SMALL LETTER B (AL) × [28.0] LATIN SMALL LETTER I (AL) × [28.0] LATIN SMALL LETTER G (AL) × [28.0] LATIN SMALL LETTER U (AL) × [30.01] LEFT PARENTHESIS (OP_OP30) × [14.0] LEFT-POINTING DOUBLE ANGLE QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] RIGHT-POINTING DOUBLE ANGLE QUOTATION MARK (QU) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) × [14.0] LATIN SMALL LETTER E (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0061 × 006D × 0062 × 0069 × 0067 × 0075 × 0028 × 00AB × 0020 ÷ 0308 × 0020 ÷ 00BB × 0029 ÷ 0028 × 0065 × 0308 × 0029 ÷	#  × [0.3] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER M (AL) × [28.0] LATIN SMALL LETTER B (AL) × [28.0] LATIN SMALL LETTER I (AL) × [28.0] LATIN SMALL LETTER G (AL) × [28.0] LATIN SMALL LETTER U (AL) × [30.01] LEFT PARENTHESIS (OP_OP30) × [14.0] LEFT-POINTING DOUBLE ANGLE QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] RIGHT-POINTING DOUBLE ANGLE QUOTATION MARK (QU) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) × [14.0] LATIN SMALL LETTER E (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0061 × 006D × 0062 × 0069 × 0067 × 0075 × 00AB × 0020 × 0028 × 0020 × 0308 × 0020 × 0029 × 0020 ÷ 00BB × 0028 × 0065 × 0308 × 0029 ÷	#  × [0.3] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER M (AL) × [28.0] LATIN SMALL LETTER B (AL) × [28.0] LATIN SMALL LETTER I (AL) × [28.0] LATIN SMALL LETTER G (AL) × [28.0] LATIN SMALL LETTER U (AL) × [19.01] LEFT-POINTING DOUBLE ANGLE QUOTATION MARK (QU) × [7.01] SPACE (SP) × [15.0] LEFT PARENTHESIS (OP_OP30) × [7.01] SPACE (SP) × [14.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) × [7.01] SPACE (SP) ÷ [18.0] RIGHT-POINTING DOUBLE ANGLE QUOTATION MARK (QU) × [15.0] LEFT PARENTHESIS (OP_OP30) × [14.0] LATIN SMALL LETTER E (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0061 × 006D × 0062 × 0069 × 0067 × 0075 × 00AB × 202F × 0028 × 0020 × 0308 × 0020 × 0029 × 202F × 00BB × 0028 × 0065 × 0308 × 0029 ÷	#  × [0.3] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER M (AL) × [28.0] LATIN SMALL LETTER B (AL) × [28.0] LATIN SMALL LETTER I (AL) × [28.0] LATIN SMALL LETTER G (AL) × [28.0] LATIN SMALL LETTER U (AL) × [19.01] LEFT-POINTING DOUBLE ANGLE QUOTATION MARK (QU) × [12.1] NARROW NO-BREAK SPACE (GL) × [12.0] LEFT PARENTHESIS (OP_OP30) × [7.01] SPACE (SP) × [14.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP_CP30) × [12.1] NARROW NO-BREAK SPACE (GL) × [12.0] RIGHT-POINTING DOUBLE ANGLE QUOTATION MARK (QU) × [15.0] LEFT PARENTHESIS (OP_OP30) × [14.0] LATIN SMALL LETTER E (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0061 × 006D × 0062 × 0069 × 0067 × 0075 × 007B × 0308 × 007D ÷ 0028 × 0065 × 0308 × 0029 ÷	#  × [0.3] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER M (AL) × [28.0] LATIN SMALL LETTER B (AL) × [28.0] LATIN SMALL LETTER I (AL) × [28.0] LATIN SMALL LETTER G (AL) × [28.0] LATIN SMALL LETTER U (AL) × [30.01] LEFT CURLY BRACKET (OP_OP30) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) × [14.0] LATIN SMALL LETTER E (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0061 × 006D × 0062 × 0069 × 0067 × 0075 × 007B × 00AB × 0308 × 00BB × 007D ÷ 0028 × 0065 × 0308 × 0029 ÷	#  × [0.3] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER M (AL) × [28.0] LATIN SMALL LETTER B (AL) × [28.0] LATIN SMALL LETTER I (AL) × [28.0] LATIN SMALL LETTER G (AL) × [28.0] LATIN SMALL LETTER U (AL) × [30.01] LEFT CURLY BRACKET (OP_OP30) × [14.0] LEFT-POINTING DOUBLE ANGLE QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] RIGHT-POINTING DOUBLE ANGLE QUOTATION MARK (QU) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) × [14.0] LATIN SMALL LETTER E (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0061 × 006D × 0062 × 0069 × 0067 × 0075 × 007B × 00AB × 0020 ÷ 0308 × 0020 ÷ 00BB × 007D ÷ 0028 × 0065 × 0308 × 0029 ÷	#  × [0.3] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER M (AL) × [28.0] LATIN SMALL LETTER B (AL) × [28.0] LATIN SMALL LETTER I (AL) × [28.0] LATIN SMALL LETTER G (AL) × [28.0] LATIN SMALL LETTER U (AL) × [30.01] LEFT CURLY BRACKET (OP_OP30) × [14.0] LEFT-POINTING DOUBLE ANGLE QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] RIGHT-POINTING DOUBLE ANGLE QUOTATION MARK (QU) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) × [14.0] LATIN SMALL LETTER E (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0061 × 006D × 0062 × 0069 × 0067 × 0075 × 00AB × 0020 × 007B × 0020 × 0308 × 0020 × 007D × 0020 ÷ 00BB × 0028 × 0065 × 0308 × 0029 ÷	#  × [0.3] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER M (AL) × [28.0] LATIN SMALL LETTER B (AL) × [28.0] LATIN SMALL LETTER I (AL) × [28.0] LATIN SMALL LETTER G (AL) × [28.0] LATIN SMALL LETTER U (AL) × [19.01] LEFT-POINTING DOUBLE ANGLE QUOTATION MARK (QU) × [7.01] SPACE (SP) × [15.0] LEFT CURLY BRACKET (OP_OP30) × [7.01] SPACE (SP) × [14.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) ÷ [18.0] RIGHT-POINTING DOUBLE ANGLE QUOTATION MARK (QU) × [15.0] LEFT PARENTHESIS (OP_OP30) × [14.0] LATIN SMALL LETTER E (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0061 × 006D × 0062 × 0069 × 0067 × 0075 × 00AB × 202F × 007B × 0020 × 0308 × 0020 × 007D × 202F × 00BB × 0028 × 0065 × 0308 × 0029 ÷	#  × [0.3] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER M (AL) × [28.0] LATIN SMALL LETTER B (AL) × [28.0] LATIN SMALL LETTER I (AL) × [28.0] LATIN SMALL LETTER G (AL) × [28.0] LATIN SMALL LETTER U (AL) × [19.01] LEFT-POINTING DOUBLE ANGLE QUOTATION MARK (QU) × [12.1] NARROW NO-BREAK SPACE (GL) × [12.0] LEFT CURLY BRACKET (OP_OP30) × [7.01] SPACE (SP) × [14.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) × [12.1] NARROW NO-BREAK SPACE (GL) × [12.0] RIGHT-POINTING DOUBLE ANGLE QUOTATION MARK (QU) × [15.0] LEFT PARENTHESIS (OP_OP30) × [14.0] LATIN SMALL LETTER E (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 0028 × 0063 × 007A × 0065 × 0072 × 0077 × 006F × 006E × 006F × 00AD ÷ 2011 × 0029 × 006E × 0069 × 0065 × 0062 × 0069 × 0065 × 0073 × 006B × 0061 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [14.0] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER Z (AL) × [28.0] LATIN SMALL LETTER E (AL) × [28.0] LATIN SMALL LETTER R (AL) × [28.0] LATIN SMALL LETTER W (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER N (AL) × [28.0] LATIN SMALL LETTER O (AL) × [21.01] SOFT HYPHEN (BA) ÷ [999.0] NON-BREAKING HYPHEN (GL) × [12.0] RIGHT PARENTHESIS (CP_CP30) × [30.02] LATIN SMALL LETTER N (AL) × [28.0] LATIN SMALL LETTER I (AL) × [28.0] LATIN SMALL LETTER E (AL) × [28.0] LATIN SMALL LETTER B (AL) × [28.0] LATIN SMALL LETTER I (AL) × [28.0] LATIN SMALL LETTER E (AL) × [28.0] LATIN SMALL LETTER S (AL) × [28.0] LATIN SMALL LETTER K (AL) × [28.0] LATIN SMALL LETTER A (AL) ÷ [0.3]');
    Test_LB('× 0028 × 0063 × 007A × 0065 × 0072 × 0077 × 006F × 006E × 006F × 00AD × 0029 × 2011 × 006E × 0069 × 0065 × 0062 × 0069 × 0065 × 0073 × 006B × 0061 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [14.0] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER Z (AL) × [28.0] LATIN SMALL LETTER E (AL) × [28.0] LATIN SMALL LETTER R (AL) × [28.0] LATIN SMALL LETTER W (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER N (AL) × [28.0] LATIN SMALL LETTER O (AL) × [21.01] SOFT HYPHEN (BA) × [13.02] RIGHT PARENTHESIS (CP_CP30) × [12.1] NON-BREAKING HYPHEN (GL) × [12.0] LATIN SMALL LETTER N (AL) × [28.0] LATIN SMALL LETTER I (AL) × [28.0] LATIN SMALL LETTER E (AL) × [28.0] LATIN SMALL LETTER B (AL) × [28.0] LATIN SMALL LETTER I (AL) × [28.0] LATIN SMALL LETTER E (AL) × [28.0] LATIN SMALL LETTER S (AL) × [28.0] LATIN SMALL LETTER K (AL) × [28.0] LATIN SMALL LETTER A (AL) ÷ [0.3]');
    Test_LB('× 0028 × 0063 × 007A × 0065 × 0072 × 0077 × 006F × 006E × 006F × 0029 × 00AD ÷ 2011 × 006E × 0069 × 0065 × 0062 × 0069 × 0065 × 0073 × 006B × 0061 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [14.0] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER Z (AL) × [28.0] LATIN SMALL LETTER E (AL) × [28.0] LATIN SMALL LETTER R (AL) × [28.0] LATIN SMALL LETTER W (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER N (AL) × [28.0] LATIN SMALL LETTER O (AL) × [13.02] RIGHT PARENTHESIS (CP_CP30) × [21.01] SOFT HYPHEN (BA) ÷ [999.0] NON-BREAKING HYPHEN (GL) × [12.0] LATIN SMALL LETTER N (AL) × [28.0] LATIN SMALL LETTER I (AL) × [28.0] LATIN SMALL LETTER E (AL) × [28.0] LATIN SMALL LETTER B (AL) × [28.0] LATIN SMALL LETTER I (AL) × [28.0] LATIN SMALL LETTER E (AL) × [28.0] LATIN SMALL LETTER S (AL) × [28.0] LATIN SMALL LETTER K (AL) × [28.0] LATIN SMALL LETTER A (AL) ÷ [0.3]');
    Test_LB('× 007B × 0063 × 007A × 0065 × 0072 × 0077 × 006F × 006E × 006F × 00AD ÷ 2011 × 007D ÷ 006E × 0069 × 0065 × 0062 × 0069 × 0065 × 0073 × 006B × 0061 ÷	#  × [0.3] LEFT CURLY BRACKET (OP_OP30) × [14.0] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER Z (AL) × [28.0] LATIN SMALL LETTER E (AL) × [28.0] LATIN SMALL LETTER R (AL) × [28.0] LATIN SMALL LETTER W (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER N (AL) × [28.0] LATIN SMALL LETTER O (AL) × [21.01] SOFT HYPHEN (BA) ÷ [999.0] NON-BREAKING HYPHEN (GL) × [12.0] RIGHT CURLY BRACKET (CL) ÷ [999.0] LATIN SMALL LETTER N (AL) × [28.0] LATIN SMALL LETTER I (AL) × [28.0] LATIN SMALL LETTER E (AL) × [28.0] LATIN SMALL LETTER B (AL) × [28.0] LATIN SMALL LETTER I (AL) × [28.0] LATIN SMALL LETTER E (AL) × [28.0] LATIN SMALL LETTER S (AL) × [28.0] LATIN SMALL LETTER K (AL) × [28.0] LATIN SMALL LETTER A (AL) ÷ [0.3]');
    Test_LB('× 007B × 0063 × 007A × 0065 × 0072 × 0077 × 006F × 006E × 006F × 00AD × 007D × 2011 × 006E × 0069 × 0065 × 0062 × 0069 × 0065 × 0073 × 006B × 0061 ÷	#  × [0.3] LEFT CURLY BRACKET (OP_OP30) × [14.0] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER Z (AL) × [28.0] LATIN SMALL LETTER E (AL) × [28.0] LATIN SMALL LETTER R (AL) × [28.0] LATIN SMALL LETTER W (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER N (AL) × [28.0] LATIN SMALL LETTER O (AL) × [21.01] SOFT HYPHEN (BA) × [13.02] RIGHT CURLY BRACKET (CL) × [12.1] NON-BREAKING HYPHEN (GL) × [12.0] LATIN SMALL LETTER N (AL) × [28.0] LATIN SMALL LETTER I (AL) × [28.0] LATIN SMALL LETTER E (AL) × [28.0] LATIN SMALL LETTER B (AL) × [28.0] LATIN SMALL LETTER I (AL) × [28.0] LATIN SMALL LETTER E (AL) × [28.0] LATIN SMALL LETTER S (AL) × [28.0] LATIN SMALL LETTER K (AL) × [28.0] LATIN SMALL LETTER A (AL) ÷ [0.3]');
    Test_LB('× 007B × 0063 × 007A × 0065 × 0072 × 0077 × 006F × 006E × 006F × 007D × 00AD ÷ 2011 × 006E × 0069 × 0065 × 0062 × 0069 × 0065 × 0073 × 006B × 0061 ÷	#  × [0.3] LEFT CURLY BRACKET (OP_OP30) × [14.0] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER Z (AL) × [28.0] LATIN SMALL LETTER E (AL) × [28.0] LATIN SMALL LETTER R (AL) × [28.0] LATIN SMALL LETTER W (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER N (AL) × [28.0] LATIN SMALL LETTER O (AL) × [13.02] RIGHT CURLY BRACKET (CL) × [21.01] SOFT HYPHEN (BA) ÷ [999.0] NON-BREAKING HYPHEN (GL) × [12.0] LATIN SMALL LETTER N (AL) × [28.0] LATIN SMALL LETTER I (AL) × [28.0] LATIN SMALL LETTER E (AL) × [28.0] LATIN SMALL LETTER B (AL) × [28.0] LATIN SMALL LETTER I (AL) × [28.0] LATIN SMALL LETTER E (AL) × [28.0] LATIN SMALL LETTER S (AL) × [28.0] LATIN SMALL LETTER K (AL) × [28.0] LATIN SMALL LETTER A (AL) ÷ [0.3]');
    Test_LB('× 006F × 0070 × 0065 × 0072 × 0061 × 0074 × 006F × 0072 × 005B × 005D ÷ 0028 × 0030 × 0029 × 003B ÷	#  × [0.3] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER P (AL) × [28.0] LATIN SMALL LETTER E (AL) × [28.0] LATIN SMALL LETTER R (AL) × [28.0] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER T (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER R (AL) × [30.01] LEFT SQUARE BRACKET (OP_OP30) × [13.02] RIGHT SQUARE BRACKET (CP_CP30) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) × [14.0] DIGIT ZERO (NU) × [25.04] RIGHT PARENTHESIS (CP_CP30) × [13.02] SEMICOLON (IS) ÷ [0.3]');
    Test_LB('× 006F × 0070 × 0065 × 0072 × 0061 × 0074 × 006F × 0072 × 005B × 005D ÷ 0028 × 0029 ÷ 007B × 007D ÷	#  × [0.3] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER P (AL) × [28.0] LATIN SMALL LETTER E (AL) × [28.0] LATIN SMALL LETTER R (AL) × [28.0] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER T (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER R (AL) × [30.01] LEFT SQUARE BRACKET (OP_OP30) × [13.02] RIGHT SQUARE BRACKET (CP_CP30) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [999.0] LEFT CURLY BRACKET (OP_OP30) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 672C ÷ 0028 × 3092 × 0029 ÷ 8AAD ÷ 3080 ÷	#  × [0.3] CJK UNIFIED IDEOGRAPH-672C (ID) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) × [14.0] HIRAGANA LETTER WO (ID) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [999.0] CJK UNIFIED IDEOGRAPH-8AAD (ID) ÷ [999.0] HIRAGANA LETTER MU (ID) ÷ [0.3]');
    Test_LB('× 672C ÷ 0028 × 300C × 3092 × 300D × 0029 ÷ 8AAD ÷ 3080 ÷	#  × [0.3] CJK UNIFIED IDEOGRAPH-672C (ID) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) × [14.0] LEFT CORNER BRACKET (OP) × [14.0] HIRAGANA LETTER WO (ID) × [13.02] RIGHT CORNER BRACKET (CL) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [999.0] CJK UNIFIED IDEOGRAPH-8AAD (ID) ÷ [999.0] HIRAGANA LETTER MU (ID) ÷ [0.3]');
    Test_LB('× 672C ÷ 300C × 0028 × 3092 × 0029 × 300D ÷ 8AAD ÷ 3080 ÷	#  × [0.3] CJK UNIFIED IDEOGRAPH-672C (ID) ÷ [999.0] LEFT CORNER BRACKET (OP) × [14.0] LEFT PARENTHESIS (OP_OP30) × [14.0] HIRAGANA LETTER WO (ID) × [13.02] RIGHT PARENTHESIS (CP_CP30) × [13.02] RIGHT CORNER BRACKET (CL) ÷ [999.0] CJK UNIFIED IDEOGRAPH-8AAD (ID) ÷ [999.0] HIRAGANA LETTER MU (ID) ÷ [0.3]');
    Test_LB('× 672C ÷ 007B × 3092 × 007D ÷ 8AAD ÷ 3080 ÷	#  × [0.3] CJK UNIFIED IDEOGRAPH-672C (ID) ÷ [999.0] LEFT CURLY BRACKET (OP_OP30) × [14.0] HIRAGANA LETTER WO (ID) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [999.0] CJK UNIFIED IDEOGRAPH-8AAD (ID) ÷ [999.0] HIRAGANA LETTER MU (ID) ÷ [0.3]');
    Test_LB('× 672C ÷ 007B × 300C × 3092 × 300D × 007D ÷ 8AAD ÷ 3080 ÷	#  × [0.3] CJK UNIFIED IDEOGRAPH-672C (ID) ÷ [999.0] LEFT CURLY BRACKET (OP_OP30) × [14.0] LEFT CORNER BRACKET (OP) × [14.0] HIRAGANA LETTER WO (ID) × [13.02] RIGHT CORNER BRACKET (CL) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [999.0] CJK UNIFIED IDEOGRAPH-8AAD (ID) ÷ [999.0] HIRAGANA LETTER MU (ID) ÷ [0.3]');
    Test_LB('× 672C ÷ 005B × 0028 × 3092 × 0029 × 005D ÷ 8AAD ÷ 3080 ÷	#  × [0.3] CJK UNIFIED IDEOGRAPH-672C (ID) ÷ [999.0] LEFT SQUARE BRACKET (OP_OP30) × [14.0] LEFT PARENTHESIS (OP_OP30) × [14.0] HIRAGANA LETTER WO (ID) × [13.02] RIGHT PARENTHESIS (CP_CP30) × [13.02] RIGHT SQUARE BRACKET (CP_CP30) ÷ [999.0] CJK UNIFIED IDEOGRAPH-8AAD (ID) ÷ [999.0] HIRAGANA LETTER MU (ID) ÷ [0.3]');
    Test_LB('× 0028 × 30CB × 30E5 × 30FC × 30FB × 0029 ÷ 30E8 × 30FC ÷ 30AF ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [14.0] KATAKANA LETTER NI (ID) × [21.03] KATAKANA LETTER SMALL YU (CJ_NS) × [21.03] KATAKANA-HIRAGANA PROLONGED SOUND MARK (CJ_NS) × [21.03] KATAKANA MIDDLE DOT (NS) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [999.0] KATAKANA LETTER YO (ID) × [21.03] KATAKANA-HIRAGANA PROLONGED SOUND MARK (CJ_NS) ÷ [999.0] KATAKANA LETTER KU (ID) ÷ [0.3]');
    Test_LB('× 0028 × 30CB × 30E5 × 30FC × 0029 × 30FB ÷ 30E8 × 30FC ÷ 30AF ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [14.0] KATAKANA LETTER NI (ID) × [21.03] KATAKANA LETTER SMALL YU (CJ_NS) × [21.03] KATAKANA-HIRAGANA PROLONGED SOUND MARK (CJ_NS) × [13.02] RIGHT PARENTHESIS (CP_CP30) × [16.0] KATAKANA MIDDLE DOT (NS) ÷ [999.0] KATAKANA LETTER YO (ID) × [21.03] KATAKANA-HIRAGANA PROLONGED SOUND MARK (CJ_NS) ÷ [999.0] KATAKANA LETTER KU (ID) ÷ [0.3]');
    Test_LB('× 007B × 30CB × 30E5 × 30FC × 30FB × 007D ÷ 30E8 × 30FC ÷ 30AF ÷	#  × [0.3] LEFT CURLY BRACKET (OP_OP30) × [14.0] KATAKANA LETTER NI (ID) × [21.03] KATAKANA LETTER SMALL YU (CJ_NS) × [21.03] KATAKANA-HIRAGANA PROLONGED SOUND MARK (CJ_NS) × [21.03] KATAKANA MIDDLE DOT (NS) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [999.0] KATAKANA LETTER YO (ID) × [21.03] KATAKANA-HIRAGANA PROLONGED SOUND MARK (CJ_NS) ÷ [999.0] KATAKANA LETTER KU (ID) ÷ [0.3]');
    Test_LB('× 007B × 30CB × 30E5 × 30FC × 007D × 30FB ÷ 30E8 × 30FC ÷ 30AF ÷	#  × [0.3] LEFT CURLY BRACKET (OP_OP30) × [14.0] KATAKANA LETTER NI (ID) × [21.03] KATAKANA LETTER SMALL YU (CJ_NS) × [21.03] KATAKANA-HIRAGANA PROLONGED SOUND MARK (CJ_NS) × [13.02] RIGHT CURLY BRACKET (CL) × [16.0] KATAKANA MIDDLE DOT (NS) ÷ [999.0] KATAKANA LETTER YO (ID) × [21.03] KATAKANA-HIRAGANA PROLONGED SOUND MARK (CJ_NS) ÷ [999.0] KATAKANA LETTER KU (ID) ÷ [0.3]');
    Test_LB('× 0028 × 1850 × 1846 × 1851 × 1846 ÷ 1806 × 0029 × 182A × 1822 × 1834 × 1822 × 182D × 180C ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [14.0] MONGOLIAN LETTER TODO TA (AL) × [28.0] MONGOLIAN LETTER TODO O (AL) × [28.0] MONGOLIAN LETTER TODO DA (AL) × [28.0] MONGOLIAN LETTER TODO O (AL) ÷ [999.0] MONGOLIAN TODO SOFT HYPHEN (BB) × [13.02] RIGHT PARENTHESIS (CP_CP30) × [30.02] MONGOLIAN LETTER BA (AL) × [28.0] MONGOLIAN LETTER I (AL) × [28.0] MONGOLIAN LETTER CHA (AL) × [28.0] MONGOLIAN LETTER I (AL) × [28.0] MONGOLIAN LETTER GA (AL) × [9.0] MONGOLIAN FREE VARIATION SELECTOR TWO (CM1_CM) ÷ [0.3]');
    Test_LB('× 0028 × 1850 × 1846 × 1851 × 1846 × 0029 ÷ 1806 × 182A × 1822 × 1834 × 1822 × 182D × 180C ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [14.0] MONGOLIAN LETTER TODO TA (AL) × [28.0] MONGOLIAN LETTER TODO O (AL) × [28.0] MONGOLIAN LETTER TODO DA (AL) × [28.0] MONGOLIAN LETTER TODO O (AL) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [999.0] MONGOLIAN TODO SOFT HYPHEN (BB) × [21.04] MONGOLIAN LETTER BA (AL) × [28.0] MONGOLIAN LETTER I (AL) × [28.0] MONGOLIAN LETTER CHA (AL) × [28.0] MONGOLIAN LETTER I (AL) × [28.0] MONGOLIAN LETTER GA (AL) × [9.0] MONGOLIAN FREE VARIATION SELECTOR TWO (CM1_CM) ÷ [0.3]');
    Test_LB('× 007B × 1850 × 1846 × 1851 × 1846 ÷ 1806 × 007D ÷ 182A × 1822 × 1834 × 1822 × 182D × 180C ÷	#  × [0.3] LEFT CURLY BRACKET (OP_OP30) × [14.0] MONGOLIAN LETTER TODO TA (AL) × [28.0] MONGOLIAN LETTER TODO O (AL) × [28.0] MONGOLIAN LETTER TODO DA (AL) × [28.0] MONGOLIAN LETTER TODO O (AL) ÷ [999.0] MONGOLIAN TODO SOFT HYPHEN (BB) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [999.0] MONGOLIAN LETTER BA (AL) × [28.0] MONGOLIAN LETTER I (AL) × [28.0] MONGOLIAN LETTER CHA (AL) × [28.0] MONGOLIAN LETTER I (AL) × [28.0] MONGOLIAN LETTER GA (AL) × [9.0] MONGOLIAN FREE VARIATION SELECTOR TWO (CM1_CM) ÷ [0.3]');
    Test_LB('× 007B × 1850 × 1846 × 1851 × 1846 × 007D ÷ 1806 × 182A × 1822 × 1834 × 1822 × 182D × 180C ÷	#  × [0.3] LEFT CURLY BRACKET (OP_OP30) × [14.0] MONGOLIAN LETTER TODO TA (AL) × [28.0] MONGOLIAN LETTER TODO O (AL) × [28.0] MONGOLIAN LETTER TODO DA (AL) × [28.0] MONGOLIAN LETTER TODO O (AL) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [999.0] MONGOLIAN TODO SOFT HYPHEN (BB) × [21.04] MONGOLIAN LETTER BA (AL) × [28.0] MONGOLIAN LETTER I (AL) × [28.0] MONGOLIAN LETTER CHA (AL) × [28.0] MONGOLIAN LETTER I (AL) × [28.0] MONGOLIAN LETTER GA (AL) × [9.0] MONGOLIAN FREE VARIATION SELECTOR TWO (CM1_CM) ÷ [0.3]');
    Test_LB('× 0028 × 0068 × 0074 × 0074 × 0070 × 003A × 002F × 002F × 0029 × 0078 × 006E × 002D × 002D ÷ 0061 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [14.0] LATIN SMALL LETTER H (AL) × [28.0] LATIN SMALL LETTER T (AL) × [28.0] LATIN SMALL LETTER T (AL) × [28.0] LATIN SMALL LETTER P (AL) × [13.02] COLON (IS) × [13.02] SOLIDUS (SY) × [13.02] SOLIDUS (SY) × [13.02] RIGHT PARENTHESIS (CP_CP30) × [30.02] LATIN SMALL LETTER X (AL) × [28.0] LATIN SMALL LETTER N (AL) × [21.02] HYPHEN-MINUS (HY) × [21.02] HYPHEN-MINUS (HY) ÷ [999.0] LATIN SMALL LETTER A (AL) ÷ [0.3]');
    Test_LB('× 007B × 0068 × 0074 × 0074 × 0070 × 003A × 002F × 002F × 007D ÷ 0078 × 006E × 002D × 002D ÷ 0061 ÷	#  × [0.3] LEFT CURLY BRACKET (OP_OP30) × [14.0] LATIN SMALL LETTER H (AL) × [28.0] LATIN SMALL LETTER T (AL) × [28.0] LATIN SMALL LETTER T (AL) × [28.0] LATIN SMALL LETTER P (AL) × [13.02] COLON (IS) × [13.02] SOLIDUS (SY) × [13.02] SOLIDUS (SY) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [999.0] LATIN SMALL LETTER X (AL) × [28.0] LATIN SMALL LETTER N (AL) × [21.02] HYPHEN-MINUS (HY) × [21.02] HYPHEN-MINUS (HY) ÷ [999.0] LATIN SMALL LETTER A (AL) ÷ [0.3]');
    Test_LB('× 0028 × 0030 × 002C × 0031 × 0029 × 002B × 0028 × 0032 × 002C × 0033 × 0029 × 2295 × 0028 × 2212 × 0034 × 002C × 0035 × 0029 × 2296 × 0028 × 0036 × 002C × 0037 × 0029 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [14.0] DIGIT ZERO (NU) × [25.03] COMMA (IS) × [25.04] DIGIT ONE (NU) × [25.04] RIGHT PARENTHESIS (CP_CP30) × [25.05] PLUS SIGN (PR) × [25.01] LEFT PARENTHESIS (OP_OP30) × [14.0] DIGIT TWO (NU) × [25.03] COMMA (IS) × [25.04] DIGIT THREE (NU) × [25.04] RIGHT PARENTHESIS (CP_CP30) × [30.02] CIRCLED PLUS (AI_AL) × [30.01] LEFT PARENTHESIS (OP_OP30) × [14.0] MINUS SIGN (PR) × [25.01] DIGIT FOUR (NU) × [25.03] COMMA (IS) × [25.04] DIGIT FIVE (NU) × [25.04] RIGHT PARENTHESIS (CP_CP30) × [30.02] CIRCLED MINUS (AL) × [30.01] LEFT PARENTHESIS (OP_OP30) × [14.0] DIGIT SIX (NU) × [25.03] COMMA (IS) × [25.04] DIGIT SEVEN (NU) × [25.04] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 007B × 0030 × 002C × 0031 × 007D × 002B × 007B × 0032 × 002C × 0033 × 007D ÷ 2295 × 007B × 2212 × 0034 × 002C × 0035 × 007D ÷ 2296 × 007B × 0036 × 002C × 0037 × 007D ÷	#  × [0.3] LEFT CURLY BRACKET (OP_OP30) × [14.0] DIGIT ZERO (NU) × [25.03] COMMA (IS) × [25.04] DIGIT ONE (NU) × [25.04] RIGHT CURLY BRACKET (CL) × [25.05] PLUS SIGN (PR) × [25.01] LEFT CURLY BRACKET (OP_OP30) × [14.0] DIGIT TWO (NU) × [25.03] COMMA (IS) × [25.04] DIGIT THREE (NU) × [25.04] RIGHT CURLY BRACKET (CL) ÷ [999.0] CIRCLED PLUS (AI_AL) × [30.01] LEFT CURLY BRACKET (OP_OP30) × [14.0] MINUS SIGN (PR) × [25.01] DIGIT FOUR (NU) × [25.03] COMMA (IS) × [25.04] DIGIT FIVE (NU) × [25.04] RIGHT CURLY BRACKET (CL) ÷ [999.0] CIRCLED MINUS (AL) × [30.01] LEFT CURLY BRACKET (OP_OP30) × [14.0] DIGIT SIX (NU) × [25.03] COMMA (IS) × [25.04] DIGIT SEVEN (NU) × [25.04] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0061 × 0062 ÷	#  × [0.3] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER B (AL) ÷ [0.3]');
    Test_LB('× 0061 × 0062 × 0020 ÷	#  × [0.3] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER B (AL) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0061 × 0062 × 0020 ÷ 0063 ÷	#  × [0.3] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER B (AL) × [7.01] SPACE (SP) ÷ [18.0] LATIN SMALL LETTER C (AL) ÷ [0.3]');
    Test_LB('× 0061 ÷ 307E ÷	#  × [0.3] LATIN SMALL LETTER A (AL) ÷ [999.0] HIRAGANA LETTER MA (ID) ÷ [0.3]');
    Test_LB('× 0939 × 093F × 0928 × 094D × 0926 × 0940 × 0020 ÷	#  × [0.3] DEVANAGARI LETTER HA (AL) × [9.0] DEVANAGARI VOWEL SIGN I (CM1_CM) × [28.0] DEVANAGARI LETTER NA (AL) × [9.0] DEVANAGARI SIGN VIRAMA (CM1_CM) × [28.0] DEVANAGARI LETTER DA (AL) × [9.0] DEVANAGARI VOWEL SIGN II (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 092F × 0938 × 0917 × 0941 × 091A × 093F × 0924 × 0940 × 092F × 0938 × 093E × 0020 ÷	#  × [0.3] DEVANAGARI LETTER YA (AL) × [28.0] DEVANAGARI LETTER SA (AL) × [28.0] DEVANAGARI LETTER GA (AL) × [9.0] DEVANAGARI VOWEL SIGN U (CM1_CM) × [28.0] DEVANAGARI LETTER CA (AL) × [9.0] DEVANAGARI VOWEL SIGN I (CM1_CM) × [28.0] DEVANAGARI LETTER TA (AL) × [9.0] DEVANAGARI VOWEL SIGN II (CM1_CM) × [28.0] DEVANAGARI LETTER YA (AL) × [28.0] DEVANAGARI LETTER SA (AL) × [9.0] DEVANAGARI VOWEL SIGN AA (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 5370 ÷ 672C ÷	#  × [0.3] CJK UNIFIED IDEOGRAPH-5370 (ID) ÷ [999.0] CJK UNIFIED IDEOGRAPH-672C (ID) ÷ [0.3]');
    Test_LB('× 8AAD ÷ 3080 ÷	#  × [0.3] CJK UNIFIED IDEOGRAPH-8AAD (ID) ÷ [999.0] HIRAGANA LETTER MU (ID) ÷ [0.3]');
    Test_LB('× 5165 ÷ 529B ÷ 3057 ÷ 30A8 ÷	#  × [0.3] CJK UNIFIED IDEOGRAPH-5165 (ID) ÷ [999.0] CJK UNIFIED IDEOGRAPH-529B (ID) ÷ [999.0] HIRAGANA LETTER SI (ID) ÷ [999.0] KATAKANA LETTER E (ID) ÷ [0.3]');
    Test_LB('× 4F4D × 3002 ÷ 8A18 ÷	#  × [0.3] CJK UNIFIED IDEOGRAPH-4F4D (ID) × [13.02] IDEOGRAPHIC FULL STOP (CL) ÷ [999.0] CJK UNIFIED IDEOGRAPH-8A18 (ID) ÷ [0.3]');
    Test_LB('× 672C × 3002 ÷	#  × [0.3] CJK UNIFIED IDEOGRAPH-672C (ID) × [13.02] IDEOGRAPHIC FULL STOP (CL) ÷ [0.3]');
    Test_LB('× 967A × 300D ÷ 306E ÷	#  × [0.3] CJK UNIFIED IDEOGRAPH-967A (ID) × [13.02] RIGHT CORNER BRACKET (CL) ÷ [999.0] HIRAGANA LETTER NO (ID) ÷ [0.3]');
    Test_LB('× 3057 × 3087 ÷ 3046 ÷	#  × [0.3] HIRAGANA LETTER SI (ID) × [21.03] HIRAGANA LETTER SMALL YO (CJ_NS) ÷ [999.0] HIRAGANA LETTER U (ID) ÷ [0.3]');
    Test_LB('× 307E ÷ 0061 ÷ 672C ÷	#  × [0.3] HIRAGANA LETTER MA (ID) ÷ [999.0] LATIN SMALL LETTER A (AL) ÷ [999.0] CJK UNIFIED IDEOGRAPH-672C (ID) ÷ [0.3]');
    Test_LB('× C5C6 ÷ C5B4 ÷ C694 × 0020 ÷ 006F × 0072 × 0020 ÷ BABB ÷	#  × [0.3] HANGUL SYLLABLE EOBS (H3) ÷ [999.0] HANGUL SYLLABLE EO (H2) ÷ [999.0] HANGUL SYLLABLE YO (H2) × [7.01] SPACE (SP) ÷ [18.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER R (AL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE MOS (H3) ÷ [0.3]');
    Test_LB('× 307E ÷ 0061 × 0062 × 0020 ÷	#  × [0.3] HIRAGANA LETTER MA (ID) ÷ [999.0] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER B (AL) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 3067 ÷ 4F7F ÷	#  × [0.3] HIRAGANA LETTER DE (ID) ÷ [999.0] CJK UNIFIED IDEOGRAPH-4F7F (ID) ÷ [0.3]');
    Test_LB('× 3059 ÷ 308B ÷	#  × [0.3] HIRAGANA LETTER SU (ID) ÷ [999.0] HIRAGANA LETTER RU (ID) ÷ [0.3]');
    Test_LB('× 306E ÷ 30D1 ÷ 30F3 ÷	#  × [0.3] HIRAGANA LETTER NO (ID) ÷ [999.0] KATAKANA LETTER PA (ID) ÷ [999.0] KATAKANA LETTER N (ID) ÷ [0.3]');
    Test_LB('× 3046 × 3000 ÷ 3048 × 3000 ÷ 304A × 300D ÷	#  × [0.3] HIRAGANA LETTER U (ID) × [21.01] IDEOGRAPHIC SPACE (BA) ÷ [999.0] HIRAGANA LETTER E (ID) × [21.01] IDEOGRAPHIC SPACE (BA) ÷ [999.0] HIRAGANA LETTER O (ID) × [13.02] RIGHT CORNER BRACKET (CL) ÷ [0.3]');
    Test_LB('× 308B × 0020 ÷ C740 ÷ C601 × 0020 ÷ 306B ÷	#  × [0.3] HIRAGANA LETTER RU (ID) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE EUN (H3) ÷ [999.0] HANGUL SYLLABLE YEONG (H3) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER NI (ID) ÷ [0.3]');
    Test_LB('× 3057 × 3087 ÷ 3046 × 3002 ÷	#  × [0.3] HIRAGANA LETTER SI (ID) × [21.03] HIRAGANA LETTER SMALL YO (CJ_NS) ÷ [999.0] HIRAGANA LETTER U (ID) × [13.02] IDEOGRAPHIC FULL STOP (CL) ÷ [0.3]');
    Test_LB('× 30E0 ÷ 306E ÷ 4E00 ÷	#  × [0.3] KATAKANA LETTER MU (ID) ÷ [999.0] HIRAGANA LETTER NO (ID) ÷ [999.0] CJK UNIFIED IDEOGRAPH-4E00 (ID) ÷ [0.3]');
    Test_LB('× 30D5 ÷ 30EA ÷	#  × [0.3] KATAKANA LETTER HU (ID) ÷ [999.0] KATAKANA LETTER RI (ID) ÷ [0.3]');
    Test_LB('× 30D5 ÷ 30EA × 30FC ÷ 767E ÷	#  × [0.3] KATAKANA LETTER HU (ID) ÷ [999.0] KATAKANA LETTER RI (ID) × [21.03] KATAKANA-HIRAGANA PROLONGED SOUND MARK (CJ_NS) ÷ [999.0] CJK UNIFIED IDEOGRAPH-767E (ID) ÷ [0.3]');
    Test_LB('× 30D4 × 30E5 × 30FC ÷ 30BF ÷ 3067 ÷ 4F7F ÷ 7528 ÷ 3059 ÷ 308B ÷	#  × [0.3] KATAKANA LETTER PI (ID) × [21.03] KATAKANA LETTER SMALL YU (CJ_NS) × [21.03] KATAKANA-HIRAGANA PROLONGED SOUND MARK (CJ_NS) ÷ [999.0] KATAKANA LETTER TA (ID) ÷ [999.0] HIRAGANA LETTER DE (ID) ÷ [999.0] CJK UNIFIED IDEOGRAPH-4F7F (ID) ÷ [999.0] CJK UNIFIED IDEOGRAPH-7528 (ID) ÷ [999.0] HIRAGANA LETTER SU (ID) ÷ [999.0] HIRAGANA LETTER RU (ID) ÷ [0.3]');
    Test_LB('× 30BF × 30FC ÷ 30AD × 30FC ÷ 3092 ÷ 62BC ÷	#  × [0.3] KATAKANA LETTER TA (ID) × [21.03] KATAKANA-HIRAGANA PROLONGED SOUND MARK (CJ_NS) ÷ [999.0] KATAKANA LETTER KI (ID) × [21.03] KATAKANA-HIRAGANA PROLONGED SOUND MARK (CJ_NS) ÷ [999.0] HIRAGANA LETTER WO (ID) ÷ [999.0] CJK UNIFIED IDEOGRAPH-62BC (ID) ÷ [0.3]');
    Test_LB('× 30B7 × 30E7 ÷ 30F3 ÷	#  × [0.3] KATAKANA LETTER SI (ID) × [21.03] KATAKANA LETTER SMALL YO (CJ_NS) ÷ [999.0] KATAKANA LETTER N (ID) ÷ [0.3]');
    Test_LB('× 0061 × 002E ÷ 0032 × 0020 ÷	#  × [0.3] LATIN SMALL LETTER A (AL) × [13.02] FULL STOP (IS) ÷ [999.0] DIGIT TWO (NU) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0061 × 002E ÷ 0032 × 0020 ÷ 0915 ÷	#  × [0.3] LATIN SMALL LETTER A (AL) × [13.02] FULL STOP (IS) ÷ [999.0] DIGIT TWO (NU) × [7.01] SPACE (SP) ÷ [18.0] DEVANAGARI LETTER KA (AL) ÷ [0.3]');
    Test_LB('× 0061 × 002E ÷ 0032 × 0020 ÷ 672C ÷	#  × [0.3] LATIN SMALL LETTER A (AL) × [13.02] FULL STOP (IS) ÷ [999.0] DIGIT TWO (NU) × [7.01] SPACE (SP) ÷ [18.0] CJK UNIFIED IDEOGRAPH-672C (ID) ÷ [0.3]');
    Test_LB('× 0061 × 002E ÷ 0032 × 3000 ÷ 672C ÷	#  × [0.3] LATIN SMALL LETTER A (AL) × [13.02] FULL STOP (IS) ÷ [999.0] DIGIT TWO (NU) × [21.01] IDEOGRAPHIC SPACE (BA) ÷ [999.0] CJK UNIFIED IDEOGRAPH-672C (ID) ÷ [0.3]');
    Test_LB('× 0061 × 002E ÷ 0032 × 3000 ÷ 307E ÷	#  × [0.3] LATIN SMALL LETTER A (AL) × [13.02] FULL STOP (IS) ÷ [999.0] DIGIT TWO (NU) × [21.01] IDEOGRAPHIC SPACE (BA) ÷ [999.0] HIRAGANA LETTER MA (ID) ÷ [0.3]');
    Test_LB('× 0061 × 002E ÷ 0032 × 3000 ÷ 0033 ÷	#  × [0.3] LATIN SMALL LETTER A (AL) × [13.02] FULL STOP (IS) ÷ [999.0] DIGIT TWO (NU) × [21.01] IDEOGRAPHIC SPACE (BA) ÷ [999.0] DIGIT THREE (NU) ÷ [0.3]');
    Test_LB('× 0061 × 0062 × 002E × 0020 ÷ 0032 ÷	#  × [0.3] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER B (AL) × [13.02] FULL STOP (IS) × [7.01] SPACE (SP) ÷ [18.0] DIGIT TWO (NU) ÷ [0.3]');
    Test_LB('× 0041 × 002E ÷ 0031 × 0020 ÷ BABB ÷	#  × [0.3] LATIN CAPITAL LETTER A (AL) × [13.02] FULL STOP (IS) ÷ [999.0] DIGIT ONE (NU) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE MOS (H3) ÷ [0.3]');
    Test_LB('× BD24 ÷ C5B4 × 002E × 0020 ÷ 0041 × 002E ÷ 0032 × 0020 ÷ BCFC ÷	#  × [0.3] HANGUL SYLLABLE BWASS (H3) ÷ [999.0] HANGUL SYLLABLE EO (H2) × [13.02] FULL STOP (IS) × [7.01] SPACE (SP) ÷ [18.0] LATIN CAPITAL LETTER A (AL) × [13.02] FULL STOP (IS) ÷ [999.0] DIGIT TWO (NU) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE BOL (H3) ÷ [0.3]');
    Test_LB('× BD10 ÷ C694 × 002E × 0020 ÷ 0041 × 002E ÷ 0033 × 0020 ÷ BABB ÷	#  × [0.3] HANGUL SYLLABLE BWA (H2) ÷ [999.0] HANGUL SYLLABLE YO (H2) × [13.02] FULL STOP (IS) × [7.01] SPACE (SP) ÷ [18.0] LATIN CAPITAL LETTER A (AL) × [13.02] FULL STOP (IS) ÷ [999.0] DIGIT THREE (NU) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE MOS (H3) ÷ [0.3]');
    Test_LB('× C694 × 002E × 0020 ÷ 0041 × 002E ÷ 0034 × 0020 ÷ BABB ÷	#  × [0.3] HANGUL SYLLABLE YO (H2) × [13.02] FULL STOP (IS) × [7.01] SPACE (SP) ÷ [18.0] LATIN CAPITAL LETTER A (AL) × [13.02] FULL STOP (IS) ÷ [999.0] DIGIT FOUR (NU) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE MOS (H3) ÷ [0.3]');
    Test_LB('× 0061 × 002E ÷ 0032 × 3000 ÷ 300C ÷	#  × [0.3] LATIN SMALL LETTER A (AL) × [13.02] FULL STOP (IS) ÷ [999.0] DIGIT TWO (NU) × [21.01] IDEOGRAPHIC SPACE (BA) ÷ [999.0] LEFT CORNER BRACKET (OP) ÷ [0.3]');
    Test_LB('× 306B ÷ 300C × 30D0 ÷ 0028 × 0062 × 0061 × 0029 × 300D ÷ 3084 ÷ 300C × 30B9 ÷	#  × [0.3] HIRAGANA LETTER NI (ID) ÷ [999.0] LEFT CORNER BRACKET (OP) × [14.0] KATAKANA LETTER BA (ID) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) × [14.0] LATIN SMALL LETTER B (AL) × [28.0] LATIN SMALL LETTER A (AL) × [13.02] RIGHT PARENTHESIS (CP_CP30) × [13.02] RIGHT CORNER BRACKET (CL) ÷ [999.0] HIRAGANA LETTER YA (ID) ÷ [999.0] LEFT CORNER BRACKET (OP) × [14.0] KATAKANA LETTER SU (ID) ÷ [0.3]');
    Test_LB('× 308B ÷ 300C × 0055 × 004B ÷ 30DD ÷ 30F3 ÷ 30C9 × 300D × FF09 × 3001 ÷ 30A8 ÷	#  × [0.3] HIRAGANA LETTER RU (ID) ÷ [999.0] LEFT CORNER BRACKET (OP) × [14.0] LATIN CAPITAL LETTER U (AL) × [28.0] LATIN CAPITAL LETTER K (AL) ÷ [999.0] KATAKANA LETTER PO (ID) ÷ [999.0] KATAKANA LETTER N (ID) ÷ [999.0] KATAKANA LETTER DO (ID) × [13.02] RIGHT CORNER BRACKET (CL) × [13.02] FULLWIDTH RIGHT PARENTHESIS (CL) × [13.02] IDEOGRAPHIC COMMA (CL) ÷ [999.0] KATAKANA LETTER E (ID) ÷ [0.3]');
    Test_LB('× 306F × 3001 ÷ 300C × 003D × 0072 × 0061 × 006E × 0064 × 0028 × 0029 × 300D ÷ 3068 ÷	#  × [0.3] HIRAGANA LETTER HA (ID) × [13.02] IDEOGRAPHIC COMMA (CL) ÷ [999.0] LEFT CORNER BRACKET (OP) × [14.0] EQUALS SIGN (AL) × [28.0] LATIN SMALL LETTER R (AL) × [28.0] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER N (AL) × [28.0] LATIN SMALL LETTER D (AL) × [30.01] LEFT PARENTHESIS (OP_OP30) × [13.02] RIGHT PARENTHESIS (CP_CP30) × [13.02] RIGHT CORNER BRACKET (CL) ÷ [999.0] HIRAGANA LETTER TO (ID) ÷ [0.3]');
    Test_LB('× 3067 × 3001 ÷ 300C × 0021 × 300D ÷ 3068 ÷	#  × [0.3] HIRAGANA LETTER DE (ID) × [13.02] IDEOGRAPHIC COMMA (CL) ÷ [999.0] LEFT CORNER BRACKET (OP) × [13.01] EXCLAMATION MARK (EX) × [13.02] RIGHT CORNER BRACKET (CL) ÷ [999.0] HIRAGANA LETTER TO (ID) ÷ [0.3]');
    Test_LB('× 8A33 ÷ 300C × 3059 ÷	#  × [0.3] CJK UNIFIED IDEOGRAPH-8A33 (ID) ÷ [999.0] LEFT CORNER BRACKET (OP) × [14.0] HIRAGANA LETTER SU (ID) ÷ [0.3]');
    Test_LB('× 3066 ÷ 300C × BD24 ÷ C5B4 × 003F × 300D ÷ 3068 ÷	#  × [0.3] HIRAGANA LETTER TE (ID) ÷ [999.0] LEFT CORNER BRACKET (OP) × [14.0] HANGUL SYLLABLE BWASS (H3) ÷ [999.0] HANGUL SYLLABLE EO (H2) × [13.01] QUESTION MARK (EX) × [13.02] RIGHT CORNER BRACKET (CL) ÷ [999.0] HIRAGANA LETTER TO (ID) ÷ [0.3]');
    Test_LB('× 306E ÷ 300C × 305D ÷	#  × [0.3] HIRAGANA LETTER NO (ID) ÷ [999.0] LEFT CORNER BRACKET (OP) × [14.0] HIRAGANA LETTER SO (ID) ÷ [0.3]');
    Test_LB('× 306F ÷ 300C × 30A8 ÷	#  × [0.3] HIRAGANA LETTER HA (ID) ÷ [999.0] LEFT CORNER BRACKET (OP) × [14.0] KATAKANA LETTER E (ID) ÷ [0.3]');
    Test_LB('× 4F8B × FF1A ÷ 300C × 3042 × 3000 ÷ 3044 ÷	#  × [0.3] CJK UNIFIED IDEOGRAPH-4F8B (ID) × [21.03] FULLWIDTH COLON (NS) ÷ [999.0] LEFT CORNER BRACKET (OP) × [14.0] HIRAGANA LETTER A (ID) × [21.01] IDEOGRAPHIC SPACE (BA) ÷ [999.0] HIRAGANA LETTER I (ID) ÷ [0.3]');
    Test_LB('× 304F × 3001 ÷ 300C × D3C9 ÷ C591 ÷ C740 ÷	#  × [0.3] HIRAGANA LETTER KU (ID) × [13.02] IDEOGRAPHIC COMMA (CL) ÷ [999.0] LEFT CORNER BRACKET (OP) × [14.0] HANGUL SYLLABLE PYEONG (H3) ÷ [999.0] HANGUL SYLLABLE YANG (H3) ÷ [999.0] HANGUL SYLLABLE EUN (H3) ÷ [0.3]');
    Test_LB('× 306B ÷ 300C × C81C ÷ BAA9 ÷ 0028 × 984C ÷ 540D × 0029 ÷ C740 ÷	#  × [0.3] HIRAGANA LETTER NI (ID) ÷ [999.0] LEFT CORNER BRACKET (OP) × [14.0] HANGUL SYLLABLE JE (H2) ÷ [999.0] HANGUL SYLLABLE MOG (H3) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) × [14.0] CJK UNIFIED IDEOGRAPH-984C (ID) ÷ [999.0] CJK UNIFIED IDEOGRAPH-540D (ID) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [999.0] HANGUL SYLLABLE EUN (H3) ÷ [0.3]');
    Test_LB('× 5178 ÷ 300E × 30A6 × 30A3 ÷ 30AD ÷	#  × [0.3] CJK UNIFIED IDEOGRAPH-5178 (ID) ÷ [999.0] LEFT WHITE CORNER BRACKET (OP) × [14.0] KATAKANA LETTER U (ID) × [21.03] KATAKANA LETTER SMALL I (CJ_NS) ÷ [999.0] KATAKANA LETTER KI (ID) ÷ [0.3]');
    Test_LB('× 3067 ÷ 300E × 82F1 ÷ 8A9E ÷	#  × [0.3] HIRAGANA LETTER DE (ID) ÷ [999.0] LEFT WHITE CORNER BRACKET (OP) × [14.0] CJK UNIFIED IDEOGRAPH-82F1 (ID) ÷ [999.0] CJK UNIFIED IDEOGRAPH-8A9E (ID) ÷ [0.3]');
    Test_LB('× 0028 × 0073 × 0029 × 0020 ÷ 672C ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [14.0] LATIN SMALL LETTER S (AL) × [13.02] RIGHT PARENTHESIS (CP_CP30) × [7.01] SPACE (SP) ÷ [18.0] CJK UNIFIED IDEOGRAPH-672C (ID) ÷ [0.3]');
    Test_LB('× 0028 × 0073 × 0029 × 0020 ÷ 307E ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [14.0] LATIN SMALL LETTER S (AL) × [13.02] RIGHT PARENTHESIS (CP_CP30) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER MA (ID) ÷ [0.3]');
    Test_LB('× 0028 × 0073 × 0029 × 0020 ÷ 30AF ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [14.0] LATIN SMALL LETTER S (AL) × [13.02] RIGHT PARENTHESIS (CP_CP30) × [7.01] SPACE (SP) ÷ [18.0] KATAKANA LETTER KU (ID) ÷ [0.3]');
    Test_LB('× 308B × 3002 ÷ 0064 × 006F × 0067 ÷ FF08 × 72AC × FF09 ÷ 3092 ÷	#  × [0.3] HIRAGANA LETTER RU (ID) × [13.02] IDEOGRAPHIC FULL STOP (CL) ÷ [999.0] LATIN SMALL LETTER D (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER G (AL) ÷ [999.0] FULLWIDTH LEFT PARENTHESIS (OP) × [14.0] CJK UNIFIED IDEOGRAPH-72AC (ID) × [13.02] FULLWIDTH RIGHT PARENTHESIS (CL) ÷ [999.0] HIRAGANA LETTER WO (ID) ÷ [0.3]');
    Test_LB('× 672C ÷ FF08 × 307E ÷	#  × [0.3] CJK UNIFIED IDEOGRAPH-672C (ID) ÷ [999.0] FULLWIDTH LEFT PARENTHESIS (OP) × [14.0] HIRAGANA LETTER MA (ID) ÷ [0.3]');
    Test_LB('× 672C × 0020 ÷ 0028 × 0061 ÷	#  × [0.3] CJK UNIFIED IDEOGRAPH-672C (ID) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) × [14.0] LATIN SMALL LETTER A (AL) ÷ [0.3]');
    Test_LB('× 70B9 × 0020 ÷ 005B × 7DE8 ÷ 96C6 × 005D ÷	#  × [0.3] CJK UNIFIED IDEOGRAPH-70B9 (ID) × [7.01] SPACE (SP) ÷ [18.0] LEFT SQUARE BRACKET (OP_OP30) × [14.0] CJK UNIFIED IDEOGRAPH-7DE8 (ID) ÷ [999.0] CJK UNIFIED IDEOGRAPH-96C6 (ID) × [13.02] RIGHT SQUARE BRACKET (CP_CP30) ÷ [0.3]');
    Test_LB('× 0061 × 0028 × 0073 × 0029 × 0020 ÷	#  × [0.3] LATIN SMALL LETTER A (AL) × [30.01] LEFT PARENTHESIS (OP_OP30) × [14.0] LATIN SMALL LETTER S (AL) × [13.02] RIGHT PARENTHESIS (CP_CP30) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× FF08 × 30B6 × 30FB ÷ 30AF ÷ 30A4 × 30C3 ÷ 30AF × 30FB ÷ 30D6 ÷	#  × [0.3] FULLWIDTH LEFT PARENTHESIS (OP) × [14.0] KATAKANA LETTER ZA (ID) × [21.03] KATAKANA MIDDLE DOT (NS) ÷ [999.0] KATAKANA LETTER KU (ID) ÷ [999.0] KATAKANA LETTER I (ID) × [21.03] KATAKANA LETTER SMALL TU (CJ_NS) ÷ [999.0] KATAKANA LETTER KU (ID) × [21.03] KATAKANA MIDDLE DOT (NS) ÷ [999.0] KATAKANA LETTER BU (ID) ÷ [0.3]');
    Test_LB('× 0070 ÷ FF08 × 30AF ÷ 30A4 × 30C3 ÷ 30AF × 30FB ÷ 30D6 ÷	#  × [0.3] LATIN SMALL LETTER P (AL) ÷ [999.0] FULLWIDTH LEFT PARENTHESIS (OP) × [14.0] KATAKANA LETTER KU (ID) ÷ [999.0] KATAKANA LETTER I (ID) × [21.03] KATAKANA LETTER SMALL TU (CJ_NS) ÷ [999.0] KATAKANA LETTER KU (ID) × [21.03] KATAKANA MIDDLE DOT (NS) ÷ [999.0] KATAKANA LETTER BU (ID) ÷ [0.3]');
    Test_LB('× 0061 × 0062 ÷ FF08 × 30AF ÷	#  × [0.3] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER B (AL) ÷ [999.0] FULLWIDTH LEFT PARENTHESIS (OP) × [14.0] KATAKANA LETTER KU (ID) ÷ [0.3]');
    Test_LB('× 0028 × 5370 ÷ 672C × 0029 ÷	#  × [0.3] LEFT PARENTHESIS (OP_OP30) × [14.0] CJK UNIFIED IDEOGRAPH-5370 (ID) ÷ [999.0] CJK UNIFIED IDEOGRAPH-672C (ID) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [0.3]');
    Test_LB('× 30B9 ÷ FF08 × 3044 ÷	#  × [0.3] KATAKANA LETTER SU (ID) ÷ [999.0] FULLWIDTH LEFT PARENTHESIS (OP) × [14.0] HIRAGANA LETTER I (ID) ÷ [0.3]');
    Test_LB('× 30C9 ÷ FF08 × 30DD ÷	#  × [0.3] KATAKANA LETTER DO (ID) ÷ [999.0] FULLWIDTH LEFT PARENTHESIS (OP) × [14.0] KATAKANA LETTER PO (ID) ÷ [0.3]');
    Test_LB('× 30C9 × 0020 ÷ 0028 × 8CEA ÷	#  × [0.3] KATAKANA LETTER DO (ID) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) × [14.0] CJK UNIFIED IDEOGRAPH-8CEA (ID) ÷ [0.3]');
    Test_LB('× 0073 × 0029 × 300D ÷ 307E ÷	#  × [0.3] LATIN SMALL LETTER S (AL) × [13.02] RIGHT PARENTHESIS (CP_CP30) × [13.02] RIGHT CORNER BRACKET (CL) ÷ [999.0] HIRAGANA LETTER MA (ID) ÷ [0.3]');
    Test_LB('× 0061 × FF09 × 300F ÷	#  × [0.3] LATIN SMALL LETTER A (AL) × [13.02] FULLWIDTH RIGHT PARENTHESIS (CL) × [13.02] RIGHT WHITE CORNER BRACKET (CL) ÷ [0.3]');
    Test_LB('× 308B × 300D × FF09 ÷ 306F ÷	#  × [0.3] HIRAGANA LETTER RU (ID) × [13.02] RIGHT CORNER BRACKET (CL) × [13.02] FULLWIDTH RIGHT PARENTHESIS (CL) ÷ [999.0] HIRAGANA LETTER HA (ID) ÷ [0.3]');
    Test_LB('× 30C9 × 300D × FF09 × 3001 ÷ 30A8 ÷	#  × [0.3] KATAKANA LETTER DO (ID) × [13.02] RIGHT CORNER BRACKET (CL) × [13.02] FULLWIDTH RIGHT PARENTHESIS (CL) × [13.02] IDEOGRAPHIC COMMA (CL) ÷ [999.0] KATAKANA LETTER E (ID) ÷ [0.3]');
    Test_LB('× 0072 × 006B × 0029 × 300D ÷ 3082 ÷	#  × [0.3] LATIN SMALL LETTER R (AL) × [28.0] LATIN SMALL LETTER K (AL) × [13.02] RIGHT PARENTHESIS (CP_CP30) × [13.02] RIGHT CORNER BRACKET (CL) ÷ [999.0] HIRAGANA LETTER MO (ID) ÷ [0.3]');
    Test_LB('× 30AF ÷ 0028 × 0061 × 0062 × 0020 ÷ 0063 × 0064 × 0029 × 300D ÷ 3082 ÷	#  × [0.3] KATAKANA LETTER KU (ID) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) × [14.0] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER B (AL) × [7.01] SPACE (SP) ÷ [18.0] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER D (AL) × [13.02] RIGHT PARENTHESIS (CP_CP30) × [13.02] RIGHT CORNER BRACKET (CL) ÷ [999.0] HIRAGANA LETTER MO (ID) ÷ [0.3]');
    Test_LB('× 30F3 × 30FB ÷ 30DE × 30FC ÷ 30AF ÷ 0028 × 0065 × 0078 ÷	#  × [0.3] KATAKANA LETTER N (ID) × [21.03] KATAKANA MIDDLE DOT (NS) ÷ [999.0] KATAKANA LETTER MA (ID) × [21.03] KATAKANA-HIRAGANA PROLONGED SOUND MARK (CJ_NS) ÷ [999.0] KATAKANA LETTER KU (ID) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) × [14.0] LATIN SMALL LETTER E (AL) × [28.0] LATIN SMALL LETTER X (AL) ÷ [0.3]');
    Test_LB('× 30DE × 30FC ÷ 0028 × 006D × 0061 × 0029 × 300D ÷ 306A ÷	#  × [0.3] KATAKANA LETTER MA (ID) × [21.03] KATAKANA-HIRAGANA PROLONGED SOUND MARK (CJ_NS) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) × [14.0] LATIN SMALL LETTER M (AL) × [28.0] LATIN SMALL LETTER A (AL) × [13.02] RIGHT PARENTHESIS (CP_CP30) × [13.02] RIGHT CORNER BRACKET (CL) ÷ [999.0] HIRAGANA LETTER NA (ID) ÷ [0.3]');
    Test_LB('× 30AC ÷ 30EF × 300D × 3002 ÷ 3053 ÷	#  × [0.3] KATAKANA LETTER GA (ID) ÷ [999.0] KATAKANA LETTER WA (ID) × [13.02] RIGHT CORNER BRACKET (CL) × [13.02] IDEOGRAPHIC FULL STOP (CL) ÷ [999.0] HIRAGANA LETTER KO (ID) ÷ [0.3]');
    Test_LB('× 30AF × 300D ÷ 307E ÷	#  × [0.3] KATAKANA LETTER KU (ID) × [13.02] RIGHT CORNER BRACKET (CL) ÷ [999.0] HIRAGANA LETTER MA (ID) ÷ [0.3]');
    Test_LB('× 30EF × 300D × 3002 ÷ 3053 ÷	#  × [0.3] KATAKANA LETTER WA (ID) × [13.02] RIGHT CORNER BRACKET (CL) × [13.02] IDEOGRAPHIC FULL STOP (CL) ÷ [999.0] HIRAGANA LETTER KO (ID) ÷ [0.3]');
    Test_LB('× 30AF × 300D ÷ 307E × 3001 ÷ 672C ÷	#  × [0.3] KATAKANA LETTER KU (ID) × [13.02] RIGHT CORNER BRACKET (CL) ÷ [999.0] HIRAGANA LETTER MA (ID) × [13.02] IDEOGRAPHIC COMMA (CL) ÷ [999.0] CJK UNIFIED IDEOGRAPH-672C (ID) ÷ [0.3]');
    Test_LB('× 30AF × 300D × 3001 ÷ 30AF ÷	#  × [0.3] KATAKANA LETTER KU (ID) × [13.02] RIGHT CORNER BRACKET (CL) × [13.02] IDEOGRAPHIC COMMA (CL) ÷ [999.0] KATAKANA LETTER KU (ID) ÷ [0.3]');
    Test_LB('× 30C7 × 30A3 ÷ 30A2 ÷ FF08 × 0061 × 0062 × FF09 × 300F ÷	#  × [0.3] KATAKANA LETTER DE (ID) × [21.03] KATAKANA LETTER SMALL I (CJ_NS) ÷ [999.0] KATAKANA LETTER A (ID) ÷ [999.0] FULLWIDTH LEFT PARENTHESIS (OP) × [14.0] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER B (AL) × [13.02] FULLWIDTH RIGHT PARENTHESIS (CL) × [13.02] RIGHT WHITE CORNER BRACKET (CL) ÷ [0.3]');
    Test_LB('× CABD ÷ C774 ÷ C5D0 ÷ C694 × 003F × 300D ÷ 3068 ÷ 805E ÷	#  × [0.3] HANGUL SYLLABLE JJOG (H3) ÷ [999.0] HANGUL SYLLABLE I (H2) ÷ [999.0] HANGUL SYLLABLE E (H2) ÷ [999.0] HANGUL SYLLABLE YO (H2) × [13.01] QUESTION MARK (EX) × [13.02] RIGHT CORNER BRACKET (CL) ÷ [999.0] HIRAGANA LETTER TO (ID) ÷ [999.0] CJK UNIFIED IDEOGRAPH-805E (ID) ÷ [0.3]');
    Test_LB('× 540D × 0029 ÷ C740 × 0020 ÷ C54C ÷ C544 ÷ C694 × 003F × 300D ÷ 3068 ÷	#  × [0.3] CJK UNIFIED IDEOGRAPH-540D (ID) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [999.0] HANGUL SYLLABLE EUN (H3) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE AL (H3) ÷ [999.0] HANGUL SYLLABLE A (H2) ÷ [999.0] HANGUL SYLLABLE YO (H2) × [13.01] QUESTION MARK (EX) × [13.02] RIGHT CORNER BRACKET (CL) ÷ [999.0] HIRAGANA LETTER TO (ID) ÷ [0.3]');
    Test_LB('× 8CA8 × 0029 × 0020 ÷ 002D × 0020 ÷ 0028 × 0070 × 006F ÷	#  × [0.3] CJK UNIFIED IDEOGRAPH-8CA8 (ID) × [13.02] RIGHT PARENTHESIS (CP_CP30) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) × [14.0] LATIN SMALL LETTER P (AL) × [28.0] LATIN SMALL LETTER O (AL) ÷ [0.3]');
    Test_LB('× 91CF × 0029 × 0020 × 301C × 0020 ÷ 0028 × 0070 × 006F ÷	#  × [0.3] CJK UNIFIED IDEOGRAPH-91CF (ID) × [13.02] RIGHT PARENTHESIS (CP_CP30) × [7.01] SPACE (SP) × [16.0] WAVE DASH (NS) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP_OP30) × [14.0] LATIN SMALL LETTER P (AL) × [28.0] LATIN SMALL LETTER O (AL) ÷ [0.3]');
    Test_LB('× 30C9 ÷ 91CD × FF09 × 0020 × 301C × 0020 ÷ 529B × 30FB ÷ 91CD ÷	#  × [0.3] KATAKANA LETTER DO (ID) ÷ [999.0] CJK UNIFIED IDEOGRAPH-91CD (ID) × [13.02] FULLWIDTH RIGHT PARENTHESIS (CL) × [7.01] SPACE (SP) × [16.0] WAVE DASH (NS) × [7.01] SPACE (SP) ÷ [18.0] CJK UNIFIED IDEOGRAPH-529B (ID) × [21.03] KATAKANA MIDDLE DOT (NS) ÷ [999.0] CJK UNIFIED IDEOGRAPH-91CD (ID) ÷ [0.3]');
    Test_LB('× 0061 × 0062 × 0022 × FF08 × 307E ÷	#  × [0.3] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER B (AL) × [19.01] QUOTATION MARK (QU) × [15.0] FULLWIDTH LEFT PARENTHESIS (OP) × [14.0] HIRAGANA LETTER MA (ID) ÷ [0.3]');
    Test_LB('× 306F × 0020 ÷ 0022 × 0073 × 0022 × 0020 ÷	#  × [0.3] HIRAGANA LETTER HA (ID) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) × [19.02] LATIN SMALL LETTER S (AL) × [19.01] QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 306F × 3001 × 0022 × 0054 × 0068 × 0065 × 0020 ÷	#  × [0.3] HIRAGANA LETTER HA (ID) × [13.02] IDEOGRAPHIC COMMA (CL) × [19.01] QUOTATION MARK (QU) × [19.02] LATIN CAPITAL LETTER T (AL) × [28.0] LATIN SMALL LETTER H (AL) × [28.0] LATIN SMALL LETTER E (AL) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0064 × 006F × 0067 × 0022 × 0020 ÷ 3092 ÷	#  × [0.3] LATIN SMALL LETTER D (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER G (AL) × [19.01] QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER WO (ID) ÷ [0.3]');
    Test_LB('× 0039 × 0030 × 0022 × 0020 ÷ 3068 ÷	#  × [0.3] DIGIT NINE (NU) × [25.03] DIGIT ZERO (NU) × [19.01] QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER TO (ID) ÷ [0.3]');
    Test_LB('× 30B9 × 30FB ÷ 30AA × 30FC ÷ 30D0 × 30FC × 30FB ÷ 30B6 × 30FB ÷ 30EC ÷	#  × [0.3] KATAKANA LETTER SU (ID) × [21.03] KATAKANA MIDDLE DOT (NS) ÷ [999.0] KATAKANA LETTER O (ID) × [21.03] KATAKANA-HIRAGANA PROLONGED SOUND MARK (CJ_NS) ÷ [999.0] KATAKANA LETTER BA (ID) × [21.03] KATAKANA-HIRAGANA PROLONGED SOUND MARK (CJ_NS) × [21.03] KATAKANA MIDDLE DOT (NS) ÷ [999.0] KATAKANA LETTER ZA (ID) × [21.03] KATAKANA MIDDLE DOT (NS) ÷ [999.0] KATAKANA LETTER RE (ID) ÷ [0.3]');
    Test_LB('× 30B9 × 30FB ÷ 30B8 × 30E3 ÷ 30F3 ÷	#  × [0.3] KATAKANA LETTER SU (ID) × [21.03] KATAKANA MIDDLE DOT (NS) ÷ [999.0] KATAKANA LETTER ZI (ID) × [21.03] KATAKANA LETTER SMALL YA (CJ_NS) ÷ [999.0] KATAKANA LETTER N (ID) ÷ [0.3]');
    Test_LB('× 30F3 × 30FB ÷ 30D5 × 30A9 × 30C3 ÷ 30AF ÷	#  × [0.3] KATAKANA LETTER N (ID) × [21.03] KATAKANA MIDDLE DOT (NS) ÷ [999.0] KATAKANA LETTER HU (ID) × [21.03] KATAKANA LETTER SMALL O (CJ_NS) × [21.03] KATAKANA LETTER SMALL TU (CJ_NS) ÷ [999.0] KATAKANA LETTER KU (ID) ÷ [0.3]');
    Test_LB('× 30A4 ÷ 30B8 × 30FC × 30FB ÷ 30C9 × 30C3 ÷ 30B0 × 3001 ÷ 548C ÷	#  × [0.3] KATAKANA LETTER I (ID) ÷ [999.0] KATAKANA LETTER ZI (ID) × [21.03] KATAKANA-HIRAGANA PROLONGED SOUND MARK (CJ_NS) × [21.03] KATAKANA MIDDLE DOT (NS) ÷ [999.0] KATAKANA LETTER DO (ID) × [21.03] KATAKANA LETTER SMALL TU (CJ_NS) ÷ [999.0] KATAKANA LETTER GU (ID) × [13.02] IDEOGRAPHIC COMMA (CL) ÷ [999.0] CJK UNIFIED IDEOGRAPH-548C (ID) ÷ [0.3]');
    Test_LB('× 30E1 × 30FC ÷ 30B7 × 30E7 ÷ 30F3 × 30FB ÷ 30DE × 30FC ÷ 30AF ÷	#  × [0.3] KATAKANA LETTER ME (ID) × [21.03] KATAKANA-HIRAGANA PROLONGED SOUND MARK (CJ_NS) ÷ [999.0] KATAKANA LETTER SI (ID) × [21.03] KATAKANA LETTER SMALL YO (CJ_NS) ÷ [999.0] KATAKANA LETTER N (ID) × [21.03] KATAKANA MIDDLE DOT (NS) ÷ [999.0] KATAKANA LETTER MA (ID) × [21.03] KATAKANA-HIRAGANA PROLONGED SOUND MARK (CJ_NS) ÷ [999.0] KATAKANA LETTER KU (ID) ÷ [0.3]');
    Test_LB('× 30F3 × 30FB ÷ 30AF ÷ 0028 × 0061 ÷	#  × [0.3] KATAKANA LETTER N (ID) × [21.03] KATAKANA MIDDLE DOT (NS) ÷ [999.0] KATAKANA LETTER KU (ID) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) × [14.0] LATIN SMALL LETTER A (AL) ÷ [0.3]');
    Test_LB('× 30B7 × 30E7 ÷ 30F3 × 30FB ÷ 30DE ÷	#  × [0.3] KATAKANA LETTER SI (ID) × [21.03] KATAKANA LETTER SMALL YO (CJ_NS) ÷ [999.0] KATAKANA LETTER N (ID) × [21.03] KATAKANA MIDDLE DOT (NS) ÷ [999.0] KATAKANA LETTER MA (ID) ÷ [0.3]');
    Test_LB('× 672C × 003A × 0020 ÷	#  × [0.3] CJK UNIFIED IDEOGRAPH-672C (ID) × [13.02] COLON (IS) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 672C × 003A × 0020 ÷ 30AF ÷	#  × [0.3] CJK UNIFIED IDEOGRAPH-672C (ID) × [13.02] COLON (IS) × [7.01] SPACE (SP) ÷ [18.0] KATAKANA LETTER KU (ID) ÷ [0.3]');
    Test_LB('× 51FA ÷ 5178 × 003A × 0020 ÷ 30D5 ÷ 30EA × 30FC ÷ 767E ÷	#  × [0.3] CJK UNIFIED IDEOGRAPH-51FA (ID) ÷ [999.0] CJK UNIFIED IDEOGRAPH-5178 (ID) × [13.02] COLON (IS) × [7.01] SPACE (SP) ÷ [18.0] KATAKANA LETTER HU (ID) ÷ [999.0] KATAKANA LETTER RI (ID) × [21.03] KATAKANA-HIRAGANA PROLONGED SOUND MARK (CJ_NS) ÷ [999.0] CJK UNIFIED IDEOGRAPH-767E (ID) ÷ [0.3]');
    Test_LB('× 5F8C × 2026 ÷ 306B ÷	#  × [0.3] CJK UNIFIED IDEOGRAPH-5F8C (ID) × [22.0] HORIZONTAL ELLIPSIS (IN) ÷ [999.0] HIRAGANA LETTER NI (ID) ÷ [0.3]');
    Test_LB('× 3057 × 3087 ÷ 3046 × 3002 × 3002 × 3002 ÷	#  × [0.3] HIRAGANA LETTER SI (ID) × [21.03] HIRAGANA LETTER SMALL YO (CJ_NS) ÷ [999.0] HIRAGANA LETTER U (ID) × [13.02] IDEOGRAPHIC FULL STOP (CL) × [13.02] IDEOGRAPHIC FULL STOP (CL) × [13.02] IDEOGRAPHIC FULL STOP (CL) ÷ [0.3]');
    Test_LB('× 304D × 3001 × 0021 × 0021 × 3001 × 0021 × 0021 × 0021 ÷ 3068 ÷	#  × [0.3] HIRAGANA LETTER KI (ID) × [13.02] IDEOGRAPHIC COMMA (CL) × [13.01] EXCLAMATION MARK (EX) × [13.01] EXCLAMATION MARK (EX) × [13.02] IDEOGRAPHIC COMMA (CL) × [13.01] EXCLAMATION MARK (EX) × [13.01] EXCLAMATION MARK (EX) × [13.01] EXCLAMATION MARK (EX) ÷ [999.0] HIRAGANA LETTER TO (ID) ÷ [0.3]');
    Test_LB('× 306F × 3001 × 003F ÷ 3068 × 0021 ÷ 3092 ÷	#  × [0.3] HIRAGANA LETTER HA (ID) × [13.02] IDEOGRAPHIC COMMA (CL) × [13.01] QUESTION MARK (EX) ÷ [999.0] HIRAGANA LETTER TO (ID) × [13.01] EXCLAMATION MARK (EX) ÷ [999.0] HIRAGANA LETTER WO (ID) ÷ [0.3]');
    Test_LB('× 305F × 3001 × 2049 ÷ 0028 × 0021 × 003F × 0029 ÷ 306E ÷	#  × [0.3] HIRAGANA LETTER TA (ID) × [13.02] IDEOGRAPHIC COMMA (CL) × [16.0] EXCLAMATION QUESTION MARK (NS) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) × [13.01] EXCLAMATION MARK (EX) × [13.01] QUESTION MARK (EX) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [999.0] HIRAGANA LETTER NO (ID) ÷ [0.3]');
    Test_LB('× 3084 × 3001 × 2048 ÷ 0028 × 003F × 0021 × 0029 ÷ 306E ÷	#  × [0.3] HIRAGANA LETTER YA (ID) × [13.02] IDEOGRAPHIC COMMA (CL) × [16.0] QUESTION EXCLAMATION MARK (NS) ÷ [999.0] LEFT PARENTHESIS (OP_OP30) × [13.01] QUESTION MARK (EX) × [13.01] EXCLAMATION MARK (EX) × [13.02] RIGHT PARENTHESIS (CP_CP30) ÷ [999.0] HIRAGANA LETTER NO (ID) ÷ [0.3]');
    Test_LB('× 305F × 0020 ÷ 203D ÷ 3068 ÷	#  × [0.3] HIRAGANA LETTER TA (ID) × [7.01] SPACE (SP) ÷ [18.0] INTERROBANG (NS) ÷ [999.0] HIRAGANA LETTER TO (ID) ÷ [0.3]');
    Test_LB('× 305B × FF01 ÷ 0031 × 0030 × 0030 × 0025 ÷ 306E ÷ 5B8C ÷	#  × [0.3] HIRAGANA LETTER SE (ID) × [13.01] FULLWIDTH EXCLAMATION MARK (EX) ÷ [999.0] DIGIT ONE (NU) × [25.03] DIGIT ZERO (NU) × [25.03] DIGIT ZERO (NU) × [25.05] PERCENT SIGN (PO) ÷ [999.0] HIRAGANA LETTER NO (ID) ÷ [999.0] CJK UNIFIED IDEOGRAPH-5B8C (ID) ÷ [0.3]');
    Test_LB('× 0032 × 0033 ÷ 672C ÷	#  × [0.3] DIGIT TWO (NU) × [25.03] DIGIT THREE (NU) ÷ [999.0] CJK UNIFIED IDEOGRAPH-672C (ID) ÷ [0.3]');
    Test_LB('× 30A1 ÷ 30D9 × 30C3 ÷ 30C8 ÷ 0032 × 0036 ÷ 5B57 ÷ 3092 ÷	#  × [0.3] KATAKANA LETTER SMALL A (CJ_NS) ÷ [999.0] KATAKANA LETTER BE (ID) × [21.03] KATAKANA LETTER SMALL TU (CJ_NS) ÷ [999.0] KATAKANA LETTER TO (ID) ÷ [999.0] DIGIT TWO (NU) × [25.03] DIGIT SIX (NU) ÷ [999.0] CJK UNIFIED IDEOGRAPH-5B57 (ID) ÷ [999.0] HIRAGANA LETTER WO (ID) ÷ [0.3]');
    Test_LB('× 4F8B × FF1A ÷ 00A3 × 0032 × 0033 ÷	#  × [0.3] CJK UNIFIED IDEOGRAPH-4F8B (ID) × [21.03] FULLWIDTH COLON (NS) ÷ [999.0] POUND SIGN (PR) × [25.01] DIGIT TWO (NU) × [25.03] DIGIT THREE (NU) ÷ [0.3]');
    Test_LB('× 8A18 ÷ 53F7 × 0020 ÷ 00A3 × 3002 ÷	#  × [0.3] CJK UNIFIED IDEOGRAPH-8A18 (ID) ÷ [999.0] CJK UNIFIED IDEOGRAPH-53F7 (ID) × [7.01] SPACE (SP) ÷ [18.0] POUND SIGN (PR) × [13.02] IDEOGRAPHIC FULL STOP (CL) ÷ [0.3]');
    Test_LB('× 308C ÷ 308B × 3002 ÷ 0071 × 0075 ÷	#  × [0.3] HIRAGANA LETTER RE (ID) ÷ [999.0] HIRAGANA LETTER RU (ID) × [13.02] IDEOGRAPHIC FULL STOP (CL) ÷ [999.0] LATIN SMALL LETTER Q (AL) × [28.0] LATIN SMALL LETTER U (AL) ÷ [0.3]');
    Test_LB('× 307E × 3002 ÷	#  × [0.3] HIRAGANA LETTER MA (ID) × [13.02] IDEOGRAPHIC FULL STOP (CL) ÷ [0.3]');
    Test_LB('× 307E × 3002 ÷ 0061 × 0062 × 0020 ÷	#  × [0.3] HIRAGANA LETTER MA (ID) × [13.02] IDEOGRAPHIC FULL STOP (CL) ÷ [999.0] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER B (AL) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 308B × 3002 ÷ 6570 ÷	#  × [0.3] HIRAGANA LETTER RU (ID) × [13.02] IDEOGRAPHIC FULL STOP (CL) ÷ [999.0] CJK UNIFIED IDEOGRAPH-6570 (ID) ÷ [0.3]');
    Test_LB('× 308B × 3002 ÷ 3053 ÷	#  × [0.3] HIRAGANA LETTER RU (ID) × [13.02] IDEOGRAPHIC FULL STOP (CL) ÷ [999.0] HIRAGANA LETTER KO (ID) ÷ [0.3]');
    Test_LB('× 3044 × 3002 ÷ 30D1 ÷	#  × [0.3] HIRAGANA LETTER I (ID) × [13.02] IDEOGRAPHIC FULL STOP (CL) ÷ [999.0] KATAKANA LETTER PA (ID) ÷ [0.3]');
    Test_LB('× 30AC ÷ 30EF × 300D × 3002 ÷ 3053 ÷ 308C ÷	#  × [0.3] KATAKANA LETTER GA (ID) ÷ [999.0] KATAKANA LETTER WA (ID) × [13.02] RIGHT CORNER BRACKET (CL) × [13.02] IDEOGRAPHIC FULL STOP (CL) ÷ [999.0] HIRAGANA LETTER KO (ID) ÷ [999.0] HIRAGANA LETTER RE (ID) ÷ [0.3]');
    Test_LB('× 8A9E ÷ 306E ÷ 0069 × 006F ÷ 306E × 3001 ÷ 0032 ÷ 5B57 ÷ 3092 ÷	#  × [0.3] CJK UNIFIED IDEOGRAPH-8A9E (ID) ÷ [999.0] HIRAGANA LETTER NO (ID) ÷ [999.0] LATIN SMALL LETTER I (AL) × [28.0] LATIN SMALL LETTER O (AL) ÷ [999.0] HIRAGANA LETTER NO (ID) × [13.02] IDEOGRAPHIC COMMA (CL) ÷ [999.0] DIGIT TWO (NU) ÷ [999.0] CJK UNIFIED IDEOGRAPH-5B57 (ID) ÷ [999.0] HIRAGANA LETTER WO (ID) ÷ [0.3]');
    Test_LB('× 3001 ÷ 548C ÷	#  × [0.3] IDEOGRAPHIC COMMA (CL) ÷ [999.0] CJK UNIFIED IDEOGRAPH-548C (ID) ÷ [0.3]');
    Test_LB('× 3001 ÷ 30BF ÷	#  × [0.3] IDEOGRAPHIC COMMA (CL) ÷ [999.0] KATAKANA LETTER TA (ID) ÷ [0.3]');
    Test_LB('× 3001 ÷ 304B ÷	#  × [0.3] IDEOGRAPHIC COMMA (CL) ÷ [999.0] HIRAGANA LETTER KA (ID) ÷ [0.3]');
    Test_LB('× 3001 ÷ 3053 ÷ 308C ÷ 3067 ÷ 306F × 0020 ÷	#  × [0.3] IDEOGRAPHIC COMMA (CL) ÷ [999.0] HIRAGANA LETTER KO (ID) ÷ [999.0] HIRAGANA LETTER RE (ID) ÷ [999.0] HIRAGANA LETTER DE (ID) ÷ [999.0] HIRAGANA LETTER HA (ID) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 3057 × 3001 ÷ 0061 × 0062 ÷ 3068 ÷	#  × [0.3] HIRAGANA LETTER SI (ID) × [13.02] IDEOGRAPHIC COMMA (CL) ÷ [999.0] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER B (AL) ÷ [999.0] HIRAGANA LETTER TO (ID) ÷ [0.3]');
    Test_LB('× 0061 ÷ 1F1E6 ÷ 0062 ÷	#  × [0.3] LATIN SMALL LETTER A (AL) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] LATIN SMALL LETTER B (AL) ÷ [0.3]');
    Test_LB('× 1F1F7 × 1F1FA ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER R (RI) × [30.11] REGIONAL INDICATOR SYMBOL LETTER U (RI) ÷ [0.3]');
    Test_LB('× 1F1F7 × 1F1FA ÷ 1F1F8 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER R (RI) × [30.11] REGIONAL INDICATOR SYMBOL LETTER U (RI) ÷ [30.13] REGIONAL INDICATOR SYMBOL LETTER S (RI) ÷ [0.3]');
    Test_LB('× 1F1F7 × 1F1FA ÷ 1F1F8 × 1F1EA ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER R (RI) × [30.11] REGIONAL INDICATOR SYMBOL LETTER U (RI) ÷ [30.13] REGIONAL INDICATOR SYMBOL LETTER S (RI) × [30.11] REGIONAL INDICATOR SYMBOL LETTER E (RI) ÷ [0.3]');
    Test_LB('× 1F1F7 × 1F1FA × 200B ÷ 1F1F8 × 1F1EA ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER R (RI) × [30.11] REGIONAL INDICATOR SYMBOL LETTER U (RI) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [8.0] REGIONAL INDICATOR SYMBOL LETTER S (RI) × [30.12] REGIONAL INDICATOR SYMBOL LETTER E (RI) ÷ [0.3]');
    Test_LB('× 05D0 × 002D × 05D0 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [21.02] HYPHEN-MINUS (HY) × [21.1] HEBREW LETTER ALEF (HL) ÷ [0.3]');
}
if (!$::TESTCHUNK or $::TESTCHUNK == 10) {
    Test_WB('÷ 0001 ÷ 0001 ÷	#  ÷ [0.2] <START OF HEADING> (Other) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 0001 × 0308 ÷ 0001 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 0001 ÷ 000D ÷	#  ÷ [0.2] <START OF HEADING> (Other) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 0001 × 0308 ÷ 000D ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 0001 ÷ 000A ÷	#  ÷ [0.2] <START OF HEADING> (Other) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 0001 × 0308 ÷ 000A ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 0001 ÷ 000B ÷	#  ÷ [0.2] <START OF HEADING> (Other) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 0001 × 0308 ÷ 000B ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 0001 ÷ 3031 ÷	#  ÷ [0.2] <START OF HEADING> (Other) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 0001 × 0308 ÷ 3031 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 0001 ÷ 0041 ÷	#  ÷ [0.2] <START OF HEADING> (Other) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0001 × 0308 ÷ 0041 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0001 ÷ 003A ÷	#  ÷ [0.2] <START OF HEADING> (Other) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0001 × 0308 ÷ 003A ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0001 ÷ 002C ÷	#  ÷ [0.2] <START OF HEADING> (Other) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0001 × 0308 ÷ 002C ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0001 ÷ 002E ÷	#  ÷ [0.2] <START OF HEADING> (Other) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 0001 × 0308 ÷ 002E ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 0001 ÷ 0030 ÷	#  ÷ [0.2] <START OF HEADING> (Other) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 0001 × 0308 ÷ 0030 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 0001 ÷ 005F ÷	#  ÷ [0.2] <START OF HEADING> (Other) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 0001 × 0308 ÷ 005F ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 0001 ÷ 1F1E6 ÷	#  ÷ [0.2] <START OF HEADING> (Other) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 0001 × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 0001 ÷ 05D0 ÷	#  ÷ [0.2] <START OF HEADING> (Other) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 0001 × 0308 ÷ 05D0 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 0001 ÷ 0022 ÷	#  ÷ [0.2] <START OF HEADING> (Other) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 0001 × 0308 ÷ 0022 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 0001 ÷ 0027 ÷	#  ÷ [0.2] <START OF HEADING> (Other) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0001 × 0308 ÷ 0027 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0001 ÷ 231A ÷	#  ÷ [0.2] <START OF HEADING> (Other) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 0001 × 0308 ÷ 231A ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 0001 ÷ 0020 ÷	#  ÷ [0.2] <START OF HEADING> (Other) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 0001 × 0308 ÷ 0020 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 0001 × 00AD ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0001 × 0308 × 00AD ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0001 × 0300 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0001 × 0308 × 0300 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0001 × 200D ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 0001 × 0308 × 200D ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 0001 ÷ 0061 × 2060 ÷	#  ÷ [0.2] <START OF HEADING> (Other) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0001 × 0308 ÷ 0061 × 2060 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0001 ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] <START OF HEADING> (Other) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0001 × 0308 ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0001 ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] <START OF HEADING> (Other) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0001 × 0308 ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0001 ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] <START OF HEADING> (Other) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0001 × 0308 ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0001 ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] <START OF HEADING> (Other) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0001 × 0308 ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0001 ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] <START OF HEADING> (Other) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0001 × 0308 ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0001 ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] <START OF HEADING> (Other) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0001 × 0308 ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0001 ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] <START OF HEADING> (Other) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0001 × 0308 ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0001 ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] <START OF HEADING> (Other) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0001 × 0308 ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0001 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0308 ÷ 0001 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 000D ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0308 ÷ 000D ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 000D × 000A ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) × [3.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0308 ÷ 000A ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 000B ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0308 ÷ 000B ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 3031 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0308 ÷ 3031 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0041 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0308 ÷ 0041 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 003A ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0308 ÷ 003A ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 002C ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0308 ÷ 002C ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 002E ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0308 ÷ 002E ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0030 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0308 ÷ 0030 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 005F ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0308 ÷ 005F ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 1F1E6 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 05D0 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0308 ÷ 05D0 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0022 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0308 ÷ 0022 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0027 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0308 ÷ 0027 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 231A ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0308 ÷ 231A ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0020 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0308 ÷ 0020 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 00AD ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0308 × 00AD ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0300 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0308 × 0300 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 200D ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0308 × 200D ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0061 × 2060 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0308 ÷ 0061 × 2060 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0308 ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0308 ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0308 ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0308 ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0308 ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0308 ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0308 ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0308 ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0001 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0308 ÷ 0001 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 000D ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0308 ÷ 000D ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 000A ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0308 ÷ 000A ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 000B ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0308 ÷ 000B ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 3031 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0308 ÷ 3031 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0041 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0308 ÷ 0041 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 003A ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0308 ÷ 003A ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 002C ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0308 ÷ 002C ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 002E ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0308 ÷ 002E ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0030 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0308 ÷ 0030 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 005F ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0308 ÷ 005F ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 1F1E6 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 05D0 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0308 ÷ 05D0 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0022 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0308 ÷ 0022 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0027 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0308 ÷ 0027 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 231A ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0308 ÷ 231A ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0020 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0308 ÷ 0020 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 00AD ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0308 × 00AD ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0300 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0308 × 0300 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 200D ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0308 × 200D ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0061 × 2060 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0308 ÷ 0061 × 2060 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0308 ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0308 ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0308 ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0308 ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0308 ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0308 ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0308 ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0308 ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0001 ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0308 ÷ 0001 ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 000D ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0308 ÷ 000D ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 000A ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0308 ÷ 000A ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 000B ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0308 ÷ 000B ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 3031 ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0308 ÷ 3031 ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0041 ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0308 ÷ 0041 ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 003A ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0308 ÷ 003A ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 002C ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0308 ÷ 002C ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 002E ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0308 ÷ 002E ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0030 ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0308 ÷ 0030 ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 005F ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0308 ÷ 005F ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 1F1E6 ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 05D0 ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0308 ÷ 05D0 ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0022 ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0308 ÷ 0022 ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0027 ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0308 ÷ 0027 ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 231A ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0308 ÷ 231A ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0020 ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0308 ÷ 0020 ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 00AD ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0308 × 00AD ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0300 ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0308 × 0300 ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 200D ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0308 × 200D ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0061 × 2060 ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0308 ÷ 0061 × 2060 ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0308 ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0308 ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0308 ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0308 ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0308 ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0308 ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0308 ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0308 ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 3031 ÷ 0001 ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 3031 × 0308 ÷ 0001 ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 3031 ÷ 000D ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 3031 × 0308 ÷ 000D ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 3031 ÷ 000A ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 3031 × 0308 ÷ 000A ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 3031 ÷ 000B ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 3031 × 0308 ÷ 000B ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 3031 × 3031 ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [13.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 3031 × 0308 × 3031 ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [4.0] COMBINING DIAERESIS (Extend_FE) × [13.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 3031 ÷ 0041 ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 3031 × 0308 ÷ 0041 ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 3031 ÷ 003A ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 3031 × 0308 ÷ 003A ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 3031 ÷ 002C ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 3031 × 0308 ÷ 002C ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 3031 ÷ 002E ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 3031 × 0308 ÷ 002E ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 3031 ÷ 0030 ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 3031 × 0308 ÷ 0030 ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 3031 × 005F ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [13.1] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 3031 × 0308 × 005F ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [4.0] COMBINING DIAERESIS (Extend_FE) × [13.1] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 3031 ÷ 1F1E6 ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 3031 × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 3031 ÷ 05D0 ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 3031 × 0308 ÷ 05D0 ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 3031 ÷ 0022 ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 3031 × 0308 ÷ 0022 ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 3031 ÷ 0027 ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 3031 × 0308 ÷ 0027 ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 3031 ÷ 231A ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 3031 × 0308 ÷ 231A ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 3031 ÷ 0020 ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 3031 × 0308 ÷ 0020 ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 3031 × 00AD ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 3031 × 0308 × 00AD ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 3031 × 0300 ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 3031 × 0308 × 0300 ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 3031 × 200D ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 3031 × 0308 × 200D ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 3031 ÷ 0061 × 2060 ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 3031 × 0308 ÷ 0061 × 2060 ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 3031 ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 3031 × 0308 ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 3031 ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 3031 × 0308 ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 3031 ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 3031 × 0308 ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 3031 ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 3031 × 0308 ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 3031 ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 3031 × 0308 ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 3031 ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 3031 × 0308 ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 3031 ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 3031 × 0308 ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 3031 ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 3031 × 0308 ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0041 ÷ 0001 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 0041 × 0308 ÷ 0001 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 0041 ÷ 000D ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 0041 × 0308 ÷ 000D ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 0041 ÷ 000A ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 0041 × 0308 ÷ 000A ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 0041 ÷ 000B ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 0041 × 0308 ÷ 000B ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 0041 ÷ 3031 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 0041 × 0308 ÷ 3031 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 0041 × 0041 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [5.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0041 × 0308 × 0041 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [5.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0041 ÷ 003A ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0041 × 0308 ÷ 003A ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0041 ÷ 002C ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0041 × 0308 ÷ 002C ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0041 ÷ 002E ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 0041 × 0308 ÷ 002E ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 0041 × 0030 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [9.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 0041 × 0308 × 0030 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [9.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 0041 × 005F ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 0041 × 0308 × 005F ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [13.1] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 0041 ÷ 1F1E6 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 0041 × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 0041 × 05D0 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [5.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 0041 × 0308 × 05D0 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [5.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 0041 ÷ 0022 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 0041 × 0308 ÷ 0022 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 0041 ÷ 0027 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0041 × 0308 ÷ 0027 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0041 ÷ 231A ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 0041 × 0308 ÷ 231A ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 0041 ÷ 0020 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 0041 × 0308 ÷ 0020 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 0041 × 00AD ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0041 × 0308 × 00AD ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0041 × 0300 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0041 × 0308 × 0300 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0041 × 200D ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 0041 × 0308 × 200D ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 0041 × 0061 × 2060 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [5.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0041 × 0308 × 0061 × 2060 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [5.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0041 × 0061 ÷ 003A ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [5.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0041 × 0308 × 0061 ÷ 003A ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [5.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0041 × 0061 ÷ 0027 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [5.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0041 × 0308 × 0061 ÷ 0027 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [5.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0041 × 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [5.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0041 × 0308 × 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [5.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0041 × 0061 ÷ 002C ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [5.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0041 × 0308 × 0061 ÷ 002C ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [5.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0041 × 0031 ÷ 003A ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [9.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0041 × 0308 × 0031 ÷ 003A ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [9.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0041 × 0031 ÷ 0027 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [9.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0041 × 0308 × 0031 ÷ 0027 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [9.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0041 × 0031 ÷ 002C ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [9.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0041 × 0308 × 0031 ÷ 002C ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [9.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0041 × 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [9.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0041 × 0308 × 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [9.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 003A ÷ 0001 ÷	#  ÷ [0.2] COLON (MidLetter) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 003A × 0308 ÷ 0001 ÷	#  ÷ [0.2] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 003A ÷ 000D ÷	#  ÷ [0.2] COLON (MidLetter) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 003A × 0308 ÷ 000D ÷	#  ÷ [0.2] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 003A ÷ 000A ÷	#  ÷ [0.2] COLON (MidLetter) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 003A × 0308 ÷ 000A ÷	#  ÷ [0.2] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 003A ÷ 000B ÷	#  ÷ [0.2] COLON (MidLetter) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 003A × 0308 ÷ 000B ÷	#  ÷ [0.2] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 003A ÷ 3031 ÷	#  ÷ [0.2] COLON (MidLetter) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 003A × 0308 ÷ 3031 ÷	#  ÷ [0.2] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 003A ÷ 0041 ÷	#  ÷ [0.2] COLON (MidLetter) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 003A × 0308 ÷ 0041 ÷	#  ÷ [0.2] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 003A ÷ 003A ÷	#  ÷ [0.2] COLON (MidLetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 003A × 0308 ÷ 003A ÷	#  ÷ [0.2] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 003A ÷ 002C ÷	#  ÷ [0.2] COLON (MidLetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 003A × 0308 ÷ 002C ÷	#  ÷ [0.2] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 003A ÷ 002E ÷	#  ÷ [0.2] COLON (MidLetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 003A × 0308 ÷ 002E ÷	#  ÷ [0.2] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 003A ÷ 0030 ÷	#  ÷ [0.2] COLON (MidLetter) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 003A × 0308 ÷ 0030 ÷	#  ÷ [0.2] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 003A ÷ 005F ÷	#  ÷ [0.2] COLON (MidLetter) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 003A × 0308 ÷ 005F ÷	#  ÷ [0.2] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 003A ÷ 1F1E6 ÷	#  ÷ [0.2] COLON (MidLetter) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 003A × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 003A ÷ 05D0 ÷	#  ÷ [0.2] COLON (MidLetter) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 003A × 0308 ÷ 05D0 ÷	#  ÷ [0.2] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 003A ÷ 0022 ÷	#  ÷ [0.2] COLON (MidLetter) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 003A × 0308 ÷ 0022 ÷	#  ÷ [0.2] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 003A ÷ 0027 ÷	#  ÷ [0.2] COLON (MidLetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 003A × 0308 ÷ 0027 ÷	#  ÷ [0.2] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 003A ÷ 231A ÷	#  ÷ [0.2] COLON (MidLetter) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 003A × 0308 ÷ 231A ÷	#  ÷ [0.2] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 003A ÷ 0020 ÷	#  ÷ [0.2] COLON (MidLetter) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 003A × 0308 ÷ 0020 ÷	#  ÷ [0.2] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 003A × 00AD ÷	#  ÷ [0.2] COLON (MidLetter) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 003A × 0308 × 00AD ÷	#  ÷ [0.2] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 003A × 0300 ÷	#  ÷ [0.2] COLON (MidLetter) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 003A × 0308 × 0300 ÷	#  ÷ [0.2] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 003A × 200D ÷	#  ÷ [0.2] COLON (MidLetter) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 003A × 0308 × 200D ÷	#  ÷ [0.2] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 003A ÷ 0061 × 2060 ÷	#  ÷ [0.2] COLON (MidLetter) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 003A × 0308 ÷ 0061 × 2060 ÷	#  ÷ [0.2] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 003A ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] COLON (MidLetter) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 003A × 0308 ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 003A ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] COLON (MidLetter) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 003A × 0308 ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 003A ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] COLON (MidLetter) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 003A × 0308 ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 003A ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] COLON (MidLetter) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 003A × 0308 ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 003A ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] COLON (MidLetter) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 003A × 0308 ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 003A ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] COLON (MidLetter) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 003A × 0308 ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 003A ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] COLON (MidLetter) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 003A × 0308 ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 003A ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] COLON (MidLetter) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 003A × 0308 ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 002C ÷ 0001 ÷	#  ÷ [0.2] COMMA (MidNum) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 002C × 0308 ÷ 0001 ÷	#  ÷ [0.2] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 002C ÷ 000D ÷	#  ÷ [0.2] COMMA (MidNum) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 002C × 0308 ÷ 000D ÷	#  ÷ [0.2] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 002C ÷ 000A ÷	#  ÷ [0.2] COMMA (MidNum) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 002C × 0308 ÷ 000A ÷	#  ÷ [0.2] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 002C ÷ 000B ÷	#  ÷ [0.2] COMMA (MidNum) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 002C × 0308 ÷ 000B ÷	#  ÷ [0.2] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 002C ÷ 3031 ÷	#  ÷ [0.2] COMMA (MidNum) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 002C × 0308 ÷ 3031 ÷	#  ÷ [0.2] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 002C ÷ 0041 ÷	#  ÷ [0.2] COMMA (MidNum) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 002C × 0308 ÷ 0041 ÷	#  ÷ [0.2] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 002C ÷ 003A ÷	#  ÷ [0.2] COMMA (MidNum) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 002C × 0308 ÷ 003A ÷	#  ÷ [0.2] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 002C ÷ 002C ÷	#  ÷ [0.2] COMMA (MidNum) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 002C × 0308 ÷ 002C ÷	#  ÷ [0.2] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 002C ÷ 002E ÷	#  ÷ [0.2] COMMA (MidNum) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 002C × 0308 ÷ 002E ÷	#  ÷ [0.2] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 002C ÷ 0030 ÷	#  ÷ [0.2] COMMA (MidNum) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 002C × 0308 ÷ 0030 ÷	#  ÷ [0.2] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 002C ÷ 005F ÷	#  ÷ [0.2] COMMA (MidNum) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 002C × 0308 ÷ 005F ÷	#  ÷ [0.2] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 002C ÷ 1F1E6 ÷	#  ÷ [0.2] COMMA (MidNum) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 002C × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 002C ÷ 05D0 ÷	#  ÷ [0.2] COMMA (MidNum) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 002C × 0308 ÷ 05D0 ÷	#  ÷ [0.2] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 002C ÷ 0022 ÷	#  ÷ [0.2] COMMA (MidNum) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 002C × 0308 ÷ 0022 ÷	#  ÷ [0.2] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 002C ÷ 0027 ÷	#  ÷ [0.2] COMMA (MidNum) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 002C × 0308 ÷ 0027 ÷	#  ÷ [0.2] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 002C ÷ 231A ÷	#  ÷ [0.2] COMMA (MidNum) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 002C × 0308 ÷ 231A ÷	#  ÷ [0.2] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 002C ÷ 0020 ÷	#  ÷ [0.2] COMMA (MidNum) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 002C × 0308 ÷ 0020 ÷	#  ÷ [0.2] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 002C × 00AD ÷	#  ÷ [0.2] COMMA (MidNum) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 002C × 0308 × 00AD ÷	#  ÷ [0.2] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 002C × 0300 ÷	#  ÷ [0.2] COMMA (MidNum) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 002C × 0308 × 0300 ÷	#  ÷ [0.2] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 002C × 200D ÷	#  ÷ [0.2] COMMA (MidNum) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 002C × 0308 × 200D ÷	#  ÷ [0.2] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 002C ÷ 0061 × 2060 ÷	#  ÷ [0.2] COMMA (MidNum) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 002C × 0308 ÷ 0061 × 2060 ÷	#  ÷ [0.2] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 002C ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] COMMA (MidNum) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 002C × 0308 ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 002C ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] COMMA (MidNum) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 002C × 0308 ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 002C ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] COMMA (MidNum) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 002C × 0308 ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 002C ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] COMMA (MidNum) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 002C × 0308 ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 002C ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] COMMA (MidNum) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 002C × 0308 ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 002C ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] COMMA (MidNum) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 002C × 0308 ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 002C ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] COMMA (MidNum) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 002C × 0308 ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 002C ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] COMMA (MidNum) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 002C × 0308 ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 002E ÷ 0001 ÷	#  ÷ [0.2] FULL STOP (MidNumLet) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 002E × 0308 ÷ 0001 ÷	#  ÷ [0.2] FULL STOP (MidNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 002E ÷ 000D ÷	#  ÷ [0.2] FULL STOP (MidNumLet) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 002E × 0308 ÷ 000D ÷	#  ÷ [0.2] FULL STOP (MidNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 002E ÷ 000A ÷	#  ÷ [0.2] FULL STOP (MidNumLet) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 002E × 0308 ÷ 000A ÷	#  ÷ [0.2] FULL STOP (MidNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 002E ÷ 000B ÷	#  ÷ [0.2] FULL STOP (MidNumLet) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 002E × 0308 ÷ 000B ÷	#  ÷ [0.2] FULL STOP (MidNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 002E ÷ 3031 ÷	#  ÷ [0.2] FULL STOP (MidNumLet) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 002E × 0308 ÷ 3031 ÷	#  ÷ [0.2] FULL STOP (MidNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 002E ÷ 0041 ÷	#  ÷ [0.2] FULL STOP (MidNumLet) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 002E × 0308 ÷ 0041 ÷	#  ÷ [0.2] FULL STOP (MidNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 002E ÷ 003A ÷	#  ÷ [0.2] FULL STOP (MidNumLet) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 002E × 0308 ÷ 003A ÷	#  ÷ [0.2] FULL STOP (MidNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 002E ÷ 002C ÷	#  ÷ [0.2] FULL STOP (MidNumLet) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 002E × 0308 ÷ 002C ÷	#  ÷ [0.2] FULL STOP (MidNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 002E ÷ 002E ÷	#  ÷ [0.2] FULL STOP (MidNumLet) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 002E × 0308 ÷ 002E ÷	#  ÷ [0.2] FULL STOP (MidNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 002E ÷ 0030 ÷	#  ÷ [0.2] FULL STOP (MidNumLet) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 002E × 0308 ÷ 0030 ÷	#  ÷ [0.2] FULL STOP (MidNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 002E ÷ 005F ÷	#  ÷ [0.2] FULL STOP (MidNumLet) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 002E × 0308 ÷ 005F ÷	#  ÷ [0.2] FULL STOP (MidNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 002E ÷ 1F1E6 ÷	#  ÷ [0.2] FULL STOP (MidNumLet) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 002E × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] FULL STOP (MidNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 002E ÷ 05D0 ÷	#  ÷ [0.2] FULL STOP (MidNumLet) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 002E × 0308 ÷ 05D0 ÷	#  ÷ [0.2] FULL STOP (MidNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 002E ÷ 0022 ÷	#  ÷ [0.2] FULL STOP (MidNumLet) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 002E × 0308 ÷ 0022 ÷	#  ÷ [0.2] FULL STOP (MidNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 002E ÷ 0027 ÷	#  ÷ [0.2] FULL STOP (MidNumLet) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 002E × 0308 ÷ 0027 ÷	#  ÷ [0.2] FULL STOP (MidNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 002E ÷ 231A ÷	#  ÷ [0.2] FULL STOP (MidNumLet) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 002E × 0308 ÷ 231A ÷	#  ÷ [0.2] FULL STOP (MidNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 002E ÷ 0020 ÷	#  ÷ [0.2] FULL STOP (MidNumLet) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 002E × 0308 ÷ 0020 ÷	#  ÷ [0.2] FULL STOP (MidNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 002E × 00AD ÷	#  ÷ [0.2] FULL STOP (MidNumLet) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 002E × 0308 × 00AD ÷	#  ÷ [0.2] FULL STOP (MidNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 002E × 0300 ÷	#  ÷ [0.2] FULL STOP (MidNumLet) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 002E × 0308 × 0300 ÷	#  ÷ [0.2] FULL STOP (MidNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 002E × 200D ÷	#  ÷ [0.2] FULL STOP (MidNumLet) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 002E × 0308 × 200D ÷	#  ÷ [0.2] FULL STOP (MidNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 002E ÷ 0061 × 2060 ÷	#  ÷ [0.2] FULL STOP (MidNumLet) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 002E × 0308 ÷ 0061 × 2060 ÷	#  ÷ [0.2] FULL STOP (MidNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 002E ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] FULL STOP (MidNumLet) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 002E × 0308 ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] FULL STOP (MidNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 002E ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] FULL STOP (MidNumLet) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 002E × 0308 ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] FULL STOP (MidNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 002E ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] FULL STOP (MidNumLet) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 002E × 0308 ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] FULL STOP (MidNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 002E ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] FULL STOP (MidNumLet) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 002E × 0308 ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] FULL STOP (MidNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 002E ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] FULL STOP (MidNumLet) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 002E × 0308 ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] FULL STOP (MidNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 002E ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] FULL STOP (MidNumLet) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 002E × 0308 ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] FULL STOP (MidNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 002E ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] FULL STOP (MidNumLet) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 002E × 0308 ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] FULL STOP (MidNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 002E ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] FULL STOP (MidNumLet) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 002E × 0308 ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] FULL STOP (MidNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0030 ÷ 0001 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 0030 × 0308 ÷ 0001 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 0030 ÷ 000D ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 0030 × 0308 ÷ 000D ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 0030 ÷ 000A ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 0030 × 0308 ÷ 000A ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 0030 ÷ 000B ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 0030 × 0308 ÷ 000B ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 0030 ÷ 3031 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 0030 × 0308 ÷ 3031 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 0030 × 0041 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [10.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0030 × 0308 × 0041 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [4.0] COMBINING DIAERESIS (Extend_FE) × [10.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0030 ÷ 003A ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0030 × 0308 ÷ 003A ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0030 ÷ 002C ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0030 × 0308 ÷ 002C ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0030 ÷ 002E ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 0030 × 0308 ÷ 002E ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 0030 × 0030 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [8.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 0030 × 0308 × 0030 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [4.0] COMBINING DIAERESIS (Extend_FE) × [8.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 0030 × 005F ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [13.1] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 0030 × 0308 × 005F ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [4.0] COMBINING DIAERESIS (Extend_FE) × [13.1] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 0030 ÷ 1F1E6 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 0030 × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 0030 × 05D0 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [10.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 0030 × 0308 × 05D0 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [4.0] COMBINING DIAERESIS (Extend_FE) × [10.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 0030 ÷ 0022 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 0030 × 0308 ÷ 0022 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 0030 ÷ 0027 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0030 × 0308 ÷ 0027 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0030 ÷ 231A ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 0030 × 0308 ÷ 231A ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 0030 ÷ 0020 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 0030 × 0308 ÷ 0020 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 0030 × 00AD ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0030 × 0308 × 00AD ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0030 × 0300 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0030 × 0308 × 0300 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0030 × 200D ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 0030 × 0308 × 200D ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 0030 × 0061 × 2060 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [10.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0030 × 0308 × 0061 × 2060 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [4.0] COMBINING DIAERESIS (Extend_FE) × [10.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0030 × 0061 ÷ 003A ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [10.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0030 × 0308 × 0061 ÷ 003A ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [4.0] COMBINING DIAERESIS (Extend_FE) × [10.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0030 × 0061 ÷ 0027 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [10.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0030 × 0308 × 0061 ÷ 0027 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [4.0] COMBINING DIAERESIS (Extend_FE) × [10.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0030 × 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [10.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0030 × 0308 × 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [4.0] COMBINING DIAERESIS (Extend_FE) × [10.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0030 × 0061 ÷ 002C ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [10.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0030 × 0308 × 0061 ÷ 002C ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [4.0] COMBINING DIAERESIS (Extend_FE) × [10.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0030 × 0031 ÷ 003A ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [8.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0030 × 0308 × 0031 ÷ 003A ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [4.0] COMBINING DIAERESIS (Extend_FE) × [8.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0030 × 0031 ÷ 0027 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [8.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0030 × 0308 × 0031 ÷ 0027 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [4.0] COMBINING DIAERESIS (Extend_FE) × [8.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0030 × 0031 ÷ 002C ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [8.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0030 × 0308 × 0031 ÷ 002C ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [4.0] COMBINING DIAERESIS (Extend_FE) × [8.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0030 × 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [8.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0030 × 0308 × 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [4.0] COMBINING DIAERESIS (Extend_FE) × [8.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 005F ÷ 0001 ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 005F × 0308 ÷ 0001 ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 005F ÷ 000D ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 005F × 0308 ÷ 000D ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 005F ÷ 000A ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 005F × 0308 ÷ 000A ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 005F ÷ 000B ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 005F × 0308 ÷ 000B ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 005F × 3031 ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [13.2] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 005F × 0308 × 3031 ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) × [13.2] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 005F × 0041 ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [13.2] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 005F × 0308 × 0041 ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) × [13.2] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 005F ÷ 003A ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 005F × 0308 ÷ 003A ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 005F ÷ 002C ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 005F × 0308 ÷ 002C ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 005F ÷ 002E ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 005F × 0308 ÷ 002E ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 005F × 0030 ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [13.2] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 005F × 0308 × 0030 ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) × [13.2] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 005F × 005F ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [13.1] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 005F × 0308 × 005F ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) × [13.1] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 005F ÷ 1F1E6 ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 005F × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 005F × 05D0 ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [13.2] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 005F × 0308 × 05D0 ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) × [13.2] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 005F ÷ 0022 ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 005F × 0308 ÷ 0022 ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 005F ÷ 0027 ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 005F × 0308 ÷ 0027 ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 005F ÷ 231A ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 005F × 0308 ÷ 231A ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 005F ÷ 0020 ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 005F × 0308 ÷ 0020 ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 005F × 00AD ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 005F × 0308 × 00AD ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 005F × 0300 ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 005F × 0308 × 0300 ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 005F × 200D ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 005F × 0308 × 200D ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 005F × 0061 × 2060 ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 005F × 0308 × 0061 × 2060 ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) × [13.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 005F × 0061 ÷ 003A ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 005F × 0308 × 0061 ÷ 003A ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 005F × 0061 ÷ 0027 ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 005F × 0308 × 0061 ÷ 0027 ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 005F × 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 005F × 0308 × 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 005F × 0061 ÷ 002C ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 005F × 0308 × 0061 ÷ 002C ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 005F × 0031 ÷ 003A ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 005F × 0308 × 0031 ÷ 003A ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 005F × 0031 ÷ 0027 ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 005F × 0308 × 0031 ÷ 0027 ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 005F × 0031 ÷ 002C ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 005F × 0308 × 0031 ÷ 002C ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 005F × 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 005F × 0308 × 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 1F1E6 ÷ 0001 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 0308 ÷ 0001 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 1F1E6 ÷ 000D ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 0308 ÷ 000D ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 1F1E6 ÷ 000A ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 0308 ÷ 000A ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 1F1E6 ÷ 000B ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 0308 ÷ 000B ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 1F1E6 ÷ 3031 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 0308 ÷ 3031 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 1F1E6 ÷ 0041 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 0308 ÷ 0041 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 1F1E6 ÷ 003A ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 0308 ÷ 003A ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 1F1E6 ÷ 002C ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 0308 ÷ 002C ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 1F1E6 ÷ 002E ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 0308 ÷ 002E ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 1F1E6 ÷ 0030 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 0308 ÷ 0030 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 1F1E6 ÷ 005F ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 0308 ÷ 005F ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 1F1E6 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [15.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 0308 × 1F1E6 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] COMBINING DIAERESIS (Extend_FE) × [15.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 1F1E6 ÷ 05D0 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 0308 ÷ 05D0 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 1F1E6 ÷ 0022 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 0308 ÷ 0022 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 1F1E6 ÷ 0027 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 0308 ÷ 0027 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 1F1E6 ÷ 231A ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 0308 ÷ 231A ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 1F1E6 ÷ 0020 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 0308 ÷ 0020 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 00AD ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 0308 × 00AD ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 0300 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 0308 × 0300 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 200D ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 0308 × 200D ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 1F1E6 ÷ 0061 × 2060 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 0308 ÷ 0061 × 2060 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 1F1E6 ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 0308 ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 1F1E6 ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 0308 ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 1F1E6 ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 0308 ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 1F1E6 ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 0308 ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 1F1E6 ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 0308 ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 1F1E6 ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 0308 ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 1F1E6 ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 0308 ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 1F1E6 ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 0308 ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 05D0 ÷ 0001 ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0308 ÷ 0001 ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 05D0 ÷ 000D ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0308 ÷ 000D ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 05D0 ÷ 000A ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0308 ÷ 000A ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 05D0 ÷ 000B ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0308 ÷ 000B ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 05D0 ÷ 3031 ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0308 ÷ 3031 ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0041 ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [5.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0308 × 0041 ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [5.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 05D0 ÷ 003A ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0308 ÷ 003A ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 05D0 ÷ 002C ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0308 ÷ 002C ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 05D0 ÷ 002E ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0308 ÷ 002E ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0030 ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [9.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0308 × 0030 ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [9.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 05D0 × 005F ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [13.1] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0308 × 005F ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [13.1] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 05D0 ÷ 1F1E6 ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 05D0 × 05D0 ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [5.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0308 × 05D0 ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [5.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 05D0 ÷ 0022 ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0308 ÷ 0022 ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0027 ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [7.1] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0308 × 0027 ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [7.1] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 05D0 ÷ 231A ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0308 ÷ 231A ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 05D0 ÷ 0020 ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0308 ÷ 0020 ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 05D0 × 00AD ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0308 × 00AD ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0300 ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0308 × 0300 ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 05D0 × 200D ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0308 × 200D ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0061 × 2060 ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [5.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0308 × 0061 × 2060 ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [5.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0061 ÷ 003A ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [5.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0308 × 0061 ÷ 003A ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [5.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0061 ÷ 0027 ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [5.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0308 × 0061 ÷ 0027 ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [5.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [5.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0308 × 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [5.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0061 ÷ 002C ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [5.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0308 × 0061 ÷ 002C ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [5.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0031 ÷ 003A ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [9.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0308 × 0031 ÷ 003A ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [9.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0031 ÷ 0027 ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [9.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0308 × 0031 ÷ 0027 ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [9.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0031 ÷ 002C ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [9.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0308 × 0031 ÷ 002C ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [9.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [9.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0308 × 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [9.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0022 ÷ 0001 ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 0022 × 0308 ÷ 0001 ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 0022 ÷ 000D ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 0022 × 0308 ÷ 000D ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 0022 ÷ 000A ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 0022 × 0308 ÷ 000A ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 0022 ÷ 000B ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 0022 × 0308 ÷ 000B ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 0022 ÷ 3031 ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 0022 × 0308 ÷ 3031 ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 0022 ÷ 0041 ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0022 × 0308 ÷ 0041 ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0022 ÷ 003A ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0022 × 0308 ÷ 003A ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0022 ÷ 002C ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0022 × 0308 ÷ 002C ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0022 ÷ 002E ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 0022 × 0308 ÷ 002E ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 0022 ÷ 0030 ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 0022 × 0308 ÷ 0030 ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 0022 ÷ 005F ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 0022 × 0308 ÷ 005F ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 0022 ÷ 1F1E6 ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 0022 × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 0022 ÷ 05D0 ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 0022 × 0308 ÷ 05D0 ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 0022 ÷ 0022 ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 0022 × 0308 ÷ 0022 ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 0022 ÷ 0027 ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0022 × 0308 ÷ 0027 ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0022 ÷ 231A ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 0022 × 0308 ÷ 231A ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 0022 ÷ 0020 ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 0022 × 0308 ÷ 0020 ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 0022 × 00AD ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0022 × 0308 × 00AD ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0022 × 0300 ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0022 × 0308 × 0300 ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0022 × 200D ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 0022 × 0308 × 200D ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 0022 ÷ 0061 × 2060 ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0022 × 0308 ÷ 0061 × 2060 ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0022 ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0022 × 0308 ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0022 ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0022 × 0308 ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0022 ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0022 × 0308 ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0022 ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0022 × 0308 ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0022 ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0022 × 0308 ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0022 ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0022 × 0308 ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0022 ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0022 × 0308 ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0022 ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0022 × 0308 ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0027 ÷ 0001 ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 0027 × 0308 ÷ 0001 ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 0027 ÷ 000D ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 0027 × 0308 ÷ 000D ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 0027 ÷ 000A ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 0027 × 0308 ÷ 000A ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 0027 ÷ 000B ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 0027 × 0308 ÷ 000B ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 0027 ÷ 3031 ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 0027 × 0308 ÷ 3031 ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 0027 ÷ 0041 ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0027 × 0308 ÷ 0041 ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0027 ÷ 003A ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0027 × 0308 ÷ 003A ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0027 ÷ 002C ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0027 × 0308 ÷ 002C ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0027 ÷ 002E ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 0027 × 0308 ÷ 002E ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 0027 ÷ 0030 ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 0027 × 0308 ÷ 0030 ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 0027 ÷ 005F ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 0027 × 0308 ÷ 005F ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 0027 ÷ 1F1E6 ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 0027 × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 0027 ÷ 05D0 ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 0027 × 0308 ÷ 05D0 ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 0027 ÷ 0022 ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 0027 × 0308 ÷ 0022 ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 0027 ÷ 0027 ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0027 × 0308 ÷ 0027 ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0027 ÷ 231A ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 0027 × 0308 ÷ 231A ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 0027 ÷ 0020 ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 0027 × 0308 ÷ 0020 ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 0027 × 00AD ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0027 × 0308 × 00AD ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0027 × 0300 ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0027 × 0308 × 0300 ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0027 × 200D ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 0027 × 0308 × 200D ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 0027 ÷ 0061 × 2060 ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0027 × 0308 ÷ 0061 × 2060 ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0027 ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0027 × 0308 ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0027 ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0027 × 0308 ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0027 ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0027 × 0308 ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0027 ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0027 × 0308 ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0027 ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0027 × 0308 ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0027 ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0027 × 0308 ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0027 ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0027 × 0308 ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0027 ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0027 × 0308 ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 231A ÷ 0001 ÷	#  ÷ [0.2] WATCH (ExtPict) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 231A × 0308 ÷ 0001 ÷	#  ÷ [0.2] WATCH (ExtPict) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 231A ÷ 000D ÷	#  ÷ [0.2] WATCH (ExtPict) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 231A × 0308 ÷ 000D ÷	#  ÷ [0.2] WATCH (ExtPict) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 231A ÷ 000A ÷	#  ÷ [0.2] WATCH (ExtPict) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 231A × 0308 ÷ 000A ÷	#  ÷ [0.2] WATCH (ExtPict) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 231A ÷ 000B ÷	#  ÷ [0.2] WATCH (ExtPict) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 231A × 0308 ÷ 000B ÷	#  ÷ [0.2] WATCH (ExtPict) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 231A ÷ 3031 ÷	#  ÷ [0.2] WATCH (ExtPict) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 231A × 0308 ÷ 3031 ÷	#  ÷ [0.2] WATCH (ExtPict) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 231A ÷ 0041 ÷	#  ÷ [0.2] WATCH (ExtPict) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 231A × 0308 ÷ 0041 ÷	#  ÷ [0.2] WATCH (ExtPict) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 231A ÷ 003A ÷	#  ÷ [0.2] WATCH (ExtPict) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 231A × 0308 ÷ 003A ÷	#  ÷ [0.2] WATCH (ExtPict) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 231A ÷ 002C ÷	#  ÷ [0.2] WATCH (ExtPict) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 231A × 0308 ÷ 002C ÷	#  ÷ [0.2] WATCH (ExtPict) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 231A ÷ 002E ÷	#  ÷ [0.2] WATCH (ExtPict) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 231A × 0308 ÷ 002E ÷	#  ÷ [0.2] WATCH (ExtPict) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 231A ÷ 0030 ÷	#  ÷ [0.2] WATCH (ExtPict) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 231A × 0308 ÷ 0030 ÷	#  ÷ [0.2] WATCH (ExtPict) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 231A ÷ 005F ÷	#  ÷ [0.2] WATCH (ExtPict) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 231A × 0308 ÷ 005F ÷	#  ÷ [0.2] WATCH (ExtPict) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 231A ÷ 1F1E6 ÷	#  ÷ [0.2] WATCH (ExtPict) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 231A × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] WATCH (ExtPict) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 231A ÷ 05D0 ÷	#  ÷ [0.2] WATCH (ExtPict) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 231A × 0308 ÷ 05D0 ÷	#  ÷ [0.2] WATCH (ExtPict) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 231A ÷ 0022 ÷	#  ÷ [0.2] WATCH (ExtPict) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 231A × 0308 ÷ 0022 ÷	#  ÷ [0.2] WATCH (ExtPict) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 231A ÷ 0027 ÷	#  ÷ [0.2] WATCH (ExtPict) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 231A × 0308 ÷ 0027 ÷	#  ÷ [0.2] WATCH (ExtPict) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 231A ÷ 231A ÷	#  ÷ [0.2] WATCH (ExtPict) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 231A × 0308 ÷ 231A ÷	#  ÷ [0.2] WATCH (ExtPict) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 231A ÷ 0020 ÷	#  ÷ [0.2] WATCH (ExtPict) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 231A × 0308 ÷ 0020 ÷	#  ÷ [0.2] WATCH (ExtPict) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 231A × 00AD ÷	#  ÷ [0.2] WATCH (ExtPict) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 231A × 0308 × 00AD ÷	#  ÷ [0.2] WATCH (ExtPict) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 231A × 0300 ÷	#  ÷ [0.2] WATCH (ExtPict) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 231A × 0308 × 0300 ÷	#  ÷ [0.2] WATCH (ExtPict) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 231A × 200D ÷	#  ÷ [0.2] WATCH (ExtPict) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 231A × 0308 × 200D ÷	#  ÷ [0.2] WATCH (ExtPict) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 231A ÷ 0061 × 2060 ÷	#  ÷ [0.2] WATCH (ExtPict) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 231A × 0308 ÷ 0061 × 2060 ÷	#  ÷ [0.2] WATCH (ExtPict) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 231A ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] WATCH (ExtPict) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 231A × 0308 ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] WATCH (ExtPict) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 231A ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] WATCH (ExtPict) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 231A × 0308 ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] WATCH (ExtPict) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 231A ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] WATCH (ExtPict) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 231A × 0308 ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] WATCH (ExtPict) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 231A ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] WATCH (ExtPict) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 231A × 0308 ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] WATCH (ExtPict) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 231A ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] WATCH (ExtPict) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 231A × 0308 ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] WATCH (ExtPict) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 231A ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] WATCH (ExtPict) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 231A × 0308 ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] WATCH (ExtPict) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 231A ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] WATCH (ExtPict) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 231A × 0308 ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] WATCH (ExtPict) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 231A ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] WATCH (ExtPict) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 231A × 0308 ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] WATCH (ExtPict) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0020 ÷ 0001 ÷	#  ÷ [0.2] SPACE (WSegSpace) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 0020 × 0308 ÷ 0001 ÷	#  ÷ [0.2] SPACE (WSegSpace) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 0020 ÷ 000D ÷	#  ÷ [0.2] SPACE (WSegSpace) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 0020 × 0308 ÷ 000D ÷	#  ÷ [0.2] SPACE (WSegSpace) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 0020 ÷ 000A ÷	#  ÷ [0.2] SPACE (WSegSpace) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 0020 × 0308 ÷ 000A ÷	#  ÷ [0.2] SPACE (WSegSpace) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 0020 ÷ 000B ÷	#  ÷ [0.2] SPACE (WSegSpace) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 0020 × 0308 ÷ 000B ÷	#  ÷ [0.2] SPACE (WSegSpace) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 0020 ÷ 3031 ÷	#  ÷ [0.2] SPACE (WSegSpace) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 0020 × 0308 ÷ 3031 ÷	#  ÷ [0.2] SPACE (WSegSpace) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 0020 ÷ 0041 ÷	#  ÷ [0.2] SPACE (WSegSpace) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0020 × 0308 ÷ 0041 ÷	#  ÷ [0.2] SPACE (WSegSpace) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0020 ÷ 003A ÷	#  ÷ [0.2] SPACE (WSegSpace) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0020 × 0308 ÷ 003A ÷	#  ÷ [0.2] SPACE (WSegSpace) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0020 ÷ 002C ÷	#  ÷ [0.2] SPACE (WSegSpace) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0020 × 0308 ÷ 002C ÷	#  ÷ [0.2] SPACE (WSegSpace) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0020 ÷ 002E ÷	#  ÷ [0.2] SPACE (WSegSpace) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 0020 × 0308 ÷ 002E ÷	#  ÷ [0.2] SPACE (WSegSpace) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 0020 ÷ 0030 ÷	#  ÷ [0.2] SPACE (WSegSpace) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 0020 × 0308 ÷ 0030 ÷	#  ÷ [0.2] SPACE (WSegSpace) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 0020 ÷ 005F ÷	#  ÷ [0.2] SPACE (WSegSpace) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 0020 × 0308 ÷ 005F ÷	#  ÷ [0.2] SPACE (WSegSpace) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 0020 ÷ 1F1E6 ÷	#  ÷ [0.2] SPACE (WSegSpace) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 0020 × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] SPACE (WSegSpace) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 0020 ÷ 05D0 ÷	#  ÷ [0.2] SPACE (WSegSpace) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 0020 × 0308 ÷ 05D0 ÷	#  ÷ [0.2] SPACE (WSegSpace) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 0020 ÷ 0022 ÷	#  ÷ [0.2] SPACE (WSegSpace) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 0020 × 0308 ÷ 0022 ÷	#  ÷ [0.2] SPACE (WSegSpace) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 0020 ÷ 0027 ÷	#  ÷ [0.2] SPACE (WSegSpace) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0020 × 0308 ÷ 0027 ÷	#  ÷ [0.2] SPACE (WSegSpace) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0020 ÷ 231A ÷	#  ÷ [0.2] SPACE (WSegSpace) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 0020 × 0308 ÷ 231A ÷	#  ÷ [0.2] SPACE (WSegSpace) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 0020 × 0020 ÷	#  ÷ [0.2] SPACE (WSegSpace) × [3.4] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 0020 × 0308 ÷ 0020 ÷	#  ÷ [0.2] SPACE (WSegSpace) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 0020 × 00AD ÷	#  ÷ [0.2] SPACE (WSegSpace) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0020 × 0308 × 00AD ÷	#  ÷ [0.2] SPACE (WSegSpace) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0020 × 0300 ÷	#  ÷ [0.2] SPACE (WSegSpace) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0020 × 0308 × 0300 ÷	#  ÷ [0.2] SPACE (WSegSpace) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0020 × 200D ÷	#  ÷ [0.2] SPACE (WSegSpace) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 0020 × 0308 × 200D ÷	#  ÷ [0.2] SPACE (WSegSpace) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 0020 ÷ 0061 × 2060 ÷	#  ÷ [0.2] SPACE (WSegSpace) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0020 × 0308 ÷ 0061 × 2060 ÷	#  ÷ [0.2] SPACE (WSegSpace) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0020 ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] SPACE (WSegSpace) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0020 × 0308 ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] SPACE (WSegSpace) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0020 ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] SPACE (WSegSpace) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0020 × 0308 ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] SPACE (WSegSpace) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0020 ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] SPACE (WSegSpace) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0020 × 0308 ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] SPACE (WSegSpace) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0020 ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] SPACE (WSegSpace) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0020 × 0308 ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] SPACE (WSegSpace) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0020 ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] SPACE (WSegSpace) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0020 × 0308 ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] SPACE (WSegSpace) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0020 ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] SPACE (WSegSpace) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0020 × 0308 ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] SPACE (WSegSpace) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0020 ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] SPACE (WSegSpace) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0020 × 0308 ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] SPACE (WSegSpace) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0020 ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] SPACE (WSegSpace) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0020 × 0308 ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] SPACE (WSegSpace) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 00AD ÷ 0001 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 00AD × 0308 ÷ 0001 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 00AD ÷ 000D ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 00AD × 0308 ÷ 000D ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 00AD ÷ 000A ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 00AD × 0308 ÷ 000A ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 00AD ÷ 000B ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 00AD × 0308 ÷ 000B ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 00AD ÷ 3031 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 00AD × 0308 ÷ 3031 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 00AD ÷ 0041 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 00AD × 0308 ÷ 0041 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 00AD ÷ 003A ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 00AD × 0308 ÷ 003A ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 00AD ÷ 002C ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 00AD × 0308 ÷ 002C ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 00AD ÷ 002E ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 00AD × 0308 ÷ 002E ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 00AD ÷ 0030 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 00AD × 0308 ÷ 0030 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 00AD ÷ 005F ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 00AD × 0308 ÷ 005F ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 00AD ÷ 1F1E6 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 00AD × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 00AD ÷ 05D0 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 00AD × 0308 ÷ 05D0 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 00AD ÷ 0022 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 00AD × 0308 ÷ 0022 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 00AD ÷ 0027 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 00AD × 0308 ÷ 0027 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 00AD ÷ 231A ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 00AD × 0308 ÷ 231A ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 00AD ÷ 0020 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 00AD × 0308 ÷ 0020 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 00AD × 00AD ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 00AD × 0308 × 00AD ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 00AD × 0300 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 00AD × 0308 × 0300 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 00AD × 200D ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 00AD × 0308 × 200D ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 00AD ÷ 0061 × 2060 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 00AD × 0308 ÷ 0061 × 2060 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 00AD ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 00AD × 0308 ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 00AD ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 00AD × 0308 ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 00AD ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 00AD × 0308 ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 00AD ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 00AD × 0308 ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 00AD ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 00AD × 0308 ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 00AD ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 00AD × 0308 ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 00AD ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 00AD × 0308 ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 00AD ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 00AD × 0308 ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0300 ÷ 0001 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 0300 × 0308 ÷ 0001 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 0300 ÷ 000D ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 0300 × 0308 ÷ 000D ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 0300 ÷ 000A ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 0300 × 0308 ÷ 000A ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 0300 ÷ 000B ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 0300 × 0308 ÷ 000B ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 0300 ÷ 3031 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 0300 × 0308 ÷ 3031 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 0300 ÷ 0041 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0300 × 0308 ÷ 0041 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0300 ÷ 003A ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0300 × 0308 ÷ 003A ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0300 ÷ 002C ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0300 × 0308 ÷ 002C ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0300 ÷ 002E ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 0300 × 0308 ÷ 002E ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 0300 ÷ 0030 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 0300 × 0308 ÷ 0030 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 0300 ÷ 005F ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 0300 × 0308 ÷ 005F ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 0300 ÷ 1F1E6 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 0300 × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 0300 ÷ 05D0 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 0300 × 0308 ÷ 05D0 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 0300 ÷ 0022 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 0300 × 0308 ÷ 0022 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 0300 ÷ 0027 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0300 × 0308 ÷ 0027 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0300 ÷ 231A ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 0300 × 0308 ÷ 231A ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 0300 ÷ 0020 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 0300 × 0308 ÷ 0020 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 0300 × 00AD ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0300 × 0308 × 00AD ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0300 × 0300 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0300 × 0308 × 0300 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0300 × 200D ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 0300 × 0308 × 200D ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 0300 ÷ 0061 × 2060 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0300 × 0308 ÷ 0061 × 2060 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0300 ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0300 × 0308 ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0300 ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0300 × 0308 ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0300 ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0300 × 0308 ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0300 ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0300 × 0308 ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0300 ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0300 × 0308 ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0300 ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0300 × 0308 ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0300 ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0300 × 0308 ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0300 ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0300 × 0308 ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 200D ÷ 0001 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 200D × 0308 ÷ 0001 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 200D ÷ 000D ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 200D × 0308 ÷ 000D ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 200D ÷ 000A ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 200D × 0308 ÷ 000A ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 200D ÷ 000B ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 200D × 0308 ÷ 000B ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 200D ÷ 3031 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 200D × 0308 ÷ 3031 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 200D ÷ 0041 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 200D × 0308 ÷ 0041 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 200D ÷ 003A ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 200D × 0308 ÷ 003A ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 200D ÷ 002C ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 200D × 0308 ÷ 002C ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 200D ÷ 002E ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 200D × 0308 ÷ 002E ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 200D ÷ 0030 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 200D × 0308 ÷ 0030 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 200D ÷ 005F ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 200D × 0308 ÷ 005F ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 200D ÷ 1F1E6 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 200D × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 200D ÷ 05D0 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 200D × 0308 ÷ 05D0 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 200D ÷ 0022 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 200D × 0308 ÷ 0022 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 200D ÷ 0027 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 200D × 0308 ÷ 0027 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 200D × 231A ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [3.3] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 200D × 0308 ÷ 231A ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 200D ÷ 0020 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 200D × 0308 ÷ 0020 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 200D × 00AD ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 200D × 0308 × 00AD ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 200D × 0300 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 200D × 0308 × 0300 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 200D × 200D ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 200D × 0308 × 200D ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 200D ÷ 0061 × 2060 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 200D × 0308 ÷ 0061 × 2060 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 200D ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 200D × 0308 ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 200D ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 200D × 0308 ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 200D ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 200D × 0308 ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 200D ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 200D × 0308 ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 200D ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 200D × 0308 ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 200D ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 200D × 0308 ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 200D ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 200D × 0308 ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 200D ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 200D × 0308 ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 ÷ 0001 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0308 ÷ 0001 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 ÷ 000D ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0308 ÷ 000D ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 ÷ 000A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0308 ÷ 000A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 ÷ 000B ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0308 ÷ 000B ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 ÷ 3031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0308 ÷ 3031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0041 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [5.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0308 × 0041 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [5.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 ÷ 003A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0308 ÷ 003A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 ÷ 002C ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0308 ÷ 002C ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 ÷ 002E ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0308 ÷ 002E ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0030 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [9.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0308 × 0030 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [9.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 005F ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [13.1] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0308 × 005F ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [13.1] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 ÷ 1F1E6 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 05D0 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [5.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0308 × 05D0 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [5.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 ÷ 0022 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0308 ÷ 0022 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 ÷ 0027 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0308 ÷ 0027 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 ÷ 231A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0308 ÷ 231A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 ÷ 0020 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0308 ÷ 0020 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 00AD ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0308 × 00AD ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0300 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0308 × 0300 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 200D ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0308 × 200D ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0061 × 2060 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [5.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0308 × 0061 × 2060 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [5.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0061 ÷ 003A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [5.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0308 × 0061 ÷ 003A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [5.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0061 ÷ 0027 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [5.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0308 × 0061 ÷ 0027 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [5.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [5.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0308 × 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [5.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0061 ÷ 002C ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [5.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0308 × 0061 ÷ 002C ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [5.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0031 ÷ 003A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [9.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0308 × 0031 ÷ 003A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [9.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0031 ÷ 0027 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [9.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0308 × 0031 ÷ 0027 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [9.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0031 ÷ 002C ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [9.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0308 × 0031 ÷ 002C ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [9.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [9.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0308 × 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [9.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A ÷ 0001 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A × 0308 ÷ 0001 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A ÷ 000D ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A × 0308 ÷ 000D ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A ÷ 000A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A × 0308 ÷ 000A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A ÷ 000B ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A × 0308 ÷ 000B ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A ÷ 3031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A × 0308 ÷ 3031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 0061 × 003A × 0041 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] COLON (MidLetter) × [7.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 003A × 0308 × 0041 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [7.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A ÷ 003A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A × 0308 ÷ 003A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A ÷ 002C ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A × 0308 ÷ 002C ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A ÷ 002E ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A × 0308 ÷ 002E ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A ÷ 0030 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A × 0308 ÷ 0030 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A ÷ 005F ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A × 0308 ÷ 005F ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A ÷ 1F1E6 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 0061 × 003A × 05D0 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] COLON (MidLetter) × [7.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 0061 × 003A × 0308 × 05D0 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [7.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A ÷ 0022 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A × 0308 ÷ 0022 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A ÷ 0027 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A × 0308 ÷ 0027 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A ÷ 231A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A × 0308 ÷ 231A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A ÷ 0020 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A × 0308 ÷ 0020 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A × 00AD ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A × 0308 × 00AD ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A × 0300 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A × 0308 × 0300 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A × 200D ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A × 0308 × 200D ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 0061 × 003A × 0061 × 2060 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] COLON (MidLetter) × [7.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 × 003A × 0308 × 0061 × 2060 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [7.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 × 003A × 0061 ÷ 003A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] COLON (MidLetter) × [7.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 003A × 0308 × 0061 ÷ 003A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [7.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 003A × 0061 ÷ 0027 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] COLON (MidLetter) × [7.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 × 003A × 0308 × 0061 ÷ 0027 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [7.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 × 003A × 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] COLON (MidLetter) × [7.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 × 003A × 0308 × 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [7.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 × 003A × 0061 ÷ 002C ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] COLON (MidLetter) × [7.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0061 × 003A × 0308 × 0061 ÷ 002C ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [7.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A × 0308 ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A × 0308 ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A × 0308 ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A × 0308 ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 ÷ 0001 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 0308 ÷ 0001 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 ÷ 000D ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 0308 ÷ 000D ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 ÷ 000A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 0308 ÷ 000A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 ÷ 000B ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 0308 ÷ 000B ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 ÷ 3031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 0308 ÷ 3031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 0061 × 0027 × 0041 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] APOSTROPHE (Single_Quote) × [7.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 0027 × 0308 × 0041 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) × [7.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 ÷ 003A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 0308 ÷ 003A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 ÷ 002C ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 0308 ÷ 002C ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 ÷ 002E ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 0308 ÷ 002E ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 ÷ 0030 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 0308 ÷ 0030 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 ÷ 005F ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 0308 ÷ 005F ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 ÷ 1F1E6 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 0061 × 0027 × 05D0 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] APOSTROPHE (Single_Quote) × [7.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 0061 × 0027 × 0308 × 05D0 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) × [7.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 ÷ 0022 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 0308 ÷ 0022 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 ÷ 0027 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 0308 ÷ 0027 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 ÷ 231A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 0308 ÷ 231A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 ÷ 0020 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 0308 ÷ 0020 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 00AD ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 0308 × 00AD ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 0300 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 0308 × 0300 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 200D ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 0308 × 200D ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 0061 × 0027 × 0061 × 2060 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] APOSTROPHE (Single_Quote) × [7.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 × 0027 × 0308 × 0061 × 2060 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) × [7.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 × 0027 × 0061 ÷ 003A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] APOSTROPHE (Single_Quote) × [7.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 0027 × 0308 × 0061 ÷ 003A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) × [7.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 0027 × 0061 ÷ 0027 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] APOSTROPHE (Single_Quote) × [7.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 × 0027 × 0308 × 0061 ÷ 0027 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) × [7.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 × 0027 × 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] APOSTROPHE (Single_Quote) × [7.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 × 0027 × 0308 × 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) × [7.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 × 0027 × 0061 ÷ 002C ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] APOSTROPHE (Single_Quote) × [7.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0061 × 0027 × 0308 × 0061 ÷ 002C ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) × [7.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 0308 ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 0308 ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 0308 ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 0308 ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 ÷ 0001 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 × 0308 ÷ 0001 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 ÷ 000D ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 × 0308 ÷ 000D ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 ÷ 000A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 × 0308 ÷ 000A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 ÷ 000B ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 × 0308 ÷ 000B ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 ÷ 3031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 × 0308 ÷ 3031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 0061 × 0027 × 2060 × 0041 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [7.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 0027 × 2060 × 0308 × 0041 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [7.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 ÷ 003A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 × 0308 ÷ 003A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 ÷ 002C ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 × 0308 ÷ 002C ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 ÷ 002E ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 × 0308 ÷ 002E ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 ÷ 0030 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 × 0308 ÷ 0030 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 ÷ 005F ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 × 0308 ÷ 005F ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 ÷ 1F1E6 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 0061 × 0027 × 2060 × 05D0 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [7.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 0061 × 0027 × 2060 × 0308 × 05D0 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [7.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 ÷ 0022 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 × 0308 ÷ 0022 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 ÷ 0027 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 × 0308 ÷ 0027 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 ÷ 231A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 × 0308 ÷ 231A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 ÷ 0020 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 × 0308 ÷ 0020 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 × 00AD ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 × 0308 × 00AD ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 × 0300 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 × 0308 × 0300 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 × 200D ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 × 0308 × 200D ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 0061 × 0027 × 2060 × 0061 × 2060 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [7.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 × 0027 × 2060 × 0308 × 0061 × 2060 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [7.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 × 0027 × 2060 × 0061 ÷ 003A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [7.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 0027 × 2060 × 0308 × 0061 ÷ 003A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [7.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 0027 × 2060 × 0061 ÷ 0027 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [7.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 × 0027 × 2060 × 0308 × 0061 ÷ 0027 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [7.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 × 0027 × 2060 × 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [7.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 × 0027 × 2060 × 0308 × 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [7.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 × 0027 × 2060 × 0061 ÷ 002C ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [7.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0061 × 0027 × 2060 × 0308 × 0061 ÷ 002C ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [7.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 × 0308 ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 × 0308 ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 × 0308 ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 × 0308 ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C ÷ 0001 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C × 0308 ÷ 0001 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C ÷ 000D ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C × 0308 ÷ 000D ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C ÷ 000A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C × 0308 ÷ 000A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C ÷ 000B ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C × 0308 ÷ 000B ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C ÷ 3031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C × 0308 ÷ 3031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C ÷ 0041 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C × 0308 ÷ 0041 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C ÷ 003A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C × 0308 ÷ 003A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C ÷ 002C ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C × 0308 ÷ 002C ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C ÷ 002E ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C × 0308 ÷ 002E ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C ÷ 0030 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C × 0308 ÷ 0030 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C ÷ 005F ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C × 0308 ÷ 005F ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C ÷ 1F1E6 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C ÷ 05D0 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C × 0308 ÷ 05D0 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C ÷ 0022 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C × 0308 ÷ 0022 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C ÷ 0027 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C × 0308 ÷ 0027 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C ÷ 231A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C × 0308 ÷ 231A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C ÷ 0020 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C × 0308 ÷ 0020 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C × 00AD ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C × 0308 × 00AD ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C × 0300 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C × 0308 × 0300 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C × 200D ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C × 0308 × 200D ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C ÷ 0061 × 2060 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C × 0308 ÷ 0061 × 2060 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C × 0308 ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C × 0308 ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C × 0308 ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C × 0308 ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C × 0308 ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C × 0308 ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C × 0308 ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C × 0308 ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A ÷ 0001 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A × 0308 ÷ 0001 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A ÷ 000D ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A × 0308 ÷ 000D ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A ÷ 000A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A × 0308 ÷ 000A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A ÷ 000B ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A × 0308 ÷ 000B ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A ÷ 3031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A × 0308 ÷ 3031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A ÷ 0041 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A × 0308 ÷ 0041 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A ÷ 003A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A × 0308 ÷ 003A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A ÷ 002C ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A × 0308 ÷ 002C ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A ÷ 002E ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A × 0308 ÷ 002E ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A ÷ 0030 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A × 0308 ÷ 0030 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A ÷ 005F ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A × 0308 ÷ 005F ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A ÷ 1F1E6 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A ÷ 05D0 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A × 0308 ÷ 05D0 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A ÷ 0022 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A × 0308 ÷ 0022 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A ÷ 0027 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A × 0308 ÷ 0027 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A ÷ 231A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A × 0308 ÷ 231A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A ÷ 0020 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A × 0308 ÷ 0020 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A × 00AD ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A × 0308 × 00AD ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A × 0300 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A × 0308 × 0300 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A × 200D ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A × 0308 × 200D ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A ÷ 0061 × 2060 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A × 0308 ÷ 0061 × 2060 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A × 0308 ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A × 0308 ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A × 0308 ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A × 0308 ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A × 0308 ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A × 0308 ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A × 0308 ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A × 0308 ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 ÷ 0001 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 × 0308 ÷ 0001 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 ÷ 000D ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 × 0308 ÷ 000D ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 ÷ 000A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 × 0308 ÷ 000A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 ÷ 000B ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 × 0308 ÷ 000B ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 ÷ 3031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 × 0308 ÷ 3031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 ÷ 0041 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 × 0308 ÷ 0041 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 ÷ 003A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 × 0308 ÷ 003A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 ÷ 002C ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 × 0308 ÷ 002C ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 ÷ 002E ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 × 0308 ÷ 002E ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 0031 × 0027 × 0030 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [12.0] APOSTROPHE (Single_Quote) × [11.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 × 0027 × 0308 × 0030 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [12.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) × [11.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 ÷ 005F ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 × 0308 ÷ 005F ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 ÷ 1F1E6 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 ÷ 05D0 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 × 0308 ÷ 05D0 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 ÷ 0022 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 × 0308 ÷ 0022 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 ÷ 0027 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 × 0308 ÷ 0027 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 ÷ 231A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 × 0308 ÷ 231A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 ÷ 0020 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 × 0308 ÷ 0020 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 × 00AD ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 × 0308 × 00AD ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 × 0300 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 × 0308 × 0300 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 × 200D ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 × 0308 × 200D ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 ÷ 0061 × 2060 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 × 0308 ÷ 0061 × 2060 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 × 0308 ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 × 0308 ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 × 0308 ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 × 0308 ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0031 × 0027 × 0031 ÷ 003A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [12.0] APOSTROPHE (Single_Quote) × [11.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0031 × 0027 × 0308 × 0031 ÷ 003A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [12.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) × [11.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0031 × 0027 × 0031 ÷ 0027 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [12.0] APOSTROPHE (Single_Quote) × [11.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0031 × 0027 × 0308 × 0031 ÷ 0027 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [12.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) × [11.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0031 × 0027 × 0031 ÷ 002C ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [12.0] APOSTROPHE (Single_Quote) × [11.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0031 × 0027 × 0308 × 0031 ÷ 002C ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [12.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) × [11.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0031 × 0027 × 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [12.0] APOSTROPHE (Single_Quote) × [11.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0031 × 0027 × 0308 × 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [12.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) × [11.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C ÷ 0001 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C × 0308 ÷ 0001 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C ÷ 000D ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C × 0308 ÷ 000D ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C ÷ 000A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C × 0308 ÷ 000A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C ÷ 000B ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C × 0308 ÷ 000B ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C ÷ 3031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C × 0308 ÷ 3031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C ÷ 0041 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C × 0308 ÷ 0041 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C ÷ 003A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C × 0308 ÷ 003A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C ÷ 002C ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C × 0308 ÷ 002C ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C ÷ 002E ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C × 0308 ÷ 002E ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 0031 × 002C × 0030 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [12.0] COMMA (MidNum) × [11.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 × 002C × 0308 × 0030 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [12.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) × [11.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C ÷ 005F ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C × 0308 ÷ 005F ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C ÷ 1F1E6 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C ÷ 05D0 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C × 0308 ÷ 05D0 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C ÷ 0022 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C × 0308 ÷ 0022 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C ÷ 0027 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C × 0308 ÷ 0027 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C ÷ 231A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C × 0308 ÷ 231A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C ÷ 0020 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C × 0308 ÷ 0020 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C × 00AD ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C × 0308 × 00AD ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C × 0300 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C × 0308 × 0300 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C × 200D ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C × 0308 × 200D ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C ÷ 0061 × 2060 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C × 0308 ÷ 0061 × 2060 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C × 0308 ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C × 0308 ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C × 0308 ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C × 0308 ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0031 × 002C × 0031 ÷ 003A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [12.0] COMMA (MidNum) × [11.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0031 × 002C × 0308 × 0031 ÷ 003A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [12.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) × [11.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0031 × 002C × 0031 ÷ 0027 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [12.0] COMMA (MidNum) × [11.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0031 × 002C × 0308 × 0031 ÷ 0027 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [12.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) × [11.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0031 × 002C × 0031 ÷ 002C ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [12.0] COMMA (MidNum) × [11.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0031 × 002C × 0308 × 0031 ÷ 002C ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [12.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) × [11.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0031 × 002C × 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [12.0] COMMA (MidNum) × [11.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0031 × 002C × 0308 × 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [12.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) × [11.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 ÷ 0001 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 × 0308 ÷ 0001 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 ÷ 000D ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 × 0308 ÷ 000D ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 ÷ 000A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 × 0308 ÷ 000A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 ÷ 000B ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 × 0308 ÷ 000B ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 ÷ 3031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 × 0308 ÷ 3031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 ÷ 0041 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 × 0308 ÷ 0041 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 ÷ 003A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 × 0308 ÷ 003A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 ÷ 002C ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 × 0308 ÷ 002C ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 ÷ 002E ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 × 0308 ÷ 002E ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 0031 × 002E × 2060 × 0030 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [12.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [11.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 × 002E × 2060 × 0308 × 0030 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [12.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [11.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 ÷ 005F ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 × 0308 ÷ 005F ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 ÷ 1F1E6 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 ÷ 05D0 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 × 0308 ÷ 05D0 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 ÷ 0022 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 × 0308 ÷ 0022 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 ÷ 0027 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 × 0308 ÷ 0027 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 ÷ 231A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 × 0308 ÷ 231A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 ÷ 0020 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 × 0308 ÷ 0020 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 × 00AD ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 × 0308 × 00AD ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 × 0300 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 × 0308 × 0300 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 × 200D ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 × 0308 × 200D ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 ÷ 0061 × 2060 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 × 0308 ÷ 0061 × 2060 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 × 0308 ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 × 0308 ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 × 0308 ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 × 0308 ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0031 × 002E × 2060 × 0031 ÷ 003A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [12.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [11.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0031 × 002E × 2060 × 0308 × 0031 ÷ 003A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [12.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [11.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0031 × 002E × 2060 × 0031 ÷ 0027 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [12.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [11.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0031 × 002E × 2060 × 0308 × 0031 ÷ 0027 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [12.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [11.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0031 × 002E × 2060 × 0031 ÷ 002C ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [12.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [11.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0031 × 002E × 2060 × 0308 × 0031 ÷ 002C ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [12.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [11.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0031 × 002E × 2060 × 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [12.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [11.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0031 × 002E × 2060 × 0308 × 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [12.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [11.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 000D × 000A ÷ 0061 ÷ 000A ÷ 0308 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) × [3.0] <LINE FEED (LF)> (LF) ÷ [3.1] LATIN SMALL LETTER A (ALetter) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0061 × 0308 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0020 × 200D ÷ 0646 ÷	#  ÷ [0.2] SPACE (WSegSpace) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [999.0] ARABIC LETTER NOON (ALetter) ÷ [0.3]');
    Test_WB('÷ 0646 × 200D ÷ 0020 ÷	#  ÷ [0.2] ARABIC LETTER NOON (ALetter) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 0041 × 0041 × 0041 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [5.0] LATIN CAPITAL LETTER A (ALetter) × [5.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0041 × 003A × 0041 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [6.0] COLON (MidLetter) × [7.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0041 ÷ 003A ÷ 003A ÷ 0041 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0027 ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [7.1] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0022 × 05D0 ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [7.2] QUOTATION MARK (Double_Quote) × [7.3] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 0041 × 0030 × 0030 × 0041 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [9.0] DIGIT ZERO (Numeric) × [8.0] DIGIT ZERO (Numeric) × [10.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0030 × 002C × 0030 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [12.0] COMMA (MidNum) × [11.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 0030 ÷ 002C ÷ 002C ÷ 0030 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] COMMA (MidNum) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 3031 × 3031 ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [13.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 0041 × 005F × 0030 × 005F × 3031 × 005F ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ZERO (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] VERTICAL KANA REPEAT MARK (Katakana) × [13.1] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 0041 × 005F × 005F × 0041 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 1F1E7 ÷ 1F1E8 ÷ 0062 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [15.0] REGIONAL INDICATOR SYMBOL LETTER B (RI) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER C (RI) ÷ [999.0] LATIN SMALL LETTER B (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 1F1E6 × 1F1E7 ÷ 1F1E8 ÷ 0062 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [16.0] REGIONAL INDICATOR SYMBOL LETTER B (RI) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER C (RI) ÷ [999.0] LATIN SMALL LETTER B (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 1F1E6 × 1F1E7 × 200D ÷ 1F1E8 ÷ 0062 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [16.0] REGIONAL INDICATOR SYMBOL LETTER B (RI) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER C (RI) ÷ [999.0] LATIN SMALL LETTER B (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 1F1E6 × 200D × 1F1E7 ÷ 1F1E8 ÷ 0062 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) × [16.0] REGIONAL INDICATOR SYMBOL LETTER B (RI) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER C (RI) ÷ [999.0] LATIN SMALL LETTER B (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 1F1E6 × 1F1E7 ÷ 1F1E8 × 1F1E9 ÷ 0062 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [16.0] REGIONAL INDICATOR SYMBOL LETTER B (RI) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER C (RI) × [16.0] REGIONAL INDICATOR SYMBOL LETTER D (RI) ÷ [999.0] LATIN SMALL LETTER B (ALetter) ÷ [0.3]');
    Test_WB('÷ 1F476 × 1F3FF ÷ 1F476 ÷	#  ÷ [0.2] BABY (ExtPict) × [4.0] EMOJI MODIFIER FITZPATRICK TYPE-6 (Extend_FE) ÷ [999.0] BABY (ExtPict) ÷ [0.3]');
    Test_WB('÷ 1F6D1 × 200D × 1F6D1 ÷	#  ÷ [0.2] OCTAGONAL SIGN (ExtPict) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) × [3.3] OCTAGONAL SIGN (ExtPict) ÷ [0.3]');
    Test_WB('÷ 0061 × 200D × 1F6D1 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) × [3.3] OCTAGONAL SIGN (ExtPict) ÷ [0.3]');
    Test_WB('÷ 2701 × 200D × 2701 ÷	#  ÷ [0.2] UPPER BLADE SCISSORS (Other) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) × [3.3] UPPER BLADE SCISSORS (Other) ÷ [0.3]');
    Test_WB('÷ 0061 × 200D × 2701 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) × [3.3] UPPER BLADE SCISSORS (Other) ÷ [0.3]');
    Test_WB('÷ 1F476 × 1F3FF × 0308 × 200D × 1F476 × 1F3FF ÷	#  ÷ [0.2] BABY (ExtPict) × [4.0] EMOJI MODIFIER FITZPATRICK TYPE-6 (Extend_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) × [3.3] BABY (ExtPict) × [4.0] EMOJI MODIFIER FITZPATRICK TYPE-6 (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 1F6D1 × 1F3FF ÷	#  ÷ [0.2] OCTAGONAL SIGN (ExtPict) × [4.0] EMOJI MODIFIER FITZPATRICK TYPE-6 (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 200D × 1F6D1 × 1F3FF ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [3.3] OCTAGONAL SIGN (ExtPict) × [4.0] EMOJI MODIFIER FITZPATRICK TYPE-6 (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 200D × 1F6D1 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [3.3] OCTAGONAL SIGN (ExtPict) ÷ [0.3]');
    Test_WB('÷ 200D × 1F6D1 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [3.3] OCTAGONAL SIGN (ExtPict) ÷ [0.3]');
    Test_WB('÷ 1F6D1 ÷ 1F6D1 ÷	#  ÷ [0.2] OCTAGONAL SIGN (ExtPict) ÷ [999.0] OCTAGONAL SIGN (ExtPict) ÷ [0.3]');
    Test_WB('÷ 0061 × 0308 × 200D × 0308 × 0062 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [5.0] LATIN SMALL LETTER B (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0020 × 0020 ÷ 0062 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] SPACE (WSegSpace) × [3.4] SPACE (WSegSpace) ÷ [999.0] LATIN SMALL LETTER B (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A ÷ 003A ÷ 0031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0031 ÷ 003A ÷ 003A ÷ 0031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0061 ÷ 003A ÷ 003A ÷ 0031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A ÷ 003A ÷ 0061 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0031 ÷ 003A ÷ 003A ÷ 0061 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0061 ÷ 003A ÷ 003A ÷ 0061 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A ÷ 002E ÷ 0031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0031 ÷ 003A ÷ 002E ÷ 0031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0061 ÷ 003A ÷ 002E ÷ 0031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A ÷ 002E ÷ 0061 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0031 ÷ 003A ÷ 002E ÷ 0061 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0061 ÷ 003A ÷ 002E ÷ 0061 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A ÷ 002C ÷ 0031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0031 ÷ 003A ÷ 002C ÷ 0031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0061 ÷ 003A ÷ 002C ÷ 0031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A ÷ 002C ÷ 0061 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0031 ÷ 003A ÷ 002C ÷ 0061 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0061 ÷ 003A ÷ 002C ÷ 0061 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E ÷ 003A ÷ 0031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] COLON (MidLetter) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0031 ÷ 002E ÷ 003A ÷ 0031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] COLON (MidLetter) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0061 ÷ 002E ÷ 003A ÷ 0031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] COLON (MidLetter) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E ÷ 003A ÷ 0061 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] COLON (MidLetter) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0031 ÷ 002E ÷ 003A ÷ 0061 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] COLON (MidLetter) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0061 ÷ 002E ÷ 003A ÷ 0061 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] COLON (MidLetter) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E ÷ 002E ÷ 0031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0031 ÷ 002E ÷ 002E ÷ 0031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0061 ÷ 002E ÷ 002E ÷ 0031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E ÷ 002E ÷ 0061 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0031 ÷ 002E ÷ 002E ÷ 0061 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0061 ÷ 002E ÷ 002E ÷ 0061 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E ÷ 002C ÷ 0031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] COMMA (MidNum) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0031 ÷ 002E ÷ 002C ÷ 0031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] COMMA (MidNum) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0061 ÷ 002E ÷ 002C ÷ 0031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] COMMA (MidNum) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E ÷ 002C ÷ 0061 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] COMMA (MidNum) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0031 ÷ 002E ÷ 002C ÷ 0061 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] COMMA (MidNum) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0061 ÷ 002E ÷ 002C ÷ 0061 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] COMMA (MidNum) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C ÷ 003A ÷ 0031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] COLON (MidLetter) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0031 ÷ 002C ÷ 003A ÷ 0031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] COLON (MidLetter) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0061 ÷ 002C ÷ 003A ÷ 0031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] COLON (MidLetter) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C ÷ 003A ÷ 0061 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] COLON (MidLetter) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0031 ÷ 002C ÷ 003A ÷ 0061 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] COLON (MidLetter) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0061 ÷ 002C ÷ 003A ÷ 0061 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] COLON (MidLetter) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C ÷ 002E ÷ 0031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0031 ÷ 002C ÷ 002E ÷ 0031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0061 ÷ 002C ÷ 002E ÷ 0031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C ÷ 002E ÷ 0061 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0031 ÷ 002C ÷ 002E ÷ 0061 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0061 ÷ 002C ÷ 002E ÷ 0061 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C ÷ 002C ÷ 0031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] COMMA (MidNum) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0031 ÷ 002C ÷ 002C ÷ 0031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] COMMA (MidNum) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0061 ÷ 002C ÷ 002C ÷ 0031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] COMMA (MidNum) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C ÷ 002C ÷ 0061 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] COMMA (MidNum) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0031 ÷ 002C ÷ 002C ÷ 0061 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] COMMA (MidNum) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0061 ÷ 002C ÷ 002C ÷ 0061 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] COMMA (MidNum) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A ÷ 003A ÷ 0031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0031 ÷ 003A ÷ 003A ÷ 0031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0061 ÷ 003A ÷ 003A ÷ 0031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A ÷ 003A ÷ 0061 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0031 ÷ 003A ÷ 003A ÷ 0061 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0061 ÷ 003A ÷ 003A ÷ 0061 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A ÷ 002E ÷ 0031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0031 ÷ 003A ÷ 002E ÷ 0031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0061 ÷ 003A ÷ 002E ÷ 0031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A ÷ 002E ÷ 0061 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0031 ÷ 003A ÷ 002E ÷ 0061 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0061 ÷ 003A ÷ 002E ÷ 0061 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A ÷ 002C ÷ 0031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0031 ÷ 003A ÷ 002C ÷ 0031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0061 ÷ 003A ÷ 002C ÷ 0031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A ÷ 002C ÷ 0061 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0031 ÷ 003A ÷ 002C ÷ 0061 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0061 ÷ 003A ÷ 002C ÷ 0061 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002E ÷ 003A ÷ 0031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] COLON (MidLetter) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0031 ÷ 002E ÷ 003A ÷ 0031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] COLON (MidLetter) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0061 ÷ 002E ÷ 003A ÷ 0031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] COLON (MidLetter) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002E ÷ 003A ÷ 0061 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] COLON (MidLetter) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0031 ÷ 002E ÷ 003A ÷ 0061 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] COLON (MidLetter) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0061 ÷ 002E ÷ 003A ÷ 0061 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] COLON (MidLetter) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002E ÷ 002E ÷ 0031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0031 ÷ 002E ÷ 002E ÷ 0031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0061 ÷ 002E ÷ 002E ÷ 0031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002E ÷ 002E ÷ 0061 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0031 ÷ 002E ÷ 002E ÷ 0061 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0061 ÷ 002E ÷ 002E ÷ 0061 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002E ÷ 002C ÷ 0031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] COMMA (MidNum) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0031 ÷ 002E ÷ 002C ÷ 0031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] COMMA (MidNum) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0061 ÷ 002E ÷ 002C ÷ 0031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] COMMA (MidNum) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002E ÷ 002C ÷ 0061 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] COMMA (MidNum) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0031 ÷ 002E ÷ 002C ÷ 0061 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] COMMA (MidNum) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0061 ÷ 002E ÷ 002C ÷ 0061 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] COMMA (MidNum) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C ÷ 003A ÷ 0031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] COLON (MidLetter) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0031 ÷ 002C ÷ 003A ÷ 0031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] COLON (MidLetter) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0061 ÷ 002C ÷ 003A ÷ 0031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] COLON (MidLetter) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C ÷ 003A ÷ 0061 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] COLON (MidLetter) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0031 ÷ 002C ÷ 003A ÷ 0061 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] COLON (MidLetter) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0061 ÷ 002C ÷ 003A ÷ 0061 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] COLON (MidLetter) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C ÷ 002E ÷ 0031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0031 ÷ 002C ÷ 002E ÷ 0031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0061 ÷ 002C ÷ 002E ÷ 0031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C ÷ 002E ÷ 0061 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0031 ÷ 002C ÷ 002E ÷ 0061 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0061 ÷ 002C ÷ 002E ÷ 0061 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C ÷ 002C ÷ 0031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] COMMA (MidNum) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0031 ÷ 002C ÷ 002C ÷ 0031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] COMMA (MidNum) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0061 ÷ 002C ÷ 002C ÷ 0031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] COMMA (MidNum) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C ÷ 002C ÷ 0061 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] COMMA (MidNum) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0031 ÷ 002C ÷ 002C ÷ 0061 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] COMMA (MidNum) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0061 ÷ 002C ÷ 002C ÷ 0061 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] COMMA (MidNum) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
}
Finished();
